(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M8, N9, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 256; useSolids; showRuler; automaticGrouping; currentKernel; 
]
:[font = section; inactive; initialization; preserveAspect; startGroup]
Implementation
:[font = input; initialization; preserveAspect]
*)
NStd = 4; (* Voreinstellung in CEV-Formel*)
(*
:[font = input; initialization; preserveAspect; startGroup]
*)
<<Hermann`LSD`
(*<<Miscellaneous`Calendar`*)
<<Hermann`BlackScholes`
(*
:[font = message; inactive; preserveAspect]
SetDelayed::write: Tag DayOfWeek in Options[DayOfWeek] is Protected.
:[font = message; inactive; preserveAspect]
SetDelayed::write: Tag DaysBetween in Options[DaysBetween] is Protected.
:[font = message; inactive; preserveAspect]
SetDelayed::write: 
  Tag DayOfWeek in DayOfWeek[date_List, opts___] is Protected.
:[font = message; inactive; preserveAspect; endGroup]
General::stop: Further output of SetDelayed::write
   will be suppressed during this calculation.
:[font = input; initialization; preserveAspect; endGroup]
*)
fCEV//Clear
fCEV[S_,t_,{mue_,sigma_,alpha_}] := mue S
								          
gCEV//Clear
gCEV[S_,t_,{mue_,sigma_,alpha_}] := {sigma S^(alpha/2)}//Transpose
(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
Beckers (1980)
:[font = input; initialization; preserveAspect]
*)


BeckersTransform//Clear
BeckersTransform[a_,b_,vara_,varb_,sd_,sdu_]:=
Module[{sigmaqdach,sigmaqkorr1,sigmaqkorr2,
			 sigmadach,sigmakorr1,sigmakorr2,alphadach},
alphadach   = 2b+2;
sigmaqdach  = Exp[2a]/dt;
sigmaqkorr1 = sigmaqdach/(1+ 2 vara);
sigmaqkorr2 = sigmaqdach/Exp[2 vara];
sigmadach   = Sqrt[sigmaqdach];
sigmakorr1  = sigmadach/(1+vara/2);
sigmakorr2  = sigmadach/Exp[vara/2];

{sigmaqdach,sigmaqkorr1,sigmaqkorr2,
 	sigmadach,sigmakorr1,sigmakorr2,alphadach,a,b,vara,varb,sd,sdu}
]

			  
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
Beckers//Clear;
Beckers[S_,dt_] :=

Module[{s,x,y,fitted,a,b,sa,sb,VarB,sd,sdu,sigmaqdach,sigmaqkorr1,
		sigmaqkorr2,sigmadach,sigmakorr1,sigmakorr2,alphadach,
		vara,varb,estimates},
		
s = Log[S//Flatten];
x = Drop[s,-1];
y = Log[Abs[Delta[s,1] ]];
{{a,b},{sa,sb},VarB,sd,sdu} = EinfachRegression[y,x];
{vara,varb} = VecDiag[VarB];
fitted = a +  b xx;

estimates = BeckersTransform[a,b,vara,varb,sd,sdu];
			  
Print[MatrixForm[{estimates}//Transpose,
	  TableHeadings->{{"sigmaqdach","sigmaqkorr1","sigmaqkorr2",
				     "sigmadach","sigmakorr1","sigmakorr2","alphadach",
				     "a","b","vara","varb","sd","sdu"},None}]
];

{estimates,x,y,fitted}
]

(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
dS^2  sigma^2 S^alpha dt 
:[font = input; initialization; preserveAspect]
*)
DS2Transform//Clear
DS2Transform[a_,b_,vara_,varb_,sd_,sdu_]:=
Module[{sigmaqdach,sigmaqkorr1,sigmaqkorr2,
			 sigmadach,sigmakorr1,sigmakorr2,alphadach},
alphadach = b;
sigmaqdach = Exp[1.27036284546147817 + a]/dt;
sigmaqkorr1 = sigmaqdach/(1+vara/2);
sigmaqkorr2 = sigmaqdach/Exp[vara/2];
sigmadach   = Sqrt[sigmaqdach];
sigmakorr1  = sigmadach/(1+vara/8);
sigmakorr2  = sigmadach/Exp[vara/8];

{sigmaqdach,sigmaqkorr1,sigmaqkorr2,
 	sigmadach,sigmakorr1,sigmakorr2,alphadach,a,b,vara,varb,sd,sdu}
]

(*
:[font = input; initialization; preserveAspect; endGroup]
*)
DS2//Clear
DS2[S_,dt_] := 
Module[{s,x,y,fitted,a,b,sa,sb,VarB,sd,sdu,sigmaqdach,sigmaqkorr1,
		sigmaqkorr2,sigmadach,sigmakorr1,sigmakorr2,alphadach,
		vara,varb,estimates},
s = Log[S//Flatten];
x = Drop[s,-1];
y = Log[ Delta[S//Flatten,1]^2 ]; (*log ds^2*)
{{a,b},{sa,sb},VarB,sd,sdu} = EinfachRegression[y,x];
fitted = a + b xx;
{vara,varb} = VecDiag[VarB];
estimates = DS2Transform[a,b,vara,varb,sd,sdu];	
		  
Print[MatrixForm[{estimates}//Transpose,
	  TableHeadings->{{"sigmaqdach","sigmaqkorr1","sigmaqkorr2",
				     "sigmadach","sigmakorr1","sigmakorr2","alphadach",
				     "a","b","vara","varb","sd","sdu"},None}]
];

{estimates,x,y,fitted}
]
(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; rightWrapOffset = 418; startGroup]
 (dS-rdach)^2  sigma^2 S^alpha dt 
:[font = input; initialization; preserveAspect; rightWrapOffset = 418]
*)
DS2modTransform//Clear
DS2modTransform[a_,b_,vara_,varb_,sd_,sdu_]:=
Module[{sigmaqdach,sigmaqkorr1,sigmaqkorr2,
			 sigmadach,sigmakorr1,sigmakorr2,alphadach},
alphadach = b;
sigmaqdach = Exp[1.27036284546147817 + a]/dt;
sigmaqkorr1 = sigmaqdach/(1+vara/2);
sigmaqkorr2 = sigmaqdach/Exp[vara/2];
sigmadach   = Sqrt[sigmaqdach];
sigmakorr1  = sigmadach/(1+vara/8);
sigmakorr2  = sigmadach/Exp[vara/8];

{sigmaqdach,sigmaqkorr1,sigmaqkorr2,
 	sigmadach,sigmakorr1,sigmakorr2,alphadach,a,b,vara,varb,sd,sdu}
]
(*
:[font = input; initialization; preserveAspect; rightWrapOffset = 418; endGroup]
*)
DS2mod//Clear
DS2mod[S_,dt_] := 
Module[{s,ds,x,y,fitted,a,b,sa,sb,VarB,sd,sdu,sigmaqdach,sigmaqkorr1,
		sigmaqkorr2,sigmadach,sigmakorr1,sigmakorr2,alphadach,
		vara,varb,estimates,r,rm,rdach,text},
s = S//Flatten;
ds = Delta[s];
s = Drop[s,-1];
r = ds/s;
rm = mean[r];
rdach = rm/dt;
y = Log[(ds - rm s)^2];
x = Log[s];
{{a,b},{sa,sb},VarB,sd,sdu} = EinfachRegression[y,x];
fitted = a + b xx;

{vara,varb} = VecDiag[VarB];

estimates = DS2modTransform[a,b,vara,varb,sd,sdu];
estimates = Join[{rdach},estimates];	
text = {"rdach","sigmaqdach","sigmaqkorr1","sigmaqkorr2",
			"sigmadach","sigmakorr1","sigmakorr2","alphadach",
				 "a","b","vara","varb","sd","sdu"};				 	
Print[MatrixForm[{text,estimates}//Transpose,
	  TableHeadings->{Automatic,None}]];
	  
{estimates,x,y,fitted}]
(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
Together
:[font = input; initialization; preserveAspect]
*)
OLSTogether[S_,dt_] := 
Module[{Sf,s,ds,ds2,ds2mod,beck,r,rdach,rm,x,y,
		fitted,a,b,alphadach,sigmaqdach},

Sf = S//Flatten;
s = Log[Sf];
x = Drop[s,-1];
y = Log[Abs[Delta[s,1] ]];
fitted = Fit[{x,y}//Transpose,{1,xx},xx];
b = Coefficient[fitted,xx];
a = fitted[[1]];
alphadach = 2b+2;
sigmaqdach = Exp[2a]/dt;
Print["Beckers: {sigmaqdach,alphadach} = ",{sigmaqdach,alphadach}];
beck = {sigmaqdach,alphadach};

ds = Delta[Sf,1];
y = Log[ ds^2 ]; (*log ds^2*)
fitted = Fit[{x,y}//Transpose,{1,xx},xx];
b = Coefficient[fitted,xx];
a = fitted[[1]];
alphadach = b;
sigmaqdach = Exp[1.27036] Exp[a]/dt;
Print["ds2:     {sigmaqdach,alphadach} = ",{sigmaqdach,alphadach}];
ds2 = {sigmaqdach,alphadach};

s = Drop[Sf,-1];
r = ds/s;
rm = mean[r];
rdach = rm/dt;
y = Log[(ds - rm s)^2];
fitted = Fit[{x,y}//Transpose,{1,xx},xx];
b = Coefficient[fitted,xx];
a = fitted[[1]];
alphadach = b;
sigmaqdach = Exp[1.27036] Exp[a]/dt;
Print["ds2mod:  {rdach,sigmaqdach,alphadach} = ",{rdach,sigmaqdach,alphadach}];
ds2mod = {rdach,sigmaqdach,alphadach};

{beck,ds2,ds2mod} 
 ]
 
 
(*
:[font = input; initialization; preserveAspect]
*)
OLSout[S_,dt_] := 
Module[{Sf,s,ds,ds2,ds2mod,beck,r,rdach,rm,x,y,
		fitted,a,b,alphadach,sigmaqdach,sa,sb,VarB,sd,sdu},

Sf = S//Flatten;
s = Log[Sf];
x = Drop[s,-1];
y = Log[Abs[Delta[s,1] ]];
{{a,b},{sa,sb},VarB,sd,sdu} = EinfachRegression[y,x];
{vara,varb} = VecDiag[VarB];
Print["Beckers: {a,b,vara,varb,sdu} = ",{a,b,vara,varb,sdu}];
beck = {a,b,vara,varb,sdu};

ds = Delta[Sf,1];
y = Log[ ds^2 ]; (*log ds^2*)
{{a,b},{sa,sb},VarB,sd,sdu} = EinfachRegression[y,x];
{vara,varb} = VecDiag[VarB];
Print["ds2:     {a,b,vara,varb,sdu} = ",{a,b,vara,varb,sdu}];
ds2 = {a,b,vara,varb,sdu};

s = Drop[Sf,-1];
r = ds/s;
rm = mean[r];
rdach = rm/dt;
y = Log[(ds - rm s)^2];
{{a,b},{sa,sb},VarB,sd,sdu} = EinfachRegression[y,x];
{vara,varb} = VecDiag[VarB];
Print["ds2mod:  {rdach,a,b,vara,varb,sdu} = ",{rdach,a,b,vara,varb,sdu}];
ds2mod = {rdach,a,b,vara,varb,sdu};

{beck,ds2,ds2mod} 
 ]
 
 
(*
:[font = input; initialization; preserveAspect]
*)
OLSBeckers//Clear
OLSBeckers[beck_,dt_,T_] := 
Module[{S,SML,MEAN,a,b,vara,varb,sd,sdu,estBeck},

{a,b,vara,varb,sdu} = beck//Transpose;
sd = sdu*(T-1)/(T+1);		  
estBeck = BeckersTransform[a,b,vara,varb,sd,sdu]//Transpose;			  
{SML,S,MEAN} = Varianz[estBeck];  (*Beckers*)
STD = VecDiag[SML]//Sqrt;
Print["--------------------------------------------------"];
Print["Beckers"];
PF = PaddedForm[#,{10,4}]&;
{{"sigmaqdach","sigmaqkorr1","sigmaqkorr2",
		"sigmadach","sigmakorr1","sigmakorr2","alphadach",
				"a","b","vara","varb","sd","sdu"},
  		MEAN,STD }//Transpose//MatrixForm//PF//Print;
			
estBeck
 ]
(*
:[font = input; initialization; preserveAspect]
*)
OLSds2//Clear
OLSds2[ds2_,dt_,T_] := 
Module[{S,SML,MEAN,a,b,vara,varb,sd,sdu,estds2},

{a,b,vara,varb,sdu} = ds2//Transpose;
sd = sdu*(T-1)/(T+1);

estds2      = DS2Transform[a,b,vara,varb,sd,sdu]//Transpose;
			   
{SML,S,MEAN} = Varianz[estds2];  (*ds2*)
STD = VecDiag[SML]//Sqrt;
Print["--------------------------------------------------"];
Print["ds2"];
PF = PaddedForm[#,{10,4}]&;
{{"sigmaqdach","sigmaqkorr1","sigmaqkorr2",
  	"sigmadach","sigmakorr1","sigmakorr2","alphadach",
  		"a","b","vara","varb","sd","sdu"},
  		MEAN,STD }//Transpose//MatrixForm//PF//Print;
  						   
estds2
 ]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
OLSds2mod//Clear
OLSds2mod[ds2mod_,dt_,T_] := 
Module[{S,SML,MEAN,a,b,vara,varb,sd,sdu,estds2mod},


{rdach,a,b,vara,varb,sdu} = ds2mod//Transpose;
sd = sdu*(T-1)/(T+1);
estds2mod = DS2modTransform[a,b,vara,varb,sd,sdu];
estds2mod = Join[{rdach},estds2mod]//Transpose;					   
{SML,S,MEAN} = Varianz[estds2mod];  (*ds2mod*)
STD = VecDiag[SML]//Sqrt;
Print["--------------------------------------------------"];
Print["ds2mod"];
PF = PaddedForm[#,{10,4}]&;
{{"rdach","sigmaqdach","sigmaqkorr1","sigmaqkorr2",
  	"sigmadach","sigmakorr1","sigmakorr2","alphadach",
  		"a","b","vara","varb","sd","sdu"},
  		MEAN,STD }//Transpose//MatrixForm//PF//Print;
  						   
estds2mod
 ]
(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
ds2modsequentiell
:[font = input; initialization; preserveAspect; rightWrapOffset = 418]
*)
DS2modSequentiellii//Clear
DS2modSequentiellii[S_,dt_] := 
Module[{s,ds,x,y,adach,bdach,varaml,varbml,MQRml,MQRu,
		sigmaqdach,sigmaqkorr1,
		sigmaqkorr2,sigmadach,sigmakorr1,sigmakorr2,alphadach,
		vara,varb,estimates,r,rm,rdach,text},
s = S//Flatten;
ds = Delta[s];
s = Drop[s,-1];
r = ds/s;
rm = CuMean[r,Plus];
rdach = rm/dt //Rest;
y = Log[(ds - rm s)^2]//Rest;
x = Log[s]//Rest;

{{adach,bdach},{varaml,varbml},{MQRml,MQRu}} = 
					EinfachRegressionSequentiell[y,x];

Clear[x,y];
estimates = 
	DS2modTransform[adach,bdach,varaml,varbml,MQRml,MQRu]//Transpose;	
estimates = (rdach//Spalte) ~ii~ estimates;
text = {"rdach","sigmaqdach","sigmaqkorr1","sigmaqkorr2",
			"sigmadach","sigmakorr1","sigmakorr2","alphadach",
				 "a","b","vara","varb","sd","sdu"};	
Print[MatrixForm[{text,estimates//Last}//Transpose,
	  TableHeadings->{Automatic,None}]];
	  
estimates]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)

DS2modSequentielliT//Clear
DS2modSequentielliT[S_,dt_] := 
Module[{s,ds,x,y,adach,bdach,varaml,varbml,MQRml,MQRu,
		sigmaqdach,sigmaqkorr1,
		sigmaqkorr2,sigmadach,sigmakorr1,sigmakorr2,alphadach,
		vara,varb,estimates,rm,rdach,text},
s = S//Flatten;
ds = Delta[s];
s = Drop[s,-1];
rm = ds/s;
rm = CuMean[rm,Plus];
rdach = rm/dt;
rm = rm//Last;
y = Log[(ds - rm s)^2];
x = Log[s];
Clear[s,ds,rm];

{{adach,bdach},{varaml,varbml},{MQRml,MQRu}} = 
					EinfachRegressionSequentiell[y,x];


estimates = 
	DS2modTransform[adach,bdach,varaml,varbml,MQRml,MQRu]//Transpose;

estimates = (rdach//Spalte) ~ii~estimates;
text = {"rdach","sigmaqdach","sigmaqkorr1","sigmaqkorr2",
			"sigmadach","sigmakorr1","sigmakorr2","alphadach",
				 "a","b","vara","varb","sd","sdu"};	
Print[MatrixForm[{text,estimates//Last}//Transpose,
	  TableHeadings->{Automatic,None}]];
	  
estimates]
(*
:[font = section; inactive; initialization; preserveAspect; startGroup]
ML
:[font = input; initialization; preserveAspect; endGroup]
*)
likCEV//Clear
likCEV[{mue_, sigma_,alpha_},{T_,DT_},{A_,DS_,S1_}]:=
	Module[{lik,sigma2},
		sigma2 = sigma^2;
	    - 0.5 T Log[sigma2 DT] 
		- A*(alpha/2)  
		- Apply[Plus,(DS - mue S1 DT)^2 / ( S1^alpha)] /(2 sigma2 DT)	
	   ]
	   
likCEV//Clear
likCEV[{mue_, sigma_,alpha_},{T_,DT_},{A_,DS_,S1_}]:=
	Module[{lik,sigma2},
		sigma2 = sigma^2;
	    - 0.5 T Log[sigma2 DT] 
		- A*(alpha/2)  
		- Dot[(DS - mue S1 DT)^2, S1^(-alpha)] /(2 sigma2 DT)	
	   ]
	   	   
likCEVp//Clear
likCEVp[{mue_, sigma_,alpha_},{T_,DT_},{A_,DS_,S1_}]:=
	Module[{lik,sigma2},
		sigma2 = sigma^2;
		lik = - 0.5 T Log[sigma2 DT] 
		- A*(alpha/2)  
		- Apply[Plus,(DS - mue S1 DT)^2 / ( S1^alpha)] /(2 sigma2 DT);
		Print[lik,"   ",{mue,sigma,alpha}];
		lik
	   ]
	   
Momente//Clear
Momente[S_]:= 
	Module[{DS,A,S1},
		DS = Delta[S];
		S1 = Drop[S,-1];
		A = Apply[Plus,Log[Abs[S1]]];
		{A,DS,S1}];
		
LogGaussKernel//Clear
LogGaussKernel[y_,mue_,sigma2_]:= 
	-.5*( Log[sigma2] + (y-mue)^2/sigma2 );
	
	 
MatPrint[F_]:=
  Print[NumberForm[F//MatrixForm,4,NumberSigns->{"-"," "}]];
  
(***************************************************************)			 
BFGSUP[F_,SNEU_,S_,STEP_] := Module[{ETA,MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)			 
ETA = 10^-4; (*NOISE LEVEL*)
MACHEPS2 = 10.^-8;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < ETA, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
(*Print["*BFGSUP ", A,"  ", B];*)
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]
 
(***************************************************************)			 
BFGSCEV//Clear
BFGSCEV[THETA0_,F0_,KMAX_,EPS_,Z_,
			 T_,DT_,
			 OPTION_,PRINT_] := 
(***************************************************************)			 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,THETA,F,
        S,LIKALT,SNUM,LIKLIK,LIKI,psii,psi,STEPL,STEP,psi1,PSI1,
        LIKNEU,SNEU,likpsi,I,COV,k,LIKELI,m},
        
INC=10.^-5;
MAXSTEP=10.^1;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: BFGSCEV*************************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,T,DT,OPTION,MAXSTEP,MINSTEP,BOUND}//Spalte,
         {"KMAX","EPS","T","DT","OPTION","MAXSTEP","MINSTEP","BOUND"}];
Print[ ""];
Print[ "STARTWERT THETA0  = ", THETA0];
];

Clear[rr, ss, aa, m,score,H];
m = Momente[Z//Flatten//N];
Print["Score"];
score[{rr_, ss_, aa_}] = 
	Outer[D,{likCEV[{rr,ss,aa},{T,DT},m]},{rr,ss,aa}]//Flatten;

THETA=THETA0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = {score[THETA0],likCEV[THETA0,{T,DT},m]};

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,

	If[PRINT[[2]] == 1,
	Print["-----------------------------------------------------------------"];
    Print["MBFGSCEV: Iteration = ",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    
 	STEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTLNGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-HALVING*)
   
    THETA1 = THETA + STEP;   (*VOLLER NEWTON-STEP*) 
    LIKNEU = likCEV[THETA1,{T,DT},m];	     				     
   
    stepreduce = 3;
    (*Print["stepreduce = ",stepreduce ];*)
    
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
         
         STEP=STEP/stepreduce;
         THETA1 = THETA + STEP;
         LIKNEU = likCEV[THETA1,{T,DT},m];
		 
    	 If[PRINT[[3]] == 1,
         Print["STEP-HALVING:  ",half,
         	   "  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         	   "  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
         
     ]; (*End DoWhile*)
     
	
    If[PRINT[[4]] == 1,
    Print[""];
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];  
    Print["LIKNEU - LIKALT  ", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    
    If[PRINT[[5]] == 1,
    Print[""]; 
    Print[MatrixForm[{THETA1,THETA,STEP,S}//Transpose,
    	  TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}]];
    ];
    
    If[PRINT[[6]] == 1,
    Print[""];
    MatPrint[F];
    ];
       
    THETA = THETA1;
    
    SNEU = score[THETA];
    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S=SNEU;
    LIKALT = LIKNEU;
    
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ "BFGSCEV:  ENDE DER ITERATION  ",k,"  ",KMAX];
];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,THETA];
likpsi = Spalte[LIKI] ~ii~ psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
			TableHeadings->{Automatic,{"Likelihood","THETA"}}]];
];
					
If[Fisher,
 	Print["Hesse-Matrix"];
	sc = score[{rr,ss,aa}];
	Do[H[i,j][{rr_,ss_,aa_}] = 
				D[sc[[i]],{rr,ss,aa}[[j]]],{i,1,3},{j,i,3}];
	Hesse//Clear;
	Hesse[{rr_,ss_,aa_}] := 
		Module[{out},
		out = Table[H[i,j][{rr,ss,aa}],{i,3},{j,3}];
		Do[out[[i,j]] = out[[j,i]],{i,3},{j,1,i}];
		out];
	F = -Hesse[THETA];
	COV = OUTPUT[THETA,F,.05,S,LIKNEU];
	LKOMP[LIKNEU,Length[THETA],(T+1)];
	
,(* else *)

	COV = Inverse[F]; Print["(* BFGS-Update !! *)"];
	Print[MatrixForm[{THETA,VecDiag[COV]//Sqrt,S}//Transpose,
		TableHeadings->{Automatic,{"Theta","STD(Theta)","Score"}}]];

	
,Print["Fisher not defined"] 
];


{THETA,COV,likpsi,k}

]
(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
ML allgemein
:[font = input; initialization; preserveAspect]
*)
LogGaussKernel//Clear
LogGaussKernel[y_,mue_,sigma2_] := 
	-.5*( Log[sigma2] + (y-mue)^2/sigma2 );
(*
:[font = input; preserveAspect]
(* user: *)
:[font = input; initialization; preserveAspect]
*)
drift//Clear
drift[S_,t_,{mue_,sigma_,alpha_}] := mue S
								          
diffusion//Clear
diffusion[S_,t_,{mue_,sigma_,alpha_}] := sigma S^(alpha/2)

DLogGaussKernel//Clear
DLogGaussKernel[{rr_,ss_,aa_},{s1_,ds_}] =
	Module[{th = {rr,ss,aa}},
	Outer[D,
	
	{LogGaussKernel[ds,
					drift[s1,t,th] dt,
					diffusion[s1,t,th]^2 dt]},
	th]//Flatten]
DDLogGaussKernel//Clear
DDLogGaussKernel[{rr_,ss_,aa_},{s1_,ds_}] = 
Module[{th = {rr,ss,aa}},
	Outer[D,DLogGaussKernel[th,{s1,ds}] ,th]
]
(*
:[font = input; initialization; preserveAspect]
*)
likelihood//Clear;
likelihood[theta_,{S1_,DS_,dt_}] :=
	Apply[Plus,
	LogGaussKernel[DS,
				   drift[S1,t,theta] dt,
	               diffusion[S1,t,theta]^2 dt]  ]
(*
:[font = input; initialization; preserveAspect]
*)
score1//Clear
score1[theta_,{S1_,DS_}] := 
	Apply[Plus,DLogGaussKernel[theta,{S1,DS}]//Transpose]
(*
:[font = input; initialization; preserveAspect]
*)
H1//Clear;
H1[theta_,{S1_,DS_}] := 
	Apply[Plus,Transpose[DDLogGaussKernel[theta,{S1,DS}],{2,3,1}]]
(*
:[font = subsection; inactive; initialization; Cclosed; preserveAspect; startGroup]
Test
:[font = input; inactive; initialization; preserveAspect; startGroup]
{r,sigma,alpha} = {.07,.2,1}
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{0.07, 0.2, 1}
;[o]
{0.07, 0.2, 1}
:[font = input; inactive; initialization; preserveAspect; startGroup]
likelihood[{r,sigma,alpha},{S1,DS,dt}]//Timing
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{1.599999999999999645*Second, 102.4095744503698603}
;[o]
{1.6 Second, 102.41}
:[font = input; inactive; initialization; preserveAspect; startGroup]
likCEV[{r,sigma,alpha},{T,dt},m]//Timing
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{0.8833333333333333038*Second, 102.4095744503698603}
;[o]
{0.883333 Second, 102.41}
:[font = input; inactive; initialization; preserveAspect; startGroup]
score1[{r,sigma,alpha},{S1,DS}]//Timing
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{3.316666666666666874*Second, {16.30192330841025374, 67.00989695398750985, 31.14765802908759884}}
;[o]
{3.31667 Second, {16.3019, 67.0099, 31.1477}}
:[font = input; inactive; initialization; preserveAspect; startGroup]
score[{r,sigma,alpha}]//Timing
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{2.43333333333333357*Second, {16.30192330841025376, 67.00989695398750973, 31.14765802908759884}}
;[o]
{2.43333 Second, {16.3019, 67.0099, 31.1477}}
:[font = input; inactive; initialization; preserveAspect; startGroup]
H1[{r,sigma,alpha},{S1,DS}]//MatrixForm //Timing
:[font = output; output; inactive; initialization; preserveAspect; fontLeading = 0; endGroup]
{8.033333333333333215*Second, MatrixForm[{{-2593.872518086374914, -163.019233084102537, -75.33494117963649927}, 
 {-163.019233084102537, -6005.148454309812646, -2632.393944261335934}, 
 {-75.33494117963649927, -2632.393944261335934, -1222.137033386846099}}]}
;[o]
{8.03333 Second,     1        2        3       }

                 1   -2593.87 -163.019 -75.3349
                 2   -163.019 -6005.15 -2632.39
                 3   -75.3349 -2632.39 -1222.14
:[font = input; inactive; initialization; preserveAspect; startGroup]
H[{r,sigma,alpha}]//MatrixForm//Timing
:[font = output; output; inactive; initialization; preserveAspect; fontLeading = 0; endGroup; endGroup; endGroup]
{6.733333333333333392*Second, MatrixForm[{{-2593.872518086374914, -163.0192330841025376, -75.33494117963649937}, 
 {-163.0192330841025376, -6005.148454309812644, -2632.393944261335934}, 
 {-75.33494117963649937, -2632.393944261335934, -1222.137033386846099}}]}
;[o]
{6.73333 Second,     1        2        3       }

                 1   -2593.87 -163.019 -75.3349
                 2   -163.019 -6005.15 -2632.39
                 3   -75.3349 -2632.39 -1222.14
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
Utilities
:[font = input; initialization; preserveAspect; endGroup]
*)
(***************************************************************)
INTERPOL[XM_,MISS_,ORDER_] := 
(***************************************************************)
	Module[{XMr,Xint,tau3,T1,q,n,data},
		{T1,q,n} = XM//Dimensions;
		XMr = XM//Reverse;
		Xint = Table[
			tau3 = Locate[XMr[[T1//Range,qq,nn]] ~eq~ MISS, False];
			tau3//Print;
			data = {tau3,XMr[[tau3,qq,nn]]}//Transpose;
      		Interpolation[data,InterpolationOrder->ORDER][T1//Range]
       		  ,{qq,q},{nn,n}];
		Transpose[Xint,{2,3,1}]//Reverse
	 ]


EXPANDDATA//Clear
(***************************************************************)
EXPANDDATA[datum_,S_,MISS_] := 
(***************************************************************)
Module[{datum1,S1,start,end,calendardate,realdate},
datum1 = datum//Rationalize;
S1 = S;
start = datum1//First//Reverse; (*amerikanisch*)
end   = datum1//Last//Reverse;
calendardate = start;

For[ i = 0, calendardate != end, i++, 

	calendardate = DaysPlus[start, i];
	realdate=datum1[[i+1]]//Reverse;
	(*Print[calendardate,realdate];*)
	If[calendardate != realdate,
		datum1 = Insert[datum1,calendardate//Reverse,i+1];
		S1 = Insert[S1,MISS,i+1];
	]
];

{datum1,S1}
]

union[x_] := Module[{x1},
	x1 = x//RotateRight;
	x1[[1]] = -999;
	(* {x,x1}//Transpose//Print;*)
	Column[Select[{x,x1}//Transpose,(#[[1]] =!= #[[2]])&],1]
]	
(*
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
GBB
:[font = text; inactive; initialization; preserveAspect; cellOutline; rightWrapOffset = 518; fontColorRed = 65535; fontName = "Courier"]
y   = log S
dS  = m S dt + sigma dW
dy  = (m - sigma^2/2) dt + sigma dW
	  :=  ms dt             + sigma dW
msdach = (y(t) - y(t0)) /(t-t0) 	
mdach  = (y(t) - y(t0)) /(t-t0) + sigma^2/2 
(mit  Wong-Zakai-Korr.)

sigma^2 = (Integrate dy^2) / (t-t0)
sigmaexakt = sigma^2 - dt msdach^2
:[font = input; initialization; preserveAspect]
*)
GBB//Clear
GBB[dt_,mue_,sigma_,T_,S0_] :=
	Module[{whitenoise,wt,y0,yt,st},
	whitenoise = Table[Random[NormalDistribution[0,1]],{T}];
	wt = Sqrt[dt] FoldList[Plus,0,whitenoise];
	y0 = Log[S0//N];
	yt = y0 + (mue - sigma^2/2) dt Range[0,T] + sigma wt;
	st = Exp[yt];
	{yt,st}
	]
	
MLGBB//Clear
MLGBB[S_,dt_]:=
	Module[{T1,y,msdach,sigmaQDKS,sigmaQ,mdach},
	T1 = Length[S];
	y = Log[S];
	msdach = Drop[y-y[[1]],1]/(dt Range[1,T1-1]);
	sigmaQDKS = DiffusionsKoeffizient[y//Spalte,dt]//Flatten;
	sigmaQ = sigmaQDKS - msdach^2 dt;
	mdach = msdach + sigmaQ/2;
	{mdach,msdach,sigmaQ,sigmaQDKS}
	]

(*
:[font = input; initialization; preserveAspect]
*)
MLGBB1//Clear
MLGBB1[S_,dt_]:=
	Module[{T1,y,dy,sigmaQ,sigmaQDKS,sigmaQEuler,
	        mdach,msdach,mdachDKS},
	T1 = Length[S];
	y = Log[S];
	dy = Delta[y];
	msdach = Drop[y-y[[1]],1]/(dt Range[1,T1-1]);
	sigmaQDKS = CuMean[dy^2,Plus]/dt;
	sigmaQ = sigmaQDKS - dt msdach^2;
	mdach = msdach + sigmaQ/2;
    r = Rendite[S,dt,dt];
    mdachDKS = CuMean[r,Plus];
    sigmaQEuler = dt*(CuMean[r^2]- mdachDKS^2);
	{mdach,msdach,mdachDKS,sigmaQ,sigmaQDKS,sigmaQEuler,r}
	]
(*
:[font = input; initialization; preserveAspect]
*)
		
MLGBB2//Clear
MLGBB2[S_,dt_]:=
	Module[{T1,y,msdach,sigmaQ,mdach},
	T1 = Length[S];
	y = Log[S];
	dy = Delta[y];
	Tdt = dt Range[1,T1-1];
	(*msdach = Drop[y-y[[1]],1]/(dt Range[1,T1-1]);*)
	msdach = CuMean[dy,Plus]/dt;
	sigmaQ = CuMean[dy^2,Plus]/dt - dt msdach^2;
	mdach = msdach + sigmaQ/2;
	{mdach,msdach,sigmaQ}
	]
(*
:[font = input; initialization; preserveAspect]
*)
		
MLGBB2multi//Clear
MLGBB2multi[S_,dt_]:=
	Module[{T1,y,msdach,sigmaQ,mdach,s,D1,rho},
	T1 = Length[S];
	y = Log[S];
	dy = Delta[y];
	Tdt = dt Range[1,T1-1];
	(*msdach = Drop[y-y[[1]],1]/(dt Range[1,T1-1]);*)
	msdach = CuMean[dy,Plus]/dt;
	(*
	dydy=Map[Outer[Times,#1,#1]&,dy];
	sigmaQ = CuMean[dydy,Plus]/dt - 
	                (dt Map[Outer[Times,#1,#1]&,msdach]);
	*)
	                
	dydy=Map[Outer[Times,#1,#1]&,dy-msdach dt];
	sigmaQ = CuMean[dydy,Plus]/dt;
	mdach = msdach + Map[VecDiag,sigmaQ]/2;
	s =Map[VecDiag,sigmaQ]^.5;
    D1=Map[DiagonalMatrix,(s+$MachineEpsilon)^-1];
    rho=MapThread[(#1.#2.#1)&,{D1,sigmaQ,D1}];
	{mdach,msdach,sigmaQ,s,rho}
	]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
GBBMulti//Clear
GBBMulti[dt_,mue_,sigma_,Rho_,T_,S0_]:=
	Module[{dw,dv,y0,yt,st,p,G},
	p=mue//Length;
	dw = Sqrt[dt ]Table[Random[NormalDistribution[0,1]],{T},{p}];
	G=Rho//CholeskyDecomposition//Transpose;
	dv=Map[(G.#)&,dw]; 
	y0 = Log[S0//N];
	yt = FoldList[Plus,y0,Map[(mue-sigma^2/2)dt+(sigma*#)&,dv]];
	st = Exp[yt];
	{yt,st}
	]
(*
:[font = section; active; initialization; preserveAspect; startGroup]
*)
Dichten (Feller-CEV)
(*
:[font = input; initialization; preserveAspect]
*)
abc[{mue_,sigmaq_,alpha_}] := 
	Module[{s2,a2,a,b,c}, 
	
	s2 = sigmaq/2;
	a2 = 2-alpha;
	a = s2 a2^2;
	b = a2 mue;
	c = s2 a2 (1-alpha);
	
	{a,b,c}]
	
feller//Clear  (* korrigiert *)
feller[t_,x_,xi_,{a_,b_,c_}] := 
	Module[{u,ebt,x1,x1i},
	ebt = Exp[b t];
	u   = b/(a (ebt-1)); 
	x1  = u x;
	xi1 = u xi ebt;

	u* (x1/xi1)^((c-a)/(2a))* 
		Exp[-x1-xi1 + Log[BesselI[Abs[1-c/a],2Sqrt[x1 xi1] ]]]
	]
(*
:[font = input; initialization; preserveAspect]
*)
CEVDichteExakt[t_,S_,S0_,{mue_,sigmaq_,alpha_}]:=
	Module[{a,b,c,x,xi,a2},
	{a,b,c} = abc[{mue,sigmaq,alpha}];
	(*{a,b,c}//Print;*)
	a2 = 2-alpha;
	x  = S ^a2;
	xi = S0^a2;
	feller[t,x,xi,{a,b,c}] Abs[a2] S^(1-alpha)
]
(*
:[font = input; initialization; preserveAspect]
*)
CEVDichteGauss[dt_,S_,S0_,{mue_,sigmaq_,alpha_}]:=
	PDF[NormalDistribution[
	(1 + mue dt)S0,
	Sqrt[sigmaq dt] S0^(alpha/2)],
	S]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
CEVDichteNowman[dt_,S_,S0_,{mue_,sigmaq_,alpha_}]:=
	Block[{Astern,Ostern},
	
	Astern=Exp[mue dt];
	Ostern=(2 mue)^(-1)(Astern^2-1) sigmaq S0^alpha;
	
	PDF[NormalDistribution[Astern S0,Ostern//Sqrt],S]
	
	]
(*
:[font = section; inactive; initialization; preserveAspect; startGroup]
CEV-Optionsformel
:[font = input; initialization; preserveAspect]
*)
abc1[{mue_,sigmaq_,alpha_}] := 
	Module[{s2,a2,a,b,c}, 
	
	s2 = sigmaq/2;
	a2 = 2-alpha;
	a = s2 a2^2;
	b = a2 mue;
	c = s2 a2 (1-alpha);
	
	{a,b,c,a2}]
(*
:[font = input; initialization; preserveAspect]
*)
Clear[gammadichte,gammadichte1,G,G1];

gammadichte[n_,z_] := z^(n-1)/(E^z*Gamma[n])//N;

gammadichte1[n_,z_]:= Exp[(n-1)Log[z] - z - Log[Gamma[n]] ]//N;

G[n_,z_] := GammaRegularized[n,z]//N;

G1[n_,z_]:= Exp[Log[Gamma[n,z]] - Log[Gamma[n]]]//N
(*
:[font = input; initialization; preserveAspect; startGroup]
*)
g2 = Compile[{n,z},gammadichte1[n,z]//Evaluate ]
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
 CompiledFunction[{_Real, _Real}, {0, 0, 15, 0}, {{1, 17}, {4, 1, 0}, {4, 2, 1}, {13, 2.718281828459045235, 2}, {13, -1., 3}, 
  {36, 3, 1, 4}, {13, -1., 5}, {33, 5, 0, 6}, {48, 1, 7}, {36, 6, 7, 8}, {13, -1., 9}, {24, Function[{n, z}, Gamma[n]], 10}, 
  {48, 10, 11}, {36, 9, 11, 12}, {33, 4, 8, 12, 13}, {44, 2, 13, 14}, {8, 14}}, 
  Function[{n, z}, 2.718281828459045235^(-1.*z + (-1. + n)*Log[z] - 1.*Log[Gamma[n]])]]
;[o]
                                -1. z + (-1. + n) Log[z] - 1. Log[Gamma[n]]
CompiledFunction[{n, z}, 2.71828                                           , -CompiledCode-]
:[font = input; initialization; preserveAspect; startGroup]
*)
G2 = Compile[{n,z},G1[n,z]//Evaluate ]
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
 CompiledFunction[{_Real, _Real}, {0, 0, 11, 0}, {{1, 17}, {4, 1, 0}, {4, 2, 1}, {13, 2.718281828459045235, 2}, {13, -1., 3}, 
  {24, Function[{n, z}, Gamma[n]], 4}, {48, 4, 5}, {36, 3, 5, 6}, {24, Function[{n, z}, Gamma[n, z]], 7}, {48, 7, 8}, 
  {33, 6, 8, 9}, {44, 2, 9, 10}, {8, 10}}, Function[{n, z}, 2.718281828459045235^(-1.*Log[Gamma[n]] + Log[Gamma[n, z]])]]
;[o]
                                -1. Log[Gamma[n]] + Log[Gamma[n, z]]
CompiledFunction[{n, z}, 2.71828                                    , -CompiledCode-]
:[font = input; inactive; initialization; preserveAspect; startGroup]
Table[g2[1000.,3000.],{100}];//Timing
Table[gammadichte1[1000.,3000.],{100}];//Timing
Table[gammadichte [1000.,3000.],{100}];//Timing
:[font = output; output; inactive; initialization; preserveAspect; fontLeading = 0]
{0.6833333333333333481*Second, Null}
;[o]
{0.683333 Second, Null}
:[font = output; output; inactive; initialization; preserveAspect; fontLeading = 0]
{1.449999999999999956*Second, Null}
;[o]
{1.45 Second, Null}
:[font = output; output; inactive; initialization; preserveAspect; fontLeading = 0; endGroup]
{1.150000000000000022*Second, Null}
;[o]
{1.15 Second, Null}
:[font = input; inactive; initialization; preserveAspect; startGroup]
Table[G2[1000.,3000.],{100}];//Timing
Table[G1[1000.,3000.],{100}];//Timing
Table[G [1000.,3000.],{100}];//Timing
:[font = output; output; inactive; initialization; preserveAspect]
{2.283333333333333326*Second, Null}
;[o]
{2.28333 Second, Null}
:[font = output; output; inactive; initialization; preserveAspect]
{2.299999999999999933*Second, Null}
;[o]
{2.3 Second, Null}
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{1.416666666666666741*Second, Null}
;[o]
{1.41667 Second, Null}
:[font = input; initialization; preserveAspect]
*)
CEVOptionsformel1//Clear
CEVOptionsformel1[S_,K_,T_,r_,sigmaq_,alpha_]:=
	Module[{a,b,c,a2,ebt,u,y,uK,a2i,imax,std,i,i1,i2,
			sum1,sum2,g1,g2},
	{a,b,c,a2} = abc1[{r,sigmaq,alpha}]//N; 
	ebt = Exp[b T];
	u   = b/(a (ebt-1));
	y   = u S^a2 ebt;
	uK  = u K^a2; Print["uK  ",uK];
	a2i = 1/a2;
	std = Sqrt[y];
	i1 = y - 4 std //Floor;
	i2 = y + 4 std //Ceiling;
	Print[{i1,i2}];
	
	sum1 = Sum[g1 = gammadichte[i//N,y];
			   g2 = G1[i+a2i//N,uK];(*Print[1,{g1,g2}]*);
			   g1*g2,
		   {i,i1,i2}];
			
	i1 = i1 - a2i //Floor;
	i2 = i2 - a2i //Ceiling;
	Print[{i1,i2}];
	
	sum2 = Sum[g1 = gammadichte[i+a2i//N,y];
			   g2 = G1[i//N,uK];(*Print[2,{g1,g2}]*);
			   g1*g2,
		   {i,i1,i2}];
	Print[sum1];
	Print[sum2];
	S sum1 - K Exp[-r T] sum2
	]
(*
:[font = input; initialization; preserveAspect]
*)
CEVOptionsformel2//Clear  (*schneller!!*)
CEVOptionsformel2[S_,K_,T_,r_,sigmaq_,alpha_]:=
	Module[{a,b,c,a2,ebt,u,y,uK,a2i,imax,std,i,i1,i2,
			sum1,sum2,g1,g2},
	{a,b,c,a2} = abc1[{r,sigmaq,alpha}]//N; 
	ebt = Exp[b T];
	u   = b/(a (ebt-1));
	y   = u S^a2 ebt;
	uK  = u K^a2; Print["uK  ",uK];
	a2i = 1/a2;
	std = Sqrt[y];
	i1 = y - 4 std //Floor;
	i2 = y + 4 std //Ceiling;
	Print[{i1,i2}];
	i = Range[i1,i2]//N;
	sum1 = Apply[Plus,gammadichte[i,y] G1[i+a2i,uK] ];	
	i1 = i1 - a2i //Floor;
	i2 = i2 - a2i //Ceiling;
	Print[{i1,i2}];
	i = Range[i1,i2]//N;
	sum2 = Apply[Plus,gammadichte[i+a2i,y] G1[i,uK] ];
	Print[sum1];
	Print[sum2];
	S sum1 - K Exp[-r T] sum2
	]

CEVOptionsformel//Clear  (*noch schneller!!*)
CEVOptionsformel[S_,K_,T_,r_,sigmaq_,alpha_]:=
	Module[{a,b,c,a2,ebt,u,y,uK,a2i,imax,std,i,i1,i2,sum1,sum2},
	
	If[Abs[alpha-2] < 0.001, 
	   Return[BlackScholes[S,K,sigmaq,T,r]]];
	   
	If[T == 0,Return[max[S-K,0]]];
	
	{a,b,c,a2} = abc1[{r,sigmaq,alpha}]//N; 
	ebt = Exp[b T];
	u   = b/(a (ebt-1));
	y   = u S^a2 ebt;
	uK  = u K^a2;
	(*Print["uK  ",uK];*)
	a2i = Abs[1./a2];
	std = Sqrt[y];
	
	i1 = Max[1.,y - NStd std //Floor]//N;
	i2 = y + NStd std //Ceiling//N;
	Print[{i1,i2,i2-i1}];
	i = Range[i1,i2];
	sum1 = gammadichte1[i,y].G1[i+a2i,uK];
	
	i1 = i1 - a2i //Floor//N;
	i1 = Max[1.,i1];
	i2 = i2 - a2i //Ceiling//N;
	Print[{i1,i2,i2-i1}];
	i = Range[i1,i2];
	sum2 = gammadichte1[i+a2i,y].G1[i,uK];
	
	(*Print[sum1];
	Print[sum2];*)
	out =
	If[alpha <= 2,
	S sum1 - K Exp[-r T] sum2,
	S (1.-sum2) - K Exp[-r T] (1.-sum1)];
	out//Print;
	out
	]
	
SetAttributes[CEVOptionsformel,Listable];

CEVOptionsformelMcBeth//Clear  (* alpha > 2!! *)
CEVOptionsformelMcBeth[S_,K_,T_,r_,sigmaq_,alpha_]:=
	Module[{a,b,c,a2,ebt,u,y,uK,a2i,imax,std,i,i1,i2,
			sum1,sum2,g1,g2},
	{a,b,c,a2} = abc1[{r,sigmaq,alpha}]//N; 
	ebt = Exp[b T];
	u   = b/(a (ebt-1));
	y   = u S^a2 ebt;
	uK  = u K^a2; Print["uK  ",uK];
	a2i = Abs[1/a2];
	std = Sqrt[y];
	i1 = y - 4 std - a2i //Floor;
	i2 = y + 4 std - a2i //Ceiling;
	Print[{i1,i2}];
	i = Range[i1,i2]//N;
	sum1 = 1. - gammadichte[i+a2i,y].G1[i,uK];
	
	i1 = i1 + a2i //Floor;
	i2 = i2 + a2i //Ceiling;
	Print[{i1,i2}];
	i = Range[i1,i2]//N;
	sum2 = 1. - gammadichte[i,y].G1[i+a2i,uK];	
	Print[sum1];
	Print[sum2];
	S sum1 - K Exp[-r T] sum2
	]		
	
CEVOptionsformelC//Clear
CEVOptionsformelC =
 
	Compile[{S,K,T,r,sigmaq,alpha},
	
	Module[{s2,a2,a,b,c,ebt,u,y,uK,a2i,std,i1,i2,
			sum1,sum2},
	s2 = sigmaq/2.;
	a2 = 2.-alpha;
	a = s2 a2^2;
	b = a2 r;
	c = s2 a2 (1.-alpha);
	 
	ebt = Exp[b T];
	u   = b/(a (ebt-1.));
	y   = u S^a2 ebt;
	uK  = u K^a2; 
	Print["uK  ",uK];
	a2i = 1./a2;
	std = Sqrt[y];
	i1 = y - 4. std //Floor;
	i2 = y + 4. std //Ceiling;
	Print[{i1,i2}];
	sum1 = 0.;
	Do[sum1 += gammadichte[i,y] G1[i+a2i,uK],{i,i1,i2}];
			
	i1 = i1 - a2i //Floor;
	i2 = i2 - a2i //Ceiling;
	Print[{i1,i2}];
	
	sum2 = 0.;
	Do[sum2 += gammadichte[i+a2i,y]G1[i,uK],{i,i1,i2}];
	
	Print[sum1];
	Print[sum2];
	S sum1 - K Exp[-r T] sum2 ]
	];
(*
:[font = input; inactive; Cclosed; preserveAspect; startGroup]
CEVOptionsformel[ 100,100,1,.07,.4,1.5]//Timing
CEVOptionsformel1[100,100,1,.07,.4,1.5]//Timing
CEVOptionsformel2[100,100,1,.07,.4,1.5]//Timing
:[font = print; inactive; preserveAspect]
{146., 261.}
{144., 259.}
11.5419
uK  196.52
{146, 261}
{144, 259}
0.682562
0.608266
uK  196.52
{146, 261}
{144, 259}
0.682562
0.608266
:[font = output; output; inactive; preserveAspect]
{12.79999999999999993*Second, 11.54188668437472562}
;[o]
{12.8 Second, 11.5419}
:[font = output; output; inactive; preserveAspect]
{15.73333333333333328*Second, 11.54188668437472389}
;[o]
{15.7333 Second, 11.5419}
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
{13.8666666666666667*Second, 11.54188668437472393}
;[o]
{13.8667 Second, 11.5419}
:[font = section; inactive; initialization; Cclosed; preserveAspect; startGroup]
Feynman-Kac-Formel
:[font = input; initialization; preserveAspect]
*)
CFeynmanKac//Clear
CFeynmanKac[S_,K_,Tstern_,t_,f_,g_,Theta_,Prozess_,n_,T_]:= 
	Module[{dt,T1,Y0,X,St,m,var,e,c,stdc},
	
	dt  = (Tstern - t)/T;
	Print["{n,T,dt} = ", {n,T,dt}];
	T1 = T+1;
	X  = Shape[dt Range[0,T],{T+1,1}]//N;
	St = Table[RungeKutta[f,g,S,X,T,dt,Theta,Prozess,EulerStep]//Last,{nn,1,n}];
	St = Map[Max[#-K,0.]&,St,{2}];
	m  = Apply[Plus,St]/n;
	var= Apply[Plus,St^2]/n - m^2;
	e = Exp[-Theta[[1]] (Tstern-t)];
	c = e m;
	stdc = e Sqrt[var/n];
	{c,stdc}]
(*
:[font = input; initialization; preserveAspect]
*)
Expintegral//Clear
Expintegral[v_,St_,X_,dt_]:=
	Exp[dt Apply[Plus,MapThread[v[#1,#2,Theta]&,
		{Drop[St,-1],Drop[X,-1]} ]]];
		
CFeynmanKacG//Clear
CFeynmanKacG[S_,K_,Tstern_,t_,f_,g_,h_,v_,X_,Theta_,Prozess_,n_,T_]:=
	(*allgemeiner Fall*) 
	Module[{dt,T1,Y0,St,ST,x,x1,x2,var,c,stdc},
	
	dt  = (Tstern - t)/T;
	Print["{n,T,dt} = ", {n,T,dt}];
	St = Table[RungeKutta[f,g,S,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	x1 = Map[Expintegral[v,#,X,dt]&,St];
	ST = Map[Last,St,{1}];
	x2 = Map[h[#1,X//Last,Theta]&,ST];
	x = x1 x2;
	c = Apply[Plus,x]/n;
	stdc = (Apply[Plus,x^2]/n - c^2)/n//Sqrt;
	{c,stdc}]
(*
:[font = input; initialization; preserveAspect]
*)
CFeynmanKacCEV//Clear (*Spezialfall*)
CFeynmanKacCEV[S_,K_,Tstern_,t_,{r_,sigma_,alpha_},Prozess_,n_,T_]:= 
	Module[{dt,T1,Y0,St,X,m,var,e,c,stdc,a,b,alpha2,S0},
	
	dt  = (Tstern - t)/T;
	Print["{n,T,dt} = ", {n,T,dt}];
	T1 = T+1;
	a  = 1 + r dt;
	alpha2 = alpha/2;
	b = sigma Sqrt[dt];
	S0 = Shape[1,{n}]/. 1->S;
	St = Nest[(a # + b (#^alpha2) Table[Prozess[],{n}])&,S0,T];
	St = Map[Max[#-K,0.]&,St,{TensorRank[St]}];
	m  = Apply[Plus,St]/n;
	var= Apply[Plus,St^2]/n - m^2;
	e = Exp[-r (Tstern-t)];
	c = e m;
	stdc = e Sqrt[var/n];
	{c,stdc}]
	
(*
:[font = input; initialization; preserveAspect]
*)
CFeynmanKacCEVImportance//Clear (*Spezialfall*)
CFeynmanKacCEVImportance[S_,K_,Tstern_,t_,
                        {r_,r2_,sigma_,alpha_},Prozess_,n_,T_]:= 
	Module[{dt,T1,Y0,St,X,m,var,e,c,stdc,a,b,alpha2,S0,
	        logp1,logp2,likratio},
	
	dt  = (Tstern - t)/T;
	Print["{n,T,dt} = ", {n,T,dt}];
	T1 = T+1;
	a  = 1 + r2 dt;
	alpha2 = alpha/2;
	b = sigma Sqrt[dt];
	S0 = Shape[1,{n}]/. 1->S;
	St = NestList[(a # + b (#^alpha2) Table[Prozess[],{n}])&,S0,T];
	ST = St//Last;
	St = St//Transpose;
		(*St//Print;ST//Print;*)
	m = Map[Momente,St];
		(*m//Print;*)
    logp1 = Map[likCEV[{r ,sigma,alpha},{T,dt},#]&,m];
    logp2 = Map[likCEV[{r2,sigma,alpha},{T,dt},#]&,m];
    likratio = Exp[logp1-logp2];
    	(*likratio//Print;*)	
	St = Map[Max[#-K,0.]&,ST]* likratio;
	m  = Apply[Plus,St]/n;
	var= Apply[Plus,St^2]/n - m^2;
	e = Exp[-r (Tstern-t)];
	c = e m;
	stdc = e Sqrt[var/n];
	{c,stdc}]
(*
:[font = input; initialization; preserveAspect]
*)
CFeynmanKacDemo//Clear
CFeynmanKacDemo[S_,K_,Tstern_,t_,f_,g_,Theta_,Prozess_,n_,T_]:= 
	Module[{dt,T1,Y0,X,St,m,var,e,c,stdc},
	
	dt  = (Tstern - t)/T;
	Print["{n,T,dt} = ", {n,T,dt}];
	T1 = T+1;
	X  = Shape[dt Range[0,T],{T+1,1}]//N;
	St = Table[RungeKutta[f,g,S,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	plot1[flatten[St,{1,3}]//Transpose//AddTimeAxis];
	St = Transpose[St]//Last;
	univariate[Column[St,1]];
	St = Map[Max[#-K,0.]&,St,{2}];
	m  = Apply[Plus,St]/n;
	var= Apply[Plus,St^2]/n - m^2;
	e = Exp[-Theta[[1]] (Tstern-t)];
	c = e m;
	stdc = e Sqrt[var/n];
	{c,stdc}]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
		
FeynmanKacFokker//Clear
FeynmanKacFokker[x_,y_,s_,t_,f_,g_,v_,h_,X_,Theta_,Prozess_,n_,T_]:=
	(*allgemeiner Fall*) 
	Module[{c},
	
	dt  = (t-s)/T //N;
	Print["{n,T,dt} = ", {n,T,dt}];
	St = Table[RungeKutta[f,g,x,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	x1 = Map[Expintegral[v,#,X,dt]&,St];
	ST = Map[Last,St,{1}];
	x2 = Map[h[y-#1,X//Last,Theta]&,ST];
	xx = x1 x2;
	c = Apply[Plus,xx]/n //N;
	c]
	

FeynmanKacFokker[x_,y_,s_,t_,f_,g_,{v_,0},h_,X_,Theta_,Prozess_,n_,T_]:=
	(*allgemeiner Fall*) 
	Module[{c},
	
	dt  = (t-s)/T //N;
	Print["{n,T,dt} = ", {n,T,dt}];
	St = Table[RungeKutta[f,g,x,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	ST = Map[Last,St,{1}];
	x2 = Map[h[y-#1,X//Last,Theta]&,ST];
	Apply[Plus,x2]/n //N
	]	
    
Mittel//Clear
Mittel[Theta_,h_]:= 
    Module[{x2,xx},
    x2 = Map[h[#1,X//Last,Theta]&,ST];
	xx = x1 x2;
	Apply[Plus,xx]/n //N
	]
(*
^*)
