(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, bold, R65535, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, bold, B65535, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, italic, G65535, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, O497, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M8, N9, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 256; useSolids; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect]
*)
FDIGITS = 16
ANALGRAD = True
(*
:[font = input; initialization; preserveAspect]
*)

LogGaussDichte1[x_,{mue_,sigma_,sigma1_}]:= 
	Module[{z = x-mue},
	-.5 (Log[Det[sigma]] + z.sigma1.z) //N
];


LogEulerTransitionDensity//Clear
LogEulerTransitionDensity[{y_,x_,t_,dt_},Theta_,{f_,g_}]:= 
	 Module[{gg,omega,sigma,sigma1},
	 gg = g[x,t,Theta];
	 omega = gg.Transpose[gg];
	 sigma = omega dt;
	 sigma1 = Inverse[sigma];
	 LogGaussDichte1[y,{x + f[x,t,Theta]dt,sigma,sigma1}]
];


LogEulerDensity//Clear
LogEulerDensity[{Y_,X_,dt_},Theta_,{f_,g_}]:=
Module[{p},
 p = LogEulerTransitionDensity[{#1,#2,#3,dt},Theta,{f,g}]&;
 Apply[Plus,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[X,-1]}]]
];


DKSScoreT//Clear
DKSScoreT[{y_,x_,t_,dt_},Theta_,{f_,g_,Df_,DO_}]:= 
	 Module[{gg,omega,gdw,sigma,sigma1,M,p},
	 gg = g[x,t,Theta];
	 omega = gg.Transpose[gg];
	 sigma = omega dt;
	 sigma1 = Inverse[sigma];
	 gdw = y - x - f[x,t,Theta]dt;
	 M = Outer[Times,gdw,gdw];
	 p = LogGaussDichte1[gdw,{0,sigma,sigma1}];
	 {.5 dt DO[x,t,Theta].Flatten[sigma1.(M-sigma).sigma1]
	   + dt Df[x,t,Theta].sigma1.gdw, p}
];


DKSScoreN//Clear
DKSScoreN[{Y_,X_,dt_},Theta_,{f_,g_,Df_,DO_,Mue_,Sigma_,DMue_,DSigma_}]:=
	Module[{p,Y2,Y1,X1,sl},
	p = DKSScoreT[{#1,#2,#3,dt},Theta,{f,g,Df,DO}]&;
	{Y2,Y1,X1} = {Drop[Y,1],Drop[Y,-1],Drop[X,-1]};
 	sl = MapThread[p,{Y2,Y1,X1}];
 	Apply[Plus,sl] + 
 	GaussScore[{Y//First,X//First},Theta,{Mue,Sigma,DMue,DSigma}]	
	];

DKSScoreN1//Clear
DKSScoreN1[{Y_,X_,dt_},Theta_,{f_,g_,Df_,DO_}]:=
	Module[{p,Y2,Y1,X1,sl},
	p = DKSScoreT[{#1,#2,#3,dt},Theta,{f,g,Df,DO}]&;
	{Y2,Y1,X1} = {Drop[Y,1],Drop[Y,-1],Drop[X,-1]};
 	sl = MapThread[p,{Y2,Y1,X1}];
 	Apply[Plus,sl]  (*ohne AB*)	
	];
	
DKSScore//Clear
DKSScore[{Y_,X_,dt_},Theta_,system_]:=
	Apply[Plus,
	MapThread[DKSScoreN[{#1,#2,dt},Theta,system]&,{Y,X}]
	]

DKSScore1//Clear
DKSScore1[{Y_,X_,dt_},Theta_,system_]:=
	Apply[Plus,
	MapThread[DKSScoreN1[{#1,#2,dt},Theta,system]&,{Y,X}]
	]
		
GaussScore//Clear
GaussScore[{Y0_,X0_},Theta_,{Mue_,Sigma_,DMue_,DSigma_}] :=
	Module[{S,S1,M,m,dm,lik0,score0},
	m = Mue[X0,Theta];
	dm = Y0 - m;
	M = Outer[Times,dm,dm];
	S = Sigma[X0,Theta];
	S1 = Inverse[S];
	lik0 = LogGaussDichte1[Y0,{m,S,S1}];
	score0 =     DMue[X0,Theta].S1.(Y0-m) + 
			.5 DSigma[X0,Theta].Flatten[S1.(M-S).S1];
			
	{score0,lik0}	
	];

		
DKSLikT//Clear
DKSLikT[{y_,x_,t_,dt_},Theta_,{f_,g_}]:= 
	 Module[{gg,omega,gdw,sigma,sigma1,M,p},
	 gg = g[x,t,Theta];
	 omega = gg.Transpose[gg];
	 sigma = omega dt;
	 sigma1 = Inverse[sigma];
	 gdw = y - x - f[x,t,Theta]dt;
	 M = Outer[Times,gdw,gdw];
	 p = LogGaussDichte1[gdw,{0,sigma,sigma1}]
	 
];

DKSLikn//Clear
DKSLikn[{Y_,X_,dt_},Theta_,{f_,g_,Mue_,Sigma_}]:=
	Module[{p,Y2,Y1,X1,lik},
	p = DKSLikT[{#1,#2,#3,dt},Theta,{f,g}]&;
	{Y2,Y1,X1} = {Drop[Y,1],Drop[Y,-1],Drop[X,-1]};
 	lik = MapThread[p,{Y2,Y1,X1}];
 	Apply[Plus,lik] + GaussLik[{Y//First,X//First},Theta,{Mue,Sigma}]	
	];


DKSLik//Clear
DKSLik[{Y_,X_,dt_},Theta_,system_]:=
Apply[Plus,
MapThread[DKSLikn[{#1,#2,dt},Theta,system]&,{Y,X}]
]

	
GaussLik//Clear
GaussLik[{Y0_,X0_},Theta_,{Mue_,Sigma_}]:=
	Module[{S,S1,m,lik0},
	m = Mue[X0,Theta];
	S = Sigma[X0,Theta];
	S1 = Inverse[S];
	lik0 = LogGaussDichte1[Y0,{m,S,S1}]
	];

(***************************************************************)			 
DKSHesse2[{Y_,X_,dt_},Theta_,system_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE (MIT MISSING DATA) 2-seitig*)
Module[{INC = $MachineEpsilon^(1/2),i,LIK,INC1,
		Sup,Sdo,DS,S,HNUM,SNUM},

{S,LIK} = DKSScore[{Y,X,dt},Theta,system];
INC = INC Abs[Theta];
INC1=1/(2 INC);
HNUM = {};
SNUM = {};
Do[ 
    {Sup,likup} = DKSScore[{Y,X,dt},GRIDI[Theta,i, INC],system];
	{Sdo,likdo} = DKSScore[{Y,X,dt},GRIDI[Theta,i,-INC],system];
	
    HNUM = Append[HNUM,(Sup-Sdo)*INC1[[i]]];
    SNUM = Append[SNUM,(likup-likdo)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];

HNUM = .5(HNUM + Transpose[HNUM]);  
DS = S-SNUM;
Print[ "KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"];
Print[MatrixForm[{SNUM, S, DS, Theta, INC }//Transpose,
	TableHeadings->{Automatic,{"SNUM","S","DS","THETA","INC"}}]];  
{S,HNUM,LIK}
]
	
(*
:[font = input; initialization; preserveAspect; startGroup]
*)
BFGSUP//Clear
(***************************************************************)			 
BFGSUP[F_,SNEU_,S_,STEP_] := 
	Module[{MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)			 
(*NOISE LEVEL*)
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
TOL = If[ANALGRAD,ETA,ETA^0.5,ETA^0.5];
NOISE = (Max[Abs[SNEU]]+Max[Abs[S]])*TOL;
Print["NOISE  ",NOISE];
MACHEPS2 = $MachineEpsilon^0.5;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < NOISE, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print["*BFGSUP ", A,"  ", B];  
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]
(*
:[font = message; inactive; preserveAspect; endGroup]
General::spell1: Possible spelling error: new symbol name "FSTEP" is similar to existing symbol "STEP".
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)			 
LikTest[LIKNEU_]:=
(***************************************************************)
	If[(LIKNEU//NumberQ//Not)||(Im[LIKNEU]=!=0)||(LIKNEU>10.^10),
	 	Print["LIKNEU = ",LIKNEU," reset to -10.^10"]; -10.^10,
	 		LIKNEU]				
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)			 
DKSBFGS//Clear
DKSBFGS[{Y_,X_,DT_,MISS_},
		{THETA0_,F0_,lik0_,Rekursiv_},
		{f_,g_,Df_,DO_,Mue_,Sigma_,DMue_,DSigma_},
		{KMAX_,EPS_,OPTION_,PRINT_}]:= 
(***************************************************************)			 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,u,THETA,F,
        S,LIKALT,LIKI,psii,STEPL,STEP,
        LIKNEU,SNEU,likpsi,COV,LIKELI,n,T,T1,P,Q,k,KK},

INC=10.^-5;
MAXSTEP=10.^2;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;
stepreduce = 3;

{n,T1,P} = Dimensions[Y];
{n,T1,Q} = Dimensions[X];
T = T1-1;

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: DKSBFGS*************************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,P,Q,n,T,DT,OPTION,MISS,MAXSTEP,
		  MINSTEP,BOUND,stepreduce}//Spalte,
         {"KMAX","EPS","P","Q","n","T","DT","OPTION",
          "MISS","MAXSTEP","MINSTEP","BOUND","stepreduce"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0]
];

u = Length[THETA0];

THETA=THETA0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = 
If[ Rekursiv > 0,

	op = Take[#,-(Rekursiv+1)]&; (*Rekursiv=Lnge der neuen Daten*)
    {0,lik0} + DKSScore1[{op/@Y,op/@X,DT},THETA0,{f,g,Df,DO}],

	DKSScore[{Y,X,DT},THETA0,{f,g,Df,DO,Mue,Sigma,DMue,DSigma}]
];

(*
Print[{S,LIKALT}];
Print[DKSScore[{Y,X,DT},THETA0,{f,g,Df,DO,Mue,Sigma,DMue,DSigma}]];
*)

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,
 	
	If[PRINT[[2]] == 1,
	Print["-----------------------------------------------------------------"];
    Print["DKSBFGS: Iteration = ",KK];
    ];
   
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    
 	STEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTLNGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-Reduction*)
   
    THETA1 = THETA + STEP;   (*VOLLER NEWTON-STEP*)
    
    (*Print["VOLLER NEWTON-STEP  ",THETA1,"   ",THETA];*)
    
  	LIKNEU = DKSLik[{Y,X,DT},THETA1,{f,g,Mue,Sigma}];			
   	LIKNEU = LikTest[LIKNEU];
   	 
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
         STEP=STEP/stepreduce;
         THETA1 = THETA + STEP; 
         
         LIKNEU = DKSLik[{Y,X,DT},THETA1,{f,g,Mue,Sigma}];
			  		
		 LIKNEU = LikTest[LIKNEU];
	  		
		 If[PRINT[[3]] == 1,
         Print["STEP-REDUCTION:  ",half,
         			"  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			"  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
     ]; (*End DoWhile*)
     
	
	If[PRINT[[4]] == 1,
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];
    Print["LIKNEU - LIKALT  ",PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    Print[""];
    ];
    
  
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA,STEP,S}//Transpose,
    	  TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}]
    	  ]];
    
    If[PRINT[[6]] == 1,
    Print[""];
    MatPrint[F];
    ];
       
    {SNEU,LIKALT} = 
    	DKSScore[{Y,X,DT},THETA1,{f,g,Df,DO,Mue,Sigma,DMue,DSigma}]; 
		
    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S = SNEU;
    
    THETA = THETA1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ "DKSBFGS:  ENDE DER ITERATION  ",k,"  ",KMAX] ];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,THETA];
likpsi = Spalte[LIKI]~ii~psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
		TableHeadings->{Automatic,{"Likelihood","THETA"}} ]];
];
					

If[Fisher,

	{S,F,LIKELI} = 
		DKSHesse2[{Y,X,DT},THETA,{f,g,Df,DO,Mue,Sigma,DMue,DSigma}];
		
	F=-F;
	
	COV = OUTPUT[THETA,F,.05,S,LIKELI];
	LKOMP[LIKELI,u,(T+1)];
	
,(* else *)
	COV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,COV,LIKI,psii,k}

]
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)			 
DKSBFGSRekursiv//Clear
DKSBFGSRekursiv[{Y_,X_,T1_,T2_,DT_,MISS_},
		{THETA0_,F0_},
		system_,
		{KMAX_,EPS_,OPTION_,PRINT_}]:= 
(***************************************************************)			 
Module[{Yt,Xt,THETA,COV,lik,psi,k,cum},

cum = {};
Rekursiv = 0;
F = F0;
THETA = THETA0;

Do[

If[PRINT[[1]] ==1,Print["******DKSBFGSRekursiv********* t = ",t]];

Yt = Map[Take[#,t+1]&,Y];
Xt = Map[Take[#,t+1]&,X];

{THETA,COV,lik,psi,k} = 
	DKSBFGS[{Yt,Xt,DT,MISS},
	{THETA,F,lik//Last,Rekursiv},
	system,
	{KMAX,EPS,OPTION,PRINT}];
Rekursiv = 1;
F = Inverse[COV];
cum = Append[cum,THETA];

,{t,T1,T2}];

cum
];


(*
;[s]
3:0,0;93,1;108,0;683,-1;
2:2,12,10,Courier,1,12,0,0,0;1,12,10,Courier,1,12,65535,0,0;
^*)
