(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	keywords = "MessUpEKFinno";
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, R65535,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect; plain; keywords = "MessUpEKFinno"]
*)
MessUpEKFInno//Clear
(***************************************************************)			 
MessUpEKFInno[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(* ret. innovation, innocov und normierte inno.*) 
	
	Block[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii,innostern},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	    If[lc == {},Return[{Yi1i,Pi1i,0,{},{{}},{}}]]; (*keine Messung*)
	    
		H = Dh[Yi1i,X,Theta]; 
		H = H[[lc]]; 
		r = R[Yi1i,X,Theta][[lc,lc]];	
		vi = H . Pi1i . Transpose[H] + r; 
			
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1;
		inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]];	
		lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
		
		Yii = Yi1i + gain.inn;
		
		{k,p} = H//Dimensions;
		ikh = IdentityMatrix[p] - gain.H;
		Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
		innostern=Transpose[CholeskyDecomposition[vi1]].inn;
		
		{Yii,Pii,lik,inn,vi,innostern}
		
]
(*
:[font = input; remoteEvaluator = "MathKernel 3.0.1"; initialization; preserveAspect; plain]
*)
MessUpOmnibusInno//Clear
(***************************************************************)			 
MessUpOmnibusInno[{Z_,{Yi1i_,Pi1i_,alphai1i_},X_},Theta_,
                  {h_,Dh_,R_},{miss_,n_,Generator_,seed_,RESAMPLING_:True}]:=
(***************************************************************)
(* mit a priori-Gewichten alphai1i *)
(* alle Methoden                   *)

Block[{Pii,jacobi,vi1,gain,lc,Yii,YiiR,prederr,pn,lik,L,LQuer,alphaii,c},

	
	pn = MessUpEKFInno[{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
	{Yii,Pii,lik,inno,gamma,innostern} = MapThread[pn,{Yi1i,Pi1i}]//Transpose;
			
	c = lik//Max;   
	L = alphai1i Exp[lik-c]; 
	LQuer = Apply[Plus,L];  
	
	(* Print["---------------"];lik//Print; *)
	
	alphaii = L/LQuer;
	lik = Log[LQuer]+c;
	
	(*
	alphai1i//Print;
	alphaii//Print;
	Print[N[lik,16]]; 
	*)
	
	
	(*RESAMPLING//Print;*)
	
	If[RESAMPLING,
		YiiR = RandomKDE[Yii,alphaii,Pii,Generator,seed,n], (* resampling *)
		(* else *)
		YiiR = Yii];
	
	{YiiR,lik,Yii,Pii,alphaii,inno,gamma,innostern}

]
(*
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
SmoothEKFInno//Clear
SmoothEKFInno[{Z_,Yii_,Pii_,alphaii_,{X_,innostern_,Dt_},dt_},
               Theta_,
              {f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{yiiZ,PiiZ,alphaiiZ,likZ,c,innosternZ},

{yiiZ,PiiZ,likZ,innosternZ}=
MapThread[SmoothEKF1Inno[{Z,#1,#2,{X,#3,Dt}//Transpose,dt},Theta,
                         {f,Df,g,h,Dh,R},miss]&,
	     {Yii,Pii,innostern}]//Transpose;
	     
c = likZ//Max; 
alphaiiZ=alphaii*Exp[likZ-c];
	
alphaiiZ=alphaiiZ/Apply[Plus,alphaiiZ];
 
(* Print["in SmoothEKFInno:  ",{yiiZ,PiiZ,alphaiiZ,innosternZ}]; *)

{yiiZ,PiiZ,alphaiiZ,innosternZ}	                  
]	
(*
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
SmoothEKF1Inno//Clear
SmoothEKF1Inno[{Z_,Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{Yi1i,Pi1i,F,Yi1i1,Pi1i1,yii,pii,liki,inn,gamma,innostern},

	{Yi1i,Pi1i,F} = TimeUpEKFSmooth[{Yii,Pii,X,dt},Theta,{f,Df,g}];
	
	Yi1i = Over[Yi1i,YMAX]; 
	
	{Yi1i1,Pi1i1,liki,inn,gamma,innostern} = 
			MessUpEKFInno[{Z,{Yi1i,Pi1i},X//Last,_},Theta,{h,Dh,R},{miss}];	
	
	yii = Yii + F.(Yi1i1-Yi1i);
	pii = Pii + F.(Pi1i1-Pi1i).Transpose[F];
	
	{yii,pii,liki,innostern}
	
]
	
(*
:[font = input; initialization; preserveAspect; plain]
*)
FIFImportanceSmoothInno//Clear
(***************************************************************)			 
FIFImportanceSmoothInno[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,p0_,dt_},
				                    {{l0_,l1_,l2_:0},
				                    {faux_,Dfaux_,gaux_},
				                    step_,dW_,seed_,Generator_,
				                    miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral mit exaktem importance sampling
   fr lineare Systeme / mit Ersatz-Modell 
   
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_{i+1|i} = 1/N sum p(y_{i+1} = y_J|y_J-1) * alpha{i+1|i}; 
   dy = fdt + gdW 
 
   option = 1: lik, 
   option = 2: YF: TxNxp,(Stichproben-Trajektorien) 
   option = 3: YF: Tx2xp (m und s)

*)

Block[{ti,T1,T,dti,dti1,n,n1,Xi,z,y0,P0,yiiR,lik,yii,Pii,alphaii,alphai1i,
        yiiZ,PiiZ,alphaiiZ,
        YF,Misch,(*likvec,*)xi,dwi,yJ1,y,G,Pi1i,yi1i,liki,
        f2g2,fI,f2,f1,g1,g2,XZ,p,
        likratio,lik2,lik1,Zi1,inno,gamma,innostern,innosternneu},

{ti,T1,T,dti,dti1} = Zeiten1[Z,miss];

(* {ti,T1,T,dti,dti1}//Print; *)

n = Length[dW]; n1 = 1./n; 

Print["FIFImportanceSmoothInno: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];


f2g2//Clear;
f2g2[y_,{XX_,z_},Th_]:= Block[{fI,OmegaI,F1,F2,G,Omega,G2},
	
	   {fI,OmegaI} = SmoothEKF2[{z,y,_,XX,dt},Th,{faux,Dfaux,gaux,h,Dh,R},miss];	
	
	   F1 = faux[y,XX//First,Th];
	   F2 = F1 + l0*fI;
	 
	   G = gaux[y,XX//First,Th];
	   Omega = G.Transpose[G];	  
	   G2 =  CholeskyDecomposition[ Omega + l1*OmegaI ]//Transpose;
	   
	   (*Print[XX//First,F1,F2,G,G2]; *)
	 
	 {F2,G2}	 ];
	 
	 
{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii,inno,gamma,innostern} = 
		    MessUpOmnibusInno[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]]},Theta,{h,Dh,R},
		                      {miss,n,Generator,seed,False}];



i=0;
Xi        = Take[X,dti[[i+1]]];
innostern = Table[innostern,     {j,dti1[[i+1]]}]//Transpose;
deltat    = Table[dti1[[i+1]]*dt,{j,dti1[[i+1]]}];

{yiiZ,PiiZ,alphaiiZ,innosternneu} = 
								SmoothEKFInno[{Z[[ti[[i+2]] ]],yii,Pii,alphaii,
                      {Xi,innostern,deltat},dt},Theta,
                      {faux,Dfaux,gaux,h,Dh,R},miss];

yii//Print;
yiiZ//Print;

Pii//Print;
PiiZ//Print;

alphaii//Print;
alphaiiZ//Print;

Return[];


                                     
innosternneu = Table[innosternneu,{j,dti1[[i+2]]}]//Transpose;

If[l2==1,alphaiiZ= Shape[n1,{n}]  ];
If[l2==2,alphaiiZ= ALPHIIZ[[1]] ];
If[l2==3,ALPHIIZ = Append[{},alphaiiZ] ];
If[l2==4,alphaiiZ= alphamax[alphaiiZ]  ];
				

yiiR = RandomKDE[yiiZ,alphaiiZ,PiiZ,Generator,seed,n]; (* resampling *)

p0Z = Map[likratio0[#,{yii,Pii,alphaii},{yiiZ,PiiZ,alphaiiZ}]&,yiiR];	                
		                  				                 	
YF   = {}; Misch = {}; likvec = {lik};

  
Do[  

	j   = ti[[i+1]];      (*Print[{i+1,j}];*)
	Zi1 = Z[[j]];
	
	Xi  = Take[ X,dti[[i]] ];	
 xi  = Xi//Last;
	dwi = Map[Take[#,dti1[[i]] ]&,dW];
                     
 {y,lik2} = 
 
 Table[
 
 					XZ = Table[{{Drop[Xi,j-1],
	              				Drop[innostern[[nn]],j-1],
	              				Drop[deltat,j-1]}//Transpose,
	              				Zi1}
	                ,{j,1,Xi//Length}];
 
 
 						RungeKutta1Lik[f2g2,yiiR[[nn]],{XZ,dwi[[nn]]},Length[Xi]-1,dt,Theta,EulerStep1Lik]
 		
 	,{nn,1,n}]//Transpose;
 
 yJ1 = Map[Last,y];
 
 (* yJ1//Print; lik2//Print; *) 
	
	
 G =  Map[g[#,xi,Theta]&,yJ1]; 
 Pi1i = MapThread[Dot,{G,Map[Transpose,G]}] dt;
 yi1i = yJ1 + Map[f[#,xi,Theta]&,yJ1] dt; 

 
 (* Print[Pi1i//First//VecDiag]; *)
 
 (* yi1i//Abs//Max//Print;*)
   		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)

	If[option==2,
				 YF = Join[YF,y//Transpose];
				 (*YF//Print;*)     
	  ];
	  
	If[option==3,
	    (*y//Dimensions//Print;
	    y//TensorMS//Dimensions//Print;*)
				 YF = Join[YF,y//TensorMS//Transpose];
				 (*YF//Print; *) 
	  ];
	   
	
	If[dti1[[i]] =!= 1,
				
				lik1=Map[LogLikelihood[#,f,g,Xi,dt,Theta]&,y];
				
				alphai1i = n1*Exp[lik1-lik2]*p0Z,	 
				 
			(* else *)
				alphai1i = n1*p0Z
	];
	
	(*
	lik1//Print;
	lik2//Print;
	alphai1i//Print;
	*)

	{yiiR,liki,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Zi1,{yi1i,Pi1i,alphai1i},X[[j]]},
				                 Theta,{h,Dh,R},{miss,n,Generator,seed,False}];
				                 
(* Print[i,"  ",liki]; *)
	                              
                                 
	If[i < Length[ti]-1,
			
				Xi        = Take[X,dti[[i+1]]];
				(*innostern = Table[innostern,{j,dti1[[i+1]]}]//Transpose;*)
				innostern = innosternneu;
				deltat    = Table[dti1[[i+1]]*dt,{j,dti1[[i+1]]}];
	
				{yiiZ,PiiZ,alphaiiZ,innosternneu} = 
														SmoothEKFInno[{Z[[ti[[i+2]]]],yii,Pii,alphaii,
				                        {Xi,innostern,deltat},dt},Theta,
                            {faux,Dfaux,gaux,h,Dh,R},miss];
   
    alphaiiZ//Print;
    If[i==3,Return[]];
    
    If[i < Length[ti]-2,                                   
				innosternneu = Table[innosternneu,{j,dti1[[i+2]]}]//Transpose];
				
				If[l2==1,alphaiiZ= Shape[n1,{n}]  ];
				If[l2==2,alphaiiZ= ALPHIIZ[[i+1]] ];
				If[l2==3,ALPHIIZ = Append[ALPHIIZ,alphaiiZ] ];
				If[l2==4,alphaiiZ= alphamax[alphaiiZ]  ];
				
				(* Print["alphaiiZ ",alphaiiZ//Chop]; *)
				(* Print["PiiZ ",PiiZ]; *)
				
				SeedRandom[seed];                    
 		 yiiR = RandomKDE[yiiZ,alphaiiZ,PiiZ,Generator,seed,n]; (* resampling *)
 		 
 		 p0Z = Map[likratio0[#,{yii,Pii,alphaii},{yiiZ,PiiZ,alphaiiZ}]&,yiiR];
 		 
 		 (*
 		 Print[i,"yi1i",yi1i];
 		 Print[i,"Pi1i",Pi1i];  
 		 Print[i,"alphai1i",alphai1i//Log];
 		 Print[i,"yii",yii];
 		 Print[i,"Pii",Pii];  
 		 Print[i,"alphaii",alphaii];
 		 Print[i,"yiiZ",yiiZ];
 		 Print[i,"PiiZ",PiiZ];  
 		 Print[i,"alphaiiZ",alphaiiZ];
 		 
 		 Print[i,"yiiR",yiiR]; 
 		 Print[i,"p0Z ",p0Z];  
 		 *) 
 		 
 		 (*Return[];*)                    
				
	  ];
  		
	
	likvec = Append[likvec,liki];	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];



If[option==1,Return[lik] ];

If[option==2,
	YF = Join[YF,{yiiR}];
	Return[{YF,lik,likvec}] ];
	
If[option==3,
	YF = Join[YF,{yiiR//TensorMS}];
	Return[{YF,lik,Misch}] ];	
	
];
(*
;[s]
10:0,1;23,0;101,1;124,0;1142,1;1167,0;4282,2;4304,0;5185,2;5222,0;6109,-1;
3:5,12,10,Courier,0,12,0,0,0;3,12,10,Courier,0,12,65535,0,0;2,12,10,Courier,0,12,0,0,65535;
^*)
