(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, R65535,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = subsubsection; inactive; initialization; preserveAspect; startGroup]
Module
:[font = input; initialization; preserveAspect]
*)
likGARCHARMA//Clear
likGARCHARMA[{Y_,X_},Theta_,{f_,g_,phi_,Y0_,H0_,Zm1_},{opt_:1}]:=

Block[{T=Length[Y]-1,Yi,Hi,Zi1,lik,yi1i,epsi,G,g0,Omega,liki,hi1},

Yi=Y0; Hi=H0; Zi1=Zm1;
 
lik=0; ZweiPi=2. Pi;

Do[

G     = g[{Yi,Hi,Zi1},{X,i},Theta];  
yi1i  = f[{Yi,Hi,Zi1},{X,i},Theta];
        
        (*yi1i//Print;*)
        
epsi  = Y[[i+1]]-yi1i;

Omega = G.Transpose[G];
liki  = -.5(Log[Det[ZweiPi Omega]] + epsi.Inverse[Omega].epsi);
lik  += liki;

zi    = Inverse[G].epsi;   (*zi//Print;*)
Zi1   = Prepend[Zi1,zi];   (*Zi//Print;*)

hi1   = phi[{Yi,Hi,Zi1},{X,i},Theta]; 

Hi    = Prepend[Hi,hi1];
Yi    = Prepend[Yi,Y[[i+1]] ];


,{i,1,T}];

If[opt==1,
 lik,
{lik,Hi//Reverse,Zi1//Reverse}]


];
(*
:[font = input; initialization; preserveAspect]
*)
likGARCHARMA1//Clear
likGARCHARMA1[{Y_,X_},Theta_,{f_,g_,phi_,Y0_,H0_,Zm1_},opt_]:=

Block[{T=Length[Y]-1,Yi,Hi,Zi1,lik,yi1i,yi1,i1,epsi,G,g0,Omega,liki,hi1},

Yi=Y0; Hi=H0; Zi1=Zm1; ZweiPi=2. Pi;
 
lik=0;

Do[

G     = g[{Yi,Hi,Zi1},{X,i},Theta];  
yi1i  = f[{Yi,Hi,Zi1},{X,i},Theta];
        
        (*yi1i//Print;*)

yi1   = Y[[i1=i+1]];        
epsi  = yi1-yi1i;

Omega = G.Transpose[G];
liki  = -.5(Log[Det[ZweiPi Omega]] + epsi.Inverse[Omega].epsi);

(*lik  += If[i1>=opt,liki,0];*)

  lik  += liki;

zi    = Inverse[G].epsi;   (*zi//Print;*)
Zi1   = Drop[Prepend[Zi1,zi],-1];   (*Zi//Print;*)

hi1   = phi[{Yi,Hi,Zi1},{X,i},Theta]; 

Hi    = Drop[Prepend[Hi,hi1],-1]; 
Yi    = Drop[Prepend[Yi,yi1 ],-1]; 


,{i,1,T}];

lik


];
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
simulGARCHARMA//Clear
simulGARCHARMA[{z_,X_},Theta_,{f_,g_,phi_,Y0_,H0_,Zm1_},{opt_:1}]:=

Block[{T=Length[z]-1,Yi,Hi,Epsi,lik,yi1i,epsi,G,g0,Omega,liki,hi1},

Yi=Y0; Hi=H0; Zi1=Zm1; 

Do[

G     = g[{Yi,Hi,Zi1},{X,i},Theta];            (*G//Print;*)

yi1i  = f[{Yi,Hi,Zi1},{X,i},Theta] + G.z[[i]]; (*yi1i//Print;*)
        
Zi1   = Prepend[Zi1,z[[i]] ];   	           (* Zi//Print;Print[i];*)               

hi1   = phi[{Yi,Hi,Zi1},{X,i},Theta];          (*hi1//Print;*)

Hi    = Prepend[Hi,hi1];                       (* Hi//Print;*)
Yi    = Prepend[Yi,yi1i ];                     (* Yi//Print;*)


,{i,1,T}];

{Yi//Reverse,Hi//Reverse}


];
(*
^*)
