(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

<<code`LSD`
<<code`PARTest`



BFGS::usage = "BFGS[THETA0,PHI0,F0,KMAX,EPS,Z,X,K,P,Q,N,T,DT,
		            OPTION,NONLIN,PRINT]"
		        
		        
		   		        

MatPrint[F_]:=
  Print[NumberForm[F//MatrixForm,4,NumberSigns->{"-"," "}]];

(***************************************************************)
DMS[Y_,X_] := Outer[D,Y//Flatten,X//Flatten]//Transpose;
(***************************************************************)

(***************************************************************)
INTERPOL[XM_,MISS_,ORDER_] := 
(***************************************************************)
	Module[{XMr,Xint,tau3,T1,q,n,data},
		{T1,q,n} = XM//Dimensions;
		XMr = XM//Reverse;
		Xint = Table[
			tau3 = Locate[XMr[[T1//Range,qq,nn]] ~eq~ MISS, False];
			(*tau3//Print;*)
			data = {tau3,XMr[[tau3,qq,nn]]}//Transpose;
      		Interpolation[data,InterpolationOrder->ORDER][T1//Range]
       		  ,{qq,q},{nn,n}];
		Transpose[Xint,{2,3,1}]//Reverse
	 ]	

(***************************************************************)
analyze[z_,miss_] := Module[{t1,p,n,LC,messindTN,messindT},
(***************************************************************)

	{t1,p,n} = Dimensions[z];
	LC = Map[Locate[# ~ne~ miss]&,Transpose[z,{1,3,2}],{2}];
	messindTN = Delete[Outer[List,t1//Range,n//Range],Position[LC,{}]];
	messindTN = Flatten[messindTN,1];
	messindT = Map[Part[#,{1}]&,messindTN]//Union;
	{LC,messindTN,messindT}
	]













(***************************************************************)
ConfidenceBand[Y_,YF_,PF_,pp_,nn_,z_] := 
(***************************************************************)

	Module[{var1,conf1,conf2,yf,T,p,n,np},
	{T,p,n} = Y//Dimensions;
	{T,np,p,p} = PF//Dimensions;
	n = If[np == 1, 1, nn];
	var1 = Sqrt[PF[[T//Range,n,{pp},pp]]  ];
	yf = YF[[T//Range,{pp},nn]];
	conf1 = yf + z var1;
	conf2 = yf - z var1;
	Y[[T//Range,{pp},nn]] ~ii~ yf ~ii~ conf1 ~ii~ conf2
]

(***************************************************************)
MessUp5[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,miss_,LC_,{k_,p_,q_,n_,np_}] :=
(***************************************************************)
	Module[{nn,zmiss,lc,hnt,dnt,rnt,pi1in,vint,vi1,gain,inn,ikh,
	        Yii,Pii,lik},
		
		lik = .0;
		Yii = Yi1i;
		Pii = Pi1i;
		
		Do[ 
			lc = LC[[nn]]; 		
			If[ lc == {},
				(* keine Messung *)
				 
				If[np == 1, Return[] ]	
				
			,(*else*)
				
				hnt = H[[lc]];
				dnt = D[[lc]]; 
				rnt = R[[lc,lc]];
				
				pi1in = Pi1i[[nn]];
				vint = hnt.pi1in.Transpose[hnt] + rnt;
				vi1 = Inverse[vint];
				gain = pi1in.Transpose[hnt].vi1;
				
				If[np == 1, (*Print["Messung, simultan"];*)
				
					(* alle N simultan*)
					inn = Z[[ lc ]] - hnt.Yi1i - dnt.X;
					lik = n Log[Det[vint]] + MatrixTrace[vi1.
											  (inn.Transpose[inn])];
											 
					Yii = Yi1i + gain.inn;
					ikh = IdentityMatrix[p] - gain.hnt;
					Pii = {ikh.pi1in.Transpose[ikh] +
								 gain.rnt.Transpose[gain]}
					
					
					
				,(*else*) (*Print["Messung, einzeln"];*)
				
				    inn = Z[[lc,nn]] - hnt.Yi1i[[Range[p],nn]] 
				                     - dnt.X[[Range[q],nn]]; (*Vektor*)
					lik += Log[Det[vint]] + inn.vi1.inn;
					
					Yii = Yii//Transpose;
					Yii[[nn]] = Yi1i[[Range[p],nn]] + gain.inn;
					Yii = Yii//Transpose; (*wieder zur\[UDoubleDot]ck*)
					
					ikh = IdentityMatrix[p] - gain.hnt;
					Pii[[nn]] = ikh.pi1in.Transpose[ikh] 
					 		   + gain.rnt.Transpose[gain]
	
				](*end if*)
					
			](*end if*)
					
		,{nn,np}];
		
	   {Yii,Pii,lik}
	   
	](*End MessUp5*)


(***************************************************************)
MGLATT5[Z_,X_,Astern_,Bstern_,Ostern_,MUEN_,SIGMAN_,
		H_,D_,R_,n_,T_,miss_,LC_]:=
(***************************************************************)			 
	Module[{np,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,
			Yi1i,Pi1i,lik,liki,Z0,X0,Y0,P0,lik0,SUM},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = Length[SIGMAN];
		(*Print["*MGLATT5",{k,p,q,n,np}];*)
		Z0 = Z[[1]];
		X0 = X[[1]]; 
		{Y0,P0,lik0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,miss]; 
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = Array[1&,{np}] /. 1->Ostern;
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
				
	        {Yii,Pii,liki} = 
	        	MessUp5[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,
	        							  LC[[i+1]],{k,p,q,n,np}];
	      
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        	
		,{i,T}];
		
		lik = -.5 lik + lik0;
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		PISUM = 0;
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			{YGalt,PGalt,SUM} = 
				GlattUp[{YGalt,PGalt},{Yii,Pii,Yi1i,Pi1i},Astern,{p,np}];
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			PISUM += SUM;
		
		,{i,T,1,-1}];
	
		PISUM = PISUM//Transpose;
		
		{YG,PG,PISUM,lik}
	]

(***************************************************************)
GLATT5[Z_,X_,Astern_,Bstern_,Ostern_,MUEN_,SIGMAN_,
						              H_,D_,R_,n_,T_]:=
(***************************************************************)			 
	Module[{k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,
			Yi1i,Pi1i,lik,liki,Z0,X0,Y0,P0,lik0,SUM},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		
		Print["*Glatt5 {k,p,q,n} ",{k,p,q,n}];
		Z0 = Z[[1]];
		X0 = X[[1]]; 
		{Y0,P0,lik0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9]; 
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = {Ostern};
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
				
	        {Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
	      
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        	
		,{i,T}];
		
		lik = -.5 lik + lik0;
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		PISUM = 0;
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			{YGalt,PGalt,SUM} = 
				GlattUp[{YGalt,PGalt},{Yii,Pii,Yi1i,Pi1i},Astern];
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			PISUM += SUM;
		
		,{i,T,1,-1}];
	
		PISUM = PISUM//Transpose;
		
		{YG,PG,PISUM,lik}
	]

(***************************************************************)
GLATT5X[Z_,X_,Astern_,Bstern_,Ostern_,MUEN_,SIGMAN_,
						              H_,D_,R_,n_,T_]:=
(***************************************************************)
(* alles explizit *)

	Module[{k,p,q,Z0,X0,Y0,P0,lik0,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,
			i,ON,Yii,Pii,Yi1i,Pi1i,lik,liki,PISUM,Pistern,IP},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		Print["*Glatt5X {k,p,q,n} ",{k,p,q,n}];
		Z0 = Z[[1]];
		X0 = X[[1]]; 
		{Y0,P0,lik0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9]; 
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = {Ostern};
		IP = IdentityMatrix[p];
		Do[ 
			(*Time Update*)
			
			(*{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];*)
			
			Yi1i = Astern.Yii + Bstern.X[[i]];
			Pi1i = Astern.Transpose[Pii,{2,1,3}].Transpose[Astern];
			Pi1i = Transpose[Pi1i,{2,1,3}] + ON;
			
			(*Mess-Update*)
					
	        (*{Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];*)
	        	
	        pi1in = Pi1i[[1]]; 
			vint = H . pi1in . Transpose[H] + R;
			vi1 = Inverse[vint];
			gain = pi1in . Transpose[H] . vi1;
			inn = Z[[i+1]] - H . Yi1i - D . X[[i+1]];
			liki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
			Yii = Yi1i + gain.inn;
			ikh = IP - gain.H;
			Pii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};						 	
			
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        	
		,{i,T}];
		
		lik = -lik/2 + lik0;
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		PISUM = 0;
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			(*{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
								     {Yii,Pii,Yi1i,Pi1i},Astern];*)
			Piin  = Pii[[1]];	
			Pi1in = Pi1i[[1]];
			PGn   = PGalt[[1]];
			Pistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
			
			YGalt = Yii + Pistern.(YGalt - Yi1i);
			PGalt = {Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]};
			PISUM += Pistern.PGn;
			(*Pistern.PGn//Transpose//Print;*)
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			(*PG//TableForm//Print;*)
		
		,{i,T,1,-1}];
		
		PISUM = PISUM//Transpose;
		
		{YG,PG,PISUM,lik}
	]

(***************************************************************)			 
MFilter5[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_,LC_]:=
(***************************************************************)			 
(* NUR BERECHNUNG DER LIKELIHOOD *)
 
	Module[{np,k,p,q,Yii,Pii,i,ON,Yi1i,Pi1i,lik,liki},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = Length[P0];
		
		(*{k,p,q,n,np}//Print;*)
		
		Yii = Y0;
		Pii = P0;
		lik = 0;
		ON  = Array[1&,{np}] /. 1->Ostern;
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
					
	        {Yii,Pii,liki} = 
	        	MessUp5[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,LC[[i+1]],{k,p,q,n,np}];
	        
	        lik += liki;
	        
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{lik}
	]

(***************************************************************)			 
Filter5[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:=
(***************************************************************)			 
(* NUR BERECHNUNG DER LIKELIHOOD *)
 
	Module[{k,p,q,Yii,Pii,i,Yi1i,Pi1i,lik,liki,IP},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		
		(*Print["*Filter5",{k,p,q,n}];*)
		
		Yii = Y0;
		Pii = P0[[1]];
		lik = 0;
		IP = IdentityMatrix[p];
	
		Do[ 
			(*Time Update*)
			
			Yi1i = Astern.Yii + Bstern.X[[i]];
			Pi1i = Astern.Pii.Transpose[Astern]+Ostern;
			
			
			(*Mess-Update*)
					
			vint = H . Pi1i . Transpose[H] + R;
			
			Check[
			vi1 = PseudoInverse[vint],
			Interrupt[] 
			];
			
			gain = Pi1i . Transpose[H] . vi1;
			inn = Z[[i+1]] - H . Yi1i - D . X[[i+1]];
			liki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
			Yii = Yi1i + gain.inn;
			ikh = IP - gain.H;
			Pii = ikh.Pi1i.Transpose[ikh] + gain . R . Transpose[gain];						 	
			
	        lik += liki
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{lik}
	]






MLIKEX//Clear
(***************************************************************)
MLIKEX[Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,PSI_,NONLIN_,MISS_,LC_] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD MIT MISSING DATA*)
Module[{THETA,PHI,OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,
		Z0,X0,MUEN,SIGMAN,Y0,P0,LIK,LIK0},
		
{THETA,PHI}=PSI;
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN=(Array[1&,{NP}] /. 1->SIGMA);
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,MISS];
LIK = MFilter5[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R,N,T,MISS,LC];
LIK=LIK + LIK0
]


cMLIKEX//Clear
(***************************************************************)
cMLIKEX[Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,PSI_,NONLIN_,MISS_,LC_] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD MIT MISSING DATA, c-Impl*)

Module[{THETA,PHI,OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,
        LIK,Z1,X1},

{THETA,PHI}=PSI;		
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];

Z1=Transpose[Z,{2,3,1}]; (*kTN->NTk*)
X1=Transpose[X,{2,3,1}];


LIK = Apply[Plus,
      MapThread[cKF[{#1,#2}, _,{{ASTERN,BSTERN, V, H, D, R, MUE, SIGMA},
                {K, P, Q, 1, T}}, {MISS, 1}]&,
                {Z1, X1}]];
                
{LIK}    
    

]



cMLIKEX//Clear
(***************************************************************)
cMLIKEX[{Z_,X_},PSI_,{PAR_,PARM_,DT_,NONLIN_},MISS_:-9] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD MIT MISSING DATA, c-Impl*)
(* Panel-Daten NxTxk                        *)
(* kompatibel zu Kalman.Exakt.impl          *)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,LIK,
        N,T,K,P,Q},
		
{OMEGA,A,B,SIGMA,MUE} = PAR[PSI];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PSI];

{K,P}=H//Dimensions;
{K,Q}=D//Dimensions;
{N,T,K}=Z//Dimensions;
T=T-1;

{OMEGA,A,B,SIGMA,MUE}//Print;
{V,ASTERN,BSTERN}//Print;
{R,H,D}//Print;


LIK = Apply[Plus,
      MapThread[cKF[{#1,#2},_,{{ASTERN,BSTERN, V, H, D, R, MUE, SIGMA},
                {K, P, Q, 1(*dummy*), T}}, {MISS, 1}]&,
                {Z, X}]];
                
LIK   
    
]

LIKEX//Clear
(***************************************************************)
LIKEX[Z_,X_,K_,P_,Q_,N_,T_,DT_,PSI_,NONLIN_] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD OHNE MISSING DATA*)
Module[{THETA,PHI,OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,
		Z0,X0,MUEN,SIGMAN,Y0,P0,LIK,LIK0},
		
{THETA,PHI}=PSI;
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN={SIGMA};
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9];
LIK = Filter5[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R,N,T];
LIK=LIK + LIK0
]


FilterX//Clear
(***************************************************************)
FilterX[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
(***************************************************************)
(* ohne TimeUp etc...*)
	Module[{T,k,p,q,YF,PF,i,i1,Yii,Pii,Yi1i,Pi1i,
			lik,liki},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		{p,n} = Dimensions[Y0];
		T = Length[Z] - 1;
		
		{k,p,q,n,T}//Print;
		
		Yii = Y0;
		YF = Shape[1,{T+1}];
		YF[[1]]  = Y0;
		Pii = P0[[1]];
		PF  = Shape[1,{T+1}];
		PF[[1]] = P0;
		lik = 0;
		
	
		Do[ 
			(*Time Update*)
			
			(*{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,{Ostern}];*)
			
			Yi1i = Astern.Yii + Bstern.X[[i]];
			Pi1i = Astern.Pii.Transpose[Astern] + Ostern;
			
			(*Mess-Update*)
					
	        (*{Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];*)
	        	
			vint = H . Pi1i . Transpose[H] + R;
			vi1 = Inverse[vint];
			gain = Pi1i . Transpose[H] . vi1;
			i1 = i+1;
			inn = Z[[i1]] - H . Yi1i - D . X[[i1]];
			liki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
			Yii = Yi1i + gain.inn;
			ikh = IdentityMatrix[p] - gain.H;
			Pii = ikh.Pi1i.Transpose[ikh] + 
				  gain . R . Transpose[gain];						 	
			
	        lik += liki;
	        
	        YF[[i1]] = Yii;
	        PF[[i1]] = {Pii};
	        	
		,{i,T}];
		
		
		lik = -.5 lik;
		{YF,PF,lik}
	]

(***************************************************************)
GlattX[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
(***************************************************************)
(* ohne TimeUp etc...*)
	Module[{T,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
			lik,liki},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		{p,n} = Dimensions[Y0];
		T = Length[Z] - 1;
		
		{k,p,q,n,T}//Print;
		
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = {Ostern};
	
		Do[ 
			(*Time Update*)
			
			(*{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];*)
			
			Yi1i = Astern.Yii + Bstern.X[[i]];
			Pi1i = Astern.Transpose[Pii,{2,1,3}].Transpose[Astern];
			Pi1i = Transpose[Pi1i,{2,1,3}] + ON;
			
			(*Mess-Update*)
					
	        (*{Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];*)
	        	
	        pi1in = Pi1i[[1]]; 
			vint = H . pi1in . Transpose[H] + R;
			vi1 = Inverse[vint];
			gain = pi1in . Transpose[H] . vi1;
			inn = Z[[i+1]] - H . Yi1i - D . X[[i+1]];
			liki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
			Yii = Yi1i + gain.inn;
			ikh = IdentityMatrix[p] - gain.H;
			Pii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};						 	
			
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        	
		,{i,T}];
		
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			(*{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
								     {Yii,Pii,Yi1i,Pi1i},Astern];*)
			Piin  = Pii[[1]];	
			Pi1in = Pi1i[[1]];
			PGn   = PGalt[[1]];
			Pistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
			
			YGalt = Yii + Pistern.(YGalt - Yi1i);
			PGalt = {Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]};
	
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			(*PG//TableForm//Print;*)
		
		,{i,T,1,-1}];
		
		lik = -.5 lik;
		{YG,PG,YF,PF,lik}
	]

(***************************************************************)
MGLATT1[Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,THETA_,PHI_,NONLIN_,MISS_] :=
(***************************************************************)
(* NP=1: ALLE N GLEICH *)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,Y0,P0,LIK0,LIK,
		Z0,MUEN,SIGMAN,X0,YG,PG,YF,PF},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]]; 
Z0//Print;
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN=(Array[1&,{NP}] /. 1->SIGMA);
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,MISS];
Y0//Print;
P0//Print;
{YG,PG,YF,PF,LIK} = MGlattFold[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R,N,T,MISS];
LIK=LIK + LIK0;

{YG,PG,YF,PF,LIK}
]

(***************************************************************)
GLATT1[Z_,X_,K_,P_,Q_,N_,T_,DT_,THETA_,PHI_,NONLIN_] :=
(***************************************************************)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,Y0,P0,LIK0,LIK,
		Z0,MUEN,SIGMAN,X0,YG,PG,YF,PF},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN={SIGMA};
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9];
{YG,PG,YF,PF,LIK} = Glatt[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R];
LIK=LIK + LIK0;

{YG,PG,YF,PF,LIK}
]

aprioriFilter//Clear;
aprioriFilter[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
	Module[{np,k,p,q,i,OsternN,Yi1i,Pi1i,lik,liki,inno,innocov,innocov1,
			Inno,Innocov,Innocov1,gain,L,Li,Y1,P1},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = 1; (* ohne missing *)
		
		(*Print["aprioriFilter",{k,p,q,n,np}];*)
		
		Y1 = Shape[1,{T+2}] /. 1->Y0;
		Yi1i = Y0;
		P1 = Shape[1,{T+2}] /. 1->P0;
		Pi1i = P0[[1]];
		lik = 0;
		OsternN  = Array[1&,{np}] /. 1->Ostern;
		Inno = Shape[1,{T+1}];
		Innocov1 = Inno;
		L = Inno;
	
		Do[ 
			
			inno = Z[[i]] - H.Yi1i -  D.X[[i]];
			innocov = H.Pi1i.Transpose[H]+ R;
			innocov1 = Inverse[innocov];
			gain = Astern.Pi1i.Transpose[H].innocov1;
			Li = Astern - gain.H;
			Yi1i = Astern.Yi1i + Bstern.X[[i]] + gain.inno;
			(* Pi1i = Astern.Pi1i.Transpose[Li] + Ostern; *)
			
			(*Joseph stabilized*)
			Pi1i = Li.Pi1i.Transpose[Li] + gain.R.Transpose[gain] + Ostern;
			
			liki = n Log[Det[innocov]] + 
				   MatrixTrace[innocov1 . (inno . Transpose[inno])];
	        lik += liki;
	        Y1[[i+1]] = Yi1i;
	        P1[[i+1]] = {Pi1i};
	        Inno[[i]] = inno;
	        Innocov1[[i]] = innocov1;
	        L[[i]] = Li;
	        	
		,{i,1,T+1}];
		
		lik = -.5 lik;
		Y1 = Drop[Y1,-1];
		YP = Drop[P1,-1];	
			
		{Y1,P1,Inno,Innocov1,L,lik}
	]

	
	
GlattDeJong//Clear;
GlattDeJong[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
	Module[{np,k,p,q,i,pi1i,lik,Y1,P1,Inno,
			Innocov1,L,Li,ri,Ri,YG,PG,HI,LiT},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = 1; (* ohne missing *)
		{k,p,q,n,np}//Print;
		
		
		
		YG = Shape[1,{T+1}];	
		PG = Shape[1,{T+1}];
		{Y1,P1,Inno,Innocov1,L,lik} = 
			aprioriFilter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,n,T];
		
		ri = Shape[0,{p,n}];
		Ri = Shape[0,{p,p}];
		
		Do[ 
			
			HI = Transpose[H].Innocov1[[i]];
			Li = L[[i]];
			LiT = Li//Transpose;
			ri = HI.Inno[[i]] + LiT.ri;
			Ri = HI.H + LiT.Ri.Li;
			pi1i = P1[[i,1]];
			YG[[i]] = Y1[[i]] + pi1i.ri;
			PG[[i]] = {pi1i - pi1i.Ri.pi1i};	
			
		,{i,T+1,1,-1}];
		
			
		{YG,PG,lik}
	]

GlattDeJong5//Clear;
GlattDeJong5[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
	Module[{np,k,p,q,i,pi1i,lik,Y1,P1,Inno,
			Innocov1,L,Li,ri,Ri,YG,PG,PISUM,RR,id,HI,LiT,Ripi1i},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = 1; (* ohne missing *)
		Print["*GlattDeJong5 {k,p,q,n} ",{k,p,q,n}];
		
		
		
		YG = Shape[1,{T+1}];	
		PG = Shape[1,{T+1}];
		{Y1,P1,Inno,Innocov1,L,lik} = 
			aprioriFilter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,n,T];
		
		ri = Shape[0,{p,n}];
		Ri = Shape[0,{p,p}];
		id = IdentityMatrix[p];
		PISUM = 0;
		
		Do[ 
			
			HI = Transpose[H].Innocov1[[i]];
			Li = L[[i]];
			LiT = Li//Transpose;
			ri = HI.Inno[[i]] + LiT.ri;
			Ri = HI.H + LiT.Ri.Li;
			pi1i = P1[[i,1]];
			YG[[i]] = Y1[[i]] + pi1i.ri;
			Ripi1i = Ri.pi1i;
			PG[[i]] = {pi1i - pi1i.Ripi1i};	
		
			PISUM += P1[[i-1,1]].Transpose[L[[i-1]]].(id - Ripi1i);
	
		,{i,T+1,2,-1}];
		
		
		    i = 1;
			HI = Transpose[H].Innocov1[[i]];
			Li = L[[i]];
			LiT = Li//Transpose;
			ri = HI.Inno[[i]] + LiT.ri;
			Ri = HI.H + LiT.Ri.Li;
			pi1i = P1[[i,1]];
			YG[[i]] = Y1[[i]] + pi1i.ri;
			Ripi1i = Ri.pi1i;
			PG[[i]] = {pi1i - pi1i.Ripi1i};	
		
		
		{YG,PG,PISUM//Transpose,lik}
	]

(***************************************************************)
linind[i_,j_,I_,J_]:= (i-1) J + j
(***************************************************************)

(***************************************************************)
tree[i_,j_,I_,J_] := Outer[linind[#1,#2,I,J]&,i,j] // Flatten
(***************************************************************)


	20//Range
	tree[{1,2,4},{1,3,5},4,5]





KOMPNT//Clear;
(***************************************************************)
KOMPNT[H_,D_,R_,DH_,DD_,DR_,K_,P_,Q_,LC_] := 
(***************************************************************)
Module[{HNT,DNT,RNT,R1,DHNT,DDNT,DRNT,U,UU},
U = Length[DH]; UU = U//Range; 
HNT =H[[LC]];
DNT =D[[LC]];
RNT =R[[LC,LC]];
R1  =Inverse[RNT];
DRNT=DR[[UU,tree[LC,LC,K,K] ]]; 
DHNT=DH[[UU,tree[LC,P//Range,K,P] ]];
DDNT=DD[[UU,tree[LC,Q//Range,K,Q] ]];

{HNT,DNT,RNT,R1,DHNT,DDNT,DRNT}
]





(***************************************************************)
MISSCORE[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,NP_,T_,DT_,NONLIN_,
		  MISS_,{LC_,messindTN_,messindT_}]:=
(***************************************************************)
(*SCORE MIT MISSING DATA: STREICH-METHODE*)
(* NP=1: ALLE N GLEICHES MESS-SCHEMA BEI DEN ZEITPUNKTEN *)

Module[{PP,PQ,NT,NPP,OMEGA,A,B,SIGMA,MUE,DVDTH,DASDTH,DBSDTH,DSIGDTH,
		DMUEDTH,V,ASTERN,BSTERN,V1,SIGMA1,R,H,D,DR,DH,DD,RSUM,HSUM,
		DSUM,U1,U2,SS,SM,T1,MUEN,SIGMAN,YG,PG,PISUM,LIK,t,n,S,YGYG,
		YGT,YG0,YG1,SY0Y0,SY1Y1,SY1Y,SY1X,lcalt,lc,ZI,YI,XI},

PP =P P;
PQ =P Q;
NT =N T;
NPP=1+N-NP;

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
          V,ASTERN,BSTERN,SIGMA,MUE} = ABL01[THETA,DT,NONLIN];
V1=Inverse[V];
SIGMA1=Inverse[SIGMA];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];

U1=Length[THETA];
U2=Length[PHI];
SM=Array[0&,{U2}];
T1=T+1;
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose; 
SIGMAN=(Array[1&,{NP}] /. 1->SIGMA);

{YG,PG,PISUM,LIK} = 
	MGLATT5[Z,X,ASTERN,BSTERN,V,MUEN,SIGMAN,H,D,R,N,T,MISS,LC];
	
    (*YGYG = Sum[YG[[i]].Transpose[YG[[i]]],{i,T1}];*)
YGYG = product[YG];	
	
PGSUM=Sum[PG[[i,j]],{i,T1},{j,NP}];
YGYG =YGYG + NPP PGSUM;   (* Summe E[Y|Z] E[Y|Z]` + Cov[Y,Y|Z] *)
YGT  =YG[[T1]];
YG0  =YG[[1]];
YG1  =Drop[YG,1];
SY0Y0=YG0.Transpose[YG0] + NPP Sum[PG[[1,n]],{n,1,NP}]; 
SY1Y1=YGYG - SY0Y0;

SY1Y =product[YG1,Drop[YG,-1]] + NPP PISUM;		
SY1X =product[YG1,Drop[ X,-1]];
SYY  =YGYG - YGT.Transpose[YGT] - NPP Sum[PG[[T1,n]],{n,1,NP}];
SYX  =product[Drop[YG,-1],Drop[ X,-1]];
   
If[PHI =!= {},

lcalt = {};
If[ NP==1,
	(* ALLE N SIMULTAN *)
	Do[  
      {t} = messindT[[i]];
      lc = LC[[t,1]];
      If[lc != lcalt,{HNT,DNT,RNT,R1,DHNT,DDNT,DRNT} = 
      								  KOMPNT[H,D,R,DH,DD,DR,K,P,Q,lc] ];
      ZI =Z[[t,lc,N//Range]];
      YI =YG[[t,P//Range,N//Range]];
      XI =X[[t,Q//Range,N//Range]];
      ZZ =ZI.Transpose[ZI];
      ZY =ZI.Transpose[YI];
      ZX =ZI.Transpose[XI];
      YY =YI.Transpose[YI] + N PG[[t,1]];
      YX =YI.Transpose[XI];
      XX =XI.Transpose[XI];
	  {RDACH,H1,H2,H3} = VDACH[HNT,DNT,{ZZ,ZY,ZX,YY,YX,XX}];
      	     
	  SM += -.5 DRNT.Flatten[R1.(N RNT-RDACH).R1]
           	  + DHNT.Flatten[R1.H2]
           	  + DDNT.Flatten[R1.H3];

      lcalt = lc;
      
	,{i,1,Length[messindT]}]
	
,(*ELSE*)

	Do[ 
      	{t,n} = messindTN[[i]];
      	lc = LC[[t,n]];
     	 
      	If[lc != lcalt, {HNT,DNT,RNT,R1,DHNT,DDNT,DRNT} = 
     		  						  KOMPNT[H,D,R,DH,DD,DR,K,P,Q,lc] ];
     	ZI = Z[[t,lc,n]];
     	YI =YG[[t,P//Range,n]];
     	XI = X[[t,Q//Range,n]];
     	ZZ =Outer[Times,ZI,ZI];
     	ZY =Outer[Times,ZI,YI];
     	ZX =Outer[Times,ZI,XI];
      	YY =Outer[Times,YI,YI] + PG[[t,n]];
      	YX =Outer[Times,YI,XI];
		XX =Outer[Times,XI,XI];
	
        {RDACH,H1,H2,H3} = VDACH[HNT,DNT,{ZZ,ZY,ZX,YY,YX,XX}];

      	SM += -.5 DRNT.Flatten[R1.(RNT-RDACH).R1]
           		+ DHNT.Flatten[R1.H2]
           		+ DDNT.Flatten[R1.H3];

     	lcalt = lc;
      
	,{i,Length[messindTN]}]
];

]; (* End If[PHI =!= {} *)
  
(* MOMENTE DER AB.*)

SY0  = Sum[YG0[[P//Range,n]],{n,N}];
S0   = -Outer[Times,SY0,MUE];
S0   = S0 + Transpose[S0] + SY0Y0 + N Outer[Times,MUE,MUE];

{vd,H1,H2,H3} =  VDACH[ASTERN,BSTERN,{SY1Y1,SY1Y,SY1X,SYY,SYX,SXX}];

 SS=  -   .5 DVDTH.Flatten[V1.(NT V - vd).V1]
      +     DASDTH.Flatten[V1.H2]
      +     DBSDTH.Flatten[V1.H3]
      - .5*DSIGDTH.Flatten[SIGMA1.(N SIGMA-S0).SIGMA1]
      +    DMUEDTH.SIGMA1.(SY0-N MUE);
      
If[PHI =!= {}, S=Join[SS,SM], S=SS];

{S,LIK} ]

(***************************************************************)
product[y_]:= Module[{y1,t,p,n},
(***************************************************************)
		{t,p,n} = y//Dimensions;
		y1 = Partition[Flatten[Transpose[y,{1,3,2}]],p];
        Transpose[y1].y1 ]
(***************************************************************)
product[y_,x_]:= Module[{y1,t,p,n,q},
(***************************************************************)
		{t,p,n} = y//Dimensions;
		{t,q,n} = x//Dimensions;
		y1 = Partition[Flatten[Transpose[y,{1,3,2}]],p];
		x1 = Partition[Flatten[Transpose[x,{1,3,2}]],q];
        Transpose[y1].x1 ]

(***************************************************************)
score[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,T_,DT_,NONLIN_]:=
(***************************************************************)

Module[{PP,PQ,NT,NPP,OMEGA,A,B,SIGMA,MUE,DVDTH,DASDTH,DBSDTH,DSIGDTH,
		DMUEDTH,V,ASTERN,BSTERN,V1,SIGMA1,R,H,D,DR,DH,DD,RSUM,HSUM,
		DSUM,U1,U2,SS,SM,T1,MUEN,SIGMAN,YG,PG,PISUM,LIK,t,n,S,YGYG,
		YGT,YG0,SY0Y0,SY1Y1,SY1Y,SY1X},

NT =N T;
NT1=NT + N;
T1 =T+1;

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];  
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
          V,ASTERN,BSTERN,SIGMA,MUE} = ABL01[THETA,DT,NONLIN];
          
V1=Inverse[V];
SIGMA1=Inverse[SIGMA];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];
R1 = Inverse[R];

MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose; 
SIGMAN={SIGMA};
(*
{YG,PG,PISUM,LIK} = GLATT5X[Z,X,ASTERN,BSTERN,V,MUEN,SIGMAN,H,D,R,N,T];
*)	
(*Print["vor GlattDeJong5"];*)
{YG,PG,PISUM,LIK} = GlattDeJong5[MUEN,SIGMAN,Z,X,ASTERN,BSTERN,V,H,D,R,N,T];

	(* YGYG = Sum[YG[[i]].Transpose[YG[[i]]],{i,T1}]; *)
    (* YGYG = Apply[Plus,MapThread[Dot,{YG, Transpose[YG,{1,3,2}]  }] ];*)
	(* Summe YG[[i]].Transpose[YG[[i]] ]: pxp *)
	
YGYG = product[YG];	
PGSUM= Sum[PG[[i,1]],{i,T1}];
YGYG = YGYG + N PGSUM;   (* Summe E[Y|Z] E[Y|Z]` + Cov[Y,Y|Z] *)
YGT  = YG[[T1]];
XT   =  X[[T1]];
YG0  = YG[[1]];
YG1  = Drop[YG,1];

SY0Y0= YG0.Transpose[YG0] + N PG[[1,1]]; 
SY1Y1= YGYG - SY0Y0;

SY1Y = product[YG1,Drop[YG,-1]] + N PISUM;		
SY1X = product[YG1,Drop[ X,-1]]; 
SYY  = YGYG - YGT.Transpose[YGT] - N PG[[T1,1]] ;
SYX  = product[YG,X];
SYX1 = SYX - YGT.Transpose[XT];
 
If[PHI =!= {},
	SZZ  = product[Z]; 
	SZY  = product[Z,YG];
	SZX  = product[Z,X];
	
	SXX1 = SXX +  XT.Transpose[XT];
	{RDACH,H1,H2,H3} = VDACH[H,D,{SZZ,SZY,SZX,YGYG,SYX,SXX1}];
      	     
	SM =  -.5  DR.Flatten[R1.(NT1 R - RDACH).R1]
	         + DH.Flatten[R1.H2]
 	         + DD.Flatten[R1.H3];
]; 
 
(* MOMENTE DER AB.*)

SY0  = Sum[YG0[[P//Range,n]],{n,N}];
S0   = -Outer[Times,SY0,MUE];
S0   = S0 + Transpose[S0] + SY0Y0 + N Outer[Times,MUE,MUE];

{vd,H1,H2,H3} =  VDACH[ASTERN,BSTERN,{SY1Y1,SY1Y,SY1X,SYY,SYX1,SXX}];

 SS=  -    .5 DVDTH .Flatten[V1.(NT V - vd).V1]
      +       DASDTH.Flatten[V1.H2]
      +       DBSDTH.Flatten[V1.H3]
      -    .5 DSIGDTH.Flatten[SIGMA1.(N SIGMA-S0).SIGMA1]
      +       DMUEDTH.SIGMA1.(SY0-N MUE);

If[PHI =!= {}, S=Join[SS,SM], S=SS];

{S,LIK} ]


(***************************************************************)
MISSHES1[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,NP_,T_,DT_,INC_,
		 				NONLIN_,MISS_,{LC_,messindTN_,messindT_}] :=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT ANALYTISCHEM SCORE:  *)
(* ZENTRALE DIFFERENZEN                             *)
(*  S(PSI,Z) = E[S(THETA)//S(PHI)|Z]                *)
(* VORSICHT: E(H) = -E(SS`) = -F !!!				*)

Module[{S,H,LIK,PSI,psi,U,U1,U2,INK,INC1,SNUM,UP,DO,THUP,PHUP,DS},

{S,LIK} = MISSCORE[THETA,PHI,Z,X,SXX,K,P,Q,N,NP,T,DT,NONLIN,
		  								  MISS,{LC,messindTN,messindT}];
PSI={THETA,PHI};
psi = PSI//Flatten;
U = Length[psi];
U1 = Length[THETA];
U2 = Length[PHI];

INK=INC Abs[psi];
INC1=.5/INK;
H = {}; SNUM = {};

Do[
    UP=psi;
    DO=psi;
    UP[[I]] = UP[[I]]+INK[[I]] ;
    DO[[I]] = DO[[I]]-INK[[I]] ;
    {THUP,PHUP} = {Take[UP,U1],Take[UP,-U2]};
    {THDO,PHDO} = {Take[DO,U1],Take[DO,-U2]};
    
    {SUP,LIKUP} = MISSCORE[THUP,PHUP,Z,X,SXX,K,P,Q,N,NP,T,DT,
    								NONLIN,MISS,{LC,messindTN,messindT}];
    {SDO,LIKDO} = MISSCORE[THDO,PHDO,Z,X,SXX,K,P,Q,N,NP,T,DT,
    								NONLIN,MISS,{LC,messindTN,messindT}];
    H = Append[H,(SUP-SDO) INC1[[I]] ];
    SNUM = Append[SNUM,(LIKUP-LIKDO) INC1[[I]]  ];
,{I,1,U}];

H = .5(H + Transpose[H]);
DS = S-SNUM;
Print[ "KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"];
Print[MatrixForm[{SNUM, S, DS, psi, INK }//Transpose,
	TableHeadings->{Automatic,{"SNUM","S","DS","PSI","INK"}}]];
{S,H,LIK}]

(***************************************************************)
HESSE[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,T_,DT_,INC_,NONLIN_] :=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT ANALYTISCHEM SCORE:  *)
(* ZENTRALE DIFFERENZEN                             *)
(*  S(PSI,Z) = E[S(THETA)//S(PHI)|Z]                *)
(* VORSICHT: E(H) = -E(SS`) = -F !!!				*)

Module[{S,LIK,PSI,psi,U,U1,U2,INK,INC1,H,SNUM,UP,DO,THUP,PHUP,THDO,PHDO,
		SUP,LIKUP,SDO,LIKDO,I},

{S,LIK} = score[THETA,PHI,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];
PSI={THETA,PHI};
psi = PSI//Flatten;
U = Length[psi];
U1 = Length[THETA];
U2 = Length[PHI];

INK=INC Abs[psi];
INC1=.5/INK;
H = {}; SNUM = {};

Do[
    UP=psi;
    DO=psi;
    UP[[I]] = UP[[I]]+INK[[I]] ;
    DO[[I]] = DO[[I]]-INK[[I]] ;
    {THUP,PHUP} = {Take[UP,U1],Take[UP,-U2]};
    {THDO,PHDO} = {Take[DO,U1],Take[DO,-U2]};
    {SUP,LIKUP} = score[THUP,PHUP,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];
    {SDO,LIKDO} = score[THDO,PHDO,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];
    H = Append[H,(SUP-SDO) INC1[[I]] ];
    SNUM = Append[SNUM,(LIKUP-LIKDO) INC1[[I]]  ];
,{I,1,U}];

H = .5(H + Transpose[H]);
DS = S-SNUM;
Print[ "KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"];
Print[MatrixForm[{SNUM, S, DS, psi, INK }//Transpose,
	TableHeadings->{Automatic,{"SNUM","S","DS","PSI","INK"}}]];
{S,H,LIK}]

(***************************************************************)			 
MSCNUM[THETA_,PHI_,Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,
									     INC_,NONLIN_,MISS_,LC_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE (MIT MISSING DATA) *)
Module[{i,PSI,PSII,LIK,LIKI,SNUM,u1},
PSI={THETA,PHI};
u1=Length[THETA];
u2=Length[PHI];
{LIK} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSI,NONLIN,MISS,LC];
INC1=1/INC;
SNUM = {};
Do[ 
    PSII=PSI//Flatten;
    PSII[[i]]=PSII[[i]]+INC;
    PSII = {Take[PSII,u1],Take[PSII,-u2]};
    
    {LIKI} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSII,NONLIN,MISS,LC];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1]
    
  ,{i,Length[THETA]+Length[PHI]} ];
  
{SNUM,LIK}
]

(***************************************************************)			 
SCNUM[THETA_,PHI_,Z_,X_,K_,P_,Q_,N_,T_,DT_,INC_,NONLIN_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE (MIT MISSING DATA) *)
Module[{i,PSI,PSII,LIK,LIKI,SNUM,u1},
PSI={THETA,PHI};
u1=Length[THETA];
u2=Length[PHI];
{LIK} = LIKEX[Z,X,K,P,Q,N,T,DT,PSI,NONLIN];
INC1=1/INC;
SNUM = {};
Do[ 
    PSII=PSI//Flatten;
    PSII[[i]]=PSII[[i]]+INC;
    PSII = {Take[PSII,u1],Take[PSII,-u2]};
    
    {LIKI} = LIKEX[Z,X,K,P,Q,N,T,DT,PSII,NONLIN];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1]
    
  ,{i,Length[THETA]+Length[PHI]} ];
  
{SNUM,LIK}
]

(***************************************************************)
DELTA1[COV_,TH_,PHI_] := Module[
(***************************************************************)
(*DELTA-THEOREM*)
{m,OMEGA,A,B,SIGMA,MUE,DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH,
 STDA,STDB,STDO,STDMUE,STDSIG,STDH,STDD,STDR,K,P,Q,U1,U2,U,
 R,H,D,DR,DH,DD},
 
{OMEGA,A,B,SIGMA,MUE} = PAR[TH];
{DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH} = PARD[TH];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];

{P,Q}=Dimensions[B];
{K,P}=Dimensions[H];

U1=Length[TH];
U2=Length[PHI];
U = U1 + U2;
C11=COV[[U1//Range,U1//Range]];
C22=COV[[Range[U1+1,U],Range[U1+1,U]  ]];
STDA=STANDARD[DADTH,C11,P,P];
STDB=STANDARD[DBDTH,C11,P,Q];
STDO=STANDARD[DODTH,C11,P,P];
STDMUE=STANDARD[DMUEDTH,C11,P,1];
STDSIG=STANDARD[DSIGDTH,C11,P,P];
STDH=STANDARD[DH,C22,K,P];
STDD=STANDARD[DD,C22,K,Q];
STDR=STANDARD[DR,C22,K,K];
m = MatrixForm[#,TableHeadings->None]&;
Print["----------------------------------------------------------"];
Print["DELTA-THEOREM"];
Print["----------------------------------------------------------"];
Print["GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"];
Print["A, B, OMEGA, SIGMA UND MUE"];
Print["UND DER MESS-MODELL-MATRIZEN H, D UND R"];
Print["----------------------------------------------------------"];
Print[" A     ",A//m,    "   STDA   ",STDA//m];
Print["----------------------------------------------------------"];
Print[" B     ",B//m,    "   STDB   ",STDB//m];
Print["----------------------------------------------------------"];
Print["OMEGA  ",OMEGA//m,"   STDO   ",STDO//m];
Print["----------------------------------------------------------"];
Print["MUE    ",MUE//m,  "   STDMUE ",STDMUE//m];
Print["----------------------------------------------------------"];
Print["SIGMA  ",SIGMA//m,"   STDSIG ",STDSIG//m];
Print["----------------------------------------------------------"];
Print[" H     ",H//m,    "   STDH   ",STDH//m];
Print["----------------------------------------------------------"];
Print[" D     ",D//m,    "   STDD   ",STDD//m];
Print["----------------------------------------------------------"];
Print[" R     ",R//m,    "   STDR   ",STDR//m];


];

(***************************************************************)
DELTA1[COV_,TH_,PHI_,LAMBDA_] := Module[
(***************************************************************)
(*DELTA-THEOREM*)
{m,OMEGA,A,B,SIGMA,MUE,DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH,
 STDA,STDB,STDO,STDMUE,STDSIG,STDH,STDD,STDR,K,P,Q,U1,U2,U,
 R,H,D,DR,DH,DD,CUTS,DCUTS},
 
{OMEGA,A,B,SIGMA,MUE} = PAR[TH];
{DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH} = PARD[TH];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];
CUTS  = PARCUT[LAMBDA];
DCUTS = PARCUTD[LAMBDA];

{P,Q}=Dimensions[B];
{K,P}=Dimensions[H];
KC = Length[CUTS//Flatten];

U1=Length[TH];
U2=Length[PHI];
U3=Length[LAMBDA];
U = U1 + U2 + U3;
C11=COV[[U1//Range,U1//Range]];
C22=COV[[Range[U1+1,U1+U2],Range[U1+1,U1+U2] ]];
C33=COV[[Range[U1+U2+1,U] ,Range[U1+U2+1,U]  ]];

STDA=STANDARD[DADTH,C11,P,P];
STDB=STANDARD[DBDTH,C11,P,Q];
STDO=STANDARD[DODTH,C11,P,P];
STDMUE=STANDARD[DMUEDTH,C11,P,1];
STDSIG=STANDARD[DSIGDTH,C11,P,P];
STDH=STANDARD[DH,C22,K,P];
STDD=STANDARD[DD,C22,K,Q];
STDR=STANDARD[DR,C22,K,K];
STDCUTS=STANDARD[DCUTS,C33,KC,1];

m = MatrixForm[#,TableHeadings->None]&;
Print["----------------------------------------------------------"];
Print["DELTA-THEOREM"];
Print["----------------------------------------------------------"];
Print["GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"];
Print["A, B, OMEGA, SIGMA UND MUE"];
Print["UND DER MESS-MODELL-MATRIZEN H, D UND R"];
Print["----------------------------------------------------------"];
Print[" A     ",A//m,    "   STDA   ",STDA//m];
Print["----------------------------------------------------------"];
Print[" B     ",B//m,    "   STDB   ",STDB//m];
Print["----------------------------------------------------------"];
Print["OMEGA  ",OMEGA//m,"   STDO   ",STDO//m];
Print["----------------------------------------------------------"];
Print["MUE    ",MUE//m,  "   STDMUE ",STDMUE//m];
Print["----------------------------------------------------------"];
Print["SIGMA  ",SIGMA//m,"   STDSIG ",STDSIG//m];
Print["----------------------------------------------------------"];
Print[" H     ",H//m,    "   STDH   ",STDH//m];
Print["----------------------------------------------------------"];
Print[" D     ",D//m,    "   STDD   ",STDD//m];
Print["----------------------------------------------------------"];
Print[" R     ",R//m,    "   STDR   ",STDR//m];
Print["----------------------------------------------------------"];
Print[" CUTS  ",CUTS//Spalte//m, "   STDCUTS   ",STDCUTS//m];


];

(***************************************************************)			 
BFGSUP[F_,SNEU_,S_,STEP_] := Module[{ETA,MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)			 
ETA = 10^-4; (*NOISE LEVEL*)
MACHEPS2 = 10.^-8;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < ETA, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print["*BFGSUP ", A,"  ", B];
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]

BFGSUP[IdentityMatrix[4],{1.001,2,3,4},{1,2,3,4},{0.01,0,0,0}]//MatrixForm



(***************************************************************)			 
MBFGS[THETA0_,PHI0_,F0_,KMAX_,EPS_,Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,
		OPTION_,NONLIN_,MISS_,PRINT_] := 
(***************************************************************)			 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,SXX,u1,u2,U,PSI0,PSI,F,
        S,LIKALT,SNUM,LIKLIK,LIKI,psii,psi,STEPL,STEP,psi1,PSI1,
        LIKNEU,SNEU,likpsi,I,COV,k,THETA,PHI,LIKELI},
INC=10.^-5;
MAXSTEP=10.^1;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;

SXX=Sum[X[[i]].Transpose[X[[i]] ],{i,T}];

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: MBFGS***************************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,K,P,Q,N,NP,T,DT,OPTION,NONLIN,MISS,MAXSTEP,
		  MINSTEP,BOUND}//Spalte,
         {"KMAX","EPS","K","P","Q","N","NP","T","DT","OPTION","NONLIN",
         "MISS","MAXSTEP","MINSTEP","BOUND"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0];
Print[ "STARTWERT PHI0   = ", PHI0];
];

u1 = Length[THETA0];
u2 = Length[PHI0];
U = u1+u2;

PSI0={THETA0,PHI0};
PSI=PSI0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{LC,messindTN,messindT} = analyze[Z,MISS];


{S,LIKALT} = MISSCORE[ THETA0,PHI0,Z,X,SXX,K,P,Q,N,NP,T,DT,NONLIN,
					   MISS,{LC,messindTN,messindT}];

{SNUM,LIKLIK} = MSCNUM[THETA0,PHI0,Z,X,K,P,Q,N,NP,T,DT,10.^-8,
						NONLIN,MISS,LC];
					
Print["KONTROLLE",MatrixForm[{SNUM,S,S-SNUM}//Transpose,
		TableHeadings->{Automatic,{"SNUM","S","DS"}}]];
Print["Likelihoods  ",LIKALT,"  ",LIKLIK];

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,

	If[PRINT[[2]] == 1, 
	Print["-----------------------------------------------------------------"];
    Print["MBFGS: Iteration = ",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psi = PSI//Flatten;
    psii=Append[psii,psi];
    
 	STEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-HALVING*)
   
    psi1 = psi + STEP;   (*VOLLER NEWTON-STEP*)
    PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
    {LIKNEU} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSI1,NONLIN,MISS,LC];
   
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
         STEP=STEP*.5;
         psi1 = psi + STEP;
         PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
         {LIKNEU} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSI1,NONLIN,MISS,LC];
         
         If[PRINT[[3]] == 1,
         Print["STEP-HALVING:  ",half,
         			"  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			"  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
         
     ]; (*End DoWhile*)
     
	If[PRINT[[4]] == 1,
	Print[""]; 
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];
    
    Print["LIKNEU - LIKALT  ", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    If[PRINT[[5]] == 1,
    Print[""]; 
    Print[TableForm[{psi1,psi,STEP,S}//Transpose,
                     TableDirections\[Rule]Column,
                     TableSpacing\[Rule]Automatic,
    	             TableHeadings->{Automatic,{"PSI1","PSI","STEP","SCORE"}}]];
    ];
    
    If[PRINT[[6]] == 1,
    Print["Fisher Information"];
    MatPrint[F];
    ];
    
    {THETA,PHI}=PSI1;
    {SNEU,LIKALT} = MISSCORE[THETA,PHI,Z,X,SXX,K,P,Q,N,NP,T,DT,NONLIN,
					   					 MISS,{LC,messindTN,messindT}];
    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S=SNEU;
    
    PSI=PSI1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ "MBFGS:  ENDE DER ITERATION  ",k,"  ",KMAX];
];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,PSI//Flatten];
likpsi = Spalte[LIKI] ~ii~ psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
					TableHeadings->{Automatic,{"Likelihood","PSI"}}]];
];
					
{THETA,PHI}=PSI;

If[Fisher,
	Do[
	
	INC=10.^(-I);
	Print["INKREMENT   ", INC];
	{S,F,LIKELI} = MISSHES1[THETA,PHI,Z,X,SXX,K,P,Q,N,NP,T,DT,INC,
									NONLIN,MISS,{LC,messindTN,messindT}];
	F=-F;
	COV = OUTPUT[PSI//Flatten,F,.05,S,LIKELI];
	LKOMP[LIKELI,U,N*(T+1)];
	DELTA1[COV,THETA,PHI];
	
	,{I,6,6}];
	
,(* else *)
	COV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,PHI,COV,likpsi,k}
]


MAXSTEP=10.^0;
STEPREDUCE=4;

(***************************************************************)			 
BFGS[THETA0_,PHI0_,F0_,KMAX_,EPS_,Z_,X_,K_,P_,Q_,N_,T_,DT_,
		OPTION_,NONLIN_,PRINT_,NUMABL_:0] := 
(***************************************************************)			 
Module[{INC,MINSTEP,BOUND,ALPHA,SXX,u1,u2,U,PSI0,PSI,F,
        S,LIKALT,SNUM,LIKLIK,LIKI,psii,psi,STEPL,STEP,psi1,PSI1,
        LIKNEU,SNEU,likpsi,I,COV,k,THETA,PHI,LIKELI,MISS,NP},
INC=10.^-5;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;

SXX=Sum[X[[i]].Transpose[X[[i]] ],{i,T}];

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: BFGS***************************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,K,P,Q,N,T,DT}//Spalte,
         {"KMAX","EPS","K","P","Q","N","T","DT"}];
Print[ ""];
VecPrint[{OPTION,NONLIN,MAXSTEP,MINSTEP,BOUND}//Spalte,
         {"OPTION","NONLIN","MAXSTEP","MINSTEP","BOUND"}];
Print[ ""];
VecPrint[{STEPREDUCE,NUMABL}//Spalte,
         {"STEPREDUCE","NUMABL"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0];
Print[ "STARTWERT PHI0   = ", PHI0];
];

u1 = Length[THETA0];
u2 = Length[PHI0];
U = u1+u2;

PSI0={THETA0,PHI0};
PSI=PSI0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = score[ THETA0,PHI0,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];

INC = $MachineEpsilon//Sqrt;
{SNUM,LIKLIK} = SCNUM[THETA0,PHI0,Z,X,K,P,Q,N,T,DT,INC,NONLIN];

Print["KONTROLLE, INC = ",INC];
Print[MatrixForm[{SNUM,S,S-SNUM}//Transpose,
		TableHeadings->{Automatic,{"SNUM","S","DS"}}]];
Print["Likelihoods  ",LIKALT,"  ",LIKLIK];

If[NUMABL==1,S=SNUM];

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,

	If[PRINT[[2]] == 1, 
	Print["-----------------------------------------------------------------"];
    Print["BFGS: Iteration = ",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psi = PSI//Flatten;
    psii=Append[psii,psi];
    
 	STEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-HALVING*)
   
    psi1 = psi + STEP;   (*VOLLER NEWTON-STEP*)
    PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
    {LIKNEU} = LIKEX[Z,X,K,P,Q,N,T,DT,PSI1,NONLIN];
    
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
         STEP=STEP/STEPREDUCE;
         psi1 = psi + STEP;
         PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
         {LIKNEU} = LIKEX[Z,X,K,P,Q,N,T,DT,PSI1,NONLIN];
         
         If[PRINT[[3]] == 1,
         Print["STEP-HALVING:  ",half,
         			"  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			"  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
         
     ]; (*End DoWhile*)
     
    If[PRINT[[4]] == 1, 
	Print[""];
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];
    Print["LIKNEU - LIKALT  ", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    
    If[PRINT[[5]] == 1,
    Print[""]; 
    Print[TableForm[{psi1,psi,STEP,S}//Transpose,
                     TableDirections\[Rule]Column,
                     TableSpacing\[Rule]Automatic,
    	             TableHeadings->{Automatic,{"PSI1","PSI","STEP","SCORE"}}]];
    ];
    
    If[PRINT[[6]] == 1, 
    Print["Fisher Information"];
    MatPrint[F];
    ]; 
     
    {THETA,PHI}=PSI1;
    
    If[NUMABL==0,

    {SNEU,LIKALT}= score[THETA,PHI,Z,X,SXX,K,P,Q,N,T,DT,NONLIN],
    
    {SNEU,LIKALT} = SCNUM[THETA,PHI,Z,X,K,P,Q,N,T,DT,INC,NONLIN]
    ];

    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S=SNEU;
    
    PSI=PSI1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ "MBFGS:  ENDE DER ITERATION  ",k,"  ",KMAX];
];
LIKI = Append[LIKI,LIKALT]; psii = Append[psii,PSI//Flatten];
likpsi = Spalte[LIKI] ~ii~ psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
		TableHeadings->{Automatic,{"Likelihood","PSI"}}]];
];
					
{THETA,PHI}=PSI;

If[Fisher,
	Do[
	INC=10.^(-I);
	INC = $MachineEpsilon^(1/3);
	Print["INKREMENT   ", INC];
	{S,F,LIKELI} = HESSE[THETA,PHI,Z,X,SXX,K,P,Q,N,T,DT,INC,NONLIN];
	F=-F;
	COV = OUTPUT[PSI//Flatten,F,.05,S,LIKELI];
	LKOMP[LIKELI,U,N*(T+1)];
	DELTA1[COV,THETA,PHI];
	u1 = THETA//Length//Range;
	DELTASTERN[COV[[u1,u1]],THETA,DT,NONLIN];
	
	,{I,6,6}];

,(* else *)
	COV = Inverse[F];
];

{THETA,PHI,COV,likpsi,k}

]