(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

Unprotect["code`PARTest`*"];
Clear[    "code`PARTest`*"];
Remove   ["code`PARTest`Private`*"];



BeginPackage["code`PARTest`",
				{"code`Kronecker`", 
				 "code`LSD`",
				 "Statistics`DataManipulation`",
      			 "Statistics`NormalDistribution`",(*
                 "Statistics`InverseStatisticalFunctions`",*)
                 "Statistics`Common`DistributionsCommon`", 
                 "Statistics`DescriptiveStatistics`",                                       
                 "Global`"
                 }]



     
DMS::usage ="DMS, McDonald-Swaminathan-Ableitungen"

NEWTON::usage ="NEWTON, Scoring-Algorithmus"

MOMENT1::usage ="MOMENT1, Momentenmatrizen"

STERN01::usage ="STERN01"

STERN01R::usage ="STERN01R; reelle Arithm."


MatrixE1::usage = "MatrixE1[Lambda,Elt,dt], Returns E1 and DL1 =
	(lambdai - lambdaj)^-1"
                             
MatrixE2::usage = "MatrixE2[Lambda,Elt], Returns {E2,Lplus1,Eltplus}"

MatrixE3::usage = "MatrixE3[dt,DL1,E2,Eltplus,Lplus1], Returns E3"

PStern::usage = "PStern[Omega,A,B,dt], Stern-Matrizen "

Stern::usage = "Stern[Omega,A,B,dt], Stern-Matrizen"

ABL::usage = "ABL[THETA,dt], Returns 
	{DOSDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,Ostern,Astern,Bstern,SIGMA,MUE}"

VDACH::usage = " "
ABLIN::usage = " "
ABL01::usage = " "
LIKSTERN::usage = " "
SH::usage = " "
MOMENT1::usage = " "
SHIFT::usage = " "
STERNR::usage = " "
LINSTERN::usage = " "
STERN01::usage = " "
LIK2::usage = " "
DoUntil::usage = " "
DoWhile::usage = " "
SIGNI::usage = " "
VecPrint::usage = " "
LKOMP::usage = " "
OUTPUT::usage = " "
STANDARD::usage = " "
DELTA::usage = " "
DELTASTERN::usage = " "
NUMABL::usage = " "
ALIASING::usage = " "
MatrixLog::usage = "MatrixLog[A_]"
Indirekt::usage = "Indirekt[{Ostern_,Astern_,Bstern_}]"
L::usage = "L[A_,B_]: AxB+BxA"
SigmaStat::usage = "SigmaStat[A_,Omega_]: A.Sigma+Sigma.A'+Omega==0"





Begin["`Private`"]



(***************************************************************)
DMS[Y_,X_] := Outer[D,Y//Flatten,X//Flatten]//Transpose;	
(***************************************************************)
 







(***************************************************************)
MatrixE1[Lambda_,Elt_,dt_]:=
(***************************************************************)
	Module[{p,d1,DL1},
		p = Length[Lambda];
		d1 = Outer[Plus,Elt,-Elt] ;
		DL1 = Outer[Plus,Lambda,-Lambda] ;
		Do[ d1[[i,i]] = Elt[[i]]dt; DL1[[i,i]] = 1,{i,p} ];
		DL1 = 1/DL1;
		{d1 DL1,DL1}
	]
		

(***************************************************************)
MatrixE2[Lambda_,Elt_]:=
(***************************************************************)
	Module[{E2,Lplus1,Eltplus,p},
		p = Length[Lambda];
		Lplus1 = 1/Outer[Plus,Lambda,Lambda];
		Eltplus = Outer[Times,Elt,Elt];
		E2 = Lplus1 (Eltplus - Array[1&,{p,p}]);
		{E2,Lplus1,Eltplus}
	](*End E2*)


(***************************************************************)
MatrixE3[dt_,DL1_,E2_,Eltplus_,Lplus1_]:=
(***************************************************************)
	Module[{E3,p,AD},
	p = Length[E2];
	E3 = Array[0&,{p,p,p}];
	Do[ E3[[f]] = DL1 Outer[Plus, E2[[p//Range,f]], -E2[[p//Range,f]]]
		,{f,1,p} ];

	AD = (dt Eltplus - E2) Lplus1;
	
	Do[ E3[[f,a,a]] = AD[[f,a]], {a,1,p},{f,1,p} ];

	E3 = Transpose[E3,{2,1,3}];
	(*E3 = Shape[E3,{p^2,p}]*)
	Partition[E3//Flatten,p]
	]
		

(***************************************************************)
PStern[Omega_,A_,B_,dt_]:= 
(***************************************************************)
	Module[{Ostern,Astern,Bstern,A1,S,SS,S1,S1S,Lambda,Elt,E2,Lplus1,SOS,B1,p},
		p = Dimensions[A][[1]];
		{Lambda,S} = Eigensystem[A//N];  
		
		(* Print["EW von A",Lambda]; *)
		
		SS = S;
    	S = S//Transpose;
		Elt = Exp[Lambda dt];
		S1 = Inverse[S];
		S1S = Transpose[S1];
		SOS = S1.Omega.S1S;
		Astern = Re[S.DiagonalMatrix[Elt].S1];
		A1 = Re[S.DiagonalMatrix[1/Lambda].S1];
		B1 = A1.(Astern - IdentityMatrix[p]);
		Bstern = B1.B;
		{E2,Lplus1,Eltplus} = MatrixE2[Lambda,Elt];
		Ostern = Re[S.(E2 SOS).SS];
		{Ostern,Astern,Bstern,A1,S,S1,S1S,Lambda,Elt,E2,Lplus1,Eltplus,SOS,B1}
		
	](*End PStern*)

	
(***************************************************************)
Stern[Omega_,A_,B_,dt_]:=
(***************************************************************)
		Take[PStern[Omega,A,B,dt],3]
		

(***************************************************************)
ABL[THETA_,dt_] :=
(***************************************************************)
	Module[{OMEGA,A,B,SIGMA,MUE,OU,AU,BU,DSIGDTH,DMUEDTH,
			p,q,NULL,p2,Zweip,u,pq,pu,Ostern,Astern,Bstern,
			A1,S,S1,S1S,Lambda,Elt,E2,Lplus1,Eltplus,SOS,B1,
			E1,DL1,E3,SS,dia,jj,SSE,AUI,OUI,BUI,AST,S1AUIS,
			DOSDTH,DASDTH,DBSDTH},

	{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
	{OU,AU,BU,DSIGDTH,DMUEDTH} = PARD[THETA];  

	{p,q} = Dimensions[B];
	NULL = J[0,p,p];
	p2 = p^2;

	Zweip = 2p;
	u = Length[THETA];              (* DIM(THETA) *)
	pq = p*q;
	pu = p*u;
	
	
	{Ostern,Astern,Bstern,A1,S,S1,S1S,
 		Lambda,Elt,E2,Lplus1,Eltplus,SOS,B1} = PStern[OMEGA,A,B,dt];
 	
  
	{E1,DL1} = MatrixE1[Lambda,Elt,dt]; 

	E3 = MatrixE3[dt,DL1,E2,Eltplus,Lplus1];
	SS = KroneckerProduct[S,S];

	Lplus1 = .;

	dia = Range[1,p2+1,p+1];
	jj = J[1,p2,1];
	E2 = Partition[E2//Flatten,p2];
	SSE = SS KroneckerProduct[jj,E2];

	DASDTH = {};
	DBSDTH = {};
	DOSDTH = {};
	
	Do[ 
		(*
		AUI = Shape[AU[[i]],{p,p}];  (* SUBMATRIX AU(I)  *)
   	 	OUI = Shape[OU[[i]],{p,p}];  (* SUBMATRIX OU(I)  *)
    	BUI = Shape[BU[[i]],{p,q}];  (* SUBMATRIX BU(I)  *)
		*)
		AUI = Partition[AU[[i]],p];  (* SUBMATRIX AU(I)  *)
   	 	OUI = Partition[OU[[i]],p];  (* SUBMATRIX OU(I)  *)
    	BUI = Partition[BU[[i]],q]; 
    	
    	If[ all[AUI ~eq~ 0],
         	(* alle A fix*)
         
              FLAG1 = False;
              AST = NULL;
         
         		(*ELSE*),
         
              S1AUIS = S1.AUI.S;
              AST = S.(S1AUIS E1).S1;
              AST = Re[AST];
              FLAG1 = True;
     	];
     	
		DASDTH = Append[DASDTH, AST//Flatten] ;
           
    	dv = NULL;
    
    	If[ FLAG1,
    		
        	hilf =  SS.Apply[Plus,
        			KroneckerProduct[S1AUIS,SOS][[p2//Range ,dia]] E3,1];
        	hilf = Shape[Re[hilf],{p,p}];
        	dv = dv + hilf + Transpose[hilf];
        
    	];

     	If[ any[OUI ~ne~ 0], 
       
        	dv = dv + Shape[Re[SSE.Flatten[S1.OUI.S1S] ],{p,p}];
        
    	];

     	DOSDTH = Append[DOSDTH,Flatten[dv]];
     	FLAG3 = Not[all[BUI ~eq~ 0]]; 
        
     	If[FLAG1 == False, 
   
         	If[FLAG3 == False,
         		DBSDTH = Append[DBSDTH,Array[0&,{pq}]];
            	,(*ELSE*) 
            	DBSDTH = Append[DBSDTH,Flatten[B1.BUI]]; 
         	];
        
       	,(*ELSE*)
       
         If[FLAG3 == False,
            DBSDTH = Append[DBSDTH,
                          Flatten[A1.(-AUI.Bstern + AST.B)]]
         ,(*ELSE*)
            DBSDTH = Append[DBSDTH,
                          Flatten[A1.(-AUI.Bstern + AST.B) + B1.BUI]]
        ];
      ];


 	,{i,1,u} ];
           
	{DOSDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,Ostern,Astern,Bstern,SIGMA,MUE}

	] (*End ABL*)
		

(***************************************************************)
VDACH[ASTERN_,BSTERN_,{M11_,M12_,M13_,M22_,M23_,M33_}]:= 
(***************************************************************)

	Module[{vdach,H1,H2,H3},
		H1 = M11-ASTERN.Transpose[M12]-BSTERN.Transpose[M13];
		H2 = M12-ASTERN.M22 -          BSTERN.Transpose[M23];
		H3 = M13-ASTERN.M23 -          BSTERN.M33 ;
		vdach = H1-H2.Transpose[ASTERN]-H3.Transpose[BSTERN];
		{vdach,H1,H2,H3}
]

(***************************************************************)
ABLIN[THETA_,DT_] := Module[
(***************************************************************)
{OU,AU,BU,DSIGDTH,DMUEDTH,OMEGA,A,B,SIGMA,MUE,P,DVDTH,DASDTH,
DBSDTH,V,ASTERN,BSTERN},

{OU,AU,BU,DSIGDTH,DMUEDTH} = PARD[THETA];
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = LINSTERN[OMEGA,A,B,DT];

DASDTH=AU*DT;
DBSDTH=BU*DT;
DVDTH=OU*DT;

{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,V,
				ASTERN,BSTERN,SIGMA,MUE}
]
	

(***************************************************************)
ABL01[THETA_,DT_,NONLIN_] := Module[
(***************************************************************)
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,V,ASTERN,BSTERN,SIGMA,MUE},

{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,V,ASTERN,BSTERN,
	SIGMA,MUE} = If[NONLIN == 1,ABL[THETA,DT],ABLIN[THETA,DT] ]
]

(***************************************************************)
LIKSTERN[ASTERN_,BSTERN_,V_,MUE_,SIGMA_,M0_,M00_,M_,n_,T_] := 
	Module[
(***************************************************************)
(* LOG-LIKELIHOOD ALS FKT. DER *-PARAMETER *)
{LIKELI,vdach,H1,H2,H3,V1,SIGMA1,S0,DM,DV,DS},

{vdach,H1,H2,H3} = VDACH[ASTERN,BSTERN,M];
V1= Inverse[V];
SIGMA1=Inverse[SIGMA];
DM=M0-MUE;
S0=M00-Outer[Times,M0,M0]+Outer[Times,DM,DM];
DV=Det[V];
DS=Det[SIGMA];
LIKELI=-.5*(   n*T*(Log[DV] + MatrixTrace[V1.vdach])
              +n*  (Log[DS] + MatrixTrace[SIGMA1.S0])  );
              
{LIKELI,vdach,H1,H2,H3,V1,SIGMA1,S0,DM}
]





(***************************************************************)
SH[THETA_,DT_,M0_,M00_,M_,n_,T_,NONLIN_] := Module[
(***************************************************************)
(* SCORE UND FISHER-INFORMATIONS-MATRIX *)

{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,V,ASTERN,BSTERN,SIGMA,
 MUE,P,Q,P2,NT,LIKELI,vdach,H1,H2,H3,V1,SIGMA1,S0,DM,S,H,
 M11,M12,M13,M22,M23,M33},
	
	
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,V,
				ASTERN,BSTERN,SIGMA,MUE} = ABL01[THETA,DT,NONLIN];

(*
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,V,
				ASTERN,BSTERN,SIGMA,MUE}//Print; *)


{P,Q} = Dimensions[BSTERN];
P2=P*P;
NT=n*T;

{LIKELI,vdach,H1,H2,H3,V1,SIGMA1,S0,DM} = 
		LIKSTERN[ASTERN,BSTERN,V,MUE,SIGMA,M0,M00,M,n,T];
		
(*{LIKELI,vdach,H1,H2,H3,V1,SIGMA1,S0,DM}//Print;*)


S=NT*(-.5*DVDTH  .Flatten[V1.(V-vdach).V1]
         +DASDTH .Flatten[V1.H2]
         +DBSDTH .Flatten[V1.H3] )
  +n*(-.5*DSIGDTH.Flatten[SIGMA1.(SIGMA-S0).SIGMA1]
         +DMUEDTH.SIGMA1.DM );
         
(*S//Print;*)

{M11,M12,M13,M22,M23,M33} = M;

H=DASDTH.(V1~KroneckerProduct~M23).Transpose[DBSDTH];
H=H+Transpose[H];
H=H+DBSDTH.(V1~KroneckerProduct~M33).Transpose[DBSDTH] ;
H=H+DASDTH.(V1~KroneckerProduct~M22).Transpose[DASDTH] ;
H=H+.5*DVDTH.(V1~KroneckerProduct~V1).Transpose[DVDTH];
H=H*NT;
H=H+n*(.5*DSIGDTH.(SIGMA1~KroneckerProduct~SIGMA1).Transpose[DSIGDTH]
 				 + DMUEDTH.SIGMA1.Transpose[DMUEDTH]);

(*H = IdentityMatrix[Length[THETA]];*)

(*
H//Print; 
S//Print;
*)

{S,H,LIKELI,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
 V,ASTERN,BSTERN,SIGMA,MUE}
]        





(***************************************************************)
MOMENT1[YY_,XX_,P_,Q_,N_,T_,PRINT_] := Module[
(***************************************************************)
(* DATENMATRIZEN (T+1)xPxN *)
(* DATENMATRIZEN (T+1)xQxN *)
{M0,M00,M11,M12,M13,M22,M23,M33,NT,Y,Y0,YPLUS,X},

NT=N*T;

Y0=First[YY];
M0=Apply[Plus,Y0,1]/N;
M00=(Y0.Transpose[Y0])/N;
YPLUS=Shape[Drop[YY,1]//Transpose,{P,NT}];
Y=Shape[Drop[YY,-1]//Transpose,{P,NT}];
X=Shape[Drop[XX,-1]//Transpose,{Q,NT}];

NT=1./(NT);
M11=NT*(YPLUS.(YPLUS// Transpose));
M12=NT*(YPLUS.(Y	// Transpose));
M13=NT*(YPLUS.(X	// Transpose));
M22=NT*(Y.    (Y	// Transpose));    
M23=NT*(Y.    (X	// Transpose));
M33=NT*(X.    (X	// Transpose));
If[PRINT,
Print[M0//Spalte//MatrixForm,"   ",M00//MatrixForm];
Print[""];
Print[ 	( M11            ~ii~ M12            ~ii~M13 )~vv~ 
 		((M12//Transpose)~ii~ M22            ~ii~M23 )~vv~
 		((M13//Transpose)~ii~(M23//Transpose)~ii~M33 )  //MatrixForm] 
 ];

{M0,M00,{M11,M12,M13,M22,M23,M33}}
]





(***************************************************************)
SHIFT[H_,BOUND_] := Module[{H1,EIGEN,MINI,COND},
(***************************************************************)
EIGEN=Eigenvalues[H];
MINI=Min[EIGEN];
COND=Max[Abs[EIGEN]]/Min[Abs[EIGEN]];
If[MINI<BOUND, 
H1=H+DiagonalMatrix[Array[(BOUND-MINI)&,{Length[H]}]], H1 = H ];
Print["EIGENWERTE DER HESSE-MATRIX: ", EIGEN];
Print["{MINI,COND,BOUND} = ", {MINI,COND,BOUND }];
Return[H1]
]

(***************************************************************)
STERNR[OMEGA_,A_,B_,DT_] := Module[{V,ASTERN,BSTERN,P,P2,IP,IP2},
(***************************************************************)

ASTERN =  MatrixExp[A DT//N];
P=Length[A];
P2=P*P;
IP = IdentityMatrix[P]//N;
IP2 = IdentityMatrix[P2]//N;
BSTERN=LinearSolve[A,(ASTERN-IP).B//N];
V=Shape[
	LinearSolve[
		IP~KroneckerProduct~A + A~KroneckerProduct~IP,
		(ASTERN~KroneckerProduct~ASTERN - IP2).Flatten[OMEGA]],
  {P,P}];
{V,ASTERN,BSTERN}
]





(***************************************************************)
LINSTERN[OMEGA_,A_,B_,DT_] := Module[{V,ASTERN,BSTERN,P},
(***************************************************************)
P=Dimensions[A][[1]];
ASTERN=IdentityMatrix[P]+A*DT;
BSTERN=B*DT;
V=OMEGA*DT;
{V,ASTERN,BSTERN}
]

(***************************************************************)
STERN01[OMEGA_,A_,B_,DT_,NONLIN_] := Module[{},
(***************************************************************)
If[NONLIN == 1, Stern[OMEGA,A,B,DT], LINSTERN[OMEGA,A,B,DT] ]
]

(***************************************************************)
STERN01R[OMEGA_,A_,B_,DT_,NONLIN_] := Module[{},
(***************************************************************)
If[NONLIN == 1, STERNR[OMEGA,A,B,DT], LINSTERN[OMEGA,A,B,DT] ]
]

(***************************************************************)
LIK2[THETA_,DT_,M0_,M00_,M_,N_,T_,NONLIN_] := Module[
(***************************************************************)
(* LOG-LIKELIHOOD MIT REELLER ARITHMETIK*)
{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];   

{LIKELI,vdach,H1,H2,H3,V1,SIGMA1,S0,DM} = 
   LIKSTERN[ASTERN,BSTERN,V,MUE,SIGMA,M0,M00,M,N,T];
LIKELI
]


(***************************************************************)
DoUntil[range_,cond_,body_]:= 
(***************************************************************)
	Module[{}, Do[ body; If[cond,Break[] ] ,range]]
		
Attributes[DoUntil] = HoldAll;


(***************************************************************)
DoWhile[range_,cond_,body_]:= 
(***************************************************************)
	Module[{}, Do[ If[!cond,Break[] ]; body ,range]]
		
Attributes[DoWhile] = HoldAll;



(***************************************************************)			 
LikTest[LIKNEU_]:=
(***************************************************************)
	If[(LIKNEU//NumberQ//Not)||(Im[LIKNEU]=!=0)||(LIKNEU>10.^10),
	 	Print["LIKNEU = ",LIKNEU," reset to -10.^10"]; -10.^10,
	 		LIKNEU]	

(***************************************************************)
NEWTON[THETA0_,KMAX_,EPS_,M0_,M00_,M_,DT_,n_,T_,OPTION_,NONLIN_,PRINT_] := 
(***************************************************************)
Module[
{THETA,MAXSTEP,MINSTEP,BOUND,U,K,S,H,LIKELI,vdach,DVDTH,DASDTH,
 DBSDTH,DSIGDTH,DMUEDTH,V,ASTERN,BSTERN,SIGMA,MUE,liktheta,LIKALT,
 ALPHA,THETA1,LIKNEU,STEP,STEPL,t,m},

(*MAXSTEP=10.^3;*)
MAXSTEP=1;
MINSTEP=10.^-10;
BOUND=10.^-4;
ALPHA=10^-4;
U=Length[THETA0];

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: NEWTON**************************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,DT,n,T,OPTION,NONLIN,MAXSTEP,MINSTEP,BOUND}//Spalte,
         {"KMAX","EPS","DT","n","T","OPTION","NONLIN","MAXSTEP",
          "MINSTEP","BOUND"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0];
];

THETA=THETA0;
liktheta = {}; 
NUMABL[THETA0,DT,$MachineEpsilon^.5,M0,M00,M,n,T,NONLIN];


DoUntil[{K,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS, 
  	
  	If[PRINT[[2]] == 1,
   	Print["-----------------------------------------------------------------"];
    Print["NEWTON: Iteration = ",K];
    ];
   
    {S,H,LIKALT,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
     V,ASTERN,BSTERN,SIGMA,MUE} = SH[THETA,DT,M0,M00,M,n,T,NONLIN];
   
    liktheta = Append[liktheta, Join[{LIKALT},THETA]];
    
	   If[OPTION == 1, H = SHIFT[H,BOUND] ];
	
    STEP=LinearSolve[H,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];
    

    (*STEP-HALVING*)
   
    THETA1=THETA+STEP;   (*VOLLER NEWTON-STEP*)
    LIKNEU = LIK2[THETA1,DT,M0,M00,M,n,T,NONLIN];
    LIKNEU = LikTest[LIKNEU];
    
    DoWhile[{Z,100},
         	(LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          		Max[Abs[STEP]]>MINSTEP),
         STEP=STEP*.5;
         
         If[PRINT[[3]] == 1,
         Print["STEP-HALVING:  ",Z,"  LIKNEU  ", LIKNEU,"  LIKALT  ", LIKALT];
         ];
         
         THETA1=THETA+STEP;
         LIKNEU = LIK2[THETA1,DT,M0,M00,M,n,T,NONLIN];
         LIKNEU = LikTest[LIKNEU];

    ]; (*End DoWhile*)
    
    If[PRINT[[4]] == 1,
    Print[""];
    Print["LIKNEU ", PaddedForm[LIKNEU,{20,15}],
    	     " LIKALT ", PaddedForm[LIKALT,{20,15}],
    	     " LIKNEU-LIKALT ", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    Print[""];
    ];
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA, STEP, S}//Transpose,
    TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}]];
    Print[""];
    ];
    
    If[PRINT[[6]] == 1,
    Print[H//MatrixForm]]; 
    
    THETA=THETA1;
    k = K;
   
]; (*End DoUntil*)

If[PRINT[[7]] == 1,
Print[ "NEWTON: ENDE DER ITERATION  ",k,"  ",KMAX]];


{S,H,LIKELI,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
 	V,ASTERN,BSTERN,SIGMA,MUE} = SH[THETA,DT,M0,M00,M,n,T,NONLIN];

liktheta = Append[liktheta,Join[{LIKELI},THETA]];

If[PRINT[[8]] == 1,
Print[MatrixForm[liktheta,
	TableHeadings->{Automatic,{"Likelihood","Theta"}}]]];
	
COV = OUTPUT[THETA,H,.05,S,LIKELI];
LKOMP[LIKELI,U,n*(T+1)];
DELTA[COV,THETA];
DELTASTERN[COV,THETA,DT,NONLIN];

t = Transpose;
m = PaddedForm[MatrixForm[#,TableHeadings->None],{10,4}]&;

If[NONLIN==0,
	{M11,M12,M13,M22,M23,M33} = M;
    AB=Inverse[( M22    ~ii~M23)~vv~
               ((M23//t)~ii~M33)]   .(((M12//t)- M22)~vv~
                                     ( (M13//t)-(M23//t)));
    AB=(AB//t)/DT;
    ODACH=(M11-M12-(M12//t)+M22)/DT;
    Print["----------------------------------------------------------"];  
    Print["ITO-SCH\[CapitalADoubleDot]TZER A B" ,AB//m];
    Print[""];
    Print["OMEGADACH       ", ODACH//m];
];

{THETA,COV,liktheta}
]







(***************************************************************)
SIGNI[THETA_,F_,ALPHA_]:= 
(***************************************************************)
(*APPROXIMATIVER CHI-QUADRAT-TEST*)
Module[{U,CHI,PROB,Z,COV,AU2,DCOV,STD,STD1,CORR,GRENZE},

U=Length[THETA];
CHI=THETA.F.THETA//N;
If[CHI>=0,
	PROB = 1 - CDF[ChiSquareDistribution[U], CHI];
	Print["------------------------------------------------------"];
	Print["WALD-TEST:"];
	Print["------------------------------------------------------"];
	VecPrint[{CHI,U,PROB//Chop,ALPHA}//Spalte,
	         {"CHI ","U ","PROB ","ALPHA "}];
	If[PROB<ALPHA, Print[ "NULLHYPOTHESE THETA = 0 ABLEHNEN"]];
,(*ELSE*) 
	Print[ "F NICHT POSITIV DEFINIT"];
];

(*BONFERRONI-KONFIDENZINTERVALLE*)
COV=PseudoInverse[F];
AU2=ALPHA/(2 U);
Z=Quantile[NormalDistribution[0,1],(1-AU2)];
DCOV=Transpose[COV,{1,1}];

If[ all[DCOV ~gr~0],

    STD=Sqrt[DCOV];
    STD1=1/STD;
    CORR=DiagonalMatrix[STD1].COV.DiagonalMatrix[STD1];
    GRENZE=Z*STD;
    Print["------------------------------------------------------"];
    Print["BONFERRONI-KONFIDENZINTERVALLE:"];
    Print["------------------------------------------------------"];
    Print["P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"];
    Print["QUANTIL Z(1-ALPHA/2U) = ", Z//N];
    VecPrint[{THETA,GRENZE,STD}//N,{"THETA","GRENZE","STD"}];  
    Print["-------------------------------------------------------"];
    Print["Korrelation der ML-Sch\[ADoubleDot]tzer"];
    Print["-------------------------------------------------------"];
    Print[N[CORR,2]//Chop//MatrixForm];
,(*else*)
	Print["Warnung: Negative Diagonalelemente der Kovarianzmatrix"];
];

Return[COV];
]







 
(***************************************************************)
VecPrint[veclist_, label_] := 
(***************************************************************)
  Print[MatrixForm[Transpose[veclist], 
  	TableHeadings -> {Automatic, label}]]









 
(***************************************************************)
VecPrint[veclist_, label_] := 
(***************************************************************)
  Print[TableForm[Transpose[veclist], 
  	TableHeadings -> {Automatic, label},
  	TableDirections->{Column,Row},
  	TableSpacing->{0,2}]]









(***************************************************************)
LKOMP[LIK_,U_,Nue_] := Module[{EPS,LN,KOMP1,KOMP2,KOMP3},
(***************************************************************)
(*KOMPENSIERTE LIKELIHOOD*)
EPS=10^-3;
LN=Log[Nue//N];
KOMP1=U;
KOMP2=.5*U*LN;
KOMP3=.5*U*(U+1)*(1+EPS)*Log[LN];
Print["--------------------------------------------------------"];
Print["KOMPENSIERTE LIKELIHOOD"];
Print["--------------------------------------------------------"];

Print["U =  ",U,"  Nue = " ,Nue];
Print["AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE (A/D)"];
ket={{  0,     KOMP1,    KOMP2,    KOMP3},
     {LIK, LIK-KOMP1,LIK-KOMP2,LIK-KOMP3}};
Print[ TableForm[ket,
		TableHeadings -> {{"Kompensator","komp. Lik."},
		                  {"LIK","AIC","SIC/RISS","A/D"}},
		TableDirections->{Column,Row},
		TableSpacing->{0,1}]];
]





(***************************************************************)
OUTPUT[THETA_,F_,ALPHA_,SCORE_,LIKELI_]:= Module[{COV,EIGF,EIGCOV},
(***************************************************************)
Print["--------------------------------------------------------"];
Print["ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"];
Print["--------------------------------------------------------"];
Print[{THETA,SCORE}//Transpose//TableForm[#,
	  TableHeadings->{Automatic,{"THETA","SCORE"}},
	  TableDirections->{Column,Row},
	  TableSpacing->{0,1}]&
      ,"   Likelihood = ",N[LIKELI,25] ];
COV = SIGNI[THETA, F, ALPHA];
EIGF=Eigenvalues[F];
EIGCOV=1/EIGF;
Print["--------------------------------------------------------"];
Print["GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"];
Print["--------------------------------------------------------"];
Print[N[COV,5]//Chop//MatrixForm];
Print[""];
Print[N[EIGCOV,5]];
Print["--------------------------------------------------------"];
Print["GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND EIGENWERTE"];
Print["--------------------------------------------------------"];
Print[N[F,5]//Chop//MatrixForm];
Print[""];
Print[N[EIGF,5]];
COV
]

































































(***************************************************************)
STANDARD[DADTH_,COV_,D1_,D2_]:= Module[{C,Cdiag,STD},
(***************************************************************)
(* COV: u x u*)
If[DADTH === {} || COV === {}, Return[Shape[0.,{D1,D2}]] ];
C=Transpose[DADTH].COV.DADTH;
Cdiag = Transpose[C,{1,1}];
STD=Sqrt[Cdiag ((Cdiag ~ge~ 0 )/.{True->1,False->0})];
STD=Shape[STD,{D1,D2}]
]





(***************************************************************)
DELTA[COV_,TH_] := Module[
(***************************************************************)
(*DELTA-THEOREM*)
{m,OMEGA,A,B,SIGMA,MUE,DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH,
 STDA,STDB,STDO,STDMUE,STDSIG},

{OMEGA,A,B,SIGMA,MUE} = PAR[TH];
{DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH} = PARD[TH];
{P,Q}=Dimensions[B];
STDA=STANDARD[DADTH,COV,P,P];
STDB=STANDARD[DBDTH,COV,P,Q];
STDO=STANDARD[DODTH,COV,P,P];
STDMUE=STANDARD[DMUEDTH,COV,P,1];
STDSIG=STANDARD[DSIGDTH,COV,P,P];
m = PaddedForm[MatrixForm[#,TableHeadings->None],{10,4}]&;
Print["----------------------------------------------------------"];
Print["DELTA-THEOREM"];
Print["----------------------------------------------------------"];
Print["GESCH\[CapitalADoubleDot]TZTE STANDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"];
Print["A, B, OMEGA, SIGMA UND MUE"];
Print["----------------------------------------------------------"];
Print[" A      ",A//m];
Print[""];
Print[" STDA   ",STDA//m];
Print["----------------------------------------------------------"];
Print[" B      ",B//m];
Print[""];
Print[" STDB   ",STDB//m];
Print["----------------------------------------------------------"];
Print[" OMEGA  ",OMEGA//m];
Print[""];
Print[" STDO   ",STDO//m];
Print["----------------------------------------------------------"];
Print[" MUE    ",MUE//m];
Print[""];
Print[" STDMUE ",STDMUE//m];
Print["----------------------------------------------------------"];
Print[" SIGMA  ",SIGMA//m];
Print[""];
Print[" STDSIG ",STDSIG//m];
]







(***************************************************************)
DELTASTERN[COV_,TH_,DT_,NONLIN_] := Module[
(***************************************************************)
(*DELTA-THEOREM f\[UDoubleDot]r Stern-Matrizen*)
{m,Ostern,Astern,Bstern,SIGMA,MUE,DOSDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
 STDA,STDB,STDO,STDMUE,STDSIG},

{DOSDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
	Ostern,Astern,Bstern,SIGMA,MUE} = ABL01[TH,DT,NONLIN];
	
{P,Q}=Dimensions[Bstern];
STDA=STANDARD[DASDTH,COV,P,P];
STDB=STANDARD[DBSDTH,COV,P,Q];
STDO=STANDARD[DOSDTH,COV,P,P];
STDMUE=STANDARD[DMUEDTH,COV,P,1];
STDSIG=STANDARD[DSIGDTH,COV,P,P];
m = PaddedForm[MatrixForm[#,TableHeadings->None],{10,4}]&;
Print["----------------------------------------------------------"];
Print["DELTA-THEOREM"];
Print["----------------------------------------------------------"];
Print["GESCH\[CapitalADoubleDot]TZTE STANDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"];
Print["A*, B*, OMEGA*, SIGMA UND MUE"];
Print["----------------------------------------------------------"];
Print[" A*     ",Astern//m];
Print[""];
Print[" STDA   ",STDA//m];
Print["----------------------------------------------------------"];
Print[" B*     ",Bstern//m]; 
Print[""];   
Print[" STDB   ",STDB//m];
Print["----------------------------------------------------------"];
Print[" OMEGA* ",Ostern//m];
Print[""];
Print[" STDO   ",STDO//m];
Print["----------------------------------------------------------"];
Print[" MUE    ",MUE//m]; 
Print[""];
Print[" STDMUE ",STDMUE//m];
Print["----------------------------------------------------------"];
Print[" SIGMA  ",SIGMA//m];
Print[""];
Print[" STDSIG ",STDSIG//m];
]

(***************************************************************)
NUMABL[THETA_,DT_,DIFF_,M0_,M00_,M_,N_,T_,NONLIN_] :=             
(***************************************************************)
(*NUMERISCHE ABLEITUNGEN*)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,P,Q,PQ,P2,
		VDach,H1,H2,H3,V1,SIGMA1,S0,DM,U,DIFF1,THI,
		SCORE,LIKELI,LIKELII,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
		VI,ASTERNI,BSTERNI,OMEGAI,AI,BI},


{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{P,Q}=A//Dimensions;

PQ=P*Q;
P2=P*P;
{LIKELI,VDach,H1,H2,H3,V1,SIGMA1,S0,DM} = 
	LIKSTERN[ASTERN,BSTERN,V,MUE,SIGMA,M0,M00,M,N,T];


U=Length[THETA];
DIFF1=1/DIFF; (*INKREMENT*)
SCORE = {}; DVDTH = {}; DASDTH = {}; 
DBSDTH = {};  DSIGDTH = {};  DMUEDTH = {};
Do[ 
    THI=THETA;
    THI[[I]]=THI[[I]]+DIFF;
    {OMEGAI,AI,BI,SIGMAI,MUEI} = PAR[THI];
	{VI,ASTERNI,BSTERNI} = STERN01[OMEGAI,AI,BI,DT,NONLIN];
	{LIKELII,VDACHI,H1I,H2I,H3I,V1I,SIGMA1I,S0I,DMI} = 
		LIKSTERN[ASTERNI,BSTERNI,VI,MUEI,SIGMAI,M0,M00,M,N,T];
    SCORE=Append[SCORE, DIFF1*(LIKELII-LIKELI)];
    DVDTH=Append[DVDTH,DIFF1*Flatten[VI-V]];
    DASDTH=Append[DASDTH,DIFF1*Flatten[ASTERNI-ASTERN]];
    DBSDTH=Append[DBSDTH,DIFF1*Flatten[BSTERNI-BSTERN]];
    DSIGDTH=Append[DSIGDTH,DIFF1*Flatten[SIGMAI-SIGMA]];
    DMUEDTH=Append[DMUEDTH,DIFF1*Flatten[MUEI-MUE]];
,{I,1,U}];

S=N*T*( -.5*DVDTH.Flatten[V1.(V-VDach).V1] +
          +DASDTH.Flatten[V1.H2] +
          +DBSDTH.Flatten[V1.H3]) +
  +N*(-.5*DSIGDTH.Flatten[SIGMA1.(SIGMA-S0).SIGMA1]
         + DMUEDTH.SIGMA1.DM );
Print[ "NUMABL: SCORE MIT ANALYTISCHER FORMEL, NUMERISCHE KOEFFIZIENTEN"];
Print[ "NUMABL: REIN NUMERISCHER SCORE"];
Print[MatrixForm[{S,SCORE,S-SCORE}//Transpose,
		TableHeadings->{Automatic,{"S1","S2","S1-S2"}}]];

{SCORE,LIKELI,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
             V,ASTERN,BSTERN,SIGMA,MUE}

]

(************************************************************************)
ExpandK//Clear;
ExpandK[S_,KK_]:=
(************************************************************************)
	Module[{j},
	j=0;
	Table[If[S[[i]] == 0, 0,
	  		If[S[[i]] == 1,
	  		j+=1;KK[[j]],
	  	        -KK[[j]] ]],
	{i,1,Length[S]}]
];

(************************************************************************)
ALIASING//Clear
ALIASING[A_,B_,OMEGA_,K_,DT_]:=
(************************************************************************)
Module[{P,P2,LAMBDA,EV,EV1,DL,AA,ELT0,EXPO,ASTERN,IP,IP2,
        BSTERN,L,V,m,S,NC,ANZ,K1,NN,AN,ASTERNN,BSTERNN,
        OMEGAN,EIGEN,VN,KL},
        
Print["***********************LSDE1******************************************"];
Print["***********************MODUL: ALIASING********************************"];
Print["**********************************************************************"];
P=Length[A];
If[Im[A],Print["ALIASING: KOMPLEXE DRIFT"];Return];
{LAMBDA,EV} = Eigensystem[A];
EV  = EV//Transpose;
EV1 = EV//Inverse//Chop;
DL = DiagonalMatrix[LAMBDA];
AA = EV.DL.EV1//Chop;
ELT0 = Exp[LAMBDA*DT];
EXP0 = DiagonalMatrix[ELT0];
ASTERN = EV.EXP0.EV1;
ASTERN= ASTERN//Chop;
IP  = IdentityMatrix[P];
IP2 = IdentityMatrix[P P];
BSTERN=Inverse[A].(ASTERN-IP).B;

L = A~KroneckerProduct~IP + IP~KroneckerProduct~A;
V=Shape[ Inverse[L].
		((ASTERN~KroneckerProduct~ASTERN) -IP2).
		Flatten[OMEGA],{P,P}];
         
Print[ "--------------------ALIASING------------------------"];
m = PaddedForm[MatrixForm[#]]&;
Print["A ",A//m,"AA ",AA//m,"LAMBDA ",LAMBDA//m];
Print[""];
Print["EV ",EV//m];
Print[""];
Print["EV1 ",EV1//m];
Print[""];
Print["ASTERN ",ASTERN//m,"BSTERN ",BSTERN//m,"V ",V//m,"DT ",DT];

S = Map[Sign[Im[#]]&,LAMBDA];
NC=Apply[Plus,S//Abs]/2;  
If[NC==0 ,Print["KEINE C.C. EW"; Return]];
ANZ=Length[K];

K1 = Map[ExpandK[S,#]&,K];
Print["Expandierte Integer-Vektoren  ",K1//m];

Table[ 

NN=DiagonalMatrix[K1[[L]] ];
AN=A + EV.NN.EV1*(2 Pi I /DT)//N//Chop;
ASTERNN = MatrixExp[AN*DT];
BN=Inverse[ASTERN-IP].AN.BSTERN//N//Chop;
BSTERNN=Inverse[AN].(ASTERN-IP).BN;
LN = (AN~KroneckerProduct~IP)+(IP~KroneckerProduct~AN);
OMEGAN=Shape[Inverse[ASTERN~KroneckerProduct~ASTERN-IP2].LN.Flatten[V],{P,P}]//N//Chop;
EIGEN=Eigenvalues[OMEGAN];
VN=Shape[Inverse[LN].(ASTERN~KroneckerProduct~ASTERN-IP2).Flatten[OMEGAN],{P,P}]//N//Chop;


KL=K[[L]];
Print[""];
Print["--------------------ALIASING------------------- L ",L,"  KL  ",KL];
Print[""];
Print["  A",A//m,"  AN",AN//m,"  ASTERNN",ASTERNN//m];
Print[""];
Print["  B",B//m,"  BN",BN//m,"  BSTERNN",BSTERNN//m];
Print[""];
Print["  OMEGA",OMEGA//m,"  OMEGAN",OMEGAN//m];
Print[""];
Print["  EIGEN",EIGEN//m,"  VN",VN//m];
{AN,BN,OMEGAN}
,{L,1,ANZ}]

]

(************************************************************************)
MatrixLog[A_]:= 
(************************************************************************)
Module[{EW,EV,logEW},
{EW,EV} = Eigensystem[A];
EV = EV//Transpose;
logEW = Log[EW];
{EV.DiagonalMatrix[logEW].Inverse[EV],EW,EV}//Chop
]


(************************************************************************)
Indirekt[{Ostern_,Astern_,Bstern_}]:=
(************************************************************************)
Module[{A,lambda,P,p = Length[Astern],Ip,B,L,Omega},

{A,lambda,P} = MatrixLog[Astern];
Ip = IdentityMatrix[p]; 
B = A.Inverse[Astern-Ip].Bstern;
L = A~KroneckerProduct~Ip + Ip~KroneckerProduct~A ;
Omega = L.Inverse[Astern~KroneckerProduct~Astern-
                  IdentityMatrix[p^2]].Flatten[Ostern];
Omega = Shape[Omega,{p,p}];
{Omega,A,B}]



(************************************************************************)
L[A_,B_]:= A~KroneckerProduct~B + B~KroneckerProduct~A;
(************************************************************************)

(************************************************************************)
SigmaStat[A_,Omega_]:= Module[{Id,p,LL},
(************************************************************************)
p=A//Length;
Id=IdentityMatrix[p];
LL=L[A,Id];
Shape[-Inverse[LL].Flatten[Omega],{p,p}]
]



End[]

Protect[Names["code`PARTest`*"]//Evaluate];

EndPackage[ ]