(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, bold, R65535, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, bold, B65535, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, italic, G65535, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, O497, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M8, N9, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 256; useSolids; automaticGrouping; currentKernel; 
]
:[font = subsection; inactive; initialization; preserveAspect; startGroup]
Impl
:[font = input; initialization; preserveAspect]
*)


RungeKutta1//Clear
RungeKutta1[f_,g_,Y0_,{X_,dw_},T_,dt_,Theta_,Step_] :=
	FoldList[ Step[f,g,#1,#2,Theta,dt]&,Y0,{Take[X,T],Take[dw,T]}//Transpose]
 

EulerStep1//Clear
EulerStep1[f_,g_,y_,{t_,dw_},Theta_,dt_] :=
      y + f[y,t,Theta] dt + g[y,t,Theta].dw
      
HeunStep1//Clear
HeunStep1[f_,g_,y_,{t_,dw_},Theta_,dt_] :=
	Module[{f1,g1,t1,f2,g2},
		f1 = f[y,t,Theta];
		g1 = g[y,t,Theta];
	
		y1 = y + f1 dt + g1.dw; (* Euler-Prdiktor *)
		t1 = t + dt;
		f2 = f[y1,t1,Theta];
		g2 = g[y1,t1,Theta];
		
        y + 0.5 ( (f1 + f2) dt + (g1 + g2).dw )
 	]
 	
RungeKutta4Step1//Clear
RungeKutta4Step1[f_,g_,y_,{t_,dw_},Theta_,dt_]:=
	Module[{f0,f1,f2,f3,g0,g1,g2,g3,t1,t3,dth,dwh,y1,y2,y3},
		f0 = f[y,t,Theta];
		g0 = g[y,t,Theta];
		dwh = dw/2;
		dth = dt/2;
		
		t1 = t + dth;
		y1 = y + f0 dth + g0.dwh;
		f1 = f[y1,t1,Theta];
		g1 = g[y1,t1,Theta];
		
		y2 = y + f1 dth + g1.dwh;
		f2 = f[y2,t1,Theta];
		g2 = g[y2,t1,Theta];
		
		y3 = y + f2 dt + g2.dw;
		t3 = t + dt;
		f3 = f[y3,t3,Theta];
		g3 = g[y3,t3,Theta];
		
        y + (f0 + 2f1 + 2f2 + f3) dt/6. + (g0 + 2g1 + 2g2 + g3).dw/6. 
 	] 
      
(*
:[font = input; initialization; preserveAspect]
*)
RungeKutta1Lik//Clear
RungeKutta1Lik[fg_,Y0_,{X_,dw_},T_,dt_,Theta_,Step_] :=
	Module[{y,l},
	
	{y,l}=FoldList[ Step[fg,#1,#2,Theta,dt]&,{Y0,0},
	                {Take[X,T],Take[dw,T]}//Transpose]//Transpose;
	                
	                (*y//MatrixForm//Print;*)
	{y,l//Last}
	]
 

EulerStep1Lik//Clear
EulerStep1Lik[fg_,{y_,l_},{t_,dw_},Theta_,dt_] := 
Module[{f,G,gdw,Omega,lik},
	{f,G} = fg[y,t,Theta];
	
	(*
	f//Print;
	G//Print;
	*)
	
	gdw = G.dw;
	Omega = G.Transpose[G]*dt; 
	lik = -.5(Log[Det[Omega]] + gdw.Inverse[Omega].gdw);
	
    {y + f dt + gdw,l+lik}]
(*
:[font = input; preserveAspect; startGroup]
RungeKutta1Lik[{#^2,#}&,y00,{{0,0},{dw1,dw2}},1,dt,Th,EulerStep1Lik]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
{{y00, y00 + 0.1*y00^2 + y00 . dw1}, -0.5*(y00 . dw1 . Inverse[0.1*y00 . Transpose[y00]] . y00 . dw1 + Log[Det[0.1*y00 . Transpose[y00]]])}
;[o]
                    2
{{y00, y00 + 0.1 y00  + y00 . dw1}, -0.5 (y00 . dw1 . Inverse[0.1 y00 . Transpose[y00]] . y00 . dw1 + Log[Det[0.1 y00 . Transpose[y00]]])}
:[font = input; preserveAspect; startGroup]
y0
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
{0}
;[o]
{0}
^*)
