(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, R65535,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; preserveAspect; startGroup]
ListCorrelate[{a,b,c,d,e},{aa,bb,cc,dd,ee},{1,-2},{pp}]//MatrixForm
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
MatrixForm[{a*aa + b*bb + c*cc + d*dd + e*ee, a*bb + b*cc + c*dd + d*ee + e*pp}]
;[o]

1   a aa + b bb + c cc + d dd + e ee
2   a bb + b cc + c dd + d ee + e pp
:[font = input; preserveAspect]
<<Kronecker.m
:[font = input; preserveAspect]
AutokorrM//Clear
AutokorrM[x_,tau_]:=Module[{sxq,T,m,xq,p,pad},
		 m=x//mean;
         xq  = Map[(#-m)&,x]; 
    	 sxq = Transpose[xq].xq //VecDiag//Sqrt;
    	 p=sxq//Length;
    	 pad=Shape[0,{1,p}];    	   
         norm=((#/sxq//Transpose)/sxq//Transpose)&;
    	 ListCorrelate[xq,xq,{1,-tau-1},pad,Outer[Times,#1,#2]&,Plus,1]//Map[norm,#]&
    ]
:[font = input; preserveAspect]
Autokorr1M//Clear
Autokorr1M[x_,tau_]:=Module[{m,xq,sxq,T,lag},
         m=x//mean;
         xq  = Map[(#-m)&,x]; 
    	 sxq = Transpose[xq].xq //VecDiag//Sqrt;    	   
         T  = x//Length; 
    	 Table[(Sum[Outer[Times,xq[[i]],xq[[i+lag]]],{i,1,T-lag}]/sxq//Transpose)/sxq//Transpose,{lag,0,tau}]
    ]
:[font = input; preserveAspect]
Y=Table[Random[],{i,2000},{j,3}];
:[font = input; preserveAspect; startGroup]
r=Autokorr[Y[[Range[2000],1]],100]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {1.0000000000000013, 0.0017310919135461286, -0.0031809759897450936, 0.003984320280605965, 0.054903345407944344, 0.0026617122514198325, -0.004009827799523824, -0.035104021192370216, -0.004459369964555833, 0.02115955202211953, -0.024459937052929263, 0.01833453777426421, 0.01865032621167739, 0.015506995444455728, -0.013203375543891099, -0.010712211303700474, 0.008177949093328807, 0.01799686336730686, 0.011190016107869996, 0.022099058169045102, 0.007574736818409885, 0.01388417783314478, 

   0.022500812367538873, -0.029712957368975768, 0.03262573997973149, -0.006942382626120428, -0.0006660408818285975, -0.00435175852132785, 0.0059538745911927714, -0.026474707023745037, -0.010400769011402373, -0.02624577747302074, 0.012941109220051534, -0.0050104183216947125, -0.04402784230929441, -0.02624156512869349, -0.03981738185413525, 0.013825884653204756, 0.01657101008816211, -0.007696052361640063, -0.00946982341423684, -0.01950002120807824, -0.010655516488955774, -0.0024821532835954834, 

   -0.007531959165506418, 0.025810110870205585, 0.027116138398996202, 0.0010890148359383948, -0.024628766955192553, -0.012606846661102027, -0.020484153338074036, -0.003545957195710689, 0.009376179073430947, -0.00234338552892562, -0.053609971881533255, 0.0337791940259894, -0.005008342535879136, 0.04214550137234218, -0.011944511893788706, -0.0006320961250771338, -0.029182983470011022, 0.03538213120522661, -0.005835150526720599, 0.026951358179417583, -0.002764404944299943, 0.04057575503632611, 

   0.043253882720481494, 0.002128236570916329, -0.009262888973779894, 0.002579301198388748, 0.019635135703133366, -0.018133972248963383, -0.02616664143436501, 0.017361002175751938, -0.02836808082692244, 0.021703319305040072, -0.012114200130494714, -0.012353256278217945, -0.034447987134044386, 0.024550041641227562, -0.04480371249977349, 0.008252948063077935, -0.016525615592340077, -0.026323444852037043, 0.010584369921040324, 0.02124580976967435, -0.004189968594682086, -0.018362373980736063, 

   0.0166312856483552, -0.014279385436853425, -0.00003687424440370301, -0.039079322897957465, -0.020413514126180074, -0.026094114846016796, -0.02485648715261774, -0.012848796084348751, -0.019610646020976223, 0.015926320665243604, 0.004660962645048229, 0.03099250529246297, 0.013114276782222418}
;[o]
 {1., 0.00173109, -0.00318098, 0.00398432, 0.0549033, 0.00266171, -0.00400983, -0.035104, -0.00445937, 0.0211596, -0.0244599, 0.0183345, 0.0186503, 0.015507, -0.0132034, -0.0107122, 0.00817795, 0.0179969, 0.01119, 0.0220991, 0.00757474, 0.0138842, 0.0225008, -0.029713, 0.0326257, -0.00694238, -0.000666041, -0.00435176, 0.00595387, -0.0264747, -0.0104008, -0.0262458, 0.0129411, -0.00501042, -0.0440278, -0.0262416, -0.0398174, 0.0138259, 0.016571, -0.00769605, -0.00946982, -0.0195, -0.0106555, 
  -0.00248215, -0.00753196, 0.0258101, 0.0271161, 0.00108901, -0.0246288, -0.0126068, -0.0204842, -0.00354596, 0.00937618, -0.00234339, -0.05361, 0.0337792, -0.00500834, 0.0421455, -0.0119445, -0.000632096, -0.029183, 0.0353821, -0.00583515, 0.0269514, -0.0027644, 0.0405758, 0.0432539, 0.00212824, -0.00926289, 0.0025793, 0.0196351, -0.018134, -0.0261666, 0.017361, -0.0283681, 0.0217033, -0.0121142, -0.0123533, -0.034448, 0.02455, -0.0448037, 0.00825295, -0.0165256, -0.0263234, 0.0105844, 
  0.0212458, -0.00418997, -0.0183624, 0.0166313, -0.0142794, -0.0000368742, -0.0390793, -0.0204135, -0.0260941, -0.0248565, -0.0128488, -0.0196106, 0.0159263, 0.00466096, 0.0309925, 0.0131143}
:[font = input; preserveAspect; startGroup]
r1=Autokorr1[Y[[Range[2000],1]],100]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {1., 0.0017310919135461514, -0.0031809759897450996, 0.003984320280605983, 0.054903345407944296, 0.0026617122514198286, -0.004009827799523821, -0.035104021192370216, -0.004459369964555822, 0.02115955202211951, -0.024459937052929346, 0.018334537774264196, 0.018650326211677372, 0.015506995444455723, -0.013203375543891085, -0.010712211303700479, 0.008177949093328809, 0.0179968633673069, 0.01119001610787001, 0.02209905816904514, 0.00757473681840988, 0.013884177833144766, 0.022500812367538925, 

   -0.0297129573689758, 0.03262573997973145, -0.00694238262612041, -0.0006660408818285813, -0.004351758521327856, 0.005953874591192764, -0.02647470702374509, -0.010400769011402376, -0.026245777473020718, 0.01294110922005152, -0.0050104183216947325, -0.044027842309294365, -0.02624156512869352, -0.03981738185413523, 0.013825884653204763, 0.016571010088162166, -0.00769605236164006, -0.009469823414236848, -0.01950002120807823, -0.010655516488955758, -0.002482153283595501, -0.007531959165506406, 

   0.025810110870205596, 0.02711613839899619, 0.0010890148359383874, -0.024628766955192526, -0.012606846661102037, -0.020484153338074036, -0.00354595719571071, 0.009376179073430899, -0.002343385528925607, -0.053609971881533304, 0.033779194025989424, -0.005008342535879143, 0.04214550137234224, -0.011944511893788753, -0.000632096125077139, -0.029182983470011095, 0.03538213120522658, -0.005835150526720607, 0.02695135817941758, -0.0027644049442999154, 0.040575755036326114, 0.043253882720481515, 

   0.002128236570916317, -0.009262888973779864, 0.0025793011983887173, 0.01963513570313341, -0.018133972248963372, -0.026166641434364972, 0.017361002175751965, -0.028368080826922493, 0.02170331930504005, -0.01211420013049471, -0.012353256278217928, -0.03444798713404441, 0.024550041641227576, -0.044803712499773496, 0.008252948063077904, -0.016525615592340073, -0.026323444852037026, 0.01058436992104033, 0.02124580976967438, -0.004189968594682128, -0.018362373980736032, 0.01663128564835521, 

   -0.014279385436853385, -0.000036874244403696764, -0.03907932289795744, -0.02041351412618006, -0.026094114846016845, -0.02485648715261774, -0.012848796084348756, -0.01961064602097632, 0.015926320665243625, 0.00466096264504824, 0.030992505292462967, 0.01311427678222242}
;[o]
 {1., 0.00173109, -0.00318098, 0.00398432, 0.0549033, 0.00266171, -0.00400983, -0.035104, -0.00445937, 0.0211596, -0.0244599, 0.0183345, 0.0186503, 0.015507, -0.0132034, -0.0107122, 0.00817795, 0.0179969, 0.01119, 0.0220991, 0.00757474, 0.0138842, 0.0225008, -0.029713, 0.0326257, -0.00694238, -0.000666041, -0.00435176, 0.00595387, -0.0264747, -0.0104008, -0.0262458, 0.0129411, -0.00501042, -0.0440278, -0.0262416, -0.0398174, 0.0138259, 0.016571, -0.00769605, -0.00946982, -0.0195, -0.0106555, 
  -0.00248215, -0.00753196, 0.0258101, 0.0271161, 0.00108901, -0.0246288, -0.0126068, -0.0204842, -0.00354596, 0.00937618, -0.00234339, -0.05361, 0.0337792, -0.00500834, 0.0421455, -0.0119445, -0.000632096, -0.029183, 0.0353821, -0.00583515, 0.0269514, -0.0027644, 0.0405758, 0.0432539, 0.00212824, -0.00926289, 0.0025793, 0.0196351, -0.018134, -0.0261666, 0.017361, -0.0283681, 0.0217033, -0.0121142, -0.0123533, -0.034448, 0.02455, -0.0448037, 0.00825295, -0.0165256, -0.0263234, 0.0105844, 
  0.0212458, -0.00418997, -0.0183624, 0.0166313, -0.0142794, -0.0000368742, -0.0390793, -0.0204135, -0.0260941, -0.0248565, -0.0128488, -0.0196106, 0.0159263, 0.00466096, 0.0309925, 0.0131143}
:[font = input; preserveAspect; startGroup]
r-r1//Short
:[font = output; output; inactive; preserveAspect; endGroup]
Short["<<>>"]
;[o]
           -15             -17            -18             -17            -17            -18             -18                 -17            -17            -17            -17            -17            -18             -17            -18             -18             -17             -17             -17            -18                     -18             -17             -17            -17                -18            -17             -17             -17            -18             -18
{1.33227 10   , -2.27682 10   , 6.07153 10   , -1.82146 10   , 4.85723 10   , 3.90313 10   , -3.46945 10   , 0., -1.12757 10   , 2.08167 10   , 8.32667 10   , 1.38778 10   , 1.73472 10   , 5.20417 10   , -1.38778 10   , 5.20417 10   , -1.73472 10   , -3.81639 10   , -1.38778 10   , -3.81639 10   , 5.20417 10   , <<69>>, -6.24772 10   , -2.77556 10   , -1.38778 10   , 4.85723 10   , 0., 5.20417 10   , 9.71445 10   , -2.08167 10   , -1.12757 10   , 3.46945 10   , -1.73472 10   }
:[font = input; preserveAspect]
r=AutokorrM[Take[Y,1000],100];
:[font = input; preserveAspect]
r1=Autokorr1M[Take[Y,1000],100];
:[font = input; preserveAspect; startGroup]
r==r1
:[font = output; output; inactive; preserveAspect; endGroup]
True
;[o]
True
:[font = input; preserveAspect; startGroup]
Map[VecDiag,r]//AddTimeAxis//plot1;
:[font = print; inactive; preserveAspect]
Dimension der Daten  {101, 4}
:[font = postscript; PostScript; formatAsPostScript; output; inactive; preserveAspect; pictureLeft = 34; pictureWidth = 282; pictureHeight = 174; endGroup]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.0704808 0.532838 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07048 -6 -4.5 ]
[-0.0125 .07048 0 4.5 ]
[-0.0125 .17705 -18 -4.5 ]
[-0.0125 .17705 0 4.5 ]
[-0.0125 .28362 -18 -4.5 ]
[-0.0125 .28362 0 4.5 ]
[-0.0125 .39018 -18 -4.5 ]
[-0.0125 .39018 0 4.5 ]
[-0.0125 .49675 -18 -4.5 ]
[-0.0125 .49675 0 4.5 ]
[-0.0125 .60332 -6 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .06236 -3 -4.5 ]
[.97619 .06236 3 4.5 ]
[.97619 .08915 -3 -4.5 ]
[.97619 .08915 3 4.5 ]
[.97619 .09696 -3 -4.5 ]
[.97619 .09696 3 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07048 m
.00625 .07048 L
s
[(0)] -0.0125 .07048 1 0 Mshowa
0 .17705 m
.00625 .17705 L
s
[(0.2)] -0.0125 .17705 1 0 Mshowa
0 .28362 m
.00625 .28362 L
s
[(0.4)] -0.0125 .28362 1 0 Mshowa
0 .39018 m
.00625 .39018 L
s
[(0.6)] -0.0125 .39018 1 0 Mshowa
0 .49675 m
.00625 .49675 L
s
[(0.8)] -0.0125 .49675 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(1)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .09712 m
.00375 .09712 L
s
0 .12376 m
.00375 .12376 L
s
0 .15041 m
.00375 .15041 L
s
0 .20369 m
.00375 .20369 L
s
0 .23033 m
.00375 .23033 L
s
0 .25697 m
.00375 .25697 L
s
0 .31026 m
.00375 .31026 L
s
0 .3369 m
.00375 .3369 L
s
0 .36354 m
.00375 .36354 L
s
0 .41683 m
.00375 .41683 L
s
0 .44347 m
.00375 .44347 L
s
0 .47011 m
.00375 .47011 L
s
0 .52339 m
.00375 .52339 L
s
0 .55004 m
.00375 .55004 L
s
0 .57668 m
.00375 .57668 L
s
0 .04384 m
.00375 .04384 L
s
0 .0172 m
.00375 .0172 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07048 m
1 .07048 L
s
.99375 .17705 m
1 .17705 L
s
.99375 .28362 m
1 .28362 L
s
.99375 .39018 m
1 .39018 L
s
.99375 .49675 m
1 .49675 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .09712 m
1 .09712 L
s
.99625 .12376 m
1 .12376 L
s
.99625 .15041 m
1 .15041 L
s
.99625 .20369 m
1 .20369 L
s
.99625 .23033 m
1 .23033 L
s
.99625 .25697 m
1 .25697 L
s
.99625 .31026 m
1 .31026 L
s
.99625 .3369 m
1 .3369 L
s
.99625 .36354 m
1 .36354 L
s
.99625 .41683 m
1 .41683 L
s
.99625 .44347 m
1 .44347 L
s
.99625 .47011 m
1 .47011 L
s
.99625 .52339 m
1 .52339 L
s
.99625 .55004 m
1 .55004 L
s
.99625 .57668 m
1 .57668 L
s
.99625 .04384 m
1 .04384 L
s
.99625 .0172 m
1 .0172 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
[( )] .97619 .06236 0 0 Mshowa
.001 w
.02381 .60332 m
.03333 .06851 L
.04286 .07087 L
.05238 .08168 L
.0619 .13618 L
.07143 .07828 L
.08095 .0718 L
.09048 .04721 L
.1 .08298 L
.10952 .10461 L
.11905 .03547 L
.12857 .09653 L
.1381 .07173 L
.14762 .09362 L
.15714 .04741 L
.16667 .0819 L
.17619 .06048 L
.18571 .08507 L
.19524 .06755 L
.20476 .07775 L
.21429 .07591 L
.22381 .07413 L
.23333 .09327 L
.24286 .04202 L
.25238 .09378 L
.2619 .04508 L
.27143 .06586 L
.28095 .06337 L
.29048 .07417 L
.3 .06963 L
.30952 .08536 L
.31905 .05776 L
.32857 .06996 L
.3381 .07211 L
.34762 .04 L
.35714 .04566 L
.36667 .02326 L
.37619 .08296 L
.38571 .05852 L
.39524 .08178 L
.40476 .06536 L
.41429 .06082 L
.42381 .06857 L
.43333 .06317 L
.44286 .05822 L
.45238 .08124 L
.4619 .07834 L
.47143 .04547 L
.48095 .072 L
.49048 .07817 L
Mistroke
.5 .05929 L
.50952 .06629 L
.51905 .09698 L
.52857 .07423 L
.5381 .0449 L
.54762 .10408 L
.55714 .07573 L
.56667 .09737 L
.57619 .08686 L
.58571 .06923 L
.59524 .06169 L
.60476 .08375 L
.61429 .07515 L
.62381 .06124 L
.63333 .07648 L
.64286 .10075 L
.65238 .09151 L
.6619 .07502 L
.67143 .06736 L
.68095 .07503 L
.69048 .10213 L
.7 .0737 L
.70952 .05584 L
.71905 .11381 L
.72857 .03971 L
.7381 .06643 L
.74762 .06621 L
.75714 .07255 L
.76667 .03256 L
.77619 .08763 L
.78571 .04569 L
.79524 .0618 L
.80476 .05467 L
.81429 .03884 L
.82381 .07945 L
.83333 .09826 L
.84286 .06424 L
.85238 .06512 L
.8619 .07606 L
.87143 .06359 L
.88095 .077 L
.89048 .02836 L
.9 .07267 L
.90952 .05191 L
.91905 .08277 L
.92857 .06261 L
.9381 .04031 L
.94762 .07767 L
.95714 .07805 L
.96667 .08731 L
Mistroke
.97619 .06236 L
Mfstroke
0 .98 .604 r
[( )] .97619 .08915 0 0 Mshowa
.02381 .60332 m
.03333 .05393 L
.04286 .0688 L
.05238 .08711 L
.0619 .06143 L
.07143 .07251 L
.08095 .07014 L
.09048 .08206 L
.1 .06136 L
.10952 .07328 L
.11905 .07775 L
.12857 .07872 L
.1381 .07325 L
.14762 .06112 L
.15714 .07671 L
.16667 .09735 L
.17619 .09067 L
.18571 .10342 L
.19524 .07339 L
.20476 .06146 L
.21429 .08903 L
.22381 .07107 L
.23333 .047 L
.24286 .07507 L
.25238 .0815 L
.2619 .08696 L
.27143 .0734 L
.28095 .09581 L
.29048 .01472 L
.3 .08782 L
.30952 .09595 L
.31905 .06738 L
.32857 .08847 L
.3381 .08084 L
.34762 .08582 L
.35714 .05298 L
.36667 .08562 L
.37619 .07808 L
.38571 .04136 L
.39524 .04192 L
.40476 .07545 L
.41429 .09741 L
.42381 .09656 L
.43333 .08321 L
.44286 .04762 L
.45238 .08376 L
.4619 .06938 L
.47143 .08838 L
.48095 .04996 L
.49048 .05337 L
Mistroke
.5 .04971 L
.50952 .07481 L
.51905 .06707 L
.52857 .07043 L
.5381 .0679 L
.54762 .06635 L
.55714 .07325 L
.56667 .08198 L
.57619 .1008 L
.58571 .05662 L
.59524 .08424 L
.60476 .06752 L
.61429 .04281 L
.62381 .07519 L
.63333 .06476 L
.64286 .07128 L
.65238 .06872 L
.6619 .07367 L
.67143 .06529 L
.68095 .07797 L
.69048 .09859 L
.7 .08104 L
.70952 .04298 L
.71905 .06967 L
.72857 .06919 L
.7381 .08899 L
.74762 .06819 L
.75714 .07367 L
.76667 .06006 L
.77619 .05337 L
.78571 .08578 L
.79524 .06834 L
.80476 .07357 L
.81429 .04792 L
.82381 .06542 L
.83333 .09314 L
.84286 .06895 L
.85238 .0821 L
.8619 .07616 L
.87143 .09317 L
.88095 .06857 L
.89048 .05884 L
.9 .08206 L
.90952 .05171 L
.91905 .08097 L
.92857 .07768 L
.9381 .06873 L
.94762 .04639 L
.95714 .04058 L
.96667 .08837 L
Mistroke
.97619 .08915 L
Mfstroke
1 0 0 r
[( )] .97619 .09696 0 0 Mshowa
.02381 .60332 m
.03333 .03933 L
.04286 .07491 L
.05238 .05281 L
.0619 .06653 L
.07143 .10216 L
.08095 .0659 L
.09048 .066 L
.1 .0946 L
.10952 .08347 L
.11905 .06497 L
.12857 .06337 L
.1381 .07332 L
.14762 .09091 L
.15714 .08809 L
.16667 .06348 L
.17619 .0477 L
.18571 .09881 L
.19524 .06418 L
.20476 .07502 L
.21429 .06271 L
.22381 .0745 L
.23333 .06445 L
.24286 .06307 L
.25238 .03997 L
.2619 .07031 L
.27143 .07421 L
.28095 .0754 L
.29048 .07792 L
.3 .07816 L
.30952 .04324 L
.31905 .07902 L
.32857 .04281 L
.3381 .07803 L
.34762 .07863 L
.35714 .0586 L
.36667 .07876 L
.37619 .08228 L
.38571 .08289 L
.39524 .06902 L
.40476 .06637 L
.41429 .04904 L
.42381 .06868 L
.43333 .07989 L
.44286 .06692 L
.45238 .0618 L
.4619 .06002 L
.47143 .06574 L
.48095 .06967 L
.49048 .09986 L
Mistroke
.5 .05075 L
.50952 .07257 L
.51905 .05959 L
.52857 .03515 L
.5381 .06637 L
.54762 .03641 L
.55714 .10589 L
.56667 .09805 L
.57619 .05569 L
.58571 .05154 L
.59524 .07507 L
.60476 .09508 L
.61429 .08164 L
.62381 .06877 L
.63333 .06916 L
.64286 .05418 L
.65238 .08989 L
.6619 .0575 L
.67143 .0745 L
.68095 .08697 L
.69048 .07418 L
.7 .08598 L
.70952 .08225 L
.71905 .08007 L
.72857 .07081 L
.7381 .0815 L
.74762 .06946 L
.75714 .06456 L
.76667 .07395 L
.77619 .06772 L
.78571 .08467 L
.79524 .07503 L
.80476 .05386 L
.81429 .06539 L
.82381 .09617 L
.83333 .05274 L
.84286 .08766 L
.85238 .08673 L
.8619 .06994 L
.87143 .0718 L
.88095 .06621 L
.89048 .06736 L
.9 .05925 L
.90952 .05848 L
.91905 .05642 L
.92857 .07585 L
.9381 .07649 L
.94762 .06335 L
.95714 .08382 L
.96667 .07042 L
Mistroke
.97619 .09696 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd

^*)
