(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, O497, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, preserveAspect, groupLikeInput, M8, N9, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 256; useSolids; automaticGrouping; remoteKernel = "Local"; 
]
:[font = subsection; inactive; initialization; nowordwrap; preserveAspect; plain; startGroup]
Implementierung
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
<<LinearAlgebra`Tridiagonal`
(*
:[font = input; initialization; preserveAspect]
*)
STABILITAET = True




(*
;[s]
1:0,1;23,-1;
2:0,12,10,Courier,1,12,0,0,0;1,12,10,Courier,0,12,0,0,0;
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
TridiagonalSolve1[{a_,b_,c_},x_]:= 
	TridiagonalSolve[Drop[a,1],b,Drop[c,-1],x];
(*
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
TridiagonalMatrix//Clear
TridiagonalMatrix[{a1_,a2_,a3_}] :=
	Module[{n,i,j},
	n = Length[a2];
	Table[Switch[j-i,-1,a1[[j]],
					  0,a2[[i]],
					  1,a3[[i]],
					  _,0]     ,{i,1,n},{j,1,n}]
	]
(*
:[font = input; nowordwrap; preserveAspect; rightWrapOffset = 509; plain; startGroup]
TridiagonalMatrix[{{1,2,3},{4,5,6,7},{8,9,10}}]//MatrixForm
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
MatrixForm[{{4, 8, 0, 0}, {1, 5, 9, 0}, {0, 2, 6, 10}, {0, 0, 3, 7}}]
;[o]
    1  2  3  4

1   4  8  0  0
2   1  5  9  0
3   0  2  6  10
4   0  0  3  7
:[font = input; initialization; nowordwrap; preserveAspect; plain; startGroup]
*)
TridiagonalMult[{a_,b_,c_},x_] := 
	Module[{xa,xc},
	xa = RotateRight[x] ;xa[[1]] = 0;
	xc = RotateLeft [x] ;xc[[Length[x]]] = 0;
    a xa + b x + c xc 
]

TridiagonalMult[{a_,b_,c_},x_,periodisch_] := 
	a RotateRight[x] + b x + c RotateLeft[x] 

(*
:[font = message; inactive; initialization; preserveAspect]
SetDelayed::write: Tag TridiagonalMult in TridiagonalMult[{a_, b_, c_}, x_] is Protected.
:[font = output; output; inactive; initialization; preserveAspect]
$Failed
;[o]
$Failed
:[font = message; inactive; initialization; preserveAspect]
SetDelayed::write: Tag TridiagonalMult in TridiagonalMult[{a_, b_, c_}, x_, periodisch_] is Protected.
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
$Failed
;[o]
$Failed
:[font = input; nowordwrap; preserveAspect; plain]
Clear[a,b,c,x]
:[font = input; nowordwrap; preserveAspect; plain; startGroup]
TridiagonalMult[{a,b,c},Array[x,5]]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
{b*x[1] + c*x[2], a*x[1] + b*x[2] + c*x[3], a*x[2] + b*x[3] + c*x[4], a*x[3] + b*x[4] + c*x[5], a*x[4] + b*x[5]}
;[o]
{b x[1] + c x[2], a x[1] + b x[2] + c x[3], a x[2] + b x[3] + c x[4], a x[3] + b x[4] + c x[5], a x[4] + b x[5]}
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
ImplicitExplicit//Clear
ImplicitExplicit[{a1_,a2_,a3_},{b1_,b2_,b3_},c0_,t_] :=
(* konstante Diagonalen *) 
	Module[{aa1,aa2,aa3,n},
	
	n = Length[c0];
	aa1 = Shape[a1,{n-1}];
	aa2 = Shape[a2,{n}  ];
	aa3 = Shape[a3,{n-1}];
	
	If[{a1,a2,a3}==={0,1,0},
	(* explizit *)
	Print["explizit"];
	NestList[TridiagonalMult[{b1,b2,b3},#]&,c0//N,t]
	,
	If[{b1,b2,b3}==={0,1,0},
	(*implizit*)
	Print["implizit"];
	NestList[TridiagonalSolve[aa1,aa2,aa3,#]&,c0//N,t]
	,
	(*implizit,explizit*)
	Print["implizit,explizit (Crank-Nicholson)"];		
	NestList[
	TridiagonalSolve[aa1,aa2,aa3,TridiagonalMult[{b1,b2,b3},#] ]&,
	c0//N,t]
	]]
	]
(*
:[font = input; initialization; nowordwrap; preserveAspect; rightWrapOffset = 535; plain]
*)
Stabil//Clear
Stabil[{a1_,a2_,a3_},{b1_,b2_,b3_}]:= 
	Module[{A,B,CC,xi}, 
			If[{a1,a2,a3}==={0,1,0},
	    B = TridiagonalMatrix[{b1,b2,b3}];
	    (*Print["B",B//MatrixForm]; *)
					CC = B,
					
					If[{b1,b2,b3}==={0,1,0},
							A = TridiagonalMatrix[{Drop[a1, 1],a2,Drop[a3, -1]}];
	      (*Print["A",A//MatrixForm]; *)
		     CC = Inverse[A],
		     
		     A = TridiagonalMatrix[{Drop[a1, 1],a2,Drop[a3, -1]}];
	      B = TridiagonalMatrix[{b1,b2,b3}];
	      (*Print["A",A//MatrixForm];*)  
	      (*Print["B",B//MatrixForm];*)
		     CC = Inverse[A].B]
		  ];
									  	
	xi = CC//Eigenvalues;
	Print["Minimaler und Maximaler Eigenwert von A^-1 .B   ",xi//Min,"  ",xi//Max];
	];
(*
;[s]
3:0,0;14,1;20,0;692,-1;
2:2,12,10,Courier,0,12,0,0,0;1,12,10,Courier,0,12,65535,0,0;
:[font = input; initialization; nowordwrap; preserveAspect; rightWrapOffset = 535; plain]
*)
ImplicitExplicitG//Clear
ImplicitExplicitG[{a1_,a2_,a3_},{b1_,b2_,b3_},c0_,{C0_,CJ1_}] := 
	Module[{aa1,aa2,aa3,n,f1,f2,f3},
	
	n = Length[c0];
	
	If[STABILITAET,Stabil[{a1,a2,a3},{b1,b2,b3}]];
	
	
	If[{a1,a2,a3}==={0,1,0},
	
	(* explizit *)
	Print["explizit"];
	rhoB ={First[b1]C0,Last[b3]CJ1}//Transpose;
	drho = - Drop[rhoB,-1];
	
	f1[c_,drho_]:= 
		Module[{bc},	
			bc = TridiagonalMult[{b1,b2,b3},c];
			bc[[1]] += drho[[1]];
			bc[[n]] += drho[[2]];  
			bc
	];
			
	FoldList[f1[#1,#2]&, c0//N,-drho]
	
	,(*else*)
	
	aa1 = Drop[a1, 1];
	aa2 = a2;
	aa3 = Drop[a3,-1];
	
	If[{b1,b2,b3}==={0,1,0},
	(*implizit*)
	Print["implizit"];
	rhoA ={First[a1]C0,Last[a3]CJ1}//Transpose;
	drho = Drop[rhoA,1];
	
	f2[c_,drho_]:= 
		Module[{bc},	
			bc = c;
			bc[[1]] += drho[[1]];
			bc[[n]] += drho[[2]];  
			TridiagonalSolve[aa1,aa2,aa3,bc]
	];
			
	FoldList[f2[#1,#2]&, c0//N,-drho]
	,
	
	(*implizit,explizit*)
	Print["implizit,explizit (Crank-Nicholson)"];
	rhoA ={First[a1]C0,Last[a3]CJ1}//Transpose;
	rhoB ={First[b1]C0,Last[b3]CJ1}//Transpose;
	drho = Drop[rhoA,1] - Drop[rhoB,-1];
	
	f3[c_,drho_]:= 
		Module[{bc},	
			bc = TridiagonalMult[{b1,b2,b3},c];
			bc[[1]] += drho[[1]];
			bc[[n]] += drho[[2]];  
			TridiagonalSolve[aa1,aa2,aa3,bc]
	];
			
	FoldList[f3[#1,#2]&, c0//N,-drho]
	]
	]
	]
	
(*
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
ImplicitExplicitT//Clear
ImplicitExplicitT[A_,B_,c0_,{C0_,CJ1_}] := 
	Module[{aa1,aa2,aa3,n,f1,f2,f3},
	
	n = Length[c0];
	
	If[A==={0,1,0},
	
	(* explizit *)
	Print["explizit"];
	
	rhoB = {Map[First[Part[#,1]]&,B]C0,Map[Last[ Part[#,3]]&,B]CJ1}//Transpose;
	drho = - Drop[rhoB,-1];
	
	f1[c_,{{b1_,b2_,b3_},drho_}]:= 
		Module[{bc},	
			bc = TridiagonalMult[{b1,b2,b3},c];
			bc[[1]] += drho[[1]];
			bc[[n]] += drho[[2]];  
			bc
	];
			
	FoldList[f1[#1,#2]&, c0//N,{Drop[B,-1],-drho}//Transpose]
	
	
	,(*else*)
	
	If[B==={0,1,0},
	(*implizit*)
	Print["implizit"];
	
	rhoA = {Map[First[Part[#,1]]&,A]C0,Map[Last[ Part[#,3]]&,A]CJ1}//Transpose;
	drho = Drop[rhoA,1];
	
	f2[c_,{{a1_,a2_,a3_},drho_}]:= 
		Module[{bc},	
			bc = c;
			bc[[1]] += drho[[1]];
			bc[[n]] += drho[[2]];  
			TridiagonalSolve[Drop[a1,1],a2,Drop[a3,-1],bc]
	];
			
	FoldList[f2[#1,#2]&, c0//N,{Drop[A,1],-drho}//Transpose]
	
	,
	
	(*implizit,explizit*)
	Print["implizit,explizit (Crank-Nicholson)"];
	
	rhoA = {Map[First[Part[#,1]]&,A]C0,Map[Last[ Part[#,3]]&,A]CJ1}//Transpose;
	rhoB = {Map[First[Part[#,1]]&,B]C0,Map[Last[ Part[#,3]]&,B]CJ1}//Transpose;
	drho = Drop[rhoA,1] - Drop[rhoB,-1];
	
	f3[c_,{{a1_,a2_,a3_},{b1_,b2_,b3_},drho_}]:= 
		Module[{bc},	
			bc = TridiagonalMult[{b1,b2,b3},c];
			bc[[1]] += drho[[1]];
			bc[[n]] += drho[[2]];  
			TridiagonalSolve[Drop[a1,1],a2,Drop[a3,-1],bc]
	];
			
	FoldList[f3[#1,#2]&, c0//N,{Drop[A,1],Drop[B,-1],-drho}//Transpose]
	]
	]
	]
(*
:[font = input; initialization; nowordwrap; preserveAspect; plain; startGroup]
*)
TridiagonalMult[{{a1,a2,a3},{b1,b2,b3},{c1,c2,c3}},{x1,x2,x3}]//Timing
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{0.00999999999999979*Second, {b1*x1 + c1*x2, a2*x1 + b2*x2 + c2*x3, a3*x2 + b3*x3}}
;[o]
{0.01 Second, {b1 x1 + c1 x2, a2 x1 + b2 x2 + c2 x3, a3 x2 + b3 x3}}
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
RueckwaertsGleichung//Clear
RueckwaertsGleichung[S0_,S1_,JJ_,t0_,t1_,T_,EndBedingung_,RandBedingung_,
					 drift_,diffusion_,v_,theta_,lambda_]:= 
					 
Module[{ds,dt,g1,g2,Sj,y0,t,fj,omegaj,vj,Ldt,A,B,yijCN},

ds = (S1-S0)/JJ//N;
dt = (t1-t0)/T//N;
g1 = dt/(2ds);
g2 = g1/ds;
Sj = Range[S0,S1,ds];
y0 = EndBedingung[Sj];
t = 0; (* keine Abh. von t *)
fj = drift[Sj,t,theta];
omegaj = diffusion[Sj,t,theta]^2;
vj = v[Sj,t,theta];

Ldt =
	g1 {-fj, 0, fj} + 
	g2 {omegaj,-2 omegaj,omegaj} + 
	dt {0, vj, 0};

A = {0,1,0} + (lambda-1)Ldt;        
B = {0,1,0} +  lambda   Ldt;
If[lambda == 1, A = {0,1,0},A = {0,1,0} + (lambda-1)Ldt];
If[lambda == 0, B = {0,1,0},B = {0,1,0} +  lambda   Ldt];  
Print["g1 = ",g1,"  g2 = ",g2];

yijCN = ImplicitExplicitG[A,B,y0,RandBedingung]
]
 
(*
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
VorwaertsGleichung//Clear
VorwaertsGleichung[S0_,S1_,JJ_,t0_,t1_,T_,AnfangsBedingung_,RandBedingung_,
					 drift_,diffusion_,v_,theta_,lambda_]:=
					  
(* pt == F(y)p; pt - L(x)p == 0 AB p(yt|xs) = delta(x-y) *)
					 
Module[{ds,dt,g1,g2,fj,omegaj,vj,Ldt,A,B,yijCN},

ds = (S1-S0)/JJ//N;
dt = (t1-t0)/T//N;
g1 = dt/(2ds);
g2 = g1/ds;
Sj = Range[S0,S1,ds];
y0 = AnfangsBedingung[Sj];

fj = drift[Sj,t,theta];
omegaj = diffusion[Sj,t,theta]^2;
vj = v[Sj,t,theta];

	(*Ldt = {-g1 fj + g2 omegaj,-2 g2 omegaj + vj dt,g1 fj + g2 omegaj};*)

Ldt =
	g1 {-fj, 0, fj} + 
	g2 {omegaj,-2 omegaj,omegaj} + 
	dt {0, vj, 0};
	
A = {0,1,0} -    lambda  Ldt;        
B = {0,1,0} + (1-lambda) Ldt;
If[lambda == 0, A = {0,1,0}];
If[lambda == 1, B = {0,1,0}];  
Print["g1 = ",g1,"  g2 = ",g2];
(*Print["A",A];
  Print["B",B];*)
yijCN = ImplicitExplicitG[A,B,y0,RandBedingung]
] 


(*
:[font = input; initialization; nowordwrap; preserveAspect; rightWrapOffset = 540; plain]
*)
RueckwaertsGleichungT//Clear
RueckwaertsGleichungT[S0_,S1_,JJ_,t0_,t1_,T_,EndBedingung_,
        RandBedingung_,drift_,diffusion_,v_,X_,theta_,lambda_]:= 
					 
Module[{ds,dt,g1,g2,fij,omegaij,vij,Ldt,i,L,A,B,yijCN},

ds = (S1-S0)/JJ//N;
dt = (t1-t0)/T//N;
g1 = dt/(2ds);
g2 = g1/ds;
Sj = Range[S0,S1,ds];
y0 = EndBedingung[Sj];
fij = Map[drift[Sj,#,theta]&,X];
omegaij = Map[(diffusion[Sj,#,theta]^2)&,X];
vij = Map[v[Sj,#,theta]&,X];

Ldt[f_,omega_,vv_] :=
	g1 {-f, 0, f} + 
	g2 { omega,-2 omega, omega} + 
	dt { 0, vv, 0};

L = MapThread[Ldt[#1,#2,#3]&,{fij,omegaij,vij}];
i = Shape[1,{T+1}]/. 1->{0,1,0};
A = i + (lambda-1)L;
B = i +  lambda   L;

(*
A = MapThread[({0,1,0} + (lambda-1)Ldt[#1,#2,#3])&,{fij,omegaij,vij}];
B = MapThread[({0,1,0} +  lambda   Ldt[#1,#2,#3])&,{fij,omegaij,vij}];
*)
If[lambda == 1, A = {0,1,0}];
If[lambda == 0, B = {0,1,0}];  
Print["g1 = ",g1,"  g2 = ",g2];
(*Print["A",A];
  Print["B",B];*)
  
yijCN = ImplicitExplicitT[A//Reverse,B//Reverse,y0,RandBedingung]

]
 
(*
:[font = input; initialization; nowordwrap; preserveAspect; plain]
*)
FokkerPlanck//Clear
FokkerPlanck[S0_,S1_,JJ_,t0_,t1_,T_,AnfangsBedingung_,RandBedingung_,
					 drift_,diffusion_,v_,theta_,lambda_]:=
					  
(* pt == F(y)p; AB p(yt|xs) = delta(x-y) *)
					 
Module[{ds,dt,g1,g2,fj,omegaj,vj,Fdt,A,B,yijCN},

ds = (S1-S0)/JJ//N;
dt = (t1-t0)/T//N;
g1 = dt/(2ds);
g2 = g1/ds;
Sj = Range[S0,S1,ds];
y0 = AnfangsBedingung[Sj];

fj = drift[Sj,t,theta];
omegaj = diffusion[Sj,t,theta]^2;
vj = v[Sj,t,theta];

Fdt = -g1 {-RotateRight[fj,1],0,RotateRight[fj,-1]} + 
       g2 { RotateRight[omegaj,1],-2 omegaj,RotateRight[omegaj,-1]} + 
       dt { 0, vj, 0};

A = {0,1,0} -    lambda  Fdt;        
B = {0,1,0} + (1-lambda) Fdt;
If[lambda == 0, A = {0,1,0}];
If[lambda == 1, B = {0,1,0}];  
Print["g1 = ",g1,"  g2 = ",g2];
(*Print["A",A];
  Print["B",B];*)
yijCN = ImplicitExplicitG[A,B,y0,RandBedingung]
] 


(*
:[font = input; nowordwrap; preserveAspect; plain; startGroup]
??Ldt
:[font = print; inactive; preserveAspect; endGroup; endGroup]
Global`Ldt

Ldt[f_, omega_, v_] := g1*Outer[Times, {-1, 0, 1}, f] + g2*Outer[Times, {1, -2, 1}, omega] + dt*Outer[Times, {0, 1, 0}, v]
^*)
