(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, O467, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, O467, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, O467, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, O467, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, O467, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, O467, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  14, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M10, N23, O467, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M10, N23, O467, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M10, N23, O467, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M10, N23, O467, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M10, N23, O467, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, O467, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	fontset = leftheader, inactive, O467, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7, O467,  12, "Times"; 
	fontset = leftfooter, inactive, O467, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O467,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
GLATT2//Clear
GLATT2[Z_,X_,DT_,THETA_,PHI_,NONLIN_] :=
(***************************************************************)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,Y0,P0,LIK0,LIK,
		Z0,MUEN,SIGMAN,X0,YG,PG,YF,PF,K,P,Q,N,T,T1},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
{T1,K,N} = Dimensions[Z];
{P,Q} = Dimensions[BSTERN];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN={SIGMA};

{Y0,P0,LIK0,inn0,stdinn0} = MessUp2[Z0,MUEN,SIGMAN,X0,H,D,R,{N,P}]; 
{YG,PG,YF,PF,LIK,INN,STDINN} = Glatt2[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R];

LIK=LIK - .5 LIK0;

{YG,PG,YF,PF,LIK,Join[{inn0},INN],Join[{stdinn0},STDINN]}
]

(***************************************************************)
Glatt2[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
(***************************************************************)
	Module[{T,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
			lik,liki,inn,inni},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		{p,n} = Dimensions[Y0];
		T = Length[Z] -1;
		
		Print["{k,p,q,n,T} = ",{k,p,q,n,T}];
		
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = {Ostern};
		inn = {};
	    stdinn = {};
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
					
	        {Yii,Pii,liki,inni,stdinni} = 
	        	MessUp2[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
	       
	        lik += liki;
	        
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        inn = Append[inn,inni];
	        stdinn = Append[stdinn,stdinni];	
	        
	        
		,{i,T}];
		
		(*
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
								     {Yii,Pii,Yi1i,Pi1i},Astern];
			
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			
		
		,{i,T,1,-1}];
		*)
		
		lik = -.5 lik;
		{YG,PG,YF,PF,lik,inn,stdinn}
	]
(*
:[font = input; preserveAspect; startGroup]
??Glatt2
:[font = print; inactive; preserveAspect; endGroup]
Global`Glatt2

Glatt2[Y0_, P0_, Z_, X_, Astern_, Bstern_, Ostern_, H_, D_, R_] := 
  Module[{T, k, p, q, YF, PF, YG, PG, Y1, P1, YGalt, PGalt, i, ON, Yii, Pii, Yi1i, Pi1i, lik, liki, inn, inni}, {k, p} = Dimensions[H]; {k, q} = Dimensions[D]; {p, n} = Dimensions[Y0]; T = Length[Z] - 1; Print["{k,p,q,n,T} = ", {k, p, q, n, T}]; Yii = Y0; YF = {Y0}; Y1 = {}; Pii = P0; PF = {P0}; 
    P1 = {}; lik = 0; ON = {Ostern}; inn = {}; stdinn = {}; Do[{Yi1i, Pi1i} = TimeUp[Yii, Pii, X[[i]], Astern, Bstern, ON]; {Yii, Pii, liki, inni, stdinni} = MessUp2[Z[[i + 1]], Yi1i, Pi1i, X[[i + 1]], H, D, R, {n, p}]; lik += liki; YF = Append[YF, Yii]; PF = Append[PF, Pii]; 
      Y1 = Append[Y1, Yi1i]; P1 = Append[P1, Pi1i]; inn = Append[inn, inni]; stdinn = Append[stdinn, stdinni]; Null, {i, T}]; lik = -0.5*lik; {YG, PG, YF, PF, lik, inn, stdinn}]
:[font = input; initialization; preserveAspect]
*)
	
(***************************************************************)
MessUp2[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,{n_,p_}] :=
(***************************************************************)
	Module[{pi1in,vint,vi1,gain,inn,stdinn,ikh,Yii,Pii,lik},		
		
	pi1in = Pi1i[[1]];
	vint = H . pi1in . Transpose[H] + R;
	vi1 = Inverse[vint];
	vi1=0.5(vi1+(vi1//Transpose));
	gain = pi1in . Transpose[H] . vi1;
	inn = Z - H . Yi1i - D . X;
	stdinn = Transpose[CholeskyDecomposition[vi1]].inn;
	lik = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
	Yii = Yi1i + gain.inn;
	ikh = IdentityMatrix[p] - gain.H;
	Pii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};						 	
	{Yii,Pii,lik,inn,stdinn}
	   
	](* End MessUp ohne missing *) 
		 	
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
autokov//Clear
autokov[y_,lag_,Mean_:0]:= Module[{t1,m,y1},
(***************************************************************)
(* Autokovarianzfunktion, (1/T)Summe(yi+lag)*yi`*)
(* vgl. Ltkepohl 138ff*)

t1=Length[y];
If[Mean === 0,

	Apply[Plus,Delta[y,y,Outer[Times,#1,#2]&,lag]]/t1,
	
	m = mean[y]; Print["mit Mittelwert"];
	y1 = Map[(#-m)&,y]; 
	Apply[Plus,Delta[y1,y1,Outer[Times,#1,#2]&,lag]]/t1]
]

(*
:[font = input; preserveAspect; startGroup]
SeedRandom[999];r = autokov[Table[UniC[],{50},{3}],1,free]//MatrixForm
SeedRandom[999];r = autokov[Table[UniC[],{50},{3}],1]//MatrixForm
:[font = message; inactive; preserveAspect]
General::spell1: Possible spelling error: new symbol name "free" is similar to existing symbol "tree".
:[font = print; inactive; preserveAspect]
mit Mittelwert
:[font = output; output; inactive; preserveAspect; fontLeading = 0]
MatrixForm[{{0.2795267463096199, -0.2193791979637147, -0.1594154035484183}, {0.07095657534627034, -0.003229902087851784, -0.01011453421569261}, {0.1249338016626342, 0.06752955658610033, -0.1483301715680698}}]
;[o]
    1          2          3

1   0.279527   -0.219379  -0.159415
2   0.0709566  -0.0032299 -0.0101145
3   0.124934   0.0675296  -0.14833
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
MatrixForm[{{0.3429223081296176, -0.2161904463480724, -0.1446725009268314}, {0.07740583774975835, -0.003196348779080216, -0.00835666459688279}, {0.1264424913087601, 0.06684836823247592, -0.1473075559846042}}]
;[o]
    1           2           3

1   0.342922    -0.21619    -0.144673
2   0.0774058   -0.00319635 -0.00835666
3   0.126442    0.0668484   -0.147308
:[font = input; preserveAspect; startGroup]
Delta[{a,b,c,d},{aa,bb,cc,dd},Dot[#1,#2//Transpose]&,2]
autokov[{a,b,c,d},1]

:[font = output; output; active; preserveAspect]
{c . Transpose[aa], d . Transpose[bb]}
;[o]
{c . Transpose[aa], d . Transpose[bb]}
:[font = message; active; preserveAspect]
Outer::normal: Normal expression expected at position 2 in Outer[Times, b, a].
:[font = message; active; preserveAspect]
Outer::normal: Normal expression expected at position 2 in Outer[Times, c, b].
:[font = message; active; preserveAspect]
Outer::normal: Normal expression expected at position 2 in Outer[Times, d, c].
:[font = message; active; preserveAspect]
General::stop: Further output of Outer::normal will be suppressed during this calculation.
:[font = output; output; active; preserveAspect; endGroup]
(Outer[Times, b, a] + Outer[Times, c, b] + Outer[Times, d, c])/4
;[o]
Outer[Times, b, a] + Outer[Times, c, b] + Outer[Times, d, c]
------------------------------------------------------------
                             4
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)
DIAGNOSE//Clear
DIAGNOSE[maxlag_,u_,Z_,X_,DT_,nselect_,tselect_,THETA_,PHI_,NONLIN_,PRINT_]:= 
(***************************************************************)
 Module[{YG,PG,YF,PF,LIK,INNO,STDINN,T1,K,N,T,k2,tab,ns,gamman,
 		 rhon,j,jj,inn,c0,gamma,rho,c01,p,p0,clag,rlag,rmlag,
 		 tr,df,prob,probmod,zeta,M,zetaq,S,kt1,det,likratio,pn,cum},
 
(*Innovations-Prozess                            *)
(*FILTER  MIT ANFANGSBEDINGUNG Y0=E[Y0|Z0]       *)
(*                             P0=V[Y0|Z0]       *)

Print["**********************************************************************"];
Print["***********************MODUL: DIAGNOSE********************************"];
Print["**********************************************************************"];

{YG,PG,YF,PF,LIK,INNO,STDINN} = GLATT2[Z,X,DT,THETA,PHI,NONLIN];

INNO   = Take[INNO,  tselect]; 
STDINN = Take[STDINN,tselect];

INNO=STDINN;
Print["Analyse der standardisierten Innovationen Gamma^-.5 nue"];

{t1, t2} = tselect;
Print[ "---------------------------------------------------"];
Print["Selektion {t1, t2} = ",tselect];
Print[ "---------------------------------------------------"];

{T1,K,N} =Dimensions[INNO];

T = T1-1; 
k2 = K^2;
tab = TableForm[#,TableDirections->{Column,Column,Row}]&;
If[PRINT[[1]]==1,Print["Innovationsprozess  ",INNO//tab]];

Print[ "---------------------------------------------------"];
pn = pNorm[INNO//Flatten,2];
Print["2-Norm der Innovation (Summe nue_tpn^2)^(1/2): ",pn];
Print[ "---------------------------------------------------"];
Print["getrennte Analyse der Einheiten  ",nselect];
Print[ "---------------------------------------------------"];
ns = Length[nselect];
gamman = {}; rhon = {};


Do[ 
    j=nselect[[jj]];
    inn=INNO[[T1//Range,K//Range,j]]; (* j-te Einheit *)
    c0 = autokov[inn,0];
    gamma={c0};
    rho={IdentityMatrix[K]};
    c01=Inverse[c0];
    p=0;pmod=0;
    
    Print["---------------Statistische Einheit----------------:  ",j];
    If[PRINT[[2]]==1,Print["Autokovarianz der Residuen",gamma//tab]];
    If[PRINT[[3]]==1,Print["Autokorrelation der Residuen",rho//tab]];
    	
    cum={};
    
    Do[
         clag = autokov[inn,lag];
         rlag=clag.c01;
         rmlag=Transpose[clag].c01;
         gamma=Append[gamma,clag];
         rho=Append[rho,rlag];
         tr=MatrixTrace[rmlag.rlag];
         p = p + tr;
         pmod = pmod + tr/(T1-lag);
         
         df=k2*lag-u;
         
         If[df>0,
         
         prob   =1-CDF[ChiSquareDistribution[df],T1*p];
         probmod=1-CDF[ChiSquareDistribution[df],T1*T1*pmod];
                
         cum=Append[cum,{{lag,df},{T1*p,prob,T1*T1*pmod,probmod}//N5}//Flatten];
         
         ];

          
    ,{lag,1,maxlag}];
    
Print[ "---------------------------------------------------"];
Print["Multivariate Portmanteau-Statistik (Hosking 1980)"];
Print[ "---------------------------------------------------"];
Print[" K = ",K,", u = ",u, ", maxlag = ",maxlag, ", df = K^2 lag - u"]; 
Print[""]; 
Print[cum//Chop//MatrixForm[#,
TableHeadings->{None,{"lag","df","P","prob","Pmod","probmod"}}]&];
plot1[Column[cum,{4,6}]//AddTimeAxis];   
    

rhon=Append[rhon,rho];
gamman=Append[gamman,gamma];


plot1[inn//AddTimeAxis[#,Join[(tselect-1)DT,{DT}]]&,
		PlotLabel->"Innovations-Prozess"];
(*		
plot1[flatten[rho,{2,3}]//AddTimeAxis,
	PlotLabel->"Autokorrelation der Innovation: C(t)C(0)^(-1)",
	PlotRange->{All,{-1,1}}];
*)

ki = 1.96/Sqrt[t2-t1];	
plot1[Map[VecDiag,rho]//AddTimeAxis[#,{t1,t1+maxlag,1}]&,
	PlotLabel->"Autokorrelation der Innovation: C(t)C(0)^(-1)",
	PlotRange->{All,{-1,1}},
	GridLines->{None,{ki,-ki}}];

,{jj,1,ns}];


If[ N > 1,
    Print[ "---------------------------------------------------"];
    Print[ "simultane Analyse aller Einheiten (Panel, N > 1)"];
    Print[ "---------------------------------------------------"];
    zeta = flatten[STDINN,{1,2}];
    M=(zeta.Transpose[zeta])/N;
    zetaq=mean[zeta//Transpose];
    S=M-Outer[Times,zetaq,zetaq];
    Print[ "---------------------------------------------------"];
    Print["normierte Innovationen <(k,T1) . N>"];
    Print[ "---------------------------------------------------"];
    Print[zeta//N4//MatrixForm];
    Print[ "---------------------------------------------------"];
    Print["1. und 2. Moment um 0 der standardisierten Residuen: zetaq, M"];
    Print[ "---------------------------------------------------"];
    Print[zetaq//MatrixForm];
    Print[M//N4//MatrixForm];
    Print[ "---------------------------------------------------"];
    Print["Standardabweichung S = M-zetaq*zetaq`"];
    Print[ "---------------------------------------------------"];
    Print[S//N4//MatrixForm];
    kt1=K*T1;
    det = If[pNorm[S//Flatten,2]==0,0,Det[S]];
    likratio=-N*(Log[det]+ kt1 - MatrixTrace[M]);
    df=(1.5 + 0.5*kt1)*kt1;
    prob=1-CDF[ChiSquareDistribution[df],likratio];
    Print[ "---------------------------------------------------"];
    Print["Asymptotischer Likelihood-Quotienten-Test"];
    Print[ "---------------------------------------------------"];
    Print["{likratio,df,prob} = ", {likratio,df,prob}];
];

{INNO,gamman,rhon}

];
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
DIAGNOSESIM//Clear
DIAGNOSESIM[maxlag_,pq_,Z_,X_,DT_,nselect_,tselect_,THETA_,PHI_,NONLIN_,PRINT_]:= 
(***************************************************************)
 Module[{YG,PG,YF,PF,LIK,INNO,STDINN,T1,K,N,T,k2,tab,ns,gamman,
 		 rhon,j,jj,inn,c0,gamma,rho,c01,p,p0,clag,rlag,rmlag,
 		 tr,df,prob,probmod,zeta,M,zetaq,S,kt1,det,likratio,pn},
 
(*Innovations-Prozess                            *)
(*FILTER  MIT ANFANGSBEDINGUNG Y0=E[Y0|Z0]       *)
(*                             P0=V[Y0|Z0]       *)
(*
Print["**********************************************************************"];
Print["***********************MODUL: DIAGNOSE********************************"];
Print["**********************************************************************"];
*)

{YG,PG,YF,PF,LIK,INNO,STDINN} = GLATT2[Z,X,DT,THETA,PHI,NONLIN];

INNO = Take[INNO,tselect];
STDINN = Take[STDINN,tselect];
(*
Print[ "---------------------------------------------------"];
Print[ "Selektion {t1, t2} = ",tselect];
Print[ "---------------------------------------------------"];
*)

{T1,K,N} =Dimensions[INNO];
T = T1-1; 
k2 = K^2;
tab = TableForm[#,TableDirections->{Column,Column,Row}]&;
If[PRINT[[1]]==1,Print["Innovationsprozess  ",INNO//tab]];

pn = pNorm[INNO//Flatten,2];
Print["Innovation ",TensorMS[INNO]];
Print["std-Innov. ",TensorMS[STDINN]];

(*
Print[ "---------------------------------------------------"];
Print["2-Norm der Innovation (Summe nue_tpn^2)^(1/2): ",pn];
Print[ "---------------------------------------------------"];
*)

Return[pn];


Print["getrennte Analyse der Einheiten  ",nselect];
Print[ "---------------------------------------------------"];
ns = Length[nselect];
gamman = {}; rhon = {};

Do[ 
    j=nselect[[jj]];
    inn=INNO[[T1//Range,K//Range,j]]; (* j-te Einheit *)
    c0 = autokov[inn,0];
    gamma={c0};
    rho={IdentityMatrix[K]};
    c01=Inverse[c0];
    p=0;pmod=0;
    
    Do[
         clag = autokov[inn,lag];
         rlag=clag.c01;
         rmlag=Transpose[clag].c01;
         gamma=Append[gamma,clag];
         rho=Append[rho,rlag];
         tr=MatrixTrace[rmlag.rlag];
         p = p + tr;
         pmod = pmod + tr/(T1-lag);
          
    ,{lag,1,maxlag}];

rhon=Append[rhon,rho];
gamman=Append[gamman,gamma];
p=T1*p;
pmod=T1*T1*pmod;

df=k2*(maxlag-pq);

prob   =1-CDF[ChiSquareDistribution[df],p];
probmod=1-CDF[ChiSquareDistribution[df],pmod];
Print["---------------Statistische Einheit----------------:  ",j];
If[PRINT[[2]]==1,Print["Autokovarianz der Residuen",gamma//tab]];
If[PRINT[[3]]==1,Print["Autokorrelation der Residuen",rho//tab]];
Print[ "---------------------------------------------------"];
Print["Multivariate Portmanteau-Statistik (Hosking 1980)"];
Print[ "---------------------------------------------------"];
Print["{p,prob,df=k^2 (maxlag-pq),maxlag}= ", {p,prob,df,maxlag}];
Print[ "---------------------------------------------------"];
Print["Modifizierte Portmanteau-Statistik (Hosking 1980)"];
Print[ "---------------------------------------------------"];
Print["{pmod,probmod,df=k^2 (maxlag-pq),maxlag} = ",{pmod,probmod,df,maxlag}];
Print[ "---------------------------------------------------"];

plot1[inn//AddTimeAxis[#,Join[(tselect-1)DT,{DT}]]&,
		PlotLabel->"Innovations-Prozess",
		farbmodell->Hue];
		
plot1[flatten[rho,{2,3}]//AddTimeAxis,
	PlotLabel->"Autokorrelation der Innovation: C(t)C(0)^(-1)",
	farbmodell->Hue,PlotRange->{All,{-1,1}}];

,{jj,1,ns}];


If[ N > 1,
    Print[ "---------------------------------------------------"];
    Print[ "simultane Analyse aller Einheiten (Panel, N > 1)"];
    Print[ "---------------------------------------------------"];
    zeta = flatten[STDINN,{1,2}];
    M=(zeta.Transpose[zeta])/N;
    zetaq=mean[zeta//Transpose];
    S=M-Outer[Times,zetaq,zetaq];
    Print[ "---------------------------------------------------"];
    Print["normierte Innovationen <(k,T1) . N>"];
    Print[ "---------------------------------------------------"];
    Print[zeta//N4//MatrixForm];
    Print[ "---------------------------------------------------"];
    Print["1. und 2. Moment um 0 der standardisierten Residuen: zetaq, M"];
    Print[ "---------------------------------------------------"];
    Print[zetaq//MatrixForm];
    Print[M//N4//MatrixForm];
    Print[ "---------------------------------------------------"];
    Print["Standardabweichung S = M-zetaq*zetaq`"];
    Print[ "---------------------------------------------------"];
    Print[S//N4//MatrixForm];
    kt1=K*T1;
    det = If[pNorm[S//Flatten,2]==0,0,Det[S]];
    likratio=-N*(Log[det]+ kt1 - MatrixTrace[M]);
    df=(1.5 + 0.5*kt1)*kt1;
    prob=1-CDF[ChiSquareDistribution[df],likratio];
    Print[ "---------------------------------------------------"];
    Print["Asymptotischer Likelihood-Quotienten-Test"];
    Print[ "---------------------------------------------------"];
    Print["{likratio,df,prob} = ", {likratio,df,prob}];
];

{INNO,gamman,rhon}

];
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
NEWTONSIM[THETA0_,KMAX_,EPS_,M0_,M00_,M_,DT_,n_,T_,OPTION_,NONLIN_,PRINT_] := 
(***************************************************************)
Module[
{THETA,MAXSTEP,MINSTEP,BOUND,U,K,S,H,LIKELI,vdach,DVDTH,DASDTH,
 DBSDTH,DSIGDTH,DMUEDTH,V,ASTERN,BSTERN,SIGMA,MUE,liktheta,LIKALT,
 ALPHA,THETA1,LIKNEU,STEP,STEPL,t},

MAXSTEP=10.^3;
MINSTEP=10.^-10;
BOUND=10.^-4;
ALPHA=10^-4;
U=Length[THETA0];

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: NEWTON**************************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,DT,n,T,OPTION,NONLIN,MAXSTEP,MINSTEP,BOUND}//Spalte,
         {"KMAX","EPS","DT","n","T","OPTION","NONLIN","MAXSTEP",
          "MINSTEP","BOUND"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0];
];

THETA=THETA0;
liktheta = {};
(*NUMABL[THETA0,DT,$MachineEpsilon^.5,M0,M00,M,n,T,NONLIN];*)

DoUntil[{K,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS, 
  	
  	If[PRINT[[2]] == 1,
  	Print["-----------------------------------------------------------------"];
    Print["NEWTON: Iteration = ",K];
    ];
   
    {S,H,LIKALT,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
     V,ASTERN,BSTERN,SIGMA,MUE} = SH[THETA,DT,M0,M00,M,n,T,NONLIN];
    liktheta = Append[liktheta, Join[{LIKALT},THETA]];
    
	If[OPTION == 1, H = SHIFT[H,BOUND] ];
	
    STEP=LinearSolve[H,S];

    (*BEGRENZUNG DER SCHRITTLNGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];
    

    (*STEP-HALVING*)
   
    THETA1=THETA+STEP;   (*VOLLER NEWTON-STEP*)
    LIKNEU = LIK2[THETA1,DT,M0,M00,M,n,T,NONLIN];
    DoWhile[{Z,100},
         	(LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          		Max[Abs[STEP]]>MINSTEP),
         STEP=STEP*.5;
         
         If[PRINT[[3]] == 1,
         Print["STEP-HALVING:  ",Z,"  LIKNEU  ", LIKNEU,"  LIKALT  ", LIKALT];
         ];
         
         THETA1=THETA+STEP;
         LIKNEU = LIK2[THETA1,DT,M0,M00,M,n,T,NONLIN];

    ]; (*End DoWhile*)
    
    If[PRINT[[4]] == 1,
    Print[""];
    Print["LIKNEU ", PaddedForm[LIKNEU,{20,15}],
    	  " LIKALT ", PaddedForm[LIKALT,{20,15}],
    	  " LIKNEU-LIKALT ", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    Print[""];
    ];
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA, STEP, S}//Transpose,
    TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}]];
    Print[""];
    ];
    
    If[PRINT[[6]] == 1,
    Print[H//MatrixForm]]; 
    
    THETA=THETA1;
    k = K;
   
]; (*End DoUntil*)

If[PRINT[[7]] == 1,
Print[ "NEWTON: ENDE DER ITERATION  ",k,"  ",KMAX]];


{S,H,LIKELI,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
 	V,ASTERN,BSTERN,SIGMA,MUE} = SH[THETA,DT,M0,M00,M,n,T,NONLIN];

liktheta = Append[liktheta,Join[{LIKELI},THETA]];

If[PRINT[[8]] == 1,
Print[MatrixForm[liktheta,
	TableHeadings->{Automatic,{"Likelihood","Theta"}}]]];


(*	
COV = OUTPUT[THETA,H,.05,S,LIKELI];
LKOMP[LIKELI,U,n*(T+1)];
DELTA[COV,THETA];
DELTASTERN[COV,THETA,DT,NONLIN];
*)

COV = Inverse[H];
{THETA,COV,liktheta,k}
]


(*
^*)
