(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   2515235,      65227]*)
(*NotebookOutlinePosition[   2516652,      65272]*)
(*  CellTagsIndexPosition[   2516514,      65265]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["SetOptions[plot1,dicke->.01];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[{
    \(\(\(@\)\(ARTICLE\)\) {Singer : 
          1995, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {Analytical\ score\ function\ for\ irregularly\ \
sampled\ \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ continuous\ time\ \
stochastic\ processes\ with\ control\[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \
\ variables\ and\ missing\ values}, \[IndentingNewLine]JOURNAL = {Econometric\
\ Theory}, \[IndentingNewLine]VOLUME = {11}, \[IndentingNewLine]PAGES = \
{\(721--\) 
              735}, \[IndentingNewLine]YEAR = {1995}}\[IndentingNewLine]\), "\
\[IndentingNewLine]", 
    \(\(\(@\)\(INCOLLECTION\)\) {Singer : 
          2006  b, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {{Stochastic\ Differential\ Equation\ Models\ with\
\ Sampled\ Data}}, \[IndentingNewLine]BOOKTITLE = {Longitudinal\ Models\ in\ \
the\ Behavioral\ and\ related\ Sciences}, \[IndentingNewLine]SERIES = {{The\ \
European\ Association\ of\ Methodology\ \((EAM)\)\ Methodology\ and\ \
\[IndentingNewLine]Statistics\ series, 
              vol . II}}, \[IndentingNewLine]PUBLISHER = {Erlbaum\ \
publishers}, \[IndentingNewLine]YEAR = {2006}, \[IndentingNewLine]EDITOR = \
{van\ Montfort, K . and\ Oud, 
            H . and\ Satorra, \(\(A\)\(.\)\)}, \[IndentingNewLine]NOTE = {}, \
\[IndentingNewLine]PAGES = {}}\ \ \), "\[IndentingNewLine]", 
    \(\(\(=\)\(SDGL . pdf\)\)\)}], "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  FontColor->RGBColor[0, 0, 1]],

Cell[CellGroupData[{

Cell["Packages", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["<<code`LSD`", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["<<Miss9_1.m", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \\!\\(DMS\\) \
in \\!\\(DMS[\\(\\(Y_, X_\\)\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Model", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
PAR//Clear;
(***************************************************************)
PAR[{t1_,t2_,t3_,t4_,t5_,t6_}] := 
(***************************************************************)
Module[{OMEGA,A,B,SIGMA,MUE},

A={{0,  1},
   {t1,t2}};

B= {{ 0},
    {t3}};

G={{.0001,0 },
   {0    ,t4}};
OMEGA=G.Transpose[G];
MUE= {t5,t6};
SIGMA={{1., 0},
       {0, 1.}};

{OMEGA,A,B,SIGMA,MUE}
]

PARD//Clear;
(***************************************************************)
PARD[{t1_,t2_,t3_,t4_,t5_,t6_}] =
(***************************************************************)
 
\tModule[{t},
\tt = {t1,t2,t3,t4,t5,t6};
\tMap[DMS[#,t]&,PAR[t]]//N
]

PARM//Clear
(***************************************************************)
PARM[{phi1_,phi2_}]:= Module[{R,H,D},
(***************************************************************)
H={{1,0},
   {0,1}};

D= {{0},
\t{0}};

R={{(phi1//Exp),     0      },
   {   0       , (phi2//Exp)}};

{R,H,D}
]

PARMD//Clear
(***************************************************************)
PARMD[{phi1_,phi2_}] =
(***************************************************************)
Module[{t},
\tt = {phi1,phi2};
\tMap[DMS[#,t]&,PARM[t]]
]\
\>", "Input",
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{{0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 
          0.`}, {0.`, 0.`, 0.`, 2.`\ t4}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 
          0.`, 0.`}}, {{0.`, 0.`, 1.`, 0.`}, {0.`, 0.`, 0.`, 1.`}, {0.`, 0.`, 
          0.`, 0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 
          0.`, 0.`}}, {{0.`, 0.`}, {0.`, 0.`}, {0.`, 1.`}, {0.`, 0.`}, {0.`, 
          0.`}, {0.`, 0.`}}, {{0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 
          0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 
          0.`}, {0.`, 0.`, 0.`, 0.`}}, {{0.`, 0.`}, {0.`, 0.`}, {0.`, 
          0.`}, {0.`, 0.`}, {1.`, 0.`}, {0.`, 1.`}}}\)], "Output"],

Cell[BoxData[
    \({{{\[ExponentialE]\^phi1, 0, 0, 0}, {0, 0, 
          0, \[ExponentialE]\^phi2}}, {{0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 
          0}, {0, 0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["??PARMD", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("Ableitungen der Me\[SZ]-Matrizen"\)], "Print",
  CellTags->"Info3417329337-2384477"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(PARMD[{phi1_, 
                        phi2_}] = {{{\[ExponentialE]\^phi1, 0, 0, 0}, {0, 0, 
                          0, \[ExponentialE]\^phi2}}, {{0, 0, 0, 0}, {0, 0, 
                          0, 0}}, {{0, 0}, {0, 0}}}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "PARMD"],
      Editable->False]], "Print",
  CellTags->"Info3417329337-2384477"]
}, Open  ]],

Cell[CellGroupData[{

Cell["PARMD[Array[t,{2}]]//TableForm", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"1", GridBox[{
                {"1"},
                {GridBox[{
                      {"1", "2", "3", "4"},
                      {GridBox[{
                            {\(\[ExponentialE]\^t[1]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Center}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(\[ExponentialE]\^t[2]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Center}]},
          {"2", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"3", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{
        Power[ E, 
          t[ 1]], 0, 0, 0}, {0, 0, 0, 
        Power[ E, 
          t[ 2]]}}, {{0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0}, {0, 
        0}}}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
PAR  [Array[t,{6}]]//TableForm
PARD [Array[t,{6}]]//TableForm
PARM [Array[t,{2}]]//TableForm
PARMD[Array[t,{2}]]//TableForm\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"1", GridBox[{
                {"1"},
                {GridBox[{
                      {"1", "2"},
                      {GridBox[{
                            {"1.`*^-8"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Center}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(t[4]\^2\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Center}]},
          {"2", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {\(t[1]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(t[2]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"3", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {\(t[3]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"4", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"5", GridBox[{
                {\(t[5]\)},
                {\(t[6]\)}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{1*^-08, 0}, {0, 
        Power[ 
          t[ 4], 2]}}, {{0, 1}, {
        t[ 1], 
        t[ 2]}}, {{0}, {
        t[ 3]}}, {{1.0, 0}, {0, 1.0}}, {
        t[ 5], 
        t[ 6]}}]]], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"1", GridBox[{
                {"1"},
                {GridBox[{
                      {"1", "2", "3", "4"},
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Center}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(2.`\ t[4]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Center}]},
          {"2", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"3", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"4", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"5", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1.`"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0,
         0.0}, {0.0, 0.0, 0.0, 
        Times[ 2.0, 
          t[ 4]]}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0, 0.0}}, {{0.0, 0.0, 
        1.0, 0.0}, {0.0, 0.0, 0.0, 1.0}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0,
         0.0}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0, 0.0}}, {{0.0, 0.0}, {0.0,
         0.0}, {0.0, 1.0}, {0.0, 0.0}, {0.0, 0.0}, {0.0, 0.0}}, {{0.0, 0.0, 
        0.0, 0.0}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0,
         0.0}, {0.0, 0.0, 0.0, 0.0}, {0.0, 0.0, 0.0, 0.0}}, {{0.0, 0.0}, {0.0,
         0.0}, {0.0, 0.0}, {0.0, 0.0}, {1.0, 0.0}, {0.0, 1.0}}}]]], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"1", GridBox[{
                {"1"},
                {GridBox[{
                      {"1", "2"},
                      {GridBox[{
                            {\(\[ExponentialE]\^t[1]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Center}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(\[ExponentialE]\^t[2]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Center}]},
          {"2", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"1"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"3", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{
        Power[ E, 
          t[ 1]], 0}, {0, 
        Power[ E, 
          t[ 2]]}}, {{1, 0}, {0, 1}}, {{0}, {0}}}]]], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"1", GridBox[{
                {"1"},
                {GridBox[{
                      {"1", "2", "3", "4"},
                      {GridBox[{
                            {\(\[ExponentialE]\^t[1]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Center}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(\[ExponentialE]\^t[2]\)}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Center}]},
          {"2", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"3", GridBox[{
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]},
                {GridBox[{
                      {GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0"}
                            },
                          RowSpacings->1,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->1,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{
        Power[ E, 
          t[ 1]], 0, 0, 0}, {0, 0, 0, 
        Power[ E, 
          t[ 2]]}}, {{0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0}, {0, 
        0}}}]]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["true parameter values", "Subsection"],

Cell[TextData[{
  "\nK=2;\nQ=1;\nP=2;\n\nT=100;\n",
  StyleBox["n=10;",
    FontColor->RGBColor[1, 0, 0]],
  "\nnp = 1;\nT1=T+1;\nDT=.1;\nA=  {{  0, 1},\n     {-16,-4}};\nB= {{0},\n    \
{1}};\nG= {{0,0},\n    {0,2}};\nOMEGA= G.Transpose[G];\nMUE= {0, 0};\nSIGMA= \
{{1,0},\n  \t\t    {0,1}};\nH={{1,0},\n   {0,1}};\nd= {{0},\n    {0}};\nR= \
{{.01, 0},\n  \t { 0,.01}};\nMISS=-9;\nNONLIN = 1;\n\n"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["exogenous variables", "Subsection"],

Cell[CellGroupData[{

Cell["\<\

MueN = Transpose[Shape[1,{n}] /. 1->MUE];
SigmaN = Shape[1,{np}] /. 1->SIGMA;
Y0 = MueN + CholeskyDecomposition[SIGMA].Array[UniC[]&,{P,n}]
X = Array[0&,{T+1,Q,n}];
X//Dimensions
Do[ X[[t+1,1,nn]] = 1 + Sin[t DT],{t,0,T},{nn,1,n/2}];
Do[ X[[t+1,1,nn]] = 1 + Cos[t DT],{t,0,T},{nn,n/2+1,n}];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-0.34243840217871363`\), 
        0.5400196110451103`, \(-0.009586314298492016`\), \
\(-0.4667843764410749`\), 0.2900632320854386`, \(-0.13268086984407113`\), 
        1.3666491530516187`, \(-0.6344558334489027`\), \(-0.3262725583137975`\
\), \(-1.4518400808243017`\)}, {\(-1.4369743975197788`\), 
        0.18791290071776034`, \(-0.7070529329494127`\), \
\(-1.6039407955903873`\), 
        1.1103983448930292`, \(-1.5868696779548195`\), \
\(-1.55665969598281`\), \(-0.25874685482314824`\), \(-1.039067597579303`\), 
        1.6043233811418245`}}\)], "Output"],

Cell[BoxData[
    \({101, 1, 10}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["simulation", "Subsection"],

Cell["\<\
SeedRandom[13579];
(*SeedRandom[99999];*)


{Z,Y} = StateSpace1[H,d,R,A,B,G,Y0,X,K,P,Q,n,T,DT,seed,UniC];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
plot1[Y[[T+1//Range,1,n//Range]]//AddTimeAxis,farbmodell->Hue]
plot1[Z[[T+1//Range,1,n//Range]]//AddTimeAxis,farbmodell->Hue]
(*second component = velocity*)
plot1[Y[[T+1//Range,2,n//Range]]//AddTimeAxis,farbmodell->Hue]
plot1[Z[[T+1//Range,2,n//Range]]//AddTimeAxis,farbmodell->Hue]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 11}\),
      SequenceForm[ "Dimension der Daten  ", {101, 11}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.317912 0.208837 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00466 -24 -4.5 ]
[-0.0125 .00466 0 4.5 ]
[-0.0125 .10908 -12 -4.5 ]
[-0.0125 .10908 0 4.5 ]
[-0.0125 .21349 -24 -4.5 ]
[-0.0125 .21349 0 4.5 ]
[-0.0125 .31791 -6 -4.5 ]
[-0.0125 .31791 0 4.5 ]
[-0.0125 .42233 -18 -4.5 ]
[-0.0125 .42233 0 4.5 ]
[-0.0125 .52675 -6 -4.5 ]
[-0.0125 .52675 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .3096 -5 -6 ]
[.97619 .3096 5 6 ]
[.97619 .3347 -5 -6 ]
[.97619 .3347 5 6 ]
[.97619 .31842 -5 -6 ]
[.97619 .31842 5 6 ]
[.97619 .31866 -5 -6 ]
[.97619 .31866 5 6 ]
[.97619 .34141 -5 -6 ]
[.97619 .34141 5 6 ]
[.97619 .32704 -5 -6 ]
[.97619 .32704 5 6 ]
[.97619 .32565 -5 -6 ]
[.97619 .32565 5 6 ]
[.97619 .32536 -5 -6 ]
[.97619 .32536 5 6 ]
[.97619 .39101 -5 -6 ]
[.97619 .39101 5 6 ]
[.97619 .23294 -5 -6 ]
[.97619 .23294 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00466 m
.00625 .00466 L
s
[(-1.5)] -0.0125 .00466 1 0 Mshowa
0 .10908 m
.00625 .10908 L
s
[(-1)] -0.0125 .10908 1 0 Mshowa
0 .21349 m
.00625 .21349 L
s
[(-0.5)] -0.0125 .21349 1 0 Mshowa
0 .31791 m
.00625 .31791 L
s
[(0)] -0.0125 .31791 1 0 Mshowa
0 .42233 m
.00625 .42233 L
s
[(0.5)] -0.0125 .42233 1 0 Mshowa
0 .52675 m
.00625 .52675 L
s
[(1)] -0.0125 .52675 1 0 Mshowa
.125 Mabswid
0 .02554 m
.00375 .02554 L
s
0 .04642 m
.00375 .04642 L
s
0 .06731 m
.00375 .06731 L
s
0 .08819 m
.00375 .08819 L
s
0 .12996 m
.00375 .12996 L
s
0 .15084 m
.00375 .15084 L
s
0 .17173 m
.00375 .17173 L
s
0 .19261 m
.00375 .19261 L
s
0 .23438 m
.00375 .23438 L
s
0 .25526 m
.00375 .25526 L
s
0 .27615 m
.00375 .27615 L
s
0 .29703 m
.00375 .29703 L
s
0 .3388 m
.00375 .3388 L
s
0 .35968 m
.00375 .35968 L
s
0 .38056 m
.00375 .38056 L
s
0 .40145 m
.00375 .40145 L
s
0 .44321 m
.00375 .44321 L
s
0 .4641 m
.00375 .4641 L
s
0 .48498 m
.00375 .48498 L
s
0 .50587 m
.00375 .50587 L
s
0 .54763 m
.00375 .54763 L
s
0 .56852 m
.00375 .56852 L
s
0 .5894 m
.00375 .5894 L
s
0 .61028 m
.00375 .61028 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00466 m
1 .00466 L
s
.99375 .10908 m
1 .10908 L
s
.99375 .21349 m
1 .21349 L
s
.99375 .31791 m
1 .31791 L
s
.99375 .42233 m
1 .42233 L
s
.99375 .52675 m
1 .52675 L
s
.125 Mabswid
.99625 .02554 m
1 .02554 L
s
.99625 .04642 m
1 .04642 L
s
.99625 .06731 m
1 .06731 L
s
.99625 .08819 m
1 .08819 L
s
.99625 .12996 m
1 .12996 L
s
.99625 .15084 m
1 .15084 L
s
.99625 .17173 m
1 .17173 L
s
.99625 .19261 m
1 .19261 L
s
.99625 .23438 m
1 .23438 L
s
.99625 .25526 m
1 .25526 L
s
.99625 .27615 m
1 .27615 L
s
.99625 .29703 m
1 .29703 L
s
.99625 .3388 m
1 .3388 L
s
.99625 .35968 m
1 .35968 L
s
.99625 .38056 m
1 .38056 L
s
.99625 .40145 m
1 .40145 L
s
.99625 .44321 m
1 .44321 L
s
.99625 .4641 m
1 .4641 L
s
.99625 .48498 m
1 .48498 L
s
.99625 .50587 m
1 .50587 L
s
.99625 .54763 m
1 .54763 L
s
.99625 .56852 m
1 .56852 L
s
.99625 .5894 m
1 .5894 L
s
.99625 .61028 m
1 .61028 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .3096 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .2464 m
.03333 .23533 L
.04286 .23737 L
.05238 .23202 L
.0619 .2324 L
.07143 .23984 L
.08095 .26796 L
.09048 .2944 L
.1 .31193 L
.10952 .3439 L
.11905 .37641 L
.12857 .40501 L
.1381 .40205 L
.14762 .38698 L
.15714 .37339 L
.16667 .34911 L
.17619 .32039 L
.18571 .29529 L
.19524 .27673 L
.20476 .28022 L
.21429 .28336 L
.22381 .2875 L
.23333 .29308 L
.24286 .30945 L
.25238 .31656 L
.2619 .31451 L
.27143 .32111 L
.28095 .31839 L
.29048 .32224 L
.3 .32071 L
.30952 .32439 L
.31905 .34034 L
.32857 .35451 L
.3381 .3582 L
.34762 .3574 L
.35714 .355 L
.36667 .34744 L
.37619 .33597 L
.38571 .32018 L
.39524 .297 L
.40476 .28093 L
.41429 .27329 L
.42381 .27361 L
.43333 .27003 L
.44286 .27198 L
.45238 .27027 L
.4619 .28762 L
.47143 .297 L
.48095 .30364 L
.49048 .30104 L
Mistroke
.5 .28892 L
.50952 .28795 L
.51905 .29885 L
.52857 .30697 L
.5381 .30509 L
.54762 .30966 L
.55714 .30776 L
.56667 .30372 L
.57619 .30316 L
.58571 .3102 L
.59524 .32485 L
.60476 .34475 L
.61429 .35496 L
.62381 .34684 L
.63333 .32927 L
.64286 .3278 L
.65238 .34128 L
.6619 .36041 L
.67143 .38445 L
.68095 .38382 L
.69048 .38366 L
.7 .36865 L
.70952 .33874 L
.71905 .32353 L
.72857 .31282 L
.7381 .29009 L
.74762 .28856 L
.75714 .29894 L
.76667 .30959 L
.77619 .31338 L
.78571 .30938 L
.79524 .31748 L
.80476 .33269 L
.81429 .36062 L
.82381 .37687 L
.83333 .37481 L
.84286 .37163 L
.85238 .35926 L
.8619 .33584 L
.87143 .32179 L
.88095 .30759 L
.89048 .30014 L
.9 .29463 L
.90952 .28224 L
.91905 .27293 L
.92857 .27097 L
.9381 .26012 L
.94762 .26678 L
.95714 .28305 L
.96667 .2961 L
Mistroke
.97619 .3096 L
Mfstroke
1 0 .6 r
gsave
.97619 .3347 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43069 m
.03333 .42003 L
.04286 .40196 L
.05238 .37636 L
.0619 .34371 L
.07143 .32537 L
.08095 .32918 L
.09048 .32676 L
.1 .33702 L
.10952 .34958 L
.11905 .34631 L
.12857 .3433 L
.1381 .34278 L
.14762 .3499 L
.15714 .34074 L
.16667 .33846 L
.17619 .35139 L
.18571 .35801 L
.19524 .35127 L
.20476 .34224 L
.21429 .3244 L
.22381 .31453 L
.23333 .31384 L
.24286 .32594 L
.25238 .3477 L
.2619 .35687 L
.27143 .35619 L
.28095 .34892 L
.29048 .34224 L
.3 .35028 L
.30952 .36256 L
.31905 .3704 L
.32857 .37564 L
.3381 .3816 L
.34762 .3859 L
.35714 .38703 L
.36667 .37353 L
.37619 .35318 L
.38571 .3319 L
.39524 .30077 L
.40476 .29137 L
.41429 .28753 L
.42381 .29526 L
.43333 .30158 L
.44286 .31337 L
.45238 .31667 L
.4619 .32287 L
.47143 .3191 L
.48095 .31826 L
.49048 .31448 L
Mistroke
.5 .29373 L
.50952 .26913 L
.51905 .25426 L
.52857 .26012 L
.5381 .26777 L
.54762 .27223 L
.55714 .27729 L
.56667 .30036 L
.57619 .31003 L
.58571 .32081 L
.59524 .33172 L
.60476 .34485 L
.61429 .35597 L
.62381 .3503 L
.63333 .34866 L
.64286 .34907 L
.65238 .34564 L
.6619 .33962 L
.67143 .33987 L
.68095 .3331 L
.69048 .33218 L
.7 .3448 L
.70952 .34711 L
.71905 .33472 L
.72857 .31001 L
.7381 .2809 L
.74762 .25228 L
.75714 .25215 L
.76667 .26989 L
.77619 .30129 L
.78571 .32369 L
.79524 .32485 L
.80476 .30793 L
.81429 .29068 L
.82381 .29057 L
.83333 .29812 L
.84286 .30365 L
.85238 .30846 L
.8619 .31376 L
.87143 .31985 L
.88095 .33345 L
.89048 .34513 L
.9 .34924 L
.90952 .3304 L
.91905 .3129 L
.92857 .31712 L
.9381 .31647 L
.94762 .30935 L
.95714 .30348 L
.96667 .31432 L
Mistroke
.97619 .3347 L
Mfstroke
.8 0 1 r
gsave
.97619 .31842 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31591 m
.03333 .30742 L
.04286 .30141 L
.05238 .30742 L
.0619 .3199 L
.07143 .33082 L
.08095 .34529 L
.09048 .35884 L
.1 .37103 L
.10952 .37657 L
.11905 .37437 L
.12857 .36474 L
.1381 .35882 L
.14762 .34761 L
.15714 .34124 L
.16667 .32341 L
.17619 .30828 L
.18571 .31386 L
.19524 .32859 L
.20476 .33152 L
.21429 .34206 L
.22381 .34121 L
.23333 .34012 L
.24286 .34125 L
.25238 .34952 L
.2619 .37172 L
.27143 .40099 L
.28095 .4146 L
.29048 .41654 L
.3 .41586 L
.30952 .40082 L
.31905 .3612 L
.32857 .33756 L
.3381 .32115 L
.34762 .3078 L
.35714 .30104 L
.36667 .3032 L
.37619 .29384 L
.38571 .2819 L
.39524 .27295 L
.40476 .27396 L
.41429 .29208 L
.42381 .30261 L
.43333 .31509 L
.44286 .32639 L
.45238 .32928 L
.4619 .34182 L
.47143 .34768 L
.48095 .35179 L
.49048 .35274 L
Mistroke
.5 .36171 L
.50952 .37822 L
.51905 .38736 L
.52857 .39369 L
.5381 .39928 L
.54762 .39486 L
.55714 .3843 L
.56667 .37918 L
.57619 .35907 L
.58571 .3349 L
.59524 .32205 L
.60476 .32045 L
.61429 .32148 L
.62381 .32658 L
.63333 .33711 L
.64286 .34511 L
.65238 .34905 L
.6619 .34976 L
.67143 .34402 L
.68095 .34009 L
.69048 .33695 L
.7 .34077 L
.70952 .34783 L
.71905 .34309 L
.72857 .33167 L
.7381 .30961 L
.74762 .2978 L
.75714 .29829 L
.76667 .30765 L
.77619 .32283 L
.78571 .34359 L
.79524 .37796 L
.80476 .41465 L
.81429 .43386 L
.82381 .42085 L
.83333 .40597 L
.84286 .39332 L
.85238 .36528 L
.8619 .32135 L
.87143 .28993 L
.88095 .26573 L
.89048 .24891 L
.9 .24994 L
.90952 .25585 L
.91905 .27896 L
.92857 .30102 L
.9381 .32231 L
.94762 .34039 L
.95714 .34288 L
.96667 .32539 L
Mistroke
.97619 .31842 L
Mfstroke
.2 0 1 r
gsave
.97619 .31866 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22043 m
.03333 .19106 L
.04286 .18394 L
.05238 .19499 L
.0619 .23231 L
.07143 .26989 L
.08095 .29699 L
.09048 .32663 L
.1 .34275 L
.10952 .35834 L
.11905 .36575 L
.12857 .35839 L
.1381 .36348 L
.14762 .37979 L
.15714 .38634 L
.16667 .37653 L
.17619 .34641 L
.18571 .31989 L
.19524 .29222 L
.20476 .29378 L
.21429 .31693 L
.22381 .33439 L
.23333 .34319 L
.24286 .35526 L
.25238 .36189 L
.2619 .37233 L
.27143 .37974 L
.28095 .39338 L
.29048 .40488 L
.3 .40405 L
.30952 .38635 L
.31905 .36568 L
.32857 .34425 L
.3381 .32634 L
.34762 .30793 L
.35714 .27856 L
.36667 .27044 L
.37619 .27571 L
.38571 .28666 L
.39524 .29156 L
.40476 .30009 L
.41429 .31131 L
.42381 .31018 L
.43333 .32242 L
.44286 .32899 L
.45238 .33547 L
.4619 .35278 L
.47143 .36556 L
.48095 .38696 L
.49048 .3914 L
Mistroke
.5 .38776 L
.50952 .36711 L
.51905 .34347 L
.52857 .31919 L
.5381 .30877 L
.54762 .28814 L
.55714 .28173 L
.56667 .27986 L
.57619 .28843 L
.58571 .2966 L
.59524 .31533 L
.60476 .32688 L
.61429 .34154 L
.62381 .36295 L
.63333 .3828 L
.64286 .38543 L
.65238 .37962 L
.6619 .37145 L
.67143 .35466 L
.68095 .33169 L
.69048 .31452 L
.7 .29526 L
.70952 .28769 L
.71905 .2811 L
.72857 .28438 L
.7381 .29274 L
.74762 .31792 L
.75714 .34775 L
.76667 .37773 L
.77619 .38316 L
.78571 .37654 L
.79524 .36108 L
.80476 .348 L
.81429 .33048 L
.82381 .30935 L
.83333 .29349 L
.84286 .28648 L
.85238 .30487 L
.8619 .3387 L
.87143 .3523 L
.88095 .36109 L
.89048 .37732 L
.9 .38591 L
.90952 .38451 L
.91905 .38688 L
.92857 .39334 L
.9381 .40456 L
.94762 .39056 L
.95714 .35642 L
.96667 .33998 L
Mistroke
.97619 .31866 L
Mfstroke
0 .4 1 r
gsave
.97619 .34141 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37849 m
.03333 .38655 L
.04286 .38549 L
.05238 .38706 L
.0619 .37617 L
.07143 .35905 L
.08095 .33625 L
.09048 .324 L
.1 .31592 L
.10952 .31101 L
.11905 .32137 L
.12857 .33842 L
.1381 .35025 L
.14762 .36846 L
.15714 .3823 L
.16667 .39826 L
.17619 .40407 L
.18571 .39537 L
.19524 .38104 L
.20476 .38452 L
.21429 .38175 L
.22381 .37923 L
.23333 .37147 L
.24286 .35819 L
.25238 .34765 L
.2619 .32285 L
.27143 .29781 L
.28095 .28705 L
.29048 .28407 L
.3 .29456 L
.30952 .30072 L
.31905 .31088 L
.32857 .32758 L
.3381 .33955 L
.34762 .33458 L
.35714 .34677 L
.36667 .3733 L
.37619 .39125 L
.38571 .39426 L
.39524 .39551 L
.40476 .40368 L
.41429 .40282 L
.42381 .3903 L
.43333 .38885 L
.44286 .3717 L
.45238 .34359 L
.4619 .32794 L
.47143 .3126 L
.48095 .30951 L
.49048 .31688 L
Mistroke
.5 .32097 L
.50952 .31409 L
.51905 .28913 L
.52857 .26424 L
.5381 .25527 L
.54762 .27324 L
.55714 .29609 L
.56667 .3018 L
.57619 .30502 L
.58571 .28958 L
.59524 .27955 L
.60476 .27819 L
.61429 .28062 L
.62381 .28059 L
.63333 .28599 L
.64286 .3007 L
.65238 .31591 L
.6619 .32841 L
.67143 .33851 L
.68095 .34527 L
.69048 .35074 L
.7 .35245 L
.70952 .33009 L
.71905 .31199 L
.72857 .31118 L
.7381 .32336 L
.74762 .34543 L
.75714 .37227 L
.76667 .38778 L
.77619 .39443 L
.78571 .39228 L
.79524 .37619 L
.80476 .35859 L
.81429 .33991 L
.82381 .32615 L
.83333 .31839 L
.84286 .32986 L
.85238 .34513 L
.8619 .35098 L
.87143 .34203 L
.88095 .32473 L
.89048 .30497 L
.9 .28965 L
.90952 .27917 L
.91905 .27777 L
.92857 .28544 L
.9381 .30775 L
.94762 .33285 L
.95714 .34528 L
.96667 .3465 L
Mistroke
.97619 .34141 L
Mfstroke
0 1 1 r
gsave
.97619 .32704 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2902 m
.03333 .26466 L
.04286 .24838 L
.05238 .24214 L
.0619 .24833 L
.07143 .25427 L
.08095 .27709 L
.09048 .3053 L
.1 .33043 L
.10952 .34091 L
.11905 .33457 L
.12857 .3385 L
.1381 .34551 L
.14762 .32964 L
.15714 .31405 L
.16667 .30784 L
.17619 .31449 L
.18571 .31393 L
.19524 .31002 L
.20476 .30801 L
.21429 .31564 L
.22381 .31884 L
.23333 .32173 L
.24286 .33325 L
.25238 .35723 L
.2619 .37776 L
.27143 .39166 L
.28095 .37685 L
.29048 .35603 L
.3 .32567 L
.30952 .29729 L
.31905 .27813 L
.32857 .26937 L
.3381 .2758 L
.34762 .29928 L
.35714 .32379 L
.36667 .33001 L
.37619 .33144 L
.38571 .33966 L
.39524 .33347 L
.40476 .32694 L
.41429 .30914 L
.42381 .30914 L
.43333 .31789 L
.44286 .3347 L
.45238 .3492 L
.4619 .35031 L
.47143 .35207 L
.48095 .34467 L
.49048 .33032 L
Mistroke
.5 .33069 L
.50952 .32129 L
.51905 .31826 L
.52857 .32813 L
.5381 .3322 L
.54762 .33497 L
.55714 .33302 L
.56667 .32568 L
.57619 .3151 L
.58571 .30785 L
.59524 .30552 L
.60476 .29739 L
.61429 .28838 L
.62381 .29026 L
.63333 .29804 L
.64286 .30551 L
.65238 .31284 L
.6619 .33601 L
.67143 .36715 L
.68095 .39866 L
.69048 .40707 L
.7 .3883 L
.70952 .36649 L
.71905 .34835 L
.72857 .3334 L
.7381 .31679 L
.74762 .3001 L
.75714 .29262 L
.76667 .30654 L
.77619 .33081 L
.78571 .33568 L
.79524 .32323 L
.80476 .297 L
.81429 .2678 L
.82381 .24576 L
.83333 .23483 L
.84286 .23565 L
.85238 .24132 L
.8619 .23211 L
.87143 .23608 L
.88095 .24269 L
.89048 .26694 L
.9 .29298 L
.90952 .29922 L
.91905 .29513 L
.92857 .28888 L
.9381 .28465 L
.94762 .29066 L
.95714 .31075 L
.96667 .32564 L
Mistroke
.97619 .32704 L
Mfstroke
0 1 .4 r
gsave
.97619 .32565 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.03333 .5662 L
.04286 .51626 L
.05238 .4549 L
.0619 .39562 L
.07143 .34731 L
.08095 .31255 L
.09048 .28885 L
.1 .28335 L
.10952 .29767 L
.11905 .3177 L
.12857 .33385 L
.1381 .34982 L
.14762 .35778 L
.15714 .35214 L
.16667 .34527 L
.17619 .33215 L
.18571 .33253 L
.19524 .34331 L
.20476 .3578 L
.21429 .36462 L
.22381 .36399 L
.23333 .35097 L
.24286 .35589 L
.25238 .34591 L
.2619 .32123 L
.27143 .2802 L
.28095 .25632 L
.29048 .25195 L
.3 .26065 L
.30952 .28667 L
.31905 .31664 L
.32857 .34949 L
.3381 .37589 L
.34762 .38995 L
.35714 .39567 L
.36667 .39059 L
.37619 .36348 L
.38571 .33604 L
.39524 .31624 L
.40476 .29564 L
.41429 .27077 L
.42381 .25919 L
.43333 .25348 L
.44286 .27309 L
.45238 .31226 L
.4619 .34137 L
.47143 .36264 L
.48095 .37887 L
.49048 .397 L
Mistroke
.5 .39616 L
.50952 .3832 L
.51905 .37283 L
.52857 .37204 L
.5381 .3716 L
.54762 .35548 L
.55714 .34518 L
.56667 .34309 L
.57619 .32472 L
.58571 .31027 L
.59524 .31289 L
.60476 .32312 L
.61429 .34223 L
.62381 .34266 L
.63333 .34365 L
.64286 .34702 L
.65238 .35004 L
.6619 .34342 L
.67143 .33192 L
.68095 .31595 L
.69048 .29992 L
.7 .29775 L
.70952 .30346 L
.71905 .29611 L
.72857 .28231 L
.7381 .28736 L
.74762 .29663 L
.75714 .30401 L
.76667 .31079 L
.77619 .30431 L
.78571 .29946 L
.79524 .31004 L
.80476 .32485 L
.81429 .34603 L
.82381 .34234 L
.83333 .33049 L
.84286 .32064 L
.85238 .32102 L
.8619 .33744 L
.87143 .34896 L
.88095 .36268 L
.89048 .36845 L
.9 .37404 L
.90952 .38896 L
.91905 .38972 L
.92857 .38637 L
.9381 .38086 L
.94762 .36656 L
.95714 .34246 L
.96667 .32902 L
Mistroke
.97619 .32565 L
Mfstroke
.2 1 0 r
gsave
.97619 .32536 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .18541 m
.03333 .198 L
.04286 .21944 L
.05238 .24453 L
.0619 .28692 L
.07143 .3352 L
.08095 .36527 L
.09048 .37018 L
.1 .37308 L
.10952 .38891 L
.11905 .39483 L
.12857 .38571 L
.1381 .36942 L
.14762 .37254 L
.15714 .37969 L
.16667 .37219 L
.17619 .36621 L
.18571 .35606 L
.19524 .3312 L
.20476 .31544 L
.21429 .306 L
.22381 .31037 L
.23333 .29781 L
.24286 .29545 L
.25238 .30632 L
.2619 .30919 L
.27143 .30089 L
.28095 .30453 L
.29048 .31214 L
.3 .33407 L
.30952 .34085 L
.31905 .341 L
.32857 .33415 L
.3381 .31398 L
.34762 .31085 L
.35714 .32202 L
.36667 .33913 L
.37619 .3386 L
.38571 .33064 L
.39524 .31834 L
.40476 .31623 L
.41429 .3247 L
.42381 .32024 L
.43333 .31416 L
.44286 .31344 L
.45238 .32195 L
.4619 .315 L
.47143 .31751 L
.48095 .34183 L
.49048 .362 L
Mistroke
.5 .37826 L
.50952 .38617 L
.51905 .39818 L
.52857 .3991 L
.5381 .40009 L
.54762 .39701 L
.55714 .39091 L
.56667 .37164 L
.57619 .34696 L
.58571 .31574 L
.59524 .28489 L
.60476 .25221 L
.61429 .22627 L
.62381 .22794 L
.63333 .26586 L
.64286 .29532 L
.65238 .32733 L
.6619 .35059 L
.67143 .35963 L
.68095 .37561 L
.69048 .3914 L
.7 .38443 L
.70952 .36962 L
.71905 .36266 L
.72857 .37071 L
.7381 .37324 L
.74762 .35933 L
.75714 .34075 L
.76667 .33089 L
.77619 .31858 L
.78571 .30216 L
.79524 .29044 L
.80476 .27898 L
.81429 .26222 L
.82381 .25375 L
.83333 .24745 L
.84286 .24883 L
.85238 .25285 L
.8619 .26273 L
.87143 .27604 L
.88095 .28646 L
.89048 .28451 L
.9 .27462 L
.90952 .27278 L
.91905 .28523 L
.92857 .30254 L
.9381 .31649 L
.94762 .32447 L
.95714 .32677 L
.96667 .329 L
Mistroke
.97619 .32536 L
Mfstroke
.8 1 0 r
gsave
.97619 .39101 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24977 m
.03333 .23012 L
.04286 .22169 L
.05238 .21519 L
.0619 .22824 L
.07143 .2376 L
.08095 .26854 L
.09048 .29523 L
.1 .31179 L
.10952 .32849 L
.11905 .34589 L
.12857 .36915 L
.1381 .38067 L
.14762 .3791 L
.15714 .38082 L
.16667 .38535 L
.17619 .36931 L
.18571 .35426 L
.19524 .34665 L
.20476 .33376 L
.21429 .32146 L
.22381 .3256 L
.23333 .32527 L
.24286 .33681 L
.25238 .35517 L
.2619 .37095 L
.27143 .36636 L
.28095 .36094 L
.29048 .3462 L
.3 .32592 L
.30952 .31438 L
.31905 .30014 L
.32857 .29062 L
.3381 .29591 L
.34762 .31546 L
.35714 .34208 L
.36667 .37634 L
.37619 .40244 L
.38571 .41008 L
.39524 .39744 L
.40476 .37979 L
.41429 .36284 L
.42381 .34334 L
.43333 .31994 L
.44286 .29658 L
.45238 .28488 L
.4619 .27361 L
.47143 .27808 L
.48095 .28306 L
.49048 .29187 L
Mistroke
.5 .31894 L
.50952 .35595 L
.51905 .3916 L
.52857 .41987 L
.5381 .43305 L
.54762 .44194 L
.55714 .44885 L
.56667 .44701 L
.57619 .44931 L
.58571 .44537 L
.59524 .43028 L
.60476 .40479 L
.61429 .3747 L
.62381 .35332 L
.63333 .34735 L
.64286 .34644 L
.65238 .34416 L
.6619 .33865 L
.67143 .33909 L
.68095 .3366 L
.69048 .33998 L
.7 .3374 L
.70952 .33978 L
.71905 .34382 L
.72857 .35512 L
.7381 .36424 L
.74762 .36671 L
.75714 .36784 L
.76667 .36794 L
.77619 .34921 L
.78571 .32961 L
.79524 .3158 L
.80476 .31662 L
.81429 .31355 L
.82381 .32401 L
.83333 .33476 L
.84286 .35214 L
.85238 .37762 L
.8619 .38519 L
.87143 .37695 L
.88095 .36189 L
.89048 .34997 L
.9 .33892 L
.90952 .3365 L
.91905 .32227 L
.92857 .30749 L
.9381 .306 L
.94762 .3278 L
.95714 .35525 L
.96667 .37558 L
Mistroke
.97619 .39101 L
Mfstroke
1 .6 0 r
gsave
.97619 .23294 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.03333 .05419 L
.04286 .09895 L
.05238 .1549 L
.0619 .21923 L
.07143 .29593 L
.08095 .35644 L
.09048 .40713 L
.1 .43228 L
.10952 .42533 L
.11905 .41162 L
.12857 .3989 L
.1381 .37654 L
.14762 .35762 L
.15714 .34083 L
.16667 .32836 L
.17619 .31882 L
.18571 .31412 L
.19524 .29973 L
.20476 .29496 L
.21429 .28939 L
.22381 .29555 L
.23333 .30942 L
.24286 .32726 L
.25238 .33208 L
.2619 .34028 L
.27143 .34439 L
.28095 .33652 L
.29048 .32553 L
.3 .30152 L
.30952 .28448 L
.31905 .27901 L
.32857 .28483 L
.3381 .29745 L
.34762 .30142 L
.35714 .29124 L
.36667 .26948 L
.37619 .27223 L
.38571 .28767 L
.39524 .30947 L
.40476 .31912 L
.41429 .32884 L
.42381 .34262 L
.43333 .361 L
.44286 .35697 L
.45238 .34194 L
.4619 .34506 L
.47143 .35733 L
.48095 .36736 L
.49048 .37014 L
Mistroke
.5 .35932 L
.50952 .34389 L
.51905 .3291 L
.52857 .32058 L
.5381 .31867 L
.54762 .33062 L
.55714 .34383 L
.56667 .35234 L
.57619 .35328 L
.58571 .35918 L
.59524 .35999 L
.60476 .37409 L
.61429 .38414 L
.62381 .39326 L
.63333 .39445 L
.64286 .40032 L
.65238 .40559 L
.6619 .4031 L
.67143 .38641 L
.68095 .36103 L
.69048 .33724 L
.7 .31398 L
.70952 .28949 L
.71905 .27492 L
.72857 .26923 L
.7381 .25379 L
.74762 .26805 L
.75714 .29622 L
.76667 .30919 L
.77619 .31621 L
.78571 .325 L
.79524 .33066 L
.80476 .32786 L
.81429 .33655 L
.82381 .34917 L
.83333 .37291 L
.84286 .39307 L
.85238 .40226 L
.8619 .38334 L
.87143 .35938 L
.88095 .34751 L
.89048 .33782 L
.9 .33691 L
.90952 .34153 L
.91905 .33048 L
.92857 .30054 L
.9381 .27773 L
.94762 .2684 L
.95714 .2514 L
.96667 .23401 L
Mistroke
.97619 .23294 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`008?ooool2o`0002Sooooo1Ol0
0003ooooo`;o0000:?ooool3o`0000?ooooo0_l0000Wooooo`?o00001?ooool2o`0002Kooooo0ol0
0004ooooo`;o00009?ooool3o`0000Cooooo0_l00004ooooo`;o00000oooool001oooooo00Co0000
oooooooooooo0000:?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0002So
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo02?ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0002Cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0002Cooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo000Oooooo`04o`000?oooooooooo
o`0002Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Uooooo`Go00000_oo
ool01?l0003oooooooooool0000Uooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool0000Tooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
000Tooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`007oooool01?l0003oooooooooool0000Zooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`0Sooooo`04o`000?ooooooooooo`0000?ooooo00Co0000
oooooooooooo00009Oooool4o`0000?ooooo00Co0000oooooooooooo00009Oooool3o`0000?ooooo
00Co0000oooooooooooo00009?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool001oooooo00Co0000oooooooooooo00009oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00009_ooool00ol0003ooooo
o`000003ooooo`04o`000?ooooooooooo`0002Gooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000Tooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
000Tooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`007oooool01?l0003oooooooooool0000Wooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool0000Wooooo`;o00000oooool01?l0003oooooooooool0
000Vooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00009?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00008oooool2o`0000Cooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`008?ooool2o`0002Wooooo0ol00004
ooooo`;o0000:Oooool00ol0003oooooooooo`02ooooo`;o0000:?ooool2o`0000Cooooo0_l0000V
ooooo`?o00001?ooool2o`0002Gooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003
ooooo`00oooooolJooooo`00oooooolJooooo`001oooool3o`0000Cooooo00?o0000ooooooooool0
0_ooool3o`000?oooooo1?ooool000Sooooo00?o0000ooooooooool01oooool01Ol0003ooooooooo
oooooooo00000?oooooo0oooool000Go00000oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00;ooooonol00003ooooo`002?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00;ooooo0_l00004ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
1?l0003oooooooooooooool3o`0000?ooooo0008ooooo`03o`000?oooooooooo00Oooooo1?l00005
ooooo`03o`000?oooooooooo0?Oooooo00?o0000ooooooooool00Oooool000Oooooo0_l00009oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool00oooV@3oooooooooo`3aoooo
o`03o`000?oooooooooo007ooooo0008ooooo`03o`000?oooooooooo00Oooooo1Ol00004ooooo`03
o`000?oooooooooo00?ooooo00?ooiT0ooooooooool0lOooool00ol0003oooooooooo`01ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03oonI0?oooooooooo0?7ooooo00?o0000ooooooooool0
0Oooool001_ooooo0_l00005ooooo`03oonI0?oooooooooo0>oooooo0_l00003ooooo`006oooool0
0ol0003oooooooooo`04ooooo`03oonI0?oooooooooo0?3ooooo00?o0000ooooooooool00Oooool0
01_ooooo00?o0000ooooooooool01?ooool00oooV@3oooooooooo`3`ooooo`03o`000?oooooooooo
007ooooo000Kooooo`03o`000?oooooooooo00Cooooo00?ooiT0ooooooooool0l?ooool00ol0003o
ooooooooo`01ooooo`006oooool00ol0003oooooooooo`04ooooo`03oonI0?oooooooooo0?3ooooo
00?o0000ooooooooool00Oooool001_ooooo0_l00006ooooo`03oonI0?oooooooooo0>kooooo0_l0
0003ooooo`006oooool00ol0003oooooooooo`05ooooo`03oonI0?oooooooooo0>oooooo00?o0000
ooooooooool00Oooool001_ooooo00?o0000ooooooooool01Oooool00oooV@3oooooooooo`3_oooo
o`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Gooooo00?ooiT0oooooooo
ool0koooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05ooooo`03oonI
0?oooooooooo0>oooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01Ooo
ool00oooV@3oooooooooo`3_ooooo`03o`000?oooooooooo007ooooo000Kooooo`;o00001oooool0
0oooV@3oooooooooo`3]ooooo`;o00000oooool001_ooooo00?o0000ooooooooool01_ooool00ooo
V@3oooooooooo`3^ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Ko
oooo00?ooiT0ooooooooool0k_ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003ooooo
ooooo`06ooooo`03oonI0?oooooooooo0>kooooo00?o0000ooooooooool00Oooool001_ooooo00?o
0000ooooooooool01_ooool00oooV@3oooooooooo`3^ooooo`03o`000?oooooooooo007ooooo000K
ooooo`;o00001oooool00oooV@3oooooooooo`3]ooooo`;o00000oooool001_ooooo00?o0000oooo
ooooool01oooool00oooV@3oooooooooo`3]ooooo`03o`000?oooooooooo007ooooo000Kooooo`03
o`000?oooooooooo00Oooooo00?ooiT0ooooooooool0kOooool00ol0003oooooooooo`01ooooo`00
4oooool3o`0000Gooooo00?o0000ooooooooool01oooool00oooV@3oooooooooo`3]ooooo`03o`00
0?oooooooooo007ooooo000Dooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01ooo
ool00oooV@3oooooooooo`3]ooooo`03o`000?oooooooooo007ooooo000<ooooo`Go00000oooool0
0ol0003oooooooooo`04ooooo`;o00002?ooool00oooV@3oooooooooo`3[ooooo`?o00000oooool0
01Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03oonI0?oooooooooo
0>cooooo00?o0000ooooooooool00Oooool001Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03oonI0?oooooooooo0>cooooo00?o0000ooooooooool00Oooool001?ooooo
0_l00006ooooo`03o`000?oooooooooo00Sooooo00?ooiT0ooooooooool0k?ooool00ol0003ooooo
ooooo`01ooooo`005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o
oiT0ooooooooool0k?ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Wooooo00?ooiT0
ooooooooool0joooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Wooooo00?ooiT0oooo
ooooool0joooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`09ooooo`03
oonI0?oooooooooo0>_ooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool0
2Oooool00oooV@3oooooooooo`3[ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oo
oooooooo00Wooooo00?ooiT0ooooooooool0joooool00ol0003oooooooooo`01ooooo`006oooool0
0ol0003oooooooooo`09ooooo`03oonI0?oooooooooo0>_ooooo00?o0000ooooooooool00Oooool0
01_ooooo0_l0000;ooooo`03oonI0?oooooooooo0>Wooooo0_l00003ooooo`006oooool00ol0003o
ooooooooo`0:ooooo`03oonI0?oooooooooo0>[ooooo00?o0000ooooooooool00Oooool001_ooooo
00?o0000ooooooooool02_ooool00oooV@3oooooooooo`3Zooooo`03o`000?oooooooooo007ooooo
000Kooooo`03o`000?oooooooooo00[ooooo00?ooiT0ooooooooool0j_ooool00ol0003ooooooooo
o`01ooooo`006oooool00ol0003oooooooooo`0:ooooo`03oonI0?oooooooooo0>[ooooo00?o0000
ooooooooool00Oooool001_ooooo0_l0000;ooooo`03oonI0?oooooooooo0>Wooooo0_l00003oooo
o`006oooool00ol0003oooooooooo`0;ooooo`03oonI0?oooooooooo0>Wooooo00?o0000oooooooo
ool00Oooool001_ooooo00?o0000ooooooooool02oooool00oooV@3oooooooooo`3Yooooo`03o`00
0?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00?ooooo00Go<ol0oooooooooooooooo
oc<0o`03ooooo`03oonI0?oooooooooo0>Wooooo00?o0000ooooooooool00Oooool001_ooooo00?o
0000ooooooooool00oooool01_lco`3ooooooooooolc0?oooooooc<0o`;ooooo00?ooiT0oooooooo
ool0jOooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Gooooo00?o<ol0oc<0ooooool0
0_ooool00olc0?oooooooonI003Zooooo`;o00000oooool001_ooooo00?o0000ooooooooool01Ooo
ool00olco`3oooooooooo`02ooooo`03oc<0ooooV@3ooooo0>[ooooo00?o0000ooooooooool00Ooo
ool001_ooooo00?o0000ooooooooool01Oooool00olco`3oooooooooo`02ooooo`03oc<0ooooV@3o
oooo0>[ooooo00?o0000ooooooooool00Oooool000Sooooo0_l00004ooooo`03o`000?oooooooooo
00;ooooo0ol00005ooooo`03o`000?oooooooooo00Cooooo00?o<`3ooooooolco`000oooool00olc
0?oooiT0ooooo`3Zooooo`03o`000?oooooooooo007ooooo0007ooooo`04o`000?ooooooooooo`00
00Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00Cooooo00?o<`3o
oooooolco`001?ooool00olc0?oooiT0ooooo`3Yooooo`03o`000?oooooooooo007ooooo0005o`00
00;ooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`;o00001Oooool0
0olc0?oooooooc?o0004ooooo`03oc<0ooooV@3ooooo0>Oooooo0ol00003ooooo`001oooool01?l0
003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool0
1_lc0?oooooooooooooooooo<ol0ooooo`;oc?l000?o<`3ooonI0?ooool0jOooool00ol0003ooooo
ooooo`01ooooo`001oooool01?l0003oooooooooool00007ooooo`Co00001Oooool00ol0003ooooo
ooooo`03ooooo`04oc<0ooooooooooooooooo`;oc?l000Coooooolco0?lc0?oooiT0j_ooool00ol0
003oooooooooo`01ooooo`001oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00oo<o`3o<ol0ooooo`02ooooo`03olco0?ooV@3ooooo
08Sooooo0olco`1Nooooo`03o`000?oooooooooo007ooooo0008ooooo`;o00002?ooool5o`0000Co
oooo00?o0000ooooooooool01Oooool01?o<o`3ooooooooooolco`03ooooo`03oonI0?o<o`3ooooo
08Oooooo00Co<ol0oooooooooooo<ol0GOooool00ol0003oooooooooo`01ooooo`006oooool2o`00
00Kooooo00Coc?l0oooooooooooo<ol00ooo00000oooV@3oo`00olco0027ooooo`04oc?o0?oooooo
oooooc?o03[ooooo0ol0oolHooooo`?ooiT01?ooool2o`0000?ooooo000Kooooo`03o`000?oooooo
oooo00Cooooo00?oc?l0ool00?oo00000_oo00001olco`3ooooooooooolc0?oooiT0ool00?o<o`00
QOooool01Olco`3ooooooooooooooooo<ol003?ooooo1Ol0ool00ooooooo0?ooooooo`02ooooo`03
o`3ooooooooooooo01Gooooo00?ooiT0ooooooooool01Oooool00ol0003oooooooooo`01ooooo`00
6oooool00ol0003oooooooooo`04ooooo`03olco0?oooooooooo00;ooooo00Oo<ol0o`3ooooooooo
oooooonI0?ooooooc?l008Gooooo00?o<ol0ooooooooool00_ooool00olco`3oooooooooo`0_oooo
o`03o`3ooooooooooooo00?ooooo00?o0?ooooooooooool00oooool00ol0ooooooooooooo`0Coooo
o`03oonI0?oooooooooo00Kooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000oooooooo
ool00oooool00ooo003oc?l0ooooo`02ooooo`08o`3ooooooooo<ol0o`3ooooooooooiT0ooooooo<
o`25ooooo`03oc?o0?oooooooooo00;ooooo00?o<ol0ooooooooool0;_ooool00ol0oooooooooooo
o`0;ooooo`03o`3ooooooooooooo017ooooo00?ooiT0ooooooooool01oooool00ol0003ooooooooo
o`01ooooo`006oooool00ol0003oooooooooo`03ooooo`05olco0?ooooooooooooooool0ool00_oo
ool01olco`3oooooo`3oooooV@3o0?ooool00?o<o`00Poooool00olco`3oooooooooo`03ooooo`03
oc?o0?oooooooooo02kooooo00?o0?oooc?o0?lco`001?lco`07ooooo`03o`3oooooooooc03o00?o
c03o3_ooool00oooV@3oooooooooo`07ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`00
0?oooooooooo00Oooooo00Co0?oooooooooooooo<ol00_ooool01?ooV@3o<`3oo`3oooo<o`0coooo
o`?o0?mV8_ooool00ol0ofKoooooooooo`0Cooooo`03ool0VOoooooooooo01;ooooo00?o<ol0oooo
ooooool00oooool00olco`3oooooooooo`0Hooooo`03oonI0?oooooooooo00?oo`2I3oooool2oc?o
00Kooooo00?o<ol0ooooooooool01Oooool00ol0ooooc03oooooo`02ooooo`03ol`0oooooooooooo
00[ooooo00?ooiT0ooooooooool02?ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Oo
oooo00Go0?oooooooooooooooooooc?o0002ooooo`04oonI0?lc0?oo0?ooolco03;ooooo00Go0?mV
ooooooooooooooooo`3oIP0Pooooo`;o0?mV5Oooool2ool0V@;ooooo00?o06Koooooooooool03_oo
ool00olco`3oooooooooo`03ooooo`03oc?o0?oooooooooo01Sooooo00KooiT0ooooooooooooo`2I
oooooooo09T>ooooo`03oc?o0?l0oooooooo00Kooooo00?o<ol0ooooooooool01Oooool00ol0oooo
ooooooooo`03ooooo`03ol`0oooooooooooo00Wooooo00?ooiT0ooooooooool01oooool2o`0000?o
oooo000Kooooo`03o`000?oooooooooo00Kooooo00?o0?ooooooooooool00_ooool01_lco`3ooooo
ooooooooV@3oooooolco03;ooooo00?o0?mVooooooooool00_ooool00ol0ofKoooooooooo`0Loooo
o`04o`3oI_ooooooooooo`3oIQ?ooooo00Coo`2Iooooooooooooo`2I0_l0I_l@ooooo`03oc?o0?oo
oooooooo00Cooooo00?o<ol0ooooooooool05_ooool01?ooV@3ooooooonI0?oo09T3ooooo`03ool0
VOoooooooooo00[ooooo00?o<ol0o`3oooooool02?ooool00olco`3oooooooooo`04ooooo`03o`3o
oooooooooooo00?ooooo00?oc03oooooooooool01?ooool2ool000;ooooo00?ooiT0ooooooooool0
2Oooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05ooooo`03o`3ooooo
oooooooo00?ooooo00Oo<ol0oooooooooooooiT0oc<0ool0ooooc?l0033ooooo00?o0?mVoooooooo
ool00oooool00ol0ofKoooooooooo`0Kooooo`05o`3oI_ooooooooooooooool0ofH04_ooool02?oo
09Wooooooooooooooooo06Koool0VOoooooo06Ko3_ooool00olco`3oooooooooo`05ooooo`03oc?o
0?oooooooooo01Kooooo00CooiT0oooooooooooooiT01?ooool00ooo09Woooooooooo`09ooooo`03
oc?o0?l0oooooooo00Wooooo00?o<ol0ooooooooool00_ooool00oo<0?ooooooo`3oo`05ooooo`03
ol`0oooooooooooo00?ooooo00Goo`00oooooooo003ooooooonI000;ooooo`03o`000?oooooooooo
007ooooo000Kooooo`03o`000?oooooooooo00Gooooo00?o0?ooooooooooool00oooool01olco`3o
ooooooooooooV@3o<`3oo`3oooo<o`00<?ooool00ol0ofKoooooooooo`03ooooo`03o`3oI_oooooo
oooo00?ooooo0_l0ool8ooooo`?ooiT02_ooool00ol0ofKoooooooooo`02ool00003o`3oI_oooooo
oooo00;oo`003Oooool00ooo09Woooooooooo`02ooooo`05o`1Vooooooooo`2Iool0VOl0I_l03Ooo
ool00olco`3oooooooooo`05ooooo`03oc?o0?oooooooooo01Gooooo00KooiT0ooooooooooooo`2I
ooooooooV@04ooooo`03ool0VOoooooooooo00Oooooo00?o<ol0o`3oooooool02oooool01olco`3o
ooooooooooooooooc03oooooool0ool01Oooool00oo<0?ooooooooooo`02ooooo`03ool00?oooooo
oooo00;ooiT03?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`04oooo
o`03o`3ooooooooooooo00Cooooo00Oo<ol0oooooooooooooiT0oc<0ooooooooc?l0033ooooo00?o
0?mVooooooooool01?ooool01Ol0ofKooooooooooooooooo0?oo00;ooooo00?o0?ooooooooooool0
1Oooool01?ooV@3ooooooc<0ooooV@03ooooo`Coc03o00?oooooo`3oI_oo00000_oo0003ooooo`05
o`3oI_oo003oooooool00?ooool00oo<o`09ooooo`05ool0VOooooooooooooooool0I_l01Oooool0
0ol0I_ooo`2Iooooo`0:ooooo`03oc?o0?oooooooooo00Kooooo00?o<ol0ooooooooool04oooool0
1oooV@3oooooooooooooooooo`2IooooooooV@001?ooool00ooo09Woooooooooo`07ooooo`03oc?o
0?l0oooooooo00cooooo00?o<ol0ooooooo<0?l00_ooool01?l0ooooooooooooooooool2oc?o0003
ooooooo<0?ooo`0000;oo`000_ooool00oooV@3oooooool0000<ooooo`03o`000?oooooooooo007o
oooo000Kooooo`;o00001Oooool00ol0ooooooooooooo`04ooooo`08oc?o0?oooooooooooonI0?lc
0?ooooooolco0?oo000Jooooo`?oo`004Oooool00ol0ofKoooooooooo`05ooooo`04o`3oI_oooooo
ooooo`3oo`Cooooo00?o0?ooooooooooool00oooool01OooV@3ooooooooooooooooooiT000;ooooo
00Ooc03ooooooooooooooooool`0oooo003o0?mV00Kooooo00Ko0?mVooooooooooooooooool00?o<
o`02ooooo`03olco0?oooooooooo00Gooooo00?oo`2Iooooooooool00_ooool00ol0I_oooooooooo
o`03ooooo`03o`1Vooooooooo`2I00[ooooo00?o<ol0o`1Vool0I_l01_ooool00olco`3ooooooooo
o`0Booooo`03oonI0?oooooooooo00;ooooo00?oo`2IooooooooV@001?ooool00ooo09Wooooooooo
o`07ooooo`03oc?o0?l0oooooooo00gooooo00?o<ol0ol`0ooooool00_ooool00ol0oooo<ol0oc?o
0002ooooo`03oc?o0?l0I_oo06Ko00?ooooo00GooiT0ooooooooooooooooool0000:ooooo`;o0000
0oooool001_ooooo00?o0000ooooooooool01?ooool00ol0ooooooooooooo`05ooooo`07oc?o0?oo
oooooiT0oooooolc0?oo0?ooolco000Jooooo`03ool00?oooooooooo00;oo`003oooool00ol0ofKo
ooooooooo`05ooooo`03o`3oI_oooooooiT000?ooiT00_ooool00ol0ooooooooooooo`02ooooo`03
oc<0ooooV@3ooooo00;ooooo00?o<`3ooonI0?o<0?l01?ooool00ooo003o0?mVooooo`06ooooo`05
o`3oI_ooooooooooooooooo<o`001?ooool00oo<o`3oooooooooo`04ooooo`03ool0VOoooooooooo
00;ooooo00?o06Koooooooooool01?ooool00ol0I_oo<`3ooc<0o`02oc<0o`Gooooo00?o06Kooc?o
0?ooool00_ooool5o`1Vo`03oooooolco`3ooooo01;ooooo00KooiT0oc<0oolc0?oo0?mVoooooooo
09T3ooooo`03oonI0?oooooooooo00;ooooo00?oo`2Iooooooooool01Oooool00olco`3o0?oooooo
o`0?ooooo`05oc?o0?oooooooooooooooolco`000oooool2o`1Vo`03oc?o0?o<0?oo06Ko00;ooooo
00GooiT0ooooooooooooooooool0000;ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00?o0?ooooooooooool01_ooool01olco`3ooooooonI0?oooooo<`3oo`3o
ooo<o`000_ooool2o`3oIQGooooo00?oo`00ooooooooool00oooool3ool000cooooo00?o0?mVoooo
ooooool00_l0I_l4ooooo`03oonI0?l0oooooooo00;ooooo00CooiT0oooooooooooo0?oo0oooool0
0olc0?oooiT0ooooo`03ooooo`03oonI0?o<0?oooooo00?ooooo00?oo`00o`3oI_ooool01oooool0
1?l0ofKoooooolco0?oo0005ooooo`03olco0?oooooooooo00?ooooo00Goo`2Ioooooooooooooooo
o`1Vo`07ooooo`03o`1Vooooooooo`2I00;ooooo00Oo<`3oooooooooooooooooo`1Voooooooo<ol0
00Sooooo00?o06Kooooooolco`004Oooool01?ooV@3oooooooooooooool2o`3oIP05ool0VOoooooo
ooooooooooooV@001?ooool00ooo09Woooooooooo`04ooooo`03oc?o0?oooooo0?oo00Oooooo0_lc
0?l6ooooo`03ol`0oooooooo<ol000;o<ol000Goooooo`3ooooooooo06Koool00002ooooo`04oc?o
0?oooooo06KooonI00;o0?oo0oooool00ooo003oooooooooo`08ooooo`03o`000?oooooooooo007o
oooo000Kooooo`03o`000?oooooooooo00?ooooo00?o0?ooooooooooool01_ooool01olco`3ooooo
ooooooooV@3o<`3oooooooo<o`000_l0ofH00ooooooo0?mVooooo`0Dooooo`03ool00?oooooooooo
00?ooooo0_ooV@000oooooooo`00ool0000:ooooo`03o`3oI_oooooo06Ko00;ooooo00Ko06Kooooo
oooooooooooooonI0?l0ool3ooooo`04oonI0?ooooooooooo`3oo`?ooooo00?ooiT0ooooooooool0
0oooool02?o<0?oooiT0oc<0oolc0?ooooooool00?oooooo0?mV0_oo09T6ooooo`04o`3oI_o<o`3o
ooooooooo`;oo`001?ooool01Oo<o`3oooooooooooooooooo`2I00;oo`000_ooool00ol0I_oooooo
ooooo`04ooooo`04oc<0ool0I_ooooooool0V@?ooooo00?o<`3oooooool0I_l00_ooool01?lco`3o
ooooooooooooool4o`3oo`04ooooool0I_oooooooc?o013ooooo00OooiT0ooooooooooooooooo`3o
I_oooooo<`3o00;o0?mV0_oo00000oooV@3oooooooooo`02ooooo`03ool0VOoooooooooo00?ooooo
00Co<ol0oooooooooooo0?oo1_ooool00olc0?oooooooc<0o`06ooooo`03ol`0oooooooooooo00?o
oooo00?o0?ooo`1Voooo00000oooool01?lco`3oc03oo`3oooooV@02ooooo`05o`3ooooooooooooo
oooooooo00002Oooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`0<oooo
o`08oc?o0?oooooooooooonI0?oooooo<`3oo`3oooo<o`03ooooo`03o`3oI_oooooooooo01;ooooo
00?oo`00oc<0oolc0?l00_lc0?l01?ooV@3oooooooooooooV@02ooooo`03ool00?oooooooooo00Ko
oooo00?o0?mVooooool0I_l01?ooool01Ol0I_oooooooonI0?l0ofKo0?oo00;ooooo0_o<o`001ooo
V@3oooooooooool0oooooooooc<0ooooV@001?ooool00oo<0?oooooooonI0002ooooo`07oc<0oooo
003o0?mVooooooo<0?ooooooool0V@05ooooo`03olco0?oooooooooo00?ooooo00?oo`00oooooooo
ool00_ooool01?o<o`3oooooool00?oo09T2ooooo`03ool00?oooooo06Ko00Kooooo00Co<`3ooooo
ool0I_ooo`2I1?ooool01?lc0?oo06Kooooooolco`03ooooo`03o`3ooooooooooooo00;ooooo00Co
0?ooooooool0I_oo<ol03oooool00olc0?oooiT0ooooo`02ooooo`09o`3oI_ooooooo`2Ioc<0oooo
oooo0?mVool00?oooooooiT000?ooooo00?oo`2Iooooooooool00_ooool01Olco`3oooooooooool0
oooooooo00Goo`2I00Go<`3ooooooooooooooooooc<0o`05ooooo`03ol`0oooooooooooo00Cooooo
00?o0?ooool00?ooool00oooool00olco`3ooooooonI0003ooooo`05o`3ooooooooooooooooooooo
00002?ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000gooooo00So<ol0oooooooooooo
oiT0oooooolc0?oo0?mVolco00Cooooo00?o0?mVooooooooool04?ooool01?oo003ooooooc<0oooo
ool2oonI00Cooooo00?ooiT0oooooolco`000olco`05ooooo`03o`3oI_l0I_oooooo00Gooooo00?o
06KooonI0?l0ofH00_ooool01?o<o`3oooooooooooooool3oonI0003ooooooooV@3ooooo00?ooooo
00Woc03ooooooooooooooooooonI0?ooooooo`00oc<0ool0ofH00_ooool01?o<0?ooooooool0VOoo
09T2ooooo`03olco0?oooooo0?mV00Gooooo00Soo`00ooooooooooooooooolco0?oo003oooooool0
V@?ooooo00?o06Koooooooooool01?ooool00olc0?ooooooooooo`02o`1Vo`08ool0VOoooooooooo
ooooool0I_oo<`3ooooooolco`02ooooo`03o`3ooooooooooooo00Cooooo0_l0ool00ol0I_oo<ol0
ooooo`0;ooooo`;o0?mV00?ooiT0ooooooooool00_l0ofH2ooooo`07ool0VOlc0?ooooooooooool0
ofKo0?oooonI0004ooooo`04ool0VOoooooooooooc?o00?ooooo00?o0?oooooooooo09T01?ooool0
1Olc0?ooo`2Ioooooooooooo<`3o00Cooooo00?oc03oooooooooool01?ooool00ol0I_ooo`00o`3o
o`02ooooo`;o0?oo00?o<ol0oonI0?l0I_l00oooool00ol0ooooooooooooo`02ooooo`03ool00?oo
oooooooo00Cooooo0_l00003ooooo`006oooool00ol0003oooooooooo`07ooooo`;oc03o1?ooool0
2?lco`3ooooooonI0?oooooo<`3oo`3oI_o<o`3oo`000oooool00ol0ofKoooooooooo`0@ooooo`04
ool00?oooooooiT0oonI00;ooooo00So<`3ooooooooooooooooooonI0?oooooo<ol0ool000;ooooo
00?o<ol0ooooooooool00_ooool3oc?o00Gooooo00GooiT0ooooool0oooo0?mVolco0004ooooo`05
olco0?oooooooooooonI0?lc0?l00_o<0?l00oooooooc03oooooo`04ooooo`04oonI0?oo09Wooooo
o`3oIP?ooooo00Soc03oooooooooooooo`2Iooooooo<o`3oooooo`3oIPKooooo00Koo`00oooooooo
003oo`00olco0?oo09T4ooooo`03o`1Voooo003ooooo00?ooooo00?o<`3oooooooooool00oooool3
o`1Vo`07ooooool0I_oo<`3ooooooolco`3oooooo`3oo`09ooooo`03o`3ooolco`3ooooo00Wooooo
0_l0ofH01Ooooooo<`3ooonI0?oooooo0?mV00Cooooo00Soo`2Ioooooolc0?ooc03oo`3oool0ofKo
o`00oonI00?ooooo00Coo`2Io`3oI_lco`3o0?mV0oooool00ol0ooooo`2Iooooo`03ooooo`06oc<0
ooooooooooooool0VOoooooo<`3o1?ooool00oo<0?ooooooooooo`02ooooo`03ool00?l0I_oooooo
00;ooooo0_l0ool2ooooo`03oc?o0?ooV@3o06Ko00Cooooo00Go0?ooooooooooooooooooool00007
ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Kooooo00Coc03ooooo
ooooooooc03o0oooool02Olco`3ooooooonI0?oooooo<`3oo`3oI_l0ooooc?l0ool00003ooooo`03
o`3oI_oooooooooo00kooooo00Coo`00oooooolc0?oooiT00oooool02?lc0?oo<ol0oc?o0?lco`3o
oooooonI0?ooooooo`000oooool2oc?o0003oooooolco`3o06Ko00;ooooo00?o<ol0ooooooooool0
0_ooool01OooV@3oooooo`3oool0ofKoc?l000Gooooo00Coc?l0ooooool0ooooc03o0_ooool00oo<
0?ooooooooooo`04ooooo`04oonI0?oo09Wo0?mVoc<0o`Cooooo00Coc03ooooooooo09Woc?l00_oo
ool00ol0ofKoooooooooo`05ooooo`04ool00?ooooooooooolco00Cooooo00Go06Kooooooooooooo
o`00ooooo`02ool00003oc<0oooo003ooooo00;ooooo0ooo00001Ooo09Wo06Koool00?oooooo<ol0
00;o0?oo2oooool00olco`3oooooooooo`08ooooo`06o`3oI_oooooo<`3oooooooooV@3o0?mV1?oo
ool01ooo09Woo`00oooooolc0?ooooooo`3oooooool00_l0ofH02?ooV@3oooooooooool0ofKooooo
oc?o0?oooooo0?mV0_ooool00ol0ooooo`2Iooooo`03ooooo`04oc<0ooooooooooooooooo`;oo`2I
00Go<`3ooooooooooooooooool`0o`03ooooo`03ool00?l0I_oooooo00Sooooo00?ooiT0olco0?o<
o`000oooool00ol0ooooo`2Iool0V@02ooooo`03ool00?oooooooooo00Cooooo00?o0000oooooooo
ool00Oooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00Gooooo00?oc03oooooooooool0
0_ooool03?o<0?oooooooooooolco`3ooooooonI0?oooooo0?mVoc<0ool0ooooooooolco00?ooooo
00?o0?mVooooooooool02Oooool4o`3oo`;oc03o00?ooooooonI0?l0ool00ol0ool02?lc0?oo<ol0
oooooooooooo<ol0ooooooooV@3ooooo0_oo0003ooooo`03oc?o0?l0ofKo06Ko00?ooooo00So<ol0
oooooooooooooiT0ooooool0ooooooooolco00Oooooo00?oc?l0oc<0ool0ool02Oooool01Ooo09Wo
oiT0o`3oI_oooooo<`3o00Co0?oo0_ooool01Oo<o`3ooooooooooooooooo0?mV00Gooooo0_l0I_l2
ooooo`03ool0VOo<o`3ooooo00;ooooo00Oo06Koooooooooooooooooool00?oooooo<`3o00;ooooo
0ooo0004ooooo`05ool0VOoooooo0?mVoc?o0?l0ofH03Oooool00olco`3oooooooooo`06ooooo`05
o`3oI_oooooo<`3oooooooooV@001_ooool01Ooo09Wooooool`0oooooooo0?oo00Cooooo00Go0?mV
oonI0?l0ofKooooooc?o0002ool00004ooooool0ofKo0?ooool0V@Cooooo00?o<`3oooooooooool0
1?ooool01?lc0?ooo`2Iooooooo<0?l3ooooo`03ool00?oooooo06Ko00Wooooo00CooiT0ol`0ooo<
o`3ooooo0_oo09T01?l0oooooooooooooooo09T2ooooo`03ool00?oooooooooo00?ooooo00?o0000
ooooooooool00Oooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`04
ooooo`03ol`0oooooooooooo00?ooooo00goc03ooooooooooooo<ol0ooooooooV@3oooooo`3oI_lc
0?ooooooo`3oooooooooc?l000;o06Ko00?o0?mVooooooooool02?ooool00ol0ooooooooooooo`02
ooooo`;o0?oo00?ooiT0oc<0ooooool00oooool00olco`3o<`3oooooo`02ooooo`03ool0VOooV@3o
oooo00;ooooo00Goo`00oooooooo003oo`00o`3oIP05ooooo`08oc?o0?oooooooiT0ooooool0oooo
c?l0ooooool0ofH4ooooo`;o<ol000?oc?l0oc?o0?l0ool02?ooool01?oo003oo`2IoonI0?l0ofH2
ooooo`07o`3ooolc0?oooooooc<0ool0oooo<ol0olco0002oc?o0003ool0VOl0ofKooooo00?ooooo
00Oo06Kooooooooooooo06Koool0VOooooooc?l000;ooooo00?o06Koooooooooool01?ooool00olc
0?ooooooooooo`07ooooo`06ool0VOl0oooo0?mVoc?o0?lc0?oo0?mV3?ooool00olco`3o0?oooooo
o`06ooooo`05o`3oI_oooooo<`3oooooooooV@001?ooool3o`1Vo`04ooooooo<0?oo0?oooc<0o`Go
oooo00Co0?mVoonI0?oo003o<ol00_ooool01?oo003o0?mVo`3ooooo09T2olco00;ooooo00?o<`3o
ooooooooool01?ooool01?lc0?ooooooool0VOo<0?l3ooooo`03ool00?l0I_oooooo00Oooooo00Ko
o`2IoonI0?o<o`3o<ol0o`1Vooo<o`03ooooo`04o`3oooooooooooooool0V@Oooooo00?o0000oooo
ooooool00Oooool001?ooooo00Co0000oooooooooooo00001?ooool2o`0000Cooooo00?oc03ooooo
ooooool01Oooool03?o<0?oooooooooooolco`3ooooooonI0?l0ofKo<`3oooooool0oooo06Koolco
00;ooooo00?o06Koo`3oI_ooool02?ooool02?l0ooooooooooooooooooooc03oool00?ooV@3o<`3o
1?ooool00olco`3oooooo`3oo`02o`3oo`04ool0VOooooooo`2IoonI00?ooooo00Koo`00ooooool0
ofKo06Koool00?ooool3ool00008oc?o0?ooV@3oooooooooool0ooooc?l0ooooool0ofH4ooooo`05
oc?o0?o<0?oo<`3oolco0?lco`002?ooool01_oo003oo`2Ioc?o0?ooV@3o<ol0o`3oo`Cooooo00?o
<ol0olco0?ooool00_ooool00olco`3o0?mVoc?o0004oc?o00;oo`2I00Koooooo`1Vool0I_ooc?l0
ooooool0I_l2ooooo`;o0?oo0_ooool00olc0?ooooooooooo`07ooooo`;o0?oo00Go0?mVoc?o0?oo
003oooooo`3oIP0<ooooo`03oc?o0?l0oooooooo00Gooooo00?o0?mVoooooolc0?l00_ooool00ooo
V@3oooooooooo`02ooooo`05o`1Voooooooo06Kool`0ool0ool00_ooool00olc0?ooooooooooo`03
ooooo`03o`3oooooV@3o<ol000?ooooo0oo<o`02ooooo`05olco0?lc0?ooooooooooool0I_l01Ooo
ool02?lc0?oooooool`0oooo09Woooooool00?oooooo06Ko2?ooool01_oo09WooiT0ool0VOo<0?oo
<ol0olco00Cooooo00Go0?oooooooooo09Wooooool`0o`03ooooo`?o00000oooool001?ooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`0<ooooo`0<ol`0oooooooo<ol0oooooooo
V@3o0?mVoc<0oooooooo06Koo`3ooooo003oc?l00_ooool00ol0ofKoooooooooo`06ooooo`05o`3o
ooooooooooooooooooo<0?l00_ooV@000ooooooo<`3ool`0o`03ooooo`03oc?o0?ooooooc?l000;o
c?l00ol0ool00oooV@3oooooooooo`03ooooo`04o`3oI_l0I_ooooooool000?ooooo00Goo`00oonI
0?oo003o0?ooolco0002ooooo`0;o`3oI_l0I_oooooooooooolco`3oc03ooc<0ooooooooc?l0oooo
oolco`001_ooool01ooo003oo`2Ioooooolco`3ooooooonI0?lco`000_ooool2oc?o0003ooooooo<
o`3oc03o00?ooooo00Ko<ol0ool0VOooooooooooo`1Voolco`06ooooo`07olco0?oooooo0?ooo`3o
oooooooo0?ooooooo`03oonI00Oooooo00Wo0?oooooooooooooo0?mVoc?o0?ooooooo`00oc<0ool0
ofH01?o<0?l7ooooo`03oc?o0?l0I_oo0?oo00Gooooo00Go0?mVoooooolc0?oooooooonI0004oooo
o`06o`1Vooooooooo`2Iooooool0I_oo0?oo0_ooool00olc0?ooooooooooo`03ooooo`08o`3ooolc
o`3ooiT0ool0VOooooooc?l0o`3oool0ofH3ooooo`06oc<0ooo<o`3oooooo`1Voooooooo06Ko1?l0
ofH01Olc0?ooc03oooooooooooooo`2I00;ooooo00?o06Koooooooooool01Oooool00ooo09Woc?l0
oonI0002ooooo`03ol`0ool0I_ooc?l000Cooooo00Co0?ooooooooo<0?oo<`3o1Oooool00ol0003o
ooooooooo`01ooooo`004oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00go
oooo00Coc03ooc?o0?oo09WooiT00_ooool01Ol0I_ooooooo`3oooooooooc?l000;ooooo00?o06Ko
o`3oI_ooool01_ooool02_l0ooooooooooooooo<0?oooiT0oooooooo003ooooooc<0ooo<0?l2oooo
o`06oc?o0?ooooooooooolco0?lc0?oooooo0oo<o`000oooV@3oo`2Iooooo`03ooooo`03o`3oI_oo
oooooooo00Cooooo00KooiT0oooooolco`3oc?l0oooooooo0002ooooo`05o`3oI_l0I_oooooooc?o
0?lc0?l00oooool00oo<o`3o<ol0o`3oo`05ooooo`03ool00?oo09Wo<ol000?ooooo00?ooiT0oc?o
0?lco`000oooool00oo<o`3o0?oool`0o`02ol`0o`04ooooool0ofKoo`2Io`1Vo`;ooooo00?o<ol0
ooooooooool00oooool00oo<o`3oooooo`3oo`03ooooo`05oonI0?lc0?ooooooooooooooV@001Ooo
ool02ol0ooooooooooooool0ofKooooooc?o0?oo09Wooooool`0oolc0?oo0?mV00?ooooo00?oc03o
ooooooooool01Oooool00olco`3o0?ooooooo`03ooooo`03o`3oI_oooooo<`3o00;ooooo00_ooiT0
ooooooooooooooooo`1Vooooooooo`00ool0VOoooooo0?ooo`1Vo`02ooooo`03oc<0oooooooooooo
00?ooooo00?o0?oooc?o0?ooool00_ooV@001?oo09Wo0?ooool00?l0ofH2ooooo`03oc<0oooooooo
c?l000;ooooo00Oo0?mVo`1Vooooooooooooo`3oI_lc0?ooc03o00;ooooo00?oo`2Iooooool0I_l0
1oooool00ooo09WooooooonI0003ooooo`03ol`0ooooooooc?l000;o<ol00oooool00ol0oooo<ol0
oc?o0005ooooo`03o`000?oooooooooo007ooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool03_ooool00olco`3oo`2IoonI0002ool0V@06o`1Voooo09Woooooo`3ooooo
003oc?l00_ooool00ol0I_oo0?mVooooo`04ooooo`09o`3oooooooooooooooooooooV@3oooooool0
0?oooooo<`3o00;ooooo00Soc03ooc?o0?o<0?ooooooolco0?oo09Wooooooc<0o`;ooooo00?oc?l0
o`3oooooV@000_ooV@000ooooooo0?mVo`1Vo`06ooooo`06oonI0?oooooo<ol0olco0?ooooooo`00
0_ooool01Ol0ofKoooooo`1Voolco`3o<`3o00?ooooo00?oc?l0oooooolco`000ol0ool01?oooooo
o`00oooooolco`02ooooo`;o0?oo00?ooooooonI0?ooool00_ooool00oo<o`3oooooo`3oo`02oc<0
o`04ooooooo<0?oo0?mVo`1Vo`?ooooo00?o<ol0ooooooooool00ol0ool00oo<o`3o0?ooooooo`02
ooooo`04oonI0?lc0?oo0?ooo`3oo`;ooooo00GooiT0ooooooooooooooooo`3oo`03ooooo`08o`3o
I_lco`3oooooooooooo<0?ooo`00ooooool0ofH4ooooo`03ol`0ooooooooo`0000?oo`0000Cooooo
oc?o0?l0oooo06Ko0oooool01Ol0ofKooooooc<0oooooooooiT000?ooooo00So06Kooooooooooooo
o`00ool0VOo<0?oo0?ooo`1Vo`?ooooo00?o<`3oooooooooool00_ooool01olco`3o0?ooooooooo<
o`3ooooooonI0?ooool00_ooV@001ooooooo<`3oooooooooooooc?l0ooooool0ofH00_ooool02_l0
I_ooooooooooool0ofKoc03ooooooooo003oooooool0VOl0I_l6ooooo`04ool0VOooooooc?l0oonI
00Cooooo00Coc03oo`1Vooo<o`3ooooo1?lco`000olc0?oo0?ooooooo`04ooooo`03o`000?oooooo
oooo007ooooo000Dooooo`;o00001Oooool00ol0003oooooooooo`0>ooooo`0;ool0VOlco`3ooiT0
ooooool0I_oo<`3ooooooooo09Wo0?ooool00?o<o`000oooool00ol0I_oo0?mVooooo`03ooooo`07
o`3ooooooooooooool`0ooooV@3oooooool00003o`3oIP06oooooolco`3oooooooooooo<o`3oo`2I
0oooool02Olc0?ooooooooooooo<o`3o0?ooool0VOoooooooiT0o`3oIP06ooooo`05oonI0?oooooo
ooooolco0?lco`000_ooool00ooo003oooooo`3oIP02oc?o0003oc<0oooooooooooo00;ooooo00?o
c?l0oooooolco`000oooool01?l0ooooo`00oc?o0?l0ofH2o`3oo`?ooooo00OooiT0oooooooooooo
ooooolco0?oooooo0?oo00;ooooo00Co<`3ool`0ool0ofKo06Ko0oooool01?lco`3oooooooooool0
ool2ooooo`03o`3oooo<o`3ooooo00;ooooo00CooiT0oc<0oooooooooooo0ol0ool00oooV@3o0?oo
o`3oo`03ooooo`0:o`3oI_oooooo<ol0ooooooo<0?ooooooool0VOoo003o<`3oo`3oIPCooooo00ko
c03oool00?ooooooooooool00?oooooo<ol0ooooool0oooo06Koooooool0ofKooooooc<0o`;oo`2I
00[ooiT0ooooooooooooooooo`1Vooooooooo`00ool0VOoooooo0?oo0_ooool01?l0I_oooooooooo
oolc0?l2ooooo`;o<ol0013oooooo`3oool0ooooc?l0o`3ooooooooooiT0oooooooo003ooiT0oc<0
oooooooo06Koooooooo<o`3o0?mV0_ooool01_l0I_ooooooooooool0ofKoc03oool000;ooooo00?o
06Koool0VOooool01Oooool00ooo09Woc?l0oonI0006ooooo`03ol`0ooo<o`3ooooo00;ooooo00Co
0?mVoooooolc0?ooo`2I1Oooool00ol0003oooooooooo`01ooooo`006oooool00ol0003ooooooooo
o`0=ooooo`05ool0VOoooooo<ol0oonI0?l0I_l00_ooool01_lc0?ooooooool0VOl0ooooooooolco
00?o0?oo00Go0?mVooooooooooooooooo`3oo`03ooooo`09oonI0?oo09Woo`00o`3oI_oooooo<`3o
o`3oI_oooooo<ol000;ooooo00?oc?l0ol`0ooooool00_ooool01_lc0?ooooooooooooooooooc?l0
ool0V@;ooooo00?ooiT0ooooooooool00oooool03_ooV@3oooooooooooo<o`3o0?oooooooolco`3o
ooooool00?oooooo<ol0o`3oI_o<0?oo06Ko0_ooool2o`1Vo`03ooooooo<o`3o<ol000?ooooo00Co
o`00oc?o0?l0ofKo0?oo1_ooool01?ooV@3oooooooooooo<o`02ooooo`06o`3ooooooooooooooc<0
ool0I_oo0?mV1?ooool00olco`3o0?ooooooo`03ooooo`06olco0?oooooooooooonI0?oooooo<`3o
1Oooool00oooV@3oooooooooo`02ooooo`05o`3oI_oooooooooooc?o0?o<0?l00_ooool01?oo09Wo
o`00ooooool0ofH4ooooo`03ool00?o<0?ooc03o00;ooooo00Ooo`00oooooolco`3o0?ooooooool0
ofKooooo00?oc?l000?ooiT0ol`0ooo<o`000_o<o`001_ooooooo`00oooooooo09Woooooo`3oo`?o
oooo00Go06Kooooooolc0?oooooooc?o0004ooooo`03olco0?l0oooooooo00?ooooo00Coo`00o`3o
I_ooV@3o06Ko0_ooool00ol0ofKoc?l0ooooo`02ooooo`04o`1Vooooooooc03oo`3oIP?ooooo00?o
06Koool0VOooool01OooV@000oo<o`3ooiT0ooooo`06ooooo`05ol`0ooo<o`3oooooooooool0ofH0
0_ooool00olc0?ooo`2Iooooo`04ooooo`03o`000?oooooooooo007ooooo000Kooooo`;o00003_oo
ool01Ooo09Wooooooc?o0?ooV@3o06Ko00?ooooo00Go<`3oool0VOoooooo0?ooolco0003ooooo`04
o`3oool0ofKoooooo`3oo`?ooooo00KooiT0oooooooo09Wo0?mVoooooolc0?l2ooooo`06oc?o0?oo
ooooooooolco0?oo09Wooooo1?o<0?l02?lc0?ooc03ool`0ooo<o`3o0?ooool0VOl0ofKo06Ko0ooo
V@001ooooooooiT0ooooooooooooo`2Iolco0?l0ool00_ooool3oc?o0004ooooool0ofKoc03ooc<0
o`;o06Ko00Goooooo`1Vooooooooc?l0ooooo`04oc?o0003ool0VOl0ofKooooo00Oooooo00?ooiT0
olco0?ooool00oooool01_l0oooooooooonI0?ooV@3o0?mVol`0o`?ooooo00?o<ol0o`3oooooool0
0oooool01Oo<o`3ooooooonI0?oooooo<`3o00Oooooo00GooiT0ooooooooooooooooo`3oIP02oooo
o`03oc?o0?o<0?oooooo00;ooooo00?oo`2Iooooooooool00ol0ofH01Oooooooo`00oooooooooooo
c03o00;ooooo00?oo`00olco0?o<o`000oo<o`002?l0I_ooc03oooooooooV@3oc?l0ool0VOo<0?oo
06Ko0oo<o`000ooooooo0?ooooooo`03ooooo`04o`1Voooooooo<`3ooc?o00Gooooo00?oc?l0oooo
ooooool00oooool01?oo003o0?mVo`1VooooV@02o`3oIP03ooooooo<o`3ooooo00;ooooo00Oo06Ko
ooooooo<0?oo<`3oo`3oI_oooooo06Ko00;ooooo00?oo`2IoonI0?ooool00_o<o`000ooo09WooiT0
ooooo`08ooooo`08ol`0ooo<o`3o0?mVol`0oooooooo<`3oooooool0I_l4ooooo`;o00000oooool0
01_ooooo00?o0000ooooooooool03?ooool01_oo09Wooooooooooolco`3o06KooonI00Cooooo00Go
<`3oool0VOoo003oo`2Iolco0003ool0V@0<o`3oI_l0ooooo`2Iool0VOooooooc03ooonI0?oooooo
0?mVool0VOoooooo<`3o0_ooool01?lco`3o0?mVolco0?oo09T7ooooo`06oc<0ooooooooooooolco
0?o<0?oo0?mV1?ooool01oooV@3ooooooooooooo09Woc?l0o`3ooooo09T01?ooool01?oo003ooooo
o`3oI_lc0?l5ooooo`05o`1Vooo<o`3ooooooooooooo00000_ooool00ooo09Wo0?mVooooo`08oooo
o`03oonI0?oooooooooo00?ooooo00Ko0?oooonI0?lc0?oooiT0ooooooo<0?l2ooooo`03oc?o0?oo
oooooooo00?ooooo00Goc?l0oonI0?oooooooooooc<0o`08ooooo`03oonI0?l0ofKo0?mV00;ooooo
00?o<ol0ol`0ooooool01?ooool00ooo09Wooooooc<0o`02ooooo`Co0?mV1?o<o`000olco`3o0?mV
o`3oo`02ol`0o`03oc<0ool0I_oooiT000?ooooo00Ooo`2Io`1Voooo003oo`2Iol`0ooo<o`3o0?oo
00Gooooo00?o06Kooooooolco`001Oooool00oo<o`3oc03oooooo`04ooooo`04oc<0ool0ofKo0?mV
oonI00?ooooo00Woc?l0ooooooooooooooooo`1Vooo<0?oooooooc<0ool0ofH00oooool01_ooV@3o
o`2Iolco0?oo09Woooooool0V@_ooooo00Koc?l0o`3oI_l0I_oo06Kooc<0ool0I_l6ooooo`03o`00
0?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00cooooo00Koo`2Ioooooooooooo0?mV
oc?o0?ooV@04ooooo`05oc<0ooooooooo`2Iooooooo<o`001?ooool2o`3oIP09ooooooo<0?oooiT0
ooooool0ofKoo`00oooooooo09Wo<`3o00;ooooo0_o<o`000ol0ofKoooooooooo`06ooooo`06oc<0
ooooooooooooooooooo<o`3o06Ko1_ooool01_oo09Woooooolco0?l0ooooooooool0V@Cooooo00?o
o`00ol`0ool0ofH01_ooool00oo<o`3oooooool00003ooooo`03o`3oI_oooooooooo00Sooooo00?o
oiT0ooooooooool00oooool02_ooV@3o0?ooo`3oool0oooooiT0o`3oooo<0?oo0?oooooooolco`04
ooooo`05olco0?ooV@3ooooooooooolc0?l02?ooool00ol0ofKooiT0ooooo`02ooooo`03oc?o0?o<
0?oooooo00Cooooo00Coo`2Ioooooooooooo<`3o0_oo09T3olco0007ool0VOl0ofKo0?mVo`3oI_o<
0?oo<ol0o`3oo`02ooooo`03oc<0oooooooooiT000?ooooo00Ko06Koooooooo<0?ooc03oooooooo<
o`06ooooo`03o`1Voolco`3o<`3o00Cooooo00?oc?l0ooooooo<0?l01?ooool00olc0?oo06Kooooo
o`02ooooo`05oonI0?ooooooooooooooooo<o`000oooool02Ol0I_ooooooo`1Voolc0?oo0?mVoooo
ooooV@3oooooolco0002ooooo`03ool0VOoooooooooo00[ooooo00Goc?l0o`3oI_oooooo<`3oo`1V
o`07ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00cooooo00Ooo`2I
oooooooooooo0?mVoc?o0?ooV@3oc03o00Cooooo00Go<`3oool00?ooooooooooolco0003ooooo`0:
o`1Voooooooo0?mVooooooooV@3o0?mVoooooooo003ooooooc<0o`;oo`2I00Goc?l0ool0VOoo09Wo
ooooo`3oIP07ooooo`;o0?mV00Goooooo`3oI_o<o`3oc03oool0V@04ooooo`07ool0VOooooooc?l0
ooooool0ooooooooool0V@04ooooo`03ol`0oolc0?oo0?mV00Kooooo00?o06Koolco0?ooool00_oo
ool00ooo09Wo0?mVooooo`08ooooo`03olco0?oooooooiT000?ooooo00_ooiT0o`1Voooooooooooo
oc<0ool0ofKooiT0o`3oooooooooc03ooc?o0002ol`0o`;ooooo00CooiT0olco0?oooooo<`3o2?oo
ool00ol0ofKoooooooooo`04oonI0003ol`0oooooooooooo00Cooooo00Goo`2Ioooooolc0?oooooo
olco0007ooooo`05ool00?lco`3o<ol0oooooolc0?l00_ooool00oooV@3o06Koo`1Vo`02o`1Vo`06
ool00?ooooooooooooooool0ooooc?l01Oooool00ol0I_oo<ol0oc<0o`04ooooo`04olco0?oooooo
oooool`0o`?ooooo00?o<`3oo`1Vooooool00_ooool00oooV@3oooooooooo`02ooooo`05olco0?oo
oooooooool`0ool0I_l00_ooool01Ol0ofKooooooonI0?ooooooc?l000oooooo00?o0?mVolco0?lc
0?l02Oooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`0;ooooo`08ool0
VOooooooooooooooool0ofKo<ol0oonI0?o<0?l5ooooo`04oc<0oooo003oooooolco00;o<`3o0_oo
ool00ol0I_oooooooonI0002ooooo`04ool00?oooooooooooc<0o`;ooooo00?oc?l0ooooooooool0
0_ooool00ol0ofKoooooooooo`04ooooo`03o`3oI_oooooo0?mV00;o<`3o00?oc?l0ol`0oooo09T0
0ooo09T2ooooo`03olco0?l0oooooooo00;ooooo00Ooo`2Ioooooooooooooooooc<0oooooooo0?mV
00Ooo`0000Koc?l0ooooooooooooooooool0VOl0ofH8ooooo`05olco0?oooooooooooonI0?ooool0
0_ooV@000ooooooo06Koooooo`02ooooo`03oc<0ool0ofKooiT000;ooooo00Wo<ol0oooooooooooo
c03oooooooooV@3oc?l0oooooolc0?l01oooool00ol0ofKoooooooooo`03ooooo`03oc?o0?o<0?oo
oiT000Oooooo00Coo`2Ioooooolc0?ooc?l01oooool01ooo003ooooooooooolco`3o<`3ooooooooo
V@001Oooool01?oo003oooooooooool0ool2ooooo`03olco0?oooooooooo00?ooooo00?o<ol0oooo
oolc0?l00_ooool01Oo<o`3oooooooooooooooooc03o00;ooooo00Co<`3oooooool0I_ooo`000ooo
ool01oooV@3oooooooooooooooooc?l0ooooooo<0?l01Oooool00oooV@3oooooolco000@ooooo`03
o`3oI_o<o`3ooooo00Wooooo00?o0000ooooooooool00Oooool001_ooooo0_l0000<ooooo`09ool0
VOooooooooooo`3oI_l0I_oooooooonI0?ooooooc03o00Gooooo00[o<`3ooooooolc0?ooc?l0oooo
oolc0?ooc03oooooool0I_oooiT00_ooool01_oo003ooooooooooolc0?ooooooolco00Kooooo00?o
0?mVooooooooool00_ooool01?l0ofKoooooooooool0I_l2ooooo`03olco0?o<0?oooooo00?ooooo
0_o<o`000ooooooo0?ooooooo`02ooooo`05ool0VOoooooooooool`0oolc0?l00_ooool00ol0ofKo
ooooooooo`04ooooo`05olco0?ooooooooooool0VOl0ofH02Oooool01Oo<o`3ooooooooooooooooo
oiT000;ooooo00?o06Koooooooooool00oooool00ol0ofKooiT0ooooo`02ooooo`07oc?o0?oooooo
oiT0oonI0?ooooooc?l0oc<0o`08ooooo`03o`3oI_oooooooooo00?ooooo00?o<ol0ol`0ooooool0
1?ooV@05ooooo`03olco0?oooooooooo00Oooooo00Koo`00ooooool0oooo<ol0ooooooooV@05oooo
o`03ool00?oooooo0?oo00Cooooo00Soc?l0oooooooooooooooooc?o0?l0I_oooooooc<0o`;ooooo
00_oc?l0oooooooooooooooool`0oooooooo<`3oooooool0I_ooooooool00003ooooo`03oonI0?oo
oooooooo00;ooooo00?oc?l0ol`0ooooool00oooool00oooV@3o0?mVolco000Aooooo`03o`3oI_o<
o`3ooooo00Sooooo0_l00003ooooo`006oooool00ol0003oooooooooo`0;ooooo`0:ool0VOoooooo
ooooo`3oI_l0I_oooooooonI0?lco`3ooooool`0o`Cooooo00Woo`00oc<0ooooooooc?l0ol`0oooo
oooo<`3oooooooooV@000oooool00ooo003ooooooc<0o`02oc?o0003olco0?oooooooooo00Gooooo
1?l0ofH2ooooo`06o`1Voooooooooooooooooolc0?ooc?l00_ooool2olco00;ooooo00?o0?oooooo
ooooool00oooool2ool0V@05oc<0ooooooooooooooooool0ofH01_ooool01Oo<o`3oooooool0VOoo
oooo0?mV00Sooooo00?oc?l0ooooooooool01Oooool00ol0I_ooooooooooo`04ooooo`08o`3oI_oo
V@3ooooooooooolco`3ooiT0ooooooo<0?l2ooooo`03olco0?oooooooooo00Gooooo00?o0?mVoooo
ooooool00oooool00olco`3ooooool`0o`04ooooo`03oonI0?oooooooooo00?ooooo00?oc?l0oc<0
ooooool01oooool01_oo003oooooo`3ooolco`3ooooooonI00Cooooo00Coo`00oooooooooooo0?oo
0_lco`03ooooo`?oc?l000Ooooooo`1Voooooooooooooc<0ooooooooc?l000Cooooo00Koc03ooc<0
oooooooo06Kooooooooo0003ooooo`03oonI0?oooooooooo00;ooooo00?oc?l0ol`0ooooool00ooo
ool01?ooV@3oooooolco0?l0ofH?ooooo`04o`3oI_oooooo<`3oolco00Wooooo00?o0000oooooooo
ool00Oooool001_ooooo00?o0000ooooooooool02oooool01?oo09Woooooooooool0ofH2ooooo`03
oonI0?oooooo<ol000;o<ol00oooool03?oo003ooooool`0ooooooooc?l0oooooolco`3ooiT0oc?o
0?l0I_ooooooool000;ooooo00?o<ol0ooooooo<o`003_ooool00ol0I_ooooooooooo`02ooooo`03
olco0?o<0?ooc?l000Cooooo00?o0?ooooooooooool01Oooool01Olc0?ooo`2Ioooooooooooo0?mV
00Kooooo00Goc?l0o`1Voooo09Woooooo`3oIP08ooooo`03olco0?oooooooooo00Gooooo00?o06Ko
ooooooooool01?ooool00ol0ofKooooooonI0002oonI0006oc?o0?oooooooooool`0oolc0?ooc?l0
1_ooool00ol0ofKoooooooooo`04ooooo`03oc?o0?o<0?oooooo00Gooooo00OooiT0oooooooooooo
ooooolco0?oooooo<`3o00Wooooo00Co<`3oooooool0oooooiT01Oooool01?oo003ooooooc?o0?lc
o`02ooooo`06oc?o0?oooooooooooooooolco`3ooooo1_o<o`05ooooo`03oc<0oooooooo06Ko00?o
oooo00Goo`00oooooooooooooooooonI0003ooooo`03olco0?o<0?oooooo00;ooooo00GooiT0oooo
ooo<o`3ooooooc<0o`03o`3oIPcooooo00Go0?mVoc<0ooooooooooooolco0008ooooo`03o`000?oo
oooooooo007ooooo000Kooooo`03o`000?oooooooooo00[ooooo00Goo`2Ioooooooooooo06Koo`3o
IP03ooooo`07oonI0?oooooooooooooooolco`3oc03oooooo`02ol`0o`;ooooo00goc?l0oooooolc
o`3ooiT0oooooolco`3oooooool00?oooooo<ol0oc<0ooooooooc?l000gooooo00?o06Kooooooooo
ool00oooool00ol0ooooc?l0oc<0o`04ooooo`03o`3ooooooooooooo00Cooooo00Co<`3ooooooooo
ooooo`2I0_ooool00ol0ofKoooooooooo`04ooooo`03olco0?oooooo0?mV00Sooooo00?oc?l0oooo
ooooool01Oooool00ol0I_ooooooooooo`06ooooo`03o`3oI_oooooooooo00;ooooo00Ko<ol0oooo
ooo<0?oo<`3oolco0?ooool5o`3oIPKooooo00?o<ol0ol`0ooooool01oooool01?ooV@3ooooooooo
ooo<o`02ooooo`03oc<0oooooooooooo00Gooooo00Go<`3oool00?oooooo0?oooonI0005ooooo`03
ool00?oooooo<ol000Cooooo0olco`04ooooo`03o`1Voooooooo<`3o00Gooooo00Co<`3ool`0oooo
oooo06Ko1?ooool01Ooo003oooooooooooooV@3ooooo00;oo`0000?oooooolco0?ooool00_ooool0
1OooV@3oooooolco0?oooooo<`3o00?ooooo00?o0?mVooooooooool02?ooool00ol0ofKooooooc<0
o`02ooooo`03olco0?oooooooooo00Kooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000
ooooooooool02_ooool01?oo09Woooooo`1Vool0ofH4ooooo`09oonI0?oooooooooooooooolco`3o
oooool`0ooooooooo`0000?ooooo00_oc?l0oonI0?oooooo<`3ooooooolco`3oo`00oc?o0?lc0?oo
ooooolco000=ooooo`03o`1Voooooooooooo00Gooooo00?o0?oooooooolc0?l00_ooool00ol0oooo
ooooooooo`05ooooo`04oc<0ooooooooooooooooo`;oo`2I00?o0?mVooooooooool01?ooool00oo<
o`3oooooo`3oIP08ooooo`03olco0?oooooooooo00Gooooo00?o06Koooooooooool01_ooool00ol0
ofKoooooooooo`03ooooo`05oc?o0?lc0?ooc03oooooooo<o`002oooool00olco`3oc03oooooo`07
ooooo`03oonI0?ooooooc?l000?ooooo00?o<`3oooooooooool01?ooool01olc0?oooooooooooooo
003o0?oooonI0?lco`000oooool00ooo003ooooooc?o000<ooooo`04o`1Voooooooooooooc<0o`?o
oooo00Co<`3ooooooooooooo06Ko1_ooool2ool00006oonI0?oo003oooooooooooo<0?ooc?l00_oo
ool00oooV@3oc?l0olco0003ooooo`;o<`3o00?oooooo`3oI_ooool02?ooool01?l0ofKooooooooo
oolc0?l3ooooo`03olco0?oooooooooo00Gooooo00?o0000ooooooooool00Oooool001_ooooo0_l0
0004ooooo`03o`1Voooooooooooo00Cooooo00Coo`2Iooooool0I_oo0?mV1?ooool00oooV@3ooooo
ooooo`02ooooo`04oc?o0?ooooooooooool000?ooooo00?o<ol0oonI0?o<o`001Oo<o`000ooooooo
c?l0ooooo`04ooooo`?o06Ko00?oooooo`1Vool0I_l00ol0I_l8ooooo`06o`3oooo<0?oooooooc<0
oooooooo0?oo1oooool00olc0?ooooooooooo`03ooooo`03ool0VOl0ofKoo`2I00?ooooo00?oo`2I
olco0?l0ofH02?ooool00oo<o`3oooooooooo`05ooooo`03o`1Voooooooooooo00Oooooo00?o<`3o
o`3oI_ooool01?ooool01?lco`3oooooo`3oI_o<o`0:ooooo`03oc?o0?o<0?oooooo00Wooooo00?o
oiT0olco0?ooool00_ooool00olc0?ooooooooooo`02ooooo`;o<`3o0oooool01?oo003ooiT0o`3o
oolco`02ooooo`04ool00?oooooooooooc?o00gooooo00Ko06Kooooooooooooo<`3ooooooolc0?l3
ooooo`03o`1Voooooooooooo00Oooooo00SooiT0ooooooooooooc03oooooooo<o`3ooooooonI00Oo
oooo00?o<`3oooooool0ofH01_ooool2o`3oIP?ooooo00Go<`3oooooooooooooooooolco0006oooo
o`;o00000oooool001_ooooo00?o0000ooooooooool01?ooool00ol0I_ooooooo`1Vo`03o`1Vo`04
ooooool0I_ooooooo`3oIPCooooo00?ooiT0ooooooooool00_ooool02?lco`3ooooooooooooooooo
o`00oooooolco`3ooiT01?ooool01?oo003o06Koooooooo<o`06ooooo`04o`1Vooooooooooooo`1V
o`kooooo00Co0?oooooooolc0?oo0?oo1oooool00olc0?ooc03oooooo`06ooooo`08o`3oI_oo09Wo
o`2Ioooooooo09Woooooolco0?l0I_l7ooooo`03olco0?oooooooooo00Gooooo00?o06Kooooooooo
ool02?ooool00ol0ofKoooooooooo`03ooooo`04oc<0oolco`3oooooolco00Wooooo00?oc03ooc?o
0?ooool02oooool2oonI00?ooooo1?lc0?l6ooooo`06oonI0?l0ooooo`00oc?o0?oo003ooooo0_lc
o`000ol0ooooooooooooo`0<ooooo`04o`1Voooooooooooooc<0o`?ooooo00?o06Kool`0ooooool0
2Oooool00oooV@3ooooool`0o`02ooooo`03oonI0?oooooooooo00Oooooo00?o<`3oo`3oI_lc0?l0
0_lc0?l00ooooooo0?mVo`3oIP05ooooo`03oc<0oooooooooooo00;ooooo00?oc?l0ooooooooool0
1?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05ooooo`06o`1Voooo
oooooooooooooooo09Wo06Ko0_ooool00ol0ofKoooooooooo`02ooooo`03oonI0?oooooooooo00?o
oooo00Oo<ol0ooooooooooooo`00oc?o0?oooooooiT000?ooooo00Coo`00oooooooooooo06Ko1_oo
ool00ol0I_ooooooooooo`0Aooooo`03o`3ooooooooo0?oo00Oooooo00?o<`3ool`0ooooool01ooo
ool00ol0ofKoooooool0V@02ooooo`03olco0?l0I_oooooo00Gooooo00?oc?l0ooooooooool00ooo
ool3o`1Vo`_ooooo00Co<`3oo`3oI_oooooooooo0_lc0?l01_oooooo0?mVoc?o0?ooooooc?l0ol`0
o`Oooooo00?oc03ooc?o0?ooool02_ooool01?o<o`3oooooooooooooV@0<ooooo`08oonI0?l0oooo
oooooc?o0?oooooo<ol0ooooool0ool@ooooo`03o`1Voooooooooooo00;ooooo00Co06Kooooooooo
ooooc03o2Oooool00oooV@3oc03oooooo`02ooooo`03oonI0?oooooooooo00Wooooo1?l0ofH00olc
0?ooooooooooo`03ooooo`03oc<0oooooooooooo00?ooooo00?oc?l0ooooooooool01?ooool00ol0
003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`08ooooo`05ool0VOoooooooooooooo
ool0ofH01Oooool00oooV@3oooooooooo`04ooooo`06oc?o0?oooooo<ol0ool00?oooooooiT00_oo
ool01Ooo003ooooooooooooooooo06Ko00Kooooo00?o06Koooooooooool04Oooool01?o<0?oo0?oo
oooooolc0?l5ooooo`03oc<0ooo<0?oooooo00Wooooo00Ko0?mVooooool0ofKo0?mVooooooo<o`05
o`1Vo`03ooooooo<o`3ooooo00Cooooo00?o06Koooooooooool03?ooool00ol0ofKo<`3ooc<0o`02
ooooo`07o`3oI_oooooooooooc?o0?o<o`3ooooool`0o`05ooooo`;o<ol03?ooool01?o<o`3ooooo
ooooooooool2oonI00Wooooo00?ooiT0ooooool0ool00_ooool01?lco`3oooooooooool0oolAoooo
o`04o`1Voooooooo06Koo`1Vo`?ooooo00?oc03oooooooooool02?ooool01?ooV@3ooooooooooooo
V@0Aooooo`03oc<0oooooooooooo00;ooooo00?o<`3oooooooooool01?ooool00oo<o`3ooooooooo
o`03ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Sooooo00Goo`2I
ooooooooooooooooo`3oIP05ooooo`03oonI0?oooooooooo00Gooooo00Co<ol0oooooooo003ooiT0
0_ooool00ooo003oooooooooo`03ooooo`;o06Ko0oooool00ol0I_ooooooooooo`0Booooo`04ol`0
oooooooooooooc<0o`Gooooo00?o<`3ool`0ooooool02_ooool01Ol0ofKoooooooooooooooooc?l0
00Gooooo00?oc?l0ooooooooool00oooool00ol0I_ooooooooooo`0>ooooo`Co0?mV1?ooool01?o<
o`3o<ol0ooooooo<0?l2ooooo`;o<ol03_ooool00oo<o`3oooooooooo`03ooooo`?ooiT01Oooool0
1OooV@3ooooooooooooooooo0?oo00?ooooo00?o0?ooooooooooool04Oooool00ol0I_oooooooooo
o`03ooooo`03ol`0oooooooooooo00Oooooo00Goc03oooooooooV@3ooooooonI000Aooooo`05oc<0
oooooooooooooooooolc0?l03Oooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Sooooo
00?oo`2Iooooooooool00_ooool00ol0ofKoooooooooo`04ooooo`03oonI0?oooooooooo00Kooooo
00Coo`00oonI0?oo003oo`002?ooool00ol0I_ooooooo`1Vo`0Fooooo`04ol`0oooooooooooooc<0
o`Cooooo00?o<`3ool`0ooooool03_ooool00oo<o`3oooooooooo`02ooooo`03olco0?oooooo06Ko
00?ooooo00?o06Koooooooooool05oooool00oo<o`3ooooooc?o0003oc?o00oooooo00?oc?l0oooo
ooooool01oooool2oonI00?ooooo00GooiT0ooooooooooooooooo`3oo`02ooooo`03o`3ooooooooo
oooo01Sooooo00?oc03oooooooooool01_ooool01Oo<0?oooooooooooooooooooiT001?ooooo00?o
<`3ooooooolc0?l03Oooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Oooooo00?oo`2I
ooooooooool00_ooool00ol0ofKoooooooooo`04ooooo`03oonI0?oooooooooo00Kooooo00?ooiT0
ool00?ooool02_ooool00ol0I_ooooooooooo`0Eooooo`04ol`0ooooooooooooooooo`Co<`3o00?o
oooool`0ooooool03oooool2olco0003ooooooo<o`3ooooo00;ooooo0ol0I_lKooooo`03olco0?oo
oooooooo017ooooo00?oc?l0ooooooooool02Oooool3oonI00Gooooo00?o0?ooooooool0ool06_oo
ool00oo<0?ooooooooooo`05ooooo`03ol`0oooooooooooo01Oooooo00?o<`3oooooooooool03Ooo
ool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`06ooooo`03ool0VOoooooo
oooo00?ooooo00?o0?mVooooooooool01?ooool00oooV@3oooooooooo`05ooooo`03oonI0?oooooo
oooo02Cooooo00?oc03oooooooooool01?ooool00oo<0?ooooooooooo`0Aooooo`03olco0?oooooo
oooo023ooooo00?oc?l0ooooooooool04Oooool00oo<o`3oooooooooo`0Booooo`03o`3ooooooooo
oooo01[ooooo00?oc03oooooooooool01?ooool00oo<0?ooooooooooo`0Wooooo`03o`000?oooooo
oooo007ooooo0008ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0
003oooooooooo`06ooooo`03ool0VOoooooooooo00?ooooo00?o0?mVooooooooool01?ooool00ooo
V@3oooooooooo`04ooooo`03oonI0?oooooooooo02Gooooo00?oc03oooooooooool01?ooool00oo<
0?ooooooooooo`0dooooo`03olco0?oooooooooo013ooooo00?oc?l0ooooooooool0<?ooool00oo<
0?ooooooooooo`03ooooo`03ol`0oooooooooooo02Sooooo00?o0000ooooooooool00Oooool000Oo
oooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool01_ooool00ooo09Woooooooooo`02ooooo`03o`3oI_oooooooooo00Kooooo00?ooiT0
ooooooooool00oooool00oooV@3oooooooooo`0Vooooo`Koc03o>?ooool00oo<o`3oooooooooo`0?
ooooo`03olco0?oooooooooo033ooooo00?oc03oooooooooool00oooool00oo<0?ooooooooooo`0X
ooooo`03o`000?oooooooooo007ooooo0007ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000
ooooooooool00_ooool2o`0000Kooooo00?oo`2Iooooooooool00oooool00ol0ofKoooooooooo`06
ooooo`03oonI0?oooooooooo00;ooooo00?ooiT0ooooooooool0IOooool00oo<o`3oooooooooo`0?
ooooo`03olco0?oooooooooo033ooooo00?oc03oooooooooool00_ooool00oo<0?ooooooooooo`0W
ooooo`?o00000oooool000Oooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00Gooooo00?oo`2Iooooooooool00oooool00ol0ofKoooooooooo`07
ooooo`04oonI0?oooooooooooonI06Sooooo00?oc?l0ooooooooool03_ooool00oo<o`3ooooooooo
o`0booooo`04ol`0oooooooooooool`0obcooooo00?o0000ooooooooool00Oooool000Oooooo00Co
0000oooooooooooo00001oooool4o`0000Gooooo00?o0000ooooooooool01?ooool00ooo09Wooooo
ooooo`04ooooo`03o`3oI_oooooooooo00Oooooo00?ooiT0ooooooooV@00J_ooool00oo<o`3ooooo
ooooo`0=ooooo`03olco0?oooooooooo03;ooooo00?oc03oooooooo<0?l0;Oooool00ol0003ooooo
ooooo`01ooooo`001oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool00oooool00ooo09Woooooooooo`05ooooo`03o`3oI_oooooooooo00Sooooo
00?ooiT0ooooooooool0J_ooool2olco00gooooo00?oc?l0ooooooooool0<oooool00oo<0?oooooo
ooooo`0/ooooo`03o`000?oooooooooo007ooooo0008ooooo`;o00002?ooool5o`0000Cooooo00?o
0000ooooooooool02oooool00ol0ofKoooooooooo`1gooooo`03olco0?oooooooooo00Wooooo00?o
c?l0ooooooooool0Hoooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`0;
ooooo`03o`3oI_oooooooooo07Sooooo00?oc?l0ooooooooool01oooool00oo<o`3oooooooooo`1T
ooooo`03o`000?oooooooooo007ooooo000Kooooo`;o00002oooool00ol0ofKoooooooooo`1joooo
o`03olco0?oooooooooo00Cooooo0_o<o`1Vooooo`;o00000oooool001_ooooo00?o0000oooooooo
ool02_ooool00ol0ofKoooooooooo`1kooooo`Koc?l0JOooool00ol0003oooooooooo`01ooooo`00
6oooool00ol0003oooooooooo`0:ooooo`03o`3oI_oooooooooo0>[ooooo00?o0000ooooooooool0
0Oooool001_ooooo00?o0000ooooooooool02_ooool00ol0ofKoooooooooo`3Zooooo`03o`000?oo
oooooooo007ooooo000Kooooo`03o`000?oooooooooo00[ooooo00?o0?mVooooooooool0j_ooool0
0ol0003oooooooooo`01ooooo`006oooool2o`0000_ooooo00?o0?mVooooooooool0jOooool2o`00
00?ooooo000Kooooo`03o`000?oooooooooo00Wooooo00?o0?mVooooooooool0joooool00ol0003o
ooooooooo`01ooooo`006oooool00ol0003oooooooooo`09ooooo`03o`3oI_oooooooooo0>_ooooo
00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool02Oooool00ol0ofKooooooooo
o`3[ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Wooooo00?o0?mV
ooooooooool0joooool00ol0003oooooooooo`01ooooo`006oooool2o`0000[ooooo00?o0?mVoooo
ooooool0j_ooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Sooooo00?o0?mVoooooooo
ool0k?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`08ooooo`03o`3o
I_oooooooooo0>cooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool02?oo
ool00ol0ofKoooooooooo`3/ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooo
oooo00Sooooo00?o0?mVooooooooool0k?ooool00ol0003oooooooooo`01ooooo`006oooool2o`00
00Wooooo00?o0?mVooooooooool0joooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Oo
oooo00?o0?mVooooooooool0kOooool00ol0003oooooooooo`01ooooo`006oooool00ol0003ooooo
ooooo`07ooooo`03o`3oI_oooooooooo0>gooooo00?o0000ooooooooool00Oooool001?ooooo0ol0
0005ooooo`03o`000?oooooooooo00Oooooo00?o0?mVooooooooool0kOooool00ol0003ooooooooo
o`01ooooo`005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Oooooo00?o0?mV
ooooooooool0kOooool00ol0003oooooooooo`01ooooo`005?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Oooooo00?o0?mVooooooooool0kOooool00ol0003oooooooooo`01oooo
o`005?ooool00ol0003oooooooooo`04ooooo`;o00002?ooool00ol0ofKoooooooooo`3[ooooo`?o
00000oooool001Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`3o
I_oooooooooo0>kooooo00?o0000ooooooooool00Oooool001?ooooo0_l00006ooooo`03o`000?oo
oooooooo00Kooooo00?o0?mVooooooooool0k_ooool00ol0003oooooooooo`01ooooo`005?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o0?mVooooooooool0k_ooool0
0ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`06ooooo`03o`3oI_oooooooooo
0>kooooo00?o0000ooooooooool00Oooool001_ooooo0_l00007ooooo`03o`3oI_oooooooooo0>go
oooo0_l00003ooooo`006oooool00ol0003oooooooooo`06ooooo`03o`3oI_oooooooooo0>kooooo
00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01Oooool00ol0ofKooooooooo
o`3_ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Gooooo00?o0?mV
ooooooooool0koooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05oooo
o`03o`3oI_oooooooooo0>oooooo00?o0000ooooooooool00Oooool001_ooooo0_l00006ooooo`03
o`3oI_oooooooooo0>kooooo0_l00003ooooo`006oooool00ol0003oooooooooo`05ooooo`03o`3o
I_oooooooooo0>oooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01?oo
ool00ol0ofKoooooooooo`3`ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooo
oooo00Cooooo00?o0?mVooooooooool0l?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0
003oooooooooo`04ooooo`03o`3oI_oooooooooo0?3ooooo00?o0000ooooooooool00Oooool001_o
oooo0_l00005ooooo`03o`3oI_oooooooooo0>oooooo0_l00003ooooo`006oooool00ol0003ooooo
ooooo`04ooooo`03o`3oI_oooooooooo0?3ooooo00?o0000ooooooooool00Oooool001_ooooo00?o
0000ooooooooool00oooool00ol0ofKoooooooooo`3aooooo`03o`000?oooooooooo007ooooo000K
ooooo`03o`000?oooooooooo00?ooooo00?o0?mVooooooooool0lOooool00ol0003oooooooooo`01
ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`3oI_oooooooooo0?7ooooo00?o0000oooo
ooooool00Oooool001_ooooo00?o0000ooooooooool0moooool00ol0003oooooooooo`01ooooo`00
6oooool2o`0000Cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo00;ooooo0_l00003ooooo`006ooooooko`0000?ooooo003ooooooa[ooooo003ooooo
oa[ooooo003ooooooa[ooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-13.8823, -1.81247, \
0.419554, 0.0191334}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 11}\),
      SequenceForm[ "Dimension der Daten  ", {101, 11}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.322526 0.203509 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01726 -24 -4.5 ]
[-0.0125 .01726 0 4.5 ]
[-0.0125 .11902 -12 -4.5 ]
[-0.0125 .11902 0 4.5 ]
[-0.0125 .22077 -24 -4.5 ]
[-0.0125 .22077 0 4.5 ]
[-0.0125 .32253 -6 -4.5 ]
[-0.0125 .32253 0 4.5 ]
[-0.0125 .42428 -18 -4.5 ]
[-0.0125 .42428 0 4.5 ]
[-0.0125 .52604 -6 -4.5 ]
[-0.0125 .52604 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .28556 -5 -6 ]
[.97619 .28556 5 6 ]
[.97619 .35479 -5 -6 ]
[.97619 .35479 5 6 ]
[.97619 .31167 -5 -6 ]
[.97619 .31167 5 6 ]
[.97619 .32774 -5 -6 ]
[.97619 .32774 5 6 ]
[.97619 .31275 -5 -6 ]
[.97619 .31275 5 6 ]
[.97619 .31884 -5 -6 ]
[.97619 .31884 5 6 ]
[.97619 .34058 -5 -6 ]
[.97619 .34058 5 6 ]
[.97619 .32891 -5 -6 ]
[.97619 .32891 5 6 ]
[.97619 .42512 -5 -6 ]
[.97619 .42512 5 6 ]
[.97619 .22615 -5 -6 ]
[.97619 .22615 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01726 m
.00625 .01726 L
s
[(-1.5)] -0.0125 .01726 1 0 Mshowa
0 .11902 m
.00625 .11902 L
s
[(-1)] -0.0125 .11902 1 0 Mshowa
0 .22077 m
.00625 .22077 L
s
[(-0.5)] -0.0125 .22077 1 0 Mshowa
0 .32253 m
.00625 .32253 L
s
[(0)] -0.0125 .32253 1 0 Mshowa
0 .42428 m
.00625 .42428 L
s
[(0.5)] -0.0125 .42428 1 0 Mshowa
0 .52604 m
.00625 .52604 L
s
[(1)] -0.0125 .52604 1 0 Mshowa
.125 Mabswid
0 .03761 m
.00375 .03761 L
s
0 .05796 m
.00375 .05796 L
s
0 .07832 m
.00375 .07832 L
s
0 .09867 m
.00375 .09867 L
s
0 .13937 m
.00375 .13937 L
s
0 .15972 m
.00375 .15972 L
s
0 .18007 m
.00375 .18007 L
s
0 .20042 m
.00375 .20042 L
s
0 .24112 m
.00375 .24112 L
s
0 .26147 m
.00375 .26147 L
s
0 .28182 m
.00375 .28182 L
s
0 .30218 m
.00375 .30218 L
s
0 .34288 m
.00375 .34288 L
s
0 .36323 m
.00375 .36323 L
s
0 .38358 m
.00375 .38358 L
s
0 .40393 m
.00375 .40393 L
s
0 .44463 m
.00375 .44463 L
s
0 .46498 m
.00375 .46498 L
s
0 .48533 m
.00375 .48533 L
s
0 .50568 m
.00375 .50568 L
s
0 .54639 m
.00375 .54639 L
s
0 .56674 m
.00375 .56674 L
s
0 .58709 m
.00375 .58709 L
s
0 .60744 m
.00375 .60744 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01726 m
1 .01726 L
s
.99375 .11902 m
1 .11902 L
s
.99375 .22077 m
1 .22077 L
s
.99375 .32253 m
1 .32253 L
s
.99375 .42428 m
1 .42428 L
s
.99375 .52604 m
1 .52604 L
s
.125 Mabswid
.99625 .03761 m
1 .03761 L
s
.99625 .05796 m
1 .05796 L
s
.99625 .07832 m
1 .07832 L
s
.99625 .09867 m
1 .09867 L
s
.99625 .13937 m
1 .13937 L
s
.99625 .15972 m
1 .15972 L
s
.99625 .18007 m
1 .18007 L
s
.99625 .20042 m
1 .20042 L
s
.99625 .24112 m
1 .24112 L
s
.99625 .26147 m
1 .26147 L
s
.99625 .28182 m
1 .28182 L
s
.99625 .30218 m
1 .30218 L
s
.99625 .34288 m
1 .34288 L
s
.99625 .36323 m
1 .36323 L
s
.99625 .38358 m
1 .38358 L
s
.99625 .40393 m
1 .40393 L
s
.99625 .44463 m
1 .44463 L
s
.99625 .46498 m
1 .46498 L
s
.99625 .48533 m
1 .48533 L
s
.99625 .50568 m
1 .50568 L
s
.99625 .54639 m
1 .54639 L
s
.99625 .56674 m
1 .56674 L
s
.99625 .58709 m
1 .58709 L
s
.99625 .60744 m
1 .60744 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .28556 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .23883 m
.03333 .26372 L
.04286 .22773 L
.05238 .23183 L
.0619 .20557 L
.07143 .25846 L
.08095 .28816 L
.09048 .2798 L
.1 .33445 L
.10952 .31477 L
.11905 .39407 L
.12857 .40902 L
.1381 .42498 L
.14762 .35819 L
.15714 .38312 L
.16667 .3533 L
.17619 .33749 L
.18571 .3073 L
.19524 .29017 L
.20476 .27074 L
.21429 .25539 L
.22381 .28779 L
.23333 .26806 L
.24286 .32445 L
.25238 .31702 L
.2619 .34578 L
.27143 .29284 L
.28095 .32629 L
.29048 .33799 L
.3 .30156 L
.30952 .34296 L
.31905 .35199 L
.32857 .37036 L
.3381 .34636 L
.34762 .36465 L
.35714 .33414 L
.36667 .33922 L
.37619 .30804 L
.38571 .32877 L
.39524 .28726 L
.40476 .28972 L
.41429 .28952 L
.42381 .25769 L
.43333 .30632 L
.44286 .30133 L
.45238 .28362 L
.4619 .31766 L
.47143 .3104 L
.48095 .31592 L
.49048 .3284 L
Mistroke
.5 .32545 L
.50952 .2886 L
.51905 .30379 L
.52857 .30936 L
.5381 .29613 L
.54762 .30725 L
.55714 .32075 L
.56667 .32393 L
.57619 .331 L
.58571 .31583 L
.59524 .35798 L
.60476 .35626 L
.61429 .35554 L
.62381 .32434 L
.63333 .30024 L
.64286 .33685 L
.65238 .33458 L
.6619 .3343 L
.67143 .36695 L
.68095 .3706 L
.69048 .41403 L
.7 .39366 L
.70952 .33729 L
.71905 .33535 L
.72857 .30193 L
.7381 .27325 L
.74762 .306 L
.75714 .29447 L
.76667 .30083 L
.77619 .33054 L
.78571 .33214 L
.79524 .31765 L
.80476 .32748 L
.81429 .33274 L
.82381 .40991 L
.83333 .36496 L
.84286 .38495 L
.85238 .34752 L
.8619 .30492 L
.87143 .35457 L
.88095 .33623 L
.89048 .31242 L
.9 .27058 L
.90952 .29542 L
.91905 .29642 L
.92857 .26274 L
.9381 .2988 L
.94762 .26344 L
.95714 .2571 L
.96667 .27666 L
Mistroke
.97619 .28556 L
Mfstroke
1 0 .6 r
gsave
.97619 .35479 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43178 m
.03333 .40425 L
.04286 .36973 L
.05238 .40162 L
.0619 .31617 L
.07143 .32144 L
.08095 .3485 L
.09048 .29649 L
.1 .35423 L
.10952 .34034 L
.11905 .31942 L
.12857 .35391 L
.1381 .36632 L
.14762 .32635 L
.15714 .34114 L
.16667 .32838 L
.17619 .37979 L
.18571 .33995 L
.19524 .35238 L
.20476 .34215 L
.21429 .33284 L
.22381 .28422 L
.23333 .28889 L
.24286 .34426 L
.25238 .37906 L
.2619 .36448 L
.27143 .34107 L
.28095 .34195 L
.29048 .34436 L
.3 .35565 L
.30952 .38244 L
.31905 .40571 L
.32857 .38889 L
.3381 .40071 L
.34762 .40607 L
.35714 .41087 L
.36667 .36981 L
.37619 .3676 L
.38571 .36539 L
.39524 .3179 L
.40476 .26948 L
.41429 .28249 L
.42381 .30692 L
.43333 .28727 L
.44286 .29904 L
.45238 .3509 L
.4619 .32971 L
.47143 .29275 L
.48095 .31086 L
.49048 .34757 L
Mistroke
.5 .31301 L
.50952 .28387 L
.51905 .29097 L
.52857 .25241 L
.5381 .30577 L
.54762 .31057 L
.55714 .27785 L
.56667 .27439 L
.57619 .28627 L
.58571 .32429 L
.59524 .32576 L
.60476 .38332 L
.61429 .36436 L
.62381 .34986 L
.63333 .33873 L
.64286 .33498 L
.65238 .3324 L
.6619 .33901 L
.67143 .37212 L
.68095 .307 L
.69048 .34858 L
.7 .34337 L
.70952 .328 L
.71905 .31523 L
.72857 .29368 L
.7381 .2649 L
.74762 .22569 L
.75714 .28227 L
.76667 .26114 L
.77619 .28408 L
.78571 .35258 L
.79524 .3183 L
.80476 .34208 L
.81429 .27893 L
.82381 .26788 L
.83333 .3249 L
.84286 .27542 L
.85238 .28588 L
.8619 .328 L
.87143 .31012 L
.88095 .32386 L
.89048 .36817 L
.9 .32631 L
.90952 .31833 L
.91905 .30066 L
.92857 .29021 L
.9381 .31337 L
.94762 .29315 L
.95714 .3017 L
.96667 .30343 L
Mistroke
.97619 .35479 L
Mfstroke
.8 0 1 r
gsave
.97619 .31167 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31129 m
.03333 .31597 L
.04286 .29283 L
.05238 .32605 L
.0619 .35377 L
.07143 .33799 L
.08095 .36639 L
.09048 .33695 L
.1 .38152 L
.10952 .37566 L
.11905 .41169 L
.12857 .37077 L
.1381 .35656 L
.14762 .33201 L
.15714 .33506 L
.16667 .33415 L
.17619 .34065 L
.18571 .32309 L
.19524 .34784 L
.20476 .34033 L
.21429 .37851 L
.22381 .3548 L
.23333 .3691 L
.24286 .32042 L
.25238 .36206 L
.2619 .38864 L
.27143 .43454 L
.28095 .44494 L
.29048 .41309 L
.3 .43956 L
.30952 .40402 L
.31905 .35662 L
.32857 .36845 L
.3381 .32679 L
.34762 .30575 L
.35714 .33956 L
.36667 .34124 L
.37619 .33371 L
.38571 .31031 L
.39524 .28249 L
.40476 .26763 L
.41429 .28386 L
.42381 .3263 L
.43333 .34782 L
.44286 .35249 L
.45238 .3221 L
.4619 .34355 L
.47143 .34302 L
.48095 .38686 L
.49048 .34689 L
Mistroke
.5 .39013 L
.50952 .40573 L
.51905 .37099 L
.52857 .40568 L
.5381 .43697 L
.54762 .36457 L
.55714 .38622 L
.56667 .36513 L
.57619 .36155 L
.58571 .33128 L
.59524 .29773 L
.60476 .35865 L
.61429 .34879 L
.62381 .33748 L
.63333 .31459 L
.64286 .35293 L
.65238 .3529 L
.6619 .36968 L
.67143 .32325 L
.68095 .36466 L
.69048 .34857 L
.7 .32894 L
.70952 .36348 L
.71905 .31444 L
.72857 .36512 L
.7381 .31238 L
.74762 .3047 L
.75714 .28308 L
.76667 .33455 L
.77619 .3419 L
.78571 .35011 L
.79524 .38583 L
.80476 .40375 L
.81429 .4252 L
.82381 .41642 L
.83333 .42823 L
.84286 .41616 L
.85238 .34846 L
.8619 .29512 L
.87143 .29393 L
.88095 .30296 L
.89048 .27883 L
.9 .25153 L
.90952 .29295 L
.91905 .26498 L
.92857 .27117 L
.9381 .31839 L
.94762 .31804 L
.95714 .36023 L
.96667 .3183 L
Mistroke
.97619 .31167 L
Mfstroke
.2 0 1 r
gsave
.97619 .32774 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22989 m
.03333 .20009 L
.04286 .21282 L
.05238 .21467 L
.0619 .23483 L
.07143 .27816 L
.08095 .27333 L
.09048 .30179 L
.1 .31561 L
.10952 .376 L
.11905 .3776 L
.12857 .33316 L
.1381 .35236 L
.14762 .41324 L
.15714 .37268 L
.16667 .38818 L
.17619 .34541 L
.18571 .34371 L
.19524 .26491 L
.20476 .29771 L
.21429 .33203 L
.22381 .32233 L
.23333 .37933 L
.24286 .39047 L
.25238 .388 L
.2619 .40089 L
.27143 .3498 L
.28095 .37808 L
.29048 .42603 L
.3 .3968 L
.30952 .38599 L
.31905 .34259 L
.32857 .37435 L
.3381 .33999 L
.34762 .28361 L
.35714 .287 L
.36667 .30816 L
.37619 .27178 L
.38571 .29139 L
.39524 .28285 L
.40476 .29673 L
.41429 .33944 L
.42381 .31471 L
.43333 .33329 L
.44286 .33553 L
.45238 .36664 L
.4619 .36552 L
.47143 .36933 L
.48095 .39878 L
.49048 .41718 L
Mistroke
.5 .37314 L
.50952 .34091 L
.51905 .325 L
.52857 .30897 L
.5381 .28353 L
.54762 .32362 L
.55714 .25375 L
.56667 .29664 L
.57619 .29103 L
.58571 .31905 L
.59524 .34728 L
.60476 .32417 L
.61429 .36338 L
.62381 .35641 L
.63333 .41149 L
.64286 .39351 L
.65238 .37637 L
.6619 .38802 L
.67143 .32494 L
.68095 .33431 L
.69048 .28863 L
.7 .2961 L
.70952 .27686 L
.71905 .2937 L
.72857 .30169 L
.7381 .3188 L
.74762 .35101 L
.75714 .33633 L
.76667 .36842 L
.77619 .39444 L
.78571 .35065 L
.79524 .39056 L
.80476 .32442 L
.81429 .31512 L
.82381 .34525 L
.83333 .30601 L
.84286 .31877 L
.85238 .31829 L
.8619 .31593 L
.87143 .38715 L
.88095 .33839 L
.89048 .37218 L
.9 .3821 L
.90952 .3581 L
.91905 .40627 L
.92857 .37312 L
.9381 .39046 L
.94762 .40532 L
.95714 .33016 L
.96667 .37159 L
Mistroke
.97619 .32774 L
Mfstroke
0 .4 1 r
gsave
.97619 .31275 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39716 m
.03333 .40075 L
.04286 .42132 L
.05238 .39649 L
.0619 .39723 L
.07143 .34638 L
.08095 .35309 L
.09048 .33189 L
.1 .28877 L
.10952 .33778 L
.11905 .35793 L
.12857 .34197 L
.1381 .32471 L
.14762 .37377 L
.15714 .4066 L
.16667 .39758 L
.17619 .37725 L
.18571 .36922 L
.19524 .41451 L
.20476 .4008 L
.21429 .37875 L
.22381 .35699 L
.23333 .34267 L
.24286 .3418 L
.25238 .34233 L
.2619 .30849 L
.27143 .30957 L
.28095 .30442 L
.29048 .29835 L
.3 .30803 L
.30952 .2734 L
.31905 .31174 L
.32857 .36525 L
.3381 .35582 L
.34762 .36549 L
.35714 .37679 L
.36667 .39603 L
.37619 .4217 L
.38571 .37779 L
.39524 .38009 L
.40476 .44056 L
.41429 .39538 L
.42381 .40341 L
.43333 .37638 L
.44286 .38492 L
.45238 .35987 L
.4619 .29815 L
.47143 .28283 L
.48095 .33223 L
.49048 .30034 L
Mistroke
.5 .31413 L
.50952 .327 L
.51905 .2984 L
.52857 .23721 L
.5381 .283 L
.54762 .3095 L
.55714 .28804 L
.56667 .29404 L
.57619 .28944 L
.58571 .31576 L
.59524 .25574 L
.60476 .25533 L
.61429 .28965 L
.62381 .28743 L
.63333 .2964 L
.64286 .30158 L
.65238 .30796 L
.6619 .33367 L
.67143 .36814 L
.68095 .32742 L
.69048 .36712 L
.7 .35878 L
.70952 .33667 L
.71905 .33766 L
.72857 .34112 L
.7381 .33357 L
.74762 .3418 L
.75714 .35283 L
.76667 .4002 L
.77619 .38384 L
.78571 .39126 L
.79524 .39768 L
.80476 .37003 L
.81429 .35226 L
.82381 .33468 L
.83333 .30613 L
.84286 .34957 L
.85238 .38201 L
.8619 .34484 L
.87143 .35435 L
.88095 .35275 L
.89048 .3241 L
.9 .27722 L
.90952 .24997 L
.91905 .29515 L
.92857 .30444 L
.9381 .29223 L
.94762 .30661 L
.95714 .32041 L
.96667 .37029 L
Mistroke
.97619 .31275 L
Mfstroke
0 1 1 r
gsave
.97619 .31884 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29713 m
.03333 .28168 L
.04286 .25596 L
.05238 .25336 L
.0619 .22267 L
.07143 .26526 L
.08095 .29398 L
.09048 .31919 L
.1 .36806 L
.10952 .33129 L
.11905 .33014 L
.12857 .32703 L
.1381 .3645 L
.14762 .3352 L
.15714 .33082 L
.16667 .29064 L
.17619 .31222 L
.18571 .34641 L
.19524 .3228 L
.20476 .29521 L
.21429 .2917 L
.22381 .32774 L
.23333 .32785 L
.24286 .35115 L
.25238 .38276 L
.2619 .40617 L
.27143 .38337 L
.28095 .40043 L
.29048 .3413 L
.3 .30721 L
.30952 .28547 L
.31905 .27897 L
.32857 .30418 L
.3381 .30082 L
.34762 .2763 L
.35714 .29787 L
.36667 .34536 L
.37619 .36067 L
.38571 .34461 L
.39524 .30381 L
.40476 .31016 L
.41429 .32673 L
.42381 .31238 L
.43333 .34883 L
.44286 .3486 L
.45238 .36669 L
.4619 .34026 L
.47143 .33055 L
.48095 .3695 L
.49048 .35869 L
Mistroke
.5 .32579 L
.50952 .34156 L
.51905 .30404 L
.52857 .34505 L
.5381 .30284 L
.54762 .35027 L
.55714 .3353 L
.56667 .30175 L
.57619 .33154 L
.58571 .30743 L
.59524 .29356 L
.60476 .30288 L
.61429 .27346 L
.62381 .29206 L
.63333 .31991 L
.64286 .332 L
.65238 .34945 L
.6619 .31816 L
.67143 .38059 L
.68095 .41081 L
.69048 .42861 L
.7 .38083 L
.70952 .36998 L
.71905 .36912 L
.72857 .30421 L
.7381 .28829 L
.74762 .32869 L
.75714 .30802 L
.76667 .29449 L
.77619 .32426 L
.78571 .34361 L
.79524 .30373 L
.80476 .27175 L
.81429 .30287 L
.82381 .23018 L
.83333 .24504 L
.84286 .2724 L
.85238 .23404 L
.8619 .2464 L
.87143 .22066 L
.88095 .26116 L
.89048 .27103 L
.9 .32053 L
.90952 .30406 L
.91905 .27484 L
.92857 .31432 L
.9381 .26409 L
.94762 .27124 L
.95714 .28129 L
.96667 .30024 L
Mistroke
.97619 .31884 L
Mfstroke
0 1 .4 r
gsave
.97619 .34058 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.03333 .53768 L
.04286 .54674 L
.05238 .43084 L
.0619 .40593 L
.07143 .37557 L
.08095 .34043 L
.09048 .3011 L
.1 .31413 L
.10952 .28899 L
.11905 .31398 L
.12857 .30945 L
.1381 .34889 L
.14762 .37455 L
.15714 .38677 L
.16667 .33966 L
.17619 .33886 L
.18571 .37027 L
.19524 .36993 L
.20476 .32618 L
.21429 .35035 L
.22381 .3372 L
.23333 .38246 L
.24286 .36037 L
.25238 .36885 L
.2619 .32904 L
.27143 .27287 L
.28095 .24178 L
.29048 .25688 L
.3 .29537 L
.30952 .26309 L
.31905 .32685 L
.32857 .34413 L
.3381 .35298 L
.34762 .39427 L
.35714 .39542 L
.36667 .39807 L
.37619 .33283 L
.38571 .36527 L
.39524 .32529 L
.40476 .30113 L
.41429 .29456 L
.42381 .2608 L
.43333 .26602 L
.44286 .24662 L
.45238 .31272 L
.4619 .35665 L
.47143 .33386 L
.48095 .38027 L
.49048 .43377 L
Mistroke
.5 .42764 L
.50952 .38491 L
.51905 .36715 L
.52857 .39539 L
.5381 .39396 L
.54762 .35213 L
.55714 .34819 L
.56667 .32766 L
.57619 .36432 L
.58571 .28913 L
.59524 .32513 L
.60476 .3338 L
.61429 .3626 L
.62381 .35475 L
.63333 .33342 L
.64286 .38353 L
.65238 .34525 L
.6619 .32435 L
.67143 .34669 L
.68095 .28977 L
.69048 .30195 L
.7 .30175 L
.70952 .2775 L
.71905 .31976 L
.72857 .26998 L
.7381 .28807 L
.74762 .30961 L
.75714 .32596 L
.76667 .30059 L
.77619 .30893 L
.78571 .32033 L
.79524 .34032 L
.80476 .34893 L
.81429 .37007 L
.82381 .31771 L
.83333 .32975 L
.84286 .3165 L
.85238 .32069 L
.8619 .3259 L
.87143 .33642 L
.88095 .39295 L
.89048 .3614 L
.9 .37643 L
.90952 .36387 L
.91905 .41292 L
.92857 .35869 L
.9381 .35978 L
.94762 .34318 L
.95714 .33299 L
.96667 .31298 L
Mistroke
.97619 .34058 L
Mfstroke
.2 1 0 r
gsave
.97619 .32891 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .18975 m
.03333 .17742 L
.04286 .2098 L
.05238 .22652 L
.0619 .30245 L
.07143 .36512 L
.08095 .3794 L
.09048 .37705 L
.1 .40922 L
.10952 .39977 L
.11905 .40181 L
.12857 .38096 L
.1381 .38495 L
.14762 .39973 L
.15714 .41603 L
.16667 .38878 L
.17619 .34598 L
.18571 .33517 L
.19524 .34303 L
.20476 .33482 L
.21429 .31871 L
.22381 .33547 L
.23333 .2894 L
.24286 .31319 L
.25238 .33692 L
.2619 .34307 L
.27143 .28559 L
.28095 .3014 L
.29048 .33338 L
.3 .31134 L
.30952 .35814 L
.31905 .36346 L
.32857 .33249 L
.3381 .31918 L
.34762 .29553 L
.35714 .35535 L
.36667 .36905 L
.37619 .36549 L
.38571 .3376 L
.39524 .35381 L
.40476 .34839 L
.41429 .33124 L
.42381 .2977 L
.43333 .33716 L
.44286 .28541 L
.45238 .31184 L
.4619 .29124 L
.47143 .33076 L
.48095 .38103 L
.49048 .35291 L
Mistroke
.5 .39017 L
.50952 .37169 L
.51905 .43102 L
.52857 .38115 L
.5381 .4302 L
.54762 .40927 L
.55714 .42547 L
.56667 .39122 L
.57619 .34634 L
.58571 .29127 L
.59524 .28514 L
.60476 .26935 L
.61429 .25903 L
.62381 .26719 L
.63333 .24445 L
.64286 .28046 L
.65238 .33493 L
.6619 .32726 L
.67143 .37133 L
.68095 .39903 L
.69048 .36169 L
.7 .41989 L
.70952 .35203 L
.71905 .34227 L
.72857 .36679 L
.7381 .35495 L
.74762 .34428 L
.75714 .34395 L
.76667 .32955 L
.77619 .31153 L
.78571 .32581 L
.79524 .27814 L
.80476 .25092 L
.81429 .25789 L
.82381 .28325 L
.83333 .24554 L
.84286 .28627 L
.85238 .22507 L
.8619 .25027 L
.87143 .26911 L
.88095 .25727 L
.89048 .28587 L
.9 .26461 L
.90952 .29271 L
.91905 .27866 L
.92857 .27871 L
.9381 .32335 L
.94762 .32857 L
.95714 .35302 L
.96667 .31364 L
Mistroke
.97619 .32891 L
Mfstroke
.8 1 0 r
gsave
.97619 .42512 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25972 m
.03333 .2029 L
.04286 .21086 L
.05238 .25292 L
.0619 .25538 L
.07143 .25669 L
.08095 .30444 L
.09048 .28483 L
.1 .3073 L
.10952 .31615 L
.11905 .37839 L
.12857 .38518 L
.1381 .35757 L
.14762 .34942 L
.15714 .39924 L
.16667 .41827 L
.17619 .35729 L
.18571 .36765 L
.19524 .375 L
.20476 .34488 L
.21429 .32477 L
.22381 .3266 L
.23333 .33889 L
.24286 .31101 L
.25238 .34645 L
.2619 .34009 L
.27143 .35031 L
.28095 .36004 L
.29048 .31701 L
.3 .36186 L
.30952 .31315 L
.31905 .32827 L
.32857 .32637 L
.3381 .28198 L
.34762 .3488 L
.35714 .32477 L
.36667 .40752 L
.37619 .37121 L
.38571 .40893 L
.39524 .38952 L
.40476 .40117 L
.41429 .33923 L
.42381 .35844 L
.43333 .35437 L
.44286 .33662 L
.45238 .28268 L
.4619 .27048 L
.47143 .27212 L
.48095 .30535 L
.49048 .27524 L
Mistroke
.5 .3295 L
.50952 .35373 L
.51905 .37437 L
.52857 .41592 L
.5381 .41708 L
.54762 .47167 L
.55714 .45063 L
.56667 .44029 L
.57619 .47853 L
.58571 .44511 L
.59524 .45839 L
.60476 .3931 L
.61429 .37549 L
.62381 .35155 L
.63333 .31749 L
.64286 .38012 L
.65238 .36575 L
.6619 .31257 L
.67143 .34608 L
.68095 .35331 L
.69048 .36634 L
.7 .33064 L
.70952 .36877 L
.71905 .33084 L
.72857 .34641 L
.7381 .38775 L
.74762 .37263 L
.75714 .37803 L
.76667 .35316 L
.77619 .32719 L
.78571 .35585 L
.79524 .31684 L
.80476 .29762 L
.81429 .34347 L
.82381 .35997 L
.83333 .34902 L
.84286 .33191 L
.85238 .39528 L
.8619 .39803 L
.87143 .39067 L
.88095 .36362 L
.89048 .32437 L
.9 .3369 L
.90952 .32691 L
.91905 .32103 L
.92857 .32547 L
.9381 .31404 L
.94762 .32339 L
.95714 .38576 L
.96667 .39385 L
Mistroke
.97619 .42512 L
Mfstroke
1 .6 0 r
gsave
.97619 .22615 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.03333 .06344 L
.04286 .14398 L
.05238 .19256 L
.0619 .22838 L
.07143 .26593 L
.08095 .3681 L
.09048 .37842 L
.1 .42084 L
.10952 .43986 L
.11905 .40714 L
.12857 .43478 L
.1381 .36811 L
.14762 .34278 L
.15714 .37708 L
.16667 .34463 L
.17619 .33963 L
.18571 .33343 L
.19524 .28449 L
.20476 .28997 L
.21429 .2934 L
.22381 .28748 L
.23333 .30922 L
.24286 .30575 L
.25238 .3214 L
.2619 .32071 L
.27143 .35065 L
.28095 .37105 L
.29048 .35784 L
.3 .29847 L
.30952 .25611 L
.31905 .26745 L
.32857 .30095 L
.3381 .29146 L
.34762 .28468 L
.35714 .28207 L
.36667 .27919 L
.37619 .2981 L
.38571 .31815 L
.39524 .29071 L
.40476 .3369 L
.41429 .34456 L
.42381 .33092 L
.43333 .34285 L
.44286 .33665 L
.45238 .36853 L
.4619 .36067 L
.47143 .35724 L
.48095 .37019 L
.49048 .38751 L
Mistroke
.5 .36805 L
.50952 .37475 L
.51905 .35903 L
.52857 .3572 L
.5381 .34373 L
.54762 .36871 L
.55714 .34419 L
.56667 .35186 L
.57619 .33545 L
.58571 .35055 L
.59524 .37014 L
.60476 .34766 L
.61429 .41891 L
.62381 .42732 L
.63333 .3989 L
.64286 .39266 L
.65238 .38783 L
.6619 .39723 L
.67143 .40274 L
.68095 .36089 L
.69048 .31523 L
.7 .33407 L
.70952 .31099 L
.71905 .27259 L
.72857 .2768 L
.7381 .24522 L
.74762 .29563 L
.75714 .30942 L
.76667 .3088 L
.77619 .33514 L
.78571 .31492 L
.79524 .35705 L
.80476 .33331 L
.81429 .3586 L
.82381 .32609 L
.83333 .38566 L
.84286 .41259 L
.85238 .42266 L
.8619 .39897 L
.87143 .38991 L
.88095 .32057 L
.89048 .32696 L
.9 .31617 L
.90952 .31187 L
.91905 .32224 L
.92857 .29067 L
.9381 .31808 L
.94762 .26471 L
.95714 .28473 L
.96667 .27093 L
Mistroke
.97619 .22615 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`008?ooool2o`0002Sooooo1Ol0
0003ooooo`;o0000:?ooool3o`0000?ooooo0_l0000Wooooo`?o00001?ooool2o`0002Kooooo0ol0
0004ooooo`;o00009?ooool3o`0000Cooooo0_l00004ooooo`;o00000oooool001oooooo00Co0000
oooooooooooo0000:?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0002So
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo02?ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0002Cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0002Cooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo000Oooooo`04o`000?oooooooooo
o`0002Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Uooooo`Go00000_oo
ool01?l0003oooooooooool0000Uooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool0000Tooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
000Tooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`007oooool01?l0003oooooooooool0000Zooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`0Sooooo`04o`000?ooooooooooo`0000?ooooo00Co0000
oooooooooooo00009Oooool4o`0000?ooooo00Co0000oooooooooooo00009Oooool3o`0000?ooooo
00Co0000oooooooooooo00009?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool001oooooo00Co0000oooooooooooo00009oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00009_ooool00ol0003ooooo
o`000003ooooo`04o`000?ooooooooooo`0002Gooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000Tooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
000Tooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`007oooool01?l0003oooooooooool0000Wooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool0000Wooooo`;o00000oooool01?l0003oooooooooool0
000Vooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00009?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00008oooool2o`0000Cooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`008?ooool2o`0002Wooooo0ol00004
ooooo`;o0000:Oooool00ol0003oooooooooo`02ooooo`;o0000:?ooool2o`0000Cooooo0_l0000V
ooooo`?o00001?ooool2o`0002Gooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`006ooooook
o`0000?ooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00Oooool000Oo
oooo0ol00004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo0?Oo
oooo00?o0000ooooooooool00Oooool000Sooooo00?o0000ooooooooool01oooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooooooool00oooool00oooV@3oooooooooo`3aooooo`03
o`000?oooooooooo007ooooo0005o`0000?ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`02ooooo`;o00001?ooool00oooV@3oooooooooo`3_ooooo`?o00000oooool000Sooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o
oiT0ooooooooool0lOooool00ol0003oooooooooo`01ooooo`002?ooool00ol0003oooooooooo`07
ooooo`Co00001Oooool00ol0003oooooooooo`03ooooo`03oonI0?oooooooooo0?7ooooo00?o0000
ooooooooool00Oooool000Oooooo0_l00009ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01?ooool00oooV@3oooooooooo`3`ooooo`03o`000?oooooooooo007ooooo0008ooooo`03
o`000?oooooooooo00Oooooo1Ol00004ooooo`03o`000?oooooooooo00Cooooo00?ooiT0oooooooo
ool0l?ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Gooooo00?ooiT0ooooooooool0
koooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Cooooo00?ooiT0ooooooooool0l?oo
ool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`04ooooo`03oonI0?oooooo
oooo0?3ooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01?ooool00ooo
V@3oooooooooo`3`ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Co
oooo00?ooiT0ooooooooool0l?ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Kooooo
00?ooiT0ooooooooool0k_ooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Gooooo00?o
oiT0ooooooooool0koooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05
ooooo`03oonI0?oooooooooo0>oooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000oooo
ooooool01Oooool00oooV@3oooooooooo`3_ooooo`03o`000?oooooooooo007ooooo000Kooooo`03
o`000?oooooooooo00Gooooo00?ooiT0ooooooooool0koooool00ol0003oooooooooo`01ooooo`00
6oooool2o`0000Kooooo00?ooiT0ooooooooool0k_ooool2o`0000?ooooo000Kooooo`03o`000?oo
oooooooo00Gooooo00?ooiT0ooooooooool0koooool00ol0003oooooooooo`01ooooo`006oooool0
0ol0003oooooooooo`05ooooo`03oonI0?oooooooooo0>oooooo00?o0000ooooooooool00Oooool0
01_ooooo00?o0000ooooooooool01_ooool00oooV@3oooooooooo`3^ooooo`03o`000?oooooooooo
007ooooo000Kooooo`03o`000?oooooooooo00Kooooo00?ooiT0ooooooooool0k_ooool00ol0003o
ooooooooo`01ooooo`006oooool2o`0000Oooooo00?ooiT0ooooooooool0kOooool2o`0000?ooooo
000Kooooo`03o`000?oooooooooo00Kooooo00?ooiT0ooooooooool0k_ooool00ol0003ooooooooo
o`01ooooo`006oooool00ol0003oooooooooo`06ooooo`03oonI0?oooooooooo0>kooooo00?o0000
ooooooooool00Oooool001?ooooo0ol00005ooooo`03o`000?oooooooooo00Kooooo00?ooiT0oooo
ooooool0k_ooool00ol0003oooooooooo`01ooooo`005?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Kooooo00?ooiT0ooooooooool0k_ooool00ol0003oooooooooo`01ooooo`00
3?ooool5o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03oonI
0?oooooooooo0>kooooo00?o0000ooooooooool00Oooool001Cooooo00?o0000ooooooooool01?oo
ool2o`0000Oooooo00?ooiT0ooooooooool0k?ooool3o`0000?ooooo000Dooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01_ooool00oooV@3oooooooooo`3^ooooo`03o`000?oooooo
oooo007ooooo000Cooooo`;o00001_ooool00ol0003oooooooooo`07ooooo`03oonI0?oooooooooo
0>gooooo00?o0000ooooooooool00Oooool001Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`07ooooo`03oonI0?oooooooooo0>gooooo00?o0000ooooooooool00Oooool001_ooooo
00?o0000ooooooooool01oooool00oooV@3oooooooooo`3]ooooo`03o`000?oooooooooo007ooooo
000Kooooo`;o00002?ooool00oooV@3oooooooooo`3/ooooo`;o00000oooool001_ooooo00?o0000
ooooooooool01oooool00oooV@3oooooooooo`3]ooooo`03o`000?oooooooooo007ooooo000Koooo
o`03o`000?oooooooooo00Oooooo00?ooiT0ooooooooool0kOooool00ol0003oooooooooo`01oooo
o`006oooool00ol0003oooooooooo`07ooooo`03oonI0?oooooooooo0>gooooo00?o0000oooooooo
ool00Oooool001_ooooo00?o0000ooooooooool02?ooool00oooV@3oooooooooo`3/ooooo`03o`00
0?oooooooooo007ooooo000Kooooo`;o00002Oooool00oooV@3oooooooooo`3[ooooo`;o00000ooo
ool001_ooooo00?o0000ooooooooool02?ooool00oooV@3oooooooooo`3/ooooo`03o`000?oooooo
oooo007ooooo000Kooooo`03o`000?oooooooooo00Sooooo00?ooiT0ooooooooool0k?ooool00ol0
003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`09ooooo`03oonI0?oooooooooo0>_o
oooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01Oooool01Olco`3ooooo
oooooooooooooiT00>gooooo00?o0000ooooooooool00Oooool001_ooooo0_l00006ooooo`05oc?o
0?ooooooooooooooooooV@00k?ooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Cooooo
0_lco`03ooooo`03oonI0?oooooooooo0>_ooooo00?o0000ooooooooool00Oooool001_ooooo00?o
0000ooooooooool00oooool01?lco`3ooooooooooolco`03ooooo`03oonI0?oooooooooo0>[ooooo
00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01_ooool01Olco`3ooooooooo
oooooooooiT00>cooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01_oo
ool01Olco`3ooooooooooooooooooiT00>cooooo00?o0000ooooooooool00Oooool001_ooooo0_l0
0006ooooo`03oc<0oolco`3ooooo00;ooooo00?ooiT0ooooooooool0jOooool2o`0000?ooooo000K
ooooo`03o`000?oooooooooo00Gooooo00?oc?l0oooooolco`000oooool00oooV@3oo`00ooooo`3Y
ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Gooooo0_o<o`001_lc
o`3ooooooooooooooooooiT0ool00>[ooooo00?o0000ooooooooool00Oooool000Sooooo0_l00004
ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo00Cooooo00Co<`3o
olco0?ooooooc?l00_lc0?l00ooooooooiT0ool0003Zooooo`03o`000?oooooooooo007ooooo0007
ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo00Cooooo00[o<`3oolco0?ooooooc?l0oc?o0?oooooo<`3ooonI0?ooooooo`00jOoo
ool00ol0003oooooooooo`01ooooo`001Ol00002ooooo`04o`000?ooooooooooo`0000_ooooo00?o
0000ooooooooool00_ooool2o`0000Gooooo00[oc?l0ooooooooooooc?l0oooooolco`3o<`3ooonI
0?ooooooo`00bOooool00ol0ooooooooooooo`0Kooooo`?o00000oooool000Oooooo00Co0000oooo
oooooooo00002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o<`3o
olco0?ooool00_ooool01_o<o`3ooooooc?o0?lc0?oooiT0ool00:[ooooo00?oo`2Iooooooooool0
5oooool00olco`3oooooooooo`02ooooo`03o`3ooooooooooooo01Oooooo00?ooiT0ooooooooool0
0oooool00ol0003oooooooooo`01ooooo`001oooool01?l0003oooooooooool00007ooooo`Co0000
1Oooool00ol0003oooooooooo`03ooooo`0;oc<0ooo<o`3ooooooooooooo003oc?l0ool00?lco`3o
<`3ooonI0?oo0000Z_ooool00ooo09Woooooooooo`0@ooooo`03o`3ooooooooooooo00Cooooo00Co
<ol0oooooooooooooooo0_l0oolIooooo`03oonI0?oooooooooo00?ooooo00?o0000ooooooooool0
0Oooool000Oooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Cooooo00_oc?l0ooooooooooooo`00olco0?oooooo<ol0oc<0ooooV@3oooooool0
002Yooooo`03ool0VOoooooooooo013ooooo00?o0?ooooooooooool01?ooool2oc?o00;ooooo00?o
0?ooooooool0ool06?ooool00oooV@3oooooooooo`03ooooo`03o`000?oooooooooo007ooooo0008
ooooo`;o00002?ooool5o`0000Cooooo00?o0000ooooooooool01?ooool02oo<o`3ooooooooooooo
003oooooolco0?lco`3o0?oooc<0ooooV@3oo`0007;ooooo00?o06Koooooooooool0<oooool2ool0
VA;ooooo0_l0ool5ooooo`;o<ol000Goooooo`3oooooooooooooo`3oo`0Hooooo`03oonI0?oooooo
oooo00?ooooo00?o0000ooooooooool00Oooool001_ooooo0_l00004ooooo`04ool00?o<o`3ooooo
ool000;ooooo00Koc?l0oc?o0?l0oooo<`3ooonI0?oo000dooooo`03o`3oI_oooooooooo03_ooooo
00?o06Koooooooooool0<oooool00ooo09Woooooool0V@0Aooooo`;o0?oo1Oooool2oc?o0005oooo
ool0ooooooooooooool0ool05oooool00oooV@3oooooooooo`03ooooo`;o00000oooool001_ooooo
00?o0000ooooooooool00oooool01?oo003oc?l0oooooooo0002ooooo`06olco0?lco`3o0?oooc<0
ooooV@3oo`00=?ooool00ol0ofKoooooooooo`0kooooo`03o`1Voooooooooooo01Oooooo00?o<ol0
ooooooooool05oooool01OooV@3oooooool0VOooooooo`2I013ooooo00Co0?oooooooooooooo<ol0
0oooool01?lco`3ooooooooooolco`03ooooo`03o`3ooooooooooooo01Gooooo00?ooiT0oooooooo
ool01?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`03ooooo`04olco
0?oo003oooooool000?ooooo00Goc?l0oc?o0?oooooo<`3ooonI000dooooo`;o0?mV9_ooool00ol0
ofKoooooooooo`0Cooooo`03o`1Voooooooooooo01Oooooo00?o<ol0ooooooooool05oooool01Ooo
V@3oo`2Iooooooooooooo`2I013ooooo00Co0?oooooooooooooo<ol00oooool01?lco`3ooooooooo
oolco`03ooooo`03o`3ooooooooooooo00Gooooo00?o06Koooooooooool03Oooool00oooV@3ooooo
ooooo`04ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00?ooooo00Co
c?l0ool00?ooooooo`000_ooool01ol0ooooc?l0olco0?oooooo<`3ooonI0?oo0000<_ooool00ol0
ofKoooooo`3oIP0Vooooo`03o`3oI_oooooooooo01?ooooo0_l0I_l5ooooo`03oc<0oooooooooooo
00oooooo00?o<ol0oooooolco`006?ooool01OooV@3oo`2Iooooooooooooo`2I00cooooo0_lco`02
ooooo`05o`3ooooooooooooooc?o0?l0ool00_ooool01?lco`3ooooooooooolco`04ooooo`03o`3o
oooooooooooo00;ooooo00?oc03oooooool0I_l03oooool00oooV@3oooooooooo`04ooooo`03o`00
0?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00?ooooo00Coc?l0ool00?ooooooo`00
0_l0ool2ooooo`05oc?o0?o<o`3oc?l0oonI0?o<o`008_ooool00ooo003oooooooooo`0=ooooo`04
o`3oI_ooooooooooo`3oIPCooooo00?ooiT0ooooooooool06_ooool00ooo003oooooooooo`02o`3o
IQCooooo00?o06Koool0VOl0I_l01Oooool00olc0?ooooooooooo`07ooooo`?o06Ko1Oooool00olc
o`3ooooooc?o000Gooooo`03oonI0?oooooooiT000;ooooo00?oo`2Iooooooooool02_ooool02Olc
o`3ooooooc?o0?oooooo0?oooooooolco`3ooooooc?o0002ooooo`05oc?o0?oooooooooooooooolc
o`000oooool00olco`3oooooooooo`02ooooo`03ol`0oooooooo06Ko00_ooooo00Goo`00oooooooo
oooooooooonI0006ooooo`03o`000?oooooooooo007ooooo000Kooooo`;o00001?ooool01Oo<o`3o
ooooool00?oooooo0?oo00?ooooo00Go<ol0oooooooooooo<`3ooonI000Rooooo`03ool00?oooooo
oooo00gooooo00Co0?mVoooooooooooo0?mV1?ooool00oooV@3oooooooooo`0Jooooo`;o0?mV00?o
ooooo`3oI_l0ofH05?ooool00ol0I_ooo`2Io`1Vo`05ooooo`03oc<0oooooooooooo00Oooooo00Co
06Koooooool0I_oooooo0_lco`02ooooo`03oc?o0?oooooo<ol001Oooooo00?ooiT0ool0VOooV@00
0_ooool01Ooo09Woooooooooooooooooo`2I00Oooooo00go<ol0oooooooooooo<ol0ooooool0oooo
oooooc?o0?oooooo<ol0o`3ooooooooo<ol000Cooooo00Co<ol0oooooooooooo<ol00oooool2ol`0
o`03o`1Voooooooo06Ko00Wooooo0_oo0003ooooo`03oonI0?oooooooooo00?ooooo0_l00003oooo
o`006oooool00ol0003oooooooooo`05ooooo`03ool00?l0oooooooo00?ooooo00Go<ol0oooooooo
oooo<`3ooonI000Mooooo`07oc<0oooooooooooooooooooo003oooooool0000>ooooo`04o`3oI_oo
ooooooooo`3oIPCooooo0_ooV@0Jooooo`04ool00?l0ofKoooooo`3oIP;ooooo00?o0?mVoooooooo
ool04Oooool00ol0I_ooo`2Io`1Vo`05ooooo`03oc<0oooooooooooo00Oooooo00Co06Koooooool0
I_oo<ol00_ooool2oc?o00?ooooo00?o<ol0ooooooooool05?ooool00oooV@3oo`2IoonI0002oooo
o`05ool0VOoooooooooooooooooo09T01oooool02_lco`3ooooooooooooooooo<ol0o`3ooooooooo
<ol0oooooolco`02o`3oo`03oc?o0?oooooooooo00;ooooo00Co<ol0oooooolco`3o<ol00oooool0
2_o<0?oo<ol0o`1Voooooooo06Koooooooo<0?ooooooool00?ooool2o`3oo`07ooooooooV@3ooooo
oooooooo003ooooooonI0007ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooo
oooo00Kooooo00?o0?ooooooooooool00_ooool01_lco`3ooooooooooolc0?oooiT0ool001cooooo
00Oo<`3oooooooooooooooooool00?ooooooo`0000?ooooo00?oo`00ooooooooool01oooool00ol0
ofKoooooooooo`02ooooo`07o`3oI_oooooooooooonI0?l0ofKooooooonI000Eooooo`06ol`0oooo
ooooooooooooool0ofKoo`001?ooool01?l0ofKoooooooooooooool3olco00gooooo00?o06Kooooo
ool0I_l01Oooool2oc<0o`Oooooo00Go06Kooooooooooooo<ol0o`1Vo`03ooooo`05oc?o0?oooooo
oooooooooolco`005Oooool01?l0ofKooiT0ool0VOooV@03ooooo`05ool0VOooooooo`2Ioooooooo
09T01_ooool02?lco`3ooooooooooooooooo<ol0oooooooo09Wo<ol00_ooool00olco`3o0?oooc?o
0005ooooo`0<oc?o0?oooooooooooc?o0?ooooooc03ooooooolco`3o06Koooooool0I_oooooo0_o<
0?l01_oo003oooooo`3ooooooooo0?oooonI00?ooooo00?oo`00oonI0?ooool01_ooool00ol0003o
ooooooooo`01ooooo`006oooool00ol0003oooooooooo`06ooooo`03o`3ooooooooooooo00;ooooo
00Oo<ol0oooooooooooooooooonI0?o<o`3o<`3o01_ooooo0_lc0?l01Oooooooo`00oooooooooooo
o`0000?ooooo00?oo`00ooooooooool01oooool00ol0ofKoooooooooo`02ooooo`07o`3oI_oooooo
oooooonI0?l0ofKooooooonI000>ooooo`03oc<0oooooooooooo00Cooooo00Ooc03ooooooooooooo
ooooo`3oI_ooooooo`0000?ooooo00Go0?mVooooooooooooooooolco0002ooooo`03olco0?oooooo
oooo00[ooooo00?o06Koooooool0I_l01?ooool01?lc0?oooooooc<0oooo09T6ooooo`06o`1Voooo
oooooooooc?o0?l0I_oo0?oo1_ooool00olco`3oooooooooo`0Aooooo`?ooiT000Coooooool0VOoo
oooooiT00_ooool2ool0V@;ooooo00?oo`2Iooooooooool00oooool00olco`3oooooo`3oo`02oooo
o`04o`3ooolco`3oo`2Ioc?o00;ooooo0_lco`09ooooo`03oc?o0?l0ooooc03o00;o<ol000Coc03o
ooooool0I_ooc03o0_ooool01Oo<0?ooooooo`3oooooooooo`0000;ooiT00_ooool00ooo003ooiT0
ooooo`06ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Gooooo00?o
0?ooooooooooool00oooool01olco`3ooooooooooooooooooiT0olco0?lc0?l06oooool2oc<0o`03
oooooooo003ooooo00;ooooo00Coo`00oooooooo003oo`002Oooool00ol0ofKoooooooooo`02oooo
o`05o`3oI_oooooooooooonI0?l0ofH00_ooool00oooV@3oooooooooo`04ooooo`03o`3ooooooooo
oooo00Cooooo00?o<`3oooooooooool00oooool02?o<0?ooo`2Iol`0ooooooooo`00o`3oI_oooooo
o`000oooool01?l0ofKoooooooooooo<o`03ooooo`05olco0?ooooooooooooooooo<o`002?ooool0
1?l0I_ooooooool0VOl0I_l3ooooo`05oc<0oooo09Wo<`3ooooooooo09T01Oooool01_l0I_oooooo
oc?o0?oooooo06Koo`3oo`Oooooo00?o<ol0ooooooooool03Oooool02_l0ofKoooooooooooooV@3o
oooooonI0?l0ofKoo`00ooooooooV@02ooooo`;oo`2I0_ooool00ooo09Woooooooooo`03ooooo`03
oc?o0?oooooo0?oo00;ooooo00?o0?oooc?o0?lco`000oooool2oc?o00Wooooo00Ko<ol0o`3ooolc
o`3oooooo`1Voolco`02ooooo`0:o`1Vool0ooooo`00ol`0oooo003o0?ooooooooooV@3ooooooonI
00;ooooo00?ooiT0ool00?ooool01_ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Ko
oooo00?o0?ooooooooooool00oooool02Olco`3ooooooooooooooooooiT0olco0?lc0?ooooooool0
000Iooooo`;o<`3o00?oo`00ooooooooool00_ooool01?oo003oooooool00?oo0009ooooo`03o`3o
I_oooooooooo00?ooooo00Co0?mVooooooooV@3o0?mV0_l0ool01OooV@3oooooooooooooooooc?l0
00;ooooo00?o0?oooonI0?ooV@000_ooV@001?oooooo<`3ooooooolc0?l3ooooo`06ol`0oooooooo
o`2Iol`0oooo09Wo0?mV0_ooool01Ooo003ooooooooooooooooo0?mV00;ooooo00Goc?l0oooooooo
ooooooooolco0003ooooo`03olco0?oooooooooo00Kooooo00Co06Kooooooooo09Wo06Ko0oooool0
0olc0?ooo`2Ioc<0o`02ooooo`03ool0VOoooooooooo00;ooooo00Go06Kooooooolco`3oooooo`1V
o`02o`3oo`Kooooo00?o<ol0ooooooooool03Oooool01Ol0ofKoooooooooooooV@3ooooo00;o0?mV
0_oo00001?ooV@3ooooooooooooo09T4ooooo`03ool0VOoooooooooo00;ooooo00Ko<ol0ooooool0
ooooooooool0VOl0ool2oc?o00Cooooo00?o<ol0ool0VOooool02?ooool2oc?o0006ooooool0I_oo
<ol0ooooooo<0?oo06Ko0olco`002?l0ooooooooooooooooV@3ooooooonI0?l0oooooiT00_ooool0
0ooo003oooooooooo`03ooooo`;o00000oooool001_ooooo00?o0000ooooooooool01Oooool00ol0
ooooooooooooo`04ooooo`08oc?o0?oooooooooooonI0?o<o`3oo`00oc<0ooo<o`0Iooooo`?ooiT0
1?ooool01Ooo003oo`2Iool0VOooooooo`0000Oooooo00?o0?mVoc?o0?ooool01?ooool01ol0ofKo
oooooonI0?l0oooo0?mVo`3oooooV@000oooool01Oo<o`3ooooooonI0?ooV@3o0?oo00;ooooo00Go
oiT0oooooolc0?oooooooc<0o`02ooooo`;o<`3o00Goo`2Iooooooooooooc03oo`3oIP02ooooo`07
ool00?oooooooooooc?o0?oooooo0?mVolco0004ooooo`05o`1Vooo<o`3oooooooooooo<o`001?oo
ool2ool0V@06ooooool0I_oooooooooooooo09Wo06Ko0oooool00olc0?ooo`2Ioc<0o`03ooooo`04
ool0VOooooooooooooooo`;o<ol00_ooool01?l0oooo06Koooooool0ool5ooooo`03oc?o0?oooooo
oooo00cooooo0_l0ofH02Olc0?oooiT0ooooool0ofKoooooo`3oI_ooooooo`00oonI0002ooooo`03
ol`0oooooooooooo00;ooooo00?oo`2Iooooooooool00_ooool02Olco`3o0?ooooooool0ooooo`2I
o`3ooooooooo<ol0ool0V@03ooooo`03oc?o0?ooooooo`2I00Sooooo00Go<ol0o`3ooooo003o06Ko
oc?o0002ol`0o`08oc?o0?l0ooooo`00oc?o0?l0ooooooooool00?ooV@02ooooo`03oonI0?oooooo
oooo00;ooooo00?oo`00ooooooooool00oooool00ol0003oooooooooo`01ooooo`006oooool00ol0
003oooooooooo`04ooooo`03o`3ooooooooooooo00Gooooo00So<ol0oooooooooooooiT0olco0?l0
oooo<`3oolco00;ooooo00?o06Koooooool0ofH04oooool01?lc0?oooiT0oooooolc0?l2oonI00;o
oooo0_ooV@000ooooooo<ol0ool00007ooooo`03o`3oI_lco`3ooooo00Cooooo00So0?mVoonI0?l0
ofKo0?ooo`3oI_oooooo0?oooonI00;ooooo00Koc?l0oonI0?l0oooo<`3oo`3ooolc0?l2ooooo`09
oonI0?lc0?oooooooc<0oooooooo<`3ool`0oolc0?ooo`2I00;oo`0000_oc03oo`3oI_oooooooooo
ool00?oo09Wooooooc?o0?oooooo0?mVolco0003ooooo`;o06Ko00Goc?l0ooooooo<o`3oooooolco
0003ooooo`04ool0VOooooooo`2Io`1Vo`;ooooo00?oo`2Io`1Vooooool00_ooool01Olc0?oo06Ko
o`1Voolc0?oooooo00;o06Ko00?oooooo`3oI_lco`001?ooool01Ol0oooo06Koo`1Vool0oooo06Ko
00Cooooo00?o<ol0ooooooooool01_ooool01?l0ofKooooooc<0oolc0?l2ooooo`0;o`3oI_oooooo
0?mVoonI0?oooooo0?mVool0VOoo003o0?mVool00?ooV@000_ooool00oo<0?ooooooooooo`02oooo
o`0;ool0VOoooooooooooooooolco`3oooooo`3ooooooooo0?ooool0VOl0ool00_ooool01?oo09Wo
oooooooooooo09T2ooooo`03ool0VOoooooooooo00Gooooo00Koc03oooooool0oooo06Kooooooooo
0002oc?o0008o`3ooooooooo0?oooc?o0?l0ooooooooool00?ooV@03ooooo`03o`3ooooooooooooo
00Oooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01?ooool01?l0oooo
ooooooooooo<0?l4ooooo`0=oc?o0?ooooooooooooooooooV@3o0?ooolco0?ooooooc?l0ooooool0
I_ooooooo`3oIP0=ooooo`03o`3ooooooooooooo00?ooooo00Ko<`3ooonI0?oooooo<`3oooooool0
ool2oonI0005ooooooooV@3ooooooc?o0?oo00001oooool00ol0ofKo<ol0oc?o0005ooooo`07oonI
0?l0ooooooooo`3oI_oooooo0?oooonI0002ooooo`06oonI0?l0oooooooooc<0ool0oooo<`3o0_oo
ool02Olc0?oooiT0oooooooooooo<`3oooooooo<0?oooiT0oc<0o`02ooooo`07o`3oI_oo09Wooooo
oooooooo003oo`2Iooooo`02oc?o000<o`3oI_o<o`3ooooooc?o0?l0I_ooooooo`1Vooo<o`3ooooo
olco0?ooooooc?l00oooool01?oo09Woooooooooool0I_l2ooooo`;o<`3o00Ko06Kooooooooooooo
<`3oo`1Vooooool2o`1Vo`07oc<0ool0I_oooooooc?o0?l0I_ooooooo`3oo`02ooooo`06o`3ooooo
ooooooooooooool0oooo06Ko0oooool00olco`3oooooooooo`06ooooo`0Bo`3oI_oooooo<`3ooooo
oolc0?ooooooo`3oI_oooooo0?mVoonI0?lc0?oo0?mVool0VOoo003o0?mVoooooooo003ooiT00_o<
0?l01Ooo003oooooo`3oooooooooo`2I00?ooooo00Oo<ol0ooooool0ooooooooo`3ooooo09Wo0?oo
00;ooooo00Coo`2Iooooooooooooo`2I0_ooool01?oo09Woooooooooooooool2ol`0o`;ooooo00Co
c03oooooool0oooo06Ko0_ooool02olco`3o0?ooooooool0I_oo0?oooonI0?l0oooo06KooonI0?oo
ooooo`2I00?ooooo00?o0?ooooooooooool01_ooool00ol0003oooooooooo`01ooooo`006oooool0
0ol0003oooooooooo`03ooooo`05o`3oooooooooooooooooooo<0?l01?ooool01Olco`3ooooooooo
oooooooooiT000;oc?l000Oo<`3oolco0?oooooo06Koo`3oI_oooooo0?mV00cooooo00?o0?oooooo
ooooool00oooool02olc0?oooiT0oooooooooooo0?ooooooool0ooooooooool0VOoooooooiT000;o
<ol01oooool00olco`3oo`00oc?o0002ooooo`07o`1VoooooooooooooonI0?l0ooooooooo`3oIP02
ooooo`0>oonI0?oooooooiT0ooooooo<o`3o<`3ooc?o0?oooooo0?oooc<0oooooooo<`3ooooooooo
V@02ooooo`05ol`0oooooooooiT0ool0VOlc0?l00_l0ofH01_o<0?ooo`2Ioc?o0?oo09Woo`00ool0
V@;o<ol000Coc?l0oooooooo003o<ol00_ooool01_l0I_ooc?l0ooooooo<o`3oooooolco00;ooooo
00Goo`2Iool00?oo003oooooo`1Vo`02ooooo`03oc<0oooo09Wo06Ko00;ooooo00?o06Kooooooooo
ool00_lc0?l01ooooooo06Koool0VOlco`3o0?mVooooool0ool00_ooool01_l0oooooooooooooooo
oooo0?ooooooo`?o06Ko00?ooooooc?o0?ooool01_ooool2o`3oIP04oc<0ooooooooooooo`3oIP;o
oooo00GooiT0oooooooooooo0?mVool0V@02o`3oo`0:o`3oI_oo003ooiT0ol`0oooo003oc03oool0
0?l0ooooooooool0V@?ooooo00Co<ol0ooooool0ooooc?l00_l0ool3ooooo`04ool0VOoooooooooo
ool0V@;ooooo00Koo`2Iooooooo<0?ooc03oooooooo<0?l2ooooo`04ol`0oooooooo0?ooo`1Vo`;o
oooo00[oo`00o`3ooooo003o06Koo`3oooooV@3o<ol0o`1VooooV@3ooooo0_oo09T2ooooo`03o`3o
oooooooooooo00Kooooo00?o0000ooooooooool00Oooool001_ooooo0_l00007ooooo`03ol`0oooo
ooooc03o00?ooooo00Go<ol0oooooooooooooooooonI0002olco0007o`3oI_oo003oc?l0o`1Vool0
ofKoooooo`3oIP0<ooooo`;o0?oo1?ooool01OooV@3ooooooooooooooooo0?oo00;ooooo00Co0?oo
ool0VOoooooooiT00_lco`07ooooo`0<oc?o0?oo003ooooooc?o0?l0I_ooooooo`1VoooooooooiT0
o`3ooooooooo0?mV0_ooool03_l0oooooiT0olco0?l0ooooc?l0oc<0oolco`3oooooo`3ooolc0?oo
oooooc<0oooooooooiT00_ooool01Oo<0?oooiT0oonI0?oo09Wo0?mV00;ooooo00[oc03oool0VOlc
o`3oo`2Iool00?lco`3oo`2Iooooooo<o`3ooooo0_lco`002?ooooooo`2Iooooool0I_ooc?l0oooo
ool0I_ooc?l00_ooool01Ooo09Wooooooooooooo003o06Ko00;ooooo00Ko<`3oool0VOlc0?oo06Ko
ooooool0I_l2ooooo`09o`3ooooooooooooooc<0ool0I_oo<ol0o`3oI_l0ooooc03o00;o0?oo1?oo
ool00ol0ooooooooool00002ooooo`03o`1Voolco`3ooooo00Kooooo00?o0?mVooooool0ofH00ol0
ofH2ooooo`0AoonI0?l0ofKoooooo`3oI_lc0?oo0?ooooooool0oooo0?mVoonI0?o<0?oooooool`0
ool0oooo0?mVoooooooo09T00oooool01_lco`3o0?ooooooooo<o`3oo`2Io`3oo`?ooooo00Coo`2I
ooooooooooooo`2I0oooool00ooo09Woc03oooooo`02ooooo`;oc03o0_ooool00ooo003o0?oooooo
o`02ooooo`04o`3oooooooooo`2Io`3oo`;ooiT000?oo`00oonI0?oo09T00_ooool3ool0V@03o`3o
oooooooooooo00Cooooo0_l00003ooooo`006oooool00ol0003oooooooooo`06ooooo`03ol`0oooo
ooooc03o00?ooooo00Oo<ol0oooooooooooooooooonI0?o<o`3o0?oo00;o0?mV00Goc?l0ooooool0
ofKoooooo`3oIP0;ooooo`04o`3oooooooooooooo`3oo`?ooooo00GooiT0oooooooooooo0?oooc<0
o`02ooooo`05o`3ooooo09WooooooonI0?ooool00_ooV@05ooooo`05o`3oI_lco`3oooooo`1Voolc
o`000oooool01_l0I_oooiT0oooooooooooo0?mVo`1Vo`;ooooo00Co0?ooolco0?ooooooc?l00_lc
o`001?oooooo0?oooc<0oolc0?l3ooooo`03oonI0?ooooooc03o00;ooiT000Go0?ooo`3oI_oooooo
oooool`0o`02oc?o000?ool0VOoo003o<ol0ool0VOooooooc?l0o`3oI_lco`3o06Kooc?o0?oo09Wo
ooooo`1Vooo<o`3ooooo00;o06Ko00?oc?l0oooooooo09T00_ooool02_l0I_oo0?ooool00?lc0?oo
o`00o`3ooolc0?oo06Koooooool0I_l2ooooo`07o`3oooooooooooooooooool0I_oo<ol0o`3oIP02
ol`0o`03ooooool0oooooooo00Cooooo00?o0?ooool00?ooool00_ooool00olco`3oooooooooo`05
ooooo`03o`3oI_lc0?oooooo00Gooooo00GooiT0o`3oI_oooooo0?mVo`3oo`02ooooo`07o`3oool0
ofKoc03ooonI0?oooooo0?ooooooo`02o`3oIP06oooooooo09Wooooooc?o0?oooooo0?oo0_o<o`00
0ooo09Wo0?ooooooo`02ooooo`03ool0VOl0I_ooo`2I00Cooooo00?oo`2Iol`0ooooool00oooool0
1Oo<0?ooooooooooool0I_oo0?oo00;ooooo00[o0?ooooooooooooooo`2IoonI0?l0oooooiT0oooo
ooooV@3o06Ko1Oooool00ol0ooooooooooooo`05ooooo`03o`000?oooooooooo007ooooo000Koooo
o`03o`000?oooooooooo00Kooooo00?oc03oooooooo<0?l00oooool03?lco`3ooooooooooooooooo
oiT0ooooool0oooo0?mVoc<0ool0ofKoc?l0o`1Vo`;ooooo00Co0?mVooooool0ofKo0?mV1oooool0
1?l0ooooooooooooool0ool2ooooo`0?ool00?ooV@3oooooooooool0oooooooooc<0oooooooo0?oo
ool0VOoooooo<ol0oonI0?oo09WooiT000Cooooo00Ko06Koo`3oI_lco`3o06Koool00?lco`03oooo
o`06oonI0?l0ooooooooooooool0ofKo06Ko0oooool00oo<o`3oooooolco0002oc?o0004ooooool0
oooooooooc<0o`;ooooo00Soo`00oonI0?o<0?oooiT0ool00?l0oooooiT0o`3oo`?ooooo00oo<ol0
ool0VOlco`3ooooooc?o0?oo09Woooooolco0?l0ofKo<ol0o`1Voolco`3oo`2Iool00?l0I_l00_oo
ool01Ol0I_ooooooolco0?oo09Woo`0000;ooooo00Wo06Koo`3ooooooooo<`3oooooool0oooooooo
oc<0ool0I_l00oooool2o`3oo`;ooooo00Go<ol0o`3oI_oooooo0?mVol`0o`07ooooo`03o`3ooooo
ooooo`0000;ooooo00?o<ol0o`1Vooooool01?ooool00ol0ofKoo`2Ioc<0o`05ooooo`0<oonI0?oo
oooo0?mVooooool0ofKo0?oooc<0oooooooo0?ooooooool0ofKooooo1?ooV@001ol0oooo0?mVool0
VOoooooo<ol0ooooool0ool00_o<o`000ooo09Woooooooooo`02ooooo`03ool0VOl0I_ooo`2I00Co
oooo00Goo`2Iol`0ooooooooooooool0V@03ooooo`03ool00?l0I_oo0?oo00;ooooo00_o0?oooooo
oooo09WooooooonI0?l0oooooiT0ol`0ooooV@3oooooo`1Vo`04ooooo`03ool0VOl0oooooooo00Go
oooo00?o0000ooooooooool00Oooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo
0oo<0?l3ooooo`04ol`0oooooooooooooc?o00?ooooo00SooiT0ooooool0ofKoooooo`1Voolc0?oo
0?mVolco00;ooooo0_l0ofH00ooooooo0?mVooooo`06ooooo`0:o`3oooooooooooooooooool0oooo
ooooool00?ooV@3oooooo`3oo`;ooooo00[o<`3ooooooooo09Wo0?oooooooolco`3oooooool0VOo<
o`3ooiT00oooool01ol0I_oo0?mVoc?o0?ooooooo`00oooooolco`000_ooool01_ooV@3o<ol0oooo
ooo<o`3o0?mVo`1Vo`?ooooo00Goc?l0ooooooo<o`3o<`3ooc?o0002ooooo`0=o`3ooooooooooooo
oooooooo003ooiT0ol`0ooooV@3oooooo`3oooooV@3o0?oooc<0o`02ooooo`0<oc?o0?l0oooo<ol0
oooooolco`3oooooolco0?oooooo<ol0ooooool0I_oo<ol00_ooool00ol0I_ooo`2Io`1Vo`02oooo
o`03olco0?l0I_ooo`0000;ooooo0_l0ool01Ooooooo<`3oooooool0oooooooo00;o<`3o0_ooool0
0ol0ooooooooo`3oo`02ooooo`05oc?o0?l0ooooooooo`3oI_o<0?l01oooool00ol0ooooooooool0
0002ooooo`04oc?o0?l0I_ooooooolco00?ooooo00?o0?mVool0VOlc0?l01Oooool06_ooV@3ooooo
o`3oI_l0ofKoo`00o`3ooolc0?ooc03oooooool0oooo0?mVooooool0ooooooooo`3oI_ooV@3o0?oo
oc?o0?oo09Wooooooc?o0?oooooo0?ooolco0?ooooooc?l01Oooool00ol0I_oo<`3oooooo`03oooo
o`05ol`0oooo003ooooooooooooo09T00oooool01?oo003o06Koo`3oooooool3oonI00;ooooo00Co
oiT0o`3ooolco`3ooiT00_ooool00ol0I_ooooooooooo`02ooooo`03oc?o0?l0oooo06Ko00Gooooo
00?o0000ooooooooool00Oooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`05ooooo`05ol`0ooooooooooooooooooo<0?l00_ooool03Ooo09Wo<ol0ool0VOoooooooiT0
ooooool0ofKo0?ooo`1Voooo003o<`3oo`1Vooo<o`001?ooool00ol0ofKoooooooooo`05ooooo`0:
o`3oooooooooooooooooool0ooooooooool00?ooV@3oooooo`3oo`;ooooo01co<`3ooooooooo09Wo
0?oooooooolco`3oooooool0VOo<o`3ooooooonI0?oo003oooooo`1Voolco`3oo`00oooooooo003o
oooooc?o0?o<o`3ooooooonI0?lco`3oo`00olco0?oooooo0?mV0_ooool02Oo<o`3ooooooooooolc
o`3oc?l0oooooolco`3oooooo`3oo`02ooooo`0Mool00?ooooooc03ooonI0?oo003o0?ooool0VOoo
V@3oooooo`3ooooooooo<ol0ol`0ool0oooo<ol0oooooolco`3oooooolco0?oooooo0?mVo`1Voooo
003oo`2Ioc?o0?oooooo06Koool0VOl0I_l00_ooool03?o<o`3o06Koool00?oooooo06Koo`3ooooo
oooo0?ooooooool0ooooooooo`3oo`;o<`3o00Goo`00ooooool0ooooooooo`3oo`02ooooo`06oc?o
0?l0I_ooc03oo`3oI_ooooooc03o1_ooool00ooo003oc?l0ool00002ooooo`04oc?o0?oooooo06Ko
olco00?ooooo00Co0?mVool0VOlc0?oooiT01?ooool05oooV@3oooooooooool0ofKoo`00o`3ooolc
0?ooc03oooooool0ooooooooo`3oI_oooooo0?mVol`0ooooV@3o0?oooc?o0?l0ofKooiT0oc?o0?l0
ooooc?l000;ooooo00Woc?l0oc<0ooooooooooooo`3oI_l0I_ooo`2Io`1Voolc0?l00_l0ofH3oc<0
o`04ool00?oo09Woooooool0V@;ooooo00Ooo`00o`1VoooooooooiT0o`3ooooo09Wooooo00;ooiT0
0oooool01OooV@3oc?l0ol`0ooo<0?oo06Ko00?ooooo00?o<ol0o`3oool0I_l01Oooool00ol0003o
ooooooooo`01ooooo`004oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Wo
oooo01;oc03oooooooooooooo`2Ioc?o0?ooooooo`2IoonI0?oooooo0?mVo`3oool0I_ooo`00oc<0
ool0I_ooc?l0oooooooo09T3ooooo`03o`3oI_oooooooooo00Cooooo00[o0?oooooooooooooooooo
o`3ooooo003ooooooonI0?oooooo0?oo0_ooool02?lc0?oo<ol0ool0VOl0oooo<`3ooc?o0?oooooo
o`2I0_o<o`001OoooooooiT0oonI0?ooV@3o<ol000?ooooo00Ooo`00oc?o0?o<o`3oo`00oonI0?lc
o`3oo`0000;oc?l000co0?mVooooooooooooc?l0oooooolco`3o<`3oolco0?oooooo<ol0ooooool0
ool2ooooo`0<ool00?ooooooc03ooooooooo003o0?ooo`3oI_ooV@3oooooo`3ooooooooo<ol00_l0
ool03olco`3ooooooc?o0?ooooooc?l0ooooool0ofKo06Kooooooooo09Wo<ol0ooooool0I_ooo`2I
o`1Vo`02ooooo`0Aolco0?oo003o06Koooooool0I_oo0?ooooooool0ooooooooo`3ooooooooo0?oo
oooooolc0?ooooooool00?l0ool00_ooool02?l0oooooooooc?o0?lc0?ooc03oooooool0ofKoc03o
1Oooool02Ooo003oooooolco0?ooooooo`00oooooolco`3oooooo`1Vo`02olco00;ooooo00Co0?mV
ool0VOlc0?oooiT00oooool06?ooV@3ooooooooooooo09Wo0?mVool00?l0oooooooooc<0oooooooo
0?ooooooool0ofKoooooo`3oI_o<0?oooooooonI0?l0oooo<ol0oonI0?oooooo0?ooolco00;ooooo
00_oc?l0oc<0ooooooooooooo`3oI_l0I_ooo`2Io`1Vool0ofKo<`3oooooo`02o`3oIP0<oc<0oooo
09Wooooooooooooo09WooiT0ool00?l0I_oooooooonI0?l0ooooo`2I0_ooool03Oo<o`3ooiT0olco
0?ooooooc?l0oc?o0?ooooooc?l0ol`0oooooooo06Koooooool0ofH00_lco`000ol0oooooooooooo
o`03ooooo`03o`000?oooooooooo007ooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo0_l0
000;ooooo`0Aol`0ooooooooo`2Ioc?o0?ooooooo`2IoonI0?oooooo0?mVo`3oool0I_ooo`00oc<0
ool0I_ooc?l0oooooooo09T00oooool01ol0ofKo06Koooooooooooooo`2Iooooool0ool01Oooool0
1?l0oooooiT0oc<0ool0ool2ooooo`03o`3oI_lc0?ooc?l000;oc?l000_o0?oooc?o0?ooooooc?l0
ol`0ooo<o`3oooooool00?l0I_oooiT0oc?o0003ooooo`07ool00?lco`3oc?l0oc?o0?ooV@3o<ol0
ool00002olco000<o`3oI_l0I_ooc?l0olco0?oooooo<ol0oc<0ooo<o`3ooooooc?o0?o<o`3o0?oo
0_ooool06Ooo003ooooool`0oooo003oooooo`3oool0ofKooiT0ooooool0oooooooooc?o0?lc0?oo
c03ooc?o0?oooooo<ol0ooooooo<o`3oooooo`3oI_l0I_ooo`2Ioooooolco`000_ooool2o`1Vo`;o
oooo00koo`2Iolco0?l0I_ooooooo`3ooooooooo<`3oo`3ooooooooo0?ooooooool0oooooooooc<0
o`;ooooo00co0?ooool00?oo003o0?oooooooolco`3o<`3ool`0oooo09Wo0?mVol`0oolc0?l4oooo
o`05ool00?o<0?ooc?l0o`3ooooo00000_ooool02Olco`3o06Koolco0?o<o`3ooooooc<0ool0ofKo
<`3oool0V@02oonI00;ooooo00?ooiT0oooooooo09T00_o<0?l01?l0oooooooooooooolc0?l2oooo
o`;o0?oo00Ko0?mVooooooo<0?oooooooonI0?l0ool2oonI000=ooooool0ooooc?l0ool0VOlc0?oo
c?l0oooooolc0?oooooooonI0?l0ofKoo`2Io`3oIP04ooooo`03ol`0ool0ofKoo`2I00?ooooo0_oo
V@001?o<o`3ooiT0oooooooo09T2ooooo`06olco0?ooooooooooooooooo<o`3ooooo0olco`002?o<
o`3oooooo`1Vool0ofKo<ol0ol`0oolco`3o06Ko0oooool3o`0000?ooooo000Cooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool02_ooool03oo<0?ooooooool0VOlco`3oooooool0
VOooV@3oooooo`3oI_l0ooooooooool0VOlc0?ooo`00olco0005o`3oo`09o`3oI_l0I_oooooooooo
oooo09Woooooo`3oooooooooo`2I00?ooooo00Co0?oooonI0?oooooo0?oo0_ooool01_l0ofKo<ol0
olco0?lco`3oooooolco00;o0?oo00Soc?l0ol`0ooo<o`3o<ol0ooooool0I_oo0?mVoonI00?ooooo
00Coo`00ooooooo<o`3ooiT00_ooool00oo<o`3oooooooooo`02olco00;ooooo01[o<ol0ol`0oolc
0?ooc?l0oooooolco`3oc?l0o`3oooooooooo`00ooooooo<0?ooooooool00?l0ooooo`2Io`3oI_oo
oooooiT0oc<0oolco`3ooooooc<0ooo<0?oo0?oooc?o00;ooooo00Goc?l0ol`0oooooooo0?mVool0
V@02ooooo`04oc?o0?oooooo06Koool0V@;oo`0000[oo`2Iolco0?oooooo06Koo`3ooooooooo<`3o
o`3ooooooooo0?oo0_ooool01ol0oooooooooooooooooooo0?ooo`3oI_ooool00_l0ool01olco`3o
c03ooc<0ooooooooo`2Io`3oI_lc0?l01?ooool01Ooo003oc?l0olco0?o<0?oo0?oo00;ooooo01Wo
<ol0olco0?lco`3oc?l0oooooolc0?oo0?mVo`1Voooo09WooiT0ooooooooV@3oc03ooonI0?oo09Wo
oooool`0oooooooo0?ooooooooo<0?oooooooc<0oooooooo0?oo00?ooooo01Coc03ooc?o0?ooV@3o
c?l0oonI0?oooooooiT0olco0?ooooooo`2Ioc<0ooo<o`3ooooooc<0ool0ofKooiT0o`1Vool0ofKo
ooooo`1Vo`?ooooo00?oc03ooc<0ool0ofH00oooool02?ooV@3oo`00oonI0?o<o`3oooooool0VOoo
ooooc?l02Oooool02?o<o`3oooooo`1Vool0ofKo<ol0ooooool0ofKo<ol01Oooool00ol0003ooooo
ooooo`01ooooo`004oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00[ooooo
00Coc03ooooooooo09Wo<ol00_ooool04?ooV@3o0?mVool0VOl0I_oo0?ooool0VOlc0?ooooooolco
0?oo09Woooooool0VOoooooo0?ooo`3oI_l0I_l2ooooo`03ol`0ool0oooo0?oo00?oc03o00Gooooo
ool00?l0oooooiT0o`3oo`03ooooo`09o`3oI_o<o`3o<`3ooooooolco`3oc?l0ooooool0ooooc?l0
00;oc03o00Goc?l0ooooool0I_oo0?mVoonI0004ooooo`03olco0?lco`3ooiT000;ooooo00coc?l0
oooooooooooo0?mVo`1Voooooooo<ol0ooooooo<0?oo<`3oolco0?ooool2olco0005o`3ooooooooo
o`00ol`0ool0ofH00_ooool09Ol0ooooo`2Io`3oI_oooooooiT0oooooolco`3o<`3oooooooooV@3o
0?oooc?o0?lc0?ooc?l0ooooooo<0?ooooooo`3oI_oo09Woooooo`3ooolco`3oooooo`1Voooo09Wo
ooooool0VOl0ooooc?l0o`3ooooooooo0?oooc<0oooooooo0?ooooooool0ool00_ooool01_l0oooo
ooooooooool0ooooooooo`3oIP;ooooo00So0?oooc?o0?o<0?oo<`3ooooooooo09Wo<`3oo`3oIP?o
oooo017oo`00ooooooo<o`3o0?mVolco0?oooooo0?ooool0VOlco`3oc?l0oc?o0?l0ofKoc?l0oc<0
ool0ofKo06KooonI0003ooooo`09oonI0?ooooooo`2Iooooooo<0?ooc?l0o`3oooooooooc03o00;o
06Ko1_ooool03Olco`3ooooooonI0?ooV@3oo`00oonI0?o<o`3oooooool0VOooV@3oc?l0ool00?oo
ool00_ooV@001Olc0?ooooooooooool0I_ooc?l000;ooooo00Coc03ooooooolc0?oo0?mV0_ooool0
1oooV@3oooooolco0?ooooooc?l0ool0VOo<o`002_ooool02?o<o`3oc03oo`3oI_l0I_oo<ol0oooo
ool0ofKo<`3o1Oooool00ol0003oooooooooo`01ooooo`005?ooool2o`0000Gooooo00?o0000oooo
ooooool02oooool06_o<0?ooo`2Ioooooolco`3oc03ooonI0?l0ofKoo`2Io`1Vool0ooooo`2Ioooo
oolc0?oo0?ooolco0?ooooooo`2Iooooool0oooo0?mVooooool0I_ooo`2Io`3ooooo09Woc03o0_oo
09T01_ooooooc03oool00?ooV@3o<ol0o`3oo`;ooooo0_lco`001Oo<o`3ooooooooooooooooo<ol0
00;oc?l000So0?ooool0VOo<0?ooc?l0oc?o0?oo003o<ol0oonI00Cooooo00?oc?l0ool00?ooV@00
0_ooool03?o<o`3oo`00oooooooooooo0?mVoooooolco`3ooooooc<0ooooooooc?l0ooooo`;oc?l0
00Woo`00o`3oooo<0?ooooooo`3oI_oooooo<ol0o`3oool0ofH00_ooool01?ooV@3ooooooc?o0?lc
0?l2oonI000<o`3ooolco`3ooooooonI0?ooooooc03oooooool0ofKoooooo`3ooooooooo<ol00_oo
ool02?oo09Woooooool0VOl0ooooooooolco0?l0oooo<`3o0oooool01Ol0oooooooooooooooooooo
0?oo00;ooooo00ko0?ooo`3oI_oooooo0?mVooooooooV@3o0?mVol`0oooo003o<`3oool0VOlc0?oo
0?mVoc<0o`;ooooo017oo`00ol`0ooo<o`3o0?mVolco0?o<0?oo0?ooool00?lco`3oc?l0oc?o0?l0
ofKoc?l0o`3oI_o<0?oo06KooonI0002ooooo`03ol`0ooo<o`3oo`2I00?o06Ko00Ooc?l0o`3ooooo
oooo06Kooooooolc0?oo06Ko00;ooooo00[o<`3ooooooolco`3oc03oolco0?ooV@3o0?oooooooooo
V@3oc?l00_ooool01?ooV@3oooooolco0?ooool2oonI00?ooooo00co06Koolco0?oooooooooool`0
oooooooo<`3oool00?l0ofKooooooonI0?o<o`02ooooo`03ool0VOo<o`3ooooo00[ooooo00Soc?l0
oc?o0?l0ofKo<ol0ol`0oooooooo06Koo`3oIPGooooo00?o0000ooooooooool00Oooool001_ooooo
00?o0000ooooooooool02oooool03oo<0?oooooooooooolco`3oc03ooonI0?l0ofKo06Kool`0ool0
ooooo`2Ioooooolc0?oo0?ooolco0002ooooo`0:ool0VOl0I_oo0?ooo`3oI_l0I_ooc03oo`3ooooo
ooooo`2Iooooo`;o0?mV0_ooV@002?lco`3o0?oooc?o0?oooooo<ol0o`3oI_o<0?ooc?l00_ooool2
o`3oIP03oc<0ooo<o`3o0?oo00;o06Ko00?oc?l0o`1Vooo<o`000_o<o`002oooV@3oo`2Iool0VOoo
09Woc?l0o`3oooooV@3oc?l0ooooooo<o`3oo`0000?ooooo00Co<ol0ooooooo<0?oo<`3o0_ooool3
olco0009ol`0ool0ooooooooooooool0ofKooooooc?o0?oooooo0?mV00?ooooo00?ooiT0olco0?oo
V@000_ooool03?ooV@3ooooooonI0?ooV@3oc03oool0VOoooooo0?mVo`3ooooooooo0?mVoc?o00;o
oooo00Ooo`2Ioooooooo09Wo0?ooooooooo<o`3o0?oo00Cooooo00Go0?ooooooooooooooooooo`3o
o`02ooooo`0>o`3oool0ofKoooooo`3oI_oooooooiT0o`3oI_o<0?oooooooc<0oooo09Wo<`3oo`3o
I_lc0?l2ooooo`0Col`0ooooooooc?l0o`3oI_o<o`3oc03oooooool0ooooooooolco0?oo09Wo<ol0
olco0?l0ofKo06KoooooooooV@3oo`2Iol`0o`02olco0008ol`0ool0I_ooc03oolco0?lco`3oc?l0
o`1Vooo<0?l2ooooo`05oc<0ool0I_oooooooc<0oolco`000_ooool01oo<o`3oc03oolco0?l0oooo
c?l0oonI0?l0ofH00_ooV@000oooooooc?l0ooooo`02oonI00?ooooo0_o<o`002_ooooooc03ooooo
oooooooo<`3oool00?l0ofKooiT0oc<0ooo<o`02ooooo`03ool0VOoooooooooo00[ooooo00Coc?l0
oc?o0?lc0?oo<ol00_ooool00ol0I_oo0?mVooooo`04ooooo`03o`000?oooooooooo007ooooo000K
ooooo`;o00003?ooool03oo<0?oooooooooooolco`3o06KoooooooooV@3o06Kool`0ool0ooooo`2I
ooooool0ooooo`2Iolco0002ooooo`07oc<0ool0I_oo0?ooo`3oI_l0I_oo0?oooonI0003ooooo`;o
oiT000[oo`00oc?o0?lc0?oo0?oooooooolco`3oc03oo`3oI_o<o`3ooooo0_l0ofH03_oooooo0?mV
oc<0ool0I_oo0?ooool0VOooooooc03oolco0?l0ofKo<ol0ooooooooV@3oo`2I0_ooool03_o<o`3o
0?oooonI0?o<o`3oooooolco0?oo003ooooooc<0oooooooo<ol0o`3oI_o<0?oo<`3o0_ooool01Oo<
o`3oo`00olco0?oooooo0?oo00;ooooo0_l0ofH2oc?o0006o`3oI_oooooooooooooooolco`3ooiT0
1?ooool03?ooV@3oc?l0ooooooooV@3oo`2Iooooool0ofKo0?oool`0ool0ofKo<ol0o`3oo`;ooooo
00Koo`2Io`3oooooooooooooolco0?lc0?l4ooooo`03o`3ooooooooooiT000;ooooo0_l0ool01ooo
V@3o0?mVooooool0ofKooiT0oc?o0?ooV@000_ooool2oc<0o`05ol`0oooooooo0?mVooooooo<0?l0
0_ooool06oo<o`3oooooolco0?o<0?ooooooo`3oool0ofKoc?l0ool0VOlco`3o0?mVolco0?l0I_oo
oooooonI0?oo09Woc03oolco0?oo09Woc?l0ool00?o<0?ooc?l0oc?o0?l0ooooc?l0ol`0o`02oooo
o`05oc<0oolco`3o<ol0oc?o0?lc0?l00_ooool05_o<o`3oooooolco0?l0ooooc?l0oonI0?oooooo
oiT0ooooooooV@3oc?l0oonI0?l0I_oo<`3ooonI0?ooooooc?l0ooooooo<o`3ooooool`0ooooool2
o`1Vo`05ool00?l0ofKooiT0oc<0ooo<o`000_ooool00ooo09Woooooooooo`0:ooooo`04o`3oI_o<
o`3o<`3ooc?o00;ooooo00?o06Koooooooooool00oooool2o`0000?ooooo000Kooooo`03o`000?oo
oooooooo00_ooooo00Coo`2Iol`0ooo<0?oo<ol00_l0I_l02OooV@3o06Koooooooo<0?oo0?ooool0
VOl0ooooooooolco0002ooooo`07o`1Voooooooo0?ooo`3oI_l0I_ooc?l0oonI0003ooooo`05oonI
0?oo09Wooooooc?o0?ooool00_oo09T01_o<0?oo0?mVooooooo<o`3oooooo`3oIP;ooooo00Wo0?mV
oc<0ool0I_ooc03oo`3oooooooooc03oooooool0ofH00_ooool04_ooV@3oc?l0ooooooooooooc?l0
oonI0?oo09Woc?l0ooooooo<o`3o<ol0ool00?lc0?oooooooc?o0?oooooo0?mVoc<0o`;ooooo00go
c?l0ool00?lco`3oc?l0o`3ooooooooo0?mVoooooolco`3o0?ooo`3oI_lco`3ooooo00;o<ol000?o
ooooolco0?o<o`000oooool01ol0ooooc?l0o`3oooooV@3oooooo`1Vooooool00_l0ofH00ooooooo
c03ooc?o0002ooooo`03ol`0ool0oooooooo00;ooooo00?oc?l0ooooooooool01?ooool01OooV@3o
ooooooooool0oooo0?mV00;ooiT000GooooooonI0?l0ofKo<ol0oonI0002ooooo`0Tool00?lc0?oo
o`2IoonI0?l0ofKoc03oool00?ooooooc?l0o`3oI_ooooooc?l0ooooooo<0?ooooooo`3oI_o<o`3o
oooooc?o0?lc0?oo0?mVolco0?oooooooiT0ol`0oooo09Woc?l0ooooooo<o`3oo`00oc?o0?o<o`3o
<ol0o`3oooo<o`3oc03o0_ooool01olco`3oooooo`1Voooooooo<`3oooooooo<o`000_ooool02_o<
o`3oc03oolco0?ooV@3ooooooonI0?l0ofKooiT0olco0?ooV@02ooooo`0AoonI0?o<o`3ooooooooo
ooo<o`3ooooool`0oooooooo06Kooc<0ool0I_oo0?mVoonI0?l0I_ooc?l0oooooooo09T03Oooool0
2?l0ofKoc?l0oc?o0?lc0?oo06Koooooool0I_ooo`2I1Oooool00ol0003oooooooooo`01ooooo`00
6oooool00ol0003oooooooooo`0;ooooo`0Fool0VOo<0?oooooooc?o0?l0I_oo0?mVoonI0?o<0?oo
oooool`0ool0ooooo`2Io`3oooooooooc?l0ooooool0I_oo<`3oool0VOl0oooo0?mVolco00;ooiT0
0oooool01OooV@3oo`2Ioooooolco`3o0?mV00;ooooo00Goo`2Io`3oI_o<o`3ooooool`0o`04oooo
o`08o`3oI_ooooooc03oo`3ooooo09Woc03oooooool0ofH2ooooo`07ool0VOooV@3oooooolco0?oo
oooooiT0ooooo`02olco000:oooooolco`3ooooooc<0oolco`3o06Kooooooolc0?oo0?mVool000;o
oooo00coo`00oc?o0?o<o`3oooooo`3oool0ofKooooooc?o0?oooooo0?mVoooooolco`03ooooo`04
olco0?ooooooc?l0ooooo`;oc?l000Koooooo`3oooooV@3oooooo`1Vool0ool2o`3oIP03ooooooo<
0?oo<ol000;ooooo00Ko<ol0o`3ooooooooooooooc<0ooo<o`05ooooo`06oonI0?oooooooiT0oooo
ool0ofKooiT00_ooool01_ooV@3oooooo`3oI_lco`3oc03ooonI00;ooooo00Soo`00ool0VOooV@3o
0?mVol`0oooo003oooooolco00;ooooo00oo0?mVolco0?o<0?ooc03oo`3oI_o<o`3ooooool`0oolc
o`3oooooo`1VooooV@3o06Kool`0ooo<o`000_ooool00oo<o`3o<ol0olco0002ooooo`0<oc?o0?o<
o`3oc03ooooooolco`3ooooooc<0oooooooo06Kooc<0ooooooooc?l00oooool02Oo<o`3ooooooooo
ooooV@3o<`3oo`3oI_ooV@3o06KooonI0002ooooo`0AoonI0?o<o`3oooooooooool0I_ooc?l0ol`0
oooooooo06Kooc<0oooooooo06KooonI0?l0I_ooc?l0oooooooo09T03?ooool02Ol0ofKoooooolco
0?lco`3oc03oo`1Voooooooo06Koool0V@05ooooo`03o`000?oooooooooo007ooooo000Kooooo`03
o`000?oooooooooo00_ooooo023oo`2Ioooooooooooo06Kooc?o0?l0ofKooiT0ol`0ooooooooc03o
o`3ooooooooo0?ooooooooo<o`3o06Kooc<0ooooooooo`2Io`3oooo<o`3o0?mVoonI0?o<o`3ooiT0
ooooooooV@3oo`00oooooolco`3oc?l0o`3oIP?ooooo00Co0?mVolco0?ooooooc03o0oooool03Ol0
I_oo0?mVooooooo<0?oo0?ooool0VOooooooc03oo`3oI_ooooooo`2IooooooooV@000_o<o`005?oo
oooooiT0ooooooooooooc?l0oooooolco`3o<`3ool`0oolco`3o06Kooooooolc0?oo0?mVo`1Voooo
003oooooool00?lco`3oc?l00_ooool01Ol0ofKooooooc?o0?oooooo0?mV00Gooooo00Coc?l0oooo
ooooooooc?l01?ooool01_l0oooooiT0o`1Vool0oooo0?mVooooo`;ooiT000Co<ol0oooooooooooo
<ol00oooool00olc0?ooc?l0ooooo`02ooooo`;ooiT00_ooool01?ooV@3oooooo`3oI_ooV@04oooo
o`04oc?o0?l0ofKooooooonI00;ooooo00Soo`00oonI0?ooV@3o0?mVoc<0oooooooo0?mVolco00;o
oooo00Go0?mVolco0?oooooo0?mVolco0002ooooo`0Col`0oolco`3oooooo`1VooooV@3o06Kooooo
ooo<o`3oooooo`1Vooo<o`3o<ol0olco0?oooooo0?oooc?o0?o<o`3ooooooc?o0004ooooo`04o`1V
oooooooo<`3oolco00?ooooo00coc?l0ol`0oooooooooiT0oc<0oooooooo0?mVoonI0?l0ofKoc?l0
ooooooooV@03ooooo`04o`1Vooo<o`3oc03oo`1Vo`;ooooo00Oo<`3oool00?ooV@3oc?l0oc<0oooo
ooooo`2I00?ooooo00?o<`3oooooooooool01Oooool01_l0ofKoooooooooooo<o`3oc03oooooo`;o
06Ko00?o<`3oool0VOooool01?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003ooooo
ooooo`0;ooooo`07ool0VOooooooooooo`1Voolco`3o0?mVoonI0003ooooo`07o`3ooooooooo0?oo
ooooooo<o`3ooooooc<0o`02ooooo`0=ool0VOo<o`3ooiT0o`1Vooo<o`3ooiT0ooooooooV@3oo`00
oooooolco`3oc?l0o`3oIP03ooooo`04o`3oI_o<o`3ooooool`0o`?ooooo00Co06Koo`3oI_o<0?oo
oooo0_l0ofH02ooooooo0?mVooooooooooooo`2Ioc<0oooooooooiT0olco0?l0oooooiT000;ooooo
00Ooc?l0oooooooooooo<ol0ol`0oolco`3o<`3o00;o06Ko00Oo0?mVooooool0I_ooo`00oooooolc
o`3oc?l000;ooooo00Co0?mVoc?o0?oooooo0?mV1Oooool00oo<o`3oooooooooo`07ooooo`03oonI
0?l0I_oo0?oo00;ooiT000GooooooonI0?lco`3ooooool`0o`02oc?o00;ooooo00Go<`3oooooooo<
o`3ooooooonI0005ooooo`03oonI0?l0ofKooiT000Cooooo00Go<ol0o`3oI_oooooooooooonI0002
ooooo`;ooiT000Goooooo`3oI_l0ofKoc?l0oc<0o`03ooooo`0>olco0?oooooo0?mVolco0?o<0?oo
oooooc<0oolco`3o06KoooooooooV@3oc?l0oc?o0?o<o`02o`1Vo`09olco0?lco`3oc?l0ooooool0
oooo<ol0ol`0ooo<o`3o<ol000Cooooo00?o06Koooooooo<o`001?ooool03?lc0?ooc03ooooooooo
oooo<`3oooooool0ofKooiT0o`3oI_ooooooc?l0oonI00Cooooo00?oc?l0ol`0ool0I_l00_ooool0
1olc0?oooooooonI0?o<o`3o<`3oo`3oI_oo09T00oooool00olc0?ooooooooooo`02ooooo`?o0?mV
0oooool00oo<o`3oc03oooooo`02o`1Vo`03oc<0oooooooooooo00Cooooo00?o0000ooooooooool0
0Oooool001_ooooo0_l0000<ooooo`07ool0VOooooooooooo`1Voolco`3o0?mVoonI0003ooooo`07
ol`0ool0oooooooooc<0oooo003oc?l0oc<0o`02ooooo`08ol`0ooo<o`3ooiT0o`3oI_oo003ooiT0
ooooooooV@02ooooo`07oc?o0?o<o`3oc?l0o`3oI_oooooo0?mVolco0002ooooo`0:ol`0oooooooo
ooooo`1Voooooooo0?mVol`0oooooooo0?mVo`3oo`;o0?mV00Soooooool0VOoooooo<`3ooooooooo
V@3ooooooonI00?ooooo00goo`2Ioooooooooooo<`3ooc?o0?oooooo<`3oo`1Voolc0?ooooooo`3o
I_oooooo06Ko00;ooooo00?oc?l0ooooooooool00_lco`000ooo09Wo0?mVooooo`04ooooo`03olco
0?oooooooooo00Oooooo00?ooiT0o`3oooooV@000olc0?l01_oooooooiT0o`3ooolco`3ooooooc?o
00;ooooo00Go<`3oooooooooooooc?l0oonI0005ooooo`;ooiT00oooool2ol`0o`03oc?o0?l0ofKo
oooo00;ooooo00WooiT0ooooooooV@3ooiT0ooooool0ofKoooooolco0?lc0?l00oooool01?o<o`3o
ooooo`3oI_o<o`02ol`0o`08oc<0oolco`3o06KoooooooooV@3oooooolco0?l0I_l2ooooo`08ool0
0?o<o`3oooooooooool0oooooooooc?o0?o<o`06ooooo`03o`1Vooo<o`3ooooo00?ooooo0_lc0?l2
ooooo`05oc<0oooooooo0?mVo`3oI_oo00000_ooool00oooV@3oo`00ooooo`02ooooo`03olco0?o<
0?oo06Ko00;ooooo00Ko<`3oooooooooV@3oc?l0oc<0ool0ofH3ooooo`03oc<0ool0ofKooooo00?o
oooo00?o0?mVooooooooool00oooool01Oo<o`3ooooooooooolc0?oo06Ko00Kooooo0_l00003oooo
o`006oooool00ol0003oooooooooo`07ooooo`05ool0VOoooooooooooooooooo09T00_ooool01?l0
I_oo<ol0o`3oI_ooV@03ooooo`07ol`0ool0oooooooooc<0oooo003oc?l0oc<0o`02ooooo`0>olco
0?ooV@3o<`3oo`3oI_l0I_oooiT0ooooooooV@3ooooooc?o0?o<o`3oooooool0VOo<o`02o`3oIP04
olco0?oooooooooool`0o`;ooooo017o06Koooooool0ofKo<`3oo`3oI_oooooo0?ooool0VOl0ofKo
ooooool0VOoooooo<`3oooooooooV@3ooooooonI0004ooooo`05ool0VOoooooo<`3ool`0ooooool0
0_lc0?l2ooooo`03o`3oI_oooooo06Ko00;ooooo00?oc?l0oc?o0?lco`000_oo09T7ooooo`03olco
0?oooooooooo00Oooooo00?o06KooonI0?ooool00oooool02?lc0?oo<ol0oonI0?lco`3ooooooc?o
0?oooooooiT00oooool00oooV@3o0?mVooooo`04ooooo`03o`3oI_ooV@3ooooo00;ooooo00?oc03o
oooooolco`001Oooool02?ooV@3oo`2IooooooooV@3oo`2Iolco0?oooooo<`3o0oooool03Oo<o`3o
ooooo`3oI_o<o`3ooooool`0oolc0?oo0?oooc?o0?oo003ooiT0oooooolco`000oooool00ooo003o
c?l0o`3oo`02o`3oo`03oooooolco`3oc?l000Kooooo00?oc?l0oooooolc0?l00_ooool02_lc0?oo
oooooc<0ooo<0?oooooooc<0ool0I_ooooooo`3oI_oo0002ooooo`03oonI0?oo003ooooo00;ooooo
00?oc?l0ooooool0I_l00_ooool01Olc0?oooooooonI0?o<o`3ooooo00;o0?mV0_ooool00olc0?oo
0?mVoc<0o`03ooooo`03o`3oI_oooooooooo00?ooooo00Goc?l0ooooooooooooooooo`1Vo`07oooo
o`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Oooooo00coo`2Ioooooooo
ooooooooool0VOoooooo06Koooooool0ofKo<ol0ooooooooV@02ooooo`06ol`0oooooooooooooc<0
oooo003oc?l00_ooool03Oo<0?ooc?l0oonI0?lc0?oo0?mVo`1Vooo<o`3ooiT0o`3oI_oooooo<ol0
olco0?oo09T00_l0I_l00oo<o`3oooooolco0003ooooo`07ol`0ool0I_ooooooooooool0ofKo<`3o
o`3oIP02ooooo`03o`3oooooooooc03o00;ooooo00Go<`3ooooooooooooooiT0o`3oo`04ooooo`03
ool0VOoooooo<`3o00?ooooo00Co<`3ooooooooooooo0?mV0_ooool01ol0I_ooooooolco0?oo09Wo
0?mVooooooo<o`001oooool00oo<o`3oooooooooo`07ooooo`03o`1Voooooooooooo00?ooooo00Co
<`3ool`0ooooV@3o<ol00_ooool01olco`3ooiT0oonI0?lco`3ooiT0ooooooo<o`001Oooool01ol0
ofKoc03ool`0ooooooooc03ooooooolco`002?ooool01?oo09WooiT0ooooooo<o`02ooooo`04oc<0
ooooooooooooo`3oIP;oc?l00oooool02?lc0?oooooooc?o0?oooooooiT0oc?o0?oooooo<ol00_oo
ool00olco`3o0?ooooooo`04ooooo`04olco0?ooooooooooooooo`;oc?l000Coooooolco0?oooooo
<`3o0_ooool01olc0?oooooooc<0ooo<0?oooooooc<0ool0I_l00oooool01Ooo003ooooooooooooo
V@3oo`0000;ooooo00?oc?l0ooooool0I_l00_ooool01Olc0?oooooooonI0?o<o`3o0?mV00;o<`3o
00Go0?mVooooool0ofKo0?mVoc<0o`03ooooo`03o`3oI_oooooooooo00?ooooo00Go<`3oolco0?oo
oooooooooc<0o`07ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Oo
oooo0_oo09T2ooooo`09ool0VOoooooo06Koooooool0ofKo<ol0oooooolco`3ooiT000;ooooo0_o<
0?l2oc<0o`;oc?l001;ooooool`0ooo<o`3ooiT0oc<0oooo003o0?mVolco0?ooV@3o0?mVoooooolc
o`3oc?l0o`1Voooooooo06Koooooooo<o`04ooooo`03ol`0ool0I_oooooo00;ooooo0_l0ofH2oooo
o`05o`3ooooo09Woc03ooooooolc0?l00oooool00olc0?oo0?ooooooo`03ooooo`03ool0VOlc0?oo
c03o00Oooooo00[o0?mVoooooooooooo06Koolco0?oo09Wo0?mVooooooo<o`3ooooo0ol0I_l3oooo
o`03olco0?oooooooooo00?ooooo00Co06Kooooooooooooo06Ko1_ooool01?lc0?ooc03ooc?o0?oo
V@02ooooo`07oonI0?lc0?oooooooonI0?oooooo0?mVolco0004ooooo`08o`3oI_ooooooc03ool`0
ooooooooc03ooooooolco`08ooooo`03ool0VOooV@3oc?l000?ooooo00Co<`3ooooooooooooo0?mV
0_o<o`002olc0?oooooooooooolc0?oooooooc?o0?ooV@3oo`00oc?o0?oooooo<ol000;ooooo00?o
<ol0ooooooooool01?ooool02_o<o`3oooooooooooooooooc?l0ooooooo<o`3o06Kooooooolc0?l2
ooooo`07oc<0oooooooooooooc<0oooooooo<`3oo`1Vo`03ooooo`09ool00?oooooooooooonI0?oo
ooooo`00ooooooo<o`3o06Ko00?ooooo00Go<`3ooonI0?o<o`3oooooo`3oIP02ooooo`05oc<0ool0
ofKoooooooooool0ofH00_ooool00ol0ofKo<`3oooooo`04ooooo`03oc<0ooo<o`3ooooo00Wooooo
00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01_ooool00ooo09Woooooool0
V@02ooooo`09ool0VOoooooo06Koooooool0ofKooooooc?o0?oooooooiT000;ooooo00Koc03ooooo
ooo<0?ooooooool00?ooool2olco000>oc?o0?ooV@3o<`3oool00?l0ofKoc?l0o`3oI_lc0?oooooo
oc?o0?o<o`3o06Koooooool0I_l6ooooo`03o`1Voooooooooooo00;ooooo00Wo0?mVoooooooooooo
ooooo`3ooooo09Woc03ooooooolc0?l00oooool00olc0?oo0?ooooooo`04ooooo`03oc<0ooo<0?oo
oooo00Kooooo00Oo0?mVoooooooooooo06Koolco0?oo09Wo0?mV00;oc?l000Goooooo`1Voooooooo
ooooo`1Vo`02ooooo`03olco0?oooooooooo00?ooooo0_l0I_l00ooooooo06Koooooo`06ooooo`07
oc<0oolco`3ooiT0ooooooooV@3o<ol0oc<0o`02oc?o0005o`3oI_o<0?ooc?l0o`3oI_lco`000_oo
ool02?l0ofKoc03oooooooo<0?oooooool`0oooooooo<ol02?ooool00ooo09WooiT0olco0003oooo
o`09oc<0ooooooooooooooooooo<o`3ooooooc<0oooooooo<`3o00;ooooo00Wo<ol0oonI0?oo003o
<ol0oooooolco`3oooooo`3ooolco`001oooool00oo<o`3oooooolco0004ooooo`05o`1Voooooooo
<`3ooooooolc0?l00_ooool2oc<0o`03o`1Voooooooooooo00;ooooo00Goo`00oooooooo003ooiT0
ooooo`02ool00003olco0?l0I_oooooo00?ooooo00CooiT0olco0?l0ofKo0?mV0oooool01?lc0?oo
ooooooooool0ofH2ooooo`03o`3oI_lc0?oo<`3o00Cooooo00?o<`3oolco0?ooool02Oooool00ol0
003oooooooooo`01ooooo`006oooool2o`0000Oooooo00Goo`2Ioooooooo09Woooooool0V@02oooo
o`03o`1Vool0ofKooooo00?ooooo00?ooiT0oc?o0?ooool00_ooool04Oo<0?ooooooool00?oooooo
c03oolco0?oooooooiT0oooooolc0?ooooooolco0?l0ofKo<`3ooc?o0?ooooooc?l000?ooooo00?o
06Koooooooooool00oooool00ol0I_ooooooooooo`02ooooo`03o`3oI_oooooooooo00;ooooo00Wo
0?ooooooooo<0?oo<`3oooooool0oooooooooc<0ool0ool01Oooool00olc0?ooc03oooooo`06oooo
o`0;o`3oI_ooooooooooooooooo<o`3oooooo`3oI_o<o`3oooooolco0?l0I_l00_ooool01?l0I_oo
ooooooooooo<o`05ooooo`03o`1Voooooooo06Ko00Sooooo00Ko<`3oo`3oI_ooV@3ooooooonI0?lc
0?l2oc?o0006o`3oI_lco`3oc03oolco0?l0ofKo<ol00_ooool01Ol0ofKoc03oooooooooooooc03o
00;ooooo00?o<ol0ooooooooool01_ooool00ooo09WooiT0ooooo`03ooooo`07oc<0oooooooooooo
ooooool0ofKo<`3oooooo`02oc<0o`;ooooo00Wo0?oooonI0?oooooo<ol0oooooolco`3oooooo`3o
oolco`001oooool2olco00Gooooo00Go06Kooooooolc0?oo06Kooc<0o`02ooooo`;o<`3o00?o06Ko
ooooooooool00_ooool01?oo003oooooool00?ooV@02ooooo`03ool00?o<0?ooc?l000Cooooo00Co
oiT0olco0?l0ofKo0?mV1_ooool01_l0ofKo<`3oooooool0ofKooooooc<0o`Cooooo00?o<`3oolco
0?o<o`002?ooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Kooooo00?oo`2Ioooooooo
ool00_oo09T2ooooo`03o`1Vool0ofKooooo00Cooooo00?ooiT0ooooooooool00_ooool03oo<0?oo
o`00oooooolco`3ooooooonI0?lco`3ooooooc<0ooooooooc?l0o`3oI_oooooo<ol0olco0004oooo
o`03o`1Voooooooooooo00;ooooo00?o06Koooooooooool01?ooool03?lc0?oooooooooooolc0?oo
0?ooooooooo<0?oo<`3oooooool0ooooooooo`3oo`Kooooo00?o<`3ool`0ooooool00_ooool00ooo
09Woooooooooo`02ooooo`0:o`3oI_ooooooooooolco0?l0ofKoooooolco0?ooooooc?l0o`1Vo`;o
oooo00?oc?l0ooooooo<o`001Oooool00ol0I_ooooooooooo`09ooooo`0Boc<0ool0ofKooooooonI
0?oooooo<`3ooc?o0?oooooo0?mVoc?o0?o<0?ooooooolco0?lco`3oooooo`3oI_ooooooc03o1?oo
ool00olco`3oooooooooo`08ooooo`03oonI0?oooooooooo00;ooooo00?o<`3oooooooooool00_oo
ool2oonI000=oooooolc0?ooooooooooool0oooooiT0oooooolco`3ooooooc?o0?oooooo0?oooc?o
0007ooooo`03olco0?oooooooooo00Cooooo00?o06Kooooooolc0?l00_l0I_l3ooooo`03oc<0ool0
I_oooooo00?ooooo00Coo`00oooooooo003ooiT00oooool00oo<0?ooc?l0ooooo`03ooooo`03oonI
0?oooooo0?mV00Oooooo00Ko0?mVoc<0oooooooo0?mVoooooolc0?l3ooooo`05oc<0oooooooooooo
ooooooo<o`002?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`06oooo
o`03ool0VOoooooooooo00;oo`2I00?oooooo`1Vool0ofH01_ooool00oooV@3oooooooooo`02oooo
o`0?ol`0oooo003o<ol0ol`0oooooooooiT0oooooolco`3o<`3oooooool0I_ooc?l0oooooolco`3o
c?l000Cooooo00?o06Koooooooooool00_ooool00ol0I_ooooooooooo`05ooooo`;o<`3o00Oooooo
oc<0ool0ooooc03ooc<0ool0oooooooo00;o0?oo00?o<`3oooooooooool00_ooool00olc0?oooooo
ol`0o`03ooooo`03ool0VOoooooooooo00;ooooo0_l0ofH01?oooooo06Koolco0?o<o`02ooooo`07
olco0?ooooooooooooooooo<o`3oooooolco0005ooooo`03o`1Voooooooooooo00Wooooo00?o<`3o
o`3oI_ooool00_ooool01Olc0?ooc03oooooool0ofKo<ol000;ooooo00Koc?l0oc?o0?l0ofKo0?mV
ooooooo<0?l4ooooo`03oc?o0?oooooooooo00Oooooo00?oc?l0oonI0?ooool00oooool00olc0?oo
ooooooooo`02oonI00;ooooo00?ooiT0ooooooooool00_ooool00oooV@3o<ol0ool00002ooooo`03
oc?o0?oo003o<ol000kooooo00Go06Koooooool0I_oo<`3oooooo`04o`1Vo`03ol`0oooooooooooo
00;ooooo00Goo`00oooooooo003ooooooonI0002ooooo`03ol`0ooo<o`3ooooo00;ooooo00CooiT0
olco0?oooooo0?mV2?ooool00ol0ofKoooooo`3oIP02ooooo`04oc<0oooooooooooooc<0o`Cooooo
00?oc?l0ooooooooool01Oooool00ol0003oooooooooo`01ooooo`006oooool00ol0003ooooooooo
o`03ooooo`;o06Ko00Goooooool0VOooooooooooool0V@03o`1Vo`03o`3oI_oooooooooo00Cooooo
00?ooiT0oc?o0?ooool00_ooool00oo<0?ooo`00oc?o0002ooooo`0:oonI0?ooooooo`00oc?o0?oo
oooo06Koolco0?oooooo<ol0olco00Cooooo00?o06Koooooooooool00_ooool00ol0I_oooooooooo
o`09ooooo`03o`3ooolc0?oo0?oo00;ooooo0_l0ool02?lc0?oooooooooooooooooo<`3oooooooo<
0?ooo`2I0_ooool00ooo09Woooooool0V@05ooooo`;o0?mV0_o<o`02ooooo`05olco0?oooooooooo
olco0?l0I_l00_o<o`000ooooooo06Koo`1Vo`02ooooo`03o`1Voooooooooooo00[ooooo00Co<`3o
o`3oI_oooooo<`3o0_ooool00oo<0?oo0?mVoc?o0002ooooo`03olco0?l0ofKo<ol000;ooooo00?o
c03oooooooooool00_ooool00olco`3oooooooooo`07ooooo`03olco0?ooV@3ooooo00?ooooo00Go
<`3oooooooooV@3ooooooc<0o`03ooooo`;ooiT000GooooooonI0?l0oooo<ol0ool00002ooooo`03
oc?o0?oo003o<ol000oooooo0_l0I_l00olc0?ooooooooooo`02ooooo`03o`1Vooo<0?oooooo00?o
oooo00Goo`00oooooooo003ooooooonI0002ooooo`05ol`0ooo<o`3oc?l0olco0?ooV@003?ooool0
0ol0ofKoooooo`3oIP03ooooo`03oc<0oooooooo<`3o00Cooooo00?oc?l0ooooooooool01Oooool0
0ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05ooooo`03o`1Voooooooooooo
00;ooooo00Co06Kooooooooooooo0?mV1oooool00oooV@3oooooooooo`03oc?o000=ol`0oooooooo
oooooonI0?ooooooo`00oc<0oolco`3o06Koolco0?lco`3o06Koolco0004ooooo`05o`1Voooooooo
ooooooooool0I_l03?ooool00ol0oooo<`3oo`3oo`03ooooo`03o`3ooolc0?oooooo00;ooooo00Ko
<`3oooooooo<0?ooo`2Ioooooooo09T3ooooo`?oo`2I0oooool00ooo09Woc?l0olco0002ooooo`03
olco0?ooooooc?l000;ooooo00Go06Koolco0?oooooo06Koooooo`02o`1Vo`gooooo00Co<`3oo`3o
I_oooooo<`3o0_ooool00ol0ofKooooooc?o0002ooooo`03olco0?o<0?oo<ol000;ooooo00?oc03o
ooooooooool00_ooool00olco`3oooooooooo`07ooooo`03olco0?ooV@3ooooo00Cooooo00?ooiT0
oooooolc0?l01_ooool2oonI0003o`3ooolco`3oo`0000;ooooo00?o<ol0oooooolco`003oooool0
0ol0I_ooooooooooo`05ooooo`03ol`0oooooooooooo00?ooooo00Ooo`00oooooooooooooooooonI
0?ooooooc03o00;ooooo00?ooiT0ooooooooool02oooool00ol0ofKo<`3oo`3oIP04ooooo`;o<`3o
1?ooool00oo<o`3oooooooooo`05ooooo`03o`000?oooooooooo007ooooo000Kooooo`;o00001_oo
ool01Ol0I_oooooooooooooooooo06Ko00;ooooo00?o0?mVooooooooool01_ooool04oooV@3ooooo
oc?o0?ooooooc03oooooooo<0?ooo`00ooooooooV@3oooooool00?oooooo<ol0ooooooo<o`3o<ol0
ooooooo<o`001?ooool01Ol0I_oooooooooooooooooo06Ko00gooooo00?o0?oool`0ooooool00ooo
ool01?lc0?oooooooooooolc0?l2ooooo`03ol`0ooooooooo`2I00Oooooo00Koo`2Ioooooooo09Wo
ooooolco0?l0I_l2ooooo`03o`1Vooo<o`3oc?l000;ooooo00Co06Kooooooooooooo06Ko0_ooool0
0ol0I_ooooooooooo`0;ooooo`04oc<0ool0ofKooooooc<0o`;ooooo00[o0?mVol`0oooooooo<ol0
ooooooo<o`3oc03ooc?o0?ooooooc03o1?ooool00olco`3oooooooooo`08ooooo`03olco0?oooooo
oiT000Cooooo00?ooiT0oc<0ooooool01oooool01?ooV@3o0?ooooooooooool2ool00003oc?o0?oo
oooo<ol001Sooooo00?oc03oooooooooool00_ooool01_oo003ooooooooooooooooooiT0ol`0o`?o
oooo00?ooiT0ooooooooool02oooool2o`3oIPKooooo00?o<`3oooooooooool00oooool00oo<o`3o
ooooooooo`03ooooo`;o00000oooool001_ooooo00?o0000ooooooooool01Oooool01Ooo09Wo06Ko
oooooooooooo06Ko00;ooooo00?o0?mVooooooooool01_ooool00oooV@3o<ol0ooooo`02ooooo`0;
oonI0?ooooooooooool00?ooV@3oooooool00?oooooo<`3ooc?o0?l0I_l00_o<o`06ooooo`03o`1V
oooooooo06Ko00oooooo00?oc03oooooooooool00_ooool01?lc0?oooooooooooolc0?l2ooooo`03
ol`0oooooooooooo00Sooooo0_oo09T00oooooooc?l0o`1Vo`02ooooo`03o`1Vooo<o`3ooooo00;o
oooo00Co06Kooooooooooooo06Ko4Oooool00ol0ofKooooooc<0o`02ooooo`0<o`3oI_oooooooooo
oc?o0?oooooo<ol0olco0?lco`3ooooool`0oooooooo<ol00_ooool00olco`3oooooooooo`08oooo
o`03olco0?oooooooiT000Cooooo00?ooiT0oc<0ooooool02Oooool01?l0ooooooooool00?l0ool2
oc?o01Wooooo00?oc03oooooooooool00_ooool01_oo003ooooooooooooooooooiT0ol`0o`;ooooo
00?ooiT0ooooooooool03Oooool00ol0ofKoooooooooo`0:ooooo`03olco0?oooooooooo00Cooooo
00?o0000ooooooooool00Oooool000Sooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol0
0005ooooo`03o`000?oooooooooo00Gooooo00Coo`2Io`1Voooooooo06Ko0oooool00ol0ofKooooo
ooooo`06ooooo`03oonI0?oooooooooo00;ooooo00WooiT0ooooooooooooo`00oonI0?ooooooo`00
oooooolc0?l00_lco`02olco00Kooooo0_l0I_l@ooooo`03ol`0oooooooooooo00;ooooo00?o<`3o
ol`0oolc0?l00oooool00oo<0?ooooooooooo`09ooooo`04ool0VOooooooooooooooo`;o06Ko1Ooo
ool00ol0I_ooooooo`1Vo`0Booooo`03o`3oI_lc0?oooooo00;ooooo00co0?mVoooooooooooo<ol0
oooooolco`3oc?l0oc?o0?ooooooc03ooooooolco`02ooooo`03oc?o0?oooooooooo00Oooooo00Co
c?l0oooooooooooooiT00oooool00oooV@3o<`3oooooo`0:ooooo`06o`3oooooooooo`00o`3ooooo
oooo<ol06_ooool00oo<0?ooooooooooo`06ooooo`04oonI0?oooooooooooonI00oooooo00?o0?mV
ooooooooool02_ooool00oo<o`3oooooooooo`04ooooo`03o`000?oooooooooo007ooooo0007oooo
o`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oo
oooooooo00Cooooo00Goo`2Iooooool0I_ooooooo`1Vo`02ooooo`03o`3oI_oooooooooo00Sooooo
00CooiT0oooooooooooooooo0_ooV@02ooooo`03oonI0?oo003ooooo00?ooooo00?o<ol0ooooooo<
o`001_ooool00ol0I_ooooooooooo`0@ooooo`03ol`0oooooooooooo00;ooooo0_lc0?l2ooooo`03
ol`0oooooooooooo00kooooo0_l0I_l5ooooo`03o`1Voooooooo06Ko01;ooooo00?o0?mVoc<0oooo
ool00_ooool01_l0ofKooooooooooolco`3ooooooc?o00?oc?l000Koc03ooc?o0?oooooo<ol0oooo
oolco`09ooooo`04olco0?oooooooooooonI00?ooooo00?ooiT0ooooooooool02_ooool01_l0oooo
ooooooooool0oooooooooc?o01[ooooo00?oc03oooooooooool00_o<0?l4ooooo`04oonI0?oooooo
oooooonI01cooooo00?oc?l0ooooooooool01?ooool00ol0003oooooooooo`01ooooo`001oooool0
1?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?oo
ool01?oo09Woooooooooool0I_l3ooooo`03o`3oI_oooooooooo00Sooooo00KooiT0oooooooooooo
oiT0ooooooooV@02ooooo`03oonI0?oo003ooooo01oooooo00?oc03oooooooooool00_ooool2oc<0
o`;ooooo00?oc03oooooooooool03oooool00ol0I_ooooooooooo`03ooooo`03o`1Voooooooo06Ko
01;ooooo00Go0?mVooooooooooooooooo`3oIP03ooooo`07oc?o0?oooooo<ol0ooooooo<0?ooc?l0
oc?o0002ooooo`;o<ol02_ooool00oo<o`3oooooooooo`02oonI00;ooooo00?ooiT0ooooooooool0
2oooool01Ol0ooooooooo`3ooooooooo<ol001[ooooo00Goc03oooooooo<0?oooooool`0o`03oooo
o`04ol`0oooooooooiT0oonI01kooooo00?oc?l0ooooooooool00oooool00ol0003oooooooooo`01
ooooo`001oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo0_l00005
ooooo`03ool0VOoooooooooo00Cooooo00?o0?mVooooooooool02?ooool01?ooV@3ooooooooooooo
V@02ooooo`;ooiT000?oooooool00?ooool07oooool01oo<0?ooooooooooooooooooc03ooc<0ooo<
0?l00_ooool00oo<0?ooooooooooo`0Eooooo`03o`1Voooooooo06Ko01?ooooo00Co0?mVoooooooo
oooo0?mV1?ooool01_lco`3oooooooooooo<0?ooc?l0oc?o00?ooooo00?o<ol0ooooooooool02?oo
ool00oo<o`3oooooooooo`02ooooo`;ooiT03_ooool2o`3ooakooooo00Ooc03ooooooooooooooooo
ol`0ooooooooc03o00?ooooo00?ooiT0ooooooooool07?ooool01?o<o`3oooooooooooooool3o`00
00?ooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo1?l00005ooooo`03o`000?oooooooooo
00?ooooo00?oo`2Iooooooooool01?ooool00ol0ofKoooooooooo`0:ooooo`03oonI0?oooooooiT0
00;ooooo0_ooV@0Rooooo`05ol`0ooooooooooooooooooo<0?l00_ooool00oo<0?oooooool`0o`0H
ooooo`;o06Ko4oooool01?l0ofKoooooo`3oI_l0ofH4ooooo`06oc?o0?oooooooooool`0oolco`3o
c?l03_ooool00oo<o`3oooooooooo`03ooooo`03oonI0?oooooooooo00gooooo00?o0?oooooooooo
ool08Oooool00oo<0?ooooooooooo`0Wooooo`03o`000?oooooooooo007ooooo0007ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`03
ool0VOoooooooooo00Cooooo00?o0?mVooooooooool02_ooool00oooV@3ooooooonI0002ooooo`;o
oiT08oooool01?o<0?ooooooooooooo<0?l2ooooo`03ol`0ooooooooc03o01Sooooo00?o06Kooooo
ooooool04_ooool2o`3oIPKooooo00Ko<ol0oooooooooooooooool`0ooo<o`0>ooooo`03olco0?oo
oooooooo067ooooo00?o0000ooooooooool00Oooool000Sooooo0_l00008ooooo`Go00001?ooool0
0ol0003oooooooooo`0:ooooo`03o`3oI_oooooooooo00[ooooo0_ooV@04ooooo`03oonI0?oooooo
oooo027ooooo00Coc03oooooooooooooc03o0_ooool2ol`0oaWooooo00?o06Koooooooooool07_oo
ool00oo<0?ooc?l0ooooo`0=ooooo`03olco0?oooooooooo067ooooo00?o0000ooooooooool00Ooo
ool001_ooooo00?o0000ooooooooool02_ooool00ol0ofKoooooooooo`0;ooooo`03oonI0?oooooo
oooo02Oooooo0_o<0?l4ooooo`03ol`0oooooooooooo01Oooooo00?o06Koooooooooool07oooool0
0oo<o`3oooooooooo`03ooooo`03olco0?oooooooooo00Kooooo00?oc?l0ooooooooool0HOooool0
0ol0003oooooooooo`01ooooo`006oooool2o`0000_ooooo00?o0?mVooooooooool0=_ooool00oo<
0?ooooooooooo`0nooooo`03olco0?oooooooooo00?ooooo00?oc?l0ooooooooool00_ooool01Oo<
o`3oooooooooooooooooc?l006;ooooo0_l00003ooooo`006oooool00ol0003oooooooooo`0:oooo
o`03o`3oI_oooooooooo07Sooooo00Coc?l0oooooooooooooooo0_o<o`04ooooo`04olco0?oooooo
ooooolco06Cooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool02_ooool0
0ol0ofKoooooooooo`1hooooo`04olco0?ooooooooooolco00;ooooo00Coc?l0oooooooooooooooo
0_o<o`000oooooooc?l0ooooo`1Sooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oo
oooooooo00Wooooo00?o0?mVooooooooool0NOooool01?o<o`3oooooooooooo<o`02ooooo`04olco
0?ooooooooooolco00;ooooo0_o<o`1Tooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`00
0?oooooooooo00Wooooo00?o0?mVooooooooool0NOooool00oo<o`3oooooolco0003ooooo`04olco
0?ooooooooooolco00?ooooo00?oc?l0ooooooooool0H_ooool00ol0003oooooooooo`01ooooo`00
6oooool2o`0000[ooooo00?o0?mVooooooooool0NOooool00oo<o`3oooooolco0004ooooo`03olco
0?ooooooc?l006Oooooo0_l00003ooooo`006oooool00ol0003oooooooooo`09ooooo`03o`3oI_oo
oooooooo07[ooooo0_o<o`04ooooo`03olco0?ooooooc?l006Sooooo00?o0000ooooooooool00Ooo
ool001_ooooo00?o0000ooooooooool02Oooool00ol0ofKoooooooooo`1jooooo`03olco0?oooooo
oooo00?ooooo00?oc?l0ooooooo<o`00J?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0
003oooooooooo`09ooooo`03o`3oI_oooooooooo087ooooo00?oc?l0ooooooooool0Ioooool00ol0
003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`09ooooo`03o`3oI_oooooooooo087o
oooo00?oc?l0ooooooooool0Ioooool00ol0003oooooooooo`01ooooo`006oooool2o`0000[ooooo
00?o0?mVooooooooool0j_ooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Wooooo00?o
0?mVooooooooool0joooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`08
ooooo`03o`3oI_oooooooooo0>cooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000oooo
ooooool02?ooool00ol0ofKoooooooooo`3/ooooo`03o`000?oooooooooo007ooooo000Kooooo`03
o`000?oooooooooo00Sooooo00?o0?mVooooooooool0k?ooool00ol0003oooooooooo`01ooooo`00
6oooool2o`0000Wooooo00?o0?mVooooooooool0joooool2o`0000?ooooo000Kooooo`03o`000?oo
oooooooo00Sooooo00?o0?mVooooooooool0k?ooool00ol0003oooooooooo`01ooooo`006oooool0
0ol0003oooooooooo`08ooooo`03o`3oI_oooooooooo0>cooooo00?o0000ooooooooool00Oooool0
01?ooooo0ol00005ooooo`03o`000?oooooooooo00Sooooo00?o0?mVooooooooool0k?ooool00ol0
003oooooooooo`01ooooo`005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00So
oooo00?o0?mVooooooooool0k?ooool00ol0003oooooooooo`01ooooo`005?ooool00ol0003ooooo
ooooo`04ooooo`;o00002Oooool00ol0ofKoooooooooo`3Zooooo`?o00000oooool001Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`3oI_oooooooooo0>cooooo00?o
0000ooooooooool00Oooool001Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`07
ooooo`03o`3oI_oooooooooo0>gooooo00?o0000ooooooooool00Oooool001?ooooo0_l00006oooo
o`03o`000?oooooooooo00Gooooo00?o0?mVooooool0ofH0koooool00ol0003oooooooooo`01oooo
o`005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0?mVooooool0
ofH0koooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`05ooooo`?o0?mV
koooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Kooooo00?o0?mVooooool0ofH0k_oo
ool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Gooooo00?o0?mVooooooooool0koooool0
0ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`04ooooo`03o`3oI_oooooooooo
0?3ooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000ooooooooool01?ooool00ol0ofKo
ooooooooo`3`ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`000?oooooooooo00Cooooo
00?o0?mVooooooooool0l?ooool00ol0003oooooooooo`01ooooo`006oooool2o`0000Gooooo00?o
0?mVooooooooool0koooool2o`0000?ooooo000Kooooo`03o`000?oooooooooo00Cooooo00?o0?mV
ooooooooool0l?ooool00ol0003oooooooooo`01ooooo`006oooool00ol0003oooooooooo`04oooo
o`03o`3oI_oooooooooo0?3ooooo00?o0000ooooooooool00Oooool001_ooooo00?o0000oooooooo
ool01?ooool00ol0ofKoooooooooo`3`ooooo`03o`000?oooooooooo007ooooo000Kooooo`03o`00
0?oooooooooo00Cooooo00?o0?mVooooooooool0l?ooool00ol0003oooooooooo`01ooooo`006ooo
ool2o`0000Gooooo00?o0?mVooooooooool0koooool2o`0000?ooooo000Kooooo`03o`000?oooooo
oooo00?ooooo00?o0?mVooooooooool0lOooool00ol0003oooooooooo`01ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`3oI_oooooooooo0?7ooooo00?o0000ooooooooool00Oooool001_o
oooo00?o0000ooooooooool00oooool00ol0ofKoooooooooo`3aooooo`03o`000?oooooooooo007o
oooo000Kooooo`03o`000?oooooooooo00?ooooo00?o0?mVooooooooool0lOooool00ol0003ooooo
ooooo`01ooooo`006oooool2o`000?Oooooo0_l00003ooooo`006oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo007ooooo000Koooooo_o00000oooool00?oooooo6_ooool00?oooooo
6_ooool00?oooooo6_ooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-13.8823, -1.8826, \
0.419554, 0.0196343}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 11}\),
      SequenceForm[ "Dimension der Daten  ", {101, 11}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.291244 0.089815 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0218 -12 -4.5 ]
[-0.0125 .0218 0 4.5 ]
[-0.0125 .11161 -12 -4.5 ]
[-0.0125 .11161 0 4.5 ]
[-0.0125 .20143 -12 -4.5 ]
[-0.0125 .20143 0 4.5 ]
[-0.0125 .29124 -6 -4.5 ]
[-0.0125 .29124 0 4.5 ]
[-0.0125 .38106 -6 -4.5 ]
[-0.0125 .38106 0 4.5 ]
[-0.0125 .47087 -6 -4.5 ]
[-0.0125 .47087 0 4.5 ]
[-0.0125 .56069 -6 -4.5 ]
[-0.0125 .56069 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31594 -5 -6 ]
[.97619 .31594 5 6 ]
[.97619 .39571 -5 -6 ]
[.97619 .39571 5 6 ]
[.97619 .28021 -5 -6 ]
[.97619 .28021 5 6 ]
[.97619 .18605 -5 -6 ]
[.97619 .18605 5 6 ]
[.97619 .26295 -5 -6 ]
[.97619 .26295 5 6 ]
[.97619 .24758 -5 -6 ]
[.97619 .24758 5 6 ]
[.97619 .32285 -5 -6 ]
[.97619 .32285 5 6 ]
[.97619 .22125 -5 -6 ]
[.97619 .22125 5 6 ]
[.97619 .37064 -5 -6 ]
[.97619 .37064 5 6 ]
[.97619 .34896 -5 -6 ]
[.97619 .34896 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0218 m
.00625 .0218 L
s
[(-3)] -0.0125 .0218 1 0 Mshowa
0 .11161 m
.00625 .11161 L
s
[(-2)] -0.0125 .11161 1 0 Mshowa
0 .20143 m
.00625 .20143 L
s
[(-1)] -0.0125 .20143 1 0 Mshowa
0 .29124 m
.00625 .29124 L
s
[(0)] -0.0125 .29124 1 0 Mshowa
0 .38106 m
.00625 .38106 L
s
[(1)] -0.0125 .38106 1 0 Mshowa
0 .47087 m
.00625 .47087 L
s
[(2)] -0.0125 .47087 1 0 Mshowa
0 .56069 m
.00625 .56069 L
s
[(3)] -0.0125 .56069 1 0 Mshowa
.125 Mabswid
0 .03976 m
.00375 .03976 L
s
0 .05773 m
.00375 .05773 L
s
0 .07569 m
.00375 .07569 L
s
0 .09365 m
.00375 .09365 L
s
0 .12958 m
.00375 .12958 L
s
0 .14754 m
.00375 .14754 L
s
0 .1655 m
.00375 .1655 L
s
0 .18347 m
.00375 .18347 L
s
0 .21939 m
.00375 .21939 L
s
0 .23736 m
.00375 .23736 L
s
0 .25532 m
.00375 .25532 L
s
0 .27328 m
.00375 .27328 L
s
0 .30921 m
.00375 .30921 L
s
0 .32717 m
.00375 .32717 L
s
0 .34513 m
.00375 .34513 L
s
0 .3631 m
.00375 .3631 L
s
0 .39902 m
.00375 .39902 L
s
0 .41699 m
.00375 .41699 L
s
0 .43495 m
.00375 .43495 L
s
0 .45291 m
.00375 .45291 L
s
0 .48884 m
.00375 .48884 L
s
0 .5068 m
.00375 .5068 L
s
0 .52476 m
.00375 .52476 L
s
0 .54273 m
.00375 .54273 L
s
0 .00384 m
.00375 .00384 L
s
0 .57865 m
.00375 .57865 L
s
0 .59662 m
.00375 .59662 L
s
0 .61458 m
.00375 .61458 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0218 m
1 .0218 L
s
.99375 .11161 m
1 .11161 L
s
.99375 .20143 m
1 .20143 L
s
.99375 .29124 m
1 .29124 L
s
.99375 .38106 m
1 .38106 L
s
.99375 .47087 m
1 .47087 L
s
.99375 .56069 m
1 .56069 L
s
.125 Mabswid
.99625 .03976 m
1 .03976 L
s
.99625 .05773 m
1 .05773 L
s
.99625 .07569 m
1 .07569 L
s
.99625 .09365 m
1 .09365 L
s
.99625 .12958 m
1 .12958 L
s
.99625 .14754 m
1 .14754 L
s
.99625 .1655 m
1 .1655 L
s
.99625 .18347 m
1 .18347 L
s
.99625 .21939 m
1 .21939 L
s
.99625 .23736 m
1 .23736 L
s
.99625 .25532 m
1 .25532 L
s
.99625 .27328 m
1 .27328 L
s
.99625 .30921 m
1 .30921 L
s
.99625 .32717 m
1 .32717 L
s
.99625 .34513 m
1 .34513 L
s
.99625 .3631 m
1 .3631 L
s
.99625 .39902 m
1 .39902 L
s
.99625 .41699 m
1 .41699 L
s
.99625 .43495 m
1 .43495 L
s
.99625 .45291 m
1 .45291 L
s
.99625 .48884 m
1 .48884 L
s
.99625 .5068 m
1 .5068 L
s
.99625 .52476 m
1 .52476 L
s
.99625 .54273 m
1 .54273 L
s
.99625 .00384 m
1 .00384 L
s
.99625 .57865 m
1 .57865 L
s
.99625 .59662 m
1 .59662 L
s
.99625 .61458 m
1 .61458 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .31594 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .16218 m
.03333 .27801 L
.04286 .28496 L
.05238 .2815 L
.0619 .27392 L
.07143 .36155 L
.08095 .41753 L
.09048 .36795 L
.1 .39714 L
.10952 .42178 L
.11905 .43238 L
.12857 .35322 L
.1381 .19816 L
.14762 .27366 L
.15714 .22501 L
.16667 .17392 L
.17619 .16603 L
.18571 .23127 L
.19524 .24008 L
.20476 .31267 L
.21429 .27525 L
.22381 .32083 L
.23333 .31571 L
.24286 .35285 L
.25238 .29576 L
.2619 .30888 L
.27143 .27778 L
.28095 .30065 L
.29048 .31131 L
.3 .30481 L
.30952 .32344 L
.31905 .3251 L
.32857 .33341 L
.3381 .27923 L
.34762 .27287 L
.35714 .25343 L
.36667 .23878 L
.37619 .20306 L
.38571 .19446 L
.39524 .22691 L
.40476 .19365 L
.41429 .27482 L
.42381 .26655 L
.43333 .26371 L
.44286 .3027 L
.45238 .32527 L
.4619 .36716 L
.47143 .29273 L
.48095 .30579 L
.49048 .22934 L
Mistroke
.5 .26485 L
.50952 .32391 L
.51905 .37313 L
.52857 .3331 L
.5381 .2897 L
.54762 .33413 L
.55714 .28818 L
.56667 .27554 L
.57619 .30611 L
.58571 .30503 L
.59524 .36622 L
.60476 .40205 L
.61429 .27174 L
.62381 .23947 L
.63333 .23173 L
.64286 .34194 L
.65238 .34563 L
.6619 .41211 L
.67143 .35673 L
.68095 .26535 L
.69048 .27794 L
.7 .18789 L
.70952 .18121 L
.71905 .26217 L
.72857 .20834 L
.7381 .23618 L
.74762 .31509 L
.75714 .35963 L
.76667 .35826 L
.77619 .24933 L
.78571 .28324 L
.79524 .35342 L
.80476 .38792 L
.81429 .41837 L
.82381 .3346 L
.83333 .24626 L
.84286 .26102 L
.85238 .18415 L
.8619 .16464 L
.87143 .26252 L
.88095 .22844 L
.89048 .30375 L
.9 .24564 L
.90952 .21262 L
.91905 .2768 L
.92857 .26958 L
.9381 .28525 L
.94762 .3874 L
.95714 .35607 L
.96667 .34319 L
Mistroke
.97619 .31594 L
Mfstroke
1 0 .6 r
gsave
.97619 .39571 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30812 m
.03333 .20824 L
.04286 .21736 L
.05238 .12868 L
.0619 .15924 L
.07143 .29095 L
.08095 .32353 L
.09048 .28412 L
.1 .38737 L
.10952 .27964 L
.11905 .29013 L
.12857 .27645 L
.1381 .30524 L
.14762 .29402 L
.15714 .23486 L
.16667 .31635 L
.17619 .37878 L
.18571 .27135 L
.19524 .23044 L
.20476 .23152 L
.21429 .2158 L
.22381 .28742 L
.23333 .29138 L
.24286 .35416 L
.25238 .35886 L
.2619 .333 L
.27143 .28877 L
.28095 .27013 L
.29048 .30435 L
.3 .37548 L
.30952 .32117 L
.31905 .35384 L
.32857 .28285 L
.3381 .31148 L
.34762 .32496 L
.35714 .24309 L
.36667 .22092 L
.37619 .23869 L
.38571 .15751 L
.39524 .19235 L
.40476 .31129 L
.41429 .28733 L
.42381 .33745 L
.43333 .28962 L
.44286 .32708 L
.45238 .33412 L
.4619 .31415 L
.47143 .29661 L
.48095 .3261 L
.49048 .23373 L
Mistroke
.5 .18537 L
.50952 .1829 L
.51905 .29942 L
.52857 .36863 L
.5381 .29639 L
.54762 .30055 L
.55714 .34178 L
.56667 .37651 L
.57619 .29198 L
.58571 .36852 L
.59524 .36002 L
.60476 .29885 L
.61429 .31324 L
.62381 .26395 L
.63333 .33087 L
.64286 .26287 L
.65238 .26565 L
.6619 .31213 L
.67143 .28279 L
.68095 .2842 L
.69048 .32802 L
.7 .33287 L
.70952 .27385 L
.71905 .20295 L
.72857 .16345 L
.7381 .15428 L
.74762 .19958 L
.75714 .29975 L
.76667 .42166 L
.77619 .37972 L
.78571 .34744 L
.79524 .24541 L
.80476 .23456 L
.81429 .24977 L
.82381 .34502 L
.83333 .29567 L
.84286 .2933 L
.85238 .29204 L
.8619 .31865 L
.87143 .31576 L
.88095 .3331 L
.89048 .36447 L
.9 .23568 L
.90952 .19625 L
.91905 .26459 L
.92857 .28941 L
.9381 .26288 L
.94762 .26752 L
.95714 .30831 L
.96667 .34002 L
Mistroke
.97619 .39571 L
Mfstroke
.8 0 1 r
gsave
.97619 .28021 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22774 m
.03333 .25012 L
.04286 .26035 L
.05238 .35675 L
.0619 .34748 L
.07143 .32717 L
.08095 .38 L
.09048 .32653 L
.1 .31512 L
.10952 .33624 L
.11905 .21573 L
.12857 .26142 L
.1381 .27558 L
.14762 .26863 L
.15714 .24188 L
.16667 .24417 L
.17619 .25475 L
.18571 .36638 L
.19524 .35034 L
.20476 .29657 L
.21429 .33848 L
.22381 .25806 L
.23333 .28748 L
.24286 .30026 L
.25238 .37673 L
.2619 .42147 L
.27143 .38663 L
.28095 .30765 L
.29048 .2953 L
.3 .25987 L
.30952 .16036 L
.31905 .11633 L
.32857 .22526 L
.3381 .2732 L
.34762 .19603 L
.35714 .3431 L
.36667 .25817 L
.37619 .21434 L
.38571 .22948 L
.39524 .27272 L
.40476 .32798 L
.41429 .37057 L
.42381 .3131 L
.43333 .3255 L
.44286 .30524 L
.45238 .33779 L
.4619 .37502 L
.47143 .28863 L
.48095 .30889 L
.49048 .31218 L
Mistroke
.5 .34857 L
.50952 .33004 L
.51905 .35533 L
.52857 .2965 L
.5381 .35122 L
.54762 .20911 L
.55714 .30309 L
.56667 .21927 L
.57619 .15767 L
.58571 .24362 L
.59524 .23349 L
.60476 .27327 L
.61429 .27472 L
.62381 .31999 L
.63333 .34471 L
.64286 .30051 L
.65238 .27177 L
.6619 .30158 L
.67143 .29371 L
.68095 .24287 L
.69048 .30714 L
.7 .2706 L
.70952 .32635 L
.71905 .27278 L
.72857 .21439 L
.7381 .20482 L
.74762 .25577 L
.75714 .31427 L
.76667 .34847 L
.77619 .33492 L
.78571 .41812 L
.79524 .46254 L
.80476 .44923 L
.81429 .27562 L
.82381 .20254 L
.83333 .24643 L
.84286 .19452 L
.85238 .12351 L
.8619 .14704 L
.87143 .20366 L
.88095 .17543 L
.89048 .28395 L
.9 .31392 L
.90952 .35783 L
.91905 .40414 L
.92857 .34377 L
.9381 .39361 L
.94762 .30749 L
.95714 .25196 L
.96667 .21417 L
Mistroke
.97619 .28021 L
Mfstroke
.2 0 1 r
gsave
.97619 .18605 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14719 m
.03333 .2168 L
.04286 .26295 L
.05238 .43647 L
.0619 .48259 L
.07143 .39991 L
.08095 .41775 L
.09048 .36946 L
.1 .37675 L
.10952 .38579 L
.11905 .29289 L
.12857 .26685 L
.1381 .33984 L
.14762 .36703 L
.15714 .2798 L
.16667 .19459 L
.17619 .19098 L
.18571 .14032 L
.19524 .23632 L
.20476 .36386 L
.21429 .39396 L
.22381 .34825 L
.23333 .31654 L
.24286 .33858 L
.25238 .32051 L
.2619 .29753 L
.27143 .35496 L
.28095 .37418 L
.29048 .34028 L
.3 .21613 L
.30952 .17425 L
.31905 .20824 L
.32857 .21821 L
.3381 .23424 L
.34762 .17232 L
.35714 .226 L
.36667 .25556 L
.37619 .34949 L
.38571 .29753 L
.39524 .32306 L
.40476 .37616 L
.41429 .29552 L
.42381 .31399 L
.43333 .34064 L
.44286 .28392 L
.45238 .33723 L
.4619 .3235 L
.47143 .38458 L
.48095 .3975 L
.49048 .28886 L
Mistroke
.5 .21501 L
.50952 .22427 L
.51905 .13656 L
.52857 .20248 L
.5381 .23323 L
.54762 .18684 L
.55714 .31398 L
.56667 .31817 L
.57619 .31089 L
.58571 .37005 L
.59524 .32309 L
.60476 .31388 L
.61429 .36099 L
.62381 .37576 L
.63333 .37923 L
.64286 .26367 L
.65238 .30047 L
.6619 .2423 L
.67143 .2182 L
.68095 .14691 L
.69048 .23553 L
.7 .23039 L
.70952 .26385 L
.71905 .32101 L
.72857 .33953 L
.7381 .36296 L
.74762 .44788 L
.75714 .42627 L
.76667 .38793 L
.77619 .27522 L
.78571 .27399 L
.79524 .24855 L
.80476 .21468 L
.81429 .20894 L
.82381 .21752 L
.83333 .23094 L
.84286 .31655 L
.85238 .42799 L
.8619 .41643 L
.87143 .33431 L
.88095 .34418 L
.89048 .39279 L
.9 .25822 L
.90952 .33665 L
.91905 .28984 L
.92857 .34362 L
.9381 .29623 L
.94762 .15884 L
.95714 .16794 L
.96667 .23259 L
Mistroke
.97619 .18605 L
Mfstroke
0 .4 1 r
gsave
.97619 .26295 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39097 m
.03333 .29565 L
.04286 .30488 L
.05238 .28096 L
.0619 .22964 L
.07143 .21192 L
.08095 .21947 L
.09048 .29126 L
.1 .26178 L
.10952 .28538 L
.11905 .33446 L
.12857 .37228 L
.1381 .36298 L
.14762 .38773 L
.15714 .34449 L
.16667 .38477 L
.17619 .31068 L
.18571 .2127 L
.19524 .28159 L
.20476 .30446 L
.21429 .3084 L
.22381 .2392 L
.23333 .22618 L
.24286 .2614 L
.25238 .21054 L
.2619 .17863 L
.27143 .17435 L
.28095 .30546 L
.29048 .30571 L
.3 .33554 L
.30952 .34513 L
.31905 .31749 L
.32857 .35282 L
.3381 .29691 L
.34762 .30086 L
.35714 .38939 L
.36667 .35375 L
.37619 .38389 L
.38571 .30071 L
.39524 .30459 L
.40476 .3049 L
.41429 .23562 L
.42381 .26165 L
.43333 .25428 L
.44286 .15781 L
.45238 .19806 L
.4619 .23042 L
.47143 .2698 L
.48095 .3274 L
.49048 .34859 L
Mistroke
.5 .29607 L
.50952 .21194 L
.51905 .14657 L
.52857 .17284 L
.5381 .34643 L
.54762 .41315 L
.55714 .33874 L
.56667 .3313 L
.57619 .25187 L
.58571 .2402 L
.59524 .23396 L
.60476 .30601 L
.61429 .29761 L
.62381 .26301 L
.63333 .32607 L
.64286 .33125 L
.65238 .38029 L
.6619 .31565 L
.67143 .33585 L
.68095 .29022 L
.69048 .33686 L
.7 .23185 L
.70952 .17644 L
.71905 .27814 L
.72857 .29927 L
.7381 .38531 L
.74762 .39128 L
.75714 .36397 L
.76667 .31433 L
.77619 .29026 L
.78571 .25379 L
.79524 .17764 L
.80476 .21771 L
.81429 .23861 L
.82381 .19145 L
.83333 .32268 L
.84286 .37362 L
.85238 .3716 L
.8619 .24682 L
.87143 .24332 L
.88095 .176 L
.89048 .20488 L
.9 .2592 L
.90952 .2788 L
.91905 .27994 L
.92857 .37453 L
.9381 .4037 L
.94762 .34728 L
.95714 .34458 L
.96667 .31173 L
Mistroke
.97619 .26295 L
Mfstroke
0 1 1 r
gsave
.97619 .24758 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14872 m
.03333 .17912 L
.04286 .21866 L
.05238 .30614 L
.0619 .31464 L
.07143 .34073 L
.08095 .42302 L
.09048 .36686 L
.1 .37098 L
.10952 .29104 L
.11905 .26133 L
.12857 .36402 L
.1381 .25842 L
.14762 .21909 L
.15714 .21868 L
.16667 .2585 L
.17619 .31334 L
.18571 .28665 L
.19524 .30784 L
.20476 .31634 L
.21429 .31309 L
.22381 .27023 L
.23333 .34809 L
.24286 .36976 L
.25238 .41802 L
.2619 .34987 L
.27143 .2899 L
.28095 .24191 L
.29048 .16011 L
.3 .12651 L
.30952 .20561 L
.31905 .21236 L
.32857 .29068 L
.3381 .37585 L
.34762 .38358 L
.35714 .38246 L
.36667 .2617 L
.37619 .30916 L
.38571 .30458 L
.39524 .25064 L
.40476 .22952 L
.41429 .26138 L
.42381 .32662 L
.43333 .359 L
.44286 .38993 L
.45238 .35548 L
.4619 .27919 L
.47143 .28795 L
.48095 .20424 L
.49048 .23183 L
Mistroke
.5 .27986 L
.50952 .28452 L
.51905 .288 L
.52857 .3067 L
.5381 .30607 L
.54762 .3388 L
.55714 .25238 L
.56667 .26649 L
.57619 .20892 L
.58571 .27758 L
.59524 .26988 L
.60476 .23117 L
.61429 .32111 L
.62381 .30489 L
.63333 .31094 L
.64286 .32959 L
.65238 .36208 L
.6619 .41086 L
.67143 .4177 L
.68095 .39079 L
.69048 .24762 L
.7 .18776 L
.70952 .16328 L
.71905 .2753 L
.72857 .25481 L
.7381 .25439 L
.74762 .20223 L
.75714 .295 L
.76667 .39381 L
.77619 .37252 L
.78571 .23975 L
.79524 .20366 L
.80476 .18109 L
.81429 .14169 L
.82381 .19717 L
.83333 .28147 L
.84286 .34894 L
.85238 .26646 L
.8619 .23938 L
.87143 .31011 L
.88095 .3546 L
.89048 .41836 L
.9 .36788 L
.90952 .28256 L
.91905 .26759 L
.92857 .24625 L
.9381 .25863 L
.94762 .32838 L
.95714 .38131 L
.96667 .33751 L
Mistroke
.97619 .24758 L
Mfstroke
0 1 .4 r
gsave
.97619 .32285 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15143 m
.03333 .05873 L
.04286 .03533 L
.05238 .01472 L
.0619 .10711 L
.07143 .12411 L
.08095 .14584 L
.09048 .25183 L
.1 .30671 L
.10952 .38363 L
.11905 .35104 L
.12857 .34503 L
.1381 .32371 L
.14762 .30146 L
.15714 .23829 L
.16667 .28079 L
.17619 .25936 L
.18571 .35038 L
.19524 .35596 L
.20476 .30388 L
.21429 .34093 L
.22381 .21744 L
.23333 .28531 L
.24286 .28435 L
.25238 .22682 L
.2619 .13019 L
.27143 .126 L
.28095 .28278 L
.29048 .25333 L
.3 .39021 L
.30952 .41721 L
.31905 .41176 L
.32857 .46266 L
.3381 .3649 L
.34762 .30087 L
.35714 .33362 L
.36667 .20838 L
.37619 .19377 L
.38571 .13366 L
.39524 .23206 L
.40476 .17116 L
.41429 .22543 L
.42381 .22461 L
.43333 .32298 L
.44286 .44129 L
.45238 .48122 L
.4619 .41767 L
.47143 .37112 L
.48095 .38118 L
.49048 .33082 L
Mistroke
.5 .29768 L
.50952 .20791 L
.51905 .27716 L
.52857 .30482 L
.5381 .26314 L
.54762 .19485 L
.55714 .29032 L
.56667 .25236 L
.57619 .23558 L
.58571 .26751 L
.59524 .32977 L
.60476 .35243 L
.61429 .33296 L
.62381 .25047 L
.63333 .28373 L
.64286 .34405 L
.65238 .30615 L
.6619 .23405 L
.67143 .24714 L
.68095 .20286 L
.69048 .23261 L
.7 .31147 L
.70952 .29506 L
.71905 .24639 L
.72857 .24081 L
.7381 .32726 L
.74762 .36673 L
.75714 .26733 L
.76667 .30869 L
.77619 .26673 L
.78571 .27911 L
.79524 .32281 L
.80476 .41042 L
.81429 .3312 L
.82381 .23642 L
.83333 .21798 L
.84286 .26743 L
.85238 .34306 L
.8619 .39215 L
.87143 .34455 L
.88095 .33948 L
.89048 .29817 L
.9 .33455 L
.90952 .33109 L
.91905 .28251 L
.92857 .28255 L
.9381 .23631 L
.94762 .23048 L
.95714 .21789 L
.96667 .24897 L
Mistroke
.97619 .32285 L
Mfstroke
.2 1 0 r
gsave
.97619 .22125 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26801 m
.03333 .37397 L
.04286 .39166 L
.05238 .45044 L
.0619 .50006 L
.07143 .47004 L
.08095 .38116 L
.09048 .27087 L
.1 .33258 L
.10952 .32856 L
.11905 .3076 L
.12857 .1927 L
.1381 .27128 L
.14762 .35707 L
.15714 .32673 L
.16667 .24124 L
.17619 .29872 L
.18571 .19364 L
.19524 .21785 L
.20476 .1872 L
.21429 .29887 L
.22381 .27305 L
.23333 .27664 L
.24286 .32567 L
.25238 .32002 L
.2619 .29191 L
.27143 .26424 L
.28095 .29149 L
.29048 .37343 L
.3 .35989 L
.30952 .34105 L
.31905 .24805 L
.32857 .2481 L
.3381 .23746 L
.34762 .29125 L
.35714 .39474 L
.36667 .31645 L
.37619 .25632 L
.38571 .26535 L
.39524 .22238 L
.40476 .30916 L
.41429 .3092 L
.42381 .26437 L
.43333 .27503 L
.44286 .33327 L
.45238 .30469 L
.4619 .24306 L
.47143 .36638 L
.48095 .43858 L
.49048 .38238 L
Mistroke
.5 .30836 L
.50952 .34708 L
.51905 .30393 L
.52857 .25986 L
.5381 .32669 L
.54762 .22531 L
.55714 .25182 L
.56667 .17969 L
.57619 .17797 L
.58571 .17604 L
.59524 .13956 L
.60476 .14882 L
.61429 .20199 L
.62381 .40666 L
.63333 .44865 L
.64286 .43428 L
.65238 .40175 L
.6619 .39436 L
.67143 .33865 L
.68095 .35548 L
.69048 .31902 L
.7 .2284 L
.70952 .23641 L
.71905 .29034 L
.72857 .36803 L
.7381 .22146 L
.74762 .19142 L
.75714 .26826 L
.76667 .24672 L
.77619 .20905 L
.78571 .20671 L
.79524 .24367 L
.80476 .23873 L
.81429 .18198 L
.82381 .27954 L
.83333 .3025 L
.84286 .29755 L
.85238 .27998 L
.8619 .3647 L
.87143 .32939 L
.88095 .29523 L
.89048 .24837 L
.9 .24076 L
.90952 .33904 L
.91905 .36209 L
.92857 .32541 L
.9381 .35611 L
.94762 .34149 L
.95714 .29296 L
.96667 .31145 L
Mistroke
.97619 .22125 L
Mfstroke
.8 1 0 r
gsave
.97619 .37064 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19792 m
.03333 .21508 L
.04286 .26733 L
.05238 .29585 L
.0619 .34566 L
.07143 .37728 L
.08095 .4272 L
.09048 .35711 L
.1 .38747 L
.10952 .38473 L
.11905 .36821 L
.12857 .36439 L
.1381 .3121 L
.14762 .2984 L
.15714 .33387 L
.16667 .25364 L
.17619 .16624 L
.18571 .25545 L
.19524 .26809 L
.20476 .22256 L
.21429 .25498 L
.22381 .30993 L
.23333 .31269 L
.24286 .35986 L
.25238 .35724 L
.2619 .32396 L
.27143 .26799 L
.28095 .26043 L
.29048 .18178 L
.3 .22064 L
.30952 .25926 L
.31905 .22701 L
.32857 .30305 L
.3381 .35741 L
.34762 .40657 L
.35714 .42984 L
.36667 .39206 L
.37619 .40574 L
.38571 .24182 L
.39524 .2512 L
.40476 .2067 L
.41429 .25498 L
.42381 .20422 L
.43333 .18068 L
.44286 .246 L
.45238 .25886 L
.4619 .27055 L
.47143 .338 L
.48095 .26261 L
.49048 .39663 L
Mistroke
.5 .42836 L
.50952 .4449 L
.51905 .46712 L
.52857 .40303 L
.5381 .34634 L
.54762 .33996 L
.55714 .27053 L
.56667 .2865 L
.57619 .26936 L
.58571 .27422 L
.59524 .1987 L
.60476 .14514 L
.61429 .13211 L
.62381 .25982 L
.63333 .23896 L
.64286 .33789 L
.65238 .26006 L
.6619 .29637 L
.67143 .25114 L
.68095 .32698 L
.69048 .28196 L
.7 .26647 L
.70952 .30392 L
.71905 .30974 L
.72857 .35936 L
.7381 .28354 L
.74762 .34204 L
.75714 .26794 L
.76667 .25683 L
.77619 .15351 L
.78571 .19612 L
.79524 .28933 L
.80476 .26303 L
.81429 .28386 L
.82381 .33472 L
.83333 .35916 L
.84286 .40469 L
.85238 .33491 L
.8619 .28351 L
.87143 .2157 L
.88095 .25545 L
.89048 .19537 L
.9 .25932 L
.90952 .25647 L
.91905 .22656 L
.92857 .23186 L
.9381 .34868 L
.94762 .38318 L
.95714 .40573 L
.96667 .33463 L
Mistroke
.97619 .37064 L
Mfstroke
1 .6 0 r
gsave
.97619 .34896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43534 m
.03333 .47387 L
.04286 .55215 L
.05238 .52855 L
.0619 .60332 L
.07143 .59178 L
.08095 .55272 L
.09048 .46059 L
.1 .30089 L
.10952 .19549 L
.11905 .22797 L
.12857 .2185 L
.1381 .15866 L
.14762 .23482 L
.15714 .24216 L
.16667 .2719 L
.17619 .29188 L
.18571 .25977 L
.19524 .2069 L
.20476 .26694 L
.21429 .26775 L
.22381 .3723 L
.23333 .35155 L
.24286 .32944 L
.25238 .33637 L
.2619 .34042 L
.27143 .2863 L
.28095 .28865 L
.29048 .20233 L
.3 .22093 L
.30952 .22925 L
.31905 .32639 L
.32857 .28645 L
.3381 .35656 L
.34762 .28435 L
.35714 .19197 L
.36667 .25056 L
.37619 .30675 L
.38571 .40535 L
.39524 .34935 L
.40476 .32382 L
.41429 .3709 L
.42381 .35488 L
.43333 .32945 L
.44286 .19902 L
.45238 .28516 L
.4619 .34339 L
.47143 .35224 L
.48095 .33639 L
.49048 .26171 L
Mistroke
.5 .25815 L
.50952 .24971 L
.51905 .23891 L
.52857 .26063 L
.5381 .29248 L
.54762 .35552 L
.55714 .34177 L
.56667 .27435 L
.57619 .31592 L
.58571 .28648 L
.59524 .33699 L
.60476 .3859 L
.61429 .32969 L
.62381 .32779 L
.63333 .28592 L
.64286 .29677 L
.65238 .3061 L
.6619 .28177 L
.67143 .22502 L
.68095 .19559 L
.69048 .22464 L
.7 .1737 L
.70952 .21868 L
.71905 .27834 L
.72857 .23729 L
.7381 .28267 L
.74762 .38212 L
.75714 .38782 L
.76667 .29784 L
.77619 .34596 L
.78571 .33815 L
.79524 .25893 L
.80476 .28059 L
.81429 .35599 L
.82381 .37118 L
.83333 .38251 L
.84286 .34739 L
.85238 .27509 L
.8619 .15206 L
.87143 .23687 L
.88095 .25749 L
.89048 .2782 L
.9 .3084 L
.90952 .26879 L
.91905 .19378 L
.92857 .1931 L
.9381 .24557 L
.94762 .23406 L
.95714 .18617 L
.96667 .21659 L
Mistroke
.97619 .34896 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`005Oooool2o`0002_ooooo1Ol00003ooooo`;o0000:Oooool3o`0000?ooooo0_l0000Yoooo
o`?o00001?ooool2o`0002Sooooo0ol00004ooooo`;o00009_ooool3o`0000Cooooo0_l00004oooo
o`;o00001?ooool001Cooooo00Co0000oooooooooooo0000:oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0002Wooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo02Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
02Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0002Kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?o
oooo000Dooooo`04o`000?ooooooooooo`0002cooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool0000Vooooo`Go00000_ooool01?l0003oooooooooool0000Wooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Vooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00003ooooo`005?ooool01?l0003oooooooooool0
000]ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`0Tooooo`04o`00
0?ooooooooooo`0000?ooooo00Co0000oooooooooooo00009oooool4o`0000?ooooo00Co0000oooo
oooooooo00009oooool3o`0000?ooooo00Co0000oooooooooooo00009_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool001Cooooo
00Co0000oooooooooooo0000:_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00009oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0002Oooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Vooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00003ooooo`005?ooool01?l0003oooooooooool0
000Zooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Xooooo`;o
00000oooool01?l0003oooooooooool0000Xooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00009_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
9Oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00003oooo
o`005Oooool2o`0002cooooo0ol00004ooooo`;o0000:_ooool00ol0003oooooooooo`02ooooo`;o
0000:_ooool2o`0000Cooooo0_l0000Xooooo`?o00001?ooool2o`0002Oooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00004ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJ
ooooo`00oooooolJooooo`004?ooooooo`0000Ko00001?ooool0013ooooo0_l00004ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`;o0000
1?ooool0013ooooo00?o0000ooooooooool0ooooool2ooooo`03o`000?oooooooooo00;ooooo0008
ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`;ooooo00?o0000ooooooooool00_ooool0
00Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00_ooooo00?o0?mV
ooooooooool0loooool00ol0003oooooooooo`02ooooo`0000?oooooo`000?l000000ol00005oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02oooool00ol0ofKoooooooooo`3coooo
o`03o`000?oooooooooo00;ooooo0009ooooo`;o00001Oooool3o`0000[ooooo0_l0ofKcooooo`?o
00001?ooool000_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`3o
I_oooooo0?mV0?Gooooo00?o0000ooooooooool00_ooool000Oooooo00Go0000oooooooooooooooo
o`000004ooooo`03o`000?oooooooooo00Wooooo00?o0?mVooooool0ofH0mOooool00ol0003ooooo
ooooo`02ooooo`002?ooool3o`0000Gooooo00?o0000ooooooooool02?ooool01?l0ofKooooooooo
ool0ofKeooooo`03o`000?oooooooooo00;ooooo000@ooooo`;o00002Oooool01?l0ofKooooooooo
ool0ofKdooooo`;o00001?ooool0013ooooo00?o0000ooooooooool01oooool00ol0ofKooooooooo
o`02ooooo`03o`3oI_oooooooooo0?;ooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000
ooooooooool01oooool00ol0ofKoooooooooo`02ooooo`03o`3oI_oooooooooo0?;ooooo00?o0000
ooooooooool00_ooool0013ooooo00?o0000ooooooooool01oooool00ol0ofKoooooooooo`02oooo
o`03o`3oI_oooooooooo0?;ooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000oooooooo
ool01_ooool00ol0ofKoooooooooo`03ooooo`03o`3oI_oooooooooo0?;ooooo00?o0000oooooooo
ool00_ooool0013ooooo0_l00007ooooo`03o`3oI_oooooooooo00?ooooo00?o0?mVooooooooool0
lOooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00Kooooo00?o0?mVooooooooool00ooo
ool00ol0ofKoooooooooo`3booooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooo
oooo00Kooooo00?o0?mVooooooooool00oooool00ol0ofKoooooooooo`3booooo`03o`000?oooooo
oooo00;ooooo000@ooooo`03o`000?oooooooooo00Kooooo00?o0?mVooooooooool00oooool00ol0
ofKoooooooooo`3booooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Ko
oooo00?o0?mVooooooooool00oooool00ol0ofKoooooooooo`3booooo`03o`000?oooooooooo00;o
oooo000@ooooo`;o00001_ooool00ol0ofKoooooooooo`04ooooo`03o`3oI_oooooooooo0?7ooooo
0_l00004ooooo`004?ooool00ol0003oooooooooo`05ooooo`03o`3oI_oooooooooo00Cooooo00?o
0?mVooooooooool0l_ooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`05
ooooo`03o`3oI_oooooooooo00Cooooo00?o0?mVooooooooool0l_ooool00ol0003oooooooooo`02
ooooo`004?ooool00ol0003oooooooooo`05ooooo`03o`3oI_oooooooooo00Gooooo00?o0?mVoooo
ooooool0lOooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Kooooo00?o0?mVoooooooo
ool01Oooool00ol0ofKoooooooooo`3`ooooo`;o00001?ooool0013ooooo00?o0000ooooooooool0
1Oooool00ol0ofKoooooooooo`05ooooo`03o`3oI_oooooooooo0?7ooooo00?o0000ooooooooool0
0_ooool000Oooooo1Ol00004ooooo`03o`000?oooooooooo00Gooooo00?o0?mVooooooooool01Ooo
ool00ol0ofKoooooooooo`3aooooo`03o`000?oooooooooo00;ooooo0008ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool01Oooool00ol0ofKoooooooooo`05ooooo`03o`3oI_oo
oooooooo0?7ooooo00?o0000ooooooooool00_ooool00003ooooool0003o000000?o00000oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0?mVooooooooool01_ooool0
0ol0ofKoooooooooo`3aooooo`03o`000?oooooooooo00;ooooo000:ooooo`03o`000?oooooooooo
00?ooooo0ol00004ooooo`03o`3oI_oooooooooo00Kooooo00?o0?mVooooooooool0koooool3o`00
00Cooooo0007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`04oooo
o`03o`3oI_oooooooooo00Oooooo00?o0?mVooooooooool0?oooool00oo<0?ooooooooooo`2^oooo
o`03o`000?oooooooooo00;ooooo0007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0
003oooooooooo`04ooooo`03o`3oI_oooooooooo00Sooooo00?o0?mVooooooooool0?_ooool00oo<
0?ooooooooooo`2^ooooo`03o`000?oooooooooo00;ooooo0008ooooo`?o00001Oooool00ol0003o
ooooooooo`04ooooo`03o`3oI_oooooooooo00Wooooo00?o0?mVooooooooool0?Oooool00oo<0?oo
ooooooooo`28ooooo`03ol`0oooooooooooo02?ooooo00?o0000ooooooooool00_ooool0013ooooo
00?o0000ooooooooool01?ooool00ol0ofKoooooooooo`04ooooo`03ool0VOoooooooooo00;ooooo
00?o0?mVooooooooool0<?ooool2o`3oIPKooooo00Co0?oooooooooooooooooo0_o<0?n:ooooo`03
ol`0oooooooooooo02?ooooo00?o0000ooooooooool00_ooool0013ooooo0_l00005ooooo`03o`3o
I_oooooooooo00Cooooo00?oo`2Iooooooooool00oooool00ol0ofKoooooooooo`0]ooooo`;o0?mV
00?oooooo`3oI_ooool01Oooool01?l0ooooooooooooooooool2ol`0odcooooo00?oc?l0oooooooo
ool0>oooool2ol`0ob?ooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`04ooooo`03o`3o
I_oooooooooo00Cooooo00?oo`2Iooooooooool00oooool00ol0ofKoooooooooo`0]ooooo`04o`3o
I_ooooooooooo`3oIPGooooo0_l0ool3ooooo`;oc03o4?ooool00ol0ofKoooooooooo`0Pooooo`03
oc<0oooooooooooo01Kooooo00?oc?l0ooooooooool0>oooool2ol`0obCooooo00?o0000oooooooo
ool00_ooool0013ooooo00?o0000ooooooooool00oooool00ol0ofKoooooooooo`05ooooo`;oo`2I
1?ooool00ol0ofKoooooooooo`0Iooooo`03oc<0oooooooooooo017ooooo00Co0?mVoooooooooooo
0?mV1Oooool2o`3oo`?ooooo0_o<0?l@ooooo`03o`3oI_oooooooooo023ooooo00?o<`3ooooooooo
ool04Oooool01?lco`3oooooooooooooool2olco03cooooo00?oc03oooooooo<0?l09?ooool00ol0
003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`03o`3oI_oooooooooo00Go
oooo0_oo09T5ooooo`03o`3oI_oooooooooo01Sooooo00?o<`3oooooooooool04Oooool01?l0ofKo
ooooooooool0ofH5ooooo`;o0?oo0_ooool00oo<0?oooooool`0o`0@ooooo`03o`3oI_oooooooooo
023ooooo00?o<`3oooooooooool04Oooool01_lco`3oooooooooooo<o`3oooooolco03?ooooo00?o
0?ooooooooooool01_ooool01?o<0?ooooooooooooo<0?lSooooo`03o`000?oooooooooo00;ooooo
000@ooooo`;o00001?ooool00ol0ofKoooooooooo`04ooooo`03ool0VOooooooo`2I00Gooooo00?o
0?mVooooooooool06?ooool00olc0?ooooooooooo`0Aooooo`04o`3oI_ooooooooooo`3oIPCooooo
00?o0?ooooooool0ool00_ooool01?o<0?ooooooooooooo<0?l?ooooo`03o`3oI_oooooooooo023o
oooo00?o06Koooooooooool04Oooool2oc?o0004olco0?ooooooooooolco013ooooo00?o<`3ooooo
ooooool08?ooool00ol0ooooooooooooo`06ooooo`04ol`0oooooooooooool`0ob;ooooo0_l00004
ooooo`004?ooool00ol0003oooooooooo`03ooooo`03o`3oI_oooooooooo00Cooooo00?oo`2Ioooo
oooo09T01Oooool00ol0ofKoooooooooo`0Hooooo`03oc<0oooooooooooo017ooooo00Co0?mVoooo
oooooooo0?mV1?ooool01_l0ooooooooooooool0oooooooool`0o`;ooooo00?oc03oooooooooool0
3Oooool00ol0ofKoooooooooo`0Pooooo`03o`1Voooooooooooo013ooooo00Co<ol0oooooooooooo
c?l00_ooool00oo<o`3oooooooooo`0>ooooo`03oc<0oooooooooooo023ooooo00?o0?oooooooooo
ool01_ooool01?o<0?ooooooooooooooV@0Sooooo`03o`000?oooooooooo00;ooooo000@ooooo`03
o`000?oooooooooo00?ooooo00?o0?ooooooooooool01?ooool01?oo09Wooooooooooooo09T4oooo
o`03o`3oI_oooooooooo01Oooooo0_lc0?lCooooo`04o`3oI_ooooooooooo`3oIPCooooo00Ko0?oo
oooooooooooo0?ooooooooo<0?l2ooooo`03ol`0oooooooooooo00cooooo00?o0?mVooooool0ofH0
8?ooool00olc0?oo06Kooc<0o`0Aooooo`04oc?o0?ooooooooooolco00;ooooo00?oc?l0oooooooo
ool03_ooool00olc0?ooooooooooo`0;ooooo`;oo`2I2Oooool00oo<o`3oooooooooo`06ooooo`;o
0?oo2?ooool01?o<0?ooooooooooooooV@0Sooooo`03o`000?oooooooooo00;ooooo000@ooooo`03
o`000?oooooooooo00?ooooo00?o<`3oo`3oooooool01?ooool01?oo09Wooooooooooooo09T4oooo
o`03o`3oI_oooooooooo00cooooo00?ooiT0ooooooooool02?ooool00olc0?oooooooc<0o`0Aoooo
o`05o`3oI_ooooooooooooooool0ofH00oooool01_l0oooooooooooooooooooo0?oool`0o`?ooooo
00?oc03oooooooooool03?ooool00ol0ofKoo`2Io`3oIP0=ooooo`03o`1Voooooooooooo013ooooo
00?o<`3oo`1Vool0I_l03Oooool01Oo<0?oooooooooooooooooo<ol000;ooooo00Coc?l0oooooooo
ooooc?l04?ooool00olc0?ooooooooooo`0:ooooo`03ool0VOooooooo`2I00Wooooo00?oc?l0oooo
ooooool01_ooool00ol0ooooooooo`3oo`07ooooo`04ol`0oooooooooooooonI01Gooooo00?o<`3o
ooooooooool02oooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03oooo
o`03ool00?l0oooooooo00Cooooo00Coo`2Iooooooooooooo`2I1?ooool00ol0ofKoooooooooo`0<
ooooo`03oonI0?oooooooooo00Sooooo00?o<`3ooooooolc0?l04Oooool01Ol0ofKooooooooooooo
oooo0?mV00?ooooo00Ko0?ooooooooooooooooooo`3oooo<0?l3ooooo`03ol`0oooooooooooo00co
oooo00?o0?mVool0VOl0ofH03Oooool00ol0I_ooooooooooo`0@ooooo`03o`1Voooooooo06Ko00go
oooo00Coc03ooooooooooooo<ol00_ooool01Oo<o`3ooooooc?o0?ooooooc?l000oooooo0_lc0?l6
ooooo`03o`3ooooooooooooo00;ooooo00Coo`2Iooooooooooooo`2I2Oooool00oo<o`3ooooooooo
o`06ooooo`03o`3ooooooooo0?oo00Kooooo00Goc03ooooooooooooooooooonI000Eooooo`;o<`3o
3?ooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Cooooo00?oo`00oc<0ool0ool01?oo
ool01?oo09Wooooooooooooo09T5ooooo`03o`3oI_oooooooooo00_ooooo00?ooiT0ooooooooool0
1_ooool01Ooo003oc?l0oc<0oooooooo<`3o017ooooo00Go0?mVooooooooooooooooo`3oIP03oooo
o`06o`3oooooooooooooooooool0ooooc03o0oooool00oo<0?ooooooooooo`0<ooooo`03o`3oI_oo
09Wo0?mV00gooooo00?o06Koooooooooool04?ooool00ol0I_ooooooo`1Vo`0=ooooo`04ol`0oooo
oooooooooc?o00;ooooo00?oc?l0oooooolco`000_ooool00oo<o`3oooooooooo`0<ooooo`;o<`3o
1_ooool00ol0ooooooooooooo`02ooooo`04ool0VOooooooooooool0V@Wooooo00?oc?l0oooooooo
ool01Oooool01?l0ooooooooooooool0ool6ooooo`06ol`0ooooooooooooooooooooV@3oc03o5?oo
ool00olc0?oooooooc<0o`0:ooooo`;o00001?ooool0013ooooo00?o0000ooooooooool00oooool0
0ooo003o<`3oo`3oo`04ooooo`04ool0VOooooooooooool0V@Gooooo00?o0?mVooooooooool02ooo
ool00oooV@3oooooooooo`05ooooo`06ool00?ooooooc?l0oc<0oooooooo<`3o4Oooool00ol0ofKo
ooooooooo`02ooooo`04o`3oI_ooooooooooo`3oo`?ooooo00?o0?oool`0ooooool00_ooool00oo<
0?ooooooooooo`0<ooooo`03o`3oI_oo09Wo0?mV00?ooooo00?o0?mVooooooooool01oooool2o`1V
oa7ooooo00Co06Kooooooolc0?oo06Ko3?ooool01?o<0?oooooooooooolco`02ooooo`03olco0?oo
oooo<ol000;ooooo00?oc?l0ooooooooool03?ooool2oc<0o`Kooooo00?o0?ooooooooooool00_oo
ool01Ooo09Woooooooooooooooooo`2I00Sooooo0_o<o`06ooooo`04o`3oooooooooooooo`3oo`Ko
oooo00Koc03ooooooooooooooooooonI0?o<0?lDooooo`04oc<0oooooooooooooc<0o`[ooooo00?o
0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool00oooool00ooo003o<`3oo`3oo`03
ooooo`05ool0VOoooooooooooooooooo09T01Oooool00ol0ofKoooooooooo`0:ooooo`;ooiT01_oo
ool01ooo003oooooooooooo<o`3o<`3ooooooolc0?l04Oooool00ol0ofKoooooooooo`02o`1Vo`04
o`3oI_ooooooooooo`3oo`?ooooo00?o0?oooc<0ooooool00_ooool00oo<0?ooooooooooo`03oooo
o`03oc<0oooooooooooo00Kooooo00?o0?mVool0VOl0ofH00oooool00ol0ofKoooooooooo`07oooo
o`;o06Ko4Oooool01?l0I_oooooooc<0ool0I_l;ooooo`;oc03o00?ooooooc?o0?ooool00_ooool0
0oo<o`3ooooooc?o0002ooooo`03olco0?oooooooooo00cooooo00?o<`3ooooooolc0?l00oooool0
0oooV@3o0?ooo`3oo`04ooooo`05ool0VOoooooooooooooooooo09T01oooool00oo<o`3oooooolco
0006ooooo`04o`3oooooooooooooo`3oo`Kooooo00Coc03oooooooooooooo`000_ooV@03ooooo`03
ol`0oooooooooooo00kooooo00Co<`3ooooooooooooo<`3o2_ooool00ol0003oooooooooo`02oooo
o`004?ooool00ol0003oooooooooo`03ooooo`04ool00?lc0?ooooooo`3oo`;ooooo00Goo`2Ioooo
ooooooooooooool0V@05ooooo`03o`3oI_oooooooooo00[ooooo0_ooV@06ooooo`07ool00?oooooo
ooooolco0?lc0?oooooooc<0o`0Aooooo`06o`3oI_l0I_oo06Koooooool0I_oo0?mV0_ooool01_l0
oooooooooooooooooooo0?oooc<0o`?ooooo00?oc03oooooooooool00oooool00olc0?oooooooooo
o`06ooooo`04o`3oI_oo09Wo0?mVool0V@;ooooo00?o0?mVooooooooool01oooool2o`1Voa7ooooo
00Co06Kooooooolc0?oo06Ko2oooool4oc?o00?ooooo00Koc?l0oooooooooooo<ol0ooooooo<o`0>
ooooo`03oc<0oooooooo<`3o00?ooooo00?ooiT0o`3oool0ool00oooool00ooo09Woooooooooo`02
ooooo`03ool0VOoooooooooo00Gooooo00?oc?l0ooooooo<o`000oooool00ol0I_ooooooo`3oo`03
ooooo`03o`3ooooooooooooo00Cooooo00Coc03oooooooooooooo`000_ooV@03ooooo`03o`1Voooo
oooooooo00kooooo00Co<`3ooooooooooooo<`3o2_ooool00ol0003oooooooooo`02ooooo`004?oo
ool00ol0003oooooooooo`03ooooo`04ool00?lc0?ooooooo`3oo`;ooooo00Goo`2Ioooooooooooo
ooooool0V@05ooooo`03o`3oI_oooooooooo00[ooooo00?ooiT0ooooooooV@001Oooool01?oo003o
ooooooooooo<o`02ooooo`03oc<0oooooooooooo00oooooo00Wo0?mVo`1Vooooooooooooo`1Vool0
ofKoooooo`3oooo<o`000oooool00ol0oooo<`3ooc<0o`02ooooo`03ol`0oooooooooooo00?ooooo
00?o<`3oooooooooool01Oooool01Ol0ofKoo`2Iooooool0ofKoo`2I00;ooooo0_l0ofH6ooooo`05
olco0?oooooo06Koooooool0I_l03Oooool2ool0V@05o`1Voooooooooooooc<0ool0I_l02Oooool2
oc?o0003ol`0ooooooooc03o00Cooooo00Koc?l0oooooooooooo<ol0ooooooo<o`0>ooooo`03oc<0
oooooooo<`3o00?ooooo00?ooiT0o`3oool0ool00oooool00ooo09Woooooooooo`02ooooo`03ool0
VOoooooooooo00Gooooo00?oc?l0ooooooo<o`000oooool00ol0I_ooooooo`3oo`02ooooo`03oc?o
0?l0oooooooo00Gooooo00Coc03oooooooooooooo`000_ooV@02ooooo`03ol`0ool0I_oooooo00oo
oooo00Co<`3ooooooooooooo<`3o2_ooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Go
oooo00?oo`00oc<0ool0ool00_ooool00ooo09Woooooooooo`02ooooo`03ool0VOoooooooooo00;o
oooo00?o0?mVooooooooool02_ooool00oooV@3ooooooonI0005ooooo`07ool00?ooooooc?l0olco
0?oo003ooooooc<0o`0Aooooo`09o`3oI_l0I_ooooooooooool0I_oo0?mVooooool0ooooc?l000?o
oooo00?o0?oooc<0oolc0?l00_ooool00oo<0?ooooooooooo`03ooooo`;o<`3o1_ooool01Ol0ofKo
o`2Ioooooooooooo0?mV00;ooooo0_l0ofH6ooooo`05olco0?l0I_ooooooooooool0I_l03?ooool0
1?oo09Woooooool0VOl0I_l2ooooo`03oc<0ool0I_oooooo00?ooooo00?o<`3oooooooooool00_oo
ool01Olco`3ooooool`0ooooooooc03o00Cooooo00Koc?l0oooooooooooo<ol0ooooooo<o`0=oooo
o`04oc<0oooooooooooooc<0o`;ooooo0_ooV@000ooo003o06Koo`3oo`02ooooo`03ool0VOoooooo
oooo00;ooooo00?oo`2Iooooooooool01Oooool00oo<o`3oooooolco0003ooooo`03o`1Voooooooo
0?oo00;ooooo00?o<ol0ooooool0ool01?ooool01oo<0?oooooooooooooo003ooiT0ool00?ooV@00
0_ooool00oo<0?oo06Koooooo`0?ooooo`04oc<0oooooooooooooonI00Cooooo00?o<`3ooooooooo
ool00_ooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00Cooooo00?oo`00oc<0ool0ool0
0_ooool00ooo09Woooooooooo`02ooooo`03ool0VOoooooooooo00;ooooo00?o0?mVooooooooool0
2_ooool00oooV@3ooooooonI0004ooooo`03ool00?oooooooooo00;oc?l000Coo`00oooooooooooo
<`3o0_ooool00olco`3oooooooooo`0;ooooo`09o`3oI_ooooooooooooooool0I_oo0?mVooooool0
ooooc?l000?ooooo00?o<`3oo`3ooolc0?l00_ooool00oo<0?ooooooooooo`03ooooo`;o<`3o1_oo
ool02Ol0ofKoo`2Ioooooooooooo0?mVool0VOl0ofKoooooo`3oIP05ooooo`;oc?l000Co06Kooooo
oooooooo06Ko3?ooool01?oo09Woooooool0VOl0I_l3ooooo`03o`1Voooooooooooo00;ooooo00?o
<`3oooooooooool00_ooool01Olco`3ooooool`0ooooooooc03o00?ooooo00Ooc?l0oooooooooooo
oooooc?o0?ooooooc?l000gooooo00Co<`3ooooooooooooo<`3o0_ooool01OooV@3o0?oooonI0?l0
I_oo0?oo00;ooooo00?oo`2Iooooooooool00_ooool00ooo09Woooooooooo`05ooooo`04olco0?oo
ooooooooolco00;ooooo00?o06Koo`3oooooool00_ooool00olco`3oooooo`3oo`04ooooo`07ol`0
ooooooooooooool00?ooV@3oo`00oonI0002ooooo`03ol`0ool0I_oo06Ko00oooooo00Go<`3ooooo
oooooooooiT0oc<0o`03ooooo`03oc<0oooooooooooo00?ooooo00?o0000ooooooooool00_ooool0
00Sooooo0ol00005ooooo`03o`000?oooooooooo00Cooooo00Koo`00oc<0oooooooo0?oooooooooo
09T4ooooo`03ool0VOoooooooooo00;ooooo00?o0?mVooooooooool02?ooool01Olco`3ooiT0oooo
oooooooooiT000Cooooo00Woo`00oc<0oolc0?ooc?l0oc<0ooo<o`3o<ol0oooooolc0?l00_ooool0
0olco`3oooooooooo`0;ooooo`08o`3oI_ooooooooooooooool0I_oo0?mVooooool0ool2olco00;o
oooo00Ko<`3oo`3ooooooooo<`3oooooooo<0?l4ooooo`05oc<0oooooooo<`3oooooooooV@001?oo
ool02Ol0ofKoo`2Iool00?oooooo0?mVool0VOl0ofKoo`00o`3oIP05ooooo`;oc?l000Go06Kooooo
ooooooooooooo`1Vo`0;ooooo`04ool0VOooooooo`2Io`1Vo`?ooooo00?o06Koooooooooool00_oo
ool00olc0?ooooooooooo`02ooooo`05oc?o0?o<0?ooooooooooooo<0?l00oooool01oo<o`3ooooo
oooooooooooo<ol0ooooooo<o`003Oooool01?lc0?oooooooooooolc0?l2ooooo`05oonI0?l0oooo
oiT0o`1Vool0ool00_ooool00ooo09Woooooooooo`03ooooo`03oc?o0?oooooooooo00Cooooo00So
c?l0ooooooooooooc?l0ooooool0I_ooooooo`3oo`;ooooo0_lco`000ooooooo0?ooooooo`03oooo
o`07ol`0ooooooooooooool00?ooV@3ooooooonI0002ol`0o`03o`1Vooo<0?oo06Ko00Sooooo0ooo
V@04ooooo`05oc<0oooooooooooooonI0?lc0?l00oooool00olc0?ooooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo0009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00ooo
ool01oo<o`3oo`00oc<0oooooooo0?oooooooooo09T01?ooool00ooo09Woooooooooo`02ooooo`03
o`3oI_oooooooooo00?ooooo00?ooiT0ooooooooool00_ooool01Olco`3ooiT0oooooooo003ooiT0
00Cooooo00Woo`00oc<0ooooooooc?l0ooooooo<o`3o<ol0oooooolc0?l00_ooool00olco`3ooooo
ooooo`0;ooooo`08o`3oI_ooooooooooooooool0I_oo0?mVooooool0ool2olco00;ooooo00Ko<`3o
o`3ooooooooo<`3oooooooo<0?l4ooooo`05oc<0ooo<0?oo<`3oooooooooV@001?ooool02Ol0ofKo
o`2Iool00?oooooo0?mVool0VOl0ofKoo`00o`3oIP04ooooo`04olco0?ooooooc?l0o`1Vo`?ooooo
00?o06Koooooooooool02?ooool01Ooo09Wooooooooooooo09Wo06Ko00?ooooo00?o06Kooooooooo
ool00_ooool00ol0ofKoooooooooo`02ooooo`05oc?o0?o<0?ooooooooooooo<0?l00oooool00oo<
o`3oooooooooo`02ooooo`03oc?o0?o<o`3ooooo00cooooo00Co<`3oooooooooV@3o<`3o0_ooool0
1oooV@3o0?oooonI0?oooooo0?oooooooooo09T01_ooool00olco`3oooooooooo`04ooooo`08olco
0?ooooooooooolco0?oooooo06Koooooool0ool2ooooo`;o<ol000?oooooo`3oooooool00oooool0
1oo<0?oooooooooooooo003ooiT0ooooooooV@000_o<0?l01?l0I_ooc03oo`1Vooo<o`04ooooo`06
ool0VOoooooooooooonI0?oooooooiT00oooool01_lc0?ooooooooooooooV@3ooooooonI00;ooooo
00?o<`3oooooooooool01?ooool00ol0003oooooooooo`02ooooo`0000?oooooo`000?l000000ol0
0003ooooo`03o`000?oooooooooo00Cooooo0ol00003ooooo`07olco0?oo003o<`3oooooool0oooo
ooooool0V@04ooooo`03ool0VOoooooooooo00?ooooo00?o0?mVooooooooool00_ooool00oooV@3o
ooooooooo`02ooooo`05oc?o0?ooV@3oooooool00?ooV@001?ooool01_oo003o<`3oooooooo<o`3o
ooooolco00;o<ol000Co<`3ooooooolco`3o<ol03Oooool02_l0ofKooooooooooooooooo06Koo`3o
I_oooooo0?oooonI0?o<o`02ooooo`04oc<0ool0oooooooooc<0o`;ooooo00Woc03ooooooooooooo
oooooc<0ooo<0?oo<`3oooooooooV@000oooool02ol0ofKoooooool0VOooooooo`00o`3oI_oo09Wo
0?mVool00?oooooo0?mV00?ooooo00Goc?l0ooooooooooooc?l0oonI0002ooooo`03o`1Voooooooo
oooo00Sooooo00Goo`2Iooooooooooooo`2Io`1Vo`03ooooo`06o`1Voooooooooooooooooolc0?oo
0?mV0oooool00olco`3ooooool`0o`02ooooo`05ol`0ooooooooooooooooooo<o`001?ooool00olc
o`3oc?l0ooooo`0<ooooo`0=oc<0oooooooooiT0oc<0oooooooooiT0o`3ooooo003ooiT0ooooool0
ooooooooool0V@06ooooo`03oc?o0?oooooooooo00Cooooo00Soc?l0ooooooooooooc?l0ooooool0
I_oo0?ooo`1Vo`;ooooo0_lco`000ooooooo0?ooooooo`03ooooo`07ol`0ooooooooo`00oooooooo
V@3ooooooonI0002ol`0o`04o`1Vooo<0?ooooooolco00Cooooo00Koo`2IoooooooooooooiT0oooo
ooooV@03ooooo`06oc<0oooooooooooooonI0?oooooooiT00_ooool00olc0?ooooooooooo`02oooo
o`?o00001?ooool000Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`05
olco0?lc0?ooooooo`3ooooo09T01Oooool00ooo09Woooooooooo`03ooooo`03o`3oI_oooooooooo
00;ooooo0_ooV@03ooooo`05oc?o0?ooV@3oooooool00?ooV@001?ooool01_oo003o<`3oooooooo<
o`3oooooolco00;o<ol000Co<`3ooooooolco`3o<ol03Oooool03Ol0ofKooooooooooooooooo06Ko
o`3oI_ooooooc?l0oonI0?ooooooc?l0oooooolc0?l00_l0ool01?oooooo<`3oooooooo<0?l3oooo
o`05oc<0ooo<0?oooooooc<0ooooV@000_ooool03?l0ofKoooooool00?oo09Woooooool00?l0ofKo
o`2Io`3oI_oo003oooooo`3oIP;ooooo00Koc?l0ooooooooooooooooolco0?ooV@02ooooo`03o`1V
oooooooooooo00Cooooo00Go0?ooooooooooooooooooool0V@02ooooo`03o`1Voolc0?oooooo00;o
oooo00Ko<`3oo`1Voooooooooooooc<0ool0ofH3ooooo`03oc?o0?ooooooc03o00;ooooo00Goc03o
ooooooooooooooooolco0004ooooo`03oc?o0?o<o`3ooooo00cooooo00go<`3ooonI0?ooV@3o<`3o
ooooooooV@3o0?ooool00?ooV@3oooooo`3oooooooooo`2I00Cooooo00?oc03ooc?o0?lco`001_oo
ool02?o<o`3oooooooooooo<o`3oooooo`1Vool0oooo06Ko0_ooool2oc?o0003ooooool0oooooooo
00?ooooo00goc03ooooooooo003ooooooonI0?oooooooiT0ol`0oooooooo06Koooooooo<0?ooc?l0
00Cooooo00Coo`2IoooooooooooooiT00_ooool01?ooV@3ooooooooooolc0?l2ooooo`03oonI0?oo
oooooiT000;ooooo00?o<`3oooooooooool01?ooool00ol0003oooooooooo`02ooooo`002Oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00Goo`00olco0?lc0?oo0?ooool0
V@05ooooo`03ool0VOoooooooooo00?ooooo00?o0?mVooooooooool00_ooool2oonI00?ooooo00Go
<ol0oonI0?ooooooo`00oonI0004ooooo`0:ool00?lc0?ooooooolco0?ooooooc?l0oc?o0?oooooo
<ol0oonI00;o<ol03?ooool00ol0ofKoooooooooo`03ooooo`03o`3oI_ooooooc?l000;ooiT000?o
c?l0oc<0ooo<0?l00_ooool01?l0oooo<`3oooooooo<0?l3ooooo`07oc<0ooo<0?oooooooc<0oooo
V@3oooooo`3oIP02ooooo`0:ool00?oo09Woooooool00?l0ofKoo`2Io`3oI_o<o`3oo`00o`3oIP;o
oooo00Koc?l0ooooooooooooooooolco0?ooV@03ooooo`03o`1Voooooooooooo00?ooooo00Go0?oo
ooooooooooooooooool0V@02ooooo`03o`3oI_lc0?oooooo00?ooooo00Ko06Kooooooooooooo<`3o
o`3oI_lc0?l2ooooo`06oc?o0?ooooooc03oooooool0ooooc03o0oooool00oo<o`3oooooooooo`02
ooooo`03oc?o0?o<o`3ooooo00cooooo013o<`3ooonI0?l0ofKooiT0ooooooooV@3o0?oooooooooo
V@3oooooo`3oooooooooo`2Ioooooooo003ooooo0_o<0?l00olco`3o0?oooc?o0004ooooo`0?olco
0?oooooo<ol0oc?o0?o<o`3oooooo`1Vool0ooooooooo`1Voooooooo<ol0oc<0oolco`3o0?oo00?o
oooo00Soc03oooooooooooooo`00ooooooooV@3ooooooonI00;ooooo00Co06Koooooooo<0?ooc?l0
0oooool2ool0V@03ooooooooV@3ooooo00;ooooo00CooiT0oooooooooooo<`3o0_ooool00oooV@3o
oooooonI0002ooooo`03oc<0oooooooooooo00Cooooo00?o0000ooooooooool00_ooool000Sooooo
0_l00006ooooo`03o`000?oooooooooo00Cooooo00Goo`00olco0?lc0?ooo`2Io`3oo`05ooooo`03
ool0VOoooooo06Ko00?ooooo00?o0?mVooooooooool00_ooool2oonI00?ooooo00GooiT0oc?o0?oo
ooooo`00oonI0004ooooo`03ool00?lc0?ooc?l000;ooooo00Goc?l0oc?o0?oooooo<ol0oonI0002
ooooo`03oc?o0?oooooooooo00Wooooo00?o0?mVooooooooool00oooool02?l0ofKoooooolco0?oo
V@3ooooooonI0?lc0?ooc03o0oooool00ol0oooooooool`0o`03ooooo`0;oc<0ooo<0?oooooooonI
0?oooooooiT0o`3oI_ooooooo`00oooooooo09T00_ooool01_l0ofKoo`2Io`3oI_o<o`3oo`00o`3o
IP;ooooo00Koc?l0ooooooooooooooooolco0?ooV@03ooooo`03o`1Voooooooooooo00?ooooo00Co
0?ooooooooooooooo`2I0oooool00ol0ofKoo`2Iooooo`03ooooo`06o`1Voooooooooooooc<0ool0
ofKo<`3o0_ooool01_lco`3oc03ooooooooooooo0?oool`0o`?ooooo00?oc?l0ooooooooool00_oo
ool00olco`3oc?l0ooooo`0;ooooo`0Foc<0ooooV@3oooooo`3oI_ooV@3ooooooonI0?l0oooooooo
o`1VooooV@3o0?oooooooooo09Woooooool00?o<0?oooooool`0oolco`3o0?oooc?o00Cooooo00Oo
c?l0oooooolco`3oooooolco0?oooooo0?oo00;ooooo00Ko06Kooc?o0?oooooooooooc?o0?l0ool3
ooooo`0:ol`0ooooooooooooool00?oooooooiT0ooooooooV@3oooooo`1Vo`;ooooo00?oc03oolco
0?o<o`000_ooool01?oo09Woo`00ool0VOooV@03ooooo`06oonI0?oooooooooooc<0oooooooooiT0
0_ooool00olc0?oooiT0oc<0o`07ooooo`03o`000?oooooooooo00;ooooo0009ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool01Ooo003oooooolco0?oooooo0?oo00Gooooo
00Coo`2Iooooool0I_oo06Ko0_ooool00ol0ofKoooooooooo`02ooooo`0:oonI0?oooooooiT0ol`0
oooooooooiT0oc?o0?ooooooo`00oonI00?ooooo00Coo`00oooooolc0?ooc?l00_ooool01Oo<o`3o
<ol0oooooolc0?oooiT000;ooooo00Go<ol0oooooooo09Woooooo`3oIP07ooooo`03o`3oI_oooooo
oooo00?ooooo00So0?mVooooooo<o`3ooiT0ooooooooV@3oc?l0ol`0o`?ooooo00?o0?oooc<0ooo<
0?l00oooool02olc0?ooc03oooooooooV@3ooooooonI0?l0ofKoooooool00?o<0?ooo`2I00;ooooo
00Ko0?mVool0VOl0ofKoc?l0ool00?l0ofH2ooooo`06olco0?ooooooooooooooooo<o`3ooiT00ooo
ool00ol0I_ooooooooooo`03ooooo`;o0?oo00Ooooooool0VOoooooo<`3oooooool0ofKoo`2I00Co
oooo00Ko06Kooooooooooooo0?mVol`0ool0ofH2ooooo`06oc?o0?o<0?ooooooooooool0ooooc03o
0_ooool00oo<o`3oooooooooo`03ooooo`03oc?o0?o<o`3ooooo00_ooooo01?o<`3ooonI0?l0ofKo
oooooonI0?lc0?oooiT0o`3ooooooooo06KooonI0?l0ooooooooool0VOooooooc03oool00?oooooo
<ol000;o0?oo00?o<ol0ooooooooool00_ooool00oo<o`3ooooooc?o0002ooooo`06olco0?l0oooo
ooooooooool0I_oo<ol00_ooool00olco`3o06Koo`3oo`02ooooo`0:ol`0ooooooooooooool00?oo
oooooiT0oooooooo003ooiT0o`1Vo`;ooooo00?oc?l0ooooooo<o`000_ooool01?oo09Woo`00ool0
VOooV@03ooooo`06oonI0?oooooooooooc<0oooooooooiT00_ooool00olc0?oooiT0oc<0o`07oooo
o`03o`000?oooooooooo00;ooooo000@ooooo`;o00001Oooool01Ooo003oooooolco0?oooooo0?oo
00Gooooo00Ooo`2Io`1Vooooooooooooo`1Voooooooo0?mV00Cooooo00SooiT0ooooooooV@3oc03o
ooooooooV@3o<ol0ooooo`;oo`0000OooiT0o`3oool0oooo0?oooc<0ooooooooc?l000;ooooo00?o
c?l0oc?o0?ooool00_ooV@02ooooo`05oc?o0?ooooooo`2Iooooool0ofH01oooool00ol0ofKooooo
ooooo`03ooooo`04o`3oI_ooooooc?l0oonI00;ooooo00?ooiT0ol`0ooooool00_ooool00ol0oooo
oooooc<0o`03ooooo`0;oc<0ooo<0?oooooooonI0?oooooooiT0o`3oI_ooooooo`00ol`0oooo09T0
0_ooool00ooo003o0?mVool00002olco0003ooooool0ofKoc?l000Cooooo00?oc?l0oonI0?ooV@00
0_ooool00ol0I_ooooooooooo`03ooooo`;o0?oo00?oooooool0VOooool00_lc0?l00ol0ofKoo`2I
ooooo`03ooooo`06o`1Voolc0?ooooooo`3oI_o<0?oo0?mV0_ooool00olco`3oc03oooooo`02o`3o
o`04ol`0ooooooooooooolco00Gooooo00?o<ol0olco0?ooool02oooool03Olc0?oooiT0o`3oI_oo
oooo0?mVoonI0?l0ooooo`00o`1VoooooooooiT0o`1Vool0ool00_ooool01oo<0?ooo`00oooooolc
o`3o0?oooooooolco`001?ooool00oo<o`3o<ol0ooooo`02ooooo`06olco0?l0ooooooooooooool0
I_oo<ol00_ooool01_lco`3o<`3oo`3ooooooooo0?mVol`0o`;ooooo00Ooo`00ooooooooV@3ooooo
ool00?ooV@3o06Ko00;ooooo00?oc?l0ooooooo<o`000_ooool01?oo09Woo`00ool0VOooV@03oooo
o`0=oonI0?oooooooooooc<0oooooooooiT0ooooool0ofKooooooonI0?lc0?oooooooc?o0004oooo
o`;o00001?ooool0013ooooo00?o0000ooooooooool01Oooool01?oo003oc?l0ooooool0ool5oooo
o`07o`1Vooooooooooooooooool0I_ooooooo`3oIP04ooooo`08oonI0?oooooooiT0ol`0ooooV@3o
oooooc?o0?ooool2ool00007oonI0?ooooooooooo`3ooolc0?ooooooolco0002ooooo`03olco0?l0
I_oooooo00;ooiT000?oooooolco0?lco`000_oo09T00ooooooo0?mVooooo`05ooooo`03o`1Vool0
ofKooooo00Cooooo00Co0?mVo`3oooo<o`3ooiT00_ooool00oo<o`3ooiT0ooooo`02ooooo`03o`3o
oooooooo<`3o00;ooooo00[o<`3ool`0ooooooooc03ooonI0?lc0?oooiT0o`3oI_oo003ooooo0_o<
0?l3ooooo`08oc?o0?o<o`3oooooolco0?oooooo0?mVolco0?l0ofH3ooooo`03olco0?ooV@3ooiT0
00;ooooo00?o06Koooooooooool00oooool2o`3oo`05oooooooo09Wooooooc<0ooooool00_l0ofH4
ooooo`06o`1Voolc0?oo<`3oo`3oI_lco`3o0?mV0_ooool00olco`3oc03oooooo`02o`3oo`04oooo
ooo<0?ooooooolco00Gooooo00?o<ol0olco0?ooool02oooool05_ooV@3oooooo`3oI_oooooo0?mV
oonI0?l0ooooo`00o`1VoooooooooiT0o`1Vool0ooooooooool00?o<0?ooooooool00?lco`3o0?oo
oooooolco`04ooooo`03olco0?lco`3ooooo00;ooooo00Koc?l0oooooooooooooooooc<0oolco`02
ooooo`06oc?o0?o<0?oo0?ooooooool0ofKoc03o0_ooool01ooo003ooooooonI0?ooooooo`00oonI
0?l0I_l00_ooool00oo<o`3oooooolco0002ooooo`04ool0VOoo003oo`2IoonI00Cooooo00GooiT0
oooooolc0?oooooooonI0002o`3oIP05ooooooooV@3o<`3ooooooolco`001Oooool00ol0003ooooo
ooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`06ol`0ooooooooo`2Iolco0?oooooo
0?oo1Oooool01ol0I_ooo`2Ioooooooooooo06Koooooool0ofH00oooool03?ooV@3ooooooooooooo
oooooiT0oc?o0?oooooo<ol0ool00?ooooooo`00oonI00;ooooo00Co0?oooc<0ooooooooc?l00_oo
ool03?o<o`3o06Koo`1VooooV@3o<`3ooonI0?o<o`3o<ol0oooooooo09Woooooo`3oIP;ooooo00Ko
06Koooooooooooooooooo`1Vool0ofH5ooooo`03o`3oI_l0oooooiT000?ooooo00?oc?l0ol`0oooo
V@000_ooool04Oo<o`3ooooool`0oolc0?oooooooc<0ooo<0?oooooool`0ooooV@3o<`3ooonI0?l0
ofKoo`2Iol`0oooo09Woc03o00?ooooo00Co<ol0olco0?ooooooc?l00_ooool00oo<o`3o0?mVoooo
o`02ooooo`03olco0?ooV@3ooiT000?ooooo00Go06Koooooooooooooooooo`3oo`02ooooo`05o`3o
oooo09Wooooooc<0ooooool00_l0ofH4ooooo`06o`1Voolc0?oo<`3oo`3oI_lco`3o0?mV0_ooool0
2Olco`3oc03oooooool0ooooooooo`3oooo<0?ooooooolco0005ooooo`03oc?o0?o<o`3ooooo00[o
oooo00?o<`3ooonI0?l0ofH00oooool04Ol0ofKo0?ooool00?lco`3ooooooonI0?l0I_oo0?oooooo
oooo003oc03ooooooooo003o<ol0o`3ooooooooo<ol000Cooooo00?oc?l0oc?o0?ooool00_ooool0
1_o<o`3o<ol0oooooolc0?oooooooc?o00;ooooo00?o<ol0ooooool0ool00_l0ofH00oo<0?oooooo
ool00002ooooo`0@oonI0?ooooooo`00oonI0?o<o`3oooooool00?o<o`3oooooolco0?ooooooo`2I
ool00?ooooooo`2IoonI00;oc?l00_ooool02OooV@3ooooooc<0oooooooooiT0ooooool0ofKoc03o
oonI0002ooooo`03oc?o0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool0013ooooo00?o
0000ooooooooool00oooool01_o<0?ooooooool0VOooooooc?l0o`3oo`Cooooo00?o06Kooooooooo
09T00_ooool00ol0I_ooooooo`3oIP03ooooo`0<oonI0?ooooooooooooooooo<0?oo<ol0oooooolc
o`3oo`00ooooool0oooooiT00_ooool01?oo003o0?ooooooooo<o`02ooooo`06olco0?l0I_oo06Ko
oonI0?lc0?oooiT00_o<o`000oooooooo`2Iooooo`02o`3oIP;o06Ko0oooool00ol0I_oo0?mVoooo
o`04ooooo`03o`3oI_l0oooooiT000?ooooo00?o<`3oolco0?ooV@000_ooool01?o<o`3ooooool`0
ooooool2oc<0o`0<ol`0ooooooooc03ooonI0?lc0?oooiT0o`3oI_oo003oc03oool0VOooooooc03o
0_ooool01?lco`3oc?l0o`3oooo<o`02ooooo`03olco0?l0ofKooooo00;ooooo00?oc?l0oonI0?oo
V@000oooool01Ol0I_oooooooooooooooooo0?oo00;ooooo00?o0?oooooooolc0?l00_ooool2o`3o
IPCooooo00Co06Kooooooolc0?oo0?mV0_lco`02ooooo`09oc?o0?o<0?ooooooo`3ooooooooo0?oo
ol`0ooooooooc?l000;ooooo00Oo0?oooooooooooooo<ol0ooooooo<o`3ooooo00;oo`001oooool0
0olc0?oooiT0o`3oIP03ooooo`03o`3oI_l0oooo<`3o00;o<ol000cooooooonI0?l0ooooooooool0
0?o<0?ooooooool00?lco`3o0?oooooooolco`04ooooo`03olco0?oooooooooo00;ooooo00Koc?l0
oc?o0?oooooo<`3ooc?o0?ooool2o`1Vo`08oc?o0?oooooo0?mVol`0ool0ofKoc03ooooooooo0002
ooooo`0HoonI0?ooooooo`00oonI0?o<o`3oooooool00?o<o`3oooooo`1Vooo<o`3oo`2Iool00?oo
ooooo`2IoonI0?o<o`3oooooolco0?oooooooiT0ooooool0ofKooiT00oooool01Ol0ofKooiT0ol`0
oooooooo<ol000Gooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01?oo
ool01Oo<0?ooo`2Iooooooo<o`3o0?oo00Cooooo00?o06Kooooooooo09T00oooool00ol0I_oooooo
o`3oIP02ooooo`06oonI0?ooooooooooooooooo<0?oo<ol00_ooool00olco`3oooooo`3oo`02oonI
0005ool00?oo09Wo0?ooooooooo<o`000_ooool01_lco`3oc?l0oonI0?oo003o<`3ooonI00;oc?l0
00?oooooool0VOooool00_l0ofH00ooooooo06Koooooo`02ooooo`03o`1Vool0ofKooooo00Cooooo
00?o0?mVo`3oooooV@000oooool01?lc0?ooc?l0oonI0?ooool2olco000Bo`3oooooooooc03ooooo
oolc0?ooc03oooooooo<0?oooiT0oc<0ooooV@3o0?mVooooooo<0?ooo`2Iooooooo<0?oooooo0_lc
o`001oo<o`3o0?ooooooooo<o`3o06Koolco0?l0ofH00_ooool01?l0I_oooiT0olco0?ooV@03oooo
o`05o`1Vooooooooooooooooool0ool00_ooool01ol0oooooooooc<0oooooooo0?mVooooool0ofH0
1?ooool01?l0I_ooooooooooool0ofH2oc?o000>oooooolco`3ooooool`0oooooooo0?ooo`3oI_l0
ooooc03oooooooo<o`3o06Koooooool0ool2ooooo`06oc?o0?ooooooc?l0ool00?ooooooo`001_oo
ool01?l0ofKo<`3ooonI0?l0ofH3ooooo`0:o`3oI_l0oooooooooc?o0?oooooo<ol0oonI0?l0oooo
oooool`0o`?ooooo00Go<ol0o`3ooooooooo0?oooc?o0003ooooo`0;olco0?ooooooooooooooool0
ooooc?l0oc?o0?oooooo<`3ooc?o0?ooool00_l0I_l02?lco`3o0?mVo`3oooo<0?oo<`3oo`3oI_oo
ooooo`000_ooool01OooV@3oooooolco0?ooV@3oc?l000;oo`0000Woc?l0ooooooooooooc?l0ool0
VOoo003ooooooonI0?o<o`000_ooool01_o<o`3ooooooonI0?l0ofKo<`3ooonI00?ooooo00Go0?mV
oonI0?o<0?oooooooc?o0005ooooo`03o`000?oooooooooo00;ooooo000@ooooo`;o00001Oooool0
1_o<0?ooo`2Iooooooo<o`3oooooo`3oo`?ooooo00?o06Kooooooooo09T00oooool00ol0I_oooooo
o`3oIP02ooooo`06oonI0?oooooooooool`0oooooooo<ol00_ooool00olco`3oooooo`3oo`02oooo
o`05oonI0?l0ofKo0?ooooooooo<o`000_ooool02?lco`3oc?l0oonI0?oooooo<`3ooonI0?oooooo
c?l00_ooool00ooo09Wo0?mVo`3oIP02ooooo`04o`1Voooooooo06Koo`3oIPKooooo00?o0?mVo`3o
ooooV@000_ooool01Olc0?ooc03oolco0?ooV@3ooooo00;oc?l000?o0?ooooooooo<0?l00_lco`00
3Oo<0?oooooool`0ooooV@3oo`2Ioc<0ooooV@3oc03ooooooooo09Wooooool`0ooooool00_lco`00
1oo<o`3oooooo`3oooo<o`3o06Koolco0?l0ofH00_ooool01?l0I_oooiT0olco0?ooV@03ooooo`05
o`1Vooooooooooooooooool0ool00_ooool02Ol0ooooo`00oc<0oooooooo0?mVooooool0ofKooooo
oonI0002ooooo`06o`1Vooooooooooooo`3oI_lco`3o0?mV0_lco`003?ooooooc03oo`3ooooooooo
0?mVo`3oool0I_ooc?l0ooooool0I_ooooooo`3oo`;ooooo00?o<ol0ooooooo<o`000_ooool00oo<
o`3oooooooooo`04ooooo`04o`3oI_oooooooiT0o`3oIP?ooooo00_o0?mVool00?oooooo<ol0oooo
oolco`3ooiT0o`3oooooooooc03ooonI0002ooooo`05oc?o0?l0ooooooooo`3ooolco`000oooool0
1oo<o`3ooooooooooooooooo0?ooolco0?ooool00olco`02ooooo`09o`1Voolco`3o0?mVo`3oooo<
0?oo<`3oo`3oI_ooooooo`0000;ooooo00SooiT0o`3oooo<o`3ooiT0ooooooo<o`3oo`00olco00;o
oooo00Koc?l0oc?o0?oo003ooooooonI0?o<o`02ooooo`06olco0?oooooooiT0o`3oI_lc0?oooiT0
0oooool01?l0ofKooiT0ol`0oolco`05ooooo`;o00001?ooool0013ooooo00?o0000ooooooooool0
1Oooool01Oo<0?ooooooolco0?oooooo0?oo00?ooooo00?o06Kooooooooo09T00oooool00ol0I_oo
ooooo`3oIP02ooooo`06oonI0?oooooooooool`0oooooooo<ol00_ooool00olco`3oooooo`3oo`02
ooooo`04ool00?ooV@3o0?ooolco00?ooooo00_o<ol0olco0?ooV@3oo`2Ioc<0ooooV@3ooooooc?o
0?o<o`3oooooool0V@02o`3oIP;ooooo00Co06Koooooool0I_oo0?mV1_ooool00ol0ofKo0?oooonI
0002ooooo`05oc<0ooo<0?ooc?l0oonI0?ooool00_o<o`003Ol0oooooooooc?o0?oooooo<ol0ol`0
oooooooooiT0oooooooo09Wo0?mVoonI0?o<0?l00oooool2olco000?oc?o0?o<o`3o0?ooooooool0
ooooc?l0o`1Vooo<o`3oooooo`3oI_oooooo06KooonI0?o<o`3ooiT000?ooooo00Go<ol0o`1Voooo
ooooooooo`3oo`02ooooo`07ool0VOl0oooo<`3oooooool0ofKoooooo`3oIP02oonI00;ooooo00Ko
06Kooooooooooooo0?mVoc?o0?l0ofH2oc?o0003ol`0oooooooo0?oo00;o0?mV00Go0?ooo`1Vooo<
o`3oooooo`1Vo`02o`3oo`;ooooo00?o<ol0ooooooo<o`000_ooool00oo<o`3oooooooooo`04oooo
o`03o`3oI_ooV@3o0?mV00;ooooo00goc03oooooool0ofKoo`00oooooolco`3o<`3ooc?o0?ooV@3o
0?ooooooool0ofKooiT000;ooooo00Go<ol0ol`0oooooooo0?oooc?o0002ooooo`03olco0?oooooo
oooo00;ooooo00Oo0?ooolco0?oooooo<ol0ool0VOooooooo`2I00;ooooo00So<ol0o`3oI_l0I_oo
0?oooc<0ool0ofKoooooool000;ooooo00GooiT0o`3oooo<o`3o06KooonI0002olco0005ol`0oooo
oooo<ol0olco0?lco`000_ooool01OooV@3oc?l0ooooooooooooc?l000;ooooo0_ooV@04ooooo`04
o`3oI_oooooooiT0oc?o00Kooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000oooooooo
ool01Oooool01Oo<0?ooooooolco0?oooooo0?oo00;ooooo00Co06Koooooooooooooo`2I0oooool0
0ol0I_ooooooo`3oIP02ooooo`06oonI0?oooooooooool`0oooooooo<ol00_ooool00olco`3ooooo
o`3oo`02ooooo`05ool0VOooV@3o0?ooolco0?o<0?l00_ooool01_lco`3oc?l0oonI0?oo09Wo<`3o
oonI00;ooooo00?oc?l0oooooooo09T00_l0ofH2ooooo`04o`1Voooooooo06Koo`3oIPKooooo00?o
06Koolco0?ooV@000_ooool01olc0?ooc03oolco0?oooooooiT0ooooooo<o`000_lco`002oo<0?oo
oooooc?o0?o<0?oooooooonI0?ooooooo`2Io`3oI_ooV@3oc03o00?ooooo00Ooc?l0oc?o0?o<o`3o
c?l0oc?o0?oooooo0?oo00;oc?l000Wo06Koooooool0ofKoooooo`1VooooV@3oc?l0ooooooooV@00
0_ooool01Olco`3o06Kooooooooooooo0?oo00;ooooo00coo`2Io`3ooolc0?ooooooo`3oI_oooooo
oiT0o`3oI_oooooooiT0ooooool0I_l2ooooo`03o`3oI_lco`3o<`3o00;o<ol000?oc03oooooool0
ofH00_ooool01Ol0ofKoooooolco0?oooooo06Ko00;o0?oo0_ooool01?lco`3oooooolco0?ooool2
olco00Kooooo00?o0?mVoonI0?l0ofH00_ooool05?o<0?ooooooo`3oool0ofKo<ol0o`1Voolc0?oo
oooooonI0?l0oooo0?mVol`0ooooV@3ooooooc?o0?l0oooooooool`0ool0oooo<ol00_ooool00oo<
o`3oooooooooo`02ooooo`04o`3oooooooooc?l0oc<0o`?ooooo017oo`2Ioooooolco`3o0?mVo`1V
ool0oooo<`3oo`3oI_ooooooo`00ooooooooV@3oooooo`3oooo<o`3oo`00oonI0002olco0005ol`0
oolco`3oooooolco0?lco`000_ooool02OooV@3oo`2Iooooooooooooc?l0ooooool0ofKooiT0oc<0
o`03ooooo`06ol`0oooooooo0?mVoonI0?lco`3o0?oo1Oooool00ol0003oooooooooo`02ooooo`00
4?ooool00ol0003oooooooooo`05ooooo`05ool0VOo<0?ooc?l0ooooool0ool00_ooool01?l0I_oo
oooooooooooo09T3ooooo`03o`1Voooooooo0?mV00;ooooo00KooiT0ooooooooooooc03ooooooolc
o`02ooooo`0Boc?o0?l0ooooo`00oooooooo003oc03ooonI0?lc0?ooc?l0ooooooo<0?oooooooc?o
0?o<o`3ooiT0o`1Voolc0?oooiT00_ooool01Oo<o`3oooooo`3oI_l0I_oo0?mV00;ooooo00Co06Ko
ooooool0I_oo0?mV1_ooool00ol0I_ooc?l0oonI0002ooooo`08oc<0ooo<0?ooooooolco0?ooV@3o
oooooc?o0?o<o`02ooooo`0:ol`0oolco`3oc03oooooooooV@3oooooool0VOl0ofKooiT0ol`0o`?o
oooo00Goc?l0oc?o0?ooooooc?l0oc?o0002ooooo`0;o`3oooo<o`3o06Koooooool0ofKoooooo`1V
ooooV@3oooooolco0?ooV@000_ooool0:_lco`3o06Kooooooooooooo0?oooooooooo003oo`2Io`3o
oolc0?ooooooo`3oI_ooV@3oooooo`3oI_oooooooiT0ooooool0I_ooooooo`3oI_o<0?oo<ol0ol`0
ool0ofKo<ol0ol`0ool0ofKo0?ooooooool0I_oo0?mVooooooo<o`3oooooo`1Vool0ooooooooo`3o
oooooooo<ol0ool000;oc?l000?oooooolco0?ooool01Oooool00ol0ofKooiT0olco0002ooooo`0D
ol`0oooooooo0?ooo`3oI_lco`3ooooooc<0oooooooo<ol0oonI0?l0ofKooiT0o`3oI_ooV@3o<ol0
o`3oooooooooc03oool0VOlco`02ooooo`09olco0?ooooooooooool00?oooooo0?ooooooooo<o`3o
<`3o00Cooooo00_oo`2Ioc?o0?l0ofKo06Koo`3ooolc0?oo0?mVoooooooo003ooooooonI0002o`3o
o`0:olco0?oo003oo`00oonI0?o<o`3oc03ooc?o0?oooooo06Koolco00;ooooo00WooiT0ool0VOoo
ooooooooolco0?l0oooo0?mVoooooolc0?l00oooool01_o<0?ooooooo`3oI_ooV@3o<ol0o`3oo`Go
oooo00?o0000ooooooooool00_ooool0013ooooo0_l00006ooooo`05ool0VOo<0?ooc?l0oc<0ool0
ool00_ooool01?l0I_oooooooooooooo09T3ooooo`03o`1Voooooooo0?mV00;ooooo02OooiT0oooo
ooooooooc03ooooooolco`3oc03ooooooolco`3o0?ooool00?ooooooo`00o`3oI_oo09WooiT0olco
0?lco`3ooooool`0oolco`3ooiT0ool0VOl0I_oo<`3oolco0?ooV@3ooooooc?o0?o<o`3o0?mVo`1V
oooooooo0?mVooooool0I_ooooooo`1Vool0ofH01_ooool03Ol0I_ooc?l0oonI0?l0ofKooooooc<0
ooo<0?ooooooolco0?ooV@3ooooooc?o0?o<o`000_ooool02Oo<0?oooooooc?o0?oooooooiT0oooo
oooo09Wo0?mVoonI0002ooooo`07oc?o0?ooooooc?l0oc?o0?o<0?oo0?oooc?o0002ooooo`05o`3o
ooo<o`3o06Koooooool0ofH00_l0I_l01?ooV@3oooooooooooooV@02ooooo`0<oc?o0?oooooo06Ko
ooooool0ooooooooool00?oo09Wo0?ooool00?oooooooiT00_ooool05?l0ofKooooooonI0?oooooo
06Koooooool0ofKo<ol0ooooooo<0?oo0?mVo`3oooo<0?oo0?mVo`3ooooooooo06Koo`3oI_oooooo
c?l00_ooool00ol0ooooooooo`3oo`02ooooo`05oc?o0?o<o`3oc?l0ooooooo<o`001Oooool01Ol0
ofKo<`3ooonI0?o<o`3ooooo00;oc03o01Koooooo`3oool0ofKo<ol0oooooolc0?oooooooc?o0?oo
V@3o0?mVoonI0?l0ofKooiT0oc?o0?l0oooooooool`0oooooooo<ol0oooooolco`3oc?l00_ooool0
1_oo003oooooo`3oooooooooc?l0ool0V@Cooooo00Soo`2Ioc?o0?l0ofKo06Koo`3ooooo003o0?mV
ool000;ooooo00CooiT0o`3oool0ooooc?l00_oo00001?ooV@3oc?l0ol`0oolco`02ooooo`0<olco
0?oooooooooooonI0?oo09Woooooo`3oooooooooc?l0o`3oI_oooooo<`3o0oooool01_o<0?oooooo
o`3oI_ooV@3o<ol0o`3oo`Cooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`05ooooo`05
ool0VOooooooc03oolco0?l0ool00_ooool01?l0I_oooooooooooooo09T4ooooo`05o`1Vool0ofKo
ooooooooooooV@000_ooool07oo<0?oooooooc?o0?o<0?oooooooc?o0?l0ooooooooool00?o<0?oo
0?mVooooooooV@3oc?l0oc?o0?oooooo0?mVoc?o0?ooV@3oo`2Io`1Voolc0?ooc?l0oonI0?oooooo
<ol0olco0?l0ofKoc03oooooool0ofH00_ooool00ol0I_oo0?mVooooo`06ooooo`0=o`3oooo<o`3o
oiT0o`3oI_oooooo<`3ool`0ooooooooc?l0oonI0?oooooo<ol0olco0002ooooo`;oc03o00Oo<ol0
ooooooooV@3oo`2Iool00?l0ofKooiT000;ooooo00Oo<ol0ooooooo<o`3o<ol0ol`0ool0oooo<ol0
00;ooooo00Go0?oooooooooooooo06Koo`3oIP02ooooo`0?oonI0?oooooooooooonI0?o<o`3ooooo
oc?o0?oooooo06Koooooool0ooooooooool00?oo09Wo<`3o00;ooiT000Co0?mVoooooooooooo0?mV
0_ooool01OooV@3o06Koooooool0ofKo<ol000;ooooo00Co0?mVo`3oool0oooo0?mV0_ooool01?l0
I_oo0?mVooooooo<o`02ooooo`03o`3ooooooooo0?oo00;ooooo00Go<ol0olco0?l0ofKoooooolco
0004ooooo`06olco0?l0ofKo<`3ooonI0?o<o`3ooooo0_o<0?l01?oooooo0?ooo`3oI_lco`02oooo
o`0@oc<0oolco`3ooiT0o`3oooooV@3o0?oooonI0?lco`3oooooool00?o<0?oooooooc?o0?oooooo
<ol0olco00;ooooo00Koo`00ooooool0ooooooooolco0?ooV@04ooooo`08ool0VOo<0?oo<ol0o`1V
ool0ooooo`00oc<0ool0ofH2ooooo`05oonI0?l0oooo06Koolco0?oo00000_ooool01OooV@3oc03o
oc?o0?ooooooo`0000?oc?l000WooiT0ool00?oo09Wo0?ooooooooo<o`3o0?mVo`3ooolc0?l00ooo
ool01_o<0?ooooooo`3oI_ooV@3o<ol0o`3oo`Gooooo00?o0000ooooooooool00_ooool0013ooooo
00?o0000ooooooooool01?ooool01_oo09Woooooool00?ooooooc?l0o`3oo`;ooooo00Co06Kooooo
ooooooooo`2I1?ooool01Ol0I_oo0?mVooooool0I_oooiT000;ooooo01ooc03oo`3ooolco`3oc03o
oooooooo003o<ol0oooooooo003oc03oo`3oI_lc0?oooiT0olco0?lco`3oooooo`3oI_lco`3ooiT0
olco0?l0I_ooc?l0ool00?ooV@3ooooooc?o0?o<o`3o0?mVol`0oooooooo0?mV00;ooooo00?o06Ko
o`3oI_ooool01_ooool01ol0ooooc?l0oonI0?l0ofKooooooc<0ooo<0?l00_ooool01?ooV@3ooooo
oc?o0?o<o`02ooooo`;oc03o00Wo<ol0ooooooooV@3oo`2Iooooool0ofKo0?oooonI0?ooool00_lc
o`001Oo<o`3oooooo`3ooooooooo<ol000;ooooo00Go06Koo`3ooooooooo06Koo`3oIP02ool00005
oonI0?oooooooooooonI0?o<o`000_lco`001_oooooo06Koooooool0ooooc?l0ool0V@;ooiT000?o
0?ooool00?l0ofH00_ooool02?l0ofKoooooooooooooV@3oooooo`1Vool0ofKo<ol00_ooool01?l0
ofKo0?ooo`3oI_l0ool2ooooo`09o`1Voooooooo0?mVolco0?oooooo0?ooo`1Voooooooo0?oo00;o
oooo00Oo<ol0o`3oI_l0ofKoooooolco0?oo003o<`3o00;oo`2I00coc?l0o`3oI_oooooooiT0olco
0?ooooooc03oooooooo<0?oo0?ooo`3oI_lco`02ooooo`0=oc<0oolco`3ooiT0o`3oooooV@3ooooo
o`3oI_ooV@3oooooool00?o<0?ooooooo`3oo`02oc?o0003olco0?oooooooooo00;oo`0000Ko0?oo
oc<0ooo<o`3ooiT0ooooooo<o`02ooooo`08ol`0ool0ofKo<ol0ooooool0ooooo`00oc<0ool0ofH2
ooooo`05oonI0?oooooo06Koolco0?oo00000_ooool04OooV@3o<ol0ol`0ooooooooo`2Ioc?o0?oo
oooooiT0oooooooo003oo`2Io`3oooooooooc?l0ooooool0oooo<`3o00;ooooo00Ooc03ooooooooo
oooo0?mVoonI0?lco`3o0?oo00Gooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000oooo
ooooool01?ooool02Ooo09Woooooool00?ooooooc?l0ooooool0ooooooooo`1Vo`02ooooo`03ool0
VOoooooooooo00;ooooo00Go06Koo`3oI_oooooo06KooonI0002ooooo`0?ol`0ool0oooo<ol0oc<0
ooo<0?ooo`00oc?o0?ooooooo`00ol`0ool0ofKo<`3ooonI0?o<o`3o<ol000;o0?mV00?o<ol0oonI
0?ooool00_o<o`000ooo003ooiT0oonI0002oonI0004o`3oI_o<0?ooc03oo`3oIP?ooooo00?o0?mV
ooooooooool01?ooool02?lco`3oc?l0o`3oI_ooV@3o0?mVoooooolc0?ooc03o0_ooool01?ooV@3o
<ol0ooooooo<o`02ooooo`;oc03o013o<ol0ooooooooV@3oo`2Iooooool0ofKo0?oooonI0?oooooo
<ol0ooooooo<o`3oooooo`3ooooooooo<ol00_ooool00ol0I_oo0?ooooooo`02oc?o0003oooooooo
003ooiT000;ooooo00oooiT0ooooooo<o`3ooooooc?o0?oooooo06Koo`3oooo<o`3oo`2IoonI0?lc
0?oo0?ooool00?l0ofH00_ooool02?l0ofKoooooooooooooV@3oooooo`1Vool0ofKo<ol00_ooool0
1_l0ofKo0?ooo`3oI_l0ooooooooo`1Vo`;ooooo00[oc?l0oooooooooooo0?ooo`1Vooo<0?oo0?oo
oooooooo003o<ol00_l0ofH2ooooo`0Qolco0?lc0?ooooooooooooo<o`3o0?mVooooooooV@3ooooo
olco0?o<0?ooo`00ol`0ool0oooo0?mVoc?o0?o<o`3ooooooc<0oooooooooiT0o`3oooooV@3ooooo
o`3oI_ooV@3oooooool00?o<0?ooooooo`3ooolco`3oc?l000?ooooo00Go0?mVo`1Vool0oooo<`3o
olco0002oonI000;olco0?oooooooooool`0ool0ofKo<ol0ooooool0oooooooooc<0ool0ofH00_oo
ool01?ooV@3oooooo`1Vooo<o`04ooooo`0:oonI0?o<0?ooooooool0VOlc0?oo<ol0oonI0?oooooo
o`00o`3oo`;ooooo00Ooc?l0ooooool0ooooooooool0VOooooooc03o00?ooooo00?ooiT0oc?o0?l0
I_l01Oooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`0:oc?o
0?oo09Woooooool00?ooooooc?l0ooooool0ooooooooo`1Vo`?ooooo00Woo`2Ioooooooooooooooo
o`1Voolco`3o0?mVo`1VooooV@000_ooool2o`3oo`05oc?o0?lc0?oooooool`0oolco`000_o<0?l0
1_oo09Wo0?mVoc<0oolco`3ooiT0oc?o00;o0?mV00KooiT0ool0VOoooooo06Koolco0?lc0?l2oooo
o`06oc?o0?ooV@3oc?l0o`3oooo<0?oo0?mV0oooool00ol0ofKoooooooooo`04ooooo`03olco0?l0
oooooiT000;o0?mV00?ooooooc<0ooooool00_ooool01?ooV@3o<ol0ooooooo<o`03ooooo`0:ol`0
oolco`3ooooooonI0?oo09Woooooo`3oI_l0oooooiT0oc?o00;ooooo00Goc?l0ooooool0ooooc03o
oc?o0002ooooo`08o`1Vool0ooooo`00oc?o0?l0ofKo<ol0ool00?ooV@02ooooo`0?oonI0?oooooo
<ol0olco0?lco`3oooooo`3oooooooooc?l0ool0VOooV@3o<`3oo`3ooooo003o0?mV00;ooooo00So
o`2Io`3oI_oooooo<ol0oonI0?l0I_oo0?mVoc?o00;ooooo00?o0?mVolco0?l0ofH00_ooool01Ol0
I_ooc?l0olco0?o<o`3ooooo00;o0?oo00co06Kool`0ool0ooooooooool00?lco`3o0?mVooooool0
ofKoooooolco0?lc0?l2ooooo`;oc?l001[ooiT0olco0?ooooooc?l0oooooooo003oc03oo`3oool0
ofKo<ol0olco0?oooooo<`3ooooooolco`3ooiT0o`3ooooooooo0?mVoonI0?ooooooo`00ooooooo<
0?oo0?ooolco00Cooooo00Go0?mVo`1Vool0oooo<`3oolco0002oonI00;oc?l000Wooooool`0ool0
ofKo<ol0ooooool0I_oo0?oooc<0ool0ofH00_ooool01?ooV@3oooooolco0?l0ool4ooooo`07oonI
0?o<0?ooooooool0VOlc0?oo<ol0oonI0002ooooo`0:o`3oooooooooo`00olco0?oo09Wo0?oooooo
oooo09Wooooool`0o`?ooooo00?ooiT0o`3oool0I_l01Oooool00ol0003oooooooooo`02ooooo`00
4?ooool2o`0000Cooooo00_o<ol0ool0VOooooooo`00oooooolc0?ooc?l0o`3oool0I_ooooooool0
0002ooooo`09ool0VOooooooooooooooool0I_oo<ol0o`3oI_oooooooiT000;ooooo0_l0ool04Olc
o`3o<`3ooooooooo003o<ol0oooooooo003o0?mVoooooolc0?oo<ol0oonI0?l0ofKo<ol0o`3oI_oo
V@3oo`2I00;ooooo00Oo06Kooc<0oooooooooooooc?o0?ooV@3oc?l000?o<ol00oooool00ol0ofKo
ooooooooo`03ooooo`04oc?o0?o<o`3o0?oooonI00;o0?mV00?ooooooc<0ooooool00_ooool01Ooo
V@3o<ol0ooooooo<o`3o0?oo00;ooooo00[oc03ooc?o0?ooV@3ooooool`0oooooooo0?mVo`3ooooo
V@3o<ol00_ooool03oo<o`3oooooo`3oooo<0?oo<ol0ooooool0I_ooooooo`3ooooooooo<ol0o`3o
I_oooooo<ol0oonI0003ooooo`0>oonI0?lco`3oc?l0oc?o0?oooooo0?ooooooooo<o`3oo`2IoonI
0?lc0?oo0?ooool00?l0ofH2ooooo`08ool0VOl0ofKo<ol0ooooooooV@3o0?mVoooooolco`02oooo
o`0:o`3oI_o<o`3o0?mVoonI0?oooooo06Koolco0?ooooooc?l0o`3oo`;ooooo00?o06Kool`0ool0
ool00_o<0?l01_lco`3o06Koooooool0ofKoooooolco00;o<`3o00coc?l0ol`0ooo<o`3ooiT0olco
0?ooooooc?l0oooooooo003oc03oo`3oooooool2olco0005oooooooo09Wo0?mVoc?o0?ooV@000_oo
ool02?l0ofKooiT0oooooooo003ooooool`0ool0ooooc?l00oooool04ooo003o0?mVo`3oI_l0oooo
oooooonI0?oooooooiT0ooooooo<o`3ooooool`0ool0ofKo<ol0ooooool0I_oo0?oooc<0ool0ofH0
0_ooool01?ooV@3oooooolco0?l0ool4ooooo`0CoonI0?o<0?ooooooool0VOlc0?oo<ol0oonI0?oo
oooo0?ooool00?oo09Woo`00olco0?oo09Wo0?oooooooooo09Wooooool`0o`03ooooo`03oonI0?l0
ooooc03o00Cooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`03ooooo`09oc?o0?oo09Wo
ooooool00?oooooo<`3oolco0?l0oooo06Ko00;oo`000_ooool02ooo09Wooooooooooooooooo06Ko
oc?o0?l0ofKooiT0o`1Vooooooooc03o00;o0?oo00Go<ol0oc<0oooo003o0?oooc?o0002ooooo`06
o`3oI_oooooo<`3oolco0?ooV@3o0?mV0_lco`001_ooV@3oo`2Ioooooooooooo06Kooc<0o`;ooooo
00Wo<ol0oonI0?o<o`3o<ol0ooooooo<0?oo<ol0ooooool0ofH01_ooool02?lco`3oc?l0oc?o0?oo
V@3oooooo`3oI_oooooo<`3o0oooool01OooV@3o<ol0ooooooo<o`3o0?oo00;ooooo00[oo`00oc?o
0?ooV@3ooooool`0oooooooo0?mVo`3oooooV@3o<ol00_ooool03oo<o`3oooooo`3oooo<0?oo<ol0
ooooool0I_ooooooo`3ooooooooo<ol0ooooool0ofKo<ol0oonI0003ooooo`0=oonI0?lco`3oc?l0
oc?o0?oooooo0?ooooooooo<o`3oo`2IoonI0?lc0?ooooooo`3oIP03ooooo`08ool0VOl0ofKo<ol0
ooooooooV@3o0?mVoooooolco`02ooooo`06o`3oooo<o`3oc?l0oonI0?ooooooc?l00_ooool01Ol0
ofKooooooooooooooooo06Ko00;ooooo00So0?oool`0oolco`3oooooo`1Vool0ofKoooooolco00;o
<`3o01?oc?l0ol`0ooo<o`3ooiT0olco0?ooooooc?l0oooooooo003oc03oo`3oooo<o`3o0?mVol`0
ooo<o`3oo`2Io`3oI_lco`3ooiT000;ooooo00So0?mVoc?o0?ooV@3oo`00ooooooo<0?oo0?ooolco
00?ooooo00Ko0?mVoc<0ool0oooo0?mVooooooooV@02olco000;oonI0?ooooooc?l0ol`0ool0ofKo
<ol0ooooool0I_oo0?oooc<0ool0ofH00_ooool01?ooV@3oooooolco0?l0ool4ooooo`0Coc?o0?oo
V@3oo`00ool0VOlc0?oo<ol0oonI0?l0oooo06Koool00?oo09Wo0?mVolco0?oooooo<`3oo`3ooooo
ooooo`2Iol`0o`03ooooo`03oonI0?l0ooooc03o00Gooooo00?o0000ooooooooool00_ooool000Wo
oooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00_o<ol0ool0VOooooooooooool00?lc0?oo
c?l0o`3oool0I_ooooooool00002ooooo`0Bool0VOooooooooooooooool0I_oo<ol0o`3oI_ooV@3o
ooooo`1Vool0oooooooooc?o0?lc0?ooo`2Ioc<0ool0oooo<ol00_ooool01_l0ofKooooooc<0ooo<
o`3o0?mVoonI00;o<ol000KooiT0ool0VOooooooooooo`1Voolc0?l2ooooo`09oc?o0?ooV@3oc?l0
oc?o0?ooooooc03ooc?o0?oooooo0?mV00Gooooo00So<ol0olco0?l0oooo<ol0oonI0?oo09Wooooo
o`3oIPGooooo00CooiT0ooooooo<o`3o0?oo0_ooool01ooo003ooooooonI0?ooooooc03oooooool0
ofH00_l0ool02_ooV@3oooooooooooo<o`3o0?ooooooooo<0?oo<ol0ooooool0I_l2ooooo`06oc?o
0?ooooooooooo`3oI_lco`3ooiT00oooool02_ooV@3o<ol0olco0?lco`3oooooo`3oooooooooc?l0
ool0VOooV@02ooooo`0<o`3oI_l0oooooooooooooooo09Wo0?mVoc?o0?oooooo<ol0oonI0?oooooo
<ol00_ooool01_l0ooooc?l0olco0?ooV@3oc?l0o`1Vo`?ooooo00Co0?mVoooooooooooo06Ko0_oo
ool02?l0ooooc03ooc?o0?oooooo06Koooooool0ofKoc?l00_lc0?l04oo<o`3oc03oolco0?ooV@3o
c?l0ool0VOo<o`3oo`2Iool00?o<0?ooc?l0oc?o0?l0ofKoc03oolco0?oo09Wo0?mVoc?o0?l0I_l0
0_ooool02Ol0ofKo<ol0oonI0?oo003ooooool`0ool0ooooc?l0o`3oIP02ooooo`06o`3oI_lc0?oo
0?ooo`3oI_oooooooiT00_o<o`004OooV@3oooooolco0?o<0?oo0?mVoc?o0?oooooo06Koo`3ooolc
0?ooooooo`3oI_oooooooiT0o`1Vooo<o`3o0?oo00Cooooo00Oo<ol0oonI0?oo003oo`2Ioc<0oooo
V@3o0?oo00;ooooo0ol0ofH01_o<o`3oo`00oc<0ool0oooooooool`0o`Cooooo00?ooiT0o`3oooo<
0?l01Oooool00ol0003oooooooooo`02ooooo`002?ooool01?l0003oooooooooool00004ooooo`03
o`000?oooooooooo00?ooooo00?o<ol0ool0VOooool00_ooool01_lc0?ooc03oolco0?l0I_oooooo
ool000;ooooo00?oo`2Iooooooooool00_ooool06Olco`3o0?mVoonI0?oooooo06Koo`3ooooo09Wo
<ol0oc<0oooooooo<`3oo`3ooolco`3oooooool0VOl0ofKooooooc<0ooo<o`3oooooo`3oooooV@3o
<ol0oonI0?l0ool00_ooool02ol0I_oo<`3oooooooooooooo`00oonI0?o<o`3oo`2Io`3oooo<0?oo
<ol000;o0?mV1Oooool00olco`3oc?l0oonI0002oonI0003ool0VOoooooo0?mV00Gooooo00CooiT0
ooooooo<o`3ooiT00_ooool01ooo003ooooooonI0?oo09Woc03oooooool0ofH00_l0ool02_ooV@3o
ooooolco0?oooooo0?ooooooooo<0?oo<ol0ool0VOl0I_l2ooooo`07oc?o0?ooooooooooo`3oI_lc
o`3ooiT0oc<0o`02ooooo`04oonI0?lco`3o0?ooolco00;o0?oo0_o<o`001_ooV@3o<`3ooooooooo
oooo0?mVool000?o0?oo00Oo0?mVoc?o0?oooooo<ol0oonI0?oooooo<ol000;ooooo00?oc?l0o`3o
I_oo00000_ooV@001Ol0I_ooooooooooooooV@3o0?mV00;ooooo027o06Kooooooooooooo0?oool`0
oolco`3oooooo`1VoooooooooiT0olco0?lc0?ooooooolco0?ooooooc?l0oonI0?o<o`3oo`2Iolco
0?oo003oo`2Io`3oooo<o`3o<ol0o`3oI_o<0?ooc?l0ool0VOl0ofKoc03ooc?o0?l0I_l00_ooool0
2?lco`3ooiT0ool00?ooooooc03oolco0?l0oooo0?mV0_ooool02Ol0ofKo06Koo`3oool0ofKooooo
oonI0?o<o`3ooooooonI0002ooooo`0>olco0?l0ofKo<ol0ooooool0I_oo0?oooc<0oooooooo0?mV
o`3oooooV@3o06Koolco0?l0ool4ooooo`07oc?o0?o<0?oooiT0oc<0oooooooooiT0o`3oo`02oooo
o`09o`3oI_ooooooo`2Iolco0?oooooo<`3oo`3oooooooooc03o00Cooooo00?o<ol0oonI0?ooool0
1Oooool00ol0003oooooooooo`02ooooo`002?ooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooooooo00Cooooo00Oo<ol0oooooooooooooooooc<0ooo<0?ooc?l000;ooooo00Coo`00oooo
ooooooooo`2I1?ooool2oc?o000AoonI0?oooooo06Koo`3ooooooooo<ol0o`3ooooooooo<`3oo`3o
oolco`3oooooool0VOl0ofKooooooc<0ooo<o`000_ooool2oonI0003o`3oI_l0oooooooo00;ooooo
00[o06Koooooooooooooo`00oonI0?o<o`3oo`2Io`3ooooo09Wo<ol01oooool02?lco`3oc?l0oonI
0?oo003ooiT0ool0VOoooooo0?mV1Oooool01_ooV@3oooooooooooooV@3oo`2Iool000;ooooo00co
oiT0ool0VOo<0?ooooooo`3oI_l0oooo<ol0oonI0?ooooooc?l0ooooool0ool2ooooo`06ol`0oolc
o`3o06Kooooooooo09Wo<ol00_ooool01?l0ofKo<ol0oonI0?lc0?l2ooooo`06oonI0?lco`3o0?oo
olco0?oooooo0?oo0_o<o`001_ooV@3o<`3ooooooooooooo0?mVool000?ooooo00Oo0?oooc?o0?oo
oooo<ol0oonI0?oo003o<ol000;ooooo00?oc?l0o`3oI_ooool00_ooV@001Ol0I_oooooooooooooo
V@3o0?mV00?ooooo023o06Koooooool0ooooo`00oc?o0?oooooo06KoooooooooV@3oc?l0oc<0ooo<
0?ooc?l0o`3oI_ooV@3oc?l0ooooooo<0?ooc?l0ool00?l0I_oo0?ooolco0?lco`3o0?mVooooooo<
o`3oo`2Io`3oI_o<0?oo<ol0o`1Vo`;ooooo00?o<ol0oonI0?oo00000_ooool03_o<o`3o0?ooo`3o
I_oooooo0?mVool00?l0I_oo0?ooool00?l0ofKooiT0olco0?oooooooiT00_ooool03_o<o`3o0?mV
oooooolco`3o06Koo`3ooolc0?ooooooo`3oI_ooV@3o<ol0o`1Vooo<o`3o0?oo0oooool02?lco`3o
oooool`0ooooV@3o<`3oooooooooV@3o0?oo0_ooool02_l0ofKoooooool0VOo<o`3ooooooc<0ool0
oooooooool`0oooo09T3ooooo`03oc?o0?ooV@3ooooo00Gooooo00?o0000ooooooooool00_ooool0
00Sooooo00Co0000oooooooooooo00001?ooool3o`0000Cooooo00?o<ol0ooooooooool00_ooool0
0olc0?ooc?l0o`3oo`02ooooo`03ool00?ooooooo`2I00?ooooo013o<ol0o`1Voolco`3ooiT0oooo
ool0ooooc03ooooooolco`3o0?oooooooolc0?oo0?oooc?o0?oooooo0?mV0_ooool01olc0?ooc?l0
oooooooooooo0?oooonI0?l0ofH00_l0ool2ooooo`0;o`1Vooooooooooooool00?ooV@3oc?l0oooo
ool0oooooooool`0oolco`001Oooool02Olco`3oooooolco0?ooV@3oo`00oc?o0?oo09Woc03oo`3o
IP05ooooo`06oonI0?oooooooooooonI0?oo09Woo`000_ooool03?ooV@3oo`2Iol`0oooooooo0?mV
o`3ooolco`3ooiT0ooooooo<o`3oooooo`3oo`;ooooo00Koc03ooc?o0?l0I_ooooooool0VOlco`02
ooooo`04o`3oI_oo09WooiT0oc<0o`;ooooo00KooiT0ooooool0ooooc?l0ooooooo<0?l2olco0006
oonI0?lc0?ooooooooooool0ofKoo`000oooool01ol0oooo<ol0oooooolco`3o06KooonI0?lco`00
0_ooool02_o<o`3o<`3ooonI0?oooooooiT0ool00?oo09WooooooonI0?l0ofH3ooooo`08o`1Voooo
oooo0?ooo`1Voolco`3oooooo`1Vooooool2oonI000Fooooooo<0?ooc?l0o`3oI_ooV@3oc?l0ool0
VOo<0?ooooooolco0?l0I_oo0?ooolco0?lco`3o0?mVooooooo<o`3o0?mVoooooolc0?oo<ol0o`1V
o`;ooooo00?o<ol0oonI0?oo00000_ooool02oo<o`3o0?ooo`3oI_oooooo0?mVool00?l0I_oo0?oo
ool00?l0ofKooiT000;ooooo01;ooiT0ooooooooooooc?l0o`3oI_ooooooo`00oc?o0?l0oooo<`3o
ool0VOlco`3ooiT0oc?o0?l0I_ooc?l0ooooool0ool2ooooo`0;oc?o0?ooooooo`00oonI0?lc0?oo
oooooonI0?l0ooooooooo`3oI_l0I_l00oooool01oo<o`3o<`3oo`3oooooooooc03oool0VOlco`00
0_ooool00olco`3ooiT0ooooo`03ooooo`?o00001?ooool000Sooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`03ooooo`04ool0VOlco`3oooooo`1Vo`;ooooo00?o06Koooooooo<
o`000_ooool00ooo003oooooool0V@03ooooo`0@oc?o0?oo09Wo<ol0oonI0?oooooo0?ooo`1Voooo
oooo<ol0o`3ooooooooo<`3oo`3ooooooooo<ol0olco00;ooooo00Wo<`3oolco0?ooooooooooo`3o
oolco`3o0?mVool0VOl0ool00_ooool02ol0I_ooc03oool00?oooooo<ol0oonI0?o<o`3o0?oooooo
oooo09Wo<ol000?ooooo00_oo`00oooooolco`3oo`00oonI0?l0oooooooooc?o0?oo09Woc03oo`3o
IP04ooooo`07oc?o0?ooV@3oooooooooooooV@3oo`2Iool00002o`1Vo`0<oonI0?oo09Woc03ooooo
ool0ofKooooooc?o0?ooV@3oooooolco0?lc0?oo0?oo0_ooool01_o<0?oo<ol0oooooooo09Wo<`3o
oc?o00;ooooo00?o0?mVool0VOooV@000_lc0?l01ooooooooiT0ooooool0ooooc?l0ooooooo<0?l0
0_o<o`001_ooV@3o<`3ooooooooooooo0?mVool000?ooooo01?o<ol0o`3oI_o<0?oo0?mVoc?o0?oo
V@3o<ol0ooooool0ooooc?l0oc<0ooooV@3oooooo`1VooooV@3oo`2IoonI0?oooooooiT000?ooooo
00[o06Koooooool0oooo06Kooc?o0?ooooooo`2IoonI0?l0ofKoc?l00_ooV@001Oo<o`3o0?mVoonI
0?o<o`3oc03o00;ooooo01;oc?l0o`1Vooo<o`3oc03ooc?o0?l0ofKooooool`0ooo<o`3ooooooc<0
oolco`3oooooo`1Voolco`3o0?mVoonI0?oo0002ooooo`0;olco0?l0oooo0?mVoonI0?l0ofKo06Ko
ooooool0ooooooooo`3oI_ooV@000oooool02?ooV@3oooooolco0?l0ofKoooooool00?lco`3o0?oo
0_lco`001ol0ofKooiT0oc?o0?l0I_ooc?l0ooooool0ool00_ooool02olco`3oooooo`3oI_o<0?oo
oiT0ooooooooV@3o0?ooooooool0ofKo06Ko00?ooooo00Ooc?l0oc<0ool0oooooooool`0oooo09Wo
<ol000;ooooo00?o<ol0oonI0?ooool01Oooool00ol0003oooooooooo`02ooooo`002?ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo00?ooooo00?oo`2Ioc?o0?ooool00_l0I_l0
1?oooooo06Koooooooo<o`02ooooo`04ool00?ooooooooooool0V@;ooooo01Wo<ol0ool0VOlco`3o
oiT0ooooool0oooo06Kooooooolco`3o0?oooooooolc0?oo0?oooooooolco`3oc?l0oooooolc0?oo
ooooolco0?oo09Woooooo`3ooolco`3o0?mV00;ooooo00ko0?oooooooolc0?oo06Koool00?oooooo
<ol0oonI0?o<o`3o0?oooooooooo09Wo<ol0ol`0o`;ooooo00_oo`00oooooolco`3oc?l0oonI0?l0
oooooooooc?o0?ooooooc03oo`3oIP04ooooo`0Doc?o0?ooV@3ooooooonI0?o<o`3ooiT0ool0VOl0
I_oooooooonI0?oo09Woc03oooooool0ofKooooooc?o0?l0oooooiT0olco0?l0ool2o`1Vo`07oooo
ooo<0?oo<ol0oooooooo09Wo<ol0o`3oo`02ooooo`0@o`3oI_ooV@3o<ol0ool00?lc0?oooooooonI
0?l0ooooooooolco0?ooooooc03oolco0?oo003ooiT0oc<0o`;ooooo00?o0?mVool00?ooool00_oo
ool05?lco`3o0?ooo`3oI_oooooo<ol0oonI0?lco`3oo`2Io`3oooo<o`3o<`3ooonI0?oooooo06Ko
oonI0?oo09WooiT0ooooooooV@3o0?mV0_ooool2o`1Vo`03o`3ooooooooo<ol000;ooooo00GooiT0
o`3oI_o<o`3oc03oolco0002oonI0003ool0VOo<0?ooo`2I00;ooooo01koc?l0o`1Vooo<o`3oc03o
oc?o0?oooooo0?mVol`0ooo<o`3ooooooc<0oolco`3oooooo`1Voolco`3oc?l0oonI0?ooooooo`00
ooooooo<o`3o0?ooooooooooV@3o0?mVo`1Voooooooo0?ooooooooooV@04ooooo`0>oonI0?oooooo
c03oolco0?ooooooo`00o`1Voolco`3o0?oooc<0ool0ofKooiT0oc?o0?o<o`02ooooo`07o`3ooooo
oooooooooc?o0?oooooo0?mVooooo`02oonI0005oc?o0?l0ooooooooo`3oI_l0I_l00oooool01_o<
o`3o<`3oo`3oooo<0?ooooooool0V@?o<ol000?o0?oooonI0?ooool01Oooool00ol0003ooooooooo
o`02ooooo`002Oooool2o`0000Gooooo00?o0000ooooooooool00oooool02Ooo09Wo<ol0ooooool0
I_ooooooo`1Voolc0?ooooooolco0002ooooo`04ool00?ooooooooooool0V@;ooooo00ko<ol0ool0
VOlco`3ooiT0ooooool0oooo06Kooooooolco`3o0?oooooooooo003o0?ooool0V@;oc?l000Wooooo
oc<0ooooooooc?l0ool0VOoooooo0?ooo`1Vool0ofH00_ooool01?l0oooooooooc<0ool0ofH2o`1V
o`08o`3oooooV@3oc?l0o`3oooooooooo`2Ioc?o0?o<0?l2ooooo`05ool00?lco`3o<`3oolco0?oo
V@000_ooool01?lco`3o06Koo`1Vool0ofH2ool000;ooooo01Ko<ol0oonI0?oooooooiT0olco0?oo
V@3oo`2Io`1VoooooooooiT0ool0VOo<0?ooooooo`3oI_oooooo<ol0oc<0ooooV@3oc?l0o`3ooolc
0?oooooo0_l0I_l01Olco`3oo`2Ioooooolco`3o0?oo00;ooooo01Co0?mVoonI0?lco`3oc03ooc<0
oooooooo<ol0oonI0?ooooooc?l0ool0VOo<0?ooc?l0ool00?ooV@3o<`3oooooool0ofKo06Koool0
00?ooooo01Co<ol0o`3oool0ofKooooooc?o0?ooV@3oc03oool0VOl0ooooc?l0oc<0ooooV@3ooooo
o`1VooooV@3oo`2IoonI0?oo003ooiT0o`3oIP;ooooo00Go06Koool0VOl0ooooo`2Ioc?o0002o`3o
o`08oonI0?ooooooc?l0ol`0ooo<o`3ooooooonI0?ooool2ool0V@;ooooo00Koc?l0ooooooo<o`3o
c03ooc?o0?ooool2o`3oIP?oc?l001Co<ol0ooooool0I_oo<ol0olco0?ooV@3oc?l0ool00?oooooo
c?l0o`3ooooooooooiT0o`1Voolc0?ooooooo`3ooooooooooiT0o`3oIP?ooooo00kooiT0ooooooo<
0?ooc?l0oooooooo003oooooo`1Vool0oooo<`3oo`3oI_ooV@3oooooolco00;ooooo00?o0?oooooo
oolco`000_ooool01Ol0ofKoo`2IoonI0?ooV@3o<ol000;ooooo00?o0?mVo`1Voolc0?l00_ooool0
1oo<o`3o<`3oo`3oooo<0?oooooooc?o0?oo09T00_lco`000ol0oooooiT0ooooo`05ooooo`03o`00
0?oooooooooo00;ooooo000@ooooo`;o00001?ooool01?oo09Wo<ol0ooooool0I_l2ooooo`03oc<0
ooooooooc?l000;ooooo01_oo`00ooooooooooooo`2Ioooooooo09Wo<ol0ool0VOlco`3ooiT0oooo
ool0oooo06Kooooooolco`3o0?oooooooooo003o0?ooooooooo<o`3oooooolco0?lc0?oo<ol0olco
0?oo09T00_ooool00ol0oooo0?mVooooo`02ooooo`07o`3ooolc0?oo0?mVol`0oooooooo0?oooonI
0003olco000:ool0VOlco`3oc03ooooooooo003ooooooc?o0?oo003oc?l0oonI00;ooooo00Ko<ol0
ool00?l0I_oo0?mVoooooooo0002ooooo`0Eoc?o0?ooV@3ooooooonI0?o<o`3ooiT0o`1Voooooooo
oiT0oc?o0?l0ofKoc03oo`3oI_l0oooo<ol0oooooolc0?oooiT0olco0?l0I_oo<`3o00;ooooo00?o
c03ooc?o0?lco`000_lco`005ol0ooooooooooooool0ofKooiT0oc?o0?o<0?oo<`3ooooooolco`3o
oiT0oooooooo09Woc?l0ooooooo<o`3oc03ooonI0?lc0?ooooooo`3oI_lco`3oo`0000?ooooo01Co
<ol0ooooool0oooo0?oooc?o0?ooV@3oc03oool0VOo<o`3oo`00oc<0ooooV@3oooooo`1VooooV@3o
o`2IoonI0?oo003ooiT0o`3oIP;ooooo013oo`2Ioooooooo09Wo0?oooc?o0?l0oooooiT0o`3ooooo
ooooc?l0ol`0ooo<o`3oooooo`3oI_ooooooo`2I0oooool01_o<o`3oooooolco0?lco`3o06Kooooo
o`;o0?mV00oooooool`0oolc0?ooc?l0ooooool0I_oo<ol0olco0?oooooooiT0ool00?o<o`3o0?mV
o`3oooooool00_ooV@001_lc0?ooooooo`3ooooooooooiT0o`3oIP?ooooo00kooiT0ol`0oooooooo
c?l0oooooooo003oo`2Io`1Vool0oooo<`3oooooooooV@3oooooolco00;ooooo00?o0?oooooooolc
o`000_ooool2o`3oIP08oc<0ooooV@3o<ol0ooooool0ofKo<`3oooooool0I_l2ooooo`07olco0?oo
003o0?oool`0oooooooo<ol0ool0V@02oc?o0003o`3oooooV@3ooooo00Cooooo0_l00004ooooo`00
4?ooool00ol0003oooooooooo`04ooooo`03oc?o0?oooooo06Ko00;ooooo00Ko<`3ool`0oooooooo
c?l0oooooooo0002ooooo`0Hool0VOooooooo`2Ioc?o0?oo09Wo<ol0oonI0?oo09Wo0?oool`0ool0
I_oo<ol0o`3ooooooooo0?oooc<0ooo<o`3o<ol0ooooooo<o`3o<`3ooc?o0?o<o`3oo`2I0_ooool0
0ol0oooo0?mVooooo`03ooooo`0Co`3oool0ofKo0?mVo`3oool0ofKooiT0ool00?oooooo0?ooolco
0?lco`3oc03ooooooooo003ooooooc?o0?ooooooc?l0oonI0002ooooo`04oc?o0?ooooooo`2Io`3o
IP;ooooo03Koo`00oooooolco`3ooiT0ooooooooV@3oc?l0oonI0?l0I_ooo`2IoonI0?l0ofKo<ol0
ol`0ool0ofKo0?oooc?o0?oooooo<`3ooonI0?o<o`3o06Kooooooolc0?oooooool`0oooo09Wooooo
oc<0oooooooo0?oooc<0ooooooooo`2IoonI0?lco`3ooooooc<0oolco`3ooooooonI0?ooooooo`2I
olco0?ooooooc?l0ool0VOooV@3o<`3oooooool0ofKo<ol0oooooooo0002ooooo`04oc?o0?oooooo
c03ool`0o`;o<ol000kooiT0ooooooo<o`3oo`00oc<0ooooV@3oooooo`1Voolc0?oooiT0oooooooo
003ooooooonI00;ooooo013o<`3ooooooooo003o0?oooc?o0?o<0?oooiT0o`1Vool0ooooc?l0ol`0
ooo<o`3oooooo`3oI_ooooooo`2I0oooool05oo<o`3oooooolco0?lco`3o06Koooooool0ofKoc03o
ooooooo<0?ooooooolco0?lco`3o06Kooc?o0?o<o`3ooooooonI0?oo003oc?l0o`3oI_l0oooooooo
00;ooiT000Ko<`3oooooool0oooooooooonI0?l0ofH3ooooo`0>oonI0?o<0?oo0?mVolco0?oooooo
o`00ool0VOl0I_oo0?oooc<0ooooV@3o0?mVooooooo<o`02ooooo`0?o`3ooooooooo<ol0ooooool0
ofKoooooo`3oI_lc0?ooc03ooc?o0?oooooo0?mVoc<0oooooooo06Ko00;ooooo00_oc?l0ool00?oo
oooo0?oooooooolco`3oo`2Ioooooolco`3o0?oooonI0006ooooo`03o`000?oooooooooo00;ooooo
000@ooooo`03o`000?oooooooooo00Cooooo00?o<ol0o`1Vooooool00_ooool01_lc0?ooc03ooooo
ooo<o`3o0?ooool000;ooooo01Soo`2Ioooooooo09Wo<ol0oooooolco`3ooiT0o`3oooooooooc03o
oc?o0?oooooo0?ooooooool0oooo<`3oolco0?lco`3oooooolco0?lc0?oo<ol0olco0?oo09T2oooo
o`03o`1Vool0ofKooooo00?ooooo00oo<`3oo`3oI_l0ofKoooooo`3oI_ooV@3oo`00ooooool0oooo
c?l0oc?o0?ooooooc03oool00?lco`000_ooool02?ooV@3o0?ooooooooooooooc03ooc?o0?oo09Wo
0?mV0_ooool01?oo003ooooooc?o0?ooool2oonI000BooooooooV@3o06Koool0VOooV@3o0?mVoc?o
0?o<0?oo0?mVo`3ooolco`3ooooooc<0ooooV@3oc?l0o`1Voooooooo<`3o0_ooool08_o<0?oooooo
oc<0ooooooooo`2Io`3oooo<0?oooooooonI0?lco`3ooooool`0oolco`3ooooooonI0?oo09Wooooo
olco0?ooooooc?l0o`1VooooV@3o<`3oo`3oI_l0I_oo<ol0oooooooo003ooooooc?o0?oo09Woc03o
ooooooo<0?l2oc?o0003oonI0?ooooooc?l000;ooooo00WooiT0ooooool0I_ooo`2IoonI0?oo09Wo
o`00ooooooooV@000_ooool02_lc0?ooooooool00?l0ofKo<ol0ol`0ooooV@3o06Koo`3oool0ofH2
olco0004o`3oI_ooooooooooo`1Vo`;ooooo00Ko06Koolco0?ooooooc?l0oc?o0?l0I_l2ooooo`0@
ool0VOo<0?ooc03oooooooo<o`3o<ol0o`1Voolco`3oc?l0o`3oI_ooV@3oo`00olco0?l0ofKo0?oo
ooooo`;ooiT000Ko<`3oooooool0oooooooooonI0?l0ofH3ooooo`0>oonI0?o<0?oo0?mVolco0?oo
ooooo`00ool0VOl0I_oo0?oooc<0ooooV@3o0?mVooooooo<o`02ool0V@0<o`3ooolco`3ooooooooo
ool0ofKoooooo`3oI_lc0?ooc03oo`3ooolco`3o0?mV0_ooool03ol0I_ooooooooooooo<o`3ooooo
ool00?l0oooooooooc?o0?oo09Woooooo`1Vool0oooooiT0o`3oIP05ooooo`03o`000?oooooooooo
00;ooooo000@ooooo`03o`000?oooooooooo00Cooooo00?o<ol0o`1Vooooool00_ooool01olc0?oo
c03oooooooo<o`3o0?oooooooooo00000_ooool04Ooo09Wooooooc?o0?ooooooo`2IoonI0?l0oooo
c03ooc?o0?l0I_ooooooo`3ooooooooo0?oooc<0ooo<o`3o<ol000;ooooo0_o<o`001_ooooooo`2I
oooooooooooo06Koo`3oIPCooooo00Ko0?mVooooool0ofKoc03oo`3oI_ooV@02ool00005o`3oooo<
o`3oo`2Ioc?o0?o<0?l00_lco`001?ooooooc?l0oonI0?l0ool2ooooo`04ol`0oolco`3oooooo`3o
IP;ooooo00goo`00ool0VOlco`3ooooooonI0?oo09WooooooonI0?l0I_oooooooonI0?oo09Wo<ol0
00;o0?mV00Wo0?oooc?o0?oooooo<`3ooonI0?o<o`3o06Kooooooolc0?l00_ooool02_o<0?oooooo
oc<0ooooooooo`2Io`3ooolc0?ooc03ooonI0?lc0?l2oc?o000=oc<0oooooooooiT0ool0VOoooooo
c?l0ooooooo<o`3ooiT0olco0?oooooo0?mVo`1Vo`02oc?o000<ool00?oooooo<ol0ooooooo<0?oo
oooool`0oooo09Wo<ol0oonI0?ooooooc?l00_ooool02_ooV@3o06Kooooooooo09Wo<`3oool0VOoo
ooooo`00oonI0?ooool2oc<0o`09oooooooo003o0?mVoc?o0?o<0?oooiT0ool0VOl0I_oo0?mV00;o
c?l000Co0?mVoooooooooooo06Ko0_ooool01Ol0I_ooooooolco0?l0oooo<ol000;ooooo017oo`2I
ooooooo<0?ooc03oooooooo<o`3o<ol0oooooolco`3oc?l0o`3oI_ooV@3oo`00olco0?oooooo0?oo
ooooo`02oonI0007oc<0oooooooo0?ooooooooooV@3oo`00o`3oIP03ooooo`0AoonI0?l0ofKoc?l0
oooooooo003oo`2Io`1Vool0oooo<`3ooonI0?l0ofKoooooolco0?oo09Woooooool0VOlco`000_oo
ool02?l0ofKoooooool0VOl0ofKoc03oo`3ooolco`3o0?mV0_ooool02?l0I_ooooooooooooo<o`3o
ooooool00?l0oooo<ol00_ooool01Ooo09Wo06Koo`3oooooV@3o0?mV00Gooooo00?o0000oooooooo
ool00_ooool0013ooooo00?o0000ooooooooool01Oooool02olco`3ooooooooooooooooo<`3ool`0
ooooooooc?l0ooooool0ooooo`0000;ooooo017oo`2Ioooooolco`3ooooool`0ooooV@3o0?oool`0
oolco`3o06Koooooool0ooooooooo`3oooo<o`3o0?mVoc?o0002ooooo`;oc?l000Koooooool0VOoo
ooooooooo`1Vool0ofH4ooooo`03o`3oI_oooooooooo00;o0?mV00KooiT0oooooooooooo0?ooolco
0?lc0?l2oc?o0005ool00?lc0?ooooooolco0?ooV@000oooool01Oo<0?oo<ol0oc<0oooo09Wo0?mV
00;ooooo00coo`2Ioc?o0?l0I_oooiT0ool0VOooooooc?l0oonI0?oooooooiT0ool0VOlco`02o`3o
IP06o`3ooolco`3ooooooc<0ooooV@3oc?l00oooool03?lc0?oooooooonI0?oooooo<`3ooooooooo
09Wo0?oooc<0oooooooooiT0oc<0o`;o<ol000Go<`3oool00?ooV@3o<`3oooooo`02olco000Woooo
ooooV@3oc?l0ooooool0ofKo<ol0oooooolco`3oo`00oooooolco`3ooooool`0ooooooooc03oool0
VOlco`3ooiT0ooooooo<o`3oo`2IooooooooV@3o06Kooooooooo09Wo<`3oool0VOooooooo`00oonI
0?l0ofKoo`2Ioooooolc0?ooo`00o`3oI_lco`3ooiT000;ooooo00Go06Koo`3oI_o<o`3oc?l0o`3o
IP02ooooo`;o06Ko00Koooooo`1Vooooooooc?l0o`3ooolco`02ooooo`03ool0VOooooooc03o00;o
oooo01Go<`3oolco0?ooooooc?l0ooooool0ofKooiT0ool00?o<o`3ooooool`0ooooV@3o06Koool0
0?ooV@3oooooo`3ooooooooooiT0ool00?l0ofH00oooool03OooV@3o0?mVolco0?oo003oo`2Ioooo
ool0I_oo0?oooc<0ooooV@3o0?mVooooooo<o`000oooool02olco`3oooooooooool0ofKoooooool0
VOl0ofKoc03oo`3ooolco`3o0?mV00;ooooo00So06Kooc?o0?lc0?ooc?l0oooooooo003o0?oooc?o
00;ooooo00Go06Koooooool0oooooiT0o`3oIP05ooooo`03o`000?oooooooooo00;ooooo000@oooo
o`;o00001_ooool03?lco`3ooooooooooooooooo<`3ool`0ooooooooc?l0ooooool0ooooo`00ol`0
o`;ooooo00Go<ol0ooooooo<0?ooo`2IoonI0002oc?o000;ooooool0I_ooooooo`3ooooooooo0?oo
olco0?l0ofKo<ol0oooooolc0?l00_o<o`001_ooooooo`2Iooooool0I_ooooooo`3oIPCooooo00?o
0?mVooooooooool00_l0ofH01_ooV@3oooooooooool0ooooooooolco00;ooiT000Ko<`3ooooooooo
ooooc?l0oonI0?lc0?l2ooooo`05ol`0oolco`3o<`3oool0VOl0ofH00_ooool03?oo09Wo<ol0o`1V
ooooV@3o06Koool00?o<o`3ooiT0ooooooooV@3ooooooc?o00;o0?mV00Ko0?oooc?o0?oooooo<`3o
oonI0?o<o`03ooooo`0<oc<0oooooooooiT0oooooolc0?ooooooool0VOl0ooooo`2Ioc<0ooooV@3o
oooo0_lco`001Olc0?ooo`00oonI0?lc0?oooooo00;oc?l000[ooooooonI0?o<o`3o0?mVo`1Voolc
o`3ooooooc?o0?oo003o<ol00_ooool06Oo<0?ooo`00ooooooo<0?oo<ol0oonI0?l0ooooc?l0ool0
VOooV@3oooooo`1Vooooooooo`2Ioc<0oooo09Woooooool00?ooV@3o0?mVool0VOoooooo<`3oool0
0?l0ofH00_ooV@001_o<0?ooooooo`1Vool0ofKoc?l0o`3oIP?ooooo0_l0I_l01_oooooo06Kooooo
ooo<o`3o0?oooc?o00?oo`2I00?ooooool`0ooooool00_ooool05?o<o`3oooooolco0?oooooo0?mV
oonI0?ooooooc?l0oooooooo09WooiT0o`1Voooo003ooiT0ooooool0oooooiT0ool0VOoo003o0?mV
0oooool03OooV@3o0?mVooooooo<o`3oo`2Iooooool0I_oo0?oooc<0ooooV@3o0?mVolco0?lco`00
0_ooool03?lco`3o0?ooool0VOoooooo0?mVoooooolc0?oo0?mVooooool0oooo<ol0oc<0o`;ooooo
00So06Kooc?o0?lc0?ooc?l0oooooooo003o0?oooc?o00;ooooo00Co06Koo`3ooooooooooiT01Ooo
ool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00Gooooo00So<ol0oooooooooooooooooc<0
ooo<0?ooooooolco00;ooooo01So0?oool`0oooooooooooooc?o0?ooooooc03oool0VOooV@3o0?mV
ol`0oooooooo<`3oo`1Vool0ooooo`00o`3oooo<o`3o<`3ooc?o0?oooooo<`3oooooooo<o`02oooo
o`05ool0VOl0I_oooooool`0ool0ofH00oooool00ol0ofKoooooooooo`02o`3oIP09oonI0?oooooo
ooooo`3oooooooooc?l0oonI0?lc0?oooiT000;ooooo00[oc?l0oonI0?lc0?oooooool`0oooooooo
<ol0oc<0oooo09Wo0?mV0_ooool05?lco`3oo`2Io`1Voooooooo06Koool00?o<o`3ooiT0oooooooo
V@3ooooooc?o0?oooooo0?mVo`3ooolco`3ooooooc<0ooooV@3oc?l00oooool07olc0?oooooooonI
0?oooooo<`3oooooooo<0?oo0?ooool0VOlc0?oooiT0oooooolco`3ooooooc<0oooo003o0?oooonI
0?oo003o<ol0olco0?oooooooiT0olco0?l0ofKo06Kooc?o0?oooooo<ol0ol`0oolco`000_ooool0
8Oo<0?ooo`00ooooooo<0?oo06KooonI0?o<o`3oooooool0VOooV@3oooooo`1Vooooooooo`2Ioooo
oolc0?ooooooool00?oooooooiT0ool0VOoooooo<`3oool00?ooV@3o<ol0ooooooo<0?ooooooool0
VOlc0?ooc?l0o`3oIP03ooooo`?o06Ko00Goo`00oooooooooooo<ol0o`1Vo`02ooooo`03ool0VOoo
oooooooo00?ooooo00Koc?l0ooooooo<o`3oooooo`3oI_ooV@02olco000<oooooooo09WooiT0oooo
oooo003ooiT0ooooool0oooooiT0ool0VOoo003o0?mV0oooool03OooV@3o0?mVooooooo<o`3oo`2I
ooooool0I_oo0?oooc<0ooooV@3o0?mVolco0?lco`000_ooool01?lco`3o0?ooooooool0ofH2oooo
o`05oc<0oooooooo0?mVo`3oI_lco`000oooool02?l0I_oo<ol0oc?o0?ooooooc?l0ol`0ool0oooo
<ol00_ooool01Ol0I_oo0?ooool00?oooooooiT000Gooooo00?o0000ooooooooool00_ooool0013o
oooo00?o0000ooooooooool01Oooool02?lco`3ooooooooooooooooo<`3ool`0ooooooooc?l00_oo
ool06?l0ooooc03ooooooooooooo<ol0ooooooo<0?ooo`2IoonI0?l0ofKoc03ooooooolc0?oo06Ko
o`3ooooo003o0?ooolco0?lc0?oo<ol0oooooolc0?oo<ol0olco00;ooooo00Goo`2Io`1Voooooooo
c03oo`3oIP03ooooo`0;o`3oI_lc0?ooooooooooool0ofKooiT0oooooolc0?oo0?ooooooooooV@00
0_lc0?l04OoooooooiT0oonI0?ooV@3o0?oooc<0ooooooooc03ooooooolco`3o<`3oool0VOl0ofKo
06Koool0VOlco`3o06Ko00;ooooo013o06Koool00?l0I_oooiT0ooooooooV@3ooooooc?o0?oooooo
0?mVo`3ooolco`3ooooooc<0oooooooooiT00oooool02olc0?oooiT0ol`0ooooV@3o<`3oooooooo<
0?ooo`2Io`3oooooV@3o0?mV00Cooooo013o<`3oo`3oooooV@3oc03ooc?o0?o<o`3ooooooonI0?o<
o`3o0?mVo`1Voolco`3ooooooc?o0?o<0?oo<ol00_ooool02oo<0?ooo`00ool0VOo<0?oo06KooonI
0?o<o`3oooooool0VOooV@3o06Ko00;ooooo00goo`2Ioooooolc0?ooooooool00?lc0?oooiT0ool0
VOoooooo<`3oool00?ooV@3o<ol000;ooooo0_o<0?l00olc0?ooc?l0o`3oIP02ooooo`05o`1Voooo
ooooooooo`1Voooo00000_ooool00olco`3o06Koooooo`07ooooo`08olco0?ooooooc?l0ooooool0
ofKooiT0olco0?l0ofH2ooooo`0:oonI0?oooooo<`3ooonI0?o<0?oo0?oooonI0?ooooooo`00o`3o
IP?ooooo00gooiT0o`3oI_ooooooc?l0ool0VOoooooo06Koooooool0oooooiT0ooooooo<o`3o<ol0
00;ooooo00Co<ol0oc<0ool0oooo0?mV0_ooool01Olc0?ooooooo`3oI_l0oooo<ol000?ooooo00So
<ol0oc<0oolco`3oooooolco0?o<0?oo0?oooc?o00;ooooo00Go06Koolco0?oo003ooooooonI0005
ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Gooooo00Ko<ol0oooo
oooooooooooooc<0ooo<0?l2ooooo`04olco0?o<0?ooo`00o`3oo`;ooooo00Ko<ol0ol`0oooooooo
o`2IoonI0?l0ofH2ooooo`0;oc<0ool0I_ooooooo`3oool0ofKoc?l0oc<0oooooooo<ol0oc<0oolc
o`000oooool01Ooo09Wo06Koooooooo<0?oo0?mV00;ooooo00?oc03oo`3oI_lc0?l00_ooool02Ol0
ofKooiT0oooooolc0?ooooooo`3oooooV@3o<`3ool`0o`02ooooo`0?olco0?ooV@3o0?oooc<0oooo
ooooc03ooooooolco`3o<`3oool0VOl0ofKo06Koool0VOlco`3o06Ko00;oo`2I00_o06Koooooool0
I_oooiT0ooooooooV@3ooooooc?o0?ooooooc03ooc?o0003ooooo`03oc<0ooooV@3ooooo00?ooooo
00?ooiT0ooooooooV@000_ooool01Oo<0?ooo`2Io`3oooooV@3o0?mV00Cooooo00ko0?ooool00?oo
V@3o<`3ooc?o0?o<o`3ooooooonI0?o<o`3o0?mVo`1Voolco`3ooooool`0o`;o<ol00_ooool01oo<
0?ooo`00ool0VOo<0?oo06KooonI0?o<o`000_ooool01?ooV@3ooooooooooooo09T2ooooo`0;oc<0
oooooooooooooc<0ooooV@3o0?mVoooooooo003o0?mVoonI0?lco`000_ooool2ol`0o`03oc<0ooo<
o`3o0?oo00;ooooo00Go06Kooooooooooooo<ol0ool00002ooooo`03oc?o0?oooooooooo00Oooooo
00?oc?l0oc<0ooo<o`000_ooool03oooV@3oc?l0o`3oI_oo003ooooooonI0?oooooo<`3ooonI0?o<
0?oo0?oooonI0?ooooooo`00o`3oIP03ooooo`05oonI0?l0ofKoooooolco0?oo09T00_ooool02_l0
I_oooiT0oc<0ooooooooc?l0oc?o0?oooooo<ol0oc<0ooooool2o`3oIP;ooooo00Go<`3ooooooooo
oooo0?oooc?o0003ooooo`0?oc?o0?lc0?oo<ol0ooooooo<o`3oc03ooc?o0?l0ooooooooo`1Voooo
ooooc?l0ool00?oooooooiT000Gooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000oooo
ooooool01Oooool01_lco`3ooooooooooooooooo<`3ool`0o`;ooooo01[oc?l0ol`0oooo003o0?oo
ol`0oooooooo<ol0ol`0oooooooooiT0ooooool0ofKooooooc<0oooooooo06Koooooool0ooooc?l0
oooooolc0?oooooooc?o0?lc0?oo<ol0o`1Vo`;ooooo00Goo`2Io`1Vooooooooo`2Io`3oIP02oooo
o`03ol`0ool0ofKo<`3o00?ooooo01WooiT0oooooolc0?ooooooo`3oooooV@3oo`2Iool00?o<0?oo
ooooolco0?l0oooooooooc<0ooooooooc03ooooooolco`3o<`3oooooool0ofKoooooo`1Voolco`3o
06Ko00;oo`2I00?o06Koooooool0I_l00_ooV@001_l0ofKooooooc?o0?ooooooc03ooc?o00?ooooo
00?o<`3ooonI0?ooool00oooool00oooV@3ooooooonI0002ooooo`05ol`0oooooooooiT0ooooool0
ofH01?ooool03?l0ooooo`00oonI0?ooV@3o<ol0ooooooooV@3oooooolco0?l0ofKooooooc?o00;o
c03o00_o<ol0ol`0ooooooooc03oool0VOoo003oo`2Iol`0ool0I_ooc?l0oonI0002ooooo`04oonI
0?ooooooooooool0V@;ooooo00_o<`3ooooooooooooo<`3ooonI0?l0ofKoooooo`3oI_ooV@3ooooo
oc?o0003ooooo`07ol`0oolc0?oo0?mVo`3ooooo003oooooo`1Vo`02ooooo`05oc?o0?oo003ooooo
oooooolco`002Oooool00oo<o`3o<`3oolco0002ooooo`09oonI0?o<o`3o0?mVool00?oooooooiT0
ol`0oolc0?oooooo00;ooiT000Coo`2Ioooooooo003o0?mV0oooool01OooV@3o0?mVoooooooo09Wo
c?l000;ooooo00So06KooonI0?lc0?ooooooolco0?lco`3ooooooc?o00;o0?mV00Go0?oooc<0oooo
09Wooooooc<0o`02ooooo`03o`3ooolco`3ooooo00;ooooo00So<ol0oc<0oooooooo<ol0olco0?o<
0?oo<ol0o`3oo`;o06Ko00Goooooolco0?o<o`3ooooooonI0005ooooo`03o`000?oooooooooo00;o
oooo000@ooooo`;o00001Oooool00ol0I_oo<ol0ooooo`02ooooo`0Boc<0ooooooooc03oooooooo<
o`3oooooool00?l0ooooc03ooooooolco`3oc03oooooooooV@3oooooo`3oI_oooooo<`3o0_ooool2
o`3oIP04olco0?oooooo<`3oooooo`;o<ol000Woooooo`1Vooooooooooooool0VOl0I_ooooooool0
VOl0ofH00_ooool00ol0ofKooooooc<0o`03ooooo`0<oonI0?lc0?ooooooooooooooV@3oc?l0ool0
VOooooooc03oooooooo<o`3o0?oo0_ooool02olc0?ooc03ooooooolco`3o<`3oooooool0ofKooooo
ool0VOlco`3ooooo00;oo`2I00?oooooo`1Vooooool00_ooV@001_l0ofKooooooooooolco`3ooooo
oc?o00?ooooo00?o<`3ooonI0?ooool00_ooool01?ooV@3o<`3oooooooooV@02ooooo`05ol`0oooo
oooooiT0o`3oool0ofH01?ooool04?l0ooooo`00oooooolc0?oooiT0ooooooooV@3oooooolco0?l0
I_oo<ol0ooooooo<0?oooooooc?o0?oo0002ol`0o`0:ool0VOooooooo`2Iooooooo<o`3ooooooonI
0?oooooooiT0o`1Vo`;ooooo00Coo`2Ioooooooooooo<`3o0_ooool02?lc0?oooiT0o`3oI_oooooo
0?mVoonI0?oooooo<ol01?ooool01_lc0?ooooooo`3oooooooooo`00o`1Vo`;ooooo0_lco`02oooo
o`03oc?o0?oooooooooo00Oooooo017oc?l0oc?o0?o<o`3o06KoooooooooV@3oooooo`3oI_oo003o
oooooonI0?o<0?oo<`3oooooooooV@3oooooool0V@02ooooo`09o`3oI_ooooooooooooooool0ofKo
oiT0oooooooo09Woc?l000;ooooo00Ko06KooonI0?lc0?ooooooolco0?ooool2oc?o0004o`3oI_oo
oooo0?oooc<0o`;oo`2I00Ko<`3oooooool0ooooc03ooooooolco`02ooooo`08oc?o0?o<0?oooooo
oc?o0?o<o`3oc03ooc?o0?l0ool3ooooo`;oc?l000?ooooooonI0?ooool00oooool2o`0000Cooooo
000@ooooo`03o`000?oooooooooo00Cooooo00?o06Kooc?o0?ooool00oooool01?lc0?ooc03ooooo
ooo<o`02ooooo`0@o`3oooo<0?oooooooc?o0?o<0?oooooooonI0?oooooo0?mVoooooolc0?oooooo
o`3oI_l0I_oo0?ooolco00;ooooo00Go<`3ooc?o0?lco`3oooooo`1Vo`02ooooo`04o`1Voooo09Wo
ooooool0V@Co0?mV00?ooooooc<0ooooool00oooool02oooV@3oooooooooooooV@3oooooolco0?oo
ooooc03oooooooo<o`3o0?oo00;ooooo00Co<`3ool`0oooooooo<ol00_ooool00ol0ofKooooooc?o
0003ooooo`07ool0VOoooooo06Koooooooo<o`3ooiT0o`3oIP02ooooo`03oc?o0?oooooo<ol000?o
oooo00?o<`3ooonI0?ooool00_ooool02oooV@3o<`3ooooooolc0?oooiT0ooooooo<0?oooooooonI
0?l0oooo0?mV00Cooooo00Ko0?oool`0oooooooo<`3oooooooooV@02ooooo`03olco0?oooooo<ol0
00Gooooo0_o<0?l01_oo09Woooooool0VOooooooc?l0ooooo`;ooiT000Goooooo`1Voooooooooooo
ool0V@02ooooo`0;oc<0oooooooo<`3oool00?oo09WooiT0o`3oI_oo003ooiT0oooooolco`000ooo
ool01olc0?ooooooooooool0I_oo0?ooool00?l0I_l00_ooool01Olco`3ooooooc?o0?lco`3o0?oo
00Wooooo017o<ol0olco0?lc0?oo06KoooooooooV@3oooooo`3oI_oo003ooooooonI0?oo003o<`3o
ooooool0ooooooooool0V@02ooooo`0Aool00?l0ofKoooooooooool0ofKooiT0oooooooo003ooooo
olco0?oooooo06KooonI0?lc0?ooc?l0o`3oI_ooool00_lco`001?l0ofKoooooooooool0ool2ool0
V@06oc<0oooooooo0?ooooooooo<0?oo<ol00_ooool02?lco`3oc03ooooooolco`3oc?l0oc?o0?l0
I_oo0?oo0_ooool01Ooo003oc?l0olco0?oooooooiT000Gooooo00?o0000ooooooooool00_ooool0
013ooooo00?o0000ooooooooool01?ooool00ol0I_oo<ol0ooooo`03ooooo`0Foc<0ooo<0?ooc03o
ooooooo<o`3oooooo`3oooo<0?oooooooc?o0?o<0?oooooooonI0?l0oooo0?mVoooooolc0?oooooo
o`3oI_l0I_oo0?ooolco00;ooooo00?o<`3ooc?o0?lco`000_l0I_l2ooooo`05o`1Voooo09Woo`2I
ooooooo<0?l00_ooool00ol0ofKooooooc<0o`04ooooo`0;oonI0?oooooooooooonI0?l0ooooc?l0
ool0VOo<0?ooc?l0ooooool0ool00_ooool01?lc0?ooc03ooooooolco`02ooooo`03o`3oI_oooooo
<ol000?ooooo00Koo`2Iooooool0I_ooooooo`3oooooV@03ooooo`04oc?o0?l0oooo<ol0o`1Vo`?o
oooo00oooiT0oooooooooooooooooonI0?lc0?oooooooc<0ooooV@3ooooool`0ooooV@3oooooo`3o
ool0ofH01?ooool01_l0ooooc03ooooooolc0?oooooooc?o00;ooooo00?oc?l0oooooolco`001Ooo
ool00ooo003oc03oool00002ool0V@0:ooooooo<o`3ooooooonI0?oooooo06Kooooooooo09Wooooo
ool0V@;ooooo00_o<`3oool0VOlc0?ooo`00ool0VOooV@3oooooool00?ooV@3ooooooc?o0003oooo
o`0:oc<0ooooooooooooo`1Vool0ooooo`00o`1Voooooooo<ol0ool000;ooooo00?o<ol0o`3ooooo
ool02Oooool01_o<o`3oooooo`1VoooooooooiT0o`3oIP;ooooo00So06KooonI0?oo003o<`3ooooo
ool0ooooooooool0V@;ooooo017oo`00o`3oI_ooooooooooo`3oI_ooV@3oooooool00?ooooooc?l0
ooooool0I_oooiT0oc<0ooo<o`3o0?mVooooo`02oc?o0004o`3oI_ooooooooooo`3oo`;oo`2I00Ko
<`3oooooool0oooooooool`0ooooool2oc?o000>ooooool0I_ooc03oooooooo<o`3oc03oo`1Vool0
ooooooooool00?o<o`3oooooool0VOo<o`06ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03
o`000?oooooooooo00Cooooo00?o06Kooooooolco`000oooool05_lc0?ooc03oooooooooooooc?l0
ooooool0ooooc03ooooooolco`3oooooolco0?ooV@3o0?ooo`3oI_oooooo<`3oo`3oI_oooooo06Ko
o`3oooo<o`02ooooo`08oc<0oolco`3oooooo`1Voooooooo06Koooooool0I_l2ool0V@04ooooooo<
0?oooooool`0o`;ooooo00?o<`3oooooooooool00_ooool01OooV@3ooooooonI0?oooooo0?oo00Co
c?l000goooooo`3ooooooooooooooc<0ooo<0?oooooooc<0oolco`3oooooo`3oI_lco`3oo`2I00Oo
oooo00?o0?oooonI0?ooool00_ooool01?lco`3o0?oooc?o0?l0I_l3ooooo`0<oonI0?oooooooooo
ooooooooV@3o<`3ooooooolc0?oooiT0ol`0oooooooooiT00_ooool00ol0oooo0?mVooooo`02oooo
o`06o`3oooo<0?ooo`00ol`0oolc0?oo<ol00_ooool00oo<o`3ooooooc?o0005ooooo`03ool00?oo
ooooo`0000;oo`2I00?oc?l0o`1Vooooool00_ooool01Ol0I_ooooooool0VOooooooo`2I00?ooooo
0_lc0?l02Oooooooo`2IoonI0?ooooooo`00oonI0?lc0?oooooooc?o0002ooooo`0:oc<0oooooooo
ooooooooool0ooooo`00o`1Voooooooo<ol0ool000;ooooo00?o0?ooooooooooool02Oooool00oo<
o`3oooooo`1Vo`02ooooo`0:oonI0?ooooooooooo`1VooooV@3oo`00oc<0oooooooo0?oool`0o`?o
oooo00Ooo`00o`3oI_ooooooooooo`3oI_ooV@3oo`0000?ooooo00Woc?l0oonI0?oooooo<`3oolco
0?l0I_oo0?mVoc?o0?l0ofH00oooool02Ol0oooo<`3oool0VOlc0?ooooooo`3oooooooooc03ooooo
o`02oc?o0003ooooool0I_ooc03o00;ooooo00Woc?l0o`1Voooooooo0?ooool00?o<o`3oooooool0
VOo<o`001_ooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Gooooo00?o06Kooooooolc
o`000oooool05Olc0?ooooooooooooooooooc?l0oooooooo003o0?oooooooolco`3oooooolco0?oo
V@3o0?ooo`3oI_oooooo<`3oo`3oI_oooooo06Koolco0002ooooo`09o`1Voooooooo<`3oooooool0
I_ooooooo`1Voooooooo06Ko00;oo`2I00?ooooool`0ooo<0?l00oooool02_lc0?oooooooooooooo
oooo<`3ooonI0?oooooooiT0ooooool0ool2ooooo`04ol`0ooooooooooooo`3oo`?ooooo00Oo<`3o
oooooolc0?oo<ol0ooooool0ofKo<ol000Sooooo00?o0?ooolco0?ooool00_ooool00olco`3o0?oo
oc?o0002o`1Vo`;ooooo00_ooiT0oooooooooooooiT0oooooolc0?oooooooc<0ooooV@3oc03ooonI
0003ooooo`06o`3oool0ofKoooooooooool0oooooooo0_o<0?l00ooooooo<`3ooc?o0002ooooo`03
olco0?oooooo<ol000Gooooo00Ooo`00oooooooo003oo`2Iooooooo<o`3o06Ko00?ooooo00Go06Ko
oooooooo09Woooooool0V@03ooooo`;o<`3o00Woo`2Iool00?ooV@3ooooooonI0?oooooo<`3ooooo
oolco`000_ooool02_lc0?oooooooooooooooooo06Koo`3oool0I_oooooooc?o0?oo0002ooooo`03
o`3ooooooooooooo00Wooooo00Ko<ol0ooooool0I_oo<`3oooooooooV@02ooooo`07o`1VooooV@3o
oooooc<0oooooooo0?oool`0o`03ooooo`07ool00?l0ofKoooooooooool0ofKooooooonI0003oooo
o`09olco0?ooV@3ooooooc<0ooo<o`3o06Koo`3oI_lco`3o0?mV00?ooooo00So0?oooc<0oooo09Wo
<`3oooooool0oooooooool`0o`;ooooo00Co<ol0ol`0ool0I_ooc03o0_ooool02Oo<o`3o06Kooooo
ool0ooooooooolco0?ooooooo`2Iolco0005ooooo`;o00001?ooool0013ooooo00?o0000oooooooo
ool01?ooool00ol0I_oooooooc?o0003ooooo`03oc<0oooooooooooo00;ooooo00koc?l0ool00?l0
oooo<ol0ol`0ooooooooc?l0oonI0?l0oooo0?mVoooooolc0?oo0?mVooooo`;oc?l000_oooooo`1V
ool0I_oooooooc<0oooooooo06Koooooool0I_ooooooo`1Vo`02ool0V@03ooooooo<0?oooooo00?o
oooo00Go<`3ooooooooooooooooooc<0o`02oonI00?ooooo00?o0?ooooooooo<0?l00_ooool02ol0
oooooooooooooooooooo<`3ooooooolc0?oo<ol0oooooolco`3oo`2I00Wooooo00coc?l0oooooooo
oooooooooc?o0?l0oooo<ol0ooooool0I_ooooooolco0?ooV@02ooooo`04oonI0?oooooooooooc<0
o`;ooooo0_ooV@03ooooo`06o`3oool0ofKoooooooooool0oooooooo0_o<0?l00ooooooo<`3ooc?o
0002ooooo`03o`3oI_o<o`3o<ol000Gooooo0_oo00001_ooooooo`2Iooooooo<o`3oooooo`1Vo`;o
oooo00Co06Kooooooooo09Woo`2I1?ooool02olc0?ooo`2Ioooooooo003ooiT0ooooooooV@3ooooo
oc<0oooooooo<ol000;ooooo00[o<`3oooooooooooooooooo`1Vool0oooo06Kooooooolco`3oo`00
0_ooool00ol0ooooooooooooo`09ooooo`06oc?o0?oooooo06Kooc<0oooooooooiT00_ooool01ol0
I_oooiT0oooooolc0?ooooooo`3oooo<0?l01?ooool01_l0ofKooooool`0ool0ofKooooooonI00?o
oooo00Woc?l0oonI0?l0I_oo<`3oolco0?l0I_oo0?mVoc?o0?l0ofH00oooool02?l0oooo<`3oool0
VOlc0?ooooooo`3oooooooooc03o0oooool00oo<0?oo06Kool`0o`02ooooo`0:olco0?oo003ooooo
o`3oooooooooc?l0oooooooo09Woooooolco00Gooooo00?o0000ooooooooool00_ooool000Sooooo
0ol00005ooooo`03o`000?oooooooooo00Cooooo00?o06Kooooooolco`000oooool00olc0?oooooo
ooooo`02ooooo`0:olco0?oo003o0?oooc?o0?o<0?ooooooolco0?ooV@3o0?ooooooo`;o0?mV00?o
ooooolco0?ooool00_l0I_l01Ooooooo06Kooooooooooooo06Ko00;ooooo00Go06Koooooool0I_oo
ooooool0V@07ooooo`04oc<0oooooooooooooc<0o`;ooiT00oooool01Ol0ooooooooooooooo<0?oo
0?oo00?ooooo00Coc03ooc<0oolc0?oooooo0_lco`000ooooooo0?mVooooo`08ooooo`0<olco0?oo
oooooooooooooolco`3o0?oooc?o0?oooooo06Koooooooo<o`3ooiT00_ooool01?ooV@3ooooooooo
oolc0?l2ooooo`03oonI0?oooooooooo00?ooooo00Co0?mVoooooooooooo0?oo0_ooool01?o<0?oo
oooooc<0oolco`02ooooo`03o`3oI_o<o`3o<ol000Kooooo00Ooo`00oooooooo09Woooooolco0?oo
oooo06Ko00;ooooo00Co06Kooooooooo09Woo`2I1?ooool01olc0?oooooooooooooo003ooiT0oooo
ooooV@000_ooool01Olc0?oo<ol0oooooooooooo<`3o00?ooooo00Ko06Koo`3ooooo003ooooooc?o
0?oo0002ooooo`03o`3ooooooooooooo00Wooooo00oo<ol0ooooool0I_oo<`3oooooooooV@3ooooo
o`1VooooV@3o0?oooooooolc0?ooooooo`3oooo<0?l01?ooool01ol0ofKooooool`0ool0ofKooooo
ool00?ooV@000_ooool02Oo<o`3ooiT0o`1Voolc0?ooc?l0o`1Vool0ofKoooooo`3oIP03ooooo`06
o`3ooolc0?oooooooc<0oooooooo0?oo0_ooool03_o<0?ooooooooooooo<0?oo06Koooooooo<0?oo
ooooolco0?oo003oooooo`3oooooooooc?l00_ooool00ooo09Woc?l0ooooo`04ooooo`03o`000?oo
oooooooo00;ooooo0009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0I_oooooooc?o0003ooooo`03oc<0oooooooooooo00;ooooo00[oc?l0ool00?l0oooo<ol0ol`0
ooo<o`3o0?oooonI0?oo09Wooooo0_l0ofH01?ooooooc?l0ooooool0I_l3ooooo`03o`1Voooooooo
06Ko00;ooooo00Go06Koooooool0I_ooooooool0V@07ooooo`05oc<0oooooooooooooc<0ooooV@00
1?ooool01Ol0ooooooooooooooo<0?oo0?oo00?ooooo00Goc03ooooooolc0?oooooooc?o0002oooo
o`03o`3oI_oooooooooo00Oooooo00Oo0?mVolco0?oooooooooooc?o0?l0oooo<ol000;ooooo00?o
06Koolco0?ooV@000_ooool01?ooV@3ooooooooooolc0?l8ooooo`03o`3oI_oooooo0?oo00?ooooo
00Soc03ooooooolc0?oo<ol0ooooool0ofKoooooolco00Oooooo00Ooo`00ooooooooooooooooolco
0?oooooo06Ko00;ooooo00Co06Koooooooooooooo`2I1oooool01?oo003ooiT0ooooooooV@02oooo
o`05oc<0oolco`3ooooooooooolc0?l00oooool01Ol0I_oo0?ooool00?oooooo<ol000?ooooo00?o
0?ooooooooooool03?ooool02?l0I_oooooooonI0?oooooo06KooonI0?oo09Wo0?oo0_ooool00ol0
ooooc03oooooo`03ooooo`03o`3oI_oooooo0?mV00;ooooo00?oo`00ooooooooV@000_ooool02?oo
V@3o06Koolco0?lc0?ooooooo`3oI_oooooo0?mV1?ooool01Ol0oooo<`3ooooooooooooo0?oo00;o
oooo00Koc03oooooooooooooc03oo`1Vooooool2ol`0o`03olco0?oo003oo`0000;o0?oo00Coc?l0
ooooooooooooo`2I1_ooool00ol0003oooooooooo`02ooooo`002Oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00?ooooo00Co06Kooooooooooooo<ol00oooool00olc0?oooooooooo
o`03ooooo`09olco0?l0oooo<ol0ooooooo<o`3o<`3ooonI0?lc0?oooooo00;o0?mV00?oc?l0oooo
oooo00001?ooool00ol0I_ooooooo`1Vo`03ooooo`04o`1Vooooooooooooool0V@Oooooo00Co<`3o
oooooooooooo<`3o1Oooool01Ol0ooooooooooooooo<0?oo0?oo00?ooooo00?oc03oooooooooool0
1?ooool00ol0ofKoooooooooo`07ooooo`04o`3oI_o<o`3oooooooooo`;o<ol000Ko06Kooooooooo
oooo06Koolco0?ooV@02ooooo`04oonI0?oooooooooooc<0o`Sooooo00?o0?mVooooool0ool01_oo
ool01Olco`3o0?mVo`3oI_ooooooc?l000[ooooo00Koc?l0oooooooooooo06Koooooool0I_l3oooo
o`03ool0VOoooooooooo00Kooooo00?oo`00oonI0?ooV@000oooool01?lco`3o<`3ooc<0oolc0?l4
ooooo`04o`1Vool0oooooooooc?o00?ooooo00?o0?ooooooooooool03?ooool02?l0I_oooooooonI
0?oooooo06KooonI0?oo09Wo0?oo0_ooool00ol0ooooc03oooooo`03ooooo`03o`3oI_oooooo0?mV
00;ooooo00?oo`00ooooooooool00_ooV@002?o<o`3oooooolco0?lc0?ooooooo`3oI_oooooo0?mV
1?ooool01?l0oooo<`3oooooool0ool3ooooo`06ol`0oooooooooooool`0ool0I_oooooo0_o<0?l0
1_l0I_ooc?l0ool00?oooooo0?ooolco00;ooooo00?oo`2Iooooooooool01?ooool00ol0003ooooo
ooooo`02ooooo`002Oooool00ol0003oooooooooo`04ooooo`?o00000oooool01Ol0I_oooooooooo
oooooooo<ol000;ooooo00?o<`3oooooooooool00oooool02oo<o`3o0?oooc?o0?ooooooc?l0oooo
ooooV@3oo`2Ioc<0ool0ofKoc?l000;ooooo00?oo`00ooooooooool00_ooool00ol0I_ooooooo`1V
o`03ooooo`03o`1Voooooooooooo00Wooooo00?o<`3ooooooolc0?l01_ooool01?l0oooooooool`0
ool0ool3ooooo`03ol`0oooooooooooo00Cooooo00?o0?mVooooooooool01oooool01ol0ofKoc?l0
oooooooooooo0?oooc?o0?l0I_l00_ooool01Ol0I_ooc?l0oonI0?oooooooiT000cooooo00?o0?mV
ooooool0ool01Oooool01_l0ofKo<ol0ooooool0ofKoooooolco00[ooooo00Koc?l0oooooooooooo
06Koooooool0I_l<ooooo`03ool00?ooV@3ooooo00?ooooo00?o<ol0ooooooooool01Oooool01?l0
I_oo0?oooc?o0?oo0003ooooo`03o`3ooooooooooooo00cooooo00co06KoooooooooV@3ooiT0oooo
ooooV@3oo`2Io`3ooooooooo0?ooool0VOo<0?l4ooooo`03o`3oI_oooooo0?mV00;ooooo00goo`00
oooooooooooooooooonI0?o<o`3oooooolco0?lc0?ooooooo`3oI_oooooo0?mV00Cooooo00Co0?oo
oc<0oooooooo0?oo0oooool01_o<0?ooooooooooooo<0?ooooooo`1Vo`;oc03o00Ko06Koolco0?oo
003oooooo`3oooo<o`02ooooo`03ool0VOoooooooooo00;ooooo0ol00004ooooo`002Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00Go06Kooooooooooooooooooc?o0002
ooooo`03oc<0oooooooooooo00?ooooo00Ooc?l0o`3ooolco`3oooooolco0?oooooooiT000?oc?l0
0oooool00ooo003oooooooooo`03ooooo`03o`1Voooooooooooo00;ooooo00?o06Koooooooooool0
2Oooool2oc<0o`Oooooo00Co0?ooooooooo<0?oo0?oo0oooool00oo<0?ooooooooooo`04ooooo`03
o`3oI_oooooooooo00Kooooo00?o0?mVooooooo<o`000_l0ool00ooooooo<ol0ooooo`03ooooo`04
olco0?oooooooiT0oonI00cooooo00?o0?mVo`3oooooool01Oooool01_l0ofKo<ol0oooooolc0?oo
ooooolco00[ooooo00Koc?l0oooooooooooo06Koooooool0I_l<ooooo`03ool00?ooV@3ooooo00?o
oooo00?o<ol0ooooooooool01_ooool00ol0oooo<ol0ool00003ooooo`03o`3ooooooooooooo00co
oooo00Co06Kooc<0oooooooo06Ko0_ooV@001_oo09Wo0?ooo`3oooooooooo`2Iol`0o`Cooooo00?o
0?mVool00?l0ofH00_ooool00ooo003oooooooooo`02ooooo`04olco0?ooooooc?l0oc<0o`;ooooo
00?o0?mVoc<0ooooool00oooool01?l0oooo<`3oooooool0ool4ooooo`05ol`0ooooooooc03ooooo
ool0I_l00_o<0?l00ol0I_ooc?l0ooooo`02ooooo`04olco0?ooooooooooool0V@Kooooo00?o0000
ooooooooool00_ooool000Sooooo0_l00006ooooo`03o`000?oooooooooo00?ooooo00Go06Kooooo
oooooooooooooc?o0002ooooo`03oc<0oooooooooooo00?ooooo00Soc?l0o`3ooolco`3oooooolco
0?oooooooiT0olco00Gooooo00?oo`00ooooooooool00oooool00ol0I_ooooooooooo`0>ooooo`;o
<`3o1oooool01?l0oooooooool`0ool0ool3ooooo`03ol`0oooooooooooo00Cooooo00?o0?mVoooo
ooooool01_ooool00ol0ofKoooooolco0003ooooo`03oc?o0?oooooooooo00;ooooo00Coc?l0oooo
ooooV@3ooiT03?ooool00ol0ofKo0?ooooooo`05ooooo`06o`3oI_lc0?oo<ol0oc<0ooooooooc?l0
2_ooool01_o<o`3oooooooooool0I_ooooooo`1Vo`cooooo0_oo0004ooooo`03oc?o0?oooooooooo
00Kooooo00?o0?oooc?o0?oo00000oooool00ol0ooooooooooooo`0=ooooo`06o`1Voooooooo06Ko
ooooooooV@3oo`2I0_l0ool00oooooooo`2Iol`0o`04ooooo`03o`3oI_oo003o0?mV00;ooooo00?o
o`00ooooooooool00_ooool01?o<o`3oooooolco0?lc0?l2ooooo`03o`3oI_lc0?oooooo00?ooooo
00Co0?oooc<0oooooooo0?oo1?ooool03?o<0?oooooool`0oooooooo06Koooooooo<0?oo06Koool0
0?o<o`3oooooolco00Cooooo00?oo`2Iooooooooool00oooool00ol0003oooooooooo`02ooooo`00
2Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o<ol0oooooolc0?l0
1_ooool01oo<o`3o<ol0ooooooo<o`3ooooooonI0?oo00001Oooool00ooo003oooooooooo`0Eoooo
o`03oc<0oooooooooooo00Gooooo00Co0?oooooooooooooo0?oo0_ooool00oo<0?ooooooooooo`05
ooooo`03o`3oI_oooooooooo00Kooooo00?o0?mVooooooo<o`000oooool00olco`3oooooolco0002
ooooo`04olco0?oooooooiT0oonI00cooooo00?o0?mVooooooooool01Oooool01_l0ofKooooooc?o
0?lc0?ooooooolco00[ooooo00Koc?l0oooooooooooo06Koooooool0I_l<ooooo`;oo`001?ooool0
0olco`3oooooooooo`06ooooo`03o`3ooolco`3oo`0000?ooooo00?o0?ooooooooooool03Oooool0
0olc0?oo06Koooooo`03ooooo`05o`3oooooooooo`2Iooooooo<0?l01Oooool2o`3oIP;ooooo00?o
o`00ooooooooool00_ooool01?o<o`3oooooolco0?lc0?l2ooooo`03o`3oI_lc0?oooooo00?ooooo
00Co0?oooc<0oooooooo0?oo1?ooool2ol`0o`?ooooo0_l0I_l2ooooo`03olco0?ooooooc?l000Co
oooo00?oo`2Iooooooooool00oooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003ooooo
ooooo`08ooooo`03oc?o0?oooooo<`3o00Kooooo00?oc?l0oc?o0?o<o`000_ooool00oooV@3oo`00
ooooo`04ooooo`03ool00?oooooooooo01kooooo00?o0?ooooooool0ool00_ooool00oo<0?oooooo
ooooo`05ooooo`03o`3oI_oooooooooo00Kooooo00?o0?mVooooooo<o`001Oooool2olco0003oooo
ooo<o`3ooooo00;ooiT03?ooool00ol0ofKoooooooooo`04ooooo`07o`3oI_oooooooooooc?o0?lc
0?ooooooolco0009ooooo`07olco0?ooooooooooooooool0I_ooooooo`1Vo`0=ooooo`03ool00?oo
oooooooo00;ooooo00?o<ol0ooooooooool01_ooool00olco`3oooooool00002ooooo`03o`3ooooo
oooooooo00kooooo00?o<`3oooooooooool00oooool01Olc0?ooooooool0VOooooooc03o00Gooooo
0_l0ofH2ooooo`03ool00?oooooooooo00?ooooo00?oc?l0oooooolc0?l00oooool00olc0?oooooo
ooooo`02ooooo`03o`3ooooooooo0?oo00Gooooo0_o<0?l3ooooo`;o06Ko0oooool2olco00Cooooo
00?oo`2Iooooooooool00oooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Wooooo00?o
<ol0oooooolc0?l01Oooool01?lc0?ooc?l0oc?o0?o<o`02ooooo`03oonI0?oo003ooooo00Cooooo
00?oo`00ooooooooool07_ooool00ol0ooooooooo`3oo`02ooooo`03ol`0oooooooooooo00Kooooo
00?o0?mVooooooooool01Oooool01?l0ofKoooooooooooo<o`04ooooo`06olco0?ooooooc?l0olco
0?oooooooiT03Oooool00ol0ofKoooooooooo`04ooooo`07o`3oI_oooooooooooc?o0?oooooo<ol0
olco0009ooooo`03olco0?oooooooooo00;ooooo0_l0I_l=ooooo`03ool00?oooooooooo00;ooooo
00?o<ol0ooooooooool01Oooool00olco`3o0?ooool00003ooooo`03o`3ooooooooooooo00kooooo
00?o<`3oooooooooool00_ooool01?lc0?ooo`2Ioooooooo09T2ooooo`03ol`0oooooooooooo00;o
oooo00Co0?mVol`0ooooooooo`001_ooool00oo<o`3ooooooc<0o`02ooooo`03oc<0oooooooooooo
00?ooooo00?o0?ooooooool0ool01_ooool01?o<0?ooooooooooooooool2o`1Vo`?ooooo0_o<o`09
ooooo`;o00001?ooool0013ooooo00?o0000ooooooooool02Oooool00olco`3o<`3oooooo`04oooo
o`04oc<0ooo<o`3o<ol0olco00;ooooo00?ooiT0oooooooo00001?ooool00ooo003oooooooooo`0N
ooooo`;o0?oo00?oc03oooooooo<0?l02Oooool00ol0ofKoooooooooo`05ooooo`04o`3oI_oooooo
ooooolco00?ooooo00Ooc?l0ooooooooooooooooolco0?oooooooiT000gooooo00?o0?mVoooooooo
ool01?ooool02?l0ofKooooooooooolco`3ooooooc?o0?ooooooc?l02?ooool00oo<o`3ooooooooo
o`02ooooo`03o`1Voooooooooooo017ooooo00?o<ol0ooooooooool01Oooool00olco`3oooooo`3o
o`02ooooo`03o`3ooooooooooooo00oooooo00?o<`3oooooooooool00_ooool00olc0?ooo`2Iool0
V@03ooooo`03ol`0oooooooooooo00;ooooo00Co0?mVol`0ooooooooo`001_ooool00oo<o`3ooooo
oc<0o`02ooooo`03oc<0oooooooooooo00?ooooo00?o0?ooooooool0ool01_ooool00oo<0?oooooo
ooooo`02ooooo`03o`1Voooooooooooo00;ooooo00?oc?l0ooooooooool02?ooool00ol0003ooooo
ooooo`02ooooo`004?ooool00ol0003oooooooooo`09ooooo`03oc?o0?oooooo<`3o00Cooooo00Co
<`3oolco0?l0ooooc?l00_ooool00oooV@3oooooool00004ooooo`03ool00?oooooooooo01kooooo
0_l0ool00oo<0?oooooool`0o`09ooooo`03o`3oI_oooooooooo00Gooooo00Co0?mVoooooooooooo
c?l00oooool00oo<o`3oooooooooo`0Aooooo`03o`3oI_oooooooooo00Cooooo00So0?mVoooooooo
oooo<ol0oooooolco`3oooooolco00Sooooo00?oc?l0ooooooooool00_ooool00ol0I_oooooooooo
o`0Aooooo`03oc?o0?oooooooooo00Cooooo00Co<ol0oooooooooooo0?oo0_ooool00ol0oooooooo
ooooo`0?ooooo`03oc<0oooooooooooo00;ooooo00?o<`3oool0VOoo09T00oooool00oo<0?oooooo
ooooo`02ooooo`04o`3oI_o<0?ooo`00ool000Sooooo00Co<`3ooooooooooooo<`3o1_ooool2o`3o
oa_ooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool02Oooool00olco`3o
oooooc<0o`04ooooo`04oc<0ooo<o`3o0?ooolco00;ooooo00?ooiT0oooooooo00001?ooool00ooo
003oooooooooo`0Nooooo`;o0?oo00?ooooool`0ooo<0?l02_ooool01?l0ofKoooooo`3oI_l0ofH3
ooooo`04o`3oI_ooooooooooolco00?ooooo00?oc?l0ooooooooool04Oooool00ol0ofKooooooooo
o`03ooooo`09o`3oI_oooooooooooooooolco`3ooooooc?o0?ooooooc?l000Sooooo00?oc?l0oooo
ooooool00_ooool00ol0I_ooooooooooo`0Aooooo`03oc?o0?oooooooooo00Cooooo00?o<ol0oooo
ooooool00_l0ool00ooooooo0?ooooooo`0@ooooo`03oc<0oooooooooooo00;ooooo00?o<`3oool0
VOoo09T00oooool00oo<0?ooooooooooo`02ooooo`04o`3oI_o<0?ooo`00ool000Wooooo00?o<`3o
oooooolc0?l01_ooool2o`3ooa_ooooo00?o0000ooooooooool00_ooool0013ooooo0_l0000:oooo
o`03oc?o0?oooooo<`3o00?ooooo00Go<`3oooooooo<o`3o0?ooolco0002ooooo`04oonI0?oooooo
ooooool000;ooooo00?oo`00ooooooooool08?ooool00ol0oooooooool`0o`0;ooooo`;o0?mV00Go
ooooo`3oI_ooooooooooo`3oIP04ooooo`04olco0?ooooooooooolco01Cooooo00?o0?mVoooooooo
ool00_ooool01ol0ofKooooooooooooooooo<ol0oooooolco`000_ooool00oo<o`3oooooooooo`05
ooooo`03olco0?oooooooooo01Kooooo00?o<ol0ooooooooool01?ooool00olco`3oooooooooo`02
ooooo`03o`3ooooooooooooo013ooooo00?o<`3oooooooooool00_ooool00olc0?ooo`2Iooooo`03
ooooo`03ol`0oooooooooooo00?ooooo00?oc03oool00?oo00002Oooool00olc0?oooooooc<0o`06
ooooo`03o`3ooooooooooooo01Wooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`09oooo
o`03oc?o0?oooooo<`3o00?ooooo00Co<`3ooooooolco`3oc?l00oooool01?ooV@3ooooooooooooo
0002ooooo`03ool00?oooooooooo023ooooo00?o0?ooooooooo<0?l03_ooool01?l0ofKooooooooo
ool0ofH4ooooo`04olco0?ooooooooooolco01Cooooo00?o0?mVooooooooool00_ooool01ol0ofKo
oooooooooooooooo<ol0oooooolco`000_ooool00oo<o`3oooooooooo`05ooooo`03olco0?oooooo
oooo01Oooooo00?o<ol0ooooooooool00_ooool00olco`3oooooooooo`0Fooooo`07oc<0oooooooo
oooooooooolc0?ooooooool0V@04ooooo`03ol`0oooooooooooo00?ooooo00?oc03ooooooooo0000
2Oooool00olc0?oooooooc<0o`06ooooo`03o`3ooooooooooooo01[ooooo00?o0000ooooooooool0
0_ooool0013ooooo00?o0000ooooooooool02_ooool00olco`3o<`3oooooo`02ooooo`04oc<0oooo
oooo<ol0olco00;ooooo00?ooiT0ooooooooool00_ooool00ooo003oooooool0000cooooo`04o`3o
I_ooooooooooo`3oIPGooooo0_o<o`0Eooooo`03o`3oI_oooooooooo00;ooooo00?o0?mVoooooooo
ool00_ooool2oc?o00;ooooo00?oc?l0ooooooooool01?ooool00oo<o`3oooooooooo`0Hooooo`03
oc?o0?oooooooooo00;ooooo00?o<ol0ooooooooool05_ooool01Olc0?oooooooooooooooooo<`3o
00Kooooo00?oc03oooooooooool00_ooool00oo<0?ooooooooooo`0:ooooo`;o<`3o9?ooool00ol0
003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`0:ooooo`03oc?o0?lc0?oooooo00;o
oooo00Co<`3ooooooolco`3oc?l00_ooool00oooV@3oooooooooo`03ooooo`;oo`00=?ooool00ol0
ofKoooooo`3oIP05ooooo`;oc?l05Oooool00ol0ofKoooooooooo`02ooooo`03o`3oI_oooooooooo
00;ooooo00?o<ol0ooooooooool00_ooool00oo<o`3oooooooooo`03ooooo`03olco0?oooooooooo
01Sooooo00?o<ol0ooooooooool00_ooool00olco`3oooooooooo`0Gooooo`04oc<0oooooooooooo
oc<0o`Kooooo00?oc03oooooooooool00_ooool00oo<0?ooooooooooo`0:ooooo`03oc<0oooooooo
oooo02?ooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool02_ooool00olc
o`3o<`3oooooo`02ooooo`03oc<0oooooooo<ol000?ooooo00?ooiT0ooooooooool01?ooool00ooo
003oooooooooo`0booooo`03o`3oI_oooooo0?mV00Kooooo00?oc?l0ooooooooool04oooool00ol0
ofKoooooooooo`02ooooo`03o`3oI_oooooooooo00;ooooo00?o<ol0ooooooooool00_ooool00oo<
o`3oooooooooo`03ooooo`03olco0?oooooooooo01Wooooo00Co<ol0oooooooooooo<ol06_ooool0
1?lc0?oooooooooooolc0?l7ooooo`05ol`0ooooooooooooooooooo<0?l0<_ooool00ol0003ooooo
ooooo`02ooooo`004?ooool2o`0000Cooooo00?ooiT0ooooooooool01?ooool00olco`3o<`3ooooo
o`02ooooo`03oc<0oooooooo<ol000?ooooo00?ooiT0ooooooooool0>Oooool00ol0ofKoooooo`3o
IP0Looooo`05o`3oI_ooooooooooooooool0ofH01Oooool00olco`3oooooooooo`03ooooo`03olco
0?oooooooooo00;ooooo00?oc?l0ooooooooool06Oooool01?lco`3ooooooooooolco`0Jooooo`03
oc<0oooooooo<`3o00Sooooo00Goc03ooooooooooooooooool`0o`0aooooo`;o00001?ooool0013o
oooo00?o0000ooooooooool00oooool00oooV@3oooooooooo`04ooooo`03oc?o0?lc0?oooooo00;o
oooo00?o<`3ooooooolco`000oooool00oooV@3oooooooooo`0iooooo`03o`3oI_oooooo0?mV01co
oooo00Go0?mVooooooooooooooooo`3oIP05ooooo`03oc?o0?oooooooooo00?ooooo00?oc?l0oooo
ooooool00_ooool00oo<o`3oooooooooo`0Iooooo`04oc?o0?oooooooooooc?o01[ooooo0_lc0?l9
ooooo`05ol`0ooooooooooooooooooo<0?l0<_ooool00ol0003oooooooooo`02ooooo`004?ooool0
0ol0003oooooooooo`03ooooo`03oonI0?oooooooooo00Gooooo00Co<ol0oooooooooooo<`3o0_oo
ool01Olco`3ooooooooooooooooooiT003_ooooo00?o0?mVooooool0ofH07?ooool01Ol0ofKooooo
oooooooooooo0?mV00_ooooo00?oc?l0ooooooooool00_ooool00oo<o`3oooooooooo`0Jooooo`;o
<ol06oooool2oc<0o`[ooooo00Coc03oooooooooooooc03o<_ooool00ol0003oooooooooo`02oooo
o`004?ooool00ol0003oooooooooo`04ooooo`03oonI0?oooooooooo00Cooooo00Co<ol0oooooooo
oooo<`3o0_ooool01Olco`3ooooooooooooooooooiT003_ooooo00?o0?mVooooool0ofH07?ooool0
1Ol0ofKooooooooooooooooo0?mV00cooooo00Goc?l0ooooooooooooooooolco000Looooo`03oc?o
0?oooooooooo01[ooooo00?o<`3oooooooooool02Oooool01?o<0?ooooooooooooo<0?lbooooo`03
o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Cooooo00?ooiT0ooooooooool0
1?ooool01_lco`3o<`3ooooooolc0?oooooooc?o00Cooooo00?ooiT0ooooooooool0>Oooool2o`3o
IQgooooo00Go0?mVooooooooooooooooo`3oIP0<ooooo`05olco0?ooooooooooooooooo<o`00AOoo
ool01?o<0?ooooooooooooo<0?lbooooo`03o`000?oooooooooo00;ooooo000@ooooo`;o00001Ooo
ool00oooV@3oooooooooo`04ooooo`06oc?o0?lc0?oooooooc<0oooooooo<ol01?ooool00oooV@3o
ooooooooo`0jooooo`03o`3oI_oooooooooo01cooooo00Co0?mVoooooooooooo0?mV3Oooool00oo<
o`3oooooolco0016ooooo`04ol`0oooooooooooool`0oc7ooooo0_l00004ooooo`004?ooool00ol0
003oooooooooo`05ooooo`03oonI0?oooooooooo00?ooooo00Ko<ol0oc<0oooooooo<`3ooooooolc
o`04ooooo`03oonI0?oooooooooo03[ooooo00?o0?mVooooooooool07?ooool01?l0ofKooooooooo
ool0ofH>ooooo`;oc?l0Aoooool2ol`0oc?ooooo00?o0000ooooooooool00_ooool000Oooooo1Ol0
0004ooooo`03o`000?oooooooooo00Gooooo00?ooiT0ooooooooool00oooool01_lco`3o<`3ooooo
oolc0?oooooooc?o00Cooooo00?ooiT0ooooooooool0>_ooool00ol0ofKoooooooooo`0Looooo`04
o`3oI_ooooooooooo`3oIPkooooo0_o<o`17ooooo`03ol`0oooooooooooo03;ooooo00?o0000oooo
ooooool00_ooool000Sooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05oooo
o`03oonI0?oooooooooo00Cooooo00Go<ol0oooooolc0?oooooooc?o0004ooooo`03oonI0?oooooo
oooo05[ooooo00?o0?mVooooool0ofH03oooool00oo<o`3oooooooooo`1jooooo`03o`000?oooooo
oooo00;ooooo0009ooooo`03o`000?oooooooooo00Cooooo0ol00006ooooo`03oonI0?oooooooooo
00?ooooo00Go<ol0oc<0oooooooooooooc?o0004ooooo`03oonI0?oooooooooo05[ooooo0_l0ofJ;
ooooo`?o00001?ooool000[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`06oooo
o`03oonI0?oooooooooo00?ooooo00Go<ol0oc<0oooooooooooooc?o0004ooooo`03oonI0?oooooo
oooo05[ooooo0_l0ofJ=ooooo`03o`000?oooooooooo00;ooooo0007ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`06ooooo`03oonI0?oooooooooo00?ooooo00Co<ol0
oc<0oooooooo<ol01Oooool00oooV@3oooooooooo`1Kooooo`03o`3oI_oooooooooo08_ooooo00?o
0000ooooooooool00_ooool000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oo
oooooooo00Kooooo00?ooiT0ooooooooool00oooool01?lco`3o<`3ooooooolco`04ooooo`03oonI
0?oooooooooo05cooooo00?o0?mVooooooooool0Roooool00ol0003oooooooooo`02ooooo`002?oo
ool3o`0000Gooooo00?o0000ooooooooool01_ooool00oooV@3oooooooooo`03ooooo`04oc?o0?oo
oooooooooc?o00Cooooo00?ooiT0ooooooooool0j_ooool00ol0003oooooooooo`02ooooo`004?oo
ool2o`0000Oooooo00?ooiT0ooooooooool00oooool00olco`3ooooooc?o0005ooooo`03oonI0?oo
oooooooo0>Wooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`06ooooo`03oonI0?oooooo
oooo00Cooooo0_lco`05ooooo`03oonI0?oooooooooo0>[ooooo00?o0000ooooooooool00_ooool0
013ooooo00?o0000ooooooooool01oooool00oooV@3oooooooooo`03ooooo`;o<ol01Oooool00ooo
V@3oooooooooo`3Zooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Oo
oooo00?ooiT0ooooooooool00oooool00olco`3oooooooooo`04ooooo`03oonI0?oooooooooo0>[o
oooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01oooool00oooV@3ooooo
ooooo`0:ooooo`03oonI0?oooooooooo0>[ooooo00?o0000ooooooooool00_ooool0013ooooo0_l0
0008ooooo`03oonI0?oooooooooo00[ooooo00?ooiT0ooooooooool0jOooool2o`0000Cooooo000@
ooooo`03o`000?oooooooooo00Oooooo00?ooiT0ooooooooool02Oooool00oooV@3oooooooooo`3[
ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Oooooo00?ooiT0oooo
ooooool02Oooool00oooV@3oooooooooo`3[ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03
o`000?oooooooooo00Oooooo00?ooiT0ooooooooool02Oooool00oooV@3oooooooooo`3[ooooo`03
o`000?oooooooooo00;ooooo000@ooooo`;o00002?ooool00oooV@3oooooooooo`09ooooo`03oonI
0?oooooooooo0>[ooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`07ooooo`05oonI0?oo
ooooooooooooooooV@001oooool00oooV@3oooooooooo`3[ooooo`03o`000?oooooooooo00;ooooo
000@ooooo`03o`000?oooooooooo00Oooooo00GooiT0oooooooooooooooooonI0007ooooo`03oonI
0?oooooooooo0>_ooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool02?oo
ool01?ooV@3ooooooonI0?ooV@07ooooo`03oonI0?oooooooooo0>_ooooo00?o0000ooooooooool0
0_ooool0013ooooo00?o0000ooooooooool02?ooool01?ooV@3ooooooonI0?ooV@07ooooo`03oonI
0?oooooooooo0>_ooooo00?o0000ooooooooool00_ooool0013ooooo0_l00009ooooo`;ooiT000?o
oooooonI0?ooool01Oooool00oooV@3oooooooooo`3[ooooo`;o00001?ooool0013ooooo00?o0000
ooooooooool02?ooool2oonI0003ooooooooV@3ooooo00Gooooo00?ooiT0ooooooooool0k?ooool0
0ol0003oooooooooo`02ooooo`002?ooool3o`0000Gooooo00?o0000ooooooooool02?ooool01Ooo
V@3ooooooooooooooooooiT000Gooooo00?ooiT0ooooooooool0k?ooool00ol0003oooooooooo`02
ooooo`001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool03?ooool0
0oooV@3oooooooooo`03ooooo`03oonI0?oooooooooo0>cooooo00?o0000ooooooooool00_ooool0
00_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0<ooooo`03oonI0?oooooooooo
00?ooooo00?ooiT0ooooooooool0k?ooool00ol0003oooooooooo`02ooooo`002Oooool2o`0000Go
oooo0ol0000<ooooo`03oonI0?oooooooooo00?ooooo00?ooiT0ooooooooool0j_ooool3o`0000Co
oooo000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03?ooool00oooV@3ooooo
ooooo`02ooooo`03oonI0?oooooooooo0>gooooo00?o0000ooooooooool00_ooool000Oooooo00Go
0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00cooooo00?ooiT0ooooooooool0
0_ooool00oooV@3oooooooooo`3]ooooo`03o`000?oooooooooo00;ooooo0008ooooo`?o00001Ooo
ool00ol0003oooooooooo`0<ooooo`03oonI0?oooooooooo00;ooooo00?ooiT0ooooooooool0kOoo
ool00ol0003oooooooooo`02ooooo`004?ooool2o`0000gooooo00?ooiT0ooooooooool00_ooool0
0oooV@3oooooooooo`3/ooooo`;o00001?ooool0013ooooo00?o0000ooooooooool03?ooool00ooo
V@3oooooooooo`02ooooo`03oonI0?oooooooooo0>gooooo00?o0000ooooooooool00_ooool0013o
oooo00?o0000ooooooooool03?ooool01OooV@3ooooooooooooooooooiT00?3ooooo00?o0000oooo
ooooool00_ooool0013ooooo00?o0000ooooooooool03Oooool01?ooV@3oooooooooooooV@3`oooo
o`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00gooooo00CooiT0oooooooo
oooooiT0l?ooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000kooooo00?ooiT0oooooooo
V@00l?ooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00gooooo0_ooV@3booooo`03o`00
0?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00gooooo00?ooiT0ooooooooool0lOoo
ool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o0000
ooooooooool00_ooool0013ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0_oooo
o`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0^oooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02oooo
o`004?ooooooo`0000Ko00001?ooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-9.16135, -3.76748, \
0.404005, 0.0428399}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 11}\),
      SequenceForm[ "Dimension der Daten  ", {101, 11}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.295015 0.086893 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03434 -12 -4.5 ]
[-0.0125 .03434 0 4.5 ]
[-0.0125 .12123 -12 -4.5 ]
[-0.0125 .12123 0 4.5 ]
[-0.0125 .20812 -12 -4.5 ]
[-0.0125 .20812 0 4.5 ]
[-0.0125 .29501 -6 -4.5 ]
[-0.0125 .29501 0 4.5 ]
[-0.0125 .38191 -6 -4.5 ]
[-0.0125 .38191 0 4.5 ]
[-0.0125 .4688 -6 -4.5 ]
[-0.0125 .4688 0 4.5 ]
[-0.0125 .55569 -6 -4.5 ]
[-0.0125 .55569 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31398 -5 -6 ]
[.97619 .31398 5 6 ]
[.97619 .39166 -5 -6 ]
[.97619 .39166 5 6 ]
[.97619 .28017 -5 -6 ]
[.97619 .28017 5 6 ]
[.97619 .1997 -5 -6 ]
[.97619 .1997 5 6 ]
[.97619 .25635 -5 -6 ]
[.97619 .25635 5 6 ]
[.97619 .24264 -5 -6 ]
[.97619 .24264 5 6 ]
[.97619 .32156 -5 -6 ]
[.97619 .32156 5 6 ]
[.97619 .23654 -5 -6 ]
[.97619 .23654 5 6 ]
[.97619 .35791 -5 -6 ]
[.97619 .35791 5 6 ]
[.97619 .34091 -5 -6 ]
[.97619 .34091 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03434 m
.00625 .03434 L
s
[(-3)] -0.0125 .03434 1 0 Mshowa
0 .12123 m
.00625 .12123 L
s
[(-2)] -0.0125 .12123 1 0 Mshowa
0 .20812 m
.00625 .20812 L
s
[(-1)] -0.0125 .20812 1 0 Mshowa
0 .29501 m
.00625 .29501 L
s
[(0)] -0.0125 .29501 1 0 Mshowa
0 .38191 m
.00625 .38191 L
s
[(1)] -0.0125 .38191 1 0 Mshowa
0 .4688 m
.00625 .4688 L
s
[(2)] -0.0125 .4688 1 0 Mshowa
0 .55569 m
.00625 .55569 L
s
[(3)] -0.0125 .55569 1 0 Mshowa
.125 Mabswid
0 .05171 m
.00375 .05171 L
s
0 .06909 m
.00375 .06909 L
s
0 .08647 m
.00375 .08647 L
s
0 .10385 m
.00375 .10385 L
s
0 .13861 m
.00375 .13861 L
s
0 .15599 m
.00375 .15599 L
s
0 .17336 m
.00375 .17336 L
s
0 .19074 m
.00375 .19074 L
s
0 .2255 m
.00375 .2255 L
s
0 .24288 m
.00375 .24288 L
s
0 .26026 m
.00375 .26026 L
s
0 .27764 m
.00375 .27764 L
s
0 .31239 m
.00375 .31239 L
s
0 .32977 m
.00375 .32977 L
s
0 .34715 m
.00375 .34715 L
s
0 .36453 m
.00375 .36453 L
s
0 .39929 m
.00375 .39929 L
s
0 .41666 m
.00375 .41666 L
s
0 .43404 m
.00375 .43404 L
s
0 .45142 m
.00375 .45142 L
s
0 .48618 m
.00375 .48618 L
s
0 .50356 m
.00375 .50356 L
s
0 .52094 m
.00375 .52094 L
s
0 .53831 m
.00375 .53831 L
s
0 .01696 m
.00375 .01696 L
s
0 .57307 m
.00375 .57307 L
s
0 .59045 m
.00375 .59045 L
s
0 .60783 m
.00375 .60783 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03434 m
1 .03434 L
s
.99375 .12123 m
1 .12123 L
s
.99375 .20812 m
1 .20812 L
s
.99375 .29501 m
1 .29501 L
s
.99375 .38191 m
1 .38191 L
s
.99375 .4688 m
1 .4688 L
s
.99375 .55569 m
1 .55569 L
s
.125 Mabswid
.99625 .05171 m
1 .05171 L
s
.99625 .06909 m
1 .06909 L
s
.99625 .08647 m
1 .08647 L
s
.99625 .10385 m
1 .10385 L
s
.99625 .13861 m
1 .13861 L
s
.99625 .15599 m
1 .15599 L
s
.99625 .17336 m
1 .17336 L
s
.99625 .19074 m
1 .19074 L
s
.99625 .2255 m
1 .2255 L
s
.99625 .24288 m
1 .24288 L
s
.99625 .26026 m
1 .26026 L
s
.99625 .27764 m
1 .27764 L
s
.99625 .31239 m
1 .31239 L
s
.99625 .32977 m
1 .32977 L
s
.99625 .34715 m
1 .34715 L
s
.99625 .36453 m
1 .36453 L
s
.99625 .39929 m
1 .39929 L
s
.99625 .41666 m
1 .41666 L
s
.99625 .43404 m
1 .43404 L
s
.99625 .45142 m
1 .45142 L
s
.99625 .48618 m
1 .48618 L
s
.99625 .50356 m
1 .50356 L
s
.99625 .52094 m
1 .52094 L
s
.99625 .53831 m
1 .53831 L
s
.99625 .01696 m
1 .01696 L
s
.99625 .57307 m
1 .57307 L
s
.99625 .59045 m
1 .59045 L
s
.99625 .60783 m
1 .60783 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .31398 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .16534 m
.03333 .28269 L
.04286 .29508 L
.05238 .2902 L
.0619 .28495 L
.07143 .36296 L
.08095 .42125 L
.09048 .3781 L
.1 .38393 L
.10952 .40859 L
.11905 .4348 L
.12857 .34103 L
.1381 .20982 L
.14762 .27411 L
.15714 .23652 L
.16667 .19207 L
.17619 .17096 L
.18571 .22385 L
.19524 .2344 L
.20476 .32308 L
.21429 .27481 L
.22381 .31861 L
.23333 .32067 L
.24286 .35638 L
.25238 .31121 L
.2619 .31438 L
.27143 .28241 L
.28095 .29349 L
.29048 .31541 L
.3 .29824 L
.30952 .33563 L
.31905 .32899 L
.32857 .34634 L
.3381 .29385 L
.34762 .28811 L
.35714 .26473 L
.36667 .23247 L
.37619 .20448 L
.38571 .19551 L
.39524 .23447 L
.40476 .19805 L
.41429 .26631 L
.42381 .2801 L
.43333 .25817 L
.44286 .29537 L
.45238 .33655 L
.4619 .38158 L
.47143 .28399 L
.48095 .30799 L
.49048 .23437 L
Mistroke
.5 .25477 L
.50952 .31497 L
.51905 .36485 L
.52857 .33456 L
.5381 .28851 L
.54762 .33832 L
.55714 .28908 L
.56667 .2721 L
.57619 .32106 L
.58571 .30188 L
.59524 .38037 L
.60476 .38949 L
.61429 .264 L
.62381 .25128 L
.63333 .24672 L
.64286 .33126 L
.65238 .34405 L
.6619 .39984 L
.67143 .34584 L
.68095 .26229 L
.69048 .26827 L
.7 .19481 L
.70952 .20064 L
.71905 .28126 L
.72857 .22023 L
.7381 .24612 L
.74762 .3278 L
.75714 .36579 L
.76667 .34727 L
.77619 .25142 L
.78571 .29837 L
.79524 .34103 L
.80476 .3841 L
.81429 .41832 L
.82381 .32487 L
.83333 .23833 L
.84286 .26998 L
.85238 .18984 L
.8619 .17466 L
.87143 .26043 L
.88095 .22201 L
.89048 .30148 L
.9 .25227 L
.90952 .21334 L
.91905 .28198 L
.92857 .28354 L
.9381 .2779 L
.94762 .39744 L
.95714 .34905 L
.96667 .35027 L
Mistroke
.97619 .31398 L
Mfstroke
1 0 .6 r
gsave
.97619 .39166 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31669 m
.03333 .20908 L
.04286 .2188 L
.05238 .1227 L
.0619 .17393 L
.07143 .29001 L
.08095 .33982 L
.09048 .29844 L
.1 .37882 L
.10952 .27557 L
.11905 .28855 L
.12857 .27408 L
.1381 .3144 L
.14762 .30759 L
.15714 .24896 L
.16667 .33398 L
.17619 .38304 L
.18571 .26811 L
.19524 .23481 L
.20476 .22473 L
.21429 .22769 L
.22381 .29492 L
.23333 .30586 L
.24286 .36013 L
.25238 .34736 L
.2619 .32155 L
.27143 .28948 L
.28095 .27242 L
.29048 .30485 L
.3 .38014 L
.30952 .32435 L
.31905 .35489 L
.32857 .28309 L
.3381 .32506 L
.34762 .32412 L
.35714 .26169 L
.36667 .22696 L
.37619 .24032 L
.38571 .17536 L
.39524 .18569 L
.40476 .31685 L
.41429 .30271 L
.42381 .35424 L
.43333 .30025 L
.44286 .34041 L
.45238 .34904 L
.4619 .32135 L
.47143 .30188 L
.48095 .34336 L
.49048 .23278 L
Mistroke
.5 .19603 L
.50952 .19824 L
.51905 .31316 L
.52857 .36997 L
.5381 .30109 L
.54762 .31232 L
.55714 .35784 L
.56667 .39214 L
.57619 .30549 L
.58571 .36418 L
.59524 .34835 L
.60476 .30734 L
.61429 .325 L
.62381 .2821 L
.63333 .34657 L
.64286 .26085 L
.65238 .27453 L
.6619 .30623 L
.67143 .28327 L
.68095 .28014 L
.69048 .32024 L
.7 .33601 L
.70952 .26794 L
.71905 .21508 L
.72857 .17686 L
.7381 .1718 L
.74762 .21835 L
.75714 .28948 L
.76667 .42997 L
.77619 .38194 L
.78571 .36194 L
.79524 .26513 L
.80476 .24836 L
.81429 .25459 L
.82381 .34294 L
.83333 .31315 L
.84286 .29913 L
.85238 .28917 L
.8619 .3173 L
.87143 .31126 L
.88095 .32705 L
.89048 .37825 L
.9 .23921 L
.90952 .19772 L
.91905 .2624 L
.92857 .30197 L
.9381 .25843 L
.94762 .26383 L
.95714 .30219 L
.96667 .33755 L
Mistroke
.97619 .39166 L
Mfstroke
.8 0 1 r
gsave
.97619 .28017 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22045 m
.03333 .26102 L
.04286 .26345 L
.05238 .36647 L
.0619 .34408 L
.07143 .32914 L
.08095 .39579 L
.09048 .32133 L
.1 .32552 L
.10952 .34182 L
.11905 .22294 L
.12857 .27034 L
.1381 .28559 L
.14762 .26876 L
.15714 .25324 L
.16667 .24868 L
.17619 .26786 L
.18571 .37443 L
.19524 .35479 L
.20476 .29463 L
.21429 .34778 L
.22381 .26215 L
.23333 .28963 L
.24286 .30454 L
.25238 .38452 L
.2619 .40873 L
.27143 .37698 L
.28095 .30157 L
.29048 .30674 L
.3 .25272 L
.30952 .18048 L
.31905 .13681 L
.32857 .24297 L
.3381 .27726 L
.34762 .20565 L
.35714 .33682 L
.36667 .26656 L
.37619 .2134 L
.38571 .22624 L
.39524 .28351 L
.40476 .34131 L
.41429 .38574 L
.42381 .32145 L
.43333 .32392 L
.44286 .30194 L
.45238 .34575 L
.4619 .39023 L
.47143 .29201 L
.48095 .30112 L
.49048 .30894 L
Mistroke
.5 .34789 L
.50952 .32603 L
.51905 .34681 L
.52857 .30341 L
.5381 .35208 L
.54762 .2107 L
.55714 .29199 L
.56667 .23905 L
.57619 .17646 L
.58571 .24881 L
.59524 .24719 L
.60476 .2666 L
.61429 .27577 L
.62381 .32525 L
.63333 .33443 L
.64286 .30121 L
.65238 .28785 L
.6619 .29959 L
.67143 .31034 L
.68095 .24129 L
.69048 .30933 L
.7 .26366 L
.70952 .34334 L
.71905 .2818 L
.72857 .20969 L
.7381 .19664 L
.74762 .27414 L
.75714 .3157 L
.76667 .34006 L
.77619 .34489 L
.78571 .41467 L
.79524 .45808 L
.80476 .43728 L
.81429 .26992 L
.82381 .22312 L
.83333 .25363 L
.84286 .19313 L
.85238 .13374 L
.8619 .16332 L
.87143 .21312 L
.88095 .18624 L
.89048 .27897 L
.9 .32513 L
.90952 .3546 L
.91905 .41173 L
.92857 .34889 L
.9381 .39522 L
.94762 .29796 L
.95714 .27191 L
.96667 .23207 L
Mistroke
.97619 .28017 L
Mfstroke
.2 0 1 r
gsave
.97619 .1997 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15336 m
.03333 .21981 L
.04286 .28142 L
.05238 .44889 L
.0619 .49022 L
.07143 .39852 L
.08095 .41905 L
.09048 .3599 L
.1 .37778 L
.10952 .37622 L
.11905 .30348 L
.12857 .28256 L
.1381 .35057 L
.14762 .36423 L
.15714 .29378 L
.16667 .20054 L
.17619 .18643 L
.18571 .13475 L
.19524 .24153 L
.20476 .35844 L
.21429 .39383 L
.22381 .34642 L
.23333 .30792 L
.24286 .34214 L
.25238 .33204 L
.2619 .2893 L
.27143 .36843 L
.28095 .36254 L
.29048 .34587 L
.3 .22416 L
.30952 .19126 L
.31905 .2122 L
.32857 .23522 L
.3381 .24458 L
.34762 .19046 L
.35714 .22875 L
.36667 .25174 L
.37619 .36514 L
.38571 .30459 L
.39524 .31379 L
.40476 .38932 L
.41429 .29092 L
.42381 .32961 L
.43333 .33404 L
.44286 .29844 L
.45238 .34943 L
.4619 .32127 L
.47143 .38338 L
.48095 .38586 L
.49048 .29742 L
Mistroke
.5 .2254 L
.50952 .23676 L
.51905 .15063 L
.52857 .20355 L
.5381 .23853 L
.54762 .20528 L
.55714 .31061 L
.56667 .31381 L
.57619 .31104 L
.58571 .37743 L
.59524 .31617 L
.60476 .33017 L
.61429 .37471 L
.62381 .3652 L
.63333 .39245 L
.64286 .28133 L
.65238 .29231 L
.6619 .23653 L
.67143 .22585 L
.68095 .1549 L
.69048 .24144 L
.7 .25114 L
.70952 .2581 L
.71905 .3146 L
.72857 .34492 L
.7381 .35806 L
.74762 .43454 L
.75714 .4159 L
.76667 .37771 L
.77619 .29398 L
.78571 .26806 L
.79524 .25542 L
.80476 .22601 L
.81429 .2153 L
.82381 .21279 L
.83333 .22186 L
.84286 .33116 L
.85238 .43869 L
.8619 .42784 L
.87143 .35073 L
.88095 .35532 L
.89048 .39291 L
.9 .24911 L
.90952 .33241 L
.91905 .28043 L
.92857 .33888 L
.9381 .29416 L
.94762 .16554 L
.95714 .18799 L
.96667 .25296 L
Mistroke
.97619 .1997 L
Mfstroke
0 .4 1 r
gsave
.97619 .25635 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38214 m
.03333 .29704 L
.04286 .30412 L
.05238 .27415 L
.0619 .22091 L
.07143 .22863 L
.08095 .23799 L
.09048 .28893 L
.1 .26396 L
.10952 .2828 L
.11905 .33855 L
.12857 .38723 L
.1381 .35099 L
.14762 .38337 L
.15714 .3322 L
.16667 .38491 L
.17619 .32037 L
.18571 .21037 L
.19524 .29252 L
.20476 .31322 L
.21429 .30295 L
.22381 .24737 L
.23333 .22374 L
.24286 .25788 L
.25238 .21172 L
.2619 .17157 L
.27143 .18557 L
.28095 .31088 L
.29048 .29452 L
.3 .32354 L
.30952 .34059 L
.31905 .31648 L
.32857 .3406 L
.3381 .29468 L
.34762 .28961 L
.35714 .40086 L
.36667 .34788 L
.37619 .38818 L
.38571 .29503 L
.39524 .29979 L
.40476 .29649 L
.41429 .24174 L
.42381 .26286 L
.43333 .2468 L
.44286 .16127 L
.45238 .20863 L
.4619 .24496 L
.47143 .26825 L
.48095 .33084 L
.49048 .34714 L
Mistroke
.5 .30111 L
.50952 .22245 L
.51905 .14532 L
.52857 .17612 L
.5381 .33773 L
.54762 .40067 L
.55714 .32795 L
.56667 .33928 L
.57619 .2565 L
.58571 .23183 L
.59524 .22569 L
.60476 .31809 L
.61429 .29127 L
.62381 .27173 L
.63333 .33509 L
.64286 .32962 L
.65238 .38334 L
.6619 .30427 L
.67143 .34427 L
.68095 .2834 L
.69048 .35285 L
.7 .22997 L
.70952 .19485 L
.71905 .28187 L
.72857 .31118 L
.7381 .39107 L
.74762 .38103 L
.75714 .35056 L
.76667 .3101 L
.77619 .30145 L
.78571 .26742 L
.79524 .18907 L
.80476 .22338 L
.81429 .24349 L
.82381 .20587 L
.83333 .32701 L
.84286 .37596 L
.85238 .3693 L
.8619 .26501 L
.87143 .25847 L
.88095 .18419 L
.89048 .19758 L
.9 .26259 L
.90952 .26795 L
.91905 .29868 L
.92857 .37564 L
.9381 .40662 L
.94762 .36419 L
.95714 .3342 L
.96667 .32549 L
Mistroke
.97619 .25635 L
Mfstroke
0 1 1 r
gsave
.97619 .24264 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15408 m
.03333 .18916 L
.04286 .22977 L
.05238 .31508 L
.0619 .31395 L
.07143 .33816 L
.08095 .41441 L
.09048 .36816 L
.1 .36444 L
.10952 .29134 L
.11905 .25484 L
.12857 .35197 L
.1381 .25944 L
.14762 .22667 L
.15714 .2124 L
.16667 .25307 L
.17619 .32629 L
.18571 .28329 L
.19524 .32141 L
.20476 .3295 L
.21429 .30814 L
.22381 .27575 L
.23333 .34001 L
.24286 .35656 L
.25238 .40894 L
.2619 .34867 L
.27143 .28859 L
.28095 .24394 L
.29048 .1534 L
.3 .12639 L
.30952 .20034 L
.31905 .22944 L
.32857 .30533 L
.3381 .37297 L
.34762 .36959 L
.35714 .37101 L
.36667 .25488 L
.37619 .31029 L
.38571 .30261 L
.39524 .26097 L
.40476 .24307 L
.41429 .2762 L
.42381 .32626 L
.43333 .37095 L
.44286 .40175 L
.45238 .34784 L
.4619 .29184 L
.47143 .29601 L
.48095 .20623 L
.49048 .24431 L
Mistroke
.5 .28788 L
.50952 .28809 L
.51905 .28361 L
.52857 .31706 L
.5381 .31527 L
.54762 .33418 L
.55714 .2552 L
.56667 .26236 L
.57619 .22626 L
.58571 .27662 L
.59524 .26643 L
.60476 .23241 L
.61429 .33076 L
.62381 .30168 L
.63333 .30354 L
.64286 .32696 L
.65238 .36965 L
.6619 .42351 L
.67143 .42456 L
.68095 .37721 L
.69048 .26107 L
.7 .18863 L
.70952 .15627 L
.71905 .26931 L
.72857 .26044 L
.7381 .24812 L
.74762 .20039 L
.75714 .29064 L
.76667 .40607 L
.77619 .37368 L
.78571 .23392 L
.79524 .20837 L
.80476 .19912 L
.81429 .15062 L
.82381 .20676 L
.83333 .28467 L
.84286 .34201 L
.85238 .26561 L
.8619 .25353 L
.87143 .32747 L
.88095 .36713 L
.89048 .42281 L
.9 .36052 L
.90952 .28387 L
.91905 .28239 L
.92857 .25056 L
.9381 .2762 L
.94762 .32903 L
.95714 .39701 L
.96667 .3283 L
Mistroke
.97619 .24264 L
Mfstroke
0 1 .4 r
gsave
.97619 .32156 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16659 m
.03333 .06565 L
.04286 .04383 L
.05238 .01472 L
.0619 .12825 L
.07143 .13966 L
.08095 .15955 L
.09048 .26474 L
.1 .31752 L
.10952 .38044 L
.11905 .3615 L
.12857 .33291 L
.1381 .31612 L
.14762 .3114 L
.15714 .22899 L
.16667 .27344 L
.17619 .25128 L
.18571 .34469 L
.19524 .36712 L
.20476 .31003 L
.21429 .33251 L
.22381 .21334 L
.23333 .29551 L
.24286 .27485 L
.25238 .22619 L
.2619 .14118 L
.27143 .13307 L
.28095 .27474 L
.29048 .2614 L
.3 .40319 L
.30952 .40613 L
.31905 .41952 L
.32857 .47561 L
.3381 .37 L
.34762 .31034 L
.35714 .34301 L
.36667 .20058 L
.37619 .1868 L
.38571 .14505 L
.39524 .23634 L
.40476 .18357 L
.41429 .22385 L
.42381 .24012 L
.43333 .32256 L
.44286 .44332 L
.45238 .47371 L
.4619 .42306 L
.47143 .38115 L
.48095 .37195 L
.49048 .3425 L
Mistroke
.5 .29457 L
.50952 .22925 L
.51905 .28881 L
.52857 .30294 L
.5381 .26203 L
.54762 .20863 L
.55714 .29565 L
.56667 .26087 L
.57619 .25126 L
.58571 .2733 L
.59524 .34472 L
.60476 .35837 L
.61429 .33911 L
.62381 .25396 L
.63333 .29373 L
.64286 .35596 L
.65238 .31837 L
.6619 .25206 L
.67143 .23855 L
.68095 .22307 L
.69048 .23934 L
.7 .32517 L
.70952 .29908 L
.71905 .25259 L
.72857 .23593 L
.7381 .3255 L
.74762 .37742 L
.75714 .26999 L
.76667 .30317 L
.77619 .26546 L
.78571 .27546 L
.79524 .33033 L
.80476 .41787 L
.81429 .34141 L
.82381 .25142 L
.83333 .22103 L
.84286 .2648 L
.85238 .35923 L
.8619 .39372 L
.87143 .33337 L
.88095 .35218 L
.89048 .30494 L
.9 .32676 L
.90952 .32267 L
.91905 .30094 L
.92857 .27945 L
.9381 .25059 L
.94762 .23544 L
.95714 .22273 L
.96667 .26346 L
Mistroke
.97619 .32156 L
Mfstroke
.2 1 0 r
gsave
.97619 .23654 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27354 m
.03333 .385 L
.04286 .39318 L
.05238 .45055 L
.0619 .50838 L
.07143 .46804 L
.08095 .38861 L
.09048 .2812 L
.1 .34845 L
.10952 .31658 L
.11905 .30261 L
.12857 .20604 L
.1381 .26232 L
.14762 .3585 L
.15714 .31558 L
.16667 .23472 L
.17619 .29588 L
.18571 .20236 L
.19524 .22019 L
.20476 .18673 L
.21429 .31724 L
.22381 .26544 L
.23333 .28493 L
.24286 .31833 L
.25238 .32808 L
.2619 .29758 L
.27143 .2569 L
.28095 .30939 L
.29048 .38122 L
.3 .36091 L
.30952 .33417 L
.31905 .26395 L
.32857 .23966 L
.3381 .23514 L
.34762 .30971 L
.35714 .40233 L
.36667 .3152 L
.37619 .2631 L
.38571 .26716 L
.39524 .21765 L
.40476 .30597 L
.41429 .30112 L
.42381 .25439 L
.43333 .29384 L
.44286 .34864 L
.45238 .31165 L
.4619 .24799 L
.47143 .3709 L
.48095 .4456 L
.49048 .37478 L
Mistroke
.5 .31261 L
.50952 .33581 L
.51905 .29337 L
.52857 .26758 L
.5381 .33873 L
.54762 .23304 L
.55714 .26588 L
.56667 .18361 L
.57619 .17379 L
.58571 .18193 L
.59524 .15665 L
.60476 .14925 L
.61429 .21548 L
.62381 .39688 L
.63333 .43234 L
.64286 .44293 L
.65238 .39302 L
.6619 .38569 L
.67143 .33898 L
.68095 .35277 L
.69048 .33575 L
.7 .23463 L
.70952 .24627 L
.71905 .28499 L
.72857 .36786 L
.7381 .21531 L
.74762 .19828 L
.75714 .28443 L
.76667 .23806 L
.77619 .22465 L
.78571 .19876 L
.79524 .25128 L
.80476 .24449 L
.81429 .20255 L
.82381 .28278 L
.83333 .30622 L
.84286 .30863 L
.85238 .29526 L
.8619 .35107 L
.87143 .31956 L
.88095 .31132 L
.89048 .25418 L
.9 .23817 L
.90952 .35013 L
.91905 .34923 L
.92857 .34284 L
.9381 .35026 L
.94762 .33401 L
.95714 .29956 L
.96667 .31557 L
Mistroke
.97619 .23654 L
Mfstroke
.8 1 0 r
gsave
.97619 .35791 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20192 m
.03333 .21799 L
.04286 .2621 L
.05238 .30584 L
.0619 .3523 L
.07143 .38449 L
.08095 .43841 L
.09048 .35732 L
.1 .3882 L
.10952 .40008 L
.11905 .3587 L
.12857 .37108 L
.1381 .31508 L
.14762 .29818 L
.15714 .35041 L
.16667 .24798 L
.17619 .17991 L
.18571 .26739 L
.19524 .25786 L
.20476 .22758 L
.21429 .25947 L
.22381 .32542 L
.23333 .30105 L
.24286 .36549 L
.25238 .34693 L
.2619 .33548 L
.27143 .26632 L
.28095 .26676 L
.29048 .18603 L
.3 .22531 L
.30952 .25695 L
.31905 .22822 L
.32857 .31406 L
.3381 .37219 L
.34762 .42091 L
.35714 .43075 L
.36667 .38461 L
.37619 .41347 L
.38571 .26072 L
.39524 .25966 L
.40476 .22567 L
.41429 .25356 L
.42381 .20399 L
.43333 .1901 L
.44286 .26517 L
.45238 .26485 L
.4619 .27339 L
.47143 .3455 L
.48095 .27442 L
.49048 .38459 L
Mistroke
.5 .4132 L
.50952 .43613 L
.51905 .46907 L
.52857 .40971 L
.5381 .36241 L
.54762 .34926 L
.55714 .28769 L
.56667 .29316 L
.57619 .27138 L
.58571 .27429 L
.59524 .20705 L
.60476 .1612 L
.61429 .13 L
.62381 .2749 L
.63333 .24566 L
.64286 .34706 L
.65238 .27569 L
.6619 .30477 L
.67143 .24509 L
.68095 .31827 L
.69048 .27858 L
.7 .25904 L
.70952 .31953 L
.71905 .30498 L
.72857 .37345 L
.7381 .27802 L
.74762 .34005 L
.75714 .26765 L
.76667 .25018 L
.77619 .16892 L
.78571 .20383 L
.79524 .30479 L
.80476 .27364 L
.81429 .29836 L
.82381 .32992 L
.83333 .34785 L
.84286 .41366 L
.85238 .34727 L
.8619 .28421 L
.87143 .22016 L
.88095 .26312 L
.89048 .19361 L
.9 .27709 L
.90952 .27527 L
.91905 .23341 L
.92857 .23758 L
.9381 .35383 L
.94762 .38383 L
.95714 .4056 L
.96667 .34774 L
Mistroke
.97619 .35791 L
Mfstroke
1 .6 0 r
gsave
.97619 .34091 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42906 m
.03333 .46464 L
.04286 .5404 L
.05238 .51258 L
.0619 .60332 L
.07143 .59044 L
.08095 .55864 L
.09048 .44851 L
.1 .28968 L
.10952 .21396 L
.11905 .24533 L
.12857 .22972 L
.1381 .15912 L
.14762 .24028 L
.15714 .25398 L
.16667 .27963 L
.17619 .30289 L
.18571 .2525 L
.19524 .1988 L
.20476 .27393 L
.21429 .26898 L
.22381 .37934 L
.23333 .36643 L
.24286 .33154 L
.25238 .3249 L
.2619 .33889 L
.27143 .27879 L
.28095 .30727 L
.29048 .21442 L
.3 .23613 L
.30952 .2229 L
.31905 .33397 L
.32857 .298 L
.3381 .3586 L
.34762 .27778 L
.35714 .20567 L
.36667 .24381 L
.37619 .30516 L
.38571 .39661 L
.39524 .34349 L
.40476 .32456 L
.41429 .36187 L
.42381 .36089 L
.43333 .31722 L
.44286 .20497 L
.45238 .28448 L
.4619 .35775 L
.47143 .35247 L
.48095 .34064 L
.49048 .25399 L
Mistroke
.5 .25643 L
.50952 .2627 L
.51905 .24729 L
.52857 .25786 L
.5381 .29534 L
.54762 .35831 L
.55714 .35082 L
.56667 .29185 L
.57619 .31693 L
.58571 .27889 L
.59524 .33552 L
.60476 .37224 L
.61429 .33193 L
.62381 .34338 L
.63333 .28753 L
.64286 .28669 L
.65238 .31097 L
.6619 .28873 L
.67143 .217 L
.68095 .19063 L
.69048 .21658 L
.7 .17409 L
.70952 .21666 L
.71905 .29357 L
.72857 .24338 L
.7381 .3008 L
.74762 .3888 L
.75714 .37664 L
.76667 .30668 L
.77619 .34093 L
.78571 .33234 L
.79524 .27686 L
.80476 .29161 L
.81429 .34481 L
.82381 .37949 L
.83333 .39717 L
.84286 .35279 L
.85238 .2899 L
.8619 .16283 L
.87143 .24698 L
.88095 .24944 L
.89048 .28807 L
.9 .30721 L
.90952 .28078 L
.91905 .20456 L
.92857 .18682 L
.9381 .23825 L
.94762 .25377 L
.95714 .18043 L
.96667 .22827 L
Mistroke
.97619 .34091 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`005Oooool2o`0002_ooooo1Ol00003ooooo`;o0000:Oooool3o`0000?ooooo0_l0000Yoooo
o`?o00001?ooool2o`0002Sooooo0ol00004ooooo`;o00009_ooool3o`0000Cooooo0_l00004oooo
o`;o00001?ooool001Cooooo00Co0000oooooooooooo0000:oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0002Wooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo02Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
02Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0002Kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?o
oooo000Dooooo`04o`000?ooooooooooo`0002cooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool0000Vooooo`Go00000_ooool01?l0003oooooooooool0000Wooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Vooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00003ooooo`005?ooool01?l0003oooooooooool0
000]ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`0Tooooo`04o`00
0?ooooooooooo`0000?ooooo00Co0000oooooooooooo00009oooool4o`0000?ooooo00Co0000oooo
oooooooo00009oooool3o`0000?ooooo00Co0000oooooooooooo00009_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool001Cooooo
00Co0000oooooooooooo0000:_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00009oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0002Oooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Vooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00003ooooo`005?ooool01?l0003oooooooooool0
000Zooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Xooooo`;o
00000oooool01?l0003oooooooooool0000Xooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00009_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
9Oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00003oooo
o`005Oooool2o`0002cooooo0ol00004ooooo`;o0000:_ooool00ol0003oooooooooo`02ooooo`;o
0000:_ooool2o`0000Cooooo0_l0000Xooooo`?o00001?ooool2o`0002Oooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00004ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJ
ooooo`00oooooolJooooo`004?ooooooo`0000Ko00001?ooool0013ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o
0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool0ooooool2ooooo`03o`000?oooooo
oooo00;ooooo000@ooooo`;o00003?ooool00ol0ofKoooooooooo`3booooo`;o00001?ooool0013o
oooo00?o0000ooooooooool02oooool00ol0ofKoooooooooo`3cooooo`03o`000?oooooooooo00;o
oooo0008ooooo`?o00001Oooool00ol0003oooooooooo`0:ooooo`;o0?mVmOooool00ol0003ooooo
ooooo`02ooooo`001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
2_ooool2o`3oI_Gooooo00?o0000ooooooooool00_ooool00003ooooool0003o000000?o00001Ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0?mVooooool0ofH0mOoo
ool00ol0003oooooooooo`02ooooo`002Oooool2o`0000Gooooo0ol00009ooooo`03o`3oI_oooooo
0?mV0??ooooo0ol00004ooooo`002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0?mVooooool0ofH0mOooool00ol0003oooooooooo`02ooooo`001oooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool02?ooool01?l0ofKoooooooooool0ofKe
ooooo`03o`000?oooooooooo00;ooooo0008ooooo`?o00001Oooool00ol0003oooooooooo`08oooo
o`05o`3oI_ooooooooooooooool0ofH0m?ooool00ol0003oooooooooo`02ooooo`004?ooool2o`00
00Sooooo00?o0?mVooooooooool00_ooool00ol0ofKoooooooooo`3aooooo`;o00001?ooool0013o
oooo00?o0000ooooooooool01oooool00ol0ofKoooooooooo`02ooooo`03o`3oI_oooooooooo0?;o
oooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01oooool00ol0ofKooooo
ooooo`02ooooo`03o`3oI_oooooooooo0?;ooooo00?o0000ooooooooool00_ooool0013ooooo00?o
0000ooooooooool01_ooool00ol0ofKoooooooooo`03ooooo`03o`3oI_oooooooooo0?;ooooo00?o
0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01_ooool00ol0ofKoooooooooo`03
ooooo`03o`3oI_oooooooooo0?;ooooo00?o0000ooooooooool00_ooool0013ooooo0_l00007oooo
o`03o`3oI_oooooooooo00?ooooo00?o0?mVooooooooool0lOooool2o`0000Cooooo000@ooooo`03
o`000?oooooooooo00Kooooo00?o0?mVooooooooool00oooool00ol0ofKoooooooooo`3booooo`03
o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Kooooo00?o0?mVooooooooool0
0oooool00ol0ofKoooooooooo`3booooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oo
oooooooo00Kooooo00?o0?mVooooooooool00oooool00ol0ofKoooooooooo`3booooo`03o`000?oo
oooooooo00;ooooo000@ooooo`;o00001_ooool00ol0ofKoooooooooo`04ooooo`03o`3oI_oooooo
oooo0?7ooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`05ooooo`03o`3oI_oooooooooo
00Cooooo00?o0?mVooooooooool0l_ooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003o
ooooooooo`05ooooo`03o`3oI_oooooooooo00Cooooo00?o0?mVooooooooool0l_ooool00ol0003o
ooooooooo`02ooooo`004?ooool00ol0003oooooooooo`05ooooo`03o`3oI_oooooooooo00Cooooo
00?o0?mVooooooooool0l_ooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003ooooooooo
o`05ooooo`03o`3oI_oooooooooo00Cooooo00?o0?mVooooooooool0l_ooool00ol0003ooooooooo
o`02ooooo`004?ooool2o`0000Kooooo00?o0?mVooooooooool01Oooool00ol0ofKoooooooooo`3`
ooooo`;o00001?ooool0013ooooo00?o0000ooooooooool01Oooool00ol0ofKoooooooooo`05oooo
o`03o`3oI_oooooooooo0?7ooooo00?o0000ooooooooool00_ooool000Oooooo1Ol00004ooooo`03
o`000?oooooooooo00Gooooo00?o0?mVooooooooool01Oooool00ol0ofKoooooooooo`3aooooo`03
o`000?oooooooooo00;ooooo0008ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooooooo
ool01Oooool00ol0ofKoooooooooo`05ooooo`03o`3oI_oooooooooo0?7ooooo00?o0000oooooooo
ool00_ooool00003ooooool0003o000000?o00000oooool00ol0003oooooooooo`04ooooo`?o0000
1?ooool00ol0ofKoooooooooo`06ooooo`03o`3oI_oooooooooo0>oooooo0ol00004ooooo`002_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0?mVooooooooool01?oo
ool00ooo09Woooooo`3oIP3cooooo`03o`000?oooooooooo00;ooooo0007ooooo`05o`000?oooooo
ooooooooool000001?ooool00ol0003oooooooooo`04ooooo`03o`3oI_oooooooooo00Cooooo00?o
o`2Iooooool0ofH0?Oooool00ol0ooooooooooooo`2cooooo`03o`000?oooooooooo00;ooooo0007
ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`04ooooo`03o`3oI_oo
oooooooo00Cooooo00Coo`2Ioooooooooooo0?mV=Oooool00ol0ofKoooooooooo`04ooooo`03o`3o
oooooooooooo04oooooo00?oc?l0ooooooooool0HOooool00ol0003oooooooooo`02ooooo`002?oo
ool3o`0000Gooooo00?o0000ooooooooool01?ooool00ol0ofKoooooooooo`04ooooo`05ool0VOoo
ooooooooooooool0ofH07Oooool00olc0?ooooooooooo`0Cooooo`;o0?mV1Oooool2o`3oo`Cooooo
00?oc03oooooooooool0B_ooool00oo<o`3oooooooooo`0kooooo`03ol`0oooooooooooo02?ooooo
00?o0000ooooooooool00_ooool0013ooooo0_l00005ooooo`03o`3oI_oooooooooo00Cooooo0_oo
09T3ooooo`03o`3oI_oooooooooo01[ooooo00?o<`3oooooooooool04_ooool00ol0ofKoooooo`3o
IP05ooooo`;o0?oo1?ooool00oo<0?ooooooooooo`19ooooo`;oc?l0?Oooool00oo<0?oooooooooo
o`0Rooooo`;o00001?ooool0013ooooo00?o0000ooooooooool01?ooool00ol0ofKoooooooooo`03
ooooo`03ool0VOooooooo`2I00?ooooo00?o0?mVooooooooool06_ooool00olc0?ooooooooooo`0A
ooooo`04o`3oI_ooooooooooo`3oIPCooooo00?o0?ooooooool0ool01?ooool00oo<0?oooooooooo
o`19ooooo`;oc?l0?Oooool00oo<0?ooooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo000@
ooooo`03o`000?oooooooooo00Cooooo00?o0?mVooooooooool00oooool00ooo09Woooooool0V@04
ooooo`03o`3oI_oooooooooo01Wooooo00?o<`3oooooooooool04Oooool01?l0ofKoooooooooool0
ofH4ooooo`03o`3ooooooooo0?oo00?ooooo0_o<0?l@ooooo`03o`3oI_oooooooooo023ooooo00?o
06Koooooooooool05Oooool2olco03cooooo00?oc03oooooooo<0?l09?ooool00ol0003ooooooooo
o`02ooooo`004?ooool00ol0003oooooooooo`04ooooo`03o`3oI_oooooooooo00?ooooo00?oo`2I
oooooooo09T01?ooool00ol0ofKoooooooooo`0Hooooo`;o<`3o4oooool01?l0ofKoooooooooool0
ofH4ooooo`04o`3oooooooooooooo`3oo`;ooooo0_o<0?l@ooooo`03o`3oI_oooooooooo023ooooo
00?o06Koooooooooool04oooool01?lco`3oc?l0ooooooo<o`0cooooo`03o`3ooooooooooooo00Ko
oooo00?oc03oooooooo<0?l09?ooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Cooooo
00?o0?mVooooooooool01?ooool00ooo09Woooooool0V@04ooooo`03o`3oI_oooooooooo01Sooooo
0_lc0?lCooooo`04o`3oI_ooooooooooo`3oIP?ooooo00Go0?ooooooooooooooooooo`3oo`02oooo
o`;oc03o4?ooool00ol0ofKoooooooooo`0Pooooo`03o`1Voooooooooooo01;ooooo0_lco`000oo<
o`3oooooolco000@ooooo`03oc<0oooooooooooo00Cooooo00?o0?ooooooooooool06Oooool00ol0
ooooooooooooo`06ooooo`03ol`0ooooooooc03o02?ooooo0_l00004ooooo`004?ooool00ol0003o
ooooooooo`03ooooo`03o`3oI_oooooooooo00Cooooo00?oo`2Ioooooooo09T01Oooool00ol0ofKo
ooooooooo`0<ooooo`03oonI0?oooooooooo00Sooooo00?o<`3ooooooolc0?l04_ooool01?l0ofKo
ooooooooool0ofH3ooooo`05o`3oooooooooooooooooool0ool00_ooool2ol`0o`oooooo0_l0ofHR
ooooo`;o06Ko4_ooool01_lco`3ooooooc?o0?o<o`3oooooolco013ooooo00?o<`3oooooooooool0
1?ooool00ol0ooooooooooooo`0Iooooo`03o`3ooooooooooooo00Kooooo00Coc03ooooooooooooo
c03o8oooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`03o`3o
I_l0oooooooo00Cooooo00?oo`2Ioooooooo09T01Oooool00ol0ofKoooooooooo`0<ooooo`03oonI
0?oooooooooo00Sooooo00?o<`3ooooooolc0?l04_ooool01?l0ofKoooooooooool0ofH3ooooo`09
o`3oooooooooooooooooool0oooooooool`0ooooooooc03o00oooooo0_l0ofH>ooooo`03o`1Voooo
oooooooo013ooooo00?o06Kooc<0ool0I_l04_ooool00olco`3oooooolco0002ooooo`03olco0?oo
oooooooo00kooooo00?o<`3oooooooooool01?ooool00ol0ooooooooooooo`0Hooooo`;o0?oo2?oo
ool01?o<0?ooooooooooooooV@0Sooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oo
oooooooo00?ooooo00?o0?mVo`3oooooool01?ooool01?oo09Wooooooooooooo09T4ooooo`03o`3o
I_oooooooooo00cooooo00?ooiT0ooooooooool02?ooool00olc0?oooooooc<0o`0Aooooo`05o`3o
I_ooooooooooooooool0ofH00oooool01ol0oooooooooooooooooooo0?ooooooooo<0?l00_ooool0
0oo<0?ooooooooooo`0<ooooo`03o`3oI_oooooo0?mV00gooooo00?o06Koooooooooool04?ooool0
0ol0I_oo<`3oo`1Vo`0Aooooo`07oc?o0?ooooooooooolco0?lco`3oooooolco000@ooooo`03oc<0
oooooooooooo00?ooooo0_l0oolJooooo`;o0?oo1oooool01Oo<0?oooooooooooooooooooiT001Go
oooo00?o<`3oooooooooool02oooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003ooooo
ooooo`03ooooo`03ool00?l0oooooooo00Cooooo00Coo`2Iooooooooooooo`2I1?ooool00ol0ofKo
ooooooooo`0<ooooo`03oonI0?oooooooooo00Oooooo00Coo`00oc<0oooooooo<`3o4Oooool00ol0
ofKo06Koooooo`02ooooo`04o`3oI_ooooooooooo`3oo`?ooooo00?o0?ooooooooo<0?l00_ooool0
0oo<0?ooooooooooo`0<ooooo`03o`3oI_oooooo0?mV00gooooo00?o06Koooooooooool04?ooool0
0ol0I_ooooooo`1Vo`0Aooooo`05oc?o0?ooooooooooolco0?lco`000_ooool00oo<o`3ooooooooo
o`0<ooooo`;o<`3o1Oooool2o`3ooa7ooooo00?oc?l0ooooooooool01_ooool00ol0ooooooooo`3o
o`06ooooo`05ol`0ooooooooooooooooooooV@005Oooool00olc0?ooooooooooo`0;ooooo`03o`00
0?oooooooooo00;ooooo000@ooooo`;o00001?ooool00ooo003o<`3oo`3oo`03ooooo`05ool0VOoo
oooooooooooooooo09T01?ooool00ol0ofKoooooooooo`0;ooooo`;ooiT02Oooool01?oo003o<`3o
oooooolc0?lAooooo`03o`3oI_l0I_oooooo00;ooooo00Co0?mVoooooooooooo0?oo0oooool00ol0
oooooooool`0o`02ooooo`03ol`0oooooooooooo00cooooo00?o0?mVool0VOl0ofH03Oooool2o`1V
oa7ooooo00Co06Kooooooolc0?oo06Ko3?ooool01?lco`3ooooooooooolco`03ooooo`05olco0?lc
o`3oooooooooooo<o`003_ooool2oc<0o`Cooooo00?ooiT0o`3oool0ool01_ooool2ool0V@Wooooo
00?oc?l0ooooooooool01_ooool00ol0ooooooooo`3oo`06ooooo`05ol`0oooooooooooooooooooo
V@005Oooool2oc<0o`_ooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`03ooooo`03ool0
0?lc0?oo0?oo00?ooooo00Goo`2Iooooooooooooooooool0V@04ooooo`03o`3oI_oooooooooo00_o
oooo0_ooV@08ooooo`05ool00?lc0?oooooooooooolc0?l04Oooool00ol0ofKo06Koo`1Vo`02oooo
o`04o`3oI_ooooooooooo`3oo`?ooooo00?o0?oool`0ooooool00_ooool00oo<0?ooooooooooo`0;
ooooo`04o`3oI_ooooooo`2Io`3oIPgooooo0_l0I_lAooooo`04o`1Voooooooo<`3oo`1Vo`_ooooo
00Go<ol0ol`0oolco`3ooooooc?o0002ooooo`03olco0?oooooo<ol000;ooooo00?oc?l0oooooooo
ool03?ooool2oc<0o`Cooooo00CooiT0o`3ooooooooo0?oo0oooool2ool0V@03oooooooo09Wooooo
00Sooooo00?oc?l0ooooooooool01Oooool01?l0ooooooooooooool0ool6ooooo`06ol`0oooooooo
ooooooooooooV@3oc03o5?ooool2oc<0o`cooooo00?o0000ooooooooool00_ooool0013ooooo00?o
0000ooooooooool00oooool00ooo003o<`3oo`3oo`03ooooo`05ool0VOoooooooooooooooooo09T0
1Oooool00ol0ofKoooooooooo`0:ooooo`03oonI0?oooooooiT000Oooooo00Goo`00olco0?oooooo
oooooc<0o`0Aooooo`08o`3oI_l0I_ooooooo`1Voooooooo0?mVooooool0ool4ooooo`03o`3oooo<
0?oooooo00;ooooo00?oc03oooooooooool02oooool01Ol0ofKoooooool0VOl0ofKoo`2I00cooooo
0_l0I_lAooooo`04o`1Voooooooo<`3oo`1Vo`[ooooo00Go<ol0ooooooo<0?oooooooc?o0003oooo
o`03olco0?oooooo<ol000;ooooo00?oc?l0ooooooooool03?ooool00olc0?oooooooc<0o`03oooo
o`04oonI0?l0ooooooooo`3oo`?ooooo00Coo`2Iooooooooooooo`2I2Oooool2olco00Kooooo00Co
0?oooooooooooooo0?oo1_ooool01_o<0?oooooooooooooo003ooiT0ol`0oaCooooo00Co<`3ooooo
oolc0?oooiT02_ooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03oooo
o`04ool00?lc0?ooooooo`3oo`;ooooo00Goo`2Iooooooooooooooooool0V@05ooooo`03o`3oI_oo
oooooooo00[ooooo00?ooiT0ooooooooV@001_ooool01_oo003oooooolco0?oo003ooooooc<0o`?o
oooo00?o<ol0ooooooooool02oooool02Ol0ofKooooooooooooooooo06Koo`3oI_oooooo0?ooolco
0004ooooo`05o`3oooooooooooooooooooo<0?l03Oooool02?l0ofKoooooool0VOl0ofKoooooool0
VOoooooo0?mV2?ooool00ol0I_ooooooo`1Vo`0Aooooo`04o`1Voooooooo<`3oo`1Vo`Wooooo00Co
<ol0ooooooooooooc03o1Oooool01_o<o`3ooooooooooolco`3oooooolco00kooooo00?o<`3ooooo
oolc0?l00_ooool2oonI00;ooooo00Go0?ooooooooooooooooooool0V@02ooooo`03ool0VOoooooo
oooo00Kooooo00?oc?l0ooooooo<o`001_ooool01?l0ooooooooooooool0ool5ooooo`05ol`0oooo
oooooooooooooooo00000_ooV@03ooooo`03o`1Voooooooooooo00Wooooo00?ooiT0ooooooooool0
0_ooool01?lc0?oooooooc<0ooooV@0:ooooo`03o`000?oooooooooo00;ooooo000@ooooo`;o0000
1Oooool00ooo003o<`3oo`3oo`02ooooo`05ool0VOoooooooooooooooooo09T01Oooool00ol0ofKo
ooooooooo`0:ooooo`03oonI0?oooooooiT000Kooooo00Koo`00ooooooo<o`3oo`00oooooolc0?l3
ooooo`03oc?o0?oooooooooo00_ooooo00Wo0?mVooooooooooooooooo`1Vool0ofKoooooo`3oooo<
o`001?ooool01Ol0ooooooooooooooooooooc03o00Gooooo00?o<`3oooooooooool01Oooool02?l0
ofKoooooool0VOl0ofKoooooool0VOoooooo0?mV1oooool01Oo<o`3o06Kooooooooooooo06Ko00oo
oooo00Go06Kooc<0oooooooo<`3oo`1Vo`09ooooo`04oc?o0?oooooooooool`0o`Gooooo00Koc?l0
oooooooooooo<ol0ooooooo<o`0>ooooo`03oc<0ooooV@3o<`3o00;ooooo00GooiT0o`3oooooV@3o
ooooo`3oo`02ooooo`03ool0VOoooooooooo00;ooooo00?oo`2Iooooooooool01Oooool00oo<o`3o
ooooolco0003ooooo`04o`1Vooooooooooooo`3oo`;ooooo00?o0?ooooooooooool00oooool01Oo<
0?oooooooooooooo003ooooo00;ooiT00oooool00ol0I_ooooooooooo`09ooooo`03oonI0?oooooo
oooo00;ooooo00Co<`3ooooooooooooooiT02Oooool2o`0000Cooooo000@ooooo`03o`000?oooooo
oooo00Cooooo00?oo`00oc<0ool0ool00_ooool01Ooo09Woooooooooooooooooo`2I00Gooooo00?o
0?mVooooooooool02_ooool00oooV@3ooooooonI0005ooooo`05ool00?oooooo<`3oolco0?oo0000
0_ooool01?lc0?oooooooooooolco`0=ooooo`09o`3oI_ooooooooooooooool0I_oo0?mVooooool0
ooooc?l000Cooooo00Go0?oooooooooooooooooool`0o`05ooooo`03oc<0oooooooooooo00Cooooo
00?o0?mVoooooooo09T00_ooool01?l0ofKoo`2Iooooool0ofH7ooooo`05olco0?l0I_oooooooooo
ool0I_l03oooool01Ol0I_oo<`3ooooooooooooo06Ko00Wooooo00Co<ol0ooooooo<0?ooc03o1Ooo
ool01_o<o`3ooooooooooolco`3oooooolco00gooooo00Co<`3oooooooooV@3o<`3o0_ooool01Ooo
V@3o0?oooonI0?oooooo0?oo00;ooooo00?oo`2Iooooooooool00_ooool00ooo09Woooooooooo`05
ooooo`03olco0?ooooooc?l000?ooooo00Co06Kooooooooooooo0?oo0_ooool00ol0oooooooooooo
o`03ooooo`05ol`0ooooooooooooool00?ooool00_ooV@02ooooo`04ol`0ool0I_oo06Koolco00So
oooo0_ooV@04ooooo`04oc<0oooooooooooooonI00[ooooo00?o0000ooooooooool00_ooool000So
oooo0ol00005ooooo`03o`000?oooooooooo00Cooooo00?oo`00oc<0ool0ool00_ooool00ooo09Wo
ooooooooo`02ooooo`03ool0VOoooooooooo00;ooooo00?o0?mVooooooooool02Oooool01?ooV@3o
ooooooooooooV@05ooooo`05ool00?lc0?ooc?l0olco0?oo00000_ooool01?lc0?oooooooc?o0?lc
o`0=ooooo`08o`3oI_ooooooooooooooool0I_oo0?mVooooool0ool2olco00?ooooo00Go0?oooooo
oooooooooooool`0o`05ooooo`03oc<0oooooooooooo00?ooooo00Wo0?mVooooooooooooo`2Iool0
0?oooooo0?mVool0VOooool00_l0ofH5ooooo`;oc?l000Co06Kooooooooooooo06Ko3?ooool3ool0
V@05o`1Vooooooooooooooooool0I_l02Oooool01?lco`3ooooool`0ooo<0?l5ooooo`06olco0?oo
oooooooooc?o0?ooooooc?l03Oooool02olc0?oooiT0oonI0?lc0?oooooooonI0?oooooo0?oooonI
0?l0I_oo0?oo00;ooooo00Ooo`2Ioooooooooooooooool`0oooo09Wo<ol000Kooooo00?oc?l0oooo
ooo<o`000oooool00ol0I_ooooooo`3oo`04ooooo`03o`3ooooooooooooo00;ooooo00Ooc03ooooo
ooooooooo`00oonI0?oo003ooiT000;ooooo00Coc03oo`1Vooooooooc?l01?ooool01ooo09Wooooo
oooooooooooooiT0ooooooooV@000oooool01Olc0?oooooooonI0?lc0?oooiT000Wooooo00?o0000
ooooooooool00_ooool000Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03oooo
o`04olco0?oo003o<`3oo`3oo`;ooooo00?oo`2Iooooooooool00_ooool00ooo09Woooooooooo`02
ooooo`03o`3oI_oooooooooo00Wooooo00CooiT0oooooooooooooiT01Oooool02Olc0?ooooooolco
0?o<o`3oo`00oc?o0?oooooo<`3ooonI0002oc?o00gooooo00So0?mVooooooooooooooooo`1Vool0
ofKoooooo`3oo`;oc?l00oooool01Ol0oooo<`3oooooooooooooc03o00Gooooo0_lc0?l3ooooo`0<
o`3oI_oooooooooooooooooo09Woo`00ooooool0ofKoo`2Io`3oI_oo003o0?mV1?ooool01?o<o`3o
ooooolco0?l0I_l2ooooo`03o`1Voooooooooooo00[ooooo00Coo`2Ioooooooo09Wo06Ko0oooool0
0ol0I_ooooooooooo`07ooooo`05oc?o0?ooooooc03oooooooo<0?l00oooool01oo<o`3ooooooooo
oooooooo<ol0ooooooo<o`003Oooool02olc0?oooiT0ooooooooV@3ooooooonI0?oooooo0?oooonI
0?l0I_oo0?oo00;ooooo00?oo`2Iooooooooool00_o<0?l00ooo09Wo<ol0ooooo`05ooooo`04olco
0?ooooooooooolco00;ooooo0_l0I_l00ol0ooooooooooooo`02ooooo`03o`3ooooooooooooo00;o
oooo00goc03oooooooooooooo`00oonI0?oooooooiT0ooooooo<0?oo06Kool`0ooooooooc?l000Co
oooo00Ooo`2IoooooooooooooooooonI0?oooooooiT000;ooooo00Ko<`3ooooooooooooooiT0oc<0
ooooV@03ooooo`03oc<0oooooooooooo00?ooooo00?o0000ooooooooool00_ooool00003ooooool0
003o000000?o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00Oo
c?l0ool00?lc0?ooooooo`3oooooooooo`2I00Cooooo00?oo`2Iooooooooool00_ooool00ol0ofKo
ooooooooo`08ooooo`05oc?o0?ooV@3oooooooooooooV@001Oooool02Olc0?ooooooolco0?oooooo
c?l0oc?o0?oooooo<`3ooonI0002oc?o00cooooo00?o06Koo`3oI_ooool00_ooool01?l0I_oo0?mV
ooooool0ool2olco00;ooooo00Ko<`3oo`3ooooooooo<`3oooooooo<0?l4ooooo`07oc<0ooo<0?oo
<`3oooooooooV@3oooooo`3oIP02ooooo`09ool00?oo09Woo`00ooooool0ofKoo`2Io`3oI_oo003o
0?mV00?ooooo00Koc?l0ooooooooooooc?l0o`1VooooV@02ooooo`03o`1Voooooooooooo00Cooooo
00Go0?ooooooooooooooooooool0V@02ooooo`03ool0VOl0I_oooooo00;ooooo00?o06Kooooooooo
ool00_ooool00olc0?ooooooooooo`02ooooo`05oc?o0?ooooooc03oooooooo<0?l00oooool01oo<
o`3ooooooooooooooooo<ol0ooooooo<o`003Oooool02oooV@3oooooooooooooV@3ooooooonI0?l0
ooooo`00oonI0?l0I_oo0?oo00;ooooo00Goo`2Iooooooo<0?oooooool`0o`02oc?o00Kooooo00So
c?l0ooooooooooooc?l0ooooool0I_ooooooo`3oo`?ooooo00?o<ol0ooooool0ool01?ooool01oo<
0?ooooooool00?oooooooiT0ooooooooV@000_o<0?l01?l0I_ooc03oooooooo<o`04ooooo`04ool0
VOoooooooooooonI00;ooooo00CooiT0oooooooooooo<`3o0_ooool00oooV@3o<`3ooonI0003oooo
o`03oc<0oooooooooooo00?ooooo00?o0000ooooooooool00_ooool000Wooooo00?o0000oooooooo
ool01?ooool3o`0000Cooooo00Goc?l0oc<0oooo09Wo0?ooool0V@05ooooo`03ool0VOoooooooooo
00;ooooo00?o0?mVooooooooool02?ooool01Olco`3ooiT0oooooooo003ooiT000Cooooo00Koo`00
oc<0ooooooooc?l0ooooooo<o`02oc?o0004oc<0ooooV@3o<ol0oc?o00cooooo00?o0?mVoooooooo
ool00_ooool01?l0I_oo0?mVooooooo<o`02ooooo`08olco0?oooooo<`3oooooool0oooo<`3ooooo
ooo<0?l4ooooo`07oc<0ooo<0?oo<`3oooooooooV@3oooooo`3oIP02ooooo`0:ool00?oo09Wooooo
ool00?l0ofKoo`2Io`3oI_oo003oooooo`3oIP;ooooo00Koc?l0ooooooooooooc?l0o`1VooooV@02
ooooo`03o`1Voooooooooooo00Cooooo00Go0?ooooooooooooooooooool0V@02ooooo`03ool0VOl0
I_oooooo00;ooooo00?o<`3oo`1Vooooool00_ooool01Ol0ofKooooooooooooooooo<ol000;ooooo
00?oc03oooooooo<0?l00oooool00oo<o`3oooooooooo`02ooooo`03oc?o0?o<o`3ooooo00cooooo
00oooiT0oooooooooooooiT0ooooooooV@3o0?ooool00?l0I_oooiT0o`3oooooooooo`2Iooooooo<
0?l00_ooool00oo<0?oo<ol0oc?o0006ooooo`08olco0?oooooo<ol0olco0?oooooo06Koo`3oool0
I_l3ooooo`03oc?o0?oooooo0?oo00Cooooo00Ooc03ooooooooo003ooooooonI0?oooooooiT000;o
c03o00Co06Kool`0ooooooooc?l01?ooool01?oo09WoooooooooooooV@02ooooo`04oonI0?oooooo
oooooc<0o`;ooooo00?ooiT0ooooooooV@000oooool01?lc0?ooooooooooooooool3o`0000Cooooo
0009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool01Ooo003oc?l0oc<0
ool0ooooo`2I00Gooooo00?oo`2Iooooooooool00_ooool00ol0ofKoooooooooo`03ooooo`03oonI
0?oooooooooo00;ooooo00Go<ol0oonI0?ooooooo`00oonI0003ooooo`09o`3ooooo003o<`3ooooo
ooo<o`3oooooolco0?lco`3ooooo00;ooiT000?o<ol0oooooolco`000oooool00ol0ofKooooooooo
o`05ooooo`03o`3oI_oooooooooo00;ooooo00Co06Koo`3oI_ooooooc?l00_ooool02?o<o`3ooooo
oc<0oooooooo0?oooooooolc0?ooc03o1?ooool04olc0?ooc03ooooooolc0?oooiT0ooooool0ofKo
ooooool00?o<0?ooo`2Ioooooooo003o0?mVool0VOl0ofKoooooool00?l0ofH00_ooool01_o<o`3o
ooooooooooooooooc?l0oonI00;ooooo00?o06Koooooooooool01?ooool01Ol0oooooooooooooooo
ooooo`2I00;ooooo00?oo`2Io`1Vooooool00oooool01Ol0I_oooooooooooooooooo0?mV00?ooooo
00?o<ol0ooooooo<0?l00_ooool01Oo<0?ooooooooooooooooooc?l000Cooooo00?o<ol0olco0?oo
ool03?ooool03oooV@3ooooooooooolc0?oooiT0ooooool0ooooooooo`1VooooV@3o0?oooooooooo
09Wooooool`0o`02ooooo`03ol`0oolco`3o<ol000Gooooo00Woc?l0oooooooooooo<ol0olco0?lc
o`3o06Koo`3oool0I_l00oooool00olco`3o<`3oo`3oo`03ooooo`0?ol`0ooooooooooooool00?oo
oooooiT0ooooooooV@3oc03oooooool0I_ooooooolco0?ooooooc?l000;ooooo00Goo`2Iool00?oo
09WooooooonI0002ooooo`04oonI0?oooooooooooc<0o`;ooooo00?ooiT0ooooooooV@000_ooool0
0olc0?ooooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0008ooooo`;o00001_ooool00ol0
003oooooooooo`04ooooo`05ool00?o<o`3o<`3oo`3ooooo09T01Oooool00ooo09Woooooooooo`03
ooooo`03o`3oI_oooooooooo00;ooooo00?ooiT0ooooooooool00_ooool01Olco`3ooiT0oooooooo
003ooiT000?ooooo00Co0?ooool00?lc0?ooc?l00_ooool00oo<o`3o<ol0ooooo`02oonI00;ooooo
00Go<ol0ooooooooooooooooo`3oIP07ooooo`03o`3oI_oooooooooo00;ooooo00ko06Koo`3oI_oo
ooooc?l0oonI0?ooooooc?l0oooooolc0?ooooooo`3ooooooooo<`3ool`0o`Cooooo00Co<`3ool`0
oooooooo<`3o0_ooV@003Ol0ofKoooooool00?o<0?ooo`2Ioooooooo003o0?mVoc?o0?l0ofKooooo
ool00?l0ofH00_ooool01_o<o`3oooooooooooooooooc?l0oonI00;ooooo00?o06Koooooooooool0
1?ooool2o`3oo`03oooooooo09Wooooo00;ooooo00?o06Kooc<0ooooool00oooool01Ol0I_oooooo
oooooolc0?oo0?mV00?ooooo00?o<ol0ooooooo<0?l00_ooool01Oo<0?ooooooooooooooooooc?l0
00Cooooo00?o<ol0olco0?ooool02oooool04?ooV@3o<`3ooooooooooooo<`3ooonI0?oooooo0?oo
ooooool0I_oooiT0o`1Vool0ooooo`2Iooooooo<0?l2ooooo`04oc?o0?l0oooo0?oooc?o00Cooooo
00Woc?l0oooooooooooo<ol0olco0?lco`3o0?ooooooool0I_l00_ooool2oc?o0003o`1Vool0oooo
<`3o00;ooooo00Soc03oooooooooooooo`00ooooooooV@3ooooooonI00;ooooo00Go06Koooooooo<
o`3oooooolco0002ooooo`05ool0VOoo003oo`2IooooooooV@000oooool00oooV@3ooooooc<0o`02
ooooo`03oonI0?oooooooiT000;ooooo00?o<`3oooooooooool01?ooool00ol0003oooooooooo`02
ooooo`002Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00Koc03oool0
0?ooooooc?l0o`3ooooo09T4ooooo`;o06Ko1Oooool00ol0ofKoooooooooo`02ooooo`;ooiT00ooo
ool01Olco`3ooiT0oooooooo003ooiT000;ooooo0_l0ool00ooo003o<`3oolco0002ooooo`03olco
0?lco`3ooooo00;ooiT00_ooool01Olco`3ooooooooooooooooo0?mV00Oooooo00?o0?mVoooooooo
ool00oooool01?l0ofKoooooolco0?ooV@02ooooo`08olco0?o<0?ooooooooooool0oooooooooc<0
ooo<0?l3ooooo`09oc<0ooo<0?oooooooonI0?oooooooiT0o`3oI_oo003ooooo00;oc03o0_ooool0
2?l0ofKo<ol0o`3oI_ooooooo`00ooooool0ofKoc?l01?ooool00oo<o`3ooiT0oonI0002ooooo`03
o`1Voooooooooooo00?ooooo0_l0ool00oooooooo`2Iooooo`02ooooo`03o`1Voolc0?oooooo00?o
oooo00Go06Kooooooooooooo<`3oo`3oIP03ooooo`03oc?o0?ooooooc03o00;ooooo00Goc03ooooo
ooooooooooooolco0004ooooo`03oc?o0?o<o`3ooooo00_ooooo00GooiT0oooooooooooooooooc<0
o`02ooooo`09o`3ooooooooo06KooonI0?l0I_oo0?ooool0VOooooooc03o00;ooooo00Co<ol0o`3o
oooo09Wo<ol01?ooool01oo<o`3ooooooc?o0?ooooooc?l0oc?o0?l0ool00_ooool02_l0I_oooooo
oc?o0?lco`3o06Koo`3ooooooooo<`3oo`3oI_o<0?l2ooooo`0<ool00?oooooooiT0ooooooooV@3o
c?l0ooooool0I_ooooooolco0?ooooooc?l00_ooool01?oo09Woo`00ool0VOooV@04ooooo`05oonI
0?oooooo<`3oooooooooV@000_ooool01?lc0?oooiT0oooooolc0?l6ooooo`03o`000?oooooooooo
00;ooooo000@ooooo`;o00001?ooool01_o<0?ooo`00ooooooo<o`3oooooo`3oo`Cooooo00?o06Ko
ool0VOl0I_l01?ooool00ol0ofKoooooooooo`02ooooo`;ooiT000oooooool`0oooooooooiT0oc?o
0?ooooooo`00ooooooooV@3o0?ooooooool0ooooo`00oc<0ooo<o`000_ooool02Oo<o`3o<ol0oooo
ooooV@3ooooooonI0?oo09Wo<ol0ool0V@02ooooo`04o`3oI_ooooooooooo`1Vo`?ooooo00?o06Ko
o`3oI_ooool01?ooool00ol0ofKo0?ooolco0002oonI0009ooooooo<o`3oc03ooonI0?oooooo0?oo
oooooolc0?ooc03o00?ooooo00_o<`3ool`0oooooooooiT0oc<0ooooV@3o0?mVool00?o<0?oooooo
ol`0o`02ooooo`08ool00?lco`3o0?mVoooooooo003oooooo`3oI_o<o`04ooooo`03olco0?ooV@3o
oiT000;ooooo00?o06Koooooooooool00oooool2o`3oo`07oooooooo09Wooooooc<0oooooooo06Ko
ool0V@04ooooo`03o`1Voolc0?oooooo00;o0?mV0oooool00olco`3ooooool`0o`02ooooo`04ol`0
ooooooooooooolco00Gooooo00?o<ol0olco0?ooool02oooool04?ooV@3oooooooooool0ofKooooo
oc<0oooooooo0?ooooooool0I_oooiT0o`1Vool0ooooo`2Iooooooo<0?l2ooooo`04oc?o0?l0oooo
o`2Ioc?o00Cooooo00?oc?l0oooooolco`000_ooool01_o<o`3o06Kooooooooooooo06Kooc<0o`;o
<ol00_l0I_l01?l0ooooooooo`3oI_o<0?l2ooooo`0<ool00?oooooooiT0ooooooooV@3oc?l0o`1V
ooooooooo`00olco0?ooooooc?l00_ooool01?oo09Woo`00ool0VOooV@04ooooo`0;oonI0?oooooo
<`3oooooooooV@3oooooo`3oI_lc0?oooiT0oooooolc0?l01Oooool2o`0000Cooooo000@ooooo`03
o`000?oooooooooo00?ooooo00Koc03ooooooooo003oc?l0ooooool0ool4ooooo`04o`1Voooo09Wo
ooooo`1Vo`?ooooo00?o0?mVooooooooool00_ooool2oonI0006ooooooo<0?oooooooonI0?lco`3o
oooo0_oo00001oooV@3oooooooooool0ofKo0?ooooooooo<o`000_ooool03?o<o`3o06KooonI0?oo
oooo<`3ooonI0?o<o`3o<ol0oooooooo09Woooooo`3oIP;ooooo00Ko06Koooooooooooooooooo`1V
ool0ofH5ooooo`0>o`3oI_l0ooooc?l0oonI0?oooooooiT0olco0?o<0?oooiT0ooooool0ooooc?l0
oc<0ooo<0?l3ooooo`0=oc<0ooo<0?oooooooonI0?lc0?oooiT0o`3oI_oo003oc03oool0VOoooooo
c03oooooo`02oc?o0006ool0VOo<o`3oo`00ooooool0ofKoc?l00oooool01?l0I_ooc?l0oonI0?oo
V@02ooooo`03o`1Voooooooooooo00?ooooo0_l0ool01ooo09Wooooooooooolc0?ooooooo`3oI_oo
09T01?ooool01_l0I_oo<`3oooooool0ofKoc03oo`3oIP;ooooo00Ko<ol0ooooooo<0?ooooooo`3o
ooo<0?l2ooooo`03olco0?l0I_oooooo00?ooooo00?o<ol0olco0?ooool02oooool03OooV@3ooooo
ooooool0ofKooooooc<0ool0ooooo`00o`1VoooooooooiT0o`1Vool0ool00_ooool01oo<0?ooo`00
oooooolco`3o0?ooool0VOlco`001?ooool00oo<o`3ooooooc?o0002ooooo`06olco0?lco`3ooooo
ooooool0I_oo<ol00_ooool00olco`3oc03oo`3oo`02o`3oIP0?ol`0ooooooooooooool00?oooooo
oiT0oooooooo003ooiT0o`1Vooooooooo`00olco0?ooooooc?l000;ooooo00Coo`2Ioooooooo09Wo
oiT01?ooool01OooV@3ooooooc<0oooooooooiT000;o0?mV00Co<`3ooonI0?oooooo<`3o1_ooool0
0ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`04ooooo`05ol`0oooo09Woc?l0
ooooool0ool01?ooool01?l0I_ooo`2Iooooool0I_l3ooooo`03o`3oI_oooooooooo00;ooooo00So
oiT0ooooooooV@3oc03ooc?o0?ooV@3o<ol0ooooo`;oo`0000OooiT0oooooooooooo0?mVo`3ooooo
ooooc?l000;ooooo00_oc?l0o`1VooooV@3oo`00oc<0ooooV@3oc?l0oc?o0?ooooooo`2Iooooo`02
o`3oIP;o06Ko0oooool00ol0I_oo0?mVooooo`04ooooo`07o`3oI_l0ooooc?l0oonI0?oooooooiT0
olco0002oonI00;ooooo00?oc?l0oooooolc0?l00_ooool03_lc0?ooc03oooooooo<0?oooiT0oc<0
ooooV@3o0?mVool0VOo<0?ooo`2Iooooooo<0?oooooo0_lco`000ooo09Woc?l0ool00002ooooo`06
olco0?ooooooooooooooool0I_ooc?l00_ooV@02ooooo`03o`1Voooooooooooo00;ooooo00Co0?oo
ooooool0ooooo`2I0_ooool2oc<0o`03o`3oI_oo09Wooooo00?ooooo00Ko06Kooc<0oooooooo0?mV
oc?o0?l0ofH2ooooo`06oc?o0?o<0?ooooooooooool0ooooc03o0_l0I_l01?o<o`3o06Koooooool0
ool2ooooo`03oc?o0?o<o`3ooooo00[ooooo00[o<`3ooonI0?oooooo0?mVooooool0ofKo<`3oo`3o
oooo003o06Ko0_ooool01?ooV@3o0?ooooooooo<0?l2ool00005oooooolco`3o0?ooool0VOlco`00
1?ooool00oo<o`3o<ol0ooooo`02ooooo`06olco0?lco`3ooooooooooolc0?oo<ol00_ooool00olc
o`3oc03oo`3oo`02o`3oIP03ol`0ooooooooo`0000;ooooo013ooiT0oooooooo003ooiT0olco0?oo
ooooo`00olco0?ooooooc?l0o`1Voooo09Woo`00oooooooo003ooiT01?ooool02_ooV@3ooooooc<0
oooooooooiT0ooooool0ofKo<`3ooonI0?lc0?l7ooooo`03o`000?oooooooooo00;ooooo000@oooo
o`03o`000?oooooooooo00Cooooo00Goc03oool0VOlc0?ooc?l0o`3oo`03ooooo`06o`1Voooooooo
ooooool0VOoooooo06Ko0_ooool01Ol0ofKooooooooooooooooooiT000;ooooo00WooiT0ol`0oolc
o`3ooiT0oooooolco`3oooooool00?ooV@000_ooool01?l0ofKo0?oooc?o0?o<o`02ooooo`06olco
0?l0I_oooiT0oooooolc0?oooiT00_o<o`000oooooooo`2Iooooo`02o`3oIP03o`1Voooooooo06Ko
00;ooooo00?o06Koo`3oI_ooool01?ooool01?l0ofKo0?ooolco0?ooV@02ooooo`04oonI0?o<o`3o
oiT0ooooo`;oc?l000?ooooooc<0oolc0?l00_lco`003Oo<0?oooooool`0ooooV@3ooooooc<0oooo
V@3ooooool`0oooo09Wooooool`0ooooool00_lco`001_oo09Woc?l0olco0?oo003oooooolco00?o
oooo00Co06KooonI0?oooooooiT00_ooool00ol0I_ooooooooooo`02ooooo`04o`3ooooooooooooo
o`3oo`;ooooo00Co<`3oooooool0ofKoo`2I1?ooool01_l0I_oooooooc<0ool0ofKo<ol0o`3oIP;o
oooo00?o<ol0ol`0ooooool00_l0ool01ooooooo06Koooooooo<o`3o06Koooooool0ool00_ooool0
0olco`3oc?l0ooooo`09ooooo`04oc<0oooooooooiT0o`3oIP;ooooo00Go0?mVoc<0ool0oooooooo
oc?o0002ooooo`0;oonI0?l0oooooooool`0ool0ofKoooooool00?lco`3o0?oooooooolco`001?oo
ool01oo<o`3ooooooooooooooooo0?ooolco0?lco`000_ooool03?lc0?oo<ol0o`1Vool0I_oo<ol0
ol`0ool0oooo0?mVoc<0ool0ofKoooooool000;ooooo00GooiT0oooooooo003ooiT0olco0002ool0
0009olco0?ooooooc?l0o`1Voooo09Woo`00oooooooo003ooiT000;oc?l00oooool01?ooV@3o<`3o
o`3oI_ooV@02ooooo`05o`3oI_ooV@3o<`3ooooooolco`001Oooool00ol0003oooooooooo`02oooo
o`004?ooool00ol0003oooooooooo`04ooooo`05ol`0oooo09Woooooolco0?l0ool00oooool01?l0
I_oooooooooooooo09T2ooooo`03o`1Voooooooo0?mV00?ooooo00KooiT0oooooooooooooiT0ol`0
ooooV@02ooooo`04oc?o0?oooooo0?oooonI00;ooooo00?o0?mVo`3oooo<o`000oooool02oo<o`3o
06KooonI0?oooooo<`3ooonI0?ooooooc?l0oooooooo09Wooooo00;o0?mV0_ooool01?l0I_oooooo
o`1Vool0ofH6ooooo`04o`3oI_l0ooooc?l0oonI00;ooooo00Co<`3oolco0?ooV@3ooooo0_o<o`00
3ooooooo<ol0oc?o0?lc0?oo<ol0ol`0ooooooooc03ooonI0?oooooo0?mVoonI0?ooooooc03oool0
V@02ooooo`0:ol`0oolco`3o<ol0olco0?ooooooc?l0ool00?ooooooc?l0o`3oIP;ooooo00Co06Ko
oonI0?oooooooiT00oooool01Ol0I_oooooooooooooooooo0?oo00;ooooo00?o0?oooooooolc0?l0
0_ooool00ol0ofKoo`2Iooooo`03ooooo`04o`1Voooooooo<`3oo`3oIP;o<ol00_ooool00olco`3o
c03oooooo`02o`3oo`07ooooool0I_ooooooolco0?l0I_ooooooo`3oo`02ooooo`03oc?o0?o<o`3o
oooo00Wooooo00?o<`3ooonI0?l0ofH01?ooool01?l0ofKo0?oooooooolco`02ooooo`0;oonI0?l0
oooooooool`0ool0ofKoooooool00?lco`3oc03ooooooolco`000oooool00oo<o`3oooooooooo`02
ooooo`07o`3oooo<o`3o<ol0oooooolc0?oo<ol0ooooo`02o`1Vo`08oc?o0?oooooo0?mVoooooolc
0?oo0?mVoooooooo0002ooooo`05oonI0?ooooooc?l0oonI0?o<o`000_oo00003?o<o`3ooooooooo
ooo<o`3o<ol0ool00?ooooooo`00oonI0?o<o`3oooooolco00;ooooo00CooiT0oc<0ool0ofKooiT0
0_ooool01Ol0ofKooiT0oc<0oooooooo<ol000Gooooo00?o0000ooooooooool00_ooool0013ooooo
0_l00006ooooo`04ol`0ooooooooc?l0o`3oo`?ooooo00Co06Koooooooooooooo`2I0_ooool00ol0
I_ooooooo`3oIP03ooooo`04oonI0?ooooooooooooooo`;ooiT00_ooool01?lco`3oooooo`3ooooo
V@02ooooo`;o0?mV00ooc?l0ooooooooooooooooolco0?oooooooiT0ool0VOlc0?oooiT0ooooooo<
o`3oooooool0VOooool00_l0ofH2ooooo`04o`1Voooooooo06Koo`3oIPKooooo00?o06Koo`3oI_oo
V@000oooool01?lc0?ooc?l0oonI0?ooool2olco0008oooooolco`3ooooooooooolco`3oc03ooooo
ooooV@02ooooo`03o`3oI_ooV@3oc03o00Cooooo00[o<ol0ooooooooooooc?l0o`3oooooooooc?l0
o`1Vooo<o`3o0?mV0_ooool01?l0I_oooiT0ooooooooV@03ooooo`05o`1Vooooooooooooooooool0
ool00_ooool00ol0ooooo`00oc<0o`02ooooo`;o0?mV1?ooool01?l0I_ooooooooooool0ofH2oc?o
00;ooooo00[o<ol0ol`0oooooooo0?ooooooool0ooooc03oolco0?oooooo06Ko0_l0ool2ooooo`03
oc?o0?ooooooc?l000Wooooo00?o<`3ooonI0?l0ofH00_ooool01Oo<0?ooooooo`3oI_l0oooooooo
00;o<ol000gooooooonI0?l0ooooooooo`3oI_ooV@3ooooooc?o0?l0ooooc03oooooool0oooo<ol0
00;ooooo00?oc?l0ooooooooool00_ooool01_l0ooooc?l0oc?o0?oooooo<`3ooc?o00;ooooo00Wo
06Kooc?o0?oooooo0?mVol`0oolc0?oo0?mVoooooooo00000_ooool02?ooV@3oooooolco0?ooV@3o
06Koolco0?oo003oc?l00_ooool02Oo<o`3o<ol0ooooooooooooo`00oonI0?o<o`3oooooolco0002
ooooo`04oonI0?l0ofKooooooonI00;ooooo00Go0?mVoonI0?lc0?oooooooc?o0004ooooo`;o0000
1?ooool0013ooooo00?o0000ooooooooool01Oooool01?o<0?ooooooolco0?l0ool3ooooo`04o`1V
ooooooooooooool0V@;ooooo00?o06Koooooool0ofH00oooool01_ooV@3oooooooooooo<0?oooiT0
oc?o00;ooooo00Wo<ol0ooooool0oooooooooonI0?l0ofKoooooo`3oI_o<o`000oooool03Olco`3o
oiT0o`1Voooo09Wo<`3ooonI0?oooooo<ol0olco0?oooooo0?mVo`1Vool0ofH00_ooool01?l0I_oo
ooooo`1Vool0ofH6ooooo`03o`1Vool0ofKooiT000;ooooo00Wo<`3ool`0ooo<o`3ooooooonI0?oo
ooooc?l0oc?o0?o<0?l00_ooool01?lco`3oc03oooooooooV@02ooooo`03o`3oI_ooV@3oc03o00Co
oooo00Ko<ol0ooooooooooooc?l0o`3oooooool2olco0006ooooool0ofKoooooooooool0I_oooiT0
0_ooool01?ooV@3ooooooooooolco`03ooooo`0<o`3oooooooooooooo`3ooooooooo<`3oooooool0
ofKoooooo`3oI_oooooooiT00_ooool01?l0I_ooooooooooool0ofH2oc?o00;ooooo00?o<ol0ol`0
ool0ool00_ooool01Ol0ooooc03oolco0?o<0?oo06Ko00;o0?oo0_ooool01_lco`3oooooolco0?oo
ooooo`00olco00Kooooo00?o<`3ooonI0?o<o`000_ooool05?o<0?ooooooo`3oI_l0oooo<`3ooc?o
0?oooooo<ol0oonI0?l0ooooooooo`3oI_ooV@3ooooooc?o0?l0ooooc03ooooooooo09Wo<ol00_oo
ool00oo<o`3oooooooooo`02ooooo`03o`3oooo<o`3ooooo00;o<ol00_oo09T2ooooo`08oc?o0?oo
oooo0?mVol`0oolc0?oo0?mVoooooooo0002ooooo`03oonI0?ooooooc?l000?ooiT000Koc?l0ol`0
ooooooooooooolco0?lco`02ooooo`05oonI0?o<o`3oooooooooooo<o`000oooool2oonI00?ooooo
00Go0?mVoonI0?lc0?oooooooc?o0005ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`00
0?oooooooooo00Gooooo00Goc03oooooooo<o`3oooooo`3oo`02ooooo`04o`1Vooooooooooooool0
V@?ooooo00?o06Koooooool0ofH00_ooool01_ooV@3oooooooooooo<0?oooooooc?o00;ooooo00?o
<ol0ooooool0ool00_ooool05?ooV@3oo`2Io`3oI_o<o`3o<ol0ooooool0ofKo<ol0oonI0?l0I_oo
o`2Ioc<0ooooV@3ooooooc?o0?o<o`3oooooo`3oI_l0I_oo0?mV0_ooool01?l0I_ooooooo`1Vool0
ofH6ooooo`03o`1Vooo<o`3ooiT000;ooooo00oo<`3ool`0ooo<o`3ooooooonI0?oooooo0?ooolco
0?ooooooc03ooooooolco`3oc03oooooooooV@000_ooool00ol0ofKooiT0ol`0o`04ooooo`06oc?o
0?ooooooooooolco0?oooooo0?oo0_o<o`002Ol0I_oo0?mVoooooooooooo06KooonI0?o<o`3ooooo
oonI0002ooooo`05oc?o0?ooooooooooooooool0ool00_ooool02Ol0oooooooooc<0oooooooo0?mV
ooooool0ofKooooooonI0002ooooo`06o`1Voooooooo0?mVol`0oolco`3o0?mV0_lco`005?oooooo
c03oo`3ooooooooo0?mVo`3oooo<0?ooc?l0ooooool0I_oo0?ooooooool0oooooooooc?o0?oooooo
c?l0ool00?ooooooc?l01_ooool00ol0ofKooiT0olco0002ooooo`0Dol`0oooooooo0?mVo`3ooooo
oooo<ol0oooooolco`3ooiT0o`3ooooooooo0?mVoonI0?oooooo<ol0o`3oooo<0?ooooooool0VOlc
o`02ooooo`0Folco0?ooooooooooool00?oooooo0?ooolco0?oooooo<ol0oooooooo09Woooooool0
VOoooooo<ol0o`3oI_l0I_oo0?oooc<0ool0ofKoooooool000;ooooo00cooiT0ooooooo<o`3o06Ko
ool00?o<o`3ooiT0ol`0oooooooo<ol0olco0?lco`02ooooo`05oonI0?o<o`3oooooooooooo<o`00
0_ooool00ol0ofKooiT0oonI0003ooooo`05o`3oI_lc0?oooiT0oc?o0?l0ool01Oooool00ol0003o
ooooooooo`02ooooo`004?ooool00ol0003oooooooooo`05ooooo`05ol`0oooooooo<`3oolco0?l0
ool00_ooool01?l0I_oooooooooooooo09T3ooooo`03o`1Voooooooo0?mV00;ooooo00KooiT0oooo
ooooooooc03oo`3ooolco`02ooooo`03ool00?lco`3oo`0000;ooooo00go0?mVoonI0?l0ofKoc?l0
oc?o0?oooooo0?mVoc?o0?ooV@3oo`2Io`1Vooo<o`3ooiT000;ooooo00Goc?l0ooooool0ofKo06Ko
o`3oIP03ooooo`03o`1Vool0ofKooooo00Kooooo00?o06Koolco0?ooV@000_ooool01Olc0?ooc03o
ooooooo<o`3ooiT000;ooooo00Soc?l0ooooooo<0?oooooooc?o0?o<0?oooooooonI00;ooooo00?o
0?mVoonI0?o<0?l01?ooool04Olco`3oooooolco0?lco`3oooooo`3oool0I_ooc?l0o`1Voolco`3o
ooooo`1VoooooooooiT0olco0?oooooooiT000;ooooo00Go<ol0o`1Vooooooooooooo`3oo`02oooo
o`?ooiT000koo`00o`3oI_oooooo0?mVoonI0?oooooooiT0ooooool0I_ooooooo`3oI_o<0?oo<ol0
oc<0o`;o<ol000?oc03oooooool0ool00_l0ofH00ol0ooooooooolco0002ooooo`08o`3ooooooooo
0?oooooooolco`3oooooolco0?ooool2olco00Gooooo00Co<`3oo`3oI_ooV@3oc?l00_ooool03?o<
0?ooooooo`3oI_oo003o<ol0oooooolc0?oo<ol0oonI0?l0I_oo0?mVol`0o`;ooiT000Wo<ol0ool0
0?o<0?ooooooool0VOlco`3ooooooc?o0?o<o`000_ooool01ooo003oooooo`3oooo<o`3ooooooc<0
oooo09T00oooool02Ooo09Wo<ol0o`3oI_l0I_oo0?oool`0ool0ofKoooooool00002ooooo`0<oonI
0?l0ooooc?l0o`1Voooo003oc?l0oonI0?o<0?oo<ol0ooooooo<o`3o<ol00_ooool01OooV@3oc?l0
ool0VOooooooc?l000;ooooo00?o0?mVoc<0ooooV@000oooool01Oo<0?oo0?mVoonI0?lco`3o0?oo
00Gooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01Oooool01Ooo09Wo
c03ooc<0ooo<o`3o0?oo00;ooooo00Co06Koooooooooooooo`2I0oooool00ol0I_ooooooo`3oIP02
ooooo`06oonI0?oooooooooool`0ool0oooo<ol00_ooool02_oo003o<ol0ool00?ooooooo`00o`3o
I_ooV@3o<ol0olco0?lco`02o`3oIP03oc?o0?ooV@3oo`2I00;oc?l000WooooooonI0?oooooo<ol0
olco0?l0ofKo06Koooooool0ofH00_ooool00ol0I_oo0?mVooooo`05ooooo`04oc?o0?l0ooooc?l0
oonI00;ooooo00[o<`3ool`0ooooooooc?l0oonI0?oooooo<ol0olco0?ooooooc03o0_ooool02?lc
o`3ooooooonI0?ooooooo`2Io`3oI_l0oooooiT01?ooool04Olco`3oc?l0olco0?lco`3oooooo`3o
ool0I_ooo`00o`1Voolco`3o0?mVoooooooo003ooiT0olco0?oooooooiT000;ooooo00[o<ol0o`1V
ooooooooooooo`3oooooooooo`00oonI0?l0oooo<`3o0_ooV@000ooooooooiT0ool0V@02ooooo`07
oonI0?l0I_ooooooo`3oI_o<0?oo<ol0oc<0o`02oc?o00;o0?oo00Ko0?mVooooool0I_oo0?mVoooo
ooo<o`02ooooo`08o`3ooooooooo0?oooooooolco`3oo`00olco0?ooool2olco00Gooooo00Go<`3o
o`3oI_ooV@3oc?l0ooooo`02ol`0o`0Eooooool0oooo0?mVoc?o0?o<o`3ooooooc<0oolco`3ooiT0
o`3oI_ooV@3ooooooonI0?lco`3oo`00ooooooo<0?oooooooc?o0?ooooooc?l000?ooooo00Ooo`00
ooooool0ooooooooolco0?lc0?ooo`2I00?ooooo00Soo`2Ioc?o0?l0ofKo06Koo`3ooooooooo<`3o
o`3oIP?ooooo00CooiT0o`3oooo<o`3o06Ko0_ooool01_ooV@3oo`00oc?o0?ooooooc?l0oc?o00;o
oooo00WooiT0ool00?oo09Woooooolco0?l0oooo0?mVool0VOlc0?l01?ooool01Oo<0?oo0?mVoonI
0?lco`3o0?oo00Gooooo00?o0000ooooooooool00_ooool0013ooooo0_l00006ooooo`07ool0VOo<
0?oo<`3oolco0?l0ooooooooo`1Vo`03ooooo`0:ool0VOooooooooooooooool0I_ooooooo`3oI_oo
oooo06KooonI00;ooooo00Soc03oo`3ooolco`3oc03ooooooooo003o<ol0ooooo`;oo`0000Go0?mV
oonI0?lco`3oc?l0oc?o0002o`3oIP0>oc?o0?ooV@3oc?l0o`1Voolc0?ooo`00oonI0?oooooo<ol0
olco0?l0ofKo06Koooooool0ofH3ooooo`03o`3oI_oooooooooo00Cooooo00So<ol0o`3oooo<o`3o
oiT0o`3oI_oooooo<`3ool`0o`;ooooo00CooiT0oooooolco`3oc?l00_ooool2ol`0o`09oc?o0?oo
oooooiT0oooooooo09Wo0?mVo`3oooooV@3ooooo00;o<ol00_o<o`000oo<0?oo0?oooc?o0002oooo
o`0;o`3ooooo003ooooooc?o0?l0ofKoooooool00?ooV@3oc?l0ooooooooV@000_ooool03olco`3o
ooooo`1Voooooooo0?oooooooooo09WooiT0o`3oooooooooo`00o`3oI_ooV@3oooooo`3oIP02oooo
o`05oonI0?oooooo06Koo`3oI_lco`000_ooool01?l0ofKo<ol0ol`0ool0ofH2ooooo`0<o`1Vool0
ofKoooooolco0?oooooo0?ooo`1Voooooooo0?oooooooolco`3ooooo0_o<o`001?ooooooc?l0oooo
oooo09T3ooooo`03oc<0ool0ofKooiT000;oc?l001Ooc03oool00?o<0?oo0?ooo`3oI_lco`3oc?l0
oooooolc0?oo<ol0oonI0?l0ofKooiT0o`3oooooV@3o<ol0ool00?ooooooc03ooooooolco`3ooooo
olco0003ooooo`07ool00?oooooo0?ooooooooo<o`3oooooool0V@03ooooo`08ol`0oolco`3o0?mV
o`1Vool0oooooooooc<0ool0ofH2ooooo`05oonI0?l0oooo0?ooolco0?oo00000_ooool01_o<o`3o
oiT0oc?o0?ooooooc?l0oc?o00;ooooo00[ooiT0ool00?oo09Wo0?ooooooooo<o`3o0?mVool0VOlc
0?ooo`2I0oooool01Oo<0?oo0?mVoonI0?lco`3o06Ko00Cooooo0_l00004ooooo`004?ooool00ol0
003oooooooooo`04ooooo`08ool0VOooooooo`00oc<0ooo<o`3o0?ooooooool0I_l3ooooo`03ool0
VOoooooooooo00;ooooo00Go06Koo`3oI_oooooo06KooonI0002ooooo`;o0?oo01go<ol0ol`0oooo
ooooo`00oc?o0?ooooooo`00ol`0ool0ofKoo`2IoonI0?o<o`3o<ol0ooooool0ofKooiT0olco0?oo
oooo06Kooc<0oooo003ooiT0oooooolco`3oc?l0o`3oI_lco`3oooooo`3oIP03ooooo`03o`3oI_oo
oooooooo00Cooooo0oo<o`001?ooV@3o0?mVoooooolc0?l3ooooo`04oonI0?oooooo<ol0olco00;o
oooo0_o<0?l04?lco`3ooooooonI0?ooooooo`2Io`3oI_l0oooooiT0oooooolco`3oooooolco0?oo
ooooc03oo`3ooolco`02ooooo`03o`3ooooo003ooooo00;o<ol00_oo00001OooV@3oc?l0olco0?oo
V@3oc?l000;o<ol000_oooooo`1Voooooooo0?oooooooooo09WooiT0o`3oooooooooo`00o`3oIP02
ooooo`08o`3oI_oooooooooooonI0?oooooo06Koo`3oI_lco`02ooooo`04o`3oI_lco`3oc03oo`3o
IP;ooooo00?o06Koo`3oI_o<o`000_ooool01ol0oooo06Kool`0ool0ooooooooool00?lco`000_o<
o`000oooooooc?l0ooooo`02ool0V@;ooooo00[o<`3oo`3oI_ooV@3oooooolco0?o<0?ooo`00ol`0
ool0oooo0?mV0_o<o`004?oooooo<`3ooc?o0?ooV@3o0?oooonI0?oooooooiT0oc?o0?oo003ooooo
ol`0oooooooo<ol0olco0?lco`03ooooo`06o`3oI_oo003o0?oooc<0ooo<o`3oo`2I1?ooool02?o<
0?oooooooc?o0?l0I_oo0?oooooooolc0?oo0?mV0_ooool01?ooV@3oooooo`3oooo<o`04ooooo`0A
oonI0?lco`3oooooool0VOo<o`3o06KoooooooooV@3oo`00ool0VOl0ooooooooolco0?l0ofKo<`3o
oooooooo09T00_ooool01_o<0?ooooooo`3oI_ooV@3o<ol0o`1Vo`Gooooo00?o0000ooooooooool0
0_ooool0013ooooo00?o0000ooooooooool01?ooool02?oo09Woooooool00?ooooooc?l0o`3ooooo
oooo06Ko0oooool00ooo09Woooooooooo`02ooooo`05o`1Vool0ofKoooooo`1VooooV@000_ooool2
o`3oo`0Goc?o0?o<0?ooooooool00?lco`3ooooool`0oooooooo0?mVool0VOooV@3oc?l0o`3oI_lc
o`3o0?mVoonI0?oo09Woooooo`1Voolc0?ooo`00oonI0?ooool00_ooV@001?l0ofKo<ol0ol`0ool0
ofH2ooooo`03o`3oI_oooooooooo00Cooooo00So<ol0olco0?l0oooo0?mVoonI0?l0ofKooooooc<0
o`?ooooo00CooiT0oooooolco`3oc?l00_ooool2ol`0o`0@oc?o0?ooV@3oc03ooooooooo09Wo0?mV
o`3oooooV@3ooooooc?o0?ooooooc?l0ooooooo<0?oo0?oooc?o00;ooooo00So0?ooool00?lco`3o
oooooc?o0?oo003ooooooonI00;ooooo00oooiT0ooooooo<o`3ooooooc?o0?oooooo06Koo`3ooooo
ooooo`2IoonI0?lc0?oo0?ooool00?l0ofH00_ooool02?l0ofKooooooooooolco`3ooiT0o`1Vool0
ofKo<ol00_ooool01?l0ofKooooool`0ool0ofH2ooooo`?oc?l000Woooooo`3ooooooooo06Kooooo
ool0ooooooooool00?lco`000_o<o`008oooooooc?l0ool00?oo09Woooooool0VOoooooo0?mVoooo
ooooV@3oooooolco0?o<0?ooo`00ol`0ool0ooooc?l0oc?o0?o<o`3oooooool0VOlc0?oooiT0o`3o
ooooV@3ooooooonI0?lco`3oooooool00?o<0?oooooooc?o0?o<o`3o<ol000;ooooo00Ooo`00o`3o
I_l0ofKo0?ooooooooo<o`3oo`2I00Cooooo00Soc03ooooooolco`3oooooo`3ooooooooo<`3oo`3o
IP;ooooo00CooiT0ooooool0ooooc?l01?ooool04OooV@3o<ol0oooooooo09Woc?l0oc?o0?o<o`3o
oiT0ool00?oo09Wo0?ooooooooo<o`3o0?oooc<0ooooooooo`2I00;ooooo00Goc03oooooool0ofKo
oiT0oc?o0006ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00?ooooo
00Wo<ol0ool0VOooooooo`00oooooolc0?ooc?l0ooooool0I_l01?ooool02ooo09Wooooooooooooo
oooo06Koo`3oI_l0I_oooiT0o`1Voooo09Wooooo00;o0?oo01Go<ol0ol`0ooooooooo`00oc?o0?oo
ooooc03oo`3oI_oo09Wo<`3ooonI0?o<o`3o0?oooc?o0?l0ofKooiT0ool0VOoooooo06Kooooooolc
0?l00_ooV@000olco`3ooiT0o`3oIP02oc?o0004o`3oI_ooooooooooo`3oIPKooooo00So<ol0olco
0?lco`3o0?mVoonI0?l0ofKooooooc<0o`?ooooo00CooiT0oooooolco`3oc?l00oooool02_o<0?oo
<ol0oonI0?ooooooc03oool0VOl0ofKo0?oooonI0?lco`02ooooo`0<olco0?oooooo0?oooooooolc
o`3oooooo`1Voooooooo0?oooc?o0?oooooo<ol00_ooool04_ooV@3ooooooooooooooooooiT0oc?o
0?o<o`3o<ol0ooooool0I_oo0?ooolco0?oo09WooiT0oc<0ool0ooooooooo`3oIP;ooooo00So0?mV
oooooooooooo<ol0oonI0?l0ofKooooooc?o00;ooooo00[o0?mVooooool0ofKoo`00ooooool0I_oo
c?l0ooooooo<o`3o0?oo0_ooool02?l0I_ooooooo`3oooo<0?ooo`00oc?o0?o<o`3o0?mV0_ooool0
8Oo<o`3oo`2Iooooooooooooo`2Io`3oI_ooV@3oc?l0ooooooo<o`3oc03oool00?o<0?oo0?ooolco
0?lco`3oc?l0oooooooo09Wo<`3ooonI0?l0I_oooiT0ooooool0ofKooiT0oooooooo003oc03ooooo
ool0ooooc?l0oc?o0002ooooo`09ool00?l0ofKo0?ooo`3oI_ooooooc?l0ool0VOooooooc?l000;o
oooo00Soc03ooooooolco`3oooooo`3ooooooooo<`3oo`3oIP;ooooo00?ooiT0ooooooo<o`001Ooo
ool01?ooV@3oc03ooooooooo09T2olco0009oonI0?ooooooooooool00?l0ooooooooolco0?l0oooo
<`3o00;ooooo00?oo`2Iooooooo<0?l00_ooool00oooV@3o<ol0ooooo`05ooooo`03o`000?oooooo
oooo00;ooooo000@ooooo`;o00001?ooool02Olco`3oo`2Ioooooooo003ooooooc<0ooo<o`3o0?oo
o`1Vo`04ooooo`0Jool0VOooooooooooooooool0I_oo0?mVo`1VooooV@3o06Koool0VOl0ooooc03o
o`3ooolco`3oo`2Iol`0ool0oooo<ol0ol`0oooooooo0?mVool0VOlc0?ooc?l0oonI0?l0ool2oc?o
0006oonI0?oo09Woooooo`1Voooooooo<`3o0_ooool01_lco`3ooiT0olco0?lco`3ooooooc?o00;o
oooo00?o0?mVooooooooool01?ooool02?lco`3ooiT0oc?o0?oo09WooiT0o`3oI_oooooo<`3o0ooo
ool01?ooV@3o<ol0ooooooo<o`03ooooo`07ol`0oolco`3ooiT0ooooooo<0?ooooooo`3oIP02o`3o
o`0BoonI0?ooooooooooolco0?oooooo0?oool`0oolco`3oooooo`1Voooooooo0?oooc?o0?oooooo
0?mVoc?o0?oooooooiT00oooool03_ooV@3o<ol0olco0?lco`3oooooo`3oooooooooc?l0oonI0?oo
oooo<`3oo`3ooooooooo0?mV0_ooool02?l0ofKooooooc?o0?lco`3ooiT0o`3oI_oooooo<ol00_oo
ool01_l0ofKoooooo`3oI_oo003oooooolco00;ooooo013ooiT0ooooooooooooooooo`1Voooooooo
0?ooooooooo<0?oo<ol0o`1Voooooooo0?mVooooooo<o`3oo`2I0_ooool07?o<o`3o0?mVoonI0?o<
o`3oooooolco0?o<0?ooo`00ol`0ooo<o`3o0?mVoc?o0?o<0?ooc?l0ool0VOlc0?oooiT0o`1Voooo
V@3oooooo`3oI_ooV@3oc?l0ool00?o<0?ooooooool0VOo<o`03ooooo`09o`3oI_oooooo0?ooo`3o
I_ooooooc?l0oonI0?ooooooc?l000;ooooo00Soc03oo`3oI_lco`3oooooo`1Vool0oooo<`3oo`3o
IP;ooooo00CooiT0ooooooo<o`3o0?oo1?ooool03oooV@3oc03oool00?lc0?ooc?l0oc?o0?ooV@3o
06Koooooool0ooooo`2Iooooooo<o`3oo`2Io`3oo`02ooooo`03ool0VOooooooc03o00;ooooo00?o
oiT0o`3oooo<0?l01?ooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00?ooooo00So<ol0
ool0VOooooooo`00oooooolc0?ooc?l0o`3oo`Gooooo01[oo`2Iooooooooooooooooo`1Voolco`3o
0?mVoonI0?oooooo06Koo`3oooo<0?oo<ol0o`3ooolc0?ooo`00o`3ooolco`3oc03oooooool0ofKo
oooooc<0ooo<o`3ooiT0o`3oo`;o<ol000KooiT0o`3oooooooooooooo`1Voolc0?l2ooooo`08oc?o
0?ooV@3oc?l0o`3ooooooooo<ol0ooooool0ofH6ooooo`09oc?o0?o<o`3ooiT0oc?o0?oo09WooiT0
o`3oI_oooooo<`3o00Cooooo00CooiT0ooooooo<o`3oo`2I0oooool01_lco`3ooiT0ool00?o<0?oo
ooooo`3oIP;o0?oo01;ooiT0ooooooooooooc?l0ooooool0ooooc03ooc?o0?oooooo06Koooooool0
oooo<ol0ool00?l0ofKo<ol0ooooooooV@03ooooo`0>oonI0?lco`3oc?l0oc?o0?oooooo0?oooooo
ooo<o`3ooiT0oooooolc0?oo0?ooo`3oI_l0I_l2ooooo`08ool0VOl0ofKo<ol0oooooolco`3ooiT0
oooooolco`02ooooo`06o`3oI_o<0?oo0?mVool00?ooooooc?l00_ooool04?ooV@3ooooooooooooo
oooo06Koooooool0oooooooool`0oolco`3o06Koooooool0ofKoooooolco0?lc0?l2ooooo`06olco
0?l0ofKooiT0olco0?oo09Woc?l00_oo09T02oo<0?ooc?l0o`3oI_lco`3oc03oolco0?oo09Wo0?mV
oonI0?lco`3ooiT000;ooooo00SooiT0olco0?oo003oc03oooooooo<o`3o<ol0o`3oIP;ooooo00So
0?mVooooool0oooo0?mVooooooo<o`3ooiT0ooooo`;oc?l000oooooool`0ool0ofKo<ol0ooooool0
I_oo0?oooc<0ool0ofKoooooo`3oooooV@3oooooolco0?l0ool01?ooool02?lco`3ooiT0ool00?lc
0?oooooooc?o0?ooV@3o06Ko0_l0ool01Ooo09Wo0?mVolco0?oooooo0?oo00;ooooo00?oo`2Iol`0
ooooool00_ooool00oooV@3o0?oool`0o`05ooooo`03o`000?oooooooooo00;ooooo0009ooooo`;o
00001Oooool00ol0003oooooooooo`03ooooo`09oc?o0?oo09Woooooool00?oooooo<`3ool`0ooo<
o`3ooooo00;oo`000_ooool00ooo09Woooooooooo`02ooooo`0=oc?o0?l0ofKooiT0ooooool0I_oo
0?ooool0VOlco`3o0?oooc<0oooo09Wo0?oooc?o0002ooooo`06o`3oI_oooooo<`3oolco0?ooV@3o
0?oo0_lco`001_ooV@3o0?oooooooooooooo06Kooc<0o`;ooooo00So<ol0oonI0?o<o`3o0?oooooo
ooo<0?oo<ol0o`3oIPKooooo00Wo<ol0olco0?ooV@3o<ol0o`1VooooV@3o0?mVol`0oolc0?l01?oo
ool01?ooV@3oooooolco0?oo09T3ooooo`09oc?o0?ooV@3oo`00ol`0oooooooo0?mVoooooolc0?oo
oiT000;ooooo00[oc?l0o`3oooooooooc03ooooooolco`3o06Koooooool0oooo<ol00_ooool00olc
o`3ooooooonI0003ooooo`0>oonI0?lco`3oc?l0oc?o0?oooooo0?ooooooooo<o`3ooiT0oooooolc
0?ooooooo`3oI_oo0002ooooo`08o`3oool0ofKo<ol0oooooolco`3ooiT0oooooolco`02ooooo`06
o`3oool0ofKo0?mVooooooo<o`3o06Ko0_ooool01OooV@3ooooooooooooooooo06Ko00;ooooo00Oo
0?oool`0oolco`3oo`2Io`1Vool0ofKooooo00;ooiT001Co<`3oooooooo<o`3o0?mVoonI0?o<o`3o
o`2Iol`0ooo<o`3o06Kool`0ooo<o`3ooooooc?o0?ooooooc?l0ool0VOl0ofKooooooonI00?ooooo
00SooiT0olco0?oo003ooooool`0ooo<o`3o<ol0o`3oIP;ooooo00Ko0?mVooooool0ooooooooo`3o
I_o<o`02oonI000Aooooooo<o`3ooooool`0ool0ofKo<ol0ool00?l0I_oo0?oooc<0oooooooo0?mV
o`3oooooV@3oooooolco0?l0ool01?ooool03olco`3ooiT0ool00?lc0?oooooooc?o0?ooV@3o0?oo
o`1Voolc0?ooo`2Io`3oI_o<o`3oooooo`3oo`03ooooo`06ol`0oooooooooooooooooolco`3ooiT0
1_ooool00ol0003oooooooooo`02ooooo`002?ooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooooooo00?ooooo00_o<ol0ool0VOooooooooooool00?lc0?ooc03oolco0?oo003oooooool0
0002ooooo`03ool0VOoooooooooo00;ooooo01Wo<ol0o`3oI_ooV@3oooooo`3oooo<0?oooooooc?o
0?l0oooo<`3oool0VOl0oooooooooc?o0?oooooo0?mVoooooolc0?ooc?l0ooooooooV@3ooooooc?o
0?ooV@3o0?oo00;ooooo00So06Kooc<0oooooooooooooc?o0?ooV@3oc?l0o`3oo`;ooooo00?o<ol0
o`3oI_ooool01?ooool00olc0?oo<ol0olco0003oonI0003ool0VOoooooo0?mV00Gooooo00CooiT0
ooooooo<o`3o0?oo0oooool02Olco`3ooiT0ooooooo<0?ooooooo`3oI_oooooo<`3ooonI0002oooo
o`0:olco0?l0oooooooool`0oooooooo<ol0o`1Voooooooo0?oooc?o00;ooooo00Co0?mVoc?o0?oo
V@3oo`000_ooool02_ooV@3o<ol0ooooooo<o`3oooooo`3oool0I_ooc?l0oonI0?lc0?l2ooooo`06
o`3oI_l0oooo0?ooo`3ooooo09Wo<ol00_ooool01?lco`3ooiT0ool00?lco`02ooooo`0:o`3oooo<
o`3oc?l0ooooooo<o`3o06KoooooooooV@3ooooooonI00;ooooo00ko06Kooooooooooooo0?ooo`1V
oolco`3oo`2Io`1VoooooooooiT0olco0?ooV@3ooooooc<0o`;oc?l0013ooiT0olco0?ooooooc03o
olco0?l0I_ooc03oolco0?lco`3o0?mVooooooo<o`3oooooo`3oI_lc0?oooiT00oooool01_ooV@3o
c?l0ool00?ooooooc03oolco00;o0?mV00[oooooo`3oI_oo003o<`3oo`3ooooo003o0?mVoonI0?oo
oooooiT00_ooool03oo<o`3oc03oo`3oI_oooooo<ol0o`1Vool0oooo<`3oooooool0ofKo0?oooonI
0?ooooooc?l0o`3oo`04ooooo`0?oc?o0?ooV@3oc03ooc<0oooooooo<ol0oonI0?oooooo06Kooc<0
ool0ofKoooooolco0?oooooo0?oo00;ooooo00?oc03oool0VOooool00_ooool00olco`3ooiT0oooo
o`05ooooo`03o`000?oooooooooo00;ooooo0008ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool00oooool02?lco`3oo`2Iooooooooooooo`00oc<0ool0I_ooc?l00_ooool01?oo
003ooooooooooooo09T4ooooo`0Hoc?o0?l0ofKooiT0ooooool0oooo06Kooooooolco`3o0?oooc<0
oooo09Wo0?oooooooolco`3oooooo`3oI_oooooo<`3oolco0?oooooooiT0o`3oooooV@3o0?mV0_l0
ool03?oooooo06Kooc<0ooo<0?oooooooc?o0?ooV@3oc?l0ool0VOl0oooooooooc?o00Kooooo00Co
<ol0ooooooooV@3o0?oo0_ooV@000ooo09Wo06Koo`3oIP05ooooo`0@oonI0?ooooooooooolco0?oo
09Woooooo`1VoooooooooiT0ooooooo<0?ooooooo`3oI_oooooo<ol0oonI00;ooooo00Koc?l0o`3o
ooooooooc03ooooooolco`02ooooo`08oc?o0?l0ooooooooooooool0ofKooiT0oooooooo0002oooo
o`04oonI0?lco`3o0?ooolco00;o0?oo00Co06Koolco0?ooV@3o<`3o0_ooool01_l0ofKoo`00oooo
ooooooooo`2Ioc?o00;ooooo00Co<ol0o`1VooooV@3o<ol00_ooool02_l0ooooc?l0ooooooooV@3o
o`00o`1VoooooooooiT0ooooooooV@02ooooo`0co`1Vooooooooooooo`3oool0I_oo<ol0ool0VOl0
I_oooooooonI0?o<o`3o<`3ooonI0?o<o`3o<`3oolco0?ooV@3oo`2Iooooooo<0?ooc?l0o`1Vooo<
o`3ooooooc?o0?l0ofKoooooolco0?oooooo0?mVoc<0ooooV@3o06Kooooooolco`3o0?mVoonI0?oo
003ooooool`0ooo<o`3o0?ooo`3oI_oooooo0?mVool00?lc0?oo0?ooool00?l0ofKooiT000;oc?l0
017ooiT0ooooooo<o`3oc03oo`3oI_oooooo<ol0o`1Vool0oooo<`3oooooool0ofKo0?oooonI0?oo
ooooc?l0o`3oo`04ooooo`0Coc?o0?ooV@3oc03ooc<0oooooooooiT0o`3ooooooooo06Kooc<0ool0
ofKoo`2Iolco0?oooooo<`3oo`3oooooooooc03oool0V@03ooooo`03oc?o0?ooV@3ooooo00Gooooo
00?o0000ooooooooool00_ooool000Sooooo00Co0000oooooooooooo00001?ooool3o`0000Cooooo
00Oo<ol0ooooool0I_oooooooc<0ool0I_ooc?l000;ooooo00Coo`00ooooooooooooo`2I1?ooool0
4olco`3o0?mVoonI0?oooooo0?ooo`1Voooooooo<ol0o`3ooooooooo<`3oo`3ooooooooo<ol0olco
0?l0ofKooooooc<0ooo<o`000_ooool2oonI000@o`3oI_oo09Wo0?ooooooool0I_oo<`3ool`0oooo
ooooo`00oonI0?o<o`3oo`2Io`3ooooooooo0?mVoc?o00Gooooo00Co<ol0ooooooooV@3o0?oo0_oo
V@001Ooo09Wo06Koo`3oI_ooooooo`0000?ooooo01SooiT0oooooooooooooiT0ool0VOoooooo06Ko
ooooooooV@3oo`2Iol`0oooooooo0?mVoooooolco`3o0?oooonI0?ooooooc?l0o`3oool0I_ooc03o
o`1Voolco`02ooooo`08oc?o0?l0ooooooooooooool0ofKooiT0oooooolc0?l2ooooo`06oonI0?lc
o`3o0?ooolco0?oooooo0?oo0_o<o`001_ooV@3o<`3ooooooooooooo0?mVool000?ooooo01?o<ol0
o`3oI_oooooo<ol0o`1VooooV@3o<ol0ooooool0ooooooooolco0?oooooooiT0ool00?l0I_oooooo
oonI0?oooooooiT000;ooooo02Ko06Kooooooooooooo0?ooo`1Voolco`3oooooo`1VoooooooooiT0
olco0?lc0?oooiT0olco0?oooooooiT0olco0?oo09Wooooool`0ooo<o`3o06Koolco0?o<0?oo<ol0
o`3oI_ooooooc?l0o`3oI_oooooo<`3ooc?o0?l0I_oooooooc?o0?o<o`3ooiT0olco00;ooooo00_o
c?l0o`3oool0ofKoooooo`3oI_oo003o06Koo`3ooooo003o0?mVoonI0002olco000AoonI0?oooooo
ooooolco0?l0ofKoooooool00?lco`3o0?oooc<0oooooooo0?mVo`3oooooV@3o06Koolco0?l0ool0
1?ooool04Olco`3oo`00oonI0?lc0?oooooooonI0?l0oooooooooc<0ool0I_oo0?mVool0VOo<o`3o
oooooc<0ool0ooooc03o00;ooooo00Goo`2Ioooooooooooo<ol0oonI0004ooooo`?o00001?ooool0
00Sooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`03ool0VOlco`3o
oooo00;o06Ko00Co<`3oo`1Vool0ooooc?l00_ooool00ooo003oooooool0V@04ooooo`;o<ol000go
oiT0ooooool0oooo06Kooooooolco`3o0?oooooooolc0?oo0?oooooooolco`3oc?l000;ooooo00Co
<ol0olco0?oooooooooo0_ooV@000ol0ofKoooooo`3oo`02ooooo`0;o`1Vooo<0?ooo`00oooooolc
o`3ooiT0ooooool0ooooo`2Iolco0?lco`001Oooool01?lco`3oo`00oonI0?ooool2oonI0005o`1V
oooo09Wo0?mVoooooooo00000_ooool05?lco`3ooiT0oooooooooooooiT0ool0VOoooooo06KooonI
0?lco`3oo`2Iol`0oooooooo0?mVoooooolco`3o0?oooonI0?ooooooc?l00_ooool01?l0I_oooooo
oc?o0?ooool2oc?o0007o`3oooooooooooooo`3oI_ooV@3ooooooc<0o`02ooooo`06oonI0?oooooo
0?ooolco0?ooooooc03o0_o<o`001_ooV@3o<`3ooooooooooooo0?mVool000?ooooo00co<ol0o`3o
I_l0ofKo<ol0o`1VooooV@3o<ol0ooooool0ooooo`00olco0?ooool2oonI0005ool00?oooooooiT0
ool00?ooV@000oooool01Ol0I_ooooooo`3ooooooooo<ol000;o0?oo00WooiT0o`3oI_o<o`3o<`3o
ooooooooV@3ooooooonI0?o<o`000_ooool04oo<0?ooc?l0o`1Vooo<o`3oc03ooc?o0?l0ofKooooo
olco0?l0ofKooooooc<0oolco`3o06Kooooooolco`3oc?l0oonI0?o<o`000_ooool01Oo<o`3o0?oo
ooooool0ofKoo`0000;o06Ko01Oo0?ooool00?l0ofKooiT0olco0?oooooooiT0ooooooo<0?ooc?l0
o`3oI_ooooooo`00oc?o0?l0oooo<`3oool0VOl0ofKo<ol0oonI0?l0I_ooc?l0o`3oo`03ooooo`0B
oc?o0?ooooooo`00ol`0ooooV@3ooooooonI0?l0oooooooooc<0ool0ofKo<`3oool0VOooooooc?l0
oc<0ool0ooooc03o0_ooool01Olco`3ooooooooooolco`3ooiT000Kooooo00?o0000ooooooooool0
0_ooool000Sooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`09ool0
VOlco`3oooooo`1Voooooooo06Kool`0ooooooooc?l000;ooooo00Coo`00ooooooooooooo`2I0_oo
ool03_lco`3oo`2Ioc?o0?ooV@3oo`2Io`3oool0I_oooooooc?o0?l0oooooooooc<0ool0oooooooo
0_o<o`02ooooo`07oc?o0?o<o`3oooooooooool0oooooiT0o`3oIP02ooooo`03o`3ooooooooo06Ko
00;oc03o00Wo06Kooc?o0?ooV@3oooooo`3oooooooooc?l0oc?o0?o<0?l00oooool01?lc0?oo<ol0
olco0?ooV@02ooooo`04oonI0?l0I_ooc03oo`3oIP;oo`000_ooool05Olco`3ooiT0oooooooo09Wo
oiT0ooooool0I_oooooooonI0?lco`3oo`2Iol`0oooooooo0?mVoooooolco`3ooooooonI0?o<o`3o
0?oooc<0o`02ooooo`06ol`0oolco`3o<ol0oooooolc0?oo0?oo0_ooool01?l0ofKooiT0oooooolc
0?l2ooooo`0MoonI0?oooooo0?ooolco0?oo003oc03oolco0?oo003ooiT0oc<0oooooooo0?mVo`1V
ooooooooo`00oooooolco`3oo`2Io`3oool0ofKooooooc?o0?ooV@3o<ol0ooooool0ooooc?l0oc<0
ooooool00_ooV@001Ooo003oo`2IoonI0?oo003ooiT000?ooooo03?o06Koooooool0oooooooooc?o
0?l0ooooo`2IoonI0?l0ofKoc?l0oc<0oooooooooiT0o`3oI_ooV@3oc?l0ooooooo<0?ooooooolco
0?ooooooc?l0ol`0oolco`3o0?mVooooooo<o`3o0?mVoooooolc0?ooc?l0o`1Voooooooo<ol0olco
0?ooV@3oc?l0ooooooo<o`3o0?mVo`3ooooooooo0?mVo`1Voooooooo<`3oo`3ooooo003ooooooonI
0?o<o`000_ooool01oooV@3oc03oolco0?l0ofKoooooool00?l0I_l00_lco`001ooo09Wo<ol0oonI
0?lco`3oc?l0ooooool0ool00oooool01?lco`3oooooo`3oI_ooool2oonI0006oc?o0?l0oooooooo
oc<0ool0ofKo<`3o0_ooool01?o<o`3oo`00o`3oooo<0?l2ooooo`05oc?o0?oooooo<ol0o`3ooooo
V@001_ooool00ol0003oooooooooo`02ooooo`002Oooool2o`0000Gooooo00?o0000ooooooooool0
0oooool02Ooo09Wo<ol0ooooool0I_oooooooc<0ooo<0?ooooooolco0002ooooo`04ool00?oooooo
ooooool0V@;ooooo01Co<ol0ool0VOlco`3ooiT0ool0VOl0oooo06Kooc?o0?lc0?oo0?ooooooool0
ooooo`2Iooooooo<o`3o0?mVolco0?lc0?oo<ol0olco00;ooooo00?o0?ooo`1Vool0ofH00_ooool0
2_l0ooooooooo`1Vool0ofKo06Kooooooolco`3ooiT0ooooool0ool2olco0003oc?o0?o<0?oooooo
00;ooooo00Co<ol0ooooooo<o`3ooiT00_ooool01?ooV@3o06Kool`0ool0ofH2ooooo`05ool00?oo
oooo<ol0oonI0?ooool00_ooV@006?oooooo06KoooooooooV@3o<ol0ool0VOo<0?ooooooo`3oI_oo
oooo<ol0ooooooooV@3oc?l0o`1Voooooooo<`3oooooooo<0?ooo`2Ioooooolc0?ooo`2Io`3oo`;o
oooo02Go0?mVoonI0?lco`3oc03ooc<0oooooooo<ol0oonI0?ooooooc?l0ool0VOo<0?ooc?l0ool0
0?ooV@3o<`3oooooool0ofKo06Kooooooooo003ooooooc?o0?oo09Wo0?oool`0oooooooo<ol0oonI
0?lco`3oooooo`3oooo<o`3o<`3oooooooooV@3o06Ko00;ooiT00_oo00001?l0ofKooiT0oooooooo
ool2o`1Vo`0:o`3ooooooooo<ol0o`3ooooo09WooiT0o`3oI_o<o`3o<`3oooooo`;ooiT002Cooooo
o`1Vooo<0?ooc03oool00?o<o`3oooooolco0?o<0?oo<ol0o`3oI_oooooo0?mVolco0?ooooooc03o
olco0?lco`3o06Kooc?o0?o<o`3ooiT0olco0?ooooooc?l0o`3oI_l0oooooooooonI0?oo003ooooo
oc<0ool0oooooooooonI0?l0ofH3ooooo`0@oonI0?o<0?ooooooolco0?ooooooo`00o`1Voooooooo
0?oooc?o0?l0ofKooiT0oc?o0?o<o`3oooooo`3oo`?ooooo00co<ol0ooooool0ofKooooooc<0oooo
V@3o<ol0oooooolc0?oo0?mVo`1Voolc0?l2ooooo`07olco0?oo003o0?oool`0oooooooo<ol0ool0
V@02oc?o0003o`3oooooV@3ooooo00Gooooo00?o0000ooooooooool00_ooool0013ooooo0_l00004
ooooo`04ool0VOlco`3oooooo`1Vo`;ooooo00?o<`3oooooooo<o`000_l0ool01?oo003ooooooooo
oooo09T2ooooo`0Doc?o0?oo09Wo<ol0oonI0?oo09Wo0?oooc?o0?l0I_oo<`3oo`3ooooooooo0?oo
oooooooo09Woc?l0o`3oI_o<o`3o<`3ooc?o0?o<o`02ooooo`03o`3oool0I_oo0?mV00;ooooo00[o
0?oooooooolc0?oo0?mVol`0oooooooo<ol0oonI0?o<o`3ooooo0_o<o`002Olco`3oc03ooooooooo
ooooo`00oc?o0?oo003ooiT0o`3oo`02ooooo`0Loc?o0?ooooooo`2Io`3oI_l0I_ooooooool00?oo
oooo<ol0oonI0?oooooooiT0olco0?ooV@3o06KoooooooooV@3o<ol0o`1Vooo<0?oo0?mVo`3ooolc
o`3ooooooc<0ooooV@3oc?l0o`1Vo`;ooooo00Oo<`3ool`0oooo09Woo`2Ioc<0oooo09Wo0?oo00;o
oooo02Goo`2IoonI0?lco`3ooooooc<0oooooooo<ol0oonI0?ooooooo`2Iolco0?oo09Woc?l0oooo
ooooV@3o<`3oooooool0ofKo<ol0oooooooo003ooooooc?o0?oo09Woooooo`3ooooooooo<ol0oonI
0?lco`3oo`2Io`3oooo<o`3o<`3ooonI0?lc0?oo06Ko00;ooiT00_oo00001?oooooooiT0oooooooo
ool2o`1Vo`0Go`3ooooooooo<ol0oooooooo09WooiT0ooooooo<o`3oo`00ooooooo<o`3ooiT0oooo
ool0I_oooooool`0oooo003o06Koolco0?l0ooooo`2Ioc?o0?ooool00_l0ofH05oo<o`3oooooolco
0?o<o`3o<ol0o`1Voolco`3oc?l0oonI0?o<o`3oo`00olco0?l0ofKo0?ooooooooooV@3oo`00oc<0
oooooooo0?ooooooooooV@3o0?mV00?ooooo00GooiT0ol`0ooooooooc?l0ool00002ooooo`07o`1V
ool0oooo<`3oo`3oI_ooV@3oooooolco0002ool0V@05o`3ooooooooo<ol0oc?o0?ooool00_l0ofH0
2?lc0?oooooooc?o0?oooooo<`3oo`3oI_l0I_oo<`3o0_ooool01oo<o`3oooooo`3oooo<0?oooooo
oc?o0?ooool00_lco`000ol0oooooiT0o`3oIP04ooooo`;o00001?ooool0013ooooo00?o0000oooo
ooooool00oooool00ooo09Wo<ol0o`1Vo`03ooooo`06oc<0ooo<0?ooc?l0ooooool0ooooo`000_oo
ool07?oo09Wooooooooooolco`3oo`2Ioc?o0?ooV@3o0?oooc?o0?o<0?oo06Kooc<0ool0oooooooo
o`3oooooooooc?l0oc?o0?ooooooc?l0oc<0oolco`3oc?l0ool0VOoooooo0?ooo`1Vool0ofH3oooo
o`07o`3ooolc0?oo0?mVo`3oI_l0oooo<ol0oonI0002olco0004o`3oooo<o`3ooooooc?o00;ooooo
00Goo`00oc?o0?oo003ooiT0o`3oo`02ooooo`0Loc?o0?ooooooo`2Io`3oI_l0I_ooooooool00?oo
oooo<ol0oonI0?l0I_oooiT0olco0?ooV@3o06KoooooooooV@3o<ol0o`1Voooooooo0?mVo`3ooolc
o`3ooooooc<0ooooV@3oc?l0o`1Vo`;ooooo00Oo<`3ool`0oooo09Wooooooc<0oooo09Wo0?oo00;o
oooo01Woo`2IoonI0?lco`3ooooooc<0oooooooo<ol0oonI0?ooooooo`2Iolco0?ooooooc?l0oooo
ooooV@3o<`3oooooool0ofKo<ol0oooooooo003o<ol0oooooooo09Wooooo00;o0?oo0_lco`004?oo
V@3oo`2Io`3oooo<o`3ooooooonI0?oooooo06KoooooooooV@3oo`00oooooooo003ooiT0oc<0oooo
ool2o`1Vo`0=o`3ooooo09Wo<ol0ol`0oooooooooiT0ooooooo<o`3oo`00olco0?oooooo0?mVoooo
o`02o`1Vo`08ooooool0I_ooooooolco0?l0ooooo`2Ioc?o0?ooool2o`3oIP;oc?l000goooooolco
0?lco`3o06Kooc?o0?o<o`3ooiT0olco0?oo003oc?l0o`3oI_l0oooooooo00;ooiT000Ko<`3ooooo
ool0oooooooooonI0?l0ofH3ooooo`05oonI0?o<0?ooooooolco0?oo00000_ooool02ol0I_oo0?oo
oc<0ool0oooooiT0ooooooo<o`3oo`2Iooooool0oooo<ol000?ooooo0_l0ofH02?lc0?oooooooc?o
0?lc0?oo0?mVooooool0I_oo<`3o0_ooool03?o<o`3oooooo`3oooo<0?oooooooc?o0?ooooooo`2I
oc?o0?oooooooiT0o`3oIPGooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000oooooooo
ool01?ooool00olco`3o06Koooooo`02ooooo`06oc<0ooo<0?ooooooolco0?oooooo0?oo0_ooool0
6?oo09Woooooool0VOlco`3oc03ooc?o0?ooV@3o0?oooc?o0?o<0?oo06Koooooool0ooooooooo`3o
oolc0?ooc?l0oc?o0?ooooooc?l0oc<0oolco`3oc?l0ool0V@;ooooo00?o0?ooo`3oI_ooool00_oo
ool01ol0oooo<`3oo`3oI_l0ofKo0?ooo`3oI_ooV@000_o<o`000ol0ooooo`00olco0002oc?o0005
oooooooo003o<ol0ool0VOooV@000oooool02_lco`3oooooooooool0ofKo06Kooooooooo003ooooo
oc?o0?ooool2oonI000@olco0?ooV@3oo`00ool0VOooV@3o<ol0o`3oI_oooooo0?mVo`3ooolco`3o
oooooc<0ooooV@3oc?l0o`1Vo`;ooooo00So<`3ool`0oooooooooooooc<0oooooooo<`3oo`3oo`;o
c03o017ooiT0oc?o0?oooooo<`3ooc?o0?oooooooiT0oc<0ooooooooc?l0ooooooo<o`3ooiT0olco
0?lc0?oo0?mVo`1Vo`02oc?o0007ool00?lco`3oooooool0VOo<0?oooooool`0o`02oc?o000:oonI
0?oo09Wo0?ooolco0?oooooooiT0ooooool0I_oooooooc<0o`;ooooo01?oo`00oonI0?lc0?ooo`2I
o`1Vooooooooo`2Io`3oI_lco`3oc03ooonI0?l0I_ooooooolco0?oo003oc?l0ooooool0ofKooooo
00;o06Ko01Woooooo`1Vooooooooc?l0o`3ooooo09Wo<ol0ooooool0ofKoc03oolco0?o<0?oooooo
olco0?lco`3o06Kooc?o0?o<o`3ooiT0olco0?oo003oc?l0o`3oI_o<0?oo0?oo00;ooiT000Ko<`3o
ooooool0oooooooooonI0?l0ofH4ooooo`0=oonI0?ooooooc?l0ool00?ooooooo`2Io`1Vool0oooo
<`3oo`3oooooV@3oooooolco0002ooooo`0<oc?o0?oo09Woooooooooool0ofKoooooool0VOl0ofKo
c03ooc?o0?lc0?oo0?mV0_ooool02?l0I_oooooooc<0ooo<o`3oooooool00?l0oooo<ol00_ooool0
1Ooo09Wo0?ooooooooooV@3o0?mV00Gooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000
ooooooooool01?ooool00olco`3o06Koooooo`02ooooo`06oc<0ooo<0?ooooooolco0?oooooo0?oo
0_ooool06?oo09Woooooool0VOlco`3oc03ooc?o0?ooV@3o0?oooc?o0?o<0?oo06Koooooool0oooo
o`00o`3oool0ofKoc?l0oc?o0?ooooooc?l0oc<0oolco`3oc?l0ool0V@;ooooo00?o0?oool`0ool0
ofH00_ooool01?l0oooo<`3oo`3oI_l0ool2o`3oIP08oonI0?o<o`3oooooo`3ooooo003oc?l0oooo
ooo<0?l2oonI0003oooooooo09WooiT000;ooooo00_oc03ooc?o0?ooooooooooo`3oI_oooooo06Ko
ool00?oo09Wo<ol0o`1Vo`02oonI000?olco0?ooV@3oooooool0VOooV@3o<ol0o`3oI_oooooo0?mV
o`3ooolco`3ooooooc<0ooooV@3oc?l000?ooooo01_o<`3ool`0ooooV@3ooooooc<0ooooooooo`2I
o`3oooooooooo`2IoonI0?lco`3ooooooc<0oolco`3ooooooonI0?lc0?ooooooolco0?ooooooc?l0
oonI0?o<o`3oooooo`3oI_l0I_l00_lco`001ooo003o<ol0oooooooo09Woc03oooooooo<0?l00_lc
o`000oooV@3o0?ooolco0002ooooo`09oonI0?oooooo06Koool0VOlc0?ooo`2Ioooooooo003ooiT0
00;o<`3o0_ooool02?oo003o0?mVoc?o0?o<0?oooiT0o`1Voooooooo0?mV0_o<o`000ooooooo0?mV
ooooo`02o`1Vo`0Iooooool0I_ooooooooooool0oooo<ol0o`1Voooooooo0?mVol`0ooooooooc03o
oooooolc0?ooc?l0o`1Voolco`3oc?l0oonI0?o<o`3oo`00olco0?l0ofKoo`2Io`3oo`02oonI0007
oc<0oooooooo0?ooooooooooV@3oo`00o`3oIP03ooooo`0=oonI0?l0ofKoc?l0ool0VOooooooo`2I
o`1Vool0oooo<`3ooonI0?l0ofKoooooolco0002ooooo`0<oc?o0?ooooooo`2Iooooool0ofKooooo
oc<0ool0ofKoc03ooc?o0?l0ofKo<`3o0_ooool02?l0I_oooooooc<0ooo<o`3ooooool`0ool0oooo
<ol00_ooool01Ooo09Wo0?oooooooooo003ooiT000Gooooo00?o0000ooooooooool00_ooool0013o
oooo00?o0000ooooooooool01?ooool00olco`3o06Koooooo`02ooooo`04oc<0ooo<0?ooooooolco
00;ooooo01Co0?oool`0oooo09Woooooool0VOlco`3oc03ooc?o0?ooV@3o<ol0ol`0oooooooo06Ko
ooooool0ooooo`00o`3oI_o<o`3ooooooc?o00;ooooo0_o<o`001oooooooo`2Ioooooooooooo0?oo
ol`0ool0ofH00oooool00ol0ofKoooooo`3oo`02o`3oIP0=oonI0?ooooooooooo`3ooooo003oc?l0
ooooooooV@3oo`00oonI0?ooooooc?l0oonI0002ooooo`0?ol`0oolco`3oooooooooool0ofKooooo
o`1Voooooooo<ol0ooooool0I_oooiT0o`1VoooooooooiT000;ooooo00_ooiT0o`3oI_lco`3ooooo
o`3oI_l0oooo<ol0oooooolc0?oooiT0olco0003ooooo`0<oc<0ooo<0?oooiT0oooooolc0?oooooo
ool0VOl0oooooooooonI0?l0ofKo<ol00_ooool05_lco`3ooooooonI0?lc0?ooooooolco0?oooooo
c?l0oonI0?o<o`3oooooo`3oI_lco`3ooooooc?o0?o<0?oo<ol0oooooooo09Woc03oooooooo<0?l2
oc?o000JoonI0?l0ooooc?l0ooooool0I_oooiT0o`1Vooooooooo`2Ioc<0oooo09Woooooool00?l0
ofKooiT0oc<0ooooooooo`00ooooool0ofKo<ol0ooooooooV@3oo`2Io`1Vool0ofH2olco0007o`3o
I_oooooo06Koooooool0I_ooooooo`1Vo`02ooooo`06o`3ooolco`3o06Kooooooooo09Wooooo0_o<
0?l2ooooo`06olco0?ooooooc?l0ooooool0ofKooiT00_o<o`02ooooo`0:oonI0?ooooooo`00oonI
0?oooooo0?oooonI0?oo09Woo`00o`3oIP?ooooo00gooiT0o`3oI_ooooooc?l0oooooooo09Wo06Ko
o`3ooolc0?oooiT0o`3oI_ooooooc?l000;ooooo00_o<ol0ooooooooooooo`2Io`3oI_oooooo<`3o
ooooool0ofKo0?oooc?o0003ooooo`08o`1Voolc0?oo<`3oolco0?ooooooc03oo`3ooolco`02oooo
o`05ool0VOl0ooooooooool00?ooV@001Oooool00ol0003oooooooooo`02ooooo`004?ooool2o`00
00Kooooo00So<ol0oooooooooooooooooc<0ooo<0?ooooooolco00;ooooo00?o0?oool`0ooooool0
0_oo09T04Olco`3oc03ooonI0?l0ofKo<ol0ol`0oooooooo<`3oo`1Voooooooo0?mVo`3oooo<o`3o
oooooc?o0?oooooo<`3o00;oc?l000Ooooooool0VOooooooooooo`1Vooo<0?oo0?mV00?ooooo00oo
0?mVo`3oooooooooc03oo`3oI_ooV@3ooooooc<0oooooooo0?ooolco0?ooV@3oc03oool00?lc0?l0
0_ooV@002?l0oooo<`3oooooooo<0?oooooooc?o0?lc0?oo0?mV0_ooool03Ol0I_oo<ol0o`1Voooo
oooooiT0o`1Vooooooooc?l0oonI0?oooooooiT0oooooolco`000_l0ofH01_l0oooo<ol0oooooolc
0?oooooooonI00?ooooo01?o<`3ooonI0?ooV@3ooooooc<0ooooooooo`2Io`3ooolc0?oooiT0o`3o
I_lco`3oo`2Ioc?o0?lc0?ooo`00oonI0?lc0?oooooo00;oc?l000Koo`2IoonI0?o<o`3oooooo`3o
I_lco`02ooooo`0Soc?o0?oo003oooooooooooo<0?ooo`00ooooooo<0?oo<ol0oonI0?l0ooooc?l0
ooooool0I_oooiT0o`1Vooooooooo`2Ioooooolc0?ooooooool00?l0ofKooiT0ool0VOlc0?ooo`00
ooooooooV@3o<ol0ooooooooV@3oc03oo`1Vool0ofH00_o<o`001ol0ofKoooooo`1Voooooooo06Ko
ooooool0I_l00_ooool00ol0oooo<ol0o`1Vo`02ool0V@03ooooooo<0?ooc03o00;ooooo00Soc?l0
ooooooo<o`3oooooo`3oI_ooV@3oc?l0o`3oIP;ooooo00[ooiT0oooooooo003ooiT0ooooool0oooo
oiT0ool0VOoo003o0?mV0oooool04?ooV@3o0?mVooooooo<o`3oo`2Iooooool0I_ooooooo`3ooooo
V@3o0?mVooooooo<o`3ooooooc?o0?l0ool2ooooo`08ool0VOl0ofKooooooc<0ooooooooc03oo`3o
oolco`03ooooo`07o`1Voolc0?oo<`3oolco0?ooooooc03ooc?o0003ooooo`05o`1Vool0oooooooo
ool00?ooV@001?ooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00Gooooo00So<ol0oooo
oooooooooooooc<0ooo<0?ooooooolco00;ooooo00So0?oool`0ooooooooo`2Ioooooolco`3ooooo
oonI00;o<ol000coc03ooooooolc0?oo06Koooooool0ofKo0?ooolco0?oooooo<ol0oooooolc0?l2
olco0007oooooooo09Woooooo`1Vooooooooc03oo`3oIP03ooooo`03o`3oI_lc0?oooooo00;oc03o
00[ooiT0oooooolc0?ooooooo`3oooo<o`3ooiT0ol`0oolc0?oooooo0_ooV@005ol0oooo<`3ooooo
ooo<0?oooooooc?o0?lc0?ooo`2Io`3oI_oooooo06Kooc?o0?l0I_oooooooonI0?oo09Wo06Koolco
0?ooV@3ooooooonI0?oooooo<ol000;o0?mV00Ko0?oooc?o0?oooooo<`3oooooooooV@04ooooo`0;
oonI0?o<0?oooiT0oc<0ooooooooo`2Io`3ooooo09WooiT0o`3oI_ooool00_lco`001Olc0?oo0?oo
oonI0?oooooo<`3o00;oc?l000[ooooooonI0?o<o`3oooooo`3oI_lco`3ooooool`0oolco`3oc03o
0_ooool07oo<0?ooo`00ooooooo<0?oo<ol0oonI0?l0ooooc?l0ooooool0I_oooiT0o`1Voooooooo
o`2Ioooooolc0?ooooooool00?lc0?oooiT0ool0VOlc0?ooo`00ooooooooV@3o<ol0ooooooooV@3o
o`2Io`1Vool0ofH00_o<o`000ol0ofKoooooo`1Vo`02ooooo`0;o`1Vooooooooooooooooool0oooo
<ol0o`1Vooooooooo`2Iooooooo<0?l00oooool02?o<o`3oooooolco0?oooooo0?mVoonI0?o<o`3o
0?mV0_ooool02_ooV@3oc03oooooooooV@3ooooooonI0?ooooooo`2Iool00?l0ofH3ooooo`0@oonI
0?l0ofKoooooolco0?oo09Woooooo`1Voooooooo0?oooonI0?l0ofKoc?l0oc?o0?oooooo<ol0o`3o
IP;ooooo00Coo`2Io`3oI_oooooo<`3o0_ooool00ol0oooo<ol0ooooo`02ooooo`07o`1Voolc0?oo
ooooolco0?ooooooc03ooc?o0002ooooo`06o`1Voooooooo0?ooool00?oooooooiT01Oooool00ol0
003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`05ooooo`0Boc?o0?oooooooooooooo
oolc0?ooc03oooooooo<o`3ooooool`0oooo003o0?oooooooooo09Wo<ol0ol`0oooooooooiT00_lc
o`002?o<0?oooooooc<0ool0I_ooooooo`3oI_ooooooc?l00_ooool2oc?o00;oc?l000Ooooooool0
VOoooooo06Koooooooo<0?oo0?mV00?ooooo00?o0?mVoc<0ooooool00_o<0?l02?ooV@3ooooooc<0
oooooooo0?ooolco0?ooV@3o<`3o0_ooool02ooo09WooiT0oooooolc0?oooooool`0oooooooo<ol0
oc<0oooo09Wo0?mV00;ooooo00co<ol0ool0VOooooooo`2Iool00?l0I_ooc?l0oonI0?oooooooiT0
oooooolco`02o`3oIP06oc?o0?oooooooooooc<0oooooooooiT01?ooool02oooV@3oc03ooonI0?lc
0?oooooool`0oooooooo0?oooonI0?l0ofKooooo00;o<ol0017o<`3oo`3oooooV@3ooooooc<0oolc
o`3oc?l0ooooooooV@3oc?l0o`3oI_l0I_oo<ol0ooooooo<0?ooooooool00002ol`0o`0Hool0VOoo
003oo`2Iol`0oolco`3ooiT0ool00?o<o`3oo`2IoonI0?oooooo06Kooooooooo09Wooooooc<0oooo
ooooo`00oc<0ooooV@3ooooooc<0oooo003ooooo0oooV@02ooooo`07ool0VOl0ofKoc?l0o`3oI_oo
003oooooo`1Vo`02ooooo`06oc?o0?ooooooooooooooool0oooo<ol01?ooool01oo<0?oooooooooo
ooooooooc?l0ooooooo<o`000_ooool00oooV@3oc?l0o`3oIP02ooooo`0:oonI0?o<0?oo<`3ooooo
ooooV@3o0?oooooooooo09Woooooo`3oIP?ooooo00goc03ooonI0?ooooooo`2Iolco0?oooooo06Ko
ooooool0oooooiT0o`3oI_o<o`3o06Ko00;o<ol000Oo0?mVo`3oooooooooo`2Io`3oI_oooooo<`3o
00;ooooo00?o0?oooc?o0?ooool00_ooool01ol0I_oo<`3oooooooooooooc?l0ol`0oolco`000_oo
ool01_l0I_ooooooo`3ooooo003ooooooonI00Gooooo00?o0000ooooooooool00_ooool0013ooooo
00?o0000ooooooooool01?ooool00ol0I_oo<ol0ooooo`02ooooo`08oc<0ooo<0?ooooooooooooo<
o`3oooooool00?l0ool2ooooo`0@oc?o0?o<0?oooooooonI0?lco`3o0?mVol`0oolc0?ooooooo`1V
ool0ofKo0?ooooooooo<o`3o<`3oooooo`;o<ol00_o<o`001oooooooo`2Iooooool0I_oooooool`0
ool0ofH00_ooool00oo<0?oo0?mVoc<0o`02ooooo`03ol`0ooooV@3o<`3o00;ooooo01Go0?oooonI
0?lc0?ooc03ooooooooo09Woc?l0o`3ooooooooo<`3oooooooo<0?oooooooc?o0?lc0?ooo`2Io`3o
I_ooooooo`2Ioc?o0?ooool00_oo09T2ool00009olco0?ooV@3ooiT0o`3oI_oooooo<ol0ooooool0
ofKo<ol000;ooooo00?o<`3oooooooooV@000oooool01?ooV@3o<`3ool`0ooooV@02ooooo`0Eol`0
oooooooooiT0ooooool0ofKooooooc?o0?oo09Wo<`3oo`3ooolc0?oooiT0oc<0oolco`3oc?l0oooo
ooooV@3oc?l0o`3oI_oooooo<ol000;oc03o0_ooool2ol`0o`0:ool0VOoo003oo`2Iol`0ool0I_oo
oiT0olco0?oooooo06KooonI00?ooooo00?oo`2Ioooooolc0?l00_ooool02Olc0?oooiT0oooooooo
oooo<`3ooonI0?l0ofKo<ol0oonI0002ooooo`07ool0VOlc0?ooc?l0o`3oI_ooooooo`00o`1Vo`02
ooooo`06oc?o0?oooooooooooooooolco`3o06Ko1?ooool01oo<0?ooooooooooooooooooc?l0oc?o
0?o<o`000_ooool02_ooV@3oooooo`3oI_oooooo06KooonI0?oo003o<`3ool`0ool0ool2ooooo`03
ool0VOoooooo0?mV00?ooooo00goc03ooonI0?ooooooo`2Iooooooo<o`3oooooo`1Vool0oooooiT0
o`3oI_o<o`3o06Ko00;o<ol00_l0ofH01Ooooooo0?mVool0VOoooooo<`3o00;ooooo00?o0?oooc?o
0?ooool00_ooool02Ol0I_oo<ol0oc?o0?ooooooc?l0oc?o0?oooooo0?ooo`1Vo`02ooooo`03o`3o
oooo003ooooo00Kooooo00?o0000ooooooooool00_ooool0013ooooo0_l00005ooooo`03o`1Voolc
o`3ooooo00;ooooo01[o<`3ool`0ooooooooooooolco0?ooooooo`00o`3oooo<0?oooooooc?o0?o<
0?oooooooonI0?lco`3o0?mVoooooolc0?ooooooo`1Vool0ofKo0?ooolco0?oooooo<`3oooooo`;o
<ol000Wo06Koolco0?l0I_ooooooool0VOl0I_oooooool`0ool0ofH00_ooool00oo<0?oo0?mVoc<0
o`02ooooo`03ol`0ooooV@3o<`3o00?ooooo01;ooiT0ool0VOoo003oc03oolco0?oooooo0?oooooo
oolc0?oooooool`0oooooooo<ol0oc<0oooooooo0?mVoooooolco`02ooooo`;oo`2I00?oooooool0
0?ooool00_ooV@002ol0ofKooooooc?o0?l0I_oo0?oooc?o0?l0I_oooooooc<0oooooooooiT000?o
oooo01cooiT0oc<0ooo<0?oo<`3ooonI0?ooooooc03oool0VOooV@3oooooo`3oI_oooooo<ol0oooo
oooo09Wo0?ooooooooooV@3o<`3ooc?o0?o<o`3ooiT0ooooooo<o`3o0?mVoc?o0?ooooooc03o0ooo
ool03?oo003oc03oool0VOooooooo`2Iooooool0I_oooooooonI0?oooooo06KooonI00?ooooo00?o
o`2Ioooooolc0?l00_ooool02?lc0?oo0?mVoonI0?oooooo<`3ooonI0?oooooo<ol00oooool01ooo
09Wo<`3oolco0?l0ofKoooooool00?l0I_l00_ooool2oc?o00;ooooo00?o<ol0o`1Vooooool01ooo
ool00oo<o`3o<ol0olco0002ooooo`0:oonI0?oooooo0?mVooooool0I_oooiT0ool00?lc0?oooooo
o`3oo`;ooooo00?oo`2Iooooool0ofH00oooool01?o<0?oooiT0oooooooo0002ooooo`03olco0?l0
I_oooiT000;ooooo00Koc?l0oooooolco`3oooooo`3oI_l0ool2o`3oIP07ool0VOoooooo<`3ooooo
ool0ooooc03ooc?o0003ooooo`0<oc?o0?oooooooooooc?o0?o<o`3o<ol0ooooool0oooo06Kooooo
ool0ooooc?l01oooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00Cooooo00?o06Kooc?o
0?ooool00_ooool06_lc0?oooooool`0ooo<0?ooc?l0oooooooo003o0?oool`0oooooooo<ol0ol`0
oooooooooiT0o`3oool0ofKooooooc<0oooooooo06Koo`3oI_l0ooooc?l0ooooool0I_oooooo0_lc
o`003_l0I_ooc?l0o`1Vooooooooo`2Io`1Vooooooooo`2Iol`0ool0ofKooooool`0ool0ofKo<`3o
0oooool00oooV@3o<`3oooooo`02ooooo`0BoonI0?oo09Wooooool`0ooo<o`3oooooo`3ooooooooo
<`3oooooooo<0?oooooooc?o0?lc0?ooooooo`3oI_oooooo<ol00_ooool2ool0V@?ooooo00Woc?l0
oonI0?l0ofKooooooc?o0?l0I_oo0?oooc?o0?l0I_l00_ooool00olc0?oooiT0ooooo`02ooooo`0;
oonI0?lc0?ooc03ooc<0ooooV@3ooooool`0oooo09WooiT0o`3oool0ofH01?ooool01?l0ooooo`00
oonI0?lc0?l2oonI00;ooooo00?oc?l0o`3oI_lco`001Oooool02_oo003oooooool0VOooooooo`2I
ooooool0I_oooooooonI0?ooool2oonI00;ooooo00koo`2Ioooooooooooo<`3ooooooolc0?ooo`00
ool0VOooV@3oooooo`3oI_ooV@3ooooooc?o00Cooooo00Ko<`3oo`3oI_l0I_oo0?ooool00?l0I_l2
ooooo`06oc?o0?oooooo<ol0o`3ooolco`3o06Ko2?ooool00oo<o`3o<ol0olco0002ooooo`0<oonI
0?oooooo0?mVool00?l0I_oooiT0ool00?lc0?ooooooo`3oooooooooo`2I0_ooool01ol0ofKooooo
ooooooooooooc03ooonI0?oo00000oooool00oo<o`3o06KooonI0002ooooo`0>olco0?oooooo<ol0
ooooool0ofKo<`3oo`3oool0ofKoo`2Ioooooolc0?ooooooo`3oooooool4oc?o000;o`1Vooo<0?oo
ooooooooooo<o`3oc03oooooool0oooo06Koool00?l0ool00_o<o`07ooooo`03o`000?oooooooooo
00;ooooo000@ooooo`03o`000?oooooooooo00Cooooo00?o06Kooc?o0?ooool00_ooool01Olc0?oo
oooool`0ooo<0?ooc?l000;ooooo00_o0?oool`0oooooooo<ol0ol`0oooooooooiT0o`3oool0ofKo
oooooc<0o`02ooooo`0=o`3oI_oo003oc?l0ooooool0I_oooooooc?o0?lc0?oo06Koooooool0I_oo
ooooo`1Vo`02ooooo`07ool0VOo<0?oo0?mVooooool0ofKooooooc<0o`04ooooo`08oonI0?oooooo
ooooooooooooV@3oc?l0ool0VOo<o`02ooooo`07o`3ooooooooo<`3oooooooo<0?oooooooc?o0002
ooooo`03o`3oI_oooooo<ol000?ooooo00goo`2Iooooooooooooooooolco0?ooV@3o0?mVoooooolc
o`3o06Koo`3ooolco`3o06Ko00;ooooo013o<`3ooonI0?oooooooooooonI0?oooooo<`3ooooooolc
0?oooiT0ooooooo<0?ooo`2IoonI0?l0oooo0?mV1?ooool01_l0ooooo`00oonI0?ooV@3o<`3ooc?o
00;ooooo00?oc?l0oooooolco`001Oooool02?oo003oooooool0VOooooooo`2Iooooool0I_oooooo
0_ooV@001Ol0I_ooo`2Iooooooooooooo`2I00;ooooo00Wo<`3oool0VOlc0?ooo`2IooooooooV@3o
oooooonI0?lc0?l00_ooool03Olco`3ooooooooooooooooo<`3oo`3oI_l0I_oo0?ooool00?l0I_oo
oooooc?o0?oo00000_ooool00olco`3oooooo`1Vo`08ooooo`0Aolco0?lco`3oc?l0o`1Voooooooo
oiT0ooooool0ofKoo`00o`1VooooV@3ooooooc<0oooooooo0?oooooooooo09T00_ooool01ooo003o
0?mVooooooooooooc03oo`3oI_ooV@000oooool01_o<o`3o06KooonI0?lc0?ooooooolco00;ooooo
00co0?mVoc<0oooooooo0?oooc<0oooo09Wooooooc<0oooooooo0?ooooooooo<0?l3ooooo`0>o`1V
ooo<0?ooooooooooooo<o`3oc03oooooool0ooooooooool00?l0ooooc?l0ool0VOo<o`06ooooo`03
o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Cooooo00?o06Kooc?o0?ooool0
0_ooool09_lc0?oooooool`0ooo<0?ooooooolco0?oooooo0?oool`0oooooooo<ol0ol`0ooo<o`3o
oiT0o`3oool0ofKooooooc<0ooooooooc?l0o`1Voooo003oc?l0ooooool0I_oo<`3ooc?o0?oooooo
06Koooooool0I_ooooooo`1Vooooooooo`2Iooooooo<0?oooooo0_l0ofH00ooooooo<`3oooooo`03
ooooo`05oonI0?ooooooooooooooooooV@000_o<o`001?o<0?ooooooooooool0ool2ooooo`04oc<0
ooo<0?oooooooc?o00;ooooo00?o0?mVoc?o0?oo09T01oooool00oo<o`3ooiT0ooooo`02ooooo`03
oc?o0?l0oooo<ol000;o06Ko00?ooooooc<0ooooV@000_ooool03OooV@3ooooooc<0oooooooo<`3o
ooooooooV@3oc03ooonI0?oooooo0?ooooooool0ofH00_ooool01ol0ooooc03oool00?ooV@3oc03o
oc<0oolco`000_ooool00oo<o`3ooooooc?o0005ooooo`03ool00?ooooooo`0000;oo`2I0_ooool0
1Oo<o`3ooiT0ooooool0I_ooo`2I00;ooooo00coo`2Ioooooooooooo<`3oool0VOlc0?ooo`00oooo
ooooV@3o0?mVoonI0?lc0?l2ooooo`0=oc?o0?oooooooooooooooolc0?ooooooo`1Vool0ooooo`00
o`1Voooooooo<ol0ool00002ooooo`03o`3ooooooooooooo00Wooooo0_o<o`003_l0I_oo<`3ooonI
0?oooooo0?mVo`1VoooooooooiT0oooooolc0?ooooooo`3oooooooooo`2I0oooool01_l0ofKooooo
ol`0ool0ofKooooooonI00?ooooo00Koc?l0o`1VooooV@3o<`3oooooooo<o`02ooooo`05o`3oI_lc
0?ooooooo`3ooolc0?l00_oo09T01Olc0?ooooooo`3oooooooooc03o00?ooooo00oo06Kool`0oooo
ooooooooolco0?o<0?ooooooo`3oooooooooo`00o`3oooo<o`3oo`2Iooooooo<o`001Oooool00ol0
003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`04ooooo`03o`1Voolco`3ooooo00;o
oooo00?o<`3oooooooo<0?l00_ooool05oo<o`3oooooool00?l0oooooooooc?o0?ooooooc?l0oonI
0?l0oooo0?mVoooooolc0?ooooooolco0?l0I_ooo`00olco0?l0I_ooooooo`1Voolc0?oo06Ko00;o
oooo00?o06Koooooool0I_l00_oo09T00oooooooc03oooooo`02o`3oIP03oooooolc0?oooooo00;o
oooo00Ko<`3ooonI0?oooooooooooonI0?ooool2olco0004ol`0ooooooooooooo`3oo`;ooooo00Co
<`3ooooooolc0?oo<ol00_ooool00ol0ofKo<ol0ool0V@07ooooo`03olco0?l0ofKooooo00;ooooo
00So<ol0o`3ooolco`3oooooo`1Voooooooo<`3ooonI00;ooooo00KooiT0oooooolc0?oooooooc<0
ooooool3oonI0004ooooool0ooooooooo`3oIP;ooooo00Oo0?ooooooooo<0?oooooool`0oolc0?oo
<ol000;ooooo00?o0?mVolco0?lco`001_ooool00ooo003oooooool0V@02ooooo`06olco0?l0I_oo
ooooooooool0I_ooo`2I0_ooool03?oo09Wooooooooooolc0?ooo`2Ioc<0oooo003ooooooonI0?oo
oooooiT0oc<0o`;ooooo00Go<ol0oooooooooooooooooc<0o`02ooooo`05o`3ooooooooo06Kooooo
oolco`000oooool00ol0ooooooooooooo`09ooooo`0@olco0?oooooo06Kooc<0ooooV@3o0?mVoooo
ool0I_oooiT0o`3ooooooooo<`3oooooool0ooooooooool0V@?ooooo00Ko0?mVooooooo<0?oo0?mV
ooooooooV@03ooooo`06olco0?l0I_oooiT0oc<0ooo<o`3o0?mV0_ooool01Ol0ofKo<`3ooooooooo
oooo0?oo00;oo`2I00Go<`3oooooool0oooooooool`0o`04ooooo`0<o`1Vooo<0?ooooooolco0?o<
0?ooooooo`3ooooo003oooooo`3oooo<o`3oo`2I1oooool00ol0003oooooooooo`02ooooo`004?oo
ool2o`0000Gooooo00?o06Kooc?o0?ooool00_ooool00olc0?oooooool`0o`02ooooo`0>olco0?oo
ooooo`00o`3ooooooooo<ol0ooooooo<o`3ooiT0o`3oool0ofKooooooc<0ooooool3olco0006oooo
ool0I_ooooooo`1Voolc0?oo06Ko0_ooool00ol0I_ooooooo`1Vo`02ool0V@05ooooooo<0?ooc03o
ooooool0ofH00_ooool01Olc0?oooooooooooolc0?oooiT000;ooooo00OooiT0ooooooo<o`3ooooo
ol`0oooooooo0?oo00?ooooo0_lc0?l2ooooo`05oc?o0?oooooo0?mVoc?o0?oo09T02?ooool03?o<
o`3ooooooooooooooooo<ol0o`3ooolco`3oooooo`1Voooooooo<`3ooonI00;ooooo00SooiT0oooo
oolc0?oooooooc<0ooo<0?oooooool`0o`?ooooo00oo0?ooo`3oI_ooooooooooo`3oooooooooc03o
ooooooo<0?oo<`3ooc?o0?oooooo<`3oo`3oI_o<o`001oooool00ooo003oooooool0V@02ooooo`06
olco0?l0I_ooooooo`1Vooooooooo`2I0_ooool01?oo09Woooooooooooooool2oc<0o`03ool00?oo
oooooooo00;ooiT000Co<`3ooooooooooooo<ol00oooool02?lc0?ooooooooooool0I_oo0?ooo`1V
oooooooo<ol00oooool00ol0ooooooooooooo`09ooooo`0;olco0?oooooo06Kooc<0ooooV@3o0?mV
ooooool0I_oooiT0o`3ooolc0?l00_ooool00ol0ooooc03oool0V@03ooooo`06o`3oI_ooooooc03o
o`3oI_oooooooiT01?ooool01Oo<o`3ooiT0oc<0ooo<o`3o0?mV00;ooooo00[o0?mVoc<0oooooooo
ooooo`3ooolc0?ooo`2Ioc<0oooooooo0?oo0_ooool01_o<0?oooooooooooooooooo06Kool`0o`;o
oooo00Soc?l0o`1Voooooooo0?ooooooooo<o`3oooooool0V@Kooooo0_l00004ooooo`004?ooool0
0ol0003oooooooooo`03ooooo`04o`1Voooooooooooooc?o00?ooooo00?o<`3oooooooooool00_oo
ool05_o<o`3oo`00o`3ooooooooo<ol0ooooooo<o`3ooiT0ool0VOoooooo0?mVooooooo<o`3ooooo
o`1Vooo<o`3oooooo`1Voooooooo06Koooooool0I_l2ooooo`03o`1Voooooooo06Ko00;oo`2I00?o
oooool`0ooo<0?l01?ooool01olc0?oooooooooooolc0?oooiT0ooooooooV@000oooool01?l0oooo
c03oooooool0ool3ooooo`08oc<0oooooooooooooooooolco`3ooooooc?o0?oo09T9ooooo`07olco
0?l0oooo0?ooo`3ooolco`3o0?oooc?o0002ooooo`;o06Ko00_ooiT0oooooooooooooiT0oooooolc
0?oooooooc<0ooo<0?oooooool`0o`03ooooo`0?o`3oool0ofKoooooooooool0oooooooool`0oooo
003oc03ooc<0oolco`3oooooo`3oI_ooooooc?l000Wooooo00Ooo`2Iooooooooooooc?l0o`1Voooo
oooo06Ko00;ooooo00?oo`2Ioooooooo09T00oooool01_lc0?oooooooooooooo003ooooooonI00;o
oooo0_lc0?l01?lco`3ooooooooooolc0?l3ooooo`05o`1Vool0ooooo`00oooooolco`000oooool0
0ol0ooooooooooooo`09ooooo`0;olco0?oooooo06Kooc<0oooooooooiT0o`1VoooooooooiT0o`3o
oolc0?l00_ooool00ol0ooooc03oooooo`03ooooo`06o`3oI_ooooooc03oo`3oI_oooooooiT01?oo
ool02OooV@3o06Kooc<0ooo<o`3o06Koo`3oI_oooooo0?mVoc<0o`02ooooo`06o`3ooolc0?ooo`2I
oc<0oooooooo0?oo0_ooool01_o<0?ooooooooooooo<0?oo06Kool`0o`;ooooo00Koc?l0o`1Voooo
oooo0?ooooooooo<o`02ooooo`03ool0VOoooooooooo00Cooooo00?o0000ooooooooool00_ooool0
00Sooooo0ol00005ooooo`03o`000?oooooooooo00?ooooo00Co06Kooooooooooooo<ol00oooool0
0olc0?ooooooooooo`02ooooo`0:olco0?oo003o0?oooc?o0?o<0?ooc?l0o`3oooooV@3oo`2Ioooo
o`;o0?mV00Goc?l0ooooool0I_ooooooo`1Vo`02ooooo`03o`1Voooooooo06Ko00?ooooo0_l0I_l2
ool0V@03ooooooo<0?oooooo00Cooooo00Co<`3ooooooooooooo<`3o0_ooV@04ooooo`04o`3ooooo
ooooc03oo`3oo`?ooooo00Coc03ooooooooooooooooo0_lco`000ol0ofKoo`2Iooooo`08ooooo`07
olco0?oooooooooooooooolco`3ooooooc?o0002ooooo`;o06Ko00?ooiT0ooooooooV@000oooool2
oc<0o`;oc03o1?ooool03ol0oooo0?mVoooooooooooo0?ooooooooo<0?ooo`00ol`0oolc0?oo<ol0
ooooool0ofKoooooolco000;ooooo`05olco0?oooooo06Koooooool0I_l00_ooool00ooo09Wooooo
ool0V@03ooooo`06oc<0ooooooooooooool00?oooooooiT00_ooool01_lc0?oooooooc?o0?lc0?oo
oooooc<0o`?ooooo00Go06Koo`3ooooo003ooooooc?o0003ooooo`03o`3ooooooooooooo00Wooooo
00_oc?l0ooooool0I_oo<`3oooooooooV@3o06KoooooooooV@3o0?oooc<0o`02ooooo`03o`3oooo<
0?oooooo00?ooooo00Oo0?mVooooooo<0?oo0?mVoooooooo003ooiT000?ooooo00SooiT0o`1Vool0
I_ooc?l0ooooool0ofKoooooo`3oIP?ooooo00?o0?oooc<0oolc0?l00_ooool01?l0oooooooooooo
ooo<0?l2ooooo`0;ol`0ool0I_ooc03oooooooo<0?ooc?l0o`1Voooooooo0?ooooooooo<o`000_oo
ool00ooo09Woooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0009ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool00oooool01?l0I_oooooooooooolco`03ooooo`03oc<0oooo
oooooooo00;ooooo00Soc?l0ool00?l0oooo<ol0ol`0ooo<o`3o0?oooonI00;o<`3o0_l0ofH01Oo<
o`3oooooo`1Voooooooo06Ko00;ooooo00?o06Koooooool0I_l00oooool01?l0I_oooooooooooooo
09T8ooooo`04oc<0oooooooo<`3ooonI00Gooooo00Co0?ooooooooo<0?oo0?oo0oooool01?o<0?oo
ooooooooooooool2oc?o0003o`3oI_oo09Wooooo00Sooooo00Ooc?l0oooooooooooooooooc?o0?oo
oooo<ol000;ooooo00?o06Koolco0?ooool00_ooV@03ooooo`04oc<0ooooooooc03ool`0o`Cooooo
00Co0?ooo`3oI_oooooo0?oo0_ooool2ol`0o`;ooooo00Go<ol0o`3oI_lc0?ooooooolco000;oooo
o`05olco0?oooooo06Koooooool0I_l00_ooool00ooo09Woooooool0V@03ooooo`06oc<0oooooooo
ooooool00?ooooooo`001?ooool01?lco`3o<`3ooooooolc0?l3ooooo`05o`1Vool0ooooo`00oc?o
0?oo00000oooool00ol0ooooooooooooo`0;ooooo`09o`1Voolc0?oooooooonI0?l0I_oooooooonI
0?oo09Wo0?oo00;ooooo00?o0?oool`0ooooool00oooool01ol0ofKoo`00ol`0ool0ofKoooooool0
0?ooV@000oooool02?ooV@3o06Kooc<0ooo<o`3oooooo`3oI_oooooo0?mV0oooool01Ol0oooo<`3o
oc<0oooooooo0?oo00?ooooo00Koc03oooooooooooooc03oo`1Vooooool2ol`0o`06olco0?l0I_oo
o`00o`3oooooooooc?l00_ooool00ooo09Woooooooooo`04ooooo`03o`000?oooooooooo00;ooooo
0009ooooo`03o`000?oooooooooo00Cooooo0ol00003ooooo`04o`1Voooooooooooooc?o00?ooooo
00?o<`3oooooooooool00oooool01oo<o`3o0?oooc?o0?o<0?ooc?l0ool00?ooV@000_ooool01Ol0
ofKoc?l0ooooooooooooo`0000;o06Ko0oooool00ol0I_ooooooooooo`02ooooo`04o`1Voooooooo
ooooool0V@Sooooo00?o<`3ooooooolc0?l01_ooool01?l0oooooooool`0ool0ool3ooooo`08ol`0
oooooooooooooooooolco`3oooooo`3oI_oo09T9ooooo`04olco0?ooooooooooooooo`;o<ol000Ko
06Kooooooooooooo06Koolco0?ooool2oonI00?ooooo00Co<`3oooooooooooooc03o1Oooool00ol0
ofKoooooo`3oo`03ooooo`08ol`0oooooooooooooc?o0?oooooo<`3oooooooo<o`0;ooooo`05olco
0?oooooo06Koooooool0I_l00_ooool2ool0V@Oooooo00?oo`00oooooooo00001?ooool01?lco`3o
oooooc<0oolc0?l4ooooo`04o`3ooooo003o<ol0ool000?ooooo00?o0?ooooooooooool03?ooool0
3?l0I_oo<`3ooonI0?oooooooiT0oooooooo09Wo0?ooooooool0ooooo`2Iol`0o`Cooooo00?o0?mV
ool00?l0ofH00_ooool00ooo003ooiT0ooooo`02ooooo`03oonI0?ooooooc?l000;ooooo0_l0ofH0
1Olc0?oooooooooooooooooo0?oo00;o<`3o00?oooooo`3oooooool00_ooool01_o<0?oooooooooo
ooo<0?oo06Koooooo`;oc03o00?o06Koolco0?oo00000_l0ool01?o<o`3ooooooooooooo09T4oooo
o`?o00001?ooool000Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`05
oc?o0?oooooooooooooooolc0?l01Oooool02?o<o`3o0?oooc?o0?o<0?ooc?l0ool00?ooV@3oc?l0
0_ooool01Oo<o`3ooooooooooooo003o06Ko00Cooooo00?o06Koooooooooool00_ooool00ol0I_oo
ooooooooo`09ooooo`;o<`3o2?ooool00ol0ooooc03oo`3oo`02ooooo`03ol`0oooooooooooo00Go
oooo00?o0?mVooooooooool01oooool01?o<o`3oooooooooooooool2oc?o0006o`1Vooo<o`3ooooo
ooooooo<o`3ooooo0_ooV@03ooooo`04oc<0oooooooooooool`0o`Gooooo00?o0?mVooooool0ool0
0oooool01?o<0?oooooooooooolco`02oc<0o`03ooooooo<o`3ooooo00[ooooo00Goc?l0ooooool0
I_ooooooo`1Vo`02ooooo`;oo`2I2?ooool2ool000Cooooo00Co<ol0oooooolc0?oo<`3o1?ooool0
1?l0I_oo0?oooc?o0?oo0003ooooo`03o`3ooooooooooooo00cooooo00Co06Kooc<0ooooV@3ooiT0
0_ooool01_oo09Wo0?ooooooool0ooooo`2Iol`0o`Cooooo00?o0?mVool00?l0ofH00_ooool00ooo
003ooiT0ooooo`02ooooo`03oonI0?ooooooc?l000;ooooo0_l0ofH00olc0?ooooooooooo`02oooo
o`04o`3ooolc0?ooooooo`3oo`Cooooo00Goc03oooooooo<0?ooooooo`1Vo`02ol`0o`03o`1Vooo<
o`3oo`0000;o0?oo00Coc?l0ooooooooooooo`2I1_ooool00ol0003oooooooooo`02ooooo`002Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Oooooo00Co<ol0oooooooooooo<`3o
1Oooool02?o<o`3o0?oooc?o0?ooooooc?l0ooooooooV@3oc?l00_ooool01Oo<o`3ooooooooooooo
003o06Ko01Kooooo00?o<`3oooooooooool01_ooool00ol0ooooc03oo`3oo`02ooooo`03ol`0oooo
oooooooo00Gooooo00?o0?mVooooooooool01_ooool00ol0ofKoooooolco0003ooooo`03oc?o0?oo
ooooc?l000;ooooo00Coc?l0ooooooooV@3ooiT00oooool00olc0?ooooooooooo`06ooooo`03o`3o
I_oooooo0?oo00?ooooo00Coc03ooooooooooooo<ol00oooool00oo<o`3oooooooooo`08ooooo`04
olco0?ooooooooooooooo`;o06Ko0oooool00ooo09Woooooooooo`07ooooo`03ool00?oooooooooo
00;ooooo00Co<ol0oooooolc0?oo<`3o1Oooool00olco`3oo`00ooooo`02ooooo`03o`3ooooooooo
oooo00gooooo0_l0I_l02_ooV@3ooooooooooooooooo<`3oo`3ooooooooo0?ooool0VOo<0?l4oooo
o`03o`3oI_oo003o0?mV00;ooooo00Woo`00ooooooooV@3ooooooonI0?o<o`3oooooolco0?lc0?l0
0_ooool00ol0ofKo<`3oooooo`03ooooo`04o`3ooolc0?ooooooo`3oo`Cooooo00Goc03oooooooo<
0?ooooooo`1Vo`02ol`0o`06o`1Vooo<o`3oo`00ooooool0ooooc?l00oooool00ooo09Wooooooooo
o`03ooooo`03o`000?oooooooooo00;ooooo0008ooooo`;o00001_ooool00ol0003oooooooooo`08
ooooo`03oc?o0?oooooo<`3o00Gooooo00_oc?l0o`3ooolco`3o<`3oolco0?oooooooiT0olco0?oo
003oooooolco0002ooooo`03ool00?oooooooooo01Gooooo00?o<`3oooooooooool01_ooool00ol0
ooooooooo`3oo`02ooooo`03ol`0oooooooooooo00Gooooo00?o0?mVooooooooool01_ooool00ol0
ofKoooooolco0003ooooo`08oc?o0?ooooooc?l0olco0?ooooooc?l0ooooooooV@0=ooooo`03o`3o
I_oooooo0?oo00Gooooo00?o0?mVoooooolco`000_ooool00olco`3oc?l0ooooo`08ooooo`05olco
0?ooooooooooooooool0I_l01?ooool00ooo09Woooooooooo`0<ooooo`04oc?o0?oooooooooooc<0
o`Cooooo00?o<ol0o`3ooooo00000oooool00ol0ooooooooooooo`0=ooooo`03o`1Voolc0?oooooo
00?ooooo00Ko<`3oo`3oool0ooooo`2Iooooooo<0?l4ooooo`03o`3oI_oooooo0?mV00;ooooo00?o
o`00ooooooooool00_ooV@001?o<o`3oooooolco0?lc0?l2ooooo`03o`3oI_lc0?oooooo00?ooooo
00Co0?oooc<0oooooooo0?oo1?ooool03?o<0?oooooool`0oooooooo06Koooooooo<0?oo06Koool0
0?o<o`3oooooolco00Cooooo00?oo`2Iooooooooool00oooool00ol0003oooooooooo`02ooooo`00
2Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o<ol0oooooolc0?l0
1Oooool02?o<o`3o0?oooc?o0?l0ooooc?l0ooooooooV@3ooooo0_o<o`03ooooo`03ool00?oooooo
oooo01kooooo0_l0ool00oo<0?oooooool`0o`08ooooo`03o`3oI_oooooooooo00Kooooo00?o0?mV
ooooooo<o`000oooool02?lco`3oooooolco0?o<o`3oooooolco0?oooooooiT03Oooool00ol0ofKo
0?ooooooo`05ooooo`07o`3oI_oooooo<ol0oooooolco`3oooooolco0009ooooo`05olco0?oooooo
ooooooooool0I_l04oooool00olco`3oooooooooo`05ooooo`03oc?o0?l0ooooo`0000?ooooo00?o
0?ooooooooooool03_ooool00olc0?ooooooooooo`02ooooo`06oc<0ool0oooo0?ooool0VOoooooo
c03o1Oooool2o`3oIP;ooooo00Woo`00oooooooooooooooooonI0?o<o`3oooooolco0?lc0?l00ooo
ool00olc0?ooooooooooo`02ooooo`03o`3ooooooooo0?oo00Gooooo00?oc03oooooooo<0?l00_oo
ool01Ol0I_ooc03oo`1Voooo003ooooo00;oc?l02_ooool00ol0003oooooooooo`02ooooo`004?oo
ool2o`0000Wooooo00?o<ol0oooooolc0?l01Oooool01?lc0?ooc?l0oc?o0?o<o`02ooooo`04oonI
0?ooooooo`00olco00?ooooo00?oo`00ooooooooool07_ooool2o`3oo`03ol`0ooooooooc03o00So
oooo00?o0?mVooooooooool01_ooool00ol0ofKoooooolco0003ooooo`04oc?o0?o<o`3ooooooooo
o`;oc?l03oooool00ol0ofKo0?ooooooo`05ooooo`05o`3oI_oooooo<ol0oooooolco`000_ooool0
0oo<o`3oooooooooo`06ooooo`05olco0?ooooooooooooooool0I_l04oooool00olco`3ooooooooo
o`05ooooo`03oc?o0?l0ooooo`0000?ooooo00?o0?ooooooooooool03_ooool00olc0?oooooooooo
o`02ooooo`04oc<0ool0oooo0?ooool0V@;ooooo00?oc03oooooooooool00_ooool2o`3oIP03oooo
oooo003ooooo00Gooooo0_o<o`001Olc0?oooooooooooooooooo<`3o00Cooooo00?o0?ooooooool0
ool01Oooool2ol`0o`?ooooo0_l0I_l3ooooo`;oc?l02Oooool2o`0000Cooooo000@ooooo`03o`00
0?oooooooooo00Wooooo00?o<ol0oc<0ooooool01?ooool01?lc0?ooc?l0oc?o0?o<o`02ooooo`04
oonI0?ooooooooooool000?ooooo00?oo`00ooooooooool07oooool01?l0oooooooool`0ooo<0?l8
ooooo`?o0?mV1_ooool00ol0ofKoooooolco0004ooooo`03olco0?oooooooooo00;oc?l03oooool0
0ol0ofKoooooooooo`04ooooo`06o`3oI_oooooooooooc?o0?oooooo<ol00_ooool00oo<o`3ooooo
ooooo`05ooooo`03olco0?oooooooooo01Oooooo00?o<ol0ooooooooool00oooool00olco`3ooooo
o`3oo`03ooooo`03o`3ooooooooooooo00oooooo00?o<`3oooooooooool00_ooool01?lc0?oo0?oo
oooooooo09T2ooooo`03ol`0oooooooooooo00;ooooo0_l0ofH2ool000Kooooo00?oc?l0oooooolc
0?l00oooool00olc0?ooooooooooo`02ooooo`03o`3ooooooooo0?oo00Kooooo00Coc03ooooooooo
oooooooo0_l0I_l4ooooo`03olco0?oooooooooo00Sooooo00?o0000ooooooooool00_ooool0013o
oooo00?o0000ooooooooool02Oooool00olco`3o<`3oooooo`04ooooo`04oc<0ooo<o`3o<ol0olco
00;ooooo00CooiT0ooooooooooooo`000oooool00ooo003oooooooooo`0Oooooo`03o`3ooooooooo
c03o00_ooooo00?o0?mVooooooooool01?ooool00ol0ofKoooooolco0004ooooo`03olco0?oooooo
oooo00;oc?l03oooool00ol0ofKoooooooooo`04ooooo`06o`3oI_oooooooooooc?o0?oooooo<ol0
0_ooool00oo<o`3oooooooooo`05ooooo`03olco0?oooooooooo01Oooooo00?o<ol0ooooooooool0
0oooool00olco`3oooooo`3oo`03ooooo`03o`3ooooooooooooo00oooooo00Ko<`3ooooooooooooo
oooooc<0ooooool2ool0V@?ooooo00?oc03oooooooooool00_ooool01?l0ofKoc03oool00?oo0006
ooooo`03olco0?oooooo<`3o00?ooooo00?o<`3oooooooooool00_ooool00ol0ooooooooo`3oo`06
ooooo`03ol`0oooooooooooo00;ooooo00?o06Koooooooooool03Oooool00ol0003oooooooooo`02
ooooo`004?ooool00ol0003oooooooooo`09ooooo`03oc?o0?lc0?oooooo00Cooooo00Ko<`3oolco
0?l0ooooc?l0ooooooooV@03ooooo`05ool00?oooooooooooooooooo0000<?ooool00ol0ofKooooo
ooooo`03ooooo`04o`3oI_ooooooooooolco00?ooooo00Goc?l0ooooooooooooooooolco000?oooo
o`03o`3oI_oooooooooo00Cooooo00Ko0?mVoooooooooooo<ol0oooooolco`03ooooo`03olco0?oo
oooooooo00Cooooo00?oc?l0ooooooooool05oooool00olco`3oooooooooo`03ooooo`04oc?o0?oo
ooooooooo`3oo`;ooooo00?o0?ooooooooooool03oooool01_lc0?oooooooooooooooooo<`3ooooo
o`;oo`2I0oooool00oo<0?ooooooooooo`02ooooo`04o`3oI_o<0?ooo`00ool000Kooooo00?oc?l0
oooooolc0?l00_ooool00olc0?ooooooooooo`04ooooo`;o0?oo1_ooool00oo<0?ooooooooooo`0B
ooooo`03o`000?oooooooooo00;ooooo000@ooooo`;o00002_ooool00olco`3o<`3oooooo`03oooo
o`07oc<0ooooooooc?l0o`3oooo<o`3ooooooonI0004ooooo`03ool00?ooooooo`0003;ooooo00?o
0?mVooooooooool00_ooool01?l0ofKoooooooooooo<o`03ooooo`03olco0?oooooooooo01;ooooo
00?o0?mVooooooooool00oooool01_l0ofKooooooooooolco`3ooooooc?o00?ooooo00?oc?l0oooo
ooooool01?ooool00oo<o`3oooooooooo`0Hooooo`03oc?o0?oooooooooo00;ooooo00Co<ol0oooo
oooooooo0?oo0_ooool00ol0ooooooooooooo`0?ooooo`06oc<0oooooooooooooooooolc0?oooooo
0_oo09T3ooooo`03ol`0oooooooooooo00;ooooo00Co0?mVooooooooooooo`002?ooool01?lc0?oo
oooooooooolc0?l6ooooo`03o`3ooooooooooooo01Wooooo0_l00004ooooo`004?ooool00ol0003o
ooooooooo`09ooooo`03oc?o0?lc0?oooooo00?ooooo00Oo<`3oooooooo<o`3o<`3oolco0?oooooo
oiT000Cooooo00?oo`00oooooooo0000<oooool01Ol0ofKooooooooooooooooo0?mV00;ooooo00Go
c?l0ooooooooooooooooolco000Dooooo`03o`3oI_oooooooooo00;ooooo00Oo0?mVoooooooooooo
oooooc?o0?oooooo<ol000Cooooo00?oc?l0ooooooooool00oooool00oo<o`3oooooooooo`0Hoooo
o`05oc?o0?oooooooooooooooolco`000oooool00ol0ooooooooo`3oo`0Cooooo`05oc<0oooooooo
oooooc<0ooooool00_oo09T3ooooo`03ol`0oooooooooooo00;ooooo00Coc03oooooooooooooo`00
2?ooool01?lc0?oooooooooooolc0?l6ooooo`03o`3ooooooooooooo01[ooooo00?o0000oooooooo
ool00_ooool0013ooooo00?o0000ooooooooool02_ooool00olco`3oooooooooo`02ooooo`07oc<0
ooooooooc?l0ooooooo<o`3ooooooonI0005ooooo`;oo`00<oooool01?l0ofKoooooooooool0ofH4
ooooo`03olco0?ooooooc?l001Gooooo00?o0?mVooooooooool00_ooool01ol0ofKooooooooooooo
oooo<ol0oooooolco`001?ooool00oo<o`3oooooooooo`03ooooo`03olco0?oooooooooo01Sooooo
00Go<ol0oooooooooooooooooc?o0003ooooo`?o0?oo4oooool00olc0?oooooooc<0o`02ooooo`;o
o`2I0oooool00oo<0?ooooooooooo`02ooooo`03ol`0oooooooooooo00[ooooo00?o<`3ooooooolc
0?l01_ooool00ol0ooooooooooooo`0Jooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`00
0?oooooooooo00?ooooo00?ooiT0ooooooooool01?ooool00olco`3o<`3oooooo`02ooooo`04oc<0
oooooooo<ol0olco00;ooooo00?ooiT0ooooooooool00oooool2ool003?ooooo00Co0?mVoooooooo
oooo0?mV1Oooool2olco01Gooooo00?o0?mVooooooooool00_ooool01ol0ofKooooooooooooooooo
<ol0oooooolco`001?ooool00oo<o`3oooooooooo`02ooooo`03olco0?oooooooooo01[ooooo00Co
<ol0oooooooooooo<ol06Oooool2oc<0o`?ooooo00?oo`2Iooooooooool00oooool01Oo<0?oooooo
ooooooooooooc03o00cooooo00?o<`3ooooooolc0?l08oooool00ol0003oooooooooo`02ooooo`00
4?ooool00ol0003oooooooooo`03ooooo`03oonI0?oooooooooo00Cooooo00?o<ol0oc<0ooooool0
0_ooool01?lc0?oooooooc?o0?o<o`02ooooo`03oonI0?oooooooooo00?ooooo0_oo000cooooo`04
o`3oI_ooooooooooo`3oIPKooooo00?oc?l0ooooooooool04oooool00ol0ofKoooooooooo`02oooo
o`03o`3oI_oooooooooo00;ooooo00?o<ol0ooooooooool01?ooool01Oo<o`3ooooooooooooooooo
c?l001cooooo00Co<ol0oooooooooooo<ol06Oooool2oc<0o`?ooooo00?oo`2Iooooooooool00ooo
ool01Oo<0?ooooooooooooooooooc03o00cooooo00?o<`3ooooooolc0?l08oooool00ol0003ooooo
ooooo`02ooooo`004?ooool2o`0000Cooooo00?ooiT0ooooooooool01?ooool00olco`3o<`3ooooo
o`02ooooo`04oc<0oooooooo<ol0olco00;ooooo00?ooiT0ooooooooool01?ooool00ooo003ooooo
ooooo`0booooo`03o`3oI_oooooo0?mV01cooooo00?o0?mVooooooooool00_ooool00ol0ofKooooo
ooooo`02ooooo`03oc?o0?oooooooooo00Cooooo00Goc?l0ooooooooooooooooolco000Looooo`04
oc?o0?oooooooooooc?o01Wooooo00?o<`3oooooooooool02?ooool01Oo<0?oooooooooooooooooo
c03o00cooooo0_lc0?lSooooo`;o00001?ooool0013ooooo00?o0000ooooooooool01?ooool00ooo
V@3oooooooooo`03ooooo`03oc?o0?lc0?oooooo00;ooooo00Co<`3ooooooolco`3oc?l00_ooool0
0oooV@3oooooooooo`0iooooo`03o`3oI_oooooo0?mV01cooooo00Go0?mVooooooooooooooooo`3o
IP05ooooo`03oc?o0?oooooooooo00Cooooo00Goc?l0ooooooooooooooooolco000Mooooo`;o<ol0
9_ooool01?o<0?ooooooooooooo<0?l<ooooo`03oc<0oooooooooooo02?ooooo00?o0000oooooooo
ool00_ooool0013ooooo00?o0000ooooooooool01?ooool00oooV@3oooooooooo`04ooooo`07oc?o
0?oooooooooooooooolc0?oooooooc?o0003ooooo`03oonI0?oooooooooo03Wooooo00?o0?mVoooo
ool0ofH07?ooool01Ol0ofKooooooooooooooooo0?mV00Gooooo00?o<ol0ooooooooool01Oooool0
1?o<o`3oooooooooooo<o`0Nooooo`03oc?o0?oooooooooo02Cooooo00Coc03oooooooooooooc03o
<_ooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`04ooooo`03oonI0?oo
oooooooo00Cooooo00Co<ol0oooooooooooo<`3o0_ooool01Olco`3ooooooooooooooooooiT003_o
oooo00?o0?mVooooool0ofH07?ooool01Ol0ofKooooooooooooooooo0?mV00Gooooo00?o<ol0oooo
ooooool01Oooool01?o<o`3oooooooooooo<o`15ooooo`03ol`0ooooooooc03o03?ooooo00?o0000
ooooooooool00_ooool0013ooooo0_l00006ooooo`03oonI0?oooooooooo00?ooooo00Co<ol0oooo
oooooooo<`3o0_ooool01Olco`3ooooooooooooooooooiT003_ooooo00?o0?mVooooool0ofH07Ooo
ool01?l0ofKoooooooooool0ofH=ooooo`04olco0?ooooooooooolco04Gooooo00?oc03oooooooo<
0?l0<_ooool2o`0000Cooooo000@ooooo`03o`000?oooooooooo00Gooooo00?ooiT0ooooooooool0
0oooool01_lco`3ooooooooooolc0?oooooooc?o00Cooooo00?ooiT0ooooooooool0>Oooool00ol0
ofKoooooo`3oIP0Mooooo`04o`3oI_ooooooooooo`3oIPkooooo00?oc?l0ooooooo<o`00A_ooool2
ol`0oc?ooooo00?o0000ooooooooool00_ooool000Oooooo1Ol00004ooooo`03o`000?oooooooooo
00Gooooo00?ooiT0ooooooooool00oooool01_lco`3ooooooooooolc0?oooooooc?o00Cooooo00?o
oiT0ooooooooool0>Oooool2o`3oIQkooooo00Co0?mVoooooooooooo0?mV3_ooool2olco04Oooooo
00?oc03oooooooooool0<_ooool00ol0003oooooooooo`02ooooo`002?ooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooooooo00Kooooo00?ooiT0ooooooooool00_ooool01_lco`3o<`3o
oooooolc0?oooooooc?o00Cooooo00?ooiT0ooooooooool0>_ooool00ol0ofKoooooooooo`0Moooo
o`03o`3oI_oooooo0?mV00kooooo0_o<o`1looooo`03o`000?oooooooooo00;ooooo0009ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool00oooV@3oooooooooo`02ooooo`06
oc?o0?lc0?oooooooc<0oooooooo<ol01?ooool00oooV@3oooooooooo`0jooooo`03o`3oI_oooooo
oooo01gooooo0_l0ofH@ooooo`03olco0?oooooooooo07[ooooo00?o0000ooooooooool00_ooool0
00[ooooo00?o0000ooooooooool00oooool3o`0000Kooooo00?ooiT0ooooooooool00oooool01Olc
o`3ooooooc<0oooooooo<ol000?ooooo00?ooiT0ooooooooool0>oooool00ol0ofKoooooooooo`0M
ooooo`;o0?mV4?ooool00oo<o`3oooooooooo`1hooooo`?o00001?ooool000Oooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo00Kooooo00?ooiT0ooooooooool00oooool0
1Olco`3ooooooc<0oooooooo<ol000?ooooo00?ooiT0ooooooooool0>oooool00ol0ofKooooooooo
o`0Nooooo`03o`3oI_oooooooooo08_ooooo00?o0000ooooooooool00_ooool000Oooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00Kooooo00?ooiT0ooooooooool00ooo
ool01Olco`3o<`3ooooooooooooo<ol000?ooooo00?ooiT0ooooooooool0j_ooool00ol0003ooooo
ooooo`02ooooo`002?ooool3o`0000Gooooo00?o0000ooooooooool01_ooool00oooV@3ooooooooo
o`03ooooo`04oc?o0?lc0?oooooooc?o00Cooooo00?ooiT0ooooooooool0j_ooool00ol0003ooooo
ooooo`02ooooo`004?ooool2o`0000Oooooo00?ooiT0ooooooooool00oooool01?lco`3o<`3ooooo
oolco`04ooooo`03oonI0?oooooooooo0>Wooooo0_l00004ooooo`004?ooool00ol0003ooooooooo
o`07ooooo`03oonI0?oooooooooo00;ooooo00Co<ol0oc<0oooooooo<ol01?ooool00oooV@3ooooo
ooooo`3Zooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00Oooooo00?o
oiT0ooooooooool00_ooool00olco`3ooooooc?o0005ooooo`03oonI0?oooooooooo0>[ooooo00?o
0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01oooool00oooV@3oooooooooo`03
ooooo`;o<ol01Oooool00oooV@3oooooooooo`3Zooooo`03o`000?oooooooooo00;ooooo000@oooo
o`03o`000?oooooooooo00Oooooo00?ooiT0ooooooooool00oooool2oc?o00Gooooo00?ooiT0oooo
ooooool0j_ooool00ol0003oooooooooo`02ooooo`004?ooool2o`0000Sooooo00?ooiT0oooooooo
ool00oooool00olco`3oooooooooo`03ooooo`03oonI0?oooooooooo0>[ooooo0_l00004ooooo`00
4?ooool00ol0003oooooooooo`07ooooo`03oonI0?oooooooooo00?ooooo00?o<ol0ooooooooool0
0oooool00oooV@3oooooooooo`3[ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oo
oooooooo00Oooooo00GooiT0oooooooooooooooooonI0007ooooo`03oonI0?oooooooooo0>_ooooo
00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01oooool01OooV@3ooooooooo
oooooooooiT000Oooooo00?ooiT0ooooooooool0joooool00ol0003oooooooooo`02ooooo`004?oo
ool2o`0000Sooooo00?ooiT0ooooooooool00_ooV@07ooooo`03oonI0?oooooooooo0>[ooooo0_l0
0004ooooo`004?ooool00ol0003oooooooooo`08ooooo`04oonI0?oooooooiT0oonI00Oooooo00?o
oiT0ooooooooool0joooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`08
ooooo`;ooiT000?ooooooonI0?ooool01_ooool00oooV@3oooooooooo`3[ooooo`03o`000?oooooo
oooo00;ooooo000@ooooo`03o`000?oooooooooo00Sooooo0_ooV@000ooooooooiT0ooooo`06oooo
o`03oonI0?oooooooooo0>_ooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000oooooooo
ool02?ooool2oonI0003ooooooooV@3ooooo00Kooooo00?ooiT0ooooooooool0joooool00ol0003o
ooooooooo`02ooooo`004?ooool2o`0000Wooooo00GooiT0oooooooooooooooooonI0006ooooo`03
oonI0?oooooooooo0>[ooooo0_l00004ooooo`004?ooool00ol0003oooooooooo`0<ooooo`03oonI
0?oooooooooo00?ooooo00?ooiT0ooooooooool0k?ooool00ol0003oooooooooo`02ooooo`002?oo
ool3o`0000Gooooo00?o0000ooooooooool03?ooool00oooV@3oooooooooo`03ooooo`03oonI0?oo
oooooooo0>cooooo00?o0000ooooooooool00_ooool000Oooooo00Go0000ooooooooooooooooo`00
0004ooooo`03o`000?oooooooooo00cooooo00?ooiT0ooooooooool00oooool00oooV@3ooooooooo
o`3/ooooo`03o`000?oooooooooo00;ooooo000;ooooo`03o`000?oooooooooo00;ooooo0ol0000<
ooooo`03oonI0?oooooooooo00?ooooo00?ooiT0ooooooooool0j_ooool3o`0000Cooooo0009oooo
o`;o00001Oooool00ol0003oooooooooo`0<ooooo`03oonI0?oooooooooo00?ooooo00?ooiT0oooo
ooooool0k?ooool00ol0003oooooooooo`02ooooo`002oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00cooooo00?ooiT0ooooooooool00oooool00oooV@3oooooooooo`3/ooooo`03
o`000?oooooooooo00;ooooo0007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`0<ooooo`03oonI0?oooooooooo00?ooooo00?ooiT0ooooooooool0k?ooool00ol0003o
ooooooooo`02ooooo`002?ooool3o`0000Gooooo00?o0000ooooooooool03?ooool00oooV@3ooooo
ooooo`02ooooo`03oonI0?oooooooooo0>gooooo00?o0000ooooooooool00_ooool0013ooooo0_l0
000=ooooo`03oonI0?oooooooooo00;ooooo00?ooiT0ooooooooool0k?ooool2o`0000Cooooo000@
ooooo`03o`000?oooooooooo00cooooo00?ooiT0ooooooooool00_ooool00oooV@3oooooooooo`3]
ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03o`000?oooooooooo00cooooo00?ooiT0oooo
ooooool00_ooool00oooV@3oooooooooo`3]ooooo`03o`000?oooooooooo00;ooooo000@ooooo`03
o`000?oooooooooo00gooooo00CooiT0oooooooooooooiT0l?ooool00ol0003oooooooooo`02oooo
o`004?ooool2o`0000kooooo00CooiT0oooooooooooooiT0koooool2o`0000Cooooo000@ooooo`03
o`000?oooooooooo00gooooo00CooiT0oooooooooooooiT0l?ooool00ol0003oooooooooo`02oooo
o`004?ooool00ol0003oooooooooo`0=ooooo`03oonI0?oooooooiT00?7ooooo00?o0000oooooooo
ool00_ooool0013ooooo00?o0000ooooooooool03Oooool2oonI0?;ooooo00?o0000ooooooooool0
0_ooool0013ooooo00?o0000ooooooooool03Oooool00oooV@3oooooooooo`3aooooo`03o`000?oo
oooooooo00;ooooo000@ooooo`;o0000ooooool2ooooo`;o00001?ooool0013ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02kooooo00?o0000oooo
ooooool0;oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02oooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`02ooooo`004?ooooooo`0000Ko00001?ooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-9.16135, -3.93757, \
0.404005, 0.0442805}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["(*SELEKTION AUS Z*)",
    FontColor->RGBColor[1, 0, 0]],
  "\n\nZM = Array[MISS&,{T+1,K,n}];\n\ntau1 = \
{0,.5,1,2,4,5,7,7.5,8,8.5,9,9.1,9.2,9.3,10}/DT + 1\nDo[ZM[[tau1[[i]],1]] = \
Z[[tau1[[i]],1]], {i,tau1//Length} ];\n\ntau2 = {0,1.5,7,9}/DT + 1\n\
Do[ZM[[tau2[[i]],2]] = Z[[tau2[[i]],2]], {i,tau2//Length} ];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1, 6.`, 11.`, 21.`, 41.`, 51.`, 71.`, 76.`, 81.`, 86.`, 91.`, 92.`, 
      93.`, 94.`, 101.`}\)], "Output"],

Cell[BoxData[
    \({1, 16.`, 71.`, 91.`}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["True and interpolated exogenous variables", "Subsection"],

Cell["\<\

XM=Shape[MISS,{T1,Q,n}];
tau3 = {0,15,55,90,100}+1;
Do[XM[[tau3[[i]] ]] = X[[tau3[[i]] ]],{i,5} ];

Xint       = INTERPOL[XM,MISS,0];
XintPoly   = INTERPOL[XM,MISS,1];
XintSpline = INTERPOL[XM,MISS,4];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
g1 = plot1[Xint[[T1//Range,1,{1}]] ~ii~ \
X[[T1//Range,1,{1}]]//AddTimeAxis];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.0146925 0.294376 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01469 -6 -4.5 ]
[-0.0125 .01469 0 4.5 ]
[-0.0125 .16188 -18 -4.5 ]
[-0.0125 .16188 0 4.5 ]
[-0.0125 .30907 -6 -4.5 ]
[-0.0125 .30907 0 4.5 ]
[-0.0125 .45626 -18 -4.5 ]
[-0.0125 .45626 0 4.5 ]
[-0.0125 .60344 -6 -4.5 ]
[-0.0125 .60344 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .43039 -5 -6 ]
[.97619 .43039 5 6 ]
[.97619 .14892 -5 -6 ]
[.97619 .14892 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01469 m
.00625 .01469 L
s
[(0)] -0.0125 .01469 1 0 Mshowa
0 .16188 m
.00625 .16188 L
s
[(0.5)] -0.0125 .16188 1 0 Mshowa
0 .30907 m
.00625 .30907 L
s
[(1)] -0.0125 .30907 1 0 Mshowa
0 .45626 m
.00625 .45626 L
s
[(1.5)] -0.0125 .45626 1 0 Mshowa
0 .60344 m
.00625 .60344 L
s
[(2)] -0.0125 .60344 1 0 Mshowa
.125 Mabswid
0 .04413 m
.00375 .04413 L
s
0 .07357 m
.00375 .07357 L
s
0 .10301 m
.00375 .10301 L
s
0 .13244 m
.00375 .13244 L
s
0 .19132 m
.00375 .19132 L
s
0 .22076 m
.00375 .22076 L
s
0 .25019 m
.00375 .25019 L
s
0 .27963 m
.00375 .27963 L
s
0 .33851 m
.00375 .33851 L
s
0 .36794 m
.00375 .36794 L
s
0 .39738 m
.00375 .39738 L
s
0 .42682 m
.00375 .42682 L
s
0 .48569 m
.00375 .48569 L
s
0 .51513 m
.00375 .51513 L
s
0 .54457 m
.00375 .54457 L
s
0 .57401 m
.00375 .57401 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01469 m
1 .01469 L
s
.99375 .16188 m
1 .16188 L
s
.99375 .30907 m
1 .30907 L
s
.99375 .45626 m
1 .45626 L
s
.99375 .60344 m
1 .60344 L
s
.125 Mabswid
.99625 .04413 m
1 .04413 L
s
.99625 .07357 m
1 .07357 L
s
.99625 .10301 m
1 .10301 L
s
.99625 .13244 m
1 .13244 L
s
.99625 .19132 m
1 .19132 L
s
.99625 .22076 m
1 .22076 L
s
.99625 .25019 m
1 .25019 L
s
.99625 .27963 m
1 .27963 L
s
.99625 .33851 m
1 .33851 L
s
.99625 .36794 m
1 .36794 L
s
.99625 .39738 m
1 .39738 L
s
.99625 .42682 m
1 .42682 L
s
.99625 .48569 m
1 .48569 L
s
.99625 .51513 m
1 .51513 L
s
.99625 .54457 m
1 .54457 L
s
.99625 .57401 m
1 .57401 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .43039 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .30907 m
.03333 .30907 L
.04286 .30907 L
.05238 .30907 L
.0619 .30907 L
.07143 .30907 L
.08095 .30907 L
.09048 .30907 L
.1 .30907 L
.10952 .30907 L
.11905 .30907 L
.12857 .30907 L
.1381 .30907 L
.14762 .30907 L
.15714 .30907 L
.16667 .60271 L
.17619 .60271 L
.18571 .60271 L
.19524 .60271 L
.20476 .60271 L
.21429 .60271 L
.22381 .60271 L
.23333 .60271 L
.24286 .60271 L
.25238 .60271 L
.2619 .60271 L
.27143 .60271 L
.28095 .60271 L
.29048 .60271 L
.3 .60271 L
.30952 .60271 L
.31905 .60271 L
.32857 .60271 L
.3381 .60271 L
.34762 .60271 L
.35714 .60271 L
.36667 .60271 L
.37619 .60271 L
.38571 .60271 L
.39524 .60271 L
.40476 .60271 L
.41429 .60271 L
.42381 .60271 L
.43333 .60271 L
.44286 .60271 L
.45238 .60271 L
.4619 .60271 L
.47143 .60271 L
.48095 .60271 L
.49048 .60271 L
Mistroke
.5 .60271 L
.50952 .60271 L
.51905 .60271 L
.52857 .60271 L
.5381 .60271 L
.54762 .10137 L
.55714 .10137 L
.56667 .10137 L
.57619 .10137 L
.58571 .10137 L
.59524 .10137 L
.60476 .10137 L
.61429 .10137 L
.62381 .10137 L
.63333 .10137 L
.64286 .10137 L
.65238 .10137 L
.6619 .10137 L
.67143 .10137 L
.68095 .10137 L
.69048 .10137 L
.7 .10137 L
.70952 .10137 L
.71905 .10137 L
.72857 .10137 L
.7381 .10137 L
.74762 .10137 L
.75714 .10137 L
.76667 .10137 L
.77619 .10137 L
.78571 .10137 L
.79524 .10137 L
.80476 .10137 L
.81429 .10137 L
.82381 .10137 L
.83333 .10137 L
.84286 .10137 L
.85238 .10137 L
.8619 .10137 L
.87143 .10137 L
.88095 .43039 L
.89048 .43039 L
.9 .43039 L
.90952 .43039 L
.91905 .43039 L
.92857 .43039 L
.9381 .43039 L
.94762 .43039 L
.95714 .43039 L
.96667 .43039 L
Mistroke
.97619 .43039 L
Mfstroke
0 .98 .604 r
gsave
.97619 .14892 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30907 m
.03333 .33846 L
.04286 .36755 L
.05238 .39606 L
.0619 .4237 L
.07143 .4502 L
.08095 .47529 L
.09048 .49871 L
.1 .52024 L
.10952 .53966 L
.11905 .55678 L
.12857 .57142 L
.1381 .58344 L
.14762 .59272 L
.15714 .59916 L
.16667 .60271 L
.17619 .60332 L
.18571 .60099 L
.19524 .59575 L
.20476 .58764 L
.21429 .57674 L
.22381 .56318 L
.23333 .54707 L
.24286 .52859 L
.25238 .50791 L
.2619 .48524 L
.27143 .46082 L
.28095 .43488 L
.29048 .40768 L
.3 .3795 L
.30952 .35061 L
.31905 .32131 L
.32857 .29188 L
.3381 .26263 L
.34762 .23384 L
.35714 .20581 L
.36667 .1788 L
.37619 .1531 L
.38571 .12895 L
.39524 .10661 L
.40476 .08628 L
.41429 .06819 L
.42381 .0525 L
.43333 .03937 L
.44286 .02894 L
.45238 .02131 L
.4619 .01655 L
.47143 .01472 L
.48095 .01582 L
.49048 .01986 L
Mistroke
.5 .02678 L
.50952 .03653 L
.51905 .049 L
.52857 .06407 L
.5381 .08159 L
.54762 .10137 L
.55714 .12324 L
.56667 .14696 L
.57619 .1723 L
.58571 .19901 L
.59524 .22682 L
.60476 .25544 L
.61429 .28461 L
.62381 .31402 L
.63333 .34338 L
.64286 .37239 L
.65238 .40078 L
.6619 .42825 L
.67143 .45452 L
.68095 .47935 L
.69048 .50247 L
.7 .52366 L
.70952 .54271 L
.71905 .55942 L
.72857 .57363 L
.7381 .58519 L
.74762 .594 L
.75714 .59996 L
.76667 .60302 L
.77619 .60313 L
.78571 .60031 L
.79524 .59458 L
.80476 .586 L
.81429 .57465 L
.82381 .56064 L
.83333 .54412 L
.84286 .52526 L
.85238 .50423 L
.8619 .48125 L
.87143 .45656 L
.88095 .43039 L
.89048 .403 L
.9 .37468 L
.90952 .3457 L
.91905 .31636 L
.92857 .28695 L
.9381 .25775 L
.94762 .22907 L
.95714 .20119 L
.96667 .17438 L
Mistroke
.97619 .14892 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`006_ooool2o`0002[ooooo1Ol00003ooooo`;o0000:?ooool3o`0000?ooooo0_l0000Xoooo
o`?o00001?ooool2o`0002Sooooo0ol00004ooooo`;o00009Oooool3o`0000Cooooo0_l00004oooo
o`;o00000oooool001Wooooo00Co0000oooooooooooo0000:_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0002Sooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo02Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
02Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0002Gooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo000Iooooo`04o`000?ooooooooooo`0002_ooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool0000Uooooo`Go00000_ooool01?l0003oooooooooool0000Vooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Uooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`006Oooool01?l0003oooooooooool0
000/ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`0Sooooo`04o`00
0?ooooooooooo`0000?ooooo00Co0000oooooooooooo00009_ooool4o`0000?ooooo00Co0000oooo
oooooooo00009oooool3o`0000?ooooo00Co0000oooooooooooo00009Oooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool001Wooooo
00Co0000oooooooooooo0000:Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00009_ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0002Kooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Uooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`006Oooool01?l0003oooooooooool0
000Yooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Wooooo`;o
00000oooool01?l0003oooooooooool0000Wooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00009_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
9?ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002oooo
o`006_ooool2o`0002_ooooo0ol00004ooooo`;o0000:Oooool00ol0003oooooooooo`02ooooo`;o
0000:Oooool2o`0000Cooooo0_l0000Xooooo`?o00001?ooool2o`0002Kooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00003ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`005Oooooooo`0000;o00000oooool000kooooo0_l0
0005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00Oooool000gooooo00Co0000
oooooooooooo00001?ooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo007ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo0_l0001fooooo`?o0?ZJPoooool3o`0000?ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0L_ooool3o`3jVP?ooooo0_l0
nYZ3ooooo`03o`000?oooooooooo007ooooo000=ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool0L?ooool2o`3jVPSooooo0ol0nYZ0ooooo`03o`000?oooooooooo007ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0Koooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooooooo07gooooo00?o0000ooooooooool00Oooool000kooooo0_l00005
ooooo`03o`000?oooooooooo06kooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`1m
ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06kooooo00?o0?ZJoooo
ooooool03Oooool00ol0nY[oooooooooo`1looooo`03o`000?oooooooooo007ooooo000Eooooo`03
o`000?oooooooooo06gooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`1kooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06cooooo00?o0?ZJooooooooool0
4Oooool00ol0nY[oooooooooo`1jooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000K?oo
ool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo07Sooooo0_l00003ooooo`005Oooool0
0ol0003oooooooooo`1Zooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool0N?ooool0
0ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Yooooo`03o`3jV_oooooooooo
01Kooooo00?o0?ZJooooooooool0N?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003o
ooooooooo`1Yooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0Moooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Xooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool0Moooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`1Xooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0M_ooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`1Wooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooooooool0M_ooool00ol0003oooooooooo`01ooooo`005Oooool2o`0006Sooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`1dooooo`;o00000oooool001Gooooo00?o0000oooooooo
ool0I_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo07Cooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool0IOooool00ol0nY[oooooooooo`0Oooooo`03o`3j
V_oooooooooo07?ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0IOoo
ool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo07?ooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool0I?ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooo
oooo07;ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0I?ooool00ol0
nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo07;ooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool0Hoooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo07;o
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0Hoooool00ol0nY[ooooo
ooooo`0Sooooo`03o`3jV_oooooooooo077ooooo00?o0000ooooooooool00Oooool001Gooooo0_l0
001Tooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJo`00ool00?l0DOl00?lOooooo`;o00000ooo
ool001Gooooo00?o0000ooooooooool0H_ooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooo
oooo053ooooo00?o003oooooooooool07_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0
003oooooooooo`1Rooooo`03o`3jV_oooooooooo02Cooooo00?o003oo`3jV_ooool0D?ooool00ol0
0?ooooooooooo`0Nooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo067o
oooo00?o0?ZJooooooooool09Oooool00ol00?ooooooo`3jVP1@ooooo`03o`00oooooooooooo01ko
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0HOooool00ol0nY[ooooo
ooooo`0Uooooo`03o`00oooooooo0?ZJ053ooooo00?o003oooooooooool07_ooool00ol0003ooooo
ooooo`01ooooo`005Oooool00ol0003oooooooooo`1Qooooo`03o`3jV_oooooooooo02Gooooo00Co
003ooooooooooooo0?ZJCoooool00ol00?ooooooooooo`0Nooooo`03o`000?oooooooooo007ooooo
000Eooooo`03o`000?oooooooooo063ooooo00?o0?ZJooooooooool09_ooool01?l00?oooooooooo
ool0nYY?ooooo`03o`00oooooooooooo01kooooo00?o0000ooooooooool00Oooool001Gooooo00?o
0000ooooooooool0H?ooool00ol0nY[oooooooooo`0Vooooo`05o`00ooooooooooooooooool0nYX0
C_ooool00ol00?ooooooooooo`0Nooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000HOoo
ool00ol0nY[oooooooooo`0Vooooo`05o`00ooooooooooooooooool0nYX0C_ooool00ol00?oooooo
ooooo`0Mooooo`;o00000oooool001Gooooo00?o0000ooooooooool0Goooool00ol0nY[ooooooooo
o`0Wooooo`05o`00ooooooooooooooooool0nYX0C_ooool00ol00?ooooooooooo`0Nooooo`03o`00
0?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05oooooo00?o0?ZJooooooooool09ooo
ool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo04_ooooo00?o003oooooooooool07_oo
ool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Nooooo`03o`3jV_oooooo
oooo02Sooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`1;ooooo`03o`00oooooooo
oooo01kooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0G_ooool00ol0
nY[oooooooooo`0Xooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool0Boooool00ol0
0?ooooooooooo`0Hooooo`03o`3jV_oooooooooo00?ooooo00?o0000ooooooooool00Oooool000;o
oooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo05go
oooo00?o0?ZJooooooooool0:Oooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo04_o
oooo00?o003oooooooooool06?ooool00ol0nY[oooooooooo`03ooooo`03o`000?oooooooooo007o
oooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo05gooooo00?o0?ZJooooooooool0:Oooool00ol00?ooooooooooo`03oooo
o`03o`3jV_oooooooooo04[ooooo00?o003oooooooooool05oooool00ol0nY[oooooooooo`04oooo
o`03o`000?oooooooooo007ooooo00001Ooooooo0000oooooooooooo000000_ooooo00?o0000oooo
ooooool00_ooool2o`0005gooooo00?o0?ZJooooooooool0:_ooool00ol00?ooooooooooo`03oooo
o`03o`3jV_oooooooooo04_ooooo00?o003oooooooooool05_ooool00ol0nY[oooooooooo`02oooo
o`?o00000oooool00005ooooool0003oooooooooool000002oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo05cooooo00?o0?ZJooooooooool0:_ooool00ol00?ooooooooooo`03oooo
o`03o`3jV_oooooooooo04_ooooo00?o003oooooooooool05Oooool00ol0nY[oooooooooo`05oooo
o`03o`000?oooooooooo007ooooo00001Ooooooo0000oooooooooooo000000Oooooo1?l00005oooo
o`03o`000?oooooooooo05cooooo00?o0?ZJooooooooool0:_ooool00ol00?ooooooooooo`04oooo
o`03o`3jV_oooooooooo04[ooooo00?o003oooooooooool05Oooool00ol0nY[oooooooooo`05oooo
o`03o`000?oooooooooo007ooooo00001Ooooooo0000oooooooooooo000000Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Kooooo`03o`3jV_oooooooooo02_ooooo00?o003ooooo
ooooool01?ooool00ol0nY[oooooooooo`1:ooooo`03o`00oooooooooooo01Cooooo00?o0?ZJoooo
ooooool01_ooool00ol0003oooooooooo`01ooooo`000_ooool2o`0000Sooooo1Ol00004ooooo`03
o`000?oooooooooo05_ooooo00?o0?ZJooooooooool0:oooool00ol00?ooooooooooo`04ooooo`03
o`3jV_oooooooooo04[ooooo00?o003oooooooooool05?ooool00ol0nY[oooooooooo`06ooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05_ooooo00?o0?ZJooooooooool0
:oooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo04Wooooo00?o003oooooooooool0
5?ooool00ol0nY[oooooooooo`06ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oo
oooooooo05[ooooo00?o0?ZJooooooooool0;?ooool00ol00?ooooooooooo`05ooooo`03o`3jV_oo
oooooooo04Wooooo00?o003oooooooooool04oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo007ooooo000Eooooo`03o`000?oooooooooo05[ooooo00?o0?ZJooooooooool0;?ooool0
0ol00?ooooooooooo`06ooooo`03o`3jV_oooooooooo04Sooooo00?o003oooooooooool04oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000F_ooool00ol0
nY[oooooooooo`0]ooooo`03o`00oooooooooooo00Kooooo00?o0?ZJooooooooool0B?ooool00ol0
0?ooooooooooo`0Cooooo`03o`3jV_oooooooooo00Kooooo0_l00003ooooo`005Oooool00ol0003o
ooooooooo`1Iooooo`03o`3jV_oooooooooo02gooooo00?o003oooooooooool01_ooool00ol0nY[o
ooooooooo`18ooooo`03o`00oooooooooooo01;ooooo00?o0?ZJooooooooool02?ooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Iooooo`03o`3jV_oooooooooo02gooooo
00?o003oooooooooool01oooool00ol0nY[oooooooooo`17ooooo`03o`00oooooooooooo01;ooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`1Hooooo`03o`3jV_oooooooooo02kooooo00?o003oooooooooool01oooool00ol0nY[ooooooooo
o`17ooooo`03o`00oooooooooooo01;ooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`1Hooooo`03o`3jV_oooooooooo02kooooo00?o003o
ooooooooool01oooool00ol0nY[oooooooooo`17ooooo`03o`00oooooooooooo01;ooooo00?o0?ZJ
ooooooooool02?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Hoooo
o`03o`3jV_oooooooooo02kooooo00?o003oooooooooool02?ooool00ol0nY[oooooooooo`16oooo
o`03o`00oooooooooooo017ooooo00?o0?ZJooooooooool02Oooool00ol0003oooooooooo`01oooo
o`005Oooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooooooo02oooooo00?o003ooooooooo
ool02?ooool00ol0nY[oooooooooo`16ooooo`03o`00oooooooooooo017ooooo00?o0?ZJoooooooo
ool02Oooool00ol0003oooooooooo`01ooooo`005Oooool2o`0005Sooooo00?o0?ZJooooooooool0
;oooool00ol00?ooooooooooo`08ooooo`03o`3jV_oooooooooo04Kooooo00?o003oooooooooool0
4Oooool00ol0nY[oooooooooo`08ooooo`;o00000oooool001Gooooo00?o0000ooooooooool0Eooo
ool00ol0nY[oooooooooo`0_ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJooooooooool0AOoo
ool00ol00?ooooooooooo`0@ooooo`03o`3jV_oooooooooo00[ooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool0Eoooool00ol0nY[oooooooooo`0_ooooo`03o`00oooooooo
oooo00Wooooo00?o0?ZJooooooooool0AOooool00ol00?ooooooooooo`0@ooooo`03o`3jV_oooooo
oooo00[ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`0_ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJooooooooool0AOooool00ol0
0?ooooooooooo`0@ooooo`03o`3jV_oooooooooo00[ooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`0_ooooo`03o`00oooooooooooo00_o
oooo00?o0?ZJooooooooool0A?ooool00ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo00_o
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`0_ooooo`03o`00oooooooooooo00_ooooo00?o0?ZJooooooooool0A?ooool00ol00?oooooo
ooooo`0?ooooo`03o`3jV_oooooooooo00_ooooo00?o0000ooooooooool00Oooool001Gooooo00?o
0000ooooooooool0EOooool00ol0nY[oooooooooo`0`ooooo`03o`00oooooooooooo00cooooo00?o
0?ZJooooooooool0@oooool00ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo00_ooooo00?o
0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0EOooool00ol0nY[oooooooooo`0`
ooooo`03o`00oooooooooooo00cooooo00?o0?ZJooooooooool0@oooool00ol00?ooooooooooo`0>
ooooo`03o`3jV_oooooooooo00cooooo00?o0000ooooooooool00Oooool001Gooooo0_l0001Eoooo
o`03o`3jV_oooooooooo037ooooo00?o003oooooooooool03?ooool00ol0nY[oooooooooo`13oooo
o`03o`00oooooooooooo00kooooo00?o0?ZJooooooooool02oooool2o`0000?ooooo000Eooooo`03
o`000?oooooooooo05Cooooo00?o0?ZJooooooooool0<Oooool00ol00?ooooooooooo`0=ooooo`03
o`3jV_oooooooooo04;ooooo00?o003oooooooooool03_ooool00ol0nY[oooooooooo`0<ooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05Cooooo00?o0?ZJooooooooool0
<Oooool00ol00?ooooooooooo`0=ooooo`03o`3jV_oooooooooo04;ooooo00?o003oooooooooool0
3Oooool00ol0nY[oooooooooo`0=ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oo
oooooooo05?ooooo00?o0?ZJooooooooool0<_ooool00ol00?ooooooooooo`0=ooooo`03o`3jV_oo
oooooooo04;ooooo00?o003oooooooooool03Oooool00ol0nY[oooooooooo`0=ooooo`03o`000?oo
oooooooo007ooooo000Eooooo`03o`000?oooooooooo05?ooooo00?o0?ZJooooooooool0<_ooool0
0ol00?ooooooooooo`0>ooooo`03o`3jV_oooooooooo047ooooo00?o003oooooooooool03Oooool0
0ol0nY[oooooooooo`0=ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo
05?ooooo00?o0?ZJooooooooool0<_ooool00ol00?ooooooooooo`0>ooooo`03o`3jV_oooooooooo
04;ooooo00?o003oooooooooool02oooool00ol0nY[oooooooooo`0>ooooo`03o`000?oooooooooo
007ooooo000Eooooo`03o`000?oooooooooo05;ooooo00?o0?ZJooooooooool0<oooool00ol00?oo
ooooooooo`0>ooooo`03o`3jV_oooooooooo04;ooooo00?o003oooooooooool02oooool00ol0nY[o
ooooooooo`0>ooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000Doooool00ol0nY[ooooo
ooooo`0cooooo`03o`00oooooooooooo00kooooo00?o0?ZJooooooooool0@_ooool00ol00?oooooo
ooooo`0;ooooo`03o`3jV_oooooooooo00gooooo0_l00003ooooo`005Oooool00ol0003ooooooooo
o`1Booooo`03o`3jV_oooooooooo03?ooooo00?o003oooooooooool03oooool00ol0nY[ooooooooo
o`11ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJooooooooool03oooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`1Aooooo`03o`3jV_oooooooooo03Cooooo00?o003o
ooooooooool03oooool00ol0nY[oooooooooo`11ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJ
ooooooooool03oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Aoooo
o`03o`3jV_oooooooooo03Cooooo00?o003oooooooooool03oooool00ol0nY[oooooooooo`11oooo
o`03o`00oooooooooooo00[ooooo00?o0?ZJooooooooool03oooool00ol0003oooooooooo`01oooo
o`005Oooool00ol0003oooooooooo`1Aooooo`03o`3jV_oooooooooo03Cooooo00?o003ooooooooo
ool04?ooool00ol0nY[oooooooooo`10ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJoooooooo
ool04?ooool00ol0003oooooooooo`01ooooo`003Oooool3o`0000Gooooo00?o0000ooooooooool0
D?ooool00ol0nY[oooooooooo`0eooooo`03o`00oooooooooooo013ooooo00?o0?ZJooooooooool0
@?ooool00ol00?ooooooooooo`09ooooo`03o`3jV_oooooooooo013ooooo00?o0000ooooooooool0
0Oooool000kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1@ooooo`03o`3jV_oo
oooooooo03Gooooo00?o003oooooooooool04Oooool00ol0nY[oooooooooo`0oooooo`03o`00oooo
oooooooo00Wooooo00?o0?ZJooooooooool04?ooool00ol0003oooooooooo`01ooooo`003_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo053ooooo00?o0?ZJooooooooool0=Oooool0
0ol00?ooooooooooo`0Aooooo`03o`3jV_oooooooooo03oooooo00?o003oooooooooool02?ooool0
0ol0nY[oooooooooo`0Aooooo`03o`000?oooooooooo007ooooo000>ooooo`03o`000?oooooooooo
00Cooooo0_l00004ooooo`03o`3jV_l00?oo003o023o003o:Oooool00ol0nY[oooooooooo`0foooo
o`03o`00oooooooooooo017ooooo00?o0?ZJooooooooool0?oooool00ol00?ooooooooooo`08oooo
o`03o`3jV_oooooooooo00oooooo0ol00003ooooo`003_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00?ooooo00?o0?ZJooooooooool07oooool00ol00?ooooooooooo`0Wooooo`03
o`3jV_oooooooooo03Kooooo00?o003oooooooooool04_ooool00ol0nY[oooooooooo`0nooooo`03
o`00oooooooooooo00Sooooo00?o0?ZJooooooooool04Oooool00ol0003oooooooooo`01ooooo`00
3Oooool2o`0000Kooooo00?o0000ooooooooool00oooool00ol0nY[oooooooooo`0Oooooo`03o`00
oooooooooooo02Oooooo00?o0?ZJooooooooool0=_ooool00ol00?ooooooooooo`0Booooo`03o`3j
V_oooooooooo03kooooo00?o003oooooooooool01oooool00ol0nY[oooooooooo`0Booooo`03o`00
0?oooooooooo007ooooo000>ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0nY[oooooooooo`0Nooooo`03o`00oooooooooooo02Kooooo00?o0?ZJooooooooool0=ooo
ool00ol00?ooooooooooo`0Booooo`03o`3jV_oooooooooo03kooooo00?o003oooooooooool01ooo
ool00ol0nY[oooooooooo`0Booooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooo
oooo00Cooooo00?o0?ZJooooooooool07_ooool00ol00?ooooooooooo`0Vooooo`03o`3jV_oooooo
oooo03Oooooo00?o003oooooooooool04oooool00ol0nY[oooooooooo`0mooooo`03o`00oooooooo
oooo00Oooooo00?o0?ZJooooooooool04_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0
003oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o003oooooooooool09_ooool00ol0
nY[oooooooooo`0gooooo`03o`00oooooooooooo01?ooooo00?o0?ZJooooooooool0?Oooool00ol0
0?ooooooooooo`06ooooo`03o`3jV_oooooooooo01?ooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`00oooooooooooo02Go
oooo00?o0?ZJooooooooool0>?ooool00ol00?ooooooooooo`0Cooooo`03o`3jV_oooooooooo03go
oooo00?o003oooooooooool01_ooool00ol0nY[oooooooooo`0Cooooo`03o`000?oooooooooo007o
oooo000Eooooo`;o00001_ooool00ol0nY[oooooooooo`0Mooooo`03o`00oooooooooooo02Gooooo
00?o0?ZJooooooooool0>?ooool00ol00?ooooooooooo`0Cooooo`03o`3jV_oooooooooo03gooooo
00?o003oooooooooool01_ooool00ol0nY[oooooooooo`0Booooo`;o00000oooool001Gooooo00?o
0000ooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`00oooooooooooo02Gooooo00?o
0?ZJooooooooool0>?ooool00ol00?ooooooooooo`0Dooooo`03o`3jV_oooooooooo03cooooo00?o
003oooooooooool01Oooool00ol0nY[oooooooooo`0Dooooo`03o`000?oooooooooo007ooooo000E
ooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol00?ooooooooooo`0T
ooooo`03o`3jV_oooooooooo03Wooooo00?o003oooooooooool05?ooool00ol0nY[oooooooooo`0l
ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJooooooooool05?ooool00ol0003oooooooooo`01
ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o003ooooo
ooooool09?ooool00ol0nY[oooooooooo`0iooooo`03o`00oooooooooooo01Cooooo00?o0?ZJoooo
ooooool0??ooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo01Cooooo00?o0000oooo
ooooool00Oooool001Gooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`03
o`00oooooooooooo02Cooooo00?o0?ZJooooooooool0>Oooool00ol00?ooooooooooo`0Dooooo`03
o`3jV_oooooooooo03cooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0Eooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
6oooool00ol00?ooooooooooo`0Tooooo`03o`3jV_oooooooooo03Wooooo00?o003oooooooooool0
5Oooool00ol0nY[oooooooooo`0kooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool0
5Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo01_ooooo00?o003oooooooooool08oooool00ol0nY[oooooooooo`0jooooo`03o`00oooo
oooooooo01Gooooo00?o0?ZJooooooooool0>oooool00ol00?ooooooooooo`04ooooo`03o`3jV_oo
oooooooo01Gooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool01oooool0
0ol0nY[oooooooooo`0Kooooo`03o`00oooooooooooo02?ooooo00?o0?ZJooooooooool0>_ooool0
0ol00?ooooooooooo`0Eooooo`03o`3jV_oooooooooo03_ooooo00?o003oooooooooool00oooool0
0ol0nY[oooooooooo`0Fooooo`03o`000?oooooooooo007ooooo000Eooooo`;o00002Oooool00ol0
nY[oooooooooo`0Jooooo`03o`00oooooooooooo02?ooooo00?o0?ZJooooooooool0>_ooool00ol0
0?ooooooooooo`0Fooooo`03o`3jV_oooooooooo03[ooooo00?o003oooooooooool00oooool00ol0
nY[oooooooooo`0Eooooo`;o00000oooool001Gooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`0Jooooo`03o`00oooooooooooo02?ooooo00?o0?ZJooooooooool0>_ooool00ol00?oo
ooooooooo`0Fooooo`03o`3jV_oooooooooo03[ooooo00?o003oooooooooool00oooool00ol0nY[o
ooooooooo`0Fooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool06_ooool00ol00?ooooooooooo`0Rooooo`03o`3jV_oooooooooo03_ooooo
00?o003oooooooooool05_ooool00ol0nY[oooooooooo`0jooooo`03o`00oooooooooooo00;ooooo
00?o0?ZJooooooooool05oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`09ooooo`03o`3jV_oooooooooo01Wooooo00?o003oooooooooool08_ooool00ol0nY[ooooooooo
o`0kooooo`03o`00oooooooooooo01Oooooo00?o0?ZJooooooooool0>_ooool01Ol00?oooooooooo
oooooooo0?ZJ01Wooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool02Ooo
ool00ol0nY[oooooooooo`0Iooooo`03o`00oooooooooooo02;ooooo00?o0?ZJooooooooool0>ooo
ool00ol00?ooooooooooo`0Gooooo`03o`3jV_oooooooooo03[ooooo00Go003ooooooooooooooooo
o`3jVP0Iooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00Wooooo00?o
0?ZJooooooooool06_ooool00ol00?ooooooooooo`0Pooooo`03o`3jV_oooooooooo03cooooo00?o
003oooooooooool06?ooool00ol0nY[oooooooooo`0iooooo`04o`00ooooooooooooo`3jVQ[ooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool02_ooool00ol0nY[ooooooooo
o`0Iooooo`03o`00oooooooooooo023ooooo00?o0?ZJooooooooool0??ooool00ol00?oooooooooo
o`0Hooooo`03o`3jV_oooooooooo03Wooooo00Co003ooooooooooooo0?ZJ6_ooool00ol0003ooooo
ooooo`01ooooo`005Oooool2o`0000_ooooo00?o0?ZJooooooooool06Oooool00ol00?oooooooooo
o`0Oooooo`03o`3jV_oooooooooo03gooooo00?o003oooooooooool06?ooool00ol0nY[ooooooooo
o`0iooooo`04o`00ooooooooooooo`3jVQWooooo0_l00003ooooo`005Oooool00ol0003ooooooooo
o`0:ooooo`03o`3jV_oooooooooo01Wooooo00?o003oooooooooool07oooool00ol0nY[ooooooooo
o`0mooooo`03o`00oooooooooooo01Wooooo00?o0?ZJooooooooool0>?ooool00ol00?ooooooo`3j
VP0Kooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00_ooooo00?o0?ZJ
ooooooooool06?ooool00ol00?ooooooooooo`0Oooooo`03o`3jV_oooooooooo03gooooo00?o003o
ooooooooool06Oooool00ol0nY[oooooooooo`0hooooo`03o`00oooooooo0?ZJ01_ooooo00?o0000
ooooooooool00Oooool001Gooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`0Hoooo
o`03o`00oooooooooooo01kooooo00?o0?ZJooooooooool0?_ooool00ol00?ooooooooooo`0Ioooo
o`03o`3jV_oooooooooo03Sooooo00?o003oooooool0nYX06oooool00ol0003oooooooooo`01oooo
o`005Oooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo01Oooooo00?o003ooooooooo
ool07_ooool00ol0nY[oooooooooo`0nooooo`03o`00oooooooooooo01[ooooo00?o0?ZJoooooooo
ool0=oooool00ol00?ooooooo`3jVP0Kooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`00
0?oooooooooo00cooooo00?o0?ZJooooooooool05oooool00ol00?ooooooooooo`0Nooooo`03o`3j
V_oooooooooo03kooooo00?o003oooooooooool06_ooool00ol0nY[oooooooooo`0gooooo`03o`00
ool0nY[ooooo01_ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool03?oo
ool00ol0nY[oooooooooo`0Gooooo`03o`00oooooooooooo01gooooo00?o0?ZJooooooooool0?ooo
ool00ol00?ooooooooooo`0Jooooo`03o`3jV_oooooooooo03Oooooo00?o003oo`3jV_ooool06ooo
ool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooo
oooo01Kooooo00?o003oooooooooool07Oooool00ol0nY[oooooooooo`0oooooo`03o`00oooooooo
oooo01_ooooo00?o0?ZJooooooooool0=_ooool00ol00?oo0?ZJooooo`0Kooooo`03o`000?oooooo
oooo007ooooo000Eooooo`;o00003_ooool00ol0nY[oooooooooo`0Fooooo`03o`00oooooooooooo
01gooooo00?o0?ZJooooooooool0?oooool00ol00?ooooooooooo`0Kooooo`03o`3jV_oooooooooo
03Kooooo00?o0?ZJooooooooool06_ooool2o`0000?ooooo000Eooooo`03o`000?oooooooooo00go
oooo00?o0?ZJooooooooool05_ooool00ol00?ooooooooooo`0Looooo`03o`3jV_oooooooooo043o
oooo00?o003oooooooooool06oooool00ol0nY[oooooooooo`0fooooo`03o`3jV_l00?oo003o01Ko
003o1Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0>ooooo`03o`3j
V_oooooooooo01Gooooo00?o003oooooooooool07?ooool00ol0nY[oooooooooo`10ooooo`03o`00
oooooooooooo01cooooo00?o0?ZJooooooooool0=Oooool00ol0nY[oooooooooo`0Kooooo`03o`00
0?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool05Ooo
ool00ol00?ooooooooooo`0Looooo`03o`3jV_oooooooooo043ooooo00?o003oooooooooool07?oo
ool00ol0nY[oooooooooo`0dooooo`03o`3jV_oooooooooo01cooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0Eooooo`03o`00oooooooo
oooo01_ooooo00?o0?ZJooooooooool0@Oooool00ol00?ooooooooooo`0Mooooo`03o`3jV_oooooo
oooo03?ooooo00?o0?ZJooooooooool07?ooool00ol0003oooooooooo`01ooooo`0000Coooooo`00
0?l0003o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`0?
ooooo`03o`3jV_oooooooooo01Cooooo00?o003oooooooooool06oooool00ol0nY[oooooooooo`11
ooooo`03o`00oooooooooooo01gooooo00?o0?ZJooooooooool0<_ooool00ol0nY[oooooooooo`0M
ooooo`03o`000?oooooooooo007ooooo0002ooooo`03o`000?oooooooooo00Oooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool05?ooool0
0ol00?ooooooooooo`0Jooooo`03o`3jV_oooooooooo04;ooooo00?o003oooooooooool07Oooool0
0ol0nY[oooooooooo`0booooo`03o`3jV_oooooooooo01gooooo00?o0000ooooooooool00Oooool0
00;ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00oooooo00?o0?ZJooooooooool05?ooool00ol00?ooooooooooo`0Jooooo`03o`3jV_oooooooooo
04;ooooo00?o003oooooooooool07_ooool00ol0nY[oooooooooo`0aooooo`03o`3jV_oooooooooo
01gooooo00?o0000ooooooooool00Oooool000;ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`02ooooo`;o00004Oooool00ol0nY[oooooooooo`0Cooooo`03o`00oooooooooooo01[o
oooo00?o0?ZJooooooooool0@_ooool00ol00?ooooooooooo`0Nooooo`03o`3jV_oooooooooo033o
oooo00?o0?ZJooooooooool07?ooool3o`0000?ooooo0002ooooo`03o`000?oooooooooo00Oooooo
1?l00005ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool04oooool00ol00?oooooo
ooooo`0Iooooo`03o`3jV_oooooooooo04?ooooo00?o003oooooooooool07oooool00ol0nY[ooooo
ooooo`0_ooooo`03o`3jV_oooooooooo01kooooo00?o0000ooooooooool00Oooool00003ooooool0
003o000000Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo01?ooooo00?o003oooooooooool06Oooool00ol0nY[oooooooooo`13ooooo`03o`00oooo
oooooooo01oooooo00?o0?ZJooooooooool0;_ooool00ol0nY[oooooooooo`0Oooooo`03o`000?oo
oooooooo007ooooo0002ooooo`03o`000?oooooooooo00Oooooo1Ol00004ooooo`03o`000?oooooo
oooo017ooooo00?o0?ZJooooooooool04_ooool00ol00?ooooooooooo`0Hooooo`03o`3jV_oooooo
oooo04Cooooo00?o003oooooooooool07oooool00ol0nY[oooooooooo`0^ooooo`03o`3jV_oooooo
oooo01oooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool04Oooool00ol0
nY[oooooooooo`0Booooo`03o`00oooooooooooo01Sooooo00?o0?ZJooooooooool0A?ooool00ol0
0?ooooooooooo`0Pooooo`03o`3jV_oooooooooo02gooooo00?o0?ZJooooooooool07oooool00ol0
003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01;o
oooo00?o003oooooooooool06?ooool00ol0nY[oooooooooo`14ooooo`03o`00oooooooooooo023o
oooo00?o0?ZJooooooooool0;?ooool00ol0nY[oooooooooo`0Pooooo`03o`000?oooooooooo007o
oooo000Eooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool04Oooool00ol00?oooooo
ooooo`0Gooooo`03o`3jV_oooooooooo04Cooooo00?o003oooooooooool08Oooool00ol0nY[ooooo
ooooo`0/ooooo`03o`3jV_oooooooooo023ooooo00?o0000ooooooooool00Oooool001Gooooo0_l0
000Cooooo`03o`3jV_oooooooooo017ooooo00?o003oooooooooool05oooool00ol0nY[ooooooooo
o`14ooooo`03o`00oooooooooooo02;ooooo00?o0?ZJooooooooool0:oooool00ol0nY[ooooooooo
o`0Oooooo`;o00000oooool001Gooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0@
ooooo`03o`00oooooooooooo01Oooooo00?o0?ZJooooooooool0A?ooool00ol00?ooooooooooo`0R
ooooo`03o`3jV_oooooooooo02[ooooo00?o0?ZJooooooooool08Oooool00ol0003oooooooooo`01
ooooo`005Oooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo013ooooo00?o003ooooo
ooooool05_ooool00ol0nY[oooooooooo`15ooooo`03o`00oooooooooooo02?ooooo00?o0?ZJoooo
ooooool0:Oooool00ol0nY[oooooooooo`0Qooooo`03o`000?oooooooooo007ooooo000Eooooo`03
o`000?oooooooooo01Cooooo00?o0?ZJooooooooool03oooool00ol00?ooooooooooo`0Fooooo`03
o`3jV_oooooooooo04Gooooo00?o003oooooooooool08oooool00ol0nY[oooooooooo`0Xooooo`03
o`3jV_oooooooooo02;ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0
5?ooool00ol0nY[oooooooooo`0?ooooo`03o`00oooooooooooo01Gooooo00?o0?ZJooooooooool0
A_ooool00ol00?ooooooooooo`0Tooooo`03o`3jV_oooooooooo02Oooooo00?o0?ZJooooooooool0
8_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0Eooooo`03o`3jV_oo
oooooooo00kooooo00?o003oooooooooool05Oooool00ol0nY[oooooooooo`16ooooo`03o`00oooo
oooooooo02Cooooo00?o0?ZJooooooooool09_ooool00ol0nY[oooooooooo`0Sooooo`03o`000?oo
oooooooo007ooooo000Eooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool03_ooool0
0ol00?ooooooooooo`0Dooooo`03o`3jV_oooooooooo04Oooooo00?o003oooooooooool09Oooool0
0ol0nY[oooooooooo`0Uooooo`03o`3jV_oooooooooo02?ooooo00?o0000ooooooooool00Oooool0
01Gooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`0>ooooo`03o`00oooooooooooo
01Cooooo00?o0?ZJooooooooool0Aoooool00ol00?ooooooooooo`0Uooooo`03o`3jV_oooooooooo
02Cooooo00?o0?ZJooooooooool09?ooool00ol0003oooooooooo`01ooooo`005Oooool2o`0001Oo
oooo00?o0?ZJooooooooool03Oooool00ol00?ooooooooooo`0Cooooo`03o`3jV_oooooooooo04So
oooo00?o003oooooooooool09Oooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo02?o
oooo0_l00003ooooo`005Oooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00gooooo
00?o003oooooooooool04oooool00ol0nY[oooooooooo`18ooooo`03o`00oooooooooooo02Kooooo
00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`0Tooooo`03o`000?oooooooooo007ooooo
000Eooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool03Oooool00ol00?oooooooooo
o`0Cooooo`03o`3jV_oooooooooo04Sooooo00?o003oooooooooool09_ooool00ol0nY[ooooooooo
o`0Rooooo`03o`3jV_oooooooooo02Gooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000
ooooooooool05oooool00ol0nY[oooooooooo`0<ooooo`03o`00oooooooooooo01;ooooo00?o0?ZJ
ooooooooool0BOooool00ol00?ooooooooooo`0Vooooo`03o`3jV_oooooooooo02;ooooo00?o0?ZJ
ooooooooool09Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0Hoooo
o`03o`3jV_oooooooooo00cooooo00?o003oooooooooool04Oooool00ol0nY[oooooooooo`19oooo
o`03o`00oooooooooooo02Oooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`0Voooo
o`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooooooo
ool03?ooool00ol00?ooooooooooo`0@ooooo`03o`3jV_oooooooooo04[ooooo00?o003ooooooooo
ool0:?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo02Oooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool06Oooool00ol0nY[oooooooooo`0;ooooo`03o`00
oooooooooooo013ooooo00?o0?ZJooooooooool0B_ooool00ol00?ooooooooooo`0Xooooo`03o`3j
V_oooooooooo01kooooo00?o0?ZJooooooooool09oooool00ol0003oooooooooo`01ooooo`005Ooo
ool2o`0001[ooooo00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`0@ooooo`03o`3jV_oo
oooooooo04[ooooo00?o003oooooooooool0:Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oo
oooooooo02Oooooo0_l00003ooooo`005Oooool00ol0003oooooooooo`0Jooooo`03o`3jV_oooooo
oooo00[ooooo00?o003oooooooooool03oooool00ol0nY[oooooooooo`1;ooooo`03o`00oooooooo
oooo02Wooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`0Xooooo`03o`000?oooooo
oooo007ooooo000Eooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool02_ooool00ol0
0?ooooooooooo`0?ooooo`03o`3jV_oooooooooo04_ooooo00?o003oooooooooool0:_ooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo02Wooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool06oooool00ol0nY[oooooooooo`09ooooo`03o`00oooooooooooo00ko
oooo00?o0?ZJooooooooool0C?ooool00ol00?ooooooooooo`0Zooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool0:Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo00Wooooo00?o003oooooooooool03Oooool00ol0nY[ooooo
ooooo`1=ooooo`03o`00oooooooooooo02_ooooo00?o0?ZJooooooooool06?ooool00ol0nY[ooooo
ooooo`0Zooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo01cooooo00?o
0?ZJooooooooool02?ooool00ol00?ooooooooooo`0<ooooo`03o`3jV_oooooooooo04kooooo00?o
003oooooooooool0:oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo02[ooooo00?o
0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool07Oooool00ol0nY[oooooooooo`07
ooooo`03o`00oooooooooooo00cooooo00?o0?ZJooooooooool0C_ooool00ol00?ooooooooooo`0/
ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool0:oooool00ol0003oooooooooo`01
ooooo`005Oooool00ol0003oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo00?o003ooooo
ooooool02oooool00ol0nY[oooooooooo`1?ooooo`03o`00oooooooooooo02cooooo00?o0?ZJoooo
ooooool05Oooool00ol0nY[oooooooooo`0/ooooo`03o`000?oooooooooo007ooooo000Eooooo`;o
00007oooool00ol0nY[oooooooooo`06ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJoooooooo
ool0D?ooool00ol00?ooooooooooo`0]ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJoooooooo
ool0;?ooool2o`0000?ooooo000Eooooo`03o`000?oooooooooo01oooooo00?o0?ZJooooooooool0
1Oooool00ol00?ooooooooooo`09ooooo`03o`3jV_oooooooooo057ooooo00?o003oooooooooool0
;_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo02gooooo00?o0000ooooooooool0
0Oooool001Gooooo00?o0000ooooooooool08?ooool00ol0nY[oooooooooo`04ooooo`03o`00oooo
oooooooo00Sooooo00?o0?ZJooooooooool0D_ooool00ol00?ooooooooooo`0_ooooo`03o`3jV_oo
oooooooo013ooooo00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`01ooooo`005Oooool0
0ol0003oooooooooo`0Qooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool01oooool0
0ol0nY[oooooooooo`1Cooooo`03o`00oooooooooooo033ooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo
02;ooooo00?o0?ZJooooooooool00_ooool00ol00?ooooooooooo`06ooooo`03o`3jV_oooooooooo
05Cooooo00?o003oooooooooool0<Oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo
033ooooo00?o0000ooooooooool00Oooool000cooooo1Ol00004ooooo`03o`000?oooooooooo02?o
oooo0_l0nYX2ooooo`03o`00oooooooooooo00Cooooo0_l0nYYGooooo`03o`00oooooooooooo03;o
oooo0ol0nYX9ooooo`;o0?ZJ<oooool00ol0003oooooooooo`01ooooo`003Oooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo02Gooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03
o`3jV_oooooooooo05Oooooo00?o003oooooooooool0=Oooool2o`3jVPCooooo0ol0nYXeooooo`03
o`000?oooooooooo007ooooo000>ooooo`03o`000?oooooooooo00Cooooo0_l0000Xooooo`Ko0?ZJ
Fol00?liooooo`Co0?ZJ=_ooool3o`0000?ooooo000?ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0oOooool00ol0003oooooooooo`01ooooo`003?ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo02kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`01ooooo`003?ooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`01ooooo`003Oooool3o`0000Goooooool00002o`0000?ooooo003ooooooa[ooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-11.1862, -0.221508, \
0.409622, 0.0132523}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g2 = plot1[XintPoly[[T1//Range,1,{1}]] ~ii~ \
X[[T1//Range,1,{1}]]//AddTimeAxis];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.0146925 0.294376 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01469 -6 -4.5 ]
[-0.0125 .01469 0 4.5 ]
[-0.0125 .16188 -18 -4.5 ]
[-0.0125 .16188 0 4.5 ]
[-0.0125 .30907 -6 -4.5 ]
[-0.0125 .30907 0 4.5 ]
[-0.0125 .45626 -18 -4.5 ]
[-0.0125 .45626 0 4.5 ]
[-0.0125 .60344 -6 -4.5 ]
[-0.0125 .60344 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .14892 -5 -6 ]
[.97619 .14892 5 6 ]
[.97619 .14892 -5 -6 ]
[.97619 .14892 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01469 m
.00625 .01469 L
s
[(0)] -0.0125 .01469 1 0 Mshowa
0 .16188 m
.00625 .16188 L
s
[(0.5)] -0.0125 .16188 1 0 Mshowa
0 .30907 m
.00625 .30907 L
s
[(1)] -0.0125 .30907 1 0 Mshowa
0 .45626 m
.00625 .45626 L
s
[(1.5)] -0.0125 .45626 1 0 Mshowa
0 .60344 m
.00625 .60344 L
s
[(2)] -0.0125 .60344 1 0 Mshowa
.125 Mabswid
0 .04413 m
.00375 .04413 L
s
0 .07357 m
.00375 .07357 L
s
0 .10301 m
.00375 .10301 L
s
0 .13244 m
.00375 .13244 L
s
0 .19132 m
.00375 .19132 L
s
0 .22076 m
.00375 .22076 L
s
0 .25019 m
.00375 .25019 L
s
0 .27963 m
.00375 .27963 L
s
0 .33851 m
.00375 .33851 L
s
0 .36794 m
.00375 .36794 L
s
0 .39738 m
.00375 .39738 L
s
0 .42682 m
.00375 .42682 L
s
0 .48569 m
.00375 .48569 L
s
0 .51513 m
.00375 .51513 L
s
0 .54457 m
.00375 .54457 L
s
0 .57401 m
.00375 .57401 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01469 m
1 .01469 L
s
.99375 .16188 m
1 .16188 L
s
.99375 .30907 m
1 .30907 L
s
.99375 .45626 m
1 .45626 L
s
.99375 .60344 m
1 .60344 L
s
.125 Mabswid
.99625 .04413 m
1 .04413 L
s
.99625 .07357 m
1 .07357 L
s
.99625 .10301 m
1 .10301 L
s
.99625 .13244 m
1 .13244 L
s
.99625 .19132 m
1 .19132 L
s
.99625 .22076 m
1 .22076 L
s
.99625 .25019 m
1 .25019 L
s
.99625 .27963 m
1 .27963 L
s
.99625 .33851 m
1 .33851 L
s
.99625 .36794 m
1 .36794 L
s
.99625 .39738 m
1 .39738 L
s
.99625 .42682 m
1 .42682 L
s
.99625 .48569 m
1 .48569 L
s
.99625 .51513 m
1 .51513 L
s
.99625 .54457 m
1 .54457 L
s
.99625 .57401 m
1 .57401 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .14892 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .30907 m
.03333 .32864 L
.04286 .34822 L
.05238 .3678 L
.0619 .38737 L
.07143 .40695 L
.08095 .42652 L
.09048 .4461 L
.1 .46568 L
.10952 .48525 L
.11905 .50483 L
.12857 .5244 L
.1381 .54398 L
.14762 .56356 L
.15714 .58313 L
.16667 .60271 L
.17619 .59017 L
.18571 .57764 L
.19524 .56511 L
.20476 .55257 L
.21429 .54004 L
.22381 .52751 L
.23333 .51497 L
.24286 .50244 L
.25238 .48991 L
.2619 .47737 L
.27143 .46484 L
.28095 .45231 L
.29048 .43977 L
.3 .42724 L
.30952 .41471 L
.31905 .40217 L
.32857 .38964 L
.3381 .37711 L
.34762 .36457 L
.35714 .35204 L
.36667 .33951 L
.37619 .32697 L
.38571 .31444 L
.39524 .30191 L
.40476 .28937 L
.41429 .27684 L
.42381 .26431 L
.43333 .25177 L
.44286 .23924 L
.45238 .22671 L
.4619 .21417 L
.47143 .20164 L
.48095 .18911 L
.49048 .17657 L
Mistroke
.5 .16404 L
.50952 .15151 L
.51905 .13897 L
.52857 .12644 L
.5381 .11391 L
.54762 .10137 L
.55714 .11077 L
.56667 .12018 L
.57619 .12958 L
.58571 .13898 L
.59524 .14838 L
.60476 .15778 L
.61429 .16718 L
.62381 .17658 L
.63333 .18598 L
.64286 .19538 L
.65238 .20478 L
.6619 .21418 L
.67143 .22358 L
.68095 .23298 L
.69048 .24238 L
.7 .25178 L
.70952 .26118 L
.71905 .27058 L
.72857 .27998 L
.7381 .28938 L
.74762 .29878 L
.75714 .30818 L
.76667 .31758 L
.77619 .32698 L
.78571 .33638 L
.79524 .34578 L
.80476 .35518 L
.81429 .36458 L
.82381 .37398 L
.83333 .38338 L
.84286 .39278 L
.85238 .40219 L
.8619 .41159 L
.87143 .42099 L
.88095 .43039 L
.89048 .40224 L
.9 .37409 L
.90952 .34595 L
.91905 .3178 L
.92857 .28965 L
.9381 .26151 L
.94762 .23336 L
.95714 .20521 L
.96667 .17707 L
Mistroke
.97619 .14892 L
Mfstroke
0 .98 .604 r
gsave
.97619 .14892 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30907 m
.03333 .33846 L
.04286 .36755 L
.05238 .39606 L
.0619 .4237 L
.07143 .4502 L
.08095 .47529 L
.09048 .49871 L
.1 .52024 L
.10952 .53966 L
.11905 .55678 L
.12857 .57142 L
.1381 .58344 L
.14762 .59272 L
.15714 .59916 L
.16667 .60271 L
.17619 .60332 L
.18571 .60099 L
.19524 .59575 L
.20476 .58764 L
.21429 .57674 L
.22381 .56318 L
.23333 .54707 L
.24286 .52859 L
.25238 .50791 L
.2619 .48524 L
.27143 .46082 L
.28095 .43488 L
.29048 .40768 L
.3 .3795 L
.30952 .35061 L
.31905 .32131 L
.32857 .29188 L
.3381 .26263 L
.34762 .23384 L
.35714 .20581 L
.36667 .1788 L
.37619 .1531 L
.38571 .12895 L
.39524 .10661 L
.40476 .08628 L
.41429 .06819 L
.42381 .0525 L
.43333 .03937 L
.44286 .02894 L
.45238 .02131 L
.4619 .01655 L
.47143 .01472 L
.48095 .01582 L
.49048 .01986 L
Mistroke
.5 .02678 L
.50952 .03653 L
.51905 .049 L
.52857 .06407 L
.5381 .08159 L
.54762 .10137 L
.55714 .12324 L
.56667 .14696 L
.57619 .1723 L
.58571 .19901 L
.59524 .22682 L
.60476 .25544 L
.61429 .28461 L
.62381 .31402 L
.63333 .34338 L
.64286 .37239 L
.65238 .40078 L
.6619 .42825 L
.67143 .45452 L
.68095 .47935 L
.69048 .50247 L
.7 .52366 L
.70952 .54271 L
.71905 .55942 L
.72857 .57363 L
.7381 .58519 L
.74762 .594 L
.75714 .59996 L
.76667 .60302 L
.77619 .60313 L
.78571 .60031 L
.79524 .59458 L
.80476 .586 L
.81429 .57465 L
.82381 .56064 L
.83333 .54412 L
.84286 .52526 L
.85238 .50423 L
.8619 .48125 L
.87143 .45656 L
.88095 .43039 L
.89048 .403 L
.9 .37468 L
.90952 .3457 L
.91905 .31636 L
.92857 .28695 L
.9381 .25775 L
.94762 .22907 L
.95714 .20119 L
.96667 .17438 L
Mistroke
.97619 .14892 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`006_ooool2o`0002[ooooo1Ol00003ooooo`;o0000:?ooool3o`0000?ooooo0_l0000Xoooo
o`?o00001?ooool2o`0002Sooooo0ol00004ooooo`;o00009Oooool3o`0000Cooooo0_l00004oooo
o`;o00000oooool001Wooooo00Co0000oooooooooooo0000:_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0002Sooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo02Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
02Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0002Gooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo000Iooooo`04o`000?ooooooooooo`0002_ooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool0000Uooooo`Go00000_ooool01?l0003oooooooooool0000Vooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Uooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`006Oooool01?l0003oooooooooool0
000/ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`0Sooooo`04o`00
0?ooooooooooo`0000?ooooo00Co0000oooooooooooo00009_ooool4o`0000?ooooo00Co0000oooo
oooooooo00009oooool3o`0000?ooooo00Co0000oooooooooooo00009Oooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool001Wooooo
00Co0000oooooooooooo0000:Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00009_ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0002Kooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool0000Vooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool0000Uooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`006Oooool01?l0003oooooooooool0
000Yooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Wooooo`;o
00000oooool01?l0003oooooooooool0000Wooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00009_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
9?ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002oooo
o`006_ooool2o`0002_ooooo0ol00004ooooo`;o0000:Oooool00ol0003oooooooooo`02ooooo`;o
0000:Oooool2o`0000Cooooo0_l0000Xooooo`?o00001?ooool2o`0002Kooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00003ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`005Oooooooo`0000;o00000oooool000kooooo0_l0
0005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00Oooool000gooooo00Co0000
oooooooooooo00001?ooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo007ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo0_l0001fooooo`?o0?ZJPoooool3o`0000?ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0L_ooool3o`3jVP?ooooo0_l0
nYZ3ooooo`03o`000?oooooooooo007ooooo000=ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool0L?ooool2o`3jVPSooooo0ol0nYZ0ooooo`03o`000?oooooooooo007ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0Koooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooooooo07gooooo00?o0000ooooooooool00Oooool000kooooo0_l00005
ooooo`03o`000?oooooooooo06kooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`1m
ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06kooooo00?o0?ZJoooo
ooooool03Oooool00ol0nY[oooooooooo`1looooo`03o`000?oooooooooo007ooooo000Eooooo`03
o`000?oooooooooo06gooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`1kooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06cooooo00?o0?ZJooooooooool0
4Oooool00ol0nY[oooooooooo`1jooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000K?oo
ool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo07Sooooo0_l00003ooooo`005Oooool0
0ol0003oooooooooo`1Zooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool0N?ooool0
0ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Yooooo`03o`3jV_oooooooooo
01Kooooo00?o0?ZJooooooooool0N?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003o
ooooooooo`1Yooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0Moooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Xooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool0Moooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`1Xooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0M_ooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`1Wooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooooooool0M_ooool00ol0003oooooooooo`01ooooo`005Oooool2o`0006Sooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`1dooooo`;o00000oooool001Gooooo00?o0000oooooooo
ool0I_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo07Cooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool0IOooool00ol0nY[oooooooooo`0Oooooo`03o`3j
V_oooooooooo07?ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0IOoo
ool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo07?ooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool0I?ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooo
oooo07;ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0I?ooool00ol0
nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo07;ooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool0Hoooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo07;o
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0Hoooool00ol0nY[ooooo
ooooo`0Sooooo`03o`3jV_oooooooooo077ooooo00?o0000ooooooooool00Oooool001Gooooo0_l0
001Tooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJo`00ooooool0L?ooool2o`0000?ooooo000E
ooooo`03o`000?oooooooooo06;ooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooo`00o`1a
ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06;ooooo00?o0?ZJoooo
ooooool08oooool01Ol00?ooooooo`3jV_oooooo003o073ooooo00?o0000ooooooooool00Oooool0
01Gooooo00?o0000ooooooooool0HOooool00ol0nY[oooooooooo`0Sooooo`07o`00oooooooooooo
ooooool0nY[oooooo`00o`1_ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooo
oooo067ooooo00?o0?ZJooooooooool08_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_oooooo
ooooo`00ofkooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0HOooool0
0ol0nY[oooooooooo`0Qooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooool00?l0K_ooool0
0ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Pooooo`03o`3jV_oooooooooo
027ooooo00?o003oooooooooool01Oooool01?l0nY[oooooooooool00?m]ooooo`03o`000?oooooo
oooo007ooooo000Eooooo`03o`000?oooooooooo063ooooo00?o0?ZJooooooooool08Oooool00ol0
0?ooooooooooo`06ooooo`03o`3jV_oooooooooo00;o003oJoooool00ol0003oooooooooo`01oooo
o`005Oooool2o`00067ooooo00?o0?ZJooooooooool08?ooool00ol00?ooooooooooo`07ooooo`03
o`3jV_oooooooooo00;ooooo00?o003oooooooooool0Ioooool2o`0000?ooooo000Eooooo`03o`00
0?oooooooooo05oooooo00?o0?ZJooooooooool08?ooool00ol00?ooooooooooo`08ooooo`03o`3j
V_oooooooooo00?ooooo00?o003oooooooooool0Ioooool00ol0003oooooooooo`01ooooo`005Ooo
ool00ol0003oooooooooo`1Oooooo`03o`3jV_oooooooooo01oooooo00?o003oooooooooool02_oo
ool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo06Oooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool0G_ooool00ol0nY[oooooooooo`0Oooooo`03o`00oooooooo
oooo00_ooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`1Vooooo`03o`000?oooooo
oooo007ooooo000Eooooo`03o`000?oooooooooo05kooooo00?o0?ZJooooooooool07_ooool00ol0
0?ooooooooooo`0<ooooo`03o`3jV_oooooooooo00Cooooo0_l00?mPooooo`03o`3jV_oooooooooo
00?ooooo00?o0000ooooooooool00Oooool000;ooooo0_l00004ooooo`03o`000?oooooooooo00;o
oooo0ol00005ooooo`03o`000?oooooooooo05gooooo00?o0?ZJooooooooool07oooool00ol00?oo
ooooooooo`0<ooooo`03o`3jV_oooooooooo00Kooooo00?o003oooooooooool0GOooool00ol0nY[o
ooooooooo`03ooooo`03o`000?oooooooooo007ooooo00001Ooooooo0000oooooooooooo000000Oo
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo05gooooo00?o0?ZJoooo
ooooool07_ooool00ol00?ooooooooooo`0>ooooo`03o`3jV_oooooooooo00Kooooo00?o003ooooo
ooooool0Foooool00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo007ooooo00001Ooooooo
0000oooooooooooo000000_ooooo00?o0000ooooooooool00_ooool2o`0005gooooo00?o0?ZJoooo
ooooool07oooool00ol00?ooooooooooo`0>ooooo`03o`3jV_oooooooooo00Oooooo00?o003ooooo
ooooool0F_ooool00ol0nY[oooooooooo`02ooooo`?o00000oooool00005ooooool0003ooooooooo
ool000002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05cooooo00?o0?ZJoooo
ooooool07_ooool00ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo00Sooooo00?o003ooooo
ooooool0F?ooool00ol0nY[oooooooooo`05ooooo`03o`000?oooooooooo007ooooo00001Ooooooo
0000oooooooooooo000000Oooooo1?l00005ooooo`03o`000?oooooooooo05cooooo00?o0?ZJoooo
ooooool07Oooool00ol00?ooooooooooo`0Aooooo`03o`3jV_oooooooooo00Sooooo00?o003ooooo
ooooool0Eoooool00ol0nY[oooooooooo`05ooooo`03o`000?oooooooooo007ooooo00001Ooooooo
0000oooooooooooo000000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Koooo
o`03o`3jV_oooooooooo01gooooo00?o003oooooooooool04_ooool00ol0nY[oooooooooo`09oooo
o`03o`00oooooooooooo05Gooooo00?o0?ZJo`00ooooool01_ooool00ol0003oooooooooo`01oooo
o`000_ooool2o`0000Sooooo1Ol00004ooooo`03o`000?oooooooooo05_ooooo00?o0?ZJoooooooo
ool07?ooool00ol00?ooooooooooo`0Cooooo`03o`3jV_oooooooooo00[ooooo00?o003ooooooooo
ool0E?ooool00ol0nY[oooooooooo`06ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`00
0?oooooooooo05_ooooo00?o0?ZJooooooooool07?ooool00ol00?ooooooooooo`0Dooooo`03o`3j
V_oooooooooo00[ooooo00?o003oooooooooool0Doooool00ol0nY[oooooooooo`06ooooo`03o`00
0?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05[ooooo00?o0?ZJooooooooool07?oo
ool00ol00?ooooooooooo`0Eooooo`03o`3jV_oooooooooo00_ooooo00?o003oooooooooool0DOoo
ool00ol0nY[o003oooooo`07ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooo
oooo05[ooooo00?o0?ZJooooooooool06oooool00ol00?ooooooooooo`0Gooooo`03o`3jV_oooooo
oooo00[ooooo00?o003oooooooooool0DOooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo007ooooo000Eooooo`;o0000F_ooool00ol0nY[oooooooooo`0Looooo`03o`00oooooooooooo
01Oooooo00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`1@ooooo`03o`3jV_oooooooooo
00Kooooo0_l00003ooooo`005Oooool00ol0003oooooooooo`1Iooooo`03o`3jV_oooooooooo01_o
oooo00?o003oooooooooool06?ooool00ol0nY[oooooooooo`0<ooooo`;o003oCoooool00ol0nY[o
003oooooo`08ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05Wooooo
00?o0?ZJooooooooool06_ooool00ol00?ooooooooooo`0Jooooo`03o`3jV_oooooooooo00gooooo
00?o003oooooooooool0C?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo007ooooo
000Eooooo`03o`000?oooooooooo05Sooooo00?o0?ZJooooooooool06_ooool00ol00?oooooooooo
o`0Kooooo`03o`3jV_oooooooooo00kooooo00?o003oooooooooool0Boooool00ol0nY[ooooooooo
o`08ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05Sooooo00?o0?ZJ
ooooooooool06Oooool00ol00?ooooooooooo`0Looooo`03o`3jV_oooooooooo00oooooo00?o003o
ooooooooool0B_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo007ooooo000Eoooo
o`03o`000?oooooooooo05Sooooo00?o0?ZJooooooooool06?ooool00ol00?ooooooooooo`0Noooo
o`03o`3jV_oooooooooo00oooooo00?o003oooooooooool0B?ooool00ol0nY[o003oooooo`09oooo
o`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05Oooooo00?o0?ZJoooooooo
ool06Oooool00ol00?ooooooooooo`0Nooooo`03o`3jV_oooooooooo013ooooo00?o003ooooooooo
ool0Aoooool00ol0nY[oooooooooo`09ooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000
F?ooool00ol0nY[oooooooooo`0Hooooo`03o`00oooooooooooo01oooooo00?o0?ZJooooooooool0
4Oooool00ol00?ooooooooooo`16ooooo`03o`3jV_oooooooooo00Sooooo0_l00003ooooo`005Ooo
ool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooooooo01Sooooo00?o003oooooooooool08?oo
ool00ol0nY[oooooooooo`0Aooooo`03o`00oooooooooooo04Cooooo00?o0?ZJo`00ooooool02_oo
ool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooo
oooo01Oooooo00?o003oooooooooool08Oooool00ol0nY[oooooooooo`0Booooo`03o`00oooooooo
oooo04?ooooo00?o0?ZJooooooooool02_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0
003oooooooooo`1Fooooo`03o`3jV_oooooooooo01Oooooo00?o003oooooooooool08_ooool00ol0
nY[oooooooooo`0Cooooo`03o`00oooooooooooo04;ooooo00?o0?ZJooooooooool02_ooool00ol0
003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo01Ko
oooo00?o003oooooooooool09?ooool00ol0nY[oooooooooo`0Cooooo`03o`00oooooooooooo043o
oooo00?o0?ZJo`00ooooool02oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo01Gooooo00?o003oooooooooool09Oooool00ol0nY[ooooo
ooooo`0Dooooo`03o`00oooooooooooo03oooooo00?o0?ZJooooooooool02oooool00ol0003ooooo
ooooo`01ooooo`005Oooool00ol0003oooooooooo`1Eooooo`03o`3jV_oooooooooo01Kooooo00?o
003oooooooooool09_ooool00ol0nY[oooooooooo`0Dooooo`03o`00oooooooooooo03kooooo00?o
0?ZJooooooooool02oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1E
ooooo`03o`3jV_oooooooooo01Gooooo00?o003oooooooooool09oooool00ol0nY[oooooooooo`0E
ooooo`03o`00oooooooooooo03cooooo00?o0?ZJo`00ooooool03?ooool00ol0003oooooooooo`01
ooooo`005Oooool2o`0005Gooooo00?o0?ZJooooooooool05Oooool00ol00?ooooooooooo`0Xoooo
o`03o`3jV_oooooooooo01Kooooo00?o003oooooooooool0>oooool00ol0nY[oooooooooo`0;oooo
o`;o00000oooool001Gooooo00?o0000ooooooooool0E?ooool00ol0nY[oooooooooo`0Dooooo`03
o`00oooooooooooo02[ooooo00?o0?ZJooooooooool05_ooool00ol00?ooooooooooo`0jooooo`03
o`3jV_oooooooooo00cooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0
E?ooool00ol0nY[oooooooooo`0Cooooo`03o`00oooooooooooo02_ooooo00?o0?ZJooooooooool0
5oooool00ol00?ooooooooooo`0hooooo`03o`3jV_l00?oooooo00gooooo00?o0000ooooooooool0
0Oooool001Gooooo00?o0000ooooooooool0Doooool00ol0nY[oooooooooo`0Cooooo`03o`00oooo
oooooooo02cooooo00?o0?ZJooooooooool06?ooool00ol00?ooooooooooo`0gooooo`03o`3jV_oo
oooooooo00gooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0Doooool0
0ol0nY[oooooooooo`0Cooooo`03o`00oooooooooooo02gooooo00?o0?ZJooooooooool06?ooool0
0ol00?ooooooooooo`0fooooo`03o`3jV_oooooooooo00gooooo00?o0000ooooooooool00Oooool0
01Gooooo00?o0000ooooooooool0Doooool00ol0nY[oooooooooo`0Booooo`03o`00oooooooooooo
02kooooo00?o0?ZJooooooooool06Oooool00ol00?ooooooooooo`0dooooo`03o`3jV_l00?oooooo
00kooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0D_ooool00ol0nY[o
ooooooooo`0Cooooo`03o`00oooooooooooo02kooooo00?o0?ZJooooooooool06_ooool00ol00?oo
ooooooooo`0cooooo`03o`3jV_oooooooooo00kooooo00?o0000ooooooooool00Oooool001Gooooo
0_l0001Cooooo`03o`3jV_oooooooooo01;ooooo00?o003oooooooooool0;oooool00ol0nY[ooooo
ooooo`0Kooooo`03o`00oooooooooooo03;ooooo00?o0?ZJooooooooool03Oooool2o`0000?ooooo
000Eooooo`03o`000?oooooooooo05;ooooo00?o0?ZJooooooooool04Oooool00ol00?oooooooooo
o`0aooooo`03o`3jV_oooooooooo01_ooooo00?o003oooooooooool0<?ooool00ol0nY[o003ooooo
o`0?ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo057ooooo00?o0?ZJ
ooooooooool04Oooool00ol00?ooooooooooo`0booooo`03o`3jV_oooooooooo01cooooo00?o003o
ooooooooool0;oooool00ol0nY[oooooooooo`0?ooooo`03o`000?oooooooooo007ooooo000Eoooo
o`03o`000?oooooooooo057ooooo00?o0?ZJooooooooool04?ooool00ol00?ooooooooooo`0coooo
o`03o`3jV_oooooooooo01gooooo00?o003oooooooooool0;_ooool00ol0nY[oooooooooo`0?oooo
o`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo057ooooo00?o0?ZJoooooooo
ool04?ooool00ol00?ooooooooooo`0dooooo`03o`3jV_oooooooooo01gooooo00?o003ooooooooo
ool0;?ooool00ol0nY[o003oooooo`0@ooooo`03o`000?oooooooooo007ooooo000=ooooo`?o0000
1Oooool00ol0003oooooooooo`1@ooooo`03o`3jV_oooooooooo013ooooo00?o003oooooooooool0
=Oooool00ol0nY[oooooooooo`0Nooooo`03o`00oooooooooooo02_ooooo00?o0?ZJooooooooool0
4?ooool00ol0003oooooooooo`01ooooo`003_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo053ooooo00?o0?ZJooooooooool03oooool00ol00?ooooooooooo`0gooooo`03o`3jV_oo
oooooooo01kooooo00?o003oooooooooool0:_ooool00ol0nY[oooooooooo`0@ooooo`03o`000?oo
oooooooo007ooooo000>ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0D?ooool0
0ol0nY[oooooooooo`0?ooooo`03o`00oooooooooooo03Oooooo00?o0?ZJooooooooool07oooool0
0ol00?ooooooooooo`0Xooooo`03o`3jV_oooooooooo017ooooo00?o0000ooooooooool00Oooool0
00kooooo00?o0000ooooooooool01?ooool2o`0000Cooooo00?o0?ZJooooooooool0BOooool00ol0
nY[oooooooooo`0?ooooo`03o`00oooooooooooo03Sooooo00?o0?ZJooooooooool08?ooool00ol0
0?ooooooooooo`0Wooooo`03o`3jV_oooooooooo00oooooo0ol00003ooooo`003_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool0BOooool00ol0nY[o
ooooooooo`0>ooooo`03o`00oooooooooooo03[ooooo00?o0?ZJooooooooool08?ooool00ol00?oo
ooooooooo`0Vooooo`03o`3jV_oooooooooo017ooooo00?o0000ooooooooool00Oooool000gooooo
0_l00006ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJo`00ooooool0BOooool00ol0nY[ooooo
ooooo`0=ooooo`03o`00oooooooooooo03_ooooo00?o0?ZJooooooooool08Oooool2o`00obGooooo
00?o0?ZJooooooooool04_ooool00ol0003oooooooooo`01ooooo`003_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo00?o0?ZJooooooooool0Aoooool00ol0nY[ooooooooo
o`0=ooooo`03o`00oooooooooooo03cooooo00?o0?ZJooooooooool08oooool00ol00?oooooooooo
o`0Rooooo`03o`3jV_oooooooooo01;ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000
ooooooooool01?ooool00ol0nY[oooooooooo`17ooooo`03o`3jV_oooooooooo00cooooo00?o003o
ooooooooool0?_ooool00ol0nY[oooooooooo`0Sooooo`03o`00oooooooooooo027ooooo00?o0?ZJ
ooooooooool04_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`04oooo
o`03o`3jV_l00?oooooo04Oooooo00?o0?ZJooooooooool03?ooool00ol00?ooooooooooo`0noooo
o`03o`3jV_oooooooooo02?ooooo00?o003oooooooooool08?ooool00ol0nY[oooooooooo`0Coooo
o`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooooooo
ool0AOooool00ol0nY[oooooooooo`0<ooooo`03o`00oooooooooooo03oooooo00?o0?ZJoooooooo
ool09?ooool00ol00?ooooooooooo`0Oooooo`03o`3jV_oooooooooo01?ooooo00?o0000oooooooo
ool00Oooool001Gooooo0_l00006ooooo`03o`3jV_l00?oooooo04Gooooo00?o0?ZJooooooooool0
3?ooool00ol00?ooooooooooo`0oooooo`03o`3jV_oooooooooo02Gooooo0_l00?lOooooo`03o`3j
V_oooooooooo01;ooooo0_l00003ooooo`005Oooool00ol0003oooooooooo`05ooooo`03o`3jV_oo
oooo003o04Gooooo00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`11ooooo`03o`3jV_oo
oooooooo02Kooooo00?o003oooooooooool06oooool00ol0nY[oooooooooo`0Dooooo`03o`000?oo
oooooooo007ooooo000Eooooo`03o`000?oooooooooo00Kooooo00?o0?ZJo`00ooooool0@oooool0
0ol0nY[oooooooooo`0;ooooo`03o`00oooooooooooo04;ooooo00?o0?ZJooooooooool09oooool0
0ol00?ooooooooooo`0Jooooo`03o`3jV_oooooooooo01Cooooo00?o0000ooooooooool00Oooool0
01Gooooo00?o0000ooooooooool01_ooool00ol0nY[oooooo`00o`13ooooo`03o`3jV_oooooooooo
00[ooooo00?o003oooooooooool0@oooool00ol0nY[oooooooooo`0Wooooo`03o`00oooooooooooo
01[ooooo00?o0?ZJooooooooool05?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003o
ooooooooo`06ooooo`03o`3jV_oooooo003o04?ooooo00?o0?ZJooooooooool02Oooool00ol00?oo
ooooooooo`14ooooo`03o`3jV_oooooooooo02Sooooo00?o003oooooooooool06?ooool00ol0nY[o
ooooooooo`0Eooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00Oooooo
00?o0?ZJooooool00?l0@_ooool00ol0nY[oooooooooo`09ooooo`03o`00oooooooooooo04Gooooo
00?o0?ZJooooooooool0:?ooool00ol00?ooooooooooo`0Gooooo`03o`3jV_oooooooooo01Gooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool01oooool00ol0nY[oooooo`00
o`11ooooo`03o`3jV_oooooooooo00Wooooo00?o003oooooooooool0A_ooool00ol0nY[ooooooooo
o`0Yooooo`03o`00oooooooooooo01Gooooo00?o003oo`3jV_ooool05_ooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo003o047ooooo00?o0?ZJ
ooooooooool02?ooool00ol00?ooooooooooo`17ooooo`03o`3jV_oooooooooo02[ooooo0_l00?lE
ooooo`03o`3jV_oooooooooo01Kooooo00?o0000ooooooooool00Oooool001Gooooo0_l00009oooo
o`03o`3jV_oooooo003o043ooooo00?o0?ZJooooooooool01oooool00ol00?ooooooooooo`19oooo
o`03o`3jV_oooooooooo02_ooooo00?o003oooooooooool04_ooool00ol0nY[oooooooooo`0Eoooo
o`;o00000oooool001Gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooo`00o`10ooooo`03
o`3jV_oooooooooo00Kooooo00?o003oooooooooool0B_ooool00ol0nY[oooooooooo`0/ooooo`03
o`00oooooooooooo013ooooo00?o003oo`3jV_ooool05oooool00ol0003oooooooooo`01ooooo`00
5Oooool00ol0003oooooooooo`08ooooo`04o`3jV_ooooooooooo`00ockooooo00?o0?ZJoooooooo
ool01_ooool00ol00?ooooooooooo`1;ooooo`03o`3jV_oooooooooo02cooooo00?o003ooooooooo
ool04?ooool00ol0nY[oooooooooo`0Gooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`00
0?oooooooooo00Wooooo00Co0?ZJoooooooooooo003o?Oooool00ol0nY[oooooooooo`06ooooo`03
o`00oooooooooooo04cooooo00?o0?ZJooooooooool0;?ooool00ol00?ooooooooooo`0?ooooo`03
o`3jV_oooooooooo01Oooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0
2Oooool01?l0nY[oooooooooool00?lmooooo`03o`3jV_oooooooooo00Gooooo00?o003ooooooooo
ool0COooool00ol0nY[oooooooooo`0]ooooo`;o003o3_ooool00ol00?oo0?ZJooooo`0Hooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00Wooooo00Go0?ZJoooooooooooo
ooooo`00o`0kooooo`03o`3jV_oooooooooo00Gooooo00?o003oooooooooool0Coooool00ol0nY[o
ooooooooo`0^ooooo`03o`00oooooooooooo00_ooooo00?o0?ZJooooooooool06?ooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0:ooooo`04o`3jV_ooooooooooo`00oc_o
oooo00?o0?ZJooooooooool01Oooool00ol00?ooooooooooo`1?ooooo`03o`3jV_oooooooooo02oo
oooo00?o003oooooooooool02_ooool00ol0nY[oooooooooo`0Hooooo`03o`000?oooooooooo007o
oooo000Eooooo`;o00002oooool01Ol0nY[ooooooooooooooooo003o03Wooooo00?o0?ZJoooooooo
ool01Oooool00ol00?ooooooooooo`1@ooooo`03o`3jV_oooooooooo02oooooo00?o003ooooooooo
ool02_ooool00ol0nY[oooooooooo`0Gooooo`;o00000oooool001Gooooo00?o0000ooooooooool0
2_ooool01Ol0nY[ooooooooooooooooo003o03Wooooo00?o0?ZJooooooooool01?ooool00ol00?oo
ooooooooo`1Booooo`03o`3jV_oooooooooo02oooooo00?o003oooooooooool02?ooool00ol0nY[o
ooooooooo`0Iooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00_ooooo
00Co0?ZJoooooooooooo003o>Oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo05?o
oooo00?o0?ZJooooooooool0<?ooool2o`00o`Sooooo00?o0?ZJooooooooool06Oooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0;ooooo`05o`3jV_ooooooooooooooool0
0?l0=oooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo05?ooooo00?o0?ZJoooooooo
ool0<_ooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo01Wooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool03?ooool01?l0nY[oooooooooool00?lgooooo`03
o`3jV_oooooooooo00?ooooo00?o003oooooooooool0EOooool00ol0nY[oooooooooo`0booooo`03
o`00oooooooooooo00Cooooo00?o0?ZJooooooooool06Oooool00ol0003oooooooooo`01ooooo`00
5Oooool00ol0003oooooooooo`0<ooooo`05o`3jV_ooooooooooooooool00?l0=_ooool00ol0nY[o
ooooooooo`02ooooo`03o`00oooooooooooo05Kooooo00?o0?ZJooooooooool0<oooool00ol00?oo
ooooooooo`02ooooo`03o`3jV_oooooooooo01[ooooo00?o0000ooooooooool00Oooool001Gooooo
00?o0000ooooooooool03?ooool01Ol0nY[ooooooooooooooooo003o03Gooooo00?o0?ZJoooooooo
ool00oooool00ol00?ooooooooooo`1Fooooo`03o`3jV_oooooooooo03Cooooo00Go003ooooooooo
ooooooooo`3jVP0Looooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo00go
oooo00Co0?ZJoooooooooooo003o=Oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo
05Sooooo00?o0?ZJooooooooool0=?ooool01?l00?ooooooooooool0nYXLooooo`03o`000?oooooo
oooo007ooooo000Eooooo`;o00003_ooool01Ol0nY[ooooooooooooooooo003o03Cooooo00Go0?ZJ
ooooooooooooooooo`00o`1Kooooo`03o`3jV_oooooooooo03Gooooo00?o003oo`3jV_ooool06ooo
ool2o`0000?ooooo000Eooooo`03o`000?oooooooooo00gooooo00Go0?ZJooooooooooooooooo`00
o`0cooooo`05o`3jV_ooooooooooooooool00?l0G?ooool00ol0nY[oooooooooo`0fooooo`03o`3j
V_oooooooooo01_ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool03_oo
ool01Ol0nY[ooooooooooooooooo003o03;ooooo00Co0?ZJoooooooooooo003oG_ooool00ol0nY[o
ooooooooo`0eooooo`03o`3jV_oooooooooo01_ooooo00?o0000ooooooooool00Oooool001Gooooo
00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo02oooooo
00?o0?ZJooooool00?l0Goooool00ol0nY[oooooooooo`0dooooo`03o`3jV_oooooooooo01cooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool03_ooool00ol0nY[ooooooooo
o`02ooooo`03o`00oooooooooooo02kooooo00Co0?ZJoooooooooooo003oH?ooool00ol0nY[ooooo
ooooo`0cooooo`03o`3jV_oooooooooo01cooooo00?o0000ooooooooool00Oooool00004ooooool0
003o0000o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0
3oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo02gooooo00?o0?ZJooooool00?l0
HOooool00ol0nY[oooooooooo`0booooo`03o`3jV_oooooooooo01gooooo00?o0000ooooooooool0
0Oooool000;ooooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool03oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo02cooooo
00Co0?ZJoooooooooooo003oHOooool00ol0nY[oooooooooo`0booooo`03o`3jV_oooooooooo01go
oooo00?o0000ooooooooool00Oooool000;ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool00oooool00ol00?oooooo
ooooo`0[ooooo`03o`3jV_oooooo003o06?ooooo00?o0?ZJooooooooool0<Oooool00ol0nY[ooooo
ooooo`0Mooooo`03o`000?oooooooooo007ooooo0002ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool00_ooool2o`00017ooooo00?o0?ZJooooooooool00_ooool00ol00?oooooooooo
o`0[ooooo`03o`3jV_l00?oooooo06?ooooo00?o0?ZJooooooooool0<?ooool00ol0nY[ooooooooo
o`0Looooo`?o00000oooool000;ooooo00?o0000ooooooooool01oooool4o`0000Gooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo02[ooooo00?o0?ZJ
o`00ooooool0IOooool00ol0nY[oooooooooo`0_ooooo`03o`3jV_oooooooooo01kooooo00?o0000
ooooooooool00Oooool00003ooooool0003o000000Wooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool0:Oooool00ol0
nY[oooooooooo`1Uooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJooooooooool07oooool00ol0
003oooooooooo`01ooooo`000_ooool00ol0003oooooooooo`07ooooo`Go00001?ooool00ol0003o
ooooooooo`0Aooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool0:?ooool00ol0nY[o
003oooooo`1Vooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJooooooooool07oooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo00?ooooo
00?o003oooooooooool09oooool00ol0nY[oooooooooo`1Wooooo`03o`3jV_oooooooooo02gooooo
00?o0?ZJooooooooool07oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`0Aooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool09Oooool00ol00?oo0?ZJoooo
o`1Xooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJooooooooool08?ooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo00?ooooo00?o003o
ooooooooool09?ooool00ol00?oo0?ZJooooo`1Yooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJ
ooooooooool08?ooool00ol0003oooooooooo`01ooooo`005Oooool2o`0001?ooooo00?o0?ZJoooo
ooooool01?ooool00ol00?ooooooooooo`0Rooooo`03o`00oooooooo0?ZJ06_ooooo00?o0?ZJoooo
ooooool0:oooool00ol0nY[oooooooooo`0Oooooo`;o00000oooool001Gooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo027ooooo00Co003ooooooooo
oooo0?ZJJoooool00ol0nY[oooooooooo`0Zooooo`03o`3jV_oooooooooo027ooooo00?o0000oooo
ooooool00Oooool001Gooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`04ooooo`03
o`00oooooooooooo023ooooo00?o003oooooool0nYX0KOooool00ol0nY[oooooooooo`0Yooooo`03
o`3jV_oooooooooo027ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0
5?ooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo01oooooo00Co003ooooooooooooo
0?ZJKOooool00ol0nY[oooooooooo`0Xooooo`03o`3jV_oooooooooo02;ooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`03ooooo`03o`00
oooooooooooo01kooooo00Co003ooooooooooooo0?ZJKoooool00ol0nY[oooooooooo`0Wooooo`03
o`3jV_oooooooooo02;ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0
5Oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo01gooooo00Co003ooooooooooooo
0?ZJKoooool00ol0nY[oooooooooo`0Vooooo`03o`3jV_oooooooooo02?ooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`03ooooo`03o`00
oooooooooooo01cooooo00Co003ooooooooooooo0?ZJLOooool00ol0nY[oooooooooo`0Uooooo`03
o`3jV_oooooooooo02?ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0
5Oooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo01_ooooo00Co003ooooooooooooo
0?ZJLOooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo02Cooooo00?o0000oooooooo
ool00Oooool001Gooooo0_l0000Gooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool0
6Oooool01?l00?ooooooooooool0nYYbooooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJoooooooo
ool08oooool2o`0000?ooooo000Eooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool0
1?ooool00ol00?ooooooooooo`0Hooooo`05o`00ooooooooooooooooool0nYX0Loooool00ol0nY[o
ooooooooo`0Sooooo`03o`3jV_oooooooooo02Cooooo00?o0000ooooooooool00Oooool001Gooooo
00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo01Kooooo
00?o003oooooooooool00_ooool00ol0nY[oooooooooo`1aooooo`03o`3jV_oooooooooo02;ooooo
00?o0?ZJooooooooool09Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool05Oooool00ol00?oooooooooo
o`02ooooo`03o`3jV_oooooooooo07;ooooo00?o0?ZJooooooooool08_ooool00ol0nY[ooooooooo
o`0Uooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo01Sooooo00?o0?ZJ
ooooooooool01?ooool00ol00?ooooooooooo`0Dooooo`03o`00oooooooooooo00;ooooo00?o0?ZJ
ooooooooool0Loooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo02Kooooo00?o0000
ooooooooool00Oooool001Gooooo00?o0000ooooooooool06?ooool00ol0nY[oooooooooo`04oooo
o`03o`00oooooooooooo01?ooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`1eoooo
o`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool09oooool00ol0003oooooooooo`01oooo
o`005Oooool00ol0003oooooooooo`0Iooooo`03o`3jV_oooooooooo00?ooooo00?o003ooooooooo
ool04_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo07Gooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`0Wooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000
6_ooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo013ooooo00?o003oooooooooool0
1?ooool00ol0nY[oooooooooo`1fooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
9oooool2o`0000?ooooo000Eooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool00ooo
ool00ol00?ooooooooooo`0?ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool0Mooo
ool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo02Sooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool06_ooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooo
oooo00gooooo00?o003oooooooooool01Oooool00ol0nY[oooooooooo`1hooooo`03o`3jV_oooooo
oooo01[ooooo00?o0?ZJooooooooool0:Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0
003oooooooooo`0Kooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool03?ooool00ol0
0?ooooooooooo`04ooooo`03o`3jV_oooooooooo07Wooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`0Yooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo01_o
oooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Co
oooo00?o0?ZJooooooooool0Noooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo02[o
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool07?ooool00ol0nY[ooooo
ooooo`04ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool01?ooool00ol0nY[ooooo
ooooo`1looooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0:_ooool00ol0003ooooo
ooooo`01ooooo`005Oooool00ol0003oooooooooo`0Mooooo`03o`3jV_oooooooooo00?ooooo00?o
003oooooooooool02Oooool00ol00?ooooooooooo`04ooooo`03o`3jV_oooooooooo07gooooo00?o
0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0[ooooo`03o`000?oooooooooo007ooooo000E
ooooo`03o`000?oooooooooo01kooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`07
ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool0O_ooool00ol0nY[oooooooooo`0E
ooooo`03o`3jV_oooooooooo02cooooo00?o0000ooooooooool00Oooool001Gooooo0_l0000Ooooo
o`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`04oooo
o`03o`3jV_oooooooooo083ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0/oooo
o`;o00000oooool001Gooooo00?o0000ooooooooool07oooool00ol0nY[oooooooooo`02ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`22ooooo`03
o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool0;Oooool00ol0003oooooooooo`01ooooo`00
5Oooool00ol0003oooooooooo`0Pooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool0
1?ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo08Cooooo00?o0?ZJooooooooool0
4?ooool00ol0nY[oooooooooo`0^ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oo
oooooooo027ooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00oooooooooooo00?ooooo
00?o0?ZJooooooooool0Q_ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo02oooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool08_ooool01Ol0nY[ooooooooo
oooooooo003o00?ooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`28ooooo`03o`3j
V_oooooooooo00cooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`01ooooo`003?oo
ool5o`0000Cooooo00?o0000ooooooooool08oooool2o`3jVP05ooooool00?ooooooooooool00?l0
1?ooool2o`3jVXcooooo0ol0nYX9ooooo`;o0?ZJ<oooool00ol0003oooooooooo`01ooooo`003Ooo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo02Gooooo0_l0nYX00ooooooo003o
ooooo`03ooooo`03o`3jV_oooooooooo08oooooo0_l0nYX4ooooo`?o0?ZJ=Oooool00ol0003ooooo
ooooo`01ooooo`003_ooool00ol0003oooooooooo`04ooooo`;o0000:?ooool6o`3jVYCooooo1?l0
nYXfooooo`?o00000oooool000oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3m
ooooo`03o`000?oooooooooo007ooooo000<ooooo`05o`000?ooooooooooooooool000001?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo007ooooo000<ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo007ooooo000=oooo
o`?o00001Oooooooo`0000;o00000oooool00?oooooo6_ooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-11.1862, -0.221508, \
0.409622, 0.0132523}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g3 = plot1[XintSpline[[T1//Range,1,{1}]] ~ii~ \
X[[T1//Range,1,{1}]]//AddTimeAxis];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00952381 0.0146927 0.291709 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01469 -6 -4.5 ]
[-0.0125 .01469 0 4.5 ]
[-0.0125 .16055 -18 -4.5 ]
[-0.0125 .16055 0 4.5 ]
[-0.0125 .3064 -6 -4.5 ]
[-0.0125 .3064 0 4.5 ]
[-0.0125 .45226 -18 -4.5 ]
[-0.0125 .45226 0 4.5 ]
[-0.0125 .59811 -6 -4.5 ]
[-0.0125 .59811 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .14771 -5 -6 ]
[.97619 .14771 5 6 ]
[.97619 .14771 -5 -6 ]
[.97619 .14771 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(20)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(40)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(60)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(80)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(100)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01469 m
.00625 .01469 L
s
[(0)] -0.0125 .01469 1 0 Mshowa
0 .16055 m
.00625 .16055 L
s
[(0.5)] -0.0125 .16055 1 0 Mshowa
0 .3064 m
.00625 .3064 L
s
[(1)] -0.0125 .3064 1 0 Mshowa
0 .45226 m
.00625 .45226 L
s
[(1.5)] -0.0125 .45226 1 0 Mshowa
0 .59811 m
.00625 .59811 L
s
[(2)] -0.0125 .59811 1 0 Mshowa
.125 Mabswid
0 .04386 m
.00375 .04386 L
s
0 .07303 m
.00375 .07303 L
s
0 .10221 m
.00375 .10221 L
s
0 .13138 m
.00375 .13138 L
s
0 .18972 m
.00375 .18972 L
s
0 .21889 m
.00375 .21889 L
s
0 .24806 m
.00375 .24806 L
s
0 .27723 m
.00375 .27723 L
s
0 .33557 m
.00375 .33557 L
s
0 .36474 m
.00375 .36474 L
s
0 .39392 m
.00375 .39392 L
s
0 .42309 m
.00375 .42309 L
s
0 .48143 m
.00375 .48143 L
s
0 .5106 m
.00375 .5106 L
s
0 .53977 m
.00375 .53977 L
s
0 .56894 m
.00375 .56894 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01469 m
1 .01469 L
s
.99375 .16055 m
1 .16055 L
s
.99375 .3064 m
1 .3064 L
s
.99375 .45226 m
1 .45226 L
s
.99375 .59811 m
1 .59811 L
s
.125 Mabswid
.99625 .04386 m
1 .04386 L
s
.99625 .07303 m
1 .07303 L
s
.99625 .10221 m
1 .10221 L
s
.99625 .13138 m
1 .13138 L
s
.99625 .18972 m
1 .18972 L
s
.99625 .21889 m
1 .21889 L
s
.99625 .24806 m
1 .24806 L
s
.99625 .27723 m
1 .27723 L
s
.99625 .33557 m
1 .33557 L
s
.99625 .36474 m
1 .36474 L
s
.99625 .39392 m
1 .39392 L
s
.99625 .42309 m
1 .42309 L
s
.99625 .48143 m
1 .48143 L
s
.99625 .5106 m
1 .5106 L
s
.99625 .53977 m
1 .53977 L
s
.99625 .56894 m
1 .56894 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .14771 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .3064 m
.03333 .35652 L
.04286 .40117 L
.05238 .44059 L
.0619 .47507 L
.07143 .50486 L
.08095 .5302 L
.09048 .55136 L
.1 .56856 L
.10952 .58204 L
.11905 .59203 L
.12857 .59877 L
.1381 .60246 L
.14762 .60332 L
.15714 .60156 L
.16667 .59738 L
.17619 .59098 L
.18571 .58255 L
.19524 .57228 L
.20476 .56035 L
.21429 .54693 L
.22381 .5322 L
.23333 .51631 L
.24286 .49943 L
.25238 .48171 L
.2619 .4633 L
.27143 .44435 L
.28095 .42498 L
.29048 .40533 L
.3 .38553 L
.30952 .36569 L
.31905 .34594 L
.32857 .32638 L
.3381 .30712 L
.34762 .28825 L
.35714 .26988 L
.36667 .25208 L
.37619 .23494 L
.38571 .21854 L
.39524 .20295 L
.40476 .18823 L
.41429 .17444 L
.42381 .16165 L
.43333 .14989 L
.44286 .13922 L
.45238 .12968 L
.4619 .12129 L
.47143 .11408 L
.48095 .10808 L
.49048 .1033 L
Mistroke
.5 .09976 L
.50952 .09746 L
.51905 .0964 L
.52857 .09658 L
.5381 .09798 L
.54762 .10059 L
.55714 .10439 L
.56667 .10935 L
.57619 .11544 L
.58571 .12262 L
.59524 .13085 L
.60476 .14008 L
.61429 .15025 L
.62381 .16131 L
.63333 .17319 L
.64286 .18582 L
.65238 .19912 L
.6619 .21301 L
.67143 .22741 L
.68095 .24222 L
.69048 .25735 L
.7 .27268 L
.70952 .28812 L
.71905 .30355 L
.72857 .31884 L
.7381 .33388 L
.74762 .34853 L
.75714 .36266 L
.76667 .37611 L
.77619 .38876 L
.78571 .40044 L
.79524 .411 L
.80476 .42026 L
.81429 .42807 L
.82381 .43426 L
.83333 .43862 L
.84286 .441 L
.85238 .44118 L
.8619 .43898 L
.87143 .4342 L
.88095 .42662 L
.89048 .41604 L
.9 .40223 L
.90952 .38497 L
.91905 .36404 L
.92857 .3392 L
.9381 .3102 L
.94762 .27681 L
.95714 .23877 L
.96667 .19582 L
Mistroke
.97619 .14771 L
Mfstroke
0 .98 .604 r
gsave
.97619 .14771 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3064 m
.03333 .33552 L
.04286 .36436 L
.05238 .39261 L
.0619 .42 L
.07143 .44626 L
.08095 .47111 L
.09048 .49433 L
.1 .51566 L
.10952 .53491 L
.11905 .55187 L
.12857 .56638 L
.1381 .57829 L
.14762 .58748 L
.15714 .59387 L
.16667 .59738 L
.17619 .59799 L
.18571 .59568 L
.19524 .59048 L
.20476 .58245 L
.21429 .57165 L
.22381 .55821 L
.23333 .54225 L
.24286 .52393 L
.25238 .50344 L
.2619 .48098 L
.27143 .45678 L
.28095 .43107 L
.29048 .40412 L
.3 .37619 L
.30952 .34757 L
.31905 .31853 L
.32857 .28937 L
.3381 .26039 L
.34762 .23186 L
.35714 .20408 L
.36667 .17731 L
.37619 .15184 L
.38571 .12792 L
.39524 .10577 L
.40476 .08564 L
.41429 .0677 L
.42381 .05216 L
.43333 .03915 L
.44286 .02881 L
.45238 .02125 L
.4619 .01653 L
.47143 .01472 L
.48095 .01581 L
.49048 .01981 L
Mistroke
.5 .02667 L
.50952 .03633 L
.51905 .04869 L
.52857 .06362 L
.5381 .08098 L
.54762 .10059 L
.55714 .12226 L
.56667 .14576 L
.57619 .17087 L
.58571 .19734 L
.59524 .22489 L
.60476 .25326 L
.61429 .28216 L
.62381 .31131 L
.63333 .3404 L
.64286 .36915 L
.65238 .39728 L
.6619 .4245 L
.67143 .45054 L
.68095 .47514 L
.69048 .49805 L
.7 .51905 L
.70952 .53792 L
.71905 .55448 L
.72857 .56856 L
.7381 .58003 L
.74762 .58875 L
.75714 .59466 L
.76667 .59769 L
.77619 .5978 L
.78571 .59501 L
.79524 .58933 L
.80476 .58082 L
.81429 .56957 L
.82381 .5557 L
.83333 .53933 L
.84286 .52063 L
.85238 .4998 L
.8619 .47703 L
.87143 .45255 L
.88095 .42662 L
.89048 .39949 L
.9 .37142 L
.90952 .34271 L
.91905 .31363 L
.92857 .28448 L
.9381 .25555 L
.94762 .22713 L
.95714 .1995 L
.96667 .17293 L
Mistroke
.97619 .14771 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`006_ooool2o`0002[ooooo1Ol00003ooooo`;o0000:?ooool3o`0000?o
oooo0_l0000Xooooo`?o00001?ooool2o`0002Sooooo0ol00004ooooo`;o00009Oooool3o`0000Co
oooo0_l00004ooooo`;o00000oooool001Wooooo00Co0000oooooooooooo0000:_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0002Sooooo00Go0000ooooooooooooooooo`00
0002ooooo`03o`000?oooooooooo02Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0002Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0002Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000;ooooo000Iooooo`04o`000?ooooooooooo`0002_ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool0000Uooooo`Go00000_ooool01?l0003oooooooooool0000Voooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Vooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Uooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`006Oooool01?l0
003oooooooooool0000/ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooooooo
o`0Sooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00009_ooool4o`0000?o
oooo00Co0000oooooooooooo00009oooool3o`0000?ooooo00Co0000oooooooooooo00009Oooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
0_ooool001Wooooo00Co0000oooooooooooo0000:Oooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00009_ooool00ol0003oooooo`000003ooooo`04o`000?oooooooooo
o`0002Kooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000Vooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Uooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`006Oooool01?l0
003oooooooooool0000Yooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool0000Wooooo`;o00000oooool01?l0003oooooooooool0000Wooooo`03o`000?oooooooooo00?o
oooo00Co0000oooooooooooo00009_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00009?ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`006_ooool2o`0002_ooooo0ol00004ooooo`;o0000:Oooool00ol0003ooooo
ooooo`02ooooo`;o0000:Oooool2o`0000Cooooo0_l0000Xooooo`?o00001?ooool2o`0002Kooooo
00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003ooooo`00oooooolJooooo`00oooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`005Oooooooo`0000;o00000oooool000kooooo0_l0
0005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00Oooool000gooooo00Co0000
oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02kooooo00?o
0000ooooooooool0;Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o
0000ooooooooool0;_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo007ooooo000=
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0oOooool00ol0003ooooooooo
o`01ooooo`003Oooool01?l0003oooooooooool00004ooooo`;o0000Loooool8o`3jVX7ooooo0ol0
0003ooooo`003Oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo073ooooo0_l0
nYX8ooooo`;o0?ZJPOooool00ol0003oooooooooo`01ooooo`003Oooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo06oooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooooooo
o`1nooooo`03o`000?oooooooooo007ooooo000>ooooo`;o00001Oooool00ol0003oooooooooo`1^
ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0OOooool00ol0003oooooooooo`01
ooooo`005Oooool00ol0003oooooooooo`1^ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooo
ooooool0O?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1]ooooo`03
o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool0Noooool00ol0003oooooooooo`01ooooo`00
5Oooool00ol0003oooooooooo`1/ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool0
N_ooool00ol0003oooooooooo`01ooooo`005Oooool2o`0006cooooo00?o0?ZJooooooooool04ooo
ool00ol0nY[oooooooooo`1hooooo`;o00000oooool001Gooooo00?o0000ooooooooool0J_ooool0
0ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo07Sooooo00?o0000ooooooooool00Oooool0
01Gooooo00?o0000ooooooooool0JOooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo
07Sooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0JOooool00ol0nY[o
ooooooooo`0Gooooo`03o`3jV_oooooooooo07Oooooo00?o0000ooooooooool00Oooool001Gooooo
00?o0000ooooooooool0J?ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo07Oooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0J?ooool00ol0nY[ooooooooo
o`0Iooooo`03o`3jV_oooooooooo07Kooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000
ooooooooool0Ioooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo07Kooooo00?o0000
ooooooooool00Oooool001Gooooo00?o0000ooooooooool0Ioooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooooooo07Gooooo00?o0000ooooooooool00Oooool001Gooooo0_l0001Wooooo`03
o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0Loooool2o`0000?ooooo000Eooooo`03o`00
0?oooooooooo06Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`1dooooo`03o`00
0?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06Gooooo00?o0?ZJooooooooool07ooo
ool00ol0nY[oooooooooo`1cooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooo
oooo06Cooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`1cooooo`03o`000?oooooo
oooo007ooooo000Eooooo`03o`000?oooooooooo06Cooooo00?o0?ZJooooooooool08Oooool00ol0
nY[oooooooooo`1booooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo06?o
oooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`1booooo`03o`000?oooooooooo007o
oooo000Eooooo`03o`000?oooooooooo06?ooooo00?o0?ZJooooooooool06?ooool:o`00o`03o`3j
V_oooooooooo07;ooooo00?o0000ooooooooool00Oooool001Gooooo0_l0001Tooooo`03o`3jV_oo
oooooooo01Cooooo1?l00?l;ooooo`03o`3jV_l00?oo003o073ooooo0_l00003ooooo`005Oooool0
0ol0003oooooooooo`1Rooooo`03o`3jV_oooooooooo01Cooooo00?o003oooooooooool03Oooool0
0ol0nY[oooooooooo`02o`00ofoooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000oooo
ooooool0H_ooool00ol0nY[oooooooooo`0Booooo`;o003o4Oooool01Ol0nY[ooooooooooooooooo
003o06kooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0HOooool00ol0
nY[oooooooooo`0Aooooo`;o003o5?ooool01Ol0nY[ooooooooooooooooo003o06gooooo00?o0000
ooooooooool00Oooool001Gooooo00?o0000ooooooooool0HOooool00ol0nY[oooooooooo`0@oooo
o`03o`00oooooooooooo01Cooooo00?o0?ZJooooooooool00_ooool3o`00of[ooooo00?o0000oooo
ooooool00Oooool001Gooooo00?o0000ooooooooool0HOooool00ol0nY[oooooooooo`0?ooooo`03
o`00oooooooooooo01Kooooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`1Wooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo063ooooo00?o0?ZJooooooooool0
3oooool00ol00?ooooooooooo`0Gooooo`03o`3jV_oooooooooo00Gooooo00?o003oooooooooool0
I_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Pooooo`03o`3jV_oo
oooooooo00kooooo00?o003oooooooooool06Oooool00ol0nY[oooooooooo`05ooooo`03o`00oooo
oooooooo06Gooooo00?o0000ooooooooool00Oooool001Gooooo0_l0001Qooooo`03o`3jV_oooooo
oooo00gooooo00?o003oooooooooool06_ooool00ol0nY[oooooooooo`06ooooo`03o`00oooooooo
oooo06?ooooo0_l00003ooooo`005Oooool00ol0003oooooooooo`1Oooooo`03o`3jV_oooooooooo
00gooooo00?o003oooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`00oooooooooooo
06?ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0Goooool00ol0nY[o
ooooooooo`0<ooooo`03o`00oooooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol00?oo
ooooooooo`1Rooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05kooooo
00?o0?ZJooooooooool03?ooool00ol00?ooooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo
00?o003oooooooooool0HOooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`1Nooooo`03o`3jV_oooooooooo00_ooooo00?o003oooooooooool07oooool00ol0nY[ooooooooo
o`09ooooo`03o`00oooooooooooo05[ooooo00?o0?ZJooooooooool00oooool00ol0003ooooooooo
o`01ooooo`000_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000
ooooooooool0GOooool00ol0nY[oooooooooo`0;ooooo`03o`00oooooooooooo023ooooo00?o0?ZJ
ooooooooool02_ooool00ol00?ooooooooooo`1Iooooo`03o`3jV_oooooooooo00?ooooo00?o0000
ooooooooool00Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool0GOooool00ol0nY[oooooooooo`0:ooooo`03o`00oooo
oooooooo02;ooooo00?o0?ZJooooooooool02_ooool00ol00?ooooooooooo`1Gooooo`03o`3jV_l0
0?oooooo00Cooooo00?o0000ooooooooool00Oooool00005ooooool0003oooooooooool000002ooo
ool00ol0003oooooooooo`02ooooo`;o0000GOooool00ol0nY[oooooooooo`0:ooooo`03o`00oooo
oooooooo02?ooooo00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`1Fooooo`03o`3jV_oo
oooooooo00;ooooo0ol00003ooooo`0000Goooooo`000?ooooooooooo`00000;ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0G?ooool00ol0nY[oooooooooo`0:ooooo`03o`00oooo
oooooooo02?ooooo00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`1Eooooo`03o`3jV_l0
0?oooooo00Gooooo00?o0000ooooooooool00Oooool00005ooooool0003oooooooooool000001ooo
ool4o`0000Gooooo00?o0000ooooooooool0G?ooool00ol0nY[oooooooooo`09ooooo`03o`00oooo
oooooooo02Gooooo00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`1Dooooo`03o`3jV_l0
0?oooooo00Gooooo00?o0000ooooooooool00Oooool00005ooooool0003oooooooooool000001ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05_ooooo00?o0?ZJooooooooool02_oo
ool00ol00?ooooooooooo`0Uooooo`03o`3jV_oooooooooo00cooooo00?o003oooooooooool0D_oo
ool00ol0nY[oooooo`00o`06ooooo`03o`000?oooooooooo007ooooo0002ooooo`;o00002?ooool5
o`0000Cooooo00?o0000ooooooooool0Foooool00ol0nY[oooooooooo`09ooooo`03o`00oooooooo
oooo02Kooooo00?o0?ZJooooooooool03?ooool00ol00?ooooooooooo`1Booooo`03o`3jV_l00?oo
oooo00Kooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0Foooool00ol0
nY[oooooooooo`08ooooo`03o`00oooooooooooo02Sooooo00?o0?ZJooooooooool03?ooool00ol0
0?ooooooooooo`1Aooooo`03o`3jV_l00?oooooo00Kooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool0F_ooool00ol0nY[oooooooooo`08ooooo`03o`00oooooooooooo02Wo
oooo00?o0?ZJooooooooool03?ooool00ol00?ooooooooooo`1@ooooo`03o`3jV_oooooo003o00Oo
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0F_ooool00ol0nY[ooooo
ooooo`07ooooo`03o`00oooooooooooo02_ooooo00?o0?ZJooooooooool03?ooool00ol00?oooooo
ooooo`1?ooooo`03o`3jV_oooooo003o00Oooooo00?o0000ooooooooool00Oooool001Gooooo0_l0
001Jooooo`03o`3jV_oooooooooo00Sooooo00?o003oooooooooool0:oooool00ol0nY[ooooooooo
o`0=ooooo`03o`00oooooooooooo04kooooo00?o0?ZJo`00ooooool01_ooool2o`0000?ooooo000E
ooooo`03o`000?oooooooooo05Wooooo00?o0?ZJooooooooool01oooool00ol00?ooooooooooo`0/
ooooo`03o`3jV_oooooooooo00kooooo00?o003oooooooooool0C?ooool00ol0nY[oooooo`00o`08
ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05Wooooo00?o0?ZJoooo
ooooool01oooool00ol00?ooooooooooo`0]ooooo`03o`3jV_oooooooooo00kooooo00?o003ooooo
ooooool0Boooool00ol0nY[oooooo`00o`08ooooo`03o`000?oooooooooo007ooooo000Eooooo`03
o`000?oooooooooo05Sooooo00?o0?ZJooooooooool01oooool00ol00?ooooooooooo`0^ooooo`03
o`3jV_oooooooooo00kooooo00?o003oooooooooool0Boooool00ol0nY[oooooo`00o`08ooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05Sooooo00?o0?ZJooooooooool0
1oooool00ol00?ooooooooooo`0^ooooo`03o`3jV_oooooooooo00oooooo00?o003oooooooooool0
B_ooool00ol0nY[oooooo`00o`08ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oo
oooooooo05Sooooo00?o0?ZJooooooooool01_ooool00ol00?ooooooooooo`0`ooooo`03o`3jV_oo
oooooooo00kooooo00?o003oooooooooool0BOooool00ol0nY[oooooo`00o`09ooooo`03o`000?oo
oooooooo007ooooo000Eooooo`03o`000?oooooooooo05Oooooo00?o0?ZJooooooooool01oooool0
0ol00?ooooooooooo`0`ooooo`03o`3jV_oooooooooo00oooooo00?o003oooooooooool0B?ooool0
0ol0nY[oooooo`00o`09ooooo`03o`000?oooooooooo007ooooo000Eooooo`;o0000F?ooool00ol0
nY[oooooooooo`06ooooo`03o`00oooooooooooo037ooooo00?o0?ZJooooooooool04?ooool00ol0
0?ooooooooooo`17ooooo`03o`3jV_oooooo003o00Sooooo0_l00003ooooo`005Oooool00ol0003o
ooooooooo`1Gooooo`03o`3jV_oooooooooo00Kooooo00?o003oooooooooool0<_ooool00ol0nY[o
ooooooooo`0@ooooo`03o`00oooooooooooo04Gooooo00Co0?ZJoooooooooooo003o2Oooool00ol0
003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo00Ko
oooo00?o003oooooooooool0<oooool00ol0nY[oooooooooo`0Aooooo`03o`00oooooooooooo04Co
oooo00Co0?ZJoooooooooooo003o2Oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003o
ooooooooo`1Fooooo`03o`3jV_oooooooooo00Gooooo00?o003oooooooooool0=?ooool00ol0nY[o
ooooooooo`0Aooooo`03o`00oooooooooooo04Cooooo00?o0?ZJooooool00?l02_ooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo00Cooooo
00?o003oooooooooool0=_ooool00ol0nY[oooooooooo`0Aooooo`03o`00oooooooooooo04;ooooo
00Co0?ZJoooooooooooo003o2_ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooo
ooooo`1Eooooo`03o`3jV_oooooooooo00Gooooo00?o003oooooooooool0=_ooool00ol0nY[ooooo
ooooo`0Aooooo`03o`00oooooooooooo04;ooooo00Co0?ZJoooooooooooo003o2_ooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`1Eooooo`03o`3jV_oooooooooo00Cooooo
00?o003oooooooooool0>?ooool00ol0nY[oooooooooo`0Aooooo`03o`00oooooooooooo043ooooo
00Go0?ZJooooooooooooooooo`00o`0:ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`00
0?oooooooooo05Gooooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`0hooooo`03o`3j
V_oooooooooo017ooooo00?o003oooooooooool0@?ooool01Ol0nY[ooooooooooooooooo003o00[o
oooo00?o0000ooooooooool00Oooool001Gooooo0_l0001Eooooo`03o`3jV_oooooooooo00Gooooo
00?o003oooooooooool0>?ooool00ol0nY[oooooooooo`0Booooo`03o`00oooooooooooo03oooooo
00Co0?ZJoooooooooooo003o2_ooool2o`0000?ooooo000Eooooo`03o`000?oooooooooo05Cooooo
00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`0jooooo`03o`3jV_oooooooooo01;ooooo
00?o003oooooooooool0?Oooool01Ol0nY[ooooooooooooooooo003o00_ooooo00?o0000oooooooo
ool00Oooool001Gooooo00?o0000ooooooooool0E?ooool00ol0nY[oooooooooo`04ooooo`03o`00
oooooooooooo03[ooooo00?o0?ZJooooooooool04oooool00ol00?ooooooooooo`0looooo`05o`3j
V_ooooooooooooooool00?l02oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooo
ooooo`1Cooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool0>oooool00ol0nY[ooooo
ooooo`0Cooooo`03o`00oooooooooooo03cooooo00Go0?ZJooooooooooooooooo`00o`0;ooooo`03
o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo05?ooooo00?o0?ZJooooooooool0
0oooool00ol00?ooooooooooo`0mooooo`03o`3jV_oooooooooo01?ooooo00?o003oooooooooool0
>_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00Wooooo00?o0000ooooooooool0
0Oooool001Gooooo00?o0000ooooooooool0Doooool00ol0nY[oooooooooo`02ooooo`03o`00oooo
oooooooo03kooooo00?o0?ZJooooooooool04oooool00ol00?ooooooooooo`0jooooo`05o`3jV_oo
ooooooooooooool00?l03?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooooooo
o`1Booooo`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool0?_ooool00ol0nY[ooooooooo
o`0Dooooo`03o`00oooooooooooo03Wooooo00Go0?ZJooooooooooooooooo`00o`0<ooooo`03o`00
0?oooooooooo007ooooo000Eooooo`;o0000Doooool00ol0nY[oooooooooo`02ooooo`03o`00oooo
oooooooo043ooooo00?o0?ZJooooooooool04oooool00ol00?ooooooooooo`0iooooo`05o`3jV_oo
ooooooooooooool00?l02oooool2o`0000?ooooo000Eooooo`03o`000?oooooooooo05;ooooo00?o
0?ZJooooooooool00_ooool00ol00?ooooooooooo`10ooooo`03o`3jV_oooooooooo01Cooooo00?o
003oooooooooool0=oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00[ooooo00?o
0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool0DOooool00ol0nY[oooooooooo`03
ooooo`03o`00oooooooooooo043ooooo00?o0?ZJooooooooool05Oooool00ol00?ooooooooooo`0f
ooooo`05o`3jV_ooooooooooooooool00?l03Oooool00ol0003oooooooooo`01ooooo`005Oooool0
0ol0003oooooooooo`1Aooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool0@_ooool0
0ol0nY[oooooooooo`0Eooooo`03o`00oooooooooooo03Gooooo00Go0?ZJooooooooooooooooo`00
o`0=ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo057ooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`12ooooo`03o`3jV_oooooooooo01Gooooo00?o003o
ooooooooool0=?ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00_ooooo00?o0000
ooooooooool00Oooool000gooooo0ol00005ooooo`03o`000?oooooooooo053ooooo00?o0?ZJoooo
ooooool00_ooool00ol00?ooooooooooo`13ooooo`03o`3jV_oooooooooo01Kooooo00?o003ooooo
ooooool0<oooool01Ol0nY[ooooooooooooooooo003o00kooooo00?o0000ooooooooool00Oooool0
00kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1@ooooo`05o`3jV_oooooooooo
ooooool00?l0Aoooool00ol0nY[oooooooooo`0Eooooo`03o`00oooooooooooo03;ooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`0<ooooo`03o`000?oooooooooo007ooooo000>oooo
o`03o`000?oooooooooo00Cooooo0_l00004ooooo`03o`3jV_oooooooooo04[ooooo00Go0?ZJoooo
ooooooooooooo`00o`17ooooo`03o`3jV_oooooooooo01Kooooo00?o003oooooooooool0<Oooool0
0ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00[ooooo0ol00003ooooo`003_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool0BOooool01Ol0
nY[ooooooooooooooooo003o04Sooooo00?o0?ZJooooooooool05_ooool00ol00?ooooooooooo`0a
ooooo`05o`3jV_ooooooooooooooool00?l03oooool00ol0003oooooooooo`01ooooo`003_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool0BOooool0
1Ol0nY[ooooooooooooooooo003o04Wooooo00?o0?ZJooooooooool05_ooool00ol00?oooooooooo
o`0_ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool03Oooool00ol0003ooooooooo
o`01ooooo`003Oooool2o`0000Kooooo00?o0000ooooooooool00oooool00ol00?oo0?ZJooooo`19
ooooo`04o`3jV_ooooooooooo`00od[ooooo00?o0?ZJooooooooool05_ooool00ol00?oooooooooo
o`0_ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool03Oooool00ol0003ooooooooo
o`01ooooo`003_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0?ZJ
ooooooooool0Aoooool01Ol0nY[ooooooooooooooooo003o04[ooooo00?o0?ZJooooooooool05ooo
ool00ol00?ooooooooooo`0^ooooo`05o`3jV_ooooooooooooooool00?l04?ooool00ol0003ooooo
ooooo`01ooooo`005Oooool00ol0003oooooooooo`04ooooo`03o`3jV_oooooooooo04Oooooo00Go
0?ZJooooooooooooooooo`00o`1;ooooo`03o`3jV_oooooooooo01Kooooo00?o003oooooooooool0
;Oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00kooooo00?o0000ooooooooool0
0Oooool001Gooooo00?o0000ooooooooool01?ooool00ol0nY[oooooooooo`17ooooo`04o`3jV_oo
ooooooooo`00odcooooo00?o0?ZJooooooooool05oooool00ol00?ooooooooooo`0/ooooo`03o`3j
V_oooooooooo00;ooooo00?o003oooooooooool03_ooool00ol0003oooooooooo`01ooooo`005Ooo
ool00ol0003oooooooooo`04ooooo`03o`00ool0nY[ooooo04Kooooo00Go0?ZJoooooooooooooooo
o`00o`1<ooooo`03o`3jV_oooooooooo01Sooooo00?o003oooooooooool0:oooool00ol0nY[ooooo
ooooo`02ooooo`03o`00oooooooooooo00kooooo00?o0000ooooooooool00Oooool001Gooooo0_l0
0005ooooo`03o`00ool0nY[ooooo04Kooooo00Co0?ZJoooooooooooo003oC_ooool00ol0nY[ooooo
ooooo`0Hooooo`03o`00oooooooooooo02[ooooo00Go0?ZJooooooooooooooooo`00o`0@ooooo`;o
00000oooool001Gooooo00?o0000ooooooooool01?ooool00ol00?oo0?ZJooooo`16ooooo`03o`3j
V_oooooo003o04oooooo00?o0?ZJooooooooool06?ooool00ol00?ooooooooooo`0Yooooo`03o`3j
V_oooooooooo00;ooooo00?o003oooooooooool03oooool00ol0003oooooooooo`01ooooo`005Ooo
ool00ol0003oooooooooo`04ooooo`03o`00oooooooo0?ZJ04Gooooo00Co0?ZJoooooooooooo003o
Coooool00ol0nY[oooooooooo`0Iooooo`03o`00oooooooooooo02Sooooo00?o0?ZJooooooooool0
0_ooool00ol00?ooooooooooo`0?ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oo
oooooooo00Gooooo00?o003oo`3jV_ooool0A?ooool00ol0nY[oooooo`00o`1@ooooo`03o`3jV_oo
oooooooo01[ooooo00?o003oooooooooool09oooool01Ol0nY[ooooooooooooooooo003o01;ooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool01Oooool00ol00?ooooooo`3j
VP14ooooo`03o`3jV_oooooo003o057ooooo00?o0?ZJooooooooool06Oooool00ol00?oooooooooo
o`0Vooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool04?ooool00ol0003ooooooooo
o`01ooooo`005Oooool00ol0003oooooooooo`05ooooo`03o`00oooooooo0?ZJ04Cooooo00?o0?ZJ
o`00ooooool0DOooool00ol0nY[oooooooooo`0Jooooo`03o`00oooooooooooo02Gooooo00Go0?ZJ
ooooooooooooooooo`00o`0Cooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooo
oooo00Gooooo00?o003oooooool0nYX0@oooool00ol0nY[oooooo`00o`1Booooo`03o`3jV_oooooo
oooo01_ooooo00?o003oooooooooool08oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooo
oooo017ooooo00?o0000ooooooooool00Oooool001Gooooo0_l00006ooooo`04o`00oooooooooooo
o`3jVT;ooooo00?o0?ZJooooool00?l0D_ooool00ol0nY[oooooooooo`0Looooo`03o`00oooooooo
oooo02;ooooo00Go0?ZJooooooooooooooooo`00o`0Cooooo`;o00000oooool001Gooooo00?o0000
ooooooooool01_ooool00ol00?ooooooo`3jVP12ooooo`03o`3jV_l00?oooooo05?ooooo00?o0?ZJ
ooooooooool06oooool00ol00?ooooooooooo`0Rooooo`05o`3jV_ooooooooooooooool00?l05?oo
ool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`00oooooooo
0?ZJ047ooooo00?o0?ZJooooool00?l0E?ooool00ol0nY[oooooooooo`0Looooo`03o`00oooooooo
oooo023ooooo00Go0?ZJooooooooooooooooo`00o`0Eooooo`03o`000?oooooooooo007ooooo000E
ooooo`03o`000?oooooooooo00Kooooo00Co003ooooooooooooo0?ZJ@?ooool00ol0nY[o003ooooo
o`1Dooooo`03o`3jV_oooooooooo01gooooo00?o003oooooooooool07oooool01Ol0nY[ooooooooo
oooooooo003o01Gooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool01_oo
ool01?l00?ooooooooooool0nYY0ooooo`03o`3jV_l00?oooooo05Gooooo00?o0?ZJooooooooool0
7?ooool00ol00?ooooooooooo`0Oooooo`05o`3jV_ooooooooooooooool00?l05Oooool00ol0003o
ooooooooo`01ooooo`005Oooool00ol0003oooooooooo`07ooooo`03o`00oooooooo0?ZJ03oooooo
00?o0?ZJooooool00?l0E_ooool00ol0nY[oooooooooo`0Mooooo`03o`00oooooooooooo01gooooo
00Go0?ZJooooooooooooooooo`00o`0Fooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`00
0?oooooooooo00Oooooo00?o003oooooool0nYX0?oooool00ol0nY[o003oooooo`1Gooooo`03o`3j
V_oooooooooo01gooooo00?o003oooooooooool07?ooool01Ol0nY[ooooooooooooooooo003o01Ko
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool01oooool01?l00?oooooo
ooooool0nYXnooooo`03o`3jV_l00?oooooo05Oooooo00?o0?ZJooooooooool07_ooool00ol00?oo
ooooooooo`0Kooooo`05o`3jV_ooooooooooooooool00?l05_ooool00ol0003oooooooooo`01oooo
o`005Oooool2o`0000Sooooo00Co003ooooooooooooo0?ZJ?Oooool00ol0nY[o003oooooo`1Hoooo
o`03o`3jV_oooooooooo01kooooo00?o003oooooooooool06_ooool01Ol0nY[ooooooooooooooooo
003o01Kooooo0_l00003ooooo`005Oooool00ol0003oooooooooo`08ooooo`03o`00oooooooo0?ZJ
03gooooo00?o0?ZJooooooooool0FOooool00ol0nY[oooooooooo`0Nooooo`03o`00oooooooooooo
01Wooooo00Co0?ZJoooooooooooo003o6?ooool00ol0003oooooooooo`01ooooo`005Oooool00ol0
003oooooooooo`08ooooo`04o`00ooooooooooooo`3jVScooooo00?o0?ZJooooooooool0FOooool0
0ol0nY[oooooooooo`0Oooooo`;o003o6Oooool00ol0nY[oooooo`00o`0Iooooo`03o`000?oooooo
oooo007ooooo000Eooooo`03o`000?oooooooooo00Sooooo00Co003ooooooooooooo0?ZJ>oooool0
0ol0nY[oooooooooo`1Jooooo`03o`3jV_oooooooooo027ooooo00?o003oooooooooool05_ooool0
0ol0nY[oooooo`00o`0Iooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo
00Sooooo00Go003oooooooooooooooooo`3jVP0jooooo`03o`3jV_oooooooooo05_ooooo00?o0?ZJ
ooooooooool08Oooool00ol00?ooooooooooo`0Dooooo`03o`3jV_oooooo003o01[ooooo00?o0000
ooooooooool00Oooool001Gooooo00?o0000ooooooooool02Oooool01?l00?ooooooooooool0nYXi
ooooo`03o`3jV_oooooooooo05cooooo00?o0?ZJooooooooool08Oooool00ol00?ooooooooooo`0D
ooooo`03o`3jV_oooooo003o01[ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000oooo
ooooool02Oooool01?l00?ooooooooooool0nYXiooooo`03o`3jV_oooooooooo05cooooo00?o0?ZJ
ooooooooool08_ooool00ol00?ooooooooooo`0Cooooo`03o`3jV_l00?oooooo01[ooooo00?o0000
ooooooooool00Oooool001Gooooo0_l0000:ooooo`05o`00ooooooooooooooooool0nYX0>?ooool0
0ol0nY[oooooooooo`1Mooooo`03o`3jV_oooooooooo02;ooooo00?o003oooooooooool04Oooool0
0ol0nY[o003oooooo`0Jooooo`;o00000oooool001Gooooo00?o0000ooooooooool02Oooool01Ol0
0?oooooooooooooooooo0?ZJ03Oooooo00?o0?ZJooooooooool0G_ooool00ol0nY[oooooooooo`0S
ooooo`03o`00oooooooooooo00oooooo00?o003oo`3jV_ooool07?ooool00ol0003oooooooooo`01
ooooo`005Oooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJoooo
ooooool0=?ooool00ol0nY[oooooooooo`1Nooooo`03o`3jV_oooooooooo02Cooooo0ol00?l=oooo
o`03o`00oooooooo0?ZJ01gooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000oooooooo
ool02_ooool01Ol00?oooooooooooooooooo0?ZJ03Gooooo00?o003oo`3jV_ooool0H?ooool00ol0
nY[oooooooooo`0Vooooo`;o003o2Oooool2o`00o`03ooooool0nY[ooooo01gooooo00?o0000oooo
ooooool00Oooool001Gooooo00?o0000ooooooooool02_ooool01Ol00?oooooooooooooooooo0?ZJ
03Cooooo00?o003oo`3jV_ooool0HOooool00ol0nY[oooooooooo`0Xooooo`?o003o1?ooool2o`00
o`?ooooo00?o0?ZJooooooooool07?ooool00ol0003oooooooooo`01ooooo`0000Coooooo`000?l0
003o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`0:oooo
o`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool0<Oooool00ol00?oo0?ZJooooo`1Roooo
o`03o`3jV_oooooooooo02[ooooo1?l00?l4ooooo`03o`3jV_oooooooooo01gooooo00?o0000oooo
ooooool00Oooool000;ooooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo0000
00Cooooo00?o0000ooooooooool02_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo
033ooooo00?o003oo`3jV_ooool0Hoooool00ol0nY[oooooooooo`0booooo`03o`3jV_oooooooooo
01gooooo00?o0000ooooooooool00Oooool000;ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00_ooooo00Go003oooooooooooooooooo`3jVP0boooo
o`03o`00ool0nY[ooooo06Cooooo00?o0?ZJooooooooool0<Oooool00ol0nY[oooooooooo`0Moooo
o`03o`000?oooooooooo007ooooo0002ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool00_ooool2o`0000cooooo00Go003oooooooooooooooooo`3jVP0aooooo`03o`00oooooooo0?ZJ
06Gooooo00?o0?ZJooooooooool0<?ooool00ol0nY[oooooooooo`0Looooo`?o00000oooool000;o
oooo00?o0000ooooooooool01oooool4o`0000Gooooo00?o0000ooooooooool02oooool00ol00?oo
ooooooooo`02ooooo`03o`3jV_oooooooooo02kooooo00?o003oo`3jV_ooool0IOooool00ol0nY[o
ooooooooo`0`ooooo`03o`3jV_oooooooooo01kooooo00?o0000ooooooooool00Oooool00003oooo
ool0003o000000Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0<ooooo`05o`00
ooooooooooooooooool0nYX0<?ooool00ol00?oo0?ZJooooo`1Vooooo`03o`3jV_oooooooooo02ko
oooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`01ooooo`000_ooool00ol0003ooooo
ooooo`07ooooo`Go00001?ooool00ol0003oooooooooo`0<ooooo`05o`00ooooooooooooooooool0
nYX0;oooool00ol00?oo0?ZJooooo`1Wooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJoooooooo
ool07oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003oooooooooo`0<ooooo`03o`00
oooooooooooo00;ooooo00?o0?ZJooooooooool0;?ooool00ol00?oo0?ZJooooo`1Wooooo`03o`3j
V_oooooooooo02kooooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`01ooooo`005Ooo
ool00ol0003oooooooooo`0=ooooo`05o`00ooooooooooooooooool0nYX0;Oooool00ol00?oooooo
o`3jVP1Yooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJooooooooool08?ooool00ol0003ooooo
ooooo`01ooooo`005Oooool00ol0003oooooooooo`0=ooooo`05o`00ooooooooooooooooool0nYX0
;?ooool00ol00?ooooooo`3jVP1Zooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJooooooooool0
8?ooool00ol0003oooooooooo`01ooooo`005Oooool2o`0000kooooo00?o003oooooooooool00_oo
ool00ol0nY[oooooooooo`0Xooooo`04o`00ooooooooooooo`3jVV[ooooo00?o0?ZJooooooooool0
;?ooool00ol0nY[oooooooooo`0Oooooo`;o00000oooool001Gooooo00?o0000ooooooooool03Ooo
ool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo02Sooooo00Co003ooooooooooooo0?ZJ
Joooool00ol0nY[oooooooooo`0Zooooo`03o`3jV_oooooooooo027ooooo00?o0000ooooooooool0
0Oooool001Gooooo00?o0000ooooooooool03_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oo
oooooooo02Kooooo00Co003ooooooooooooo0?ZJK?ooool00ol0nY[oooooooooo`0Zooooo`03o`3j
V_oooooooooo027ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool03_oo
ool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo02Kooooo00Co003ooooooooooooo0?ZJ
KOooool00ol0nY[oooooooooo`0Xooooo`03o`3jV_oooooooooo02;ooooo00?o0000ooooooooool0
0Oooool001Gooooo00?o0000ooooooooool03_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oo
oooooooo02Gooooo00?o003oooooool0nYX0K_ooool00ol0nY[oooooooooo`0Xooooo`03o`3jV_oo
oooooooo02;ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool03oooool0
0ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo02Cooooo00Co003ooooooooooooo0?ZJKooo
ool00ol0nY[oooooooooo`0Vooooo`03o`3jV_oooooooooo02?ooooo00?o0000ooooooooool00Ooo
ool001Gooooo00?o0000ooooooooool03oooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooo
oooo02?ooooo00?o003oooooool0nYX0L?ooool00ol0nY[oooooooooo`0Vooooo`03o`3jV_oooooo
oooo02?ooooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool03oooool00ol0
0?ooooooooooo`03ooooo`03o`3jV_oooooooooo02;ooooo00Co003ooooooooooooo0?ZJLOooool0
0ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo02Cooooo00?o0000ooooooooool00Oooool0
01Gooooo0_l0000@ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool08_ooool00ol0
0?ooooooo`3jVP1booooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJooooooooool08oooool2o`00
00?ooooo000Eooooo`03o`000?oooooooooo013ooooo00?o003oooooooooool00oooool00ol0nY[o
ooooooooo`0Pooooo`04o`00ooooooooooooo`3jVW;ooooo00?o0?ZJooooooooool09?ooool00ol0
nY[oooooooooo`0Tooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo013o
oooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`0Pooooo`04o`00ooooooooooooo`3j
VW?ooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooooooo
007ooooo000Eooooo`03o`000?oooooooooo013ooooo00?o003oooooooooool01?ooool00ol0nY[o
ooooooooo`0Nooooo`04o`00ooooooooooooo`3jVWCooooo00?o0?ZJooooooooool08_ooool00ol0
nY[oooooooooo`0Uooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooooooo017o
oooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0Looooo`05o`00oooooooooooooooo
ool0nYX0MOooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo02Kooooo00?o0000oooo
ooooool00Oooool001Gooooo00?o0000ooooooooool04Oooool00ol00?ooooooooooo`04ooooo`03
o`3jV_oooooooooo01_ooooo00Go003oooooooooooooooooo`3jVP1gooooo`03o`3jV_oooooooooo
01kooooo00?o0?ZJooooooooool09oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003o
ooooooooo`0Aooooo`03o`00oooooooooooo00Gooooo00?o0?ZJooooooooool06_ooool01Ol00?oo
oooooooooooooooo0?ZJ07Oooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`0Woooo
o`03o`000?oooooooooo007ooooo000Eooooo`;o00004oooool00ol00?ooooooooooo`04ooooo`03
o`3jV_oooooooooo01Wooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`1fooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool09oooool2o`0000?ooooo000Eooooo`03o`00
0?oooooooooo01?ooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0Hooooo`05o`00
ooooooooooooooooool0nYX0NOooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo02So
oooo00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool04oooool00ol00?oooooo
ooooo`04ooooo`03o`3jV_oooooooooo01Oooooo00?o003oooooooooool00_ooool00ol0nY[ooooo
ooooo`1hooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0:Oooool00ol0003ooooo
ooooo`01ooooo`005Oooool00ol0003oooooooooo`0Dooooo`03o`00oooooooooooo00Cooooo00?o
0?ZJooooooooool05_ooool01Ol00?oooooooooooooooooo0?ZJ07_ooooo00?o0?ZJooooooooool0
6_ooool00ol0nY[oooooooooo`0Yooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oo
oooooooo01Cooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0Eooooo`05o`00oooo
ooooooooooooool0nYX0OOooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo02[ooooo
00?o0000ooooooooool00Oooool001Gooooo00?o0000ooooooooool05Oooool00ol00?oooooooooo
o`04ooooo`03o`3jV_oooooooooo01?ooooo00Go003oooooooooooooooooo`3jVP1nooooo`03o`3j
V_oooooooooo01Sooooo00?o0?ZJooooooooool0:_ooool00ol0003oooooooooo`01ooooo`005Ooo
ool00ol0003oooooooooo`0Eooooo`03o`00oooooooooooo00Gooooo00?o0?ZJooooooooool04Ooo
ool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo07gooooo00?o0?ZJooooooooool05_oo
ool00ol0nY[oooooooooo`0[ooooo`03o`000?oooooooooo007ooooo000Eooooo`03o`000?oooooo
oooo01Gooooo00?o003oooooooooool01_ooool00ol0nY[oooooooooo`0@ooooo`05o`00oooooooo
ooooooooool0nYX0P?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo02cooooo00?o
0000ooooooooool00Oooool001Gooooo0_l0000Gooooo`03o`00oooooooooooo00Gooooo00?o0?ZJ
ooooooooool03oooool01Ol00?oooooooooooooooooo0?ZJ08;ooooo00?o0?ZJooooooooool04ooo
ool00ol0nY[oooooooooo`0/ooooo`;o00000oooool001Gooooo00?o0000ooooooooool05oooool0
0ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo00cooooo0_l00?l3ooooo`03o`3jV_oooooo
oooo08;ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0]ooooo`03o`000?oooooo
oooo007ooooo000Eooooo`03o`000?oooooooooo01Sooooo00?o003oooooooooool01Oooool00ol0
nY[oooooooooo`0:ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool0Q?ooool00ol0
nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo02kooooo00?o0000ooooooooool00Oooool001Go
oooo00?o0000ooooooooool06Oooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo00So
oooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`26ooooo`03o`3jV_oooooooooo00ko
oooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`01ooooo`005Oooool00ol0003ooooo
ooooo`0Iooooo`03o`00oooooooooooo00Kooooo00?o0?ZJooooooooool01_ooool00ol00?oooooo
ooooo`02ooooo`03o`3jV_oooooooooo08Sooooo00?o0?ZJooooooooool03?ooool00ol0nY[ooooo
ooooo`0`ooooo`03o`000?oooooooooo007ooooo000<ooooo`Go00001?ooool00ol0003ooooooooo
o`0Jooooo`03o`00oooooooooooo00Kooooo0_l0nYX4ooooo`;o003o0oooool2o`3jVXcooooo0ol0
nYX9ooooo`;o0?ZJ<oooool00ol0003oooooooooo`01ooooo`003Oooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo01_ooooo0ol00?l7ooooo`;o0?ZJ00?oooooo`00ooooool00ooo
ool00ol0nY[oooooooooo`2?ooooo`;o0?ZJ1?ooool3o`3jVSGooooo00?o0000ooooooooool00Ooo
ool000kooooo00?o0000ooooooooool01?ooool2o`0001oooooo0_l00?l6ooooo`03o`00ool0nY[o
0?ZJ00Co0?ZJU?ooool4o`3jVSKooooo0ol00003ooooo`003oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo023ooooo0ol00?l00ooooooo003oo`00o`3Gooooo`03o`000?oooooooooo
007ooooo000<ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`0Soooo
o`03o`00oooooooooooo0=Oooooo00?o0000ooooooooool00Oooool000cooooo00Go0000oooooooo
ooooooooo`000004ooooo`03o`000?oooooooooo0?gooooo00?o0000ooooooooool00Oooool000go
oooo0ol00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00Oooool001Gooooo
ool00002o`0000?ooooo003ooooooa[ooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-11.1862, -0.228616, \
0.409622, 0.0133735}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g4 = plot1[Xint      [[T1//Range,1,{1}]] ~ii~
           XintPoly  [[T1//Range,1,{1}]] ~ii~
           XintSpline[[T1//Range,1,{1}]] ~ii~ 
                     X[[T1//Range,1,{1}]]//AddTimeAxis[#,{0,10,.1}]&,
           color->{2,3,4,10}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0.0146927 0.291709 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01469 -6 -4.5 ]
[-0.0125 .01469 0 4.5 ]
[-0.0125 .16055 -18 -4.5 ]
[-0.0125 .16055 0 4.5 ]
[-0.0125 .3064 -6 -4.5 ]
[-0.0125 .3064 0 4.5 ]
[-0.0125 .45226 -18 -4.5 ]
[-0.0125 .45226 0 4.5 ]
[-0.0125 .59811 -6 -4.5 ]
[-0.0125 .59811 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .42662 -5 -6 ]
[.97619 .42662 5 6 ]
[.97619 .14771 -5 -6 ]
[.97619 .14771 5 6 ]
[.97619 .14771 -5 -6 ]
[.97619 .14771 5 6 ]
[.97619 .14771 -5 -6 ]
[.97619 .14771 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01469 m
.00625 .01469 L
s
[(0)] -0.0125 .01469 1 0 Mshowa
0 .16055 m
.00625 .16055 L
s
[(0.5)] -0.0125 .16055 1 0 Mshowa
0 .3064 m
.00625 .3064 L
s
[(1)] -0.0125 .3064 1 0 Mshowa
0 .45226 m
.00625 .45226 L
s
[(1.5)] -0.0125 .45226 1 0 Mshowa
0 .59811 m
.00625 .59811 L
s
[(2)] -0.0125 .59811 1 0 Mshowa
.125 Mabswid
0 .04386 m
.00375 .04386 L
s
0 .07303 m
.00375 .07303 L
s
0 .10221 m
.00375 .10221 L
s
0 .13138 m
.00375 .13138 L
s
0 .18972 m
.00375 .18972 L
s
0 .21889 m
.00375 .21889 L
s
0 .24806 m
.00375 .24806 L
s
0 .27723 m
.00375 .27723 L
s
0 .33557 m
.00375 .33557 L
s
0 .36474 m
.00375 .36474 L
s
0 .39392 m
.00375 .39392 L
s
0 .42309 m
.00375 .42309 L
s
0 .48143 m
.00375 .48143 L
s
0 .5106 m
.00375 .5106 L
s
0 .53977 m
.00375 .53977 L
s
0 .56894 m
.00375 .56894 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01469 m
1 .01469 L
s
.99375 .16055 m
1 .16055 L
s
.99375 .3064 m
1 .3064 L
s
.99375 .45226 m
1 .45226 L
s
.99375 .59811 m
1 .59811 L
s
.125 Mabswid
.99625 .04386 m
1 .04386 L
s
.99625 .07303 m
1 .07303 L
s
.99625 .10221 m
1 .10221 L
s
.99625 .13138 m
1 .13138 L
s
.99625 .18972 m
1 .18972 L
s
.99625 .21889 m
1 .21889 L
s
.99625 .24806 m
1 .24806 L
s
.99625 .27723 m
1 .27723 L
s
.99625 .33557 m
1 .33557 L
s
.99625 .36474 m
1 .36474 L
s
.99625 .39392 m
1 .39392 L
s
.99625 .42309 m
1 .42309 L
s
.99625 .48143 m
1 .48143 L
s
.99625 .5106 m
1 .5106 L
s
.99625 .53977 m
1 .53977 L
s
.99625 .56894 m
1 .56894 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .98 .604 r
gsave
.97619 .42662 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .3064 m
.03333 .3064 L
.04286 .3064 L
.05238 .3064 L
.0619 .3064 L
.07143 .3064 L
.08095 .3064 L
.09048 .3064 L
.1 .3064 L
.10952 .3064 L
.11905 .3064 L
.12857 .3064 L
.1381 .3064 L
.14762 .3064 L
.15714 .3064 L
.16667 .59738 L
.17619 .59738 L
.18571 .59738 L
.19524 .59738 L
.20476 .59738 L
.21429 .59738 L
.22381 .59738 L
.23333 .59738 L
.24286 .59738 L
.25238 .59738 L
.2619 .59738 L
.27143 .59738 L
.28095 .59738 L
.29048 .59738 L
.3 .59738 L
.30952 .59738 L
.31905 .59738 L
.32857 .59738 L
.3381 .59738 L
.34762 .59738 L
.35714 .59738 L
.36667 .59738 L
.37619 .59738 L
.38571 .59738 L
.39524 .59738 L
.40476 .59738 L
.41429 .59738 L
.42381 .59738 L
.43333 .59738 L
.44286 .59738 L
.45238 .59738 L
.4619 .59738 L
.47143 .59738 L
.48095 .59738 L
.49048 .59738 L
Mistroke
.5 .59738 L
.50952 .59738 L
.51905 .59738 L
.52857 .59738 L
.5381 .59738 L
.54762 .10059 L
.55714 .10059 L
.56667 .10059 L
.57619 .10059 L
.58571 .10059 L
.59524 .10059 L
.60476 .10059 L
.61429 .10059 L
.62381 .10059 L
.63333 .10059 L
.64286 .10059 L
.65238 .10059 L
.6619 .10059 L
.67143 .10059 L
.68095 .10059 L
.69048 .10059 L
.7 .10059 L
.70952 .10059 L
.71905 .10059 L
.72857 .10059 L
.7381 .10059 L
.74762 .10059 L
.75714 .10059 L
.76667 .10059 L
.77619 .10059 L
.78571 .10059 L
.79524 .10059 L
.80476 .10059 L
.81429 .10059 L
.82381 .10059 L
.83333 .10059 L
.84286 .10059 L
.85238 .10059 L
.8619 .10059 L
.87143 .10059 L
.88095 .42662 L
.89048 .42662 L
.9 .42662 L
.90952 .42662 L
.91905 .42662 L
.92857 .42662 L
.9381 .42662 L
.94762 .42662 L
.95714 .42662 L
.96667 .42662 L
Mistroke
.97619 .42662 L
Mfstroke
1 0 0 r
gsave
.97619 .14771 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3064 m
.03333 .3258 L
.04286 .3452 L
.05238 .3646 L
.0619 .384 L
.07143 .4034 L
.08095 .42279 L
.09048 .44219 L
.1 .46159 L
.10952 .48099 L
.11905 .50039 L
.12857 .51979 L
.1381 .53919 L
.14762 .55858 L
.15714 .57798 L
.16667 .59738 L
.17619 .58496 L
.18571 .57254 L
.19524 .56012 L
.20476 .5477 L
.21429 .53528 L
.22381 .52286 L
.23333 .51044 L
.24286 .49802 L
.25238 .4856 L
.2619 .47318 L
.27143 .46076 L
.28095 .44834 L
.29048 .43592 L
.3 .4235 L
.30952 .41108 L
.31905 .39866 L
.32857 .38624 L
.3381 .37382 L
.34762 .3614 L
.35714 .34899 L
.36667 .33657 L
.37619 .32415 L
.38571 .31173 L
.39524 .29931 L
.40476 .28689 L
.41429 .27447 L
.42381 .26205 L
.43333 .24963 L
.44286 .23721 L
.45238 .22479 L
.4619 .21237 L
.47143 .19995 L
.48095 .18753 L
.49048 .17511 L
Mistroke
.5 .16269 L
.50952 .15027 L
.51905 .13785 L
.52857 .12543 L
.5381 .11301 L
.54762 .10059 L
.55714 .1099 L
.56667 .11922 L
.57619 .12853 L
.58571 .13785 L
.59524 .14717 L
.60476 .15648 L
.61429 .1658 L
.62381 .17511 L
.63333 .18443 L
.64286 .19374 L
.65238 .20306 L
.6619 .21237 L
.67143 .22169 L
.68095 .231 L
.69048 .24032 L
.7 .24963 L
.70952 .25895 L
.71905 .26826 L
.72857 .27758 L
.7381 .28689 L
.74762 .29621 L
.75714 .30552 L
.76667 .31484 L
.77619 .32415 L
.78571 .33347 L
.79524 .34278 L
.80476 .3521 L
.81429 .36141 L
.82381 .37073 L
.83333 .38005 L
.84286 .38936 L
.85238 .39868 L
.8619 .40799 L
.87143 .41731 L
.88095 .42662 L
.89048 .39873 L
.9 .37084 L
.90952 .34295 L
.91905 .31506 L
.92857 .28716 L
.9381 .25927 L
.94762 .23138 L
.95714 .20349 L
.96667 .1756 L
Mistroke
.97619 .14771 L
Mfstroke
1 1 0 r
gsave
.97619 .14771 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3064 m
.03333 .35652 L
.04286 .40117 L
.05238 .44059 L
.0619 .47507 L
.07143 .50486 L
.08095 .5302 L
.09048 .55136 L
.1 .56856 L
.10952 .58204 L
.11905 .59203 L
.12857 .59877 L
.1381 .60246 L
.14762 .60332 L
.15714 .60156 L
.16667 .59738 L
.17619 .59098 L
.18571 .58255 L
.19524 .57228 L
.20476 .56035 L
.21429 .54693 L
.22381 .5322 L
.23333 .51631 L
.24286 .49943 L
.25238 .48171 L
.2619 .4633 L
.27143 .44435 L
.28095 .42498 L
.29048 .40533 L
.3 .38553 L
.30952 .36569 L
.31905 .34594 L
.32857 .32638 L
.3381 .30712 L
.34762 .28825 L
.35714 .26988 L
.36667 .25208 L
.37619 .23494 L
.38571 .21854 L
.39524 .20295 L
.40476 .18823 L
.41429 .17444 L
.42381 .16165 L
.43333 .14989 L
.44286 .13922 L
.45238 .12968 L
.4619 .12129 L
.47143 .11408 L
.48095 .10808 L
.49048 .1033 L
Mistroke
.5 .09976 L
.50952 .09746 L
.51905 .0964 L
.52857 .09658 L
.5381 .09798 L
.54762 .10059 L
.55714 .10439 L
.56667 .10935 L
.57619 .11544 L
.58571 .12262 L
.59524 .13085 L
.60476 .14008 L
.61429 .15025 L
.62381 .16131 L
.63333 .17319 L
.64286 .18582 L
.65238 .19912 L
.6619 .21301 L
.67143 .22741 L
.68095 .24222 L
.69048 .25735 L
.7 .27268 L
.70952 .28812 L
.71905 .30355 L
.72857 .31884 L
.7381 .33388 L
.74762 .34853 L
.75714 .36266 L
.76667 .37611 L
.77619 .38876 L
.78571 .40044 L
.79524 .411 L
.80476 .42026 L
.81429 .42807 L
.82381 .43426 L
.83333 .43862 L
.84286 .441 L
.85238 .44118 L
.8619 .43898 L
.87143 .4342 L
.88095 .42662 L
.89048 .41604 L
.9 .40223 L
.90952 .38497 L
.91905 .36404 L
.92857 .3392 L
.9381 .3102 L
.94762 .27681 L
.95714 .23877 L
.96667 .19582 L
Mistroke
.97619 .14771 L
Mfstroke
0 g
gsave
.97619 .14771 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3064 m
.03333 .33552 L
.04286 .36436 L
.05238 .39261 L
.0619 .42 L
.07143 .44626 L
.08095 .47111 L
.09048 .49433 L
.1 .51566 L
.10952 .53491 L
.11905 .55187 L
.12857 .56638 L
.1381 .57829 L
.14762 .58748 L
.15714 .59387 L
.16667 .59738 L
.17619 .59799 L
.18571 .59568 L
.19524 .59048 L
.20476 .58245 L
.21429 .57165 L
.22381 .55821 L
.23333 .54225 L
.24286 .52393 L
.25238 .50344 L
.2619 .48098 L
.27143 .45678 L
.28095 .43107 L
.29048 .40412 L
.3 .37619 L
.30952 .34757 L
.31905 .31853 L
.32857 .28937 L
.3381 .26039 L
.34762 .23186 L
.35714 .20408 L
.36667 .17731 L
.37619 .15184 L
.38571 .12792 L
.39524 .10577 L
.40476 .08564 L
.41429 .0677 L
.42381 .05216 L
.43333 .03915 L
.44286 .02881 L
.45238 .02125 L
.4619 .01653 L
.47143 .01472 L
.48095 .01581 L
.49048 .01981 L
Mistroke
.5 .02667 L
.50952 .03633 L
.51905 .04869 L
.52857 .06362 L
.5381 .08098 L
.54762 .10059 L
.55714 .12226 L
.56667 .14576 L
.57619 .17087 L
.58571 .19734 L
.59524 .22489 L
.60476 .25326 L
.61429 .28216 L
.62381 .31131 L
.63333 .3404 L
.64286 .36915 L
.65238 .39728 L
.6619 .4245 L
.67143 .45054 L
.68095 .47514 L
.69048 .49805 L
.7 .51905 L
.70952 .53792 L
.71905 .55448 L
.72857 .56856 L
.7381 .58003 L
.74762 .58875 L
.75714 .59466 L
.76667 .59769 L
.77619 .5978 L
.78571 .59501 L
.79524 .58933 L
.80476 .58082 L
.81429 .56957 L
.82381 .5557 L
.83333 .53933 L
.84286 .52063 L
.85238 .4998 L
.8619 .47703 L
.87143 .45255 L
.88095 .42662 L
.89048 .39949 L
.9 .37142 L
.90952 .34271 L
.91905 .31363 L
.92857 .28448 L
.9381 .25555 L
.94762 .22713 L
.95714 .1995 L
.96667 .17293 L
Mistroke
.97619 .14771 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`006_ooool2o`0002gooooo1Ol0000_ooooo`?o0000;Oooool3o`0002kooooo0ol0000/oooo
o`?o00001?ooool2o`0000?ooooo000Iooooo`04o`000?ooooooooooo`0002gooooo00Co0000oooo
oooooooo0000<?ooool00ol0003oooooooooo`0[ooooo`05o`000?ooooooooooooooool00000;?oo
ool01Ol0003ooooooooooooooooo000002cooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00002ooooo`006Oooool01?l0003oooooooooool0000^ooooo`03o`000?oooooooooo02go
oooo1Ol0000/ooooo`05o`000?ooooooooooooooool00000;?ooool01Ol0003ooooooooooooooooo
000002cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`006Oooool0
1?l0003oooooooooool0000_ooooo`03o`000?oooooooooo02cooooo00Co0000oooooooooooo0000
;Oooool4o`0002kooooo0ol0000]ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000_ooool001Wooooo00Co0000oooooooooooo0000;?ooool01Ol0003ooooooooooooooooo0000
02kooooo00?o0000ooooool00000;Oooool00ol0003oooooooooo`0^ooooo`05o`000?oooooooooo
ooooool00000;?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo000I
ooooo`04o`000?ooooooooooo`0002cooooo00Go0000ooooooooooooooooo`00000_ooooo`;o0000
;_ooool00ol0003oooooooooo`0]ooooo`05o`000?ooooooooooooooool00000:oooool2o`0000Co
oooo00Co0000oooooooooooo00000_ooool001[ooooo0_l0000^ooooo`?o0000<Oooool00ol0003o
ooooooooo`0]ooooo`;o0000;_ooool3o`0002gooooo00?o0000ooooooooool00oooool2o`0000?o
oooo003ooooooa[ooooo003ooooooa[ooooo003ooooooa[ooooo003ooooooa[ooooo000Eoooooooo
00001Ol0000000kooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo0Ol0000000gooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02kooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`03ooooo`7o0000000=ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool0ooooool1ooooo`7o0000000=ooooo`04o`000?oo
ooooooooo`0000Cooooo0_l0001eooooo`So0000P_ooool3o`0000003Oooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooooooo07?ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`21ooooo`7o0000000=ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0
LOooool2o`0000[ooooo00?o0000ooooooooool0P?ooool1o`0000003_ooool2o`0000Gooooo00?o
0000ooooooooool0L?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo07oooooo0Ol0
000001Gooooo00?o0000ooooooooool0Koooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo07kooooo0Ol0000001Gooooo00?o0000ooooooooool0K_ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo07gooooo0Ol0000001Gooooo00?o0000ooooooooool0KOooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo07cooooo0Ol0000001Gooooo0_l0001^ooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool0Noooool2o`0000005Oooool00ol0003ooooooooo
o`1/ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Noooool1o`0000005Oooool0
0ol0003oooooooooo`1/ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0N_ooool1
o`0000005Oooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool0N_ooool1o`0000005Oooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0NOooool1o`0000005Oooool00ol0003oooooooooo`1Zooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool0N?ooool1o`0000005Oooool00ol0003ooooooooo
o`1Yooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Moooool1o`0000005Oooool0
0ol0003oooooooooo`1Xooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0Moooool1
o`0000005Oooool2o`0006Wooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1eoooo
o`;o0000000Eooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`1fooooo`7o0000000Eooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`1eooooo`7o0000000Eooooo`03o`000?oooooooooo06Kooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`1eooooo`7o0000000Eooooo`03o`000?oooooo
oooo06Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`1dooooo`7o0000000Eoooo
o`03o`000?oooooooooo06Gooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1coooo
o`7o0000000Eooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool06?ooool8oooo00;o
oooo00?o0000ooooooooool0Loooool1o`0000005Oooool00ol0003oooooooooo`1Tooooo`03o`00
0?oooooooooo01Kooooo0oooo`08ooooo`?oool000?o0000oooo0?l0nYX0D_l0nYXPooooo`7o0000
000Eooooo`;o0000IOooool00ol0003oooooooooo`0Dooooo`;oool03Oooool00ooo003o0000oooo
o`03oooo04oooooo00?o0?ZJooooooooool07Oooool2o`0000005Oooool00ol0003oooooooooo`1S
ooooo`03o`000?oooooooooo01?ooooo0_ooo`0>ooooo`04ool00?oooooo0?ZJo`0000?ooooo00?o
ool0ooooooooool0C?ooool00ol0nY[oooooooooo`0Nooooo`7o0000000Eooooo`03o`000?oooooo
oooo06?ooooo00?o0000ooooooooool04_ooool00oooo`3oooooooooo`0=ooooo`05ool00?oooooo
ooooo`3jV_l000000_oo0002ooooo`03oooo0?oooooooooo04_ooooo00?o0?ZJooooooooool07_oo
ool1o`0000005Oooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo017ooooo0_ooo`0@
ooooo`05ool00?ooooooooooo`3jV_l000000_ooool01?oo003oooooooooooooo`1<ooooo`03o`3j
V_oooooooooo01kooooo0Ol0000001Gooooo00?o0000ooooooooool0H_ooool00ol0003ooooooooo
o`0@ooooo`03oooo0?oooooooooo00oooooo00Ooo`00ooooooooooooooooo`3jV_oooooo000000;o
oooo00Coo`00ooooooooooooool0Boooool00ol0nY[oooooooooo`0Nooooo`7o0000000Eooooo`03
o`000?oooooooooo06;ooooo00?o0000ooooooooool03oooool00oooo`3oooooooooo`0@ooooo`07
ool00?ooooooooooooooool0nY[oooooo`000003ooooo`03ool00?oooooooooo00;oool0BOooool0
0ol0nY[oooooooooo`0Nooooo`7o0000000Eooooo`03o`000?oooooooooo067ooooo00?o0000oooo
ooooool03oooool00oooo`3oooooooooo`0@ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJoooo
ool000001?ooool01Ooo003oooooooooooooooooool004Sooooo00?o0?ZJooooooooool07_ooool1
o`0000005Oooool2o`0006;ooooo00?o0000ooooooooool03Oooool2oooo01;ooooo00?oo`00oooo
ooooool00oooool01?l0nY[oooooooooool00003ooooo`03ool00?oooooooooo00;ooooo00?oool0
ooooooooool0AOooool00ol0nY[oooooooooo`0Mooooo`;o0000000Eooooo`03o`000?oooooooooo
063ooooo00?o0000ooooooooool03Oooool00oooo`3oooooooooo`0Aooooo`03ool00?oooooooooo
00Cooooo00Co0?ZJoooooooooooo00001?ooool00ooo003oooooooooo`02ooooo`03oooo0?oooooo
oooo04Cooooo00?o0?ZJooooooooool07_ooool1o`0000005Oooool00ol0003oooooooooo`1Poooo
o`03o`000?oooooooooo00cooooo00?oool0ooooooooool04Oooool00ooo003oooooooooo`05oooo
o`05o`3jV_ooooooooooooooool000001?ooool2ool000?ooooo00?oool0ooooooooool0@oooool0
0ol0nY[oooooooooo`0Nooooo`7o0000000Eooooo`03o`000?oooooooooo05oooooo00?o0000oooo
ooooool03Oooool00oooo`3oooooooooo`0Aooooo`03ool00?oooooooooo00Gooooo00Go0?ZJoooo
ooooooooooooo`000006ooooo`05ool00?ooooooooooooooooooo`00A?ooool00ol0nY[ooooooooo
o`0Nooooo`7o0000000Eooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool03?ooool0
0oooo`3oooooooooo`0Aooooo`03ool00?oooooooooo00Kooooo00?o0?ZJooooooooool00_ooool0
0ol0003oooooooooo`04ooooo`05ool00?ooooooooooooooooooo`00@oooool00ol0nY[ooooooooo
o`0Hooooo`03o`000?oooooooooo00?ooooo0Ol0000000;ooooo0_l00004ooooo`03o`000?oooooo
oooo00;ooooo0ol00005ooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool03?ooool0
0oooo`3oooooooooo`0Aooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool0
0ol0003oooooooooo`04ooooo`03ool00?oooooooooo00;ooooo00?oool0ooooooooool0@?ooool0
0ol0nY[oooooooooo`0Hooooo`03o`000?oooooooooo00?ooooo0Ol000000005ooooool0003ooooo
ooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0G_oo
ool00ol0003oooooooooo`0<ooooo`03oooo0?oooooooooo013ooooo00?oo`00ooooooooool02?oo
ool00ol0nY[oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00Goo`00oooooooooooooooo
oooo0012ooooo`03o`3jV_oooooooooo01Oooooo00?o0000oooo0?ooool01?ooool1o`00000000Go
ooooo`000?ooooooooooo`00000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
G_ooool00ol0003oooooooooo`0;ooooo`03oooo0?oooooooooo013ooooo00?oo`00ooooooooool0
2Oooool00ol0nY[oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo0_oo0002ooooo`03oooo
0?oooooooooo03oooooo00?o0?ZJooooooooool05oooool00ol0003oooooooooo`04ooooo`7o0000
00001Ooooooo0000oooooooooooo000000_ooooo00?o0000ooooooooool00_ooool2o`0005kooooo
00?o0000ooooooooool02oooool00oooo`3oooooooooo`0@ooooo`03ool00?oooooooooo00[ooooo
00?o0?ZJooooooooool00oooool00ol0003oooooooooo`07ooooo`04ool00?oooooooooooooo043o
oooo00?o0?ZJooooooooool05_ooool00ol0003oool0ooooo`03ooooo`?o000000001Ooooooo0000
oooooooooooo000000Oooooo1?l00005ooooo`03o`000?oooooooooo05gooooo00?o0000oooooooo
ool02_ooool00oooo`3oooooooooo`0Aooooo`03ool00?oooooooooo00[ooooo00?o0?ZJoooooooo
ool01?ooool00ol0003oooooooooo`07ooooo`04ool00?oooooooooooooo03oooooo00?o0?ZJoooo
ooooool05_ooool00ol0003oool0ooooo`05ooooo`7o000000001Ooooooo0000oooooooooooo0000
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo
00Wooooo00?oool0ooooooooool04Oooool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo
00Cooooo00?o0000ooooooooool02?ooool01?oo003oooooooooooooo`0nooooo`03o`3jV_oooooo
oooo01Kooooo00?o0000oooo0?ooool01Oooool1o`0000000_ooool2o`0000Sooooo1Ol00004oooo
o`03o`000?oooooooooo05cooooo00?o0000ooooooooool02Oooool00oooo`3oooooooooo`0Aoooo
o`03ool00?oooooooooo00cooooo00?o0?ZJooooooooool01?ooool00ol0003oooooooooo`09oooo
o`04ool00?oooooooooooooo03gooooo00?o0?ZJooooooooool05Oooool00ol0003oool0ooooo`06
ooooo`7o0000000Eooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool02Oooool00ooo
o`3oooooooooo`0Aooooo`03ool00?oooooooooo00cooooo00?o0?ZJooooooooool01?ooool00ol0
003oooooooooo`0:ooooo`03ool00?ooooooool003gooooo00?o0?ZJooooooooool05Oooool00ol0
003oool0ooooo`06ooooo`7o0000000Eooooo`03o`000?oooooooooo05cooooo00?o0000oooooooo
ool02?ooool00oooo`3oooooooooo`0Aooooo`03ool00?oooooooooo00gooooo00?o0?ZJoooooooo
ool01Oooool00ol0003oooooooooo`0:ooooo`03ool00?ooooooool003cooooo00?o0?ZJoooooooo
ool05Oooool00ol0003oool0ooooo`06ooooo`7o0000000Eooooo`03o`000?oooooooooo05_ooooo
00?o0000ooooooooool02Oooool00oooo`3oooooooooo`0@ooooo`03ool00?oooooooooo00gooooo
00?o0?ZJooooooooool01_ooool00ol0003oooooooooo`0;ooooo`03ool00?ooooooool003cooooo
00?o0?ZJooooooooool04oooool00ol0003oo`00oooo0007ooooo`7o0000000Eooooo`;o0000G?oo
ool00ol0003oooooooooo`08ooooo`03oooo0?oooooooooo013ooooo00?oo`00ooooooooool03_oo
ool00ol0nY[oooooooooo`06ooooo`03o`000?oooooooooo00cooooo00?oo`00oooo0?ooool0>ooo
ool00ol0nY[oooooooooo`0Cooooo`03o`000?ooooooool000Kooooo0_l0000001Gooooo00?o0000
ooooooooool0F_ooool00ol0003oooooooooo`09ooooo`03oooo0?oooooooooo013ooooo00?oo`00
ooooooooool03_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?oo`00
oooo0?ooool0>_ooool00ol0nY[oooooooooo`0Cooooo`03o`000?ooo`3ooooo00Oooooo0Ol00000
01Gooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`08ooooo`03oooo0?oooooooooo
013ooooo00?oo`00ooooooooool03oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
00gooooo00?oo`00oooo0?ooool0>Oooool00ol0nY[oooooooooo`0Booooo`03o`000?oo003oool0
00Sooooo0Ol0000001Gooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`07ooooo`03
oooo0?oooooooooo013ooooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo00kooooo00?oo`00oooo0?ooool0>?ooool00ol0nY[oooooooooo`0Booooo`03
o`000?ooooooool000Sooooo0Ol0000001Gooooo00?o0000ooooooooool0FOooool00ol0003ooooo
ooooo`07ooooo`03oooo0?oooooooooo013ooooo00?oo`00ooooooooool04Oooool00ol0nY[ooooo
ooooo`08ooooo`03o`000?oooooooooo00kooooo00?oool0ooooooooool0=oooool00ol0nY[ooooo
ooooo`0Booooo`03o`000?ooooooool000Sooooo0Ol0000001Gooooo00?o0000ooooooooool0FOoo
ool00ol0003oooooooooo`07ooooo`03oooo0?oooooooooo00oooooo00?oo`00ooooooooool04_oo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo00oooooo00?oool0ooooooooool0=_oo
ool00ol0nY[oooooooooo`0Aooooo`04o`000?oo003ooooooooo00Sooooo0Ol0000001Gooooo00?o
0000ooooooooool0FOooool00ol0003oooooooooo`06ooooo`03oooo0?oooooooooo00oooooo00?o
o`00ooooooooool04oooool00ol0nY[oooooooooo`09ooooo`03o`000?oooooooooo00oooooo00?o
ool0ooooooooool0=Oooool00ol0nY[oooooooooo`0Aooooo`03o`000?ooooooool000Wooooo0Ol0
000001Gooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`07ooooo`03oooo0?oooooo
oooo00oooooo00?oo`00ooooooooool04oooool00ol0nY[oooooooooo`09ooooo`03o`000?oooooo
oooo00oooooo00?oool0ool00?ooool0=Oooool00ol0nY[oooooooooo`0@ooooo`04o`000?oo003o
oooooooo00Wooooo0Ol0000001Gooooo0_l0001Iooooo`03o`000?oooooooooo00Kooooo00?oool0
ooooooooool03oooool00ooo003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Wooooo00?o0000
ooooooooool04?ooool00oooo`3oo`00ooooo`0dooooo`03o`3jV_oooooooooo013ooooo00Co0000
ooooooooooooool02?ooool2o`0000005Oooool00ol0003oooooooooo`1Hooooo`03o`000?oooooo
oooo00Kooooo00?oool0ooooooooool03_ooool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooo
oooo00[ooooo00?o0000ooooooooool04?ooool00oooo`3oo`00ooooo`0cooooo`03o`3jV_oooooo
oooo013ooooo00Co0000ooooooooooooool02Oooool1o`0000005Oooool00ol0003oooooooooo`1G
ooooo`03o`000?oooooooooo00Kooooo00?oool0ooooooooool03oooool00ooo003oooooooooo`0E
ooooo`03o`3jV_oooooooooo00[ooooo00?o0000ooooooooool04Oooool00oooo`3oo`00ooooo`0b
ooooo`03o`3jV_oooooooooo00oooooo00Go0000ool00?oooooooooooooo0009ooooo`7o0000000E
ooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool01Oooool00oooo`3oooooooooo`0?
ooooo`03ool00?oooooooooo01Kooooo00?o0?ZJooooooooool02_ooool00ol0003oooooooooo`0A
ooooo`04oooo0?ooooooo`00ool0037ooooo00?o0?ZJooooooooool03oooool01?l0003ooooooooo
ooooo`0:ooooo`7o0000000Eooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool01?oo
ool00oooo`3oooooooooo`0?ooooo`03ool00?oooooooooo01Oooooo00?o0?ZJooooooooool02ooo
ool00ol0003oooooooooo`0Aooooo`04oooo0?ooooooooooool0033ooooo00?o0?ZJooooooooool0
3oooool01?l0003oooooooooooooo`0:ooooo`7o0000000Eooooo`03o`000?oooooooooo05Kooooo
00?o0000ooooooooool01Oooool00oooo`3oooooooooo`0>ooooo`03ool00?oooooooooo01Sooooo
00?o0?ZJooooooooool02oooool00ol0003oooooooooo`0Aooooo`05oooo0?oooooooooooooooooo
0000;oooool00ol0nY[oooooooooo`0>ooooo`05o`000?oo003oooooooooooooo`002_ooool1o`00
00005Oooool00ol0003oooooooooo`1Fooooo`03o`000?oooooooooo00Cooooo00?oool0oooooooo
ool03oooool00ooo003oooooooooo`0Hooooo`03o`3jV_oooooooooo00_ooooo00?o0000oooooooo
ool04_ooool01?ooo`3ooooooooooooo000_ooooo`03o`3jV_oooooooooo00kooooo00Go0000oooo
oooooooooooooooo000:ooooo`7o0000000Eooooo`;o0000Eoooool00ol0003oooooooooo`04oooo
o`03oooo0?oooooooooo00kooooo00?oo`00ooooooooool06Oooool00ol0nY[oooooooooo`0;oooo
o`03o`000?oooooooooo01;ooooo00Goool0ooooooooooooooooool0000^ooooo`03o`3jV_oooooo
oooo00kooooo00Go0000oooooooooooooooooooo0009ooooo`;o0000000Eooooo`03o`000?oooooo
oooo05Gooooo00?o0000ooooooooool01?ooool00oooo`3oooooooooo`0>ooooo`03ool00?oooooo
oooo01[ooooo00?o0?ZJooooooooool03?ooool00ol0003oooooooooo`0Booooo`04oooo0?oooooo
ooooooooo`;oo`00;?ooool00ol0nY[oooooooooo`0=ooooo`05o`000?oo003oooooooooooooo`00
2oooool1o`0000005Oooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo00Cooooo00?o
ool0ooooooooool03_ooool00ooo003oooooooooo`0Jooooo`03o`3jV_oooooooooo00cooooo00?o
0000ooooooooool04oooool00oooo`3oooooooooo`02ooooo`03ool00?oooooooooo02Wooooo00?o
0?ZJooooooooool03Oooool01Ol0003oooooooooooooooooool000_ooooo0Ol0000001Gooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`03ooooo`03oooo0?oooooooooo00kooooo00?o
o`00ooooooooool06oooool00ol0nY[oooooooooo`0<ooooo`03o`000?oooooooooo01Cooooo00?o
ool0ooooooooool00_ooool00ooo003oooooooooo`0Xooooo`03o`3jV_oooooooooo00gooooo00Go
0000oooooooooooooooooooo000;ooooo`7o0000000Eooooo`03o`000?oooooooooo05Cooooo00?o
0000ooooooooool00oooool00oooo`3oooooooooo`0>ooooo`03ool00?oooooooooo01cooooo00?o
0?ZJooooooooool03Oooool00ol0003oooooooooo`0Cooooo`03oooo0?oooooooooo00;ooooo00?o
o`00ooooooooool0:?ooool00ol0nY[oooooooooo`0<ooooo`05o`000?oo003oooooooooooooo`00
3?ooool1o`0000005Oooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo00?ooooo00?o
ool0ooooooooool03Oooool00ooo003oooooooooo`0Mooooo`03o`3jV_oooooooooo00gooooo00?o
0000ooooooooool05?ooool00oooo`3oooooooooo`02ooooo`03ool00?oooooooooo02Oooooo00?o
0?ZJooooooooool03?ooool01Ol0003oooooooooooooooooool000cooooo0Ol0000001Gooooo00?o
0000ooooooooool0E?ooool00ol0003oooooooooo`02ooooo`03oooo0?oooooooooo00gooooo00?o
o`00ooooooooool07_ooool00ol0nY[oooooooooo`0>ooooo`03o`000?oooooooooo01?ooooo00?o
ool0ooooooooool00oooool00ooo003oooooooooo`0Vooooo`03o`3jV_oooooooooo00cooooo00Go
0000oooooooooooooooooooo000<ooooo`7o0000000Eooooo`03o`000?oooooooooo05?ooooo00?o
0000ooooooooool00oooool00oooo`3oooooooooo`0<ooooo`03ool00?oooooooooo01oooooo00?o
0?ZJooooooooool03_ooool00ol0003oooooooooo`0Dooooo`03oooo0?oooooooooo00?ooooo00?o
o`00ooooooooool09Oooool00ol0nY[oooooooooo`0;ooooo`05o`000?oo003oooooooooooooo`00
3Oooool1o`0000005Oooool2o`0005Cooooo00?o0000ooooooooool00_ooool00oooo`3ooooooooo
o`0=ooooo`03ool00?oooooooooo01oooooo00?o0?ZJooooooooool03_ooool00ol0003ooooooooo
o`0Dooooo`03oooo0?oooooooooo00Cooooo0_oo000Uooooo`03o`3jV_oooooooooo00_ooooo00Go
0000oooooooooooooooooooo000<ooooo`;o0000000Eooooo`03o`000?oooooooooo05?ooooo00?o
0000ooooooooool00_ooool00oooo`3oooooooooo`0<ooooo`03ool00?oooooooooo023ooooo00?o
0?ZJooooooooool03oooool00ol0003oooooooooo`0Dooooo`03oooo0?oooooooooo00Gooooo00?o
o`00ooooooooool08_ooool00ol0nY[oooooooooo`0;ooooo`05o`000?ooooooooooooooooooo`00
3Oooool1o`0000005Oooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo00?ooooo00?o
ool0ooooooooool02oooool00ooo003oooooooooo`0Qooooo`03o`3jV_oooooooooo00oooooo00?o
0000ooooooooool05Oooool00oooo`3oooooooooo`05ooooo`03ool00?oooooooooo027ooooo00?o
0?ZJooooooooool02_ooool00ol0003oo`00ooooo`02ooooo`03oooo0?oooooooooo00_ooooo0Ol0
000001Gooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`02ooooo`03oooo0?oooooo
oooo00cooooo00?oo`00ooooooooool08Oooool00ol0nY[oooooooooo`0?ooooo`03o`000?oooooo
oooo01Kooooo00?oool0ooooooooool01?ooool00ooo003oooooooooo`0Qooooo`03o`3jV_oooooo
oooo00[ooooo00Go0000oooooooooooooooooooo000>ooooo`7o0000000Eooooo`03o`000?oooooo
oooo05;ooooo00?o0000ooooooooool00_ooool00oooo`3oooooooooo`0;ooooo`03ool00?oooooo
oooo02;ooooo00?o0?ZJooooooooool04?ooool00ol0003oooooooooo`0Eooooo`03oooo0?oooooo
oooo00Gooooo00?oo`00ooooooooool08?ooool00ol0nY[oooooooooo`0:ooooo`05o`000?oooooo
ooooooooooooo`003_ooool1o`0000003Oooool3o`0000Gooooo00?o0000ooooooooool0DOooool0
0ol0003oooooooooo`02ooooo`03oooo0?oooooooooo00_ooooo00?oo`00ooooooooool08oooool0
0ol0nY[oooooooooo`0@ooooo`03o`000?oooooooooo01Kooooo00?oool0ooooooooool01Oooool2
ool0023ooooo00?o0?ZJooooooooool02Oooool00ol0003oo`00ooooo`02ooooo`03oooo0?oooooo
oooo00cooooo0Ol0000000kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Aoooo
o`05o`000?ooooooooooooooooooo`003Oooool00ooo003oooooooooo`0Tooooo`03o`3jV_oooooo
oooo013ooooo00?o0000ooooooooool05_ooool00oooo`3oooooooooo`07ooooo`03ool00?oooooo
oooo01gooooo00?o0?ZJooooooooool02Oooool00ol0003oooooooooo`02ooooo`03oooo0?oooooo
oooo00cooooo0Ol0000000kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Aoooo
o`05o`000?ooooooooooooooooooo`003Oooool00ooo003oooooooooo`0Tooooo`03o`3jV_oooooo
oooo013ooooo00?o0000ooooooooool05oooool00oooo`3oooooooooo`07ooooo`03ool00?oooooo
oooo01cooooo00?o0?ZJooooooooool02Oooool01Ol0003oooooooooooooooooool000oooooo0Ol0
000000kooooo00?o0000ooooooooool01?ooool2o`0000Cooooo00?o0000o`3jV_l0nYX08?l0nYXZ
ooooo`05o`000?ooooooooooooooooooo`003Oooool00ooo003oooooooooo`0Uooooo`03o`3jV_oo
oooooooo017ooooo00?o0000ooooooooool05_ooool00oooo`3oooooooooo`07ooooo`03ool00?oo
oooooooo01cooooo00?o0?ZJooooooooool02?ooool00ol0003oo`00ooooo`02ooooo`03oooo0?oo
oooooooo00_ooooo0ol0000000kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo01oooooo00?o0?ZJooooooooool0:?ooool01Ol0003ooooooooooooo
ooooool000cooooo00?oo`00ooooooooool09_ooool00ol0nY[oooooooooo`0Aooooo`03o`000?oo
oooooooo01Oooooo00?oool0ooooooooool01oooool00ooo003oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool00_ooool00oooo`3oooooooooo`0=ooooo`7o0000000=
ooooo`;o00001_ooool00ol0003oooooooooo`03ooooo`03o`000?oo003ooooo01oooooo00?o0?ZJ
ooooooooool0:?ooool01?l0003oooooooooooooo`0<ooooo`03ool00?oooooooooo02Oooooo00?o
0?ZJooooooooool04Oooool00ol0003oooooooooo`0Gooooo`03oooo0?oooooooooo00Sooooo0_oo
000Kooooo`03o`3jV_oooooooooo00Sooooo00Go0000oooooooooooooooooooo000@ooooo`7o0000
000>ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00oooo`3o0000oooo
o`0Oooooo`03o`3jV_oooooooooo02Oooooo00Go0000oooooooooooooooooooo000;ooooo`03ool0
0?oooooooooo02Sooooo00?o0?ZJooooooooool04_ooool00ol0003oooooooooo`0Gooooo`03oooo
0?oooooooooo00Wooooo00?oo`00ooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oo003ooooo00;ooooo00?oool0ooooooooool03_ooool1o`0000005Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo01kooooo00?o0?ZJooooooooool09oooool01Ol0003ooooooooo
ooooooooool000[ooooo00?oo`00ooooooooool0:Oooool00ol0nY[oooooooooo`0Booooo`03o`00
0?oooooooooo01Oooooo00?oool0ooooooooool02_ooool00ooo003oooooooooo`0Gooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool00_ooool00oooo`3oooooooooo`0>ooooo`7o0000
000Eooooo`03o`000?oooooooooo00Cooooo00?o0000ool00?ooool07_ooool00ol0nY[ooooooooo
o`0Wooooo`04o`000?oooooooooooooo00_ooooo00?oo`00ooooooooool0:Oooool00ol0nY[ooooo
ooooo`0Cooooo`03o`000?oooooooooo01Oooooo00?oool0ooooooooool02Oooool00ooo003ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00Oooooo00Go0000oooooooooooooooooooo000Aooooo`7o
0000000Eooooo`03o`000?oooooooooo00Cooooo00?oool0o`000?ooool07_ooool00ol0nY[ooooo
ooooo`0Vooooo`05o`000?ooooooooooooooooooo`002_ooool00ooo003oooooooooo`0Zooooo`03
o`3jV_oooooooooo01?ooooo00?o0000ooooooooool06?ooool00oooo`3oooooooooo`09ooooo`03
ool00?oooooooooo01Kooooo00?o0?ZJooooooooool01_ooool00ol0003oooooooooo`02ooooo`03
oooo0?oooooooooo00oooooo0Ol0000001Gooooo0_l00005ooooo`03oooo0?l0003oo`0001kooooo
00?o0?ZJooooooooool09_ooool01?l0003oooooooooooooo`0:ooooo`03ool00?oooooooooo02_o
oooo00?o0?ZJooooooooool04oooool00ol0003oooooooooo`0Iooooo`03oooo0?oooooooooo00Wo
oooo0_oo000Fooooo`03o`3jV_oooooooooo00Kooooo00?o0000ooooooooool00_ooool00oooo`3o
ooooooooo`0>ooooo`;o0000000Eooooo`03o`000?oooooooooo00Cooooo00Coool0o`000?oooooo
o`007Oooool00ol0nY[oooooooooo`0Vooooo`03o`000?ooooooool000_ooooo00?oo`00oooooooo
ool0:oooool00ol0nY[oooooooooo`0Dooooo`03o`000?oooooooooo01Sooooo00?oool0oooooooo
ool02oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Kooooo00Go0000oooooooo
oooooooooooo000Booooo`7o0000000Eooooo`03o`000?oooooooooo00Cooooo00Coool0ooooool0
003oo`007Oooool00ol0nY[oooooooooo`0Uooooo`04o`000?oooooooooooooo00[ooooo00?oo`00
ooooooooool0;?ooool00ol0nY[oooooooooo`0Dooooo`03o`000?oooooooooo01Wooooo00?oool0
ooooooooool02oooool00ooo003oooooooooo`0Booooo`03o`3jV_oooooooooo00Gooooo00?o0000
ooooooooool00_ooool00oooo`3oooooooooo`0@ooooo`7o0000000Eooooo`03o`000?oooooooooo
00Gooooo00Coool0o`000?ooooooo`007?ooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooo
ool000[ooooo00?oo`00ooooooooool0;Oooool00ol0nY[oooooooooo`0Dooooo`03o`000?oooooo
oooo01[ooooo00?oool0ooooooooool02oooool00ooo003oooooooooo`0Aooooo`03o`3jV_oooooo
oooo00Gooooo00Go0000oooooooooooooooooooo000Cooooo`7o0000000Eooooo`03o`000?oooooo
oooo00Gooooo00Coool0o`000?ooooooo`007?ooool00ol0nY[oooooooooo`0Uooooo`03o`000?oo
ooooool000Wooooo00?oo`00ooooooooool0;Oooool00ol0nY[oooooooooo`0Fooooo`03o`000?oo
oooooooo01Wooooo00?oool0ooooooooool03?ooool00ooo003oooooooooo`0Aooooo`03o`3jV_oo
oooooooo00Cooooo00Go0000oooooooooooooooooooo000Cooooo`7o0000000Eooooo`03o`000?oo
oooooooo00Gooooo00Goool0ooooool0003oooooool0000Kooooo`03o`3jV_oooooooooo02Cooooo
00?o0000ooooooooo`002_ooool00ooo003oooooooooo`0]ooooo`03o`3jV_oooooooooo01Kooooo
00?o0000ooooooooool06_ooool00oooo`3oooooooooo`0<ooooo`03ool00?oooooooooo013ooooo
00?o0?ZJooooooooool00oooool00ol0003oooooooooo`02ooooo`03oooo0?oooooooooo017ooooo
0Ol0000001Gooooo00?o0000ooooooooool01Oooool01Oooo`3oooooo`000?ooooooo`0001cooooo
00?o0?ZJooooooooool08oooool00ol0003ooooooooo0009ooooo`03ool00?oooooooooo02kooooo
00?o0?ZJooooooooool05_ooool00ol0003oooooooooo`0Kooooo`03oooo0?oooooooooo00cooooo
00?oo`00ooooooooool03oooool00ol0nY[oooooooooo`03ooooo`05o`000?oooooooooooooooooo
o`005?ooool1o`0000005Oooool00ol0003oooooooooo`05ooooo`05oooo0?oooooo0000oooooooo
00007?ooool00ol0nY[oooooooooo`0Sooooo`03o`000?ooooooool000Sooooo00?oo`00oooooooo
ool0;oooool00ol0nY[oooooooooo`0Fooooo`03o`000?oooooooooo01cooooo00?oool0oooooooo
ool03?ooool00ooo003oooooooooo`0>ooooo`03o`3jV_oooooooooo00?ooooo00Go0000oooooooo
oooooooooooo000Dooooo`7o0000000Eooooo`;o00001oooool01Oooo`3oooooo`000?ooooooo`00
01_ooooo00?o0?ZJooooooooool08_ooool00ol0003ooooooooo0008ooooo`03ool00?oooooooooo
033ooooo00?o0?ZJooooooooool05oooool00ol0003oooooooooo`0Kooooo`03oooo0?oooooooooo
00gooooo00?oo`00ooooooooool03Oooool00ol0nY[oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?oool0ooooooooool04Oooool2o`0000005Oooool00ol0003oooooooooo`06ooooo`05
oooo0?oooooo0000oooooooo00006oooool00ol0nY[oooooooooo`0Rooooo`03o`000?ooooooool0
00Oooooo00?oo`00ooooooooool0<Oooool00ol0nY[oooooooooo`0Gooooo`03o`000?oooooooooo
01cooooo00?oool0ooooooooool03Oooool00ooo003oooooooooo`0<ooooo`03o`3jV_oooooooooo
00;ooooo00Go0000oooooooooooooooooooo000Eooooo`7o0000000Eooooo`03o`000?oooooooooo
00Kooooo00?oool0ooooool000000_ooool00ooo003oooooooooo`0Hooooo`03o`3jV_oooooooooo
02;ooooo00?o0000oooo0?ooool01_ooool00ooo003oooooooooo`0booooo`03o`3jV_oooooooooo
01Oooooo00?o0000ooooooooool07?ooool00oooo`3oooooooooo`0>ooooo`03ool00?oooooooooo
00_ooooo00?o0?ZJooooooooool00_ooool01Ol0003oooooooooooooooooool001Gooooo0Ol00000
01Gooooo00?o0000ooooooooool01_ooool01?ooo`3oooooooooool00002ooooo`03ool00?oooooo
oooo01Oooooo00?o0?ZJooooooooool08Oooool00ol0003oool0ooooo`07ooooo`03ool00?oooooo
oooo03;ooooo00?o0?ZJooooooooool06?ooool00ol0003oooooooooo`0Looooo`03oooo0?oooooo
oooo00kooooo00?oo`00ooooooooool02_ooool01Ol0nY[ooooooooooooooooo000000?ooooo00?o
ool0ooooooooool05?ooool1o`0000005Oooool00ol0003oooooooooo`07ooooo`03oooo0?oooooo
000000;ooooo00?oo`00ooooooooool05oooool00ol0nY[oooooooooo`0Qooooo`03o`000?ooo`3o
oooo00Kooooo00?oo`00ooooooooool0<oooool00ol0nY[oooooooooo`0Hooooo`03o`000?oooooo
oooo01gooooo00?oool0ooooooooool03_ooool00ooo003oooooooooo`09ooooo`05o`3jV_oooooo
ooooooooool000000oooool00oooo`3oooooooooo`0Dooooo`7o0000000Eooooo`03o`000?oooooo
oooo00Oooooo00?oool0ooooool000000oooool00ooo003oooooooooo`0Fooooo`03o`3jV_oooooo
oooo027ooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`0dooooo`03o`3jV_oooooo
oooo01Wooooo00?o0000ooooooooool07Oooool00oooo`3oooooooooo`0>ooooo`03ool00?oooooo
oooo00Sooooo00Go0?ZJooooooooooooo`00o`000002ooooo`03oooo0?oooooooooo01Gooooo0Ol0
000001Gooooo00?o0000ooooooooool01oooool01?ooo`3oooooooooool00002ooooo`03ool00?oo
oooooooo01Kooooo00?o0?ZJooooooooool08?ooool00ol0003oool0ooooo`05ooooo`03ool00?oo
oooooooo03Gooooo00?o0?ZJooooooooool06Oooool00ol0003oooooooooo`0Nooooo`03oooo0?oo
oooooooo00kooooo0_oo0008ooooo`04o`3jV_ooooooooooo`0000?ooooo00?oool0ooooooooool0
5Oooool1o`0000005Oooool2o`0000Sooooo00Coool0oooooooooooo00000oooool00ooo003ooooo
ooooo`0Eooooo`03o`3jV_oooooooooo023ooooo00?o0000ooooooooool01?ooool00ooo003ooooo
ooooo`0fooooo`03o`3jV_oooooooooo01Wooooo00?o0000ooooooooool07_ooool00oooo`3ooooo
ooooo`0@ooooo`03ool00?oooooooooo00Gooooo00Co0?ZJoooooooooooo00000_ooool00oooo`3o
ooooooooo`0Eooooo`;o0000000Eooooo`03o`000?oooooooooo00Sooooo00?oool0ooooool00000
0oooool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooooooo023ooooo00?o0000ooooooooool0
0oooool00ooo003oooooooooo`0gooooo`03o`3jV_oooooooooo01[ooooo00?o0000ooooooooool0
7_ooool00oooo`3oooooooooo`0@ooooo`03ool00?oooooooooo00Cooooo00Co0?ZJoooooooo003o
00000_ooool00oooo`3oooooooooo`0Fooooo`7o0000000Eooooo`03o`000?oooooooooo00Sooooo
00Coool0oooooooooooo00000_ooool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooooooo01oo
oooo00?o0000oooo0?ooool01?ooool00ooo003oooooooooo`0gooooo`03o`3jV_oooooooooo01[o
oooo00?o0000ooooooooool07oooool00oooo`3oooooooooo`0?ooooo`03ool00?oooooooooo00Co
oooo00?o0?ZJooooool000000_ooool00oooo`3oooooooooo`0Gooooo`7o0000000Eooooo`03o`00
0?oooooooooo00Sooooo00Coool0oooooooooooo00000oooool00ooo003oooooooooo`0Dooooo`03
o`3jV_oooooooooo01oooooo00?o0000ooooooooool00oooool00ooo003oooooooooo`0hooooo`03
o`3jV_oooooooooo01[ooooo00?o0000ooooooooool08?ooool00oooo`3oooooooooo`0?ooooo`03
ool00?oooooooooo00?ooooo00?o0?ZJooooool000000_ooool00oooo`3oooooooooo`0Gooooo`7o
0000000Eooooo`03o`000?oooooooooo00Sooooo00Goool0ooooooooooooooooo`000002ooooo`03
ool00?oooooooooo01Cooooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`03ooooo`03
ool00?oooooooooo03Sooooo00?o0?ZJooooooooool06oooool00ol0003oooooooooo`0Pooooo`03
oooo0?oooooooooo00oooooo0_oo0003ooooo`05o`3jV_oo003o0000ooooooooo`006_ooool1o`00
00005Oooool00ol0003oooooooooo`09ooooo`04oooo0?ooooooooooo`0000?ooooo00?oo`00oooo
ooooool04oooool00ol0nY[oooooooooo`0Nooooo`03oooo0?l0003ooooo00?ooooo00?oo`00oooo
ooooool0>Oooool00ol0nY[oooooooooo`0Kooooo`03o`000?oooooooooo027ooooo00?oool0oooo
ooooool04?ooool01ooo003oooooooooool0nY[o0000ooooooooo`006oooool1o`0000005Oooool0
0ol0003oooooooooo`09ooooo`04oooo0?ooooooooooo`0000Cooooo00?oo`00ooooooooool04_oo
ool00ol0nY[oooooooooo`0Nooooo`03o`000?oooooooooo00;ooooo00?oo`00ooooooooool0>_oo
ool00ol0nY[oooooooooo`0Kooooo`03o`000?oooooooooo02;ooooo00?oool0ooooooooool04?oo
ool01Ooo003oooooo`3jV_l0003oool001cooooo0Ol0000001Gooooo00?o0000ooooooooool02Ooo
ool01Oooo`3ooooooooooooooooo000000?ooooo00?oo`00ooooooooool04_ooool00ol0nY[ooooo
ooooo`0Nooooo`05o`000?oooooooooooooooooo0000?Oooool00ol0nY[oooooooooo`0Looooo`03
o`000?oooooooooo02;ooooo0_ooo`0@ooooo`05ool00?oooooo0?ZJo`000?ooo`007?ooool1o`00
00005Oooool2o`0000[ooooo00Goool0ooooooooooooooooo`000004ooooo`03ool00?oooooooooo
017ooooo00?o0?ZJooooooooool07Oooool01Oooo`3o0000ooooooooooooo`0003kooooo00?o0?ZJ
ooooooooool07?ooool00ol0003oooooooooo`0Tooooo`03oooo0?oooooooooo00kooooo00?oo`00
o`000?ooo`007?ooool2o`0000005Oooool00ol0003oooooooooo`09ooooo`05oooo0?oooooooooo
ooooool000001?ooool00ooo003oooooooooo`0Aooooo`03o`3jV_oooooooooo01gooooo00Go0000
ooooooooooooooooool0000nooooo`03o`3jV_oooooooooo01cooooo00?o0000ooooooooool09Ooo
ool00oooo`3oooooooooo`0>ooooo`03o`000?l0nY[o0?ZJ01Oo0?ZJ1Oooool1o`0000005Oooool0
0ol0003oooooooooo`0:ooooo`05oooo0?ooooooooooooooool000001?ooool00ooo003ooooooooo
o`0@ooooo`03o`3jV_oooooooooo01cooooo00Goool0o`000?ooooooooooool0000oooooo`03o`3j
V_oooooooooo01gooooo00?o0000ooooooooool09Oooool00oooo`3oooooooooo`0<ooooo`03oooo
0?l0003ooooo01gooooo0Ol0000001Gooooo00?o0000ooooooooool02_ooool01Oooo`3ooooooooo
oooooooo000000Cooooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`05oooo
0?oooooo0000oooooooo0000@?ooool00ol0nY[oooooooooo`0Mooooo`03o`000?oooooooooo02Ko
oooo0oooo`09ooooo`;oool000?o0000ooooooooool07Oooool1o`0000005Oooool00ol0003ooooo
ooooo`0:ooooo`05oooo0?ooooooooooooooool000001?ooool00ooo003oooooooooo`0@ooooo`03
o`3jV_oooooooooo01_ooooo00Goool0o`000?ooooooooooool00010ooooo`03o`3jV_oooooooooo
01kooooo00?o0000ooooooooool0:?ooool9oooo00;ooooo00?o0000ooooooooool07Oooool1o`00
000000Coooooo`000?l0003o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0
003oooooooooo`0:ooooo`03oooo0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ooo
003oooooooooo`0?ooooo`03o`3jV_oooooooooo01[ooooo00Goool0ooooool0003oooooool00011
ooooo`03o`3jV_oooooooooo01kooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0M
ooooo`7o00000002ooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo00_ooooo00Goool0ooooooooooooooooo`000004ooooo`03ool00?oo
oooooooo00oooooo00?o0?ZJooooooooool06_ooool01?ooo`3o0000oooooooo0012ooooo`03o`3j
V_oooooooooo01kooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Nooooo`7o0000
0002ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_ooool2o`0000cooooo00Go
ool0ooooooooooooooooo`000005ooooo`03ool00?oooooooooo00kooooo00?o0?ZJooooooooool0
6Oooool01?ooo`3oooooo`000?oo0013ooooo`03o`3jV_oooooooooo01oooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Looooo`?o00000002ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0;ooooo`03oooo0?oooooooooo00;ooooo
00?o0000ooooooooool00oooool00ooo003oooooooooo`0>ooooo`03o`3jV_oooooooooo01Sooooo
00?oool0o`000?oo0000A?ooool00ol0nY[oooooooooo`0Oooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool07_ooool1o`0000000_ooool00ol0003oooooooooo`07ooooo`Co00001Ooo
ool00ol0003oooooooooo`0<ooooo`05oooo0?ooooooooooooooool000001Oooool00ooo003ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo01Sooooo00?oool0o`000?ooool0A?ooool00ol0nY[ooooo
ooooo`0Pooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool07oooool1o`00000000?o
ooooo`000?l000002Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo00?o
ool0ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03ool00?oooooooooo00gooooo00?o
0?ZJooooooooool05oooool00oooo`3oooooo`000015ooooo`03o`3jV_oooooooooo023ooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Oooooo`7o00000002ooooo`03o`000?oooooo
oooo00Oooooo1Ol00004ooooo`03o`000?oooooooooo00cooooo00?oool0ooooooooool00_ooool0
0ol0003oooooooooo`03ooooo`03ool00?oooooooooo00gooooo00?o0?ZJooooooooool05oooool0
0oooo`3o0000ooooo`15ooooo`03o`3jV_oooooooooo023ooooo00?o0000ooooooooool0;_ooool0
0ol0003oooooooooo`0Pooooo`7o0000000Eooooo`03o`000?oooooooooo00gooooo00?oool0oooo
ooooool00_ooool00ol0003oooooooooo`03ooooo`03ool00?oooooooooo00cooooo00?o0?ZJoooo
ooooool05_ooool00oooo`3oooooo`000016ooooo`03o`3jV_oooooooooo027ooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`0Pooooo`7o0000000Eooooo`03o`000?oooooooooo00go
oooo00?oool0ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03ool00?oooooooooo00co
oooo00?o0?ZJooooooooool05Oooool01?ooo`3oooooool00?l00016ooooo`03o`3jV_oooooooooo
027ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0Pooooo`7o0000000Eooooo`03
o`000?oooooooooo00gooooo00?oool0ooooooooool00oooool00ol0003oooooooooo`02ooooo`03
ool00?oooooooooo00cooooo00?o0?ZJooooooooool05Oooool00oooo`3oo`00o`000017ooooo`03
o`3jV_oooooooooo027ooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0Qooooo`7o
0000000Eooooo`;o00003_ooool00oooo`3oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?oo`00ooooooooool02oooool00ol0nY[oooooooooo`0Dooooo`04oooo0?oo003oooooo`0004Oo
oooo00?o0?ZJooooooooool08_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo023o
oooo0_l0000001Gooooo00?o0000ooooooooool03_ooool00oooo`3oooooooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00?oo`00ooooooooool02oooool00ol0nY[oooooooooo`0Dooooo`04oooo
0?ooooooooooo`0004Oooooo00?o0?ZJooooooooool08_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02;ooooo0Ol0000001Gooooo00?o0000ooooooooool03_ooool00oooo`3ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?oo`00ooooooooool02_ooool00ol0nY[ooooo
ooooo`0Cooooo`04oooo0?oo003oooooo`0004Sooooo00?o0?ZJooooooooool08oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo02;ooooo0Ol0000001Gooooo00?o0000ooooooooool0
3_ooool00oooo`3oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?oo`00ooooooooool0
2Oooool00ol0nY[oooooooooo`0Cooooo`04oooo0?ooooooooooo`0004Sooooo00?o0?ZJoooooooo
ool08oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02;ooooo0Ol0000001Gooooo
00?o0000ooooooooool03_ooool00oooo`3oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?oo`00ooooooooool02Oooool00ol0nY[oooooooooo`0Booooo`04ool00?ooo`3oooooo`0004Wo
oooo00?o0?ZJooooooooool09?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02?o
oooo0Ol0000001Gooooo00?o0000ooooooooool03oooool00oooo`3oooooooooo`03ooooo`03o`00
0?oooooooooo00Cooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`0Aooooo`05ool0
0?ooo`3oooooooooool00000BOooool00ol0nY[oooooooooo`0Tooooo`03o`000?oooooooooo02Oo
oooo00?o0000ooooooooool08oooool1o`0000005Oooool00ol0003oooooooooo`0?ooooo`03oooo
0?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ooo003oooooooooo`08ooooo`03o`3j
V_oooooooooo013ooooo00Goo`00ooooooooo`3oooooo`00001:ooooo`03o`3jV_oooooooooo02Go
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Sooooo`7o0000000Eooooo`;o0000
4?ooool00oooo`3oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?oo`00ooooooooool0
1oooool00ol0nY[oooooooooo`0?ooooo`03ool00?ooooooool000;ooooo00?o0000ooooooooool0
B?ooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
8oooool2o`0000005Oooool00ol0003oooooooooo`0@ooooo`03oooo0?oooooooooo00?ooooo00?o
0000ooooooooool01?ooool00ooo003oooooooooo`07ooooo`03o`3jV_oooooooooo00oooooo00Go
o`00oooo0?ooooooooooo`00001;ooooo`03o`3jV_oooooooooo02Gooooo00?o0000ooooooooool0
9?ooool00ol0003oooooooooo`0Uooooo`7o0000000Eooooo`03o`000?oooooooooo013ooooo00?o
ool0ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03ool00?oooooooooo00Oooooo00?o
0?ZJooooooooool03_ooool00ooo003oool0ooooo`02ooooo`03o`000?oooooooooo04Sooooo00?o
0?ZJooooooooool09oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Gooooo0Ol0
000001Gooooo00?o0000ooooooooool04Oooool00oooo`3oooooooooo`03ooooo`03o`000?oooooo
oooo00Cooooo00?oo`00ooooooooool01_ooool00ol0nY[oooooooooo`0>ooooo`03ool00?ooo`3o
oooo00;ooooo00?o0000ooooooooool0B?ooool00ol0nY[oooooooooo`0Wooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool09_ooool1o`0000005Oooool00ol0003oooooooooo`0Aoooo
o`03oooo0?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ooo003oooooooooo`06oooo
o`03o`3jV_oooooooooo00gooooo00?oo`00oooo0?ooool00_ooool00ol0003oooooooooo`19oooo
o`03o`3jV_oooooooooo02Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Voooo
o`7o0000000Eooooo`03o`000?oooooooooo01;ooooo00?oool0ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool03?ooool00ooo003o
oooooooo0003ooooo`03o`000?oooooooooo04Wooooo00?o0?ZJooooooooool0:?ooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo02Oooooo0Ol0000001Gooooo00?o0000ooooooooool0
4_ooool00oooo`3oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool0
1?ooool00ol0nY[oooooooooo`0;ooooo`03ool00?ooooooool000?ooooo00?o0000ooooooooool0
B_ooool00ol0nY[oooooooooo`0Yooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
9oooool1o`0000005Oooool00ol0003oooooooooo`0Cooooo`03oooo0?oooooooooo00?ooooo00?o
0000ooooooooool01?ooool00ooo003oooooooooo`04ooooo`03o`3jV_oooooooooo00[ooooo00Co
o`00ooooooooooooool00_ooool00ol0003oooooooooo`1;ooooo`03o`3jV_oooooooooo02[ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Wooooo`7o0000000Eooooo`;o00005?oo
ool00oooo`3oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool00ooo
ool00ol0nY[oooooooooo`0:ooooo`03ool00?ooooooool000?ooooo00?o0000ooooooooool0Booo
ool00ol0nY[oooooooooo`0Zooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool09ooo
ool2o`0000005Oooool00ol0003oooooooooo`0Cooooo`03oooo0?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo00Wooooo00?oo`00
ooooooooo`000oooool00ol0003oooooooooo`1<ooooo`03o`3jV_oooooooooo02_ooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Xooooo`7o0000000Eooooo`03o`000?oooooooooo
01Cooooo00?oool0ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03ool00?oooooooooo
00;ooooo00?o0?ZJooooooooool02?ooool00ooo003ooooooooo0004ooooo`03o`000?oooooooooo
04cooooo00?o0?ZJooooooooool0:oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo0Ol0000001Gooooo00?o0000ooooooooool05?ooool00oooo`3oooooooooo`05ooooo`03
o`000?oooooooooo00?ooooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`06ooooo`04
ool00?oooooooooooooo00?ooooo00?o0000ooooooooool0COooool00ol0nY[oooooooooo`0[oooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0:_ooool1o`0000005Oooool00ol0003o
ooooooooo`0Dooooo`03oooo0?oooooooooo00Gooooo00?o0000ooooooooool00oooool00ooo003o
ooooooooo`03ooooo`03o`3jV_oooooooooo00Gooooo00Coo`00ooooooooooooool01?ooool00ol0
003oooooooooo`1=ooooo`03o`3jV_oooooooooo02cooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0[ooooo`7o0000000Eooooo`03o`000?oooooooooo01Gooooo00?oool0oooooooo
ool01Oooool00ol0003oooooooooo`03ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJoooooooo
ool01?ooool01?oo003oooooooooooooo`04ooooo`03o`000?oooooooooo04kooooo00?o0?ZJoooo
ooooool0;?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02_ooooo0Ol0000001Go
oooo00?o0000ooooooooool05_ooool00oooo`3oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03ool00?ooooooool000Co
oooo00?o0000ooooooooool0Coooool00ol0nY[oooooooooo`0]ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0;?ooool1o`0000005Oooool00ol0003oooooooooo`0Gooooo`03oooo
0?oooooooooo00Cooooo00?o0000ooooooooool00oooool01Ooo003ooooooooooooooooo0?ZJ00Go
oooo00?oo`00ooooooooo`001?ooool00ol0003oooooooooo`1@ooooo`03o`3jV_oooooooooo02ko
oooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0/ooooo`7o0000000Eooooo`;o0000
6?ooool00oooo`3oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00Goo`00oooooooooooo
ooooo`3jVP04ooooo`03ool00?ooooooool000Cooooo00?o0000ooooooooool0DOooool00ol0nY[o
ooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0;?ooool2o`000000
5Oooool00ol0003oooooooooo`0Hooooo`03oooo0?oooooooooo00Gooooo00Go0000oooooooooooo
ooooool00003ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00ooooooooo`001?ooool00ol0003o
ooooooooo`1Aooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0^ooooo`7o0000000Eooooo`03o`000?oooooooooo01Sooooo00?oool0ooooooooool0
1_ooool01Ol0003oooooooooooooooooo`0000;ooooo00Oo0?ZJooooooooooooooooool00?oooooo
ool000Cooooo00?o0000ooooooooool0D_ooool00ol0nY[oooooooooo`0aooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool0;oooool1o`0000005Oooool00ol0003oooooooooo`0Ioooo
o`03oooo0?oooooooooo00Kooooo00Co0000ooooooooooooo`000_ooool01?l0nY[ooooooooooooo
0002oooo00?ooooo0_l0001Eooooo`03o`3jV_oooooooooo037ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`0`ooooo`7o0000000Eooooo`03o`000?oooooooooo01[ooooo00?oool0
ooooooooool01_ooool02Ol0003ooooooooooooo003oooooo`3jV_ooooooo`00oooo0004ooooo`03
o`000?oooooooooo05Gooooo00?o0?ZJooooooooool0<_ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo037ooooo0Ol0000000cooooo1Ol00004ooooo`03o`000?oooooooooo01_ooooo
00?oool0ooooooooool01_ooool01ol0003ooooooooooooo003o0?ZJooooooooo`000oooool2o`00
05Sooooo00?o0?ZJooooooooool0<oooool3o`0000Wooooo0_l0000dooooo`7o0000000=ooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool07?ooool2oooo00Oooooo0ol000001?l0
nY[oool0ooooooooool2o`0005[ooooo00?o0?ZJooooooooool0=_ooool2o`0000Cooooo0ol0000f
ooooo`7o0000000>ooooo`03o`000?oooooooooo00Cooooo0_l0000Oooooo`?oool01_ooool00ooo
o`3o0000o`000002o`0005go0?ZJ>_ooool4o`0003Oooooo0ol0000000oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0Qooooo`Koool0fOooool1o`0000003?ooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooooooool0ooooool1ooooo`7o0000000<ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`3oooooo`7ooooo0Ol0000000gooooo
0ol00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00?ooooo0Ol0000001Goooooool00005o`000000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-1.11083, -0.215766, \
0.0405294, 0.0132322}}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ML", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[TextData[{
  "THETA = { -16, -4, 1, 2, 0, 0} //N;\nPHI = {-2,-2} //N;\nNONLIN = 1;\nEPS \
= 10.^-4;\nKMAX = 40;\nF0 = IdentityMatrix[(THETA//Length)+(PHI//Length)];\n\
DT = .1;\nPRINT = {1,1,1,1,1,1,1,1};\nFisher = True;\n\nK=2;\nQ=1;\nP=2;\n\n\
T=100;\n",
  "n=10;",
  "\n",
  StyleBox["np = 1; (*same sampling scheme for each panel unit*)",
    FontColor->RGBColor[1, 0, 0]],
  "\nT1=T+1;\nDT=.1;\n\n{THETA,PHI,COV,likpsi,k} =\n \n\
MBFGS[THETA,PHI,F0,KMAX,EPS,ZM,Xint,K,P,Q,n,np,T,DT,1,NONLIN,MISS,PRINT];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL: MBFGS***************************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS\"\>", "\<\"K\"\>", \
"\<\"P\"\>", "\<\"Q\"\>", "\<\"N\"\>", "\<\"NP\"\>", "\<\"T\"\>", \
"\<\"DT\"\>", "\<\"OPTION\"\>", "\<\"NONLIN\"\>", "\<\"MISS\"\>", \
"\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>"},
          {"1", "40", "0.0001`", "2", "2", "1", "10", "1", "100", "0.1`", "1",
             "1", \(-9\), "10.`", "1.`*^-10", "1.`*^-6"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS", "K", "P", 
          "Q", "N", "NP", "T", "DT", "OPTION", "NONLIN", "MISS", "MAXSTEP", 
          "MINSTEP", "BOUND"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-16.`\), \
\(-4.`\), 1.`, 2.`, 0.`, 0.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {-16.0, -4.0, 1.0, 2.0, 0.0, 0.0}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT PHI0   = "\[InvisibleSpace]{\(-2.`\), \
\(-2.`\)}\),
      SequenceForm[ "STARTWERT PHI0   = ", {-2.0, -2.0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("EIGENWERTE DER HESSE-MATRIX: "\[InvisibleSpace]{1, 
          1, 1, 1, 1, 1, 1, 1}\),
      SequenceForm[ 
      "EIGENWERTE DER HESSE-MATRIX: ", {1, 1, 1, 1, 1, 1, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("{MINI,COND,BOUND} = "\[InvisibleSpace]{1, 1, 
          1.`*^-6}\),
      SequenceForm[ "{MINI,COND,BOUND} = ", {1, 1, 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"KONTROLLE\"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", 
            TagBox[GridBox[{
                  {
                    StyleBox["\[Null]",
                      ShowStringCharacters->False], 
                    TagBox["\<\"SNUM\"\>",
                      HoldForm], 
                    TagBox["\<\"S\"\>",
                      HoldForm], 
                    TagBox["\<\"DS\"\>",
                      HoldForm]},
                  {"1", \(-0.43502268454176374`\), \(-0.4350214149667192`\), 
                    "1.2695750445379517`*^-6"},
                  {"2", \(-2.209409899478487`\), \(-2.209408532599275`\), 
                    "1.3668792120391515`*^-6"},
                  {"3", \(-2.9387962285909452`\), \(-2.9387954171411645`\), 
                    "8.114497807021337`*^-7"},
                  {"4", \(-11.19552734962781`\), \(-11.195526329516586`\), 
                    "1.0201112239371923`*^-6"},
                  {"5", \(-1.3655764519171498`\), \(-1.3655748695509273`\), 
                    "1.582366222496745`*^-6"},
                  {"6", \(-5.031230898566719`\), \(-5.031229841010469`\), 
                    "1.0575562496839552`*^-6"},
                  {
                    "7", \(-45.26839774143809`\), \(-45.26839784415408`\), \
\(-1.0271598682720651`*^-7\)},
                  {
                    "8", \(-1.4329344821817358`\), \(-1.4329347747136982`\), \
\(-2.925319624313971`*^-7\)}
                  },
                RowSpacings->0.6,
                ColumnSpacings->1,
                ColumnAlignments->{Left},
                RowLines->{True, False},
                ColumnLines->{True, False}],
              {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
            "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"SNUM", "S", 
              "DS"}}]]]}],
      SequenceForm[ "KONTROLLE", 
        MatrixForm[ {{-0.43502268454176374, -0.4350214149667192, 
          1.2695750445379517*^-06}, {-2.2094098994784872, -2.2094085325992752,
           1.3668792120391515*^-06}, {-2.9387962285909452, \
-2.9387954171411645, 
          8.1144978070213369*^-07}, {-11.19552734962781, -11.195526329516586, 
          1.0201112239371923*^-06}, {-1.3655764519171498, -1.3655748695509273,
           1.582366222496745*^-06}, {-5.0312308985667187, -5.031229841010469, 
          1.0575562496839552*^-06}, {-45.268397741438093, -45.26839784415408, \
-1.0271598682720651*^-07}, {-1.4329344821817358, -1.4329347747136982, \
-2.9253196243139712*^-07}}, TableHeadings -> {Automatic, {"SNUM", "S", 
          "DS"}}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Likelihoods  "\[InvisibleSpace]96.1422650125902`\
\[InvisibleSpace]"  "\[InvisibleSpace]96.1422650125902`\),
      SequenceForm[ 
      "Likelihoods  ", 96.142265012590201, "  ", 96.142265012590201],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "MBFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -250.125796108271400\"\>",
            -250.1257961082714,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    96.142265012590200\"\>",
            96.142265012590201,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -250.1257961082714, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 96.142265012590201, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   139.941980889646200\"\>",
            139.94198088964623,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    96.142265012590200\"\>",
            96.142265012590201,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 139.94198088964623, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 96.142265012590201, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   139.941980889646200\"\>",
            139.94198088964623,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    96.142265012590200\"\>",
            96.142265012590201,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 139.94198088964623, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 96.142265012590201, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    43.799715877056030\"\>",
            43.79971587705603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 43.79971587705603, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-16.024024564358584`\), \(-16.`\), \(-0.02402456435858252`\
\), \(-0.4350214149667192`\)},
          {
            "2", \(-4.122017159752684`\), \(-4.`\), \
\(-0.12201715975268362`\), \(-2.209408532599275`\)},
          {"3", "0.837701599951771`", 
            "1.`", \(-0.1622984000482291`\), \(-2.9387954171411645`\)},
          {"4", "1.3817140177978287`", 
            "2.`", \(-0.6182859822021713`\), \(-11.195526329516586`\)},
          {"5", \(-0.07541546280543239`\), 
            "0.`", \(-0.07541546280543239`\), \(-1.3655748695509273`\)},
          {"6", \(-0.27785552839375544`\), 
            "0.`", \(-0.27785552839375544`\), \(-5.031229841010469`\)},
          {"7", \(-4.5`\), \(-2.`\), \(-2.5`\), \(-45.26839784415408`\)},
          {
            "8", \(-2.079135492029499`\), \(-2.`\), \
\(-0.07913549202949902`\), \(-1.4329347747136982`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.005212735695632509`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.14785818606175485`\),
      SequenceForm[ 
      "*BFGSUP ", 0.0052127356956325087, "  ", 0.14785818606175485],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "MBFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    39.127494299211150\"\>",
            39.127494299211151,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   139.941980889646200\"\>",
            139.94198088964623,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 39.127494299211151, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 139.94198088964623, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   110.961467734124700\"\>",
            110.96146773412472,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   139.941980889646200\"\>",
            139.94198088964623,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 110.96146773412472, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 139.94198088964623, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   149.649831759051000\"\>",
            149.64983175905104,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   139.941980889646200\"\>",
            139.94198088964623,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 149.64983175905104, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 139.94198088964623, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   149.649831759051000\"\>",
            149.64983175905104,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   139.941980889646200\"\>",
            139.94198088964623,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 149.64983175905104, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 139.94198088964623, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     9.707850869404810\"\>",
            9.7078508694048082,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 9.7078508694048082, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-15.959672908044483`\), \(-16.024024564358584`\), 
            "0.06435165631410085`", "2.1509247534607043`"},
          {"2", \(-3.9246994540181794`\), \(-4.122017159752684`\), 
            "0.1973177057345043`", "7.517183982785837`"},
          {"3", "0.27730241404581624`", 
            "0.837701599951771`", \(-0.5603991859059547`\), \
\(-11.647427743466164`\)},
          {"4", "2.6317140177978287`", "1.3817140177978287`", "1.25`", 
            "44.67162891003377`"},
          {
            "5", \(-0.15345971182949697`\), \(-0.07541546280543239`\), \
\(-0.07804424902406458`\), \(-0.6150994641068042`\)},
          {
            "6", \(-0.5916187732382612`\), \(-0.27785552839375544`\), \
\(-0.3137632448445058`\), \(-2.9560417783094772`\)},
          {"7", \(-5.647711944243012`\), \(-4.5`\), \(-1.1477119442430115`\), 
            "17.475616524269572`"},
          {
            "8", \(-2.206724309187875`\), \(-2.079135492029499`\), \
\(-0.12758881715837647`\), \(-1.8474990920160765`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.035\"\>",
                    1.0347728357990751,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1307\"\>",
                    0.13067961321070112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.118\"\>",
                    -0.11796761242352792,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7509\"\>",
                    0.75088479729858648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009848\"\>",
                    0.0098484058634441089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02699\"\>",
                    0.026986225569677301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8369\"\>",
                    0.83689957546479243,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005869\"\>",
                    -0.0058693737797365425,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1307\"\>",
                    0.13067961321070112,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.491\"\>",
                    1.4909578707170925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4445\"\>",
                    -0.44447449849481707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.821\"\>",
                    2.821430577069167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03669\"\>",
                    0.036690132926664676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1002\"\>",
                    0.10020365175168662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.136\"\>",
                    3.1361537149146512,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02245\"\>",
                    -0.022447006769166909,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.118\"\>",
                    -0.11796761242352791,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4445\"\>",
                    -0.44447449849481702,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.391\"\>",
                    1.3914406204900889,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.551\"\>",
                    -2.5509712265379703,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03588\"\>",
                    -0.035878186299886414,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1009\"\>",
                    -0.10087255929419009,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.908\"\>",
                    -2.9083075064244177,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01692\"\>",
                    0.016920452212183502,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7509\"\>",
                    0.75088479729858648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.821\"\>",
                    2.8214305770691674,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.551\"\>",
                    -2.5509712265379707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.21\"\>",
                    17.213149990512107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2117\"\>",
                    0.21165960433011238,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5789\"\>",
                    0.57893657441328505,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.04\"\>",
                    18.043810074855148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.128\"\>",
                    -0.12796417597824758,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.009848\"\>",
                    0.0098484058634441055,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03669\"\>",
                    0.036690132926664676,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03588\"\>",
                    -0.035878186299886414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2117\"\>",
                    0.21165960433011238,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.002\"\>",
                    1.0020949399964985,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00502\"\>",
                    0.0050198881926384678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2176\"\>",
                    0.21757947860101506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002504\"\>",
                    -0.0025042115517540263,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02699\"\>",
                    0.026986225569677301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1002\"\>",
                    0.10020365175168663,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1009\"\>",
                    -0.1008725592941901,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5789\"\>",
                    0.57893657441328505,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00502\"\>",
                    0.0050198881926384678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.011\"\>",
                    1.0110329553971193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.576\"\>",
                    0.57601949727081347,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007736\"\>",
                    -0.0077356512890921839,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8369\"\>",
                    0.83689957546479243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.136\"\>",
                    3.1361537149146517,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.908\"\>",
                    -2.9083075064244177,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.04\"\>",
                    18.043810074855148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2176\"\>",
                    0.21757947860101506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.576\"\>",
                    0.57601949727081347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.6\"\>",
                    20.597443331228732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1648\"\>",
                    -0.16484278271387981,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.005869\"\>",
                    -0.0058693737797365425,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02245\"\>",
                    -0.022447006769166913,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01692\"\>",
                    0.016920452212183506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.128\"\>",
                    -0.12796417597824758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002504\"\>",
                    -0.0025042115517540263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007736\"\>",
                    -0.0077356512890921839,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1648\"\>",
                    -0.16484278271387981,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.\"\>",
                    0.99996992841938925,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.014507899300412826`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.37200284743464523`\),
      SequenceForm[ 
      "*BFGSUP ", 0.014507899300412826, "  ", 0.37200284743464523],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "MBFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   152.077676437853500\"\>",
            152.07767643785354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   149.649831759051000\"\>",
            149.64983175905104,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 152.07767643785354, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 149.64983175905104, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   152.077676437853500\"\>",
            152.07767643785354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   149.649831759051000\"\>",
            149.64983175905104,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 152.07767643785354, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 149.64983175905104, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.427844678802501\"\>",
            2.4278446788025008,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.4278446788025008, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-15.832407683498511`\), \(-15.959672908044483`\), 
            "0.12726522454597325`", \(-0.18497622933038113`\)},
          {
            "2", \(-4.518829625471365`\), \(-3.9246994540181794`\), \
\(-0.5941301714531855`\), \(-3.6881718088336317`\)},
          {"3", "0.07398513663705011`", 
            "0.27730241404581624`", \(-0.20331727740876612`\), 
            "3.4909321623639373`"},
          {"4", "2.325576222682975`", 
            "2.6317140177978287`", \(-0.3061377951148536`\), \
\(-12.437655903530311`\)},
          {
            "5", \(-0.21026902610447037`\), \(-0.15345971182949697`\), \
\(-0.056809314274973405`\), "0.2735623917204`"},
          {
            "6", \(-1.15933343698494`\), \(-0.5916187732382612`\), \
\(-0.5677146637466789`\), "0.12384810940980806`"},
          {"7", \(-5.090606042481281`\), \(-5.647711944243012`\), 
            "0.5571059017617311`", "4.967834820982341`"},
          {
            "8", \(-3.0440434409408614`\), \(-2.206724309187875`\), \
\(-0.8373191317529861`\), \(-1.7211463579486943`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.108\"\>",
                    1.1078314178908795,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4891\"\>",
                    0.48908964233954233,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5979\"\>",
                    -0.59794456917870886,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.56\"\>",
                    2.559515767307726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01852\"\>",
                    -0.018522252651725888,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.069\"\>",
                    -0.069001055517510679,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.211\"\>",
                    1.2111925442544815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004909\"\>",
                    -0.0049094469747569267,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4891\"\>",
                    0.48908964233954233,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.238\"\>",
                    3.2380296882323565,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.79\"\>",
                    -2.7899644680495364,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.66\"\>",
                    11.662506986599158,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1017\"\>",
                    -0.10167693096757863,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3712\"\>",
                    -0.3711703092384388,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.996\"\>",
                    4.9962086428375461,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02467\"\>",
                    -0.024667984734601918,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5979\"\>",
                    -0.59794456917870886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.79\"\>",
                    -2.7899644680495368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.537\"\>",
                    4.5372620130081742,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.41\"\>",
                    -14.40730127125228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1498\"\>",
                    0.14984439458372539,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5301\"\>",
                    0.53013360400674014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.387\"\>",
                    -5.3868407861617094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01629\"\>",
                    0.016285487438696226,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 2.56\"\>",
                    2.559515767307726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.66\"\>",
                    11.662506986599158,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.41\"\>",
                    -14.407301271252281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 61.9\"\>",
                    61.897890670736182,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4884\"\>",
                    -0.4883828449485404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.799\"\>",
                    -1.7986730589720987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.38\"\>",
                    27.377177145381758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1238\"\>",
                    -0.12378524177141244,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01852\"\>",
                    -0.018522252651725885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1017\"\>",
                    -0.10167693096757863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1498\"\>",
                    0.14984439458372539,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4884\"\>",
                    -0.48838284494854028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.013\"\>",
                    1.013053037228947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04233\"\>",
                    0.042329254567463677,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0705\"\>",
                    0.070500810626666799,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002374\"\>",
                    -0.0023742181800944341,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.069\"\>",
                    -0.069001055517510679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3712\"\>",
                    -0.37117030923843874,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5301\"\>",
                    0.53013360400674014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.799\"\>",
                    -1.7986730589720987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04233\"\>",
                    0.042329254567463677,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.137\"\>",
                    1.1371242796568295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08528\"\>",
                    0.085280765118193214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009294\"\>",
                    -0.0092938675667659631,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.211\"\>",
                    1.2111925442544815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.996\"\>",
                    4.996208642837547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.387\"\>",
                    -5.3868407861617094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.38\"\>",
                    27.377177145381758,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0705\"\>",
                    0.070500810626666771,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08528\"\>",
                    0.085280765118193103,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.46\"\>",
                    22.464275278335844,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1452\"\>",
                    -0.14518212336474673,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.004909\"\>",
                    -0.0049094469747569258,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02467\"\>",
                    -0.024667984734601921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01629\"\>",
                    0.016285487438696223,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1238\"\>",
                    -0.12378524177141242,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002374\"\>",
                    -0.0023742181800944341,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009294\"\>",
                    -0.0092938675667659631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1452\"\>",
                    -0.14518212336474673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9957\"\>",
                    0.99569911202662598,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.07241743835933612`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.21302679217097747`\),
      SequenceForm[ 
      "*BFGSUP ", 0.072417438359336117, "  ", 0.21302679217097747],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "MBFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   128.244974949871400\"\>",
            128.24497494987139,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   152.077676437853500\"\>",
            152.07767643785354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 128.24497494987139, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 152.07767643785354, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   151.173460703698100\"\>",
            151.17346070369808,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   152.077676437853500\"\>",
            152.07767643785354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 151.17346070369808, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 152.07767643785354, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.686522047982300\"\>",
            154.68652204798232,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   152.077676437853500\"\>",
            152.07767643785354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 154.68652204798232, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 152.07767643785354, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.686522047982300\"\>",
            154.68652204798232,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   152.077676437853500\"\>",
            152.07767643785354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 154.68652204798232, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 152.07767643785354, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.608845610128782\"\>",
            2.6088456101287818,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.6088456101287818, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-15.721439310240614`\), \(-15.832407683498511`\), 
            "0.11096837325789796`", "0.2991804729469201`"},
          {
            "2", \(-4.710634844483952`\), \(-4.518829625471365`\), \
\(-0.19180521901258688`\), "1.6804008082845987`"},
          {"3", "0.6077249587514284`", "0.07398513663705011`", 
            "0.5337398221143783`", "8.675416208145215`"},
          {"4", "2.3013217527485854`", 
            "2.325576222682975`", \(-0.024254469934389525`\), \
\(-0.010710216499772884`\)},
          {"5", \(-0.18764421972790293`\), \(-0.21026902610447037`\), 
            "0.02262480637656743`", "0.813819001955419`"},
          {"6", \(-1.0705286538603787`\), \(-1.15933343698494`\), 
            "0.08880478312456135`", "5.658839512865554`"},
          {"7", \(-4.824469275679968`\), \(-5.090606042481281`\), 
            "0.2661367668013122`", "1.5531017207828666`"},
          {
            "8", \(-3.640576675174346`\), \(-3.0440434409408614`\), \
\(-0.5965332342334848`\), \(-0.8290065400048305`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.123\"\>",
                    1.1229843818315881,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.641\"\>",
                    0.64098624699063911,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3818\"\>",
                    -0.38177940985171399,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.873\"\>",
                    2.8726956092052442,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003115\"\>",
                    0.0031148182341494621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1263\"\>",
                    0.12628348181709856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.14\"\>",
                    1.1404065112173842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009415\"\>",
                    0.0094148165446519654,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.641\"\>",
                    0.64098624699063911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.601\"\>",
                    4.6007839358553237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08866\"\>",
                    -0.088661315880481872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.05\"\>",
                    14.050830977742018,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1621\"\>",
                    0.16209618746034898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.805\"\>",
                    1.8050403368343593,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.644\"\>",
                    4.644415975219423,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01589\"\>",
                    -0.015890717353840629,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3818\"\>",
                    -0.38177940985171394,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08866\"\>",
                    -0.088661315880482316,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.835\"\>",
                    5.8347428050677959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.429\"\>",
                    -7.4292878595794569,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3018\"\>",
                    0.30182265287281196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.585\"\>",
                    2.5852045336304741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.592\"\>",
                    -7.5924898624889616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6712\"\>",
                    0.67122457390780621,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 2.873\"\>",
                    2.8726956092052442,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.05\"\>",
                    14.050830977742018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.429\"\>",
                    -7.4292878595794587,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 64.84\"\>",
                    64.84268169763871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.179\"\>",
                    0.17901355340536468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.264\"\>",
                    3.2644538844341393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.59\"\>",
                    27.594801252978161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.461\"\>",
                    -0.46099154856250285,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.003115\"\>",
                    0.0031148182341494655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1621\"\>",
                    0.16209618746034898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3018\"\>",
                    0.30182265287281196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.179\"\>",
                    0.1790135534053649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.03\"\>",
                    1.0302044981159706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2571\"\>",
                    0.25707591017951353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1355\"\>",
                    -0.13547373941024438,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05761\"\>",
                    0.057605292244599551,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1263\"\>",
                    0.12628348181709856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.805\"\>",
                    1.8050403368343595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.585\"\>",
                    2.5852045336304741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.264\"\>",
                    3.2644538844341393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2571\"\>",
                    0.25707591017951353,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.355\"\>",
                    3.3548974535494676,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.316\"\>",
                    -1.3162129114210086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3597\"\>",
                    0.35965468158664471,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.14\"\>",
                    1.1404065112173842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.644\"\>",
                    4.6444159752194238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.592\"\>",
                    -7.5924898624889616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.59\"\>",
                    27.594801252978161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1355\"\>",
                    -0.1354737394102444,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.316\"\>",
                    -1.3162129114210088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.99\"\>",
                    21.994349293842724,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08957\"\>",
                    0.089568506286434424,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.009415\"\>",
                    0.0094148165446519619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01589\"\>",
                    -0.015890717353840633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6712\"\>",
                    0.67122457390780621,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.461\"\>",
                    -0.46099154856250274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05761\"\>",
                    0.057605292244599537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3597\"\>",
                    0.35965468158664471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08957\"\>",
                    0.089568506286434368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8956\"\>",
                    0.89557242383733071,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.1591176878231706`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.3863912819665547`\),
      SequenceForm[ 
      "*BFGSUP ", 0.15911768782317059, "  ", 1.3863912819665547],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "MBFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   143.449685279691700\"\>",
            143.44968527969166,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.686522047982300\"\>",
            154.68652204798232,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 143.44968527969166, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 154.68652204798232, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.874862913573200\"\>",
            154.87486291357322,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.686522047982300\"\>",
            154.68652204798232,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 154.87486291357322, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 154.68652204798232, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.874862913573200\"\>",
            154.87486291357322,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.686522047982300\"\>",
            154.68652204798232,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 154.87486291357322, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 154.68652204798232, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.188340865590902\"\>",
            0.18834086559090224,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.18834086559090224, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-15.580196312634918`\), \(-15.721439310240614`\), 
            "0.1412429976056956`", "0.14080052842700483`"},
          {"2", \(-4.589092916455549`\), \(-4.710634844483952`\), 
            "0.12154192802840356`", "1.6216661433859638`"},
          {"3", "0.4622921424753427`", 
            "0.6077249587514284`", \(-0.14543281627608567`\), \
\(-1.4752917794591387`\)},
          {"4", "2.081096415117446`", 
            "2.3013217527485854`", \(-0.22022533763113938`\), \
\(-1.3442806890500663`\)},
          {"5", \(-0.06191391914258379`\), \(-0.18764421972790293`\), 
            "0.12573030058531914`", "0.5712366761826042`"},
          {"6", \(-0.06671813225649825`\), \(-1.0705286538603787`\), 
            "1.0038105216038804`", "4.922049564815831`"},
          {"7", \(-4.565169712591296`\), \(-4.824469275679968`\), 
            "0.2592995630886719`", \(-0.7409701504370062`\)},
          {
            "8", \(-4.337298942972715`\), \(-3.640576675174346`\), \
\(-0.696722267798369`\), \(-0.4746270722518924`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.125\"\>",
                    1.1250367472692899,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6316\"\>",
                    0.63157581814499153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1822\"\>",
                    -0.18219589735717487,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.906\"\>",
                    2.9063723985665382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003954\"\>",
                    0.0039538223534130298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1082\"\>",
                    0.10817667129895293,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.188\"\>",
                    1.1881539481639081,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.005857\"\>",
                    0.0058568367663215711,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6316\"\>",
                    0.63157581814499153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.54\"\>",
                    4.5401638217639508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3096\"\>",
                    -0.309593360493012,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.06\"\>",
                    14.063684026860392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1347\"\>",
                    0.13473910029842803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.606\"\>",
                    1.6059361883949925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.609\"\>",
                    4.6093205776979351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01097\"\>",
                    0.010974393028603861,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1822\"\>",
                    -0.18219589735717476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3096\"\>",
                    -0.30959336049301245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.6\"\>",
                    20.599360584049894,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.273\"\>",
                    -5.2733491582408494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5407\"\>",
                    0.54069021642006798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.712\"\>",
                    2.7117702785800226,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.179\"\>",
                    -4.1790776376641059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2546\"\>",
                    0.25464124761366491,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 2.906\"\>",
                    2.9063723985665382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.06\"\>",
                    14.063684026860392,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.273\"\>",
                    -5.2733491582408512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 65.13\"\>",
                    65.125655732638094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2307\"\>",
                    0.23067703816539833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.422\"\>",
                    3.422109669155184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.08\"\>",
                    28.081951364056213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5364\"\>",
                    -0.53638131239135467,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.003954\"\>",
                    0.0039538223534130341,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1347\"\>",
                    0.13473910029842803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5407\"\>",
                    0.54069021642006798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2307\"\>",
                    0.23067703816539856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.025\"\>",
                    1.0252209538100872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1858\"\>",
                    0.18575430922908298,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0743\"\>",
                    -0.074304548935044817,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05854\"\>",
                    0.058541307954543279,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1082\"\>",
                    0.10817667129895293,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.606\"\>",
                    1.6059361883949927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.712\"\>",
                    2.7117702785800226,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.422\"\>",
                    3.422109669155184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1858\"\>",
                    0.18575430922908298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.748\"\>",
                    2.7475937124519314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.238\"\>",
                    -1.2376495566146835,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4197\"\>",
                    0.41973134454936334,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.188\"\>",
                    1.1881539481639081,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.609\"\>",
                    4.609320577697936,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.179\"\>",
                    -4.1790776376641059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.08\"\>",
                    28.081951364056213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0743\"\>",
                    -0.074304548935044845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.238\"\>",
                    -1.2376495566146839,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.78\"\>",
                    22.779496083327054,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0119\"\>",
                    -0.011898738258047076,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.005857\"\>",
                    0.0058568367663215668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01097\"\>",
                    0.010974393028603858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2546\"\>",
                    0.25464124761366491,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5364\"\>",
                    -0.53638131239135456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05854\"\>",
                    0.058541307954543265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4197\"\>",
                    0.41973134454936334,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0119\"\>",
                    -0.011898738258047131,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9007\"\>",
                    0.90066768853904799,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.0873229532637218`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.680415026177375`\),
      SequenceForm[ 
      "*BFGSUP ", 0.087322953263721803, "  ", 0.68041502617737504],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "MBFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   156.216342137047600\"\>",
            156.21634213704758,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   154.874862913573200\"\>",
            154.87486291357322,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 156.21634213704758, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 154.87486291357322, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.341479223474352\"\>",
            1.3414792234743516,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.3414792234743516, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-15.335663655392867`\), \(-15.580196312634918`\), 
            "0.2445326572420505`", "0.4379993205193013`"},
          {"2", \(-2.943713472056112`\), \(-4.589092916455549`\), 
            "1.645379444399437`", "2.5966119866695143`"},
          {"3", "0.4728077598104057`", "0.4622921424753427`", 
            "0.010515617335062939`", "1.2526803541237062`"},
          {"4", "1.7627137096402847`", 
            "2.081096415117446`", \(-0.3183827054771611`\), 
            "2.78590379570635`"},
          {
            "5", \(-0.15985331246895707`\), \(-0.06191391914258379`\), \
\(-0.09793939332637326`\), \(-0.6968348274912848`\)},
          {
            "6", \(-0.5890345379288775`\), \(-0.06671813225649825`\), \
\(-0.5223164056723792`\), \(-4.896672198478143`\)},
          {
            "7", \(-4.590768750092476`\), \(-4.565169712591296`\), \
\(-0.025599037501179905`\), \(-1.2714467249965393`\)},
          {
            "8", \(-4.719498402295347`\), \(-4.337298942972715`\), \
\(-0.38219945932263266`\), \(-0.25533550507495706`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.132\"\>",
                    1.1319066646553382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6472\"\>",
                    0.64716787263884723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1026\"\>",
                    -0.10256524372722542,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.022\"\>",
                    3.0216092026781882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03238\"\>",
                    -0.032375898986701721,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1761\"\>",
                    -0.17611313980861937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.179\"\>",
                    1.1788235617912501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01439\"\>",
                    0.014389864606535177,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6472\"\>",
                    0.64716787263884723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.511\"\>",
                    4.5113312219799813,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02439\"\>",
                    0.024393320761589177,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.51\"\>",
                    14.508013365850617,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01261\"\>",
                    -0.012612481669878328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4306\"\>",
                    0.43057914285732579,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.615\"\>",
                    4.6152578071794856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06238\"\>",
                    0.062375461355007038,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1026\"\>",
                    -0.10256524372722531,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02439\"\>",
                    0.024393320761588788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.16\"\>",
                    21.156646224499369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.374\"\>",
                    -4.3738166912478729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2745\"\>",
                    0.27445543459769006,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6816\"\>",
                    0.68160794148593196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.352\"\>",
                    -4.3519320038239302,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2771\"\>",
                    0.27710246367545316,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.022\"\>",
                    3.0216092026781882,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.51\"\>",
                    14.508013365850617,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.374\"\>",
                    -4.3738166912478746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 66.54\"\>",
                    66.538399460066415,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.194\"\>",
                    -0.19400973996616491,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1623\"\>",
                    0.16226821074898279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.85\"\>",
                    27.848270840671137,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4844\"\>",
                    -0.48442454655354317,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03238\"\>",
                    -0.032375898986701721,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01261\"\>",
                    -0.012612481669878328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2745\"\>",
                    0.27445543459769001,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.194\"\>",
                    -0.19400973996616463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.152\"\>",
                    1.1517600326321575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.153\"\>",
                    1.1534302602623812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002436\"\>",
                    0.0024359753747989488,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04579\"\>",
                    0.04578858861436632,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1761\"\>",
                    -0.17611313980861937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4306\"\>",
                    0.43057914285732601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6816\"\>",
                    0.68160794148593196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1623\"\>",
                    0.16226821074898323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.153\"\>",
                    1.1534302602623812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.14\"\>",
                    10.135905885456864,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6277\"\>",
                    -0.62772305323229338,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3311\"\>",
                    0.33105726404912755,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.179\"\>",
                    1.1788235617912501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.615\"\>",
                    4.6152578071794865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.352\"\>",
                    -4.3519320038239302,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.85\"\>",
                    27.848270840671137,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002436\"\>",
                    0.0024359753747989071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6277\"\>",
                    -0.62772305323229383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.78\"\>",
                    22.780720929581303,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03701\"\>",
                    -0.037012646877412916,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01439\"\>",
                    0.014389864606535172,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06238\"\>",
                    0.062375461355007031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2771\"\>",
                    0.27710246367545316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4844\"\>",
                    -0.48442454655354306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04579\"\>",
                    0.045788588614366306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3311\"\>",
                    0.33105726404912755,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03701\"\>",
                    -0.037012646877412972,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8953\"\>",
                    0.89528708904173149,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.08646885368715361`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.15970096435626563`\),
      SequenceForm[ 
      "*BFGSUP ", 0.08646885368715361, "  ", 0.15970096435626563],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "MBFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.662232703276100\"\>",
            157.66223270327606,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   156.216342137047600\"\>",
            156.21634213704758,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 157.66223270327606, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 156.21634213704758, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.445890566228485\"\>",
            1.4458905662284849,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.4458905662284849, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-14.469564092978107`\), \(-15.335663655392867`\), 
            "0.8660995624147605`", "1.4721361839103688`"},
          {
            "2", \(-3.962313898363048`\), \(-2.943713472056112`\), \
\(-1.0186004263069364`\), \(-3.4109013983960614`\)},
          {"3", "0.5001301082703689`", "0.4728077598104057`", 
            "0.02732234845996322`", \(-0.5264126441378385`\)},
          {"4", "2.0937630202759046`", "1.7627137096402847`", 
            "0.3310493106356197`", \(-0.0461139107736086`\)},
          {"5", \(-0.057009534455469274`\), \(-0.15985331246895707`\), 
            "0.10284377801348779`", "0.27151430957884104`"},
          {
            "6", \(-0.7676338550290316`\), \(-0.5890345379288775`\), \
\(-0.17859931710015414`\), "0.2586800187357374`"},
          {
            "7", \(-4.895228297030782`\), \(-4.590768750092476`\), \
\(-0.3044595469383061`\), \(-1.5685158629317675`\)},
          {"8", \(-4.665621071007514`\), \(-4.719498402295347`\), 
            "0.053877331287832654`", \(-0.16089175827711105`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.194\"\>",
                    1.1937422568414346,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07166\"\>",
                    -0.071657941999537789,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3493\"\>",
                    -0.34927648912063836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.573\"\>",
                    2.5734974529807917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.103\"\>",
                    0.10295732940337481,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6274\"\>",
                    0.62739860073926512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.241\"\>",
                    1.2411957700436393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0407\"\>",
                    0.040695525116426053,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07166\"\>",
                    -0.0716579419995379,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.555\"\>",
                    6.5552441280766089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4291\"\>",
                    0.42910265281867377,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.82\"\>",
                    14.823878608691766,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2267\"\>",
                    -0.2266693632933619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2169\"\>",
                    -0.21687546353651577,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.297\"\>",
                    5.2968195288336641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1192\"\>",
                    0.11919834308777577,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3493\"\>",
                    -0.3492764891206383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4291\"\>",
                    0.42910265281867327,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.18\"\>",
                    21.17973096811739,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.495\"\>",
                    -4.4954819649746023,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2649\"\>",
                    0.26489312493065303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8681\"\>",
                    0.86812863244161886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.052\"\>",
                    -4.0518737022183666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3137\"\>",
                    0.31365455862967362,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 2.573\"\>",
                    2.5734974529807917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.82\"\>",
                    14.823878608691766,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.495\"\>",
                    -4.4954819649746041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 65.99\"\>",
                    65.992427007545075,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1211\"\>",
                    -0.12111051520105839,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.078\"\>",
                    1.0784046148672066,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.49\"\>",
                    28.486698823245931,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.394\"\>",
                    -0.39395034799691919,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.103\"\>",
                    0.10295732940337481,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2267\"\>",
                    -0.2266693632933619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2649\"\>",
                    0.26489312493065298,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1211\"\>",
                    -0.12111051520105814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.155\"\>",
                    1.1552944822407165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.04\"\>",
                    1.0401713022576939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1639\"\>",
                    -0.16393142490642795,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02528\"\>",
                    0.025281494981037492,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6274\"\>",
                    0.6273986007392649,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2169\"\>",
                    -0.2168754635365151,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8681\"\>",
                    0.86812863244161875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.078\"\>",
                    1.0784046148672071,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.04\"\>",
                    1.0401713022576939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.605\"\>",
                    8.604831693014237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.754\"\>",
                    -1.7544252595619669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1735\"\>",
                    0.17348495113355183,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.241\"\>",
                    1.2411957700436393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.297\"\>",
                    5.296819528833665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.052\"\>",
                    -4.0518737022183666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.49\"\>",
                    28.486698823245931,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1639\"\>",
                    -0.16393142490642798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.754\"\>",
                    -1.7544252595619674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.53\"\>",
                    22.530182942362355,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09128\"\>",
                    -0.091284843016741155,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0407\"\>",
                    0.040695525116426046,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1192\"\>",
                    0.11919834308777577,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3137\"\>",
                    0.31365455862967362,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.394\"\>",
                    -0.39395034799691908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02528\"\>",
                    0.025281494981037479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1735\"\>",
                    0.17348495113355183,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09128\"\>",
                    -0.09128484301674121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8856\"\>",
                    0.8856464592410237,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.14407996076303997`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.1934117008673074`\),
      SequenceForm[ 
      "*BFGSUP ", 0.14407996076303997, "  ", 0.19341170086730741],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "MBFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.849389757331000\"\>",
            157.84938975733098,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.662232703276100\"\>",
            157.66223270327606,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 157.84938975733098, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 157.66223270327606, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.849389757331000\"\>",
            157.84938975733098,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.662232703276100\"\>",
            157.66223270327606,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 157.84938975733098, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 157.66223270327606, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.187157054054921\"\>",
            0.18715705405492145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.18715705405492145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-14.208414450325476`\), \(-14.469564092978107`\), 
            "0.2611496426526305`", "0.1190761313376858`"},
          {"2", \(-3.866110231999448`\), \(-3.962313898363048`\), 
            "0.09620366636359974`", "0.5009663691630467`"},
          {"3", "0.4886446516947773`", 
            "0.5001301082703689`", \(-0.01148545657559157`\), \
\(-0.2869067789640041`\)},
          {"4", "2.018868507998254`", 
            "2.0937630202759046`", \(-0.07489451227765041`\), \
\(-3.130234349301811`\)},
          {
            "5", \(-0.38654305606272044`\), \(-0.057009534455469274`\), \
\(-0.32953352160725113`\), \(-0.725641079316522`\)},
          {"6", \(-0.6290505463155034`\), \(-0.7676338550290316`\), 
            "0.13858330871352825`", "2.0339317717989633`"},
          {"7", \(-4.847283427562251`\), \(-4.895228297030782`\), 
            "0.04794486946853059`", \(-0.42354587670641036`\)},
          {
            "8", \(-4.833236388242201`\), \(-4.665621071007514`\), \
\(-0.16761531723468678`\), \(-0.1871820914517206`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.038\"\>",
                    1.0383608174641459,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1369\"\>",
                    0.13690834961246834,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2461\"\>",
                    -0.24608326898478622,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.188\"\>",
                    3.1878730910232038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.22\"\>",
                    0.22004379009282765,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2077\"\>",
                    0.20766179370433624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.465\"\>",
                    1.4645861545792234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09163\"\>",
                    0.091631242046016442,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1369\"\>",
                    0.13690834961246812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.51\"\>",
                    6.5098581408392837,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2168\"\>",
                    0.21681460927107943,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.06\"\>",
                    13.055179509202208,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6096\"\>",
                    -0.6095676054857051,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9543\"\>",
                    0.95434838426359803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.907\"\>",
                    4.907386680430295,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001761\"\>",
                    -0.0017610794585016659,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2461\"\>",
                    -0.24608326898478616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2168\"\>",
                    0.21681460927107887,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.13\"\>",
                    21.134399466455012,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.607\"\>",
                    -4.6066038382089305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2581\"\>",
                    0.25812734808190935,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9557\"\>",
                    0.95572635403573492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.172\"\>",
                    -4.1720605292649955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2964\"\>",
                    0.29636623974635501,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.188\"\>",
                    3.1878730910232038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.06\"\>",
                    13.055179509202208,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.607\"\>",
                    -4.6066038382089323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 67.36\"\>",
                    67.362475328284461,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3244\"\>",
                    0.32440703327630582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2919\"\>",
                    0.29186099079859373,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.96\"\>",
                    27.963930469592032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3837\"\>",
                    -0.38370296556725442,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.22\"\>",
                    0.22004379009282765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6096\"\>",
                    -0.6095676054857051,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2581\"\>",
                    0.25812734808190929,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3244\"\>",
                    0.3244070332763061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.284\"\>",
                    1.2842975914437058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7715\"\>",
                    0.77153635485232708,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2461\"\>",
                    -0.24606027627228161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03751\"\>",
                    0.037507706963797127,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2077\"\>",
                    0.20766179370433602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9543\"\>",
                    0.95434838426359869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9557\"\>",
                    0.9557263540357348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2919\"\>",
                    0.29186099079859418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7715\"\>",
                    0.77153635485232708,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.046\"\>",
                    9.04596018409128,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.383\"\>",
                    -1.3830913124702966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1748\"\>",
                    0.17481015196488556,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.465\"\>",
                    1.4645861545792234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.907\"\>",
                    4.9073866804302959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.172\"\>",
                    -4.1720605292649955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.96\"\>",
                    27.963930469592032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2461\"\>",
                    -0.24606027627228166,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.383\"\>",
                    -1.383091312470297,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.24\"\>",
                    22.243225878075286,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1444\"\>",
                    -0.14443150991931952,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09163\"\>",
                    0.091631242046016442,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001761\"\>",
                    -0.0017610794585016798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2964\"\>",
                    0.29636623974635501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3837\"\>",
                    -0.38370296556725431,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03751\"\>",
                    0.037507706963797113,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1748\"\>",
                    0.17481015196488556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1444\"\>",
                    -0.14443150991931958,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8807\"\>",
                    0.88073935883670684,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.7548265133512556`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.355479802773976`\),
      SequenceForm[ 
      "*BFGSUP ", 0.75482651335125561, "  ", 2.3554798027739761],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "MBFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   158.653884175484000\"\>",
            158.653884175484,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.849389757331000\"\>",
            157.84938975733098,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 158.653884175484, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 157.84938975733098, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   158.653884175484000\"\>",
            158.653884175484,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   157.849389757331000\"\>",
            157.84938975733098,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 158.653884175484, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 157.84938975733098, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.804494418153013\"\>",
            0.8044944181530127,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.8044944181530127, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-13.65230304599502`\), \(-14.208414450325476`\), 
            "0.556111404330457`", "0.15014508567178142`"},
          {"2", \(-3.4192942370137183`\), \(-3.866110231999448`\), 
            "0.44681599498572977`", "0.7396360967574955`"},
          {"3", "0.44543539256082787`", 
            "0.4886446516947773`", \(-0.04320925913394941`\), \
\(-0.1897868265402836`\)},
          {"4", "1.7913432804906995`", 
            "2.018868507998254`", \(-0.2275252275075546`\), \
\(-2.0275441153993574`\)},
          {"5", \(-0.18508088177286783`\), \(-0.38654305606272044`\), 
            "0.2014621742898526`", "2.5395899923340206`"},
          {"6", \(-0.4303866852667255`\), \(-0.6290505463155034`\), 
            "0.1986638610487779`", "0.6649916759458172`"},
          {"7", \(-4.717453983762095`\), \(-4.847283427562251`\), 
            "0.12982944380015676`", \(-0.4685099897678728`\)},
          {
            "8", \(-5.260807130776268`\), \(-4.833236388242201`\), \
\(-0.42757074253406613`\), \(-0.16146710887161697`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.031\"\>",
                    1.0307397756715126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1074\"\>",
                    0.10737761347186608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2237\"\>",
                    -0.2236876385021242,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.433\"\>",
                    3.4332261646748115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3475\"\>",
                    0.3475011237170193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03294\"\>",
                    0.032937842594942535,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.493\"\>",
                    1.4932308584997342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1054\"\>",
                    0.10535957615631496,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1074\"\>",
                    0.10737761347186586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.405\"\>",
                    6.4050684004623548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3189\"\>",
                    0.31894983954160472,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.18\"\>",
                    14.177265611056237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1927\"\>",
                    0.19274466196727147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1077\"\>",
                    0.10770993196695433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.024\"\>",
                    5.0242339501129374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05809\"\>",
                    0.058091057043027479,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2237\"\>",
                    -0.22368763850212414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3189\"\>",
                    0.31894983954160416,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.09\"\>",
                    21.093046081056688,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.055\"\>",
                    -5.0546225713926818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3749\"\>",
                    0.37489961541625333,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.199\"\>",
                    1.1990054755110877,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.247\"\>",
                    -4.2469151971841752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2666\"\>",
                    0.26662681157801077,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.433\"\>",
                    3.4332261646748115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.18\"\>",
                    14.177265611056237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.055\"\>",
                    -5.0546225713926836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 62.51\"\>",
                    62.510324383929763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.705\"\>",
                    1.7046140019745808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.902\"\>",
                    2.9015859925318348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.15\"\>",
                    27.145782532012564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7073\"\>",
                    -0.70733228789963942,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3475\"\>",
                    0.3475011237170193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1927\"\>",
                    0.19274466196727136,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3749\"\>",
                    0.37489961541625327,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.705\"\>",
                    1.7046140019745806,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.022\"\>",
                    9.0219846534115522,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.733\"\>",
                    -1.733351228588967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5379\"\>",
                    -0.53786719813342421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0209\"\>",
                    0.020902539441931212,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03294\"\>",
                    0.032937842594942313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1077\"\>",
                    0.107709931966955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.199\"\>",
                    1.1990054755110875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.902\"\>",
                    2.9015859925318348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.733\"\>",
                    -1.7333512285889674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.024\"\>",
                    8.0244193848399359,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8293\"\>",
                    -0.8293394233263961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3724\"\>",
                    0.37243052301377361,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.493\"\>",
                    1.4932308584997342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.024\"\>",
                    5.0242339501129383,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.247\"\>",
                    -4.2469151971841752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.15\"\>",
                    27.145782532012564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5379\"\>",
                    -0.53786719813342421,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8293\"\>",
                    -0.82933942332639654,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.14\"\>",
                    22.139113930870632,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.192\"\>",
                    -0.19199000836800878,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1054\"\>",
                    0.10535957615631496,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05809\"\>",
                    0.058091057043027472,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2666\"\>",
                    0.26662681157801077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7073\"\>",
                    -0.70733228789963931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0209\"\>",
                    0.020902539441931198,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3724\"\>",
                    0.37243052301377366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.192\"\>",
                    -0.19199000836800884,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8606\"\>",
                    0.8606061794933092,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.6604696355787593`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.3025497639633685`\),
      SequenceForm[ 
      "*BFGSUP ", 0.66046963557875926, "  ", 1.3025497639633685],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "MBFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.013407012890400\"\>",
            159.01340701289044,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   158.653884175484000\"\>",
            158.653884175484,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.01340701289044, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 158.653884175484, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.359522837406445\"\>",
            0.35952283740644475,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.35952283740644475, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.883364063372106`\), \(-13.65230304599502`\), 
            "0.7689389826229124`", "0.43360501721199896`"},
          {"2", \(-3.1147174417511643`\), \(-3.4192942370137183`\), 
            "0.3045767952625541`", "0.5124078210266324`"},
          {"3", "0.44323740629851743`", 
            "0.44543539256082787`", \(-0.002197986262310463`\), 
            "0.3754651226752829`"},
          {"4", "1.7201896719749508`", 
            "1.7913432804906995`", \(-0.07115360851574869`\), 
            "1.1164939423027282`"},
          {"5", \(-0.11513832263473303`\), \(-0.18508088177286783`\), 
            "0.0699425591381348`", "0.5233336636967454`"},
          {
            "6", \(-0.5374381113407432`\), \(-0.4303866852667255`\), \
\(-0.1070514260740176`\), \(-1.304456313507349`\)},
          {
            "7", \(-4.784641787035408`\), \(-4.717453983762095`\), \
\(-0.06718780327331356`\), \(-0.519461357016884`\)},
          {
            "8", \(-5.559735794314172`\), \(-5.260807130776268`\), \
\(-0.29892866353790387`\), \(-0.09987352656372457`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.076\"\>",
                    1.076467179436466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02867\"\>",
                    0.028673765392267431,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1086\"\>",
                    -0.10858382549479531,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.121\"\>",
                    4.1209749579244237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1541\"\>",
                    -0.1541435091926891,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3683\"\>",
                    -0.36828901275934645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.507\"\>",
                    1.5065987068294513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1248\"\>",
                    0.12478551098966091,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02867\"\>",
                    0.028673765392267209,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.261\"\>",
                    6.2610264989040081,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2798\"\>",
                    0.27982907555473913,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.19\"\>",
                    14.193757127970049,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11632926905274216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2431\"\>",
                    0.24311414231843517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.145\"\>",
                    5.1447227306277856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08774\"\>",
                    0.087737124608183947,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1086\"\>",
                    -0.10858382549479526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2798\"\>",
                    0.27982907555473857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.29\"\>",
                    21.292343431972402,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.006\"\>",
                    -4.006159010793354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2209\"\>",
                    -0.2208819159892465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5048\"\>",
                    0.50484562697471647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.295\"\>",
                    -4.294891672436667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2796\"\>",
                    0.27964271012076752,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 4.121\"\>",
                    4.1209749579244237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.19\"\>",
                    14.193757127970049,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.006\"\>",
                    -4.0061590107933558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 67.7\"\>",
                    67.70037602446061,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8055\"\>",
                    -0.80547652331692454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.749\"\>",
                    -0.74899787643934346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.73\"\>",
                    26.730648855193984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.686\"\>",
                    -0.68603838221352176,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1541\"\>",
                    -0.1541435091926891,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11632926905274238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2209\"\>",
                    -0.22088191598924667,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8055\"\>",
                    -0.80547652331692476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.607\"\>",
                    9.6067806639709232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3394\"\>",
                    0.33937702391061308,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08257\"\>",
                    -0.082565472430367992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07241\"\>",
                    0.072410810733789147,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3683\"\>",
                    -0.36828901275934667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2431\"\>",
                    0.24311414231843589,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5048\"\>",
                    0.50484562697471613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.749\"\>",
                    -0.74899787643934346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3394\"\>",
                    0.33937702391061264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.44\"\>",
                    10.442198312931229,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6616\"\>",
                    -0.66160984034915105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3273\"\>",
                    0.32727710504286739,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.507\"\>",
                    1.5065987068294513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.145\"\>",
                    5.1447227306277865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.295\"\>",
                    -4.294891672436667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.73\"\>",
                    26.730648855193984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08257\"\>",
                    -0.082565472430368048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6616\"\>",
                    -0.66160984034915149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.07\"\>",
                    22.069350594927844,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2187\"\>",
                    -0.21869687682761546,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1248\"\>",
                    0.12478551098966091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08774\"\>",
                    0.087737124608183947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2796\"\>",
                    0.27964271012076752,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.686\"\>",
                    -0.68603838221352165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07241\"\>",
                    0.072410810733789133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3273\"\>",
                    0.32727710504286744,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2187\"\>",
                    -0.21869687682761552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8546\"\>",
                    0.85462195099489402,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.6464648817431873`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.5379428392137457`\),
      SequenceForm[ "*BFGSUP ", 1.6464648817431873, "  ", 1.5379428392137457],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "MBFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.068469697790900\"\>",
            159.06846969779085,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.013407012890400\"\>",
            159.01340701289044,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.06846969779085, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.01340701289044, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.055062684900406\"\>",
            0.055062684900406111,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.055062684900406111, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.571261694359666`\), \(-12.883364063372106`\), 
            "0.3121023690124401`", "0.20983552615107678`"},
          {
            "2", \(-3.17238586264111`\), \(-3.1147174417511643`\), \
\(-0.057668420889945664`\), \(-0.5240237316111005`\)},
          {"3", "0.44231925142415124`", 
            "0.44323740629851743`", \(-0.0009181548743662143`\), \
\(-0.1239205576598399`\)},
          {"4", "1.716202138173854`", 
            "1.7201896719749508`", \(-0.003987533801096798`\), \
\(-0.09820685596451126`\)},
          {
            "5", \(-0.11841137059277086`\), \(-0.11513832263473303`\), \
\(-0.003273047958037833`\), \(-0.16607406917922396`\)},
          {
            "6", \(-0.5668552928839525`\), \(-0.5374381113407432`\), \
\(-0.029417181543209367`\), \(-0.23664988929873054`\)},
          {
            "7", \(-4.793551895795508`\), \(-4.784641787035408`\), \
\(-0.008910108760099983`\), "0.012188280543698027`"},
          {
            "8", \(-5.700681977474876`\), \(-5.559735794314172`\), \
\(-0.14094618316070437`\), \(-0.07009295703301902`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8698\"\>",
                    0.86975653642892992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06882\"\>",
                    0.068820658448820876,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.175\"\>",
                    -0.17497842492338331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.824\"\>",
                    3.8239606326139719,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2491\"\>",
                    -0.24913612372185384,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1082\"\>",
                    0.10818993875225252,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.657\"\>",
                    1.657131631525022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1804\"\>",
                    0.18041513027814246,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06882\"\>",
                    0.068820658448820599,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.626\"\>",
                    7.625838206601192,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8361\"\>",
                    0.836118078850285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.39\"\>",
                    15.386723613311553,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6477\"\>",
                    0.64769412875097232,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5511\"\>",
                    -0.55106022258335841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.647\"\>",
                    4.6468537567814208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1156\"\>",
                    0.11562385273578363,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.175\"\>",
                    -0.17497842492338334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8361\"\>",
                    0.83611807885028444,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.49\"\>",
                    21.486138774463512,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.652\"\>",
                    -3.652119136608428,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04377\"\>",
                    0.043767759195468603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3801\"\>",
                    0.38012311381528685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.432\"\>",
                    -4.4320653709397471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3128\"\>",
                    0.31282785926929169,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.824\"\>",
                    3.8239606326139719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.39\"\>",
                    15.386723613311553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.652\"\>",
                    -3.6521191366084298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 68.21\"\>",
                    68.212595650799713,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3253\"\>",
                    -0.32530536880236516,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6447\"\>",
                    -0.64468339255685647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.56\"\>",
                    26.559338776266948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5741\"\>",
                    -0.57410517742029255,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2491\"\>",
                    -0.24913612372185384,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6477\"\>",
                    0.6476941287509721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04377\"\>",
                    0.043767759195468492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3253\"\>",
                    -0.32530536880236538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.968\"\>",
                    9.9681085698846026,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1772\"\>",
                    0.17722644043596181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2679\"\>",
                    -0.26794108684143048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.119\"\>",
                    0.11899124745963513,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1082\"\>",
                    0.1081899387522523,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5511\"\>",
                    -0.55106022258335774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3801\"\>",
                    0.38012311381528641,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6447\"\>",
                    -0.64468339255685647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1772\"\>",
                    0.17722644043596136,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.703\"\>",
                    9.7025417730468817,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.769\"\>",
                    -0.7690461344713948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1793\"\>",
                    0.17927030014621959,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.657\"\>",
                    1.657131631525022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.647\"\>",
                    4.6468537567814217,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.432\"\>",
                    -4.4320653709397471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.56\"\>",
                    26.559338776266948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2679\"\>",
                    -0.26794108684143042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.769\"\>",
                    -0.76904613447139536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.12\"\>",
                    22.119727443538018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2724\"\>",
                    -0.27241782746678883,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1804\"\>",
                    0.18041513027814249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1156\"\>",
                    0.11562385273578363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3128\"\>",
                    0.31282785926929169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5741\"\>",
                    -0.57410517742029243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.119\"\>",
                    0.1189912474596351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1793\"\>",
                    0.17927030014621964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2724\"\>",
                    -0.27241782746678889,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8407\"\>",
                    0.84074162038238887,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.522423643653015`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.811267935003363`\),
      SequenceForm[ "*BFGSUP ", 8.5224236436530152, "  ", 8.8112679350033627],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "MBFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.075787608151300\"\>",
            159.0757876081513,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.068469697790900\"\>",
            159.06846969779085,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.0757876081513, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.06846969779085, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.007317910360456\"\>",
            0.0073179103604559259,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0073179103604559259, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.53221393287058`\), \(-12.571261694359666`\), 
            "0.03904776148908728`", \(-0.008940628946370224`\)},
          {"2", \(-3.1524328962031345`\), \(-3.17238586264111`\), 
            "0.01995296643797533`", "0.09567514619866435`"},
          {"3", "0.4357146222506873`", 
            "0.44231925142415124`", \(-0.006604629173463932`\), \
\(-0.16506980277411987`\)},
          {"4", "1.7080527653880344`", 
            "1.716202138173854`", \(-0.008149372785819608`\), 
            "0.24911463396466915`"},
          {
            "5", \(-0.1321434606691722`\), \(-0.11841137059277086`\), \
\(-0.013732090076401344`\), \(-0.1328221754347212`\)},
          {"6", \(-0.5601900741151336`\), \(-0.5668552928839525`\), 
            "0.006665218768818936`", "0.057893942036485235`"},
          {"7", \(-4.7838529252410815`\), \(-4.793551895795508`\), 
            "0.009698970554426456`", "0.21296607340535034`"},
          {
            "8", \(-5.787719285439`\), \(-5.700681977474876`\), \
\(-0.08703730796412427`\), \(-0.06008707839044996`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8897\"\>",
                    0.88969687018443522,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1177\"\>",
                    -0.11773339754357462,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1309\"\>",
                    0.13086330026313833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.358\"\>",
                    3.3579549757297764,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004077\"\>",
                    -0.0040772049812659583,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003442\"\>",
                    -0.0034419274496226837,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.26\"\>",
                    1.2602456993427666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2914\"\>",
                    0.29135520162888684,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1177\"\>",
                    -0.1177333975435749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.479\"\>",
                    8.4790945751693076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04662\"\>",
                    0.046615009857411516,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.77\"\>",
                    16.767593387345141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05649\"\>",
                    0.05649252228835222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08816\"\>",
                    -0.088161903593202973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.764\"\>",
                    5.7635059284859977,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1552\"\>",
                    -0.15517289350411395,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1309\"\>",
                    0.1308633002631383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04662\"\>",
                    0.046615009857410961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.37\"\>",
                    21.365260942288646,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.881\"\>",
                    -3.8811535558523023,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1492\"\>",
                    -0.14922920777257417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01843\"\>",
                    0.0184317947790551,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.489\"\>",
                    -4.489168046185565,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2328\"\>",
                    0.23278457862453564,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.358\"\>",
                    3.3579549757297764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.77\"\>",
                    16.767593387345141,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.881\"\>",
                    -3.881153555852304,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 69.16\"\>",
                    69.155693475982645,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3706\"\>",
                    -0.37058743202862465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02239\"\>",
                    0.022392977547560422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.16\"\>",
                    27.164192082194877,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6051\"\>",
                    -0.60514089042853825,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.004077\"\>",
                    -0.0040772049812659583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05649\"\>",
                    0.056492522288351998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1492\"\>",
                    -0.14922920777257428,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3706\"\>",
                    -0.37058743202862487,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.735\"\>",
                    9.7345116900065261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0856\"\>",
                    -0.085599002199050922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1932\"\>",
                    -0.19320793286053048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01926\"\>",
                    0.019258136026098327,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.003442\"\>",
                    -0.0034419274496228502,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08816\"\>",
                    -0.088161903593202307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01843\"\>",
                    0.018431794779054766,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02239\"\>",
                    0.022392977547560422,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0856\"\>",
                    -0.085599002199051311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.948\"\>",
                    9.9484548061176223,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2396\"\>",
                    -0.23963340828233637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05823\"\>",
                    0.058230506635048543,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.26\"\>",
                    1.2602456993427666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.764\"\>",
                    5.7635059284859986,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.489\"\>",
                    -4.489168046185565,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.16\"\>",
                    27.164192082194877,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1932\"\>",
                    -0.19320793286053042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2396\"\>",
                    -0.23963340828233692,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.46\"\>",
                    22.461972066428082,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2478\"\>",
                    -0.24776905691827994,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2914\"\>",
                    0.29135520162888684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1552\"\>",
                    -0.15517289350411401,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2328\"\>",
                    0.23278457862453564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6051\"\>",
                    -0.60514089042853803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01926\"\>",
                    0.019258136026098313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05823\"\>",
                    0.058230506635048598,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2478\"\>",
                    -0.24776905691828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7983\"\>",
                    0.79830490632174134,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]178.11347660601243`\
\[InvisibleSpace]"  "\[InvisibleSpace]98.7638778359748`\),
      SequenceForm[ "*BFGSUP ", 178.11347660601243, "  ", 98.763877835974796],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "MBFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.084909453873000\"\>",
            159.08490945387302,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.075787608151300\"\>",
            159.0757876081513,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.08490945387302, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.0757876081513, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.009121845721722\"\>",
            0.0091218457217223659,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0091218457217223659, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.519572267272292`\), \(-12.53221393287058`\), 
            "0.012641665598287374`", \(-0.011897239036184526`\)},
          {"2", \(-3.1454380883705317`\), \(-3.1524328962031345`\), 
            "0.0069948078326028855`", "0.03773307568523991`"},
          {"3", "0.435399837551184`", 
            "0.4357146222506873`", \(-0.00031478469950330226`\), 
            "0.014633590448327863`"},
          {"4", "1.7056408589265348`", 
            "1.7080527653880344`", \(-0.0024119064614996555`\), 
            "0.2220790083268718`"},
          {
            "5", \(-0.14331656303647136`\), \(-0.1321434606691722`\), \
\(-0.011173102367299164`\), "0.002537370243012038`"},
          {"6", \(-0.554832136688937`\), \(-0.5601900741151336`\), 
            "0.005357937426196455`", \(-0.007931990419046464`\)},
          {"7", \(-4.765025784212628`\), \(-4.7838529252410815`\), 
            "0.018827141028453828`", "0.15028751974857413`"},
          {
            "8", \(-5.978410726146161`\), \(-5.787719285439`\), \
\(-0.19069144070716193`\), \(-0.054677317067813765`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8834\"\>",
                    0.88335918147791714,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002738\"\>",
                    -0.002738177769103553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1095\"\>",
                    -0.10952916355124118,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.592\"\>",
                    3.5921632715245213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1926\"\>",
                    -0.19264264639489814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08234\"\>",
                    0.082343803575237157,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.481\"\>",
                    1.4813044090885128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2354\"\>",
                    0.23544879355219425,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.002738\"\>",
                    -0.0027381777691038167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.173\"\>",
                    8.1730137905815639,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2482\"\>",
                    -0.24818580358053632,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.69\"\>",
                    14.692662101945112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08538\"\>",
                    -0.085383937211876204,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04412\"\>",
                    0.044124830322668673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.398\"\>",
                    4.3979957863372583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3568\"\>",
                    0.35677467593246875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1095\"\>",
                    -0.1095291635512412,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2482\"\>",
                    -0.24818580358053732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.43\"\>",
                    24.426012501918805,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6852\"\>",
                    -0.6851995472431609,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.018\"\>",
                    2.0179133238980183,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.145\"\>",
                    -1.1446569592901159,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.023\"\>",
                    -3.0233860733617983,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5737\"\>",
                    -0.57365762920275809,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.592\"\>",
                    3.5921632715245213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.69\"\>",
                    14.692662101945112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6852\"\>",
                    -0.68519954724316179,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 63.16\"\>",
                    63.156782386812104,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.245\"\>",
                    2.2454949724848356,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.085\"\>",
                    -1.0850233988112226,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.23\"\>",
                    22.226298374890437,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8472\"\>",
                    0.84716296684224623,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1926\"\>",
                    -0.19264264639489814,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08538\"\>",
                    -0.085383937211876426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.018\"\>",
                    2.0179133238980178,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.245\"\>",
                    2.2454949724848356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.26\"\>",
                    11.255577912808093,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9132\"\>",
                    -0.91316540879620534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.089\"\>",
                    1.0893483002772062,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6385\"\>",
                    -0.63854026838969991,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08234\"\>",
                    0.08234380357523699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04412\"\>",
                    0.04412483032266945,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.145\"\>",
                    -1.1446569592901166,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.085\"\>",
                    -1.0850233988112221,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9132\"\>",
                    -0.91316540879620578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.39\"\>",
                    10.389202277339352,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7225\"\>",
                    -0.72246345354213659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3384\"\>",
                    0.33837155004932595,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.481\"\>",
                    1.4813044090885128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.398\"\>",
                    4.3979957863372601,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.023\"\>",
                    -3.0233860733617974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.23\"\>",
                    22.226298374890437,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.089\"\>",
                    1.0893483002772062,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7225\"\>",
                    -0.72246345354213726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.68\"\>",
                    18.682317784874044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9557\"\>",
                    0.9556698012997038,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2354\"\>",
                    0.23544879355219425,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3568\"\>",
                    0.3567746759324687,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5737\"\>",
                    -0.57365762920275831,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8472\"\>",
                    0.84716296684224646,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6385\"\>",
                    -0.63854026838969991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3384\"\>",
                    0.33837155004932606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9557\"\>",
                    0.9556698012997038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4469\"\>",
                    0.44693475635740565,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]138.57948488796853`\
\[InvisibleSpace]"  "\[InvisibleSpace]78.37957588652317`\),
      SequenceForm[ "*BFGSUP ", 138.57948488796853, "  ", 78.37957588652317],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "MBFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.094118444848100\"\>",
            159.09411844484808,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.084909453873000\"\>",
            159.08490945387302,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.09411844484808, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.08490945387302, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.009208990975054\"\>",
            0.009208990975054121,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.009208990975054121, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.51237990453257`\), \(-12.519572267272292`\), 
            "0.007192362739720783`", \(-0.020436771783653843`\)},
          {"2", \(-3.1442890822404053`\), \(-3.1454380883705317`\), 
            "0.0011490061301263257`", \(-0.0366387295005397`\)},
          {"3", "0.43146516435768356`", 
            "0.435399837551184`", \(-0.003934673193500414`\), 
            "0.012502829573920654`"},
          {"4", "1.705109910974777`", 
            "1.7056408589265348`", \(-0.0005309479517578809`\), \
\(-0.03720289803005117`\)},
          {"5", \(-0.14259888276730484`\), \(-0.14331656303647136`\), 
            "0.0007176802691665254`", "0.11219025124814075`"},
          {
            "6", \(-0.5555900161473537`\), \(-0.554832136688937`\), \
\(-0.0007578794584166844`\), \(-0.06037533549195295`\)},
          {"7", \(-4.751170819489525`\), \(-4.765025784212628`\), 
            "0.013854964723102981`", \(-0.05567094253327459`\)},
          {
            "8", \(-6.27081944830056`\), \(-5.978410726146161`\), \
\(-0.2924087221543987`\), \(-0.045079721600957766`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8824\"\>",
                    0.88237071716738646,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1205\"\>",
                    0.12045983146862534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09336\"\>",
                    -0.09336178136458087,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.106\"\>",
                    4.1060873268057358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.32\"\>",
                    -0.32004021065002519,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.137\"\>",
                    0.1370088850674549,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.865\"\>",
                    1.865179682151425,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1731\"\>",
                    0.17310433198138181,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1205\"\>",
                    0.12045983146862507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.828\"\>",
                    8.8279241789512177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2695\"\>",
                    -0.26950419583787477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.71\"\>",
                    16.708127599262411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.223\"\>",
                    -1.223015376333676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6081\"\>",
                    0.6080861416394886,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.076\"\>",
                    6.0762117002828067,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4196\"\>",
                    0.41956625631317357,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09336\"\>",
                    -0.093361781364580898,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2695\"\>",
                    -0.26950419583787577,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.41\"\>",
                    24.409857315703352,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8634\"\>",
                    -0.86335783684725309,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.983\"\>",
                    1.9826247499700613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.12\"\>",
                    -1.1200737101202813,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.135\"\>",
                    -3.1349466810711841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5138\"\>",
                    -0.51377811015325803,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 4.106\"\>",
                    4.1060873268057358,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.71\"\>",
                    16.708127599262411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8634\"\>",
                    -0.86335783684725398,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 68.61\"\>",
                    68.607471201357868,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.739\"\>",
                    -1.7386261041999216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9374\"\>",
                    0.93739432001892298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.01\"\>",
                    27.01064992620671,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.454\"\>",
                    1.4540487451275148,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.32\"\>",
                    -0.32004021065002519,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.223\"\>",
                    -1.2230153763336764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.983\"\>",
                    1.9826247499700609,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.739\"\>",
                    -1.738626104199922,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.92\"\>",
                    12.921318964756894,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.708\"\>",
                    -1.7084980902387321,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.07\"\>",
                    -2.0702111812333044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4818\"\>",
                    -0.48182454939793762,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.137\"\>",
                    0.13700888506745473,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6081\"\>",
                    0.60808614163948937,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.12\"\>",
                    -1.120073710120282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9374\"\>",
                    0.93739432001892342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.708\"\>",
                    -1.7084980902387323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.77\"\>",
                    10.765406683864965,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8678\"\>",
                    0.86778910730100267,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2346\"\>",
                    0.23462711786042095,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.865\"\>",
                    1.865179682151425,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.076\"\>",
                    6.0762117002828075,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.135\"\>",
                    -3.1349466810711832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.01\"\>",
                    27.01064992620671,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.07\"\>",
                    -2.0702111812333044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8678\"\>",
                    0.86778910730100201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.79\"\>",
                    22.790397819457155,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.326\"\>",
                    1.325808830154009,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1731\"\>",
                    0.17310433198138178,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4196\"\>",
                    0.41956625631317346,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5138\"\>",
                    -0.51377811015325825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.454\"\>",
                    1.454048745127515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4818\"\>",
                    -0.48182454939793762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2346\"\>",
                    0.23462711786042104,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.326\"\>",
                    1.325808830154009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2254\"\>",
                    0.22537555905933718,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]165.20708439269453`\
\[InvisibleSpace]"  "\[InvisibleSpace]81.18115163924004`\),
      SequenceForm[ "*BFGSUP ", 165.20708439269453, "  ", 81.181151639240042],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "MBFGS: Iteration = ", 15],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.105638261867900\"\>",
            159.10563826186785,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.094118444848100\"\>",
            159.09411844484808,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.10563826186785, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.09411844484808, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.011519817019774\"\>",
            0.011519817019774337,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.011519817019774337, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.519916642022121`\), \(-12.51237990453257`\), \
\(-0.007536737489550064`\), \(-0.02792274202264504`\)},
          {
            "2", \(-3.1480782166545254`\), \(-3.1442890822404053`\), \
\(-0.0037891344141200737`\), \(-0.07297419773537112`\)},
          {"3", "0.43394399392215566`", "0.43146516435768356`", 
            "0.0024788295644721198`", "0.13809756069086684`"},
          {"4", "1.7062096688240633`", "1.705109910974777`", 
            "0.001099757849286452`", \(-0.23651403297429271`\)},
          {"5", \(-0.13725992754344704`\), \(-0.14259888276730484`\), 
            "0.005338955223857811`", "0.10419456704749974`"},
          {
            "6", \(-0.558530840082032`\), \(-0.5555900161473537`\), \
\(-0.0029408239346782957`\), \(-0.05165849894699015`\)},
          {"7", \(-4.743837509296956`\), \(-4.751170819489525`\), 
            "0.00733331019256915`", \(-0.21402559254899584`\)},
          {
            "8", \(-6.733578519814649`\), \(-6.27081944830056`\), \
\(-0.46275907151408935`\), \(-0.0335796386116366`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8577\"\>",
                    0.85772262793740139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1046\"\>",
                    0.10461058043776007,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2279\"\>",
                    -0.22794601811411405,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.291\"\>",
                    4.290859837510121,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.124\"\>",
                    -0.12401898849840257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02606\"\>",
                    0.026060913449205844,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.969\"\>",
                    1.9686598858501765,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08409\"\>",
                    0.084090878519257811,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1046\"\>",
                    0.1046105804377598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.937\"\>",
                    8.9370642232616184,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9862\"\>",
                    -0.98624579492747855,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.79\"\>",
                    17.793912438518685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8413\"\>",
                    -0.84132247438321306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3762\"\>",
                    0.37618120250938292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.861\"\>",
                    6.8612089315798341,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2164\"\>",
                    0.21644871194377646,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2279\"\>",
                    -0.22794601811411411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9862\"\>",
                    -0.98624579492747966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.\"\>",
                    27.003149594089479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.961\"\>",
                    -4.9611316262640308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.703\"\>",
                    1.7028487408552351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8779\"\>",
                    -0.87792624449464263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.364\"\>",
                    -6.364163701435035,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2294\"\>",
                    -0.22940563413764559,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 4.291\"\>",
                    4.290859837510121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.79\"\>",
                    17.793912438518685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.961\"\>",
                    -4.9611316262640317,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 75.06\"\>",
                    75.05795158934616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1365132294256095,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.468\"\>",
                    0.46802568791682836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.06\"\>",
                    32.056754380621662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9392\"\>",
                    0.93922987243652578,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.124\"\>",
                    -0.12401898849840257,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8413\"\>",
                    -0.8413224743832135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.703\"\>",
                    1.7028487408552349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1365132294256099,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.91\"\>",
                    11.910081870011922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.17\"\>",
                    -1.1701300566473445,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.354\"\>",
                    -1.3539974830317842,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08644\"\>",
                    -0.086441407203607934,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02606\"\>",
                    0.026060913449205678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3762\"\>",
                    0.37618120250938369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8779\"\>",
                    -0.87792624449464329,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.468\"\>",
                    0.46802568791682886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.17\"\>",
                    -1.1701300566473449,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.48\"\>",
                    10.482039650765849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3669\"\>",
                    0.36688306737025789,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03024\"\>",
                    0.030237184029225372,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.969\"\>",
                    1.9686598858501767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.861\"\>",
                    6.861208931579835,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.364\"\>",
                    -6.3641637014350341,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.06\"\>",
                    32.056754380621662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.354\"\>",
                    -1.3539974830317842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3669\"\>",
                    0.36688306737025722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.68\"\>",
                    26.68156191691169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8212\"\>",
                    0.82121689217065241,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08409\"\>",
                    0.084090878519257783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2164\"\>",
                    0.21644871194377635,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2294\"\>",
                    -0.22940563413764581,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9392\"\>",
                    0.939229872436526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08644\"\>",
                    -0.086441407203607934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03024\"\>",
                    0.030237184029225456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8212\"\>",
                    0.82121689217065241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08225\"\>",
                    0.08224969306828836,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]142.65745195456046`\
\[InvisibleSpace]"  "\[InvisibleSpace]65.5860594823159`\),
      SequenceForm[ "*BFGSUP ", 142.65745195456046, "  ", 65.586059482315903],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "MBFGS: Iteration = ", 16],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.118374622897200\"\>",
            159.11837462289716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.105638261867900\"\>",
            159.10563826186785,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.11837462289716, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.10563826186785, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.012736361029312\"\>",
            0.012736361029311638,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.012736361029311638, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.55624799879523`\), \(-12.519916642022121`\), \
\(-0.036331356773110265`\), \(-0.030266383230265016`\)},
          {
            "2", \(-3.160721763402666`\), \(-3.1480782166545254`\), \
\(-0.012643546748140548`\), \(-0.08228102163715206`\)},
          {"3", "0.43359633527077746`", 
            "0.43394399392215566`", \(-0.0003476586513781926`\), 
            "0.06399741344205603`"},
          {"4", "1.712994670396727`", "1.7062096688240633`", 
            "0.006785001572663617`", \(-0.3252274633606414`\)},
          {"5", \(-0.13043853733427332`\), \(-0.13725992754344704`\), 
            "0.0068213902091737106`", "0.05084684128531003`"},
          {
            "6", \(-0.5621634027674914`\), \(-0.558530840082032`\), \
\(-0.0036325626854594264`\), \(-0.021091205004584168`\)},
          {
            "7", \(-4.753951667767957`\), \(-4.743837509296956`\), \
\(-0.010114158471001571`\), \(-0.3015298150973381`\)},
          {
            "8", \(-7.397735203655072`\), \(-6.733578519814649`\), \
\(-0.6641566838404235`\), \(-0.021121596321094435`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8074\"\>",
                    0.80737008846602965,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02592\"\>",
                    -0.025918554176891331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04973\"\>",
                    0.049732416746821301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.887\"\>",
                    3.887381869390675,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08463\"\>",
                    0.084633128518308454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07876\"\>",
                    -0.078763301661626067,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.606\"\>",
                    1.6059616731324291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01843\"\>",
                    0.018429859706783458,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02592\"\>",
                    -0.025918554176891609,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.6\"\>",
                    8.6001596962686246,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2269\"\>",
                    -0.22691657028504675,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.78\"\>",
                    16.779718710860106,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2718\"\>",
                    -0.27180876756230021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08836\"\>",
                    0.088355150749632516,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.953\"\>",
                    5.9530414549314319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03919\"\>",
                    0.039193146361117787,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04973\"\>",
                    0.049732416746821245,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2269\"\>",
                    -0.22691657028504775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.54\"\>",
                    26.535670110462313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.881\"\>",
                    -1.881174838736607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.323\"\>",
                    1.323065423258301,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7332\"\>",
                    -0.73316599731838261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.501\"\>",
                    -3.500673360655524,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05696\"\>",
                    -0.056958813641690254,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.887\"\>",
                    3.887381869390675,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.78\"\>",
                    16.779718710860106,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.881\"\>",
                    -1.8811748387366078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 72.51\"\>",
                    72.511864889618906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.155\"\>",
                    1.1549045181329025,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7202\"\>",
                    -0.72015057969350593,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 29.84\"\>",
                    29.844205606461045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2607\"\>",
                    0.26067733351650502,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08463\"\>",
                    0.084633128518308454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2718\"\>",
                    -0.27180876756230055,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.323\"\>",
                    1.3230654232583008,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.155\"\>",
                    1.1549045181329021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.6\"\>",
                    11.604046536384326,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.05\"\>",
                    -1.0497416817072101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7745\"\>",
                    0.77453814365158258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04822\"\>",
                    0.04822082524033558,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07876\"\>",
                    -0.078763301661626234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08836\"\>",
                    0.088355150749633238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7332\"\>",
                    -0.73316599731838328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7202\"\>",
                    -0.72015057969350538,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.05\"\>",
                    -1.0497416817072105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.44\"\>",
                    10.440309998380854,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7398\"\>",
                    -0.73982768891781459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02921\"\>",
                    -0.029208039781151711,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.606\"\>",
                    1.6059616731324291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.953\"\>",
                    5.9530414549314328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.501\"\>",
                    -3.5006733606555231,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 29.84\"\>",
                    29.844205606461045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7745\"\>",
                    0.77453814365158258,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7398\"\>",
                    -0.73982768891781503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.77\"\>",
                    24.769590824939897,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1943\"\>",
                    0.19434095244890548,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01843\"\>",
                    0.01842985970678343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03919\"\>",
                    0.039193146361117648,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05696\"\>",
                    -0.056958813641690476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2607\"\>",
                    0.26067733351650524,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04822\"\>",
                    0.048220825240335607,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02921\"\>",
                    -0.029208039781151628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1943\"\>",
                    0.19434095244890537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03044\"\>",
                    0.030436207116102523,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]116.07283800600686`\
\[InvisibleSpace]"  "\[InvisibleSpace]57.43081333961209`\),
      SequenceForm[ "*BFGSUP ", 116.07283800600686, "  ", 57.430813339612087],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "MBFGS: Iteration = ", 17],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.126584884542900\"\>",
            159.12658488454292,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.118374622897200\"\>",
            159.11837462289716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.12658488454292, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.11837462289716, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.008210261645758\"\>",
            0.008210261645757555,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.008210261645757555, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.578071445963973`\), \(-12.55624799879523`\), \
\(-0.02182344716874215`\), \(-0.02116768434115937`\)},
          {
            "2", \(-3.1648312693425873`\), \(-3.160721763402666`\), \
\(-0.0041095059399213684`\), \(-0.05543606230650551`\)},
          {"3", "0.43854192660482144`", "0.43359633527077746`", 
            "0.004945591334043992`", "0.10395644408868168`"},
          {"4", "1.714254695174209`", "1.712994670396727`", 
            "0.00126002477748209`", \(-0.30703124336458676`\)},
          {"5", \(-0.1289654235278912`\), \(-0.13043853733427332`\), 
            "0.0014731138063821339`", \(-0.016010134457307368`\)},
          {"6", \(-0.5620422171449886`\), \(-0.5621634027674914`\), 
            "0.00012118562250279531`", "0.0162115862184411`"},
          {
            "7", \(-4.767878366255615`\), \(-4.753951667767957`\), \
\(-0.013926698487657799`\), \(-0.23379050840936355`\)},
          {
            "8", \(-8.14940288760709`\), \(-7.397735203655072`\), \
\(-0.7516676839520177`\), \(-0.010915906095335598`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7644\"\>",
                    0.76436960811559407,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1406\"\>",
                    -0.14059004054500468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2032\"\>",
                    0.20317539697229414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.341\"\>",
                    3.3412812531650582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1024\"\>",
                    0.10240783666823547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07603\"\>",
                    -0.076028601353440028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.153\"\>",
                    1.1533758928743287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007506\"\>",
                    -0.0075058350397405466,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1406\"\>",
                    -0.14059004054500496,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.295\"\>",
                    8.2949916309384424,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2\"\>",
                    0.200012196030942,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3\"\>",
                    15.299566278921487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2399\"\>",
                    -0.23985811997973724,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1049\"\>",
                    0.10492378003933468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.739\"\>",
                    4.7392462563646891,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02882\"\>",
                    -0.02881560795905494,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2032\"\>",
                    0.20317539697229409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2\"\>",
                    0.200012196030941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.49\"\>",
                    26.485788814106293,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6014\"\>",
                    -0.60142923022886063,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8261\"\>",
                    0.82608852462369298,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4826\"\>",
                    -0.48263064375038123,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.078\"\>",
                    -2.0782379772030413,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06801\"\>",
                    0.06800760264893517,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.341\"\>",
                    3.3412812531650582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3\"\>",
                    15.299566278921485,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6014\"\>",
                    -0.60142923022886152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 66.48\"\>",
                    66.475673043210918,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.963\"\>",
                    1.9634180301863196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.035\"\>",
                    -1.0353070099007753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.36\"\>",
                    24.355279580783801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1123\"\>",
                    -0.11227817999704753,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1024\"\>",
                    0.10240783666823548,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2399\"\>",
                    -0.23985811997973755,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8261\"\>",
                    0.82608852462369275,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.963\"\>",
                    1.9634180301863191,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.97\"\>",
                    11.974393617886372,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.278\"\>",
                    -1.2776317268223749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.129\"\>",
                    1.1293821939690583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0307\"\>",
                    0.030700589626764911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07603\"\>",
                    -0.076028601353440195,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1049\"\>",
                    0.1049237800393354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4826\"\>",
                    -0.48263064375038189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.035\"\>",
                    -1.0353070099007748,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.278\"\>",
                    -1.2776317268223754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.58\"\>",
                    10.576277685897345,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8118\"\>",
                    -0.81176583164334337,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0106\"\>",
                    -0.010603299431732074,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.153\"\>",
                    1.1533758928743287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.739\"\>",
                    4.7392462563646891,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.078\"\>",
                    -2.0782379772030404,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.36\"\>",
                    24.355279580783805,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.129\"\>",
                    1.1293821939690583,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8118\"\>",
                    -0.81176583164334382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.08\"\>",
                    20.080581513152698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09118\"\>",
                    -0.09117968164706991,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.007506\"\>",
                    -0.0075058350397405743,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02882\"\>",
                    -0.028815607959055078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06801\"\>",
                    0.068007602648934948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1123\"\>",
                    -0.11227817999704726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0307\"\>",
                    0.030700589626764932,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0106\"\>",
                    -0.01060329943173199,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09118\"\>",
                    -0.091179681647070021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0169\"\>",
                    0.016904763134272513,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]132.3845943218682`\
\[InvisibleSpace]"  "\[InvisibleSpace]81.58956433344561`\),
      SequenceForm[ "*BFGSUP ", 132.38459432186821, "  ", 81.589564333445608],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "MBFGS: Iteration = ", 18],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.129168903790700\"\>",
            159.12916890379071,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.126584884542900\"\>",
            159.12658488454292,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.12916890379071, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.12658488454292, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002584019247792\"\>",
            0.0025840192477915025,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0025840192477915025, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.599607918785438`\), \(-12.578071445963973`\), \
\(-0.021536472821464456`\), \(-0.006257225101212866`\)},
          {
            "2", \(-3.1700764562791166`\), \(-3.1648312693425873`\), \
\(-0.005245186936529447`\), \(-0.007873711006758077`\)},
          {"3", "0.43719998476594524`", 
            "0.43854192660482144`", \(-0.001341941838876208`\), \
\(-0.04356773836317308`\)},
          {"4", "1.7182728902257003`", "1.714254695174209`", 
            "0.004018195051491255`", \(-0.051476099177223206`\)},
          {
            "5", \(-0.13084825160207086`\), \(-0.1289654235278912`\), \
\(-0.0018828280741796776`\), \(-0.029794879348737924`\)},
          {"6", \(-0.5610248735200566`\), \(-0.5620422171449886`\), 
            "0.001017343624931988`", "0.015573084227891165`"},
          {
            "7", \(-4.779742078219887`\), \(-4.767878366255615`\), \
\(-0.011863711964272728`\), \(-0.07081427278856006`\)},
          {
            "8", \(-8.747374865257978`\), \(-8.14940288760709`\), \
\(-0.5979719776508873`\), \(-0.005148463305503238`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7572\"\>",
                    0.75724368243411433,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1424\"\>",
                    -0.14244752182107986,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09151\"\>",
                    0.091514425106727221,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.315\"\>",
                    3.3154633733157541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04755\"\>",
                    0.047547423478972062,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04929\"\>",
                    -0.049290533231043127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.071\"\>",
                    1.0713064083748911,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01497\"\>",
                    -0.014973840819697663,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1424\"\>",
                    -0.14244752182108011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.344\"\>",
                    8.3437315088525636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2587\"\>",
                    -0.25868171982625821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.52\"\>",
                    15.519971420538374,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3991\"\>",
                    -0.39906798241701102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1742\"\>",
                    0.17422850993723421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.708\"\>",
                    4.7079943593519156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04187\"\>",
                    -0.041873463003383266,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09151\"\>",
                    0.091514425106727165,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2587\"\>",
                    -0.25868171982625909,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.49\"\>",
                    28.485191918654731,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.988\"\>",
                    -2.9882374432043699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.231\"\>",
                    1.231097748048348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6077\"\>",
                    -0.60766354463653571,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.278\"\>",
                    -3.2781970827646667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04796\"\>",
                    0.047955960595318481,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.315\"\>",
                    3.3154633733157541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.52\"\>",
                    15.519971420538372,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.988\"\>",
                    -2.9882374432043699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 67.43\"\>",
                    67.430203186478749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.096\"\>",
                    1.0959959501173884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6508\"\>",
                    -0.65079945462231548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.01\"\>",
                    24.012440800360338,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1906\"\>",
                    -0.19060597065316906,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04755\"\>",
                    0.047547423478972076,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3991\"\>",
                    -0.39906798241701136,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.231\"\>",
                    1.2310977480483478,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.096\"\>",
                    1.0959959501173879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.98\"\>",
                    11.978635834936028,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.255\"\>",
                    -1.2552899873748427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5266\"\>",
                    0.52657767503513342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.005917\"\>",
                    0.0059166429416201774,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04929\"\>",
                    -0.0492905332310433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1742\"\>",
                    0.17422850993723493,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6077\"\>",
                    -0.60766354463653638,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6508\"\>",
                    -0.65079945462231503,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.255\"\>",
                    -1.2552899873748431,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.55\"\>",
                    10.554888652676565,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5163\"\>",
                    -0.51630802836285405,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003348\"\>",
                    0.003347619292910331,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.071\"\>",
                    1.0713064083748911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.708\"\>",
                    4.7079943593519156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.278\"\>",
                    -3.2781970827646658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.01\"\>",
                    24.012440800360341,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5266\"\>",
                    0.52657767503513342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5163\"\>",
                    -0.5163080283628545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.14\"\>",
                    19.137359710145255,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.175\"\>",
                    -0.17496341572712737,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01497\"\>",
                    -0.014973840819697689,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04187\"\>",
                    -0.041873463003383404,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04796\"\>",
                    0.047955960595318273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1906\"\>",
                    -0.19060597065316881,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.005917\"\>",
                    0.0059166429416201982,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003348\"\>",
                    0.003347619292910416,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.175\"\>",
                    -0.17496341572712748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01159\"\>",
                    0.011586356166509919,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]365.9224116794372`\
\[InvisibleSpace]"  "\[InvisibleSpace]248.8564584331756`\),
      SequenceForm[ "*BFGSUP ", 365.92241167943718, "  ", 248.85645843317559],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]19\),
      SequenceForm[ "MBFGS: Iteration = ", 19],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.130161524073800\"\>",
            159.13016152407383,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.129168903790700\"\>",
            159.12916890379071,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13016152407383, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.12916890379071, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000992620283114\"\>",
            0.0009926202831138653,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0009926202831138653, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.599234717881416`\), \(-12.599607918785438`\), 
            "0.00037320090402240383`", "0.0021645886384503445`"},
          {"2", \(-3.1685642148845417`\), \(-3.1700764562791166`\), 
            "0.0015122413945750737`", "0.007020852686582791`"},
          {"3", "0.4382916266880118`", "0.43719998476594524`", 
            "0.001091641922066582`", "0.014954928257543968`"},
          {"4", "1.7171703298403063`", 
            "1.7182728902257003`", \(-0.0011025603853940743`\), 
            "0.0067189525136840955`"},
          {
            "5", \(-0.1321405856970809`\), \(-0.13084825160207086`\), \
\(-0.0012923340950100346`\), \(-0.010312257672004277`\)},
          {"6", \(-0.5600635518199697`\), \(-0.5610248735200566`\), 
            "0.0009613217000869147`", "0.005637885399193188`"},
          {
            "7", \(-4.781296789778551`\), \(-4.779742078219887`\), \
\(-0.0015547115586644039`\), "0.03045612572198453`"},
          {
            "8", \(-9.232017370326606`\), \(-8.747374865257978`\), \
\(-0.4846425050686277`\), \(-0.002840008791525018`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7735\"\>",
                    0.77345399824892391,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1088\"\>",
                    -0.10880704818669762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.204\"\>",
                    0.20402396353111921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.415\"\>",
                    3.4146487798657477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06119\"\>",
                    0.061192488314506549,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05566\"\>",
                    -0.055658495651769509,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.273\"\>",
                    1.2731259664416315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01588\"\>",
                    -0.015876740538132469,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1088\"\>",
                    -0.10880704818669787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.409\"\>",
                    8.4094827371203866,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02509\"\>",
                    -0.025085947941118403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.74\"\>",
                    15.736285776941454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3513\"\>",
                    -0.35126352946942502,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1506\"\>",
                    0.15059341858189695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.121\"\>",
                    5.1211886475001531,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03938\"\>",
                    -0.039379819732572187,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.204\"\>",
                    0.20402396353111915,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02509\"\>",
                    -0.025085947941119291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 29.27\"\>",
                    29.266074158713888,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.3\"\>",
                    -2.300114338854474,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.325\"\>",
                    1.325273873173455,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6516\"\>",
                    -0.65157825642405032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.877\"\>",
                    -1.8772926313559379,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04157\"\>",
                    0.041570727851093323,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.415\"\>",
                    3.4146487798657477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.74\"\>",
                    15.736285776941452,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.3\"\>",
                    -2.300114338854474,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 68.01\"\>",
                    68.010042407016812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.129\"\>",
                    1.1291987535903127,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6629\"\>",
                    -0.6628745619627282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.26\"\>",
                    25.261838996444716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2074\"\>",
                    -0.20740036075657353,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06119\"\>",
                    0.061192488314506556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3513\"\>",
                    -0.35126352946942541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.325\"\>",
                    1.3252738731734546,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.129\"\>",
                    1.1291987535903123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.9\"\>",
                    11.896611389720622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.211\"\>",
                    -1.2106503504087331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7235\"\>",
                    0.72348438247142011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0158\"\>",
                    -0.015800133499265619,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05566\"\>",
                    -0.055658495651769682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1506\"\>",
                    0.1505934185818977,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6516\"\>",
                    -0.65157825642405098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6629\"\>",
                    -0.66287456196272776,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.211\"\>",
                    -1.2106503504087336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.53\"\>",
                    10.530655281102863,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.61\"\>",
                    -0.61003970400030993,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01491\"\>",
                    0.014907882325318686,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.273\"\>",
                    1.2731259664416315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.121\"\>",
                    5.1211886475001531,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.877\"\>",
                    -1.877292631355937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.26\"\>",
                    25.26183899644472,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7235\"\>",
                    0.72348438247142022,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.61\"\>",
                    -0.61003970400031038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.64\"\>",
                    21.642217016920384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1801\"\>",
                    -0.18014801993743004,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01588\"\>",
                    -0.015876740538132497,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03938\"\>",
                    -0.039379819732572326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04157\"\>",
                    0.041570727851093114,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2074\"\>",
                    -0.20740036075657328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0158\"\>",
                    -0.015800133499265592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01491\"\>",
                    0.014907882325318767,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1801\"\>",
                    -0.18014801993743015,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00694\"\>",
                    0.0069399857642117114,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1411.832040602646`\
\[InvisibleSpace]"  "\[InvisibleSpace]730.925967307235`\),
      SequenceForm[ "*BFGSUP ", 1411.832040602646, "  ", 730.92596730723506],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]20\),
      SequenceForm[ "MBFGS: Iteration = ", 20],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131015352158200\"\>",
            159.13101535215816,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.130161524073800\"\>",
            159.13016152407383,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13101535215816, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13016152407383, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000853828084331\"\>",
            0.00085382808433109858,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00085382808433109858, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.59811565372727`\), \(-12.599234717881416`\), 
            "0.001119064154145265`", "0.005428403553975759`"},
          {"2", \(-3.168125309721635`\), \(-3.1685642148845417`\), 
            "0.00043890516290687333`", "0.014812504383499956`"},
          {"3", "0.43797400204452047`", 
            "0.4382916266880118`", \(-0.00031762464349133625`\), \
\(-0.022268242891840054`\)},
          {"4", "1.7171705326763191`", "1.7171703298403063`", 
            "2.0283601282348987`*^-7", "0.07841068391287087`"},
          {
            "5", \(-0.1328504526388404`\), \(-0.1321405856970809`\), \
\(-0.0007098669417595158`\), "0.0025481434970584527`"},
          {"6", \(-0.5597503901359693`\), \(-0.5600635518199697`\), 
            "0.0003131616840003912`", \(-0.003863142084075122`\)},
          {"7", \(-4.780745400177761`\), \(-4.781296789778551`\), 
            "0.0005513896007903847`", "0.060249792337041586`"},
          {
            "8", \(-9.857155689020257`\), \(-9.232017370326606`\), \
\(-0.6251383186936507`\), \(-0.0017473526825573019`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7851\"\>",
                    0.78506880917230792,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08401\"\>",
                    -0.084011511209484246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00884\"\>",
                    0.0088401364400077509,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.734\"\>",
                    3.7343708830695057,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1368\"\>",
                    0.13676826302159018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1084\"\>",
                    -0.10835883892528236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.362\"\>",
                    1.3622276624551948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006348\"\>",
                    -0.0063484951678749249,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08401\"\>",
                    -0.084011511209484496,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.459\"\>",
                    8.4591657539879144,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5113\"\>",
                    -0.51130413040364575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.49\"\>",
                    16.490451113402074,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1569\"\>",
                    -0.1568729857468372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01715\"\>",
                    0.017145263130840194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.293\"\>",
                    5.2926415644784042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01279\"\>",
                    -0.012785912392409719,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00884\"\>",
                    0.0088401364400076954,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5113\"\>",
                    -0.51130413040364653,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.06\"\>",
                    31.058786968084462,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.141\"\>",
                    -6.1411647726428367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7621\"\>",
                    0.76214566351582336,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2139\"\>",
                    -0.2138994527442753,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.776\"\>",
                    -3.7759494385809345,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01519\"\>",
                    0.015192499163624716,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.734\"\>",
                    3.7343708830695057,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.49\"\>",
                    16.490451113402074,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.141\"\>",
                    -6.1411647726428367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 75.23\"\>",
                    75.233444531131667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.482\"\>",
                    2.4815299914122226,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.652\"\>",
                    -1.652225028845911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.13\"\>",
                    28.127883353289164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08286\"\>",
                    -0.082857888597868301,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1368\"\>",
                    0.13676826302159018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1569\"\>",
                    -0.15687298574683758,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7621\"\>",
                    0.76214566351582302,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.482\"\>",
                    2.4815299914122217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.05\"\>",
                    12.052385565089875,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.341\"\>",
                    -1.340662363385384,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.494\"\>",
                    1.4940027900559651,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01737\"\>",
                    -0.017367632953543492,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1084\"\>",
                    -0.10835883892528253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01715\"\>",
                    0.017145263130840943,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2139\"\>",
                    -0.21389945274427596,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.652\"\>",
                    -1.6522250288459106,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.341\"\>",
                    -1.3406623633853845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.63\"\>",
                    10.634867654937626,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.135\"\>",
                    -1.1351935715672974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01195\"\>",
                    0.011954478144902013,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.362\"\>",
                    1.3622276624551948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.293\"\>",
                    5.2926415644784042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.776\"\>",
                    -3.775949438580934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.13\"\>",
                    28.127883353289167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.494\"\>",
                    1.4940027900559654,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.135\"\>",
                    -1.1351935715672978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.22\"\>",
                    22.217458386721116,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07096\"\>",
                    -0.070964984908505113,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.006348\"\>",
                    -0.0063484951678749544,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01279\"\>",
                    -0.012785912392409858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01519\"\>",
                    0.015192499163624508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08286\"\>",
                    -0.082857888597868051,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01737\"\>",
                    -0.01736763295354346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01195\"\>",
                    0.011954478144902095,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07096\"\>",
                    -0.070964984908505224,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00273\"\>",
                    0.0027301753464603253,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1907.764838287487`\
\[InvisibleSpace]"  "\[InvisibleSpace]875.4999959567604`\),
      SequenceForm[ "*BFGSUP ", 1907.764838287487, "  ", 875.49999595676036],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]21\),
      SequenceForm[ "MBFGS: Iteration = ", 21],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131619864835400\"\>",
            159.13161986483544,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131015352158200\"\>",
            159.13101535215816,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13161986483544, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13101535215816, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000604512677285\"\>",
            0.00060451267728467428,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00060451267728467428, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.593172376028726`\), \(-12.59811565372727`\), 
            "0.004943277698544486`", "0.004582106383772088`"},
          {"2", \(-3.1672104776509378`\), \(-3.168125309721635`\), 
            "0.0009148320706970599`", "0.010041822854957113`"},
          {"3", "0.4376282343126329`", 
            "0.43797400204452047`", \(-0.0003457677318875593`\), \
\(-0.012791326514545932`\)},
          {"4", "1.7165230496751285`", 
            "1.7171705326763191`", \(-0.000647483001190702`\), 
            "0.06094975167253408`"},
          {"5", \(-0.132483226177999`\), \(-0.1328504526388404`\), 
            "0.00036722646084141376`", "0.009561064175381384`"},
          {
            "6", \(-0.5600454487296395`\), \(-0.5597503901359693`\), \
\(-0.00029505859367019775`\), \(-0.006911348630525005`\)},
          {"7", \(-4.777447545607376`\), \(-4.780745400177761`\), 
            "0.003297854570385165`", "0.052264563356929916`"},
          {
            "8", \(-10.589239760929317`\), \(-9.857155689020257`\), \
\(-0.7320840719090601`\), \(-0.0009350792570713579`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7606\"\>",
                    0.76063633324166458,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1467\"\>",
                    -0.146706498022625,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09937\"\>",
                    0.099370636694648545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.39\"\>",
                    3.3899101349705685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1133\"\>",
                    0.11333542679988351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08508\"\>",
                    -0.085077557065513454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.089\"\>",
                    1.0887789097208656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006445\"\>",
                    0.0006444713602272497,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1467\"\>",
                    -0.14670649802262525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.31\"\>",
                    8.3104916367315305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3088\"\>",
                    -0.30877444139471766,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.63\"\>",
                    15.632511968927723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2537\"\>",
                    -0.25374516095804994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09499\"\>",
                    0.094986591747049542,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.584\"\>",
                    4.5839775907169802,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002482\"\>",
                    0.0024815890692878959,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09937\"\>",
                    0.099370636694648462,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3088\"\>",
                    -0.30877444139471844,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.8\"\>",
                    30.795988790328767,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.928\"\>",
                    -4.9281710130118901,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9386\"\>",
                    0.93861557537938189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3443\"\>",
                    -0.34432542282161815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.746\"\>",
                    -2.7456994984998992,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004188\"\>",
                    -0.0041879381603655147,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.39\"\>",
                    3.3899101349705685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.63\"\>",
                    15.632511968927723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.928\"\>",
                    -4.9281710130118901,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 70.43\"\>",
                    70.432311775681768,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.073\"\>",
                    2.0729937530855591,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.285\"\>",
                    -1.2854860300268474,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.26\"\>",
                    24.25782104169091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01004\"\>",
                    0.010037418963275924,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1133\"\>",
                    0.11333542679988351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2537\"\>",
                    -0.25374516095805033,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9386\"\>",
                    0.93861557537938156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.073\"\>",
                    2.0729937530855582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.14\"\>",
                    12.140526802914007,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.373\"\>",
                    -1.3728260471770213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.253\"\>",
                    1.2527571447996377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002602\"\>",
                    -0.0026020555262455704,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08508\"\>",
                    -0.08507755706551362,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09499\"\>",
                    0.094986591747050278,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3443\"\>",
                    -0.34432542282161882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.285\"\>",
                    -1.2854860300268469,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.373\"\>",
                    -1.3728260471770217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.64\"\>",
                    10.639527927118007,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.885\"\>",
                    -0.88498168314857206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001321\"\>",
                    0.0013210331219159158,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.089\"\>",
                    1.0887789097208656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.584\"\>",
                    4.5839775907169802,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.746\"\>",
                    -2.7456994984998984,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.26\"\>",
                    24.257821041690914,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.253\"\>",
                    1.252757144799638,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.885\"\>",
                    -0.8849816831485724,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.16\"\>",
                    19.161007082359756,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.008831\"\>",
                    0.0088314613394314123,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0006445\"\>",
                    0.00064447136022722021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002482\"\>",
                    0.0024815890692877537,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004188\"\>",
                    -0.0041879381603657229,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01004\"\>",
                    0.010037418963276173,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002602\"\>",
                    -0.0026020555262455392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001321\"\>",
                    0.0013210331219159974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.008831\"\>",
                    0.0088314613394313013,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001316\"\>",
                    0.0013157830872861283,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2143.8796191611123`\
\[InvisibleSpace]"  "\[InvisibleSpace]1163.7866913681403`\),
      SequenceForm[ "*BFGSUP ", 2143.8796191611123, "  ", 1163.7866913681403],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]22\),
      SequenceForm[ "MBFGS: Iteration = ", 22],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131853765952600\"\>",
            159.13185376595254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131619864835400\"\>",
            159.13161986483544,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13185376595254, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13161986483544, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000233901117099\"\>",
            0.00023390111709886696,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00023390111709886696, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.59047597483385`\), \(-12.593172376028726`\), 
            "0.002696401194875134`", "0.0018546405687500252`"},
          {"2", \(-3.166982172962391`\), \(-3.1672104776509378`\), 
            "0.00022830468854690973`", "0.0038516482712781953`"},
          {"3", "0.43740003570698344`", 
            "0.4376282343126329`", \(-0.00022819860564947183`\), \
\(-0.0045484804407620455`\)},
          {"4", "1.716395298089546`", 
            "1.7165230496751285`", \(-0.0001277515855823285`\), 
            "0.026565333602988753`"},
          {"5", \(-0.13198312836612`\), \(-0.132483226177999`\), 
            "0.000500097811878998`", "0.0057069570909036305`"},
          {
            "6", \(-0.5604167345507084`\), \(-0.5600454487296395`\), \
\(-0.0003712858210689838`\), \(-0.003911143862531219`\)},
          {"7", \(-4.775397252943928`\), \(-4.777447545607376`\), 
            "0.002050292663448059`", "0.019257322606259286`"},
          {
            "8", \(-11.239562095372408`\), \(-10.589239760929317`\), \
\(-0.6503223344430918`\), \(-0.0004493999578386814`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7522\"\>",
                    0.75215028834162057,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1641\"\>",
                    -0.16405929744372386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1194\"\>",
                    0.11938271818602933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.266\"\>",
                    3.2659478437140161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08489\"\>",
                    0.084886494583795324,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06577\"\>",
                    -0.065765410339526251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.003\"\>",
                    1.003078355954748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002791\"\>",
                    0.0027909288792436621,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1641\"\>",
                    -0.16405929744372411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.275\"\>",
                    8.2752872139225548,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2687\"\>",
                    -0.26867881568018992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.38\"\>",
                    15.376535508877984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3143\"\>",
                    -0.3143331047125521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1359\"\>",
                    0.13594065769865288,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.411\"\>",
                    4.4112244243229961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.006964\"\>",
                    0.0069639853188666247,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1194\"\>",
                    0.11938271818602925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2687\"\>",
                    -0.2686788156801907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.75\"\>",
                    30.751237153105684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.628\"\>",
                    -4.6284801981711619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.013\"\>",
                    1.0128366600809946,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3942\"\>",
                    -0.39419172648273382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.551\"\>",
                    -2.5509626360574185,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009525\"\>",
                    -0.0095251150050214371,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.266\"\>",
                    3.2659478437140161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.38\"\>",
                    15.376535508877984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.628\"\>",
                    -4.6284801981711619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 68.64\"\>",
                    68.643676504281956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.679\"\>",
                    1.6789130369511553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.016\"\>",
                    -1.0164099793298746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.98\"\>",
                    22.98372789955021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04056\"\>",
                    0.040562576545859166,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08489\"\>",
                    0.084886494583795324,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3143\"\>",
                    -0.31433310471255249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.013\"\>",
                    1.0128366600809944,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.679\"\>",
                    1.6789130369511545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.07\"\>",
                    12.065985957680796,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.321\"\>",
                    -1.3207131165761585,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9439\"\>",
                    0.94393759952009493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00379\"\>",
                    0.0037895654982935383,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06577\"\>",
                    -0.065765410339526417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1359\"\>",
                    0.13594065769865366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3942\"\>",
                    -0.39419172648273448,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.016\"\>",
                    -1.0164099793298742,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.321\"\>",
                    -1.320713116576159,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.6\"\>",
                    10.603235181590799,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6769\"\>",
                    -0.67690540470196092,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003076\"\>",
                    -0.0030761960483734613,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.003\"\>",
                    1.003078355954748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.411\"\>",
                    4.4112244243229961,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.551\"\>",
                    -2.550962636057418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.98\"\>",
                    22.983727899550214,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9439\"\>",
                    0.94393759952009515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6769\"\>",
                    -0.67690540470196137,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.32\"\>",
                    18.317734853766286,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03134\"\>",
                    0.031339081458129317,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.002791\"\>",
                    0.0027909288792436326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.006964\"\>",
                    0.0069639853188664834,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009525\"\>",
                    -0.009525115005021647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04056\"\>",
                    0.040562576545859416,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00379\"\>",
                    0.0037895654982935713,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003076\"\>",
                    -0.0030761960483733797,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03134\"\>",
                    0.031339081458129213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008039\"\>",
                    0.0008039068924586099,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5094.519723467327`\
\[InvisibleSpace]"  "\[InvisibleSpace]2944.913359833826`\),
      SequenceForm[ "*BFGSUP ", 5094.5197234673269, "  ", 2944.9133598338258],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]23\),
      SequenceForm[ "MBFGS: Iteration = ", 23],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131951352374900\"\>",
            159.13195135237493,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131853765952600\"\>",
            159.13185376595254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13195135237493, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13185376595254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000097586422385\"\>",
            9.7586422384665639*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 9.7586422384665639*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.589603528462368`\), \(-12.59047597483385`\), 
            "0.0008724463714839782`", \(-0.0004067132526185741`\)},
          {"2", \(-3.166926068746667`\), \(-3.166982172962391`\), 
            "0.000056104215723705504`", \(-0.0014095247019498955`\)},
          {"3", "0.43732387962312064`", 
            "0.43740003570698344`", \(-0.00007615608386282124`\), 
            "0.0015113456282710228`"},
          {"4", "1.7163015753890187`", 
            "1.716395298089546`", \(-0.00009372270052731637`\), \
\(-0.006514698720981454`\)},
          {"5", \(-0.13172812896463246`\), \(-0.13198312836612`\), 
            "0.00025499940148755474`", "0.0006290890097098156`"},
          {
            "6", \(-0.5605757287351483`\), \(-0.5604167345507084`\), \
\(-0.0001589941844398862`\), \(-0.00017635607991994817`\)},
          {"7", \(-4.774684514703201`\), \(-4.775397252943928`\), 
            "0.0007127382407275203`", \(-0.004227759704203915`\)},
          {
            "8", \(-11.821323974855346`\), \(-11.239562095372408`\), \
\(-0.5817618794829388`\), \(-0.00023449656586855834`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7681\"\>",
                    0.76807264751133952,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1245\"\>",
                    -0.12448465518217749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07441\"\>",
                    0.074413110769547916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.502\"\>",
                    3.5019533767271245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1122\"\>",
                    0.11221612701689715,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08743\"\>",
                    -0.087430363848350595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.168\"\>",
                    1.168459726971482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00277\"\>",
                    0.0027696446706890164,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1245\"\>",
                    -0.12448465518217774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.373\"\>",
                    8.372614857366818,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3795\"\>",
                    -0.37950887009287149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.96\"\>",
                    15.961860079057836,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.243\"\>",
                    -0.24296295174761906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0802\"\>",
                    0.080199789518051207,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.822\"\>",
                    4.8222672062238381,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.006301\"\>",
                    0.0063013381426490133,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07441\"\>",
                    0.074413110769547833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3795\"\>",
                    -0.37950887009287226,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.88\"\>",
                    30.877389164906056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.294\"\>",
                    -5.2938842840461655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9325\"\>",
                    0.93251721711085056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3313\"\>",
                    -0.33128102462491638,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.018\"\>",
                    -3.018042288014938,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00891\"\>",
                    -0.0089102971158425068,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.502\"\>",
                    3.5019533767271245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.96\"\>",
                    15.961860079057836,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.294\"\>",
                    -5.2938842840461655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 72.14\"\>",
                    72.140275774452817,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.088\"\>",
                    2.0882001625246995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.34\"\>",
                    -1.3398431249020879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.44\"\>",
                    25.435044951502647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0395\"\>",
                    0.039503308777304603,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1122\"\>",
                    0.11221612701689715,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.243\"\>",
                    -0.24296295174761945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9325\"\>",
                    0.93251721711085034,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.088\"\>",
                    2.0882001625246986,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.1\"\>",
                    12.101432904687526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.352\"\>",
                    -1.3515968422060045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.228\"\>",
                    1.2278321377049148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.005783\"\>",
                    0.0057830031517173289,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08743\"\>",
                    -0.087430363848350762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0802\"\>",
                    0.080199789518051956,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3313\"\>",
                    -0.33128102462491704,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.34\"\>",
                    -1.3398431249020875,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.352\"\>",
                    -1.351596842206005,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.63\"\>",
                    10.629248326016995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9019\"\>",
                    -0.90194943904211167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004163\"\>",
                    -0.0041634195922609502,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.168\"\>",
                    1.168459726971482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.822\"\>",
                    4.8222672062238381,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.018\"\>",
                    -3.0180422880149376,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.44\"\>",
                    25.435044951502647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.228\"\>",
                    1.2278321377049148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9019\"\>",
                    -0.90194943904211211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.04\"\>",
                    20.035507731194734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03111\"\>",
                    0.031112905812511926,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00277\"\>",
                    0.0027696446706889869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.006301\"\>",
                    0.006301338142648872,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00891\"\>",
                    -0.0089102971158427184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0395\"\>",
                    0.03950330877730486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.005783\"\>",
                    0.0057830031517173619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004163\"\>",
                    -0.0041634195922608686,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03111\"\>",
                    0.031112905812511821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004444\"\>",
                    0.00044443382974817592,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]15074.181401550275`\
\[InvisibleSpace]"  "\[InvisibleSpace]7481.787738558919`\),
      SequenceForm[ "*BFGSUP ", 15074.181401550275, "  ", 7481.787738558919],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]24\),
      SequenceForm[ "MBFGS: Iteration = ", 24],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132016794642300\"\>",
            159.13201679464228,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.131951352374900\"\>",
            159.13195135237493,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13201679464228, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13195135237493, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000065442267356\"\>",
            6.5442267356274897*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 6.5442267356274897*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.589907060779403`\), \(-12.589603528462368`\), \
\(-0.0003035323170349841`\), \(-0.0010077472876487156`\)},
          {
            "2", \(-3.1670002882855193`\), \(-3.166926068746667`\), \
\(-0.00007421953885200432`\), \(-0.0022976367560698105`\)},
          {"3", "0.4373625260862567`", "0.43732387962312064`", 
            "0.00003864646313608246`", "0.00356622756494257`"},
          {"4", "1.7163564673743326`", "1.7163015753890187`", 
            "0.000054891985313749794`", \(-0.01421452292429548`\)},
          {"5", \(-0.13171829877466618`\), \(-0.13172812896463246`\), 
            "9.830189966286232`*^-6", \(-0.0019447769514926438`\)},
          {
            "6", \(-0.5605773649861088`\), \(-0.5605757287351483`\), \
\(-1.6362509605369176`*^-6\), "0.001424145591126802`"},
          {
            "7", \(-4.774879927046837`\), \(-4.774684514703201`\), \
\(-0.00019541234363632868`\), \(-0.01157523840219471`\)},
          {
            "8", \(-12.48477306054076`\), \(-11.821323974855346`\), \
\(-0.6634490856854152`\), \(-0.0001310488802853661`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7723\"\>",
                    0.77228046868109401,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1207\"\>",
                    -0.12072737688359142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06039\"\>",
                    0.060394620436735179,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.552\"\>",
                    3.5518906719195633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1374\"\>",
                    0.13744988141516307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1025\"\>",
                    -0.10246770411480852,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.222\"\>",
                    1.2221637613386607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001119\"\>",
                    0.0011188391985596919,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1207\"\>",
                    -0.12072737688359167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.37\"\>",
                    8.3696399969895534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3911\"\>",
                    -0.3910804345778921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.\"\>",
                    15.996239475214354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2019\"\>",
                    -0.20187093644601603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05691\"\>",
                    0.056913164121472182,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.876\"\>",
                    4.8760470756081169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002443\"\>",
                    0.0024434802258377917,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06039\"\>",
                    0.060394620436735096,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3911\"\>",
                    -0.39108043457789288,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.92\"\>",
                    30.923950853189979,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.459\"\>",
                    -5.4587260507706441,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8457\"\>",
                    0.84567654605776532,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2797\"\>",
                    -0.27971026589303311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.198\"\>",
                    -3.1978296356739184,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003054\"\>",
                    -0.0030543507871645583,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.552\"\>",
                    3.5518906719195633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.\"\>",
                    15.996239475214354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.459\"\>",
                    -5.4587260507706441,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 72.72\"\>",
                    72.716446386705471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.418\"\>",
                    2.4176078447805178,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.534\"\>",
                    -1.5342069042852222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.08\"\>",
                    26.081788383777493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01607\"\>",
                    0.01606655006570424,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1374\"\>",
                    0.13744988141516307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2019\"\>",
                    -0.20187093644601642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8457\"\>",
                    0.8456765460577651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.418\"\>",
                    2.4176078447805169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.2\"\>",
                    12.198335190581249,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.413\"\>",
                    -1.4128645253435304,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.533\"\>",
                    1.5328052342965179,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002873\"\>",
                    0.0028730518606185623,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1025\"\>",
                    -0.10246770411480868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05691\"\>",
                    0.056913164121472931,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2797\"\>",
                    -0.27971026589303377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.534\"\>",
                    -1.5342069042852218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.413\"\>",
                    -1.4128645253435308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.67\"\>",
                    10.667629738922013,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.085\"\>",
                    -1.0847949200775682,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001977\"\>",
                    -0.0019770231541500639,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.222\"\>",
                    1.2221637613386607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.876\"\>",
                    4.8760470756081169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.198\"\>",
                    -3.197829635673918,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.08\"\>",
                    26.081788383777493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.533\"\>",
                    1.5328052342965179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.085\"\>",
                    -1.0847949200775686,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.72\"\>",
                    20.715564979512596,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01224\"\>",
                    0.012237919102585461,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.001119\"\>",
                    0.0011188391985596626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002443\"\>",
                    0.0024434802258376503,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003054\"\>",
                    -0.0030543507871647699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01607\"\>",
                    0.016066550065704496,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002873\"\>",
                    0.0028730518606185952,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001977\"\>",
                    -0.0019770231541499823,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01224\"\>",
                    0.012237919102585357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001943\"\>",
                    0.00019433570308710233,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]23515.017431185293`\
\[InvisibleSpace]"  "\[InvisibleSpace]11233.591131019477`\),
      SequenceForm[ "*BFGSUP ", 23515.017431185293, "  ", 11233.591131019477],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]25\),
      SequenceForm[ "MBFGS: Iteration = ", 25],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132055513039500\"\>",
            159.13205551303955,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132016794642300\"\>",
            159.13201679464228,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13205551303955, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13201679464228, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000038718397263\"\>",
            3.871839726343751*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.871839726343751*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.590695220049145`\), \(-12.589907060779403`\), \
\(-0.0007881592697416241`\), \(-0.0008980700374458313`\)},
          {
            "2", \(-3.1670945876984384`\), \(-3.1670002882855193`\), \
\(-0.00009429941291905221`\), \(-0.0020324973486180774`\)},
          {"3", "0.43742191496562177`", "0.4373625260862567`", 
            "0.000059388879365081045`", "0.002515195440514033`"},
          {"4", "1.716409791943325`", "1.7163564673743326`", 
            "0.000053324568992415595`", \(-0.012827547909654333`\)},
          {
            "5", \(-0.1318307771194307`\), \(-0.13171829877466618`\), \
\(-0.00011247834476453043`\), \(-0.0020287000475716077`\)},
          {"6", \(-0.5604907588899759`\), \(-0.5605773649861088`\), 
            "0.000086606096132824`", "0.0014470000754043255`"},
          {
            "7", \(-4.775447409125803`\), \(-4.774879927046837`\), \
\(-0.0005674820789662446`\), \(-0.009797740672808086`\)},
          {
            "8", \(-13.199131898367897`\), \(-12.48477306054076`\), \
\(-0.7143588378271356`\), \(-0.00006750164623139219`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7612\"\>",
                    0.76115500805871406,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1461\"\>",
                    -0.14605424068841483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09806\"\>",
                    0.098055853587467864,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.395\"\>",
                    3.3945505404793854,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1152\"\>",
                    0.11521735572589265,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08629\"\>",
                    -0.086286548496816828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.096\"\>",
                    1.0957091521350522,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002008\"\>",
                    -0.00020082322151630393,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1461\"\>",
                    -0.14605424068841508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.312\"\>",
                    8.3119894366470781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3056\"\>",
                    -0.30558649310491603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.64\"\>",
                    15.637999972702698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2526\"\>",
                    -0.25259025419901043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09381\"\>",
                    0.093813867830590564,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.588\"\>",
                    4.5883642000168292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005428\"\>",
                    -0.00054278305367878431,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09806\"\>",
                    0.098055853587467795,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3056\"\>",
                    -0.30558649310491681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.81\"\>",
                    30.807058576244295,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.924\"\>",
                    -4.9235494799285426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9257\"\>",
                    0.92566147282070843,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3373\"\>",
                    -0.33732858426102574,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.778\"\>",
                    -2.7780386574923437,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006251\"\>",
                    0.00062509712900097854,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.395\"\>",
                    3.3945505404793854,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.64\"\>",
                    15.637999972702698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.924\"\>",
                    -4.9235494799285426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 70.49\"\>",
                    70.491905227024802,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.104\"\>",
                    2.1043284614182536,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.306\"\>",
                    -1.3060537457303947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.29\"\>",
                    24.291425339981615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002787\"\>",
                    -0.0027867766877373232,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1152\"\>",
                    0.11521735572589263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2526\"\>",
                    -0.25259025419901082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9257\"\>",
                    0.92566147282070821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.104\"\>",
                    2.1043284614182527,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.16\"\>",
                    12.156013599148315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.382\"\>",
                    -1.381796562232682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.276\"\>",
                    1.2764151706228593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001154\"\>",
                    -0.00011535811652418774,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08629\"\>",
                    -0.086286548496816995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09381\"\>",
                    0.093813867830591313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3373\"\>",
                    -0.33732858426102641,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.306\"\>",
                    -1.3060537457303942,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.382\"\>",
                    -1.3817965622326824,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.64\"\>",
                    10.644858156797861,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8987\"\>",
                    -0.89865586989675339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001537\"\>",
                    0.0001536839047804185,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.096\"\>",
                    1.0957091521350522,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.588\"\>",
                    4.5883642000168292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.778\"\>",
                    -2.7780386574923428,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.29\"\>",
                    24.291425339981615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.276\"\>",
                    1.2764151706228593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8987\"\>",
                    -0.89865586989675383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.28\"\>",
                    19.284715074563692,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002146\"\>",
                    -0.0021464224739981119,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002008\"\>",
                    -0.00020082322151633342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005428\"\>",
                    -0.00054278305367892569,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006251\"\>",
                    0.0006250971290007656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002787\"\>",
                    -0.0027867766877370699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001154\"\>",
                    -0.00011535811652415521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001537\"\>",
                    0.00015368390478050047,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002146\"\>",
                    -0.0021464224739982211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00009637\"\>",
                    9.6371695968469097*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]34897.545491171295`\
\[InvisibleSpace]"  "\[InvisibleSpace]18349.034481987597`\),
      SequenceForm[ "*BFGSUP ", 34897.545491171295, "  ", 18349.034481987597],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]26\),
      SequenceForm[ "MBFGS: Iteration = ", 26],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132072158496600\"\>",
            159.13207215849664,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132055513039500\"\>",
            159.13205551303955,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13207215849664, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13205551303955, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000016645457094\"\>",
            1.6645457094455196*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.6645457094455196*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.591251115595645`\), \(-12.590695220049145`\), \
\(-0.0005558955464986412`\), \(-0.00029808133436772693`\)},
          {
            "2", \(-3.1671550075264023`\), \(-3.1670945876984384`\), \
\(-0.00006041982796375256`\), \(-0.0005902403260118526`\)},
          {"3", "0.437474185523253`", "0.43742191496562177`", 
            "0.000052270557631217724`", "0.0010155840742432434`"},
          {"4", "1.7164638956068161`", "1.716409791943325`", 
            "0.000054103663491153735`", \(-0.004157606592491661`\)},
          {
            "5", \(-0.13193275944822613`\), \(-0.1318307771194307`\), \
\(-0.00010198232879543378`\), \(-0.000879897232681337`\)},
          {"6", \(-0.5604204756218598`\), \(-0.5604907588899759`\), 
            "0.00007028326811605067`", "0.0005844605831279992`"},
          {
            "7", \(-4.775869725328145`\), \(-4.775447409125803`\), \
\(-0.00042231620234213643`\), \(-0.003452593665140835`\)},
          {
            "8", \(-13.865345700752236`\), \(-13.199131898367897`\), \
\(-0.6662138023843395`\), \(-0.00003304416448540818`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7589\"\>",
                    0.7589186083911178,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1493\"\>",
                    -0.14934902205760497,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1081\"\>",
                    0.10810398785364775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.365\"\>",
                    3.3647013796828147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1058\"\>",
                    0.10584076576199702,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0805\"\>",
                    -0.080501808844882922,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.067\"\>",
                    1.0671104780553307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005917\"\>",
                    -0.00059168848228681817,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1493\"\>",
                    -0.14934902205760525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.309\"\>",
                    8.3087793108373287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2873\"\>",
                    -0.28726116365129983,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6\"\>",
                    15.595973543584121,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2704\"\>",
                    -0.27042867332112336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1044\"\>",
                    0.10436614163728158,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.542\"\>",
                    4.5423227474151622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001326\"\>",
                    -0.0013259265734794782,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1081\"\>",
                    0.10810398785364769,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2873\"\>",
                    -0.28726116365130061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.77\"\>",
                    30.769457561140282,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.785\"\>",
                    -4.7852620068062528,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9592\"\>",
                    0.95916881889738959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.359\"\>",
                    -0.3589706062439289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.658\"\>",
                    -2.6579181608609668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001937\"\>",
                    0.0019371381556865849,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.365\"\>",
                    3.3647013796828147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6\"\>",
                    15.595973543584121,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.785\"\>",
                    -4.7852620068062528,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 70.1\"\>",
                    70.095819864547053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.974\"\>",
                    1.9744084061973053,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.226\"\>",
                    -1.2264384903716916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.91\"\>",
                    23.90508615391143,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008249\"\>",
                    -0.0082494053345002743,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1058\"\>",
                    0.10584076576199701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2704\"\>",
                    -0.27042867332112375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9592\"\>",
                    0.95916881889738936,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.974\"\>",
                    1.9744084061973044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.13\"\>",
                    12.126551837242795,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.363\"\>",
                    -1.3625119891150563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.166\"\>",
                    1.1660768115651481,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001247\"\>",
                    -0.001246671603749116,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0805\"\>",
                    -0.080501808844883088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1044\"\>",
                    0.10436614163728233,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.359\"\>",
                    -0.35897060624392957,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.226\"\>",
                    -1.2264384903716912,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.363\"\>",
                    -1.3625119891150568,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.63\"\>",
                    10.63240165887556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8295\"\>",
                    -0.82950769385846723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009087\"\>",
                    0.00090873596362134432,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.067\"\>",
                    1.0671104780553307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.542\"\>",
                    4.5423227474151622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.658\"\>",
                    -2.6579181608609659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.91\"\>",
                    23.90508615391143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.166\"\>",
                    1.1660768115651481,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8295\"\>",
                    -0.82950769385846757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.93\"\>",
                    18.928292515557466,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006652\"\>",
                    -0.0066518843052716945,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0005917\"\>",
                    -0.00059168848228684798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001326\"\>",
                    -0.0013259265734796198,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001937\"\>",
                    0.0019371381556863726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008249\"\>",
                    -0.0082494053345000228,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001247\"\>",
                    -0.0012466716037490837,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009087\"\>",
                    0.00090873596362142628,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006652\"\>",
                    -0.0066518843052718038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000542\"\>",
                    5.4199315250206698*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]78150.50533879976`\
\[InvisibleSpace]"  "\[InvisibleSpace]42313.92123636364`\),
      SequenceForm[ "*BFGSUP ", 78150.505338799761, "  ", 42313.92123636364],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]27\),
      SequenceForm[ "MBFGS: Iteration = ", 27],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132079862851800\"\>",
            159.13207986285178,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132072158496600\"\>",
            159.13207215849664,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13207986285178, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13207215849664, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.704355141413544"\[Times]10\^"-6"\),
            7.7043551414135436*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 7.7043551414135436*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.591423615429166`\), \(-12.591251115595645`\), \
\(-0.00017249983352069474`\), "0.0000823611568426576`"},
          {
            "2", \(-3.1671712394113865`\), \(-3.1671550075264023`\), \
\(-0.000016231884984119835`\), "0.00017612839167247072`"},
          {"3", "0.4374848326217104`", "0.437474185523253`", 
            "0.000010647098457372948`", \(-0.00038708314353664425`\)},
          {"4", "1.7164719510093707`", "1.7164638956068161`", 
            "8.055402554568523`*^-6", "0.0011045077034698148`"},
          {
            "5", \(-0.13196441658356142`\), \(-0.13193275944822613`\), \
\(-0.000031657135335281764`\), "0.00015759965909212248`"},
          {"6", \(-0.5603971298966961`\), \(-0.5604204756218598`\), 
            "0.000023345725163761427`", \(-0.00011672975244714223`\)},
          {
            "7", \(-4.775996049617948`\), \(-4.775869725328145`\), \
\(-0.00012632428980308957`\), "0.001015952084964633`"},
          {
            "8", \(-14.498306244002672`\), \(-13.865345700752236`\), \
\(-0.6329605432504355`\), \(-0.000016972467572299244`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7665\"\>",
                    0.76647014123597534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.134\"\>",
                    -0.13400821674600025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07921\"\>",
                    0.079209756502296058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.469\"\>",
                    3.4687135163076421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1256\"\>",
                    0.12558925268586449,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09398\"\>",
                    -0.093977645138792393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.156\"\>",
                    1.1564207359382861,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005306\"\>",
                    -0.00053063415856344285,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.134\"\>",
                    -0.13400821674600052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.34\"\>",
                    8.3399372666711677,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3459\"\>",
                    -0.34590525163705732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.81\"\>",
                    15.8072948170758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2303\"\>",
                    -0.23026657316279547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07697\"\>",
                    0.07696750485937591,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.724\"\>",
                    4.7237234998123929,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001189\"\>",
                    -0.0011886495064812677,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07921\"\>",
                    0.079209756502296003,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3459\"\>",
                    -0.34590525163705815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.88\"\>",
                    30.879573707621542,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.183\"\>",
                    -5.1834242525820464,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8833\"\>",
                    0.88325141645881367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3072\"\>",
                    -0.30722294234442882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.999\"\>",
                    -2.9993868590947588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001595\"\>",
                    0.0015953906356312646,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.469\"\>",
                    3.4687135163076421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.81\"\>",
                    15.8072948170758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.183\"\>",
                    -5.1834242525820464,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.53\"\>",
                    71.528369955445513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.246\"\>",
                    2.246269800749765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.412\"\>",
                    -1.4119728077935367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.14\"\>",
                    25.13532072686467,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007453\"\>",
                    -0.0074534133281098916,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1256\"\>",
                    0.12558925268586446,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2303\"\>",
                    -0.23026657316279586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8833\"\>",
                    0.88325141645881344,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.246\"\>",
                    2.2462698007497641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.18\"\>",
                    12.177912777880691,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.398\"\>",
                    -1.3976045577974119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4\"\>",
                    1.3998439215060183,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001174\"\>",
                    -0.0011738609513710615,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09398\"\>",
                    -0.093977645138792559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07697\"\>",
                    0.076967504859376673,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3072\"\>",
                    -0.30722294234442948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.412\"\>",
                    -1.4119728077935363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.398\"\>",
                    -1.3976045577974123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.66\"\>",
                    10.656371563739468,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.989\"\>",
                    -0.98899128844686468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008452\"\>",
                    0.00084524227752324533,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.156\"\>",
                    1.1564207359382861,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.724\"\>",
                    4.7237234998123929,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.999\"\>",
                    -2.9993868590947579,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.14\"\>",
                    25.13532072686467,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4\"\>",
                    1.3998439215060183,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.989\"\>",
                    -0.98899128844686501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.98\"\>",
                    19.984395084353167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005867\"\>",
                    -0.0058668543709427959,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0005306\"\>",
                    -0.00053063415856347267,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001189\"\>",
                    -0.0011886495064814093,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001595\"\>",
                    0.0015953906356310525,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007453\"\>",
                    -0.00745341332810964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001174\"\>",
                    -0.0011738609513710291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008452\"\>",
                    0.0008452422775233273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005867\"\>",
                    -0.0058668543709429052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00002818\"\>",
                    2.818226539665898*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]190324.9706629207`\
\[InvisibleSpace]"  "\[InvisibleSpace]94388.07814166465`\),
      SequenceForm[ "*BFGSUP ", 190324.97066292071, "  ", 94388.07814166465],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]28\),
      SequenceForm[ "MBFGS: Iteration = ", 28],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132084441982700\"\>",
            159.1320844419827,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132079862851800\"\>",
            159.13207986285178,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.1320844419827, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13207986285178, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     4.579130916226859"\[Times]10\^"-6"\),
            4.579130916226859*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 4.579130916226859*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.59135167499975`\), \(-12.591423615429166`\), 
            "0.00007194042941576203`", "0.0002265754348568912`"},
          {"2", \(-3.1671621427285435`\), \(-3.1671712394113865`\), 
            "9.096682843074304`*^-6", "0.0005188747137729213`"},
          {"3", "0.43748091556021146`", 
            "0.4374848326217104`", \(-3.9170614989556616`*^-6\), \
\(-0.0006431144281313084`\)},
          {"4", "1.716468988028942`", 
            "1.7164719510093707`", \(-2.9629804285596884`*^-6\), 
            "0.003201941769740743`"},
          {"5", \(-0.13195600623222753`\), \(-0.13196441658356142`\), 
            "8.41035133389244`*^-6", "0.00047874419868931817`"},
          {
            "6", \(-0.5604043433472677`\), \(-0.5603971298966961`\), \
\(-7.213450571661931`*^-6\), \(-0.0003493735656530106`\)},
          {"7", \(-4.775946886255078`\), \(-4.775996049617948`\), 
            "0.0000491633628706446`", "0.0024701108309945763`"},
          {
            "8", \(-15.179748268613361`\), \(-14.498306244002672`\), \
\(-0.6814420246106895`\), \(-9.012086212776643`*^-6\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7698\"\>",
                    0.76978820558546501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.126\"\>",
                    -0.12596986675200322,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07519\"\>",
                    0.075191467815122856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.518\"\>",
                    3.5176966570028951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1332\"\>",
                    0.1331787267883752,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09946\"\>",
                    -0.099455707659488024,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.188\"\>",
                    1.1884359504804354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001802\"\>",
                    -0.00018019851085622615,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.126\"\>",
                    -0.1259698667520035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.359\"\>",
                    8.3593676680359028,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3562\"\>",
                    -0.35617195455119233,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.93\"\>",
                    15.925755318423271,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2119\"\>",
                    -0.21193729540448866,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06373\"\>",
                    0.063731972733595973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.802\"\>",
                    4.801693289856285,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003872\"\>",
                    -0.00038721105086280717,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07519\"\>",
                    0.075191467815122801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3562\"\>",
                    -0.35617195455119316,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.88\"\>",
                    30.877907410762969,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.245\"\>",
                    -5.2452760939456944,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8734\"\>",
                    0.87336038357037105,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3002\"\>",
                    -0.30015125003922044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.033\"\>",
                    -3.0331279140796141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005874\"\>",
                    0.0005873813920659241,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.518\"\>",
                    3.5176966570028951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.93\"\>",
                    15.925755318423272,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.245\"\>",
                    -5.2452760939456944,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 72.25\"\>",
                    72.250505677784645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.358\"\>",
                    2.3580386625551002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.493\"\>",
                    -1.4926734879988581,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.61\"\>",
                    25.609896883568769,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002506\"\>",
                    -0.0025062564480434315,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1332\"\>",
                    0.13317872678837517,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2119\"\>",
                    -0.21193729540448905,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8734\"\>",
                    0.87336038357037082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.358\"\>",
                    2.3580386625550993,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.2\"\>",
                    12.195197339965148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.41\"\>",
                    -1.4100877554431257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.474\"\>",
                    1.4736119333766307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004348\"\>",
                    -0.00043483348185268116,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09946\"\>",
                    -0.099455707659488191,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06373\"\>",
                    0.063731972733596737,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3002\"\>",
                    -0.30015125003922111,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.493\"\>",
                    -1.4926734879988577,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.41\"\>",
                    -1.4100877554431261,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.67\"\>",
                    10.665386433110994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.042\"\>",
                    -1.0421847677140399,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003058\"\>",
                    0.00030577219393456432,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.188\"\>",
                    1.1884359504804354,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.802\"\>",
                    4.801693289856285,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.033\"\>",
                    -3.0331279140796132,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.61\"\>",
                    25.609896883568769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.474\"\>",
                    1.4736119333766307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.042\"\>",
                    -1.0421847677140401,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.29\"\>",
                    20.28942854493398,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002036\"\>",
                    -0.0020361637550726035,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001802\"\>",
                    -0.00018019851085625596,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003872\"\>",
                    -0.00038721105086294877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005874\"\>",
                    0.00058738139206571203,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002506\"\>",
                    -0.0025062564480431791,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004348\"\>",
                    -0.00043483348185264885,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003058\"\>",
                    0.00030577219393464628,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002036\"\>",
                    -0.0020361637550727128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00001305\"\>",
                    1.3052846382253322*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]325614.774593686`\
\[InvisibleSpace]"  "\[InvisibleSpace]159153.26322094983`\),
      SequenceForm[ "*BFGSUP ", 325614.77459368599, "  ", 159153.26322094983],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]29\),
      SequenceForm[ "MBFGS: Iteration = ", 29],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132086912124300\"\>",
            159.13208691212427,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132084441982700\"\>",
            159.1320844419827,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13208691212427, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.1320844419827, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.470141566845996"\[Times]10\^"-6"\),
            2.4701415668459958*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.4701415668459958*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.591187571254373`\), \(-12.59135167499975`\), 
            "0.000164103745377314`", "0.00016661958480891978`"},
          {"2", \(-3.1671428330502156`\), \(-3.1671621427285435`\), 
            "0.00001930967832781927`", "0.000360353537204905`"},
          {"3", "0.43746539227431164`", 
            "0.43748091556021146`", \(-0.000015523285899842145`\), \
\(-0.0005553301784948991`\)},
          {"4", "1.7164528415914275`", 
            "1.716468988028942`", \(-0.00001614643751457681`\), 
            "0.0023247072157807497`"},
          {"5", \(-0.1319289154255947`\), \(-0.13195600623222753`\), 
            "0.000027090806632818306`", "0.0003925924124137392`"},
          {
            "6", \(-0.5604234573699564`\), \(-0.5604043433472677`\), \
\(-0.000019114022688591525`\), \(-0.0002767839835451369`\)},
          {"7", \(-4.77582384860168`\), \(-4.775946886255078`\), 
            "0.00012303765339752488`", "0.0018922607205723585`"},
          {
            "8", \(-15.883456169351103`\), \(-15.179748268613361`\), \
\(-0.7037079007377425`\), \(-4.553957027428538`*^-6\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7628\"\>",
                    0.76278833431602311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1416\"\>",
                    -0.14158587164163833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09667\"\>",
                    0.096668546521049448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.419\"\>",
                    3.4193597538024649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1176\"\>",
                    0.1175970049052491,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08827\"\>",
                    -0.088274350967706083,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.111\"\>",
                    1.1106442958324714,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00005775\"\>",
                    5.7745424769533183*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1416\"\>",
                    -0.14158587164163861,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.325\"\>",
                    8.3247010425841417,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3076\"\>",
                    -0.30759432201958203,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.71\"\>",
                    15.706617106563467,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.247\"\>",
                    -0.24702539772112389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08884\"\>",
                    0.088836608131473094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.628\"\>",
                    4.6275368407954218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001269\"\>",
                    0.00012689794271331274,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09667\"\>",
                    0.096668546521049392,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3076\"\>",
                    -0.30759432201958281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.81\"\>",
                    30.814591442728688,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.943\"\>",
                    -4.9426200546830783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9199\"\>",
                    0.91989910269760078,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3338\"\>",
                    -0.33383605845091413,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.797\"\>",
                    -2.7968199633559787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002076\"\>",
                    -0.00020760902607555511,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.419\"\>",
                    3.4193597538024649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.71\"\>",
                    15.706617106563469,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.943\"\>",
                    -4.9426200546830783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 70.87\"\>",
                    70.869371557069528,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.139\"\>",
                    2.1386793092547771,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.335\"\>",
                    -1.3353674269814928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.52\"\>",
                    24.516187098045332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008129\"\>",
                    0.00081287562116082353,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1176\"\>",
                    0.11759700490524908,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.247\"\>",
                    -0.24702539772112428,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9199\"\>",
                    0.91989910269760056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.139\"\>",
                    2.1386793092547762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.16\"\>",
                    12.161136802687587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.386\"\>",
                    -1.3855039946130934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.302\"\>",
                    1.3016150675797307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001268\"\>",
                    0.00012676997197297627,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08827\"\>",
                    -0.08827435096770625,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08884\"\>",
                    0.088836608131473857,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3338\"\>",
                    -0.3338360584509148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.335\"\>",
                    -1.3353674269814924,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.386\"\>",
                    -1.3855039946130938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.65\"\>",
                    10.647675630075259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9185\"\>",
                    -0.91849506985769147,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00008996\"\>",
                    -8.9961921433727823*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.111\"\>",
                    1.1106442958324714,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.628\"\>",
                    4.6275368407954218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.797\"\>",
                    -2.7968199633559774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.52\"\>",
                    24.516187098045332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.302\"\>",
                    1.3016150675797307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9185\"\>",
                    -0.91849506985769169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.43\"\>",
                    19.427089535802025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006679\"\>",
                    0.00066789731204613565,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00005775\"\>",
                    5.7745424769503341*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001269\"\>",
                    0.00012689794271317115,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002076\"\>",
                    -0.00020760902607576729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008129\"\>",
                    0.00081287562116107506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001268\"\>",
                    0.00012676997197300858,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00008996\"\>",
                    -8.9961921433645857*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006679\"\>",
                    0.0006678973120460255,
                    AutoDelete->True], 
                  InterpretationBox[\(" 6.598"\[Times]10\^"-6"\),
                    6.5983509682505594*^-06,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]548641.79474846`\
\[InvisibleSpace]"  "\[InvisibleSpace]289118.701619607`\),
      SequenceForm[ "*BFGSUP ", 548641.79474845994, "  ", 289118.70161960699],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]30\),
      SequenceForm[ "MBFGS: Iteration = ", 30],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132088003848700\"\>",
            159.13208800384868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132086912124300\"\>",
            159.13208691212427,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13208800384868, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13208691212427, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.091724413981865"\[Times]10\^"-6"\),
            1.0917244139818649*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0917244139818649*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.59107962942384`\), \(-12.591187571254373`\), 
            "0.00010794183053407885`", "0.000055584615673277295`"},
          {"2", \(-3.1671302965781623`\), \(-3.1671428330502156`\), 
            "0.000012536472053518473`", "0.0001295692182456832`"},
          {"3", "0.43745737088420505`", 
            "0.43746539227431164`", \(-8.02139010656181`*^-6\), \
\(-0.0001393443875381331`\)},
          {"4", "1.7164453927269927`", 
            "1.7164528415914275`", \(-7.448864434735033`*^-6\), 
            "0.0007907050161997109`"},
          {"5", \(-0.13191243035123829`\), \(-0.1319289154255947`\), 
            "0.00001648507435640732`", "0.0001163084011355231`"},
          {
            "6", \(-0.5604358478945245`\), \(-0.5604234573699564`\), \
\(-0.000012390524568087974`\), \(-0.00008540835050574458`\)},
          {"7", \(-4.775745794790506`\), \(-4.77582384860168`\), 
            "0.00007805381117421179`", "0.0005908115304850692`"},
          {
            "8", \(-16.533227473682114`\), \(-15.883456169351103`\), \
\(-0.6497713043310129`\), \(-2.213431255151986`*^-6\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7615\"\>",
                    0.76152587145684869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1449\"\>",
                    -0.144886107053742,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09808\"\>",
                    0.098079178157739991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.401\"\>",
                    3.4008210071986329,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1155\"\>",
                    0.11551550096214279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0866\"\>",
                    -0.086599183060259516,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.099\"\>",
                    1.098770961188114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001345\"\>",
                    0.00013454131589622916,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1449\"\>",
                    -0.14488610705374227,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.316\"\>",
                    8.3163790595978746,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3024\"\>",
                    -0.30240853374541082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.66\"\>",
                    15.658649781277299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2529\"\>",
                    -0.25294510966948014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09344\"\>",
                    0.093441747573037137,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.595\"\>",
                    4.595178551567991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.000305\"\>",
                    0.00030499920144369633,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09808\"\>",
                    0.098079178157739921,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3024\"\>",
                    -0.3024085337454116,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.82\"\>",
                    30.820368930221086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.919\"\>",
                    -4.9194745850418595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9199\"\>",
                    0.91987677982009797,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3346\"\>",
                    -0.33459835872541277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.79\"\>",
                    -2.7900316002061403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004046\"\>",
                    -0.00040460407739088984,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.401\"\>",
                    3.4008210071986329,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.66\"\>",
                    15.658649781277301,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.919\"\>",
                    -4.9194745850418595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 70.6\"\>",
                    70.597941304095201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.107\"\>",
                    2.1073370567264162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.31\"\>",
                    -1.3104015151681945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.34\"\>",
                    24.339690463549374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001904\"\>",
                    0.0019038365500480409,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1155\"\>",
                    0.11551550096214276,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2529\"\>",
                    -0.25294510966948053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9199\"\>",
                    0.91987677982009775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.107\"\>",
                    2.1073370567264154,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.16\"\>",
                    12.158454677992825,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.383\"\>",
                    -1.383096306143583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.284\"\>",
                    1.2841073966863996,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002889\"\>",
                    0.00028889141278538009,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0866\"\>",
                    -0.086599183060259682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09344\"\>",
                    0.0934417475730379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3346\"\>",
                    -0.33459835872541344,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.31\"\>",
                    -1.310401515168194,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.383\"\>",
                    -1.3830963061435835,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.65\"\>",
                    10.645620231801331,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9037\"\>",
                    -0.9037177163546174,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002086\"\>",
                    -0.00020863775043708711,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.099\"\>",
                    1.098770961188114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.595\"\>",
                    4.595178551567991,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.79\"\>",
                    -2.7900316002061389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.34\"\>",
                    24.339690463549374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.284\"\>",
                    1.2841073966863996,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9037\"\>",
                    -0.90371771635461762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.32\"\>",
                    19.321129482974083,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001488\"\>",
                    0.0014881081258883806,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001345\"\>",
                    0.00013454131589619932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.000305\"\>",
                    0.00030499920144355473,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004046\"\>",
                    -0.00040460407739110202,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001904\"\>",
                    0.0019038365500482928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002889\"\>",
                    0.00028889141278541235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002086\"\>",
                    -0.00020863775043700509,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001488\"\>",
                    0.00148810812588827,
                    AutoDelete->True], 
                  InterpretationBox[\(" 3.608"\[Times]10\^"-6"\),
                    3.6079488189858799*^-06,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.3017273480968722`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]671065.7534261844`\),
      SequenceForm[ "*BFGSUP ", 1301727.3480968722, "  ", 671065.75342618441],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]31\),
      SequenceForm[ "MBFGS: Iteration = ", 31],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132088560180900\"\>",
            159.13208856018093,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132088003848700\"\>",
            159.13208800384868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13208856018093, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13208800384868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.563322531543236"\[Times]10\^"-7"\),
            5.5633225315432355*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.5633225315432355*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.591046904203695`\), \(-12.59107962942384`\), 
            "0.0000327252201448072`", \(-0.00002648129035326348`\)},
          {"2", \(-3.167126315449957`\), \(-3.1671302965781623`\), 
            "3.981128205106882`*^-6", \(-0.00006339026551724705`\)},
          {"3", "0.4374539004383249`", 
            "0.43745737088420505`", \(-3.47044588019407`*^-6\), 
            "0.00006307062274866354`"},
          {"4", "1.7164416288019069`", 
            "1.7164453927269927`", \(-3.7639250859070994`*^-6\), \
\(-0.00038081557812445765`\)},
          {"5", \(-0.1319070188500525`\), \(-0.13191243035123829`\), 
            "5.411501185791353`*^-6", \(-0.000051781284353236146`\)},
          {
            "6", \(-0.5604395734697705`\), \(-0.5604358478945245`\), \
\(-3.7255752459981316`*^-6\), "0.00003860704157609973`"},
          {"7", \(-4.775720877542827`\), \(-4.775745794790506`\), 
            "0.000024917247679495374`", \(-0.00027849137539032176`\)},
          {
            "8", \(-17.189856740442305`\), \(-16.533227473682114`\), \
\(-0.656629266760193`\), \(-1.1486327593083925`*^-6\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7682\"\>",
                    0.76821940366545804,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1291\"\>",
                    -0.12910579309323822,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08165\"\>",
                    0.081653377484506101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.496\"\>",
                    3.4964775123895389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1291\"\>",
                    0.12913367902065404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09666\"\>",
                    -0.096661618126207105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.17\"\>",
                    1.1695985394628303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001034\"\>",
                    0.00010335467334834074,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1291\"\>",
                    -0.1291057930932385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.354\"\>",
                    8.3535807714467065,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3411\"\>",
                    -0.34113534502964121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.88\"\>",
                    15.884161692341262,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2208\"\>",
                    -0.22083718864140012,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06972\"\>",
                    0.069717692769472178,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.762\"\>",
                    4.7621598627603108,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00023\"\>",
                    0.00022999910047536866,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08165\"\>",
                    0.081653377484506032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3411\"\>",
                    -0.34113534502964199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.86\"\>",
                    30.860673101480913,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.154\"\>",
                    -5.1542193257882065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8865\"\>",
                    0.88646288164235953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3099\"\>",
                    -0.30990811840670912,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.964\"\>",
                    -2.9638371469426028,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.000331\"\>",
                    -0.0003310175105963133,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.496\"\>",
                    3.4964775123895389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.88\"\>",
                    15.884161692341264,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.154\"\>",
                    -5.1542193257882065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.96\"\>",
                    71.964950687352214,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.302\"\>",
                    2.3019589047941595,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.454\"\>",
                    -1.4542060804549861,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.35\"\>",
                    25.351884245498706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001454\"\>",
                    0.001454498374282613,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1291\"\>",
                    0.12913367902065401,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2208\"\>",
                    -0.22083718864140051,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8865\"\>",
                    0.88646288164235931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.302\"\>",
                    2.3019589047941587,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.19\"\>",
                    12.186155929079719,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.404\"\>",
                    -1.4035655629570956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.428\"\>",
                    1.4282037204347879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002287\"\>",
                    0.00022866571558782518,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09666\"\>",
                    -0.096661618126207272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06972\"\>",
                    0.069717692769472941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3099\"\>",
                    -0.30990811840670979,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.454\"\>",
                    -1.4542060804549857,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.404\"\>",
                    -1.403565562957096,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.66\"\>",
                    10.660745413739376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.01\"\>",
                    -1.0101908215730835,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001636\"\>",
                    -0.00016360479711332148,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.17\"\>",
                    1.1695985394628303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.762\"\>",
                    4.7621598627603108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.964\"\>",
                    -2.9638371469426015,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.35\"\>",
                    25.351884245498706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.428\"\>",
                    1.4282037204347882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.01\"\>",
                    -1.0101908215730837,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.07\"\>",
                    20.070587575931647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001161\"\>",
                    0.0011607536637226962,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001034\"\>",
                    0.00010335467334831089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00023\"\>",
                    0.00022999910047522706,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.000331\"\>",
                    -0.00033101751059652547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001454\"\>",
                    0.0014544983742828649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002287\"\>",
                    0.00022866571558785746,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001636\"\>",
                    -0.00016360479711323946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001161\"\>",
                    0.0011607536637225856,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.796"\[Times]10\^"-6"\),
                    1.7961042373522322*^-06,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.6337249500529957`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]1.338763165166153`*^6\),
      SequenceForm[ "*BFGSUP ", 2633724.9500529957, "  ", 1338763.1651661531],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]32\),
      SequenceForm[ "MBFGS: Iteration = ", 32],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132088861219800\"\>",
            159.13208886121981,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132088560180900\"\>",
            159.13208856018093,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13208886121981, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13208856018093, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.010388809343567"\[Times]10\^"-7"\),
            3.0103888093435671*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.0103888093435671*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.591067430821209`\), \(-12.591046904203695`\), \
\(-0.00002052661751267631`\), \(-0.00004701907719753659`\)},
          {
            "2", \(-3.167128758643671`\), \(-3.167126315449957`\), \
\(-2.44319371401477`*^-6\), \(-0.00010288400301899491`\)},
          {"3", "0.43745608988604756`", "0.4374539004383249`", 
            "2.1894477226835423`*^-6", "0.00015811415163666243`"},
          {"4", "1.71644400062693`", "1.7164416288019069`", 
            "2.3718250229967734`*^-6", \(-0.0006587431283879286`\)},
          {
            "5", \(-0.13191052313471677`\), \(-0.1319070188500525`\), \
\(-3.5042846642680744`*^-6\), \(-0.00010702982921295678`\)},
          {"6", \(-0.560437178519597`\), \(-0.5604395734697705`\), 
            "2.3949501734591515`*^-6", "0.00007592073845508196`"},
          {
            "7", \(-4.775736590076956`\), \(-4.775720877542827`\), \
\(-0.000015712534129440446`\), \(-0.0005347521906640118`\)},
          {
            "8", \(-17.84453100834813`\), \(-17.189856740442305`\), \
\(-0.6546742679058242`\), \(-5.809547655751273`*^-7\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7684\"\>",
                    0.76839149129388551,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1292\"\>",
                    -0.1292168648684538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07875\"\>",
                    0.078748380037523616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.498\"\>",
                    3.4980101176788603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1303\"\>",
                    0.1302863623098158,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09731\"\>",
                    -0.097311245250980241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.174\"\>",
                    1.1735867876082011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00003193\"\>",
                    3.1926939338085768*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1292\"\>",
                    -0.12921686486845407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.352\"\>",
                    8.352309151384917,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3457\"\>",
                    -0.34566889851288696,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.88\"\>",
                    15.880752761239624,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2195\"\>",
                    -0.21948487131243755,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06911\"\>",
                    0.069112853946466643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.765\"\>",
                    4.7651809499877888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00007347\"\>",
                    7.3473504494070142*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07875\"\>",
                    0.078748380037523547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3457\"\>",
                    -0.34566889851288773,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.88\"\>",
                    30.879138785719245,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.192\"\>",
                    -5.1916349542449618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.877\"\>",
                    0.87700538499572622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3038\"\>",
                    -0.30382765762687186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.004\"\>",
                    -3.0044691009993261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00009193\"\>",
                    -9.1930523800871271*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.498\"\>",
                    3.4980101176788603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.88\"\>",
                    15.880752761239625,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.192\"\>",
                    -5.1916349542449618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.97\"\>",
                    71.974241298692078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.316\"\>",
                    2.3160007644701417,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.462\"\>",
                    -1.4618364224634584,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.4\"\>",
                    25.397482254071946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004534\"\>",
                    0.00045336865522178785,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1303\"\>",
                    0.13028636230981577,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2195\"\>",
                    -0.21948487131243793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.877\"\>",
                    0.877005384995726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.316\"\>",
                    2.3160007644701408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.19\"\>",
                    12.190605488057164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.406\"\>",
                    -1.4063187080917199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.446\"\>",
                    1.4461862729949679,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00006644\"\>",
                    6.6436664491750102*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09731\"\>",
                    -0.097311245250980408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06911\"\>",
                    0.069112853946467406,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3038\"\>",
                    -0.30382765762687253,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.462\"\>",
                    -1.4618364224634579,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.406\"\>",
                    -1.4063187080917203,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.66\"\>",
                    10.662416949129041,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.021\"\>",
                    -1.0209805830827285,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00004845\"\>",
                    -4.8448930571972108*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.174\"\>",
                    1.1735867876082011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.765\"\>",
                    4.7651809499877888,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.004\"\>",
                    -3.0044691009993247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.4\"\>",
                    25.397482254071946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.446\"\>",
                    1.4461862729949682,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.021\"\>",
                    -1.0209805830827288,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.14\"\>",
                    20.139712202139126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003494\"\>",
                    0.0003493668060449292,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00003193\"\>",
                    3.1926939338055926*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00007347\"\>",
                    7.3473504493928545*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00009193\"\>",
                    -9.1930523801083449*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004534\"\>",
                    0.00045336865522203982,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00006644\"\>",
                    6.6436664491782384*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00004845\"\>",
                    -4.8448930571890088*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003494\"\>",
                    0.00034936680604481861,
                    AutoDelete->True], 
                  InterpretationBox[\(" 8.785"\[Times]10\^"-7"\),
                    8.7853713230659369*^-07,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.257656682052225`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]2.56874207680945`*^6\),
      SequenceForm[ "*BFGSUP ", 6257656.6820522249, "  ", 2568742.0768094501],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]33\),
      SequenceForm[ "MBFGS: Iteration = ", 33],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132088861219800\"\>",
            159.13208886121981,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13208906091145, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13208886121981, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.996916410007543"\[Times]10\^"-7"\),
            1.9969164100075432*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.9969164100075432*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-12.59110642499198`\), \(-12.591067430821209`\), \
\(-0.00003899417076998661`\), \(-0.000034144917579900086`\)},
          {
            "2", \(-3.1671334282469625`\), \(-3.167128758643671`\), \
\(-4.669603291454373`*^-6\), \(-0.00007847520455028269`\)},
          {"3", "0.43745904838033955`", "0.43745608988604756`", 
            "2.958494292011834`*^-6", "0.00009806601681870003`"},
          {"4", "1.7164468069169294`", "1.71644400062693`", 
            "2.80628999946603`*^-6", \(-0.00048411684752058814`\)},
          {
            "5", \(-0.13191627476454587`\), \(-0.13191052313471677`\), \
\(-5.75162982910023`*^-6\), \(-0.00007127938592610406`\)},
          {"6", \(-0.5604328318576024`\), \(-0.560437178519597`\), 
            "4.346661994554369`*^-6", "0.000052001223089348514`"},
          {
            "7", \(-4.775764691711424`\), \(-4.775736590076956`\), \
\(-0.000028101634467769705`\), \(-0.00037333601147704343`\)},
          {
            "8", \(-18.77975180005872`\), \(-17.84453100834813`\), \
\(-0.9352207917105884`\), \(-3.4107330722743454`*^-7\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7637\"\>",
                    0.76374970165837419,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1397\"\>",
                    -0.13967675925959688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09301\"\>",
                    0.093007786518274266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.433\"\>",
                    3.4325154551874366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1202\"\>",
                    0.12023944191474116,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09007\"\>",
                    -0.090068553112412422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.122\"\>",
                    1.1220035027964648,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00001892\"\>",
                    -1.8915361632560612*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1397\"\>",
                    -0.13967675925959716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.329\"\>",
                    8.3288469589791063,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3131\"\>",
                    -0.31305396541111019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.73\"\>",
                    15.73333124834781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2423\"\>",
                    -0.24231038873364286,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08552\"\>",
                    0.085523862280577762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.649\"\>",
                    4.6485103322991597,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00004342\"\>",
                    -4.3422709381336542*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09301\"\>",
                    0.093007786518274196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3131\"\>",
                    -0.31305396541111097,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.84\"\>",
                    30.837483739484032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.99\"\>",
                    -4.9897011634554298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.907\"\>",
                    0.90704242055668205,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3257\"\>",
                    -0.32567519350393925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.848\"\>",
                    -2.8479309484394166,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00005389\"\>",
                    5.3888849955851072*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.433\"\>",
                    3.4325154551874366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.73\"\>",
                    15.733331248347811,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.99\"\>",
                    -4.9897011634554298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.05\"\>",
                    71.050378014158071,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.174\"\>",
                    2.173957525572261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.36\"\>",
                    -1.3595058954495525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.67\"\>",
                    24.668993786697509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002676\"\>",
                    -0.00026755805546851248,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1202\"\>",
                    0.12023944191474113,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2423\"\>",
                    -0.24231038873364324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.907\"\>",
                    0.90704242055668183,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.174\"\>",
                    2.1739575255722601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.17\"\>",
                    12.169177434974427,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.391\"\>",
                    -1.3907967961382695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.335\"\>",
                    1.3352768290914698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00003962\"\>",
                    -3.9621565440697241*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09007\"\>",
                    -0.090068553112412589,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08552\"\>",
                    0.085523862280578525,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3257\"\>",
                    -0.32567519350393992,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.36\"\>",
                    -1.359505895449552,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.391\"\>",
                    -1.3907967961382699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.65\"\>",
                    10.651191102144811,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9409\"\>",
                    -0.94085357782187151,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00002894\"\>",
                    2.8943845575460044*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.122\"\>",
                    1.1220035027964648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.649\"\>",
                    4.6485103322991597,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.848\"\>",
                    -2.8479309484394153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.67\"\>",
                    24.668993786697509,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.335\"\>",
                    1.3352768290914701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9409\"\>",
                    -0.94085357782187173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.57\"\>",
                    19.568199350203475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002064\"\>",
                    -0.00020635501084876207,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.00001892\"\>",
                    -1.8915361632590455*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00004342\"\>",
                    -4.3422709381478138*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00005389\"\>",
                    5.3888849955638894*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002676\"\>",
                    -0.00026755805546826051,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00003962\"\>",
                    -3.9621565440664958*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00002894\"\>",
                    2.8943845575542091*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002064\"\>",
                    -0.00020635501084887244,
                    AutoDelete->True], 
                  InterpretationBox[\(" 3.717"\[Times]10\^"-7"\),
                    3.7165005431108329*^-07,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]34\),
      SequenceForm[ "MBFGS: Iteration = ", 34],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089025508000\"\>",
            159.13208902550798,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 159.13208902550798, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089044312600\"\>",
            159.13208904431258,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 159.13208904431258, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089052870800\"\>",
            159.13208905287078,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 159.13208905287078, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089056953800\"\>",
            159.13208905695382,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 159.13208905695382, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089058948000\"\>",
            159.13208905894805,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 159.13208905894805, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089059933500\"\>",
            159.13208905993355,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 6, "  LIKNEU  ", 
        PaddedForm[ 159.13208905993355, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060423500\"\>",
            159.13208906042351,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 7, "  LIKNEU  ", 
        PaddedForm[ 159.13208906042351, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060667700\"\>",
            159.13208906066768,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 8, "  LIKNEU  ", 
        PaddedForm[ 159.13208906066768, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "9", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060789600\"\>",
            159.13208906078964,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 9, "  LIKNEU  ", 
        PaddedForm[ 159.13208906078964, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060850600\"\>",
            159.13208906085055,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 10, "  LIKNEU  ", 
        PaddedForm[ 159.13208906085055, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "11", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060881000\"\>",
            159.13208906088101,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 11, "  LIKNEU  ", 
        PaddedForm[ 159.13208906088101, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "12", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060896200\"\>",
            159.13208906089622,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 12, "  LIKNEU  ", 
        PaddedForm[ 159.13208906089622, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "13", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060903800\"\>",
            159.13208906090384,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 13, "  LIKNEU  ", 
        PaddedForm[ 159.13208906090384, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "14", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060907600\"\>",
            159.13208906090765,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 14, "  LIKNEU  ", 
        PaddedForm[ 159.13208906090765, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "15", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060909500\"\>",
            159.13208906090952,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 15, "  LIKNEU  ", 
        PaddedForm[ 159.13208906090952, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060909500\"\>",
            159.13208906090952,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   159.132089060911500\"\>",
            159.13208906091145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 159.13208906090952, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ 159.13208906091145, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("    -1.932676241267473"\[Times]10\^"-12"\),
            -1.9326762412674725*^-12,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ -1.9326762412674725*^-12, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-12.591106424906169`\), \(-12.59110642499198`\), 
            "8.581076916925071`*^-11", \(-4.925090161378578`*^-6\)},
          {"2", \(-3.1671334282374266`\), \(-3.1671334282469625`\), 
            "9.536147671649691`*^-12", \(-9.672432025377778`*^-6\)},
          {"3", "0.437459048381439`", "0.43745904838033955`", 
            "1.0994641966853672`*^-12", "0.000023134520701850736`"},
          {"4", "1.7164468069210659`", "1.7164468069169294`", 
            "4.136416918540118`*^-12", \(-0.00006712432086206088`\)},
          {"5", \(-0.13191627475468692`\), \(-0.13191627476454587`\), 
            "9.858957028036992`*^-12", \(-0.000012575220597055292`\)},
          {
            "6", \(-0.5604328318674866`\), \(-0.5604328318576024`\), \
\(-9.884197869605924`*^-12\), "8.554307249220017`*^-6"},
          {"7", \(-4.775764691660331`\), \(-4.775764691711424`\), 
            "5.109270725114027`*^-11", \(-0.00006168320970179053`\)},
          {"8", \(-18.77973656322309`\), \(-18.77975180005872`\), 
            "0.000015236835628562803`", "1.85088938108895`*^-7"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7637\"\>",
                    0.76374970165837419,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1397\"\>",
                    -0.13967675925959688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09301\"\>",
                    0.093007786518274266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.433\"\>",
                    3.4325154551874366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1202\"\>",
                    0.12023944191474116,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09007\"\>",
                    -0.090068553112412422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.122\"\>",
                    1.1220035027964648,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00001892\"\>",
                    -1.8915361632560612*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1397\"\>",
                    -0.13967675925959716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.329\"\>",
                    8.3288469589791063,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3131\"\>",
                    -0.31305396541111019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.73\"\>",
                    15.73333124834781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2423\"\>",
                    -0.24231038873364286,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08552\"\>",
                    0.085523862280577762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.649\"\>",
                    4.6485103322991597,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00004342\"\>",
                    -4.3422709381336542*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09301\"\>",
                    0.093007786518274196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3131\"\>",
                    -0.31305396541111097,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.84\"\>",
                    30.837483739484032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.99\"\>",
                    -4.9897011634554298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.907\"\>",
                    0.90704242055668205,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3257\"\>",
                    -0.32567519350393925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.848\"\>",
                    -2.8479309484394166,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00005389\"\>",
                    5.3888849955851072*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.433\"\>",
                    3.4325154551874366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.73\"\>",
                    15.733331248347811,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.99\"\>",
                    -4.9897011634554298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.05\"\>",
                    71.050378014158071,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.174\"\>",
                    2.173957525572261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.36\"\>",
                    -1.3595058954495525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.67\"\>",
                    24.668993786697509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002676\"\>",
                    -0.00026755805546851248,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1202\"\>",
                    0.12023944191474113,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2423\"\>",
                    -0.24231038873364324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.907\"\>",
                    0.90704242055668183,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.174\"\>",
                    2.1739575255722601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.17\"\>",
                    12.169177434974427,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.391\"\>",
                    -1.3907967961382695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.335\"\>",
                    1.3352768290914698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00003962\"\>",
                    -3.9621565440697241*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09007\"\>",
                    -0.090068553112412589,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08552\"\>",
                    0.085523862280578525,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3257\"\>",
                    -0.32567519350393992,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.36\"\>",
                    -1.359505895449552,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.391\"\>",
                    -1.3907967961382699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.65\"\>",
                    10.651191102144811,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9409\"\>",
                    -0.94085357782187151,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00002894\"\>",
                    2.8943845575460044*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.122\"\>",
                    1.1220035027964648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.649\"\>",
                    4.6485103322991597,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.848\"\>",
                    -2.8479309484394153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.67\"\>",
                    24.668993786697509,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.335\"\>",
                    1.3352768290914701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9409\"\>",
                    -0.94085357782187173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.57\"\>",
                    19.568199350203475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002064\"\>",
                    -0.00020635501084876207,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.00001892\"\>",
                    -1.8915361632590455*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00004342\"\>",
                    -4.3422709381478138*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00005389\"\>",
                    5.3888849955638894*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002676\"\>",
                    -0.00026755805546826051,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00003962\"\>",
                    -3.9621565440664958*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00002894\"\>",
                    2.8943845575542091*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002064\"\>",
                    -0.00020635501084887244,
                    AutoDelete->True], 
                  InterpretationBox[\(" 3.717"\[Times]10\^"-7"\),
                    3.7165005431108329*^-07,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS:  ENDE DER ITERATION  "\[InvisibleSpace]34\
\[InvisibleSpace]"  "\[InvisibleSpace]40\),
      SequenceForm[ "MBFGS:  ENDE DER ITERATION  ", 34, "  ", 40],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"Likelihood\"\>",
                  HoldForm], 
                TagBox["\<\"PSI\"\>",
                  HoldForm], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)]},
              {"1", "96.1422650125902`", \(-16.`\), \(-4.`\), "1.`", "2.`", 
                "0.`", "0.`", \(-2.`\), \(-2.`\)},
              {"2", 
                "139.94198088964623`", \(-16.024024564358584`\), \
\(-4.122017159752684`\), "0.837701599951771`", 
                
                "1.3817140177978287`", \(-0.07541546280543239`\), \
\(-0.27785552839375544`\), \(-4.5`\), \(-2.079135492029499`\)},
              {"3", 
                "149.64983175905104`", \(-15.959672908044483`\), \
\(-3.9246994540181794`\), "0.27730241404581624`", 
                "2.6317140177978287`", \(-0.15345971182949697`\), \
\(-0.5916187732382612`\), \(-5.647711944243012`\), \(-2.206724309187875`\)},
              {"4", 
                "152.07767643785354`", \(-15.832407683498511`\), \
\(-4.518829625471365`\), "0.07398513663705011`", 
                "2.325576222682975`", \(-0.21026902610447037`\), \
\(-1.15933343698494`\), \(-5.090606042481281`\), \(-3.0440434409408614`\)},
              {"5", 
                "154.68652204798232`", \(-15.721439310240614`\), \
\(-4.710634844483952`\), "0.6077249587514284`", 
                "2.3013217527485854`", \(-0.18764421972790293`\), \
\(-1.0705286538603787`\), \(-4.824469275679968`\), \(-3.640576675174346`\)},
              {"6", 
                "154.87486291357322`", \(-15.580196312634918`\), \
\(-4.589092916455549`\), "0.4622921424753427`", 
                "2.081096415117446`", \(-0.06191391914258379`\), \
\(-0.06671813225649825`\), \(-4.565169712591296`\), \(-4.337298942972715`\)},
              {"7", 
                "156.21634213704758`", \(-15.335663655392867`\), \
\(-2.943713472056112`\), "0.4728077598104057`", 
                "1.7627137096402847`", \(-0.15985331246895707`\), \
\(-0.5890345379288775`\), \(-4.590768750092476`\), \(-4.719498402295347`\)},
              {"8", 
                "157.66223270327606`", \(-14.469564092978107`\), \
\(-3.962313898363048`\), "0.5001301082703689`", 
                "2.0937630202759046`", \(-0.057009534455469274`\), \
\(-0.7676338550290316`\), \(-4.895228297030782`\), \(-4.665621071007514`\)},
              {"9", 
                "157.84938975733098`", \(-14.208414450325476`\), \
\(-3.866110231999448`\), "0.4886446516947773`", 
                "2.018868507998254`", \(-0.38654305606272044`\), \
\(-0.6290505463155034`\), \(-4.847283427562251`\), \(-4.833236388242201`\)},
              {"10", 
                "158.653884175484`", \(-13.65230304599502`\), \
\(-3.4192942370137183`\), "0.44543539256082787`", 
                "1.7913432804906995`", \(-0.18508088177286783`\), \
\(-0.4303866852667255`\), \(-4.717453983762095`\), \(-5.260807130776268`\)},
              {"11", 
                "159.01340701289044`", \(-12.883364063372106`\), \
\(-3.1147174417511643`\), "0.44323740629851743`", 
                "1.7201896719749508`", \(-0.11513832263473303`\), \
\(-0.5374381113407432`\), \(-4.784641787035408`\), \(-5.559735794314172`\)},
              {"12", 
                "159.06846969779085`", \(-12.571261694359666`\), \
\(-3.17238586264111`\), "0.44231925142415124`", 
                "1.716202138173854`", \(-0.11841137059277086`\), \
\(-0.5668552928839525`\), \(-4.793551895795508`\), \(-5.700681977474876`\)},
              {"13", 
                "159.0757876081513`", \(-12.53221393287058`\), \
\(-3.1524328962031345`\), "0.4357146222506873`", 
                "1.7080527653880344`", \(-0.1321434606691722`\), \
\(-0.5601900741151336`\), \(-4.7838529252410815`\), \(-5.787719285439`\)},
              {"14", 
                "159.08490945387302`", \(-12.519572267272292`\), \
\(-3.1454380883705317`\), "0.435399837551184`", 
                "1.7056408589265348`", \(-0.14331656303647136`\), \
\(-0.554832136688937`\), \(-4.765025784212628`\), \(-5.978410726146161`\)},
              {"15", 
                "159.09411844484808`", \(-12.51237990453257`\), \
\(-3.1442890822404053`\), "0.43146516435768356`", 
                "1.705109910974777`", \(-0.14259888276730484`\), \
\(-0.5555900161473537`\), \(-4.751170819489525`\), \(-6.27081944830056`\)},
              {"16", 
                "159.10563826186785`", \(-12.519916642022121`\), \
\(-3.1480782166545254`\), "0.43394399392215566`", 
                "1.7062096688240633`", \(-0.13725992754344704`\), \
\(-0.558530840082032`\), \(-4.743837509296956`\), \(-6.733578519814649`\)},
              {"17", 
                "159.11837462289716`", \(-12.55624799879523`\), \
\(-3.160721763402666`\), "0.43359633527077746`", 
                "1.712994670396727`", \(-0.13043853733427332`\), \
\(-0.5621634027674914`\), \(-4.753951667767957`\), \(-7.397735203655072`\)},
              {"18", 
                "159.12658488454292`", \(-12.578071445963973`\), \
\(-3.1648312693425873`\), "0.43854192660482144`", 
                "1.714254695174209`", \(-0.1289654235278912`\), \
\(-0.5620422171449886`\), \(-4.767878366255615`\), \(-8.14940288760709`\)},
              {"19", 
                "159.1291689037907`", \(-12.599607918785438`\), \
\(-3.1700764562791166`\), "0.43719998476594524`", 
                "1.7182728902257003`", \(-0.13084825160207086`\), \
\(-0.5610248735200566`\), \(-4.779742078219887`\), \(-8.747374865257978`\)},
              {"20", 
                "159.13016152407383`", \(-12.599234717881416`\), \
\(-3.1685642148845417`\), "0.4382916266880118`", 
                "1.7171703298403063`", \(-0.1321405856970809`\), \
\(-0.5600635518199697`\), \(-4.781296789778551`\), \(-9.232017370326606`\)},
              {"21", 
                "159.13101535215816`", \(-12.59811565372727`\), \
\(-3.168125309721635`\), "0.43797400204452047`", 
                "1.7171705326763191`", \(-0.1328504526388404`\), \
\(-0.5597503901359693`\), \(-4.780745400177761`\), \(-9.857155689020257`\)},
              {"22", 
                "159.13161986483544`", \(-12.593172376028726`\), \
\(-3.1672104776509378`\), "0.4376282343126329`", 
                "1.7165230496751285`", \(-0.132483226177999`\), \
\(-0.5600454487296395`\), \(-4.777447545607376`\), \(-10.589239760929317`\)},
              {"23", 
                "159.13185376595254`", \(-12.59047597483385`\), \
\(-3.166982172962391`\), "0.43740003570698344`", 
                "1.716395298089546`", \(-0.13198312836612`\), \
\(-0.5604167345507084`\), \(-4.775397252943928`\), \(-11.239562095372408`\)},
              {"24", 
                "159.13195135237493`", \(-12.589603528462368`\), \
\(-3.166926068746667`\), "0.43732387962312064`", 
                "1.7163015753890187`", \(-0.13172812896463246`\), \
\(-0.5605757287351483`\), \(-4.774684514703201`\), \(-11.821323974855346`\)},
              {"25", 
                "159.13201679464228`", \(-12.589907060779403`\), \
\(-3.1670002882855193`\), "0.4373625260862567`", 
                "1.7163564673743326`", \(-0.13171829877466618`\), \
\(-0.5605773649861088`\), \(-4.774879927046837`\), \(-12.48477306054076`\)},
              {"26", 
                "159.13205551303955`", \(-12.590695220049145`\), \
\(-3.1670945876984384`\), "0.43742191496562177`", 
                "1.716409791943325`", \(-0.1318307771194307`\), \
\(-0.5604907588899759`\), \(-4.775447409125803`\), \(-13.199131898367897`\)},
              {"27", 
                "159.13207215849664`", \(-12.591251115595645`\), \
\(-3.1671550075264023`\), "0.437474185523253`", 
                "1.7164638956068161`", \(-0.13193275944822613`\), \
\(-0.5604204756218598`\), \(-4.775869725328145`\), \(-13.865345700752236`\)},
              {"28", 
                "159.13207986285178`", \(-12.591423615429166`\), \
\(-3.1671712394113865`\), "0.4374848326217104`", 
                "1.7164719510093707`", \(-0.13196441658356142`\), \
\(-0.5603971298966961`\), \(-4.775996049617948`\), \(-14.498306244002672`\)},
              {"29", 
                "159.1320844419827`", \(-12.59135167499975`\), \
\(-3.1671621427285435`\), "0.43748091556021146`", 
                "1.716468988028942`", \(-0.13195600623222753`\), \
\(-0.5604043433472677`\), \(-4.775946886255078`\), \(-15.179748268613361`\)},
              {"30", 
                "159.13208691212427`", \(-12.591187571254373`\), \
\(-3.1671428330502156`\), "0.43746539227431164`", 
                "1.7164528415914275`", \(-0.1319289154255947`\), \
\(-0.5604234573699564`\), \(-4.77582384860168`\), \(-15.883456169351103`\)},
              {"31", 
                "159.13208800384868`", \(-12.59107962942384`\), \
\(-3.1671302965781623`\), "0.43745737088420505`", 
                "1.7164453927269927`", \(-0.13191243035123829`\), \
\(-0.5604358478945245`\), \(-4.775745794790506`\), \(-16.533227473682114`\)},
              {"32", 
                "159.13208856018093`", \(-12.591046904203695`\), \
\(-3.167126315449957`\), "0.4374539004383249`", 
                "1.7164416288019069`", \(-0.1319070188500525`\), \
\(-0.5604395734697705`\), \(-4.775720877542827`\), \(-17.189856740442305`\)},
              {"33", 
                "159.1320888612198`", \(-12.591067430821209`\), \
\(-3.167128758643671`\), "0.43745608988604756`", 
                "1.71644400062693`", \(-0.13191052313471677`\), \
\(-0.560437178519597`\), \(-4.775736590076956`\), \(-17.84453100834813`\)},
              {"34", 
                "159.13208906091145`", \(-12.59110642499198`\), \
\(-3.1671334282469625`\), "0.43745904838033955`", 
                "1.7164468069169294`", \(-0.13191627476454587`\), \
\(-0.5604328318576024`\), \(-4.775764691711424`\), \(-18.77975180005872`\)},
              {"35", 
                "159.13208906090952`", \(-12.591106424906169`\), \
\(-3.1671334282374266`\), "0.437459048381439`", 
                "1.7164468069210659`", \(-0.13191627475468692`\), \
\(-0.5604328318674866`\), \(-4.775764691660331`\), \(-18.77973656322309`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "PSI"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INKREMENT   "\[InvisibleSpace]1.`*^-6\),
      SequenceForm[ "INKREMENT   ", 9.9999999999999995*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    \("KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"SNUM\"\>",
                  HoldForm], 
                TagBox["\<\"S\"\>",
                  HoldForm], 
                TagBox["\<\"DS\"\>",
                  HoldForm], 
                TagBox["\<\"PSI\"\>",
                  HoldForm], 
                TagBox["\<\"INK\"\>",
                  HoldForm]},
              {
                "1", \(-4.9253947893307316`*^-6\), \(-4.9251835560550105`*^-6\
\), "2.11233275721082`*^-10", \(-12.591106424906169`\), 
                "0.000012591106424906169`"},
              {
                "2", \(-9.669435344346515`*^-6\), \
\(-9.672711846328477`*^-6\), \(-3.2765019819617222`*^-9\), \
\(-3.1671334282374266`\), "3.1671334282374266`*^-6"},
              {"3", "0.000023161800971834544`", 
                "0.000023134438290779713`", \(-2.7362681054830546`*^-8\), 
                "0.437459048381439`", "4.37459048381439`*^-7"},
              {
                "4", \(-0.00006711970258070495`\), \(-0.00006712571050830618`\
\), \(-6.007927601229157`*^-9\), "1.7164468069210659`", 
                "1.716446806921066`*^-6"},
              {
                "5", \(-0.000012603979340460874`\), \
\(-0.000012575320623708919`\), 
                "2.8658716751955187`*^-8", \(-0.13191627475468692`\), 
                "1.3191627475468692`*^-7"},
              {"6", "8.545284584889273`*^-6", "8.554405896532558`*^-6", 
                "9.121311643284634`*^-9", \(-0.5604328318674866`\), 
                "5.604328318674866`*^-7"},
              {
                "7", \(-0.0000616815999971327`\), \
\(-0.00006168392202199335`\), \(-2.322024860652622`*^-9\), \
\(-4.775764691660331`\), "4.775764691660331`*^-6"},
              {
                "8", \(-1.2410079158709674`*^-7\), \(-1.3180866786556716`*^-7\
\), \(-7.707876278470425`*^-9\), \(-18.77973656322309`\), 
                "0.000018779736563223087`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SNUM", "S", "DS", "PSI", 
          "INK"}}]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", \(-12.591106424906169`\), \(-4.9251835560550105`*^-6\)},
              {"2", \(-3.1671334282374266`\), \(-9.672711846328477`*^-6\)},
              {"3", "0.437459048381439`", "0.000023134438290779713`"},
              {"4", "1.7164468069210659`", \(-0.00006712571050830618`\)},
              {
                "5", \(-0.13191627475468692`\), \
\(-0.000012575320623708919`\)},
              {"6", \(-0.5604328318674866`\), "8.554405896532558`*^-6"},
              {"7", \(-4.775764691660331`\), \(-0.00006168392202199335`\)},
              {"8", \(-18.77973656322309`\), \(-1.3180866786556716`*^-7\)}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "159.13208906090952`"}],
      SequenceForm[ 
        TableForm[ {{-12.591106424906169, -4.9251835560550105*^-06}, \
{-3.1671334282374266, -9.6727118463284766*^-06}, {0.43745904838143901, 
          2.3134438290779713*^-05}, {
          1.7164468069210659, -6.712571050830618*^-05}, \
{-0.13191627475468692, -1.2575320623708919*^-05}, {-0.5604328318674866, 
          8.5544058965325576*^-06}, {-4.7757646916603314, \
-6.1683922021993354*^-05}, {-18.779736563223089, -1.3180866786556716*^-07}}, 
          TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 1}], 
        "   Likelihood = ", 159.13208906090952],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "233.5267151074008`", "8", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("Warnung: Negative Diagonalelemente der Kovarianzmatrix"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "2.307457904929532`", 
                "0.42027210410343274`", \(-0.03335233062498403`\), \
\(-0.2249286735052134`\), \(-0.0359993031306524`\), "0.005464421861668705`", 
                "0.10523932520506867`", \(-0.9631509331052353`\)},
              {"2", "0.420272104103432`", 
                "0.2887101519081618`", \(-0.010669795195898609`\), \
\(-0.09416356200608846`\), \(-0.013825854882404563`\), 
                "0.0020844485219021027`", 
                "0.03387938119965692`", \(-0.3674020702734644`\)},
              {"3", \(-0.033352330624987866`\), \(-0.010669795195899407`\), 
                "0.026961973055834188`", "0.004350771599454252`", 
                "0.016251867546210087`", \(-0.0025219050242760504`\), \
\(-0.0016384124000786635`\), "0.4445045088955149`"},
              {"4", \(-0.22492867350521273`\), \(-0.09416356200608834`\), 
                "0.004350771599453842`", "0.05684628773336146`", 
                "0.00592040150225925`", \(-0.0008494026720398905`\), \
\(-0.041619088714575335`\), "0.14971508276567821`"},
              {"5", \(-0.03599930313063781`\), \(-0.013825854882401562`\), 
                "0.01625186754620988`", "0.0059204015022577315`", 
                "0.045098467274259965`", 
                "0.008681739091650745`", \(-0.004038252882889174`\), \
\(-1.5302205002084286`\)},
              {"6", "0.005464421861666835`", 
                "0.0020844485219017436`", \(-0.002521905024276062`\), \
\(-0.0008494026720397078`\), "0.008681739091650946`", "0.098647556193174`", 
                "0.0004790330943616032`", "0.2383783090274971`"},
              {"7", "0.10523932520506776`", 
                "0.03387938119965676`", \(-0.00163841240007846`\), \
\(-0.041619088714575286`\), \(-0.004038252882889903`\), 
                "0.0004790330943616756`", 
                "0.1279499007111697`", \(-0.0844342839563217`\)},
              {"8", \(-0.9631509331048308`\), \(-0.3674020702733826`\), 
                "0.44450450889550697`", 
                "0.1497150827656366`", \(-1.5302205002084297`\), 
                "0.23837830902749224`", \(-0.08443428395630223`\), \
\(-42.015934183230435`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.01370133181940371`, 0.030611895859965724`, 0.09999615283767892`, 
      0.10066263225670721`, 0.12480109066016017`, 0.22210513960457268`, 
      2.4460225865953813`, \(-42.10216277105875`\)}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0.7311801292623807`", \(-0.15117022639069727`\), 
                "0.42397986200231474`", 
                "2.8959399084528554`", \(-0.004007711295174797`\), \
\(-2.645707002920549`*^-9\), 
                "0.38507954826673374`", \(-0.0012626390870829627`\)},
              {"2", \(-0.15117022639069727`\), "8.372632771910858`", 
                "0.9966807613492574`", 
                "15.34944794686198`", \(-0.008497649067158466`\), \
\(-3.7080112284091503`*^-9\), 
                "2.906062853765674`", \(-0.01003947611257439`\)},
              {"3", "0.42397986200231474`", "0.9966807613492574`", 
                "32.62679845150152`", \(-0.01790383347308648`\), \
\(-0.011891526305488431`\), "1.1615762445330965`*^-8", 
                "0.014797209314651352`", "0.3270779743270083`"},
              {"4", "2.8959399084528554`", 
                "15.34944794686198`", \(-0.01790383347308648`\), 
                "65.30496382299269`", \(-0.06740009520870235`\), \
\(-1.6023695693999115`*^-6\), "14.796615853938352`", 
                "0.004625114623691657`"},
              {
                "5", \(-0.004007711295174797`\), \(-0.008497649067158466`\), \
\(-0.011891526305488431`\), \(-0.06740009520870235`\), "9.91857063682407`", 
                "2.97151494745315`*^-10", 
                "0.05792487477214603`", \(-0.3615505837237851`\)},
              {"6", \(-2.645707002920549`*^-9\), \(-3.7080112284091503`*^-9\),
                 "1.1615762445330965`*^-8", \(-1.6023695693999115`*^-6\), 
                "2.97151494745315`*^-10", 
                "9.999999932785899`", \(-2.7896425296595066`*^-9\), 
                "0.05673520985663926`"},
              {"7", "0.38507954826673374`", "2.906062853765674`", 
                "0.014797209314651352`", "14.796615853938352`", 
                "0.05792487477214603`", \(-2.7896425296595066`*^-9\), 
                "11.539958579519384`", \(-0.006657836320100802`\)},
              {"8", \(-0.0012626390870829627`\), \(-0.01003947611257439`\), 
                "0.3270779743270083`", 
                "0.004625114623691657`", \(-0.3615505837237851`\), 
                "0.05673520985663926`", \(-0.006657836320100802`\), \
\(-0.0067040416279750496`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({72.985605573307`, 32.66703913323452`, 10.000384731033336`, 
      9.934172965493552`, 8.012750487277806`, 4.502372172838328`, 
      0.4088269689250498`, \(-0.023751748940731503`\)}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]8\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]1010\),
      SequenceForm[ "U =  ", 8, "  Nue = ", 1010],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "8", "27.67082243934122`", 
            "69.69665662324827`"},
          {"\<\"komp. Lik.\"\>", "159.13208906090952`", "151.13208906090952`",
             "131.4612666215683`", "89.43543243766125`"}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("DELTA-THEOREM"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"\)], "Print"],

Cell[BoxData[
    \("A, B, OMEGA, SIGMA UND MUE"\)], "Print"],

Cell[BoxData[
    \("UND DER MESS-MODELL-MATRIZEN H, D UND R"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" A     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0", "1"},
                {\(-12.591106424906169`\), \(-3.1671334282374266`\)}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDA   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"1.519031897271921`", "0.537317552205548`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " A     ", 
        MatrixForm[ {{0, 1}, {-12.591106424906169, -3.1671334282374266}}, 
          TableHeadings -> None], "   STDA   ", 
        MatrixForm[ {{0.0, 0.0}, {1.519031897271921, 0.537317552205548}}, 
          TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" B     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {"0.437459048381439`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDB   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.164201014174195`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " B     ", 
        MatrixForm[ {{0}, {0.43745904838143901}}, TableHeadings -> None], 
        "   STDB   ", 
        MatrixForm[ {{0.0}, {0.164201014174195}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"OMEGA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1.`*^-8", "0.`"},
                {"0.`", "2.9461896409895227`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDO   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "0.8184862712318132`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "OMEGA  ", 
        MatrixForm[ {{1*^-08, 0.0}, {0.0, 2.9461896409895227}}, TableHeadings -> 
          None], "   STDO   ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 0.81848627123181317}}, TableHeadings -> 
          None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"MUE    \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", 
            TagBox[GridBox[{
                  {\(-0.13191627475468692`\)},
                  {\(-0.5604328318674866`\)}
                  },
                RowSpacings->0.6,
                ColumnAlignments->{Left}],
              Column], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDMUE \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.21236399712347656`"},
                {"0.31408208511975655`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "MUE    ", 
        MatrixForm[ {-0.13191627475468692, -0.5604328318674866}, 
          TableHeadings -> None], "   STDMUE ", 
        MatrixForm[ {{0.21236399712347656}, {0.31408208511975655}}, 
          TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"SIGMA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1.`", "0"},
                {"0", "1.`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDSIG \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "0.`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "SIGMA  ", 
        MatrixForm[ {{1.0, 0}, {0, 1.0}}, TableHeadings -> None], 
        "   STDSIG ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" H     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1", "0"},
                {"0", "1"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDH   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "0.`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " H     ", 
        MatrixForm[ {{1, 0}, {0, 1}}, TableHeadings -> None], "   STDH   ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" D     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {"0"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDD   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " D     ", 
        MatrixForm[ {{0}, {0}}, TableHeadings -> None], "   STDD   ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" R     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.008431634021390855`", "0"},
                {"0", "6.983353696925629`*^-9"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDR   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.0030160026872246863`", "0.`"},
                {"0.`", "0"}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left}], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " R     ", 
        MatrixForm[ {{0.0084316340213908547, 0}, {0, 
          6.9833536969256292*^-09}}, TableHeadings -> None], "   STDR   ", 
        MatrixForm[ {{0.0030160026872246863, 0.0}, {0.0, 0}}, TableHeadings -> 
          None]],
      Editable->False]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
g = Table[plot1[ColumnSelect[likpsi,{i}]//AddTimeAxis,
\t\t\tcolor->{i},
\t\t\tDisplayFunction->Identity],{i,9}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{36, 2}\),
      SequenceForm[ "Dimension der Daten  ", {36, 2}],
      Editable->False]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Show[GraphicsArray[Partition[Join[g,{{}}],3]],Background->GrayLevel[\
.95]];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
.95 g
MFill
% Scaling calculations
0.0238095 0.31746 0.0147151 0.31746 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.34127 0.210916 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 0.603319 0.507709 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09561 -12 -4.5 ]
[-0.0125 .09561 0 4.5 ]
[-0.0125 .19715 -24 -4.5 ]
[-0.0125 .19715 0 4.5 ]
[-0.0125 .29869 -24 -4.5 ]
[-0.0125 .29869 0 4.5 ]
[-0.0125 .40024 -24 -4.5 ]
[-0.0125 .40024 0 4.5 ]
[-0.0125 .50178 -24 -4.5 ]
[-0.0125 .50178 0 4.5 ]
[-0.0125 .60332 -6 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31878 -5 -6 ]
[.97619 .31878 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09561 m
.00625 .09561 L
s
[(-1)] -0.0125 .09561 1 0 Mshowa
0 .19715 m
.00625 .19715 L
s
[(-0.8)] -0.0125 .19715 1 0 Mshowa
0 .29869 m
.00625 .29869 L
s
[(-0.6)] -0.0125 .29869 1 0 Mshowa
0 .40024 m
.00625 .40024 L
s
[(-0.4)] -0.0125 .40024 1 0 Mshowa
0 .50178 m
.00625 .50178 L
s
[(-0.2)] -0.0125 .50178 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(0)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .121 m
.00375 .121 L
s
0 .14638 m
.00375 .14638 L
s
0 .17177 m
.00375 .17177 L
s
0 .22254 m
.00375 .22254 L
s
0 .24792 m
.00375 .24792 L
s
0 .27331 m
.00375 .27331 L
s
0 .32408 m
.00375 .32408 L
s
0 .34946 m
.00375 .34946 L
s
0 .37485 m
.00375 .37485 L
s
0 .42562 m
.00375 .42562 L
s
0 .45101 m
.00375 .45101 L
s
0 .47639 m
.00375 .47639 L
s
0 .52716 m
.00375 .52716 L
s
0 .55255 m
.00375 .55255 L
s
0 .57793 m
.00375 .57793 L
s
0 .07022 m
.00375 .07022 L
s
0 .04484 m
.00375 .04484 L
s
0 .01945 m
.00375 .01945 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09561 m
1 .09561 L
s
.99375 .19715 m
1 .19715 L
s
.99375 .29869 m
1 .29869 L
s
.99375 .40024 m
1 .40024 L
s
.99375 .50178 m
1 .50178 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .121 m
1 .121 L
s
.99625 .14638 m
1 .14638 L
s
.99625 .17177 m
1 .17177 L
s
.99625 .22254 m
1 .22254 L
s
.99625 .24792 m
1 .24792 L
s
.99625 .27331 m
1 .27331 L
s
.99625 .32408 m
1 .32408 L
s
.99625 .34946 m
1 .34946 L
s
.99625 .37485 m
1 .37485 L
s
.99625 .42562 m
1 .42562 L
s
.99625 .45101 m
1 .45101 L
s
.99625 .47639 m
1 .47639 L
s
.99625 .52716 m
1 .52716 L
s
.99625 .55255 m
1 .55255 L
s
.99625 .57793 m
1 .57793 L
s
.99625 .07022 m
1 .07022 L
s
.99625 .04484 m
1 .04484 L
s
.99625 .01945 m
1 .01945 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 1 r
gsave
.97619 .31878 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .60332 m
.05102 .46225 L
.07823 .30295 L
.10544 .01472 L
.13265 .0598 L
.15986 .56945 L
.18707 .30426 L
.21429 .21358 L
.2415 .28394 L
.26871 .38481 L
.29592 .33046 L
.32313 .31552 L
.35034 .31891 L
.37755 .32163 L
.40476 .32124 L
.43197 .31975 L
.45918 .3179 L
.48639 .31797 L
.51361 .31848 L
.54082 .31897 L
.56803 .31913 L
.59524 .31898 L
.62245 .31879 L
.64966 .31871 L
.67687 .31871 L
.70408 .31875 L
.73129 .31879 L
.7585 .3188 L
.78571 .3188 L
.81293 .31879 L
.84014 .31878 L
.86735 .31878 L
.89456 .31878 L
.92177 .31878 L
.94898 .31878 L
.97619 .31878 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.0147151 0.65873 0.210916 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 0.926044 0.161362 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03855 -24 -4.5 ]
[-0.0125 .03855 0 4.5 ]
[-0.0125 .11923 -12 -4.5 ]
[-0.0125 .11923 0 4.5 ]
[-0.0125 .19991 -24 -4.5 ]
[-0.0125 .19991 0 4.5 ]
[-0.0125 .28059 -12 -4.5 ]
[-0.0125 .28059 0 4.5 ]
[-0.0125 .36128 -24 -4.5 ]
[-0.0125 .36128 0 4.5 ]
[-0.0125 .44196 -12 -4.5 ]
[-0.0125 .44196 0 4.5 ]
[-0.0125 .52264 -24 -4.5 ]
[-0.0125 .52264 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .15541 -5 -6 ]
[.97619 .15541 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03855 m
.00625 .03855 L
s
[(-5.5)] -0.0125 .03855 1 0 Mshowa
0 .11923 m
.00625 .11923 L
s
[(-5)] -0.0125 .11923 1 0 Mshowa
0 .19991 m
.00625 .19991 L
s
[(-4.5)] -0.0125 .19991 1 0 Mshowa
0 .28059 m
.00625 .28059 L
s
[(-4)] -0.0125 .28059 1 0 Mshowa
0 .36128 m
.00625 .36128 L
s
[(-3.5)] -0.0125 .36128 1 0 Mshowa
0 .44196 m
.00625 .44196 L
s
[(-3)] -0.0125 .44196 1 0 Mshowa
0 .52264 m
.00625 .52264 L
s
[(-2.5)] -0.0125 .52264 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(-2)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .05469 m
.00375 .05469 L
s
0 .07082 m
.00375 .07082 L
s
0 .08696 m
.00375 .08696 L
s
0 .1031 m
.00375 .1031 L
s
0 .13537 m
.00375 .13537 L
s
0 .1515 m
.00375 .1515 L
s
0 .16764 m
.00375 .16764 L
s
0 .18378 m
.00375 .18378 L
s
0 .21605 m
.00375 .21605 L
s
0 .23219 m
.00375 .23219 L
s
0 .24832 m
.00375 .24832 L
s
0 .26446 m
.00375 .26446 L
s
0 .29673 m
.00375 .29673 L
s
0 .31287 m
.00375 .31287 L
s
0 .329 m
.00375 .329 L
s
0 .34514 m
.00375 .34514 L
s
0 .37741 m
.00375 .37741 L
s
0 .39355 m
.00375 .39355 L
s
0 .40968 m
.00375 .40968 L
s
0 .42582 m
.00375 .42582 L
s
0 .45809 m
.00375 .45809 L
s
0 .47423 m
.00375 .47423 L
s
0 .49037 m
.00375 .49037 L
s
0 .5065 m
.00375 .5065 L
s
0 .53877 m
.00375 .53877 L
s
0 .55491 m
.00375 .55491 L
s
0 .57105 m
.00375 .57105 L
s
0 .58718 m
.00375 .58718 L
s
0 .02241 m
.00375 .02241 L
s
0 .00628 m
.00375 .00628 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03855 m
1 .03855 L
s
.99375 .11923 m
1 .11923 L
s
.99375 .19991 m
1 .19991 L
s
.99375 .28059 m
1 .28059 L
s
.99375 .36128 m
1 .36128 L
s
.99375 .44196 m
1 .44196 L
s
.99375 .52264 m
1 .52264 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .05469 m
1 .05469 L
s
.99625 .07082 m
1 .07082 L
s
.99625 .08696 m
1 .08696 L
s
.99625 .1031 m
1 .1031 L
s
.99625 .13537 m
1 .13537 L
s
.99625 .1515 m
1 .1515 L
s
.99625 .16764 m
1 .16764 L
s
.99625 .18378 m
1 .18378 L
s
.99625 .21605 m
1 .21605 L
s
.99625 .23219 m
1 .23219 L
s
.99625 .24832 m
1 .24832 L
s
.99625 .26446 m
1 .26446 L
s
.99625 .29673 m
1 .29673 L
s
.99625 .31287 m
1 .31287 L
s
.99625 .329 m
1 .329 L
s
.99625 .34514 m
1 .34514 L
s
.99625 .37741 m
1 .37741 L
s
.99625 .39355 m
1 .39355 L
s
.99625 .40968 m
1 .40968 L
s
.99625 .42582 m
1 .42582 L
s
.99625 .45809 m
1 .45809 L
s
.99625 .47423 m
1 .47423 L
s
.99625 .49037 m
1 .49037 L
s
.99625 .5065 m
1 .5065 L
s
.99625 .53877 m
1 .53877 L
s
.99625 .55491 m
1 .55491 L
s
.99625 .57105 m
1 .57105 L
s
.99625 .58718 m
1 .58718 L
s
.99625 .02241 m
1 .02241 L
s
.99625 .00628 m
1 .00628 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .808 .82 r
gsave
.97619 .15541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.808 0.820 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .60332 m
.05102 .19991 L
.07823 .01472 L
.10544 .10461 L
.13265 .14756 L
.15986 .1894 L
.18707 .18527 L
.21429 .13614 L
.2415 .14387 L
.26871 .16482 L
.29592 .15398 L
.32313 .15254 L
.35034 .15411 L
.37755 .15715 L
.40476 .15938 L
.43197 .16057 L
.45918 .15893 L
.48639 .15669 L
.51361 .15477 L
.54082 .15452 L
.56803 .15461 L
.59524 .15514 L
.62245 .15547 L
.64966 .15559 L
.67687 .15556 L
.70408 .15547 L
.73129 .1554 L
.7585 .15538 L
.78571 .15539 L
.81293 .15541 L
.84014 .15542 L
.86735 .15542 L
.89456 .15542 L
.92177 .15542 L
.94898 .15541 L
.97619 .15541 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.0147151 0.97619 0.210916 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 0.673065 0.0348731 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06279 -30 -4.5 ]
[-0.0125 .06279 0 4.5 ]
[-0.0125 .14997 -18 -4.5 ]
[-0.0125 .14997 0 4.5 ]
[-0.0125 .23715 -30 -4.5 ]
[-0.0125 .23715 0 4.5 ]
[-0.0125 .32433 -18 -4.5 ]
[-0.0125 .32433 0 4.5 ]
[-0.0125 .41152 -24 -4.5 ]
[-0.0125 .41152 0 4.5 ]
[-0.0125 .4987 -12 -4.5 ]
[-0.0125 .4987 0 4.5 ]
[-0.0125 .58588 -24 -4.5 ]
[-0.0125 .58588 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06279 m
.00625 .06279 L
s
[(-17.5)] -0.0125 .06279 1 0 Mshowa
0 .14997 m
.00625 .14997 L
s
[(-15)] -0.0125 .14997 1 0 Mshowa
0 .23715 m
.00625 .23715 L
s
[(-12.5)] -0.0125 .23715 1 0 Mshowa
0 .32433 m
.00625 .32433 L
s
[(-10)] -0.0125 .32433 1 0 Mshowa
0 .41152 m
.00625 .41152 L
s
[(-7.5)] -0.0125 .41152 1 0 Mshowa
0 .4987 m
.00625 .4987 L
s
[(-5)] -0.0125 .4987 1 0 Mshowa
0 .58588 m
.00625 .58588 L
s
[(-2.5)] -0.0125 .58588 1 0 Mshowa
.125 Mabswid
0 .08022 m
.00375 .08022 L
s
0 .09766 m
.00375 .09766 L
s
0 .1151 m
.00375 .1151 L
s
0 .13253 m
.00375 .13253 L
s
0 .16741 m
.00375 .16741 L
s
0 .18484 m
.00375 .18484 L
s
0 .20228 m
.00375 .20228 L
s
0 .21971 m
.00375 .21971 L
s
0 .25459 m
.00375 .25459 L
s
0 .27202 m
.00375 .27202 L
s
0 .28946 m
.00375 .28946 L
s
0 .3069 m
.00375 .3069 L
s
0 .34177 m
.00375 .34177 L
s
0 .35921 m
.00375 .35921 L
s
0 .37664 m
.00375 .37664 L
s
0 .39408 m
.00375 .39408 L
s
0 .42895 m
.00375 .42895 L
s
0 .44639 m
.00375 .44639 L
s
0 .46383 m
.00375 .46383 L
s
0 .48126 m
.00375 .48126 L
s
0 .51614 m
.00375 .51614 L
s
0 .53357 m
.00375 .53357 L
s
0 .55101 m
.00375 .55101 L
s
0 .56845 m
.00375 .56845 L
s
0 .04535 m
.00375 .04535 L
s
0 .02791 m
.00375 .02791 L
s
0 .01048 m
.00375 .01048 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06279 m
1 .06279 L
s
.99375 .14997 m
1 .14997 L
s
.99375 .23715 m
1 .23715 L
s
.99375 .32433 m
1 .32433 L
s
.99375 .41152 m
1 .41152 L
s
.99375 .4987 m
1 .4987 L
s
.99375 .58588 m
1 .58588 L
s
.125 Mabswid
.99625 .08022 m
1 .08022 L
s
.99625 .09766 m
1 .09766 L
s
.99625 .1151 m
1 .1151 L
s
.99625 .13253 m
1 .13253 L
s
.99625 .16741 m
1 .16741 L
s
.99625 .18484 m
1 .18484 L
s
.99625 .20228 m
1 .20228 L
s
.99625 .21971 m
1 .21971 L
s
.99625 .25459 m
1 .25459 L
s
.99625 .27202 m
1 .27202 L
s
.99625 .28946 m
1 .28946 L
s
.99625 .3069 m
1 .3069 L
s
.99625 .34177 m
1 .34177 L
s
.99625 .35921 m
1 .35921 L
s
.99625 .37664 m
1 .37664 L
s
.99625 .39408 m
1 .39408 L
s
.99625 .42895 m
1 .42895 L
s
.99625 .44639 m
1 .44639 L
s
.99625 .46383 m
1 .46383 L
s
.99625 .48126 m
1 .48126 L
s
.99625 .51614 m
1 .51614 L
s
.99625 .53357 m
1 .53357 L
s
.99625 .55101 m
1 .55101 L
s
.99625 .56845 m
1 .56845 L
s
.99625 .04535 m
1 .04535 L
s
.99625 .02791 m
1 .02791 L
s
.99625 .01048 m
1 .01048 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
.859 .439 .576 r
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.859 0.439 0.577 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .60332 m
.05102 .60056 L
.07823 .59611 L
.10544 .56691 L
.13265 .54611 L
.15986 .52181 L
.18707 .50848 L
.21429 .51036 L
.2415 .50452 L
.26871 .4896 L
.29592 .47918 L
.32313 .47426 L
.35034 .47123 L
.37755 .46458 L
.40476 .45438 L
.43197 .43824 L
.45918 .41508 L
.48639 .38887 L
.51361 .36802 L
.54082 .35112 L
.56803 .32932 L
.59524 .30379 L
.62245 .28111 L
.64966 .26082 L
.67687 .23768 L
.70408 .21277 L
.73129 .18954 L
.7585 .16746 L
.78571 .14372 L
.81293 .11915 L
.84014 .09559 L
.86735 .07412 L
.89456 .05321 L
.92177 .03955 L
.94898 .01472 L
.97619 .01472 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.210916 0.34127 0.407118 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 -0.0323113 0.63563 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09481 -18 -4.5 ]
[-0.0125 .09481 0 4.5 ]
[-0.0125 .22194 -18 -4.5 ]
[-0.0125 .22194 0 4.5 ]
[-0.0125 .34907 -18 -4.5 ]
[-0.0125 .34907 0 4.5 ]
[-0.0125 .47619 -18 -4.5 ]
[-0.0125 .47619 0 4.5 ]
[-0.0125 .60332 -6 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .24575 -5 -6 ]
[.97619 .24575 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09481 m
.00625 .09481 L
s
[(0.2)] -0.0125 .09481 1 0 Mshowa
0 .22194 m
.00625 .22194 L
s
[(0.4)] -0.0125 .22194 1 0 Mshowa
0 .34907 m
.00625 .34907 L
s
[(0.6)] -0.0125 .34907 1 0 Mshowa
0 .47619 m
.00625 .47619 L
s
[(0.8)] -0.0125 .47619 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(1)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .1266 m
.00375 .1266 L
s
0 .15838 m
.00375 .15838 L
s
0 .19016 m
.00375 .19016 L
s
0 .25372 m
.00375 .25372 L
s
0 .2855 m
.00375 .2855 L
s
0 .31729 m
.00375 .31729 L
s
0 .38085 m
.00375 .38085 L
s
0 .41263 m
.00375 .41263 L
s
0 .44441 m
.00375 .44441 L
s
0 .50797 m
.00375 .50797 L
s
0 .53976 m
.00375 .53976 L
s
0 .57154 m
.00375 .57154 L
s
0 .06303 m
.00375 .06303 L
s
0 .03125 m
.00375 .03125 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09481 m
1 .09481 L
s
.99375 .22194 m
1 .22194 L
s
.99375 .34907 m
1 .34907 L
s
.99375 .47619 m
1 .47619 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .1266 m
1 .1266 L
s
.99625 .15838 m
1 .15838 L
s
.99625 .19016 m
1 .19016 L
s
.99625 .25372 m
1 .25372 L
s
.99625 .2855 m
1 .2855 L
s
.99625 .31729 m
1 .31729 L
s
.99625 .38085 m
1 .38085 L
s
.99625 .41263 m
1 .41263 L
s
.99625 .44441 m
1 .44441 L
s
.99625 .50797 m
1 .50797 L
s
.99625 .53976 m
1 .53976 L
s
.99625 .57154 m
1 .57154 L
s
.99625 .06303 m
1 .06303 L
s
.99625 .03125 m
1 .03125 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 1 0 r
gsave
.97619 .24575 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .60332 m
.05102 .50016 L
.07823 .14395 L
.10544 .01472 L
.13265 .35398 L
.15986 .26154 L
.18707 .26822 L
.21429 .28559 L
.2415 .27829 L
.26871 .25082 L
.29592 .24942 L
.32313 .24884 L
.35034 .24464 L
.37755 .24444 L
.40476 .24194 L
.43197 .24352 L
.45918 .2433 L
.48639 .24644 L
.51361 .24559 L
.54082 .24628 L
.56803 .24608 L
.59524 .24586 L
.62245 .24571 L
.64966 .24566 L
.67687 .24569 L
.70408 .24573 L
.73129 .24576 L
.7585 .24577 L
.78571 .24576 L
.81293 .24575 L
.84014 .24575 L
.86735 .24575 L
.89456 .24575 L
.92177 .24575 L
.94898 .24575 L
.97619 .24575 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.210916 0.65873 0.407118 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 -0.635911 0.470883 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02333 -18 -4.5 ]
[-0.0125 .02333 0 4.5 ]
[-0.0125 .1175 -18 -4.5 ]
[-0.0125 .1175 0 4.5 ]
[-0.0125 .21168 -18 -4.5 ]
[-0.0125 .21168 0 4.5 ]
[-0.0125 .30586 -6 -4.5 ]
[-0.0125 .30586 0 4.5 ]
[-0.0125 .40003 -18 -4.5 ]
[-0.0125 .40003 0 4.5 ]
[-0.0125 .49421 -18 -4.5 ]
[-0.0125 .49421 0 4.5 ]
[-0.0125 .58839 -18 -4.5 ]
[-0.0125 .58839 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .17234 -5 -6 ]
[.97619 .17234 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02333 m
.00625 .02333 L
s
[(1.4)] -0.0125 .02333 1 0 Mshowa
0 .1175 m
.00625 .1175 L
s
[(1.6)] -0.0125 .1175 1 0 Mshowa
0 .21168 m
.00625 .21168 L
s
[(1.8)] -0.0125 .21168 1 0 Mshowa
0 .30586 m
.00625 .30586 L
s
[(2)] -0.0125 .30586 1 0 Mshowa
0 .40003 m
.00625 .40003 L
s
[(2.2)] -0.0125 .40003 1 0 Mshowa
0 .49421 m
.00625 .49421 L
s
[(2.4)] -0.0125 .49421 1 0 Mshowa
0 .58839 m
.00625 .58839 L
s
[(2.6)] -0.0125 .58839 1 0 Mshowa
.125 Mabswid
0 .04687 m
.00375 .04687 L
s
0 .07041 m
.00375 .07041 L
s
0 .09396 m
.00375 .09396 L
s
0 .14105 m
.00375 .14105 L
s
0 .16459 m
.00375 .16459 L
s
0 .18813 m
.00375 .18813 L
s
0 .23522 m
.00375 .23522 L
s
0 .25877 m
.00375 .25877 L
s
0 .28231 m
.00375 .28231 L
s
0 .3294 m
.00375 .3294 L
s
0 .35294 m
.00375 .35294 L
s
0 .37649 m
.00375 .37649 L
s
0 .42358 m
.00375 .42358 L
s
0 .44712 m
.00375 .44712 L
s
0 .47066 m
.00375 .47066 L
s
0 .51775 m
.00375 .51775 L
s
0 .5413 m
.00375 .5413 L
s
0 .56484 m
.00375 .56484 L
s
0 .61193 m
.00375 .61193 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02333 m
1 .02333 L
s
.99375 .1175 m
1 .1175 L
s
.99375 .21168 m
1 .21168 L
s
.99375 .30586 m
1 .30586 L
s
.99375 .40003 m
1 .40003 L
s
.99375 .49421 m
1 .49421 L
s
.99375 .58839 m
1 .58839 L
s
.125 Mabswid
.99625 .04687 m
1 .04687 L
s
.99625 .07041 m
1 .07041 L
s
.99625 .09396 m
1 .09396 L
s
.99625 .14105 m
1 .14105 L
s
.99625 .16459 m
1 .16459 L
s
.99625 .18813 m
1 .18813 L
s
.99625 .23522 m
1 .23522 L
s
.99625 .25877 m
1 .25877 L
s
.99625 .28231 m
1 .28231 L
s
.99625 .3294 m
1 .3294 L
s
.99625 .35294 m
1 .35294 L
s
.99625 .37649 m
1 .37649 L
s
.99625 .42358 m
1 .42358 L
s
.99625 .44712 m
1 .44712 L
s
.99625 .47066 m
1 .47066 L
s
.99625 .51775 m
1 .51775 L
s
.99625 .5413 m
1 .5413 L
s
.99625 .56484 m
1 .56484 L
s
.99625 .61193 m
1 .61193 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
.541 .169 .886 r
gsave
.97619 .17234 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .30586 m
.05102 .01472 L
.07823 .60332 L
.10544 .45916 L
.13265 .44774 L
.15986 .34404 L
.18707 .19412 L
.21429 .35001 L
.2415 .31474 L
.26871 .2076 L
.29592 .1741 L
.32313 .17222 L
.35034 .16838 L
.37755 .16725 L
.40476 .167 L
.43197 .16751 L
.45918 .17071 L
.48639 .1713 L
.51361 .17319 L
.54082 .17268 L
.56803 .17268 L
.59524 .17237 L
.62245 .17231 L
.64966 .17227 L
.67687 .17229 L
.70408 .17232 L
.73129 .17234 L
.7585 .17235 L
.78571 .17235 L
.81293 .17234 L
.84014 .17233 L
.86735 .17233 L
.89456 .17233 L
.92177 .17233 L
.94898 .17234 L
.97619 .17234 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.210916 0.97619 0.407118 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 0.603319 1.52274 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .1465 -24 -4.5 ]
[-0.0125 .1465 0 4.5 ]
[-0.0125 .29877 -24 -4.5 ]
[-0.0125 .29877 0 4.5 ]
[-0.0125 .45104 -24 -4.5 ]
[-0.0125 .45104 0 4.5 ]
[-0.0125 .60332 -6 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .40244 -5 -6 ]
[.97619 .40244 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .1465 m
.00625 .1465 L
s
[(-0.3)] -0.0125 .1465 1 0 Mshowa
0 .29877 m
.00625 .29877 L
s
[(-0.2)] -0.0125 .29877 1 0 Mshowa
0 .45104 m
.00625 .45104 L
s
[(-0.1)] -0.0125 .45104 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(0)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .02468 m
.00375 .02468 L
s
0 .05513 m
.00375 .05513 L
s
0 .08559 m
.00375 .08559 L
s
0 .11604 m
.00375 .11604 L
s
0 .17695 m
.00375 .17695 L
s
0 .20741 m
.00375 .20741 L
s
0 .23786 m
.00375 .23786 L
s
0 .26832 m
.00375 .26832 L
s
0 .32923 m
.00375 .32923 L
s
0 .35968 m
.00375 .35968 L
s
0 .39014 m
.00375 .39014 L
s
0 .42059 m
.00375 .42059 L
s
0 .4815 m
.00375 .4815 L
s
0 .51195 m
.00375 .51195 L
s
0 .54241 m
.00375 .54241 L
s
0 .57286 m
.00375 .57286 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .1465 m
1 .1465 L
s
.99375 .29877 m
1 .29877 L
s
.99375 .45104 m
1 .45104 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .02468 m
1 .02468 L
s
.99625 .05513 m
1 .05513 L
s
.99625 .08559 m
1 .08559 L
s
.99625 .11604 m
1 .11604 L
s
.99625 .17695 m
1 .17695 L
s
.99625 .20741 m
1 .20741 L
s
.99625 .23786 m
1 .23786 L
s
.99625 .26832 m
1 .26832 L
s
.99625 .32923 m
1 .32923 L
s
.99625 .35968 m
1 .35968 L
s
.99625 .39014 m
1 .39014 L
s
.99625 .42059 m
1 .42059 L
s
.99625 .4815 m
1 .4815 L
s
.99625 .51195 m
1 .51195 L
s
.99625 .54241 m
1 .54241 L
s
.99625 .57286 m
1 .57286 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 .38 .01 r
gsave
.97619 .40244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .60332 m
.05102 .48848 L
.07823 .36964 L
.10544 .28313 L
.13265 .31759 L
.15986 .50904 L
.18707 .3599 L
.21429 .51651 L
.2415 .01472 L
.26871 .32149 L
.29592 .42799 L
.32313 .42301 L
.35034 .4021 L
.37755 .38509 L
.40476 .38618 L
.43197 .39431 L
.45918 .4047 L
.48639 .40694 L
.51361 .40407 L
.54082 .4021 L
.56803 .40102 L
.59524 .40158 L
.62245 .40234 L
.64966 .40273 L
.67687 .40275 L
.70408 .40258 L
.73129 .40242 L
.7585 .40237 L
.78571 .40238 L
.81293 .40243 L
.84014 .40245 L
.86735 .40246 L
.89456 .40245 L
.92177 .40245 L
.94898 .40244 L
.97619 .40244 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.407118 0.34127 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 -0.883679 0.00934442 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05076 -18 -4.5 ]
[-0.0125 .05076 0 4.5 ]
[-0.0125 .14421 -18 -4.5 ]
[-0.0125 .14421 0 4.5 ]
[-0.0125 .23765 -18 -4.5 ]
[-0.0125 .23765 0 4.5 ]
[-0.0125 .3311 -18 -4.5 ]
[-0.0125 .3311 0 4.5 ]
[-0.0125 .42454 -18 -4.5 ]
[-0.0125 .42454 0 4.5 ]
[-0.0125 .51798 -18 -4.5 ]
[-0.0125 .51798 0 4.5 ]
[-0.0125 .61143 -18 -4.5 ]
[-0.0125 .61143 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .60332 -5 -6 ]
[.97619 .60332 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05076 m
.00625 .05076 L
s
[(100)] -0.0125 .05076 1 0 Mshowa
0 .14421 m
.00625 .14421 L
s
[(110)] -0.0125 .14421 1 0 Mshowa
0 .23765 m
.00625 .23765 L
s
[(120)] -0.0125 .23765 1 0 Mshowa
0 .3311 m
.00625 .3311 L
s
[(130)] -0.0125 .3311 1 0 Mshowa
0 .42454 m
.00625 .42454 L
s
[(140)] -0.0125 .42454 1 0 Mshowa
0 .51798 m
.00625 .51798 L
s
[(150)] -0.0125 .51798 1 0 Mshowa
0 .61143 m
.00625 .61143 L
s
[(160)] -0.0125 .61143 1 0 Mshowa
.125 Mabswid
0 .06945 m
.00375 .06945 L
s
0 .08814 m
.00375 .08814 L
s
0 .10683 m
.00375 .10683 L
s
0 .12552 m
.00375 .12552 L
s
0 .1629 m
.00375 .1629 L
s
0 .18159 m
.00375 .18159 L
s
0 .20027 m
.00375 .20027 L
s
0 .21896 m
.00375 .21896 L
s
0 .25634 m
.00375 .25634 L
s
0 .27503 m
.00375 .27503 L
s
0 .29372 m
.00375 .29372 L
s
0 .31241 m
.00375 .31241 L
s
0 .34978 m
.00375 .34978 L
s
0 .36847 m
.00375 .36847 L
s
0 .38716 m
.00375 .38716 L
s
0 .40585 m
.00375 .40585 L
s
0 .44323 m
.00375 .44323 L
s
0 .46192 m
.00375 .46192 L
s
0 .48061 m
.00375 .48061 L
s
0 .4993 m
.00375 .4993 L
s
0 .53667 m
.00375 .53667 L
s
0 .55536 m
.00375 .55536 L
s
0 .57405 m
.00375 .57405 L
s
0 .59274 m
.00375 .59274 L
s
0 .03207 m
.00375 .03207 L
s
0 .01339 m
.00375 .01339 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05076 m
1 .05076 L
s
.99375 .14421 m
1 .14421 L
s
.99375 .23765 m
1 .23765 L
s
.99375 .3311 m
1 .3311 L
s
.99375 .42454 m
1 .42454 L
s
.99375 .51798 m
1 .51798 L
s
.99375 .61143 m
1 .61143 L
s
.125 Mabswid
.99625 .06945 m
1 .06945 L
s
.99625 .08814 m
1 .08814 L
s
.99625 .10683 m
1 .10683 L
s
.99625 .12552 m
1 .12552 L
s
.99625 .1629 m
1 .1629 L
s
.99625 .18159 m
1 .18159 L
s
.99625 .20027 m
1 .20027 L
s
.99625 .21896 m
1 .21896 L
s
.99625 .25634 m
1 .25634 L
s
.99625 .27503 m
1 .27503 L
s
.99625 .29372 m
1 .29372 L
s
.99625 .31241 m
1 .31241 L
s
.99625 .34978 m
1 .34978 L
s
.99625 .36847 m
1 .36847 L
s
.99625 .38716 m
1 .38716 L
s
.99625 .40585 m
1 .40585 L
s
.99625 .44323 m
1 .44323 L
s
.99625 .46192 m
1 .46192 L
s
.99625 .48061 m
1 .48061 L
s
.99625 .4993 m
1 .4993 L
s
.99625 .53667 m
1 .53667 L
s
.99625 .55536 m
1 .55536 L
s
.99625 .57405 m
1 .57405 L
s
.99625 .59274 m
1 .59274 L
s
.99625 .03207 m
1 .03207 L
s
.99625 .01339 m
1 .01339 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .01472 m
.05102 .424 L
.07823 .51471 L
.10544 .5374 L
.13265 .56178 L
.15986 .56354 L
.18707 .57607 L
.21429 .58958 L
.2415 .59133 L
.26871 .59885 L
.29592 .60221 L
.32313 .60272 L
.35034 .60279 L
.37755 .60288 L
.40476 .60296 L
.43197 .60307 L
.45918 .60319 L
.48639 .60327 L
.51361 .60329 L
.54082 .6033 L
.56803 .60331 L
.59524 .60331 L
.62245 .60332 L
.64966 .60332 L
.67687 .60332 L
.70408 .60332 L
.73129 .60332 L
.7585 .60332 L
.78571 .60332 L
.81293 .60332 L
.84014 .60332 L
.86735 .60332 L
.89456 .60332 L
.92177 .60332 L
.94898 .60332 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.407118 0.65873 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 2.70058 0.167615 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01874 -18 -4.5 ]
[-0.0125 .01874 0 4.5 ]
[-0.0125 .10255 -30 -4.5 ]
[-0.0125 .10255 0 4.5 ]
[-0.0125 .18636 -18 -4.5 ]
[-0.0125 .18636 0 4.5 ]
[-0.0125 .27016 -30 -4.5 ]
[-0.0125 .27016 0 4.5 ]
[-0.0125 .35397 -18 -4.5 ]
[-0.0125 .35397 0 4.5 ]
[-0.0125 .43778 -30 -4.5 ]
[-0.0125 .43778 0 4.5 ]
[-0.0125 .52159 -18 -4.5 ]
[-0.0125 .52159 0 4.5 ]
[-0.0125 .60539 -30 -4.5 ]
[-0.0125 .60539 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .59012 -5 -6 ]
[.97619 .59012 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01874 m
.00625 .01874 L
s
[(-16)] -0.0125 .01874 1 0 Mshowa
0 .10255 m
.00625 .10255 L
s
[(-15.5)] -0.0125 .10255 1 0 Mshowa
0 .18636 m
.00625 .18636 L
s
[(-15)] -0.0125 .18636 1 0 Mshowa
0 .27016 m
.00625 .27016 L
s
[(-14.5)] -0.0125 .27016 1 0 Mshowa
0 .35397 m
.00625 .35397 L
s
[(-14)] -0.0125 .35397 1 0 Mshowa
0 .43778 m
.00625 .43778 L
s
[(-13.5)] -0.0125 .43778 1 0 Mshowa
0 .52159 m
.00625 .52159 L
s
[(-13)] -0.0125 .52159 1 0 Mshowa
0 .60539 m
.00625 .60539 L
s
[(-12.5)] -0.0125 .60539 1 0 Mshowa
.125 Mabswid
0 .0355 m
.00375 .0355 L
s
0 .05226 m
.00375 .05226 L
s
0 .06903 m
.00375 .06903 L
s
0 .08579 m
.00375 .08579 L
s
0 .11931 m
.00375 .11931 L
s
0 .13607 m
.00375 .13607 L
s
0 .15283 m
.00375 .15283 L
s
0 .1696 m
.00375 .1696 L
s
0 .20312 m
.00375 .20312 L
s
0 .21988 m
.00375 .21988 L
s
0 .23664 m
.00375 .23664 L
s
0 .2534 m
.00375 .2534 L
s
0 .28693 m
.00375 .28693 L
s
0 .30369 m
.00375 .30369 L
s
0 .32045 m
.00375 .32045 L
s
0 .33721 m
.00375 .33721 L
s
0 .37073 m
.00375 .37073 L
s
0 .38749 m
.00375 .38749 L
s
0 .40426 m
.00375 .40426 L
s
0 .42102 m
.00375 .42102 L
s
0 .45454 m
.00375 .45454 L
s
0 .4713 m
.00375 .4713 L
s
0 .48806 m
.00375 .48806 L
s
0 .50482 m
.00375 .50482 L
s
0 .53835 m
.00375 .53835 L
s
0 .55511 m
.00375 .55511 L
s
0 .57187 m
.00375 .57187 L
s
0 .58863 m
.00375 .58863 L
s
0 .00198 m
.00375 .00198 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01874 m
1 .01874 L
s
.99375 .10255 m
1 .10255 L
s
.99375 .18636 m
1 .18636 L
s
.99375 .27016 m
1 .27016 L
s
.99375 .35397 m
1 .35397 L
s
.99375 .43778 m
1 .43778 L
s
.99375 .52159 m
1 .52159 L
s
.99375 .60539 m
1 .60539 L
s
.125 Mabswid
.99625 .0355 m
1 .0355 L
s
.99625 .05226 m
1 .05226 L
s
.99625 .06903 m
1 .06903 L
s
.99625 .08579 m
1 .08579 L
s
.99625 .11931 m
1 .11931 L
s
.99625 .13607 m
1 .13607 L
s
.99625 .15283 m
1 .15283 L
s
.99625 .1696 m
1 .1696 L
s
.99625 .20312 m
1 .20312 L
s
.99625 .21988 m
1 .21988 L
s
.99625 .23664 m
1 .23664 L
s
.99625 .2534 m
1 .2534 L
s
.99625 .28693 m
1 .28693 L
s
.99625 .30369 m
1 .30369 L
s
.99625 .32045 m
1 .32045 L
s
.99625 .33721 m
1 .33721 L
s
.99625 .37073 m
1 .37073 L
s
.99625 .38749 m
1 .38749 L
s
.99625 .40426 m
1 .40426 L
s
.99625 .42102 m
1 .42102 L
s
.99625 .45454 m
1 .45454 L
s
.99625 .4713 m
1 .4713 L
s
.99625 .48806 m
1 .48806 L
s
.99625 .50482 m
1 .50482 L
s
.99625 .53835 m
1 .53835 L
s
.99625 .55511 m
1 .55511 L
s
.99625 .57187 m
1 .57187 L
s
.99625 .58863 m
1 .58863 L
s
.99625 .00198 m
1 .00198 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .98 .604 r
gsave
.97619 .59012 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .01874 m
.05102 .01472 L
.07823 .0255 L
.10544 .04683 L
.13265 .06543 L
.15986 .08911 L
.18707 .13009 L
.21429 .27527 L
.2415 .31904 L
.26871 .41225 L
.29592 .54114 L
.32313 .59345 L
.35034 .59999 L
.37755 .60211 L
.40476 .60332 L
.43197 .60206 L
.45918 .59597 L
.48639 .59231 L
.51361 .5887 L
.54082 .58876 L
.56803 .58895 L
.59524 .58978 L
.62245 .59023 L
.64966 .59038 L
.67687 .59032 L
.70408 .59019 L
.73129 .5901 L
.7585 .59007 L
.78571 .59008 L
.81293 .59011 L
.84014 .59013 L
.86735 .59013 L
.89456 .59013 L
.92177 .59012 L
.94898 .59012 L
.97619 .59012 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.407118 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0272109 1.58394 0.333124 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -6 -9 ]
[.56803 -0.0125 6 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0016 -30 -4.5 ]
[-0.0125 .0016 0 4.5 ]
[-0.0125 .08488 -24 -4.5 ]
[-0.0125 .08488 0 4.5 ]
[-0.0125 .16816 -30 -4.5 ]
[-0.0125 .16816 0 4.5 ]
[-0.0125 .25144 -12 -4.5 ]
[-0.0125 .25144 0 4.5 ]
[-0.0125 .33473 -30 -4.5 ]
[-0.0125 .33473 0 4.5 ]
[-0.0125 .41801 -24 -4.5 ]
[-0.0125 .41801 0 4.5 ]
[-0.0125 .50129 -30 -4.5 ]
[-0.0125 .50129 0 4.5 ]
[-0.0125 .58457 -12 -4.5 ]
[-0.0125 .58457 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .52889 -5 -6 ]
[.97619 .52889 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(5)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(10)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(15)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(20)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(25)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(30)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(35)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0016 m
.00625 .0016 L
s
[(-4.75)] -0.0125 .0016 1 0 Mshowa
0 .08488 m
.00625 .08488 L
s
[(-4.5)] -0.0125 .08488 1 0 Mshowa
0 .16816 m
.00625 .16816 L
s
[(-4.25)] -0.0125 .16816 1 0 Mshowa
0 .25144 m
.00625 .25144 L
s
[(-4)] -0.0125 .25144 1 0 Mshowa
0 .33473 m
.00625 .33473 L
s
[(-3.75)] -0.0125 .33473 1 0 Mshowa
0 .41801 m
.00625 .41801 L
s
[(-3.5)] -0.0125 .41801 1 0 Mshowa
0 .50129 m
.00625 .50129 L
s
[(-3.25)] -0.0125 .50129 1 0 Mshowa
0 .58457 m
.00625 .58457 L
s
[(-3)] -0.0125 .58457 1 0 Mshowa
.125 Mabswid
0 .01826 m
.00375 .01826 L
s
0 .03491 m
.00375 .03491 L
s
0 .05157 m
.00375 .05157 L
s
0 .06823 m
.00375 .06823 L
s
0 .10154 m
.00375 .10154 L
s
0 .1182 m
.00375 .1182 L
s
0 .13485 m
.00375 .13485 L
s
0 .15151 m
.00375 .15151 L
s
0 .18482 m
.00375 .18482 L
s
0 .20148 m
.00375 .20148 L
s
0 .21813 m
.00375 .21813 L
s
0 .23479 m
.00375 .23479 L
s
0 .2681 m
.00375 .2681 L
s
0 .28476 m
.00375 .28476 L
s
0 .30141 m
.00375 .30141 L
s
0 .31807 m
.00375 .31807 L
s
0 .35138 m
.00375 .35138 L
s
0 .36804 m
.00375 .36804 L
s
0 .38469 m
.00375 .38469 L
s
0 .40135 m
.00375 .40135 L
s
0 .43466 m
.00375 .43466 L
s
0 .45132 m
.00375 .45132 L
s
0 .46798 m
.00375 .46798 L
s
0 .48463 m
.00375 .48463 L
s
0 .51794 m
.00375 .51794 L
s
0 .5346 m
.00375 .5346 L
s
0 .55126 m
.00375 .55126 L
s
0 .56791 m
.00375 .56791 L
s
0 .60122 m
.00375 .60122 L
s
0 .61788 m
.00375 .61788 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0016 m
1 .0016 L
s
.99375 .08488 m
1 .08488 L
s
.99375 .16816 m
1 .16816 L
s
.99375 .25144 m
1 .25144 L
s
.99375 .33473 m
1 .33473 L
s
.99375 .41801 m
1 .41801 L
s
.99375 .50129 m
1 .50129 L
s
.99375 .58457 m
1 .58457 L
s
.125 Mabswid
.99625 .01826 m
1 .01826 L
s
.99625 .03491 m
1 .03491 L
s
.99625 .05157 m
1 .05157 L
s
.99625 .06823 m
1 .06823 L
s
.99625 .10154 m
1 .10154 L
s
.99625 .1182 m
1 .1182 L
s
.99625 .13485 m
1 .13485 L
s
.99625 .15151 m
1 .15151 L
s
.99625 .18482 m
1 .18482 L
s
.99625 .20148 m
1 .20148 L
s
.99625 .21813 m
1 .21813 L
s
.99625 .23479 m
1 .23479 L
s
.99625 .2681 m
1 .2681 L
s
.99625 .28476 m
1 .28476 L
s
.99625 .30141 m
1 .30141 L
s
.99625 .31807 m
1 .31807 L
s
.99625 .35138 m
1 .35138 L
s
.99625 .36804 m
1 .36804 L
s
.99625 .38469 m
1 .38469 L
s
.99625 .40135 m
1 .40135 L
s
.99625 .43466 m
1 .43466 L
s
.99625 .45132 m
1 .45132 L
s
.99625 .46798 m
1 .46798 L
s
.99625 .48463 m
1 .48463 L
s
.99625 .51794 m
1 .51794 L
s
.99625 .5346 m
1 .5346 L
s
.99625 .55126 m
1 .55126 L
s
.99625 .56791 m
1 .56791 L
s
.99625 .60122 m
1 .60122 L
s
.99625 .61788 m
1 .61788 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .52889 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .25144 m
.05102 .2108 L
.07823 .27653 L
.10544 .07861 L
.13265 .01472 L
.15986 .0552 L
.18707 .60332 L
.21429 .264 L
.2415 .29605 L
.26871 .44489 L
.29592 .54635 L
.32313 .52714 L
.35034 .53379 L
.37755 .53612 L
.40476 .5365 L
.43197 .53524 L
.45918 .53103 L
.48639 .52966 L
.51361 .52791 L
.54082 .52842 L
.56803 .52856 L
.59524 .52887 L
.62245 .52894 L
.64966 .52896 L
.67687 .52894 L
.70408 .52891 L
.73129 .52889 L
.7585 .52888 L
.78571 .52888 L
.81293 .52889 L
.84014 .52889 L
.86735 .52889 L
.89456 .52889 L
.92177 .52889 L
.94898 .52889 L
.97619 .52889 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{539.5, 333.438},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008K0001CB000`400?l00000o`00003ooooooooo
oooooagooooo003ooo?clooolo?c7Ooclo<00?oolo?coooclo<Moo?cl`00oooclo?ooo?clagolo?c
003ooo?clooolo?c7Ooclo<00?oolo?coooclo<Moo?cl`00oooclo?ooo?clagolo?c003ooo?clooo
lo?c7Ooclo<00?oolo?coooclo<Moo?cl`00oooclo?ooo?clagolo?c003ooo?clooolo?c7Ooclo<0
02Wolo?c0_l0000@oo?cl`?o00003Ooclo<3o`0000Colo?c0_l0000;oo?cl`?o00000ooclo<3o`00
00Wolo?c1Ol00003oo?cl`;o00002_oclo<5o`0000;olo?c0ol0000:oo?cl`?o00001?oclo<2o`00
00[olo?c0ol00003oo?cl`?o00007_oclo<2o`00017olo?c0ol0000=oo?cl`?o00001?oclo<2o`00
00_olo?c0ol00003oo?cl`?o00002Ooclo<5o`0000?olo?c0_l00009oo?cl`Go00000_oclo<3o`00
00_olo?c0ol00004oo?cl`;o00002_oclo<3o`0000?olo?c0ol0002koo?cl`00:?oclo<01?l0003o
lo?coo?clol0000>oo?cl`05o`000?oclo?olo?coo?clol000003Ooclo<00ol0003olo?coo?cl`02
oo?cl`04o`000?oclo?olo?co`0000_olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`03o`00
0?oclo?olo?c00Oolo?c00Co0000oo?clooclo?o00000_oclo<01?l0003olo?coo?clol0000:oo?c
l`06o`000?oclo?olo?co`000?oclo?o00000ooclo<00ol0003olo?coo?cl`06oo?cl`05o`000?oc
lo?olo?coo?clol000000_oclo<01?l0003olo?coo?clol00008oo?cl`07o`000?oclo?olo?coo?c
lol0003olo?co`000003oo?cl`03o`000?oclo?olo?c01[olo?c00Co0000oo?clooclo?o00003ooc
lo<01Ol0003olo?coo?clooclo?o000000golo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?c
oo?clol0000;oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003olo?coo?cl`07oo?c
l`04o`000?oclo?olo?co`0000;olo?c00Co0000oo?clooclo?o00002Ooclo<01_l0003olo?coo?c
lol0003olo?co`0000?olo?c00?o0000oo?clooclo<01ooclo<01Ol0003olo?coo?clooclo?o0000
00;olo?c00Co0000oo?clooclo?o00002?oclo<01ol0003olo?coo?clooclo?o0000oo?clol00000
0ooclo<00ol0003olo?coo?cl`2hoo?cl`00:?oclo<01?l0003olo?coo?clol0000Boo?cl`03o`00
0?oclo?olo?c00_olo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000;oo?cl`03
o`000?oclo?olo?c00Golo?c00?o0000oo?clooclo<02?oclo<00ol0003olo?coo?cl`02oo?cl`04
o`000?oclo?olo?co`0000_olo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`0:oo?c
l`04o`000?oclo?olo?co`0000;olo?c00?o0000oo?clooclo<02_oclo<00ol0003olo?coo?cl`03
oo?cl`03o`000?oclo?olo?c01[olo?c00Co0000oo?clooclo?o00004ooclo<00ol0003olo?coo?c
l`0;oo?cl`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o00002ooclo<00ol0003olo?c
oo?cl`05oo?cl`03o`000?oclo?olo?c00Solo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?c
oo?clol0000:oo?cl`03o`000?oclo?olo?c00Golo?c00?o0000oo?clooclo<02ooclo<01?l0003o
lo?coo?clol00002oo?cl`03o`000?oclo?olo?c00[olo?c00?o0000oo?clooclo<00ooclo<00ol0
003olo?coo?cl`2hoo?cl`00:?oclo<01?l0003olo?coo?clol0000Boo?cl`03o`000?oclo?olo?c
00_olo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000;oo?cl`03o`000?oclo?o
lo?c00Golo?c00?o0000oo?clooclo<02Ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o
0000oo?clooclo<02_oclo<00ol0003olo?coo?cl`04oo?cl`03o`000?oclo?olo?c00Solo?c0_l0
0003oo?cl`04o`000?oclo?olo?co`0000[olo?c0_l00006oo?cl`03o`000?oclo?olo?c01[olo?c
00Co0000oo?clooclo?o00004ooclo<00ol0003olo?coo?cl`0;oo?cl`03o`000?oclo?olo?c00;o
lo?c00Co0000oo?clooclo?o00002ooclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c
00Wolo?c00Go0000oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?olo?c00Wolo?c00?o0000
oo?clooclo<01?oclo<00ol0003olo?coo?cl`09oo?cl`;o00000ooclo<01?l0003olo?coo?clol0
000:oo?cl`;o00001_oclo<00ol0003olo?coo?cl`0Qoo?cl`;o00004?oclo<3o`0000colo?c0ol0
0004oo?cl`;o00002_oclo<3o`0000?olo?c0ol00008oo?cl`Go00000ooclo<2o`0000Wolo?c1Ol0
0002oo?cl`?o00002Ooclo<3o`0000Colo?c0_l0000:oo?cl`?o00000ooclo<3o`00013olo?c000X
oo?cl`04o`000?oclo?olo?co`0000kolo?c1?l0000>oo?cl`03o`000?oclo?olo?c00;olo?c00Co
0000oo?clooclo?o00002ooclo<01?l0003olo?coo?clooclo<4o`0000Wolo?c00Go0000oo?clooc
lo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Ko0000oo?clooclo?olo?co`00
0?oclo<4o`0000golo?c00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?cl`0:oo?cl`03
o`000?oclo?o000000?o00007Ooclo<01?l0003olo?coo?clol0000?oo?cl`Co00003_oclo<00ol0
003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000_olo?c00Co0000oo?clooclo?olo?c1?l0
0009oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?clol00008oo?cl`06
o`000?oclo?olo?coo?clol0003olo?c1?l0000>oo?cl`04o`000?oclo?olo?co`0000;olo?c00?o
0000oo?clooclo<02_oclo<00ol0003olo?co`000003o`0002?olo?c00Co0000oo?clooclo?o0000
3_oclo<01Ol0003olo?coo?clooclo?o000000colo?c00?o0000oo?clooclo<00_oclo<01?l0003o
lo?coo?clol0000:oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003olo?coo?cl`06
oo?cl`04o`000?oclo?olo?co`0000;olo?c00Co0000oo?clooclo?o00002Ooclo<01_l0003olo?c
oo?clol0003olo?co`0000?olo?c00?o0000oo?clooclo<01Ooclo<01Ol0003olo?coo?clooclo?o
000000;olo?c00Co0000oo?clooclo?o00002?oclo<01ol0003olo?coo?clooclo?o0000oo?clol0
00000ooclo<00ol0003olo?coo?cl`0=oo?cl`00:?oclo<01?l0003olo?coo?clol0000>oo?cl`03
o`000?oclo?olo?c00kolo?c0_l00004oo?cl`04o`000?oclo?olo?co`0000[olo?c0_l00003oo?c
l`03o`000?oclo?olo?c00[olo?c00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?o
lo?co`0000Wolo?c00Oo0000oo?clooclo?olo?co`000?oclo?o000000colo?c00Go0000oo?clooc
lo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Solo?c00Oo0000oo?clooclo?olo?co`00
0?oclo?o0000023olo?c00Co0000oo?clooclo?o00003ooclo<00ol0003olo?coo?cl`0>oo?cl`;o
00001?oclo<01?l0003olo?coo?clol0000:oo?cl`;o00000ooclo<00ol0003olo?coo?cl`0:oo?c
l`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?clol00008oo?cl`07o`000?oc
lo?olo?coo?clol0003olo?co`00000=oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0
003olo?coo?clol00008oo?cl`07o`000?oclo?olo?coo?clol0003olo?co`00000Voo?cl`04o`00
0?oclo?olo?co`0001;olo?c00?o0000oo?clooclo<02_oclo<00ol0003olo?coo?cl`02oo?cl`04
o`000?oclo?olo?co`0000[olo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`07oo?c
l`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o00002_oclo<00ol0003olo?coo?cl`05
oo?cl`03o`000?oclo?olo?c00Wolo?c00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?c
l`0:oo?cl`03o`000?oclo?olo?c00?olo?c00?o0000oo?clooclo<03Ooclo<002Wolo?c0_l0000?
oo?cl`Go00003Ooclo<00ol0003olo?coo?cl`03oo?cl`;o00003?oclo<01?l0003olo?coo?clooc
lo<5o`0000Wolo?c0ol00004oo?cl`;o00002ooclo<3o`0000;olo?c1Ol00009oo?cl`?o00001?oc
lo<2o`0000[olo?c0ol00002oo?cl`Go00007Ooclo<2o`00013olo?c1Ol0000=oo?cl`03o`000?oc
lo?olo?c00?olo?c0_l0000<oo?cl`04o`000?oclo?olo?coo?cl`Go00002Ooclo<3o`0000Colo?c
0_l0000:oo?cl`?o00000_oclo<5o`0000[olo?c0ol00004oo?cl`;o00002_oclo<3o`0000;olo?c
1Ol0000Roo?cl`04o`000?oclo?olo?co`0001;olo?c00?o0000oo?clooclo<02_oclo<00ol0003o
lo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000[olo?c00?o0000oo?clooclo<01Ooclo<00ol0
003olo?coo?cl`08oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<00ol0003olo?coo?cl`09
oo?cl`03o`000?oclo?olo?c00Colo?c00?o0000oo?clooclo<01ooclo<2o`0000?olo?c00Co0000
oo?clooclo?o00002_oclo<2o`0000Kolo?c00?o0000oo?clooclo<03Ooclo<00?oolo?cQ?oclo<0
1?l0003olo?coo?clol0000>oo?cl`Co00003Ooclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oc
lo?olo?co`0000[olo?c00Co0000oo?clooclo?olo?c1?l00008oo?cl`05o`000?oclo?olo?coo?c
lol000000_oclo<01?l0003olo?coo?clol00008oo?cl`06o`000?oclo?olo?coo?clol0003olo?c
1?l0000<oo?cl`04o`000?oclo?olo?co`0000;olo?c00?o0000oo?clooclo<02_oclo<00ol0003o
lo?co`000003o`00013olo?c003ooo?clhColo?c00Co0000oo?clooclo?o00003_oclo<00ol0003o
lo?coo?cl`0=oo?cl`;o00001?oclo<01?l0003olo?coo?clol00009oo?cl`;o00000ooclo<00ol0
003olo?coo?cl`09oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?clol0
0008oo?cl`07o`000?oclo?olo?coo?clol0003olo?co`00000;oo?cl`05o`000?oclo?olo?coo?c
lol000000_oclo<01?l0003olo?coo?clol00008oo?cl`07o`000?oclo?olo?coo?clol0003olo?c
o`00000Coo?cl`00oooclo>5oo?cl`;o00003ooclo<5o`0000colo?c00?o0000oo?clooclo<00ooc
lo<2o`0000_olo?c00Co0000oo?clooclo?olo?c1Ol00008oo?cl`?o00001?oclo<2o`0000[olo?c
0ol00002oo?cl`Go00002?oclo<3o`0000Colo?c0_l0000:oo?cl`?o00000_oclo<5o`0000oolo?c
000Voo?cli3o00006ooclo>@o`000;[olo?c000Voo?cl`05o`000?oclo?olo?coo?clol000000ooc
lo<01?l0003olo?coo?clol00003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003o
lo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`04o`000?oclo?o
lo?co`0000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol0
00000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o00000ooclo<0
1Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`00
0?oclo?olo?coo?clol000000ooclo<01?l0003olo?coo?clol00003oo?cl`05o`000?oclo?olo?c
oo?clol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?c
o`000003oo?cl`04o`000?oclo?olo?co`0000?olo?c00Go0000oo?clooclo?olo?co`00000Koo?c
l`;o000000?olo?co`000?oclo<04_oclo<00ol0003olo?coo?cl`0@oo?cl`03o`000?oclo?olo?c
017olo?c00?o0000oo?clooclo<04?oclo<00ol0003olo?coo?cl`0@oo?cl`03o`000?oclo?olo?c
017olo?c00?o0000oo?clooclo<04?oclo<00ol0003olo?coo?cl`02o`000;[olo?c000Voo?cl`03
o`000?oclo?olo?c00colo?c00?oo`3ooo?clooclo<0OOoclo<00ol0003olo?coo?cl`0Ioo?cl`03
o`000?oclo?olo?c00Solo?c00?o0<kAoo?clooclo<0POoclo<00ol0003olo?coo?cl`2hoo?cl`00
9_oclo<2o`0000golo?c00?oo`3ooo?clooclo<0O?oclo<2o`0000Solo?c0ol00004oo?cl`03o`00
0?oclo?olo?c00;olo?c0ol00004oo?cl`;o00002Ooclo<00ol0c]7olo?coo?cl`20oo?cl`;o0000
8Ooclo>9o`00013olo?c000Voo?cl`03o`000?oclo?olo?c00colo?c0_oo0?mnoo?cl`03o`000?oc
lo?olo?c00Golo?c00Go0000oo?clooclo?olo?co`000007oo?cl`05o`000?oclo?olo?coo?clol0
00000ooclo<00ol0003olo?coo?cl`08oo?cl`03o`3>dOoclo?olo?c087olo?c00?o0000oo?clooc
lo<07ooclo<01?l0003olo?coo?clol0000Boo?cl`03o`000?oclo?olo?c00oolo?c00?o0000oo?c
looclo<04?oclo<00ol0003olo?coo?cl`0?oo?cl`03o`000?oclo?olo?c013olo?c00?o0000oo?c
looclo<03ooclo<00ol0003olo?coo?cl`0@oo?cl`04o`000?oclo?olo?co`00013olo?c000Voo?c
l`03o`000?oclo?olo?c00colo?c00?oo`3ooo?clooo0?l0OOoclo<00ol0003olo?co`000004o`00
00Golo?c00?o0000oo?clooclo<02Ooclo<01?l0003olo?coo?clooclo<2o`0000Wolo?c0_l0c]61
oo?cl`;o00008Ooclo<00ol0003olo?coo?cl`1moo?cl`Kofg2C0_oclo<00ol0003olo?coo?cl`0>
oo?cl`009_oclo<2o`0000golo?c00?oo`3ooo?clooo0?l0O?oclo<2o`0000_olo?c00?o0000oo?c
looclo<02Ooclo<01Ol0003olo?coo?clooclo?o000000Wolo?c00?o0<kAoo?clol0c]40P_oclo<0
0ol0003olo?coo?cl`0Ooo?cl`03o`000?oclo?olo?c07colo?c00?ofg2Coo?clooclo<01_oclo<0
0ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0003olo?coo?cl`0<oo?cl`04ool0oooclo?olo?c
ool0ogcolo?c00?o0000oo?clooclo<01Ooclo<4o`0000Solo?c1?l00004oo?cl`03o`000?oclo?o
lo?c00Oolo?c00?o0<kAoo?clol0c]40P_oclo<00ol0003olo?coo?cl`0Ooo?cl`03o`000?oclo?o
lo?c07_olo?c00?ofg2Coo?clooclo<01ooclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0
003olo?coo?cl`0;oo?cl`03ool0oooclo?olo?c00;olo?c00?oo`3ooo?clooclo<0NOoclo<00ol0
003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00Wolo?c00?o0000oo?clooclo<01Ooclo<2o`00
00Solo?c00Co0<kAoo?clooclo?o0<kAP?oclo<2o`00027olo?c00?o0000oo?clooclo<0NOoclo<2
om]`T`[olo?c00?o0000oo?clooclo<03_oclo<002Kolo?c00?o0000oo?clooclo<02ooclo<00ooo
0?oolo?coo?cl`02oo?cl`03ool0oooclo?olo?c07Wolo?c00?o0000oo?clooclo<01Ooclo<5o`00
00Oolo?c1Ol00003oo?cl`03o`000?oclo?olo?c00Oolo?c00Co0<kAoo?clooclo?o0<kAPOoclo<0
0ol0003olo?coo?cl`06oo?cl`?o00001?oclo<00ol0003olo?coo?cl`03oo?cl`03o`000?oclo?o
lo?c00;olo?c0ol00004oo?cl`03o`000?oclo?olo?c07Solo?c00?ofg2Coo?clooclo<02_oclo<0
0ol0003olo?coo?cl`0>oo?cl`009_oclo<2o`0000colo?c00?oo`3ooo?clooclo<00_oclo<00ooo
0?oolo?coo?cl`1hoo?cl`;o00006ooclo<2o`0000Solo?c00Co0<kAoo?clooclo?o0<kAP?oclo<2
o`0000Wolo?c00?o0000oo?clooclo<00ooclo<00ol0003olo?coo?cl`07oo?cl`05o`000?oclo?o
lo?coo?clol000000ooclo<00ol0003olo?coo?cl`1foo?cl`;ofg2C3Ooclo<00ol0003olo?coo?c
l`0>oo?cl`008?oclo<3o`0000?olo?c00?o0000oo?clooclo<02ooclo<00ooo0?oolo?coo?cl`02
oo?cl`03ool0oooclo?olo?c07Wolo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`07
oo?cl`05o`3>dOoclo?olo?coo?clol0c]40P?oclo<00ol0003olo?co`000004o`0000?olo?c00?o
0000oo?clooclo<01?oclo<00ol0003olo?coo?cl`0:oo?cl`05o`000?oclo?olo?coo?clol00000
Mooclo<00ooKL9?olo?coo?cl`0=oo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?cl`03o`000?oc
lo?olo?c00;olo?c00?o0000oo?clooclo<02ooclo<00ooo0?oolo?coo?cl`02oo?cl`03ool0oooc
lo?olo?c07Wolo?c00?o0000oo?clooclo<06Ooclo<2o`0000Solo?c00Go0<kAoo?clooclo?olo?c
o`3>d@1ooo?cl`;o00002Ooclo<00ol0003olo?coo?cl`04oo?cl`03o`000?oclo?olo?c00[olo?c
00Co0000oo?clooclo?olo?c0_l0001eoo?cl`03om]`Tooclo?olo?c00golo?c0_l0000@oo?cl`00
6Ooclo<5o`0000?olo?c00?o0000oo?clooclo<00_oclo<00ol0003olo?coo?cl`0;oo?cl`03ool0
oooclo?olo?c00;olo?c00?oo`3ooo?clooclo<0NOoclo<00ol0003olo?coo?cl`0Ioo?cl`03o`00
0?oclo?olo?c00Kolo?c00?o0<kAoo?clooclo<00_oclo<00ol0c]7olo?coo?cl`1noo?cl`03o`00
0?oclo?olo?c00Oolo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`05oo?cl`Co0000
1?oclo<00ol0003olo?coo?cl`1boo?cl`;ofg2C4Ooclo<00ol0003olo?coo?cl`0>oo?cl`008Ooc
lo<00ol0003olo?coo?cl`02oo?cl`;o00003?oclo<00ooo0?oolo?coo?cl`02oo?cl`03ool0oooc
lo?olo?c07Solo?c0_l0000Doo?cl`?o00001?oclo<00ol0003olo?coo?cl`06oo?cl`03o`3>dOoc
lo?olo?c00?olo?c00?o0<kAoo?clooclo<0OOoclo<00ol0003olo?coo?cl`06oo?cl`;o00000ooc
lo<01Ol0003olo?coo?clooclo?o000000Oolo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?c
oo?cl`1aoo?cl`03om]`Tooclo?olo?c017olo?c00?o0000oo?clooclo<03_oclo<0027olo?c00?o
0000oo?clooclo<00_oclo<00ol0003olo?coo?cl`0;oo?cl`03ool0oooclo?olo?c00;olo?c00?o
o`3ooo?clooclo<0NOoclo<00ol0003olo?coo?cl`0Aoo?cl`05o`000?oclo?olo?coo?clol00000
0ooclo<2o`0000Oolo?c00?o0<kAoo?clooclo<00ooclo<00ol0c]7olo?coo?cl`1loo?cl`;o0000
2Ooclo<01?l0003olo?coo?clooclo<5o`0000Oolo?c1Ol00003oo?cl`03o`000?oclo?olo?c073o
lo?c00?ofg2Coo?clooclo<04_oclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<2o`0000Colo?c
00?o0000oo?clooclo<02ooclo<00ooo0?oolo?coo?cl`02oo?cl`03ool0oooclo?olo?c07Wolo?c
00?o0000oo?clooclo<02ooclo<5o`0000Golo?c00Go0000oo?clooclo?olo?co`000008oo?cl`03
o`3>dOoclo?olo?c00?olo?c00?o0<kAoo?clooclo<0OOoclo<00ol0003olo?coo?cl`0Ooo?cl`03
o`000?oclo?olo?c06oolo?c00?ofg2Coo?clooclo<04ooclo<00ol0003olo?coo?cl`0>oo?cl`00
8Ooclo<00ol0003olo?coo?cl`02oo?cl`;o00003?oclo<00ooo0?oolo?coo?cl`02oo?cl`03ool0
oooclo?olo?c07Solo?c0_l0000Goo?cl`04o`000?oclo?olo?coo?cl`;o00001ooclo<00ol0c]7o
lo?coo?cl`04oo?cl`03o`3>dOoclo?olo?c07_olo?c0_l0000Qoo?cl`03o`000?oclo?olo?c06ko
lo?c00?ofg2Coo?clooclo<05?oclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0003olo?c
oo?cl`0:oo?cl`03ool0oooclo?olo?c00Colo?c00?oo`3ooo?clooclo<0N?oclo<00ol0003olo?c
oo?cl`0Aoo?cl`Co00001?oclo<00ol0003olo?coo?cl`06oo?cl`03o`3>dOoclo?olo?c00Golo?c
00?o0<kAoo?clooclo<0Nooclo<00ol0003olo?coo?cl`0Ooo?cl`03o`000?oclo?olo?c06golo?c
00?ofg2Coo?clooclo<05Ooclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0003olo?coo?c
l`0:oo?cl`03ool0oooclo?olo?c00Colo?c00?oo`3ooo?clooclo<0N?oclo<00ol0003olo?coo?c
l`0Aoo?cl`03o`000?oclo?olo?c00Golo?c0_l00006oo?cl`03o`3>dOoclo?olo?c00Kolo?c00?o
0<kAoo?clooclo<02ooclo<3o`3>dFcolo?c0_l0000Qoo?cl`03o`000?oclo?olo?c06colo?c00?o
fg2Coo?clooclo<05_oclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0003olo?coo?cl`0:
oo?cl`03ool0oooclo?olo?c00Colo?c00?oo`3ooo?clooclo<0N?oclo<00ol0003olo?coo?cl`0A
oo?cl`Go00000ooclo<00ol0003olo?coo?cl`05oo?cl`03o`3>dOoclo?olo?c00Oolo?c00?o0<kA
oo?clooclo<02_oclo<00ol0c]7olo?coo?cl`02o`3>dF_olo?c00?o0000oo?clooclo<07ooclo<0
0ol0003olo?coo?cl`1[oo?cl`03om]`Tooclo?olo?c01Oolo?c00?o0000oo?clooclo<03_oclo<0
02Kolo?c0_l0000;oo?cl`03ool0oooclo?olo?c00Colo?c00?oo`3ooo?clooclo<0Mooclo<2o`00
01_olo?c00?o0000oo?clooclo<01Ooclo<00ol0c]7olo?coo?cl`08oo?cl`03o`3>dOoclo?olo?c
00Solo?c00?o0<kAoo?clooclo<00ooclo<00ol0c]7olo?coo?cl`1Xoo?cl`03o`000?oclo?olo?c
01;olo?c0ol00003oo?cl`?o00001?oclo<00ol0003olo?coo?cl`1Zoo?cl`03om]`Tooclo?olo?c
01Solo?c00?o0000oo?clooclo<03_oclo<002Kolo?c00?o0000oo?clooclo<02_oclo<00ooo0?oo
lo?coo?cl`04oo?cl`03ool0oooclo?olo?c07Solo?c00?o0000oo?clooclo<06Ooclo<2o`0000Ko
lo?c00?o0<kAoo?clooclo<02?oclo<00ol0c]7olo?coo?cl`08oo?cl`03o`3>dOoclo?olo?c00Co
lo?c00?o0<kAoo?clooclo<04Ol0c]4:oo?cldWo0<kA0_oclo<2o`0001Golo?c00Go0000oo?clooc
lo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol00000Jooclo<00ooKL9?olo?coo?cl`0I
oo?cl`03o`000?oclo?olo?c00kolo?c000Voo?cl`03o`000?oclo?olo?c00[olo?c00?oo`3ooo?c
looclo<01?oclo<00ooo0?oolo?coo?cl`1hoo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?c
looclo<01Ooclo<00ol0c]7olo?coo?cl`09oo?cl`03o`3>dOoclo?olo?c00Kolo?c00?o0<kAoo?c
looclo<01_oclo<2o`3>dA7olo?c2_l0c]5<oo?cl`03o`000?oclo?olo?c00_olo?c1Ol00003oo?c
l`03o`000?oclo?olo?c00Golo?c00Co0000oo?clooclo?olo?c0_l0001Xoo?cl`;ofg2C6ooclo<2
o`00013olo?c000Voo?cl`;o00002ooclo<00ooo0?oolo?coo?cl`04oo?cl`03ool0oooclo?olo?c
07Oolo?c0_l0000Koo?cl`;o00001_oclo<00ol0c]7olo?coo?cl`0:oo?cl`03o`3>dOoclo?olo?c
00Colo?c00?o0<kAoo?clooclo<0Kooclo<2o`0001Golo?c00?o0000oo?clooclo<01Ooclo<01Ol0
003olo?coo?clooclo?o000006Solo?c00?ofg2Coo?clooclo<07?oclo<00ol0003olo?coo?cl`0>
oo?cl`009_oclo<00ol0003olo?coo?cl`0:oo?cl`03ool0oooclo?olo?c00Colo?c00?oo`3ooo?c
looclo<0N?oclo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c00Golo?c00?o0<kAoo?c
looclo<02_oclo<00ol0c]7olo?coo?cl`04oo?cl`03o`3>dOoclo?olo?c073olo?c00?o0000oo?c
looclo<04ooclo<01?l0003olo?coo?clooclo<4o`0000Colo?c00?o0000oo?clooclo<0IOoclo<0
0ooKL9?olo?coo?cl`0Moo?cl`03o`000?oclo?olo?c00kolo?c000Eoo?cl`;o00001?oclo<00ol0
003olo?coo?cl`02oo?cl`?o00000ooclo<00ol0003olo?coo?cl`0:oo?cl`03ool0oooclo?olo?c
00Colo?c00?oo`3ooo?clooclo<0N?oclo<00ol0003olo?coo?cl`07oo?cl`?o00000ooclo<00ol0
003olo?coo?cl`02oo?cl`?o00001?oclo<2o`0000Golo?c00?o0<kAoo?clooclo<03?oclo<00ol0
c]7olo?coo?cl`03o`3>dG;olo?c0_l0000Doo?cl`;o00000ooclo<00ol0003olo?coo?cl`05oo?c
l`03o`000?oclo?olo?c06?olo?c0_oKL9<Poo?cl`03o`000?oclo?olo?c00kolo?c000Doo?cl`04
o`000?oclo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?o
lo?c00[olo?c00?oo`3ooo?clooclo<01?oclo<00ooo0?oolo?coo?cl`1hoo?cl`03o`000?oclo?o
lo?c00Solo?c00?o0000oo?clooclo<01_oclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o
0000oo?clooclo<01?oclo<00ol0c]7olo?coo?cl`0=oo?cl`;o0<kAM_oclo<00ol0003olo?coo?c
l`0Coo?cl`04o`000?oclo?olo?coo?cl`Go00000ooclo<00ol0003olo?coo?cl`1Roo?cl`03om]`
Tooclo?olo?c023olo?c00?o0000oo?clooclo<03_oclo<000golo?c1Ol00002oo?cl`04o`000?oc
lo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000002oo?cl`;o00002ooclo<00ooo0?oo
lo?coo?cl`04oo?cl`03ool0oooclo?olo?c07Oolo?c0_l000000ooclo?o0000o`000003o`000003
oo?clol0003o000000?o00002ooclo<01?l0003olo?coo?clooclo<2o`0000Golo?c00?o0<kAoo?c
looclo<0Q?oclo<2o`00027olo?c00?o0000oo?clooclo<0HOoclo<00ooKL9?olo?coo?cl`0Qoo?c
l`03o`000?oclo?olo?c00kolo?c000Doo?cl`04o`000?oclo?olo?co`0000Solo?c0ol00003oo?c
l`03o`000?oclo?olo?c00Wolo?c00?oo`3ooo?clooclo<01Ooclo<00ooo0?oolo?coo?cl`1hoo?c
l`03o`000?oclo?olo?c00Golo?c00Co0000oo?clooclo?o00003?oclo<01Ol0003olo?coo?clooc
lo?o000000Kolo?c00?o0<kAoo?clooclo<0QOoclo<00ol0003olo?coo?cl`0Ooo?cl`03o`000?oc
lo?olo?c063olo?c00?ofg2Coo?clooclo<08_oclo<00ol0003olo?coo?cl`0>oo?cl`005?oclo<0
1?l0003olo?coo?clol00007oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<00ol0003olo?c
oo?cl`09oo?cl`03ool0oooclo?olo?c00Golo?c00?oo`3ooo?clooclo<02?oclo<00ooo0?oolo?c
oo?cl`1]oo?cl`03o`000?oclo?olo?c00Kolo?c00?o0000oo?clol000002?oclo<4o`0000Colo?c
00?o0000oo?clooclo<01?oclo<00ol0c]7olo?coo?cl`25oo?cl`03o`000?oclo?olo?c01oolo?c
00?o0000oo?clooclo<0Gooclo<00ooKL9?olo?coo?cl`0Soo?cl`03o`000?oclo?olo?c00kolo?c
000Doo?cl`04o`000?oclo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000002oo?cl`03
o`000?oclo?olo?c00Wolo?c00?oo`3ooo?clooclo<01Ooclo<00ooo0?oolo?coo?cl`08oo?cl`03
ool0oooclo?olo?c06golo?c00?o0000oo?clooclo<01ooclo<2o`0000Solo?c00?o0000oo?clooc
lo<01Ooclo<2o`0000Golo?c00?o0<kAoo?clooclo<0Q?oclo<2o`00027olo?c00?o0000oo?clooc
lo<0G_oclo<00ooKL9?olo?coo?cl`0Too?cl`03o`000?oclo?olo?c00kolo?c000Eoo?cl`;o0000
2Ooclo<3o`0000?olo?c0_l0000:oo?cl`03ool0oooclo?olo?c00Golo?c00?oo`3ooo?clooclo<0
2?oclo<2ool0ofgolo?c0_l0000:oo?cl`03o`000?oclo?olo?c00Kolo?c1Ol00003oo?cl`03o`00
0?oclo?olo?c00Colo?c00?o0<kAoo?clooclo<0QOoclo<00ol0003olo?coo?cl`0Ooo?cl`03o`00
0?oclo?olo?c05colo?c0_oKL9<Woo?cl`03o`000?oclo?olo?c00kolo?c000Voo?cl`03o`000?oc
lo?olo?c00Wolo?c00?oo`3ooo?clooclo<01Ooclo<00ooo0?oolo?coo?cl`07oo?cl`03ool0oooc
lo?oo`3o06kolo?c00?o0000oo?clooclo<06Ooclo<2o`0000Golo?c00?o0<kAoo?clooclo<0Q?oc
lo<2o`0000Solo?c0ol00002oo?cl`Go00000ooclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oc
lo<00ol0003olo?coo?cl`1Koo?cl`03om]`Tooclo?olo?c02Oolo?c00?o0000oo?clooclo<03_oc
lo<002Kolo?c00?o0000oo?clooclo<02Ooclo<00ooo0?oolo?coo?cl`05oo?cl`03ool0oooclo?o
lo?c00Oolo?c00?oo`3ooo?clooo0?l0K_oclo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?o
lo?c00Colo?c00?o0<kAoo?clooclo<0QOoclo<00ol0003olo?coo?cl`07oo?cl`03o`000?oclo?o
lo?c00;olo?c00Co0000oo?clooclo?o00001ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c
00?o0000oo?clooclo<0F_oclo<00ooKL9?olo?coo?cl`0Xoo?cl`03o`000?oclo?olo?c00kolo?c
000Voo?cl`;o00002_oclo<00ooo0?oolo?coo?cl`05oo?cl`03ool0oooclo?olo?c00Oolo?c00Co
o`3ooo?clooclo?oo`3oK?oclo<2o`0001_olo?c0_l00005oo?cl`03o`3>dOoclo?olo?c08Colo?c
0_l000000ooclo?o0000o`000003o`0000?olo?c00?o0000oo?clooclo<00ooclo<00ol0003olo?c
oo?cl`0;oo?cl`04o`000?oclo?olo?coo?cl`;o0000F_oclo<00ooKL9?olo?coo?cl`0Xoo?cl`;o
00004?oclo<002Kolo?c00?o0000oo?clooclo<02Ooclo<00ooo0?oolo?coo?cl`06oo?cl`03ool0
oooclo?olo?c00Golo?c00Goo`3ooo?clooclo?olo?cool0o`1]oo?cl`03o`000?oclo?olo?c01Wo
lo?c00?o0000oo?clooclo<00ooclo<00ol0c]7olo?coo?cl`26oo?cl`03o`000?oclo?olo?c00Oo
lo?c00?o0000oo?clooclo<01?oclo<00ol0003olo?coo?cl`0:oo?cl`05o`000?oclo?olo?coo?c
lol00000F_oclo<00ooKL9?olo?coo?cl`0Zoo?cl`03o`000?oclo?olo?c00kolo?c000Voo?cl`03
o`000?oclo?olo?c00Wolo?c00?oo`3ooo?clooclo<01_oclo<00ooo0?oolo?coo?cl`05oo?cl`03
ool0oooclo?olo?c00;olo?c00?oo`3ooo?clooclo<0J_oclo<00ol0003olo?coo?cl`0Coo?cl`?o
00000ooclo<00ol0003olo?coo?cl`03oo?cl`03o`3>dOoclo?olo?c08Kolo?c00?o0000oo?clooc
lo<01ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooclo<01Ooclo<4o`00
00Colo?c00?o0000oo?clooclo<0Eooclo<00ooKL9?olo?coo?cl`0[oo?cl`03o`000?oclo?olo?c
00kolo?c000Voo?cl`03o`000?oclo?olo?c00Wolo?c00?oo`3ooo?clooclo<01_oclo<00ooo0?oo
lo?coo?cl`05oo?cl`03ool0oooclo?olo?c00;olo?c00?oo`3ooo?clooclo<0J_oclo<00ol0003o
lo?coo?cl`0Doo?cl`03o`000?oclo?olo?c00;olo?c0_l00004oo?cl`03o`3>dOoclo?olo?c08Go
lo?c0_l00008oo?cl`;o00000ooclo<01Ol0003olo?coo?clooclo?o000000Oolo?c00?o0000oo?c
looclo<01Ooclo<00ol0003olo?coo?cl`1Foo?cl`03om]`Tooclo?olo?c02colo?c00?o0000oo?c
looclo<03_oclo<002Kolo?c0_l00009oo?cl`03ool0oooclo?olo?c00Oolo?c00?oo`3ooo?clooc
lo<01?oclo<00ooo0?oolo?coo?cl`03oo?cl`03ool0oooclo?olo?c06Wolo?c0_l0000=oo?cl`Go
000000?olo?co`000?l000000ol00003oo?cl`03o`000?oclo?olo?c00?olo?c00?o0<kAoo?clooc
lo<0Q_oclo<00ol0003olo?coo?cl`07oo?cl`03o`000?oclo?olo?c00;olo?c0ol00008oo?cl`Go
00000ooclo<00ol0003olo?coo?cl`1Doo?cl`;ofg2C;ooclo<00ol0003olo?coo?cl`0>oo?cl`00
5Ooclo<2o`0000Colo?c00?o0000oo?clooclo<00_oclo<3o`0000?olo?c00?o0000oo?clooclo<0
2?oclo<00ooo0?oolo?coo?cl`07oo?cl`03ool0oooclo?olo?c00Colo?c00?oo`3ooo?clooclo<0
1?oclo<00ooo0?oolo?coo?cl`1Yoo?cl`03o`000?oclo?olo?c017olo?c00Co0000oo?clooclo?o
00001?oclo<2o`0000Colo?c00?o0<kAoo?clooclo<0QOoclo<2o`00027olo?c00?o0000oo?clooc
lo<0Dooclo<00ooKL9?olo?coo?cl`0_oo?cl`03o`000?oclo?olo?c00kolo?c000Doo?cl`04o`00
0?oclo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?olo?c
00Solo?c00?oo`3ooo?clooclo<01ooclo<00ooo0?oolo?coo?cl`04oo?cl`03ool0oooclo?olo?c
00Colo?c00?oo`3ooo?clooclo<0JOoclo<00ol0003olo?coo?cl`0Boo?cl`03o`000?oclo?o0000
00Colo?c00?o0000oo?clooclo<00ooclo<00ol0c]7olo?coo?cl`26oo?cl`03o`000?oclo?olo?c
01oolo?c00?o0000oo?clooclo<0DOoclo<2om]`Tc;olo?c00?o0000oo?clooclo<03_oclo<000go
lo?c1Ol00002oo?cl`04o`000?oclo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000002
oo?cl`;o00002Ooclo<00ooo0?oolo?coo?cl`07oo?cl`03ool0oooclo?olo?c00?olo?c00?oo`3o
oo?clooclo<01Ooclo<00ooo0?oolo?coo?cl`1Xoo?cl`;o00005Ooclo<2o`0000Colo?c0_l00004
oo?cl`03o`3>dOoclo?olo?c08Golo?c0_l0000Qoo?cl`03o`000?oclo?olo?c053olo?c00?ofg2C
oo?clooclo<0<_oclo<00ol0003olo?coo?cl`0>oo?cl`005?oclo<01?l0003olo?coo?clol00007
oo?cl`Co00000ooclo<00ol0003olo?coo?cl`08oo?cl`03ool0oooclo?olo?c00Oolo?c00?oo`3o
oo?clooclo<00ooclo<00ooo0?oolo?coo?cl`06oo?cl`03ool0oooclo?olo?c06Solo?c00?o0000
oo?clooclo<05?oclo<00ol0003olo?coo?cl`02oo?cl`03o`000?oclo?olo?c00?olo?c00?o0<kA
oo?clooclo<0Q_oclo<00ol0003olo?coo?cl`0Ooo?cl`03o`000?oclo?olo?c04oolo?c00?ofg2C
oo?clooclo<0<ooclo<00ol0003olo?coo?cl`0>oo?cl`005?oclo<01?l0003olo?coo?clol00007
oo?cl`03o`000?oclo?olo?c00Colo?c00?o0000oo?clooclo<02?oclo<00ooo0?oolo?coo?cl`07
oo?cl`03ool0oooclo?olo?c00?olo?c00?oo`3ooo?clooclo<01_oclo<00ooo0?oolo?coo?cl`1X
oo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<00ooclo<00ol0c]7olo?coo?cl`26
oo?cl`03o`000?oclo?olo?c01oolo?c00?o0000oo?clooclo<0C_oclo<00ooKL9?olo?coo?cl`0d
oo?cl`03o`000?oclo?olo?c00kolo?c000Doo?cl`04o`000?oclo?olo?co`0000Solo?c00?o0000
oo?clooclo<00ooclo<00ol0003olo?coo?cl`08oo?cl`03ool0oooclo?olo?c00Oolo?c00?oo`3o
oo?clooclo<00ooclo<00ooo0?oolo?coo?cl`06oo?cl`03ool0oooclo?olo?c00Kolo?c2?oo0?l7
oo?cle3oo`3o0ooclo<00ol0003olo?coo?cl`0Ioo?cl`;o00001?oclo<00ol0c]7olo?coo?cl`25
oo?cl`;o00005?oclo<3o`0000Colo?c0_l00004oo?cl`03o`000?oclo?olo?c04golo?c00?ofg2C
oo?clooclo<0=Ooclo<00ol0003olo?coo?cl`0>oo?cl`005Ooclo<2o`0000[olo?c0_l00003oo?c
l`;o00002Ooclo<00ooo0?oolo?coo?cl`07oo?cl`03ool0oooclo?olo?c00?olo?c00?oo`3ooo?c
looclo<01_oclo<00ooo0?oolo?coo?cl`04oo?cl`;oo`3o2?oclo<7ool0oe;olo?c0_l0000Koo?c
l`03o`000?oclo?olo?c00?olo?c00?o0<kAoo?clooclo<0Q_oclo<00ol0003olo?coo?cl`0Coo?c
l`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o00000ooclo<00ol0003olo?coo?cl`1<
oo?cl`03om]`Tooclo?olo?c03Kolo?c00?o0000oo?clooclo<03_oclo<002Kolo?c00?o0000oo?c
looclo<02?oclo<00ooo0?oolo?coo?cl`07oo?cl`03ool0oooclo?olo?c00?olo?c00?oo`3ooo?c
looclo<01ooclo<00ooo0?oolo?coo?cl`02oo?cl`03ool0oooclo?olo?c06;olo?c00?o0000oo?c
looclo<06Ooclo<2o`0000Colo?c00?o0<kAoo?clooclo<0QOoclo<2o`0000golo?c1Ol00003oo?c
l`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o00000ooclo<2o`0004colo?c00?ofg2C
oo?clooclo<0=_oclo<2o`00013olo?c000Voo?cl`03o`000?oclo?olo?c00Oolo?c00?oo`3ooo?c
looclo<02?oclo<00ooo0?oolo?coo?cl`03oo?cl`03ool0oooclo?olo?c00Oolo?c00?oo`3ooo?c
looclo<00_oclo<00ooo0?oolo?coo?cl`1Roo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?c
looclo<00ooclo<00ol0c]7olo?coo?cl`26oo?cl`03o`000?oclo?olo?c01?olo?c00?o0000oo?c
looclo<00_oclo<01?l0003olo?coo?clol00003oo?cl`03o`000?oclo?olo?c04[olo?c00?ofg2C
oo?clooclo<0>?oclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0003olo?coo?cl`07oo?c
l`03ool0oooclo?olo?c00Solo?c00?oo`3ooo?clooclo<00_oclo<00ooo0?oolo?coo?cl`08oo?c
l`05ool0oooclo?olo?coo?clooo0?l0IOoclo<00ol0003olo?coo?cl`06oo?cl`?o00001?oclo<0
0ol0003olo?coo?cl`02oo?cl`?o00001?oclo<2o`0000Colo?c00?o0<kAoo?clooclo<0QOoclo<2
o`0001Golo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol00003oo?cl`03o`000?oc
lo?olo?c04Wolo?c00?ofg2Coo?clooclo<0>Ooclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<2
o`0000Solo?c00?oo`3ooo?clooclo<02?oclo<00ooo0?oolo?coo?cl`02oo?cl`03ool0oooclo?o
lo?c00Wolo?c00Coo`3ooo?clooclo?oo`3oI?oclo<2o`0000Oolo?c00Go0000oo?clooclo?olo?c
o`000007oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003olo?coo?cl`03oo?cl`03
o`3>dOoclo?olo?c08Kolo?c00?o0000oo?clooclo<04_oclo<2o`0000Colo?c00Co0000oo?clooc
lo?o00000ooclo<00ol0003olo?coo?cl`18oo?cl`03om]`Tooclo?olo?c03[olo?c00?o0000oo?c
looclo<03_oclo<002Kolo?c00?o0000oo?clooclo<01ooclo<00ooo0?oolo?coo?cl`08oo?cl`03
ool0oooclo?olo?c00;olo?c00?oo`3ooo?clooclo<02Ooclo<01?oo0?oolo?coo?clooo0?mUoo?c
l`03o`000?oclo?o000000Co00001Ooclo<00ol0003olo?coo?cl`09oo?cl`04o`000?oclo?olo?c
oo?cl`;o00000ooclo<00ol0c]7olo?coo?cl`26oo?cl`;o00005Ooclo<00ol0003olo?coo?cl`03
oo?cl`;o00001?oclo<00ol0003olo?coo?cl`16oo?cl`;ofg2C?Ooclo<00ol0003olo?coo?cl`0>
oo?cl`009_oclo<00ol0003olo?coo?cl`07oo?cl`03ool0oooclo?olo?c00Solo?c00?oo`3ooo?c
looclo<00_oclo<00ooo0?oolo?coo?cl`09oo?cl`03ool0oooclo?oo`3o06Kolo?c00?o0000oo?c
looclo<01ooclo<2o`0000colo?c00Go0000oo?clooclo?olo?co`000004oo?cl`03o`3>dOoclo?o
lo?c08Oolo?c00?o0000oo?clooclo<07ooclo<00ol0003olo?coo?cl`14oo?cl`;ofg2C?ooclo<0
0ol0003olo?coo?cl`0>oo?cl`009_oclo<2o`0000Solo?c00?oo`3ooo?clooclo<02?oclo<00ooo
0?oolo?coo?cl`02oo?cl`03ool0oooclo?olo?c00Wolo?c00?oo`3ooo?clooo0?l0IOoclo<2o`00
00_olo?c00?o0000oo?clooclo<01Ooclo<4o`0000Colo?c00?o0000oo?clooclo<00_oclo<00ol0
c]7olo?coo?cl`27oo?cl`03o`000?oclo?olo?c01oolo?c00?o0000oo?clooclo<0@_oclo<2om]`
Td7olo?c00?o0000oo?clooclo<03_oclo<001Golo?c0_l00004oo?cl`03o`000?oclo?olo?c00?o
lo?c0ol00002oo?cl`03o`000?oclo?olo?c00Oolo?c00?oo`3ooo?clooclo<02?oclo<00ooo0?oo
lo?coo?cl`02oo?cl`03ool0oooclo?olo?c00[olo?c0_oo0?mVoo?cl`03o`000?oclo?olo?c00Go
lo?c00Go0000oo?clooclo?olo?co`000007oo?cl`03o`000?oclo?olo?c00Golo?c0_l00003oo?c
l`03o`3>dOoclo?olo?c08Kolo?c0_l0000Qoo?cl`03o`000?oclo?olo?c047olo?c00?ofg2Coo?c
looclo<0@Ooclo<00ol0003olo?coo?cl`0>oo?cl`005?oclo<01?l0003olo?coo?clol0000:oo?c
l`05o`000?oclo?olo?coo?clol000002?oclo<00ooo0?oolo?coo?cl`0:oo?cl`05ool0oooclo?o
lo?coo?clooo0?l03?oclo<00ooo0?oolo?coo?cl`1Uoo?cl`03o`000?oclo?olo?c00Kolo?c0ol0
0008oo?cl`Go00000ooclo<00ol0003olo?coo?cl`02oo?cl`03o`3>dOoclo?olo?c08Oolo?c00?o
0000oo?clooclo<07ooclo<00ol0003olo?coo?cl`10oo?cl`03om]`Tooclo?olo?c04;olo?c00?o
0000oo?clooclo<03_oclo<000golo?c1Ol00002oo?cl`04o`000?oclo?olo?co`0000Oolo?c1Ol0
0002oo?cl`03o`000?oclo?olo?c00Kolo?c00?oo`3ooo?clooclo<02_oclo<01Ooo0?oolo?coo?c
looclo?oo`3o07Colo?c00?o0000oo?clooclo<06Ooclo<2o`0000?olo?c00?o0<kAoo?clooclo<0
Q_oclo<2o`00027olo?c00?o0000oo?clooclo<0?ooclo<00ooKL9?olo?coo?cl`13oo?cl`03o`00
0?oclo?olo?c00kolo?c000Doo?cl`04o`000?oclo?olo?co`0000Oolo?c00Co0000oo?clooclo?o
00000ooclo<2o`0000Oolo?c00?oo`3ooo?clooclo<02_oclo<01Ooo0?oolo?coo?clooclo?oo`3o
07?olo?c0_l0000Koo?cl`03o`000?oclo?olo?c00;olo?c00?o0<kAoo?clooclo<0Qooclo<00ol0
003olo?coo?cl`0=oo?cl`03o`000?oclo?olo?c00?olo?c00?o0000oo?clooclo<00_oclo<3o`00
00Colo?c00?o0000oo?clooclo<0?_oclo<00ooKL9?olo?coo?cl`14oo?cl`03o`000?oclo?olo?c
00kolo?c000Doo?cl`04o`000?oclo?olo?co`0000Solo?c00?o0000oo?clol000000ooclo<00ol0
003olo?coo?cl`06oo?cl`03ool0oooclo?olo?c00[olo?c00Coo`3ooo?clooclo?oo`3oMOoclo<0
0ol0003olo?coo?cl`0Ioo?cl`;o00000ooclo<00ol0c]7olo?coo?cl`26oo?cl`;o00003ooclo<0
0ol0003olo?coo?cl`07oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003olo?coo?c
l`0moo?cl`03om]`Tooclo?olo?c04Golo?c00?o0000oo?clooclo<03_oclo<001Colo?c00Co0000
oo?clooclo?o00002Ooclo<2o`0000?olo?c00?o0000oo?clooclo<01_oclo<00ooo0?oolo?coo?c
l`0:oo?cl`04ool0oooclo?olo?cool0ogGolo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?c
oo?cl`02oo?cl`03o`3>dOoclo?olo?c08Oolo?c00?o0000oo?clooclo<01Ooclo<5o`0000Colo?c
00?o0000oo?clooclo<02_oclo<01?l0003olo?coo?clooclo<2o`0003golo?c00?ofg2Coo?clooc
lo<0AOoclo<2o`00013olo?c000Eoo?cl`;o00002ooclo<01Ol0003olo?coo?clooclo?o000000So
lo?c00?oo`3ooo?clooclo<02_oclo<01?oo0?oolo?coo?clooo0?meoo?cl`03o`000?oclo?olo?c
01;olo?c0ol00004oo?cl`03o`000?oclo?olo?c00;olo?c00?o0<kAoo?clooclo<0Qooclo<00ol0
003olo?coo?cl`0>oo?cl`03o`000?oclo?olo?c00[olo?c00Go0000oo?clooclo?olo?co`00000m
oo?cl`03om]`Tooclo?olo?c04Oolo?c00?o0000oo?clooclo<03_oclo<002Kolo?c0_l00007oo?c
l`03ool0oooclo?olo?c00[olo?c00Coo`3ooo?clooclo?oo`3oM?oclo<2o`0001?olo?c00Go0000
oo?clooclo?olo?co`000003oo?cl`;o00000ooclo<00ol0c]7olo?coo?cl`26oo?cl`;o00004Ooc
lo<00ol0003olo?coo?cl`05oo?cl`Co00001?oclo<00ol0003olo?coo?cl`0joo?cl`03om]`Tooc
lo?olo?c04Solo?c00?o0000oo?clooclo<03_oclo<002Kolo?c00?o0000oo?clooclo<01_oclo<0
0ooo0?oolo?coo?cl`0:oo?cl`04ool0oooclo?olo?cool0ogGolo?c00?o0000oo?clooclo<02ooc
lo<5o`0000Golo?c00Go0000oo?clooclo?olo?co`000004oo?cl`03o`3>dOoclo?olo?c08Oolo?c
00?o0000oo?clooclo<02ooclo<01Ol0003olo?coo?clooclo?o000000Oolo?c00?o0000oo?clooc
lo<01Ooclo<00ol0003olo?coo?cl`0ioo?cl`03om]`Tooclo?olo?c04Wolo?c00?o0000oo?clooc
lo<03_oclo<002Kolo?c00?o0000oo?clooclo<01Ooclo<00ooo0?oolo?coo?cl`0;oo?cl`04ool0
oooclo?olo?cool0ogGolo?c00?o0000oo?clooclo<04ooclo<2o`0000Colo?c0_l00003oo?cl`03
o`3>dOoclo?olo?c08Kolo?c0_l0000=oo?cl`Go00001ooclo<5o`0000?olo?c00?o0000oo?clooc
lo<0=ooclo<2om]`Tdcolo?c00?o0000oo?clooclo<03_oclo<002Kolo?c0_l00006oo?cl`03ool0
oooclo?olo?c00_olo?c00Coo`3ooo?clooclo?oo`3oM?oclo<2o`0001Oolo?c00Go0000oo?clooc
lo?olo?co`000004oo?cl`03o`3>dOoclo?olo?c08Oolo?c00?o0000oo?clooclo<07ooclo<00ol0
003olo?coo?cl`0eoo?cl`;ofg2CC_oclo<00ol0003olo?coo?cl`0>oo?cl`009_oclo<00ol0003o
lo?coo?cl`05oo?cl`03ool0oooclo?olo?c00_olo?c00Coo`3ooo?clooclo?oo`3oMOoclo<00ol0
003olo?coo?cl`0Aoo?cl`05o`000?oclo?olo?coo?clol000000ooclo<2o`0000;olo?c00?o0<kA
oo?clooclo<0Qooclo<2o`00027olo?c00?o0000oo?clooclo<0<_oclo<3om]`Te3olo?c00?o0000
oo?clooclo<03_oclo<002Kolo?c00?o0000oo?clooclo<01Ooclo<00ooo0?oolo?coo?cl`0;oo?c
l`04ool0oooclo?olo?cool0ogGolo?c00?o0000oo?clooclo<04_oclo<3o`0000Colo?c00Go0000
oo?clooclo?olo?co`3>d@2:oo?cl`03o`000?oclo?olo?c01oolo?c00?o0000oo?clooclo<0;ooc
lo<3om]`Te?olo?c00?o0000oo?clooclo<03_oclo<002Kolo?c00?o0000oo?clooclo<01Ooclo<0
0ooo0?oolo?coo?cl`0;oo?cl`04ool0oooclo?olo?cool0ogGolo?c00?o0000oo?clooclo<06Ooc
lo<2o`0000;olo?c00?o0<kAoo?clooclo<0Qooclo<2o`00027olo?c00?o0000oo?clooclo<0:ooc
lo<4om]`TeKolo?c00?o0000oo?clooclo<03_oclo<002Kolo?c0_l00006oo?cl`03ool0oooclo?o
lo?c00_olo?c00?oo`3ooo?clooo0?l0MOoclo<2o`0001_olo?c00Go0000oo?clooclo?olo?co`3>
d@2:oo?cl`03o`000?oclo?olo?c01Solo?c0ol00004oo?cl`03o`000?oclo?olo?c02Colo?c1ooK
L9=Joo?cl`03o`000?oclo?olo?c00kolo?c000Eoo?cl`;o00001?oclo<01?l0003olo?coo?clooc
lo<5o`0000;olo?c00?o0000oo?clooclo<01?oclo<00ooo0?oolo?coo?cl`0<oo?cl`03ool0oooc
lo?oo`3o07Kolo?c00?o0000oo?clooclo<06Ooclo<01Ol0003olo?coo?clooclo?o0<kA08[olo?c
00?o0000oo?clooclo<05ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooc
lo<08_oclo<2om]`Tf7olo?c00?o0000oo?clooclo<03_oclo<001Colo?c00Co0000oo?clooclo?o
00002?oclo<01?l0003olo?coo?clol00002oo?cl`03o`000?oclo?olo?c00Colo?c00?oo`3ooo?c
looclo<03?oclo<00ooo0?oolo?cool0o`1foo?cl`03o`000?oclo?olo?c01Wolo?c0_l00002oo?c
l`03o`3>dOoclo?olo?c08Oolo?c0_l0000Coo?cl`Go00001Ooclo<01Ol0003olo?coo?clooclo?o
000002;olo?c0_oKL9=Soo?cl`03o`000?oclo?olo?c00kolo?c000=oo?cl`Go00000_oclo<01?l0
003olo?coo?clol00009oo?cl`03o`000?oclo?olo?c00;olo?c0_l00005oo?cl`03ool0oooclo?o
lo?c00colo?c00?oo`3ooo?clooo0?l0MOoclo<2o`0001_olo?c00Go0000oo?clooclo?olo?co`3>
d@2:oo?cl`03o`000?oclo?olo?c01_olo?c00Co0000oo?clooclo?olo?c0_l0000Poo?cl`03om]`
Tooclo?olo?c06;olo?c0_l0000@oo?cl`005?oclo<01?l0003olo?coo?clol0000:oo?cl`05o`00
0?oclo?olo?coo?clol000001_oclo<00ooo0?oolo?coo?cl`0<oo?cl`03ool0oooclo?oo`3o07Ko
lo?c00?o0000oo?clooclo<01Ooclo<5o`0000?olo?c00?o0000oo?clooclo<00_oclo<3o`0000Co
lo?c0_l00002oo?cl`03o`3>dOoclo?olo?c08Oolo?c0_l0000Ioo?cl`Co00001?oclo<00ol0003o
lo?coo?cl`0Eoo?cl`Cofg2C0ooclo<3om]`TfKolo?c00?o0000oo?clooclo<03_oclo<001Colo?c
00Co0000oo?clooclo?o00001ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o0000oo?c
looclo<01?oclo<00ooo0?oolo?coo?cl`0=oo?cl`;oo`3oM_oclo<00ol0003olo?coo?cl`06oo?c
l`04o`000?oclo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oc
lo?olo?coo?clol0c]40R_oclo<00ol0003olo?coo?cl`0Goo?cl`03o`000?oclo?olo?c00Golo?c
00?o0000oo?clooclo<05?oclo<00ooKL9?olo?coo?cl`02oo?cl`?ofg2CJOoclo<00ol0003olo?c
oo?cl`0>oo?cl`005?oclo<01?l0003olo?coo?clol00007oo?cl`05o`000?oclo?olo?coo?clol0
00000_oclo<00ol0003olo?coo?cl`03oo?cl`03ool0oooclo?olo?c00kolo?c0_oo0?mfoo?cl`03
o`000?oclo?o000000Co00000ooclo<00ol0003olo?coo?cl`0;oo?cl`04o`000?oclo?olo?coo?c
l`;o00000_oclo<00ol0c]7olo?coo?cl`27oo?cl`;o00006Ooclo<5o`0000?olo?c00?o0000oo?c
looclo<04_oclo<2om]`Tg7olo?c00?o0000oo?clooclo<03_oclo<001Golo?c0_l00009oo?cl`?o
00000ooclo<2o`0000Colo?c00?oo`3ooo?clooclo<03_oclo<2ool0ogGolo?c0_l0000:oo?cl`03
o`000?oclo?olo?c00[olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`03o`3>dOoclo?olo?c
08Solo?c00?o0000oo?clooclo<07ooclo<00ol0003olo?coo?cl`0Aoo?cl`03om]`Tooclo?olo?c
077olo?c00?o0000oo?clooclo<03_oclo<002Kolo?c00?o0000oo?clooclo<00ooclo<00ooo0?oo
lo?coo?cl`0>oo?cl`;oo`3oM_oclo<00ol0003olo?coo?cl`05oo?cl`05o`000?oclo?olo?coo?c
lol000001ooclo<4o`0000Colo?c00Go0000oo?clooclo?olo?co`3>d@2:oo?cl`03o`000?oclo?o
lo?c01oolo?c00?o0000oo?clooclo<04?oclo<00ooKL9?olo?coo?cl`1boo?cl`03o`000?oclo?o
lo?c00kolo?c000Voo?cl`03o`000?oclo?olo?c00?olo?c00?oo`3ooo?clooclo<03_oclo<00ooo
0?oolo?coo?cl`1eoo?cl`03o`000?oclo?olo?c00Golo?c00Go0000oo?clooclo?olo?co`000007
oo?cl`03o`000?oclo?olo?c00Golo?c0_l00002oo?cl`03o`3>dOoclo?olo?c08Oolo?c0_l0000Q
oo?cl`03o`000?oclo?olo?c00kolo?c0_oKL9=eoo?cl`03o`000?oclo?olo?c00kolo?c000Voo?c
l`03o`000?oclo?olo?c00?olo?c00?oo`3ooo?clooclo<03_oclo<00ooo0?oolo?coo?cl`1eoo?c
l`03o`000?oclo?olo?c00Kolo?c0ol00008oo?cl`Go00000ooclo<01Ol0003olo?coo?clooclo?o
0<kA08[olo?c00?o0000oo?clooclo<07ooclo<00ol0003olo?coo?cl`0=oo?cl`03om]`Tooclo?o
lo?c07Golo?c00?o0000oo?clooclo<03_oclo<002Kolo?c0_l00003oo?cl`03ool0oooclo?olo?c
00oolo?c00?oo`3ooo?clooclo<0M?oclo<2o`0001_olo?c0_l00002oo?cl`03o`3>dOoclo?olo?c
08Oolo?c0_l0000Qoo?cl`03o`000?oclo?olo?c00colo?c00?ofg2Coo?clooclo<0M_oclo<00ol0
003olo?coo?cl`0>oo?cl`009_oclo<00ol0003olo?coo?cl`02oo?cl`03ool0oooclo?olo?c00oo
lo?c00?oo`3ooo?clooclo<0MOoclo<00ol0003olo?coo?cl`0Ioo?cl`04o`000?oclo?olo?co`3>
dH_olo?c00?o0000oo?clooclo<02ooclo<5o`0000?olo?c00?o0000oo?clooclo<00_oclo<3o`00
00Colo?c00?o0000oo?clooclo<02ooclo<00ooKL9?olo?coo?cl`1goo?cl`03o`000?oclo?olo?c
00kolo?c000Voo?cl`03o`000?oclo?olo?c00;olo?c00?oo`3ooo?clooclo<03ooclo<00ooo0?oo
lo?coo?cl`1eoo?cl`03o`000?oclo?olo?c01Wolo?c0_l000000ooclo?o0<kAoo?cl`29oo?cl`;o
00003_oclo<01?l0003olo?coo?clol00007oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<0
0ol0003olo?coo?cl`0:oo?cl`03om]`Tooclo?olo?c07Solo?c00?o0000oo?clooclo<03_oclo<0
02Kolo?c0_l00003oo?cl`03ool0oooclo?olo?c08Kolo?c0_l0000Koo?cl`04o`000?oclo?olo?c
o`3>dH_olo?c00?o0000oo?clooclo<01Ooclo<5o`0000?olo?c00?o0000oo?clooclo<02ooclo<0
1Ol0003olo?coo?clooclo?o000000_olo?c00?ofg2Coo?clooclo<0NOoclo<00ol0003olo?coo?c
l`0>oo?cl`008Ooclo<2o`0000?olo?c00?o0000oo?clooclo<00_oclo<00ooo0?oolo?coo?cl`27
oo?cl`03o`000?oclo?olo?c017olo?c1Ol00003oo?cl`04o`000?oclo?olo?co`3>dH_olo?c00?o
0000oo?clooclo<03_oclo<00ol0003olo?coo?cl`0:oo?cl`04o`000?oclo?olo?coo?cl`;o0000
2Ooclo<00ooKL9?olo?coo?cl`1ioo?cl`;o00004?oclo<0023olo?c00Co0000oo?clooclo?o0000
0_oclo<01Ol0003olo?coo?clooclo?oo`3o08[olo?c00?o0000oo?clooclo<04_oclo<01?l0003o
lo?coo?clol00003oo?cl`;o000000?olo?co`3>dOoclo<0ROoclo<2o`0000golo?c00Go0000oo?c
looclo?olo?co`000007oo?cl`Co00001?oclo<00ol0003olo?coo?cl`06oo?cl`;ofg2COOoclo<0
0ol0003olo?coo?cl`0>oo?cl`008?oclo<01?l0003olo?coo?clol00002oo?cl`05o`000?oclo?o
lo?coo?clooo0?l0R_oclo<00ol0003olo?coo?cl`0;oo?cl`Go00000ooclo<00ol0003olo?coo?c
l`03oo?cl`04o`000?oclo?olo?co`3>dH_olo?c00?o0000oo?clooclo<02ooclo<01Ol0003olo?c
oo?clooclo?o000000Oolo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`06om]`Tgoo
lo?c00?o0000oo?clooclo<03_oclo<0023olo?c00Co0000oo?clooclo?o00000_oclo<2o`0000;o
lo?c00?oo`3ooo?clooclo<0Qooclo<2o`0001Kolo?c00?o0000oo?clooclo<00_oclo<2o`000003
oo?clol0c]7olo?c08Wolo?c0_l0000>oo?cl`?o00002?oclo<5o`0000?olo?c00Co0000oo?clooc
lo?o00004_oclo<00ol0003olo?coo?cl`0?oo?cl`03o`000?oclo?olo?c013olo?c00?o0000oo?c
looclo<03ooclo<00ol0003olo?coo?cl`0@oo?cl`03o`000?oclo?olo?c00oolo?c00?o0000oo?c
looclo<04?oclo<01?l0003olo?coo?clol0000@oo?cl`008?oclo<01?l0003olo?coo?clol00002
oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01?l0003olo?coo?clol00003oo?cl`05o`00
0?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?c
looclo?olo?co`000003oo?cl`04o`000?oclo?olo?co`0000?olo?c00Go0000oo?clooclo?olo?c
o`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooclo?o0000
00?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go
0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01?l0003o
lo?coo?clol00003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooc
lo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`04o`000?oclo?olo?co`0000?o
lo?c00Go0000oo?clooclo?olo?co`00000Coo?cl`05o`000?oclo?olo?coo?clol000000ooclo<0
1?l0003olo?coo?clol00003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?c
oo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`04o`000?oclo?olo?c
o`0000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol00000
0ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0
003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oc
lo?olo?coo?clol000000ooclo<01?l0003olo?coo?clol00003oo?cl`05o`000?oclo?olo?coo?c
lol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`00
0003oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01Ol0003olo?coo?clooclo?o000000?o
lo?c00Go0000oo?clooclo?olo?co`00000Qoo?clhWo00004?oclo<0023olo?c00Co0000oo?clooc
lo?o00000_oclo>@o`0001?olo?c00Go0000oo?clooclo?olo?co`000003oo?cli3o0000^_oclo<0
027olo?c0_l0002Woo?cl`?o0000oooclo=?oo?cl`00oooclo?ooo?clagolo?c003ooo?clooolo?c
7Ooclo<00?oolo?coooclo<Moo?cl`00oooclo?ooo?clagolo?c000Soo?cl`;o00004Ooclo<3o`00
00kolo?c0ol00004oo?cl`;o00003?oclo<3o`0000?olo?c0ol0000:oo?cl`Go00000ooclo<2o`00
00[olo?c1Ol00002oo?cl`?o00002ooclo<3o`0000Colo?c0_l0000;oo?cl`?o00000ooclo<3o`00
0?oolo?cIooclo<002;olo?c00Co0000oo?clooclo?o00003ooclo<01Ol0003olo?coo?clooclo?o
000000kolo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000<oo?cl`05o`000?oc
lo?olo?coo?clol000000ooclo<00ol0003olo?coo?cl`08oo?cl`04o`000?oclo?olo?co`0000;o
lo?c00Co0000oo?clooclo?o00002_oclo<01_l0003olo?coo?clol0003olo?co`0000?olo?c00?o
0000oo?clooclo<01ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Co0000oo?clooclo?o
00002Ooclo<01ol0003olo?coo?clooclo?o0000oo?clol000000ooclo<00ol0003olo?coo?cl`0F
oo?cl`;o00004Ooclo<3o`0000kolo?c0ol00004oo?cl`;o00002ooclo<3o`0000?olo?c0ol0000;
oo?cl`Go00000ooclo<2o`0000[olo?c1Ol00002oo?cl`?o00002ooclo<3o`0000Colo?c0_l0000;
oo?cl`?o00000ooclo<3o`000;_olo?c000Roo?cl`04o`000?oclo?olo?co`0001?olo?c00?o0000
oo?clooclo<03?oclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000colo?c00?o
0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`09oo?cl`03o`000?oclo?olo?c00;olo?c00Co
0000oo?clooclo?o00002ooclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00_olo?c
00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?cl`0;oo?cl`03o`000?oclo?olo?c00?o
lo?c00?o0000oo?clooclo<05Ooclo<01?l0003olo?coo?clol0000?oo?cl`05o`000?oclo?olo?c
oo?clol000003_oclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000_olo?c00Go
0000oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c00Wolo?c00Co0000oo?clooclo?o
00000_oclo<01?l0003olo?coo?clol0000:oo?cl`06o`000?oclo?olo?co`000?oclo?o00000ooc
lo<00ol0003olo?coo?cl`07oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?c
oo?clol00009oo?cl`07o`000?oclo?olo?coo?clol0003olo?co`000003oo?cl`03o`000?oclo?o
lo?c01_olo?c0_l0000Aoo?cl`?o00003Ooclo<3o`0000Colo?c0_l0000:oo?cl`?o00000ooclo<3
o`0000[olo?c1Ol00003oo?cl`;o00002Ooclo<5o`0000;olo?c0ol0000;oo?cl`?o00001?oclo<2
o`0000[olo?c0ol00003oo?cl`?o00004?oclo<002;olo?c00Co0000oo?clooclo?o00004ooclo<0
0ol0003olo?coo?cl`0<oo?cl`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o00003?oc
lo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00[olo?c00Go0000oo?clooclo?olo?c
o`000002oo?cl`03o`000?oclo?olo?c00[olo?c00?o0000oo?clooclo<01?oclo<00ol0003olo?c
oo?cl`09oo?cl`;o00000ooclo<01?l0003olo?coo?clol0000;oo?cl`;o00001_oclo<00ol0003o
lo?coo?cl`0Eoo?cl`04o`000?oclo?olo?co`0001?olo?c00?o0000oo?clooclo<03?oclo<00ol0
003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000_olo?c00?o0000oo?clooclo<01Ooclo<0
0ol0003olo?coo?cl`0:oo?cl`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o00002ooc
lo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00_olo?c00Co0000oo?clooclo?o0000
0_oclo<00ol0003olo?coo?cl`0;oo?cl`03o`000?oclo?olo?c00?olo?c00?o0000oo?clooclo<0
6_oclo<01?l0003olo?coo?clol0000?oo?cl`05o`000?oclo?olo?coo?clol000003Ooclo<00ol0
003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000[olo?c00Go0000oo?clooclo?olo?co`00
0003oo?cl`03o`000?oclo?olo?c00Solo?c00Co0000oo?clooclo?o00000_oclo<01?l0003olo?c
oo?clol00009oo?cl`06o`000?oclo?olo?co`000?oclo?o00000ooclo<00ol0003olo?coo?cl`07
oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?clol00008oo?cl`07o`00
0?oclo?olo?coo?clol0003olo?co`000003oo?cl`03o`000?oclo?olo?c00golo?c000Roo?cl`04
o`000?oclo?olo?co`0000oolo?c1?l0000?oo?cl`03o`000?oclo?olo?c00;olo?c00Co0000oo?c
looclo?o00003?oclo<01?l0003olo?coo?clooclo<4o`0000[olo?c00Go0000oo?clooclo?olo?c
o`000002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Ko0000oo?clooclo?olo?co`000?oclo<4
o`0000kolo?c00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?cl`0;oo?cl`03o`000?oc
lo?o000000?o00006?oclo<01?l0003olo?coo?clol0000Coo?cl`03o`000?oclo?olo?c00colo?c
00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000;oo?cl`03o`000?oclo?olo?c00Go
lo?c00?o0000oo?clooclo<02ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o0000oo?c
looclo<02_oclo<00ol0003olo?coo?cl`04oo?cl`03o`000?oclo?olo?c00Wolo?c0_l00003oo?c
l`04o`000?oclo?olo?co`0000_olo?c0_l00006oo?cl`03o`000?oclo?olo?c01[olo?c00Co0000
oo?clooclo?o00004ooclo<00ol0003olo?coo?cl`0;oo?cl`03o`000?oclo?olo?c00;olo?c00Co
0000oo?clooclo?o00002_oclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00Wolo?c
00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000:oo?cl`03o`000?oclo?olo?c00Go
lo?c00?o0000oo?clooclo<02ooclo<01?l0003olo?coo?clol00002oo?cl`03o`000?oclo?olo?c
00[olo?c00?o0000oo?clooclo<00ooclo<00ol0003olo?coo?cl`0=oo?cl`008_oclo<01?l0003o
lo?coo?clol0000?oo?cl`03o`000?oclo?olo?c00oolo?c0_l00004oo?cl`04o`000?oclo?olo?c
o`0000_olo?c0_l00003oo?cl`03o`000?oclo?olo?c00_olo?c00Go0000oo?clooclo?olo?co`00
0002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Oo0000oo?clooclo?olo?co`000?oclo?o0000
00golo?c00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Oo
0000oo?clooclo?olo?co`000?oclo?o000001_olo?c00Co0000oo?clooclo?o00003ooclo<4o`00
00oolo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000;oo?cl`04o`000?oclo?o
lo?coo?cl`Co00002ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Co0000oo?clooclo?o
00002Ooclo<01_l0003olo?coo?clooclo?o0000oo?cl`Co00003_oclo<01?l0003olo?coo?clol0
0002oo?cl`03o`000?oclo?olo?c00_olo?c00?o0000oo?clol000000ol0000Moo?cl`04o`000?oc
lo?olo?co`0001?olo?c00?o0000oo?clooclo<02ooclo<00ol0003olo?coo?cl`02oo?cl`04o`00
0?oclo?olo?co`0000[olo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`0:oo?cl`05
o`000?oclo?olo?coo?clol000000_oclo<00ol0003olo?coo?cl`09oo?cl`03o`000?oclo?olo?c
00Colo?c00?o0000oo?clooclo<02Ooclo<2o`0000?olo?c00Co0000oo?clooclo?o00002_oclo<2
o`0000Kolo?c00?o0000oo?clooclo<03Ooclo<002?olo?c0_l0000@oo?cl`Go00003_oclo<00ol0
003olo?coo?cl`03oo?cl`;o00003Ooclo<01?l0003olo?coo?clooclo<5o`0000[olo?c0ol00004
oo?cl`;o00002ooclo<3o`0000;olo?c1Ol0000:oo?cl`?o00001?oclo<2o`0000_olo?c0ol00002
oo?cl`Go00005ooclo<01?l0003olo?coo?clol0000?oo?cl`03o`000?oclo?olo?c00oolo?c0_l0
0004oo?cl`04o`000?oclo?olo?co`0000[olo?c0_l00003oo?cl`03o`000?oclo?olo?c00colo?c
00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Oo0000oo?c
looclo?olo?co`000?oclo?o000000golo?c00Go0000oo?clooclo?olo?co`000002oo?cl`04o`00
0?oclo?olo?co`0000Wolo?c00Oo0000oo?clooclo?olo?co`000?oclo?o0000023olo?c00Co0000
oo?clooclo?o00003ooclo<4o`0000kolo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?c
lol0000:oo?cl`04o`000?oclo?olo?coo?cl`Co00002_oclo<01Ol0003olo?coo?clooclo?o0000
00;olo?c00Co0000oo?clooclo?o00002?oclo<01_l0003olo?coo?clooclo?o0000oo?cl`Co0000
3_oclo<01?l0003olo?coo?clol00002oo?cl`03o`000?oclo?olo?c00[olo?c00?o0000oo?clol0
00000ol0000@oo?cl`00c_oclo<2o`00013olo?c1Ol0000>oo?cl`03o`000?oclo?olo?c00?olo?c
0_l0000<oo?cl`04o`000?oclo?olo?coo?cl`Go00002ooclo<3o`0000Colo?c0_l0000;oo?cl`?o
00000_oclo<5o`0000[olo?c0ol00004oo?cl`;o00002ooclo<3o`0000;olo?c1Ol0000Loo?cl`04
o`000?oclo?olo?co`0000oolo?c00?o0000oo?clooclo<03_oclo<2o`0000Colo?c00Co0000oo?c
looclo?o00002Ooclo<2o`0000?olo?c00?o0000oo?clooclo<02ooclo<01Ol0003olo?coo?clooc
lo?o000000;olo?c00Co0000oo?clooclo?o00002?oclo<01ol0003olo?coo?clooclo?o0000oo?c
lol000003Ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Co0000oo?clooclo?o00002?oc
lo<01ol0003olo?coo?clooclo?o0000oo?clol000004ooclo<00?oolo?cOooclo<2o`00013olo?c
1Ol0000=oo?cl`03o`000?oclo?olo?c00?olo?c0_l0000;oo?cl`04o`000?oclo?olo?coo?cl`Go
00002_oclo<3o`0000Colo?c0_l0000:oo?cl`?o00000_oclo<5o`0000[olo?c0ol00004oo?cl`;o
00002_oclo<3o`0000;olo?c1Ol0000?oo?cl`00oooclo?ooo?clagolo?c000Poo?cliKo0000oooc
lo=Voo?cl`008?oclo<01Ol0003olo?coo?clooclo?o000001?olo?c00?o0000oo?clooclo<04Ooc
lo<00ol0003olo?coo?cl`0Boo?cl`03o`000?oclo?olo?c017olo?c00?o0000oo?clooclo<04Ooc
lo<00ol0003olo?coo?cl`0Aoo?cl`03o`000?oclo?olo?c017olo?c00Go0000oo?clooclo?olo?c
o`00000Eoo?cliKo0000^_oclo<0023olo?c00?o0000oo?clooclo<03Ooclo<00oooo`3olo?coo?c
l`22oo?cl`03o`000?oclo?olo?c00?o00001?oclo<00ol0003olo?coo?cl`03oo?cl`?o00000ooc
lo<01Ol0003olo?coo?clooclo?o000001?olo?c00?o0000oo?clooclo<04Ooclo<00ol0003olo?c
oo?cl`0Aoo?cl`03o`000?oclo?olo?c01;olo?c00?o0000oo?clooclo<04Ooclo<00ol0003olo?c
oo?cl`0Aoo?cl`03o`000?oclo?olo?c017olo?c00Go0000oo?clooclo?olo?co`00000Koo?clhoo
00004?oclo<0023olo?c00?o0000oo?clooclo<03Ooclo<00oooo`3olo?coo?cl`22oo?cl`05o`00
0?oclo?olo?coo?clol000003?oclo<00ol0003olo?coo?cl`02oo?cl`03o`000?oclo?olo?c00Go
lo?c00?oRR_Roo?clooclo<0R_oclo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c08_o
lo?c00?o0000oo?clooclo<03_oclo<0023olo?c0_l0000>oo?cl`03oooo0?oclo?olo?c087olo?c
0_l00003oo?cl`03o`000?oclo?olo?c00Oolo?c1Ol00003oo?cl`;o00001_oclo<00on::n;olo?c
oo?cl`29oo?cl`;o00006ooclo<00ol0003olo?coo?cl`0Ooo?cl`03oomQ0_oclo?olo?c06Wolo?c
00?o0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<03?oclo<2oooo08Colo?c00Go
0000oo?clooclo?olo?co`000009oo?cl`04o`000?oclo?olo?co`0000Colo?c00?o0000oo?clooc
lo<01Ooclo<00on::n;olo?coo?cl`2:oo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?clooc
lo<07ooclo<00oooH@;olo?coo?cl`1Yoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`00
0?oclo?olo?c00colo?c0_ooo`24oo?cl`05o`000?oclo?olo?coo?clol000002_oclo<00ol0003o
lo?co`000004oo?cl`03o`000?oclo?olo?c00Golo?c00?oRR_Roo?clooclo<0R_oclo<00ol0003o
lo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01oolo?c00?oof42oo?clooclo<0JOoclo<00ol0003o
lo?coo?cl`0>oo?cl`008?oclo<00ol0003olo?coo?cl`0<oo?cl`;oool0Q?oclo<00ol0003olo?c
oo?cl`02o`0000_olo?c0_l00004oo?cl`03o`000?oclo?olo?c00Golo?c00?oRR_Roo?clooclo<0
R_oclo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01oolo?c00?oof42oo?clooclo<0
JOoclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<00ol0003olo?coo?cl`0<oo?cl`;oool0Q?oc
lo<01Ol0003olo?coo?clooclo?o000000colo?c00?o0000oo?clooclo<00_oclo<2o`0000Kolo?c
00?oRR_Roo?clooclo<0ROoclo<2o`0001_olo?c00?o0000oo?clooclo<07ooclo<00oooH@;olo?c
oo?cl`1Yoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`;o00003Ooclo<00oooo`3olo?coooo
0022oo?cl`;o00005Ooclo<00ol0003olo?coo?cl`04oo?cl`;oRR_RS?oclo<00ol0003olo?coo?c
l`0Ioo?cl`03o`000?oclo?olo?c01oolo?c00?oof42oo?clooclo<0JOoclo<00ol0003olo?coo?c
l`0>oo?cl`008?oclo<00ol0003olo?coo?cl`0;oo?cl`04oooo0?oclo?olo?coooo08?olo?c00?o
0000oo?clooclo<04ooclo<00ol0003olo?coo?cl`04oo?cl`;oRR_RS?oclo<00ol0003olo?coo?c
l`0Ioo?cl`03o`000?oclo?olo?c01oolo?c0_ooH@9Zoo?cl`03o`000?oclo?olo?c00kolo?c000?
oo?cl`;o00001?oclo<01?l0003olo?coo?clooclo<5o`0000;olo?c00?o0000oo?clooclo<02ooc
lo<01?ooo`3olo?coo?cloooo`23oo?cl`03o`000?oclo?olo?c01?olo?c0_l00005oo?cl`;oRR_R
Rooclo<2o`0001_olo?c00?o0000oo?clooclo<07ooclo<2oomQ0V[olo?c00?o0000oo?clooclo<0
3_oclo<000kolo?c00Co0000oo?clooclo?o00002?oclo<01?l0003olo?coo?clol00002oo?cl`03
o`000?oclo?olo?c00_olo?c00Coool0oo?clooclo?oool0Pooclo<00ol0003olo?coo?cl`0Coo?c
l`03o`000?oclo?olo?c00Colo?c0_n::n:<oo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?c
looclo<07ooclo<2oomQ0V[olo?c00?o0000oo?clooclo<03_oclo<000kolo?c00Co0000oo?clooc
lo?o00002Ooclo<00ol0003olo?coo?cl`02oo?cl`03o`000?oclo?olo?c00_olo?c00Coool0oo?c
looclo?oool0Pooclo<00ol0003olo?coo?cl`0Coo?cl`03o`000?oclo?olo?c00Colo?c0_n::n:<
oo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<07ooclo<2oomQ0V[olo?c00?o0000
oo?clooclo<03_oclo<000kolo?c00Co0000oo?clooclo?o00002_oclo<01?l0003olo?coo?clooc
lo<2o`0000colo?c00Coool0oo?clooclo?oool0P_oclo<2o`0001Golo?c00?o0000oo?clooclo<0
1?oclo<2ohX[hXcolo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`0Noo?cl`03oomQ
0_oclo?oof4206[olo?c00?o0000oo?clooclo<03_oclo<000kolo?c00Co0000oo?clooclo?o0000
1ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o0000oo?clooclo<02_oclo<01Oooo`3o
lo?coo?clooclo?oool008?olo?c00?o0000oo?clooclo<04ooclo<2o`0000Golo?c00?oRR_Roo?c
lon::n80R_oclo<2o`0001_olo?c00?o0000oo?clooclo<07_oclo<00oooH@;olo?coomQ0P1Zoo?c
l`03o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oclo?olo?co`0000Oolo?c00Go0000oo?c
looclo?olo?co`000002oo?cl`03o`000?oclo?olo?c00[olo?c00Goool0oo?clooclo?olo?coooo
0023oo?cl`03o`000?oclo?olo?c00?o00001?oclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oc
lo<00ol0003olo?coo?cl`04oo?cl`03ohX[h_oclo?oRR_R08_olo?c00?o0000oo?clooclo<06Ooc
lo<00ol0003olo?coo?cl`0Noo?cl`03oomQ0_oclo?oof4206[olo?c00?o0000oo?clooclo<03_oc
lo<000oolo?c0_l00009oo?cl`?o00000ooclo<00ol0003olo?coo?cl`0:oo?cl`05oooo0?oclo?o
lo?coo?cloooo`00Pooclo<01Ol0003olo?coo?clooclo?o000000Wolo?c00Go0000oo?clooclo?o
lo?co`000003oo?cl`03o`000?oclo?olo?c00Colo?c00?oRR_Roo?clon::n80Rooclo<00ol0003o
lo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01kolo?c00?oof42oo?cloooH@80J_oclo<00ol0003o
lo?coo?cl`0>oo?cl`008?oclo<00ol0003olo?coo?cl`0:oo?cl`05oooo0?oclo?olo?coo?clooo
o`00Pooclo<01Ol0003olo?coo?clooclo?o000000Wolo?c00Go0000oo?clooclo?olo?co`000003
oo?cl`;o00001Ooclo<00on::n;olo?cohX[hP2:oo?cl`;o00006ooclo<00ol0003olo?coo?cl`0N
oo?cl`03oomQ0_oclo?oof4206[olo?c00?o0000oo?clooclo<03_oclo<0023olo?c0_l0000;oo?c
l`05oooo0?oclo?olo?coo?cloooo`00P_oclo<2o`0000?olo?c00?o0000oo?clooclo<01ooclo<4
o`0000Colo?c00?o0000oo?clooclo<01?oclo<00on::n;olo?cohX[hP2;oo?cl`03o`000?oclo?o
lo?c01Wolo?c00?o0000oo?clooclo<07_oclo<00oooH@;olo?coomQ0P1Zoo?cl`03o`000?oclo?o
lo?c00kolo?c000Poo?cl`03o`000?oclo?olo?c00Wolo?c00?oool0oo?clooclo<00_oclo<00ooo
o`3olo?coo?cl`21oo?cl`05o`000?oclo?olo?coo?clol000002Ooclo<00ol0003olo?coo?cl`05
oo?cl`03o`000?oclo?olo?c00?olo?c00CoRR_Roo?clooclo?oRR_RRooclo<00ol0003olo?coo?c
l`07oo?cl`;o00001?oclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oclo<00ol0003olo?coo?c
l`0Noo?cl`03oomQ0_oclo?oof4206[olo?c00?o0000oo?clooclo<03_oclo<0023olo?c00?o0000
oo?clooclo<02Ooclo<00oooo`3olo?coo?cl`02oo?cl`03oooo0?oclo?olo?c087olo?c00?o0000
oo?clooclo<00_l0000:oo?cl`03o`000?oclo?olo?c00Colo?c00?o0000oo?clooclo<00ooclo<0
1?n::n;olo?coo?clon::n:;oo?cl`03o`000?oclo?olo?c00Kolo?c00Co0000oo?clooclo?o0000
1ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooclo<07_oclo<01?ooH@;o
lo?coo?cloooH@9Yoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`000?oclo?olo?c00Wo
lo?c00?oool0oo?clooclo<00ooclo<00oooo`3olo?coo?cl`20oo?cl`05o`000?oclo?olo?coo?c
lol000002ooclo<2o`0000Colo?c0_l00004oo?cl`04ohX[h_oclo?olo?cohX[hX[olo?c0_l00000
0ooclo?o0000o`000003o`0000;olo?c00Co0000oo?clooclo?o00002ooclo<01?l0003olo?coo?c
looclo<2o`0001oolo?c00Coof42oo?clooclo?oof42J?oclo<2o`00013olo?c000Poo?cl`;o0000
2_oclo<00oooo`3olo?coo?cl`03oo?cl`03oooo0?oclo?olo?c07oolo?c0_l0000Eoo?cl`03o`00
0?oclo?olo?c00?olo?c00CoRR_Roo?clooclo?oRR_RRooclo<00ol0003olo?coo?cl`06oo?cl`04
o`000?oclo?olo?co`0000Wolo?c0_l00004oo?cl`03o`000?oclo?olo?c01kolo?c00Coof42oo?c
looclo?oof42JOoclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<00ol0003olo?coo?cl`09oo?c
l`03oooo0?oclo?olo?c00?olo?c00?oool0oo?clooclo<0P?oclo<00ol0003olo?coo?cl`0Coo?c
l`03o`000?oclo?olo?c00?olo?c00CoRR_Roo?clooclo?oRR_RRooclo<00ol0003olo?coo?cl`06
oo?cl`04o`000?oclo?olo?co`0000_olo?c00Go0000oo?clooclo?olo?co`00000Poo?cl`04oomQ
0_oclo?olo?coomQ0VWolo?c00?o0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<0
2Ooclo<00oooo`3olo?coo?cl`03oo?cl`03oooo0?oclo?olo?c083olo?c00?o0000oo?clooclo<0
4ooclo<2o`0000Colo?c00CoRR_Roo?clooclo?oRR_RR_oclo<2o`0000Solo?c00Co0000oo?clooc
lo?o00001ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooclo<07_oclo<0
1?ooH@;olo?coo?cloooH@9Yoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`000?oclo?o
lo?c00Wolo?c00?oool0oo?clooclo<00ooclo<00oooo`3olo?coo?cl`20oo?cl`03o`000?oclo?o
lo?c01?olo?c00?o0000oo?clooclo<00ooclo<01?n::n;olo?coo?clon::n8Too?clagoRR_R0ooc
lo=4ohX[hP?olo?c00?o0000oo?clooclo<01ooclo<2o`0000Wolo?c0ol00004oo?cl`03o`000?oc
lo?olo?c01kolo?c00Coof42oo?clooclo?oof42JOoclo<00ol0003olo?coo?cl`0>oo?cl`008?oc
lo<00ol0003olo?coo?cl`09oo?cl`03oooo0?oclo?olo?c00?olo?c00?oool0oo?clooclo<0P?oc
lo<00ol0003olo?coo?cl`0Coo?cl`03o`000?oclo?olo?c00?olo?c00CoRR_Roo?clooclo?oRR_R
8_oclo<2ohX[hQgolo?c0on::n97oo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<0
7_oclo<01?ooH@;olo?coo?cloooH@9Yoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`;o0000
2_oclo<00oooo`3olo?coo?cl`03oo?cl`03oooo0?oclo?olo?c07oolo?c0_l0000Eoo?cl`03o`00
0?oclo?olo?c00?olo?c00CoRR_Roo?clooclo?oRR_R8_oclo<00on::n;olo?coo?cl`1Voo?cl`03
o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<07_oclo<01?ooH@;olo?coo?cloooH@9Yoo?c
l`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`000?oclo?olo?c00Solo?c00?oool0oo?clooc
lo<01?oclo<00oooo`3olo?coo?cl`20oo?cl`03o`000?oclo?olo?c01?olo?c0_l00004oo?cl`04
ohX[h_oclo?olo?cohX[hR7olo?c00?oRR_Roo?clooclo<0I_oclo<2o`0001_olo?c00?o0000oo?c
looclo<07_oclo<01?ooH@;olo?coo?cloooH@9Yoo?cl`03o`000?oclo?olo?c00kolo?c000?oo?c
l`;o00001?oclo<00ol0003olo?coo?cl`03oo?cl`?o00000_oclo<00ol0003olo?coo?cl`08oo?c
l`03oooo0?oclo?olo?c00Colo?c00?oool0oo?clooclo<0P?oclo<00ol0003olo?coo?cl`03o`00
00Colo?c00?o0000oo?clooclo<00_oclo<3o`0000Colo?c00?o0000oo?clooclo<00ooclo<01?n:
:n;olo?coo?clon::n8Boo?cl`03ohX[h_oclo?olo?c00_olo?c00?oRR_Roo?clooclo<0J?oclo<0
0ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01kolo?c00Coof42oo?clooclo?oof42JOoc
lo<00ol0003olo?coo?cl`0>oo?cl`003_oclo<01?l0003olo?coo?clol0000:oo?cl`05o`000?oc
lo?olo?coo?clol000002_oclo<00oooo`3olo?coo?cl`04oo?cl`03oooo0?oclo?olo?c083olo?c
00Go0000oo?clooclo?olo?co`000009oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0
003olo?coo?cl`02oo?cl`05ohX[h_oclo?olo?coo?clon::n804_oclo<00on::n;olo?coo?cl`0:
oo?cl`03ohX[h_oclo?olo?c06Wolo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`0N
oo?cl`04oomQ0_oclo?olo?coomQ0VWolo?c00?o0000oo?clooclo<03_oclo<000kolo?c00Co0000
oo?clooclo?o00001ooclo<5o`0000;olo?c00?o0000oo?clooclo<02?oclo<00oooo`3olo?coo?c
l`04oo?cl`03oooo0?oclo?olo?c083olo?c00Go0000oo?clooclo?olo?co`000009oo?cl`05o`00
0?oclo?olo?coo?clol000000ooclo<2o`0000?olo?c00GoRR_Roo?clooclo?olo?cohX[hP0Boo?c
l`03ohX[h_oclo?olo?c00Wolo?c00?oRR_Roo?clooclo<0JOoclo<2o`0001_olo?c00?o0000oo?c
looclo<07Ooclo<00oooH@;olo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c06Kolo?c00?o0000oo?c
looclo<03_oclo<000kolo?c00Co0000oo?clooclo?o00001ooclo<01?l0003olo?coo?clol00003
oo?cl`;o00002Ooclo<00oooo`3olo?coo?cl`04oo?cl`03oooo0?oclo?olo?c07oolo?c0_l00003
oo?cl`03o`000?oclo?olo?c00Solo?c0ol00004oo?cl`03o`000?oclo?olo?c00;olo?c00GoRR_R
oo?clooclo?olo?cohX[hP0Boo?cl`03ohX[h_oclo?olo?c00Wolo?c00?oRR_Roo?clooclo<0J_oc
lo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01golo?c00?oof42oo?clooclo<00_oc
lo<00oooH@;olo?coo?cl`1Voo?cl`03o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oclo?o
lo?co`0000Solo?c00?o0000oo?clol000000ooclo<00ol0003olo?coo?cl`08oo?cl`03oooo0?oc
lo?olo?c00Golo?c00?oool0oo?clooclo<0Oooclo<01Ol0003olo?coo?clooclo?o000000Wolo?c
00Go0000oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c00;olo?c00GoRR_Roo?clooc
lo?olo?cohX[hP0Aoo?cl`03ohX[h_oclo?oRR_R00[olo?c00?oRR_Roo?clooclo<0J_oclo<00ol0
003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01golo?c00?oof42oo?clooclo<00_oclo<00ooo
H@;olo?coo?cl`1Voo?cl`03o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oclo?olo?co`00
00Wolo?c0_l00003oo?cl`03o`000?oclo?olo?c00Solo?c00?oool0oo?clooclo<01Ooclo<00ooo
o`3olo?coo?cl`1ooo?cl`03o`000?oclo?olo?c00;o00002Ooclo<01Ol0003olo?coo?clooclo?o
000000?olo?c00?o0000oo?clooclo<00_oclo<01On::n;olo?coo?clooclo?oRR_R017olo?c00?o
RR_Roo?clon::n802Ooclo<00on::n;olo?coo?cl`1[oo?cl`03o`000?oclo?olo?c01Wolo?c00?o
0000oo?clooclo<07Ooclo<00oooH@;olo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c06Kolo?c00?o
0000oo?clooclo<03_oclo<000oolo?c0_l0000;oo?cl`05o`000?oclo?olo?coo?clol000002_oc
lo<00oooo`3olo?coo?cl`05oo?cl`03oooo0?oclo?olo?c01colo?cH?ooo`03oo?cl`05o`000?oc
lo?olo?coo?clol000002_oclo<3o`0000Colo?c0_l00003oo?cl`05ohX[h_oclo?olo?coo?clon:
:n804Ooclo<00on::n;olo?cohX[hP09oo?cl`03ohX[h_oclo?olo?c06[olo?c0_l0000Koo?cl`03
o`000?oclo?olo?c01golo?c00?oof42oo?clooclo<00_oclo<00oooH@;olo?coo?cl`1Voo?cl`03
o`000?oclo?olo?c00kolo?c000Poo?cl`;o00002Ooclo<00oooo`3olo?coo?cl`05oo?cl`03oooo
0?oclo?olo?c01;olo?c2_ooo`1Roo?cl`;o00005Ooclo<00ol0003olo?coo?cl`02oo?cl`03ohX[
h_oclo?olo?c00;olo?c00?oRR_Roo?clooclo<03_oclo<00on::n;olo?cohX[hP09oo?cl`03ohX[
h_oclo?olo?c06_olo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`0Moo?cl`03oomQ
0_oclo?olo?c00;olo?c00?oof42oo?clooclo<0I_oclo<00ol0003olo?coo?cl`0>oo?cl`008?oc
lo<00ol0003olo?coo?cl`08oo?cl`03oooo0?oclo?olo?c00Golo?c00?oool0oo?clooclo<04Ooc
lo<00oooo`3olo?coo?cl`1[oo?cl`03o`000?oclo?olo?c01?olo?c00?o0000oo?clooclo<00_oc
lo<00on::n;olo?coo?cl`02oo?cl`03ohX[h_oclo?olo?c00kolo?c00?oRR_Roo?clon::n802Ooc
lo<00on::n;olo?coo?cl`1[oo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<07Ooc
lo<00oooH@;olo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c06Kolo?c00?o0000oo?clooclo<03_oc
lo<0023olo?c00?o0000oo?clooclo<02?oclo<00oooo`3olo?coo?cl`05oo?cl`03oooo0?oclo?o
lo?c00;olo?c0oooo`0;oo?cl`03oooo0?oclo?olo?c06colo?c00?o0000oo?clooclo<04ooclo<2
o`0000?olo?c00?oRR_Roo?clooclo<00_oclo<00on::n;olo?coo?cl`0=oo?cl`04ohX[h_oclo?o
lo?cohX[hPSolo?c00?oRR_Roo?clooclo<0Jooclo<2o`0001_olo?c00?o0000oo?clooclo<07Ooc
lo<00oooH@;olo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c06Kolo?c00?o0000oo?clooclo<03_oc
lo<0023olo?c00?o0000oo?clooclo<02?oclo<00oooo`3olo?coo?cl`05oo?cl`03oooo0?oclo?o
lo?c00;olo?c00?oool0oo?clooclo<00oooo`07oo?cl`03oooo0?oclo?olo?c06golo?c00?o0000
oo?clooclo<04ooclo<00ol0003olo?coo?cl`02oo?cl`03ohX[h_oclo?olo?c00;olo?c00?oRR_R
oo?clooclo<03Ooclo<01On::n;olo?coo?clooclo?oRR_R00Oolo?c00?oRR_Roo?clooclo<0K?oc
lo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c01golo?c00?oof42oo?clooclo<00_oc
lo<00oooH@;olo?coo?cl`1Voo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`000?oclo?o
lo?c00Solo?c00?oool0oo?clooclo<01Ooclo<00oooo`3olo?coo?cl`02oo?cl`03oooo0?oclo?o
lo?c00?olo?c0_ooo`02oo?cl`?oool0L?oclo<00ol0003olo?coo?cl`0Coo?cl`03o`000?oclo?o
lo?c00;olo?c00?oRR_Roo?clooclo<00_oclo<00on::n;olo?coo?cl`0=oo?cl`05ohX[h_oclo?o
lo?coo?clon::n801ooclo<00on::n;olo?coo?cl`1/oo?cl`03o`000?oclo?olo?c01Wolo?c00?o
0000oo?clooclo<07Ooclo<00oooH@;olo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c06Kolo?c00?o
0000oo?clooclo<03_oclo<0023olo?c0_l00008oo?cl`03oooo0?oclo?olo?c00Kolo?c00Goool0
oo?clooclo?olo?coooo0008oo?cl`;oool0L_oclo<2o`0001Golo?c00Go0000oo?clooclo?olo?c
ohX[hP05oo?cl`03ohX[h_oclo?olo?c00golo?c00GoRR_Roo?clooclo?olo?cohX[hP07oo?cl`03
ohX[h_oclo?olo?c06colo?c00?o0000oo?clooclo<01ooclo<2o`0000Colo?c00Co0000oo?clooc
lo?olo?c1Ol00003oo?cl`03o`000?oclo?olo?c00colo?c00?oof42oo?clooclo<03_oclo<00ooo
H@;olo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c06Kolo?c00?o0000oo?clooclo<03_oclo<0023o
lo?c00?o0000oo?clooclo<01ooclo<00oooo`3olo?coo?cl`06oo?cl`05oooo0?oclo?olo?coo?c
loooo`00OOoclo<00ol0003olo?coo?cl`0Coo?cl`;o00000_oclo<00on::n;olo?coo?cl`03oo?c
l`03ohX[h_oclo?olo?c00golo?c00GoRR_Roo?clooclo?olo?cohX[hP06oo?cl`03ohX[h_oclo?o
lo?c06colo?c0_l00008oo?cl`04o`000?oclo?olo?co`0000Solo?c00Co0000oo?clooclo?o0000
0ooclo<00ol0003olo?coo?cl`0<oo?cl`03oomQ0_oclo?olo?c00kolo?c00?oof42oo?clooclo<0
0ooclo<00oooH@;olo?coo?cl`1Uoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`000?oc
lo?olo?c00Oolo?c00?oool0oo?clooclo<01_oclo<01Oooo`3olo?coo?clooclo?oool007golo?c
00?o0000oo?clooclo<02ooclo<5o`0000?olo?c00Go0000oo?clooclo?olo?cohX[hP05oo?cl`03
ohX[h_oclo?olo?c00golo?c00GoRR_Roo?clooclo?olo?cohX[hP06oo?cl`03ohX[h_oclo?olo?c
06golo?c00?o0000oo?clol000001?l00002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00?o0000
oo?clooclo<00ooclo<2o`0000colo?c00?oof42oo?cloooH@803ooclo<00oooH@;olo?coo?cl`03
oo?cl`03oomQ0_oclo?olo?c06Colo?c0_l0000@oo?cl`008?oclo<00ol0003olo?coo?cl`07oo?c
l`03oooo0?oclo?olo?c00Kolo?c00Coool0oo?clooclo?oool0O_oclo<00ol0003olo?coo?cl`0<
oo?cl`04o`000?oclo?olo?co`0000?olo?c00Go0000oo?clooclo?olo?cohX[hP05oo?cl`03ohX[
h_oclo?olo?c00colo?c00?oRR_Roo?clooclo<00ooclo<00on::n;olo?coo?cl`03oo?cl`03ohX[
h_oclo?olo?c06golo?c00?o0000oo?clooclo<01_oclo<01?l0003olo?coo?clol0000:oo?cl`03
o`000?oclo?olo?c00;olo?c00?o0000oo?clooclo<02ooclo<01?ooH@;olo?coo?cloooH@8>oo?c
l`03oomQ0_oclo?olo?c00?olo?c00?oof42oo?clooclo<0IOoclo<00ol0003olo?coo?cl`0>oo?c
l`008?oclo<00ol0003olo?coo?cl`07oo?cl`03oooo0?oclo?olo?c00Kolo?c00Coool0oo?clooc
lo?oool0O_oclo<00ol0003olo?coo?cl`0=oo?cl`03o`000?oclo?olo?c00?olo?c0_l00002oo?c
l`03ohX[h_oclo?olo?c00?olo?c00?oRR_Roo?clooclo<03?oclo<00on::n;olo?coo?cl`03oo?c
l`03ohX[h_oclo?olo?c00?olo?c00?oRR_Roo?clooclo<0K?oclo<2o`0000Solo?c00Co0000oo?c
looclo?o00001ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooclo<02ooc
lo<01OooH@;olo?coo?clooclo?oof4200golo?c00?oof42oo?clooclo<00ooclo<00oooH@;olo?c
oo?cl`1Uoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`;o00002?oclo<00oooo`3olo?coo?c
l`07oo?cl`03oooo0?oclo?oool007golo?c0_l0000@oo?cl`03o`000?oclo?olo?c00;olo?c00?o
0000oo?clooclo<01ooclo<00on::n;olo?coo?cl`0<oo?cl`03ohX[h_oclo?olo?c00?olo?c00?o
RR_Roo?clooclo<00_oclo<00on::n;olo?coo?cl`1^oo?cl`03o`000?oclo?olo?c00Kolo?c00Co
0000oo?clooclo?o00001ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooc
lo<02_oclo<00oooH@;olo?coo?cl`03oo?cl`03oomQ0_oclo?olo?c00[olo?c00?oof42oo?clooc
lo<00ooclo<00oooH@;olo?coo?cl`1Uoo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`00
0?oclo?olo?c00Oolo?c00?oool0oo?clooclo<01ooclo<2oooo07oolo?c00?o0000oo?clooclo<0
2ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooclo<01ooclo<00on::n;o
lo?coo?cl`0<oo?cl`03ohX[h_oclo?olo?c00?olo?c00?oRR_Roo?clooclo<00_oclo<00on::n;o
lo?coo?cl`1^oo?cl`03o`000?oclo?olo?c00Oolo?c0_l00009oo?cl`?o00001?oclo<00ol0003o
lo?coo?cl`0:oo?cl`03oomQ0_oclo?olo?c00?olo?c00?oof42oo?clooclo<02_oclo<00oooH@;o
lo?coo?cl`03oo?cl`03oomQ0_oclo?olo?c06Golo?c00?o0000oo?clooclo<03_oclo<000oolo?c
0_l00004oo?cl`03o`000?oclo?olo?c00;olo?c0ol00003oo?cl`03o`000?oclo?olo?c00Oolo?c
00?oool0oo?clooclo<01ooclo<2oooo07oolo?c00?o0000oo?clooclo<02ooclo<01Ol0003olo?c
oo?clooclo?o000000?olo?c00?o0000oo?clooclo<01ooclo<00on::n;olo?coo?cl`0<oo?cl`03
ohX[h_oclo?olo?c00?olo?c00?oRR_Roo?clooclo<00_oclo<00on::n;olo?coo?cl`1^oo?cl`03
o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<02_oclo<00oooH@;olo?coo?cl`03oo?cl`03
oomQ0_oclo?olo?c00Wolo?c00?oof42oo?clooclo<01?oclo<00oooH@;olo?coo?cl`1Uoo?cl`03
o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oclo?olo?co`0000Oolo?c00Go0000oo?clooc
lo?olo?co`000002oo?cl`03o`000?oclo?olo?c00Oolo?c00?oool0oo?clooclo<01ooclo<2oooo
07oolo?c00?o0000oo?clooclo<03?oclo<3o`0000Colo?c0_l00008oo?cl`03ohX[h_oclo?olo?c
00_olo?c00?oRR_Roo?clooclo<01?oclo<01On::n;olo?coo?clooclo?oRR_R073olo?c0_l0000K
oo?cl`03o`000?oclo?olo?c00Wolo?c00?oof42oo?clooclo<01?oclo<00oooH@;olo?coo?cl`09
oo?cl`03oomQ0_oclo?olo?c00Golo?c00?oof42oo?clooclo<0I?oclo<00ol0003olo?coo?cl`0>
oo?cl`003_oclo<01?l0003olo?coo?clol00007oo?cl`05o`000?oclo?olo?coo?clol000000_oc
lo<00ol0003olo?coo?cl`07oo?cl`03oooo0?oclo?olo?c00Oolo?c00?oool0oo?clooclo<0O_oc
lo<00ol0003olo?coo?cl`0Coo?cl`03o`000?oclo?olo?c00Oolo?c00?oRR_Roo?clooclo<02ooc
lo<00on::n;olo?coo?cl`05oo?cl`03ohX[h_oclo?oRR_R07;olo?c00?o0000oo?clooclo<06Ooc
lo<00ol0003olo?coo?cl`09oo?cl`03oomQ0_oclo?olo?c00Golo?c00?oof42oo?clooclo<02?oc
lo<00oooH@;olo?coo?cl`05oo?cl`03oomQ0_oclo?olo?c06Colo?c00?o0000oo?clooclo<03_oc
lo<000kolo?c00Co0000oo?clooclo?o00001ooclo<4o`0000?olo?c0_l00008oo?cl`03oooo0?oc
lo?olo?c00Oolo?c00?oool0oo?clooclo<0OOoclo<2o`0001Golo?c00?o0000oo?clooclo<01ooc
lo<00on::n;olo?coo?cl`0;oo?cl`03ohX[h_oclo?olo?c00Golo?c0_n::n9coo?cl`03o`000?oc
lo?olo?c01Wolo?c00?o0000oo?clooclo<02Ooclo<00oooH@;olo?coo?cl`05oo?cl`03oomQ0_oc
lo?olo?c00Solo?c00?oof42oo?clooclo<01Ooclo<00oooH@;olo?coo?cl`1Too?cl`03o`000?oc
lo?olo?c00kolo?c000>oo?cl`04o`000?oclo?olo?co`0000Oolo?c00?o0000oo?clooclo<01?oc
lo<00ol0003olo?coo?cl`07oo?cl`03oooo0?oclo?olo?c08Solo?c00?o0000oo?clooclo<04ooc
lo<2o`0000Solo?c00?oRR_Roo?clooclo<02ooclo<00on::n;olo?coo?cl`05oo?cl`03ohX[h_oc
lo?olo?c077olo?c0_l0000Koo?cl`03o`000?oclo?olo?c00Solo?c00?oof42oo?clooclo<01_oc
lo<00oooH@;olo?coo?cl`04oo?cl`05oomQ0_oclo?olo?coo?cloooH@801ooclo<00oooH@;olo?c
oo?cl`1Too?cl`03o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oclo?olo?co`0000Solo?c
00?o0000oo?clooclo<00ooclo<00ol0003olo?coo?cl`07oo?cl`03oooo0?oclo?olo?c08Solo?c
00?o0000oo?clooclo<04ooclo<00ol0003olo?coo?cl`07oo?cl`03ohX[h_oclo?olo?c00_olo?c
00?oRR_Roo?clooclo<0N_oclo<00ol0003olo?coo?cl`0Ioo?cl`03o`000?oclo?olo?c00Solo?c
00?oof42oo?clooclo<01_oclo<00oooH@;olo?coo?cl`04oo?cl`05oomQ0_oclo?olo?coo?clooo
H@802?oclo<00oooH@;olo?coo?cl`1Soo?cl`03o`000?oclo?olo?c00kolo?c000?oo?cl`;o0000
2_oclo<2o`0000?olo?c00?o0000oo?clooclo<01_oclo<00oooo`3olo?coo?cl`29oo?cl`03o`00
0?oclo?olo?c01?olo?c00?o0000oo?clooclo<01ooclo<00on::n;olo?coo?cl`0:oo?cl`03ohX[
h_oclo?olo?c07_olo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`08oo?cl`03oomQ
0_oclo?olo?c00Kolo?c00?oof42oo?clooclo<01?oclo<01OooH@;olo?coo?clooclo?oof4200So
lo?c00?oof42oo?clooclo<0Hooclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<2o`0000Oolo?c
00?oool0oo?clooclo<0R?oclo<2o`0001Golo?c00?o0000oo?clooclo<01ooclo<00on::n;olo?c
oo?cl`0:oo?cl`03ohX[h_oclo?olo?c07_olo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?c
oo?cl`08oo?cl`03oomQ0_oclo?olo?c00Kolo?c00?oof42oo?clooclo<01?oclo<01OooH@;olo?c
oo?clooclo?oof4200Solo?c00?oof42oo?clooclo<02_oclo<7oomQ0U;olo?c00?o0000oo?clooc
lo<03_oclo<0023olo?c00?o0000oo?clooclo<01_oclo<00oooo`3olo?coo?cl`29oo?cl`03o`00
0?oclo?olo?c01?olo?c0_l00008oo?cl`03ohX[h_oclo?olo?c00[olo?c00?oRR_Roo?clooclo<0
N_oclo<2o`0001_olo?c00?o0000oo?clooclo<01ooclo<00oooH@;olo?coo?cl`07oo?cl`03oomQ
0_oclo?olo?c00?olo?c0_ooH@83oo?cl`03oomQ0_oclo?olo?c00Oolo?c00?oof42oo?clooclo<0
2?oclo<00oooH@;olo?coo?cl`05oo?cl`03oomQ0_oclo?olo?c04oolo?c00?o0000oo?clooclo<0
3_oclo<0023olo?c00?o0000oo?clooclo<01_oclo<00oooo`3olo?coo?cl`29oo?cl`03o`000?oc
lo?o000000Co00000ooclo<01?l0003olo?coo?clooclo<5o`0000?olo?c00?o0000oo?clooclo<0
2?oclo<00on::n;olo?coo?cl`09oo?cl`03ohX[h_oclo?olo?c07_olo?c00?o0000oo?clooclo<0
6Ooclo<00ol0003olo?coo?cl`07oo?cl`03oomQ0_oclo?olo?c00Solo?c00?oof42oo?clooclo<0
0_oclo<00oooH@;olo?coomQ0P02oo?cl`03oomQ0_oclo?olo?c00Oolo?c00?oof42oo?clooclo<0
1ooclo<00oooH@;olo?coo?cl`07oo?cl`?oof42C_oclo<00ol0003olo?coo?cl`0>oo?cl`008?oc
lo<00ol0003olo?coo?cl`06oo?cl`03oooo0?oclo?olo?c08Wolo?c00Co0000oo?clooclo?o0000
0_oclo<00ol0003olo?coo?cl`06oo?cl`04o`000?oclo?olo?co`0000?olo?c00?o0000oo?clooc
lo<02?oclo<00on::n;olo?coo?cl`08oo?cl`03ohX[h_oclo?olo?c07colo?c00?o0000oo?clooc
lo<06Ooclo<00ol0003olo?coo?cl`07oo?cl`03oomQ0_oclo?olo?c00Solo?c00?oof42oo?clooc
lo<00_oclo<00oooH@;olo?coomQ0P02oo?cl`03oomQ0_oclo?olo?c00Oolo?c00?oof42oo?clooc
lo<01Ooclo<2oomQ0Pgolo?cC?ooH@82oo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`00
0?oclo?olo?c00Kolo?c00?oool0oo?clooclo<0ROoclo<01Ol0003olo?coo?clooclo?o000000_o
lo?c00?o0000oo?clooclo<00ooclo<2o`0000Wolo?c00?oRR_Roo?clooclo<02?oclo<00on::n;o
lo?coo?cl`1koo?cl`;o00006ooclo<00ol0003olo?coo?cl`07oo?cl`03oomQ0_oclo?olo?c00So
lo?c00?oof42oo?clooclo<00_oclo<00oooH@;olo?coomQ0P02oo?cl`03oomQ0_oclo?olo?c00Oo
lo?c00?oof42oo?clooclo<01?oclo<00oooH@;olo?coo?cl`1Koo?cl`03o`000?oclo?olo?c00ko
lo?c000Poo?cl`;o00001ooclo<00oooo`3olo?coo?cl`28oo?cl`;o00001?oclo<00ol0003olo?c
oo?cl`09oo?cl`03o`000?oclo?olo?c00;olo?c00?o0000oo?clooclo<02?oclo<00on::n;olo?c
oo?cl`08oo?cl`03ohX[h_oclo?olo?c07colo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?c
oo?cl`06oo?cl`03oomQ0_oclo?olo?c00Wolo?c00?oof42oo?clooclo<00_oclo<00oooH@;olo?c
oomQ0P02oo?cl`03oomQ0_oclo?olo?c00Solo?c00?oof42oo?clooclo<00_oclo<00oooH@;olo?c
oo?cl`1Loo?cl`03o`000?oclo?olo?c00kolo?c000Poo?cl`03o`000?oclo?olo?c00Kolo?c00?o
ool0oo?clooclo<0ROoclo<00ol0003olo?co`000003oo?cl`03o`000?oclo?olo?c00Golo?c00Go
0000oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c00Solo?c00?oRR_Roo?clooclo<0
1ooclo<00on::n;olo?coo?cl`1moo?cl`03o`000?oclo?olo?c01Wolo?c00?o0000oo?clooclo<0
1_oclo<00oooH@;olo?coo?cl`09oo?cl`05oomQ0_oclo?olo?coo?cloooH@800_oclo<01?ooH@;o
lo?coo?cloooH@8:oo?cl`Goof42Gooclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<00ol0003o
lo?coo?cl`06oo?cl`03oooo0?oclo?olo?c08Wolo?c00?o0000oo?clol000000ooclo<00ol0003o
lo?coo?cl`05oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003olo?coo?cl`08oo?c
l`03ohX[h_oclo?olo?c00Oolo?c00?oRR_Roo?clooclo<0OOoclo<00ol0003olo?coo?cl`07oo?c
l`;o00001?oclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oclo<00ol0003olo?coo?cl`06oo?c
l`03oomQ0_oclo?olo?c00Wolo?c00Goof42oo?clooclo?olo?coomQ0P02oo?cl`04oomQ0_oclo?o
lo?coomQ0Vkolo?c00?o0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<01_oclo<0
0oooo`3olo?coo?cl`29oo?cl`03o`000?oclo?olo?c00?o00002Ooclo<3o`0000Colo?c0_l00009
oo?cl`03ohX[h_oclo?olo?c00Oolo?c00?oRR_Roo?clooclo<0O?oclo<2o`0000Solo?c00Co0000
oo?clooclo?o00002Ooclo<00ol0003olo?coo?cl`03oo?cl`03o`000?oclo?olo?c00Kolo?c00?o
of42oo?clooclo<02Ooclo<01OooH@;olo?coo?clooclo?oof4200;olo?c00Coof42oo?clooclo?o
of42K_oclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<00ol0003olo?coo?cl`06oo?cl`03oooo
0?oclo?olo?c08Wolo?c00?o0000oo?clooclo<04ooclo<00ol0003olo?coo?cl`08oo?cl`03ohX[
h_oclo?olo?c00Oolo?c00?oRR_Roo?clooclo<0OOoclo<00ol0003olo?co`000004o`0000;olo?c
00Co0000oo?clooclo?o00002Ooclo<00ol0003olo?coo?cl`03oo?cl`03o`000?oclo?olo?c00Ko
lo?c00?oof42oo?clooclo<02_oclo<01?ooH@;olo?coo?cloooH@83oo?cl`03oomQ0_oclo?oof42
06kolo?c00?o0000oo?clooclo<03_oclo<0023olo?c0_l00007oo?cl`03oooo0?oclo?olo?c08So
lo?c0_l0000Eoo?cl`03o`000?oclo?olo?c00Solo?c00?oRR_Roo?clooclo<01_oclo<00on::n;o
lo?coo?cl`1noo?cl`03o`000?oclo?olo?c00Kolo?c00Co0000oo?clooclo?o00002Ooclo<00ol0
003olo?coo?cl`03oo?cl`;o00001_oclo<00oooH@;olo?coo?cl`0;oo?cl`04oomQ0_oclo?olo?c
oomQ0P?olo?c00?oof42oo?cloooH@80KOoclo<2o`00013olo?c000Poo?cl`03o`000?oclo?olo?c
00Kolo?c00?oool0oo?clooclo<0ROoclo<00ol0003olo?coo?cl`0Coo?cl`;o00002Ooclo<00on:
:n;olo?coo?cl`05oo?cl`;oRR_ROooclo<2o`0000Solo?c00Co0000oo?clooclo?o00002Ooclo<0
0ol0003olo?coo?cl`03oo?cl`03o`000?oclo?olo?c00Golo?c00?oof42oo?clooclo<02ooclo<0
0oooH@;olo?coomQ0P04oo?cl`;oof42Kooclo<00ol0003olo?coo?cl`0>oo?cl`003ooclo<2o`00
00Colo?c00?o0000oo?clooclo<00_oclo<3o`0000?olo?c00?o0000oo?clooclo<01Ooclo<00ooo
o`3olo?coo?cl`2:oo?cl`03o`000?oclo?olo?c01?olo?c00?o0000oo?clooclo<02?oclo<00on:
:n;olo?coo?cl`03oo?cl`;oRR_RP_oclo<00ol0003olo?coo?cl`06oo?cl`04o`000?oclo?olo?c
o`0000Solo?c0_l00005oo?cl`03o`000?oclo?olo?c00Golo?c00?oof42oo?clooclo<02ooclo<0
0oooH@;olo?coomQ0P04oo?cl`;oof42Kooclo<00ol0003olo?coo?cl`0>oo?cl`003_oclo<01?l0
003olo?coo?clol00007oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<00ol0003olo?coo?c
l`05oo?cl`03oooo0?oclo?olo?c08[olo?c00?o0000oo?clooclo<04ooclo<00ol0003olo?coo?c
l`08oo?cl`03ohX[h_oclo?olo?c00;olo?c00?oRR_Roo?clooclo<0P_oclo<00ol0003olo?coo?c
l`07oo?cl`;o00002_oclo<00ol0003olo?coo?cl`03oo?cl`03o`000?oclo?olo?c00Golo?c00?o
of42oo?clooclo<02ooclo<00oooH@;olo?coomQ0P04oo?cl`;oof42Kooclo<00ol0003olo?coo?c
l`0>oo?cl`003_oclo<01?l0003olo?coo?clol00007oo?cl`05o`000?oclo?olo?coo?clol00000
0_oclo<2o`0000Kolo?c00?oool0oo?clooclo<0ROoclo<2o`0001Golo?c00?o0000oo?clooclo<0
2?oclo<00on::n;olo?coo?cl`02oo?cl`03ohX[h_oclo?olo?c08;olo?c00?o0000oo?clooclo<0
6Ooclo<00ol0003olo?coo?cl`04oo?cl`03oomQ0_oclo?olo?c00colo?c00?oof42oo?cloooH@80
1?oclo<2oomQ0Voolo?c00?o0000oo?clooclo<03_oclo<000kolo?c00Co0000oo?clooclo?o0000
2?oclo<3o`0000?olo?c00?o0000oo?clooclo<01Ooclo<00oooo`3olo?coo?cl`2:oo?cl`03o`00
0?oclo?olo?c01?olo?c0_l00009oo?cl`03ohX[h_oclo?olo?c00;olo?c00?oRR_Roo?clooclo<0
POoclo<2o`0001_olo?c00?o0000oo?clooclo<01?oclo<00oooH@;olo?coo?cl`0<oo?cl`03oomQ
0_oclo?oof4200Colo?c0_ooH@9_oo?cl`03o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oc
lo?olo?co`0000Oolo?c00Go0000oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?olo?c00Go
lo?c00?oool0oo?clooclo<0R_oclo<00ol0003olo?co`000004o`0000?olo?c00?o0000oo?clooc
lo<00ooclo<3o`0000?olo?c00?o0000oo?clooclo<02?oclo<00on::n;olo?coo?cl`02oo?cl`03
ohX[h_oclo?olo?c08;olo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`04oo?cl`03
oomQ0_oclo?olo?c00golo?c00?oof42oo?clooclo<01?oclo<00oooH@;olo?coo?cl`1]oo?cl`03
o`000?oclo?olo?c00kolo?c000>oo?cl`04o`000?oclo?olo?co`0000Oolo?c00Go0000oo?clooc
lo?olo?co`000002oo?cl`03o`000?oclo?olo?c00Golo?c00?oool0oo?clooclo<0R_oclo<01?l0
003olo?coo?clol00002oo?cl`03o`000?oclo?olo?c00Solo?c00?o0000oo?clooclo<00_oclo<0
0ol0003olo?coo?cl`08oo?cl`05ohX[h_oclo?olo?coo?clon::n80QOoclo<00ol0003olo?coo?c
l`0Ioo?cl`03o`000?oclo?olo?c00Colo?c00?oof42oo?clooclo<03Ooclo<00oooH@;olo?coo?c
l`04oo?cl`03oomQ0_oclo?olo?c06golo?c00?o0000oo?clooclo<03_oclo<000oolo?c0_l00009
oo?cl`?o00000ooclo<00ol0003olo?coo?cl`05oo?cl`03oooo0?oclo?olo?c08[olo?c00Go0000
oo?clooclo?olo?co`000009oo?cl`Go00000ooclo<2o`0000Wolo?c00GoRR_Roo?clooclo?olo?c
ohX[hP24oo?cl`;o00006ooclo<00ol0003olo?coo?cl`03oo?cl`03oomQ0_oclo?olo?c00kolo?c
00?oof42oo?clooclo<01?oclo<00oooH@;olo?coo?cl`1]oo?cl`03o`000?oclo?olo?c00kolo?c
000Poo?cl`;o00001_oclo<00oooo`3olo?coo?cl`29oo?cl`;o00001?oclo<00ol0003olo?coo?c
l`06oo?cl`04o`000?oclo?olo?co`0000Colo?c00?o0000oo?clooclo<02?oclo<01On::n;olo?c
oo?clooclo?oRR_R08Golo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`03oo?cl`03
oomQ0_oclo?olo?c01Golo?c00?oof42oo?clooclo<0KOoclo<00ol0003olo?coo?cl`0>oo?cl`00
8?oclo<00ol0003olo?coo?cl`05oo?cl`03oooo0?oclo?olo?c08[olo?c00?o0000oo?clol00000
0ooclo<00ol0003olo?coo?cl`06oo?cl`03o`000?oclo?o000000Colo?c00?o0000oo?clooclo<0
2?oclo<01On::n;olo?coo?clooclo?oRR_R08Golo?c00?o0000oo?clooclo<06Ooclo<00ol0003o
lo?coo?cl`03oo?cl`03oomQ0_oclo?olo?c08Golo?c00?o0000oo?clooclo<03_oclo<0023olo?c
00?o0000oo?clooclo<01?oclo<00oooo`3olo?coo?cl`2;oo?cl`03o`000?oclo?o000000?olo?c
00?o0000oo?clooclo<01ooclo<2o`0000Colo?c00?o0000oo?clooclo<02?oclo<01On::n;olo?c
oo?clooclo?oRR_R08Golo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?coo?cl`03oo?cl`03
oomQ0_oclo?olo?c08Golo?c00?o0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<0
1?oclo<00oooo`3olo?coo?cl`2;oo?cl`03o`000?oclo?olo?c00?o00002ooclo<00ol0003olo?c
oo?cl`02oo?cl`;o00002Ooclo<01?n::n;olo?coo?clon::n:5oo?cl`;o00006ooclo<00ol0003o
lo?coo?cl`02oo?cl`03oomQ0_oclo?olo?c08Kolo?c00?o0000oo?clooclo<03_oclo<0023olo?c
00?o0000oo?clooclo<01?oclo<00oooo`3olo?coo?cl`2;oo?cl`03o`000?oclo?olo?c01?olo?c
00?o0000oo?clooclo<02?oclo<01?n::n;olo?coo?clon::n:6oo?cl`03o`000?oclo?olo?c01Wo
lo?c00?o0000oo?clooclo<00_oclo<00oooH@;olo?coo?cl`26oo?cl`03o`000?oclo?olo?c00ko
lo?c000Poo?cl`;o00001Ooclo<00oooo`3olo?coo?cl`2:oo?cl`;o00005Ooclo<00ol0003olo?c
oo?cl`09oo?cl`03ohX[h_oclo?oRR_R08Kolo?c00?o0000oo?clooclo<06Ooclo<00ol0003olo?c
oo?cl`02oo?cl`03oomQ0_oclo?olo?c08Kolo?c00?o0000oo?clooclo<03_oclo<0023olo?c00?o
0000oo?clooclo<00ooclo<00oooo`3olo?coo?cl`2<oo?cl`03o`000?oclo?olo?c01?olo?c0_l0
000:oo?cl`03ohX[h_oclo?oRR_R08Golo?c0_l0000Koo?cl`03o`000?oclo?olo?c00;olo?c00?o
of42oo?clooclo<0Q_oclo<00ol0003olo?coo?cl`0>oo?cl`008?oclo<00ol0003olo?coo?cl`03
oo?cl`03oooo0?oclo?olo?c08colo?c00?o0000oo?clooclo<04ooclo<00ol0003olo?coo?cl`09
oo?cl`03ohX[h_oclo?oRR_R08Kolo?c00?o0000oo?clooclo<06Ooclo<01Ol0003olo?coo?clooc
lo?oof4208Wolo?c00?o0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<00ooclo<0
0oooo`3olo?coo?cl`2<oo?cl`03o`000?oclo?olo?c01?olo?c00?o0000oo?clooclo<02Ooclo<2
ohX[hXOolo?c00?o0000oo?clooclo<06Ooclo<01Ol0003olo?coo?clooclo?oof4208Wolo?c00?o
0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<00_oclo<00oooo`3olo?coo?cl`2=
oo?cl`03o`000?oclo?olo?c01?olo?c00?o0000oo?clooclo<02Ooclo<2ohX[hXOolo?c00?o0000
oo?clooclo<06Ooclo<01Ol0003olo?coo?clooclo?oof4208Wolo?c00?o0000oo?clooclo<03_oc
lo<0023olo?c0_l00003oo?cl`03oooo0?oclo?olo?c08colo?c0_l0000Eoo?cl`;o00002_oclo<2
ohX[hXKolo?c0_l0000Eoo?cl`;o00001?oclo<01Ol0003olo?coo?clooclo?oof4208Wolo?c00?o
0000oo?clooclo<03_oclo<0023olo?c00?o0000oo?clooclo<00_oclo<00oooo`3olo?coo?cl`2=
oo?cl`03o`000?oclo?o000000Co00000ooclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oclo<0
0ol0003olo?coo?cl`09oo?cl`;oRR_RQooclo<00ol0003olo?coo?cl`0Boo?cl`04o`000?oclo?o
lo?co`0000?olo?c00Co0000oo?clooclo?oof42R_oclo<00ol0003olo?coo?cl`0>oo?cl`006_oc
lo<3o`0000?olo?c00?o0000oo?clooclo<00_oclo<00oooo`3olo?coo?cl`2=oo?cl`04o`000?oc
lo?olo?co`0000;olo?c00?o0000oo?clooclo<01Ooclo<01Ol0003olo?coo?clooclo?o000000?o
lo?c00?o0000oo?clooclo<02Ooclo<2ohX[hXOolo?c00?o0000oo?clooclo<04_oclo<01?l0003o
lo?coo?clol00003oo?cl`;o000000?olo?coomQ0_oclo<0R?oclo<2o`00013olo?c000Koo?cl`03
o`000?oclo?olo?c00;olo?c00Go0000oo?clooclo?olo?coooo002@oo?cl`05o`000?oclo?olo?c
oo?clol000002Ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c0_l0000:oo?cl`03ohX[h_oc
lo?olo?c08Golo?c0_l0000Doo?cl`04o`000?oclo?olo?co`0000?olo?c00?o0000oo?clooclo<0
Rooclo<00ol0003olo?coo?cl`0>oo?cl`006ooclo<00ol0003olo?coo?cl`02oo?cl`;o00000_oc
lo<00oooo`3olo?coo?cl`2=oo?cl`;o00001?oclo<00ol0003olo?coo?cl`06oo?cl`Co00001?oc
lo<00ol0003olo?coo?cl`09oo?cl`03ohX[h_oclo?olo?c08Kolo?c00?o0000oo?clooclo<04_oc
lo<01?l0003olo?coo?clol00003oo?clhoo00004?oclo<001_olo?c00?o0000oo?clooclo<00_oc
lo<00ol0003olo?coo?cl`2Boo?cl`03o`000?oclo?o000000?olo?c00?o0000oo?clooclo<01Ooc
lo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00Wolo?c00?oRR_Roo?clooclo<0Q_oc
lo<00ol0003olo?coo?cl`0Boo?cl`04o`000?oclo?olo?co`000:;olo?c000Koo?cl`03o`000?oc
lo?olo?c00;olo?cU_l000000ooclo?o0000oo?cl`02oo?cl`03o`000?oclo?olo?c00Kolo?c00?o
0000oo?clooclo<01?oclo<00ol0003olo?coo?cl`2Boo?cl`03o`000?oclo?olo?c01?olo?c0_l0
002Soo?cl`006_oclo<2o`0009colo?c0ol0000:oo?cl`;o00001?oclo<2o`0000;olo?c00Go0000
oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?c
oo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?c
oo?clol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?c
o`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooclo?o0000
00?olo?c00Go0000oo?clooclo?olo?co`000004oo?cl`05o`000?oclo?olo?coo?clol000000ooc
lo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05
o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000
oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?c
oo?clooclo?o000000;olo?c0_l0002joo?cl`006ooclo<00ol0003olo?coo?cl`2]oo?cliKo0000
^_oclo<00?oolo?coooclo<Moo?cl`009?oclo<2o`00017olo?c0ol0000>oo?cl`?o00001?oclo<2
o`0000_olo?c0ol00003oo?cl`?o00002_oclo<5o`0000?olo?c0_l0000:oo?cl`Go00000_oclo<3
o`0000_olo?c0ol00004oo?cl`;o00002ooclo<3o`0000?olo?c0ol0003ooo?clfOolo?c000Soo?c
l`04o`000?oclo?olo?co`0000oolo?c00Go0000oo?clooclo?olo?co`00000>oo?cl`03o`000?oc
lo?olo?c00;olo?c00Co0000oo?clooclo?o00002ooclo<01Ol0003olo?coo?clooclo?o000000?o
lo?c00?o0000oo?clooclo<02?oclo<01?l0003olo?coo?clol00002oo?cl`04o`000?oclo?olo?c
o`0000[olo?c00Ko0000oo?clooclo?o0000oo?clol00003oo?cl`03o`000?oclo?olo?c00Oolo?c
00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Oo0000oo?c
looclo?olo?co`000?oclo?o000000?olo?c00?o0000oo?clooclo<0oooclo=Too?cl`008ooclo<0
1?l0003olo?coo?clol0000Coo?cl`03o`000?oclo?olo?c00colo?c00?o0000oo?clooclo<00_oc
lo<01?l0003olo?coo?clol0000;oo?cl`03o`000?oclo?olo?c00Golo?c00?o0000oo?clooclo<0
2Ooclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000_olo?c00?o0000oo?clooc
lo<01Ooclo<00ol0003olo?coo?cl`0;oo?cl`04o`000?oclo?olo?co`0000;olo?c00?o0000oo?c
looclo<02ooclo<00ol0003olo?coo?cl`03oo?cl`03o`000?oclo?olo?c0?oolo?cI?oclo<002?o
lo?c00Co0000oo?clooclo?o00004ooclo<00ol0003olo?coo?cl`0<oo?cl`03o`000?oclo?olo?c
00;olo?c00Co0000oo?clooclo?o00002ooclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?o
lo?c00[olo?c00Go0000oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?olo?c00[olo?c00?o
0000oo?clooclo<01?oclo<00ol0003olo?coo?cl`09oo?cl`;o00000ooclo<01?l0003olo?coo?c
lol0000;oo?cl`;o00001_oclo<00ol0003olo?coo?cl`3ooo?clfColo?c000Soo?cl`04o`000?oc
lo?olo?co`0000oolo?c1?l0000?oo?cl`03o`000?oclo?olo?c00;olo?c00Co0000oo?clooclo?o
00002ooclo<01?l0003olo?coo?clooclo<4o`0000[olo?c00Go0000oo?clooclo?olo?co`000002
oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Ko0000oo?clooclo?olo?co`000?oclo<4o`0000ko
lo?c00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?cl`0;oo?cl`03o`000?oclo?o0000
00?o00009?oclo<2o`00013olo?c0ol0000<oo?cl`?o00001?oclo<2o`0000[olo?c0ol00003oo?c
l`?o00002?oclo<5o`0000?olo?c0_l00009oo?cl`Go00000_oclo<3o`0000[olo?c0ol00004oo?c
l`;o00002Ooclo<3o`0000?olo?c0ol0002koo?cl`008ooclo<01?l0003olo?coo?clol0000?oo?c
l`03o`000?oclo?olo?c00oolo?c0_l00004oo?cl`04o`000?oclo?olo?co`0000[olo?c0_l00003
oo?cl`03o`000?oclo?olo?c00_olo?c00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oc
lo?olo?co`0000Wolo?c00Oo0000oo?clooclo?olo?co`000?oclo?o000000golo?c00Go0000oo?c
looclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Wolo?c00Oo0000oo?clooclo?olo?c
o`000?oclo?o000002Kolo?c00Co0000oo?clooclo?o00003_oclo<01Ol0003olo?coo?clooclo?o
000000colo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000:oo?cl`05o`000?oc
lo?olo?coo?clol000000ooclo<00ol0003olo?coo?cl`06oo?cl`04o`000?oclo?olo?co`0000;o
lo?c00Co0000oo?clooclo?o00002Ooclo<01_l0003olo?coo?clol0003olo?co`0000?olo?c00?o
0000oo?clooclo<01_oclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Co0000oo?clooclo?o
00001ooclo<01ol0003olo?coo?clooclo?o0000oo?clol000000ooclo<00ol0003olo?coo?cl`0Q
oo?cl`;o00004?oclo<3o`0000colo?c0ol00004oo?cl`;o00002_oclo<3o`0000?olo?c0ol00008
oo?cl`Go00000ooclo<2o`0000Wolo?c1Ol00002oo?cl`?o00002Ooclo<3o`0000Colo?c0_l0000:
oo?cl`?o00000ooclo<3o`00013olo?c000Too?cl`;o00004?oclo<5o`0000kolo?c00?o0000oo?c
looclo<00ooclo<2o`0000colo?c00Co0000oo?clooclo?olo?c1Ol0000:oo?cl`?o00001?oclo<2
o`0000_olo?c0ol00002oo?cl`Go00002_oclo<3o`0000Colo?c0_l0000;oo?cl`?o00000_oclo<5
o`0002;olo?c00Co0000oo?clooclo?o00004_oclo<00ol0003olo?coo?cl`0:oo?cl`03o`000?oc
lo?olo?c00;olo?c00Co0000oo?clooclo?o00002_oclo<00ol0003olo?coo?cl`05oo?cl`03o`00
0?oclo?olo?c00Oolo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000:oo?cl`03
o`000?oclo?olo?c00Golo?c00?o0000oo?clooclo<02_oclo<01?l0003olo?coo?clol00002oo?c
l`03o`000?oclo?olo?c00Wolo?c00?o0000oo?clooclo<00ooclo<00ol0003olo?coo?cl`0Poo?c
l`04o`000?oclo?olo?co`0000kolo?c00Go0000oo?clooclo?olo?co`00000<oo?cl`03o`000?oc
lo?olo?c00;olo?c00Co0000oo?clooclo?o00002_oclo<01Ol0003olo?coo?clooclo?o000000?o
lo?c00?o0000oo?clooclo<01_oclo<01?l0003olo?coo?clol00002oo?cl`04o`000?oclo?olo?c
o`0000Wolo?c00Ko0000oo?clooclo?o0000oo?clol00003oo?cl`03o`000?oclo?olo?c00Golo?c
00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Solo?c00Oo0000oo?c
looclo?olo?co`000?oclo?o000000?olo?c00?o0000oo?clooclo<03Ooclo<00=Solo?c00Co0000
oo?clooclo?o00004_oclo<00ol0003olo?coo?cl`0:oo?cl`03o`000?oclo?olo?c00;olo?c00Co
0000oo?clooclo?o00002_oclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00Solo?c
00Go0000oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?olo?c00Wolo?c00?o0000oo?clooc
lo<01?oclo<00ol0003olo?coo?cl`08oo?cl`;o00000ooclo<01?l0003olo?coo?clol00009oo?c
l`;o00001_oclo<00ol0003olo?coo?cl`0Poo?cl`04o`000?oclo?olo?co`0001;olo?c00?o0000
oo?clooclo<02_oclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000[olo?c00?o
0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`07oo?cl`03o`000?oclo?olo?c00;olo?c00Co
0000oo?clooclo?o00002_oclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00Wolo?c
00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?cl`0:oo?cl`03o`000?oclo?olo?c00?o
lo?c00?o0000oo?clooclo<03Ooclo<00=Solo?c00Co0000oo?clooclo?o00003_oclo<4o`0000go
lo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0000:oo?cl`04o`000?oclo?olo?c
oo?cl`Co00002?oclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Co0000oo?clooclo?o0000
2?oclo<01_l0003olo?coo?clooclo?o0000oo?cl`Co00003Ooclo<01?l0003olo?coo?clol00002
oo?cl`03o`000?oclo?olo?c00Wolo?c00?o0000oo?clol000000ol0000Soo?cl`04o`000?oclo?o
lo?co`0001;olo?c00?o0000oo?clooclo<02_oclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oc
lo?olo?co`0000[olo?c00?o0000oo?clooclo<01Ooclo<00ol0003olo?coo?cl`08oo?cl`05o`00
0?oclo?olo?coo?clol000000_oclo<00ol0003olo?coo?cl`09oo?cl`03o`000?oclo?olo?c00Co
lo?c00?o0000oo?clooclo<01ooclo<2o`0000?olo?c00Co0000oo?clooclo?o00002_oclo<2o`00
00Kolo?c00?o0000oo?clooclo<03Ooclo<00=Solo?c00Co0000oo?clooclo?o00003_oclo<00ol0
003olo?coo?cl`0=oo?cl`;o00001?oclo<01?l0003olo?coo?clol00009oo?cl`;o00000ooclo<0
0ol0003olo?coo?cl`09oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?c
lol00008oo?cl`07o`000?oclo?olo?coo?clol0003olo?co`00000<oo?cl`05o`000?oclo?olo?c
oo?clol000000_oclo<01?l0003olo?coo?clol00007oo?cl`07o`000?oclo?olo?coo?clol0003o
lo?co`00000Voo?cl`04o`000?oclo?olo?co`0000kolo?c1?l0000=oo?cl`03o`000?oclo?olo?c
00;olo?c00Co0000oo?clooclo?o00002_oclo<01?l0003olo?coo?clooclo<4o`0000Solo?c00Go
0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000Solo?c00Ko0000oo?clooc
lo?olo?co`000?oclo<4o`0000colo?c00Co0000oo?clooclo?o00000_oclo<00ol0003olo?coo?c
l`0:oo?cl`03o`000?oclo?o000000?o00004?oclo<0027olo?cU?l0000Too?cl`;o00003ooclo<5
o`0000colo?c00?o0000oo?clooclo<00ooclo<2o`0000_olo?c00Co0000oo?clooclo?olo?c1Ol0
0008oo?cl`?o00001?oclo<2o`0000[olo?c0ol00002oo?cl`Go00002Ooclo<3o`0000Colo?c0_l0
0009oo?cl`?o00000_oclo<5o`0002;olo?c00Co0000oo?clooclo?o00003_oclo<00ol0003olo?c
oo?cl`0=oo?cl`;o00001?oclo<01?l0003olo?coo?clol00009oo?cl`;o00000ooclo<00ol0003o
lo?coo?cl`09oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?clol00008
oo?cl`07o`000?oclo?olo?coo?clol0003olo?co`00000;oo?cl`05o`000?oclo?olo?coo?clol0
00000_oclo<01?l0003olo?coo?clol00008oo?cl`07o`000?oclo?olo?coo?clol0003olo?co`00
000Coo?cl`008Ooclo<01Ol0003olo?coo?clooclo?o000001?olo?c00?o0000oo?clooclo<04Ooc
lo<00ol0003olo?coo?cl`0Aoo?cl`03o`000?oclo?olo?c017olo?c00?o0000oo?clooclo<04Ooc
lo<00ol0003olo?coo?cl`0Aoo?cl`03o`000?oclo?olo?c017olo?c00Co0000oo?clooclo?o0000
cooclo<2o`0000oolo?c1Ol0000<oo?cl`03o`000?oclo?olo?c00?olo?c0_l0000;oo?cl`04o`00
0?oclo?olo?coo?cl`Go00002?oclo<3o`0000Colo?c0_l0000:oo?cl`?o00000_oclo<5o`0000So
lo?c0ol00004oo?cl`;o00002_oclo<3o`0000;olo?c1Ol0000?oo?cl`008Ooclo<2o`0000;olo?c
00?o003ooo?clooclo<0S?oclo<00ol0003olo?coo?cl`3ooo?clfGolo?c000Qoo?cl`05o`000?oc
lo?olo?coo?clol00?l0S_oclo<00ol0003olo?coo?cl`2coo?cl`?o00000ooclo<00ol0003olo?c
oo?cl`03oo?cl`03o`000?oclo?olo?c00;olo?c0ol0002Moo?cl`008Ooclo<01Ol0003olo?coo?c
looclo?o003o08kolo?c00?o0000oo?clooclo<04ooclo<3o`0000?olo?c0ol00004oo?clhWo0000
2ooclo<00ol0003olo?coo?cl`08oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003o
lo?coo?cl`2Joo?cl`003_oclo<3o`0000Colo?c0_l00004oo?cl`;o00001?oclo<2o`0000;olo?c
00?o003ooo?clooclo<0S?oclo<00ol0003olo?coo?cl`0Doo?cl`05o`000?oclo?olo?coo?clol0
00000ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o0000oo?clooclo<04?oclo<00ol0
003olo?coo?cl`0?oo?cl`03o`000?oclo?olo?c013olo?c00?o0000oo?clooclo<03ooclo<00ol0
003olo?coo?cl`0@oo?cl`03o`000?oclo?olo?c013olo?c00?o0000oo?clooclo<03ooclo<01?l0
003olo?coo?clol00002oo?cl`Go000000?olo?co`000?l000000ol0000:oo?cl`03o`000?oclo?o
lo?c00Colo?c00Co0000oo?clooclo?olo?cROl0000@oo?cl`003ooclo<00ol0003olo?coo?cl`02
oo?cl`04o`000?oclo?olo?co`0000;olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?c
oo?clooclo?o003o08kolo?c00?o0000oo?clooclo<03?oclo<5o`0000?olo?c00Go0000oo?clooc
lo?olo?co`000003oo?cl`04o`000?oclo?olo?coo?cl`;o000000?olo?co`3jV_l0nYX01Ol0nYYn
oo?cl`03o`000?oclo?olo?c00Kolo?c00Co0000oo?clooclo?o00002ooclo<00ol0003olo?coo?c
l`04oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01Ol0003olo?coo?clooclo?o000000;o
lo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<0
1Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?c
oo?clooclo?o000000?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o
000000;olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol00000
0_oclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0
003olo?coo?clooclo?o000000;olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oc
lo?olo?coo?clol000000_oclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooc
lo?o00000ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o0000oo?clooclo<03_oclo<0
00oolo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol00002oo?cl`04o`000?oclo?o
lo?co`0000?olo?c0_l00002oo?cl`03o`00oooclo?olo?c08_olo?c0_l0000Foo?cl`04o`000?oc
lo?olo?coo?cl`Co00001?oclo<00ol0003olo?coo?cl`07oo?cl`;o0?ZJO?oclo<00ol0003olo?c
oo?cl`07oo?cl`03o`000?oclo?o000000colo?c00?o0000oo?clol000000ol00004oo?cl`03o`00
0?oclo?olo?c00oolo?c00?oo`00oo?clooclo<0Looclo<00ol0003olo?coo?cl`0>oo?cl`003ooc
lo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000;olo?c00Co0000oo?clooclo?o
00000ooclo<01Ol0003olo?coo?clooclo?o003o08kolo?c00?o0000oo?clooclo<05?oclo<01Ol0
003olo?coo?clooclo?o000000Oolo?c00?o0000oo?clooclo<02Ooclo<00ol0nY[olo?coo?cl`1i
oo?cl`03o`000?oclo?olo?c00Solo?c0_l00008oo?cl`07o`000?oclo?olo?coo?clol0003olo?c
o`000007oo?cl`03o`000?oclo?olo?c00oolo?c00?oo`00oo?clooclo<0Looclo<00ol0003olo?c
oo?cl`0>oo?cl`003ooclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000;olo?c
00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o003o08kolo?c00?o0000oo?c
looclo<04ooclo<2o`0000Colo?c00?o0000oo?clooclo<01?oclo<2o`0000_olo?c00?o0?ZJoo?c
looclo<0N?oclo<00ol0003olo?coo?cl`09oo?cl`03o`000?oclo?olo?c00Kolo?c1Ol000000ooc
lo?o0000o`000003o`0000?olo?c00?o0000oo?clooclo<03_oclo<00ooo003olo?cool0001doo?c
l`03o`000?oclo?olo?c00kolo?c000>oo?cl`;o00001?oclo<01?l0003olo?coo?clol00002oo?c
l`04o`000?oclo?olo?co`0000?olo?c0_l00003oo?cl`03o`00oooclo?olo?c08_olo?c00?o0000
oo?clooclo<05?oclo<00ol0003olo?coo?cl`03oo?cl`;o00001?oclo<00ol0003olo?coo?cl`0;
oo?cl`;o0?ZJN?oclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c00kolo?c00Coo`00
oo?clooclo?oo`00Looclo<00ol0003olo?coo?cl`0>oo?cl`003ooclo<00ol0003olo?coo?cl`03
oo?cl`;o00001?oclo<2o`0000Colo?c00?o0000oo?clooclo<00_oclo<00ol00?oolo?coo?cl`2;
oo?cl`03o`000?oclo?olo?c023olo?c0_l0000>oo?cl`03o`3jV_oclo?olo?c07Golo?c00?o0000
oo?clooclo<08?oclo<00ol0003olo?coo?cl`0=oo?cl`05ool00?oclo?olo?coo?clooo0000Looc
lo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<00ol0003olo?coo?cl`02oo?cl`03o`00oooclo?o
lo?c08_olo?c00?o0000oo?clooclo<08?oclo<00ol0003olo?coo?cl`0>oo?cl`03o`3jV_oclo?o
lo?c07Colo?c00?o0000oo?clooclo<08?oclo<00ol0003olo?coo?cl`0=oo?cl`03ool00?oclo?o
lo?c00;olo?c00?oo`00oo?clooclo<0L?oclo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<2o`00
00?olo?c00?o003ooo?clooclo<0Rooclo<00ol0003olo?coo?cl`0Poo?cl`;o00004?oclo<2o`3j
VWColo?c00?o0000oo?clooclo<08?oclo<00ol0003olo?coo?cl`0=oo?cl`03ool00?oclo?olo?c
00?olo?c00?oo`00oo?clooclo<0Kooclo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<00ol0003o
lo?coo?cl`02oo?cl`03o`00oooclo?olo?c08_olo?c00?o0000oo?clooclo<08?oclo<00ol0003o
lo?coo?cl`0Aoo?cl`03o`3jV_oclo?olo?c077olo?c00?o0000oo?clooclo<03_oclo<3o`0000?o
lo?c00?o0000oo?clooclo<00_oclo<3o`0000Colo?c00?o0000oo?clooclo<03?oclo<00ooo003o
lo?coo?cl`04oo?cl`03ool00?oclo?olo?c06oolo?c00?o0000oo?clooclo<03_oclo<0027olo?c
00?o0000oo?clooclo<00_oclo<00ol00?oolo?coo?cl`2;oo?cl`03o`000?oclo?olo?c00Oolo?c
0ol00003oo?cl`?o00001?oclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oclo<2o`0001?olo?c
00?o0?ZJoo?clooclo<0L?oclo<00ol0003olo?coo?cl`0?oo?cl`03o`000?oclo?olo?c00Kolo?c
00Go0000oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c00colo?c00?oo`00oo?clooc
lo<01?oclo<00ooo003olo?coo?cl`1_oo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?cl`;o0000
0ooclo<00ol00?oolo?coo?cl`2;oo?cl`03o`000?oclo?olo?c00Solo?c00Go0000oo?clooclo?o
lo?co`000003oo?cl`03o`000?oclo?olo?c00Golo?c00Go0000oo?clooclo?olo?co`000003oo?c
l`03o`000?oclo?olo?c01?olo?c00?o0?ZJoo?clooclo<0Kooclo<00ol0003olo?coo?cl`06oo?c
l`Go000000?olo?co`000?l000000ol0000;oo?cl`05o`000?oclo?olo?coo?clol000003Ooclo<0
0ooo003olo?coo?cl`05oo?cl`03ool00?oclo?olo?c06oolo?c00?o0000oo?clooclo<03_oclo<0
027olo?c00?o0000oo?clooclo<00_oclo<00ol00?oolo?coo?cl`2;oo?cl`03o`000?oclo?olo?c
00Go00000ooclo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c00Wolo?c00Go0000oo?c
looclo?olo?co`00000Eoo?cl`03o`3jV_oclo?olo?c06oolo?c00?o0000oo?clooclo<03?oclo<0
1?l0003olo?coo?clol0000<oo?cl`04o`000?oclo?olo?coo?cl`;o00003?oclo<00ooo003olo?c
oo?cl`05oo?cl`03ool00?oclo?olo?c06kolo?c0_l0000@oo?cl`008Ooclo<2o`0000?olo?c00?o
003ooo?clooclo<0Rooclo<00ol0003olo?coo?cl`08oo?cl`03o`000?oclo?olo?c00Golo?c00?o
0000oo?clooclo<02Ooclo<01?l0003olo?coo?clooclo<2o`0001Golo?c00?o0?ZJoo?clooclo<0
K_oclo<00ol0003olo?coo?cl`0=oo?cl`03o`000?oclo?o000000Solo?c1?l00004oo?cl`03o`00
0?oclo?olo?c00_olo?c00?oo`00oo?clooclo<01Ooclo<00ooo003olo?coo?cl`1_oo?cl`03o`00
0?oclo?olo?c00kolo?c000>oo?cl`?o00000ooclo<3o`0000Colo?c0_l00004oo?cl`03o`000?oc
lo?olo?c00;olo?c00?o003ooo?clooclo<0Rooclo<00ol0003olo?coo?cl`08oo?cl`04o`000?oc
lo?olo?coo?cl`Co00002?oclo<4o`0000Colo?c00?o0000oo?clooclo<05Ooclo<00ol0nY[olo?c
oo?cl`1]oo?cl`03o`000?oclo?olo?c00kolo?c0_l00008oo?cl`03o`000?oclo?olo?c00Golo?c
00?o0000oo?clooclo<02ooclo<00ooo003olo?coo?cl`05oo?cl`03ool00?oclo?olo?c06oolo?c
00?o0000oo?clooclo<03_oclo<000oolo?c00?o0000oo?clooclo<00ooclo<00ol0003olo?coo?c
l`02oo?cl`04o`000?oclo?olo?co`0000?olo?c00?o0000oo?clooclo<00_oclo<00ol00?oolo?c
oo?cl`2;oo?cl`03o`000?oclo?olo?c00Oolo?c0_l00003oo?cl`03o`000?oclo?olo?c00Wolo?c
00?o0000oo?clooclo<01Ooclo<2o`0001Oolo?c00?o0?ZJoo?clooclo<0K?oclo<00ol0003olo?c
oo?cl`0?oo?cl`03o`000?oclo?olo?c00Kolo?c1Ol00003oo?cl`03o`000?oclo?olo?c00[olo?c
00?oo`00oo?clooclo<01_oclo<00ooo003olo?coo?cl`1_oo?cl`03o`000?oclo?olo?c00kolo?c
000?oo?cl`03o`000?oclo?olo?c00?olo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?c
lol00003oo?cl`;o00000ooclo<00ol00?oolo?coo?cl`2:oo?cl`;o00002_oclo<01?l0003olo?c
oo?clooclo<5o`0000Oolo?c1Ol00003oo?cl`03o`000?oclo?olo?c01Oolo?c00?o0?ZJoo?clooc
lo<0Jooclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c00[olo?c00?oo`00oo?clooc
lo<01_oclo<00ooo003olo?coo?cl`1_oo?cl`03o`000?oclo?olo?c00kolo?c000?oo?cl`03o`00
0?oclo?olo?c00?olo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol00003oo?cl`03
o`000?oclo?olo?c00;olo?c00?o003ooo?clooclo<0Rooclo<00ol0003olo?coo?cl`0Poo?cl`;o
00006?oclo<00ol0nY[olo?coo?cl`1[oo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?clooc
lo<02_oclo<00ooo003olo?coo?cl`06oo?cl`03ool00?oclo?olo?c06oolo?c00?o0000oo?clooc
lo<03_oclo<000oolo?c00?o0000oo?clooclo<00ooclo<00ol0003olo?coo?cl`02oo?cl`04o`00
0?oclo?olo?co`0000?olo?c00?o0000oo?clooclo<00_oclo<00ol00?oolo?coo?cl`2;oo?cl`03
o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<05ooclo<00ol0nY[olo?coo?cl`1[oo?cl`03
o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<02_oclo<00ooo003olo?coo?cl`06oo?cl`03
ool00?oclo?olo?c06oolo?c00?o0000oo?clooclo<03_oclo<000kolo?c0_l00004oo?cl`;o0000
1?oclo<01?l0003olo?coo?clol00003oo?cl`;o00000ooclo<00ol00?oolo?coo?cl`2;oo?cl`03
o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<05ooclo<00ol0nY[olo?coo?cl`1[oo?cl`03
o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<02_oclo<00ooo003olo?coo?cl`06oo?cl`03
ool00?oclo?olo?c06oolo?c00?o0000oo?clooclo<03_oclo<000oolo?c00?o0000oo?clooclo<0
0ooclo<00ol0003olo?coo?cl`03oo?cl`;o00001?oclo<00ol0003olo?coo?cl`03oo?cl`03o`00
oooclo?olo?c08[olo?c00?o0000oo?clooclo<08?oclo<2o`0001Wolo?c00?o0?ZJoo?clooclo<0
J_oclo<00ol0003olo?coo?cl`08oo?cl`?o00000ooclo<01?l0003olo?coo?clooclo<5o`0000;o
lo?c0ol00004oo?cl`03o`000?oclo?olo?c00[olo?c00?oo`00oo?clooclo<01_oclo<00ooo003o
lo?coo?cl`1_oo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?cl`03o`000?oclo?olo?c00?olo?c
00?o003ooo?clooclo<0R_oclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c01Solo?c
00?o0?ZJoo?clooclo<0J_oclo<00ol0003olo?coo?cl`09oo?cl`03o`000?oclo?olo?c00Oolo?c
00Ko0000oo?clooclo?o0000oo?clol00003oo?cl`05o`000?oclo?olo?coo?clol000003?oclo<0
0ooo003olo?coo?cl`07oo?cl`03ool00?oclo?olo?c06kolo?c00?o0000oo?clooclo<03_oclo<0
027olo?c0_l00004oo?cl`03o`00oooclo?olo?c08[olo?c00?o0000oo?clooclo<04ooclo<3o`00
00?olo?c0ol00004oo?cl`;o00006Ooclo<00ol0nY[olo?coo?cl`1Zoo?cl`03o`000?oclo?olo?c
00Go000000?olo?co`000?l000000ol00009oo?cl`03o`000?oclo?olo?c00Golo?c00Go0000oo?c
looclo?olo?co`00000;oo?cl`03ool00?oclo?olo?c00Solo?c00?oo`00oo?clooclo<0K_oclo<0
0ol0003olo?coo?cl`0>oo?cl`008Ooclo<00ol0003olo?coo?cl`03oo?cl`03o`00oooclo?olo?c
08[olo?c00?o0000oo?clooclo<05?oclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000
oo?clooclo?olo?co`00000Joo?cl`03o`3jV_oclo?olo?c06[olo?c00?o0000oo?clooclo<01_oc
lo<01?l0003olo?coo?clol0000;oo?cl`03o`000?oclo?olo?c00Colo?c00Co0000oo?clooclo?o
lo?c0_l0000:oo?cl`03ool00?oclo?olo?c00Solo?c00?oo`00oo?clooclo<0KOoclo<2o`00013o
lo?c000Qoo?cl`;o00001?oclo<00ol00?oolo?coo?cl`2:oo?cl`03o`000?oclo?olo?c00colo?c
1Ol00003oo?cl`03o`000?oclo?olo?c00Golo?c00Co0000oo?clooclo?olo?c0_l0000Ioo?cl`03
o`3jV_oclo?olo?c06[olo?c00?o0000oo?clooclo<01ooclo<00ol0003olo?co`000008oo?cl`06
o`000?oclo?olo?coo?clol0003olo?c1?l00004oo?cl`03o`000?oclo?olo?c00Wolo?c00?oo`00
oo?clooclo<02?oclo<00ooo003olo?coo?cl`1^oo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?c
l`03o`000?oclo?olo?c00?olo?c00?o003ooo?clooclo<0R_oclo<00ol0003olo?coo?cl`0Doo?c
l`03o`000?oclo?olo?c00Golo?c00Go0000oo?clooclo?olo?co`00000Joo?cl`03o`3jV_oclo?o
lo?c06[olo?c00?o0000oo?clooclo<02?oclo<2o`0000Solo?c00Oo0000oo?clooclo?olo?co`00
0?oclo?o000000Oolo?c00?o0000oo?clooclo<02Ooclo<00ooo003olo?coo?cl`08oo?cl`03ool0
0?oclo?olo?c06kolo?c00?o0000oo?clooclo<03_oclo<0027olo?c00?o0000oo?clooclo<00ooc
lo<00ol00?oolo?coo?cl`2:oo?cl`03o`000?oclo?olo?c01Colo?c00Co0000oo?clooclo?olo?c
1?l00004oo?cl`;o00006Ooclo<00ol0nY[olo?coo?cl`1Zoo?cl`03o`000?oclo?olo?c00Wolo?c
00?o0000oo?clooclo<01ooclo<3o`0000;olo?c1Ol00003oo?cl`03o`000?oclo?olo?c00Wolo?c
00?oo`00oo?clooclo<02?oclo<00ooo003olo?coo?cl`1^oo?cl`03o`000?oclo?olo?c00kolo?c
000>oo?cl`?o00000_oclo<5o`0000?olo?c0_l00004oo?cl`;o00001?oclo<00ol00?oolo?coo?c
l`2:oo?cl`03o`000?oclo?olo?c01?olo?c0_l00003oo?cl`03o`000?oclo?olo?c00Golo?c00?o
0000oo?clooclo<06Ooclo<00ol0nY[olo?coo?cl`1Yoo?cl`03o`000?oclo?olo?c023olo?c00?o
0000oo?clooclo<02Ooclo<00ooo003olo?coo?cl`08oo?cl`03ool00?oclo?olo?c06kolo?c00?o
0000oo?clooclo<03_oclo<000oolo?c00?o0000oo?clooclo<00_oclo<01?l0003olo?coo?clol0
0002oo?cl`04o`000?oclo?olo?co`0000?olo?c00?o0000oo?clooclo<00ooclo<00ol00?oolo?c
oo?cl`2:oo?cl`03o`000?oclo?olo?c01Colo?c00Co0000oo?clooclo?olo?c1Ol00003oo?cl`03
o`000?oclo?olo?c01Wolo?c00?o0?ZJoo?clooclo<0JOoclo<00ol0003olo?coo?cl`0Poo?cl`03
o`000?oclo?olo?c00Wolo?c00?oo`00oo?clooclo<02?oclo<00ooo003olo?coo?cl`1^oo?cl`03
o`000?oclo?olo?c00kolo?c000?oo?cl`03o`000?oclo?olo?c00?olo?c00?o0000oo?clooclo<0
0_oclo<01?l0003olo?coo?clol00003oo?cl`03o`000?oclo?olo?c00?olo?c00?o003ooo?clooc
lo<0R_oclo<00ol0003olo?coo?cl`0Poo?cl`;o00006_oclo<00ol0nY[olo?coo?cl`1Yoo?cl`03
o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<01?oclo<01Ooo003olo?coo?clooclo?oo`00
00_olo?c00?oo`00oo?clooclo<0K_oclo<00ol0003olo?coo?cl`0>oo?cl`003ooclo<00ol0003o
lo?coo?cl`04oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01?l0003olo?coo?clooclo<2
o`0000Colo?c00?o003ooo?clooclo<0ROoclo<2o`0002;olo?c00?o0000oo?clooclo<06Ooclo<0
0ol0nY[olo?coo?cl`1Yoo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<01?oclo<0
1Ooo003olo?coo?clooclo?oo`0000_olo?c00?oo`00oo?clooclo<0K_oclo<00ol0003olo?coo?c
l`0>oo?cl`003ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o0000
0_oclo<01Ol0003olo?coo?clooclo?o000000Golo?c00?o003ooo?clooclo<0R_oclo<00ol0003o
lo?coo?cl`0Poo?cl`;o00006_oclo<00ol0nY[olo?coo?cl`1Yoo?cl`03o`000?oclo?olo?c023o
lo?c00?o0000oo?clooclo<00ooclo<00ooo003olo?cool00002oo?cl`03ool00?oclo?olo?c00Wo
lo?c00?oo`00oo?clooclo<0K_oclo<00ol0003olo?coo?cl`0>oo?cl`003_oclo<2o`0000?olo?c
00Go0000oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000?olo?c00?o0000oo?c
looclo<00ooclo<00ol00?oolo?coo?cl`2:oo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?c
looclo<06Ooclo<00ol0nY[olo?coo?cl`1Yoo?cl`03o`000?oclo?olo?c01[olo?c0ol00003oo?c
l`03o`000?oclo?olo?c00;olo?c00Coo`00oo?clooclo?oo`000_oclo<00ooo003olo?coo?cl`09
oo?cl`03ool00?oclo?olo?c06kolo?c00?o0000oo?clooclo<03_oclo<000oolo?c00?o0000oo?c
looclo<00_oclo<3o`0000Colo?c0_l00004oo?cl`;o00001?oclo<00ol00?oolo?coo?cl`2:oo?c
l`03o`000?oclo?olo?c00Oolo?c0ol00004oo?cl`?o00000ooclo<00ol0003olo?coo?cl`02oo?c
l`?o00001?oclo<2o`0001[olo?c00?o0?ZJoo?clooclo<0JOoclo<00ol0003olo?coo?cl`0Koo?c
l`03o`000?oclo?olo?c00;olo?c00Go0000oo?clooclo?olo?cool00003oo?cl`04ool00?oclo?o
lo?cool000_olo?c00?oo`00oo?clooclo<0K_oclo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<0
0ol0003olo?coo?cl`03oo?cl`03o`00oooclo?olo?c08[olo?c00?o0000oo?clooclo<02?oclo<0
0ol0003olo?coo?cl`04oo?cl`03o`000?oclo?olo?c00Kolo?c00Go0000oo?clooclo?olo?co`00
0003oo?cl`03o`000?oclo?olo?c01[olo?c00?o0?ZJoo?clooclo<0J?oclo<00ol0003olo?coo?c
l`0Boo?cl`Go000000?olo?co`000?l000000ol00003oo?cl`;o000000?olo?cool00?oclo<01?oc
lo<00ooo003olo?cool0000;oo?cl`03ool00?oclo?olo?c06golo?c0_l0000@oo?cl`008Ooclo<2
o`0000Golo?c00?o003ooo?clooclo<0ROoclo<00ol0003olo?coo?cl`05o`0000?olo?c00Co0000
oo?clooclo?olo?c1Ol0000;oo?cl`05o`000?oclo?olo?coo?clol000007?oclo<00ol0nY[olo?c
oo?cl`1Xoo?cl`03o`000?oclo?olo?c01Solo?c00Co0000oo?clooclo?o00001?oclo<00ol0003o
lo?coo?cl`06oo?cl`03ool00?oclo?oo`0000_olo?c00?oo`00oo?clooclo<0K_oclo<00ol0003o
lo?coo?cl`0>oo?cl`008Ooclo<00ol0003olo?coo?cl`04oo?cl`03o`00oooclo?olo?c08Wolo?c
00?o0000oo?clooclo<02?oclo<01Ol0003olo?coo?clooclo?o000000;olo?c00?o0000oo?clooc
lo<02_oclo<01?l0003olo?coo?clooclo<2o`0001_olo?c00?o0?ZJoo?clooclo<0J?oclo<00ol0
003olo?coo?cl`0Ioo?cl`03o`000?oclo?o000000Colo?c00?o0000oo?clooclo<01_oclo<2ool0
00colo?c00?oo`00oo?clooclo<00ooclo<00ooo003olo?coo?cl`1Xoo?cl`03o`000?oclo?olo?c
00kolo?c000Qoo?cl`03o`000?oclo?olo?c00Colo?c00?o003ooo?clooclo<0ROoclo<00ol0003o
lo?coo?cl`08oo?cl`03o`000?oclo?olo?c00;olo?c00?o0000oo?clol000002?oclo<4o`0000Co
lo?c00?o0000oo?clooclo<06_oclo<00ol0nY[olo?coo?cl`1Xoo?cl`03o`000?oclo?olo?c01[o
lo?c0_l00004oo?cl`03o`000?oclo?olo?c00Oolo?c00?oo`00oo?clooclo<02_oclo<00ooo003o
lo?coo?cl`03oo?cl`;oo`00JOoclo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<2o`0000Golo?c
00?o003ooo?clooclo<0ROoclo<00ol0003olo?coo?cl`07oo?cl`;o00001Ooclo<2o`0000Solo?c
00?o0000oo?clooclo<01Ooclo<2o`0001colo?c00?o0?ZJoo?clooclo<0Iooclo<00ol0003olo?c
oo?cl`0Koo?cl`03o`000?oclo?olo?c00;olo?c00?o0000oo?clooclo<01ooclo<00ooo003olo?c
oo?cl`0:oo?cl`03ool00?oclo?olo?c00?olo?c00?oo`00oo?clooo0000J?oclo<00ol0003olo?c
oo?cl`0>oo?cl`008Ooclo<00ol0003olo?coo?cl`04oo?cl`03o`00oooclo?olo?c08Wolo?c00?o
0000oo?clooclo<02?oclo<00ol0003olo?coo?cl`04oo?cl`03o`000?oclo?olo?c00Kolo?c1Ol0
0003oo?cl`03o`000?oclo?olo?c01colo?c00?o0?ZJoo?clooclo<0I_oclo<00ol0003olo?coo?c
l`0Poo?cl`03o`000?oclo?olo?c01Colo?c00?oo`00oo?clooclo<00ooclo<01?oo003olo?coo?c
looo001Woo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?cl`03o`000?oclo?olo?c00Colo?c00?o
003ooo?clooclo<0ROoclo<00ol0003olo?coo?cl`0Poo?cl`;o00007Ooclo<00ol0nY[olo?coo?c
l`1Voo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<05?oclo<00ooo003olo?coo?c
l`03oo?cl`05ool00?oclo?olo?coo?clooo0000I_oclo<00ol0003olo?coo?cl`0>oo?cl`003_oc
lo<3o`0000?olo?c0ol00004oo?cl`;o00001?oclo<2o`0000Golo?c00?o003ooo?clooclo<0ROoc
lo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c01golo?c00?o0?ZJoo?clooclo<0IOoc
lo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c01Colo?c00?oo`00oo?clooclo<00ooc
lo<01Ooo003olo?coo?clooclo?oo`0006Kolo?c00?o0000oo?clooclo<03_oclo<000oolo?c00Go
0000oo?clooclo?olo?co`000003oo?cl`04o`000?oclo?olo?co`0000;olo?c00Go0000oo?clooc
lo?olo?co`000006oo?cl`03o`00oooclo?olo?c08Wolo?c00?o0000oo?clooclo<08?oclo<2o`00
01oolo?c00?o0?ZJoo?clooclo<0I?oclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c
01Colo?c00?oo`00oo?clooclo<00ooclo<01Ooo003olo?coo?clooclo?oo`0006Kolo?c00?o0000
oo?clooclo<03_oclo<000oolo?c00?o0000oo?clooclo<01Ooclo<01?l0003olo?coo?clol00002
oo?cl`05o`000?oclo?olo?coo?clol000001_oclo<00ol00?oolo?coo?cl`29oo?cl`03o`000?oc
lo?olo?c023olo?c00?o0000oo?clooclo<07_oclo<00ol0nY[olo?coo?cl`1Too?cl`03o`000?oc
lo?olo?c00Oolo?c0ol00004oo?cl`03o`000?oclo?olo?c00?olo?c00?o0000oo?clooclo<00_oc
lo<3o`0000Colo?c00?o0000oo?clooclo<05?oclo<00ooo003olo?coo?cl`02oo?cl`03ool00?oc
lo?olo?c00;olo?c00?oo`00oo?clooclo<0I?oclo<00ol0003olo?coo?cl`0>oo?cl`003ooclo<0
0ol0003olo?coo?cl`03oo?cl`;o00000ooclo<01?l0003olo?coo?clol00003oo?cl`;o00001Ooc
lo<00ol00?oolo?coo?cl`28oo?cl`;o00005Ooclo<3o`0000Colo?c0ol00003oo?cl`03o`000?oc
lo?olo?c01kolo?c00?o0?ZJoo?clooclo<0I?oclo<00ol0003olo?coo?cl`06oo?cl`05o`000?oc
lo?olo?coo?clol000002Ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooc
lo?olo?co`00000Foo?cl`03ool00?oclo?olo?c00;olo?c00?oo`00oo?clooclo<00ooclo<00ooo
003olo?coo?cl`1Soo?cl`03o`000?oclo?olo?c00kolo?c000?oo?cl`03o`000?oclo?olo?c00Go
lo?c00Co0000oo?clooclo?o00000_oclo<01Ol0003olo?coo?clooclo?o000000Kolo?c00?o003o
oo?clooclo<0ROoclo<00ol0003olo?coo?cl`0Doo?cl`03o`000?oclo?olo?c00Colo?c00?o0000
oo?clooclo<00_oclo<2o`00023olo?c00?o0?ZJoo?clooclo<0Hooclo<00ol0003olo?coo?cl`05
o`0000Golo?c00?o0000oo?clooclo<02?oclo<00ol0003olo?coo?cl`04oo?cl`05o`000?oclo?o
lo?coo?clol000005_oclo<00ooo003olo?coo?cl`02oo?cl`03ool00?oclo?olo?c00?olo?c00?o
o`00oo?clooclo<0Hooclo<00ol0003olo?coo?cl`0>oo?cl`003_oclo<2o`0000?olo?c00Go0000
oo?clooclo?olo?co`000002oo?cl`04o`000?oclo?olo?co`0000?olo?c0_l00005oo?cl`03o`00
oooclo?olo?c08Wolo?c00?o0000oo?clooclo<03?oclo<5o`0000?olo?c00Co0000oo?clooclo?o
lo?c1Ol00003oo?cl`03o`000?oclo?olo?c01oolo?c00?o0?ZJoo?clooclo<0Hooclo<00ol0003o
lo?coo?cl`08oo?cl`;o00002ooclo<00ol0003olo?coo?cl`04oo?cl`04o`000?oclo?olo?coo?c
l`;o00005_oclo<01Ooo003olo?coo?clooclo?oo`0000Golo?c00?oo`00oo?clooclo<0H_oclo<2
o`00013olo?c000?oo?cl`03o`000?oclo?olo?c00;olo?c0ol00004oo?cl`;o00001?oclo<00ol0
003olo?coo?cl`04oo?cl`03o`00oooclo?olo?c08Wolo?c00?o0000oo?clooclo<05?oclo<01Ol0
003olo?coo?clooclo?o000000;olo?c00?o0000oo?clooclo<00_oclo<2o`00023olo?c00?o0?ZJ
oo?clooclo<0Hooclo<00ol0003olo?coo?cl`0:oo?cl`03o`000?oclo?olo?c00Wolo?c00?o0000
oo?clol000000ol00004oo?cl`03o`000?oclo?olo?c01Golo?c00Goo`00oo?clooclo?olo?cool0
0005oo?cl`03ool00?oclo?olo?c06?olo?c00?o0000oo?clooclo<03_oclo<0027olo?c00?o0000
oo?clooclo<01?oclo<00ol00?oolo?coo?cl`29oo?cl`03o`000?oclo?olo?c01Colo?c00?o0000
oo?clooclo<00_oclo<00ol0003olo?co`000004oo?cl`03o`000?oclo?olo?c023olo?c00?o0?ZJ
oo?clooclo<0H_oclo<00ol0003olo?coo?cl`06oo?cl`05o`000?oclo?olo?coo?clol000001ooc
lo<01ol0003olo?coo?clooclo?o0000oo?clol000001ooclo<00ol0003olo?coo?cl`0Eoo?cl`05
ool00?oclo?olo?coo?clooo00001Ooclo<00ooo003olo?coo?cl`1Soo?cl`03o`000?oclo?olo?c
00kolo?c000Qoo?cl`;o00001Ooclo<00ol00?oolo?coo?cl`29oo?cl`03o`000?oclo?olo?c01?o
lo?c0_l00005oo?cl`;o00001?oclo<2o`00027olo?c00?o0?ZJoo?clooclo<0H_oclo<00ol0003o
lo?coo?cl`07oo?cl`?o00002?oclo<5o`000003oo?clol0003o000000?o00000ooclo<00ol0003o
lo?coo?cl`0Eoo?cl`05ool00?oclo?olo?coo?clooo00001Ooclo<00ooo003olo?coo?cl`1Soo?c
l`03o`000?oclo?olo?c00kolo?c000Qoo?cl`03o`000?oclo?olo?c00Golo?c00?o003ooo?clooc
lo<0R?oclo<00ol0003olo?coo?cl`0Doo?cl`03o`000?oclo?olo?c00Colo?c00?o0000oo?clooc
lo<00_oclo<00ol0003olo?coo?cl`0Poo?cl`03o`3jV_oclo?olo?c06;olo?c00?o0000oo?clooc
lo<08?oclo<00ol0003olo?coo?cl`0Eoo?cl`05ool00?oclo?olo?coo?clooo00001Ooclo<00ooo
003olo?coo?cl`1Soo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?cl`03o`000?oclo?olo?c00Go
lo?c00?o003ooo?clooclo<0R?oclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c027o
lo?c00?o0?ZJoo?clooclo<0HOoclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c01Go
lo?c00Goo`00oo?clooclo?olo?cool00006oo?cl`03ool00?oclo?olo?c06;olo?c00?o0000oo?c
looclo<03_oclo<0027olo?c0_l00006oo?cl`03o`00oooclo?olo?c08Solo?c00?o0000oo?clooc
lo<08?oclo<2o`0002;olo?c00?o0?ZJoo?clooclo<0HOoclo<00ol0003olo?coo?cl`0Poo?cl`03
o`000?oclo?olo?c01Golo?c00Goo`00oo?clooclo?olo?cool00006oo?cl`03ool00?oclo?olo?c
06;olo?c00?o0000oo?clooclo<03_oclo<0027olo?c00?o0000oo?clooclo<01Ooclo<00ol00?oo
lo?coo?cl`28oo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<08Ooclo<00ol0nY[o
lo?coo?cl`1Qoo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?clooclo<05Ooclo<01Ooo003o
lo?coo?clooclo?oo`0000Kolo?c00?oo`00oo?clooclo<0H_oclo<00ol0003olo?coo?cl`0>oo?c
l`008Ooclo<00ol0003olo?coo?cl`05oo?cl`03o`00oooclo?olo?c08Solo?c00?o0000oo?clooc
lo<08?oclo<2o`0002?olo?c00?o0?ZJoo?clooclo<0H?oclo<00ol0003olo?coo?cl`0Poo?cl`03
o`000?oclo?olo?c01Golo?c00Coo`00oo?clooclo?oo`001ooclo<00ooo003olo?coo?cl`1Roo?c
l`03o`000?oclo?olo?c00kolo?c000>oo?cl`?o00001?oclo<3o`0000?olo?c0_l00004oo?cl`;o
00001_oclo<00ol00?oolo?coo?cl`28oo?cl`03o`000?oclo?olo?c023olo?c00?o0000oo?clooc
lo<08_oclo<00ol0nY[olo?coo?cl`1Poo?cl`03o`000?oclo?olo?c00golo?c0ol00004oo?cl`03
o`000?oclo?olo?c00;olo?c0ol00004oo?cl`03o`000?oclo?olo?c01Golo?c00Coo`00oo?clooc
lo?oo`001ooclo<00ooo003olo?coo?cl`1Roo?cl`03o`000?oclo?olo?c00kolo?c000?oo?cl`03
o`000?oclo?olo?c00Colo?c00Go0000oo?clooclo?olo?co`000002oo?cl`05o`000?oclo?olo?c
oo?clol000001ooclo<00ol00?oolo?coo?cl`28oo?cl`03o`000?oclo?olo?c00Oolo?c0ol00003
oo?cl`?o00001?oclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oclo<2o`0002?olo?c00?o0?ZJ
oo?clooclo<0H?oclo<00ol0003olo?coo?cl`0<oo?cl`05o`000?oclo?olo?coo?clol000001ooc
lo<01Ol0003olo?coo?clooclo?o000000?olo?c00?o0000oo?clooclo<05Ooclo<01?oo003olo?c
oo?clooo0007oo?cl`03ool00?oclo?olo?c06;olo?c00?o0000oo?clooclo<03_oclo<000oolo?c
00Co0000oo?clooclo?olo?c1Ol00002oo?cl`04o`000?oclo?olo?co`0000?olo?c0_l00006oo?c
l`03o`00oooclo?olo?c08Oolo?c0_l0000:oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<0
0ol0003olo?coo?cl`05oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<00ol0003olo?coo?c
l`0Roo?cl`03o`3jV_oclo?olo?c063olo?c00?o0000oo?clooclo<01_oclo<5o`0000Golo?c00?o
0000oo?clooclo<02Ooclo<01?l0003olo?coo?clooclo<2o`0001Kolo?c00Coo`00oo?clooclo?o
o`001ooclo<00ooo003olo?coo?cl`1Qoo?cl`;o00004?oclo<000oolo?c00Go0000oo?clooclo?o
lo?co`000002oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01Ol0003olo?coo?clooclo?o
000000Oolo?c00?o003ooo?clooclo<0R?oclo<00ol0003olo?coo?cl`05o`0000?olo?c00?o0000
oo?clooclo<01Ooclo<00ol0003olo?coo?cl`09oo?cl`04o`000?oclo?olo?coo?cl`;o00008ooc
lo<00ol0nY[olo?coo?cl`1Poo?cl`03o`000?oclo?olo?c00kolo?c0_l0000<oo?cl`05o`000?oc
lo?olo?coo?clol000005ooclo<01?oo003olo?coo?clooo0008oo?cl`03ool00?oclo?olo?c067o
lo?c00?o0000oo?clooclo<03_oclo<000oolo?c00?o0000oo?clooclo<00_oclo<00ol0003olo?c
o`000003oo?cl`04o`000?oclo?olo?co`0000?olo?c00?o0000oo?clooclo<01Ooclo<00ol00?oo
lo?coo?cl`28oo?cl`03o`000?oclo?olo?c00Solo?c00?o0000oo?clooclo<00ooclo<2o`0000co
lo?c00Go0000oo?clooclo?olo?co`00000Uoo?cl`03o`3jV_oclo?olo?c05oolo?c00?o0000oo?c
looclo<04?oclo<00ol0003olo?coo?cl`05oo?cl`Co00001?oclo<00ol0003olo?coo?cl`0Eoo?c
l`04ool00?oclo?olo?cool000Solo?c00?oo`00oo?clooclo<0HOoclo<00ol0003olo?coo?cl`0>
oo?cl`003_oclo<2o`0000Golo?c0_l00003oo?cl`04o`000?oclo?olo?co`0000?olo?c0_l00007
oo?cl`03o`00oooclo?olo?c08Oolo?c00?o0000oo?clooclo<02?oclo<00ol0003olo?coo?cl`05
oo?cl`03o`000?oclo?olo?c00Golo?c1?l00004oo?cl`03o`000?oclo?olo?c02?olo?c00?o0?ZJ
oo?clooclo<0Gooclo<00ol0003olo?coo?cl`0<oo?cl`05o`000?oclo?olo?coo?clol000001ooc
lo<00ol0003olo?coo?cl`05oo?cl`03o`000?oclo?olo?c01Golo?c00Coo`00oo?clooclo?oo`00
2?oclo<00ooo003olo?coo?cl`1Qoo?cl`03o`000?oclo?olo?c00kolo?c000?oo?cl`03o`000?oc
lo?olo?c00Colo?c00?o0000oo?clooclo<00_oclo<2o`0000Colo?c00?o0000oo?clooclo<01_oc
lo<00ol00?oolo?coo?cl`27oo?cl`03o`000?oclo?olo?c00Oolo?c0_l00003oo?cl`05o`000?oc
lo?olo?coo?clol000001ooclo<00ol0003olo?coo?cl`05oo?cl`;o00009?oclo<00ol0nY[olo?c
oo?cl`1Ooo?cl`03o`000?oclo?olo?c00golo?c0ol00008oo?cl`Go00000ooclo<00ol0003olo?c
oo?cl`0Eoo?cl`04ool00?oclo?olo?cool000Solo?c00?oo`00oo?clooclo<0HOoclo<00ol0003o
lo?coo?cl`0>oo?cl`008Ooclo<00ol0003olo?coo?cl`06oo?cl`03o`00oooclo?olo?c08Oolo?c
00?o0000oo?clooclo<02?oclo<00ol0003olo?coo?cl`02oo?cl`?o00002?oclo<5o`0000?olo?c
00?o0000oo?clooclo<08ooclo<00ol0nY[olo?coo?cl`1Ooo?cl`03o`000?oclo?olo?c023olo?c
00?o0000oo?clooclo<05Ooclo<01?oo003olo?coo?clooo0008oo?cl`03ool00?oclo?olo?c067o
lo?c00?o0000oo?clooclo<03_oclo<0027olo?c0_l00008oo?cl`03o`00oooclo?olo?c08Kolo?c
00?o0000oo?clooclo<08?oclo<2o`0002Colo?c00?o0?ZJoo?clooclo<0Gooclo<00ol0003olo?c
oo?cl`0Poo?cl`03o`000?oclo?olo?c01Golo?c00Coo`00oo?clooclo?oo`002?oclo<00ooo003o
lo?coo?cl`1Qoo?cl`03o`000?oclo?olo?c00kolo?c000Qoo?cl`03o`000?oclo?olo?c00Oolo?c
00?o003ooo?clooclo<0Q_oclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c02Colo?c
00?o0?ZJoo?clooclo<0G_oclo<00ol0003olo?coo?cl`0Poo?cl`03o`000?oclo?olo?c01Golo?c
00Coo`00oo?clooclo?oo`002Ooclo<00ooo003olo?coo?cl`1Poo?cl`03o`000?oclo?olo?c00ko
lo?c000Qoo?cl`03o`000?oclo?olo?c00Oolo?c00?o003ooo?clooclo<0Q_oclo<00ol0003olo?c
oo?cl`0Poo?cl`;o00009Ooclo<00ol0nY[olo?coo?cl`1Noo?cl`03o`000?oclo?olo?c023olo?c
00?o0000oo?clooclo<05Ooclo<01?oo003olo?coo?clooo0009oo?cl`03ool00?oclo?olo?c063o
lo?c00?o0000oo?clooclo<03_oclo<0027olo?c0_l00008oo?cl`03o`00oooclo?olo?c08Kolo?c
00?o0000oo?clooclo<08?oclo<00ol0003olo?coo?cl`0Too?cl`03o`3jV_oclo?olo?c05kolo?c
00?o0000oo?clooclo<01ooclo<3o`0000Colo?c00Co0000oo?clooclo?olo?c1Ol00002oo?cl`?o
00001?oclo<00ol0003olo?coo?cl`0Eoo?cl`03ool00?oclo?oo`0000[olo?c00?oo`00oo?clooc
lo<0H?oclo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<00ol0003olo?coo?cl`08oo?cl`03o`00
oooclo?olo?c08Golo?c00?o0000oo?clooclo<04ooclo<3o`0000?olo?c0ol00004oo?cl`03o`00
0?oclo?olo?c02Colo?c00?o0?ZJoo?clooclo<0G_oclo<00ol0003olo?coo?cl`06oo?cl`05o`00
0?oclo?olo?coo?clol000002?oclo<01_l0003olo?coo?clol0003olo?co`0000?olo?c00Go0000
oo?clooclo?olo?co`00000Goo?cl`03ool00?oclo?oo`0000_olo?c00?oo`00oo?clooclo<0Gooc
lo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<2o`0000Wolo?c00?o003ooo?clooclo<0QOoclo<0
0ol0003olo?coo?cl`0Doo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01?l0003olo?coo?c
looclo<2o`0002Golo?c00?o0?ZJoo?clooclo<0G_oclo<00ol0003olo?coo?cl`05o`0000Golo?c
00?o0000oo?clooclo<01ooclo<00ol0003olo?coo?cl`05oo?cl`04o`000?oclo?olo?coo?cl`;o
00005_oclo<00ooo003olo?cool0000;oo?cl`03ool00?oclo?olo?c05kolo?c0_l0000@oo?cl`00
3_oclo<3o`0000?olo?c0ol00004oo?cl`;o00001?oclo<00ol0003olo?coo?cl`08oo?cl`03o`00
oooclo?olo?c08Golo?c00?o0000oo?clooclo<03?oclo<5o`0000?olo?c00?o0000oo?clooclo<0
1Ooclo<01Ol0003olo?coo?clooclo?o000002Kolo?c00?o0?ZJoo?clooclo<0G_oclo<00ol0003o
lo?coo?cl`08oo?cl`;o00002ooclo<00ol0003olo?coo?cl`04oo?cl`05o`000?oclo?olo?coo?c
lol000005ooclo<00ooo003olo?cool0000;oo?cl`03ool00?oclo?olo?c05oolo?c00?o0000oo?c
looclo<03_oclo<000oolo?c00Go0000oo?clooclo?olo?co`000003oo?cl`04o`000?oclo?olo?c
o`0000;olo?c00Go0000oo?clooclo?olo?co`00000;oo?cl`03o`00oooclo?olo?c08Colo?c00?o
0000oo?clooclo<05?oclo<00ol0003olo?coo?cl`03oo?cl`;o00001?oclo<2o`0002Kolo?c00?o
0?ZJoo?clooclo<0GOoclo<00ol0003olo?coo?cl`0:oo?cl`03o`000?oclo?olo?c00Golo?c00Ko
0000oo?clooclo?olo?co`000?oclo<4o`0000Colo?c00?o0000oo?clooclo<05Ooclo<00ooo003o
lo?cool0000;oo?cl`03ool00?oclo?olo?c05oolo?c00?o0000oo?clooclo<03_oclo<000oolo?c
00?o0000oo?clooclo<01Ooclo<01?l0003olo?coo?clol00002oo?cl`04o`000?oclo?olo?coo?c
l`;o00002_oclo<2o`00ohColo?c0_l0000Foo?cl`03o`000?oclo?olo?c00Golo?c00Go0000oo?c
looclo?olo?co`00000Woo?cl`03o`3jV_oclo?olo?c05golo?c00?o0000oo?clooclo<01_oclo<0
1Ol0003olo?coo?clooclo?o000000Oolo?c00Oo0000oo?clooclo?olo?co`000?oclo?o000000Oo
lo?c00?o0000oo?clooclo<05_oclo<2ool000colo?c00?oo`00oo?clooclo<0G_oclo<00ol0003o
lo?coo?cl`0>oo?cl`003ooclo<00ol0003olo?coo?cl`05oo?cl`04o`000?oclo?olo?co`0000;o
lo?c00Go0000oo?clooclo?olo?co`00000=oo?cl`03o`00oooclo?olo?c08;olo?c00?o0000oo?c
looclo<04ooclo<2o`0000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`;o00009_oclo<0
0ol0nY[olo?coo?cl`1Moo?cl`03o`000?oclo?olo?c00Oolo?c0ol00009oo?cl`?o00000_oclo<5
o`0000?olo?c00?o0000oo?clooclo<05_oclo<2ool000colo?c00Coo`00oo?clooclo?olo?c1?oo
000>oo?cldWoo`000_oclo<00ol0003olo?coo?cl`0>oo?cl`003ooclo<01?l0003olo?coo?clooc
lo<4o`0000?olo?c00Co0000oo?clooclo?o00000ooclo<00ol0003olo?coo?cl`0<oo?cl`03o`00
oooclo?olo?c087olo?c00?o0000oo?clooclo<05?oclo<00ol0003olo?coo?cl`02oo?cl`?o0000
1?oclo<00ol0003olo?coo?cl`0Uoo?cl`03o`3jV_oclo?olo?c05golo?c00?o0000oo?clooclo<0
8?oclo<00ol0003olo?coo?cl`0Foo?cl`;oo`003?oclo<01?oo003olo?coo?clooo0004oo?cl`ko
o`00Booclo<00ol0003olo?coo?cl`0>oo?cl`003_oclo<2o`0000?olo?c00?o0000oo?clooclo<0
1?oclo<01?l0003olo?coo?clol00003oo?cl`;o00003_oclo<00ol00?oolo?coo?cl`20oo?cl`03
o`000?oclo?olo?c023olo?c0_l0000Woo?cl`03o`3jV_oclo?olo?c05colo?c00?o0000oo?clooc
lo<08?oclo<00ol0003olo?coo?cl`0Foo?cl`;oo`003Ooclo<2ool005kolo?c00?o0000oo?clooc
lo<03_oclo<000oolo?c00Co0000oo?clooclo?olo?c1Ol00003oo?cl`;o00001?oclo<00ol0003o
lo?coo?cl`0>oo?cl`03o`00oooclo?olo?c07oolo?c00?o0000oo?clooclo<08?oclo<00ol0003o
lo?coo?cl`0Voo?cl`03o`3jV_oclo?olo?c05colo?c00?o0000oo?clooclo<08?oclo<00ol0003o
lo?coo?cl`0Foo?cl`;oo`003Ooclo<00ooo003olo?coo?cl`1Moo?cl`03o`000?oclo?olo?c00ko
lo?c000Qoo?cl`03o`000?oclo?olo?c00oolo?c00?o003ooo?clooclo<0O_oclo<00ol0003olo?c
oo?cl`0Poo?cl`03o`000?oclo?olo?c02Oolo?c00?o0?ZJoo?clooclo<0Fooclo<00ol0003olo?c
oo?cl`0Poo?cl`03o`000?oclo?olo?c01Kolo?c0_oo001]oo?cl`03o`000?oclo?olo?c00kolo?c
000Qoo?cl`;o00004Ooclo<00ol00?oolo?coo?cl`1moo?cl`03o`000?oclo?olo?c023olo?c0_l0
000Xoo?cl`03o`3jV_oclo?olo?c05_olo?c00?o0000oo?clooclo<06Ooclo<3o`0000Colo?c00?o
0000oo?clooclo<05_oclo<00ooo003olo?coo?cl`1/oo?cl`03o`000?oclo?olo?c00kolo?c000Q
oo?cl`03o`000?oclo?olo?c017olo?c1_l00?mioo?cl`03o`000?oclo?olo?c023olo?c00?o0000
oo?clooclo<0:?oclo<00ol0nY[olo?coo?cl`1Joo?cl`03o`000?oclo?olo?c01Solo?c00Go0000
oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c01Kolo?c00?oo`00oo?clooclo<0K?oc
lo<00ol0003olo?coo?cl`0>oo?cl`008Ooclo<2o`0001Solo?c0_l00?mgoo?cl`03o`000?oclo?o
lo?c00Oolo?c0ol00002oo?cl`Go00000ooclo<00ol0003olo?coo?cl`02oo?cl`?o00001?oclo<2
o`0002Wolo?c00?o0?ZJoo?clooclo<04ooclo=5o`3jVP;olo?c00?o0000oo?clooclo<04_oclo<5
o`0000Golo?c00Go0000oo?clooclo?olo?co`00000Hoo?cl`03ool00?oclo?olo?c06colo?c00?o
0000oo?clooclo<03_oclo<0027olo?c00?o0000oo?clooclo<06Ooclo<2o`00ogGolo?c00?o0000
oo?clooclo<02?oclo<00ol0003olo?coo?cl`02oo?cl`04o`000?oclo?olo?co`0000Oolo?c00Go
0000oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c02Wolo?c1ol0nYX:oo?cl`Co0?ZJ
Aooclo<00ol0003olo?coo?cl`0Joo?cl`;o00001?oclo<2o`0001Oolo?c00?oo`00oo?clooclo<0
Jooclo<2o`00013olo?c000Qoo?cl`03o`000?oclo?olo?c01_olo?c0_l00?mcoo?cl`03o`000?oc
lo?olo?c00Go00000ooclo<00ol0003olo?coo?cl`03oo?cl`03o`000?oclo?olo?c00_olo?c00Co
0000oo?clooclo?olo?c0_l0000aoo?cl`[o0?ZJBooclo<00ol0003olo?coo?cl`0Loo?cl`05o`00
0?oclo?olo?coo?clol000006?oclo<00ooo003olo?coo?cl`1/oo?cl`03o`000?oclo?olo?c00ko
lo?c000>oo?cl`?o00000ooclo<3o`0000Colo?c0_l00004oo?cl`;o00007_oclo<7o`00ofcolo?c
00?o0000oo?clooclo<02?oclo<00ol0003olo?coo?cl`04oo?cl`03o`000?oclo?olo?c00[olo?c
00Go0000oo?clooclo?olo?co`000002oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01?l0
003olo?coo?clol00003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01?l0003olo?coo?c
lol00003oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01Ol0003olo?coo?clooclo?o0000
00?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co
0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Go0000oo?clooc
lo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000_oclo<01Ol0003olo?coo?clooc
lo?o000000?olo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o000000?o
lo?c00Co0000oo?clooclo?o00000ooclo<01Ol0003olo?coo?clooclo?o000000;olo?c00Go0000
oo?clooclo?olo?co`000002oo?cl`03o`000?oclo?olo?c01Solo?c00Go0000oo?clooclo?olo?c
o`000003oo?cl`03o`000?oclo?olo?c01Kolo?c00?oo`00oo?clooclo<0K?oclo<00ol0003olo?c
oo?cl`0>oo?cl`003ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o
00000_oclo<01Ol0003olo?coo?clooclo?o000002Kolo?c2?l00?mToo?cl`03o`000?oclo?olo?c
00Solo?c00Go0000oo?clooclo?olo?co`000003oo?cl`03o`000?oclo?olo?c00Golo?c1?l00004
oo?clhWo00006ooclo<3o`0000Colo?c00Co0000oo?clooclo?o00004_oclo<00ol0003olo?coo?c
l`0?oo?cl`03o`000?oclo?olo?c013olo?c00?o0000oo?clooclo<03ooclo<00ol0003olo?coo?c
l`0@oo?cl`03o`000?oclo?olo?c00oolo?c00?o0000oo?clooclo<04?oclo<01?l0003olo?coo?c
lol0000@oo?cl`003ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Co0000oo?clooclo?o
00000_oclo<01Ol0003olo?coo?clooclo?o000002kolo?cH_l00?l2oo?cl`03o`000?oclo?olo?c
00Oolo?c0_l00003oo?cl`05o`000?oclo?olo?coo?clol000001ooclo<00ol0003olo?coo?cl`2`
oo?clhWo00004?oclo<000oolo?c00Co0000oo?clooclo?olo?c1?l00003oo?cl`04o`000?oclo?o
lo?co`0000?olo?c0_l00002oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?c
oo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?c
oo?clol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?c
o`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooclo?o0000
00?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooc
lo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000oo?clooclo?olo?co`000003oo?cl`05
o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?coo?clooclo?o000000?olo?c00Go0000
oo?clooclo?olo?co`000003oo?cl`05o`000?oclo?olo?coo?clol000000ooclo<01Ol0003olo?c
oo?clooclo?o000000?olo?c00Ko0000oo?clooclo?olo?co`000?oclo<2o`0000[olo?c00?o0000
oo?clooclo<00_oclo<3o`0000Solo?c1Ol0003ooo?cldSolo?c000?oo?cl`05o`000?oclo?olo?c
oo?clol000001_oclo<01?l0003olo?coo?clol00003oo?cliCo0000oooclo=Woo?cl`003_oclo<2
o`0000Colo?c00?o0000oo?clooclo<00ooclo<01?l0003olo?coo?clol0003ooo?clokolo?c000?
oo?cl`03o`000?oclo?olo?c00?olo?c0_l00004oo?cl`;o0000oooclo?ooo?cl`00oooclo?ooo?c
lagolo?c003ooo?clooolo?c7Ooclo<00?oolo?coooclo<Moo?cl`00oooclo?ooo?clagolo?c003o
oo?clooolo?c7Ooclo<00?oolo?coooclo<Moo?cl`00oooclo?ooo?clagolo?c003ooo?clooolo?c
7Ooclo<00?oolo?coooclo<Moo?cl`00\
\>"],
  ImageRangeCache->{{{0, 538.5}, {332.438, 0}} -> {-0.0767766, -0.0463623, \
0.00585619, 0.00585619}, {{13.0625, 183.812}, {324.5, 218.938}} -> {-10.9023, \
-1.47768, 0.258151, 0.0138357}, {{183.812, 354.625}, {324.5, 218.938}} -> \
{-54.9577, -6.64817, 0.258036, 0.0435133}, {{354.625, 525.375}, {324.5, \
218.938}} -> {-105.047, -24.3281, 0.269645, 0.2104}, {{13.0625, 183.812}, \
{218.938, 113.438}} -> {-9.0255, -1.27042, 0.247596, 0.0105994}, {{183.812, \
354.625}, {218.938, 113.438}} -> {-51.2812, -0.447876, 0.247491, 0.0143017}, \
{{354.625, 525.375}, {218.938, 113.438}} -> {-99.0768, -0.97951, 0.258151, \
0.00461307}, {{13.0625, 183.812}, {113.438, 7.875}} -> {-9.26617, -72.688, \
0.2499, 0.727708}, {{183.812, 354.625}, {113.438, 7.875}} -> {-58.9614, \
-26.3333, 0.26952, 0.0437544}, {{354.625, 525.375}, {113.438, 7.875}} -> \
{-105.047, -9.93123, 0.269645, 0.0220257}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["filtering and smoothing",
  FontColor->RGBColor[1, 0, 0]]], "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["states", "Subsection"],

Cell[CellGroupData[{

Cell["estimated parameters", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
period//Clear
period[omega02_,gamma_]:= 2 Pi/Sqrt[omega02 - gamma^2/4] //N;
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
period[-THETA[[1]],THETA[[2]]  ]
period[16,4]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(1.9786814288768366`\)], "Output"],

Cell[BoxData[
    \(1.813799364234218`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(THETA\)], "Input"],

Cell[BoxData[
    \({\(-12.591106424906169`\), \(-3.1671334282374266`\), 
      0.437459048381439`, 
      1.7164468069210659`, \(-0.13191627475468692`\), \
\(-0.5604328318674866`\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YG,PG,YF,PF,LIK} = 
\tMGLATT1[ZM,Xint,K,P,Q,n,np,T,DT,THETA,PHI,NONLIN,MISS];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-0.4112440068432943`\), 
        0.5368597890233188`, \(-0.055211469022736305`\), \
\(-0.45517390491189696`\), 0.36672640684195246`, \(-0.12479380433932591`\), 
        1.3797542127870763`, \(-0.6524215907377521`\), \(-0.3085947650263319`\
\), \(-1.5125188486349967`\)}, {\(-1.492397546590675`\), 
        0.24944288448585888`, \(-0.858136823237616`\), \(-1.6301663790788419`\
\), 1.0026990533699027`, \(-1.6218991659892485`\), \(-1.4779799581956927`\), \
\(-0.2471652765086586`\), \(-1.071336593797615`\), 
        1.5426200540044062`}}\)], "Print"],

Cell[BoxData[
    \({{\(-0.4089085096915397`\), 
        0.531268061412042`, \(-0.055852808333993934`\), \
\(-0.45247110390868106`\), 0.36255718757430444`, \(-0.12485335628300208`\), 
        1.367114930279583`, \(-0.6480695750110573`\), \
\(-0.3071175321439382`\), \(-1.5009754427766062`\)}, \
{\(-1.4923975400824356`\), 
        0.24944287883021032`, \(-0.8581368211586438`\), \
\(-1.6301663716085142`\), 
        1.002699042454`, \(-1.621899158576654`\), \(-1.4779799517881367`\), \
\(-0.24716527869631671`\), \(-1.071336590229793`\), 
        1.5426200393180443`}}\)], "Print"],

Cell[BoxData[
    \({{{0.008361135982780963`, 0.`}, {0.`, 
          6.9833536481584005`*^-9}}}\)], "Print"],

Cell[BoxData[
    \({2, 2, 1, 10, 1}\)], "Print"]
}, Open  ]],

Cell["\<\
graph//Clear
graph[Z_,Y_,YG_,PG_,tau_,pp_,nn_,plotrange_] := 

Module[{},

g1 = plot1[{DT(tau-1),Z[[tau,pp,nn]]}//Transpose,
\t\t\t\tPlotJoined->False,dicke->.02,
\t\t\t\tcolor->{10},DisplayFunction->Identity];
g2 = plot1[ Y[[T1//Range,{pp},nn]]//AddTimeAxis[#,DT]&,
            dicke->.001,
            DisplayFunction->Identity];
g3 = plot1[YG[[T1//Range,{pp},nn]]//AddTimeAxis[#,DT]&,
\t\t\t\tcolor->{2},
\t\t\t\tdicke -> .01,
\t\t\t\tDisplayFunction->Identity];
g4 = plot1[ConfidenceBand[YG,YG,PG,pp,nn,1.96]//AddTimeAxis[#,DT]&,
\t\t\t\t\tcolor->{1,2,6,6},
\t\t\t\t\tdicke->.001,
\t\t\t\t\tDisplayFunction->Identity ];
Show[g2,g3,g4,g1, DisplayFunction->Identity,
\t\t\t\t  PlotRange->plotrange]
]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["YG//Dimensions", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({101, 2, 10}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
glatt1 =  graph[Z,Y,YG,PG,tau1,1,1,{{-0.1,10.1},{-1,1}}];
glatt2 =  graph[Z,Y,YG,PG,tau2,2,1,{{-0.1,10.1},{-2,2}}];
filter1 = graph[Z,Y,YF,PF,tau1,1,1,{{-0.1,10.1},{-1,1}}];
filter2 = graph[Z,Y,YF,PF,tau2,2,1,{{-0.1,10.1},{-2,2}}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 2}\),
      SequenceForm[ "Dimension der Daten  ", {15, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{4, 2}\),
      SequenceForm[ "Dimension der Daten  ", {4, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 2}\),
      SequenceForm[ "Dimension der Daten  ", {15, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{4, 2}\),
      SequenceForm[ "Dimension der Daten  ", {4, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Show[GraphicsArray[{{filter1,glatt1},
\t\t\t\t\t{filter2,glatt2}} ]];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.154508 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -24 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -12 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -24 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -18 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -18 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-1.5)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-1)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.5)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(1)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(1.5)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(2)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .3515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .08699 m
.01961 .28625 L
.02941 .29821 L
.03922 .29225 L
.04902 .27921 L
.05882 .42997 L
.06863 .52627 L
.07843 .44098 L
.08824 .4912 L
.09804 .53359 L
.10784 .55182 L
.11765 .41564 L
.12745 .14889 L
.13725 .27876 L
.14706 .19507 L
.15686 .10718 L
.16667 .0936 L
.17647 .20584 L
.18627 .22099 L
.19608 .34588 L
.20588 .28149 L
.21569 .35991 L
.22549 .3511 L
.23529 .41499 L
.2451 .31679 L
.2549 .33935 L
.26471 .28585 L
.27451 .32521 L
.28431 .34354 L
.29412 .33235 L
.30392 .3644 L
.31373 .36726 L
.32353 .38155 L
.33333 .28835 L
.34314 .2774 L
.35294 .24397 L
.36275 .21875 L
.37255 .15731 L
.38235 .14252 L
.39216 .19833 L
.40196 .14113 L
.41176 .28076 L
.42157 .26654 L
.43137 .26164 L
.44118 .32872 L
.45098 .36755 L
.46078 .43962 L
.47059 .31157 L
.48039 .33404 L
.4902 .20253 L
Mistroke
.5 .26362 L
.5098 .36522 L
.51961 .44988 L
.52941 .38102 L
.53922 .30637 L
.54902 .38279 L
.55882 .30375 L
.56863 .28199 L
.57843 .33459 L
.58824 .33274 L
.59804 .438 L
.60784 .49963 L
.61765 .27546 L
.62745 .21995 L
.63725 .20663 L
.64706 .39623 L
.65686 .40258 L
.66667 .51694 L
.67647 .42166 L
.68627 .26448 L
.69608 .28613 L
.70588 .13121 L
.71569 .11973 L
.72549 .259 L
.73529 .16639 L
.7451 .21429 L
.7549 .35003 L
.76471 .42666 L
.77451 .42431 L
.78431 .23692 L
.79412 .29525 L
.80392 .41598 L
.81373 .47532 L
.82353 .52772 L
.83333 .3836 L
.84314 .23162 L
.85294 .25703 L
.86275 .12478 L
.87255 .09122 L
.88235 .2596 L
.89216 .20098 L
.90196 .33053 L
.91176 .23056 L
.92157 .17375 L
.93137 .28417 L
.94118 .27174 L
.95098 .2987 L
.96078 .47444 L
.97059 .42053 L
.98039 .39838 L
Mistroke
.9902 .3515 L
Mfstroke
0 .98 .604 r
gsave
.9902 .34509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .07843 m
.01961 .22512 L
.02941 .34095 L
.03922 .42193 L
.04902 .46887 L
.05882 .48123 L
.06863 .48126 L
.07843 .46289 L
.08824 .43307 L
.09804 .3981 L
.10784 .3757 L
.11765 .31019 L
.12745 .26234 L
.13725 .23247 L
.14706 .21888 L
.15686 .12596 L
.16667 .1748 L
.17647 .22471 L
.18627 .27007 L
.19608 .30728 L
.20588 .31659 L
.21569 .36995 L
.22549 .40232 L
.23529 .41593 L
.2451 .41444 L
.2549 .40209 L
.26471 .38315 L
.27451 .36144 L
.28431 .34002 L
.29412 .32111 L
.30392 .30604 L
.31373 .29537 L
.32353 .28906 L
.33333 .2866 L
.34314 .2872 L
.35294 .28996 L
.36275 .29401 L
.37255 .29856 L
.38235 .303 L
.39216 .30687 L
.40196 .30991 L
.41176 .34071 L
.42157 .35977 L
.43137 .36824 L
.44118 .36808 L
.45098 .36166 L
.46078 .35136 L
.47059 .33933 L
.48039 .32733 L
.4902 .31663 L
Mistroke
.5 .30797 L
.5098 .31433 L
.51961 .3184 L
.52941 .32036 L
.53922 .32057 L
.54902 .3195 L
.55882 .30793 L
.56863 .29963 L
.57843 .29457 L
.58824 .29244 L
.59804 .29265 L
.60784 .29455 L
.61765 .29749 L
.62745 .30085 L
.63725 .30418 L
.64706 .30712 L
.65686 .30946 L
.66667 .31112 L
.67647 .31211 L
.68627 .31249 L
.69608 .26147 L
.70588 .21851 L
.71569 .19688 L
.72549 .1931 L
.73529 .20272 L
.7451 .18607 L
.7549 .25543 L
.76471 .31169 L
.77451 .35238 L
.78431 .3774 L
.79412 .39879 L
.80392 .37017 L
.81373 .34278 L
.82353 .31923 L
.83333 .30097 L
.84314 .2947 L
.85294 .27074 L
.86275 .25737 L
.87255 .25314 L
.88235 .25603 L
.89216 .17921 L
.90196 .21851 L
.91176 .22163 L
.92157 .29703 L
.93137 .33513 L
.94118 .3601 L
.95098 .37283 L
.96078 .3753 L
.97059 .37001 L
.98039 .35965 L
Mistroke
.9902 .34509 L
Mfstroke
0 0 1 r
gsave
.9902 .34509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .07843 m
.01961 .22512 L
.02941 .34095 L
.03922 .42193 L
.04902 .46887 L
.05882 .48123 L
.06863 .48126 L
.07843 .46289 L
.08824 .43307 L
.09804 .3981 L
.10784 .3757 L
.11765 .31019 L
.12745 .26234 L
.13725 .23247 L
.14706 .21888 L
.15686 .12596 L
.16667 .1748 L
.17647 .22471 L
.18627 .27007 L
.19608 .30728 L
.20588 .31659 L
.21569 .36995 L
.22549 .40232 L
.23529 .41593 L
.2451 .41444 L
.2549 .40209 L
.26471 .38315 L
.27451 .36144 L
.28431 .34002 L
.29412 .32111 L
.30392 .30604 L
.31373 .29537 L
.32353 .28906 L
.33333 .2866 L
.34314 .2872 L
.35294 .28996 L
.36275 .29401 L
.37255 .29856 L
.38235 .303 L
.39216 .30687 L
.40196 .30991 L
.41176 .34071 L
.42157 .35977 L
.43137 .36824 L
.44118 .36808 L
.45098 .36166 L
.46078 .35136 L
.47059 .33933 L
.48039 .32733 L
.4902 .31663 L
Mistroke
.5 .30797 L
.5098 .31433 L
.51961 .3184 L
.52941 .32036 L
.53922 .32057 L
.54902 .3195 L
.55882 .30793 L
.56863 .29963 L
.57843 .29457 L
.58824 .29244 L
.59804 .29265 L
.60784 .29455 L
.61765 .29749 L
.62745 .30085 L
.63725 .30418 L
.64706 .30712 L
.65686 .30946 L
.66667 .31112 L
.67647 .31211 L
.68627 .31249 L
.69608 .26147 L
.70588 .21851 L
.71569 .19688 L
.72549 .1931 L
.73529 .20272 L
.7451 .18607 L
.7549 .25543 L
.76471 .31169 L
.77451 .35238 L
.78431 .3774 L
.79412 .39879 L
.80392 .37017 L
.81373 .34278 L
.82353 .31923 L
.83333 .30097 L
.84314 .2947 L
.85294 .27074 L
.86275 .25737 L
.87255 .25314 L
.88235 .25603 L
.89216 .17921 L
.90196 .21851 L
.91176 .22163 L
.92157 .29703 L
.93137 .33513 L
.94118 .3601 L
.95098 .37283 L
.96078 .3753 L
.97059 .37001 L
.98039 .35965 L
Mistroke
.9902 .34509 L
Mfstroke
0 .98 .604 r
gsave
.9902 .34509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .07843 m
.01961 .22512 L
.02941 .34095 L
.03922 .42193 L
.04902 .46887 L
.05882 .48123 L
.06863 .48126 L
.07843 .46289 L
.08824 .43307 L
.09804 .3981 L
.10784 .3757 L
.11765 .31019 L
.12745 .26234 L
.13725 .23247 L
.14706 .21888 L
.15686 .12596 L
.16667 .1748 L
.17647 .22471 L
.18627 .27007 L
.19608 .30728 L
.20588 .31659 L
.21569 .36995 L
.22549 .40232 L
.23529 .41593 L
.2451 .41444 L
.2549 .40209 L
.26471 .38315 L
.27451 .36144 L
.28431 .34002 L
.29412 .32111 L
.30392 .30604 L
.31373 .29537 L
.32353 .28906 L
.33333 .2866 L
.34314 .2872 L
.35294 .28996 L
.36275 .29401 L
.37255 .29856 L
.38235 .303 L
.39216 .30687 L
.40196 .30991 L
.41176 .34071 L
.42157 .35977 L
.43137 .36824 L
.44118 .36808 L
.45098 .36166 L
.46078 .35136 L
.47059 .33933 L
.48039 .32733 L
.4902 .31663 L
Mistroke
.5 .30797 L
.5098 .31433 L
.51961 .3184 L
.52941 .32036 L
.53922 .32057 L
.54902 .3195 L
.55882 .30793 L
.56863 .29963 L
.57843 .29457 L
.58824 .29244 L
.59804 .29265 L
.60784 .29455 L
.61765 .29749 L
.62745 .30085 L
.63725 .30418 L
.64706 .30712 L
.65686 .30946 L
.66667 .31112 L
.67647 .31211 L
.68627 .31249 L
.69608 .26147 L
.70588 .21851 L
.71569 .19688 L
.72549 .1931 L
.73529 .20272 L
.7451 .18607 L
.7549 .25543 L
.76471 .31169 L
.77451 .35238 L
.78431 .3774 L
.79412 .39879 L
.80392 .37017 L
.81373 .34278 L
.82353 .31923 L
.83333 .30097 L
.84314 .2947 L
.85294 .27074 L
.86275 .25737 L
.87255 .25314 L
.88235 .25603 L
.89216 .17921 L
.90196 .21851 L
.91176 .22163 L
.92157 .29703 L
.93137 .33513 L
.94118 .3601 L
.95098 .37283 L
.96078 .3753 L
.97059 .37001 L
.98039 .35965 L
Mistroke
.9902 .34509 L
Mfstroke
1 .38 .01 r
gsave
.9902 .54111 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .07845 m
.01961 .36698 L
.02941 .51151 L
.03922 .59964 L
s
.03922 .59964 m
.04304 .61803 L
s
.0855 .61803 m
.08824 .60894 L
.09804 .57542 L
.10784 .55723 L
.11765 .4965 L
.12745 .44355 L
.13725 .4092 L
.14706 .39628 L
.15686 .12599 L
.16667 .32527 L
.17647 .41369 L
.18627 .47178 L
.19608 .50925 L
.20588 .51256 L
.21569 .56243 L
.22549 .58504 L
.23529 .59244 L
.2451 .5918 L
.2549 .58569 L
.26471 .57476 L
.27451 .55998 L
.28431 .54318 L
.29412 .52656 L
.30392 .51214 L
.31373 .50128 L
.32353 .49458 L
.33333 .49191 L
.34314 .49256 L
.35294 .49558 L
.36275 .49995 L
.37255 .50478 L
.38235 .5094 L
.39216 .51336 L
.40196 .51642 L
.41176 .53964 L
.42157 .54566 L
.43137 .54577 L
.44118 .54559 L
.45098 .54539 L
.46078 .54337 L
.47059 .53851 L
.48039 .53118 L
.4902 .52269 L
.5 .5145 L
.5098 .51324 L
.51961 .50424 L
.52941 .49784 L
.53922 .49804 L
.54902 .5032 L
.55882 .49993 L
Mistroke
.56863 .4988 L
.57843 .49842 L
.58824 .49849 L
.59804 .49918 L
.60784 .5007 L
.61765 .50311 L
.62745 .50619 L
.63725 .50955 L
.64706 .51274 L
.65686 .51542 L
.66667 .51737 L
.67647 .51854 L
.68627 .51901 L
.69608 .26149 L
.70588 .35982 L
.71569 .36625 L
.72549 .36924 L
.73529 .37913 L
.7451 .35768 L
.7549 .43593 L
.76471 .49009 L
.77451 .52822 L
.78431 .55472 L
.79412 .58024 L
.80392 .55643 L
.81373 .52396 L
.82353 .49595 L
.83333 .47838 L
.84314 .47624 L
.85294 .45708 L
.86275 .4386 L
.87255 .4299 L
.88235 .43345 L
.89216 .17923 L
.90196 .35947 L
.91176 .38269 L
.92157 .45534 L
.93137 .50594 L
.94118 .53208 L
.95098 .54504 L
.96078 .55092 L
.97059 .55207 L
.98039 .54914 L
.9902 .54111 L
Mfstroke
gsave
.9902 .14906 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .0784 m
.01961 .08327 L
.02941 .1704 L
.03922 .24423 L
.04902 .29089 L
.05882 .30808 L
.06863 .30003 L
.07843 .28423 L
.08824 .25719 L
.09804 .22078 L
.10784 .19417 L
.11765 .12388 L
.12745 .08114 L
.13725 .05573 L
.14706 .04147 L
.15686 .12594 L
.16667 .02432 L
.17647 .03572 L
.18627 .06836 L
.19608 .10532 L
.20588 .12062 L
.21569 .17747 L
.22549 .2196 L
.23529 .23943 L
.2451 .23708 L
.2549 .21848 L
.26471 .19154 L
.27451 .1629 L
.28431 .13687 L
.29412 .11565 L
.30392 .09994 L
.31373 .08947 L
.32353 .08355 L
.33333 .08129 L
.34314 .08183 L
.35294 .08434 L
.36275 .08807 L
.37255 .09235 L
.38235 .09659 L
.39216 .10038 L
.40196 .10339 L
.41176 .14179 L
.42157 .17389 L
.43137 .1907 L
.44118 .19057 L
.45098 .17793 L
.46078 .15934 L
.47059 .14016 L
.48039 .12348 L
.4902 .11058 L
Mistroke
.5 .10144 L
.5098 .11542 L
.51961 .13255 L
.52941 .14287 L
.53922 .14311 L
.54902 .1358 L
.55882 .11593 L
.56863 .10046 L
.57843 .09073 L
.58824 .08638 L
.59804 .08612 L
.60784 .0884 L
.61765 .09186 L
.62745 .09551 L
.63725 .09881 L
.64706 .10149 L
.65686 .1035 L
.66667 .10488 L
.67647 .10567 L
.68627 .10598 L
.69608 .26144 L
.70588 .0772 L
.71569 .02752 L
.72549 .01696 L
.73529 .02632 L
.7451 .01446 L
.7549 .07494 L
.76471 .13329 L
.77451 .17655 L
.78431 .20009 L
.79412 .21734 L
.80392 .1839 L
.81373 .1616 L
.82353 .1425 L
.83333 .12357 L
.84314 .11316 L
.85294 .0844 L
.86275 .07613 L
.87255 .07638 L
.88235 .07861 L
.89216 .17918 L
.90196 .07754 L
.91176 .06058 L
.92157 .13871 L
.93137 .16431 L
.94118 .18812 L
.95098 .20063 L
.96078 .19968 L
.97059 .18796 L
.98039 .17016 L
Mistroke
.9902 .14906 L
Mfstroke
0 g
gsave
.89216 .17921 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .07843 Mdot
.15686 .12596 Mdot
.69608 .26147 Mdot
.89216 .17921 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.154508 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -24 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -12 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -24 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -18 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -18 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-1.5)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-1)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.5)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(1)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(1.5)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(2)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .3515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .08699 m
.01961 .28625 L
.02941 .29821 L
.03922 .29225 L
.04902 .27921 L
.05882 .42997 L
.06863 .52627 L
.07843 .44098 L
.08824 .4912 L
.09804 .53359 L
.10784 .55182 L
.11765 .41564 L
.12745 .14889 L
.13725 .27876 L
.14706 .19507 L
.15686 .10718 L
.16667 .0936 L
.17647 .20584 L
.18627 .22099 L
.19608 .34588 L
.20588 .28149 L
.21569 .35991 L
.22549 .3511 L
.23529 .41499 L
.2451 .31679 L
.2549 .33935 L
.26471 .28585 L
.27451 .32521 L
.28431 .34354 L
.29412 .33235 L
.30392 .3644 L
.31373 .36726 L
.32353 .38155 L
.33333 .28835 L
.34314 .2774 L
.35294 .24397 L
.36275 .21875 L
.37255 .15731 L
.38235 .14252 L
.39216 .19833 L
.40196 .14113 L
.41176 .28076 L
.42157 .26654 L
.43137 .26164 L
.44118 .32872 L
.45098 .36755 L
.46078 .43962 L
.47059 .31157 L
.48039 .33404 L
.4902 .20253 L
Mistroke
.5 .26362 L
.5098 .36522 L
.51961 .44988 L
.52941 .38102 L
.53922 .30637 L
.54902 .38279 L
.55882 .30375 L
.56863 .28199 L
.57843 .33459 L
.58824 .33274 L
.59804 .438 L
.60784 .49963 L
.61765 .27546 L
.62745 .21995 L
.63725 .20663 L
.64706 .39623 L
.65686 .40258 L
.66667 .51694 L
.67647 .42166 L
.68627 .26448 L
.69608 .28613 L
.70588 .13121 L
.71569 .11973 L
.72549 .259 L
.73529 .16639 L
.7451 .21429 L
.7549 .35003 L
.76471 .42666 L
.77451 .42431 L
.78431 .23692 L
.79412 .29525 L
.80392 .41598 L
.81373 .47532 L
.82353 .52772 L
.83333 .3836 L
.84314 .23162 L
.85294 .25703 L
.86275 .12478 L
.87255 .09122 L
.88235 .2596 L
.89216 .20098 L
.90196 .33053 L
.91176 .23056 L
.92157 .17375 L
.93137 .28417 L
.94118 .27174 L
.95098 .2987 L
.96078 .47444 L
.97059 .42053 L
.98039 .39838 L
Mistroke
.9902 .3515 L
Mfstroke
0 .98 .604 r
gsave
.9902 .34509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .07843 m
.01961 .21339 L
.02941 .32692 L
.03922 .41594 L
.04902 .48083 L
.05882 .52398 L
.06863 .54259 L
.07843 .53425 L
.08824 .50278 L
.09804 .45199 L
.10784 .3856 L
.11765 .31538 L
.12745 .25249 L
.13725 .19895 L
.14706 .15626 L
.15686 .12596 L
.16667 .14272 L
.17647 .17039 L
.18627 .20848 L
.19608 .25706 L
.20588 .31621 L
.21569 .3702 L
.22549 .40397 L
.23529 .4196 L
.2451 .42041 L
.2549 .41026 L
.26471 .39295 L
.27451 .37174 L
.28431 .34923 L
.29412 .32718 L
.30392 .30669 L
.31373 .28832 L
.32353 .27234 L
.33333 .259 L
.34314 .2487 L
.35294 .24217 L
.36275 .24051 L
.37255 .24513 L
.38235 .25755 L
.39216 .2791 L
.40196 .31053 L
.41176 .34007 L
.42157 .3562 L
.43137 .36046 L
.44118 .35544 L
.45098 .34437 L
.46078 .33064 L
.47059 .3175 L
.48039 .30779 L
.4902 .30368 L
Mistroke
.5 .3065 L
.5098 .31105 L
.51961 .31189 L
.52941 .3097 L
.53922 .30557 L
.54902 .30088 L
.55882 .28749 L
.56863 .28021 L
.57843 .27999 L
.58824 .28717 L
.59804 .30142 L
.60784 .32166 L
.61765 .34603 L
.62745 .37184 L
.63725 .3956 L
.64706 .41314 L
.65686 .4199 L
.66667 .41133 L
.67647 .38345 L
.68627 .33364 L
.69608 .26147 L
.70588 .16765 L
.71569 .1152 L
.72549 .1067 L
.73529 .14104 L
.7451 .21378 L
.7549 .29708 L
.76471 .36298 L
.77451 .40655 L
.78431 .42538 L
.79412 .41933 L
.80392 .40016 L
.81373 .3799 L
.82353 .35938 L
.83333 .33835 L
.84314 .31587 L
.85294 .29177 L
.86275 .26606 L
.87255 .23819 L
.88235 .20863 L
.89216 .17921 L
.90196 .18869 L
.91176 .23217 L
.92157 .27887 L
.93137 .30282 L
.94118 .31454 L
.95098 .31773 L
.96078 .31731 L
.97059 .31864 L
.98039 .32664 L
Mistroke
.9902 .34509 L
Mfstroke
0 0 1 r
gsave
.9902 .34509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .07843 m
.01961 .21339 L
.02941 .32692 L
.03922 .41594 L
.04902 .48083 L
.05882 .52398 L
.06863 .54259 L
.07843 .53425 L
.08824 .50278 L
.09804 .45199 L
.10784 .3856 L
.11765 .31538 L
.12745 .25249 L
.13725 .19895 L
.14706 .15626 L
.15686 .12596 L
.16667 .14272 L
.17647 .17039 L
.18627 .20848 L
.19608 .25706 L
.20588 .31621 L
.21569 .3702 L
.22549 .40397 L
.23529 .4196 L
.2451 .42041 L
.2549 .41026 L
.26471 .39295 L
.27451 .37174 L
.28431 .34923 L
.29412 .32718 L
.30392 .30669 L
.31373 .28832 L
.32353 .27234 L
.33333 .259 L
.34314 .2487 L
.35294 .24217 L
.36275 .24051 L
.37255 .24513 L
.38235 .25755 L
.39216 .2791 L
.40196 .31053 L
.41176 .34007 L
.42157 .3562 L
.43137 .36046 L
.44118 .35544 L
.45098 .34437 L
.46078 .33064 L
.47059 .3175 L
.48039 .30779 L
.4902 .30368 L
Mistroke
.5 .3065 L
.5098 .31105 L
.51961 .31189 L
.52941 .3097 L
.53922 .30557 L
.54902 .30088 L
.55882 .28749 L
.56863 .28021 L
.57843 .27999 L
.58824 .28717 L
.59804 .30142 L
.60784 .32166 L
.61765 .34603 L
.62745 .37184 L
.63725 .3956 L
.64706 .41314 L
.65686 .4199 L
.66667 .41133 L
.67647 .38345 L
.68627 .33364 L
.69608 .26147 L
.70588 .16765 L
.71569 .1152 L
.72549 .1067 L
.73529 .14104 L
.7451 .21378 L
.7549 .29708 L
.76471 .36298 L
.77451 .40655 L
.78431 .42538 L
.79412 .41933 L
.80392 .40016 L
.81373 .3799 L
.82353 .35938 L
.83333 .33835 L
.84314 .31587 L
.85294 .29177 L
.86275 .26606 L
.87255 .23819 L
.88235 .20863 L
.89216 .17921 L
.90196 .18869 L
.91176 .23217 L
.92157 .27887 L
.93137 .30282 L
.94118 .31454 L
.95098 .31773 L
.96078 .31731 L
.97059 .31864 L
.98039 .32664 L
Mistroke
.9902 .34509 L
Mfstroke
0 .98 .604 r
gsave
.9902 .34509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .07843 m
.01961 .21339 L
.02941 .32692 L
.03922 .41594 L
.04902 .48083 L
.05882 .52398 L
.06863 .54259 L
.07843 .53425 L
.08824 .50278 L
.09804 .45199 L
.10784 .3856 L
.11765 .31538 L
.12745 .25249 L
.13725 .19895 L
.14706 .15626 L
.15686 .12596 L
.16667 .14272 L
.17647 .17039 L
.18627 .20848 L
.19608 .25706 L
.20588 .31621 L
.21569 .3702 L
.22549 .40397 L
.23529 .4196 L
.2451 .42041 L
.2549 .41026 L
.26471 .39295 L
.27451 .37174 L
.28431 .34923 L
.29412 .32718 L
.30392 .30669 L
.31373 .28832 L
.32353 .27234 L
.33333 .259 L
.34314 .2487 L
.35294 .24217 L
.36275 .24051 L
.37255 .24513 L
.38235 .25755 L
.39216 .2791 L
.40196 .31053 L
.41176 .34007 L
.42157 .3562 L
.43137 .36046 L
.44118 .35544 L
.45098 .34437 L
.46078 .33064 L
.47059 .3175 L
.48039 .30779 L
.4902 .30368 L
Mistroke
.5 .3065 L
.5098 .31105 L
.51961 .31189 L
.52941 .3097 L
.53922 .30557 L
.54902 .30088 L
.55882 .28749 L
.56863 .28021 L
.57843 .27999 L
.58824 .28717 L
.59804 .30142 L
.60784 .32166 L
.61765 .34603 L
.62745 .37184 L
.63725 .3956 L
.64706 .41314 L
.65686 .4199 L
.66667 .41133 L
.67647 .38345 L
.68627 .33364 L
.69608 .26147 L
.70588 .16765 L
.71569 .1152 L
.72549 .1067 L
.73529 .14104 L
.7451 .21378 L
.7549 .29708 L
.76471 .36298 L
.77451 .40655 L
.78431 .42538 L
.79412 .41933 L
.80392 .40016 L
.81373 .3799 L
.82353 .35938 L
.83333 .33835 L
.84314 .31587 L
.85294 .29177 L
.86275 .26606 L
.87255 .23819 L
.88235 .20863 L
.89216 .17921 L
.90196 .18869 L
.91176 .23217 L
.92157 .27887 L
.93137 .30282 L
.94118 .31454 L
.95098 .31773 L
.96078 .31731 L
.97059 .31864 L
.98039 .32664 L
Mistroke
.9902 .34509 L
Mfstroke
1 .38 .01 r
gsave
.9902 .54111 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .07845 m
.01961 .34238 L
.02941 .46623 L
.03922 .55345 L
s
.03922 .55345 m
.04785 .61803 L
s
.09493 .61803 m
.09804 .60779 L
.10784 .56045 L
.11765 .4945 L
.12745 .43064 L
.13725 .37066 L
.14706 .29969 L
.15686 .12599 L
.16667 .2852 L
.17647 .34071 L
.18627 .38758 L
.19608 .44438 L
.20588 .51218 L
.21569 .56268 L
.22549 .58666 L
.23529 .59596 L
.2451 .59738 L
.2549 .59317 L
.26471 .58358 L
.27451 .56924 L
.28431 .55156 L
.29412 .53228 L
.30392 .51279 L
.31373 .49378 L
.32353 .47527 L
.33333 .45711 L
.34314 .43973 L
.35294 .42517 L
.36275 .41757 L
.37255 .42243 L
.38235 .44332 L
.39216 .47797 L
.40196 .51703 L
.41176 .53893 L
.42157 .54118 L
.43137 .53402 L
.44118 .52285 L
.45098 .51002 L
.46078 .49806 L
.47059 .49108 L
.48039 .49276 L
.4902 .50248 L
.5 .51286 L
.5098 .50965 L
.51961 .49725 L
.52941 .48649 L
.53922 .48216 L
.54902 .4836 L
.55882 .47847 L
.56863 .4783 L
Mistroke
.57843 .48249 L
.58824 .49099 L
.59804 .5037 L
.60784 .51999 L
.61765 .53859 L
.62745 .55779 L
.63725 .57561 L
.64706 .58959 L
.65686 .59577 L
.66667 .58716 L
.67647 .55266 L
.68627 .4749 L
.69608 .26149 L
.70588 .2957 L
.71569 .25226 L
.72549 .24113 L
.73529 .28417 L
.7451 .36917 L
.7549 .44598 L
.76471 .49949 L
.77451 .54413 L
.78431 .578 L
.79412 .58242 L
.80392 .55271 L
.81373 .51748 L
.82353 .49578 L
.83333 .48636 L
.84314 .46861 L
.85294 .42967 L
.86275 .39388 L
.87255 .37021 L
.88235 .3346 L
.89216 .17923 L
.90196 .31036 L
.91176 .36964 L
.92157 .43409 L
.93137 .46439 L
.94118 .46772 L
.95098 .46165 L
.96078 .46204 L
.97059 .47793 L
.98039 .50747 L
.9902 .54111 L
Mfstroke
gsave
.9902 .14906 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .0784 m
.01961 .08441 L
.02941 .18761 L
.03922 .27844 L
.04902 .33485 L
.05882 .36635 L
.06863 .39216 L
.07843 .39761 L
.08824 .36548 L
.09804 .29619 L
.10784 .21075 L
.11765 .13626 L
.12745 .07434 L
.13725 .02725 L
.14706 .01283 L
.15686 .12594 L
.16667 .00024 L
.17647 8e-05 L
.18627 .02938 L
.19608 .06975 L
.20588 .12024 L
.21569 .17771 L
.22549 .22128 L
.23529 .24324 L
.2451 .24343 L
.2549 .22736 L
.26471 .20231 L
.27451 .17425 L
.28431 .14689 L
.29412 .12209 L
.30392 .1006 L
.31373 .08287 L
.32353 .06942 L
.33333 .06089 L
.34314 .05767 L
.35294 .05917 L
.36275 .06346 L
.37255 .06783 L
.38235 .07177 L
.39216 .08022 L
.40196 .10403 L
.41176 .14121 L
.42157 .17122 L
.43137 .1869 L
.44118 .18804 L
.45098 .17872 L
.46078 .16322 L
.47059 .14393 L
.48039 .12282 L
.4902 .10488 L
Mistroke
.5 .10014 L
.5098 .11244 L
.51961 .12653 L
.52941 .13291 L
.53922 .12899 L
.54902 .11817 L
.55882 .09652 L
.56863 .08211 L
.57843 .07749 L
.58824 .08336 L
.59804 .09914 L
.60784 .12333 L
.61765 .15347 L
.62745 .18589 L
.63725 .21558 L
.64706 .23669 L
.65686 .24404 L
.66667 .23549 L
.67647 .21423 L
.68627 .19239 L
.69608 .26144 L
.70588 .03959 L
Mfstroke
.70588 .03959 m
.7122 0 L
s
.73563 0 m
.7451 .05839 L
.7549 .14818 L
.76471 .22648 L
.77451 .26897 L
.78431 .27275 L
.79412 .25623 L
.80392 .2476 L
.81373 .24231 L
.82353 .22298 L
.83333 .19035 L
.84314 .16312 L
.85294 .15387 L
.86275 .13823 L
.87255 .10617 L
.88235 .08266 L
.89216 .17918 L
.90196 .06703 L
.91176 .0947 L
.92157 .12365 L
.93137 .14125 L
.94118 .16135 L
.95098 .1738 L
.96078 .17259 L
.97059 .15935 L
.98039 .14581 L
.9902 .14906 L
s
0 g
gsave
.89216 .17921 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .07843 Mdot
.15686 .12596 Mdot
.69608 .26147 Mdot
.89216 .17921 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.309017 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -30 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -24 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -30 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -24 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -18 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -24 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-0.75)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-0.5)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.25)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.25)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(0.5)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(0.75)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(1)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .29672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .2032 m
.01961 .18682 L
.02941 .18983 L
.03922 .18192 L
.04902 .18249 L
.05882 .19349 L
.06863 .2351 L
.07843 .27422 L
.08824 .30016 L
.09804 .34747 L
.10784 .39558 L
.11765 .43789 L
.12745 .43352 L
.13725 .41122 L
.14706 .3911 L
.15686 .35518 L
.16667 .31269 L
.17647 .27554 L
.18627 .24808 L
.19608 .25324 L
.20588 .25788 L
.21569 .26401 L
.22549 .27227 L
.23529 .2965 L
.2451 .30701 L
.2549 .30399 L
.26471 .31374 L
.27451 .30973 L
.28431 .31542 L
.29412 .31316 L
.30392 .31861 L
.31373 .3422 L
.32353 .36316 L
.33333 .36863 L
.34314 .36745 L
.35294 .3639 L
.36275 .35272 L
.37255 .33573 L
.38235 .31238 L
.39216 .27807 L
.40196 .25429 L
.41176 .24299 L
.42157 .24346 L
.43137 .23817 L
.44118 .24106 L
.45098 .23852 L
.46078 .26419 L
.47059 .27807 L
.48039 .28789 L
.4902 .28404 L
Mistroke
.5 .26612 L
.5098 .26468 L
.51961 .28082 L
.52941 .29282 L
.53922 .29004 L
.54902 .29681 L
.55882 .29399 L
.56863 .28802 L
.57843 .28719 L
.58824 .29761 L
.59804 .31928 L
.60784 .34873 L
.61765 .36383 L
.62745 .35183 L
.63725 .32582 L
.64706 .32364 L
.65686 .34359 L
.66667 .3719 L
.67647 .40747 L
.68627 .40655 L
.69608 .4063 L
.70588 .38409 L
.71569 .33984 L
.72549 .31732 L
.73529 .30148 L
.7451 .26785 L
.7549 .26559 L
.76471 .28095 L
.77451 .2967 L
.78431 .30232 L
.79412 .29639 L
.80392 .30838 L
.81373 .33089 L
.82353 .37221 L
.83333 .39626 L
.84314 .39321 L
.85294 .3885 L
.86275 .37021 L
.87255 .33555 L
.88235 .31475 L
.89216 .29375 L
.90196 .28273 L
.91176 .27456 L
.92157 .25623 L
.93137 .24246 L
.94118 .23955 L
.95098 .2235 L
.96078 .23336 L
.97059 .25742 L
.98039 .27675 L
Mistroke
.9902 .29672 L
Mfstroke
0 .98 .604 r
gsave
.9902 .26711 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .18266 m
.01961 .15166 L
.02941 .14703 L
.03922 .1621 L
.04902 .18992 L
.05882 .21474 L
.06863 .24955 L
.07843 .28241 L
.08824 .31034 L
.09804 .33169 L
.10784 .40309 L
.11765 .4096 L
.12745 .40474 L
.13725 .39213 L
.14706 .37521 L
.15686 .34961 L
.16667 .31781 L
.17647 .29599 L
.18627 .28377 L
.19608 .27986 L
.20588 .22486 L
.21569 .23207 L
.22549 .24783 L
.23529 .26813 L
.2451 .28958 L
.2549 .30958 L
.26471 .32637 L
.27451 .33905 L
.28431 .34736 L
.29412 .35162 L
.30392 .35246 L
.31373 .35072 L
.32353 .34729 L
.33333 .343 L
.34314 .33853 L
.35294 .33441 L
.36275 .33099 L
.37255 .32844 L
.38235 .3268 L
.39216 .326 L
.40196 .27161 L
.41176 .27507 L
.42157 .28351 L
.43137 .29467 L
.44118 .30662 L
.45098 .31787 L
.46078 .32742 L
.47059 .3347 L
.48039 .33955 L
.4902 .34211 L
Mistroke
.5 .31906 L
.5098 .31953 L
.51961 .32103 L
.52941 .32314 L
.53922 .32545 L
.54902 .32768 L
.55882 .32856 L
.56863 .32746 L
.57843 .32503 L
.58824 .32188 L
.59804 .31855 L
.60784 .31545 L
.61765 .31283 L
.62745 .31086 L
.63725 .30957 L
.64706 .3089 L
.65686 .30877 L
.66667 .30903 L
.67647 .30956 L
.68627 .31023 L
.69608 .42246 L
.70588 .40828 L
.71569 .38768 L
.72549 .36461 L
.73529 .34221 L
.7451 .25584 L
.7549 .23837 L
.76471 .23353 L
.77451 .2384 L
.78431 .24982 L
.79412 .31164 L
.80392 .32674 L
.81373 .33618 L
.82353 .3405 L
.83333 .34062 L
.84314 .36626 L
.85294 .36082 L
.86275 .35166 L
.87255 .34077 L
.88235 .32978 L
.89216 .32643 L
.90196 .29969 L
.91176 .26282 L
.92157 .25938 L
.93137 .26101 L
.94118 .26894 L
.95098 .28062 L
.96078 .29378 L
.97059 .30662 L
.98039 .31784 L
Mistroke
.9902 .26711 L
Mfstroke
0 0 1 r
gsave
.9902 .26711 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .18266 m
.01961 .15166 L
.02941 .14703 L
.03922 .1621 L
.04902 .18992 L
.05882 .21474 L
.06863 .24955 L
.07843 .28241 L
.08824 .31034 L
.09804 .33169 L
.10784 .40309 L
.11765 .4096 L
.12745 .40474 L
.13725 .39213 L
.14706 .37521 L
.15686 .34961 L
.16667 .31781 L
.17647 .29599 L
.18627 .28377 L
.19608 .27986 L
.20588 .22486 L
.21569 .23207 L
.22549 .24783 L
.23529 .26813 L
.2451 .28958 L
.2549 .30958 L
.26471 .32637 L
.27451 .33905 L
.28431 .34736 L
.29412 .35162 L
.30392 .35246 L
.31373 .35072 L
.32353 .34729 L
.33333 .343 L
.34314 .33853 L
.35294 .33441 L
.36275 .33099 L
.37255 .32844 L
.38235 .3268 L
.39216 .326 L
.40196 .27161 L
.41176 .27507 L
.42157 .28351 L
.43137 .29467 L
.44118 .30662 L
.45098 .31787 L
.46078 .32742 L
.47059 .3347 L
.48039 .33955 L
.4902 .34211 L
Mistroke
.5 .31906 L
.5098 .31953 L
.51961 .32103 L
.52941 .32314 L
.53922 .32545 L
.54902 .32768 L
.55882 .32856 L
.56863 .32746 L
.57843 .32503 L
.58824 .32188 L
.59804 .31855 L
.60784 .31545 L
.61765 .31283 L
.62745 .31086 L
.63725 .30957 L
.64706 .3089 L
.65686 .30877 L
.66667 .30903 L
.67647 .30956 L
.68627 .31023 L
.69608 .42246 L
.70588 .40828 L
.71569 .38768 L
.72549 .36461 L
.73529 .34221 L
.7451 .25584 L
.7549 .23837 L
.76471 .23353 L
.77451 .2384 L
.78431 .24982 L
.79412 .31164 L
.80392 .32674 L
.81373 .33618 L
.82353 .3405 L
.83333 .34062 L
.84314 .36626 L
.85294 .36082 L
.86275 .35166 L
.87255 .34077 L
.88235 .32978 L
.89216 .32643 L
.90196 .29969 L
.91176 .26282 L
.92157 .25938 L
.93137 .26101 L
.94118 .26894 L
.95098 .28062 L
.96078 .29378 L
.97059 .30662 L
.98039 .31784 L
Mistroke
.9902 .26711 L
Mfstroke
0 .98 .604 r
gsave
.9902 .26711 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .18266 m
.01961 .15166 L
.02941 .14703 L
.03922 .1621 L
.04902 .18992 L
.05882 .21474 L
.06863 .24955 L
.07843 .28241 L
.08824 .31034 L
.09804 .33169 L
.10784 .40309 L
.11765 .4096 L
.12745 .40474 L
.13725 .39213 L
.14706 .37521 L
.15686 .34961 L
.16667 .31781 L
.17647 .29599 L
.18627 .28377 L
.19608 .27986 L
.20588 .22486 L
.21569 .23207 L
.22549 .24783 L
.23529 .26813 L
.2451 .28958 L
.2549 .30958 L
.26471 .32637 L
.27451 .33905 L
.28431 .34736 L
.29412 .35162 L
.30392 .35246 L
.31373 .35072 L
.32353 .34729 L
.33333 .343 L
.34314 .33853 L
.35294 .33441 L
.36275 .33099 L
.37255 .32844 L
.38235 .3268 L
.39216 .326 L
.40196 .27161 L
.41176 .27507 L
.42157 .28351 L
.43137 .29467 L
.44118 .30662 L
.45098 .31787 L
.46078 .32742 L
.47059 .3347 L
.48039 .33955 L
.4902 .34211 L
Mistroke
.5 .31906 L
.5098 .31953 L
.51961 .32103 L
.52941 .32314 L
.53922 .32545 L
.54902 .32768 L
.55882 .32856 L
.56863 .32746 L
.57843 .32503 L
.58824 .32188 L
.59804 .31855 L
.60784 .31545 L
.61765 .31283 L
.62745 .31086 L
.63725 .30957 L
.64706 .3089 L
.65686 .30877 L
.66667 .30903 L
.67647 .30956 L
.68627 .31023 L
.69608 .42246 L
.70588 .40828 L
.71569 .38768 L
.72549 .36461 L
.73529 .34221 L
.7451 .25584 L
.7549 .23837 L
.76471 .23353 L
.77451 .2384 L
.78431 .24982 L
.79412 .31164 L
.80392 .32674 L
.81373 .33618 L
.82353 .3405 L
.83333 .34062 L
.84314 .36626 L
.85294 .36082 L
.86275 .35166 L
.87255 .34077 L
.88235 .32978 L
.89216 .32643 L
.90196 .29969 L
.91176 .26282 L
.92157 .25938 L
.93137 .26101 L
.94118 .26894 L
.95098 .28062 L
.96078 .29378 L
.97059 .30662 L
.98039 .31784 L
Mistroke
.9902 .26711 L
Mfstroke
1 .38 .01 r
gsave
.9902 .31708 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .23804 m
.01961 .20653 L
.02941 .20741 L
.03922 .23466 L
.04902 .27617 L
.05882 .26309 L
.06863 .30942 L
.07843 .35936 L
.08824 .4026 L
.09804 .43507 L
.10784 .45274 L
.11765 .46939 L
.12745 .4818 L
.13725 .48491 L
.14706 .47933 L
.15686 .45957 L
.16667 .42292 L
.17647 .3932 L
.18627 .37682 L
.19608 .3745 L
.20588 .27347 L
.21569 .29289 L
.22549 .32759 L
.23529 .36406 L
.2451 .3965 L
.2549 .42256 L
.26471 .44175 L
.27451 .45465 L
.28431 .46236 L
.29412 .46605 L
.30392 .46676 L
.31373 .46532 L
.32353 .46241 L
.33333 .45864 L
.34314 .45458 L
.35294 .45069 L
.36275 .44736 L
.37255 .44482 L
.38235 .44315 L
.39216 .44232 L
.40196 .32179 L
.41176 .33609 L
.42157 .36384 L
.43137 .39164 L
.44118 .41477 L
.45098 .432 L
.46078 .44368 L
.47059 .45088 L
.48039 .45484 L
.4902 .45666 L
Mistroke
.5 .36908 L
.5098 .38044 L
.51961 .40132 L
.52941 .42009 L
.53922 .4336 L
.54902 .44181 L
.55882 .44483 L
.56863 .44364 L
.57843 .44032 L
.58824 .43643 L
.59804 .43288 L
.60784 .43005 L
.61765 .42797 L
.62745 .42655 L
.63725 .42566 L
.64706 .42523 L
.65686 .42517 L
.66667 .42543 L
.67647 .42592 L
.68627 .42655 L
.69608 .47263 L
.70588 .45849 L
.71569 .44507 L
.72549 .43573 L
.73529 .42793 L
.7451 .30418 L
.7549 .29819 L
.76471 .31029 L
.77451 .33042 L
.78431 .35297 L
.79412 .36127 L
.80392 .38653 L
.81373 .41324 L
.82353 .43327 L
.83333 .44473 L
.84314 .41597 L
.85294 .42063 L
.86275 .42872 L
.87255 .43354 L
.88235 .43389 L
.89216 .37606 L
.90196 .33677 L
.91176 .29859 L
.92157 .29783 L
.93137 .31755 L
.94118 .34453 L
.95098 .37186 L
.96078 .39609 L
.97059 .41568 L
.98039 .43034 L
Mistroke
.9902 .31708 L
Mfstroke
gsave
.9902 .21715 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .12728 m
.01961 .09679 L
.02941 .08664 L
.03922 .08954 L
.04902 .10366 L
.05882 .16638 L
.06863 .18967 L
.07843 .20546 L
.08824 .21807 L
.09804 .22831 L
.10784 .35344 L
.11765 .34981 L
.12745 .32768 L
.13725 .29935 L
.14706 .27109 L
.15686 .23965 L
.16667 .2127 L
.17647 .19877 L
.18627 .19073 L
.19608 .18522 L
.20588 .17625 L
.21569 .17124 L
.22549 .16806 L
.23529 .17221 L
.2451 .18267 L
.2549 .1966 L
.26471 .211 L
.27451 .22344 L
.28431 .23237 L
.29412 .23718 L
.30392 .23815 L
.31373 .23612 L
.32353 .23218 L
.33333 .22735 L
.34314 .22248 L
.35294 .21813 L
.36275 .21462 L
.37255 .21207 L
.38235 .21046 L
.39216 .20967 L
.40196 .22144 L
.41176 .21405 L
.42157 .20317 L
.43137 .1977 L
.44118 .19847 L
.45098 .20375 L
.46078 .21115 L
.47059 .21852 L
.48039 .22425 L
.4902 .22756 L
Mistroke
.5 .26905 L
.5098 .25861 L
.51961 .24075 L
.52941 .22619 L
.53922 .21731 L
.54902 .21355 L
.55882 .2123 L
.56863 .21128 L
.57843 .20973 L
.58824 .20733 L
.59804 .20422 L
.60784 .20085 L
.61765 .1977 L
.62745 .19518 L
.63725 .19347 L
.64706 .19257 L
.65686 .19236 L
.66667 .19264 L
.67647 .1932 L
.68627 .1939 L
.69608 .37228 L
.70588 .35806 L
.71569 .3303 L
.72549 .29349 L
.73529 .25649 L
.7451 .2075 L
.7549 .17855 L
.76471 .15676 L
.77451 .14637 L
.78431 .14667 L
.79412 .26201 L
.80392 .26694 L
.81373 .25912 L
.82353 .24772 L
.83333 .23651 L
.84314 .31654 L
.85294 .301 L
.86275 .2746 L
.87255 .24799 L
.88235 .22567 L
.89216 .2768 L
.90196 .26262 L
.91176 .22705 L
.92157 .22092 L
.93137 .20447 L
.94118 .19335 L
.95098 .18938 L
.96078 .19147 L
.97059 .19755 L
.98039 .20535 L
Mistroke
.9902 .21715 L
Mfstroke
0 g
gsave
.9902 .25288 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .18194 Mdot
.05882 .21173 Mdot
.10784 .41765 Mdot
.20588 .20707 Mdot
.40196 .25921 Mdot
.5 .31346 Mdot
.69608 .44796 Mdot
.7451 .2342 Mdot
.79412 .32361 Mdot
.84314 .37345 Mdot
.89216 .32982 Mdot
.90196 .29367 Mdot
.91176 .23013 Mdot
.92157 .26786 Mdot
.9902 .25288 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.309017 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -30 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -24 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -30 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -24 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -18 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -24 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-0.75)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-0.5)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.25)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.25)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(0.5)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(0.75)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(1)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .29672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .2032 m
.01961 .18682 L
.02941 .18983 L
.03922 .18192 L
.04902 .18249 L
.05882 .19349 L
.06863 .2351 L
.07843 .27422 L
.08824 .30016 L
.09804 .34747 L
.10784 .39558 L
.11765 .43789 L
.12745 .43352 L
.13725 .41122 L
.14706 .3911 L
.15686 .35518 L
.16667 .31269 L
.17647 .27554 L
.18627 .24808 L
.19608 .25324 L
.20588 .25788 L
.21569 .26401 L
.22549 .27227 L
.23529 .2965 L
.2451 .30701 L
.2549 .30399 L
.26471 .31374 L
.27451 .30973 L
.28431 .31542 L
.29412 .31316 L
.30392 .31861 L
.31373 .3422 L
.32353 .36316 L
.33333 .36863 L
.34314 .36745 L
.35294 .3639 L
.36275 .35272 L
.37255 .33573 L
.38235 .31238 L
.39216 .27807 L
.40196 .25429 L
.41176 .24299 L
.42157 .24346 L
.43137 .23817 L
.44118 .24106 L
.45098 .23852 L
.46078 .26419 L
.47059 .27807 L
.48039 .28789 L
.4902 .28404 L
Mistroke
.5 .26612 L
.5098 .26468 L
.51961 .28082 L
.52941 .29282 L
.53922 .29004 L
.54902 .29681 L
.55882 .29399 L
.56863 .28802 L
.57843 .28719 L
.58824 .29761 L
.59804 .31928 L
.60784 .34873 L
.61765 .36383 L
.62745 .35183 L
.63725 .32582 L
.64706 .32364 L
.65686 .34359 L
.66667 .3719 L
.67647 .40747 L
.68627 .40655 L
.69608 .4063 L
.70588 .38409 L
.71569 .33984 L
.72549 .31732 L
.73529 .30148 L
.7451 .26785 L
.7549 .26559 L
.76471 .28095 L
.77451 .2967 L
.78431 .30232 L
.79412 .29639 L
.80392 .30838 L
.81373 .33089 L
.82353 .37221 L
.83333 .39626 L
.84314 .39321 L
.85294 .3885 L
.86275 .37021 L
.87255 .33555 L
.88235 .31475 L
.89216 .29375 L
.90196 .28273 L
.91176 .27456 L
.92157 .25623 L
.93137 .24246 L
.94118 .23955 L
.95098 .2235 L
.96078 .23336 L
.97059 .25742 L
.98039 .27675 L
Mistroke
.9902 .29672 L
Mfstroke
0 .98 .604 r
gsave
.9902 .26711 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .17796 m
.01961 .14565 L
.02941 .13827 L
.03922 .15117 L
.04902 .17943 L
.05882 .21844 L
.06863 .26377 L
.07843 .31007 L
.08824 .35233 L
.09804 .38629 L
.10784 .40848 L
.11765 .41667 L
.12745 .41151 L
.13725 .39468 L
.14706 .36821 L
.15686 .33441 L
.16667 .29928 L
.17647 .26861 L
.18627 .24452 L
.19608 .2291 L
.20588 .22445 L
.21569 .23163 L
.22549 .24757 L
.23529 .2684 L
.2451 .29081 L
.2549 .31222 L
.26471 .33083 L
.27451 .34554 L
.28431 .35584 L
.29412 .36166 L
.30392 .36321 L
.31373 .36087 L
.32353 .35509 L
.33333 .34638 L
.34314 .33529 L
.35294 .3225 L
.36275 .30887 L
.37255 .29551 L
.38235 .28384 L
.39216 .27554 L
.40196 .27253 L
.41176 .27601 L
.42157 .28405 L
.43137 .29409 L
.44118 .30401 L
.45098 .31226 L
.46078 .31797 L
.47059 .32095 L
.48039 .3216 L
.4902 .32083 L
Mistroke
.5 .31993 L
.5098 .31994 L
.51961 .32049 L
.52941 .32089 L
.53922 .32063 L
.54902 .31947 L
.55882 .31642 L
.56863 .31127 L
.57843 .30536 L
.58824 .30015 L
.59804 .2971 L
.60784 .29752 L
.61765 .30243 L
.62745 .31242 L
.63725 .32743 L
.64706 .34664 L
.65686 .36836 L
.66667 .38997 L
.67647 .40799 L
.68627 .41828 L
.69608 .41635 L
.70588 .39681 L
.71569 .36256 L
.72549 .32222 L
.73529 .2845 L
.7451 .25759 L
.7549 .24711 L
.76471 .25165 L
.77451 .2672 L
.78431 .28901 L
.79412 .31208 L
.80392 .33226 L
.81373 .34847 L
.82353 .36059 L
.83333 .36858 L
.84314 .37223 L
.85294 .37121 L
.86275 .36522 L
.87255 .35388 L
.88235 .33678 L
.89216 .31373 L
.90196 .28823 L
.91176 .26788 L
.92157 .2577 L
.93137 .25429 L
.94118 .2544 L
.95098 .25593 L
.96078 .25765 L
.97059 .25937 L
.98039 .26194 L
Mistroke
.9902 .26711 L
Mfstroke
0 0 1 r
gsave
.9902 .26711 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .17796 m
.01961 .14565 L
.02941 .13827 L
.03922 .15117 L
.04902 .17943 L
.05882 .21844 L
.06863 .26377 L
.07843 .31007 L
.08824 .35233 L
.09804 .38629 L
.10784 .40848 L
.11765 .41667 L
.12745 .41151 L
.13725 .39468 L
.14706 .36821 L
.15686 .33441 L
.16667 .29928 L
.17647 .26861 L
.18627 .24452 L
.19608 .2291 L
.20588 .22445 L
.21569 .23163 L
.22549 .24757 L
.23529 .2684 L
.2451 .29081 L
.2549 .31222 L
.26471 .33083 L
.27451 .34554 L
.28431 .35584 L
.29412 .36166 L
.30392 .36321 L
.31373 .36087 L
.32353 .35509 L
.33333 .34638 L
.34314 .33529 L
.35294 .3225 L
.36275 .30887 L
.37255 .29551 L
.38235 .28384 L
.39216 .27554 L
.40196 .27253 L
.41176 .27601 L
.42157 .28405 L
.43137 .29409 L
.44118 .30401 L
.45098 .31226 L
.46078 .31797 L
.47059 .32095 L
.48039 .3216 L
.4902 .32083 L
Mistroke
.5 .31993 L
.5098 .31994 L
.51961 .32049 L
.52941 .32089 L
.53922 .32063 L
.54902 .31947 L
.55882 .31642 L
.56863 .31127 L
.57843 .30536 L
.58824 .30015 L
.59804 .2971 L
.60784 .29752 L
.61765 .30243 L
.62745 .31242 L
.63725 .32743 L
.64706 .34664 L
.65686 .36836 L
.66667 .38997 L
.67647 .40799 L
.68627 .41828 L
.69608 .41635 L
.70588 .39681 L
.71569 .36256 L
.72549 .32222 L
.73529 .2845 L
.7451 .25759 L
.7549 .24711 L
.76471 .25165 L
.77451 .2672 L
.78431 .28901 L
.79412 .31208 L
.80392 .33226 L
.81373 .34847 L
.82353 .36059 L
.83333 .36858 L
.84314 .37223 L
.85294 .37121 L
.86275 .36522 L
.87255 .35388 L
.88235 .33678 L
.89216 .31373 L
.90196 .28823 L
.91176 .26788 L
.92157 .2577 L
.93137 .25429 L
.94118 .2544 L
.95098 .25593 L
.96078 .25765 L
.97059 .25937 L
.98039 .26194 L
Mistroke
.9902 .26711 L
Mfstroke
0 .98 .604 r
gsave
.9902 .26711 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .17796 m
.01961 .14565 L
.02941 .13827 L
.03922 .15117 L
.04902 .17943 L
.05882 .21844 L
.06863 .26377 L
.07843 .31007 L
.08824 .35233 L
.09804 .38629 L
.10784 .40848 L
.11765 .41667 L
.12745 .41151 L
.13725 .39468 L
.14706 .36821 L
.15686 .33441 L
.16667 .29928 L
.17647 .26861 L
.18627 .24452 L
.19608 .2291 L
.20588 .22445 L
.21569 .23163 L
.22549 .24757 L
.23529 .2684 L
.2451 .29081 L
.2549 .31222 L
.26471 .33083 L
.27451 .34554 L
.28431 .35584 L
.29412 .36166 L
.30392 .36321 L
.31373 .36087 L
.32353 .35509 L
.33333 .34638 L
.34314 .33529 L
.35294 .3225 L
.36275 .30887 L
.37255 .29551 L
.38235 .28384 L
.39216 .27554 L
.40196 .27253 L
.41176 .27601 L
.42157 .28405 L
.43137 .29409 L
.44118 .30401 L
.45098 .31226 L
.46078 .31797 L
.47059 .32095 L
.48039 .3216 L
.4902 .32083 L
Mistroke
.5 .31993 L
.5098 .31994 L
.51961 .32049 L
.52941 .32089 L
.53922 .32063 L
.54902 .31947 L
.55882 .31642 L
.56863 .31127 L
.57843 .30536 L
.58824 .30015 L
.59804 .2971 L
.60784 .29752 L
.61765 .30243 L
.62745 .31242 L
.63725 .32743 L
.64706 .34664 L
.65686 .36836 L
.66667 .38997 L
.67647 .40799 L
.68627 .41828 L
.69608 .41635 L
.70588 .39681 L
.71569 .36256 L
.72549 .32222 L
.73529 .2845 L
.7451 .25759 L
.7549 .24711 L
.76471 .25165 L
.77451 .2672 L
.78431 .28901 L
.79412 .31208 L
.80392 .33226 L
.81373 .34847 L
.82353 .36059 L
.83333 .36858 L
.84314 .37223 L
.85294 .37121 L
.86275 .36522 L
.87255 .35388 L
.88235 .33678 L
.89216 .31373 L
.90196 .28823 L
.91176 .26788 L
.92157 .2577 L
.93137 .25429 L
.94118 .2544 L
.95098 .25593 L
.96078 .25765 L
.97059 .25937 L
.98039 .26194 L
Mistroke
.9902 .26711 L
Mfstroke
1 .38 .01 r
gsave
.9902 .31708 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .23261 m
.01961 .19863 L
.02941 .19093 L
.03922 .20341 L
.04902 .22856 L
.05882 .26622 L
.06863 .31835 L
.07843 .37146 L
.08824 .41359 L
.09804 .44034 L
.10784 .45641 L
.11765 .47186 L
.12745 .48204 L
.13725 .48162 L
.14706 .46914 L
.15686 .44192 L
.16667 .40058 L
.17647 .35657 L
.18627 .31621 L
.19608 .28462 L
.20588 .27305 L
.21569 .29245 L
.22549 .32733 L
.23529 .36432 L
.2451 .3977 L
.2549 .42509 L
.26471 .44588 L
.27451 .46044 L
.28431 .46963 L
.29412 .47438 L
.30392 .47554 L
.31373 .4737 L
.32353 .46916 L
.33333 .46182 L
.34314 .45117 L
.35294 .43646 L
.36275 .41695 L
.37255 .39244 L
.38235 .36411 L
.39216 .33644 L
.40196 .32253 L
.41176 .3369 L
.42157 .36436 L
.43137 .39098 L
.44118 .41132 L
.45098 .42307 L
.46078 .42527 L
.47059 .41781 L
.48039 .40188 L
.4902 .38171 L
Mistroke
.5 .36993 L
.5098 .38082 L
.51961 .40066 L
.52941 .41758 L
.53922 .42831 L
.54902 .43283 L
.55882 .43154 L
.56863 .42592 L
.57843 .41881 L
.58824 .41271 L
.59804 .40944 L
.60784 .41 L
.61765 .41461 L
.62745 .42273 L
.63725 .43317 L
.64706 .44422 L
.65686 .45398 L
.66667 .46094 L
.67647 .46507 L
.68627 .468 L
.69608 .46597 L
.70588 .44533 L
.71569 .41237 L
.72549 .37314 L
.73529 .33321 L
.7451 .30509 L
.7549 .30095 L
.76471 .31183 L
.77451 .32728 L
.78431 .34281 L
.79412 .36096 L
.80392 .38596 L
.81373 .40838 L
.82353 .42063 L
.83333 .42238 L
.84314 .41967 L
.85294 .41904 L
.86275 .41309 L
.87255 .39675 L
.88235 .3737 L
.89216 .34993 L
.90196 .31941 L
.91176 .29723 L
.92157 .29605 L
.93137 .30965 L
.94118 .32577 L
.95098 .33675 L
.96078 .33903 L
.97059 .33233 L
.98039 .32073 L
Mistroke
.9902 .31708 L
Mfstroke
gsave
.9902 .21715 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .1233 m
.01961 .09266 L
.02941 .08561 L
.03922 .09892 L
.04902 .13029 L
.05882 .17066 L
.06863 .2092 L
.07843 .24868 L
.08824 .29106 L
.09804 .33224 L
.10784 .36054 L
.11765 .36148 L
.12745 .34098 L
.13725 .30775 L
.14706 .26728 L
.15686 .22689 L
.16667 .19798 L
.17647 .18066 L
.18627 .17284 L
.19608 .17358 L
.20588 .17585 L
.21569 .17081 L
.22549 .16781 L
.23529 .17248 L
.2451 .18392 L
.2549 .19936 L
.26471 .21579 L
.27451 .23063 L
.28431 .24205 L
.29412 .24893 L
.30392 .25088 L
.31373 .24804 L
.32353 .24102 L
.33333 .23093 L
.34314 .2194 L
.35294 .20854 L
.36275 .20079 L
.37255 .19859 L
.38235 .20357 L
.39216 .21463 L
.40196 .22252 L
.41176 .21512 L
.42157 .20374 L
.43137 .1972 L
.44118 .1967 L
.45098 .20145 L
.46078 .21068 L
.47059 .22408 L
.48039 .24131 L
.4902 .25996 L
Mistroke
.5 .26992 L
.5098 .25906 L
.51961 .24032 L
.52941 .22419 L
.53922 .21296 L
.54902 .20611 L
.55882 .20129 L
.56863 .19662 L
.57843 .19191 L
.58824 .18759 L
.59804 .18476 L
.60784 .18503 L
.61765 .19026 L
.62745 .20211 L
.63725 .22169 L
.64706 .24906 L
.65686 .28273 L
.66667 .319 L
.67647 .35092 L
.68627 .36855 L
.69608 .36672 L
.70588 .34828 L
.71569 .31276 L
.72549 .27129 L
.73529 .23579 L
.7451 .21009 L
.7549 .19327 L
.76471 .19147 L
.77451 .20712 L
.78431 .23521 L
.79412 .26321 L
.80392 .27856 L
.81373 .28855 L
.82353 .30056 L
.83333 .31478 L
.84314 .3248 L
.85294 .32338 L
.86275 .31735 L
.87255 .31102 L
.88235 .29986 L
.89216 .27754 L
.90196 .25704 L
.91176 .23852 L
.92157 .21935 L
.93137 .19894 L
.94118 .18304 L
.95098 .17512 L
.96078 .17626 L
.97059 .1864 L
.98039 .20315 L
Mistroke
.9902 .21715 L
Mfstroke
0 g
gsave
.9902 .25288 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .18194 Mdot
.05882 .21173 Mdot
.10784 .41765 Mdot
.20588 .20707 Mdot
.40196 .25921 Mdot
.5 .31346 Mdot
.69608 .44796 Mdot
.7451 .2342 Mdot
.79412 .32361 Mdot
.84314 .37345 Mdot
.89216 .32982 Mdot
.90196 .29367 Mdot
.91176 .23013 Mdot
.92157 .26786 Mdot
.9902 .25288 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{602.062, 372.125},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009J0001M2000`400?l00000o`00003ooooooooo
oooooecooooo003oooooooooooooG?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo
003oooooooooooooG?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo003ooooooooo
ooooG?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo003oooooooooooooG?ooool0
02_ooooo0_l0000^ooooo`Go0000;oooool3o`0002kooooo0ol0000_ooooo`?o0000;?ooool3o`00
00Cooooo0_l0000Oooooo`;o0000;_ooool5o`0002oooooo0ol0000^ooooo`?o0000;oooool3o`00
02cooooo0ol00004ooooo`;o00004_ooool002[ooooo00Co0000oooooooooooo0000;_ooool01?l0
003oooooooooool0000`ooooo`03o`000?oooooooooo02cooooo00Go0000ooooooooooooooooo`00
000]ooooo`05o`000?ooooooooooooooool00000;?ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0001gooooo00Co0000oooooooooooo0000;_ooool01?l0003oooooooooool0000`
ooooo`03o`000?oooooooooo02cooooo00Go0000ooooooooooooooooo`00000]ooooo`05o`000?oo
ooooooooooooool00000;?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00017o
oooo000Zooooo`04o`000?ooooooooooo`0002oooooo00?o0000ooooooooool0;Oooool5o`0002go
oooo00Go0000ooooooooooooooooo`00000]ooooo`05o`000?ooooooooooooooool00000;?ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001gooooo00Co0000oooooooooooo0000
;oooool00ol0003oooooooooo`0]ooooo`Go0000;Oooool01Ol0003ooooooooooooooooo000002go
oooo00Go0000ooooooooooooooooo`00000/ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00004Oooool002[ooooo00Co0000oooooooooooo0000<?ooool00ol0003oooooooooo`0/
ooooo`04o`000?ooooooooooo`0002kooooo1?l0000_ooooo`?o0000;Oooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0001gooooo00Co0000oooooooooooo0000<?ooool00ol0003o
ooooooooo`0/ooooo`04o`000?ooooooooooo`0002kooooo1?l0000_ooooo`?o0000;Oooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`00017ooooo000Zooooo`04o`000?oooooooooo
o`0002gooooo00Go0000ooooooooooooooooo`00000^ooooo`03o`000?oooooo000002kooooo00?o
0000ooooooooool0;oooool01Ol0003ooooooooooooooooo000002cooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool0000Mooooo`04o`000?ooooooooooo`0002gooooo00Go0000oooo
ooooooooooooo`00000^ooooo`03o`000?oooooo000002kooooo00?o0000ooooooooool0;oooool0
1Ol0003ooooooooooooooooo000002cooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool0000Aooooo`00:_ooool01?l0003oooooooooool0000]ooooo`05o`000?ooooooooooooooool0
0000;oooool2o`0002oooooo00?o0000ooooooooool0;_ooool01Ol0003ooooooooooooooooo0000
02_ooooo0_l00004ooooo`04o`000?ooooooooooo`0001gooooo00Co0000oooooooooooo0000;Ooo
ool01Ol0003ooooooooooooooooo000002oooooo0_l0000_ooooo`03o`000?oooooooooo02kooooo
00Go0000ooooooooooooooooo`00000[ooooo`;o00001?ooool01?l0003oooooooooool0000Aoooo
o`00:oooool2o`0002oooooo0ol0000aooooo`03o`000?oooooooooo02kooooo0_l0000_ooooo`?o
0000;Oooool00ol0003oooooooooo`03ooooo`;o00007oooool2o`0002oooooo0ol0000aooooo`03
o`000?oooooooooo02kooooo0_l0000_ooooo`?o0000;Oooool00ol0003oooooooooo`03ooooo`;o
00004_ooool00?oooooooooooomLooooo`00oooooooooooooecooooo003oooooooooooooG?ooool0
0?oooooooooooomLooooo`00oooooooooooooecooooo000Yoooooooo00000_l0000Mooooob_o0000
0oooH@:8o`000003oomQ0_l0003o000000?o000000?oof42o`000?l00000@Ol0000Cooooo`00:Ooo
ool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo
00007Oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02Oooool01_l0003oooooooooooooH@;ooooooomQ0POooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool01Ol0003oooooooooooooooooof4200Gooooo00?oof42ooooool000003?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooo000001?ooooo000Yooooo`03o`000?oooooooooo0?gooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Xooooo`04oomQ0_oooooooooooomQ0XOooooo
00?oof42ooooooooool00oooool00oooH@;oooooooooo`10ooooo`03o`000?oooooooooo017ooooo
000Yooooo`03o`000?oooooooooo0;_ooooo00?oof42ooooooooool0?oooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo02?ooooo00?oof42ooooooooool00_ooool01?ooH@;ooooooooo
ooooH@:6ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool0@?ooool00ol0003ooooo
ooooo`0Aooooo`00:Oooool2o`000;Oooooo0_ooH@83ooooo`03oomQ0_oooooooooo03kooooo0_l0
000Mooooo`;o00009?ooool00oooH@;oooooooooo`02ooooo`05oomQ0_ooooooooooooooooooH@80
QOooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo03kooooo0_l0000Cooooo`00:Ooo
ool00ol0003oooooooooo`2fooooo`04oomQ0_ooooooof42ooooo`;oof42@Oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo02;ooooo0_ooH@84ooooo`05oomQ0_oooooooooooooooooo
H@80QOooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo03oooooo00?o0000oooooooo
ool04Oooool002Wooooo00?o0000ooooooooool0:?ooool00oooH@;oooooooooo`2:ooooo`07oomQ
0_ooooooooooooooooooH@;ooooooomQ0P11ooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool08Oooool00oooH@;ooooooomQ0P03ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooo
ooooool0Poooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo03oooooo00?o0000oooo
ooooool04Oooool002Wooooo0_l0000Yooooo`03oomQ0_oooooooooo08Wooooo00?oof42oooooooo
ool01Oooool00oooH@;oooooooooo`0mooooo`;o00007Oooool2o`00027ooooo00Coof42oooooooo
ooooof420oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo08;ooooo00?oof42oooo
ooooool01Oooool00oooH@;oooooooooo`0nooooo`;o00004oooool002Wooooo00?o0000oooooooo
ool0:?ooool2oomQ0X[ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0nooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool08?ooool01?ooH@;oooooooooooooH@83oooo
o`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool0POooool00oooH@;oooooooooo`06oooo
o`03oomQ0_oooooooooo03oooooo00?o0000ooooooooool04Oooool002Wooooo00?o0000oooooooo
ool0:?ooool00oooH@;ooooooomQ0P29ooooo`03oomQ0_oooooooooo00Gooooo00?oof42oooooooo
ool0?_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo023ooooo00Coof42oooooooo
ooooof420oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo087ooooo00?oof42oooo
ooooool01_ooool00oooH@;oooooooooo`0oooooo`03o`000?oooooooooo017ooooo000Yooooo`03
o`000?oooooooooo02?ooooo00?oof42ooooooooool00_ooool00oooH@;ooooooomQ0P28ooooo`03
oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0?_ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo023ooooo00Coof42ooooooooooooof420oooool00oooH@;oooooooooo`04oooo
o`03oomQ0_oooooooooo083ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo000Yooooo`;o00009?ooool01OooH@;oooooooooooooooooof42
00?ooooo00?oof42ooooooooool0QOooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo
03gooooo0_l0000Mooooo`;o00008?ooool00oooH@;oooooooooo`02ooooo`04oomQ0_oooooooooo
oomQ0PKooooo00?oof42ooooooooool0P?ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooo
oooo03gooooo0_l0000Cooooo`00:Oooool00ol0003oooooooooo`0Rooooo`;oof420oooool01Ooo
H@;oooooooooooooooooof4208Oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0m
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool07oooool00oooH@;oooooooooo`02
ooooo`04oomQ0_oooooooooooomQ0PKooooo00?oof42ooooooooool0P?ooool00oooH@;ooooooooo
o`07ooooo`03oomQ0_oooooooooo03kooooo00?o0000ooooooooool04Oooool002Wooooo00?o0000
ooooooooool08Oooool00oooH@;ooooooomQ0P03ooooo`05oomQ0_ooooooooooooooooooH@80Qooo
ool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo03gooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`0Oooooo`03oomQ0_oooooooooo00;ooooo00Coof42ooooooooooooof42
1_ooool00oooH@;oooooooooo`20ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0
?_ooool00ol0003oooooooooo`0Aooooo`00:Oooool00ol0003oooooooooo`0Pooooo`04oomQ0_oo
oooooooooomQ0P?ooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`23ooooo`03oomQ
0_oooooooooo00Sooooo00?oof42ooooooooool0?Oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo01oooooo00?oof42ooooooooool00_ooool01?ooH@;oooooooooooooH@86ooooo`03
oomQ0_oooooooooo02?ooooo0oooH@9Jooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooooooo
ool0?_ooool00ol0003oooooooooo`0Aooooo`00:Oooool2o`00027ooooo00Coof42oooooooooooo
of420oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo08?ooooo00?oof42oooooooo
ool02?ooool00oooH@;oooooooooo`0Vooooo`03oomQ0_oooooooooo01?ooooo0_l0000Mooooo`;o
00008?ooool00oooH@;oooooooooo`02ooooo`04oomQ0_oooooooooooomQ0POooooo00?oof42oooo
ooooool08?ooool2oomQ0P?ooooo0oooH@9Gooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooo
ooooool0?Oooool2o`0001?ooooo000Yooooo`03o`000?oooooooooo01oooooo00?oof42oooooooo
ool00_ooool01?ooH@;oooooooooooooH@84ooooo`03oomQ0_oooooooooo08?ooooo00?oof42oooo
ooooool02?ooool00oooH@;oooooooooo`0Vooooo`03oomQ0_oooooooooo01Cooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`0Oooooo`03oomQ0_oooooooooo00;ooooo00Coof42oooo
ooooooooof421oooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo00Kooooo0_ooH@9E
ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0?_ooool00ol0003oooooooooo`0A
ooooo`005Oooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000oooo
ooooool07oooool00oooH@;oooooooooo`02ooooo`04oomQ0_oooooooooooomQ0PGooooo00?oof42
ooooooooool0P_ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo02Cooooo0_ooH@8F
ooooo`03o`000?oooooooooo00Oooooo0ol00004ooooo`03o`000?oooooooooo00;ooooo0ol00005
ooooo`03o`000?oooooooooo01kooooo00?oof42ooooooooool00oooool00oooH@;ooooooomQ0P08
ooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool02Oooool3oomQ0U;ooooo00?oof42
ooooooooool01oooool00oooH@;oooooooooo`0Uooooo`03oomQ0_oooooooooo01Kooooo00?o0000
ooooooooool04Oooool001Kooooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo
000000Cooooo00?o0000ooooool000000_l0000Mooooo`03oomQ0_oooooooooo00;ooooo00Coof42
ooooooooooooof421Oooool00oooH@;oooooooooo`21ooooo`03oomQ0_oooooooooo00[ooooo00?o
of42ooooooooool08oooool00oooH@;ooooooomQ0P0Fooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooool00000
0_l0000Looooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooH@802?ooool00oooH@;ooooo
ooooo`0Nooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0Coooool00oooH@;ooooo
ooooo`07ooooo`03oomQ0_oooooooooo02Gooooo00?oof42ooooooooool05_ooool00ol0003ooooo
ooooo`0Aooooo`003_ooool5o`0000?ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`02ooooo`Ko00006oooool00oooH@;oooooooooo`03ooooo`04oomQ0_oooooooooooomQ0PGooooo
00?oof42ooooooooool0POooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01Sooooo
1OooH@85ooooo`04oomQ0_oooooooooooomQ0QCooooo0ol00002ooooo`Go00000oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo1_l0000Kooooo`03oomQ0_oooooooooo00?o
oooo00?oof42ooooooooH@802?ooool00oooH@;oooooooooo`0Mooooo`03oomQ0_oooooooooo00ko
oooo00?oof42ooooooooool0;Oooool2oomQ0Qoooooo00?oof42ooooooooool02?ooool00oooH@;o
ooooooooo`0Tooooo`;oof425_ooool2o`0001?ooooo000Fooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool00_ooool6o`0001_ooooo00?oof42ooooooooool00oooool00oooH@;ooooo
oomQ0P07ooooo`03oomQ0_oooooooooo023ooooo1_ooH@9Jooooo`03oomQ0_oooooooooo00[ooooo
00?oof42ooooooooool05oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00;ooooo
00Coof42ooooooooooooof425_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool00_ooool6o`0001_ooooo00?oof42ooooooooool00oooool00oooH@;o
oooooomQ0P09ooooo`03oomQ0_oooooooooo01_ooooo00?oof42ooooooooool04?ooool00oooH@;o
ooooooooo`0[ooooo`04oomQ0_oooooooooooomQ0Qkooooo00?oof42ooooooooool02?ooool00ooo
H@;oooooooooo`0Tooooo`;oof425oooool00ol0003oooooooooo`0Aooooo`005_ooool00ol0003o
ooooooooo`07ooooo`Co00001Oooool6o`0001_ooooo00?oof42ooooooooool00oooool00oooH@;o
oooooomQ0P07ooooo`03oomQ0_oooooooooo01kooooo0_ooH@86ooooo`?oof42Eoooool00oooH@;o
ooooooooo`0:ooooo`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool01?ooool00oooH@;o
ooooooooo`02ooooo`05oomQ0_ooooooooooooooooooH@805Oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Oooooo1?l00005ooooo`Ko00006oooool00oooH@;oooooooooo`03oooo
o`03oomQ0_ooooooof4200Wooooo00?oof42ooooooooool06_ooool00oooH@;oooooooooo`0Aoooo
o`03oomQ0_oooooooooo02[ooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0Koooo
o`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool07oooool00oooH@;oooooooooo`02oooo
o`03oomQ0_ooooooof4201Kooooo00?o0000ooooooooool04Oooool001Gooooo0_l00009ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooool000000_l000000oooH@;oooooooooo`0Iooooo`03
oomQ0_oooooooooo00?ooooo00?oof42ooooooooH@801oooool00oooH@;oooooooooo`0Looooo`;o
of422oooool2oomQ0SKooooo2OooH@8Fooooo`03oomQ0_oooooooooo00[ooooo00?oof42oooooooo
ool05_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00;ooooo00Goof42oooooooo
oooooooooomQ0P0Eooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooool000000_l000000oooH@;oooooooooo`0Hooooo`03oomQ0_oooooooooo
00Cooooo00?oof42ooooooooH@802Oooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo
01;ooooo00?oof42ooooooooool0:Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo
01_ooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo
00;ooooo00?oof42ooooooooH@805_ooool00ol0003oooooooooo`0Aooooo`005_ooool00ol0003o
ooooooooo`07ooooo`Go00001?ooool2o`000004o`3jV_ooH@;ooooooomQ0Q[ooooo00?oof42oooo
ooooool01?ooool01OooH@;ooooooomQ0_oooooo003o00Gooooo00?oof42ooooooooool07?ooool0
0oooH@;oooooooooo`0<ooooo`?oof42<Oooool2oomQ0PWooooo0_ooH@8Dooooo`03oomQ0_oooooo
oooo00[ooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`03ooooo`03o`00oooooooo
of4200Cooooo00Goof42oooooooooooooooooomQ0P0Dooooo`;o00002_ooool00ol0003ooooooooo
o`07ooooo`Go00001?ooool2o`000004o`3jV_ooH@;ooooooomQ0Q[ooooo00?oof42ooooooooool0
1?ooool01OooH@;ooooooomQ0_oooooo003o00Oooooo00?oof42ooooooooool06Oooool00oooH@;o
ooooooooo`0Cooooo`03oomQ0_oooooooooo02Sooooo00?oof42ooooooooool01?ooool00oooH@;o
ooooooooo`0Jooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool07Oooool00ol00?oo
of42oomQ0P04ooooo`03oomQ0_ooooooof4201Gooooo0_l0000Cooooo`00:Oooool01_l0003ooooo
o`3jV_ooH@;ooooooomQ0Q[ooooo00?oof42ooooooooool01?ooool01OooH@;ooooooomQ0_oooooo
003o00Gooooo00?oof42ooooooooool06oooool00oooH@;oooooooooo`0@ooooo`;oof42;_ooool0
0oooH@;oooooooooo`0;ooooo`?oof424Oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooo
oooo01Cooooo00?oof42ooooooooool00oooool00ol00?oooooooomQ0P04ooooo`05oomQ0_oooooo
ooooooooooooH@805Oooool00ol0003oooooooooo`0Kooooo`06o`000?oooooo0?ZJoomQ0_oooooo
of426_ooool00oooH@;oooooooooo`04ooooo`05oomQ0_ooooooof42ooooool00?l02?ooool00ooo
H@;oooooooooo`0Hooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool09_ooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool02?ooool00ooo
H@;oooooooooo`0Mooooo`03o`00ooooH@;oof4200Cooooo00Coof42ooooooooooooof425Oooool0
0ol0003oooooooooo`0Aooooo`00:Oooool01_l0003oooooo`3jV_ooH@;ooooooomQ0Q[ooooo00?o
of42ooooooooool01?ooool00oooH@;ooooooomQ0P02o`00o`Kooooo00?oof42ooooooooool06Ooo
ool00oooH@;oooooooooo`0Cooooo`?oof426Oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oo
oooooooo00oooooo1OooH@8<ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool04ooo
ool00oooH@;oooooooooo`03ooooo`;o003o0_ooool01OooH@;oooooooooooooooooof4200?ooooo
00?oof42ooooooooool04oooool00ol0003oooooooooo`0Kooooo`06o`000?oooooo0?ZJoomQ0_oo
ooooof426_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_ooooooof4200;o003o2?ooool00ooo
H@;oooooooooo`0Gooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool05_ooool2oomQ
0Pkooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo
00Wooooo00?oof42ooooooooool07?ooool2o`00o`;oof420oooool01OooH@;ooooooooooooooooo
of4201Gooooo00?o0000ooooooooool04Oooool002Wooooo00Co0000ooooool0nY[oof420_ooool0
0oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00Gooooo00Goof42ooooooooH@;oooooo`00
o`06ooooo`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool05_ooool00oooH@;ooooooooo
o`0Eooooo`;oof424?ooool00oooH@;oooooooooo`0Dooooo`Goof421oooool00oooH@;ooooooooo
o`0;ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool00oooool2o`00o`;ooooo00Co
of42ooooooooooooof421?ooool00oooH@;oooooooooo`0Cooooo`03o`000?oooooooooo01_ooooo
00Co0000ooooool0nY[oof420_ooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00Go
oooo0_ooH@800ooooooo003oooooo`07ooooo`03oomQ0_oooooooooo01Oooooo00?oof42oooooooo
ool05_ooool00oooH@;oooooooooo`0Cooooo`;oof4200?ooooooomQ0_ooool03?ooool00oooH@;o
ooooooooo`08ooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool02_ooool00oooH@;o
ooooooooo`0Kooooo`05o`00ooooH@;oooooooooooooH@800_ooool01OooH@;ooooooooooooooooo
of4201Gooooo00?o0000ooooooooool04Oooool002Wooooo0_l000001Ol0nY[oof42oooooooooooo
of4201Sooooo00?oof42ooooooooool01_ooool2oomQ0P03ooooool00?oooooo00Gooooo00?oof42
ooooooooool06?ooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo01Cooooo00Coof42
ooooooooooooof423_ooool00oooH@;oooooooooo`0Jooooo`?oof421?ooool00oooH@;ooooooooo
o`0;ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool00oooool2o`00o`;ooooo00Co
of42ooooooooooooof421?ooool00oooH@;oooooooooo`0Booooo`;o00007Oooool2o`000005o`3j
V_ooH@;oooooooooooooH@806?ooool00oooH@;oooooooooo`06ooooo`;oof4200?oooooo`00oooo
ool01oooool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo01Oooooo00?oof42oooooooo
ool04oooool01OooH@;oooooooooooooooooof4200cooooo00?oof42ooooooooool02Oooool00ooo
H@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX6ooooo`03oomQ0_oooooooooo
01_ooooo00Go003ooomQ0_oooooooooooomQ0P02ooooo`03oomQ0_oooooooooo00;ooooo00?oof42
ooooooooool04Oooool2o`0001?ooooo000Yooooo`04o`000?oooooo0?ZJoomQ0P;ooooo00?oof42
ooooooooool05_ooool00oooH@;oooooooooo`06ooooo`;oof4200?oooooo`00ooooool01_ooool0
0oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool04oooool0
1OooH@;oooooooooooooooooof4200kooooo00?oof42ooooooooool07?ooool00oooH@;ooooooooo
o`02ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool04_ooool00oooH@;ooooooooo
o`03ooooo`03o`00oooooooo003o00;ooooo00Coof42ooooooooooooof421?ooool00oooH@;ooooo
ooooo`0Cooooo`03o`000?oooooooooo01_ooooo00Co0000ooooool0nY[oof420_ooool00oooH@;o
ooooooooo`0Fooooo`03oomQ0_oooooooooo00Kooooo00Coof42oooooooooooo003o2?ooool00ooo
H@;oooooooooo`0Fooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool04_ooool00ooo
H@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool02_ooool00ooo
H@;oooooooooo`0Fooooo`04oomQ0_ooooooooooooooo`?o0?ZJ1_ooool00oooH@;oooooooooo`0J
ooooo`03o`00ooooooooof4200;ooooo00Coof42ooooooooooooof421?ooool00oooH@;ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo000Yooooo`04o`000?oooooo0?ZJoomQ0P;ooooo00?o
of42ooooooooool05_ooool00oooH@;oooooooooo`06ooooo`04oomQ0_ooooooooooo`00o`Sooooo
00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo01;ooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01gooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01;ooooo
00?oof42ooooooooool00oooool00ol00?ooooooo`00o`02ooooo`04oomQ0_oooooooooooomQ0PCo
oooo00?oof42ooooooooool04oooool00ol0003oooooooooo`0Kooooo`07o`000?oooooo0?ZJoomQ
0_l0nY[ooooooomQ0P0Hooooo`03oomQ0_oooooooooo00Kooooo00Coof42oooooooooooo003o2Ooo
ool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool04Ooo
ool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool02_oo
ool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00Go0?ZJ1Oooool00oooH@;ooooooooo
o`0Jooooo`03o`00ooooH@;o003o00;ooooo00Coof42ooooooooooooof421?ooool00oooH@;ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo000Yooooo`07o`000?oooooo0?ZJoomQ0_l0nY[o
oooooomQ0P0Gooooo`03oomQ0_oooooooooo00Kooooo0ol000000ooooooo003oooooo`08ooooo`03
oomQ0_oooooooooo01?ooooo00?oof42ooooooooool06_ooool00oooH@;oooooooooo`0Aooooo`03
oomQ0_oooooooooo00?ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0Mooooo`03
oomQ0_oooooooooo00;ooooo00Coof42oooooooooooo003o2_ooool00oooH@;oooooooooo`0Aoooo
o`03oomQ0_oooooooooo00Cooooo00?o003oooooool00?l00_ooool01?ooH@;oooooooooooooH@84
ooooo`03oomQ0_oooooooooo01?ooooo00?o0000ooooooooool06oooool01ol0003ooooooooooooo
H@;o0?ZJooooooooH@806?ooool00oooH@;oooooooooo`05ooooo`?o000000?oooooo`00ooooool0
2?ooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool0
4Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0
3?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo00;o0?ZJ00?oooooo`3jV_l0nYX0
1Oooool00oooH@;oooooooooo`0Jooooo`03o`00ooooH@;o003o00;ooooo00Coof42oooooooooooo
of421Oooool00oooH@;oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo000Yooooo`;o0000
00GooooooomQ0_l0nY[ooooooomQ0P0Gooooo`03oomQ0_oooooooooo00Gooooo1Ol000000ooooooo
003oooooo`07ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool06oooool00oooH@;o
ooooooooo`0@ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool02?ooool00oooH@;o
ooooooooo`0Nooooo`03oomQ0_oooooooooo00;ooooo00Coof42ooooool00?oo003o2oooool00ooo
H@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Cooooo00Co003ooooooooooooo003o0_ooool0
1?ooH@;oooooooooooooH@85ooooo`03oomQ0_oooooooooo017ooooo0_l0000Mooooo`;o000000Go
oooooomQ0_l0nY[ooooooomQ0P0Hooooo`03oomQ0_oooooooooo00Cooooo1Ol000000ooooooo003o
ooooo`07ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool06_ooool00oooH@;ooooo
ooooo`0@ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01?ooool00oooH@;ooooo
ooooo`0=ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool00_l0nYX00ooooooo0?ZJ
o`3jVP05ooooo`03oomQ0_oooooooooo01Wooooo00Co003oooooooooH@;o003o0_ooool01?ooH@;o
ooooooooooooH@85ooooo`03oomQ0_oooooooooo013ooooo0_l0000Cooooo`00:Oooool01ol0003o
ooooooooooooH@;o0?ZJooooooooH@805oooool00oooH@;oooooooooo`05ooooo`Go000000?ooooo
o`00ooooool01oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo01_ooooo00?oof42
ooooooooool04?ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Kooooo00?oof42
ooooooooool07oooool02OooH@;oooooooooooooooooof42ooooool00?ooooooo`00o`0;ooooo`03
oomQ0_oooooooooo00oooooo00?oof42ooooooooool01?ooool01?l00?ooooooooooool00?l2oooo
o`04oomQ0_oooooooooooomQ0PGooooo00?oof42ooooooooool04_ooool00ol0003oooooooooo`0K
ooooo`07o`000?oooooooooooomQ0_l0nY[ooooooomQ0P0Gooooo`03oomQ0_oooooooooo00Gooooo
1Ol000000ooooooo003oooooo`07ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool0
6_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00Oooooo0_ooH@82ooooo`;oof42
4?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooo0?ZJ00;o0?ZJ00Coooooo`3jV_l0nY[o
0?ZJ1?ooool00oooH@;oooooooooo`0Iooooo`04o`00ooooH@;oooooo`00o`;ooooo00Coof42oooo
ooooooooof421Oooool00oooH@;oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo000Yoooo
o`05o`000?oooooooooooomQ0_l0nYX00_ooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooo
oooo00Gooooo1Ol000000ooooooo003oooooo`07ooooo`03oomQ0_oooooooooo01;ooooo00?oof42
ooooooooool06oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Sooooo00?oof42
ooooooooool01Oooool00oooH@;oooooooooo`0Oooooo`06oomQ0_ooooooooooooooooooH@;o003o
0_ooool00ol00?ooooooooooo`09ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool0
1Oooool01?l00?ooooooooooool00?l3ooooo`03oomQ0_ooooooof4200Gooooo00?oof42oooooooo
ool04_ooool00ol0003oooooooooo`0Kooooo`07o`000?oooooooooooomQ0_l0nY[ooooooomQ0P0G
ooooo`03oomQ0_oooooooooo00Gooooo1Ol000000ooooooo003oooooo`07ooooo`03oomQ0_oooooo
oooo01;ooooo00?oof42ooooooooool06oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooo
oooo00[ooooo0_ooH@8Cooooo`03oomQ0_oooooooooo01Cooooo00Goof42o`00ool0nY[o0?ZJo`00
o`02ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`0Iooooo`04o`00ooooH@;oooooo`00o`;ooooo
00Coof42ooooooooooooof421_ooool00oooH@;oooooooooo`0@ooooo`03o`000?oooooooooo017o
oooo000Yooooo`05o`000?oooooooooooomQ0_l0nYX00_ooool00oooH@;oooooooooo`0Dooooo`03
oomQ0_oooooooooo00Kooooo0ol00002ooooo`03o`00oooooooooooo00Kooooo00?oof42oooooooo
ool04Oooool00oooH@;oooooooooo`0Mooooo`03oomQ0_oooooooooo00gooooo00?oof42oooooooo
ool02Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo027ooooo00Goof42oooooooo
ooooof42o`00o`02ooooo`03o`00oooooooooooo00Wooooo00?oof42ooooooooool03Oooool00ooo
H@;oooooooooo`06ooooo`04o`00ooooooooooooo`00o`?ooooo00?oof42ooooooooH@801Oooool0
0oooH@;oooooooooo`0Booooo`03o`000?oooooooooo01_ooooo00Oo0000ooooooooooooof42o`3j
V_ooooooof4201Oooooo00?oof42ooooooooool01_ooool3o`0000;ooooo00?o003oooooooooool0
1_ooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo01cooooo00?oof42ooooooooool0
3Oooool00oooH@;oooooooooo`0Pooooo`03oomQ0_oooooooooo01Cooooo00Goof42o`00ool0nY[o
0?ZJo`00o`02ooooo`;o0?ZJ1Oooool00oooH@;oooooooooo`0Hooooo`04o`00ooooH@;oooooo`00
o`?ooooo00?oof42ooooooooH@801oooool00oooH@;oooooooooo`0?ooooo`03o`000?oooooooooo
017ooooo000Yooooo`;o000000?ooooooomQ0_l0nYX00_ooool00oooH@;oooooooooo`0Dooooo`03
oomQ0_oooooooooo00Kooooo00?o0?ZJoomQ0_l0nYX00_ooool00ol00?ooooooooooo`07ooooo`03
oomQ0_oooooooooo013ooooo00?oof42ooooooooool07Oooool00oooH@;oooooooooo`0<ooooo`03
oomQ0_oooooooooo00_ooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0Rooooo`05
oomQ0_oooooooooooomQ0_l00?l00_ooool00ol00?ooooooooooo`09ooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool01_ooool01Ol00?oooooooooooooooooo003o00;ooooo00?oof42
ooooooooH@801Oooool00oooH@;oooooooooo`0Aooooo`;o00007Oooool2o`000003ooooooooH@;o
0?ZJ00;ooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`05ooooo`;o0?ZJ00Goof42
o`3jV_l0nY[oooooo`00o`09ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool07?oo
ool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo023ooooo00?oof42ooooooooool05?oo
ool01OooH@;o003oo`3jV_l0nY[o003o00;ooooo0ol0nYX4ooooo`03oomQ0_oooooooooo01Sooooo
00Goof42ooooooooooooooooo`00o`02ooooo`03oomQ0_ooooooof4200Oooooo00?oof42oooooooo
ool03_ooool2o`0001?ooooo000Yooooo`05o`000?oooooooooooomQ0_l0nYX00_ooool00oooH@;o
ooooooooo`0Cooooo`03oomQ0_oooooooooo00Oooooo00?o0?ZJoomQ0_l0nYX00_ooool00ol00?oo
ooooooooo`07ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool05oooool00ol00?oo
ooooooooo`02ooooo`03o`00ooooooooof4200kooooo00?oof42ooooooooool03?ooool4oomQ0RGo
oooo00Goof42ooooooooooooof42o`00o`02ooooo`03o`00oooooooooooo00Wooooo00?oof42oooo
ooooool03?ooool00oooH@;oooooooooo`07ooooo`05o`00ooooooooooooooooool00?l00_ooool0
0oooH@;ooooooomQ0P05ooooo`03oomQ0_oooooooooo01;ooooo00?o0000ooooooooool06oooool0
1Ol0003oooooooooooooH@;o0?ZJ00;ooooo00?oof42ooooooooool05?ooool00oooH@;ooooooooo
o`05ooooo`;o0?ZJ00Goof42o`3jV_l0nY[o0?ZJo`00o`09ooooo`03oomQ0_oooooooooo013ooooo
00?oof42ooooooooool05_ooool00ol00?ooooooooooo`02ooooo`03o`00ooooooooof4200kooooo
00?oof42ooooooooool08_ooool00oooH@;oooooooooo`0Cooooo`05oomQ0_l0nY[o0?ZJo`3jV_l0
0?l00oooool2o`3jVPCooooo00?oof42ooooooooool06?ooool01OooH@;ooooooooooooooooo003o
00;ooooo00?oof42ooooooooH@802?ooool00oooH@;oooooooooo`0>ooooo`03o`000?oooooooooo
017ooooo000Qooooo`?o00001Oooool01Ol0003oooooooooooooH@;o0?ZJ00;ooooo00?oof42oooo
ooooool04oooool00oooH@;oooooooooo`07ooooo`03o`3jV_ooH@;o0?ZJ00;ooooo00?o003ooooo
ooooool01oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo01Oooooo00?o003ooooo
ooooool00_ooool00ol00?oooooooomQ0P0=ooooo`03oomQ0_oooooooooo03Kooooo00Goof42oooo
ooooooooof42o`00o`02ooooo`03o`00oooooooooooo00[ooooo00?oof42ooooooooool02oooool0
0oooH@;oooooooooo`07ooooo`05o`00ooooooooooooooooool00?l00_ooool00oooH@;ooooooomQ
0P06ooooo`03oomQ0_oooooooooo017ooooo00?o0000ooooooooool04oooool3o`0000Gooooo00Go
0000ooooooooooooof42o`3jVP02ooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool0
1Oooool2o`3jVP05oomQ0_oooooo0?ZJo`3jV_l00?l02Oooool00oooH@;oooooooooo`0@ooooo`03
oomQ0_oooooooooo01Kooooo00?o003oooooooooool00_ooool00ol00?oooooooomQ0P0>ooooo`03
oomQ0_oooooooooo02;ooooo00?oof42ooooooooool04oooool01OooH@;o0?ZJo`3jV_oooooo003o
00?ooooo0_l0nYX4ooooo`03oomQ0_oooooooooo01Oooooo00?oof42o`00ooooool00_ooool01_l0
0?ooooooooooooooH@;ooooooomQ0PSooooo00?oof42ooooooooool02Oooool3oomQ0P;ooooo00?o
0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooo
H@;o0?ZJ00;ooooo00?oof42ooooooooool04oooool01OooH@;ooooooooooooooooo003o00Gooooo
00?o0?ZJoomQ0_l0nYX00_ooool00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00kooooo
00?oof42ooooooooool05oooool2o`00o`Cooooo00Co003oooooooooooooof423?ooool00oooH@;o
ooooooooo`0fooooo`05oomQ0_oooooooooooomQ0_l00?l00_ooool00ol00?ooooooooooo`0:oooo
o`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool02?ooool01Ol00?oooooooooooooooooo
003o00;ooooo00?oof42ooooooooH@801_ooool00oooH@;oooooooooo`0>ooooo`04oomQ0_oooooo
ooooo`0001Kooooo00?o0000ooooooooool01?ooool01Ol0003oooooooooool0nY[oof4200;ooooo
00?oof42ooooooooool05?ooool01?ooH@;oooooooooool00?l3ooooo`?o0?ZJ00Goof42ooooool0
nY[o0?ZJo`00o`09ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool05Oooool2o`00
o`Cooooo00Co003oooooooooooooof423?ooool00oooH@;oooooooooo`0Sooooo`03oomQ0_oooooo
oooo01?ooooo00Goof42o`3jV_l0nY[oooooo`00o`03ooooo`;o0?ZJ1?ooool00oooH@;ooooooooo
o`0Gooooo`03oomQ0_l00?oooooo00;ooooo00Ko003oooooooooooooof42ooooooooH@89ooooo`03
oomQ0_oooooooooo00Sooooo00Koof42ooooooooooooof42ooooool0000Cooooo`006_ooool5o`00
00?ooooo00?o0000ooooooooool01?ooool3o`000005o`3jV_ooH@;oooooooooooooH@805Oooool0
1OooH@;ooooooooooooooooo003o00Cooooo0_l0nYX01OooH@;o0?ZJo`3jV_oooooo003o00Wooooo
00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Fooooo`03o`00oooooooo003o00?ooooo
0_l00?l2ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0=_ooool01OooH@;ooooo
ooooooooH@;o003o00;ooooo00?o003oooooooooool02_ooool00oooH@;oooooooooo`0:ooooo`03
oomQ0_oooooooooo00Sooooo00Go003oooooooooooooooooo`00o`02ooooo`;oof422?ooool00ooo
H@;oooooooooo`0=ooooo`04oomQ0_l0003o0000o`0000kooooo1Ol00003ooooo`03o`000?oooooo
oooo00Cooooo0ol000001Ol0nY[oof42ooooooooooooof4201Kooooo00Coof42oooooooooooo003o
0oooool2o`3jVP03o`00ooooH@;ooooo00?o0?ZJ2Oooool00oooH@;oooooooooo`0?ooooo`03oomQ
0_oooooooooo01Gooooo00?o003oooooool00?l00oooool2o`00o`;ooooo00?oof42ooooooooool0
2_ooool00oooH@;oooooooooo`0Tooooo`03oomQ0_oooooooooo01;ooooo00Goof42o`3jV_l0nY[o
ooooo`00o`03ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`0Eooooo`;oof4200?oooooo`00oooo
ool00_ooool00ol00?ooooooooooo`02oomQ0P[ooooo00?oof42ooooooooool01oooool00oooH@;o
ooooooooo`02ooooo`;o00004oooool002;ooooo00?o0000ooooooooool01?ooool01Ol0003ooooo
ooooool0nY[oof4200?ooooo00?oof42ooooooooool04_ooool01OooH@;ooooooooooooooooo003o
00Cooooo0_l0nYX01OooH@;o0?ZJo`3jV_oooooo003o00Wooooo00?oof42ooooooooool03_ooool0
0oooH@;oooooooooo`0Eooooo`05o`00ooooooooooooooooool00?l00_ooool2o`00o`;ooooo00?o
of42ooooooooool02Oooool00oooH@;oooooooooo`0gooooo`05oomQ0_oooooooooooomQ0_l00?l0
0oooool00ol00?ooooooooooo`0:ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0
1oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;oof422?ooool00oooH@;ooooo
ooooo`0<ooooo`05oomQ0_ooooooooooooooool000005_ooool00ol0003oooooooooo`04ooooo`05
o`000?ooooooooooo`3jV_ooH@800_ooool00oooH@;oooooooooo`0Cooooo`05oomQ0_oooooooooo
ooooool00?l00oooool2o`3jVP04o`00ooooH@;oof42ooooo`;o0?ZJ2Oooool00oooH@;ooooooooo
o`0?ooooo`03oomQ0_oooooooooo01Cooooo00Go003oooooooooooooooooo`00o`02ooooo`;o003o
0oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo02Cooooo00?oof42ooooooooool0
4_ooool00oooH@;o0?ZJo`3jVP02ooooo`03o`00oooooooooooo00;o0?ZJ1?ooool00oooH@;ooooo
ooooo`0Dooooo`04oomQ0_ooooooooooo`00o`Cooooo00?o003oooooooooool00_ooH@8:ooooo`03
oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01?ooool00ol0003oooooooooo`0Aooooo`00
8_ooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooo`3jV_ooH@800oooool00oooH@;o
ooooooooo`0Booooo`05oomQ0_ooooooooooooooool00?l01?ooool2o`3jVP;oof4200?o0?ZJoooo
ool00?l02Oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Kooooo00Go003ooooo
ooooooooooooo`00o`02ooooo`;o003o0oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooo
oooo03Oooooo00Goof42ooooooooooooof42o`00o`03ooooo`03o`00oooooooooooo00[ooooo00?o
of42ooooooooool02?ooool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool00_ooH@88ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool00_oo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Cooooo00Go0000oooooooooooo0?ZJ
oomQ0P02ooooo`03oomQ0_oooooooooo01?ooooo00Goof42ooooooooooooooooo`00o`03ooooo`;o
0?ZJ00Co003ooomQ0_ooH@;ooooo0_l0nYX9ooooo`03oomQ0_oooooooooo00kooooo00?oof42oooo
ooooool05Oooool01Ol00?oooooooooooooooooo003o00;ooooo0_l00?l3ooooo`03oomQ0_oooooo
oooo00Sooooo00?oof42ooooooooool09Oooool00oooH@;oooooooooo`0Booooo`03oomQ0_l0nY[o
0?ZJ00;ooooo00?o003oooooooooool00ol0nYX3ooooo`03oomQ0_oooooooooo01?ooooo00Goof42
ooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;oof422oooool00oooH@;ooooooooo
o`05ooooo`03oomQ0_oooooooooo00Cooooo00?o0000ooooooooool04Oooool0027ooooo0_l00006
ooooo`05o`000?ooooooooooo`3jV_ooH@800oooool00oooH@;oooooooooo`0Booooo`05oomQ0_oo
ooooooooooooool00?l01?ooool2o`3jVP;oof4200?o0?ZJooooool00?l02_ooool00oooH@;ooooo
ooooo`0<ooooo`03oomQ0_oooooooooo01Kooooo00Go003oooooooooooooooooo`00o`02ooooo`;o
003o0oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo03Sooooo00Goof42oooooooo
ooooof42o`00o`03ooooo`05o`00ooooooooooooooooool00?l02?ooool00oooH@;oooooooooo`08
ooooo`03oomQ0_oooooooooo00Sooooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooo
ooooof4200Wooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`02ooooo`03o`000?oo
oooooooo01?ooooo0_l00006ooooo`05o`000?ooooooooooo`3jV_ooH@800_ooool00oooH@;ooooo
ooooo`0Cooooo`05oomQ0_ooooooooooooooool00?l00_ooool3o`3jVP04o`00ooooH@;oof42oooo
o`?o0?ZJ2Oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Gooooo00Go003ooooo
ooooooooooooo`00o`02ooooo`;o003o0oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooo
oooo02Kooooo00?oof42ooooooooool04Oooool00oooH@;o0?ZJooooo`02ooooo`04o`00oooooooo
ooooooooo`;o0?ZJ0oooool00oooH@;oooooooooo`0Cooooo`05oomQ0_ooooooooooooooool00?l0
1?ooool01Ol00?ooooooooooooooooooof4200cooooo00?oof42ooooooooool00oooool00oooH@;o
ooooooooo`05ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00Cooooo
0_l000000ooooooo0?ZJoomQ0P03ooooo`03oomQ0_oooooooooo01;ooooo00Goof42oooooooooooo
ooooo`00o`04ooooo`;o0?ZJ0_ooH@82o`3jVP03o`00oooooooooooo00Sooooo00?oof42oooooooo
ool03?ooool00oooH@;oooooooooo`0Fooooo`05o`00ooooooooooooooooool00?l00_ooool2o`00
o`?ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0iooooo`05oomQ0_oooooooooo
oomQ0_l00?l00oooool01Ol00?oooooooooooooooooo003o00Sooooo00?oof42ooooooooool01ooo
ool00oooH@;oooooooooo`09ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00ol0
0008ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool00_ooool2o`0001Kooooo00?o
0000ooooooooool01?ooool2o`000003ooooool0nY[oof4200;ooooo00?oof42ooooooooool04ooo
ool01OooH@;ooooooooooooooooo003o00;ooooo0_l0nYX01?oooooo003ooomQ0_ooH@82ooooo`;o
0?ZJ2Oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Gooooo00Go003ooooooooo
ooooooooo`00o`02ooooo`;o003o1?ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo
02Oooooo00?oof42ooooooooool04Oooool00oooH@;o0?ZJooooo`02ooooo`04o`00oooooooooooo
ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`0Booooo`05oomQ0_ooooooooooooooool00?l01?oo
ool00ol00?ooooooooooo`03o`0000cooooo00Goof42oooooooooooooooooomQ0P07ooooo`;o0000
4oooool002Wooooo00Go0000oooooooooooo0?ZJoomQ0P03ooooo`03oomQ0_oooooooooo01;ooooo
00Goof42ooooooooooooooooo`00o`04ooooo`;o0?ZJ0_ooH@82o`3jVP03o`00oooooooooooo00So
oooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Gooooo`09o`00oooooooooooooooo
ool00?ooooooo`00oooooooo003o00Cooooo00?oof42ooooooooool01Oooool00oooH@;ooooooooo
o`0iooooo`04oomQ0_oooooooooooomQ0PCooooo00Go003oooooooooooooooooo`00o`09ooooo`03
oomQ0_oooooooooo00Kooooo00?oof42ooooooooool02Oooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooo000000Co00001?ooool01Ol00?ooooooooooooooooooof4200[ooooo00?oof42oooo
ooooool00oooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooo`3jV_ooH@800oooool0
0oooH@;oooooooooo`0Booooo`05oomQ0_ooooooooooooooool00?l00_ooool2o`3jVP04o`00oooo
H@;ooooooomQ0P;ooooo0_l0nYX9ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0
5_ooool02Ol00?oooooooooooooooooo003oooooool00?ooooooo`00o`04ooooo`03oomQ0_oooooo
oooo00Gooooo00?oof42ooooooooool0:?ooool00oooH@;oooooooooo`0Aooooo`03oomQ0_l0nY[o
oooo00;ooooo00Co003ooooooooooooooooo0_l0nYX4ooooo`03oomQ0_oooooooooo017ooooo00?o
of42ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo000000Co00001?oo
ool00ol00?ooooooooooo`05ooooo`?oof422Oooool00ol0003oooooooooo`0Aooooo`00:Oooool0
1Ol0003oooooooooool0nY[oof4200?ooooo00?oof42ooooooooool04Oooool00oooH@;ooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo0_l0nYX2oomQ0P;o0?ZJ00?o003oooooooooool02?oo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01Kooooo00?o003oooooooooool00_oo
ool01Ol00?ooooooo`00oooooooo003o00Cooooo00?oof42ooooooooool01?ooool00oooH@;ooooo
ooooo`0jooooo`04oomQ0_oooooooooooomQ0PCooooo00Go003oooooooooooooooooo`00o`09oooo
o`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool02_ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooo000000Co00001?ooool01Ol00?ooooooooooooooooooof4200Wooooo00?oof42
ooooooooool01?ooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooo`3jV_ooH@800ooo
ool00oooH@;oooooooooo`0Booooo`06oomQ0_ooooooooooooooool00?oooooo0ol0nYX01?l00?oo
of42ooooooooH@82ooooo`;o0?ZJ2Oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo
01Gooooo00?o003oooooooooool00_ooool01Ol00?ooooooo`00oooooooo003o00Gooooo00?oof42
ooooooooool00oooool00oooH@;oooooooooo`0Yooooo`03oomQ0_oooooooooo017ooooo00?oof42
o`3jV_ooool00_ooool01?l00?ooooooooooooooool2o`3jVPCooooo00?oof42ooooooooool04Ooo
ool00oooH@;oooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooool000001?l0
0004ooooo`03o`00oooooooooooo017ooooo00?o0000ooooooooool04Oooool002Wooooo00Go0000
oooooooooooo0?ZJoomQ0P03ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool00_oo
ool00ol00?ooooooooooo`02ooooo`;o0?ZJ0_ooH@82o`3jVP03ooooool00?oooooo00Sooooo00?o
of42ooooooooool02oooool00oooH@;oooooooooo`0Fooooo`03o`00oooooooooooo00;ooooo00?o
003oooooool00?l00_ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00?ooooo00?o
of42ooooooooool0>_ooool01?ooH@;oooooooooooooH@84ooooo`04o`00ooooooooooooooooo`;o
003o2?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00[ooooo00?o003ooooooooo
ool00_ooool00ol00?ooooooo`000004o`0000Cooooo00Go003ooooooooooooooooooomQ0P09oooo
o`03oomQ0_oooooooooo00Cooooo00?o0000ooooooooool06oooool01_l0003oooooooooool0nY[o
of42o`3jVP;ooooo00?oof42ooooooooool04_ooool01_ooH@;ooooooooooooooooo003oooooo`;o
0?ZJ00Goooooo`00ooooH@;ooooooomQ0P02ooooo`?o0?ZJ2?ooool00oooH@;oooooooooo`0<oooo
o`03oomQ0_oooooooooo01Gooooo00?o003oooooooooool00_ooool00ol00?ooooooo`00o`02oooo
o`03o`00oooooooooooo00;ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`0Zoooo
o`03oomQ0_oooooooooo013ooooo00?oof42o`3jV_ooool00_ooool01?l00?ooooooooooooooool2
o`3jVPCooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`02ooooo`03o`00oooooooo
oooo00;ooooo00?o003oooooool000001?l00004ooooo`03o`00oooooooooooo017ooooo00?o0000
ooooooooool04Oooool002Wooooo0_l000000ooooooo0?ZJoomQ0P03ooooo`03oomQ0_oooooooooo
017ooooo00?oof42ooooooooool00_ooool2o`00o`?ooooo0_l0nYX2oomQ0P;o0?ZJ00?oooooo`00
ooooool02?ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01Oooooo00?o003ooooo
ooooool00oooool2o`00o`;ooooo00?o003oooooooooool00_ooool00oooH@;oooooooooo`02oooo
o`03oomQ0_oooooooooo03cooooo00?oof42ooooooooH@801?ooool01Ol00?ooooooooooool00?oo
oooo00;o0?ZJ2?ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00_ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`03o`0000Gooooo00?o003oooooooooool00_ooool0
0oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00?ooooo0_l0000Mooooo`;o00000_ooool0
1OooH@;o0?ZJooooooooooooof4201Cooooo00Coof42oooooooooooooooo0_l00?l2o`3jVP05oooo
ool00?ooof42ooooooooH@800oooool2o`3jVPSooooo00?oof42ooooooooool02oooool00oooH@;o
ooooooooo`0Fooooo`03o`00oooooooooooo00?ooooo0_l00?l2ooooo`03o`00oooooooooooo00?o
oooo0oooH@800oooooooof42ooooo`0/ooooo`03oomQ0_oooooooooo013ooooo00?oof42o`3jV_oo
ool00_ooool01?l00?ooooooooooool00?l2o`3jVPCooooo00?oof42ooooooooool04?ooool00ooo
H@;oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooool0nYX00ol00005oooo
o`03o`00oooooooooooo013ooooo0_l0000Cooooo`00:Oooool01Ol0003oooooooooool0nY[oof42
00?ooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`02ooooo`;o003o0oooool2o`3j
VP;oof420ol0nYX00ol00?ooooooooooo`08ooooo`03oomQ0_oooooooooo00Wooooo00?oof42oooo
ooooool05oooool00ol00?ooooooooooo`03ooooo`;o003o0_ooool00ol00?ooooooooooo`03oooo
o`Coof42?oooool00oooH@;ooooooomQ0P04ooooo`05o`00ooooooooooooo`00ooooool00_l0nYX8
ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool02oooool00ol00?ooooooooooo`02
ooooo`06o`00ooooooooooooo`3jV_ooH@;o0?ZJ1?ooool2o`00o`Cooooo00?oof42ooooooooool0
1Oooool00oooH@;oooooooooo`05ooooo`03o`000?oooooooooo01_ooooo00Ko0000oooooooooooo
oooooomQ0_l0nYX2ooooo`03oomQ0_oooooooooo01;ooooo00Coof42oooooooooooooooo0_l00?l2
o`3jVP05ooooool00?ooof42ooooooooH@800oooool2o`3jVPWooooo00?oof42ooooooooool02_oo
ool00oooH@;oooooooooo`0Fooooo`03o`00oooooooooooo00?ooooo0_l00?l2ooooo`03o`00oooo
oooooooo00Kooooo00?oof42ooooooooool0;?ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_l0
nY[ooooo00;ooooo00Co003ooooooooooooo003o0_l0nYX4ooooo`03oomQ0_oooooooooo013ooooo
00?oof42ooooooooool00oooool00ol00?ooooooooooo`02ooooo`05o`00oooooooo0?ZJo`3jV_oo
H@800_l0nYX3ooooo`;o003o4oooool00ol0003oooooooooo`0Aooooo`00:Oooool01_l0003ooooo
ooooool0nY[oof42o`3jVP?ooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`02oooo
o`;o003o0oooool2o`3jVP;oof4200Coooooo`3jV_l0nY[o003o2_ooool00oooH@;oooooooooo`09
ooooo`03oomQ0_oooooooooo01Oooooo00?o003oooooooooool00oooool01Ol00?oooooooooooooo
oooo003o04Sooooo00?oof42ooooooooH@800oooool4o`3jVP04o`00ool0nY[o0?ZJo`3jVPSooooo
00?oof42ooooooooool00oooool00oooH@;oooooooooo`0;ooooo`03o`00oooooooooooo00;ooooo
00Ko003oooooool0nY[o0?ZJoomQ0_l0nYX4ooooo`;o003o1Oooool00oooH@;oooooooooo`03oooo
o`03oomQ0_oooooooooo00Kooooo00?o0000ooooooooool06oooool01_l0003ooooooooooooooooo
of42o`3jVP;ooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`02ooooo`09o`00ool0
nY[o0?ZJo`3jV_oooooo003ooomQ0_ooooooof4200?ooooo0ol0nYX8ooooo`03oomQ0_oooooooooo
00[ooooo00?oof42ooooooooool05_ooool00ol00?ooooooooooo`03ooooo`05o`00oooooooooooo
ooooool00?l0>?ooool00oooH@;oooooooooo`0;ooooo`06oomQ0_ooooooooooo`3jV_ooH@;o0?ZJ
0oooool01?l00?ooooooooooool00?l2o`3jVPCooooo00?oof42ooooooooool04?ooool00oooH@;o
ooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00Go003oooooool0nY[o0?ZJoomQ0P02o`3j
VP?ooooo0_l00?lCooooo`03o`000?oooooooooo017ooooo000Yooooo`06o`000?oooooooooooooo
ooooH@;o0?ZJ0oooool00oooH@;oooooooooo`0@ooooo`07oomQ0_ooooooooooooooool00?oooooo
o`00o`02ooooo`;o0?ZJ00Coof42ooooooooH@;ooooo0_l0nYX00ol00?ooooooooooo`08ooooo`03
oomQ0_oooooooooo00Sooooo00?oof42ooooooooool06?ooool00ol00?ooooooooooo`03ooooo`05
o`00ooooooooooooooooool00?l0B?ooool00oooH@;ooooooomQ0P02ooooo`Wo0?ZJ2Oooool01Ooo
H@;oooooooooooooooooof4200kooooo00?o003oooooooooool00_ooool01_l00?ooooooo`3jV_l0
nY[oof42o`3jVPCooooo00?o003oooooool00?l01Oooool01OooH@;oooooooooooooooooof4200Wo
oooo00?o0000ooooooooool06oooool01_l0003oooooooooooooooooof42o`3jVP;ooooo00?oof42
ooooooooool04Oooool01_ooH@;ooooooooooooooooo003oooooo`;o0?ZJ0_ooool01?l00?ooof42
ooooooooH@83ooooo`03o`00ool0nY[o0?ZJ00Sooooo00?oof42ooooooooool02Oooool00oooH@;o
ooooooooo`0Gooooo`03o`00oooooooooooo00?ooooo00Go003oooooooooooooooooo`00o`0hoooo
o`03oomQ0_oooooooooo00_ooooo00Goof42oooooooooooo0?ZJoomQ0P04ooooo`04o`00oooooooo
ooooo`00o`?o0?ZJ0oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Cooooo00?o
003oooooooooool00_ooool01Ol00?oo0?ZJo`3jV_l0nY[oof4200;o0?ZJ0oooool00ol00?oooooo
o`00o`0Booooo`03o`000?oooooooooo017ooooo000Yooooo`;o00000_ooool00oooH@;o0?ZJoooo
o`02ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool00_ooool00ol00?ooooooo`00
o`02ooooo`;o0?ZJ00Coof42ooooooooH@;ooooo0_l0nYX00ol00?ooooooooooo`09ooooo`03oomQ
0_oooooooooo00Oooooo00?oof42ooooooooool06?ooool00ol00?ooooooooooo`07ooooo`03o`00
oooooooooooo01;ooooo00?o003oooooooooool0<Oooool00oooH@;ooooooomQ0P02ooooo`;o0?ZJ
00?o003oooooool0nYX01Ol0nYX8ooooo`05oomQ0_ooooooooooooooooooH@803_ooool00ol00?oo
ooooooooo`02ooooo`06o`00oooooooo0?ZJo`3jV_ooH@;o0?ZJ1?ooool00ol00?ooooooo`00o`06
ooooo`?oof422Oooool2o`0001gooooo0_l00002ooooo`05oomQ0_l0nY[oooooooooooooH@804ooo
ool01_ooH@;ooooooooooooooooo003oooooo`;o0?ZJ0_ooool01?l00?ooof42ooooooooH@83oooo
o`03o`00ool0nY[o0?ZJ00Wooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Goooo
o`03o`00oooooooooooo00Oooooo00?o003oooooooooool04_ooool00ol00?ooooooooooo`0Qoooo
o`03oomQ0_oooooooooo00[ooooo0_ooH@82ooooo`03o`3jV_ooH@;ooooo00?ooooo00Go003ooooo
oooooooo003oooooo`02o`3jVP?ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`04
ooooo`03o`00oooooooooooo00;ooooo00Go003oo`3jV_l0nY[ooooooomQ0P03o`3jVP;ooooo00?o
003oooooool00?l04Oooool2o`0001?ooooo000Yooooo`06o`000?ooooooooooooooooooH@;o0?ZJ
0oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooool00?l0
0_ooool2o`3jVP04oomQ0_ooooooof42ooooo`;o0?ZJ00?o003oooooooooool02Oooool00oooH@;o
ooooooooo`06ooooo`03oomQ0_oooooooooo01Sooooo00?o003oooooooooool02?ooool00ol00?oo
ooooooooo`0Booooo`03o`00oooooooooooo02?ooooo00?o003oooooooooool02oooool01?ooH@;o
oooooomQ0_ooool3o`3jVP03o`00oooooooooooo00;o0?ZJ00?oooooo`3jV_l0nYX02?ooool01Ooo
H@;oooooooooooooooooof4200kooooo00?o003oooooooooool00_ooool01_l00?ooooooo`3jV_l0
nY[oof42o`3jVPCooooo00?o003oooooool00?l04oooool00ol0003oooooooooo`0Kooooo`06o`00
0?ooooooooooooooooooH@;o0?ZJ0_ooool00oooH@;oooooooooo`0Aooooo`06oomQ0_oooooooooo
ooooool00?oooooo0_l0nYX2ooooo`04o`00ooooH@;ooooooomQ0P?ooooo00Co003oo`3jV_l0nY[o
0?ZJ2?ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo01Kooooo00?o003ooooooooo
ool02?ooool00ol00?ooooooooooo`0Booooo`03o`00oooooooooooo02;ooooo00?oof42o`00oooo
ool02Oooool2oomQ0P;ooooo00?o0?ZJoomQ0_ooool00oooool01Ol00?ooooooooooool00?oooooo
00;o0?ZJ0oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Cooooo00?o003ooooo
ooooool00_ooool01_l00?oo0?ZJo`3jV_ooooooof42ooooo`;o0?ZJ0_ooool00ol00?ooooooo`00
o`0Booooo`03o`000?oooooooooo017ooooo000Yooooo`06o`000?ooooooooooooooooooH@;o0?ZJ
0oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00?ooooo00?o003oooooool00?l0
0_ooool2o`3jVP04oomQ0_ooooooof42ooooo`;o0?ZJ00?o003oooooooooool02Oooool00oooH@;o
ooooooooo`06ooooo`03oomQ0_oooooooooo01Sooooo00?o003oooooooooool02?ooool00ol00?oo
ooooooooo`0Booooo`03o`00oooooooooooo02?ooooo00?o003oooooooooool02oooool00oooH@;o
oooooomQ0P03o`3jVP05ooooool00?ooooooooooool00?l00_ooool2o`3jVPWooooo00Coof42oooo
ooooooooof423_ooool00ol00?ooooooooooo`02ooooo`05o`00oooooooo0?ZJo`3jV_ooH@800_l0
nYX3ooooo`03o`00oooooooo003o01?ooooo00?o0000ooooooooool06oooool01_l0003ooooooooo
ooooooooof42o`3jVP;ooooo00?oof42ooooooooool04Oooool01_ooH@;ooooooooooooooooo003o
ooooo`;o0?ZJ0_ooool01Ol00?ooof42ooooooooooooof4200;ooooo00Co003oooooool0nY[o0?ZJ
2?ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo01Oooooo00?o003oooooooooool0
2?ooool00ol00?ooooooooooo`0Booooo`03o`00oooooooooooo02;ooooo00?oof42o`00ooooool0
2Oooool01_ooH@;ooooooomQ0_ooooooof42o`3jVPCooooo00Go003ooooooooooooo003oooooo`02
o`3jVPCooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`05ooooo`03o`00oooooooo
oooo00;ooooo0ol0nYX2oomQ0P03ooooool0nY[o0?ZJ00;ooooo00?o003oooooool00?l04_ooool0
0ol0003oooooooooo`0Aooooo`00:Oooool01_l0003oooooooooooooooooof42o`3jVP?ooooo00?o
of42ooooooooool03_ooool00oooH@;oooooooooo`03ooooo`03o`00oooooooo003o00;ooooo0_l0
nYX01?ooH@;ooooooomQ0_ooool2o`3jVP03ooooool00?oooooo00Wooooo00?oof42ooooooooool0
1_ooool00oooH@;oooooooooo`0Hooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool0
4_ooool00ol00?ooooooooooo`0Rooooo`;o003o3Oooool00oooH@;ooooooomQ0P02o`3jVP;ooooo
00Co003ooooooooooooo003o0_ooool2o`3jVP[ooooo0_ooH@8?ooooo`03o`00oooooooooooo00;o
oooo00Go003oooooool0nY[o0?ZJoomQ0P02o`3jVP?ooooo00?o003oooooool00?l04oooool00ol0
003oooooooooo`0Kooooo`06o`000?ooooooooooooooooooH@;o0?ZJ0oooool00oooH@;ooooooooo
o`0@ooooo`05oomQ0_ooooooooooooooool00?l00ol0nYX01?oooooo003oooooooooH@82ooooo`05
oomQ0_ooooooooooooooool00?l00_l0nYX8ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooo
ooooool05oooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo01;ooooo00?o003ooooo
ooooool08_ooool00oooH@;o003oooooo`08ooooo`07oomQ0_oooooooooooomQ0_ooooooof42o`3j
VP04ooooo`05o`00ooooooooooooo`00ooooool00_l0nYX4ooooo`03oomQ0_oooooooooo00gooooo
00?oof42ooooooooool01Oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ00CooooooomQ0_l00?oo
of420ol0nYX01?oooooo003oooooool00?lBooooo`03o`000?oooooooooo017ooooo000Yooooo`;o
00000_ooool00oooH@;o0?ZJooooo`02ooooo`03oomQ0_oooooooooo00kooooo00?oof42oooooooo
ool00oooool00ol00?ooooooo`00o`02ooooo`;o0?ZJ00Coof42ooooooooH@;ooooo0ol0nYX00ooo
oooo003oooooo`09ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool06Oooool00ol0
0?ooooooooooo`08ooooo`03o`00oooooooooooo01;ooooo0_l00?lRooooo`03o`00oooooooo003o
00gooooo0_ooH@83o`3jVP;ooooo00?o003oooooool00?l00oooool2o`3jVP_ooooo00?oof42oooo
ooooool03Oooool00ol00?ooooooooooo`02ooooo`05o`00oooooooo0?ZJo`3jV_ooH@801?l0nYX0
1?l00?ooooooooooool00?lBooooo`;o00007Oooool2o`0000;ooooo00?oof42o`3jV_ooool00_oo
ool00oooH@;oooooooooo`0@ooooo`05oomQ0_ooooooooooooooool00?l00_l0nYX2ooooo`03o`00
ooooooooof4200;ooooo00?oof42ooooooooool00_ooool2o`3jVPWooooo00?oof42ooooooooool0
1Oooool00oooH@;oooooooooo`0Hooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool0
4_ooool2o`00ob;ooooo00?o003oooooooooH@802Oooool01oooH@;oooooooooooooH@;ooooooomQ
0_l0nYX01?ooool00ol00?ooooooo`00o`02ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`0=oooo
o`03oomQ0_oooooooooo00Gooooo00?o003oooooooooool00_ooool2o`3jVP05ooooooooH@;o003o
oomQ0_ooool00_l0nYX01?l00?ooooooooooool00?lAooooo`;o00004oooool001Kooooo0_l00004
ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`06o`000?ooooooooooooooooooH@;o0?ZJ
0oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00Cooooo00?o003oooooool00?l0
0_ooool2o`3jVP03oomQ0_ooooooof4200;ooooo0_l0nYX2ooooo`03o`00oooooooooooo00Oooooo
00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0Iooooo`03o`00oooooooooooo00Sooooo
00?o003oooooooooool04_ooool2o`00ob7ooooo00Co003ooooooooooooo003o3Oooool2oomQ0P;o
0?ZJ0oooool00ol00?ooooooo`00o`03ooooo`;o0?ZJ6oooool00ol00?ooooooooooo`03ooooo`?o
0?ZJ00?oof42o`3jV_l0nYX00ol0nYX2ooooo`03o`00oooooooooooo017ooooo00?o0000oooooooo
ool02?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00Ko0000oooooooo
oooooooooomQ0_l0nYX3ooooo`03oomQ0_oooooooooo013ooooo00Goof42ooooooooooooooooo`00
o`02o`3jVP;ooooo00?o003oooooooooH@800_ooool00oooH@;oooooooooo`02ooooo`;o0?ZJ2Ooo
ool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo01Sooooo00?o003oooooooooool02?oo
ool00ol00?ooooooooooo`0Booooo`;o003o8Oooool01?l00?ooooooooooooooH@88ooooo`08oomQ
0_ooooooooooooooooooH@;ooooooomQ0_l0nYX4ooooo`03o`00oooooooo003o00;ooooo0_l0nYX4
ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool01_ooool01?l00?oooooooooooooo
ool3o`3jVP05ooooooooH@;o003ooomQ0_ooool00_l0nYX01?l00?ooooooooooool00?lBooooo`03
o`000?oooooooooo017ooooo000Eooooo`04o`000?ooooooooooo`0000Oooooo00Go0000oooooooo
ooooooooo`000004ooooo`06o`000?ooooooooooooooooooH@;o0?ZJ0oooool00oooH@;ooooooooo
o`0=ooooo`03oomQ0_oooooooooo00Cooooo00Co003oooooool00?oooooo0ol0nYX00oooH@;ooooo
oomQ0P02ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00?ooooo
00?oof42ooooooooool06Oooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo01;ooooo
0_l00?lQooooo`04o`00ooooooooooooo`00o`gooooo0_ooH@82o`3jVP?ooooo00?o003oooooool0
0?l00oooool3o`3jVQWooooo00?o003oooooooooool01?ooool2o`3jVP03oomQ0_l00?ooof4200;o
oooo0_l0nYX2ooooo`03o`00oooooooooooo017ooooo00?o0000ooooooooool01oooool01?l0003o
ooooooooool00007ooooo`05o`000?ooooooooooooooool000001?ooool01_l0003ooooooooooooo
ooooof42o`3jVP?ooooo00?oof42ooooooooool04?ooool01OooH@;ooooooooooooooooo003o00;o
0?ZJ0_ooool00ol00?oooooooomQ0P02ooooo`03oomQ0_oooooooooo00;ooooo0ol0nYX8ooooo`03
oomQ0_oooooooooo00Gooooo00?oof42ooooooooool05oooool00ol00?ooooooooooo`09ooooo`03
o`00oooooooooooo01;ooooo0_l00?lQooooo`05o`00ooooooooooooo`00ooooH@801oooool02?oo
H@;oooooooooooooooooof42ooooooooH@;o0?ZJ1?ooool00ol00?ooooooo`00o`02ooooo`;o0?ZJ
1?ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Gooooo00?o003oooooooooool0
0_ooool2o`3jVP06o`00ooooooooof42o`00ooooH@;ooooo0_l0nYX01?l00?ooooooooooool00?lB
ooooo`03o`000?oooooooooo017ooooo000>ooooo`Go00000_ooool01?l0003oooooooooool0000;
ooooo`03o`000?oooooooooo00;ooooo00Ko0000oooooooooooooooooomQ0_l0nYX4ooooo`03oomQ
0_oooooooooo00cooooo00?oof42ooooooooool01?ooool00ol00?ooooooo`00o`03o`3jVP06oooo
ooooH@;oooooooooooooH@;ooooo0_l0nYX2ooooo`03o`00oooooooooooo00Sooooo00?oof42oooo
ooooool00_ooool00oooH@;oooooooooo`0Iooooo`03o`00oooooooooooo00Wooooo00?o003ooooo
ooooool04_ooool2o`00ob7ooooo00Co003ooooooooooooo003o3Oooool2oomQ0P;o0?ZJ1?ooool2
o`00o`?ooooo00?o003oo`3jV_l0nYX06Oooool00ol00?ooooooooooo`04ooooo`;o0?ZJ00?oof42
o`00ooooH@800_ooool2o`3jVP;ooooo00?o003oooooooooool04Oooool00ol0003oooooooooo`05
o`0000;ooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`06o`000?oo
ooooooooooooooooH@;o0?ZJ0oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00;o
oooo00?o003oo`3jV_l0nYX00_ooool00ol00?oooooooomQ0P02ooooo`03oomQ0_oooooooooo00?o
oooo0_l0nYX9ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool06?ooool00ol00?oo
ooooooooo`09ooooo`03o`00oooooooooooo01;ooooo0_l00?lQooooo`05o`00ooooooooooooo`00
ooooH@801_ooool00oooH@;oooooooooo`03ooooo`;oof4200?o0?ZJooooooooool00oooool2o`00
o`;ooooo0ol0nYX3ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01_ooool00ol0
0?ooooooooooo`02ooooo`;o0?ZJ00Ko003oooooooooH@;o003ooomQ0_ooool3o`3jVP;ooooo00?o
003oooooooooool04?ooool00ol0003oooooooooo`0Aooooo`005Oooool01?l0003oooooooooool0
000;ooooo`03o`000?oooooooooo00;ooooo0ol000000oooooooof42o`3jVP04ooooo`03oomQ0_oo
oooooooo00_ooooo00?oof42ooooooooool01Oooool00ol00?ooooooo`3jVP02o`3jVP03o`00oooo
ooooof4200;ooooo00Coof42ooooool0nY[o0?ZJ0_ooool00ol00?ooooooooooo`08ooooo`03oomQ
0_oooooooooo00;ooooo00?oof42ooooooooool06?ooool00ol00?ooooooooooo`0:ooooo`03o`00
oooooooooooo01;ooooo0_l00?lQooooo`04o`00ooooooooooooo`00o`gooooo0_ooH@82o`3jVPCo
oooo0_l00?l3ooooo`03o`00ool0nY[o0?ZJ01Kooooo00Co003ooooooooooooo003o1_ooool2o`3j
VP03oomQ0_l00?ooof4200;ooooo0_l0nYX3ooooo`03o`00oooooooooooo00kooooo0ol00009oooo
o`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool3o`000003ooooooooH@;o
0?ZJ00?ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`02ooooo`03o`00ool0nY[o
0?ZJ00;ooooo00?o003oooooooooH@800_ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ2Oooool0
0oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo01Oooooo00?o003oooooooooool02_ooool0
0ol00?ooooooooooo`0Booooo`;o003o8Oooool01Ol00?ooooooooooool00?ooof4200Kooooo00?o
of42ooooooooool00oooool2oomQ0P03o`3jV_oooooooooo00?ooooo0_l00?l3ooooo`;o0?ZJ0ooo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00?ooooo00Co003ooooooooooooo003o
0oooool3o`3jVP;o003o00?oof42o`00ooooH@800_ooool2o`3jVP?ooooo00?o003oooooooooool0
3_ooool2o`0001?ooooo000Eooooo`04o`000?ooooooooooo`0000Oooooo1?l00005ooooo`06o`00
0?ooooooooooooooooooH@;o0?ZJ1?ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo
00Gooooo00So003oooooool0nY[o0?ZJooooool00?oooooooomQ0P;ooooo00?oof42ooooool0nYX0
0_l0nYX00ooooooo003oooooo`09ooooo`03oomQ0_oooooooooo00;oof426oooool00ol00?oooooo
ooooo`0:ooooo`03o`00oooooooooooo017ooooo00Co003ooooooooooooo003o7oooool01Ol00?oo
oooooooooooooooo003o00kooooo00?oof42o`3jV_ooool01?ooool2o`00o`?ooooo00?o003oo`3j
V_l0nYX01oooool00ol00?ooooooooooo`0<ooooo`04o`00ooooooooooooo`00o`Kooooo0_l0nYX0
0oooH@;ooooooomQ0P02ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`0@ooooo`03o`000?oooooo
oooo00Oooooo00Co0000oooooooooooo00001oooool4o`0000Gooooo00Go0000oooooooooooooooo
oomQ0P02o`3jVP;ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`02ooooo`03o`00
ool0nY[o0?ZJ00;ooooo00?o003oooooooooH@800_ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ
2Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo01Sooooo00?o003oooooooooool0
2_ooool00ol00?ooooooooooo`0Aooooo`04o`00ooooooooooooo`00oaoooooo00Ko003ooooooooo
ooooooooo`00ooooool2oomQ0P?ooooo00?oof42ooooooooool01?ooool2oomQ0P03o`3jV_oooooo
oooo00?ooooo0_l00?l3ooooo`;o0?ZJ1?ooool01OooH@;ooooooooooooooooo003o00Sooooo00?o
of42ooooooooool00oooool01?l00?ooooooooooool00?l3ooooo`;o0?ZJ00Koooooo`00ool00?oo
of42ooooooooH@82ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`0?ooooo`03o`000?oooooooooo
017ooooo000Eooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01_ooool01_l0
003oooooooooooooooooof42o`3jVPCooooo00?oof42ooooooooool02oooool00oooH@;ooooooooo
o`05ooooo`05o`00oooooooo0?ZJo`3jV_l00?l00_ooool01?ooH@;oooooooooooooH@82ooooo`;o
0?ZJ00?oooooo`00ooooool02_ooool2oomQ0Qgooooo00?o003oooooooooool02_ooool00ol00?oo
ooooooooo`0Aooooo`04o`00ooooooooooooo`00oaoooooo00Go003oooooooooooooooooo`00o`0>
ooooo`03oomQ0_l0nY[ooooo00Cooooo0_l00?l4ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`0<
ooooo`;o003o00?oooooo`00ooooool01Oooool2o`3jVP03oomQ0_ooooooof4200;ooooo0_l0nYX3
ooooo`03o`00oooooooooooo013ooooo00?o0000ooooooooool01oooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo00Kooooo00Go0000oooooooooooooooooomQ0P02o`3jVP;ooooo
00?oof42ooooooooool03oooool00oooH@;oooooooooo`02ooooo`?o0?ZJ00Goooooo`00oooooooo
oooooomQ0P02ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX:ooooo`05oomQ0_oooooooooooooo
ooooH@806?ooool6o`3jVPWooooo00?o003oooooooooool04Oooool01?l00?ooooooooooool00?lO
ooooo`05o`00ooooooooooooooooool00?l00oooool00oooH@;ooooooomQ0P07ooooo`;oof4200?o
0?ZJooooooooool00oooool00oooH@;o003oooooo`02ooooo`;o0?ZJ1?ooool01OooH@;ooooooooo
oooooooo003o00Kooooo0_ooH@86ooooo`;o003o00?oooooo`00ooooool00_ooool2o`3jVP06oooo
ool00?oo003ooomQ0_ooooooof420_ooool2o`3jVP?ooooo00?o003oooooooooool03oooool00ol0
003oooooooooo`0Aooooo`005_ooool2o`0000Sooooo1Ol00004ooooo`06o`000?oooooooooooooo
ooooH@;o0?ZJ1?ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00Gooooo00Go003o
o`3jV_l0nY[o0?ZJo`00o`02ooooo`04oomQ0_oooooooooooomQ0P;ooooo0_l0nYX00ooooooo003o
ooooo`0Xooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool04Oooool01?l00?oooooo
ooooool00?lOooooo`05o`00ooooooooooooooooool00?l03_ooool00oooH@;o0?ZJooooo`04oooo
o`;o003o1?ooool2o`3jVPOooooo00?o003oooooooooool03?ooool2o`00o`03ooooool00?oooooo
00Gooooo0_l0nYX00oooH@;ooooooomQ0P02ooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`0@oooo
o`03o`000?oooooooooo00Sooooo0_l00008ooooo`Go00001?ooool01Ol0003ooooooooooooooooo
of4200;o0?ZJ0_ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX0
0ol00?ooooooo`00o`02ooooo`04oomQ0_oooooooooooomQ0PGooooo0_l0nYX:ooooo`Coof426?oo
ool8o`3jVPSooooo00?o003oooooooooool04Oooool01?l00?ooooooooooool00?lOooooo`05o`00
ooooooooooooooooool00?l01?ooool00oooH@;oooooooooo`06ooooo`;oof4200?o003ooooooooo
ool00oooool00oooH@;o003oooooo`02ooooo`;o0?ZJ1?ooool01OooH@;ooooooooooooooooo003o
00Gooooo00?oof42ooooooooool01_ooool2o`00o`04ooooool00?ooooooooooo`?o0?ZJ00Kooooo
o`00ool00?ooof42ooooooooH@82ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`0?ooooo`03o`00
0?oooooooooo017ooooo000Yooooo`;o00000_ooool00oooH@;o0?ZJo`3jVP03ooooo`03oomQ0_oo
oooooooo00_ooooo00?oof42ooooooooool01Oooool01Ol00?oo0?ZJo`3jV_oooooo003o00;ooooo
00Coof42ooooooooooooof420_ooool3o`3jVP03o`00oooooooooooo02Oooooo00?o003ooooooooo
ool03?ooool00ol00?ooooooooooo`0@ooooo`04o`00ooooooooooooo`00oaoooooo00Go003ooooo
ooooooooooooo`00o`0>ooooo`03oomQ0_l0nY[ooooo00Cooooo00?o003oooooooooool00oooool3
o`3jVPKooooo0_l00?l=ooooo`04o`00oooooooo003oo`00o`Gooooo0ol0nYX00oooH@;ooooooomQ
0P02ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oooooooooool03oooool2o`0001gooooo0_l0
0002ooooo`03oomQ0_l0nY[o0?ZJ00;ooooo00?oof42ooooooooool03oooool00oooH@;ooooooooo
o`02ooooo`;o0?ZJ00?o003oooooool00?l00_ooool01?ooH@;oooooooooooooH@85ooooo`?o0?ZJ
9?ooool3o`3jVP04o`00ooooooooooooooooo`?o0?ZJ2?ooool00ol00?ooooooooooo`0@ooooo`04
o`00ooooooooooooo`00oaoooooo00Go003oooooooooooooooooo`00o`0=ooooo`;oof4200?o003o
ooooooooool00_ooool2oomQ0PCooooo0_l0nYX5ooooo`03oomQ0_oooooooooo00;o003o0oooool0
0oooH@;oooooooooo`07ooooo`04o`00oooooooo003oo`00o`;ooooo0_l0nYX2ooooo`;o003o00?o
of42ooooooooH@800_ooool3o`3jVP;ooooo00?o003oooooooooool03_ooool2o`0001?ooooo000Y
ooooo`05o`000?ooooooooooooooooooH@800_l0nYX3ooooo`03oomQ0_oooooooooo00[ooooo00?o
of42ooooooooool01_ooool00ol00?oo0?ZJo`3jVP02o`00o`;ooooo00Coof42ooooooooooooof42
0oooool2o`3jVP03o`00oooooooooooo02Oooooo00?o003oooooooooool03?ooool00ol00?oooooo
ooooo`0@ooooo`04o`00ooooooooooooo`00oaoooooo00Go003oooooooooooooooooo`00o`0=oooo
o`?o00001Oooool00ol00?ooooooooooo`03ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_l00?l=oooo
o`04o`00oooooooo003oo`00o`;ooooo1Ol0nYX01?ooooooof42ooooooooH@82ooooo`03o`00ool0
nY[o0?ZJ00;ooooo00?o003oooooooooool04?ooool00ol0003oooooooooo`0Kooooo`05o`000?oo
ooooooooooooooooH@800_l0nYX2ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool0
0_ooool2o`3jVP03ooooool00?oo003o00;ooooo00Coof42ooooooooooooof421Oooool00ol00?oo
0?ZJo`3jVP0Sooooo`?o0?ZJ00?oooooo`00ooooool00oooool3o`3jVPOooooo00?o003ooooooooo
ool04?ooool01?l00?ooooooooooool00?lOooooo`05o`00ooooooooooooooooool00?l03Oooool3
o`0000?ooooo00Coof42ooooool00?ooof420oooool2o`3jVPGooooo00?oof42ooooooooool00_l0
0?l2ooooo`03oomQ0_oooooooooo00Sooooo00Go003oooooool00?oo003oooooo`03o`3jVP;ooooo
00Go003oooooooooH@;ooooooomQ0P02ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003ooooooooo
ool03oooool00ol0003oooooooooo`0Aooooo`00:Oooool01Ol0003oooooooooooooooooof4200;o
0?ZJ1?ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00Kooooo00?o003oo`3jV_l0
nYX00_l00?l2ooooo`04oomQ0_oooooooooooomQ0P?ooooo0_l0nYX00ooooooo003oooooo`0Voooo
o`03o`00oooooooooooo00gooooo00?o003oooooooooool04?ooool01Ol00?oooooooooooooooooo
003o01kooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`09ooooo`Go00001?ooool0
0ol00?ooooooooooo`03ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_l00?l=ooooo`04o`00oooooooo
ooooo`00o`Oo0?ZJ00CooooooomQ0_ooooooof420_ooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00
oooooooooooo013ooooo00?o0000ooooooooool06oooool01Ol0003oooooooooooooooooof4200;o
0?ZJ0_ooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX00ooooooo
003oo`00o`02ooooo`04oomQ0_oooooooooooomQ0PKooooo0_l0nYXRooooo`?o0?ZJ00?oooooo`00
ooooool01Oooool3o`3jVPKooooo00?o003oooooooooool04?ooool01Ol00?oooooooooooooooooo
003o01kooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`09ooooo`Go00000_ooool0
1?ooH@;oooooo`00ooooH@83ooooo`?o0?ZJ1?ooool00oooH@;oooooooooo`02o`00o`03oooooooo
H@;ooooo00[ooooo00Go003ooooooooooooo003oooooo`02o`3jVP?ooooo00Go003oooooooooH@;o
oooooomQ0P02ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oooooooooool03oooool00ol0003o
ooooooooo`0Aooooo`00:Oooool01Ol0003oooooooooooooooooof4200;o0?ZJ1?ooool00oooH@;o
ooooooooo`09ooooo`03oomQ0_oooooooooo00Kooooo0ol0nYX2o`00o`;ooooo00Coof42oooooooo
ooooof420oooool2o`3jVP03ooooool00?oooooo02Kooooo00?o003oooooooooool03Oooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00_ooooo00Go003oooooooooooooooooo`00o`0N
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool02Oooool5o`0000Cooooo00?o003o
ooooooooool00oooool00ol00?oo0?ZJo`3jVP06ooooo`;o003o3Oooool01?l00?oooooooooooooo
ool3o`3jVP;ooooo0_l0nYX01?ooooooof42ooooooooH@82ooooo`03o`00ool0nY[o0?ZJ00;ooooo
00?o003oooooooooool04?ooool00ol0003oooooooooo`0Kooooo`05o`000?oooooooooooooooooo
H@800_l0nYX3ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool00oooool2o`3jVP05
ooooool00?oo003oooooooooH@801?ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ8Oooool3o`3j
VP;ooooo00?o003oooooooooool01Oooool2o`3jVPKooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`0;ooooo`05o`00ooooooooooooooooool00?l07_ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00Wooooo1Ol00002ooooo`04oomQ0_oooooo003ooomQ0PCooooo0_l0
nYX4ooooo`03oomQ0_oooooooooo00;o003o00?ooooooomQ0_ooool02_ooool00ol00?oooooooooo
o`02ooooo`;o0?ZJ0oooool01Ol00?ooof42ooooooooooooof4200;ooooo00?o003oo`3jV_l0nYX0
0_ooool00ol00?ooooooooooo`0?ooooo`03o`000?oooooooooo017ooooo000Yooooo`;o00000_oo
ool00oooH@;o0?ZJo`3jVP04ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool01ooo
ool2o`3jVP03ooooool00?oo003o00;ooooo00Coof42ooooooooooooof420oooool3o`3jVP03o`00
oooooooooooo02Gooooo00?o003oooooooooool03Oooool01?l00?ooooooooooooooool2o`00o`go
oooo00Go003oooooooooooooooooo`00o`0Mooooo`03o`00oooooooooooo00?ooooo00?o003ooooo
ooooool02?ooool00ol00?oo0000o`000003o`0000[ooooo00?o003oo`3jV_l0nYX01_ooool2o`00
o`gooooo00?o003oooooooooool00ol0nYX6ooooo`03oomQ0_ooooooof4200;ooooo00?o003oo`3j
V_l0nYX00_ooool00ol00?ooooooooooo`0?ooooo`;o00007Oooool2o`0000;ooooo00?oof42o`3j
V_l0nYX00oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX01Ooo
oooo003oo`00ooooooooof4200Cooooo00?oof42ooooooooool00oooool2o`3jVR7ooooo0_l0nYX3
ooooo`03o`00oooooooooooo00Gooooo0ol0nYX5ooooo`04o`00ooooooooooooooooo`;o003o3Ooo
ool01Ol00?oooooooooooooooooo003o01gooooo00?o003oooooooooool00oooool00ol00?oooooo
ooooo`08ooooo`03o`00ool0003o000000?o000000?ooooooomQ0_ooool00oooool01?ooH@;ooooo
ooooooooool2o`3jVPGooooo00Goof42ooooool00?oo003ooomQ0P0<ooooo`04o`00oooooooooooo
ooooo`?o0?ZJ1?ooool01?ooH@;oooooooooooooH@82ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o
003oooooooooool03_ooool2o`0001?ooooo000Yooooo`05o`000?ooooooooooooooooooH@800_l0
nYX4ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool01oooool2o`3jVP03ooooool0
0?oooooo00;ooooo00Coof42ooooooooooooof421?ooool2o`3jVP03o`00oooooooooooo02Gooooo
00?o003oooooooooool03Oooool01_l00?ooooooooooool00?ooooooo`00o`gooooo00Go003ooooo
ooooooooooooo`00o`0Mooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool02?ooool0
0ol00?ooooooo`000002o`0000_ooooo00?o003oo`3jV_l0nYX01_ooool00ol00?ooooooo`00o`0<
ooooo`03o`00oooooooooooo00;o0?ZJ1oooool00oooH@;ooooooomQ0P02ooooo`03o`00ool0nY[o
0?ZJ00?ooooo00?o003oooooooooool03oooool00ol0003oooooooooo`0Kooooo`05o`000?oooooo
ooooooooooooH@800_l0nYX3ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool00_oo
ool3o`3jVP05ooooool00?ooooooooooooooH@801?ooool00oooH@;oooooooooo`03ooooo`?o0?ZJ
7oooool3o`3jVP?ooooo00?o003oooooooooool01_ooool2o`3jVPGooooo00Ko003ooooooooooooo
003oooooool00?l=ooooo`05o`00ooooooooooooooooool00?l07Oooool00ol00?ooooooooooo`03
ooooo`03o`00oooooooooooo00Sooooo00?o003oooooool000000_l00002ooooo`03oomQ0_oooooo
oooo00;ooooo00Coof42oooooooooooooooo0_l0nYX5ooooo`;oof4200?o003ooomQ0_l00?l03?oo
ool01?l00?ooooooooooooooool2o`3jVPGooooo00Coof42ooooooooooooof420_ooool00ol00?oo
0?ZJo`3jVP03ooooo`03o`00oooooooooooo00kooooo00?o0000ooooooooool04Oooool002Wooooo
00Go0000oooooooooooooooooomQ0P02o`3jVPGooooo00?oof42ooooooooool01_ooool00oooH@;o
ooooooooo`08ooooo`;o0?ZJ00?oooooo`00ooooool00_ooool01?ooH@;oooooooooooooH@84oooo
o`;o0?ZJ00?o003oooooooooool09?ooool00ol00?ooooooooooo`0>ooooo`03o`00oooooooo003o
00;ooooo00?o003oooooooooool02oooool01Ol00?oooooooooooooooooo003o01gooooo00?o003o
ooooooooool00oooool00ol00?ooooooooooo`08ooooo`04o`00ool0nY[o0?ZJoomQ0Pcooooo00Co
003oo`3jV_l0nY[o0?ZJ1Oooool00ol00?ooooooo`00o`0;ooooo`03o`00oooooooooooo00?o0?ZJ
1oooool00oooH@;ooooooomQ0P02ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oooooool00?l0
3oooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooooooooooH@800ol0nYX2ooooo`03
oomQ0_oooooooooo00gooooo00?oof42ooooooooool00_ooool2o`3jVP;ooooo00Co003ooooooooo
ooooof421?ooool00oooH@;oooooooooo`03ooooo`03o`00ool0nY[o0?ZJ01kooooo0ol0nYX3oooo
o`03o`00oooooooooooo00Oooooo0_l0nYX5ooooo`03o`00oooooooo003o00;ooooo00?o003ooooo
ooooool02oooool01Ol00?oooooooooooooooooo003o01gooooo00?o003oooooooooool00oooool0
0ol00?ooooooooooo`08ooooo`;o003o00?o0?ZJoomQ0_ooH@800_ooool00oooH@;oooooooooo`02
ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1oooool00oooH@;oooooo`00o`0;ooooo`03o`00oooo
oooooooo00;ooooo0_l0nYX5ooooo`04oomQ0_oooooooooooomQ0P;ooooo00Co003oo`3jV_l0nY[o
0?ZJ0_ooool00ol00?ooooooo`00o`0>ooooo`03o`000?oooooooooo017ooooo000Yooooo`05o`00
0?ooooooooooooooooooH@800_l0nYX5ooooo`03oomQ0_oooooooooo00Kooooo00?oof42oooooooo
ool01oooool3o`3jVP03ooooool00?oooooo00;ooooo00Coof42ooooooooooooof421?ooool2o`3j
VP03o`00oooooooooooo02Cooooo00?o003oooooooooool03_ooool2o`00o`Cooooo00?o003ooooo
ooooool02_ooool01Ol00?oooooooooooooooooo003o01gooooo00?o003oooooooooool00oooool0
0ol00?ooooooooooo`08ooooo`04o`00ool0nY[o0?ZJoomQ0Pcooooo00Co003oooooool0nY[o0?ZJ
1Oooool00ol00?ooooooo`00o`0;ooooo`03o`00oooooooooooo00;o0?ZJ2?ooool00oooH@;ooooo
oomQ0P02ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oooooool00?l03oooool00ol0003ooooo
ooooo`0Kooooo`06o`000?ooooooooooooooooooH@;o003o0_l0nYX2ooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool00_ooool2o`3jVP;ooooo00Co003oooooooooooooof421?ooool0
0oooH@;oooooooooo`03ooooo`03o`00ool0nY[o0?ZJ01kooooo0_l0nYX4ooooo`03o`00oooooooo
oooo00Oooooo0ol0nYX4ooooo`;o003o1?ooool00ol00?ooooooooooo`0:ooooo`05o`00oooooooo
ooooooooool00?l07Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Sooooo00?o
003oo`3jV_l0nYX00_ooH@800oooooooof42ooooo`04ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ
1oooool00ol00?ooooooo`00o`0;ooooo`04o`00ooooooooooooooooo`?o0?ZJ1Oooool01?ooH@;o
ooooooooooooH@82ooooo`04o`00oooooooo0?ZJo`3jVP;ooooo00?o003oooooool00?l03_ooool0
0ol0003oooooooooo`0Aooooo`00:Oooool2o`0000;ooooo00?oof42o`3jV_l0nYX01Oooool00ooo
H@;o003oooooo`06ooooo`03oomQ0_oooooooooo00Oooooo0_l0nYX2ooooo`05o`00oooooooooooo
ooooooooH@800_ooool00oooH@;oooooooooo`02ooooo`?o0?ZJ0oooool00ol00?ooooooooooo`0O
ooooo`03o`00oooooooooooo00oooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0:
ooooo`05o`00ooooooooooooooooool00?l07Oooool00ol00?ooooooooooo`03ooooo`03o`00oooo
oooooooo00Sooooo00Co003oo`3jV_l0nY[oof423?ooool01?l00?ooooooo`3jV_l0nYX5ooooo`03
o`00oooooooo003o00_ooooo00?o003oooooool0nYX00_l0nYX8ooooo`03oomQ0_ooooooof4200;o
oooo00Co003oo`3jV_l0nY[o0?ZJ0_ooool2o`00o`03ooooool00?oooooo00cooooo0_l0000Moooo
o`;o00000oooool00oooH@;o0?ZJo`3jVP02ooooo`04oomQ0_ooooooooooo`00o`cooooo00?oof42
ooooooooool00_ooool2o`3jVP;ooooo00Co003oooooooooooooof421?ooool00oooH@;ooooooooo
o`03ooooo`05o`00ool0nY[o0?ZJooooool00?l06oooool3o`3jVP?ooooo00?o003oooooooooool0
2Oooool2o`3jVPCooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0:ooooo`05o`00
ooooooooooooooooool00?l03oooool5o`3jVPWooooo00?o003oooooooooool00oooool00ol00?oo
ooooooooo`08ooooo`03o`00ool0nY[o0?ZJ00;oof4200?ooooooomQ0_ooool01Oooool00oooH@;o
ooooooooo`02o`3jVPOooooo00?o003oooooool00?l02oooool01?l00?ooooooooooooooool2o`3j
VPKooooo00Soof42oooooooooooo003ooomQ0_oooooo003oooooo`;o0?ZJ0_ooool2o`00o`03oooo
ool00?oooooo00_ooooo0_l0000Cooooo`00:Oooool01Ol0003oooooooooooooooooof4200;o0?ZJ
1Oooool00oooH@;o003oooooo`05ooooo`03oomQ0_oooooooooo00Sooooo0_l0nYX6ooooo`04oomQ
0_oooooooooooomQ0PGooooo0_l0nYX3ooooo`03o`00oooooooooooo01kooooo00?o003ooooooooo
ool05_ooool00ol00?ooooooooooo`0:ooooo`05o`00ooooooooooooooooool00?l04?ooool00ol0
0?ooooooooooo`0:ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool02?ooool01?l0
0?oo0?ZJo`3jV_ooH@8=ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oooooool00?l02oooool0
1?l00?ooooooo`3jV_l0nYX9ooooo`05oomQ0_ooooooof42ooooool00?l00_ooool2o`3jVP;ooooo
00Co003ooooooooooooo003o3_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00;o
oooo00?oof42o`3jV_l0nYX00_ooool01?ooH@;oooooo`00ool00?l;ooooo`03oomQ0_oooooooooo
00?ooooo0_l0nYX5ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool00oooool01Ol0
0?oo0?ZJo`3jV_oooooo003o01[ooooo0ol0nYX3ooooo`03o`00oooooooooooo00[ooooo0_l0nYX:
ooooo`03o`00oooooooooooo00[ooooo00Go003oooooooooooooooooo`00o`0>ooooo`Oo0?ZJ2?oo
ool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Sooooo00?o003oo`3jV_l0nYX00_oo
H@800oooooooof42ooooo`05ooooo`03oomQ0_oooooooooo00?o0?ZJ1_ooool00ol00?ooooooo`00
o`0;ooooo`04o`00ooooooooooooooooo`;o0?ZJ1_ooool01_ooH@;oooooooooool00?ooof42o`00
o`;ooooo0_l0nYX2ooooo`04o`00ooooooooooooo`00o`gooooo00?o0000ooooooooool04Oooool0
02Wooooo00Go0000oooooooooooooooooomQ0P03o`3jVP?ooooo00?o003oooooooooH@801_ooool0
0oooH@;oooooooooo`08ooooo`;o0?ZJ1_ooool01?ooH@;oooooooooooooH@85ooooo`;o0?ZJ0ooo
ool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo00[ooooo2Ol0nYXEooooo`03o`00oooo
oooooooo00[ooooo00Go003oooooooooooooooooo`00o`0@ooooo`03o`00oooooooooooo00[ooooo
00?o003oooooooooool00oooool00ol00?ooooooooooo`08ooooo`?o0?ZJ0_ooH@8<ooooo`03o`00
ool0nY[o0?ZJ00Cooooo00Go003oooooooooooooooooo`00o`0:ooooo`04o`00ool0nY[o0?ZJo`3j
VPWooooo00Goof42ooooooooH@;oooooo`00o`02ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`0;
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool00_ooool00oooH@;o0?ZJo`3jVP02
ooooo`04oomQ0_l00?ooooooo`00o`_ooooo00?oof42ooooooooool00_ooool3o`3jVPGooooo00?o
of42ooooooooool00_ooool00oooH@;oooooooooo`03ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0
3_ooool00ol00?ooooooooooo`08ooooo`?o0?ZJ0oooool00ol00?ooooooooooo`0;ooooo`?o0?ZJ
2Oooool00ol00?ooooooooooo`0:ooooo`05o`00ooooooooooooooooool00?l03Oooool3o`3jVP03
o`00oooooooooooo00?o0?ZJ1oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00So
oooo00?o003oo`3jV_l0nYX00_ooH@800oooooooof42ooooo`05ooooo`04oomQ0_oooooooooooooo
o`;o0?ZJ1Oooool01Ol00?oooooooooooooooooo003o00[ooooo00?o003oooooooooool00ol0nYX6
ooooo`06oomQ0_ooooooooooo`00ooooH@;o003o0_ooool3o`3jVPGooooo00?o003oooooooooool0
2_ooool00ol0003oooooooooo`0Aooooo`00:Oooool2o`0000;ooooo00Coof42ooooool0nY[o0?ZJ
0_ooool01?l00?ooooooooooooooH@85ooooo`03oomQ0_oooooooooo00Sooooo0ol0nYX6ooooo`04
oomQ0_oooooooooooomQ0PGooooo0_l0nYX3ooooo`03o`00oooooooooooo00cooooo00?o003ooooo
ooooool02Oooool=o`3jVQ;ooooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo00cooooo0_l00?l2ooooo`Oo0?ZJ0oooool00ol00?ooooooooooo`03oooo
o`03o`00oooooooooooo00Sooooo0_l0nYX00oooooooof42oomQ0P0<ooooo`03o`00ool0nY[o0?ZJ
00Cooooo00Go003oooooooooooooooooo`00o`0:ooooo`03o`00ool0nY[o0?ZJ00[ooooo00Goof42
ooooooooH@;oooooo`00o`02ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`0:ooooo`;o00007Ooo
ool2o`0000?ooooo00?oof42o`3jV_l0nYX00_ooool01?l00?ooof42ooooool00?l;ooooo`03oomQ
0_oooooooooo00;ooooo0_l0nYX6ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0
0oooool01Ol00?ooooooo`3jV_l0nY[o003o00kooooo00?o003oooooooooool02?ooool2o`3jVPCo
oooo00?o003oooooooooool03?ooool2o`3jVPWooooo00?o003oooooooooool02_ooool00ol00?oo
ooooooooo`02ooooo`03o`00oooooooooooo00Wooooo0ol0nYX2o`00o`?ooooo0ol0nYX6ooooo`03
o`00oooooooooooo00?ooooo00?o003oooooooooool02?ooool01_l00?oo0?ZJo`3jV_ooH@;ooooo
oomQ0POooooo00Coof42oooooooooooooooo0_l0nYX5ooooo`05o`00ooooooooooooooooool00?l0
2_ooool00ol00?ooooooooooo`02o`3jVPOooooo00Koof42oooooooooooo003ooomQ0_l00?l3oooo
o`;o0?ZJ1Oooool00ol00?ooooooooooo`09ooooo`;o00004oooool002Wooooo00Ko0000oooooooo
oooooooooomQ0_ooool2o`3jVP03ooooool00?oooooo00;ooooo00?oof42ooooooooool00oooool0
0oooH@;oooooooooo`08ooooo`;o0?ZJ1oooool01OooH@;oooooooooooooooooof4200Cooooo0_l0
nYX2ooooo`;o003o3_ooool00ol00?ooooooooooo`08ooooo`?o0?ZJ0oooool01?l00?oooooooooo
ooooool6o`3jVQ7ooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`02ooooo`03o`00
oooooooooooo00cooooo00?o003oooooool0nYX03Ol0nYX4ooooo`03o`00oooooooooooo00Sooooo
0_l0nYX00oooooooof42oomQ0P0<ooooo`03o`00ool0nY[o0?ZJ00Cooooo00Go003ooooooooooooo
ooooo`00o`09ooooo`Co0?ZJ2_ooool01OooH@;ooooooomQ0_oooooo003o00;ooooo0_l0nYX6oooo
o`03o`00oooooooooooo00_ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`02oooo
o`09oomQ0_l0nY[o0?ZJooooool00?oooooooomQ0_oooooo003o00_ooooo00?oof42ooooooooool0
0_ooool2o`3jVPKooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`03ooooo`05o`00
oooooooo0?ZJo`3jV_l00?l03_ooool00ol00?ooooooooooo`07ooooo`?o0?ZJ1?ooool00ol00?oo
ooooooooo`0<ooooo`;o0?ZJ2_ooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool02?ooool3o`3jVP04ooooool00?ooooooo`00o`?ooooo0ol0nYX5oooo
o`03o`00oooooooooooo00?ooooo00?o003oooooooooool02?ooool01_l00?oo0?ZJo`3jV_ooH@;o
oooooomQ0POooooo00Coof42oooooooooooooooo0_l0nYX5ooooo`05o`00ooooooooooooooooool0
0?l02_ooool00ol00?ooooooooooo`02o`3jVPOooooo00Koof42oooooooooooo003ooomQ0_l00?l3
ooooo`?o0?ZJ1?ooool00ol00?ooooooooooo`0:ooooo`03o`000?oooooooooo017ooooo000Roooo
o`;o00001Oooool00ol0003oooooooooo`02ooooo`04oomQ0_l0nY[o0?ZJo`00o`Cooooo00Co003o
oomQ0_oooooooooo0_ooH@8;ooooo`;o0?ZJ1oooool01OooH@;oooooooooooooooooof4200Cooooo
0ol0nYX00ooooooo003oo`00o`0=ooooo`03o`00oooooooo003o00Wooooo0_l0nYX4ooooo`03o`00
oooooooooooo00Cooooo1_l0nYX>ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool0
0_ooool00ol00?ooooooooooo`0<ooooo`Go0?ZJ1Oooool9o`3jVP03ooooool00?oooooo00Wooooo
0_l0nYX00oooooooof42oomQ0P0<ooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo00Go003ooooooooo
ooooooooo`00o`08ooooo`Co0?ZJ2oooool01OooH@;ooooooomQ0_oooooo003o00;ooooo0_l0nYX7
ooooo`03o`00oooooooooooo00[ooooo00?o0000ooooooooool05?ooool2o`0000Gooooo00?o0000
ooooooooool00_ooool01?ooH@;o0?ZJo`3jV_l00?l2ooooo`03oomQ0_oooooo003o00_ooooo00?o
of42ooooooooool00_ooool2o`3jVPKooooo00?oof42ooooooooool00_ooool00oooH@;ooooooooo
o`03ooooo`05o`00oooooooo0?ZJo`3jV_l00?l03Oooool00ol00?ooooooo`00o`08ooooo`;o0?ZJ
1Oooool00ol00?ooooooooooo`0<ooooo`?o0?ZJ2Oooool00ol00?ooooooooooo`09ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool01oooool3o`3jVP;ooooo00?o003oooooool00?l0
1?ooool3o`3jVPCooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`08ooooo`;o0?ZJ
00?oof42ooooooooool02?ooool01?ooH@;oooooooooooooool2o`3jVPGooooo00Go003ooooooooo
ooooooooo`00o`0:ooooo`03o`00oooooooo0?ZJ00;o0?ZJ1oooool01_ooH@;oooooooooool00?oo
of42o`00o`Cooooo0_l0nYX5ooooo`03o`00oooooooooooo00Wooooo00?o0000ooooooooool04Ooo
ool0027ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`02ooooo`03oomQ0_l0
nY[o0?ZJ00Gooooo00Co003ooomQ0_ooooooof423Oooool2o`3jVPOooooo00Goof42oooooooooooo
oooooomQ0P05ooooo`;o0?ZJ00Coooooo`00oooooooo003o3?ooool00ol00?ooooooo`00o`08oooo
o`?o0?ZJ1?ooool00ol00?ooooooooooo`06ooooo`Ko0?ZJ3?ooool00ol00?ooooooooooo`08oooo
o`03o`00oooooooooooo00?ooooo00?o003oooooooooool02oooool4o`3jVP_ooooo00?o003oo`3j
V_l0nYX01?l0nYX:ooooo`;o0?ZJ00?ooooooomQ0_ooH@803?ooool01?l00?ooooooo`3jV_l0nYX3
ooooo`05o`00ooooooooooooooooool00?l02?ooool2o`3jVP03o`00oooooooooooo00[ooooo00?o
of42ooooooooH@800_l00?l2ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`0:ooooo`03o`000?oo
oooooooo01?ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`02ooooo`03oomQ
0_l0nY[o0?ZJ00?ooooo00?oof42ooooool00?l02oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ
1_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00;ooooo00Ko003oooooool0nY[o
0?ZJooooool00?l<ooooo`03o`00oooooooo003o00Sooooo0_l0nYX5ooooo`03o`00oooooooooooo
00gooooo0_l0nYX9ooooo`03o`00oooooooooooo00Sooooo1Ol0nYX00ooooooo003oooooo`07oooo
o`?o0?ZJ0_ooool01?l00?ooooooooooool00?l5ooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`03
ooooo`03o`00oooooooooooo00Sooooo0_l0nYX00oooH@;oooooooooo`08ooooo`04oomQ0_oooooo
ooooooooo`;o0?ZJ1Oooool01Ol00?oooooooooooooooooo003o00[ooooo00Co003oooooool0nY[o
0?ZJ2?ooool01_ooH@;oooooooooooooooooof42o`00o`Cooooo0ol0nYX4ooooo`03o`00oooooooo
oooo00Wooooo00?o0000ooooooooool04Oooool0027ooooo00Co0000oooooooooooo00001?ooool3
o`0000;ooooo00?oof42o`3jV_l0nYX01Oooool00ol00?oooooooomQ0P0=ooooo`?o0?ZJ1oooool0
1OooH@;oooooooooooooooooof4200Gooooo0ol0nYX00ol00?ooooooo`00o`0<ooooo`03o`00oooo
oooo003o00Oooooo0ol0nYX5ooooo`03o`00oooooooooooo00Wooooo1_l0nYX9ooooo`03o`00oooo
oooooooo00Sooooo00?o003oooooooooool00ol0nYX00ol00?ooooooooooo`06ooooo`04o`00oooo
ooooooooooooo`?o0?ZJ00?oooooo`00ooooool02_ooool01?l00?ooooooooooooooool6o`3jVPKo
oooo0ol0nYX00oooH@;ooooooomQ0P0<ooooo`04o`00oooooooo0?ZJo`3jVP?ooooo00Go003ooooo
ooooooooooooo`00o`07ooooo`?o0?ZJ00?o003oooooooooool02Oooool01?ooH@;ooooooooooooo
H@82o`00o`;ooooo0ol0nYX6ooooo`03o`00oooooooooooo00Sooooo0ol0000Eooooo`04o`000?oo
ooooooooo`0000Cooooo0ol00002ooooo`03oomQ0_l0nY[o0?ZJ00?ooooo00?oof42ooooool00?l0
2oooool01?ooH@;oooooooooooooool3o`3jVPKooooo00?oof42ooooooooool00oooool00oooH@;o
ooooooooo`02ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00?o003oooooooooool02_ooool00ol00?oo
ooooo`00o`07ooooo`?o0?ZJ1Oooool00ol00?ooooooooooo`0=ooooo`;o0?ZJ2Oooool00ol00?oo
ooooooooo`07ooooo`So0?ZJ1_ooool4o`3jVP?ooooo00Co003ooooooooooooo003o1Oooool3o`3j
VP?ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`07ooooo`04o`00ool0nY[o0?ZJ
oomQ0P_ooooo00?oof42ooooooooool00_l0nYX5ooooo`05o`00ooooooooooooooooool00?l02_oo
ool01?l00?oo0?ZJo`3jV_l0nYX8ooooo`06oomQ0_ooooooooooooooooooH@;o003o1Oooool2o`3j
VPCooooo00?o003oooooooooool02?ooool2o`0001?ooooo000Qooooo`04o`000?ooooooooooo`00
00Cooooo00?o0000ooooooooool00_ooool00oooH@;o0?ZJo`3jVP05ooooo`03o`00oooooooooooo
00gooooo0_l0nYX00ol00?ooooooooooo`05ooooo`05oomQ0_ooooooooooooooooooH@801Oooool4
o`3jVP03ooooool00?oooooo00_ooooo00?o003oooooool00?l01oooool2o`3jVPKooooo00?o003o
ooooooooool02oooool5o`3jVPSooooo00?o003oooooooooool01Oooool01Ol00?ooooooooooool0
0?oooooo00Go0?ZJ2?ooool00ol00?ooooooooooo`03o`3jVP?ooooo00?o003oooooooooool02?oo
ool00ol00?ooooooooooo`03ooooo`co0?ZJ00CooooooomQ0_ooooooof423?ooool01?l00?oooooo
o`3jV_l0nYX3ooooo`05o`00ooooooooooooooooool00?l01_ooool3o`3jVP03ooooool00?oooooo
00[ooooo00Coof42ooooooooooooof420_l00?l3ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`0:
ooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`02ooooo`04oomQ0_l0nY[o0?ZJo`3jVP?ooooo00?oof42o`00ooooool02_ooool01?ooH@;ooooo
ooooooooool2o`3jVP03o`00oooooooooooo00Cooooo00?oof42ooooooooool00oooool00oooH@;o
ooooooooo`02ooooo`03o`00oooooooooooo00;o0?ZJ00?o003oooooooooool02_ooool00ol00?oo
ooooo`00o`07ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`0=ooooo`?o0?ZJ2?ooool00ol00?oo
ooooooooo`05ooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo3?l0nYX4ooooo`05o`00oooooooooooo
ooooool00?l01Oooool2o`3jVP?ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`07
ooooo`04o`00ool0nY[o0?ZJoomQ0P_ooooo00?oof42ooooooooool00_l0nYX5ooooo`05o`00oooo
ooooooooooooool00?l02_ooool00ol00?oo0?ZJo`3jVP08ooooo`03oomQ0_oooooooooo00;ooooo
00?oof42o`00ooooool01?ooool3o`3jVP?ooooo00?o003oooooooooool02Oooool00ol0003ooooo
ooooo`0Aooooo`008Oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo
00?oof42o`3jV_l0nYX01Oooool00ol00?ooooooooooo`0=ooooo`;o0?ZJ00?o003oooooooooool0
1Oooool01OooH@;oooooooooooooooooof4200Gooooo00?o003oooooool0nYX00_l0nYX00ol00?oo
ooooooooo`06ooooo`04o`00ooooooooooooo`00o`;ooooo00?o003oooooooooool01?ooool3o`3j
VPGooooo00?o003oooooooooool03oooool2o`3jVPSooooo00?o003oooooooooool01Oooool01?l0
0?ooooooooooool00?l3o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ1Oooool00ol00?ooooooo`3jVP02
o`3jVP05o`00ooooooooooooooooool00?l02Oooool00ol00?ooooooooooo`04ooooo`03o`00oooo
oooooooo00Wo0?ZJ00CooooooomQ0_ooooooof423?ooool01?l00?ooooooo`3jV_l0nYX3ooooo`05
o`00ooooooooooooooooool00?l01_ooool2o`3jVP;ooooo00?o003oooooooooool02Oooool01_oo
H@;oooooooooooooooooof42o`00o`?ooooo0_l0nYX6ooooo`03o`00oooooooooooo00[ooooo00?o
0000ooooooooool04oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo
00Coof42ooooool0nY[o0?ZJ0oooool00oooH@;o003oooooo`09ooooo`03oomQ0_oooooooooo00;o
oooo0_l0nYX00ol00?ooooooooooo`03ooooo`03oomQ0_oooooooooo00Cooooo00?oof42oooooooo
ool00_ooool00ol00?ooooooo`00o`02o`3jVP03o`00oooooooooooo00Kooooo00Co003ooooooooo
oooo003o0_ooool00ol00?ooooooooooo`04ooooo`?o0?ZJ1Oooool00ol00?ooooooooooo`0?oooo
o`;o0?ZJ2?ooool00ol00?ooooooooooo`05ooooo`?o0?ZJ00?o003oooooooooool00oooool8o`3j
VP03ooooool00?oooooo00?ooooo00Go003oooooooooooooooooo`00o`05ooooo`;o0?ZJ0_ooool0
0ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Oooooo00Co003oo`3jV_l0nY[oof422ooo
ool00oooH@;oooooooooo`03o`3jVPCooooo00Go003oooooooooooooooooo`00o`0:ooooo`?o0?ZJ
2?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_l00?oooooo00Gooooo1Ol0nYX00ol00?oooooo
ooooo`09ooooo`03o`000?oooooooooo017ooooo000Qooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool00_ooool00oooH@;o0?ZJo`3jVP06ooooo`03o`00oooooooooooo00cooooo
0_l0nYX00ol00?ooooooooooo`05ooooo`05oomQ0_ooooooooooooooooooH@801_ooool2o`00o`;o
0?ZJ00?o003oooooooooool01_ooool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooooooo
00;ooooo0ol0nYX6ooooo`03o`00oooooooooooo00oooooo0_l0nYX9ooooo`03o`00oooooooooooo
00Cooooo0_l00?l01?oooooo003oo`3jV_l0nYX3ooooo`go0?ZJ00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`07ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01oooool0
1_l00?ooooooooooooooH@;ooooooomQ0Pcooooo00Co003oooooool0nY[o0?ZJ0oooool01Ol00?oo
oooooooooooooooo003o00Gooooo0ol0nYX2ooooo`03o`00oooooooooooo00Wooooo00Goof42oooo
oooooooooooooomQ0P04ooooo`?o0?ZJ1Oooool00ol00?ooooooooooo`0:ooooo`03o`000?oooooo
oooo01?ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`02ooooo`04oomQ0_oo
oooo0?ZJo`3jVP?ooooo00?oof42ooooool00?l02Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ
00?o003oooooooooool00oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00?ooooo
0_l00?l2o`3jVP03o`00oooooooooooo00Kooooo00Co003ooooooooooooo003o0oooool00ol00?oo
ooooooooo`02ooooo`?o0?ZJ1_ooool00ol00?ooooooooooo`0?ooooo`;o0?ZJ2Oooool00ol00?oo
ooooooooo`03ooooo`?o0?ZJ00?oooooo`00ooooool01?ooool00ol00?ooooooooooo`06ooooo`05
o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`03ooooo`?o0?ZJ00?oooooo`00
ooooool01Oooool00ol00?ooooooooooo`07ooooo`04o`00ool0nY[o0?ZJoomQ0P_ooooo00Coof42
oooooooooooo003o0_l0nYX4ooooo`05o`00ooooooooooooooooool00?l02_ooool2o`3jVPWooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`06ooooo`[o0?ZJ1_ooool00ol0003ooooo
ooooo`0Aooooo`008_ooool2o`0000Gooooo0_l00003ooooo`03oomQ0_l0nY[o0?ZJ00Kooooo00?o
003oooooooooool03?ooool2o`3jVP03o`00oooooooooooo00Gooooo00Goof42oooooooooooooooo
oomQ0P06ooooo`;o003o0_l0nYX00ol00?ooooooooooo`06ooooo`;o003o00?oooooo`00ooooool0
0_ooool01?l00?ooooooooooooooool3o`3jVPOooooo00?o003oooooooooool03oooool3o`3jVPSo
oooo00?o003oooooooooool01?ooool2o`00o`04ooooool0nY[o0?ZJo`3jVP?ooooo00?o003ooooo
ooooool02Ol0nYX00ooooooo003oooooo`03ooooo`03o`00oooooooooooo00Oooooo00?o003ooooo
ooooool01?ooool00ol00?ooooooooooo`07ooooo`06o`00oooooooooooooomQ0_ooooooof423?oo
ool00ol00?ooooooo`3jVP02o`3jVP;ooooo00Go003oooooooooooooooooo`00o`05ooooo`;o0?ZJ
0oooool00ol00?ooooooooooo`09ooooo`05oomQ0_ooooooooooooooooooH@801Oooool2o`3jVPGo
oooo00?o003oooooooooool02Oooool2o`0001Kooooo0_l00005ooooo`;o00000oooool01?ooH@;o
ooooo`3jV_l0nYX3ooooo`03oomQ0_oooooo003o00Wooooo00?oof42ooooooooool00_ooool2o`3j
VP03o`00oooooooooooo00?ooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`03oooo
o`;o003o0_l0nYX00ol00?ooooooooooo`06ooooo`;o003o00?oooooo`00ooooool00_ooool00ol0
0?ooooooooooo`02ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`0?ooooo`?o0?ZJ2?ooool00ol0
0?ooooooooooo`03ooooo`;o0?ZJ00?o003oooooool00?l01Oooool00ol00?ooooooooooo`05oooo
o`;o003o0oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Cooooo0_l0nYX00ooo
oooo003oooooo`05ooooo`03o`00oooooooooooo00Oooooo00Co003oo`3jV_l0nY[oof422oooool0
1?ooH@;oooooooooool00?l2o`3jVPCooooo00Go003oooooooooooooooooo`00o`09ooooo`?o0?ZJ
2Oooool00oooH@;oooooooooo`02ooooo`03o`00ooooH@;ooooo00Wooooo2?l0nYX4ooooo`;o0000
4oooool002Wooooo00?o0000ooooooooool00_ooool01?ooH@;o0?ZJo`3jV_l0nYX5ooooo`03o`00
oooooooooooo00cooooo0_l0nYX00ol00?ooooooooooo`05ooooo`05oomQ0_oooooooooooooooooo
H@801_ooool2o`00o`;o0?ZJ00?o003oooooooooool01_ooool2o`00o`03ooooool00?oooooo00;o
oooo00Co003ooooooooooooooooo0_l0nYX8ooooo`03o`00oooooooooooo013ooooo0_l0nYX8oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooool0nYX00_l0nYX4ooooo`03o`00oooooooooooo
00Gooooo0_l00?l3ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool01oooool00ol0
0?ooooooooooo`04ooooo`03o`00oooooooooooo00Oooooo00Ko003oooooooooooooof42oooooooo
H@8<ooooo`03o`00oooooooooooo00;o0?ZJ0_ooool01Ol00?oooooooooooooooooo003o00Cooooo
0ol0nYX3ooooo`03o`00oooooooooooo00Wooooo00Goof42oooooooooooooooooomQ0P05ooooo`;o
0?ZJ1Oooool00ol00?ooooooooooo`0:ooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool00_ooool01?ooH@;oooooo`3jV_l0nYX3ooooo`03oomQ0_oooooo003o00Wooooo00?oof42oooo
ooooool00_ooool2o`3jVP03o`00oooooooooooo00?ooooo00?oof42ooooooooool01?ooool00ooo
H@;oooooooooo`03ooooo`;o003o0_l0nYX00ol00?ooooooooooo`06ooooo`;o003o00?oooooo`00
ooooool00_ooool01?l00?ooooooooooooooool3o`3jVPOooooo00?o003oooooooooool04?ooool2
o`3jVPSooooo00?o003oooooooooool00_ooool3o`3jVP03ooooool00?oo003o00Gooooo00?o003o
ooooooooool01Oooool2o`00o`?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`04
ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool00ol00?ooooooooooo`07ooooo`?o0?ZJ00?oof42
ooooooooool02Oooool01?ooH@;oooooooooool00?l2o`3jVPCooooo00Go003ooooooooooooooooo
o`00o`09ooooo`;o0?ZJ2_ooool00oooH@;oooooooooo`02ooooo`03o`00ooooH@;ooooo00[ooooo
00?o003oooooooooool00_ooool3o`3jVPCooooo00?o0000ooooooooool04Oooool002Wooooo00?o
0000ooooooooool00_ooool01?ooH@;oooooo`3jV_l0nYX5ooooo`03o`00oooooooooooo00_ooooo
0ol0nYX00ol00?ooooooooooo`05ooooo`05oomQ0_ooooooooooooooooooH@801_ooool2o`00o`?o
0?ZJ2?ooool2o`00o`03ooooool00?oooooo00;ooooo00?o003oooooooooool00ol0nYX8ooooo`03
o`00oooooooooooo013ooooo0_l0nYX8ooooo`03o`00oooooooooooo00Cooooo00Co003oo`3jV_l0
nY[o0?ZJ1Oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooo003o00;ooooo00?o003ooooo
ooooool00oooool3o`00o`Kooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`07oooo
o`06o`00oooooooooooooomQ0_ooooooof423Oooool01?l00?ooooooo`3jV_l0nYX2ooooo`03o`00
oooooooooooo00;ooooo00Co003ooooooooooooooooo0_l0nYX4ooooo`03o`00oooooooooooo00Wo
oooo00Goof42oooooooooooooooooomQ0P05ooooo`?o0?ZJ1?ooool00ol00?ooooooooooo`0:oooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool00_ooool01?ooH@;oooooo`3jV_l0nYX4
ooooo`03oomQ0_l00?oooooo00Sooooo00?oof42ooooooooool00_ooool2o`3jVP03o`00oooooooo
oooo00?ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`02ooooo`;o003o0ol0nYX8
ooooo`;o003o00?oooooo`00ooooool00_ooool01?l00?ooooooooooooooool2o`3jVPSooooo00?o
003oooooooooool04?ooool2o`3jVPSooooo00Co003ooooooooooooooooo0ol0nYX01?l00?oooooo
o`00ool00?l5ooooo`03o`00oooooooooooo00Gooooo00?o003oooooool00?l00_ooool00ol00?oo
ooooooooo`03ooooo`?o003o0oooool3o`3jVP03o`00oooooooooooo00Cooooo00?o003ooooooooo
ool01oooool2o`3jVP03ooooooooH@;ooooo00[ooooo00Coof42oooooooooooooooo0_l0nYX4oooo
o`03o`00oooooooooooo00;ooooo00?o003oooooooooool01_ooool2o`3jVP[ooooo00?oof42oooo
ooooool00_ooool00ol00?ooof42ooooo`0:ooooo`03o`00oooooooooooo00?ooooo0_l0nYX4oooo
o`03o`000?oooooooooo017ooooo000Yooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0
nY[o0?ZJ1Oooool00ol00?ooooooooooo`0;ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool00ooo
H@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Cooooo0_l00?l00ooooooo0?ZJo`3jVP07oooo
o`04o`00ooooooooooooo`00o`Gooooo00Go003oooooool0nY[o0?ZJo`00o`08ooooo`03o`00oooo
oooooooo013ooooo0_l0nYX8ooooo`03o`00oooooooooooo00Cooooo0ol0nYX00ol00?oooooooooo
o`03ooooo`03o`00oooooooooooo00Gooooo00?o003oooooool00?l00_ooool00ol00?oooooooooo
o`03ooooo`03o`00oooooooo003o00Kooooo00?o003oooooooooool01?ooool00ol00?oooooooooo
o`07ooooo`06o`00oooooooooooooomQ0_ooooooof423Oooool00ol00?ooooooo`3jVP02o`3jVP03
ooooool00?oooooo00?ooooo00Co003ooooooooooooooooo0_l0nYX4ooooo`03o`00oooooooooooo
00Wooooo00Goof42oooooooooooooooooomQ0P06ooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`0:
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool00_ooool01?ooH@;oooooo`3jV_l0
nYX4ooooo`03oomQ0_l00?oooooo00Sooooo00Coof42oooooooooooooooo0ol0nYX00ol00?oooooo
ooooo`03ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool00_ooool2o`00o`03oooo
ool0nY[o0?ZJ00Oooooo00Co003ooooooooooooo003o1Oooool00ol00?ooooooo`3jVP02o`3jVPSo
oooo00?o003oooooooooool04?ooool3o`3jVPOooooo00?o003oooooooooool00ol0nYX01Ooooooo
003ooooooooooooo003o00Gooooo00?o003oooooooooool01Oooool00ol00?ooooooo`00o`02oooo
o`03o`00oooooooooooo00?ooooo00?o003oooooool00?l01?ooool2o`3jVP03o`00oooooooooooo
00Cooooo00?o003oooooooooool01oooool2o`3jVP03ooooooooH@;ooooo00[ooooo00Coof42oooo
oooooooooooo0_l0nYX4ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool01Oooool3
o`3jVP[ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`09ooooo`03o`00oooooooo
oooo00?ooooo0ol0nYX3ooooo`03o`000?oooooooooo017ooooo000Yooooo`;o00000oooool01?oo
H@;oooooo`3jV_l0nYX5ooooo`03o`00oooooooooooo00_ooooo0_l0nYX00ooooooo003oooooo`05
ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01?ooool00ol00?ooooooooooo`02
o`3jVPOooooo00Co003ooooooooooooo003o1_ooool3o`3jVP03ooooool00?oooooo00Kooooo00?o
003oooooooooool04?ooool3o`3jVPSooooo00?o003oooooooooool00_ooool3o`3jVPOooooo00?o
003oooooooooool01Oooool00ol00?ooooooo`00o`02ooooo`03o`00oooooooooooo00Gooooo00?o
003oooooooooool01?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Oooooo00Co
003oooooooooooooof420_ooool00oooH@;oooooooooo`0:ooooo`03o`00oooooooooooo00;o0?ZJ
00?oooooo`00ooooool00oooool00ol00?ooooooooooo`03o`3jVPCooooo00?o003oooooooooool0
2Oooool01OooH@;oooooooooooooooooof4200Kooooo0_l0nYX4ooooo`03o`00oooooooooooo00Wo
oooo0_l0000Mooooo`;o00000oooool01?ooH@;oooooo`3jV_l0nYX4ooooo`03oomQ0_l00?oooooo
00Sooooo00Coof42oooooooooooooooo0_l0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooo
oooo00Kooooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`02o`3jVPOooooo00Co003o
oooooooooooo003o1_ooool01Ol00?oo0?ZJo`3jV_oooooo003o00Oooooo00?o003oooooooooool0
4Oooool2o`3jVPSooooo00Co003oo`3jV_l0nY[o0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooool00?l00_ooool00ol00?ooooooooooo`05ooooo`03
o`00oooooooooooo00;ooooo0ol0nYX6ooooo`03o`00oooooooooooo00Oooooo0_l0nYX00ooooooo
of42ooooo`0:ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo00Gooooo0_l0nYX00ol00?ooooooooooo`08ooooo`03oomQ0_oooooooooo
00?ooooo00?oof42ooooooooool02Oooool00ol00?ooooooooooo`04ooooo`?o0?ZJ00?oooooo`00
0?l000004oooool002Wooooo00?o0000ooooooooool00_ooool01?ooH@;oooooo`3jV_l0nYX5oooo
o`03o`00oooooooooooo00_ooooo0_l0nYX00ooooooo003oooooo`05ooooo`03oomQ0_oooooooooo
00;ooooo00?oof42ooooooooool01?ooool00ol00?ooooooooooo`02o`3jVP03o`00oooooooooooo
00Cooooo00?o003oooooooooool01oooool2o`3jVP;ooooo00?o003oooooooooool01Oooool00ol0
0?ooooooooooo`0Aooooo`;o0?ZJ2?ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ2Oooool00ol0
0?ooooooooooo`04ooooo`03o`00oooooooo003o00;ooooo00?o003oooooooooool01Oooool00ol0
0?ooooooooooo`04ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01oooool01?l0
0?ooooooooooooooH@82ooooo`03oomQ0_oooooooooo00[ooooo00?o003oooooooooool00_l0nYX0
0ooooooo003oooooo`03ooooo`03o`00oooooooooooo00;o0?ZJ1Oooool00ol00?ooooooooooo`09
ooooo`05oomQ0_ooooooooooooooooooH@801_ooool3o`3jVP?ooooo00?o003oooooooooool02_oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ
1?ooool00oooH@;o003oooooo`08ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ00?oooooo`00oooo
ool00oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00;ooooo00?o003ooooooooo
ool00_l0nYX00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Sooooo0_l0nYX00ooooooo
003oooooo`06ooooo`03o`00oooooooooooo017ooooo0_l0nYX8ooooo`?o0?ZJ0oooool00ol00?oo
ooooooooo`07ooooo`03o`00oooooooooooo00Cooooo00?o003oooooool00?l00_ooool00ol00?oo
ooooooooo`05ooooo`03o`00oooooooooooo00?ooooo0_l0nYX6ooooo`03o`00oooooooooooo00Oo
oooo0_l0nYX00oooooooof42ooooo`0:ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1?ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00Gooooo0_l0nYX00ol00?ooooooooooo`08oooo
o`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool02?ooool00ol00?ooooooooooo`05oooo
o`;o0?ZJ0_ooool00ol0003oooooooooo`0Aooooo`00:Oooool00ol0003oooooooooo`02ooooo`04
oomQ0_oooooo0?ZJo`3jVPGooooo00?o003oooooooooool02oooool2o`3jVP03ooooool00?oooooo
00Gooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`04ooooo`03o`00oooooooooooo
00;o0?ZJ00?o003oooooooooool01?ooool00ol00?ooooooooooo`06ooooo`?o0?ZJ0_ooool00ol0
0?ooooooooooo`05ooooo`03o`00oooooooooooo017ooooo0_l0nYX8ooooo`04o`00oooooooooooo
ooooo`?o0?ZJ2Oooool00ol00?ooooooooooo`03ooooo`06o`00ooooooooooooo`00oooooooo003o
2?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool0
1oooool01?l00?ooooooooooooooH@82ooooo`03oomQ0_oooooooooo00[ooooo00?o003ooooooooo
ool00_l0nYX00ooooooo003oooooo`03ooooo`03o`00oooooooooooo00;o0?ZJ1?ooool00ol00?oo
ooooooooo`0:ooooo`05oomQ0_ooooooooooooooooooH@801oooool2o`3jVPCooooo00?o003ooooo
ooooool01Oooool2o`3jVP;ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`02oooo
o`04oomQ0_oooooo0?ZJo`3jVPGooooo00?oof42ooooooooool01oooool01?ooH@;ooooooooooooo
ool2o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool01_ooool00oooH@;ooooooooo
o`02ooooo`03o`00oooooooooooo00;o0?ZJ00?o003oooooooooool01?ooool00ol00?oooooooooo
o`07ooooo`?o0?ZJ00?oooooo`00ooooool01_ooool00ol00?ooooooooooo`0Aooooo`?o0?ZJ1ooo
ool2o`3jVP?ooooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`03ooooo`06o`00oooo
ooooooooo`00oooooooo003o2?ooool00ol00?ooooooooooo`03ooooo`?o0?ZJ1Oooool00ol00?oo
ooooooooo`07ooooo`;o0?ZJ00?ooooooomQ0_ooool02_ooool01?ooH@;oooooooooooooool2o`3j
VPCooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`04ooooo`?o0?ZJ2_ooool00ooo
H@;oooooooooo`05ooooo`03oomQ0_oooooooooo00Wooooo00?o003oooooooooool01?ooool3o`3j
VP03ooooool0003ooooo01;ooooo000Yooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0
nY[o0?ZJ1Oooool00ol00?ooooooooooo`0;ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool00ooo
H@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Kooooo0_l0nYX01?l00?ooooooo`00ool00?l3
ooooo`03o`00oooooooooooo00Kooooo0_l0nYX4ooooo`03o`00oooooooooooo00Cooooo00?o003o
ooooooooool04Oooool3o`3jVPOooooo00?o003oooooooooool00ol0nYX:ooooo`03o`00oooooooo
oooo00?ooooo00Ko003ooooooooooooo003oooooool00?l9ooooo`03o`00oooooooooooo00?ooooo
00?o003oooooooooool01?ooool00ol00?ooooooooooo`07ooooo`04o`00oooooooooooooomQ0P;o
oooo00?oof42ooooooooool02_ooool00ol00?ooooooooooo`03o`3jVP03o`00oooooooooooo00;o
oooo00?o003oooooool0nYX00_l0nYX4ooooo`03o`00oooooooooooo00[ooooo00Goof42oooooooo
oooooooooomQ0P07ooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`?o0?ZJ0_ooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ1Oooool0
0oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX00ooooooo003oooooo`03
ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01Oooool2o`3jVP04o`00oooooooo
003oo`00o`?ooooo00?o003oooooooooool01oooool2o`3jVP?ooooo00?o003oooooooooool01?oo
ool00ol00?ooooooooooo`0Booooo`?o0?ZJ1Oooool3o`3jVP?ooooo00?o003oooooooooool02?oo
ool00ol00?ooooooooooo`03ooooo`06o`00ooooooooooooo`00oooooooo003o2Oooool00ol00?oo
ooooooooo`03ooooo`;o0?ZJ1Oooool00ol00?ooooooooooo`06ooooo`?o0?ZJ00?ooooooomQ0_oo
ool02oooool00oooH@;oooooooooo`03o`3jVP?ooooo00?o003oooooooooool00_ooool00ol00?oo
ooooooooo`03ooooo`?o0?ZJ00?o003oooooooooool02?ooool00oooH@;oooooooooo`05ooooo`03
oomQ0_oooooooooo00Wooooo00?o003oooooooooool01Oooool2o`3jVP03ooooool0003ooooo01;o
oooo000Yooooo`;o00000oooool01?ooH@;oooooo`3jV_l0nYX5ooooo`03o`00oooooooooooo00_o
oooo0_l0nYX00ooooooo003oooooo`05ooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooooooo
ool01_ooool2o`3jVP;o003o00?oooooo`00ooooool00_ooool00ol00?ooooooooooo`05ooooo`?o
0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo01;ooooo0ol0nYX6ooooo`03
o`00oooooooo0?ZJ00;o0?ZJ00?o003oooooooooool02?ooool00ol00?ooooooooooo`03ooooo`06
o`00ooooooooooooo`00oooooooo003o2Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo
oooo00Gooooo00?o003oooooooooool01_ooool01?l00?ooooooooooooooH@82ooooo`03oomQ0_oo
oooooooo00[ooooo00Co003ooooooooooooooooo0_l0nYX00ol00?ooooooooooo`02ooooo`04o`00
oooooooo0?ZJo`3jVPGooooo00?o003oooooooooool02_ooool01OooH@;oooooooooooooooooof42
00Oooooo0ol0nYX3ooooo`03o`00oooooooooooo00?ooooo0ol0nYX01?l00?ooooooo`000?l0000M
ooooo`;o00000oooool00oooH@;oooooo`3jVP02o`3jVPCooooo00?oof42ooooooooool01_ooool0
0oooH@;oooooooooo`02ooooo`;o0?ZJ00?oooooo`00ooooool00oooool00oooH@;oooooooooo`07
ooooo`03oomQ0_oooooooooo00Cooooo0_l0nYX2o`00o`03ooooool00?oooooo00;ooooo00?o003o
ooooooooool01oooool2o`3jVP?ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0C
ooooo`?o0?ZJ0_ooool4o`3jVPCooooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`03
ooooo`06o`00ooooooooooooo`00oooooooo003o2Oooool00ol00?ooooooooooo`03ooooo`?o0?ZJ
1Oooool00ol00?ooooooooooo`05ooooo`;o0?ZJ0_ooool00oooH@;oooooooooo`0:ooooo`04oomQ
0_ooooooooooo`00o`;o0?ZJ0oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?o
oooo0_l0nYX00ooooooo003oooooo`09ooooo`03oomQ0_oooooooooo00Gooooo00?oof42oooooooo
ool02Oooool00ol00?ooooooooooo`06ooooo`03o`00ool0003o000001?ooooo000Yooooo`03o`00
0?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ1Oooool00ol00?ooooooooooo`0;ooooo`;o
0?ZJ00?oooooo`00ooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Ko
oooo0ol0nYX2ooooo`05o`00ooooooooooooooooool00?l01oooool2o`3jVPGooooo00?o003ooooo
ooooool01?ooool00ol00?ooooooooooo`0Cooooo`?o0?ZJ1_ooool3o`3jVP03ooooool00?oooooo
00Wooooo00?o003oooooooooool00oooool01_l00?ooooooooooool00?ooooooo`00o`Wooooo00?o
003oooooooooool00oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Kooooo00Co
003oooooooooooooof420_ooool2oomQ0PSooooo00Coof42oooooooooooo003o0oooool2o`3jVP03
o`00oooooooooooo00;ooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool00ol00?ooooooooooo`0:oooo
o`05oomQ0_ooooooooooooooooooH@802?ooool2o`3jVP?ooooo00?o003oooooooooool00_ooool3
o`3jVP05ooooool00?ooooooooooool000007Oooool00ol0003oooooooooo`02ooooo`03oomQ0_oo
oooooooo00;o0?ZJ1?ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00;ooooo0_l0
nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool01?oo
ool3o`3jVP;ooooo00Go003oooooooooooooooooo`00o`08ooooo`?o0?ZJ0oooool00ol00?oooooo
ooooo`04ooooo`03o`00oooooooooooo01Cooooo1ol0nYX00ooooooo003oooooo`02ooooo`03o`00
oooooooooooo00Sooooo00?o003oooooooooool00oooool01_l00?ooooooooooool00?ooooooo`00
o`Wooooo00?o003oooooooooool00oooool00ol00?oo0?ZJo`3jVP05ooooo`03o`00oooooooooooo
00Gooooo0_l0nYX2ooooo`03oomQ0_oooooooooo00[ooooo00Coof42oooooooooooo003o0_l0nYX3
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool3o`3jVP03ooooool00?oo
oooo00Wooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`09ooooo`03o`00oooooooo
oooo00Kooooo00?o003oooooool000004oooool002Wooooo00?o0000ooooooooool00_ooool01?oo
H@;oooooo`3jV_l0nYX5ooooo`03o`00oooooooooooo00[ooooo0ol0nYX00ooooooo003oooooo`05
ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool01oooool2o`3jVP;ooooo00Go003o
ooooooooooooooooo`00o`06ooooo`?o0?ZJ1_ooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo01Gooooo0_l0nYX5ooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`08ooooo`03o`00oooo
oooooooo00?ooooo00Ko003ooooooooooooo003oooooool00?l9ooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`06ooooo`04o`00oooooooooooooomQ
0PCooooo00?oof42ooooooooool01Oooool01?ooH@;oooooooooool00?l3ooooo`?o0?ZJ1?ooool0
0ol00?oo0?ZJo`3jVP06ooooo`03o`00oooooooooooo00[ooooo00Goof42oooooooooooooooooomQ
0P08ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ00?oooooo`00ooooool00_oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00;ooooo00?oof42ooooooooool00_l0
nYX4ooooo`03o`00ooooH@;ooooo00Kooooo00?oof42ooooooooool00_ooool2o`3jVP03ooooool0
0?oooooo00;ooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`05ooooo`;o0?ZJ0_oo
ool01Ol00?oooooooooooooooooo003o00Oooooo0ol0nYX5ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool05_ooool4o`3jVP?ooooo00Go003oooooooooooooooooo`00o`0:ooooo`03
o`00oooooooooooo00?ooooo00Ko003ooooooooooooo003oooooool00?l9ooooo`03o`00oooooooo
oooo00?ooooo00?o003oo`3jV_l0nYX01Oooool00ol00?ooooooooooo`05ooooo`;o0?ZJ0_ooool0
0oooH@;oooooooooo`0:ooooo`04oomQ0_ooooooooooo`00o`;o0?ZJ0oooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo0_l0nYX2ooooo`03o`00oooooooooooo00Sooooo00?o
of42ooooooooool01_ooool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00Gooooo00Co
003ooooooooooooo00004oooool002Wooooo00?o0000ooooooooool00_ooool00oooH@;oooooo`3j
VP02o`3jVPCooooo00?o003oooooooooool02_ooool2o`3jVP;ooooo00?o003oooooooooool01?oo
ool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Oooooo0_l0nYX2ooooo`04o`00oooo
ooooooooo`00o`Oooooo0_l0nYX7ooooo`?o003o0_ooool00ol00?ooooooooooo`0Eooooo`?o0?ZJ
0oooool3o`3jVP?ooooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`03ooooo`04o`00
ooooooooooooooooo`;o003o2Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Go
oooo00?o003oooooooooool01_ooool01?l00?ooooooooooooooH@85ooooo`;oof421?ooool2oomQ
0P;ooooo00?o003oooooooooool00_ooool2o`3jVPCooooo00?o003oo`3jV_l0nYX01_ooool00ol0
0?ooooooooooo`0:ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01Oooool3o`3j
VP;ooooo00Co003ooooooooooooooooo0ol0nYX00ooooooo003oooooo`02ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool00oooool01?ooH@;oooooo`3jV_l0nYX4ooooo`03o`00oooo
H@;ooooo00Kooooo00?oof42ooooooooool00_ooool2o`3jVP03ooooool00?oooooo00;ooooo00?o
of42ooooooooool02Oooool00oooH@;oooooooooo`04ooooo`;o0?ZJ0_ooool01?l00?oooooooooo
ool00?l8ooooo`;o0?ZJ1_ooool3o`00o`;ooooo00?o003oooooooooool05oooool2o`3jVPCooooo
00Go003oooooooooooooooooo`00o`0:ooooo`03o`00oooooooooooo00?ooooo00Co003ooooooooo
oooooooo0_l00?l9ooooo`03o`00oooooooooooo00?ooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool0
0ol00?ooooooooooo`05ooooo`;o0?ZJ0_ooool00oooH@;oooooooooo`0:ooooo`04oomQ0_oooooo
ooooo`00o`;o0?ZJ0oooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooooooo`?o0?ZJ
0_ooool00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0
2?ooool00ol00?ooooooooooo`05ooooo`04o`00ooooooooooooo`0001?ooooo000Yooooo`;o0000
0oooool00oooH@;oooooooooo`02o`3jVPCooooo00?o003oooooooooool02_ooool2o`3jVP;ooooo
00?o003oooooooooool01?ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Oooooo
0_l0nYX3ooooo`03o`00oooooooo003o00Kooooo0ol0nYX9ooooo`04o`00ooooooooooooo`00oaSo
oooo1ol0nYX01Ol00?oooooooooooooooooo003o00[ooooo00?o003oooooooooool00oooool01?l0
0?ooooooooooooooool2o`00o`Wooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`05
ooooo`03o`00oooooooooooo00Kooooo00Co003oooooooooooooof421oooool2oomQ0P;ooooo0_oo
H@82ooooo`03o`00oooooooooooo00;ooooo0_l0nYX4ooooo`?o0?ZJ1_ooool00ol00?oooooooooo
o`0:ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01_ooool3o`3jVP03ooooool0
0?oooooo00Co0?ZJ0_ooool00ol00?ooooooooooo`02o`0001gooooo0_l00004ooooo`04oomQ0_oo
oooo0?ZJo`3jVPCooooo00?o003ooomQ0_ooool01_ooool01?ooH@;oooooooooooooool3o`3jVP03
ooooool00?oooooo00;ooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`04ooooo`;o
0?ZJ0oooool00ol00?ooooooo`00o`07ooooo`?o0?ZJ2?ooool01?l00?ooooooooooool00?lOoooo
o`05o`00ooooooooooooooooool00?l02_ooool00ol00?ooooooooooo`03ooooo`04o`00oooooooo
ooooooooo`;o003o2Oooool00ol00?ooooooooooo`03ooooo`04o`00oooooooo0?ZJo`3jVPCooooo
00?o003oooooooooool01Oooool2o`3jVP03ooooooooH@;ooooo00cooooo00Coof42oooooooooooo
003o0_l0nYX3ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooooooo0_l0nYX3oooo
o`03o`00oooooooooooo00Oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`08oooo
o`03o`00oooooooooooo00Gooooo00Co003oooooool0003o00004oooool002Wooooo00?o0000oooo
ooooool00_ooool00oooH@;oooooooooo`02o`3jVPCooooo00?o003oooooooooool02_ooool2o`3j
VP;ooooo00?o003oooooooooool01?ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo
00Oooooo0_l0nYX3ooooo`03o`00oooooooo003o00Kooooo0_l0nYX;ooooo`03o`00oooooooo003o
01Wooooo1Ol0nYX00ooooooo003oooooo`02ooooo`03o`00oooooooooooo00Sooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Sooooo00?o003ooooo
ooooool00oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Kooooo00Co003ooooo
ooooooooof422Oooool01OooH@;ooooooomQ0_ooooooof4200;ooooo00Co003ooooooooooooooooo
0ol0nYX3ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`0:ooooo`03oomQ0_oooooooooo00?ooooo
00?oof42ooooooooool01_ooool8o`3jVP?ooooo00Go003oooooooooooooooooo`00000Mooooo`03
o`000?oooooooooo00?ooooo00Coof42ooooool0nY[o0?ZJ1?ooool00ol00?oooooooomQ0P05oooo
o`03oomQ0_oooooooooo00;ooooo0_l0nYX2ooooo`05o`00ooooooooooooooooooooH@802oooool0
0oooH@;oooooooooo`04ooooo`;o0?ZJ0oooool00ol00?ooooooo`00o`07ooooo`;o0?ZJ2_ooool0
0ol00?ooooooo`00o`0Oooooo`05o`00ooooooooooooooooool00?l02_ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool02?ooool00ol00?oooooooooo
o`03ooooo`04o`00oooooooo0?ZJo`3jVPCooooo00?o003oooooooooool01?ooool3o`3jVP03oooo
ooooH@;ooooo00cooooo00Coof42oooooooooooooooo0ol0nYX2ooooo`03o`00oooooooooooo00;o
oooo00Co003ooooooooooooooooo0_l0nYX3ooooo`03o`00oooooooooooo00Oooooo00?oof42oooo
ooooool01oooool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00Gooooo00Co003ooooo
oooooooo00004oooool001Kooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00005oooo
o`03o`000?oooooooooo00;ooooo00?oof42ooooooooool00_l0nYX4ooooo`03o`00oooooooooooo
00[ooooo0_l0nYX00ooooooo003oooooo`06ooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooo
ooooool01oooool3o`3jVP;ooooo00?o003oooooool00?l01_ooool2o`3jVPcooooo0_l00?lOoooo
o`05o`00ooooooooooooooooool00?l02_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo
oooo00;ooooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo
oooo00Gooooo00?o003oooooooooool01_ooool01?l00?ooooooooooooooH@8:ooooo`04oomQ0_oo
oooooooooomQ0P;ooooo00?o003oooooooooool00_ooool2o`3jVP?ooooo0_l0nYX7ooooo`03o`00
oooooooooooo00[ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`07ooooo`Go0?ZJ
1?ooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo00Sooooo0_l00004ooooo`03o`00
0?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo00?ooooo00Coof42ooooool0nY[o
0?ZJ1?ooool00ol00?oooooooomQ0P05ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX00ooooooo
003oooooo`03ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool01?ooool3o`3jVP;o
oooo00?o003oooooool00?l01_ooool3o`3jVP_ooooo0_l00?lOooooo`05o`00oooooooooooooooo
ool00?l02_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool02?ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo0?ZJ00;o0?ZJ0oooool00ol0
0?ooooooooooo`04ooooo`;o0?ZJ00?o003oooooooooH@803Oooool01OooH@;ooooooooooooooooo
003o00;o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?o0?ZJ0oooool0
0ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool02?ooool0
0ol00?ooooooooooo`04ooooo`05o`00ooooooooooooooooool000004oooool001Gooooo00Co0000
oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
0_ooool00oooH@;oooooooooo`02o`3jVPCooooo00?o003oooooooooool02Oooool3o`3jVP03oooo
ool00?oooooo00Kooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`08ooooo`;o0?ZJ
0_ooool00ol00?ooooooo`00o`05ooooo`?o0?ZJ3Oooool00ol00?ooooooooooo`0Nooooo`04o`00
ooooooooooooo`00o`_ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo
00Sooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo
00Kooooo00Co003oooooooooooooof423Oooool01?ooH@;oooooooooool00?l3ooooo`03o`00ool0
nY[o0?ZJ00;ooooo0ol0nYX7ooooo`03o`00oooooooooooo00[ooooo00?oof42ooooooooool01?oo
ool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_oo
ool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo00?ooooo00Coof42ooooool0nY[o0?ZJ1?ooool01?l0
0?ooooooooooooooH@84ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX00ooooooo003oooooo`03
ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool01?ooool2o`3jVP;ooooo00?o003o
ooooool00?l01_ooool2o`3jVPgooooo00?o003oooooooooool07_ooool01?l00?ooooooooooool0
0?l;ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`08ooooo`03o`00
oooooooooooo00?ooooo00?o003oooooooooool00_l0nYX3ooooo`03o`00oooooooooooo00Cooooo
0_l0nYX00ol00?oooooooomQ0P0=ooooo`05oomQ0_ooooooooooooooool00?l00_l0nYX00ooooooo
003oooooo`04ooooo`03o`00oooooooooooo00;o0?ZJ1?ooool00ol00?ooooooooooo`06ooooo`03
oomQ0_oooooooooo00Sooooo00?oof42ooooooooool02?ooool00ol00?ooooooooooo`04ooooo`05
o`00ooooooooooooooooool000004oooool001Gooooo00Co0000oooooooooooo00002oooool00ol0
003oooooooooo`02ooooo`?o00000_ooool00oooH@;oooooooooo`02o`3jVPCooooo00?o003ooooo
ooooool02Oooool2o`3jVP;ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`03oooo
o`03oomQ0_oooooooooo00Sooooo0_l0nYX2ooooo`03o`00oooooooo003o00Gooooo0_l0nYX_oooo
o`04o`00ooooooooooooo`00o`_ooooo00Go003oooooooooooooooooo`00o`0@ooooo`03o`00oooo
oooooooo00;ooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`05ooooo`05o`00oooo
ooooooooooooooooH@803Oooool01?ooH@;oooooooooool00?l3ooooo`05o`00ool0nY[o0?ZJo`3j
V_ooool00_l0nYX8ooooo`03o`00oooooooooooo00[ooooo00?oof42ooooooooool01?ooool00ooo
H@;oooooooooo`08ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00ol00009oooo
o`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool3o`0000?ooooo00Coof42
ooooool0nY[o0?ZJ1?ooool01?l00?ooooooooooooooH@83ooooo`03oomQ0_oooooooooo00?ooooo
0_l0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0
1?ooool2o`3jVP;ooooo00?o003oooooool00?l01_ooool2o`3jVRkooooo00Co003ooooooooooooo
003o2oooool01Ol00?oooooooooooooooooo003o013ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`03o`3jVP;ooooo00?o003oooooooooool01?ooool2o`3jVP;ooooo00?oof42oooo
ooooool03?ooool01?ooH@;oooooooooool00?l3o`3jVP03o`00oooooooooooo00?ooooo00?o003o
ooooooooool00_l0nYX4ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool02Oooool0
0oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_l0000C
ooooo`005Oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00oooH@;oooooooooo`02o`3jVPCooooo00?o003oooooooooool02?ooool3
o`3jVP;ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooo
oooo00Sooooo0ol0nYX01?oooooo003oooooool00?l4ooooo`?o0?ZJ;oooool01?l00?oooooooooo
ool00?l;ooooo`05o`00ooooooooooooooooool00?l04?ooool01Ol00?oooooooooooooooooo003o
00Sooooo00?o003oooooooooool01Oooool01Ol00?ooooooooooooooooooof4200gooooo00Coof42
oooooooooooo003o0oooool00ol00?ooooooo`3jVP04o`3jVP03o`00oooooooooooo00Gooooo00?o
003oooooooooool02_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Sooooo00?o
003oooooooooool01?ooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00Co
0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo
00Coof42ooooool0nY[o0?ZJ1?ooool01?l00?ooooooooooooooH@83ooooo`03oomQ0_oooooooooo
00?ooooo0_l0nYX00ooooooo003oooooo`02ooooo`03oomQ0_oooooooooo00_ooooo00?oof42oooo
ooooool01?ooool3o`3jVP04ooooool00?ooooooo`00o`Gooooo0ol0nYX^ooooo`04o`00oooooooo
ooooo`00o`_ooooo00Go003oooooooooooooooooo`00o`0@ooooo`05o`00ooooooooooooooooool0
0?l01?ooool2o`3jVP;ooooo00?o003oooooooooool00oooool3o`3jVP;ooooo00?oof42oooooooo
ool03?ooool01OooH@;oooooooooool00?oooooo00;o0?ZJ00?o003oooooooooool01?ooool01?l0
0?oo0?ZJo`3jV_l0nYX4ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool02_ooool0
0oooH@;oooooooooo`07ooooo`03o`00oooooooooooo00Cooooo00Go003oooooooooooooooooo`00
000Cooooo`005Oooool01?l0003oooooooooool00007ooooo`Co00001Oooool00ol0003ooooooooo
o`03ooooo`04oomQ0_oooooo0?ZJo`3jVPGooooo00?o003oooooooooool01oooool2o`3jVP?ooooo
00?o003oooooooooool01Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Sooooo
0_l0nYX01?oooooo003oooooool00?l3ooooo`?o0?ZJ<?ooool01?l00?ooooooooooool00?l;oooo
o`05o`00ooooooooooooooooool00?l04?ooool01Ol00?oooooooooooooooooo003o00Sooooo00?o
003oooooooooool01Oooool01?l00?ooooooooooooooH@8>ooooo`04oomQ0_ooooooooooo`00o`?o
oooo00?o003oooooooooool01?l0nYX00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Wo
oooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool00oooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`00
00Oooooo1?l00005ooooo`03o`000?oooooooooo00?ooooo00Coof42ooooool0nY[o0?ZJ1Oooool0
0ol00?ooooooooooo`02oomQ0P03ooooooooH@;ooooo00Cooooo0_l0nYX00ooooooo003oooooo`02
ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01Oooool2o`3jVP04ooooool00?oo
ooooo`00o`Gooooo0_l0nYX_ooooo`04o`00ooooooooooooo`00o`_ooooo00Go003ooooooooooooo
ooooo`00o`0@ooooo`05o`00ooooooooooooooooool00?l01?ooool2o`3jVP;ooooo00?o003ooooo
ooooool00oooool2o`3jVP04o`00oooooooooooooomQ0Pkooooo00Goof42oooooooooooo003ooooo
o`02o`3jVP03o`00oooooooooooo00Cooooo0ol0nYX5ooooo`03o`00oooooooooooo00Cooooo00?o
of42ooooooooool02oooool00oooH@;oooooooooo`07ooooo`03o`00oooooooooooo00?ooooo00?o
003oooooooooool00_ooool00ol0003oooooooooo`0Aooooo`005Oooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool01?ooH@;oooooo`3j
V_l0nYX5ooooo`03o`00oooooooooooo00Kooooo0ol0nYX3ooooo`03o`00oooooooooooo00Gooooo
00?oof42ooooooooool01?ooool00oooH@;oooooooooo`08ooooo`;o0?ZJ00Coooooo`00oooooooo
003o0oooool2o`3jVS7ooooo00Co003ooooooooooooo003o2oooool01Ol00?oooooooooooooooooo
003o013ooooo00Go003oooooooooooooooooo`00o`08ooooo`?o003o1Oooool01?l00?oooooooooo
ooooH@8>ooooo`04oomQ0_ooooooooooo`00o`?ooooo00?o003oooooooooool00ol0nYX00ooooooo
003oooooo`06ooooo`03o`00oooooooooooo00Wooooo00?oof42ooooooooool01Oooool00oooH@;o
ooooooooo`08ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool00oooool00ol0003o
ooooooooo`07ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`03ooooo`03oomQ0_oooooo0?ZJ00;o0?ZJ1?ooool00ol00?ooooooooooo`02oooo
o`03oomQ0_oooooooooo00Cooooo0_l0nYX00ooooooo003oooooo`02ooooo`03oomQ0_oooooooooo
00_ooooo00?oof42ooooooooool01Oooool2o`3jVP04ooooool00?ooooooo`00o`Gooooo0_l0nYX_
ooooo`04o`00ooooooooooooo`00o`_ooooo00Go003oooooooooooooooooo`00o`0@ooooo`05o`00
ooooooooooooooooool00?l01?ooool3o`3jVP04ooooool00?oo003oo`00o`?ooooo0_l0nYX01?l0
0?ooooooooooooooH@8>ooooo`05oomQ0_ooooooooooo`00ooooool00_l0nYX00ol00?oooooooooo
o`04ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00_ooooo00?o
of42ooooooooool01oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o
0000ooooooooool04Oooool001Kooooo0_l00008ooooo`Go00001?ooool2o`0000Cooooo00Coof42
ooooool0nY[o0?ZJ1Oooool00ol00?ooooooooooo`06ooooo`;o0?ZJ1?ooool00ol00?oooooooooo
o`04ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool02?ooool3o`3jVP03ooooool0
0?oooooo00;ooooo0ol0nYXaooooo`04o`00ooooooooooooo`00o`_ooooo00Co003ooooooooooooo
003o4Oooool01Ol00?oooooooooooooooooo003o00_ooooo00?o003oooooooooool00_ooool01?l0
0?ooooooooooooooH@8?ooooo`03oomQ0_oooooo003o00?ooooo00Co003ooooooooooooooooo0_l0
nYX00ooooooo003oooooo`06ooooo`03o`00oooooooooooo00Wooooo00?oof42ooooooooool01Ooo
ool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool00_oo
ool2o`0000[ooooo0_l00008ooooo`Go00001?ooool2o`0000Cooooo00?oof42ooooooooool00_l0
nYX4ooooo`03o`00oooooooooooo00Sooooo0ol0nYX00ooooooo003oooooo`02ooooo`03oomQ0_oo
oooooooo00_ooooo00?oof42ooooooooool01Oooool3o`3jVP03ooooool00?oooooo00Cooooo0ol0
nYX_ooooo`04o`00ooooooooooooo`00o`_ooooo00Co003ooooooooooooo003o4Oooool01Ol00?oo
oooooooooooooooo003o00Gooooo0_l0nYX4ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00Co003ooooo
ooooooooof423_ooool01OooH@;oooooooooool00?oooooo00?o0?ZJ1Oooool3o`3jVPKooooo00?o
003oooooooooool01?ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00Oooooo00?o
003oooooooooool00oooool01?l00?ooooooooooooooool2o`0001?ooooo000Yooooo`03o`000?oo
oooooooo00?ooooo00?oof42ooooool0nYX00_l0nYX4ooooo`03o`00oooooooooooo00Kooooo0_l0
nYX4ooooo`03o`00oooooooooooo00?ooooo00?oof42ooooooooool01_ooool00oooH@;ooooooooo
o`09ooooo`;o0?ZJ00?oooooo`00ooooool00_ooool2o`3jVS?ooooo00?o003oooooool00?l02ooo
ool01?l00?ooooooooooool00?lAooooo`05o`00ooooooooooooooooool00?l02oooool00ol00?oo
ooooooooo`02ooooo`04o`00oooooooooooooomQ0Poooooo00?oof42ooooool00?l00oooool00ol0
0?ooooooooooo`04ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool02Oooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Oooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`04ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool00oooool00ooo
H@;oooooooooo`02o`3jVPCooooo00?o003oooooooooool02?ooool2o`3jVP;ooooo00Go003ooooo
oooooooooooooomQ0P0>ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX00ooooooo003oooooo`03
ooooo`?o0?ZJ<Oooool00ol00?ooooooo`00o`0;ooooo`04o`00ooooooooooooo`00oa7ooooo00Go
003oooooooooooooooooo`00o`05ooooo`?o0?ZJ0oooool01_l00?ooooooo`3jV_l0nY[oooooo`00
o`;ooooo00?oof42ooooooooool03?ooool01?ooH@;oooooooooool00?l2ooooo`;o0?ZJ1Oooool2
o`3jVPOooooo00?o003oooooooooool00oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooo
oooo00Oooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`03ooooo`03o`000?oooooo
oooo017ooooo000Yooooo`03o`000?oooooooooo00?ooooo00?oof42ooooooooool00_l0nYX4oooo
o`03o`00oooooooooooo00Gooooo0ol0nYX4ooooo`03o`00oooooooooooo00;ooooo00?oof42oooo
ooooool01oooool00oooH@;oooooooooo`09ooooo`?o0?ZJ00?o003oooooooooool00ol0nYXcoooo
o`03o`00oooooooo003o00cooooo00?o003oooooool00?l04Oooool01Ol00?oooooooooooooooooo
003o00_ooooo00?o003oooooooooool00_ooool01?l00?ooooooooooooooH@8?ooooo`04oomQ0_oo
ooooooooo`00o`;ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`04ooooo`03o`00
oooooooooooo00[ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`07ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool01?ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00Cooooo00Coof42ooooool0nY[o0?ZJ1?ooool00ol00?ooooooooooo`08ooooo`;o
0?ZJ0_ooool01Ol00?ooooooooooooooooooof4200kooooo00?oof42ooooooooool01Oooool2o`3j
VP03ooooool00?oooooo00;ooooo0ol0nYXbooooo`03o`00oooooooo003o00cooooo00?o003ooooo
ool00?l04Oooool01Ol00?oooooooooooooooooo003o00Kooooo0_l0nYX3ooooo`06o`00oooooooo
0?ZJo`3jV_oooooo003o0_ooool00oooH@;oooooooooo`0=ooooo`05oomQ0_ooooooooooo`00oooo
ool00_l0nYX4ooooo`?o0?ZJ1_ooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00co
oooo00?oof42ooooooooool01oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?o
oooo00?o0000ooooooooool04Oooool002Wooooo00?o0000ooooooooool00oooool00oooH@;ooooo
ooooo`02o`3jVPCooooo00?o003oooooooooool01Oooool2o`3jVPGooooo00?o003oooooooooool0
0_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00[ooooo0_l0nYX00ol00?oo0?ZJ
o`3jVP02o`3jVSCooooo0_l00?l=ooooo`03o`00oooooooo003o017ooooo00Go003ooooooooooooo
ooooo`00o`0;ooooo`03o`00oooooooooooo00;ooooo00Co003oooooooooooooof423oooool01?oo
H@;oooooooooool00?l2ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01?ooool0
0ol00?ooooooooooo`0:ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01oooool0
0ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`04ooooo`04oomQ0_oooooo0?ZJo`3jVPCooooo00?o003oooooooooool02?oo
ool2o`3jVP;ooooo00Go003ooooooooooooooooooomQ0P0>ooooo`03oomQ0_oooooooooo00Gooooo
0ol0nYX01?l00?ooooooooooooooool2o`3jVS?ooooo0_l00?l=ooooo`03o`00oooooooo003o017o
oooo00Go003oooooooooooooooooo`00o`06ooooo`Co0?ZJ00?oooooo`00ool0nYX00_l0nYX01Ooo
oooo003oooooooooooooof4200oooooo00Goof42oooooooooooo003oooooo`03o`3jVP?ooooo0_l0
nYX00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Cooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`07ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00ooo
ool00ol0003oooooooooo`0Aooooo`00:Oooool2o`0000Cooooo00?oof42ooooooooool00_l0nYX4
ooooo`03o`00oooooooooooo00Gooooo0_l0nYX5ooooo`03o`00oooooooooooo00;ooooo00?oof42
ooooooooool01oooool00oooH@;oooooooooo`0:ooooo`Ko0?ZJ=Oooool2o`00o`gooooo00?o003o
ooooool00?l04Oooool01Ol00?oooooooooooooooooo003o00_ooooo00?o003oooooooooool00_oo
ool01?l00?ooooooooooooooH@8?ooooo`04oomQ0_ooooooooooo`00o`;ooooo00?o003ooooooooo
ool01?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00[ooooo00?oof42oooooooo
ool01_ooool00oooH@;oooooooooo`07ooooo`05o`00ooooooooooooooooool00?l01_ooool2o`00
01gooooo0_l00005ooooo`04oomQ0_oooooo0?ZJo`3jVPCooooo00?o003oooooooooool02?ooool2
o`3jVP;ooooo00Co003oooooooooooooof423oooool00oooH@;oooooooooo`06ooooo`;o0?ZJ0ooo
ool3o`3jVQ[ooooo0oooH@8Fooooo`;o003o3Oooool00ol00?ooooooo`00o`0Aooooo`05o`00oooo
ooooooooooooool00?l01oooool7o`3jVP;ooooo00Co003oooooooooooooof423oooool01?ooH@;o
ooooooooool00?l2ooooo`;o0?ZJ0oooool2o`3jVP03o`00oooooooooooo00Cooooo00?o003ooooo
ooooool01?ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Oooooo00Go003ooooo
ooooooooooooo`00o`05ooooo`;o00004oooool002Wooooo00?o0000ooooooooool00oooool00ooo
H@;oooooooooo`02o`3jVPCooooo00?o003oooooooooool01Oooool2o`3jVPGooooo00Go003ooooo
oooooooooooooomQ0P0:ooooo`03oomQ0_oooooooooo00_ooooo0ol0nYXgooooo`;o003o3Oooool0
0ol00?ooooooo`00o`0Booooo`04o`00ooooooooooooo`00o`_ooooo00?o003oooooooooool00_oo
ool01?l00?ooooooooooooooH@8?ooooo`04oomQ0_ooooooooooo`00o`;ooooo00?o003ooooooooo
ool01?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00[ooooo00?oof42oooooooo
ool01_ooool00oooH@;oooooooooo`07ooooo`05o`00ooooooooooooooooool00?l01oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00Coof42ooooool0nY[o0?ZJ1?ooool0
0ol00?ooooooooooo`07ooooo`?o0?ZJ0_ooool01?l00?ooooooooooooooH@8?ooooo`03oomQ0_oo
oooooooo00Kooooo1ol0nYXJooooo`05oomQ0_ooooooooooooooooooH@805Oooool2o`00o`gooooo
00?o003oooooool00?l04_ooool01?l00?ooooooooooool00?l9ooooo`Co0?ZJ0oooool01?l00?oo
ooooooooooooH@8?ooooo`04oomQ0_ooooooooooo`00o`;ooooo0_l0nYX00ooooooo0?ZJo`3jVP02
o`3jVP03o`00oooooooooooo00Cooooo00?o003oooooooooool01?ooool00oooH@;oooooooooo`0=
ooooo`03oomQ0_oooooooooo00Kooooo00Go003oooooooooooooooooo`00o`06ooooo`03o`000?oo
oooooooo017ooooo000Yooooo`03o`000?oooooooooo00?ooooo00?oof42ooooooooool00_l0nYX4
ooooo`03o`00oooooooooooo00Gooooo0_l0nYX5ooooo`05o`00ooooooooooooooooooooH@802ooo
ool00oooH@;oooooooooo`14ooooo`;o003o3Oooool00ol00?ooooooo`00o`0Booooo`04o`00oooo
ooooooooo`00o`_ooooo00?o003oooooooooool00_ooool01?l00?ooooooooooooooH@8?ooooo`03
oomQ0_oooooooooo00Co003o1_ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00[o
oooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`07ooooo`05o`00oooooooooooooooo
ool00?l01oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00Coof42oooo
ool0nY[o0?ZJ1?ooool00ol00?ooooooooooo`07ooooo`;o0?ZJ0oooool01?l00?oooooooooooooo
H@8?ooooo`03oomQ0_oooooooooo00Oooooo1Ol0nYXJooooo`03oomQ0_oooooooooo00;ooooo00?o
of42ooooooooool04oooool2o`00o`gooooo00?o003oooooool00?l04_ooool01?l00?oooooooooo
ool00?l:ooooo`;o0?ZJ1?ooool01?l00?ooooooooooooooH@8?ooooo`03oomQ0_oooooooooo00?o
003o1_l0nYX00ooooooo003oooooo`05ooooo`03o`00oooooooooooo00?ooooo00?oof42oooooooo
ool03_ooool00oooH@;oooooooooo`06ooooo`05o`00ooooooooooooooooool00?l01_ooool00ol0
003oooooooooo`0Aooooo`00:Oooool00ol0003oooooooooo`03ooooo`03oomQ0_oooooooooo00;o
0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`?o0?ZJ1Oooool01Ol00?ooooooooooooooooooof42
00_ooooo00?oof42ooooooooool0A?ooool2o`00o`gooooo00?o003oooooool00?l04_ooool01?l0
0?ooooooooooool00?l;ooooo`03o`00oooooooooooo00;ooooo00Co003oooooooooooooof424?oo
ool00oooH@;oooooooooo`0:ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool02?oo
ool3oomQ0PSooooo00?oof42ooooooooool01oooool01Ol00?oooooooooooooooooo003o00Oooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`04ooooo`04oomQ0_oooooo0?ZJo`3jVPCo
oooo00?o003oooooooooool01oooool2o`3jVP?ooooo00Co003oooooooooooooof423oooool00ooo
H@;oooooooooo`0Vooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool04_ooool2o`00
o`gooooo00?o003oooooool00?l04_ooool01?l00?ooooooooooool00?l;ooooo`03o`00oooooooo
oooo00;ooooo00Co003oooooooooooooof423oooool00oooH@;oooooooooo`04ooooo`?o0?ZJ1?oo
ool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00?ooooo00?oof42ooooooooool03_oo
ool00oooH@;oooooooooo`06ooooo`05o`00ooooooooooooooooool00?l01_ooool00ol0003ooooo
ooooo`0Aooooo`00:Oooool2o`0000Cooooo00?oof42ooooooooool00ol0nYX3ooooo`03o`00oooo
oooooooo00Cooooo0_l0nYX6ooooo`05o`00ooooooooooooooooooooH@802oooool00oooH@;ooooo
ooooo`15ooooo`03o`00oooooooooooo00_ooooo00?o003oooooool00?l04_ooool01?l00?oooooo
ooooool00?l<ooooo`05o`00ooooooooooooooooool00?l00_ooool00oooH@;oooooooooo`0>oooo
o`03oomQ0_oooooooooo00[ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`07oooo
o`04oomQ0_oooooooooooomQ0PSooooo00?oof42ooooooooool01oooool01?l00?ooooooooooool0
0?l7ooooo`;o00007Oooool2o`0000Gooooo00?oof42ooooool0nYX00_l0nYX3ooooo`03o`00oooo
oooooooo00Oooooo0_l0nYX3ooooo`04o`00oooooooooooooomQ0Q3ooooo00?oof42ooooooooool0
9?ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo01?ooooo00?o003oooooooooool0
2oooool00ol00?ooooooo`00o`0Booooo`04o`00ooooooooooooo`00o`cooooo00Go003ooooooooo
ooooooooo`00o`02ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool02oooool00ol0
0?ooooooooooo`03ooooo`03o`00oooooooooooo00?ooooo00?oof42ooooooooool03_ooool00ooo
H@;oooooooooo`06ooooo`04o`00ooooooooooooo`00o`Kooooo0_l0000Cooooo`00:Oooool00ol0
003oooooooooo`03ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ0oooool00ol00?ooooooooooo`04
ooooo`;o0?ZJ1_ooool01Ol00?ooooooooooooooooooof4200_ooooo00?oof42ooooooooool0AOoo
ool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo017ooooo00Co003ooooooooooooo003o
3?ooool01Ol00?oooooooooooooooooo003o00;ooooo00?oof42ooooooooool03_ooool00oooH@;o
ooooooooo`0:ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool01_ooool00oooH@;o
ooooooooo`0:ooooo`03oomQ0_oooooooooo00Sooooo00?o003oooooool00?l02?ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00?oof42ooooooooool00_l0nYX3ooooo`03
o`00oooooooooooo00Oooooo0_l0nYX3ooooo`04o`00oooooooooooooomQ0Q3ooooo00?oof42oooo
ooooool09?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo01;ooooo00?o003ooooo
ooooool03?ooool00ol00?ooooooooooo`0Aooooo`04o`00ooooooooooooo`00o`cooooo00Go003o
ooooooooooooooooo`00o`02ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool02_oo
ool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00?ooooo00?oof42ooooooooool03_oo
ool00oooH@;oooooooooo`07ooooo`03o`00oooooooo003o00Oooooo00?o0000ooooooooool04Ooo
ool002Wooooo00?o0000ooooooooool01?ooool00oooH@;oooooooooo`02o`3jVP?ooooo00?o003o
ooooooooool00_ooool01?l00?oo0?ZJo`3jV_l0nYX6ooooo`04o`00oooooooooooooomQ0Pcooooo
00?oof42ooooooooool0AOooool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo017ooooo
00Co003ooooooooooooo003o3?ooool01?l00?ooooooooooool00?l3ooooo`03oomQ0_oooooooooo
00kooooo00?oof42ooooooooool02_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo
00Gooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`07ooooo`03o`00oooooooo003o
00Sooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`04ooooo`03oomQ0_oooooooooo
00;o0?ZJ0oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo0_l0nYX3oooo
o`04o`00oooooooooooooomQ0Q3ooooo00?oof42ooooooooool08oooool00oooH@;oooooooooo`06
ooooo`03oomQ0_oooooooooo01;ooooo00?o003oooooooooool03?ooool00ol00?ooooooooooo`0A
ooooo`04o`00ooooooooooooo`00o`cooooo00Co003ooooooooooooo003o0oooool00oooH@;ooooo
ooooo`0>ooooo`03oomQ0_oooooooooo00[ooooo00?o003oooooooooool00oooool00ol00?oooooo
ooooo`02ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool01_ooool00ol00?oooooo
o`00o`07ooooo`03o`000?oooooooooo017ooooo000Yooooo`03o`000?oooooooooo00Cooooo00?o
of42ooooooooool00_l0nYX3ooooo`03o`00oooooooooooo00;ooooo00?o003oo`3jV_l0nYX01ooo
ool01?l00?ooooooooooooooH@8=ooooo`03oomQ0_oooooooooo05?ooooo00?o003oooooooooool0
4Oooool01?l00?ooooooooooool00?l<ooooo`04o`00ooooooooooooo`00o`?ooooo00?oof42oooo
ooooool03_ooool00oooH@;oooooooooo`0:ooooo`03o`00oooooooooooo00?ooooo00?o003ooooo
ooooool01Oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Oooooo00?o003ooooo
ool00?l02?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00?oof42oooo
ooooool00_l0nYX3ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooooooo0ol0nYX3
ooooo`03o`00ooooooooof42017ooooo00?oof42ooooooooool08oooool00oooH@;oooooooooo`07
ooooo`03oomQ0_oooooooooo023ooooo00?o003oooooooooool04Oooool01?l00?ooooooooooool0
0?l<ooooo`04o`00ooooooooooooo`00o`;ooooo00?oof42ooooooooool03oooool00oooH@;ooooo
ooooo`0:ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool00_ooool00oooH@;ooooo
ooooo`0@ooooo`03oomQ0_oooooooooo00Kooooo00?o003oooooool00?l01oooool00ol0003ooooo
ooooo`0Aooooo`00:Oooool2o`0000Gooooo00?oof42ooooooooool00ol0nYX3ooooo`05o`00oooo
ooooooooooooool00?l00_l0nYX7ooooo`04o`00oooooooooooooomQ0Pgooooo00?oof42oooooooo
ool0Doooool00ol00?ooooooooooo`0Aooooo`04o`00ooooooooooooo`00o`cooooo00Co003ooooo
oooooooo003o0oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00_ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00gooooo00?oof42
ooooooooool01oooool00ol00?ooooooo`00o`07ooooo`;o00007Oooool2o`0000Gooooo00?oof42
ooooooooool00_l0nYX4ooooo`05o`00ooooooooooooooooool00?l00oooool2o`3jVPCooooo00?o
003oooooooooH@804Oooool00oooH@;oooooooooo`0Rooooo`03oomQ0_oooooooooo00Sooooo00?o
of42ooooooooool08?ooool00ol00?ooooooooooo`0Aooooo`04o`00ooooooooooooo`00o`cooooo
00Co003ooooooooooooo003o0_ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00_o
oooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo013o
oooo00?oof42ooooooooool01_ooool00ol00?ooooooo`00o`06ooooo`;o00004oooool0027ooooo
0ol00005ooooo`03o`000?oooooooooo00Cooooo00Coof42oooooooooooooooo0_l0nYX3ooooo`04
o`00ooooooooooooooooo`?o0?ZJ1_ooool01Ol00?ooooooooooooooooooof4200gooooo00?oof42
ooooooooool0Ioooool01?l00?ooooooooooool00?l<ooooo`04o`00ooooooooooooo`00o`?ooooo
00?oof42ooooooooool03oooool00oooH@;oooooooooo`0:ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool01?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00Oooooo
0_l00?l9ooooo`03o`000?oooooooooo01?ooooo0ol00005ooooo`03o`000?oooooooooo00Gooooo
00?oof42ooooool0nYX00_l0nYX3ooooo`04o`00ooooooooooooooooo`;o003o0_ooool2o`3jVP?o
oooo00Co003oooooooooooooof424Oooool00oooH@;oooooooooo`0Qooooo`03oomQ0_oooooooooo
00Wooooo00?oof42ooooooooool0=?ooool01?l00?ooooooooooool00?l<ooooo`04o`00oooooooo
ooooo`00o`;ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0;ooooo`03o`00oooo
oooooooo00;ooooo00Go003ooooooooooooooooooomQ0P0Dooooo`03oomQ0_oooooooooo00Gooooo
0_l00?l8ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool01?ooool01?ooH@;oooooooooooooool2o`3jVP?ooooo00Co003ooooooooooooo
oooo0_l0nYX7ooooo`04o`00oooooooooooooomQ0Pkooooo00?oof42ooooooooool0J?ooool00ol0
0?ooooooo`00o`0<ooooo`04o`00ooooooooooooo`00o`?ooooo00?oof42ooooooooool03oooool0
0oooH@;oooooooooo`0:ooooo`05o`00ooooooooooooooooool00?l01_ooool00oooH@;ooooooooo
o`0>ooooo`03oomQ0_oooooooooo00Oooooo0_l00?l9ooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03oomQ0_oooooooooo00;o0?ZJ0ooo
ool01?l00?ooooooooooooooool2o`00o`;ooooo0_l0nYX3ooooo`04o`00oooooooooooooomQ0Q7o
oooo00?oof42ooooooooool08?ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo03Co
oooo00?o003oooooool00?l03?ooool01?l00?ooooooooooool00?l2ooooo`03oomQ0_oooooooooo
00oooooo00?oof42ooooooooool02oooool01Ol00?oooooooooooooooooo003o00Cooooo00?oof42
ooooooooool04_ooool00oooH@;oooooooooo`05ooooo`;o003o2?ooool00ol0003oooooooooo`0A
ooooo`008_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00Coof42oooo
oooooooooooo0_l0nYX3ooooo`04o`00ooooooooooooooooo`;o0?ZJ1oooool01?l00?oooooooooo
ooooH@8>ooooo`03oomQ0_oooooooooo06Sooooo00?o003oooooool00?l03?ooool01?l00?oooooo
ooooool00?l3ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool02_ooool01Ol00?oo
oooooooooooooooo003o00Kooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`07oooo
o`;o003o2Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool00oooH@;oooooooooo`02o`3jVP?ooooo00Co003ooooooooooooooooo0_l00?l2
ooooo`;o0?ZJ0oooool01?l00?ooooooooooooooH@8Booooo`03oomQ0_oooooooooo01oooooo00?o
of42ooooooooool02oooool00oooH@;oooooooooo`0dooooo`03o`00oooooooo003o00cooooo00Co
003ooooooooooooo003o0_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00[ooooo
00Go003oooooooooooooooooo`00o`04ooooo`03oomQ0_oooooooooo01;ooooo00?oof42oooooooo
ool00_ooool4oomQ0P03o`00oooooooooooo00Kooooo00?o0000ooooooooool04Oooool002;ooooo
00?o0000ooooooooool01?ooool3o`0000Cooooo00Coof42oooooooooooooooo0ol0nYX2ooooo`03
o`00oooooooooooo00?o0?ZJ1oooool01?l00?ooooooooooooooH@8?ooooo`03oomQ0_oooooooooo
06Oooooo0_l00?l=ooooo`04o`00ooooooooooooo`00o`?ooooo00?oof42ooooooooool03oooool0
0oooH@;oooooooooo`0:ooooo`05o`00ooooooooooooooooool00?l01Oooool00oooH@;ooooooooo
o`0?ooooo`03oomQ0_oooooooooo00Oooooo0_l00?l7ooooo`?o00005_ooool00ol0003ooooooooo
o`04ooooo`?o00001Oooool00oooH@;oooooooooo`02o`3jVP?ooooo00Ko003ooooooooooooo003o
ooooool00?l2ooooo`;o0?ZJ0oooool00ol00?oooooooomQ0P0Cooooo`03oomQ0_oooooooooo01ko
oooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0dooooo`;o003o3Oooool01?l00?oo
ooooooooool00?l2ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool02_ooool01Ol0
0?oooooooooooooooooo003o00?ooooo00?oof42ooooooooool05?ooool2oomQ0P03ooooooooH@;o
oooo00;ooooo00?oof42o`00ooooool01_ooool2o`0001?ooooo000Rooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00oooH@;oooooooooo`02ooooo`;o0?ZJ0_ooool00ol0
0?ooooooooooo`02o`3jVP03ooooool00?oooooo00Gooooo00Co003oooooooooooooof423oooool0
0oooH@;oooooooooo`1Wooooo`;o003o3Oooool01?l00?ooooooooooool00?l3ooooo`03oomQ0_oo
oooooooo00oooooo00?oof42ooooooooool02oooool01?l00?ooooooooooool00?l4ooooo`03oomQ
0_oooooooooo017ooooo00?oof42ooooooooool01_ooool2o`00o`Wooooo00?o0000ooooooooool0
5?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?oof42ooooooooool0
0_l0nYX3ooooo`04o`00ooooooooooooo`00o`;ooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool00ol0
0?oooooooomQ0P0Cooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool03?ooool00ooo
H@;oooooooooo`0dooooo`;o003o3Oooool01?l00?ooooooooooool00?l2ooooo`03oomQ0_oooooo
oooo013ooooo00?oof42ooooooooool02oooool01?l00?ooooooooooool00?l3ooooo`03oomQ0_oo
oooooooo01Kooooo00?oof42ooooooooool00_ooool00ol00?ooof42ooooo`07ooooo`03o`000?oo
oooooooo017ooooo000Qooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`03oomQ0_oooooo
oooo00;ooooo0_l0nYX2ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00?oooooo`00ooooool01Oooool0
0ol00?oooooooomQ0P0@ooooo`03oomQ0_oooooooooo06Oooooo0_l00?l=ooooo`03o`00oooooooo
003o00Cooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0;ooooo`04o`00oooooooo
ooooo`00o`Cooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`06ooooo`03o`00oooo
oooooooo00Sooooo00?o0000ooooooooool04oooool2o`0000Kooooo00?o0000ooooooooool01Ooo
ool00oooH@;oooooooooo`03o`3jVP;ooooo00Co003ooooooooooooo003o0_ooool00ol00?oo0?ZJ
o`3jVP04ooooo`03o`00ooooooooof4201?ooooo00?oof42ooooooooool07_ooool00oooH@;ooooo
ooooo`0<ooooo`03oomQ0_oooooooooo03Cooooo0_l00?l=ooooo`03o`00oooooooo003o00?ooooo
00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0;ooooo`04o`00ooooooooooooo`00o`?o
oooo00?oof42ooooooooool06oooool00ol00?oooooooomQ0P07ooooo`03o`000?oooooooooo017o
oooo000Rooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00oooH@;ooooo
ooooo`02ooooo`?o0?ZJ00?oooooo`00ooooool00_l0nYX2ooooo`03o`00oooooooooooo00Cooooo
00?o003oooooooooH@804?ooool00oooH@;oooooooooo`1Wooooo`;o003o3Oooool00ol00?oooooo
o`00o`04ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool02oooool01?l00?oooooo
ooooool00?l2ooooo`;oof425?ooool00oooH@;oooooooooo`06ooooo`03o`00oooooooooooo00So
oooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Go
oooo00Coof42oooooooooooooooo0_l0nYX2ooooo`04o`00ooooooooooooo`00o`;ooooo00?o003o
o`3jV_l0nYX01?ooool00ol00?oooooooomQ0P0Cooooo`03oomQ0_oooooooooo01gooooo00?oof42
ooooooooool03_ooool00oooH@;oooooooooo`0cooooo`;o003o3Oooool00ol00?ooooooo`00o`03
ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool02oooool01?l00?ooooooooooool0
0?l2ooooo`03oomQ0_oooooooooo01cooooo00?o003oooooooooH@801oooool00ol0003ooooooooo
o`0Aooooo`00:Oooool2o`0000Gooooo00?oof42ooooooooool00oooool7o`3jVP;ooooo00?o003o
ooooooooool01?ooool00ol00?oooooooomQ0P0@ooooo`03oomQ0_oooooooooo06Oooooo0_l00?l=
ooooo`03o`00oooooooo003o00?ooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0:
ooooo`06o`00ooooooooooooo`00ooooooooof425_ooool00oooH@;oooooooooo`0@ooooo`;o0000
7Oooool2o`0000Kooooo00Coof42oooooooooooooooo0_l0nYX3ooooo`03o`00oooooooo003o00;o
oooo00?o003oo`3jV_l0nYX01?ooool00ol00?oooooooomQ0P0Dooooo`03oomQ0_oooooooooo01co
oooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Wooooo`Koof421_ooool2o`00o`go
oooo00?o003oooooool00?l00oooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00_o
oooo00Co003ooooooooooooo003o0_ooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo
00?ooooo0_l0000Cooooo`00:Oooool00ol0003oooooooooo`04ooooo`03oomQ0_oooooooooo00Co
oooo1Ol0nYX01?l00?ooooooooooool00?l6ooooo`03o`00ooooooooof42017ooooo00?oof42oooo
ooooool0I_ooool2o`00o`gooooo00?o003oooooool00?l00oooool00oooH@;oooooooooo`0Aoooo
o`03oomQ0_oooooooooo00[ooooo00Ko003ooooooooooooo003oooooooooH@8Gooooo`03oomQ0_oo
oooooooo013ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`05ooooo`04oomQ0_oo
ooooooooooooo`;o0?ZJ0oooool00ol00?ooooooo`00o`02ooooo`03o`00ool0nY[o0?ZJ00Cooooo
00?o003oooooooooH@805?ooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo00oooooo
00?oof42ooooooooool08_ooool5oomQ0PKooooo00?oof42ooooooooool00oooool2o`00o`gooooo
00?o003oooooool00?l00oooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00_ooooo
00Co003ooooooooooooo003o0_ooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo00Co
oooo00?o0000ooooooooool04Oooool002Wooooo00?o0000ooooooooool01?ooool00oooH@;ooooo
ooooo`07ooooo`03o`00oooooooo003o00?ooooo00?o003oooooooooool00oooool00ol00?oooooo
oomQ0P0Aooooo`03oomQ0_oooooooooo06Oooooo00?o003oooooooooool02oooool00ol00?oooooo
o`00o`03ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool02_ooool01Ol00?oooooo
ooooool00?ooof4201Sooooo00?oof42ooooooooool04?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Gooooo00Coof42oooooooooooooooo0_l0nYX3ooooo`03o`00oooooooo003o
00?ooooo0_l0nYX4ooooo`03o`00ooooH@;ooooo01Cooooo00?oof42ooooooooool06_ooool00ooo
H@;oooooooooo`0@ooooo`03oomQ0_oooooooooo023ooooo0_ooH@8<ooooo`03oomQ0_oooooooooo
00?ooooo00?o003oooooooooool02oooool00ol00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo
017ooooo00?oof42ooooooooool02_ooool01?l00?ooooooooooool00?l2oomQ0R;ooooo00?oof42
ooooooooool01?ooool00ol0003oooooooooo`0Aooooo`00:Oooool00ol0003oooooooooo`05oooo
o`03oomQ0_oooooooooo00Kooooo00?o003oooooool00?l00oooool00ol00?ooooooooooo`03oooo
o`03o`00ooooH@;ooooo017ooooo00?oof42ooooooooool08?ooool6oomQ0T7ooooo00?o003ooooo
ooooool03?ooool2o`00o`?ooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0;oooo
o`03o`00ooooooooof4201Wooooo00?oof42ooooooooool04?ooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Kooooo00?oof42ooooooooool00_l0nYX3ooooo`03o`00oooooooo003o
00?ooooo0_l0nYX4ooooo`03o`00ooooH@;ooooo01Cooooo00?oof42ooooooooool06_ooool00ooo
H@;oooooooooo`0Aooooo`03oomQ0_oooooooooo013ooooo1?ooH@8:ooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`0<ooooo`;o003o0oooool00ooo
H@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00_ooooo00?o003oooooooooH@809Oooool00ooo
H@;oooooooooo`03ooooo`03o`000?oooooooooo017ooooo000Yooooo`;o00001_ooool00oooH@;o
ooooooooo`06ooooo`03o`00oooooooo003o00?ooooo00?o003oooooooooool00oooool00ol00?oo
of42ooooo`0Aooooo`03oomQ0_oooooooooo01kooooo0_ooH@86ooooo`?oof42?_ooool00ol00?oo
ooooooooo`0<ooooo`;o003o0oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00_o
oooo00?o003ooomQ0_l00?l06Oooool00oooH@;oooooooooo`0?ooooo`;o00007Oooool2o`0000Oo
oooo00?oof42ooooooooool00ol0nYX2ooooo`03o`00oooooooo003o00;ooooo0ol0nYX4ooooo`03
o`00ooooH@;ooooo01Cooooo00?oof42ooooooooool06Oooool00oooH@;oooooooooo`0Booooo`03
oomQ0_oooooooooo00oooooo00Goof42oooooooooooooooooomQ0P09ooooo`03oomQ0_oooooooooo
00oooooo00Goof42ooooooooooooooooo`00o`0>ooooo`;o003o0oooool00oooH@;oooooooooo`0A
ooooo`03oomQ0_oooooooooo00_ooooo00?o003ooomQ0_l00?l09Oooool00oooH@;oooooooooo`02
ooooo`;o00004oooool002Wooooo00?o0000ooooooooool01Oooool00oooH@;oooooooooo`06oooo
o`03o`00oooooooo003o00?ooooo00?o003oooooooooool00oooool00ol00?ooof42ooooo`0Aoooo
o`03oomQ0_oooooooooo01gooooo00?oof42ooooooooool02Oooool2oomQ0ROooooo1_ooH@82oooo
oa3oof423?ooool2o`00o`?ooooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`0:oooo
o`03o`00ooooH@;o003o01Wooooo00?oof42ooooooooool04?ooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Kooooo00Coof42oooooooooooooooo0_l0nYX2ooooo`03o`00oooooooo
003o00;ooooo0_l0nYX5ooooo`03o`00ooooH@;ooooo01Cooooo00?oof42ooooooooool06Oooool0
0oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool00oooool0
0oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo013ooooo00Coof42oooooooooooo003o3_oo
ool2o`00o`;ooooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`0;ooooo`03o`00oooo
H@;o003o02Gooooo00?oof42ooooooooool00oooool00ol0003oooooooooo`0Aooooo`00:Oooool0
0ol0003oooooooooo`05ooooo`03oomQ0_oooooooooo00Kooooo00?o003oooooool00?l00oooool0
0ol00?ooooooooooo`03ooooo`03o`00ooooH@;ooooo01;ooooo00?oof42ooooooooool06oooool0
0oooH@;oooooooooo`0<ooooo`;oof429?ooool00oooH@;oooooooooo`04ooooo`;oof424?ooool2
oomQ0P[ooooo0_l00?l3ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool02_ooool0
0ol00?ooof42o`00o`0Jooooo`03oomQ0_oooooooooo00oooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`06ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ0_ooool00ol00?ooooooo`00
o`02ooooo`;o0?ZJ1Oooool00ol00?ooof42ooooo`0Eooooo`03oomQ0_oooooooooo01Oooooo00?o
of42ooooooooool05?ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Gooooo0_oo
H@85ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool03_ooool2o`00o`;ooooo00?o
of42ooooooooool04_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooo003o02Kooooo00?o
of42ooooooooool00_ooool00ol0003oooooooooo`0Aooooo`00:Oooool00ol0003oooooooooo`05
ooooo`03oomQ0_oooooooooo00Kooooo0_l00?l5ooooo`03o`00oooooooooooo00;ooooo00?o003o
oomQ0_ooool04_ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo00oooooo00?oof42
ooooooooool08?ooool00oooH@;oooooooooo`0Iooooo`?oof421oooool00ol00?ooooooooooo`02
ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool02_ooool00oooH@;o003oooooo`0J
ooooo`03oomQ0_oooooooooo00oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`06
ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ0_ooool2o`00o`?ooooo0_l0nYX00ol00?oooooooooo
o`02ooooo`03o`00ooooH@;ooooo01Gooooo00?oof42ooooooooool05oooool00oooH@;ooooooooo
o`0Dooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool02?ooool01OooH@;ooooooooo
ooooooooof4201Gooooo00?oof42ooooooooool03_ooool01Ol00?ooooooooooooooooooof4201Co
oooo00?oof42ooooooooool02oooool00oooH@;o003oooooo`0Vooooo`03oomQ0_oooooooooo00;o
oooo00?o0000ooooooooool04Oooool002Wooooo0_l00006ooooo`03oomQ0_oooooooooo00Kooooo
0_l00?l5ooooo`03o`00oooooooooooo00;ooooo00?o003ooomQ0_ooool04_ooool4oomQ0QSooooo
00?oof42ooooooooool04Oooool2oomQ0Qoooooo00?oof42ooooooooool07Oooool5oomQ0P;ooooo
00?o003oooooooooool00_ooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo00Wooooo
00?oof42o`00ooooool06_ooool00oooH@;oooooooooo`0>ooooo`;o00007Oooool2o`0000Oooooo
00Coof42oooooooooooooooo0_l0nYX2ooooo`;o003o0_ooool3o`3jVP03o`00oooooooooooo00;o
oooo00?o003ooomQ0_ooool05Oooool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo01Go
oooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0:ooooo`?oof425oooool00oooH@;o
ooooooooo`0=ooooo`05o`00ooooooooooooooooooooH@805Oooool00oooH@;oooooooooo`0:oooo
o`03oomQ0_l00?oooooo02Kooooo00Coof42oooooooooooooooo0_l0000Cooooo`00:Oooool00ol0
003oooooooooo`05ooooo`03oomQ0_oooooooooo00Oooooo00?o003oooooooooool00oooool00ol0
0?ooooooooooo`02ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool05_ooool00ooo
H@;oooooooooo`0Cooooo`Coof425oooool4oomQ0RGooooo0_ooH@800ol00?ooooooooooo`02oooo
o`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool02Oooool00oooH@;o003oooooo`0Koooo
o`03oomQ0_oooooooooo00kooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`06oooo
o`04oomQ0_ooooooooooooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`02o`3jVP03ooooool00?oo
oooo00?ooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooo
oooo01Kooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Tooooo`03oomQ0_oooooo
oooo00gooooo00Go003ooooooooooooooooooomQ0P0Eooooo`03oomQ0_oooooooooo00Wooooo00?o
of42o`00ool00?l0:?ooool01OooH@;ooooooooooooooooo000001?ooooo000Yooooo`03o`000?oo
oooooooo00Gooooo00?oof42ooooooooool01oooool00ol00?ooooooooooo`03ooooo`06o`00oooo
ooooooooooooool00?ooof425oooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo01Oo
oooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Yooooo`Koof425Oooool00oooH@;o
ooooooooo`08ooooo`03oomQ0_oooooo003o01cooooo00?oof42ooooooooool03_ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00Kooooo00?oof42ooooooooool00_ooool2o`3jVP;o
oooo00?o003oooooooooool00_l0nYX00ooooooo003oooooo`02ooooo`03o`00ooooH@;ooooo01Ko
oooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00So
oooo00?oof42ooooooooool09_ooool00oooH@;oooooooooo`0<ooooo`05o`00oooooooooooooooo
ooooH@805Oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooo003o02Sooooo00Goof42oooo
ooooooooooooo`00000Cooooo`00:Oooool00ol0003oooooooooo`05ooooo`03oomQ0_oooooooooo
00Oooooo00?o003oooooooooool00oooool01_l00?oooooooooooooooooo003ooomQ0QOooooo00?o
of42ooooooooool05?ooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo01;ooooo00?o
of42ooooooooool0A_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooo003o01cooooo00?o
of42ooooooooool03_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Kooooo00?o
of42ooooooooool00_ooool2o`3jVP;ooooo00?o003oooooool0nYX00_l0nYX00ooooooo003ooooo
o`02ooooo`03o`00ooooH@;ooooo01Kooooo00?oof42ooooooooool05?ooool00oooH@;ooooooooo
o`0Hooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool09oooool00oooH@;ooooooooo
o`0@ooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool02?ooool00oooH@;oooooo`00
o`0Xooooo`05oomQ0_ooooooooooooooool000004oooool002Wooooo0_l00006ooooo`03oomQ0_oo
oooooooo00Oooooo00?o003oooooooooool01?ooool01Ol00?ooooooooooool00?ooof4201Sooooo
00?oof42ooooooooool04_ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo017ooooo
00?oof42ooooooooool0Aoooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooo003o01gooooo
00?oof42ooooooooool03?ooool2o`0001gooooo0_l00007ooooo`03oomQ0_oooooooooo00;ooooo
0_l0nYX2ooooo`04o`00oooooooo0?ZJo`3jVP?ooooo00Go003ooooooooooooo003ooomQ0P0Hoooo
o`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool06Oooool00oooH@;oooooooooo`05oooo
o`03oomQ0_oooooooooo02Wooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Doooo
o`03oomQ0_oooooooooo00Oooooo00Coof42oooooooooooo003o:Oooool01?ooH@;oooooo`000?l0
000Cooooo`005Oooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000
ooooooooool01Oooool00oooH@;oooooooooo`0>ooooo`05o`00ooooooooooooo`00ooooH@806?oo
ool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool03ooo
ool2oomQ0T[ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Nooooo`03oomQ0_oo
oooooooo00gooooo00?o0000ooooooooool01oooool3o`0000Cooooo00?o0000ooooooooool00_oo
ool3o`0000Gooooo00?o0000ooooooooool01_ooool00oooH@;oooooooooo`02ooooo`?o0?ZJ0ooo
ool2o`3jVP?ooooo00Go003ooooooooooooo003ooomQ0P0Hooooo`03oomQ0_oooooooooo01;ooooo
00?oof42ooooooooool06_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo02_ooooo
00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00Oooooo
00?oof42ooooooooool0:_ooool01?ooH@;oooooooooool0000Cooooo`005_ooool00ol0003ooooo
ooooo`07ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`05ooooo`03
oomQ0_oooooooooo00kooooo00Go003ooooooooooooo003ooomQ0P0Hooooo`03oomQ0_oooooooooo
017ooooo00?oof42ooooooooool07?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo
04[ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Nooooo`03oomQ0_oooooooooo
00gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`07ooooo`03oomQ0_oooooooooo00;ooooo0ol0nYX0
1?oooooo0?ZJo`3jV_l0nYX3ooooo`05o`00ooooooooooooo`00ooooH@806?ooool00oooH@;ooooo
ooooo`0Booooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool00oooool00oooH@;ooooo
ooooo`0/ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool05?ooool00oooH@;ooooo
ooooo`07ooooo`03oomQ0_oooooooooo02[ooooo00Coof42oooooooooooo00004oooool001Kooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Kooooo
00?oof42ooooooooool03Oooool01Ol00?ooooooooooool00?ooof4201Sooooo00?oof42oooooooo
ool04Oooool00oooH@;oooooooooo`0Looooo`;oof423?ooool2oomQ0Tkooooo00?oof42oooooooo
ool01Oooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo00cooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01oooool00oooH@;oooooooooo`03ooooo`Go0?ZJ1?ooool01Ol00?ooooooooooool00?ooof42
01Sooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0Looooo`?oof4200?ooooooomQ
0_ooool0;oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo01Kooooo00?oof42oooo
ooooool01Oooool00oooH@;oooooooooo`0/ooooo`03oomQ0_oooooo000001?ooooo000Fooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool00_ooool3o`0000Kooooo00?oof42oooooooo
ool03_ooool01?l00?ooooooo`00ooooH@8Hooooo`03oomQ0_oooooooooo013ooooo00?oof42oooo
ooooool07oooool00oooH@;oooooooooo`07ooooo`;oof42D?ooool00oooH@;oooooooooo`04oooo
o`03oomQ0_oooooooooo027ooooo00?oof42ooooooooool01oooool2oomQ0P?o00002_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo0ol00007ooooo`03oomQ0_oooooooooo
00?ooooo1?l0nYX6ooooo`04o`00oooooooo003ooomQ0QSooooo00?oof42ooooooooool04Oooool0
0oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo02oooooo00?oof42ooooooooool03?ooool0
0oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0;?ooool0
0oooH@;o0000o`00000Cooooo`005_ooool00ol0003oooooooooo`07ooooo`Co00001Oooool00ol0
003oooooooooo`06ooooo`03oomQ0_oooooooooo00oooooo00?o003ooomQ0_ooool06?ooool00ooo
H@;oooooooooo`0@ooooo`03oomQ0_oooooooooo023ooooo2OooH@9Booooo`03oomQ0_oooooooooo
00Cooooo00?oof42ooooooooool08_ooool2oomQ0PKooooo00?oof42ooooooooool00_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo1?l00005ooooo`03o`000?oooooooooo
00Oooooo00?oof42ooooooooool01?ooool2o`3jVPSooooo0_l00?l00oooH@;oooooooooo`0Foooo
o`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool0D_ooool00oooH@;oooooooooo`0;oooo
o`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0^oooo
o`03o`000?oooooooooo017ooooo000Eooooo`;o00002Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0Gooooo`03
oomQ0_oooooooooo00oooooo00?oof42ooooooooool0OOooool00oooH@;oooooooooo`03ooooo`03
oomQ0_oooooooooo02Cooooo1_ooH@85ooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00oooH@;oooooooooo`0?ooooo`03
oomQ0_oooooooooo01Oooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`1Cooooo`03
oomQ0_oooooooooo00_ooooo00?oof42ooooooooool05_ooool00oooH@;oooooooooo`04ooooo`03
oomQ0_oooooooooo02oooooo00?o0000ooooooooool04Oooool001Kooooo00?o0000ooooooooool0
1oooool5o`0000Cooooo00?o0000ooooooooool01_ooool00oooH@;oooooooooo`0@ooooo`03oomQ
0_oooooooooo01Sooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`1nooooo`03oomQ
0_oooooooooo00;ooooo00?oof42ooooooooool0<?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Oooooo1Ol00004ooooo`03o`000?oooooooooo00Oooooo00?oof42ooooooooool0
3oooool00oooH@;oooooooooo`0Hooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool0
Doooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool0
0oooool00oooH@;oooooooooo`0_ooooo`03o`000?oooooooooo017ooooo000Yooooo`;o00001ooo
ool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`1oooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0;ooo
ool2o`0001gooooo0_l00008ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool06?oo
ool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo05Gooooo00?oof42ooooooooool02_oo
ool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool0;_oo
ool2o`0001?ooooo000Yooooo`03o`000?oooooooooo00Kooooo00?oof42ooooooooool04?ooool0
0oooH@;oooooooooo`0Hooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0P?ooool0
1OooH@;oooooooooooooooooof4203;ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`07ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool06?ooool00oooH@;ooooooooo
o`0=ooooo`03oomQ0_oooooooooo05Kooooo00?oof42ooooooooool02Oooool00oooH@;ooooooooo
o`0Hooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool0;oooool00ol0003ooooooooo
o`0Aooooo`00:Oooool00ol0003oooooooooo`06ooooo`03oomQ0_oooooooooo00oooooo00?oof42
ooooooooool06Oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo087ooooo00Coof42
ooooooooooooof42<oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Oooooo00?o
of42ooooooooool03oooool00oooH@;oooooooooo`0Hooooo`03oomQ0_oooooooooo00gooooo00?o
of42ooooooooool0Eoooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo01Sooooo00?o
of42ooooooooool00_ooool00oooH@;oooooooooo`0`ooooo`03o`000?oooooooooo017ooooo000Y
ooooo`;o00001oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo01_ooooo00?oof42
ooooooooool02_ooool00oooH@;oooooooooo`22ooooo`03oomQ0_ooooooof4203;ooooo0_l0000M
ooooo`;o00002?ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo01Wooooo00?oof42
ooooooooool02oooool00oooH@;oooooooooo`1Iooooo`03oomQ0_oooooooooo00Oooooo00?oof42
ooooooooool06?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo02oooooo0_l0000C
ooooo`00:Oooool00ol0003oooooooooo`06ooooo`03oomQ0_oooooooooo00gooooo00?oof42oooo
ooooool07?ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo08?ooooo00?oof42oooo
ooooH@80<oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo00?oof42oooo
ooooool03Oooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo00_ooooo00?oof42oooo
ooooool0F_ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo01[ooooo00Goof42oooo
oooooooooooooomQ0P0booooo`03o`000?oooooooooo017ooooo000Yooooo`03o`000?oooooooooo
00Kooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`0Mooooo`03oomQ0_oooooooooo
00Oooooo00?oof42ooooooooool0Q?ooool2oomQ0SCooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`08ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool06oooool00ooo
H@;oooooooooo`09ooooo`03oomQ0_oooooooooo05_ooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooooooo`0Jooooo`Coof42<oooool00ol0003oooooooooo`0Aooooo`00:Oooool00ol0003o
ooooooooo`07ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool07Oooool00oooH@;o
ooooooooo`06ooooo`03oomQ0_oooooooooo08Kooooo00?oof42ooooooooool0<_ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo00?oof42ooooooooool03Oooool00oooH@;o
ooooooooo`0Kooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0G?ooool00oooH@;o
ooooooooo`04ooooo`03oomQ0_oooooooooo01gooooo00?oof42ooooooooool0<Oooool00ol0003o
ooooooooo`0Aooooo`00:Oooool2o`0000Sooooo00?oof42ooooooooool02oooool00oooH@;ooooo
ooooo`0Oooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool0^oooool2o`0001gooooo
0_l00009ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool07?ooool00oooH@;ooooo
ooooo`06ooooo`;oof42Goooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo057ooooo
0_l0000Cooooo`00:Oooool00ol0003oooooooooo`07ooooo`03oomQ0_oooooooooo00_ooooo00?o
of42ooooooooool08?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo0;gooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`03oomQ0_oooooooooo00cooooo00?o
of42ooooooooool07Oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo063ooooo0_oo
H@83ooooo`03oomQ0_oooooooooo05;ooooo00?o0000ooooooooool04Oooool002Wooooo00?o0000
ooooooooool01oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo027ooooo1?ooH@;0
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool00oooH@;oooooooooo`0<
ooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool00_ooool2oomQ0VGooooo00?oof42
ooooooooH@80EOooool00ol0003oooooooooo`0Aooooo`00:Oooool00ol0003oooooooooo`07oooo
o`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool0iOooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Sooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0Ooooo
o`Coof42J?ooool00oooH@;oooooooooo`1Dooooo`03o`000?oooooooooo017ooooo000Yooooo`;o
00002?ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo0>Cooooo0_l0000Mooooo`;o
00002Oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo0>7ooooo0_l0000Cooooo`00
:Oooool00ol0003oooooooooo`07ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0
i_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Wooooo00?oof42ooooooooool0
2_ooool00oooH@;oooooooooo`3Sooooo`03o`000?oooooooooo017ooooo000Pooooo`Go00001?oo
ool00ol0003oooooooooo`07ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0i_oo
ool00ol0003oooooooooo`0Booooo`Go00001?ooool00ol0003oooooooooo`09ooooo`03oomQ0_oo
oooooooo00[ooooo00?oof42ooooooooool0hoooool00ol0003oooooooooo`0Aooooo`008Oooool0
1?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000Oooooo00Goof42oooooooooooo
ooooo`000007ooooo`03oomQ0_oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00005Oooool01?l0
003oooooooooool00004ooooo`04o`000?ooooooooooo`0000Sooooo00Coof42oooooooooooo0000
2Oooool01?ooH@;oooooooooool0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooo`00000Cooooo`008_ooool00ol0003oooooooooo`04ooooo`_o0000
00?oof42o`000?l000002?l000000oooH@;o0000o`00003Xo`0001Kooooo00?o0000ooooooooool0
1?ooool<o`000003oomQ0_l0003o000000Wo000000?oof42o`000?l00000iOl0000Cooooo`008ooo
ool00ol0003oooooooooo`3ooooooacooooo00?o0000ooooooooool0oooooolGooooo`008?ooool0
1Ol0003ooooooooooooooooo00000?oooooo6_ooool01Ol0003ooooooooooooooooo00000?oooooo
6?ooool0023ooooo00Go0000ooooooooooooooooo`00003ooooooa[ooooo00Go0000oooooooooooo
ooooo`00003ooooooaSooooo000Qooooo`?o0000oooooolLooooo`?o0000oooooolIooooo`00oooo
oooooooooecooooo003oooooooooooooG?ooool00?oooooooooooomLooooo`00oooooooooooooeco
oooo003oooooooooooooG?ooool0037ooooo0_l0000/ooooo`Go0000;_ooool3o`0002gooooo0ol0
000^ooooo`?o0000:oooool3o`0000Cooooo0_l0000Uooooo`;o0000;?ooool5o`0002kooooo0ol0
000]ooooo`?o0000;_ooool3o`0002_ooooo0ol00004ooooo`;o00004_ooool0033ooooo00Co0000
oooooooooooo0000;?ooool01?l0003oooooooooool0000_ooooo`03o`000?oooooooooo02_ooooo
00Go0000ooooooooooooooooo`00000/ooooo`05o`000?ooooooooooooooool00000:oooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0002?ooooo00Co0000oooooooooooo0000;?oo
ool01?l0003oooooooooool0000_ooooo`03o`000?oooooooooo02_ooooo00Go0000oooooooooooo
ooooo`00000/ooooo`05o`000?ooooooooooooooool00000:oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`00017ooooo000`ooooo`04o`000?ooooooooooo`0002gooooo00?o0000
ooooooooool0;?ooool5o`0002cooooo00Go0000ooooooooooooooooo`00000/ooooo`05o`000?oo
ooooooooooooool00000:oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002?o
oooo00Co0000oooooooooooo0000;Oooool00ol0003oooooooooo`0/ooooo`Go0000;?ooool01Ol0
003ooooooooooooooooo000002cooooo00Go0000ooooooooooooooooo`00000[ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00004Oooool0033ooooo00Co0000oooooooooooo0000
;_ooool00ol0003oooooooooo`0[ooooo`04o`000?ooooooooooo`0002gooooo1?l0000^ooooo`?o
0000;?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002?ooooo00Co0000oooo
oooooooo0000;_ooool00ol0003oooooooooo`0[ooooo`04o`000?ooooooooooo`0002gooooo1?l0
000^ooooo`?o0000;?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00017ooooo
000`ooooo`04o`000?ooooooooooo`0002_ooooo00Go0000ooooooooooooooooo`00000]ooooo`03
o`000?oooooo000002gooooo00?o0000ooooooooool0;_ooool01Ol0003ooooooooooooooooo0000
02_ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Sooooo`04o`000?oooooo
ooooo`0002_ooooo00Go0000ooooooooooooooooo`00000]ooooo`03o`000?oooooo000002gooooo
00?o0000ooooooooool0;_ooool01Ol0003ooooooooooooooooo000002_ooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool0000Aooooo`00<?ooool01?l0003oooooooooool0000[oooo
o`05o`000?ooooooooooooooool00000;_ooool2o`0002kooooo00?o0000ooooooooool0;Oooool0
1Ol0003ooooooooooooooooo000002[ooooo0_l00004ooooo`04o`000?ooooooooooo`0002?ooooo
00Co0000oooooooooooo0000:oooool01Ol0003ooooooooooooooooo000002kooooo0_l0000^oooo
o`03o`000?oooooooooo02gooooo00Go0000ooooooooooooooooo`00000Zooooo`;o00001?ooool0
1?l0003oooooooooool0000Aooooo`00<Oooool2o`0002gooooo0ol0000`ooooo`03o`000?oooooo
oooo02gooooo0_l0000^ooooo`?o0000;?ooool00ol0003oooooooooo`03ooooo`;o00009Oooool2
o`0002gooooo0ol0000`ooooo`03o`000?oooooooooo02gooooo0_l0000^ooooo`?o0000;?ooool0
0ol0003oooooooooo`03ooooo`;o00004_ooool00?oooooooooooomLooooo`00oooooooooooooeco
oooo003oooooooooooooG?ooool00?oooooooooooomLooooo`00;oooooojo`0002Cooooon_l0000C
ooooo`00;oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooool000009?ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooool000004oooool002oooooo00Co0000oooooooooooo0000;oooool00ol0003ooooooooo
o`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003ooooooooo
o`0^ooooo`03o`000?oooooo000002Cooooo00Co0000oooooooooooo0000;oooool00ol0003ooooo
ooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003ooooo
ooooo`0^ooooo`03o`000?oooooo000001?ooooo000_ooooo`03o`000?oooooooooo0?Kooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo017ooooo000_
ooooo`;o0000moooool00ol0003oooooooooo`0Rooooo`;o0000m_ooool2o`0001?ooooo000_oooo
o`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3foooo
o`03o`000?oooooooooo017ooooo000_ooooo`03o`000?oooooooooo0?Kooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo017ooooo000_ooooo`03o`00
0?oooooooooo0?Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3fooooo`03o`00
0?oooooooooo017ooooo000_ooooo`;o0000moooool00ol0003oooooooooo`0Rooooo`;o0000m_oo
ool2o`0001?ooooo000_ooooo`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`3fooooo`03o`000?oooooooooo017ooooo000_ooooo`03o`000?oooooooooo
0?Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo
017ooooo000_ooooo`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`3fooooo`03o`000?oooooooooo017ooooo000_ooooo`;o0000moooool00ol0003ooooo
ooooo`0Rooooo`;o0000m_ooool2o`0001?ooooo000_ooooo`03o`000?oooooooooo0?Kooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo017ooooo000_
ooooo`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3f
ooooo`03o`000?oooooooooo017ooooo000_ooooo`;o0000moooool00ol0003oooooooooo`0Roooo
o`;o0000m_ooool2o`0001?ooooo000_ooooo`03o`000?oooooooooo0?Kooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo017ooooo000Fooooo`;o0000
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`00
0?oooooooooo0?Kooooo00?o0000ooooooooool02Oooool2o`0000Cooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`3fooooo`03o`00
0?oooooooooo017ooooo000Eooooo`04o`000?ooooooooooo`0000Wooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0m_ooool00ol0003o
ooooooooo`08ooooo`04o`000?ooooooooooo`0000Wooooo00Go0000ooooooooooooooooo`000003
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0A
ooooo`003_ooool5o`0000;ooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00;ooooo0ol0003eooooo`;o00000oooool5o`0000;ooooo00Co0000
oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0ol0
003eooooo`;o00004oooool001Gooooo00Co0000oooooooooooo00002_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0m_ooool00ol0003ooooooooo
o`08ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool04Oooool001Gooooo00Co
0000oooooooooooo00002oooool00ol0003oooooo`000003o`0000Gooooo00?o0000ooooooooool0
m_ooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooool0
00000ol00005ooooo`03o`000?oooooooooo00Cooooo00?oof42ooooooooool0koooool00ol0003o
ooooooooo`0Aooooo`005Oooool01?l0003oooooooooool00007ooooo`07o`000?oooooooooooooo
ool0003oooooo`000008ooooo`03o`000?oooooooooo00Cooooo1?ooH@;^ooooo`03o`000?oooooo
oooo00Sooooo00Co0000oooooooooooo00001oooool01ol0003ooooooooooooooooo0000ooooool0
00002?ooool00ol0003oooooooooo`03ooooo`;oof42lOooool00ol0003oooooooooo`0Aooooo`00
5_ooool2o`0000Sooooo1Ol000000ooooooo0000o`000003o`0000Cooooo0_l00004ooooo`05oomQ
0_ooooooooooooooooooH@80k_ooool00ol0003oooooooooo`09ooooo`;o00002?ooool5o`000003
ooooool0003o000000?o00001?ooool2o`0000?ooooo00Coof42ooooooooooooof42koooool2o`00
01?ooooo000_ooooo`03o`000?oooooooooo00;ooooo00?oof42ooooooooool00oooool00oooH@;o
ooooooooo`3[ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool00_ooool01OooH@;o
ooooooooooooooooof420>oooooo00?o0000ooooooooool04Oooool002oooooo00?o0000oooooooo
ool00_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo0>_ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`02ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooooooo
ool0k?ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`02ooooo`03oomQ
0_oooooooooo00Cooooo00?oof42ooooooooool0j_ooool00ol0003oooooooooo`0Rooooo`05o`00
0?ooooooooooooooooooH@801Oooool00oooH@;oooooooooo`3/ooooo`03o`000?oooooooooo017o
oooo000_ooooo`;o00000_ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo0>[ooooo
00?o0000ooooooooool08_ooool2o`0000;ooooo00?oof42ooooooooool00oooool00oooH@;ooooo
ooooo`3[ooooo`;o00004oooool002oooooo00Go0000oooooooooooooooooomQ0P07ooooo`03oomQ
0_oooooooooo0>[ooooo00?o0000ooooooooool08_ooool01Ol0003oooooooooooooooooof4200Ko
oooo00?oof42ooooooooool0joooool00ol0003oooooooooo`0Aooooo`00;oooool01Ol0003ooooo
ooooooooooooof4200Oooooo00?oof42ooooooooool0j_ooool00ol0003oooooooooo`0Rooooo`05
o`000?ooooooooooooooooooH@801_ooool00oooH@;oooooooooo`3[ooooo`03o`000?oooooooooo
017ooooo000_ooooo`05o`000?ooooooooooooooooooH@802?ooool00oooH@;oooooooooo`3Yoooo
o`03o`000?oooooooooo02;ooooo00Co0000ooooooooooooof421oooool00oooH@;oooooooooo`3[
ooooo`03o`000?oooooooooo017ooooo000_ooooo`;o000000?ooooooomQ0_ooool02?ooool00ooo
H@;oooooooooo`3Yooooo`03o`000?oooooooooo02;ooooo0_l000000oooooooof42ooooo`06oooo
o`03oomQ0_oooooooooo0>[ooooo0_l0000Cooooo`00;oooool01?l0003oooooooooooooH@89oooo
o`03oomQ0_oooooooooo0>Wooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`09oooo
o`03oomQ0_oooooooooo0>[ooooo00?o0000ooooooooool04Oooool002oooooo00?o0000oooooooo
ool02_ooool00oooH@;oooooooooo`3Yooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool02Oooool00oooH@;oooooooooo`3Zooooo`03o`000?oooooooooo017ooooo000_ooooo`03o`00
0?oooooooooo00[ooooo00?oof42ooooooooool0jOooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Wooooo00?oof42ooooooooool0j_ooool00ol0003oooooooooo`0Aooooo`00;ooo
ool2o`0000cooooo00?oof42ooooooooool0j?ooool00ol0003oooooooooo`0Rooooo`;o00000ooo
ool3o`3jVPCooooo00?oof42ooooooooool0jOooool2o`0001?ooooo000Looooo`;o00001?ooool0
0ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`03oomQ0_oooooo
oooo0>Sooooo00?o0000ooooooooool03oooool2o`0000Cooooo00?o0000ooooooooool00_ooool3
o`0000Gooooo00Co0000oooooooooooooooo1Ol0nYX4ooooo`03oomQ0_oooooooooo0>Wooooo00?o
0000ooooooooool04Oooool001_ooooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool00oooool3o`3jVPGooooo00?oof42ooooooooool0
/?ooool4oomQ0SCooooo00?o0000ooooooooool03_ooool01?l0003oooooooooool00007ooooo`05
o`000?ooooooooooooooool000001?ooool01?l0003oooooooooooooool2o`3jVP04ooooool0nY[o
0?ZJo`3jVP?ooooo00?oof42ooooooooool0jOooool00ol0003oooooooooo`0Aooooo`005?ooool5
o`0000;ooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooooooo`Go0?ZJ1Oooool00oooH@;oooooooooo`2_ooooo`05oomQ0_oooooooooooooooooo
H@80=?ooool00ol0003oooooooooo`07ooooo`Go00000_ooool01?l0003oooooooooool0000;oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooooooo0_l0nYX2ooooo`?o0?ZJ0_ooool0
0oooH@;oooooooooo`3Yooooo`03o`000?oooooooooo017ooooo000Kooooo`04o`000?oooooooooo
o`0000_ooooo00?o0000ooooooooool00_ooool3o`000003ooooool0nY[o0?ZJ00Co0?ZJ1?ooool0
0oooH@;oooooooooo`2^ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0<Oooool2
o`00013ooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`?o00000ol0
nYX3ooooo`;o0?ZJ0oooool00oooH@;oooooooooo`3Wooooo`;o00004oooool001_ooooo00Co0000
oooooooooooo00001oooool4o`0000Gooooo00Co0000oooooooooooooooo0_l0nYX2ooooo`?o0?ZJ
1?ooool00oooH@;oooooooooo`2]ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0
<_ooool00ol0003oooooooooo`0>ooooo`04o`000?ooooooooooo`0000Oooooo1?l00005ooooo`03
o`000?oooooooooo00;o0?ZJ1?ooool2o`3jVP?ooooo00?oof42ooooooooool0j?ooool00ol0003o
ooooooooo`0Aooooo`006oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool00ol0nYX3ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`2/ooooo`03
oomQ0_oooooooooo00?ooooo00?oof42ooooooooool0<_ooool00ol0003oooooooooo`0>ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02o`3j
VPCooooo0ol0nYX2ooooo`03oomQ0_oooooooooo0>Sooooo00?o0000ooooooooool04Oooool001co
oooo0_l00008ooooo`Go00001?ooool2o`000003ooooool0nY[o0?ZJ00Cooooo0_l0nYX4ooooo`03
oomQ0_oooooooooo02Gooooo1?ooH@:3ooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooooooo
ool0<_ooool00ol0003oooooooooo`0?ooooo`;o00002?ooool5o`0000Cooooo0_l000000ooooooo
0?ZJo`3jVP05ooooo`;o0?ZJ0oooool00oooH@;oooooooooo`0Uooooo`Coof42_Oooool2o`0001?o
oooo000_ooooo`03o`000?oooooooooo00;o0?ZJ1?ooool3o`3jVP?ooooo00?oof42ooooooooool0
8oooool2oomQ0PCooooo00?oof42ooooooooool0Ooooool00oooH@;oooooooooo`04ooooo`03oomQ
0_oooooooooo03;ooooo00?o0000ooooooooool08_ooool00ol0003oooooo`3jVP02o`3jVPGooooo
0_l0nYX3ooooo`03oomQ0_oooooooooo01cooooo1OooH@82ooooo`;oof421?ooool00oooH@;ooooo
ooooo`2kooooo`03o`000?oooooooooo017ooooo000_ooooo`05o`000?oooooo0000o`000?l0nYX0
1Oooool2o`3jVPCooooo00?oof42ooooooooool08?ooool2oomQ0PKooooo00?oof42ooooooooool0
Ooooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo03;ooooo00?o0000ooooooooool0
8_ooool01?l0003oooooo`000?l00006ooooo`?o0?ZJ0_ooool00oooH@;oooooooooo`0Kooooo`03
oomQ0_oooooooooo00?ooooo0_ooH@86ooooo`03oomQ0_oooooooooo0:oooooo1?ooH@88ooooo`03
o`000?oooooooooo017ooooo000_ooooo`Go00001Oooool2o`3jVPCooooo00?oof42ooooooooool0
7oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo07gooooo00?oof42ooooooooool0
1_ooool00oooH@;oooooooooo`0aooooo`03o`000?oooooooooo02;ooooo1Ol00004ooooo`;o003o
0_l0nYX2ooooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool03Oooool00oooH@;ooooo
ooooo`2]ooooo`05oomQ0_ooooooooooooooooooH@802?ooool00ol0003oooooooooo`0Aooooo`00
;oooool5o`0000Cooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`02ooooo`03oomQ0_oooooooooo01ko
oooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`1looooo`03oomQ0_oooooooooo00Ko
oooo00?oof42ooooooooool0<Oooool00ol0003oooooooooo`0Rooooo`Go00000oooool00ol00?oo
ooooooooo`02o`3jVP04o`00oooooooooooooomQ0Q_ooooo00?oof42ooooooooool03_ooool00ooo
H@;oooooooooo`1Dooooo`Goof42D_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo
00Cooooo0_l0000Cooooo`00;oooool01Ol0003oooooo`000?l0003ooooo00Co003o0_ooool2o`3j
VP05ooooool00?ooooooooooooooH@807_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooo
oooo07_ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Tooooo`Coof422Oooool0
0ol0003oooooooooo`0Rooooo`05o`000?oooooo0000o`000?ooool00ol00?l3ooooo`;o0?ZJ00Co
ooooo`00ooooooooof426_ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo05;ooooo
0_ooH@85ooooo`03oomQ0_oooooooooo04oooooo00?oof42ooooooooool01?ooool00oooH@;ooooo
ooooo`04ooooo`03o`000?oooooooooo017ooooo000_ooooo`03o`000?oooooooooo00;ooooo00?o
003oooooooooool00oooool2o`3jVP;ooooo00?o003oooooooooH@807?ooool2oomQ0Poooooo00?o
of42ooooooooool0G?ooool>oomQ0Poooooo00?oof42ooooooooool01oooool00oooH@;ooooooooo
o`0Sooooo`03oomQ0_oooooooooo00;ooooo0_ooH@87ooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool00_ooool00ol00?oooooooomQ0P03ooooo`?o0?ZJ00?oooooo`00ooooH@806_oo
ool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo04kooooo0oooH@88ooooo`;oof428?oo
ool4oomQ0R[ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`04ooooo`03o`000?oo
oooooooo017ooooo000_ooooo`05o`000?ooooooooooooooool00?l01_ooool3o`3jVP05ooooool0
0?ooooooooooooooH@806_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo02Sooooo
0oooH@8[ooooo`Goof423Oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00Oooooo
00?oof42ooooooooool08_ooool00oooH@;oooooooooo`05ooooo`;oof421Oooool00ol0003ooooo
ooooo`0Rooooo`09o`000?ooooooooooooooool00?oooooooomQ0_ooooooof4200?ooooo0_l0nYX0
0ooooooo003ooomQ0P0Iooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool0:Oooool6
oomQ0Qcooooo0_ooH@8=ooooo`03oomQ0_oooooooooo01gooooo00Coof42ooooooooooooof42:Ooo
ool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00?ooooo00?o0000ooooooooool04Ooo
ool002oooooo0_l00002ooooo`03o`00oooooooooooo00Gooooo0_l0nYX00ooooooo003oooooo`02
ooooo`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0W
ooooo`04oomQ0_ooooooooooooooo`?oof429_ooool2oomQ0Q;ooooo00?oof42ooooooooool03Ooo
ool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo027ooooo00?oof42ooooooooool02?oo
ool00oooH@;oooooooooo`02ooooo`03o`000?oooooooooo02;ooooo0_l00002ooooo`03o`00oooo
H@;ooooo00;ooooo00?oof42ooooooooool00_l0nYX00ooooooo003ooomQ0P0Iooooo`03oomQ0_oo
oooooooo01?ooooo00?oof42ooooooooool05oooool5oomQ0P_ooooo00?oof42ooooooooool01?oo
ool00oooH@;oooooooooo`0Fooooo`?oof424?ooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oo
oooooooo00;ooooo00?oof42ooooooooool09Oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oo
oooooooo00;ooooo0_l0000Cooooo`00;oooool01?l0003oooooooooool00?l8ooooo`?o0?ZJ00?o
003oooooooooool00_ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo00Cooooo0_l0
000<ooooo`03oomQ0_oooooooooo02Gooooo00?oof42ooooooooool01Oooool00oooH@;ooooooooo
o`0Pooooo`?oof425?ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Sooooo00?o
of42ooooooooool08?ooool00oooH@;oooooooooo`0:ooooo`05oomQ0_ooooooooooooooool00000
9?ooool01_l0003oooooooooool00?oooooooomQ0PCooooo00?oof42ooooool0nYX00_l0nYX00ol0
0?oooooooomQ0P0Gooooo`03oomQ0_oooooooooo00Kooooo0_l0000<ooooo`03oomQ0_oooooooooo
01Kooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo
00Gooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo
01_ooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0Uooooo`03oomQ0_oooooooooo
00Wooooo00?oof42ooooooooool00_ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003o
ooooooooo`02ooooo`Coof421?ooool01?l0nY[o0000o`000?l00?l3ooooo`03oomQ0_oooooooooo
01Cooooo00?oof42ooooooooool01?ooool4o`0000_ooooo00?oof42ooooooooool07Oooool2oomQ
0PGooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0Jooooo`Goof425oooool00ooo
H@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool08?ooool00ooo
H@;oooooooooo`0:ooooo`05oomQ0_ooooooooooooooool000009?ooool00ol0003oooooooooo`02
ooooo`03oomQ0_oooooooooo00;ooooo00Coof42oooooooooooo0?ZJ0_l000000ol00?ooof42oooo
o`0Fooooo`03oomQ0_oooooooooo00Gooooo1?l0000<ooooo`03oomQ0_oooooooooo01Cooooo00?o
of42ooooooooool01Oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Kooooo00?o
of42ooooooooool04oooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo01Wooooo00?o
of42ooooooooool01?ooool00oooH@;oooooooooo`0Sooooo`03oomQ0_oooooooooo00_ooooo00Go
of42ooooooooooooooooo`00000Cooooo`00;oooool00ol0003oooooooooo`02ooooo`04oomQ0_oo
oooooooooomQ0PCooooo1?l00004ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool0
1Oooool4o`0000cooooo00?oof42ooooooooool05oooool5oomQ0P03ooooooooH@;ooooo00;ooooo
0_ooH@8;ooooo`03oomQ0_oooooooooo01;ooooo1oooH@8Looooo`03oomQ0_oooooooooo00cooooo
00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo00cooooo
00Coof42oooooooooooo00009?ooool01Ol0003oooooooooooooooooof4200Kooooo00?oof42oooo
ool000000ol000000oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo00Gooooo1?l0000<oooo
o`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`04oooo
o`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0Doooo
o`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0Soooo
o`03oomQ0_oooooooooo00cooooo00Coof42oooooooooooo00004oooool002oooooo0_l00003oooo
o`04oomQ0_oooooooooooomQ0PCooooo1?l00005ooooo`03oomQ0_oooooooooo017ooooo00?oof42
ooooooooool01_ooool2o`0000kooooo00?oof42ooooooooool04_ooool4oomQ0POooooo00?oof42
ooooooooH@803_ooool00oooH@;oooooooooo`0?ooooo`;oof428oooool00oooH@;oooooooooo`0<
ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool07oooool00oooH@;oooooooooo`0=
ooooo`03oomQ0_oooooo000002Cooooo0_l00002ooooo`03oomQ0_oooooooooo00Cooooo00?oof42
ooooool000000ol000000oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00Oooooo0_l0000>
ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool02?ooool01?ooH@;ooooooooooooo
ool2oomQ0P_ooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oo
oooooooo01Sooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Rooooo`03oomQ0_oo
oooooooo00gooooo00?oof42o`000?l000004oooool001Kooooo0_l00004ooooo`04o`000?oooooo
ooooooooo`Go00000_ooool3o`0000Gooooo00Go0000oooooooooooooooooomQ0P04ooooo`03oomQ
0_oooooooooo00;ooooo0_l000000ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00oooooo
00?oof42ooooooooool06?ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00[ooooo
00?oof42ooooooooool03_ooool3oomQ0Pgooooo00?oof42ooooooooool08oooool00oooH@;ooooo
ooooo`0;ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool07Oooool2oomQ0Q;ooooo
00?o0000ooooooooool02Oooool2o`0000Cooooo00Co0000oooooooooooooooo1Ol00002ooooo`?o
00001Oooool01Ol0003oooooooooooooooooof4200Kooooo00?oof42ooooooooool00_l000000ol0
0?oooooooomQ0P0Eooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool04Oooool00ooo
H@;oooooooooo`0:ooooo`03oomQ0_ooooooof4200kooooo00?oof42ooooooooool03_ooool00ooo
H@;oooooooooo`0Gooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool01_ooool00ooo
H@;oooooooooo`0Qooooo`03oomQ0_oooooooooo013ooooo00?o0000ooooooooool04Oooool001Go
oooo00Co0000oooooooooooo00002?ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o
0000ooooooooool00_ooool01Ol0003oooooooooooooooooof4200Cooooo00?oof42ooooooooool0
0_ooool2o`3jVP03o`00oooooooooooo00Gooooo00?oof42ooooooooool03_ooool00oooH@;ooooo
ooooo`06ooooo`?o0?ZJ4?ooool00oooH@;oooooooooo`0=ooooo`;oof428Oooool2oomQ0P[ooooo
00?oof42ooooooooool09Oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00Wooooo
00?oof42ooooooooool05?ooool00oooH@;oooooooooo`04ooooo`;o00002?ooool2o`00o`[ooooo
00?o0000ooooooooool02?ooool01?l0003oooooooooool00008ooooo`06o`000?ooooooooooo`00
0?oooooo00000oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooooooH@801ooo
ool01oooH@;oooooo`3jV_l0nY[o003oooooooooH@805Oooool00oooH@;oooooooooo`06ooooo`Co
0?ZJ3_ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00cooooo00?oof42oooooooo
ool03_ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo01Sooooo00?oof42oooooooo
ool05_ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo01cooooo0_l00002ooooo`03
oomQ0_oooooooooo00Cooooo0_l00?l:ooooo`03o`000?oooooooooo017ooooo000>ooooo`Go0000
0_ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool00_ooool01Ol0003oooooooooooooooooof4200Cooooo00?oof42ooooooooool00_ooool3o`3j
VP03o`00oooooooooooo00Gooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`07oooo
o`Co0?ZJ4?ooool00oooH@;oooooooooo`09ooooo`?oof429Oooool00oooH@;oooooooooo`07oooo
o`03oomQ0_oooooooooo02Gooooo00?oof42ooooooooool02_ooool2o`0000[ooooo00?oof42oooo
ooooool05?ooool00oooH@;oooooooooo`03ooooo`Co00001oooool00ol00?ooooooo`00o`09oooo
o`04o`000?ooooooooooooooo`Go00000_ooool01?l0003oooooooooool00009ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooH@88ooooo`07oomQ
0_oooooo0?ZJo`3jV_oooooo003ooomQ0P0Dooooo`03oomQ0_oooooooooo00Kooooo1_l0nYX>oooo
o`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool07_ooool00oooH@;oooooooooo`0<oooo
o`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool05_ooool00oooH@;o0000o`000008oooo
o`03oomQ0_oooooooooo01_ooooo1?l000000oooH@;oooooooooo`05ooooo`03o`00oooooooo003o
00Wooooo00?o0000ooooooooool04Oooool001Gooooo00Co0000oooooooooooo00002_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0ol000000oooH@;oooooooooo`04oooo
o`03oomQ0_oooooooooo00;ooooo0_l0nYX00ol00?ooooooooooo`05ooooo`03oomQ0_oooooooooo
00cooooo00?oof42ooooooooool01oooool5o`3jVQ3ooooo0_ooH@87ooooo`;oof42:?ooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo02Kooooo00?oof42ooooooooool02Oooool4o`00
0004ooooool0nY[o0?ZJo`3jVPGooooo00?oof42ooooooooool04oooool2oomQ0PGooooo1?l00006
ooooo`05o`00ooooooooooooooooool00?l01oooool2o`0000[ooooo00Co0000oooooooooooo0000
2_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0ol000000oooH@;ooooo
ooooo`06ooooo`08oomQ0_oooooo0?ZJo`3jV_oooooo003oooooooooH@8Cooooo`03oomQ0_oooooo
oooo00Kooooo0_l0nYX2ooooo`?o0?ZJ3_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooo
oooo023ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooo
oooo01Gooooo1?l00007ooooo`03oomQ0_oooooooooo01_ooooo1?l00007ooooo`05o`00oooooooo
ooooooooool00?l01oooool2o`0001?ooooo000Eooooo`04o`000?ooooooooooo`0000Oooooo00Ko
0000ooooooooooooooooo`000?ooool4o`0000Gooooo00Co0000ooooooooooooof421_ooool00ooo
H@;oooooooooo`02ooooo`;o0?ZJ00?o003oooooooooool01Oooool00oooH@;oooooooooo`0<oooo
o`03oomQ0_oooooooooo00Oooooo0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`Ooof426oooool3o`00
o`cooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Vooooo`03oomQ0_oooooooooo
00Wooooo1?l00005o`3jVPGooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`08oooo
o`03oomQ0_ooooooof4200Gooooo0_l00007ooooo`05o`00ooooooooooooooooool00?l02?ooool0
0ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000Oooooo00Ko0000oooooooooooooooo
o`000?ooool4o`0000Gooooo00?o0000ooooooooool02_ooool01oooH@;o0?ZJo`3jV_l0nY[o003o
ooooooooH@804oooool00oooH@;oooooooooo`05ooooo`?o0?ZJ0oooool2o`3jVPoooooo00?oof42
ooooooooool02Oooool00oooH@;oooooooooo`0Fooooo`?o003o2Oooool00oooH@;oooooooooo`09
ooooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool05?ooool00oooH@;o0000o`000002
o`0000Sooooo00?oof42ooooooooool06oooool2o`000003oomQ0_oooooooooo00Gooooo00Go003o
ooooooooooooooooo`00o`08ooooo`03o`000?oooooooooo017ooooo000Eooooo`04o`000?oooooo
ooooo`0000Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000Sooooo00?o0000oooooooo
ool01oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?o003oooooooooool01Oooool00oooH@;o
ooooooooo`0;ooooo`03oomQ0_oooooooooo00Oooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYXboooo
o`04o`00ooooooooooooooooo`Co003o2Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooo
oooo02Oooooo00?oof42ooooooooool02Oooool00oooH@;o0000o`000003o`3jVP03ooooool0nY[o
0?ZJ00;o0?ZJ0oooool00oooH@;oooooooooo`06ooooo`;oof422_ooool00oooH@;ooooooomQ0P04
ooooo`03oomQ0_oooooooooo00Gooooo0_l00?l5ooooo`03o`00oooooooooooo00Gooooo00?o0000
ooooooooool02?ooool01?l0003oooooooooool00007ooooo`07o`000?ooooooooooooooool0003o
ooooo`000008ooooo`03o`000?oooooooooo00[ooooo00Ooof42ooooool0nY[o0?ZJo`00oooooooo
of4201;ooooo00?oof42ooooooooool01_ooool2o`3jVPCooooo0ol0nYX?ooooo`03oomQ0_oooooo
oooo00Kooooo0_ooH@8Hooooo`04o`00ooooooooooooooooo`Co003o1_ooool00oooH@;ooooooooo
o`07ooooo`03oomQ0_oooooooooo01_ooooo00?oof42ooooooooool05?ooool01?ooH@;oooooo`00
0?l00009ooooo`03oomQ0_oooooooooo01cooooo00?oof42ooooooooool01?ooool2o`00o`Gooooo
00?o003oooooooooool01Oooool00ol0003oooooooooo`0Aooooo`005_ooool2o`0000Wooooo0ol0
0002ooooo`Go00001?ooool00ol0003oooooooooo`07ooooo`03oomQ0_oooooooooo00;ooooo0ol0
nYX00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01ooo
ool2o`3jVP?ooooo0_l0nYX^ooooo`Co003o1oooool00ol00?ooooooooooo`07ooooo`03oomQ0_oo
oooooooo00Cooooo00?oof42ooooooooool09oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oo
oooooooo00;o0?ZJ0oooool4o`3jVP;ooooo00?oof42ooooooooool01Oooool00oooH@;ooooooomQ
0P09ooooo`04oomQ0_oooooooooooomQ0PCooooo00?oof42ooooooooool00oooool2o`00o`Oooooo
00?o003oooooooooool01Oooool00ol0003oooooooooo`09ooooo`;o00002Oooool3o`0000;ooooo
1Ol00004ooooo`03o`000?oooooooooo00[ooooo00Soof42ooooool0nY[o0?ZJooooool00?oooooo
oomQ0Q7ooooo00?oof42ooooooooool01Oooool3o`3jVPGooooo0_l0nYX@ooooo`03oomQ0_oooooo
oooo00Cooooo00?oof42ooooooooool05?ooool4o`00o`Oooooo00?o003oooooooooool01?ooool0
0oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo01cooooo00?oof42ooooooooool04oooool0
0oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01cooooo00?oof42ooooooooool00_ooool2
o`00o`Oooooo00?o003oooooooooool01Oooool00ol0003oooooooooo`0Aooooo`00;oooool2o`00
00Wooooo00?oof42ooooooooool00_ooool2o`3jVP03o`00oooooooooooo00Cooooo00?oof42oooo
ooooool02oooool00oooH@;oooooooooo`05ooooo`;o003o0_l0nYX3ooooo`?o0?ZJ;?ooool00ol0
0?ooooooooooo`0:ooooo`03o`00oooooooooooo00Kooooo00?oof42ooooooooool00oooool00ooo
H@;oooooooooo`0Xooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooool0nYX00_l0nYX5oooo
o`?o0?ZJ00?ooooooomQ0_ooool01Oooool01?ooH@;oooooooooooooH@89ooooo`04oomQ0_oooooo
oooooomQ0PCooooo00?oof42ooooooooool00oooool00ol00?ooooooooooo`06ooooo`03o`00oooo
oooooooo00;ooooo0_l000000ooooooo0000ooooo`0Sooooo`;o00003?ooool01oooH@;o0?ZJo`3j
V_oooooo003oooooooooH@804Oooool00oooH@;oooooooooo`05ooooo`;o0?ZJ00?o003ooooooooo
ool00oooool3o`3jVQ3ooooo0oooH@800oooooooof42oomQ0P0Fooooo`03o`00oooooooooooo00[o
oooo00?o003oooooooooool01?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo01go
oooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`02ooooo`Co0?ZJ1_ooool00oooH@;o
ooooooooo`0Jooooo`03oomQ0_oooooooooo00?ooooo00?o003oooooooooool01_ooool00ol00?oo
ooooooooo`02ooooo`Co00004oooool002oooooo00?o0000ooooooooool02?ooool00oooH@;ooooo
ooooo`02ooooo`;o0?ZJ00?o003oooooooooool01?ooool00oooH@;oooooooooo`0:ooooo`03oomQ
0_oooooooooo00Kooooo00Co003oooooool0nY[o0?ZJ1?ooool2o`3jVR_ooooo00?o003ooooooooo
ool02oooool00ol00?ooooooooooo`07ooooo`05oomQ0_ooooooooooooooooooH@80:oooool00ooo
H@;oooooooooo`08ooooo`03oomQ0_oooooooooo00;o0?ZJ1oooool2o`3jVP03ooooooooH@;ooooo
00Gooooo00Coof42ooooooooooooof422Oooool01OooH@;oooooooooooooooooof4200?ooooo00?o
of42ooooooooool00_ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo00Go00009?oo
ool00ol0003oooooooooo`0;ooooo`07oomQ0_l0nY[o0?ZJooooool00?oooooooomQ0P0Aooooo`03
oomQ0_oooooooooo00Cooooo0ol0nYX00ooooooo003oo`00o`04ooooo`;o0?ZJ4oooool00oooH@;o
ooooooooo`0Eooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01?ooool00oooH@;o
ooooooooo`04ooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool04_ooool01?ooH@;o
ooooooooooooool6o`3jVPGooooo00?oof42ooooooooool06_ooool01?ooH@;oooooooooooooool5
o`3jVPOooooo00?o003oooooooooool01Ol0000Cooooo`00;oooool00ol0003oooooooooo`08oooo
o`03oomQ0_oooooooooo00;ooooo0ol0nYX00ol00?ooooooooooo`03ooooo`03oomQ0_oooooooooo
00[ooooo00?oof42ooooooooool01Oooool00ol00?ooooooooooo`02o`3jVP;o003o0_ooool3o`3j
VRWooooo0_l0000=ooooo`03o`00oooooooooooo00Oooooo00Goof42oooooooooooooooooomQ0P0[
ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooool0nYX00_l0nYX7ooooo`;o0?ZJ00?ooooo
oomQ0_ooool01?ooool01OooH@;oooooooooooooooooof4200Sooooo00?oof42ooooooooool00_oo
ool01OooH@;oooooooooooooooooof4200?ooooo00?o003oooooooooool02Oooool00ol00?oooooo
ooooo`05o`0002Cooooo00?o0000ooooooooool02oooool01oooH@;o0?ZJo`3jV_l0nY[oooooo`00
ooooH@804Oooool00oooH@;oooooooooo`04ooooo`;o0?ZJ1?ooool2o`00o`;ooooo0ol0nYXYoooo
o`;o00003Oooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00Cooooo00?oof42oooo
ooooool07oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00?o0?ZJ0_ooool2o`3j
VPGooooo00?oof42ooooooooool06Oooool01?ooH@;oooooooooooooool=o`3jVP03o`00oooooooo
oooo00Go00004oooool002oooooo00?o0000ooooooooool02?ooool00oooH@;oooooooooo`03oooo
o`;o0?ZJ00?o003oooooooooool00oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo
00Gooooo00?o003oooooooooool00_l0nYX2ooooo`03o`00oooooooooooo00?o0?ZJ9oooool4o`00
00gooooo00?o003oooooooooool01_ooool01?ooH@;oooooooooooooH@8/ooooo`03oomQ0_oooooo
oooo00Sooooo00Coof42ooooool0nY[o0?ZJ2?ooool2o`3jVP03ooooooooH@;oof4200?ooooo00?o
of42ooooooooool00oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00;ooooo00Co
of42ooooooooooooof420_ooool6o`3jVPSooooo00Co003ooooooooooooooooo0_l000000ooooooo
0000ooooo`0Sooooo`03o`000?oooooooooo00cooooo00Koof42o`3jV_l0nY[oooooo`00ooooH@8@
ooooo`03oomQ0_oooooooooo00Cooooo0ol0nYX6ooooo`03o`00oooooooooooo00?o0?ZJ9oooool4
o`0000gooooo00?o003oooooooooool01?ooool2oomQ0P?ooooo00?oof42ooooooooool08?ooool0
0oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00;o0?ZJ0oooool3o`3jVPGooooo00?oof42
ooooooooool06?ooool00oooH@;oooooooooo`03o`3jVP?ooooo3?l0nYX2o`000003ooooool0003o
oooo01;ooooo000_ooooo`;o00002Oooool01_ooH@;oooooooooooooooooof42ooooo`;o0?ZJ00?o
003oooooooooool01?ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00Cooooo00Co
003ooooooooooooooooo0_l0nYX3ooooo`03o`00oooooooooooo00;o0?ZJ9oooool4o`0000gooooo
00?o003oooooooooool01oooool2oomQ0P03o`00oooooooooooo02[ooooo00?oof42ooooooooool0
2?ooool01?ooH@;oooooo`3jV_l0nYX2o`00o`Kooooo0_l0nYX3ooooo`03oomQ0_ooooooof4200Ko
oooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`03ooooo`04oomQ0_oooooooooooomQ
0P?o0?ZJ0_l00004o`3jVPSooooo00?o003oooooooooool00oooool00ol0003oooooooooo`0Roooo
o`;o00003Oooool01oooH@;o0?ZJo`3jV_oooooo003oooooooooH@803oooool00oooH@;ooooooooo
o`04ooooo`;o0?ZJ2?ooool00ol00?ooooooooooo`02o`3jVROooooo1?l0000=ooooo`03o`00oooo
oooooooo00Kooooo00Coof42o`00ooooH@;o003o8_ooool00oooH@;oooooooooo`0Aooooo`03oomQ
0_oooooo0?ZJ00;o0?ZJ0_l00?l2ooooo`;o0?ZJ1Oooool00oooH@;oooooooooo`0Gooooo`03oomQ
0_oooooooooo00;o0?ZJ0_l0000:ooooo`Ko0?ZJ00?oooooo`000?l000004oooool002oooooo00?o
0000ooooooooool02Oooool01OooH@;ooooooomQ0_ooH@;ooooo00?o0?ZJ00?o003oooooooooool0
0oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00Gooooo00?o003oooooooooool0
0ol0nYX4ooooo`03o`00oooooooo0?ZJ00;o0?ZJ9oooool2o`0000kooooo00?o003oooooooooool0
1oooool00oooH@;oooooo`00o`0/ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0
0_l0nYX00ooooooo003oooooo`05ooooo`?o0?ZJ0oooool00oooH@;oooooooooo`05ooooo`03oomQ
0_oooooooooo00Cooooo00?oof42ooooooooool00oooool01?ooH@;oooooooooooooH@82o`3jVPCo
000000Coooooo`3jV_l0nY[o0?ZJ2?ooool01_l00?ooooooo`3jV_l0nY[oooooo`0002Cooooo00?o
0000ooooooooool03?ooool00oooH@;o0?ZJo`3jVP02ooooo`03o`00ooooH@;ooooo00kooooo00?o
of42ooooooooool00oooool3o`3jVPWooooo00?o003oooooool0nYX00_l0nYXWooooo`;o00003_oo
ool00ol00?ooooooooooo`07ooooo`03oomQ0_oooooo003o02?ooooo00?oof42ooooooooool03ooo
ool00oooH@;oooooooooo`02o`3jVP03o`00oooooooo003o00;ooooo0ol0nYX4ooooo`03oomQ0_oo
oooooooo01Oooooo00Coof42ooooool0nY[o0?ZJ1?l0000;ooooo`03o`00oooooooo0?ZJ00;o0?ZJ
00?oooooo`000?ooool04_ooool002oooooo00?o0000ooooooooool02Oooool2oomQ0P04oooooooo
H@;oooooooooo`;o0?ZJ00?o003oooooooooool00oooool00oooH@;oooooooooo`08ooooo`03oomQ
0_oooooooooo00Gooooo00?o003oooooooooool00_l0nYX00oooooooof42ooooo`03ooooo`04o`00
oooooooo0?ZJo`3jVRKooooo00?o003oo`3jV_l0nYX00_l0nYX=ooooo`03o`00oooooooooooo00Go
oooo00Go003oooooooooooooooooo`00o`0[ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooo
ool0nYX00_l0nYX2ooooo`03o`00oooooooooooo00Cooooo0_l0nYX;ooooo`03oomQ0_oooooooooo
00Cooooo00?oof42ooooooooool01?ooool2oomQ0P03ooooool0nY[o0?ZJ00Co00000_ooool2o`3j
VPSooooo00Ko003oooooool0nY[o0?ZJooooool0000Tooooo`03o`000?oooooooooo00cooooo00?o
of42o`3jV_l0nYX00_ooool00ol00?ooof42ooooo`0>ooooo`03oomQ0_oooooooooo00?ooooo0_l0
nYX00ol00?ooooooooooo`03ooooo`03oomQ0_oooooooooo00;ooooo00Co003oooooool0nY[o0?ZJ
9_ooool5o`3jVPgooooo00?o003oooooooooool01Oooool01Ol00?oooooooooooooooooo003o02;o
oooo00?oof42ooooooooool03oooool00oooH@;oooooo`3jVP02o`3jVP04o`00ooooooooooooo`00
o`;ooooo0_l0nYX5ooooo`03oomQ0_oooooooooo01Kooooo00Coof42ooooool0nY[o0?ZJ1?l0000;
ooooo`03o`00oooooooooooo00;o0?ZJ00?oooooo`000?ooool04_ooool002oooooo0_l0000:oooo
o`04oomQ0_oooooooooooomQ0P;ooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03oomQ0_oooooo
oooo00Sooooo00?oof42ooooooooool01?ooool01?l00?ooooooooooooooool2o`3jVP03oooooooo
H@;ooooo00?ooooo00?o003oooooool0nYX00_l0nYXUooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ3Ooo
ool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool0:?oo
ool00oooH@;oooooooooo`07ooooo`04oomQ0_oooooo0?ZJo`3jVPCooooo00?o003oooooooooool0
0oooool2o`3jVP_ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`05ooooo`03oomQ
0_oooooo0?ZJ00;o0?ZJ00?oooooo`000?l000000oooool3o`3jVPSooooo00Go003oo`3jV_l0nY[o
ooooo`00000Tooooo`;o00003Oooool01oooH@;o0?ZJo`3jV_l0nY[oooooo`00ooooH@803oooool0
0oooH@;oooooooooo`03ooooo`;o0?ZJ1_ooool00oooH@;oooooooooo`02ooooo`03o`00oooooooo
0?ZJ00;o0?ZJ8oooool8o`3jVPgooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`03
ooooo`03o`00oooooooooooo01oooooo00?oof42ooooooooool03oooool01OooH@;oooooo`3jV_l0
nY[o003o00Cooooo00?o003oooooool0nYX00_l0nYX5ooooo`03oomQ0_oooooooooo01Cooooo00?o
of42ooooool0nYX00_l0nYX00ooooooo0000o`00000=ooooo`04o`00ooooooooooooooooo`;o0000
4oooool002oooooo00?o0000ooooooooool03Oooool00oooH@;oooooo`3jVP02o`3jVPGooooo00?o
of42ooooooooool01oooool00oooH@;oooooooooo`05ooooo`03o`00oooooooooooo00?o0?ZJ00?o
oooooomQ0_ooH@801?ooool01?l00?ooooooo`3jV_l0nYXUooooo`04o`00ool0nY[o0?ZJooooo`?o
0?ZJ3Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o003ooooooooo
ool09oooool00oooH@;oooooooooo`07ooooo`04oomQ0_oooooo0?ZJo`3jVPGooooo00?o003ooooo
ooooool00_ooool2o`3jVP_ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`07oooo
o`;o0?ZJ2?ooool3o`3jVPOooooo00Go003oo`3jV_l0nY[oooooo`00000Tooooo`03o`000?oooooo
oooo00gooooo00Koof42o`3jV_l0nY[oooooo`00ooooH@8>ooooo`03oomQ0_oooooooooo00?ooooo
0ol0nYX5ooooo`03oomQ0_ooooooof4200Cooooo00Co003oooooool0nY[o0?ZJ8_ooool4o`3jVP?o
oooo0ol0nYX=ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool01?ooool00ol00?oo
ooooooooo`0Oooooo`03oomQ0_oooooooooo00kooooo00Goof42ooooool0nY[o0?ZJo`00o`05oooo
o`03o`00oooooooo0?ZJ00;o0?ZJ1Oooool00oooH@;oooooooooo`0Cooooo`04oomQ0_oooooo0?ZJ
o`3jVQ7ooooo00?o003oooooooooool00_ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0
003oooooooooo`0=ooooo`03oomQ0_oooooooooo00;o0?ZJ00?o003oooooooooool00_ooool00ooo
H@;oooooooooo`07ooooo`03oomQ0_oooooooooo00Gooooo00?o003oooooool0nYX00ol0nYX01?oo
ooooof42ooooooooH@83ooooo`04o`00oooooooo0?ZJo`3jVRCooooo00Co003oooooool0nY[o0?ZJ
0_ooool3o`3jVPgooooo00Co003oooooool00?oo003o1oooool00ol00?ooooooooooo`0Xooooo`03
oomQ0_oooooooooo00Kooooo00Coof42ooooool0nY[o0?ZJ1Oooool00ol00?ooooooooooo`02oooo
o`;o0?ZJ2oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Sooooo0_l0nYX9oooo
o`?o0?ZJ1_ooool3o`3jVP03ooooool0003ooooo02?ooooo00?o0000ooooooooool03Oooool00ooo
H@;o0?ZJo`3jVP02ooooo`03o`00ooooH@;ooooo00cooooo00?oof42ooooooooool00oooool2o`3j
VP03o`00oooooooooooo00;ooooo00Goof42oooooooooooooooooomQ0P03ooooo`04o`00oooooooo
0?ZJo`3jVR7ooooo0ol0nYX00ol00?ooooooooooo`03ooooo`Co0?ZJ3?ooool01?l00?ooooooo`00
ool00?l7ooooo`03o`00oooooooooooo01oooooo00?oof42ooooooooool03Oooool00oooH@;ooooo
o`3jVP02o`3jVP03o`00oooooooooooo00?ooooo00?o003oooooooooool00_l0nYX6ooooo`03oomQ
0_oooooooooo017ooooo00?oof42ooooooooool00_l0nYXBooooo`05o`00ooooooooooooooooool0
00004oooool002oooooo00?o0000ooooooooool03Oooool00oooH@;oooooooooo`02o`3jVP03o`00
oooooooooooo00;ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`05ooooo`03o`00
oooooooo0?ZJ00;o0?ZJ0oooool00oooH@;ooooooomQ0P04ooooo`04o`00ool0nY[o0?ZJo`3jVR?o
oooo00Co003oo`3jV_l0nY[o0?ZJ0oooool3o`3jVPgooooo00?o003oooooooooool02?ooool00ol0
0?ooooooooooo`02o`00o`Gooooo1Ol00?lKooooo`03oomQ0_oooooooooo00Gooooo00?oof42oooo
ooooool00_l0nYX6ooooo`04o`00ooooooooooooooooo`;o0?ZJ2oooool00oooH@;oooooooooo`02
ooooo`03oomQ0_oooooooooo00Oooooo0_l000000ol0nY[oooooooooo`08ooooo`?o0?ZJ1Oooool2
o`3jVP;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0=ooooo`07oomQ0_l0nY[o
0?ZJo`3jV_oooooo003ooomQ0P0=ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX5ooooo`05oomQ
0_ooooooooooooooooooH@801?ooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`;o0?ZJ00?oooooo`00
ooooool01Oooool4o`3jVPcooooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`02o`00
o`Gooooo1Ol00?lBooooo`03oomQ0_oooooooooo00gooooo00Goof42ooooool0nY[o0?ZJo`00o`07
ooooo`03o`00oooooooo0?ZJ00;o0?ZJ1_ooool00oooH@;oooooooooo`0@ooooo`05oomQ0_oooooo
0000o`000?l0nYX04oooool01?l00?ooooooooooool0000Cooooo`00;oooool2o`0000kooooo00?o
of42ooooooooool00ol0nYX4ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01Ooo
ool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`04oomQ0_oooooooooooomQ0P?ooooo00Co003oooooool0
nY[o0?ZJ8oooool00ol00?oo0?ZJo`3jVP05ooooo`?o0?ZJ6?ooool2o`00o`;ooooo00?o003ooooo
ool00?l00_l00?l5ooooo`03o`00oooooooooooo01Sooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooooooo`02o`3jVPKooooo00Co003ooooooooooooooooo0_l0nYX;ooooo`03oomQ0_oooooo
oooo00;ooooo00?oof42ooooooooool01_ooool4o`0000_ooooo0ol0nYX4ooooo`;o0?ZJ0_ooool0
0ol0003oooooooooo`0Rooooo`;o00003_ooool01oooH@;oooooo`3jV_l0nY[oooooo`00ooooH@80
3?ooool00oooH@;oooooooooo`04ooooo`;o0?ZJ1Oooool00oooH@;oooooooooo`02ooooo`06oomQ
0_ooooooooooooooool00?oooooo0_l0nYXOooooo`?o0?ZJ00?oooooo`00ooooool01oooool3o`3j
VQOooooo0_l00?l2ooooo`03o`00oooooooo003o00;o003o1Oooool00ol00?ooooooooooo`0?oooo
o`03oomQ0_oooooooooo00gooooo00Goof42ooooool0nY[o0?ZJo`00o`07ooooo`03o`00oooooooo
oooo00;o0?ZJ1_ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooo000000?o00004oooool0
1?l00?ooooooo`000?l0000Cooooo`00;oooool00ol0003oooooooooo`0=ooooo`04oomQ0_oooooo
ooooooooo`;o0?ZJ00Go003ooooooooooooooooooomQ0P08ooooo`03oomQ0_oooooooooo00Gooooo
0ol0nYX5ooooo`04oomQ0_oooooooooooomQ0PCooooo00Co003oo`3jV_l0nY[o0?ZJ8Oooool01?l0
0?ooooooo`3jV_l0nYX6ooooo`?o0?ZJ7?ooool00ol00?ooooooooooo`07ooooo`03o`00oooooooo
oooo01Oooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`02o`3jVP;ooooo00?oof42
ooooooooool00_ooool3o`00o`;o0?ZJ00?o003oooooooooool02?ooool01OooH@;ooooooooooooo
ooooof4200Wooooo1?l00002ooooo`;oof422?ooool2o`3jVPCooooo0_l0nYX00ol00?ooooooo`00
000Tooooo`03o`000?oooooooooo00gooooo00Coof42ooooool0nY[o0?ZJ0_ooool00oooH@;ooooo
ooooo`0:ooooo`03oomQ0_oooooooooo00?ooooo0ol0nYX4ooooo`03oomQ0_oooooooooo00?ooooo
00?oof42ooooooooool00_ooool00ol00?oo0?ZJo`3jVP0Nooooo`?o0?ZJ00?oooooo`00ooooool0
2Oooool2o`3jVQcooooo00?o003oooooooooool01oooool7o`3jVP_ooooo00?oof42ooooooooool0
3?ooool01OooH@;o0?ZJo`3jV_l0nY[o003o00Sooooo0_l00?l3o`3jVP03o`00oooooooooooo00?o
oooo00?oof42ooooooooool03_ooool00oooH@;oooooo`000003o`0000Coof424?ooool00ol00?oo
ooooo`00000Cooooo`00:?ooool2o`0000Gooooo00?o0000ooooooooool03_ooool00oooH@;ooooo
ooooo`02o`3jVP05o`00ooooooooooooooooooooH@801oooool00oooH@;oooooooooo`06ooooo`;o
0?ZJ1Oooool01OooH@;oooooooooooooooooof4200Cooooo00?o003oooooool0nYX00_l0nYXPoooo
o`04o`00oooooooo0?ZJo`3jVPOooooo0_l0nYXVooooo`03o`00oooooooooooo01Oooooo00?oof42
ooooooooool01Oooool00oooH@;oooooo`3jVP02o`3jVP04ooooooooH@;ooooooomQ0PKooooo0ol0
nYX00ol00?ooooooooooo`08ooooo`04oomQ0_oooooooooooomQ0PSooooo00Go003oooooool0003o
0000ooooo`02oomQ0P03ooooooooH@;ooooo00Oooooo0ol0nYX3ooooo`;o0?ZJ0_ooool00ol0003o
ooooooooo`0Kooooo`;o00001Oooool00ol0003oooooooooo`0=ooooo`04oomQ0_oooooo0?ZJo`3j
VP;ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?o003ooooo
ooooool00_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00;ooooo00Co003oo`3j
V_l0nY[o0?ZJ7Oooool2o`3jVP;ooooo00?o003oooooooooool02?ooool3o`3jVR?ooooo2_l0nYX:
ooooo`03oomQ0_oooooooooo00cooooo00Coof42o`3jV_l0nY[o003o0oooool2oomQ0POooooo0_l0
nYX00ooooooo003oooooo`04ooooo`03oomQ0_oooooooooo00cooooo00Coof42ooooool00?oo0?ZJ
0_l000001Oooooooof42ooooooooooooof4201;ooooo00?o0000ooooooooool04Oooool002Oooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0>ooooo`03oomQ0_oooooooooo00?o
0?ZJ0oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00Gooooo0ol0nYX5ooooo`03
oomQ0_oooooooooo00;ooooo00?oof42ooooooooool00_ooool01Ol00?ooooooo`3jV_l0nY[o003o
01oooooo00Co003oooooool0nY[o0?ZJ1oooool3o`3jVRKooooo00?o003oooooooooool05_ooool0
0oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00;o0?ZJ00?ooooooomQ0_ooool00_ooool0
0oooH@;oooooooooo`04ooooo`;o0?ZJ00?oooooo`00ooooool02?ooool01?ooH@;ooooooooooooo
H@88ooooo`06o`00oooooooo0?ZJo`3jV_ooooooof420oooool00oooH@;oooooooooo`06ooooo`;o
0?ZJ0oooool2o`3jVP;ooooo00?o0000ooooooooool06_ooool01?l0003oooooooooool00004oooo
o`03o`000?oooooooooo00gooooo00?oof42ooooool0nYX00_l0nYX00ooooooo003ooomQ0P0:oooo
o`03oomQ0_oooooooooo00Cooooo0_l0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo
00Cooooo00?oof42ooooooooool00_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o01[ooooo0ol0nYX2
ooooo`03o`00oooooooooooo00Wooooo1?l0nYXOooooo`Go0?ZJ00?o003oooooooooool00_ooool3
o`3jVPWooooo00?oof42ooooooooool02oooool01OooH@;oooooo`3jV_l0nY[o003o00;ooooo00Co
of42ooooooooooooof421_ooool2o`3jVP;ooooo00?o003oooooooooool00_ooool00oooH@;ooooo
ooooo`0<ooooo`03oomQ0_oooooo003o00;o0?ZJ00?ooooooomQ0_ooool00oooool00oooH@;ooooo
ooooo`0?ooooo`03o`000?oooooooooo017ooooo000Wooooo`04o`000?ooooooooooo`0000Cooooo
0ol0000>ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ0oooool00oooH@;oooooooooo`05ooooo`03
oomQ0_oooooooooo00Gooooo0_l0nYX6ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooooooo
ool00oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00;ooooo0_l00?lIooooo`03o`00oooooooooooo
00;o0?ZJ2?ooool4o`3jVPcooooo0_l0000Fooooo`03o`00oooooooooooo00Kooooo3ol0nYX00ooo
ooooof42ooooo`05ooooo`03oomQ0_oooooo003o00;o0?ZJ00?ooooooomQ0_ooool00oooool00ooo
H@;oooooooooo`03ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`03oomQ0_ooooooof42
00Sooooo00?o003oooooool0nYX00_l0nYX00oooooooof42ooooo`02ooooo`03oomQ0_oooooooooo
00Kooooo1ol0nYX00ooooooo0000o`00000Looooo`04o`000?ooooooooooo`0000Cooooo0ol0000>
ooooo`07oomQ0_oooooo0?ZJo`3jV_oooooo003ooomQ0P0:ooooo`03oomQ0_oooooooooo00?ooooo
0ol0nYX5ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool00oooool01Ol00?oo0?ZJ
o`3jV_oooooo003o00;ooooo0_l00?lDooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`0;ooooo`Co
0?ZJ2oooool2o`00013ooooo1?l0nYX2ooooo`03o`00oooooooooooo00?ooooo0ol0nYX8ooooo`03
oomQ0_oooooooooo00_ooooo00Coof42ooooool0nY[o0?ZJ0oooool01OooH@;ooooooooooooooooo
of4200Gooooo0ol0nYX2ooooo`03o`00oooooooooooo00;ooooo00?oof42ooooooooool02_ooool0
0oooH@;oooooo`00o`03o`3jVP03ooooooooH@;ooooo00Cooooo00?oof42ooooooooool03Oooool2
o`0001?ooooo000Wooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool03_ooool0
1?ooH@;oooooooooooooool2o`3jVP04o`00oooooooooooooomQ0PKooooo00?oof42ooooooooool0
1_ooool2o`3jVPKooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`05ooooo`;o0?ZJ
00?oooooo`00ool00?l00_ooool00ol00?ooooooo`00o`02o`00oaCooooo00?o003oooooooooool0
0_l0nYX9ooooo`Co0?ZJ2_ooool4o`0001Gooooo00Co003ooooooooooooooooo5?l0nYX00ooooooo
of42ooooo`05ooooo`03oomQ0_oooooo003o00;o0?ZJ00?ooooooomQ0_ooool00oooool00oooH@;o
ooooooooo`03ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`;oof422Oooool01_l00?oo
ooooo`3jV_l0nY[ooooooomQ0PCooooo00?oof42ooooooooool01oooool5o`3jVP?ooooo00?o0000
ooooooooool06_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00kooooo00Co
of42ooooool0nY[o0?ZJ0_ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00?ooooo
0_l0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0
1?ooool3o`3jVP03ooooool00?oo003o00;ooooo00?o003oooooool00?l00_l00?l>ooooo`?o0?ZJ
0oooool00ol00?ooooooooooo`0=ooooo`Co0?ZJ2?ooool4o`0000gooooo1?l0nYX4ooooo`03o`00
oooooooooooo00Cooooo0ol0nYX7ooooo`03oomQ0_oooooooooo00_ooooo00Coof42ooooool0nY[o
0?ZJ0_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX2ooooo`03
o`00oooooooooooo00?ooooo00?oof42ooooooooool01oooool2oomQ0P;ooooo00?o003oo`3jV_l0
nYX00_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00kooooo00?o0000oooooooo
ool04Oooool002Oooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0>ooooo`04
oomQ0_ooooooooooooooo`?o0?ZJ0_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo
00Gooooo0ol0nYX6ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01Oooool3o`3j
VPGooooo00Go003oooooooooooooooooo`00o`0Cooooo`03o`00oooooooo0?ZJ00;o0?ZJ2oooool3
o`3jVPWooooo1?l0000Dooooo`_o0?ZJ3?ooool2o`3jVP03ooooooooH@;ooooo00Gooooo00?oof42
o`00ooooool00_l0nYX00oooooooof42ooooo`04ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX3
ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool01oooool00ol00?ooooooooooo`02
o`3jVP03ooooooooH@;ooooo00Cooooo00?oof42ooooooooool02?ooool3o`3jVP04ooooooooH@;o
ooooo`0001cooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0>ooooo`04oomQ
0_oooooo0?ZJo`3jVP;ooooo00?o003ooomQ0_ooool02?ooool00oooH@;oooooooooo`03ooooo`;o
0?ZJ00?o003oooooooooool00_ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00Go
oooo0_l0nYX6ooooo`05o`00ooooooooooooooooool00?l03?ooool3o`3jVPCooooo00?o003ooooo
ooooool03_ooool5o`3jVPKooooo1?l0000:ooooo`Ko0?ZJ1_ooool00ol00?ooooooooooo`04oooo
o`;o0?ZJ2?ooool00oooH@;oooooooooo`0:ooooo`04oomQ0_l0nY[o0?ZJo`3jVP;ooooo00?oof42
ooooooooool00oooool00oooH@;oooooooooo`03ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`03
ooooo`03oomQ0_oooooooooo00Cooooo0_ooH@83ooooo`06o`00oooooooo0?ZJo`3jV_ooooooof42
1oooool00oooH@;oooooooooo`0:ooooo`;oof4200?oooooo`000?ooool04_ooool002Oooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`0?ooooo`04oomQ0_ooooooooooooooo`;o
0?ZJ0_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX7ooooo`03
oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01_ooool2o`3jVP[ooooo00?o003ooooooooo
ool03oooool00ol00?ooooooooooo`02o`3jVP03ooooooooH@;ooooo00[ooooo0_l0nYX:ooooo`;o
00001_l0nYX=ooooo`So0?ZJ4Oooool2o`3jVP03ooooooooH@;ooooo00Gooooo00?oof42o`00oooo
ool00_l0nYX00oooooooof42ooooo`04ooooo`03oomQ0_oooooooooo00;ooooo0_l000001?l0nY[o
ooooooooool00?lAooooo`03o`00oooooooo0?ZJ00;o0?ZJ00?ooooooomQ0_ooool01?ooool00ooo
H@;oooooooooo`09ooooo`;o0?ZJ00CooooooomQ0_oooooo00007?ooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo00kooooo00Coof42ooooool0nY[o0?ZJ0_ooool00ol00?ooof42
ooooo`07ooooo`03oomQ0_oooooooooo00?ooooo0ol0nYX00ol00?ooooooooooo`02ooooo`03oomQ
0_oooooooooo00Gooooo00?oof42ooooooooool01Oooool3o`3jVP[ooooo00?o003oooooooooool0
2?ooool3o`3jVPCooooo00?o003oooooooooool00oooool00oooH@;oooooooooo`0;ooooo`[o0?ZJ
0_l0000?o`3jVPSooooo00?o003oooooooooool01?ooool3o`3jVPOooooo00?oof42ooooooooool0
2Oooool01?ooH@;oooooo`3jV_l0nYX2ooooo`03oomQ0_oooooooooo00Gooooo00?oof42oooooooo
ool00_ooool2o`000004o`3jV_ooooooooooo`00o`Kooooo00?oof42ooooooooool00_ooool00ooo
H@;oooooooooo`03ooooo`06o`00ool0nY[o0?ZJo`3jV_ooooooof422?ooool00oooH@;ooooooooo
o`07ooooo`;oof420oooool00ol0003oooooooooo`0Aooooo`00:?ooool2o`0000Gooooo0_l0000@
ooooo`04oomQ0_ooooooooooooooo`?o0?ZJ0_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oo
oooooooo00Gooooo0ol0nYX7ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool01Ooo
ool3o`3jVPWooooo00?o003oooooooooool03oooool00ol00?ooooooo`3jVP02o`3jVP03oooooooo
H@;ooooo00[ooooo0ol0nYX9ooooo`go0?ZJ1Oooool6o`3jVP03ooooool00?oooooo00Sooooo0ol0
0?l8ooooo`;o0?ZJ00?ooooooomQ0_ooool01?ooool01?ooH@;o003oooooooooool2o`3jVP03oooo
ooooH@;ooooo00Cooooo00Coof42oooooooooooooooo1?l000000ol0nY[oooooo`00o`0@ooooo`03
o`00oooooooo0?ZJ00;o00000_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00_o
oooo00?oof42ooooool000007Oooool2o`0000Gooooo0_l0000?ooooo`03oomQ0_oooooo0?ZJ00;o
0?ZJ00?oooooo`00ooooH@802?ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?o003ooooooooo
ool00oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX:ooooo`03
o`00oooooooooooo00Sooooo0_l0nYX5ooooo`03o`00oooooooooooo00?ooooo00?oof42oooooooo
ool03OoooolFo`3jVP_ooooo00?o003oooooooooool01Oooool2o`3jVP?o003o1?ooool00oooH@;o
ooooooooo`09ooooo`04oomQ0_oooooo0?ZJo`3jVP;ooooo00?oof42ooooooooool01Oooool01?oo
H@;oooooooooooooool4o`000003o`3jV_oooooo003o00Oooooo1?ooH@85ooooo`03o`00oooooooo
0?ZJ00;o000000?ooooooomQ0_ooool02?ooool00oooH@;oooooooooo`06ooooo`04oomQ0_oooooo
ooooooooo`;o00004oooool002oooooo00?o0000ooooooooool03oooool00oooH@;oooooooooo`02
ooooo`;o0?ZJ0_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX8
ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool01_ooool2o`3jVP[ooooo00?o003o
ooooooooool02oooool8o`3jVP03ooooooooH@;oof4200_ooooo0ol0nYX7ooooo`?o0?ZJ1Oooool?
o`3jVPCooooo00?o003oooooooooool01_ooool00ol00?ooooooo`00o`08ooooo`;o0?ZJ00?ooooo
oomQ0_ooool01?ooool00oooH@;o003oooooo`03o`3jVP03oomQ0_oooooooooo00Gooooo00?oof42
ooooooooool01?l00002o`3jVP03ooooool00?oooooo00kooooo0_l0nYX4o`000003ooooooooH@;o
oooo00Gooooo00?oof42ooooooooool02oooool00oooH@;oooooo`00000Tooooo`03o`000?oooooo
oooo00oooooo00Coof42ooooool0nY[o0?ZJ0_ooool00ol00?ooof42ooooo`06ooooo`03oomQ0_oo
oooooooo00?ooooo0_l0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00Oooooo00?o
of42ooooooooool01Oooool2o`3jVP_ooooo00?o003oooooooooool01_ooool3o`3jVPGooooo00?o
003oooooooooool00_ooool00oooH@;ooooooomQ0P0`ooooo`03o`00oooooooooooo00Cooooo0ol0
nYX00ooooooo003oooooo`04ooooo`03oomQ0_oooooooooo00Sooooo00Coof42ooooool0nY[o0?ZJ
0_ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Co000000Co0?ZJoooooooooooo
003o3oooool00ol00?oo0?ZJo`000003o`000003oomQ0_oooooooooo00Oooooo00?oof42oooooooo
ool01Oooool00oooH@;oooooooooo`03ooooo`03o`000?oooooooooo017ooooo000_ooooo`03o`00
0?oooooooooo00oooooo00?oof42ooooooooool00_ooool3o`3jVP03ooooooooH@;ooooo00?ooooo
00?oof42ooooooooool01Oooool2o`3jVPSooooo00?oof42ooooooooool00oooool00oooH@;ooooo
ooooo`06ooooo`?o0?ZJ2Oooool00ol00?ooooooooooo`06ooooo`_o0?ZJ0oooool00oooH@;ooooo
oomQ0P0;ooooo`?o0?ZJ1Oooool3o`3jVP_ooooo1ol0nYX7ooooo`03o`00oooooooooooo00Kooooo
00Co003ooooooooooooo003o1oooool3o`3jVP03oomQ0_oooooooooo00?ooooo00?oof42o`00oooo
ool00_l0nYX00oooooooof42ooooo`06ooooo`04oomQ0_ooooooooooooooo`;o000000Goooooo`3j
V_l0nY[o0?ZJo`00o`0?ooooo`;o0?ZJ1?l000000oooH@;oooooooooo`06ooooo`03oomQ0_oooooo
oooo00[ooooo00?oof42ooooool000009?ooool00ol0003oooooooooo`0?ooooo`04oomQ0_oooooo
0?ZJo`3jVP;ooooo00?o003ooomQ0_ooool01_ooool00oooH@;oooooooooo`02ooooo`?o0?ZJ00?o
003oooooooooool00_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00Gooooo0ol0
nYX:ooooo`03o`00oooooooooooo00Kooooo0_l0nYX5ooooo`03o`00oooooooooooo00?ooooo00Co
of42ooooooooooooof42;oooool00ol00?ooooooooooo`05ooooo`;o0?ZJ0_ooool00ol00?oooooo
ooooo`02ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooool0nYX00_l0nYX00oooooooof42
ooooo`08ooooo`04oomQ0_ooooooooooooooo`;o00000ol0nYX00ooooooo003oooooo`0>ooooo`03
o`00ool0nY[o000000?o00002oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Co
oooo00?o0000ooooooooool04Oooool002oooooo00?o0000ooooooooool04?ooool00oooH@;ooooo
ooooo`02ooooo`;o0?ZJ00?ooooooomQ0_ooool00_ooool00oooH@;oooooooooo`05ooooo`?o0?ZJ
2?ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Kooooo0ol0nYX8ooooo`03o`00
oooooooooooo00Cooooo2?l0nYX00ooooooo003oooooo`05ooooo`04oomQ0_oooooooooooomQ0P_o
oooo1Ol0nYX2ooooo`;o0?ZJ6oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool01Oooool2o`3jVP03oomQ0_oooooooooo00;ooooo00Coof42o`00oooo
oooooooo0_l0nYX00oooooooof42ooooo`07ooooo`03oomQ0_oooooooooo00Cooooo1?l0nYX=oooo
o`?o0?ZJ00Goooooo`000?l0003ooooooomQ0P08ooooo`03oomQ0_oooooooooo00[ooooo00?oof42
ooooool000009?ooool00ol0003oooooooooo`0?ooooo`04oomQ0_oooooo0?ZJo`3jVP;ooooo00?o
003ooomQ0_ooool01Oooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?o003oooooooooool00ooo
ool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00Gooooo0ol0nYX9ooooo`03o`00oooo
oooooooo00Cooooo1?l0nYX5ooooo`03o`00oooooooooooo00;ooooo00?oof42ooooooooool00_oo
ool00oooH@;oooooooooo`0]ooooo`03o`00oooooooooooo00Cooooo0ol0nYX2ooooo`05o`00oooo
ooooooooooooooooH@802Oooool01?ooH@;oooooo`3jV_l0nYX2ooooo`03oomQ0_oooooooooo00So
oooo00?oof42ooooooooool00oooool2o`3jVP03ooooool00?oooooo00gooooo00Co003oo`3jV_l0
nY[o0?ZJ0_l000000oooH@;oooooooooo`0:ooooo`?oof4200?ooooooomQ0_ooool01_ooool00ol0
003oooooooooo`0Aooooo`00;oooool2o`00017ooooo00?oof42ooooooooool00_ooool2o`3jVP03
ooooooooH@;ooooo00;ooooo00?oof42ooooooooool01Oooool2o`3jVPWooooo00?oof42oooooooo
ool01?ooool00oooH@;oooooooooo`07ooooo`?o0?ZJ2?ooool00ol00?ooooooooooo`02ooooo`Co
0?ZJ1_ooool00ol00?ooooooooooo`04ooooo`04oomQ0_oooooooooooomQ0Pcooooo2?l0nYXKoooo
o`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`05oooo
o`;o0?ZJ00?oof42ooooooooool00_ooool01?ooH@;o003oooooooooool2o`3jVP03ooooooooH@;o
oooo00Oooooo00?oof42ooooooooool01Oooool7o`3jVPSooooo0ol0nYX5ooooo`03oomQ0_oooooo
oooo00Kooooo00?oof42ooooooooool02_ooool00oooH@;oooooo`00000Tooooo`;o00004?ooool0
1?ooH@;oooooo`3jV_l0nYX2ooooo`03o`00ooooH@;ooooo00Gooooo00?oof42ooooooooool00ooo
ool2o`3jVP03o`00oooooooooooo00;ooooo00?oof42ooooooooool02Oooool00oooH@;ooooooooo
o`06ooooo`?o0?ZJ2Oooool00ol00?ooooooooooo`02ooooo`Co0?ZJ1_ooool00ol00?oooooooooo
o`02ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0;Oooool00ol00?oooooooooo
o`04ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oooooooooool00_ooool00oooH@;ooooooooo
o`06ooooo`04oomQ0_oooooo0?ZJo`3jVP;ooooo00?oof42ooooooooool02Oooool00oooH@;ooooo
ooooo`02ooooo`?o0?ZJ00?o003oooooooooool03?ooool00ol00?oo0?ZJo`3jVP03ooooo`03oomQ
0_oooooooooo00gooooo00?oof42ooooooooool01Oooool2o`0001?ooooo000_ooooo`03o`000?oo
oooooooo013ooooo00?oof42ooooooooool00_ooool2o`3jVP03ooooooooH@;ooooo00;ooooo00?o
of42ooooooooool01Oooool2o`3jVPWooooo00?oof42ooooooooool01?ooool00oooH@;ooooooooo
o`08ooooo`?o0?ZJ1oooool00ol00?ooooooooooo`04o`3jVPOooooo00?o003oooooooooool01Ooo
ool01?ooH@;oooooooooooooH@8?ooooo`Co0?ZJ7?ooool00ol00?ooooooooooo`04ooooo`03o`00
oooooooooooo00?ooooo00?o003oooooooooool01?ooool2o`3jVP07ooooooooH@;ooooooooooooo
H@;oooooo`00o`02ooooo`;o0?ZJ00?ooooooomQ0_ooool02?ooool00oooH@;oooooooooo`06oooo
o`Go0?ZJ1oooool3o`3jVPKooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`09oooo
o`03oomQ0_oooooo000002Cooooo00?o0000ooooooooool03oooool00oooH@;oooooo`3jVP02o`3j
VP;ooooo00?o003ooomQ0_ooool01?ooool00oooH@;oooooooooo`02ooooo`?o0?ZJ00?o003ooooo
ooooool00_ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00Oooooo0ol0nYX8oooo
o`04o`00ooooooooooooooooo`?o0?ZJ1oooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooo
oooo00?ooooo00?oof42ooooooooool0;Oooool00ol00?ooooooooooo`04ooooo`04o`00ool0nY[o
0?ZJo`3jVP;ooooo00Go003ooooooooooooooooooomQ0P07ooooo`03oomQ0_oooooooooo00;o0?ZJ
00?ooooooomQ0_ooool03?ooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?oooooo`00ooooool0
2oooool01?l00?oo0?ZJo`3jV_l0nYX2ooooo`03oomQ0_oooooooooo01Oooooo00?o0000oooooooo
ool04Oooool002oooooo00?o0000ooooooooool04?ooool00oooH@;oooooooooo`02ooooo`;o0?ZJ
00?ooooooomQ0_ooool00_ooH@87ooooo`?o0?ZJ2Oooool00oooH@;oooooooooo`05ooooo`03oomQ
0_oooooooooo00Sooooo1?l0nYX6ooooo`Go0?ZJ2?ooool00ol00?ooooooooooo`05ooooo`05oomQ
0_ooooooooooooooooooH@80;oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Co
oooo00?o003oooooooooool01?ooool2o`3jVP08ooooooooH@;oooooooooooooH@;oooooo`00oooo
ool3o`3jVP03ooooooooH@;ooooo00Sooooo00?oof42ooooooooool01_ooool00ol00?oooooooooo
o`03o`3jVPGooooo0ol0nYX6ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool02?oo
ool01?ooH@;oooooooooool0000Tooooo`03o`000?oooooooooo013ooooo00Coof42ooooool0nY[o
0?ZJ0_ooool00ol00?ooof42ooooo`03ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX00ooooooo
003oooooo`03ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool01oooool2o`3jVPWo
oooo00?o003oooooooooool00_l0nYX8ooooo`03o`00oooooooooooo00;ooooo00?oof42oooooooo
ool01?ooool00oooH@;oooooooooo`0]ooooo`03o`00oooooooooooo00;ooooo00?o003ooooooooo
ool00_l0nYX2ooooo`05o`00ooooooooooooooooooooH@801oooool00oooH@;oooooooooo`02o`3j
VP03ooooooooH@;ooooo00cooooo00?oof42ooooooooool00_ooool3o`3jVP03o`00oooooooooooo
00[ooooo00?o003oo`3jV_l0nYX00oooool00oooH@;oooooooooo`0Gooooo`03o`000?oooooooooo
017ooooo000_ooooo`03o`000?oooooooooo013ooooo00?oof42ooooooooool00_ooool3o`3jVP;o
of422Oooool2o`3jVPWooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`09ooooo`co
0?ZJ2Oooool00ol00?ooooooooooo`05ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooooooo
ool0;Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o003ooooooooo
ool01?ooool2o`3jVP06ooooooooH@;oooooooooooooH@;o003o0_ooool2o`3jVP;ooooo00?oof42
ooooooooool02?ooool00oooH@;oooooooooo`05ooooo`04o`00ooooooooooooooooo`;o0?ZJ1?oo
ool3o`3jVP03o`00oooooooooooo00Cooooo00?oof42ooooooooool02?ooool00oooH@;ooooooooo
o`08ooooo`04oomQ0_ooooooooooo`0002Cooooo00?o0000ooooooooool04?ooool01?ooH@;ooooo
o`3jV_l0nYX2ooooo`03o`00ooooH@;ooooo00;ooooo00?oof42ooooooooool01?ooool2o`3jVP03
o`00oooooooooooo00;ooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`07ooooo`?o
0?ZJ2?ooool00ol00?ooooooo`3jVP02o`3jVPOooooo00?o003oooooooooool00_ooool00oooH@;o
ooooooooo`05ooooo`03oomQ0_oooooooooo02gooooo00?o003oooooooooool00_ooool00ol00?oo
ooooooooo`03o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool01?ooool00oooH@;o
ooooo`3jVP02o`3jVP03ooooooooH@;ooooo00gooooo00?oof42ooooooooool00_ooool2o`3jVP03
o`00oooooooooooo00[ooooo0ol0nYX3ooooo`03oomQ0_oooooooooo01Oooooo00?o0000oooooooo
ool04Oooool002oooooo0_l0000Booooo`03oomQ0_oooooooooo00;ooooo0_l0nYX;ooooo`;o0?ZJ
2Oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00_ooooo2?l0nYX00ol00?oooooo
ooooo`07ooooo`03o`00oooooooooooo00Kooooo00?oof42ooooooooool00_ooool00oooH@;ooooo
ooooo`0^ooooo`04o`00ooooooooooooo`00o`Sooooo00?o003oooooooooool00oooool2o`3jVP06
ooooooooH@;ooooooomQ0_oooooo003o0_ooool2o`3jVP;ooooo00?oof42ooooooooool02Oooool0
0oooH@;oooooooooo`04ooooo`04o`00ooooooooooooooooo`;o0?ZJ0oooool3o`3jVP03o`00oooo
oooooooo00Gooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`07ooooo`04oomQ0_oo
ooooooooo`0002Cooooo0_l0000Aooooo`04oomQ0_oooooo0?ZJo`3jVP;ooooo00?o003ooooooooo
H@800_ooool00oooH@;oooooooooo`04ooooo`;o0?ZJ00?o003oooooooooool00_ooool00oooH@;o
ooooooooo`0;ooooo`03oomQ0_oooooooooo00Sooooo1?l0nYX6ooooo`Co0?ZJ1oooool00ol00?oo
ooooooooo`03ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0;_ooool01?l00?oo
ooooooooool00?l4ooooo`;o0?ZJ0_ooool01Ol00?ooooooooooooooooooof4200Gooooo00?oof42
ooooooooool00_l0nYX2ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool00_ooool3
o`3jVP_ooooo0ol0nYX3ooooo`03oomQ0_oooooooooo01Oooooo0_l0000Cooooo`00;oooool00ol0
003oooooooooo`0Aooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX:ooooo`?o0?ZJ2Oooool00ooo
H@;oooooooooo`07ooooo`03oomQ0_oooooooooo01;ooooo00?o003oooooooooool01_ooool00ol0
0?ooooooooooo`07ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool0;Oooool00ol0
0?ooooooo`00o`09ooooo`03o`00oooooooooooo00?ooooo0_l0nYX01oooooooof42ooooooooH@;o
ooooo`00ooooool00ol0nYX2ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool00ooo
ool01?l00?ooooooooooooooool7o`3jVP03ooooool00?oooooo00Kooooo00?oof42ooooooooool0
2Oooool00oooH@;oooooooooo`07ooooo`04oomQ0_ooooooooooo`0002Cooooo00?o0000oooooooo
ool04?ooool00oooH@;oooooo`3jVP02o`3jVP03ooooool00?oooooo00?oof421oooool2o`3jVP03
o`00oooooooooooo00;ooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`08ooooo`co
0?ZJ1oooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00Kooooo00?oof42oooooooo
ool0;Oooool00ol00?ooooooo`00o`05ooooo`?o0?ZJ00?oooooo`00ooooool00oooool00oooH@;o
ooooooooo`02ooooo`03oomQ0_oooooooooo00;o0?ZJ0_ooool00oooH@;oooooooooo`0=ooooo`03
oomQ0_oooooooooo00;ooooo1?l0nYX8ooooo`?o0?ZJ1?ooool00oooH@;oooooooooo`0Hooooo`03
o`000?oooooooooo017ooooo000_ooooo`03o`000?oooooooooo017ooooo00?oof42ooooooooool0
0_ooool2o`3jVP[ooooo0_l0nYX00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00Oooooo
00?oof42ooooooooool04oooool2o`00o`Cooooo0_l00?l:ooooo`03oomQ0_oooooooooo00?ooooo
00?oof42ooooooooool0;_ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo00?ooooo
0_l0nYX01Oooooooof42oomQ0_oooooo003o00;ooooo0_l0nYX3ooooo`03oomQ0_oooooooooo00[o
oooo00?oof42ooooooooool01?ooool01?l00?ooooooooooooooool5o`3jVP;ooooo00?o003ooooo
ooooool01Oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00Oooooo00Coof42oooo
oooooooo00009?ooool00ol0003oooooooooo`0@ooooo`03oomQ0_oooooooooo00;o0?ZJ0_ooool0
0ol00?ooooooooooo`07ooooo`?o0?ZJ00?o003oooooooooool00_ooool00oooH@;oooooooooo`0<
ooooo`03oomQ0_oooooooooo00[ooooo2?l0nYX00ooooooo003oo`00o`04ooooo`;o003o1_ooool0
0oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo02kooooo00?o003oooooooooool01Oooool2
o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool00_ooool00oooH@;oooooo`00o`02
o`3jVP03ooooooooH@;ooooo00oooooo00?oof42ooooooooool00oooool4o`3jVPKooooo0ol0nYX4
ooooo`03oomQ0_oooooooooo01Wooooo00?o0000ooooooooool04Oooool002oooooo00?o0000oooo
ooooool04Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ2_ooool2o`3jVP[ooooo00?oof42oooo
ooooool01oooool00oooH@;oooooooooo`0Eooooo`Co003o3?ooool00oooH@;oooooooooo`03oooo
o`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool09_ooool00ol00?ooooooooooo`02oooo
o`?o0?ZJ0_ooH@801?oooooo003oooooooooool2o`3jVP;ooooo00?oof42ooooooooool03?ooool0
0oooH@;oooooooooo`03ooooo`04o`00ooooooooooooooooo`;o000000Go0?ZJoooooooooooooooo
o`00o`07ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01_ooool01?ooH@;ooooo
ooooool0000Tooooo`03o`000?oooooooooo017ooooo00Coof42ooooool0nY[o0?ZJ0_ooool00ol0
0?ooooooooooo`07ooooo`;o0?ZJ00?o003oooooooooool00oooool00oooH@;oooooooooo`0<oooo
o`03oomQ0_oooooooooo00gooooo0_l0nYX6ooooo`Co003o2?ooool00oooH@;oooooooooo`07oooo
o`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool08_ooool3o`3jVP03ooooool00?oooooo
00?ooooo1?ooH@82ooooo`?o0?ZJ00?ooooooomQ0_ooool04?ooool00oooH@;oooooooooo`03oooo
o`04o`00ool0nY[o0?ZJo`3jVP;o00000_ooool3o`3jVPGooooo00?oof42ooooooooool06Oooool0
0ol0003oooooooooo`0Aooooo`00;oooool2o`0001?ooooo00Coof42oooooooooooooooo0_l0nYX9
ooooo`?o0?ZJ2Oooool2oomQ0PWooooo00?oof42ooooooooool09Oooool00oooH@;oooooooooo`04
ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool09_ooool00ol00?ooooooooooo`03
ooooo`;o0?ZJ00Goof42oooooooooooo003oooooo`03o`3jVP;ooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`03ooooo`03o`00oooooooooooo00Co00000oooool00ol00?oooooooooo
o`05ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01_ooool01?ooH@;ooooooooo
ool0000Tooooo`;o00004_ooool00oooH@;oooooo`3jVP02o`3jVP03ooooool00?oooooo00Sooooo
0_l0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool0
8Oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00oooooo0_ooH@8Uooooo`;o0?ZJ
00?oooooo`00ooooool02Oooool2o`3jVP;ooooo00?oof42ooooooooool03oooool00oooH@;ooooo
ooooo`03ooooo`03o`00oooooooo0?ZJ00Co00000ol0nYX00ol00?ooooooooooo`02ooooo`03oomQ
0_oooooooooo01Wooooo0_l0000Cooooo`005_ooool2o`0000Cooooo00Co0000oooooooooooooooo
1Ol00002ooooo`?o00001Oooool00ol0003oooooooooo`0Booooo`04oomQ0_ooooooooooooooo`;o
0?ZJ2Oooool2o`3jVP03o`00oooooooooooo00Kooooo00?oof42ooooooooool02_ooool00oooH@;o
ooooooooo`0Tooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool04?ooool2oomQ0ROo
oooo00?o003oooooooooool00oooool2o`3jVP?ooooo00Co003oooooool0nY[o0?ZJ0oooool00ooo
H@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooooooool01?l00002oooo
o`03o`00oooooooooooo00Kooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`06oooo
o`04oomQ0_ooooooooooo`0000_ooooo0_l00004ooooo`04o`000?ooooooooooooooo`Go00000_oo
ool3o`0000Gooooo00?o0000ooooooooool04Oooool00oooH@;oooooooooo`02o`3jVP03ooooool0
0?oooooo00Oooooo0ol0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00kooooo00?o
of42ooooooooool07oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00kooooo00Co
of42ooooooooooooof429?ooool3o`3jVP03o`00oooooooooooo00Sooooo0_l0nYX2ooooo`03oomQ
0_oooooooooo013ooooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`04o`0000;o0?ZJ
00?o003oooooooooool00oooool00oooH@;oooooooooo`0Jooooo`03o`000?oooooooooo017ooooo
000Eooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00003oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04_ooool01?ooH@;oooooooooooooool2
o`3jVPWooooo0_l0nYX00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo00[ooooo00?oof42
ooooooooool09?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00oooooo00?oof42
ooooooooH@809oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`02
o`3jVP?ooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`03ooooo`03o`00oooooooo
oooo00;o00000oooool00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo00cooooo00?oof42
ooooooooool01Oooool01?ooH@;oooooooooool0000:ooooo`04o`000?ooooooooooo`0000Sooooo
00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04Oooool00oooH@;oooooooooo`02o`3jVP03ooooool00?oooooo00Oooooo0_l0nYX00ooo
oooo003oooooo`03ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool07oooool00ooo
H@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool00_ooool00ooo
H@;oooooooooo`0Rooooo`;o0?ZJ00?oooooo`00ooooool01oooool3o`3jVP;ooooo00?oof42oooo
ooooool04?ooool00oooH@;oooooooooo`03ooooo`03o`00oooooooooooo00;o00000oooool00ol0
0?ooooooooooo`02ooooo`03oomQ0_oooooooooo01_ooooo00?o0000ooooooooool04Oooool001Go
oooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00;ooooo0ol0000Booooo`04oomQ0_ooooooooooooooo`;o0?ZJ2?ooool3o`3jVP03o`00oooooooo
oooo00Gooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Tooooo`03oomQ0_oooooo
oooo00Gooooo00?oof42ooooooooool03oooool00oooH@;ooooooomQ0P0Wooooo`03o`00oooooooo
oooo00;ooooo0_l0nYX2ooooo`03o`00oooooooo0?ZJ00;o0?ZJ0oooool00oooH@;oooooooooo`0>
ooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`06
ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool01Oooool01?ooH@;oooooo`000?l0
000:ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`02ooooo`?o00004_ooool00oooH@;oooooo`3jVP02o`3jVP03o`00oooooooooooo00Gooooo
0ol0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool0
7oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0
0_ooool00oooH@;oooooooooo`0Rooooo`;o0?ZJ00?oooooo`00ooooool01oooool2o`3jVP;ooooo
00?oof42ooooooooool04_ooool00oooH@;oooooooooo`02ooooo`03o`00oooooooooooo00Gooooo
00?o003oooooooooool00_ooool00oooH@;oooooooooo`0Jooooo`;o00004oooool001Gooooo00Co
0000oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool04_ooool01?ooH@;oooooooooooooool3o`3jVPKooooo0ol0nYX00ol00?oo
ooooooooo`05ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool09?ooool00oooH@;o
ooooooooo`05ooooo`03oomQ0_oooooooooo00kooooo00Goof42oooooooooooooooooomQ0P0Voooo
o`03o`00oooooooooooo00;ooooo0_l0nYX2ooooo`04o`00oooooooo0?ZJo`3jVPCooooo00?oof42
ooooooooool03_ooool00oooH@;oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo0_l00?l8
ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool01?ooool01?ooH@;oooooooooool0
000:ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo01;ooooo00?oof42ooooooooool00_l0nYX00ooooooo003o
ooooo`05ooooo`;o0?ZJ00?oooooo`00ooooool01?ooool00oooH@;oooooooooo`0>ooooo`03oomQ
0_oooooooooo01kooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0;ooooo`03oomQ
0_oooooooooo00Cooooo00?oof42ooooooooool08Oooool3o`3jVP03o`00oooooooooooo00Kooooo
0_l0nYX2ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool00oooool00ol00?oooooo
ooooo`02ooooo`;o003o1Oooool00oooH@;oooooooooo`0Kooooo`03o`000?oooooooooo017ooooo
000Eooooo`04o`000?ooooooooooo`0000Oooooo00Ko0000ooooooooooooooooo`000?ooool4o`00
00Gooooo00?o0000ooooooooool04oooool01?ooH@;oooooooooooooool2o`3jVPGooooo0ol0nYX0
0ooooooo003oooooo`05ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool08oooool0
0oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool00_ooool0
0oooH@;oooooooooo`0Tooooo`04o`00ooooooooooooooooo`;o0?ZJ00Coooooo`00oooooooooooo
0_l0nYX4ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool00oooool00ol00?oooooo
o`00o`02o`00o`[ooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`04ooooo`04oomQ
0_ooooooooooo`0000[ooooo00Co0000oooooooooooo00001oooool01_l0003ooooooooooooooooo
0000ooooo`Co00001Oooool00ol0003oooooooooo`0Booooo`03oomQ0_oooooooooo00?o0?ZJ00?o
003oooooooooool00oooool3o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool04?oo
ool00oooH@;oooooooooo`0Mooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool02_oo
ool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo027ooooo0_l0nYX00ooooooo003ooooo
o`05ooooo`?o0?ZJ0_ooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo00;ooooo00?o
003oooooool00?l00_l00?l6ooooo`03oomQ0_oooooooooo01cooooo00?o0000ooooooooool04Ooo
ool001Gooooo00Co0000oooooooooooo00001oooool01ol0003ooooooooooooooooo0000ooooool0
00002?ooool00ol0003oooooooooo`0Cooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1Oooool2o`3j
VP;ooooo00?o003oooooooooool01?ooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo
02?ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo
00;ooooo00?oof42ooooooooool09?ooool01?l00?ooooooooooooooool2o`3jVP03ooooool00?oo
oooo00?o0?ZJ1?ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00?ooooo00?o003o
ooooooooool02oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00?ooooo00Coof42
oooooooooooo00002_ooool01?l0003oooooooooool00007ooooo`07o`000?ooooooooooooooool0
003oooooo`000008ooooo`03o`000?oooooooooo01;ooooo00Coof42oooooooooooooooo0_l0nYX0
0ol00?ooooooooooo`03ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooo
oooo013ooooo00?oof42ooooooooool07Oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooo
oooo00[ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0Qooooo`?o0?ZJ00?o003o
ooooooooool01?ooool2o`3jVP?ooooo00?oof42ooooooooool04oooool00oooH@;oooooooooo`03
ooooo`03o`00oooooooooooo00Oooooo00?oof42ooooooooool07?ooool00ol0003oooooooooo`0A
ooooo`005_ooool2o`0000Wooooo0ol00002ooooo`Go00001?ooool2o`0001Cooooo00Coof42oooo
oooooooooooo0_l0nYX4ooooo`?o0?ZJ00?oooooo`00ooooool01_ooool00oooH@;oooooooooo`0>
ooooo`03oomQ0_oooooooooo02?ooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0<
ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool08oooool01?l00?oooooooooooooo
ool2o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ1Oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oo
oooooooo017ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`03ooooo`04oomQ0_oo
ooooooooo`0000_ooooo0_l00009ooooo`?o00000_ooool5o`0000Cooooo0_l0000Cooooo`04oomQ
0_ooooooooooooooo`;o0?ZJ00?o003oooooooooool00_ooool3o`3jVP03ooooool00?oooooo00Co
oooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0Looooo`03oomQ0_oooooooooo00ko
oooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo027o
oooo0ol0nYX6ooooo`;o0?ZJ0oooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo00go
oooo00?oof42ooooooooool06oooool2o`0001?ooooo000_ooooo`03o`000?oooooooooo01?ooooo
00Coof42oooooooooooooooo2?l0nYX00ooooooo003oooooo`06ooooo`03oomQ0_oooooooooo013o
oooo00?oof42ooooooooool08_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00co
oooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`0Tooooo`?o003o0ol0nYX00ooooooo
0?ZJo`3jVP06ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool04Oooool00oooH@;o
ooooooooo`0@ooooo`05oomQ0_ooooooooooooooooooH@800oooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo01?ooooo00?oof42ooooooooool00ol0nYX4ooooo`;o0?ZJ00?oooooo`00
ooooool01Oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo01_ooooo00?oof42oooo
ooooool03_ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooo
ooooool08_ooool2o`3jVPGo003o0ol0nYX2ooooo`03oomQ0_oooooooooo01Gooooo00?oof42oooo
ooooool02oooool00oooH@;oooooooooo`0Mooooo`03o`000?oooooooooo017ooooo000_ooooo`03
o`000?oooooooooo01Cooooo00?oof42ooooooooool01ol0nYX2ooooo`03o`00oooooooooooo00Go
oooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0Rooooo`03oomQ0_oooooooooo00Oo
oooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo02?o
oooo00Co003ooooooooooooooooo1Ol0nYX6ooooo`03oomQ0_oooooooooo013ooooo00?oof42oooo
ooooool03oooool00oooH@;oooooooooo`0Aooooo`05oomQ0_ooooooooooooooooooH@800oooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01?ooooo00Coof42oooooooooooooooo0_l0
nYX01?l00?ooooooooooooooool2o`3jVP03ooooool00?oooooo00Gooooo00?oof42ooooooooool0
4Oooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool0
1oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00kooooo1_ooH@8=ooooo`?o0?ZJ
1?ooool2o`3jVP?ooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0:ooooo`03oomQ
0_oooooooooo01kooooo00?o0000ooooooooool04Oooool002oooooo00?o0000ooooooooool05?oo
ool00oooH@;oooooooooo`02o`000003o`00ool0nY[o0?ZJ00?ooooo00?o003oooooooooool01_oo
ool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo023ooooo00?oof42ooooooooool02Ooo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool09ooo
ool4o`3jVPKooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oo
oooooooo017ooooo00Goof42oooooooooooooooooomQ0P03ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool04oooool01?ooH@;oooooooooooooool2o`000003o`3jV_oooooo0?ZJ00?o
0?ZJ00?o003oooooooooool01?ooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo01Wo
oooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00[o
oooo00?oof42ooooooooool03?ooool2oomQ0PKooooo0_ooH@8<ooooo`?o0?ZJ0oooool2o`3jVP?o
oooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo01oo
oooo00?o0000ooooooooool04Oooool002oooooo0_l0000Eooooo`03oomQ0_oooooo000000?o0000
1Oooool00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool0
8?ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0
1Oooool00oooH@;oooooooooo`0Wooooo`Co0?ZJ1_ooool00oooH@;oooooooooo`0Aooooo`03oomQ
0_oooooooooo00Cooooo0oooH@88ooooo`03oomQ0_oooooooooo01;ooooo00Coof42oooooooooooo
of420oooool00ol0003oooooooooo`0Rooooo`;o00005?ooool00oooH@;oooooooooo`04o`0000Co
0?ZJ00?oooooo`00ooooool01Oooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo01Wo
oooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00co
oooo00?oof42ooooooooool02Oooool2oomQ0P[ooooo00?oof42ooooooooool02_ooool7o`3jVP?o
oooo00?oof42ooooooooool05_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo01oo
oooo0_l0000Cooooo`00;oooool00ol0003oooooooooo`0Eooooo`03oomQ0_l0003o000000;o0000
00Go003oooooooooooooooooo`00o`08ooooo`03oomQ0_oooooooooo01?ooooo00?oof42oooooooo
ool07oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00Wooooo00?oof42oooooooo
ool01_ooool00oooH@;oooooooooo`0Vooooo`?o0?ZJ1oooool00oooH@;oooooooooo`0Booooo`03
oomQ0_oooooooooo00?ooooo00Coof42ooooooooooooof421oooool00oooH@;oooooooooo`0Coooo
o`03oomQ0_ooooooof4200?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Doooo
o`03oomQ0_oooooo000000?o00000_l0nYX2ooooo`03o`00oooooooooooo00Gooooo00?oof42oooo
ooooool04oooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo01;ooooo00Goof42oooo
oooooooooooooomQ0P0@ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool02oooool0
0oooH@;oooooooooo`0:ooooo`Go0?ZJ0oooool00oooH@;oooooooooo`0Hooooo`Woof428oooool0
0ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`0Eooooo`06oomQ0_oooooo0000
o`000?oooooo003o0oooool00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo01?ooooo00?o
of42ooooooooool07oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00Sooooo00?o
of42ooooooooool01oooool00oooH@;oooooooooo`0Doooooa3oof4200?oooooo`3jV_l0nYX02?oo
ool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo00?ooooo00Goof42oooooooooooooooo
oomQ0P06ooooo`03oomQ0_oooooooooo01Cooooo0_ooH@83ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool05?ooool00oooH@;oooooooooo`02o`000003o`00oooooooooooo00;ooooo
00?o003oooooooooool01?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo01Oooooo
00?oof42ooooooooool05?ooool3oomQ0Q;ooooo00?oof42ooooooooool01?ooool2oomQ0Pkooooo
00?oof42ooooooooool04_ooool00oooH@;oooooooooo`14ooooo`03o`000?oooooooooo017ooooo
000_ooooo`03o`000?oooooooooo01Gooooo00?oof42ooooooooool00_ooool01Ol00?oooooooooo
oooooooo003o00Sooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Nooooo`03oomQ
0_oooooooooo00_ooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`08ooooo`03oomQ
0_oooooooooo00kooooo1OooH@8?ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0
4_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00?ooooo0oooH@82ooooo`03oomQ
0_oooooooooo01Kooooo00Goof42ooooooooooooooooo`00000Tooooo`03o`000?oooooooooo01Go
oooo00?oof42ooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Kooooo00?oof42oooo
ooooool05Oooool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo02_ooooo0_ooH@83oooo
o`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`14oooo
o`03o`000?oooooooooo017ooooo000_ooooo`;o00005oooool00oooH@;oooooooooo`02ooooo`?o
003o2?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo01kooooo00?oof42oooooooo
ool03?ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00Wooooo00?oof42oooooooo
ool02_ooool3oomQ0QCooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Dooooo`05
oomQ0_ooooooooooooooooooH@802?ooool3oomQ0Qcooooo00?o0000ooooooooool08_ooool2o`00
01Kooooo00?oof42ooooooooool00_ooool01?l00?ooooooo`00ool00?l7ooooo`03oomQ0_oooooo
oooo01Kooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0]ooooo`?oof424oooool0
0oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo04Cooooo0_l0000Cooooo`00;oooool00ol0
003oooooooooo`0Fooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooooooool02?ooool00ooo
H@;oooooooooo`0Eooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool03?ooool00ooo
H@;oooooooooo`07ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool01oooool2oomQ
0QSooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Fooooo`04oomQ0_oooooooooo
oomQ0ROooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Eooooo`03oomQ0_oooooo
oooo00;ooooo0_l00?l8ooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool05?ooool0
0oooH@;oooooooooo`14ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool0AOooool0
0ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`0Fooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool05_ooool00oooH@;oooooooooo`0Looooo`;oof423oooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo00_ooooo0_ooH@84ooooo`?oof426_ooool00ooo
H@;oooooooooo`05ooooo`03oomQ0_oooooooooo01Sooooo0_ooH@8Xooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool05_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo
01Oooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`15ooooo`03oomQ0_oooooooooo
00kooooo00?oof42ooooooooool0AOooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003o
ooooooooo`0Gooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool06?ooool00oooH@;o
ooooooooo`0Fooooo`Goof424_ooool2oomQ0PGooooo00?oof42ooooooooool03_ooool4oomQ0Qgo
oooo00?oof42o`000?l000001?ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo02Ko
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Fooooo`03oomQ0_oooooooooo00_o
oooo00?oof42ooooooooool06?ooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo04Oo
oooo0_ooH@8:ooooo`;o000000?ooooooomQ0_ooool0Aoooool00ol0003oooooooooo`0Aooooo`00
;oooool2o`0001Sooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Iooooo`03oomQ
0_oooooooooo013ooooo1OooH@8Iooooo`?oof420_ooool00oooH@;oooooooooo`0_ooooo`Co0000
0_ooool00oooH@;oooooooooo`14ooooo`03o`000?oooooooooo02;ooooo0_l0000Hooooo`03oomQ
0_oooooooooo00[ooooo00?oof42ooooooooool06?ooool00oooH@;oooooooooo`0Booooo`03oomQ
0_oooooooooo04Wooooo00?oof42ooooooooool01_ooool4o`000003oomQ0_oooooooooo04Gooooo
0_l0000Cooooo`007?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o
0000ooooooooool06?ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01[ooooo00?o
of42ooooooooool03Oooool2oomQ0R7ooooo0oooH@8aooooo`Co000000?ooooooomQ0_ooool0A_oo
ool00ol0003oooooooooo`0?ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Ooo
ool00ol0003oooooooooo`0Gooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool06_oo
ool00oooH@;oooooooooo`0?ooooo`;oof42COooool00oooH@;oooooooooo`05ooooo`Co0000BOoo
ool00ol0003oooooooooo`0Aooooo`006oooool01?l0003oooooooooool00007ooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`0Hooooo`03oomQ0_oooooooooo00Wooooo
00?oof42ooooooooool07?ooool00oooH@;oooooooooo`09ooooo`?oof429Oooool00oooH@;ooooo
ooooo`0`ooooo`;o000000?ooooooomQ0_ooool0Aoooool00ol0003oooooooooo`0>ooooo`04o`00
0?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
01Sooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool0C_ooool00oooH@;oooooooooo`05ooooo`;o000000?oof42oooo
ooooool0Aoooool00ol0003oooooooooo`0Aooooo`006oooool01?l0003oooooooooool0000;oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool06Oooool00oooH@;oooooooooo`08oooo
o`03oomQ0_oooooooooo01gooooo0_ooH@87ooooo`;oof42Foooool01?ooH@;oooooooooooooH@98
ooooo`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00002oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo01Sooooo00?oof42ooooooooool02?ooool00oooH@;ooooooooo
o`0Looooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool0D?ooool3oomQ0PKooooo00?o
of42ooooooooool0Aoooool00ol0003oooooooooo`0Aooooo`006oooool01?l0003oooooooooool0
000;ooooo`03o`000?oooooooooo00;ooooo0ol0000Jooooo`03oomQ0_oooooooooo00Oooooo00?o
of42ooooooooool07oooool7oomQ0Ugooooo00?oof42ooooooooH@80B?ooool2o`00013ooooo00Co
0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`?o00006Oooool00oooH@;ooooo
ooooo`06ooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool02Oooool00oooH@;ooooo
ooooo`1Dooooo`;oof420_ooool2oomQ0TWooooo0_l0000Cooooo`006oooool01?l0003ooooooooo
ool00007ooooo`Co00001Oooool00ol0003oooooooooo`0Kooooo`03oomQ0_oooooooooo00Gooooo
00?oof42ooooooooool0QOooool2oomQ0TWooooo00?o0000ooooooooool03_ooool01?l0003ooooo
ooooool00007ooooo`Co00001Oooool00ol0003oooooooooo`0Iooooo`03oomQ0_oooooooooo00Ko
oooo00?oof42ooooooooool07oooool2oomQ0POooooo0_ooH@9Iooooo`;oof42C?ooool00ol0003o
ooooooooo`0Aooooo`006oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool06oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo08Go
oooo00?oof42ooooooooool0B?ooool00ol0003oooooooooo`0>ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Jooooo`;oof421Oooool00ooo
H@;oooooooooo`0Rooooo`?oof4200CooooooomQ0_ooH@;oof42ZOooool00ol0003oooooooooo`0A
ooooo`007?ooool2o`0000Sooooo1Ol00004ooooo`;o00007Oooool00oooH@;oooooooooo`04oooo
o`03oomQ0_oooooooooo0=3ooooo00?o0000ooooooooool03oooool2o`0000Sooooo1Ol00004oooo
o`;o00007Oooool01OooH@;oooooooooooooooooof4202Sooooo00?oof42ooooooooool0ZOooool2
o`0001?ooooo000_ooooo`03o`000?oooooooooo01gooooo0_ooH@82ooooo`;oof42doooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo01gooooo0oooH@;Fooooo`03o`000?oooooooooo
017ooooo000_ooooo`03o`000?oooooooooo01oooooo0_ooH@;Eooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003ooooo
ooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003ooooo
ooooo`0Aooooo`00;oooool2o`000?Oooooo00?o0000ooooooooool08_ooool2o`000?Kooooo0_l0
000Cooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`3foooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aoooo
o`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool2o`000?Oooooo00?o0000ooooooooool0
8_ooool2o`000?Kooooo0_l0000Cooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool0
0ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool0
0ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool2o`000?Oo
oooo00?o0000ooooooooool08_ooool2o`000?Kooooo0_l0000Cooooo`005_ooool2o`0000Cooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003ooooo
ooooo`3fooooo`03o`000?oooooooooo00Wooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0m_ooool00ol0003ooooo
ooooo`0Aooooo`005Oooool01?l0003oooooooooool00009ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?Kooooo00?o0000oooooooo
ool02?ooool01?l0003oooooooooool00009ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool04Oooool0
01Gooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`08ooooo`04o`000?oooooo
ooooo`0000[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0?Kooooo00?o0000ooooooooool04Oooool001Gooooo00Co0000oooooooooooo00002_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0ol0003eooooo`;o00002_oo
ool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
0_ooool3o`000?Gooooo0_l0000Cooooo`005Oooool01?l0003oooooooooool0000;ooooo`03o`00
0?oooooo000000?o00001Oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo00Sooooo
00Co0000oooooooooooo00002oooool00ol0003oooooo`000003o`0000Gooooo00?o0000oooooooo
ool0m_ooool00ol0003oooooooooo`0Aooooo`005Oooool01?l0003oooooooooool00007ooooo`07
o`000?ooooooooooooooool0003oooooo`000008ooooo`03o`000?oooooooooo0?Kooooo00?o0000
ooooooooool02?ooool01?l0003oooooooooool00007ooooo`07o`000?ooooooooooooooool0003o
ooooo`000008ooooo`03o`000?oooooooooo0?Kooooo00?o0000ooooooooool04Oooool001Kooooo
0_l00008ooooo`Go000000?oooooo`000?l000000ol00004ooooo`03o`000?oooooooooo0?Kooooo
00?o0000ooooooooool02Oooool2o`0000Sooooo1Ol000000ooooooo0000o`000003o`0000Cooooo
00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool2o`000?Oooooo00?o
0000ooooooooool08_ooool2o`000?Kooooo0_l0000Cooooo`00;oooool00ol0003oooooooooo`3f
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0A
ooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`3fooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00
;oooool2o`000?Oooooo00?o0000ooooooooool08_ooool2o`000?Kooooo0_l0000Cooooo`00;ooo
ool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_oo
ool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool2o`00
0?Oooooo00?o0000ooooooooool08_ooool2o`000?Kooooo0_l0000Cooooo`00;oooool00ol0003o
ooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003o
ooooooooo`0Aooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0m_ooool00ol0003oooooooooo`0Aooooo`00;oooool00ol0003ooooooooo
o`3fooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0m_ooool00ol0003ooooooooo
o`0Aooooo`00;oooool2o`000?Oooooo00?o0000ooooooooool08_ooool2o`000?Kooooo0_l0000C
ooooo`00;oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0m_ooool00ol0003oooooooooo`0Aooooo`009oooool3o`0000Gooooo00?o0000oooooooo
ool0m_ooool00ol0003oooooooooo`0Jooooo`?o00001Oooool00ol0003oooooooooo`3fooooo`03
o`000?oooooooooo017ooooo000Xooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00002oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000001gooooo00?o0000oooooooo
ool01?ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ool000004oooool002Sooooo00?o0000ooooooooool01?ooooojo`0001gooooo00?o0000oooooooo
ool01?ooooojo`0001?ooooo000Xooooo`03o`000?oooooooooo0?oooooo7?ooool00ol0003ooooo
ooooo`3ooooooa;ooooo000Xooooo`03o`000?oooooooooo0?oooooo7?ooool00ol0003ooooooooo
o`3ooooooa;ooooo000Wooooo`;o0000oooooolMooooo`;o0000oooooolDooooo`00:?ooool00ol0
003oooooooooo`3ooooooacooooo00?o0000ooooooooool0oooooolBooooo`00oooooooooooooeco
oooo003oooooooooooooG?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo003ooooo
ooooooooG?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo003oooooooooooooG?oo
ool00?oooooooooooomLooooo`00oooooooooooooecooooo003oooooooooooooG?ooool00?oooooo
oooooomLooooo`00\
\>"],
  ImageRangeCache->{{{0, 601.062}, {371.125, 0}} -> {-0.0509998, -0.0309082, \
0.00349714, 0.00349714}, {{14.5625, 300.5}, {362.25, 185.562}} -> {-1.76857, \
-2.56265, 0.0399615, 0.0253566}, {{300.5, 586.438}, {362.25, 185.562}} -> \
{-13.1951, -2.56265, 0.0399615, 0.0253566}, {{14.5625, 300.5}, {185.562, \
8.8125}} -> {-2.05108, -3.60586, 0.0409208, 0.0129826}, {{300.5, 586.438}, \
{185.562, 8.8125}} -> {-13.7519, -3.60586, 0.0409208, 0.0129826}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["true parameters", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
THETA0 = { -16, -4, 1, 2, 0, 0};
PHI0 = Log[{.01, .01}]
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA0]
{R,H,d} = PARM[PHI0]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{Inherited, -2}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({\(-4.605170185988091`\), \(-4.605170185988091`\)}\)], "Output"],

Cell[BoxData[
    \({{{1.`*^-8, 0.`}, {0.`, 4.`}}, {{0, 
          1}, {\(-16\), \(-4\)}}, {{0}, {1}}, {{1.`, 0}, {0, 1.`}}, {0, 
        0}}\)], "Output"],

Cell[BoxData[
    \({{{0.010000000000000005`, 0}, {0, 0.010000000000000005`}}, {{1, 0}, {0, 
          1}}, {{0}, {0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YGt,PGt,YFt,PFt,LIKt} = 
\tMGLATT1[ZM,Xint,K,P,Q,n,np,T,DT,THETA0,PHI0,NONLIN,MISS];\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{Inherited, -2}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-0.4112440068432943`\), 
        0.5368597890233188`, \(-0.055211469022736305`\), \
\(-0.45517390491189696`\), 0.36672640684195246`, \(-0.12479380433932591`\), 
        1.3797542127870763`, \(-0.6524215907377521`\), \(-0.3085947650263319`\
\), \(-1.5125188486349967`\)}, {\(-1.492397546590675`\), 
        0.24944288448585888`, \(-0.858136823237616`\), \(-1.6301663790788419`\
\), 1.0026990533699027`, \(-1.6218991659892485`\), \(-1.4779799581956927`\), \
\(-0.2471652765086586`\), \(-1.071336593797615`\), 
        1.5426200540044062`}}\)], "Print"],

Cell[BoxData[
    \({{\(-0.4071722840032617`\), 
        0.5315443455676423`, \(-0.0546648208145904`\), \(-0.4506672325860366`\
\), 0.36309545231876483`, \(-0.12355822211814446`\), 
        1.3660932799872043`, \(-0.6459619710274773`\), \
\(-0.30553937131319986`\), \(-1.4975434144900959`\)}, {\(-1.4776213332580939`\
\), 0.24697315295629593`, \(-0.8496404190471445`\), \(-1.6140261178998434`\), 
        0.9927713399702007`, \(-1.6058407584051966`\), \
\(-1.463346493263062`\), \(-0.24471809555312732`\), \(-1.0607293007897178`\), 
        1.5273465881231745`}}\)], "Print"],

Cell[BoxData[
    \({{{0.009900990099009906`, 0.`}, {0.`, 
          0.009900990099009906`}}}\)], "Print"],

Cell[BoxData[
    \({2, 2, 1, 10, 1}\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
glatt1 =  graph[Z,Y,YGt,PGt,tau1,1,1,{{-0.1,10.1},{-1,1}}];
glatt2 =  graph[Z,Y,YGt,PGt,tau2,2,1,{{-0.1,10.1},{-2,2}}];
filter1 = graph[Z,Y,YFt,PFt,tau1,1,1,{{-0.1,10.1},{-1,1}}];
filter2 = graph[Z,Y,YFt,PFt,tau2,2,1,{{-0.1,10.1},{-2,2}}];
Show[GraphicsArray[{{filter1,glatt1},
\t\t\t\t\t{filter2,glatt2}} ]];\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{Inherited, -2}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 2}\),
      SequenceForm[ "Dimension der Daten  ", {15, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{4, 2}\),
      SequenceForm[ "Dimension der Daten  ", {4, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 2}\),
      SequenceForm[ "Dimension der Daten  ", {15, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{4, 2}\),
      SequenceForm[ "Dimension der Daten  ", {4, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 2}\),
      SequenceForm[ "Dimension der Daten  ", {101, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 5}\),
      SequenceForm[ "Dimension der Daten  ", {101, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.154508 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -24 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -12 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -24 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -18 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -18 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-1.5)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-1)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.5)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(1)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(1.5)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(2)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .3515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .08699 m
.01961 .28625 L
.02941 .29821 L
.03922 .29225 L
.04902 .27921 L
.05882 .42997 L
.06863 .52627 L
.07843 .44098 L
.08824 .4912 L
.09804 .53359 L
.10784 .55182 L
.11765 .41564 L
.12745 .14889 L
.13725 .27876 L
.14706 .19507 L
.15686 .10718 L
.16667 .0936 L
.17647 .20584 L
.18627 .22099 L
.19608 .34588 L
.20588 .28149 L
.21569 .35991 L
.22549 .3511 L
.23529 .41499 L
.2451 .31679 L
.2549 .33935 L
.26471 .28585 L
.27451 .32521 L
.28431 .34354 L
.29412 .33235 L
.30392 .3644 L
.31373 .36726 L
.32353 .38155 L
.33333 .28835 L
.34314 .2774 L
.35294 .24397 L
.36275 .21875 L
.37255 .15731 L
.38235 .14252 L
.39216 .19833 L
.40196 .14113 L
.41176 .28076 L
.42157 .26654 L
.43137 .26164 L
.44118 .32872 L
.45098 .36755 L
.46078 .43962 L
.47059 .31157 L
.48039 .33404 L
.4902 .20253 L
Mistroke
.5 .26362 L
.5098 .36522 L
.51961 .44988 L
.52941 .38102 L
.53922 .30637 L
.54902 .38279 L
.55882 .30375 L
.56863 .28199 L
.57843 .33459 L
.58824 .33274 L
.59804 .438 L
.60784 .49963 L
.61765 .27546 L
.62745 .21995 L
.63725 .20663 L
.64706 .39623 L
.65686 .40258 L
.66667 .51694 L
.67647 .42166 L
.68627 .26448 L
.69608 .28613 L
.70588 .13121 L
.71569 .11973 L
.72549 .259 L
.73529 .16639 L
.7451 .21429 L
.7549 .35003 L
.76471 .42666 L
.77451 .42431 L
.78431 .23692 L
.79412 .29525 L
.80392 .41598 L
.81373 .47532 L
.82353 .52772 L
.83333 .3836 L
.84314 .23162 L
.85294 .25703 L
.86275 .12478 L
.87255 .09122 L
.88235 .2596 L
.89216 .20098 L
.90196 .33053 L
.91176 .23056 L
.92157 .17375 L
.93137 .28417 L
.94118 .27174 L
.95098 .2987 L
.96078 .47444 L
.97059 .42053 L
.98039 .39838 L
Mistroke
.9902 .3515 L
Mfstroke
0 .98 .604 r
gsave
.9902 .33228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .08071 m
.01961 .26301 L
.02941 .3912 L
.03922 .46643 L
.04902 .49638 L
.05882 .47935 L
.06863 .4792 L
.07843 .45695 L
.08824 .42279 L
.09804 .38508 L
.10784 .35678 L
.11765 .29198 L
.12745 .25075 L
.13725 .2307 L
.14706 .22745 L
.15686 .12846 L
.16667 .20038 L
.17647 .26272 L
.18627 .31054 L
.19608 .34239 L
.20588 .33923 L
.21569 .39932 L
.22549 .42784 L
.23529 .4315 L
.2451 .41801 L
.2549 .39479 L
.26471 .36806 L
.27451 .34246 L
.28431 .32095 L
.29412 .30498 L
.30392 .2948 L
.31373 .28982 L
.32353 .28899 L
.33333 .29103 L
.34314 .29474 L
.35294 .29909 L
.36275 .30329 L
.37255 .30686 L
.38235 .30953 L
.39216 .31125 L
.40196 .31209 L
.41176 .35421 L
.42157 .37656 L
.43137 .38276 L
.44118 .37731 L
.45098 .36478 L
.46078 .34912 L
.47059 .3334 L
.48039 .3197 L
.4902 .30912 L
Mistroke
.5 .30162 L
.5098 .31942 L
.51961 .33 L
.52941 .33435 L
.53922 .33398 L
.54902 .33048 L
.55882 .30423 L
.56863 .28725 L
.57843 .2787 L
.58824 .27692 L
.59804 .2799 L
.60784 .28569 L
.61765 .2926 L
.62745 .29937 L
.63725 .30517 L
.64706 .30955 L
.65686 .31242 L
.66667 .3139 L
.67647 .31426 L
.68627 .31382 L
.69608 .26248 L
.70588 .21594 L
.71569 .19686 L
.72549 .19866 L
.73529 .21423 L
.7451 .21294 L
.7549 .28652 L
.76471 .33876 L
.77451 .36991 L
.78431 .38287 L
.79412 .38576 L
.80392 .35615 L
.81373 .33018 L
.82353 .31001 L
.83333 .29636 L
.84314 .29293 L
.85294 .26836 L
.86275 .25718 L
.87255 .25644 L
.88235 .26278 L
.89216 .18137 L
.90196 .23609 L
.91176 .24617 L
.92157 .32073 L
.93137 .36231 L
.94118 .38324 L
.95098 .38762 L
.96078 .38032 L
.97059 .36615 L
.98039 .34922 L
Mistroke
.9902 .33228 L
Mfstroke
0 0 1 r
gsave
.9902 .33228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .08071 m
.01961 .26301 L
.02941 .3912 L
.03922 .46643 L
.04902 .49638 L
.05882 .47935 L
.06863 .4792 L
.07843 .45695 L
.08824 .42279 L
.09804 .38508 L
.10784 .35678 L
.11765 .29198 L
.12745 .25075 L
.13725 .2307 L
.14706 .22745 L
.15686 .12846 L
.16667 .20038 L
.17647 .26272 L
.18627 .31054 L
.19608 .34239 L
.20588 .33923 L
.21569 .39932 L
.22549 .42784 L
.23529 .4315 L
.2451 .41801 L
.2549 .39479 L
.26471 .36806 L
.27451 .34246 L
.28431 .32095 L
.29412 .30498 L
.30392 .2948 L
.31373 .28982 L
.32353 .28899 L
.33333 .29103 L
.34314 .29474 L
.35294 .29909 L
.36275 .30329 L
.37255 .30686 L
.38235 .30953 L
.39216 .31125 L
.40196 .31209 L
.41176 .35421 L
.42157 .37656 L
.43137 .38276 L
.44118 .37731 L
.45098 .36478 L
.46078 .34912 L
.47059 .3334 L
.48039 .3197 L
.4902 .30912 L
Mistroke
.5 .30162 L
.5098 .31942 L
.51961 .33 L
.52941 .33435 L
.53922 .33398 L
.54902 .33048 L
.55882 .30423 L
.56863 .28725 L
.57843 .2787 L
.58824 .27692 L
.59804 .2799 L
.60784 .28569 L
.61765 .2926 L
.62745 .29937 L
.63725 .30517 L
.64706 .30955 L
.65686 .31242 L
.66667 .3139 L
.67647 .31426 L
.68627 .31382 L
.69608 .26248 L
.70588 .21594 L
.71569 .19686 L
.72549 .19866 L
.73529 .21423 L
.7451 .21294 L
.7549 .28652 L
.76471 .33876 L
.77451 .36991 L
.78431 .38287 L
.79412 .38576 L
.80392 .35615 L
.81373 .33018 L
.82353 .31001 L
.83333 .29636 L
.84314 .29293 L
.85294 .26836 L
.86275 .25718 L
.87255 .25644 L
.88235 .26278 L
.89216 .18137 L
.90196 .23609 L
.91176 .24617 L
.92157 .32073 L
.93137 .36231 L
.94118 .38324 L
.95098 .38762 L
.96078 .38032 L
.97059 .36615 L
.98039 .34922 L
Mistroke
.9902 .33228 L
Mfstroke
0 .98 .604 r
gsave
.9902 .33228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .08071 m
.01961 .26301 L
.02941 .3912 L
.03922 .46643 L
.04902 .49638 L
.05882 .47935 L
.06863 .4792 L
.07843 .45695 L
.08824 .42279 L
.09804 .38508 L
.10784 .35678 L
.11765 .29198 L
.12745 .25075 L
.13725 .2307 L
.14706 .22745 L
.15686 .12846 L
.16667 .20038 L
.17647 .26272 L
.18627 .31054 L
.19608 .34239 L
.20588 .33923 L
.21569 .39932 L
.22549 .42784 L
.23529 .4315 L
.2451 .41801 L
.2549 .39479 L
.26471 .36806 L
.27451 .34246 L
.28431 .32095 L
.29412 .30498 L
.30392 .2948 L
.31373 .28982 L
.32353 .28899 L
.33333 .29103 L
.34314 .29474 L
.35294 .29909 L
.36275 .30329 L
.37255 .30686 L
.38235 .30953 L
.39216 .31125 L
.40196 .31209 L
.41176 .35421 L
.42157 .37656 L
.43137 .38276 L
.44118 .37731 L
.45098 .36478 L
.46078 .34912 L
.47059 .3334 L
.48039 .3197 L
.4902 .30912 L
Mistroke
.5 .30162 L
.5098 .31942 L
.51961 .33 L
.52941 .33435 L
.53922 .33398 L
.54902 .33048 L
.55882 .30423 L
.56863 .28725 L
.57843 .2787 L
.58824 .27692 L
.59804 .2799 L
.60784 .28569 L
.61765 .2926 L
.62745 .29937 L
.63725 .30517 L
.64706 .30955 L
.65686 .31242 L
.66667 .3139 L
.67647 .31426 L
.68627 .31382 L
.69608 .26248 L
.70588 .21594 L
.71569 .19686 L
.72549 .19866 L
.73529 .21423 L
.7451 .21294 L
.7549 .28652 L
.76471 .33876 L
.77451 .36991 L
.78431 .38287 L
.79412 .38576 L
.80392 .35615 L
.81373 .33018 L
.82353 .31001 L
.83333 .29636 L
.84314 .29293 L
.85294 .26836 L
.86275 .25718 L
.87255 .25644 L
.88235 .26278 L
.89216 .18137 L
.90196 .23609 L
.91176 .24617 L
.92157 .32073 L
.93137 .36231 L
.94118 .38324 L
.95098 .38762 L
.96078 .38032 L
.97059 .36615 L
.98039 .34922 L
Mistroke
.9902 .33228 L
Mfstroke
1 .38 .01 r
gsave
.9902 .54171 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .11085 m
.01961 .42402 L
.02941 .57817 L
s
.02941 .57817 m
.03434 .61803 L
s
.08623 .61803 m
.08824 .61068 L
.09804 .57673 L
.10784 .55489 L
.11765 .49078 L
.12745 .44222 L
.13725 .41897 L
.14706 .41907 L
.15686 .1584 L
.16667 .37041 L
.17647 .46789 L
.18627 .52324 L
.19608 .55215 L
.20588 .54357 L
.21569 .59964 L
s
.21569 .59964 m
.22499 .61803 L
s
.23673 .61803 m
.2451 .60988 L
.2549 .594 L
.26471 .5742 L
.27451 .5533 L
.28431 .53412 L
.29412 .51885 L
.30392 .50859 L
.31373 .50339 L
.32353 .50247 L
.33333 .5046 L
.34314 .50848 L
.35294 .51301 L
.36275 .51734 L
.37255 .52097 L
.38235 .52366 L
.39216 .52538 L
.40196 .52621 L
.41176 .55981 L
.42157 .56986 L
.43137 .57114 L
.44118 .5692 L
.45098 .56415 L
.46078 .55563 L
.47059 .54468 L
.48039 .53325 L
.4902 .52325 L
.5 .51556 L
.5098 .52488 L
.51961 .5232 L
.52941 .5227 L
.53922 .52586 L
.54902 .52985 L
.55882 .51073 L
.56863 .49853 L
.57843 .49226 L
.58824 .49105 L
.59804 .49384 L
.60784 .49931 L
.61765 .5061 L
.62745 .51294 L
.63725 .51891 L
.64706 .52348 L
.65686 .52648 L
.66667 .52802 L
.67647 .5284 L
.68627 .52795 L
.69608 .29246 L
.70588 .37584 L
.71569 .38158 L
Mistroke
.72549 .38704 L
.73529 .40261 L
.7451 .40132 L
.7549 .48031 L
.76471 .5283 L
.77451 .55779 L
.78431 .57449 L
.79412 .58376 L
.80392 .5549 L
.81373 .52162 L
.82353 .49827 L
.83333 .48798 L
.84314 .49111 L
.85294 .46722 L
.86275 .4487 L
.87255 .44472 L
.88235 .4544 L
.89216 .21131 L
.90196 .39561 L
.91176 .42247 L
.92157 .493 L
.93137 .54521 L
.94118 .56638 L
.95098 .57247 L
.96078 .57081 L
.97059 .56411 L
.98039 .55393 L
.9902 .54171 L
Mfstroke
gsave
.9902 .12286 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .05058 m
.01961 .102 L
.02941 .20423 L
.03922 .27537 L
.04902 .30566 L
.05882 .28923 L
.06863 .2847 L
.07843 .26724 L
.08824 .2349 L
.09804 .19344 L
.10784 .15867 L
.11765 .09318 L
.12745 .05928 L
.13725 .04244 L
.14706 .03584 L
.15686 .09853 L
.16667 .03035 L
.17647 .05756 L
.18627 .09784 L
.19608 .13263 L
.20588 .1349 L
.21569 .19899 L
.22549 .23665 L
.23529 .24356 L
.2451 .22615 L
.2549 .19558 L
.26471 .16192 L
.27451 .13163 L
.28431 .10778 L
.29412 .0911 L
.30392 .081 L
.31373 .07625 L
.32353 .0755 L
.33333 .07747 L
.34314 .081 L
.35294 .08517 L
.36275 .08925 L
.37255 .09275 L
.38235 .0954 L
.39216 .09712 L
.40196 .09797 L
.41176 .14861 L
.42157 .18327 L
.43137 .19437 L
.44118 .18543 L
.45098 .16541 L
.46078 .14261 L
.47059 .12212 L
.48039 .10614 L
.4902 .09498 L
Mistroke
.5 .08769 L
.5098 .11396 L
.51961 .13679 L
.52941 .14601 L
.53922 .1421 L
.54902 .13111 L
.55882 .09772 L
.56863 .07597 L
.57843 .06515 L
.58824 .06279 L
.59804 .06597 L
.60784 .07206 L
.61765 .07911 L
.62745 .08581 L
.63725 .09142 L
.64706 .09562 L
.65686 .09837 L
.66667 .09978 L
.67647 .10012 L
.68627 .09968 L
.69608 .23249 L
.70588 .05604 L
.71569 .01214 L
.72549 .01028 L
.73529 .02586 L
.7451 .02457 L
.7549 .09272 L
.76471 .14922 L
.77451 .18203 L
.78431 .19125 L
.79412 .18775 L
.80392 .15741 L
.81373 .13873 L
.82353 .12175 L
.83333 .10475 L
.84314 .09474 L
.85294 .0695 L
.86275 .06567 L
.87255 .06815 L
.88235 .07116 L
.89216 .15144 L
.90196 .07657 L
.91176 .06988 L
.92157 .14846 L
.93137 .17941 L
.94118 .20011 L
.95098 .20277 L
.96078 .18984 L
.97059 .16819 L
.98039 .14451 L
Mistroke
.9902 .12286 L
Mfstroke
0 g
gsave
.89216 .17921 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .07843 Mdot
.15686 .12596 Mdot
.69608 .26147 Mdot
.89216 .17921 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.154508 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -24 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -12 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -24 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -18 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -18 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-1.5)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-1)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.5)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(1)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(1.5)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(2)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .3515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .08699 m
.01961 .28625 L
.02941 .29821 L
.03922 .29225 L
.04902 .27921 L
.05882 .42997 L
.06863 .52627 L
.07843 .44098 L
.08824 .4912 L
.09804 .53359 L
.10784 .55182 L
.11765 .41564 L
.12745 .14889 L
.13725 .27876 L
.14706 .19507 L
.15686 .10718 L
.16667 .0936 L
.17647 .20584 L
.18627 .22099 L
.19608 .34588 L
.20588 .28149 L
.21569 .35991 L
.22549 .3511 L
.23529 .41499 L
.2451 .31679 L
.2549 .33935 L
.26471 .28585 L
.27451 .32521 L
.28431 .34354 L
.29412 .33235 L
.30392 .3644 L
.31373 .36726 L
.32353 .38155 L
.33333 .28835 L
.34314 .2774 L
.35294 .24397 L
.36275 .21875 L
.37255 .15731 L
.38235 .14252 L
.39216 .19833 L
.40196 .14113 L
.41176 .28076 L
.42157 .26654 L
.43137 .26164 L
.44118 .32872 L
.45098 .36755 L
.46078 .43962 L
.47059 .31157 L
.48039 .33404 L
.4902 .20253 L
Mistroke
.5 .26362 L
.5098 .36522 L
.51961 .44988 L
.52941 .38102 L
.53922 .30637 L
.54902 .38279 L
.55882 .30375 L
.56863 .28199 L
.57843 .33459 L
.58824 .33274 L
.59804 .438 L
.60784 .49963 L
.61765 .27546 L
.62745 .21995 L
.63725 .20663 L
.64706 .39623 L
.65686 .40258 L
.66667 .51694 L
.67647 .42166 L
.68627 .26448 L
.69608 .28613 L
.70588 .13121 L
.71569 .11973 L
.72549 .259 L
.73529 .16639 L
.7451 .21429 L
.7549 .35003 L
.76471 .42666 L
.77451 .42431 L
.78431 .23692 L
.79412 .29525 L
.80392 .41598 L
.81373 .47532 L
.82353 .52772 L
.83333 .3836 L
.84314 .23162 L
.85294 .25703 L
.86275 .12478 L
.87255 .09122 L
.88235 .2596 L
.89216 .20098 L
.90196 .33053 L
.91176 .23056 L
.92157 .17375 L
.93137 .28417 L
.94118 .27174 L
.95098 .2987 L
.96078 .47444 L
.97059 .42053 L
.98039 .39838 L
Mistroke
.9902 .3515 L
Mfstroke
0 .98 .604 r
gsave
.9902 .33228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .07976 m
.01961 .23317 L
.02941 .34624 L
.03922 .42407 L
.04902 .4765 L
.05882 .51459 L
.06863 .53252 L
.07843 .5225 L
.08824 .49066 L
.09804 .44127 L
.10784 .37683 L
.11765 .31027 L
.12745 .25311 L
.13725 .20406 L
.14706 .16191 L
.15686 .12697 L
.16667 .15358 L
.17647 .18401 L
.18627 .22136 L
.19608 .27078 L
.20588 .33769 L
.21569 .39777 L
.22549 .42712 L
.23529 .4324 L
.2451 .42117 L
.2549 .40059 L
.26471 .37647 L
.27451 .3529 L
.28431 .33216 L
.29412 .31498 L
.30392 .30092 L
.31373 .28888 L
.32353 .27764 L
.33333 .26636 L
.34314 .25501 L
.35294 .24462 L
.36275 .23746 L
.37255 .23689 L
.38235 .247 L
.39216 .27199 L
.40196 .3152 L
.41176 .35608 L
.42157 .37432 L
.43137 .37394 L
.44118 .36034 L
.45098 .33942 L
.46078 .31697 L
.47059 .29827 L
.48039 .28778 L
.4902 .2889 L
Mistroke
.5 .30368 L
.5098 .32115 L
.51961 .33003 L
.52941 .33145 L
.53922 .32723 L
.54902 .31953 L
.55882 .28949 L
.56863 .27015 L
.57843 .26179 L
.58824 .26388 L
.59804 .27541 L
.60784 .29498 L
.61765 .32071 L
.62745 .35011 L
.63725 .37978 L
.64706 .40524 L
.65686 .4209 L
.66667 .42035 L
.67647 .39695 L
.68627 .34498 L
.69608 .26111 L
.70588 .16807 L
.71569 .11914 L
.72549 .11441 L
.73529 .15157 L
.7451 .22647 L
.7549 .30861 L
.76471 .36841 L
.77451 .40411 L
.78431 .41634 L
.79412 .40716 L
.80392 .38846 L
.81373 .37118 L
.82353 .35498 L
.83333 .33772 L
.84314 .31632 L
.85294 .29269 L
.86275 .26895 L
.87255 .24255 L
.88235 .21237 L
.89216 .17962 L
.90196 .1955 L
.91176 .2487 L
.92157 .30542 L
.93137 .33092 L
.94118 .3344 L
.95098 .32387 L
.96078 .30899 L
.97059 .29975 L
.98039 .3052 L
Mistroke
.9902 .33228 L
Mfstroke
0 0 1 r
gsave
.9902 .33228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .07976 m
.01961 .23317 L
.02941 .34624 L
.03922 .42407 L
.04902 .4765 L
.05882 .51459 L
.06863 .53252 L
.07843 .5225 L
.08824 .49066 L
.09804 .44127 L
.10784 .37683 L
.11765 .31027 L
.12745 .25311 L
.13725 .20406 L
.14706 .16191 L
.15686 .12697 L
.16667 .15358 L
.17647 .18401 L
.18627 .22136 L
.19608 .27078 L
.20588 .33769 L
.21569 .39777 L
.22549 .42712 L
.23529 .4324 L
.2451 .42117 L
.2549 .40059 L
.26471 .37647 L
.27451 .3529 L
.28431 .33216 L
.29412 .31498 L
.30392 .30092 L
.31373 .28888 L
.32353 .27764 L
.33333 .26636 L
.34314 .25501 L
.35294 .24462 L
.36275 .23746 L
.37255 .23689 L
.38235 .247 L
.39216 .27199 L
.40196 .3152 L
.41176 .35608 L
.42157 .37432 L
.43137 .37394 L
.44118 .36034 L
.45098 .33942 L
.46078 .31697 L
.47059 .29827 L
.48039 .28778 L
.4902 .2889 L
Mistroke
.5 .30368 L
.5098 .32115 L
.51961 .33003 L
.52941 .33145 L
.53922 .32723 L
.54902 .31953 L
.55882 .28949 L
.56863 .27015 L
.57843 .26179 L
.58824 .26388 L
.59804 .27541 L
.60784 .29498 L
.61765 .32071 L
.62745 .35011 L
.63725 .37978 L
.64706 .40524 L
.65686 .4209 L
.66667 .42035 L
.67647 .39695 L
.68627 .34498 L
.69608 .26111 L
.70588 .16807 L
.71569 .11914 L
.72549 .11441 L
.73529 .15157 L
.7451 .22647 L
.7549 .30861 L
.76471 .36841 L
.77451 .40411 L
.78431 .41634 L
.79412 .40716 L
.80392 .38846 L
.81373 .37118 L
.82353 .35498 L
.83333 .33772 L
.84314 .31632 L
.85294 .29269 L
.86275 .26895 L
.87255 .24255 L
.88235 .21237 L
.89216 .17962 L
.90196 .1955 L
.91176 .2487 L
.92157 .30542 L
.93137 .33092 L
.94118 .3344 L
.95098 .32387 L
.96078 .30899 L
.97059 .29975 L
.98039 .3052 L
Mistroke
.9902 .33228 L
Mfstroke
0 .98 .604 r
gsave
.9902 .33228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .07976 m
.01961 .23317 L
.02941 .34624 L
.03922 .42407 L
.04902 .4765 L
.05882 .51459 L
.06863 .53252 L
.07843 .5225 L
.08824 .49066 L
.09804 .44127 L
.10784 .37683 L
.11765 .31027 L
.12745 .25311 L
.13725 .20406 L
.14706 .16191 L
.15686 .12697 L
.16667 .15358 L
.17647 .18401 L
.18627 .22136 L
.19608 .27078 L
.20588 .33769 L
.21569 .39777 L
.22549 .42712 L
.23529 .4324 L
.2451 .42117 L
.2549 .40059 L
.26471 .37647 L
.27451 .3529 L
.28431 .33216 L
.29412 .31498 L
.30392 .30092 L
.31373 .28888 L
.32353 .27764 L
.33333 .26636 L
.34314 .25501 L
.35294 .24462 L
.36275 .23746 L
.37255 .23689 L
.38235 .247 L
.39216 .27199 L
.40196 .3152 L
.41176 .35608 L
.42157 .37432 L
.43137 .37394 L
.44118 .36034 L
.45098 .33942 L
.46078 .31697 L
.47059 .29827 L
.48039 .28778 L
.4902 .2889 L
Mistroke
.5 .30368 L
.5098 .32115 L
.51961 .33003 L
.52941 .33145 L
.53922 .32723 L
.54902 .31953 L
.55882 .28949 L
.56863 .27015 L
.57843 .26179 L
.58824 .26388 L
.59804 .27541 L
.60784 .29498 L
.61765 .32071 L
.62745 .35011 L
.63725 .37978 L
.64706 .40524 L
.65686 .4209 L
.66667 .42035 L
.67647 .39695 L
.68627 .34498 L
.69608 .26111 L
.70588 .16807 L
.71569 .11914 L
.72549 .11441 L
.73529 .15157 L
.7451 .22647 L
.7549 .30861 L
.76471 .36841 L
.77451 .40411 L
.78431 .41634 L
.79412 .40716 L
.80392 .38846 L
.81373 .37118 L
.82353 .35498 L
.83333 .33772 L
.84314 .31632 L
.85294 .29269 L
.86275 .26895 L
.87255 .24255 L
.88235 .21237 L
.89216 .17962 L
.90196 .1955 L
.91176 .2487 L
.92157 .30542 L
.93137 .33092 L
.94118 .3344 L
.95098 .32387 L
.96078 .30899 L
.97059 .29975 L
.98039 .3052 L
Mistroke
.9902 .33228 L
Mfstroke
1 .38 .01 r
gsave
.9902 .54171 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .10984 m
.01961 .38276 L
.02941 .50534 L
.03922 .57979 L
s
.03922 .57979 m
.04526 .61803 L
s
.09701 .61803 m
.09804 .61475 L
.10784 .56712 L
.11765 .49982 L
.12745 .441 L
.13725 .39028 L
.14706 .32415 L
.15686 .15686 L
.16667 .31538 L
.17647 .36945 L
.18627 .40955 L
.19608 .4651 L
.20588 .54201 L
.21569 .59809 L
s
.21569 .59809 m
.22536 .61803 L
s
.23836 .61803 m
.2451 .61299 L
.2549 .59962 L
.26471 .58226 L
.27451 .56319 L
.28431 .54471 L
.29412 .52834 L
.30392 .51451 L
.31373 .50244 L
.32353 .49055 L
.33333 .4771 L
.34314 .46116 L
.35294 .44381 L
.36275 .42928 L
.37255 .42522 L
.38235 .4402 L
.39216 .47743 L
.40196 .52912 L
.41176 .56159 L
.42157 .56754 L
.43137 .56088 L
.44118 .54664 L
.45098 .52626 L
.46078 .50328 L
.47059 .48522 L
.48039 .48101 L
.4902 .49441 L
.5 .5176 L
.5098 .52658 L
.51961 .52317 L
.52941 .51967 L
.53922 .51886 L
.54902 .5185 L
.55882 .49547 L
.56863 .48082 L
.57843 .47471 L
.58824 .47726 L
.59804 .48802 L
.60784 .50565 L
.61765 .52801 L
.62745 .55239 L
.63725 .57601 L
.64706 .59609 L
.65686 .60916 L
.66667 .60863 L
.67647 .58157 L
.68627 .50482 L
.69608 .29104 L
.70588 .31611 L
.71569 .27479 L
Mistroke
.72549 .26587 L
.73529 .31346 L
.7451 .40319 L
.7549 .47784 L
.76471 .52353 L
.77451 .56009 L
.78431 .58902 L
.79412 .59188 L
.80392 .56105 L
.81373 .52715 L
.82353 .51005 L
.83333 .50635 L
.84314 .49102 L
.85294 .45023 L
.86275 .41436 L
.87255 .39305 L
.88235 .35795 L
.89216 .20939 L
.90196 .33426 L
.91176 .40145 L
.92157 .47647 L
.93137 .50894 L
.94118 .5055 L
.95098 .4879 L
.96078 .47388 L
.97059 .47667 L
.98039 .50127 L
.9902 .54171 L
Mfstroke
gsave
.9902 .12286 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .04968 m
.01961 .08357 L
.02941 .18714 L
.03922 .26835 L
.04902 .31122 L
.05882 .33573 L
.06863 .36196 L
.07843 .3671 L
.08824 .33517 L
.09804 .26779 L
.10784 .18655 L
.11765 .12072 L
.12745 .06523 L
.13725 .01785 L
s
.13725 .01785 m
.14688 0 L
s
.14709 0 m
.15686 .09708 L
s
.15686 .09708 m
.1659 0 L
s
.17688 0 m
.18627 .03317 L
.19608 .07646 L
.20588 .13337 L
.21569 .19746 L
.22549 .23594 L
.23529 .24446 L
.2451 .22935 L
.2549 .20155 L
.26471 .17068 L
.27451 .1426 L
.28431 .11961 L
.29412 .10162 L
.30392 .08733 L
.31373 .07531 L
.32353 .06472 L
.33333 .05562 L
.34314 .04885 L
.35294 .04543 L
.36275 .04565 L
.37255 .04856 L
.38235 .0538 L
.39216 .06655 L
.40196 .10127 L
.41176 .15057 L
.42157 .18109 L
.43137 .18699 L
.44118 .17403 L
.45098 .15258 L
.46078 .13067 L
.47059 .11133 L
.48039 .09455 L
.4902 .08339 L
.5 .08977 L
.5098 .11573 L
.51961 .13689 L
.52941 .14324 L
.53922 .1356 L
.54902 .12055 L
.55882 .08352 L
.56863 .05948 L
.57843 .04886 L
.58824 .0505 L
.59804 .0628 L
.60784 .0843 L
.61765 .11342 L
.62745 .14783 L
.63725 .18355 L
.64706 .21438 L
.65686 .23265 L
Mistroke
.66667 .23207 L
.67647 .21232 L
.68627 .18514 L
.69608 .23117 L
.70588 .02003 L
Mfstroke
.70588 .02003 m
.70936 0 L
s
.73698 0 m
.7451 .04976 L
.7549 .13938 L
.76471 .21329 L
.77451 .24812 L
.78431 .24366 L
.79412 .22244 L
.80392 .21586 L
.81373 .21522 L
.82353 .1999 L
.83333 .16909 L
.84314 .14161 L
.85294 .13515 L
.86275 .12355 L
.87255 .09204 L
.88235 .0668 L
.89216 .14985 L
.90196 .05674 L
.91176 .09594 L
.92157 .13437 L
.93137 .15291 L
.94118 .16331 L
.95098 .15985 L
.96078 .14411 L
.97059 .12282 L
.98039 .10914 L
.9902 .12286 L
s
0 g
gsave
.89216 .17921 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .07843 Mdot
.15686 .12596 Mdot
.69608 .26147 Mdot
.89216 .17921 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.309017 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -30 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -24 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -30 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -24 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -18 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -24 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-0.75)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-0.5)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.25)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.25)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(0.5)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(0.75)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(1)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .29672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .2032 m
.01961 .18682 L
.02941 .18983 L
.03922 .18192 L
.04902 .18249 L
.05882 .19349 L
.06863 .2351 L
.07843 .27422 L
.08824 .30016 L
.09804 .34747 L
.10784 .39558 L
.11765 .43789 L
.12745 .43352 L
.13725 .41122 L
.14706 .3911 L
.15686 .35518 L
.16667 .31269 L
.17647 .27554 L
.18627 .24808 L
.19608 .25324 L
.20588 .25788 L
.21569 .26401 L
.22549 .27227 L
.23529 .2965 L
.2451 .30701 L
.2549 .30399 L
.26471 .31374 L
.27451 .30973 L
.28431 .31542 L
.29412 .31316 L
.30392 .31861 L
.31373 .3422 L
.32353 .36316 L
.33333 .36863 L
.34314 .36745 L
.35294 .3639 L
.36275 .35272 L
.37255 .33573 L
.38235 .31238 L
.39216 .27807 L
.40196 .25429 L
.41176 .24299 L
.42157 .24346 L
.43137 .23817 L
.44118 .24106 L
.45098 .23852 L
.46078 .26419 L
.47059 .27807 L
.48039 .28789 L
.4902 .28404 L
Mistroke
.5 .26612 L
.5098 .26468 L
.51961 .28082 L
.52941 .29282 L
.53922 .29004 L
.54902 .29681 L
.55882 .29399 L
.56863 .28802 L
.57843 .28719 L
.58824 .29761 L
.59804 .31928 L
.60784 .34873 L
.61765 .36383 L
.62745 .35183 L
.63725 .32582 L
.64706 .32364 L
.65686 .34359 L
.66667 .3719 L
.67647 .40747 L
.68627 .40655 L
.69608 .4063 L
.70588 .38409 L
.71569 .33984 L
.72549 .31732 L
.73529 .30148 L
.7451 .26785 L
.7549 .26559 L
.76471 .28095 L
.77451 .2967 L
.78431 .30232 L
.79412 .29639 L
.80392 .30838 L
.81373 .33089 L
.82353 .37221 L
.83333 .39626 L
.84314 .39321 L
.85294 .3885 L
.86275 .37021 L
.87255 .33555 L
.88235 .31475 L
.89216 .29375 L
.90196 .28273 L
.91176 .27456 L
.92157 .25623 L
.93137 .24246 L
.94118 .23955 L
.95098 .2235 L
.96078 .23336 L
.97059 .25742 L
.98039 .27675 L
Mistroke
.9902 .29672 L
Mfstroke
0 .98 .604 r
gsave
.9902 .27539 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .18319 m
.01961 .15663 L
.02941 .16116 L
.03922 .18596 L
.04902 .2211 L
.05882 .22498 L
.06863 .25949 L
.07843 .29158 L
.08824 .31788 L
.09804 .33686 L
.10784 .40023 L
.11765 .40291 L
.12745 .395 L
.13725 .38102 L
.14706 .36479 L
.15686 .34537 L
.16667 .31655 L
.17647 .30127 L
.18627 .29705 L
.19608 .30081 L
.20588 .23563 L
.21569 .24825 L
.22549 .26964 L
.23529 .29412 L
.2451 .31749 L
.2549 .33707 L
.26471 .35157 L
.27451 .36077 L
.28431 .36522 L
.29412 .36591 L
.30392 .36399 L
.31373 .36057 L
.32353 .35659 L
.33333 .35275 L
.34314 .34951 L
.35294 .34708 L
.36275 .34553 L
.37255 .34475 L
.38235 .3446 L
.39216 .34489 L
.40196 .28012 L
.41176 .28529 L
.42157 .29687 L
.43137 .31123 L
.44118 .32559 L
.45098 .33808 L
.46078 .34769 L
.47059 .35412 L
.48039 .35758 L
.4902 .3586 L
Mistroke
.5 .32437 L
.5098 .3248 L
.51961 .32805 L
.52941 .33277 L
.53922 .33787 L
.54902 .34255 L
.55882 .34406 L
.56863 .34125 L
.57843 .33592 L
.58824 .32958 L
.59804 .3234 L
.60784 .31812 L
.61765 .31414 L
.62745 .31154 L
.63725 .31022 L
.64706 .30991 L
.65686 .31033 L
.66667 .31118 L
.67647 .31221 L
.68627 .31322 L
.69608 .4155 L
.70588 .40103 L
.71569 .3801 L
.72549 .35756 L
.73529 .33687 L
.7451 .25852 L
.7549 .247 L
.76471 .24809 L
.77451 .25749 L
.78431 .27123 L
.79412 .31415 L
.80392 .3265 L
.81373 .33325 L
.82353 .33536 L
.83333 .33408 L
.84314 .36276 L
.85294 .35684 L
.86275 .34739 L
.87255 .3368 L
.88235 .32683 L
.89216 .32618 L
.90196 .30093 L
.91176 .26666 L
.92157 .2644 L
.93137 .27127 L
.94118 .28434 L
.95098 .29986 L
.96078 .315 L
.97059 .32792 L
.98039 .33767 L
Mistroke
.9902 .27539 L
Mfstroke
0 0 1 r
gsave
.9902 .27539 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .18319 m
.01961 .15663 L
.02941 .16116 L
.03922 .18596 L
.04902 .2211 L
.05882 .22498 L
.06863 .25949 L
.07843 .29158 L
.08824 .31788 L
.09804 .33686 L
.10784 .40023 L
.11765 .40291 L
.12745 .395 L
.13725 .38102 L
.14706 .36479 L
.15686 .34537 L
.16667 .31655 L
.17647 .30127 L
.18627 .29705 L
.19608 .30081 L
.20588 .23563 L
.21569 .24825 L
.22549 .26964 L
.23529 .29412 L
.2451 .31749 L
.2549 .33707 L
.26471 .35157 L
.27451 .36077 L
.28431 .36522 L
.29412 .36591 L
.30392 .36399 L
.31373 .36057 L
.32353 .35659 L
.33333 .35275 L
.34314 .34951 L
.35294 .34708 L
.36275 .34553 L
.37255 .34475 L
.38235 .3446 L
.39216 .34489 L
.40196 .28012 L
.41176 .28529 L
.42157 .29687 L
.43137 .31123 L
.44118 .32559 L
.45098 .33808 L
.46078 .34769 L
.47059 .35412 L
.48039 .35758 L
.4902 .3586 L
Mistroke
.5 .32437 L
.5098 .3248 L
.51961 .32805 L
.52941 .33277 L
.53922 .33787 L
.54902 .34255 L
.55882 .34406 L
.56863 .34125 L
.57843 .33592 L
.58824 .32958 L
.59804 .3234 L
.60784 .31812 L
.61765 .31414 L
.62745 .31154 L
.63725 .31022 L
.64706 .30991 L
.65686 .31033 L
.66667 .31118 L
.67647 .31221 L
.68627 .31322 L
.69608 .4155 L
.70588 .40103 L
.71569 .3801 L
.72549 .35756 L
.73529 .33687 L
.7451 .25852 L
.7549 .247 L
.76471 .24809 L
.77451 .25749 L
.78431 .27123 L
.79412 .31415 L
.80392 .3265 L
.81373 .33325 L
.82353 .33536 L
.83333 .33408 L
.84314 .36276 L
.85294 .35684 L
.86275 .34739 L
.87255 .3368 L
.88235 .32683 L
.89216 .32618 L
.90196 .30093 L
.91176 .26666 L
.92157 .2644 L
.93137 .27127 L
.94118 .28434 L
.95098 .29986 L
.96078 .315 L
.97059 .32792 L
.98039 .33767 L
Mistroke
.9902 .27539 L
Mfstroke
0 .98 .604 r
gsave
.9902 .27539 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .18319 m
.01961 .15663 L
.02941 .16116 L
.03922 .18596 L
.04902 .2211 L
.05882 .22498 L
.06863 .25949 L
.07843 .29158 L
.08824 .31788 L
.09804 .33686 L
.10784 .40023 L
.11765 .40291 L
.12745 .395 L
.13725 .38102 L
.14706 .36479 L
.15686 .34537 L
.16667 .31655 L
.17647 .30127 L
.18627 .29705 L
.19608 .30081 L
.20588 .23563 L
.21569 .24825 L
.22549 .26964 L
.23529 .29412 L
.2451 .31749 L
.2549 .33707 L
.26471 .35157 L
.27451 .36077 L
.28431 .36522 L
.29412 .36591 L
.30392 .36399 L
.31373 .36057 L
.32353 .35659 L
.33333 .35275 L
.34314 .34951 L
.35294 .34708 L
.36275 .34553 L
.37255 .34475 L
.38235 .3446 L
.39216 .34489 L
.40196 .28012 L
.41176 .28529 L
.42157 .29687 L
.43137 .31123 L
.44118 .32559 L
.45098 .33808 L
.46078 .34769 L
.47059 .35412 L
.48039 .35758 L
.4902 .3586 L
Mistroke
.5 .32437 L
.5098 .3248 L
.51961 .32805 L
.52941 .33277 L
.53922 .33787 L
.54902 .34255 L
.55882 .34406 L
.56863 .34125 L
.57843 .33592 L
.58824 .32958 L
.59804 .3234 L
.60784 .31812 L
.61765 .31414 L
.62745 .31154 L
.63725 .31022 L
.64706 .30991 L
.65686 .31033 L
.66667 .31118 L
.67647 .31221 L
.68627 .31322 L
.69608 .4155 L
.70588 .40103 L
.71569 .3801 L
.72549 .35756 L
.73529 .33687 L
.7451 .25852 L
.7549 .247 L
.76471 .24809 L
.77451 .25749 L
.78431 .27123 L
.79412 .31415 L
.80392 .3265 L
.81373 .33325 L
.82353 .33536 L
.83333 .33408 L
.84314 .36276 L
.85294 .35684 L
.86275 .34739 L
.87255 .3368 L
.88235 .32683 L
.89216 .32618 L
.90196 .30093 L
.91176 .26666 L
.92157 .2644 L
.93137 .27127 L
.94118 .28434 L
.95098 .29986 L
.96078 .315 L
.97059 .32792 L
.98039 .33767 L
Mistroke
.9902 .27539 L
Mfstroke
1 .38 .01 r
gsave
.9902 .32795 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .24346 m
.01961 .21599 L
.02941 .22565 L
.03922 .26165 L
.04902 .30856 L
.05882 .27628 L
.06863 .32164 L
.07843 .36972 L
.08824 .40928 L
.09804 .43685 L
.10784 .45262 L
.11765 .46497 L
.12745 .47324 L
.13725 .47284 L
.14706 .4653 L
.15686 .45001 L
.16667 .4159 L
.17647 .39308 L
.18627 .38629 L
.19608 .39293 L
.20588 .28706 L
.21569 .31099 L
.22549 .34934 L
.23529 .38736 L
.2451 .41905 L
.2549 .44257 L
.26471 .4582 L
.27451 .46726 L
.28431 .47133 L
.29412 .47188 L
.30392 .47011 L
.31373 .46698 L
.32353 .4633 L
.33333 .45967 L
.34314 .45653 L
.35294 .45414 L
.36275 .45258 L
.37255 .45179 L
.38235 .45164 L
.39216 .45193 L
.40196 .33283 L
.41176 .34809 L
.42157 .37692 L
.43137 .40517 L
.44118 .42793 L
.45098 .44422 L
.46078 .45476 L
.47059 .46084 L
.48039 .46378 L
.4902 .46459 L
Mistroke
.5 .37697 L
.5098 .38756 L
.51961 .4081 L
.52941 .42671 L
.53922 .4402 L
.54902 .44868 L
.55882 .45112 L
.56863 .44797 L
.57843 .44211 L
.58824 .43556 L
.59804 .42951 L
.60784 .42454 L
.61765 .42086 L
.62745 .41848 L
.63725 .41726 L
.64706 .41698 L
.65686 .41739 L
.66667 .41822 L
.67647 .41925 L
.68627 .42026 L
.69608 .46821 L
.70588 .4538 L
.71569 .44061 L
.72549 .43152 L
.73529 .42377 L
.7451 .30981 L
.7549 .30908 L
.76471 .32604 L
.77451 .34867 L
.78431 .37103 L
.79412 .36652 L
.80392 .38857 L
.81373 .41149 L
.82353 .42717 L
.83333 .43459 L
.84314 .41521 L
.85294 .41891 L
.86275 .42563 L
.87255 .42862 L
.88235 .42734 L
.89216 .3786 L
.90196 .34062 L
.91176 .30528 L
.92157 .30567 L
.93137 .33042 L
.94118 .36138 L
.95098 .39042 L
.96078 .4141 L
.97059 .43147 L
.98039 .443 L
Mistroke
.9902 .32795 L
Mfstroke
gsave
.9902 .22283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .12293 m
.01961 .09727 L
.02941 .09668 L
.03922 .11026 L
.04902 .13365 L
.05882 .17368 L
.06863 .19734 L
.07843 .21345 L
.08824 .22647 L
.09804 .23688 L
.10784 .34784 L
.11765 .34085 L
.12745 .31675 L
.13725 .2892 L
.14706 .26428 L
.15686 .24073 L
.16667 .2172 L
.17647 .20945 L
.18627 .20782 L
.19608 .20868 L
.20588 .1842 L
.21569 .18551 L
.22549 .18994 L
.23529 .20087 L
.2451 .21592 L
.2549 .23158 L
.26471 .24494 L
.27451 .25428 L
.28431 .25911 L
.29412 .25995 L
.30392 .25788 L
.31373 .25416 L
.32353 .24988 L
.33333 .24584 L
.34314 .24248 L
.35294 .24003 L
.36275 .23847 L
.37255 .23771 L
.38235 .23756 L
.39216 .23785 L
.40196 .2274 L
.41176 .2225 L
.42157 .21682 L
.43137 .2173 L
.44118 .22325 L
.45098 .23193 L
.46078 .24062 L
.47059 .2474 L
.48039 .25138 L
.4902 .25261 L
Mistroke
.5 .27177 L
.5098 .26203 L
.51961 .248 L
.52941 .23884 L
.53922 .23553 L
.54902 .23641 L
.55882 .237 L
.56863 .23454 L
.57843 .22972 L
.58824 .2236 L
.59804 .21728 L
.60784 .2117 L
.61765 .20742 L
.62745 .20461 L
.63725 .20317 L
.64706 .20284 L
.65686 .20327 L
.66667 .20413 L
.67647 .20517 L
.68627 .20618 L
.69608 .36278 L
.70588 .34826 L
.71569 .31959 L
.72549 .2836 L
.73529 .24998 L
.7451 .20724 L
.7549 .18493 L
.76471 .17015 L
.77451 .1663 L
.78431 .17144 L
.79412 .26178 L
.80392 .26444 L
.81373 .25501 L
.82353 .24355 L
.83333 .23358 L
.84314 .31031 L
.85294 .29476 L
.86275 .26915 L
.87255 .24499 L
.88235 .22632 L
.89216 .27376 L
.90196 .26124 L
.91176 .22804 L
.92157 .22313 L
.93137 .21212 L
.94118 .2073 L
.95098 .20929 L
.96078 .2159 L
.97059 .22437 L
.98039 .23234 L
Mistroke
.9902 .22283 L
Mfstroke
0 g
gsave
.9902 .25288 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .18194 Mdot
.05882 .21173 Mdot
.10784 .41765 Mdot
.20588 .20707 Mdot
.40196 .25921 Mdot
.5 .31346 Mdot
.69608 .44796 Mdot
.7451 .2342 Mdot
.79412 .32361 Mdot
.84314 .37345 Mdot
.89216 .32982 Mdot
.90196 .29367 Mdot
.91176 .23013 Mdot
.92157 .26786 Mdot
.9902 .25288 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.0980392 0.309017 0.309017 [
[.0098 -0.0125 -3 -9 ]
[.0098 -0.0125 3 0 ]
[.20588 -0.0125 -3 -9 ]
[.20588 -0.0125 3 0 ]
[.40196 -0.0125 -3 -9 ]
[.40196 -0.0125 3 0 ]
[.59804 -0.0125 -3 -9 ]
[.59804 -0.0125 3 0 ]
[.79412 -0.0125 -3 -9 ]
[.79412 -0.0125 3 0 ]
[.9902 -0.0125 -6 -9 ]
[.9902 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -30 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -24 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -30 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -24 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -18 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -24 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0098 0 m
.0098 .00625 L
s
[(0)] .0098 -0.0125 0 1 Mshowa
.20588 0 m
.20588 .00625 L
s
[(2)] .20588 -0.0125 0 1 Mshowa
.40196 0 m
.40196 .00625 L
s
[(4)] .40196 -0.0125 0 1 Mshowa
.59804 0 m
.59804 .00625 L
s
[(6)] .59804 -0.0125 0 1 Mshowa
.79412 0 m
.79412 .00625 L
s
[(8)] .79412 -0.0125 0 1 Mshowa
.9902 0 m
.9902 .00625 L
s
[(10)] .9902 -0.0125 0 1 Mshowa
.125 Mabswid
.05882 0 m
.05882 .00375 L
s
.10784 0 m
.10784 .00375 L
s
.15686 0 m
.15686 .00375 L
s
.2549 0 m
.2549 .00375 L
s
.30392 0 m
.30392 .00375 L
s
.35294 0 m
.35294 .00375 L
s
.45098 0 m
.45098 .00375 L
s
.5 0 m
.5 .00375 L
s
.54902 0 m
.54902 .00375 L
s
.64706 0 m
.64706 .00375 L
s
.69608 0 m
.69608 .00375 L
s
.7451 0 m
.7451 .00375 L
s
.84314 0 m
.84314 .00375 L
s
.89216 0 m
.89216 .00375 L
s
.94118 0 m
.94118 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-0.75)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-0.5)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.25)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.25)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(0.5)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(0.75)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(1)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.0098 .61178 m
.0098 .61803 L
s
.20588 .61178 m
.20588 .61803 L
s
.40196 .61178 m
.40196 .61803 L
s
.59804 .61178 m
.59804 .61803 L
s
.79412 .61178 m
.79412 .61803 L
s
.9902 .61178 m
.9902 .61803 L
s
.125 Mabswid
.05882 .61428 m
.05882 .61803 L
s
.10784 .61428 m
.10784 .61803 L
s
.15686 .61428 m
.15686 .61803 L
s
.2549 .61428 m
.2549 .61803 L
s
.30392 .61428 m
.30392 .61803 L
s
.35294 .61428 m
.35294 .61803 L
s
.45098 .61428 m
.45098 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54902 .61428 m
.54902 .61803 L
s
.64706 .61428 m
.64706 .61803 L
s
.69608 .61428 m
.69608 .61803 L
s
.7451 .61428 m
.7451 .61803 L
s
.84314 .61428 m
.84314 .61803 L
s
.89216 .61428 m
.89216 .61803 L
s
.94118 .61428 m
.94118 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.9902 .29672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .2032 m
.01961 .18682 L
.02941 .18983 L
.03922 .18192 L
.04902 .18249 L
.05882 .19349 L
.06863 .2351 L
.07843 .27422 L
.08824 .30016 L
.09804 .34747 L
.10784 .39558 L
.11765 .43789 L
.12745 .43352 L
.13725 .41122 L
.14706 .3911 L
.15686 .35518 L
.16667 .31269 L
.17647 .27554 L
.18627 .24808 L
.19608 .25324 L
.20588 .25788 L
.21569 .26401 L
.22549 .27227 L
.23529 .2965 L
.2451 .30701 L
.2549 .30399 L
.26471 .31374 L
.27451 .30973 L
.28431 .31542 L
.29412 .31316 L
.30392 .31861 L
.31373 .3422 L
.32353 .36316 L
.33333 .36863 L
.34314 .36745 L
.35294 .3639 L
.36275 .35272 L
.37255 .33573 L
.38235 .31238 L
.39216 .27807 L
.40196 .25429 L
.41176 .24299 L
.42157 .24346 L
.43137 .23817 L
.44118 .24106 L
.45098 .23852 L
.46078 .26419 L
.47059 .27807 L
.48039 .28789 L
.4902 .28404 L
Mistroke
.5 .26612 L
.5098 .26468 L
.51961 .28082 L
.52941 .29282 L
.53922 .29004 L
.54902 .29681 L
.55882 .29399 L
.56863 .28802 L
.57843 .28719 L
.58824 .29761 L
.59804 .31928 L
.60784 .34873 L
.61765 .36383 L
.62745 .35183 L
.63725 .32582 L
.64706 .32364 L
.65686 .34359 L
.66667 .3719 L
.67647 .40747 L
.68627 .40655 L
.69608 .4063 L
.70588 .38409 L
.71569 .33984 L
.72549 .31732 L
.73529 .30148 L
.7451 .26785 L
.7549 .26559 L
.76471 .28095 L
.77451 .2967 L
.78431 .30232 L
.79412 .29639 L
.80392 .30838 L
.81373 .33089 L
.82353 .37221 L
.83333 .39626 L
.84314 .39321 L
.85294 .3885 L
.86275 .37021 L
.87255 .33555 L
.88235 .31475 L
.89216 .29375 L
.90196 .28273 L
.91176 .27456 L
.92157 .25623 L
.93137 .24246 L
.94118 .23955 L
.95098 .2235 L
.96078 .23336 L
.97059 .25742 L
.98039 .27675 L
Mistroke
.9902 .29672 L
Mfstroke
0 .98 .604 r
gsave
.9902 .27539 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.0098 .1782 m
.01961 .14836 L
.02941 .14515 L
.03922 .16089 L
.04902 .18947 L
.05882 .22693 L
.06863 .27036 L
.07843 .31447 L
.08824 .35431 L
.09804 .38596 L
.10784 .40621 L
.11765 .41295 L
.12745 .40734 L
.13725 .39113 L
.14706 .36581 L
.15686 .33276 L
.16667 .29896 L
.17647 .27083 L
.18627 .24941 L
.19608 .23657 L
.20588 .23529 L
.21569 .24759 L
.22549 .26874 L
.23529 .29322 L
.2451 .31699 L
.2549 .33746 L
.26471 .35338 L
.27451 .36448 L
.28431 .37113 L
.29412 .37398 L
.30392 .37372 L
.31373 .37088 L
.32353 .36572 L
.33333 .35832 L
.34314 .34865 L
.35294 .33678 L
.36275 .3231 L
.37255 .30859 L
.38235 .29497 L
.39216 .28478 L
.40196 .28137 L
.41176 .2871 L
.42157 .29868 L
.43137 .31197 L
.44118 .32377 L
.45098 .33201 L
.46078 .33583 L
.47059 .33545 L
.48039 .33208 L
.4902 .32773 L
Mistroke
.5 .32495 L
.5098 .32577 L
.51961 .32923 L
.52941 .33368 L
.53922 .33782 L
.54902 .34073 L
.55882 .33966 L
.56863 .33364 L
.57843 .32485 L
.58824 .31545 L
.59804 .30743 L
.60784 .30254 L
.61765 .30222 L
.62745 .30747 L
.63725 .31868 L
.64706 .33549 L
.65686 .35652 L
.66667 .37917 L
.67647 .39953 L
.68627 .41243 L
.69608 .41177 L
.70588 .39217 L
.71569 .35834 L
.72549 .31917 L
.73529 .2833 L
.7451 .25871 L
.7549 .25076 L
.76471 .25705 L
.77451 .2729 L
.78431 .29352 L
.79412 .3144 L
.80392 .33215 L
.81373 .34628 L
.82353 .35709 L
.83333 .3646 L
.84314 .36829 L
.85294 .36737 L
.86275 .36176 L
.87255 .35116 L
.88235 .33491 L
.89216 .31233 L
.90196 .28753 L
.91176 .26941 L
.92157 .26363 L
.93137 .26588 L
.94118 .27092 L
.95098 .2751 L
.96078 .27657 L
.97059 .27547 L
.98039 .27385 L
Mistroke
.9902 .27539 L
Mfstroke
0 0 1 r
gsave
.9902 .27539 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.0098 .1782 m
.01961 .14836 L
.02941 .14515 L
.03922 .16089 L
.04902 .18947 L
.05882 .22693 L
.06863 .27036 L
.07843 .31447 L
.08824 .35431 L
.09804 .38596 L
.10784 .40621 L
.11765 .41295 L
.12745 .40734 L
.13725 .39113 L
.14706 .36581 L
.15686 .33276 L
.16667 .29896 L
.17647 .27083 L
.18627 .24941 L
.19608 .23657 L
.20588 .23529 L
.21569 .24759 L
.22549 .26874 L
.23529 .29322 L
.2451 .31699 L
.2549 .33746 L
.26471 .35338 L
.27451 .36448 L
.28431 .37113 L
.29412 .37398 L
.30392 .37372 L
.31373 .37088 L
.32353 .36572 L
.33333 .35832 L
.34314 .34865 L
.35294 .33678 L
.36275 .3231 L
.37255 .30859 L
.38235 .29497 L
.39216 .28478 L
.40196 .28137 L
.41176 .2871 L
.42157 .29868 L
.43137 .31197 L
.44118 .32377 L
.45098 .33201 L
.46078 .33583 L
.47059 .33545 L
.48039 .33208 L
.4902 .32773 L
Mistroke
.5 .32495 L
.5098 .32577 L
.51961 .32923 L
.52941 .33368 L
.53922 .33782 L
.54902 .34073 L
.55882 .33966 L
.56863 .33364 L
.57843 .32485 L
.58824 .31545 L
.59804 .30743 L
.60784 .30254 L
.61765 .30222 L
.62745 .30747 L
.63725 .31868 L
.64706 .33549 L
.65686 .35652 L
.66667 .37917 L
.67647 .39953 L
.68627 .41243 L
.69608 .41177 L
.70588 .39217 L
.71569 .35834 L
.72549 .31917 L
.73529 .2833 L
.7451 .25871 L
.7549 .25076 L
.76471 .25705 L
.77451 .2729 L
.78431 .29352 L
.79412 .3144 L
.80392 .33215 L
.81373 .34628 L
.82353 .35709 L
.83333 .3646 L
.84314 .36829 L
.85294 .36737 L
.86275 .36176 L
.87255 .35116 L
.88235 .33491 L
.89216 .31233 L
.90196 .28753 L
.91176 .26941 L
.92157 .26363 L
.93137 .26588 L
.94118 .27092 L
.95098 .2751 L
.96078 .27657 L
.97059 .27547 L
.98039 .27385 L
Mistroke
.9902 .27539 L
Mfstroke
0 .98 .604 r
gsave
.9902 .27539 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .1782 m
.01961 .14836 L
.02941 .14515 L
.03922 .16089 L
.04902 .18947 L
.05882 .22693 L
.06863 .27036 L
.07843 .31447 L
.08824 .35431 L
.09804 .38596 L
.10784 .40621 L
.11765 .41295 L
.12745 .40734 L
.13725 .39113 L
.14706 .36581 L
.15686 .33276 L
.16667 .29896 L
.17647 .27083 L
.18627 .24941 L
.19608 .23657 L
.20588 .23529 L
.21569 .24759 L
.22549 .26874 L
.23529 .29322 L
.2451 .31699 L
.2549 .33746 L
.26471 .35338 L
.27451 .36448 L
.28431 .37113 L
.29412 .37398 L
.30392 .37372 L
.31373 .37088 L
.32353 .36572 L
.33333 .35832 L
.34314 .34865 L
.35294 .33678 L
.36275 .3231 L
.37255 .30859 L
.38235 .29497 L
.39216 .28478 L
.40196 .28137 L
.41176 .2871 L
.42157 .29868 L
.43137 .31197 L
.44118 .32377 L
.45098 .33201 L
.46078 .33583 L
.47059 .33545 L
.48039 .33208 L
.4902 .32773 L
Mistroke
.5 .32495 L
.5098 .32577 L
.51961 .32923 L
.52941 .33368 L
.53922 .33782 L
.54902 .34073 L
.55882 .33966 L
.56863 .33364 L
.57843 .32485 L
.58824 .31545 L
.59804 .30743 L
.60784 .30254 L
.61765 .30222 L
.62745 .30747 L
.63725 .31868 L
.64706 .33549 L
.65686 .35652 L
.66667 .37917 L
.67647 .39953 L
.68627 .41243 L
.69608 .41177 L
.70588 .39217 L
.71569 .35834 L
.72549 .31917 L
.73529 .2833 L
.7451 .25871 L
.7549 .25076 L
.76471 .25705 L
.77451 .2729 L
.78431 .29352 L
.79412 .3144 L
.80392 .33215 L
.81373 .34628 L
.82353 .35709 L
.83333 .3646 L
.84314 .36829 L
.85294 .36737 L
.86275 .36176 L
.87255 .35116 L
.88235 .33491 L
.89216 .31233 L
.90196 .28753 L
.91176 .26941 L
.92157 .26363 L
.93137 .26588 L
.94118 .27092 L
.95098 .2751 L
.96078 .27657 L
.97059 .27547 L
.98039 .27385 L
Mistroke
.9902 .27539 L
Mfstroke
1 .38 .01 r
gsave
.9902 .32795 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .23803 m
.01961 .20632 L
.02941 .20306 L
.03922 .21843 L
.04902 .24292 L
.05882 .27791 L
.06863 .32873 L
.07843 .38056 L
.08824 .4204 L
.09804 .44412 L
.10784 .45721 L
.11765 .47025 L
.12745 .4779 L
.13725 .47555 L
.14706 .46287 L
.15686 .4364 L
.16667 .39627 L
.17647 .35598 L
.18627 .32083 L
.19608 .2942 L
.20588 .28671 L
.21569 .31032 L
.22549 .34842 L
.23529 .38646 L
.2451 .41855 L
.2549 .44296 L
.26471 .45999 L
.27451 .47085 L
.28431 .47691 L
.29412 .47932 L
.30392 .4789 L
.31373 .47622 L
.32353 .47157 L
.33333 .46489 L
.34314 .45566 L
.35294 .4429 L
.36275 .42543 L
.37255 .40251 L
.38235 .375 L
.39216 .34754 L
.40196 .33397 L
.41176 .34968 L
.42157 .37855 L
.43137 .40587 L
.44118 .42602 L
.45098 .43698 L
.46078 .43808 L
.47059 .42934 L
.48039 .41195 L
.4902 .39031 L
Mistroke
.5 .37754 L
.5098 .38853 L
.51961 .40926 L
.52941 .42758 L
.53922 .44008 L
.54902 .44672 L
.55882 .44644 L
.56863 .43987 L
.57843 .43031 L
.58824 .42047 L
.59804 .41248 L
.60784 .40789 L
.61765 .4077 L
.62745 .41219 L
.63725 .42075 L
.64706 .43188 L
.65686 .4434 L
.66667 .45307 L
.67647 .4599 L
.68627 .46496 L
.69608 .46419 L
.70588 .44369 L
.71569 .41234 L
.72549 .37501 L
.73529 .33628 L
.7451 .30956 L
.7549 .30869 L
.76471 .32231 L
.77451 .33805 L
.78431 .35132 L
.79412 .36635 L
.80392 .38987 L
.81373 .4113 L
.82353 .42222 L
.83333 .42248 L
.84314 .41912 L
.85294 .41973 L
.86275 .41519 L
.87255 .39926 L
.88235 .37578 L
.89216 .35176 L
.90196 .3213 L
.91176 .30145 L
.92157 .30488 L
.93137 .32459 L
.94118 .34584 L
.95098 .35939 L
.96078 .3613 L
.97059 .35164 L
.98039 .33558 L
Mistroke
.9902 .32795 L
Mfstroke
gsave
.9902 .22283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0098 .11836 m
.01961 .0904 L
.02941 .08723 L
.03922 .10335 L
.04902 .13602 L
.05882 .17596 L
.06863 .212 L
.07843 .24838 L
.08824 .28822 L
.09804 .3278 L
.10784 .3552 L
.11765 .35565 L
.12745 .33678 L
.13725 .3067 L
.14706 .26876 L
.15686 .22912 L
.16667 .20164 L
.17647 .18568 L
.18627 .17799 L
.19608 .17895 L
.20588 .18386 L
.21569 .18485 L
.22549 .18905 L
.23529 .19999 L
.2451 .21543 L
.2549 .23197 L
.26471 .24678 L
.27451 .25812 L
.28431 .26535 L
.29412 .26865 L
.30392 .26854 L
.31373 .26553 L
.32353 .25987 L
.33333 .25175 L
.34314 .24164 L
.35294 .23066 L
.36275 .22078 L
.37255 .21467 L
.38235 .21493 L
.39216 .22202 L
.40196 .22877 L
.41176 .22452 L
.42157 .21881 L
.43137 .21807 L
.44118 .22152 L
.45098 .22705 L
.46078 .23358 L
.47059 .24155 L
.48039 .25221 L
.4902 .26515 L
Mistroke
.5 .27235 L
.5098 .26301 L
.51961 .24919 L
.52941 .23978 L
.53922 .23556 L
.54902 .23474 L
.55882 .23289 L
.56863 .22742 L
.57843 .2194 L
.58824 .21042 L
.59804 .20237 L
.60784 .19719 L
.61765 .19674 L
.62745 .20274 L
.63725 .21662 L
.64706 .23911 L
.65686 .26964 L
.66667 .30526 L
.67647 .33915 L
.68627 .35989 L
.69608 .35936 L
.70588 .34064 L
.71569 .30435 L
.72549 .26334 L
.73529 .23031 L
.7451 .20787 L
.7549 .19282 L
.76471 .1918 L
.77451 .20776 L
.78431 .23572 L
.79412 .26246 L
.80392 .27442 L
.81373 .28127 L
.82353 .29196 L
.83333 .30671 L
.84314 .31747 L
.85294 .315 L
.86275 .30832 L
.87255 .30306 L
.88235 .29405 L
.89216 .27289 L
.90196 .25375 L
.91176 .23738 L
.92157 .22238 L
.93137 .20718 L
.94118 .196 L
.95098 .1908 L
.96078 .19184 L
.97059 .19929 L
.98039 .21211 L
Mistroke
.9902 .22283 L
Mfstroke
0 g
gsave
.9902 .25288 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.0098 .18194 Mdot
.05882 .21173 Mdot
.10784 .41765 Mdot
.20588 .20707 Mdot
.40196 .25921 Mdot
.5 .31346 Mdot
.69608 .44796 Mdot
.7451 .2342 Mdot
.79412 .32361 Mdot
.84314 .37345 Mdot
.89216 .32982 Mdot
.90196 .29367 Mdot
.91176 .23013 Mdot
.92157 .26786 Mdot
.9902 .25288 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{614.5, 379.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009V0001Nb000`400?l00000o`00003ooooooooo
ooooofSooooo003oooooooooooooJ?ooool00?oooooooooooomXooooo`00ooooooooooooofSooooo
003oooooooooooooJ?ooool00?oooooooooooomXooooo`00ooooooooooooofSooooo003ooooooooo
ooooJ?ooool00?oooooooooooomXooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool0
02_ooooo0_l0000_ooooo`Go0000<Oooool3o`0002oooooo0ol0000`ooooo`?o0000;Oooool3o`00
00Cooooo0_l0000Oooooo`;o0000;oooool5o`00033ooooo0ol0000`ooooo`?o0000<?ooool3o`00
02gooooo0ol00004ooooo`;o00004_ooool002[ooooo00Co0000oooooooooooo0000;oooool01?l0
003oooooooooool0000booooo`03o`000?oooooooooo02gooooo00Go0000ooooooooooooooooo`00
000^ooooo`05o`000?ooooooooooooooool00000;Oooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0001gooooo00Co0000oooooooooooo0000;oooool01?l0003oooooooooool0000a
ooooo`03o`000?oooooooooo02kooooo00Go0000ooooooooooooooooo`00000^ooooo`05o`000?oo
ooooooooooooool00000;Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00017o
oooo000Zooooo`04o`000?ooooooooooo`00033ooooo00?o0000ooooooooool0;oooool5o`0002ko
oooo00Go0000ooooooooooooooooo`00000^ooooo`05o`000?ooooooooooooooool00000;Oooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001gooooo00Co0000oooooooooooo0000
<?ooool00ol0003oooooooooo`0^ooooo`Go0000;oooool01Ol0003ooooooooooooooooo000002ko
oooo00Go0000ooooooooooooooooo`00000]ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00004Oooool002[ooooo00Co0000oooooooooooo0000<Oooool00ol0003oooooooooo`0^
ooooo`04o`000?ooooooooooo`0002oooooo1?l0000`ooooo`?o0000;_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0001gooooo00Co0000oooooooooooo0000<Oooool00ol0003o
ooooooooo`0]ooooo`04o`000?ooooooooooo`00033ooooo1?l0000`ooooo`?o0000;_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`00017ooooo000Zooooo`04o`000?oooooooooo
o`0002kooooo00Go0000ooooooooooooooooo`00000`ooooo`03o`000?oooooo000002oooooo00?o
0000ooooooooool0<?ooool01Ol0003ooooooooooooooooo000002gooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool0000Mooooo`04o`000?ooooooooooo`0002kooooo00Go0000oooo
ooooooooooooo`00000_ooooo`03o`000?oooooo0000033ooooo00?o0000ooooooooool0<?ooool0
1Ol0003ooooooooooooooooo000002gooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool0000Aooooo`00:_ooool01?l0003oooooooooool0000^ooooo`05o`000?ooooooooooooooool0
0000<Oooool2o`00033ooooo00?o0000ooooooooool0;oooool01Ol0003ooooooooooooooooo0000
02cooooo0_l00004ooooo`04o`000?ooooooooooo`0001gooooo00Co0000oooooooooooo0000;_oo
ool01Ol0003ooooooooooooooooo0000033ooooo0_l0000aooooo`03o`000?oooooooooo02oooooo
00Go0000ooooooooooooooooo`00000/ooooo`;o00001?ooool01?l0003oooooooooool0000Aoooo
o`00:oooool2o`00033ooooo0ol0000cooooo`03o`000?oooooooooo02oooooo0_l0000`ooooo`?o
0000;_ooool00ol0003oooooooooo`03ooooo`;o00007oooool2o`00033ooooo0ol0000booooo`03
o`000?oooooooooo033ooooo0_l0000`ooooo`?o0000;_ooool00ol0003oooooooooo`03ooooo`;o
00004_ooool00?oooooooooooomXooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool0
0?oooooooooooomXooooo`00:_ooooooo`0000Oo00007_oooolVo`000003oomQ0_l0003o000000;o
000000Coof42o`000?l0003oof42R_l000000oooH@;o0000o`000004o`000003oomQ0_l0003o0000
04?o00004_ooool002[ooooo00?o0000ooooool000003?ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`04
o`000?ooooooooooo`0001kooooo00?o0000ooooool000003?ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Oooooo00?oof42ooooool000000_ooool01?ooH@;oooooooooooooH@86
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooooooooomQ0P06ooooo`03oomQ0_oo
oooo000000cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000Booooo`00:_oo
ool00ol0003oooooo`00000booooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00Co0000oooooooooooo0000
7_ooool00ol0003oooooo`00000Rooooo`;oof421?ooool01?ooH@;oooooooooooooH@86ooooo`03
o`000?oooooooooo033ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Jooooo`03
oomQ0_oooooooooo00Cooooo00?oof42ooooooooool03?ooool00ol0003oooooooooo`0`ooooo`04
o`000?ooooooooooo`0001;ooooo000Zooooo`03o`000?oooooooooo0;Sooooo0oooH@97ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool08Oooool00oooH@;ooooooomQ0P04ooooo`05
oomQ0_ooooooooooooooooooH@80R?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo
04;ooooo00?o0000ooooooooool04?ooool002[ooooo0_l0002iooooo`03oomQ0_ooooooof4204Ko
oooo0_l0000Nooooo`03o`000?oooooooooo027ooooo00?oof42ooooooooH@801?ooool01OooH@;o
ooooooooooooooooof4208Sooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`10oooo
o`;o00004_ooool002[ooooo00?o0000ooooooooool0^?ooool01?ooH@;oooooooooooooH@96oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool08?ooool01?ooH@;oooooooooooooH@83
ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0Q_ooool00oooH@;oooooooooo`06
ooooo`03oomQ0_oooooooooo047ooooo00?o0000ooooooooool04?ooool002[ooooo00?o0000oooo
ooooool0]oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo04?ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0Pooooo`04oomQ0_oooooooooooomQ0P?ooooo00?oof42
ooooooooool00_ooool00oooH@;oooooooooo`26ooooo`03oomQ0_oooooooooo00Kooooo00?oof42
ooooooooool0@Oooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003oooooooooo`2goooo
o`03oomQ0_oooooooooo00?ooooo0oooH@92ooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool08?ooool01OooH@;oooooooooooooooooof4200;ooooo00?oof42ooooooooool00_ooool0
0oooH@;oooooooooo`26ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0@Oooool0
0ol0003oooooooooo`0@ooooo`00:_ooool2o`0002Wooooo00?oof42ooooooooool0S?ooool00ooo
H@;oooooooooo`05ooooo`03oomQ0_oooooooooo03oooooo0_l0000Nooooo`03o`000?oooooooooo
023ooooo00Goof42oooooooooooooooooomQ0P02ooooo`03oomQ0_oooooooooo00?ooooo00?oof42
ooooooooool0QOooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo043ooooo0_l0000B
ooooo`00:_ooool00ol0003oooooooooo`0Rooooo`;oof421?ooool00oooH@;oooooooooo`2<oooo
o`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0@?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo01oooooo00?oof42ooooooooool00_ooool01?ooH@;oooooooooooooH@85
ooooo`03oomQ0_oooooooooo08Gooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`11
ooooo`03o`000?oooooooooo013ooooo000Zooooo`03o`000?oooooooooo027ooooo00?oof42oooo
ooooH@801?ooool2oomQ0Xcooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`10oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool07oooool00oooH@;oooooooooo`02oooo
o`04oomQ0_oooooooooooomQ0PGooooo00?oof42ooooooooool0QOooool00oooH@;oooooooooo`06
ooooo`03oomQ0_oooooooooo047ooooo00?o0000ooooooooool04?ooool002[ooooo00?o0000oooo
ooooool08?ooool01?ooH@;oooooooooooooH@84ooooo`;oof42S?ooool00oooH@;oooooooooo`07
ooooo`03oomQ0_oooooooooo03oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0O
ooooo`03oomQ0_oooooooooo00;ooooo00Coof42ooooooooooooof421Oooool00oooH@;ooooooooo
o`25ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0@?ooool00ol0003ooooooooo
o`0@ooooo`00:_ooool2o`00027ooooo00Coof42ooooooooooooof421?ooool00oooH@;ooooooomQ
0P2;ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0?_ooool2o`0001kooooo00?o
0000ooooooooool07oooool00oooH@;oooooooooo`02ooooo`04oomQ0_oooooooooooomQ0PKooooo
00?oof42ooooooooool09oooool6oomQ0UOooooo00?oof42ooooooooool01oooool00oooH@;ooooo
ooooo`0oooooo`;o00004_ooool002[ooooo00?o0000ooooooooH@807oooool00oooH@;ooooooooo
o`02ooooo`04oomQ0_oooooooooooomQ0P;ooooo00?oof42ooooooooool0ROooool00oooH@;ooooo
ooooo`07ooooo`03oomQ0_oooooooooo03oooooo00?o0000ooooooooool07?ooool00ol0003ooooo
oomQ0P0Oooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooH@801oooool00oooH@;ooooo
ooooo`0Uooooo`;oof421_ooool2oomQ0SCooooo0oooH@8Nooooo`03oomQ0_oooooooooo00Oooooo
00?oof42ooooooooool0@?ooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003ooooooomQ
0P0Oooooo`03oomQ0_oooooooooo00;ooooo00Coof42ooooooooooooof420_ooool00oooH@;ooooo
ooooo`28ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool0?oooool00ol0003ooooo
ooooo`0Looooo`03o`000?ooooooof4201oooooo00?oof42ooooooooool00_ooool00oooH@;ooooo
oomQ0P07ooooo`03oomQ0_oooooooooo02Cooooo00?oof42ooooooooool02?ooool00oooH@;ooooo
ooooo`0`ooooo`04oomQ0_oooooooooooomQ0Qkooooo00?oof42ooooooooool01oooool00oooH@;o
ooooooooo`10ooooo`03o`000?oooooooooo013ooooo000Zooooo`03o`000?ooooooof4201oooooo
00?oof42ooooooooool00_ooool01?ooH@;oooooooooooooH@83ooooo`03oomQ0_oooooooooo08Oo
oooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0oooooo`03o`000?oooooooooo01co
oooo00Co0000ooooooooooooof427Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_ooooooof42
00Sooooo00?oof42ooooooooool08Oooool2oomQ0Pcooooo00?oof42ooooooooool0;_ooool00ooo
H@;oooooooooo`02ooooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool02?ooool00ooo
H@;oooooooooo`0Vooooo`03oomQ0_oooooooooo01Oooooo00?o0000ooooooooool04?ooool002[o
oooo0_l000000oooooooof42ooooo`0Looooo`03oomQ0_oooooooooo00?ooooo00Coof42oooooooo
ooooof420oooool00oooH@;oooooooooo`27ooooo`03oomQ0_oooooooooo00Wooooo00?oof42oooo
ooooool0?Oooool2o`0001kooooo00Co0000ooooooooooooof427Oooool00oooH@;oooooooooo`03
ooooo`03oomQ0_ooooooof4200Sooooo00?oof42ooooooooool08?ooool00oooH@;oooooooooo`0=
ooooo`03oomQ0_oooooooooo02cooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0I
ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool09_ooool00oooH@;oooooooooo`0F
ooooo`;o00004_ooool002[ooooo00Co0000ooooooooooooof427Oooool00oooH@;oooooooooo`03
ooooo`04oomQ0_oooooooooooomQ0P?ooooo00?oof42ooooooooool0I_ooool6oomQ0Q_ooooo00?o
of42ooooooooool02Oooool00oooH@;oooooooooo`0Iooooo`Coof428Oooool00ol0003ooooooooo
o`0Looooo`04o`000?oooooooooooomQ0Qgooooo00?oof42ooooooooool00oooool00oooH@;ooooo
oomQ0P08ooooo`03oomQ0_oooooooooo01oooooo00?oof42ooooooooool03oooool00oooH@;ooooo
ooooo`0[ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool06?ooool00oooH@;ooooo
ooooo`08ooooo`03oomQ0_oooooooooo02Kooooo00?oof42ooooooooool05oooool00ol0003ooooo
ooooo`0@ooooo`005Oooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Kooooo00Co
0000ooooooooooooof427?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_ooooooof4200?ooooo
00?oof42ooooooooool0IOooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo01Sooooo
00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Gooooo`;oof421?ooool2oomQ0POooooo
0_ooH@8Fooooo`03o`000?oooooooooo00Oooooo0ol00004ooooo`03o`000?oooooooooo00;ooooo
0ol00006ooooo`05o`000?ooooooooooooooooooH@807?ooool00oooH@;oooooooooo`03ooooo`03
oomQ0_ooooooof4200Sooooo00?oof42ooooooooool07_ooool00oooH@;oooooooooo`0@ooooo`03
oomQ0_oooooooooo02[ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Hooooo`03
oomQ0_oooooooooo00Wooooo00?oof42ooooooooool08?ooool00oooH@;oooooooooo`02ooooo`;o
of426?ooool00ol0003oooooooooo`0@ooooo`005_ooool00ol0003oooooooooo`07ooooo`05o`00
0?ooooooooooooooool000001Oooool4o`0001cooooo00?oof42ooooooooool01Oooool00oooH@;o
oooooomQ0P04ooooo`03oomQ0_oooooooooo06?ooooo00?oof42ooooooooool01_ooool2oomQ0QSo
oooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00Go
oooo00?oof42ooooooooool00oooool00oooH@;ooooooomQ0P0Fooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo000000Gooooo1?l000000ooo
H@;oooooooooo`0Jooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooH@802Oooool00ooo
H@;oooooooooo`0Looooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool0:_ooool00ooo
H@;oooooooooo`07ooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool02Oooool00ooo
H@;oooooooooo`0Pooooo`03oomQ0_oooooooooo00;ooooo0_ooH@8Hooooo`03o`000?oooooooooo
013ooooo000>ooooo`Go00000oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?o
oooo1Ol0000Kooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooH@801?ooool00oooH@;o
ooooooooo`0Oooooo`Soof42>oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo01Go
oooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00Go
oooo00?oof42ooooooooool00_ooool01?ooH@;oooooooooooooH@8Dooooo`?o00000_ooool5o`00
00?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`Go00006oooool00ooo
H@;oooooooooo`05ooooo`;oof422Oooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo
01?ooooo00?oof42ooooooooool0:?ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo
01Oooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Oooooo`;oof421?ooool2oomQ
0QKooooo0ol0000Booooo`005_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?o
oooo1Ol0000Jooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooH@801?ooool00oooH@;o
ooooooooo`0Mooooo`;oof422?ooool3oomQ0SSooooo00?oof42ooooooooool02_ooool2oomQ0QGo
oooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00Ko
oooo00?oof42ooooooooool00_ooool01?ooH@;oooooooooooooH@8Fooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`Go000000?oof42oooo
ooooool06?ooool00oooH@;oooooooooo`05ooooo`;oof422Oooool00oooH@;oooooooooo`0Koooo
o`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool0:?ooool00oooH@;oooooooooo`08oooo
o`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Ooooo
o`;oof421?ooool00oooH@;ooooooomQ0P0Gooooo`03o`000?oooooooooo013ooooo000Fooooo`03
o`000?oooooooooo00Oooooo1?l00006ooooo`Go00006_ooool00oooH@;oooooooooo`06ooooo`;o
of421Oooool00oooH@;oooooooooo`0Looooo`03oomQ0_oooooooooo00_ooooo0_ooH@8eooooo`03
oomQ0_oooooooooo00gooooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`0:ooooo`03
oomQ0_oooooooooo01Gooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`02ooooo`04
oomQ0_oooooooooooomQ0QKooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`Co00001_ooool5o`000003oomQ0_oooooooooo01Sooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooooooo`08ooooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool05?ooool00ooo
H@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool02_ooool00ooo
H@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool07_ooool01?oo
H@;oooooooooooooH@82ooooo`04oomQ0_oooooooooooomQ0QOooooo00?o0000ooooooooool04?oo
ool001Gooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo1?l000000oooH@;oooooooooo`0H
ooooo`03oomQ0_oooooooooo00Kooooo0_ooH@85ooooo`03oomQ0_oooooooooo01_ooooo00?oof42
ooooooooool03_ooool3oomQ0R7ooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0>
ooooo`;oof424_ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01Gooooo00?oof42
ooooooooool01oooool01OooH@;oooooooooooooooooof4200;ooooo00?oof42ooooooooool05?oo
ool00ol0003oooooooooo`07ooooo`;o00002Oooool00ol0003oooooooooo`07ooooo`Co000000?o
oooooomQ0_ooool06Oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00Sooooo00?o
of42ooooooooool06Oooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo01Gooooo00?o
of42ooooooooH@803oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo01Kooooo00?o
of42ooooooooool02Oooool00oooH@;oooooooooo`0Nooooo`04oomQ0_oooooooooooomQ0P;ooooo
00Coof42ooooooooooooof425oooool00ol0003oooooooooo`0@ooooo`005_ooool00ol0003ooooo
ooooo`07ooooo`Go00001Oooool01Ol0003o0?ZJo`3jV_ooooooof4201Wooooo00?oof42oooooooo
ool02?ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo01Wooooo00?oof42oooooooo
ool04_ooool3oomQ0Qgooooo0_ooH@8@ooooo`03oomQ0_oooooooooo013ooooo0oooH@8>ooooo`03
oomQ0_oooooooooo00_ooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`05ooooo`04
o`00oooooooooooooomQ0P?ooooo00Goof42oooooooooooooooooomQ0P0Dooooo`;o00002_ooool0
0ol0003oooooooooo`07ooooo`Go00001Oooool00ol0003o0?ZJo`3jVP02ooooo`03oomQ0_oooooo
oooo01Sooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooo
oooo01Wooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0Dooooo`05oomQ0_oooooo
ooooooooooooH@803_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01Gooooo00?o
of42ooooooooool02Oooool00oooH@;oooooooooo`0Mooooo`05oomQ0_ooooooooooooooooooH@80
0_ooool01OooH@;oooooooooooooooooof4201Gooooo0_l0000Booooo`00:_ooool01Ol0003o0?ZJ
o`3jV_ooooooof4201Wooooo00?oof42ooooooooool02?ooool00oooH@;oooooo`00o`04ooooo`03
oomQ0_oooooooooo01Wooooo00?oof42ooooooooool05Oooool5oomQ0QOooooo00Coof42oooooooo
ooooof423_ooool00oooH@;oooooooooo`0Dooooo`;oof423?ooool00oooH@;oooooooooo`0;oooo
o`03oomQ0_oooooooooo01?ooooo0_ooH@87ooooo`04o`00oooooooooooooomQ0P?ooooo00Goof42
oooooooooooooooooomQ0P0Eooooo`03o`000?oooooooooo01cooooo00?o0000o`3jV_l0nYX00_oo
ool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00Kooooo00Coof42oooooooooooo003o
2?ooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool0
4_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool0
3?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0
7Oooool01OooH@;oooooooooooooooooof4200;ooooo00Goof42oooooooooooooooooomQ0P0Foooo
o`03o`000?oooooooooo013ooooo000Zooooo`03o`000?l0nY[o0?ZJ00;ooooo00?oof42oooooooo
ool05_ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooo003o00Cooooo00?oof42oooooooo
ool06?ooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo01?ooooo00Goof42oooooooo
oooooooooomQ0P0>ooooo`03oomQ0_oooooooooo01Kooooo2OooH@83ooooo`03oomQ0_oooooooooo
00_ooooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`06ooooo`;o003o0_ooool01?oo
H@;oooooooooooooH@84ooooo`03oomQ0_oooooooooo01?ooooo00?o0000ooooooooool07?ooool0
0ol0003o0?ZJo`3jVP02ooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool02?ooool2
o`00o`Sooooo00?oof42ooooooooool05_ooool00oooH@;oooooooooo`0Hooooo`03oomQ0_oooooo
oooo01;ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooo
oooo00cooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooo
oooo01cooooo00Goof42oooooooooooooooooomQ0P02ooooo`05oomQ0_ooooooooooooooooooH@80
5_ooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003o0?ZJo`3jVP02ooooo`03oomQ0_oo
oooooooo01Kooooo00?oof42ooooooooool02Oooool2o`00o`Cooooo00?oof42ooooooooool06?oo
ool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool00ooo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01kooooo00Goof42oooooooooooooooo
oomQ0P0=ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool01oooool2o`00o`;ooooo
00Coof42ooooooooooooof421?ooool00oooH@;oooooooooo`0Cooooo`03o`000?oooooooooo01co
oooo00?o0000o`3jV_l0nYX00_ooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00Oo
oooo00?o003oooooool00?l02?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo01Wo
oooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00[o
oooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00[o
oooo00?oof42ooooooooool06oooool00oooH@;o003oooooo`02ooooo`04oomQ0_oooooooooooomQ
0P?ooooo00?oof42ooooooooool05?ooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003o
0?ZJo`3jVP02ooooo`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool02?ooool00ol00?oo
ooooo`00o`05ooooo`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool07?ooool00oooH@;o
ooooooooo`0Aooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool02_ooool00oooH@;o
ooooooooo`0Oooooo`05oomQ0_ooooooooooooooooooH@803Oooool00oooH@;oooooooooo`0Aoooo
o`03oomQ0_oooooooooo00Oooooo0_l00?l2ooooo`04oomQ0_oooooooooooomQ0PCooooo00?oof42
ooooooooool04_ooool2o`0001kooooo00?o0000o`3jV_l0nYX00_ooool00oooH@;oooooooooo`0G
ooooo`03oomQ0_oooooooooo00Kooooo00Co003ooooooooooooo003o2?ooool00oooH@;ooooooooo
o`0Eooooo`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool04?ooool00oooH@;ooooooooo
o`06ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool03Oooool00oooH@;ooooooooo
o`0Dooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool06oooool00oooH@;o003ooooo
o`02ooooo`04oomQ0_oooooooooooomQ0PCooooo00?oof42ooooooooool04_ooool2o`0001;ooooo
000Zooooo`03o`000?l0nY[oof4200;ooooo00?oof42ooooooooool05Oooool00oooH@;ooooooooo
o`09ooooo`03o`00oooooooo003o00Gooooo00?oof42ooooooooool05_ooool00oooH@;ooooooooo
o`0Looooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool01?ooool00oooH@;ooooooooo
o`0:ooooo`03oomQ0_oooooooooo01oooooo00Goof42oooooooooooooooooomQ0P0>ooooo`03oomQ
0_oooooooooo00oooooo00?oof42ooooooooool01oooool00ol00?ooooooo`00o`02ooooo`04oomQ
0_oooooooooooomQ0PCooooo00?oof42ooooooooool04oooool00ol0003oooooooooo`0Looooo`06
o`000?l0nY[oof42o`3jV_ooooooof426Oooool00oooH@;oooooooooo`06ooooo`04o`00oooooooo
ooooo`00o`Sooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oo
oooooooo00oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oo
oooooooo00gooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oo
oooooooo01_ooooo00?oof42o`00ooooool00oooool00oooH@;ooooooomQ0P04ooooo`03oomQ0_oo
oooooooo00kooooo00?oof42ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`00:_ooool0
1_l0003o0?ZJoomQ0_l0nY[ooooooomQ0QOooooo00?oof42ooooooooool02Oooool00ol00?oooooo
o`00o`05ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool07_ooool00oooH@;ooooo
ooooo`0?ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool02Oooool00oooH@;ooooo
ooooo`0Oooooo`05oomQ0_ooooooooooooooooooH@803_ooool00oooH@;oooooooooo`0?ooooo`03
oomQ0_oooooooooo00Oooooo00?o003oooooool00?l00oooool00oooH@;ooooooomQ0P04ooooo`03
oomQ0_oooooooooo01?ooooo00?o0000ooooooooool07?ooool01?l0003ooooooomQ0_l0nYX2oooo
o`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool01oooool01?l00?ooooooooooool00?l8
ooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool06oooool00oooH@;oooooooooo`0>
ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0?
ooooo`03oomQ0_oooooooooo01?ooooo00Coof42oooooooooooooooo0ol0nYX6ooooo`03oomQ0_oo
oooooooo01_ooooo00?oof42o`00ooooool00oooool00oooH@;ooooooomQ0P04ooooo`03oomQ0_oo
oooooooo00gooooo0_ooH@84ooooo`03o`000?oooooooooo013ooooo000Zooooo`06o`000?oooooo
of42o`3jV_ooooooof425oooool00oooH@;oooooooooo`08ooooo`?o000000?oooooo`00ooooool0
1?ooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool0
3oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool0
8?ooool01OooH@;oooooooooooooooooof4200?ooooo00?o003oooooooooool02?ooool00oooH@;o
ooooooooo`0?ooooo`03oomQ0_oooooooooo00Oooooo00?o003oooooool00?l00oooool00oooH@;o
oooooomQ0P04ooooo`03oomQ0_oooooooooo01?ooooo00?o0000ooooooooool07?ooool01?l0003o
oooooomQ0_l0nYX2ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool01_ooool3o`00
00;ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo
01cooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo
00Oooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooo0?ZJ
00Co0?ZJ1_ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_l00?oo003o00Cooooo00?oof42oooo
ooooH@801?ooool00oooH@;oooooooooo`0<ooooo`04oomQ0_oooooooooooomQ0P?ooooo00?o0000
ooooooooool04?ooool002[ooooo0_l000001?ooH@;o0?ZJooooooooH@8Gooooo`03oomQ0_oooooo
oooo00Oooooo1Ol000000ol00?ooooooooooo`03ooooo`03oomQ0_oooooooooo01?ooooo00?oof42
ooooooooool07oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00Sooooo00?oof42
ooooooooool01oooool00oooH@;oooooooooo`0Pooooo`05oomQ0_ooooooooooooooooooH@800_oo
ool2o`00o`[ooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`07ooooo`04o`00oooo
ooooooooo`00o`?ooooo00?oof42ooooooooH@801?ooool00oooH@;oooooooooo`0@ooooo`04oomQ
0_oooooo0000o`0001kooooo00Co0000ooooooooH@;o0?ZJ0_ooool00oooH@;oooooooooo`0Eoooo
o`03oomQ0_oooooooooo00Gooooo1Ol000000ooooooo003oooooo`07ooooo`03oomQ0_oooooooooo
01;ooooo00?oof42ooooooooool07?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo
00[ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo
01?ooooo00?oof42ooooool0nYX01?l0nYX6ooooo`03oomQ0_oooooooooo01[ooooo00Coof42oooo
oooooooo003o0oooool00oooH@;ooooooomQ0P04ooooo`03oomQ0_oooooooooo00_ooooo00?oof42
ooooooooool00_ooool01?ooH@;oooooo`000?l0000Booooo`00:_ooool01_l0003ooooooomQ0_l0
nY[ooooooomQ0QOooooo00?oof42ooooooooool01oooool5o`000003o`00oooooooooooo00?ooooo
00?oof42ooooooooool04oooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo00kooooo
00?oof42ooooooooool02?ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo023ooooo
00Woof42oooooooooooooooooomQ0_oooooo003oooooool00?l02_ooool00oooH@;oooooooooo`0>
ooooo`03oomQ0_oooooooooo00Oooooo00Co003ooooooooooooo003o0oooool00oooH@;ooooooomQ
0P04ooooo`03oomQ0_oooooooooo013ooooo00Coof42oooooooooooo00007_ooool01?l0003ooooo
oomQ0_l0nYX2ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool01Oooool5o`000003
ooooool00?oooooo00Oooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0Mooooo`03
oomQ0_oooooooooo00gooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`06ooooo`03
oomQ0_oooooooooo013ooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`02o`3jVP04
ooooool0nY[o0?ZJo`3jVPGooooo00?oof42ooooooooool06Oooool01OooH@;o003ooooooooooooo
003o00?ooooo00?oof42ooooooooH@801Oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooo
oooo00Gooooo00?o0000ooooooooool04?ooool002[ooooo00Co0000ooooooooH@;o0?ZJ0_ooool0
0oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00Oooooo1Ol000000ol00?ooooooooooo`04
ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool08?ooool00oooH@;oooooooooo`0=
ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Q
ooooo`06oomQ0_ooooooooooooooooooH@;o003o0_ooool00ol00?ooooooooooo`08ooooo`03oomQ
0_oooooooooo00gooooo00?oof42ooooooooool02?ooool01?l00?ooooooooooool00?l3ooooo`03
oomQ0_ooooooof4200Cooooo00?oof42ooooooooool03oooool01OooH@;ooooooooooooooooo0000
01kooooo00Co0000ooooooooH@;o0?ZJ0_ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooo
oooo00Gooooo1Ol000000ooooooo003oooooo`07ooooo`03oomQ0_oooooooooo017ooooo00?oof42
ooooooooool07_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00_ooooo00?oof42
ooooooooool01Oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo017ooooo00?oof42
ooooool00?l00_l0nYX2ooooo`;o0?ZJ1_ooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooo
003o00;ooooo00Co003ooooooooooooooooo0_ooH@86ooooo`03oomQ0_oooooooooo00Wooooo00?o
of42ooooooooool01_ooool00ol0003oooooooooo`0@ooooo`00:_ooool01?l0003ooooooomQ0_l0
nYX2ooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool02?ooool3o`000003ooooool0
0?oooooo00Gooooo0oooH@8Aooooo`03oomQ0_oooooooooo023ooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool08_oo
ool01_ooH@;oooooooooooooooooof42o`00o`;ooooo00?o003oooooooooool02?ooool00oooH@;o
ooooooooo`0<ooooo`03oomQ0_oooooooooo00Wooooo00Co003ooooooooooooo003o0oooool00ooo
H@;ooooooomQ0P05ooooo`03oomQ0_oooooooooo00kooooo00Goof42ooooooooooooooooo`00000N
ooooo`04o`000?ooooooof42o`3jVP;ooooo00?oof42ooooooooool05Oooool00oooH@;ooooooooo
o`06ooooo`?o00000_ooool00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo013ooooo00?o
of42ooooooooool07oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00cooooo00?o
of42ooooooooool00oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo017ooooo00?o
of42ooooool0nYX00_l0nYX2ooooo`;o0?ZJ1_ooool00oooH@;oooooooooo`0Fooooo`04oomQ0_oo
ooooooooo`00o`;ooooo00Co003ooooooooooooooooo0_ooH@86ooooo`03oomQ0_oooooooooo00Wo
oooo00?oof42ooooooooool01_ooool00ol0003oooooooooo`0@ooooo`00:_ooool2o`000005oomQ
0_l0nY[oooooooooooooH@805_ooool00oooH@;oooooooooo`08ooooo`;o0?ZJ0_ooool00ol00?oo
ooooooooo`06ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool08?ooool00oooH@;o
ooooooooo`0<ooooo`03oomQ0_oooooooooo00_ooooo0_ooH@84ooooo`03oomQ0_oooooooooo02Co
oooo00Goof42ooooooooooooof42o`00o`02ooooo`03o`00oooooooooooo00Wooooo00?oof42oooo
ooooool02_ooool00oooH@;oooooooooo`0:ooooo`05o`00ooooooooooooooooool00?l00_ooool2
oomQ0PKooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`02o`0001kooooo00Co0000
ooooooooH@;o0?ZJ0_ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo00Gooooo1?l0
nYX2ooooo`03o`00oooooooooooo00Kooooo00?oof42ooooooooool04?ooool00oooH@;ooooooooo
o`0Oooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool03Oooool2oomQ0P?ooooo00?o
of42ooooooooool04oooool00oooH@;oooooooooo`0Aooooo`05oomQ0_oooooo0?ZJo`3jV_l00?l0
0_ooool3o`3jVPGooooo00?oof42ooooooooool05Oooool01OooH@;ooooooooooooooooo003o00;o
oooo00?o003oooooooooool00_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00So
oooo00?oof42ooooooooool01_ooool2o`0001;ooooo000Zooooo`04o`000?ooooooof42o`3jVP;o
oooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`08ooooo`;o0?ZJ0_ooool00ol00?oo
ooooooooo`06ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool06oooool00ol00?oo
ooooooooo`02ooooo`03o`00ooooooooof4200cooooo00?oof42ooooooooool03_ooool01?ooH@;o
oooooomQ0_ooH@8Wooooo`05oomQ0_oooooooooooomQ0_l00?l00_ooool00ol00?ooooooooooo`09
ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool02_ooool01Ol00?oooooooooooooo
oooo003o00?ooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oo
oooooooo00;ooooo00?o0000ooooooooool07?ooool01?l0003ooooooomQ0_l0nYX2ooooo`03oomQ
0_oooooooooo01Cooooo00?oof42ooooooooool01_ooool5o`3jVP03ooooool00?oooooo00Oooooo
00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Iooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooH@803?ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_ooooooof4201Kooooo
00?oof42ooooooooool04Oooool01OooH@;oooooo`3jV_l0nY[o003o00?ooooo0_l0nYX5ooooo`03
oomQ0_oooooooooo01Cooooo00?oof42ooooooooool00_ooool01?l00?ooooooooooool00?l4oooo
o`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`07oooo
o`03o`000?oooooooooo013ooooo000Qooooo`?o00001_ooool01?l0003ooooooomQ0_l0nYX2oooo
o`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool02Oooool2o`3jVP;ooooo00?o003ooooo
ooooool01_ooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo01_ooooo00?o003ooooo
ooooool00_ooool00ol00?oooooooomQ0P0<ooooo`03oomQ0_oooooooooo00oooooo00?oof42oooo
ooooool09oooool01OooH@;oooooooooooooH@;o003o00;ooooo00?o003oooooooooool02Oooool0
0oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00_ooooo00Go003oooooooooooooooooo`00
o`03ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool03Oooool00oooH@;ooooooooo
o`02ooooo`03o`000?oooooooooo01?ooooo0ol00006ooooo`04o`000?ooooooof42o`3jVP;ooooo
00?oof42ooooooooool05?ooool00oooH@;oooooooooo`06ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o
ooooo`00o`08ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool06Oooool00ol00?oo
ooooooooo`02ooooo`04o`00oooooooooooooomQ0P[ooooo00?oof42ooooooooool04Oooool00ooo
H@;oooooooooo`0Fooooo`03oomQ0_oooooooooo013ooooo00Koof42ooooool0nY[o0?ZJooooool0
0?l2ooooo`;o0?ZJ1Oooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00;ooooo00Co
003ooooooooooooo003o1?ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Gooooo
00?oof42ooooooooool02?ooool00ol0003oooooooooo`0@ooooo`008_ooool00ol0003ooooooooo
o`05ooooo`04o`000?ooooooof42o`3jVP;ooooo00?oof42ooooooooool04oooool00oooH@;ooooo
ooooo`02ooooo`03o`00oooooooooooo00?ooooo1?l0nYX00ooooooo003oooooo`08ooooo`03oomQ
0_oooooooooo00gooooo00?oof42ooooooooool06_ooool2o`00o`Cooooo00?o003oooooooooH@80
2oooool00oooH@;oooooooooo`0jooooo`05oomQ0_ooooooof42ooooool00?l00_ooool00ol00?oo
ooooooooo`09ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool02oooool01Ol00?oo
oooooooooooooooo003o00?ooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0=oooo
o`03oomQ0_oooooooooo00;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`05oooo
o`04o`000?ooooooof42o`3jVP;ooooo00?oof42ooooooooool05?ooool01OooH@;ooooooooooooo
oooo003o00Cooooo0_l0nYX01Ooooooo0?ZJo`3jV_oooooo003o00Wooooo00?oof42ooooooooool0
3_ooool00oooH@;oooooooooo`0Hooooo`;o003o1?ooool01?l00?ooooooooooooooH@8:ooooo`03
oomQ0_oooooooooo02[ooooo00?oof42ooooooooool04?ooool01_ooH@;oooooo`3jV_l0nY[ooooo
o`00o`;ooooo0ol0nYX4ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool00oooool0
1?l00?ooooooooooool00?l4ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01Ooo
ool00oooH@;oooooooooo`08ooooo`03o`000?oooooooooo013ooooo000Jooooo`Go00000oooool0
0ol0003oooooooooo`05ooooo`;o000000Goof42o`3jV_oooooooooooomQ0P0Eooooo`03oomQ0_oo
oooooooo00;ooooo00?o003oooooooooool00oooool4o`3jVP;ooooo00?o003oooooooooool01_oo
ool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Wooooo00?o003oooooool00?l00ooo
ool2o`00o`03ooooooooH@;ooooo00[ooooo00?oof42ooooooooool0>_ooool01OooH@;ooooooomQ
0_oooooo003o00;ooooo00?o003oooooooooool02Oooool00oooH@;oooooooooo`09ooooo`03oomQ
0_oooooooooo00[ooooo00?o003oooooooooool00_ooool01Ol00?ooooooooooooooooooof4200Ko
oooo00?oof42ooooooooool03?ooool01?ooH@;oooooooooooooool3o`0000kooooo1Ol00003oooo
o`03o`000?oooooooooo00Gooooo0_l000001OooH@;o0?ZJooooooooooooof4201Kooooo00Goof42
ooooooooooooooooo`00o`04ooooo`;o0?ZJ00Koooooo`3jV_l0nY[o0?ZJooooool00?l8ooooo`03
oomQ0_oooooooooo00gooooo00?oof42ooooooooool06Oooool00ol00?ooooooo`00o`03ooooo`04
o`00oooooooooooooomQ0PWooooo00?oof42ooooooooool0:oooool00oooH@;oooooooooo`0@oooo
o`06oomQ0_oooooo0?ZJo`3jV_oooooo003o0oooool2o`3jVPCooooo00?oof42ooooooooool04ooo
ool00oooH@;oooooooooo`02ooooo`05o`00ooooooooooooooooool00?l03_ooool00oooH@;ooooo
ooooo`03ooooo`03oomQ0_oooooooooo00Oooooo0ol0000Booooo`008_ooool00ol0003ooooooooo
o`05ooooo`04o`000?ooooooof42o`3jVP;ooooo00?oof42ooooooooool04oooool00oooH@;ooooo
ooooo`02ooooo`03o`00oooooooooooo00?ooooo0_l0nYX01OooH@;o0?ZJoooooooooooo003o00So
oooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0Iooooo`04o`00ooooooooooooo`00
o`?ooooo0_l00?l2ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0>oooool01Ooo
H@;ooooooomQ0_oooooo003o00?ooooo00?o003oooooooooool02Oooool00oooH@;oooooooooo`07
ooooo`03oomQ0_oooooooooo00_ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`09
ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool00oooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo00Gooooo00Co0000ooooooooH@;o0?ZJ0_ooool00oooH@;ooooooooo
o`0Dooooo`05oomQ0_ooooooooooooooool00?l00oooool3o`3jVP06oomQ0_oooooo0?ZJo`3jV_oo
oooo003o2?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Sooooo00Co003ooooo
oooooooo003o0oooool01Ol00?ooooooooooooooooooof4200Sooooo00?oof42ooooooooool0;?oo
ool00oooH@;oooooooooo`0?ooooo`06oomQ0_oooooo0?ZJo`3jV_oooooo003o0oooool2o`3jVPCo
oooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`03ooooo`05o`00oooooooooooooooo
ool00?l03_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Wooooo00?o0000oooo
ooooool04?ooool002;ooooo00?o0000ooooooooool01Oooool01?l0003ooooooomQ0_l0nYX2oooo
o`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`03oooo
o`;o0?ZJ00Goof42o`3jV_ooooooooooo`00o`08ooooo`03oomQ0_oooooooooo00cooooo00?oof42
ooooooooool06Oooool01Ol00?oooooooooooooooooo003o00;ooooo0_l00?l2ooooo`03oomQ0_oo
oooooooo00Oooooo00?oof42ooooooooool0>oooool01?ooH@;ooooooomQ0_l00?l4ooooo`03o`00
oooooooooooo00Wooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0;ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool02Oooool00oooH@;oooooooooo`0:ooooo`03oomQ
0_oooooooooo00Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`05ooooo`07o`00
0?oooooo0?ZJoomQ0_l0nY[ooooooomQ0P0Fooooo`05oomQ0_ooooooooooooooool00?l00oooool2
o`3jVP03o`00ooooH@;ooooo00?o0?ZJ00?o003oooooooooool01_ooool00oooH@;oooooooooo`0=
ooooo`03oomQ0_oooooooooo01Sooooo00Co003ooooooooooooo003o0_ooool2o`00o`?ooooo00?o
of42ooooooooool01Oooool00oooH@;oooooooooo`0]ooooo`03oomQ0_oooooooooo00oooooo00Ko
of42o`3jV_l0nY[o0?ZJooooool00?l3ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`0Booooo`03
oomQ0_oooooooooo00?ooooo00Go003oooooooooooooooooo`00o`0?ooooo`03oomQ0_oooooooooo
00;oof423?ooool00ol0003oooooooooo`0@ooooo`008Oooool2o`0000Oooooo00Co0000oooooooo
H@;o0?ZJ0_ooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo00;ooooo00?o003ooooo
ooooool00oooool2o`3jVP05oomQ0_l0nY[oooooooooool00?l02?ooool00oooH@;oooooooooo`0<
ooooo`03oomQ0_oooooooooo01Wooooo00Go003oooooooooooooooooo`00o`02ooooo`;o003o0_oo
ool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo03cooooo00Coof42ooooooooH@;o003o
1?ooool00ol00?ooooooooooo`09ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0
3?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Wooooo00?oof42ooooooooool0
2_ooool00oooH@;oooooooooo`04ooooo`03o`000?oooooooooo01?ooooo0_l00007ooooo`05o`00
0?oooooooooooomQ0_l0nYX00_ooool00oooH@;oooooooooo`0Cooooo`05oomQ0_oooooooooooooo
ool00?l00oooool2o`3jVP04o`00ooooH@;oooooooooo`;o0?ZJ00?o003oooooooooool01_ooool0
0oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Sooooo00Co003ooooooooooooo003o0_oo
ool2o`00o`?ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0]ooooo`03oomQ0_oo
oooooooo00oooooo00?oof42o`3jV_l0nYX00_ooool01?l00?ooooooooooooooool2o`3jVPGooooo
00?oof42ooooooooool04Oooool00oooH@;oooooooooo`03ooooo`05o`00ooooooooooooooooool0
0?l04?ooool2oomQ0Pkooooo00?o0000ooooooooool04?ooool002;ooooo00?o0000ooooooooool0
1Oooool01?l0003oooooo`3jV_ooH@82ooooo`03oomQ0_oooooooooo01;ooooo00?oof42oooooooo
ool00oooool00ol00?ooooooooooo`03ooooo`;o0?ZJ00Goof42o`3jV_ooooooooooo`00o`09oooo
o`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool06_ooool01Ol00?oooooooooooooooooo
003o00;ooooo0_l00?l3ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0??ooool0
1?ooH@;ooooooomQ0_l00?l4ooooo`05o`00ooooooooooooooooool00?l02?ooool00oooH@;ooooo
ooooo`05ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`0:ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool01Oooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo00Gooooo00Go0000ooooooooooooof42o`3jVP02ooooo`03
oomQ0_oooooooooo01?ooooo00Goof42ooooooooooooooooo`00o`03ooooo`;o0?ZJ00Co003ooomQ
0_oooooooooo0_l0nYX00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00_ooooo00?oof42
ooooooooool06Oooool01?l00?ooooooooooool00?l2ooooo`03o`00oooooooo003o00?ooooo00?o
of42ooooooooool01?ooool00oooH@;oooooooooo`0^ooooo`03oomQ0_oooooooooo00kooooo00?o
of42o`3jV_l0nYX00_ooool01?l00?ooooooooooooooool2o`3jVPGooooo00?oof42ooooooooool0
4?ooool00oooH@;oooooooooo`04ooooo`05o`00ooooooooooooooooool00?l08?ooool00ol0003o
ooooooooo`0@ooooo`00:_ooool2o`000005o`3jV_ooH@;oooooooooooooH@805?ooool00oooH@;o
ooooooooo`03ooooo`03o`00oooooooooooo00?ooooo0_l0nYX01OooH@;o0?ZJoooooooooooo003o
00Wooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0Iooooo`03o`00oooooooooooo
00;ooooo00Go003oooooool00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00Cooooo00?oof42
ooooooooool0?Oooool01?ooH@;ooooooomQ0_l00?l4ooooo`05o`00ooooooooooooooooool00?l0
2?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooool0
0_ooool00ol00?ooooooooooo`03o`0000Gooooo00?o003oooooooooH@802_ooool00oooH@;ooooo
ooooo`04ooooo`;o00007_ooool01Ol0003oooooooooooooH@;o0?ZJ00;ooooo00?oof42oooooooo
ool04oooool01OooH@;ooooooooooooooooo003o00;ooooo0ol0nYX01?l00?ooof42ooooooooool3
o`3jVPWooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Hooooo`03o`00oooooooo
oooo00;ooooo00Go003oooooool00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00?ooooo00?o
of42ooooooooool0;oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_l0nY[o0?ZJ00;ooooo00Co
003ooooooooooooooooo0_l0nYX5ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool0
1?ooool01Ol00?oooooooooooooooooo003o00;ooooo0ol00006ooooo`03o`00oooooooooooo017o
oooo0_l0000Booooo`00:_ooool01ol0003oooooo`3jV_ooH@;o0?ZJooooooooH@805?ooool00ooo
H@;oooooooooo`03ooooo`03o`00oooooooooooo00?ooooo0_l0nYX01OooH@;o0?ZJoooooooooooo
003o00Wooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0Iooooo`03o`00oooooooo
oooo00;ooooo00Go003oooooool00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00Cooooo00?o
of42ooooooooool0?Oooool01?ooH@;ooooooomQ0_l00?l4ooooo`05o`00ooooooooooooooooool0
0?l02?ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00gooooo00?o003ooooooooo
ool00_ooool00ol00?ooooooo`000004o`0000Cooooo00?o003oooooooooH@802Oooool00oooH@;o
ooooooooo`06ooooo`03o`000?oooooooooo01cooooo00Go0000ooooooooooooof42o`3jVP02oooo
o`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`02o`3j
VP03o`00ooooooooof4200?ooooo0_l0nYX9ooooo`03oomQ0_oooooooooo00_ooooo00?oof42oooo
ooooool06?ooool00ol00?ooooooooooo`02ooooo`05o`00oooooooo003oooooool00?l00oooool0
0oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo02oooooo00?oof42ooooooooool03_ooool0
0oooH@;o0?ZJo`3jVP02ooooo`04o`00ooooooooooooooooo`?o0?ZJ1?ooool00oooH@;ooooooooo
o`0@ooooo`03oomQ0_oooooooooo00Cooooo00Ko003oooooooooooooooooo`00ooooool5o`0000Go
oooo00?o003oooooooooool04_ooool00ol0003oooooooooo`0@ooooo`00:_ooool01Ol0003ooooo
ooooooooH@;o0?ZJ00;ooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`04ooooo`03
o`00oooooooooooo00?ooooo0_l0nYX01OooH@;o0?ZJoooooooooooo003o00Wooooo00?oof42oooo
ooooool02Oooool00oooH@;oooooooooo`0Jooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ool00?l00_ooool01Ol00?ooooooooooooooooooof4200Gooooo00?oof42ooooooooool0?Oooool0
1?ooH@;ooooooomQ0_l00?l4ooooo`05o`00ooooooooooooooooool00?l02Oooool00oooH@;ooooo
ooooo`03ooooo`03oomQ0_oooooooooo00gooooo00?o003oooooooooool00_ooool00ol00?oooooo
o`000004o`0000Cooooo00Co003oooooooooooooof422?ooool00oooH@;oooooooooo`06ooooo`03
o`000?oooooooooo01cooooo00Go0000ooooooooooooof42o`3jVP02ooooo`03oomQ0_oooooooooo
01;ooooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`02o`3jVP03o`00ooooooooof42
00?ooooo0_l0nYX9ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool06Oooool00ol0
0?ooooooooooo`02ooooo`05o`00oooooooo003oooooool00?l01?ooool01OooH@;ooooooooooooo
ooooof4203?ooooo00?oof42ooooooooool03Oooool00oooH@;o0?ZJo`3jVP02ooooo`03o`00oooo
oooooooo00;ooooo0_l0nYX4ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool01Ooo
ool00ol00?ooooooooooo`02ooooo`03o`00ool0003o000000?o00001Oooool00ol00?oooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo000Zooooo`05o`000?oooooooooooomQ0_l0nYX00_oo
ool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00Cooooo0_l00?l3ooooo`?o0?ZJ00Go
of42o`3jV_l0nY[oooooo`00o`09ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0
6_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo003o00;ooooo00Go003ooooooooooooo
oooooomQ0P04ooooo`03oomQ0_oooooooooo03kooooo00Coof42ooooooooH@;o003o1?ooool01?l0
0?ooooooooooooooool2o`00o`Sooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`0=
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooool000001?l00004ooooo`04o`00oooooooo
oooooomQ0PSooooo00?oof42ooooooooool01_ooool00ol0003oooooooooo`0Looooo`05o`000?oo
oooooooooomQ0_l0nYX00_ooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo00;ooooo
0_l00?l3o`3jVP03o`00ooooooooof4200?ooooo0ol0nYX8ooooo`03oomQ0_oooooooooo00[ooooo
00?oof42ooooooooool06Oooool00ol00?ooooooooooo`02ooooo`05o`00oooooooo003oooooool0
0?l01Oooool00oooH@;ooooooomQ0P0dooooo`03oomQ0_oooooooooo00[ooooo00Coof42oooooooo
ooooof420_l0nYX2ooooo`03o`00oooooooooooo00;ooooo0_l0nYX4ooooo`03oomQ0_oooooooooo
00oooooo00?oof42ooooooooool01Oooool00ol00?ooooooooooo`02ooooo`03o`00ool0003o0000
00?o00001Oooool00ol00?ooooooooooo`0Booooo`03o`000?oooooooooo013ooooo000Zooooo`;o
000000?ooooooomQ0_l0nYX00_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00Co
oooo0_l00?l3ooooo`;o0?ZJ00KooooooomQ0_l0nY[o0?ZJooooool00?l9ooooo`03oomQ0_oooooo
oooo00Wooooo00?oof42ooooooooool06_ooool00ol00?ooooooooooo`03ooooo`;o003o0_ooool0
1Ol00?ooooooooooooooooooof4200?ooooo0_ooH@90ooooo`04oomQ0_ooooooof42o`00o`Cooooo
00Ko003ooooooooooooo003oooooool00?l9ooooo`03oomQ0_oooooooooo00;oof424?ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00?o00001Oooool01Ol00?oooooooooooooooooo
of4200Kooooo00?oof42ooooooooool01_ooool2o`0001kooooo00Go0000ooooooooooooof42o`3j
VP02ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool00_ooool2o`00o`;o0?ZJ00?o
ooooo`00ooooool00_ooH@83ooooo`;o0?ZJ2?ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oo
oooooooo01Wooooo00?o003oooooooooool00_ooool2o`00o`;ooooo00?o003oooooooooool01?oo
ool00oooH@;oooooooooo`0cooooo`03oomQ0_oooooooooo00[ooooo00Coof42ooooooooooooof42
0_l0nYX2ooooo`05o`00ooooooooooooooooool00?l00_l0nYX4ooooo`03oomQ0_oooooooooo00oo
oooo00?oof42ooooooooool01Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo000000;o
000000?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0Aooooo`;o00004_ooool002[ooooo
00Go0000ooooooooooooof42o`3jVP02ooooo`03oomQ0_oooooooooo00oooooo00?oof42oooooooo
ool01Oooool2o`00o`?ooooo0_l0nYX01?ooooooof42o`3jV_l0nYX2ooooo`03o`00oooooooooooo
00Oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0Jooooo`03o`00oooooooooooo
00Cooooo00Go003oooooooooooooooooo`00o`04ooooo`03oomQ0_ooooooof4204;ooooo00Coof42
ooooooooH@;o003o1?ooool01_l00?ooooooooooool00?ooooooo`00o`[ooooo0_ooH@8Booooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_l0nYX5ooooo`;o003o0oooool00oooH@;o
ooooooooo`04ooooo`03oomQ0_oooooooooo00Oooooo00?o0000ooooooooool07?ooool01Ol0003o
ooooooooooooH@;o0?ZJ00;ooooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`02oooo
o`;o003o0_l0nYX00ooooooo003oooooo`02oomQ0P?ooooo0_l0nYX9ooooo`03oomQ0_oooooooooo
00Sooooo00?oof42ooooooooool06Oooool00ol00?ooooooooooo`04ooooo`04o`00oooooooooooo
o`00ocgooooo00?oof42ooooooooool02?ooool2oomQ0P;ooooo00?oof42o`3jV_ooool00oooool0
1?l00?ooooooooooool00?l2o`3jVPCooooo00?oof42ooooooooool03oooool00oooH@;ooooooooo
o`05ooooo`03o`00oooooooooooo00;ooooo00?o003oooooool0nYX00ol0nYX4ooooo`;o003o5?oo
ool00ol0003oooooooooo`0@ooooo`00:_ooool01Ol0003oooooooooooooH@;o0?ZJ00;ooooo00?o
of42ooooooooool03oooool00oooH@;oooooooooo`05ooooo`;o003o0oooool2o`3jVP04oooooooo
H@;o0?ZJo`3jVP;ooooo00?o003oooooooooool01oooool00oooH@;oooooooooo`07ooooo`03oomQ
0_oooooooooo01[ooooo00?o003oooooooooool01?ooool01Ol00?oooooooooooooooooo003o00Go
oooo00?oof42ooooooooool0@Oooool01?ooH@;ooooooomQ0_l00?l4ooooo`06o`00oooooooooooo
o`00oooooooo003o7Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00;o0?ZJ1Ooo
ool00ol00?ooooooo`00o`02ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool02?oo
ool00ol0003oooooooooo`0Looooo`05o`000?oooooooooooomQ0_l0nYX00_ooool00oooH@;ooooo
ooooo`0Booooo`03oomQ0_oooooooooo00;ooooo0_l00?l2o`3jVP03ooooool00?oooooo00;oof42
0oooool3o`3jVPSooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Iooooo`03o`00
oooooooooooo00Cooooo00Co003ooooooooooooo003o?Oooool00oooH@;oooooooooo`08ooooo`;o
of420_ooool00oooH@;o0?ZJooooo`03ooooo`04o`00ooooooooooooo`00o`;o0?ZJ1?ooool00ooo
H@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00Gooooo00?o003oooooooooool00oooool00ol0
0?ooooooo`3jVP04o`3jVP?ooooo00?o003oooooool00?l04oooool00ol0003oooooooooo`0@oooo
o`00:_ooool01Ol0003oooooooooooooH@;o0?ZJ00;ooooo00?oof42ooooooooool03oooool00ooo
H@;oooooooooo`04ooooo`03o`00oooooooo003o00?ooooo0_l0nYX01?ooooooof42o`3jV_l0nYX2
ooooo`03o`00oooooooooooo00Oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0J
ooooo`03o`00oooooooooooo00Cooooo00Go003oooooooooooooooooo`00o`19ooooo`04oomQ0_oo
ooooof42o`00o`;ooooo1?l0nYX01?oooooo003oooooool00?lMooooo`03o`00oooooooooooo00?o
oooo00?o003oooooool0nYX00ol0nYX4ooooo`03o`00oooooooo003o00?ooooo0oooH@800ooooooo
of42ooooo`0:ooooo`03o`000?oooooooooo01cooooo00Go0000ooooooooooooof42o`3jVP02oooo
o`03oomQ0_oooooooooo01;ooooo00Koof42ooooooooooooooooo`00ooooool3o`3jVP03ooooool0
0?oooooo00;oof421?ooool2o`3jVPSooooo00?oof42ooooooooool02?ooool00oooH@;ooooooooo
o`0Iooooo`03o`00oooooooooooo00Cooooo00Co003ooooooooooooo003o?Oooool00oooH@;ooooo
ooooo`08ooooo`04oomQ0_ooooooof42oomQ0P;o0?ZJ1?ooool01?l00?ooooooooooool00?l2o`3j
VPGooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`05ooooo`03o`00oooooooooooo
00?ooooo00Go003oo`3jV_l0nY[o0?ZJooooo`02o`3jVP?ooooo00?o003oooooool00?l04oooool0
0ol0003oooooooooo`0@ooooo`00:_ooool2o`000003ooooooooH@;o0?ZJ00;ooooo00?oof42oooo
ooooool03oooool00oooH@;oooooooooo`04ooooo`03o`00oooooooo003o00?ooooo0_l0nYX2oomQ
0P;o0?ZJ0_ooool00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooo
ooooool06_ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo01?ooooo00?o003ooooo
ooooool0<_ooool2oomQ0P03o`00oooooooooooo00Co0?ZJ00Coooooo`00oooooooo003o7Oooool0
0ol00?ooooooooooo`03ooooo`03o`00oooooooo0?ZJ00?o0?ZJ1?ooool00ol00?ooooooo`00o`06
ooooo`03oomQ0_oooooooooo00Wooooo0_l0000Nooooo`05o`000?oooooooooooomQ0_l0nYX00ooo
ool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00;ooooo00Co003oooooool0nY[o0?ZJ
0_ooool01?l00?ooof42ooooooooH@84ooooo`;o0?ZJ2?ooool00oooH@;oooooooooo`07ooooo`03
oomQ0_oooooooooo01[ooooo00?o003oooooooooool01oooool00ol00?ooooooooooo`0Dooooo`03
o`00oooooooooooo02Gooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`02oomQ0P;o
0?ZJ1?ooool01?l00?ooooooooooool00?l2o`3jVPGooooo00?oof42ooooooooool03Oooool00ooo
H@;oooooooooo`05ooooo`03o`00oooooooooooo00?ooooo00Go003oo`3jV_l0nY[oooooo`00o`02
o`3jVP?ooooo00?o003oooooool00?l04_ooool2o`0001;ooooo000Zooooo`05o`000?oooooooooo
oomQ0_l0nYX00_ooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00Gooooo00?o003o
ooooool00?l00oooool2o`3jVP;oof420_l0nYX2ooooo`03o`00oooooooooooo00Oooooo00?oof42
ooooooooool01_ooool00oooH@;oooooooooo`0Kooooo`03o`00oooooooooooo00Sooooo00?o003o
ooooooooool04oooool00ol00?ooooooooooo`0Sooooo`03o`00oooooooooooo00cooooo00Coof42
ooooool00?oooooo1_l0nYX01?l00?ooooooooooool00?lLooooo`03o`00oooooooooooo00?ooooo
00?o003oooooool0nYX00ol0nYX4ooooo`03o`00oooooooo003o01?ooooo00?o0000ooooooooool0
7?ooool01Ol0003oooooooooooooH@;o0?ZJ00?ooooo00?oof42ooooooooool04?ooool00oooH@;o
ooooooooo`02ooooo`04o`00oooooooo0?ZJo`3jVP;ooooo00Co003ooomQ0_ooooooof421?ooool2
o`3jVPSooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0Jooooo`03o`00oooooooo
oooo00Oooooo00?o003oooooooooool05?ooool00ol00?ooooooooooo`0Sooooo`03o`00oooooooo
of4200Sooooo00?oof42ooooooooool00_ooH@82o`3jVPCooooo00Co003ooooooooooooo003o0_l0
nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool01_oo
ool00ol00?ooooooooooo`03ooooo`05o`00ool0nY[o0?ZJooooool00?l00ol0nYX2ooooo`03o`00
oooooooo003o01?ooooo00?o0000ooooooooool04?ooool002[ooooo00Go0000ooooooooooooof42
o`3jVP02ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool01Oooool00ol00?oooooo
o`00o`03ooooo`;o0?ZJ0_ooH@82o`3jVP;ooooo00?o003oooooooooool02?ooool00oooH@;ooooo
ooooo`05ooooo`03oomQ0_oooooooooo01[ooooo00?o003oooooooooool02Oooool00ol00?oooooo
ooooo`0Cooooo`03o`00oooooooooooo02?ooooo00?o003oooooooooool03?ooool00oooH@;o003o
ooooo`03o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ0_ooool00ol00?ooooooooooo`0Jooooo`03o`00
oooooooooooo00?ooooo00Ko003oooooool0nY[o0?ZJoomQ0_l0nYX4ooooo`03o`00oooooooo003o
01?ooooo00?o0000ooooooooool07?ooool01?l0003oooooooooooooH@82o`3jVP;ooooo00?oof42
ooooooooool04?ooool00oooH@;oooooooooo`02ooooo`04o`00oooooooo0?ZJo`3jVP;ooooo00Co
003ooomQ0_ooooooof421?ooool2o`3jVPWooooo00?oof42ooooooooool01_ooool00oooH@;ooooo
ooooo`0Iooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool05?ooool00ol00?oooooo
ooooo`0Sooooo`03o`00ooooooooof4200Sooooo00?oof42ooooooooool00_ooH@82o`3jVPCooooo
00Co003ooooooooooooo003o0ol0nYX4ooooo`03oomQ0_oooooooooo00_ooooo00?oof42oooooooo
ool01oooool00ol00?ooooooooooo`03ooooo`?o0?ZJ00?ooooooomQ0_ooool00_l0nYX2ooooo`03
o`00oooooooo003o01?ooooo00?o0000ooooooooool04?ooool002[ooooo00Go0000oooooooooooo
of42o`3jVP02ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool01Oooool00ol00?oo
ooooo`00o`02ooooo`06o`00ool0nY[o0?ZJoomQ0_ooooooof420_l0nYX2ooooo`03o`00oooooooo
oooo00Oooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0Jooooo`03o`00oooooooo
oooo00Wooooo00?o003oooooooooool04oooool00ol00?ooooooooooo`0Rooooo`;o003o3_ooool0
0oooH@;o003oooooo`02o`3jVP;ooooo00?o003oooooool0nYX01?l0nYXLooooo`03o`00oooooooo
oooo00?ooooo00Ko003oooooool0nY[o0?ZJoomQ0_l0nYX4ooooo`03o`00oooooooo003o01?ooooo
00?o0000ooooooooool07?ooool01?l0003oooooooooooooH@82o`3jVP;ooooo00?oof42oooooooo
ool04?ooool00oooH@;oooooooooo`02ooooo`0:o`00oooooooo0?ZJo`3jV_oooooo003ooooooooo
H@;ooooooomQ0PCooooo0ol0nYX8ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0
6_ooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo01?ooooo00?o003oooooooooool0
8_ooool2o`00o`;ooooo00?oof42ooooooooool01?ooool01?ooH@;oooooooooooooool2oomQ0P;o
0?ZJ1?ooool01Ol00?ooooooooooool00?oooooo00;o0?ZJ1?ooool00oooH@;oooooooooo`07oooo
o`Coof422_ooool00ol00?ooooooooooo`03ooooo`;o0?ZJ00Coooooo`00ooooH@;ooooo0_l0nYX2
ooooo`03o`00oooooooo003o01?ooooo00?o0000ooooooooool04?ooool002[ooooo0_l000000ooo
ooooof42o`3jVP03ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool01Oooool00ol0
0?ooooooo`00o`02ooooo`?o0?ZJ00?oof42ooooooooH@800_l0nYX2ooooo`03o`00oooooooooooo
00Oooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0Jooooo`03o`00oooooooooooo
00Wooooo00?o003oooooooooool04oooool00ol00?ooooooooooo`0Rooooo`;o003o3_ooool00ooo
H@;o003oo`3jVP02o`3jVP;ooooo00?o003oooooool00?l01?l0nYXLooooo`03o`00oooooooooooo
00?ooooo00Ko003oooooool0nY[o0?ZJoomQ0_l0nYX3ooooo`04o`00ooooooooooooo`00oa;ooooo
0_l0000Nooooo`04o`000?oooooooooooomQ0P;o0?ZJ0_ooool00oooH@;oooooooooo`0@ooooo`03
oomQ0_oooooooooo00;ooooo00[o003oo`3jV_l0nY[o0?ZJooooool00?oooooooomQ0_ooooooof42
1Oooool2o`3jVPSooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0Jooooo`03o`00
oooooooooooo00Wooooo00?o003oooooooooool04oooool00ol00?ooooooooooo`0Qooooo`03o`00
oooooooo003o00;ooooo00?oof42ooooooooool01?ooool01?ooH@;oooooooooooooool2oomQ0P;o
0?ZJ1?ooool00ol00?ooooooo`00o`02ooooo`;o0?ZJ1?ooool00oooH@;oooooooooo`06ooooo`03
oomQ0_oooooooooo00cooooo00?o003oooooooooool00oooool2o`3jVP04ooooool00?ooof42oooo
o`;o0?ZJ00Goooooo`00ooooooooooooo`00o`0Booooo`;o00004_ooool001Kooooo0_l00004oooo
o`03o`000?oooooooooo00;ooooo0ol00006ooooo`05o`000?oooooooooooomQ0_l0nYX00oooool0
0oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00Gooooo00?o003oooooool00?l00_ooool2
o`3jVP04ooooooooH@;ooooooomQ0P;o0?ZJ0oooool00ol00?ooooooooooo`07ooooo`03oomQ0_oo
oooooooo00?ooooo00?oof42ooooooooool06oooool00ol00?ooooooooooo`09ooooo`03o`00oooo
oooooooo01?ooooo0_l00?lRooooo`03o`00oooooooo003o00kooooo00Coof42o`00ool0nY[o0?ZJ
0oooool00ol00?ooooooo`00o`02ooooo`;o0?ZJ7?ooool00ol00?ooooooooooo`04ooooo`05o`00
ool0nY[o0?ZJoomQ0_l0nYX00oooool01?l00?ooooooooooool00?lCooooo`03o`000?oooooooooo
00Sooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00006ooooo`04o`000?oooooooooo
oomQ0P;o0?ZJ0_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00;ooooo00?o003o
o`3jV_l0nYX00_ooool01Ol00?oooooooomQ0_ooooooof4200Gooooo0_l0nYX8ooooo`03oomQ0_oo
oooooooo00Gooooo00?oof42ooooooooool06_ooool00ol00?ooooooooooo`09ooooo`03o`00oooo
oooooooo01?ooooo0_l00?lQooooo`04o`00ooooooooooooo`00o`?ooooo00?oof42ooooooooool0
0_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_l0nY[ooooo00Cooooo00?o003oooooool00?l0
0_ooool2o`3jVPGooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0=ooooo`03o`00
oooooooooooo00;ooooo0ol0nYX01?oooooo003ooomQ0_ooool2o`3jVP05ooooool00?oooooooooo
ool00?l04oooool00ol0003oooooooooo`0@ooooo`005Oooool01?l0003oooooooooool00007oooo
o`05o`000?ooooooooooooooool000001Oooool01Ol0003oooooooooooooH@;o0?ZJ00?ooooo00?o
of42ooooooooool03?ooool00oooH@;oooooooooo`06ooooo`03o`00oooooooo003o00;ooooo0_l0
nYX01?ooooooof42ooooooooH@82o`3jVP?ooooo00?o003oooooooooool01oooool00oooH@;ooooo
ooooo`03ooooo`03oomQ0_oooooooooo01_ooooo00?o003oooooooooool02Oooool00ol00?oooooo
ooooo`0Cooooo`;o003o8_ooool00ol00?ooooooo`00o`0>ooooo`04oomQ0_l00?oo0?ZJo`3jVP?o
oooo00?o003oooooool00?l00_ooool2o`3jVQcooooo00?o003oooooooooool01?ooool3o`3jVP03
oomQ0_l0nY[o0?ZJ00;ooooo00Co003ooooooooooooo003o4oooool00ol0003oooooooooo`07oooo
o`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000005ooooo`04o`000?oo
oooooooooomQ0P;o0?ZJ0_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00;ooooo
00?o003oo`3jV_l0nYX00_ooool01Ol00?oooooooomQ0_ooooooof4200Gooooo0_l0nYX8ooooo`03
oomQ0_oooooooooo00Cooooo00?oof42ooooooooool06oooool00ol00?ooooooooooo`09ooooo`03
o`00oooooooooooo01?ooooo0_l00?lQooooo`04o`00ooooooooooooo`00o`?ooooo00?oof42oooo
ooooool00_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_l0nY[ooooo00Cooooo00?o003ooooo
ool00?l00_ooool2o`3jVPGooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0=oooo
o`03o`00oooooooooooo00;ooooo0_l0nYX2ooooo`03o`00ooooH@;ooooo00?o0?ZJ00Co003ooooo
oooooooo003o4oooool00ol0003oooooooooo`0@ooooo`003_ooool5o`0000;ooooo00Co0000oooo
oooooooo00002oooool00ol0003oooooooooo`03ooooo`05o`000?oooooooooooomQ0_l0nYX00ooo
ool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Kooooo00?o003oooooool0nYX01?l0
nYX01?ooooooof42ooooooooH@82o`3jVP?ooooo00?o003oooooooooool01oooool00oooH@;ooooo
ooooo`03ooooo`03oomQ0_oooooooooo01[ooooo00?o003oooooooooool02_ooool00ol00?oooooo
ooooo`0Booooo`03o`00oooooooo003o02;ooooo00?o003oooooool00?l03_ooool01?ooH@;o0?ZJ
o`3jV_l0nYX4ooooo`;o003o0_ooool3o`3jVQ_ooooo00?o003oooooooooool01?ooool2o`3jVP04
o`00ooooH@;o0?ZJo`3jVP;ooooo00Go003oooooooooooooooooo`00o`0Booooo`03o`000?oooooo
oooo00Go00000_ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00?ooooo00Co
0000ooooooooooooof420_l0nYX3ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool0
0oooool00ol00?oo0?ZJo`3jVP02ooooo`05o`00ooooooooof42ooooooooH@801Oooool2o`3jVPWo
oooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`0Jooooo`03o`00oooooooooooo00[o
oooo00?o003oooooooooool04_ooool00ol00?ooooooo`00o`0Qooooo`04o`00ooooooooooooo`00
o`?ooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_l0nY[ooooo
00Cooooo00?o003oooooool00?l00_ooool2o`3jVPGooooo00?oof42ooooooooool00oooool00ooo
H@;oooooooooo`0>ooooo`04o`00ooooooooooooooooo`?o0?ZJ0_ooool01?l00?ooof42oooooooo
ool2o`3jVP05o`00ooooooooooooooooool00?l04_ooool00ol0003oooooooooo`0@ooooo`005Ooo
ool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00?ooooo0_l000000oooooooof42
o`3jVP03ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool01_ooool00ol00?oooooo
o`3jVP04o`3jVP04ooooooooH@;ooooooomQ0P?o0?ZJ0_ooool00ol00?ooooooooooo`08ooooo`05
oomQ0_ooooooooooooooooooH@807Oooool00ol00?ooooooooooo`0:ooooo`03o`00oooooooooooo
01;ooooo00?o003oooooool00?l08Oooool01?l00?ooooooooooool00?l>ooooo`03oomQ0_l0nY[o
0?ZJ00Gooooo0_l00?l3ooooo`;o0?ZJ6?ooool01?l00?ooooooooooool00?l6ooooo`;o0?ZJ00Co
oooooomQ0_l0nY[o0?ZJ0_ooool01Ol00?oooooooooooooooooo003o013ooooo0ol00009ooooo`04
o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool00oooool2o`000004ooooooooH@;o0?ZJ
o`3jVP?ooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`03ooooo`03o`00ool0nY[o
0?ZJ00;ooooo00Go003oooooooooH@;ooooooomQ0P05ooooo`?o0?ZJ2?ooool00oooH@;ooooooooo
o`03ooooo`03oomQ0_oooooooooo01[ooooo00?o003oooooooooool02_ooool00ol00?oooooooooo
o`0Booooo`03o`00oooooooo003o027ooooo00Co003ooooooooooooo003o1?ooool4oomQ0PKooooo
0_l0nYX5ooooo`03o`00oooooooo003o00;ooooo0_l0nYX6ooooo`03oomQ0_oooooooooo00;ooooo
00?oof42ooooooooool02oooool01?l00?ooooooooooool00?l3ooooo`;o0?ZJ00Go003oooooool0
0?oooooooomQ0P02ooooo`;o0?ZJ00Go003oooooooooooooooooo`00o`0@ooooo`?o00004_ooool0
01Gooooo00Co0000oooooooooooo00001oooool4o`0000Kooooo00Co0000ooooooooooooof420_l0
nYX2ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool01_ooool01_l00?oo0?ZJo`3j
V_l0nY[oooooo`00o`;ooooo00Coof42ooooooooH@;ooooo0_l0nYX2ooooo`03o`00oooooooooooo
00Sooooo00Coof42ooooooooooooof427_ooool00ol00?ooooooooooo`0:ooooo`03o`00oooooooo
oooo01;ooooo00?o003oooooool00?l08Oooool01?l00?ooooooooooool00?l?ooooo`;o0?ZJ1Ooo
ool2o`00o`?ooooo0_l0nYX8ooooo`03o`00oooooooooooo00gooooo00?o003oooooool00?l01ooo
ool2o`3jVP03ooooooooH@;o0?ZJ00;o0?ZJ00?oooooo`00ooooool00_ooool00ol00?oooooooooo
o`0@ooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo00001oooool4o`0000Kooooo
00Co0000ooooooooooooof420_l0nYX3ooooo`03oomQ0_oooooooooo00kooooo00?oof42oooooooo
ool00oooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ooooooooof4200;ooooo00?oof42oooooooo
ool00oooool2o`3jVPSooooo0_ooH@83ooooo`03oomQ0_oooooooooo01_ooooo1Ol0nYX8ooooo`03
o`00oooooooooooo01;ooooo00?o003oooooool00?l08?ooool01Ol00?oooooooooooooooooo003o
00kooooo0_l0nYX5ooooo`03o`00oooooooo003o00;ooooo0_l0nYX6ooooo`05oomQ0_oooooooooo
o`00ooooH@803_ooool00ol00?ooooooo`00o`04ooooo`;o0?ZJ00?oooooo`00ool00?l00_ooH@80
1Ol00?ooooooo`3jV_l0nY[o003o00?ooooo00?o003oooooooooool04?ooool00ol0003ooooooooo
o`0@ooooo`005Oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Oooooo00Co
0000ooooooooooooof420_l0nYX3ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0
1oooool01Ol00?oo0?ZJo`3jV_oooooo003o00?ooooo00Coof42ooooooooH@;ooooo0_l0nYX2oooo
o`03o`00oooooooooooo00Wooooo00?oof42ooooooooH@807Oooool00ol00?ooooooooooo`0;oooo
o`03o`00oooooooooooo01;ooooo00?o003oooooool00?l08Oooool01Ol00?oooooooooooooooooo
003o00kooooo0_l0nYX5ooooo`;o003o0oooool2o`3jVPSooooo00?o003oooooooooool03Oooool3
o`00o`Oooooo0_l0nYX00oooooooof42o`3jVP03o`3jVP05o`00ooooooooooooooooool00?l04_oo
ool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
1oooool01?l0003oooooooooooooH@82o`3jVP?ooooo00?oof42ooooooooool03_ooool00oooH@;o
ooooooooo`03ooooo`05o`00ool0nY[o0?ZJooooool00?l00_ooool01?ooH@;oooooooooooooH@85
ooooo`;o0?ZJ2_ooool00oooH@;ooooooomQ0P0Mooooo`Ko0?ZJ2?ooool00ol00?ooooooooooo`0B
ooooo`03o`00oooooooo003o023ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0;
ooooo`;o0?ZJ1_ooool2o`00o`;ooooo0_l0nYX00ol00?ooooooooooo`03ooooo`05oomQ0_oooooo
ooooo`00ooooH@803_ooool3o`00o`?ooooo0ol0nYX00ooooooo003oo`00o`02oomQ0P05o`00oooo
oooo0?ZJo`3jV_l00?l00oooool00ol00?ooooooooooo`0@ooooo`03o`000?oooooooooo013ooooo
000Fooooo`;o00002?ooool5o`0000Gooooo00Co0000ooooooooooooof420_l0nYX3ooooo`03oomQ
0_oooooooooo00[ooooo00?oof42ooooooooool01oooool01Ol00?oo0?ZJo`3jV_oooooo003o00?o
oooo00Coof42ooooooooH@;ooooo0_l0nYX3ooooo`03o`00oooooooooooo00Wooooo00?oof42oooo
ooooool07?ooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo01;ooooo00?o003ooooo
ool00?l08Oooool01Ol00?oooooooooooooooooo003o00gooooo0ol0nYX5ooooo`;o003o0oooool2
o`3jVPSooooo00?o003oooooooooool03Oooool3o`00o`Oooooo0_l0nYX01?ooooooof42o`00oooo
ool3o`3jVP?ooooo00?o003oooooooooool04?ooool00ol0003oooooooooo`08ooooo`;o00002?oo
ool5o`0000Gooooo00Co0000ooooooooooooof420_l0nYX3ooooo`03oomQ0_oooooooooo00kooooo
00?oof42ooooooooool00oooool3o`3jVP05ooooool00?ooooooooooooooH@800_ooool00oooH@;o
ooooooooo`03ooooo`;o0?ZJ2oooool00oooH@;oooooooooo`0Kooooo`?o0?ZJ0_ooool3o`3jVPOo
oooo00?o003oooooooooool04_ooool00ol00?ooooooo`00o`0Pooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool02oooool2o`3jVPKooooo0_l00?l2ooooo`?o0?ZJ1_ooool3oomQ0Poo
oooo0ol00?l3ooooo`;o0?ZJ0_ooool2o`00o`04oomQ0_ooooooof42ooooo`?o0?ZJ0oooool00ol0
0?ooooooooooo`0@ooooo`03o`000?oooooooooo013ooooo000Zooooo`;o000000CooooooomQ0_l0
nY[o0?ZJ0oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00Oooooo0ol0nYX2o`00
o`?ooooo00Coof42ooooooooH@;ooooo0_l0nYX3ooooo`03o`00oooooooooooo02Sooooo00?o003o
ooooooooool03?ooool00ol00?ooooooooooo`0Aooooo`03o`00oooooooo003o027ooooo00Go003o
ooooooooooooooooo`00o`0=ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ2?oo
ool2o`00o`kooooo0ol00?l7ooooo`;o0?ZJ00?ooooooomQ0_l00?l00_ooool2o`3jVP?ooooo00?o
003oooooooooool03oooool2o`0001kooooo00Ko0000oooooooooooooooooomQ0_l0nYX3ooooo`03
oomQ0_oooooooooo00kooooo00?oof42ooooooooool00oooool2o`3jVP03ooooool00?oo003o00;o
oooo00Coof42ooooooooooooof421Oooool3o`3jVROooooo0ol0nYX4ooooo`?o0?ZJ1_ooool00ol0
0?ooooooooooo`0Booooo`03o`00oooooooo003o023ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`0:ooooo`?o0?ZJ1_ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ1_ooool01?oo
H@;oooooo`00ool00?l>ooooo`?o003o0oooool2o`3jVP;ooooo0_l00?l00oooH@;ooooooomQ0P02
ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`0?ooooo`;o00004_ooool002[ooooo00Co0000oooo
ooooooooof420_l0nYX3ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool02?ooool2
o`3jVP03ooooool00?oo003o00?ooooo00Coof42ooooooooH@;ooooo0_l0nYX3ooooo`03o`00oooo
oooooooo02Oooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`0Aooooo`04o`00oooo
ooooooooo`00oaoooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0:ooooo`?o0000
1_ooool00ol00?ooooooooooo`02ooooo`?o0?ZJ1oooool2o`00o`kooooo00?o003oooooool00?l0
1_ooool3o`3jVP03ooooooooH@;o003o00;ooooo0_l0nYX3ooooo`03o`00oooooooooooo013ooooo
00?o0000ooooooooool07?ooool01_l0003oooooooooooooooooof42o`3jVP?ooooo00?oof42oooo
ooooool03_ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool01?oo
H@;oooooooooooooH@86ooooo`;o0?ZJ9_ooool3o`3jVPKooooo0_l0nYX6ooooo`03o`00oooooooo
oooo01;ooooo00Co003ooooooooooooo003o7oooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00[ooooo0ol00006ooooo`03o`00oooooooooooo00;ooooo0_l0nYX8ooooo`;o003o3_oo
ool00ol00?ooooooo`00o`02ooooo`?o0?ZJ0_ooool01Ol00?oooooooomQ0_ooooooof4200;ooooo
0_l0nYX3ooooo`03o`00oooooooooooo013ooooo00?o0000ooooooooool04?ooool002[ooooo00Co
0000ooooooooooooof420_l0nYX3ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0
2?ooool2o`3jVP03ooooool00?oo003o00?ooooo00Coof42ooooooooH@;ooooo0ol0nYX2ooooo`03
o`00oooooooooooo02Oooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`0Aooooo`04
o`00ooooooooooooo`00oaoooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`09oooo
o`Go00001Oooool00ol00?ooooooooooo`03ooooo`;o0?ZJ1oooool2o`00o`kooooo00Co003ooooo
ool00?oooooo1ol0nYX01?ooooooof42oomQ0_l00?l2ooooo`;o0?ZJ0oooool00ol00?oooooooooo
o`0@ooooo`03o`000?oooooooooo01cooooo00Ko0000oooooooooooooooooomQ0_l0nYX4ooooo`03
oomQ0_oooooooooo00cooooo00?oof42ooooooooool01?ooool2o`3jVP03ooooool00?oo003o00;o
oooo00Coof42ooooooooooooof421_ooool2o`3jVRGooooo0ol0nYX00ol00?ooooooooooo`04oooo
o`?o0?ZJ1Oooool00ol00?ooooooooooo`0Booooo`04o`00ooooooooooooo`00oaoooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`09ooooo`Go00001Oooool00ol00?ooooooooooo`02
ooooo`;o0?ZJ2?ooool2o`00o`kooooo00?o003oooooool00?l00_ooool2o`3jVP?ooooo00Go003o
ooooooooH@;ooooooomQ0P02ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`0@ooooo`03o`000?oo
oooooooo013ooooo000Zooooo`04o`000?oooooooooooomQ0P;o0?ZJ0oooool00oooH@;ooooooooo
o`09ooooo`03oomQ0_oooooooooo00Sooooo0_l0nYX00ooooooo003oo`00o`03ooooo`03oomQ0_oo
ooooof4200;ooooo0_l0nYX2ooooo`03o`00oooooooooooo02Oooooo00?o003oooooooooool03Ooo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00cooooo00Co003ooooooooooooo003o
7oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Wooooo1Ol00005ooooo`03o`00
oooooooooooo00?ooooo0_l0nYX7ooooo`;o003o3Oooool01?l00?ooooooooooooooool8o`3jVP04
ooooooooH@;ooooooomQ0P;ooooo0_l0nYX3ooooo`03o`00oooooooooooo013ooooo00?o0000oooo
ooooool07?ooool01_l0003oooooooooooooooooof42o`3jVPCooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`04ooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool01?ooH@;ooooooooo
ooooH@86ooooo`;o0?ZJ9Oooool2o`3jVP03ooooool00?oooooo00Kooooo0_l0nYX6ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool03?ooool01?l00?ooooooooooool00?lCooooo`?o
0?ZJ2Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Wooooo1Ol00005ooooo`03
o`00oooooooooooo00;ooooo0_l0nYX8ooooo`;o003o3Oooool00ol00?ooooooooooo`03ooooo`;o
0?ZJ0oooool01Ol00?oooooooomQ0_ooooooof4200;ooooo0_l0nYX3ooooo`03o`00oooooooooooo
013ooooo00?o0000ooooooooool04?ooool002[ooooo0_l000001?ooooooof42o`3jV_l0nYX3oooo
o`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool02?ooool3o`3jVP03ooooool00?oo003o
00?ooooo00?oof42ooooooooH@800_ooool2o`3jVP;ooooo00?o003oooooooooool09_ooool00ol0
0?ooooooooooo`0>ooooo`04o`00ooooooooooooooooo`;o003o3_ooool01?l00?ooooooooooool0
0?lOooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool02Oooool5o`0000_ooooo0_l0
nYX7ooooo`;o003o3Oooool00ol00?ooooooooooo`03o`3jVP?ooooo0ol0nYX01?ooooooof42oooo
ooooH@82ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`0?ooooo`;o00007_ooool01Ol0003ooooo
ooooooooooooof4200;o0?ZJ0oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00?o
oooo0ol0nYX00ooooooo003oo`00o`02ooooo`04oomQ0_oooooooooooomQ0PKooooo0_l0nYXToooo
o`?o0?ZJ00?o003oooooooooool01_ooool3o`3jVPGooooo00Co003ooooooooooooooooo0_l00?l>
ooooo`04o`00ooooooooooooo`00oa;ooooo1Ol0nYX7ooooo`03o`00oooooooooooo00?ooooo00?o
003oooooooooool02Oooool5o`0000[ooooo0_l0nYX8ooooo`;o003o3Oooool00ol00?oooooooooo
o`02ooooo`?o0?ZJ1Oooool00oooH@;ooooooomQ0P02ooooo`;o0?ZJ0oooool00ol00?oooooooooo
o`0?ooooo`;o00004_ooool002[ooooo00Co0000ooooooooooooof420_l0nYX4ooooo`03oomQ0_oo
oooooooo00Oooooo00?oof42ooooooooool02?ooool2o`3jVP;ooooo00?o003oooooooooool00_oo
ool00oooH@;ooooooomQ0P02ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`0Vooooo`03o`00oooo
oooooooo00kooooo00Ko003ooooooooooooo003oooooool00?l>ooooo`04o`00ooooooooooooo`00
oaoooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`09ooooo`04o`00ool0003o0000
o`0000cooooo0_l0nYX7ooooo`03o`00oooooooo003o00cooooo00?o003oooooool0nYX00_l0nYX5
ooooo`;o0?ZJ00CooooooomQ0_ooooooof420_ooool3o`3jVP?ooooo00?o003oooooooooool03ooo
ool00ol0003oooooooooo`0Looooo`05o`000?ooooooooooooooooooH@800_l0nYX3ooooo`03oomQ
0_oooooooooo00cooooo00?oof42ooooooooool00oooool2o`3jVP;ooooo00Go003ooooooooooooo
oooooomQ0P02ooooo`03oomQ0_oooooooooo00Cooooo0ol0nYXRooooo`?o0?ZJ00?oooooo`00oooo
ool02?ooool2o`3jVPGooooo00Ko003ooooooooooooo003oooooool00?l>ooooo`04o`00oooooooo
ooooo`00oa7ooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYX6ooooo`03o`00oooooooooooo00?ooooo
00?o003oooooooooool02Oooool01?l00?oo0000o`000?l00005ooooo`;oof421?ooool2o`3jVPSo
oooo00?o003oooooool00?l03?ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ1_ooool00oooH@;o
oooooomQ0P02ooooo`?o0?ZJ0oooool00ol00?ooooooooooo`0?ooooo`03o`000?oooooooooo013o
oooo000Zooooo`06o`000?ooooooooooooooooooH@;o0?ZJ1?ooool00oooH@;oooooooooo`07oooo
o`03oomQ0_oooooooooo00Sooooo0_l0nYX2ooooo`03o`00oooooooooooo00;ooooo00?oof42oooo
ooooH@800_ooool2o`3jVP;ooooo00?o003oooooooooool09_ooool00ol00?ooooooooooo`0>oooo
o`03o`00oooooooo003o00;ooooo00?o003oooooooooool02oooool01Ol00?oooooooooooooooooo
003o01kooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`09ooooo`03o`00ool0nY[o
0?ZJ00gooooo0_l0nYX7ooooo`03o`00oooooooo003o00cooooo00Co003oooooool0nY[o0?ZJ2Ooo
ool00oooH@;ooooooomQ0P02ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oooooool00?l03ooo
ool00ol0003oooooooooo`0Looooo`05o`000?ooooooooooooooooooH@800_l0nYX3ooooo`03oomQ
0_oooooooooo00cooooo00?oof42ooooooooool00oooool2o`3jVP;ooooo00Go003ooooooooooooo
oooooomQ0P02ooooo`03oomQ0_oooooooooo00Cooooo00?o003oo`3jV_l0nYX08Oooool3o`3jVP;o
oooo00?o003oooooooooool01oooool3o`3jVPCooooo00?o003oooooool00?l00_ooool00ol00?oo
ooooooooo`0;ooooo`05o`00ooooooooooooooooool00?l04?ooool3o`3jVP?ooooo0ol0nYX5oooo
o`03o`00oooooooooooo00?ooooo00?o003oooooooooool02Oooool00ol00?oo0?ZJo`3jVP05oooo
o`03oomQ0_ooooooof4200Cooooo0ol0nYX7ooooo`03o`00oooooooo003o00cooooo00?o003ooooo
ooooool00_ooool2o`3jVPKooooo00?oof42ooooooooH@800_ooool00ol00?oo0?ZJo`3jVP03oooo
o`03o`00oooooooo003o00oooooo00?o0000ooooooooool04?ooool002[ooooo00Ko0000oooooooo
oooooooooomQ0_l0nYX4ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool02?ooool3
o`3jVP;ooooo00?o003oooooooooool00_ooool00oooH@;ooooooomQ0P02ooooo`;o0?ZJ0_ooool0
0ol00?ooooooooooo`0Uooooo`03o`00oooooooooooo00oooooo0_l00?l4ooooo`03o`00oooooooo
oooo00[ooooo00Go003oooooooooooooooooo`00o`0Dooooo`Go0?ZJ1Oooool00ol00?oooooooooo
o`03ooooo`03o`00oooooooooooo00Wooooo00?o003oo`3jV_l0nYX03Oooool2o`3jVPOooooo00?o
003oooooool00?l03?ooool01?l00?ooooooo`3jV_l0nYX9ooooo`03oomQ0_ooooooof4200;ooooo
00?o003oo`3jV_l0nYX00oooool00ol00?ooooooo`00o`0?ooooo`03o`000?oooooooooo01cooooo
00Go0000oooooooooooooooooomQ0P02o`3jVP?ooooo00?oof42ooooooooool03?ooool00oooH@;o
ooooooooo`03ooooo`;o0?ZJ0_ooool01Ol00?ooooooooooooooooooof4200;ooooo00?oof42oooo
ooooool01?ooool00ol00?oo0?ZJo`3jVP0Pooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`09oooo
o`;o0?ZJ1?ooool2o`00o`Cooooo00?o003oooooooooool02_ooool01Ol00?oooooooooooooooooo
003o013ooooo0_l0nYX5ooooo`?o0?ZJ1?ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo
oooo00Wooooo00?o003oo`3jV_l0nYX01?ooool01?ooH@;oooooooooooooH@85ooooo`;o0?ZJ1ooo
ool00ol00?ooooooo`00o`0<ooooo`04o`00ooooooooooooooooo`?o0?ZJ1_ooool00oooH@;ooooo
oomQ0P02ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oooooool00?l03oooool00ol0003ooooo
ooooo`0@ooooo`00:_ooool2o`0000;ooooo00?oof42o`3jV_ooool00oooool00oooH@;oooooo`00
o`06ooooo`03oomQ0_oooooooooo00Sooooo0_l0nYX01?l00?ooooooooooool00?l4ooooo`03oomQ
0_ooooooof4200;ooooo0ol0nYX00ooooooo003oooooo`0Vooooo`03o`00oooooooooooo00oooooo
00?o003oooooooooool00oooool00ol00?ooooooooooo`0:ooooo`05o`00ooooooooooooooooool0
0?l04_ooool8o`3jVPCooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`09ooooo`?o
0?ZJ3Oooool3o`3jVPKooooo00?o003oooooool00?l03?ooool01?l00?oo0?ZJo`3jV_l0nYX9oooo
o`03oomQ0_ooooooof4200;ooooo00?o003oo`3jV_l0nYX00oooool2o`00o`03ooooool00?oooooo
00cooooo0_l0000Nooooo`05o`000?ooooooooooooooooooH@800_l0nYX3ooooo`03oomQ0_oooooo
003o00cooooo00?oof42ooooooooool00oooool2o`3jVP;ooooo00Go003ooooooooooooooooooomQ
0P02ooooo`03oomQ0_oooooooooo00Cooooo00?o003oo`3jV_l0nYX07oooool3o`3jVP?ooooo00?o
003oooooooooool02Oooool2o`3jVPCooooo00?o003oooooooooool00oooool00ol00?oooooooooo
o`0:ooooo`05o`00ooooooooooooooooool00?l03oooool3o`3jVPKooooo0_l0nYX4ooooo`03o`00
oooooooooooo00?ooooo00?o003oooooooooool02Oooool00ol00?oo0?ZJo`3jVP04ooooo`05oomQ
0_ooooooooooooooooooH@801?ooool2o`3jVPOooooo00?o003oooooool00?l03?ooool01?l00?oo
ooooooooooooool2o`3jVPOooooo00?oof42ooooooooH@800_ooool00ol00?oo0?ZJo`3jVP03oooo
o`;o003o00?oooooo`00ooooool03?ooool2o`0001;ooooo000Zooooo`06o`000?oooooooooooooo
ooooH@;o0?ZJ1?ooool00oooH@;oooooo`00o`04ooooo`;oof422oooool2o`3jVP03o`00oooooooo
oooo00Gooooo00?oof42ooooooooH@800oooool2o`3jVP03ooooool00?oooooo00;ooooo00?o003o
ooooooooool08?ooool00ol00?ooooooooooo`0Fooooo`03o`00oooooooooooo00[ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`0>ooooo`Co0?ZJ0oooool3o`3jVP?ooooo00?o003o
ooooooooool00oooool00ol00?ooooooooooo`09ooooo`;o0?ZJ00?o003oooooooooool02oooool0
0ol00?oo0?ZJo`3jVP06ooooo`03o`00oooooooo003o00cooooo00?o003oo`3jV_l0nYX02_ooool0
1_ooH@;ooooooomQ0_oooooo003oooooo`;o0?ZJ0oooool01?l00?ooooooooooool00?l>ooooo`03
o`000?oooooooooo01cooooo00Go0000oooooooooooooooooomQ0P02o`3jVPCooooo00?oof42o`00
ooooool02oooool00oooH@;oooooooooo`02ooooo`?o0?ZJ1_ooool01?ooH@;oooooooooooooH@86
ooooo`05o`00ool0nY[o0?ZJooooool00?l07?ooool3o`3jVP?ooooo00?o003oooooooooool02_oo
ool2o`3jVP[ooooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00_ooooo0ol0nYX00ol00?ooooooooooo`04ooooo`?o0?ZJ0oooool00ol00?oooooooooo
o`03ooooo`03o`00oooooooooooo00Wooooo0ol0nYX4ooooo`05oomQ0_ooooooooooooooooooH@80
1?ooool2o`3jVPOooooo00?o003oooooool00?l03?ooool00ol00?ooooooooooo`03o`3jVPOooooo
00Koof42ooooooooH@;oooooo`00ooooool2o`3jVP?ooooo00Co003ooooooooooooo003o3_ooool0
0ol0003oooooooooo`0@ooooo`00:_ooool01_l0003oooooooooooooooooof42o`3jVPGooooo00?o
of42o`00ooooool00_ooool00oooH@;oooooooooo`0:ooooo`?o0?ZJ2?ooool00oooH@;ooooooomQ
0P03ooooo`;o0?ZJ0_ooool01?l00?ooooooooooool00?l?ooooo`03o`00oooooooooooo00oooooo
00?o003oooooooooool05oooool00ol00?ooooooooooo`0:ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool03Oooool3o`3jVPKooooo1?l0nYX00ooooooo003oooooo`04ooooo`03o`00
oooooooooooo00Wooooo0_l0nYX00ol00?ooooooooooo`0<ooooo`;o0?ZJ1Oooool01Ol00?oooooo
oooooooooooo003o00_ooooo00?o003oo`3jV_l0nYX02_ooool01_ooH@;ooooooomQ0_oooooo003o
ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`0;ooooo`03o`000?oooooooooo01cooooo00Go0000
oooooooooooooooooomQ0P02o`3jVPCooooo00?oof42o`00ooooool02_ooool00oooH@;ooooooooo
o`03ooooo`;o0?ZJ1_ooool01OooH@;oooooooooooooooooof4200Oooooo0_l0nYX00ooooooo003o
ooooo`0>ooooo`03o`00oooooooooooo00Wooooo0ol0nYX3ooooo`03o`00oooooooooooo00_ooooo
0ol0nYX9ooooo`03o`00oooooooooooo00Sooooo1?l0nYX3ooooo`03o`00oooooooooooo00_ooooo
0_l0nYX00ooooooo003oooooo`06ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooooooo00Wooooo0_l0nYX00ol00?ooooooooooo`02ooooo`05oomQ0_oooooooooooooooooo
H@801?ooool2o`3jVPKooooo00Go003oooooooooooooooooo`00o`0;ooooo`03o`00oooooooooooo
00;o0?ZJ1oooool01oooH@;oooooooooooooH@;oooooo`00ooooool00_l0nYX7ooooo`03o`00oooo
oooooooo00_ooooo00?o0000ooooooooool04?ooool002[ooooo00Ko0000oooooooooooooooooomQ
0_l0nYX3ooooo`;o003o00Goof42o`00oooooooooooooomQ0P0=ooooo`;o0?ZJ00?o003ooooooooo
ool01Oooool01?ooH@;oooooooooooooH@83ooooo`;o0?ZJ0_ooool01?l00?ooooooooooool00?l?
ooooo`03o`00oooooooooooo00Sooooo2Ol0nYXHooooo`03o`00oooooooooooo00[ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`0=ooooo`;o0?ZJ2?ooool4o`3jVP03o`00oooooooo
oooo00?ooooo00?o003oooooooooool02Oooool2o`3jVP03oomQ0_oooooooooo00cooooo0_l0nYX5
ooooo`05o`00ooooooooooooooooool00?l02oooool3o`3jVP[ooooo00Koof42ooooooooH@;ooooo
o`00ooooool2o`3jVPOooooo00?o003oooooooooool02oooool00ol0003oooooooooo`0Looooo`05
o`000?ooooooooooooooooooH@800_l0nYX2ooooo`;o003o00?oof42o`00ooooool02_ooool00ooo
H@;oooooooooo`03ooooo`;o0?ZJ1_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo
00Cooooo0ol0nYX00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00Sooooo0ol0nYX4oooo
o`03o`00oooooooooooo00cooooo0_l0nYX9ooooo`03o`00oooooooooooo00Oooooo1_l0nYX2oooo
o`03o`00oooooooooooo00[ooooo0ol0nYX2o`00o`Oooooo0_l0nYX3ooooo`03o`00oooooooooooo
00?ooooo00?o003oooooooooool02Oooool2o`3jVP05oomQ0_ooooooooooooooooooH@801?ooool0
0oooH@;oooooooooo`02ooooo`;o0?ZJ1_ooool01Ol00?oooooooooooooooooo003o00_ooooo00?o
003oooooooooool00_l0nYX7ooooo`07oomQ0_oooooooooooomQ0_oooooo003oooooo`02o`3jVPOo
oooo00?o003oooooooooool02oooool00ol0003oooooooooo`0@ooooo`00:_ooool2o`0000;ooooo
00Goof42o`3jV_l00?ooooooo`00o`02ooooo`05oomQ0_l00?ooooooooooooooH@803Oooool2o`3j
VP03o`00oooooooooooo00Gooooo00Coof42ooooooooooooof420oooool2o`3jVP;ooooo00Co003o
oooooooooooo003o3oooool00ol00?ooooooooooo`06ooooo`ko0?ZJ5Oooool00ol00?oooooooooo
o`0:ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool03?ooool3o`3jVP03o`00oooo
oooooooo00Oooooo1Ol0nYX3ooooo`03o`00oooooooooooo00Sooooo00Co003oo`3jV_l0nY[oof42
3_ooool2o`3jVPGooooo00Go003oooooooooooooooooo`00o`0:ooooo`?o0?ZJ2oooool01_ooH@;o
oooooomQ0_oooooo003oooooo`;o0?ZJ1oooool00ol00?ooooooooooo`0:ooooo`;o00007_ooool0
1Ol0003oooooooooooooooooof4200;o0?ZJ00Koooooo`00oooooooooooooomQ0_l00?l;ooooo`03
oomQ0_oooooooooo00?ooooo0_l0nYX6ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooooooo
ool01?ooool01?l00?oo0?ZJo`3jV_l00?l?ooooo`03o`00oooooooooooo00Sooooo0_l0nYX5oooo
o`03o`00oooooooooooo00cooooo0_l0nYX9ooooo`03o`00oooooooooooo00Kooooo0ol0nYX01?oo
oooo003oo`3jV_l0nYX2ooooo`03o`00oooooooooooo00[ooooo0_l0nYX01?l00?ooooooooooool0
0?l6ooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Sooooo00Co
003oo`3jV_l0nY[oof420oooool00oooH@;oooooooooo`03ooooo`04oomQ0_ooooooooooooooo`;o
0?ZJ1_ooool01Ol00?oooooooooooooooooo003o00_ooooo00?o003oooooool0nYX00_l0nYX7oooo
o`07oomQ0_oooooooooooomQ0_oooooo003oooooo`03o`3jVPKooooo00?o003oooooooooool02_oo
ool2o`0001;ooooo000Rooooo`;o00001_ooool01Ol0003oooooooooooooooooof4200;o0?ZJ00So
003ooooooooooooooooooomQ0_l00?oooooooomQ0Pkooooo0_l0nYX00ol00?ooooooooooo`05oooo
o`04oomQ0_oooooooooooomQ0P?ooooo0_l0nYX2ooooo`03o`00oooooooooooo00;o003o3Oooool0
0ol00?ooooooo`00o`06ooooo`Co0?ZJ1_ooool00ol00?oo0?ZJo`3jVP04o`3jVQCooooo00?o003o
ooooooooool02Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00cooooo0_l0nYX0
0ooooooo003oooooo`09ooooo`Go0?ZJ0_ooool00ol00?ooooooooooo`08ooooo`04o`00ool0nY[o
0?ZJoomQ0Pkooooo0_l0nYX5ooooo`05o`00ooooooooooooooooool00?l02?ooool5o`3jVP_ooooo
00Koof42ooooooooH@;oooooo`00ooooool2o`3jVPSooooo00?o003oooooooooool02_ooool00ol0
003oooooooooo`0Dooooo`;o00001_ooool01Ol0003oooooooooooooooooof4200;o0?ZJ00Ko003o
oooooooooooooooooomQ0_l00?l;ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX6ooooo`03oomQ
0_oooooooooo00;ooooo00?oof42ooooooooool01?ooool00ol00?oo0?ZJo`3jVP02o`00o`gooooo
00?o003oooooool00?l02?ooool3o`3jVPGooooo00?o003oooooooooool03?ooool2o`3jVP[ooooo
00?o003oooooooooool01?ooool3o`3jVP;ooooo00Ko003oo`3jV_l0nY[o0?ZJooooool00?l<oooo
o`;o0?ZJ00Co003ooooooooooooo003o1oooool2o`3jVP;ooooo00?o003oooooooooool00oooool0
0ol00?ooooooooooo`08ooooo`03o`00ool0nY[o0?ZJ00;oof420_ooool00oooH@;oooooooooo`03
ooooo`04oomQ0_ooooooooooooooo`?o0?ZJ1Oooool01Ol00?oooooooooooooooooo003o00_ooooo
00Co003oooooool0nY[o0?ZJ2?ooool01_ooH@;oooooooooooooH@;oooooo`00o`;ooooo0_l0nYX7
ooooo`04o`00ooooooooooooooooo`?o0?ZJ1_ooool00ol0003oooooooooo`0@ooooo`008Oooool0
1?l0003oooooooooool00005ooooo`05o`000?ooooooooooooooooooH@800_l0nYX5ooooo`;oof42
3oooool2o`3jVP03o`00oooooooooooo00Gooooo00Coof42ooooooooooooof420oooool3o`3jVP06
ooooool00?ooooooo`00oooooooo003o3Oooool00ol00?ooooooo`00o`05ooooo`?o0?ZJ2?ooool0
1?l00?ooooooooooooooool6o`3jVQ7ooooo00?o003oooooooooool02Oooool00ol00?oooooooooo
o`02o`3jVP03o`00oooooooooooo00cooooo0_l0nYX00ooooooo003oooooo`0:ooooo`03o`00oooo
oooo0?ZJ00;o0?ZJ00?oooooo`00ooooool02Oooool01?l00?oo0?ZJo`3jV_ooH@8>ooooo`?o0?ZJ
1?ooool01Ol00?oooooooooooooooooo003o00Sooooo0ol0nYX00ol00?ooooooooooo`0:ooooo`03
oomQ0_ooooooof4200;o003o00?oooooo`3jV_l0nYX02?ooool00ol00?ooooooooooo`0:ooooo`03
o`000?oooooooooo01?ooooo00Co0000oooooooooooo00001Oooool01Ol0003ooooooooooooooooo
of4200;o0?ZJ1Oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00;ooooo0ol0nYX6
ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01?ooool01Ol00?oo0?ZJo`3jV_oo
oooo003o00gooooo00?o003oooooool00?l01oooool3o`3jVPKooooo00?o003oooooooooool03?oo
ool2o`3jVP[ooooo00?o003oooooooooool01?ooool2o`3jVP?ooooo00?o003oooooool0nYX00_l0
nYX00ol00?ooooooooooo`09ooooo`?o0?ZJ0oooool00ol00?ooooooooooo`05ooooo`?o0?ZJ00?o
ooooo`00ooooool01?ooool00ol00?ooooooooooo`08ooooo`03o`00ool0nY[o0?ZJ00;oof420_oo
ool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX5ooooo`05o`00oooo
ooooooooooooool00?l02oooool01?l00?oo0?ZJo`3jV_l0nYX8ooooo`04oomQ0_oooooooooooomQ
0P;o003o0_ooool2o`3jVPOooooo00?o003oooooooooool01Ol0nYX5ooooo`03o`000?oooooooooo
013ooooo000Qooooo`04o`000?ooooooooooo`0000Gooooo00Go0000oooooooooooooooooomQ0P02
o`3jVPGooooo00?oof42o`00ooooool03_ooool2o`3jVP03o`00oooooooooooo00Gooooo00Coof42
ooooooooooooof421?ooool2o`3jVP06ooooool00?ooooooo`00oooooooo003o3Oooool00ol00?oo
ooooo`00o`04ooooo`?o0?ZJ2?ooool00ol00?ooooooooooo`04ooooo`Oo0?ZJ3_ooool00ol00?oo
ooooooooo`09ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00?o003oooooooooool01_ooool00ol00?oo
ooooooooo`02ooooo`?o0?ZJ00?oooooo`00ooooool02_ooool00ol00?ooooooooooo`05o`3jVPWo
oooo0ol0nYX00oooH@;oooooooooo`0<ooooo`03o`00ool0nY[o0?ZJ00Cooooo00Go003ooooooooo
ooooooooo`00o`07ooooo`?o0?ZJ00?oooooo`00ooooool02oooool00oooH@;ooooooomQ0P02o`00
o`04ooooool0nY[o0?ZJo`3jVPOooooo00?o003oooooooooool02_ooool00ol0003oooooooooo`0C
ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000oooooooooooooooooomQ0P02o`3jVPGooooo
00?oof42o`00ooooool02Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?o003oooooooooool0
1?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Cooooo00Go003oo`3jV_l0nY[o
ooooo`00o`0=ooooo`03o`00oooooooo003o00Kooooo0ol0nYX6ooooo`03o`00oooooooooooo00go
oooo0ol0nYX9ooooo`03o`00oooooooooooo00?ooooo0ol0nYX3ooooo`03o`00oooooooooooo00;o
0?ZJ00?o003oooooooooool01_ooool00ol00?ooooooooooo`02o`3jVP05o`00oooooooooooooooo
ool00?l02?ooool2o`3jVP03ooooool00?oooooo00Gooooo00?o003oooooooooool01oooool02?l0
0?oo0?ZJo`3jV_ooH@;ooooooomQ0_ooooooof421Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ
1Oooool01Ol00?oooooooooooooooooo003o00_ooooo00?o003oo`3jV_l0nYX02Oooool01_ooH@;o
ooooooooooooooooof42o`00o`;ooooo0_l0nYX7ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00Cooooo
o`3jV_l0nY[o0?ZJ1?ooool00ol0003oooooooooo`0@ooooo`008Oooool01?l0003oooooooooool0
0005ooooo`;o00000_ooool00oooH@;o0?ZJo`3jVP06ooooo`03o`00oooooooooooo00cooooo0ol0
nYX00ol00?ooooooooooo`05ooooo`04oomQ0_oooooooooooomQ0PCooooo0_l0nYX01_oooooo003o
ooooool00?ooooooo`00o`gooooo00?o003oooooool00?l01?ooool2o`3jVPWooooo00?o003ooooo
ooooool01oooool9o`3jVPWooooo00?o003oooooooooool01_ooool01?l00?ooooooooooool00?l5
o`3jVPSooooo00?o003oooooooooool00_ooool2o`3jVP?ooooo00?o003oooooooooool02?ooool0
1?l00?ooooooooooooooool6o`3jVPOooooo0_l0nYX00oooooooof42oomQ0P0=ooooo`03o`00ool0
nY[o0?ZJ00Cooooo00Go003oooooooooooooooooo`00o`06ooooo`?o0?ZJ00?oooooo`00ooooool0
3?ooool00oooH@;ooooooomQ0P02o`00o`;ooooo0_l0nYX7ooooo`03o`00oooooooooooo00Sooooo
0ol0000Eooooo`04o`000?ooooooooooo`0000Gooooo0_l00002ooooo`03oomQ0_l0nY[o0?ZJ00Go
oooo00?oof42o`00ooooool02Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?o003ooooooooo
ool01?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Cooooo00Go003oo`3jV_l0
nY[oooooo`00o`0=ooooo`03o`00oooooooo003o00Gooooo0ol0nYX7ooooo`03o`00oooooooooooo
00kooooo0_l0nYX9ooooo`03o`00oooooooooooo00?ooooo0_l0nYX01Ol00?oooooooooooooooooo
003o00;ooooo0ol0nYX8ooooo`03o`00oooooooooooo00;o0?ZJ00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`05ooooo`?o0?ZJ00?o003oooooooooool01?ooool00ol00?ooooooooooo`07
ooooo`05o`00ool0nY[o0?ZJoomQ0_ooool00_ooH@87ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ
1Oooool01Ol00?oooooooooooooooooo003o00[ooooo00Co003oooooool0nY[o0?ZJ2Oooool01_oo
H@;oooooooooooooooooof42o`00o`;ooooo0_l0nYX7ooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo
0_l0nYX2ooooo`?o00004_ooool0027ooooo00Co0000oooooooooooo00001Oooool01Ol0003ooooo
ooooooooooooof4200;o0?ZJ1_ooool00ol00?ooooooooooo`0<ooooo`;o0?ZJ00?oooooo`00oooo
ool01_ooool01?ooH@;oooooooooooooH@84ooooo`;o0?ZJ00Koooooo`00oooooooo003oooooool0
0?l=ooooo`03o`00oooooooo003o00?ooooo0ol0nYX9ooooo`03o`00oooooooooooo00[ooooo1ol0
nYX8ooooo`03o`00oooooooooooo00Kooooo00?o003oooooool00?l00ol0nYX01?oooooo0?ZJo`3j
V_l0nYX7ooooo`04o`00ooooooooooooooooo`?o0?ZJ0oooool00ol00?ooooooooooo`08ooooo`03
o`00oooooooooooo00Cooooo3?l0nYX00oooooooof42oomQ0P0=ooooo`03o`00ool0nY[o0?ZJ00Co
oooo00Go003oooooooooooooooooo`00o`06ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`0;oooo
o`03oomQ0_ooooooof4200;o003o0_ooool2o`3jVPOooooo00?o003oooooooooool02_ooool00ol0
003oooooooooo`0Cooooo`04o`000?ooooooooooo`0000Gooooo00Go0000oooooooooooooooooomQ
0P02o`3jVPGooooo00?oof42o`00ooooool02Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?o
003oooooooooool01?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Cooooo00Go
003oo`3jV_l0nY[oooooo`00o`0=ooooo`03o`00oooooooo003o00Cooooo0ol0nYX8ooooo`03o`00
oooooooooooo00kooooo0_l0nYX9ooooo`03o`00oooooooooooo00?ooooo0_l0nYX01?l00?oooooo
ooooool00?l4ooooo`?o0?ZJ1oooool00ol00?ooooooooooo`02o`3jVP03o`00oooooooooooo00;o
oooo00?o003oooooooooool01_ooool2o`3jVP03o`00oooooooooooo00Cooooo00?o003ooooooooo
ool01oooool01Ol00?oo0?ZJo`3jV_ooH@;ooooo00;oof421oooool01?ooH@;oooooooooooooool2
o`3jVPGooooo00Go003oooooooooooooooooo`00o`0:ooooo`04o`00ool0nY[o0?ZJo`3jVPWooooo
00Koof42oooooooooooooooooomQ0_l00?l2ooooo`?o0?ZJ1_ooool00ol00?oo0?ZJo`3jVP04oooo
o`;o0?ZJ1?ooool00ol0003oooooooooo`0@ooooo`008Oooool01?l0003oooooooooool00005oooo
o`05o`000?ooooooooooooooooooH@800_l0nYX6ooooo`03o`00oooooooooooo00cooooo0_l0nYX0
0ooooooo003oooooo`06ooooo`04oomQ0_oooooooooooomQ0PCooooo0ol0nYX01Ol00?ooooooo`00
oooooooo003o00Wooooo00Co003ooooooooooooo003o0oooool00ol00?ooooooooooo`02o`3jVP[o
oooo00?o003oooooooooool03oooool2o`3jVPSooooo00?o003oooooooooool01_ooool2o`00o`?o
0?ZJ0oooool2o`3jVPOooooo00Co003ooooooooooooooooo0_l0nYX4ooooo`03o`00oooooooooooo
00Oooooo00?o003oooooooooool01Oooool00ol00?ooooooo`3jVP09o`3jVP03ooooooooH@;oof42
00gooooo00?o003oo`3jV_l0nYX01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00;ooooo0ol0nYX2ooooo`03o`00oooooooooooo00_ooooo00Coof42ooooooooH@;o003o0oooool2
o`3jVPOooooo00?o003oooooooooool02_ooool00ol0003oooooooooo`0Cooooo`04o`000?oooooo
ooooo`0000Gooooo00Go0000oooooooooooooooooomQ0P02o`3jVPKooooo00?oof42ooooooooool0
2?ooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?o003oooooooooool01?ooool00oooH@;ooooo
ooooo`02ooooo`03oomQ0_oooooooooo00Cooooo00Go003oo`3jV_l0nY[oooooo`00o`09ooooo`04
o`00ooooooooooooo`00o`?ooooo00Co003ooooooooooooooooo0_l0nYX9ooooo`03o`00oooooooo
oooo00kooooo0_l0nYX9ooooo`03o`00oooooooooooo00;ooooo0ol0nYX2o`00o`03ooooool00?oo
oooo00Cooooo0_l0nYX7ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`06ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`07ooooo`04o`00ool0nY[o
0?ZJoomQ0P;ooooo00?oof42ooooooooool01Oooool01?ooH@;oooooooooooooool2o`3jVPGooooo
00Go003oooooooooooooooooo`00o`0:ooooo`03o`00ool0nY[o0?ZJ00[ooooo00Goof42oooooooo
oooooooooomQ0P04ooooo`;o0?ZJ1_ooool3o`3jVPCooooo0ol0nYX3ooooo`03o`000?oooooooooo
013ooooo000Rooooo`;o00001_ooool01Ol0003oooooooooooooooooof4200;o0?ZJ1_ooool00ol0
0?ooooooooooo`0<ooooo`;o0?ZJ00?oooooo`00ooooool01_ooool01OooH@;ooooooooooooooooo
of4200Cooooo0_l0nYX01Ol00?ooooooo`00oooooooo003o00Wooooo00Co003ooooooooooooo003o
0oooool00ol00?ooooooo`3jVP02o`3jVP[ooooo00?o003oooooooooool03oooool2o`3jVPWooooo
00?o003oooooooooool01Oooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`?o0?ZJ1_ooool2o`00o`04
ooooool0nY[o0?ZJo`3jVPCooooo00?o003oooooooooool01oooool00ol00?ooooooooooo`05oooo
o`03o`00oooooooooooo00Oooooo00?o003oooooooooool00_ooH@8=ooooo`03o`00ool0nY[o0?ZJ
00Cooooo00?o003oooooooooool00_ooool01?l00?ooooooooooooooool3o`3jVP?ooooo00?o003o
ooooooooool02oooool01?ooH@;ooooooomQ0_l00?l3ooooo`;o0?ZJ1oooool00ol00?oooooooooo
o`0:ooooo`03o`000?oooooooooo01Cooooo0_l00006ooooo`05o`000?ooooooooooooooooooH@80
0ol0nYX5ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool00oooool2o`3jVP03o`00
oooooooooooo00Cooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`04ooooo`05o`00
ool0nY[o0?ZJooooool00?l02Oooool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooooooo
00?o0?ZJ2Oooool00ol00?ooooooooooo`0>ooooo`;o0?ZJ2_ooool01?l00?ooooooooooooooool2
o`3jVP05ooooool00?oo003oooooool00?l01Oooool3o`3jVPKooooo00Ko003oo`3jV_l0nY[o0?ZJ
ooooool00?l4ooooo`03o`00oooooooooooo00Kooooo0ol0nYX6ooooo`03o`00oooooooooooo00Oo
oooo00Co003oo`3jV_l0nY[oof422_ooool01?ooH@;oooooooooooooool2o`3jVPGooooo00Go003o
ooooooooooooooooo`00o`0:ooooo`03o`00ool0nY[o0?ZJ00[ooooo00Goof42oooooooooooooooo
oomQ0P04ooooo`?o0?ZJ1Oooool2o`3jVPKooooo0_l0nYX3ooooo`03o`000?oooooooooo013ooooo
000Zooooo`;o00000_ooool00oooH@;o0?ZJo`3jVP06ooooo`03o`00oooooooooooo00cooooo0_l0
nYX00ooooooo003oooooo`06ooooo`05oomQ0_ooooooooooooooooooH@801?ooool2o`3jVP03o`00
oooooooo003o00;ooooo00?o003oooooooooool01_ooool2o`00o`03ooooool00?oooooo00;ooooo
00Co003oooooool0nY[o0?ZJ2oooool00ol00?ooooooooooo`0?ooooo`;o0?ZJ2Oooool00ol00?oo
ooooooooo`05ooooo`03o`00ool0nY[o0?ZJ00Kooooo0ol0nYX5ooooo`;o003o00Coooooo`3jV_l0
nY[o003o1?ooool00ol00?ooooooooooo`07ooooo`03o`00oooooooooooo00Gooooo00?o003ooooo
ooooool01oooool00ol00?ooooooooooo`02oomQ0Pgooooo00?o003oo`3jV_l0nYX01?ooool00ol0
0?ooooooooooo`02ooooo`04o`00ooooooooooooooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`0;
ooooo`04oomQ0_ooooooof42o`00o`?ooooo0_l0nYX7ooooo`03o`00oooooooooooo00Wooooo0_l0
000Nooooo`06o`000?ooooooooooooooooooH@;ooooo0_l0nYX5ooooo`03o`00ooooH@;ooooo00Oo
oooo00?oof42ooooooooool00oooool2o`3jVP03o`00oooooooooooo00Cooooo00?oof42oooooooo
ool00oooool00oooH@;oooooooooo`03ooooo`06o`00ool0nY[o0?ZJo`3jV_oooooo003o2?ooool2
o`00o`03ooooool00?oooooo00;ooooo00?o003oooooooooool00_l0nYX:ooooo`03o`00oooooooo
oooo00kooooo0ol0nYX9ooooo`03o`00oooooooooooo00?o0?ZJ00?oooooo`00ooooool00_l00?l6
ooooo`?o0?ZJ1Oooool4o`3jVP03o`00oooooooooooo00?ooooo00?o003oooooooooool01oooool2
o`3jVPKooooo00?o003oooooooooool01oooool3o`3jVP03oomQ0_oooooooooo00Sooooo00Coof42
oooooooooooooooo0_l0nYX5ooooo`05o`00ooooooooooooooooool00?l02_ooool3o`3jVP[ooooo
00Goof42oooooooooooooooooomQ0P05ooooo`;o0?ZJ0oooool4o`3jVPKooooo0_l0nYX2ooooo`;o
00004_ooool002[ooooo00Go0000oooooooooooooooooomQ0P02o`3jVPKooooo00?o003ooooooooo
ool03?ooool2o`3jVP03ooooool00?oooooo00Kooooo00Goof42oooooooooooooooooomQ0P04oooo
o`?o0?ZJ0_l00?l2ooooo`03o`00oooooooooooo00Kooooo0_l00?l00ooooooo003oooooo`02oooo
o`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o003oooooooooool03oooool3o`3jVPSooooo00?o003o
ooooooooool01Oooool3o`3jVPKooooo00?o003oo`3jV_l0nYX00ol0nYX00ooooooo003oooooo`04
o`3jVP03o`00oooooooooooo00?ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`05
ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool00_ooH@8=ooooo`04o`00ool0nY[o
0?ZJo`3jVP?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`03o`3jVPCooooo00?o
003oooooooooool02oooool01?ooH@;ooooooomQ0_l00?l3ooooo`;o0?ZJ1oooool00ol00?oooooo
ooooo`0:ooooo`03o`000?oooooooooo01cooooo00Ko0000oooooooooooooooooomQ0_ooool2o`3j
VPGooooo00?o003ooomQ0_ooool01oooool00oooH@;oooooooooo`02ooooo`?o0?ZJ00?o003ooooo
ooooool01?ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Cooooo00Go003oo`3j
V_l0nY[oooooo`00o`08ooooo`;o003o00?oooooo`00ooooool00_ooool00ol00?ooooooooooo`02
o`3jVP[ooooo00?o003oooooooooool03oooool2o`3jVPWooooo00?o003oooooooooool00_l0nYX2
ooooo`04o`00oooooooo003oo`00o`Kooooo00?o003oo`3jV_l0nYX01ol0nYX2ooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool01_ooool2o`3jVPKooooo00?o003oooooooooool01ooo
ool2o`3jVP03ooooooooH@;ooooo00Wooooo00Coof42oooooooooooooooo0ol0nYX4ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool01_ooool3o`3jVP_ooooo00Goof42oooooooooooo
oooooomQ0P05ooooo`;o0?ZJ0_ooool4o`3jVPOooooo0ol0nYX2ooooo`03o`000?oooooooooo013o
oooo000Zooooo`05o`000?ooooooooooooooooooH@800_l0nYX6ooooo`03o`00oooooooooooo00co
oooo0_l0nYX00ooooooo003oooooo`06ooooo`05oomQ0_ooooooooooooooooooH@801Oooool2o`3j
VP05o`00ooooooooooooooooool00?l02?ooool2o`00o`03ooooool00?oooooo00?ooooo0_l0nYX2
ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool04?ooool2o`3jVPSooooo00?o003o
ooooooooool01?ooool3o`3jVP03o`00oooooooooooo00Cooooo00?o003oooooool0nYX02Ol0nYX0
0ooooooo003oooooo`04ooooo`?o003o1_ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooo
oooo00Oooooo00?o003oooooooooool00_ooH@8>ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`02o`3jVPGooooo00?o003oooooooooool02oooool0
0oooH@;ooooooomQ0P04ooooo`?o0?ZJ1oooool00ol00?ooooooooooo`05ooooo`;o0?ZJ0_ooool0
0ol0003oooooooooo`0Looooo`06o`000?ooooooooooooooooooH@;ooooo0_l0nYX5ooooo`03o`00
ooooH@;ooooo00Oooooo00?oof42ooooooooool00_ooool2o`3jVP03ooooool00?oooooo00Gooooo
00?oof42ooooooooool00oooool00oooH@;oooooooooo`04ooooo`05o`00ool0nY[o0?ZJooooool0
0?l02?ooool2o`00o`03ooooool00?oooooo00?ooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`09oooo
o`03o`00oooooooooooo00oooooo0_l0nYX9ooooo`03o`00oooooooo0?ZJ00;o0?ZJ0_ooool01?l0
0?ooooooooooool00?l6ooooo`03o`00oooooooo0?ZJ00Ko0?ZJ00Co003ooooooooooooo003o1_oo
ool3o`00o`Kooooo0ol0nYX5ooooo`03o`00oooooooooooo00Oooooo0_l0nYX00oooooooof42oooo
o`09ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX4ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool01_ooool2o`3jVPcooooo00Goof42oooooooooooooooooomQ0P05ooooo`Ko0?ZJ
00?oooooo`00ooooool01oooool2o`3jVP;ooooo00?o0000ooooooooool04?ooool002[ooooo00Go
0000oooooooooooooooooomQ0P02o`3jVPKooooo00?o003oooooooooool03?ooool2o`3jVP03oooo
ool00?oooooo00Kooooo00Goof42oooooooooooooooooomQ0P05ooooo`;o0?ZJ00Go003ooooooooo
ooooooooo`00o`07ooooo`04o`00ooooooooooooo`00o`Cooooo0ol0nYX2ooooo`03o`00oooooooo
oooo00Kooooo00?o003oooooooooool04Oooool2o`3jVPSooooo00?o003oooooooooool01?ooool2
o`3jVPSooooo00?o003oooooooooool00_ooool5o`3jVP?ooooo00?o003oooooooooool01Oooool0
0ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool01oooool0
1_l00?ooooooooooooooH@;ooooooomQ0Pgooooo00?o003oo`3jV_l0nYX00oooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo00;o0?ZJ1Oooool00ol00?ooooooooooo`0:ooooo`04oomQ
0_oooooooooooomQ0PGooooo0_l0nYX7ooooo`03o`00oooooooooooo00Gooooo0_l0nYX2ooooo`03
o`000?oooooooooo01cooooo00Ko0000oooooooooooooooooomQ0_ooool2o`3jVPGooooo00?o003o
ooooooooH@801oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool0
0oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Cooooo00Go003oo`3jV_l0nY[oooooo`00
o`07ooooo`04o`00ooooooooooooo`00o`Kooooo0_l0nYX00ooooooo003oooooo`07ooooo`03o`00
oooooooooooo013ooooo0ol0nYX8ooooo`04o`00oooooooo0?ZJo`3jVP?ooooo00?o003ooooooooo
ool01oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ00?o003oooooool00?l00_ooool00ol00?oo
ooooooooo`06ooooo`03o`00oooooooooooo00Cooooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo
ooooooooo`07ooooo`;o0?ZJ00?ooooooomQ0_ooool02Oooool00oooH@;oooooooooo`02ooooo`;o
0?ZJ1?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Gooooo0ol0nYX;ooooo`03
oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01?ooool4o`3jVP;ooooo00?o003ooooooooo
ool01_ooool2o`3jVP;ooooo00?o0000ooooooooool04?ooool002[ooooo0_l00002ooooo`03oomQ
0_l0nY[o0?ZJ00Kooooo00?o003oooooooooool03?ooool2o`3jVP03ooooool00?oooooo00Kooooo
00Goof42oooooooooooooooooomQ0P05ooooo`Go0?ZJ00?oooooo`00ooooool01_ooool01?l00?oo
ooooooooool00?l4ooooo`;o0?ZJ00Go003oooooool00?ooooooo`00o`07ooooo`03o`00oooooooo
oooo017ooooo0_l0nYX9ooooo`03o`00oooooooooooo00;ooooo0ol0nYX8ooooo`03o`00oooooooo
oooo00Cooooo00?o003oooooool00?l00oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooo
oooo00Cooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`07ooooo`06o`00oooooooo
oooooomQ0_ooooooof423Oooool00ol00?oo0?ZJo`3jVP03ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooool0nYX00_l0nYX5ooooo`03o`00oooooooooooo00[ooooo00Coof42oooooooooooo
of421Oooool2o`3jVPOooooo00?o003oooooooooool01?ooool3o`3jVP03ooooool0003o000001ko
oooo00?o0000ooooooooool00_ooool00oooH@;o0?ZJo`3jVP05ooooo`03o`00ooooooooof4200Oo
oooo00?oof42ooooooooool00_ooool2o`3jVP03ooooool00?oooooo00Cooooo00?oof42oooooooo
ool01?ooool00oooH@;oooooooooo`04ooooo`05o`00ool0nY[o0?ZJooooool00?l01oooool01?l0
0?ooooooooooool00?l5ooooo`?o0?ZJ00?o003oooooool00?l01oooool00ol00?ooooooooooo`0A
ooooo`;o0?ZJ2Oooool3o`3jVP?ooooo00?o003oooooooooool01oooool00ol00?ooooooooooo`04
ooooo`03o`00oooooooo003o00;ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`04
ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oooooooooool01oooool2o`3jVP03ooooooooH@;o
oooo00[ooooo00Coof42oooooooooooooooo0_l0nYX4ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool01Oooool2o`3jVP03o`00oooooooooooo00Wooooo00?oof42ooooooooool00_oo
ool00oooH@;oooooooooo`0:ooooo`03o`00oooooooooooo00Wooooo0_l0000Booooo`00:_ooool0
1Ol0003oooooooooooooooooof4200;o0?ZJ1_ooool00ol00?ooooooooooo`0;ooooo`?o0?ZJ00?o
ooooo`00ooooool01_ooool01OooH@;oooooooooooooooooof4200Kooooo1?l0nYX00ooooooo003o
ooooo`06ooooo`03o`00oooooooooooo00Cooooo0ol0nYX01Ooooooo003ooooooooooooo003o00Oo
oooo00?o003oooooooooool04Oooool2o`3jVPWooooo00Co003ooooooooooooooooo0ol0nYX9oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooool00?l00_ooool00ol00?ooooooooooo`06oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`06oooo
o`07o`00ooooooooooooooooooooH@;ooooooomQ0P0=ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o
003oooooooooool00_ooool01?l00?ooooooo`3jV_l0nYX6ooooo`03o`00oooooooooooo00[ooooo
00Coof42ooooooooooooof421Oooool3o`3jVPKooooo00?o003oooooooooool01?ooool2o`3jVP?o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`02ooooo`03oomQ0_l0nY[o0?ZJ00Go
oooo00?o003oooooooooH@801_ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?oooooo`00oooo
ool01?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00?ooooo00Go003oo`3jV_l0
nY[oooooo`00o`07ooooo`03o`00oooooooooooo00Gooooo0ol0nYX01?l00?ooooooooooool00?l7
ooooo`03o`00oooooooooooo017ooooo0_l0nYX9ooooo`;o0?ZJ0oooool00ol00?ooooooooooo`08
ooooo`03o`00oooooooooooo00Cooooo00?o003oooooool00?l00_ooool00ol00?ooooooooooo`06
ooooo`03o`00oooooooooooo00Cooooo00?o003oo`3jV_l0nYX01Oooool00ol00?ooooooooooo`06
ooooo`05o`00ool0nY[o0?ZJooooooooH@802oooool01?ooH@;oooooooooooooool2o`3jVPCooooo
00?o003oooooooooool00_ooool00ol00?ooooooooooo`04ooooo`?o0?ZJ00?o003oooooooooool0
2Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00_ooooo00?o003oooooooooool0
2Oooool00ol0003oooooooooo`0@ooooo`00:_ooool01Ol0003oooooooooooooooooof4200;o0?ZJ
1_ooool00ol00?ooooooooooo`0;ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`05ooooo`05oomQ
0_ooooooooooooooooooH@801_ooool4o`3jVP03ooooool00?oooooo00Kooooo00?o003ooooooooo
ool01?ooool2o`3jVPGooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0Aooooo`?o
0?ZJ2?ooool00ol00?ooooooooooo`03o`3jVP03o`00oooooooooooo00Oooooo00?o003ooooooooo
ool01?ooool01_l00?ooooooooooool00?ooooooo`00o`Sooooo00?o003oooooooooool01?ooool0
0ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Kooooo00Oo003ooooooooooooooooooomQ
0_ooooooof4200gooooo00Co003oo`3jV_l0nY[o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`04
o`00oooooooo0?ZJo`3jVPKooooo00?o003oooooooooool02_ooool01?ooH@;oooooooooooooH@86
ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`03ooooo`?o0?ZJ0oooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00;ooooo00?oof42o`3jV_l0nYX01Oooool01?l00?oooooooooooooo
H@85ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX00ooooooo003oooooo`04ooooo`03oomQ0_oo
oooooooo00Gooooo00?oof42ooooooooool01?ooool2o`3jVP03ooooool00?oooooo00Kooooo00?o
003oooooooooool01Oooool2o`3jVPCooooo00?o003oooooooooool01Oooool00ol00?oooooooooo
o`0Aooooo`;o0?ZJ2?ooool3o`3jVP?ooooo00?o003oooooooooool02?ooool00ol00?oooooooooo
o`04ooooo`06o`00ooooooooooooo`00oooooooo003o2?ooool00ol00?ooooooooooo`04ooooo`04
o`00ool0nY[o0?ZJo`3jVPCooooo00?o003oooooooooool01_ooool01?l00?oo0?ZJo`3jV_ooH@8<
ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00Cooooo0_l0nYX00ooooooo003oooooo`0:ooooo`03oomQ0_oooooooooo00?ooooo00?o
of42ooooooooool02_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo013ooooo000Z
ooooo`05o`000?ooooooooooooooooooH@800_l0nYX6ooooo`03o`00oooooooooooo00_ooooo0_l0
nYX2ooooo`03o`00oooooooooooo00Gooooo00Goof42oooooooooooooooooomQ0P08ooooo`?o0?ZJ
00?oooooo`00ooooool00_l00?l3ooooo`03o`00oooooooooooo00?ooooo0ol0nYX6ooooo`03o`00
oooooooooooo00Cooooo00?o003oooooooooool04_ooool2o`3jVPSooooo00?o003oooooooooool0
0_l0nYX00ooooooo003oooooo`09ooooo`03o`00oooooooooooo00?ooooo00Ko003ooooooooooooo
003oooooool00?l8ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01Oooool00ol0
0?ooooooooooo`06ooooo`04o`00oooooooooooooomQ0P;ooooo00?oof42ooooooooool02oooool0
1?l00?ooooooo`3jV_l0nYX2ooooo`03o`00oooooooooooo00;ooooo00Co003oo`3jV_l0nY[o0?ZJ
1_ooool00ol00?ooooooooooo`0:ooooo`05oomQ0_ooooooooooooooooooH@801Oooool2o`3jVPKo
oooo00?o003oooooooooool00oooool2o`3jVP05ooooool00?ooooooooooool000007_ooool00ol0
003oooooooooo`02ooooo`03oomQ0_l0nY[o0?ZJ00Gooooo00Co003oooooooooooooof421Oooool0
0oooH@;oooooooooo`03ooooo`;o0?ZJ00?oooooo`00ooooool01?ooool00oooH@;oooooooooo`05
ooooo`03oomQ0_oooooooooo00Cooooo0ol0nYX01?oooooo003oooooool00?l4ooooo`03o`00oooo
oooooooo00Cooooo0ol0nYX5ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool04Ooo
ool3o`3jVPOooooo0_l0nYX4ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool00ooo
ool01_l00?ooooooooooool00?ooooooo`00o`Sooooo00?o003oooooooooool01?ooool01?l00?oo
ooooo`3jV_l0nYX4ooooo`03o`00oooooooooooo00Kooooo00Co003oo`3jV_l0nY[oof423?ooool0
1?ooH@;oooooooooooooool2o`3jVPCooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`04ooooo`;o0?ZJ00?oooooo`00ooooool02_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oo
oooooooo00[ooooo00?o003oooooooooool01_ooool01?l00?ooooooooooool0000Booooo`00:_oo
ool2o`0000;ooooo00?oof42o`3jV_l0nYX01oooool00ol00?ooooooooooo`0:ooooo`;o0?ZJ0_oo
ool00ol00?ooooooooooo`05ooooo`05oomQ0_ooooooooooooooooooH@802Oooool2o`3jVP05oooo
ool00?oo003oooooool00?l00oooool00ol00?ooooooooooo`03ooooo`;o0?ZJ1oooool00ol00?oo
ooooooooo`04ooooo`03o`00oooooooooooo01;ooooo0_l0nYX8ooooo`03o`00oooooooo0?ZJ00;o
0?ZJ00?oooooo`00ooooool02Oooool00ol00?ooooooooooo`03ooooo`06o`00ooooooooooooo`00
oooooooo003o2Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Gooooo00?o003o
ooooooooool01_ooool01?l00?ooooooooooooooH@82ooooo`03oomQ0_oooooooooo00_ooooo00Co
003oooooool0nY[o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03o`00ool0nY[o0?ZJ00Oooooo
00?o003oooooooooool02_ooool01OooH@;oooooooooooooooooof4200Gooooo0_l0nYX6ooooo`03
o`00oooooooooooo00;ooooo0ol0nYX00ooooooo003oooooo`02o`0001kooooo00?o0000oooooooo
ool00_ooool00oooH@;o0?ZJo`3jVP06ooooo`03o`00ooooooooof4200Cooooo00?oof42oooooooo
ool01?ooool2o`3jVP03ooooool00?oooooo00Cooooo00?oof42ooooooooool01Oooool00oooH@;o
ooooooooo`05ooooo`;o0?ZJ00Coooooo`00ool00?oo003o1?ooool00ol00?ooooooooooo`04oooo
o`;o0?ZJ1_ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo01;ooooo0_l0nYX7oooo
o`;o0?ZJ1?ooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo00?ooooo00Ko003ooooo
oooooooo003oooooool00?l9ooooo`03o`00oooooooooooo00?ooooo00Co003oooooool0nY[o0?ZJ
1?ooool00ol00?ooooooooooo`06ooooo`?o0?ZJ00?oof42ooooooooool02_ooool01?ooH@;ooooo
ooooooooool3o`3jVP?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`03ooooo`?o
0?ZJ00?oooooo`00ooooool02_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00[o
oooo00?o003oooooooooool01_ooool01?l00?ooooooo`000?l0000Booooo`00:_ooool01Ol0003o
ooooooooooooooooof4200;o0?ZJ1oooool00ol00?ooooooooooo`0:ooooo`;o0?ZJ0_ooool00ol0
0?ooooooooooo`05ooooo`05oomQ0_ooooooooooooooooooH@802Oooool2o`3jVP05ooooool00?oo
ooooooooool00?l00oooool00ol00?ooooooooooo`03ooooo`;o0?ZJ1oooool00ol00?oooooooooo
o`04ooooo`03o`00oooooooooooo01;ooooo0_l0nYX9ooooo`?o0?ZJ0_ooool00ol00?oooooooooo
o`08ooooo`03o`00oooooooooooo00?ooooo00Ko003ooooooooooooo003oooooool00?l9ooooo`03
o`00oooooooooooo00?ooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`06ooooo`04
o`00oooooooooooooomQ0P;ooooo00?oof42ooooooooool02oooool00ol00?ooooooo`3jVP02o`3j
VP03ooooool00?oooooo00Cooooo0_l0nYX6ooooo`03o`00oooooooooooo00_ooooo00Goof42oooo
oooooooooooooomQ0P05ooooo`?o0?ZJ1Oooool01?l00?ooooooooooooooool3o`3jVP;ooooo00Co
003ooooooooooooo00007_ooool00ol0003oooooooooo`02ooooo`03oomQ0_l0nY[o0?ZJ00Kooooo
00Co003oooooooooooooof420oooool00oooH@;oooooooooo`04ooooo`;o0?ZJ00?oooooo`00oooo
ool00oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX01?oooooo
003oooooool00?l4ooooo`03o`00oooooooooooo00?ooooo0ol0nYX6ooooo`03o`00oooooooooooo
00Cooooo00?o003oooooooooool04_ooool2o`3jVPKooooo0ol0nYX01Ol00?oooooooooooooooooo
003o00_ooooo00?o003oooooooooool00oooool01_l00?ooooooooooool00?ooooooo`00o`Wooooo
00?o003oooooooooool00oooool00ol00?ooooooo`3jVP02o`3jVP?ooooo00?o003oooooooooool0
1_ooool2o`3jVP03ooooooooH@;ooooo00_ooooo00Goof42ooooooooooooooooo`00o`02o`3jVP?o
oooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`03ooooo`;o0?ZJ00?oooooo`00oooo
ool02oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00[ooooo00?o003ooooooooo
ool01_ooool01?l00?ooooooooooool0000Booooo`00:_ooool01Ol0003oooooooooooooooooof42
00?o0?ZJ1_ooool00ol00?ooooooooooo`09ooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`05oooo
o`05oomQ0_ooooooooooooooooooH@802Oooool2o`3jVPCooooo00Go003oooooooooooooooooo`00
o`04ooooo`?o0?ZJ2?ooool3o`00o`?ooooo00?o003oooooooooool04_ooool3o`3jVPOooooo0ol0
nYX3ooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool00oooool01_l00?oooooooooo
ool00?ooooooo`00o`Wooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`05ooooo`03
o`00oooooooooooo00Kooooo00Co003oooooooooooooof420oooool00oooH@;oooooooooo`0:oooo
o`03o`00oooooooooooo00;o0?ZJ00?oooooo`00ooooool00oooool3o`3jVPKooooo00?o003ooooo
ooooool02oooool01OooH@;oooooooooooooooooof4200Kooooo0_l0nYX5ooooo`04o`00oooooooo
ooooooooo`;o0?ZJ0oooool01?l00?ooooooooooool0000Nooooo`03o`000?oooooooooo00;ooooo
00Coof42o`3jV_l0nY[o0?ZJ1Oooool00ol00?ooooooooooo`03oomQ0P03ooooooooH@;ooooo00Co
oooo0ol0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooooooo
ool01?ooool2o`3jVP?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`03ooooo`;o
0?ZJ2?ooool2o`00o`Cooooo00?o003oooooooooool04_ooool3o`3jVPGooooo0_l0nYX00ooooooo
003oooooo`02ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool00oooool01_l00?oo
ooooooooool00?ooooooo`00o`Wooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`02
o`3jVP?ooooo00?o003oooooooooool01_ooool2o`3jVP03ooooooooH@;ooooo00_ooooo00Goof42
ooooooooooooooooo`00o`02o`3jVP?ooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`02ooooo`?o0?ZJ00?oooooo`00ooooool02oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oo
oooooooo00[ooooo00?o003oooooooooool01_ooool01?l00?ooooooooooool0000Booooo`00:_oo
ool01_l0003oooooooooooooooooof42ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`09ooooo`;o
0?ZJ0oooool00ol00?ooooooooooo`05ooooo`05oomQ0_ooooooooooooooooooH@802Oooool2o`3j
VPCooooo00Co003ooooooooooooo003o1Oooool2o`3jVPcooooo00Co003ooooooooooooo003o5Ooo
ool3o`3jVPKooooo0_l0nYX4ooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool00_oo
ool01ol00?oooooooooooooooooo003oooooool00?l02Oooool00ol00?ooooooooooo`03ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooooooool01_ooool01?l00?ooooooooooooooH@83oooo
o`03oomQ0_oooooooooo00[ooooo00?o003oooooooooool00_l0nYX00ooooooo003oooooo`03oooo
o`;o0?ZJ1oooool00ol00?ooooooooooo`0;ooooo`05oomQ0_ooooooooooooooooooH@801_ooool2
o`3jVPGooooo00?o003oooooooooool00ol0nYX2ooooo`05o`00ooooooooooooooooool000007_oo
ool00ol0003oooooooooo`02ooooo`04oomQ0_oooooo0?ZJo`3jVPGooooo00?o003oooooooooool0
0oooool00oooH@;oooooooooo`04ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03oomQ
0_oooooooooo00Oooooo00?oof42ooooooooool01?ooool2o`3jVPCooooo00Co003ooooooooooooo
003o1_ooool2o`3jVP[ooooo00Go003oooooooooooooooooo`00o`0Eooooo`?o0?ZJ0oooool3o`3j
VP03ooooool00?oooooo00;ooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`02oooo
o`04o`00ooooooooooooooooo`;o003o2_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo
oooo00?o0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`;o0?ZJ00?ooooooomQ0_ooool02oooool0
1OooH@;ooooooooooooooooo003o00;o0?ZJ0oooool00ol00?ooooooooooo`02ooooo`04o`00oooo
ooooooooooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`09ooooo`03oomQ0_oooooooooo00Cooooo
00?oof42ooooooooool02_ooool00ol00?ooooooooooo`05ooooo`05o`00ooooooooooooooooool0
00004_ooool002[ooooo0_l00002ooooo`04oomQ0_oooooo0?ZJo`3jVPKooooo00?o003ooooooooo
ool02Oooool2o`3jVP?ooooo00?o003oooooooooool01Oooool01OooH@;oooooooooooooooooof42
00Wooooo0ol0nYX4ooooo`03o`00oooooooo003o00Gooooo0_l0nYX<ooooo`03o`00oooooooo003o
01Oooooo0_l0nYX5ooooo`?o0?ZJ1?ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo
00;ooooo00Co003ooooooooooooooooo0_l00?l:ooooo`03o`00oooooooooooo00?ooooo00?o003o
ooooooooool01_ooool00ol00?ooooooooooo`05ooooo`04o`00oooooooooooooomQ0P?ooooo00?o
of42ooooooooool02_ooool00ol00?ooooooooooo`03o`3jVP03o`00oooooooooooo00;ooooo0_l0
nYX7ooooo`03o`00oooooooooooo00_ooooo00Goof42oooooooooooooooooomQ0P06ooooo`?o0?ZJ
1?ooool00ol00?ooooooooooo`02o`3jVP?ooooo00?o003oooooooooool00_l0000Nooooo`03o`00
0?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ1Oooool00ol00?ooooooooooo`0:ooooo`;o
0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooooooo
ool01?ooool3o`3jVP?ooooo00Co003ooooooooooooo003o1Oooool3o`3jVP[ooooo00Co003ooooo
oooooooo003o5oooool2o`3jVP;ooooo0ol0nYX2ooooo`05o`00ooooooooooooooooool00?l02ooo
ool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooooooo`;o003o2_ooool00ol00?oooooo
ooooo`03ooooo`04o`00ooooooooooooooooo`;o0?ZJ0oooool00ol00?ooooooooooo`05ooooo`;o
0?ZJ00?ooooooomQ0_ooool02oooool01OooH@;ooooooooooooooooo003o00;o0?ZJ0oooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00?o0?ZJ0oooool00ol00?ooooooooooo`09oooo
o`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool02Oooool00ol00?ooooooooooo`05oooo
o`03o`00oooooooooooo00;o00004_ooool001Kooooo0_l00004ooooo`03o`000?oooooooooo00;o
oooo0ol00006ooooo`03o`000?oooooooooo00;ooooo00?oof42o`3jV_l0nYX01_ooool00ol00?oo
ooooooooo`08ooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`05oomQ0_oooooooooooooo
ooooH@802_ooool2o`3jVPCooooo00?o003oooooool00?l01?ooool3o`3jVPgooooo0_l00?lGoooo
o`?o0?ZJ1?ooool2o`3jVP03o`00oooooooooooo00;ooooo00?o003oooooooooool02?ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool02?ooool00ol0
0?ooooooooooo`03ooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool01Oooool01?l0
0?ooooooooooooooH@83ooooo`;oof423?ooool00ol00?ooooooooooo`02o`3jVP04o`00oooooooo
ooooooooo`?o0?ZJ1oooool00ol00?ooooooooooo`0;ooooo`05oomQ0_ooooooooooooooooooH@80
1oooool2o`3jVPCooooo00?o003oooooool0nYX00_l0nYX3ooooo`05o`00ooooooooooooooooool0
00002_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Kooooo00?o0000oooooooo
ool00_ooool01?ooH@;oooooo`3jV_l0nYX5ooooo`03o`00oooooooooooo00[ooooo0_l0nYX00ooo
oooo003oooooo`04ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool01Oooool2o`3j
VP?ooooo00Co003ooooooooooooo003o1Oooool2o`3jVPcooooo00?o003oooooool00?l05oooool6
o`3jVP?ooooo00Go003oooooooooooooooooo`00o`0;ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo00?ooooo00Co
003ooooooooooooooooo0_l0nYX3ooooo`03o`00oooooooooooo00Cooooo0ol0nYX00oooooooof42
ooooo`0;ooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX3ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool00_l0nYX4ooooo`03o`00oooooooooooo00Wooooo00?oof42ooooooooool0
1Oooool00oooH@;oooooooooo`09ooooo`03o`00oooooooooooo00Gooooo00Go003ooooooooooooo
ooooo`00000Booooo`005Oooool01?l0003oooooooooool00007ooooo`05o`000?oooooooooooooo
ool000001Oooool00ol0003oooooooooo`02ooooo`03oomQ0_l0nY[o0?ZJ00Kooooo00?o003ooooo
ooooool02?ooool2o`3jVP?ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`02oooo
o`03oomQ0_oooooooooo00Sooooo0_l0nYX4ooooo`03o`00oooooooo003o00Cooooo0_l0nYX>oooo
o`;o003o6?ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00Go003oooooooooooooooooo`00o`0;
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`08
ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`05
ooooo`04o`00oooooooooooooomQ0PGooooo00?oof42ooooooooool02Oooool00ol00?oooooooooo
o`03o`3jVP?ooooo0_l0nYX00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00_ooooo00Go
of42oooooooooooooooooomQ0P07ooooo`;o0?ZJ1?ooool4o`3jVPCooooo00Go003ooooooooooooo
ooooo`000009ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000005
ooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ1Oooool00ol00?oooooooooo
o`0:ooooo`;o0?ZJ00?oooooo`00ooooool01?ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oo
oooooooo00Gooooo0_l0nYX3ooooo`04o`00ooooooooooooo`00o`Gooooo0_l0nYX=ooooo`;o003o
6?ooool4o`3jVPCooooo00Go003oooooooooooooooooo`00o`0;ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo00?o
oooo00Co003ooooooooooooooooo0ol0nYX2ooooo`03o`00oooooooooooo00Cooooo0_l0nYX2oooo
o`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool00_ooool3o`3jVP;ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooo`3jVP02o`3jVPCooooo00?o003oooooooooool02?ooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Wooooo00?o003oooooooooool01Oooool01Ol0
0?oooooooooooooooooo000001;ooooo000Eooooo`04o`000?ooooooooooo`0000_ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`02ooooo`03oomQ0_l0nY[o0?ZJ00Kooooo00?o003o
ooooooooool02?ooool2o`3jVP?ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`02
ooooo`03oomQ0_oooooooooo00Sooooo0_l0nYX4ooooo`03o`00oooooooo003o00?ooooo0ol0nYX?
ooooo`03o`00oooooooooooo01Oooooo1_l0nYX2ooooo`04o`00ooooooooooooo`00o`_ooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Sooooo00?o
003oooooooooool00oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00Gooooo00Co
003oooooooooooooof421_ooool2oomQ0PWooooo00Co003ooooooooooooooooo1ol0nYX00ol00?oo
ooooooooo`05ooooo`03o`00oooooooooooo00_ooooo00Goof42oooooooooooooooooomQ0P07oooo
o`Wo0?ZJ1Oooool01Ol00?oooooooooooooooooo000000Wooooo00Co0000oooooooooooo00002ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ
1Oooool00ol00?ooooooooooo`0:ooooo`;o0?ZJ00?oooooo`00ooooool00oooool00oooH@;ooooo
ooooo`09ooooo`03oomQ0_oooooooooo00Cooooo0_l0nYX3ooooo`04o`00ooooooooooooo`00o`Co
oooo0ol0nYX>ooooo`03o`00oooooooooooo01oooooo00Co003ooooooooooooo003o2oooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool02?ooool00ol0
0?ooooooooooo`03ooooo`03o`00oooooooooooo00;ooooo0_l0nYX2ooooo`03o`00oooooooooooo
00Cooooo0_l0nYX2ooooo`03oomQ0_oooooooooo00_ooooo00Goof42ooooooooooooooooo`00o`02
o`3jVP03ooooool00?oooooo00Cooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool00ol00?oooooooooo
o`08ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool02Oooool00ol00?oooooooooo
o`05ooooo`05o`00ooooooooooooooooool000004_ooool001Gooooo00Co0000oooooooooooo0000
2oooool00ol0003oooooooooo`03ooooo`;o00000oooool00oooH@;o0?ZJo`3jVP06ooooo`03o`00
oooooooooooo00Oooooo0ol0nYX3ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool0
0_ooool00oooH@;oooooooooo`08ooooo`;o0?ZJ1?ooool00ol00?ooooooo`00o`03ooooo`;o0?ZJ
:oooool3o`3jVPCooooo00Co003ooooooooooooo003o2oooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00gooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`06ooooo`03
o`00oooooooooooo00Gooooo00Co003oooooooooooooof422?ooool00oooH@;oooooooooo`06oooo
o`05o`00ooooooooooooooooool00?l01_l0nYX00ol00?ooooooooooo`05ooooo`03o`00oooooooo
oooo00_ooooo00Goof42oooooooooooooooooomQ0P08ooooo`Ko0?ZJ1oooool00ol00?ooooooo`00
0002o`0000Wooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`03ooooo`;o0000
0oooool01?ooH@;oooooo`3jV_l0nYX5ooooo`03o`00oooooooooooo00[ooooo0_l0nYX00ooooooo
003oooooo`03ooooo`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool01?ooool2o`3jVPCo
oooo00?o003oooooool00?l01?ooool2o`3jVS7ooooo00Co003ooooooooooooo003o2oooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00gooooo00?o003oooooooooool00oooool00ol0
0?ooooooooooo`02ooooo`?o0?ZJ00?oooooo`00ooooool01Oooool2o`3jVP;ooooo00?oof42oooo
ooooool02oooool01OooH@;ooooooooooooooooo003o00;o0?ZJ00?oooooo`00ooooool01?ooool0
0ol00?oo0?ZJo`3jVP06ooooo`03o`00oooooooooooo00Sooooo00?oof42ooooooooool01_ooool0
0oooH@;oooooooooo`09ooooo`03o`00oooooooooooo00Gooooo00?o003oooooool000000_l0000B
ooooo`005Oooool01?l0003oooooooooool00007ooooo`Co00001_ooool00ol0003oooooooooo`02
ooooo`03oomQ0_l0nY[o0?ZJ00Kooooo00?o003oooooooooool01oooool2o`3jVPCooooo00?o003o
ooooooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Oooooo0ol0nYX3
ooooo`03o`00oooooooo003o00?ooooo0_l0nYXbooooo`04o`00ooooooooooooo`00o`cooooo00Go
003oooooooooooooooooo`00o`0@ooooo`05o`00ooooooooooooooooool00?l02Oooool00ol00?oo
ooooooooo`05ooooo`04o`00oooooooooooooomQ0PSooooo00?oof42ooooooooool01_ooool01Ol0
0?oooooooooooooooooo003o00?ooooo0_l0nYX00ooooooo003oooooo`06ooooo`03o`00oooooooo
oooo00_ooooo00Goof42oooooooooooooooooomQ0P0;ooooo`;o0?ZJ00?oooooo`00ooooool01?oo
ool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo0000
1oooool4o`0000Kooooo00?o0000ooooooooool00_ooool00oooH@;oooooo`3jVP02o`3jVPCooooo
00?o003oooooooooool02_ooool2o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool0
2Oooool00oooH@;oooooooooo`04ooooo`?o0?ZJ0oooool00ol00?ooooooo`00o`03ooooo`?o0?ZJ
<Oooool01?l00?ooooooooooool00?l<ooooo`05o`00ooooooooooooooooool00?l04?ooool01Ol0
0?oooooooooooooooooo003o00Kooooo0_l0nYX00ooooooo003oooooo`05ooooo`;o0?ZJ0_ooool0
0oooH@;oooooooooo`0;ooooo`05oomQ0_ooooooooooooooool00?l00ol0nYX00ol00?oooooooooo
o`03ooooo`?o0?ZJ1_ooool00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00Oooooo00?o
of42ooooooooool02Oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00;ooooo00?o
0000ooooooooool04?ooool001Gooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00;ooooo00?oof42o`3jV_l0nYX01_ooool00ol00?oooooooooo
o`07ooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`05ooooo`03oomQ0_oooooooooo00?ooooo00?o
of42ooooooooool02?ooool2o`3jVP?ooooo00?o003oooooool00?l00_ooool3o`3jVS;ooooo00Co
003ooooooooooooo003o3?ooool01Ol00?oooooooooooooooooo003o013ooooo00Go003ooooooooo
ooooooooo`00o`09ooooo`03o`00oooooooooooo00Gooooo00Co003oooooooooooooof422Oooool0
0oooH@;oooooooooo`05ooooo`05o`00ooooooooooooooooool00?l01_ooool00ol00?oooooooooo
o`05ooooo`03o`00oooooooooooo00_ooooo00Goof42oooooooooooooooooomQ0P0>ooooo`03o`00
oooooooooooo00?ooooo00?o003oooooooooool00_ooool00ol0003oooooooooo`07ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`03
oomQ0_oooooooooo00;o0?ZJ1?ooool00ol00?ooooooooooo`09ooooo`?o0?ZJ00?oooooo`00oooo
ool00oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX3ooooo`03
o`00oooooooo003o00?ooooo0_l0nYXbooooo`04o`00ooooooooooooo`00o`cooooo00Go003ooooo
ooooooooooooo`00o`0@ooooo`05o`00ooooooooooooooooool00?l01_ooool3o`3jVP03o`00oooo
oooooooo00?ooooo0ol0nYX2ooooo`03oomQ0_oooooooooo00_ooooo00Koof42oooooooooooooooo
o`00ooooool2o`3jVP03o`00oooooooooooo00?ooooo0_l0nYX7ooooo`03o`00oooooooooooo00Oo
oooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00Co
oooo00?o003oooooooooool00_ooool00ol0003oooooooooo`0@ooooo`005_ooool2o`0000Sooooo
1Ol00005ooooo`03o`000?oooooooooo00;ooooo00?oof42o`3jV_l0nYX01_ooool00ol00?oooooo
ooooo`06ooooo`?o0?ZJ1?ooool00ol00?ooooooooooo`05ooooo`03oomQ0_oooooooooo00?ooooo
00?oof42ooooooooool02?ooool2o`3jVP?ooooo00?o003oooooool00?l00_ooool2o`3jVS?ooooo
00Co003ooooooooooooo003o3?ooool01?l00?ooooooooooool00?lAooooo`05o`00oooooooooooo
ooooool00?l02Oooool2o`00o`Gooooo00Go003ooooooooooooooooooomQ0P0:ooooo`03oomQ0_oo
oooooooo00Cooooo00Go003oooooooooooooooooo`00o`06ooooo`03o`00oooooooooooo00Gooooo
00?o003oooooooooool02oooool01OooH@;oooooooooooooooooof4200kooooo00?o003ooooooooo
ool00oooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo00Sooooo0_l00008ooooo`Go
00001Oooool00ol0003oooooooooo`02ooooo`03oomQ0_oooooooooo00;o0?ZJ1?ooool00ol00?oo
ooooooooo`09ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00Wo
oooo00?oof42ooooooooool01Oooool2o`3jVP?ooooo00?o003oooooool00?l00oooool2o`3jVS;o
oooo00Co003ooooooooooooo003o3?ooool01?l00?ooooooooooool00?lAooooo`05o`00oooooooo
ooooooooool00?l01oooool2o`3jVP;o003o1?ooool2o`3jVP?ooooo00?oof42ooooooooool02ooo
ool01_ooH@;ooooooooooooooooo003oooooo`;o0?ZJ00?o003oooooooooool00_ooool3o`3jVPOo
oooo00?o003oooooooooool01oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00So
oooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo013o
oooo000Zooooo`;o00000oooool00oooH@;o0?ZJo`3jVP06ooooo`03o`00oooooooooooo00Kooooo
0_l0nYX5ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool00oooool00oooH@;ooooo
ooooo`08ooooo`;o0?ZJ1?ooool00ol00?ooooooooooo`03o`3jVS?ooooo00Co003ooooooooooooo
003o3?ooool01?l00?ooooooooooool00?lAooooo`05o`00ooooooooooooooooool00?l02oooool0
0ol00?ooooooooooo`02ooooo`05o`00ooooooooooooooooooooH@802oooool3oomQ0P?ooooo00Go
003oooooooooooooooooo`00o`07ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool0
2oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00_ooooo00?o003oooooooooool0
0oooool01?l00?ooooooooooooooool2o`0001kooooo00?o0000ooooooooool00_ooool00oooH@;o
ooooooooo`02o`3jVPCooooo00?o003oooooooooool02Oooool2o`3jVP;ooooo00?o003ooooooooo
ool00_ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00Cooooo0_l0nYX3ooooo`;o
003o0oooool3o`3jVS;ooooo00Co003ooooooooooooo003o3?ooool01?l00?ooooooooooool00?lA
ooooo`05o`00ooooooooooooooooool00?l01oooool2o`3jVP;ooooo00Co003ooooooooooooooooo
0_l0nYX3ooooo`03oomQ0_oooooooooo00_ooooo00Koof42ooooooooooooooooo`00ooooool3o`3j
VPCooooo0_l0nYX00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Kooooo00?oof42oooo
ooooool02Oooool00oooH@;oooooooooo`08ooooo`03o`00oooooooooooo00Cooooo00Co003ooooo
oooooooooooo0_l0000Booooo`00:_ooool00ol0003oooooooooo`02ooooo`04oomQ0_l0nY[o0?ZJ
o`3jVPKooooo00?o003oooooooooool01Oooool2o`3jVPGooooo00?o003oooooooooool01Oooool0
0oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Sooooo0ol0nYX3ooooo`03o`00oooooooo
oooo00;o0?ZJ=Oooool00ol00?ooooooo`00o`0<ooooo`04o`00ooooooooooooo`00oa7ooooo00Go
003oooooooooooooooooo`00o`0;ooooo`03o`00oooooooooooo00;ooooo00Go003ooooooooooooo
oooooomQ0P0=ooooo`05oomQ0_ooooooooooooooool00?l00oooool00ol00?ooooooooooo`05oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooooooool02oooool00oooH@;oooooooooo`02oooo
o`03oomQ0_oooooooooo00_ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`03oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool00_ooool00oooH@;oooooooooo`02o`3j
VPGooooo00?o003oooooooooool02?ooool2o`3jVP;ooooo00Go003ooooooooooooooooooomQ0P0=
ooooo`03oomQ0_oooooooooo00Cooooo0_l0nYX4ooooo`04o`00ooooooooooooooooo`;o0?ZJ=?oo
ool00ol00?ooooooo`00o`0<ooooo`04o`00ooooooooooooo`00oa7ooooo00Go003ooooooooooooo
ooooo`00o`07ooooo`?o0?ZJ00Coooooo`00oooooooooooo0ol0nYX3ooooo`03oomQ0_oooooooooo
00_ooooo00Goof42ooooooooooooooooo`00o`02ooooo`;o0?ZJ0oooool3o`3jVP03o`00oooooooo
oooo00Gooooo00?o003oooooooooool01_ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooo
oooo00Sooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`03ooooo`03o`000?oooooo
oooo013ooooo000Zooooo`03o`000?oooooooooo00;ooooo00Coof42ooooool0nY[o0?ZJ1_ooool0
0ol00?ooooooooooo`05ooooo`;o0?ZJ1Oooool00ol00?ooooooooooo`05ooooo`03oomQ0_oooooo
oooo00?ooooo00?oof42ooooooooool02Oooool2o`3jVP?ooooo00?o003oooooooooool00_l0nYXe
ooooo`03o`00oooooooo003o00cooooo00Co003ooooooooooooo003o4Oooool01Ol00?oooooooooo
oooooooo003o00_ooooo00?o003oooooooooool00_ooool01Ol00?ooooooooooooooooooof4200go
oooo00Goof42ooooooooooooooooo`00o`03ooooo`03o`00oooooooooooo00Gooooo00?o003ooooo
ooooool01?ooool00ol00?ooooooooooo`0;ooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooo
ooooool02_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`02ooooo`03oomQ0_oooooooooo00;o0?ZJ1Oooool00ol0
0?ooooooooooo`08ooooo`;o0?ZJ0_ooool01Ol00?ooooooooooooooooooof4200gooooo00?oof42
ooooooooool01?ooool3o`3jVP?ooooo00?o003oooooooooool00ol0nYXdooooo`;o003o3Oooool0
1?l00?ooooooooooool00?lAooooo`05o`00ooooooooooooooooool00?l02?ooool2o`3jVP04oooo
ool00?ooooooooooo`;o0?ZJ00Go003ooooooooooooooooooomQ0P0=ooooo`05oomQ0_oooooooooo
ooooool00?l00_ooool2o`3jVP;ooooo0ol0nYX00ooooooo003oooooo`06ooooo`03o`00oooooooo
oooo00Kooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`08ooooo`03o`00oooooooo
oooo00?ooooo00?o003oooooooooool00oooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0
003oooooooooo`02ooooo`04oomQ0_oooooo0?ZJo`3jVPKooooo00?o003oooooooooool01Oooool2
o`3jVPGooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooo
oooo00Wooooo0_l0nYX3ooooo`03o`00oooooooo0?ZJ00;o0?ZJ=Oooool00ol00?ooooooo`00o`0<
ooooo`04o`00ooooooooooooo`00oa7ooooo00Go003oooooooooooooooooo`00o`0;ooooo`03o`00
oooooooooooo00;ooooo00Go003ooooooooooooooooooomQ0P0=ooooo`03oomQ0_oooooooooo00;o
oooo00Co003ooooooooooooo003o1oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo
00_ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`0:ooooo`05o`00oooooooooooo
ooooool00?l01_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00;ooooo00?oof42
ooooooooool00_l0nYX5ooooo`03o`00oooooooooooo00Oooooo0ol0nYX2ooooo`05o`00oooooooo
ooooooooooooH@803Oooool00oooH@;oooooooooo`05ooooo`;o0?ZJ0oooool00ol00?oooooooooo
o`02o`3jVSGooooo0_l00?l=ooooo`04o`00ooooooooooooo`00oa7ooooo00Go003ooooooooooooo
ooooo`00o`08ooooo`?o0?ZJ00?o003oooooooooool00_l0nYX01Ol00?ooooooooooooooooooof42
00gooooo00?oof42ooooooooool00_ooool00ol00?ooooooo`3jVP05o`3jVP;ooooo00?o003ooooo
ooooool01Oooool00ol00?ooooooooooo`05ooooo`03oomQ0_oooooooooo00[ooooo00?oof42oooo
ooooool02?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o0000oooo
ooooool04?ooool002[ooooo0_l00003ooooo`04oomQ0_oooooo0?ZJo`3jVPKooooo00?o003ooooo
ooooool01?ooool3o`3jVPGooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`03oooo
o`03oomQ0_oooooooooo00Wooooo0ol0nYX4ooooo`;o0?ZJ=_ooool00ol00?ooooooo`00o`0<oooo
o`04o`00ooooooooooooo`00oa7ooooo00Go003oooooooooooooooooo`00o`0;ooooo`03o`00oooo
oooooooo00;ooooo00Go003ooooooooooooooooooomQ0P0>ooooo`05oomQ0_ooooooooooooooool0
0?l00_ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Cooooo00?o003ooooooooo
ool02_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00[ooooo00Go003ooooooooo
ooooooooo`00o`05ooooo`;o00007_ooool00ol0003oooooooooo`03ooooo`03oomQ0_oooooo0?ZJ
00;o0?ZJ1?ooool00ol00?ooooooooooo`07ooooo`;o0?ZJ0oooool01Ol00?oooooooooooooooooo
of4200gooooo00?oof42ooooooooool01Oooool2o`3jVPKooooo0_l0nYXeooooo`;o003o3Oooool0
1?l00?ooooooooooool00?lAooooo`05o`00ooooooooooooooooool00?l02Oooool2o`3jVP03o`00
oooooooo0?ZJ00;o0?ZJ00Go003ooooooooooooooooooomQ0P0>ooooo`05oomQ0_oooooooooooooo
ool00?l00_ooool4o`3jVP?ooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`05oooo
o`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool02?ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo00?ooooo0_l0000Booooo`00:_ooool00ol0003oooooooooo`02ooooo`04
oomQ0_oooooo0?ZJo`3jVPKooooo00?o003oooooooooool01?ooool2o`3jVPKooooo00?o003ooooo
ooooool00_ooool4oomQ0PKooooo00?oof42ooooooooool02Oooool2o`3jVPCooooo0_l0nYXfoooo
o`;o003o3Oooool00ol00?ooooooo`00o`0Booooo`05o`00ooooooooooooooooool00?l02oooool0
0ol00?ooooooooooo`02ooooo`05o`00ooooooooooooooooooooH@803_ooool01OooH@;ooooooooo
oooooooo003o00;ooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooooooo00_ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`09ooooo`04o`00
ooooooooooooo`00o`Oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`03ooooo`03
oomQ0_oooooooooo00;o0?ZJ1?ooool00ol00?ooooooooooo`07ooooo`;o0?ZJ0oooool01Ol00?oo
ooooooooooooooooof4200kooooo00?oof42ooooooooool01?ooool2o`3jVPGooooo0ol0nYXeoooo
o`;o003o3Oooool00ol00?ooooooo`00o`0Booooo`05o`00ooooooooooooooooool00?l02Oooool6
o`3jVP03ooooool00?oooooo00;ooooo00?oof42ooooooooool03?ooool01OooH@;ooooooooooooo
oooo003o00;ooooo00?o003oo`3jV_l0nYX01?ooool00ol00?ooooooooooo`04ooooo`03o`00oooo
oooooooo00Kooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`08ooooo`05o`00oooo
ooooooooooooool00?l01oooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003ooooooooo
o`02ooooo`04oomQ0_oooooo0?ZJo`3jVPKooooo00?o003oooooooooool01?ooool2o`3jVPKooooo
00?o003oooooooooool00_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00Wooooo
0_l0nYX3ooooo`?o0?ZJ=_ooool2o`00o`gooooo00?o003oooooool00?l04oooool01?l00?oooooo
ooooool00?l<ooooo`05o`00ooooooooooooooooool00?l00oooool00oooH@;oooooooooo`0<oooo
o`06oomQ0_ooooooooooooooool00?oooooo0_l00?l7ooooo`03o`00oooooooooooo00?ooooo00?o
003oooooooooool02oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00Wooooo00Co
003ooooooooooooo003o1oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00?ooooo
00?oof42ooooooooool00_l0nYX4ooooo`03o`00oooooooooooo00Oooooo0_l0nYX3ooooo`05o`00
ooooooooooooooooooooH@803_ooool00oooH@;oooooooooo`04ooooo`?o0?ZJ0oooool3o`3jVQoo
oooo0_ooH@8Eooooo`;o003o3Oooool00ol00?ooooooo`00o`0Cooooo`04o`00ooooooooooooo`00
o`[ooooo1Ol0nYX00ooooooo003oooooo`02ooooo`03oomQ0_oooooooooo00cooooo00Koof42oooo
ooooooooooooo`00ooooool2o`00o`Kooooo00?o003oooooooooool01?ooool00ol00?oooooooooo
o`05ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool01oooool01Ol00?oooooooooo
oooooooo003o00Oooooo00?o0000ooooooooool04?ooool002[ooooo00?o0000ooooooooool00_oo
ool01?ooH@;oooooo`3jV_l0nYX6ooooo`03o`00oooooooooooo00Cooooo0_l0nYX6ooooo`05o`00
ooooooooooooooooooooH@802_ooool00oooH@;oooooooooo`09ooooo`Oo0?ZJ=oooool2o`00o`go
oooo00?o003oooooool00?l04oooool01?l00?ooooooooooool00?l<ooooo`05o`00oooooooooooo
ooooool00?l00oooool00oooH@;oooooooooo`0<ooooo`04oomQ0_ooooooooooooooo`;o003o2Ooo
ool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00_ooooo00?oof42ooooooooool01Ooo
ool00oooH@;oooooooooo`09ooooo`04o`00ooooooooooooo`00o`Oooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`03ooooo`03oomQ0_oooooooooo00;o0?ZJ1?ooool00ol00?oooooo
ooooo`07ooooo`;o0?ZJ0oooool01Ol00?ooooooooooooooooooof4200kooooo00?oof42oooooooo
ool01Oooool7o`3jVQkooooo0_ooH@800oooooooof42ooooo`0Dooooo`;o003o3Oooool00ol00?oo
ooooo`00o`0Cooooo`04o`00ooooooooooooo`00o`cooooo00Go003oooooooooooooooooo`00o`03
ooooo`03oomQ0_oooooooooo00cooooo00Coof42oooooooooooooooo0_l00?l9ooooo`03o`00oooo
oooooooo00?ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oo
oooooooo00Oooooo00Go003oooooooooooooooooo`00o`07ooooo`03o`000?oooooooooo013ooooo
000Zooooo`;o00000oooool00oooH@;oooooo`3jVP02o`3jVPGooooo00?o003oooooooooool00ooo
ool3o`3jVPKooooo00Go003ooooooooooooooooooomQ0P0:ooooo`03oomQ0_oooooooooo00[ooooo
1Ol0nYXiooooo`03o`00oooooooooooo00cooooo0_l00?lCooooo`04o`00ooooooooooooo`00o`co
oooo00Go003oooooooooooooooooo`00o`03ooooo`03oomQ0_oooooooooo00cooooo00?oof42oooo
ooooool03?ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00_ooooo00?oof42oooo
ooooool01Oooool00oooH@;oooooooooo`09ooooo`04o`00ooooooooooooo`00o`Kooooo0_l0000N
ooooo`03o`000?oooooooooo00?ooooo00?oof42ooooooooool00_l0nYX4ooooo`03o`00oooooooo
oooo00Kooooo0ol0nYX3ooooo`04o`00oooooooooooooomQ0Poooooo00?oof42ooooooooool01Ooo
ool6o`3jVQoooooo00Goof42oooooooooooooooooomQ0P0Eooooo`03o`00oooooooooooo00cooooo
0_l00?lCooooo`04o`00ooooooooooooo`00o`cooooo00Go003oooooooooooooooooo`00o`03oooo
o`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool03?ooool00ol00?ooooooooooo`03oooo
o`03o`00oooooooooooo00Gooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`08oooo
o`03o`00oooooooo003o00Oooooo0_l0000Booooo`00:_ooool00ol0003oooooooooo`02ooooo`03
oomQ0_oooooooooo00;o0?ZJ1Oooool00ol00?ooooooooooo`03ooooo`;o0?ZJ1oooool01Ol00?oo
ooooooooooooooooof4200[ooooo00?oof42ooooooooool03?ooool2o`3jVS[ooooo00?o003ooooo
ooooool03?ooool2o`00oa?ooooo00Co003ooooooooooooo003o3?ooool01Ol00?oooooooooooooo
oooo003o00?ooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0=ooooo`03o`00oooo
oooooooo00;ooooo00?o003oooooooooool02oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oo
oooooooo00Wooooo00?o003oooooool00?l02?ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00?ooooo00?oof42ooooooooool00_l0nYX4ooooo`03o`00oooooooooooo00Kooooo0_l0
nYX4ooooo`04o`00oooooooooooooomQ0Poooooo00?oof42ooooooooool02?ooool2o`3jVQoooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0Cooooo`03o`00oooooooooooo00cooooo
0_l00?lCooooo`04o`00ooooooooooooo`00o`cooooo00Go003oooooooooooooooooo`00o`03oooo
o`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool03?ooool00ol00?ooooooooooo`03oooo
o`03o`00oooooooooooo00Cooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`08oooo
o`03o`00oooooooo003o00Sooooo00?o0000ooooooooool04?ooool002[ooooo00?o0000oooooooo
ool00_ooool00oooH@;oooooooooo`02o`3jVPGooooo00?o003oooooooooool00_ooool00ol00?oo
0?ZJo`3jVP07ooooo`04o`00oooooooooooooomQ0P_ooooo00?oof42ooooooooool0B?ooool00ol0
0?ooooooooooo`0<ooooo`;o003o4oooool01?l00?ooooooooooool00?l<ooooo`05o`00oooooooo
ooooooooool00?l00oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00gooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`0;ooooo`03oomQ0_oooooooooo00Gooooo00?o
of42ooooooooool02Oooool00ol00?ooooooo`00o`08ooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool00oooool00oooH@;oooooooooo`03o`3jVP?ooooo00?o003oooooooooool00_oo
ool01?l00?ooooooooooooooool2o`3jVPCooooo00Co003oooooooooooooof424?ooool00oooH@;o
ooooooooo`0Xooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool04_ooool00ol00?oo
ooooooooo`0<ooooo`;o003o4oooool01?l00?ooooooooooool00?l<ooooo`05o`00oooooooooooo
ooooool00?l00oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00cooooo00?o003o
ooooooooool00oooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00gooooo00?oof42
ooooooooool02?ooool00ol00?ooooooo`00o`08ooooo`03o`000?oooooooooo013ooooo000Zoooo
o`03o`000?oooooooooo00;ooooo00?oof42ooooooooool00_l0nYX5ooooo`03o`00oooooooooooo
00;ooooo0ol0nYX7ooooo`04o`00oooooooooooooomQ0P_ooooo00?oof42ooooooooool0Eoooool0
0ol00?ooooooooooo`0Booooo`04o`00ooooooooooooo`00o`cooooo00Go003ooooooooooooooooo
o`00o`03ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool03?ooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo00Sooooo0_ooH@800oooooooof42ooooo`07ooooo`03oomQ
0_oooooooooo00Sooooo00?o003oooooool00?l02?ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00?ooooo00Coof42oooooooooooooooo0_l0nYX3ooooo`03o`00oooooooooooo00;o
oooo00Co003ooooooooooooooooo0_l0nYX4ooooo`04o`00oooooooooooooomQ0Q3ooooo00?oof42
ooooooooool09oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo027ooooo00?o003o
ooooooooool04_ooool01?l00?ooooooooooool00?l<ooooo`05o`00ooooooooooooooooool00?l0
0oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00_ooooo00?o003oooooooooool0
0oooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool0
2?ooool00ol00?ooooooo`00o`08ooooo`03o`000?oooooooooo013ooooo000Zooooo`;o00000ooo
ool00oooH@;oooooooooo`02o`3jVPKooooo00Co003ooooooooooooooooo0_l0nYX8ooooo`04o`00
oooooooooooooomQ0P_ooooo00?oof42ooooooooool0Eoooool00ol00?ooooooooooo`0Booooo`04
o`00ooooooooooooo`00o`cooooo00Co003ooooooooooooo003o1?ooool00oooH@;oooooooooo`0=
ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`06
ooooo`;oof4200CooooooomQ0_ooooooof422?ooool00oooH@;oooooooooo`09ooooo`;o003o1ooo
ool2o`0001kooooo00?o0000ooooooooool00oooool01?ooH@;oooooooooooooool2o`3jVP?ooooo
00?o003oooooooooool00_ooool01?l00?ooooooooooooooool2o`3jVPCooooo00Co003ooooooooo
ooooof424?ooool00oooH@;oooooooooo`0Wooooo`03oomQ0_oooooooooo00Cooooo00?oof42oooo
ooooool08Oooool00ol00?ooooooooooo`0Booooo`04o`00ooooooooooooo`00o`cooooo00Co003o
oooooooooooo003o1?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00cooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`03ooooo`03oomQ0_oooooooooo00kooooo00?o
of42ooooooooool02?ooool00ol00?ooooooo`00o`07ooooo`;o00004_ooool002[ooooo00?o0000
ooooooooool00_ooool00oooH@;oooooooooo`02o`3jVPKooooo00Co003ooooooooooooooooo0_l0
nYX8ooooo`04o`00oooooooooooooomQ0P_ooooo00?oof42ooooooooool0Eoooool00ol00?oooooo
ooooo`0Booooo`04o`00ooooooooooooo`00o`cooooo00Co003ooooooooooooo003o1?ooool00ooo
H@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`06ooooo`04oomQ0_ooooooooooooooo`;oof422?ooool00oooH@;oooooooooo`09
ooooo`;o003o2?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00?ooooo00Coof42
oooooooooooooooo0_l0nYX3ooooo`03o`00oooooooooooo00;ooooo0_l00?l2ooooo`;o0?ZJ1?oo
ool01?l00?ooooooooooooooH@8@ooooo`03oomQ0_oooooooooo02Kooooo00?oof42ooooooooool0
1_ooool00oooH@;oooooooooo`0Pooooo`03o`00oooooooooooo01;ooooo00Co003ooooooooooooo
003o3?ooool01?l00?ooooooooooool00?l4ooooo`03oomQ0_oooooooooo00gooooo00?oof42oooo
ooooool03?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?ooooo00?oof42oooo
ooooool03_ooool00oooH@;oooooooooo`08ooooo`;o003o2Oooool00ol0003oooooooooo`0@oooo
o`008Oooool3o`0000Kooooo00?o0000ooooooooool00_ooool00oooH@;oooooooooo`02o`3jVPKo
oooo00?o003oooooooooool00ol0nYX7ooooo`04o`00oooooooooooooomQ0Pgooooo00?oof42oooo
ooooool0Joooool01?l00?ooooooooooool00?l<ooooo`04o`00ooooooooooooo`00o`Cooooo00?o
of42ooooooooool03Oooool00oooH@;oooooooooo`0<ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Kooooo00?o
of42ooooooooool02Oooool2o`00o`Sooooo00?o0000ooooooooool04oooool3o`0000Kooooo00?o
0000ooooooooool00oooool01?ooH@;oooooooooooooool2o`3jVPCooooo00Co003ooooooooooooo
oooo0_l00?l01?oooooo0?ZJo`3jV_l0nYX3ooooo`04o`00oooooooooooooomQ0Q7ooooo00?oof42
ooooooooool09Oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo03Gooooo00Co003o
oooooooooooo003o3?ooool01?l00?ooooooooooool00?l3ooooo`03oomQ0_oooooooooo00kooooo
00?oof42ooooooooool03?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?ooooo
00?oof42ooooooooool03_ooool00oooH@;oooooooooo`08ooooo`;o003o2Oooool00ol0003ooooo
ooooo`0@ooooo`008_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o
of42ooooooooool00ol0nYX5ooooo`03o`00oooooooooooo00;o0?ZJ00?o003oooooooooool01Ooo
ool01?l00?ooooooooooooooH@8=ooooo`03oomQ0_oooooooooo06cooooo00?o003oooooool00?l0
3?ooool01?l00?ooooooooooool00?l4ooooo`03oomQ0_oooooooooo00gooooo00?oof42oooooooo
ool03?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?oof42oooooooo
ool03Oooool00oooH@;oooooooooo`09ooooo`;o003o2?ooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool01?ooH@;oooooooooooooool2o`3j
VPCooooo00Oo003ooooooooooooo003oooooool00?oooooo00;o0?ZJ1?ooool01?l00?oooooooooo
ooooH@8Booooo`03oomQ0_oooooooooo02Cooooo00?oof42ooooooooool01oooool00oooH@;ooooo
ooooo`0fooooo`03o`00oooooooo003o00cooooo00Co003ooooooooooooo003o0oooool00oooH@;o
ooooooooo`0>ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooool00_ooool00ol00?oo
ooooooooo`03ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool02?ooool2o`00o`Wo
oooo00?o0000ooooooooool04?ooool002;ooooo00?o0000ooooooooool01Oooool2o`0000?ooooo
00Coof42oooooooooooooooo0_l0nYX5ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00?o003ooooooooo
ool01Oooool01?l00?ooooooooooooooH@8=ooooo`03oomQ0_oooooooooo06cooooo00?o003ooooo
ool00?l03Oooool00ol00?ooooooo`00o`04ooooo`03oomQ0_oooooooooo00gooooo00?oof42oooo
ooooool03Oooool01Ol00?oooooooooooooooooo003o00Kooooo00?oof42ooooooooool03Oooool0
0oooH@;oooooooooo`09ooooo`03o`00oooooooooooo00Gooooo0ol0000Fooooo`03o`000?oooooo
oooo00Gooooo0_l00004ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1?ooool01ol00?oooooooooo
ool00?ooooooo`00ooooool00_l0nYX4ooooo`04o`00oooooooooooooomQ0Q;ooooo00?oof42oooo
ooooool08oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo03Gooooo00?o003ooooo
ool00?l03Oooool00ol00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00kooooo00?oof42oooo
ooooool03?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?oof42oooo
ooooool04?ooool00oooH@;oooooooooo`07ooooo`;o003o1oooool3o`0001;ooooo000Rooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool00oooH@;oooooooooo`02o`3jVPGo
oooo00Co003oooooool0nY[o0?ZJ0_ooool00ol00?ooooooooooo`04ooooo`04o`00oooooooooooo
oomQ0Pgooooo00?oof42ooooooooool0K?ooool2o`00o`kooooo00?o003oooooool00?l01?ooool0
0oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00gooooo00Go003oooooooooooooooooo`00
o`05ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool02Oooool00ol00?oooooooooo
o`07ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`03ooooo`04oomQ0_ooooooooooooooo`?o0?ZJ0oooool01?l00?ooooooooooool00?l2ooooo`03
o`00ool0nY[o0?ZJ00Cooooo00Co003oooooooooooooof424_ooool00oooH@;oooooooooo`0Soooo
o`03oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0=Oooool2o`00o`kooooo00?o003ooooo
ool00?l00oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00gooooo00Go003ooooo
ooooooooooooo`00o`04ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool01oooool2
o`00o`Wooooo00?o0000ooooooooool04?ooool002;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`03ooooo`03oomQ0_oooooooooo00;o0?ZJ1Oooool01?l00?ooooooo`3jV_l0nYX2
ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooH@803_ooool00oooH@;oooooooooo`1/
ooooo`;o003o3_ooool00ol00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00oooooo00?oof42
ooooooooool03?ooool01Ol00?oooooooooooooooooo003o00Gooooo00?oof42ooooooooool03_oo
ool00oooH@;oooooooooo`09ooooo`03o`00oooooooooooo00Oooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?oof42ooooooooool00_oo
ool2o`3jVP?ooooo00Co003ooooooooooooo003o0_ooool00ol00?oo0?ZJo`3jVP04ooooo`04o`00
oooooooooooooomQ0Q;ooooo00?oof42ooooooooool08_ooool00oooH@;oooooooooo`0:ooooo`03
oomQ0_oooooooooo03Gooooo0_l00?l>ooooo`03o`00oooooooo003o00?ooooo00?oof42oooooooo
ool03oooool00oooH@;oooooooooo`0<ooooo`05o`00ooooooooooooooooool00?l01?ooool00ooo
H@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00Oooooo00?o003oooooooooool02?ooool00ol0
003oooooooooo`0@ooooo`008Oooool2o`0000Oooooo00?o0000ooooooooool00oooool00oooH@;o
ooooooooo`02o`3jVPGooooo00Co003oo`3jV_l0nY[o0?ZJ0_ooool00ol00?ooooooooooo`04oooo
o`03o`00ooooooooof4200kooooo00?oof42ooooooooool0K?ooool2o`00o`kooooo00?o003ooooo
ool00?l00oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00cooooo00Go003ooooo
ooooooooooooo`00o`04ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool02Oooool0
0ol00?ooooooooooo`07ooooo`03o`000?oooooooooo01?ooooo0_l00007ooooo`03o`000?oooooo
oooo00?ooooo00?oof42ooooooooool00_ooool2o`3jVP?ooooo00Co003ooooooooooooo003o0_oo
ool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ooooooooof4201?ooooo00?oof42ooooooooool08_oo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo02gooooo0oooH@84ooooo`;o003o3_oo
ool00ol00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool03?oo
ool01Ol00?oooooooooooooooooo003o00Cooooo00?oof42ooooooooool04?ooool00oooH@;ooooo
ooooo`07ooooo`?oof422?ooool00ol0003oooooooooo`0@ooooo`008_ooool00ol0003ooooooooo
o`05ooooo`;o00001?ooool00oooH@;oooooooooo`03o`3jVP;ooooo1Ol0nYX01?l00?oooooooooo
ool00?l6ooooo`03o`00ooooooooof4200kooooo00?oof42ooooooooool0K?ooool2o`00o`kooooo
00?o003oooooool00?l00oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00cooooo
00Go003oooooooooooooooooo`00o`04ooooo`03oomQ0_oooooooooo013ooooo00?oof42oooooooo
ool04Oooool2o`0001Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`04
oomQ0_ooooooooooooooo`;o0?ZJ0oooool01?l00?ooooooooooool00?l2ooooo`03o`00ool0nY[o
0?ZJ00Cooooo00?o003oooooooooH@804oooool00oooH@;oooooooooo`0Qooooo`03oomQ0_oooooo
oooo00cooooo00?oof42ooooooooool0;?ooool01OooH@;oooooooooooooooooof4200?ooooo0_l0
0?l>ooooo`03o`00oooooooo003o00?ooooo00?oof42ooooooooool03oooool00oooH@;ooooooooo
o`0<ooooo`05o`00ooooooooooooooooool00?l01?ooool00oooH@;oooooooooo`0@ooooo`03oomQ
0_oooooooooo00Oooooo00Coof42ooooooooooooof421_ooool2o`0001;ooooo000Zooooo`03o`00
0?oooooooooo00?ooooo00Coof42oooooooooooooooo0_l0nYX2ooooo`Go0?ZJ00Co003ooooooooo
oooo003o1_ooool00ol00?oooooooomQ0P0>ooooo`03oomQ0_oooooooooo06cooooo0_l00?l>oooo
o`03o`00oooooooo003o00?ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0<oooo
o`05o`00ooooooooooooooooool00?l01?ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooo
oooo01;ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`04ooooo`04oomQ0_oooooo
ooooooooo`;o0?ZJ0oooool01?l00?ooooooooooool00?l2ooooo`?o0?ZJ1?ooool00ol00?oooooo
oomQ0P0Cooooo`03oomQ0_oooooooooo023ooooo00?oof42ooooooooool03Oooool00oooH@;ooooo
ooooo`0Cooooo`;oof425_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00;o003o
3_ooool00ol00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool0
3?ooool01Ol00?oooooooooooooooooo003o00?ooooo00?oof42ooooooooool04Oooool00oooH@;o
ooooooooo`06ooooo`05oomQ0_ooooooooooooooooooH@801oooool00ol0003oooooooooo`0@oooo
o`00:_ooool00ol0003oooooooooo`03ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ00Soooooo`3j
V_l0nY[o0?ZJooooool00?ooooooo`00o`?ooooo00?o003oooooooooool00oooool00ol00?ooof42
ooooo`0?ooooo`03oomQ0_oooooooooo06_ooooo0_l00?l>ooooo`03o`00oooooooo003o00?ooooo
00?oof42ooooooooool03oooool00oooH@;oooooooooo`0=ooooo`04o`00ooooooooooooo`00o`?o
oooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0Booooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool01?ooool01?ooH@;oooooooooooooool2o`3jVP?ooooo00?o003ooooo
ool00?l00oooool2o`3jVPGooooo00?o003oooooooooH@804oooool00oooH@;oooooooooo`0Ooooo
o`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool04Oooool2oomQ0P;ooooo00?oof42oooo
ooooool04oooool00oooH@;oooooooooo`04ooooo`04oomQ0_oooooo003oo`00o`kooooo00?o003o
ooooool00?l00oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00gooooo00Co003o
oooooooooooo003o0oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo00Gooooo00?o
of42ooooooooool00_ooool00oooH@;oooooooooo`04ooooo`03o`000?oooooooooo013ooooo000Z
ooooo`03o`000?oooooooooo00?ooooo00Coof42oooooooooooooooo1Ol0nYX2ooooo`03o`00oooo
oooo003o00?ooooo00?o003oooooooooool00oooool00ol00?ooof42ooooo`0?ooooo`03oomQ0_oo
oooooooo06Kooooo1?ooH@82ooooo`03o`00oooooooooooo00cooooo00?o003oooooool00?l00ooo
ool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00gooooo00Co003ooooooooooooo003o
1?ooH@8Cooooo`03oomQ0_oooooooooo01;ooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`04ooooo`04oomQ0_ooooooooooooooo`?o0?ZJ0_ooool00ol00?ooooooo`00o`03ooooo`;o
0?ZJ1Oooool00ol00?oooooooomQ0P0Dooooo`03oomQ0_oooooooooo01gooooo00?oof42oooooooo
ool03oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooooooo
ool04Oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooo003o00kooooo00?o003oooooool0
0?l00oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00gooooo00Co003ooooooooo
oooo003o0oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooooooo00Cooooo00?oof42oooo
ooooool00oooool00oooH@;oooooooooo`04ooooo`03o`000?oooooooooo013ooooo000Zooooo`;o
00001?ooool01?ooH@;oooooooooooooool4o`3jVP?ooooo00?o003oooooool00?l00oooool00ol0
0?ooooooooooo`03ooooo`03o`00ooooH@;ooooo00oooooo00?oof42ooooooooool0I?ooool2oomQ
0PCooooo00?oof42ooooool00?l03_ooool00ol00?ooooooo`00o`03ooooo`03oomQ0_oooooooooo
00oooooo00?oof42ooooooooool03Oooool01?l00?ooooooo`00ooooH@8Gooooo`03oomQ0_oooooo
oooo017ooooo0_l0000Nooooo`03o`000?oooooooooo00Cooooo00?oof42ooooooooool00_ooool2
o`3jVP;ooooo00?o003oooooool00?l00oooool2o`3jVPGooooo00?o003ooomQ0_ooool05?ooool0
0oooH@;oooooooooo`0Looooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool03oooool0
0oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool01oooool0
0oooH@;oooooo`00o`0>ooooo`03o`00oooooooo003o00?ooooo00?oof42ooooooooool04?ooool0
0oooH@;oooooooooo`0<ooooo`03o`00oooooooo003o00Cooooo00?oof42ooooooooool04_ooool0
0oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool00_ooool2
o`0001;ooooo000Zooooo`03o`000?oooooooooo00?ooooo00?oof42ooooooooool00_ooool3o`3j
VP?ooooo00?o003oooooool00?l00oooool00ol00?ooooooooooo`03ooooo`03o`00ooooH@;ooooo
00oooooo00?oof42ooooooooool0H_ooool2oomQ0POooooo00?oof42o`00ooooool03Oooool2o`00
o`Cooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0<ooooo`03o`00ooooooooof42
01Sooooo00?oof42ooooooooool04_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Cooooo00?oof42ooooooooool00_ooool2o`3jVP;ooooo00?o003oooooool00?l00_ooool3o`3j
VPGooooo00?o003ooomQ0_ooool05?ooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo
01;ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo
00kooooo00?oof42ooooooooool02Oooool00oooH@;o003oooooo`0=ooooo`;o003o1?ooool00ooo
H@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooool00?l00oooool00ooo
H@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooooooo`03ooooo`03o`000?oooooooooo013ooooo000Zooooo`03o`000?oooooooooo00?o
oooo00?oof42ooooooooool00_ooool2o`3jVPCooooo00?o003oooooool00?l00oooool00ol00?oo
ooooooooo`03ooooo`03o`00ooooH@;ooooo00oooooo00?oof42ooooooooool08Oooool4oomQ0Sgo
oooo00?oof42ooooooooool01oooool3oomQ0Pgooooo00?o003oooooooooool00_ooool00oooH@;o
ooooooooo`0@ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooH@806?ooool00oooH@;o
ooooooooo`0Booooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01?ooool00oooH@;o
ooooooooo`02ooooo`?o0?ZJ00Coooooo`00oooooooo003o0_ooool2o`3jVP03o`00oooooooooooo
00?ooooo00?o003ooomQ0_ooool05?ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooooooo
01?ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool02Oooool00oooH@;o003oooooo`0>ooooo`03o`00oooooooooooo
00;ooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0<ooooo`03o`00oooooooo003o
00;ooooo00?oof42ooooooooool05Oooool01OooH@;oooooooooooooooooof4200Wooooo00?oof42
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003oooooooooo`03oooo
o`03oomQ0_oooooooooo00Sooooo00?o003oooooool00?l01?ooool00ol00?ooooooooooo`02oooo
o`03o`00ooooH@;ooooo00oooooo00?oof42ooooooooool07oooool2oomQ0PCooooo0_ooH@8joooo
o`03oomQ0_oooooooooo00_ooooo0_ooH@8;ooooo`03o`00oooooooooooo00;ooooo00?oof42oooo
ooooool04?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_l00?oooooo01Sooooo00?oof42oooo
ooooool04Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Cooooo00?oof42oooo
ooooool00oooool2o`3jVP;ooooo0_l00?l2ooooo`;o0?ZJ00?oooooo`00ooooool00oooool00ol0
0?ooof42ooooo`0Dooooo`03oomQ0_oooooooooo01[ooooo00?oof42ooooooooool04oooool00ooo
H@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool03?ooool00ooo
H@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00gooooo00?o003oooooooooool00_ooool00ooo
H@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00gooooo0_l00?l2oomQ0QSooooo00Coof42oooo
ooooH@;oof422_ooool00oooH@;oooooooooo`02ooooo`03o`000?oooooooooo013ooooo000Zoooo
o`;o00001?ooool00oooH@;oooooooooo`08ooooo`;o003o1Oooool00ol00?ooooooooooo`02oooo
o`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool07Oooool2oomQ0PSooooo0oooH@8foooo
o`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool02?ooool00ol00?ooooooooooo`02oooo
o`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool03Oooool00oooH@;o003oooooo`0Hoooo
o`03oomQ0_oooooooooo013ooooo0_l0000Nooooo`03o`000?oooooooooo00Cooooo00?oof42oooo
ooooool00oooool2o`3jVP;ooooo0_l00?l01_oooooo0?ZJo`3jV_l0nY[oooooo`00o`Cooooo00?o
003ooomQ0_ooool05?ooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo01Cooooo00?o
of42ooooooooool03_ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00cooooo00?o
of42ooooooooool02oooool00oooH@;oooooooooo`0=ooooo`03o`00oooooooooooo00;ooooo00?o
of42ooooooooool04?ooool00oooH@;oooooooooo`0=ooooo`03o`00ooooH@;ooooo01[ooooo00?o
of42ooooooooool02_ooool01?ooH@;oooooooooooooool2o`0001;ooooo000Zooooo`03o`000?oo
oooooooo00?ooooo00?oof42ooooooooool02?ooool2o`00o`Gooooo00?o003oooooooooool00_oo
ool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo01_ooooo00?oof42ooooooooool02ooo
ool2oomQ0SCooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`07ooooo`03o`00oooo
oooooooo00;ooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_l0
0?oo003o01Wooooo00?oof42ooooooooool04Oooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Cooooo00?oof42ooooooooool00oooool3o`3jVP04ooooool00?oo003oooooo`;o0?ZJ
0_ooool00ol00?ooooooooooo`02ooooo`03o`00ooooH@;ooooo01Cooooo00?oof42ooooooooool0
6?ooool00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool0
2?ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0
3?ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool0
3Oooool00ol00?ooof42ooooo`0Wooooo`03oomQ0_oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool002[ooooo00?o0000ooooooooool00oooool00oooH@;oooooooooo`09ooooo`03o`00oooo
oooooooo00?ooooo00?o003oooooooooool00_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oo
oooooooo01[ooooo00?oof42ooooooooool03_ooool3oomQ0R7ooooo0_ooH@8=ooooo`03oomQ0_oo
oooooooo017ooooo00?oof42ooooooooool01_ooool00ol00?ooooooooooo`02ooooo`03oomQ0_oo
oooooooo013ooooo00?oof42ooooooooool03?ooool00oooH@;o003oo`00o`0Iooooo`03oomQ0_oo
oooooooo017ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`04ooooo`03oomQ0_oo
oooooooo00Cooooo0_l0nYX01?oooooo003oooooooooool2o`3jVP;ooooo00?o003oooooooooool0
0_ooool00ol00?ooof42ooooo`0Dooooo`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool0
5Oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool0
2_ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00cooooo00?o003oooooooooool0
0_ooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00cooooo00?oof42o`00ooooool0
:?ooool01OooH@;ooooooooooooooooo000001;ooooo000Zooooo`03o`000?oooooooooo00?ooooo
00?oof42ooooooooool02Oooool00ol00?ooooooooooo`03ooooo`06o`00ooooooooooooooooool0
0?ooof424_ooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo01;ooooo0oooH@8Moooo
o`04oomQ0_oooooooooooomQ0P_ooooo00?oof42ooooooooool04oooool3oomQ0P[ooooo00?oof42
ooooooooool04Oooool00oooH@;oooooooooo`0:ooooo`04oomQ0_oooooo003oo`00oaWooooo00?o
of42ooooooooool04Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Gooooo00?o
of42ooooooooool00oooool2o`3jVP03ooooool00?oooooo00?o0?ZJ0_ooool01_l00?oooooooooo
oooooooo003ooomQ0QKooooo00?oof42ooooooooool05oooool00oooH@;oooooooooo`0Gooooo`03
oomQ0_oooooooooo00_ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`03ooooo`Oo
of424?ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo01;ooooo00?oof42oooooooo
ool02oooool00oooH@;o003oo`00o`0Yooooo`05oomQ0_ooooooooooooooool000004_ooool002[o
oooo0_l00004ooooo`03oomQ0_oooooooooo00Wooooo00?o003oooooooooool01?ooool01Ol00?oo
ooooooooool00?ooof4201;ooooo00?oof42ooooooooool06Oooool00oooH@;oooooooooo`0Eoooo
o`Goof425_ooool2oomQ0PCooooo2_ooH@800oooooooof42ooooo`0Gooooo`;oof422?ooool00ooo
H@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00[ooooo00Coof42oooooooooooo003o6_ooool0
0oooH@;oooooooooo`0?ooooo`;o00007_ooool00ol0003oooooooooo`05ooooo`03oomQ0_oooooo
oooo00?ooooo0ol0nYX01?l00?oo0?ZJo`3jV_l0nYX4ooooo`05o`00ooooooooooooo`00ooooH@80
5_ooool00oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool0
2oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_ooooooof4200;oof425oooool00oooH@;ooooo
ooooo`0?ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool02oooool00oooH@;ooooo
o`00o`0Yooooo`03oomQ0_oooooooooo00;o00004_ooool002[ooooo00?o0000ooooooooool00ooo
ool00oooH@;oooooooooo`09ooooo`03o`00oooooooooooo00Cooooo00Go003ooooooooooooo003o
oomQ0P0Booooo`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool06oooool00oooH@;ooooo
ooooo`0Booooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool06Oooool9oomQ0Q?ooooo
00?oof42ooooooooool02_ooool01?ooH@;oooooooooool00?lJooooo`03oomQ0_oooooooooo013o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`05ooooo`03oomQ0_oooooooooo00Co
oooo1_l0nYX4ooooo`05o`00ooooooooooooo`00ooooH@805oooool00oooH@;oooooooooo`0Doooo
o`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0=oooo
o`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Boooo
o`03oomQ0_oooooooooo00[ooooo00Coof42oooooooooooo003o:Oooool01OooH@;ooooooooooooo
oooo000001;ooooo000Eooooo`?o00001?ooool00ol0003oooooooooo`02ooooo`?o00001_ooool0
0ol0003oooooooooo`03ooooo`03oomQ0_oooooooooo013ooooo00Go003ooooooooooooo003ooomQ
0P0Cooooo`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool06oooool00oooH@;ooooooooo
o`0Aooooo`03oomQ0_oooooooooo04Oooooo00?oof42ooooooooool02Oooool00oooH@;ooooooooo
o`0Looooo`03oomQ0_oooooooooo013ooooo00?o0000ooooooooool01oooool3o`0000Cooooo00?o
0000ooooooooool00_ooool3o`0000Kooooo00?o0000ooooooooool01Oooool00oooH@;ooooooooo
o`04ooooo`Co0?ZJ1_ooool01Ol00?ooooooooooool00?ooof4201Oooooo00?oof42ooooooooool0
5?ooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool0
:Oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool0
2Oooool00oooH@;oooooooooo`0Zooooo`05oomQ0_ooooooooooooooool000004_ooool001Kooooo
00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000oooooooo
ool00oooool00oooH@;oooooooooo`0@ooooo`05o`00ooooooooooooo`00ooooH@804oooool00ooo
H@;oooooooooo`0Fooooo`03oomQ0_oooooooooo01cooooo00?oof42ooooooooool04Oooool00ooo
H@;oooooooooo`18ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool07?ooool00ooo
H@;oooooooooo`0@ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool01Ol0
003ooooooooooooooooo000000Gooooo00?o0000ooooooooool01Oooool00oooH@;oooooooooo`05
ooooo`;o0?ZJ1oooool01Ol00?ooooooooooool00?ooof4201Oooooo00?oof42ooooooooool04ooo
ool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool0:ooo
ool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool02?oo
ool00oooH@;oooooooooo`0/ooooo`04oomQ0_ooooooooooo`0001;ooooo000Fooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00?oof42ooooooooool04Ooo
ool01?l00?ooooooo`00ooooH@8Dooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool0
7Oooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo04Wooooo00?oof42ooooooooool0
2?ooool00oooH@;oooooooooo`0Looooo`03oomQ0_oooooooooo00kooooo0ol0000:ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool00oooool2o`0000Kooooo00?oof42ooooooooool0
3oooool01?l00?ooooooo`00ooooH@8Gooooo`03oomQ0_oooooooooo01?ooooo00?oof42oooooooo
ool06oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo02_ooooo00?oof42oooooooo
ool03Oooool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo00Sooooo00?oof42oooooooo
ool0;?ooool01?ooH@;o0000o`000?l0000Booooo`005_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00oooH@;oooooooooo`0Aooooo`03
o`00ooooH@;ooooo01Cooooo00Coof42ooooooooooooof424oooool00oooH@;oooooooooo`0Noooo
o`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool0B_ooool00oooH@;oooooooooo`08oooo
o`03oomQ0_oooooooooo01gooooo00?oof42ooooooooool03?ooool01?ooH@;oooooooooool0000:
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05
ooooo`03oomQ0_oooooooooo013ooooo0_l00?l00oooH@;oooooooooo`0Eooooo`03oomQ0_oooooo
oooo01;ooooo00?oof42ooooooooool07?ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooo
oooo02_ooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooo
oooo00Oooooo00?oof42ooooooooool0;?ooool01?ooH@;oooooooooool0000Booooo`005_ooool0
0ol0003oooooooooo`07ooooo`Co00001_ooool00ol0003oooooooooo`04ooooo`03oomQ0_oooooo
oooo017ooooo00?o003ooomQ0_ooool05?ooool01?ooH@;ooooooomQ0_ooH@8Booooo`03oomQ0_oo
oooooooo01oooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`1<ooooo`03oomQ0_oo
oooooooo00Oooooo00?oof42ooooooooool07Oooool00oooH@;oooooooooo`0<ooooo`04oomQ0_oo
ooooooooo`0000[ooooo00?o0000ooooooooool01oooool4o`0000Kooooo00?o0000ooooooooool0
1_ooool00oooH@;oooooooooo`0?ooooo`;o003o00?oof42ooooooooool05Oooool00oooH@;ooooo
ooooo`0Booooo`03oomQ0_oooooooooo01gooooo00?oof42ooooooooool01_ooool00oooH@;ooooo
ooooo`0]ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool05Oooool00oooH@;ooooo
ooooo`06ooooo`03oomQ0_oooooooooo033ooooo00?o0000ooooooooool04?ooool001Gooooo0_l0
0009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00oooH@;ooooooooo
o`0Booooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooH@804_ooool00oooH@;ooooooooo
o`0Oooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0COooool00oooH@;ooooooooo
o`06ooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool02oooool01OooH@;ooooooooo
oooooooo000000Wooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1_ooool00oooH@;oooooooooo`0@ooooo`03o`00ooooH@;ooooo01Kooooo00?oof42ooooooooool0
4Oooool00oooH@;oooooooooo`0Nooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0
;Oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool0
1_ooool00oooH@;oooooooooo`0`ooooo`03o`000?oooooooooo013ooooo000Fooooo`03o`000?oo
oooooooo00Oooooo1Ol00005ooooo`;o00001Oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oo
oooooooo01Oooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Qooooo`03oomQ0_oo
oooooooo00Wooooo0_ooH@9@ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool07ooo
ool00oooH@;oooooooooo`08ooooo`;oof420oooool2o`0000[ooooo00?o0000ooooooooool01ooo
ool5o`0000Gooooo00?o0000ooooooooool01_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oo
oooooooo01Oooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oo
oooooooo00Gooooo00?oof42ooooooooool0;_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oo
oooooooo01Kooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0_ooooo`;o00004_oo
ool002[ooooo00?o0000ooooooooool01?ooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooo
oooo01Oooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Qooooo`03oomQ0_oooooo
oooo00Sooooo00?oof42ooooooooool0DOooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooo
oooo01oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`04ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool01_ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooo
oooo01Oooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Pooooo`03oomQ0_oooooo
oooo00?ooooo00?oof42ooooooooool0<?ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooo
oooo01Kooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0aooooo`03o`000?oooooo
oooo013ooooo000Zooooo`03o`000?oooooooooo00Cooooo00?oof42ooooooooool04Oooool00ooo
H@;oooooooooo`0Hooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool08oooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo05;ooooo00?oof42ooooooooool01?ooool00ooo
H@;oooooooooo`0Pooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01Oooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Kooooo00?oof42ooooooooool04?ooool00ooo
H@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool08Oooool3oomQ
0P03ooooooooH@;oof4203?ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0Foooo
o`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool0<Oooool00ol0003oooooooooo`0@oooo
o`00:_ooool00ol0003oooooooooo`04ooooo`03oomQ0_oooooooooo017ooooo00?oof42oooooooo
ool06?ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo02Cooooo00?oof42oooooooo
ool01?ooool00oooH@;oooooooooo`1Dooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooooooo
ool08Oooool2oomQ0PGooooo00?oof42ooooooooool01_ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Kooooo00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0Gooooo`03
oomQ0_oooooooooo00kooooo00?oof42ooooooooool09?ooool00oooH@;oooooooooo`0dooooo`03
oomQ0_oooooooooo00Wooooo00?oof42ooooooooool05_ooool00oooH@;oooooooooo`04ooooo`03
oomQ0_oooooooooo037ooooo00?o0000ooooooooool04?ooool002[ooooo0_l00005ooooo`03oomQ
0_oooooooooo013ooooo00?oof42ooooooooool06Oooool00oooH@;oooooooooo`0=ooooo`03oomQ
0_oooooooooo02Gooooo1_ooH@9Gooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool0
8oooool00oooH@;oooooooooo`02oomQ0PSooooo0_l0000Nooooo`03o`000?oooooooooo00Kooooo
00?oof42ooooooooool04?ooool00oooH@;oooooooooo`0Gooooo`03oomQ0_oooooooooo00gooooo
00?oof42ooooooooool0G?ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo01Oooooo
00?oof42ooooooooool00oooool00oooH@;oooooooooo`0`ooooo`;o00004_ooool002[ooooo00?o
0000ooooooooool01?ooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo01[ooooo00?o
of42ooooooooool02oooool00oooH@;oooooooooo`24ooooo`05oomQ0_ooooooooooooooooooH@80
9oooool2oomQ0P_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`03oomQ
0_oooooooooo00oooooo00?oof42ooooooooool06?ooool00oooH@;oooooooooo`0<ooooo`03oomQ
0_oooooooooo05cooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Hooooo`03oomQ
0_oooooooooo00;ooooo00?oof42ooooooooool0<_ooool00ol0003oooooooooo`0@ooooo`00:_oo
ool00ol0003oooooooooo`04ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool06ooo
ool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo08Gooooo00Coof42ooooooooooooof42
=?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo00?oof42ooooooooool0
3_ooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool0
GOooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo01Sooooo00?oof42ooooooooool0
0_ooool00oooH@;oooooooooo`0booooo`03o`000?oooooooooo013ooooo000Zooooo`03o`000?oo
oooooooo00Cooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oo
oooooooo00[ooooo00?oof42ooooooooool0Qoooool00oooH@;ooooooomQ0P0dooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool01oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oo
oooooooo01Wooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`1Nooooo`03oomQ0_oo
oooooooo00Oooooo00?oof42ooooooooool06?ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oo
oooooooo03;ooooo00?o0000ooooooooool04?ooool002[ooooo0_l00005ooooo`03oomQ0_oooooo
oooo00oooooo00?oof42ooooooooool06oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooo
oooo08Wooooo00?oof42ooooooooool0<_ooool2o`0001kooooo00?o0000ooooooooool01oooool0
0oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo01Wooooo00?oof42ooooooooool02oooool0
0oooH@;oooooooooo`1Oooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool06Oooool0
1OooH@;oooooooooooooooooof4203?ooooo0_l0000Booooo`00:_ooool00ol0003oooooooooo`04
ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool07?ooool00oooH@;oooooooooo`09
ooooo`03oomQ0_oooooooooo0;oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07
ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool06Oooool00oooH@;oooooooooo`0:
ooooo`03oomQ0_oooooooooo067ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0I
ooooo`Coof42=Oooool00ol0003oooooooooo`0@ooooo`00:_ooool00ol0003oooooooooo`05oooo
o`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool07Oooool00oooH@;oooooooooo`07oooo
o`03oomQ0_oooooooooo0<3ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07oooo
o`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool06oooool00oooH@;oooooooooo`08oooo
o`03oomQ0_oooooooooo06;ooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`0Moooo
o`03oomQ0_oooooooooo03?ooooo00?o0000ooooooooool04?ooool002[ooooo00?o0000oooooooo
ool01Oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01gooooo00?oof42oooooooo
ool01oooool00oooH@;oooooooooo`30ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool01oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01_ooooo00?oof42oooooooo
ool02?ooool00oooH@;oooooooooo`1Sooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooooooo
ool0Doooool00ol0003oooooooooo`0@ooooo`00:_ooool2o`0000Kooooo00?oof42ooooooooool0
3Oooool00oooH@;oooooooooo`0Mooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0
`?ooool2o`0001kooooo00?o0000ooooooooool01oooool00oooH@;oooooooooo`0=ooooo`03oomQ
0_oooooooooo01_ooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`1Tooooo`03oomQ
0_oooooooooo00?ooooo00?oof42ooooooooool0D_ooool2o`0001;ooooo000Zooooo`03o`000?oo
oooooooo00Gooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`0Mooooo`03oomQ0_oo
oooooooo00Kooooo00?oof42ooooooooool0`Oooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Sooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0Looooo`03oomQ0_oo
oooooooo00Kooooo00?oof42ooooooooool0IOooool01OooH@;oooooooooooooooooof4205Kooooo
00?o0000ooooooooool04?ooool0023ooooo1Ol00005ooooo`03o`000?oooooooooo00Gooooo00?o
of42ooooooooool03?ooool00oooH@;oooooooooo`0Oooooo`03oomQ0_oooooooooo00Cooooo00?o
of42ooooooooool0`_ooool00ol0003oooooooooo`0Booooo`Go00001Oooool00ol0003ooooooooo
o`08ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool07?ooool00oooH@;ooooooooo
o`05ooooo`03oomQ0_oooooooooo06Oooooo1?ooH@9Fooooo`03o`000?oooooooooo013ooooo000Q
ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool000001_ooool00oooH@;ooooooooo
o`0;ooooo`03oomQ0_oooooooooo01_ooooo00Go0000oooooooooooooooooomQ0P05ooooo`03oomQ
0_oooooooooo02Oooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo033ooooo00Co0000oooooooooooo00005Oooool01?l0003oooooooooool00005oooo
o`03o`000?oooooo000000Sooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Ioooo
o`05o`000?ooooooooooooooooooH@801_ooool00oooH@;oooooooooo`0Uooooo`03o`000?oooooo
oooo037ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`04o`000?oooooo
ooooo`0001;ooooo000Rooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000001_ooool0
0oooH@;oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?oof42ooooooooool00_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooooooooomQ
0P04ooooo`05oomQ0_ooooooooooooooool000003?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00[ooooo00Co0000oooooooooooo00005_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooo000000Sooooo00Goof42ooooooooooooooooo`000009ooooo`04oomQ0_oooooooooo
o`0000_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`03oomQ0_oooooo
oooo00;ooooo00Coof42oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00004_ooool002?ooooo00?o0000ooooooooool01?oo
ool9o`000003oomQ0_l0003o000000[o000000?oof42o`000?l000008Ol000001?ooH@;o0000o`00
0?ooH@;8o`0001Oooooo00?o0000ooooooooool01?ooool;o`000003oomQ0_l0003o000000_o0000
00?oof42o`000?l000007_l000001OooH@;o0000o`000?l0003oof420<Oo00004_ooool0023ooooo
00Go0000ooooooooooooooooo`00003oooooob3ooooo00Go0000ooooooooooooooooo`00003ooooo
oakooooo000Pooooo`05o`000?ooooooooooooooool00000oooooolPooooo`05o`000?oooooooooo
ooooool00000oooooolNooooo`008Oooool3o`000?oooooo8_ooool3o`000?oooooo7oooool00?oo
oooooooooomXooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool00?oooooooooooomX
ooooo`00ooooooooooooofSooooo000aooooo`;o0000;_ooool5o`0002oooooo0ol0000^ooooo`?o
0000;oooool3o`0002cooooo0ol00004ooooo`;o00009Oooool2o`0002kooooo1Ol0000_ooooo`?o
0000;_ooool3o`0002oooooo0ol0000/ooooo`?o00001?ooool2o`0001;ooooo000`ooooo`04o`00
0?ooooooooooo`0002kooooo00Co0000oooooooooooo0000<?ooool00ol0003oooooooooo`0/oooo
o`05o`000?ooooooooooooooool00000;Oooool01Ol0003ooooooooooooooooo000002cooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool0000Sooooo`04o`000?ooooooooooo`0002ko
oooo00Co0000oooooooooooo0000<?ooool00ol0003oooooooooo`0/ooooo`05o`000?oooooooooo
ooooool00000;Oooool01Ol0003ooooooooooooooooo000002cooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool0000Aooooo`00<?ooool01?l0003oooooooooool0000_ooooo`03o`00
0?oooooooooo02gooooo1Ol0000]ooooo`05o`000?ooooooooooooooool00000;Oooool01Ol0003o
oooooooooooooooo000002cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000S
ooooo`04o`000?ooooooooooo`0002oooooo00?o0000ooooooooool0;Oooool5o`0002gooooo00Go
0000ooooooooooooooooo`00000]ooooo`05o`000?ooooooooooooooool00000;?ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`00017ooooo000`ooooo`04o`000?ooooooooooo`00
033ooooo00?o0000ooooooooool0;?ooool01?l0003oooooooooool0000^ooooo`Co0000;oooool3
o`0002gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Sooooo`04o`000?oo
ooooooooo`00033ooooo00?o0000ooooooooool0;?ooool01?l0003oooooooooool0000^ooooo`Co
0000;oooool3o`0002gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Aoooo
o`00<?ooool01?l0003oooooooooool0000]ooooo`05o`000?ooooooooooooooool00000;_ooool0
0ol0003oooooo`00000^ooooo`03o`000?oooooooooo02oooooo00Go0000ooooooooooooooooo`00
000/ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00008oooool01?l0003ooooo
ooooool0000]ooooo`05o`000?ooooooooooooooool00000;_ooool00ol0003oooooo`00000^oooo
o`03o`000?oooooooooo02oooooo00Go0000ooooooooooooooooo`00000/ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00004Oooool0033ooooo00Co0000oooooooooooo0000;Ooo
ool01Ol0003ooooooooooooooooo000002oooooo0_l0000_ooooo`03o`000?oooooooooo02kooooo
00Go0000ooooooooooooooooo`00000[ooooo`;o00001?ooool01?l0003oooooooooool0000Soooo
o`04o`000?ooooooooooo`0002gooooo00Go0000ooooooooooooooooo`00000_ooooo`;o0000;ooo
ool00ol0003oooooooooo`0^ooooo`05o`000?ooooooooooooooool00000:oooool2o`0000Cooooo
00Co0000oooooooooooo00004Oooool0037ooooo0_l0000_ooooo`?o0000<Oooool00ol0003ooooo
ooooo`0^ooooo`;o0000;oooool3o`0002gooooo00?o0000ooooooooool00oooool2o`0002Gooooo
0_l0000_ooooo`?o0000<Oooool00ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0002gooooo
00?o0000ooooooooool00oooool2o`0001;ooooo003oooooooooooooJ?ooool00?oooooooooooomX
ooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool0033oooooool00001o`0002?ooooo
ool00002o`0001;ooooo000`ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool01?l0003oooooooooool0000Sooooo`04o`000?ooooooooooo`0000_ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool01?l0003oooooooooool0000Booooo`00<?ooool00ol0003oooooo`00000aooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_ooooo`03
o`000?oooooooooo02oooooo00Co0000oooooooooooo00008oooool01?l0003oooooooooool0000a
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo02oooooo00Co0000oooooooooooo00004_ooool0033ooooo00?o0000
ooooooooool0o?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo00?o0000
ooooooooool04?ooool0033ooooo0_l0003looooo`;o00008oooool2o`000?gooooo0_l0000Boooo
o`00<?ooool00ol0003oooooooooo`3looooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0oOooool00ol0003oooooooooo`0@ooooo`00<?ooool00ol0003oooooooooo`3looooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`0@ooooo`00<?oo
ool00ol0003oooooooooo`3looooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oOoo
ool00ol0003oooooooooo`0@ooooo`00<?ooool2o`000?cooooo0_l0000Sooooo`;o0000oOooool2
o`0001;ooooo000`ooooo`03o`000?oooooooooo0?cooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000`ooooo`03o`000?oooooooooo0?co
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo013o
oooo000`ooooo`03o`000?oooooooooo0?cooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`3mooooo`03o`000?oooooooooo013ooooo000`ooooo`;o0000o?ooool2o`0002?ooooo0_l0
003mooooo`;o00004_ooool0033ooooo00?o0000ooooooooool0o?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo0?gooooo00?o0000ooooooooool04?ooool0033ooooo00?o0000oooo
ooooool0o?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo00?o0000oooo
ooooool04?ooool0033ooooo00?o0000ooooooooool0o?ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo0?gooooo00?o0000ooooooooool04?ooool0033ooooo0_l0003looooo`;o0000
8oooool2o`000?gooooo0_l0000Booooo`00<?ooool00ol0003oooooooooo`3looooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`0@ooooo`005_ooool2
o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`?o00001_ooool0
0ol0003oooooooooo`3looooo`03o`000?oooooooooo00Sooooo0_l00004ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0oOooool0
0ol0003oooooooooo`0@ooooo`005Oooool01?l0003oooooooooool00009ooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?cooooo00?o
0000ooooooooool01oooool01?l0003oooooooooool00009ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?gooooo00?o0000oooooooo
ool04?ooool000kooooo1Ol00002ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`03ooooo`;o0000noooool3o`0000;ooooo1Ol00002ooooo`04
o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02oooo
o`?o0000noooool3o`0001;ooooo000Eooooo`04o`000?ooooooooooo`0000[ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?cooooo00?o0000oooo
ooooool01oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000Eoooo
o`04o`000?ooooooooooo`0000_ooooo00?o0000ooooool000000ol00006ooooo`03o`000?oooooo
oooo0?cooooo00?o0000ooooooooool01oooool01?l0003oooooooooool0000;ooooo`03o`000?oo
oooo000000?o00001Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000E
ooooo`04o`000?ooooooooooo`0000Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000Wo
oooo00?o0000ooooooooool0o?ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`00
00Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000Sooooo00?o0000ooooooooool00_oo
ool4oomQ0_Oooooo00?o0000ooooooooool04?ooool001Kooooo0_l00008ooooo`Go000000?ooooo
o`000?l000000ol00005ooooo`;o0000o?ooool2o`0000[ooooo0_l00008ooooo`Go000000?ooooo
o`000?l000000ol00004ooooo`;o00000oooool01?ooH@;oooooooooooooH@;fooooo`;o00004_oo
ool0033ooooo00?o0000ooooooooool00_ooool3oomQ0_Oooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`02ooooo`05oomQ0_ooooooooooooooooooH@80m_ooool00ol0003ooooooooo
o`0@ooooo`00<?ooool00ol0003oooooooooo`02ooooo`04oomQ0_oooooooooooomQ0_Kooooo00?o
0000ooooooooool08Oooool01Ol0003oooooooooooooooooof4200Cooooo00?oof42ooooooooool0
m?ooool00ol0003oooooooooo`0@ooooo`00<?ooool01Ol0003oooooooooooooooooof4200Cooooo
00?oof42ooooooooool0loooool00ol0003oooooooooo`0Qooooo`05o`000?oooooooooooooooooo
H@801Oooool00oooH@;oooooooooo`3cooooo`03o`000?oooooooooo013ooooo000`ooooo`;o0000
0_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo0?7ooooo0_l0000Sooooo`;o0000
0_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo0?;ooooo0_l0000Booooo`00<?oo
ool01?l0003oooooooooooooH@86ooooo`03oomQ0_oooooooooo0?;ooooo00?o0000ooooooooool0
8Oooool01Ol0003oooooooooooooooooof4200Kooooo00?oof42ooooooooool0l_ooool00ol0003o
ooooooooo`0@ooooo`00<?ooool01?l0003oooooooooooooH@87ooooo`03oomQ0_oooooooooo0?7o
oooo00?o0000ooooooooool08Oooool01?l0003oooooooooooooH@87ooooo`03oomQ0_oooooooooo
0?;ooooo00?o0000ooooooooool04?ooool0033ooooo00Co0000ooooooooooooof421oooool00ooo
H@;oooooooooo`3aooooo`03o`000?oooooooooo027ooooo00Co0000ooooooooooooof421oooool0
0oooH@;oooooooooo`3booooo`03o`000?oooooooooo013ooooo000`ooooo`;o000000?oof42oooo
ooooool01_ooool00oooH@;oooooooooo`3`ooooo`;o00008oooool2o`0000[ooooo00?oof42oooo
ooooool0l?ooool2o`0001;ooooo000`ooooo`03o`000?oooooooooo00Wooooo00?oof42oooooooo
ool0l?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wooooo00?oof42oooooooo
ool0lOooool00ol0003oooooooooo`0@ooooo`00<?ooool00ol0003oooooooooo`09ooooo`03oomQ
0_oooooooooo0?3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`09ooooo`03oomQ
0_oooooooooo0?7ooooo00?o0000ooooooooool04?ooool0033ooooo00?o0000ooooooooool02Ooo
ool00oooH@;oooooooooo`3`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02_oo
ool00oooH@;oooooooooo`3`ooooo`03o`000?oooooooooo013ooooo000`ooooo`;o00002_ooool0
0oooH@;oooooooooo`3_ooooo`;o00008oooool2o`0000_ooooo00?oof42ooooooooool0koooool2
o`0001;ooooo000Looooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001_ooool00ol0
003oooooooooo`0:ooooo`03oomQ0_oooooooooo0>oooooo00?o0000ooooooooool03_ooool2o`00
00Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool00oooool3o`3j
VPCooooo00?oof42ooooooooool0l?ooool00ol0003oooooooooo`0@ooooo`006oooool01?l0003o
ooooooooool00007ooooo`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`0:
ooooo`03oomQ0_oooooooooo0>oooooo00?o0000ooooooooool03Oooool01?l0003oooooooooool0
0007ooooo`05o`000?ooooooooooooooool000001?ooool01?l0003oooooooooooooool5o`3jVPGo
oooo00?oof42ooooooooool0koooool00ol0003oooooooooo`0@ooooo`005?ooool5o`0000;ooooo
00Co0000oooooooooooo00002oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00[o
oooo00?oof42ooooooooool0koooool00ol0003oooooooooo`06ooooo`Go00000_ooool01?l0003o
ooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooooooo1_l0nYX4
ooooo`03oomQ0_oooooooooo0>oooooo00?o0000ooooooooool04?ooool001_ooooo00Co0000oooo
oooooooo00002oooool00ol0003oooooooooo`03ooooo`;o00000_ooool3o`3jVPOooooo00?oof42
ooooooooool0k?ooool3o`0000oooooo00Co0000oooooooooooo00002oooool00ol0003ooooooooo
o`02ooooo`?o000000?oooooo`3jV_l0nYX00_ooool2o`3jVPCooooo00?oof42ooooooooool0kOoo
ool3o`0001;ooooo000Kooooo`04o`000?ooooooooooo`0000Oooooo1?l00006ooooo`04o`000?oo
ooooooooooooo`Co0?ZJ1_ooool00oooH@;oooooooooo`3^ooooo`03o`000?oooooooooo00gooooo
00Co0000oooooooooooo00001oooool4o`0000Gooooo00?o0000ooooooooool00ol0nYX2ooooo`?o
0?ZJ0oooool00oooH@;oooooooooo`3_ooooo`03o`000?oooooooooo013ooooo000Kooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05o`3jVPKo
oooo00?oof42ooooooooool0k_ooool00ol0003oooooooooo`0=ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02o`3jVPCooooo0_l0nYX3oooo
o`03oomQ0_oooooooooo0>oooooo00?o0000ooooooooool04?ooool001cooooo0_l00008ooooo`Go
00001Oooool00ol0003oooooooooo`02o`3jVP04ooooool0nY[o0?ZJo`3jVPGooooo00?oof42oooo
ooooool0/oooool4oomQ0SOooooo00?o0000ooooooooool03_ooool2o`0000Sooooo1Ol00004oooo
o`03o`000?oooooooooo00;o0?ZJ1?ooool3o`3jVP?ooooo00?oof42ooooooooool0k_ooool00ol0
003oooooooooo`0@ooooo`00<?ooool2o`0000?o0?ZJ0_ooool2o`3jVPKooooo00?oof42oooooooo
ool0/Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo03?ooooo0_l0000Sooooo`;o
000000?oooooo`3jV_l0nYX01Oooool2o`3jVP?ooooo00?oof42ooooooooool0kOooool2o`0001;o
oooo000`ooooo`Co00000oooool3o`3jVPGooooo00?oof42ooooooooool0/?ooool00oooH@;ooooo
ooooo`03ooooo`03oomQ0_oooooooooo03Cooooo00?o0000ooooooooool08Oooool00ol0003ooooo
o`000002o`0000Gooooo0_l0nYX3ooooo`03oomQ0_oooooooooo0>kooooo00?o0000ooooooooool0
4?ooool0033ooooo1Ol00003ooooo`;o0?ZJ1Oooool00oooH@;oooooooooo`2_ooooo`03oomQ0_oo
oooooooo00Cooooo00?oof42ooooooooool0=?ooool00ol0003oooooooooo`0Qooooo`Ko00001?oo
ool3o`3jVP;ooooo00?oof42ooooooooool07Oooool6oomQ0/_ooooo00?o0000ooooooooool04?oo
ool0033ooooo1Ol00003ooooo`;o0?ZJ0ol00?l3ooooo`03oomQ0_oooooooooo027ooooo0oooH@:9
ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool0=?ooool00ol0003oooooooooo`0Q
ooooo`Ko00001?ooool01?l00?oo0?ZJo`3jV_l00?l2ooooo`03oomQ0_oooooooooo01_ooooo00?o
of42ooooooooool01?ooool4oomQ0/Oooooo00?o0000ooooooooool04?ooool0033ooooo1Ol00002
o`00o`04ooooool0nY[o0?ZJo`3jVP;ooooo00Co003oooooooooooooof428oooool00oooH@;ooooo
ooooo`02oomQ0XOooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`0cooooo`;o0000
8oooool6o`0000;o003o00?oooooo`00ooooool00_l0nYX01?l00?ooooooooooooooH@8Looooo`03
oomQ0_oooooooooo00Wooooo00?oof42ooooooooool0`oooool2o`0001;ooooo000`ooooo`Co0000
00Goooooo`00oooooooo003oooooo`02o`3jVP?ooooo00?o003oooooooooH@808oooool00oooH@;o
ooooooooo`02ooooo`03oomQ0_oooooooooo08?ooooo00?oof42ooooooooool01_ooool00oooH@;o
ooooooooo`0dooooo`03o`000?oooooooooo027ooooo00?o0000ooooool000000_l000001?l00?oo
ooooooooool00?l2ooooo`?o0?ZJ00?o003oooooooooH@807?ooool00oooH@;oooooooooo`0:oooo
o`03oomQ0_oooooooooo08Kooooo0_ooH@8]ooooo`Goof422Oooool00ol0003oooooooooo`0@oooo
o`00<?ooool01Ol0003ooooooooooooooooo003o00Cooooo0_l0nYX4ooooo`03o`00ooooooooof42
027ooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`22ooooo`03oomQ0_oooooooooo
00Kooooo00?oof42ooooooooool0=?ooool00ol0003oooooooooo`0Qooooo`05o`000?oooooooooo
ooooool00?l01oooool2o`3jVP04ooooool00?oooooooomQ0Q[ooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`23ooooo`;oof4200?ooooooomQ0_ooool0:oooool00oooH@;ooooooooo
o`03ooooo`03oomQ0_oooooooooo00Kooooo00?o0000ooooooooool04?ooool0033ooooo00Co0000
oooooooooooo003o1Oooool3o`3jVP?ooooo00?o003oooooooooH@808Oooool3o`0000Gooooo00?o
of42ooooooooool0POooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo03?ooooo00?o
0000ooooooooool08Oooool01Ol0003ooooooooooooooooo003o00Oooooo0_l0nYX01?oooooo003o
ooooooooH@8Jooooo`03oomQ0_oooooooooo00Gooooo0ol00005ooooo`03oomQ0_oooooooooo05co
oooo1_ooH@8Pooooo`05oomQ0_ooooooooooooooooooH@80:_ooool00oooH@;oooooooooo`05oooo
o`03oomQ0_oooooooooo00Gooooo00?o0000ooooooooool04?ooool0033ooooo0_l000000ol00?oo
ooooooooo`05ooooo`;o0?ZJ0_ooool3o`000003oomQ0_oooooooooo01kooooo1Ol00005ooooo`03
oomQ0_oooooooooo06;ooooo2oooH@8Booooo`03oomQ0_oooooooooo00Sooooo00?oof42oooooooo
ool0<_ooool2o`0002?ooooo0_l000000ooooooo003oooooo`02ooooo`;oof420oooool2o`3jVP?o
000000?oof42ooooooooool05oooool00oooH@;oooooooooo`05ooooo`Go00001?ooool00oooH@;o
ooooooooo`1Jooooo`;oof421_ooool00oooH@;oooooooooo`0Looooo`03oomQ0_oooooooooo00;o
oooo00?oof42ooooooooool09oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00?o
oooo0_l0000Booooo`00<?ooool00ol0003oooooooooo`07ooooo`;o0?ZJ00?oooooo`000?l00000
0ol000000oooH@;oooooooooo`0Iooooo`Coof421Ol00005ooooo`03oomQ0_oooooooooo05gooooo
1OooH@8;ooooo`Coof423_ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo02?ooooo
0oooH@8=ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool00_ooool2oomQ0P03oooo
ooooH@;ooooo00?ooooo1Ol000000oooH@;oooooooooo`0Fooooo`03oomQ0_oooooooooo00Gooooo
1Ol00005ooooo`03oomQ0_oooooooooo05Sooooo00?oof42ooooooooool01_ooool00oooH@;ooooo
ooooo`0Kooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool09Oooool00oooH@;ooooo
ooooo`09ooooo`03oomQ0_oooooooooo00?ooooo00?o0000ooooooooool04?ooool0033ooooo00?o
0000ooooooooool01oooool2o`3jVP03ooooool0003o000000?o000000?ooooooomQ0_ooool05ooo
ool2oomQ0PCooooo1Ol00006ooooo`03oomQ0_oooooooooo05[ooooo0_ooH@8Cooooo`03oomQ0_oo
oooooooo00cooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Qooooo`;oof420ooo
ool3oomQ0P[ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`02ooooo`05oomQ0_oo
ooooooooooooooooH@800oooool5o`000003oomQ0_oooooooooo01Gooooo00?oof42ooooooooool0
1_ooool5o`0000Kooooo00?oof42ooooooooool0EOooool2oomQ0P[ooooo00?oof42ooooooooool0
6_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo02Gooooo00?oof42ooooooooool0
2_ooool00oooH@;oooooooooo`02ooooo`03o`000?oooooooooo013ooooo000`ooooo`;o00000ooo
ool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?oooooo`000?l000000ol00002ooooo`03oomQ0_oo
oooooooo01Cooooo00?oof42ooooooooool01Oooool3o`0000Sooooo00?oof42ooooooooool0F?oo
ool00oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooooooool02?oo
ool00oooH@;oooooooooo`0Qooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool01_oo
ool2o`0002?ooooo0_l00003ooooo`05oomQ0_ooooooooooooooooooH@800oooool5o`000003oomQ
0_oooooooooo01Gooooo00?oof42ooooooooool01oooool3o`0000Sooooo00?oof42ooooooooool0
7Oooool5oomQ0S7ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0Iooooo`03oomQ
0_oooooooooo00Kooooo00?oof42ooooooooool08oooool00oooH@;oooooooooo`0;ooooo`04oomQ
0_ooooooooooooooo`;o00004_ooool0033ooooo00?o0000ooooooooool00_ooool00oooH@;ooooo
ooooo`02ooooo`?o0?ZJ00Coooooo`000?l0003o00000oooool00oooH@;oooooooooo`0Cooooo`03
oomQ0_oooooooooo017ooooo00?oof42ooooooooool0:Oooool6oomQ0ROooooo0_ooH@8Fooooo`03
oomQ0_oooooooooo00_ooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0Pooooo`03
oomQ0_oooooooooo00Kooooo00?oof42ooooooooool01oooool00ol0003oooooooooo`0Qooooo`05
o`000?ooooooooooooooooooH@801Oooool01?ooH@;oooooooooool0nYX3o`000003o`00ooooH@;o
oooo01Gooooo00?oof42ooooooooool04oooool00oooH@;oooooooooo`0Looooo`03oomQ0_oooooo
oooo00?ooooo00?oof42ooooooooool01Oooool5oomQ0R?ooooo00?oof42ooooooooool03?ooool0
0oooH@;oooooooooo`0Hooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool08oooool0
0oooH@;oooooooooo`0<ooooo`05oomQ0_ooooooooooooooool000004_ooool001Kooooo0_l00004
ooooo`04o`000?ooooooooooooooo`Go00000_ooool3o`0000Kooooo00Oo0000oooooooooooooooo
oomQ0_ooooooof4200Cooooo1?l0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooooooo01;o
oooo00?oof42ooooooooool04_ooool00oooH@;oooooooooo`0Vooooo`;oof421_ooool2oomQ0R?o
oooo0_ooH@8Hooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool02Oooool00oooH@;o
ooooooooo`0Kooooo`?o00000_ooH@86ooooo`05o`00ooooooooooooooooooooH@801Oooool01?oo
H@;oooooooooool0000:ooooo`;o00001?ooool01?l0003oooooooooooooool5o`0000;ooooo0ol0
0005ooooo`05o`000?ooooooooooooooooooH@801Oooool00oooH@;oooooooooo`03o`3jVP04oooo
ool00?oooooooomQ0QGooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Jooooo`03
oomQ0_oooooooooo00Gooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`03ooooo`?o
of427oooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo01Oooooo00?oof42oooooooo
ool02?ooool00oooH@;oooooooooo`0Mooooo`?o000000?ooooooomQ0_ooool01Oooool00ol00?oo
ooooooooo`07ooooo`04oomQ0_ooooooooooo`0001;ooooo000Eooooo`04o`000?ooooooooooo`00
00Sooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo00?ooooo00Go
0000oooooooooooooooooomQ0P02ooooo`04oomQ0_ooooooooooooooo`Go0?ZJ00?oooooo`00oooo
ool00oooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo01Cooooo00?oof42oooooooo
ool08oooool2oomQ0P[ooooo00?oof42ooooooooool07oooool00oooH@;oooooooooo`0Hooooo`03
oomQ0_oooooooooo00_ooooo0ol00009ooooo`03oomQ0_oooooooooo01Gooooo00?oof42oooooooo
ool00_ooool5o`0000Oooooo0_l00?l3ooooo`;oof420oooool01?ooH@;oooooooooool00009oooo
o`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`00
0?oooooooooo00;ooooo00Go0000oooooooooooooooooomQ0P06ooooo`03oomQ0_oooooooooo00;o
0?ZJ00Coooooo`00ooooooooof425Oooool00oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo
01Wooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`02oomQ0PWooooo00?oof42oooo
ooooool06_ooool2oomQ0Q7ooooo00?oof42ooooooooool05_ooool01?ooH@;o0000o`000?l00007
ooooo`03oomQ0_oooooooooo01cooooo1Ol000000oooH@;oooooooooo`04ooooo`;o003o2oooool0
0ol0003oooooooooo`0@ooooo`003_ooool5o`0000;ooooo00Co0000oooooooooooo00002Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo0_l000000oooooooof42ooooo`02
ooooo`03oomQ0_oooooooooo00Cooooo0_l0nYX00ooooooo003oooooo`04ooooo`03oomQ0_oooooo
oooo00oooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`0Rooooo`03oomQ0_oooooo
oooo00[ooooo00?oof42ooooooooool07?ooool2oomQ0Q_ooooo00?oof42ooooooooool02_ooool5
o`0000Sooooo00?oof42ooooooooool05Oooool00oooH@;oooooooooo`02ooooo`Go00001_ooool0
1?l00?ooooooooooool00?l4ooooo`04oomQ0_ooooooof42ooooo`?o00000_ooool5o`0000;ooooo
00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;o
oooo0ol000000oooooooof42ooooo`05ooooo`03oomQ0_oooooooooo00;o0?ZJ0_ooool00ol00?oo
of42ooooo`0Cooooo`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool05oooool00oooH@;o
ooooooooo`09ooooo`;oof423?ooool00oooH@;oooooooooo`0Hooooo`03oomQ0_oooooooooo01;o
oooo00?oof42ooooooooool05?ooool00oooH@;o0000o`000003o`0000Kooooo00?oof42oooooooo
ool07?ooool5o`0000Kooooo00Co003ooooooooooooo003o2?ooool3o`0001;ooooo000Eooooo`04
o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03oooo
o`04o`000?oooooooooooomQ0PCooooo00?oof42ooooooooool00oooool2o`3jVP03ooooool00?oo
oooo00Gooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`07ooooo`;o0?ZJ3?ooool0
0oooH@;oooooooooo`0Qooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool04_ooool4
oomQ0PCooooo0_ooH@8Mooooo`03oomQ0_oooooooooo00[ooooo1Ol00008ooooo`03oomQ0_oooooo
oooo00Sooooo00?oof42ooooooooool02Oooool2oomQ0PCooooo1Ol00006ooooo`05o`00oooooooo
ooooooooool00?l01?ooool00oooH@;oooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00Co
0000oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo
00Co0000ooooooooooooof422?ooool01?ooH@;oooooo`3jV_l0nYX2ooooo`03o`00ooooH@;ooooo
01?ooooo00?oof42ooooooooool02?ooool3o`3jVP_ooooo00?oof42ooooooooool05_ooool00ooo
H@;oooooooooo`0Iooooo`;oof424Oooool7oomQ0QGooooo00?oof42ooooooooool05?ooool00ooo
H@;o0000o`000003o`0000Oooooo00?oof42ooooooooool06oooool5o`0000Kooooo00Go003ooooo
ooooooooooooo`00o`09ooooo`03o`000?oooooooooo013ooooo000Eooooo`04o`000?oooooooooo
o`0000Oooooo00Ko0000ooooooooooooooooo`000?ooool4o`0000Kooooo00Co0000oooooooooooo
of421?ooool00oooH@;oooooooooo`03ooooo`?o0?ZJ00?o003oooooooooool01Oooool00oooH@;o
ooooooooo`0<ooooo`03oomQ0_oooooooooo00Sooooo0_l0nYX=ooooo`03oomQ0_oooooooooo01Ko
oooo2_ooH@88ooooo`?o003o0_ooool2o`00o`03oomQ0_oooooooooo013ooooo00?oof42oooooooo
ool00_ooool4oomQ0Qoooooo00?oof42ooooooooool02_ooool5o`0000Sooooo00?oof42oooooooo
ool01oooool2oomQ0P[ooooo00?oof42ooooooooH@801Oooool3o`0000Gooooo0_l00?l4ooooo`03
o`00oooooooooooo00Oooooo00?o0000ooooooooool01oooool01?l0003oooooooooool00007oooo
o`06o`000?ooooooooooooooool0003ooooo1?l00005ooooo`04o`000?oooooooooooomQ0PSooooo
00?oof42ooooool0nYX00_l0nYX00ooooooo003ooomQ0P0Dooooo`03oomQ0_oooooooooo00Kooooo
1Ol0nYX<ooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool04_ooool3o`00o`;ooooo
0_l00?l3ooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool06oooool00oooH@;ooooo
ooooo`0Cooooo`03oomQ0_l0003o000000?o00001oooool00oooH@;oooooooooo`0Looooo`?o0000
1Oooool2o`00o`Cooooo00?o003oooooooooool01oooool00ol0003oooooooooo`0@ooooo`005Ooo
ool01?l0003oooooooooool00007ooooo`07o`000?ooooooooooooooool0003oooooo`000009oooo
o`03o`000?ooooooof4200Gooooo00?oof42ooooooooool01?ooool2o`3jVP03o`00oooooooooooo
00Gooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`08ooooo`?o0?ZJ3?ooool00ooo
H@;oooooooooo`0Aooooo`Goof423_ooool4o`00o`?ooooo0_l00?l00ooooooo003oooooo`03oomQ
0Pkooooo00?oof42ooooooooool09_ooool00oooH@;oooooooooo`0:ooooo`04oomQ0_l0003o0000
o`0000[ooooo00?oof42ooooooooool01Oooool00oooH@;ooooooomQ0P0:ooooo`04oomQ0_oooooo
oooooomQ0PCooooo00?oof42ooooooooool00oooool2o`00o`Oooooo00?o003oooooooooool01_oo
ool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Oooooo00Oo0000oooooooooooo
ooooo`000?oooooo000000Sooooo00?o0000ooooooooool02_ooool02?ooH@;oooooo`3jV_l0nY[o
ooooo`00ooooooooof424_ooool00oooH@;oooooooooo`07ooooo`Ko0?ZJ3?ooool00oooH@;ooooo
ooooo`0Booooo`03oomQ0_oooooooooo00oooooo1?l00?l3ooooo`;o003o00?oooooo`00ooooool0
0oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01cooooo00?oof42ooooooooool0
4_ooool00oooH@;oooooooooo`03o`0000Sooooo00?oof42ooooooooool07Oooool00oooH@;ooooo
ooooo`02ooooo`;o003o1oooool00ol00?ooooooooooo`06ooooo`03o`000?oooooooooo013ooooo
000Fooooo`;o00002Oooool3o`0000;ooooo1Ol00005ooooo`;o00001oooool00oooH@;ooooooooo
o`03ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oo
oooooooo00Sooooo1?l0nYX<ooooo`;oof423oooool2oomQ0Q;ooooo00?o003oooooooooool02?oo
ool00ol00?ooooooooooo`02ooooo`;oof422oooool00oooH@;oooooooooo`0Wooooo`03oomQ0_oo
oooooooo00Wooooo00Coof42oooooooooooooooo1?l0nYX7ooooo`03oomQ0_oooooooooo00Cooooo
00Coof42ooooooooooooof422Oooool01OooH@;oooooooooooooooooof4200Cooooo00?oof42oooo
ooooool00oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00;ooooo1Ol0000:oooo
o`;o00002Oooool3o`0000;ooooo1Ol00004ooooo`;o00002oooool01?ooH@;oooooo`3jV_l0nYX2
ooooo`03o`00ooooH@;ooooo017ooooo00?oof42ooooooooool01_ooool3o`3jVP;ooooo0ol0nYX<
ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool03_ooool00ol00?ooooooooooo`08
ooooo`03o`00oooooooooooo00;ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0M
ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0K
ooooo`03oomQ0_oooooooooo00?ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`02
ooooo`Go00004_ooool0033ooooo00?o0000ooooooooool01_ooool00oooH@;oooooooooo`03oooo
o`;o0?ZJ00?oooooo`00ooooool01Oooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo
00Gooooo0ol00?l00ooooooo0?ZJo`3jVP03o`3jVPgooooo00?oof42ooooooooool02Oooool3oomQ
0Q7ooooo0ol0000<ooooo`03o`00oooooooooooo00?ooooo0oooH@87ooooo`03oomQ0_oooooooooo
02Wooooo00?oof42ooooooooool02?ooool01?ooH@;oooooooooooooool5o`3jVPKooooo00?oof42
ooooooooool00oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Kooooo00Goof42
oooooooooooooooooomQ0P04ooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooooooool01ooo
ool01?l00?ooooooooooooooool6o`0002?ooooo00?o0000ooooooooool02_ooool00oooH@;ooooo
o`3jVP02o`3jVP03ooooool00?ooof4201;ooooo00?oof42ooooooooool01Oooool3o`3jVPCooooo
0_l0nYX<ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool03?ooool3o`0000cooooo
00?o003oooooooooool00_ooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo01oooooo
00?oof42ooooooooool04Oooool00oooH@;oooooooooo`02ooooo`?o0?ZJ1oooool00oooH@;ooooo
ooooo`0Kooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooooooool01oooool01?l00?oooooo
ooooooooool6o`0001;ooooo000`ooooo`03o`000?oooooooooo00Kooooo00?oof42ooooooooool0
0oooool2o`3jVP03ooooool00?oooooo00Gooooo00?oof42ooooooooool02oooool00oooH@;ooooo
ooooo`05ooooo`03o`00oooooooooooo00?o0?ZJ00?oooooo`3jV_l0nYX03_ooool2oomQ0POooooo
0_ooH@8Cooooo`Go00002oooool00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo00Cooooo
00?oof42ooooooooool0:Oooool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00?o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ1Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00?o
oooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00;o
oooo00?oof42ooooooooool00_ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo00Ko
00008oooool00ol0003oooooooooo`0;ooooo`07oomQ0_oooooo0?ZJo`3jV_oooooo003ooomQ0P0B
ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX01Ooooooo003oo`00ool00?oooooo00?o0?ZJ3?oo
ool00oooH@;oooooooooo`0=ooooo`;oof423_ooool5o`0000_ooooo00?o003oooooooooool00ooo
ool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo01oooooo00?oof42ooooooooool04Ooo
ool01?ooH@;oooooooooooooool5o`3jVPKooooo00?oof42ooooooooool06_ooool00oooH@;ooooo
ooooo`03ooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool01_l0000Booooo`00<?oo
ool00ol0003oooooooooo`07ooooo`03oomQ0_oooooooooo00;ooooo0ol0nYX00ooooooo003ooooo
o`04ooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool01_ooool00ol00?oooooooooo
o`02o`3jVP;o003o0ol0nYX?ooooo`?oof4200CooooooomQ0_ooH@;oof425Oooool5o`0000_ooooo
00?o003oooooooooool01_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo02[ooooo
00?oof42ooooooooool02?ooool00oooH@;oooooo`3jVP02o`3jVP?ooooo0ol0nYX4ooooo`03oomQ
0_oooooooooo00;ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`05ooooo`03oomQ
0_oooooooooo00;ooooo00Goof42oooooooooooooooooomQ0P04ooooo`03o`00oooooooooooo00Wo
oooo00?o003oooooooooool01_l0000Sooooo`03o`000?oooooooooo00_ooooo00Ooof42ooooool0
nY[o0?ZJooooool00?ooof4201;ooooo00?oof42ooooooooool01?ooool3o`3jVPCooooo00Co003o
ooooool0nY[o0?ZJ3Oooool2oomQ0Pcooooo00?oof42ooooooooool03_ooool5o`0000_ooooo00?o
003oooooooooool01?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo023ooooo00?o
of42ooooooooool04?ooool01?ooH@;oooooooooooooool3o`3jVP04ooooool0nY[o0?ZJo`3jVPKo
oooo00?oof42ooooooooool06Oooool00oooH@;oooooooooo`02ooooo`03o`00oooooooooooo00Wo
oooo00?o003oooooooooool01_l0000Booooo`00<?ooool2o`0000Sooooo00?oof42ooooooooool0
0oooool2o`3jVP03ooooool00?oooooo00Cooooo00?oof42ooooooooool02_ooool00oooH@;ooooo
ooooo`05ooooo`04o`00ooooooooooooooooo`;o0?ZJ0_ooool00ol00?oo0?ZJo`3jVP0Booooo`03
oomQ0_oooooooooo01Kooooo1Ol0000<ooooo`03o`00oooooooooooo00Kooooo00Goof42oooooooo
oooooooooomQ0P0]ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool00_l0nYX5oooo
o`;o0?ZJ1?ooool3oomQ0P03ooooooooH@;ooooo00Gooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooooooo`02ooooo`05oomQ0_ooooooooooooooooooH@800oooool3o`0000[ooooo00Co003o
oooooooooooooooo1Ol0000Sooooo`;o00003?ooool02?ooH@;oooooo`3jV_l0nY[oooooo`00oooo
ooooof424?ooool00oooH@;oooooooooo`04ooooo`?o0?ZJ1_ooool01?l00?oo0?ZJo`3jV_l0nYX>
ooooo`03oomQ0_oooooooooo00Oooooo0_ooH@8Aooooo`Go00003?ooool00ol00?ooooooooooo`04
ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool08Oooool00oooH@;oooooooooo`0@
ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ0oooool2o`3jVPKooooo00?oof42ooooooooool06?oo
ool00oooH@;oooooooooo`02ooooo`?o00002_ooool01?l00?ooooooooooooooool5o`0001;ooooo
000`ooooo`03o`000?oooooooooo00Oooooo00?oof42ooooooooool00oooool2o`3jVP03ooooool0
0?oooooo00Cooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`06ooooo`04o`00oooo
ooooooooooooo`;o0?ZJ0oooool2o`3jVRcooooo0ol0000=ooooo`03o`00oooooooooooo00Kooooo
00Goof42o`00ool00?ooof42o`00o`0]ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooooooo
ool00_l0nYX2o`00o`?ooooo0ol0nYX6ooooo`03oomQ0_oooooooooo00Gooooo00?oof42oooooooo
ool01?ooool00oooH@;oooooooooo`04ooooo`04oomQ0_ooooooof42ooooo`;o0?ZJ1Ol0000:oooo
o`03o`00oooooooooooo00Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0;oooo
o`03oomQ0_oooooo0?ZJ00;o0?ZJ00?oooooo`00ooooH@804?ooool00oooH@;oooooooooo`04oooo
o`;o0?ZJ2?ooool00ol00?oo0?ZJo`3jVP0?ooooo`;oof421Oooool2oomQ0QCooooo0ol0000=oooo
o`03o`00oooooooooooo00Gooooo00Koof42ooooool00?oo003ooomQ0_l00?lTooooo`03oomQ0_oo
oooooooo00oooooo00?oof42ooooooooool00ol0nYX2o`00o`04ooooool0nY[o0?ZJo`3jVPKooooo
00?oof42ooooooooool05_ooool00oooH@;oooooooooo`02ooooo`Go00000_l0nYX8ooooo`03o`00
oooooooooooo00Cooooo00?o0000ooooooooool04?ooool0033ooooo00?o0000ooooooooool01ooo
ool00oooH@;oooooooooo`03ooooo`?o0?ZJ00?oooooo`00ooooool01?ooool00oooH@;ooooooooo
o`08ooooo`03oomQ0_oooooooooo00Kooooo00Co003ooooooooooooooooo0_l0nYX3ooooo`?o0?ZJ
:oooool00ol00?ooooooooooo`0>ooooo`03o`00oooooooooooo00Gooooo00Goof42o`00ooooH@;o
ooooo`00o`0]ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool00_l0nYX00ooooooo
003oooooo`03ooooo`?o0?ZJ3Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Co
oooo0_ooH@82ooooo`;o0?ZJ1Ol0000;ooooo`03o`00oooooooooooo00?ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`0;ooooo`03oomQ0_oooooooooo00;o0?ZJ00?oooooo`00oooo
H@804?ooool00oooH@;oooooooooo`03ooooo`?o0?ZJ2Oooool3o`3jVQ3ooooo1OooH@8Fooooo`03
o`00oooooooooooo00kooooo00?o003oooooooooool01Oooool01OooH@;o003ooomQ0_oooooo003o
02Cooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`02o`3jVP03o`00oooooooo003o
00;ooooo0_l0nYX7ooooo`03oomQ0_oooooooooo01Gooooo00?oof42ooooooooool00_l0nYX5o`00
00?o0?ZJ2?ooool00ol00?ooooooooooo`03ooooo`03o`000?oooooooooo013ooooo000`ooooo`03
o`000?oooooooooo00Oooooo00?oof42ooooooooool01?ooool2o`3jVP03ooooool00?oooooo00Co
oooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`06ooooo`03o`00oooooooooooo00;o
oooo0_l0nYX4ooooo`;o0?ZJ:_ooool00ol00?ooooooooooo`0@ooooo`03o`00oooooooooooo00Co
oooo00?o003ooomQ0_ooool00_ooool00ol00?ooooooooooo`0Zooooo`03oomQ0_oooooooooo00Oo
oooo00?oof42ooooool0nYX00_l0nYX2ooooo`03o`00oooooooooooo00;ooooo0ol0nYX=ooooo`03
oomQ0_oooooooooo00?ooooo00?oof42ooooooooool01?ooool01?ooH@;oooooooooooooool2o`3j
VPGo00002oooool00ol00?ooooooooooo`03ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool03?ooool02?ooH@;oooooo`3jV_l0nY[oooooo`00ooooooooof423oooool00oooH@;ooooo
ooooo`03ooooo`;o0?ZJ00?o003oooooooooool02?ooool2o`3jVR[ooooo00?o003oooooooooool0
4?ooool00ol00?ooooooooooo`04ooooo`03o`00ooooH@;ooooo00;ooooo00?o003oooooooooool0
8Oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00?o0?ZJ00Go003ooooooooooooo
003oooooo`03o`3jVPOooooo00?oof42ooooooooool04oooool01?ooH@;oooooooooooooool2o`3j
VPGo000000Coooooo`3jV_l0nY[o0?ZJ1_ooool4o`3jVP?ooooo00?o0000ooooooooool04?ooool0
033ooooo0_l00009ooooo`06oomQ0_ooooooooooooooooooH@;ooooo0_l0nYX00ooooooo003ooooo
o`04ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool01_ooool00ol00?oooooooooo
o`02ooooo`;o0?ZJ1?ooool3o`3jVRWooooo00?o003oooooooooool04Oooool00ol00?oooooooooo
o`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool0:_ooool00oooH@;ooooooooo
o`07ooooo`04oomQ0_oooooo0?ZJo`3jVPCooooo00?o003oooooooooool00_ooool2o`3jVPgooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`08ooooo`?o0?ZJ00Coooooo`000?l0003o
00000_l0nYX;ooooo`04o`00ool0nY[o0?ZJooooo`;o00008oooool2o`0000gooooo00Soof42oooo
ool0nY[o0?ZJooooool00?oooooooomQ0Poooooo00?oof42ooooooooool00oooool2o`3jVP_ooooo
0ol0nYXYooooo`03o`00oooooooooooo017ooooo00?o003oooooooooool00oooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo02;ooooo00?oof42ooooooooool03Oooool00oooH@;ooooo
ooooo`02o`3jVP03o`00oooooooooooo00;ooooo00Co003oooooool0nY[o0?ZJ2?ooool00oooH@;o
ooooooooo`0Booooo`03oomQ0_oooooooooo00?o0?ZJ00Coooooo`000?l0003o00000oooool=o`3j
VP03ooooool0003o000001;ooooo000`ooooo`03o`000?oooooooooo00Sooooo00Koof42oooooooo
oooooooooomQ0_ooool3o`3jVP03o`00oooooooooooo00?ooooo00?oof42ooooooooool01oooool0
0oooH@;oooooooooo`06ooooo`03o`00oooooooooooo00;ooooo0_l0nYX5ooooo`;o0?ZJ:Oooool0
0ol00?oo0?ZJo`3jVP02o`3jVPoooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`03
ooooo`03o`00oooooooooooo02Wooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`02
o`3jVPGooooo00Co003ooooooooooooooooo0_l0nYX=ooooo`03oomQ0_oooooooooo00;ooooo00?o
of42ooooooooool02?ooool2o`3jVPGooooo0ol0nYX:ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0<ooooo`04oomQ0_oooooo0?ZJo`3jVP;ooooo
00?o003ooomQ0_ooool03Oooool00oooH@;oooooooooo`03ooooo`?o0?ZJ3?ooool2o`3jVRWooooo
1?l0nYX@ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool00oooool00ol00?oooooo
ooooo`0Qooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool00_l0nYX00ol00?oooooo
ooooo`03ooooo`04o`00ool0nY[o0?ZJo`3jVPSooooo00?oof42ooooooooool04?ooool01?ooH@;o
ooooooooooooool2o`3jVPWooooo2?l0nYX01?oooooo003oo`3jV_l0nYX2ooooo`03o`000?oooooo
oooo013ooooo000`ooooo`03o`000?oooooooooo00Sooooo00?oof42ooooooooool00_ooH@82oooo
o`;o0?ZJ00?oooooo`00ooooool00oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo
00Kooooo00?o003oooooooooool00oooool2o`3jVPGooooo0ol0nYXWooooo`03o`00oooooooo0?ZJ
00Co0?ZJ3oooool00ol00?ooooooooooo`02o`00o`Oooooo00?o003oooooooooool0:?ooool00ooo
H@;oooooooooo`06ooooo`03oomQ0_oooooooooo00;o0?ZJ1Oooool01?l00?ooooooooooooooool3
o`3jVPcooooo00Goof42oooooooooooooooooomQ0P0:ooooo`?o00001_ooool3o`3jVP[ooooo0_l0
nYX2ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03?ooool00oooH@;oooooo`3j
VP02o`3jVP04ooooool00?oooooooomQ0Pgooooo00?oof42ooooooooool00oooool2o`3jVP03o`00
oooooooooooo00Cooooo0_ooH@84ooooo`;o0?ZJ:?ooool6o`3jVQ3ooooo00?o003oooooooooool0
0_l00?l7ooooo`03o`00oooooooooooo023ooooo00?oof42ooooooooool03?ooool00oooH@;ooooo
ooooo`03o`3jVP03o`00oooooooooooo00?ooooo00?o003oooooool0nYX00_l0nYX8ooooo`03oomQ
0_oooooooooo00oooooo00?oof42ooooooooool00ol0000Cooooo`05o`00ooooooooooooooooool0
00004_ooool0033ooooo00?o0000ooooooooool02?ooool00oooH@;oooooooooo`02oomQ0P;ooooo
0_l0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool0
1_ooool00ol00?ooooooooooo`02ooooo`?o0?ZJ00?oof42ooooooooool00oooool2o`3jVROooooo
00Go003oooooool0nY[o0?ZJooooo`02o`3jVQ3ooooo0_l00?l:ooooo`03o`00oooooooo003o00;o
003o1Oooool5o`00oa_ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`02o`3jVPKo
oooo00Co003ooooooooooooooooo0_l0nYX<ooooo`05oomQ0_ooooooooooooooooooH@802Oooool5
o`0000Kooooo0_l0nYX:ooooo`;o0?ZJ0_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo00gooooo00Coof42ooooool0nY[o0?ZJ0_ooool00ol00?ooof42ooooo`0<ooooo`03oomQ0_oo
oooooooo00?ooooo0_l0nYX6ooooo`03oomQ0_ooooooof4200Cooooo0ol0nYXVooooo`?o0?ZJ0_oo
ool3o`3jVQ3ooooo0_l00?l:ooooo`03o`00oooooooo003o00;o003o1Oooool5o`00oaCooooo00?o
of42ooooooooool02oooool00oooH@;oooooooooo`02o`3jVP03o`00oooooooooooo00Gooooo00Co
003oooooool0nY[o0?ZJ2Oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooo000000Co0000
4_ooool01Ol00?oooooooooooooooooo000001;ooooo000`ooooo`;o00002Oooool01oooH@;ooooo
ooooooooH@;ooooooomQ0_ooool00ol0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo
00Kooooo00?oof42ooooooooool01_ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ00?ooooooomQ
0_ooool01?ooool3o`3jVRKooooo00Go003oooooool0nY[o0?ZJooooo`03o`3jVQcooooo00Ko003o
ooooooooooooooooo`00ooooool3o`00o`Gooooo00?o003oooooooooool06?ooool00oooH@;ooooo
ooooo`05ooooo`04oomQ0_ooooooooooooooo`;o0?ZJ1_ooool01?l00?ooooooooooooooool2o`3j
VPcooooo00Goof42oooooooooooooooooomQ0P08ooooo`03o`00ool0003o000000?o00001_ooool3
o`3jVPWooooo0_l0nYX00ooooooo0000o`00000Sooooo`;o00003_ooool01?ooH@;oooooo`3jV_l0
nYX2ooooo`03o`00ooooH@;ooooo00_ooooo00?oof42ooooooooool01?ooool2o`3jVPGooooo00Go
of42oooooooooooooooooomQ0P04ooooo`;o0?ZJ9Oooool3o`3jVPCooooo0_l0nYXMooooo`06o`00
ooooooooooooooooool00?oooooo0ol00?l5ooooo`03o`00oooooooooooo017ooooo00?oof42oooo
ooooool02oooool00oooH@;oooooooooo`02o`3jVP03o`00oooooooooooo00Gooooo00?o003ooooo
ool0nYX00_l0nYX9ooooo`03oomQ0_oooooooooo00cooooo00?oof42ooooool00?l01Ol0000Boooo
o`03o`00oooooooooooo00;o00004_ooool0033ooooo00?o0000ooooooooool02?ooool00oooH@;o
oooooomQ0P02ooooo`03oomQ0_oooooooooo00;o0?ZJ00?oooooo`00ooooool00_ooool00oooH@;o
ooooooooo`05ooooo`03oomQ0_oooooooooo00Kooooo00?o003oooooool0nYX01Ol0nYX00ooooooo
of42oomQ0P05ooooo`;o0?ZJ9Oooool00ol00?ooooooooooo`02o`3jVP;ooooo0ol0nYXPooooo`03
o`00oooooooooooo00Oooooo00?o003oooooooooool05oooool00oooH@;oooooooooo`05ooooo`04
oomQ0_ooooooooooooooo`;o0?ZJ1oooool3o`00o`;o0?ZJ00?o003oooooooooool02Oooool01?oo
H@;oooooooooooooH@89ooooo`03o`00ool0003o000000?o00001oooool2o`3jVPSooooo0ol0nYX2
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03Oooool01?ooH@;oooooo`3jV_l0
nYX2ooooo`03o`00ooooH@;ooooo00_ooooo00?oof42ooooooooool00oooool3o`3jVPGooooo00Go
of42oooooooooooooooooomQ0P04ooooo`;o0?ZJ9?ooool3o`3jVPGooooo0ol0nYXQooooo`03o`00
oooooooooooo00Oooooo00?o003oooooooooool04?ooool00oooH@;oooooooooo`0;ooooo`03oomQ
0_oooooo0?ZJ00;o0?ZJ00?o003oooooooooool01_ooool2o`00o`;o0?ZJ0_l00?l7ooooo`03oomQ
0_oooooooooo00_ooooo00Coof42oooooooooooo003o1Ol0000Cooooo`04o`00ooooooooooooo`00
01;ooooo000Xooooo`;o00001_ooool00ol0003oooooooooo`09ooooo`;oof420_ooool00oooH@;o
ooooooooo`03o`3jVP05o`00ooooooooooooooooooooH@801oooool00oooH@;oooooooooo`06oooo
o`03o`00ool0nY[o0?ZJ00Go0?ZJ00?ooooooomQ0_ooH@801Oooool3o`3jVRCooooo00?o003ooooo
ool0nYX00_l0nYX3ooooo`;o0?ZJ:_ooool00ol00?ooooooooooo`0Gooooo`03oomQ0_oooooooooo
00Gooooo00?oof42ooooooooool00ol0nYX:ooooo`;o0?ZJ00?oooooo`00ooooool02_ooool00ooo
H@;ooooooomQ0P08ooooo`03o`00oooooooooooo00?o00002?ooool3o`3jVPOooooo0_l0nYX3oooo
o`03o`000?oooooooooo01[ooooo0_l00005ooooo`03o`000?oooooooooo00gooooo00Coof42oooo
ool0nY[o0?ZJ0oooool00ol00?ooof42ooooo`0:ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX0
0ol00?ooooooooooo`03ooooo`05oomQ0_ooooooooooooooooooH@801?ooool3o`3jVR?ooooo0_l0
nYX00ol00?ooooooooooo`04ooooo`?o0?ZJ:_ooool00ol00?ooooooooooo`02ooooo`Co0?ZJ2ooo
ool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00;o0?ZJ00?o003oooooooooool02Ooo
ool3o`3jVP03ooooool00?oooooo00Kooooo00?oof42ooooooooool02Oooool01_ooH@;ooooooooo
ool00?ooooooo`3jVP?o00000oooH@8Dooooo`03o`000?oooooooooo013ooooo000Wooooo`04o`00
0?ooooooooooo`0000Gooooo00?o0000ooooooooool02Oooool2oomQ0P;ooooo00Coof42oooooooo
oooooooo0_l0nYX01Ol00?ooooooooooooooooooof4200Kooooo00?oof42ooooooooool01oooool0
0ol00?oo0?ZJo`3jVP03ooooo`;o0?ZJ00CooooooomQ0_ooooooof421Oooool2o`3jVP;ooooo0_l0
0?lPooooo`04o`00oooooooo0?ZJo`3jVPCooooo0ol0nYXAooooo`?o00005_ooool00ol00?oooooo
ooooo`0Fooooo`03oomQ0_oooooooooo00Cooooo00Coof42oooooooooooooooo0_l0nYX;ooooo`?o
0?ZJ00?oooooo`00ooooool02Oooool2oomQ0PWooooo00?o003oooooooooool00_l0nYX00ooooooo
of42oomQ0P02oomQ0PGooooo0_l0nYX7ooooo`;o0?ZJ0oooool00ol0003oooooooooo`0Iooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool03_ooool00oooH@;o0?ZJo`3jVP03oooo
o`03o`00ooooH@;ooooo00Wooooo00?oof42ooooooooool01?ooool2o`3jVP03o`00oooooooooooo
00;ooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ00?o003ooooo
ool00?l00_l00?lMooooo`?o0?ZJ00?o003oooooooooool01Oooool3o`3jVQ7ooooo0ol0000Foooo
o`03o`00oooooooo0?ZJ00Ko0?ZJ2_ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo
00;o0?ZJ00?o003oooooooooool02_ooool2o`3jVP;ooooo00?o003oooooooooool01?ooool00ooo
H@;oooooooooo`07ooooo`;oof420oooool01?l00?oo0?ZJo`3jV_l0nYX2ooooo`04oomQ0_oooooo
oooooomQ0Q?ooooo00?o0000ooooooooool04?ooool002Oooooo00Co0000oooooooooooo00001Ooo
ool2o`0000[ooooo00Goof42oooooooooooooooooomQ0P03ooooo`;o0?ZJ00Go003ooooooooooooo
oooooomQ0P06ooooo`03oomQ0_oooooooooo00Kooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool00ooo
H@;ooooooomQ0P05ooooo`;o0?ZJ0_l00?l2ooooo`03o`00oooooooooooo00;o003o6_ooool00ol0
0?ooooooooooo`02o`3jVPGooooo0ol0nYX?ooooo`Go00005Oooool00ol00?ooooooooooo`06oooo
o`[o0?ZJ1_ooool00oooH@;oooooooooo`04ooooo`04oomQ0_ooooooooooo`00o`;o0?ZJ00Cooooo
oomQ0_ooH@;oof422?ooool2o`3jVP;ooooo00?o003oooooooooool01oooool00oooH@;ooooooooo
o`08ooooo`03o`00oooooooo0?ZJ00;o0?ZJ00GooooooomQ0_oooooooooooomQ0P05ooooo`?o0?ZJ
1_ooool2o`3jVP04ooooool0003o0000o`0001_ooooo00Co0000oooooooooooo00001?ooool3o`00
00kooooo00Coof42o`3jV_l0nY[o0?ZJ0_ooool00ol00?ooof42ooooo`09ooooo`03oomQ0_oooooo
oooo00?ooooo0ol0nYX5ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool00_ooool3
o`3jVP06o`00ooooooooooooooooool00?oooooo0ol00?lGooooo`?o0?ZJ00?o003oooooooooool0
1oooool3o`3jVPoooooo1Ol0000Eooooo`Go0?ZJ0_ooool3o`3jVPWooooo00?oof42ooooooooool0
2Oooool00oooH@;oooooooooo`02o`3jVP?ooooo0oooH@87ooooo`;o0?ZJ0oooool00ol00?oooooo
ooooo`04ooooo`;oof421Oooool2oomQ0PGooooo00?o003oo`3jV_l0nYX00_ooool01OooH@;ooooo
ooooooooooooof42017ooooo0ol0000Booooo`009oooool01?l0003oooooooooool00005ooooo`03
o`000?oooooooooo00kooooo00?oof42ooooooooool00ol0nYX01?l00?ooooooooooooooH@86oooo
o`03oomQ0_oooooooooo00Kooooo0ol0nYX7ooooo`04oomQ0_oooooooooooomQ0PCooooo0ol0nYX4
ooooo`;o003o0_ooool00ol00?ooooooooooo`02o`00oaGooooo00?o003oooooooooool00_l0nYX6
ooooo`?o0?ZJ3_ooool5o`0001Gooooo00Co003ooooooooooooooooo5Ol0nYX00oooH@;ooooooooo
o`04ooooo`04oomQ0_ooooooooooo`00o`;o0?ZJ00CooooooomQ0_ooooooof422?ooool2o`3jVP;o
oooo00?o003oooooooooool04Oooool00ol00?ooooooooooo`02o`3jVP;ooooo00Coof42oooooooo
ooooof421_ooool3o`3jVPGooooo0_l0nYX3ooooo`03o`000?oooooooooo01Wooooo00Co0000oooo
oooooooo00001?ooool00ol0003oooooooooo`0>ooooo`04oomQ0_oooooo0?ZJo`3jVP;ooooo00?o
003ooomQ0_ooool02Oooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?o003oooooooooool00ooo
ool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX5ooooo`06o`00oooo
ooooooooooooool00?oooooo0ol00?lBooooo`;o0?ZJ00?oooooo`00ooooool02Oooool3o`3jVPko
oooo1Ol0000Dooooo`Co0?ZJ1Oooool2o`3jVPWooooo00?oof42ooooooooool02Oooool00oooH@;o
ooooooooo`02o`3jVP?ooooo00?oof42ooooooooH@801oooool3o`3jVP;ooooo00?o003ooooooooo
ool01_ooool01OooH@;oooooooooooooooooof4200Kooooo00Co003oo`3jV_l0nY[o0?ZJ0_ooool0
0oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo013ooooo00?o0000ooooooooool04?ooool0
02Oooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`0>ooooo`04oomQ0_oooooo
ooooooooo`;o0?ZJ00Co003oooooooooooooof421Oooool00oooH@;oooooooooo`06ooooo`?o0?ZJ
2?ooool01?ooH@;oooooooooooooH@85ooooo`;o0?ZJ2Oooool2o`00o`;ooooo00?o003ooooooooo
ool04_ooool00ol00?ooooooooooo`02o`3jVPOooooo0_l0nYX>ooooo`Go00005_ooool00ol00?oo
0?ZJo`3jVP06o`3jVPSooooo1ol0nYX00oooH@;oooooooooo`03ooooo`05oomQ0_ooooooooooo`00
ooooool00_l0nYX01Oooooooof42ooooooooooooof4200Oooooo0ol00002ooooo`03o`00oooooooo
oooo013ooooo00?o003oooooool0nYX00_l0nYX00oooooooof42ooooo`03ooooo`03oomQ0_oooooo
oooo00Cooooo0ol0nYX4ooooo`;o0?ZJ0oooool00ol0003oooooooooo`0Iooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool03_ooool01?ooH@;oooooo`3jV_l0nYX3ooooo`03oomQ
0_oooooooooo00Sooooo00?oof42ooooooooool00oooool2o`3jVP03o`00oooooooooooo00;ooooo
00?oof42ooooooooool01?ooool00oooH@;oooooooooo`03ooooo`?o0?ZJ2Oooool01Ol00?oooooo
oooooooooooo003o013ooooo0ol0nYX00ooooooo003oooooo`0:ooooo`;o0?ZJ3_ooool5o`0001;o
oooo1?l0nYX00ol00?ooooooooooo`04ooooo`?o0?ZJ2Oooool00oooH@;oooooooooo`07ooooo`03
oomQ0_oooooooooo00?o0?ZJ0_ooool01OooH@;oooooooooooooooooof4200Oooooo0ol00002oooo
o`03o`00oooooooooooo00Kooooo0oooH@87ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?oof42oooo
ooooool00_ooool00oooH@;oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo000Wooooo`04
o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool03_ooool01?ooH@;oooooooooooooool2
o`3jVP04o`00oooooooooooooomQ0PGooooo00?oof42ooooooooool01_ooool2o`3jVPSooooo00Go
of42oooooooooooooooooomQ0P05ooooo`;o0?ZJ3_ooool00ol00?ooooooooooo`0@ooooo`04o`00
ooooooooooooooooo`;o0?ZJ1oooool3o`3jVPkooooo0ol0000Gooooo`Co0?ZJ4_ooool2o`3jVP03
oomQ0_oooooooooo00?ooooo00Goof42oooooooooooo003oooooo`02o`3jVP03ooooooooH@;ooooo
00;ooooo00?oof42ooooooooool00oooool5o`000003ooooool00?oooooo017ooooo00Co003oo`00
0?l0003o00000_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Gooooo0_l0nYX4
ooooo`;o0?ZJ0oooool00ol0003oooooooooo`0Iooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool03_ooool01?ooH@;oooooo`3jV_l0nYX3ooooo`03o`00ooooH@;ooooo00Oooooo
00?oof42ooooooooool00oooool3o`3jVP03o`00oooooooooooo00;ooooo00?oof42ooooooooool0
1Oooool00oooH@;oooooooooo`03ooooo`;o0?ZJ3_ooool00ol00?ooooooooooo`0<ooooo`?o0?ZJ
00?oooooo`00ooooool02oooool3o`3jVPkooooo0ol0000Booooo`Co0?ZJ00?oooooo`00ooooool0
1_ooool3o`3jVPSooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`02o`3jVP?ooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`03ooooo`Go000000?oooooo`00ooooool0
4Oooool01_l0nY[o0000o`000?l0003ooooooomQ0PGooooo00?oof42ooooooooool04?ooool00ol0
003oooooooooo`0@ooooo`00:?ooool2o`0000Kooooo0_l0000?ooooo`04oomQ0_oooooooooooooo
o`?o0?ZJ0oooool01OooH@;oooooooooooooooooof4200Wooooo0_l0nYX8ooooo`03oomQ0_oooooo
oooo00;ooooo00?oof42ooooooooool00_ooool3o`3jVPgooooo00?o003oooooooooool04?ooool0
1?l00?ooooooooooooooool2o`3jVPSooooo0ol0nYX=ooooo`Ko0?ZJ4_ooool4o`3jVPSooooo1?l0
0?l8ooooo`;o0?ZJ00?oof42ooooooooool00oooool00oooH@;oooooo`00o`02ooooo`;o0?ZJ00?o
oooooomQ0_ooool00oooool00oooH@;oooooooooo`02ooooo`Go000000?oooooo`00ooooool04?oo
ool00ol00?oo0000o`000003o`000003ooooooooH@;ooooo00?ooooo00?oof42ooooooooool01Ooo
ool3o`3jVP;ooooo0ol0nYX2ooooo`;o00007?ooool2o`0000Gooooo0_l0000@ooooo`03oomQ0_l0
nY[o0?ZJ00?ooooo00?o003ooomQ0_ooool01oooool00oooH@;oooooooooo`03ooooo`;o0?ZJ00?o
003oooooooooool00oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00?ooooo0ol0
nYX=ooooo`03o`00oooooooooooo00_ooooo0ol0nYX2ooooo`03o`00oooooooooooo00_ooooo1?l0
nYX;ooooo`Oo0?ZJ3_ooool3o`3jVP?ooooo00?o003oooooooooool01_ooool2o`3jVP?o003o1Ooo
ool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo00;o0?ZJ0_ooool00oooH@;ooooooooo
o`04ooooo`03oomQ0_oooooooooo00;ooooo1Ol000000ooooooo003oooooo`0@ooooo`03o`00ool0
003o000000?o000000?oof42ooooooooool01?ooool00oooH@;oooooooooo`0>ooooo`;o00004_oo
ool0033ooooo00?o0000ooooooooool03_ooool00oooH@;oooooooooo`02ooooo`?o0?ZJ0_ooool0
1OooH@;oooooooooooooooooof4200Sooooo0ol0nYX8ooooo`03oomQ0_oooooooooo00;ooooo00?o
of42ooooooooool00oooool3o`3jVPgooooo00?o003oooooooooool03oooool01?l00?oooooooooo
ooooool2o`3jVPWooooo0_l0nYX=ooooo`Wo0?ZJ3Oooool5o`3jVP03o`00oooooooooooo00Kooooo
00Co003ooooooooooooo003o2?ooool2o`3jVP03ooooooooH@;ooooo00?ooooo00Coof42ooooool0
0?oooooo0ol0nYX00oooooooof42ooooo`03ooooo`03oomQ0_oooooooooo00;ooooo1Ol00002o`3j
VP03o`00oooooooooooo00gooooo0_l0nYX5o`000003ooooooooH@;ooooo00Cooooo00?oof42oooo
ooooool01Oooool6o`3jVP05ooooooooH@;oooooooooool000008oooool00ol0003oooooooooo`0?
ooooo`04oomQ0_l0nY[o0?ZJo`3jVP;ooooo00?o003ooomQ0_ooool01oooool00oooH@;ooooooooo
o`03ooooo`;o0?ZJ00?o003oooooooooool00_ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oo
oooooooo00Cooooo0_l0nYX>ooooo`03o`00oooooooooooo00[ooooo0_l0nYX3ooooo`03o`00oooo
oooooooo00cooooo1?l0nYX8ooooo`co0?ZJ2_ooool3o`3jVPGooooo00?o003oooooooooool01Ooo
ool3o`3jVP03ooooool00?oooooo00Cooooo00?oof42ooooooooool01oooool00oooH@;ooooooooo
o`02o`3jVP;ooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`02ooooo`Go00000_oo
ool00ol00?ooooooooooo`0=ooooo`03o`00oooooooo000000Co00001oooool00oooH@;ooooooooo
o`0<ooooo`04oomQ0_ooooooooooo`0001;ooooo000`ooooo`03o`000?oooooooooo00oooooo00?o
of42ooooooooool00_ooool2o`3jVP;ooooo00Goof42oooooooooooooooooomQ0P08ooooo`;o0?ZJ
2Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Cooooo0_l0nYX=ooooo`03o`00
oooooooooooo00kooooo00Co003ooooooooooooooooo0ol0nYX00oooH@;oooooooooo`06ooooo`?o
0?ZJ3?ooool2o`3jVP?ooooo1Ol0nYX;ooooo`Co0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`05
o`00ooooooooooooooooool00?l01oooool2o`3jVP03ooooooooH@;ooooo00;ooooo00?oof42oooo
ool00?l00_ooool2o`3jVP03ooooooooH@;ooooo00Gooooo00?oof42ooooooooool00_ooool3o`00
00Ko0?ZJ3?ooool3o`3jVPGo000000?ooooooomQ0_ooool01?ooool00oooH@;oooooooooo`06oooo
o`Go0?ZJ00GooooooomQ0_ooooooooooo`00000Sooooo`03o`000?oooooooooo00oooooo00Coof42
ooooool0nY[o0?ZJ0_ooool00ol00?ooof42ooooo`06ooooo`03oomQ0_oooooooooo00?ooooo0ol0
nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool00ooo
ool2o`3jVPkooooo00?o003oooooooooool02Oooool3o`3jVP;ooooo00?o003oooooooooool03ooo
ool4o`3jVP?ooooo1_l0nYX5ooooo`Go0?ZJ1oooool4o`3jVPKooooo00?o003oooooooooool01_oo
ool3o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool01oooool00oooH@;oooooo`3j
VP02o`3jVP;ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`02ooooo`?o00000_l0
nYX00ooooooo003oooooo`0>ooooo`03o`00ool0nY[o000000Co00002?ooool00oooH@;ooooooooo
o`0:ooooo`05oomQ0_ooooooooooooooool000004_ooool0033ooooo00?o0000ooooooooool03ooo
ool00oooH@;oooooooooo`02ooooo`?o0?ZJ00GooooooomQ0_oooooooooooomQ0P09ooooo`;o0?ZJ
2Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00Cooooo0ol0nYX=ooooo`03o`00
oooooooooooo00gooooo00Co003ooooooooooooooooo0_l0nYX00oooooooof42ooooo`08ooooo`?o
0?ZJ2_ooool3o`3jVPKooooo0ol0nYX8ooooo`Co0?ZJ1Oooool00ol00?ooooooooooo`04ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool01Oooool2o`3jVP03ooooooooH@;ooooo00;o
oooo00?oof42ooooool00?l00_ooool2o`3jVP03ooooooooH@;ooooo00Gooooo00?oof42oooooooo
ool01oooool7o`3jVPSooooo0ol0nYX2ooooo`?o000000?ooooooomQ0_ooool01Oooool00oooH@;o
ooooooooo`08ooooo`?o0?ZJ00GooooooomQ0_ooooooooooo`00000Sooooo`03o`000?oooooooooo
00oooooo00Coof42ooooool0nY[o0?ZJ0_ooool00ol00?oooooooomQ0P06ooooo`03oomQ0_oooooo
oooo00?ooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03oomQ0_oooooooooo00Oooooo00?oof42
ooooooooool00oooool3o`3jVPkooooo00?o003oooooooooool01oooool3o`3jVP?ooooo00?o003o
ooooooooool01?ooool00oooH@;oooooooooo`09ooooo`[o0?ZJ2_ooool3o`3jVPGooooo1?l0nYX8
ooooo`03o`00oooooooooooo00Cooooo00?o003oooooool0nYX00_l0nYX00ol00?ooooooooooo`03
ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool00_l0nYX2ooooo`03oomQ0_oooooo
oooo00Kooooo00?oof42ooooooooool01Oooool2o`3jVP03ooooool00?oooooo00gooooo00Co003o
ooooool0nY[o0?ZJ0ol000000oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00Wooooo00?o
of42ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`00<?ooool2o`00013ooooo00?oof42
ooooooooool00oooool2o`3jVP03ooooooooH@;ooooo00;oof422?ooool3o`3jVPWooooo00?oof42
ooooooooool00_ooool00oooH@;oooooooooo`05ooooo`;o0?ZJ3Oooool00ol00?ooooooooooo`0=
ooooo`04o`00ooooooooooooooooo`;o0?ZJ00?ooooooomQ0_ooH@802Oooool3o`3jVPWooooo0_l0
nYX8ooooo`Go0?ZJ0oooool5o`3jVPKooooo00?o003oooooooooool01?ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00Gooooo0ol0nYX01_ooH@;oooooooooooooooooof42o`00o`?o
oooo0_l0nYX00oooooooof42ooooo`05ooooo`03oomQ0_oooooooooo00Sooooo00?o003oooooool0
nYX00ol0nYX8ooooo`;o0?ZJ1oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00So
oooo0_l0nYX00oooooooof42ooooo`02o`0002?ooooo0_l0000@ooooo`03oomQ0_oooooo0?ZJ00;o
0?ZJ0_ooool00ol00?ooof42ooooo`05ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX00ol00?oo
ooooooooo`02ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool01?ooool2o`3jVPko
oooo00?o003oooooooooool01_ooool3o`3jVPCooooo00?o003oooooooooool01?ooool00oooH@;o
ooooooooo`0;ooooo`Go0?ZJ3_ooool9o`3jVP[ooooo00?o003oooooooooool01?ooool00ol00?oo
ooooooooo`02o`3jVP03o`00oooooooooooo00?ooooo00?oof42ooooooooool01Oooool00oooH@;o
ooooo`00o`02o`3jVP;ooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`04ooooo`?o
0?ZJ00?o003oooooooooool03?ooool01?l00?ooooooo`3jV_l0nYX2ooooo`03oomQ0_oooooooooo
00Sooooo00?oof42ooooooooool02?ooool01?ooH@;oooooooooooooool2o`0001;ooooo000`oooo
o`03o`000?oooooooooo00oooooo00?oof42ooooooooool00oooool2o`3jVP03ooooooooH@;oof42
00[ooooo0_l0nYX00ol00?ooooooooooo`07ooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooo
ooooool01?ooool3o`3jVPgooooo00?o003oooooooooool01oooool;o`3jVP04ooooooooH@;ooooo
oomQ0PWooooo0ol0nYX8ooooo`;o0?ZJ2Oooool:o`3jVPSooooo00?o003oooooooooool01?ooool0
0ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Gooooo0_l0nYX01_ooH@;ooooooooooooo
H@;oooooo`00o`;ooooo0ol0nYX00oooooooof42ooooo`06ooooo`03oomQ0_oooooooooo00Sooooo
00?o003oooooooooool00ol0nYX6ooooo`?o0?ZJ1oooool00oooH@;oooooooooo`05ooooo`03oomQ
0_oooooooooo00_ooooo00Coof42oooooooooooo00008oooool00ol0003oooooooooo`0@ooooo`04
oomQ0_oooooo0?ZJo`3jVP;ooooo00?o003oooooooooH@801?ooool00oooH@;oooooooooo`03oooo
o`?o0?ZJ00?o003oooooooooool00_ooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo
00?ooooo0ol0nYX>ooooo`03o`00oooooooooooo00Cooooo0ol0nYX4ooooo`03o`00oooooooooooo
00Cooooo00?oof42ooooooooH@808?ooool7o`3jVP_ooooo00?o003oooooooooool01?ooool00ol0
0?ooooooooooo`03o`3jVP03o`00oooooooooooo00;ooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooo`3jVP02o`3jVP;ooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`04oooo
o`;o0?ZJ00?oooooo`00ooooool03?ooool01?l00?oo0?ZJo`3jV_l0nYX2ooooo`03oomQ0_oooooo
oooo00Sooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`03ooooo`03o`000?oooooo
oooo013ooooo000`ooooo`03o`000?oooooooooo013ooooo00?oof42ooooooooool00_ooool2o`3j
VP03ooooooooH@;ooooo00[ooooo0_l0nYX:ooooo`03oomQ0_oooooooooo00?ooooo00?oof42oooo
ooooool01Oooool2o`3jVPgooooo00?o003oooooooooool00_ooool@o`3jVP05ooooooooH@;ooooo
ooooooooH@802Oooool4o`3jVPKooooo0_l0nYX<ooooo`Go0?ZJ2oooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01Oooool2o`3jVP06oomQ0_oooooo
oooooomQ0_oooooo003o0_ooool2o`3jVP;ooooo00?oof42ooooooooool01Oooool00oooH@;ooooo
ooooo`08ooooo`04o`00ooooooooooooooooo`;o0?ZJ1?ooool4o`3jVPSooooo00?oof42oooooooo
ool01Oooool00oooH@;oooooooooo`0;ooooo`04oomQ0_ooooooooooo`0002?ooooo00?o0000oooo
ooooool04?ooool01?ooH@;oooooo`3jV_l0nYX2ooooo`03o`00ooooooooof4200?ooooo00?oof42
ooooooooool01?ooool2o`3jVP03ooooool00?oooooo00?ooooo00?oof42ooooooooool02Oooool0
0oooH@;oooooooooo`04ooooo`?o0?ZJ3Oooool00ol00?ooooooooooo`03ooooo`?o0?ZJ1?ooool0
0ol00?ooooooooooo`04ooooo`05oomQ0_ooooooooooooooooooH@80<_ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03oomQ0_oo
oooooooo00?ooooo00?oof42ooooooooool00_l0nYX2ooooo`03oomQ0_oooooooooo00[ooooo00?o
of42ooooooooool00oooool4o`3jVPcooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool00oooH@;ooooo
ooooo`09ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool01?ooool00ol0003ooooo
ooooo`0@ooooo`00<?ooool00ol0003oooooooooo`0@ooooo`03oomQ0_oooooooooo00;ooooo0_l0
nYX<ooooo`?o0?ZJ2_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Gooooo1?l0
nYX<ooooo`03o`00oooooooo0?ZJ00Oo0?ZJ00?oooooo`00ooooool02?ooool01?ooH@;ooooooooo
ooooH@8:ooooo`Co0?ZJ1Oooool2o`3jVQcooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`05ooooo`03o`00oooooooooooo00Cooooo0_l0nYX01_ooH@;oooooooooooooH@;oooooo`00
o`;ooooo0_l0nYX2ooooo`03oomQ0_oooooooooo00Gooooo00?oof42ooooooooool02?ooool01?l0
0?ooooooooooooooool3o`3jVP;ooooo1?l0nYX00ol00?ooooooooooo`05ooooo`03oomQ0_oooooo
oooo00Oooooo00?oof42ooooooooool02_ooool01?ooH@;oooooooooool0000Sooooo`03o`000?oo
oooooooo013ooooo00?oof42ooooool0nYX00_l0nYX01?oooooo003oooooooooH@83ooooo`03oomQ
0_oooooooooo00Cooooo0_l0nYX00ol00?ooooooooooo`02ooooo`03oomQ0_oooooooooo00[ooooo
00?oof42ooooooooool01Oooool3o`3jVPgooooo00?o003oooooooooool00_ooool2o`3jVPCooooo
00?o003oooooooooool01Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo02oooooo
00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ00?oooooo`00ooooool0
1?ooool01OooH@;oooooooooooooooooof4200?ooooo0_l0nYX2ooooo`03oomQ0_oooooooooo00_o
oooo00?oof42ooooooooool00oooool4o`3jVP_ooooo0ol0nYX3ooooo`03oomQ0_oooooooooo00[o
oooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`05ooooo`03o`000?oooooooooo013o
oooo000`ooooo`;o00004Oooool00oooH@;oooooooooo`02ooooo`?o0?ZJ2_ooool3o`3jVP03o`00
oooooooooooo00Sooooo00?oof42ooooooooool00oooool00oooH@;oooooooooo`06ooooo`Co0?ZJ
2_ooool6o`3jVPKooooo00?o003oooooooooool01oooool01?ooH@;oooooooooooooH@8<ooooo`Co
0?ZJ0_ooool3o`3jVQgooooo00Co003ooooooooooooo003o2?ooool00ol00?ooooooooooo`04oooo
o`;o0?ZJ00Goof42ooooooooH@;oooooo`00o`02ooooo`?o0?ZJ0_ooool00oooH@;oooooooooo`06
ooooo`03oomQ0_oooooooooo00Sooooo00Co003ooooooooooooooooo0_l0nYX01?oooooo0?ZJo`3j
V_l0nYX2ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool01oooool00oooH@;ooooo
ooooo`0:ooooo`04oomQ0_oooooo0000o`0002?ooooo0_l0000Aooooo`03oomQ0_oooooooooo00;o
0?ZJ00Coooooo`00oooooooooooo0oooH@87ooooo`;o0?ZJ00?o003oooooooooool00_ooool00ooo
H@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00Kooooo0_l0nYX=ooooo`04o`00oooooooooooo
ooooo`?o0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo00?ooooo00?oof42
ooooooooool0<?ooool01?l00?ooooooooooool00?l5ooooo`?o0?ZJ00?o003oooooooooool00ooo
ool01OooH@;oooooooooooooooooof4200;ooooo0ol0nYX2ooooo`03oomQ0_oooooooooo00_ooooo
00?oof42ooooooooool01Oooool3o`3jVP[ooooo0_l0nYX4ooooo`03oomQ0_oooooooooo00_ooooo
00?oof42ooooooooool00_ooool00oooH@;oooooooooo`05ooooo`;o00004_ooool0033ooooo00?o
0000ooooooooool04?ooool00oooH@;oooooooooo`03ooooo`;o0?ZJ2_ooool2o`3jVP03ooooool0
0?oooooo00Wooooo00?oof42ooooooooool01?ooool00oooH@;oooooooooo`07ooooo`Co0?ZJ1_oo
ool6o`3jVPOooooo00?o003oooooooooool02?ooool01OooH@;oooooooooooooooooof4200cooooo
1ol0nYXNooooo`03o`00oooooooo003o00[ooooo00?o003oooooooooool00oooool2o`3jVP;oof42
0_ooool00ol00?ooooooooooo`02o`3jVP?ooooo00?oof42ooooooooool01_ooool00oooH@;ooooo
ooooo`08ooooo`04o`00ooooooooooooooooo`Go0?ZJ0oooool00ol00?ooooooooooo`05ooooo`03
oomQ0_oooooooooo00Oooooo00?oof42ooooooooool02Oooool01OooH@;ooooooooooooooooo0000
02?ooooo00?o0000ooooooooool04?ooool00oooH@;oooooooooo`02o`3jVP;ooooo00?o003ooooo
ooooool02Oooool2o`3jVP03o`00oooooooooooo00;ooooo00?oof42ooooooooool02oooool00ooo
H@;oooooooooo`05ooooo`?o0?ZJ3?ooool00ol00?ooooooo`3jVP03o`3jVPCooooo00?o003ooooo
ooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo033ooooo00?o003ooooo
ool00?l01oooool2o`3jVP03ooooool00?oooooo00Cooooo0oooH@83ooooo`;o0?ZJ0oooool00ooo
H@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Gooooo0ol0nYX8ooooo`?o0?ZJ0oooool00ooo
H@;oooooooooo`0=ooooo`Coof422Oooool00ol0003oooooooooo`0@ooooo`00<?ooool00ol0003o
ooooooooo`0@ooooo`03oomQ0_oooooooooo00?ooooo0_l0nYX9ooooo`?o0?ZJ00?o003ooooooooo
ool02Oooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Sooooo3?l0nYX01?oooooo
003oo`00ool00?l4ooooo`;o003o2oooool01OooH@;oooooooooooooooooof4200kooooo1Ol0nYXO
ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool00oooool2o`3jVP05oomQ0_oooooo
ooooooooool00?l00_ooool2o`3jVP?ooooo00?oof42ooooooooool01oooool00oooH@;ooooooooo
o`07ooooo`04o`00ooooooooooooooooo`Co0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`03oomQ
0_oooooooooo00Wooooo00?oof42ooooooooool02?ooool01OooH@;ooooooooooooooooo000002?o
oooo00?o0000ooooooooool04?ooool00oooH@;oooooooooo`02o`3jVP;ooooo00?o003ooooooooo
ool02?ooool3o`3jVP03o`00oooooooooooo00;ooooo00?oof42ooooooooool02oooool00oooH@;o
ooooooooo`06ooooo`Co0?ZJ2oooool4o`3jVP?ooooo0_l00?l7ooooo`03oomQ0_oooooooooo00Go
oooo00?oof42ooooooooool0<?ooool00ol00?ooooooooooo`06ooooo`?o0?ZJ00?o003ooooooooo
ool02Oooool2o`3jVP?ooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`05ooooo`03
o`00ool0nY[o0?ZJ00?o0?ZJ0oooool4o`3jVPCooooo00?oof42ooooooooool06_ooool00ol0003o
ooooooooo`0@ooooo`00<?ooool00ol0003oooooooooo`0Aooooo`03oomQ0_oooooooooo00;ooooo
0_l0nYX9ooooo`;o0?ZJ00?oooooo`00ooooool02_ooool00oooH@;oooooooooo`04ooooo`03oomQ
0_oooooooooo00[ooooo2?l0nYX6ooooo`Co003o3?ooool00oooH@;oooooooooo`02ooooo`03oomQ
0_oooooooooo03cooooo00?o003oooooooooool00oooool2o`3jVPCooooo00?o003oooooool0nYX0
0_l0nYX2ooooo`03oomQ0_oooooooooo00Sooooo00Coof42ooooooooH@;oof421oooool01?l00?oo
ooooooooooooool3o`0000?ooooo00?o003oooooooooool01Oooool00oooH@;oooooooooo`09oooo
o`03oomQ0_oooooooooo00Sooooo00Goof42ooooooooooooooooo`00000Sooooo`03o`000?oooooo
oooo013ooooo00?oof42ooooooooool00ol0nYX00ooooooo003oooooo`09ooooo`;o0?ZJ00?o003o
ooooooooool00_ooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Oooooo1?l0nYX8
ooooo`Co0?ZJ00?oooooo`00ool00?l00_l00?l9ooooo`03oomQ0_oooooooooo00Gooooo00?oof42
ooooooooool0>_ooool2o`3jVP03o`00oooooooooooo00Wooooo0_l0nYX2ooooo`03oomQ0_oooooo
oooo00kooooo00?oof42ooooooooool01Oooool01?l00?oo0?ZJo`3jV_l0nYX3o`0000Co0?ZJ1Ooo
ool00oooH@;oooooooooo`0Jooooo`03o`000?oooooooooo013ooooo000`ooooo`;o00004_ooool0
0oooH@;oooooooooo`02ooooo`;o0?ZJ2?ooool3o`3jVP03ooooool00?oooooo00Wooooo00?oof42
ooooooooool01_ooool00oooH@;oooooooooo`0<ooooo`;o0?ZJ6Oooool00oooH@;oooooooooo`03
ooooo`03oomQ0_oooooooooo03cooooo00?o003oooooooooool00_ooool2o`3jVPCooooo00Co003o
o`3jV_l0nY[o0?ZJ0oooool00oooH@;oooooooooo`09ooooo`03oomQ0_ooooooof4200Oooooo00?o
003oooooooooool01Ol00002ooooo`03o`00oooooooooooo00Gooooo00?oof42ooooooooool02Ooo
ool00oooH@;oooooooooo`08ooooo`03oomQ0_oooooooooo00;o00008oooool2o`0001;ooooo00?o
of42ooooooooool00_l0nYX00ooooooo003oooooo`09ooooo`;o0?ZJ00?o003oooooooooool00_oo
ool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Wooooo1?l0nYX4ooooo`Go0?ZJ3ooo
ool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo03[ooooo0ol0nYX00ol00?oooooooooo
o`07ooooo`?o0?ZJ0_ooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00Gooooo00?o
003oooooooooool01Ol000000ol0nY[oooooo`00o`04ooooo`03oomQ0_oooooooooo01[ooooo0_l0
000Booooo`005_ooool2o`0000Cooooo00Co0000oooooooooooooooo1Ol00002ooooo`?o00001_oo
ool00ol0003oooooooooo`0Aooooo`03oomQ0_oooooooooo00;ooooo0_l0nYX8ooooo`;o0?ZJ00?o
ooooo`00ooooool02_ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo02Oooooo00?o
of42ooooooooool00oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo02Sooooo00?o
003oooooooooool00_ooool2o`3jVP?ooooo00Co003oooooool0nY[o0?ZJ1?ooool00oooH@;ooooo
ooooo`0<ooooo`03oomQ0_oooooooooo00Cooooo00?o003oooooooooool01Ol00002ooooo`03o`00
oooooooooooo00Cooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`07ooooo`05oomQ
0_ooooooooooooooool000002_ooool2o`0000Cooooo00Co0000oooooooooooooooo1Ol00002oooo
o`?o00001Oooool00ol0003oooooooooo`0Aooooo`03oomQ0_oooooooooo00;o0?ZJ0_ooool00ol0
0?ooooooooooo`06ooooo`?o0?ZJ00?o003oooooooooool00_ooool00oooH@;oooooooooo`0<oooo
o`03oomQ0_oooooooooo00[ooooo2_l0nYX@ooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooo
ooooool0>_ooool2o`3jVP03o`00oooooooooooo00Oooooo0_l0nYX3ooooo`03oomQ0_oooooooooo
00oooooo00?oof42ooooooooool01?ooool00ol00?ooooooooooo`05o`0000;ooooo00?o003ooooo
ooooool00_ooool00oooH@;oooooooooo`0Kooooo`03o`000?oooooooooo013ooooo000Eooooo`04
o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool04Oooool00oooH@;oooooooooo`02ooooo`;o0?ZJ2?oo
ool2o`3jVP03ooooool00?oooooo00[ooooo00?oof42ooooooooool01_ooool00oooH@;ooooooooo
o`0Wooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool04Oooool2oomQ0RWooooo00?o
003oooooooooool00_ooool2o`3jVP?ooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool00oooH@;ooooo
ooooo`0=ooooo`03oomQ0_oooooooooo00Cooooo00?o003oooooool000001?l000000ooooooo003o
ooooo`06ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01oooool01OooH@;ooooo
oooooooooooo000000Wooooo00Co0000oooooooooooo00002?ooool01_l0003oooooooooool0003o
ooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Aooooo`03oomQ0_oo
oooooooo00;o0?ZJ0_ooool00ol00?ooooooooooo`06ooooo`;o0?ZJ00?oooooo`00ooooool00ooo
ool00oooH@;oooooooooo`0=ooooo`03oomQ0_oooooooooo00_ooooo1_l0nYXBooooo`03oomQ0_oo
oooooooo00Oooooo00?oof42ooooooooool04Oooool2oomQ0ROooooo0ol0nYX9ooooo`;o0?ZJ0ooo
ool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Gooooo00?o003oooooool000001?l0
00000ooooooo003oooooo`04ooooo`03oomQ0_oooooooooo01_ooooo00?o0000ooooooooool04?oo
ool001Gooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool04_ooool01?ooH@;oooooooooooooool2o`3jVPOooooo
0ol0nYX00ooooooo003oooooo`0:ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0
9_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooH@80
:Oooool01?l00?ooooooooooooooool2o`3jVP?ooooo00?o003oo`3jV_l0nYX01Oooool00oooH@;o
ooooooooo`0=ooooo`03oomQ0_oooooooooo00Cooooo00?o003oooooooooool00ol000000ooooooo
003oooooo`07ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01oooool01OooH@;o
oooooooooooooooo000000Wooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04Oooool00oooH@;oooooooooo`03
o`3jVP03ooooool00?oooooo00Kooooo0ol0nYX00ooooooo003oooooo`03ooooo`03oomQ0_oooooo
oooo00gooooo00?oof42ooooooooool08oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooo
oooo017ooooo00?oof42ooooooooH@809oooool2o`3jVP03o`00oooooooooooo00Kooooo0_l0nYX3
ooooo`03oomQ0_oooooooooo013ooooo00?oof42ooooooooool01?ooool00ol00?ooooooooooo`03
o`000003ooooool00?oooooo00Cooooo00?oof42ooooooooool07?ooool00ol0003oooooooooo`0@
ooooo`005Oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool00oooool2o`0001?ooooo00Coof42oooooooooooooooo0ol0nYX5ooooo`?o0?ZJ00?o
ooooo`00ooooool02?ooool2oomQ0P03ooooooooH@;ooooo00Sooooo00?oof42ooooooooool09_oo
ool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo013ooooo00Coof42ooooooooooooof42
:?ooool01?l00?ooooooooooooooool2o`3jVP?ooooo0ol0nYX5ooooo`03oomQ0_oooooooooo00ko
oooo00?oof42ooooooooool00oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Oo
oooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooo000000;o
00002Oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00_ooool3o`00017ooooo00Coof42oooooooooooooooo0_l0nYX00ooooooo003oooooo`06
ooooo`;o0?ZJ00?oooooo`00ooooool00oooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooo
oooo02;ooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0?ooooo`05oomQ0_oooooo
ooooooooooooH@809_ooool3o`3jVPOooooo0ol0nYX2ooooo`03oomQ0_oooooooooo017ooooo00?o
of42ooooooooool01?ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Cooooo00?o
of42ooooooooool06_ooool3o`0001;ooooo000Eooooo`04o`000?ooooooooooo`0000Oooooo00Ko
0000ooooooooooooooooo`000?ooool4o`0000Kooooo00?o0000ooooooooool04_ooool00oooH@;o
ooooooooo`02ooooo`;o0?ZJ1?ooool3o`3jVP;ooooo00?o003oooooooooool01_ooool00oooH@;o
ooooooooo`02oomQ0PWooooo00?oof42ooooooooool09_ooool00oooH@;oooooooooo`04ooooo`03
oomQ0_oooooooooo013ooooo00Coof42ooooooooooooof42:?ooool01?l00?ooooooooooooooool3
o`3jVP04ooooool00?oo0?ZJo`3jVPKooooo00?oof42ooooooooool03_ooool00oooH@;ooooooooo
o`04ooooo`05o`00ooooooooooooooooool00?l02_ooool00oooH@;oooooooooo`0<ooooo`03oomQ
0_oooooooooo00Kooooo00Goof42ooooooooooooooooo`000009ooooo`04o`000?ooooooooooo`00
00Oooooo00Ko0000ooooooooooooooooo`000?ooool4o`0000Gooooo00?o0000ooooooooool04_oo
ool00oooH@;oooooooooo`02o`3jVP;ooooo00?o003oooooooooool00oooool3o`3jVP03ooooool0
0?oooooo00?ooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`0Rooooo`03oomQ0_oo
oooooooo00Wooooo00?oof42ooooooooool03_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oo
oooooooo02Gooooo0_l0nYX7ooooo`;o0?ZJ0oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oo
oooooooo00Cooooo00Go003oooooooooooooooooo`00o`06ooooo`03oomQ0_oooooooooo01gooooo
00?o0000ooooooooool04?ooool001Gooooo00Co0000oooooooooooo00001oooool01ol0003ooooo
oooooooooooo0000ooooool000002Oooool00ol0003oooooooooo`0Booooo`03oomQ0_oooooooooo
00;ooooo0_l0nYX3ooooo`?o0?ZJ0oooool00ol00?ooooooooooo`05ooooo`03oomQ0_oooooooooo
00;ooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0Vooooo`03oomQ0_oooooooooo
00Gooooo00?oof42ooooooooool03oooool01OooH@;oooooooooooooooooof4202Oooooo00?o003o
ooooooooool00_ooool2o`3jVP04ooooool00?oo0?ZJo`3jVPKooooo00?oof42ooooooooool03ooo
ool00oooH@;oooooooooo`03ooooo`Co003o2_ooool00oooH@;oooooooooo`0=ooooo`03oomQ0_oo
oooooooo00Kooooo00Goof42ooooooooooooooooo`000009ooooo`04o`000?ooooooooooo`0000Oo
oooo00Oo0000ooooooooooooooooo`000?oooooo000000Sooooo00?o0000ooooooooool04_ooool0
0oooH@;oooooooooo`03o`3jVP03ooooool00?oooooo00Cooooo0_l0nYX2ooooo`03o`00oooooooo
oooo00;ooooo00?oof42ooooooooool03oooool00oooH@;oooooooooo`0Qooooo`03oomQ0_oooooo
oooo00[ooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooo
oooo02Cooooo0_l0nYX7ooooo`;o0?ZJ0oooool00oooH@;oooooooooo`0Booooo`03oomQ0_oooooo
oooo00Cooooo1?l00?l7ooooo`03oomQ0_oooooooooo01gooooo00?o0000ooooooooool04?ooool0
01Kooooo0_l00009ooooo`?o00000_ooool5o`0000Gooooo00?o0000ooooooooool04_ooool00ooo
H@;oooooooooo`02ooooo`Oo0?ZJ0oooool00ol00?ooooooooooo`06ooooo`03oomQ0_oooooooooo
00gooooo00?oof42ooooooooool09Oooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo
00oooooo00Goof42oooooooooooooooooomQ0P0Wooooo`03o`00oooooooooooo00;ooooo0_l0nYX0
1?l00?oo0?ZJo`3jV_l0nYX6ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool04Ooo
ool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00Gooooo00Goof42oooooooooooooooo
o`00000:ooooo`;o00002Oooool3o`0000;ooooo1Ol00004ooooo`03o`000?oooooooooo01;ooooo
00Coof42oooooooooooooooo0ol0nYX00ol00?ooooooooooo`02ooooo`?o0?ZJ00?oooooo`00oooo
ool01?ooool00oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo023ooooo00?oof42oooooooo
ool02oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oooooooooo00Cooooo00?oof42oooooooo
ool09?ooool3o`3jVPGooooo0ol0nYX2ooooo`03oomQ0_oooooooooo01Cooooo00?oof42oooooooo
ool03Oooool00oooH@;oooooooooo`0Nooooo`03o`000?oooooooooo013ooooo000`ooooo`;o0000
5?ooool01?ooH@;oooooooooooooool6o`3jVPCooooo00?o003oooooooooool01Oooool00oooH@;o
ooooooooo`0>ooooo`03oomQ0_oooooooooo02Gooooo00?oof42ooooooooool01Oooool00oooH@;o
ooooooooo`0>ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool09_ooool01?l00?oo
ooooooooooooool2o`3jVP03o`00ool0nY[o0?ZJ00Oooooo00?oof42ooooooooool03oooool00ooo
H@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool01Oooool00ooo
H@;oooooooooo`02o`0002?ooooo0_l0000Dooooo`04oomQ0_ooooooooooooooo`;o0?ZJ00?o003o
ooooooooool00_ooool2o`3jVP03ooooool00?oooooo00Gooooo00?oof42ooooooooool03oooool0
0oooH@;oooooooooo`0Pooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool02oooool0
0oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo02Gooooo0_l0nYX4ooooo`?o0?ZJ0oooool0
0oooH@;oooooooooo`0Dooooo`03oomQ0_oooooooooo00gooooo00?oof42ooooooooool07Oooool2
o`0001;ooooo000`ooooo`03o`000?oooooooooo01?ooooo00?oof42ooooooooool00oooool00ol0
0?oo0?ZJo`3jVP05ooooo`03o`00oooooooooooo00Cooooo00?oof42ooooooooool03oooool00ooo
H@;oooooooooo`0Uooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool03Oooool00ooo
H@;oooooooooo`03ooooo`03oomQ0_oooooooooo02Gooooo1?l00?l5o`3jVPKooooo00?oof42oooo
ooooool04Oooool00oooH@;oooooooooo`0@ooooo`03oomQ0_oooooooooo00oooooo00?oof42oooo
ooooool01?ooool01OooH@;ooooooooooooooooo000002?ooooo00?o0000ooooooooool04oooool0
1?ooH@;oooooooooooooool3o`3jVP;ooooo1?l0nYX00ooooooo003oooooo`04ooooo`03oomQ0_oo
oooooooo017ooooo00?oof42ooooooooool07oooool00oooH@;oooooooooo`0<ooooo`03oomQ0_oo
oooooooo00[ooooo00?oof42ooooooooool01_ooool00oooH@;oooooooooo`0Cooooo`Koof422ooo
ool3o`3jVP?o003o0_l0nYX4ooooo`03oomQ0_oooooooooo01Cooooo00?oof42ooooooooool03?oo
ool00oooH@;oooooooooo`0Oooooo`03o`000?oooooooooo013ooooo000`ooooo`03o`000?oooooo
oooo01?ooooo00Coof42oooooooooooooooo0ol00006ooooo`03o`00oooooooooooo00Gooooo00?o
of42ooooooooool03oooool00oooH@;oooooooooo`0Uooooo`03oomQ0_oooooooooo00Kooooo00?o
of42ooooooooool03Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo02Wooooo1?l0
nYX7ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool04?ooool00oooH@;ooooooooo
o`0?ooooo`03oomQ0_oooooooooo00Cooooo00Goof42ooooooooooooooooo`00000Sooooo`03o`00
0?oooooooooo01?ooooo00?oof42ooooooooool00_ooool3o`0000Co0?ZJ00?oooooo`00ooooool0
1Oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo01kooooo00?oof42ooooooooool0
3Oooool00oooH@;oooooooooo`09ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool0
4_ooool00oooH@;oooooooooo`04ooooo`03oomQ0_oooooooooo00Wooooo1ol0nYX3ooooo`03oomQ
0_oooooooooo01Kooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Oooooo`03o`00
0?oooooooooo013ooooo000`ooooo`03o`000?oooooooooo01?ooooo00?oof42ooooooooool01Ol0
0005ooooo`03o`00oooooooooooo00Cooooo00?oof42ooooooooool04Oooool00oooH@;ooooooooo
o`0Tooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool03?ooool00oooH@;ooooooooo
o`04ooooo`03oomQ0_oooooooooo02Sooooo0ol0nYX8ooooo`03oomQ0_oooooooooo017ooooo00?o
of42ooooooooool01Oooool2oomQ0PWooooo00?oof42ooooooooool04?ooool00oooH@;ooooooooo
o`03ooooo`05oomQ0_ooooooooooooooool000008oooool00ol0003oooooooooo`0Cooooo`04oomQ
0_ooooooooooooooo`Go000000Go0?ZJooooooooooooooooo`00o`06ooooo`03oomQ0_oooooooooo
017ooooo00?oof42ooooooooool07_ooool00oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo
00Sooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo
00Gooooo00?oof42ooooooooool02_ooool5o`3jVPCooooo00?oof42ooooooooool05oooool00ooo
H@;oooooooooo`08ooooo`;oof428_ooool00ol0003oooooooooo`0@ooooo`00<?ooool2o`0001Go
oooo00?oof42ooooool000001?l00004ooooo`03o`00oooooooooooo00Gooooo00?oof42oooooooo
ool04Oooool00oooH@;oooooooooo`0Tooooo`03oomQ0_oooooooooo00Oooooo00?oof42oooooooo
ool03?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo01Kooooo4?ooH@800ooooooo
0?ZJo`3jVP09ooooo`03oomQ0_oooooooooo01;ooooo00?oof42ooooooooool01?ooool01?ooH@;o
oooooomQ0_ooH@86ooooo`03oomQ0_oooooooooo017ooooo00?oof42ooooooooool00_ooool01?oo
H@;oooooooooooooool2o`0002?ooooo0_l0000Eooooo`03oomQ0_oooooooooo00Go00000oooool0
0ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo01?ooooo00?oof42ooooooooool07?ooool0
0oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool02Oooool0
0oooH@;oooooooooo`0?ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool02_ooool2
o`3jVPKooooo00?oof42ooooooooool06?ooool00oooH@;oooooooooo`02ooooo`Goof428oooool2
o`0001;ooooo000`ooooo`03o`000?oooooooooo01Cooooo00?oof42ooooool000001?l00004oooo
o`03o`00oooooooooooo00Gooooo00?oof42ooooooooool04Oooool00oooH@;oooooooooo`0Toooo
o`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`05oooo
o`03oomQ0_oooooooooo01?ooooo0oooH@8@ooooo`03oomQ0_oooooooooo00Wooooo00?oof42oooo
ooooool04oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooo
ooooool00oooool00oooH@;oooooooooo`0Booooo`05oomQ0_ooooooooooooooooooH@801?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?oof42ooooooooool01Ol00003
ooooo`03o`00oooooooooooo00Cooooo00?oof42ooooooooool04oooool00oooH@;oooooooooo`0L
ooooo`03oomQ0_oooooooooo00oooooo00?oof42ooooooooool01oooool00oooH@;oooooooooo`0:
ooooo`03oomQ0_oooooooooo00cooooo0_ooH@8;ooooo`03oomQ0_oooooooooo017ooooo00?oof42
ooooooooool06Oooool4oomQ0RWooooo00?o0000ooooooooool04?ooool0033ooooo00?o0000oooo
ooooool05Oooool00oooH@;oooooo`000002o`000005o`00ooooooooooooooooool00?l01oooool0
0oooH@;oooooooooo`0Cooooo`03oomQ0_oooooooooo02;ooooo00?oof42ooooooooool02Oooool0
0oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool04?ooool2
oomQ0Q?ooooo00?oof42ooooooooool02?ooool00oooH@;oooooooooo`0Eooooo`04oomQ0_oooooo
oooooomQ0PKooooo0_ooH@82ooooo`;oof425?ooool01OooH@;oooooooooooooooooof4200Cooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Dooooo`04oomQ0_ooooooooooooooo`?o
00001?ooool00ol00?ooooooooooo`04ooooo`03oomQ0_oooooooooo01Cooooo00?oof42oooooooo
ool06_ooool00oooH@;oooooooooo`0Aooooo`03oomQ0_oooooooooo00Kooooo00?oof42oooooooo
ool02oooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oooooooooo00cooooo00?oof42oooooooo
ool03oooool00oooH@;oooooooooo`17ooooo`03o`000?oooooooooo013ooooo000`ooooo`03o`00
0?oooooooooo01Gooooo00?oof42ooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Oo
oooo00?oof42ooooooooool04oooool00oooH@;oooooooooo`0Rooooo`03oomQ0_oooooooooo00Wo
oooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`06ooooo`03oomQ0_oooooooooo00go
oooo0oooH@8Eooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool05oooool00oooH@;o
oooooomQ0P08ooooo`;oof425oooool01?ooH@;oooooooooooooH@84ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool05Oooool00oooH@;oooooooooo`03ooooo`04o`00oooooooooooo
o`00o`Oooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Jooooo`03oomQ0_oooooo
oooo01;ooooo00?oof42ooooooooool00oooool2oomQ0Pkooooo00?oof42ooooooooool02Oooool0
0oooH@;oooooooooo`0>ooooo`03oomQ0_oooooooooo00kooooo00?oof42ooooooooool0Aoooool0
0ol0003oooooooooo`0@ooooo`00<?ooool2o`0001Kooooo00?oof42ooooooooool00oooool3o`00
o`Sooooo00?oof42ooooooooool05?ooool00oooH@;oooooooooo`0Qooooo`03oomQ0_oooooooooo
00Wooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo
00[ooooo0_ooH@8Hooooo`03oomQ0_oooooooooo00Kooooo00?oof42ooooooooool06Oooool00ooo
H@;oooooooooo`0Qooooo`03oomQ0_ooooooof4200?ooooo0_l0000Sooooo`;o00005_ooool00ooo
H@;oooooooooo`03ooooo`04o`00oooooooo003oo`00o`Kooooo00?oof42ooooooooool05Oooool0
0oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo01Cooooo00Goof42oooooooooooooooooomQ
0P0Aooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool03oooool00oooH@;ooooooooo
o`0=ooooo`03oomQ0_oooooooooo04Kooooo0_l0000Booooo`00<?ooool00ol0003oooooooooo`0F
ooooo`03oomQ0_oooooooooo00;ooooo00?o003oooooooooool02?ooool00oooH@;oooooooooo`0D
ooooo`03oomQ0_oooooooooo027ooooo00?oof42ooooooooool02_ooool00oooH@;oooooooooo`0:
ooooo`03oomQ0_oooooooooo00Oooooo00?oof42ooooooooool02Oooool00oooH@;oooooooooo`0I
ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool0?oooool2oomQ0PCooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Eooooo`03oomQ0_oooooooooo00?ooooo0_l00?l8
ooooo`03oomQ0_oooooooooo01Kooooo00?oof42ooooooooool06?ooool00oooH@;oooooooooo`0E
ooooo`?oof424_ooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo017ooooo00?oof42
ooooooooool03?ooool00oooH@;oooooooooo`17ooooo`03o`000?oooooooooo013ooooo000`oooo
o`03o`000?oooooooooo01Kooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`0Eoooo
o`03oomQ0_oooooooooo023ooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`09oooo
o`03oomQ0_oooooooooo00Sooooo0_ooH@88ooooo`03oomQ0_oooooooooo01[ooooo0ol00003oooo
o`03oomQ0_oooooooooo047ooooo00?oof42ooooooooool00_ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Kooooo00?oof42ooooooooool03?ooool00oooH@;oooooooooo`0Foooo
o`03oomQ0_oooooooooo01Oooooo00?oof42ooooooooool0;?ooool3oomQ0PCooooo0_ooH@8Eoooo
o`03oomQ0_oooooooooo00Kooooo0ol000000oooooooof42ooooo`19ooooo`03o`000?oooooooooo
013ooooo000`ooooo`03o`000?oooooooooo01Oooooo00?oof42ooooooooool02oooool00oooH@;o
ooooooooo`0Fooooo`03oomQ0_oooooooooo023ooooo00?oof42ooooooooool03?ooool00oooH@;o
ooooooooo`07ooooo`03oomQ0_oooooooooo00_ooooo00?oof42ooooooooool01?ooool00oooH@;o
ooooooooo`0Jooooo`Go00000_ooool00oooH@;oooooooooo`16ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool05_ooool00oooH@;oooooooooo`0;ooooo`03oomQ0_oooooooooo01Oo
oooo00?oof42ooooooooool05oooool00oooH@;oooooooooo`0_ooooo`Coof426?ooool00oooH@;o
ooooooooo`04ooooo`Go000000?oof42ooooooooool0B?ooool00ol0003oooooooooo`0@ooooo`00
<?ooool2o`0001Sooooo00?oof42ooooooooool02oooool00oooH@;oooooooooo`0Gooooo`03oomQ
0_oooooooooo01oooooo00?oof42ooooooooool03Oooool00oooH@;oooooooooo`06ooooo`03oomQ
0_oooooooooo00cooooo1_ooH@8Mooooo`Go000000?ooooooomQ0_ooool0Aoooool2o`0002?ooooo
0_l0000Hooooo`03oomQ0_oooooooooo00[ooooo00?oof42ooooooooool06?ooool00oooH@;ooooo
ooooo`0Eooooo`03oomQ0_oooooooooo04gooooo00?oof42ooooooooool00oooool5o`000003oomQ
0_oooooooooo04Oooooo0_l0000Booooo`007?ooool2o`0000Cooooo00?o0000ooooooooool00_oo
ool3o`0000Kooooo00?o0000ooooooooool06?ooool00oooH@;oooooooooo`0:ooooo`03oomQ0_oo
oooooooo01Oooooo00?oof42ooooooooool05?ooool<oomQ0Q3ooooo0_ooH@86ooooo`03oomQ0_oo
oooooooo02oooooo1Ol000000oooH@;oooooooooo`18ooooo`03o`000?oooooooooo00kooooo0_l0
0004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo01Sooooo00?o
of42ooooooooool02Oooool00oooH@;oooooooooo`0Iooooo`03oomQ0_oooooooooo01?ooooo00?o
of42ooooooooool0Coooool00oooH@;oooooooooo`02ooooo`Go0000Boooool00ol0003ooooooooo
o`0@ooooo`006oooool01?l0003oooooooooool00007ooooo`05o`000?ooooooooooooooool00000
1Oooool00ol0003oooooooooo`0Iooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool0
6Oooool00oooH@;oooooooooo`0@ooooo`?oof427_ooool00oooH@;oooooooooo`03ooooo`03oomQ
0_oooooooooo033ooooo0ol000000oooooooof42ooooo`19ooooo`03o`000?oooooooooo00gooooo
00Co0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooo
ooooool06Oooool00oooH@;oooooooooo`07ooooo`03oomQ0_oooooooooo01[ooooo00?oof42oooo
ooooool04_ooool00oooH@;oooooooooo`1Aooooo`03oomQ0_oooooooooo00;ooooo0ol0001<oooo
o`03o`000?oooooooooo013ooooo000Kooooo`04o`000?ooooooooooo`0000_ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0Jooooo`03oomQ0_oooooooooo00Kooooo00?oof42oooo
ooooool06oooool00oooH@;oooooooooo`0=ooooo`;oof428_ooool2oomQ0P?ooooo00?oof42oooo
ooooool0<Oooool00oooH@;ooooooomQ0P1;ooooo`03o`000?oooooooooo00gooooo00Co0000oooo
oooooooo00002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo01Wooooo00?oof42
ooooooooool01oooool00oooH@;oooooooooo`0Kooooo`03oomQ0_oooooooooo013ooooo00?oof42
ooooooooool0Doooool3oomQ0P?ooooo00?oof42ooooooooool0B_ooool00ol0003oooooooooo`0@
ooooo`006oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00?ooooo0_l0000L
ooooo`03oomQ0_oooooooooo00Cooooo00?oof42ooooooooool07Oooool00oooH@;oooooooooo`07
ooooo`Goof429_ooool4oomQ0S?ooooo0_ooH@9:ooooo`?o00003oooool01?l0003oooooooooool0
000;ooooo`03o`000?oooooooooo00;ooooo0ol0000Jooooo`03oomQ0_oooooooooo00Kooooo00?o
of42ooooooooool07?ooool00oooH@;oooooooooo`0=ooooo`;oof42FOooool3oomQ0T_ooooo0ol0
000Booooo`006oooool01?l0003oooooooooool00007ooooo`Co00001_ooool00ol0003ooooooooo
o`0Looooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool07oooool2oomQ0PCooooo0ooo
H@9Rooooo`03oomQ0_oooooooooo04_ooooo00?o0000ooooooooool03Oooool01?l0003ooooooooo
ool00007ooooo`Co00001Oooool00ol0003oooooooooo`0Kooooo`;oof421Oooool00oooH@;ooooo
ooooo`0Nooooo`;oof423?ooool00oooH@;oooooooooo`2Yooooo`03o`000?oooooooooo013ooooo
000Kooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0Mooooo`Coof429?ooool4oomQ0[?ooooo00?o0000ooooooooool03Oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool07Oooool01OooH@;o
ooooooooooooooooof4202?ooooo00?oof42ooooooooool01oooool2oomQ0Zcooooo00?o0000oooo
ooooool04?ooool001cooooo0_l00008ooooo`Go00001Oooool00ol0003oooooooooo`3looooo`03
o`000?oooooooooo00kooooo0_l00008ooooo`Go00001?ooool00ol0003oooooooooo`0Nooooo`?o
of429Oooool2oomQ0PGooooo0_ooH@:^ooooo`03o`000?oooooooooo013ooooo000`ooooo`;o0000
o?ooool2o`0002?ooooo0_l00019ooooo`Goof42[oooool2o`0001;ooooo000`ooooo`03o`000?oo
oooooooo0?cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3mooooo`03o`000?oo
oooooooo013ooooo000`ooooo`03o`000?oooooooooo0?cooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000`ooooo`;o0000o?ooool2o`00
02?ooooo0_l0003mooooo`;o00004_ooool0033ooooo00?o0000ooooooooool0o?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo00?o0000ooooooooool04?ooool0033ooooo
00?o0000ooooooooool0o?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo
00?o0000ooooooooool04?ooool0033ooooo00?o0000ooooooooool0o?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo0?gooooo00?o0000ooooooooool04?ooool0033ooooo0_l0003l
ooooo`;o00008oooool2o`000?gooooo0_l0000Booooo`00<?ooool00ol0003oooooooooo`3loooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`0@oooo
o`00<?ooool00ol0003oooooooooo`3looooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0oOooool00ol0003oooooooooo`0@ooooo`00<?ooool00ol0003oooooooooo`3looooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`0@ooooo`00<?oo
ool2o`000?cooooo0_l0000Sooooo`;o0000oOooool2o`0001;ooooo000`ooooo`03o`000?oooooo
oooo0?cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooo
oooo013ooooo000Fooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00;ooooo0ol00006ooooo`03o`000?oooooooooo0?cooooo00?o0000ooooooooool02?ooool2o`00
00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0
003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000Eooooo`04o`000?ooooooooooo`00
00Wooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0o?ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Wooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
oOooool00ol0003oooooooooo`0@ooooo`005Oooool01?l0003oooooooooool0000:ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00oooool2o`000?_ooooo0ol00009ooooo`04o`00
0?ooooooooooo`0000[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`?o
0000noooool3o`0001;ooooo000Eooooo`04o`000?ooooooooooo`0000[ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?cooooo00?o0000oooooooo
ool01oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000Eooooo`04
o`000?ooooooooooo`0000_ooooo00?o0000ooooool000000ol00006ooooo`03o`000?oooooooooo
0?cooooo00?o0000ooooooooool01oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooo
000000?o00001Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000Eoooo
o`04o`000?ooooooooooo`0000Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000Wooooo
00?o0000ooooooooool0o?ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Oo
oooo00Oo0000ooooooooooooooooo`000?oooooo000000Sooooo00?o0000ooooooooool0oOooool0
0ol0003oooooooooo`0@ooooo`005_ooool2o`0000Sooooo1Ol000000ooooooo0000o`000003o`00
00Gooooo0_l0003looooo`;o00002_ooool2o`0000Sooooo1Ol000000ooooooo0000o`000003o`00
00Cooooo0_l0003mooooo`;o00004_ooool0033ooooo00?o0000ooooooooool0o?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo00?o0000ooooooooool04?ooool0033ooooo
00?o0000ooooooooool0o?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo
00?o0000ooooooooool04?ooool0033ooooo00?o0000ooooooooool0o?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo0?gooooo00?o0000ooooooooool04?ooool0033ooooo0_l0003l
ooooo`;o00008oooool2o`000?gooooo0_l0000Booooo`00<?ooool00ol0003oooooooooo`3loooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`0@oooo
o`00<?ooool00ol0003oooooooooo`3looooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0oOooool00ol0003oooooooooo`0@ooooo`00<?ooool00ol0003oooooooooo`3looooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`0@ooooo`00<?oo
ool2o`000?cooooo0_l0000Sooooo`;o0000oOooool2o`0001;ooooo000`ooooo`03o`000?oooooo
oooo0?cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooo
oooo013ooooo000`ooooo`03o`000?oooooooooo0?cooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`3mooooo`03o`000?oooooooooo013ooooo000`ooooo`03o`000?oooooooooo0?co
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo013o
oooo000`ooooo`;o0000o?ooool2o`0002?ooooo0_l0003mooooo`;o00004_ooool0033ooooo00?o
0000ooooooooool0o?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?gooooo00?o
0000ooooooooool04?ooool002Oooooo0ol00006ooooo`03o`000?oooooo0000037ooooo00?o0000
ooooooooool0;oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0;oooool01?l0003oooooooooool0000Kooooo`?o00001Oooool01?l0003ooooooooo
ool0000aooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo02oooooo00Co0000oooooooooooo00004_ooool002Sooooo
00?o0000ooooooooool01Oooool00ol0003oooooo`00000<ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo
00Co0000oooooooooooo00007?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02Oooool01?l0003oooooooooool0000Booooo`00:?ooool00ol0
003oooooooooo`05oooooooo00000Ol0000Looooo`03o`000?oooooooooo00Coooooool00002o`00
01;ooooo000Xooooo`03o`000?oooooooooo0?oooooo8_ooool00ol0003oooooooooo`3ooooooaSo
oooo000Xooooo`03o`000?oooooooooo0?oooooo8_ooool00ol0003oooooooooo`3ooooooaSooooo
000Wooooo`;o0000oooooolSooooo`;o0000oooooolJooooo`00:?ooool00ol0003oooooooooo`3o
ooooob;ooooo00?o0000ooooooooool0oooooolHooooo`00ooooooooooooofSooooo003ooooooooo
ooooJ?ooool00?oooooooooooomXooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool0
0?oooooooooooomXooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool00?oooooooooo
oomXooooo`00ooooooooooooofSooooo003oooooooooooooJ?ooool00?oooooooooooomXooooo`00
\
\>"],
  ImageRangeCache->{{{0, 613.5}, {378.812, 0}} -> {-0.0509671, -0.0309017, \
0.00342614, 0.00342614}, {{14.875, 306.75}, {369.75, 189.375}} -> {-1.74583, \
-2.5558, 0.0390554, 0.0247817}, {{306.75, 598.625}, {369.75, 189.375}} -> \
{-13.1451, -2.5558, 0.0390554, 0.0247817}, {{14.875, 306.75}, {189.375, 9}} -> \
{-2.02126, -3.59478, 0.0399713, 0.0126813}, {{306.75, 598.625}, {189.375, 9}} -> \
{-13.6879, -3.59478, 0.0399713, 0.0126813}}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["filtering and smoothing errors", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["estimated parameters", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\

g = 
Table[
plot1[PF[[T1//Range,{1},i,j]]~ii~PG[[T1//Range,{1},i,j]]
\t\t//AddTimeAxis[#,{0,10,.1}]&,DisplayFunction->Identity]
,{i,1,2},{j,i,2}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Show[GraphicsArray[g//Flatten]];", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20601 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00490503 0.31746 [
[ 0 0 0 0 ]
[ 1 .20601 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .20601 L
0 .20601 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00490503 0.34127 0.201106 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 -0.0252594 17.017 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05983 -30 -4.5 ]
[-0.0125 .05983 0 4.5 ]
[-0.0125 .14491 -24 -4.5 ]
[-0.0125 .14491 0 4.5 ]
[-0.0125 .23 -30 -4.5 ]
[-0.0125 .23 0 4.5 ]
[-0.0125 .31508 -24 -4.5 ]
[-0.0125 .31508 0 4.5 ]
[-0.0125 .40017 -30 -4.5 ]
[-0.0125 .40017 0 4.5 ]
[-0.0125 .48525 -24 -4.5 ]
[-0.0125 .48525 0 4.5 ]
[-0.0125 .57034 -30 -4.5 ]
[-0.0125 .57034 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .09056 -5 -6 ]
[.97619 .09056 5 6 ]
[.97619 .09056 -5 -6 ]
[.97619 .09056 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05983 m
.00625 .05983 L
s
[(0.005)] -0.0125 .05983 1 0 Mshowa
0 .14491 m
.00625 .14491 L
s
[(0.01)] -0.0125 .14491 1 0 Mshowa
0 .23 m
.00625 .23 L
s
[(0.015)] -0.0125 .23 1 0 Mshowa
0 .31508 m
.00625 .31508 L
s
[(0.02)] -0.0125 .31508 1 0 Mshowa
0 .40017 m
.00625 .40017 L
s
[(0.025)] -0.0125 .40017 1 0 Mshowa
0 .48525 m
.00625 .48525 L
s
[(0.03)] -0.0125 .48525 1 0 Mshowa
0 .57034 m
.00625 .57034 L
s
[(0.035)] -0.0125 .57034 1 0 Mshowa
.125 Mabswid
0 .07684 m
.00375 .07684 L
s
0 .09386 m
.00375 .09386 L
s
0 .11088 m
.00375 .11088 L
s
0 .12789 m
.00375 .12789 L
s
0 .16193 m
.00375 .16193 L
s
0 .17894 m
.00375 .17894 L
s
0 .19596 m
.00375 .19596 L
s
0 .21298 m
.00375 .21298 L
s
0 .24701 m
.00375 .24701 L
s
0 .26403 m
.00375 .26403 L
s
0 .28105 m
.00375 .28105 L
s
0 .29806 m
.00375 .29806 L
s
0 .3321 m
.00375 .3321 L
s
0 .34912 m
.00375 .34912 L
s
0 .36613 m
.00375 .36613 L
s
0 .38315 m
.00375 .38315 L
s
0 .41718 m
.00375 .41718 L
s
0 .4342 m
.00375 .4342 L
s
0 .45122 m
.00375 .45122 L
s
0 .46823 m
.00375 .46823 L
s
0 .50227 m
.00375 .50227 L
s
0 .51929 m
.00375 .51929 L
s
0 .5363 m
.00375 .5363 L
s
0 .55332 m
.00375 .55332 L
s
0 .04281 m
.00375 .04281 L
s
0 .02579 m
.00375 .02579 L
s
0 .00877 m
.00375 .00877 L
s
0 .58735 m
.00375 .58735 L
s
0 .60437 m
.00375 .60437 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05983 m
1 .05983 L
s
.99375 .14491 m
1 .14491 L
s
.99375 .23 m
1 .23 L
s
.99375 .31508 m
1 .31508 L
s
.99375 .40017 m
1 .40017 L
s
.99375 .48525 m
1 .48525 L
s
.99375 .57034 m
1 .57034 L
s
.125 Mabswid
.99625 .07684 m
1 .07684 L
s
.99625 .09386 m
1 .09386 L
s
.99625 .11088 m
1 .11088 L
s
.99625 .12789 m
1 .12789 L
s
.99625 .16193 m
1 .16193 L
s
.99625 .17894 m
1 .17894 L
s
.99625 .19596 m
1 .19596 L
s
.99625 .21298 m
1 .21298 L
s
.99625 .24701 m
1 .24701 L
s
.99625 .26403 m
1 .26403 L
s
.99625 .28105 m
1 .28105 L
s
.99625 .29806 m
1 .29806 L
s
.99625 .3321 m
1 .3321 L
s
.99625 .34912 m
1 .34912 L
s
.99625 .36613 m
1 .36613 L
s
.99625 .38315 m
1 .38315 L
s
.99625 .41718 m
1 .41718 L
s
.99625 .4342 m
1 .4342 L
s
.99625 .45122 m
1 .45122 L
s
.99625 .46823 m
1 .46823 L
s
.99625 .50227 m
1 .50227 L
s
.99625 .51929 m
1 .51929 L
s
.99625 .5363 m
1 .5363 L
s
.99625 .55332 m
1 .55332 L
s
.99625 .04281 m
1 .04281 L
s
.99625 .02579 m
1 .02579 L
s
.99625 .00877 m
1 .00877 L
s
.99625 .58735 m
1 .58735 L
s
.99625 .60437 m
1 .60437 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .09056 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .11702 m
.03333 .11442 L
.04286 .14389 L
.05238 .21896 L
.0619 .31986 L
.07143 .0832 L
.08095 .14105 L
.09048 .24941 L
.1 .36964 L
.10952 .47049 L
.11905 .08908 L
.12857 .14058 L
.1381 .2502 L
.14762 .37405 L
.15714 .47762 L
.16667 .5356 L
.17619 .48725 L
.18571 .41314 L
.19524 .3763 L
.20476 .39022 L
.21429 .08435 L
.22381 .14637 L
.23333 .26985 L
.24286 .40158 L
.25238 .50498 L
.2619 .56685 L
.27143 .5922 L
.28095 .59468 L
.29048 .58819 L
.3 .58223 L
.30952 .58083 L
.31905 .58393 L
.32857 .58945 L
.3381 .59512 L
.34762 .59944 L
.35714 .60195 L
.36667 .60292 L
.37619 .60296 L
.38571 .60266 L
.39524 .60242 L
.40476 .09152 L
.41429 .14746 L
.42381 .27411 L
.43333 .41094 L
.44286 .51729 L
.45238 .57895 L
.4619 .60178 L
.47143 .60088 L
.48095 .59139 L
.49048 .58343 L
Mistroke
.5 .09077 L
.50952 .14687 L
.51905 .27375 L
.52857 .41077 L
.5381 .51726 L
.54762 .57897 L
.55714 .60179 L
.56667 .60087 L
.57619 .59137 L
.58571 .5834 L
.59524 .58105 L
.60476 .58396 L
.61429 .58965 L
.62381 .59554 L
.63333 .59998 L
.64286 .60247 L
.65238 .60332 L
.6619 .60321 L
.67143 .60279 L
.68095 .60246 L
.69048 .09152 L
.7 .09171 L
.70952 .12749 L
.71905 .20938 L
.72857 .31558 L
.7381 .08313 L
.74762 .14071 L
.75714 .24812 L
.76667 .36762 L
.77619 .46832 L
.78571 .089 L
.79524 .14058 L
.80476 .25019 L
.81429 .37401 L
.82381 .47755 L
.83333 .08939 L
.84286 .14072 L
.85238 .2502 L
.8619 .374 L
.87143 .47756 L
.88095 .08899 L
.89048 .03849 L
.9 .03409 L
.90952 .04335 L
.91905 .12304 L
.92857 .23982 L
.9381 .36095 L
.94762 .46029 L
.95714 .52656 L
.96667 .56178 L
Mistroke
.97619 .09056 L
Mfstroke
0 .98 .604 r
gsave
.97619 .09056 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .11331 m
.03333 .10495 L
.04286 .10339 L
.05238 .10136 L
.0619 .08675 L
.07143 .08065 L
.08095 .11291 L
.09048 .14957 L
.1 .14884 L
.10952 .11026 L
.11905 .08134 L
.12857 .11604 L
.1381 .20552 L
.14762 .32534 L
.15714 .44728 L
.16667 .51095 L
.17619 .45072 L
.18571 .3336 L
.19524 .21313 L
.20476 .11773 L
.21429 .08432 L
.22381 .14633 L
.23333 .26984 L
.24286 .40157 L
.25238 .50472 L
.2619 .56562 L
.27143 .5887 L
.28095 .58721 L
.29048 .5754 L
.3 .5642 L
.30952 .56007 L
.31905 .56532 L
.32857 .57834 L
.3381 .59293 L
.34762 .59771 L
.35714 .57721 L
.36667 .51661 L
.37619 .41053 L
.38571 .27364 L
.39524 .14681 L
.40476 .09073 L
.41429 .14673 L
.42381 .27393 L
.43333 .41021 L
.44286 .5089 L
.45238 .54434 L
.4619 .50875 L
.47143 .40998 L
.48095 .27373 L
.49048 .14664 L
Mistroke
.5 .09073 L
.50952 .14667 L
.51905 .27289 L
.52857 .40849 L
.5381 .51257 L
.54762 .57087 L
.55714 .58955 L
.56667 .58446 L
.57619 .57179 L
.58571 .56247 L
.59524 .56017 L
.60476 .56169 L
.61429 .55849 L
.62381 .53922 L
.63333 .49341 L
.64286 .41647 L
.65238 .31484 L
.6619 .2084 L
.67143 .12586 L
.68095 .08943 L
.69048 .08896 L
.7 .08398 L
.70952 .08981 L
.71905 .09503 L
.72857 .08482 L
.7381 .0794 L
.74762 .1092 L
.75714 .14274 L
.76667 .14216 L
.77619 .10901 L
.78571 .08556 L
.79524 .10851 L
.80476 .14127 L
.81429 .14195 L
.82381 .10902 L
.83333 .07913 L
.84286 .08086 L
.85238 .08104 L
.8619 .05998 L
.87143 .03797 L
.88095 .03551 L
.89048 .01985 L
.9 .01472 L
.90952 .04297 L
.91905 .11688 L
.92857 .21097 L
.9381 .2777 L
.94762 .28198 L
.95714 .22168 L
.96667 .13505 L
Mistroke
.97619 .09056 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00490503 0.65873 0.201106 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0.308932 7.09363 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02519 -30 -4.5 ]
[-0.0125 .02519 0 4.5 ]
[-0.0125 .16706 -30 -4.5 ]
[-0.0125 .16706 0 4.5 ]
[-0.0125 .30893 -6 -4.5 ]
[-0.0125 .30893 0 4.5 ]
[-0.0125 .4508 -24 -4.5 ]
[-0.0125 .4508 0 4.5 ]
[-0.0125 .59268 -24 -4.5 ]
[-0.0125 .59268 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31153 -5 -6 ]
[.97619 .31153 5 6 ]
[.97619 .31153 -5 -6 ]
[.97619 .31153 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02519 m
.00625 .02519 L
s
[(-0.04)] -0.0125 .02519 1 0 Mshowa
0 .16706 m
.00625 .16706 L
s
[(-0.02)] -0.0125 .16706 1 0 Mshowa
0 .30893 m
.00625 .30893 L
s
[(0)] -0.0125 .30893 1 0 Mshowa
0 .4508 m
.00625 .4508 L
s
[(0.02)] -0.0125 .4508 1 0 Mshowa
0 .59268 m
.00625 .59268 L
s
[(0.04)] -0.0125 .59268 1 0 Mshowa
.125 Mabswid
0 .06065 m
.00375 .06065 L
s
0 .09612 m
.00375 .09612 L
s
0 .13159 m
.00375 .13159 L
s
0 .20253 m
.00375 .20253 L
s
0 .238 m
.00375 .238 L
s
0 .27346 m
.00375 .27346 L
s
0 .3444 m
.00375 .3444 L
s
0 .37987 m
.00375 .37987 L
s
0 .41534 m
.00375 .41534 L
s
0 .48627 m
.00375 .48627 L
s
0 .52174 m
.00375 .52174 L
s
0 .55721 m
.00375 .55721 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02519 m
1 .02519 L
s
.99375 .16706 m
1 .16706 L
s
.99375 .30893 m
1 .30893 L
s
.99375 .4508 m
1 .4508 L
s
.99375 .59268 m
1 .59268 L
s
.125 Mabswid
.99625 .06065 m
1 .06065 L
s
.99625 .09612 m
1 .09612 L
s
.99625 .13159 m
1 .13159 L
s
.99625 .20253 m
1 .20253 L
s
.99625 .238 m
1 .238 L
s
.99625 .27346 m
1 .27346 L
s
.99625 .3444 m
1 .3444 L
s
.99625 .37987 m
1 .37987 L
s
.99625 .41534 m
1 .41534 L
s
.99625 .48627 m
1 .48627 L
s
.99625 .52174 m
1 .52174 L
s
.99625 .55721 m
1 .55721 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .31153 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .30893 m
.03333 .32338 L
.04286 .421 L
.05238 .502 L
.0619 .5264 L
.07143 .35515 L
.08095 .49487 L
.09048 .56043 L
.1 .54744 L
.10952 .48596 L
.11905 .32995 L
.12857 .49161 L
.1381 .56705 L
.14762 .55479 L
.15714 .48951 L
.16667 .30893 L
.17619 .14937 L
.18571 .18117 L
.19524 .28704 L
.20476 .38259 L
.21429 .33749 L
.22381 .52173 L
.23333 .59153 L
.24286 .56254 L
.25238 .48197 L
.2619 .39591 L
.27143 .33268 L
.28095 .3005 L
.29048 .29364 L
.3 .30071 L
.30952 .31123 L
.31905 .31877 L
.32857 .32128 L
.3381 .31968 L
.34762 .31605 L
.35714 .31237 L
.36667 .30975 L
.37619 .30849 L
.38571 .30828 L
.39524 .30862 L
.40476 .30896 L
.41429 .5217 L
.42381 .60216 L
.43333 .57177 L
.44286 .48477 L
.45238 .39257 L
.4619 .32601 L
.47143 .29353 L
.48095 .28834 L
.49048 .2977 L
Mistroke
.5 .30917 L
.50952 .52215 L
.51905 .60263 L
.52857 .57211 L
.5381 .48495 L
.54762 .39262 L
.55714 .32598 L
.56667 .29349 L
.57619 .2883 L
.58571 .29769 L
.59524 .31017 L
.60476 .31888 L
.61429 .32178 L
.62381 .32007 L
.63333 .31615 L
.64286 .3122 L
.65238 .30945 L
.6619 .30819 L
.67143 .30806 L
.68095 .3085 L
.69048 .30893 L
.7 .33398 L
.70952 .4356 L
.71905 .51509 L
.72857 .53516 L
.7381 .35627 L
.74762 .49318 L
.75714 .55847 L
.76667 .54649 L
.77619 .48621 L
.78571 .33021 L
.79524 .49167 L
.80476 .567 L
.81429 .55473 L
.82381 .48947 L
.83333 .32955 L
.84286 .49128 L
.85238 .56686 L
.8619 .55474 L
.87143 .48954 L
.88095 .30893 L
.89048 .32344 L
.9 .39252 L
.90952 .41808 L
.91905 .52448 L
.92857 .5681 L
.9381 .54535 L
.94762 .48279 L
.95714 .41224 L
.96667 .35593 L
Mistroke
.97619 .31153 L
Mfstroke
0 .98 .604 r
gsave
.97619 .31153 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30893 m
.03333 .29372 L
.04286 .31265 L
.05238 .2911 L
.0619 .27364 L
.07143 .33553 L
.08095 .39933 L
.09048 .35544 L
.1 .25895 L
.10952 .21566 L
.11905 .30652 L
.12857 .44751 L
.1381 .5349 L
.14762 .5738 L
.15714 .53255 L
.16667 .30893 L
.17619 .09686 L
.18571 .05002 L
.19524 .07419 L
.20476 .15873 L
.21429 .33747 L
.22381 .52175 L
.23333 .59159 L
.24286 .56241 L
.25238 .48091 L
.2619 .39273 L
.27143 .32621 L
.28095 .29053 L
.29048 .28194 L
.3 .29147 L
.30952 .30996 L
.31905 .32926 L
.32857 .34074 L
.3381 .33397 L
.34762 .2983 L
.35714 .22865 L
.36667 .13432 L
.37619 .0462 L
.38571 .01538 L
.39524 .09579 L
.40476 .30872 L
.41429 .52238 L
.42381 .60332 L
.43333 .56629 L
.44286 .45422 L
.45238 .30876 L
.4619 .16338 L
.47143 .05152 L
.48095 .01472 L
.49048 .09575 L
Mistroke
.5 .30917 L
.50952 .52138 L
.51905 .60054 L
.52857 .56818 L
.5381 .47887 L
.54762 .38457 L
.55714 .31699 L
.56667 .28547 L
.57619 .28344 L
.58571 .29682 L
.59524 .31029 L
.60476 .31084 L
.61429 .28962 L
.62381 .24411 L
.63333 .18101 L
.64286 .11825 L
.65238 .083 L
.6619 .10167 L
.67143 .18076 L
.68095 .2828 L
.69048 .30893 L
.7 .30647 L
.70952 .32918 L
.71905 .30384 L
.72857 .27896 L
.7381 .33322 L
.74762 .39226 L
.75714 .35098 L
.76667 .26494 L
.77619 .23068 L
.78571 .30841 L
.79524 .38615 L
.80476 .3525 L
.81429 .26777 L
.82381 .22687 L
.83333 .28191 L
.84286 .32518 L
.85238 .28606 L
.8619 .25257 L
.87143 .28338 L
.88095 .30893 L
.89048 .27401 L
.9 .32761 L
.90952 .41462 L
.91905 .49979 L
.92857 .49269 L
.9381 .39044 L
.94762 .24425 L
.95714 .13585 L
.96667 .14582 L
Mistroke
.97619 .31153 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00490503 0.97619 0.201106 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0.0147151 1.26556 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01472 -6 -4.5 ]
[-0.0125 .01472 0 4.5 ]
[-0.0125 .14127 -18 -4.5 ]
[-0.0125 .14127 0 4.5 ]
[-0.0125 .26783 -18 -4.5 ]
[-0.0125 .26783 0 4.5 ]
[-0.0125 .39438 -18 -4.5 ]
[-0.0125 .39438 0 4.5 ]
[-0.0125 .52094 -18 -4.5 ]
[-0.0125 .52094 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .54498 -5 -6 ]
[.97619 .54498 5 6 ]
[.97619 .54498 -5 -6 ]
[.97619 .54498 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01472 m
.00625 .01472 L
s
[(0)] -0.0125 .01472 1 0 Mshowa
0 .14127 m
.00625 .14127 L
s
[(0.1)] -0.0125 .14127 1 0 Mshowa
0 .26783 m
.00625 .26783 L
s
[(0.2)] -0.0125 .26783 1 0 Mshowa
0 .39438 m
.00625 .39438 L
s
[(0.3)] -0.0125 .39438 1 0 Mshowa
0 .52094 m
.00625 .52094 L
s
[(0.4)] -0.0125 .52094 1 0 Mshowa
.125 Mabswid
0 .04003 m
.00375 .04003 L
s
0 .06534 m
.00375 .06534 L
s
0 .09065 m
.00375 .09065 L
s
0 .11596 m
.00375 .11596 L
s
0 .16658 m
.00375 .16658 L
s
0 .19189 m
.00375 .19189 L
s
0 .2172 m
.00375 .2172 L
s
0 .24252 m
.00375 .24252 L
s
0 .29314 m
.00375 .29314 L
s
0 .31845 m
.00375 .31845 L
s
0 .34376 m
.00375 .34376 L
s
0 .36907 m
.00375 .36907 L
s
0 .41969 m
.00375 .41969 L
s
0 .445 m
.00375 .445 L
s
0 .47032 m
.00375 .47032 L
s
0 .49563 m
.00375 .49563 L
s
0 .54625 m
.00375 .54625 L
s
0 .57156 m
.00375 .57156 L
s
0 .59687 m
.00375 .59687 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01472 m
1 .01472 L
s
.99375 .14127 m
1 .14127 L
s
.99375 .26783 m
1 .26783 L
s
.99375 .39438 m
1 .39438 L
s
.99375 .52094 m
1 .52094 L
s
.125 Mabswid
.99625 .04003 m
1 .04003 L
s
.99625 .06534 m
1 .06534 L
s
.99625 .09065 m
1 .09065 L
s
.99625 .11596 m
1 .11596 L
s
.99625 .16658 m
1 .16658 L
s
.99625 .19189 m
1 .19189 L
s
.99625 .2172 m
1 .2172 L
s
.99625 .24252 m
1 .24252 L
s
.99625 .29314 m
1 .29314 L
s
.99625 .31845 m
1 .31845 L
s
.99625 .34376 m
1 .34376 L
s
.99625 .36907 m
1 .36907 L
s
.99625 .41969 m
1 .41969 L
s
.99625 .445 m
1 .445 L
s
.99625 .47032 m
1 .47032 L
s
.99625 .49563 m
1 .49563 L
s
.99625 .54625 m
1 .54625 L
s
.99625 .57156 m
1 .57156 L
s
.99625 .59687 m
1 .59687 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .54498 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .01472 m
.03333 .2924 L
.04286 .41612 L
.05238 .45049 L
.0619 .45181 L
.07143 .42845 L
.08095 .46794 L
.09048 .45518 L
.1 .44156 L
.10952 .4486 L
.11905 .46945 L
.12857 .49372 L
.1381 .46783 L
.14762 .44575 L
.15714 .44901 L
.16667 .01472 L
.17619 .32716 L
.18571 .50755 L
.19524 .57618 L
.20476 .5776 L
.21429 .54468 L
.22381 .52598 L
.23333 .47543 L
.24286 .44462 L
.25238 .4488 L
.2619 .47991 L
.27143 .52134 L
.28095 .55866 L
.29048 .58424 L
.3 .59722 L
.30952 .60088 L
.31905 .59976 L
.32857 .59757 L
.3381 .59638 L
.34762 .59672 L
.35714 .59816 L
.36667 .59997 L
.37619 .60155 L
.38571 .6026 L
.39524 .60312 L
.40476 .60324 L
.41429 .56079 L
.42381 .49153 L
.43333 .44965 L
.44286 .44953 L
.45238 .48055 L
.4619 .5235 L
.47143 .56215 L
.48095 .58814 L
.49048 .60063 L
Mistroke
.5 .60332 L
.50952 .5607 L
.51905 .49133 L
.52857 .44941 L
.5381 .44932 L
.54762 .4804 L
.55714 .52342 L
.56667 .56212 L
.57619 .58814 L
.58571 .60064 L
.59524 .60332 L
.60476 .60117 L
.61429 .59819 L
.62381 .59656 L
.63333 .59673 L
.64286 .59818 L
.65238 .60007 L
.6619 .6017 L
.67143 .60277 L
.68095 .60326 L
.69048 .01472 L
.7 .29028 L
.70952 .41056 L
.71905 .44283 L
.72857 .44415 L
.7381 .42111 L
.74762 .46428 L
.75714 .45391 L
.76667 .44137 L
.77619 .44859 L
.78571 .46905 L
.79524 .49346 L
.80476 .4677 L
.81429 .4457 L
.82381 .44901 L
.83333 .4695 L
.84286 .49387 L
.85238 .46799 L
.8619 .44587 L
.87143 .44908 L
.88095 .01472 L
.89048 .28894 L
.9 .37267 L
.90952 .36057 L
.91905 .41735 L
.92857 .42287 L
.9381 .42395 L
.94762 .44032 L
.95714 .47209 L
.96667 .51023 L
Mistroke
.97619 .54498 L
Mfstroke
0 .98 .604 r
gsave
.97619 .54498 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.03333 .24429 L
.04286 .28253 L
.05238 .27563 L
.0619 .30879 L
.07143 .35758 L
.08095 .32701 L
.09048 .27238 L
.1 .27487 L
.10952 .34969 L
.11905 .4366 L
.12857 .45748 L
.1381 .45266 L
.14762 .42155 L
.15714 .29859 L
.16667 .01472 L
.17619 .29486 L
.18571 .415 L
.19524 .45734 L
.20476 .49889 L
.21429 .54467 L
.22381 .52597 L
.23333 .47529 L
.24286 .44392 L
.25238 .44692 L
.2619 .47636 L
.27143 .51623 L
.28095 .55297 L
.29048 .57967 L
.3 .59519 L
.30952 .60084 L
.31905 .59722 L
.32857 .58298 L
.3381 .55629 L
.34762 .51831 L
.35714 .47683 L
.36667 .44731 L
.37619 .44851 L
.38571 .49098 L
.39524 .56052 L
.40476 .60317 L
.41429 .56042 L
.42381 .48689 L
.43333 .4304 L
.44286 .40142 L
.45238 .39336 L
.4619 .40149 L
.47143 .43048 L
.48095 .48686 L
.49048 .56009 L
Mistroke
.5 .60234 L
.50952 .55904 L
.51905 .48885 L
.52857 .44601 L
.5381 .44501 L
.54762 .4754 L
.55714 .51801 L
.56667 .55625 L
.57619 .58056 L
.58571 .58795 L
.59524 .57935 L
.60476 .55751 L
.61429 .5264 L
.62381 .49187 L
.63333 .46188 L
.64286 .44436 L
.65238 .44152 L
.6619 .44135 L
.67143 .40983 L
.68095 .29006 L
.69048 .01472 L
.7 .24099 L
.70952 .27394 L
.71905 .2641 L
.72857 .29742 L
.7381 .34791 L
.74762 .32065 L
.75714 .27184 L
.76667 .27591 L
.77619 .33616 L
.78571 .38176 L
.79524 .33586 L
.80476 .27594 L
.81429 .27144 L
.82381 .31701 L
.83333 .33667 L
.84286 .27712 L
.85238 .2402 L
.8619 .25523 L
.87143 .23369 L
.88095 .01472 L
.89048 .21897 L
.9 .2755 L
.90952 .34718 L
.91905 .37496 L
.92857 .33854 L
.9381 .30058 L
.94762 .30374 L
.95714 .36485 L
.96667 .46595 L
Mistroke
.97619 .54498 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{602.188, 124},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009J0000O2000`400?l00000o`00003ooooooooo
oooooecooooo003oooooooooooooG?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo
003oooooooooooooG?ooool00?oooooooooooomLooooo`00oooooonSooooo`;o00007?ooool5o`00
01gooooo0ol0000Looooo`?o00007?ooool3o`0001[ooooo0ol00004ooooo`;o00005?ooool00?oo
ooooX_ooool01?l0003oooooooooool0000Looooo`04o`000?ooooooooooo`0001kooooo00?o0000
ooooooooool06_ooool01Ol0003ooooooooooooooooo000001[ooooo00Go0000oooooooooooooooo
o`00000Jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00004oooool00?oooooo
X_ooool01?l0003oooooooooool0000Mooooo`03o`000?oooooooooo01_ooooo1Ol0000Kooooo`05
o`000?ooooooooooooooool000006_ooool01Ol0003ooooooooooooooooo000001[ooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool0000Cooooo`00l?ooool2o`0001[ooooo1Ol0000J
ooooo`?o00006_ooool3o`0001[ooooo0ol0000Hooooo`?o00001?ooool2o`0001Sooooo00Co0000
oooooooooooo00007_ooool00ol0003oooooooooo`0Jooooo`04o`000?ooooooooooo`0001cooooo
1?l0000Looooo`?o00006oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001?o
oooo000booooo`;o00006_ooool5o`0001_ooooo0ol0000Iooooo`?o00006oooool3o`0001Oooooo
0ol00004ooooo`;o00009?ooool01?l0003oooooooooool0000Jooooo`04o`000?ooooooooooo`00
01_ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo000001Sooooo00Go0000
ooooooooooooooooo`00000Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
5oooool01?l0003oooooooooool0000Kooooo`05o`000?ooooooooooooooool000007?ooool00ol0
003oooooo`00000Looooo`03o`000?oooooooooo01cooooo00Go0000ooooooooooooooooo`00000J
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00004oooool0037ooooo00Co0000
oooooooooooo00006_ooool01?l0003oooooooooool0000Looooo`03o`000?oooooooooo01Oooooo
00Go0000ooooooooooooooooo`00000Iooooo`05o`000?ooooooooooooooool000005oooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0002?ooooo00Co0000oooooooooooo00006ooo
ool00ol0003oooooooooo`0Hooooo`Go00006Oooool01Ol0003ooooooooooooooooo000001Sooooo
00Go0000ooooooooooooooooo`00000Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00005oooool01?l0003oooooooooool0000Kooooo`05o`000?ooooooooooooooool000007Ooo
ool2o`0001gooooo00?o0000ooooooooool06oooool01Ol0003ooooooooooooooooo000001Wooooo
0_l00004ooooo`04o`000?ooooooooooo`0001?ooooo000aooooo`04o`000?ooooooooooo`0001_o
oooo00?o0000ooooooooool06Oooool5o`0001Sooooo00Go0000ooooooooooooooooo`00000Ioooo
o`05o`000?ooooooooooooooool000005oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0002?ooooo00Co0000oooooooooooo00007?ooool00ol0003oooooooooo`0Gooooo`04o`00
0?ooooooooooo`0001[ooooo1?l0000Jooooo`?o00006Oooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0001Sooooo0_l0000Mooooo`?o00007oooool00ol0003oooooooooo`0Loooo
o`;o00007?ooool3o`0001_ooooo00?o0000ooooooooool00oooool2o`0001Cooooo000aooooo`04
o`000?ooooooooooo`0001cooooo00?o0000ooooooooool06?ooool01?l0003oooooooooool0000I
ooooo`Co00006oooool3o`0001Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
000Sooooo`04o`000?ooooooooooo`0001Wooooo00Go0000ooooooooooooooooo`00000Iooooo`03
o`000?oooooo000001[ooooo00?o0000ooooooooool06_ooool01Ol0003ooooooooooooooooo0000
01Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0003@ooooo`00<Oooool01?l0
003oooooooooool0000Iooooo`05o`000?ooooooooooooooool000006_ooool00ol0003oooooo`00
000Iooooo`03o`000?oooooooooo01_ooooo00Go0000ooooooooooooooooo`00000Gooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00008oooool01?l0003oooooooooool0000Ioooo
o`05o`000?ooooooooooooooool000006_ooool2o`0001_ooooo00?o0000ooooooooool06Oooool0
1Ol0003ooooooooooooooooo000001Oooooo0_l00004ooooo`04o`000?ooooooooooo`000=3ooooo
000aooooo`04o`000?ooooooooooo`0001Wooooo00Go0000ooooooooooooooooo`00000Kooooo`;o
00006_ooool00ol0003oooooooooo`0Jooooo`05o`000?ooooooooooooooool000005_ooool2o`00
00Cooooo00Co0000oooooooooooo00009?ooool2o`0001_ooooo0ol0000Looooo`03o`000?oooooo
oooo01[ooooo0_l0000Jooooo`?o00006Oooool00ol0003oooooooooo`03ooooo`;o0000dOooool0
03;ooooo0_l0000Kooooo`?o00007Oooool00ol0003oooooooooo`0Iooooo`;o00006oooool3o`00
01Sooooo00?o0000ooooooooool00oooool2o`000<kooooo0_l00004ooooojSo00004oooool00?oo
ooooVOooool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooooooool000007oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool000004oooool00?ooooooVOooool0
1?l0003oooooooooool00003ooooo`;o00000_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oo
oooooooo05Gooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`0@ooooo`;o00004ooo
ool00>goooooWOl0000>ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000oooooooooooooooo
o`3jVP0Gooooo`03o`3jV_oooooooooo05Gooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo000`oooooico00008Oooool01Ol0003ooooooooo
oooooooo000000Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo000000ko
oooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ01Oooooo00?o0?ZJ
ooooooooool0EOooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo017ooooo00?o0000
ooooooooool04Oooool0033ooooo00?o0000ooooooooool0Uoooool2o`0000Wooooo0_l00004oooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`?o00000oooool00ol0003oooooooooo`2Ioooo
o`03o`000?oooooooooo00cooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooo
oooo0?ZJ01Oooooo00?o0?ZJooooooooool0EOooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oo
oooooooo017ooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool0R?ooool0
0ol0nY[oooooooooo`0=ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00002?oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
>Oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo04kooooo00?o0000ooooooooool0
3Oooool2o`0000Cooooo00Go0000ooooooooooooooooo`3jVP0Gooooo`03o`3jV_oooooooooo05Go
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo000`ooooo`03o`000?oooooooooo08Oooooo0_l0nYX?ooooo`03o`000?oooooo000000Co0000
0_ooool01?l0003oooooooooool00008ooooo`05o`000?ooooooooooo`000?ooool01Ol00003oooo
o`;o0000>_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo04gooooo0_l0000Eoooo
o`;o00000_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo05Gooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo000`ooooo`03
o`000?oooooooooo08Oooooo00?o0?ZJooooool0nYX03Oooool2o`0000Sooooo00Co0000oooooooo
oooo00002?ooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0iooooo`03o`3jV_oooooooooo00_ooooo0_l0nYY@ooooo`03o`000?oo
oooooooo01?ooooo00Go0000ooooooooooooooooo`3jVP0Gooooo`03o`3jV_oooooooooo05Gooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
000`ooooo`03o`000?oooooooooo08Cooooo0ol0nYX2o`00o`03o`3jV_oooooooooo00cooooo00?o
0000ooooooooool01_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooool000001?ooool00ol0003oooooooooo`0hooooo`;o0?ZJ3Oooool2o`3jVU3o
oooo00?o0000ooooooooool04oooool01Ol0003ooooooooooooooooo0?ZJ01Oooooo00?o0?ZJoooo
ooooool0EOooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo017ooooo00?o0000oooo
ooooool04Oooool001;ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o
00000oooool3o`0000Cooooo00?o0000ooooooooool0Q?ooool01?l0nY[oooooooooool00?l2oooo
o`03o`3jV_oooooooooo00[ooooo0_l00008ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000
oooooooooooo00000oooool2o`0000Cooooo00?o0000ooooooooool0>?ooool00ol0nY[oooooo`3j
VP0<ooooo`;o0?ZJD?ooool00ol0003oooooooooo`0Cooooo`05o`000?ooooooooooooooool0nYX0
5oooool00ol0nY[oooooooooo`1Eooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`004Oooool01?l0003oooooooooool00008ooooo`04o`00
0?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`05o`000?oooooo
ooooooooool00000Q_ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo00_ooooo
00?o0000ooooooooool01oooool2o`0000[ooooo0_l00005ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool06_ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo0?ZJ00_ooooo
00?o0?ZJooooool0nYX0D?ooool00ol0003oooooooooo`0Cooooo`;o00000_ooool00ol0nY[ooooo
ooooo`0Eooooo`03o`3jV_oooooooooo05Gooooo00?o0?ZJooooooooool07?ooool2o`3jVQ;ooooo
00?o0000ooooooooool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000ooooooooooooooooo`000025
ooooo`05o`3jV_ooooooooooooooool00?l00_ooool00ol0nY[oooooooooo`0;ooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool06_ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooo0?ZJ00_ooooo00?o0?ZJooooool0nYX0D?ooool00ol0003oooooooooo`0Cooooo`05o`000?oo
ooooooooooooool0nYX05oooool00ol0nY[oooooooooo`1Eooooo`03o`3jV_oooooooooo01cooooo
0_l0nYXBooooo`03o`000?oooooooooo017ooooo000Aooooo`04o`000?ooooooooooo`0000Sooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00005ooooo`04o`000?oooooooooo
ooooo`;o0000Q?ooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJooooooooool02_oo
ool2o`00027ooooo0_l0000Kooooo`;o0?ZJ7?ooool00ol0nY[oooooo`3jVP0;ooooo`04o`3jV_oo
ooooooooo`3jVTkooooo0_l0000Eooooo`05o`000?ooooooooooooooool0nYX05oooool00ol0nY[o
ooooooooo`1Eooooo`03o`3jV_oooooooooo01cooooo0_l0nYXBooooo`03o`000?oooooooooo017o
oooo000Aooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01Ol0
003oooooooooool0003ooooo00Co00001?ooool00ol0003oooooooooo`23ooooo`04o`3jV_oooooo
ooooo`00o`?ooooo00?o0?ZJooooooooool02oooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo01[ooooo0_l0nYXKooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Co0?ZJoooooooooooo
0?ZJCoooool00ol0003oooooooooo`0Cooooo`05o`000?ooooooooooooooool0nYX05oooool00ol0
nY[oooooooooo`1Dooooo`;o0?ZJ7_ooool2o`3jVQ;ooooo00?o0000ooooooooool04Oooool0017o
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?oooooo
ooooo`000?oooooo00001oooool00ol0003oooooooooo`22ooooo`05o`3jV_ooooooooooooooool0
0?l00oooool00ol0nY[oooooooooo`0:ooooo`;o00008Oooool00ol0003oooooooooo`0Iooooo`04
o`3jV_ooooooooooo`3jVQ[ooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0nY[oooooooooool0
nYY?ooooo`03o`000?oooooooooo01?ooooo0_l00002ooooo`03o`3jV_oooooooooo01Cooooo0_l0
nYYFooooo`;o0?ZJ7_ooool2o`3jVQ;ooooo00?o0000ooooooooool04Oooool001;ooooo0_l0000:
ooooo`;o00001?ooool2o`0000;ooooo1Ol00003ooooo`03o`000?oooooooooo00Oooooo0_l0nYX6
ooooo`03o`3jV_oooooooooo05gooooo00?o0?ZJooooooooool03?ooool4o`3jVPCooooo00Go003o
ooooooooooooooooo`3jVP0=ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool06Ooo
ool01?l0nY[oooooooooool0nYXJooooo`05o`3jV_ooooooooooooooool0nYX02_ooool01?l0nY[o
ooooooooool0nYXIooooo`03o`3jV_oooooooooo03?ooooo00?o0000ooooooooool04oooool01Ol0
003ooooooooooooooooo0?ZJ01Kooooo0_l0nYYFooooo`;o0?ZJ7_ooool2o`3jVQ;ooooo00?o0000
ooooooooool04Oooool0033ooooo00?o0000ooooooooool01_ooool00ol0nY[oooooo`3jVP06oooo
o`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0AOooool6o`3jVP04ooooool0nY[o0?ZJ
o`3jVPOooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooo
oooo00;ooooo00?o0?ZJooooooooool02_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo01Wooooo00Co0?ZJoooooooooooo0?ZJ6_ooool01Ol0nY[ooooooooooooooooo0?ZJ00[ooooo
00Co0?ZJoooooooooooo0?ZJ6Oooool00ol0nY[oooooooooo`0cooooo`03o`000?oooooooooo01?o
oooo00Go0000ooooooooooooooooo`3jVP0Fooooo`;o0?ZJE_ooool2o`3jVQkooooo0_l0nYXBoooo
o`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooool0
nYX01_ooool2o`3jVPgooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0;ooooo`03
o`3jV_oooooooooo01Wooooo00Co0?ZJooooool00?oo003o0_ooool01Ol0nY[oooooooooool00?oo
0?ZJ00Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooo
oooo00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`02o`00027ooooo0_l0000J
ooooo`04o`3jV_ooooooooooo`3jVQ[ooooo00Go0?ZJooooooooooooooooo`3jVP0:ooooo`04o`3j
V_ooooooooooo`3jVQSooooo00?o0?ZJooooool0nYX0<oooool2o`0001Gooooo00Go0000oooooooo
ooooooooo`3jVP0Fooooo`;o0?ZJE_ooool2o`3jVQkooooo0_l0nYXBooooo`03o`000?oooooooooo
017ooooo000`ooooo`03o`000?oooooooooo00Cooooo0_l0nYX2ooooo`03o`00ool0nY[ooooo00?o
oooo00?o0?ZJo`00ool0nYX03?ooool2o`3jVQgooooo00?o0?ZJooooooooool02oooool00ol0nY[o
ooooooooo`0Iooooo`04o`3jV_oooooo003oo`00o`Gooooo00?o003oo`3jV_ooool01?ooool00ol0
nY[o003oo`3jVP04ooooo`03o`3jV_l00?oooooo00Kooooo00?o003oooooooooool00_ooool00ol0
nY[oooooooooo`06ooooo`05o`3jV_ooooooooooooooool000008Oooool00ol0003oooooooooo`0I
ooooo`04o`3jV_ooooooooooo`3jVQ[ooooo00Go0?ZJooooooooooooooooo`3jVP0:ooooo`04o`3j
V_ooooooooooo`3jVQSooooo00?o0?ZJooooool0nYX0=?ooool00ol0003oooooooooo`0Cooooo`;o
00000_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJE_ooool2o`3jVQkooooo0_l0nYXBooooo`03
o`000?oooooooooo017ooooo000`ooooo`04o`000?ooooooooooooooo`?o0?ZJ1?ooool00ol00?oo
0?ZJooooo`03ooooo`03o`3jV_l00?oo0?ZJ00cooooo0_l0nYXMooooo`03o`3jV_oooooooooo00_o
oooo00?o0?ZJooooooooool06Oooool01Ol0nY[oooooo`00oooooooo003o00Cooooo0_l00?l02?l0
nY[ooooooooooooooooo0?ZJooooool00?oo0?ZJ1?ooool00ol0nY[o003oo`00o`06ooooo`03o`00
oooooooooooo00;ooooo00?o0?ZJooooooooool01_ooool01Ol0nY[ooooooooooooooooo0000027o
oooo00?o0000ooooooooool06Oooool01?l0nY[oooooooooool0nYXJooooo`05o`3jV_oooooooooo
ooooool0nYX02_ooool01?l0nY[oooooooooool0nYXHooooo`03o`3jV_oooooo0?ZJ03Cooooo00?o
0000ooooooooool04oooool01Ol0003ooooooooooooooooo0?ZJ01Kooooo0_l0nYYFooooo`;o0?ZJ
7_ooool2o`3jVQ;ooooo00?o0000ooooooooool04Oooool0033ooooo00Co0000oooooooooooo0?ZJ
0_l00?l5ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00ool00?oo0?ZJ2oooool2o`3jVQco
oooo0_l0nYX=ooooo`;o0?ZJ6Oooool01_l0nY[oooooooooool00?ooooooo`00o`Cooooo0_l00?l0
2?l0nY[ooooooooooooooooo0?ZJooooool00?oo0?ZJ1?ooool00ol0nY[o003oo`00o`06ooooo`03
o`00oooooooooooo00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`02o`00027o
oooo00?o0000ooooooooool06Oooool01?l0nY[oooooooooool0nYXIooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ01Oooooo00Co0?ZJ
oooooooooooo0?ZJ=?ooool01?l0003oooooooooooooool2o`0000Cooooo00?o0000ooooooooool0
0_ooool3o`0000Cooooo00Go0000ooooooooooooooooo`3jVP0Fooooo`;o0?ZJE_ooool2o`3jVQgo
oooo00?o0?ZJo`00ool0nYX04_ooool00ol0003oooooooooo`0Aooooo`00<?ooool01_l0003ooooo
ooooool00?ooooooo`00o`Gooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX:
ooooo`04o`3jV_oooooo003oo`3jVQ_ooooo0_l0nYX=ooooo`;o0?ZJ6Oooool01_l0nY[ooooooooo
ool00?ooooooo`00o`Cooooo0_l00?l01_l0nY[ooooooooooooooooo0?ZJooooo`;o003o00Go0?ZJ
oooooooooooo0?ZJooooo`02o`00o`Kooooo00?o003oooooooooool00_ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_l00?oooooo00;ooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Iooooo`05o`3jV_ooooooooooooooool0nYX06?ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00Oooooo00Go0?ZJooooooooooooooooo`3jVP0Gooooo`04o`3jV_ooooooooooo`3j
VSCooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00?ooooo00Ko0000ooooooooooooooooo`00ool0nYXEooooo`;o0?ZJE_ooool00ol0nY[o003o
o`3jVP0Looooo`03o`3jV_l00?oo0?ZJ01;ooooo00?o0000ooooooooool04Oooool0033ooooo00?o
0000ooooooooool00_ooool00ol00?ooooooooooo`03ooooo`;o003o00Go0?ZJoooooooooooo0?ZJ
ooooo`02o`00o`03o`3jV_oooooooooo00Sooooo00Co0?ZJooooool00?oo0?ZJ6oooool00ol0nY[o
003oo`3jVP0;ooooo`03o`3jV_l00?oo0?ZJ01Wooooo00Co0?ZJoooooooooooo003o0_ooool01?l0
0?ooooooooooooooool2o`00o`06o`3jV_ooooooooooooooool0nY[ooooo0_l00?l01Ol0nY[ooooo
ooooool0nY[ooooo00;o003o1_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo00Go
oooo00Co0?ZJo`00oooooooooooo0_l0000Qooooo`03o`000?oooooooooo01Wooooo00Go0?ZJoooo
ooooooooooooo`3jVP0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool0
1Ol0nY[ooooooooooooooooo0?ZJ01Oooooo00Co0?ZJoooooooooooo0?ZJ=?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool2o`0000;o
oooo00?o003oo`3jV_ooool05?ooool2o`3jVUKooooo00?o0?ZJo`00ool0nYX07?ooool00ol0nY[o
003oo`3jVP0Aooooo`;o00004oooool001Sooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo
0_l00003ooooo`?o00001?ooool00ol0003oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo
0_l00?l02?l0nY[oooooooooool0nY[oooooo`00oooooooo0?ZJ2_ooool01?l0nY[oooooo`00ool0
nYXKooooo`03o`3jV_l00?oo0?ZJ00_ooooo00?o0?ZJo`00ool0nYX06Oooool01?l0nY[ooooooooo
ool00?l2ooooo`0:o`00ooooooooooooooooool00?ooooooo`00ool0nY[oooooo`3jVP;ooooo0_l0
0?l02?l0nY[oooooooooool0nY[oooooo`00oooooooo003o1Oooool00ol00?ooooooooooo`02oooo
o`03o`3jV_oooooooooo00Gooooo00?o0?ZJo`00ooooool00_ooool00ol0003oooooooooo`0Ooooo
o`;o00006_ooool01Ol0nY[ooooooooooooooooo0?ZJ01Sooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX05oooool01?l0nY[ooooooooo
ool0nYX]ooooo`03o`3jV_oooooooooo00?ooooo0_l00002ooooo`04o`000?ooooooooooo`0000Wo
oooo00?o0000ooooooooool00oooool01_l0003ooooooooooooooooo003oo`3jVQGooooo0_l0nYYF
ooooo`03o`3jV_l00?oo0?ZJ01cooooo00?o0?ZJo`00ool0nYX04_ooool00ol0003oooooooooo`0A
ooooo`005oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo0_l0
0?l02?l0nY[oooooooooool0nY[oooooo`00oooooooo0?ZJ2_ooool01?l0nY[oooooo`00ool0nYXJ
ooooo`04o`3jV_oooooo003oo`3jVP_ooooo00Co0?ZJo`00oooooooo0?ZJ6?ooool01?l0nY[ooooo
ooooool00?l2ooooo`0:o`00ooooooooooooooooool00?ooooooo`00ool0nY[oooooo`3jVP;ooooo
0_l00?l00ooooooo0?ZJo`3jVP02ooooo`03o`00oooooooo003o00Gooooo00?o003oooooooooool0
0_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_l00?oooooo00;ooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0Iooooo`05o`3jV_ooooooooooooooool0nYX06?ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00Go0?ZJooooooooooooooooo`3jVP0Goooo
o`04o`3jV_ooooooooooo`3jVRgooooo00?o0?ZJooooooooool01?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool01_l0003ooooooooo
oooooooo003oo`3jVQGooooo0_l0nYYFooooo`03o`3jV_l00?oo0?ZJ01cooooo00?o0?ZJo`00ool0
nYX04_ooool00ol0003oooooooooo`0Aooooo`005oooool01?l0003oooooooooool00008ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00So003ooooo
ooooooooooooo`00oooooooo003oooooo`;o0?ZJ0_ooool00ol00?ooooooo`3jVP0:ooooo`04o`3j
V_oooooo003oo`3jVQ[ooooo00Co0?ZJooooool00?oo0?ZJ2oooool01?l0nY[o003oooooool0nYXH
ooooo`04o`3jV_ooooooooooo`00o`;ooooo00Oo003oooooooooooooooooo`00oooooooo003o00?o
0?ZJ0_ooool2o`00o`;ooooo00Ko0?ZJoooooooooooo003oooooool00?l5ooooo`03o`00oooooooo
oooo00;ooooo00?o003oo`3jV_ooool01Oooool01?l0nY[o003oooooooooool2o`00027ooooo00?o
0000ooooooooool06Oooool01Ol0nY[ooooooooooooooooo0?ZJ01Sooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[oooooooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX05oooool01Ol0nY[o
oooooooooooooooo0?ZJ02cooooo0_l0nYX5ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01_ooool2o`0000Gooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`0C
ooooo`03o`3jV_l00?oo0?ZJ05Gooooo00?o0?ZJo`00ool0nYX07?ooool00ol0nY[o003oo`3jVP0B
ooooo`03o`000?oooooooooo017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00So
003oooooooooooooooooo`00oooooooo003oooooo`;o0?ZJ0_ooool00ol00?ooooooo`3jVP0:oooo
o`04o`3jV_oooooo003oo`3jVQ[ooooo00Co0?ZJooooool00?oo0?ZJ2oooool01?l0nY[o003ooooo
ool0nYXGooooo`05o`3jV_ooooooooooooooool00?l00_ooool01ol00?oooooooooooooooooo003o
ooooool00?l01Oooool2o`00o`Gooooo00?o003oooooool00?l01Oooool00ol00?ooooooooooo`02
ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJo`00ooooool00_ooool00ol0003oooooooooo`07
ooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000_ooool5o`0000?ooooo00?o0000
ooooooooool06?ooool00ol0nY[o003oooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool04oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02[ooooo0_l0nYX5
ooooo`04o`000?ooooooooooooooo`;o00002_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[o003oo`3jVP1Eooooo`03o`3jV_l0
0?oo0?ZJ01cooooo00?o0?ZJo`00ool0nYX04_ooool00ol0003oooooooooo`0Aooooo`005oooool0
1?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`03ooooo`07o`00ooooooooooooooooool00?ooooooo`00o`05oooo
o`03o`00oooooooo0?ZJ00[ooooo00Co0?ZJooooool00?oo0?ZJ6_ooool01?l0nY[oooooo`00ool0
nYX;ooooo`04o`3jV_l00?ooooooo`3jVQOooooo00Go0?ZJooooooooooooooooo`00o`02ooooo`07
o`00ooooooooooooooooool00?ooooooo`00o`05ooooo`;o003o1Oooool00ol00?ooooooo`00o`05
ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`00o`03
ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00002?ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool06?ooool00ol0nY[o
003oooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo02[ooooo0_l0nYX5ooooo`03o`000?oooooooooo01?o
oooo0_l00003ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJo`00ool0nYX0EOooool00ol0nY[o
ooooo`3jVP0Looooo`04o`3jV_l00?oo003oo`3jVQ7ooooo00?o0000ooooooooool04Oooool001Oo
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`;o00001Oooool0
0ol0003oooooooooo`03ooooo`07o`00ooooooooooooooooool00?ooooooo`00o`05ooooo`04o`00
oooooooo003oo`3jVPWooooo00Co0?ZJooooool00?oo0?ZJ6_ooool01?l0nY[oooooo`00ool0nYX;
ooooo`04o`3jV_l00?ooooooo`3jVQOooooo00Go0?ZJooooooooooooooooo`00o`02ooooo`07o`00
ooooooooooooooooool00?ooooooo`00o`05ooooo`;o003o1Oooool00ol00?ooooooo`00o`05oooo
o`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`00o`02oooo
o`;o000000?oooooo`000?l000000ol00002ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`;o00006Oooool00ol0nY[o003oo`00
o`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo02Wooooo00?o0?ZJooooool0nYX01?ooool2o`0001Gooooo00?o
0000ooooooooool00_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooo0?ZJ05Gooooo00?o
0?ZJooooool0nYX07?ooool01?l0nY[o003oo`00ool0nYXAooooo`03o`000?oooooooooo017ooooo
000Hooooo`;o00002_ooool2o`0000Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`04ooooo`04o`00ooooooooooooo`00o`;ooooo00?o003oooooooooool00_ooool01?l00?oooooo
o`00ool0nYX8ooooo`05o`3jV_oooooo003oooooool0nYX06_ooool01?l0nY[oooooo`00ool0nYX;
ooooo`04o`3jV_l00?ooooooo`3jVQOooooo00Go0?ZJooooooooooooooooo`00o`03ooooo`06o`00
ooooooooooooo`00oooooooo003o1Oooool00ol00?ooooooo`00o`04ooooo`03o`00oooooooo003o
00Gooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo003o
00?ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Hooooo`03o`3jV_l0
0?oo003o00;ooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool0:Oooool00ol0nY[oooooo`3jVP05ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oo
oooo0?ZJ05Gooooo00?o0?ZJooooool0nYX07?ooool01?l0nY[o003oo`00ool0nYXAooooo`03o`00
0?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooo003o
0_ooool00ol00?ooooooooooo`02ooooo`04o`00oooooooo003oo`3jVPSooooo00Go0?ZJooooool0
0?ooooooo`3jVP0Jooooo`04o`3jV_oooooo003oo`3jVP_ooooo00Co0?ZJo`00oooooooo0?ZJ5ooo
ool01Ol0nY[ooooooooooooooooo003o00?ooooo00Ko003ooooooooooooo003oooooool00?l5oooo
o`03o`00oooooooo003o00Cooooo00?o003oooooool00?l01Oooool00ol00?ooooooooooo`03oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool00?l00_ooool2o`0000Sooooo00Co0000oooo
oooooooo00002?ooool01_l0003oooooooooool0003oooooo`0000?ooooo00Go0000oooooooooooo
ooooo`00000Jooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool05_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`0Cooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0:Oooool00ol0nY[o
ooooo`3jVP05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_ooool00ol0nY[o
ooooooooo`0Cooooo`03o`3jV_oooooo0?ZJ05Gooooo00?o0?ZJooooool0nYX07?ooool01?l0nY[o
003oo`00ool0nYXAooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Co
oooo00Co003ooooooooooooo003o0_ooool00ol00?ooooooooooo`02ooooo`04o`00oooooooo003o
o`3jVPSooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`0Gooooo`05o`3jV_oooooo
003oooooool0nYX02Oooool01Ol0nY[oooooo`00oooooooo0?ZJ01Oooooo00Go0?ZJoooooooooooo
ooooo`00o`03ooooo`06o`00ooooooooooooo`00oooooooo003o1Oooool00ol00?ooooooo`00o`04
ooooo`03o`00oooooooo003o00Gooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooo003o00?ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool0
0008ooooo`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooooooo0000
01[ooooo00?o0?ZJo`00ool00?l00_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
01?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Yooooo`03o`3jV_oooooo0?ZJ
00Gooooo00?o0000ooooooooool04oooool2o`0000?ooooo00?o0?ZJooooooooool04oooool00ol0
nY[oooooo`3jVP1Eooooo`03o`3jV_oooooo0?ZJ01cooooo00Co0?ZJo`00ool00?oo0?ZJ4Oooool0
0ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`04ooooo`04o`00oooooooooooo
o`00o`;ooooo00?o003oooooooooool00_ooool01?l00?ooooooo`00ool0nYX8ooooo`03o`3jV_oo
oooo003o00;ooooo00?o0?ZJooooooooool05oooool01Ol0nY[oooooo`00oooooooo0?ZJ00Wooooo
00Go0?ZJooooool00?ooooooo`3jVP0Gooooo`05o`3jV_ooooooooooooooool00?l00oooool01_l0
0?ooooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooooooo003o1?ooool00ol00?oooooo
o`00o`04ooooo`03o`00oooooooooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol0nY[ooooo
o`00o`03ooooo`03o`000?oooooooooo00Oooooo0_l0000:ooooo`;o00000oooool3o`0000Cooooo
00?o0000ooooooooool06?ooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01Gooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02Wooooo
00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00;o
oooo00?o0?ZJooooooooool04oooool00ol0nY[oooooo`3jVP1Eooooo`03o`3jV_oooooo0?ZJ01co
oooo00Co0?ZJo`00ool00?oo0?ZJ4Oooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003o
ooooooooo`04ooooo`04o`00ooooooooooooo`00o`;ooooo00?o003oooooooooool00_ooool01?l0
0?ooooooooooool0nYX8ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool05oooool0
1Ol0nY[oooooo`00oooooooo0?ZJ00Wooooo00Go0?ZJooooool00?ooooooo`3jVP0Fooooo`03o`3j
V_oooooooooo00;ooooo00Go003oooooooooooooooooo`00o`02ooooo`04o`00ooooooooooooo`00
o`?ooooo00Co003ooooooooooooo003o1?ooool01?l00?ooooooooooool00?l3ooooo`03o`00oooo
oooooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooo`00o`02ooooo`;o00008Ooo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool05Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0:Ooo
ool01?l0nY[oooooooooool0nYX4ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
0_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooo0?ZJ05Gooooo00?o0?ZJooooool0nYX0
7?ooool01?l0nY[o003oo`00ool0nYXAooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`00
0?oooooooooo00Cooooo00Co003ooooooooooooo003o0_ooool00ol00?ooooooooooo`02ooooo`04
o`00ooooooooooooo`3jVPSooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`0Goooo
o`05o`3jV_oooooo003oooooool0nYX02Oooool01Ol0nY[oooooo`00oooooooo0?ZJ01Kooooo00?o
0?ZJooooooooool00_ooool01ol00?oooooooooooooooooo003oooooool00?l00oooool01Ol00?oo
oooooooooooooooo003o00;ooooo00?o003oooooooooool00_ooool01?l00?ooooooooooool00?l3
ooooo`03o`00oooooooooooo00Cooooo00?o003oo`3jV_ooool00_ooool01?l0nY[oooooooooool0
0?l3ooooo`03o`000?oooooooooo01oooooo0_l0000Iooooo`03o`3jV_oooooo003o00;ooooo00?o
0?ZJooooooooool05Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool0:Oooool01?l0nY[oooooooooool0nYX3ooooo`;o00005Oooool00ol0003ooooo
ooooo`02ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooool0nYX0EOooool00ol0nY[ooooo
o`3jVP0Looooo`04o`3jV_l00?oo003oo`3jVQ7ooooo00?o0000ooooooooool04Oooool0033ooooo
00?o0000ooooooooool01Oooool00ol00?ooooooo`00o`02ooooo`03o`00oooooooooooo00;ooooo
00Co003ooooooooooooo0?ZJ2?ooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01Oo
oooo00Go0?ZJooooool00?ooooooo`3jVP09ooooo`05o`3jV_oooooo003oooooool0nYX05_ooool0
0ol0nY[oooooooooo`02ooooo`07o`00ooooooooooooooooool00?ooooooo`00o`03ooooo`05o`00
ooooooooooooooooool00?l00_ooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooo`00
o`?ooooo00?o003oooooooooool01?ooool00ol00?oo0?ZJooooo`02ooooo`04o`3jV_oooooooooo
o`00o`?ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Hooooo`04o`3jV_oooooo
ooooo`00o`;ooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool0:?ooool01?l0nY[oooooooooool0nYX4ooooo`03o`00
0?oooooooooo01?ooooo0_l00003ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooool0nYX0
EOooool00ol0nY[oooooo`3jVP0Looooo`04o`3jV_l00?oo003oo`3jVQ7ooooo00?o0000oooooooo
ool04Oooool001;ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00003ooooo`?o0000
0oooool3o`0000Cooooo00?o0000ooooooooool01Oooool00ol00?ooooooo`00o`02ooooo`03o`00
oooooooooooo00;ooooo00Co003ooooooooooooo0?ZJ2?ooool00ol0nY[oooooo`00o`02ooooo`03
o`3jV_oooooooooo01Kooooo00Ko0?ZJoooooooooooo003oooooool0nYX9ooooo`03o`3jV_oooooo
003o00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`02ooooo`07o`00oooooooo
ooooooooool00?ooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l00_ooool00ol00?oo
ooooooooo`02ooooo`04o`00ooooooooooooo`00o`?ooooo00?o003oooooooooool01Oooool01Ol0
nY[ooooooooooooooooo0?ZJ00;ooooo00?o003oooooooooool00_l0000Qooooo`03o`000?oooooo
oooo00kooooo00?o0?ZJooooooooool01oooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oo
oooooooo01Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooooooo02Sooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooo`3jVP1Dooooo`04o`3j
V_l00?ooooooo`3jVQcooooo00Co0?ZJo`00oooooooo0?ZJ4Oooool00ol0003oooooooooo`0Aoooo
o`004Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol00?oooooo
o`00o`02ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo0?ZJ2?ooool00ol0nY[o
ooooo`00o`02ooooo`03o`3jV_oooooooooo01Kooooo00Ko0?ZJoooooooooooo003oooooool0nYX9
ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`02
ooooo`07o`00ooooooooooooooooool00?ooooooo`00o`03ooooo`05o`00ooooooooooooooooool0
0?l00_ooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooo`00o`?ooooo00?o003ooooo
ooooool01Oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Go003oooooooooooooooooo`00
000Qooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool01oooool01?l0nY[ooooooooo
ool00?l2ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04_ooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool04?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ00Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`02ooooo`03
o`3jV_oooooooooo01?ooooo00?o0?ZJooooool0nYX0E?ooool01?l0nY[o003oooooool0nYXLoooo
o`04o`3jV_l00?ooooooo`3jVQ7ooooo00?o0000ooooooooool04Oooool0017ooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Gooooo00Co
0000oooooooooooooooo0_l00006ooooo`03o`00oooooooo003o00?ooooo00Go003ooooooooooooo
ooooo`00o`02ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool00?l00_ooool00ol0nY[o
ooooooooo`0Fooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool01oooool00ol0nY[o
ooooo`00o`02ooooo`03o`3jV_oooooooooo01?ooooo00Go0?ZJooooooooooooooooo`00o`04oooo
o`03o`00oooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`03ooooo`05o`00oooooooo
ooooooooool00?l00_ooool01Ol00?oooooooooooooooooo003o00Oooooo00Go0?ZJoooooooooooo
ooooo`3jVP02ooooo`03o`00oooooooooooo00;o00008Oooool00ol0003oooooooooo`0>ooooo`03
o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0Doooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0=oooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool04?ooool01Ol0nY[ooooooooooooooooo
0?ZJ00Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooo
oooo01;ooooo00Co0?ZJo`00oooooooo0?ZJE?ooool01?l0nY[o003oooooool0nYXLooooo`05o`3j
V_ooooooooooo`00ool0nYX04?ooool00ol0003oooooooooo`0Aooooo`004Oooool01?l0003ooooo
ooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01Oooool01Ol0
003ooooooooooooooooo000000Oooooo00?o003oooooool00?l00oooool01Ol00?oooooooooooooo
oooo003o00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oo
oooooooo01Kooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooo003o00;ooooo00?o0?ZJooooooooool04oooool01Ol0nY[ooooooooooooooooo003o00Cooooo
00?o003oooooool00?l00oooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003ooooooooo
ooooooooo`00o`02ooooo`05o`00ooooooooooooooooool00?l01oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00;ooooo00Go003oooooooooooooooooo`00000Qooooo`;o00003oooool00ol0nY[ooooo
ooooo`07ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooooooool05?ooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`0Aooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool03Oooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo013ooooo00Go0?ZJooooooooooooooooo`3jVP03oooo
o`;o00005Oooool2o`0000?ooooo00?o0?ZJooooooooool04_ooool01?l0nY[o003oooooool0nYYD
ooooo`04o`3jV_l00?ooooooo`3jVQWooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol00?oo0?ZJ
ooooo`0?ooooo`03o`000?oooooooooo017ooooo000Aooooo`04o`000?ooooooooooo`0000Sooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooooooool4o`0000Cooooo00?o0000oooo
ooooool01Oooool00ol00?ooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l00_ooool0
0ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool05Oooool0
0ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooool00?l00_ooool0
0ol0nY[oooooooooo`0Cooooo`05o`3jV_ooooooooooooooool00?l01Oooool2o`00o`?ooooo00Go
003oooooooooooooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l00_ooool01Ol00?oo
oooooooooooooooo003o00Oooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`05o`00oooooooo
ooooooooool000008Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooo0?ZJ00Sooooo00Co
0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo017ooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ1_ooool2o`3jVQ7ooooo
00Go0?ZJooooooooooooooooo`3jVP04ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool00_ooool00ol0nY[oooooooooo`0Booooo`04o`3jV_l00?ooooooo`3jVUCooooo00Co0?ZJo`00
oooooooo0?ZJ6Oooool01?l0nY[oooooo`3jV_l00?l2ooooo`03o`00ool0nY[ooooo00oooooo00?o
0000ooooooooool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003ooooooooo
ool00002ooooo`;o00000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o003oooooool00?l00oooool01Ol00?oooooooooooooooooo003o00;ooooo00?o003oo`3jV_oo
ool01_ooool00ol0nY[oooooo`00o`03ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooool0
0?l00oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJoooo
ooooool04oooool01Ol0nY[ooooooooooooooooo003o00Gooooo0_l00?l3ooooo`05o`00oooooooo
ooooooooool00?l00oooool01Ol00?oooooooooooooooooo003o00;ooooo00Go003ooooooooooooo
ooooo`00o`07ooooo`05o`00ool0nY[oooooooooool0nYX00_ooool00ol00?ooooooooooo`02o`00
027ooooo00?o0000ooooooooool03Oooool00ol0nY[oooooo`3jVP08ooooo`04o`3jV_oooooooooo
o`00o`;ooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool03?ooool2o`3jVPGooooo00?o0?ZJooooool0nYX01?ooool0
0ol0nY[oooooooooo`0:ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01?l0003ooooooooo
ooooool2o`0000Cooooo00Co0000oooooooooooooooo1Ol00003ooooo`03o`000?oooooooooo00;o
oooo00?o0?ZJooooooooool04_ooool01?l0nY[o003oooooool0nYYDooooo`05o`3jV_l00?oooooo
o`00ool0nYX05oooool01Ol0nY[oooooo`3jV_l0nY[o003o00;ooooo00?o003oo`3jV_ooool03ooo
ool00ol0003oooooooooo`0Aooooo`004_ooool2o`0000[ooooo0_l00004ooooo`04o`000?oooooo
ooooooooo`Go00000oooool00ol0003oooooooooo`05ooooo`03o`00oooooooo003o00?ooooo00Go
003oooooooooooooooooo`00o`02ooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooool00?l0
0oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool0
1Oooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01?ooooo00Go0?ZJoooooooo
ooooooooo`00o`05ooooo`;o003o0oooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003o
ooooooooooooooooo`00o`02ooooo`05o`00ooooooooooooooooool00?l01oooool01?l00?oo0?ZJ
ooooool0nYX3ooooo`05o`00ooooooooooooooooool000008Oooool00ol0003oooooooooo`0=oooo
o`03o`3jV_oooooo0?ZJ00Sooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0C
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0<
ooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00[ooooo00Go0?ZJ
ooooooooooooooooo`3jVP04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
1_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o003oo`3jV_oo
ool04_ooool01?l0nY[o003oooooool0nYYDooooo`05o`3jV_l00?ooooooo`00ool0nYX05oooool0
1Ol0nY[oooooo`3jV_oooooo003o00;ooooo00?o003oo`3jV_ooool03oooool00ol0003ooooooooo
o`0Aooooo`00<?ooool00ol0003oooooooooo`05ooooo`03o`00oooooooo003o00?ooooo00Go003o
ooooooooooooooooo`00o`02ooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooool00?l00ooo
ool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool01Ooo
ool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01?ooooo00Go0?ZJoooooooooooo
ooooo`00o`05ooooo`;o003o0oooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003ooooo
ooooooooooooo`00o`02ooooo`05o`00ooooooooooooooooool00?l01oooool01?l00?oo0?ZJoooo
ool0nYX3ooooo`05o`00ooooooooooooooooool000008Oooool00ol0003oooooooooo`0=ooooo`03
o`3jV_oooooo0?ZJ00Oooooo00Go0?ZJo`00ooooooooooooo`00o`02ooooo`03o`3jV_oooooooooo
01?ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
00[ooooo00?o0?ZJooooool0nYX01Oooool00ol0nY[oooooo`3jVP04ooooo`;o0?ZJ2oooool01Ol0
nY[ooooooooooooooooo0?ZJ00Cooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol00?oo0?ZJoooo
o`0Booooo`04o`3jV_l00?ooooooo`3jVUCooooo00Oo0?ZJo`00oooooooo003oo`3jV_oooooo0?ZJ
01Gooooo00Go0?ZJooooooooooooooooo`00o`02ooooo`03o`00oooooooo0?ZJ00oooooo00?o0000
ooooooooool04Oooool0033ooooo00?o0000ooooooooool01Oooool2o`00o`Cooooo00Go003ooooo
ooooooooooooo`00o`02ooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooool00?l00oooool0
0ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool01Oooool0
1?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool00_oo
ool00ol00?ooooooooooo`03ooooo`;o003o0oooool01Ol00?oooooooooooooooooo003o00?ooooo
00Go003oooooooooooooooooo`00o`02ooooo`05o`00ooooooooooooooooool00?l01oooool01?l0
0?oo0?ZJooooool0nYX3ooooo`03o`00oooooooooooo00;o00008Oooool00ol0003oooooooooo`0=
ooooo`03o`3jV_oooooo0?ZJ00Oooooo00?o0?ZJo`00ooooool00_ooool00ol00?ooooooo`3jVP0E
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0:
ooooo`03o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX01?ooool2o`3jVP_ooooo00Go0?ZJ
ooooooooooooooooo`3jVP04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`02ooooo`;o00000oooool00ol00?oo0?ZJooooo`07ooooo`;o0?ZJ
2Oooool01?l0nY[o003oooooool0nYYDooooo`05o`3jV_l00?ooooooo`00ooooool00_l0nYX6oooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02oooo
o`06o`00ooooooooooooo`00oooooooo0?ZJ3_ooool2o`0001?ooooo000`ooooo`03o`000?oooooo
oooo00Kooooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooooooo003o00;ooooo00?o
003oo`3jV_ooool01_ooool00ol0nY[oooooo`00o`03ooooo`03o`3jV_oooooooooo01Gooooo00?o
0?ZJooooool00?l00oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`00o`;ooooo
00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00?ooooo
0_l00?l3ooooo`05o`00ooooooooooooooooool00?l00oooool01Ol00?oooooooooooooooooo003o
00;ooooo00Go003oooooooooooooooooo`00o`07ooooo`04o`00ool0nY[oooooo`3jVP?ooooo00Go
003oooooooooooooooooo`00000Qooooo`;o00002?ooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooo0?ZJ00Oooooo00?o0?ZJooooooooool00_ooool00ol00?ooooooo`3jVP0Eooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo00oooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0:ooooo`04o`3j
V_ooooooooooo`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooo`3jVP03oooo
o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02o`00
00;ooooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool00_ooool00ol00?ooooooo`3jVP02o`3jVPGooooo00?o0?ZJooooool0nYX02?oo
ool01?l0nY[o003oooooool0nYYDooooo`08o`3jV_l00?ooooooo`00oooooooo0?ZJooooool0nYX5
ooooo`;o0?ZJ1_ooool2o`3jVPCooooo00?o0?ZJooooooooool00_ooool01_l00?ooooooooooool0
0?ooooooo`3jVPoooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool01_oo
ool00ol00?ooooooooooo`02ooooo`05o`00ooooooooooooooooool00?l00_ooool00ol00?oo0?ZJ
ooooo`05ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o0?ZJooooooooool05Oooool00ol0nY[o
ooooo`00o`03ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooo003o0_ooool00ol0
nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool00oooool2o`00
o`?ooooo00Go003oooooooooooooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l00_oo
ool01Ol00?oooooooooooooooooo003o00Oooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool00ol00?oo
ooooooooo`02o`00027ooooo00?o0000ooooooooool01_ooool2o`3jVPGooooo00?o0?ZJooooool0
nYX01oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooo0?ZJ00_ooooo0_l0nYX8ooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo00Sooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJoooo
oooooooo0?ZJ0_ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool00_ooool01Ol0nY[ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool00_ooool01Ol0
0?ooooooo`3jV_oooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX02?ooool01?l0nY[o003oooooool0
nYYDooooo`04o`3jV_l00?ooooooo`00o`?ooooo00?o0?ZJooooooooool00oooool2o`3jVPKooooo
0_l0nYX4ooooo`03o`3jV_oooooooooo00;ooooo00Ko003ooooooooooooo003oooooool0nYX?oooo
o`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Kooooo00?o003ooooooooo
ool00_ooool01?l00?ooooooooooool00?l4ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJoooo
oooooooo003o0oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJ
ooooooooool01Oooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01;ooooo00?o
0?ZJooooooooool00_ooool00ol00?ooooooooooo`03ooooo`;o003o1?ooool01?l00?oooooooooo
ool00?l3ooooo`04o`00ooooooooooooo`00o`Cooooo00Co003ooooooooooooo003o1oooool00ol0
0?ooooooooooo`04ooooo`05o`00ooooooooooooooooool000008Oooool00ol0003oooooooooo`05
ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`03o`3jV_oo
oooooooo00;ooooo00?o003oooooool0nYX02_ooool01?l0nY[oooooooooool0nYX6ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool01?ooool01?l0nY[oooooooooooooool2o`00o`;o
oooo00?o0?ZJooooooooool01oooool00ol0nY[o003oo`3jVP05ooooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3j
VPCooooo00Co0?ZJoooooooooooo0?ZJ0_ooool01Ol0nY[oooooooooool0nY[ooooo00;o0?ZJ1ooo
ool00ol0nY[oooooooooo`02ooooo`05o`3jV_ooooooooooooooool000000oooool2o`0000Wooooo
0ol00004ooooo`03o`000?oooooooooo00;ooooo00Go003oooooooooooooooooo`3jVP04ooooo`04
o`3jV_ooooooooooo`3jVPSooooo00Co0?ZJo`00oooooooo0?ZJE?ooool01?l0nY[o003oooooool0
0?l3ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooool0nYX01_ooool00ol0nY[oooooo`3j
VP03ooooo`03o`3jV_oooooooooo00;ooooo00Ko003ooooooooooooo003oooooool0nYX?ooooo`03
o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Kooooo00?o003oooooooooool0
0_ooool01?l00?ooooooooooool00?l4ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJoooooooo
oooo003o0oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJoooo
ooooool01Oooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`03ooooo`;o003o1?ooool01?l00?ooooooooooool0
0?l3ooooo`04o`00ooooooooooooo`00o`Cooooo00Co003ooooooooooooo003o1oooool00ol00?oo
ooooooooo`04ooooo`05o`00ooooooooooooooooool000006oooool2o`0000Cooooo00?o0000oooo
ooooool00_ooool01_l0nY[oooooooooool0nY[oooooo`3jVPCooooo00Go0?ZJoooooooooooooooo
o`3jVP06ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooool0nYX02_ooool01?l0nY[o003o
o`00ool0nYX6ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01?ooool01?l0nY[o
ooooooooool00?l2ooooo`03o`00oooooooo0?ZJ00Wooooo00Co0?ZJoooooooooooo0?ZJ1?ooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`04o`3jV_oooooo
ooooo`3jVP?ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`05o`3jV_ooooooooooo`3jV_oo
ool00_l0nYX7ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`00000Eoooo
o`;o00000oooool01Ol00?oooooooooooooooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ2?oo
ool01?l0nY[o003oooooool0nYYDooooo`04o`3jV_l00?ooooooo`00o`Cooooo00Go0?ZJoooooooo
ooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool0
0ol0nY[oooooooooo`03ooooo`06o`00ooooooooooooo`00oooooooo0?ZJ3oooool00ol0003ooooo
ooooo`0Aooooo`006?ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000;ooooo1Ol0
0003ooooo`03o`000?oooooooooo00Kooooo00?o003oooooooooool00_ooool01?l00?oooooooooo
ool00?l4ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool01Oooool01?l0nY[o
ooooooooool00?l2ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool00_ooool00ol0
0?ooooooooooo`04ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo003o0oooool0
1?l00?ooooooooooool00?l4ooooo`04o`00ooooooooooooo`00o`Oooooo00?o003oooooooooool0
1?ooool00ol00?ooooooooooo`02o`0001[ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`02ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Kooooo00?o0?ZJooooooooool00_ooool01?l00?ooooooooooool0nYX8ooooo`06o`3j
V_l00?ooooooooooool00?oo0?ZJ1Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
00Cooooo00Co0?ZJoooooooooooo003o0oooool00ol00?oo0?ZJooooo`08ooooo`05o`3jV_oooooo
ooooooooool0nYX00_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooool0nYX01?ooool01?l0nY[oooooooooool0nYX3ooooo`07o`3jV_ooooooooooooooool0
nY[oooooo`3jVP04ooooo`?o0?ZJ1oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oooooooooo
ooooool000005Oooool00ol0003oooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Go0?ZJ
ooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJo`00oooooooo0?ZJ
E?ooool01?l0nY[o003oooooool00?l4ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0
nY[oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool00oooool0
1_l00?ooooooooooool00?ooooooo`3jVPGooooo0_l0nYX8ooooo`03o`000?oooooooooo017ooooo
000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo00Kooooo00?o003oooooooooool00_ooool01?l0
0?ooooooooooool00?l4ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJoooooooooooo003o0ooo
ool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool01Ooo
ool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool0
0_ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo
003o0oooool01?l00?ooooooooooool00?l4ooooo`04o`00ooooooooooooo`00o`Sooooo00?o003o
ooooooooool00oooool01Ol00?oooooooooooooooooo000001[ooooo00Co0000oooooooooooo0000
0oooool2o`0000;ooooo00Co0?ZJooooool0nY[o0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ
00?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`04o`00oooooooooooo
o`3jVPSooooo00Ko0?ZJo`00ooooooooooooo`00ool0nYX5ooooo`03o`3jV_oooooooooo00Ko003o
00?o0?ZJooooooooool01?ooool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJo`00ooooool00oooool00ol0nY[oooooo`3jVP05ooooo`Ko003o0ol0nYX2ooooo`03
o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`02oooo
o`;o0?ZJ1?ooool01?l0nY[oooooooooool0nYX6ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool00_l0000Eooooo`03o`000?oooooooooo00;ooooo00?o003oooooooooool00_ooool0
1Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool01_ooool01?l0nY[o003ooooo
ool0nYYDooooo`04o`3jV_l00?ooooooo`00o`Cooooo00Go0?ZJooooooooooooooooo`3jVP02oooo
o`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`03
ooooo`06o`00ooooooooooooo`00oooooooo0?ZJ1Oooool00ol0nY[oooooo`3jVP07ooooo`03o`00
0?oooooooooo017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00000oooool00ol0003oooooooooo`03ooooo`;o00001oooool00ol00?ooooooooooo`03ooooo`03
o`00oooooooo003o00Cooooo00?o003oo`3jV_ooool01?ooool01?l0nY[oooooooooool00?l3oooo
o`03o`3jV_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`05
ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o0?ZJooooooooool04Oooool00ol0nY[ooooooooo
o`02ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool01?l00?oooooooooo
ool00?l3ooooo`04o`00ooooooooooooo`00o`Cooooo00Co003ooooooooooooo003o2?ooool00ol0
0?ooooooooooo`03ooooo`03o`00oooooooooooo00;o00006_ooool01?l0003oooooooooool00003
ooooo`05o`000?ooooooooooooooool00?l00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo
00Go0?ZJooooooooooooooooo`3jVP06ooooo`03o`3jV_oooooooooo00;ooooo00Co003ooooooooo
oooo0?ZJ2?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_l00?oooooo00?ooooo00?o0?ZJo`00
ool00?l01_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo003o00Gooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`00ool0nY[ooooo00;ooooo0ol00?l6oooo
o`05o`00oooooooo0?ZJooooool0nYX00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Go
0?ZJooooooooooooooooo`3jVP04ooooo`;o0?ZJ1?ooool2o`00o`03ooooool0nY[ooooo00Gooooo
00?o0?ZJooooooooool00_ooool01Ol0nY[ooooooooooooooooo000001Gooooo00?o0000oooooooo
ool00_ooool00ol00?ooooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0
nY[oooooooooo`06ooooo`04o`3jV_l00?ooooooo`3jVUCooooo00Co0?ZJo`00oooooooo003o1?oo
ool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool00_ooool01ol0nY[ooooo
oooooooooooo0?ZJooooool0nYX01Oooool01_l00?oooooooooooooooooo003oo`3jVPGooooo00?o
0?ZJooooool0nYX01oooool00ol0003oooooooooo`0Aooooo`005oooool01?l0003oooooooooool0
0008ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`06ooooo`03o`00oooooooooooo00?ooooo00?o003oooooool00?l01?ooool00ol00?oo0?ZJ
ooooo`04ooooo`03o`3jV_oooooo003o00Cooooo00?o0?ZJooooooooool05?ooool01?l0nY[ooooo
ooooool00?l3ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooo003o0oooool00ol0
nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool01?ooool00ol0
0?ooooooooooo`02ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooool00?l01?ooool0
1?l00?ooooooooooool00?l8ooooo`03o`00oooooooooooo00?ooooo00Go003ooooooooooooooooo
o`00000Jooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol00?oo
ooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooooooo00;ooooo00Co003ooooooooooooo0?ZJ1oooool00ol0nY[o003oooooo`04
ooooo`05o`3jV_l00?oo003oo`00ool0nYX02Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooo003o00Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`Co003o2_oo
ool01?l00?ooooooo`3jV_l0nYX2ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01Ol0nY[o
oooooooooooooooo0?ZJ00Cooooo00?o0?ZJooooooooool00oooool01?l00?ooooooo`00ool0nYX5
ooooo`03o`3jV_oooooooooo00?ooooo00Go003oooooooooooooooooo`00000Eooooo`;o00000ooo
ool00ol00?ooooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooooooool0
1Oooool01?l0nY[o003oooooool0nYYDooooo`04o`3jV_l00?ooooooo`00o`Gooooo00?o0?ZJoooo
ool0nYX00oooool00ol0nY[oooooooooo`02ooooo`07o`3jV_ooooooooooooooool0nY[oooooo`3j
VP05ooooo`07o`00ooooooooooooooooool00?ooooooo`3jVP03ooooo`04o`3jV_ooooooooooo`3j
VPOooooo00?o0000ooooooooool04Oooool001Oooooo00Co0000oooooooooooo00002?ooool01_l0
003oooooooooool0003oooooo`0000?ooooo00Go0000ooooooooooooooooo`00000>ooooo`03o`00
oooooooo003o00Cooooo00?o003oo`3jV_ooool01?ooool00ol0nY[oooooo`00o`04ooooo`03o`3j
V_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`05ooooo`04
o`3jV_ooooooooooo`00o`?ooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`02oooo
o`03o`00oooooooooooo00Wooooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooo`00o`04
ooooo`04o`00ooooooooooooo`00o`Sooooo00?o003oooooooooool00oooool01Ol00?oooooooooo
oooooooo000001[ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03
o`00oooooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool00_ooool01?l00?ooooooooooool0nYX7ooooo`03o`3jV_l00?oo
oooo00Gooooo00Co0?ZJoooooooooooo0?ZJ2Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooo003o00Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Booooo`03o`00oooo
oooo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ00?o
oooo00?o003oo`3jV_ooool01?ooool01?l00?ooooooo`00ool0nYX5ooooo`03o`3jV_oooooooooo
00?ooooo00Go003oooooooooooooooooo`00000Eooooo`03o`000?oooooooooo00;ooooo00?o003o
ooooooooool00_ooool01?l0nY[oooooooooool0nYX4ooooo`03o`3jV_oooooooooo00Gooooo00Co
0?ZJo`00oooooooo0?ZJDoooool00ol0nY[oooooo`00o`02ooooo`03o`00oooooooooooo00;ooooo
00?o0?ZJooooool0nYX01?ooool01?l0nY[oooooooooool0nYX4ooooo`;o0?ZJ1_ooool01ol00?oo
oooooooooooooooo003oooooool0nYX00oooool01?l0nY[oooooooooool0nYX7ooooo`03o`000?oo
oooooooo017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000
ooooool00003ooooo`05o`000?ooooooooooooooool000003_ooool00ol00?ooooooo`00o`04oooo
o`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooool00?l01?ooool00ol0nY[oooooooooo`0Doooo
o`04o`3jV_ooooooooooo`00o`?ooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0
0?l3ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool00_ooool00ol00?oooooooooo
o`09ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooool00?l01?ooool01?l00?oooooo
ooooool00?l8ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooooooo0_l0000Koooo
o`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`00oooooooooooo00?ooooo00Co0?ZJoooo
oooooooo0?ZJ1?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00Co003o
oooooooooooo0?ZJ1oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_oooooo0?ZJo`3jVPWooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`00o`05ooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool04oooool00ol00?ooooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP?o
oooo00Go003oo`3jV_ooooooooooo`3jVP03ooooo`03o`00oooooooooooo00Cooooo00Co003ooooo
ool00?oo0?ZJ1Oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJ
ooooool0nYX01?ooool00ol0nY[oooooooooo`05ooooo`05o`3jV_l00?ooooooo`00ool0nYX0D_oo
ool00ol0nY[oooooo`00o`02ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooool0nYX01?oo
ool01?l0nY[oooooooooool0nYX5ooooo`03o`3jV_oooooooooo00Cooooo00Oo003ooooooooooooo
ooooo`00oooooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol0003oooooooooo`0A
ooooo`006?ooool2o`0000[ooooo0_l00003ooooo`?o00001?ooool00ol0003oooooooooo`0<oooo
o`03o`00oooooooo003o00Cooooo00?o003oo`3jV_ooool01?ooool00ol0nY[oooooo`00o`05oooo
o`03o`3jV_oooooooooo01?ooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`05
ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o0?ZJooooooooool04Oooool00ol0nY[ooooooooo
o`02ooooo`03o`00oooooooooooo00Wooooo00Co003ooooooooooooo003o1?ooool00ol00?oooooo
o`00o`04ooooo`04o`00ooooooooooooo`00o`Sooooo00?o003oooooooooool00_ooool00ol00?oo
ooooooooo`02ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool00_ooool00ol00?oo
ooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`03ooooo`03o`00oooooooo0?ZJ00Oooooo00?o0?ZJooooooooool01_ooool00ol0
nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool00?l01Oooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_l00?oooooo01Cooooo00?o003oooooooooool00oooool01?l0
nY[oooooooooool0nYX3ooooo`04o`00ool0nY[oooooo`3jVPCooooo00?o003oooooooooool01?oo
ool01?l00?ooooooo`00ool0nYX5ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool0
0_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool0
0_ooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00Gooooo00Go0?ZJo`00oooooooo
003oo`3jVP1Booooo`03o`3jV_oooooo003o00;ooooo00?o003oooooooooool00_ooool00ol0nY[o
ooooo`3jVP04ooooo`04o`3jV_ooooooooooo`3jVPGooooo00?o0?ZJooooooooool01?ooool01ol0
0?oooooooooooooooooo003oooooool0nYX00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo
00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool03?ooool00ol00?ooooooo`00
o`04ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooool00?l01Oooool00ol0nY[ooooooooo
o`0Cooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJooooooooool00oooool01?l0nY[ooooo
ooooool00?l4ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool00_ooool00ol00?oo
ooooooooo`0:ooooo`03o`00oooooooo003o00Cooooo00?o003oooooool00?l01?ooool01?l00?oo
ooooooooool00?l8ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol0
003oooooooooo`0Oooooo`;o00000oooool00ol00?ooooooooooo`03ooooo`04o`3jV_oooooooooo
o`3jVPCooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooo
0?ZJ00Oooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oo
oooo00Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Dooooo`03o`00oooooooo
oooo00?ooooo00Co0?ZJoooooooooooo0?ZJ0oooool01?l00?oo0?ZJooooool0nYX4ooooo`03o`00
oooooooooooo00Cooooo00Co003oooooool00?oo0?ZJ1Oooool00ol0nY[oooooooooo`02ooooo`04
o`00ooooooooooooooooo`;o00005Oooool2o`0000Cooooo00?o003oooooooooool00_ooool00ol0
nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00Gooooo00Go0?ZJo`00oooooooo003oo`3jVP1B
ooooo`03o`3jV_oooooo003o00;ooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`03
ooooo`04o`3jV_ooooooooooo`3jVPcooooo00Oo003oooooooooooooooooo`00oooooooo0?ZJ00;o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo017o
oooo000`ooooo`03o`000?oooooooooo00cooooo00?o003oooooool00?l01Oooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooo003o00Gooooo00?o0?ZJooooooooool04oooool01?l0nY[ooooo
ooooool00?l4ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo003o1?ooool00ol0
nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool02_ooool00ol0
0?ooooooo`00o`04ooooo`03o`00oooooooo003o00Gooooo00?o003oooooool00?l02?ooool00ol0
0?ooooooooooo`02ooooo`04o`00ooooooooooooooooo`;o00008Oooool00ol0003oooooooooo`03
ooooo`03o`00oooooooooooo00;ooooo00Co003oo`3jV_oooooo0?ZJ1?ooool00ol0nY[ooooooooo
o`04ooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooool0nYX01oooool00ol0nY[ooooooooo
o`0Booooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJo`00ooooool01Oooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01Cooooo00?o003oooooooooool00oooool01?l0nY[ooooooooo
ool0nYX3ooooo`04o`00ool0nY[oooooo`3jVPCooooo00?o003oooooooooool01?ooool01?l00?oo
ooooo`00ool0nYX5ooooo`05o`3jV_ooooooooooooooool00?l01Oooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool00_ooool2o`3jVPGooooo00?o0?ZJ
ooooooooool01Oooool01Ol0nY[oooooooooool00?oo0?ZJ05;ooooo00?o0?ZJooooool00?l00_oo
ool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ
3?ooool01ol00?oooooooooooooooooo003oooooool0nYX00_ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Cooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000oooooooo
ool03?ooool00ol00?ooooooo`00o`05ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool0
0?l01Oooool00ol0nY[oooooooooo`0Cooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJoooo
ooooool00oooool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`0:ooooo`03o`00oooooooo003o00Cooooo00?o003o
ooooool00?l01Oooool00ol00?ooooooo`00o`08ooooo`03o`00oooooooooooo00;ooooo00?o003o
ooooooooool00_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00?ooooo00?o003o
ooooooooool00_ooool01?l00?oo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool00oooool2o`00o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04_oo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oooooo00Gooooo00?o0?ZJooooooooool01Ooo
ool00ol0nY[oooooooooo`0Dooooo`03o`00oooooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ
0oooool01?l00?oo0?ZJooooool0nYX4ooooo`03o`00oooooooooooo00Cooooo00Co003ooooooooo
oooo0?ZJ1Oooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`03ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`05ooooo`05o`3jV_ooooooooooo`00ool0nYX0D_ooool00ol0nY[oooooo`00
o`02ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJooooool0nYX03Oooool00ol00?oooooooooo
o`02ooooo`05o`00ool0nY[oooooooooool0nYX01?ooool00ol0nY[oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00cooooo00?o003oooooool00?l01Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo003o00Gooooo00?o0?ZJooooooooool04ooo
ool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo
003o1?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00;ooooo00?o003ooooooooo
ool02_ooool00ol00?ooooooo`00o`04ooooo`03o`00oooooooo003o00Gooooo00?o003oooooool0
0?l02?ooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooooooo`;o00008Oooool00ol0
003oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00Co003oo`3jV_oooooo0?ZJ1?ooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l00ol0nY[oooooooooo`04
ooooo`03o`3jV_l00?oooooo01Cooooo00?o0?ZJooooooooool00oooool00ol0nY[o003oooooo`05
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool05?ooool00ol00?ooooooooooo`03
ooooo`03o`00ool0nY[o0?ZJ00Cooooo00Co003oo`3jV_oooooo0?ZJ1?ooool00ol00?oooooooooo
o`04ooooo`04o`00ooooooooooooo`3jVPGooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool00oooool00ol00?ooooooooooo`03ooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01Oooool01Ol0nY[oooooooooool00?oo0?ZJ
05;ooooo00?o0?ZJooooool00?l00_ooool00ol00?ooooooooooo`09ooooo`03o`3jV_oooooo0?ZJ
00gooooo00?o003oooooooooool00_ooool2o`00o`03o`3jV_oooooo0?ZJ00Cooooo00?o0?ZJoooo
ooooool01?ooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0<ooooo`03
o`00oooooooo003o00Gooooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooooooool00?l5oooo
o`03o`3jV_oooooooooo01?ooooo00Co0?ZJoooooooooooo003o1?ooool00ol0nY[oooooooooo`03
ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJooooooooool04?ooool00ol0nY[ooooooooo
o`03ooooo`03o`00oooooooooooo00[ooooo00?o003oooooool00?l01?ooool00ol00?ooooooo`00
o`05ooooo`03o`00oooooooo003o00Sooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`02ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool00oooool00ol00?oooooooooo
o`02ooooo`04o`00ool0nY[oooooo`3jVP?ooooo00?o003oo`3jV_ooool01Oooool00ol0nY[ooooo
ooooo`03ooooo`;o003o00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Dooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJo`00ooooool01Oooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_l00?oooooo01Gooooo00?o003oooooooooool00oooool00ol00?oo0?ZJo`3jVP04ooooo`03o`00
oooooooo0?ZJ00Cooooo0_l00?l6ooooo`04o`00ooooooooooooo`3jVPGooooo00Go0?ZJoooooooo
ooooooooo`00o`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00oooool00ol0
0?ooooooooooo`09ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJo`00ooooooooooooo`00ool0
nYYBooooo`03o`3jV_oooooo003o00;ooooo00?o003oooooooooool02_ooool2o`3jVPgooooo00?o
003oooooooooool00_ooool2o`00o`;o0?ZJ1Oooool00ol0nY[oooooooooo`04ooooo`03o`000?oo
oooooooo017ooooo000`ooooo`03o`000?oooooooooo00cooooo00?o003oooooool00?l01Oooool0
0ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`Gooooo00?o0?ZJooooooooool04ooo
ool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo
003o1?ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o003ooooooooo
ool02_ooool2o`00o`Gooooo00?o003oooooool00?l01Oooool00ol00?ooooooo`00o`08ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol0003oooooooooo`0Oooooo`;o
00001?ooool00ol00?ooooooooooo`02ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_oo
ool01Oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooo0?ZJ00Kooooo00?o0?ZJoooooooo
ool05?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`0Eooooo`03o`00oooooooooooo00?ooooo00?o003oo`3jV_l0
nYX01?ooool2o`00o`03o`3jV_oooooooooo00;ooooo0_l00?l6ooooo`05o`00ooooooooooooo`00
ool0nYX01?ooool01Ol0nY[ooooooooooooooooo003o00Cooooo0_l0000Eooooo`;o00001?ooool0
0ol00?ooooooooooo`09ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJo`00ooooooooooooo`00
ool0nYYBooooo`03o`3jV_oooooo003o00;ooooo00?o003oooooooooool02_ooool2o`3jVPgooooo
00?o003oooooooooool00_ooool2o`00o`;o0?ZJ1Oooool00ol0nY[oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo000Booooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000_oo
ool5o`0000;ooooo0ol00004ooooo`03o`000?oooooooooo00cooooo00?o003oooooool00?l01Ooo
ool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`Gooooo00?o0?ZJooooooooool0
4_ooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o0?ZJooooooooool00oooool01?l0nY[o
ooooooooool00?l5ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool00oooool00ol0
0?ooooooooooo`0:ooooo`;o003o1Oooool00ol00?ooooooo`00o`05ooooo`03o`00oooooooo003o
00Sooooo00?o003oooooooooool00_ooool01?l00?ooooooooooooooool2o`00027ooooo00?o0000
ooooooooool00oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo0?ZJ00Cooooo0_l00?l0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooool0nYX01_ooool0
0ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJo`00ooooool01_ooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01Gooooo00?o003oooooooooool00oooool0
0ol00?oo0?ZJooooo`04ooooo`;o003o00?o0?ZJooooooooool00_ooool2o`00o`Kooooo00Go003o
oooooooooooo003oo`3jVP04ooooo`05o`3jV_ooooooooooooooool00?l01Oooool01?l0003ooooo
ooooooooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Cooooo00?o0000oooooooo
ool00oooool00ol00?ooooooooooo`0:ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00oooo
ool00_ooool00ol0nY[oooooooooo`1@ooooo`03o`3jV_oooooo003o00;ooooo00?o003ooooooooo
ool02_ooool00ol0nY[oooooooooo`0<ooooo`03o`00oooooooooooo00Cooooo00?o003oo`3jV_oo
ool01?ooool00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo017ooooo000Aooooo`04o`00
0?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003o
ooooo`0000?ooooo00Go0000ooooooooooooooooo`00000>ooooo`03o`00oooooooo003o00Gooooo
00?o003oo`3jV_ooool00_ooool01?l0nY[oooooo`00ool00?l5ooooo`03o`3jV_oooooooooo01;o
oooo00Go0?ZJooooooooooooooooo`00o`04ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooo
oooooooo003o1Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00?ooooo00?o003o
ooooooooool02_ooool2o`00o`Gooooo00?o003oooooool00?l01Oooool2o`00o`Wooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool00oooool00ol00?ooooooooooo`02ooooo`;o003o00?o0?ZJooooooooool00_ooool2
o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[o003oooooo`06
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool05_ooool00ol00?ooooooooooo`02
ooooo`03o`00ool0nY[ooooo00Cooooo0_l00?l5ooooo`;o003o1_ooool01Ol00?ooooooooooool0
0?oo0?ZJ00Cooooo00Co0?ZJoooooooooooo003o1_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
00?ooooo00?o003oooooooooool02_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_l00?oooooo
00;ooooo00?o0?ZJooooooooool0Coooool01?l0nY[oooooooooool00?l2ooooo`03o`00oooooooo
oooo00[ooooo00?o0?ZJooooooooool03?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooo
oooo00Cooooo00?o0?ZJooooooooool01?ooool00ol0003oooooooooo`0Aooooo`004Oooool01?l0
003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01Ooo
ool01Ol0003ooooooooooooooooo000000kooooo00?o003oooooool00?l01Oooool00ol00?oo0?ZJ
ooooo`02ooooo`03o`3jV_oooooo003o00Kooooo00?o0?ZJooooooooool04_ooool01Ol0nY[ooooo
oooooooooooo003o00Cooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool00?l5oooo
o`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0:oooo
o`;o003o1Oooool00ol00?ooooooo`00o`05ooooo`;o003o2_ooool01Ol00?oooooooooooooooooo
003o00Cooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`03ooooo`03o`00oooooooo
oooo00;ooooo0_l00?l00ol0nY[oooooooooo`02ooooo`;o003o00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool05?ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_l00?oooooo00Kooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`0Fooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool01?ooool2
o`00o`Gooooo0_l00?l6ooooo`05o`00ooooooooooooo`00ool0nYX01?ooool01?l0nY[ooooooooo
ool00?l6ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02Oooool01Ol0003o
oooooooooooooooo000000Gooooo00?o003oooooooooool02_ooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_l00?oooooo00;ooooo00?o003oo`3jV_ooool0Coooool01?l0nY[oooooooooool00?l3
ooooo`03o`00oooooooooooo01Sooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`04
ooooo`03o`3jV_oooooooooo00Cooooo00?o0000ooooooooool04Oooool0017ooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooooooo0_l0000>ooooo`;o003o1Oooool00ol00?oo0?ZJooooo`02ooooo`03o`3j
V_l00?oooooo00Kooooo00?o0?ZJooooooooool04_ooool01Ol0nY[ooooooooooooooooo003o00Co
oooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooooooo
00oooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0:ooooo`;o003o1Oooool00ol0
0?ooooooo`00o`05ooooo`;o003o2_ooool01Ol00?oooooooooooooooooo003o00?ooooo0_l0000Q
ooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooooooo0_l00?l5ooooo`;o003o00?o
0?ZJooooooooool00_ooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool05?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_l00?oooooo00Kooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Fooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool01?ooool2o`00o`Gooooo0_l00?l5ooooo`06o`00ooooooooooooooooool00?oo
0?ZJ1?ooool01?l0nY[oooooooooool00?l6ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01oooool2o`0000Cooooo0_l00005ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[o003oooooo`02ooooo`03o`00ool0nY[ooooo02[ooooo0_l0nYXS
ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o003oooooooooool06?ooool00ol00?oooooooooo
o`04ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJooooooooool00_ooool2o`0001?ooooo000A
ooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03
o`000?oooooo000000?o00001?ooool00ol0003oooooooooo`0=ooooo`;o003o1Oooool00ol00?oo
0?ZJooooo`02ooooo`03o`3jV_l00?oooooo00Kooooo00?o0?ZJooooooooool04_ooool01Ol0nY[o
oooooooooooooooo003o00Cooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool00?l5
ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0:
ooooo`;o003o1_ooool2o`00o`Gooooo0_l00?l:ooooo`05o`00ooooooooooooooooool00?l01?oo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooooooo
0_l00?l5ooooo`;o003o00?o0?ZJooooooooool00_ooool00ol00?oo0?ZJooooo`06ooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_l00?oooooo00Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Fooooo`04o`00
ooooooooooooooooo`;o003o1_ooool2o`00o`Gooooo0_l00?l5ooooo`03o`00oooooooooooo00;o
oooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooooooool00?l6ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000Kooooo00?o
003oooooooooool02Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_l00?oooooo00;ooooo00?o
003oo`3jV_ooool0:Oooool01?l0nY[oooooooooool0nYXRooooo`04o`3jV_ooooooooooo`00o`?o
oooo00?o003oooooooooool06?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Go
oooo00?o0?ZJooooooooool00oooool00ol0003oooooooooo`0Aooooo`004Oooool01?l0003ooooo
ooooool00008ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooo`000007
ooooo`03o`000?oooooooooo00gooooo0_l00?l5ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJ
o`00ooooool01_ooool00ol0nY[oooooooooo`0Booooo`05o`3jV_ooooooooooooooool00?l01?oo
ool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`00o`Gooooo00?o0?ZJooooooooool0
3oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00[ooooo0_l00?l6ooooo`;o003o
1Oooool2o`00o`[ooooo00Go003oooooooooooooooooo`00o`03ooooo`;o00008Oooool2o`0000Go
oooo00Co003ooooooooooooooooo0_l00?l5ooooo`03o`00oooooooo0?ZJ00Cooooo00?o003oo`3j
V_ooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_l00?oooooo01Gooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[o003oooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooo
ooooool05_ooool01?l00?ooooooooooooooool2o`00o`Gooooo00?o003oooooool00?l01Oooool0
0ol00?ooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool00_ooool0
1?l0nY[oooooooooool00?l5ooooo`;o00000_ooool01?l0003oooooooooool00007ooooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`04ooooo`03o`00oooooooooooo00Wo
oooo00?o0?ZJooooooooool00oooool00ol0nY[o003oooooo`02ooooo`03o`00ool0nY[ooooo02Wo
oooo00Co0?ZJoooooooooooo0?ZJ8_ooool01?l0nY[oooooooooool00?l3ooooo`03o`00oooooooo
oooo01Sooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`04ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0000ooooooooool04Oooool001;ooooo0_l0000:ooooo`;o00000oooool3o`00
00;ooooo1Ol00003ooooo`03o`000?oooooooooo00gooooo0_l00?l5ooooo`03o`00ool0nY[ooooo
00;ooooo00?o0?ZJo`00ooooool01_ooool00ol0nY[oooooooooo`0Booooo`05o`3jV_oooooooooo
ooooool00?l01?ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`00o`Gooooo00?o
0?ZJooooooooool03oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00_ooooo00?o
003oooooooooool01?ooool2o`00o`Gooooo0_l00?l:ooooo`05o`00ooooooooooooooooool00?l0
1?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooo
oooo0_l00?l5ooooo`03o`00oooooooo0?ZJ00Cooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
003oooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05_ooool01?l00?oo
ooooooooooooool2o`00o`Gooooo00?o003oooooool00?l01Oooool00ol00?ooooooo`00o`04oooo
o`03o`00oooooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`03o`00oooooooo
oooo00Cooooo00Co0000oooooooooooooooo0_l00009ooooo`?o00001?ooool00ol0003ooooooooo
o`04ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJooooooooool00oooool00ol0nY[o003ooooo
o`02ooooo`03o`00ool0nY[ooooo02Sooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Oooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o003oooooooooool06?ooool00ol00?oooooo
ooooo`05ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool00oooool00ol0003ooooo
ooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0=ooooo`;o003o1Oooool01ol00?oo0?ZJoooo
oooooooo0?ZJooooool00?l01oooool00ol0nY[oooooooooo`0Booooo`05o`3jV_oooooooooooooo
ool00?l01?ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`00o`Gooooo00?o0?ZJ
ooooooooool03oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00_ooooo00?o003o
ooooooooool01?ooool2o`00o`Gooooo0_l00?l:ooooo`05o`00ooooooooooooooooool00?l01?oo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooooooo
0_l00?l5ooooo`03o`00oooooooo0?ZJ00Cooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[o003o
ooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05_ooool01ol00?oooooo
oooooooooooo003oooooool00?l01?ooool00ol00?ooooooo`00o`05ooooo`03o`00oooooooo003o
00Cooooo00?o003oooooooooool00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o003o
ooooooooool01?ooool00ol0003oooooooooo`0Cooooo`;o00001Oooool00ol00?ooooooooooo`0:
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJo`00ooooool00_ooool00ol00?oo0?ZJooooo`0X
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool07oooool01?l0nY[oooooooooool0
0?l3ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool04oooool00ol00?oooooooooo
o`05ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`00<?ooool00ol0003oooooooooo`0=ooooo`;o003o1_ooool01_l0nY[oooooooooool0
nY[oooooo`00o`Sooooo00?o0?ZJooooooooool04Oooool01Ol0nY[ooooooooooooooooo003o00Co
oooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooooooo
00oooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo
00Cooooo0_l00?l6ooooo`03o`00oooooooooooo00Sooooo00Go003oooooooooooooooooo`00o`03
ooooo`;o00002Oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000;ooooo1Ol00003
ooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooooooo0_l00?l5ooooo`03o`00oooo
oooo0?ZJ00Cooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo01Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[o003oooooo`07ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJo`00ooooool05oooool01ol00?oooooooooooooooooo003oooooool0
0?l01?ooool00ol00?ooooooo`00o`05ooooo`03o`00oooooooo003o00Cooooo00?o003ooooooooo
ool00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o003oooooooooool01Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo00Cooooo00?o003oooooooooool02_ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_l00?oooooo00;ooooo00?o003oo`3jV_ooool0:?ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01oooooo00Co0?ZJoooooooooooo003o0oooool0
0ol00?ooooooooooo`02ooooo`03o`00oooooooooooo01?ooooo00?o003oooooooooool01_ooool3
o`00o`?ooooo00?o0?ZJooooooooool00oooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0
003oooooooooo`0=ooooo`;o003o1_ooool01Ol0nY[oooooooooool0nY[o003o00Wooooo00?o0?ZJ
ooooooooool04Oooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o0?ZJooooooooool00_oo
ool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o0?ZJooooooooool03_ooool00ol0nY[ooooo
ooooo`04ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01?ooool2o`00o`Kooooo
00?o003oooooooooool02Oooool01?l00?ooooooooooool00?l4ooooo`03o`000?oooooooooo00Ko
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000?ooooo00?o0000ooooooooool01?ooool01_l00?ooooooooooool00?ooooooo`00o`Go
oooo00?o003oooooool0nYX01?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Gooooo`07o`00oooooooooooooooo
ool00?ooooooo`00o`04ooooo`03o`00oooooooo003o00Gooooo00?o003oooooool00?l01?ooool0
0ol00?ooooooooooo`02ooooo`05o`00ool0nY[oooooooooool0nYX00_ooool00ol00?oooooooooo
o`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01Oooool01Ol00?oooooooooo
oooooooo003o00Oooooo00Oo0?ZJooooooooooooooooo`3jV_oooooo003o00?ooooo00?o003ooooo
ool0nYX09oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01gooooo00Go0?ZJoooo
ooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;o003o5Oooool00ol00?ooooooooooo`08
ooooo`05o`00ooooooooooooooooool0nYX01Oooool00ol0003oooooooooo`0Aooooo`00<?ooool0
0ol0003oooooooooo`0=ooooo`;o003o1_ooool01Ol0nY[oooooooooool0nY[o003o00Wooooo00?o
0?ZJooooooooool04Oooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o0?ZJooooooooool0
0_ooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o0?ZJooooooooool03_ooool00ol0nY[o
ooooooooo`04ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01?ooool2o`00o`Ko
oooo00?o003oooooooooool02Oooool01?l00?ooooooooooool00?l4ooooo`03o`000?oooooooooo
00Kooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oo
oooooooo00?ooooo0_l00005ooooo`06o`00ooooooooooooo`00oooooooo003o1Oooool00ol00?oo
ooooo`3jVP04ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo01Oooooo00Oo003oooooooooooooooooo`00oooooooo
003o00Cooooo00?o003oooooool00?l01Oooool00ol00?ooooooo`00o`04ooooo`03o`00oooooooo
oooo00?ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol00?ooooooooooo`04ooooo`;o00005Ooo
ool00ol0003oooooooooo`05ooooo`05o`00ooooooooooooooooool00?l01oooool01ol0nY[ooooo
oooooooooooo0?ZJooooool00?l00oooool00ol00?ooooooo`3jVP0Wooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool07Oooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o003o
ooooooooool00_l00?lEooooo`03o`00oooooooooooo00Wooooo00Co003ooooooooooooo0?ZJ1Ooo
ool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0>ooooo`03o`00oooooooo
oooo00Cooooo00Go0?ZJoooooooooooo0?ZJo`00o`09ooooo`03o`3jV_oooooooooo017ooooo00Go
0?ZJooooooooooooooooo`00o`04ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJoooooooooooo
ooooo`00o`05ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool01?ooool00ol00?oo
ooooooooo`0;ooooo`03o`00oooooooooooo00Cooooo0_l00?l6ooooo`03o`00oooooooooooo00Wo
oooo00Co003ooooooooooooo003o0oooool2o`0000Sooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?oo
ool01_l00?ooooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooooooo0?ZJ1?ooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool05Oooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0Gooooo`07o`00ooooooooooooooooool00?ooooooo`00o`04ooooo`03o`00oooo
oooo003o00Cooooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooooooo`03ooooo`04o`3j
V_ooooooooooo`3jVP;ooooo00?o003oooooooooool01Oooool00ol0003oooooooooo`0Cooooo`;o
00001_ooool00ol00?ooooooooooo`02o`00o`Cooooo00Co003ooooooooooooo0?ZJ0oooool00ol0
nY[o003oo`00o`03ooooo`03o`00oooooooo0?ZJ00Sooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXAooooo`Co0?ZJ0oooool00ol0
0?ooooooooooo`02ooooo`?o003o00?oooooo`00ooooool00_ooool2o`00o`Kooooo0_l00?l6oooo
o`?o003o3?ooool00ol00?ooooooo`3jVP05ooooo`03o`000?oooooooooo017ooooo000`ooooo`03
o`000?oooooooooo00kooooo00?o003oooooooooool01?ooool01Ol0nY[oooooooooool0nY[o003o
00Wooooo00?o0?ZJooooooooool04Oooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o0?ZJ
ooooooooool00_ooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o0?ZJooooooooool03_oo
ool00ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01Ooo
ool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Wooooo00Co003ooooooooooooo003o
1?ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooo
oooo0000ooooool00003ooooo`05o`000?ooooooooooooooool000001_ooool01?l00?oooooooooo
ool00?l2ooooo`05o`00ooooooooooooooooool00?l00_ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Oooooo00Ko0?ZJooooooooooooooooo`3jV_l00?lGooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo01Sooooo00Ko003ooooooooooooo003oooooool00?l4ooooo`04o`00ooooooooooooo`00o`?o
oooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooooooo`03ooooo`04o`3jV_oooooooooo
o`3jVP;ooooo00?o003oooooooooool01Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo00Kooooo0_l00?l00ooooooo003oooooo`02ooooo`03o`00oooooooo003o00;ooooo00Co0?ZJ
ooooool0nY[ooooo0_l00?l3ooooo`04o`00ooooooooooooo`3jVPOooooo0_l0nYXBooooo`?o0?ZJ
2?ooool00ol0nY[o003oo`00o`04ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJo`00ool0nYX0
4Oooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo00Oooooo00Ko003ooooooooooooo
003oooooool00?l5ooooo`03o`00oooooooo003o00Gooooo00?o003oooooool00?l03?ooool01?l0
0?ooooooooooool0nYX4ooooo`03o`000?oooooooooo017ooooo000Hooooo`;o00001?ooool00ol0
003oooooooooo`03ooooo`;o00000oooool3o`0000Cooooo00?o0000ooooooooool03_ooool00ol0
0?ooooooooooo`04ooooo`05o`00ool0nY[oooooo`3jV_l00?l02Oooool00ol0nY[oooooooooo`0@
ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool00oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00?ooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oo
oooooooo00Cooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`05ooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool02Oooool01?l00?ooooooooooool00?l3ooooo`;o0000
2?ooool01?l0003oooooooooool00008ooooo`06o`000?ooooooooooo`000?oooooo00000oooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o003oooooool00?l00_ooool01Ol00?oooooooooo
oooooooo003o00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`07ooooo`05o`3j
V_ooooooooooooooool0nYX06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Hooooo`06o`00ooooooooooooo`00
oooooooo003o1?ooool01?l00?ooooooooooool00?l3ooooo`04o`00ooooooooooooo`00o`Cooooo
00?o003oooooooooool00oooool01_l0nY[oooooooooool0nY[oooooo`00o`Sooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0:ooooo`03o`00oooooooo003o00;ooooo00?o003ooooo
ooooool00ol0nYX00ol00?ooooooooooo`03ooooo`04o`00ooooooooooooo`3jVPKooooo00?o0?ZJ
ooooool0nYX04_ooool00ol0nY[oooooo`3jVP08ooooo`03o`3jV_oooooo003o00Cooooo00?o0?ZJ
ooooooooool01_ooool01?l0nY[oooooo`00ool0nYX?ooooo`03o`3jV_oooooooooo00Gooooo00?o
003oooooooooool01oooool00ol00?ooooooo`00o`02ooooo`03o`00oooooooooooo00?ooooo00?o
003oooooool00?l01Oooool00ol00?ooooooooooo`0<ooooo`04o`00ooooooooooooo`3jVPCooooo
00?o0000ooooooooool04Oooool001Oooooo00Co0000oooooooooooo00002?ooool01_l0003ooooo
ooooool0003oooooo`0000?ooooo00Go0000ooooooooooooooooo`00000@ooooo`03o`00oooooooo
oooo00Cooooo00Co003oo`3jV_oooooo0?ZJ2_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oo
oooooooo00;ooooo00?o003oooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo
00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00Cooooo
00?o003oooooooooool04oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Wooooo
00Co003ooooooooooooo003o1?ooool00ol0003oooooooooo`07ooooo`;o00002_ooool2o`0000?o
oooo0ol00004ooooo`03o`000?oooooooooo00Gooooo00?o003oooooool00?l00_ooool01Ol00?oo
oooooooooooooooo003o00;ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`07oooo
o`05o`3jV_ooooooooooooooool0nYX06Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Hooooo`06o`00ooooooooooooo`00oooooooo
003o1?ooool01?l00?ooooooooooool00?l3ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003o
ooooooooool00oooool00ol0nY[oooooo`3jVP02ooooo`03o`00oooooooooooo00Kooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0:ooooo`;o003o1?ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00?ooooo00Co003ooooooooooooo0?ZJ1_ooool01?l0nY[ooooooooo
ool0nYXAooooo`03o`3jV_oooooo0?ZJ00Oooooo00Go0?ZJo`00ooooooooooooo`00o`04ooooo`03
o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ3_ooool00ol0nY[oooooooooo`05oooo
o`03o`00oooooooooooo00Sooooo0_l00?l4ooooo`05o`00ooooooooooooooooool00?l00oooool0
1Ol00?oooooooooooooooooo003o013ooooo00?o003oooooool0nYX01?ooool00ol0003ooooooooo
o`0Aooooo`005oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000Gooooo
00Go0000ooooooooooooooooo`00000Gooooo`04o`00ool0nY[oooooo`3jVP[ooooo00?o0?ZJoooo
ooooool04?ooool01Ol0nY[ooooooooooooooooo003o00Kooooo00Go0?ZJooooooooooooooooo`3j
VP03ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool03?ooool00ol0nY[ooooooooo
o`04ooooo`03o`00oooooooooooo01Cooooo00?o003oooooooooool01?ooool00ol00?oooooooooo
o`09ooooo`04o`00ooooooooooooo`00o`Cooooo00?o0000ooooooooool07oooool00ol0003ooooo
ooooo`05ooooo`03o`00oooooooo003o00;ooooo00Go003oooooooooooooooooo`00o`02ooooo`03
o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ
01Wooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool06?ooool01_l00?ooooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooooooo
003o0oooool01?l00?ooooooooooool00?l4ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJoooo
ool0nYX00_ooool00ol00?ooooooooooo`06ooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool02_ooool00ol00?ooooooooooo`04ooooo`04o`00ooooooooooooo`00o`Oooooo00?o003o
ooooool0nYX01_ooool01?l0nY[oooooooooool0nYX@ooooo`04o`3jV_ooooooooooo`3jVPOooooo
00Go0?ZJo`00ooooooooooooo`00o`04ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooo
oooo0?ZJ3_ooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo00Sooooo00?o003ooooo
ooooool00oooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003oooooooooooooooooo`00
o`0@ooooo`03o`00oooooooo0?ZJ00Cooooo00?o0000ooooooooool04Oooool001Oooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00003ooooo`;o00001?ooool2o`0001Kooooo
00Co003oo`3jV_l0nY[o003o2oooool00ol0nY[oooooooooo`0?ooooo`05o`3jV_oooooooooooooo
ool00?l01_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o003oooooooooool01?ooool0
0ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool09oooool0
1?l00?ooooooooooool00?l3ooooo`;o00008Oooool2o`0000Kooooo00?o003oooooool00?l00_oo
ool01Ol00?oooooooooooooooooo003o00;ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[ooooo
ooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX06Oooool01Ol0nY[ooooooooooooooooo0?ZJ
00Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Hooooo`06o`00oooooooooooo
o`00oooooooo003o1?ooool01?l00?ooooooooooool00?l3ooooo`04o`00ooooooooooooo`00o`Co
oooo00?o003oooooooooool00oooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00oooooooooooo00Go
oooo0_l0000Eooooo`;o00004_ooool01?l00?ooooooooooool00?l7ooooo`03o`00oooooooo0?ZJ
00Gooooo00Go0?ZJooooooooooooooooo`3jVP0@ooooo`05o`3jV_ooooooooooooooool0nYX01_oo
ool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o0?ZJooooooooool01?ooool01_l0nY[ooooo
oooooooooooo003oo`3jVPcooooo00?o0?ZJooooooooool01_ooool00ol00?ooooooooooo`0>oooo
o`05o`00ooooooooooooooooool00?l00oooool01Ol00?oooooooooooooooooo003o013ooooo00?o
003oooooool0nYX01?ooool00ol0003oooooooooo`0Aooooo`005oooool01?l0003oooooooooool0
0008ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000ooooooooooooooooo`00000Gooooo`04
o`00ool0nY[o0?ZJo`00o`_ooooo00?o0?ZJooooooooool03oooool01Ol0nY[ooooooooooooooooo
003o00Kooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`03o`3jV_oo
oooooooo00cooooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`0Wooooo`04o`00oooo
ooooooooo`00o`Cooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`05ooooo`03o`00
oooooooo003o00;ooooo00Go003oooooooooooooooooo`00o`02ooooo`03o`00ool0nY[ooooo00;o
oooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ01Wooooo00Go0?ZJoooo
ooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06?ooool0
0ol00?ooooooo`00o`02ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo003o0ooo
ool01?l00?ooooooooooool00?l4ooooo`03o`00oooooooooooo00?ooooo00?o003oo`3jV_l0nYX0
0_ooool00ol00?ooooooooooo`06ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4Oooool00ol00?ooooooo`00o`08ooooo`04o`00ooooooooooooo`3jVPCooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0=ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool00ol0
nY[oooooooooo`02ooooo`05o`00ooooooooooooooooool0nYX01_ooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool01_ooool00ol00?ooooooooooo`0?
ooooo`03o`00oooooooo003o00Gooooo00?o003oooooool00?l04Oooool00ol00?ooooooo`3jVP04
ooooo`03o`000?oooooooooo017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000
oooooooooooo0000ooooool00003ooooo`05o`000?ooooooooooooooool000006?ooool00ol00?oo
0?ZJo`00o`0;ooooo`03o`3jV_oooooooooo00oooooo00Go0?ZJooooooooooooooooo`00o`06oooo
o`04o`3jV_ooooooooooo`3jVPCooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0<
ooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool0:?ooool00ol00?ooooooo`00o`04
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool01Oooool00ol00?ooooooo`00o`02
ooooo`05o`00ooooooooooooooooool00?l00_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oo
oooooooo00Oooooo00Go0?ZJooooooooooooooooo`3jVP0Iooooo`05o`3jV_ooooooooooooooool0
nYX02Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Wooooo0_l00?l2ooooo`03
o`00oooooooooooo00;ooooo00Co003ooooooooooooo003o0oooool01?l00?ooooooooooool00?l4
ooooo`03o`00oooooooooooo00?ooooo00?o003oo`3jV_ooool00_ooool00ol00?ooooooooooo`06
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool2o`00o`Sooooo00Co003o
oooooooooooo0?ZJ1?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00gooooo00Go
0?ZJooooooooooooooooo`3jVP06ooooo`03o`3jV_oooooooooo00;ooooo00Go003ooooooooooooo
ooooo`3jVP06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02_ooool00ol0nY[o
ooooooooo`06ooooo`03o`00oooooooooooo00oooooo00?o003oooooool00?l01Oooool00ol00?oo
ooooo`00o`0Booooo`03o`00ool0nY[ooooo00?ooooo00?o0000ooooooooool04Oooool001Sooooo
0_l0000:ooooo`;o00000oooool3o`0000Cooooo00?o0000ooooooooool05_ooool00ol00?oo0?ZJ
o`00o`0;ooooo`03o`3jV_oooooooooo00oooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`04
o`3jV_ooooooooooo`3jVPCooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0<oooo
o`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool0:?ooool00ol00?ooooooo`00o`03oooo
o`;o00008Oooool00ol0003oooooooooo`05ooooo`03o`00oooooooo003o00;ooooo00Go003ooooo
ooooooooooooo`00o`02ooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ2Oooool01Ol0nY[ooooo
oooooooooooo0?ZJ01Wooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`06o`3jV_oooooooooo
ooooool0nY[o003o6oooool2o`00o`;ooooo00Go003oooooooooooooooooo`00o`03ooooo`05o`00
ooooooooooooooooool00?l00_ooool01Ol00?oooooooooooooooooo003o00Oooooo00Go003ooooo
ooooooooooooo`00o`08ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool2
o`00o`Sooooo00Co003ooooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo00gooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`03o`3jV_oooooooooo00;ooooo
00Go003oooooooooooooooooo`3jVP06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool02Oooool00ol0nY[oooooooooo`07ooooo`03o`00oooooooooooo013ooooo00?o003ooooooooo
ool01?ooool00ol00?ooooooo`00o`0Booooo`03o`00ool0nY[ooooo00?ooooo00?o0000oooooooo
ool04Oooool0033ooooo00?o0000ooooooooool05_ooool00ol00?oo0?ZJo`00o`0;ooooo`03o`3j
V_oooooooooo00oooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`04o`3jV_ooooooooooo`3j
VPCooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo
00Cooooo00?o003oooooooooool0:?ooool00ol00?ooooooo`00o`04ooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool01_ooool2o`00o`;ooooo00Go003oooooooooooooooooo`00o`02
ooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ2Oooool01Ol0nY[ooooooooooooooooo0?ZJ01Wo
oooo00Go0?ZJoooooooooooo0?ZJo`00o`09ooooo`05o`3jV_ooooooooooooooool0nYX07?ooool2
o`00o`?ooooo00Co003ooooooooooooo003o0oooool01Ol00?oooooooooooooooooo003o00;ooooo
00Go003oooooooooooooooooo`00o`07ooooo`05o`00ooooooooooooooooool00?l02?ooool00ol0
003oooooooooo`0Cooooo`;o00004oooool00ol00?ooooooooooo`07ooooo`04o`00oooooooooooo
o`3jVP?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`05o`00oooooooo
ooooooooool0nYX01_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Wooooo00?o
0?ZJooooooooool01oooool00ol00?ooooooooooo`0Hooooo`03o`00oooooooooooo017ooooo00?o
003oo`3jV_ooool00oooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0F
ooooo`;o003o3?ooool00ol0nY[oooooooooo`0?ooooo`05o`3jV_ooooooooooooooool00?l01_oo
ool01?l0nY[oooooooooool0nYX4ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool0
2oooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo02Sooooo00?o003oooooool00?l0
0oooool2o`00027ooooo0_l00007ooooo`;o003o0_ooool01?l00?ooooooooooool00?l4ooooo`05
o`00ool0nY[oooooo`00ool0nYX02Oooool01Ol0nY[ooooooooooooooooo0?ZJ01Wooooo00Go0?ZJ
oooooooooooo0?ZJo`00o`09ooooo`05o`3jV_ooooooooooooooool0nYX07?ooool2o`00o`?ooooo
00Co003ooooooooooooo003o0oooool01Ol00?oooooooooooooooooo003o00?ooooo00Co003ooooo
oooooooo003o1oooool01?l00?ooooooooooool00?l8ooooo`;o00005Oooool00ol0003ooooooooo
o`0Looooo`04o`00ooooooooooooo`3jVP?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`03ooooo`04o`00ooooooooooooo`3jVPKooooo00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo00Oooooo00?o003oooooooooool0;Oooool00ol0nY[o
ooooooooo`02ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo01Kooooo
0_l00?l<ooooo`03o`3jV_oooooooooo00oooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`04
o`00ool0nY[oooooo`3jVPCooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0;oooo
o`03o`3jV_oooooooooo00Gooooo00?o003oooooooooool0:?ooool00ol00?ooooooo`00o`04oooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool01oooool01?l00?ooooooooooool00?l2
ooooo`03o`00oooooooooooo00;ooooo00Go003oo`3jV_oooooo003oo`3jVP09ooooo`04o`3jV_oo
ooooooooo`3jVQ[ooooo00Go0?ZJoooooooooooo0?ZJo`00o`09ooooo`05o`3jV_oooooooooooooo
ool0nYX07Oooool01Ol00?oooooooooooooooooo003o00;ooooo00Go003oooooooooooooooooo`00
o`02ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo003o1oooool01?l00?oooooo
ooooool00?l9ooooo`04o`000?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`03oooo
o`?o00000oooool00ol0003oooooooooo`0Looooo`04o`00ooooooooooooo`3jVP?ooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[o003oooooo`04ooooo`05o`00ooooooooooooooooool0nYX01Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool01ooo
ool00ol00?ooooooooooo`0]ooooo`03o`00ool0nY[ooooo00;ooooo00?o0000ooooooooool04Ooo
ool0033ooooo00?o0000ooooooooool05oooool00ol00?ooooooooooo`0:ooooo`03o`3jV_oooooo
oooo00oooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o
003oooooooooool01?ooool00ol00?oo0?ZJooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo00?o
003oooooooooool0:?ooool00ol00?ooooooo`00o`04ooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool02oooool00ol00?ooooooo`00o`04ooooo`05o`00ool0nY[oooooo`00ool0nYX0
2Oooool01?l0nY[oooooooooool0nYXJooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Go0?ZJoooo
ooooooooooooo`3jVP0Mooooo`05o`00ooooooooooooooooool00?l00_ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooo003o00Cooooo00Co003ooooooooooooo003o1oooool01?l00?oooooo
ooooool00?l9ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo01cooooo00Go003oooooooooooooooooo`3jVP02
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool01Ol00?oooooooooooooo
oooo0?ZJ00Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00Sooooo00?o003oooooooooool0;Oooool00ol00?oo0?ZJooooo`02ooooo`03o`000?oo
oooooooo017ooooo000`ooooo`03o`000?oooooooooo01Oooooo00?o003oooooooooool02_ooool0
0ol00?oo0?ZJooooo`0>ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool01Oooool2
o`3jVPGooooo00?o003oooooooooool01Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooo
oooo00Gooooo00?o003oooooooooool0:Oooool2o`00o`?ooooo0_l0000Qooooo`03o`000?oooooo
oooo00_ooooo00?o003oooooool00?l01?ooool01Ol00?oo0?ZJo`00oooooooo0?ZJ00Wooooo00Co
0?ZJoooooooooooo0?ZJ6_ooool01?l0nY[oooooooooool0nYX:ooooo`05o`3jV_oooooooooooooo
ool0nYX08Oooool00ol00?ooooooo`00o`05ooooo`03o`00oooooooo003o00Cooooo00?o003ooooo
ool00?l02?ooool01?l00?ooooooooooool00?l9ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01Oooool5o`0000?ooooo0_l0000Mooooo`07o`00ooooooooooooooooool0nY[o
ooooo`3jVP07ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00Go003oooooooooooooooooo`3jVP04oooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`08oooo
o`03o`00oooooooooooo02gooooo00Co003oo`3jV_oooooooooo0_l0000Cooooo`00<?ooool00ol0
003oooooooooo`0Uooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool00_ooool00ol0
0?ooooooooooo`05ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oooooooooool01Oooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00Gooooo00?o003oooooooooool0:Oooool2o`00
o`Cooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0;ooooo`03o`00oooooooo003o
00Cooooo00Co003oo`3jV_l00?oo0?ZJ2_ooool01?l0nY[oooooooooool0nYXJooooo`04o`3jV_oo
ooooooooo`3jVP_ooooo00Co0?ZJoooooooooooo0?ZJ8_ooool2o`00o`Gooooo00?o003oooooool0
0?l01?ooool00ol00?ooooooo`00o`08ooooo`04o`00ooooooooooooo`00o`Wooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool07?ooool01ol00?oooooooooooooooooo0?ZJooooool0nYX01oooool00ol00?oo
0?ZJooooo`0:ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`04ooooo`05o`00ooooooooooooooooool0nYX01?ooool00ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool00ol00?ooooooooooo`0]oooo
o`03o`00ool0nY[ooooo00;ooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000oooooooo
ool09Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00;ooooo00?o003ooooooooo
ool01Oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJoooooooo
ool02Oooool00ol0nY[oooooooooo`06ooooo`03o`00oooooooooooo02Wooooo0_l00?l3ooooo`;o
00008Oooool00ol0003oooooooooo`0;ooooo`;o003o1_ooool00ol0nY[o003oo`3jVP0:ooooo`04
o`3jV_ooooooooooo`3jVQ[ooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0nY[oooooo`3jV_l0
0?lRooooo`;o003o1Oooool00ol00?ooooooo`00o`05ooooo`;o003o2Oooool00ol00?ooooooo`00
o`09ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
o`000004ooooo`03o`000?oooooooooo01gooooo00Ko003ooooooooooooo0?ZJooooool0nYX8oooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Cooooo00Go003oooooooooooooooooo`3jVP04ooooo`03o`3jV_oooooo
oooo00Cooooo00?o003oo`3jV_ooool01oooool00ol0nY[oooooooooo`08ooooo`03o`00oooooooo
oooo02kooooo00Go0?ZJooooooooooooooooo`00000Cooooo`004_ooool2o`0000Cooooo00?o0000
ooooooooool00oooool2o`0000?ooooo0ol00003ooooo`?o00001?ooool00ol0003oooooooooo`0U
ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX7ooooo`03o`3jV_oooooooooo00;ooooo00?o003o
ooooooooool01Oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`07ooooo`03o`00oooooooooooo02[ooooo00?o003o
ooooooooool00_ooool00ol0003oooooooooo`0Oooooo`;o00003?ooool00ol00?ooooooooooo`05
ooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o0?ZJooooool0nYX06_ooool01?l0nY[oooooooooool0
nYX;ooooo`03o`3jV_oooooo0?ZJ02?ooooo00?o003oooooooooool01?ooool2o`00o`Kooooo0_l0
0?l9ooooo`;o003o2Oooool2o`0000;ooooo00Co0000oooooooooooo00002Oooool2o`0000Cooooo
00?o0000ooooooooool07Oooool01Ol00?oooooooooooooooooo0?ZJ00Wooooo00?o0?ZJoooooooo
ool02Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool01Oooool01?l00?ooooooooooool0nYX4ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ooooool01Oooool00ol0nY[oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00Go0?ZJoooo
ooooooooooooo`00000Cooooo`004Oooool01?l0003oooooooooool00008ooooo`06o`000?oooooo
ooooo`000?oooooo00000oooool00ol0003oooooo`000003ooooo`05o`000?ooooooooooooooool0
00009oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVPKooooo00?o0?ZJoooo
ooooool00_ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Cooooo00?o003ooooo
ooooool01Oooool00ol00?oo0?ZJooooo`03ooooo`Go0?ZJ2_ooool00ol00?ooooooooooo`0Zoooo
o`03o`00oooooooooooo00;ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Coooo
o`03o`00ool0nY[ooooo00_ooooo00?o0?ZJooooool0nYX06oooool00ol0nY[oooooo`3jVP0;oooo
o`03o`3jV_oooooo0?ZJ02[ooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`08oooo
o`03o`00oooooooooooo00Wooooo00Co0000oooooooooooooooo0_l0000;ooooo`03o`000?oooooo
oooo00;ooooo0_l0000Nooooo`05o`00ooooooooooooooooool0nYX02Oooool00ol00?oo0?ZJoooo
o`08ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`05ooooo`04o`00ooooooooooooo`3jVP?ooooo00?o0?ZJo`00ooooool01_ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo00Wooooo00?o003oooooooooool0;_ooool01Ol0nY[ooooo
oooooooooooo000001?ooooo000Aooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooo
oooo00001Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o00009_ooool0
0ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool00ol0nY[ooooooooo
o`03ooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool00oooool00ol00?oooooooooo
o`06ooooo`05o`3jV_ooooooooooooooool0nYX03oooool00ol00?ooooooooooo`0^ooooo`;o0000
8Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooool0nYX0
6oooool00ol0nY[oooooo`3jVP0;ooooo`03o`3jV_oooooo0?ZJ04Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Mooooo`05o`00ooooooooooooooooool00?l02_ooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooo0?ZJ2?ooool01Ol0
0?oooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool01_ooool00ol00?oo0?ZJooooo`05
ooooo`03o`3jV_oooooooooo00Wooooo00?o003oooooooooool0<_ooool00ol0003oooooooooo`0A
ooooo`004Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo0_l0
0006ooooo`05o`000?ooooooooooooooool000009oooool00ol00?oo0?ZJooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`00oooooooooooo00Ko
oooo00?o003oooooooooool00oooool00ol00?ooooooooooo`06ooooo`05o`3jV_oooooooooooooo
ool0nYX03oooool00ol00?ooooooooooo`0_ooooo`03o`000?oooooooooo00Oooooo0_l00004oooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`?o00000oooool00ol0003oooooooooo`0Qoooo
o`;o0?ZJ7?ooool2o`3jVP03o`00oooooooooooo00Wooooo00?o0?ZJooooool0nYX0BOooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo01gooooo00Co003ooooooooooooo003o2oooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooo0?ZJ2Ooo
ool01?l00?ooooooooooool0nYX2ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`0:ooooo`03o`00oooooooooooo03;ooooo00?o0000ooooooooool0
4Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00005ooooo`03
o`000?oooooo000000?o00001?ooool00ol0003oooooooooo`0Vooooo`05o`3jV_ooooooooooo`3j
V_ooool01Ol00?l01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo00?o003oooooooooool01_ooool0
0ol00?ooooooooooo`02ooooo`;o003o2?ooool01Ol00?oo0?ZJo`3jV_l0nY[ooooo00Go003o2_oo
ool00ol00?ooooooooooo`0_ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo0000
2?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool08Oooool2o`3jVQcooooo0_l0nYX<ooooo`03o`00ool0nY[o003o04Wooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Nooooo`03o`00oooooooo003o00_ooooo00?o003oo`3jV_oo
ool01oooool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooo`3jVPWooooo00Co003ooooo
oooooooo0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool02_ooool00ol00?ooooooooooo`0booooo`03o`000?oooooooooo017ooooo000Aoooo
o`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`00
0?oooooo000000Oooooo00?o0000ooooooooool09oooool2o`3jVP;o003o1Oooool01?l00?oo0?ZJ
ooooool0nYX6ooooo`03o`00oooooooooooo00Kooooo00Go003oooooooooooooooooo`00o`0:oooo
o`05o`00ool0nY[oooooooooool00?l01Oooool2o`00o`Sooooo00?o003oooooooooool0;_ooool2
o`0000Sooooo00Co0000oooooooooooo00002?ooool01Ol0003oooooooooool0003ooooo00Go0000
0oooool2o`0002;ooooo00?o0?ZJooooooooool06oooool2o`3jVPgooooo00?o0?ZJooooooooool0
Aoooool2o`0001Gooooo00?o0000ooooooooool07_ooool00ol00?ooooooo`00o`0<ooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool01oooool01?l0nY[oooooooooool0nYX9ooooo`04
o`00ooooooooooooo`3jVP;ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo00[ooooo00?o003oooooooooool0<_ooool00ol0003oooooooooo`0Aoooo
o`004_ooool2o`0000[ooooo0_l00003ooooo`?o00000_ooool5o`0000?ooooo00?o0000oooooooo
ool0:?ooool00ol00?ooooooooooo`06ooooo`?o0?ZJ1_ooool00ol00?ooooooooooo`07ooooo`04
o`00ooooooooooooo`00o`_ooooo00Co003ooooooooooooo003o1oooool00ol00?ooooooooooo`05
ooooo`03o`00oooooooooooo02oooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool0
0008ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo03oooooo00?o0?ZJo`00ooooool03?ooool00ol0nY[oooooooooo`18ooooo`03
o`000?oooooooooo01?ooooo0_l0000Oooooo`;o003o3Oooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooo0?ZJ2Oooool01?l00?ooooooooooool0nYX2
ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`0;
ooooo`03o`00oooooooooooo03;ooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000oooo
ooooool0<oooool8o`00o`Wooooo0ol00?l<ooooo`?o003o2Oooool8o`00oc3ooooo0_l00008oooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool00ol0003oooooo`00
0004ooooo`03o`000?oooooooooo03oooooo00?o0?ZJooooooooool03?ooool00ol00?oooooooooo
o`18ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07oooool00ol00?oooooooooo
o`0;ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooo`3j
VP0:ooooo`06o`00ooooooooooooo`3jV_oooooo0?ZJ2_ooool2o`3jVP03ooooool0nY[o0?ZJ00go
oooo00?o003oooooooooool0<_ooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003ooooo
ooooo`2Hooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00002?ooool01?l0003o
ooooooooool00003ooooo`;o00001?ooool01Ol0003ooooooooooooooooo000001gooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06oooool01Ol0003ooooooooooooooooo000001Gooooo00?o0000ooooooooool0;_oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYX;ooooo`03o`00oooo
oooooooo00;o0?ZJ2oooool00ol00?ooooooo`3jVP0?ooooo`03o`00oooooooooooo03;ooooo00?o
0000ooooooooool04Oooool0033oooooW?l00009ooooo`;o00002_ooool2o`0000Gooooo00?o0000
ooooooooool00_oooonMo`0001Gooooo00?o0000ooooooooool0;_ooool00ol00?oo0?ZJo`3jVP02
ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX<ooooo`04o`00oooooooo0?ZJo`3jVPcooooo00?o
003oooooooooool03_ooool00ol00?ooooooooooo`0booooo`03o`000?oooooooooo017ooooo003o
oooooj3ooooo0_l0000`ooooo`;o003o0_l0nYX9o`00o`Gooooo00?o0?ZJooooooooool02oooool2
o`00o`03o`3jV_oooooooooo00_ooooo0_l00?l00ooooooo003oo`00o`08o`00o`?ooooo00?o003o
ooooooooool0<_ooool00ol0003oooooooooo`0Aooooo`00oooooonPooooo`03o`000?oooooooooo
03cooooo1Ol00?l00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00gooooo00?o003ooooo
ooooool02?ooool4o`00ocCooooo00?o0000ooooooooool04Oooool00?ooooooX?ooool01Ol0003o
oooooooooooooooo000001oooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool07Oooool01Ol0003ooooooooooooooooo
000001?ooooo003ooooooj3oooooZ?l0000Cooooo`00oooooooooooooecooooo003ooooooooooooo
G?ooool00?oooooooooooomLooooo`00oooooooooooooecooooo0000\
\>"],
  ImageRangeCache->{{{0, 601.188}, {123, 0}} -> {-0.0858923, -0.0154509, \
0.00527587, 0.00527587}, {{16.25, 205.812}, {120.062, 2.875}} -> {-3.50796, \
-0.0057068, 0.0676034, 0.000378352}, {{205.812, 395.312}, {120.062, 2.875}} -> \
{-16.3295, -0.0605698, 0.0676309, 0.000908004}, {{395.312, 584.875}, \
{120.062, 2.875}} -> {-26.2974, -0.0839731, 0.0627035, 0.00471867}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["true parameters", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
g = 
Table[
plot1[PFt[[T1//Range,{1},i,j]]~ii~PGt[[T1//Range,{1},i,j]]
\t\t//AddTimeAxis[#,{0,10,.1}]&,DisplayFunction->Identity]
,{i,1,2},{j,i,2}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{101, 3}\),
      SequenceForm[ "Dimension der Daten  ", {101, 3}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Show[GraphicsArray[g//Flatten]]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20601 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00490503 0.31746 [
[ 0 0 0 0 ]
[ 1 .20601 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .20601 L
0 .20601 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00490503 0.34127 0.201106 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 -0.0431504 20.6872 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06029 -30 -4.5 ]
[-0.0125 .06029 0 4.5 ]
[-0.0125 .16372 -24 -4.5 ]
[-0.0125 .16372 0 4.5 ]
[-0.0125 .26716 -30 -4.5 ]
[-0.0125 .26716 0 4.5 ]
[-0.0125 .37059 -24 -4.5 ]
[-0.0125 .37059 0 4.5 ]
[-0.0125 .47403 -30 -4.5 ]
[-0.0125 .47403 0 4.5 ]
[-0.0125 .57747 -24 -4.5 ]
[-0.0125 .57747 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .11264 -5 -6 ]
[.97619 .11264 5 6 ]
[.97619 .11264 -5 -6 ]
[.97619 .11264 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06029 m
.00625 .06029 L
s
[(0.005)] -0.0125 .06029 1 0 Mshowa
0 .16372 m
.00625 .16372 L
s
[(0.01)] -0.0125 .16372 1 0 Mshowa
0 .26716 m
.00625 .26716 L
s
[(0.015)] -0.0125 .26716 1 0 Mshowa
0 .37059 m
.00625 .37059 L
s
[(0.02)] -0.0125 .37059 1 0 Mshowa
0 .47403 m
.00625 .47403 L
s
[(0.025)] -0.0125 .47403 1 0 Mshowa
0 .57747 m
.00625 .57747 L
s
[(0.03)] -0.0125 .57747 1 0 Mshowa
.125 Mabswid
0 .08097 m
.00375 .08097 L
s
0 .10166 m
.00375 .10166 L
s
0 .12235 m
.00375 .12235 L
s
0 .14303 m
.00375 .14303 L
s
0 .18441 m
.00375 .18441 L
s
0 .2051 m
.00375 .2051 L
s
0 .22578 m
.00375 .22578 L
s
0 .24647 m
.00375 .24647 L
s
0 .28784 m
.00375 .28784 L
s
0 .30853 m
.00375 .30853 L
s
0 .32922 m
.00375 .32922 L
s
0 .34991 m
.00375 .34991 L
s
0 .39128 m
.00375 .39128 L
s
0 .41197 m
.00375 .41197 L
s
0 .43266 m
.00375 .43266 L
s
0 .45334 m
.00375 .45334 L
s
0 .49472 m
.00375 .49472 L
s
0 .5154 m
.00375 .5154 L
s
0 .53609 m
.00375 .53609 L
s
0 .55678 m
.00375 .55678 L
s
0 .0396 m
.00375 .0396 L
s
0 .01891 m
.00375 .01891 L
s
0 .59815 m
.00375 .59815 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06029 m
1 .06029 L
s
.99375 .16372 m
1 .16372 L
s
.99375 .26716 m
1 .26716 L
s
.99375 .37059 m
1 .37059 L
s
.99375 .47403 m
1 .47403 L
s
.99375 .57747 m
1 .57747 L
s
.125 Mabswid
.99625 .08097 m
1 .08097 L
s
.99625 .10166 m
1 .10166 L
s
.99625 .12235 m
1 .12235 L
s
.99625 .14303 m
1 .14303 L
s
.99625 .18441 m
1 .18441 L
s
.99625 .2051 m
1 .2051 L
s
.99625 .22578 m
1 .22578 L
s
.99625 .24647 m
1 .24647 L
s
.99625 .28784 m
1 .28784 L
s
.99625 .30853 m
1 .30853 L
s
.99625 .32922 m
1 .32922 L
s
.99625 .34991 m
1 .34991 L
s
.99625 .39128 m
1 .39128 L
s
.99625 .41197 m
1 .41197 L
s
.99625 .43266 m
1 .43266 L
s
.99625 .45334 m
1 .45334 L
s
.99625 .49472 m
1 .49472 L
s
.99625 .5154 m
1 .5154 L
s
.99625 .53609 m
1 .53609 L
s
.99625 .55678 m
1 .55678 L
s
.99625 .0396 m
1 .0396 L
s
.99625 .01891 m
1 .01891 L
s
.99625 .59815 m
1 .59815 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .11264 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .16167 m
.03333 .15557 L
.04286 .19136 L
.05238 .27999 L
.0619 .38816 L
.07143 .10525 L
.08095 .17466 L
.09048 .30111 L
.1 .428 L
.10952 .52059 L
.11905 .11163 L
.12857 .17406 L
.1381 .30209 L
.14762 .43227 L
.15714 .52656 L
.16667 .57438 L
.17619 .51349 L
.18571 .43224 L
.19524 .40592 L
.20476 .43549 L
.21429 .106 L
.22381 .17886 L
.23333 .31506 L
.24286 .44717 L
.25238 .53858 L
.2619 .58445 L
.27143 .59803 L
.28095 .59635 L
.29048 .59181 L
.3 .59008 L
.30952 .59183 L
.31905 .5954 L
.32857 .59896 L
.3381 .60148 L
.34762 .60277 L
.35714 .60318 L
.36667 .60315 L
.37619 .60302 L
.38571 .60297 L
.39524 .60301 L
.40476 .11356 L
.41429 .1792 L
.42381 .31823 L
.43333 .45445 L
.44286 .54746 L
.45238 .59221 L
.4619 .6033 L
.47143 .59914 L
.48095 .59288 L
.49048 .59032 L
Mistroke
.5 .11289 L
.50952 .17903 L
.51905 .31823 L
.52857 .45444 L
.5381 .54739 L
.54762 .59211 L
.55714 .6032 L
.56667 .59906 L
.57619 .59284 L
.58571 .5903 L
.59524 .59184 L
.60476 .59548 L
.61429 .59915 L
.62381 .60171 L
.63333 .60298 L
.64286 .60332 L
.65238 .60322 L
.6619 .60305 L
.67143 .60298 L
.68095 .60301 L
.69048 .11356 L
.7 .11389 L
.70952 .16332 L
.71905 .26533 L
.72857 .38264 L
.7381 .10516 L
.74762 .17416 L
.75714 .29946 L
.76667 .42573 L
.77619 .51847 L
.78571 .11153 L
.79524 .17406 L
.80476 .30207 L
.81429 .43221 L
.82381 .52648 L
.83333 .11198 L
.84286 .17414 L
.85238 .30206 L
.8619 .43223 L
.87143 .52656 L
.88095 .11181 L
.89048 .04567 L
.9 .04095 L
.90952 .05289 L
.91905 .15413 L
.92857 .29154 L
.9381 .41936 L
.94762 .51063 L
.95714 .56152 L
.96667 .58253 L
Mistroke
.97619 .11264 L
Mfstroke
0 .98 .604 r
gsave
.97619 .11264 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15875 m
.03333 .14628 L
.04286 .14602 L
.05238 .14355 L
.0619 .11797 L
.07143 .10338 L
.08095 .14896 L
.09048 .20318 L
.1 .20317 L
.10952 .1476 L
.11905 .10355 L
.12857 .14198 L
.1381 .23761 L
.14762 .35879 L
.15714 .48805 L
.16667 .56261 L
.17619 .49091 L
.18571 .36572 L
.19524 .2445 L
.20476 .14409 L
.21429 .10598 L
.22381 .17881 L
.23333 .31496 L
.24286 .44707 L
.25238 .53854 L
.2619 .58444 L
.27143 .59768 L
.28095 .59481 L
.29048 .58783 L
.3 .58255 L
.30952 .5807 L
.31905 .58269 L
.32857 .58868 L
.3381 .5973 L
.34762 .60264 L
.35714 .59195 L
.36667 .54727 L
.37619 .4543 L
.38571 .31811 L
.39524 .17897 L
.40476 .11287 L
.41429 .1777 L
.42381 .31658 L
.43333 .45404 L
.44286 .54645 L
.45238 .57817 L
.4619 .54644 L
.47143 .45402 L
.48095 .31656 L
.49048 .17768 L
Mistroke
.5 .11287 L
.50952 .17897 L
.51905 .31807 L
.52857 .45408 L
.5381 .54657 L
.54762 .59036 L
.55714 .59978 L
.56667 .59316 L
.57619 .58399 L
.58571 .57891 L
.59524 .57921 L
.60476 .58272 L
.61429 .58426 L
.62381 .57528 L
.63333 .54431 L
.64286 .48073 L
.65238 .3825 L
.6619 .26489 L
.67143 .16243 L
.68095 .11249 L
.69048 .1118 L
.7 .10656 L
.70952 .12128 L
.71905 .13265 L
.72857 .11518 L
.7381 .10266 L
.74762 .14613 L
.75714 .19701 L
.76667 .19619 L
.77619 .14526 L
.78571 .10902 L
.79524 .14475 L
.80476 .19522 L
.81429 .19604 L
.82381 .14581 L
.83333 .10251 L
.84286 .11148 L
.85238 .11788 L
.8619 .08731 L
.87143 .05102 L
.88095 .04456 L
.89048 .02118 L
.9 .01472 L
.90952 .05283 L
.91905 .1512 L
.92857 .27338 L
.9381 .35755 L
.94762 .36171 L
.95714 .28407 L
.96667 .17176 L
Mistroke
.97619 .11264 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00490503 0.65873 0.201106 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0.309016 8.2057 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06285 -30 -4.5 ]
[-0.0125 .06285 0 4.5 ]
[-0.0125 .1449 -30 -4.5 ]
[-0.0125 .1449 0 4.5 ]
[-0.0125 .22696 -30 -4.5 ]
[-0.0125 .22696 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .39107 -24 -4.5 ]
[-0.0125 .39107 0 4.5 ]
[-0.0125 .47313 -24 -4.5 ]
[-0.0125 .47313 0 4.5 ]
[-0.0125 .55519 -24 -4.5 ]
[-0.0125 .55519 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .30965 -5 -6 ]
[.97619 .30965 5 6 ]
[.97619 .30965 -5 -6 ]
[.97619 .30965 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06285 m
.00625 .06285 L
s
[(-0.03)] -0.0125 .06285 1 0 Mshowa
0 .1449 m
.00625 .1449 L
s
[(-0.02)] -0.0125 .1449 1 0 Mshowa
0 .22696 m
.00625 .22696 L
s
[(-0.01)] -0.0125 .22696 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .39107 m
.00625 .39107 L
s
[(0.01)] -0.0125 .39107 1 0 Mshowa
0 .47313 m
.00625 .47313 L
s
[(0.02)] -0.0125 .47313 1 0 Mshowa
0 .55519 m
.00625 .55519 L
s
[(0.03)] -0.0125 .55519 1 0 Mshowa
.125 Mabswid
0 .07926 m
.00375 .07926 L
s
0 .09567 m
.00375 .09567 L
s
0 .11208 m
.00375 .11208 L
s
0 .12849 m
.00375 .12849 L
s
0 .16131 m
.00375 .16131 L
s
0 .17772 m
.00375 .17772 L
s
0 .19414 m
.00375 .19414 L
s
0 .21055 m
.00375 .21055 L
s
0 .24337 m
.00375 .24337 L
s
0 .25978 m
.00375 .25978 L
s
0 .27619 m
.00375 .27619 L
s
0 .2926 m
.00375 .2926 L
s
0 .32543 m
.00375 .32543 L
s
0 .34184 m
.00375 .34184 L
s
0 .35825 m
.00375 .35825 L
s
0 .37466 m
.00375 .37466 L
s
0 .40748 m
.00375 .40748 L
s
0 .4239 m
.00375 .4239 L
s
0 .44031 m
.00375 .44031 L
s
0 .45672 m
.00375 .45672 L
s
0 .48954 m
.00375 .48954 L
s
0 .50595 m
.00375 .50595 L
s
0 .52236 m
.00375 .52236 L
s
0 .53878 m
.00375 .53878 L
s
0 .04643 m
.00375 .04643 L
s
0 .03002 m
.00375 .03002 L
s
0 .01361 m
.00375 .01361 L
s
0 .5716 m
.00375 .5716 L
s
0 .58801 m
.00375 .58801 L
s
0 .60442 m
.00375 .60442 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06285 m
1 .06285 L
s
.99375 .1449 m
1 .1449 L
s
.99375 .22696 m
1 .22696 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .39107 m
1 .39107 L
s
.99375 .47313 m
1 .47313 L
s
.99375 .55519 m
1 .55519 L
s
.125 Mabswid
.99625 .07926 m
1 .07926 L
s
.99625 .09567 m
1 .09567 L
s
.99625 .11208 m
1 .11208 L
s
.99625 .12849 m
1 .12849 L
s
.99625 .16131 m
1 .16131 L
s
.99625 .17772 m
1 .17772 L
s
.99625 .19414 m
1 .19414 L
s
.99625 .21055 m
1 .21055 L
s
.99625 .24337 m
1 .24337 L
s
.99625 .25978 m
1 .25978 L
s
.99625 .27619 m
1 .27619 L
s
.99625 .2926 m
1 .2926 L
s
.99625 .32543 m
1 .32543 L
s
.99625 .34184 m
1 .34184 L
s
.99625 .35825 m
1 .35825 L
s
.99625 .37466 m
1 .37466 L
s
.99625 .40748 m
1 .40748 L
s
.99625 .4239 m
1 .4239 L
s
.99625 .44031 m
1 .44031 L
s
.99625 .45672 m
1 .45672 L
s
.99625 .48954 m
1 .48954 L
s
.99625 .50595 m
1 .50595 L
s
.99625 .52236 m
1 .52236 L
s
.99625 .53878 m
1 .53878 L
s
.99625 .04643 m
1 .04643 L
s
.99625 .03002 m
1 .03002 L
s
.99625 .01361 m
1 .01361 L
s
.99625 .5716 m
1 .5716 L
s
.99625 .58801 m
1 .58801 L
s
.99625 .60442 m
1 .60442 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .30965 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .30902 m
.03333 .3216 L
.04286 .43982 L
.05238 .51728 L
.0619 .51802 L
.07143 .35353 L
.08095 .52325 L
.09048 .5765 L
.1 .53326 L
.10952 .45002 L
.11905 .32532 L
.12857 .52069 L
.1381 .58301 L
.14762 .53874 L
.15714 .45117 L
.16667 .31043 L
.17619 .12661 L
.18571 .19275 L
.19524 .31965 L
.20476 .40482 L
.21429 .34135 L
.22381 .54177 L
.23333 .59318 L
.24286 .53685 L
.25238 .44268 L
.2619 .36218 L
.27143 .31563 L
.28095 .29988 L
.29048 .30194 L
.3 .30938 L
.30952 .31496 L
.31905 .31659 L
.32857 .31523 L
.3381 .31274 L
.34762 .31055 L
.35714 .30925 L
.36667 .30878 L
.37619 .30882 L
.38571 .30901 L
.39524 .30917 L
.40476 .30906 L
.41429 .54112 L
.42381 .6021 L
.43333 .54303 L
.44286 .44284 L
.45238 .35808 L
.4619 .31033 L
.47143 .29559 L
.48095 .29945 L
.49048 .30844 L
Mistroke
.5 .31046 L
.50952 .54174 L
.51905 .60221 L
.52857 .54293 L
.5381 .44274 L
.54762 .35805 L
.55714 .31037 L
.56667 .29566 L
.57619 .29951 L
.58571 .30848 L
.59524 .31493 L
.60476 .31682 L
.61429 .3154 L
.62381 .31275 L
.63333 .31044 L
.64286 .30911 L
.65238 .30867 L
.6619 .30875 L
.67143 .30899 L
.68095 .30917 L
.69048 .30902 L
.7 .34436 L
.70952 .46859 L
.71905 .54027 L
.72857 .53119 L
.7381 .35497 L
.74762 .52106 L
.75714 .57453 L
.76667 .53283 L
.77619 .45089 L
.78571 .32569 L
.79524 .52073 L
.80476 .58293 L
.81429 .53868 L
.82381 .45116 L
.83333 .32463 L
.84286 .52034 L
.85238 .58292 L
.8619 .53878 L
.87143 .45123 L
.88095 .30937 L
.89048 .32974 L
.9 .41856 L
.90952 .44441 L
.91905 .56193 L
.92857 .58503 L
.9381 .53101 L
.94762 .44813 L
.95714 .37564 L
.96667 .33057 L
Mistroke
.97619 .30965 L
Mfstroke
0 .98 .604 r
gsave
.97619 .30965 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30855 m
.03333 .28982 L
.04286 .3185 L
.05238 .28062 L
.0619 .24793 L
.07143 .33823 L
.08095 .43485 L
.09048 .37557 L
.1 .24173 L
.10952 .17965 L
.11905 .29611 L
.12857 .45719 L
.1381 .52971 L
.14762 .56547 L
.15714 .54708 L
.16667 .30935 L
.17619 .07982 L
.18571 .0579 L
.19524 .08243 L
.20476 .15087 L
.21429 .3413 L
.22381 .54167 L
.23333 .59311 L
.24286 .53691 L
.25238 .44284 L
.2619 .36201 L
.27143 .31429 L
.28095 .29636 L
.29048 .29581 L
.3 .30174 L
.30952 .30906 L
.31905 .31696 L
.32857 .32449 L
.3381 .32587 L
.34762 .3091 L
.35714 .26028 L
.36667 .17525 L
.37619 .0751 L
.38571 .01593 L
.39524 .0764 L
.40476 .30762 L
.41429 .53971 L
.42381 .60332 L
.43333 .54579 L
.44286 .43421 L
.45238 .309 L
.4619 .18381 L
.47143 .07223 L
.48095 .01472 L
.49048 .07834 L
Mistroke
.5 .31044 L
.50952 .54162 L
.51905 .60193 L
.52857 .54234 L
.5381 .44146 L
.54762 .35554 L
.55714 .30621 L
.56667 .29006 L
.57619 .29372 L
.58571 .30451 L
.59524 .31399 L
.60476 .31626 L
.61429 .30507 L
.62381 .27343 L
.63333 .21797 L
.64286 .14687 L
.65238 .08644 L
.6619 .07699 L
.67143 .14844 L
.68095 .27272 L
.69048 .30866 L
.7 .31522 L
.70952 .34943 L
.71905 .30309 L
.72857 .2576 L
.7381 .3374 L
.74762 .42832 L
.75714 .37015 L
.76667 .24505 L
.77619 .19413 L
.78571 .30854 L
.79524 .42286 L
.80476 .37235 L
.81429 .2486 L
.82381 .19124 L
.83333 .27867 L
.84286 .34692 L
.85238 .28424 L
.8619 .22504 L
.87143 .26505 L
.88095 .30538 L
.89048 .26286 L
.9 .33438 L
.90952 .44346 L
.91905 .5484 L
.92857 .53261 L
.9381 .40477 L
.94762 .22885 L
.95714 .097 L
.96667 .10583 L
Mistroke
.97619 .30965 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00490503 0.97619 0.201106 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0.00311395 1.20041 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00311 -6 -4.5 ]
[-0.0125 .00311 0 4.5 ]
[-0.0125 .12316 -18 -4.5 ]
[-0.0125 .12316 0 4.5 ]
[-0.0125 .2432 -18 -4.5 ]
[-0.0125 .2432 0 4.5 ]
[-0.0125 .36324 -18 -4.5 ]
[-0.0125 .36324 0 4.5 ]
[-0.0125 .48328 -18 -4.5 ]
[-0.0125 .48328 0 4.5 ]
[-0.0125 .60332 -18 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .57718 -5 -6 ]
[.97619 .57718 5 6 ]
[.97619 .57718 -5 -6 ]
[.97619 .57718 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00311 m
.00625 .00311 L
s
[(0)] -0.0125 .00311 1 0 Mshowa
0 .12316 m
.00625 .12316 L
s
[(0.1)] -0.0125 .12316 1 0 Mshowa
0 .2432 m
.00625 .2432 L
s
[(0.2)] -0.0125 .2432 1 0 Mshowa
0 .36324 m
.00625 .36324 L
s
[(0.3)] -0.0125 .36324 1 0 Mshowa
0 .48328 m
.00625 .48328 L
s
[(0.4)] -0.0125 .48328 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(0.5)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .02712 m
.00375 .02712 L
s
0 .05113 m
.00375 .05113 L
s
0 .07514 m
.00375 .07514 L
s
0 .09915 m
.00375 .09915 L
s
0 .14716 m
.00375 .14716 L
s
0 .17117 m
.00375 .17117 L
s
0 .19518 m
.00375 .19518 L
s
0 .21919 m
.00375 .21919 L
s
0 .2672 m
.00375 .2672 L
s
0 .29121 m
.00375 .29121 L
s
0 .31522 m
.00375 .31522 L
s
0 .33923 m
.00375 .33923 L
s
0 .38725 m
.00375 .38725 L
s
0 .41125 m
.00375 .41125 L
s
0 .43526 m
.00375 .43526 L
s
0 .45927 m
.00375 .45927 L
s
0 .50729 m
.00375 .50729 L
s
0 .5313 m
.00375 .5313 L
s
0 .5553 m
.00375 .5553 L
s
0 .57931 m
.00375 .57931 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00311 m
1 .00311 L
s
.99375 .12316 m
1 .12316 L
s
.99375 .2432 m
1 .2432 L
s
.99375 .36324 m
1 .36324 L
s
.99375 .48328 m
1 .48328 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .02712 m
1 .02712 L
s
.99625 .05113 m
1 .05113 L
s
.99625 .07514 m
1 .07514 L
s
.99625 .09915 m
1 .09915 L
s
.99625 .14716 m
1 .14716 L
s
.99625 .17117 m
1 .17117 L
s
.99625 .19518 m
1 .19518 L
s
.99625 .21919 m
1 .21919 L
s
.99625 .2672 m
1 .2672 L
s
.99625 .29121 m
1 .29121 L
s
.99625 .31522 m
1 .31522 L
s
.99625 .33923 m
1 .33923 L
s
.99625 .38725 m
1 .38725 L
s
.99625 .41125 m
1 .41125 L
s
.99625 .43526 m
1 .43526 L
s
.99625 .45927 m
1 .45927 L
s
.99625 .50729 m
1 .50729 L
s
.99625 .5313 m
1 .5313 L
s
.99625 .5553 m
1 .5553 L
s
.99625 .57931 m
1 .57931 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .57718 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .015 m
.03333 .34244 L
.04286 .46066 L
.05238 .48094 L
.0619 .47922 L
.07143 .47626 L
.08095 .49826 L
.09048 .47422 L
.1 .46518 L
.10952 .48386 L
.11905 .51684 L
.12857 .52042 L
.1381 .48298 L
.14762 .46704 L
.15714 .48371 L
.16667 .01485 L
.17619 .38154 L
.18571 .55408 L
.19524 .59528 L
.20476 .57901 L
.21429 .54961 L
.22381 .52838 L
.23333 .48157 L
.24286 .46543 L
.25238 .48497 L
.2619 .52254 L
.27143 .55932 L
.28095 .58495 L
.29048 .59792 L
.3 .60183 L
.30952 .60142 L
.31905 .60015 L
.32857 .59965 L
.3381 .60012 L
.34762 .6011 L
.35714 .60209 L
.36667 .6028 L
.37619 .60316 L
.38571 .60328 L
.39524 .60327 L
.40476 .60324 L
.41429 .55643 L
.42381 .49217 L
.43333 .46763 L
.44286 .48507 L
.45238 .52338 L
.4619 .56132 L
.47143 .58741 L
.48095 .60008 L
.49048 .60331 L
Mistroke
.5 .60219 L
.50952 .55566 L
.51905 .49173 L
.52857 .46744 L
.5381 .48502 L
.54762 .52338 L
.55714 .56131 L
.56667 .58739 L
.57619 .60005 L
.58571 .60328 L
.59524 .60218 L
.60476 .60045 L
.61429 .59971 L
.62381 .60012 L
.63333 .60112 L
.64286 .60214 L
.65238 .60286 L
.6619 .60322 L
.67143 .60332 L
.68095 .60329 L
.69048 .01488 L
.7 .3378 L
.70952 .44974 L
.71905 .46761 L
.72857 .4676 L
.7381 .4676 L
.74762 .49471 L
.75714 .47335 L
.76667 .46515 L
.77619 .48373 L
.78571 .51631 L
.79524 .52012 L
.80476 .48286 L
.81429 .46701 L
.82381 .48371 L
.83333 .51723 L
.84286 .52075 L
.85238 .48319 L
.8619 .46714 L
.87143 .48373 L
.88095 .01484 L
.89048 .33619 L
.9 .40991 L
.90952 .39157 L
.91905 .44097 L
.92857 .4421 L
.9381 .45038 L
.94762 .47805 L
.95714 .51604 L
.96667 .55163 L
Mistroke
.97619 .57718 L
Mfstroke
0 .98 .604 r
gsave
.97619 .57718 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01496 m
.03333 .29602 L
.04286 .33444 L
.05238 .32051 L
.0619 .36067 L
.07143 .42186 L
.08095 .38386 L
.09048 .3192 L
.1 .31958 L
.10952 .39703 L
.11905 .47706 L
.12857 .47339 L
.1381 .46518 L
.14762 .45701 L
.15714 .34764 L
.16667 .01481 L
.17619 .34575 L
.18571 .45323 L
.19524 .46668 L
.20476 .49736 L
.21429 .54954 L
.22381 .52831 L
.23333 .48155 L
.24286 .46541 L
.25238 .48471 L
.2619 .52165 L
.27143 .55742 L
.28095 .58198 L
.29048 .59443 L
.3 .59897 L
.30952 .60025 L
.31905 .60012 L
.32857 .59649 L
.3381 .58441 L
.34762 .55939 L
.35714 .52245 L
.36667 .4847 L
.37619 .46737 L
.38571 .49167 L
.39524 .55556 L
.40476 .60211 L
.41429 .55594 L
.42381 .49183 L
.43333 .46057 L
.44286 .45744 L
.45238 .46006 L
.4619 .45744 L
.47143 .46057 L
.48095 .49183 L
.49048 .55593 L
Mistroke
.5 .60207 L
.50952 .55546 L
.51905 .49139 L
.52857 .46678 L
.5381 .48377 L
.54762 .52132 L
.55714 .55845 L
.56667 .58404 L
.57619 .59653 L
.58571 .5991 L
.59524 .59477 L
.60476 .58407 L
.61429 .56557 L
.62381 .53869 L
.63333 .50712 L
.64286 .4799 L
.65238 .467 L
.6619 .46711 L
.67143 .44928 L
.68095 .33752 L
.69048 .01484 L
.7 .28997 L
.70952 .32021 L
.71905 .30341 L
.72857 .34615 L
.7381 .41186 L
.74762 .37796 L
.75714 .31807 L
.76667 .3216 L
.77619 .39341 L
.78571 .44972 L
.79524 .39302 L
.80476 .32151 L
.81429 .31788 L
.82381 .37531 L
.83333 .40263 L
.84286 .32798 L
.85238 .27985 L
.8619 .2996 L
.87143 .28049 L
.88095 .01472 L
.89048 .25514 L
.9 .30853 L
.90952 .38608 L
.91905 .41792 L
.92857 .38627 L
.9381 .35528 L
.94762 .35898 L
.95714 .41283 L
.96667 .50628 L
Mistroke
.97619 .57718 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{601.25, 123.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009I0000Nb000`400?l00000o`00003ooooooooo
oooooe_ooooo003oooooooooooooFoooool00?oooooooooooomKooooo`00oooooooooooooe_ooooo
003ooooooj;ooooo0_l0000Looooo`Go00007Oooool3o`0001cooooo0ol0000Mooooo`?o00006_oo
ool3o`0000Cooooo0_l0000Cooooo`00oooooonQooooo`04o`000?ooooooooooo`0001cooooo00Co
0000oooooooooooo00007_ooool00ol0003oooooooooo`0Jooooo`05o`000?ooooooooooooooool0
00006oooool01Ol0003ooooooooooooooooo000001[ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool0000Booooo`00oooooonQooooo`04o`000?ooooooooooo`0001gooooo00?o0000
ooooooooool06oooool5o`0001_ooooo00Go0000ooooooooooooooooo`00000Kooooo`05o`000?oo
ooooooooooooool000006_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001;o
oooo003ooooooj7ooooo00Co0000oooooooooooo00007_ooool00ol0003oooooooooo`0Jooooo`04
o`000?ooooooooooo`0001cooooo1?l0000Mooooo`?o00006oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0001;ooooo003ooooooj7ooooo00Co0000oooooooooooo00006oooool0
1Ol0003ooooooooooooooooo000001cooooo00?o0000ooooool000007?ooool00ol0003ooooooooo
o`0Mooooo`05o`000?ooooooooooooooool000006_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0001;ooooo000booooo`;o00006_ooool5o`0001[ooooo0ol0000Jooooo`?o0000
6_ooool3o`0001Sooooo0ol00004ooooo`;o00009Oooool2o`0001Wooooo1Ol0000Kooooo`?o0000
6Oooool3o`0001_ooooo0ol0000Gooooo`?o00001?ooool2o`0001Sooooo00Co0000oooooooooooo
00006oooool01Ol0003ooooooooooooooooo000001gooooo0_l0000Mooooo`03o`000?oooooooooo
01cooooo00Go0000ooooooooooooooooo`00000Iooooo`;o00001?ooool01?l0003oooooooooool0
000Booooo`00<Oooool01?l0003oooooooooool0000Jooooo`04o`000?ooooooooooo`0001_ooooo
00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo000001Sooooo00Go0000oooooooo
ooooooooo`00000Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00008oooool0
1?l0003oooooooooool0000Iooooo`04o`000?ooooooooooo`0001cooooo00?o0000ooooooooool0
5oooool01Ol0003ooooooooooooooooo000001Wooooo00Go0000ooooooooooooooooo`00000Goooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00006?ooool2o`0001gooooo0ol0000O
ooooo`03o`000?oooooooooo01cooooo0_l0000Mooooo`?o00006oooool00ol0003oooooooooo`03
ooooo`;o00004oooool0037ooooo00Co0000oooooooooooo00006oooool00ol0003oooooooooo`0H
ooooo`Go00006Oooool01Ol0003ooooooooooooooooo000001Sooooo00Go0000oooooooooooooooo
o`00000Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00008oooool01?l0003o
ooooooooool0000Jooooo`03o`000?oooooooooo01Wooooo1Ol0000Hooooo`05o`000?oooooooooo
ooooool000006Oooool01Ol0003ooooooooooooooooo000001Oooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool0003@ooooo`00<Oooool01?l0003oooooooooool0000Looooo`03o`00
0?oooooooooo01Oooooo00Co0000oooooooooooo00006_ooool4o`0001[ooooo0ol0000Iooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00008oooool01?l0003oooooooooool0000K
ooooo`03o`000?oooooooooo01Sooooo00Co0000oooooooooooo00006Oooool4o`0001_ooooo0ol0
000Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00003oooool2o`000;oooooo
000aooooo`04o`000?ooooooooooo`0001Wooooo00Go0000ooooooooooooooooo`00000Iooooo`03
o`000?oooooo000001[ooooo00?o0000ooooooooool06_ooool01Ol0003ooooooooooooooooo0000
01Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Sooooo`04o`000?oooooo
ooooo`0001Sooooo00Go0000ooooooooooooooooo`00000Jooooo`03o`000?oooooo000001Wooooo
00?o0000ooooooooool06oooool01Ol0003ooooooooooooooooo000001Oooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool0000>ooooo`04o`000?ooooooooooo`000;kooooo000aoooo
o`04o`000?ooooooooooo`0001Wooooo00Go0000ooooooooooooooooo`00000Jooooo`;o00006ooo
ool00ol0003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000005oooool2o`0000Cooooo
00Co0000oooooooooooo00008oooool01?l0003oooooooooool0000Hooooo`05o`000?oooooooooo
ooooool000006oooool2o`0001[ooooo00?o0000ooooooooool06_ooool01Ol0003ooooooooooooo
oooo000001Kooooo0_l00004ooooo`04o`000?ooooooooooo`0000kooooo00Co0000oooooooooooo
00000ooooonXo`0001?ooooo000booooo`;o00006oooool3o`0001cooooo00?o0000ooooooooool0
6_ooool2o`0001[ooooo0ol0000Iooooo`03o`000?oooooooooo00?ooooo0_l0000Uooooo`;o0000
6_ooool3o`0001gooooo00?o0000ooooooooool06Oooool2o`0001_ooooo0ol0000Hooooo`03o`00
0?oooooooooo00?ooooo0_l0000?ooooo`04o`000?ooooooooooo`0000?ooooo0_l00002ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool01?l0003oooooo`000?l0000Coooo
o`00oooooonHooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`3jVP0G
ooooo`03o`3jV_oooooooooo05Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo003ooooooiSooooo00Co0000oooooooooooo00000oooool0
1Ol0003ooooooooooooooooo0?ZJ01Oooooo00?o0?ZJooooooooool0EOooool00ol0nY[ooooooooo
o`0Mooooo`03o`3jV_oooooooooo013ooooo00?o0000ooooooooool04Oooool00?ooooooVOooool2
o`0000Cooooo00Go0000ooooooooooooooooo`3jVP0Gooooo`03o`3jV_oooooooooo05Gooooo00?o
0?ZJooooooooool07Oooool00ol0nY[oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo000`
oooooico00008OoooonLo`0001Gooooo0_l00002ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJ
ooooooooool0EOooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo013ooooo00?o0000
ooooooooool04Oooool0033ooooo00Co0000oooooooooooo00007Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0K
ooooo`05o`000?ooooooooooooooool000008Oooool01Ol0003ooooooooooooooooo000001cooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool06_ooool01Ol0003ooooooooooooooooo000001Gooooo00Go0000oooooooo
ooooooooo`3jVP0Gooooo`03o`3jV_oooooooooo05Gooooo00?o0?ZJooooooooool07Oooool00ol0
nY[oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo08So
oooo00?o0?ZJooooooooool03Oooool00ol0003oooooooooo`0Oooooo`;o0000>_ooool00ol0nY[o
ooooooooo`0;ooooo`03o`3jV_oooooooooo04gooooo0_l0000Eooooo`05o`000?oooooooooooooo
ool0nYX05oooool00ol0nY[oooooooooo`1Eooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`27ooooo`;o
0?ZJ3_ooool2o`00027ooooo00?o0000ooooooooool0>Oooool00ol0nY[oooooooooo`0;ooooo`03
o`3jV_oooooooooo04kooooo00?o0000ooooooooool04oooool01Ol0003ooooooooooooooooo0?ZJ
01Oooooo00?o0?ZJooooooooool0EOooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo
013ooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool0Qoooool00ol0nY[o
ooooo`3jVP0>ooooo`03o`000?oooooooooo01oooooo0_l0000jooooo`03o`3jV_oooooooooo00_o
oooo00?o0?ZJooooooooool0COooool2o`0001Gooooo0_l00002ooooo`03o`3jV_oooooooooo01Go
oooo00?o0?ZJooooooooool0EOooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo013o
oooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool0Q_ooool01?l0nY[ooooo
ooooool0nYX>ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0>?ooool2o`3jVPgo
oooo0_l0nYY?ooooo`03o`000?oooooooooo01?ooooo00Go0000ooooooooooooooooo`3jVP0Goooo
o`03o`3jV_oooooooooo05Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo08Kooooo00Co0?ZJooooool0
0?oo0?ZJ3Oooool2o`00027ooooo00?o0000ooooooooool0>?ooool2o`3jVPgooooo0_l0nYY?oooo
o`03o`000?oooooooooo01?ooooo00Go0000ooooooooooooooooo`3jVP0Gooooo`03o`3jV_oooooo
oooo05Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`0@ooooo`03o`000?oooooo
oooo017ooooo000Booooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`00
00?ooooo0ol00004ooooo`03o`000?oooooooooo08Gooooo00Ko0?ZJooooool00?ooooooo`00ool0
nYX=ooooo`03o`000?oooooooooo00Oooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l0
0003ooooo`?o00001?ooool2o`0003Wooooo0_l0nYX<ooooo`03o`3jV_oooooo0?ZJ04kooooo0_l0
000Eooooo`05o`000?ooooooooooooooool0nYX05oooool00ol0nY[oooooooooo`1Eooooo`03o`3j
V_oooooooooo01gooooo00?o0?ZJooooooooool04?ooool00ol0003oooooooooo`0Aooooo`004Ooo
ool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooo
oooo0000ooooool00003ooooo`05o`000?ooooooooooooooool00000Q_ooool01?l0nY[ooooooooo
ool00?l2ooooo`03o`3jV_oooooooooo00_ooooo00?o0000ooooooooool01_ooool01?l0003ooooo
ooooool00008ooooo`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooo
oooo000003[ooooo00?o0?ZJooooool0nYX02oooool00ol0nY[oooooo`3jVP1?ooooo`03o`000?oo
oooooooo01?ooooo0_l00002ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool0EOoo
ool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo013ooooo00?o0000ooooooooool04Ooo
ool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000Gooooo00Co0000oooooooooooooooo0_l00025ooooo`04o`3jV_oooooooooo
o`00o`;ooooo00?o0?ZJooooooooool02_ooool2o`000003ooooool0003o000000?o00000_ooool0
1?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000Gooooo00Co0000oooooooooooo
oooo0_l0000Kooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX02oooool00ol0nY[o
ooooo`3jVP1>ooooo`;o00005Oooool01Ol0003ooooooooooooooooo0?ZJ01Oooooo00?o0?ZJoooo
ooooool0EOooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ4_ooool00ol0003oooooooooo`0Aoooo
o`004Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00001Oooool01Ol0003ooooooooooooooooo000008Gooooo00Co0?ZJoooooooooooo
003o0oooool00ol0nY[oooooooooo`0;ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00003ooooo`;o00001?ooool00ol0003oooooooooo`0J
ooooo`03o`3jV_oooooooooo01[ooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0nY[ooooooooo
ool0nYY>ooooo`03o`000?oooooooooo01?ooooo00Ko0000ooooooooooooooooo`00ool0nYXFoooo
o`03o`3jV_oooooooooo05Gooooo00?o0?ZJooooooooool07?ooool2o`3jVQ;ooooo00?o0000oooo
ooooool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002
ooooo`05o`000?ooooooooooo`000?ooool01?l00004ooooo`03o`000?oooooooooo08?ooooo00Co
0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`0;ooooo`03o`000?oooooooooo00Kooooo
00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00005ooooo`05o`000?oooooooooo
ooooool000006oooool00ol0nY[oooooo`3jVP0Kooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Co
0?ZJoooooooooooo0?ZJC_ooool00ol0003oooooooooo`0Cooooo`06o`000?ooooooooooooooool0
0?oo0?ZJ5_ooool00ol0nY[oooooooooo`1Dooooo`;o0?ZJ7_ooool2o`3jVQ;ooooo00?o0000oooo
ooooool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002
ooooo`06o`000?ooooooooooo`000?oooooo00001oooool00ol0003oooooooooo`23ooooo`04o`3j
V_ooooooooooo`00o`?ooooo00?o0?ZJooooooooool02_ooool2o`0000Sooooo00Co0000oooooooo
oooo00002?ooool01_l0003oooooooooool0003oooooo`0000?ooooo00Co0000oooooooooooooooo
0_l0000Iooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0
nY[oooooooooool0nYXIooooo`;o0?ZJ<_ooool2o`0001Gooooo0_l00003ooooo`03o`3jV_oooooo
oooo01Cooooo0_l0nYYEooooo`;o0?ZJ7_ooool2o`3jVQ;ooooo00?o0000ooooooooool04Oooool0
01;ooooo0_l0000:ooooo`;o00001?ooool2o`0000;ooooo1Ol00003ooooo`03o`000?oooooooooo
08;ooooo00Go0?ZJooooooooooooooooo`00o`03ooooo`03o`3jV_oooooooooo00_ooooo00?o0000
ooooooooool01oooool2o`0000[ooooo0_l00003ooooo`?o00001?ooool00ol0003oooooooooo`0H
ooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0nY[ooooo
ooooool0nYXHooooo`03o`3jV_oooooo0?ZJ03?ooooo00Co0000oooooooooooooooo0_l00004oooo
o`03o`000?oooooooooo00;ooooo0ol00004ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooo
ooooool05?ooool2o`3jVUGooooo0_l0nYXNooooo`;o0?ZJ4_ooool00ol0003oooooooooo`0Aoooo
o`00<?ooool00ol0003oooooooooo`22ooooo`05o`3jV_ooooooooooooooool00?l00oooool00ol0
nY[oooooooooo`0;ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool06?ooool01?l0
nY[oooooooooool0nYXKooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Co0?ZJoooooooooooo0?ZJ
6?ooool00ol0nY[oooooo`3jVP0cooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooooooo
ool05?ooool2o`3jVUGooooo0_l0nYXNooooo`;o0?ZJ4_ooool00ol0003oooooooooo`0Aooooo`00
<?ooool00ol0003oooooooooo`22ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJoooooooo
ool02_ooool2o`00027ooooo0_l0000Iooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00Co0?ZJoooo
oooooooo0?ZJ2oooool01?l0nY[oooooooooool0nYXHooooo`03o`3jV_oooooo0?ZJ02cooooo0_l0
nYX4ooooo`;o00000_ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJEOooool2o`3jVQkooooo
0_l0nYXBooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo04Sooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`0<ooooo`04o`3jV_ooooooooooo`3jVP?ooooo
00?o003oooooooooool00_ooool00ol00?oo0?ZJooooo`0;ooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool06?ooool01Ol0nY[ooooooooooooooooo0?ZJ01[ooooo00Co0?ZJoooooooo
oooo0?ZJ2oooool01?l0nY[oooooooooool0nYXHooooo`03o`3jV_oooooo0?ZJ02cooooo00?o0?ZJ
ooooool0nYX01?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool00oooool2o`0000?ooooo00?o0?ZJooooooooool05?ooool2o`3jVUGooooo0_l0
nYXNooooo`;o0?ZJ4Oooool2o`0001?ooooo000`ooooo`03o`000?oooooooooo00Oooooo0_l0nYX6
ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`0<
ooooo`03o`3jV_oooooooooo01Wooooo0ol0nYX00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooooooool01Oooool4o`3jVP?ooooo00?o003oooooooooool00oooool0
0ol0nY[oooooooooo`06ooooo`05o`3jV_ooooooooooooooool000008Oooool2o`0001Wooooo00Go
0?ZJooooooooooooooooo`3jVP0Jooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Co0?ZJoooooooo
oooo0?ZJ6?ooool00ol0nY[oooooo`3jVP0/ooooo`03o`3jV_oooooo0?ZJ00?ooooo0_l00002oooo
o`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
ooooo`03o`3jV_oooooooooo01Cooooo0_l0nYYEooooo`;o0?ZJ7_ooool2o`3jVQ;ooooo00?o0000
ooooooooool04Oooool0033ooooo00?o0000ooooooooool01_ooool00ol0nY[oooooo`3jVP06oooo
o`;o0?ZJ3?ooool2o`3jVQcooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Ioooo
o`06o`3jV_oooooo003oo`00oooooooo0?ZJ0_ooool00ol0nY[o003oo`3jVP05ooooo`03o`3jV_oo
oooooooo00Cooooo00Go0?ZJo`00ooooooooooooo`3jVP03ooooo`03o`00oooooooooooo00?ooooo
00?o0?ZJooooooooool01_ooool01Ol0nY[ooooooooooooooooo0000027ooooo00?o0000oooooooo
ool06?ooool01Ol0nY[ooooooooooooooooo0?ZJ01[ooooo00Co0?ZJoooooooooooo0?ZJ2oooool0
1?l0nY[oooooooooool0nYXGooooo`05o`3jV_ooooooooooooooool0nYX0:oooool00ol0nY[ooooo
o`3jVP04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool2o`0000Go
oooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJEOooool2o`3jVQko
oooo00?o0?ZJo`00ool0nYX04Oooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003ooooo
ooooo`06ooooo`03o`3jV_oooooo0?ZJ00Kooooo0_l0nYX<ooooo`;o0?ZJ7?ooool00ol0nY[ooooo
ooooo`0<ooooo`03o`3jV_oooooooooo01Wooooo00_o0?ZJooooool00?oo003oooooool0nY[ooooo
o`3jV_oooooo003oo`3jVP05ooooo`;o0?ZJ1Oooool00ol0nY[o003oooooo`05ooooo`03o`00oooo
oooooooo00?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`02o`00027ooooo00?o
0000ooooooooool06?ooool01Ol0nY[ooooooooooooooooo0?ZJ01[ooooo00Co0?ZJoooooooooooo
0?ZJ2oooool01?l0nY[oooooooooool0nYXGooooo`05o`3jV_ooooooooooooooool0nYX0:oooool0
0ol0nY[oooooo`3jVP04ooooo`04o`000?ooooooooooooooo`;o00002_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool05?ooool2o`3jVUGooooo0_l0
nYXNooooo`03o`3jV_l00?oo0?ZJ017ooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000
ooooooooool01_ooool01?l0nY[oooooo`00ool0nYX4ooooo`03o`3jV_l00?oo0?ZJ00cooooo0_l0
nYXLooooo`;o0?ZJ3Oooool2o`3jVQ[ooooo00Oo0?ZJooooool00?ooooooo`00oooooooo0?ZJ00;o
oooo00?o003oo`3jV_ooool00oooool00ol0nY[o003oo`3jVP05ooooo`03o`3jV_l00?oooooo00Go
oooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`06ooooo`05o`3jV_oooooooooooooo
ool000002Oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000;ooooo1Ol00003oooo
o`;o00006Oooool01Ol0nY[ooooooooooooooooo0?ZJ01Wooooo00Go0?ZJooooooooooooooooo`3j
VP0:ooooo`05o`3jV_ooooooooooooooool0nYX05oooool01Ol0nY[ooooooooooooooooo0?ZJ02_o
oooo00?o0?ZJooooool0nYX00oooool2o`0001Gooooo0_l00003ooooo`03o`3jV_oooooooooo01Co
oooo0_l0nYYEooooo`;o0?ZJ7_ooool00ol0nY[o003oo`3jVP0Aooooo`03o`000?oooooooooo017o
oooo000`ooooo`03o`000?oooooooooo00Gooooo00Go0?ZJoooooooooooo003oo`3jVP04ooooo`04
o`3jV_l00?oo003oo`3jVP[ooooo00?o0?ZJooooool0nYX07?ooool2o`3jVPgooooo0_l0nYXJoooo
o`05o`3jV_oooooo003oooooool00?l01?ooool2o`00o`07o`3jV_ooooooooooooooool0nY[o003o
o`3jVP04ooooo`03o`3jV_oooooo003o00Kooooo00?o003oooooooooool00oooool00ol0nY[ooooo
ooooo`06ooooo`05o`3jV_ooooooooooooooool000002?ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool00ol0003ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool05_ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00[ooooo00Go0?ZJooooooooooooooooo`3jVP0Gooooo`05o`3jV_oooooooooooooo
ool0nYX0:oooool00ol0nY[oooooo`3jVP04ooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool00_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJEOooool00ol0nY[o003oo`3jVP0Moooo
o`03o`3jV_l00?oo0?ZJ017ooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000oooooooo
ool00_ooool4o`3jVP;ooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX:oooo
o`04o`3jV_oooooo003oo`3jVQ_ooooo0_l0nYX=ooooo`;o0?ZJ6Oooool01_l0nY[oooooooooool0
0?ooooooo`00o`Cooooo0_l00?l01Ol0nY[ooooooooooooooooo0?ZJ00;o003o00Oo0?ZJoooooooo
ooooooooo`3jV_oooooo003o00Kooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`05
ooooo`04o`3jV_l00?ooooooooooo`;o000000?oooooo`000?l000000ol00002ooooo`04o`000?oo
ooooooooo`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`;o
00006Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX05oooool01Ol0
nY[ooooooooooooooooo0?ZJ02_ooooo00?o0?ZJooooool0nYX00oooool2o`0001Gooooo00?o0000
ooooooooool00_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJEOooool00ol0nY[o003oo`3jVP0M
ooooo`03o`3jV_l00?oo0?ZJ017ooooo00?o0000ooooooooool04Oooool001Sooooo0_l00004oooo
o`03o`000?oooooooooo00?ooooo0_l00003ooooo`?o00001?ooool01Ol0003ooooooooooooooooo
0?ZJ00Kooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX:ooooo`04o`3jV_oo
oooo003oo`3jVQ[ooooo00?o0?ZJo`00ool0nYX03?ooool00ol0nY[o003oo`3jVP0Iooooo`06o`3j
V_ooooooooooo`00oooooooo003o1?ooool2o`00o`05o`3jV_ooooooooooooooool0nYX00_l00?l0
1_l0nY[ooooooooooooooooo0?ZJooooo`;o003o1Oooool00ol00?ooooooooooo`03ooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJo`00ooooool00_ooool00ol0003oooooooooo`06ooooo`04o`00
0?ooooooooooo`0000Sooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo01Sooooo00?o0?ZJo`00ooooool00_ooool00ol0nY[oooooooooo`0Foooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooooooooooooooo
0?ZJ01Oooooo00Go0?ZJooooooooooooooooo`3jVP0[ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo01Cooooo0_l0
nYYEooooo`03o`3jV_l00?oo0?ZJ01gooooo00?o0?ZJo`00ool0nYX04Oooool00ol0003ooooooooo
o`0Aooooo`005oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo
00?o0000ooooooooool00oooool01?l0003oooooooooool0nYX2o`00o`Gooooo00?o003oo`3jV_oo
ool00oooool01?l0nY[o003oo`00ool0nYX:ooooo`04o`3jV_oooooo003oo`3jVQ[ooooo00?o0?ZJ
o`00ool0nYX03?ooool00ol0nY[o003oo`3jVP0Iooooo`04o`3jV_ooooooooooo`00o`;ooooo00Co
003ooooooooooooooooo0_l00?l01Ol0nY[ooooooooooooooooo0?ZJ00;o003o00Ko0?ZJoooooooo
ooooooooo`3jV_ooool2o`00o`Gooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_l00?oooooo00;ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool0
0008ooooo`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooooooo0000
01[ooooo00?o0?ZJo`00ooooool00_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ01Oooooo00Go0?ZJ
ooooooooooooooooo`3jVP0[ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o0000ooooooooool04ooo
ool2o`0000?ooooo00?o0?ZJooooooooool05?ooool2o`3jVUGooooo00?o0?ZJo`00ool0nYX07Ooo
ool00ol0nY[o003oo`3jVP0Aooooo`03o`000?oooooooooo017ooooo000Gooooo`04o`000?oooooo
ooooo`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`;o0000
00Coooooo`00oooooooo003o1Oooool00ol00?oo0?ZJooooo`03ooooo`04o`3jV_l00?ooooooo`3j
VP[ooooo00Co0?ZJooooool00?oo0?ZJ6_ooool01?l0nY[o003oooooool0nYX;ooooo`04o`3jV_l0
0?ooooooo`3jVQSooooo00Co0?ZJoooooooooooo003o0_ooool01ol00?oooooooooooooooooo003o
ooooool0nYX00oooool01?l0nY[o003oooooool0nYX3ooooo`04o`3jV_oooooo003oo`00o`Gooooo
00?o003oooooooooool00oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_l00?ooooooooooo`;o
00002?ooool01?l0003oooooooooool00008ooooo`06o`000?ooooooooooo`000?oooooo00000ooo
ool01?l0003oooooooooooooool2o`0001Wooooo00?o0?ZJo`00ooooool00_ooool00ol0nY[ooooo
ooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooo
oooooooooooo0?ZJ01Oooooo00Go0?ZJooooooooooooooooo`3jVP0[ooooo`03o`3jV_oooooo0?ZJ
00?ooooo0_l0000Eooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool05?ooool2o`3j
VUGooooo00?o0?ZJooooool0nYX07Oooool00ol0nY[oooooo`3jVP0Aooooo`03o`000?oooooooooo
017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o003oooooooooool00oooool2
o`00o`08o`3jV_ooooooooooo`3jV_oooooo003oooooool0nYX:ooooo`04o`3jV_oooooo003oo`3j
VQ[ooooo00Co0?ZJo`00oooooooo0?ZJ2oooool01?l0nY[o003oooooool0nYXHooooo`04o`3jV_oo
ooooooooo`00o`;ooooo00Oo003oooooooooooooooooo`00oooooooo0?ZJ00?ooooo00Co0?ZJo`00
oooooooo0?ZJ0oooool01?l0nY[oooooo`00ool00?l5ooooo`03o`00oooooooooooo00?ooooo00?o
0?ZJooooooooool01Oooool00ol0nY[o003oooooo`02ooooo`03o`000?oooooooooo00Oooooo0_l0
000:ooooo`;o00000oooool3o`0000Cooooo00?o0000ooooooooool06?ooool00ol0nY[o003ooooo
o`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`07ooooo`05o`3jV_ooooooooooooooool0nYX05_ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo02Sooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[o003oo`3jVP1Eooooo`03
o`3jV_oooooo0?ZJ01gooooo00?o0?ZJooooool0nYX04Oooool00ol0003oooooooooo`0Aooooo`00
5oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo0_l00?l02?l0
nY[oooooooooool0nY[oooooo`00oooooooo0?ZJ2_ooool01?l0nY[oooooo`00ool0nYXJooooo`04
o`3jV_l00?ooooooo`3jVP_ooooo00Co0?ZJo`00oooooooo0?ZJ6?ooool01?l0nY[oooooooooool0
0?l2ooooo`0Ao`00ooooooooooooooooool00?ooooooo`00ool0nY[oooooo`3jV_oooooo003ooooo
ool00?oo0?ZJooooool0nYX00_ooool2o`00o`Gooooo00?o003oooooooooool00oooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_l00?oooooo00;ooooo00?o0000ooooooooool07oooool2o`0001Wo
oooo00?o0?ZJo`00ooooool00_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ01Kooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`0Xooooo`04o`3jV_ooooooooooo`3jVP?ooooo0_l0000E
ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[o003oo`3jVP1E
ooooo`03o`3jV_oooooo0?ZJ01gooooo00?o0?ZJooooool0nYX04Oooool00ol0003oooooooooo`0A
ooooo`005oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo0_l0
0005ooooo`03o`000?oooooooooo00?ooooo00So003oooooooooooooooooo`00oooooooo003oo`3j
VP;ooooo00Go0?ZJooooool00?ooooooo`3jVP0:ooooo`04o`3jV_oooooo003oo`3jVQ[ooooo00Co
0?ZJo`00oooooooo0?ZJ2oooool01?l0nY[o003oooooool0nYXHooooo`04o`3jV_ooooooooooo`00
o`;ooooo017o003oooooooooooooooooo`00oooooooo003oo`3jV_oooooo0?ZJooooool00?oooooo
o`00ool0nY[oooooo`3jVP02ooooo`;o003o1Oooool00ol00?ooooooooooo`03ooooo`03o`3jV_oo
oooooooo00Gooooo00Co0?ZJo`00oooooooooooo0_l0000Qooooo`03o`000?oooooooooo00kooooo
00?o0?ZJooooooooool01oooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01Kooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`07ooooo`05o`3jV_ooooooooooooooool0
nYX05_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02Sooooo00Co0?ZJoooooooo
oooo0?ZJ1?ooool00ol0003oooooooooo`0Cooooo`;o00000oooool00ol0nY[oooooooooo`0Coooo
o`03o`3jV_l00?oo0?ZJ05Gooooo00?o0?ZJooooool0nYX07Oooool00ol0nY[oooooo`3jVP0Aoooo
o`03o`000?oooooooooo017ooooo000Hooooo`;o00002_ooool2o`0000Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`08o`00ooooooooooooooooool00?ooooooo`00ool0
nYX2ooooo`05o`3jV_oooooo003oooooool0nYX02_ooool01?l0nY[oooooo`00ool0nYXJooooo`04
o`3jV_l00?ooooooo`3jVP_ooooo00Co0?ZJo`00oooooooo0?ZJ6?ooool01?l0nY[oooooooooool0
0?l2ooooo`0Ao`00ooooooooooooooooool00?ooooooo`00ool0nY[oooooo`3jV_oooooo003ooooo
ool00?oo0?ZJooooool0nYX00_ooool2o`00o`Gooooo00?o003oooooooooool00oooool00ol00?oo
0?ZJooooo`05ooooo`03o`3jV_l00?oooooo00;ooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0>ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooool00?l00_ooool00ol0nY[o
ooooooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[o
oooooooooooooooo0?ZJ01Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Eoooo
o`03o`3jV_oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ol0nY[o003oo`3jVP1E
ooooo`03o`3jV_oooooo0?ZJ01gooooo00?o0?ZJooooool0nYX04Oooool00ol0003oooooooooo`0A
ooooo`00<?ooool00ol0003oooooooooo`03ooooo`08o`00ooooooooooooooooool00?ooooooo`00
ooooool2o`3jVP;ooooo00Co003oooooool00?oo0?ZJ2Oooool01?l0nY[o003oooooool0nYXJoooo
o`04o`3jV_l00?ooooooo`3jVP_ooooo00Co0?ZJo`00oooooooo0?ZJ5oooool01Ol0nY[ooooooooo
oooooooo003o00;ooooo00Oo003oooooooooooooooooo`00oooooooo003o00?o0?ZJ00Coooooo`00
oooooooo003o0ol0nYX2ooooo`;o003o1Oooool00ol00?ooooooooooo`04ooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJo`00ooooool00_ooool00ol0003oooooooooo`0Oooooo`;o00003oooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool05_ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00Go0?ZJooooooooooooooooo`3j
VP0Fooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool03Oooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJ0oooool2o`0001Gooooo
00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_l00?oo0?ZJ05Gooooo
00?o0?ZJooooool0nYX07Oooool00ol0nY[oooooo`3jVP0Aooooo`03o`000?oooooooooo017ooooo
000`ooooo`03o`000?oooooooooo00?ooooo00So003oooooooooooooooooo`00oooooooo003ooooo
o`;o0?ZJ0_ooool01?l00?ooooooo`00ool0nYX8ooooo`05o`3jV_oooooo003oooooool0nYX06_oo
ool01?l0nY[o003oooooool0nYX;ooooo`04o`3jV_l00?ooooooo`3jVQOooooo00Go0?ZJoooooooo
ooooooooo`00o`02ooooo`07o`00ooooooooooooooooool00?ooooooo`00o`04ooooo`03o`00oooo
oooo003o00Gooooo0_l00?l5ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooo`00o`02ooooo`;o00008Oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ2?oo
ool01?l0nY[o003oooooool00?l2ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJo`00ool0
nYX0EOooool00ol0nY[oooooo`3jVP0Mooooo`03o`3jV_oooooo0?ZJ017ooooo00?o0000oooooooo
ool04Oooool0033ooooo00?o0000ooooooooool00oooool01ol00?oooooooooooooooooo003ooooo
ool00?l01Oooool01?l00?ooooooo`00ool0nYX8ooooo`05o`3jV_oooooo003oooooool0nYX06_oo
ool01?l0nY[o003oooooool0nYX;ooooo`04o`3jV_l00?ooooooo`3jVQOooooo00Go0?ZJoooooooo
ooooooooo`00o`02ooooo`07o`00ooooooooooooooooool00?ooooooo`00o`04ooooo`03o`00oooo
oooo003o00Gooooo0_l00?l5ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooo`00o`03ooooo`03o`000?oooooooooo00Oooooo0_l00004ooooo`03o`000?oo
oooooooo00?ooooo0_l00003ooooo`?o00001?ooool2o`0000kooooo0_l0nYX8ooooo`04o`3jV_l0
0?ooooooo`00o`;ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Booooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ
4_ooool01?l0nY[oooooooooool0nYX3ooooo`;o00005Oooool2o`0000?ooooo00?o0?ZJoooooooo
ool04oooool00ol0nY[o003oo`3jVP1Eooooo`03o`3jV_oooooo0?ZJ01cooooo00Co0?ZJo`00oooo
oooo0?ZJ4Oooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`04ooooo`04
o`00ooooooooooooo`00o`;ooooo00?o003oooooooooool00_ooool01?l00?ooooooo`00ool0nYX8
ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool05_ooool01Ol0nY[oooooo`00oooo
oooo0?ZJ00[ooooo00Go0?ZJooooool00?ooooooo`3jVP0Gooooo`05o`3jV_ooooooooooooooool0
0?l00_ooool01ol00?oooooooooooooooooo003oooooool00?l01?ooool00ol00?ooooooo`00o`05
ooooo`03o`00oooooooo003o00Cooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooo003o00?ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool0
0008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0=ooooo`;o0?ZJ2?ooool01?l0nY[o003oooooool00?l2ooooo`03o`3jV_oooooooooo01Go
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00co
oooo00?o0?ZJooooooooool01?ooool2o`3jVQ;ooooo00Go0?ZJooooooooooooooooo`3jVP03oooo
o`04o`000?ooooooooooooooo`;o00001?ooool01?l0003oooooooooooooool5o`0000?ooooo00?o
0000ooooooooool00_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`3jV_l00?oo0?ZJ05Gooooo00?o
0?ZJooooool0nYX07?ooool01?l0nY[o003oooooool0nYXAooooo`03o`000?oooooooooo017ooooo
000`ooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooo003o0_ooool00ol00?oooooo
ooooo`02ooooo`04o`00oooooooo003oo`3jVPSooooo00?o0?ZJooooool00?l00_ooool00ol0nY[o
ooooooooo`0Fooooo`05o`3jV_oooooo003oooooool0nYX02_ooool01Ol0nY[oooooo`00oooooooo
0?ZJ01Oooooo00Go0?ZJooooooooooooooooo`00o`03ooooo`06o`00ooooooooooooo`00oooooooo
003o1?ooool00ol00?ooooooo`00o`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003ooooo
ooooool01?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo003o00?ooooo00?o0000oooo
ool000001?l00002ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00gooooo0_l0nYX8ooooo`04o`3jV_oo
ooooooooo`00o`;ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Booooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ
4_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`06ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool0
0ol00?oo0?ZJooooo`0Cooooo`03o`3jV_l00?oo0?ZJ05Gooooo00?o0?ZJooooool0nYX07?ooool0
1?l0nY[o003oooooool0nYXAooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooo
oooo00Cooooo00Co003ooooooooooooo003o0_ooool00ol00?ooooooooooo`02ooooo`04o`00oooo
oooo003oo`3jVPSooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`0Fooooo`05o`3j
V_oooooo003oooooool0nYX02_ooool01Ol0nY[oooooo`00oooooooo0?ZJ01Oooooo00Go0?ZJoooo
ooooooooooooo`00o`03ooooo`06o`00ooooooooooooo`00oooooooo003o1?ooool00ol00?oooooo
o`00o`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooooooool01?ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooo003o00;ooooo0_l00008ooooo`04o`000?ooooooooooo`00
00Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`;o00003_ooool2
o`3jVPSooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo01;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oo
oooo0?ZJ00Gooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00[ooooo00Go0?ZJoooooooooooooooo
o`3jVP02ooooo`;o00000_ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`3jV_l00?oo0?ZJ05Go
oooo00?o0?ZJooooool0nYX07?ooool01?l0nY[o003oooooool0nYXAooooo`03o`000?oooooooooo
017ooooo000`ooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooo003o0_ooool00ol0
0?ooooooooooo`02ooooo`04o`00oooooooo003oo`3jVPSooooo00?o0?ZJooooool00?l00_ooool0
0ol0nY[oooooooooo`0Fooooo`05o`3jV_oooooo003oooooool0nYX02_ooool01Ol0nY[oooooo`00
oooooooo0?ZJ01Oooooo00Go0?ZJooooooooooooooooo`00o`03ooooo`06o`00ooooooooooooo`00
oooooooo003o1?ooool00ol00?ooooooo`00o`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o
003oooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo003o00?ooooo00?o
0000ooooooooool01_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ00So
oooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
01;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo0?ZJ
00Gooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00[ooooo00Go0?ZJooooooooooooooooo`3jVP03
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`02ooooo`;o00000oooool00ol00?oo0?ZJooooo`0Cooooo`03o`3jV_l00?oo0?ZJ05Gooooo00?o
0?ZJooooool0nYX07?ooool01?l0nY[o003oooooool0nYX@ooooo`;o00004oooool0033ooooo00?o
0000ooooooooool01?ooool01?l00?ooooooooooool00?l2ooooo`03o`00oooooooooooo00;ooooo
00Co003oooooool00?oo0?ZJ2?ooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01Ko
oooo00Go0?ZJooooool00?ooooooo`3jVP0:ooooo`05o`3jV_oooooo003oooooool0nYX05oooool0
1?l0nY[oooooooooool00?l4ooooo`04o`00ooooooooooooo`00o`;ooooo00Oo003ooooooooooooo
ooooo`00oooooooo003o00Cooooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooooooo`04
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool00?l00oooool00ol0003oooooooooo`06
ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool2o`0000Gooooo
0_l0000=ooooo`03o`3jV_oooooo0?ZJ00Sooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`0;ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0
nY[oooooooooo`0:ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool2o`0000;ooooo00Co0000
oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0
0_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`3jV_oooooo0?ZJ05Gooooo00?o0?ZJooooool0nYX0
7?ooool01?l0nY[o003oooooool0nYXAooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`00
0?oooooooooo00Cooooo00Co003ooooooooooooo003o0_ooool00ol00?ooooooooooo`02ooooo`04
o`00ooooooooooooo`3jVPSooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`0Foooo
o`05o`3jV_oooooo003oooooool0nYX02_ooool01Ol0nY[oooooo`00oooooooo0?ZJ01Kooooo00Go
0?ZJooooooooooooooooo`00o`04ooooo`03o`00oooooooo003o00?ooooo00Go003ooooooooooooo
ooooo`00o`02ooooo`05o`00ooooooooooooooooool00?l00_ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooo`00o`02oooo
o`;o00002Oooool2o`0000[ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVPOooooo00Co0?ZJ
oooooooooooo003o0_ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo017ooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co
0?ZJoooooooooooo0?ZJ0oooool2o`3jVPcooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo
000000?ooooo00?o0000ooooooooool00_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`3jV_oooooo
0?ZJ05Cooooo00Co0?ZJo`00oooooooo0?ZJ7?ooool01?l0nY[o003oooooool0nYXAooooo`03o`00
0?oooooooooo017ooooo000Booooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000ooo
ool3o`0000?ooooo0ol00004ooooo`03o`000?oooooooooo00Cooooo00Co003ooooooooooooo003o
0_ooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooo`3jVPSooooo00?o0?ZJooooool0
0?l00_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01?ooooo00Go0?ZJoooooooo
ooooooooo`00o`04ooooo`03o`00oooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`02
ooooo`05o`00ooooooooooooooooool00?l00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooo`00o`03ooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo
ooooooooo`3jVPOooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`0Cooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0;ooooo`03
o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooo`3jVP0;oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool01?l0003oooooooooooooool2o`0000Wooooo0ol0
0004ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooo`3j
VP1Dooooo`04o`3jV_l00?ooooooo`3jVQcooooo00Co0?ZJo`00oooooooo0?ZJ4Oooool00ol0003o
ooooooooo`0Aooooo`004Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`00
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001ooo
ool00ol00?ooooooo`00o`02ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo0?ZJ
2?ooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooool00?l0
0_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool0
4oooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o003oooooool00?l00oooool01Ol00?oo
oooooooooooooooo003o00;ooooo00Go003oooooooooooooooooo`00o`02ooooo`03o`00oooooooo
oooo00;ooooo00?o003oooooooooool01?ooool00ol00?oo0?ZJooooo`02ooooo`04o`3jV_oooooo
ooooo`00o`?ooooo00?o0000ooooooooool07oooool2o`0000Oooooo0_l0nYX4ooooo`04o`3jV_oo
ooooooooo`3jVPOooooo00Go0?ZJooooooooooooooooo`00o`02ooooo`03o`3jV_oooooooooo01?o
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`3jVP04ooooo`04o`3jV_ooooooooooo`3j
VP?ooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`06ooooo`05o`3jV_oooooooooo
ooooool0nYX00_ooool2o`0001Gooooo0_l00004ooooo`03o`3jV_oooooooooo01;ooooo00Co0?ZJ
ooooool00?oo0?ZJDoooool01?l0nY[o003oooooool0nYXLooooo`04o`3jV_l00?ooooooo`3jVQ7o
oooo00?o0000ooooooooool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooooooo0_l00006
ooooo`03o`00oooooooo003o00;ooooo00?o003oooooooooool00_ooool01?l00?ooooooooooool0
nYX8ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooo`00
o`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooool00?l00_ooool00ol0nY[ooooooooo
o`0Cooooo`05o`3jV_ooooooooooooooool00?l01?ooool00ol00?ooooooo`00o`03ooooo`05o`00
ooooooooooooooooool00?l00_ooool01Ol00?oooooooooooooooooo003o00;ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`05ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool0
0ol00?ooooooooooo`02o`00027ooooo00?o0000ooooooooool01_ooool2o`3jVPCooooo00Co0?ZJ
oooooooooooo0?ZJ1oooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo
0?ZJ0oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJoooooooo
ooooooooo`3jVP03ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00oooool00ol0
nY[oooooooooo`0Booooo`04o`3jV_oooooo003oo`3jVU?ooooo00Co0?ZJo`00oooooooo0?ZJ7?oo
ool01Ol0nY[o003oooooool00?oo0?ZJ013ooooo00?o0000ooooooooool04Oooool0017ooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Go
oooo00Go0000ooooooooooooooooo`000007ooooo`03o`00oooooooo003o00?ooooo00Go003ooooo
ooooooooooooo`00o`02ooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooool00?l00_ooool0
0ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool01oooool0
0ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo01?ooooo00Go0?ZJooooooooooooooooo`00
o`04ooooo`03o`00oooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`02ooooo`05o`00
ooooooooooooooooool00?l00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Go
oooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`05o`00ooooooooooooooooool000008Oooool0
0ol0003oooooooooo`06ooooo`;o0?ZJ1?ooool01?l0nY[oooooooooool0nYX7ooooo`05o`3jV_oo
ooooooooooooool00?l00_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo017ooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooool0nYX01?ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooo0?ZJ00;o
oooo00?o0?ZJooooooooool01_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo01;ooooo00Co0?ZJoooo
ool00?oo0?ZJDoooool01?l0nY[o003oooooool0nYXIooooo`08o`3jV_ooooooooooo`3jV_l00?oo
ooooo`00ool0nYX@ooooo`03o`000?oooooooooo017ooooo000Aooooo`04o`000?ooooooooooo`00
00Sooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooooooool4o`0000Cooooo00?o
0000ooooooooool01Oooool00ol00?ooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l0
0_ooool00ol00?oo0?ZJooooo`05ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJoooooooo
ool05_ooool00ol0nY[oooooo`00o`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooool0
0?l00_ooool00ol0nY[oooooooooo`0Cooooo`05o`3jV_ooooooooooooooool00?l01?ooool00ol0
0?ooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l00_ooool01Ol00?oooooooooooooo
oooo003o00?ooooo00Go003oooooooooooooooooo`00o`07ooooo`05o`3jV_ooooooooooooooool0
nYX00_ooool01Ol00?oooooooooooooooooo0000027ooooo0_l00006ooooo`03o`3jV_oooooo0?ZJ
00Cooooo00Co0?ZJoooooooooooo0?ZJ1oooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o
0?ZJooooooooool04oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool01?ooool2o`3jVPGooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[ooooooooo
ool0nYX2ooooo`05o`3jV_ooooooooooo`3jV_ooool00_l0nYX7ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool00_l0000Eooooo`03o`000?oooooooooo00?ooooo00?o0?ZJoooooooo
ool04_ooool01?l0nY[oooooo`00ool0nYYCooooo`04o`3jV_l00?ooooooo`3jVQWooooo00So0?ZJ
oooooooooooo0?ZJo`00oooooooo003oo`3jVQ3ooooo00?o0000ooooooooool04Oooool0017ooooo
00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`;o00000oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o003oooooool00?l00oooool01Ol0
0?oooooooooooooooooo003o00;ooooo00?o003oo`3jV_ooool01Oooool01?l0nY[oooooooooool0
0?l3ooooo`03o`3jV_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[ooooo
ooooo`06ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooooooool04oooool01Ol0nY[o
oooooooooooooooo003o00Cooooo00?o003oooooool00?l00oooool01Ol00?oooooooooooooooooo
003o00;ooooo00Go003oooooooooooooooooo`00o`03ooooo`05o`00ooooooooooooooooool00?l0
1oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o003oooooooooool00_l0000Qooooo`03
o`000?oooooooooo00Gooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oooooooooool0nYX7oooo
o`05o`3jV_ooooooooooooooool00?l00_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo013ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool0
1Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool01Ol0nY[ooooo
ooooool0nY[ooooo00;o0?ZJ1oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oooooooooooooo
ool000005Oooool2o`0000Cooooo00?o0?ZJooooooooool04_ooool01?l0nY[oooooooooool0nYYC
ooooo`04o`3jV_l00?ooooooo`3jVQWooooo0ol0nYX01Ooooooo003oooooool00?oo0?ZJ013ooooo
00?o0000ooooooooool04Oooool001;ooooo0_l0000:ooooo`;o00001?ooool01?l0003ooooooooo
ooooool5o`0000?ooooo00?o0000ooooooooool01Oooool00ol00?ooooooo`00o`03ooooo`05o`00
ooooooooooooooooool00?l00_ooool00ol00?oo0?ZJooooo`05ooooo`04o`3jV_ooooooooooo`00
o`?ooooo00?o0?ZJooooooooool05?ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooo
oooo00Kooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0Cooooo`05o`3jV_oo
ooooooooooooool00?l01?ooool00ol00?ooooooo`00o`03ooooo`05o`00ooooooooooooooooool0
0?l00_ooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`07
ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool01Ol00?oooooooooooooooooo000001_ooooo
0_l00004ooooo`;o00000oooool01_l0nY[oooooooooool0nY[oooooo`3jVPCooooo00Co0?ZJoooo
oooooooo0?ZJ1oooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJooooooooool04_oo
ool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`08ooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00?ooooo0_l0nYX4ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01?l0nY[ooooo
ooooool0nYX2ooooo`04o`3jV_ooooooooooooooo`?o0?ZJ1oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00;o00005Oooool00ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo
01;ooooo00Co0?ZJoooooooooooo0?ZJDoooool01Ol0nY[o003oooooool00?oo0?ZJ01Oooooo00?o
0?ZJooooool0nYX00_ooool01?l00?ooooooo`00ool0nYX@ooooo`03o`000?oooooooooo017ooooo
000`ooooo`03o`000?oooooooooo00Gooooo00?o003oooooool00?l00oooool01Ol00?oooooooooo
oooooooo003o00;ooooo00?o003oo`3jV_ooool01Oooool01?l0nY[oooooooooool00?l3ooooo`03
o`3jV_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`06oooo
o`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooooooool04oooool01Ol0nY[ooooooooooooo
oooo003o00Gooooo0_l00?l3ooooo`05o`00ooooooooooooooooool00?l00_ooool01Ol00?oooooo
oooooooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`07ooooo`05o`3jV_oooooooooo
ooooool0nYX00_ooool01Ol00?oooooooooooooooooo000001[ooooo00Co0000oooooooooooo0000
0oooool00ol0003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00Go0?ZJoooooooo
ooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00Gooooo00Go0?ZJooooooooooooooooo`00o`02
ooooo`03o`3jV_oooooooooo00Oooooo1?l0nYX7ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`02o`00o`;ooooo00?o0?ZJooooooooool01oooool0
1?l0nY[o003oo`00ool0nYX5ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooo`3jVP04ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01ol0nY[ooooo
oooooooooooo0?ZJooooool0nYX00oooool00ol0nY[oooooo`3jVP07ooooo`03o`3jV_oooooooooo
00;ooooo00Go0?ZJooooooooooooooooo`00000Eooooo`03o`000?oooooooooo00?ooooo00?o0?ZJ
ooooooooool04_ooool01?l0nY[oooooooooool0nYYCooooo`05o`3jV_l00?ooooooo`00ool0nYX0
0_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00;ooooo00Go003oooooool00?oo
ooooo`3jVP0?ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Gooooo
00?o003oooooool00?l00oooool01Ol00?oooooooooooooooooo003o00;ooooo00?o003oo`3jV_oo
ool01Oooool01?l0nY[oooooooooool00?l3ooooo`03o`3jV_oooooooooo01Cooooo00Co0?ZJoooo
oooooooo003o0_ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o
0?ZJooooooooool04oooool01Ol0nY[ooooooooooooooooo003o00Gooooo0_l00?l3ooooo`05o`00
ooooooooooooooooool00?l00_ooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003ooooo
ooooooooooooo`00o`07ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool01Ol00?oooooooooo
oooooooo000001[ooooo00Co0000oooooooooooo00000oooool01_l0003ooooooooooooooooo0?ZJ
ooooo`;o0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool01Ooo
ool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[ooooo
o`00oooooooo0?ZJ00Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`08
o`3jV_ooooooooooo`00oooooooo003oooooool0nYX8ooooo`06o`3jV_l00?ooooooooooool00?oo
0?ZJ0oooool00ol0nY[oooooooooo`09ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool01Ol0
nY[ooooooooooooooooo0?ZJ00?ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`03o`3jV_oo
oooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ1_ooool00ol0nY[oooooooooo`02ooooo`05o`3j
V_ooooooooooooooool000005Oooool00ol0003oooooooooo`03ooooo`03o`00ool0nY[ooooo01;o
oooo00Co0?ZJoooooooooooo0?ZJDoooool01Ol0nY[o003oooooool00?oo0?ZJ00;ooooo00?o0?ZJ
ooooooooool04_ooool00ol0nY[oooooooooo`02ooooo`05o`00oooooooo003oooooool0nYX03ooo
ool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`05ooooo`03o`00oooooooo
003o00?ooooo00Go003oooooooooooooooooo`00o`02ooooo`03o`00ool0nY[ooooo00Gooooo00Co
0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`0Dooooo`04o`3jV_ooooooooooo`00o`;o
oooo00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo
01?ooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`;o003o0oooool01Ol00?oooooooooooooo
oooo003o00;ooooo00Go003oooooooooooooooooo`00o`03ooooo`05o`00ooooooooooooooooool0
0?l01oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o003oooooooooool00_l0000Joooo
o`04o`000?ooooooooooo`0000?ooooo0_l00002ooooo`04o`3jV_oooooo0?ZJo`3jVP?ooooo00Co
0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`05ooooo`05o`3jV_ooooooooooooooool0
0?l00_ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooooooo`;o003o00Co0?ZJoooo
oooooooooooo0_l00?l00ol0nY[o003oo`00o`06o`00o`03o`3jV_oooooooooo00Cooooo00?o0?ZJ
ooooool00?l00oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00Go003o
o`3jV_l0nY[oooooo`3jVP0;o`00o`05o`3jV_ooooooooooooooool0nYX00_ooool01Ol0nY[ooooo
oooooooooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`3jVP03oooo
o`04o`00ooooooooooooo`3jVPKooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02
o`0001Gooooo0_l00004ooooo`03o`00ool0nY[ooooo00Kooooo0ol0nYX9ooooo`04o`3jV_oooooo
ooooo`3jVU?ooooo00Go0?ZJo`00oooooooo003oooooo`03o`3jVPGooooo00?o0?ZJooooooooool0
1_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;ooooo00Go003oooooool00?oo
ooooo`3jVP0?ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Gooooo
00?o003oooooool00?l00oooool01?l00?ooooooooooool00?l3ooooo`03o`00ool0nY[ooooo00Go
oooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`0Dooooo`04o`3jV_oooooooooo
o`00o`;ooooo00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oo
oooooooo01?ooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`;o003o0oooool01?l00?oooooo
ooooool00?l3ooooo`05o`00ooooooooooooooooool00?l00oooool01Ol00?oooooooooooooooooo
003o00Oooooo00Go003oo`3jV_ooooooooooo`3jVP02ooooo`05o`00ooooooooooooooooool00000
6_ooool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooooooool00?l00_ooool01Ol0
nY[ooooooooooooooooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`05o`3jV_oo
ooooooooooooool00?l00_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo
00Ko003oo`3jV_l0nY[o003oooooool0nYX9ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ool00?l01?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l00ol0
nY[o003oooooo`0:ooooo`05o`00ool0nY[oooooooooool0nYX00_ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool2o`3jVPCooooo00Co003ooooooooooooo
0?ZJ1_ooool00ol0nY[oooooooooo`02ooooo`05o`00ooooooooooooooooool000005Oooool00ol0
003oooooooooo`03ooooo`04o`00ool0nY[oooooo`3jVPGooooo00?o0?ZJooooool0nYX02Oooool0
1?l0nY[oooooooooool0nYYCooooo`08o`3jV_l00?ooooooo`00oooooooo0?ZJooooool0nYX5oooo
o`;o0?ZJ1_ooool2o`3jVPCooooo00?o0?ZJooooooooool00oooool01Ol00?ooooooo`00oooooooo
0?ZJ00oooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool01Oooool2o`00
o`Cooooo00Co003ooooooooooooo003o0oooool00ol00?oo0?ZJooooo`05ooooo`04o`3jV_oooooo
ooooo`00o`?ooooo00?o0?ZJooooooooool05?ooool01?l0nY[oooooooooool00?l2ooooo`03o`3j
V_oooooooooo00Kooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`0Cooooo`05
o`3jV_ooooooooooooooool00?l01Oooool2o`00o`?ooooo00Co003ooooooooooooo003o0oooool0
1Ol00?oooooooooooooooooo003o00?ooooo00Co003ooooooooooooo003o2?ooool01Ol00?oo0?ZJ
oooooooooooo0?ZJ00;ooooo00Go003oooooooooooooooooo`00000Jooooo`04o`000?oooooooooo
o`0000?ooooo0_l00003ooooo`03o`00oooooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ0ooo
ool00ol0nY[oooooooooo`05ooooo`05o`3jV_ooooooooooooooool00?l00_ooool00ol0nY[ooooo
ooooo`06ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX:ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooool00?l01?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01;ooooo
00Go003oo`3jV_ooooooooooo`3jVP02ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01?l0
nY[oooooooooool0nYX3ooooo`03o`00ool0nY[o0?ZJ00Cooooo0_l00?l00ooooooo0?ZJooooo`05
ooooo`05o`3jV_ooooooooooooooool00?l00oooool2o`0001Gooooo00?o0000ooooooooool00ooo
ool01?l00?ooooooo`3jV_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00Wooooo00Co0?ZJoooooooooooo
0?ZJDoooool01?l0nY[o003oooooool00?l4ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX6oooo
o`;o0?ZJ1?ooool00ol0nY[oooooooooo`03ooooo`05o`00oooooooo003oooooool0nYX03oooool0
0ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`05ooooo`;o003o1?ooool01?l0
0?ooooooooooool00?l3ooooo`03o`00oooooooo0?ZJ00Gooooo00Co0?ZJoooooooooooo003o0ooo
ool00ol0nY[oooooooooo`0Dooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooooooool0
1_ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJoooooooo
ool00_ooool00ol00?ooooooooooo`03ooooo`;o003o0oooool01?l00?ooooooooooool00?l3oooo
o`05o`00ooooooooooooooooool00?l00oooool01?l00?ooooooooooool00?l8ooooo`04o`00ool0
nY[oooooo`3jVP?ooooo00?o003oooooooooool00_l0000Kooooo`;o00001?ooool00ol0003ooooo
ooooo`02ooooo`03o`00oooooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[o
ooooooooo`05ooooo`05o`3jV_ooooooooooooooool00?l00_ooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o003oooooo`04oooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool04oooool00ol00?oo0?ZJo`3jVP03oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool01?l0nY[oooooooooool0nYX3ooooo`03o`00oooo
oooo0?ZJ00Cooooo00Co003oooooool00?oo0?ZJ1_ooool01Ol0nY[ooooooooooooooooo003o00Co
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`05o`00oooooooo0?ZJoooo
ool0nYX01?ooool00ol0nY[oooooo`3jVP09ooooo`04o`3jV_ooooooooooo`3jVU?ooooo00Co0?ZJ
o`00oooooooo003o1?ooool01ol0nY[ooooooooooooooooo0?ZJooooool0nYX01_ooool00ol0nY[o
ooooo`3jVP03ooooo`03o`3jV_oooooooooo00?ooooo00Go003oooooool00?ooooooo`3jVP0?oooo
o`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Kooooo00?o003ooooooooo
ool00_ooool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooo0?ZJ00Cooooo00Go0?ZJoooo
ooooooooooooo`00o`03ooooo`03o`3jV_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0_oo
ool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00?ooooo0_l00?l4ooooo`03o`00
oooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`03ooooo`04o`00ooooooooooooo`00
o`Sooooo00Co003oo`3jV_oooooo0?ZJ0oooool01Ol00?oooooooooooooooooo0000027ooooo00?o
0000ooooooooool00_ooool00ol00?ooooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP?ooooo
00?o0?ZJooooooooool01Oooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJo`00oooo
ool01?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01Cooooo00?o003oo`3jV_l0
nYX00oooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ0oooool0
0ol00?ooooooo`3jVP04ooooo`04o`00oooooooo003oo`3jVPKooooo00Go0?ZJoooooooooooooooo
o`00o`04ooooo`03o`000?oooooooooo01?ooooo0_l00004ooooo`05o`00ooooooooooooooooool0
nYX01?ooool01?l0nY[oooooooooool0nYX8ooooo`04o`3jV_ooooooooooo`3jVU?ooooo00Co0?ZJ
o`00oooooooo003o1?ooool01ol0nY[ooooooooooooooooo0?ZJooooool0nYX01_ooool00ol0nY[o
ooooo`3jVP03ooooo`03o`3jV_oooooooooo00?ooooo00Go003oooooool00?ooooooo`3jVP0?oooo
o`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00Kooooo00?o003ooooooooo
ool00_ooool01?l00?ooooooooooool00?l4ooooo`03o`00ool0nY[ooooo00?ooooo00Go0?ZJoooo
ooooooooooooo`00o`03ooooo`03o`3jV_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0_oo
ool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00?ooooo0_l00?l4ooooo`03o`00
oooooooo003o00Cooooo00Co003ooooooooooooo003o0oooool01?l00?ooooooooooool00?l8oooo
o`04o`00ool0nY[oooooo`3jVP?ooooo00Go003oooooooooooooooooo`00000Qooooo`;o00000ooo
ool00ol00?ooooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o003oo`3jV_ooool0
1Oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooo0?ZJ00Oooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oooooo00Cooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ00?ooooo00Co0?ZJoooooooooooo
0?ZJ1?ooool01?l0nY[oooooooooool0nYX3ooooo`03o`00oooooooo0?ZJ00Cooooo00Co003ooooo
ool00?oo0?ZJ1_ooool01Ol0nY[ooooooooooooooooo003o00?ooooo0_l00003ooooo`;o00001?oo
ool00ol0003oooooooooo`02ooooo`?o00001?ooool00ol0003oooooooooo`03ooooo`05o`00oooo
ooooooooooooool0nYX01?ooool01?l0nY[oooooooooool0nYX8ooooo`04o`3jV_ooooooooooo`3j
VU?ooooo00Co0?ZJo`00oooooooo003o1?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o
0?ZJooooooooool00_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo00?ooooo
00Go003oooooool00?ooooooo`3jVP0?ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`00
0?oooooooooo00Kooooo00?o003oooooooooool00_ooool01?l00?ooooooooooool00?l4ooooo`03
o`00ool0nY[ooooo00?ooooo00Go0?ZJooooooooooooooooo`00o`03ooooo`03o`3jV_oooooooooo
01Cooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_oooooo
ooooo`00o`;ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooo
oooooooo00?ooooo0_l00?l4ooooo`03o`00oooooooo003o00Cooooo00Co003ooooooooooooo003o
0oooool01?l00?ooooooooooool00?l8ooooo`04o`00ool0nY[oooooo`3jVP;ooooo00Co003ooooo
oooooooooooo0_l0000Qooooo`03o`000?oooooooooo00;ooooo00?o003oooooooooool00oooool0
1?l0nY[oooooooooool0nYX3ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_ooool00ooo
ool00ol00?ooooooo`3jVP07ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool05?oo
ool00ol00?ooooooo`3jVP03ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJoooooooooooo
0?ZJ0oooool00ol00?ooooooooooo`04ooooo`04o`00oooooooo003oo`3jVPKooooo00Co0?ZJoooo
oooooooo003o1Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool0
0_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooo
oooo0?ZJDoooool01?l0nY[o003oooooool00?l4ooooo`05o`3jV_ooooooooooooooool0nYX00_oo
ool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJooooooooool0
0oooool00ol00?ooooooo`00o`02ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX8ooooo`03o`00
0?oooooooooo017ooooo000Hooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000_oo
ool5o`0000?ooooo00?o0000ooooooooool01_ooool00ol00?ooooooooooo`02ooooo`04o`00oooo
ooooooooo`00o`Cooooo00?o003oo`3jV_ooool00oooool01?l0nY[oooooooooool00?l4ooooo`03
o`3jV_oooooooooo01Cooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooo003o00Cooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`02oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooo`00o`04oooo
o`04o`00ooooooooooooo`00o`?ooooo00Co003ooooooooooooo003o2?ooool01?l00?oo0?ZJo`3j
V_l0nYX2ooooo`03o`00oooooooooooo00;ooooo00?o0000ooooooooool07oooool2o`0000Cooooo
00?o003oooooooooool00_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`00ool0nY[ooooo00Co
oooo00?o003oo`3jV_ooool00oooool00ol00?ooooooo`3jVP07ooooo`03o`3jV_oooooooooo01?o
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool05?ooool00ol00?ooooooooooo`03ooooo`04o`3jV_ooooooooooo`3j
VPCooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol00?ooooooooooo`04ooooo`04o`00oooooooo
003oo`3jVPKooooo00Co0?ZJoooooooooooo003o1?ooool2o`0000;ooooo00Co0000oooooooooooo
00002oooool01Ol0003ooooooooooooooooo000000Gooooo00?o003oooooooooool00_ooool01?l0
nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooo0?ZJDooo
ool01?l0nY[o003oooooool00?l4ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[o
ooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJooooooooool00oooool01_l0
0?ooooooooooool00?ooooooo`3jVPCooooo00?o0?ZJooooool0nYX01oooool00ol0003ooooooooo
o`0Aooooo`005oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000oooool00ol0003oooooooooo`06ooooo`03o`00oooooooooooo00;o
oooo00Co003ooooooooooooo003o1?ooool00ol00?oo0?ZJooooo`03ooooo`04o`3jV_oooooooooo
o`00o`Cooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooo`00o`04ooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooool00?l01?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooo
oooo00;ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo
003o00Cooooo00Co003ooooooooooooo003o0oooool01?l00?ooooooooooool00?l9ooooo`03o`00
oooooooo0?ZJ00;ooooo00?o003oooooooooool00_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo00?ooooo00?o003oooooooooool00_ooool01?l0nY[oooooooooool0nYX3ooooo`03
o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol00?ooooooo`3jVP07ooooo`03
o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool05?ooool00ol00?ooooooooooo`03ooooo`04
o`00ool0nY[oooooo`3jVP?ooooo00Go003oo`3jV_ooooooooooo`3jVP03ooooo`03o`00oooooooo
oooo00Cooooo00Co003oooooool00?oo0?ZJ1Oooool01Ol0nY[ooooooooooooooooo003o00Gooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`07ooooo`;o00001?ooool2o`0000Co
oooo00?o003oooooooooool00_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo
00Kooooo00Co0?ZJoooooooooooo0?ZJDoooool01?l0nY[o003oooooool00?l4ooooo`04o`3jV_oo
ooooooooo`3jVP?ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;o
oooo00?o0?ZJooooooooool00oooool01_l00?ooooooooooool00?ooooooo`3jVPCooooo00?o0?ZJ
ooooool0nYX01_ooool2o`0001?ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`;o00001oooool00ol00?oooooooooo
o`03ooooo`03o`00oooooooo003o00Cooooo00?o003oo`3jV_ooool00oooool01?l0nY[ooooooooo
ool00?l4ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooool00?l01?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooo003o00Cooooo00?o0?ZJooooooooool04Oooool00ol0nY[ooooo
ooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool00ol00?oooooo
o`00o`04ooooo`04o`00ooooooooooooo`00o`?ooooo00Co003ooooooooooooo003o2Oooool00ol0
0?ooooooooooo`02ooooo`04o`00ooooooooooooooooo`;o00008Oooool00ol0003oooooooooo`03
ooooo`03o`00oooooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol00?oo0?ZJoooo
o`04ooooo`03o`00ool0nY[ooooo00?ooooo00?o003oooooool0nYX01oooool00ol0nY[ooooooooo
o`0Cooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01Cooooo00?o003oooooooooool00oooool01?l00?oo0?ZJoooo
ool0nYX3ooooo`;o003o00?o0?ZJooooool0nYX00oooool00ol00?ooooooooooo`04ooooo`05o`00
oooooooo003oooooool0nYX01?ooool01?l0nY[oooooooooool00?l6ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000Gooooo00?o
003oooooooooool00_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo00Kooooo
00Co0?ZJoooooooooooo0?ZJDoooool01Ol0nY[o003ooooooooooooo003o00Cooooo00?o0?ZJoooo
ool0nYX00oooool00ol0nY[oooooooooo`02ooooo`07o`3jV_ooooooooooooooool0nY[oooooo`3j
VP05ooooo`07o`00ooooooooooooooooool00?ooooooo`3jVP04ooooo`03o`3jV_oooooo0?ZJ00Oo
oooo00?o0000ooooooooool04Oooool001Oooooo00Co0000oooooooooooo00002?ooool01?l0003o
ooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01_ooool00ol0
0?ooooooooooo`03ooooo`03o`00oooooooo003o00Cooooo00?o003oo`3jV_ooool00oooool01?l0
nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooool00?l01?ooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo003o00Cooooo00?o0?ZJooooooooool04Oooool0
0ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool0
0ol00?ooooooo`00o`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooool00?l02Ooo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o0000ooooooooool01ooo
ool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol00004ooooo`;o00001?oo
ool00ol00?ooooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o003oo`3jV_ooool0
1?ooool00ol0nY[oooooooooo`03ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ooooool01_ooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo01Cooooo00?o003oooooooooool00oooool01?l00?oo0?ZJ
ooooool0nYX3ooooo`;o003o00?o0?ZJooooool0nYX00oooool2o`00o`Gooooo00Go003oooooool0
0?ooooooo`3jVP04ooooo`04o`3jV_ooooooooooo`00o`Gooooo0_l00002ooooo`04o`000?oooooo
ooooo`0000Oooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00Cooooo
00Go003oooooooooooooooooo`3jVP02ooooo`05o`3jV_ooooooooooooooool0nYX01oooool01Ol0
nY[o003ooooooooooooo0?ZJ05?ooooo00Go0?ZJo`00ooooooooooooo`00o`04ooooo`03o`3jV_oo
oooo0?ZJ00?ooooo00?o0?ZJooooooooool00_ooool01ol0nY[ooooooooooooooooo0?ZJooooool0
nYX01Oooool01ol00?oooooooooooooooooo003oooooool0nYX00oooool01?l0nY[oooooooooool0
nYX7ooooo`03o`000?oooooooooo017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Ko
0000oooooooooooo0000ooooool00003ooooo`05o`000?ooooooooooooooool000002?ooool00ol0
0?ooooooooooo`03ooooo`03o`00oooooooo003o00Cooooo00?o003oo`3jV_ooool00oooool01?l0
nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooool00?l01?ooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo003o00Cooooo00?o0?ZJooooooooool04Oooool0
0ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool0
0ol00?ooooooo`00o`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooool00?l02Ooo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o0000ooooooooool01_oo
ool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00Co0?ZJoooooooo
oooo0?ZJ0oooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool00oooool00ol0
nY[o003oooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05_ooool00ol0
0?ooooooooooo`02ooooo`04o`00ool0nY[oooooo`3jVP?ooooo0_l00?l00ol0nY[oooooo`3jVP03
ooooo`;o003o1Oooool01Ol00?ooooooooooool00?oo0?ZJ00Cooooo00Co0?ZJoooooooooooo003o
1_ooool01?l0003oooooooooooooool2o`0000Wooooo0ol00004ooooo`03o`000?oooooooooo00Co
oooo00Go003oooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool01?ooool01Ol0nY[o003ooooooooooooo0?ZJ05?ooooo00Go0?ZJo`00ooooooooooooo`00
o`04ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[ooooo
o`3jVP05ooooo`07o`00ooooooooooooooooool00?ooooooo`3jVP03ooooo`04o`3jV_oooooooooo
o`3jVPOooooo00?o0000ooooooooool04Oooool001Oooooo00Co0000oooooooooooo00002?ooool0
1_l0003oooooooooool0003oooooo`0000?ooooo00Go0000ooooooooooooooooo`000008ooooo`03
o`00oooooooooooo00?ooooo00?o003oooooool00?l01?ooool00ol00?oo0?ZJooooo`03ooooo`04
o`3jV_ooooooooooo`00o`Gooooo00?o0?ZJooooooooool04_ooool01?l0nY[oooooooooool00?l4
ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJoooooooooooo003o1?ooool00ol0nY[ooooooooo
o`0Aooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool02Oooool00ol00?ooooooo`00
o`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooool00?l02Oooool00ol00?oooooo
ooooo`02ooooo`04o`00ooooooooooooooooo`;o00002?ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00?o003o
ooooooooool00_ooool01?l00?oo0?ZJooooool0nYX2ooooo`03o`00oooooooo0?ZJ00Gooooo00?o
0?ZJooooooooool01?ooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01Cooooo00?o
0?ZJooooooooool00oooool00ol0nY[o003oooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool05_ooool00ol00?ooooooooooo`02ooooo`04o`00ool0nY[oooooo`3jVP?ooooo
0_l00?l2o`3jVPCooooo0_l00?l4ooooo`06o`00ooooooooooooooooool00?oo0?ZJ1?ooool01?l0
nY[oooooooooool00?l5ooooo`;o00005Oooool2o`0000Gooooo00Go003oooooooooooooooooo`3j
VP02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool01Ol0nY[o003ooooo
oooooooo0?ZJ05?ooooo00Go0?ZJo`00ooooooooooooo`00o`04ooooo`03o`3jV_oooooo0?ZJ00Co
oooo00Co0?ZJoooooooooooo0?ZJ1Oooool2o`3jVPGooooo00Oo003oooooooooooooooooo`00oooo
oooo0?ZJ00?ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`03o`000?oooooooooo017ooooo
000Hooooo`;o00002_ooool2o`0000?ooooo0ol00004ooooo`03o`000?oooooooooo00cooooo00?o
003oooooool00?l01?ooool00ol00?oo0?ZJooooo`03ooooo`04o`3jV_ooooooooooo`00o`Gooooo
00?o0?ZJooooooooool04_ooool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo00Co
oooo00Co0?ZJoooooooooooo003o1?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo
00;ooooo00?o003oooooooooool02Oooool00ol00?ooooooo`00o`04ooooo`04o`00oooooooooooo
o`00o`Cooooo00?o003oooooool00?l02Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo
oooo00;ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00008ooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
oooooooooooo00;ooooo00?o003oo`3jV_l0nYX00oooool00ol00?ooooooo`3jVP05ooooo`03o`3j
V_oooooooooo00Cooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Dooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJo`00ooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo01Kooooo00?o003oooooooooool00_ooool01?l00?oo0?ZJooooool0nYX3ooooo`;o
003o0_l0nYX3ooooo`03o`00oooooooo003o00Cooooo00Ko003oooooooooooooooooo`00ool0nYX4
ooooo`04o`3jV_ooooooooooo`00o`Kooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`04ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooool0nYX01?ooool00ol0nY[ooooooooo
o`04ooooo`05o`3jV_l00?ooooooooooool0nYX0D_ooool00ol0nY[oooooo`00o`02ooooo`03o`00
oooooooooooo00;ooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oooooooooool0nYX5ooooo`;o
0?ZJ1Oooool01ol00?oooooooooooooooooo003oooooool0nYX00oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Kooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool03?ooool0
0ol00?ooooooo`00o`04ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJoooooooooooo003o1Ooo
ool00ol0nY[oooooooooo`0Booooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJooooooooool0
1?ooool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJoooooooo
ool00_ooool00ol00?ooooooooooo`0:ooooo`;o003o1?ooool01?l00?ooooooooooool00?l4oooo
o`03o`00oooooooo003o00Wooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02oooo
o`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool0
0003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol00?oooooooooo
o`02ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oooooool0nYX01Oooool00ol0nY[ooooooooo
o`04ooooo`03o`00oooooooo0?ZJ00Gooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`0Fooooo`03o`00oooooooooooo00;ooooo00?o003oo`3jV_l0nYX01?ooool2o`00o`;o0?ZJ0ooo
ool00ol00?ooooooo`00o`04ooooo`06o`00ooooooooooooooooool00?oo0?ZJ1?ooool01?l0nY[o
ooooooooool00?l6ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01?ooool00ol0
0?ooooooooooo`02ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`04ooooo`05o`3jV_l00?oooooo
ooooool0nYX0D_ooool00ol0nY[oooooo`00o`02ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJ
ooooooooool00oooool01?l0nY[oooooooooool0nYX6ooooo`03o`3jV_oooooooooo00?ooooo00?o
003oooooooooool00_ooool2o`00o`03o`3jV_oooooo0?ZJ00Cooooo00?o0?ZJooooooooool01?oo
ool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0<ooooo`03o`00oooooooo
003o00Gooooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooo`00ool00?l5ooooo`03o`3jV_oo
oooooooo01;ooooo00Co0?ZJoooooooooooo003o1?ooool00ol0nY[oooooooooo`04ooooo`04o`3j
V_ooooooooooo`00o`Cooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`02ooooo`03
o`00oooooooooooo00[ooooo0_l00?l5ooooo`03o`00oooooooo003o00Cooooo00?o003oooooool0
0?l02Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o0000oooooooo
ool01_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo0_l00005
ooooo`;o00001?ooool00ol00?ooooooooooo`02ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003o
ooooool0nYX01Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool05?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`0Fooooo`03o`00oooooooooooo00;ooooo0_l00?l0
0ol0nY[oooooooooo`02ooooo`;o003o0_l0nYX3ooooo`03o`00oooooooo003o00Cooooo00Ko003o
ooooooooooooooooo`00ool0nYX4ooooo`04o`3jV_ooooooooooo`00o`Gooooo0_l0000Eooooo`03
o`000?oooooooooo00Cooooo00?o003oooooooooool00_ooool2o`3jVPGooooo00?o0?ZJoooooooo
ool01?ooool01_l0nY[o003ooooooooooooo003oo`3jVU7ooooo00?o0?ZJooooool00?l00_ooool0
0ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ3?oo
ool00ol00?ooooooooooo`02ooooo`05o`00oooooooo0?ZJooooool0nYX01?ooool00ol0nY[ooooo
ooooo`04ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo00cooooo00?o
003oooooool00?l01Oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`Gooooo
00?o0?ZJooooooooool04_ooool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo00Co
oooo00Co0?ZJoooooooooooo003o1?ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo
00?ooooo00?o003oooooooooool02_ooool2o`00o`Gooooo00?o003oooooool00?l01?ooool00ol0
0?ooooooo`00o`09ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooooooo0_l00009
ooooo`;o00002_ooool2o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04
ooooo`05o`00ooooooooooooooooool00?l00_l0nYX3ooooo`03o`00oooooooo0?ZJ00Gooooo00?o
0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01Cooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool05_ooool00ol00?ooooooooooo`02ooooo`;o003o00?o0?ZJooooooooool00_oo
ool2o`00o`03o`3jV_oooooooooo00;ooooo00?o003oooooool00?l01?ooool01_l00?oooooooooo
oooooooo003oo`3jVPCooooo00?o0?ZJooooool00?l01oooool00ol0003oooooooooo`0Cooooo`;o
00001Oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`04ooooo`06
o`3jV_l00?ooooooooooool00?oo0?ZJDOooool00ol0nY[oooooo`00o`02ooooo`03o`00oooooooo
oooo00?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP0<ooooo`03o`00oooooooo
oooo00;ooooo00Go003oooooool0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00Cooooo00?o
0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool03?ooool00ol00?ooooooo`00o`05
ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJo`00ool00?oo003o1Oooool00ol0nY[ooooooooo
o`0Booooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJooooooooool01?ooool01?l0nY[ooooo
ooooool00?l4ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool00oooool00ol00?oo
ooooooooo`0:ooooo`;o003o1Oooool00ol00?ooooooo`00o`04ooooo`03o`00oooooooo003o00Wo
oooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo01oo
oooo0_l00005ooooo`05o`00ooooooooooooooooool00?l00_l0nYX3ooooo`03o`00oooooooo0?ZJ
00Cooooo00?o003oo`3jV_ooool01oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
01Cooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool05_ooool00ol00?ooooooooooo`02ooooo`;o003o00?o0?ZJoooo
ooooool00_ooool2o`00o`03o`3jV_oooooooooo00;ooooo00?o003oooooool00?l01?ooool01ol0
0?oooooooooooooooooo003oooooool0nYX00oooool00ol0nY[oooooo`00o`06ooooo`;o00005Ooo
ool00ol0003oooooooooo`04ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`04ooooo`06o`3jV_l00?ooooooooooool00?oo0?ZJDOooool00ol0nY[o
ooooo`00o`02ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJooooool0nYX03?ooool00ol00?oo
ooooooooo`04ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooooooool01?ooool00ol0003o
ooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0<ooooo`03o`00oooooooo003o00Gooooo
00?o003oo`3jV_ooool00_ooool01?l0nY[o003oooooool00?l5ooooo`03o`3jV_oooooooooo01;o
oooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_oooooooooo
o`00o`Gooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooo
oooo00[ooooo0_l00?l5ooooo`;o003o1Oooool00ol00?ooooooo`00o`09ooooo`03o`00oooooooo
oooo00;ooooo00?o003oooooooooool00_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo00Cooooo00Ko003oooooooooooooooooo`00ool0nYX4ooooo`04o`00oooooooo003oo`3jVP?o
oooo00?o003oo`3jV_ooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Go
oooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool05oooool00ol00?ooooooooooo`02ooooo`;o003o00Go0?ZJoooooooo
ooooooooo`00o`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooool00?l01?ooool01ol0
0?oooooooooooooooooo003oooooool0nYX00oooool00ol0nY[oooooo`00o`07ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool01?ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool01?ooool01_l0nY[o003ooooooooooooo003oo`3jVU7o
oooo00?o0?ZJooooool00?l00oooool00ol00?ooooooooooo`09ooooo`;o0?ZJ3Oooool00ol00?oo
ooooooooo`04ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool01?ooool00ol0003o
ooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0<ooooo`03o`00oooooooo003o00Gooooo
00Ko003oo`3jV_ooooooooooo`3jV_l00?l2ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJoooo
ooooool04_ooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJ
oooooooooooo003o1Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00?ooooo00?o
003oooooooooool02_ooool2o`00o`Gooooo0_l00?l5ooooo`03o`00oooooooo003o00Wooooo00?o
003oooooooooool00_ooool01?l00?ooooooooooooooool2o`00027ooooo00?o0000ooooooooool0
1?ooool01_l00?oooooooooooooooooo003oo`3jVPCooooo00Co003oooooool00?oo0?ZJ0oooool0
0ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool05_ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`0Gooooo`03o`00oooooooooooo00;ooooo0_l00?l4ooooo`04o`00oooooooo
ooooo`00o`Cooooo00?o003oooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03o`00ool0
nY[ooooo00;ooooo00?o0?ZJooooool00?l01oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo00Cooooo00?o003oooooooooool02Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooo003o00;ooooo00?o003oo`3jV_ooool0D?ooool00ol0nY[oooooo`00o`03ooooo`03o`00oooo
oooooooo00Wooooo0_l0nYX=ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01?oo
ool00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooo
oooo00cooooo00?o003oooooool00?l01Oooool01_l00?oo0?ZJoooooooooooo0?ZJo`00o`Sooooo
00?o0?ZJooooooooool04_ooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooooooo00?o
oooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo
00?ooooo00?o003oooooooooool02_ooool2o`00o`Gooooo0_l00?l5ooooo`03o`00oooooooo003o
00Wooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo
01oooooo0_l00005ooooo`06o`00ooooooooooooo`00oooooooo003o1?ooool01?l00?ooooooo`00
ool0nYX3ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo01Sooooo00Co003ooooooooooooooooo0_l00?l4ooooo`04
o`00ooooooooooooo`00o`Cooooo00?o003oooooool00?l01?ooool00ol00?ooooooooooo`02oooo
o`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooool00?l01_ooool2o`0001Gooooo0_l00006oooo
o`03o`00oooooooooooo00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`00o`02oooo
o`03o`00ool0nY[ooooo053ooooo00?o0?ZJooooool00?l00oooool00ol00?ooooooooooo`09oooo
o`;o0?ZJ3Oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJoooo
ooooool01?ooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0<ooooo`03
o`00oooooooo003o00Gooooo00Ko003oo`3jV_ooooooooooo`3jV_l00?l8ooooo`03o`3jV_oooooo
oooo01;ooooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_oo
ooooooooo`00o`Gooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`03ooooo`03o`00
oooooooooooo00[ooooo0_l00?l5ooooo`;o003o1Oooool00ol00?ooooooo`00o`0:ooooo`05o`00
ooooooooooooooooool00?l01?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Co
oooo00Ko003ooooooooooooo003oooooool00?l4ooooo`04o`00oooooooo003oo`3jVP?ooooo00?o
003oo`3jV_ooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool06?ooool01_l00?ooooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooo
oooo003o1?ooool00ol00?ooooooo`00o`04ooooo`03o`00oooooooooooo00?ooooo00Oo0?ZJoooo
ooooooooooooo`3jV_oooooo003o00Oooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`05ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`00
o`02ooooo`03o`00ool0nY[ooooo053ooooo00?o0?ZJooooool00?l00oooool00ol00?oooooooooo
o`0:ooooo`03o`3jV_oooooooooo00_ooooo00?o003oooooooooool01Oooool3o`00o`Cooooo00?o
0?ZJooooooooool00oooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0=
ooooo`;o003o1Oooool01_l00?oo0?ZJoooooooooooo0?ZJo`00o`Sooooo00?o0?ZJooooooooool0
4_ooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooo
oooo003o1Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00?ooooo00?o003ooooo
ooooool02_ooool2o`00o`Gooooo0_l00?l5ooooo`03o`00oooooooo003o00[ooooo00Go003ooooo
ooooooooooooo`00o`03ooooo`;o00008Oooool2o`0000Gooooo00Ko003ooooooooooooo003ooooo
ool00?l4ooooo`04o`00oooooooo003oo`3jVP?ooooo00?o003oo`3jV_ooool01oooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06?ooool01_l00?oo
ooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooo`00
o`04ooooo`03o`00oooooooooooo00?ooooo00Oo0?ZJooooooooooooooooo`3jV_oooooo003o00Ko
oooo0_l0000Eooooo`03o`000?oooooooooo00Gooooo00?o003oooooooooool02Oooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooo003o00;ooooo00?o003oo`3jV_ooool0D?ooool00ol0nY[o
ooooo`00o`03ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJooooooooool02oooool00ol00?oo
ooooooooo`08ooooo`05o`00ooooooooooooooooool0nYX01Oooool00ol0003oooooooooo`0Aoooo
o`004_ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000;ooooo1Ol00002ooooo`?o
00001?ooool00ol0003oooooooooo`0=ooooo`;o003o1Oooool01_l00?oo0?ZJoooooooooooo0?ZJ
o`00o`Sooooo00?o0?ZJooooooooool04_ooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oo
oooooooo00?ooooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooooooo`0>ooooo`03o`3j
V_oooooooooo00Cooooo00?o003oooooooooool02_ooool2o`00o`Gooooo0_l00?l6ooooo`;o003o
2_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o0000ooooooooool01oooool2o`0000Co
oooo00?o0000ooooooooool00oooool2o`0000;ooooo1Ol00003ooooo`03o`000?oooooooooo00Co
oooo00Ko003ooooooooooooo003oooooool00?l4ooooo`04o`00oooooooo003oo`3jVP?ooooo00?o
003oo`3jV_ooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool06?ooool01_l00?ooooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooo
oooo003o1?ooool00ol00?ooooooo`00o`04ooooo`03o`00oooooooooooo00?ooooo00Oo0?ZJoooo
ooooooooooooo`3jV_oooooo003o00Oooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`05ooooo`03o`00oooooooooooo00Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`00
o`02ooooo`03o`00ool0nY[ooooo02Wooooo0_l0nYX00ooooooo0?ZJo`3jVP0Rooooo`03o`3jV_oo
oooo003o00?ooooo00?o003oooooooooool06?ooool00ol00?ooooooooooo`08ooooo`05o`00oooo
ooooooooooooool0nYX01Oooool00ol0003oooooooooo`0Aooooo`004Oooool01?l0003ooooooooo
ool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003
ooooo`05o`000?ooooooooooooooool000003oooool2o`00o`Gooooo00Ko003oo`3jV_oooooooooo
o`3jV_l00?l8ooooo`03o`3jV_oooooooooo01;ooooo00Co0?ZJoooooooooooo003o1Oooool00ol0
nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`00o`Gooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo00[ooooo0_l00?l5ooooo`;o003o1_ooool2
o`00o`[ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`000?oooooooooo00Kooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00?ooooo00?o0000ooooooooool01?ooool01_l00?ooooooooooool00?ooooooo`00o`Cooooo00Co
003oooooool00?oo0?ZJ0oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool05_ooool01_l0nY[ooooooooooooooooo0?ZJo`00o`Sooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`0Hooooo`06o`00ooooooooooooo`00oooooooo003o1?oo
ool01?l00?ooooooooooool00?l4ooooo`03o`00oooooooo003o00Cooooo00?o003oooooooooool0
0oooool01ol0nY[ooooooooooooooooo0?ZJooooool00?l01oooool00ol0003oooooooooo`0Coooo
o`;o00001_ooool00ol00?ooooooooooo`09ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool0
1_l00?ooooooooooool00?ooooooo`3jVRSooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[o
ooooooooo`0Nooooo`03o`3jV_oooooo003o00Gooooo00?o003oooooooooool05oooool00ol00?oo
ooooooooo`09ooooo`04o`00ooooooooooooo`3jVPGooooo00?o0000ooooooooool04Oooool0017o
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooo
oooo00Gooooo00Co0000oooooooooooooooo0_l0000>ooooo`;o003o1Oooool01_l00?oo0?ZJoooo
oooooooo0?ZJo`00o`Wooooo00?o0?ZJooooooooool04Oooool01?l0nY[oooooooooool00?l5oooo
o`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooooooo`0>
ooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool02_ooool2o`00o`Gooooo0_l00?l6
ooooo`;o003o2_ooool01Ol00?oooooooooooooooooo003o00?ooooo0_l00008ooooo`04o`000?oo
ooooooooo`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`03ooooo`;o
00001Oooool01_l00?ooooooooooool00?ooooooo`00o`?ooooo00Go003oooooooooooooooooo`3j
VP03ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Fooooo`05o`3jV_ooooooooooooooool0nYX02Oooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo01Sooooo00Ko003ooooooooooooo003oooooool00?l4ooooo`04o`00oooooooooooo
o`00o`Cooooo00Co003ooooooooooooo003o0oooool00ol00?ooooooooooo`03ooooo`06o`3jV_oo
ooooooooo`3jV_oooooo003o1oooool2o`0000?ooooo0_l00004ooooo`03o`000?oooooooooo00?o
oooo0ol00003ooooo`03o`000?oooooooooo00Gooooo00?o003oooooooooool01Oooool2o`00o`;o
oooo00So0?ZJoooooooooooo0?ZJooooool00?ooooooo`00o`;ooooo00Co003ooooooooooooo0?ZJ
1oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo017ooooo0ol0nYX2ooooo`03o`00
oooooooooooo00Cooooo1?l00?l3ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool0
1Oooool00ol00?ooooooo`00o`0;ooooo`04o`00ooooooooooooo`3jVPGooooo00?o0000oooooooo
ool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00004oooo
o`03o`000?oooooooooo00Cooooo00Go0000ooooooooooooooooo`00000?ooooo`;o003o1Oooool0
1Ol00?oo0?ZJoooooooooooo0?ZJ00[ooooo00?o0?ZJooooooooool04Oooool01?l0nY[ooooooooo
ool00?l5ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`0;ooooo`03
o`00oooooooooooo00?ooooo0_l00?l6ooooo`;o003o2_ooool01Ol00?oooooooooooooooooo003o
00Cooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`06o`00oooo
ooooooooo`00oooooooo003o0oooool01Ol00?oooooooooooooooooo0?ZJ00?ooooo00?o003oo`3j
V_ooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00Go0?ZJoooo
ooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06?ooool0
1_l00?ooooooooooool00?ooooooo`00o`Cooooo00Co003ooooooooooooo003o0oooool01Ol00?oo
oooooooooooooooo003o00?ooooo00?o003oooooooooool00oooool01_l0nY[oooooooooool0nY[o
ooooo`00o`Sooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool01_ooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooo003o00;ooooo0ol0nYX2ooooo`03o`00oooooooo003o00?ooooo00?o003oooooool0nYX0
1_ooool2o`3jVQGooooo00?o0?ZJooooooooool01_ooool00ol0nY[o003oooooo`05ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`02ooooo`03o`00
oooooooooooo00Oooooo00?o003oooooooooool00_l00?l7ooooo`03o`00oooooooooooo00Gooooo
00?o003oooooool00?l02oooool01?l00?ooooooooooool0nYX5ooooo`03o`000?oooooooooo017o
oooo000Aooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00003
ooooo`03o`000?oooooo000000?o00001?ooool00ol0003oooooooooo`0=ooooo`;o003o1_ooool0
1?l0nY[oooooooooool0nYX:ooooo`03o`3jV_oooooooooo013ooooo00Go0?ZJoooooooooooooooo
o`00o`05ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0<ooooo`03
o`00oooooooooooo00Cooooo00?o003oooooooooool01?ooool2o`00o`[ooooo00Go003ooooooooo
ooooooooo`00o`04ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00002?ooool0
1_l0003oooooooooool0003oooooo`0000?ooooo00Go0000ooooooooooooooooo`000007ooooo`05
o`00oooooooo003oooooool00?l00oooool01Ol00?oooooooooooooooooo0?ZJ00?ooooo00?o003o
o`3jV_ooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo00Go0?ZJ
ooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06?oo
ool01?l00?ooooooooooool00?l2ooooo`05o`00ooooooooooooooooool00?l00_ooool01Ol00?oo
oooooooooooooooo003o00?ooooo00Go003oooooooooooooooooo`00o`05ooooo`06o`3jV_oooooo
ooooo`3jV_oooooo003o2?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo1Ol00003ooooo`03o`000?oooooooooo00Kooooo1?l00?l2ooooo`06o`00ooooooooooooo`00
oooooooo0?ZJ0oooool01?l00?ooooooo`00ool00?l3ooooo`04o`00ooooooooooooo`3jVPCooooo
00Co0?ZJoooooooooooo0?ZJ4oooool00ol0nY[oooooo`3jVP07ooooo`03o`3jV_oooooo003o00Go
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooo`3jVP0Aooooo`03o`3jV_oooooooooo00?o
oooo00?o003oooooooooool01oooool01_l00?ooooooooooool00?ooooooo`00o`Gooooo00?o003o
ooooool00?l01Oooool01?l00?ooooooo`00ool00?l<ooooo`03o`00oooooooo0?ZJ00Gooooo00?o
0000ooooooooool04Oooool0017ooooo00Co0000oooooooooooo00002?ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooool000001oooool00ol0003oooooooooo`0=ooooo`;o
003o1_ooool01?l0nY[oooooooooool0nYX:ooooo`03o`3jV_oooooooooo013ooooo00Go0?ZJoooo
ooooooooooooo`00o`05ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`00
o`05ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool00oooool00ol00?oooooooooo
o`0<ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01?ooool2o`00o`_ooooo00Co
003ooooooooooooo003o0oooool2o`0000Sooooo00Co0000oooooooooooo00002?ooool01_l0003o
ooooooooool0003oooooo`0000?ooooo00Co0000oooooooooooooooo0_l00006ooooo`05o`00oooo
oooo003oooooool00?l00oooool01Ol00?oooooooooooooooooo0?ZJ00?ooooo00?o0?ZJoooooooo
ool01oooool01Ol0nY[ooooooooooooooooo0?ZJ01Wooooo00Go0?ZJooooooooooooooooo`3jVP0:
ooooo`05o`3jV_ooooooooooooooool0nYX06_ooool01?l00?ooooooooooool00?l2ooooo`05o`00
ooooooooooooooooool00?l00_ooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003ooooo
ooooooooooooo`00o`05ooooo`06o`3jV_ooooooooooo`3jV_oooooo003o1oooool2o`0000;ooooo
00Co0000oooooooooooo00001oooool01?l0003oooooooooool00004ooooo`;o00002_ooool01?l0
0?ooooooooooool00?l3ooooo`05o`00ooooooooooooooooool00?l00oooool01Ol00?oooooooooo
oooooooo003o00;ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[ooooooooooooooooo0?ZJ01;o
oooo00?o0?ZJooooool0nYX01oooool00ol0nY[oooooo`00o`05ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooool0nYX04Oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00So
oooo0_l00?l3ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo003o1?ooool01?l0
0?ooooooooooool00?l<ooooo`03o`00oooooooo0?ZJ00Cooooo0_l0000Cooooo`004_ooool2o`00
00[ooooo0_l00003ooooo`?o00000_ooool5o`0000?ooooo00?o0000ooooooooool03_ooool00ol0
0?ooooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?o0?ZJooooooooool04?ooool0
1Ol0nY[ooooooooooooooooo003o00Gooooo00?o0?ZJooooooooool00_ooool01Ol0nY[ooooooooo
oooooooo003o00Gooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`03ooooo`03o`00
oooooooooooo00cooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`04ooooo`;o003o
2oooool01?l00?ooooooooooool00?l4ooooo`03o`000?oooooooooo00Oooooo0_l0000:ooooo`;o
00000oooool3o`0000Cooooo00?o0000ooooooooool01Oooool01Ol00?ooooooo`00oooooooo003o
00?ooooo00Wo003oooooooooooooooooo`00ool0nY[oooooo`00ool0nYX02_ooool01?l0nY[ooooo
ooooool0nYXIooooo`05o`3jV_ooooooooooooooool0nYX02_ooool01?l0nY[oooooooooool0nYXK
ooooo`04o`00ooooooooooooo`00o`;ooooo00Co003ooooooooooooo003o0oooool01Ol00?oooooo
oooooooooooo003o00?ooooo00Co003ooooooooooooo003o1_ooool01_l00?oo0?ZJooooool0nY[o
ooooo`00o`Sooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooo000000Cooooo00?o0000ooooooooool02_ooool2o`00o`Cooooo00Go003ooooooooooooo
ooooo`00o`07ooooo`04o`00ooooooooooooo`3jVPCooooo00Go0?ZJooooooooooooooooo`3jVP0B
ooooo`04o`3jV_ooooooooooo`3jVPGooooo00Co0?ZJoooooooooooo003o1_ooool00ol0nY[ooooo
ooooo`03ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?o0?ZJooooooooool01?ooool00ol00?oo
ooooooooo`08ooooo`;o003o0oooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooo`00
o`Cooooo00?o003oooooooooool03Oooool01?l00?ooooooooooool0nYX4ooooo`03o`000?oooooo
oooo017ooooo000`ooooo`03o`000?oooooooooo00kooooo00?o003oooooooooool01?ooool01?l0
nY[oooooooooool0nYX:ooooo`03o`3jV_oooooooooo013ooooo00Go0?ZJooooooooooooooooo`00
o`06ooooo`05o`3jV_ooooooooooooooool0nYX00oooool00ol00?ooooooooooo`04ooooo`03o`3j
V_oooooooooo00gooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`0<ooooo`03o`00
oooooooooooo00Cooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`09ooooo`04o`00
ooooooooooooo`00o`Cooooo00?o0000ooooooooool07oooool2o`0000Kooooo00Go003oooooool0
0?ooooooo`00o`03ooooo`09o`00ooooooooooooooooool00?oo0?ZJooooool00?oo0?ZJ00[ooooo
00Co0?ZJoooooooooooo0?ZJ6Oooool01Ol0nY[ooooooooooooooooo0?ZJ00[ooooo00Co0?ZJoooo
oooooooo0?ZJ7?ooool00ol00?ooooooo`00o`02ooooo`04o`00ooooooooooooo`00o`?ooooo00Go
003oooooooooooooooooo`00o`03ooooo`04o`00ooooooooooooo`00o`Kooooo00Ko003oo`3jV_oo
oooo0?ZJooooool00?l7ooooo`;o00000_ooool01?l0003oooooooooool00009ooooo`;o00001?oo
ool00ol0003oooooooooo`0;ooooo`03o`00oooooooooooo00;ooooo00Go003ooooooooooooooooo
o`00o`07ooooo`05o`00ooooooooooooooooool0nYX00oooool01Ol0nY[ooooooooooooooooo0?ZJ
017ooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`05o`3jV_ooooooooooooooool00?l01Ooo
ool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX03oooool00ol0nY[ooooo
ooooo`04ooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool00oooool01?l00?oooooo
ooooool00?l4ooooo`04o`00ooooooooooooo`00oa3ooooo00Co003ooooooooooooo0?ZJ1?ooool0
0ol0003oooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0>ooooo`03o`00oooooooooooo
00Cooooo00Co0?ZJoooooooooooo0?ZJ2_ooool00ol0nY[oooooooooo`0@ooooo`05o`3jV_oooooo
ooooooooool00?l01_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o003oooooooooool0
1?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool0
3?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool0
2Oooool01?l00?ooooooooooool00?l4ooooo`03o`000?oooooooooo01oooooo00?o0000oooooooo
ool01Oooool01Ol00?ooooooo`00oooooooo003o00?ooooo00Wo003oooooooooooooooooo`00ool0
nY[oooooo`00ool0nYX02_ooool01?l0nY[oooooooooool0nYXIooooo`05o`3jV_oooooooooooooo
ool0nYX02_ooool01?l0nY[oooooooooool0nYXLooooo`03o`00oooooooo003o00;ooooo00Co003o
oooooooooooo003o0oooool01Ol00?oooooooooooooooooo003o00?ooooo00Co003ooooooooooooo
003o1oooool01Ol0nY[oooooo`3jV_oooooo003o00Sooooo00Co0000oooooooooooooooo0_l0000;
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04Oooool01?l00?ooooooooooool0
0?l7ooooo`05o`00ooooooooooooooooool0nYX00oooool01Ol0nY[ooooooooooooooooo0?ZJ017o
oooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`05o`3jV_ooooooooooooooool00?l01Oooool0
0ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX03oooool00ol0nY[ooooooooo
o`04ooooo`03o`00oooooooooooo00kooooo00Co003ooooooooooooo003o1?ooool01?l00?oooooo
ooooool00?lAooooo`03o`00oooooooo0?ZJ00Cooooo00?o0000ooooooooool04Oooool0033ooooo
00?o0000ooooooooool03_ooool00ol00?ooooooooooo`04ooooo`04o`3jV_oooooo0?ZJo`00o`_o
oooo00?o0?ZJooooooooool03oooool01Ol0nY[ooooooooooooooooo003o00Kooooo00Go0?ZJoooo
ooooooooooooo`3jVP03ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool03?ooool0
0ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo00cooooo00?o003oooooooooool01?ooool0
0ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Wooooo00Co003ooooooooooooo003o0ooo
ool2o`00027ooooo00?o0000ooooooooool01Oooool3o`00o`05ooooool00?ooooooooooool00?l0
1?ooool01Ol00?oo0?ZJooooool00?oo0?ZJ00[ooooo00Co0?ZJoooooooooooo0?ZJ6Oooool01Ol0
nY[ooooooooooooooooo0?ZJ00[ooooo00Co0?ZJoooooooooooo0?ZJ7?ooool00ol00?ooooooo`00
o`02ooooo`04o`00ooooooooooooo`00o`?ooooo00Go003oooooooooooooooooo`00o`03ooooo`04
o`00ooooooooooooo`00o`Oooooo00Co0?ZJooooool0nY[o003o2Oooool00ol0003oooooooooo`0C
ooooo`;o00004_ooool00ol00?ooooooo`00o`08ooooo`05o`00ooooooooooooooooool0nYX00_oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00kooooo00Go0?ZJoooooooooooooooo
o`3jVP05ooooo`05o`3jV_ooooooooooooooool00?l01Oooool00ol0nY[oooooooooo`03ooooo`05
o`3jV_ooooooooooooooool0nYX03_ooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo
00kooooo00Co003ooooooooooooo003o1?ooool01?l00?ooooooooooool00?lAooooo`03o`00oooo
oooo0?ZJ00Cooooo00?o0000ooooooooool04Oooool0033ooooo00?o0000ooooooooool05Oooool0
1?l0nY[oooooo`3jV_l00?l;ooooo`03o`3jV_oooooooooo00oooooo00Go0?ZJoooooooooooooooo
o`00o`06ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o003oooooooooool01?ooool00ol0nY[o
ooooooooo`0<ooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool04oooool00ol00?oo
ooooooooo`05ooooo`03o`00oooooooooooo00Wooooo00Co003ooooooooooooo003o1?ooool00ol0
003oooooooooo`0Oooooo`;o00002_ooool01?l00?ooooooooooool00?l4ooooo`05o`00ool0nY[o
ooooo`00ool0nYX02_ooool01?l0nY[oooooooooool0nYXIooooo`04o`3jV_ooooooooooo`3jVP_o
oooo00Co0?ZJoooooooooooo0?ZJ7?ooool00ol00?ooooooo`00o`02ooooo`04o`00oooooooooooo
o`00o`?ooooo00Co003ooooooooooooo003o1?ooool01?l00?ooooooooooool00?l7ooooo`04o`3j
V_oooooo0?ZJo`00o`Sooooo0_l0000Eooooo`03o`000?oooooooooo017ooooo0ol00?l8ooooo`05
o`00ooooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00;ooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo
00oooooo0_l00?l6ooooo`;o003o4_ooool00ol00?ooooooo`3jVP04ooooo`03o`000?oooooooooo
017ooooo000`ooooo`03o`000?oooooooooo01Gooooo00?o003oo`3jV_l0nYX03?ooool00ol0nY[o
ooooooooo`0>ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool01?ooool01?l0nY[o
ooooooooool0nYX4ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool03?ooool00ol0
nY[oooooooooo`04ooooo`03o`00oooooooooooo02Oooooo00Co003ooooooooooooo003o1?ooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Wooooo00Co003ooooooooooooo003o1?oo
ool01Ol00?oo0?ZJooooool00?oo0?ZJ00[ooooo00Co0?ZJoooooooooooo0?ZJ6Oooool01?l0nY[o
ooooooooool0nYX;ooooo`04o`3jV_ooooooooooo`3jVQcooooo0ol00?l2ooooo`04o`00oooooooo
ooooo`00o`?ooooo00Co003ooooooooooooo003o1?ooool01?l00?ooooooooooool00?l7ooooo`04
o`3jV_oooooo0?ZJo`00o`Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Coooo
o`03o`00oooooooooooo00Kooooo00Go003oooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo
oooo00Gooooo00?o003oooooooooool04?ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooo
oooo013ooooo00?o003oooooool0nYX01?ooool00ol0003oooooooooo`0Aooooo`00<?ooool00ol0
003oooooooooo`0Eooooo`03o`00ool0nY[o0?ZJ00cooooo00?o0?ZJooooooooool03_ooool00ol0
nY[oooooooooo`02ooooo`03o`00oooooooooooo00Cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool0
0ol00?ooooooooooo`04ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool01?ooool0
0ol00?ooooooooooo`0Wooooo`04o`00ooooooooooooo`00o`?ooooo0_l00009ooooo`;o00001?oo
ool00ol0003oooooooooo`03ooooo`;o00000oooool3o`0000Cooooo0_l0000:ooooo`04o`00oooo
ooooooooo`00o`Cooooo00Go003oo`3jV_oooooo003oo`3jVP0:ooooo`04o`3jV_ooooooooooo`3j
VQWooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0nY[oooooooooool0nYXLooooo`03o`00oooo
oooooooo00;ooooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooo`00o`04ooooo`04o`00
ooooooooooooo`00o`Oooooo00Co0?ZJooooool0nY[o003o2?ooool2o`0001Gooooo00?o0000oooo
ooooool07?ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJoooo
ooooool03Oooool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool0
0ol00?ooooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool00ol0nY[ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00Kooooo00?o003oooooooooool0;?ooool00ol00?oo0?ZJoooo
o`03ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo01Gooooo00?o003o
o`3jV_l0nYX03?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00;ooooo00?o003o
ooooooooool01?ooool01?l0nY[oooooooooool0nYX4ooooo`03o`00oooooooooooo00Cooooo00?o
0?ZJooooooooool03?ooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooooooo02Sooooo00?o
003oooooool00?l01?ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Sooooo
00Ko0000oooooooooooo0000ooooool00003ooooo`05o`000?ooooooooooooooool000003?ooool0
0ol00?ooooooo`00o`04ooooo`05o`00oooooooo0?ZJo`00ool0nYX02_ooool01?l0nY[ooooooooo
ool0nYXIooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Co0?ZJoooooooooooo0?ZJ8Oooool01?l0
0?ooooooooooool00?l4ooooo`03o`00oooooooo003o00Cooooo00Co003ooooooooooooo003o1ooo
ool2o`3jVP03ooooool00?oooooo00Sooooo00?o0000ooooooooool04oooool2o`0001gooooo00?o
003oooooooooool00_ooool00ol0nY[oooooo`3jVP06ooooo`03o`3jV_oooooooooo00_ooooo00?o
0?ZJooooooooool01?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo00?o003oooooooooool0
0oooool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo00?o0?ZJooooooooool02_ooool00ol0nY[o
ooooooooo`06ooooo`03o`00oooooooooooo02cooooo00?o003oooooool0nYX00oooool00ol0003o
ooooooooo`0Aooooo`00<?ooool00ol0003oooooooooo`0Eooooo`03o`00ool0nY[o003o00cooooo
00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00Cooooo
00Co0?ZJoooooooooooo0?ZJ1?ooool00ol00?ooooooooooo`04ooooo`03o`3jV_oooooooooo00co
oooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`0Xooooo`03o`00oooooooo003o00Co
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00008ooooo`04o`000?oooooooooo
o`0000Gooooo00Go0000ooooooooooooooooo`00000<ooooo`03o`00oooooooo003o00Cooooo00Go
003oooooool0nY[o003oo`3jVP0:ooooo`04o`3jV_ooooooooooo`3jVQWooooo00Co0?ZJoooooooo
oooo0?ZJ2oooool01?l0nY[oooooooooool0nYXRooooo`;o003o1Oooool00ol00?ooooooo`00o`04
ooooo`04o`00ooooooooooooo`00o`Oooooo00Co0?ZJoooooooooooo003o2Oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo01cooooo00?o003oooooooooool00_ooool2o`3jVPOooooo
00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`04ooooo`05o`3jV_ooooooooooooooool0
nYX01_ooool00ol00?ooooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00Kooooo00?o003oooooooooool0;?ooool00ol0
0?ooooooo`3jVP03ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo01Ko
oooo00?o0?ZJo`00ooooool02oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00;o
oooo00?o003oooooooooool01?ooool01?l00?oo0?ZJooooool0nYX4ooooo`03o`00oooooooooooo
00Cooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo
02Sooooo00?o003oooooool00?l00oooool2o`0000Sooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00003ooooo`;o00001?ooool2o`0000_ooooo0_l00?l6ooooo`03o`00ool0
nY[o0?ZJ00_ooooo00?o0?ZJooooool0nYX06_ooool01?l00?oo0?ZJooooool0nYX;ooooo`04o`3j
V_ooooooooooo`3jVR;ooooo0_l00?l5ooooo`03o`00oooooooo003o00Gooooo0_l00?l8ooooo`04
o`00ooooooooooooo`00o`Sooooo0_l0000Eooooo`03o`000?oooooooooo01cooooo00?o003ooooo
ooooool00_ooool2o`3jVPOooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`04oooo
o`05o`3jV_ooooooooooooooool0nYX01_ooool00ol00?ooooooooooo`02ooooo`05o`3jV_oooooo
ooooooooool0nYX01_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Kooooo00?o
003oooooooooool0;Oooool00ol00?oo0?ZJooooo`02ooooo`03o`000?oooooooooo017ooooo000H
ooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000oooool3o`0000Cooooo00?o0000
ooooooooool05_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`04ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003o
ooooooooool01Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00Gooooo00?o003o
ooooooooool0:?ooool00ol00?ooooooo`00o`04ooooo`03o`000?oooooooooo00Kooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00005ooooo`05o`000?ooooooooooooooool0
00003?ooool2o`00o`Kooooo0_l00?l00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo0?ZJ01_o
oooo00?o0?ZJooooool0nYX02oooool00ol0nY[oooooo`3jVP0Sooooo`;o003o1Oooool2o`00o`Ko
oooo0_l00?l8ooooo`03o`00oooooooo003o00[ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Looooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool01oooool00ol0nY[o
ooooooooo`09ooooo`03o`3jV_oooooooooo00Gooooo00Go0?ZJooooooooooooooooo`3jVP06oooo
o`03o`00oooooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool01oooool00ol00?ooooooooooo`0]ooooo`03o`00ool0nY[o
oooo00;ooooo00?o0000ooooooooool04Oooool001Oooooo00Co0000oooooooooooo00002?ooool0
1_l0003oooooooooool0003oooooo`0000?ooooo00Go0000ooooooooooooooooo`00000Hooooo`03
o`00oooooooooooo00cooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`02ooooo`03
o`00oooooooooooo00Gooooo0_l0nYX5ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJoooooooo
ool02_ooool00ol0nY[oooooooooo`05ooooo`03o`00oooooooooooo02Sooooo00?o003oooooool0
0?l01?ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooo
oooooooo0000ooooool00003ooooo`04o`000?ooooooooooooooo`;o00003?ooool00ol00?oooooo
ooooo`04ooooo`;o003o3?ooool00ol0nY[oooooo`3jVP0Kooooo`03o`3jV_oooooo0?ZJ00_ooooo
00?o0?ZJooooool0nYX08oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Cooooo
0_l00?l8ooooo`03o`00oooooooo003o00Wooooo0_l0000Eooooo`;o00007Oooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo00Oooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooo
ooooo`05ooooo`05o`3jV_ooooooooooooooool0nYX01oooool01Ol00?oooooooooooooooooo0?ZJ
00?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo
00Oooooo00?o003oooooooooool0;Oooool00ol00?oo0?ZJooooo`02ooooo`03o`000?oooooooooo
017ooooo000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00001Oooool0
1?l0003oooooooooooooool2o`0001Oooooo00?o003oooooooooool03?ooool00ol0nY[ooooooooo
o`0<ooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool01Oooool00ol00?oo0?ZJoooo
o`04ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJooooooooool00oooool3o`3jVP?ooooo00?o
0?ZJooooooooool01_ooool00ol00?ooooooooooo`0Yooooo`;o003o0oooool2o`0000Wooooo0_l0
000:ooooo`;o00000oooool3o`0000Cooooo00?o0000ooooooooool02oooool00ol00?oooooooooo
o`04ooooo`03o`00oooooooooooo00cooooo0_l0nYXKooooo`;o0?ZJ3Oooool2o`3jVR?ooooo00?o
003oooooooooool01Oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Sooooo0_l0
0?l:ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07?ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00Oooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooooooo
o`05ooooo`05o`3jV_ooooooooooooooool0nYX01oooool01Ol00?oooooooooooooooooo0?ZJ00?o
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00Oo
oooo00?o003oooooooooool0;_ooool01Ol00?oo0?ZJoooooooooooo000001?ooooo000Gooooo`04
o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000oooool2o`0000Cooooo00?o0000
ooooooooool09Oooool00ol0nY[oooooooooo`03ooooo`Go0?ZJ1?ooool00ol0nY[oooooooooo`03
ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`06
ooooo`05o`3jV_ooooooooooooooool0nYX00oooool3o`3jVPWooooo00?o003oooooooooool0:_oo
ool00ol00?ooooooooooo`02ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool04_oo
ool00ol00?ooooooooooo`0<ooooo`;o0?ZJ6oooool2o`3jVPgooooo0_l0nYX[ooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`08ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool07Oooool01?l00?ooooooooooool00?l:ooooo`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooooooool01Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Oo
oooo00Go003oooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00Cooooo00?o003oo`3j
V_ooool01oooool00ol0nY[oooooooooo`08ooooo`03o`00oooooooooooo02kooooo00Go003oo`3j
V_ooooooooooo`00000Cooooo`005oooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000Gooooo00Go0000ooooooooooooooooo`00000Xooooo`03o`3jV_oooooooooo00;o0?ZJ
0ol00?l2ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool00ol00?ooooooooooo`06ooooo`03
o`00oooooooooooo00;ooooo0_l00?l8ooooo`05o`3jV_ooooooooooo`3jV_ooool00ol00?l<oooo
o`03o`00oooooooooooo02oooooo00?o0000ooooooooool07oooool2o`0002;ooooo00?o0?ZJoooo
ooooool06_ooool00ol00?oo0?ZJooooo`0<ooooo`;o0?ZJB?ooool2o`0001Gooooo00?o0000oooo
ooooool07Oooool01?l00?ooooooooooool00?l;ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooo`3jVP08ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJ
ooooool0nYX02?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Sooooo00?o003o
ooooooooool0;oooool01?l0nY[oooooooooool0000Cooooo`005oooool01?l0003oooooooooool0
0008ooooo`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooooooo0000
02Wooooo0_l0nYX5ooooo`;o003o00Goooooo`3jV_l0nY[oooooo`3jVP05ooooo`03o`00oooooooo
oooo00Kooooo00Go003oooooooooooooooooo`00o`0:ooooo`03o`3jV_oooooo0?ZJ00;o003o0ooo
ool2o`00o`[ooooo00?o003oooooooooool0;_ooool2o`00027ooooo00?o0000ooooooooool08Ooo
ool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0B?oo
ool00ol0003oooooooooo`0Cooooo`;o00007_ooool01?l00?ooooooooooool00?l;ooooo`03o`3j
V_oooooooooo00Oooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooo`3jVP09ooooo`07o`00
ooooooooooooooooool0nY[oooooo`3jVP08ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ooooool02Oooool00ol00?ooooooooooo`0booooo`03o`000?oooooooooo017ooooo000Hooooo`;o
00002_ooool2o`0000?ooooo0ol00004ooooo`03o`000?oooooooooo033ooooo0ol00?l00ol0nY[o
003oo`00o`05o`00o`Wooooo0ol00?l<ooooo`03o`3jV_l00?oooooo00Kooooo2ol00?laooooo`03
o`000?oooooooooo01oooooo0_l00010ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooooooo
ool0Aoooool2o`0000?ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00004ooooo`03
o`000?oooooooooo01kooooo0_l00?l<ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooo`3jVP09ooooo`07o`00ooooooooooooooooool0nY[oooooo`3jVP09
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool02_ooool00ol00?ooooooooooo`0b
ooooo`03o`000?oooooooooo017ooooo000`ooooo`03o`000?oooooooooo09Sooooo00?o0000oooo
ooooool07oooool00ol0003oooooooooo`2Hooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool07_oo
ool00ol00?ooooooooooo`0<ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool02?oo
ool00ol0nY[oooooo`3jVP0:ooooo`06o`00ooooooooooooo`3jV_oooooo0?ZJ2_ooool00ol0nY[o
ooooooooo`02o`3jVPgooooo00?o003oooooooooool0<_ooool00ol0003oooooooooo`0Aooooo`00
<?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00Go0000oooooooo
ooooooooo`00000Qoooooico00000_ooool01?l0003oooooooooool0000;ooooo`05o`000?oooooo
ooooooooool00000<?ooool00ol00?oo0?ZJo`3jVP04o`3jVPCo003o2?ooool00ol0nY[ooooooooo
o`0:ooooo`04o`00ooooooooooooo`3jVPcooooo0_l0nYX2ooooo`Oo003o1_ooool00ol00?oooooo
ooooo`0booooo`03o`000?oooooooooo017ooooo000`oooooico0000_oooool01?l0003ooooooooo
ool0000;ooooo`04o`000?ooooooooooooooo`;o0000<?ooool3o`00o`Oooooo2?l00?l00ol0nY[o
ooooooooo`0;ooooo`;o003o00?o0?ZJooooooooool02oooool3o`00o`Oooooo1ol00?lcooooo`;o
00004oooool00?ooooooS?ooool01?l0003oooooooooool00007ooooo`Co00001?ooool01Ol0003o
oooooooooooooooo000001oooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool01?l0003oooooooooool0000C
ooooo`00oooooon<ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01OoooonX
o`0001?ooooo003oooooohgooooo0_l00008ooooo`Go0000__ooool00?oooooooooooomKooooo`00
oooooooooooooe_ooooo003oooooooooooooFoooool00?oooooooooooomKooooo`00\
\>"],
  ImageRangeCache->{{{0, 600.25}, {122.812, 0}} -> {-0.0858525, -0.0154541, \
0.00528398, 0.00528398}, {{16.1875, 205.5}, {119.875, 2.875}} -> {-3.50883, \
-0.00383378, 0.0677136, 0.000311735}, {{205.5, 394.75}, {119.875, 2.875}} -> \
{-16.3344, -0.0526037, 0.0677413, 0.000786228}, {{394.75, 584}, {119.875, \
2.875}} -> {-26.3111, -0.0739329, 0.0628221, 0.00498418}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["stationary  variance", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? SigmaStat\)], "Input"],

Cell[BoxData[
    \("SigmaStat[A_,Omega_]: A.Sigma+Sigma.A'+Omega==0"\)], "Print",
  CellTags->"Info3417329866-9092711"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(Attributes[SigmaStat] = {Protected}\)},
          {" "},
          {GridBox[{
                {\(SigmaStat[A_, Omega_] := 
                    Module[{code`PARTest`Private`Id, p, LL}, p = Length[A]; 
                      code`PARTest`Private`Id = IdentityMatrix[p]; 
                      LL = L[A, code`PARTest`Private`Id]; 
                      Shape[\(-Inverse[LL] . Flatten[Omega]\), {p, p}]]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "SigmaStat"],
      Editable->False]], "Print",
  CellTags->"Info3417329866-9092711"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
A
OMEGA\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{0, 1}, {\(-16\), \(-4\)}}\)], "Output"],

Cell[BoxData[
    \({{1.`*^-8, 0.`}, {0.`, 4.`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
SigmaStat[A,OMEGA]//MatrixForm
SigmaStat[{{0,1},{-16,-4}},{{0,0},{0,4.}}]//MatrixForm\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2"},
              {"1", "0.0312500025`", \(-5.`*^-9\)},
              {"2", \(-5.`*^-9\), "0.50000002`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2"},
              {"1", "0.03125`", "0.`"},
              {"2", "0.`", "0.5`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["sampling scheme",
  FontColor->RGBColor[1, 0, 0]]], "Section"],

Cell[CellGroupData[{

Cell["\<\
xlines = Shape[Outer[List,Range[0,10,.1],{0,1,2,3,4}] ,{101 5,2}];
ylines = Shape[Outer[List,Range[0,10,1],Range[0,4,.1]] ,{41 11,2}];\
\>", \
"Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(ylines\\)\\\" is similar to existing symbol \
\\\"\\!\\(xlines\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell["\<\
epi1 = 
Map[Point, {(tau1-1)DT,Shape[3,{tau1//Length}]}//Transpose] ; 
epi2 = 
Map[Point, {(tau2-1)DT,Shape[2,{tau2//Length}]}//Transpose] ;
epi3 = 
Map[Point, {(tau3-1)DT,Shape[1,{tau3//Length}]}//Transpose] ;\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\

grid = plot1[xlines ~vv~ ylines,
  PlotJoined->False,
  dicke->.001,
  PlotRange->{Automatic,{0,4}},
  FrameTicks->{Automatic,{{1,\"x\"},{2,\"y2\"},{3,\"y1\"}}},
  Epilog->{Hue[.8],PointSize[.015],epi1,epi2,epi3}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(grid\\)\\\" is similar to existing symbol \\\
\"\\!\\(Grid\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{956, 2}\),
      SequenceForm[ "Dimension der Daten  ", {956, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0 0.154508 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .15451 -10 -6 ]
[-0.0125 .15451 0 6 ]
[-0.0125 .30902 -16 -6 ]
[-0.0125 .30902 0 6 ]
[-0.0125 .46353 -16 -6 ]
[-0.0125 .46353 0 6 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[1.0125 .15451 0 -6 ]
[1.0125 .15451 10 6 ]
[1.0125 .30902 0 -6 ]
[1.0125 .30902 16 6 ]
[1.0125 .46353 0 -6 ]
[1.0125 .46353 16 6 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .15451 m
.00625 .15451 L
s
gsave
-0.0125 .15451 -71 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30902 m
.00625 .30902 L
s
gsave
-0.0125 .30902 -77 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y2) show
75.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .46353 m
.00625 .46353 L
s
gsave
-0.0125 .46353 -77 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y1) show
75.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .15451 m
1 .15451 L
s
gsave
1.0125 .15451 -61 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .30902 m
1 .30902 L
s
gsave
1.0125 .30902 -61 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y2) show
75.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .46353 m
1 .46353 L
s
gsave
1.0125 .46353 -61 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y1) show
75.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .61803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 0 Mdot
.02381 .15451 Mdot
.02381 .30902 Mdot
.02381 .46353 Mdot
.02381 .61803 Mdot
.03333 0 Mdot
.03333 .15451 Mdot
.03333 .30902 Mdot
.03333 .46353 Mdot
.03333 .61803 Mdot
.04286 0 Mdot
.04286 .15451 Mdot
.04286 .30902 Mdot
.04286 .46353 Mdot
.04286 .61803 Mdot
.05238 0 Mdot
.05238 .15451 Mdot
.05238 .30902 Mdot
.05238 .46353 Mdot
.05238 .61803 Mdot
.0619 0 Mdot
.0619 .15451 Mdot
.0619 .30902 Mdot
.0619 .46353 Mdot
.0619 .61803 Mdot
.07143 0 Mdot
.07143 .15451 Mdot
.07143 .30902 Mdot
.07143 .46353 Mdot
.07143 .61803 Mdot
.08095 0 Mdot
.08095 .15451 Mdot
.08095 .30902 Mdot
.08095 .46353 Mdot
.08095 .61803 Mdot
.09048 0 Mdot
.09048 .15451 Mdot
.09048 .30902 Mdot
.09048 .46353 Mdot
.09048 .61803 Mdot
.1 0 Mdot
.1 .15451 Mdot
.1 .30902 Mdot
.1 .46353 Mdot
.1 .61803 Mdot
.10952 0 Mdot
.10952 .15451 Mdot
.10952 .30902 Mdot
.10952 .46353 Mdot
.10952 .61803 Mdot
.11905 0 Mdot
.11905 .15451 Mdot
.11905 .30902 Mdot
.11905 .46353 Mdot
.11905 .61803 Mdot
.12857 0 Mdot
.12857 .15451 Mdot
.12857 .30902 Mdot
.12857 .46353 Mdot
.12857 .61803 Mdot
.1381 0 Mdot
.1381 .15451 Mdot
.1381 .30902 Mdot
.1381 .46353 Mdot
.1381 .61803 Mdot
.14762 0 Mdot
.14762 .15451 Mdot
.14762 .30902 Mdot
.14762 .46353 Mdot
.14762 .61803 Mdot
.15714 0 Mdot
.15714 .15451 Mdot
.15714 .30902 Mdot
.15714 .46353 Mdot
.15714 .61803 Mdot
.16667 0 Mdot
.16667 .15451 Mdot
.16667 .30902 Mdot
.16667 .46353 Mdot
.16667 .61803 Mdot
.17619 0 Mdot
.17619 .15451 Mdot
.17619 .30902 Mdot
.17619 .46353 Mdot
.17619 .61803 Mdot
.18571 0 Mdot
.18571 .15451 Mdot
.18571 .30902 Mdot
.18571 .46353 Mdot
.18571 .61803 Mdot
.19524 0 Mdot
.19524 .15451 Mdot
.19524 .30902 Mdot
.19524 .46353 Mdot
.19524 .61803 Mdot
.20476 0 Mdot
.20476 .15451 Mdot
.20476 .30902 Mdot
.20476 .46353 Mdot
.20476 .61803 Mdot
.21429 0 Mdot
.21429 .15451 Mdot
.21429 .30902 Mdot
.21429 .46353 Mdot
.21429 .61803 Mdot
.22381 0 Mdot
.22381 .15451 Mdot
.22381 .30902 Mdot
.22381 .46353 Mdot
.22381 .61803 Mdot
.23333 0 Mdot
.23333 .15451 Mdot
.23333 .30902 Mdot
.23333 .46353 Mdot
.23333 .61803 Mdot
.24286 0 Mdot
.24286 .15451 Mdot
.24286 .30902 Mdot
.24286 .46353 Mdot
.24286 .61803 Mdot
.25238 0 Mdot
.25238 .15451 Mdot
.25238 .30902 Mdot
.25238 .46353 Mdot
.25238 .61803 Mdot
.2619 0 Mdot
.2619 .15451 Mdot
.2619 .30902 Mdot
.2619 .46353 Mdot
.2619 .61803 Mdot
.27143 0 Mdot
.27143 .15451 Mdot
.27143 .30902 Mdot
.27143 .46353 Mdot
.27143 .61803 Mdot
.28095 0 Mdot
.28095 .15451 Mdot
.28095 .30902 Mdot
.28095 .46353 Mdot
.28095 .61803 Mdot
.29048 0 Mdot
.29048 .15451 Mdot
.29048 .30902 Mdot
.29048 .46353 Mdot
.29048 .61803 Mdot
.3 0 Mdot
.3 .15451 Mdot
.3 .30902 Mdot
.3 .46353 Mdot
.3 .61803 Mdot
.30952 0 Mdot
.30952 .15451 Mdot
.30952 .30902 Mdot
.30952 .46353 Mdot
.30952 .61803 Mdot
.31905 0 Mdot
.31905 .15451 Mdot
.31905 .30902 Mdot
.31905 .46353 Mdot
.31905 .61803 Mdot
.32857 0 Mdot
.32857 .15451 Mdot
.32857 .30902 Mdot
.32857 .46353 Mdot
.32857 .61803 Mdot
.3381 0 Mdot
.3381 .15451 Mdot
.3381 .30902 Mdot
.3381 .46353 Mdot
.3381 .61803 Mdot
.34762 0 Mdot
.34762 .15451 Mdot
.34762 .30902 Mdot
.34762 .46353 Mdot
.34762 .61803 Mdot
.35714 0 Mdot
.35714 .15451 Mdot
.35714 .30902 Mdot
.35714 .46353 Mdot
.35714 .61803 Mdot
.36667 0 Mdot
.36667 .15451 Mdot
.36667 .30902 Mdot
.36667 .46353 Mdot
.36667 .61803 Mdot
.37619 0 Mdot
.37619 .15451 Mdot
.37619 .30902 Mdot
.37619 .46353 Mdot
.37619 .61803 Mdot
.38571 0 Mdot
.38571 .15451 Mdot
.38571 .30902 Mdot
.38571 .46353 Mdot
.38571 .61803 Mdot
.39524 0 Mdot
.39524 .15451 Mdot
.39524 .30902 Mdot
.39524 .46353 Mdot
.39524 .61803 Mdot
.40476 0 Mdot
.40476 .15451 Mdot
.40476 .30902 Mdot
.40476 .46353 Mdot
.40476 .61803 Mdot
.41429 0 Mdot
.41429 .15451 Mdot
.41429 .30902 Mdot
.41429 .46353 Mdot
.41429 .61803 Mdot
.42381 0 Mdot
.42381 .15451 Mdot
.42381 .30902 Mdot
.42381 .46353 Mdot
.42381 .61803 Mdot
.43333 0 Mdot
.43333 .15451 Mdot
.43333 .30902 Mdot
.43333 .46353 Mdot
.43333 .61803 Mdot
.44286 0 Mdot
.44286 .15451 Mdot
.44286 .30902 Mdot
.44286 .46353 Mdot
.44286 .61803 Mdot
.45238 0 Mdot
.45238 .15451 Mdot
.45238 .30902 Mdot
.45238 .46353 Mdot
.45238 .61803 Mdot
.4619 0 Mdot
.4619 .15451 Mdot
.4619 .30902 Mdot
.4619 .46353 Mdot
.4619 .61803 Mdot
.47143 0 Mdot
.47143 .15451 Mdot
.47143 .30902 Mdot
.47143 .46353 Mdot
.47143 .61803 Mdot
.48095 0 Mdot
.48095 .15451 Mdot
.48095 .30902 Mdot
.48095 .46353 Mdot
.48095 .61803 Mdot
.49048 0 Mdot
.49048 .15451 Mdot
.49048 .30902 Mdot
.49048 .46353 Mdot
.49048 .61803 Mdot
.5 0 Mdot
.5 .15451 Mdot
.5 .30902 Mdot
.5 .46353 Mdot
.5 .61803 Mdot
.50952 0 Mdot
.50952 .15451 Mdot
.50952 .30902 Mdot
.50952 .46353 Mdot
.50952 .61803 Mdot
.51905 0 Mdot
.51905 .15451 Mdot
.51905 .30902 Mdot
.51905 .46353 Mdot
.51905 .61803 Mdot
.52857 0 Mdot
.52857 .15451 Mdot
.52857 .30902 Mdot
.52857 .46353 Mdot
.52857 .61803 Mdot
.5381 0 Mdot
.5381 .15451 Mdot
.5381 .30902 Mdot
.5381 .46353 Mdot
.5381 .61803 Mdot
.54762 0 Mdot
.54762 .15451 Mdot
.54762 .30902 Mdot
.54762 .46353 Mdot
.54762 .61803 Mdot
.55714 0 Mdot
.55714 .15451 Mdot
.55714 .30902 Mdot
.55714 .46353 Mdot
.55714 .61803 Mdot
.56667 0 Mdot
.56667 .15451 Mdot
.56667 .30902 Mdot
.56667 .46353 Mdot
.56667 .61803 Mdot
.57619 0 Mdot
.57619 .15451 Mdot
.57619 .30902 Mdot
.57619 .46353 Mdot
.57619 .61803 Mdot
.58571 0 Mdot
.58571 .15451 Mdot
.58571 .30902 Mdot
.58571 .46353 Mdot
.58571 .61803 Mdot
.59524 0 Mdot
.59524 .15451 Mdot
.59524 .30902 Mdot
.59524 .46353 Mdot
.59524 .61803 Mdot
.60476 0 Mdot
.60476 .15451 Mdot
.60476 .30902 Mdot
.60476 .46353 Mdot
.60476 .61803 Mdot
.61429 0 Mdot
.61429 .15451 Mdot
.61429 .30902 Mdot
.61429 .46353 Mdot
.61429 .61803 Mdot
.62381 0 Mdot
.62381 .15451 Mdot
.62381 .30902 Mdot
.62381 .46353 Mdot
.62381 .61803 Mdot
.63333 0 Mdot
.63333 .15451 Mdot
.63333 .30902 Mdot
.63333 .46353 Mdot
.63333 .61803 Mdot
.64286 0 Mdot
.64286 .15451 Mdot
.64286 .30902 Mdot
.64286 .46353 Mdot
.64286 .61803 Mdot
.65238 0 Mdot
.65238 .15451 Mdot
.65238 .30902 Mdot
.65238 .46353 Mdot
.65238 .61803 Mdot
.6619 0 Mdot
.6619 .15451 Mdot
.6619 .30902 Mdot
.6619 .46353 Mdot
.6619 .61803 Mdot
.67143 0 Mdot
.67143 .15451 Mdot
.67143 .30902 Mdot
.67143 .46353 Mdot
.67143 .61803 Mdot
.68095 0 Mdot
.68095 .15451 Mdot
.68095 .30902 Mdot
.68095 .46353 Mdot
.68095 .61803 Mdot
.69048 0 Mdot
.69048 .15451 Mdot
.69048 .30902 Mdot
.69048 .46353 Mdot
.69048 .61803 Mdot
.7 0 Mdot
.7 .15451 Mdot
.7 .30902 Mdot
.7 .46353 Mdot
.7 .61803 Mdot
.70952 0 Mdot
.70952 .15451 Mdot
.70952 .30902 Mdot
.70952 .46353 Mdot
.70952 .61803 Mdot
.71905 0 Mdot
.71905 .15451 Mdot
.71905 .30902 Mdot
.71905 .46353 Mdot
.71905 .61803 Mdot
.72857 0 Mdot
.72857 .15451 Mdot
.72857 .30902 Mdot
.72857 .46353 Mdot
.72857 .61803 Mdot
.7381 0 Mdot
.7381 .15451 Mdot
.7381 .30902 Mdot
.7381 .46353 Mdot
.7381 .61803 Mdot
.74762 0 Mdot
.74762 .15451 Mdot
.74762 .30902 Mdot
.74762 .46353 Mdot
.74762 .61803 Mdot
.75714 0 Mdot
.75714 .15451 Mdot
.75714 .30902 Mdot
.75714 .46353 Mdot
.75714 .61803 Mdot
.76667 0 Mdot
.76667 .15451 Mdot
.76667 .30902 Mdot
.76667 .46353 Mdot
.76667 .61803 Mdot
.77619 0 Mdot
.77619 .15451 Mdot
.77619 .30902 Mdot
.77619 .46353 Mdot
.77619 .61803 Mdot
.78571 0 Mdot
.78571 .15451 Mdot
.78571 .30902 Mdot
.78571 .46353 Mdot
.78571 .61803 Mdot
.79524 0 Mdot
.79524 .15451 Mdot
.79524 .30902 Mdot
.79524 .46353 Mdot
.79524 .61803 Mdot
.80476 0 Mdot
.80476 .15451 Mdot
.80476 .30902 Mdot
.80476 .46353 Mdot
.80476 .61803 Mdot
.81429 0 Mdot
.81429 .15451 Mdot
.81429 .30902 Mdot
.81429 .46353 Mdot
.81429 .61803 Mdot
.82381 0 Mdot
.82381 .15451 Mdot
.82381 .30902 Mdot
.82381 .46353 Mdot
.82381 .61803 Mdot
.83333 0 Mdot
.83333 .15451 Mdot
.83333 .30902 Mdot
.83333 .46353 Mdot
.83333 .61803 Mdot
.84286 0 Mdot
.84286 .15451 Mdot
.84286 .30902 Mdot
.84286 .46353 Mdot
.84286 .61803 Mdot
.85238 0 Mdot
.85238 .15451 Mdot
.85238 .30902 Mdot
.85238 .46353 Mdot
.85238 .61803 Mdot
.8619 0 Mdot
.8619 .15451 Mdot
.8619 .30902 Mdot
.8619 .46353 Mdot
.8619 .61803 Mdot
.87143 0 Mdot
.87143 .15451 Mdot
.87143 .30902 Mdot
.87143 .46353 Mdot
.87143 .61803 Mdot
.88095 0 Mdot
.88095 .15451 Mdot
.88095 .30902 Mdot
.88095 .46353 Mdot
.88095 .61803 Mdot
.89048 0 Mdot
.89048 .15451 Mdot
.89048 .30902 Mdot
.89048 .46353 Mdot
.89048 .61803 Mdot
.9 0 Mdot
.9 .15451 Mdot
.9 .30902 Mdot
.9 .46353 Mdot
.9 .61803 Mdot
.90952 0 Mdot
.90952 .15451 Mdot
.90952 .30902 Mdot
.90952 .46353 Mdot
.90952 .61803 Mdot
.91905 0 Mdot
.91905 .15451 Mdot
.91905 .30902 Mdot
.91905 .46353 Mdot
.91905 .61803 Mdot
.92857 0 Mdot
.92857 .15451 Mdot
.92857 .30902 Mdot
.92857 .46353 Mdot
.92857 .61803 Mdot
.9381 0 Mdot
.9381 .15451 Mdot
.9381 .30902 Mdot
.9381 .46353 Mdot
.9381 .61803 Mdot
.94762 0 Mdot
.94762 .15451 Mdot
.94762 .30902 Mdot
.94762 .46353 Mdot
.94762 .61803 Mdot
.95714 0 Mdot
.95714 .15451 Mdot
.95714 .30902 Mdot
.95714 .46353 Mdot
.95714 .61803 Mdot
.96667 0 Mdot
.96667 .15451 Mdot
.96667 .30902 Mdot
.96667 .46353 Mdot
.96667 .61803 Mdot
.97619 0 Mdot
.97619 .15451 Mdot
.97619 .30902 Mdot
.97619 .46353 Mdot
.97619 .61803 Mdot
.02381 0 Mdot
.02381 .01545 Mdot
.02381 .0309 Mdot
.02381 .04635 Mdot
.02381 .0618 Mdot
.02381 .07725 Mdot
.02381 .09271 Mdot
.02381 .10816 Mdot
.02381 .12361 Mdot
.02381 .13906 Mdot
.02381 .15451 Mdot
.02381 .16996 Mdot
.02381 .18541 Mdot
.02381 .20086 Mdot
.02381 .21631 Mdot
.02381 .23176 Mdot
.02381 .24721 Mdot
.02381 .26266 Mdot
.02381 .27812 Mdot
.02381 .29357 Mdot
.02381 .30902 Mdot
.02381 .32447 Mdot
.02381 .33992 Mdot
.02381 .35537 Mdot
.02381 .37082 Mdot
.02381 .38627 Mdot
.02381 .40172 Mdot
.02381 .41717 Mdot
.02381 .43262 Mdot
.02381 .44807 Mdot
.02381 .46353 Mdot
.02381 .47898 Mdot
.02381 .49443 Mdot
.02381 .50988 Mdot
.02381 .52533 Mdot
.02381 .54078 Mdot
.02381 .55623 Mdot
.02381 .57168 Mdot
.02381 .58713 Mdot
.02381 .60258 Mdot
.02381 .61803 Mdot
.11905 0 Mdot
.11905 .01545 Mdot
.11905 .0309 Mdot
.11905 .04635 Mdot
.11905 .0618 Mdot
.11905 .07725 Mdot
.11905 .09271 Mdot
.11905 .10816 Mdot
.11905 .12361 Mdot
.11905 .13906 Mdot
.11905 .15451 Mdot
.11905 .16996 Mdot
.11905 .18541 Mdot
.11905 .20086 Mdot
.11905 .21631 Mdot
.11905 .23176 Mdot
.11905 .24721 Mdot
.11905 .26266 Mdot
.11905 .27812 Mdot
.11905 .29357 Mdot
.11905 .30902 Mdot
.11905 .32447 Mdot
.11905 .33992 Mdot
.11905 .35537 Mdot
.11905 .37082 Mdot
.11905 .38627 Mdot
.11905 .40172 Mdot
.11905 .41717 Mdot
.11905 .43262 Mdot
.11905 .44807 Mdot
.11905 .46353 Mdot
.11905 .47898 Mdot
.11905 .49443 Mdot
.11905 .50988 Mdot
.11905 .52533 Mdot
.11905 .54078 Mdot
.11905 .55623 Mdot
.11905 .57168 Mdot
.11905 .58713 Mdot
.11905 .60258 Mdot
.11905 .61803 Mdot
.21429 0 Mdot
.21429 .01545 Mdot
.21429 .0309 Mdot
.21429 .04635 Mdot
.21429 .0618 Mdot
.21429 .07725 Mdot
.21429 .09271 Mdot
.21429 .10816 Mdot
.21429 .12361 Mdot
.21429 .13906 Mdot
.21429 .15451 Mdot
.21429 .16996 Mdot
.21429 .18541 Mdot
.21429 .20086 Mdot
.21429 .21631 Mdot
.21429 .23176 Mdot
.21429 .24721 Mdot
.21429 .26266 Mdot
.21429 .27812 Mdot
.21429 .29357 Mdot
.21429 .30902 Mdot
.21429 .32447 Mdot
.21429 .33992 Mdot
.21429 .35537 Mdot
.21429 .37082 Mdot
.21429 .38627 Mdot
.21429 .40172 Mdot
.21429 .41717 Mdot
.21429 .43262 Mdot
.21429 .44807 Mdot
.21429 .46353 Mdot
.21429 .47898 Mdot
.21429 .49443 Mdot
.21429 .50988 Mdot
.21429 .52533 Mdot
.21429 .54078 Mdot
.21429 .55623 Mdot
.21429 .57168 Mdot
.21429 .58713 Mdot
.21429 .60258 Mdot
.21429 .61803 Mdot
.30952 0 Mdot
.30952 .01545 Mdot
.30952 .0309 Mdot
.30952 .04635 Mdot
.30952 .0618 Mdot
.30952 .07725 Mdot
.30952 .09271 Mdot
.30952 .10816 Mdot
.30952 .12361 Mdot
.30952 .13906 Mdot
.30952 .15451 Mdot
.30952 .16996 Mdot
.30952 .18541 Mdot
.30952 .20086 Mdot
.30952 .21631 Mdot
.30952 .23176 Mdot
.30952 .24721 Mdot
.30952 .26266 Mdot
.30952 .27812 Mdot
.30952 .29357 Mdot
.30952 .30902 Mdot
.30952 .32447 Mdot
.30952 .33992 Mdot
.30952 .35537 Mdot
.30952 .37082 Mdot
.30952 .38627 Mdot
.30952 .40172 Mdot
.30952 .41717 Mdot
.30952 .43262 Mdot
.30952 .44807 Mdot
.30952 .46353 Mdot
.30952 .47898 Mdot
.30952 .49443 Mdot
.30952 .50988 Mdot
.30952 .52533 Mdot
.30952 .54078 Mdot
.30952 .55623 Mdot
.30952 .57168 Mdot
.30952 .58713 Mdot
.30952 .60258 Mdot
.30952 .61803 Mdot
.40476 0 Mdot
.40476 .01545 Mdot
.40476 .0309 Mdot
.40476 .04635 Mdot
.40476 .0618 Mdot
.40476 .07725 Mdot
.40476 .09271 Mdot
.40476 .10816 Mdot
.40476 .12361 Mdot
.40476 .13906 Mdot
.40476 .15451 Mdot
.40476 .16996 Mdot
.40476 .18541 Mdot
.40476 .20086 Mdot
.40476 .21631 Mdot
.40476 .23176 Mdot
.40476 .24721 Mdot
.40476 .26266 Mdot
.40476 .27812 Mdot
.40476 .29357 Mdot
.40476 .30902 Mdot
.40476 .32447 Mdot
.40476 .33992 Mdot
.40476 .35537 Mdot
.40476 .37082 Mdot
.40476 .38627 Mdot
.40476 .40172 Mdot
.40476 .41717 Mdot
.40476 .43262 Mdot
.40476 .44807 Mdot
.40476 .46353 Mdot
.40476 .47898 Mdot
.40476 .49443 Mdot
.40476 .50988 Mdot
.40476 .52533 Mdot
.40476 .54078 Mdot
.40476 .55623 Mdot
.40476 .57168 Mdot
.40476 .58713 Mdot
.40476 .60258 Mdot
.40476 .61803 Mdot
.5 0 Mdot
.5 .01545 Mdot
.5 .0309 Mdot
.5 .04635 Mdot
.5 .0618 Mdot
.5 .07725 Mdot
.5 .09271 Mdot
.5 .10816 Mdot
.5 .12361 Mdot
.5 .13906 Mdot
.5 .15451 Mdot
.5 .16996 Mdot
.5 .18541 Mdot
.5 .20086 Mdot
.5 .21631 Mdot
.5 .23176 Mdot
.5 .24721 Mdot
.5 .26266 Mdot
.5 .27812 Mdot
.5 .29357 Mdot
.5 .30902 Mdot
.5 .32447 Mdot
.5 .33992 Mdot
.5 .35537 Mdot
.5 .37082 Mdot
.5 .38627 Mdot
.5 .40172 Mdot
.5 .41717 Mdot
.5 .43262 Mdot
.5 .44807 Mdot
.5 .46353 Mdot
.5 .47898 Mdot
.5 .49443 Mdot
.5 .50988 Mdot
.5 .52533 Mdot
.5 .54078 Mdot
.5 .55623 Mdot
.5 .57168 Mdot
.5 .58713 Mdot
.5 .60258 Mdot
.5 .61803 Mdot
.59524 0 Mdot
.59524 .01545 Mdot
.59524 .0309 Mdot
.59524 .04635 Mdot
.59524 .0618 Mdot
.59524 .07725 Mdot
.59524 .09271 Mdot
.59524 .10816 Mdot
.59524 .12361 Mdot
.59524 .13906 Mdot
.59524 .15451 Mdot
.59524 .16996 Mdot
.59524 .18541 Mdot
.59524 .20086 Mdot
.59524 .21631 Mdot
.59524 .23176 Mdot
.59524 .24721 Mdot
.59524 .26266 Mdot
.59524 .27812 Mdot
.59524 .29357 Mdot
.59524 .30902 Mdot
.59524 .32447 Mdot
.59524 .33992 Mdot
.59524 .35537 Mdot
.59524 .37082 Mdot
.59524 .38627 Mdot
.59524 .40172 Mdot
.59524 .41717 Mdot
.59524 .43262 Mdot
.59524 .44807 Mdot
.59524 .46353 Mdot
.59524 .47898 Mdot
.59524 .49443 Mdot
.59524 .50988 Mdot
.59524 .52533 Mdot
.59524 .54078 Mdot
.59524 .55623 Mdot
.59524 .57168 Mdot
.59524 .58713 Mdot
.59524 .60258 Mdot
.59524 .61803 Mdot
.69048 0 Mdot
.69048 .01545 Mdot
.69048 .0309 Mdot
.69048 .04635 Mdot
.69048 .0618 Mdot
.69048 .07725 Mdot
.69048 .09271 Mdot
.69048 .10816 Mdot
.69048 .12361 Mdot
.69048 .13906 Mdot
.69048 .15451 Mdot
.69048 .16996 Mdot
.69048 .18541 Mdot
.69048 .20086 Mdot
.69048 .21631 Mdot
.69048 .23176 Mdot
.69048 .24721 Mdot
.69048 .26266 Mdot
.69048 .27812 Mdot
.69048 .29357 Mdot
.69048 .30902 Mdot
.69048 .32447 Mdot
.69048 .33992 Mdot
.69048 .35537 Mdot
.69048 .37082 Mdot
.69048 .38627 Mdot
.69048 .40172 Mdot
.69048 .41717 Mdot
.69048 .43262 Mdot
.69048 .44807 Mdot
.69048 .46353 Mdot
.69048 .47898 Mdot
.69048 .49443 Mdot
.69048 .50988 Mdot
.69048 .52533 Mdot
.69048 .54078 Mdot
.69048 .55623 Mdot
.69048 .57168 Mdot
.69048 .58713 Mdot
.69048 .60258 Mdot
.69048 .61803 Mdot
.78571 0 Mdot
.78571 .01545 Mdot
.78571 .0309 Mdot
.78571 .04635 Mdot
.78571 .0618 Mdot
.78571 .07725 Mdot
.78571 .09271 Mdot
.78571 .10816 Mdot
.78571 .12361 Mdot
.78571 .13906 Mdot
.78571 .15451 Mdot
.78571 .16996 Mdot
.78571 .18541 Mdot
.78571 .20086 Mdot
.78571 .21631 Mdot
.78571 .23176 Mdot
.78571 .24721 Mdot
.78571 .26266 Mdot
.78571 .27812 Mdot
.78571 .29357 Mdot
.78571 .30902 Mdot
.78571 .32447 Mdot
.78571 .33992 Mdot
.78571 .35537 Mdot
.78571 .37082 Mdot
.78571 .38627 Mdot
.78571 .40172 Mdot
.78571 .41717 Mdot
.78571 .43262 Mdot
.78571 .44807 Mdot
.78571 .46353 Mdot
.78571 .47898 Mdot
.78571 .49443 Mdot
.78571 .50988 Mdot
.78571 .52533 Mdot
.78571 .54078 Mdot
.78571 .55623 Mdot
.78571 .57168 Mdot
.78571 .58713 Mdot
.78571 .60258 Mdot
.78571 .61803 Mdot
.88095 0 Mdot
.88095 .01545 Mdot
.88095 .0309 Mdot
.88095 .04635 Mdot
.88095 .0618 Mdot
.88095 .07725 Mdot
.88095 .09271 Mdot
.88095 .10816 Mdot
.88095 .12361 Mdot
.88095 .13906 Mdot
.88095 .15451 Mdot
.88095 .16996 Mdot
.88095 .18541 Mdot
.88095 .20086 Mdot
.88095 .21631 Mdot
.88095 .23176 Mdot
.88095 .24721 Mdot
.88095 .26266 Mdot
.88095 .27812 Mdot
.88095 .29357 Mdot
.88095 .30902 Mdot
.88095 .32447 Mdot
.88095 .33992 Mdot
.88095 .35537 Mdot
.88095 .37082 Mdot
.88095 .38627 Mdot
.88095 .40172 Mdot
.88095 .41717 Mdot
.88095 .43262 Mdot
.88095 .44807 Mdot
.88095 .46353 Mdot
.88095 .47898 Mdot
.88095 .49443 Mdot
.88095 .50988 Mdot
.88095 .52533 Mdot
.88095 .54078 Mdot
.88095 .55623 Mdot
.88095 .57168 Mdot
.88095 .58713 Mdot
.88095 .60258 Mdot
.88095 .61803 Mdot
.97619 0 Mdot
.97619 .01545 Mdot
.97619 .0309 Mdot
.97619 .04635 Mdot
.97619 .0618 Mdot
.97619 .07725 Mdot
.97619 .09271 Mdot
.97619 .10816 Mdot
.97619 .12361 Mdot
.97619 .13906 Mdot
.97619 .15451 Mdot
.97619 .16996 Mdot
.97619 .18541 Mdot
.97619 .20086 Mdot
.97619 .21631 Mdot
.97619 .23176 Mdot
.97619 .24721 Mdot
.97619 .26266 Mdot
.97619 .27812 Mdot
.97619 .29357 Mdot
.97619 .30902 Mdot
.97619 .32447 Mdot
.97619 .33992 Mdot
.97619 .35537 Mdot
.97619 .37082 Mdot
.97619 .38627 Mdot
.97619 .40172 Mdot
.97619 .41717 Mdot
.97619 .43262 Mdot
.97619 .44807 Mdot
.97619 .46353 Mdot
.97619 .47898 Mdot
.97619 .49443 Mdot
.97619 .50988 Mdot
.97619 .52533 Mdot
.97619 .54078 Mdot
.97619 .55623 Mdot
.97619 .57168 Mdot
.97619 .58713 Mdot
.97619 .60258 Mdot
.97619 .61803 Mdot
.8 0 1 r
.015 w
.02381 .46353 Mdot
.07143 .46353 Mdot
.11905 .46353 Mdot
.21429 .46353 Mdot
.40476 .46353 Mdot
.5 .46353 Mdot
.69048 .46353 Mdot
.7381 .46353 Mdot
.78571 .46353 Mdot
.83333 .46353 Mdot
.88095 .46353 Mdot
.89048 .46353 Mdot
.9 .46353 Mdot
.90952 .46353 Mdot
.97619 .46353 Mdot
.02381 .30902 Mdot
.16667 .30902 Mdot
.69048 .30902 Mdot
.88095 .30902 Mdot
.02381 .15451 Mdot
.16667 .15451 Mdot
.54762 .15451 Mdot
.88095 .15451 Mdot
.97619 .15451 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{555.75, 343.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008[0001Eb000`400?l00000o`00003ooooooooo
ooooobgooooo003ooooooooooooo;Oooool00?ooooooooooool]ooooo`00ooooooooooooobgooooo
003ooooooooooooo;Oooool00?ooooooooooool]ooooo`00ooooooooooooobgooooo000Qooooo`;o
0000GOooool5o`0005kooooo0ol0001Mooooo`?o0000Goooool3o`0005_ooooo0ol00004ooooo`;o
00007oooool0023ooooo00Co0000oooooooooooo0000GOooool01?l0003oooooooooool0001Ooooo
o`03o`000?oooooooooo05_ooooo00Go0000ooooooooooooooooo`00001Mooooo`05o`000?oooooo
ooooooooool00000Foooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001kooooo
000Pooooo`04o`000?ooooooooooo`0005kooooo00?o0000ooooooooool0G?ooool5o`0005cooooo
00Go0000ooooooooooooooooo`00001Mooooo`05o`000?ooooooooooooooool00000Foooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0001kooooo000Pooooo`04o`000?oooooooooo
o`0005oooooo00?o0000ooooooooool0Foooool01?l0003oooooooooool0001Mooooo`Co0000Gooo
ool3o`0005cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Nooooo`008?oo
ool01?l0003oooooooooool0001Looooo`05o`000?ooooooooooooooool00000GOooool00ol0003o
ooooo`00001Mooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`00001Koooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00007_ooool0023ooooo00Co0000oooo
oooooooo0000G?ooool01Ol0003ooooooooooooooooo000005kooooo0_l0001Nooooo`03o`000?oo
oooooooo05kooooo00Go0000ooooooooooooooooo`00001Jooooo`;o00001?ooool01?l0003ooooo
ooooool0000Nooooo`008Oooool2o`0005kooooo0ol0001Pooooo`03o`000?oooooooooo05gooooo
0_l0001Oooooo`?o0000G?ooool00ol0003oooooooooo`03ooooo`;o00007oooool00?oooooooooo
ool]ooooo`00ooooooooooooobgooooo003ooooooooooooo;Oooool00?ooooooooooool]ooooo`00
ooooooooooooobgooooo003ooooooooooooo;Oooool00?ooooooooooool]ooooo`005_ooool<o`00
0003o`00ool0003o000000;o000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`00
0003o`00ool0003o000000;o000000?o003oo`000?l000000_l000001Ol00?oo0000o`000?l0003o
003o00Co000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`000003o`00ool0003o
000000;o000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`000005o`00ool0003o
0000o`000?l00?l01?l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000?o
003oo`000?l000000_l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000Go
003oo`000?l0003o0000o`00o`04o`000003o`00ool0003o000000;o000000?o003oo`000?l00000
0_l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000?o003oo`000?l00000
0_l000001Ol00?oo0000o`000?l0003o003o00Co000000?o003oo`000?l000000_l000000ol00?oo
0000o`000002o`000003o`00ool0003o000000;o000000?o003oo`000?l000000_l000000ol00?oo
0000o`000002o`000005o`00ool0003o0000o`000?l00?l01?l000000ol00?oo0000o`000002o`00
0003o`00ool0003o000000;o000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`00
0003o`00ool0003o000000;o000000Go003oo`000?l0003o0000o`00o`04o`000003o`00ool0003o
000000;o000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`000003o`00ool0003o
000000;o000000?o003oo`000?l000000_l000001Ol00?oo0000o`000?l0003o003o00Co000000?o
003oo`000?l000000_l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000?o
003oo`000?l000000_l000000ol00?oo0000o`000002o`000005o`00ool0003o0000o`000?l00?l0
1?l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000?o003oo`000?l00000
0_l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000Go003oo`000?l0003o
0000o`00o`04o`000003o`00ool0003o000000;o000000?o003oo`000?l000000_l000000ol00?oo
0000o`000002o`000003o`00ool0003o000000;o000000?o003oo`000?l000000_l000001Ol00?oo
0000o`000?l0003o003o00Co000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`00
0003o`00ool0003o000000;o000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`00
0005o`00ool0003o0000o`000?l00?l01?l000000ol00?oo0000o`000002o`000003o`00ool0003o
000000;o000000?o003oo`000?l000000_l000000ol00?oo0000o`000002o`000003o`00ool0003o
000000;o000000Go003oo`000?l0003o0000o`00o`04o`000003o`00ool0003o000000;o000000?o
003oo`000?l000000_l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000?o
003oo`000?l000000_l000001Ol00?oo0000o`000?l0003o003o00Co000000?o003oo`000?l00000
0_l000000ol00?oo0000o`000002o`000003o`00ool0003o000000;o000000?o003oo`000?l00000
0_l000000ol00?oo0000o`000002o`000005o`00ool0003o0000o`000?l00?l01?l000000ol00?oo
0000o`000002o`000003o`00ool0003o000000;o000000?o003oo`000?l000002_l0000Fooooo`00
5_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1Nooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool0G_ooool0
0ol0003oooooooooo`1Oooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
05kooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo
05oooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`00
5_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o
0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo00Wooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooo
oooo02kooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooo
oooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooo
oooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooo
oooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Doooo
o`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oo
oooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3o
oooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooooloooo
o`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003o
ooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo
00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo
00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo
00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo
00?o003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooool
ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0
003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool0
0ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooo
ooooool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003ooooo
ooooool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003ooooo
ooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003ooooo
ooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo00Wooooo00?o0000oooo
ooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Co
oooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000
ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo
0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3oooooooco
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003oooooooooool0;_oo
ool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;_oo
ool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Ooo
ool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_oo
ool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooo
oocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03
o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?oo
ool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Foooo
o`03o`000?oooooooooo00Wooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]oooo
o`03o`00oooooooooooo02kooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]oooo
o`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^oooo
o`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`09oooo
o`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003o
ooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool0
5?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0
003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooooooo
ool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oooooo
o?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00oooo
oooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooo
oooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooo
oooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooo
oooooooo02kooooo00?o003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_ooool0
0ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooo
ooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oo
ooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oo
oooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0D
ooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Ko
oooo00?o0000ooooooooool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02go
oooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02go
oooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02ko
oooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo00Wo
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooooooo
o`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool0
01Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03
o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooo
ooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooo
ooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003o
ooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Foooo
o`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003o
ooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0
ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000
ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`00
5_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0
;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
2Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o
0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooo
oooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Doooo
o`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool02?ooool3ol`0odKooooo0oo<0?noooooo`?oc03oYoooool3ol`0obgooooo
0oo<0?l;ooooo`03o`000?oooooooooo01Cooooo0008ooooo`;o000000?oooooo`000?l000002Ooo
ool00ol0003oooooooooo`07ooooo`Goc03oA?ooool5ol`0okgooooo1Oo<0?nUooooo`Goc03o:ooo
ool5ol`0o`[ooooo00?o0000ooooooooool01Oooool2o`000003ooooool0003o000000[ooooo0009
ooooo`03o`000?oooooo000000[ooooo00?o0000ooooooooool01_ooool7ol`0od;ooooo1oo<0?nk
ooooo`Ooc03oXoooool7ol`0obWooooo1oo<0?l9ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooool000002oooool000[ooooo00?o0000ooooooooool02Oooool4o`0000Gooooo1oo<0?l00ooo
oooo003oooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooo
ooooc03o00Koc03o00?oooooo`00ooooool00oooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003ooooooooo
ool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooooooo
ool00_ooool00ol00?ooooooooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooo
oooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00ooo<
0?ooc03o00Goc03o00?oooooo`00ooooool00oooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`05o`00oooo
ooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo
00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo00?o003ooooooooo
ool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooooooo
ool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00?o003ool`0ooo<0?l01Oo<0?l00ooooooo003oooooo`03
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooo
oooooooo00;ooooo00?o003ool`0ooo<0?l01Oo<0?l6ooooo`Co00002Oooool00ol0003ooooooooo
o`0:ooooo`002Oooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo00Kooooo1oo<0?m2
ooooo`Ooc03o^oooool7ol`0oj?ooooo1oo<0?lYooooo`Ooc03o2Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooo000000_ooooo0008ooooo`;o000000?oooooo`000?l000002Oooool00ol0
003oooooooooo`07ooooo`Goc03oA?ooool5ol`0okgooooo1Oo<0?nUooooo`Goc03o:oooool5ol`0
o`[ooooo00?o0000ooooooooool01Oooool2o`000003ooooool0003o000000[ooooo000Fooooo`03
o`000?oooooooooo00Sooooo0oo<0?m6ooooo`?oc03o_oooool3ol`0ojOooooo0oo<0?l]ooooo`?o
c03o2oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oo
oooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0D
ooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Ko
oooo00?o0000ooooooooool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02go
oooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02go
oooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02ko
oooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo00Wo
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooooooo
o`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool0
01Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03
o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooo
ooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooo
ooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003o
ooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Foooo
o`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003o
ooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0
ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000
ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`00
5_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0
;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
2Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o
0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooo
oooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Doooo
o`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oo
oooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09
ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^
ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^
ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]
ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool02Oooool00ol0003oooooooooo`0D
ooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Ko
oooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`00
0?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooool
ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0
003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00
oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00
oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00
oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00
oooooooooooo00Wooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooo
ooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool0
0ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooo
ooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Co
oooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000
ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo
00Wooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo
02kooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo
02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo
02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`00
5_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o
0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooo
oocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03
o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o
003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o
003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o
003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o
003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3o
oooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooooloooo
o`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003o
ooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool0
5?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0
003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooooooo
ool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003ooooooooo
ool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003ooooooooo
ool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003ooooooooo
ool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo00Wooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool0
0ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooo
ooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oo
ooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oo
oooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003oooooooooool0;_ooool0
0ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;_ooool0
0ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool0
0ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool0
0ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo
0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3oooooooco
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`00
0?oooooooooo01Cooooo0002ooooo`?o00004Oooool00ol0003oooooooooo`3ooooooocooooo00?o
0000ooooooooool01Oooool3o`0000cooooo0003ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool02?ooool3ol`0odKooooo0oo<0?ooooooo`Wooooo0oo<0?mNooooo`?oc03o>oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00_ooooo0004ooooo`04o`000?oooooooooo
ooooo`Go00002Oooool00ol0003oooooooooo`07ooooo`Goc03oA?ooool5ol`0oooooooo1oooool5
ol`0oecooooo1Oo<0?ljooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooooooo1Ol0
0004ooooo`001?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Wooooo00?o
0000ooooooooool01_ooool7ol`0od;ooooo1oo<0?ooooooo`Gooooo1oo<0?mJooooo`Ooc03o>Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool000?ooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`09ooooo`Co00001Ooo
ool7ol`0o`03ooooool00?oooooo00?ooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Co
oooo00?o003oooooooo<0?l01_o<0?l00ooooooo003oooooo`03ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool0
0ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00
o`04ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool01Ol00?oooooooooo
oooooooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`05o`00
ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;o
oooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`02ooooo`06o`00ooooooooooooooooool00?oooooo1oo<0?l00ooooooo003o
ooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo
00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00;ooooo00?o003oooooooooool00_ooool00ol00?ooc03ool`0o`05ol`0o`03ooooool00?oooooo
00?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00;ooooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Kooooo1?l00008
ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool01?ooool000?ooooo00?o0000oooo
ool000001Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo1oo<0?m2oooo
o`Ooc03oooooool5ooooo`Ooc03oF_ooool7ol`0ocWooooo00?o0000ooooooooool01_ooool00ol0
003oooooo`000005ooooo`03o`000?oooooooooo00?ooooo0002ooooo`;o000000Goooooo`000?l0
003oooooo`000003ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool5ol`0
odCooooo1Oo<0?ooooooo`Oooooo1Oo<0?mLooooo`Goc03o>_ooool00ol0003oooooooooo`05oooo
o`;o000000Goooooo`000?l0003oooooo`000003ooooo`03o`000?oooooooooo00;ooooo0008oooo
o`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`08ooooo`?oc03oA_ooool3
ol`0oooooooo2Oooool3ol`0oekooooo0oo<0?lkooooo`03o`000?oooooooooo00_ooooo00Go0000
ooooooooooooooooo`000004ooooo`002Oooool3o`0000[ooooo00?o0000ooooooooool0oooooool
ooooo`03o`000?oooooooooo00cooooo0ol00005ooooo`005_ooool00ol0003oooooooooo`3ooooo
oocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03
o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o
003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o
003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o
003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o
003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3o
oooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooooloooo
o`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003o
ooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool0
5?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0
003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol0
0?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol0
0?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol0
0?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool02Oooool00ol0
003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool0
0ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooo
ooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oo
ooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool02Oooool00ol00?oooooooooo
o`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?oooooooooo
o`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?oooooooooo
o`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?oooooooooo
o`0^ooooo`03o`00oooooooooooo00Wooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000
ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo
0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3oooooooco
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooooooo
o`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool0
01Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03
o`000?oooooooooo00Wooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03
o`00oooooooooooo02kooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03
o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03
o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`09ooooo`03
o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?oo
ool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Foooo
o`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003o
ooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0
ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooo
oooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooo
oooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooo
oooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooo
oooo02kooooo00?o003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0
003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooooooo
ool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oooooo
o?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o
0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooo
oooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Doooo
o`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo
00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo
00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo
00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo00Wooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oo
oooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0D
ooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Ko
oooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`00
0?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooool
ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003ooooo
ooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003ooooo
ooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003ooooo
ooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003ooooo
ooooool0;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03
o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooo
ooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooo
ooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool0
0ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooo
ooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Co
oooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Ooo
ool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Ooo
ool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_oo
ool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool02Ooo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000
ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`00
5_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o
0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooo
oocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool02Oooool00ol00?oo
ooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?oo
ooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?oo
ooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?oo
ooooooooo`0^ooooo`03o`00oooooooooooo00Wooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oo
oooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3o
oooooocooooo00?o0000ooooooooool05?ooool000;ooooo0ol0000Aooooo`03o`000?oooooooooo
0?ooooooo?ooool00ol0003oooooooooo`05ooooo`?o00003?ooool000?ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`08ooooo`?oc03o5Oooool3ol`0oaGooooo0oo<0?l^ooooo`?o
c03oG_ooool3ol`0obkooooo0oo<0?mNooooo`?oc03o5Oooool3ol`0oaGooooo0oo<0?lFooooo`?o
c03o5Oooool3ol`0o`;ooooo0oo<0?l2ooooo`?oc03o00Cooooool`0ooo<0?ooc03o7oooool3ol`0
o`_ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0;ooooo`001?ooool00ol0003o
ooooooooo`02ooooo`?o00002_ooool00ol0003oooooooooo`07ooooo`Goc03o4oooool5ol`0oa?o
oooo1Oo<0?l/ooooo`Goc03oG?ooool5ol`0obcooooo1Oo<0?mLooooo`Goc03o4oooool5ol`0oa?o
oooo1Oo<0?lDooooo`Goc03o4ooooolCol`0oagooooo1Oo<0?l:ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool00_ooool3o`0000Gooooo0004ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`Ooc03o00?oooooo`00ooooool0
0oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ool`0ooo<0?l0
1Oo<0?l00ooooooo003oooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool0
0_ooool00ol00?ooc03ool`0o`05ol`0o`;ooooo00?o003oooooooooool00_ooool01Ol00?oooooo
oooooooooooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03
o`00ooo<0?ooc03o00Goc03o00?oooooo`00ooooool00oooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`05
o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003o
ol`0ooo<0?l01Oo<0?l00ooooooo003oooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003o
ooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooo<0?l01_o<
0?l00ooooooo003oooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_oo
ool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00Ko003oooooooooooooooooo`00ooooool7ol`0o`03ooooool00?oo
oooo00?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00ooo<0?oo
c03o00Goc03o00?oooooo`00ooooool00oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo
oooo00;ooooo00?o003ool`0ooo<0?l01Oo<0?l2ooooo`03o`00oooooooooooo00;ooooo00Go003o
ooooooooooooooooo`00o`04ooooo`03o`00ooooooooc03o00Koc03o00?oooooo`00ooooool00ooo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ool`0ooo<0?l04oo<
0?l2ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool01Ol00?oooooooooo
oooooooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?ooc03ool`0o`05ol`0o`Wooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
0003ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool02Oooool4o`0000Gooooo1oo<
0?lAooooo`Ooc03o4Oooool7ol`0ob[ooooo1oo<0?mJooooo`Ooc03o:_ooool7ol`0oe[ooooo1oo<
0?lAooooo`Ooc03o4Oooool7ol`0oa;ooooo1oo<0?lAoooooaGoc03o6oooool7ol`0o`Kooooo1?l0
0008ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool01?ooool000?ooooo00?o0000
ooooool000001?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Kooooo1oo<0?lA
ooooo`Ooc03o4Oooool7ol`0ob[ooooo1oo<0?mJooooo`Ooc03o:_ooool7ol`0oe[ooooo1oo<0?lA
ooooo`Ooc03o4Oooool7ol`0oa;ooooo1oo<0?lAoooooaGoc03o6oooool7ol`0o`Wooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00Cooooo0002oooo
o`;o000000?oooooo`000?l000000oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Oooooo1Oo<0?lCooooo`Goc03o4oooool5ol`0obcooooo1Oo<0?mLooooo`Goc03o;?ooool5ol`0
oecooooo1Oo<0?lCooooo`Goc03o4oooool5ol`0oaCooooo1Oo<0?lCoooooa?oc03o7Oooool5ol`0
o`[ooooo00?o0000ooooooooool01Oooool2o`000003ooooool0003o000000?ooooo00?o0000oooo
ooooool01?ooool000Wooooo0_l0000;ooooo`03o`000?oooooooooo00Sooooo0oo<0?lEooooo`?o
c03o5Oooool3ol`0obkooooo0oo<0?mNooooo`?oc03o;_ooool3ol`0oekooooo0oo<0?lEooooo`?o
c03o5Oooool3ol`0oaKooooo0oo<0?lEooooo`?oc03o0_ooool3ol`0o`;ooooo0oo<0?l01?oooooo
c03ool`0ooo<0?lOooooo`?oc03o2oooool00ol0003oooooooooo`0<ooooo`;o00001_ooool000[o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`04ooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oo
oooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003oooooooooool0;_ooool0
0ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;_ooool0
0ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool0
0ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool0
0ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo
0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3oooooooco
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003ooooooooo
o`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool0
01Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03
o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooo
ooooo`09ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?oooooo
ooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?oooooo
ooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?oooooo
ooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool02Oooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?oo
ool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Foooo
o`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003o
ooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0
ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000
ooooooooool05?ooool001Kooooo00?o0000ooooooooool02Oooool00ol00?ooooooooooo`0^oooo
o`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0^oooo
o`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]oooo
o`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^oooo
o`03o`00oooooooooooo00Wooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooooooo
ool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oooooo
o?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o
0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooo
oooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Doooo
o`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oo
oooooooo00Wooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooo
oooooooo02kooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooo
oooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooo
oooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oo
oooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0D
ooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Ko
oooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`00
0?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooool
ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0
003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00oooooooooooo02ko
oooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02ko
oooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02go
oooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02ko
oooo00?o003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooo
ooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooo
ooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool0
0ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooo
ooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Co
oooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000
ooooooooool02Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003o
ooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003o
ooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo00Wooooo00?o0000
ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`00
5_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o
0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooo
oocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03
o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo00Wooooo00?o003oooooooooool0
;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
;_ooool00ol00?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0
;Oooool00ol00?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0
;_ooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oo
oooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3o
oooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0oooooooloooo
o`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003o
ooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool0
5?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0
003oooooooooo`09ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol0
0?ooooooooooo`0^ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol0
0?ooooooooooo`0^ooooo`03o`00oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol0
0?ooooooooooo`0]ooooo`03o`00oooooooooooo02kooooo00?o003oooooooooool02Oooool00ol0
003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3ooooooocooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool0
0ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooo
ooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo0?oo
ooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`00
oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00
oooooooooooo02kooooo00?o003oooooooooool0;Oooool00ol00?ooooooooooo`0^ooooo`03o`00
oooooooooooo02gooooo00?o003oooooooooool0;_ooool00ol00?ooooooooooo`0]ooooo`03o`00
oooooooooooo02kooooo00?o003oooooooooool02Oooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`3ooooooocooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000
ooooooooool0ooooooolooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo
0?ooooooo?ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`3oooooooco
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`1Nooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool0G_ooool00ol0003ooooo
ooooo`1Oooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05kooooo00?o
0000ooooooooool0G_ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo05oooooo00?o
0000ooooooooool0G_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000oooo
ooooool02Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`02ooooo`06o`00ooooooooooooooooool0003o003o0ooo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_oo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_oo
ool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool01_l00?oooooooooooooooooo0000
o`00o`Cooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool00_ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooooool0
0_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool0
0_ooool01_l00?oooooooooooooooooo0000o`00o`?ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool01Ol00?oooooooooooooo
oooo003o00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooo
oooooooo00;ooooo00Ko003oooooooooooooooooo`000?l00?l4ooooo`05o`00oooooooooooooooo
ool00?l01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Go003ooooo
ooooooooooooo`00o`04ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Ko003oooooooooooooooooo`00
0?l00?l3ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`05o`00ooooooooooooooooool00?l01?ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo
00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`06o`00oooooooooooo
ooooool0003o003o1?ooool01Ol00?oooooooooooooooooo003o00Cooooo00?o003oooooooooool0
0_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Wooooo00?o0000ooooooooool0
5?ooool001Koooooool0003oo`00007o00005_ooool00?ooooooooooool]ooooo`00oooooooooooo
obgooooo003ooooooooooooo;Oooool00?ooooooooooool]ooooo`00ooooooooooooobgooooo0000
\
\>"],
  ImageRangeCache->{{{0, 554.75}, {342.5, 0}} -> {-0.710719, -0.270836, \
0.0205884, 0.0126906}}]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{43, 1440}, {0, 878}},
AutoGeneratedPackage->None,
WindowToolbars->{},
WindowSize->{911, 770},
WindowMargins->{{16, Automatic}, {Automatic, 5}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
StyleDefinitions -> "Default.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3417329337-2384477"->{
    Cell[6301, 194, 105, 2, 22, "Print",
      CellTags->"Info3417329337-2384477"],
    Cell[6409, 198, 643, 16, 23, "Print",
      CellTags->"Info3417329337-2384477"]},
  "Info3417329866-9092711"->{
    Cell[2428748, 62876, 120, 2, 22, "Print",
      CellTags->"Info3417329866-9092711"],
    Cell[2428871, 62880, 797, 19, 83, "Print",
      CellTags->"Info3417329866-9092711"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3417329337-2384477", 2516109, 65251},
  {"Info3417329866-9092711", 2516309, 65256}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 80, 1, 26, "Input"],
Cell[1837, 54, 1524, 26, 341, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3386, 84, 61, 1, 69, "Section"],
Cell[3450, 87, 62, 1, 26, "Input"],

Cell[CellGroupData[{
Cell[3537, 92, 62, 1, 26, "Input"],
Cell[3602, 95, 306, 4, 21, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3957, 105, 58, 1, 69, "Section"],

Cell[CellGroupData[{
Cell[4040, 110, 1307, 60, 796, "Input",
  InitializationCell->True],
Cell[5350, 172, 676, 9, 86, "Output"],
Cell[6029, 183, 174, 3, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6240, 191, 58, 1, 26, "Input"],
Cell[6301, 194, 105, 2, 22, "Print",
  CellTags->"Info3417329337-2384477"],
Cell[6409, 198, 643, 16, 23, "Print",
  CellTags->"Info3417329337-2384477"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7089, 219, 81, 1, 26, "Input"],
Cell[7173, 222, 7822, 194, 129, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15032, 421, 182, 6, 68, "Input"],
Cell[15217, 429, 7149, 188, 181, "Output"],
Cell[22369, 619, 34893, 834, 401, "Output"],
Cell[57265, 1455, 5113, 133, 129, "Output"],
Cell[62381, 1590, 7822, 194, 129, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[70252, 1790, 86, 2, 39, "Section"],

Cell[CellGroupData[{
Cell[70363, 1796, 43, 0, 36, "Subsection"],
Cell[70409, 1798, 558, 12, 432, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[71004, 1815, 41, 0, 36, "Subsection"],

Cell[CellGroupData[{
Cell[71070, 1819, 463, 13, 124, "Input",
  InitializationCell->True],
Cell[71536, 1834, 584, 10, 41, "Output"],
Cell[72123, 1846, 46, 1, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[72218, 1853, 32, 0, 36, "Subsection"],
Cell[72253, 1855, 277, 10, 82, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[72555, 1869, 366, 9, 96, "Input"],
Cell[72924, 1880, 181, 3, 22, "Print"],
Cell[73108, 1885, 82073, 2472, 182, 30985, 1836, "GraphicsData", \
"PostScript", "Graphics"],
Cell[155184, 4359, 130, 3, 26, "Output"],
Cell[155317, 4364, 181, 3, 22, "Print"],
Cell[155501, 4369, 93194, 2609, 182, 31010, 1836, "GraphicsData", \
"PostScript", "Graphics"],
Cell[248698, 6980, 130, 3, 26, "Output"],
Cell[248831, 6985, 181, 3, 22, "Print"],
Cell[249015, 6990, 129530, 3086, 182, 31373, 1869, "GraphicsData", \
"PostScript", "Graphics"],
Cell[378548, 10078, 130, 3, 26, "Output"],
Cell[378681, 10083, 181, 3, 22, "Print"],
Cell[378865, 10088, 127388, 3059, 182, 31378, 1869, "GraphicsData", \
"PostScript", "Graphics"],
Cell[506256, 13149, 130, 3, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[506423, 13157, 501, 11, 138, "Input",
  InitializationCell->True],
Cell[506927, 13170, 128, 2, 26, "Output"],
Cell[507058, 13174, 55, 1, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[507162, 13181, 63, 0, 36, "Subsection"],
Cell[507228, 13183, 374, 13, 124, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[507627, 13200, 159, 5, 26, "Input"],
Cell[507789, 13207, 179, 3, 22, "Print"],
Cell[507971, 13212, 44536, 1072, 182, 9522, 635, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[552544, 14289, 163, 5, 26, "Input"],
Cell[552710, 14296, 179, 3, 22, "Print"],
Cell[552892, 14301, 43220, 1056, 182, 9518, 635, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[596149, 15362, 165, 5, 26, "Input"],
Cell[596317, 15369, 179, 3, 22, "Print"],
Cell[596499, 15374, 43108, 1055, 182, 9503, 635, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[639644, 16434, 321, 8, 82, "Input"],
Cell[639968, 16444, 179, 3, 22, "Print"],
Cell[640150, 16449, 57334, 1452, 182, 14705, 921, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[697545, 17908, 78, 2, 69, "Section"],

Cell[CellGroupData[{
Cell[697648, 17914, 674, 15, 334, "Input",
  InitializationCell->True],
Cell[698325, 17931, 99, 2, 22, "Print"],
Cell[698427, 17935, 99, 2, 22, "Print"],
Cell[698529, 17939, 99, 2, 22, "Print"],
Cell[698631, 17943, 51, 1, 22, "Print"],
Cell[698685, 17946, 879, 18, 33, "Print"],
Cell[699567, 17966, 45, 1, 22, "Print"],
Cell[699615, 17969, 242, 5, 22, "Print"],
Cell[699860, 17976, 193, 4, 22, "Print"],
Cell[700056, 17982, 245, 5, 22, "Print"],
Cell[700304, 17989, 218, 4, 24, "Print"],
Cell[700525, 17995, 2773, 57, 141, "Print"],
Cell[703301, 18054, 272, 5, 22, "Print"],
Cell[703576, 18061, 102, 2, 22, "Print"],
Cell[703681, 18065, 161, 3, 22, "Print"],
Cell[703845, 18070, 824, 18, 22, "Print"],
Cell[704672, 18090, 824, 18, 22, "Print"],
Cell[705499, 18110, 45, 1, 22, "Print"],
Cell[705547, 18113, 760, 17, 22, "Print"],
Cell[706310, 18132, 410, 10, 22, "Print"],
Cell[706723, 18144, 45, 1, 22, "Print"],
Cell[706771, 18147, 1368, 31, 141, "Print"],
Cell[708142, 18180, 53, 1, 22, "Print"],
Cell[708198, 18183, 9758, 266, 125, "Print"],
Cell[717959, 18451, 273, 5, 22, "Print"],
Cell[718235, 18458, 102, 2, 22, "Print"],
Cell[718340, 18462, 161, 3, 22, "Print"],
Cell[718504, 18467, 824, 18, 22, "Print"],
Cell[719331, 18487, 824, 18, 22, "Print"],
Cell[720158, 18507, 824, 18, 22, "Print"],
Cell[720985, 18527, 45, 1, 22, "Print"],
Cell[721033, 18530, 760, 17, 22, "Print"],
Cell[721796, 18549, 412, 10, 22, "Print"],
Cell[722211, 18561, 45, 1, 22, "Print"],
Cell[722259, 18564, 1495, 33, 141, "Print"],
Cell[723757, 18599, 53, 1, 22, "Print"],
Cell[723813, 18602, 11329, 266, 125, "Print"],
Cell[735145, 18870, 272, 5, 22, "Print"],
Cell[735420, 18877, 102, 2, 22, "Print"],
Cell[735525, 18881, 161, 3, 22, "Print"],
Cell[735689, 18886, 824, 18, 22, "Print"],
Cell[736516, 18906, 45, 1, 22, "Print"],
Cell[736564, 18909, 760, 17, 22, "Print"],
Cell[737327, 18928, 412, 10, 22, "Print"],
Cell[737742, 18940, 45, 1, 22, "Print"],
Cell[737790, 18943, 1541, 35, 141, "Print"],
Cell[739334, 18980, 53, 1, 22, "Print"],
Cell[739390, 18983, 11310, 266, 125, "Print"],
Cell[750703, 19251, 271, 5, 22, "Print"],
Cell[750977, 19258, 102, 2, 22, "Print"],
Cell[751082, 19262, 161, 3, 22, "Print"],
Cell[751246, 19267, 824, 18, 22, "Print"],
Cell[752073, 19287, 824, 18, 22, "Print"],
Cell[752900, 19307, 824, 18, 22, "Print"],
Cell[753727, 19327, 45, 1, 22, "Print"],
Cell[753775, 19330, 760, 17, 22, "Print"],
Cell[754538, 19349, 412, 10, 22, "Print"],
Cell[754953, 19361, 45, 1, 22, "Print"],
Cell[755001, 19364, 1510, 32, 141, "Print"],
Cell[756514, 19398, 53, 1, 22, "Print"],
Cell[756570, 19401, 11271, 266, 125, "Print"],
Cell[767844, 19669, 267, 5, 22, "Print"],
Cell[768114, 19676, 102, 2, 22, "Print"],
Cell[768219, 19680, 161, 3, 22, "Print"],
Cell[768383, 19685, 824, 18, 22, "Print"],
Cell[769210, 19705, 824, 18, 22, "Print"],
Cell[770037, 19725, 45, 1, 22, "Print"],
Cell[770085, 19728, 760, 17, 22, "Print"],
Cell[770848, 19747, 414, 10, 22, "Print"],
Cell[771265, 19759, 45, 1, 22, "Print"],
Cell[771313, 19762, 1515, 32, 141, "Print"],
Cell[772831, 19796, 53, 1, 22, "Print"],
Cell[772887, 19799, 11273, 266, 125, "Print"],
Cell[784163, 20067, 268, 5, 22, "Print"],
Cell[784434, 20074, 102, 2, 22, "Print"],
Cell[784539, 20078, 161, 3, 22, "Print"],
Cell[784703, 20083, 45, 1, 22, "Print"],
Cell[784751, 20086, 760, 17, 22, "Print"],
Cell[785514, 20105, 412, 10, 22, "Print"],
Cell[785929, 20117, 45, 1, 22, "Print"],
Cell[785977, 20120, 1536, 34, 141, "Print"],
Cell[787516, 20156, 53, 1, 22, "Print"],
Cell[787572, 20159, 11301, 266, 125, "Print"],
Cell[798876, 20427, 270, 5, 22, "Print"],
Cell[799149, 20434, 102, 2, 22, "Print"],
Cell[799254, 20438, 161, 3, 22, "Print"],
Cell[799418, 20443, 45, 1, 22, "Print"],
Cell[799466, 20446, 760, 17, 22, "Print"],
Cell[800229, 20465, 412, 10, 22, "Print"],
Cell[800644, 20477, 45, 1, 22, "Print"],
Cell[800692, 20480, 1523, 32, 141, "Print"],
Cell[802218, 20514, 53, 1, 22, "Print"],
Cell[802274, 20517, 11258, 266, 125, "Print"],
Cell[813535, 20785, 269, 5, 22, "Print"],
Cell[813807, 20792, 102, 2, 22, "Print"],
Cell[813912, 20796, 161, 3, 22, "Print"],
Cell[814076, 20801, 824, 18, 22, "Print"],
Cell[814903, 20821, 45, 1, 22, "Print"],
Cell[814951, 20824, 760, 17, 22, "Print"],
Cell[815714, 20843, 414, 10, 22, "Print"],
Cell[816131, 20855, 45, 1, 22, "Print"],
Cell[816179, 20858, 1526, 33, 141, "Print"],
Cell[817708, 20893, 53, 1, 22, "Print"],
Cell[817764, 20896, 11269, 266, 125, "Print"],
Cell[829036, 21164, 266, 5, 22, "Print"],
Cell[829305, 21171, 102, 2, 22, "Print"],
Cell[829410, 21175, 161, 3, 22, "Print"],
Cell[829574, 21180, 820, 18, 22, "Print"],
Cell[830397, 21200, 45, 1, 22, "Print"],
Cell[830445, 21203, 756, 17, 22, "Print"],
Cell[831204, 21222, 412, 10, 22, "Print"],
Cell[831619, 21234, 45, 1, 22, "Print"],
Cell[831667, 21237, 1517, 32, 141, "Print"],
Cell[833187, 21271, 53, 1, 22, "Print"],
Cell[833243, 21274, 11252, 266, 125, "Print"],
Cell[844498, 21542, 267, 5, 22, "Print"],
Cell[844768, 21549, 102, 2, 22, "Print"],
Cell[844873, 21553, 163, 3, 22, "Print"],
Cell[845039, 21558, 45, 1, 22, "Print"],
Cell[845087, 21561, 756, 17, 22, "Print"],
Cell[845846, 21580, 414, 10, 22, "Print"],
Cell[846263, 21592, 45, 1, 22, "Print"],
Cell[846311, 21595, 1549, 34, 141, "Print"],
Cell[847863, 21631, 53, 1, 22, "Print"],
Cell[847919, 21634, 11281, 266, 125, "Print"],
Cell[859203, 21902, 266, 5, 22, "Print"],
Cell[859472, 21909, 102, 2, 22, "Print"],
Cell[859577, 21913, 163, 3, 22, "Print"],
Cell[859743, 21918, 45, 1, 22, "Print"],
Cell[859791, 21921, 760, 17, 22, "Print"],
Cell[860554, 21940, 416, 10, 22, "Print"],
Cell[860973, 21952, 45, 1, 22, "Print"],
Cell[861021, 21955, 1560, 36, 141, "Print"],
Cell[862584, 21993, 53, 1, 22, "Print"],
Cell[862640, 21996, 11268, 266, 125, "Print"],
Cell[873911, 22264, 264, 5, 22, "Print"],
Cell[874178, 22271, 102, 2, 22, "Print"],
Cell[874283, 22275, 163, 3, 22, "Print"],
Cell[874449, 22280, 45, 1, 22, "Print"],
Cell[874497, 22283, 758, 17, 22, "Print"],
Cell[875258, 22302, 418, 10, 22, "Print"],
Cell[875679, 22314, 45, 1, 22, "Print"],
Cell[875727, 22317, 1546, 33, 141, "Print"],
Cell[877276, 22352, 53, 1, 22, "Print"],
Cell[877332, 22355, 11315, 266, 125, "Print"],
Cell[888650, 22623, 264, 5, 22, "Print"],
Cell[888917, 22630, 102, 2, 22, "Print"],
Cell[889022, 22634, 163, 3, 22, "Print"],
Cell[889188, 22639, 45, 1, 22, "Print"],
Cell[889236, 22642, 758, 17, 22, "Print"],
Cell[889997, 22661, 418, 10, 22, "Print"],
Cell[890418, 22673, 45, 1, 22, "Print"],
Cell[890466, 22676, 1563, 33, 141, "Print"],
Cell[892032, 22711, 53, 1, 22, "Print"],
Cell[892088, 22714, 11276, 266, 125, "Print"],
Cell[903367, 22982, 257, 4, 22, "Print"],
Cell[903627, 22988, 102, 2, 22, "Print"],
Cell[903732, 22992, 163, 3, 22, "Print"],
Cell[903898, 22997, 45, 1, 22, "Print"],
Cell[903946, 23000, 760, 17, 22, "Print"],
Cell[904709, 23019, 416, 10, 22, "Print"],
Cell[905128, 23031, 45, 1, 22, "Print"],
Cell[905176, 23034, 1560, 33, 141, "Print"],
Cell[906739, 23069, 53, 1, 22, "Print"],
Cell[906795, 23072, 11231, 266, 125, "Print"],
Cell[918029, 23340, 265, 5, 22, "Print"],
Cell[918297, 23347, 102, 2, 22, "Print"],
Cell[918402, 23351, 163, 3, 22, "Print"],
Cell[918568, 23356, 45, 1, 22, "Print"],
Cell[918616, 23359, 760, 17, 22, "Print"],
Cell[919379, 23378, 416, 10, 22, "Print"],
Cell[919798, 23390, 45, 1, 22, "Print"],
Cell[919846, 23393, 1547, 33, 141, "Print"],
Cell[921396, 23428, 53, 1, 22, "Print"],
Cell[921452, 23431, 11261, 266, 125, "Print"],
Cell[932716, 23699, 264, 5, 22, "Print"],
Cell[932983, 23706, 102, 2, 22, "Print"],
Cell[933088, 23710, 163, 3, 22, "Print"],
Cell[933254, 23715, 45, 1, 22, "Print"],
Cell[933302, 23718, 760, 17, 22, "Print"],
Cell[934065, 23737, 416, 10, 22, "Print"],
Cell[934484, 23749, 45, 1, 22, "Print"],
Cell[934532, 23752, 1570, 35, 141, "Print"],
Cell[936105, 23789, 53, 1, 22, "Print"],
Cell[936161, 23792, 11296, 266, 125, "Print"],
Cell[947460, 24060, 265, 5, 22, "Print"],
Cell[947728, 24067, 102, 2, 22, "Print"],
Cell[947833, 24071, 163, 3, 22, "Print"],
Cell[947999, 24076, 45, 1, 22, "Print"],
Cell[948047, 24079, 760, 17, 22, "Print"],
Cell[948810, 24098, 416, 10, 22, "Print"],
Cell[949229, 24110, 45, 1, 22, "Print"],
Cell[949277, 24113, 1546, 33, 141, "Print"],
Cell[950826, 24148, 53, 1, 22, "Print"],
Cell[950882, 24151, 11282, 266, 125, "Print"],
Cell[962167, 24419, 264, 5, 22, "Print"],
Cell[962434, 24426, 102, 2, 22, "Print"],
Cell[962539, 24430, 163, 3, 22, "Print"],
Cell[962705, 24435, 45, 1, 22, "Print"],
Cell[962753, 24438, 760, 17, 22, "Print"],
Cell[963516, 24457, 418, 10, 22, "Print"],
Cell[963937, 24469, 45, 1, 22, "Print"],
Cell[963985, 24472, 1566, 35, 141, "Print"],
Cell[965554, 24509, 53, 1, 22, "Print"],
Cell[965610, 24512, 11304, 266, 125, "Print"],
Cell[976917, 24780, 264, 5, 22, "Print"],
Cell[977184, 24787, 102, 2, 22, "Print"],
Cell[977289, 24791, 163, 3, 22, "Print"],
Cell[977455, 24796, 45, 1, 22, "Print"],
Cell[977503, 24799, 760, 17, 22, "Print"],
Cell[978266, 24818, 418, 10, 22, "Print"],
Cell[978687, 24830, 45, 1, 22, "Print"],
Cell[978735, 24833, 1562, 33, 141, "Print"],
Cell[980300, 24868, 53, 1, 22, "Print"],
Cell[980356, 24871, 11287, 266, 125, "Print"],
Cell[991646, 25139, 255, 4, 22, "Print"],
Cell[991904, 25145, 102, 2, 22, "Print"],
Cell[992009, 25149, 163, 3, 22, "Print"],
Cell[992175, 25154, 45, 1, 22, "Print"],
Cell[992223, 25157, 760, 17, 22, "Print"],
Cell[992986, 25176, 420, 10, 22, "Print"],
Cell[993409, 25188, 45, 1, 22, "Print"],
Cell[993457, 25191, 1548, 32, 143, "Print"],
Cell[995008, 25225, 53, 1, 22, "Print"],
Cell[995064, 25228, 11307, 266, 125, "Print"],
Cell[1006374, 25496, 256, 4, 22, "Print"],
Cell[1006633, 25502, 102, 2, 22, "Print"],
Cell[1006738, 25506, 163, 3, 22, "Print"],
Cell[1006904, 25511, 45, 1, 22, "Print"],
Cell[1006952, 25514, 760, 17, 22, "Print"],
Cell[1007715, 25533, 420, 10, 22, "Print"],
Cell[1008138, 25545, 45, 1, 22, "Print"],
Cell[1008186, 25548, 1560, 33, 141, "Print"],
Cell[1009749, 25583, 53, 1, 22, "Print"],
Cell[1009805, 25586, 11321, 266, 125, "Print"],
Cell[1021129, 25854, 266, 5, 22, "Print"],
Cell[1021398, 25861, 102, 2, 22, "Print"],
Cell[1021503, 25865, 163, 3, 22, "Print"],
Cell[1021669, 25870, 45, 1, 22, "Print"],
Cell[1021717, 25873, 760, 17, 22, "Print"],
Cell[1022480, 25892, 420, 10, 22, "Print"],
Cell[1022903, 25904, 45, 1, 22, "Print"],
Cell[1022951, 25907, 1563, 33, 141, "Print"],
Cell[1024517, 25942, 53, 1, 22, "Print"],
Cell[1024573, 25945, 11312, 266, 125, "Print"],
Cell[1035888, 26213, 264, 5, 22, "Print"],
Cell[1036155, 26220, 102, 2, 22, "Print"],
Cell[1036260, 26224, 163, 3, 22, "Print"],
Cell[1036426, 26229, 45, 1, 22, "Print"],
Cell[1036474, 26232, 760, 17, 22, "Print"],
Cell[1037237, 26251, 422, 10, 22, "Print"],
Cell[1037662, 26263, 45, 1, 22, "Print"],
Cell[1037710, 26266, 1583, 33, 141, "Print"],
Cell[1039296, 26301, 53, 1, 22, "Print"],
Cell[1039352, 26304, 11308, 266, 125, "Print"],
Cell[1050663, 26572, 257, 4, 22, "Print"],
Cell[1050923, 26578, 102, 2, 22, "Print"],
Cell[1051028, 26582, 163, 3, 22, "Print"],
Cell[1051194, 26587, 45, 1, 22, "Print"],
Cell[1051242, 26590, 760, 17, 22, "Print"],
Cell[1052005, 26609, 422, 10, 22, "Print"],
Cell[1052430, 26621, 45, 1, 22, "Print"],
Cell[1052478, 26624, 1575, 34, 145, "Print"],
Cell[1054056, 26660, 53, 1, 22, "Print"],
Cell[1054112, 26663, 11310, 266, 125, "Print"],
Cell[1065425, 26931, 266, 5, 22, "Print"],
Cell[1065694, 26938, 102, 2, 22, "Print"],
Cell[1065799, 26942, 163, 3, 22, "Print"],
Cell[1065965, 26947, 45, 1, 22, "Print"],
Cell[1066013, 26950, 760, 17, 22, "Print"],
Cell[1066776, 26969, 420, 10, 22, "Print"],
Cell[1067199, 26981, 45, 1, 22, "Print"],
Cell[1067247, 26984, 1578, 34, 141, "Print"],
Cell[1068828, 27020, 53, 1, 22, "Print"],
Cell[1068884, 27023, 11361, 266, 125, "Print"],
Cell[1080248, 27291, 266, 5, 22, "Print"],
Cell[1080517, 27298, 102, 2, 22, "Print"],
Cell[1080622, 27302, 163, 3, 22, "Print"],
Cell[1080788, 27307, 45, 1, 22, "Print"],
Cell[1080836, 27310, 760, 17, 22, "Print"],
Cell[1081599, 27329, 422, 10, 22, "Print"],
Cell[1082024, 27341, 45, 1, 22, "Print"],
Cell[1082072, 27344, 1582, 34, 141, "Print"],
Cell[1083657, 27380, 53, 1, 22, "Print"],
Cell[1083713, 27383, 11330, 266, 125, "Print"],
Cell[1095046, 27651, 256, 4, 22, "Print"],
Cell[1095305, 27657, 102, 2, 22, "Print"],
Cell[1095410, 27661, 163, 3, 22, "Print"],
Cell[1095576, 27666, 45, 1, 22, "Print"],
Cell[1095624, 27669, 760, 17, 22, "Print"],
Cell[1096387, 27688, 434, 10, 24, "Print"],
Cell[1096824, 27700, 45, 1, 22, "Print"],
Cell[1096872, 27703, 1582, 34, 143, "Print"],
Cell[1098457, 27739, 53, 1, 22, "Print"],
Cell[1098513, 27742, 11331, 266, 125, "Print"],
Cell[1109847, 28010, 256, 4, 22, "Print"],
Cell[1110106, 28016, 102, 2, 22, "Print"],
Cell[1110211, 28020, 163, 3, 22, "Print"],
Cell[1110377, 28025, 45, 1, 22, "Print"],
Cell[1110425, 28028, 758, 17, 22, "Print"],
Cell[1111186, 28047, 432, 10, 24, "Print"],
Cell[1111621, 28059, 45, 1, 22, "Print"],
Cell[1111669, 28062, 1575, 33, 153, "Print"],
Cell[1113247, 28097, 53, 1, 22, "Print"],
Cell[1113303, 28100, 11349, 266, 125, "Print"],
Cell[1124655, 28368, 264, 5, 22, "Print"],
Cell[1124922, 28375, 102, 2, 22, "Print"],
Cell[1125027, 28379, 163, 3, 22, "Print"],
Cell[1125193, 28384, 45, 1, 22, "Print"],
Cell[1125241, 28387, 758, 17, 22, "Print"],
Cell[1126002, 28406, 434, 10, 24, "Print"],
Cell[1126439, 28418, 45, 1, 22, "Print"],
Cell[1126487, 28421, 1580, 33, 143, "Print"],
Cell[1128070, 28456, 53, 1, 22, "Print"],
Cell[1128126, 28459, 11375, 266, 127, "Print"],
Cell[1139504, 28727, 261, 5, 22, "Print"],
Cell[1139768, 28734, 102, 2, 22, "Print"],
Cell[1139873, 28738, 163, 3, 22, "Print"],
Cell[1140039, 28743, 45, 1, 22, "Print"],
Cell[1140087, 28746, 760, 17, 22, "Print"],
Cell[1140850, 28765, 434, 10, 24, "Print"],
Cell[1141287, 28777, 45, 1, 22, "Print"],
Cell[1141335, 28780, 1582, 33, 147, "Print"],
Cell[1142920, 28815, 53, 1, 22, "Print"],
Cell[1142976, 28818, 11342, 266, 127, "Print"],
Cell[1154321, 29086, 268, 5, 24, "Print"],
Cell[1154592, 29093, 102, 2, 22, "Print"],
Cell[1154697, 29097, 163, 3, 22, "Print"],
Cell[1154863, 29102, 45, 1, 22, "Print"],
Cell[1154911, 29105, 760, 17, 22, "Print"],
Cell[1155674, 29124, 434, 10, 24, "Print"],
Cell[1156111, 29136, 45, 1, 22, "Print"],
Cell[1156159, 29139, 1592, 33, 153, "Print"],
Cell[1157754, 29174, 53, 1, 22, "Print"],
Cell[1157810, 29177, 11347, 266, 127, "Print"],
Cell[1169160, 29445, 271, 5, 24, "Print"],
Cell[1169434, 29452, 102, 2, 22, "Print"],
Cell[1169539, 29456, 163, 3, 22, "Print"],
Cell[1169705, 29461, 45, 1, 22, "Print"],
Cell[1169753, 29464, 760, 17, 22, "Print"],
Cell[1170516, 29483, 434, 10, 24, "Print"],
Cell[1170953, 29495, 45, 1, 22, "Print"],
Cell[1171001, 29498, 1582, 34, 153, "Print"],
Cell[1172586, 29534, 53, 1, 22, "Print"],
Cell[1172642, 29537, 11379, 266, 127, "Print"],
Cell[1184024, 29805, 269, 5, 24, "Print"],
Cell[1184296, 29812, 102, 2, 22, "Print"],
Cell[1184401, 29816, 163, 3, 22, "Print"],
Cell[1184567, 29821, 45, 1, 22, "Print"],
Cell[1184615, 29824, 760, 17, 22, "Print"],
Cell[1185378, 29843, 434, 10, 24, "Print"],
Cell[1185815, 29855, 45, 1, 22, "Print"],
Cell[1185863, 29858, 1583, 34, 153, "Print"],
Cell[1187449, 29894, 53, 1, 22, "Print"],
Cell[1187505, 29897, 11390, 266, 127, "Print"],
Cell[1198898, 30165, 102, 2, 22, "Print"],
Cell[1199003, 30169, 163, 3, 22, "Print"],
Cell[1199169, 30174, 824, 18, 22, "Print"],
Cell[1199996, 30194, 824, 18, 22, "Print"],
Cell[1200823, 30214, 824, 18, 22, "Print"],
Cell[1201650, 30234, 824, 18, 22, "Print"],
Cell[1202477, 30254, 824, 18, 22, "Print"],
Cell[1203304, 30274, 824, 18, 22, "Print"],
Cell[1204131, 30294, 824, 18, 22, "Print"],
Cell[1204958, 30314, 824, 18, 22, "Print"],
Cell[1205785, 30334, 824, 18, 22, "Print"],
Cell[1206612, 30354, 826, 18, 22, "Print"],
Cell[1207441, 30374, 826, 18, 22, "Print"],
Cell[1208270, 30394, 826, 18, 22, "Print"],
Cell[1209099, 30414, 826, 18, 22, "Print"],
Cell[1209928, 30434, 826, 18, 22, "Print"],
Cell[1210757, 30454, 826, 18, 22, "Print"],
Cell[1211586, 30474, 45, 1, 22, "Print"],
Cell[1211634, 30477, 760, 17, 22, "Print"],
Cell[1212397, 30496, 437, 10, 24, "Print"],
Cell[1212837, 30508, 45, 1, 22, "Print"],
Cell[1212885, 30511, 1569, 30, 157, "Print"],
Cell[1214457, 30543, 53, 1, 22, "Print"],
Cell[1214513, 30546, 11390, 266, 127, "Print"],
Cell[1225906, 30814, 233, 4, 22, "Print"],
Cell[1226142, 30820, 11837, 223, 477, "Print"],
Cell[1237982, 31045, 175, 3, 24, "Print"],
Cell[1238160, 31050, 86, 1, 22, "Print"],
Cell[1238249, 31053, 2522, 59, 141, "Print"],
Cell[1240774, 31114, 91, 1, 22, "Print"],
Cell[1240868, 31117, 80, 1, 22, "Print"],
Cell[1240951, 31120, 91, 1, 22, "Print"],
Cell[1241045, 31123, 1915, 37, 109, "Print"],
Cell[1242963, 31162, 89, 1, 22, "Print"],
Cell[1243055, 31165, 45, 1, 22, "Print"],
Cell[1243103, 31168, 89, 1, 22, "Print"],
Cell[1243195, 31171, 541, 14, 31, "Print"],
Cell[1243739, 31187, 67, 1, 22, "Print"],
Cell[1243809, 31190, 89, 1, 22, "Print"],
Cell[1243901, 31193, 91, 1, 22, "Print"],
Cell[1243995, 31196, 97, 2, 22, "Print"],
Cell[1244095, 31200, 91, 1, 22, "Print"],
Cell[1244189, 31203, 2780, 53, 125, "Print"],
Cell[1246972, 31258, 45, 1, 22, "Print"],
Cell[1247020, 31261, 226, 3, 22, "Print"],
Cell[1247249, 31266, 91, 1, 22, "Print"],
Cell[1247343, 31269, 108, 2, 22, "Print"],
Cell[1247454, 31273, 91, 1, 22, "Print"],
Cell[1247548, 31276, 2841, 55, 139, "Print"],
Cell[1250392, 31333, 45, 1, 22, "Print"],
Cell[1250440, 31336, 215, 3, 22, "Print"],
Cell[1250658, 31341, 91, 1, 22, "Print"],
Cell[1250752, 31344, 58, 1, 22, "Print"],
Cell[1250813, 31347, 91, 1, 22, "Print"],
Cell[1250907, 31350, 201, 4, 22, "Print"],
Cell[1251111, 31356, 109, 2, 22, "Print"],
Cell[1251223, 31360, 742, 17, 41, "Print"],
Cell[1251968, 31379, 93, 1, 22, "Print"],
Cell[1252064, 31382, 48, 1, 22, "Print"],
Cell[1252115, 31385, 93, 1, 22, "Print"],
Cell[1252211, 31388, 89, 1, 22, "Print"],
Cell[1252303, 31391, 61, 1, 22, "Print"],
Cell[1252367, 31394, 74, 1, 22, "Print"],
Cell[1252444, 31397, 93, 1, 22, "Print"],
Cell[1252540, 31400, 1265, 29, 33, "Print"],
Cell[1253808, 31431, 93, 1, 22, "Print"],
Cell[1253904, 31434, 1140, 28, 33, "Print"],
Cell[1255047, 31464, 93, 1, 22, "Print"],
Cell[1255143, 31467, 1215, 29, 35, "Print"],
Cell[1256361, 31498, 93, 1, 22, "Print"],
Cell[1256457, 31501, 1251, 30, 33, "Print"],
Cell[1257711, 31533, 93, 1, 22, "Print"],
Cell[1257807, 31536, 1124, 28, 33, "Print"],
Cell[1258934, 31566, 93, 1, 22, "Print"],
Cell[1259030, 31569, 1107, 27, 33, "Print"],
Cell[1260140, 31598, 93, 1, 22, "Print"],
Cell[1260236, 31601, 1067, 27, 33, "Print"],
Cell[1261306, 31630, 93, 1, 22, "Print"],
Cell[1261402, 31633, 1245, 29, 35, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[1262684, 31667, 195, 6, 51, "Input"],
Cell[1262882, 31675, 177, 3, 22, "Print"],
Cell[1263062, 31680, 177, 3, 22, "Print"],
Cell[1263242, 31685, 177, 3, 22, "Print"],
Cell[1263422, 31690, 177, 3, 22, "Print"],
Cell[1263602, 31695, 177, 3, 22, "Print"],
Cell[1263782, 31700, 177, 3, 22, "Print"],
Cell[1263962, 31705, 177, 3, 22, "Print"],
Cell[1264142, 31710, 177, 3, 22, "Print"],
Cell[1264322, 31715, 177, 3, 22, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[1264536, 31723, 158, 5, 23, "Input"],
Cell[1264697, 31730, 191537, 6700, 342, 67973, 5169, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1456283, 38436, 151, 3, 39, "Section"],

Cell[CellGroupData[{
Cell[1456459, 38443, 28, 0, 36, "Subsection"],

Cell[CellGroupData[{
Cell[1456512, 38447, 102, 2, 26, "Subsubsection"],
Cell[1456617, 38451, 158, 6, 54, "Input"],

Cell[CellGroupData[{
Cell[1456800, 38461, 127, 5, 40, "Input"],
Cell[1456930, 38468, 53, 1, 26, "Output"],
Cell[1456986, 38471, 52, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1457075, 38477, 38, 1, 26, "Input"],
Cell[1457116, 38480, 196, 4, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1457349, 38489, 160, 5, 40, "Input"],
Cell[1457512, 38496, 574, 9, 37, "Print"],
Cell[1458089, 38507, 581, 11, 37, "Print"],
Cell[1458673, 38520, 108, 2, 24, "Print"],
Cell[1458784, 38524, 49, 1, 22, "Print"]
}, Open  ]],
Cell[1458848, 38528, 784, 25, 320, "Input"],

Cell[CellGroupData[{
Cell[1459657, 38557, 88, 2, 26, "Input"],
Cell[1459748, 38561, 46, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1459831, 38567, 313, 7, 68, "Input"],
Cell[1460147, 38576, 177, 3, 22, "Print"],
Cell[1460327, 38581, 179, 3, 22, "Print"],
Cell[1460509, 38586, 179, 3, 22, "Print"],
Cell[1460691, 38591, 179, 3, 22, "Print"],
Cell[1460873, 38596, 175, 3, 22, "Print"],
Cell[1461051, 38601, 179, 3, 22, "Print"],
Cell[1461233, 38606, 179, 3, 22, "Print"],
Cell[1461415, 38611, 179, 3, 22, "Print"],
Cell[1461597, 38616, 177, 3, 22, "Print"],
Cell[1461777, 38621, 179, 3, 22, "Print"],
Cell[1461959, 38626, 179, 3, 22, "Print"],
Cell[1462141, 38631, 179, 3, 22, "Print"],
Cell[1462323, 38636, 175, 3, 22, "Print"],
Cell[1462501, 38641, 179, 3, 22, "Print"],
Cell[1462683, 38646, 179, 3, 22, "Print"],
Cell[1462865, 38651, 179, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1463081, 38659, 151, 5, 40, "Input"],
Cell[1463235, 38666, 335012, 8505, 381, 88938, 5462, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1798296, 47177, 97, 2, 26, "Subsubsection"],

Cell[CellGroupData[{
Cell[1798418, 47183, 252, 8, 68, "Input"],
Cell[1798673, 47193, 84, 1, 26, "Output"],
Cell[1798760, 47196, 155, 3, 28, "Output"],
Cell[1798918, 47201, 133, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1799088, 47208, 225, 6, 40, "Input"],
Cell[1799316, 47216, 574, 9, 37, "Print"],
Cell[1799893, 47227, 575, 9, 37, "Print"],
Cell[1800471, 47238, 106, 2, 22, "Print"],
Cell[1800580, 47242, 49, 1, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1800666, 47248, 449, 10, 96, "Input"],
Cell[1801118, 47260, 177, 3, 22, "Print"],
Cell[1801298, 47265, 179, 3, 22, "Print"],
Cell[1801480, 47270, 179, 3, 22, "Print"],
Cell[1801662, 47275, 179, 3, 22, "Print"],
Cell[1801844, 47280, 175, 3, 22, "Print"],
Cell[1802022, 47285, 179, 3, 22, "Print"],
Cell[1802204, 47290, 179, 3, 22, "Print"],
Cell[1802386, 47295, 179, 3, 22, "Print"],
Cell[1802568, 47300, 177, 3, 22, "Print"],
Cell[1802748, 47305, 179, 3, 22, "Print"],
Cell[1802930, 47310, 179, 3, 22, "Print"],
Cell[1803112, 47315, 179, 3, 22, "Print"],
Cell[1803294, 47320, 175, 3, 22, "Print"],
Cell[1803472, 47325, 179, 3, 22, "Print"],
Cell[1803654, 47330, 179, 3, 22, "Print"],
Cell[1803836, 47335, 179, 3, 22, "Print"],
Cell[1804018, 47340, 343360, 8620, 388, 88973, 5474, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[2147439, 55967, 109, 2, 28, "Subsection"],

Cell[CellGroupData[{
Cell[2147573, 55973, 102, 2, 26, "Subsubsection"],

Cell[CellGroupData[{
Cell[2147700, 55979, 229, 9, 96, "Input"],
Cell[2147932, 55990, 179, 3, 22, "Print"],
Cell[2148114, 55995, 179, 3, 22, "Print"],
Cell[2148296, 56000, 179, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2148512, 56008, 106, 2, 26, "Input"],
Cell[2148621, 56012, 138482, 3350, 132, 29584, 2001, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2287152, 59368, 97, 2, 26, "Subsubsection"],

Cell[CellGroupData[{
Cell[2287274, 59374, 230, 8, 82, "Input"],
Cell[2287507, 59384, 179, 3, 22, "Print"],
Cell[2287689, 59389, 179, 3, 22, "Print"],
Cell[2287871, 59394, 179, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2288087, 59402, 105, 2, 26, "Input"],
Cell[2288195, 59406, 140291, 3455, 132, 30653, 2097, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2428489, 62863, 135, 3, 26, "Output"]
}, Open  ]],
Cell[2428639, 62869, 36, 0, 30, "Text"],

Cell[CellGroupData[{
Cell[2428700, 62873, 45, 1, 26, "Input"],
Cell[2428748, 62876, 120, 2, 22, "Print",
  CellTags->"Info3417329866-9092711"],
Cell[2428871, 62880, 797, 19, 83, "Print",
  CellTags->"Info3417329866-9092711"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2429705, 62904, 89, 5, 40, "Input"],
Cell[2429797, 62911, 61, 1, 26, "Output"],
Cell[2429861, 62914, 62, 1, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2429960, 62920, 167, 5, 40, "Input"],
Cell[2430130, 62927, 667, 18, 67, "Output"],
Cell[2430800, 62947, 641, 18, 63, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2431514, 62973, 86, 1, 69, "Section"],

Cell[CellGroupData[{
Cell[2431625, 62978, 218, 6, 40, "Input"],
Cell[2431846, 62986, 360, 5, 21, "Message"]
}, Open  ]],
Cell[2432221, 62994, 292, 9, 96, "Input"],

Cell[CellGroupData[{
Cell[2432538, 63007, 297, 10, 110, "Input"],
Cell[2432838, 63019, 356, 5, 21, "Message"],
Cell[2433197, 63026, 179, 3, 22, "Print"],
Cell[2433379, 63031, 81828, 2192, 352, 29499, 1541, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

