(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     63292,       1424]*)
(*NotebookOutlinePosition[     64127,       1450]*)
(*  CellTagsIndexPosition[     64083,       1446]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(plot1[Shape[22 // Range, {2, 11}]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 11}\),
      SequenceForm[ "Dimension der Daten  ", {2, 11}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0627706 0.0865801 -0.0441453 0.0294302 [
[.11039 -0.0125 -3 -9 ]
[.11039 -0.0125 3 0 ]
[.28355 -0.0125 -3 -9 ]
[.28355 -0.0125 3 0 ]
[.45671 -0.0125 -3 -9 ]
[.45671 -0.0125 3 0 ]
[.62987 -0.0125 -3 -9 ]
[.62987 -0.0125 3 0 ]
[.80303 -0.0125 -6 -9 ]
[.80303 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -6 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .25016 -12 -4.5 ]
[-0.0125 .25016 0 4.5 ]
[-0.0125 .39731 -12 -4.5 ]
[-0.0125 .39731 0 4.5 ]
[-0.0125 .54446 -12 -4.5 ]
[-0.0125 .54446 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33845 -5 -6 ]
[.97619 .33845 5 6 ]
[.97619 .36788 -5 -6 ]
[.97619 .36788 5 6 ]
[.97619 .39731 -5 -6 ]
[.97619 .39731 5 6 ]
[.97619 .42674 -5 -6 ]
[.97619 .42674 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.97619 .4856 -5 -6 ]
[.97619 .4856 5 6 ]
[.97619 .51503 -5 -6 ]
[.97619 .51503 5 6 ]
[.97619 .54446 -5 -6 ]
[.97619 .54446 5 6 ]
[.97619 .57389 -5 -6 ]
[.97619 .57389 5 6 ]
[.97619 .60332 -5 -6 ]
[.97619 .60332 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11039 0 m
.11039 .00625 L
s
[(2)] .11039 -0.0125 0 1 Mshowa
.28355 0 m
.28355 .00625 L
s
[(4)] .28355 -0.0125 0 1 Mshowa
.45671 0 m
.45671 .00625 L
s
[(6)] .45671 -0.0125 0 1 Mshowa
.62987 0 m
.62987 .00625 L
s
[(8)] .62987 -0.0125 0 1 Mshowa
.80303 0 m
.80303 .00625 L
s
[(10)] .80303 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(12)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.15368 0 m
.15368 .00375 L
s
.19697 0 m
.19697 .00375 L
s
.24026 0 m
.24026 .00375 L
s
.32684 0 m
.32684 .00375 L
s
.37013 0 m
.37013 .00375 L
s
.41342 0 m
.41342 .00375 L
s
.5 0 m
.5 .00375 L
s
.54329 0 m
.54329 .00375 L
s
.58658 0 m
.58658 .00375 L
s
.67316 0 m
.67316 .00375 L
s
.71645 0 m
.71645 .00375 L
s
.75974 0 m
.75974 .00375 L
s
.84632 0 m
.84632 .00375 L
s
.88961 0 m
.88961 .00375 L
s
.9329 0 m
.9329 .00375 L
s
.0671 0 m
.0671 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(5)] -0.0125 .10301 1 0 Mshowa
0 .25016 m
.00625 .25016 L
s
[(10)] -0.0125 .25016 1 0 Mshowa
0 .39731 m
.00625 .39731 L
s
[(15)] -0.0125 .39731 1 0 Mshowa
0 .54446 m
.00625 .54446 L
s
[(20)] -0.0125 .54446 1 0 Mshowa
.125 Mabswid
0 .13244 m
.00375 .13244 L
s
0 .16187 m
.00375 .16187 L
s
0 .1913 m
.00375 .1913 L
s
0 .22073 m
.00375 .22073 L
s
0 .27959 m
.00375 .27959 L
s
0 .30902 m
.00375 .30902 L
s
0 .33845 m
.00375 .33845 L
s
0 .36788 m
.00375 .36788 L
s
0 .42674 m
.00375 .42674 L
s
0 .45617 m
.00375 .45617 L
s
0 .4856 m
.00375 .4856 L
s
0 .51503 m
.00375 .51503 L
s
0 .07358 m
.00375 .07358 L
s
0 .04415 m
.00375 .04415 L
s
0 .01472 m
.00375 .01472 L
s
0 .57389 m
.00375 .57389 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.11039 .61178 m
.11039 .61803 L
s
.28355 .61178 m
.28355 .61803 L
s
.45671 .61178 m
.45671 .61803 L
s
.62987 .61178 m
.62987 .61803 L
s
.80303 .61178 m
.80303 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.15368 .61428 m
.15368 .61803 L
s
.19697 .61428 m
.19697 .61803 L
s
.24026 .61428 m
.24026 .61803 L
s
.32684 .61428 m
.32684 .61803 L
s
.37013 .61428 m
.37013 .61803 L
s
.41342 .61428 m
.41342 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54329 .61428 m
.54329 .61803 L
s
.58658 .61428 m
.58658 .61803 L
s
.67316 .61428 m
.67316 .61803 L
s
.71645 .61428 m
.71645 .61803 L
s
.75974 .61428 m
.75974 .61803 L
s
.84632 .61428 m
.84632 .61803 L
s
.88961 .61428 m
.88961 .61803 L
s
.9329 .61428 m
.9329 .61803 L
s
.0671 .61428 m
.0671 .61803 L
s
.02381 .61428 m
.02381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .25016 m
1 .25016 L
s
.99375 .39731 m
1 .39731 L
s
.99375 .54446 m
1 .54446 L
s
.125 Mabswid
.99625 .13244 m
1 .13244 L
s
.99625 .16187 m
1 .16187 L
s
.99625 .1913 m
1 .1913 L
s
.99625 .22073 m
1 .22073 L
s
.99625 .27959 m
1 .27959 L
s
.99625 .30902 m
1 .30902 L
s
.99625 .33845 m
1 .33845 L
s
.99625 .36788 m
1 .36788 L
s
.99625 .42674 m
1 .42674 L
s
.99625 .45617 m
1 .45617 L
s
.99625 .4856 m
1 .4856 L
s
.99625 .51503 m
1 .51503 L
s
.99625 .07358 m
1 .07358 L
s
.99625 .04415 m
1 .04415 L
s
.99625 .01472 m
1 .01472 L
s
.99625 .57389 m
1 .57389 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .33845 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.97619 .33845 L
s
0 .98 .604 r
gsave
.97619 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .04415 m
.97619 .36788 L
s
1 0 0 r
gsave
.97619 .39731 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .07358 m
.97619 .39731 L
s
1 1 0 r
gsave
.97619 .42674 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .10301 m
.97619 .42674 L
s
.541 .169 .886 r
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13244 m
.97619 .45617 L
s
1 .38 .01 r
gsave
.97619 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16187 m
.97619 .4856 L
s
1 0 1 r
gsave
.97619 .51503 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .1913 m
.97619 .51503 L
s
0 .808 .82 r
gsave
.97619 .54446 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.808 0.820 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22073 m
.97619 .54446 L
s
.859 .439 .576 r
gsave
.97619 .57389 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.859 0.439 0.577 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25016 m
.97619 .57389 L
s
0 0 0 r
gsave
.97619 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27959 m
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{513, 316.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000810001?2000`400?l00000o`00003oo`3ooooo
0?ooo`<0oooo00180?ooo`D00000D@3oool300000500oooo0`00001B0?ooo`<00000CP3oool30000
00@0oooo0P00001;0?ooo`<000000P3oool5000000`0oooo00190?ooo`040000003oool0oooo0000
0580oooo00<000000?ooo`3oool0CP3oool01@000000oooo0?ooo`3oool000000500oooo00D00000
0?ooo`3oool0oooo0000001>0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
B`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000`0oooo001:0?ooo`030000
003oool0oooo04l0oooo1@00001?0?ooo`050000003oool0oooo0?ooo`000000D03oool01@000000
oooo0?ooo`3oool0000004h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00001;
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0303oool004/0oooo00<000000?oo
o`3oool0CP3oool010000000oooo0?ooo`00001@0?ooo`@00000DP3oool3000004l0oooo00<00000
0?ooo`3oool00P3oool010000000oooo0?ooo`00001;0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool02`3oool004P0oooo00D000000?ooo`3oool0oooo0000001@0?ooo`030000003o
ool000000500oooo00<000000?ooo`3oool0DP3oool01@000000oooo0?ooo`3oool0000004h0oooo
00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00001;0?ooo`050000003oool0oooo0?oo
o`0000000`3oool00`000000oooo0?ooo`0:0?ooo`00B03oool01@000000oooo0?ooo`3oool00000
0540oooo0P00001A0?ooo`030000003oool0oooo0540oooo00D000000?ooo`3oool0oooo0000001=
0?ooo`800000103oool010000000oooo0?ooo`00001:0?ooo`8000000`3oool01@000000oooo0?oo
o`3oool0000000`0oooo00190?ooo`<00000D`3oool00`000000oooo0?ooo`1@0?ooo`800000DP3o
ool3000004l0oooo00<000000?ooo`3oool00`3oool2000004`0oooo00<000000?ooo`3oool00P3o
ool3000000d0oooo003o0?ooool0oooo0`3oool00?l0ooooo`3oool30?ooo`00o`3ooooo0?ooo`<0
oooo003o0?ooool0oooo0`3oool00?l0ooooo`3oool30?ooo`00o`3ooooo0?ooo`<0oooo003o0?oo
ool0oooo0`3oool001D0ooooo`00003Y000000@0oooo000E0?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0080oooo
000E0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?oo
o`1A0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?oo
o`1A0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00P3oool001D0oooo00<00000
0?ooo`3oool0<`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo0540oooo00<00000
0?ooo`3oool0DP3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo0540oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oo
onD0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooooU0?ooo`03
0000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00L0oooo1@000?oo0?ooomT0oooo
00<000000?ooo`3oool00P3oool001D0oooo0`0000070?ooo`P0003oo`3ooooD0?ooo`<00000103o
ool001D0oooo00<000000?ooo`3oool01`3oool;0000ool0ooood`3oool00`000000oooo0?ooo`02
0?ooo`005@3oool00`000000oooo0?ooo`070?ooo`h0003oo`3oooo@0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo00T0oooo3`000?oo0?ooold0oooo00<000000?ooo`3o
ool00P3oool001D0oooo00<000000?ooo`3oool0303oool?0000ool0oooobP3oool00`000000oooo
0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0?0?ooo`l0003oo`3oooo70?ooo`030000003o
ool0oooo0080oooo000E0?ooo`030000003oool0oooo0180oooo3`000?oo0?oool@0oooo00<00000
0?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool05@3oool?0000ool0oooo`@3oool00`00
0000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0H0?ooo`l0003oo`3ooonn0?ooo`03
0000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01/0oooo3`000?oo0?oook/0oooo
00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool07P3oool?0000ool0oooo^03o
ool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0Q0?ooo`l0003oo`3ooone
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo02@0oooo3`000?oo0?oo
ok80oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool01`3oool5003jVQ/0
oooo3`000?oo0?ooojl0oooo00<000000?ooo`3oool00P3oool001D0oooo0`0000070?ooo`P00?ZJ
6`3oool?0000ool0ooooZP3oool3000000@0oooo000E0?ooo`030000003oool0oooo00L0oooo2`00
nYXK0?ooo`l0003oo`3ooonY0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo00L0oooo3P00nYXK0?ooo`l0003oo`3ooonV0?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo00T0oooo3`00nYXK0?ooo`l0003oo`3ooonS0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo00`0oooo3`00nYXK0?ooo`l0003oo`3ooonP0?ooo`03
0000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00l0oooo3`00nYXK0?ooo`h0003o
o`3ooonN0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0180oooo3`00
nYXK0?ooo`h0003oo`3ooonK0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo01D0oooo3`00nYXK0?ooo`h0003oo`3ooonH0?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo01P0oooo3`00nYXK0?ooo`h0003oo`3ooonE0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo01/0oooo3`00nYXJ0?ooo`l0003oo`3ooonB0?ooo`03
0000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01h0oooo3`00nYXJ0?ooo`l0003o
o`3ooon?0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0240oooo3`00
nYXJ0?ooo`l0003oo`3ooon<0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo02@0oooo3`00nYXJ0?ooo`l0003oo`3ooon90?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo00L0oooo1@3o000K0?ooo`h00?ZJ6`3oool?0000ool0ooooQP3oool00`00
0000oooo0?ooo`020?ooo`005@3oool3000000L0oooo203o000K0?ooo`h00?ZJ6`3oool?0000ool0
ooooP@3oool3000000@0oooo000E0?ooo`030000003oool0oooo00L0oooo2`3o000K0?ooo`h00?ZJ
6`3oool?0000ool0ooooP03oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?oo
o`070?ooo`h0o`006`3oool>003jVQ/0oooo3`000?oo0?ooogd0oooo00<000000?ooo`3oool00P3o
ool001D0oooo00<000000?ooo`3oool02@3oool?0?l001X0oooo3`00nYXK0?ooo`l0003oo`3ooomj
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00`0oooo3`3o000J0?oo
o`l00?ZJ6`3oool?0000ool0ooooM`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000
oooo0?ooo`0?0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?ooog@0oooo00<000000?ooo`3o
ool00P3oool001D0oooo00<000000?ooo`3oool04P3oool?0?l001X0oooo3`00nYXK0?ooo`l0003o
o`3oooma0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01D0oooo3`3o
000J0?ooo`l00?ZJ6`3oool?0000ool0ooooKP3oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`0H0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?ooof/0oooo00<00000
0?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool06`3oool?0?l001X0oooo3`00nYXK0?oo
o`l0003oo`3ooomX0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01h0
oooo3`3o000J0?ooo`l00?ZJ6`3oool>0000ool0ooooIP3oool00`000000oooo0?ooo`020?ooo`00
5@3oool00`000000oooo0?ooo`0Q0?ooo`l0o`006P3oool?003jVQ/0oooo3P000?oo0?ooof<0oooo
00<000000?ooo`3oool00P3oool000X0oooo0`0000080?ooo`030000003oool0oooo02@0oooo3`3o
000J0?ooo`l00?ZJ6`3oool>0000ool0ooooH03oool00`000000oooo0?ooo`020?ooo`002@3oool0
1@000000oooo0?ooo`3oool0000000L0oooo00<000000?ooo`3oool09`3oool>0?l001/0oooo3`00
nYXK0?ooo`h0003oo`3ooomM0?ooo`030000003oool0oooo0080oooo000=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01`3oool50?oo01h0oooo3P3o000K0?ooo`h00?ZJ6`3oool?
0000ool0ooooFP3oool00`000000oooo0?ooo`020?ooo`003@3oool00`000000oooo0?ooo`050?oo
o`@000001P3oool80?oo01h0oooo3P3o000K0?ooo`h00?ZJ6`3oool?0000ool0ooooE03oool40000
00@0oooo00090?ooo`@00000203oool00`000000oooo0?ooo`070?ooo`/0ool07P3oool>0?l001/0
oooo3P00nYXK0?ooo`l0003oo`3ooomD0?ooo`030000003oool0oooo0080oooo00090?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool01`3oool>0?oo01d0oooo3`3o000K0?ooo`h00?ZJ
6`3oool?0000ool0ooooD@3oool00`000000oooo0?ooo`020?ooo`002@3oool5000000L0oooo00<0
00000?ooo`3oool02@3oool?0?oo01d0oooo3`3o000J0?ooo`l00?ZJ6`3oool?0000ool0ooooCP3o
ool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0<0?ooo`l0ool07@3oool?
0?l001X0oooo3`00nYXK0?ooo`l0003oo`3ooom;0?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo00l0oooo3`3oo`0M0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?oo
odP0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool04P3oool?0?oo01d0
oooo3`3o000J0?ooo`l00?ZJ6`3oool?0000ool0ooooA@3oool00`000000oooo0?ooo`020?ooo`00
5@3oool00`000000oooo0?ooo`0E0?ooo`l0ool07@3oool?0?l001X0oooo3`00nYXK0?ooo`l0003o
o`3ooom20?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01P0oooo3`3o
o`0M0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?ooocl0oooo00<000000?ooo`3oool00P3o
ool001D0oooo00<000000?ooo`3oool06`3oool?0?oo01d0oooo3`3o000J0?ooo`l00?ZJ6`3oool?
0000ool0oooo?03oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0N0?oo
o`l0ool07@3oool?0?l001X0oooo3`00nYXK0?ooo`l0003oo`3oooli0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo0240oooo3`3oo`0M0?ooo`l0o`006P3oool?003jVQ/0
oooo3`000?oo0?ooocH0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0
903oool?0?oo01d0oooo3`3o000J0?ooo`l00?ZJ6`3oool?0000ool0oooo<`3oool00`000000oooo
0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`070?ooo`D0RR_R6`3oool?0?oo01d0oooo3P3o
000K0?ooo`h00?ZJ703oool?0000ool0oooo<03oool00`000000oooo0?ooo`020?ooo`005@3oool3
000000L0oooo202::n8K0?ooo`l0ool07@3oool>0?l001/0oooo3P00nYXL0?ooo`l0003oo`3oool[
0?ooo`<00000103oool001D0oooo00<000000?ooo`3oool01`3oool;08X[hQ/0oooo3`3oo`0M0?oo
o`h0o`006`3oool>003jVQ`0oooo3P000?oo0?ooob/0oooo00<000000?ooo`3oool00P3oool001D0
oooo00<000000?ooo`3oool01`3oool>08X[hQ/0oooo3`3oo`0M0?ooo`h0o`006`3oool>003jVQ`0
oooo3P000?oo0?ooobP0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0
2@3oool?08X[hQ/0oooo3`3oo`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3P000?oo0?ooobD0oooo
00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0303oool?08X[hQ/0oooo3`3o
o`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3P000?oo0?ooob80oooo00<000000?ooo`3oool00P3o
ool001D0oooo00<000000?ooo`3oool03`3oool?08X[hQ/0oooo3P3oo`0M0?ooo`l0o`006P3oool?
003jVQ/0oooo3`000?oo0?oooal0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?oo
o`3oool04P3oool?08X[hQ/0oooo3P3oo`0M0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?oo
oa`0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool05@3oool?08X[hQ/0
oooo3P3oo`0M0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?oooaT0oooo00<000000?ooo`3o
ool00P3oool001D0oooo00<000000?ooo`3oool0603oool?08X[hQ/0oooo3P3oo`0M0?ooo`l0o`00
6P3oool?003jVQ/0oooo3`000?oo0?oooaH0oooo00<000000?ooo`3oool00P3oool001D0oooo00<0
00000?ooo`3oool06`3oool?08X[hQX0oooo3`3oo`0M0?ooo`l0o`006P3oool?003jVQ/0oooo3`00
0?oo0?oooa<0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool07P3oool?
08X[hQX0oooo3`3oo`0M0?ooo`l0o`006P3oool?003jVQ/0oooo3`000?oo0?oooa00oooo00<00000
0?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool08@3oool?08X[hQX0oooo3`3oo`0M0?oo
o`l0o`006P3oool?003jVQ/0oooo3`000?oo0?ooo`d0oooo00<000000?ooo`3oool00P3oool001D0
oooo00<000000?ooo`3oool0903oool?08X[hQX0oooo3`3oo`0M0?ooo`l0o`006P3oool?003jVQ/0
oooo3`000?oo0?ooo`X0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0
1`3oool50?mQ0Q/0oooo3P2::n8K0?ooo`l0ool07@3oool>0?l001/0oooo3P00nYXL0?ooo`l0003o
o`3oool70?ooo`030000003oool0oooo0080oooo000E0?ooo`<000001`3oool80?mQ0Q/0oooo3P2:
:n8K0?ooo`l0ool07@3oool>0?l001/0oooo3P00nYXL0?ooo`l0003oo`3oool20?ooo`<00000103o
ool001D0oooo00<000000?ooo`3oool01`3oool;0?mQ0Q/0oooo3P2::n8K0?ooo`l0ool07@3oool>
0?l001/0oooo3P00nYXL0?ooo`l0003oo`3oool10?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo00L0oooo3P3oH@8K0?ooo`h0RR_R6`3oool?0?oo01d0oooo3P3o000K0?oo
o`h00?ZJ703oool?0000ood0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3o
ool02@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0
003onP3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0<0?ooo`l0of42
6P3oool?08X[hQ/0oooo3`3oo`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3`000?og0?ooo`030000
003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00l0oooo3`3oH@8J0?ooo`l0RR_R6`3o
ool?0?oo01`0oooo3`3o000J0?ooo`l00?ZJ703oool?0000oo@0oooo00<000000?ooo`3oool00P3o
ool001D0oooo00<000000?ooo`3oool04P3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?
0?l001X0oooo3`00nYXL0?ooo`l0003ol@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`00
0000oooo0?ooo`0E0?ooo`l0of426P3oool?08X[hQ/0oooo3`3oo`0L0?ooo`l0o`006P3oool?003j
VQ`0oooo3P000?o_0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01P0
oooo3`3oH@8J0?ooo`l0RR_R6`3oool?0?oo01`0oooo3`3o000J0?ooo`l00?ZJ703oool>0000on`0
oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool06`3oool?0?mQ0QX0oooo
3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`h0003oj@3oool00`000000oooo
0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0N0?ooo`l0of426P3oool?08X[hQ/0oooo3P3o
o`0M0?ooo`l0o`006P3oool?003jVQ`0oooo3P000?oV0?ooo`030000003oool0oooo0080oooo000E
0?ooo`030000003oool0oooo0240oooo3`3oH@8J0?ooo`l0RR_R6`3oool>0?oo01d0oooo3`3o000J
0?ooo`l00?ZJ6`3oool?0000on<0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?oo
o`3oool0903oool?0?mQ0QX0oooo3`2::n8K0?ooo`h0ool07@3oool?0?l001X0oooo3`00nYXK0?oo
o`l0003oh03oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0W0?ooo`h0
of426`3oool?08X[hQ/0oooo3P3oo`0M0?ooo`h0o`006`3oool?003jVQ/0oooo3`000?oM0?ooo`03
0000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00L0oooo1@3o0?lN0?ooo`h0of42
6`3oool>08X[hQ/0oooo3`3oo`0M0?ooo`h0o`006`3oool>003jVQ`0oooo3`000?oJ0?ooo`030000
003oool0oooo0080oooo000E0?ooo`<000001`3oool80?l0oah0oooo3P3oH@8K0?ooo`h0RR_R6`3o
ool?0?oo01d0oooo3P3o000K0?ooo`h00?ZJ703oool?0000omD0oooo0`0000040?ooo`005@3oool0
0`000000oooo0?ooo`070?ooo`/0o`3o7P3oool>0?mQ0Q/0oooo3P2::n8K0?ooo`l0ool07@3oool>
0?l001/0oooo3P00nYXL0?ooo`l0003oe03oool00`000000oooo0?ooo`020?ooo`005@3oool00`00
0000oooo0?ooo`070?ooo`h0o`3o7@3oool?0?mQ0Q/0oooo3P2::n8K0?ooo`l0ool0703oool?0?l0
01/0oooo3P00nYXL0?ooo`l0003od@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000
oooo0?ooo`090?ooo`l0o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0
oooo3`00nYXL0?ooo`l0003ocP3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo
0?ooo`0<0?ooo`l0o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo
3`00nYXL0?ooo`l0003ob`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?oo
o`0?0?ooo`l0o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00
nYXL0?ooo`l0003ob03oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0B
0?ooo`l0o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL
0?ooo`l0003oa@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0E0?oo
o`l0o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?oo
o`l0003o`P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0H0?ooo`l0
o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0
003o_`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0K0?ooo`l0o`3o
7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0003o
_03oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0N0?ooo`l0o`3o7@3o
ool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0003o^@3o
ool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0Q0?ooo`l0o`3o7@3oool?
0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`h0003o]`3oool0
0`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0T0?ooo`l0o`3o7@3oool?0?mQ
0QX0oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`h0003o]03oool00`00
0000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`070?ooo`D00<kA6`3oool?0?l0oad0
oooo3P3oH@8K0?ooo`h0RR_R703oool?0?oo01`0oooo3P3o000K0?ooo`h00?ZJ7@3oool>0000ok40
oooo00<000000?ooo`3oool00P3oool001D0oooo0`0000070?ooo`P00<kA6`3oool?0?l0oad0oooo
3P3oH@8K0?ooo`h0RR_R703oool?0?oo01`0oooo3P3o000K0?ooo`h00?ZJ7@3oool>0000oj`0oooo
0`0000040?ooo`005@3oool00`000000oooo0?ooo`070?ooo`/00<kA6`3oool?0?l0oad0oooo3P3o
H@8K0?ooo`h0RR_R703oool>0?oo01d0oooo3P3o000K0?ooo`h00?ZJ703oool?0000oj/0oooo00<0
00000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool01`3oool>003>dA/0oooo3`3o0?lM
0?ooo`h0of426`3oool>08X[hQ`0oooo3P3oo`0M0?ooo`h0o`006`3oool>003jVQ`0oooo3`000?nX
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00T0oooo3`00c]4K0?oo
o`l0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`h0ool0703oool?0?l001X0oooo3`00nYXL0?oo
o`l0003oY@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0<0?ooo`l0
0<kA6`3oool?0?l0oa`0oooo3`3oH@8J0?ooo`l0RR_R703oool>0?oo01`0oooo3`3o000J0?ooo`l0
0?ZJ703oool?0000oj80oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0
3`3oool?003>dA/0oooo3P3o0?lM0?ooo`l0of426P3oool?08X[hQ/0oooo3`3oo`0L0?ooo`l0o`00
6P3oool?003jVQ`0oooo3`000?nO0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003o
ool0oooo0180oooo3`00c]4K0?ooo`h0o`3o7@3oool?0?mQ0QX0oooo3`2::n8K0?ooo`l0ool0703o
ool?0?l001X0oooo3`00nYXL0?ooo`l0003oW03oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`0E0?ooo`l00<kA6`3oool>0?l0oad0oooo3`3oH@8J0?ooo`l0RR_R6`3oool?
0?oo01`0oooo3`3o000J0?ooo`l00?ZJ703oool?0000oiT0oooo00<000000?ooo`3oool00P3oool0
01D0oooo00<000000?ooo`3oool0603oool?003>dA/0oooo3P3o0?lM0?ooo`l0of426P3oool?08X[
hQ/0oooo3`3oo`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3`000?nF0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo01/0oooo3`00c]4J0?ooo`l0o`3o7@3oool?0?mQ0QX0
oooo3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0003oT`3oool00`000000
oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0N0?ooo`l00<kA6P3oool?0?l0oad0oooo
3`3oH@8J0?ooo`l0RR_R6`3oool?0?oo01`0oooo3`3o000J0?ooo`l00?ZJ703oool?0000oi00oooo
00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool08@3oool?003>dAX0oooo3`3o
0?lM0?ooo`l0of426P3oool?08X[hQ/0oooo3`3oo`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3`00
0?n=0?ooo`030000003oool0oooo0080oooo00040?ooo`<00000103oool2000000P0oooo00<00000
0?ooo`3oool0903oool?003>dAX0oooo3`3o0?lM0?ooo`l0of426P3oool?08X[hQ/0oooo3`3oo`0L
0?ooo`l0o`006P3oool?003jVQ`0oooo3`000?n:0?ooo`030000003oool0oooo0080oooo00050?oo
o`030000003oool0oooo0080oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?ooo`07
0?ooo`D0fg2C6`3oool>003>dA/0oooo3`3o0?lM0?ooo`h0of426`3oool>08X[hQ`0oooo3`3oo`0L
0?ooo`h0o`006`3oool?003jVQ`0oooo3`000?n70?ooo`030000003oool0oooo0080oooo00050?oo
o`030000003oool0oooo0080oooo00@000000?ooo`3oool000001`3oool4000000H0oooo203KL9<K
0?ooo`h00<kA6`3oool?0?l0oad0oooo3P3oH@8K0?ooo`h0RR_R703oool?0?oo01`0oooo3P3o000K
0?ooo`h00?ZJ7@3oool?0000oh40oooo100000040?ooo`001@3oool00`000000oooo0?ooo`020?oo
o`040000003oool0oooo000000L0oooo00<000000?ooo`3oool01`3oool;0=]`Ta/0oooo3P00c]4K
0?ooo`l0o`3o7@3oool>0?mQ0Q/0oooo3P2::n8L0?ooo`l0ool0703oool>0?l001/0oooo3P00nYXM
0?ooo`l0003oP@3oool00`000000oooo0?ooo`020?ooo`001@3oool00`000000oooo0?ooo`020?oo
o`040000003oool0oooo000000L0oooo00<000000?ooo`3oool01`3oool>0=]`Ta/0oooo3P00c]4K
0?ooo`l0o`3o7@3oool>0?mQ0Q/0oooo3P2::n8L0?ooo`l0ool0703oool>0?l001/0oooo3P00nYXM
0?ooo`l0003oOP3oool00`000000oooo0?ooo`020?ooo`00103oool2000000@0oooo00@000000?oo
o`3oool000001`3oool00`000000oooo0?ooo`090?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL
0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0o`006`3oool>003jVQd0oooo3P000?ml
0?ooo`030000003oool0oooo0080oooo00050?ooo`030000003oool0oooo00<0oooo0P0000080?oo
o`030000003oool0oooo00`0oooo3`3KL9<J0?ooo`l00<kA6`3oool?0?l0oa`0oooo3`3oH@8J0?oo
o`l0RR_R703oool?0?oo01/0oooo3`3o000J0?ooo`l00?ZJ7@3oool>0000ogT0oooo00<000000?oo
o`3oool00P3oool001D0oooo00<000000?ooo`3oool03`3oool?0=]`TaX0oooo3`00c]4K0?ooo`l0
o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXM0?ooo`h0
003oMP3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0B0?ooo`l0fg2C
6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0o`00
6P3oool?003jVQd0oooo3P000?mc0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003o
ool0oooo01D0oooo3`3KL9<J0?ooo`l00<kA6`3oool?0?l0oa`0oooo3`3oH@8J0?ooo`l0RR_R703o
ool>0?oo01`0oooo3`3o000J0?ooo`l00?ZJ703oool?0000og00oooo00<000000?ooo`3oool00P3o
ool001D0oooo00<000000?ooo`3oool0603oool?0=]`TaX0oooo3`00c]4K0?ooo`l0o`3o703oool?
0?mQ0QX0oooo3`2::n8L0?ooo`h0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0003oK@3oool0
0`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0K0?ooo`l0fg2C6P3oool?003>
dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3P3oo`0L0?ooo`l0o`006P3oool?003j
VQ`0oooo3`000?mZ0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01h0
oooo3`3KL9<J0?ooo`l00<kA6`3oool>0?l0oad0oooo3`3oH@8J0?ooo`l0RR_R703oool>0?oo01`0
oooo3`3o000J0?ooo`l00?ZJ703oool?0000ofL0oooo00<000000?ooo`3oool00P3oool001D0oooo
00<000000?ooo`3oool08@3oool?0=]`TaX0oooo3`00c]4K0?ooo`h0o`3o7@3oool?0?mQ0QX0oooo
3`2::n8K0?ooo`l0ool0703oool?0?l001X0oooo3`00nYXL0?ooo`l0003oI03oool00`000000oooo
0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0T0?ooo`l0fg2C6P3oool?003>dA/0oooo3P3o
0?lM0?ooo`l0of426P3oool?08X[hQ/0oooo3`3oo`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3`00
0?mQ0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo02L0oooo3P3KL9<K
0?ooo`l00<kA6`3oool>0?l0oad0oooo3P3oH@8K0?ooo`l0RR_R6`3oool?0?oo01`0oooo3`3o000J
0?ooo`l00?ZJ703oool?0000oeh0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?oo
o`3oool01`3oool5000001h0oooo3P3KL9<K0?ooo`h00<kA6`3oool?0?l0oad0oooo3P3oH@8K0?oo
o`h0RR_R703oool?0?oo01`0oooo3P3o000K0?ooo`h00?ZJ7@3oool?0000oe/0oooo00<000000?oo
o`3oool00P3oool001D0oooo0`0000070?ooo`P000007P3oool>0=]`Ta/0oooo3P00c]4K0?ooo`l0
o`3o7@3oool>0?mQ0Q/0oooo3P2::n8L0?ooo`l0ool0703oool>0?l001/0oooo3P00nYXM0?ooo`l0
003oEP3oool3000000@0oooo000E0?ooo`030000003oool0oooo00L0oooo2`00000N0?ooo`h0fg2C
6`3oool>003>dA/0oooo3`3o0?lM0?ooo`h0of426`3oool>08X[hQ`0oooo3`3oo`0L0?ooo`h0o`00
6`3oool>003jVQd0oooo3`000?mE0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003o
ool0oooo00L0oooo3P00000M0?ooo`l0fg2C6`3oool>003>dA/0oooo3`3o0?lL0?ooo`l0of426`3o
ool>08X[hQ`0oooo3`3oo`0L0?ooo`h0o`006`3oool>003jVQd0oooo3`000?mB0?ooo`030000003o
ool0oooo0080oooo000E0?ooo`030000003oool0oooo00T0oooo3`00000M0?ooo`l0fg2C6P3oool?
003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0o`006P3oool?
003jVQd0oooo3`000?m?0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo
00`0oooo3`00000M0?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[
hQ`0oooo3`3oo`0K0?ooo`l0o`006P3oool?003jVQd0oooo3`000?m<0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo00l0oooo3`00000M0?ooo`l0fg2C6P3oool?003>dA/0
oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0o`006P3oool?003jVQd0
oooo3`000?m90?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0180oooo
3`00000M0?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo
3`3oo`0K0?ooo`l0o`006P3oool?003jVQd0oooo3`000?m60?ooo`030000003oool0oooo0080oooo
000E0?ooo`030000003oool0oooo01D0oooo3`00000M0?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o
0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0o`006P3oool?003jVQd0oooo3P00
0?m40?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01P0oooo3`00000M
0?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K
0?ooo`l0o`006P3oool?003jVQd0oooo3P000?m10?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo01/0oooo3`00000M0?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL0?oo
o`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0o`006P3oool?003jVQd0oooo3P000?ln0?oo
o`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo01h0oooo3`00000M0?ooo`l0
fg2C6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?ooo`l0
o`006P3oool?003jVQd0oooo3P000?lk0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000
003oool0oooo0240oooo3`00000M0?ooo`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of42
6P3oool?08X[hQ`0oooo3P3oo`0L0?ooo`l0o`006P3oool?003jVQ`0oooo3`000?lh0?ooo`030000
003oool0oooo0080oooo000E0?ooo`030000003oool0oooo02@0oooo3`00000M0?ooo`l0fg2C6P3o
ool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3P3oo`0L0?ooo`l0o`006P3o
ool?003jVQ`0oooo3`000?le0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo02L0oooo3`00000M0?ooo`h0fg2C6`3oool>003>dA`0oooo3`3o0?lL0?ooo`h0of426`3oool>
08X[hQd0oooo3P3oo`0L0?ooo`h0o`006`3oool>003jVQd0oooo3`000?lb0?ooo`030000003oool0
oooo0080oooo000E0?ooo`<00000:P3oool?000001d0oooo3P3KL9<K0?ooo`h00<kA703oool?0?l0
oa`0oooo3P3oH@8K0?ooo`h0RR_R7@3oool>0?oo01`0oooo3P3o000K0?ooo`h00?ZJ7@3oool?0000
obd0oooo0`0000040?ooo`005@3oool00`000000oooo0?ooo`0]0?ooo`l000007@3oool>0=]`Ta/0
oooo3P00c]4L0?ooo`h0o`3o7@3oool>0?mQ0Q/0oooo3P2::n8L0?ooo`l0ool0703oool>0?l001/0
oooo3P00nYXM0?ooo`l0003o;03oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo
0?ooo`0`0?ooo`l000007@3oool>0=]`Ta/0oooo3P00c]4L0?ooo`h0o`3o7@3oool>0?mQ0Q/0oooo
3P2::n8L0?ooo`l0ool0703oool>0?l001/0oooo3P00nYXM0?ooo`l0003o:@3oool00`000000oooo
0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0c0?ooo`l00000703oool?0=]`TaX0oooo3`00
c]4L0?ooo`h0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00
nYXM0?ooo`l0003o9P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0f
0?ooo`l00000703oool?0=]`TaX0oooo3`00c]4L0?ooo`h0o`3o703oool?0?mQ0QX0oooo3`2::n8L
0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXM0?ooo`l0003o8`3oool00`000000oooo0?ooo`02
0?ooo`005@3oool00`000000oooo0?ooo`0i0?ooo`h000007@3oool?0=]`TaX0oooo3`00c]4K0?oo
o`l0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXM0?oo
o`l0003o803oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0l0?ooo`h0
00007@3oool?0=]`TaX0oooo3`00c]4K0?ooo`l0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0
ool06`3oool?0?l001X0oooo3`00nYXM0?ooo`l0003o7@3oool00`000000oooo0?ooo`020?ooo`00
5@3oool00`000000oooo0?ooo`0o0?ooo`h000007@3oool?0=]`TaX0oooo3`00c]4K0?ooo`l0o`3o
703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXM0?ooo`l0003o
6P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`120?ooo`h000007@3o
ool?0=]`TaX0oooo3`00c]4K0?ooo`l0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3o
ool?0?l001X0oooo3`00nYXM0?ooo`l0003o5`3oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`140?ooo`l000007@3oool?0=]`TaX0oooo3`00c]4K0?ooo`l0o`3o703oool?
0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXM0?ooo`l0003o503oool0
0`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`170?ooo`l000007@3oool?0=]`
TaX0oooo3`00c]4K0?ooo`l0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l0
01X0oooo3`00nYXM0?ooo`l0003o4@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000
oooo0?ooo`1:0?ooo`l000007@3oool?0=]`TaX0oooo3`00c]4K0?ooo`l0o`3o703oool?0?mQ0QX0
oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXM0?ooo`l0003o3P3oool00`000000
oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`1=0?ooo`l000007@3oool?0=]`TaX0oooo
3`00c]4K0?ooo`l0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo
3`00nYXM0?ooo`l0003o2`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?oo
o`1@0?ooo`l000007@3oool>0=]`Ta/0oooo3P00c]4L0?ooo`l0o`3o703oool>0?mQ0Q/0oooo3`2:
:n8L0?ooo`l0ool06`3oool>0?l001/0oooo3`00nYXM0?ooo`d0003o2P3oool00`000000oooo0?oo
o`020?ooo`005@3oool3000005<0oooo3`00000M0?ooo`h0fg2C6`3oool>003>dA`0oooo3`3o0?lL
0?ooo`h0of426`3oool>08X[hQd0oooo3`3oo`0K0?ooo`h0o`006`3oool>003jVQh0oooo2P000?l8
0?ooo`<00000103oool001D0oooo00<000000?ooo`3oool0EP3oool?000001d0oooo3P3KL9<K0?oo
o`h00<kA703oool?0?l0oa`0oooo3P3oH@8K0?ooo`h0RR_R7@3oool?0?oo01/0oooo3P3o000K0?oo
o`h00?ZJ7P3oool70000o`X0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3o
ool0F@3oool?000001d0oooo3P3KL9<K0?ooo`h00<kA703oool?0?l0oa`0oooo3P3oH@8K0?ooo`h0
RR_R7@3oool?0?oo01/0oooo3P3o000K0?ooo`h00?ZJ7P3oool40000o`X0oooo00<000000?ooo`3o
ool00P3oool001D0oooo00<000000?ooo`3oool0G03oool?000001`0oooo3`3KL9<J0?ooo`l00<kA
703oool?0?l0oa/0oooo3`3oH@8K0?ooo`h0RR_R7@3oool>0?oo01/0oooo3`3o000K0?ooo`h00?ZJ
:@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`1O0?ooo`l00000703o
ool?0=]`TaX0oooo3`00c]4L0?ooo`l0o`3o6`3oool?0?mQ0QX0oooo3`2::n8M0?ooo`h0ool06`3o
ool?0?l001X0oooo3`00nYXV0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo0680oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0of426P3oool?
08X[hQd0oooo3P3oo`0K0?ooo`l0o`006P3oool?003jVR<0oooo00<000000?ooo`3oool00P3oool0
01D0oooo00<000000?ooo`3oool0I@3oool?000001`0oooo3`3KL9<J0?ooo`l00<kA703oool?0?l0
oa/0oooo3`3oH@8J0?ooo`l0RR_R7@3oool>0?oo01/0oooo3`3o000J0?ooo`l00?ZJ803oool00`00
0000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`1X0?ooo`l00000703oool?0=]`TaX0
oooo3`00c]4L0?ooo`h0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0
oooo3`00nYXM0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo06/0oooo
3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3P3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo
3`3oo`0K0?ooo`l0o`006P3oool?003jVQX0oooo00<000000?ooo`3oool00P3oool001D0oooo00<0
00000?ooo`3oool0KP3oool?000001`0oooo3`3KL9<J0?ooo`l00<kA703oool>0?l0oa`0oooo3`3o
H@8J0?ooo`l0RR_R703oool?0?oo01/0oooo3`3o000J0?ooo`l00?ZJ5`3oool00`000000oooo0?oo
o`020?ooo`005@3oool00`000000oooo0?ooo`1a0?ooo`h000007@3oool?0=]`TaX0oooo3`00c]4L
0?ooo`h0o`3o703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYXD
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo07@0oooo3P00000M0?oo
o`l0fg2C6P3oool?003>dA/0oooo3`3o0?lL0?ooo`l0of426P3oool?08X[hQ`0oooo3`3oo`0K0?oo
o`l0o`006P3oool?003jVQ40oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3o
ool0M`3oool>000001d0oooo3`3KL9<J0?ooo`l00<kA6`3oool?0?l0oa`0oooo3`3oH@8J0?ooo`l0
RR_R703oool?0?oo01/0oooo3`3o000J0?ooo`l00?ZJ3P3oool00`000000oooo0?ooo`020?ooo`00
5@3oool00`000000oooo0?ooo`1j0?ooo`h000007@3oool>0=]`Ta/0oooo3`00c]4K0?ooo`l0o`3o
703oool?0?mQ0QX0oooo3`2::n8L0?ooo`l0ool06`3oool?0?l001X0oooo3`00nYX;0?ooo`030000
003oool0oooo0080oooo000E0?ooo`030000003oool0oooo07`0oooo3`00000M0?ooo`h0fg2C6`3o
ool>003>dA`0oooo3`3o0?lL0?ooo`h0of426`3oool>08X[hQd0oooo3`3oo`0K0?ooo`h0o`006`3o
ool=003jVPX0oooo00<000000?ooo`3oool00P3oool001D0oooo0`00001o0?ooo`l000007@3oool>
0=]`Ta/0oooo3P00c]4L0?ooo`l0o`3o703oool>0?mQ0Q/0oooo3P2::n8M0?ooo`l0ool06`3oool>
0?l001/0oooo2P00nYX80?ooo`<00000103oool001D0oooo00<000000?ooo`3oool0PP3oool?0000
01d0oooo3P3KL9<K0?ooo`h00<kA703oool?0?l0oa`0oooo3P3oH@8K0?ooo`h0RR_R7@3oool?0?oo
01/0oooo3P3o000K0?ooo`L00?ZJ2P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000
oooo0?ooo`250?ooo`l00000703oool?0=]`Ta/0oooo3P00c]4L0?ooo`l0o`3o703oool>0?mQ0Q/0
oooo3P2::n8M0?ooo`l0ool06`3oool>0?l001/0oooo1000nYX:0?ooo`030000003oool0oooo0080
oooo000E0?ooo`030000003oool0oooo08P0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo
3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0J0?ooo`l0o`009P3oool00`000000oooo
0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`2;0?ooo`l00000703oool?0=]`TaX0oooo3`00
c]4L0?ooo`l0o`3o6`3oool?0?mQ0QX0oooo3`2::n8M0?ooo`l0ool06P3oool?0?l002<0oooo00<0
00000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0SP3oool?000001`0oooo3`3KL9<J
0?ooo`l00<kA703oool?0?l0oa/0oooo3`3oH@8J0?ooo`l0RR_R7@3oool?0?oo01X0oooo3`3o000P
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0940oooo3`00000L0?oo
o`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0J0?oo
o`l0o`007@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`2D0?ooo`l0
0000703oool?0=]`TaX0oooo3`00c]4L0?ooo`l0o`3o6`3oool?0?mQ0QX0oooo3`2::n8M0?ooo`h0
ool06`3oool?0?l001X0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0
U`3oool?000001`0oooo3`3KL9<J0?ooo`l00<kA703oool?0?l0oa/0oooo3`3oH@8J0?ooo`l0RR_R
7@3oool>0?oo01/0oooo3`3o000G0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003o
ool0oooo09X0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0of426P3o
ool?08X[hQd0oooo3P3oo`0K0?ooo`l0o`00503oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`2M0?ooo`l00000703oool?0=]`TaX0oooo3`00c]4L0?ooo`l0o`3o6`3oool?
0?mQ0QX0oooo3`2::n8M0?ooo`h0ool06`3oool?0?l00140oooo00<000000?ooo`3oool00P3oool0
01D0oooo00<000000?ooo`3oool0X03oool?000001`0oooo3`3KL9<J0?ooo`l00<kA703oool>0?l0
oa`0oooo3`3oH@8J0?ooo`l0RR_R703oool?0?oo01/0oooo3`3o000>0?ooo`030000003oool0oooo
0080oooo00040?ooo`<000000`3oool3000000P0oooo00<000000?ooo`3oool0X`3oool?000001`0
oooo3`3KL9<J0?ooo`l00<kA703oool>0?l0oa`0oooo3`3oH@8J0?ooo`l0RR_R703oool?0?oo01/0
oooo3`3o000;0?ooo`030000003oool0oooo0080oooo00050?ooo`050000003oool0oooo0?ooo`00
00000`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:H0oooo3`00000L0?ooo`h0
fg2C6`3oool>003>dAd0oooo3P3o0?lL0?ooo`h0of426`3oool>08X[hQd0oooo3`3oo`0K0?ooo`d0
o`002P3oool00`000000oooo0?ooo`020?ooo`001@3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00D0oooo1000002X0?ooo`l00000703oool>0=]`Ta/0oooo3P00c]4M0?ooo`h0o`3o
703oool>0?mQ0Q/0oooo3P2::n8M0?ooo`l0ool06`3oool:0?l000L0oooo100000040?ooo`001@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[03o
ool>000001d0oooo3P3KL9<K0?ooo`h00<kA703oool?0?l0oa`0oooo3P3oH@8K0?ooo`h0RR_R7@3o
ool?0?oo01/0oooo1`3o000:0?ooo`030000003oool0oooo0080oooo00050?ooo`040000003oool0
oooo0?ooo`@00000203oool00`000000oooo0?ooo`2_0?ooo`h000007@3oool>0=]`Ta/0oooo3P00
c]4L0?ooo`l0o`3o703oool>0?mQ0Q/0oooo3P2::n8M0?ooo`l0ool06`3oool40?l000X0oooo00<0
00000?ooo`3oool00P3oool000@0oooo0P0000030?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool0/P3oool>000001`0oooo3`3KL9<J0?ooo`l00<kA703oool?0?l0oa/0oooo3`3oH@8J
0?ooo`l0RR_R7@3oool?0?oo02H0oooo00<000000?ooo`3oool00P3oool000D0oooo00@000000?oo
o`3oool0oooo1@0000070?ooo`030000003oool0oooo0;D0oooo3P00000L0?ooo`l0fg2C6P3oool?
003>dA`0oooo3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0S0?ooo`030000003oool0
oooo0080oooo000E0?ooo`030000003oool0oooo0;L0oooo3`00000L0?ooo`l0fg2C6P3oool?003>
dA`0oooo3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0P0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo0;X0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0
oooo3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0M0?ooo`030000003oool0oooo0080
oooo000E0?ooo`030000003oool0oooo0;d0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo
3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0J0?ooo`030000003oool0oooo0080oooo
000E0?ooo`030000003oool0oooo0<00oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o
0?lK0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0G0?ooo`030000003oool0oooo0080oooo000E
0?ooo`030000003oool0oooo0<<0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK
0?ooo`l0of426P3oool?08X[hQd0oooo3`3oo`0D0?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo0<H0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?oo
o`l0of426P3oool?08X[hQd0oooo3`3oo`0A0?ooo`030000003oool0oooo0080oooo000E0?ooo`03
0000003oool0oooo0<T0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0
of426P3oool?08X[hQd0oooo3`3oo`0>0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000
003oool0oooo0<`0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0of42
6P3oool?08X[hQd0oooo3`3oo`0;0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003o
ool0oooo0<l0oooo3`00000L0?ooo`h0fg2C6`3oool?003>dA`0oooo3`3o0?lK0?ooo`h0of426`3o
ool?08X[hQd0oooo3@3oo`0:0?ooo`030000003oool0oooo0080oooo000E0?ooo`<00000dP3oool?
000001`0oooo3P3KL9<K0?ooo`h00<kA7@3oool?0?l0oa/0oooo3P3oH@8K0?ooo`h0RR_R7P3oool:
0?oo00P0oooo0`0000040?ooo`005@3oool00`000000oooo0?ooo`3E0?ooo`l00000703oool>0=]`
Ta/0oooo3P00c]4M0?ooo`l0o`3o6`3oool>0?mQ0Q/0oooo3P2::n8N0?ooo`L0ool02P3oool00`00
0000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3H0?ooo`l00000703oool>0=]`Ta/0
oooo3P00c]4M0?ooo`l0o`3o6`3oool>0?mQ0Q/0oooo3P2::n8N0?ooo`@0ool02P3oool00`000000
oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3K0?ooo`l000006`3oool?0=]`Ta/0oooo
3P00c]4M0?ooo`h0o`3o6`3oool?0?mQ0Q/0oooo3P2::n8Y0?ooo`030000003oool0oooo0080oooo
000E0?ooo`030000003oool0oooo0=h0oooo3`00000K0?ooo`l0fg2C6P3oool?003>dAd0oooo3P3o
0?lK0?ooo`l0of426P3oool?08X[hRH0oooo00<000000?ooo`3oool00P3oool001D0oooo00<00000
0?ooo`3oool0h@3oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool>0?l0oa/0oooo3`3oH@8J
0?ooo`l0RR_R8`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3T0?oo
o`l000006`3oool?0=]`TaX0oooo3`00c]4M0?ooo`h0o`3o6`3oool?0?mQ0QX0oooo3`2::n8P0?oo
o`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0>L0oooo3P00000L0?ooo`l0
fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0of426P3oool?08X[hQd0oooo00<000000?ooo`3o
ool00P3oool001D0oooo00<000000?ooo`3oool0jP3oool>000001`0oooo3`3KL9<J0?ooo`l00<kA
703oool?0?l0oa/0oooo3`3oH@8J0?ooo`l0RR_R6P3oool00`000000oooo0?ooo`020?ooo`005@3o
ool00`000000oooo0?ooo`3]0?ooo`h00000703oool?0=]`TaX0oooo3`00c]4L0?ooo`l0o`3o6`3o
ool?0?mQ0QX0oooo3`2::n8G0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo0?00oooo3P00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo3`3o0?lK0?ooo`l0of426P3oool?
08X[hQ@0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0lP3oool?0000
01`0oooo3`3KL9<J0?ooo`l00<kA703oool?0?l0oa/0oooo3`3oH@8J0?ooo`l0RR_R4@3oool00`00
0000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3e0?ooo`l00000703oool?0=]`TaX0
oooo3`00c]4L0?ooo`l0o`3o6`3oool?0?mQ0QX0oooo3`2::n8>0?ooo`030000003oool0oooo0080
oooo000E0?ooo`030000003oool0oooo0?P0oooo3`00000L0?ooo`l0fg2C6P3oool?003>dA`0oooo
3`3o0?lK0?ooo`l0of426P3oool?08X[hP/0oooo00<000000?ooo`3oool00P3oool001D0oooo00<0
00000?ooo`3oool0n`3oool?000001`0oooo3P3KL9<K0?ooo`h00<kA7@3oool?0?l0oa/0oooo3P3o
H@8K0?ooo`d0RR_R2P3oool00`000000oooo0?ooo`020?ooo`005@3oool300000?h0oooo3`00000L
0?ooo`h0fg2C6`3oool>003>dAd0oooo3`3o0?lK0?ooo`h0of426`3oool:08X[hPP0oooo0`000004
0?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`80oooo3`00000L0?ooo`h0fg2C6`3oool>003>
dAd0oooo3`3o0?lK0?ooo`h0of426`3oool708X[hPX0oooo00<000000?ooo`3oool00P3oool001D0
oooo00<000000?ooo`3oool0o`3oool50?ooo`l00000703oool>0=]`Ta/0oooo3P00c]4M0?ooo`l0
o`3o6`3oool>0?mQ0Q/0oooo102::n8:0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000
003oool0oooo0?l0oooo203oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool?0?l0oaX0oooo
3`3oH@8V0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0oooo2`3o
ool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool?0?l0oaX0oooo3`3oH@8S0?ooo`030000003o
ool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0oooo3P3oool?000001/0oooo3`3KL9<J
0?ooo`l00<kA7@3oool?0?l0oaX0oooo3`3oH@8P0?ooo`030000003oool0oooo0080oooo000E0?oo
o`030000003oool0oooo0?l0oooo4@3oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool?0?l0
oaX0oooo3`3oH@8M0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0
oooo503oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool>0?l0oa/0oooo3`3oH@8J0?ooo`03
0000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0oooo5`3oool?000001/0oooo
3`3KL9<J0?ooo`l00<kA7@3oool>0?l0oa/0oooo3`3oH@8G0?ooo`030000003oool0oooo0080oooo
000E0?ooo`030000003oool0oooo0?l0oooo6P3oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3o
ool>0?l0oa/0oooo3`3oH@8D0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0
oooo0?l0oooo7@3oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool>0?l0oa/0oooo3`3oH@8A
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0oooo803oool>0000
01`0oooo3`3KL9<J0?ooo`l00<kA703oool?0?l0oa/0oooo3`3oH@8>0?ooo`030000003oool0oooo
0080oooo000E0?ooo`030000003oool0oooo0?l0oooo8`3oool>000001`0oooo3`3KL9<J0?ooo`l0
0<kA703oool?0?l0oa/0oooo3`3oH@8;0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000
003oool0oooo0?l0oooo9P3oool>000001`0oooo3P3KL9<K0?ooo`h00<kA7@3oool?0?l0oa/0oooo
3@3oH@8:0?ooo`030000003oool0oooo0080oooo000E0?ooo`<00000o`3ooolY0?ooo`h00000703o
ool>0=]`Ta/0oooo3P00c]4M0?ooo`l0o`3o6`3oool:0?mQ0PP0oooo0`0000040?ooo`005@3oool0
0`000000oooo0?ooo`3o0?ooob/0oooo3`00000L0?ooo`h0fg2C6`3oool>003>dAd0oooo3`3o0?lK
0?ooo`L0of422P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oo
obh0oooo3`00000L0?ooo`h0fg2C6`3oool>003>dAd0oooo3`3o0?lK0?ooo`@0of422P3oool00`00
0000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oooc40oooo3`00000K0?ooo`l0
fg2C6P3oool?003>dAd0oooo3`3o0?lV0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000
003oool0oooo0?l0oooo=03oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3oool?0?l0ob<0oooo
00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooolg0?ooo`l000006`3o
ool?0=]`TaX0oooo3`00c]4M0?ooo`l0o`3o803oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`3o0?ooocX0oooo3`00000K0?ooo`l0fg2C6P3oool?003>dAd0oooo3`3o0?lM
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0oooo?@3oool?0000
01/0oooo3`3KL9<J0?ooo`l00<kA7@3oool?0?l0oaX0oooo00<000000?ooo`3oool00P3oool001D0
oooo00<000000?ooo`3oool0o`3ooom00?ooo`l000006`3oool?0=]`TaX0oooo3`00c]4M0?ooo`l0
o`3o5`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oood<0oooo
3`00000K0?ooo`l0fg2C6P3oool?003>dAd0oooo3`3o0?lD0?ooo`030000003oool0oooo0080oooo
000E0?ooo`030000003oool0oooo0?l0ooooAP3oool?000001/0oooo3`3KL9<J0?ooo`l00<kA7@3o
ool?0?l0oa40oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooom9
0?ooo`l000006`3oool?0=]`TaX0oooo3`00c]4M0?ooo`l0o`3o3P3oool00`000000oooo0?ooo`02
0?ooo`005@3oool00`000000oooo0?ooo`3o0?oood`0oooo3`00000K0?ooo`l0fg2C6P3oool?003>
dAd0oooo3`3o0?l;0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0
ooooC`3oool?000001/0oooo3P3KL9<K0?ooo`l00<kA7@3oool=0?l0o`X0oooo00<000000?ooo`3o
ool00P3oool001D0oooo0`00003o0?oooe80oooo3`00000K0?ooo`h0fg2C6`3oool>003>dAh0oooo
2P3o0?l80?ooo`<00000103oool001D0oooo00<000000?ooo`3oool0o`3ooomE0?ooo`l000006`3o
ool>0=]`Ta/0oooo3P00c]4N0?ooo`L0o`3o2P3oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`3o0?oooeP0oooo3`00000K0?ooo`h0fg2C6`3oool>003>dAh0oooo103o0?l:
0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0ooooF`3oool>0000
01/0oooo3`3KL9<K0?ooo`h00<kA:@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000
oooo0?ooo`3o0?oooeh0oooo3P00000K0?ooo`l0fg2C6P3oool?003>dBH0oooo00<000000?ooo`3o
ool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooomQ0?ooo`h000006`3oool?0=]`TaX0oooo
3`00c]4S0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0ooooI03o
ool>000001/0oooo3`3KL9<J0?ooo`l00<kA803oool00`000000oooo0?ooo`020?ooo`005@3oool0
0`000000oooo0?ooo`3o0?ooofH0oooo3`00000K0?ooo`l0fg2C6P3oool?003>dAd0oooo00<00000
0?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooomY0?ooo`l000006`3oool?0=]`
TaX0oooo3`00c]4J0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003oool0oooo0?l0
ooooK03oool?000001/0oooo3`3KL9<J0?ooo`l00<kA5`3oool00`000000oooo0?ooo`020?ooo`00
5@3oool00`000000oooo0?ooo`3o0?ooofl0oooo3`00000K0?ooo`l0fg2C6P3oool?003>dA@0oooo
00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooomb0?ooo`l000006`3o
ool?0=]`TaX0oooo3`00c]4A0?ooo`030000003oool0oooo0080oooo00030?ooo`D000000`3oool2
000000P0oooo00<000000?ooo`3oool0o`3ooome0?ooo`l000006`3oool?0=]`TaX0oooo3`00c]4>
0?ooo`030000003oool0oooo0080oooo00040?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000001`3oool00`000000oooo0?ooo`3o0?ooogP0oooo3`00000K0?ooo`l0fg2C6P3o
ool?003>d@/0oooo00<000000?ooo`3oool00P3oool000D0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`0000070?ooo`030000003oool0oooo0?l0ooooN`3oool?000001/0oooo3P3K
L9<K0?ooo`d00<kA2P3oool00`000000oooo0?ooo`020?ooo`001P3oool01@000000oooo0?ooo`3o
ool000000080oooo00<000000?ooo`3oool01@3oool400000?l0ooooO@3oool?000001/0oooo3P3K
L9<K0?ooo`X00<kA1`3oool4000000@0oooo00030?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo0?l0ooooP@3oool?000001/0oooo
3P3KL9<K0?ooo`L00<kA2P3oool00`000000oooo0?ooo`020?ooo`000`3oool01@000000oooo0?oo
o`3oool000000080oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?ooo`3o0?oooh@0
oooo3`00000K0?ooo`h0fg2C6`3oool4003>d@X0oooo00<000000?ooo`3oool00P3oool000@0oooo
0`0000040?ooo`800000203oool00`000000oooo0?ooo`3o0?ooohL0oooo3`00000J0?ooo`l0fg2C
9P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?ooohX0oooo3`00
000J0?ooo`l0fg2C8`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o
0?ooohd0oooo3`00000J0?ooo`l0fg2C803oool00`000000oooo0?ooo`020?ooo`005@3oool00`00
0000oooo0?ooo`3o0?oooi00oooo3`00000J0?ooo`l0fg2C7@3oool00`000000oooo0?ooo`020?oo
o`005@3oool00`000000oooo0?ooo`3o0?oooi<0oooo3P00000K0?ooo`l0fg2C6P3oool00`000000
oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oooiH0oooo3P00000K0?ooo`l0fg2C
5`3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oooiT0oooo3P00
000K0?ooo`l0fg2C503oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o
0?oooi`0oooo3P00000K0?ooo`l0fg2C4@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`00
0000oooo0?ooo`3o0?oooih0oooo3`00000K0?ooo`l0fg2C3P3oool00`000000oooo0?ooo`020?oo
o`005@3oool00`000000oooo0?ooo`3o0?oooj40oooo3`00000K0?ooo`l0fg2C2`3oool00`000000
oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`3o0?oooj@0oooo3`00000K0?ooo`d0fg2C
2P3oool00`000000oooo0?ooo`020?ooo`005@3oool300000?l0ooooY`3oool?000001/0oooo2P3K
L9<80?ooo`<00000103oool001D0oooo00<000000?ooo`3oool0o`3ooonZ0?ooo`l000006`3oool7
0=]`T`X0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3oool0o`3ooon]0?oo
o`l000006`3oool40=]`T`X0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3o
ool0o`3ooon`0?ooo`l000009P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo
0?ooo`3o0?oook<0oooo3`00000S0?ooo`030000003oool0oooo0080oooo000E0?ooo`030000003o
ool0oooo0?l0oooo]P3oool?00000200oooo00<000000?ooo`3oool00P3oool001D0oooo00<00000
0?ooo`3oool0o`3oooni0?ooo`l000007@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`00
0000oooo0?ooo`3o0?oook`0oooo3`00000J0?ooo`030000003oool0oooo0080oooo000E0?ooo`03
0000003oool0oooo0?l0oooo_`3oool?000001L0oooo00<000000?ooo`3oool00P3oool001D0oooo
00<000000?ooo`3oool0o`3oooo20?ooo`l00000503oool00`000000oooo0?ooo`020?ooo`005@3o
ool00`000000oooo0?ooo`3o0?ooolD0oooo3`00000A0?ooo`030000003oool0oooo0080oooo000E
0?ooo`030000003oool0oooo0?l0oooob03oool?000000h0oooo00<000000?ooo`3oool00P3oool0
01D0oooo00<000000?ooo`3oool0o`3oooo;0?ooo`l000002`3oool00`000000oooo0?ooo`020?oo
o`005@3oool00`000000oooo0?ooo`3o0?ooolh0oooo3@00000:0?ooo`030000003oool0oooo0080
oooo000E0?ooo`<00000o`3ooooA0?ooo`X00000203oool3000000@0oooo000E0?ooo`030000003o
ool0oooo0?l0ooooe03oool7000000X0oooo00<000000?ooo`3oool00P3oool001D0oooo00<00000
0?ooo`3oool0o`3ooooG0?ooo`@000002P3oool00`000000oooo0?ooo`020?ooo`005@3oool00`00
0000oooo0?ooo`3o0?ooonD0oooo00<000000?ooo`3oool00P3oool001D0oooo00<000000?ooo`3o
ool0<`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3o
ool0DP3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`020?ooo`005@3oool00`000000oooo0?ooo`0c0?ooo`030000
003oool0oooo0540oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`1B0?ooo`030000
003oool0oooo0540oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo0080oooo000E0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0080oooo000E0?ooool00000j@000004
0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 512}, {315.938, 0}} -> {0.212832, 0.446942, \
0.023727, 0.0698019}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{806, 544},
WindowMargins->{{73, Automatic}, {Automatic, 61}},
MacintoshSystemPageSetup->"\<\
0000001804P000000bd2=_oaoo43?095o`85N@?NW0002008ool000001@050001
0000I24A4R060`410@000BL?0040000000000000000004E3<34100;o00000001
000A0S<R<3`00Q3400018NOWinOWia4A\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 67, 1, 39, "Input"],
Cell[1846, 56, 177, 3, 22, "Print"],
Cell[2026, 61, 61117, 1355, 325, 14779, 778, "GraphicsData", "PostScript", \
"Graphics"],
Cell[63146, 1418, 130, 3, 38, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

