(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   6055181,     253183]*)
(*NotebookOutlinePosition[   6056071,     253213]*)
(*  CellTagsIndexPosition[   6056027,     253209]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{\(\(\(@\)\(TECHREPORT\)\) {Singer : 
          2006  c, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {{Continuous - 
                Discrete\ Unscented\ Kalman\ Filtering}}, \
\[IndentingNewLine]INSTITUTION = {{FernUniversit \*"\\\"" at\ in\ Hagen}}, 
        TYPE = {{Diskussionsbeitr \*"\\\"" 
                age\ Fach\\\(-be\)\\\(-reich\)\ Wirtschaftswissenschaft}}, 
        NOTE = {\(\(http\)\(:\)\)\  // 
              www . fernuni - \(\(\(\(hagen . de/FBWIWI\)/forschung\)/
                      beitraege\)/pdf\)/
                  db384 . pdf}, \[IndentingNewLine]NUMBER = {384}, 
        YEAR = {2006}}\), "\[IndentingNewLine]", 
    RowBox[{
      StyleBox[\(\(=\)\(UKF . pdf\)\),
        FontColor->RGBColor[0, 1, 0]], 
      "\[IndentingNewLine]"}], "\[IndentingNewLine]", \(\(\(@\)\(TECHREPORT\)\
\) {Singer : 
          2006  d, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {{Generalized\ Gauss - 
                Hermite\ Filtering}}, \[IndentingNewLine]INSTITUTION = \
{{FernUniversit \*"\\\"" at\ in\ Hagen}}, 
        TYPE = {{Diskussionsbeitr \*"\\\"" 
                age\ Fachbereich\ Wirtschaftswissenschaft}}, 
        NOTE = {\(\(http\)\(:\)\) // 
              www . fernuni - \(\(\(\(hagen . de/FBWIWI\)/forschung\)/
                      beitraege\)/pdf\)/
                  db391 . 
                    pdf}, \[IndentingNewLine]NUMBER = {391}, \
\[IndentingNewLine]YEAR = {2006}}\), "\[IndentingNewLine]", 
    StyleBox[\(\(=\)\(GGHF . pdf\)\),
      FontColor->RGBColor[0, 1, 0]]}], "Input",
  FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell["LorenzX", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Pakete", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["$Path", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({"/Applications/Mathematica 5.2.app/AddOns/JLink", 
      "/Applications/Mathematica 5.2.app/AddOns/NETLink", 
      "/Users/hermannsinger/Library/Mathematica/Kernel", 
      "/Users/hermannsinger/Library/Mathematica/Autoload", 
      "/Users/hermannsinger/Library/Mathematica/Applications", 
      "/Library/Mathematica/Kernel", "/Library/Mathematica/Autoload", 
      "/Library/Mathematica/Applications", ".", "/Users/hermannsinger", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages/StartUp", 
      "/Applications/Mathematica 5.2.app/AddOns/Autoload", 
      "/Applications/Mathematica 5.2.app/AddOns/Applications", 
      "/Applications/Mathematica 5.2.app/AddOns/ExtraPackages", 
      "/Applications/Mathematica 5.2.app/SystemFiles/Graphics/Packages", 
      "/Applications/Mathematica 5.2.app/Configuration/Kernel", "/SDE/", 
      "/SDE/code/"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Unprotect[RungeKutta];

<<RungeKutta1.m
<<Kuba.Impl.m
<<Kalman.exakt.impl.m\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomMultinomial\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomMultinomial\\) in \\!\\(RandomMultinomial[\\(\\(xij_, pij_, n_\\)\
\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomNumbers\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomNumbers\\) in \\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(alphanorm\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Clear :: \\\"wrsym\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(alphanorm\\) in \\!\\(alphanorm[x_]\\) is Protected. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(SetDelayed :: \\\"write\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell["SetOptions[plot1,dicke->.001];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["System-Matrizen", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Clear[x,y,z,sigma,r,b]


driftLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}] := 
\t{-sigma (x - y),
\t -x z + r x - y,
\t  x y - b z     } 
\t\t\t\t\t\t\t\t          
DdriftLorenz//Clear
DdriftLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}] = 
\tOuter[D,driftLorenz[{x,y,z},t,{sigma,r,b}],{x,y,z}] 
\t\t\t\t\t\t\t\t\t          
diffusionLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}] = DiagonalMatrix[2{1,1,1}]

hLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}] := {x,y,z}

DhLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}] = DiagonalMatrix[{1.,1.,1.}]

RLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}] = DiagonalMatrix[{1,1,1}]

mueLorenz[t_,{sigma_,r_,b_}] = {0,0,0}

sigmaLorenz[t_,{sigma_,r_,b_}] = DiagonalMatrix[{10,10,10}]

p0Lorenz[t_,{sigma_,r_,b_},n_] := 
\tModule[{y0,P0,nn=Shape[1,n]},
\t y0 = mueLorenz[t,{sigma,r,b}];
\t y0 = nn/.(1->y0);
\t P0 = sigmaLorenz[t,{sigma,r,b}];
\t P0 = nn/. (1->P0);
\t 
\t {y0,P0,1./n}\t 
\t ];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(DdriftLorenz\\)\\\" is similar to existing \
symbol \\\"\\!\\(driftLorenz\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({{\(-sigma\), sigma, 0}, {r - z, \(-1\), \(-x\)}, {y, 
        x, \(-b\)}}\)], "Output"],

Cell[BoxData[
    \({{2, 0, 0}, {0, 2, 0}, {0, 0, 2}}\)], "Output"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(DhLorenz\\)\\\" is similar to existing \
symbol \\\"\\!\\(hLorenz\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({{1.`, 0, 0}, {0, 1.`, 0}, {0, 0, 1.`}}\)], "Output"],

Cell[BoxData[
    \({{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}\)], "Output"],

Cell[BoxData[
    \({0, 0, 0}\)], "Output"],

Cell[BoxData[
    \({{10, 0, 0}, {0, 10, 0}, {0, 0, 10}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
driftLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}]\t
DdriftLorenz[{x_,y_,z_},t,{sigma_,r_,b_}]
diffusionLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}]
hLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}]
DhLorenz[{x_,y_,z_},t_,{sigma_,r_,b_}]
mueLorenz[t_,{sigma_,r_,b_}]
sigmaLorenz[t_,{sigma_,r_,b_}] 
p0Lorenz[t_,{sigma_,r_,b_},3]
\t\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({\(-sigma_\)\ \((x_ - y_)\), r_\ x_ - y_ - x_\ z_, 
      x_\ y_ - b_\ z_}\)], "Output"],

Cell[BoxData[
    \({{\(-sigma_\), sigma_, 0}, {r_ - z_, \(-1\), \(-x_\)}, {y_, 
        x_, \(-b_\)}}\)], "Output"],

Cell[BoxData[
    \({{2, 0, 0}, {0, 2, 0}, {0, 0, 2}}\)], "Output"],

Cell[BoxData[
    \({x_, y_, z_}\)], "Output"],

Cell[BoxData[
    \({{1.`, 0, 0}, {0, 1.`, 0}, {0, 0, 1.`}}\)], "Output"],

Cell[BoxData[
    \({0, 0, 0}\)], "Output"],

Cell[BoxData[
    \({{10, 0, 0}, {0, 10, 0}, {0, 0, 10}}\)], "Output"],

Cell[BoxData[
    \({{{0, 0, 0}, {0, 0, 0}, {0, 0, 
          0}}, {{{10, 0, 0}, {0, 10, 0}, {0, 0, 10}}, {{10, 0, 0}, {0, 10, 
            0}, {0, 0, 10}}, {{10, 0, 0}, {0, 10, 0}, {0, 0, 10}}}, 
      0.3333333333333333`}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["X-System-Matrizen", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Clear[driftLorenzX,DdriftLorenzX,DDdriftLorenzX,DDDdriftLorenzX,\
DDDDdriftLorenzX,
     diffusionLorenzX,OmegaLorenzX,DOmegaLorenzX,DDOmegaLorenzX,\
DDDOmegaLorenzX,DDDDOmegaLorenzX,
     hLorenzX,DhLorenzX,RLorenzX,x,y,z,sigma,r,b]

driftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] :=
\tModule[{f},
\tf=driftLorenz[{x,y,z},t,{sigma,r,b}]; 
\t{f,{0,0,0}}//Flatten
]
\t\t\t\t\t\t\t\t          
DdriftLorenzX
DdriftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] = 
\tOuter[D,driftLorenzX[{x,y,z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}] 

DDdriftLorenzX
DDdriftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] = 
\tOuter[D,DdriftLorenzX[{x,y,z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}] 

DDDdriftLorenzX
DDDdriftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] = 
\tOuter[D,DDdriftLorenzX[{x,y,z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}] 
\t\t\t\t\t\t\t\t\t          
DDDDdriftLorenzX
DDDDdriftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] = 
\tOuter[D,DDDdriftLorenzX[{x,y,z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}] 
\t\t\t\t\t\t\t\t\t          \
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(driftLorenzX\\)\\\" is similar to existing \
symbol \\\"\\!\\(driftLorenz\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(DdriftLorenzX\\)\\\" is similar to existing \
symbols \\!\\({DdriftLorenz, driftLorenzX}\\). \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(DDdriftLorenzX\\)\\\" is similar to existing \
symbol \\\"\\!\\(DdriftLorenzX\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\
\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(DDDdriftLorenzX\\)\\\" is similar to \
existing symbol \\\"\\!\\(DDdriftLorenzX\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(General :: \\\"spell1\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(DhLorenzX\\)\\\" is similar to existing \
symbols \\!\\({DhLorenz, hLorenzX}\\). \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\
\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(DdriftLorenzX\)], "Output"],

Cell[BoxData[
    \({{\(-sigma\), sigma, 0, \(-x\) + y, 0, 0}, {r - z, \(-1\), \(-x\), 0, 
        x, 0}, {y, x, \(-b\), 0, 0, \(-z\)}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0}, {0, 0, 0, 0, 0, 0}}\)], "Output"],

Cell[BoxData[
    \(DDdriftLorenzX\)], "Output"],

Cell[BoxData[
    \({{{0, 0, 0, \(-1\), 0, 0}, {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {\(-1\), 1, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, \(-1\), 0, 1, 0}, {0, 0, 0, 0, 0, 0}, {\(-1\), 0, 0, 
          0, 0, 0}, {0, 0, 0, 0, 0, 0}, {1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 1, 0, 0, 0, 0}, {1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
          0, \(-1\)}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, \(-1\), 
          0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}}\)], "Output"],

Cell[BoxData[
    \(DDDdriftLorenzX\)], "Output"],

Cell[BoxData[
    \({{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
            0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
            0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}\)], "Output"],

Cell[BoxData[
    \(DDDDdriftLorenzX\)], "Output"],

Cell[BoxData[
    \({{{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
              0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
              0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
              0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
              0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
diffusionLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_]:=DiagonalMatrix[\
{4.,4.,4.,.0001,.0001,.0001}]
OmegaLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_]:=DiagonalMatrix[{4.,4.,4.,.\
0001,.0001,.0001}^2]
DOmegaLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_]=Outer[D,OmegaLorenzX[{x,y,z,\
sigma,r,b},t,Theta],{x,y,z,sigma,r,b}]
DDOmegaLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_]=Outer[D,DOmegaLorenzX[{x,y,\
z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}]
DDDOmegaLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_]=Outer[D,DDOmegaLorenzX[{x,\
y,z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}]
DDDDOmegaLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_]=Outer[D,DDDOmegaLorenzX[{\
x,y,z,sigma,r,b},t,Theta],{x,y,z,sigma,r,b}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
          0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
          0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
          0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
          0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
          0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}}\)], "Output"],

Cell[BoxData[
    \({{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
            0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
            0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}\)], "Output"],

Cell[BoxData[
    \({{{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
              0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
              0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
              0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
              0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 
              0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
              0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}\)], "Output"],

Cell[BoxData[
    \({{{{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}, {{{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}, {{{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}, {{{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}, {{{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}, {{{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}, {{{{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}}}}, {{{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
                0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 
                0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 
                0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 
                0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}, {{{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
                0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

hLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] := {x,y,z}


DhLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] = \
DiagonalMatrix[{1.,1.,1.}]~ii~Shape[0,{3,3}]

RLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,Theta_] = .1 DiagonalMatrix[{1,1,1}]

mueLorenzX//Clear
mueLorenzX[t_,{sigma_,r_,b_}] = {0,0,0,sigma,r,b}//N

sigmaLorenzX//Clear
sigmaLorenzX[t_,{sigma_,r_,b_}] =\t  
\t\tDiagonalMatrix[{10,10,10,1,1,1}]//N

p0LorenzX//Clear
p0LorenzX[t_,{sigma_,r_,b_},n_] := 
\tModule[{y0,P0,nn=Shape[1,n]},
\t y0 = mueLorenzX[t,{sigma,r,b}];
\t y0 = nn/.(1->y0);
\t P0 = sigmaLorenzX[t,{sigma,r,b}];
\t P0 = nn/. (1->P0);
\t 
\t {y0,P0,1./n}\t 
\t ];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1.`, 0, 0, 0, 0, 0}, {0, 1.`, 0, 0, 0, 0}, {0, 0, 1.`, 0, 0, 
        0}}\)], "Output"],

Cell[BoxData[
    \({{0.1`, 0, 0}, {0, 0.1`, 0}, {0, 0, 0.1`}}\)], "Output"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(mueLorenzX\\)\\\" is similar to existing \
symbol \\\"\\!\\(mueLorenz\\)\\\". \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    \({0.`, 0.`, 0.`, sigma, r, b}\)], "Output"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(sigmaLorenzX\\)\\\" is similar to existing \
symbol \\\"\\!\\(sigmaLorenz\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({{10.`, 0.`, 0.`, 0.`, 0.`, 0.`}, {0.`, 10.`, 0.`, 0.`, 0.`, 
        0.`}, {0.`, 0.`, 10.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 1.`, 0.`, 
        0.`}, {0.`, 0.`, 0.`, 0.`, 1.`, 0.`}, {0.`, 0.`, 0.`, 0.`, 0.`, 
        1.`}}\)], "Output"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(p0LorenzX\\)\\\" is similar to existing \
symbol \\\"\\!\\(p0Lorenz\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
    driftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,{_}] 
   DdriftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,{_}]//MatrixForm 
   DDdriftLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,{_}] 
diffusionLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,{_}] //MatrixForm 
 hLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,{_}] 
DhLorenzX[{x_,y_,z_,sigma_,r_,b_},t_,{_}]//MatrixForm 
  mueLorenzX[t_,{sigma_,r_,b_}] 
sigmaLorenzX[t_,{sigma_,r_,b_}] 
\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({\(-sigma_\)\ \((x_ - y_)\), r_\ x_ - y_ - x_\ z_, x_\ y_ - b_\ z_, 0, 
      0, 0}\)], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", 
                "6"},
              {"1", \(-sigma_\), "sigma_", "0", \(\(-x_\) + y_\), "0", "0"},
              {"2", \(r_ - z_\), \(-1\), \(-x_\), "0", "x_", "0"},
              {"3", "y_", "x_", \(-b_\), "0", "0", \(-z_\)},
              {"4", "0", "0", "0", "0", "0", "0"},
              {"5", "0", "0", "0", "0", "0", "0"},
              {"6", "0", "0", "0", "0", "0", "0"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    \({{{0, 0, 0, \(-1\), 0, 0}, {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {\(-1\), 1, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, \(-1\), 0, 1, 0}, {0, 0, 0, 0, 0, 0}, {\(-1\), 0, 0, 
          0, 0, 0}, {0, 0, 0, 0, 0, 0}, {1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 1, 0, 0, 0, 0}, {1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
          0, \(-1\)}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, \(-1\), 
          0, 0, 0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}, {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
          0}}}\)], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", 
                "6"},
              {"1", "4.`", "0", "0", "0", "0", "0"},
              {"2", "0", "4.`", "0", "0", "0", "0"},
              {"3", "0", "0", "4.`", "0", "0", "0"},
              {"4", "0", "0", "0", "0.0001`", "0", "0"},
              {"5", "0", "0", "0", "0", "0.0001`", "0"},
              {"6", "0", "0", "0", "0", "0", "0.0001`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    \({x_, y_, z_}\)], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", 
                "6"},
              {"1", "1.`", "0", "0", "0", "0", "0"},
              {"2", "0", "1.`", "0", "0", "0", "0"},
              {"3", "0", "0", "1.`", "0", "0", "0"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    \({0.`, 0.`, 0.`, sigma_, r_, b_}\)], "Output"],

Cell[BoxData[
    \({{10.`, 0.`, 0.`, 0.`, 0.`, 0.`}, {0.`, 10.`, 0.`, 0.`, 0.`, 
        0.`}, {0.`, 0.`, 10.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 1.`, 0.`, 
        0.`}, {0.`, 0.`, 0.`, 0.`, 1.`, 0.`}, {0.`, 0.`, 0.`, 0.`, 0.`, 
        1.`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["p0LorenzX[t_,{sigma,r,b},2] ", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{{0.`, 0.`, 0.`, sigma, r, b}, {0.`, 0.`, 0.`, sigma, r, 
          b}}, {{{10.`, 0.`, 0.`, 0.`, 0.`, 0.`}, {0.`, 10.`, 0.`, 0.`, 0.`, 
            0.`}, {0.`, 0.`, 10.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 1.`, 0.`, 
            0.`}, {0.`, 0.`, 0.`, 0.`, 1.`, 0.`}, {0.`, 0.`, 0.`, 0.`, 0.`, 
            1.`}}, {{10.`, 0.`, 0.`, 0.`, 0.`, 0.`}, {0.`, 10.`, 0.`, 0.`, 
            0.`, 0.`}, {0.`, 0.`, 10.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 1.`, 
            0.`, 0.`}, {0.`, 0.`, 0.`, 0.`, 1.`, 0.`}, {0.`, 0.`, 0.`, 0.`, 
            0.`, 1.`}}}, 0.5`}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["c-Funktionen", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
f     = \"driftLorenz\";
Df    = \"DdriftLorenz\";
g     = \"diffusionLorenz\";
h     = \"hLorenz\";
Dh    = \"DhLorenz\";
R     = \"RLorenz\";
mue   = \"mueLorenz\";
sigma = \"sigmaLorenz\";
p0    = \"p0Lorenz\";

fX     = \"driftLorenzX\";
DfX    = \"DdriftLorenzX\";
gX     = \"diffusionLorenzX\";
hX     = \"hLorenzX\";
DhX    = \"DhLorenzX\";
RX     = \"RLorenzX\";
mueX   = \"mueLorenzX\";
sigmaX = \"sigmaLorenzX\";
p0X    = \"p0LorenzX\";\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(mueX\\)\\\" is similar to existing symbol \\\
\"\\!\\(mue\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(sigmaX\\)\\\" is similar to existing symbol \
\\\"\\!\\(sigma\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\

k = 3;
p = 6;
q = 1;
T = 1000; T1 = T+1;
dt = 0.01;
r = 6;
u = 3;
Theta = {10,28,8/3}//N;
Y0 = {.01,.01,.01,Theta}//Flatten;
X = Shape[10.,{T+1,q}]//N;

SeedRandom[-999999];

{Z,Y}=NonLinStateSpace[hLorenzX, {RLorenzX, konstant}, driftLorenzX, \
diffusionLorenzX, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
ti=Range[1,T+1,50]; ",
  StyleBox["(* selection deltat= 0.5 *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#,{1,2,3}]])&,ti];\n"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(50\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
SetOptions[plot1,dicke->.001];
DisplayTogetherArray[
plot1[Y//AddTimeAxis,GridLines->{ti,None}],
plot1[Z//AddTimeAxis,GridLines->{ti,None}]
];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 7}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 7}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.221689 0.00687448 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0842 -18 -4.5 ]
[-0.0125 .0842 0 4.5 ]
[-0.0125 .22169 -6 -4.5 ]
[-0.0125 .22169 0 4.5 ]
[-0.0125 .35918 -12 -4.5 ]
[-0.0125 .35918 0 4.5 ]
[-0.0125 .49667 -12 -4.5 ]
[-0.0125 .49667 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .18902 -5 -6 ]
[.97619 .18902 5 6 ]
[.97619 .22407 -5 -6 ]
[.97619 .22407 5 6 ]
[.97619 .41382 -5 -6 ]
[.97619 .41382 5 6 ]
[.97619 .29043 -5 -6 ]
[.97619 .29043 5 6 ]
[.97619 .41417 -5 -6 ]
[.97619 .41417 5 6 ]
[.97619 .24003 -5 -6 ]
[.97619 .24003 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.07238 0 m
.07238 .61803 L
s
.12 0 m
.12 .61803 L
s
.16762 0 m
.16762 .61803 L
s
.21524 0 m
.21524 .61803 L
s
.26286 0 m
.26286 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.3581 0 m
.3581 .61803 L
s
.40571 0 m
.40571 .61803 L
s
.45333 0 m
.45333 .61803 L
s
.50095 0 m
.50095 .61803 L
s
.54857 0 m
.54857 .61803 L
s
.59619 0 m
.59619 .61803 L
s
.64381 0 m
.64381 .61803 L
s
.69143 0 m
.69143 .61803 L
s
.73905 0 m
.73905 .61803 L
s
.78667 0 m
.78667 .61803 L
s
.83429 0 m
.83429 .61803 L
s
.8819 0 m
.8819 .61803 L
s
.92952 0 m
.92952 .61803 L
s
.97714 0 m
.97714 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0842 m
.00625 .0842 L
s
[(-20)] -0.0125 .0842 1 0 Mshowa
0 .22169 m
.00625 .22169 L
s
[(0)] -0.0125 .22169 1 0 Mshowa
0 .35918 m
.00625 .35918 L
s
[(20)] -0.0125 .35918 1 0 Mshowa
0 .49667 m
.00625 .49667 L
s
[(40)] -0.0125 .49667 1 0 Mshowa
.125 Mabswid
0 .11857 m
.00375 .11857 L
s
0 .15294 m
.00375 .15294 L
s
0 .18732 m
.00375 .18732 L
s
0 .25606 m
.00375 .25606 L
s
0 .29043 m
.00375 .29043 L
s
0 .32481 m
.00375 .32481 L
s
0 .39355 m
.00375 .39355 L
s
0 .42792 m
.00375 .42792 L
s
0 .4623 m
.00375 .4623 L
s
0 .04983 m
.00375 .04983 L
s
0 .01546 m
.00375 .01546 L
s
0 .53104 m
.00375 .53104 L
s
0 .56541 m
.00375 .56541 L
s
0 .59979 m
.00375 .59979 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0842 m
1 .0842 L
s
.99375 .22169 m
1 .22169 L
s
.99375 .35918 m
1 .35918 L
s
.99375 .49667 m
1 .49667 L
s
.125 Mabswid
.99625 .11857 m
1 .11857 L
s
.99625 .15294 m
1 .15294 L
s
.99625 .18732 m
1 .18732 L
s
.99625 .25606 m
1 .25606 L
s
.99625 .29043 m
1 .29043 L
s
.99625 .32481 m
1 .32481 L
s
.99625 .39355 m
1 .39355 L
s
.99625 .42792 m
1 .42792 L
s
.99625 .4623 m
1 .4623 L
s
.99625 .04983 m
1 .04983 L
s
.99625 .01546 m
1 .01546 L
s
.99625 .53104 m
1 .53104 L
s
.99625 .56541 m
1 .56541 L
s
.99625 .59979 m
1 .59979 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .18902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .22176 m
.02476 .21751 L
.02571 .21853 L
.02667 .21803 L
.02762 .21815 L
.02857 .2203 L
.02952 .2199 L
.03048 .21531 L
.03143 .21617 L
.03238 .21835 L
.03333 .2205 L
.03429 .22429 L
.03524 .22271 L
.03619 .21771 L
.03714 .21868 L
.0381 .21894 L
.03905 .21835 L
.04 .22106 L
.04095 .22307 L
.0419 .22052 L
.04286 .2181 L
.04381 .21764 L
.04476 .21852 L
.04571 .21905 L
.04667 .21995 L
.04762 .21862 L
.04857 .21722 L
.04952 .21214 L
.05048 .21232 L
.05143 .20583 L
.05238 .20043 L
.05333 .20122 L
.05429 .19706 L
.05524 .19378 L
.05619 .1908 L
.05714 .18787 L
.0581 .1856 L
.05905 .18071 L
.06 .17351 L
.06095 .17157 L
.0619 .16507 L
.06286 .15669 L
.06381 .14666 L
.06476 .14018 L
.06571 .12657 L
.06667 .11808 L
.06762 .10651 L
.06857 .09649 L
.06952 .08504 L
.07048 .07988 L
Mistroke
.07143 .0758 L
.07238 .07489 L
.07333 .07052 L
.07429 .07195 L
.07524 .07244 L
.07619 .07719 L
.07714 .08479 L
.0781 .09606 L
.07905 .11051 L
.08 .1271 L
.08095 .14787 L
.0819 .16738 L
.08286 .18535 L
.08381 .19793 L
.08476 .21617 L
.08571 .23064 L
.08667 .24186 L
.08762 .25793 L
.08857 .2738 L
.08952 .28277 L
.09048 .2896 L
.09143 .29358 L
.09238 .29758 L
.09333 .29902 L
.09429 .30755 L
.09524 .30878 L
.09619 .31074 L
.09714 .30146 L
.0981 .29618 L
.09905 .28898 L
.1 .28637 L
.10095 .28202 L
.1019 .28056 L
.10286 .2761 L
.10381 .26566 L
.10476 .26418 L
.10571 .25698 L
.10667 .25099 L
.10762 .25203 L
.10857 .24881 L
.10952 .24355 L
.11048 .24464 L
.11143 .24261 L
.11238 .24137 L
.11333 .24193 L
.11429 .23968 L
.11524 .23951 L
.11619 .23857 L
.11714 .23892 L
.1181 .23959 L
Mistroke
.11905 .24041 L
.12 .23942 L
.12095 .23661 L
.1219 .23712 L
.12286 .2372 L
.12381 .23456 L
.12476 .23818 L
.12571 .23927 L
.12667 .24224 L
.12762 .24158 L
.12857 .24184 L
.12952 .24549 L
.13048 .24866 L
.13143 .25088 L
.13238 .25418 L
.13333 .25431 L
.13429 .25462 L
.13524 .25431 L
.13619 .25425 L
.13714 .25538 L
.1381 .25348 L
.13905 .25418 L
.14 .25972 L
.14095 .26284 L
.1419 .26245 L
.14286 .26507 L
.14381 .26883 L
.14476 .27167 L
.14571 .27334 L
.14667 .27567 L
.14762 .27904 L
.14857 .28548 L
.14952 .28764 L
.15048 .2947 L
.15143 .29501 L
.15238 .29617 L
.15333 .29694 L
.15429 .29857 L
.15524 .30531 L
.15619 .30409 L
.15714 .30903 L
.1581 .31349 L
.15905 .32164 L
.16 .32675 L
.16095 .33288 L
.1619 .32891 L
.16286 .33418 L
.16381 .33581 L
.16476 .33669 L
.16571 .33357 L
Mistroke
.16667 .32753 L
.16762 .31909 L
.16857 .31035 L
.16952 .3015 L
.17048 .29058 L
.17143 .2803 L
.17238 .27286 L
.17333 .26591 L
.17429 .25865 L
.17524 .24954 L
.17619 .24336 L
.17714 .23475 L
.1781 .23311 L
.17905 .2275 L
.18 .2193 L
.18095 .21988 L
.1819 .21754 L
.18286 .21999 L
.18381 .22045 L
.18476 .22034 L
.18571 .21592 L
.18667 .2189 L
.18762 .21592 L
.18857 .2126 L
.18952 .20963 L
.19048 .21203 L
.19143 .20809 L
.19238 .20645 L
.19333 .20765 L
.19429 .20918 L
.19524 .20727 L
.19619 .20901 L
.19714 .20605 L
.1981 .20172 L
.19905 .20253 L
.2 .19927 L
.20095 .19764 L
.2019 .20241 L
.20286 .20383 L
.20381 .20247 L
.20476 .20155 L
.20571 .20043 L
.20667 .19377 L
.20762 .18731 L
.20857 .18504 L
.20952 .18346 L
.21048 .18092 L
.21143 .17816 L
.21238 .17613 L
.21333 .17551 L
Mistroke
.21429 .17237 L
.21524 .17035 L
.21619 .16337 L
.21714 .16115 L
.2181 .15615 L
.21905 .15116 L
.22 .14659 L
.22095 .13685 L
.2219 .13194 L
.22286 .12443 L
.22381 .11767 L
.22476 .11308 L
.22571 .11777 L
.22667 .11701 L
.22762 .11444 L
.22857 .11555 L
.22952 .11225 L
.23048 .11291 L
.23143 .11442 L
.23238 .12115 L
.23333 .12993 L
.23429 .13433 L
.23524 .1433 L
.23619 .15257 L
.23714 .15783 L
.2381 .16336 L
.23905 .17214 L
.24 .18155 L
.24095 .19099 L
.2419 .19829 L
.24286 .2054 L
.24381 .21187 L
.24476 .21917 L
.24571 .22802 L
.24667 .23238 L
.24762 .23809 L
.24857 .24569 L
.24952 .25157 L
.25048 .25433 L
.25143 .25589 L
.25238 .26016 L
.25333 .2596 L
.25429 .25914 L
.25524 .26007 L
.25619 .25669 L
.25714 .25949 L
.2581 .25912 L
.25905 .26298 L
.26 .26449 L
.26095 .26854 L
Mistroke
.2619 .2696 L
.26286 .27237 L
.26381 .27157 L
.26476 .27285 L
.26571 .27364 L
.26667 .27446 L
.26762 .27399 L
.26857 .27644 L
.26952 .28012 L
.27048 .28046 L
.27143 .27868 L
.27238 .28437 L
.27333 .28686 L
.27429 .28741 L
.27524 .291 L
.27619 .28888 L
.27714 .29119 L
.2781 .2941 L
.27905 .29476 L
.28 .29555 L
.28095 .29251 L
.2819 .29416 L
.28286 .29605 L
.28381 .29763 L
.28476 .29499 L
.28571 .29723 L
.28667 .29613 L
.28762 .29714 L
.28857 .29384 L
.28952 .28944 L
.29048 .28674 L
.29143 .28504 L
.29238 .28389 L
.29333 .28656 L
.29429 .28583 L
.29524 .28034 L
.29619 .2757 L
.29714 .27336 L
.2981 .27469 L
.29905 .26685 L
.3 .26653 L
.30095 .26472 L
.3019 .26478 L
.30286 .2593 L
.30381 .25704 L
.30476 .25381 L
.30571 .2531 L
.30667 .25091 L
.30762 .25003 L
.30857 .24855 L
Mistroke
.30952 .25033 L
.31048 .25166 L
.31143 .25275 L
.31238 .25294 L
.31333 .25497 L
.31429 .25204 L
.31524 .2579 L
.31619 .25618 L
.31714 .25484 L
.3181 .25515 L
.31905 .25609 L
.32 .25469 L
.32095 .25336 L
.3219 .25145 L
.32286 .25259 L
.32381 .25629 L
.32476 .25271 L
.32571 .25201 L
.32667 .25356 L
.32762 .25539 L
.32857 .25889 L
.32952 .26121 L
.33048 .2636 L
.33143 .26536 L
.33238 .26808 L
.33333 .26872 L
.33429 .26874 L
.33524 .27259 L
.33619 .27473 L
.33714 .2827 L
.3381 .28185 L
.33905 .28541 L
.34 .29204 L
.34095 .29078 L
.3419 .29469 L
.34286 .29716 L
.34381 .30066 L
.34476 .29944 L
.34571 .30311 L
.34667 .30759 L
.34762 .3131 L
.34857 .3151 L
.34952 .31588 L
.35048 .31437 L
.35143 .31114 L
.35238 .30702 L
.35333 .30657 L
.35429 .30844 L
.35524 .30373 L
.35619 .30563 L
Mistroke
.35714 .30336 L
.3581 .30661 L
.35905 .30336 L
.36 .29622 L
.36095 .28878 L
.3619 .28423 L
.36286 .28097 L
.36381 .2757 L
.36476 .27087 L
.36571 .26778 L
.36667 .26204 L
.36762 .26082 L
.36857 .25575 L
.36952 .25545 L
.37048 .24394 L
.37143 .2462 L
.37238 .24011 L
.37333 .2333 L
.37429 .23006 L
.37524 .23069 L
.37619 .23179 L
.37714 .22817 L
.3781 .22443 L
.37905 .22257 L
.38 .22223 L
.38095 .21826 L
.3819 .21618 L
.38286 .21485 L
.38381 .21016 L
.38476 .20674 L
.38571 .21031 L
.38667 .20999 L
.38762 .21045 L
.38857 .20749 L
.38952 .20823 L
.39048 .20703 L
.39143 .20497 L
.39238 .20355 L
.39333 .20691 L
.39429 .2035 L
.39524 .20338 L
.39619 .2041 L
.39714 .20468 L
.3981 .20033 L
.39905 .20352 L
.4 .20151 L
.40095 .20587 L
.4019 .20651 L
.40286 .20191 L
.40381 .20691 L
Mistroke
.40476 .20112 L
.40571 .19815 L
.40667 .19486 L
.40762 .19705 L
.40857 .19506 L
.40952 .18977 L
.41048 .1862 L
.41143 .18279 L
.41238 .18411 L
.41333 .18547 L
.41429 .18268 L
.41524 .18226 L
.41619 .17829 L
.41714 .17322 L
.4181 .16246 L
.41905 .16303 L
.42 .1598 L
.42095 .15923 L
.4219 .15842 L
.42286 .15366 L
.42381 .14775 L
.42476 .14269 L
.42571 .13809 L
.42667 .12801 L
.42762 .12892 L
.42857 .1204 L
.42952 .11866 L
.43048 .11695 L
.43143 .11319 L
.43238 .11541 L
.43333 .11755 L
.43429 .11828 L
.43524 .11509 L
.43619 .12156 L
.43714 .12307 L
.4381 .12634 L
.43905 .13721 L
.44 .14138 L
.44095 .15264 L
.4419 .16125 L
.44286 .16921 L
.44381 .18003 L
.44476 .19196 L
.44571 .19751 L
.44667 .20468 L
.44762 .21111 L
.44857 .21723 L
.44952 .22498 L
.45048 .22978 L
.45143 .23403 L
Mistroke
.45238 .23994 L
.45333 .24236 L
.45429 .24227 L
.45524 .24768 L
.45619 .24844 L
.45714 .25192 L
.4581 .25254 L
.45905 .25622 L
.46 .26119 L
.46095 .25904 L
.4619 .2571 L
.46286 .25127 L
.46381 .25514 L
.46476 .25649 L
.46571 .25678 L
.46667 .25851 L
.46762 .26426 L
.46857 .26309 L
.46952 .25778 L
.47048 .25835 L
.47143 .26415 L
.47238 .26562 L
.47333 .26552 L
.47429 .26603 L
.47524 .26394 L
.47619 .26609 L
.47714 .26931 L
.4781 .26854 L
.47905 .26489 L
.48 .26686 L
.48095 .2711 L
.4819 .27391 L
.48286 .27891 L
.48381 .28667 L
.48476 .29111 L
.48571 .2966 L
.48667 .29599 L
.48762 .30134 L
.48857 .30509 L
.48952 .30672 L
.49048 .30888 L
.49143 .30959 L
.49238 .31108 L
.49333 .31317 L
.49429 .31634 L
.49524 .32067 L
.49619 .32493 L
.49714 .32543 L
.4981 .32387 L
.49905 .3217 L
Mistroke
.5 .32036 L
.50095 .31677 L
.5019 .31474 L
.50286 .30816 L
.50381 .30152 L
.50476 .296 L
.50571 .29005 L
.50667 .28138 L
.50762 .27213 L
.50857 .27411 L
.50952 .27128 L
.51048 .26461 L
.51143 .26042 L
.51238 .2549 L
.51333 .25284 L
.51429 .2479 L
.51524 .24536 L
.51619 .24299 L
.51714 .24231 L
.5181 .23865 L
.51905 .23877 L
.52 .23673 L
.52095 .2377 L
.5219 .23497 L
.52286 .23605 L
.52381 .23602 L
.52476 .23646 L
.52571 .23418 L
.52667 .23628 L
.52762 .22999 L
.52857 .22861 L
.52952 .23356 L
.53048 .23303 L
.53143 .23256 L
.53238 .23365 L
.53333 .2373 L
.53429 .23562 L
.53524 .23587 L
.53619 .23252 L
.53714 .23305 L
.5381 .23098 L
.53905 .23226 L
.54 .23222 L
.54095 .24103 L
.5419 .2393 L
.54286 .23932 L
.54381 .24092 L
.54476 .24061 L
.54571 .24148 L
.54667 .24363 L
Mistroke
.54762 .24668 L
.54857 .24712 L
.54952 .25351 L
.55048 .25477 L
.55143 .25562 L
.55238 .25456 L
.55333 .25824 L
.55429 .26121 L
.55524 .26559 L
.55619 .27586 L
.55714 .28064 L
.5581 .28408 L
.55905 .28714 L
.56 .29501 L
.56095 .29539 L
.5619 .30208 L
.56286 .30603 L
.56381 .3087 L
.56476 .31757 L
.56571 .32352 L
.56667 .32689 L
.56762 .33058 L
.56857 .33459 L
.56952 .33349 L
.57048 .33089 L
.57143 .33075 L
.57238 .33142 L
.57333 .33204 L
.57429 .33461 L
.57524 .33227 L
.57619 .32992 L
.57714 .3237 L
.5781 .32028 L
.57905 .30926 L
.58 .29988 L
.58095 .29372 L
.5819 .28084 L
.58286 .27518 L
.58381 .26928 L
.58476 .2598 L
.58571 .25069 L
.58667 .24223 L
.58762 .23736 L
.58857 .22971 L
.58952 .22381 L
.59048 .21849 L
.59143 .21939 L
.59238 .21571 L
.59333 .21211 L
.59429 .20678 L
Mistroke
.59524 .20301 L
.59619 .20177 L
.59714 .19847 L
.5981 .19158 L
.59905 .19036 L
.6 .18721 L
.60095 .1838 L
.6019 .18262 L
.60286 .18307 L
.60381 .17389 L
.60476 .17245 L
.60571 .1711 L
.60667 .16378 L
.60762 .16209 L
.60857 .16016 L
.60952 .15941 L
.61048 .156 L
.61143 .15713 L
.61238 .15919 L
.61333 .16189 L
.61429 .16283 L
.61524 .16301 L
.61619 .15897 L
.61714 .15311 L
.6181 .15453 L
.61905 .15674 L
.62 .16122 L
.62095 .16074 L
.6219 .15967 L
.62286 .16033 L
.62381 .16013 L
.62476 .16398 L
.62571 .16828 L
.62667 .17417 L
.62762 .17593 L
.62857 .17358 L
.62952 .17598 L
.63048 .18666 L
.63143 .1842 L
.63238 .18453 L
.63333 .18717 L
.63429 .18965 L
.63524 .18819 L
.63619 .19215 L
.63714 .19409 L
.6381 .20151 L
.63905 .20162 L
.64 .20074 L
.64095 .20151 L
.6419 .19998 L
Mistroke
.64286 .20056 L
.64381 .19965 L
.64476 .20023 L
.64571 .19444 L
.64667 .19429 L
.64762 .19413 L
.64857 .19001 L
.64952 .19068 L
.65048 .19148 L
.65143 .19058 L
.65238 .18979 L
.65333 .19198 L
.65429 .19515 L
.65524 .18889 L
.65619 .183 L
.65714 .17702 L
.6581 .17442 L
.65905 .16919 L
.66 .16738 L
.66095 .16609 L
.6619 .16197 L
.66286 .16334 L
.66381 .16442 L
.66476 .16086 L
.66571 .15718 L
.66667 .15024 L
.66762 .14741 L
.66857 .145 L
.66952 .14261 L
.67048 .14233 L
.67143 .1353 L
.67238 .12932 L
.67333 .12817 L
.67429 .1269 L
.67524 .13181 L
.67619 .13233 L
.67714 .13584 L
.6781 .12993 L
.67905 .13338 L
.68 .13336 L
.68095 .13872 L
.6819 .14283 L
.68286 .14665 L
.68381 .14839 L
.68476 .14957 L
.68571 .15214 L
.68667 .15587 L
.68762 .15789 L
.68857 .16682 L
.68952 .1699 L
Mistroke
.69048 .17988 L
.69143 .18257 L
.69238 .18354 L
.69333 .1852 L
.69429 .18847 L
.69524 .19054 L
.69619 .19265 L
.69714 .19573 L
.6981 .19512 L
.69905 .19518 L
.7 .19793 L
.70095 .19998 L
.7019 .20043 L
.70286 .19869 L
.70381 .20268 L
.70476 .21241 L
.70571 .21175 L
.70667 .20939 L
.70762 .20995 L
.70857 .21341 L
.70952 .21109 L
.71048 .21544 L
.71143 .21792 L
.71238 .21632 L
.71333 .22113 L
.71429 .22063 L
.71524 .22169 L
.71619 .21776 L
.71714 .21512 L
.7181 .21443 L
.71905 .2139 L
.72 .21479 L
.72095 .21094 L
.7219 .20587 L
.72286 .20286 L
.72381 .20133 L
.72476 .20326 L
.72571 .20047 L
.72667 .1988 L
.72762 .19806 L
.72857 .19739 L
.72952 .19191 L
.73048 .1854 L
.73143 .18596 L
.73238 .18452 L
.73333 .18761 L
.73429 .18405 L
.73524 .1747 L
.73619 .17093 L
.73714 .16474 L
Mistroke
.7381 .15822 L
.73905 .15656 L
.74 .15535 L
.74095 .14871 L
.7419 .14128 L
.74286 .13801 L
.74381 .13251 L
.74476 .13066 L
.74571 .12099 L
.74667 .12197 L
.74762 .12138 L
.74857 .12069 L
.74952 .11953 L
.75048 .11849 L
.75143 .11675 L
.75238 .11479 L
.75333 .1205 L
.75429 .12496 L
.75524 .12944 L
.75619 .13125 L
.75714 .13884 L
.7581 .14743 L
.75905 .15567 L
.76 .1597 L
.76095 .16624 L
.7619 .17506 L
.76286 .18265 L
.76381 .18881 L
.76476 .20135 L
.76571 .20873 L
.76667 .21873 L
.76762 .22703 L
.76857 .23652 L
.76952 .24225 L
.77048 .24476 L
.77143 .24916 L
.77238 .25262 L
.77333 .25608 L
.77429 .25323 L
.77524 .25563 L
.77619 .25706 L
.77714 .26108 L
.7781 .26549 L
.77905 .26635 L
.78 .26886 L
.78095 .27459 L
.7819 .27959 L
.78286 .27995 L
.78381 .27937 L
.78476 .27895 L
Mistroke
.78571 .27783 L
.78667 .28041 L
.78762 .28067 L
.78857 .27533 L
.78952 .27727 L
.79048 .27825 L
.79143 .28031 L
.79238 .28219 L
.79333 .28201 L
.79429 .28574 L
.79524 .28037 L
.79619 .28058 L
.79714 .28094 L
.7981 .27686 L
.79905 .278 L
.8 .27375 L
.80095 .26675 L
.8019 .27575 L
.80286 .27611 L
.80381 .27428 L
.80476 .27126 L
.80571 .26795 L
.80667 .26599 L
.80762 .26683 L
.80857 .26725 L
.80952 .27077 L
.81048 .269 L
.81143 .26533 L
.81238 .26813 L
.81333 .27168 L
.81429 .27067 L
.81524 .2737 L
.81619 .27253 L
.81714 .26933 L
.8181 .27056 L
.81905 .2706 L
.82 .2696 L
.82095 .27023 L
.8219 .26775 L
.82286 .27163 L
.82381 .27125 L
.82476 .27357 L
.82571 .27681 L
.82667 .27906 L
.82762 .27889 L
.82857 .28367 L
.82952 .2822 L
.83048 .28692 L
.83143 .29705 L
.83238 .2996 L
Mistroke
.83333 .29902 L
.83429 .29771 L
.83524 .29629 L
.83619 .29208 L
.83714 .29325 L
.8381 .29011 L
.83905 .28424 L
.84 .28222 L
.84095 .28084 L
.8419 .27626 L
.84286 .27264 L
.84381 .2705 L
.84476 .27018 L
.84571 .27208 L
.84667 .27449 L
.84762 .27346 L
.84857 .27236 L
.84952 .26787 L
.85048 .26554 L
.85143 .26176 L
.85238 .25878 L
.85333 .25773 L
.85429 .25516 L
.85524 .25544 L
.85619 .25507 L
.85714 .24765 L
.8581 .25426 L
.85905 .25315 L
.86 .24752 L
.86095 .24678 L
.8619 .24788 L
.86286 .24092 L
.86381 .24353 L
.86476 .24309 L
.86571 .24315 L
.86667 .24302 L
.86762 .24092 L
.86857 .24332 L
.86952 .246 L
.87048 .25312 L
.87143 .25206 L
.87238 .2488 L
.87333 .24966 L
.87429 .25702 L
.87524 .25494 L
.87619 .25749 L
.87714 .26018 L
.8781 .26121 L
.87905 .26028 L
.88 .26626 L
Mistroke
.88095 .26766 L
.8819 .27087 L
.88286 .28029 L
.88381 .28095 L
.88476 .28572 L
.88571 .29017 L
.88667 .29038 L
.88762 .29793 L
.88857 .30341 L
.88952 .30995 L
.89048 .31514 L
.89143 .31577 L
.89238 .32019 L
.89333 .32183 L
.89429 .32001 L
.89524 .32475 L
.89619 .3285 L
.89714 .32607 L
.8981 .32705 L
.89905 .32829 L
.9 .32192 L
.90095 .31938 L
.9019 .31511 L
.90286 .30875 L
.90381 .30416 L
.90476 .30188 L
.90571 .29348 L
.90667 .28668 L
.90762 .27605 L
.90857 .26964 L
.90952 .26739 L
.91048 .26008 L
.91143 .25372 L
.91238 .24798 L
.91333 .24065 L
.91429 .23397 L
.91524 .23251 L
.91619 .22722 L
.91714 .22447 L
.9181 .22013 L
.91905 .21658 L
.92 .21917 L
.92095 .21678 L
.9219 .21024 L
.92286 .21137 L
.92381 .20737 L
.92476 .20523 L
.92571 .20136 L
.92667 .20156 L
.92762 .20216 L
Mistroke
.92857 .19607 L
.92952 .19467 L
.93048 .19701 L
.93143 .19549 L
.93238 .19971 L
.93333 .19675 L
.93429 .19628 L
.93524 .19536 L
.93619 .19437 L
.93714 .19207 L
.9381 .1868 L
.93905 .18481 L
.94 .18331 L
.94095 .17846 L
.9419 .17527 L
.94286 .17863 L
.94381 .17304 L
.94476 .16974 L
.94571 .16903 L
.94667 .16733 L
.94762 .16317 L
.94857 .16072 L
.94952 .15985 L
.95048 .14794 L
.95143 .14743 L
.95238 .14044 L
.95333 .13304 L
.95429 .13184 L
.95524 .12701 L
.95619 .12763 L
.95714 .12227 L
.9581 .11967 L
.95905 .12088 L
.96 .12155 L
.96095 .11948 L
.9619 .11985 L
.96286 .1225 L
.96381 .12734 L
.96476 .1306 L
.96571 .13084 L
.96667 .1337 L
.96762 .13987 L
.96857 .14458 L
.96952 .15407 L
.97048 .15829 L
.97143 .16138 L
.97238 .16746 L
.97333 .17448 L
.97429 .18117 L
.97524 .18381 L
Mistroke
.97619 .18902 L
Mfstroke
0 .98 .604 r
gsave
.97619 .22407 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22176 m
.02476 .21941 L
.02571 .21961 L
.02667 .21746 L
.02762 .21673 L
.02857 .21318 L
.02952 .2136 L
.03048 .21126 L
.03143 .21203 L
.03238 .21101 L
.03333 .21278 L
.03429 .21428 L
.03524 .21438 L
.03619 .21574 L
.03714 .21108 L
.0381 .21338 L
.03905 .21065 L
.04 .21336 L
.04095 .21255 L
.0419 .21296 L
.04286 .21297 L
.04381 .21158 L
.04476 .20945 L
.04571 .20494 L
.04667 .20376 L
.04762 .20341 L
.04857 .20318 L
.04952 .20448 L
.05048 .20071 L
.05143 .19325 L
.05238 .18831 L
.05333 .18238 L
.05429 .17216 L
.05524 .16163 L
.05619 .1539 L
.05714 .14908 L
.0581 .14241 L
.05905 .13471 L
.06 .12227 L
.06095 .11719 L
.0619 .11032 L
.06286 .09627 L
.06381 .08353 L
.06476 .0628 L
.06571 .04995 L
.06667 .0365 L
.06762 .02437 L
.06857 .01633 L
.06952 .01472 L
.07048 .01851 L
Mistroke
.07143 .03238 L
.07238 .05172 L
.07333 .07557 L
.07429 .10718 L
.07524 .14127 L
.07619 .18564 L
.07714 .2231 L
.0781 .26315 L
.07905 .29627 L
.08 .31796 L
.08095 .33301 L
.0819 .34692 L
.08286 .35278 L
.08381 .35748 L
.08476 .35895 L
.08571 .35131 L
.08667 .35057 L
.08762 .35357 L
.08857 .35267 L
.08952 .34868 L
.09048 .33961 L
.09143 .33641 L
.09238 .3294 L
.09333 .32168 L
.09429 .31576 L
.09524 .30307 L
.09619 .29277 L
.09714 .27958 L
.0981 .27232 L
.09905 .2667 L
.1 .25545 L
.10095 .25069 L
.1019 .24038 L
.10286 .2386 L
.10381 .23432 L
.10476 .23267 L
.10571 .22884 L
.10667 .23277 L
.10762 .23427 L
.10857 .23305 L
.10952 .22864 L
.11048 .22715 L
.11143 .22332 L
.11238 .22104 L
.11333 .21924 L
.11429 .21889 L
.11524 .22274 L
.11619 .22358 L
.11714 .22815 L
.1181 .23158 L
Mistroke
.11905 .23629 L
.12 .24094 L
.12095 .24446 L
.1219 .24762 L
.12286 .24648 L
.12381 .25054 L
.12476 .2506 L
.12571 .25078 L
.12667 .25323 L
.12762 .25541 L
.12857 .25762 L
.12952 .2564 L
.13048 .25795 L
.13143 .25958 L
.13238 .26383 L
.13333 .26615 L
.13429 .26391 L
.13524 .26823 L
.13619 .27071 L
.13714 .27304 L
.1381 .27492 L
.13905 .28007 L
.14 .28178 L
.14095 .28488 L
.1419 .29257 L
.14286 .29236 L
.14381 .29399 L
.14476 .30083 L
.14571 .304 L
.14667 .30578 L
.14762 .31205 L
.14857 .31732 L
.14952 .31953 L
.15048 .32315 L
.15143 .32632 L
.15238 .33128 L
.15333 .33794 L
.15429 .34261 L
.15524 .34512 L
.15619 .34691 L
.15714 .34514 L
.1581 .34659 L
.15905 .34422 L
.16 .33937 L
.16095 .33111 L
.1619 .32471 L
.16286 .31478 L
.16381 .30123 L
.16476 .28622 L
.16571 .27086 L
Mistroke
.16667 .25584 L
.16762 .23808 L
.16857 .2317 L
.16952 .2218 L
.17048 .2138 L
.17143 .20505 L
.17238 .20058 L
.17333 .19751 L
.17429 .19619 L
.17524 .19564 L
.17619 .19836 L
.17714 .19798 L
.1781 .19616 L
.17905 .19786 L
.18 .20148 L
.18095 .20656 L
.1819 .20601 L
.18286 .2042 L
.18381 .19869 L
.18476 .19795 L
.18571 .19804 L
.18667 .19916 L
.18762 .19454 L
.18857 .19052 L
.18952 .19253 L
.19048 .19624 L
.19143 .19413 L
.19238 .18977 L
.19333 .1852 L
.19429 .18696 L
.19524 .18464 L
.19619 .18306 L
.19714 .18489 L
.1981 .18326 L
.19905 .18426 L
.2 .18136 L
.20095 .18241 L
.2019 .17961 L
.20286 .17788 L
.20381 .17543 L
.20476 .17004 L
.20571 .16961 L
.20667 .16731 L
.20762 .16401 L
.20857 .15369 L
.20952 .14894 L
.21048 .14968 L
.21143 .14283 L
.21238 .1362 L
.21333 .1299 L
Mistroke
.21429 .12326 L
.21524 .1178 L
.21619 .11114 L
.21714 .10444 L
.2181 .09814 L
.21905 .08819 L
.22 .07815 L
.22095 .07216 L
.2219 .07351 L
.22286 .07127 L
.22381 .07747 L
.22476 .08139 L
.22571 .09274 L
.22667 .10384 L
.22762 .11777 L
.22857 .12676 L
.22952 .14024 L
.23048 .15372 L
.23143 .17065 L
.23238 .18383 L
.23333 .20427 L
.23429 .22254 L
.23524 .23294 L
.23619 .24427 L
.23714 .25599 L
.2381 .26412 L
.23905 .26662 L
.24 .26936 L
.24095 .27345 L
.2419 .27716 L
.24286 .2773 L
.24381 .27208 L
.24476 .26912 L
.24571 .26717 L
.24667 .27382 L
.24762 .27732 L
.24857 .27476 L
.24952 .27427 L
.25048 .27307 L
.25143 .27339 L
.25238 .27209 L
.25333 .27232 L
.25429 .27284 L
.25524 .27321 L
.25619 .27184 L
.25714 .27009 L
.2581 .27247 L
.25905 .27546 L
.26 .27909 L
.26095 .27752 L
Mistroke
.2619 .27663 L
.26286 .27463 L
.26381 .27363 L
.26476 .27726 L
.26571 .28183 L
.26667 .28413 L
.26762 .28896 L
.26857 .29068 L
.26952 .29113 L
.27048 .29439 L
.27143 .2988 L
.27238 .30139 L
.27333 .30838 L
.27429 .30732 L
.27524 .30282 L
.27619 .3086 L
.27714 .30524 L
.2781 .30763 L
.27905 .30413 L
.28 .30145 L
.28095 .3032 L
.2819 .30106 L
.28286 .29948 L
.28381 .29128 L
.28476 .28532 L
.28571 .28139 L
.28667 .27875 L
.28762 .27371 L
.28857 .2707 L
.28952 .26749 L
.29048 .26586 L
.29143 .26586 L
.29238 .26768 L
.29333 .26534 L
.29429 .25928 L
.29524 .26263 L
.29619 .26153 L
.29714 .25693 L
.2981 .25491 L
.29905 .24834 L
.3 .24491 L
.30095 .24439 L
.3019 .24297 L
.30286 .24084 L
.30381 .24531 L
.30476 .2439 L
.30571 .24536 L
.30667 .24813 L
.30762 .24582 L
.30857 .25006 L
Mistroke
.30952 .24789 L
.31048 .24441 L
.31143 .24658 L
.31238 .24762 L
.31333 .24708 L
.31429 .25303 L
.31524 .25523 L
.31619 .25408 L
.31714 .25453 L
.3181 .25912 L
.31905 .25793 L
.32 .25812 L
.32095 .25978 L
.3219 .25791 L
.32286 .25988 L
.32381 .26746 L
.32476 .27233 L
.32571 .27001 L
.32667 .27144 L
.32762 .27496 L
.32857 .27327 L
.32952 .27079 L
.33048 .27775 L
.33143 .28187 L
.33238 .28229 L
.33333 .28096 L
.33429 .2853 L
.33524 .29389 L
.33619 .2969 L
.33714 .30354 L
.3381 .30789 L
.33905 .31351 L
.34 .31409 L
.34095 .31857 L
.3419 .32295 L
.34286 .32225 L
.34381 .32222 L
.34476 .32844 L
.34571 .32939 L
.34667 .32661 L
.34762 .32721 L
.34857 .32217 L
.34952 .31532 L
.35048 .31068 L
.35143 .30599 L
.35238 .29821 L
.35333 .29612 L
.35429 .29044 L
.35524 .28831 L
.35619 .27825 L
Mistroke
.35714 .27193 L
.3581 .26432 L
.35905 .26044 L
.36 .25048 L
.36095 .24885 L
.3619 .24353 L
.36286 .2419 L
.36381 .23714 L
.36476 .23427 L
.36571 .23213 L
.36667 .22994 L
.36762 .22343 L
.36857 .22652 L
.36952 .22199 L
.37048 .22342 L
.37143 .22012 L
.37238 .21295 L
.37333 .20901 L
.37429 .2124 L
.37524 .21256 L
.37619 .21183 L
.37714 .21349 L
.3781 .2191 L
.37905 .21949 L
.38 .21814 L
.38095 .21429 L
.3819 .21479 L
.38286 .21459 L
.38381 .21615 L
.38476 .21285 L
.38571 .21187 L
.38667 .21142 L
.38762 .20979 L
.38857 .20688 L
.38952 .20436 L
.39048 .20328 L
.39143 .20358 L
.39238 .20368 L
.39333 .20035 L
.39429 .20128 L
.39524 .20376 L
.39619 .20138 L
.39714 .19942 L
.3981 .19805 L
.39905 .19531 L
.4 .19477 L
.40095 .19583 L
.4019 .19668 L
.40286 .19789 L
.40381 .19275 L
Mistroke
.40476 .19006 L
.40571 .18479 L
.40667 .17743 L
.40762 .17017 L
.40857 .16362 L
.40952 .16436 L
.41048 .15998 L
.41143 .15425 L
.41238 .14942 L
.41333 .14521 L
.41429 .13935 L
.41524 .13525 L
.41619 .13176 L
.41714 .12841 L
.4181 .12768 L
.41905 .1155 L
.42 .10902 L
.42095 .10256 L
.4219 .09624 L
.42286 .09078 L
.42381 .08543 L
.42476 .08659 L
.42571 .08162 L
.42667 .07598 L
.42762 .07635 L
.42857 .07694 L
.42952 .07906 L
.43048 .08996 L
.43143 .09585 L
.43238 .1019 L
.43333 .11685 L
.43429 .12882 L
.43524 .1453 L
.43619 .16339 L
.43714 .17844 L
.4381 .18611 L
.43905 .20337 L
.44 .22006 L
.44095 .23138 L
.4419 .24377 L
.44286 .25012 L
.44381 .25996 L
.44476 .26342 L
.44571 .26819 L
.44667 .27237 L
.44762 .27509 L
.44857 .27715 L
.44952 .27514 L
.45048 .27624 L
.45143 .27609 L
Mistroke
.45238 .27124 L
.45333 .26545 L
.45429 .25807 L
.45524 .25578 L
.45619 .25662 L
.45714 .25398 L
.4581 .25356 L
.45905 .25412 L
.46 .25307 L
.46095 .25698 L
.4619 .25593 L
.46286 .25753 L
.46381 .25749 L
.46476 .26185 L
.46571 .26018 L
.46667 .26101 L
.46762 .26156 L
.46857 .2648 L
.46952 .26311 L
.47048 .26439 L
.47143 .26554 L
.47238 .26668 L
.47333 .27326 L
.47429 .27331 L
.47524 .27777 L
.47619 .2758 L
.47714 .27978 L
.4781 .28114 L
.47905 .2861 L
.48 .29143 L
.48095 .2952 L
.4819 .29677 L
.48286 .30392 L
.48381 .30553 L
.48476 .31384 L
.48571 .31509 L
.48667 .3169 L
.48762 .31993 L
.48857 .32254 L
.48952 .32983 L
.49048 .32652 L
.49143 .32771 L
.49238 .32927 L
.49333 .32848 L
.49429 .32431 L
.49524 .32281 L
.49619 .31864 L
.49714 .31164 L
.4981 .30059 L
.49905 .28671 L
Mistroke
.5 .27621 L
.50095 .26716 L
.5019 .25607 L
.50286 .25268 L
.50381 .2432 L
.50476 .23295 L
.50571 .22989 L
.50667 .22122 L
.50762 .21542 L
.50857 .21163 L
.50952 .21535 L
.51048 .2147 L
.51143 .21205 L
.51238 .2194 L
.51333 .21635 L
.51429 .2181 L
.51524 .22079 L
.51619 .22326 L
.51714 .22434 L
.5181 .22835 L
.51905 .2255 L
.52 .23126 L
.52095 .23635 L
.5219 .23737 L
.52286 .23809 L
.52381 .24197 L
.52476 .2386 L
.52571 .2376 L
.52667 .24002 L
.52762 .23991 L
.52857 .24091 L
.52952 .24133 L
.53048 .24564 L
.53143 .24628 L
.53238 .24663 L
.53333 .24381 L
.53429 .24249 L
.53524 .2421 L
.53619 .24541 L
.53714 .25252 L
.5381 .25508 L
.53905 .25594 L
.54 .25377 L
.54095 .25601 L
.5419 .26072 L
.54286 .26305 L
.54381 .26599 L
.54476 .27219 L
.54571 .27363 L
.54667 .27746 L
Mistroke
.54762 .27929 L
.54857 .28217 L
.54952 .28583 L
.55048 .29075 L
.55143 .29273 L
.55238 .29704 L
.55333 .29617 L
.55429 .30415 L
.55524 .30967 L
.55619 .3142 L
.55714 .31856 L
.5581 .32862 L
.55905 .33471 L
.56 .33905 L
.56095 .34336 L
.5619 .34978 L
.56286 .35766 L
.56381 .36129 L
.56476 .36272 L
.56571 .36986 L
.56667 .36713 L
.56762 .36392 L
.56857 .3588 L
.56952 .34822 L
.57048 .34426 L
.57143 .33655 L
.57238 .32385 L
.57333 .30799 L
.57429 .29366 L
.57524 .27861 L
.57619 .2602 L
.57714 .24694 L
.5781 .23133 L
.57905 .2189 L
.58 .2042 L
.58095 .1942 L
.5819 .1857 L
.58286 .18067 L
.58381 .17983 L
.58476 .1793 L
.58571 .17592 L
.58667 .17474 L
.58762 .17801 L
.58857 .17761 L
.58952 .18045 L
.59048 .18063 L
.59143 .17687 L
.59238 .17638 L
.59333 .17817 L
.59429 .17826 L
Mistroke
.59524 .17761 L
.59619 .17435 L
.59714 .17042 L
.5981 .16761 L
.59905 .16197 L
.6 .16203 L
.60095 .15728 L
.6019 .1569 L
.60286 .15484 L
.60381 .15258 L
.60476 .15203 L
.60571 .15501 L
.60667 .15228 L
.60762 .14982 L
.60857 .14877 L
.60952 .15101 L
.61048 .15273 L
.61143 .15163 L
.61238 .14994 L
.61333 .15361 L
.61429 .15177 L
.61524 .15453 L
.61619 .15509 L
.61714 .15661 L
.6181 .16357 L
.61905 .16552 L
.62 .17403 L
.62095 .17356 L
.6219 .17577 L
.62286 .17503 L
.62381 .17527 L
.62476 .17899 L
.62571 .18597 L
.62667 .19248 L
.62762 .19091 L
.62857 .19318 L
.62952 .20017 L
.63048 .20077 L
.63143 .19683 L
.63238 .19594 L
.63333 .19521 L
.63429 .19549 L
.63524 .19506 L
.63619 .19611 L
.63714 .20102 L
.6381 .20302 L
.63905 .19834 L
.64 .19986 L
.64095 .20113 L
.6419 .20119 L
Mistroke
.64286 .19615 L
.64381 .19616 L
.64476 .19456 L
.64571 .19617 L
.64667 .19456 L
.64762 .19285 L
.64857 .19391 L
.64952 .19307 L
.65048 .18556 L
.65143 .18457 L
.65238 .17992 L
.65333 .1744 L
.65429 .16948 L
.65524 .16129 L
.65619 .15499 L
.65714 .15132 L
.6581 .14847 L
.65905 .1475 L
.66 .14681 L
.66095 .14531 L
.6619 .13959 L
.66286 .13554 L
.66381 .13469 L
.66476 .13428 L
.66571 .13296 L
.66667 .12927 L
.66762 .12391 L
.66857 .11959 L
.66952 .11734 L
.67048 .11866 L
.67143 .1192 L
.67238 .12024 L
.67333 .12072 L
.67429 .12357 L
.67524 .12749 L
.67619 .13165 L
.67714 .13482 L
.6781 .13854 L
.67905 .14534 L
.68 .15614 L
.68095 .1634 L
.6819 .17061 L
.68286 .17981 L
.68381 .18329 L
.68476 .18703 L
.68571 .19131 L
.68667 .20009 L
.68762 .20608 L
.68857 .20994 L
.68952 .21088 L
Mistroke
.69048 .21748 L
.69143 .2193 L
.69238 .22381 L
.69333 .22764 L
.69429 .22986 L
.69524 .23047 L
.69619 .22521 L
.69714 .22398 L
.6981 .22159 L
.69905 .21998 L
.7 .21805 L
.70095 .21879 L
.7019 .21888 L
.70286 .2172 L
.70381 .2164 L
.70476 .2137 L
.70571 .2167 L
.70667 .21572 L
.70762 .21641 L
.70857 .21465 L
.70952 .21805 L
.71048 .21749 L
.71143 .21387 L
.71238 .21306 L
.71333 .20973 L
.71429 .20508 L
.71524 .20648 L
.71619 .20669 L
.71714 .20872 L
.7181 .20839 L
.71905 .20909 L
.72 .20704 L
.72095 .2113 L
.7219 .20692 L
.72286 .20141 L
.72381 .19786 L
.72476 .19204 L
.72571 .1902 L
.72667 .18306 L
.72762 .18345 L
.72857 .18069 L
.72952 .17166 L
.73048 .16577 L
.73143 .15858 L
.73238 .14805 L
.73333 .14225 L
.73429 .13829 L
.73524 .13589 L
.73619 .12661 L
.73714 .11554 L
Mistroke
.7381 .10607 L
.73905 .10179 L
.74 .0897 L
.74095 .08558 L
.7419 .07594 L
.74286 .06993 L
.74381 .06522 L
.74476 .06583 L
.74571 .06446 L
.74667 .06435 L
.74762 .07012 L
.74857 .07488 L
.74952 .08563 L
.75048 .09641 L
.75143 .10774 L
.75238 .12318 L
.75333 .14048 L
.75429 .16011 L
.75524 .18159 L
.75619 .19687 L
.75714 .20939 L
.7581 .2232 L
.75905 .23571 L
.76 .24352 L
.76095 .25513 L
.7619 .26229 L
.76286 .26899 L
.76381 .27414 L
.76476 .27784 L
.76571 .27699 L
.76667 .27974 L
.76762 .27966 L
.76857 .2746 L
.76952 .27857 L
.77048 .28054 L
.77143 .27983 L
.77238 .28082 L
.77333 .28348 L
.77429 .28787 L
.77524 .28699 L
.77619 .28708 L
.77714 .28444 L
.7781 .28968 L
.77905 .29297 L
.78 .29316 L
.78095 .29089 L
.7819 .29221 L
.78286 .29138 L
.78381 .29279 L
.78476 .29356 L
Mistroke
.78571 .29381 L
.78667 .29203 L
.78762 .29076 L
.78857 .29106 L
.78952 .28814 L
.79048 .28567 L
.79143 .28005 L
.79238 .27637 L
.79333 .27248 L
.79429 .26869 L
.79524 .27172 L
.79619 .2712 L
.79714 .27145 L
.7981 .27106 L
.79905 .26876 L
.8 .26616 L
.80095 .26388 L
.8019 .26673 L
.80286 .26297 L
.80381 .26341 L
.80476 .26168 L
.80571 .26257 L
.80667 .26192 L
.80762 .25831 L
.80857 .26075 L
.80952 .25909 L
.81048 .25377 L
.81143 .25602 L
.81238 .25782 L
.81333 .26421 L
.81429 .26521 L
.81524 .27255 L
.81619 .27583 L
.81714 .27922 L
.8181 .28519 L
.81905 .28984 L
.82 .29108 L
.82095 .29663 L
.8219 .2988 L
.82286 .30191 L
.82381 .30339 L
.82476 .31136 L
.82571 .31313 L
.82667 .31707 L
.82762 .31409 L
.82857 .30967 L
.82952 .30893 L
.83048 .31025 L
.83143 .30984 L
.83238 .30458 L
Mistroke
.83333 .30013 L
.83429 .29474 L
.83524 .28879 L
.83619 .28229 L
.83714 .27633 L
.8381 .27609 L
.83905 .27304 L
.84 .26753 L
.84095 .26884 L
.8419 .26359 L
.84286 .26068 L
.84381 .26306 L
.84476 .26286 L
.84571 .25964 L
.84667 .25881 L
.84762 .25288 L
.84857 .25293 L
.84952 .25458 L
.85048 .24825 L
.85143 .24439 L
.85238 .24187 L
.85333 .2376 L
.85429 .24043 L
.85524 .23995 L
.85619 .23975 L
.85714 .24009 L
.8581 .24049 L
.85905 .24019 L
.86 .24389 L
.86095 .24541 L
.8619 .24173 L
.86286 .24707 L
.86381 .24591 L
.86476 .2415 L
.86571 .24204 L
.86667 .2437 L
.86762 .24759 L
.86857 .24618 L
.86952 .25067 L
.87048 .25272 L
.87143 .25647 L
.87238 .26086 L
.87333 .26058 L
.87429 .26719 L
.87524 .27248 L
.87619 .27507 L
.87714 .27988 L
.8781 .28416 L
.87905 .28863 L
.88 .29697 L
Mistroke
.88095 .30212 L
.8819 .31078 L
.88286 .31471 L
.88381 .32259 L
.88476 .32923 L
.88571 .33617 L
.88667 .3396 L
.88762 .34316 L
.88857 .34581 L
.88952 .34917 L
.89048 .34601 L
.89143 .35037 L
.89238 .35215 L
.89333 .35529 L
.89429 .34886 L
.89524 .34393 L
.89619 .33916 L
.89714 .32612 L
.8981 .31656 L
.89905 .30185 L
.9 .28254 L
.90095 .27064 L
.9019 .25717 L
.90286 .24732 L
.90381 .23704 L
.90476 .22494 L
.90571 .21744 L
.90667 .21024 L
.90762 .20551 L
.90857 .20102 L
.90952 .20413 L
.91048 .20435 L
.91143 .20054 L
.91238 .1992 L
.91333 .20119 L
.91429 .20205 L
.91524 .20246 L
.91619 .19894 L
.91714 .19454 L
.9181 .19642 L
.91905 .2024 L
.92 .20183 L
.92095 .20549 L
.9219 .20496 L
.92286 .20317 L
.92381 .19875 L
.92476 .19982 L
.92571 .20355 L
.92667 .20257 L
.92762 .19868 L
Mistroke
.92857 .19393 L
.92952 .193 L
.93048 .19524 L
.93143 .1921 L
.93238 .18473 L
.93333 .17927 L
.93429 .17632 L
.93524 .17101 L
.93619 .17375 L
.93714 .17018 L
.9381 .16674 L
.93905 .16102 L
.94 .16003 L
.94095 .15302 L
.9419 .15298 L
.94286 .15211 L
.94381 .14921 L
.94476 .147 L
.94571 .1396 L
.94667 .13508 L
.94762 .12813 L
.94857 .12141 L
.94952 .11618 L
.95048 .10796 L
.95143 .10311 L
.95238 .10054 L
.95333 .09959 L
.95429 .09465 L
.95524 .09482 L
.95619 .09487 L
.95714 .09967 L
.9581 .10418 L
.95905 .1155 L
.96 .12317 L
.96095 .12921 L
.9619 .14035 L
.96286 .14805 L
.96381 .15496 L
.96476 .16607 L
.96571 .1765 L
.96667 .18288 L
.96762 .19607 L
.96857 .20427 L
.96952 .20524 L
.97048 .21242 L
.97143 .21694 L
.97238 .22007 L
.97333 .22345 L
.97429 .22395 L
.97524 .22357 L
Mistroke
.97619 .22407 L
Mfstroke
1 0 0 r
gsave
.97619 .41382 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22176 m
.02476 .2214 L
.02571 .22195 L
.02667 .22143 L
.02762 .22365 L
.02857 .22377 L
.02952 .22212 L
.03048 .22407 L
.03143 .22081 L
.03238 .22228 L
.03333 .2228 L
.03429 .22051 L
.03524 .22193 L
.03619 .21993 L
.03714 .21893 L
.0381 .21811 L
.03905 .21889 L
.04 .22015 L
.04095 .22339 L
.0419 .22373 L
.04286 .22665 L
.04381 .22481 L
.04476 .22069 L
.04571 .21961 L
.04667 .22075 L
.04762 .22165 L
.04857 .21889 L
.04952 .21955 L
.05048 .21861 L
.05143 .22001 L
.05238 .22205 L
.05333 .22169 L
.05429 .22818 L
.05524 .22947 L
.05619 .22995 L
.05714 .23025 L
.0581 .23451 L
.05905 .24076 L
.06 .24472 L
.06095 .25044 L
.0619 .25323 L
.06286 .26055 L
.06381 .26884 L
.06476 .28884 L
.06571 .30391 L
.06667 .32525 L
.06762 .34993 L
.06857 .37904 L
.06952 .41345 L
.07048 .45375 L
Mistroke
.07143 .49257 L
.07238 .52858 L
.07333 .55631 L
.07429 .57838 L
.07524 .59439 L
.07619 .60332 L
.07714 .59911 L
.0781 .58845 L
.07905 .57131 L
.08 .54772 L
.08095 .53018 L
.0819 .50895 L
.08286 .49127 L
.08381 .478 L
.08476 .46346 L
.08571 .45429 L
.08667 .44853 L
.08762 .4514 L
.08857 .45362 L
.08952 .45576 L
.09048 .45969 L
.09143 .46176 L
.09238 .46807 L
.09333 .4755 L
.09429 .47813 L
.09524 .4852 L
.09619 .49075 L
.09714 .49038 L
.0981 .49378 L
.09905 .49229 L
.1 .49183 L
.10095 .4866 L
.1019 .48323 L
.10286 .4711 L
.10381 .46674 L
.10476 .46079 L
.10571 .45343 L
.10667 .4523 L
.10762 .44403 L
.10857 .43755 L
.10952 .42704 L
.11048 .42252 L
.11143 .41648 L
.11238 .41522 L
.11333 .40643 L
.11429 .39559 L
.11524 .39323 L
.11619 .3865 L
.11714 .38411 L
.1181 .38376 L
Mistroke
.11905 .38003 L
.12 .37587 L
.12095 .37776 L
.1219 .37281 L
.12286 .36809 L
.12381 .36535 L
.12476 .36456 L
.12571 .36355 L
.12667 .36331 L
.12762 .36089 L
.12857 .35664 L
.12952 .35382 L
.13048 .35236 L
.13143 .35127 L
.13238 .35137 L
.13333 .34569 L
.13429 .34414 L
.13524 .34178 L
.13619 .34231 L
.13714 .343 L
.1381 .34581 L
.13905 .34507 L
.14 .34511 L
.14095 .34864 L
.1419 .34538 L
.14286 .34769 L
.14381 .34741 L
.14476 .34572 L
.14571 .3467 L
.14667 .34994 L
.14762 .34945 L
.14857 .35098 L
.14952 .35341 L
.15048 .35873 L
.15143 .36747 L
.15238 .37016 L
.15333 .37838 L
.15429 .38542 L
.15524 .39971 L
.15619 .41206 L
.15714 .42002 L
.1581 .43015 L
.15905 .44196 L
.16 .45617 L
.16095 .4646 L
.1619 .47375 L
.16286 .48455 L
.16381 .48694 L
.16476 .48836 L
.16571 .49431 L
Mistroke
.16667 .49193 L
.16762 .49333 L
.16857 .48654 L
.16952 .47885 L
.17048 .47467 L
.17143 .46695 L
.17238 .46179 L
.17333 .45517 L
.17429 .44257 L
.17524 .43655 L
.17619 .4262 L
.17714 .41797 L
.1781 .41366 L
.17905 .40818 L
.18 .40553 L
.18095 .40241 L
.1819 .3907 L
.18286 .38864 L
.18381 .38389 L
.18476 .37474 L
.18571 .37141 L
.18667 .36683 L
.18762 .36351 L
.18857 .35934 L
.18952 .35226 L
.19048 .34903 L
.19143 .34452 L
.19238 .34131 L
.19333 .33933 L
.19429 .33499 L
.19524 .33032 L
.19619 .32351 L
.19714 .32054 L
.1981 .32113 L
.19905 .32366 L
.2 .32012 L
.20095 .32131 L
.2019 .32276 L
.20286 .32118 L
.20381 .3188 L
.20476 .31845 L
.20571 .31897 L
.20667 .31826 L
.20762 .32138 L
.20857 .3232 L
.20952 .32221 L
.21048 .32362 L
.21143 .32536 L
.21238 .3281 L
.21333 .33441 L
Mistroke
.21429 .33765 L
.21524 .33812 L
.21619 .344 L
.21714 .34713 L
.2181 .35455 L
.21905 .3609 L
.22 .3699 L
.22095 .37833 L
.2219 .39641 L
.22286 .41516 L
.22381 .436 L
.22476 .45347 L
.22571 .4705 L
.22667 .47637 L
.22762 .49151 L
.22857 .50146 L
.22952 .5113 L
.23048 .51979 L
.23143 .52045 L
.23238 .52169 L
.23333 .51796 L
.23429 .51419 L
.23524 .50662 L
.23619 .49794 L
.23714 .48905 L
.2381 .48189 L
.23905 .47499 L
.24 .46137 L
.24095 .45183 L
.2419 .44004 L
.24286 .43544 L
.24381 .43566 L
.24476 .4246 L
.24571 .42029 L
.24667 .41588 L
.24762 .41085 L
.24857 .40756 L
.24952 .40076 L
.25048 .40028 L
.25143 .39243 L
.25238 .38957 L
.25333 .39269 L
.25429 .39275 L
.25524 .39321 L
.25619 .39058 L
.25714 .38575 L
.2581 .3845 L
.25905 .38414 L
.26 .38754 L
.26095 .38407 L
Mistroke
.2619 .38191 L
.26286 .37717 L
.26381 .37368 L
.26476 .36984 L
.26571 .36577 L
.26667 .36599 L
.26762 .36836 L
.26857 .37236 L
.26952 .37372 L
.27048 .37758 L
.27143 .38559 L
.27238 .38476 L
.27333 .3874 L
.27429 .39041 L
.27524 .39516 L
.27619 .40062 L
.27714 .40508 L
.2781 .40851 L
.27905 .4142 L
.28 .42281 L
.28095 .42305 L
.2819 .42397 L
.28286 .42954 L
.28381 .43187 L
.28476 .43574 L
.28571 .43426 L
.28667 .43548 L
.28762 .43617 L
.28857 .44006 L
.28952 .44332 L
.29048 .4435 L
.29143 .44455 L
.29238 .4438 L
.29333 .44158 L
.29429 .43601 L
.29524 .43397 L
.29619 .43136 L
.29714 .42706 L
.2981 .42583 L
.29905 .42505 L
.3 .42295 L
.30095 .42191 L
.3019 .41742 L
.30286 .41253 L
.30381 .41137 L
.30476 .40416 L
.30571 .39793 L
.30667 .39633 L
.30762 .38902 L
.30857 .38591 L
Mistroke
.30952 .38315 L
.31048 .38235 L
.31143 .38133 L
.31238 .38182 L
.31333 .3817 L
.31429 .3787 L
.31524 .37949 L
.31619 .37843 L
.31714 .38053 L
.3181 .37845 L
.31905 .37603 L
.32 .37971 L
.32095 .37719 L
.3219 .37674 L
.32286 .37279 L
.32381 .37406 L
.32476 .36933 L
.32571 .37006 L
.32667 .36866 L
.32762 .36611 L
.32857 .3655 L
.32952 .36877 L
.33048 .36923 L
.33143 .36275 L
.33238 .36268 L
.33333 .36137 L
.33429 .362 L
.33524 .36009 L
.33619 .35816 L
.33714 .36198 L
.3381 .36886 L
.33905 .37463 L
.34 .38256 L
.34095 .3879 L
.3419 .38741 L
.34286 .39301 L
.34381 .39987 L
.34476 .40513 L
.34571 .41343 L
.34667 .42389 L
.34762 .43075 L
.34857 .43745 L
.34952 .44502 L
.35048 .45226 L
.35143 .45424 L
.35238 .45844 L
.35333 .46 L
.35429 .46193 L
.35524 .46442 L
.35619 .46758 L
Mistroke
.35714 .46681 L
.3581 .46722 L
.35905 .46692 L
.36 .46913 L
.36095 .46796 L
.3619 .45836 L
.36286 .45297 L
.36381 .45016 L
.36476 .44625 L
.36571 .44411 L
.36667 .43713 L
.36762 .43395 L
.36857 .42965 L
.36952 .42132 L
.37048 .41675 L
.37143 .41207 L
.37238 .40706 L
.37333 .40186 L
.37429 .39675 L
.37524 .3976 L
.37619 .38721 L
.37714 .38569 L
.3781 .37829 L
.37905 .37313 L
.38 .37243 L
.38095 .36687 L
.3819 .36055 L
.38286 .35787 L
.38381 .34977 L
.38476 .34569 L
.38571 .34618 L
.38667 .34581 L
.38762 .34034 L
.38857 .33858 L
.38952 .33498 L
.39048 .33309 L
.39143 .33331 L
.39238 .32929 L
.39333 .32528 L
.39429 .32212 L
.39524 .3197 L
.39619 .32182 L
.39714 .31674 L
.3981 .31672 L
.39905 .31297 L
.4 .31052 L
.40095 .31275 L
.4019 .31146 L
.40286 .30807 L
.40381 .30449 L
Mistroke
.40476 .30088 L
.40571 .2998 L
.40667 .30632 L
.40762 .3029 L
.40857 .30113 L
.40952 .30215 L
.41048 .30279 L
.41143 .30647 L
.41238 .3083 L
.41333 .3116 L
.41429 .31562 L
.41524 .31288 L
.41619 .31413 L
.41714 .31566 L
.4181 .31977 L
.41905 .32407 L
.42 .32818 L
.42095 .33745 L
.4219 .3482 L
.42286 .35605 L
.42381 .36313 L
.42476 .36799 L
.42571 .38133 L
.42667 .39581 L
.42762 .41243 L
.42857 .43024 L
.42952 .44897 L
.43048 .46204 L
.43143 .47612 L
.43238 .49192 L
.43333 .50286 L
.43429 .51088 L
.43524 .52156 L
.43619 .52994 L
.43714 .53087 L
.4381 .52813 L
.43905 .53197 L
.44 .52329 L
.44095 .51773 L
.4419 .51026 L
.44286 .5029 L
.44381 .49399 L
.44476 .48785 L
.44571 .47387 L
.44667 .46569 L
.44762 .45836 L
.44857 .45108 L
.44952 .44678 L
.45048 .44372 L
.45143 .43589 L
Mistroke
.45238 .43108 L
.45333 .42759 L
.45429 .41904 L
.45524 .41299 L
.45619 .40862 L
.45714 .40329 L
.4581 .39813 L
.45905 .39594 L
.46 .39417 L
.46095 .39254 L
.4619 .39114 L
.46286 .39427 L
.46381 .39496 L
.46476 .39046 L
.46571 .38097 L
.46667 .37582 L
.46762 .36777 L
.46857 .3645 L
.46952 .36556 L
.47048 .36434 L
.47143 .35864 L
.47238 .35436 L
.47333 .35186 L
.47429 .34751 L
.47524 .351 L
.47619 .34963 L
.47714 .34996 L
.4781 .35286 L
.47905 .35505 L
.48 .35379 L
.48095 .35325 L
.4819 .35302 L
.48286 .35795 L
.48381 .36365 L
.48476 .36439 L
.48571 .37102 L
.48667 .37199 L
.48762 .37935 L
.48857 .38483 L
.48952 .39511 L
.49048 .4047 L
.49143 .40967 L
.49238 .41795 L
.49333 .42524 L
.49429 .43106 L
.49524 .44115 L
.49619 .45459 L
.49714 .46328 L
.4981 .47201 L
.49905 .47506 L
Mistroke
.5 .48019 L
.50095 .48207 L
.5019 .47939 L
.50286 .47846 L
.50381 .47665 L
.50476 .47333 L
.50571 .46521 L
.50667 .46032 L
.50762 .4539 L
.50857 .44187 L
.50952 .44 L
.51048 .43295 L
.51143 .42634 L
.51238 .41837 L
.51333 .41152 L
.51429 .40756 L
.51524 .40151 L
.51619 .39295 L
.51714 .39018 L
.5181 .38712 L
.51905 .38744 L
.52 .38464 L
.52095 .38377 L
.5219 .38348 L
.52286 .38056 L
.52381 .37304 L
.52476 .36967 L
.52571 .36876 L
.52667 .36711 L
.52762 .3574 L
.52857 .35257 L
.52952 .34896 L
.53048 .34325 L
.53143 .34142 L
.53238 .33926 L
.53333 .33776 L
.53429 .33355 L
.53524 .32861 L
.53619 .32358 L
.53714 .32077 L
.5381 .31634 L
.53905 .3108 L
.54 .31111 L
.54095 .3063 L
.5419 .30867 L
.54286 .30461 L
.54381 .30592 L
.54476 .30581 L
.54571 .30852 L
.54667 .30671 L
Mistroke
.54762 .30469 L
.54857 .30222 L
.54952 .29788 L
.55048 .30016 L
.55143 .30448 L
.55238 .30695 L
.55333 .3049 L
.55429 .30745 L
.55524 .31233 L
.55619 .31508 L
.55714 .31874 L
.5581 .32201 L
.55905 .32746 L
.56 .33852 L
.56095 .34894 L
.5619 .36398 L
.56286 .37919 L
.56381 .38895 L
.56476 .40024 L
.56571 .40986 L
.56667 .42769 L
.56762 .44273 L
.56857 .45572 L
.56952 .46969 L
.57048 .4847 L
.57143 .50129 L
.57238 .50694 L
.57333 .51305 L
.57429 .52076 L
.57524 .5212 L
.57619 .52392 L
.57714 .52418 L
.5781 .52192 L
.57905 .51942 L
.58 .51102 L
.58095 .49796 L
.5819 .4888 L
.58286 .47147 L
.58381 .46456 L
.58476 .45519 L
.58571 .44875 L
.58667 .44338 L
.58762 .43613 L
.58857 .42856 L
.58952 .4186 L
.59048 .41084 L
.59143 .40199 L
.59238 .3977 L
.59333 .39543 L
.59429 .39725 L
Mistroke
.59524 .39044 L
.59619 .38888 L
.59714 .38837 L
.5981 .38735 L
.59905 .38564 L
.6 .38316 L
.60095 .38376 L
.6019 .38542 L
.60286 .38894 L
.60381 .38173 L
.60476 .38099 L
.60571 .38396 L
.60667 .38546 L
.60762 .38804 L
.60857 .39742 L
.60952 .3955 L
.61048 .3995 L
.61143 .4065 L
.61238 .40642 L
.61333 .41541 L
.61429 .4202 L
.61524 .42324 L
.61619 .42496 L
.61714 .42982 L
.6181 .42947 L
.61905 .4333 L
.62 .43581 L
.62095 .43814 L
.6219 .43746 L
.62286 .43583 L
.62381 .43719 L
.62476 .44138 L
.62571 .43731 L
.62667 .43266 L
.62762 .43382 L
.62857 .42942 L
.62952 .42798 L
.63048 .42509 L
.63143 .42075 L
.63238 .41351 L
.63333 .40781 L
.63429 .4046 L
.63524 .40195 L
.63619 .40347 L
.63714 .39891 L
.6381 .39502 L
.63905 .38985 L
.64 .38484 L
.64095 .38024 L
.6419 .3762 L
Mistroke
.64286 .37621 L
.64381 .37049 L
.64476 .36695 L
.64571 .36377 L
.64667 .36088 L
.64762 .35995 L
.64857 .35774 L
.64952 .35447 L
.65048 .34479 L
.65143 .34279 L
.65238 .33843 L
.65333 .33653 L
.65429 .3366 L
.65524 .33839 L
.65619 .33689 L
.65714 .33891 L
.6581 .33961 L
.65905 .34267 L
.66 .34281 L
.66095 .35114 L
.6619 .3562 L
.66286 .35867 L
.66381 .36335 L
.66476 .36649 L
.66571 .37221 L
.66667 .37533 L
.66762 .38083 L
.66857 .38752 L
.66952 .39599 L
.67048 .39884 L
.67143 .40633 L
.67238 .4126 L
.67333 .42228 L
.67429 .43081 L
.67524 .44025 L
.67619 .44388 L
.67714 .44691 L
.6781 .45277 L
.67905 .45771 L
.68 .46272 L
.68095 .46596 L
.6819 .47091 L
.68286 .46754 L
.68381 .46208 L
.68476 .46357 L
.68571 .46174 L
.68667 .45832 L
.68762 .45807 L
.68857 .45357 L
.68952 .44815 L
Mistroke
.69048 .4464 L
.69143 .43735 L
.69238 .43378 L
.69333 .42732 L
.69429 .42614 L
.69524 .41877 L
.69619 .4141 L
.69714 .40446 L
.6981 .3991 L
.69905 .39615 L
.7 .38815 L
.70095 .38246 L
.7019 .38111 L
.70286 .3796 L
.70381 .37418 L
.70476 .37059 L
.70571 .36637 L
.70667 .35704 L
.70762 .35532 L
.70857 .34682 L
.70952 .34537 L
.71048 .33727 L
.71143 .33215 L
.71238 .32294 L
.71333 .32175 L
.71429 .32397 L
.71524 .31935 L
.71619 .3151 L
.71714 .31824 L
.7181 .3169 L
.71905 .31521 L
.72 .31384 L
.72095 .3106 L
.7219 .30578 L
.72286 .29961 L
.72381 .29342 L
.72476 .29063 L
.72571 .2876 L
.72667 .28365 L
.72762 .28536 L
.72857 .2838 L
.72952 .28447 L
.73048 .29083 L
.73143 .29314 L
.73238 .29608 L
.73333 .29595 L
.73429 .29708 L
.73524 .30102 L
.73619 .30598 L
.73714 .31134 L
Mistroke
.7381 .31968 L
.73905 .33003 L
.74 .33913 L
.74095 .34382 L
.7419 .35583 L
.74286 .36617 L
.74381 .38191 L
.74476 .39075 L
.74571 .41507 L
.74667 .43471 L
.74762 .45266 L
.74857 .46901 L
.74952 .4882 L
.75048 .50233 L
.75143 .52076 L
.75238 .53002 L
.75333 .53708 L
.75429 .54125 L
.75524 .53902 L
.75619 .53583 L
.75714 .53095 L
.7581 .52313 L
.75905 .51471 L
.76 .50857 L
.76095 .49954 L
.7619 .49318 L
.76286 .48251 L
.76381 .47299 L
.76476 .46445 L
.76571 .4536 L
.76667 .4387 L
.76762 .43175 L
.76857 .42638 L
.76952 .42045 L
.77048 .4191 L
.77143 .41418 L
.77238 .41043 L
.77333 .40862 L
.77429 .4083 L
.77524 .40456 L
.77619 .40273 L
.77714 .39925 L
.7781 .39986 L
.77905 .39991 L
.78 .40273 L
.78095 .40548 L
.7819 .40172 L
.78286 .40451 L
.78381 .40423 L
.78476 .40609 L
Mistroke
.78571 .41178 L
.78667 .4136 L
.78762 .4121 L
.78857 .41812 L
.78952 .41504 L
.79048 .41856 L
.79143 .41791 L
.79238 .41874 L
.79333 .41817 L
.79429 .41384 L
.79524 .40971 L
.79619 .40841 L
.79714 .4108 L
.7981 .40832 L
.79905 .40315 L
.8 .39772 L
.80095 .39744 L
.8019 .39418 L
.80286 .39435 L
.80381 .39744 L
.80476 .3943 L
.80571 .39788 L
.80667 .3929 L
.80762 .39249 L
.80857 .39318 L
.80952 .3946 L
.81048 .39645 L
.81143 .39219 L
.81238 .38693 L
.81333 .38704 L
.81429 .38394 L
.81524 .38667 L
.81619 .38204 L
.81714 .38227 L
.8181 .38369 L
.81905 .3823 L
.82 .3846 L
.82095 .38718 L
.8219 .39001 L
.82286 .39326 L
.82381 .39821 L
.82476 .40084 L
.82571 .40425 L
.82667 .40403 L
.82762 .40397 L
.82857 .40576 L
.82952 .41076 L
.83048 .41683 L
.83143 .42038 L
.83238 .42829 L
Mistroke
.83333 .43101 L
.83429 .43597 L
.83524 .44235 L
.83619 .44458 L
.83714 .44503 L
.8381 .44314 L
.83905 .44059 L
.84 .43881 L
.84095 .43491 L
.8419 .43882 L
.84286 .44 L
.84381 .44054 L
.84476 .43124 L
.84571 .42847 L
.84667 .42656 L
.84762 .42324 L
.84857 .41966 L
.84952 .414 L
.85048 .41354 L
.85143 .41278 L
.85238 .41005 L
.85333 .40544 L
.85429 .40624 L
.85524 .40059 L
.85619 .39412 L
.85714 .38987 L
.8581 .38845 L
.85905 .38621 L
.86 .38183 L
.86095 .38565 L
.8619 .37812 L
.86286 .37662 L
.86381 .37108 L
.86476 .36567 L
.86571 .36173 L
.86667 .36347 L
.86762 .3602 L
.86857 .35519 L
.86952 .3494 L
.87048 .34665 L
.87143 .34513 L
.87238 .34194 L
.87333 .34132 L
.87429 .34029 L
.87524 .33575 L
.87619 .33338 L
.87714 .33359 L
.8781 .32874 L
.87905 .3246 L
.88 .32777 L
Mistroke
.88095 .32901 L
.8819 .33415 L
.88286 .33703 L
.88381 .34467 L
.88476 .35121 L
.88571 .35507 L
.88667 .3631 L
.88762 .36927 L
.88857 .37266 L
.88952 .38473 L
.89048 .39535 L
.89143 .40789 L
.89238 .42017 L
.89333 .43307 L
.89429 .44347 L
.89524 .45271 L
.89619 .46612 L
.89714 .47261 L
.8981 .48089 L
.89905 .49085 L
.9 .49324 L
.90095 .49206 L
.9019 .48964 L
.90286 .48648 L
.90381 .4829 L
.90476 .48123 L
.90571 .47417 L
.90667 .46739 L
.90762 .45575 L
.90857 .44786 L
.90952 .43735 L
.91048 .43471 L
.91143 .43419 L
.91238 .42493 L
.91333 .41487 L
.91429 .41244 L
.91524 .40736 L
.91619 .40119 L
.91714 .39992 L
.9181 .39256 L
.91905 .39039 L
.92 .38851 L
.92095 .38509 L
.9219 .37941 L
.92286 .37285 L
.92381 .36902 L
.92476 .37049 L
.92571 .36414 L
.92667 .36196 L
.92762 .35597 L
Mistroke
.92857 .35709 L
.92952 .35379 L
.93048 .34703 L
.93143 .34331 L
.93238 .34019 L
.93333 .3376 L
.93429 .3398 L
.93524 .33852 L
.93619 .33939 L
.93714 .33815 L
.9381 .33493 L
.93905 .33625 L
.94 .3413 L
.94095 .33736 L
.9419 .34087 L
.94286 .33962 L
.94381 .34135 L
.94476 .34532 L
.94571 .34697 L
.94667 .34587 L
.94762 .34801 L
.94857 .35578 L
.94952 .35936 L
.95048 .36338 L
.95143 .3729 L
.95238 .38682 L
.95333 .39426 L
.95429 .40244 L
.95524 .41501 L
.95619 .42532 L
.95714 .43383 L
.9581 .44465 L
.95905 .45347 L
.96 .45742 L
.96095 .46458 L
.9619 .4723 L
.96286 .47843 L
.96381 .47891 L
.96476 .48217 L
.96571 .48195 L
.96667 .4818 L
.96762 .47451 L
.96857 .46833 L
.96952 .4605 L
.97048 .45244 L
.97143 .44743 L
.97238 .43982 L
.97333 .43361 L
.97429 .42579 L
.97524 .41874 L
Mistroke
.97619 .41382 L
Mfstroke
1 1 0 r
gsave
.97619 .29043 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29043 m
.02476 .29043 L
.02571 .29043 L
.02667 .29043 L
.02762 .29043 L
.02857 .29043 L
.02952 .29043 L
.03048 .29043 L
.03143 .29043 L
.03238 .29043 L
.03333 .29043 L
.03429 .29043 L
.03524 .29043 L
.03619 .29043 L
.03714 .29043 L
.0381 .29043 L
.03905 .29043 L
.04 .29043 L
.04095 .29043 L
.0419 .29043 L
.04286 .29043 L
.04381 .29043 L
.04476 .29043 L
.04571 .29043 L
.04667 .29043 L
.04762 .29043 L
.04857 .29043 L
.04952 .29043 L
.05048 .29043 L
.05143 .29043 L
.05238 .29043 L
.05333 .29043 L
.05429 .29043 L
.05524 .29043 L
.05619 .29043 L
.05714 .29043 L
.0581 .29043 L
.05905 .29043 L
.06 .29043 L
.06095 .29043 L
.0619 .29043 L
.06286 .29043 L
.06381 .29043 L
.06476 .29043 L
.06571 .29043 L
.06667 .29043 L
.06762 .29043 L
.06857 .29043 L
.06952 .29043 L
.07048 .29043 L
Mistroke
.07143 .29043 L
.07238 .29043 L
.07333 .29043 L
.07429 .29043 L
.07524 .29043 L
.07619 .29043 L
.07714 .29043 L
.0781 .29043 L
.07905 .29043 L
.08 .29043 L
.08095 .29043 L
.0819 .29043 L
.08286 .29043 L
.08381 .29043 L
.08476 .29043 L
.08571 .29043 L
.08667 .29043 L
.08762 .29043 L
.08857 .29043 L
.08952 .29043 L
.09048 .29043 L
.09143 .29043 L
.09238 .29043 L
.09333 .29043 L
.09429 .29043 L
.09524 .29043 L
.09619 .29043 L
.09714 .29043 L
.0981 .29043 L
.09905 .29043 L
.1 .29043 L
.10095 .29043 L
.1019 .29043 L
.10286 .29043 L
.10381 .29043 L
.10476 .29043 L
.10571 .29043 L
.10667 .29043 L
.10762 .29043 L
.10857 .29043 L
.10952 .29043 L
.11048 .29043 L
.11143 .29043 L
.11238 .29043 L
.11333 .29043 L
.11429 .29043 L
.11524 .29043 L
.11619 .29043 L
.11714 .29043 L
.1181 .29043 L
Mistroke
.11905 .29043 L
.12 .29043 L
.12095 .29043 L
.1219 .29043 L
.12286 .29043 L
.12381 .29043 L
.12476 .29043 L
.12571 .29043 L
.12667 .29043 L
.12762 .29043 L
.12857 .29043 L
.12952 .29043 L
.13048 .29043 L
.13143 .29043 L
.13238 .29043 L
.13333 .29043 L
.13429 .29043 L
.13524 .29043 L
.13619 .29043 L
.13714 .29043 L
.1381 .29043 L
.13905 .29043 L
.14 .29043 L
.14095 .29043 L
.1419 .29043 L
.14286 .29043 L
.14381 .29043 L
.14476 .29043 L
.14571 .29043 L
.14667 .29043 L
.14762 .29043 L
.14857 .29043 L
.14952 .29043 L
.15048 .29043 L
.15143 .29043 L
.15238 .29043 L
.15333 .29043 L
.15429 .29043 L
.15524 .29043 L
.15619 .29043 L
.15714 .29043 L
.1581 .29043 L
.15905 .29043 L
.16 .29043 L
.16095 .29043 L
.1619 .29043 L
.16286 .29043 L
.16381 .29043 L
.16476 .29043 L
.16571 .29043 L
Mistroke
.16667 .29043 L
.16762 .29043 L
.16857 .29043 L
.16952 .29043 L
.17048 .29043 L
.17143 .29043 L
.17238 .29043 L
.17333 .29043 L
.17429 .29043 L
.17524 .29043 L
.17619 .29043 L
.17714 .29043 L
.1781 .29043 L
.17905 .29043 L
.18 .29043 L
.18095 .29043 L
.1819 .29043 L
.18286 .29043 L
.18381 .29043 L
.18476 .29043 L
.18571 .29043 L
.18667 .29043 L
.18762 .29043 L
.18857 .29043 L
.18952 .29043 L
.19048 .29043 L
.19143 .29043 L
.19238 .29043 L
.19333 .29043 L
.19429 .29043 L
.19524 .29043 L
.19619 .29043 L
.19714 .29043 L
.1981 .29043 L
.19905 .29043 L
.2 .29043 L
.20095 .29043 L
.2019 .29043 L
.20286 .29043 L
.20381 .29043 L
.20476 .29043 L
.20571 .29043 L
.20667 .29043 L
.20762 .29043 L
.20857 .29043 L
.20952 .29043 L
.21048 .29043 L
.21143 .29043 L
.21238 .29043 L
.21333 .29043 L
Mistroke
.21429 .29043 L
.21524 .29043 L
.21619 .29043 L
.21714 .29043 L
.2181 .29043 L
.21905 .29043 L
.22 .29043 L
.22095 .29043 L
.2219 .29043 L
.22286 .29043 L
.22381 .29043 L
.22476 .29043 L
.22571 .29043 L
.22667 .29043 L
.22762 .29043 L
.22857 .29043 L
.22952 .29043 L
.23048 .29043 L
.23143 .29043 L
.23238 .29043 L
.23333 .29043 L
.23429 .29043 L
.23524 .29043 L
.23619 .29043 L
.23714 .29043 L
.2381 .29043 L
.23905 .29043 L
.24 .29043 L
.24095 .29043 L
.2419 .29043 L
.24286 .29043 L
.24381 .29043 L
.24476 .29043 L
.24571 .29043 L
.24667 .29043 L
.24762 .29043 L
.24857 .29043 L
.24952 .29043 L
.25048 .29043 L
.25143 .29043 L
.25238 .29043 L
.25333 .29043 L
.25429 .29043 L
.25524 .29043 L
.25619 .29043 L
.25714 .29043 L
.2581 .29043 L
.25905 .29043 L
.26 .29043 L
.26095 .29043 L
Mistroke
.2619 .29043 L
.26286 .29043 L
.26381 .29043 L
.26476 .29043 L
.26571 .29043 L
.26667 .29043 L
.26762 .29043 L
.26857 .29043 L
.26952 .29043 L
.27048 .29043 L
.27143 .29043 L
.27238 .29043 L
.27333 .29043 L
.27429 .29043 L
.27524 .29043 L
.27619 .29043 L
.27714 .29043 L
.2781 .29043 L
.27905 .29043 L
.28 .29043 L
.28095 .29043 L
.2819 .29043 L
.28286 .29043 L
.28381 .29043 L
.28476 .29043 L
.28571 .29043 L
.28667 .29043 L
.28762 .29043 L
.28857 .29043 L
.28952 .29043 L
.29048 .29043 L
.29143 .29043 L
.29238 .29043 L
.29333 .29043 L
.29429 .29043 L
.29524 .29043 L
.29619 .29043 L
.29714 .29043 L
.2981 .29043 L
.29905 .29043 L
.3 .29043 L
.30095 .29043 L
.3019 .29043 L
.30286 .29043 L
.30381 .29043 L
.30476 .29043 L
.30571 .29043 L
.30667 .29043 L
.30762 .29043 L
.30857 .29043 L
Mistroke
.30952 .29043 L
.31048 .29043 L
.31143 .29043 L
.31238 .29043 L
.31333 .29043 L
.31429 .29043 L
.31524 .29043 L
.31619 .29043 L
.31714 .29043 L
.3181 .29043 L
.31905 .29043 L
.32 .29043 L
.32095 .29043 L
.3219 .29043 L
.32286 .29043 L
.32381 .29043 L
.32476 .29043 L
.32571 .29043 L
.32667 .29043 L
.32762 .29043 L
.32857 .29043 L
.32952 .29043 L
.33048 .29043 L
.33143 .29043 L
.33238 .29043 L
.33333 .29043 L
.33429 .29043 L
.33524 .29043 L
.33619 .29043 L
.33714 .29043 L
.3381 .29043 L
.33905 .29043 L
.34 .29043 L
.34095 .29043 L
.3419 .29043 L
.34286 .29043 L
.34381 .29043 L
.34476 .29043 L
.34571 .29043 L
.34667 .29043 L
.34762 .29043 L
.34857 .29043 L
.34952 .29043 L
.35048 .29043 L
.35143 .29043 L
.35238 .29043 L
.35333 .29043 L
.35429 .29043 L
.35524 .29043 L
.35619 .29043 L
Mistroke
.35714 .29043 L
.3581 .29043 L
.35905 .29043 L
.36 .29043 L
.36095 .29043 L
.3619 .29043 L
.36286 .29043 L
.36381 .29043 L
.36476 .29043 L
.36571 .29043 L
.36667 .29043 L
.36762 .29043 L
.36857 .29043 L
.36952 .29043 L
.37048 .29043 L
.37143 .29043 L
.37238 .29043 L
.37333 .29043 L
.37429 .29043 L
.37524 .29043 L
.37619 .29043 L
.37714 .29043 L
.3781 .29043 L
.37905 .29043 L
.38 .29043 L
.38095 .29043 L
.3819 .29043 L
.38286 .29043 L
.38381 .29043 L
.38476 .29043 L
.38571 .29043 L
.38667 .29043 L
.38762 .29043 L
.38857 .29043 L
.38952 .29043 L
.39048 .29043 L
.39143 .29043 L
.39238 .29043 L
.39333 .29043 L
.39429 .29043 L
.39524 .29043 L
.39619 .29043 L
.39714 .29043 L
.3981 .29043 L
.39905 .29043 L
.4 .29043 L
.40095 .29043 L
.4019 .29043 L
.40286 .29043 L
.40381 .29043 L
Mistroke
.40476 .29043 L
.40571 .29043 L
.40667 .29043 L
.40762 .29043 L
.40857 .29043 L
.40952 .29043 L
.41048 .29043 L
.41143 .29043 L
.41238 .29043 L
.41333 .29043 L
.41429 .29043 L
.41524 .29043 L
.41619 .29043 L
.41714 .29043 L
.4181 .29043 L
.41905 .29043 L
.42 .29043 L
.42095 .29043 L
.4219 .29043 L
.42286 .29043 L
.42381 .29043 L
.42476 .29043 L
.42571 .29043 L
.42667 .29043 L
.42762 .29043 L
.42857 .29043 L
.42952 .29043 L
.43048 .29043 L
.43143 .29043 L
.43238 .29043 L
.43333 .29043 L
.43429 .29043 L
.43524 .29043 L
.43619 .29043 L
.43714 .29043 L
.4381 .29043 L
.43905 .29043 L
.44 .29043 L
.44095 .29043 L
.4419 .29043 L
.44286 .29043 L
.44381 .29043 L
.44476 .29043 L
.44571 .29043 L
.44667 .29043 L
.44762 .29043 L
.44857 .29043 L
.44952 .29043 L
.45048 .29043 L
.45143 .29043 L
Mistroke
.45238 .29043 L
.45333 .29043 L
.45429 .29043 L
.45524 .29043 L
.45619 .29043 L
.45714 .29043 L
.4581 .29043 L
.45905 .29043 L
.46 .29043 L
.46095 .29043 L
.4619 .29043 L
.46286 .29043 L
.46381 .29043 L
.46476 .29043 L
.46571 .29043 L
.46667 .29043 L
.46762 .29043 L
.46857 .29043 L
.46952 .29043 L
.47048 .29043 L
.47143 .29043 L
.47238 .29043 L
.47333 .29043 L
.47429 .29043 L
.47524 .29043 L
.47619 .29043 L
.47714 .29043 L
.4781 .29043 L
.47905 .29043 L
.48 .29043 L
.48095 .29043 L
.4819 .29043 L
.48286 .29043 L
.48381 .29043 L
.48476 .29043 L
.48571 .29043 L
.48667 .29043 L
.48762 .29043 L
.48857 .29043 L
.48952 .29043 L
.49048 .29043 L
.49143 .29043 L
.49238 .29043 L
.49333 .29043 L
.49429 .29043 L
.49524 .29043 L
.49619 .29043 L
.49714 .29043 L
.4981 .29043 L
.49905 .29043 L
Mistroke
.5 .29043 L
.50095 .29043 L
.5019 .29043 L
.50286 .29043 L
.50381 .29043 L
.50476 .29043 L
.50571 .29043 L
.50667 .29043 L
.50762 .29043 L
.50857 .29043 L
.50952 .29043 L
.51048 .29043 L
.51143 .29043 L
.51238 .29043 L
.51333 .29043 L
.51429 .29043 L
.51524 .29043 L
.51619 .29043 L
.51714 .29043 L
.5181 .29043 L
.51905 .29043 L
.52 .29043 L
.52095 .29043 L
.5219 .29043 L
.52286 .29043 L
.52381 .29043 L
.52476 .29043 L
.52571 .29043 L
.52667 .29043 L
.52762 .29043 L
.52857 .29043 L
.52952 .29043 L
.53048 .29043 L
.53143 .29043 L
.53238 .29043 L
.53333 .29043 L
.53429 .29043 L
.53524 .29043 L
.53619 .29043 L
.53714 .29043 L
.5381 .29043 L
.53905 .29043 L
.54 .29043 L
.54095 .29043 L
.5419 .29043 L
.54286 .29043 L
.54381 .29043 L
.54476 .29043 L
.54571 .29043 L
.54667 .29043 L
Mistroke
.54762 .29043 L
.54857 .29043 L
.54952 .29043 L
.55048 .29043 L
.55143 .29043 L
.55238 .29043 L
.55333 .29043 L
.55429 .29043 L
.55524 .29043 L
.55619 .29043 L
.55714 .29043 L
.5581 .29043 L
.55905 .29043 L
.56 .29043 L
.56095 .29043 L
.5619 .29043 L
.56286 .29043 L
.56381 .29043 L
.56476 .29043 L
.56571 .29043 L
.56667 .29043 L
.56762 .29043 L
.56857 .29043 L
.56952 .29043 L
.57048 .29043 L
.57143 .29043 L
.57238 .29043 L
.57333 .29043 L
.57429 .29043 L
.57524 .29043 L
.57619 .29043 L
.57714 .29043 L
.5781 .29043 L
.57905 .29043 L
.58 .29043 L
.58095 .29043 L
.5819 .29043 L
.58286 .29043 L
.58381 .29043 L
.58476 .29043 L
.58571 .29043 L
.58667 .29043 L
.58762 .29043 L
.58857 .29043 L
.58952 .29043 L
.59048 .29043 L
.59143 .29043 L
.59238 .29043 L
.59333 .29043 L
.59429 .29043 L
Mistroke
.59524 .29043 L
.59619 .29043 L
.59714 .29043 L
.5981 .29043 L
.59905 .29043 L
.6 .29043 L
.60095 .29043 L
.6019 .29043 L
.60286 .29043 L
.60381 .29043 L
.60476 .29043 L
.60571 .29043 L
.60667 .29043 L
.60762 .29043 L
.60857 .29043 L
.60952 .29043 L
.61048 .29043 L
.61143 .29043 L
.61238 .29043 L
.61333 .29043 L
.61429 .29043 L
.61524 .29043 L
.61619 .29043 L
.61714 .29043 L
.6181 .29043 L
.61905 .29043 L
.62 .29043 L
.62095 .29043 L
.6219 .29043 L
.62286 .29043 L
.62381 .29043 L
.62476 .29043 L
.62571 .29043 L
.62667 .29043 L
.62762 .29043 L
.62857 .29043 L
.62952 .29043 L
.63048 .29043 L
.63143 .29043 L
.63238 .29043 L
.63333 .29043 L
.63429 .29043 L
.63524 .29043 L
.63619 .29043 L
.63714 .29043 L
.6381 .29043 L
.63905 .29043 L
.64 .29043 L
.64095 .29043 L
.6419 .29043 L
Mistroke
.64286 .29043 L
.64381 .29043 L
.64476 .29043 L
.64571 .29043 L
.64667 .29043 L
.64762 .29043 L
.64857 .29043 L
.64952 .29043 L
.65048 .29043 L
.65143 .29043 L
.65238 .29043 L
.65333 .29043 L
.65429 .29043 L
.65524 .29043 L
.65619 .29043 L
.65714 .29043 L
.6581 .29043 L
.65905 .29043 L
.66 .29043 L
.66095 .29043 L
.6619 .29043 L
.66286 .29043 L
.66381 .29043 L
.66476 .29043 L
.66571 .29043 L
.66667 .29043 L
.66762 .29043 L
.66857 .29043 L
.66952 .29043 L
.67048 .29043 L
.67143 .29043 L
.67238 .29043 L
.67333 .29043 L
.67429 .29043 L
.67524 .29043 L
.67619 .29043 L
.67714 .29043 L
.6781 .29043 L
.67905 .29043 L
.68 .29043 L
.68095 .29043 L
.6819 .29043 L
.68286 .29043 L
.68381 .29043 L
.68476 .29043 L
.68571 .29043 L
.68667 .29043 L
.68762 .29043 L
.68857 .29043 L
.68952 .29043 L
Mistroke
.69048 .29043 L
.69143 .29043 L
.69238 .29043 L
.69333 .29043 L
.69429 .29043 L
.69524 .29043 L
.69619 .29043 L
.69714 .29043 L
.6981 .29043 L
.69905 .29043 L
.7 .29043 L
.70095 .29043 L
.7019 .29043 L
.70286 .29043 L
.70381 .29043 L
.70476 .29043 L
.70571 .29043 L
.70667 .29043 L
.70762 .29043 L
.70857 .29043 L
.70952 .29043 L
.71048 .29043 L
.71143 .29043 L
.71238 .29043 L
.71333 .29043 L
.71429 .29043 L
.71524 .29043 L
.71619 .29043 L
.71714 .29043 L
.7181 .29043 L
.71905 .29043 L
.72 .29043 L
.72095 .29043 L
.7219 .29043 L
.72286 .29043 L
.72381 .29043 L
.72476 .29043 L
.72571 .29043 L
.72667 .29043 L
.72762 .29043 L
.72857 .29043 L
.72952 .29043 L
.73048 .29043 L
.73143 .29043 L
.73238 .29043 L
.73333 .29043 L
.73429 .29043 L
.73524 .29043 L
.73619 .29043 L
.73714 .29043 L
Mistroke
.7381 .29043 L
.73905 .29043 L
.74 .29043 L
.74095 .29043 L
.7419 .29043 L
.74286 .29043 L
.74381 .29043 L
.74476 .29043 L
.74571 .29043 L
.74667 .29043 L
.74762 .29043 L
.74857 .29043 L
.74952 .29043 L
.75048 .29043 L
.75143 .29043 L
.75238 .29043 L
.75333 .29043 L
.75429 .29043 L
.75524 .29043 L
.75619 .29043 L
.75714 .29043 L
.7581 .29043 L
.75905 .29043 L
.76 .29043 L
.76095 .29043 L
.7619 .29043 L
.76286 .29043 L
.76381 .29043 L
.76476 .29043 L
.76571 .29043 L
.76667 .29043 L
.76762 .29043 L
.76857 .29043 L
.76952 .29043 L
.77048 .29043 L
.77143 .29043 L
.77238 .29043 L
.77333 .29043 L
.77429 .29043 L
.77524 .29043 L
.77619 .29043 L
.77714 .29043 L
.7781 .29043 L
.77905 .29043 L
.78 .29043 L
.78095 .29043 L
.7819 .29043 L
.78286 .29043 L
.78381 .29043 L
.78476 .29043 L
Mistroke
.78571 .29043 L
.78667 .29043 L
.78762 .29043 L
.78857 .29043 L
.78952 .29043 L
.79048 .29043 L
.79143 .29043 L
.79238 .29043 L
.79333 .29043 L
.79429 .29043 L
.79524 .29043 L
.79619 .29043 L
.79714 .29043 L
.7981 .29043 L
.79905 .29043 L
.8 .29043 L
.80095 .29043 L
.8019 .29043 L
.80286 .29043 L
.80381 .29043 L
.80476 .29043 L
.80571 .29043 L
.80667 .29043 L
.80762 .29043 L
.80857 .29043 L
.80952 .29043 L
.81048 .29043 L
.81143 .29043 L
.81238 .29043 L
.81333 .29043 L
.81429 .29043 L
.81524 .29043 L
.81619 .29043 L
.81714 .29043 L
.8181 .29043 L
.81905 .29043 L
.82 .29043 L
.82095 .29043 L
.8219 .29043 L
.82286 .29043 L
.82381 .29043 L
.82476 .29043 L
.82571 .29043 L
.82667 .29043 L
.82762 .29043 L
.82857 .29043 L
.82952 .29043 L
.83048 .29043 L
.83143 .29043 L
.83238 .29043 L
Mistroke
.83333 .29043 L
.83429 .29043 L
.83524 .29043 L
.83619 .29043 L
.83714 .29043 L
.8381 .29043 L
.83905 .29043 L
.84 .29043 L
.84095 .29043 L
.8419 .29043 L
.84286 .29043 L
.84381 .29043 L
.84476 .29043 L
.84571 .29043 L
.84667 .29043 L
.84762 .29043 L
.84857 .29043 L
.84952 .29043 L
.85048 .29043 L
.85143 .29043 L
.85238 .29043 L
.85333 .29043 L
.85429 .29043 L
.85524 .29043 L
.85619 .29043 L
.85714 .29043 L
.8581 .29043 L
.85905 .29043 L
.86 .29043 L
.86095 .29043 L
.8619 .29043 L
.86286 .29043 L
.86381 .29043 L
.86476 .29043 L
.86571 .29043 L
.86667 .29043 L
.86762 .29043 L
.86857 .29043 L
.86952 .29043 L
.87048 .29043 L
.87143 .29043 L
.87238 .29043 L
.87333 .29043 L
.87429 .29043 L
.87524 .29043 L
.87619 .29043 L
.87714 .29043 L
.8781 .29043 L
.87905 .29043 L
.88 .29043 L
Mistroke
.88095 .29043 L
.8819 .29043 L
.88286 .29043 L
.88381 .29043 L
.88476 .29043 L
.88571 .29043 L
.88667 .29043 L
.88762 .29043 L
.88857 .29043 L
.88952 .29043 L
.89048 .29043 L
.89143 .29043 L
.89238 .29043 L
.89333 .29043 L
.89429 .29043 L
.89524 .29043 L
.89619 .29043 L
.89714 .29043 L
.8981 .29043 L
.89905 .29043 L
.9 .29043 L
.90095 .29043 L
.9019 .29043 L
.90286 .29043 L
.90381 .29043 L
.90476 .29043 L
.90571 .29043 L
.90667 .29043 L
.90762 .29043 L
.90857 .29043 L
.90952 .29043 L
.91048 .29043 L
.91143 .29043 L
.91238 .29043 L
.91333 .29043 L
.91429 .29043 L
.91524 .29043 L
.91619 .29043 L
.91714 .29043 L
.9181 .29043 L
.91905 .29043 L
.92 .29043 L
.92095 .29043 L
.9219 .29043 L
.92286 .29043 L
.92381 .29043 L
.92476 .29043 L
.92571 .29043 L
.92667 .29043 L
.92762 .29043 L
Mistroke
.92857 .29043 L
.92952 .29043 L
.93048 .29043 L
.93143 .29043 L
.93238 .29043 L
.93333 .29043 L
.93429 .29043 L
.93524 .29043 L
.93619 .29043 L
.93714 .29043 L
.9381 .29043 L
.93905 .29043 L
.94 .29043 L
.94095 .29043 L
.9419 .29043 L
.94286 .29043 L
.94381 .29043 L
.94476 .29043 L
.94571 .29043 L
.94667 .29043 L
.94762 .29043 L
.94857 .29043 L
.94952 .29043 L
.95048 .29043 L
.95143 .29043 L
.95238 .29043 L
.95333 .29043 L
.95429 .29043 L
.95524 .29043 L
.95619 .29043 L
.95714 .29043 L
.9581 .29043 L
.95905 .29043 L
.96 .29043 L
.96095 .29043 L
.9619 .29043 L
.96286 .29043 L
.96381 .29043 L
.96476 .29043 L
.96571 .29043 L
.96667 .29043 L
.96762 .29043 L
.96857 .29043 L
.96952 .29043 L
.97048 .29043 L
.97143 .29043 L
.97238 .29043 L
.97333 .29043 L
.97429 .29043 L
.97524 .29043 L
Mistroke
.97619 .29043 L
Mfstroke
.541 .169 .886 r
gsave
.97619 .41417 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41417 m
.02476 .41417 L
.02571 .41417 L
.02667 .41417 L
.02762 .41417 L
.02857 .41417 L
.02952 .41417 L
.03048 .41417 L
.03143 .41417 L
.03238 .41417 L
.03333 .41417 L
.03429 .41417 L
.03524 .41417 L
.03619 .41417 L
.03714 .41417 L
.0381 .41417 L
.03905 .41417 L
.04 .41417 L
.04095 .41417 L
.0419 .41417 L
.04286 .41417 L
.04381 .41417 L
.04476 .41417 L
.04571 .41417 L
.04667 .41417 L
.04762 .41417 L
.04857 .41417 L
.04952 .41417 L
.05048 .41417 L
.05143 .41417 L
.05238 .41417 L
.05333 .41417 L
.05429 .41417 L
.05524 .41417 L
.05619 .41418 L
.05714 .41418 L
.0581 .41418 L
.05905 .41417 L
.06 .41417 L
.06095 .41417 L
.0619 .41417 L
.06286 .41417 L
.06381 .41417 L
.06476 .41417 L
.06571 .41417 L
.06667 .41418 L
.06762 .41417 L
.06857 .41418 L
.06952 .41418 L
.07048 .41417 L
Mistroke
.07143 .41417 L
.07238 .41417 L
.07333 .41418 L
.07429 .41418 L
.07524 .41418 L
.07619 .41418 L
.07714 .41418 L
.0781 .41418 L
.07905 .41418 L
.08 .41418 L
.08095 .41418 L
.0819 .41418 L
.08286 .41417 L
.08381 .41417 L
.08476 .41417 L
.08571 .41417 L
.08667 .41417 L
.08762 .41417 L
.08857 .41417 L
.08952 .41417 L
.09048 .41417 L
.09143 .41417 L
.09238 .41417 L
.09333 .41417 L
.09429 .41417 L
.09524 .41417 L
.09619 .41417 L
.09714 .41417 L
.0981 .41417 L
.09905 .41417 L
.1 .41417 L
.10095 .41417 L
.1019 .41417 L
.10286 .41417 L
.10381 .41417 L
.10476 .41417 L
.10571 .41417 L
.10667 .41417 L
.10762 .41417 L
.10857 .41417 L
.10952 .41417 L
.11048 .41417 L
.11143 .41417 L
.11238 .41417 L
.11333 .41417 L
.11429 .41417 L
.11524 .41417 L
.11619 .41417 L
.11714 .41417 L
.1181 .41417 L
Mistroke
.11905 .41417 L
.12 .41417 L
.12095 .41417 L
.1219 .41417 L
.12286 .41417 L
.12381 .41417 L
.12476 .41417 L
.12571 .41417 L
.12667 .41417 L
.12762 .41417 L
.12857 .41417 L
.12952 .41417 L
.13048 .41417 L
.13143 .41417 L
.13238 .41417 L
.13333 .41417 L
.13429 .41417 L
.13524 .41417 L
.13619 .41417 L
.13714 .41417 L
.1381 .41417 L
.13905 .41417 L
.14 .41417 L
.14095 .41417 L
.1419 .41417 L
.14286 .41417 L
.14381 .41417 L
.14476 .41417 L
.14571 .41417 L
.14667 .41417 L
.14762 .41417 L
.14857 .41417 L
.14952 .41417 L
.15048 .41417 L
.15143 .41417 L
.15238 .41417 L
.15333 .41417 L
.15429 .41417 L
.15524 .41417 L
.15619 .41417 L
.15714 .41417 L
.1581 .41417 L
.15905 .41417 L
.16 .41417 L
.16095 .41417 L
.1619 .41417 L
.16286 .41417 L
.16381 .41417 L
.16476 .41417 L
.16571 .41417 L
Mistroke
.16667 .41417 L
.16762 .41417 L
.16857 .41417 L
.16952 .41417 L
.17048 .41417 L
.17143 .41417 L
.17238 .41417 L
.17333 .41417 L
.17429 .41417 L
.17524 .41417 L
.17619 .41417 L
.17714 .41417 L
.1781 .41417 L
.17905 .41417 L
.18 .41417 L
.18095 .41417 L
.1819 .41417 L
.18286 .41417 L
.18381 .41417 L
.18476 .41417 L
.18571 .41417 L
.18667 .41417 L
.18762 .41417 L
.18857 .41417 L
.18952 .41417 L
.19048 .41417 L
.19143 .41417 L
.19238 .41417 L
.19333 .41417 L
.19429 .41417 L
.19524 .41417 L
.19619 .41417 L
.19714 .41417 L
.1981 .41417 L
.19905 .41417 L
.2 .41417 L
.20095 .41417 L
.2019 .41417 L
.20286 .41417 L
.20381 .41417 L
.20476 .41417 L
.20571 .41417 L
.20667 .41417 L
.20762 .41418 L
.20857 .41418 L
.20952 .41418 L
.21048 .41418 L
.21143 .41418 L
.21238 .41418 L
.21333 .41418 L
Mistroke
.21429 .41418 L
.21524 .41418 L
.21619 .41418 L
.21714 .41418 L
.2181 .41417 L
.21905 .41417 L
.22 .41417 L
.22095 .41418 L
.2219 .41418 L
.22286 .41418 L
.22381 .41418 L
.22476 .41418 L
.22571 .41417 L
.22667 .41417 L
.22762 .41418 L
.22857 .41417 L
.22952 .41418 L
.23048 .41417 L
.23143 .41417 L
.23238 .41417 L
.23333 .41417 L
.23429 .41417 L
.23524 .41417 L
.23619 .41417 L
.23714 .41417 L
.2381 .41417 L
.23905 .41417 L
.24 .41417 L
.24095 .41417 L
.2419 .41417 L
.24286 .41417 L
.24381 .41418 L
.24476 .41417 L
.24571 .41418 L
.24667 .41417 L
.24762 .41417 L
.24857 .41417 L
.24952 .41417 L
.25048 .41418 L
.25143 .41418 L
.25238 .41418 L
.25333 .41418 L
.25429 .41417 L
.25524 .41418 L
.25619 .41418 L
.25714 .41417 L
.2581 .41418 L
.25905 .41418 L
.26 .41418 L
.26095 .41418 L
Mistroke
.2619 .41418 L
.26286 .41418 L
.26381 .41418 L
.26476 .41418 L
.26571 .41418 L
.26667 .41418 L
.26762 .41418 L
.26857 .41418 L
.26952 .41418 L
.27048 .41418 L
.27143 .41418 L
.27238 .41418 L
.27333 .41418 L
.27429 .41418 L
.27524 .41418 L
.27619 .41418 L
.27714 .41418 L
.2781 .41418 L
.27905 .41418 L
.28 .41418 L
.28095 .41418 L
.2819 .41418 L
.28286 .41418 L
.28381 .41418 L
.28476 .41418 L
.28571 .41418 L
.28667 .41418 L
.28762 .41418 L
.28857 .41418 L
.28952 .41418 L
.29048 .41418 L
.29143 .41418 L
.29238 .41418 L
.29333 .41418 L
.29429 .41418 L
.29524 .41418 L
.29619 .41418 L
.29714 .41418 L
.2981 .41418 L
.29905 .41418 L
.3 .41418 L
.30095 .41418 L
.3019 .41418 L
.30286 .41418 L
.30381 .41418 L
.30476 .41418 L
.30571 .41418 L
.30667 .41418 L
.30762 .41418 L
.30857 .41418 L
Mistroke
.30952 .41418 L
.31048 .41418 L
.31143 .41418 L
.31238 .41418 L
.31333 .41418 L
.31429 .41418 L
.31524 .41418 L
.31619 .41418 L
.31714 .41418 L
.3181 .41418 L
.31905 .41418 L
.32 .41418 L
.32095 .41418 L
.3219 .41418 L
.32286 .41418 L
.32381 .41418 L
.32476 .41418 L
.32571 .41418 L
.32667 .41418 L
.32762 .41418 L
.32857 .41418 L
.32952 .41418 L
.33048 .41418 L
.33143 .41418 L
.33238 .41418 L
.33333 .41418 L
.33429 .41418 L
.33524 .41418 L
.33619 .41418 L
.33714 .41418 L
.3381 .41418 L
.33905 .41418 L
.34 .41418 L
.34095 .41418 L
.3419 .41418 L
.34286 .41418 L
.34381 .41418 L
.34476 .41418 L
.34571 .41418 L
.34667 .41418 L
.34762 .41418 L
.34857 .41418 L
.34952 .41417 L
.35048 .41417 L
.35143 .41418 L
.35238 .41418 L
.35333 .41418 L
.35429 .41418 L
.35524 .41417 L
.35619 .41418 L
Mistroke
.35714 .41418 L
.3581 .41418 L
.35905 .41418 L
.36 .41417 L
.36095 .41417 L
.3619 .41418 L
.36286 .41418 L
.36381 .41418 L
.36476 .41417 L
.36571 .41417 L
.36667 .41418 L
.36762 .41418 L
.36857 .41418 L
.36952 .41418 L
.37048 .41418 L
.37143 .41418 L
.37238 .41418 L
.37333 .41418 L
.37429 .41418 L
.37524 .41418 L
.37619 .41418 L
.37714 .41418 L
.3781 .41418 L
.37905 .41418 L
.38 .41418 L
.38095 .41418 L
.3819 .41418 L
.38286 .41418 L
.38381 .41418 L
.38476 .41418 L
.38571 .41418 L
.38667 .41418 L
.38762 .41418 L
.38857 .41418 L
.38952 .41418 L
.39048 .41418 L
.39143 .41418 L
.39238 .41418 L
.39333 .41418 L
.39429 .41418 L
.39524 .41418 L
.39619 .41418 L
.39714 .41418 L
.3981 .41418 L
.39905 .41418 L
.4 .41418 L
.40095 .41418 L
.4019 .41418 L
.40286 .41418 L
.40381 .41418 L
Mistroke
.40476 .41418 L
.40571 .41418 L
.40667 .41418 L
.40762 .41418 L
.40857 .41418 L
.40952 .41418 L
.41048 .41418 L
.41143 .41418 L
.41238 .41418 L
.41333 .41418 L
.41429 .41418 L
.41524 .41418 L
.41619 .41418 L
.41714 .41418 L
.4181 .41418 L
.41905 .41418 L
.42 .41418 L
.42095 .41418 L
.4219 .41418 L
.42286 .41418 L
.42381 .41418 L
.42476 .41418 L
.42571 .41418 L
.42667 .41418 L
.42762 .41418 L
.42857 .41418 L
.42952 .41418 L
.43048 .41418 L
.43143 .41418 L
.43238 .41418 L
.43333 .41418 L
.43429 .41418 L
.43524 .41418 L
.43619 .41418 L
.43714 .41418 L
.4381 .41418 L
.43905 .41418 L
.44 .41418 L
.44095 .41418 L
.4419 .41418 L
.44286 .41418 L
.44381 .41418 L
.44476 .41418 L
.44571 .41418 L
.44667 .41418 L
.44762 .41418 L
.44857 .41418 L
.44952 .41418 L
.45048 .41418 L
.45143 .41418 L
Mistroke
.45238 .41418 L
.45333 .41418 L
.45429 .41418 L
.45524 .41418 L
.45619 .41418 L
.45714 .41418 L
.4581 .41418 L
.45905 .41418 L
.46 .41418 L
.46095 .41418 L
.4619 .41418 L
.46286 .41418 L
.46381 .41418 L
.46476 .41418 L
.46571 .41418 L
.46667 .41418 L
.46762 .41418 L
.46857 .41418 L
.46952 .41418 L
.47048 .41418 L
.47143 .41418 L
.47238 .41418 L
.47333 .41418 L
.47429 .41418 L
.47524 .41418 L
.47619 .41418 L
.47714 .41418 L
.4781 .41418 L
.47905 .41418 L
.48 .41418 L
.48095 .41418 L
.4819 .41418 L
.48286 .41418 L
.48381 .41418 L
.48476 .41418 L
.48571 .41418 L
.48667 .41418 L
.48762 .41418 L
.48857 .41418 L
.48952 .41418 L
.49048 .41418 L
.49143 .41418 L
.49238 .41418 L
.49333 .41418 L
.49429 .41418 L
.49524 .41418 L
.49619 .41418 L
.49714 .41418 L
.4981 .41418 L
.49905 .41418 L
Mistroke
.5 .41418 L
.50095 .41418 L
.5019 .41418 L
.50286 .41418 L
.50381 .41418 L
.50476 .41418 L
.50571 .41418 L
.50667 .41418 L
.50762 .41418 L
.50857 .41418 L
.50952 .41418 L
.51048 .41418 L
.51143 .41418 L
.51238 .41418 L
.51333 .41418 L
.51429 .41418 L
.51524 .41418 L
.51619 .41418 L
.51714 .41418 L
.5181 .41418 L
.51905 .41418 L
.52 .41418 L
.52095 .41418 L
.5219 .41418 L
.52286 .41418 L
.52381 .41418 L
.52476 .41418 L
.52571 .41418 L
.52667 .41418 L
.52762 .41418 L
.52857 .41418 L
.52952 .41418 L
.53048 .41418 L
.53143 .41418 L
.53238 .41418 L
.53333 .41418 L
.53429 .41418 L
.53524 .41418 L
.53619 .41418 L
.53714 .41418 L
.5381 .41418 L
.53905 .41418 L
.54 .41418 L
.54095 .41418 L
.5419 .41418 L
.54286 .41418 L
.54381 .41418 L
.54476 .41418 L
.54571 .41418 L
.54667 .41418 L
Mistroke
.54762 .41418 L
.54857 .41418 L
.54952 .41418 L
.55048 .41418 L
.55143 .41418 L
.55238 .41418 L
.55333 .41418 L
.55429 .41418 L
.55524 .41418 L
.55619 .41418 L
.55714 .41418 L
.5581 .41418 L
.55905 .41418 L
.56 .41418 L
.56095 .41418 L
.5619 .41418 L
.56286 .41418 L
.56381 .41418 L
.56476 .41418 L
.56571 .41418 L
.56667 .41418 L
.56762 .41418 L
.56857 .41418 L
.56952 .41418 L
.57048 .41418 L
.57143 .41418 L
.57238 .41418 L
.57333 .41418 L
.57429 .41418 L
.57524 .41418 L
.57619 .41418 L
.57714 .41418 L
.5781 .41418 L
.57905 .41418 L
.58 .41418 L
.58095 .41418 L
.5819 .41418 L
.58286 .41418 L
.58381 .41418 L
.58476 .41418 L
.58571 .41418 L
.58667 .41418 L
.58762 .41418 L
.58857 .41418 L
.58952 .41418 L
.59048 .41418 L
.59143 .41418 L
.59238 .41418 L
.59333 .41418 L
.59429 .41418 L
Mistroke
.59524 .41418 L
.59619 .41418 L
.59714 .41418 L
.5981 .41418 L
.59905 .41418 L
.6 .41418 L
.60095 .41418 L
.6019 .41418 L
.60286 .41418 L
.60381 .41418 L
.60476 .41418 L
.60571 .41418 L
.60667 .41418 L
.60762 .41418 L
.60857 .41418 L
.60952 .41418 L
.61048 .41418 L
.61143 .41418 L
.61238 .41418 L
.61333 .41418 L
.61429 .41418 L
.61524 .41418 L
.61619 .41418 L
.61714 .41418 L
.6181 .41418 L
.61905 .41418 L
.62 .41418 L
.62095 .41418 L
.6219 .41418 L
.62286 .41418 L
.62381 .41418 L
.62476 .41418 L
.62571 .41418 L
.62667 .41418 L
.62762 .41418 L
.62857 .41418 L
.62952 .41418 L
.63048 .41418 L
.63143 .41418 L
.63238 .41418 L
.63333 .41418 L
.63429 .41418 L
.63524 .41418 L
.63619 .41418 L
.63714 .41418 L
.6381 .41418 L
.63905 .41418 L
.64 .41418 L
.64095 .41418 L
.6419 .41418 L
Mistroke
.64286 .41418 L
.64381 .41418 L
.64476 .41418 L
.64571 .41418 L
.64667 .41418 L
.64762 .41418 L
.64857 .41418 L
.64952 .41418 L
.65048 .41418 L
.65143 .41418 L
.65238 .41418 L
.65333 .41418 L
.65429 .41418 L
.65524 .41418 L
.65619 .41418 L
.65714 .41418 L
.6581 .41418 L
.65905 .41418 L
.66 .41418 L
.66095 .41418 L
.6619 .41418 L
.66286 .41418 L
.66381 .41418 L
.66476 .41418 L
.66571 .41418 L
.66667 .41418 L
.66762 .41418 L
.66857 .41418 L
.66952 .41418 L
.67048 .41418 L
.67143 .41418 L
.67238 .41418 L
.67333 .41418 L
.67429 .41418 L
.67524 .41418 L
.67619 .41418 L
.67714 .41418 L
.6781 .41418 L
.67905 .41418 L
.68 .41418 L
.68095 .41418 L
.6819 .41418 L
.68286 .41418 L
.68381 .41418 L
.68476 .41418 L
.68571 .41418 L
.68667 .41418 L
.68762 .41418 L
.68857 .41418 L
.68952 .41418 L
Mistroke
.69048 .41418 L
.69143 .41418 L
.69238 .41418 L
.69333 .41418 L
.69429 .41418 L
.69524 .41418 L
.69619 .41418 L
.69714 .41418 L
.6981 .41418 L
.69905 .41418 L
.7 .41418 L
.70095 .41418 L
.7019 .41418 L
.70286 .41418 L
.70381 .41418 L
.70476 .41418 L
.70571 .41418 L
.70667 .41418 L
.70762 .41418 L
.70857 .41418 L
.70952 .41418 L
.71048 .41418 L
.71143 .41418 L
.71238 .41418 L
.71333 .41418 L
.71429 .41418 L
.71524 .41418 L
.71619 .41418 L
.71714 .41418 L
.7181 .41418 L
.71905 .41418 L
.72 .41418 L
.72095 .41418 L
.7219 .41418 L
.72286 .41418 L
.72381 .41418 L
.72476 .41418 L
.72571 .41418 L
.72667 .41418 L
.72762 .41418 L
.72857 .41418 L
.72952 .41418 L
.73048 .41418 L
.73143 .41418 L
.73238 .41418 L
.73333 .41418 L
.73429 .41418 L
.73524 .41418 L
.73619 .41418 L
.73714 .41418 L
Mistroke
.7381 .41418 L
.73905 .41418 L
.74 .41418 L
.74095 .41418 L
.7419 .41418 L
.74286 .41418 L
.74381 .41418 L
.74476 .41418 L
.74571 .41418 L
.74667 .41418 L
.74762 .41418 L
.74857 .41418 L
.74952 .41418 L
.75048 .41418 L
.75143 .41418 L
.75238 .41418 L
.75333 .41418 L
.75429 .41418 L
.75524 .41418 L
.75619 .41418 L
.75714 .41418 L
.7581 .41418 L
.75905 .41418 L
.76 .41418 L
.76095 .41418 L
.7619 .41418 L
.76286 .41418 L
.76381 .41418 L
.76476 .41418 L
.76571 .41418 L
.76667 .41418 L
.76762 .41418 L
.76857 .41418 L
.76952 .41418 L
.77048 .41418 L
.77143 .41418 L
.77238 .41418 L
.77333 .41418 L
.77429 .41418 L
.77524 .41418 L
.77619 .41418 L
.77714 .41418 L
.7781 .41417 L
.77905 .41418 L
.78 .41418 L
.78095 .41418 L
.7819 .41418 L
.78286 .41418 L
.78381 .41418 L
.78476 .41418 L
Mistroke
.78571 .41418 L
.78667 .41418 L
.78762 .41418 L
.78857 .41418 L
.78952 .41418 L
.79048 .41418 L
.79143 .41418 L
.79238 .41418 L
.79333 .41417 L
.79429 .41417 L
.79524 .41418 L
.79619 .41418 L
.79714 .41418 L
.7981 .41418 L
.79905 .41418 L
.8 .41418 L
.80095 .41418 L
.8019 .41418 L
.80286 .41418 L
.80381 .41418 L
.80476 .41418 L
.80571 .41418 L
.80667 .41418 L
.80762 .41418 L
.80857 .41418 L
.80952 .41417 L
.81048 .41417 L
.81143 .41417 L
.81238 .41417 L
.81333 .41417 L
.81429 .41417 L
.81524 .41417 L
.81619 .41417 L
.81714 .41417 L
.8181 .41417 L
.81905 .41417 L
.82 .41417 L
.82095 .41417 L
.8219 .41417 L
.82286 .41417 L
.82381 .41417 L
.82476 .41417 L
.82571 .41417 L
.82667 .41417 L
.82762 .41417 L
.82857 .41417 L
.82952 .41417 L
.83048 .41417 L
.83143 .41417 L
.83238 .41417 L
Mistroke
.83333 .41417 L
.83429 .41417 L
.83524 .41417 L
.83619 .41417 L
.83714 .41417 L
.8381 .41417 L
.83905 .41417 L
.84 .41417 L
.84095 .41417 L
.8419 .41417 L
.84286 .41417 L
.84381 .41417 L
.84476 .41417 L
.84571 .41417 L
.84667 .41417 L
.84762 .41417 L
.84857 .41417 L
.84952 .41417 L
.85048 .41417 L
.85143 .41417 L
.85238 .41418 L
.85333 .41418 L
.85429 .41418 L
.85524 .41418 L
.85619 .41418 L
.85714 .41417 L
.8581 .41418 L
.85905 .41418 L
.86 .41418 L
.86095 .41418 L
.8619 .41418 L
.86286 .41418 L
.86381 .41418 L
.86476 .41418 L
.86571 .41418 L
.86667 .41418 L
.86762 .41418 L
.86857 .41418 L
.86952 .41418 L
.87048 .41418 L
.87143 .41418 L
.87238 .41418 L
.87333 .41418 L
.87429 .41418 L
.87524 .41418 L
.87619 .41418 L
.87714 .41418 L
.8781 .41418 L
.87905 .41418 L
.88 .41418 L
Mistroke
.88095 .41418 L
.8819 .41418 L
.88286 .41418 L
.88381 .41418 L
.88476 .41418 L
.88571 .41418 L
.88667 .41418 L
.88762 .41418 L
.88857 .41418 L
.88952 .41418 L
.89048 .41418 L
.89143 .41418 L
.89238 .41418 L
.89333 .41418 L
.89429 .41418 L
.89524 .41418 L
.89619 .41418 L
.89714 .41418 L
.8981 .41418 L
.89905 .41418 L
.9 .41418 L
.90095 .41418 L
.9019 .41418 L
.90286 .41418 L
.90381 .41418 L
.90476 .41418 L
.90571 .41418 L
.90667 .41418 L
.90762 .41418 L
.90857 .41418 L
.90952 .41418 L
.91048 .41418 L
.91143 .41418 L
.91238 .41418 L
.91333 .41418 L
.91429 .41418 L
.91524 .41418 L
.91619 .41418 L
.91714 .41418 L
.9181 .41418 L
.91905 .41418 L
.92 .41418 L
.92095 .41418 L
.9219 .41418 L
.92286 .41418 L
.92381 .41418 L
.92476 .41418 L
.92571 .41418 L
.92667 .41418 L
.92762 .41418 L
Mistroke
.92857 .41418 L
.92952 .41418 L
.93048 .41418 L
.93143 .41418 L
.93238 .41418 L
.93333 .41418 L
.93429 .41418 L
.93524 .41418 L
.93619 .41418 L
.93714 .41418 L
.9381 .41418 L
.93905 .41418 L
.94 .41418 L
.94095 .41418 L
.9419 .41418 L
.94286 .41418 L
.94381 .41418 L
.94476 .41418 L
.94571 .41418 L
.94667 .41418 L
.94762 .41417 L
.94857 .41418 L
.94952 .41418 L
.95048 .41417 L
.95143 .41417 L
.95238 .41418 L
.95333 .41418 L
.95429 .41418 L
.95524 .41418 L
.95619 .41417 L
.95714 .41418 L
.9581 .41418 L
.95905 .41418 L
.96 .41418 L
.96095 .41417 L
.9619 .41418 L
.96286 .41418 L
.96381 .41418 L
.96476 .41417 L
.96571 .41417 L
.96667 .41418 L
.96762 .41417 L
.96857 .41417 L
.96952 .41417 L
.97048 .41417 L
.97143 .41417 L
.97238 .41417 L
.97333 .41417 L
.97429 .41417 L
.97524 .41417 L
Mistroke
.97619 .41417 L
Mfstroke
1 .38 .01 r
gsave
.97619 .24003 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24002 m
.02476 .24002 L
.02571 .24002 L
.02667 .24002 L
.02762 .24002 L
.02857 .24002 L
.02952 .24002 L
.03048 .24002 L
.03143 .24002 L
.03238 .24002 L
.03333 .24002 L
.03429 .24002 L
.03524 .24002 L
.03619 .24002 L
.03714 .24002 L
.0381 .24002 L
.03905 .24002 L
.04 .24002 L
.04095 .24002 L
.0419 .24002 L
.04286 .24002 L
.04381 .24002 L
.04476 .24002 L
.04571 .24002 L
.04667 .24002 L
.04762 .24002 L
.04857 .24002 L
.04952 .24002 L
.05048 .24002 L
.05143 .24002 L
.05238 .24002 L
.05333 .24002 L
.05429 .24002 L
.05524 .24002 L
.05619 .24002 L
.05714 .24002 L
.0581 .24002 L
.05905 .24002 L
.06 .24002 L
.06095 .24002 L
.0619 .24002 L
.06286 .24002 L
.06381 .24002 L
.06476 .24002 L
.06571 .24002 L
.06667 .24002 L
.06762 .24002 L
.06857 .24002 L
.06952 .24002 L
.07048 .24002 L
Mistroke
.07143 .24002 L
.07238 .24002 L
.07333 .24002 L
.07429 .24002 L
.07524 .24002 L
.07619 .24002 L
.07714 .24002 L
.0781 .24002 L
.07905 .24002 L
.08 .24002 L
.08095 .24002 L
.0819 .24002 L
.08286 .24002 L
.08381 .24002 L
.08476 .24002 L
.08571 .24002 L
.08667 .24002 L
.08762 .24002 L
.08857 .24002 L
.08952 .24002 L
.09048 .24002 L
.09143 .24002 L
.09238 .24002 L
.09333 .24002 L
.09429 .24002 L
.09524 .24002 L
.09619 .24002 L
.09714 .24002 L
.0981 .24002 L
.09905 .24002 L
.1 .24002 L
.10095 .24002 L
.1019 .24002 L
.10286 .24002 L
.10381 .24002 L
.10476 .24002 L
.10571 .24002 L
.10667 .24002 L
.10762 .24002 L
.10857 .24002 L
.10952 .24002 L
.11048 .24002 L
.11143 .24002 L
.11238 .24002 L
.11333 .24002 L
.11429 .24002 L
.11524 .24002 L
.11619 .24002 L
.11714 .24002 L
.1181 .24002 L
Mistroke
.11905 .24002 L
.12 .24002 L
.12095 .24002 L
.1219 .24002 L
.12286 .24002 L
.12381 .24002 L
.12476 .24002 L
.12571 .24002 L
.12667 .24002 L
.12762 .24002 L
.12857 .24002 L
.12952 .24002 L
.13048 .24002 L
.13143 .24002 L
.13238 .24002 L
.13333 .24002 L
.13429 .24002 L
.13524 .24002 L
.13619 .24002 L
.13714 .24002 L
.1381 .24002 L
.13905 .24002 L
.14 .24002 L
.14095 .24002 L
.1419 .24002 L
.14286 .24002 L
.14381 .24002 L
.14476 .24002 L
.14571 .24002 L
.14667 .24002 L
.14762 .24002 L
.14857 .24002 L
.14952 .24002 L
.15048 .24002 L
.15143 .24002 L
.15238 .24002 L
.15333 .24002 L
.15429 .24002 L
.15524 .24002 L
.15619 .24002 L
.15714 .24002 L
.1581 .24002 L
.15905 .24002 L
.16 .24002 L
.16095 .24002 L
.1619 .24002 L
.16286 .24002 L
.16381 .24002 L
.16476 .24002 L
.16571 .24002 L
Mistroke
.16667 .24002 L
.16762 .24002 L
.16857 .24002 L
.16952 .24002 L
.17048 .24002 L
.17143 .24002 L
.17238 .24002 L
.17333 .24002 L
.17429 .24002 L
.17524 .24002 L
.17619 .24002 L
.17714 .24002 L
.1781 .24002 L
.17905 .24002 L
.18 .24002 L
.18095 .24002 L
.1819 .24002 L
.18286 .24002 L
.18381 .24002 L
.18476 .24002 L
.18571 .24002 L
.18667 .24002 L
.18762 .24002 L
.18857 .24002 L
.18952 .24002 L
.19048 .24002 L
.19143 .24002 L
.19238 .24002 L
.19333 .24002 L
.19429 .24002 L
.19524 .24002 L
.19619 .24002 L
.19714 .24002 L
.1981 .24002 L
.19905 .24002 L
.2 .24002 L
.20095 .24002 L
.2019 .24002 L
.20286 .24002 L
.20381 .24002 L
.20476 .24002 L
.20571 .24002 L
.20667 .24002 L
.20762 .24002 L
.20857 .24002 L
.20952 .24002 L
.21048 .24002 L
.21143 .24002 L
.21238 .24002 L
.21333 .24002 L
Mistroke
.21429 .24002 L
.21524 .24002 L
.21619 .24002 L
.21714 .24002 L
.2181 .24002 L
.21905 .24002 L
.22 .24002 L
.22095 .24002 L
.2219 .24002 L
.22286 .24002 L
.22381 .24002 L
.22476 .24002 L
.22571 .24002 L
.22667 .24002 L
.22762 .24002 L
.22857 .24002 L
.22952 .24002 L
.23048 .24002 L
.23143 .24002 L
.23238 .24002 L
.23333 .24002 L
.23429 .24002 L
.23524 .24002 L
.23619 .24002 L
.23714 .24002 L
.2381 .24002 L
.23905 .24002 L
.24 .24002 L
.24095 .24002 L
.2419 .24002 L
.24286 .24002 L
.24381 .24002 L
.24476 .24002 L
.24571 .24002 L
.24667 .24002 L
.24762 .24002 L
.24857 .24002 L
.24952 .24002 L
.25048 .24002 L
.25143 .24002 L
.25238 .24002 L
.25333 .24002 L
.25429 .24002 L
.25524 .24002 L
.25619 .24002 L
.25714 .24002 L
.2581 .24002 L
.25905 .24002 L
.26 .24002 L
.26095 .24002 L
Mistroke
.2619 .24002 L
.26286 .24002 L
.26381 .24002 L
.26476 .24002 L
.26571 .24002 L
.26667 .24002 L
.26762 .24002 L
.26857 .24002 L
.26952 .24002 L
.27048 .24002 L
.27143 .24002 L
.27238 .24002 L
.27333 .24002 L
.27429 .24002 L
.27524 .24002 L
.27619 .24002 L
.27714 .24002 L
.2781 .24002 L
.27905 .24002 L
.28 .24002 L
.28095 .24002 L
.2819 .24002 L
.28286 .24002 L
.28381 .24002 L
.28476 .24002 L
.28571 .24002 L
.28667 .24002 L
.28762 .24002 L
.28857 .24002 L
.28952 .24002 L
.29048 .24002 L
.29143 .24002 L
.29238 .24002 L
.29333 .24002 L
.29429 .24002 L
.29524 .24002 L
.29619 .24002 L
.29714 .24002 L
.2981 .24002 L
.29905 .24002 L
.3 .24002 L
.30095 .24002 L
.3019 .24002 L
.30286 .24002 L
.30381 .24002 L
.30476 .24002 L
.30571 .24002 L
.30667 .24002 L
.30762 .24002 L
.30857 .24002 L
Mistroke
.30952 .24002 L
.31048 .24002 L
.31143 .24002 L
.31238 .24002 L
.31333 .24002 L
.31429 .24002 L
.31524 .24002 L
.31619 .24002 L
.31714 .24002 L
.3181 .24002 L
.31905 .24002 L
.32 .24002 L
.32095 .24002 L
.3219 .24002 L
.32286 .24002 L
.32381 .24002 L
.32476 .24002 L
.32571 .24002 L
.32667 .24002 L
.32762 .24002 L
.32857 .24002 L
.32952 .24002 L
.33048 .24002 L
.33143 .24002 L
.33238 .24002 L
.33333 .24002 L
.33429 .24002 L
.33524 .24002 L
.33619 .24002 L
.33714 .24002 L
.3381 .24002 L
.33905 .24002 L
.34 .24002 L
.34095 .24002 L
.3419 .24002 L
.34286 .24002 L
.34381 .24002 L
.34476 .24002 L
.34571 .24002 L
.34667 .24002 L
.34762 .24002 L
.34857 .24002 L
.34952 .24002 L
.35048 .24002 L
.35143 .24002 L
.35238 .24002 L
.35333 .24002 L
.35429 .24002 L
.35524 .24002 L
.35619 .24002 L
Mistroke
.35714 .24002 L
.3581 .24002 L
.35905 .24002 L
.36 .24002 L
.36095 .24002 L
.3619 .24002 L
.36286 .24002 L
.36381 .24002 L
.36476 .24002 L
.36571 .24002 L
.36667 .24002 L
.36762 .24002 L
.36857 .24002 L
.36952 .24002 L
.37048 .24002 L
.37143 .24002 L
.37238 .24002 L
.37333 .24002 L
.37429 .24002 L
.37524 .24002 L
.37619 .24002 L
.37714 .24002 L
.3781 .24002 L
.37905 .24002 L
.38 .24002 L
.38095 .24002 L
.3819 .24002 L
.38286 .24002 L
.38381 .24002 L
.38476 .24002 L
.38571 .24002 L
.38667 .24002 L
.38762 .24002 L
.38857 .24002 L
.38952 .24002 L
.39048 .24002 L
.39143 .24002 L
.39238 .24002 L
.39333 .24002 L
.39429 .24002 L
.39524 .24002 L
.39619 .24002 L
.39714 .24002 L
.3981 .24002 L
.39905 .24002 L
.4 .24002 L
.40095 .24002 L
.4019 .24002 L
.40286 .24002 L
.40381 .24002 L
Mistroke
.40476 .24002 L
.40571 .24002 L
.40667 .24002 L
.40762 .24002 L
.40857 .24002 L
.40952 .24002 L
.41048 .24002 L
.41143 .24002 L
.41238 .24002 L
.41333 .24002 L
.41429 .24002 L
.41524 .24002 L
.41619 .24002 L
.41714 .24002 L
.4181 .24002 L
.41905 .24002 L
.42 .24002 L
.42095 .24002 L
.4219 .24002 L
.42286 .24002 L
.42381 .24002 L
.42476 .24002 L
.42571 .24002 L
.42667 .24002 L
.42762 .24002 L
.42857 .24002 L
.42952 .24002 L
.43048 .24002 L
.43143 .24002 L
.43238 .24002 L
.43333 .24002 L
.43429 .24002 L
.43524 .24002 L
.43619 .24002 L
.43714 .24002 L
.4381 .24002 L
.43905 .24002 L
.44 .24002 L
.44095 .24002 L
.4419 .24002 L
.44286 .24002 L
.44381 .24002 L
.44476 .24002 L
.44571 .24002 L
.44667 .24002 L
.44762 .24002 L
.44857 .24002 L
.44952 .24002 L
.45048 .24002 L
.45143 .24002 L
Mistroke
.45238 .24002 L
.45333 .24002 L
.45429 .24002 L
.45524 .24002 L
.45619 .24002 L
.45714 .24002 L
.4581 .24002 L
.45905 .24002 L
.46 .24002 L
.46095 .24002 L
.4619 .24002 L
.46286 .24002 L
.46381 .24002 L
.46476 .24002 L
.46571 .24002 L
.46667 .24002 L
.46762 .24002 L
.46857 .24002 L
.46952 .24002 L
.47048 .24002 L
.47143 .24002 L
.47238 .24002 L
.47333 .24002 L
.47429 .24002 L
.47524 .24002 L
.47619 .24002 L
.47714 .24002 L
.4781 .24002 L
.47905 .24002 L
.48 .24002 L
.48095 .24002 L
.4819 .24002 L
.48286 .24002 L
.48381 .24002 L
.48476 .24002 L
.48571 .24002 L
.48667 .24002 L
.48762 .24002 L
.48857 .24002 L
.48952 .24002 L
.49048 .24002 L
.49143 .24002 L
.49238 .24002 L
.49333 .24002 L
.49429 .24002 L
.49524 .24002 L
.49619 .24002 L
.49714 .24002 L
.4981 .24002 L
.49905 .24002 L
Mistroke
.5 .24002 L
.50095 .24002 L
.5019 .24002 L
.50286 .24002 L
.50381 .24002 L
.50476 .24002 L
.50571 .24002 L
.50667 .24002 L
.50762 .24002 L
.50857 .24002 L
.50952 .24002 L
.51048 .24002 L
.51143 .24002 L
.51238 .24002 L
.51333 .24002 L
.51429 .24002 L
.51524 .24002 L
.51619 .24002 L
.51714 .24002 L
.5181 .24002 L
.51905 .24002 L
.52 .24002 L
.52095 .24002 L
.5219 .24002 L
.52286 .24002 L
.52381 .24002 L
.52476 .24002 L
.52571 .24002 L
.52667 .24002 L
.52762 .24002 L
.52857 .24002 L
.52952 .24002 L
.53048 .24002 L
.53143 .24002 L
.53238 .24002 L
.53333 .24002 L
.53429 .24002 L
.53524 .24002 L
.53619 .24002 L
.53714 .24002 L
.5381 .24002 L
.53905 .24002 L
.54 .24002 L
.54095 .24002 L
.5419 .24002 L
.54286 .24002 L
.54381 .24002 L
.54476 .24002 L
.54571 .24002 L
.54667 .24002 L
Mistroke
.54762 .24002 L
.54857 .24002 L
.54952 .24002 L
.55048 .24002 L
.55143 .24002 L
.55238 .24002 L
.55333 .24002 L
.55429 .24002 L
.55524 .24002 L
.55619 .24002 L
.55714 .24002 L
.5581 .24002 L
.55905 .24002 L
.56 .24002 L
.56095 .24002 L
.5619 .24002 L
.56286 .24002 L
.56381 .24002 L
.56476 .24002 L
.56571 .24002 L
.56667 .24002 L
.56762 .24002 L
.56857 .24002 L
.56952 .24002 L
.57048 .24002 L
.57143 .24002 L
.57238 .24002 L
.57333 .24002 L
.57429 .24002 L
.57524 .24002 L
.57619 .24002 L
.57714 .24002 L
.5781 .24002 L
.57905 .24002 L
.58 .24002 L
.58095 .24002 L
.5819 .24002 L
.58286 .24002 L
.58381 .24002 L
.58476 .24002 L
.58571 .24002 L
.58667 .24002 L
.58762 .24002 L
.58857 .24002 L
.58952 .24002 L
.59048 .24002 L
.59143 .24002 L
.59238 .24002 L
.59333 .24002 L
.59429 .24002 L
Mistroke
.59524 .24002 L
.59619 .24002 L
.59714 .24002 L
.5981 .24002 L
.59905 .24002 L
.6 .24002 L
.60095 .24002 L
.6019 .24002 L
.60286 .24002 L
.60381 .24002 L
.60476 .24002 L
.60571 .24002 L
.60667 .24002 L
.60762 .24002 L
.60857 .24002 L
.60952 .24002 L
.61048 .24002 L
.61143 .24002 L
.61238 .24002 L
.61333 .24002 L
.61429 .24002 L
.61524 .24002 L
.61619 .24002 L
.61714 .24002 L
.6181 .24002 L
.61905 .24002 L
.62 .24002 L
.62095 .24002 L
.6219 .24002 L
.62286 .24002 L
.62381 .24002 L
.62476 .24002 L
.62571 .24002 L
.62667 .24002 L
.62762 .24002 L
.62857 .24002 L
.62952 .24002 L
.63048 .24002 L
.63143 .24002 L
.63238 .24002 L
.63333 .24002 L
.63429 .24002 L
.63524 .24002 L
.63619 .24002 L
.63714 .24002 L
.6381 .24002 L
.63905 .24002 L
.64 .24002 L
.64095 .24002 L
.6419 .24002 L
Mistroke
.64286 .24002 L
.64381 .24002 L
.64476 .24002 L
.64571 .24002 L
.64667 .24002 L
.64762 .24003 L
.64857 .24003 L
.64952 .24003 L
.65048 .24003 L
.65143 .24002 L
.65238 .24003 L
.65333 .24003 L
.65429 .24002 L
.65524 .24002 L
.65619 .24002 L
.65714 .24002 L
.6581 .24002 L
.65905 .24002 L
.66 .24002 L
.66095 .24002 L
.6619 .24002 L
.66286 .24002 L
.66381 .24002 L
.66476 .24002 L
.66571 .24002 L
.66667 .24002 L
.66762 .24002 L
.66857 .24002 L
.66952 .24002 L
.67048 .24002 L
.67143 .24002 L
.67238 .24002 L
.67333 .24002 L
.67429 .24002 L
.67524 .24002 L
.67619 .24002 L
.67714 .24002 L
.6781 .24002 L
.67905 .24002 L
.68 .24002 L
.68095 .24002 L
.6819 .24002 L
.68286 .24002 L
.68381 .24002 L
.68476 .24002 L
.68571 .24002 L
.68667 .24002 L
.68762 .24002 L
.68857 .24002 L
.68952 .24002 L
Mistroke
.69048 .24002 L
.69143 .24002 L
.69238 .24002 L
.69333 .24002 L
.69429 .24002 L
.69524 .24002 L
.69619 .24002 L
.69714 .24002 L
.6981 .24002 L
.69905 .24002 L
.7 .24002 L
.70095 .24002 L
.7019 .24002 L
.70286 .24002 L
.70381 .24002 L
.70476 .24002 L
.70571 .24002 L
.70667 .24002 L
.70762 .24002 L
.70857 .24002 L
.70952 .24002 L
.71048 .24002 L
.71143 .24002 L
.71238 .24002 L
.71333 .24002 L
.71429 .24002 L
.71524 .24002 L
.71619 .24002 L
.71714 .24002 L
.7181 .24002 L
.71905 .24002 L
.72 .24002 L
.72095 .24002 L
.7219 .24002 L
.72286 .24002 L
.72381 .24002 L
.72476 .24002 L
.72571 .24002 L
.72667 .24002 L
.72762 .24002 L
.72857 .24002 L
.72952 .24002 L
.73048 .24002 L
.73143 .24002 L
.73238 .24002 L
.73333 .24002 L
.73429 .24002 L
.73524 .24002 L
.73619 .24002 L
.73714 .24002 L
Mistroke
.7381 .24002 L
.73905 .24003 L
.74 .24003 L
.74095 .24003 L
.7419 .24003 L
.74286 .24003 L
.74381 .24003 L
.74476 .24003 L
.74571 .24003 L
.74667 .24003 L
.74762 .24003 L
.74857 .24003 L
.74952 .24003 L
.75048 .24003 L
.75143 .24003 L
.75238 .24003 L
.75333 .24003 L
.75429 .24003 L
.75524 .24003 L
.75619 .24003 L
.75714 .24003 L
.7581 .24003 L
.75905 .24003 L
.76 .24003 L
.76095 .24003 L
.7619 .24003 L
.76286 .24003 L
.76381 .24003 L
.76476 .24003 L
.76571 .24003 L
.76667 .24003 L
.76762 .24003 L
.76857 .24003 L
.76952 .24003 L
.77048 .24003 L
.77143 .24003 L
.77238 .24003 L
.77333 .24003 L
.77429 .24003 L
.77524 .24003 L
.77619 .24003 L
.77714 .24003 L
.7781 .24003 L
.77905 .24003 L
.78 .24003 L
.78095 .24003 L
.7819 .24003 L
.78286 .24003 L
.78381 .24003 L
.78476 .24003 L
Mistroke
.78571 .24003 L
.78667 .24003 L
.78762 .24003 L
.78857 .24003 L
.78952 .24003 L
.79048 .24003 L
.79143 .24003 L
.79238 .24003 L
.79333 .24003 L
.79429 .24003 L
.79524 .24003 L
.79619 .24003 L
.79714 .24003 L
.7981 .24003 L
.79905 .24003 L
.8 .24003 L
.80095 .24003 L
.8019 .24003 L
.80286 .24003 L
.80381 .24003 L
.80476 .24003 L
.80571 .24003 L
.80667 .24003 L
.80762 .24003 L
.80857 .24003 L
.80952 .24003 L
.81048 .24003 L
.81143 .24003 L
.81238 .24003 L
.81333 .24003 L
.81429 .24003 L
.81524 .24003 L
.81619 .24003 L
.81714 .24003 L
.8181 .24003 L
.81905 .24003 L
.82 .24003 L
.82095 .24003 L
.8219 .24003 L
.82286 .24003 L
.82381 .24003 L
.82476 .24003 L
.82571 .24003 L
.82667 .24003 L
.82762 .24003 L
.82857 .24003 L
.82952 .24003 L
.83048 .24003 L
.83143 .24003 L
.83238 .24003 L
Mistroke
.83333 .24003 L
.83429 .24003 L
.83524 .24003 L
.83619 .24003 L
.83714 .24003 L
.8381 .24003 L
.83905 .24003 L
.84 .24003 L
.84095 .24003 L
.8419 .24003 L
.84286 .24003 L
.84381 .24003 L
.84476 .24003 L
.84571 .24003 L
.84667 .24003 L
.84762 .24003 L
.84857 .24003 L
.84952 .24003 L
.85048 .24003 L
.85143 .24003 L
.85238 .24003 L
.85333 .24003 L
.85429 .24003 L
.85524 .24003 L
.85619 .24003 L
.85714 .24003 L
.8581 .24003 L
.85905 .24003 L
.86 .24003 L
.86095 .24003 L
.8619 .24003 L
.86286 .24003 L
.86381 .24003 L
.86476 .24003 L
.86571 .24003 L
.86667 .24003 L
.86762 .24003 L
.86857 .24003 L
.86952 .24003 L
.87048 .24003 L
.87143 .24003 L
.87238 .24003 L
.87333 .24003 L
.87429 .24003 L
.87524 .24003 L
.87619 .24003 L
.87714 .24003 L
.8781 .24003 L
.87905 .24003 L
.88 .24003 L
Mistroke
.88095 .24003 L
.8819 .24003 L
.88286 .24003 L
.88381 .24003 L
.88476 .24003 L
.88571 .24003 L
.88667 .24003 L
.88762 .24003 L
.88857 .24003 L
.88952 .24003 L
.89048 .24003 L
.89143 .24003 L
.89238 .24003 L
.89333 .24003 L
.89429 .24003 L
.89524 .24003 L
.89619 .24003 L
.89714 .24003 L
.8981 .24003 L
.89905 .24003 L
.9 .24003 L
.90095 .24003 L
.9019 .24003 L
.90286 .24003 L
.90381 .24003 L
.90476 .24003 L
.90571 .24003 L
.90667 .24003 L
.90762 .24003 L
.90857 .24003 L
.90952 .24003 L
.91048 .24003 L
.91143 .24003 L
.91238 .24003 L
.91333 .24003 L
.91429 .24003 L
.91524 .24003 L
.91619 .24003 L
.91714 .24003 L
.9181 .24003 L
.91905 .24003 L
.92 .24003 L
.92095 .24003 L
.9219 .24003 L
.92286 .24003 L
.92381 .24003 L
.92476 .24003 L
.92571 .24003 L
.92667 .24003 L
.92762 .24003 L
Mistroke
.92857 .24003 L
.92952 .24003 L
.93048 .24003 L
.93143 .24003 L
.93238 .24003 L
.93333 .24003 L
.93429 .24003 L
.93524 .24003 L
.93619 .24003 L
.93714 .24003 L
.9381 .24003 L
.93905 .24003 L
.94 .24003 L
.94095 .24003 L
.9419 .24003 L
.94286 .24003 L
.94381 .24003 L
.94476 .24003 L
.94571 .24003 L
.94667 .24003 L
.94762 .24003 L
.94857 .24003 L
.94952 .24003 L
.95048 .24003 L
.95143 .24003 L
.95238 .24003 L
.95333 .24003 L
.95429 .24003 L
.95524 .24003 L
.95619 .24003 L
.95714 .24003 L
.9581 .24003 L
.95905 .24003 L
.96 .24003 L
.96095 .24003 L
.9619 .24003 L
.96286 .24003 L
.96381 .24003 L
.96476 .24003 L
.96571 .24003 L
.96667 .24003 L
.96762 .24003 L
.96857 .24003 L
.96952 .24003 L
.97048 .24003 L
.97143 .24003 L
.97238 .24003 L
.97333 .24003 L
.97429 .24003 L
.97524 .24003 L
Mistroke
.97619 .24003 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.222879 0.0068084 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .08671 -18 -4.5 ]
[-0.0125 .08671 0 4.5 ]
[-0.0125 .22288 -6 -4.5 ]
[-0.0125 .22288 0 4.5 ]
[-0.0125 .35905 -12 -4.5 ]
[-0.0125 .35905 0 4.5 ]
[-0.0125 .49521 -12 -4.5 ]
[-0.0125 .49521 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .19094 -5 -6 ]
[.97619 .19094 5 6 ]
[.97619 .22526 -5 -6 ]
[.97619 .22526 5 6 ]
[.97619 .41151 -5 -6 ]
[.97619 .41151 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.07238 0 m
.07238 .61803 L
s
.12 0 m
.12 .61803 L
s
.16762 0 m
.16762 .61803 L
s
.21524 0 m
.21524 .61803 L
s
.26286 0 m
.26286 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.3581 0 m
.3581 .61803 L
s
.40571 0 m
.40571 .61803 L
s
.45333 0 m
.45333 .61803 L
s
.50095 0 m
.50095 .61803 L
s
.54857 0 m
.54857 .61803 L
s
.59619 0 m
.59619 .61803 L
s
.64381 0 m
.64381 .61803 L
s
.69143 0 m
.69143 .61803 L
s
.73905 0 m
.73905 .61803 L
s
.78667 0 m
.78667 .61803 L
s
.83429 0 m
.83429 .61803 L
s
.8819 0 m
.8819 .61803 L
s
.92952 0 m
.92952 .61803 L
s
.97714 0 m
.97714 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .08671 m
.00625 .08671 L
s
[(-20)] -0.0125 .08671 1 0 Mshowa
0 .22288 m
.00625 .22288 L
s
[(0)] -0.0125 .22288 1 0 Mshowa
0 .35905 m
.00625 .35905 L
s
[(20)] -0.0125 .35905 1 0 Mshowa
0 .49521 m
.00625 .49521 L
s
[(40)] -0.0125 .49521 1 0 Mshowa
.125 Mabswid
0 .12075 m
.00375 .12075 L
s
0 .15479 m
.00375 .15479 L
s
0 .18884 m
.00375 .18884 L
s
0 .25692 m
.00375 .25692 L
s
0 .29096 m
.00375 .29096 L
s
0 .325 m
.00375 .325 L
s
0 .39309 m
.00375 .39309 L
s
0 .42713 m
.00375 .42713 L
s
0 .46117 m
.00375 .46117 L
s
0 .05267 m
.00375 .05267 L
s
0 .01863 m
.00375 .01863 L
s
0 .52926 m
.00375 .52926 L
s
0 .5633 m
.00375 .5633 L
s
0 .59734 m
.00375 .59734 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .08671 m
1 .08671 L
s
.99375 .22288 m
1 .22288 L
s
.99375 .35905 m
1 .35905 L
s
.99375 .49521 m
1 .49521 L
s
.125 Mabswid
.99625 .12075 m
1 .12075 L
s
.99625 .15479 m
1 .15479 L
s
.99625 .18884 m
1 .18884 L
s
.99625 .25692 m
1 .25692 L
s
.99625 .29096 m
1 .29096 L
s
.99625 .325 m
1 .325 L
s
.99625 .39309 m
1 .39309 L
s
.99625 .42713 m
1 .42713 L
s
.99625 .46117 m
1 .46117 L
s
.99625 .05267 m
1 .05267 L
s
.99625 .01863 m
1 .01863 L
s
.99625 .52926 m
1 .52926 L
s
.99625 .5633 m
1 .5633 L
s
.99625 .59734 m
1 .59734 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .19094 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .22012 m
.02476 .21601 L
.02571 .22023 L
.02667 .22039 L
.02762 .22333 L
.02857 .22259 L
.02952 .21896 L
.03048 .21812 L
.03143 .22074 L
.03238 .21948 L
.03333 .2195 L
.03429 .22299 L
.03524 .22602 L
.03619 .22077 L
.03714 .22041 L
.0381 .22067 L
.03905 .21862 L
.04 .22346 L
.04095 .22304 L
.0419 .21989 L
.04286 .21871 L
.04381 .22003 L
.04476 .21963 L
.04571 .21986 L
.04667 .22155 L
.04762 .22018 L
.04857 .21761 L
.04952 .21249 L
.05048 .21673 L
.05143 .20545 L
.05238 .20015 L
.05333 .2007 L
.05429 .19657 L
.05524 .19429 L
.05619 .1924 L
.05714 .19009 L
.0581 .18563 L
.05905 .18204 L
.06 .17278 L
.06095 .17347 L
.0619 .1612 L
.06286 .15995 L
.06381 .15036 L
.06476 .14258 L
.06571 .12734 L
.06667 .11904 L
.06762 .10813 L
.06857 .09659 L
.06952 .08781 L
.07048 .08371 L
Mistroke
.07143 .07877 L
.07238 .07859 L
.07333 .07174 L
.07429 .07371 L
.07524 .07459 L
.07619 .08103 L
.07714 .08846 L
.0781 .1035 L
.07905 .10993 L
.08 .12646 L
.08095 .14708 L
.0819 .17332 L
.08286 .18644 L
.08381 .19949 L
.08476 .22031 L
.08571 .23185 L
.08667 .24405 L
.08762 .25675 L
.08857 .27218 L
.08952 .2825 L
.09048 .2927 L
.09143 .29588 L
.09238 .29884 L
.09333 .29639 L
.09429 .30686 L
.09524 .31272 L
.09619 .31218 L
.09714 .30086 L
.0981 .29173 L
.09905 .28874 L
.1 .28641 L
.10095 .28475 L
.1019 .28078 L
.10286 .27854 L
.10381 .26733 L
.10476 .26459 L
.10571 .25774 L
.10667 .24653 L
.10762 .2536 L
.10857 .24829 L
.10952 .24106 L
.11048 .24402 L
.11143 .23989 L
.11238 .24049 L
.11333 .24277 L
.11429 .24055 L
.11524 .24139 L
.11619 .23688 L
.11714 .24212 L
.1181 .24132 L
Mistroke
.11905 .24236 L
.12 .24162 L
.12095 .23738 L
.1219 .23955 L
.12286 .24008 L
.12381 .23801 L
.12476 .24024 L
.12571 .23985 L
.12667 .24627 L
.12762 .24215 L
.12857 .23984 L
.12952 .24975 L
.13048 .24998 L
.13143 .25159 L
.13238 .2526 L
.13333 .25753 L
.13429 .25586 L
.13524 .2527 L
.13619 .25519 L
.13714 .25738 L
.1381 .25913 L
.13905 .25267 L
.14 .25947 L
.14095 .26303 L
.1419 .25814 L
.14286 .26827 L
.14381 .26903 L
.14476 .2696 L
.14571 .27229 L
.14667 .27716 L
.14762 .27878 L
.14857 .28598 L
.14952 .2879 L
.15048 .29749 L
.15143 .29433 L
.15238 .29612 L
.15333 .29869 L
.15429 .3017 L
.15524 .30407 L
.15619 .30541 L
.15714 .3092 L
.1581 .31248 L
.15905 .32243 L
.16 .32755 L
.16095 .32989 L
.1619 .32729 L
.16286 .33307 L
.16381 .33841 L
.16476 .33617 L
.16571 .33003 L
Mistroke
.16667 .32985 L
.16762 .31867 L
.16857 .30939 L
.16952 .30088 L
.17048 .29481 L
.17143 .28067 L
.17238 .27214 L
.17333 .26772 L
.17429 .25805 L
.17524 .25144 L
.17619 .24712 L
.17714 .2377 L
.1781 .23487 L
.17905 .22953 L
.18 .21935 L
.18095 .22079 L
.1819 .2183 L
.18286 .2203 L
.18381 .22131 L
.18476 .22008 L
.18571 .21277 L
.18667 .2201 L
.18762 .21507 L
.18857 .21088 L
.18952 .21313 L
.19048 .21489 L
.19143 .20888 L
.19238 .20286 L
.19333 .20967 L
.19429 .21194 L
.19524 .20916 L
.19619 .2098 L
.19714 .20776 L
.1981 .20642 L
.19905 .20651 L
.2 .19835 L
.20095 .20129 L
.2019 .20186 L
.20286 .20839 L
.20381 .20422 L
.20476 .20366 L
.20571 .20328 L
.20667 .19131 L
.20762 .19076 L
.20857 .18957 L
.20952 .18325 L
.21048 .18725 L
.21143 .17712 L
.21238 .17401 L
.21333 .17696 L
Mistroke
.21429 .17724 L
.21524 .17476 L
.21619 .15973 L
.21714 .16535 L
.2181 .16023 L
.21905 .15157 L
.22 .151 L
.22095 .13474 L
.2219 .1328 L
.22286 .12921 L
.22381 .11937 L
.22476 .11428 L
.22571 .11841 L
.22667 .12049 L
.22762 .11753 L
.22857 .11756 L
.22952 .11236 L
.23048 .11523 L
.23143 .11745 L
.23238 .12636 L
.23333 .13069 L
.23429 .13958 L
.23524 .14035 L
.23619 .15665 L
.23714 .15622 L
.2381 .1639 L
.23905 .17494 L
.24 .18386 L
.24095 .19221 L
.2419 .19972 L
.24286 .20802 L
.24381 .21207 L
.24476 .22022 L
.24571 .23095 L
.24667 .23467 L
.24762 .24061 L
.24857 .24315 L
.24952 .2542 L
.25048 .25296 L
.25143 .25777 L
.25238 .26202 L
.25333 .25964 L
.25429 .2608 L
.25524 .25601 L
.25619 .2543 L
.25714 .25989 L
.2581 .26038 L
.25905 .26571 L
.26 .26743 L
.26095 .26411 L
Mistroke
.2619 .26881 L
.26286 .27509 L
.26381 .27568 L
.26476 .26863 L
.26571 .27278 L
.26667 .27336 L
.26762 .27284 L
.26857 .28062 L
.26952 .27842 L
.27048 .27794 L
.27143 .27991 L
.27238 .28228 L
.27333 .29063 L
.27429 .29176 L
.27524 .29128 L
.27619 .29106 L
.27714 .29009 L
.2781 .29215 L
.27905 .29425 L
.28 .29336 L
.28095 .29629 L
.2819 .29258 L
.28286 .2949 L
.28381 .29982 L
.28476 .29811 L
.28571 .29999 L
.28667 .29657 L
.28762 .29736 L
.28857 .29104 L
.28952 .28835 L
.29048 .28987 L
.29143 .28419 L
.29238 .28459 L
.29333 .28801 L
.29429 .28869 L
.29524 .28152 L
.29619 .27693 L
.29714 .27918 L
.2981 .27569 L
.29905 .26733 L
.3 .26343 L
.30095 .26357 L
.3019 .26691 L
.30286 .26116 L
.30381 .25744 L
.30476 .25472 L
.30571 .25181 L
.30667 .25303 L
.30762 .25737 L
.30857 .24856 L
Mistroke
.30952 .25122 L
.31048 .25517 L
.31143 .25316 L
.31238 .24911 L
.31333 .25814 L
.31429 .25406 L
.31524 .25706 L
.31619 .25834 L
.31714 .2576 L
.3181 .2544 L
.31905 .25841 L
.32 .25358 L
.32095 .25172 L
.3219 .25293 L
.32286 .25648 L
.32381 .2551 L
.32476 .25267 L
.32571 .25302 L
.32667 .2538 L
.32762 .25957 L
.32857 .25978 L
.32952 .26139 L
.33048 .2645 L
.33143 .26821 L
.33238 .26583 L
.33333 .26905 L
.33429 .26804 L
.33524 .27317 L
.33619 .27367 L
.33714 .28277 L
.3381 .28267 L
.33905 .28611 L
.34 .29241 L
.34095 .28781 L
.3419 .29385 L
.34286 .296 L
.34381 .29981 L
.34476 .30308 L
.34571 .30482 L
.34667 .30904 L
.34762 .3132 L
.34857 .3151 L
.34952 .31652 L
.35048 .31582 L
.35143 .3136 L
.35238 .3042 L
.35333 .30742 L
.35429 .30531 L
.35524 .303 L
.35619 .30498 L
Mistroke
.35714 .30243 L
.3581 .3061 L
.35905 .30476 L
.36 .29677 L
.36095 .28757 L
.3619 .28517 L
.36286 .27797 L
.36381 .27469 L
.36476 .27438 L
.36571 .26463 L
.36667 .26429 L
.36762 .26567 L
.36857 .25683 L
.36952 .25855 L
.37048 .24473 L
.37143 .24765 L
.37238 .241 L
.37333 .23453 L
.37429 .23213 L
.37524 .2315 L
.37619 .23127 L
.37714 .22555 L
.3781 .22383 L
.37905 .22432 L
.38 .2174 L
.38095 .21682 L
.3819 .21607 L
.38286 .21521 L
.38381 .21091 L
.38476 .20849 L
.38571 .21083 L
.38667 .20802 L
.38762 .21478 L
.38857 .20955 L
.38952 .21246 L
.39048 .21222 L
.39143 .21001 L
.39238 .204 L
.39333 .20947 L
.39429 .20433 L
.39524 .20251 L
.39619 .20337 L
.39714 .21114 L
.3981 .20418 L
.39905 .20587 L
.4 .20184 L
.40095 .20899 L
.4019 .21014 L
.40286 .20128 L
.40381 .20805 L
Mistroke
.40476 .1963 L
.40571 .20306 L
.40667 .19424 L
.40762 .19956 L
.40857 .19703 L
.40952 .19121 L
.41048 .18793 L
.41143 .18397 L
.41238 .18586 L
.41333 .18418 L
.41429 .1857 L
.41524 .18509 L
.41619 .17806 L
.41714 .17507 L
.4181 .16208 L
.41905 .16258 L
.42 .16087 L
.42095 .15696 L
.4219 .1613 L
.42286 .15261 L
.42381 .15341 L
.42476 .14229 L
.42571 .14307 L
.42667 .12648 L
.42762 .12754 L
.42857 .12382 L
.42952 .124 L
.43048 .12006 L
.43143 .1154 L
.43238 .11612 L
.43333 .12101 L
.43429 .11959 L
.43524 .1133 L
.43619 .12383 L
.43714 .12276 L
.4381 .12602 L
.43905 .13827 L
.44 .14287 L
.44095 .15671 L
.4419 .16275 L
.44286 .17337 L
.44381 .18076 L
.44476 .19243 L
.44571 .19628 L
.44667 .2057 L
.44762 .21209 L
.44857 .2208 L
.44952 .22707 L
.45048 .23044 L
.45143 .23674 L
Mistroke
.45238 .2412 L
.45333 .24542 L
.45429 .24376 L
.45524 .25064 L
.45619 .24915 L
.45714 .25515 L
.4581 .25496 L
.45905 .25631 L
.46 .26193 L
.46095 .26233 L
.4619 .26169 L
.46286 .24954 L
.46381 .25816 L
.46476 .25912 L
.46571 .25794 L
.46667 .2625 L
.46762 .26448 L
.46857 .26146 L
.46952 .2607 L
.47048 .25888 L
.47143 .26477 L
.47238 .26562 L
.47333 .2654 L
.47429 .26403 L
.47524 .26703 L
.47619 .26393 L
.47714 .26836 L
.4781 .26501 L
.47905 .26361 L
.48 .26921 L
.48095 .26752 L
.4819 .27297 L
.48286 .27942 L
.48381 .28374 L
.48476 .29179 L
.48571 .29771 L
.48667 .30009 L
.48762 .30157 L
.48857 .30711 L
.48952 .30492 L
.49048 .30764 L
.49143 .31133 L
.49238 .31247 L
.49333 .30944 L
.49429 .31295 L
.49524 .32104 L
.49619 .32812 L
.49714 .3243 L
.4981 .324 L
.49905 .31852 L
Mistroke
.5 .31973 L
.50095 .31789 L
.5019 .31713 L
.50286 .30543 L
.50381 .30013 L
.50476 .29835 L
.50571 .29015 L
.50667 .28384 L
.50762 .27241 L
.50857 .27373 L
.50952 .27014 L
.51048 .26516 L
.51143 .2657 L
.51238 .25538 L
.51333 .25261 L
.51429 .24543 L
.51524 .24691 L
.51619 .24431 L
.51714 .24006 L
.5181 .23743 L
.51905 .24165 L
.52 .23699 L
.52095 .23891 L
.5219 .23658 L
.52286 .23779 L
.52381 .23487 L
.52476 .23922 L
.52571 .23786 L
.52667 .23597 L
.52762 .23031 L
.52857 .22887 L
.52952 .23601 L
.53048 .23242 L
.53143 .23433 L
.53238 .23278 L
.53333 .24012 L
.53429 .23805 L
.53524 .23525 L
.53619 .22921 L
.53714 .23049 L
.5381 .22994 L
.53905 .23555 L
.54 .23067 L
.54095 .24311 L
.5419 .24503 L
.54286 .24036 L
.54381 .24061 L
.54476 .24087 L
.54571 .24434 L
.54667 .2441 L
Mistroke
.54762 .24529 L
.54857 .24819 L
.54952 .25727 L
.55048 .25396 L
.55143 .25997 L
.55238 .25459 L
.55333 .26272 L
.55429 .26105 L
.55524 .26875 L
.55619 .2763 L
.55714 .28511 L
.5581 .2861 L
.55905 .28627 L
.56 .29386 L
.56095 .29266 L
.5619 .30737 L
.56286 .3049 L
.56381 .3117 L
.56476 .31875 L
.56571 .32405 L
.56667 .32163 L
.56762 .32673 L
.56857 .33096 L
.56952 .33344 L
.57048 .32932 L
.57143 .32992 L
.57238 .3325 L
.57333 .33356 L
.57429 .33601 L
.57524 .32981 L
.57619 .32673 L
.57714 .32427 L
.5781 .3213 L
.57905 .31207 L
.58 .29738 L
.58095 .29277 L
.5819 .2812 L
.58286 .27763 L
.58381 .26902 L
.58476 .26159 L
.58571 .25467 L
.58667 .24789 L
.58762 .2365 L
.58857 .23189 L
.58952 .22666 L
.59048 .21978 L
.59143 .22171 L
.59238 .21671 L
.59333 .20879 L
.59429 .20856 L
Mistroke
.59524 .20555 L
.59619 .20098 L
.59714 .20243 L
.5981 .19713 L
.59905 .18987 L
.6 .19024 L
.60095 .18841 L
.6019 .1842 L
.60286 .1849 L
.60381 .17655 L
.60476 .17538 L
.60571 .17091 L
.60667 .16885 L
.60762 .16431 L
.60857 .16043 L
.60952 .16123 L
.61048 .15547 L
.61143 .15924 L
.61238 .15849 L
.61333 .16286 L
.61429 .16533 L
.61524 .16559 L
.61619 .1623 L
.61714 .1547 L
.6181 .15288 L
.61905 .15527 L
.62 .16299 L
.62095 .16495 L
.6219 .1629 L
.62286 .15721 L
.62381 .1579 L
.62476 .16446 L
.62571 .17025 L
.62667 .17404 L
.62762 .18279 L
.62857 .17692 L
.62952 .1803 L
.63048 .18669 L
.63143 .18638 L
.63238 .18613 L
.63333 .19195 L
.63429 .19161 L
.63524 .18636 L
.63619 .19514 L
.63714 .19333 L
.6381 .20337 L
.63905 .19949 L
.64 .20324 L
.64095 .20518 L
.6419 .20271 L
Mistroke
.64286 .19888 L
.64381 .19952 L
.64476 .20242 L
.64571 .19917 L
.64667 .19534 L
.64762 .2007 L
.64857 .19146 L
.64952 .19321 L
.65048 .19784 L
.65143 .19436 L
.65238 .18753 L
.65333 .19812 L
.65429 .19431 L
.65524 .19117 L
.65619 .18427 L
.65714 .17889 L
.6581 .17417 L
.65905 .16847 L
.66 .16717 L
.66095 .16805 L
.6619 .16257 L
.66286 .16754 L
.66381 .16385 L
.66476 .16263 L
.66571 .15877 L
.66667 .15441 L
.66762 .14799 L
.66857 .14507 L
.66952 .1422 L
.67048 .14599 L
.67143 .13785 L
.67238 .13188 L
.67333 .12696 L
.67429 .12782 L
.67524 .13196 L
.67619 .13359 L
.67714 .13576 L
.6781 .13128 L
.67905 .13541 L
.68 .1358 L
.68095 .13914 L
.6819 .14455 L
.68286 .1483 L
.68381 .1502 L
.68476 .14945 L
.68571 .15364 L
.68667 .15953 L
.68762 .16314 L
.68857 .16831 L
.68952 .16834 L
Mistroke
.69048 .18061 L
.69143 .18129 L
.69238 .18445 L
.69333 .18674 L
.69429 .19028 L
.69524 .19176 L
.69619 .19109 L
.69714 .19644 L
.6981 .19494 L
.69905 .197 L
.7 .19848 L
.70095 .20063 L
.7019 .205 L
.70286 .19989 L
.70381 .20348 L
.70476 .21521 L
.70571 .21479 L
.70667 .21253 L
.70762 .2058 L
.70857 .21408 L
.70952 .20946 L
.71048 .21746 L
.71143 .2175 L
.71238 .22275 L
.71333 .21989 L
.71429 .223 L
.71524 .22138 L
.71619 .21922 L
.71714 .21514 L
.7181 .21734 L
.71905 .21477 L
.72 .22052 L
.72095 .21411 L
.7219 .21012 L
.72286 .20244 L
.72381 .20315 L
.72476 .20302 L
.72571 .20275 L
.72667 .19588 L
.72762 .19884 L
.72857 .20109 L
.72952 .19218 L
.73048 .18753 L
.73143 .1895 L
.73238 .18602 L
.73333 .18689 L
.73429 .19087 L
.73524 .17487 L
.73619 .17512 L
.73714 .17083 L
Mistroke
.7381 .16274 L
.73905 .16004 L
.74 .16164 L
.74095 .14949 L
.7419 .1415 L
.74286 .13922 L
.74381 .13214 L
.74476 .12971 L
.74571 .12421 L
.74667 .12247 L
.74762 .11958 L
.74857 .1258 L
.74952 .1215 L
.75048 .12059 L
.75143 .12131 L
.75238 .11831 L
.75333 .12131 L
.75429 .12547 L
.75524 .13641 L
.75619 .13489 L
.75714 .13902 L
.7581 .15241 L
.75905 .15663 L
.76 .16055 L
.76095 .16851 L
.7619 .17864 L
.76286 .18646 L
.76381 .19081 L
.76476 .20385 L
.76571 .20916 L
.76667 .21965 L
.76762 .23185 L
.76857 .23751 L
.76952 .23953 L
.77048 .24746 L
.77143 .24799 L
.77238 .25198 L
.77333 .25759 L
.77429 .25235 L
.77524 .25605 L
.77619 .25632 L
.77714 .26324 L
.7781 .26708 L
.77905 .26385 L
.78 .26923 L
.78095 .27248 L
.7819 .27748 L
.78286 .27777 L
.78381 .28329 L
.78476 .28145 L
Mistroke
.78571 .2791 L
.78667 .27674 L
.78762 .28286 L
.78857 .27606 L
.78952 .27532 L
.79048 .27798 L
.79143 .2786 L
.79238 .28703 L
.79333 .28355 L
.79429 .28578 L
.79524 .28241 L
.79619 .28344 L
.79714 .27963 L
.7981 .28029 L
.79905 .27383 L
.8 .2755 L
.80095 .26776 L
.8019 .27428 L
.80286 .28104 L
.80381 .278 L
.80476 .27826 L
.80571 .26846 L
.80667 .2671 L
.80762 .27042 L
.80857 .27207 L
.80952 .27119 L
.81048 .26692 L
.81143 .26467 L
.81238 .26803 L
.81333 .27179 L
.81429 .27361 L
.81524 .27472 L
.81619 .27071 L
.81714 .27134 L
.8181 .268 L
.81905 .26858 L
.82 .26934 L
.82095 .268 L
.8219 .267 L
.82286 .27454 L
.82381 .27045 L
.82476 .27471 L
.82571 .27692 L
.82667 .27789 L
.82762 .28247 L
.82857 .28178 L
.82952 .2812 L
.83048 .28464 L
.83143 .29964 L
.83238 .30166 L
Mistroke
.83333 .30006 L
.83429 .29941 L
.83524 .29775 L
.83619 .29133 L
.83714 .291 L
.8381 .28874 L
.83905 .2854 L
.84 .28203 L
.84095 .27981 L
.8419 .27813 L
.84286 .27451 L
.84381 .27139 L
.84476 .26868 L
.84571 .27253 L
.84667 .27476 L
.84762 .27311 L
.84857 .27218 L
.84952 .26857 L
.85048 .26408 L
.85143 .26622 L
.85238 .26165 L
.85333 .25862 L
.85429 .25717 L
.85524 .25728 L
.85619 .25938 L
.85714 .2475 L
.8581 .26045 L
.85905 .25359 L
.86 .24543 L
.86095 .24402 L
.8619 .25073 L
.86286 .24272 L
.86381 .24259 L
.86476 .24423 L
.86571 .25162 L
.86667 .24396 L
.86762 .23656 L
.86857 .24459 L
.86952 .24883 L
.87048 .25105 L
.87143 .25286 L
.87238 .25003 L
.87333 .25189 L
.87429 .25689 L
.87524 .25832 L
.87619 .25633 L
.87714 .26197 L
.8781 .25942 L
.87905 .25989 L
.88 .26541 L
Mistroke
.88095 .27151 L
.8819 .27151 L
.88286 .28473 L
.88381 .28078 L
.88476 .28688 L
.88571 .29042 L
.88667 .29195 L
.88762 .29985 L
.88857 .30347 L
.88952 .30945 L
.89048 .31007 L
.89143 .31567 L
.89238 .32096 L
.89333 .31744 L
.89429 .32167 L
.89524 .3245 L
.89619 .33077 L
.89714 .32654 L
.8981 .32987 L
.89905 .33276 L
.9 .32005 L
.90095 .31902 L
.9019 .31808 L
.90286 .31099 L
.90381 .30374 L
.90476 .3019 L
.90571 .29391 L
.90667 .29002 L
.90762 .27806 L
.90857 .26974 L
.90952 .27144 L
.91048 .2624 L
.91143 .25456 L
.91238 .24667 L
.91333 .24158 L
.91429 .23221 L
.91524 .2306 L
.91619 .22772 L
.91714 .22884 L
.9181 .2227 L
.91905 .22203 L
.92 .21979 L
.92095 .21593 L
.9219 .20881 L
.92286 .21143 L
.92381 .20748 L
.92476 .21003 L
.92571 .20435 L
.92667 .20345 L
.92762 .20361 L
Mistroke
.92857 .19981 L
.92952 .1974 L
.93048 .19995 L
.93143 .20044 L
.93238 .20056 L
.93333 .19893 L
.93429 .19445 L
.93524 .1942 L
.93619 .19633 L
.93714 .19273 L
.9381 .18885 L
.93905 .18439 L
.94 .18369 L
.94095 .1801 L
.9419 .17909 L
.94286 .18016 L
.94381 .1787 L
.94476 .17283 L
.94571 .17576 L
.94667 .16258 L
.94762 .16724 L
.94857 .16159 L
.94952 .15876 L
.95048 .14858 L
.95143 .15036 L
.95238 .14109 L
.95333 .13209 L
.95429 .1323 L
.95524 .13015 L
.95619 .12624 L
.95714 .12774 L
.9581 .12101 L
.95905 .1218 L
.96 .12501 L
.96095 .12168 L
.9619 .12192 L
.96286 .12115 L
.96381 .13219 L
.96476 .13027 L
.96571 .13264 L
.96667 .13419 L
.96762 .14272 L
.96857 .14455 L
.96952 .15933 L
.97048 .15958 L
.97143 .166 L
.97238 .1699 L
.97333 .17603 L
.97429 .18427 L
.97524 .18423 L
Mistroke
.97619 .19094 L
Mfstroke
0 .98 .604 r
gsave
.97619 .22526 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22258 m
.02476 .22289 L
.02571 .22124 L
.02667 .22149 L
.02762 .21502 L
.02857 .21569 L
.02952 .21446 L
.03048 .21261 L
.03143 .20971 L
.03238 .21573 L
.03333 .21147 L
.03429 .21283 L
.03524 .21839 L
.03619 .21586 L
.03714 .2134 L
.0381 .21401 L
.03905 .2111 L
.04 .21473 L
.04095 .21229 L
.0419 .21741 L
.04286 .2128 L
.04381 .21272 L
.04476 .21004 L
.04571 .20836 L
.04667 .20691 L
.04762 .20159 L
.04857 .20641 L
.04952 .20784 L
.05048 .20087 L
.05143 .19766 L
.05238 .19029 L
.05333 .18669 L
.05429 .17312 L
.05524 .15957 L
.05619 .1579 L
.05714 .15346 L
.0581 .14545 L
.05905 .13718 L
.06 .12535 L
.06095 .12248 L
.0619 .11794 L
.06286 .10054 L
.06381 .08667 L
.06476 .06438 L
.06571 .05179 L
.06667 .03995 L
.06762 .03364 L
.06857 .01472 L
.06952 .01865 L
.07048 .02467 L
Mistroke
.07143 .03632 L
.07238 .05352 L
.07333 .07582 L
.07429 .11194 L
.07524 .14466 L
.07619 .18581 L
.07714 .2257 L
.0781 .26446 L
.07905 .29844 L
.08 .31932 L
.08095 .33336 L
.0819 .35153 L
.08286 .35199 L
.08381 .35321 L
.08476 .36095 L
.08571 .34958 L
.08667 .3496 L
.08762 .35384 L
.08857 .35309 L
.08952 .34819 L
.09048 .3379 L
.09143 .33774 L
.09238 .32759 L
.09333 .32419 L
.09429 .3162 L
.09524 .30305 L
.09619 .29182 L
.09714 .28307 L
.0981 .2765 L
.09905 .26866 L
.1 .25634 L
.10095 .25707 L
.1019 .24227 L
.10286 .23621 L
.10381 .23287 L
.10476 .23716 L
.10571 .23116 L
.10667 .23556 L
.10762 .23646 L
.10857 .23681 L
.10952 .23086 L
.11048 .22478 L
.11143 .22276 L
.11238 .22363 L
.11333 .21851 L
.11429 .22371 L
.11524 .21961 L
.11619 .22333 L
.11714 .22908 L
.1181 .23678 L
Mistroke
.11905 .23703 L
.12 .24396 L
.12095 .24949 L
.1219 .24873 L
.12286 .24974 L
.12381 .25507 L
.12476 .25282 L
.12571 .24967 L
.12667 .25487 L
.12762 .25701 L
.12857 .26117 L
.12952 .25573 L
.13048 .25687 L
.13143 .26061 L
.13238 .26701 L
.13333 .26617 L
.13429 .26804 L
.13524 .27152 L
.13619 .27403 L
.13714 .27385 L
.1381 .27477 L
.13905 .2806 L
.14 .28396 L
.14095 .2864 L
.1419 .293 L
.14286 .29348 L
.14381 .29265 L
.14476 .29816 L
.14571 .30055 L
.14667 .30824 L
.14762 .31747 L
.14857 .31833 L
.14952 .3207 L
.15048 .32046 L
.15143 .32551 L
.15238 .33051 L
.15333 .3401 L
.15429 .34193 L
.15524 .34582 L
.15619 .3458 L
.15714 .34472 L
.1581 .3486 L
.15905 .34145 L
.16 .34037 L
.16095 .32736 L
.1619 .32184 L
.16286 .31526 L
.16381 .30082 L
.16476 .28715 L
.16571 .27303 L
Mistroke
.16667 .25695 L
.16762 .23823 L
.16857 .23382 L
.16952 .22212 L
.17048 .21412 L
.17143 .20521 L
.17238 .19963 L
.17333 .19903 L
.17429 .1925 L
.17524 .19484 L
.17619 .19642 L
.17714 .2025 L
.1781 .19904 L
.17905 .20014 L
.18 .20009 L
.18095 .20863 L
.1819 .2062 L
.18286 .20627 L
.18381 .19815 L
.18476 .20002 L
.18571 .2022 L
.18667 .19955 L
.18762 .19427 L
.18857 .19133 L
.18952 .18922 L
.19048 .1983 L
.19143 .195 L
.19238 .1936 L
.19333 .18511 L
.19429 .18772 L
.19524 .1873 L
.19619 .1909 L
.19714 .18988 L
.1981 .18586 L
.19905 .18489 L
.2 .18509 L
.20095 .18305 L
.2019 .18209 L
.20286 .18068 L
.20381 .17777 L
.20476 .17579 L
.20571 .17056 L
.20667 .16639 L
.20762 .16478 L
.20857 .153 L
.20952 .14989 L
.21048 .15212 L
.21143 .14834 L
.21238 .13944 L
.21333 .13399 L
Mistroke
.21429 .12508 L
.21524 .12366 L
.21619 .11577 L
.21714 .108 L
.2181 .10193 L
.21905 .09202 L
.22 .08144 L
.22095 .07283 L
.2219 .07307 L
.22286 .07342 L
.22381 .07956 L
.22476 .08408 L
.22571 .09535 L
.22667 .10611 L
.22762 .11692 L
.22857 .12685 L
.22952 .14415 L
.23048 .15899 L
.23143 .17197 L
.23238 .18593 L
.23333 .20639 L
.23429 .22433 L
.23524 .23754 L
.23619 .24426 L
.23714 .2532 L
.2381 .26571 L
.23905 .26486 L
.24 .26867 L
.24095 .27337 L
.2419 .28015 L
.24286 .27773 L
.24381 .27487 L
.24476 .27033 L
.24571 .26826 L
.24667 .27702 L
.24762 .2774 L
.24857 .26973 L
.24952 .27713 L
.25048 .2744 L
.25143 .27056 L
.25238 .27391 L
.25333 .26892 L
.25429 .2742 L
.25524 .27524 L
.25619 .27293 L
.25714 .26883 L
.2581 .27098 L
.25905 .27695 L
.26 .28136 L
.26095 .28082 L
Mistroke
.2619 .27907 L
.26286 .27539 L
.26381 .27567 L
.26476 .27875 L
.26571 .28191 L
.26667 .28526 L
.26762 .28568 L
.26857 .29024 L
.26952 .29486 L
.27048 .29783 L
.27143 .30064 L
.27238 .30463 L
.27333 .30607 L
.27429 .30797 L
.27524 .30314 L
.27619 .30924 L
.27714 .30977 L
.2781 .30686 L
.27905 .30202 L
.28 .30136 L
.28095 .3007 L
.2819 .30191 L
.28286 .30175 L
.28381 .29356 L
.28476 .28809 L
.28571 .28195 L
.28667 .27842 L
.28762 .27341 L
.28857 .26876 L
.28952 .26509 L
.29048 .26798 L
.29143 .27012 L
.29238 .26687 L
.29333 .26499 L
.29429 .26105 L
.29524 .26407 L
.29619 .26344 L
.29714 .26017 L
.2981 .25527 L
.29905 .24819 L
.3 .24758 L
.30095 .24281 L
.3019 .24221 L
.30286 .2426 L
.30381 .2451 L
.30476 .24835 L
.30571 .24975 L
.30667 .24536 L
.30762 .24705 L
.30857 .25543 L
Mistroke
.30952 .25055 L
.31048 .24233 L
.31143 .24543 L
.31238 .24997 L
.31333 .24685 L
.31429 .24977 L
.31524 .25378 L
.31619 .25569 L
.31714 .25578 L
.3181 .26048 L
.31905 .25834 L
.32 .26053 L
.32095 .26383 L
.3219 .25802 L
.32286 .2592 L
.32381 .27289 L
.32476 .27422 L
.32571 .27123 L
.32667 .27494 L
.32762 .27487 L
.32857 .2749 L
.32952 .26998 L
.33048 .27749 L
.33143 .28153 L
.33238 .28561 L
.33333 .27753 L
.33429 .28547 L
.33524 .29606 L
.33619 .29701 L
.33714 .30322 L
.3381 .30822 L
.33905 .31536 L
.34 .31234 L
.34095 .31447 L
.3419 .32707 L
.34286 .32202 L
.34381 .32112 L
.34476 .32731 L
.34571 .32931 L
.34667 .3262 L
.34762 .3268 L
.34857 .32125 L
.34952 .31461 L
.35048 .31018 L
.35143 .30629 L
.35238 .2975 L
.35333 .29775 L
.35429 .29149 L
.35524 .28992 L
.35619 .27849 L
Mistroke
.35714 .27116 L
.3581 .26608 L
.35905 .26378 L
.36 .24954 L
.36095 .24884 L
.3619 .2418 L
.36286 .24492 L
.36381 .2402 L
.36476 .23673 L
.36571 .23567 L
.36667 .23023 L
.36762 .22549 L
.36857 .22751 L
.36952 .22414 L
.37048 .22493 L
.37143 .2228 L
.37238 .2148 L
.37333 .20767 L
.37429 .2148 L
.37524 .21365 L
.37619 .21376 L
.37714 .21264 L
.3781 .22231 L
.37905 .21914 L
.38 .21842 L
.38095 .21543 L
.3819 .21506 L
.38286 .21941 L
.38381 .22085 L
.38476 .21619 L
.38571 .21454 L
.38667 .21139 L
.38762 .21126 L
.38857 .21001 L
.38952 .20734 L
.39048 .20944 L
.39143 .20778 L
.39238 .20378 L
.39333 .20087 L
.39429 .2037 L
.39524 .20456 L
.39619 .19972 L
.39714 .19876 L
.3981 .19517 L
.39905 .1949 L
.4 .19481 L
.40095 .19906 L
.4019 .1983 L
.40286 .19744 L
.40381 .19798 L
Mistroke
.40476 .19015 L
.40571 .18872 L
.40667 .17501 L
.40762 .16895 L
.40857 .16325 L
.40952 .16231 L
.41048 .16377 L
.41143 .15791 L
.41238 .15169 L
.41333 .1448 L
.41429 .13909 L
.41524 .13669 L
.41619 .13519 L
.41714 .13222 L
.4181 .12772 L
.41905 .11643 L
.42 .10857 L
.42095 .10473 L
.4219 .0949 L
.42286 .09333 L
.42381 .08968 L
.42476 .09233 L
.42571 .08098 L
.42667 .08124 L
.42762 .0728 L
.42857 .07921 L
.42952 .0824 L
.43048 .09084 L
.43143 .09793 L
.43238 .10581 L
.43333 .1202 L
.43429 .1302 L
.43524 .14569 L
.43619 .16263 L
.43714 .18115 L
.4381 .18616 L
.43905 .20241 L
.44 .21917 L
.44095 .23139 L
.4419 .24587 L
.44286 .25121 L
.44381 .26219 L
.44476 .26371 L
.44571 .26861 L
.44667 .2708 L
.44762 .27062 L
.44857 .27946 L
.44952 .27445 L
.45048 .27523 L
.45143 .27664 L
Mistroke
.45238 .27011 L
.45333 .26805 L
.45429 .25901 L
.45524 .25836 L
.45619 .25678 L
.45714 .25572 L
.4581 .25611 L
.45905 .25709 L
.46 .25413 L
.46095 .25916 L
.4619 .2559 L
.46286 .25839 L
.46381 .26041 L
.46476 .26255 L
.46571 .25909 L
.46667 .26065 L
.46762 .26585 L
.46857 .26714 L
.46952 .26529 L
.47048 .2652 L
.47143 .26466 L
.47238 .26926 L
.47333 .27232 L
.47429 .27465 L
.47524 .27966 L
.47619 .27337 L
.47714 .27635 L
.4781 .28182 L
.47905 .28996 L
.48 .29292 L
.48095 .29499 L
.4819 .29503 L
.48286 .30759 L
.48381 .306 L
.48476 .31278 L
.48571 .31434 L
.48667 .3149 L
.48762 .3198 L
.48857 .32438 L
.48952 .32875 L
.49048 .32942 L
.49143 .32425 L
.49238 .32906 L
.49333 .33339 L
.49429 .32559 L
.49524 .32542 L
.49619 .31899 L
.49714 .3149 L
.4981 .30363 L
.49905 .28992 L
Mistroke
.5 .27606 L
.50095 .2719 L
.5019 .25311 L
.50286 .25155 L
.50381 .24653 L
.50476 .23136 L
.50571 .23238 L
.50667 .22541 L
.50762 .21313 L
.50857 .2101 L
.50952 .21911 L
.51048 .21552 L
.51143 .21219 L
.51238 .22103 L
.51333 .21826 L
.51429 .22265 L
.51524 .22386 L
.51619 .22389 L
.51714 .22544 L
.5181 .23176 L
.51905 .22536 L
.52 .23617 L
.52095 .23389 L
.5219 .23845 L
.52286 .23732 L
.52381 .24465 L
.52476 .24099 L
.52571 .2377 L
.52667 .24124 L
.52762 .24209 L
.52857 .24099 L
.52952 .24503 L
.53048 .24632 L
.53143 .25173 L
.53238 .24881 L
.53333 .24419 L
.53429 .24505 L
.53524 .24386 L
.53619 .24396 L
.53714 .25233 L
.5381 .25617 L
.53905 .2553 L
.54 .25447 L
.54095 .25475 L
.5419 .26189 L
.54286 .26085 L
.54381 .26789 L
.54476 .27527 L
.54571 .27516 L
.54667 .27456 L
Mistroke
.54762 .27901 L
.54857 .28568 L
.54952 .28397 L
.55048 .29131 L
.55143 .29446 L
.55238 .30089 L
.55333 .296 L
.55429 .30958 L
.55524 .31133 L
.55619 .31231 L
.55714 .31717 L
.5581 .32398 L
.55905 .33511 L
.56 .33604 L
.56095 .34618 L
.5619 .3495 L
.56286 .35966 L
.56381 .36207 L
.56476 .36606 L
.56571 .37241 L
.56667 .36398 L
.56762 .36065 L
.56857 .36144 L
.56952 .3483 L
.57048 .34593 L
.57143 .33529 L
.57238 .32659 L
.57333 .3068 L
.57429 .29388 L
.57524 .28288 L
.57619 .26049 L
.57714 .24604 L
.5781 .23119 L
.57905 .22041 L
.58 .20595 L
.58095 .19451 L
.5819 .18615 L
.58286 .1826 L
.58381 .17966 L
.58476 .18091 L
.58571 .1775 L
.58667 .17744 L
.58762 .18046 L
.58857 .18003 L
.58952 .18206 L
.59048 .18215 L
.59143 .17801 L
.59238 .17743 L
.59333 .17937 L
.59429 .18081 L
Mistroke
.59524 .17621 L
.59619 .179 L
.59714 .17271 L
.5981 .16893 L
.59905 .16488 L
.6 .16444 L
.60095 .15818 L
.6019 .15552 L
.60286 .15331 L
.60381 .15216 L
.60476 .15428 L
.60571 .15751 L
.60667 .1529 L
.60762 .15128 L
.60857 .14866 L
.60952 .1561 L
.61048 .15293 L
.61143 .15498 L
.61238 .14972 L
.61333 .15625 L
.61429 .15664 L
.61524 .15485 L
.61619 .15974 L
.61714 .15684 L
.6181 .16364 L
.61905 .17025 L
.62 .17489 L
.62095 .17317 L
.6219 .17548 L
.62286 .17562 L
.62381 .17979 L
.62476 .18381 L
.62571 .18823 L
.62667 .19367 L
.62762 .19407 L
.62857 .19551 L
.62952 .20317 L
.63048 .20225 L
.63143 .20109 L
.63238 .19588 L
.63333 .19577 L
.63429 .19855 L
.63524 .19805 L
.63619 .19943 L
.63714 .19986 L
.6381 .20295 L
.63905 .19881 L
.64 .20301 L
.64095 .20369 L
.6419 .20285 L
Mistroke
.64286 .19468 L
.64381 .1939 L
.64476 .19384 L
.64571 .20015 L
.64667 .19647 L
.64762 .19219 L
.64857 .19523 L
.64952 .1932 L
.65048 .18333 L
.65143 .18421 L
.65238 .1835 L
.65333 .17518 L
.65429 .17214 L
.65524 .16553 L
.65619 .15517 L
.65714 .15218 L
.6581 .15085 L
.65905 .14951 L
.66 .14943 L
.66095 .15167 L
.6619 .14049 L
.66286 .14096 L
.66381 .13949 L
.66476 .13728 L
.66571 .13618 L
.66667 .13047 L
.66762 .12702 L
.66857 .1199 L
.66952 .11775 L
.67048 .11878 L
.67143 .12592 L
.67238 .12163 L
.67333 .12366 L
.67429 .12596 L
.67524 .12899 L
.67619 .13024 L
.67714 .13928 L
.6781 .14118 L
.67905 .14603 L
.68 .15405 L
.68095 .1623 L
.6819 .17167 L
.68286 .17954 L
.68381 .18633 L
.68476 .18905 L
.68571 .19275 L
.68667 .20067 L
.68762 .2089 L
.68857 .21106 L
.68952 .21426 L
Mistroke
.69048 .21769 L
.69143 .21969 L
.69238 .22456 L
.69333 .23093 L
.69429 .23079 L
.69524 .23224 L
.69619 .2278 L
.69714 .22476 L
.6981 .2216 L
.69905 .22248 L
.7 .21633 L
.70095 .22034 L
.7019 .22 L
.70286 .21678 L
.70381 .21563 L
.70476 .21469 L
.70571 .22002 L
.70667 .21522 L
.70762 .21631 L
.70857 .2143 L
.70952 .21893 L
.71048 .21788 L
.71143 .21407 L
.71238 .21385 L
.71333 .21076 L
.71429 .20786 L
.71524 .20954 L
.71619 .20879 L
.71714 .20876 L
.7181 .20782 L
.71905 .20877 L
.72 .20888 L
.72095 .21133 L
.7219 .21149 L
.72286 .2051 L
.72381 .19931 L
.72476 .197 L
.72571 .19249 L
.72667 .18734 L
.72762 .18515 L
.72857 .18023 L
.72952 .17212 L
.73048 .17106 L
.73143 .15802 L
.73238 .15066 L
.73333 .14818 L
.73429 .13924 L
.73524 .13685 L
.73619 .12955 L
.73714 .11467 L
Mistroke
.7381 .10639 L
.73905 .10438 L
.74 .09589 L
.74095 .09013 L
.7419 .08078 L
.74286 .07143 L
.74381 .07137 L
.74476 .06941 L
.74571 .06282 L
.74667 .06632 L
.74762 .07612 L
.74857 .08097 L
.74952 .08523 L
.75048 .09663 L
.75143 .11157 L
.75238 .12447 L
.75333 .13771 L
.75429 .16549 L
.75524 .18139 L
.75619 .19632 L
.75714 .21338 L
.7581 .22331 L
.75905 .23931 L
.76 .24236 L
.76095 .26023 L
.7619 .26271 L
.76286 .26785 L
.76381 .27698 L
.76476 .27671 L
.76571 .27646 L
.76667 .28249 L
.76762 .2805 L
.76857 .27909 L
.76952 .27734 L
.77048 .28181 L
.77143 .2829 L
.77238 .28008 L
.77333 .28703 L
.77429 .28922 L
.77524 .2825 L
.77619 .29105 L
.77714 .28481 L
.7781 .29458 L
.77905 .29168 L
.78 .29878 L
.78095 .29181 L
.7819 .29133 L
.78286 .29038 L
.78381 .29662 L
.78476 .2936 L
Mistroke
.78571 .29434 L
.78667 .29508 L
.78762 .29451 L
.78857 .29057 L
.78952 .28764 L
.79048 .28437 L
.79143 .27592 L
.79238 .27847 L
.79333 .26981 L
.79429 .27115 L
.79524 .27358 L
.79619 .2714 L
.79714 .27387 L
.7981 .27207 L
.79905 .26532 L
.8 .26706 L
.80095 .26331 L
.8019 .26986 L
.80286 .25926 L
.80381 .2618 L
.80476 .26395 L
.80571 .26318 L
.80667 .26127 L
.80762 .25903 L
.80857 .2595 L
.80952 .26122 L
.81048 .25453 L
.81143 .25725 L
.81238 .26255 L
.81333 .2645 L
.81429 .2667 L
.81524 .27213 L
.81619 .27803 L
.81714 .28424 L
.8181 .28777 L
.81905 .2898 L
.82 .28776 L
.82095 .29844 L
.8219 .30386 L
.82286 .29814 L
.82381 .30053 L
.82476 .31257 L
.82571 .31399 L
.82667 .31732 L
.82762 .31397 L
.82857 .31013 L
.82952 .30801 L
.83048 .30656 L
.83143 .31113 L
.83238 .30523 L
Mistroke
.83333 .30071 L
.83429 .29425 L
.83524 .28996 L
.83619 .2824 L
.83714 .2761 L
.8381 .27789 L
.83905 .27302 L
.84 .27275 L
.84095 .2713 L
.8419 .26522 L
.84286 .26155 L
.84381 .26123 L
.84476 .26648 L
.84571 .26326 L
.84667 .25773 L
.84762 .25237 L
.84857 .25441 L
.84952 .25531 L
.85048 .249 L
.85143 .24562 L
.85238 .24696 L
.85333 .23363 L
.85429 .24119 L
.85524 .24477 L
.85619 .24244 L
.85714 .23967 L
.8581 .242 L
.85905 .23937 L
.86 .24433 L
.86095 .24134 L
.8619 .24236 L
.86286 .24846 L
.86381 .24648 L
.86476 .24628 L
.86571 .24423 L
.86667 .24679 L
.86762 .24808 L
.86857 .25031 L
.86952 .24902 L
.87048 .25657 L
.87143 .25935 L
.87238 .25986 L
.87333 .25891 L
.87429 .26516 L
.87524 .27417 L
.87619 .27614 L
.87714 .28318 L
.8781 .28235 L
.87905 .29137 L
.88 .29816 L
Mistroke
.88095 .30229 L
.8819 .31182 L
.88286 .31168 L
.88381 .32605 L
.88476 .32672 L
.88571 .33355 L
.88667 .34335 L
.88762 .34151 L
.88857 .34438 L
.88952 .34847 L
.89048 .34506 L
.89143 .35439 L
.89238 .35166 L
.89333 .35899 L
.89429 .35383 L
.89524 .34031 L
.89619 .33568 L
.89714 .32444 L
.8981 .31551 L
.89905 .30454 L
.9 .28316 L
.90095 .27018 L
.9019 .2577 L
.90286 .24725 L
.90381 .23447 L
.90476 .226 L
.90571 .21746 L
.90667 .21126 L
.90762 .21121 L
.90857 .20221 L
.90952 .20446 L
.91048 .20072 L
.91143 .20228 L
.91238 .20128 L
.91333 .20311 L
.91429 .20397 L
.91524 .2052 L
.91619 .20401 L
.91714 .19468 L
.9181 .19762 L
.91905 .20285 L
.92 .2021 L
.92095 .21018 L
.9219 .20758 L
.92286 .20722 L
.92381 .19921 L
.92476 .19894 L
.92571 .20713 L
.92667 .20233 L
.92762 .20066 L
Mistroke
.92857 .19388 L
.92952 .19077 L
.93048 .19936 L
.93143 .19193 L
.93238 .18659 L
.93333 .18352 L
.93429 .17911 L
.93524 .17181 L
.93619 .17383 L
.93714 .1708 L
.9381 .16992 L
.93905 .16566 L
.94 .15933 L
.94095 .15572 L
.9419 .15563 L
.94286 .15398 L
.94381 .14973 L
.94476 .1452 L
.94571 .14275 L
.94667 .1337 L
.94762 .12734 L
.94857 .1228 L
.94952 .1192 L
.95048 .10966 L
.95143 .10695 L
.95238 .10511 L
.95333 .10115 L
.95429 .09806 L
.95524 .09679 L
.95619 .09415 L
.95714 .10166 L
.9581 .10795 L
.95905 .11443 L
.96 .1272 L
.96095 .13157 L
.9619 .14332 L
.96286 .15063 L
.96381 .15441 L
.96476 .16459 L
.96571 .18161 L
.96667 .18223 L
.96762 .19714 L
.96857 .20339 L
.96952 .20448 L
.97048 .2113 L
.97143 .21791 L
.97238 .21884 L
.97333 .22152 L
.97429 .22364 L
.97524 .22415 L
Mistroke
.97619 .22526 L
Mfstroke
1 0 0 r
gsave
.97619 .41151 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22409 m
.02476 .22187 L
.02571 .22279 L
.02667 .22365 L
.02762 .22346 L
.02857 .22425 L
.02952 .22482 L
.03048 .22684 L
.03143 .22395 L
.03238 .21914 L
.03333 .2244 L
.03429 .21693 L
.03524 .22502 L
.03619 .22181 L
.03714 .21896 L
.0381 .21773 L
.03905 .22093 L
.04 .22198 L
.04095 .2255 L
.0419 .22465 L
.04286 .2285 L
.04381 .22048 L
.04476 .21907 L
.04571 .22316 L
.04667 .21917 L
.04762 .22388 L
.04857 .22175 L
.04952 .22108 L
.05048 .22094 L
.05143 .22407 L
.05238 .22095 L
.05333 .2228 L
.05429 .22624 L
.05524 .2318 L
.05619 .23234 L
.05714 .22835 L
.0581 .23244 L
.05905 .2427 L
.06 .24912 L
.06095 .25219 L
.0619 .2528 L
.06286 .25925 L
.06381 .26697 L
.06476 .2872 L
.06571 .30905 L
.06667 .32614 L
.06762 .34765 L
.06857 .37664 L
.06952 .41856 L
.07048 .45388 L
Mistroke
.07143 .49335 L
.07238 .52715 L
.07333 .55278 L
.07429 .5793 L
.07524 .59109 L
.07619 .60332 L
.07714 .59963 L
.0781 .58195 L
.07905 .57052 L
.08 .54554 L
.08095 .52988 L
.0819 .50532 L
.08286 .4859 L
.08381 .4742 L
.08476 .45925 L
.08571 .456 L
.08667 .44683 L
.08762 .44819 L
.08857 .4532 L
.08952 .45326 L
.09048 .45852 L
.09143 .46322 L
.09238 .46748 L
.09333 .47399 L
.09429 .47921 L
.09524 .48322 L
.09619 .49212 L
.09714 .48912 L
.0981 .49279 L
.09905 .48817 L
.1 .488 L
.10095 .48699 L
.1019 .48078 L
.10286 .47183 L
.10381 .46527 L
.10476 .45687 L
.10571 .45473 L
.10667 .45322 L
.10762 .44333 L
.10857 .43837 L
.10952 .42302 L
.11048 .42664 L
.11143 .41958 L
.11238 .41331 L
.11333 .41145 L
.11429 .39547 L
.11524 .3953 L
.11619 .38602 L
.11714 .38305 L
.1181 .38603 L
Mistroke
.11905 .37567 L
.12 .37234 L
.12095 .37603 L
.1219 .37036 L
.12286 .36772 L
.12381 .36334 L
.12476 .36267 L
.12571 .36272 L
.12667 .36253 L
.12762 .36117 L
.12857 .35372 L
.12952 .35534 L
.13048 .35658 L
.13143 .35187 L
.13238 .3497 L
.13333 .3473 L
.13429 .34595 L
.13524 .34235 L
.13619 .33961 L
.13714 .34217 L
.1381 .34597 L
.13905 .34255 L
.14 .3414 L
.14095 .34916 L
.1419 .34433 L
.14286 .34929 L
.14381 .34855 L
.14476 .34837 L
.14571 .34976 L
.14667 .34979 L
.14762 .35007 L
.14857 .34746 L
.14952 .35225 L
.15048 .36239 L
.15143 .3688 L
.15238 .36979 L
.15333 .3775 L
.15429 .38518 L
.15524 .39886 L
.15619 .40964 L
.15714 .41873 L
.1581 .43192 L
.15905 .43969 L
.16 .45783 L
.16095 .4631 L
.1619 .46867 L
.16286 .488 L
.16381 .487 L
.16476 .48473 L
.16571 .49202 L
Mistroke
.16667 .48867 L
.16762 .48886 L
.16857 .486 L
.16952 .47767 L
.17048 .47391 L
.17143 .4681 L
.17238 .46137 L
.17333 .44935 L
.17429 .4398 L
.17524 .43127 L
.17619 .42441 L
.17714 .41624 L
.1781 .4149 L
.17905 .40458 L
.18 .40548 L
.18095 .40617 L
.1819 .3878 L
.18286 .39076 L
.18381 .38292 L
.18476 .37635 L
.18571 .3728 L
.18667 .36631 L
.18762 .3607 L
.18857 .35794 L
.18952 .35198 L
.19048 .3476 L
.19143 .34816 L
.19238 .34222 L
.19333 .34224 L
.19429 .334 L
.19524 .33148 L
.19619 .32069 L
.19714 .32482 L
.1981 .32023 L
.19905 .32301 L
.2 .32046 L
.20095 .32555 L
.2019 .32157 L
.20286 .32139 L
.20381 .32075 L
.20476 .31632 L
.20571 .32172 L
.20667 .31935 L
.20762 .32025 L
.20857 .32048 L
.20952 .32286 L
.21048 .3245 L
.21143 .3242 L
.21238 .32937 L
.21333 .3369 L
Mistroke
.21429 .33784 L
.21524 .34088 L
.21619 .34283 L
.21714 .34418 L
.2181 .353 L
.21905 .3566 L
.22 .3667 L
.22095 .37534 L
.2219 .39665 L
.22286 .42003 L
.22381 .43682 L
.22476 .44947 L
.22571 .4698 L
.22667 .47794 L
.22762 .49057 L
.22857 .50053 L
.22952 .50852 L
.23048 .51706 L
.23143 .51766 L
.23238 .52211 L
.23333 .51614 L
.23429 .51203 L
.23524 .50222 L
.23619 .49603 L
.23714 .48715 L
.2381 .48135 L
.23905 .47449 L
.24 .4634 L
.24095 .45006 L
.2419 .44058 L
.24286 .43506 L
.24381 .43932 L
.24476 .42235 L
.24571 .41718 L
.24667 .41888 L
.24762 .40863 L
.24857 .40333 L
.24952 .39658 L
.25048 .39991 L
.25143 .3936 L
.25238 .38895 L
.25333 .38983 L
.25429 .39435 L
.25524 .3962 L
.25619 .38987 L
.25714 .38222 L
.2581 .38689 L
.25905 .38202 L
.26 .38569 L
.26095 .38364 L
Mistroke
.2619 .37926 L
.26286 .38068 L
.26381 .36879 L
.26476 .37301 L
.26571 .36751 L
.26667 .36768 L
.26762 .36626 L
.26857 .37232 L
.26952 .37335 L
.27048 .37764 L
.27143 .38251 L
.27238 .38426 L
.27333 .38617 L
.27429 .39349 L
.27524 .39528 L
.27619 .39873 L
.27714 .40559 L
.2781 .40946 L
.27905 .41205 L
.28 .41831 L
.28095 .42125 L
.2819 .42295 L
.28286 .42662 L
.28381 .42885 L
.28476 .43244 L
.28571 .43283 L
.28667 .4342 L
.28762 .43638 L
.28857 .43898 L
.28952 .44027 L
.29048 .4394 L
.29143 .44514 L
.29238 .4444 L
.29333 .43787 L
.29429 .4332 L
.29524 .43423 L
.29619 .42779 L
.29714 .42824 L
.2981 .42565 L
.29905 .42144 L
.3 .42304 L
.30095 .41782 L
.3019 .41991 L
.30286 .41382 L
.30381 .40765 L
.30476 .40209 L
.30571 .39794 L
.30667 .39052 L
.30762 .38879 L
.30857 .38218 L
Mistroke
.30952 .38392 L
.31048 .38222 L
.31143 .38187 L
.31238 .38375 L
.31333 .3789 L
.31429 .37858 L
.31524 .37739 L
.31619 .37736 L
.31714 .37878 L
.3181 .37882 L
.31905 .37507 L
.32 .38102 L
.32095 .37717 L
.3219 .37556 L
.32286 .37256 L
.32381 .3749 L
.32476 .36978 L
.32571 .36745 L
.32667 .36884 L
.32762 .36854 L
.32857 .36364 L
.32952 .36776 L
.33048 .36754 L
.33143 .36106 L
.33238 .3613 L
.33333 .36468 L
.33429 .36402 L
.33524 .3619 L
.33619 .36 L
.33714 .36399 L
.3381 .3682 L
.33905 .37344 L
.34 .38284 L
.34095 .38777 L
.3419 .38582 L
.34286 .39145 L
.34381 .39797 L
.34476 .40518 L
.34571 .4096 L
.34667 .42369 L
.34762 .42632 L
.34857 .43535 L
.34952 .44906 L
.35048 .45331 L
.35143 .45282 L
.35238 .45747 L
.35333 .45819 L
.35429 .46174 L
.35524 .46259 L
.35619 .46713 L
Mistroke
.35714 .46578 L
.3581 .46692 L
.35905 .46865 L
.36 .46388 L
.36095 .46515 L
.3619 .45823 L
.36286 .45308 L
.36381 .45134 L
.36476 .444 L
.36571 .44233 L
.36667 .43575 L
.36762 .43376 L
.36857 .43019 L
.36952 .4211 L
.37048 .41704 L
.37143 .41632 L
.37238 .40631 L
.37333 .40021 L
.37429 .39399 L
.37524 .39555 L
.37619 .38651 L
.37714 .38542 L
.3781 .37685 L
.37905 .37425 L
.38 .3757 L
.38095 .36737 L
.3819 .36031 L
.38286 .35549 L
.38381 .3507 L
.38476 .34698 L
.38571 .34489 L
.38667 .34455 L
.38762 .34104 L
.38857 .33901 L
.38952 .337 L
.39048 .33412 L
.39143 .33255 L
.39238 .32796 L
.39333 .32558 L
.39429 .3226 L
.39524 .32072 L
.39619 .32241 L
.39714 .31875 L
.3981 .31331 L
.39905 .31527 L
.4 .31109 L
.40095 .31389 L
.4019 .31244 L
.40286 .30691 L
.40381 .30768 L
Mistroke
.40476 .30233 L
.40571 .30003 L
.40667 .3093 L
.40762 .30086 L
.40857 .30181 L
.40952 .30129 L
.41048 .30066 L
.41143 .30937 L
.41238 .31415 L
.41333 .31227 L
.41429 .31513 L
.41524 .31304 L
.41619 .31309 L
.41714 .31742 L
.4181 .32056 L
.41905 .32783 L
.42 .32674 L
.42095 .33477 L
.4219 .34542 L
.42286 .35502 L
.42381 .36448 L
.42476 .36944 L
.42571 .38128 L
.42667 .39299 L
.42762 .41416 L
.42857 .431 L
.42952 .45293 L
.43048 .46127 L
.43143 .47439 L
.43238 .49072 L
.43333 .50094 L
.43429 .50966 L
.43524 .52211 L
.43619 .52738 L
.43714 .52776 L
.4381 .5253 L
.43905 .52785 L
.44 .52465 L
.44095 .51266 L
.4419 .50648 L
.44286 .50281 L
.44381 .4896 L
.44476 .48768 L
.44571 .47395 L
.44667 .46299 L
.44762 .45642 L
.44857 .45092 L
.44952 .44402 L
.45048 .44571 L
.45143 .43679 L
Mistroke
.45238 .42727 L
.45333 .42835 L
.45429 .41231 L
.45524 .41259 L
.45619 .40888 L
.45714 .40274 L
.4581 .39773 L
.45905 .39703 L
.46 .39417 L
.46095 .39254 L
.4619 .39138 L
.46286 .39102 L
.46381 .39367 L
.46476 .38327 L
.46571 .38107 L
.46667 .37741 L
.46762 .36717 L
.46857 .36724 L
.46952 .36264 L
.47048 .36665 L
.47143 .35996 L
.47238 .35656 L
.47333 .35022 L
.47429 .34613 L
.47524 .35136 L
.47619 .35289 L
.47714 .35119 L
.4781 .35306 L
.47905 .35648 L
.48 .34838 L
.48095 .35232 L
.4819 .35439 L
.48286 .35822 L
.48381 .36064 L
.48476 .3617 L
.48571 .36824 L
.48667 .37498 L
.48762 .37998 L
.48857 .3855 L
.48952 .39196 L
.49048 .39919 L
.49143 .41081 L
.49238 .41448 L
.49333 .42562 L
.49429 .43086 L
.49524 .44214 L
.49619 .45406 L
.49714 .46254 L
.4981 .46643 L
.49905 .47203 L
Mistroke
.5 .47928 L
.50095 .48216 L
.5019 .47935 L
.50286 .48159 L
.50381 .47725 L
.50476 .47601 L
.50571 .46212 L
.50667 .45939 L
.50762 .45645 L
.50857 .44101 L
.50952 .44339 L
.51048 .43122 L
.51143 .42959 L
.51238 .41498 L
.51333 .40746 L
.51429 .40613 L
.51524 .40101 L
.51619 .39264 L
.51714 .39238 L
.5181 .38716 L
.51905 .3879 L
.52 .38312 L
.52095 .37997 L
.5219 .38241 L
.52286 .38181 L
.52381 .37856 L
.52476 .36978 L
.52571 .36926 L
.52667 .36074 L
.52762 .35946 L
.52857 .35253 L
.52952 .35027 L
.53048 .33991 L
.53143 .3391 L
.53238 .34055 L
.53333 .33702 L
.53429 .33599 L
.53524 .32855 L
.53619 .32564 L
.53714 .31893 L
.5381 .31605 L
.53905 .3109 L
.54 .3092 L
.54095 .30424 L
.5419 .31033 L
.54286 .30334 L
.54381 .30183 L
.54476 .3112 L
.54571 .31227 L
.54667 .30827 L
Mistroke
.54762 .30983 L
.54857 .30243 L
.54952 .29535 L
.55048 .30025 L
.55143 .30284 L
.55238 .30775 L
.55333 .30928 L
.55429 .30648 L
.55524 .31354 L
.55619 .31771 L
.55714 .32011 L
.5581 .32653 L
.55905 .32826 L
.56 .33525 L
.56095 .34192 L
.5619 .36325 L
.56286 .38031 L
.56381 .38861 L
.56476 .40269 L
.56571 .40907 L
.56667 .42465 L
.56762 .4403 L
.56857 .4543 L
.56952 .46877 L
.57048 .48373 L
.57143 .5004 L
.57238 .50229 L
.57333 .51261 L
.57429 .51838 L
.57524 .51982 L
.57619 .52363 L
.57714 .52294 L
.5781 .51864 L
.57905 .51601 L
.58 .51074 L
.58095 .49378 L
.5819 .48711 L
.58286 .46911 L
.58381 .46173 L
.58476 .45335 L
.58571 .44661 L
.58667 .44118 L
.58762 .43545 L
.58857 .42625 L
.58952 .41886 L
.59048 .41138 L
.59143 .40118 L
.59238 .3998 L
.59333 .39743 L
.59429 .40142 L
Mistroke
.59524 .39111 L
.59619 .38725 L
.59714 .39021 L
.5981 .3888 L
.59905 .38694 L
.6 .38007 L
.60095 .38047 L
.6019 .38724 L
.60286 .39042 L
.60381 .37963 L
.60476 .38001 L
.60571 .38183 L
.60667 .38541 L
.60762 .38703 L
.60857 .39607 L
.60952 .39614 L
.61048 .40202 L
.61143 .40388 L
.61238 .41017 L
.61333 .41117 L
.61429 .41781 L
.61524 .42168 L
.61619 .42432 L
.61714 .427 L
.6181 .42484 L
.61905 .43296 L
.62 .43543 L
.62095 .43189 L
.6219 .43812 L
.62286 .4382 L
.62381 .43344 L
.62476 .4399 L
.62571 .43387 L
.62667 .43095 L
.62762 .43313 L
.62857 .42888 L
.62952 .42223 L
.63048 .42599 L
.63143 .41916 L
.63238 .4118 L
.63333 .40622 L
.63429 .40153 L
.63524 .39834 L
.63619 .40028 L
.63714 .39775 L
.6381 .39334 L
.63905 .39105 L
.64 .3869 L
.64095 .37811 L
.6419 .377 L
Mistroke
.64286 .37675 L
.64381 .37015 L
.64476 .36168 L
.64571 .3629 L
.64667 .36413 L
.64762 .35888 L
.64857 .35629 L
.64952 .35339 L
.65048 .34463 L
.65143 .33986 L
.65238 .34043 L
.65333 .33809 L
.65429 .33654 L
.65524 .33637 L
.65619 .33543 L
.65714 .33775 L
.6581 .33962 L
.65905 .34335 L
.66 .3383 L
.66095 .34771 L
.6619 .35187 L
.66286 .35907 L
.66381 .3626 L
.66476 .36491 L
.66571 .37363 L
.66667 .37589 L
.66762 .38212 L
.66857 .38486 L
.66952 .39831 L
.67048 .39874 L
.67143 .40775 L
.67238 .41506 L
.67333 .42174 L
.67429 .42831 L
.67524 .43702 L
.67619 .44527 L
.67714 .44586 L
.6781 .44919 L
.67905 .45785 L
.68 .45844 L
.68095 .46636 L
.6819 .47069 L
.68286 .46775 L
.68381 .46298 L
.68476 .46312 L
.68571 .4581 L
.68667 .45678 L
.68762 .45953 L
.68857 .45767 L
.68952 .44837 L
Mistroke
.69048 .44636 L
.69143 .43311 L
.69238 .4317 L
.69333 .42899 L
.69429 .42331 L
.69524 .41977 L
.69619 .41542 L
.69714 .40615 L
.6981 .39502 L
.69905 .39278 L
.7 .3871 L
.70095 .38349 L
.7019 .38155 L
.70286 .37496 L
.70381 .37348 L
.70476 .37585 L
.70571 .36427 L
.70667 .35519 L
.70762 .35585 L
.70857 .34842 L
.70952 .3429 L
.71048 .33794 L
.71143 .3325 L
.71238 .32047 L
.71333 .32161 L
.71429 .32561 L
.71524 .32188 L
.71619 .31747 L
.71714 .31636 L
.7181 .31636 L
.71905 .3121 L
.72 .31127 L
.72095 .31236 L
.7219 .30733 L
.72286 .29874 L
.72381 .29317 L
.72476 .28992 L
.72571 .28734 L
.72667 .28375 L
.72762 .2828 L
.72857 .28208 L
.72952 .28596 L
.73048 .29046 L
.73143 .29522 L
.73238 .29459 L
.73333 .29909 L
.73429 .29656 L
.73524 .3031 L
.73619 .3038 L
.73714 .31291 L
Mistroke
.7381 .31727 L
.73905 .33013 L
.74 .34005 L
.74095 .34452 L
.7419 .35404 L
.74286 .36405 L
.74381 .38019 L
.74476 .38538 L
.74571 .41417 L
.74667 .43667 L
.74762 .45206 L
.74857 .46681 L
.74952 .48657 L
.75048 .50214 L
.75143 .51815 L
.75238 .52827 L
.75333 .53584 L
.75429 .54048 L
.75524 .53943 L
.75619 .53152 L
.75714 .53013 L
.7581 .52277 L
.75905 .51184 L
.76 .5116 L
.76095 .49973 L
.7619 .49193 L
.76286 .47853 L
.76381 .47142 L
.76476 .46302 L
.76571 .45107 L
.76667 .43391 L
.76762 .43242 L
.76857 .42211 L
.76952 .41823 L
.77048 .4208 L
.77143 .41319 L
.77238 .41406 L
.77333 .41126 L
.77429 .40715 L
.77524 .40321 L
.77619 .40023 L
.77714 .40008 L
.7781 .39953 L
.77905 .39722 L
.78 .40279 L
.78095 .40483 L
.7819 .40409 L
.78286 .40648 L
.78381 .40309 L
.78476 .40632 L
Mistroke
.78571 .41126 L
.78667 .41667 L
.78762 .41299 L
.78857 .42008 L
.78952 .41189 L
.79048 .41492 L
.79143 .41895 L
.79238 .4197 L
.79333 .42033 L
.79429 .41636 L
.79524 .41089 L
.79619 .40684 L
.79714 .4131 L
.7981 .40632 L
.79905 .4026 L
.8 .39953 L
.80095 .39873 L
.8019 .39563 L
.80286 .39565 L
.80381 .39701 L
.80476 .39695 L
.80571 .39987 L
.80667 .39172 L
.80762 .39174 L
.80857 .38815 L
.80952 .39422 L
.81048 .3963 L
.81143 .39235 L
.81238 .38722 L
.81333 .3843 L
.81429 .38487 L
.81524 .3865 L
.81619 .38211 L
.81714 .38412 L
.8181 .38585 L
.81905 .37923 L
.82 .38253 L
.82095 .38755 L
.8219 .38559 L
.82286 .39323 L
.82381 .40047 L
.82476 .39842 L
.82571 .40479 L
.82667 .40046 L
.82762 .40391 L
.82857 .40195 L
.82952 .40851 L
.83048 .41477 L
.83143 .41718 L
.83238 .42786 L
Mistroke
.83333 .43025 L
.83429 .43609 L
.83524 .44193 L
.83619 .44406 L
.83714 .44598 L
.8381 .44483 L
.83905 .43842 L
.84 .43567 L
.84095 .43075 L
.8419 .43866 L
.84286 .43856 L
.84381 .44207 L
.84476 .43105 L
.84571 .42892 L
.84667 .42466 L
.84762 .42009 L
.84857 .42105 L
.84952 .40963 L
.85048 .41128 L
.85143 .41216 L
.85238 .41258 L
.85333 .40248 L
.85429 .40524 L
.85524 .39975 L
.85619 .3912 L
.85714 .39086 L
.8581 .38797 L
.85905 .3867 L
.86 .38269 L
.86095 .3813 L
.8619 .37481 L
.86286 .37083 L
.86381 .37354 L
.86476 .36683 L
.86571 .36287 L
.86667 .36489 L
.86762 .3616 L
.86857 .355 L
.86952 .35164 L
.87048 .34902 L
.87143 .34495 L
.87238 .34154 L
.87333 .34054 L
.87429 .34409 L
.87524 .33634 L
.87619 .33316 L
.87714 .33182 L
.8781 .32876 L
.87905 .32674 L
.88 .32706 L
Mistroke
.88095 .32628 L
.8819 .33464 L
.88286 .33819 L
.88381 .34478 L
.88476 .35102 L
.88571 .3567 L
.88667 .36311 L
.88762 .37389 L
.88857 .37037 L
.88952 .38563 L
.89048 .39466 L
.89143 .40543 L
.89238 .41835 L
.89333 .43363 L
.89429 .44378 L
.89524 .45235 L
.89619 .46263 L
.89714 .47003 L
.8981 .4804 L
.89905 .48849 L
.9 .48832 L
.90095 .49226 L
.9019 .48908 L
.90286 .48213 L
.90381 .48264 L
.90476 .4819 L
.90571 .47333 L
.90667 .46787 L
.90762 .45114 L
.90857 .44677 L
.90952 .43827 L
.91048 .43399 L
.91143 .43407 L
.91238 .42179 L
.91333 .41652 L
.91429 .413 L
.91524 .40455 L
.91619 .39875 L
.91714 .40556 L
.9181 .39146 L
.91905 .39245 L
.92 .39006 L
.92095 .38225 L
.9219 .37866 L
.92286 .37331 L
.92381 .36816 L
.92476 .37049 L
.92571 .36454 L
.92667 .36039 L
.92762 .35616 L
Mistroke
.92857 .35901 L
.92952 .3547 L
.93048 .34558 L
.93143 .33935 L
.93238 .33999 L
.93333 .33462 L
.93429 .34094 L
.93524 .33647 L
.93619 .34219 L
.93714 .34211 L
.9381 .33756 L
.93905 .33466 L
.94 .34416 L
.94095 .33653 L
.9419 .33842 L
.94286 .34487 L
.94381 .34124 L
.94476 .34495 L
.94571 .34645 L
.94667 .35007 L
.94762 .34892 L
.94857 .35992 L
.94952 .36142 L
.95048 .36403 L
.95143 .37493 L
.95238 .38722 L
.95333 .39303 L
.95429 .40066 L
.95524 .41284 L
.95619 .42151 L
.95714 .43568 L
.9581 .44317 L
.95905 .45228 L
.96 .45604 L
.96095 .46241 L
.9619 .4697 L
.96286 .47771 L
.96381 .48137 L
.96476 .48279 L
.96571 .48005 L
.96667 .47913 L
.96762 .47323 L
.96857 .46892 L
.96952 .45806 L
.97048 .45294 L
.97143 .44403 L
.97238 .43999 L
.97333 .43324 L
.97429 .42507 L
.97524 .41836 L
Mistroke
.97619 .41151 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{825.188, 255},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000<i0000ob000`400?l00000o`00003ooooooooo
oooooooooooo??ooool00?oooooooooooooooooooccooooo003ooooooooooooooooooollooooo`00
oooooooooooooooooooo??ooool00?oooooooooooooooooooccooooo003oooooooooooooooooooll
ooooo`00oooooooooooooooooooo??ooool00?oooooooooooooooooooccooooo003ooooooooooooo
oooooollooooo`00<_ooool2o`0003cooooo1Ol00003ooooo`;o00001?ooool2o`0003Sooooo0ol0
0003ooooo`;o00001?ooool2o`0003Kooooo0ol00004ooooo`;o00001?ooool2o`0003Oooooo0ol0
0004ooooo`;o00001?ooool2o`0003Cooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0
000Pooooo`;o0000>oooool5o`0000?ooooo0_l00004ooooo`;o0000>?ooool3o`0000?ooooo0_l0
0004ooooo`;o0000=oooool3o`0000Cooooo0_l00004ooooo`;o0000=_ooool3o`0000Cooooo0_l0
0004ooooo`;o0000=?ooool3o`0000Cooooo0_l00004ooooo`;o00001?ooool2o`0001Sooooo000a
ooooo`04o`000?ooooooooooo`0003cooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0003Sooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0<_ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000eoooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0003Cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007_ooool01?l0003oooooooooool0
000kooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000hooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo03?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001Oooooo000aooooo`04o`000?ooooooooooo`0003gooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Gooooo
1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000eooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0003Cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007_ooool01?l0003o
ooooooooool0000looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000eooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0003Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo0000=?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001Oooooo000aooooo`04o`000?ooooooooooo`0003kooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0<oooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
=?ooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000foooo
o`?o00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Cooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00007_ooool01?l0003oooooooooool0000mooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo03?ooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0003Gooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
=Oooool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000doooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001Oooooo000aooooo`04o`000?ooooooooooo`0003_ooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo0000=_ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo0000=?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo0000=Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001kooooo00Co0000oooooooooooo0000>_ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000fooooo`03o`000?oooooo0000
00?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000eooooo`03o`000?oo
oooooooo00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0003Cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005oooool0037ooooo00Co0000oooooooo
oooo0000>oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000gooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0003Gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000<oooool2o`0000Cooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001kooooo
00Co0000oooooooooooo0000>_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000gooooo`;o00000oooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0003Kooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0003Cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000<oooool2o`0000Co
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001Oooooo000booooo`;o0000?Oooool3o`0000Cooooo0_l00004ooooo`;o0000>Oooool0
0ol0003oooooooooo`02ooooo`;o00001?ooool2o`0003Oooooo0_l00004ooooo`;o00001?ooool2
o`0003Oooooo0ol00004ooooo`;o00001?ooool2o`0003Gooooo00?o0000ooooooooool00oooool2
o`0000Cooooo0_l00004ooooo`;o00008?ooool2o`0003cooooo0ol00004ooooo`;o00001?ooool2
o`0003Wooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000hooooo`;o00001?ooool2
o`0000Cooooo0_l0000fooooo`?o00001?ooool2o`0000Cooooo0_l0000eooooo`03o`000?oooooo
oooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0001Sooooo003ooooooooooooooooooolloooo
o`00oooooooooooooooooooo??ooool00?oooooooooooooooooooccooooo003ooooooooooooooooo
oollooooo`00oooooooooooooooooooo??ooool002_oooooool0001_o`0001Woooooool0001`o`00
01Sooooo000[ooooo`03o`000?oooooooooo00Gooooo00?o0000o`00Ooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
001oooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
001oooooo`0?ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
001oooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Gooooo
00?o0000o`00Ooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003o001oooooo`0?ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo
00?o0000o`00Ooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003o001oooooo`0?ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00kooooo
00?o0000o`00Ooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo
00?o0000o`00Ooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003o001oooooo`0?ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo
00?o0000o`00Ooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01Kooooo
000[ooooo`03o`000?oooooooooo00Gooooo00?o0000o`00Ooooool03oooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0003ooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`000?oooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0003ooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0003ooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`000?oooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[oooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06oooo
o`03o`000?oooooooooo01Kooooo000[ooooo`;o00001oooool00ol007ooooooooooo`0=ooooo`03
o`3jV_l007oooooo013ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool2o`0001Wooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`3jV_oooooo001o013ooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00gooooo0_l0nYXAooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool0
5oooool3o`0000Kooooo00?o001oooooooooool03Oooool2o`3jVP03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool01?ooool3o`0001Sooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03?ooool00ol0nY[oooooo`3jVP0Aooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo0_l0
nYX00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_oo
ool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0<ooooo`03o`3jV_oooooo
0?ZJ017ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool03Oooool2o`3jVP03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00cooooo00?o0?ZJooooool0nYX04Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05oooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`;o0?ZJ00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo
01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool00ol0nY[o
ooooo`3jVP0Aooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo0_l0nYX00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ017ooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
3Oooool2o`3jVP03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooo
ooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00?o
0?ZJooooool0nYX04Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`;o0?ZJ00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool03?ooool00ol0nY[oooooo`3jVP0Aooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo0_l0nYX00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000
ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0<oooo
o`03o`3jV_oooooo0?ZJ017ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool2o`3jVP03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00?o0?ZJooooool0nYX04Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`0=ooooo`;o0?ZJ00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03
o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
3?ooool00ol0nY[oooooo`3jVP0Aooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo0_l0nYX00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ017ooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03?ooool01?l0nY[oooooooooool0nYX@ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo
00?o0000ooooooooool05_ooool002_ooooo0_l00007ooooo`03o`00Oooooooooooo00cooooo00?o
0?ZJooooool0nYX04Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`;o00006Oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00cooooo00Co0?ZJoooooooooooo0?ZJ4?ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03?ooool00ol0nY[oooooo`3jVP0Aooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool05oooool3o`0000Kooooo00?o001oooooooooool03?ooool01?l0nY[ooooooooo
ool0nYX@ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Cooooo0ol0000Hooooo`00:oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00cooooo00?o0?ZJooooool0nYX04Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0<ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooo
ooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Co
0?ZJoooooooooooo0?ZJ4Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0<ooooo`04o`3jV_ooooooooooo`3jVQ3o
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Co0?ZJoooooooooooo0?ZJ4Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`0<ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01?l0
07ooooooooooool0nYX>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool0
0ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo
00_ooooo00Go0?ZJoooooooooooo001oo`3jVP0@ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co001o
ooooool0nY[o0?ZJ3Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00Co
0?ZJoooooooooooo0?ZJ4?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooo`3jVPko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Ko
oooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02oooool01Ol0nY[ooooo
ooooool007oo0?ZJ013ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007ooooooo`3jV_l0nYX=oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool01?l0nY[oooooooooool0nYX@
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00Co001oooooool0nY[o0?ZJ3_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`05o`3jV_ooooooooooo`00Ool0nYX04?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Co001ooooooooooooo0?ZJ
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`04o`00Ool0nY[oooooo`3jVPgooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0<ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool01?l007ooooooo`3jV_l0nYX>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00_ooooo00Go0?ZJoooooooooooo001oo`3jVP0@ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00Co001oo`3jV_oooooo0?ZJ3Oooool00ol007ooooooooooo`0?ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00cooooo00Co0?ZJoooooooooooo0?ZJ4?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00Co001oooooool0nY[o0?ZJ3Oooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05oooo
o`03o`3jV_oooooooooo00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00Co001oooooool0nY[o0?ZJ3_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000oooo
ooooool01_ooool00ol007ooooooooooo`0;ooooo`05o`3jV_ooooooooooo`00ool0nYX04?ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_l0nYX=
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJooooooooool01_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007oo0?ZJooooool0
nYX=ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool01Ol0nY[ooooooooo
ool0nY[o003o00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`04o`00
Oooooooo0?ZJo`3jVPgooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0nY[oooooooooo`07ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`04
o`00Oooooooo0?ZJo`3jVPkooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06oooo
o`03o`000?oooooooooo01Kooooo000Jooooo`Go00000oooool2o`0000Oooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0;ooooo`06o`3jV_ooooooooooo`00ool0nY[o003o3oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Go001oooooool0nY[oooooo`3j
VP0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Gooooo0_l0nYX7ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`04o`00Ool0nY[oooooo`3jVPgooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`06o`3jV_ooooooooooo`00ool0
nY[o003o3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co001ooooo
ool0nY[o0?ZJ3Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`05ooooo`;o0?ZJ2?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01?l007oo0?ZJooooool0
nYX>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooooooo
o`0Fooooo`006oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Kooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`06o`3jV_ooooooooooo`00ool0
nY[o003o3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Go001ooooo
ool0nY[oooooo`3jVP0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00?o0?ZJooooool0nYX01oooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
1?l007oo0?ZJooooool0nYX=ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Ooo
ool00ol0003oooooooooo`07ooooo`Go00000oooool2o`0000Kooooo00?o0000ooooooooool01_oo
ool00ol007ooooooooooo`0;ooooo`06o`3jV_ooooooooooo`00ool0nY[o003o3oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co001oooooool0nY[o0?ZJ3Oooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`05ooooo`;o0?ZJ2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool01Ol007oo0?ZJoooooooooooo0?ZJ00gooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000Doooo
o`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Kooooo0ol00006
ooooo`03o`00Oooooooooooo00_ooooo00Ko0?ZJooooool00?oo001oo`3jV_l00?l?ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03_ooool01Ol007ooooooo`3jV_oooooo0?ZJ00go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool01?ooool00ol0nY[oooooo`3jVP07ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Ool0nY[ooooooooo
ool0nYX03?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo0ol0000:oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001Oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00_ooooo00Ko0?ZJoooooooooooo003oo`3jV_l00?l?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007ooooooo`3jV_l0nYX=oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Gooooo0_l0nYX8ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`05o`00Ool0nY[oooooooooool0nYX03Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool0
01gooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`06o`3jV_oooooo003oo`00Ool0nY[o003o
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Go001oooooool0nY[o
ooooo`3jVP0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00?o0?ZJooooool0nYX01oooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol007oo
0?ZJoooooooooooo0?ZJ00cooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05oooo
o`04o`000?ooooooooooooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000Gooooo0ol00006ooooo`03o`00Oooooooooooo00_ooooo00Ko0?ZJoooooooooooo003o
o`3jV_l00?l?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007oo
ooooo`3jV_l0nYX=ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo0_l0nYX8ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`05o`00Ool0nY[ooooo
ooooool0nYX03Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo1?l0000H
ooooo`006_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001_oo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Ko0?ZJooooool00?oo001o
o`3jV_l00?l?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool01Ol007oo
ooooo`3jV_oooooo0?ZJ00gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool00ol0nY[oooooo`3jVP07oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`05o`3jV_ooooooooooooooool0nYX03?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00Gooooo00?o0000ooooooooool02_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Ko
0?ZJoooooooooooo003oo`3jV_l00?l?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool01?l007oo0?ZJooooool0nYX=ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00?o0?ZJoooo
ool0nYX02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool01Ol007oo0?ZJoooooooooooo0?ZJ00gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000Jooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00006ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool02oooool01_l0nY[oooooo`00ool007oo0?ZJo`00o`oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0>ooooo`05o`00Oooooooo0?ZJooooool0nYX03Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVPOooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go0?ZJooooooooooooooooo`3j
VP0<ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`07ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00005ooooo`03
o`000?oooooooooo00Kooooo00?o001oooooooooool02oooool01_l0nY[oooooooooool00?oo0?ZJ
o`00o`oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Ool0nY[o
ooooooooool0nYX03?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Go
001oo`3jV_ooooooooooo`3jVP0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1_ooool00ol0003oooooooooo`0Fooooo`006oooool3o`0000Cooooo0_l00007ooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool02oooool01_l0nY[oooooo`00ool007oo0?ZJo`00o`oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`05o`00Ool0nY[ooooooooo
ool0nYX03Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVPOooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go0?ZJ
ooooooooooooooooo`3jVP0<ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooooooool01Ooo
ool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`0;ooooo`06o`3jV_oooooo003oooooool0nY[o003o3oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00Go001oo`3jV_ooooooooooo`3jVP0<ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ2?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool01Ol007oo0?ZJoooooooooooo0?ZJ00go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool01oooool00ol0nY[oooooooooo`04ooooo`03o`00Oooooooooooo00Ko
oooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`0;ooooo`06o`3jV_oooooo003oo`00Ool0nY[o003o3oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00Go001oo`3jV_ooooooooooo`3jVP0=ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool01Ol0nY[ooooooooooooooooo0?ZJ00cooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool01_ooool00ol0nY[oooooooooo`05ooooo`03o`00Oooooooooooo00Gooooo
00?o0000ooooooooool02?ooool3o`0000Cooooo0_l00006ooooo`03o`000?oooooooooo00Kooooo
00?o001oooooooooool02oooool01ol0nY[oooooo`00oooooooo0?ZJooooool00?l03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go001oo`3jV_ooooooooooo`3jVP0<
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`05o`00Ool0
nY[oooooooooool0nYX03Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`06ooooo`;o0?ZJ1_ooool00ol007oooooo
ooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool02oooool01_l0nY[oooooo`00ool007oo0?ZJo`00o`oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Ool0nY[ooooo00;ooooo00?o0?ZJoooooooo
ool02_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol0
nY[ooooooooooooooooo0?ZJ00cooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01Oooool00ol0nY[oooooo`3jVP06
ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06
ooooo`03o`00Oooooooooooo00_ooooo00Oo0?ZJooooool00?ooooooo`3jV_oooooo003o00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Ool0nY[oooooooooool0
nYX03?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01Ol0
07oo0?ZJoooooooooooo0?ZJ00gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01_ooool2o`3jVPKooooo00?o001o
ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00_ooooo00Ko0?ZJo`00oooooooo001oo`3jV_l00?l?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`02ooooo`03o`3jV_oo
oooooooo00[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00Go0?ZJooooooooooooooooo`3jVP0<ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJooooool0
nYX01_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0;ooooo`07o`3jV_oooooo003oooooool0nY[oooooo`00o`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol007oo0?ZJoooooooo
oooo0?ZJ00cooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00Go0?ZJooooooooooooooooo`3jVP0=ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo0_l0nYX6ooooo`03
o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0:ooooo`08o`3jV_oooooo003oooooool007oo0?ZJooooool00?l>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`02
ooooo`03o`3jV_oooooooooo00[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00Go0?ZJooooooooooooooooo`3jVP0<ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Gooooo
00?o0?ZJooooool0nYX01_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`07o`3jV_oooooo003oooooool0
nY[oooooo`00o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol0
07oo0?ZJoooooooooooo0?ZJ00cooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0:ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00Gooooo00?o0?ZJooooool0nYX01_ooool00ol007ooooooooooo`06ooooo`03o`000?oo
oooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02_ooool0
2?l0nY[oooooo`00oooooooo001oo`3jV_oooooo003o3_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oo`3jV_ooool00_ooool00ol0nY[oooooooooo`0:ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05
o`3jV_ooooooooooooooool0nYX03?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`04ooooo`04o`3jV_oooooooooo
o`3jVPKooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool02oooool01ol0nY[oooooo`00oooooooo0?ZJooooool00?l0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go001oo`3jV_oooooo
ooooo`3jVP0<ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP07oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`05oooo
o`03o`3jV_oooooo0?ZJ00Kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Foooo
o`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00[ooooo00So0?ZJooooool0
0?ooooooo`00Ool0nY[oooooo`00o`kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Ool0nY[ooooo00;ooooo00?o0?ZJo`00ooooool02_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol0nY[ooooooooo
oooooooo0?ZJ00cooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool0nYX6ooooo`03
o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00_ooooo00Oo0?ZJooooool00?ooooooo`3jV_oooooo003o00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`06o`00Ool0nY[oooooooooool0nY[o003o
2oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo00[ooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01Oooool00ol0nY[o
ooooo`3jVP06ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:ooooo`08o`3jV_oooooo003oooooool0
07oo0?ZJooooool00?l>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool0
1ol007oo0?ZJoooooooooooo003oo`3jV_l00?l02oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`07o`3j
V_ooooooooooooooool00?oo0?ZJo`00o`05ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`3jV_l007oooooo00;ooooo00?o0?ZJo`00
ooooool02_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVPKooooo00?o001o
ooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001o
ooooooooool02oooool01ol0nY[oooooo`00oooooooo0?ZJooooool00?l03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Ko0?ZJoooooooooooo003oo`3jV_l00?l;oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00;ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`04oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`05oooo
o`04o`3jV_ooooooooooo`3jVPGooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00[ooooo00So0?ZJoooo
ool00?ooooooo`00Ool0nY[oooooo`00o`kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`07o`3jV_ooooooooooooooool00?oo0?ZJo`00o`0;ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00;ooooo00Oo0?ZJooooooooooooooooo`00ool0nY[o003o00Gooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`06ooooo`03o`3jV_oooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol0nY[o001oooooo`02ooooo`03o`00ool0nY[ooooo00[ooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01?oo
ool01?l0nY[oooooooooool0nYX6ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Oo0?ZJooooool00?oo
ooooo`3jV_oooooo003o00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`05o`3jV_ooooooooooo`00ool0nYX00_l00?l:ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00?o0?ZJ
ooooooooool00_ooool00ol00?oo0?ZJooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01oooool00ol0nY[oooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`0:ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Cooooo00Go0?ZJ
ooooooooooooooooo`3jVP05ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_oo
ool002_ooooo0_l00007ooooo`03o`00Oooooooooooo00[ooooo00So0?ZJooooool00?ooooooo`00
Ool0nY[oooooo`00o`kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`08
o`3jV_ooooooooooooooool00?oo0?ZJooooool00?l:ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00?o
0?ZJooooooooool00_l00?l00ol0nY[o003oooooo`04ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01_ooool3o`3jVPGooooo00?o001oooooooooool03_ooool01?l0nY[o001ooooo
ooooool2o`00o`03o`3jV_oooooooooo00Wooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01?ooool01Ol0nY[ooooo
ooooool0nY[o003o00Gooooo00?o001oooooooooool01?ooool2o`0001Wooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0;ooooo`07o`3jV_oooooo003oooooool0nY[oooooo`00o`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01ol0nY[oooooooooool0
0?oo0?ZJooooool00?l02_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`04o`3jV_ooooooooooooooo`;o
003o00?o0?ZJooooooooool01?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oo
oooo00?o0?ZJooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`3jV_oooooooooo00;o
003o00?o0?ZJooooooooool02_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`04ooooo`05o`3jV_oooooooooooooo
ool0nYX01Oooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03
o`000?oooooooooo00Kooooo00?o001oooooooooool02_ooool02?l0nY[oooooo`00oooooooo001o
o`3jV_oooooo003o3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00So
0?ZJoooooooooooo003oooooool0nY[oooooo`00o`[ooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool01_l0
nY[oooooooooool00?ooooooo`3jVP;o003o1?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Kooooo00?o0?ZJooooool0nYX01Oooool00ol007ooooooooooo`0>ooooo`03o`3jV_l0
07oooooo00;o003o00?oooooo`3jV_ooool02_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`03ooooo`07o`3jV_oo
ooooooooooooool00?oo0?ZJo`00o`04ooooo`03o`00Oooooooooooo00Gooooo00?o0000oooooooo
ool05oooool3o`0000Kooooo00?o001oooooooooool02_ooool02?l0nY[oooooooooool00?oooooo
o`3jV_oooooo003o3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Oo
0?ZJoooooooooooo003oo`3jV_oooooo003o00[ooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool02?l0nY[o
oooooooooooooooo003oooooool0nY[o003o1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Oooooo0_l0nYX6ooooo`03o`00Oooooooooooo00kooooo00?o0?ZJooooooooool00_l0
0?l00ol0nY[oooooooooo`0:ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Cooooo00Ko0?ZJoooooooooooo003o
o`3jV_l00?l4ooooo`03o`00Oooooooooooo00Cooooo0ol0000Hooooo`00:oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00[ooooo00So0?ZJooooool00?ooooooo`00Ool0nY[ooooo
o`00o`kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`08o`3jV_oooooo
ooooo`00oooooooo0?ZJooooool00?l:ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00So0?ZJoooooooo
oooo003oooooool0nY[oooooo`00o`Cooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`06ooooo`03o`3jV_oooooo0?ZJ00Gooooo00?o001oooooooooool03_ooool01?l0nY[o001ooooo
ool00?l2ooooo`03o`3jV_oooooooooo00Wooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool00oooool01ol0nY[ooooo
oooooooooooo003oo`3jV_l00?l01?ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:ooooo`03o`3jV_oooooo003o
00;ooooo00?o0?ZJooooool00?l03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo0_l0nYX2ooooo`04o`00oooooooo0?ZJo`00o`[ooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool0
2?l0nY[ooooooooooooooooo003oooooool0nY[o003o1Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Kooooo00Co0?ZJooooool0nY[o0?ZJ1Oooool00ol007ooooooooooo`0=oooo
o`04o`3jV_l007ooooooooooo`;o003o00?o0?ZJo`00ooooool02_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`04
ooooo`06o`3jV_ooooooooooo`00ool0nY[o003o1?ooool00ol007ooooooooooo`06ooooo`03o`00
0?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02_oo
ool02?l0nY[oooooo`00oooooooo001oo`3jV_oooooo003o3_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00So0?ZJoooooooooooo003oooooool0nY[oooooo`00o`[ooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00Co001ooooooooooooooooo0_l0nYX2ooooo`05o`00oooooooo0?ZJooooool00?l01?ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00Co0?ZJooooool00?oo0?ZJ1?ooool0
0ol007ooooooooooo`0>ooooo`04o`3jV_l007ooooooo`00o`;ooooo00?o0?ZJooooooooool02Ooo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`03ooooo`07o`3jV_ooooooooooo`00oooooooo0?ZJo`00o`04ooooo`03
o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00[ooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooo`00o`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool02?l0nY[o001ooooooooooooo003o
ooooool0nY[o003o2_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`;ooooo
00?o0?ZJo`00ooooool01?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo
00Co0?ZJooooool00?oo0?ZJ1Oooool00ol007ooooooooooo`0=ooooo`08o`3jV_l007oooooooooo
ool00?ooooooo`3jV_l00?l;ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00?ooooo00Oo0?ZJoooooooooooooooo
o`00ool0nY[o003o00Cooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00
:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo00Wo0?ZJoooooooooooo
003oooooool007oo0?ZJooooool00?l03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00kooooo00So0?ZJoooooooooooo003oooooool0nY[oooooo`00o`[ooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Go001ooooooooo
ooooooooo`3jVP03ooooo`05o`00oooooooo0?ZJooooool00?l01?ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Gooooo00Ko0?ZJoooooooooooo003oo`3jV_l00?l3ooooo`03o`00
Oooooooooooo00kooooo00Co0?ZJo`00Oooooooo003o0_ooool00ol0nY[o003oooooo`09ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00?ooooo00Ko0?ZJoooooooooooo003oooooool0nYX2o`00o`?ooooo00?o001o
ooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001o
ooooooooool02_ooool00ol0nY[oooooo`00o`02ooooo`03o`00Ool0nY[o003o00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`08o`3jV_l007ooooooooooool00?oooooo
o`3jV_l00?l:ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00Co0?ZJoooooooooooo003o0_ooool00ol0
nY[o003oooooo`04ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool01Ol0
nY[oooooo`00ool0nY[o003o00Cooooo00?o001oooooooooool03Oooool01?l0nY[o001oooooool0
0?l2ooooo`03o`3jV_l00?oooooo00[ooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool00oooool01_l0nY[ooooooooo
ool00?ooooooo`3jVP;o003o0oooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Ko
oooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02Oooool02Ol0nY[ooooo
ooooool00?ooooooo`00Ool0nY[oooooo`00o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool02?l0nY[oooooooooool00?ooooooo`3jV_oooooo003o2_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01Ol007oo
oooooooooooooooo0?ZJ00?ooooo00Go003oooooool0nY[oooooo`00o`04ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool01Oooool01_l0nY[oooooooooool00?oo0?ZJo`00o`?ooooo
00?o001oooooooooool03Oooool01Ol0nY[oooooo`00Oooooooo003o00;ooooo00?o0?ZJo`00oooo
ool02Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`03ooooo`08o`3jV_oooooo003oo`00oooooooo0?ZJooooool0
0?l3ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00[ooooo00?o0?ZJooooool00?l00_ooool00ol007oo0?ZJo`00
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool01?l0nY[o001ooooo
ool00?l2ooooo`03o`3jV_l00?oooooo00Wooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool01?l0nY[ooooo
ooooool00?l2ooooo`03o`3jV_oooooo003o00Cooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`06ooooo`05o`3jV_oooooo003oo`3jV_l00?l01?ooool00ol007ooooooooooo`0=oooo
o`04o`3jV_l007ooooooo`00o`;ooooo00?o0?ZJo`00ooooool02_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`03
ooooo`06o`3jV_ooooooooooo`00oooooooo0?ZJ0_l00?l3ooooo`03o`00Oooooooooooo00Kooooo
00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`09ooooo`03o`3jV_oooooo003o00;ooooo00Co001oo`3jV_oooooo003o3_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00gooooo00Go0?ZJo`00Ooooooooooooo`00o`02ooooo`03
o`3jV_l00?oooooo00Wooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00Go001oooooooooooooooooo`3jVP02ooooo`06o`00oooooooooooo
o`3jV_oooooo003o1?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00Oo
0?ZJoooooooooooo003oooooool0nY[o003o00?ooooo00?o001oooooooooool03Oooool01Ol0nY[o
ooooo`00Oooooooo003o00;ooooo00?o0?ZJo`00ooooool02Oooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`03oooo
o`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooool00?l00oooool00ol007ooooooooooo`05oooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:oooo
o`03o`3jV_oooooo003o00;ooooo00?o001oo`3jV_l00?l03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00Co0?ZJo`00Oooooooo003o0_ooool00ol0nY[oooooo`00o`09
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`05o`00Ooooooooooooooooool0nYX00oooool01_l00?ooooooooooool0nY[oooooo`00o`Co
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`07o`3jV_ooooooooooo`00
oooooooo0?ZJo`00o`03ooooo`03o`00Oooooooooooo00gooooo00Co0?ZJo`00Oooooooo003o0_oo
ool00ol0nY[o003oo`00o`0:ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00?ooooo00So0?ZJoooooooooooo003o
ooooool0nY[oooooo`00o`?ooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Foooo
o`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo00?o0?ZJooooool0
0?l00_ooool01?l007oo0?ZJooooool00?l>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03Oooool01Ol0nY[o001ooooooooooooo003o00;ooooo00?o0?ZJo`00ooooool02Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
1?l007ooooooooooool0nYX3ooooo`06o`00ooooooooooooooooool0nY[o003o1?ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00Co0?ZJoooooooooooo003o0_ooool01Ol0
nY[o003ooooooooooooo001o00oooooo00Co0?ZJooooool007oo003o0oooool00ol0nY[o003ooooo
o`09ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00;ooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[ooooo
o`00o`03ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00[ooooo00?o0?ZJooooool00?l00_ooool01?l007oo0?ZJ
ooooool00?l=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool01?l0nY[o
001oooooool00?l2ooooo`03o`3jV_oooooo003o00Wooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Go001oooooooooooooooooo`3jVP03
ooooo`06o`00ooooooooooooo`3jV_oooooo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Gooooo00Oo0?ZJoooooooooooo003oooooool0nY[o003o00?ooooo00?o001ooooo
ooooool03Oooool01?l0nY[o001oooooool00?l2ooooo`03o`3jV_oooooo003o00[ooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool00oooool00ol0nY[oooooo`00o`03ooooo`03o`3jV_l00?oooooo00;ooooo00?o001o
ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00Wooooo00?o0?ZJooooool00?l00_ooool01?l007oo0?ZJooooool00?l>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03Oooool01Ol0nY[o001ooooooooo
oooo003o00;ooooo00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX3ooooo`07o`00
ooooooooooooooooool0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01?ooool01?l0nY[oooooo`00ool00?l2ooooo`05o`3jV_l00?ooooooooooool007l03ooo
ool01?l0nY[oooooo`00Ool00?l3ooooo`03o`3jV_l00?oooooo00Wooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
0_ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooo003o00?ooooo00?o001ooooooooo
ool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool02_ooool00ol0nY[oooooo`00o`02ooooo`04o`00Ool0nY[oooooo`00o`gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`04o`3jV_l007ooooooo`00o`;ooooo00?o0?ZJ
ooooool00?l02Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool01Ol007oooooooooooooooooo0?ZJ00;ooooo0_l00?l2ooooo`03o`3jV_oo
oooo003o00Cooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`03o`3jV_oo
oooooooo00;o003o00?oooooo`3jV_l00?l00oooool00ol007ooooooooooo`0=ooooo`03o`3jV_l0
07oo003o00?ooooo00?o0?ZJooooool00?l02_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`03ooooo`03o`3jV_oo
oooo003o00?ooooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`06ooooo`03o`000?oo
oooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02Oooool0
0ol0nY[oooooo`00o`02ooooo`04o`00Ool0nY[oooooo`00o`kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0=ooooo`04o`3jV_l007ooooooo`00o`?ooooo00?o0?ZJooooool00?l0
2Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool01?l007ooooooooooool0nYX3ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`03
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00oooool01?l0nY[oooooooooool0
0?l3ooooo`05o`3jV_l00?ooooooooooool007l03oooool01?l0nY[oooooo`00Ool00?l3ooooo`03
o`3jV_oooooo003o00Wooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool00_ooool01?l0nY[oooooooooool00?l2oooo
o`04o`3jV_ooooooooooo`00o`;ooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02Oooool01?l0nY[oooooooooool0
0?l2ooooo`04o`00Ool0nY[oooooo`00o`gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`04o`3jV_l007ooooooo`00o`;ooooo00?o0?ZJooooool00?l02Oooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool01?l007oo
ooooooooool0nYX3ooooo`;o003o0_ooool00ol0nY[oooooo`00o`04ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_l00?oo
oooo00;ooooo00?o001oooooooooool03Oooool00ol0nY[o001oo`00o`03ooooo`03o`3jV_oooooo
003o00[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool00_ooool2o`3jVP03ooooool00?oooooo00;ooooo00?o0?ZJ
ooooool00?l00_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[oooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool02Oooool00ol0nY[oooooo`00o`02oooo
o`04o`00Ool0nY[oooooo`00o`kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0=
ooooo`04o`3jV_l007ooooooo`00o`?ooooo00?o0?ZJooooool00?l02Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01?l007oooooooooo
ool0nYX3ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool00oooool01?l0nY[oooooooooool00?l3ooooo`05o`3jV_l00?oo
ooooooooool007l03_ooool01Ol0nY[oooooooooool007oo003o00?ooooo00?o0?ZJooooool00?l0
2Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`?ooooo00?o0?ZJooooool0
0?l00_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooo003o00?ooooo00Co001oo`3jV_oo
oooo003o3Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00gooooo00Go0?ZJoooo
ool007ooooooo`00o`02ooooo`03o`3jV_oooooo003o00Wooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Co001ooooooooooooo0?ZJ0ooo
ool01ol00?oooooooooooooooooo0?ZJooooool00?l01?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Cooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[o003oooooo`02oooo
o`03o`00Oooooooooooo00cooooo00Co0?ZJooooool007oo003o0oooool00ol0nY[oooooo`00o`0:
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00;ooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[oooooo`00
o`02ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooo003o00;ooooo00Co001o
o`3jV_oooooo003o3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo0_l0
nYX00ol007ooooooo`00o`03ooooo`03o`3jV_oooooo003o00Wooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool0nYX01?oo
ool01ol00?oooooooooooooooooo0?ZJooooool00?l00oooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01ol007oooooooooooooooooo0?ZJ
ooooool0nYX02_ooool00ol007ooooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`Cooooo00Go
0?ZJooooool00?ooooooo`00O`0>ooooo`05o`3jV_ooooooooooo`00Ool00?l00oooool00ol0nY[o
ooooo`00o`09ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00;ooooo00?o0?ZJooooool00?l01?ooool00ol0nY[o
ooooo`00o`02ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo00?o0?ZJooooool00?l00oooool01?l007oo
0?ZJooooool00?l=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03Oooool01Ol0
nY[oooooo`00Oooooooo003o00;ooooo00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool01?l007ooooooooooool0
nYX3ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`04ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;o
oooo0_l0nYX:ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX00ooooooo003oooooo`02ooooo`03
o`3jV_oooooo003o00;ooooo00?o001oooooooooool03?ooool01?l0nY[oooooo`00Ool00?l3oooo
o`03o`3jV_oooooo003o00[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool00_ooool01?l0nY[oooooooooool00?l3
ooooo`03o`3jV_oooooo003o00;ooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`00:oooool2o`0000Oooooo00?o001oooooooooool02Oooool00ol0nY[oooooo`00o`02oooo
o`04o`00Ool0nY[oooooo`00o`kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0<
ooooo`05o`3jV_oooooo001oooooool00?l00oooool00ol0nY[oooooo`00o`09ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooo0?ZJ00?ooooo00?o003oooooooooool00_ooool00ol0nY[oooooo`00o`03ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooo0?ZJ00Co0?ZJ00?o003oooooooooool01oooool00ol007ooooooooooo`02ooooo`04o`3jV_oo
ooooooooo`00o`Cooooo00Go0?ZJooooool00?ooooooo`00O`0>ooooo`05o`3jV_ooooooooooo`00
Ool00?l00oooool00ol0nY[oooooo`00o`09ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Ooooooooooooooooool0nYX00_ooool0
0ol00?ooooooooooo`02ooooo`03o`3jV_oooooo003o00;ooooo00?o001oooooooooool01?ooool2
o`0001Wooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooo
003o00?ooooo00Co001oo`3jV_oooooo003o3Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00cooooo0_l0nYX01?oooooo001oo`00ool00?l2ooooo`03o`3jV_oooooo003o00Wooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00Co001ooooooooooooo0?ZJ0oooool01ol00?oooooooooooooooooo0?ZJooooool00?l01?ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooo`3jVP04o`3jVP03ooooool00?oooooo00Oooooo00?o001oooooooooool00_ooool3
o`3jVP03ooooool00?oooooo00?ooooo00Go0?ZJo`00ooooooooooooo`00O`0>ooooo`04o`3jV_oo
oooo001oo`00o`?ooooo00?o0?ZJooooool00?l02_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`02ooooo`04o`3j
V_ooooooooooo`00o`?ooooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`06ooooo`03
o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
2?ooool01?l0nY[oooooooooool00?l2ooooo`04o`00Ool0nY[oooooo`00o`kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0<ooooo`04o`3jV_oooooo001oo`00o`Cooooo00?o0?ZJ
ooooool00?l02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooo`3jVP03ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJ
ooooool00?l00oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool01_l007ooooooo`3jV_l0nY[oooooo`00o`;o0?ZJ00?o003oooooooooool0
1_ooool00ol007ooooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`Cooooo00Go0?ZJoooooooo
oooo003oo`00O`0>ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o0?ZJooooool00?l02Oooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
1Ol007oooooooooooooooooo0?ZJ00;ooooo00?o003oooooooooool00_ooool00ol0nY[oooooo`00
o`02ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool3o`0000Kooooo00?o
001oooooooooool02Oooool00ol0nY[oooooo`00o`03ooooo`04o`00Ool0nY[oooooo`00o`gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0<ooooo`05o`3jV_ooooooooooo`00Ool0
0?l00oooool01?l0nY[oooooo`00ool00?l8ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooo`3jVP?ooooo00Oo003o
ooooooooooooooooo`3jV_oooooo003o00Cooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool0nYX01Ol0nYX00ol00?oooooo
ooooo`06ooooo`03o`00Oooooooooooo00;ooooo00Go0?ZJooooooooooooooooo`00o`04ooooo`05
o`3jV_oooooo003oooooool007l03Oooool01Ol0nY[oooooooooool007oo003o00Cooooo00?o0?ZJ
o`00ooooool02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool01?l007ooooooooooooooool2o`3jVP03ooooool00?oooooo00?ooooo00?o
0?ZJooooool00?l00_ooool00ol007ooooooooooo`04ooooo`?o00006?ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`08ooooo`04o`3jV_ooooooooooo`00o`;ooooo00Co
001oo`3jV_oooooo003o3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo
00Co0?ZJooooool007oo003o1?ooool00ol0nY[oooooo`00o`09ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo0?ZJ00?o
oooo00?o003oooooooooool00_ooool00ol0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Ool0nY[o0?ZJ00;o
oooo00Co003oooooool0nY[o003o2?ooool00ol007ooooooooooo`02ooooo`04o`3jV_oooooooooo
o`00o`Cooooo00Go0?ZJoooooooooooo003oo`00O`0>ooooo`04o`3jV_ooooooooooo`00o`Cooooo
00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool01?l007ooooooooooool0nYX3ooooo`03o`00oooooooooooo00;o
oooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooo003o00?o
oooo00Co001oo`3jV_oooooo003o3Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00cooooo00Go0?ZJoooooooooooo001oo`00o`03ooooo`04o`3jV_oooooo003oo`00o`Sooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Co
001ooooooooooooo0?ZJ0_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_l00?oooooo00?ooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00Go001oooooool0nY[oooooo`3jVP02o`00o`;o0?ZJ00?oooooo`00ooooool01Oooool00ol007oo
ooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`Gooooo00Go0?ZJooooool00?ooooooo`00O`0=
ooooo`05o`3jV_ooooooooooo`00Ool00?l01?ooool00ol0nY[oooooo`00o`09ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Oooo
ooooooooooooool0nYX00_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooo003o00;ooooo
00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00Sooooo00Co0?ZJoooooooooooo003o0_ooool01Ol007oo0?ZJ
oooooooooooo003o00gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0<ooooo`04
o`3jV_oooooo001oo`00o`Cooooo00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooo`3jVP02oooo
o`;o003o1?ooool00ol0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`04o`00Ool0nY[oooooooooo`?o003o00Co0?ZJ
o`00ool00?oo003o1_ooool01Ol007oooooooooooooooooo0?ZJ00?ooooo00?o003oooooooooool0
0oooool01?l0nY[oooooo`00ool007l>ooooo`04o`3jV_ooooooooooo`00o`Cooooo00Co0?ZJoooo
oooooooo003o2?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool01?l007ooooooooooool0nYX2ooooo`;o003o1?ooool01_l0nY[ooooooooo
ool00?ooooooo`00O`Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00Sooooo00Co0?ZJoooooooooooo003o0oooool01?l007oo0?ZJooooool00?l=
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03?ooool00ol0nY[oooooooooo`02
o`00o`?ooooo00Co0?ZJoooooooooooo003o2?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX2ooooo`03o`00
oooooooooooo00?ooooo00?o0?ZJo`00ooooool00oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooo`3jVP02ooooo`;o003o
0_l0nYX2o`00o`Kooooo00?o001oooooooooool00_ooool01?l0nY[oooooooooool00?l5ooooo`05
o`3jV_oooooo003oooooool007l03Oooool00ol0nY[oooooooooo`02o`00o`Cooooo00?o0?ZJoooo
ool00?l02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool01Ol007oooooooooooooooooo0?ZJ00;ooooo00?o003oooooooooool00_ooool0
1_l0nY[oooooo`00ool00?ooooooo`00O`Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`08ooooo`03o`3jV_oooooo003o00?ooooo00Go
001oo`3jV_ooooooooooo`00o`0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3?ooool01?l0nY[oooooo`00Ool00?l4ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oo`3j
V_ooool00_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooo003o00?ooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Ko001oo`3j
V_ooooooooooo`00ooooool2o`00o`03o`3jV_oooooo003o00Kooooo00Go001ooooooooooooooooo
o`3jVP02ooooo`03o`00oooooooooooo00Cooooo00Co0?ZJooooool00?oo001o3_ooool01?l0nY[o
ooooo`00ool007l4ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co001ooooooooooooo0?ZJ0_oo
ool00ol00?ooooooooooo`03ooooo`06o`3jV_ooooooooooo`00oooooooo001o1oooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02?ooool01?l0nY[o
ooooooooool00?l3ooooo`04o`00Ool0nY[oooooo`00o`gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0<ooooo`03o`3jV_oooooooooo00;o003o0oooool01?l0nY[oooooooooool0
0?l8ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Ool0nY[o0?ZJ00;ooooo00?o003oooooooooool01?ooool00ol0nY[oooooo`00
o`03ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`06o`00Ool0nY[oooooooooool00?oooooo0_l00?l00ol0nY[o003oo`00o`06ooooo`03
o`00Oooooooooooo00;ooooo00Co0?ZJooooool00?oo003o1Oooool01Ol0nY[oooooo`00oooooooo
001o00gooooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooo`00o`09ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`06o`00Oooo
ooooooooooooool0nY[ooooo0_l00?l5ooooo`05o`3jV_oooooo003oooooool007l02?ooool00ol0
003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00So
oooo00?o0?ZJooooool00?l00oooool01Ol007ooooooo`3jV_oooooo003o00gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0<ooooo`04o`3jV_oooooo001oo`00o`Cooooo00Co0?ZJ
oooooooooooo003o2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007oo0?ZJooooo`02ooooo`03o`00oooooooooooo00?ooooo00Co
0?ZJoooooooooooo003o0_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool01Ol007oo0?ZJoooooooooooo003o00?ooooo00?o0?ZJooooool0
0?l01_ooool01ol007oooooooooooooooooo0?ZJooooool00?l01oooool01?l0nY[oooooo`00ool0
07l>ooooo`04o`3jV_oooooo003oo`00O`Cooooo00Co0?ZJoooooooooooo003o2?ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007oo
ooooooooool0nYX2ooooo`03o`00oooooooooooo00?ooooo00Ko0?ZJoooooooooooo003oooooool0
07l7ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`08ooooo`04o`3jV_ooooooooooo`00o`?ooooo00Co001oo`3jV_oooooo003o3Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo00?o0?ZJooooooooool00_l00?l4ooooo`03
o`3jV_oooooo003o00Sooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oo`3jV_ooool00_ooool00ol00?ooooooooooo`04ooooo`03
o`3jV_oooooo003o00?ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00Go001oo`3jV_ooooooooooo`00o`02ooooo`04o`00ool0nY[o003o
o`00o`Kooooo00?o001oooooooooool00_ooool01?l0nY[o003oo`00ool00?l5ooooo`05o`3jV_oo
oooo003oooooool007l03Oooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooo003o00Wo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00Co001ooooooooooooo0?ZJ0_ooool00ol00?ooooooooooo`04ooooo`05o`3jV_oooooo003o
ooooool007l02?ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00Sooooo00?o0?ZJooooool00?l00oooool01Ol007ooooooo`3jV_oooooo
003o00gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0;ooooo`04o`3jV_oooooo
ooooo`00o`Gooooo00Co0?ZJoooooooooooo003o2?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`02ooooo`03o`00
oooooooooooo00?ooooo00Co0?ZJoooooooooooo003o0_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l0nY[oooooooooool00?l4oooo
o`03o`3jV_oooooo003o00Kooooo00Oo001oooooooooooooooooo`3jV_oooooo003o00Oooooo00Co
0?ZJoooooooooooo003o3_ooool01?l0nY[oooooo`00ool007l4ooooo`04o`3jV_ooooooooooo`00
o`Sooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00Go001ooooooooooooo0?ZJooooo`02o`00o`Gooooo00Ko0?ZJoooooooooooo003ooooo
ool007l7ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`08ooooo`03o`3jV_oooooo003o00Cooooo00Co001oo`3jV_oooooo003o3Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo00Co0?ZJoooooooooooo003o1Oooool00ol0
nY[oooooo`00o`08ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Ool0nY[ooooo00;ooooo00?o003oooooooooool01?ooool00ol0
nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`05o`00Ool0nY[oooooooooool00?l00oooool01?l0nY[oooooooooool0
0?l5ooooo`03o`00Oooooooooooo00;ooooo00?o0?ZJo`00ool00?l01_ooool01Ol0nY[ooooooooo
ool00?oo001o00gooooo00Co0?ZJoooooooooooo003o1Oooool00ol0nY[oooooo`00o`09ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`04
o`00Ooooooooooooo`3jVP;ooooo00?o003oooooooooool01?ooool01Ol0nY[oooooooooool00?oo
001o00Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol0
07ooooooooooo`08ooooo`03o`3jV_oooooo003o00?ooooo00Go001oooooool0nY[oooooo`00o`0=
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02oooool01?l0nY[oooooooooool0
0?l5ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Go001oo`3jV_ooooooooooo`00o`06ooooo`04
o`3jV_ooooooooooo`00o`;ooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00Co0?ZJoooooooooooo003o1?ooool00ol0nY[oooooo`00o`06
ooooo`07o`00Ooooooooooooooooool0nY[oooooo`00o`07ooooo`04o`3jV_ooooooooooo`00o`go
oooo00Go0?ZJoooooooooooo003oo`00O`04ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooool0nYX00_ooool00ol00?ooooooooooo`04ooooo`06o`3jV_ooooooooooo`00oooooooo001o
1oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
2?ooool00ol0nY[oooooo`00o`04ooooo`04o`00Ool0nY[oooooo`00o`gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0;ooooo`05o`3jV_ooooooooooooooool00?l01Oooool01?l0
nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Ool0nY[ooooo00;ooooo00?o003oooooooooool01?ooool0
0ol0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`05o`3jV_ooooooooooooooool00?l00oooool01?l0nY[ooooooooo
ool00?l5ooooo`07o`00Ooooooooooooooooool0nY[oooooo`00o`07ooooo`05o`3jV_oooooooooo
o`00ool007l03Oooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooo003o00Wooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co
001oooooool0nY[o0?ZJ0_ooool00ol00?ooooooooooo`04ooooo`05o`3jV_ooooooooooo`00ool0
07l02?ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00Sooooo00?o0?ZJooooool00?l00oooool01Ol007ooooooo`3jV_oooooo003o00go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0:ooooo`05o`3jV_oooooooooooooo
ool00?l01Oooool01?l0nY[oooooooooool00?l8ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`05o`00Ool0nY[oooooooooool00?l01ooo
ool00ol0nY[oooooo`00o`02ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0;ooooo`07o`3jV_ooooooooooooooool0nY[oooooo`00o`05ooooo`?o
0?ZJ0_l00?l4ooooo`06o`00Ooooooooooooooooool0nY[o003o2?ooool01?l0nY[oooooooooool0
0?l=ooooo`05o`3jV_oooooo003oooooool007l01Oooool00ol0nY[oooooo`00o`08ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`04o`00
Oooooooo0?ZJooooo`;o003o1oooool01Ol0nY[oooooooooool00?oo001o00Oooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJoooo
ool00?l01?ooool01?l007oo0?ZJooooool00?l=ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool02oooool00ol0nY[oooooooooo`02o`00o`Gooooo00Co0?ZJoooooooooooo003o1ooo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007oo0?ZJooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooool00?l00ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooo003o00Gooooo00Oo001ooooooooooooo
ooooo`3jV_oooooo003o00Oooooo00Go0?ZJoooooooooooo003oo`00O`0=ooooo`04o`3jV_oooooo
003oo`00O`Gooooo00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooo`3jVP02ooooo`;o003o1_oo
ool01Ol0nY[oooooooooool00?oo001o00Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`08ooooo`03o`3jV_oooooo003o00?ooooo00Go
001oooooool0nY[oooooo`00o`0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
2_ooool00ol0nY[oooooooooo`02o`00o`Gooooo00Co0?ZJoooooooooooo003o2?ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01Ol0nY[o
oooooooooooooooo003o00Oooooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool02oooool4o`3jVP03o`00Oooooooo003o
00Kooooo0_l0nYX2o`00o`Cooooo00Ko001oooooooooooooooooo`3jV_l00?l8ooooo`04o`3jV_oo
ooooooooo`00o`gooooo00Go0?ZJooooool00?ooooooo`00O`05ooooo`03o`3jV_oooooo003o00So
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00Co001oo`3jV_oooooooooo0_l00?l7ooooo`05o`3jV_ooooooooooo`00ool007l01oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02?ooool0
0ol0nY[oooooo`00o`04ooooo`04o`00Ool0nY[oooooo`00o`gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0;ooooo`05o`3jV_oooooo003oo`00ool007l01Oooool01?l0nY[ooooo
ooooool00?l7ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`05o`00Ool0nY[oooooooooool00?l01oooool00ol0nY[oooooo`00o`03oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0:oooo
o`Go0?ZJ0_ooool00ol00?ooooooooooo`03ooooo`;o0?ZJ0_l00?l4ooooo`07o`00Oooooooooooo
ooooool0nY[oooooo`00o`08ooooo`04o`3jV_ooooooooooo`00o`cooooo00Go0?ZJoooooooooooo
003oo`00O`05ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooool0nYX00_ooool2o`00
o`Kooooo00Go0?ZJoooooooooooo003oo`00O`08ooooo`03o`000?oooooooooo01Kooooo000[oooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool01oooool00ol0nY[oooooo`00o`04oooo
o`05o`00Oooooooo0?ZJooooool00?l03Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00[ooooo00Go0?ZJoooooooooooo003oo`00O`06ooooo`03o`3jV_oooooo003o00Sooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Go
0?ZJooooooooooooooooo`00o`07ooooo`03o`3jV_oooooo003o00;ooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00[ooooo00?o0?ZJooooool0nYX0
0_l0nYX00ol007ooooooo`00o`07ooooo`03o`3jV_oooooo003o00Cooooo00Ko001ooooooooooooo
0?ZJooooool00?l8ooooo`04o`3jV_ooooooooooo`00o`gooooo00Go0?ZJooooool00?ooooooo`00
O`05ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go001oo`3jV_ooooooooooo`00o`08ooooo`05
o`3jV_ooooooooooo`00ool007l01oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
00Kooooo00?o001oooooooooool02?ooool00ol0nY[oooooo`00o`04ooooo`04o`00Ool0nY[ooooo
o`00o`gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0:ooooo`06o`3jV_oooooo
ooooo`00oooooooo001o1Oooool01?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`05o`00Ool0nY[ooooooooo
ool00?l01oooool00ol0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0:ooooo`Go0?ZJ0_ooool00ol00?ooooooooooo`04oooo
o`03o`3jV_oooooo003o00Cooooo00Ko001oooooooooooooooooo`3jV_l00?l9ooooo`04o`3jV_oo
ooooooooo`00o`cooooo00Go0?ZJoooooooooooo003oo`00O`05ooooo`04o`3jV_ooooooooooo`00
o`Sooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00Co001oooooool0nY[ooooo0_l00?l7ooooo`05o`3jV_ooooooooooo`00ool007l02?oo
ool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00Oooooo00?o0?ZJooooool00?l01?ooool01Ol007ooooooo`3jV_oooooo003o00gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`?o0?ZJ0_ooool00ol00?ooooooo`00
O`06ooooo`03o`3jV_oooooo003o00Sooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o0?ZJooooool00?l00_l00?l7ooooo`03o`3jV_oo
oooo003o00;ooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00[ooooo00?o0?ZJooooooooool00_ooool00ol007ooooooo`00o`07ooooo`03o`3jV_oo
oooo003o00Cooooo00Ko001ooooooooooooo0?ZJooooool00?l9ooooo`04o`3jV_oooooo003oo`00
o`_ooooo0_l0nYX01?oooooo003oooooool007l5ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co
001oo`3jV_oooooo003o2Oooool01Ol0nY[oooooooooool00?oo001o00Oooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJooooool0
0?l01?ooool01?l007oo0?ZJooooool00?l=ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool02_ooool01_l0nY[oooooooooool00?ooooooo`00O`Gooooo00Co0?ZJoooooooooooo003o
1oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool01Ol0nY[ooooooooooooooooo003o00Oooooo00?o0?ZJooooool00?l00oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool02Oooool02?l0nY[o
ooooooooool0nY[oooooo`00Oooooooo003o1oooool00ol0nY[oooooo`00o`04ooooo`03o`00Oooo
oooooooo00;o0?ZJ00?o003oooooooooool01oooool01?l0nY[oooooooooool00?l<ooooo`05o`3j
V_ooooooooooo`00ool007l01Oooool01?l0nY[oooooooooool00?l8ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Ool0nY[ooooo
ooooool00?l02?ooool01Ol0nY[oooooooooool00?oo001o00Sooooo00?o0000ooooooooool05_oo
ool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`07ooooo`03o`3jV_oooooo
003o00Cooooo00Go001oooooool0nY[oooooo`00o`0=ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01_ooool4o`3jVP;ooooo00?o003oooooool007l01_ooool00ol0nY[oooooo`00
o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`04o`3jV_oooooo003oo`00o`Sooooo00?o0?ZJooooool00?l00_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02Oooool00ol0nY[ooooo
ooooo`03ooooo`03o`00Ool00?oooooo00Oooooo00Co0?ZJooooool00?oo003o0oooool01_l007oo
ooooooooool0nY[oooooo`00o`Wooooo00Co0?ZJooooool007oo003o2oooool01_l0nY[oooooo`00
ool00?ooooooo`00O`Gooooo00Co0?ZJoooooooooooo003o1oooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007oo0?ZJooooool00?l9
ooooo`05o`3jV_ooooooooooo`00ool007l01oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool02?ooool00ol0nY[o003oooooo`04ooooo`04o`00Ool0
nY[oooooo`00o`gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`03o`3j
V_oooooo0?ZJ00?ooooo00?o003oooooool007l01Oooool01?l0nY[oooooooooool00?l7ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`3jV_oooooooooo00;o003o1oooool00ol0nY[oooooo`00o`03ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooooooo00;o
oooo00?o001oooooool00?l01oooool00ol0nY[oooooooooo`02o`00o`;ooooo00Ko001ooooooooo
oooo0?ZJooooool00?l9ooooo`04o`3jV_ooooooooooo`00o`cooooo00Go0?ZJooooool00?oo003o
o`00O`05ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oo`3jV_ooool00_l00?l8ooooo`03
o`3jV_oooooooooo00;o003o2?ooool00ol0003oooooooooo`0Fooooo`00:oooool2o`0000Oooooo
00?o001oooooooooool01oooool00ol0nY[oooooo`00o`04ooooo`05o`00Oooooooo0?ZJooooool0
0?l03Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo0_l0nYX4ooooo`03
o`00oooooooo001o00Kooooo00Co0?ZJoooooooooooo003o1oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0nY[oooooo`00o`09oooo
o`03o`3jV_oooooo003o00;ooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Wooooo00?o0?ZJooooooooool00oooool00ol007oo003oooooo`07oooo
o`03o`3jV_oooooo003o00;o003o0_ooool01Ol007ooooooooooool0nY[o003o00[ooooo00Go0?ZJ
ooooool007ooooooo`00o`0:ooooo`06o`3jV_oooooo003oo`00oooooooo001o1Oooool01?l0nY[o
ooooooooool00?l7ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`04o`00Ool0nY[oooooo`00o`Wooooo00Go0?ZJooooooooooooooooo`00
o`06ooooo`;o00006Oooool3o`0000Kooooo00?o001oooooooooool02?ooool00ol0nY[o003ooooo
o`04ooooo`04o`00Ool0nY[oooooo`00o`gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`07ooooo`03o`3jV_oooooo0?ZJ00;ooooo0_l00?l00ooooooo001oooooo`04ooooo`04o`3j
V_ooooooooooo`00o`Oooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o0?ZJooooool00?l02Oooool01?l0nY[oooooooooool00?l2oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`09oooo
o`03o`3jV_oooooooooo00;ooooo00?o001oooooool00?l02?ooool01?l0nY[oooooo`00ool00?l2
ooooo`04o`00Ooooooooooooo`3jVP;o003o2Oooool01Ol0nY[oooooooooool007oo003o00_ooooo
00Go0?ZJo`00ool00?oo003oo`00O`05ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Co001oo`3j
V_oooooo003o2Oooool01Ol0nY[ooooooooooooooooo003o00Kooooo0ol0000Hooooo`00:oooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Oooooo00?o0?ZJo`00ooooool01?ooool0
1Ol007ooooooo`3jV_oooooo003o00gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`05ooooo`;o0?ZJ1Oooool00ol00?ooooooo`00O`06ooooo`04o`3jV_ooooooooooo`00o`Oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o0?ZJo`00ooooool02Oooool00ol0nY[oooooo`00o`02ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo
0_l00?l9ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o001oooooool0nYX00_l00?l:ooooo`05
o`3jV_oooooo001oooooool00?l02_ooool00ol0nY[o003oooooo`02ooooo`03o`00Oooooooooooo
00?ooooo00Co0?ZJoooooooooooo003o1oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool01?l0nY[oooooooooool00?l9ooooo`05o`3jV_oo
ooooooooooooool007l01oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo
00?o001oooooooooool01oooool00ol0nY[oooooo`00o`05ooooo`04o`00Ool0nY[oooooo`00o`go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`;o0?ZJ00?oooooo`3jV_oo
ool00_ooool01?l00?ooooooooooool007l5ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o0?ZJ
ooooool00?l02Oooool01?l0nY[oooooooooool00?l2ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`08ooooo`03o`3jV_oooooooooo00?ooooo00?o
001oo`00ooooool02?ooool01?l0nY[oooooooooool00?l2ooooo`04o`00Oooooooo003oo`3jVP;o
003o2Oooool01?l0nY[oooooooooool007l2o`00o`[ooooo00Go0?ZJo`00oooooooo003oo`00O`06
ooooo`03o`3jV_oooooo003o00Sooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo0_l0nYX00ooooooo003oooooo`09ooooo`04o`3jV_oooooo
ooooo`00o`Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`07ooooo`03o`3jV_l00?oooooo00Cooooo00Go001oooooool0nY[oooooo`00
o`0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool3o`3jVPCooooo00Co
003ooooooooooooo001o1_ooool01?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0=ooooo`03o`3jV_l007oo003o00[o
oooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool02Oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00So
oooo0_l0nYX01?oooooo003oo`00ooooool3o`3jVP03ooooool00?oooooo00Wooooo00Go0?ZJoooo
ool007ooooooo`00o`0:ooooo`03o`3jV_l00?oooooo00;ooooo00?o001oooooooooool00oooool0
1?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00?oooooo`00ooooool0
2Oooool01Ol0nY[ooooooooooooooooo001o00Oooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00Oooooo00?o0?ZJo`00ool00?l01Oooool01?l007oo
0?ZJooooool00?l=ooooo`03o`00Oooooooooooo00kooooo00Co001ooooooooooooo0?ZJ1?ooool2
o`3jVPGooooo00Co003ooooooooooooo001o1Oooool01?l0nY[oooooooooool00?l7ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`3j
V_l00?oo003o00Wooooo00Co0?ZJoooooooooooo003o0_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`03
o`00Ool00?oooooo00Sooooo0_l0nYX01?oooooo003oo`00ooooool4o`3jVP03o`00oooooooooooo
00Wooooo00Go0?ZJooooool007ooooooo`00o`09ooooo`03o`3jV_oooooo003o00;ooooo00?o001o
ooooooooool01?ooool00ol0nY[oooooo`00o`08ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`;o0?ZJ0_l00?l:ooooo`04o`3jV_oooooo
ooooo`00O`Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`07ooooo`03o`3jV_l00?oooooo00Cooooo00Go001oooooool0nY[oooooo`00
o`0=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool0nYX00_l0nYX2ooooo`;o0?ZJ1Ooo
ool01?l00?ooooooooooool007l6ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00cooooo0_l0nYX2o`00o`[o
oooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool02Oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00Wo
oooo0ol0nYX01?l00?ooooooo`3jV_l0nYX2ooooo`03o`00oooooooooooo00Sooooo00?o0?ZJoooo
ool007l00_ooool00ol00?ooooooooooo`07ooooo`03o`3jV_l00?oooooo00;ooooo00?o001ooooo
ooooool00oooool01?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0_l0
0?l:ooooo`05o`3jV_ooooooooooooooool007l01oooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool01oooool00ol0nY[o003oooooo`05ooooo`05o`00
Ool0nY[oooooooooool00?l03?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;o
0?ZJ0oooool2o`3jVPGooooo00Co003ooooooooooooo001o1Oooool01?l0nY[oooooooooool00?l7
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0<
ooooo`04o`3jV_oooooo0?ZJo`00o`_ooooo00?o0?ZJooooool00?l00_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool02?ooool00ol0nY[ooooooooo
o`03ooooo`03o`00Ool00?oooooo00Wooooo0ol0nYX00ol00?ooooooo`3jVP02o`3jVP;o003o2ooo
ool01?l0nY[oooooo`00Ooooool2o`00o`Sooooo00?o0?ZJo`00ool00?l00_ooool00ol007oooooo
ooooo`04ooooo`03o`3jV_oooooo003o00Sooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00[ooooo00?o0?ZJooooooooool00_ooool2o`3jVP03o`00
oooooooooooo00Wooooo00Co0?ZJoooooooooooo001o2?ooool00ol0003oooooooooo`0Fooooo`00
:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooool00?l0
1Oooool01Ol007ooooooo`3jV_oooooo003o00gooooo00?o001oooooooooool03_ooool00ol007oo
ooooo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00Cooooo00?o003oooooool00?l00_ooool00ol007oo
ooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00_ooooo00Co0?ZJooooool0nY[o003o2oooool0
1_l0nY[oooooooooool00?ooooooo`00Oa7ooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`09ooooo`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool02Oooool6o`3jVPoooooo
00?o0?ZJo`00Ooooool00_ooool2o`00o`Kooooo00?o0?ZJo`00ool00?l00oooool00ol007oooooo
ooooo`03ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo00Co0?ZJooooool0nY[ooooo0ol0nYX00ol0
07oo003oooooo`0:ooooo`05o`3jV_ooooooooooooooool007l01oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool01oooool00ol0nY[o003oooooo`05
ooooo`05o`00Ool0nY[oooooooooool00?l03?ooool00ol007ooooooooooo`0>ooooo`06o`00Oooo
oooo0?ZJooooool0nY[ooooo0_l0nYX01ooooooo0?ZJoooooooooooo003oooooool00?l00oooool0
0ol007ooooooooooo`03ooooo`05o`3jV_ooooooooooooooool00?l01_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02oooool01Ol0nY[oooooo`3j
V_l0nY[o003o00_ooooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`00
Ool00?oooooo00Wooooo1ol0nYX3o`00o`_ooooo00?o0?ZJooooool007l00_ooool2o`00o`Oooooo
00?o0?ZJo`00ooooool00_ooool00ol007ooooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00[o
oooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[o003o00cooooo00Co0?ZJoooooooooooo001o2?ooool0
0ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo
00Kooooo00?o0?ZJo`00ooooool01Oooool01Ol007ooooooo`3jV_oooooo003o00gooooo00?o001o
ooooooooool03_ooool00ol007ooooooo`3jVP02ooooo`;o0?ZJ1?ooool4o`00o`;ooooo00?o001o
ooooooooool01?ooool01?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0:ooooo`;o0?ZJ0ol00?l;ooooo`06o`3jV_oo
ooooooooo`00oooooooo001o4Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Wo
oooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`09ooooo`03o`3jV_oooooooooo00;o
0?ZJ00?o003oooooooooool03Oooool00ol0nY[o001oooooo`02ooooo`;o003o1_ooool00ol0nY[o
003oooooo`03ooooo`03o`00Oooooooooooo00?ooooo00Co0?ZJoooooooooooo003o1oooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01oooool3o`3j
VP06ooooool0nY[o0?ZJo`3jV_l00?oo001o3Oooool01?l0nY[oooooooooool007l7ooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`06ooooo`;o0?ZJ
00?o003oooooooooool01?ooool01Ol007oo0?ZJoooooooooooo003o00cooooo00?o001ooooooooo
ool03_ooool01?l007ooooooo`3jV_ooool4o`3jVPCooooo0ol00?l3ooooo`03o`00Oooooooooooo
00?ooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0:ooooo`;o0?ZJ0ol00?l<ooooo`03o`3jV_oooooo
003o00;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00Sooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`09ooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX00_l0nYX00ol00?ooooooooooo`0;ooooo`03o`3jV_oooooo001o00;ooooo0_l00?l6
ooooo`03o`00ool0nY[o003o00?ooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool0
0?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`07ooooo`Go0?ZJ00?oooooo`3jV_l0nYX00_l00?l<ooooo`04o`3jV_ooooooooooo`00O`Sooooo
00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`04ooooo`?o0?ZJ00?o003oooooooooool01?ooool01Ol007ooooooo`3jV_oooooo003o00gooooo
00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`02ooooo`;o0?ZJ1?ooool00ol00?oooooo
o`00o`03ooooo`03o`00Oooooooooooo00Cooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`08ooooo`?o
0?ZJ1?l00?l;ooooo`06o`3jV_ooooooooooo`00oooooooo001o4Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Wooooo00?o0?ZJooooooooool00_ooool00ol00?oo001oooooo`0=
ooooo`03o`3jV_oooooo001o00oooooo00?o0?ZJo`00Ooooool00oooool01Ol00?oooooooooooooo
oooo0?ZJ00;ooooo00?o0?ZJo`00ooooool00oooool00ol007ooooooooooo`03ooooo`04o`3jV_oo
ooooooooo`00o`Oooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Kooooo0ol0nYX2ooooo`?o0?ZJ00?oooooo`00Ooooool03?ooool01?l0nY[ooooo
ooooool007l7ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`06ooooo`;o0?ZJ1oooool01Ol007oo0?ZJoooooooooooo003o00cooooo00?o001ooooo
ooooool03_ooool00ol007ooooooo`3jVP02ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`03o`00
o`?ooooo00?o001oooooooooool00oooool01Ol0nY[ooooooooooooooooo003o00Kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00[ooooo0_l0nYX3
o`00o`cooooo00?o0?ZJooooool00?l00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooo
oooo00Wooooo00?o0?ZJooooooooool00ol0nYX?ooooo`03o`3jV_oooooo001o00?ooooo00?o003o
ooooooooool01?ooool00ol0nY[o003oooooo`03ooooo`03o`00Oooooooooooo00Cooooo00Co0?ZJ
oooooooooooo003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01oooool8o`3jVP03o`00Oooooooooooo00_ooooo00Co0?ZJoooooooooooo001o
2?ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooo
oooooooo00Cooooo00Co0?ZJoooooooooooo003o1_ooool01Ol007ooooooo`3jV_oooooo003o00go
oooo00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`02ooooo`04o`3jV_oooooooooooooo
o`?o003o1Oooool00ol007ooooooooooo`04ooooo`05o`3jV_ooooooooooooooool00?l01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01_ooool0
1_l00?ooooooo`3jV_oooooo003oooooo`;o003o00?o001oooooooooool02Oooool01_l0nY[ooooo
ooooool00?ooooooo`00Oa7ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`09oooo
o`03o`3jV_oooooooooo00;ooooo00?o003oo`00Ooooool03oooool00ol007ooooooooooo`0=oooo
o`03o`3jV_l007oooooo00?ooooo00Co003ooooooooooooooooo1?l0nYX5ooooo`03o`00Oooooooo
oooo00?ooooo00Go0?ZJooooooooooooooooo`00o`06ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00Co
003ooooooooooooo001o3Oooool01?l0nY[oooooooooool007l7ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`05ooooo`;o0?ZJ00?o003ooooooooo
ool01Oooool01Ol007oo0?ZJoooooooooooo003o00cooooo00?o001oooooooooool03_ooool00ol0
07ooooooo`3jVP02ooooo`;o0?ZJ0_ooool00ol00?ooooooo`00o`03o`00o`?ooooo00?o001ooooo
ooooool00oooool01Ol0nY[ooooooooooooooooo003o00Kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00Oo0?ZJooooooooooooooooo`00
oooooooo0?ZJ00Go003o3?ooool00ol0nY[oooooo`00o`02ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`08ooooo`03o`3jV_oooooooooo00?ooooo
00?o003oooooooooool03_ooool00ol007ooooooooooo`0=ooooo`03o`3jV_oooooo001o00?ooooo
00Ko003oooooool00?ooooooo`3jV_ooool2o`3jVPGooooo00?o001oooooooooool01?ooool01?l0
nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX00ooooooo001oooooo`0<
ooooo`04o`3jV_ooooooooooo`00O`Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool02?l007ooooooooooool0nY[oooooo`3jV_oooooo0?ZJ0_ooool00ol00?oo
ooooooooo`04ooooo`03o`00Oooooooo0?ZJ00;ooooo00?o003oooooooooool02_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Ool0nY[ooooo00Gooooo0ol00?l6ooooo`03o`00Oooooooooooo00Co
oooo00Go0?ZJooooooooooooooooo`00o`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`02ooooo`06o`3jV_ooooooooooooooool00?oo0?ZJ1_oo
ool00ol007ooooooooooo`09ooooo`06o`3jV_ooooooooooo`00oooooooo001o4Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Wooooo00?o0?ZJooooooooool00_ooool00ol00?oo
001oooooo`0?ooooo`03o`00Oooooooooooo00gooooo0_l0nYX4ooooo`;o003o00?oooooo`3jV_oo
ool00ol0nYX5ooooo`03o`00Oooooooooooo00?ooooo00Go0?ZJooooooooooooooooo`00o`06oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06oooo
o`03o`3jV_oooooooooo00?ooooo00Co003ooooooooooooo001o3Oooool01?l0nY[oooooooooool0
07l7ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool01?l007oooooooooo
ool0nYX3ooooo`;o0?ZJ00?oooooo`00ooooool01_ooool01Ol007oo0?ZJoooooooooooo003o00co
oooo00?o001oooooooooool03_ooool00ol007ooooooo`3jVP02ooooo`03o`3jV_oooooooooo00Co
003o00?oooooo`00ooooool00oooool00ol007ooooooooooo`03ooooo`05o`3jV_oooooooooooooo
ool00?l01_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool00oooool00ol0nY[oooooooooo`02o`00o`;o0?ZJ0_l00?l00ooooooo003oo`00O`0<oooo
o`03o`3jV_oooooo003o00;ooooo00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX>
ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJooooooooool00_ooool00ol00?oo001oooooo`0?
ooooo`03o`00Oooooooooooo00gooooo00?o0?ZJooooool007l00oooool01?l00?ooooooo`00oooo
ool4o`3jVPGooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool00?l7ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`03o`3j
V_oooooooooo00;ooooo00Co0?ZJo`00oooooooo001o3_ooool00ol0nY[oooooo`00O`08ooooo`03
o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oo`3jV_l0nYX0
1Ol0nYX00ooooooo003oooooo`06ooooo`03o`00Oooooooo0?ZJ00;ooooo00?o003oooooooooool0
2_ooool00ol007ooooooooooo`0>ooooo`03o`00Ool0nY[ooooo00Gooooo00?o003oooooooooool0
1_ooool00ol007ooooooooooo`04ooooo`05o`3jV_ooooooooooooooool00?l01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool00_ooool3o`3jVP03
ooooool0nY[o0?ZJ00Kooooo00?o001oooooooooool02Oooool01_l0nY[oooooooooool00?oooooo
o`00Oa7ooooo00?o001oooooooooool00_l0nYX<ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJ
ooooooooool00oooool00ol00?oo001oooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o0?ZJ
ooooooooool00_ooool01?l0nY[o003oo`00ool0nYX2ooooo`03o`3jV_oooooooooo00Cooooo00?o
001oooooooooool00oooool01Ol0nY[ooooooooooooooooo003o00Kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooooooool0
0oooool01?l00?ooooooooooool007l=ooooo`04o`3jV_ooooooooooo`00O`Oooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo0?ZJ00Go0?ZJ00?oooooo`00
ool00?l01oooool01Ol007oo0?ZJoooooooooooo003o00cooooo00?o001oooooooooool03_ooool0
0ol007oo0?ZJooooo`04ooooo`Co003o1oooool00ol007ooooooooooo`03ooooo`05o`3jV_oooooo
ooooooooool00?l01_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool00_ooool3o`3jVP07ooooool00?oo0?ZJo`3jV_l00?ooooooo`00o`02ooooo`03
o`00Oooooooooooo00[ooooo00Ko0?ZJoooooooooooo003oooooool007l@ooooo`03o`00Oooooooo
oooo00;o0?ZJ3Oooool00ol007ooooooooooo`08ooooo`03o`3jV_oooooooooo00;ooooo00?o003o
o`00Ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`3jV_l007oooooo00?ooooo0_l00?l0
1Ooooooo0?ZJoooooooooooo0?ZJ00Gooooo00?o001oooooooooool01?ooool01?l0nY[ooooooooo
ool00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00Co003ooooooooooooo001o3_ooool00ol0nY[o
ooooo`00O`08ooooo`03o`000?oooooooooo01Kooooo000Rooooo`;o00001oooool00ol0003ooooo
ooooo`06ooooo`03o`00Ool0nY[o003o00;o0?ZJ1?ooool00ol00?ooooooooooo`05ooooo`03o`00
Oooooooo0?ZJ00;ooooo00?o003oooooooooool02_ooool00ol007ooooooooooo`0>ooooo`03o`00
Ool0nY[ooooo00Cooooo00?o003oooooooooool01oooool00ol007ooooooooooo`04ooooo`05o`3j
V_ooooooooooooooool00?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool00_ooool00ol0nY[oooooo`3jVP02o`3jVPOooooo00?o001ooooooooo
ool02_ooool01Ol0nY[oooooo`00oooooooo001o017ooooo00?o001oooooool0nYX00_l0nYX<oooo
o`03o`00Oooooooooooo00Sooooo00?o0?ZJooooooooool00_ooool00ol00?ooooooo`00O`0@oooo
o`03o`00Oooooooooooo00kooooo00?o0?ZJooooooooool00_ooool4o`3jVP03ooooool00?oo003o
00Kooooo00?o001oooooooooool00oooool01Ol0nY[ooooooooooooooooo003o00Kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJ
ooooooooool00_ooool01Ol00?oooooooooooooooooo001o00gooooo00Co0?ZJoooooooooooo001o
1oooool00ol0003oooooooooo`0?ooooo`;o00001_ooool00ol0003oooooooooo`06ooooo`03o`00
ool0nY[o0?ZJ00Go0?ZJ00?oooooo`00ool00?l01oooool01Ol007oo0?ZJoooooooooooo003o00co
oooo00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`04ooooo`?o003o2?ooool00ol007oo
ooooooooo`03ooooo`05o`3jV_ooooooooooooooool00?l01_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool6o`3jVP03o`00oooooooooooo
00?ooooo00?o001oooooooooool02_ooool01_l0nY[oooooooooool00?ooooooo`00Oa3ooooo00?o
001oooooooooool00_l0nYX=ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJooooooooool00_oo
ool00ol00?oo001oooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Co0?ZJo`00Oooooooooooo
1_l0nYX3o`00o`Gooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool00?l7ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`03
o`3jV_oooooooooo00;ooooo00Co003ooooooooooooo001o3_ooool00ol0nY[oooooo`00O`08oooo
o`03o`000?oooooooooo01Kooooo000Qooooo`04o`000?ooooooooooo`0000Kooooo00?o0000oooo
ooooool01_ooool01?l00?oo0?ZJo`00ool00?l2ool000?o003o00?oo`00ooooooooool01Oooool0
0ol007ooooooo`3jVP02ooooo`03o`00oooooooooooo00Sooooo00?o0?ZJooooool007l04?ooool0
0ol007oo0?ZJooooo`02ooooo`03o`00oooooooo003o00Wooooo00?o001oooooooooool01?ooool0
1Ol0nY[ooooooooooooooooo003o00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00;ooooo00Co0?ZJooooool0nY[o0?ZJ2?ooool00ol007oooooo
ooooo`0:ooooo`05o`3jV_ooooooooooo`00ool007l04Oooool01?l007ooooooo`3jV_ooool2o`3j
VP_ooooo00?o001oooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooo001o
013ooooo00?o001oooooooooool03_ooool01?l0nY[oooooooooooooool4o`3jVP03o`00oooooooo
003o00Oooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool00?l6ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`3jV_oo
oooooooo00;ooooo00Go003oooooooooooooooooo`00O`0>ooooo`03o`3jV_oooooo001o00Oooooo
00?o0000ooooooooool03_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00Ko
oooo00?o003oo`3jV_l00?l00ooo00000ol0nY[oo`00ool00002o`00o`Oooooo00Go001oo`3jV_oo
ooooooooo`00o`0:ooooo`03o`3jV_oooooo001o013ooooo00?o001oo`3jV_ooool00oooool3o`00
o`Wooooo00?o001oooooooooool01?ooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00?o0?ZJ
ooooool0nYX00ol0nYX6ooooo`03o`00Oooooooooooo00[ooooo00Ko0?ZJoooooooooooo003ooooo
ool007l@ooooo`03o`00Oooooooooooo00?o0?ZJ3?ooool00ol007ooooooooooo`08ooooo`03o`3j
V_oooooooooo00;ooooo00?o003oo`00Ooooool03oooool00ol007ooooooooooo`0?ooooo`03o`3j
V_oooooooooo00Go0?ZJ00Coooooo`00ool00?oo003o1Oooool00ol007ooooooooooo`04ooooo`04
o`3jV_ooooooooooo`00o`Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Kooooo00?o0?ZJooooooooool00oooool01?l00?ooooooooooool007l>
ooooo`;o0?ZJ00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`008Oooool01?l0
003oooooooooool00006ooooo`?o00001Oooool7ool00003o`00oooo003oo`0000;oo`001_ooool0
0ol007ooooooo`3jVP02ooooo`03o`00oooooooooooo00Oooooo0_l0nYX00ooooooo001oooooo`0?
ooooo`03o`00Ool0nY[ooooo00;ooooo0_l00?l:ooooo`03o`00Oooooooooooo00Cooooo00Go0?ZJ
ooooooooooooooooo`00o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`02ooooo`04o`3jV_oooooo0?ZJo`00o`Sooooo00?o001oooooooooool0
2_ooool01Ol0nY[oooooooooool00?oo001o017ooooo00Co001oooooool0nY[ooooo0_l0nYX;oooo
o`03o`00Oooooooooooo00Sooooo00?o0?ZJooooooooool00_ooool00ol00?ooooooo`00O`0@oooo
o`03o`00Oooooooooooo00kooooo00Co0?ZJoooooooooooo0?ZJ1?ooool2o`00o`Sooooo00?o001o
ooooooooool01?ooool01?l0nY[oooooooooool00?l6ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`05o`3jV_ooooooooooooooool00?l0
1?ooool00ol007ooooooooooo`0<ooooo`03o`3jV_oooooo001o00Gooooo0ol0000@ooooo`04o`00
0?ooooooooooo`0000Gooooo00?o0000ooooooooool01_ooool00ooo003o0?ZJo`00o`03ool00003
o`00oooo003oo`0000;oo`001oooool01Ol007oo0?ZJoooooooooooo003o00[ooooo00?o0?ZJoooo
ool007l04?ooool00ol007oo0?ZJooooo`02ooooo`?o003o2_ooool00ol007ooooooooooo`04oooo
o`05o`3jV_ooooooooooooooool00?l01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool00_ooool00ol0nY[oooooo`3jVP02o`3jVPOooooo00?o001o
ooooooooool02_ooool01_l0nY[oooooooooool00?ooooooo`00Oa3ooooo00Co001oooooool0nY[o
oooo0_l0nYX<ooooo`03o`00Oooooooooooo00Sooooo00Oo0?ZJooooooooooooooooo`00oooooooo
001o013ooooo00?o001oooooooooool03oooool00ol0nY[oooooo`3jVP03o`3jVP03ooooool00?oo
003o00;o003o1_ooool00ol007ooooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o
0?ZJooooooooool00_ooool01Ol00?oooooooooooooooooo001o00oooooo00?o0?ZJo`00Ooooool0
1oooool00ol0003oooooooooo`0Fooooo`008Oooool01?l0003oooooooooool00006ooooo`03o`00
0?oooooooooo00Kooooo00Ko001oool00?oo003oo`00o`00ooooool2ool000;ooooo00?oo`00oooo
ooooool01?ooool00ol007ooooooo`3jVP02ooooo`03o`00oooooooooooo00Kooooo00Go0?ZJoooo
ool0nY[oooooo`00O`0@ooooo`03o`00Ool0nY[ooooo00;ooooo00?o003oooooooooool02Oooool0
0ol007ooooooooooo`04ooooo`05o`3jV_ooooooooooooooool00?l01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool00_l0nYX2ooooo`;o003o2?oo
ool00ol007ooooooooooo`0:ooooo`05o`3jV_ooooooooooo`00ool007l04Oooool00ol007oooooo
o`3jVP02ooooo`;o0?ZJ2_ooool00ol007ooooooooooo`08ooooo`05o`3jV_ooooooooooooooool0
0?l00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Co001oo`3jV_oo
oooo0?ZJ3_ooool00ol007ooooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00Oooooooooooo00gooooo0_l0nYX7
ooooo`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00001Oooool3o`0000Kooooo1Ooo
00000oooooooo`00ool00004ool000Kooooo00Go001oo`3jV_ooooooooooo`00o`09ooooo`?o0?ZJ
00?o001oooooooooool03_ooool00ol007oo0?ZJooooo`02ooooo`03o`00oooooooooooo00[ooooo
00?o001oooooooooool01?ooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?oooooo`3j
V_l00?l02?ooool00ol007ooooooooooo`0:ooooo`06o`3jV_ooooooooooo`00oooooooo001o4?oo
ool00ol007ooooooo`3jVP02ooooo`;o0?ZJ2oooool00ol007ooooooooooo`08ooooo`07o`3jV_oo
ooooooooooooool00?ooooooo`00O`0@ooooo`03o`00Oooooooooooo00oooooo00Co0?ZJooooool0
nY[o0?ZJ1?ooool00ol00?ooooooooooo`06ooooo`03o`00Oooooooooooo00Cooooo00Co0?ZJoooo
oooooooo003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01_ooool00ol0nY[oooooooooo`02ooooo`05o`00ooooooooooooooooool007l03ooo
ool2o`3jVPGooooo1?l0000Hooooo`008Oooool01?l0003oooooooooool00006ooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool00oooool2ool000?ooooo00?oo`00ooooooooool00ooo
ool00ol007ooooooo`3jVP02ooooo`03o`00oooooooooooo00Kooooo00Go0?ZJooooool0nY[ooooo
o`00O`0@ooooo`05o`00Ool0nY[oooooooooool00?l03?ooool00ol007ooooooooooo`04ooooo`03
o`3jV_oooooooooo00;ooooo00?o003oooooooooool00oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00Co001ooooooooooooo0?ZJ0oooool00ol00?ooooooooooo`07oooo
o`03o`00Oooooooooooo00[ooooo00Go0?ZJoooooooooooo003oo`00O`0Aooooo`03o`00Oooooooo
0?ZJ00?ooooo00?o0?ZJooooooooool02?ooool00ol007ooooooooooo`08ooooo`05o`3jV_oooooo
ooooooooool00?l00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oo`3jV_l0nYX03oooool00ol007ooooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo
00?o0?ZJooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool01Oooool00ol0003oooooooooo`0>ooooo`04o`000?ooooooooooo`0000Go
oooo00?o0000ooooooooool01_ooool01_l007ooooooool00?ooooooo`00ooooo`;oo`000oooool0
0ooo003oooooooooo`04ooooo`05o`00Ool0nY[oooooooooool00?l02Oooool01?l0nY[oooooo`3j
V_l007l@ooooo`03o`00Ool0nY[ooooo00;ooooo00?o003oooooooooool02_ooool00ol007oooooo
ooooo`04ooooo`05o`3jV_ooooooooooooooool00?l01Oooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00Co001ooooooooooooooooo0_l0nYX00ooooooo003oooooo`08oooo
o`03o`00Oooooooooooo00[ooooo00Ko0?ZJoooooooooooo003oooooool007l@ooooo`03o`00Oooo
oooo0?ZJ00?ooooo0_l0nYX:ooooo`03o`00Oooooooooooo00Sooooo00Oo0?ZJoooooooooooooooo
o`00oooooooo001o013ooooo00?o001oooooooooool03oooool00ol0nY[oooooo`3jVP0>ooooo`03
o`00Oooooooooooo00Cooooo00Co0?ZJoooooooooooo003o1oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0nY[oooooooooo`02oooo
o`05o`00ooooooooooooooooool007l04?ooool00ol0nY[oooooooooo`06ooooo`03o`000?oooooo
oooo01Kooooo000Qooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o001oooooool0nYX00_ooool0
0ol00?ooooooooooo`04ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJo`00Ooooool03oooool0
1Ol0nY[ooooooooooooooooo003o00cooooo00?o001oooooooooool01?ooool00ol0nY[ooooooooo
o`02ooooo`03o`00oooooooooooo00?ooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`04o`00Ooooooooooooo`3jVP;ooooo0_l00?l9ooooo`03o`00Oooooooooooo00[ooooo
00Go0?ZJoooooooooooo003oo`00O`0Aooooo`03o`00Oooooooo0?ZJ00?ooooo00Go0?ZJoooooooo
ooooooooo`00o`06ooooo`03o`00Oooooooooooo00Sooooo00Go0?ZJooooooooooooooooo`00o`02
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo0?ZJo`3jVP0?
ooooo`03o`00Oooooooooooo00Cooooo00Co0?ZJoooooooooooo003o1_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0nY[ooooooooo
o`02ooooo`03o`00oooooooooooo00;ooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`05ooooo`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00001Oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00Cooooo00Coo`00oooooooooooooooo0_oo0005ooooo`05
o`00Ool0nY[oooooooooool00?l02Oooool01?l0nY[oooooo`3jV_l007l@ooooo`03o`00Ool0nY[o
oooo00;ooooo00?o003oooooooooool02_ooool00ol007ooooooooooo`04ooooo`05o`3jV_oooooo
ooooooooool00?l01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Go
001oooooooooooooooooo`3jVP02ooooo`03o`00oooooooooooo00Oooooo00?o001oooooooooool0
2_ooool01_l0nY[oooooooooool00?ooooooo`00Oa3ooooo00?o001oooooool0nYX00oooool2o`3j
VP;ooooo00?o003oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Oooooo00?o0?ZJoooo
ooooool00_ooool00ol00?ooooooo`00O`0@ooooo`03o`00Oooooooooooo00oooooo00?o001oo`3j
V_l0nYX03_ooool00ol007ooooooooooo`04ooooo`05o`3jV_ooooooooooooooool00?l01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool0
1Ol0nY[ooooooooooooooooo003o00Cooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`06ooooo`03o`000?oooooooooo01Kooooo000Rooooo`;o00001oooool00ol0003oooooooooo`06
ooooo`03o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ol007ooooooo`3jVP02
ooooo`03o`00oooooooooooo00Cooooo0ol0nYX2ooooo`03o`3jV_l007oooooo00oooooo00Go0?ZJ
ooooooooooooooooo`00o`0<ooooo`03o`00Oooooooooooo00Gooooo00Go0?ZJoooooooooooooooo
o`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
o`3jVP03ooooo`03o`00oooooooooooo00Sooooo00?o001oooooooooool02_ooool01Ol0nY[ooooo
ooooool00?oo001o017ooooo00?o001oooooool0nYX01?ooool00ol0nY[oooooooooo`02o`00o`03
ooooool00?oo003o00;ooooo00?o001oooooooooool02?ooool01Ol0nY[ooooooooooooooooo003o
00;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo0?ZJ
00oooooo00?o001oooooooooool01?ooool01?l0nY[oooooooooool00?l6ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`05o`3jV_oooooo
ooooooooool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool03oooool2o`0000Kooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`08ooooo`;oo`001Oooool01Ol007oo0?ZJoooooooooooo003o00Kooooo0ol0nYX2ooooo`03o`3j
V_l007oooooo00oooooo00?o001oo`3jV_ooool00_ooool00ol00?ooooooooooo`0:ooooo`03o`00
Oooooooooooo00Cooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX2ooooo`;o003o2Oooool00ol0
07ooooooooooo`0:ooooo`06o`3jV_ooooooooooooooool00?oo001o4?ooool00ol007ooooooo`3j
VP04ooooo`03o`3jV_oooooooooo00Ko003o0_ooool00ol007ooooooooooo`07ooooo`05o`3jV_oo
ooooooooooooool00?l00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oo`3jV_ooool03_ooool00ol007ooooooooooo`04ooooo`05o`3jV_ooooooooooooooool0
0?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01Oooool01?l0nY[oooooooooooooool2o`00o`Cooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Ko
oooo00?o001oooooooooool02Oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooo0?ZJ00;o
oooo00?o003oooooooooool01?ooool2o`3jVP?ooooo00?o0?ZJo`00Ool00?l03oooool01Ol0nY[o
oooooooooooooooo003o00cooooo00?o001oooooooooool01Oooool01Ol0nY[ooooooooooooooooo
003o00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
0?ZJ00;ooooo00?o003oooooooooool02Oooool00ol007ooooooooooo`0:ooooo`05o`3jV_oooooo
ooooooooool00?l04Oooool00ol007oo0?ZJooooo`04ooooo`03o`3jV_l00?oo003o00Go003o0_oo
ool00ol007ooooooooooo`08ooooo`05o`3jV_ooooooooooooooool00?l00_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`04ooooo`05o`3jV_ooooooooooooooool00?l01Oooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool01Ol0nY[ooooooooooooooooo003o
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`09ooooo`03ool00?oooooooooo
00?ooooo00Go001oo`3jV_ooooooooooo`00o`06ooooo`?o0?ZJ0_ooool00ol0nY[o001oooooo`0?
ooooo`05o`00Ool0nY[oooooooooool00?l03Oooool00ol007ooooooooooo`04ooooo`05o`3jV_oo
ooooooooooooool00?l01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00Co001ooooooooooooo0?ZJ0_ooool00ol00?ooooooooooo`08ooooo`03o`00Oooooooooooo00[o
oooo00Ko0?ZJooooooooooooooooo`00ool007l@ooooo`03o`00Oooooooo0?ZJ00Cooooo0_l0nYX7
o`00o`;ooooo00?o001oooooooooool01oooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool01?l0nY[oooooooooool00?l6ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool01?ooool00ol0nY[oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo
00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ol007ooooooo`3jVP02ooooo`03o`00
oooooooooooo00Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[o003oo`00o`0?ooooo`05o`3j
V_ooooooooooooooool00?l03?ooool00ol007ooooooooooo`05ooooo`05o`3jV_oooooooooooooo
ool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ool0nYX00_ooool00ol00?ooooooooooo`09ooooo`03o`00Oooooooooooo00[ooooo00Go0?ZJoooo
ooooooooooooo`00o`0Aooooo`03o`00Ool0nY[ooooo00Cooooo0ol0nYX2ooooo`03o`00oooooooo
003o00;ooooo00?o001oooooooooool02?ooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool01?ooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`04ooooo`03o`3jV_oooooooooo00Oooooo00?o001oooooooooool0
1Oooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`09ooooo`03ool00?oooooooooo00?ooooo00Go001oo`3jV_ooooooooooo`00o`06oooo
o`?o0?ZJ0_ooool2o`3jVP03o`00oooooooooooo00gooooo00Go0?ZJooooooooooooooooo`00o`0=
ooooo`03o`00Oooooooooooo00Cooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool01?l007ooooooo`3jV_l0nYX2ooooo`03o`00
oooooooooooo00Sooooo00?o001oooooooooool02_ooool01_l0nY[ooooooooooooooooo003oo`00
Oa3ooooo00?o001oooooool0nYX01?ooool3o`3jVP?o003o0_ooool01?l00?ooooooooooool007l9
ooooo`05o`3jV_ooooooooooooooool00?l00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`04o`3jV_oo
ooooooooo`00o`Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`03o`3j
V_oooooooooo00;ooooo00?o003oooooooooool00_ooool00ol007ooooooooooo`05ooooo`05o`3j
V_ooooooooooooooool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Ko
oooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01OoooooooomQ0Uooof42
1oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
2_ooool00ooo003oooooooooo`02ooooo`03o`00Ool0nY[ooooo00;ooooo00?o003oooooooooool0
0oooool00ol0nY[oooooo`00o`03o`00o`04o`3jV_l00?oo003oo`00o`gooooo00Go0?ZJoooooooo
ooooooooo`00o`0=ooooo`03o`00Oooooooooooo00Cooooo00?o0?ZJooooooooool00_ooool00ol0
0?ooooooooooo`02ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooo`3jVP02ooooo`03o`00oooooooooooo00Wooooo00?o001oooooooooool02oooool01Ol0
nY[oooooooooool00?oo001o013ooooo00?o001oo`3jV_ooool00oooool2o`00o`?o0?ZJ00Cooooo
o`00oooooooooooo0_l00?l00ooooooo001oooooo`08ooooo`05o`3jV_ooooooooooooooool00?l0
0_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`05ooooo`04o`3jV_ooooooooooo`00o`Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`04ooooo`?o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03
o`00Oooooooooooo00Gooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ol007oo
ooooo`3jVP02ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool00_l00?l2ooooo`04
o`3jV_oooooo003oo`00o`gooooo00Co0?ZJoooooooooooo003o3Oooool00ol007ooooooooooo`05
ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool00_ooool00ol007ooooooooooo`0;
ooooo`04o`3jV_ooooooooooo`00Oa7ooooo00?o001oo`3jV_ooool00_ooool00ol00?oooooooooo
o`09ooooo`03o`00Oooooooooooo00[ooooo00Co0?ZJoooooooooooooooo0_l00?l@ooooo`03o`00
Ool0nY[ooooo00;ooooo0_l00?l01_oooooo0?ZJooooool0nY[oooooo`3jVP?ooooo0_l00?l:oooo
o`04o`3jV_ooooooooooo`00o`?ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01Oooool01?l0nY[oooooooooool0
0?l5ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool00oooool00ol0nY[ooooooooo
o`04o`3jVPCooooo00?o001oooooooooool01Oooool01Ol0nY[ooooooooooooooooo003o00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:ooooo`03ool00?oooooooooo00;ooooo
00?o001oo`3jV_ooool00_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo00Co003o
00Co0?ZJooooool00?oo003o3Oooool01Ol0nY[ooooooooooooooooo003o00gooooo00?o001ooooo
ooooool01?ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o001ooooo
ooooool02oooool2o`3jVP;ooooo00?o0?ZJooooooooool03_ooool00ol007oo0?ZJo`3jVP02oooo
o`03o`00oooooooooooo00Wooooo00?o001oooooooooool02oooool00ol0nY[oooooooooo`02o`00
oa3ooooo00?o001oo`3jV_ooool00oooool2o`00o`03ooooool0nY[o0?ZJ00;ooooo00Ko0?ZJoooo
ool00?oo003oooooool007l9ooooo`05o`3jV_ooooooooooooooool00?l00_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`05ooooo`04o`3jV_ooooooooooo`00o`Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`04ooooo`Co0?ZJ0ol00?l3ooooo`03o`00Oooooooooooo00Gooooo00Go0?ZJoooooooo
ooooooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0
003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00[o
oooo00Ooo`00ooooooooooooooooo`00Oooooooo0?ZJ00;ooooo00?o003oooooooooool00oooool0
1?l0nY[oooooooooool00?l3ooooo`;o0?ZJ00?oooooo`00ooooool03?ooool01?l0nY[ooooooooo
ool00?l=ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJooooooooool00_ooool00ol00?oooooo
ooooo`02ooooo`03o`00Oooooooooooo00[ooooo1_l0nYX@ooooo`04o`00Ool0nY[oooooooooo`;o
003o2oooool00ol007ooooooooooo`0:ooooo`06o`3jV_ooooooooooooooool007oo003o4?ooool0
0ol007oo0?ZJooooo`02ooooo`03o`00oooooooooooo00?ooooo0ol0nYX3ooooo`03o`00oooooooo
oooo00Sooooo00Co0?ZJoooooooooooo003o0oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`05ooooo`04o`3jV_oo
ooooooooo`00o`Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`03ooooo`03o`3j
V_oooooooooo00;o0?ZJ00?oooooo`3jV_l00?l00oooool00ol007ooooooooooo`05ooooo`04o`3j
V_ooooooooooo`00o`Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:ooooo`03
ool00?oooooooooo00;ooooo00?o001oo`3jV_ooool00_ooool00ol00?ooooooooooo`02ooooo`03
o`3jV_oooooo003o00;o003o0_ooool01?l0nY[oooooo`00ool00?l=ooooo`05o`3jV_oooooooooo
ooooool00?l03Oooool00ol007ooooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o003o
ooooooooool00_ooool00ol007ooooooooooo`0;ooooo`?o0?ZJ00?oooooo`3jV_ooool03oooool0
0ol007oo0?ZJo`3jVP02ooooo`03o`00oooooooooooo00Wooooo00?o001oooooooooool02oooool0
1Ol0nY[ooooooooooooooooo003o013ooooo00?o001oo`3jV_ooool00_ooool2o`00o`;ooooo00?o
0?ZJooooool0nYX00_l0nYX01Ooooooo003oooooool00?oo001o00Wooooo00Go0?ZJoooooooooooo
ooooo`00o`02ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00Go0?ZJooooooooooooooooo`00o`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool00oooool7o`3jVP05o`00oooooooooooo
ooooool007l01oooool01Ol0nY[ooooooooooooooooo003o00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool02_ooool01ooo003ooooooooooooooooo001oooooool0nYX0
0_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooo003o00Cooooo0_l0nYX00ooooooo003o
ooooo`0<ooooo`04o`3jV_ooooooooooo`00o`gooooo00?o001oooooooooool01Oooool00ol0nY[o
ooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o001oooooooooool02_ooool00ol0nY[o
ooooooooo`03o`3jVQ3ooooo00Go001oo`3jV_ooooooooooo`00o`0<ooooo`03o`00Oooooooooooo
00_ooooo00Go0?ZJoooooooooooo001oo`00o`0@ooooo`03o`00Ool0nY[ooooo00;ooooo00?o003o
ooooooooool00oooool00ol0nY[oooooo`3jVP03ooooo`03o`00oooooooooooo00Sooooo00Co0?ZJ
oooooooooooo003o0oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`05ooooo`05o`3jV_ooooooooooooooool00?l0
1?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00?ooooo00Oo0?ZJooooool00?oo
003oo`3jV_oooooo0?ZJ00;o003o0_ooool00ol007ooooooooooo`05ooooo`04o`3jV_oooooooooo
o`00o`Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:ooooo`03ool00?oooooo
oooo00;ooooo00?o001oooooool0nYX00_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_oooooo
003oo`00o`?ooooo0_l0nYX00ooooooo003oooooo`0<ooooo`05o`3jV_ooooooooooooooool00?l0
3Oooool00ol007ooooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o003oooooooooool0
0_ooool00ol007ooooooooooo`0:ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX?ooooo`03o`00
Ool0nY[ooooo00;ooooo00?o003oooooooooool02Oooool00ol007ooooooooooo`0;ooooo`06o`3j
V_ooooooooooooooool007oo003o3oooool00ol007oo0?ZJooooo`02ooooo`03o`00oooooooooooo
00?ooooo0ol0nYX4ooooo`03o`00oooooooooooo00Oooooo00Go0?ZJooooooooooooooooo`00o`02
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Gooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool00oooool2o`3jVP?o003o0ol0nYX3ooooo`03o`00Oooo
oooooooo00Gooooo00Go0?ZJooooooooooooooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00[ooooo00Ooo`00ooooooooooooooooo`00Oooooooo0?ZJ00;o
oooo00?o003oooooooooool00oooool00ol0nY[oooooo`00o`04ooooo`05o`00Ool0nY[o0?ZJoooo
ool00?l03?ooool01?l0nY[oooooooooool00?l=ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`00Oooooooooooo00[ooooo00Co0?ZJ
oooooooooooo003o0_l0nYX01Ol00?ooooooo`00oooooooo003o00_ooooo00Go0?ZJoooooooooooo
ooooo`00o`0<ooooo`03o`00Oooooooooooo00_ooooo00So0?ZJoooooooooooo001oooooool00?oo
ooooo`00o`gooooo00?o001oo`3jV_ooool00_ooool00ol00?ooooooooooo`05ooooo`05o`3jV_oo
ooooooooooooool00?l02_ooool01?l0nY[oooooooooool00?l3ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Go
oooo00Go0?ZJooooooooooooooooo`00o`04ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool00oooool01?l0nY[oooooo`00ool00?l3ooooo`05o`3jV_l00?ooooooooooool007l01ooo
ool01?l0nY[oooooooooool00?l6ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
2_ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooo0?ZJ00;ooooo00?o003oooooooooool0
0_ooool01?l0nY[oooooo`00ool00?l3ooooo`?o0?ZJ0_l00?l<ooooo`04o`3jV_ooooooooooo`00
o`kooooo00?o001oooooooooool01Oooool01Ol0nY[ooooooooooooooooo003o00Cooooo00?o001o
ooooooooool02_ooool00ol0nY[oooooooooo`04o`3jVP03ooooool00?oooooo00cooooo00?o001o
o`3jV_ooool00_ooool00ol00?ooooooooooo`09ooooo`03o`00Oooooooooooo00_ooooo00So0?ZJ
ooooooooooooooooo`00Ool00?ooooooo`00o`gooooo00?o001oo`3jV_ooool00_ooool00ol00?oo
ooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o003oooooooooool01oooool01Ol0nY[o
oooooooooooooooo003o00;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool01Ol0nY[ooooooooooooooooo
003o00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`03ooooo`03o`3jV_oooooo
003o00;o003o00Coooooo`00ool0nY[o003o0_ooool00ol007ooooooooooo`05ooooo`05o`3jV_oo
ooooooooooooool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo
00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0:ooooo`07ool00?ooooooooooooooool007ooooooo`3jVP03ooooo`03o`00oooooooooooo00;o
oooo00?o0?ZJooooool00?l01?ooool01?l007ooooooo`3jV_ooool4o`00o`Wooooo00Co0?ZJoooo
oooooooo003o3Oooool00ol007ooooooooooo`05ooooo`03o`3jV_oooooooooo00;ooooo00?o003o
ooooooooool00_ooool00ol007ooooooooooo`0:ooooo`06o`3jV_oooooo003oooooool007oo003o
0_l0nYX3o`00o`_ooooo00Go0?ZJooooooooooooooooo`00o`0<ooooo`03o`00Oooooooooooo00_o
oooo00Go0?ZJoooooooooooo001oooooo`02o`3jVP03o`00oooooooooooo00_ooooo00Go001oo`3j
V_ooooooooooo`00o`08ooooo`;o0?ZJ0_ooool00ol007oo003oo`00o`08ooooo`04o`3jV_oooooo
ooooo`00o`?ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool01Oooool01?l0nY[oooooooooooooool2o`00o`?ooooo
00?o001oooooooooool01_ooool00ol0nY[oooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo
00?o0?ZJooooooooool00_l00?l3ooooo`05o`3jV_l00?ooooooooooool007l01_ooool01Ol0nY[o
oooooooooooooooo003o00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05oooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0:oooo
o`;oo`000oooool00ol007ooooooo`3jVP02ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJoooo
ool00?l01?ooool00ol007oo0?ZJo`3jVP02ooooo`?o003o2Oooool01?l0nY[oooooooooool00?l>
ooooo`03o`00Oooooooooooo00Gooooo00Co0?ZJoooooooooooooooo0_l00?l01?oooooo003ooooo
ool007l<ooooo`07o`3jV_ooooooooooo`00ool0nY[o003oo`3jVP05o`00o`[ooooo00Go001oo`3j
V_ooooooooooo`00o`0<ooooo`03o`00Oooooooooooo00_ooooo00So0?ZJooooooooooooooooo`00
Ool00?oo0?ZJo`00o`gooooo00?o001oo`3jV_ooool00_ooool00ol00?ooooooooooo`05ooooo`03
o`3jV_oooooo0?ZJ00;ooooo0_l00?l8ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01Oooool01?l0nY[oooooooooooooool2o`00o`Cooooo00?o001oooooooooool01Oooool0
0ol0nY[oooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX00ooooooo003oo`00o`03
ooooo`05o`3jV_l00?ooooooooooool007l01oooool01?l0nY[oooooooooool00?l6ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:ooo
ool2o`0000Oooooo00?o001oooooooooool02_ooool01ooo003ooooooooooooooooo001oooooool0
nYX00oooool01ol00?oooooooooooooooooo0?ZJooooool00?l01Oooool01?l007ooooooo`3jV_l0
nYX2ooooo`;o003o2Oooool00ol0nY[oooooo`00o`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0?ZJooooooooool00oooool2o`00o`;ooooo00?o001oooooooooool02Oooool2o`3jVP05ooooool0
0?ooooooo`00Ool00?l00_l0nYX01?oooooo003oooooool00?l:ooooo`03o`3jV_oooooooooo00;o
003o3?ooool00ol007ooooooooooo`0;ooooo`06o`3jV_ooooooooooo`00Ool0nY[ooooo0_l0nYX0
0ol00?ooooooooooo`0:ooooo`05o`3jV_ooooooooooooooool00?l02?ooool2o`3jVP;ooooo00?o
001oo`00ool00?l01oooool01?l0nY[oooooooooool00?l4ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Gooooo
00Co0?ZJoooooooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJoooooooo
ool01_ooool00ol007ooooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`Cooooo00Go0?ZJo`00
ool00?ooooooo`00O`06ooooo`05o`3jV_ooooooooooooooool00?l01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Cooooo0_l0000Iooooo`?o00001_ooool00ol007oooooooooo
o`0;ooooo`07ool00?ooooooooooooooool007ooooooo`3jVP02ooooo`03o`00oooooooooooo00;o
oooo00?o0?ZJooooool00?l01?ooool00ol007oo0?ZJo`3jVP02o`3jVP?o003o2Oooool01?l0nY[o
ooooooooool00?l>ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJooooooooool00_ooool3o`00
o`03ooooool007oooooo00_ooooo00Go0?ZJooooool00?ooooooo`3jVP02o`00o`05o`3jV_l00?oo
003oooooool00?l02_ooool01Ol007oo0?ZJoooooooooooo003o00cooooo00?o001oooooooooool0
2oooool01Ol0nY[ooooooooooooooooo001o00?o0?ZJ00?o003oooooooooool02_ooool01Ol007oo
0?ZJoooooooooooo003o00Wooooo0_l0nYX2ooooo`;o003o2?ooool01?l0nY[oooooooooool00?l3
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJooooooooool00_ooool2o`00o`?ooooo00?o001o
ooooooooool01Oooool2o`3jVPOooooo00?o001oooooooooool00_ooool2o`3jVP?o003o0oooool0
1Ol0nY[oooooo`00oooooooo001o00Oooooo00Co0?ZJoooooooooooo003o1_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Cooooo0ol0000Hooooo`00:oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00_ooooo00Koo`00oooooooooooo001oooooool0nYX3ooooo`07
o`00ooooooooooooooooool0nY[oooooo`00o`05ooooo`03o`00Oooooooooooo00;o0?ZJ0_ooool0
0ol00?ooooooooooo`07ooooo`03o`3jV_oooooo003o00kooooo00?o001oooooooooool01Oooool0
0ol0nY[oooooooooo`03ooooo`?o003o00?oooooo`00Ooooool02Oooool2o`3jVP07ooooool00?oo
ooooooooool007ooooooo`00o`03o`3jVP03ooooool00?oooooo00Wooooo00Co0?ZJoooooooooooo
003o3Oooool00ol007ooooooooooo`0;ooooo`07o`3jV_ooooooooooo`00Ool0nY[oooooo`00o`02
o`3jVP;o003o2_ooool01Ol0nY[ooooooooooooooooo003o00Wooooo00Ko0?ZJoooooooooooo001o
ooooool00?l7ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01Oooool00ol0
nY[oooooooooo`02ooooo`05o`00ooooooooooooooooool007l01oooool3o`3jVPOooooo00Ko001o
ooooooooooooooooo`3jV_ooool2o`00o`Gooooo00Go0?ZJooooool00?ooooooo`00O`06ooooo`05
o`3jV_ooooooooooooooool00?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo
00_ooooo00Ooo`00ooooooooooooooooo`00Oooooooo0?ZJ00;ooooo00?o003oooooooooool00_oo
ool00ol0nY[oooooo`00o`04ooooo`03o`00Oooooooooooo00;o0?ZJ0_ooool2o`00o`Sooooo00Co
0?ZJoooooooooooo003o3_ooool00ol007ooooooooooo`05ooooo`03o`3jV_oooooooooo00;ooooo
0ol00?l00ooooooo001oooooo`0;ooooo`03o`3jV_oooooo003o00;ooooo00?o001oo`00ool0nYX0
0_l0nYX00ooooooo003oooooo`09ooooo`05o`3jV_ooooooooooooooool00?l03?ooool00ol007oo
ooooooooo`0;ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00Go003oo`3jV_l0nY[oooooo`00o`0:
ooooo`05o`00Ool0nY[oooooooooool00?l02_ooool01Ol0nY[oooooooooool007oo003o00Sooooo
00Co0?ZJoooooooooooo003o0oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`3jV_oooooooooo00;o
oooo0_l00?l3ooooo`03o`00Oooooooooooo00?ooooo1?l0nYX7ooooo`03o`00Oooooooooooo00;o
oooo00?o0?ZJooooool00?l00_l00?l4ooooo`04o`3jV_l00?oo003oo`00O`Oooooo00Co0?ZJoooo
oooooooo003o1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000
ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0;oooo
o`06ool00?ooooooooooo`00Oooooooo0?ZJ0oooool01ol00?oooooooooooooooooo0?ZJooooool0
0?l01Oooool01Ol007oooooooooooooooooo0?ZJ00;ooooo0_l00?l8ooooo`03o`3jV_oooooo003o
00kooooo00?o001oooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`03o`00oooooooo001o
00[ooooo0_l0nYX01Ooooooo003ooooooooooooo001o00Cooooo00?o0?ZJooooool00?l02_ooool0
1?l0nY[oooooooooool00?l=ooooo`03o`00Oooooooooooo00_ooooo00So0?ZJoooooooooooo001o
o`3jV_oooooo003oooooo`;o0?ZJ00?o003oooooooooool02?ooool01Ol0nY[ooooooooooooooooo
003o00[ooooo00Go0?ZJooooool007ooooooo`00o`07ooooo`04o`3jV_ooooooooooo`00o`Cooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`04o`00ooooooooooooo`00O`Go
oooo0ol0nYX00ooooooo0?ZJooooo`06ooooo`03o`00Oooooooooooo00;o0?ZJ00?oooooo`00oooo
ool01_ooool01?l0nY[oooooo`00ool007l6ooooo`05o`3jV_ooooooooooooooool00?l01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Ooo`00ooooooooooooooooo`00
Oooooooo0?ZJ00;ooooo00?o003oooooooooool00_ooool00ol0nY[oooooo`00o`04ooooo`03o`00
Oooooooooooo00;o0?ZJ0_ooool2o`00o`Sooooo00Co0?ZJoooooooooooo003o3_ooool00ol007oo
ooooooooo`05ooooo`03o`3jV_oooooooooo00;ooooo0ol00?l00ooooooo001oooooo`0:ooooo`;o
0?ZJ00Koooooo`00ooooooooooooo`00Ooooool3o`3jVP;ooooo00?o003oooooooooool01oooool0
1Ol0nY[ooooooooooooooooo003o00cooooo00?o001oooooooooool02oooool01_l0nY[ooooooooo
oooooooo0?ZJooooo`;o003o0_l0nYX00ol00?ooooooooooo`08ooooo`05o`00Ool0nY[ooooooooo
ool00?l02_ooool2o`3jVP04ooooool007oo003oo`00o`Oooooo00Co0?ZJoooooooooooo003o0ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00Go003ooooooooooooooooo
o`00O`05ooooo`Co0?ZJ1oooool00ol007ooooooooooo`03o`3jVP04ooooool00?ooooooo`00o`Co
oooo00Co0?ZJooooool00?oo001o1oooool01?l0nY[oooooooooool00?l6ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Koo`00oooooooooooo001oooooool0
nYX3ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`05ooooo`04o`00Oooooooooooooooo
o`;o0?ZJ0_ooool00ol00?ooooooooooo`05ooooo`04o`3jV_l007ooooooo`00o`kooooo00?o001o
ooooooooool01_ooool00ol0nY[oooooooooo`05ooooo`03o`00ool007oooooo00Wooooo00Co0?ZJ
oooooooooooo003o0_ooool00ol007ooooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`Wooooo
00Co0?ZJoooooooooooo003o3Oooool00ol007ooooooooooo`0;ooooo`04o`3jV_ooooooooooo`3j
VPGooooo0_l0nYX00ol00?ooooooo`00o`07ooooo`04o`3jV_ooooooooooo`00o`_ooooo00?o0?ZJ
ooooool007l00_ooool00ol00?ooooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`04o`00ooooooooooooo`00O`Gooooo
0_l0nYX00ooooooo003oo`3jVP07ooooo`04o`00Oooooooo0?ZJo`3jVP;ooooo00?o003ooooooooo
ool01Oooool01?l0nY[oooooo`00ool007l6ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`07ool00?ooooooooooooooool007oooooo
o`3jVP02ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`05ooooo`05o`00Oooooooooooo
ooooool0nYX00oooool00ol00?ooooooooooo`06ooooo`03o`3jV_oooooo003o00oooooo00?o001o
ooooooooool01Oooool2o`3jVPKooooo0_l00?l9ooooo`?o0?ZJ00?oooooo`00ool00?l00_ooool0
0ol007ooooooooooo`02o`3jVP;ooooo00?o003oooooooooool01oooool00ol0nY[oooooooooo`02
o`00o`cooooo00?o001oooooooooool03?ooool01?l0nY[oooooooooool0nYX4ooooo`;o0?ZJ0ol0
0?l7ooooo`05o`3jV_ooooooooooooooool00?l02oooool01Ol0nY[oooooo`00Oooooooo003o00Oo
oooo00Co0?ZJoooooooooooo003o0oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`3jV_oooooooooo
00;ooooo0_l00?l2ooooo`04o`00Ooooooooooooooooo`Co0?ZJ00?oooooo`3jV_ooool01_ooool0
0ol007ooooooooooo`02o`3jVP03ooooool00?oo003o00Oooooo00?o0?ZJooooool00?l01oooool0
1?l0nY[oooooooooool00?l6ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_oo
ool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00_ooooo00Koo`00oooooooooooo001oooooool0nYX3ooooo`07o`00ooooooooooooooooool0
nY[oooooo`00o`05ooooo`04o`00Ooooooooooooooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`05
ooooo`04o`3jV_l007ooooooo`00o`kooooo00?o001oooooooooool01_ooool01?l0nY[ooooooooo
ool0nYX4ooooo`03o`00ool007oooooo00Sooooo0_l0nYX00ooooooo003oooooo`02ooooo`03o`00
Oooooooooooo00;ooooo00Co0?ZJoooooooooooo003o2Oooool00ol0nY[oooooo`00o`0>ooooo`03
o`00Oooooooooooo00cooooo00?o0?ZJooooool0nYX01_ooool01?l0nY[o003oo`00ool00?l7oooo
o`04o`3jV_ooooooooooo`00o`cooooo00Go0?ZJo`00Ooooooooooooo`00o`06ooooo`04o`3jV_oo
ooooooooo`00o`Cooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`00
oooooooo001o00Cooooo0_l0nYX3o`00o`04o`3jV_ooooooooooo`00o`Cooooo00?o001oooooool0
nYX00_ooool00ol00?ooooooooooo`06ooooo`04o`3jV_oooooo003oo`00o`Kooooo00Co0?ZJoooo
oooooooo003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Ooo`00
ooooooooooooooooo`00Oooooooo0?ZJ00?ooooo00Ko003ooooooooooooo0?ZJooooool00?l5oooo
o`03o`00Oooooooooooo00;ooooo00Co0?ZJoooooooooooo003o2?ooool00ol0nY[oooooo`00o`0?
ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooool0nYX01?ooool2o`00o`Wooooo0_l0nYX0
0ooooooo003oo`00o`03ooooo`05o`00Ooooooooooooooooool0nYX00_ooool2o`00o`Sooooo00Co
0?ZJoooooooooooo003o3Oooool00ol007ooooooooooo`0<ooooo`04o`3jV_ooooooooooo`3jVPCo
oooo0_l0nYX01?oooooo003oo`00ool00?l6ooooo`05o`3jV_ooooooooooooooool00?l02oooool0
1Ol0nY[oooooo`00Oooooooo003o00Oooooo00Co0?ZJoooooooooooo003o0oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00Co003ooooooooooooo001o0oooool2o`3jVP05
ooooool00?oo003oo`00ool0nYX00ol00?l3ooooo`03o`00Oooooooooooo00;o0?ZJ00?oooooo`00
ooooool01oooool00ol0nY[oooooo`00o`06ooooo`05o`3jV_ooooooooooooooool00?l01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool0
02_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`06ool00?oooooooooo
o`00Oooooooo0?ZJ0oooool01ol00?oooooooooooooooooo0?ZJooooool00?l01Oooool00ol007oo
ooooooooo`03ooooo`03o`3jV_oooooo003o00Oooooo00Co0?ZJo`00Oooooooo003o3_ooool00ol0
07ooooooooooo`06ooooo`04o`3jV_oooooo0?ZJo`3jVP?ooooo00?o0?ZJo`00ool007l02?ooool0
1Ol0nY[ooooooooooooooooo003o00?ooooo00?o001oooooooooool00_ooool3o`3jVP03ooooool0
0?oooooo00Kooooo00Co0?ZJo`00Oooooooo003o3_ooool00ol007ooooooooooo`0<ooooo`03o`3j
V_oooooo0?ZJ00Kooooo00?o0?ZJooooool00?l00_l00?l6ooooo`04o`3jV_ooooooooooo`00o`co
oooo00Go0?ZJo`00Ooooooooooooo`00o`06ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooo001o00;ooooo0ol0nYX2
o`00o`04ooooool00?oo003oo`3jVP;o003o1?ooool00ol007ooooooo`3jVP03o`00o`Sooooo00Co
0?ZJoooooooooooo003o1_ooool01?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Ko
oooo00?o001oooooooooool02oooool01ooo003ooooooooooooooooo001oooooool0nYX00oooool0
1_l00?ooooooooooool0nY[oooooo`00o`Gooooo00?o001oooooooooool00_ooool01Ol0nY[ooooo
oooooooooooo003o00Oooooo00?o0?ZJooooool00?l03oooool00ol007ooooooooooo`06ooooo`03
o`3jV_oooooo0?ZJ00Co0?ZJ00?oooooo`00ool00?l02?ooool2o`3jVP03ooooool00?oooooo00?o
oooo00Go001oooooooooooooooooo`3jVP02ooooo`03o`3jV_l00?oooooo00Oooooo00Co0?ZJoooo
oooooooo003o3Oooool00ol007ooooooooooo`0<ooooo`?o0?ZJ00?o001oooooooooool01?ooool0
1?l0nY[oooooooooool00?l6ooooo`04o`3jV_ooooooooooo`00o`cooooo00Go0?ZJooooool007oo
ooooo`00o`07ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0
nY[oooooooooo`03ooooo`07o`00ooooooooooooo`00Oooooooo0?ZJooooo`02o`3jVP05ooooool0
0?oo003oo`00ool0nYX00ol00?l3ooooo`07o`00Ooooooooooooo`3jV_l00?ooooooo`00o`08oooo
o`03o`3jV_oooooo003o00Kooooo00?o0?ZJooooooooool00_l00?l6ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Koo`00oooooooooooo001oooooool0nYX3
ooooo`06o`00ooooooooooooooooool0nY[o003o1_ooool00ol007ooooooooooo`03ooooo`04o`3j
V_ooooooooooo`00o`Kooooo00Co0?ZJo`00Oooooooo003o3_ooool00ol007ooooooooooo`07oooo
o`Oo0?ZJ00?oooooo`3jV_l00?l01oooool00ol0nY[oooooooooo`02o`00o`?ooooo00?o001ooooo
ooooool00_ooool3o`3jVP03ooooool00?oooooo00Kooooo00Co0?ZJo`00Oooooooo003o3_ooool0
0ol007ooooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Co0?ZJoooooooooooo003o1_oo
ool01?l0nY[oooooo`00ool00?l<ooooo`05o`3jV_l007ooooooooooool00?l01_ooool01?l0nY[o
ooooooooool00?l4ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol0
0?ooooooo`00O`02ooooo`;o0?ZJ0ol00?l2ooooo`05o`00ool0nY[oooooooooool00?l00oooool0
0ol007oo0?ZJooooo`03o`00o`Wooooo00?o0?ZJooooool00?l01_ooool01?l0nY[oooooooooool0
0?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02oooool01ooo003ooooooooo
oooooooo001oooooool0nYX00oooool01_l00?ooooooooooool0nY[oooooo`00o`Gooooo00?o001o
ooooooooool00oooool01?l0nY[oooooooooool00?l7ooooo`03o`3jV_oooooo003o00oooooo00?o
001oooooooooool01_ooool00ol0nY[oooooo`3jVP04o`3jVP04ooooool00?oo003oo`00o`Kooooo
00Go0?ZJooooooooooooooooo`00o`04ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00Coooooo`3j
V_oooooo003o1oooool00ol0nY[oooooo`00o`0>ooooo`03o`00Oooooooooooo00gooooo0_l0nYX0
0ol007ooooooooooo`04ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool01?l0nY[oooooooooool0
0?l<ooooo`05o`3jV_oooooo001oooooool00?l01oooool01?l0nY[oooooooooool00?l3ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Kooooo00?o0?ZJooooooooool01?ooool01?l00?ooooooo`00Ooooool3o`3j
VP03o`00oooooooo003o00;o003o00Co0?ZJo`00oooooooo003o0oooool01?l007ooooooo`3jV_l0
nYX2o`00o`Wooooo00?o0?ZJooooool00?l01_ooool00ol0nY[oooooooooo`02o`00o`Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02oooool01_oo003oooooooooool0
07ooooooo`3jVP?ooooo00Ko003oooooooooooooooooo`3jV_l00?l6ooooo`03o`00Oooooooooooo
00?ooooo00Co0?ZJoooooooooooo003o1_ooool01?l0nY[o001oooooool00?l>ooooo`03o`00Oooo
oooooooo00Oooooo1?l0nYX2ooooo`?o0?ZJ0_l00?l6ooooo`03o`3jV_oooooooooo00;o003o0ooo
ool00ol007ooooooooooo`04ooooo`;o0?ZJ00?oooooo`00ooooool01Oooool01?l0nY[o001ooooo
ool00?l>ooooo`03o`00Oooooooooooo00cooooo0ol0nYX7ooooo`;o0?ZJ00?oooooo`00ooooool0
1Oooool01?l0nY[oooooo`00ool00?l<ooooo`05o`3jV_l007ooooooooooool00?l01_ooool01?l0
nY[oooooooooool00?l4ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooool0nYX00oooool0
1Ol00?ooooooo`00Ool00?oo0?ZJ00;ooooo0ol00?l3ooooo`04o`3jV_ooooooooooo`00o`?ooooo
00Go001oo`3jV_l00?ooooooo`00o`0:ooooo`03o`3jV_oooooo003o00Kooooo00?o0?ZJooooool0
0?l02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Ooo`00oooooooo
ooooooooo`00Oooooooo0?ZJ00?ooooo00Ko003ooooooooooooo0?ZJooooool00?l5ooooo`03o`00
Oooooooooooo00?ooooo0_l0nYX00ooooooo003oooooo`06ooooo`03o`3jV_oooooo003o00oooooo
00?o001oooooooooool01_ooool6o`3jVP05ooooool0nY[o0?ZJo`3jV_l00?l01_ooool01Ol0nY[o
oooooooooooooooo003o00Cooooo00?o001oooooooooool00_ooool3o`3jVP03ooooool00?oooooo
00Gooooo00Co0?ZJo`00Oooooooo003o3_ooool00ol007ooooooooooo`0=ooooo`;o0?ZJ00?o001o
ooooooooool01?ooool3o`3jVP03o`00oooooooooooo00Cooooo00Co0?ZJoooooooooooo003o3?oo
ool2o`3jVP03o`00Oooooooo003o00Kooooo00Co0?ZJoooooooooooo003o1?ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`06ooooo`;o0?ZJ1Oooool00ol00?ooooooo`00o`02o`3jVP04ooooool00?oo003oo`00o`?o
oooo00?o0?ZJooooooooool00_l00?l2ooooo`06o`00Ool0nY[o0?ZJo`00oooooooo003o2Oooool0
0ol0nY[oooooo`00o`06ooooo`04o`3jV_ooooooooooo`00o`Oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool02oooool01_oo003oooooooooool007ooooooo`3jVP?ooooo
00Ko003ooooooooooooo0?ZJooooool00?l6ooooo`03o`00Oooooooooooo00?ooooo00Go0?ZJoooo
ooooooooooooo`00o`05ooooo`03o`3jV_l007oo003o00oooooo00?o001oooooooooool01oooool3
o`3jVPCooooo00?o0?ZJo`00Ool0nYX00_l00?l5ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o
001oooooooooool01Oooool00ol0nY[oooooo`00o`06ooooo`04o`3jV_l007ooooooo`00o`kooooo
00?o001oooooooooool03Oooool00ol0nY[o001oooooo`06ooooo`;o0?ZJ00?oooooo`00ooooool0
1Oooool00ol0nY[oooooo`00o`0>ooooo`04o`3jV_ooooooooooo`00o`Kooooo00Co0?ZJoooooooo
oooo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`06ooooo`?o0?ZJ0oooool4o`00o`04o`3jV_oooooo003o
o`00o`Gooooo00Go0?ZJooooooooooooooooo`00o`02ooooo`03o`00Ool0nY[o003o00cooooo00?o
0?ZJooooool00?l01_ooool00ol0nY[oooooo`00o`08ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03?ooool01_oo003oooooooooool007ooooooo`3jVP?ooooo00Ko003ooooooooo
oooo0?ZJooooool00?l5ooooo`03o`00Oooooooooooo00Cooooo00Co0?ZJoooooooooooo003o1_oo
ool00ol0nY[oooooo`00o`0?ooooo`03o`00Oooooooooooo00Oooooo0ol0nYX3ooooo`?o0?ZJ0_l0
0?l5ooooo`03o`3jV_oooooooooo00;o003o1?ooool00ol007ooooooooooo`04ooooo`;o0?ZJ00?o
003oooooooooool01?ooool01?l0nY[o001oooooool00?l>ooooo`03o`00Oooooooooooo00gooooo
00?o0?ZJooooool007l01_ooool3o`3jVP03ooooool00?oooooo00Cooooo00Co0?ZJoooooooooooo
003o3Oooool01?l0nY[o001oooooool00?l6ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01_ooool3o`3jVPCooooo0ol00?l2o`3jVP04ooooool00?oo003oo`00o`?ooooo00Go
0?ZJooooooooooooooooo`00o`02ooooo`04o`00Ool0nY[oooooo`00o`_ooooo00?o0?ZJooooool0
0?l01_ooool01?l0nY[oooooooooool00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00_ooooo00Koo`00oooooooooooo001oooooool0nYX3ooooo`06o`00oooooooo
ooooo`3jV_oooooo003o1_ooool00ol007ooooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Go
oooo00?o0?ZJo`00Ool00?l03oooool00ol007ooooooooooo`0?ooooo`04o`00Ool0nY[o003oo`00
o`Cooooo00Go0?ZJooooooooooooooooo`00o`04ooooo`03o`00Oooooooooooo00Gooooo0_l0nYX0
0ol00?ooooooooooo`04ooooo`03o`3jV_l007oo003o00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`06ooooo`;o0?ZJ00?o003oooooooooool01?ooool00ol0nY[oooooo`00o`0>
ooooo`04o`3jV_ooooooooooo`00o`Kooooo00?o0?ZJooooool00?l01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`07ooooo`?o0?ZJ0oooool3o`00o`03o`3jV_l00?oo003o00Kooooo00Go0?ZJoooooooooooooooo
o`00o`02ooooo`03o`3jV_oooooo003o00cooooo00Co0?ZJooooool00?oo003o1Oooool00ol0nY[o
ooooo`00o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool01_oo003o
ooooooooool007ooooooo`3jVP?ooooo00Go003ooooooooooooo0?ZJo`00o`06ooooo`03o`00Oooo
oooooooo00Cooooo00Co0?ZJoooooooooooo003o1Oooool01?l0nY[o001oooooool00?l?ooooo`03
o`00Oooooooooooo00Oooooo00?o0?ZJooooooooool00oooool3o`3jVP;o003o1Oooool01?l0nY[o
ooooooooool00?l5ooooo`03o`00Oooooooooooo00Cooooo0_l0nYX00ol00?ooooooooooo`04oooo
o`04o`3jV_l007ooooooo`00o`kooooo00?o001oooooooooool03Oooool00ol0nY[oooooo`00O`07
ooooo`;o0?ZJ00?oooooo`00ooooool01?ooool00ol0nY[oooooo`00o`0>ooooo`04o`3jV_l007oo
ooooo`00o`Kooooo00Co0?ZJoooooooooooo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool02_ooool01Ooo003ooooooooooooooooo001o00Wo
oooo0ol0nYX3ooooo`?o003o00Ko0?ZJooooool00?oo003oooooool00?l3ooooo`04o`3jV_oooooo
ooooooooo`;o003o00?oooooo`00Ool0nYX00_l00?l<ooooo`03o`3jV_l007oo003o00Gooooo00Co
0?ZJoooooooooooo003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo
00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0;ooooo`04ool00?ooooooooooo`00O`;ooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[o
ooooo`00o`06ooooo`03o`00Oooooooooooo00Cooooo00Co0?ZJoooooooooooo003o1Oooool00ol0
nY[o001oo`00o`0?ooooo`03o`00Oooooooooooo00oooooo00Co001oo`3jV_oooooo003o1?ooool0
0ol0nY[oooooooooo`02o`00o`Cooooo00?o001oooooooooool01Oooool2o`3jVP03o`00oooooooo
oooo00Cooooo00?o0?ZJo`00Ool00?l03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00Oooooo00?o0?ZJooooool00?l01?ooool01?l0nY[o001oooooool00?l>ooooo`05o`3jV_oo
ooooooooooooool00?l01Oooool00ol0nY[oooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0:ooooo`;oo`000oooool00ol007oooooo
ooooo`09ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Co001oooooool0nY[o003o2?ooool01ol0nY[o
oooooooooooooooo003oooooool0nYX00_l00?l=ooooo`03o`3jV_l007oo003o00Gooooo00?o0?ZJ
ooooool00?l02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00Koo`00
oooooooooooo001oooooool0nYX3ooooo`05o`00ooooooooooooo`3jV_l00?l01_ooool00ol007oo
ooooooooo`04ooooo`04o`3jV_ooooooooooo`00o`Gooooo00Co0?ZJo`00Oooooooo003o3oooool0
0ol007ooooooooooo`0>ooooo`05o`00Ool0nY[oooooooooool00?l01?ooool01?l0nY[oooooo`00
ool00?l5ooooo`03o`00Oooooooooooo00Cooooo0_l0nYX2o`00o`Gooooo00?o0?ZJo`00Ool00?l0
3oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo00?o0?ZJooooool00?l0
1Oooool00ol0nY[oooooo`00o`0?ooooo`04o`3jV_ooooooooooo`00o`Gooooo00Co0?ZJoooooooo
oooo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool02_ooool01Ooo003ooooooooooooooooo001o00Wooooo00?o0?ZJooooool0nYX00_l0nYX2
ooooo`;o003o00?o0?ZJo`00ool00?l01oooool01?l0nY[oooooooooooooool2o`00o`03o`00Ool0
nY[o003o00gooooo00?o0?ZJo`00Ool00?l01Oooool01?l0nY[oooooooooool00?l7ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:ooo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo00Coo`00oooooooooooo001o
0_ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_l00?oooooo00Kooooo00?o001ooooooooo
ool01?ooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_l007oo003o00oooooo00?o001ooooo
ooooool03oooool01Ol007oo0?ZJoooooooooooo003o00?ooooo00Co0?ZJooooool00?oo003o1Ooo
ool00ol007ooooooooooo`06ooooo`03o`3jV_oooooo003o00Gooooo00?o0?ZJo`00Ool00?l03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00?o0?ZJooooool00?l01?oo
ool01?l0nY[o001oooooool00?l>ooooo`05o`00Ool0nY[oooooooooool00?l01Oooool00ol0nY[o
ooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0:ooooo`;oo`000oooool00ol007ooooooooooo`09ooooo`?o0?ZJ0_ooool01?l007oo
ooooo`3jV_l00?l8ooooo`08o`3jV_ooooooooooooooool00?ooooooo`3jV_l00?l>ooooo`03o`3j
V_l007oo003o00Gooooo00?o0?ZJooooool00?l02?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00cooooo00Koo`00oooooooooooo001oooooool0nYX3ooooo`05o`00oooooooooooo
o`3jV_l00?l01_ooool00ol007ooooooooooo`05ooooo`03o`3jV_oooooo003o00Gooooo00Co0?ZJ
o`00Oooooooo003o3oooool00ol007ooooooooooo`0>ooooo`05o`00Oooooooo0?ZJooooool00?l0
0oooool00ol0nY[oooooooooo`02o`00o`Gooooo00?o001oooooooooool01Oooool00ol0nY[ooooo
o`00o`05ooooo`03o`3jV_l007oo003o00oooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`06ooooo`03o`3jV_oooooo003o00Gooooo00?o0?ZJooooool00?l03oooool01?l0nY[ooooo
ooooool00?l5ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00Wooooo00?oo`00oooooooo00000_ooool00ol0
07ooooooooooo`0:ooooo`;o0?ZJ0oooool00ol007oo0?ZJo`00o`08ooooo`03o`3jV_oooooooooo
00;ooooo00Co003oo`00Ool0nY[o003o3Oooool01?l0nY[o001oooooool00?l4ooooo`04o`3jV_oo
ooooooooo`00o`Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`00
0?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02ooo
ool01?oo003oooooooooool007l2ooooo`08o`3jV_ooooooooooooooool00?ooooooo`3jV_l00?l7
ooooo`03o`00Oooooooooooo00Gooooo00?o0?ZJooooool00?l01Oooool00ol0nY[o001oo`00o`0?
ooooo`03o`00Oooooooooooo00oooooo00Co001oooooool0nY[ooooo0_l00?l2ooooo`03o`3jV_oo
oooo003o00Kooooo00?o001oooooooooool01_ooool00ol0nY[oooooo`00o`05ooooo`03o`3jV_l0
07oo003o00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`03o`3jV_oo
oooo003o00Cooooo00Co0?ZJo`00Oooooooo003o3_ooool01Ol007oo0?ZJoooooooooooo003o00Go
oooo00?o0?ZJooooool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool02_ooool00ooo003oooooool00002ooooo`03o`00Oooooooooooo00[o
oooo0_l0nYX2ooooo`03o`00Ool0nY[ooooo00Wooooo00So0?ZJooooooooooooooooo`00oooooooo
0?ZJo`00o`kooooo00?o0?ZJo`00Ool00?l01Oooool00ol0nY[oooooo`00o`08ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool03?ooool01_oo003oooooooooool007ooooooo`3jVP?o
oooo00Co003oooooool0nY[o003o1oooool00ol007ooooooooooo`05ooooo`04o`3jV_oooooooooo
o`00o`Cooooo00?o0?ZJo`00Ool00?l04?ooool00ol007ooooooooooo`0>ooooo`04o`00Oooooooo
0?ZJooooo`;o003o0_ooool00ol0nY[oooooo`00o`02o`00o`Gooooo00?o001oooooooooool01Ooo
ool01?l0nY[oooooo`00ool00?l4ooooo`03o`3jV_l007oo003o00oooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`06ooooo`03o`3jV_oooooo003o00Gooooo00?o0?ZJooooool00?l0
3oooool01?l0nY[oooooooooool00?l5ooooo`03o`3jV_oooooo003o00Gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Wooooo00?oo`00oooooooo
00000_ooool00ol007ooooooooooo`0:ooooo`;o0?ZJ0oooool00ol007oo0?ZJooooo`08ooooo`;o
0?ZJ0oooool00ol00?oo0?ZJo`00o`0>ooooo`04o`3jV_l007ooooooo`00o`Cooooo00Co0?ZJoooo
oooooooo003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000
ooooooooool05_ooool002_ooooo0_l00006ooooooooool0Goooo`06ooooo`;o00006Oooool3o`00
00Kooooo00?o001oooooooooool03?ooool01_oo003oooooooooool007ooooooo`3jVP?ooooo00Co
003oooooool0nY[o003o1oooool00ol007ooooooooooo`05ooooo`;o0?ZJ00?oooooo`00ooooool0
0oooool00ol0nY[o001oo`00o`0@ooooo`03o`00Oooooooooooo00kooooo00Co001oooooool0nY[o
oooo1?l00?l00ol0nY[oooooo`00o`07ooooo`03o`00Oooooooooooo00Gooooo00Co0?ZJooooool0
0?oo003o1?ooool00ol0nY[o001oo`00o`0?ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool01oooool00ol0nY[o003oooooo`04ooooo`03o`3jV_oooooo003o00oooooo00Go0?ZJoooo
ooooooooooooo`00o`04ooooo`03o`3jV_oooooo003o00Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Wooooo00?oo`00oooooooo00000_ooool0
0ol007ooooooooooo`0;ooooo`?o0?ZJ00?oooooo`3jV_ooool02_ooool01ol0nY[ooooooooooooo
oooo003oo`3jV_l00?l03_ooool01?l0nY[o001oooooool00?l4ooooo`04o`3jV_ooooooooooo`00
o`Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`?o00006?ooool002_o
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0;ooooo`04ool00?ooooooooooo`00
O`;ooooo00So0?ZJooooooooooooooooo`00oooooooo0?ZJo`00o`Oooooo00?o001oooooooooool0
1Oooool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_l007oo003o00oooooo00?o001ooooooooo
ool03oooool01Ol007ooooooooooool0nY[ooooo00;o003o00?o0?ZJo`00ool00?l01oooool00ol0
07ooooooooooo`06ooooo`04o`3jV_ooooooooooo`00o`?ooooo00?o0?ZJooooool00?l04?ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJo`00ooooool00oooool0
0ol0nY[o001oo`00o`0?ooooo`04o`00Ool0nY[oooooooooo`;o003o1?ooool00ol0nY[oooooo`00
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`09ooooo`04ool00?ooooooooooool000;ooooo00?o001oooooooooool03?ooool00ol0nY[ooooo
o`3jVP0;ooooo`03o`3jV_oooooooooo00;ooooo00?o003oo`3jV_l00?l03_ooool01?l0nY[o001o
ooooool00?l3ooooo`04o`3jV_ooooooooooo`00o`Sooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol0
07ooooooooooo`0<ooooo`06ool00?ooooooooooo`00Oooooooo0?ZJ0oooool01?l00?ooooooo`3j
V_l00?l7ooooo`03o`00Oooooooooooo00Gooooo0_l0nYX00ooooooo003oooooo`03ooooo`03o`3j
V_l007oo003o013ooooo00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX2ooooo`;o
003o00?o0?ZJooooool00?l01oooool00ol007ooooooooooo`06ooooo`03o`3jV_oooooo003o00Co
oooo00?o0?ZJo`00Ool00?l03oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Oo
oooo00?o0?ZJo`00ooooool01?ooool00ol0nY[oooooo`00o`0?ooooo`05ool00?l0nY[ooooooooo
ool00?l01?ooool00ol0nY[oooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`09ooooo`06ool00?ooooooo`00ool00?oooooo001o3_oo
ool4o`3jVP_ooooo00Oo0?ZJooooooooooooooooo`00ool0nY[o003o00kooooo00Co0?ZJo`00Oooo
oooo003o1?ooool00ol0nY[oooooo`00o`08ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00cooooo00?oo`00ooooool007l00_ooool00ol0nY[oooooooooo`02ooooo`03
o`00ool0nY[o003o00Oooooo00?o001oooooooooool01Oooool00ol0nY[oooooooooo`02o`00o`?o
oooo00?o0?ZJo`00Ool00?l03oooool00ol007ooooooooooo`0?ooooo`04o`00Ooooooooooooo`3j
VP?ooooo00?o0?ZJo`00ool00?l01oooool00ol007ooooooooooo`07ooooo`03o`3jV_oooooo003o
00?ooooo00?o0?ZJooooool00?l04?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00Sooooo00?o0?ZJo`00ool00?l00oooool00ol0nY[o001oo`00o`0?ooooo`03o`00Oooo003o0?ZJ
00;ooooo00?o003oooooooooool00_ooool00ol0nY[oooooo`00o`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`09ooooo`03ool00?oooooooooo
00;oo`0000?oooooo`00Ooooool03oooool00ol007ooooooooooo`0:ooooo`06o`3jV_oooooooooo
ooooool00?oo0?ZJ3oooool01?l0nY[o001oooooool00?l3ooooo`04o`3jV_ooooooooooo`00o`So
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0<ooooo`06ool00?ooooooooooo`00
Oooooooo0?ZJ1?ooool00ol00?oo0?ZJo`00o`07ooooo`03o`00Oooooooooooo00Kooooo00Co0?ZJ
ooooool00?oo003o0oooool00ol0nY[o001oo`00o`0@ooooo`03o`00Oooooooooooo00kooooo00Co
001ooooooooooooo0?ZJ0oooool00ol00?oo0?ZJo`00o`08ooooo`03o`00Oooooooooooo00Kooooo
00?o0?ZJooooool00?l00oooool01?l0nY[oooooo`00Ool00?l?ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool01oooool00ol0nY[oooooo`00o`03ooooo`04o`3jV_l007ooooooo`00
o`oooooo00Goo`00o`3jV_ooooooooooo`00o`04ooooo`03o`3jV_oooooo003o00Gooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Wooooo00?oo`00
ooooooooool00_oo00000ol007ooooooooooo`0<ooooo`04o`3jV_oooooo0?ZJo`00O`_ooooo0_l0
nYX2ooooo`03o`00ool0nY[ooooo00oooooo00Co0?ZJoooooooooooo003o0oooool00ol0nY[ooooo
o`00o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooo
ooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00?o
o`00ooooool007l00_ooool00ol0nY[oooooooooo`02ooooo`03o`00ool0nY[o003o00Oooooo00?o
001oooooooooool01_ooool01?l0nY[oooooooooool00?l3ooooo`03o`3jV_l007oo003o00oooooo
00?o001oooooooooool03oooool01?l007ooooooooooool0nYX3ooooo`03o`3jV_oooooooooo00Oo
oooo00?o001oooooooooool01oooool01?l0nY[oooooo`00ool00?l2ooooo`03o`3jV_oooooo003o
013ooooo0_oo000?ooooo`03o`00Oooooooooooo00Sooooo00?o0?ZJooooool00?l00oooool00ol0
nY[o001oo`00o`0?ooooo`03o`00Oooo003o0?ZJ00;ooooo00?o003oooooooooool00_ooool00ol0
nY[oooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`09ooooo`07ool00?oooooooooooooooooo003oooooo`00O`0@ooooo`03o`00Oooo
oooooooo00[ooooo00Ko0?ZJooooooooooooooooo`3jV_l007l?ooooo`04o`3jV_l007ooooooo`00
o`?ooooo00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo
00cooooo00Koo`00oooooooooooo001oooooool0nYX4ooooo`03o`00ool0nY[o003o00Oooooo00?o
001oooooooooool01_ooool01?l0nY[oooooooooool00?l3ooooo`03o`3jV_l007oo003o013ooooo
00?o001oooooooooool03_ooool01?l007ooooooooooool0nYX3ooooo`;o0?ZJ00?o003ooooooooo
ool01_ooool00ol007ooooooooooo`06ooooo`04o`3jV_ooooooooooo`00o`;ooooo00Co0?ZJoooo
ool007oo003o3oooool3ool000oooooo00?o001oooooooooool01oooool00ol0nY[oooooo`00o`03
ooooo`03o`3jV_l007oo003o013ooooo00Goo`00o`3jV_ooooooooooo`00o`04ooooo`03o`3jV_oo
oooo003o00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00Sooooo00Coo`00oooooooooooooooo0_oo00000ol007ooooooooooo`0<ooooo`04o`3j
V_ooooooooooo`00O`_ooooo0_l0nYX2ooooo`03o`00ool0nY[ooooo00oooooo00Co0?ZJoooooooo
oooo003o0oooool00ol0nY[oooooo`00o`08ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00cooooo00?oo`00ooooool007l00_ooool00ol0nY[oooooooooo`02ooooo`03
o`00ool0nY[ooooo00Oooooo00?o001oooooooooool01_ooool01Ol0nY[ooooooooooooooooo003o
00;ooooo00?o0?ZJo`00Ool00?l03oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00;o0?ZJ00?oooooo`3jV_ooool02Oooool00ol007ooooooooooo`07ooooo`07o`3jV_oooooooooo
o`00oooooooo0?ZJooooo`02o`00oa3ooooo0ooo000>ooooo`03o`00Oooooooooooo00Sooooo00?o
0?ZJooooool00?l00oooool00ol0nY[o001oo`00o`0?ooooo`;oo`0000Co0?ZJoooooooooooo003o
0oooool01?l0nY[oooooooooool00?l5ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`09ooooo`07ool00?oooooooooooooooooo003oooooo`00O`0@
ooooo`03o`00Oooooooooooo00_ooooo00Go0?ZJoooooooooooo0?ZJo`00O`0@ooooo`04o`3jV_oo
ooooooooo`00o`;ooooo00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00cooooo00Koo`00oooooooooooo001oooooool0nYX4ooooo`03o`00ool0nY[o003o
00Oooooo00?o001oooooooooool01_ooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJ
o`00Ool00?l04?ooool00ol007ooooooooooo`0>ooooo`05o`00Ooooooooooooo`3jV_ooool01?l0
nYX9ooooo`03o`00Oooooooooooo00Kooooo00Co0?ZJoooooooooooo003o0_ooool00ol0nY[o003o
o`00o`0@ooooo`?oo`003oooool00ol007ooooooooooo`08ooooo`03o`3jV_l00?oooooo00;ooooo
00?o0?ZJo`00Ool00?l03_ooool01?oo003oooooool00?oo0003ooooo`07o`00oooooooooooooooo
ool0nY[oooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`08ooooo`03ool00?oooooooooo00;ooooo00?oo`00o`00Ooooool04?ooool0
0ol007ooooooooooo`0:ooooo`05o`3jV_ooooooooooo`00ool0nYX04?ooool01?l0nY[ooooooooo
ool00?l3ooooo`03o`3jV_l00?oo003o00Sooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03?ooool00ooo003oooooo`00O`02ooooo`03o`3jV_oooooooooo00;ooooo00?o
003oo`3jV_ooool01oooool00ol007ooooooooooo`06ooooo`05o`3jV_ooooooooooooooool00?l0
0_ooool00ol0nY[o001oo`00o`0?ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
1?l0nYX:ooooo`03o`00Oooooooooooo00Oooooo00Ko0?ZJoooooooooooo003oooooool0nYX3o`00
o`oooooo0_oo00000oooooooo`00ooooo`0=ooooo`03o`00Oooooooooooo00Wooooo00?o0?ZJo`00
ool00?l00_ooool00ol0nY[o001oo`00o`0<ooooo`Koo`000_ooool01ol00?oooooooooooooooooo
0?ZJooooool00?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool02Oooool00ooo003oooooooooo`02ooooo`03ool00?l007oooooo00oooooo00?o
001oooooooooool02oooool01Ol0nY[oooooooooool0nY[o001o013ooooo00Co0?ZJoooooooooooo
003o0_ooool00ol0nY[oooooo`00o`09ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool03?ooool01_oo003oooooooooool007ooooooo`3jVPGooooo00?o0?ZJo`00ooooool01_ooool0
0ol007ooooooooooo`07ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJo`00Ool00?l04?oo
ool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooooooo`?o0?ZJ2oooool00ol007oooooo
ooooo`06ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJo`00ool00?l04?ooool2ool00003
oooooooo003ooooo00gooooo00?o001oooooooooool02?ooool00ol0nY[o003oo`00o`02ooooo`03
o`3jV_l007oo003o00gooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`07o`00oooooooooooo
ooooool0nY[oooooo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00;ooooo00?oo`00o`00Ooooool04?oo
ool00ol007ooooooooooo`0:ooooo`05o`3jV_ooooooooooo`3jV_l007l04?ooool01?l0nY[ooooo
ooooool00?l3ooooo`03o`3jV_l00?oooooo00Sooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo
00?o001oooooooooool03?ooool00ooo003oooooo`00O`02ooooo`03o`3jV_oooooooooo00;ooooo
00?o003oo`3jV_ooool01oooool00ol007ooooooooooo`06ooooo`09o`3jV_ooooooooooooooool0
0?ooooooo`3jV_oooooo003o013ooooo00?o001oooooooooool03oooool01?l007oooooooooooooo
ool2o`3jVP_ooooo00?o001oooooooooool01oooool02Ol0nY[oooooooooool00?ooooooo`3jV_l0
0?ooooooo`00O`0?ooooo`04ool00?l007ooooooool000kooooo00?o001oooooooooool02Oooool0
2?l0nY[oooooo`00oooooooo0?ZJooooool007oo003o3?ooool3ool00003o`00Ooooooooo`0000?o
oooo00Ko003ooooooooooooo0?ZJooooool00?l6ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`09ooooo`03ool00?oooooooooo00;ooooo00?oo`00
o`00Ooooool03oooool00ol007ooooooooooo`0;ooooo`05o`3jV_oooooo0?ZJo`3jV_l007l04?oo
ool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_oooooo003o00Wooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0<ooooo`06ool00?ooooooooooo`00Oooooooo0?ZJ1Oooool00ol0
nY[oooooooooo`06ooooo`03o`00Oooooooooooo00Oooooo00Wo0?ZJooooooooooooooooo`00oooo
oooo0?ZJo`00Ool00?l04?ooool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooooooo`?o
0?ZJ2oooool00ol007ooooooooooo`07ooooo`08o`3jV_ooooooooooo`00oooooooo0?ZJooooool0
07l?ooooo`?oo`0000?oooooool00?ooool03Oooool00ol007ooooooooooo`08ooooo`08o`3jV_oo
oooo003oo`00oooooooo0?ZJo`00Ool00?l=ooooo`?oo`0000?o001oool00?oo00000_ooool01ol0
0?oooooooooooooooooo0?ZJooooool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool02?ooool00ooo003oooooooooo`02ooooo`03ool00?l0
07oooooo013ooooo00?o001oooooooooool02oooool3o`3jVP03o`00Oooooooooooo00kooooo00Co
0?ZJoooooooooooo003o0oooool00ol0nY[o003oooooo`08ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00cooooo00?oo`00ooooool007l00_ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_l00?oooooo00Oooooo00?o001oooooooooool01oooool02?l0nY[ooooooooo
ool00?ooooooo`3jV_oooooo003o4?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool01oooool01_l0nY[oooooooooool00?ooooooo`3jVP;ooooo00?o
001oooooooooool03?ooool2ool00004o`00Ooooooooooooool000gooooo00?o001oooooooooool0
2Oooool02?l0nY[oooooo`00ool00?oo0?ZJooooool007oo003o3?ooool01ooo003oooooooooool0
07ooooooool00?l0nYX00_ooool01_l00?ooooooooooool0nY[oooooo`00o`Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo00?oo`00oooo
ooooool00oooool00ooo003o001oooooo`0?ooooo`03o`00Oooooooooooo00_ooooo00Go0?ZJoooo
ool0nY[o0?ZJo`00O`0@ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0?ZJooooool00?l02Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00Koo`00oooooooooooo001o
ooooool0nYX5ooooo`03o`3jV_oooooooooo00Kooooo00?o001oooooooooool01oooool02Ol0nY[o
oooooooooooooooo003oooooool0nY[o001oo`00o`0@ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool00_ooool00ol0nY[oooooooooo`0:ooooo`03o`00Oooooooooooo00Oooooo00So
0?ZJoooooooooooo003oo`3jV_l00?ooooooo`00O`kooooo0_oo00001?l007oooooooooooooo000>
ooooo`03o`00Oooooooooooo00Sooooo00So0?ZJoooooooooooo003oooooool0nY[o001oo`00o`co
oooo1?oo00000ol007ooooooool00002ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`07
ooooo`;oo`001Oooool00ooo003oooooooooo`0?ooooo`03o`00Oooooooooooo00_ooooo0ol0nYX0
0ol007ooooooooooo`0>ooooo`;o0?ZJ0_ooool01Ol00?ooooooooooool0nY[o003o00Wooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool00ooo003oooooo`00O`02
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool00ol007ooooooooooo`07
ooooo`08o`3jV_ooooooooooooooool00?oo0?ZJooooool00?l@ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`08ooooo`05o`3jV_ooooooooooo`00
ool0nYX00_ooool00ol007ooooooooooo`0<ooooo`03ool00?oooooo001o00;ooooo0_oo000<oooo
o`03o`00Oooooooooooo00Wooooo00Oo0?ZJoooooooooooo003oo`3jV_oooooo003o00gooooo00Co
o`00oooooooooooo001o0_ooool01?oo003oooooooooool00?l2ooooo`03o`3jV_oooooo003o00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00So
oooo00?oo`00ooooooooool00oooool00ooo003o001oooooo`0?ooooo`03o`00Oooooooooooo00co
oooo00Co0?ZJoooooooooooo001o4?ooool01?l0nY[oooooooooool00?l2ooooo`03o`3jV_l00?oo
oooo00Wooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0<ooooo`06ool00?oooooo
ooooo`00Oooooooo0?ZJ1Oooool00ol0nY[oooooooooo`06ooooo`03o`00Oooooooooooo00Oooooo
00Wo0?ZJooooooooooooooooo`00oooooooo0?ZJo`00Ool00?l04?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01oooool2o`3jVP06ooooool00?oo
0?ZJo`00oooooooo001o3_ooool2ool00003o`00Oooooooooooo00;oo`003Oooool00ol007oooooo
ooooo`08ooooo`;o0?ZJ00Koooooo`00ool00?oo0?ZJo`00Ool00?l<ooooo`07ool00?oooooooooo
ool00?l007ooooooool00002ooooo`07o`00ooooooooooooooooool0nY[oooooo`00o`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`07ooooo`;o
o`001Oooool00ooo003oooooooooo`0?ooooo`03o`00Oooooooooooo00_ooooo0_l0nYX00ooooooo
001oooooo`0?ooooo`09o`00Ool0nY[oooooooooool00?ooooooo`3jV_oooooo003o00Wooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool00ooo003oooooo`00O`02
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01oooool00ol007ooooooooooo`07
ooooo`08o`3jV_ooooooooooooooool00?oo0?ZJooooool00?l@ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`08ooooo`05o`3jV_ooooooooooo`00
ool0nYX00_ooool00ol007ooooooooooo`0;ooooo`04ool00?ooooooooooo`00O`;ooooo0_oo000<
ooooo`03o`00Oooooooooooo00Wooooo0_l0nYX01Ooooooo003oo`3jV_oooooo003o00cooooo00Go
o`00ooooooooooooooooo`00O`02ooooo`04ool00?ooooooooooo`00o`;ooooo00?o0?ZJooooool0
0?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01oooool2ool000Kooooo00?oo`00ooooooooool03_ooool00ol007ooooooooooo`0<ooooo`04
o`3jV_ooooooooooo`00Oa3ooooo00?o0?ZJooooooooool00_l00?l00ooooooo0?ZJo`00o`0:oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool01_oo003oooooooooool007oo
ooooo`3jVPGooooo00?o0?ZJooooooooool01_ooool00ol007ooooooooooo`07ooooo`08o`3jV_oo
ooooooooooooool00?ooooooo`3jV_l00?l=ooooo`05ool00?ooooooooooooooool007l04?ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Oooooo0_l0nYX2ooooo`04o`3jV_oooooo
ooooo`00O`kooooo00?oo`00ooooool007l00oooool2ool000cooooo00?o001oooooooooool02Ooo
ool01ol0nY[oooooooooool00?oo0?ZJo`00Ool00?l03?ooool02?oo003ooooooooooooooooo001o
oooooooo003o0?ZJ0_ooool01_l00?ooooooooooool0nY[oooooo`00o`Gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo0_oo0006ooooo`03
ool00?oooooooooo00oooooo00?o001oooooooooool02oooool01?l0nY[oooooooooool007l@oooo
o`04o`00Ool0nY[oooooooooo`;o003o00?o0?ZJooooool00?l02Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000oooo
ooooool01_ooool00ol007ooooooooooo`0<ooooo`03ool00?oooooo001o00;ooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`07ooooo`03o`00Oooooooooooo00Oooooo00So0?ZJoooo
ooooooooooooo`00ool0nY[oooooo`00o`_ooooo0ooo0002ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`08ooooo`05o`3jV_ooooooooooooooool0
nYX00_ooool00ol007ooooooooooo`0:ooooo`;oo`000_ooool00ol007ooooooooooo`02ooooo`03
ool00?oooooooooo00Wooooo00?o001oooooooooool02_ooool01_l0nY[oooooo`00ool0nY[ooooo
o`00o`cooooo00Goo`00ooooooooooooooooo`00O`02ooooo`04ool00?ooooooooooo`00o`;ooooo
00?o0?ZJooooool00?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool01_ooool2ool000Oooooo00?oo`00ooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Co001oo`3jV_oooooooooo0_l00?l00ol0nY[o
003oooooo`09ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool01Ooo003o
ooooo`00Oooooooo0?ZJ00Gooooo00?o0?ZJooooooooool01_ooool00ol007ooooooooooo`07oooo
o`;o0?ZJ0_ooool01?l00?ooooooo`3jV_l00?l;ooooo`04ool00?ooooooo`00ool000;ooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Sooooo00Co
0?ZJoooooooooooo0?ZJ0_ooool00ol007ooooooooooo`0;ooooo`04ool00?ooooooooooo`00O`Co
oooo00?oo`00ooooooooool02_ooool00ol007ooooooooooo`09ooooo`06o`3jV_ooooooooooo`3j
V_oooooo003o3?ooool00ooo003oooooooooo`02ooooo`04o`00Ooooooooooooool000;ooooo00Go
003oooooool0nY[oooooo`00o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`06ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00Co001oo`3jV_oooooo
oooo0_l00?l00ol0nY[o003oo`00o`09ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00cooooo00?oo`00ooooool007l00_ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00Oooooo00?o001oooooooooool02?ooool01ol0nY[oooooooooool00?oo0?ZJoooo
ool00?l02_ooool3ool00004oooooooo003oooooo`00Oa7ooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`09ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o001oooooooooool02_ooool2
ool000;ooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`09ooooo`03o`00Oooooooo
oooo00[ooooo00Ko0?ZJoooooooooooo0?ZJo`00ool007l<ooooo`05ool00?ooooooooooooooool0
07l00_ooool02Ol0nY[oo`00oooooooooooo003oooooool0nY[oooooo`00o`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`;oo`002?oo
ool00ooo003oooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool01?l007oo0?ZJooooooooool2o`00o`03o`3jV_l00?oooooo00Wooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`05ool00?oooooo001oooooool0nYX01?ooool00ol0nY[o
ooooooooo`07ooooo`03o`00Oooooooooooo00Sooooo00Oo0?ZJoooooooooooo003oo`3jV_oooooo
003o00[ooooo1_oo00000ooooooo001oooooo`0?ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool02?ooool2o`3jVP05ooooool0nY[oooooooooool007l03?ooool2ool000;ooooo00?o
001oooooooooool00_ooool00ooo003oooooooooo`0:ooooo`03o`00Oooooooooooo00Wooooo00Ko
0?ZJoooooooooooo0?ZJooooool00?l<ooooo`03ool00?oooooooooo00;ooooo00Co001ooooooooo
ooooo`000_ooool01Ol00?ooooooo`3jV_oooooo003o00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Gooooo0_oo0007ooooo`03ool00?oooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`04o`00Ool0nY[o
ooooooooo`;o003o00?o0?ZJo`00ooooool02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo0_l00007ooooo`03o`00Oooooooo
oooo00cooooo00?oo`00ooooool007l00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00Oooooo00?o001oooooooooool02?ooool01ol0nY[oooooooooool00?oo0?ZJooooool00?l0
2Oooool00ooo003oooooool00003ooooo`03ool00?l007oooooo013ooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o001oooooooooool0
2_ooool01Ooo003ooooooooooooooooo001o00Cooooo00?oo`00ooooooooool02Oooool00ol007oo
ooooooooo`0:ooooo`03o`3jV_oooooo0?ZJ00;o003o00?o001oooooooooool02_ooool01Ooo003o
oooooooooooooooo001o00?ooooo00Soo`00oooooooooooo003oooooool0nY[oooooo`00o`Kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo
0_oo0008ooooo`03ool00?oooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0=ooooo`03ool00?l007oo0?ZJ00?ooooo00?o003oo`3jV_l00?l02_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Cooooo0_l0000Iooooo`?o00001_ooool00ol007oooooo
ooooo`0=ooooo`05ool00?oooooo001oooooool0nYX01?ooool00ol0nY[oooooooooo`07ooooo`03
o`00Oooooooooooo00Sooooo00Oo0?ZJoooooooooooo003oo`3jV_oooooo003o00[ooooo00?oo`00
oooooooo00000_ooool00ooo003oooooo`00O`0@ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool02?ooool2o`3jVP05ooooool0nY[oooooooooool007l03?ooool01Ooo003ooooooooo
oooooooo001o00Cooooo00?oo`00ooooooooool02_ooool00ol007ooooooooooo`0:ooooo`?o0?ZJ
00?o003oo`00Ooooool02oooool00ooo003oooooooooo`02ooooo`04o`00Ooooooooooooool000;o
oooo00Go003oooooool0nY[oooooo`00o`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oo`3j
V_ooool00_ooool00ol00?oo0?ZJo`00o`0:ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01?ooool3o`0001Sooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool03?ooool00ooo003oooooo`00O`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool01oooool00ol007ooooooooooo`08ooooo`07o`3jV_ooooooooooo`00ool0nY[oooooo`00o`09
ooooo`03ool00?oooooooooo00?ooooo00?oo`00o`00Ooooool04?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00[ooooo0_l0nYX3ooooo`03o`00Oooooooooooo00[ooooo00Goo`00
ooooooooooooooooo`00O`04ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool02ooo
ool2o`3jVP;ooooo00?o001oooooooooool02Oooool00ooo003oooooooooo`02ooooo`05o`00Oooo
oooooooooooooooo00000_ooool01Ol00?ooooooo`3jV_oooooo003o00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?oo`00oooooooo
ool01oooool00ooo003oooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03Oooool00ooo003o001oo`3jVP03ooooo`03o`00ool0nY[ooooo00[ooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03ool00?oooooo001o00;ooooo00Go0?ZJoooooooo
ooooooooo`3jVP09ooooo`03o`00Oooooooooooo00Sooooo00Oo0?ZJooooooooooooooooo`3jV_oo
oooo003o00[ooooo00?oo`00ooooooooool00_ooool00ooo003oooooo`00O`0@ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool02?ooool3o`3jVP?ooooo00?o001oooooooooool02_oo
ool01Ooo003ooooooooooooooooo001o00Cooooo0_oo000;ooooo`03o`00Oooooooooooo00[ooooo
0ol0nYX00ooooooo001oooooo`0;ooooo`03ool00?oooooooooo00;ooooo00Co001ooooooooooooo
o`000oooool01?l00?oo0?ZJooooool00?l6ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00gooooo0_oo0002o`3j
VP;ooooo00?o003oo`3jV_l00?l02_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`0<ooooo`03ool00?oooooo001o00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`07ooooo`03o`00Oooooooooooo00Sooooo00Oo0?ZJoooooooooooo003oo`3jV_oooooo
003o00Wooooo00?oo`00ooooooooool00oooool00ooo003o001oooooo`0@ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`03o`00Oooooooo
oooo00Wooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
oooo00Wooooo00?o001oooooooooool02oooool2o`3jVP;ooooo00?o001oooooooooool02Oooool0
0ooo003oooooooooo`02ooooo`05o`00Oooooooooooooooooooo00000_ooool2o`00o`03o`3jV_l0
0?oooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Gooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03Oooool2ool00003o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
o`00ooooool007l00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo00?o001oooooooooool0
2Oooool01_l0nY[oooooooooool0nY[oooooo`00o`Wooooo00?oo`00ooooooooool01?ooool00ooo
003o001oooooo`0?ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool02Oooool00ol0
nY[oooooooooo`02ooooo`03o`00Oooooooooooo00[ooooo00Goo`00ooooooooooooooooo`00O`05
ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool02_ooool2o`3jVP;ooooo00?o001o
ooooooooool02_ooool00ooo003oooooooooo`02ooooo`04o`00Ooooooooooooool000?ooooo00?o
003oo`3jV_l00?l01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0=ooooo`;oo`0000?oooooo`3jV_ooool00_oo
ool00ol0nY[o003oooooo`09ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_oo
ool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00cooooo00?oo`00ooooool007l00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00Oooooo00?o001oooooooooool02?ooool01ol0nY[ooooooooooooooooo0?ZJo`00ool007l0
2Oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Sooooo0_oo0004ooooo`03o`00
Oooooooooooo00;ooooo00?oo`00ooooooooool02Oooool00ol007ooooooooooo`0?ooooo`03o`00
Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool01Ol007ooooooooooooooooooo`0000;o
oooo0_l00?l00ol0nY[o003oooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Oooooo00?oo`00oooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00cooooo00Coo`00oooooooo
003o0?ZJ1?ooool00ol0nY[oooooooooo`09ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ooo003oooooo`00O`02ooooo`05o`3jV_ooooooooooooooool0nYX02Oooool0
0ol007ooooooooooo`09ooooo`04o`3jV_ooooooooooo`3jVP;o003o2Oooool00ooo003ooooooooo
o`04ooooo`03ool00?l007oooooo00oooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ol007oooooooooo
o`03ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool02oooool01?l0nY[ooooooooo
ool007l;ooooo`03ool00?oooooooooo00?ooooo00Go001ooooooooooooo0?ZJool00002ooooo`03
o`00ool0nY[o003o00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00Cooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03?ooool3ool00003ooooool0nY[ooooo00;o
oooo00?o0?ZJo`00ooooool02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Ko
oooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`0<ooooo`03ool00?oooooo001o00;ooooo00Go0?ZJooooooooooooooooo`3jVP0:ooooo`03
o`00Oooooooooooo00Wooooo00?o0?ZJooooool0nYX00_l00?l00ol007ooooooooooo`07ooooo`03
ool00?oooooooooo00Cooooo00?oo`00ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool02?ooool00ooo003oooooooooo`03ooooo`03
o`00Oooooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool01Ol007ooooooooooooooooooo`00
00?ooooo00?o003oo`3jV_l00?l01oooool00ol007ooooooooooo`0>ooooo`05o`00Oooooooooooo
oooooooo00003?ooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Oooooo00?oo`00
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00cooooo00Coo`00
oooooooo003o0?ZJ0oooool00ol0nY[oooooooooo`0:ooooo`04o`00Ooooooooooooool000gooooo
00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo
00?o001oooooooooool03Oooool00ooo003oooooo`00O`02ooooo`05o`3jV_ooooooooooooooool0
nYX02Oooool00ol007ooooooooooo`09ooooo`06o`3jV_ooooooooooo`3jV_l00?oo001o2Oooool0
0ooo003oooooooooo`04ooooo`03ool00?l007oooooo00oooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool0
0ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`09ooooo`03ool00?oooooooooo00?ooooo00Go001ooooooooooooo0?ZJool0
0003ooooo`03o`3jV_l00?oooooo00Kooooo00?o001oooooooooool03_ooool01?l007oooooooooo
ooooool2ool000cooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03ool0
0?oooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0<ooooo`05ool0
0?ooooooo`00ooooool0nYX00oooool00ol0nY[oooooooooo`09ooooo`03o`00Oooo003oo`0000;o
o`003?ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool03?ooool00ooo003oooooo`00O`02ooooo`05o`3j
V_ooooooooooooooool0nYX02_ooool00ol007ooooooooooo`09ooooo`03o`3jV_oooooo0?ZJ00;o
oooo00?o001oooooooooool01_ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00So
oooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00So
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`08ooooo`;oo`001?ooool01Ol007oo
ooooooooooooooooo`0000Cooooo00?o0?ZJooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00?oo`002oooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo
00Sooooo00?oo`00ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00cooooo00Goo`00oooooooo003oooooo`3jVP02ooooo`03o`3jV_oooooooooo00[ooooo00?o001o
ool00?oo00000_oo000<ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00ooooool007l00_ooool0
0ol0nY[oooooooooo`02o`3jVPWooooo00?o001oooooooooool00oooool00ooo003oooooooooo`03
ooooo`06o`3jV_ooooooooooo`3jV_l00?oo001o2Oooool00ooo003oooooooooo`04ooooo`03ool0
0?l007oooooo00oooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Sooooo0_oo0004ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool0
2Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo0_oo0005ooooo`05o`00
Oooooooooooooooooooo00000oooool00ol0nY[oooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00Co001ooooooooooooooooo0ooo000;ooooo`03o`00Oooooooooooo00Cooooo00?oo`00oooo
ooooool01oooool00ol007ooo`00ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03?ooool01Ooo003oooooo`00Oooo003o0?ZJ00?ooooo00?o0?ZJooooooooool02Oooool0
0ol007ooo`00ool00002ool000cooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00?oo`00oooo
ool007l00oooool01?l0nY[oooooooooool0nYX:ooooo`03o`00Oooooooooooo00;ooooo0_oo0005
ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`05
ooooo`03ool00?oooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`03
ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool03oooool00ol007ooooooooooo`08
ooooo`03ool00?oooooooooo00?ooooo00Go001oooooooooooooooooool00003ooooo`03o`3jV_oo
oooooooo00Oooooo00?o001oooooooooool03_ooool01_l007oooooooooooooo003oooooool000_o
oooo00?o001oooooooooool01?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0;ooooo`06ool00?ooooooooooool0
0?oooooo0?ZJ0_ooool00ol0nY[oooooooooo`0:ooooo`03o`00Oooo003ooooo00?oo`002oooool0
0ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03ool00?oooooo001o00;ooooo00Co0?ZJoooooooooooo0?ZJ2_oo
ool00ol007ooooooooooo`03ooooo`;oo`001?ooool4o`3jVP03ooooool007oooooo00Oooooo0_oo
0007ooooo`03ool00?oooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Sooooo00?oo`00ooooooooool00oooool00ol007oooooooooo
o`03ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`08ooooo`;oo`001Oooool01Ol007ooooooooooooooooooo`0000?ooooo00?o0?ZJooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;oo`0000?oooooool00?ooool0
2_ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Oooooo00?o001oool00?ooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00_ooooo0_oo00000ooooooo001o
ool00002o`3jVP03ooooool0nY[ooooo00_ooooo00?o001oool00?oo00000ooo000;ooooo`03o`00
Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_oo
ool00ol007ooooooooooo`0<ooooo`03ool00?oooooo001o00?ooooo00Co0?ZJoooooooooooo0?ZJ
2_ooool00ol007ooooooooooo`02ooooo`?oo`001?ooool00ol0nY[oooooo`3jVP02ooooo`03o`00
Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool00ol007ooo`00ooooo`0?ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`07ooooo`03ool0
0?oooooooooo00Cooooo00?o001oooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool02?ooool00ooo003oooooooooo`03ooooo`06o`00
Oooooooooooooooooooo003o0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`00Oooooooooooo
00kooooo00Co001oooooooooooooo`000_ooool00ooo003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Cooooo00?oo`00ooooooooool02?ooool00ol007ooo`00ooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool02oooool01_oo003oooooooooool007ooo`00o`3jVP;ooooo
00?o0?ZJooooooooool02_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Wooooo
00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo
00?o001oooooooooool03Oooool00ooo003oooooo`00O`02ooooo`04o`3jV_ooooooooooo`3jVP[o
oooo00?o001oooooooooool00oooool3ool000Cooooo0_l0nYX2ooooo`03o`00Oooooooooooo00Ko
oooo00?oo`00ooooooooool01_ooool2ool000oooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01?ooool00ol007oo
ooooooooo`03ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`08ooooo`03ool00?oooooooooo00Cooooo00Go001oooooooooooooooooool00003oooo
o`03o`3jV_oooooooooo00Kooooo00?o001oooooooooool03_ooool01?l007oooooooooooooo0002
ooooo`;oo`002_ooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001o
ool00?ooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00_ooooo0_oo0000
0ooooooo001oool00004o`3jVPcooooo00Coo`00oooooooooooooooo0_oo000;ooooo`03o`00Oooo
oooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`0<ooooo`03ool00?oooooo001o00?ooooo00?o0?ZJooooool0nYX02oooool0
1_l007ooooooooooooooooooo`00ooooo`Coo`000oooool2o`3jVP;ooooo00?o001oooooooooool0
1_ooool00ooo003oooooooooo`05ooooo`03o`00Oooo003ooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo0_oo0006ooooo`03o`00
Oooooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03ool0
0?oooooooooo00Oooooo00?o001oooooooooool02?ooool00ooo003oooooooooo`03ooooo`03o`00
Oooooooooooo00;ooooo00Coo`00oooooooooooo0?ZJ2Oooool00ol007ooooooooooo`0>ooooo`04
o`00Ooooooooooooool000;ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`04oooo
o`03ool00?oooooooooo00Sooooo00?o001oool00?ooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00[ooooo00[oo`00ooooooooooooooooo`00Oooo003oooooo`3jV_oooooo
0?ZJ3?ooool00ooo003oooooooooo`02ooooo`;oo`002_ooool00ol007ooooooooooo`05ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03
ool00?oooooo001o00;ooooo00Co0?ZJoooooooooooo0?ZJ2_ooool00ol007ooooooooooo`02oooo
o`06ool00?ooooooo`00ool00?ooooooo`000_ooool2o`3jVP;ooooo00?o001oooooooooool01_oo
ool00ooo003oooooooooo`06ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01?oo
ool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool01?oo
ool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00Sooooo00?oo`00ooooooooool01?oo
ool01Ol007ooooooooooooooooooo`0000?ooooo00?o0?ZJooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`04o`00Ooooooooooooool000?ooooo00?oo`00ooooooooool02?ooool00ol007oo
ooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001oool00?ooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00_ooooo00Koo`00oooooooooooo001oool00?ooool3
o`3jVPcooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol0
07ooooooooooo`0<ooooo`03ool00?oooooo001o00?ooooo00?o0?ZJooooool0nYX02oooool01Ol0
07ooooooooooooooooooo`0000;ooooo00Coo`00oooooooo003oo`001_ooool00ol007oooooooooo
o`05ooooo`03ool00?oooooooooo00Kooooo00?o001oool00?ooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool01_ooool00ooo003ooooooooo
o`05ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`;oo`002?ooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00Cooooo00?o
001oooooooooool00_ooool01?oo003oooooooooool0nYX9ooooo`03o`00Oooooooooooo00kooooo
00Co001oooooooooooooo`000_ooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00Co
oooo00?oo`00ooooooooool02?ooool00ol007ooo`00ooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool02_ooool01ooo003ooooooooooooooooo001oool00?ooool00ol0nYX<
ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03ool00?oooooo001o00;ooooo1?l0nYX:ooooo`03o`00Oooooooooooo00;ooooo00?oo`00
ooooooooool00ooo0003ooooo`04o`3jV_ooooooooooo`00O`Sooooo00?oo`00ooooooooool01_oo
ool00ol007ooo`00ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool00ooo
ool00ooo003oooooooooo`09ooooo`03o`00Oooooooooooo00Cooooo00Coo`00ooooooooooooo`00
1_ooool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00Cooooo00So001ooooooooooooo
ooooool00?l0nY[oooooo`3jVPWooooo00?o001oooooooooool03_ooool01?l007oooooooooooooo
0003ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool00oooool00ooo003ooooooooo
o`08ooooo`03o`00Oooo003ooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0:ooooo`07ool00?ooooooooooooooool007ooooooool00003o`3jVPcooooo00?oo`00oooooooo
ool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o0000oooooooo
ool05_ooool001[ooooo1Ol00003ooooo`;o00001oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00cooooo00?oo`00ooooool007l00oooool3o`3jVP_ooooo00?o001oooooooooool0
0_oo0005ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01Oooool00ooo003ooooo
ooooo`06ooooo`03o`00Oooo003ooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool00ol007oooooo
ooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool01Oooool01?oo003ooooo
ool00?oo0006ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01?ooool00ol007oo
ooooooooo`02ooooo`04ool00?ooooooooooo`3jVPWooooo00?o001oooooooooool03_ooool00ol0
07ooooooool00003ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool00oooool00ooo
003oooooooooo`09ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0:ooooo`06ool00?ooooooooooooooool007ooo`000_ooool2o`3jVPcooooo00?o
o`00ooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool01oooool5o`0000?ooooo0_l00006ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03Oooool00ooo003oooooo`00O`02ooooo`Co0?ZJ2_ooool01Ol007oooooooooo
ooooooooo`0000Kooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`05ooooo`03ool0
0?oooooooooo00Oooooo00?o001oool00?ooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`05ooooo`03o`00
Oooooooooooo00Cooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`04ooooo`Coo`00
1_ooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00Gooooo00So001ooooooooooooo
ooooool00?l0nY[oooooo`3jVPWooooo00?o001oooooooooool03_ooool01?l007oooooooooooooo
0003ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool00oooool00ooo003ooooooooo
o`08ooooo`03o`00Oooo003ooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0:ooooo`08ool00?ooooooooooooooool007ooooooool00?ooool2o`3jVPcooooo00?oo`00oooo
ooooool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o0000oooo
ooooool05_ooool001_ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00006
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03?ooool00ooo003oooooo`00O`03
ooooo`?o0?ZJ2oooool01?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Cooooo00?o
001oooooooooool01Oooool00ooo003oooooooooo`06ooooo`03o`00Oooo003ooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo00?o
o`00ooooooooool01Oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o
001oooooooooool01?ooool00ooo003oooooooooo`02ool000Kooooo00?o001oooooooooool01ooo
ool00ooo003oooooooooo`04ooooo`03o`00Oooooooooooo00;ooooo00Coo`00oooooooooooo0?ZJ
2Oooool00ol007ooooooooooo`0>ooooo`03o`00Ooooooooo`0000?ooooo00?oo`00ooooooooool0
2?ooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Wooooo00?o001oool00?ooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Wooooo00?oo`00ooooooooool0
0_ooool01Ol007ooo`00oooooooooooo0?ZJ00cooooo0_oo0005ooooo`03ool00?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?oo`00ooooool007l00oooool2o`3jVP_ooooo00?o001oooooooooool00_oo0006
ooooo`03ool00?oooooooooo00?ooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`07
ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`04
ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool01?ooool01?oo003oooooool00?oo
0006ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01Oooool00ol007oooooooooo
o`02ooooo`03ool00?oooooo0?ZJ00Wooooo00?o001oooooooooool03_ooool01?l007oooooooooo
oooo0003ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool00_ooool2ool000[ooooo
00?o001oool00?ooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00[ooooo
00Soo`00ooooooooooooooooo`00Ooooooooo`00ooooo`;o0?ZJ3?ooool00ooo003oooooooooo`03
ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`007?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0<ooooo`03ool00?oooooo001o00?ooooo0_l0nYX<
ooooo`04o`00Ooooooooooooool000Oooooo00?oo`00ooooooooool00oooool00ol007oooooooooo
o`05ooooo`03ool00?oooooooooo00Kooooo00?o001oool00?ooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool00oooool00ooo003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Cooooo00Goo`00ooooooooooooooooool00006ooooo`03o`00
Oooooooooooo00Oooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`02ooooo`04ool0
0?ooooooooooo`3jVPWooooo00?o001oooooooooool03_ooool00ol007ooooooool00004ooooo`03
ool00?oooooooooo00Oooooo00?o001oooooooooool00oooool00ooo003oooooooooo`09ooooo`03
o`00Oooo003ooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`09ooooo`03
ool00?oooooooooo00;ooooo00?o001oool00?ooool03_ooool00ooo003o001oooooo`04ooooo`03
ool00?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?oo`00ooooool007l00oooool00ol0nY[oooooooooo`0:oooo
o`03o`00Oooooooooooo00;oo`001_ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo
00Gooooo00?oo`00ooooooooool01oooool00ol007ooo`00ooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03ool00?oooooooooo
00Gooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo
00Cooooo00Goo`00oooooooo003oooooool00005ooooo`03o`00Oooooooooooo00Oooooo00?oo`00
ooooooooool01Oooool00ol007ooooooooooo`02ooooo`03ool00?oooooo0?ZJ00Wooooo00?o001o
ooooooooool03_ooool00ol007ooooooool00004ooooo`03ool00?oooooooooo00Sooooo00?o001o
ooooooooool00_ooool00ooo003oooooooooo`09ooooo`03o`00Oooo003ooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0:ooooo`07ool00?ooooooooooooooool007oooooo
ool00002ooooo`03o`3jV_oooooooooo00Wooooo0_oo0006ooooo`03ool00?oooooooooo00Oooooo
00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`007Oooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool01?ooool3o`0000Kooooo00?o001oooooooooool0
3?ooool00ooo003oooooo`00O`04ooooo`03o`3jV_oooooooooo00[ooooo00?o001ooooooooo0000
2?ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool0
1_ooool00ol007ooooooool0000?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1_ooool2ool000Oooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`06ooooo`03o`00
Oooooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`04ooooo`05ool0
0?oooooooooooooooooo00001_ooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00Co
oooo00?o001oooooooooool00_ooool01?oo003o0?ZJooooool0nYX9ooooo`03o`00Oooooooooooo
00kooooo00?o001oool00?ooool01?ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo
00?ooooo00?oo`00ooooooooool02Oooool00ol007ooo`00ooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool02Oooool00ooo003oooooooooo`02ooooo`03o`00Ooooooooo`00
00gooooo00?oo`00ooooool007l01_ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo
00?ooooo0ol0000<ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`03
ooooo`?o00001_ooool00ol007ooooooooooo`0=ooooo`03ool00?oooooo001o00?ooooo00?o0?ZJ
ooooooooool02_ooool01?l007oooooooooooooo0007ooooo`03ool00?oooooooooo00?ooooo00?o
001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Oooo003ooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`04ooooo`?oo`001oooool00ol007oooooooooo
o`06ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool01?ooool00ooo003ooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool00_ooool00ooo003ooooooooo
o`03ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01Oooool00ol007oooooooooo
o`02ooooo`03ool00?oooooo0?ZJ00Wooooo00?o001oooooooooool03_ooool00ol007ooooooool0
0004ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool00_ooool00ooo003ooooooooo
o`09ooooo`03o`00Ooooooooo`0000oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`09ooooo`03ool00?oooooooooo00;ooooo00?o001ooooooooo00000_ooool00ol0nY[ooooooooo
o`09ooooo`;oo`001_ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo1?l0
000Hooooo`006_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1_ooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00cooooo00?oo`00ooooool007l0
4Oooool00ol007ooooooool00008ooooo`03ool00?oooooooooo00?ooooo00?o001oooooooooool0
1?ooool00ooo003oooooooooo`07ooooo`03o`00Ooooooooo`0000oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`05ooooo`?oo`001oooool00ol007ooooooooooo`05ooooo`03ool0
0?oooooooooo00Kooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03o`00
Oooooooooooo00Cooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`03ooooo`03o`00
Oooooooooooo00Oooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`02ooooo`03ool0
0?l0nY[o0?ZJ00[ooooo00?o001oooooooooool03_ooool00ol007ooo`00ooooo`04ooooo`03ool0
0?oooooooooo00Oooooo00?o001oooooooooool00oooool00ooo003oooooooooo`09ooooo`03o`00
Oooo003ooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`08ooooo`;oo`00
1?ooool00ol007ooooooool0000=ooooo`03ool00?oooooo001o00Kooooo00?oo`00ooooooooool0
1oooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool01_ooool00ol0
07ooooooooooo`0=ooooo`03ool00?oooooo001o013ooooo00?o001oool00?oo00002?ooool00ooo
003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01oooool00ol0
07ooooooool0000>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool00oooool4ool0
00Oooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo
00Cooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo
00;ooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo
00Gooooo00?o001oooooooooool00_ooool00ooo003o0?ZJooooo`09ooooo`03o`00Oooooooooooo
00kooooo00?o001oool00?ooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo
00;ooooo00?oo`00ooooooooool02Oooool00ol007ooooooool0000?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool02Oooool00ooo003oooooooooo`02ooooo`03o`00Ooooooooo`00
00kooooo00?oo`00o`00Ooooool01_ooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo
00Kooooo00?o0000ooooooooool05_ooool001[ooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03ool00?l007oooooo013ooooo00?o001oool00?ooool02?ooool00ooo003oooooooooo`03
ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool01oooool00ol007ooooooool0000?
ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool01?ooool2ool00003oooooooo003o
oooo00Kooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`06ooooo`03o`00Oooooooo
oooo00Cooooo00?oo`00ooooooooool01oooool00ol007ooooooooooo`03ooooo`;oo`001?ooool0
0ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool0
0ol007ooooooooooo`02ooooo`03ool00?l0nY[o0?ZJ00[ooooo00?o001oooooooooool03_ooool0
0ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool00oooool0
0ooo003oooooooooo`09ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o001ooooooooo00003Oooool0
0ooo003oooooo`00O`06ooooo`03ool00?oooooooooo00Oooooo00?o001oooooooooool01Oooool0
0ol0003oooooooooo`07ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00005ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003ooooo
o`00O`0@ooooo`03o`00Oooo003ooooo00Sooooo00?oo`00ooooooooool00oooool00ol007oooooo
ooooo`04ooooo`03ool00?oooooooooo00Sooooo00?o001ooooooooo00003_ooool00ol007oooooo
ool0000?ooooo`03o`00Oooooooooooo00?ooooo1?oo0007ooooo`03o`00Oooooooooooo00Gooooo
00?oo`00ooooooooool01_ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Sooooo
00?o001oooooooooool00oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00?ooooo
00?o001oooooooooool01_ooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo
00?oo`00o`3jV_ooool02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo003ooooo00Gooooo
00?oo`00ooooooooool01oooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Wooooo
00?o001ooooooooo00003oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo
0_oo0004ooooo`03o`00Ooooooooo`0000gooooo00?oo`00ooooool007l01oooool00ooo003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool001_ooooo0ol0
0004ooooo`;o00001oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
o`00o`00Ooooool04?ooool00ol007ooo`00ooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o
001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03o`00Ooooooooo`0000oooooo00?o
001oool00?oo00003_ooool00ol007ooooooooooo`02ooooo`Coo`0000?oooooool00?ooool01_oo
ool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool01?oo
ool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool00ooo
ool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Ooo
ool00ol007ooooooooooo`02ooooo`03ool00?oooooo0?ZJ00[ooooo00?o001oooooooooool03_oo
ool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool00ooo
ool00ooo003oooooooooo`09ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o001ooooooooo00003?oo
ool2ool00003ooooool007oooooo00Gooooo00?oo`00ooooooooool01oooool00ol007oooooooooo
o`05ooooo`03o`000?oooooooooo00Sooooo0ol00004ooooo`;o00001_ooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00ooooool007l04?ooool00ol007ooo`00oooo
o`08ooooo`03ool00?oooooooooo00?ooooo00?o001oooooooooool01?ooool00ooo003ooooooooo
o`08ooooo`03o`00Ooooooooo`0000kooooo00?o001oool00?oo00003oooool00ol007oooooooooo
o`02ooooo`?oo`000_ooool00ooo003oooooooooo`04ooooo`03o`00Oooooooooooo00Gooooo00?o
o`00ooooooooool01_ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Sooooo00?o
001oooooooooool00_ooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00;ooooo00?o
001oooooooooool01_ooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo00?o
o`00o`3jV_ooool02Oooool00ol007ooooooooooo`0>ooooo`03ool00?oooooooooo00Gooooo00?o
o`00ooooooooool01oooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Wooooo00?o
001ooooooooo00003oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo00?o
o`00ooooooooool00oooool00ol007ooooooool0000=ooooo`03ool00?oooooo001o00Oooooo00?o
o`00ooooooooool01_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003o001oooooo`0@
ooooo`03o`00Oooo003ooooo00Sooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`04
ooooo`03ool00?oooooooooo00Oooooo00?o001ooooooooo00003oooool00ol007ooo`00ool0000>
ooooo`03o`00Oooooooooooo00;ooooo0_oo0003ooooo`03ool00?oooooooooo00Gooooo00?o001o
ooooooooool01Oooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo00Cooooo00?oo`00
ooooooooool01oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00?ooooo0_oo0004
ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`02
ooooo`03ool00?oooooo0?ZJ00[ooooo00?o001oooooooooool03_ooool00ooo003oooooooooo`05
ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`0:
ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`07
ooooo`03ool00?oooooooooo00Cooooo00?o001ooooooooo00003?ooool2ool00003ooooool007oo
oooo00Kooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03ool00?oooooo
001o013ooooo0_oo000:ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool01?ooool0
0ooo003oooooooooo`08ooooo`03o`00Ooooooooo`0000kooooo00?o001oool00?oo00003oooool0
0ol007ooooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool01?ooool0
0ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool01?ooool0
0ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool01?ooool0
0ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01_ooool0
0ol007ooooooooooo`02ooooo`03ool00?l0nY[ooooo00Wooooo00?o001oooooooooool03_ooool0
0ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Oooooo00?o001oooooooooool00_ooool0
0ooo003oooooooooo`09ooooo`03o`00Ooooooooo`0000oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00Co001oooooooooooooo`003?oo
ool00ooo003oooooo`00O`07ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool01_oo
ool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?oo`00o`00Ooooool04?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooo
oooo00?ooooo00?o001oooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooo
o`0000oooooo00?oo`00oooooooo00003_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
oooo00?ooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`04ooooo`03ool00?oooooo
oooo00Oooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooo
oooo00;ooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooo
oooo00Gooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
oooo00[ooooo00?o001oooooooooool03_ooool00ooo003oooooooooo`05ooooo`03ool00?oooooo
oooo00Kooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`0:ooooo`03o`00Oooo003o
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`07ooooo`03ool00?oooooo
oooo00Cooooo00Co001oooooooooooooo`002oooool01?oo003oooooooooool007l7ooooo`03ool0
0?oooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003oooooo`00O`0@ooooo`;oo`00
2_ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool0
2?ooool00ol007ooooooool0000>ooooo`04o`00Oooo003oooooool000kooooo00?o001ooooooooo
ool00_oo0005ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01Oooool00ooo003o
ooooooooo`06ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool02?ooool00ol007oo
ooooooooo`02ooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool00_ooool00ol007oo
ooooooooo`06ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool00_ooool00ooo003o
ooooooooo`09ooooo`03o`00Oooooooooooo00kooooo00?oo`00ooooooooool01Oooool00ooo003o
ooooooooo`07ooooo`04o`00Ooooooooooooooooo`;oo`002oooool00ol007ooooooool0000?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01oooool2ool000Gooooo00Co001ooooo
ooooooooo`002oooool01?oo003oooooooooool007l7ooooo`03ool00?oooooooooo00Kooooo00?o
001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool04?ooool00ooo003oooooooooo`09
ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool00oooool00ooo003oooooooooo`08
ooooo`04o`00Ooooooooooooool000kooooo00Coo`00ooooooooooooo`003Oooool00ol007oooooo
ooooo`02ool000Kooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`04ooooo`03ool0
0?oooooooooo00Oooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03o`00
Oooooooooooo00;ooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`02ooooo`03o`00
Oooooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`02ooooo`03ool0
0?oooooooooo00[ooooo00?o001oooooooooool03Oooool2ool000Oooooo00?oo`00ooooooooool0
1_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00[ooooo00?o001ooooooooo0000
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool0
1?ooool01?l007oooooooooooooo000;ooooo`04ool00?ooooooooooo`00O`Oooooo00?oo`00oooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`03ool00?oooooo001o013ooooo00?oo`00oooo
ooooool02Oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00Cooooo00?oo`00oooo
ooooool02?ooool00ol007ooooooool0000>ooooo`04ool00?ooooooooooool000kooooo00?o001o
ool00?oo00000_oo0005ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01?ooool2
ool000Sooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Oooooooo
oooo00;ooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooo
oooo00Kooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
oooo00Wooooo00?o001oooooooooool03_ooool00ooo003oooooooooo`06ooooo`03ool00?oooooo
oooo00Kooooo00Co001ooooooooooooooooo0_oo000;ooooo`03o`00Ooooooooo`0000oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00Cooooo00Co
001oooooooooooooo`002oooool01?oo003oooooooooool007l7ooooo`03ool00?oooooooooo00Ko
oooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03oooool00ooo003o001o
ooooo`0:ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool00oooool00ooo003ooooo
ooooo`08ooooo`04o`00Ooooooooooooool000kooooo00Coo`00ooooooooooooo`003Oooool00ol0
07ooooooool00002ool000Kooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`04oooo
o`03ool00?oooooooooo00Oooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`07oooo
o`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`02oooo
o`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`02oooo
o`03ool00?oooooooooo00[ooooo00?o001oooooooooool03Oooool00ooo003o001oooooo`06oooo
o`03ool00?oooooooooo00Kooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`0:oooo
o`03o`00Ooooooooo`0000kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`07oooo
o`03ool00?oooooooooo00Cooooo00Co001oooooooooooooo`002oooool01?oo003oooooooooool0
07l7ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003oooooo`00
O`0@ooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ol007oooooooooo
o`04ooooo`03ool00?oooooooooo00Sooooo00?o001ooooooooo00003_ooool01?oo003ooooooooo
oooo000>ooooo`04o`00Oooo003oo`00ool000Kooooo00?oo`00ooooooooool01?ooool00ol007oo
ooooooooo`04ooooo`03ool00?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ooo003o
ooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool01?ooool00ooo003o
ooooooooo`02ooooo`03o`00Oooooooooooo00Gooooo0_oo0008ooooo`03o`00Oooooooooooo00;o
oooo00?oo`00ooooooooool02Oooool01?l007ooo`00ool00?oo000<ooooo`03ool00?l007oooooo
00Oooooo00?oo`00ooooooooool01_ooool01Ol007ooooooooooooooooooo`0000cooooo00?o001o
oooooooo00003oooool00ol007ooooooooooo`09ooooo`03ool00?oooooooooo00;ooooo00?o001o
ooooooooool01oooool00ooo003oooooooooo`04ooooo`04o`00Ooooooooooooool000_ooooo00Co
o`00oooooooooooo001o1oooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo00Kooooo
00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03ool00?l007oooooo00oooooo00?oo`00o`00Ooooool02_ooool00ooo003ooooooooo
o`02ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool02?ooool01?l007oooooooooo
oooo000=ooooo`05ool00?l007oooooooooooooo00003Oooool2ool000Wooooo00?oo`00oooooooo
ool01?ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Oooooo00?o001ooooooooo
ool01?ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo00?oo`00oooooooo
ool01Oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00Gooooo00?oo`00oooooooo
ool01_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00[ooooo00Co001oool00?oo
003oo`003?ooool00ooo003o001oooooo`07ooooo`03ool00?oooooooooo00Gooooo00Go001ooooo
ooooooooooooool0000=ooooo`03o`00Ooooooooo`0000kooooo00?o001oooooooooool02?ooool2
ool000Gooooo00?o001oooooooooool01_ooool2ool000Kooooo00Co001oooooooooooooo`002ooo
ool01?oo003oooooooooool007l7ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool0
1Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool0
3Oooool00ooo003oooooo`00O`0?ooooo`03ool00?l007oooooo00_ooooo00Goo`00oooooooooooo
ooooo`00O`05ooooo`03ool00?oooooooooo00Wooooo00?o001ooooooooo00003?ooool3ool000;o
oooo00?oo`00ooooooooool02oooool3ool00003oooooooo003ooooo00Gooooo00?oo`00oooooooo
ool01?ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Oooooo00?o001ooooooooo
ool01Oooool00ooo003oooooooooo`07ooooo`05o`00Oooooooooooooooooooo00001oooool00ooo
003oooooooooo`02ooooo`03o`00Oooooooooooo00Cooooo0_oo0009ooooo`03o`00Oooooooooooo
00;ooooo00?oo`00ooooooooool02Oooool00ol007ooo`00ool00002ool000_ooooo00?oo`00o`00
Ooooool01oooool00ooo003oooooooooo`06ooooo`05o`00Oooooooooooooooooooo00003?ooool0
0ol007ooooooool0000?ooooo`03o`00Oooooooooooo00Oooooo00?oo`00oooooooo00001?ooool0
0ol007ooooooooooo`06ooooo`;oo`001_ooool01?l007oooooooooooooo000;ooooo`04ool00?oo
ooooooooo`00O`Oooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`06ooooo`03o`00
0?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ooo003o001oooooo`0?ooooo`03ool00?l007oooooo00[ooooo00?oo`00ooooooooool00_oo
ool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00Co001oooooooooooooo`00
3?ooool2ool00004o`00Ooooooooooooool000gooooo00?oo`00ooooooooool02?ooool00ooo003o
ooooooooo`04ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool01oooool00ol007oo
ooooooooo`04ooooo`03ool00?oooooooooo00Oooooo00?o001oooooooooool00_ooool00ooo003o
ooooooooo`05ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool01?ooool2ool000So
oooo00?o001oooooooooool00_ooool00ooo003oooooooooo`0:ooooo`03o`00Oooo003oo`0000;o
o`002oooool00ooo003o001oooooo`07ooooo`03ool00?oooooooooo00Gooooo00Go001ooooooooo
ooooooooool0000=ooooo`03o`00Ooooooooo`0000kooooo00?o001oooooooooool01oooool3ool0
00Gooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`05ooooo`04o`00Oooooooooooo
ool000[ooooo00Goo`00ooooooooooooooooo`00O`07ooooo`03ool00?oooooooooo00Kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03Oooool00ooo003oooooo`00O`0?ooooo`03ool00?l007oooooo00_ooooo00Go
o`00ooooooooooooooooo`00O`05ooooo`03ool00?oooooooooo00Wooooo00?o001ooooooooo0000
3?ooool3ool000?ooooo00?oo`00ooooooooool02_ooool2ool000Wooooo0_oo0005ooooo`03o`00
Oooooooooooo00Cooooo00?oo`00ooooooooool01oooool00ol007ooooooooooo`05ooooo`03ool0
0?oooooooooo00Oooooo00Go001oooooooooooooooooool00008ooooo`05ool00?oooooooooooooo
ool007l01_ooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo00?oo`00oooo
ooooool02Oooool00ol007ooo`00ool00002ool000_ooooo00?oo`00o`00Ooooool02?ooool00ooo
003oooooooooo`05ooooo`04o`00Ooooooooooooool000gooooo00?o001ooooooooo00003oooool0
0ol007ooooooooooo`06ooooo`Goo`000oooool00ol007ooooooooooo`06ooooo`03ool00?oooooo
oooo00Gooooo00Co001oooooooooooooo`002oooool01?oo003oooooooooool007l7ooooo`03ool0
0?oooooooooo00Kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:ooo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03_oo
ool00ooo003oooooo`00O`0;ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool00ooo
ool00ooo003oooooooooo`08ooooo`04o`00Ooooooooooooool000cooooo0_oo00001Ol007oooooo
ooooooooooooo`0000cooooo00?oo`00ooooooooool02?ooool2ool000Gooooo00?o001ooooooooo
ool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo00?oo`00oooooooo
ool01oooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo
ool00_ooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001ooooooooo
ool00oooool00ooo003oooooooooo`09ooooo`05ool00?ooooooo`00oooooooo00002oooool00ooo
003o001oooooo`07ooooo`03ool00?oooooooooo00Gooooo00Go001oooooooooooooooooool0000=
ooooo`03o`00Ooooooooo`0000kooooo00?o001oooooooooool01oooool2ool00003oooooooo003o
oooo00?ooooo00?o001oooooooooool01Oooool2ool000Oooooo00Co001oooooooooooooo`002_oo
ool01Ooo003ooooooooooooooooo001o00Oooooo00?oo`00ooooooooool01_ooool00ol007oooooo
ooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03ool00?oooooo001o00oooooo00?oo`00o`00Ooooool02oooool01Ooo003ooooo
oooooooooooo001o00Gooooo00?oo`00ooooooooool02Oooool00ol007ooooooool0000<ooooo`03
ool00?oooooo001o00?ooooo00?oo`00ooooooooool02_ooool00ooo003o001oooooo`09ooooo`03
ool00?oooooooooo00?ooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`07ooooo`03
o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01oooool01Ol007ooooooooooooooooooo`00
00Sooooo00Goo`00ooooooooooooooooo`00O`06ooooo`03ool00?oooooooooo00Sooooo00?o001o
ooooooooool00_ooool00ooo003oooooooooo`09ooooo`?oo`0000?oooooool00?ooool02_ooool0
0ooo003o001oooooo`08ooooo`03ool00?oooooooooo00Gooooo00Co001oooooooooooooo`003Ooo
ool00ol007ooooooool0000?ooooo`03o`00Oooooooooooo00Gooooo0ooo00000oooooooo`00ool0
0003ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool01?l007oooooooooo
oooo000:ooooo`05ool00?ooooooooooooooool007l01oooool00ooo003oooooooooo`06ooooo`03
o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`03ool00?l007oooooo00kooooo00?oo`00ooooool007l0
2oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool0
2Oooool01?l007oooooooooooooo000:ooooo`;oo`000_ooool01Ol007ooooooooooooooooooo`00
00_ooooo00?oo`00o`00Ooooool02_ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo
00?ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo
00Kooooo00Co001ooooooooooooooooo0_oo0007ooooo`03ool00?oooooooooo00;ooooo00?o001o
ooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?oo`00
ooooooooool02?ooool2ool00004oooooooo003oooooool000[ooooo00?oo`00ooooool007l02?oo
ool00ooo003oooooooooo`05ooooo`05o`00Oooooooooooooooooooo00003Oooool00ol007oooooo
ool0000>ooooo`03o`00Oooooooooooo00Oooooo00Coo`00ooooooooooooo`001?ooool00ol007oo
ooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00Co001oooooooooooooo`002_ooool01Ooo
003ooooooooooooooooo001o00Oooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03ool00?oooooo001o00oooooo00?oo`00o`00Ooooool02oooool01Ooo003ooooooooooooo
oooo001o00Gooooo00?oo`00ooooooooool02Oooool00ol007ooooooool0000:ooooo`?oo`0000?o
ooooo`00Ooooool00_ooool00ooo003oooooooooo`09ooooo`03ool00?oooooo001o00[ooooo00?o
o`00ooooooooool00oooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Oooooo00?o
001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00;oo`002?oo
ool01Ooo003ooooooooooooooooo001o00Kooooo00?oo`00ooooooooool02?ooool00ol007oooooo
ooooo`02ooooo`03ool00?oooooooooo00Wooooo00Goo`00oooooooo003oooooool0000;ooooo`03
ool00?l007oooooo00Sooooo00?oo`00ooooooooool01Oooool01?l007oooooooooooooo000=oooo
o`03o`00Ooooooooo`0000oooooo00?o001oooooooooool01Oooool2ool000?ooooo00Goo`00oooo
ooooooooooooo`00O`07ooooo`03ool00?oooooooooo00Kooooo00Co001oooooooooooooo`002_oo
ool01Ooo003ooooooooooooooooo001o00Oooooo00?oo`00ooooooooool01_ooool00ol007oooooo
ooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`;o00001oooool00ol007oooooooooo
o`0=ooooo`03ool00?l007oooooo00kooooo00?oo`00ooooool007l03?ooool01Ooo003ooooooooo
oooooooo001o00Cooooo00?oo`00ooooooooool02Oooool01?l007oooooooooooooo000:ooooo`;o
o`000_ooool01Ol007ooooooooooooooooooo`0000_ooooo00?oo`00o`00Ooooool02_ooool00ooo
003oooooooooo`03ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool00ooo0008oooo
o`05ool00?ooooooooooooooool007l01?ooool00ooo003oooooooooo`09ooooo`03o`00Oooooooo
oooo00?ooooo00?oo`00ooooooooool02?ooool00ooo003o001oooooo`02ooooo`03ool00?oooooo
oooo00Sooooo00?oo`00ooooool007l02?ooool00ooo003oooooooooo`05ooooo`04o`00Oooooooo
ooooool000kooooo00?o001ooooooooo00003_ooool00ol007ooooooooooo`03ooooo`Coo`001?oo
ool01Ooo003ooooooooooooooooo001o00Oooooo00?oo`00ooooooooool01_ooool01?l007oooooo
oooooooo0009ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool01Oooool00ooo003o
ooooooooo`06ooooo`03o`00Oooooooooooo00Cooooo0_l0000Iooooo`?o00001_ooool00ol007oo
ooooooooo`0=ooooo`03ool00?oooooo001o00kooooo00?oo`00ooooool007l03?ooool01Ooo003o
oooooooooooooooo001o00Gooooo00?oo`00ooooooooool02Oooool00ol007ooooooool0000:oooo
o`?oo`0000?oooooo`00Ooooool00_ooool00ooo003oooooooooo`09ooooo`03ool00?oooooo001o
00[ooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Ooooooooo`00
00;oo`002?ooool01Ooo003ooooooooooooooooo001o00Gooooo00?oo`00ooooooooool02Oooool0
0ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool00_ooool0
0ooo003oooooooooo`07ooooo`03ool00?oooooo001o00Wooooo00?oo`00ooooooooool01Oooool0
1?l007oooooooooooooo000=ooooo`03o`00Ooooooooo`0000oooooo00?o001oooooooooool01?oo
ool3ool000?ooooo00Goo`00ooooooooooooooooo`00O`07ooooo`03ool00?oooooooooo00Kooooo
00Go001oooooooooooooooooool00009ooooo`05ool00?ooooooooooooooool007l02?ooool00ooo
003oooooooooo`05ooooo`03o`00Oooooooooooo00Cooooo0ol0000Hooooo`00:oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03_ooool00ooo003o
ooooo`00O`0<ooooo`05ool00?ooooooooooooooool007l01?ooool00ooo003oooooooooo`09oooo
o`04o`00Ooooooooooooool000[ooooo00Goo`00ooooooooooooooooo`00O`03ooooo`03ool00?oo
oooooooo00Wooooo00?oo`00o`00Ooooool02_ooool00ooo003oooooooooo`03ooooo`03o`00Oooo
oooooooo00?ooooo00?oo`00ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03ool00?oo
oooooooo00Kooooo00?o001oooooooooool00_oo0009ooooo`05ool00?ooooooooooooooool007l0
1?ooool00ooo003oooooooooo`09ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool0
2?ooool00ooo003o001oooooo`02ooooo`;oo`002Oooool00ooo003oooooo`00O`08ooooo`03ool0
0?oooooooooo00Gooooo00Co001oooooooooooooo`003_ooool00ol007ooooooool0000>ooooo`03
o`00Oooooooooooo00?ooooo1?oo0004ooooo`05ool00?ooooooooooooooool007l01oooool00ooo
003oooooooooo`06ooooo`04o`00Ooooooooooooool000Wooooo00?oo`00ooooooooool00_ooool0
0ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool01Oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool0
0ooo003oooooo`00O`0>ooooo`03ool00?oooooo001o00cooooo00Goo`00ooooooooooooooooo`00
O`05ooooo`03ool00?oooooooooo00Wooooo00?o001ooooooooo00002Oooool3ool000;ooooo00?o
001oooooooooool00_ooool00ooo003oooooooooo`08ooooo`03ool00?oooooo001o00_ooooo00?o
o`00ooooooooool00_ooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Ooooooooo`0000[ooooo00Go
o`00ooooooooooooooooo`00O`05ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool0
0_ooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool0
1oooool00ooo003oooooo`00O`09ooooo`03ool00?oooooooooo00Gooooo00?o001ooooooooo0000
3_ooool00ol007ooooooool0000?ooooo`03o`00Oooooooooooo00;ooooo1?oo0004ooooo`05ool0
0?ooooooooooooooool007l01oooool00ooo003oooooooooo`06ooooo`05o`00Oooooooooooooooo
oooo00002Oooool01Ooo003ooooooooooooooooo001o00Sooooo00?oo`00ooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo
00Kooooo00?o001oooooooooool03Oooool00ooo003o001oooooo`0>ooooo`03ool00?oooooo001o
00cooooo00Goo`00ooooooooooooooooo`00O`04ooooo`03ool00?oooooooooo00Wooooo00Co001o
ooooooooooooo`002Oooool00ooo003oooooooooo`02ooooo`05o`00Oooooooooooooooooooo0000
2_ooool00ooo003oooooo`00O`0;ooooo`03ool00?oooooooooo00?ooooo00?o001oooooooooool0
0oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool0
1_ooool00ol007ooooooool0000;ooooo`05ool00?ooooooooooooooool007l01?ooool00ooo003o
ooooooooo`09ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool01oooool2ool00004
o`00Ooooooooooooooooo`;oo`002Oooool00ooo003oooooo`00O`09ooooo`03ool00?oooooooooo
00Cooooo00Co001oooooooooooooo`003_ooool00ol007ooooooool0000;ooooo`04ool00?oooooo
ooooo`00O`Cooooo0ooo0006ooooo`05ool00?ooooooooooooooool007l01_ooool00ooo003ooooo
ooooo`07ooooo`04o`00Ooooooooooooool000Wooooo00?oo`00ooooooooool00_ooool00ol007oo
ooooooooo`06ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool01Oooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o
001oooooo`0=ooooo`03ool00?oooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`04oooo
o`03ool00?oooooooooo00[ooooo00?o001ooooooooo00002Oooool2ool000?ooooo00?o001ooooo
ooooool00_ooool00ooo003oooooooooo`08ooooo`03ool00?oooooo001o00_ooooo00?oo`00oooo
ooooool00_ooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Ooooooooo`0000[ooooo00Goo`00oooo
ooooooooooooo`00O`04ooooo`03ool00?oooooooooo00[ooooo00?o001oooooooooool00oooool0
0ooo003oooooooooo`07ooooo`03ool00?l007oooooo00?ooooo00?oo`00ooooooooool01_ooool2
ool00003ooooool007oooooo00Sooooo00?oo`00ooooooooool01Oooool00ol007ooooooool0000>
ooooo`03o`00Ooooooooo`0000cooooo00Coo`00oooooooooooo001o1?ooool3ool000Gooooo0_oo
0002ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01_ooool01Ol007oooooooooo
ooooooooo`0000Sooooo0_oo0003ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003o001oooooo`0>ooooo`03ool00?oo
oooo001o00cooooo00Goo`00ooooooooooooooooo`00O`04ooooo`03ool00?oooooooooo00Wooooo
00Co001oooooooooooooo`002Oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00;o
oooo00?oo`00ooooooooool01oooool00ooo003oooooo`00O`0;ooooo`03ool00?oooooooooo00?o
oooo00?o001oooooooooool00_ooool00ooo003oooooooooo`09ooooo`03o`00Oooooooooooo00Go
oooo00?oo`00ooooooooool01_ooool00ol007ooooooool0000;ooooo`05ool00?oooooooooooooo
ool007l01?ooool00ooo003oooooooooo`09ooooo`03o`00Oooooooooooo00?ooooo00?oo`00oooo
ooooool01oooool00ooo003oooooo`00O`04ooooo`03ool00?oooooooooo00Kooooo0_oo00000ooo
oooo001oooooo`08ooooo`03ool00?oooooooooo00Cooooo00Co001oooooooooooooo`003_ooool0
0ol007ooooooool0000;ooooo`?oo`0000?o001oooooooooool00_ooool00ooo003oooooooooo`06
ooooo`05ool00?ooooooooooooooool007l01_ooool00ooo003oooooooooo`07ooooo`04o`00Oooo
ooooooooool000Wooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`06ooooo`03ool0
0?oooooooooo00Gooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`0=ooooo`03ool0
0?oooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`04ooooo`03ool00?oooooooooo00[o
oooo00?o001ooooooooo00002Oooool2ool000?ooooo00?o001oooooooooool00_ooool00ooo003o
ooooooooo`08ooooo`03ool00?oooooo001o00_ooooo00?oo`00ooooooooool00_ooool00ol007oo
ooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ooo003o
ooooooooo`07ooooo`03o`00Ooooooooo`0000[ooooo00Goo`00ooooooooooooooooo`00O`04oooo
o`03ool00?oooooooooo00[ooooo00?o001oooooooooool00oooool00ooo003oooooooooo`06oooo
o`;oo`0000?o001oooooooooool00_ooool00ooo003oooooooooo`06ooooo`;oo`0000?oooooo`00
Ooooool02?ooool00ooo003oooooooooo`05ooooo`03o`00Ooooooooo`0000kooooo00Co001ooooo
ooooooooo`002_ooool2ool000;ooooo00?o001oooooooooool00_ooool00ooo003oooooool00005
ooooo`?oo`0000?oooooo`00Ooooool01Oooool2ool000Sooooo00Go001oooooooooooooooooool0
0008ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool01_ooool00ooo003ooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03ool00?l007oooooo00gooooo00Coo`00
oooooooooooo001o3?ooool01Ooo003ooooooooooooooooo001o00Cooooo00?oo`00ooooooooool0
2Oooool01?l007oooooooooooooo0009ooooo`03ool00?oooooooooo00;ooooo00?o001ooooooooo
ool00_ooool00ooo003oooooooooo`07ooooo`03ool00?oooooo001o00cooooo00?oo`00oooooooo
ool00_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Wooooo00?o001ooooooooo
ool01Oooool00ooo003oooooooooo`06ooooo`03o`00Ooooooooo`0000_ooooo00Goo`00oooooooo
ooooooooo`00O`04ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool00oooool00ooo
003oooooooooo`07ooooo`03ool00?oooooo001o00Cooooo00?oo`00ooooooooool01_ooool01?oo
003oooooooooool007l9ooooo`03ool00?oooooooooo00Cooooo00Co001oooooooooooooo`003_oo
ool00ol007ooooooool0000:ooooo`05ool00?ooooooo`00ool00?l007l01?ooool00ooo003ooooo
ooooo`07ooooo`04ool00?ooooooooooo`00O`Kooooo00?oo`00ooooooooool01oooool01Ol007oo
ooooooooooooooooo`0000Sooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`06oooo
o`03ool00?oooooooooo00Gooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`0=oooo
o`03ool00?oooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`04ooooo`03ool00?oooooo
oooo00[ooooo00?o001ooooooooo00002Oooool00ooo003oooooooooo`02ooooo`03o`00Oooooooo
oooo00;ooooo00?oo`00ooooooooool02?ooool00ooo003oooooo`00O`0;ooooo`03ool00?oooooo
oooo00;ooooo00?o001oooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?oo`00ooooooooool01oooool00ol007ooo`00ooooo`0:ooooo`05ool00?oooooo
ooooooooool007l01?ooool00ooo003oooooooooo`0:ooooo`03o`00Oooooooooooo00?ooooo00?o
o`00ooooooooool01_ooool00ooo003oooooo`00O`05ooooo`03ool00?oooooooooo00Gooooo00Co
o`00oooooooooooo001o2_ooool00ooo003oooooooooo`04ooooo`03o`00Ooooooooo`0000kooooo
00Co001oooooooooooooo`002Oooool00ooo003oooooool00002ool00005o`00Oooooooooooooooo
oooo00002Oooool2ool00003ooooool007oooooo00Gooooo00?oo`00ooooooooool01oooool01Ol0
07ooooooooooooooooooo`0000Sooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`06
ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00
Ooooool03Oooool01?oo003oooooooooool007l<ooooo`05ool00?ooooooooooooooool007l01?oo
ool00ooo003oooooooooo`09ooooo`04o`00Ooooooooooooool000Wooooo00?oo`00ooooooooool0
0_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooool007l0
3?ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool0
2Oooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001ooooooooo0000
2oooool01Ooo003ooooooooooooooooo001o00Cooooo00?oo`00ooooooooool02Oooool00ol007oo
ooooooooo`04ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooool007l01?ooool2ool000Ko
oooo00Goo`00ooooooooooooooooo`00O`09ooooo`03ool00?oooooooooo00Cooooo00Co001ooooo
ooooooooo`003_ooool00ol007ooooooool0000:ooooo`05ool00?ooooooo`00oooooooo00001?oo
ool00ooo003oooooooooo`08ooooo`03ool00?oooooo001o00Kooooo00?oo`00ooooooooool01ooo
ool01Ol007ooooooooooooooooooo`0000Oooooo00?oo`00ooooooooool00oooool00ol007oooooo
ooooo`06ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool01Oooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001o
ooooo`0=ooooo`03ool00?oooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`04ooooo`03
ool00?oooooooooo00[ooooo00?o001ooooooooo00002Oooool00ooo003oooooooooo`02ooooo`03
o`00Oooooooooooo00;ooooo00?oo`00ooooooooool01oooool01?oo003oooooooooool007l;oooo
o`03ool00?oooooooooo00;ooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`09oooo
o`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01oooool00ol007ooo`00ooooo`0;oooo
o`04ool00?ooooooooooo`00O`Cooooo00?oo`00ooooooooool02_ooool00ol007ooooooooooo`03
ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooool007l01Oooool00ooo003oooooooooo`05
ooooo`04ool00?ooooooooooo`00O`[ooooo00?oo`00ooooooooool01?ooool00ol007ooooooool0
000>ooooo`04o`00Ooooooooooooool000Wooooo00?oo`00ooooooooool00_oo00000ol007oooooo
ooooo`02ool000[ooooo00?oo`00ooooool007l01_ooool00ooo003oooooooooo`07ooooo`05o`00
Oooooooooooooooooooo00002?ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00Ko
oooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Ko
oooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003o001o
ooooo`0=ooooo`04ool00?ooooooooooo`00O`cooooo00Goo`00ooooooooooooooooo`00O`03oooo
o`03ool00?oooooooooo00[ooooo00Co001oooooooooooooo`002Oooool00ooo003oooooooooo`02
ooooo`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool01oooool00ooo003oooooo`00O`0<
ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`09
ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ol007ooo`00ooooo`0;
ooooo`05ool00?ooooooooooooooool007l01?ooool00ooo003oooooooooo`09ooooo`03o`00Oooo
oooooooo00Cooooo00?oo`00ooooooooool01_ooool00ooo003oooooo`00O`05ooooo`03ool00?oo
oooooooo00Cooooo00Goo`00ooooooooooooooooo`00O`09ooooo`03ool00?oooooooooo00Cooooo
00Co001oooooooooooooo`003_ooool00ol007ooooooool00009ooooo`;oo`000oooool00ooo003o
ooooooooo`02ool000_ooooo00?oo`00ooooool007l01Oooool00ooo003oooooooooo`08ooooo`05
o`00Oooooooooooooooooooo00001oooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo
00Kooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo
00gooooo00?oo`00ooooool007l03?ooool01Ooo003ooooooooooooooooo001o00Cooooo00?oo`00
ooooooooool02_ooool01?l007oooooooooooooo0008ooooo`03ool00?oooooooooo00;ooooo00?o
001oooooooooool00oooool00ooo003oooooooooo`06ooooo`04ool00?ooooooooooo`00O`_ooooo
00?oo`00ooooooooool00_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Wooooo
00?o001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03o`00Oooo003ooooo00_ooooo
00Coo`00oooooooooooo001o1?ooool00ooo003oooooooooo`0:ooooo`03o`00Oooooooooooo00?o
oooo00?oo`00ooooooooool01_ooool00ooo003oooooo`00O`05ooooo`03ool00?oooooooooo00Go
oooo00Coo`00oooooooooooo001o2_ooool00ooo003oooooooooo`04ooooo`03o`00Ooooooooo`00
00kooooo00Co001oooooooooooooo`002Oooool01_oo003oooooooooooooooooo`00o`00O`;ooooo
0_oo000:ooooo`03ool00?oooooo001o00Gooooo0_oo0009ooooo`05o`00Oooooooooooooooooooo
00001oooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo00?oo`00oooooooo
ool01Oooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool03Oooool00ooo003o001oooooo`0=ooooo`04ool0
0?ooooooooooo`00O`cooooo00Goo`00ooooooooooooooooo`00O`03ooooo`03ool00?oooooooooo
00[ooooo00Co001oooooooooooooo`002?ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooo
oooo00;ooooo00?oo`00ooooooooool01_ooool2ool00003ooooool007oooooo00_ooooo00?oo`00
ooooooooool00_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00Wooooo00?o001o
ooooooooool01Oooool00ooo003oooooooooo`06ooooo`03o`00Oooo003ooooo00_ooooo00Goo`00
ooooooooooooooooo`00O`03ooooo`03ool00?oooooooooo00[ooooo00?o001oooooooooool01?oo
ool00ooo003oooooooooo`06ooooo`03ool00?oooooo001o00Gooooo00?oo`00ooooooooool01?oo
ool01Ooo003ooooooooooooooooo001o00[ooooo00?oo`00ooooooooool00oooool00ol007oooooo
ool0000?ooooo`03o`00Ooooooooo`0000Wooooo00?oo`00ooooooooool00_ooool2ool00003oooo
oooo003oo`0000_ooooo00?oo`00ooooool007l01Oooool00ooo003oooooooooo`08ooooo`05o`00
Oooooooooooooooooooo00001oooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Ko
oooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo00co
oooo0_oo00000ooooooo001oooooo`0;ooooo`05ool00?ooooooooooooooool007l00oooool00ooo
003oooooooooo`0;ooooo`04o`00Ooooooooooooool000Sooooo00?oo`00ooooooooool00_ooool0
0ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Kooooo00Coo`00oooooooooooo001o2ooo
ool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00;ooooo00?oo`00ooooooooool02Ooo
ool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Oooooo0_oo000<ooooo`04ool00?oo
ooooooooo`00O`?ooooo00?oo`00ooooooooool02oooool00ol007ooooooooooo`03ooooo`03ool0
0?oooooooooo00Kooooo00?oo`00ooooool007l01Oooool00ooo003oooooooooo`04ooooo`05ool0
0?ooooooooooooooool007l02_ooool00ooo003oooooooooo`04ooooo`03o`00Ooooooooo`0000ko
oooo00Co001oooooooooooooo`002?ooool2ool000?ooooo0ooo00000oooooooo`00ooooo`0:oooo
o`03ool00?oooooo001o00Gooooo0_oo0009ooooo`05o`00Oooooooooooooooooooo00001oooool0
0ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01Oooool0
0ooo003oooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo
00Gooooooon::n9OohX[hPOooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?oo`00o`00Ooooool03?ooool01?oo003oooooooooool007l=
ooooo`04ool00?ooooooooooo`00O`?ooooo00?oo`00ooooooooool02oooool01?l007oooooooooo
oooo0007ooooo`03ool00?oooooooooo00?ooooo00?o001oooooooooool00oooool00ooo003ooooo
ooooo`06ooooo`04ool00?ooooooooooo`00O`_ooooo00?oo`00ooooooooool00_ooool00ol007oo
ooooooooo`02ooooo`03ool00?oooooooooo00Wooooo00?o001oooooooooool01Oooool00ooo003o
ooooooooo`07ooooo`03ool00?oooooooooo00_ooooo00Coo`00oooooooooooo001o0oooool00ooo
003oooooooooo`0;ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool01_ooool00ooo
003oooooo`00O`05ooooo`03ool00?oooooooooo00Cooooo00Goo`00ooooooooooooooooo`00O`0:
ooooo`03ool00?oooooooooo00Cooooo00?o001ooooooooo00003_ooool01?l007oooooooooooooo
0008ooooo`03ool00?oooooooooo00;ooooo0ooo00000oooooooo`00ooooo`0;ooooo`03ool00?l0
07oooooo00Cooooo00?oo`00ooooooooool02?ooool01Ol007ooooooooooooooooooo`0000Oooooo
00?oo`00ooooooooool00oooool00ol007ooooooooooo`06ooooo`03ool00?oooooooooo00Gooooo
00?oo`00ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03?ooool01Ooo003ooooooooo
oooooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`03ooooo`03ool00?oooooooooo00[o
oooo00Co001oooooooooooooo`002?ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo
00?ooooo00?oo`00ooooooooool01Oooool01?oo003oooooooooool007l<ooooo`03ool00?oooooo
oooo00;ooooo00Go001oooooooooooooooooool0000<ooooo`03o`00Oooooooooooo00Gooooo00?o
o`00ooooooooool01_ooool00ol007ooo`00ooooo`0<ooooo`04ool00?ooooooooooo`00O`?ooooo
00?oo`00ooooooooool02_ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Gooooo
00Coo`00oooooooooooo001o1Oooool00ooo003oooooooooo`04ooooo`05ool00?oooooooooooooo
ool007l02_ooool00ooo003oooooooooo`03ooooo`03o`00Ooooooooo`0000oooooo00?o001ooooo
oooo00002Oooool00ooo003oooooooooo`02ooooo`04o`00Oooo003oo`00ool000cooooo00?oo`00
ooooool007l01?ooool00ooo003oooooooooo`09ooooo`05o`00Oooooooooooooooooooo00001ooo
ool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01?oo
ool00ooo003o001oooooo`06ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo00cooooo00Coo`00oooooooooooo001o
3Oooool01?oo003oooooooooool007l3ooooo`03ool00?oooooooooo00_ooooo00Co001ooooooooo
ooooo`001oooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00?ooooo00?oo`00oooo
ooooool01Oooool2ool000;ooooo00?o001oooooooooool02_ooool01Ooo003ooooooooooooooooo
001o00Cooooo00?oo`00ooooooooool02Oooool00ol007ooooooooooo`05ooooo`03ool00?oooooo
oooo00Oooooo00?oo`00ooooooooool02oooool01?oo003oooooooooool007l3ooooo`03ool00?oo
oooooooo00_ooooo00?o001oooooooooool00oooool00ooo003oooooooooo`06ooooo`03ool00?oo
oooo001o00Kooooo00?oo`00ooooooooool00oooool01Ooo003ooooooooooooooooo001o00[ooooo
00?oo`00ooooooooool01?ooool00ol007ooooooool0000>ooooo`04o`00Ooooooooooooool000Oo
oooo0_oo0005ooooo`?oo`003Oooool00ooo003o001oooooo`03ooooo`03ool00?oooooooooo00Wo
oooo00Go001oooooooooooooooooool00007ooooo`03ool00?oooooooooo00?ooooo00?o001ooooo
ooooool01oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00Kooooo00?o0000oooo
ooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03
ool00?l007oooooo00cooooo00Goo`00ooooooooooooooooo`00O`0<ooooo`05ool00?oooooooooo
ooooool007l00oooool00ooo003oooooooooo`0:ooooo`04o`00Ooooooooooooool000Sooooo00?o
o`00ooooooooool00oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Gooooo00Co
o`00oooooooooooo001o3?ooool00ooo003oooooooooo`02ooooo`05o`00Oooooooooooooooooooo
00003?ooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?o001oool00?oo
ool03?ooool01?oo003oooooooooool007l3ooooo`03ool00?oooooooooo00[ooooo00?o001ooooo
ooooool01?ooool00ooo003oooooooooo`05ooooo`04ool00?ooooooooooo`00O`Gooooo00?oo`00
ooooooooool01?ooool01Ooo003ooooooooooooooooo001o00[ooooo00?oo`00ooooooooool00ooo
ool00ol007ooooooool0000?ooooo`03o`00Ooooooooo`0000Sooooo00?oo`00ooooooooool00ooo
ool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo00?ooooo00?oo`00ooooooooool02Ooo
ool01Ol007ooooooooooooooooooo`0000Oooooo00?oo`00ooooooooool00oooool00ol007oooooo
ooooo`06ooooo`03ool00?oooooooooo00Cooooo00?oo`00o`00Ooooool01_ooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001o
ooooo`0<ooooo`04ool00?ooooooooooo`00O`gooooo00Coo`00oooooooooooo001o0oooool00ooo
003oooooooooo`0;ooooo`04o`00Ooooooooooooool000Oooooo00?oo`00ooooooooool00oooool0
0ol007ooooooooooo`04ooooo`03ool00?oooooooooo00?ooooo0_oo0003ooooo`03o`00Oooooooo
oooo00[ooooo00Goo`00ooooooooooooooooo`00O`03ooooo`03ool00?oooooooooo00[ooooo00?o
001oooooooooool01Oooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo00_ooooo00Co
o`00oooooooooooo001o0oooool00ooo003oooooooooo`0;ooooo`03o`00Oooooooooooo00?ooooo
00?oo`00ooooooooool01_ooool00ooo003oooooo`00O`06ooooo`03ool00?oooooooooo00?ooooo
00Goo`00ooooooooooooooooo`00O`0:ooooo`03ool00?oooooooooo00Cooooo00?o001oool00?oo
ool03_ooool01?l007oooooooooooooo0007ooooo`;oo`001Oooool00ooo003oooooool0000=oooo
o`03ool00?l007oooooo00?ooooo00?oo`00ooooooooool02Oooool01Ol007oooooooooooooooooo
o`0000Oooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`07ooooo`03ool00?oooooo
oooo00Cooooo00?oo`00ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03?ooool01Ooo
003ooooooooooooooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`02ooooo`03ool00?oo
oooooooo00_ooooo00Co001oooooooooooooo`002?ooool00ooo003oooooooooo`03ooooo`03o`00
Oooooooooooo00?ooooo0_oo0005ooooo`;oo`000_ooool00ol007ooooooooooo`0:ooooo`03ool0
0?oooooooooo00;ooooo00Go001oooooooooooooooooool0000<ooooo`03o`00Oooooooooooo00Go
oooo00?oo`00ooooooooool01_ooool00ol007ooo`00ooooo`0<ooooo`04ool00?ooooooooooo`00
O`?ooooo00?oo`00ooooooooool02_ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo
00Gooooo00Coo`00oooooooooooo001o1_ooool00ooo003oooooooooo`03ooooo`05ool00?oooooo
ooooooooool007l02_ooool00ooo003oooooooooo`03ooooo`03o`00Ooooooooo`0000oooooo00?o
001ooooooooo00002?ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00kooooo00?o
o`00o`00Ooooool00oooool00ooo003oooooooooo`09ooooo`05o`00Oooooooooooooooooooo0000
1_ooool00ooo003oooooooooo`04ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool0
1?ooool00ooo003o001oooooo`06ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo00_ooooo0_oo0002ooooo`03o`00
Oooooooooooo00_ooooo00Coo`00oooooooooooo001o0oooool00ooo003oooooooooo`0;ooooo`04
o`00Ooooooooooooool000Oooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`04oooo
o`03ool00?oooooooooo00?ooooo0_oo0003ooooo`03o`00Oooooooooooo00[ooooo00Goo`00oooo
ooooooooooooo`00O`03ooooo`03ool00?oooooooooo00[ooooo00?o001oooooooooool01Oooool0
0ooo003oooooooooo`07ooooo`03ool00?oooooooooo00_ooooo00Coo`00oooooooooooo001o0ooo
ool00ooo003oooooooooo`0;ooooo`03o`00Oooooooooooo00?ooooo00?oo`00ooooooooool01Ooo
ool01?oo003oooooooooool007l6ooooo`03ool00?oooooooooo00;ooooo0_oo0003ooooo`03o`00
Oooooooooooo00Sooooo00?oo`00ooooooooool01?ooool00ol007ooo`00ooooo`0>ooooo`04o`00
Ooooooooooooool000Oooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`0=ooooo`03
ool00?l007oooooo00?ooooo00?oo`00ooooooooool02Oooool01Ol007ooooooooooooooooooo`00
00Oooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo
00?ooooo00?oo`00o`00Ooooool01oooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03?ooool01Ooo003o
oooooooooooooooo001o00cooooo00Goo`00ooooooooooooooooo`00O`02ooooo`03ool00?oooooo
oooo00_ooooo00Co001oooooooooooooo`001oooool00ooo003oooooooooo`04ooooo`03o`00Oooo
oooooooo00Cooooo00?oo`00ooooooooool00_ooool2ool000?ooooo00?o001oooooooooool02_oo
ool00ooo003oooooooooo`02ooooo`04o`00Ooooooooooooool000gooooo00?o001oooooooooool0
1Oooool00ooo003oooooooooo`06ooooo`03ool00?oooooooooo00cooooo00Coo`00oooooooooooo
001o0oooool00ooo003oooooooooo`0:ooooo`03o`00Oooooooooooo00Cooooo00?oo`00oooooooo
ool01Oooool01?oo003oooooooooool007l6ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooo
ooooool00_ooool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o001ooooo
oooo00003oooool01?l007oooooooooooooo0007ooooo`03ool00?oooooooooo00?ooooo00?o001o
ooooooooool03_ooool00ooo003o001oooooo`02ooooo`03ool00?oooooooooo00[ooooo00Go001o
ooooooooooooooooool00006ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01_oo
ool00ooo003oooooooooo`04ooooo`03ool00?l007oooooo00Kooooo00?o0000ooooooooool05ooo
ool3o`0000Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`0;ooooo`;oo`000_oo
ool00ol007ooooooooooo`0;ooooo`04ool00?ooooooooooo`00O`?ooooo00?oo`00ooooooooool0
2oooool01?l007oooooooooooooo0007ooooo`03ool00?oooooooooo00?ooooo00?o001ooooooooo
ool01Oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00?o001ooooooooo
ool02_ooool01Ooo003ooooooooooooooooo001o00?ooooo00?oo`00ooooooooool02_ooool00ol0
07ooooooooooo`06ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool02oooool01?oo
003oooooooooool007l3ooooo`03ool00?oooooooooo00_ooooo00?o001oooooooooool00oooool0
0ooo003oooooooooo`05ooooo`04ool00?ooooooooooo`00O`Oooooo00Coo`00oooooooooooooooo
0_oo0003ooooo`03o`00Oooooooooooo00Sooooo00?oo`00ooooooooool01?ooool00ol007ooo`00
ooooo`0>ooooo`04o`00Ooooooooooooool000Oooooo00?oo`00ooooooooool01?ooool00ol007oo
ooooooooo`0=ooooo`03ool00?l007oooooo00?ooooo00?oo`00ooooooooool02Oooool01Ol007oo
ooooooooooooooooo`0000Oooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`07oooo
o`03ool00?oooooooooo00?ooooo00?oo`00o`00Ooooool01Oooool3o`0001Sooooo000[ooooo`;o
00001oooool00ol007ooooooooooo`0=ooooo`03ool00?l007oooooo00cooooo00Goo`00oooooooo
ooooooooo`00O`0=ooooo`04ool00?ooooooooooo`00O`;ooooo00?oo`00ooooooooool02oooool0
1Ol007ooooooooooooooooooo`0000Kooooo00?oo`00ooooooooool01?ooool00ol007oooooooooo
o`04ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool00_ooool00ol007oooooooooo
o`0;ooooo`05ool00?ooooooooooooooool007l00_ooool00ooo003oooooooooo`0;ooooo`03o`00
Oooooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`0<ooooo`04ool0
0?ooooooooooo`00O`?ooooo00?oo`00ooooooooool02_ooool00ol007ooooooooooo`04ooooo`03
ool00?oooooooooo00Gooooo00Coo`00oooooooooooo001o1_ooool2ool000?ooooo00?oo`00oooo
ooooool00_ooool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o001oool0
0?ooool03oooool01?l007oooooooooooooo0007ooooo`03ool00?oooooooooo00?ooooo00?o001o
ooooooooool03_ooool00ooo003o001oooooo`02ooooo`03ool00?oooooooooo00[ooooo00Go001o
ooooooooooooooooool00006ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01_oo
ool00ooo003oooooooooo`04ooooo`03ool00?l007oooooo00Gooooo0_l0000Iooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`0;ooooo`05ool00?oo
ooooooooooooool007l03Oooool01?oo003oooooooooool007l2ooooo`03ool00?oooooooooo00co
oooo00Co001oooooooooooooo`001oooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo
00Gooooo00Coo`00oooooooooooooooo0_oo0004ooooo`03o`00Oooooooooooo00[ooooo00Goo`00
ooooooooooooooooo`00O`03ooooo`03ool00?oooooooooo00[ooooo00?o001oooooooooool01_oo
ool00ooo003oooooooooo`05ooooo`;oo`003Oooool01?oo003oooooooooool007l3ooooo`03ool0
0?oooooooooo00_ooooo00?o001oooooooooool00oooool00ooo003oooooooooo`05ooooo`04ool0
0?ooooooooooo`00O`Oooooo00Goo`00ooooooooooooooooool00004ooooo`03o`00Oooooooooooo
00Wooooo00?oo`00ooooooooool00oooool00ol007ooo`00ooooo`0>ooooo`04o`00Oooooooooooo
ool000Oooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`0=ooooo`03ool00?l007oo
oooo00;ooooo00?oo`00ooooooooool02_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
oooo00Cooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`07ooooo`03ool00?oooooo
oooo00?ooooo00?oo`00o`00Ooooool01oooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Ooooool03?ooool01Ooo
003ooooooooooooooooo001o00gooooo00Coo`00oooooooooooo001o0_ooool00ooo003ooooooooo
o`0;ooooo`05o`00Oooooooooooooooooooo00001_ooool00ooo003oooooooooo`04ooooo`03o`00
Oooooooooooo00Cooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`02ooooo`03o`00
Oooooooooooo00_ooooo00Goo`00ooooooooooooooooo`00O`02ooooo`03ool00?oooooooooo00_o
oooo00?o001oooooooooool01Oooool00ooo003oooooooooo`06ooooo`03ool00?oooooooooo00co
oooo00Coo`00oooooooooooo001o0_ooool00ooo003oooooooooo`0;ooooo`03o`00Oooooooooooo
00Cooooo00?oo`00ooooooooool01Oooool01?oo003oooooooooool007l7ooooo`05ool00?oooooo
oooooooooooo00001?ooool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o
001oool00?ooool03oooool01?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Cooooo
00?o001oooooooooool03_ooool00ooo003o001oooooo`02ooooo`03ool00?oooooooooo00[ooooo
00Go001oooooooooooooooooool00006ooooo`03ool00?oooooooooo00Cooooo00?o001ooooooooo
ool01oooool00ooo003oooooooooo`03ooooo`03ool00?l007oooooo00Kooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00o`00Oooo
ool02oooool01Ooo003ooooooooooooooooo001o00gooooo00Coo`00oooooooooooo001o0_ooool0
0ooo003oooooooooo`0<ooooo`04o`00Ooooooooooooool000Oooooo00?oo`00ooooooooool00ooo
ool00ol007ooooooooooo`05ooooo`05ool00?oooooooooooooooooo00001Oooool00ol007oooooo
ooooo`0;ooooo`04ool00?ooooooooooo`00O`?ooooo00?oo`00ooooooooool02_ooool00ol007oo
ooooooooo`06ooooo`03ool00?oooooooooo00Gooooo00?oo`00o`00Ooooool03Oooool00ooo003o
ooooo`00O`03ooooo`03ool00?oooooooooo00_ooooo00?o001oooooooooool00oooool00ooo003o
ooooooooo`05ooooo`04ool00?ooooooooooo`00O`Oooooo0_oo00000oooooooo`00ool00004oooo
o`03o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0>oooo
o`04o`00Ooooooooooooool000Oooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`0>
ooooo`03ool00?oooooooooo00;oo`003?ooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
oooo00?ooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`07ooooo`03ool00?oooooo
oooo00?ooooo00?oo`00o`00Ooooool01oooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00ooooooooool02_ooool00ooo
003oooooooooo`02ooooo`03o`00Oooooooooooo00_ooooo00Coo`00oooooooooooo001o0_ooool0
0ooo003oooooooooo`0;ooooo`05o`00Oooooooooooooooooooo00001_ooool00ooo003ooooooooo
o`04ooooo`03o`00Oooooooooooo00Cooooo0_oo0003ooooo`03ool00?oooooooooo00;ooooo00?o
001oooooooooool02oooool01Ooo003ooooooooooooooooo001o00;ooooo00?oo`00ooooooooool0
2oooool00ol007ooooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool0
3?ooool01?oo003oooooooooool007l2ooooo`03ool00?oooooooooo00_ooooo00?o001ooooooooo
ool01?ooool00ooo003oooooooooo`05ooooo`04ool00?ooooooooooo`00O`Oooooo00Coo`00oooo
ooooooooo`001Oooool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00?ooooo00?o001o
ool00?ooool03oooool01?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Cooooo00?o
001oooooooooool03_ooool01_oo003o001ooooooooo003oooooool000cooooo00Go001ooooooooo
ooooooooool00006ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01oooool00ooo
003oooooooooo`03ooooo`03ool00?l007oooooo00Kooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00o`00Ooooool02oooool01Ooo
003ooooooooooooooooo001o00gooooo00Coo`00oooooooooooo001o0_ooool00ooo003ooooooooo
o`0<ooooo`04o`00Ooooooooooooool000Kooooo00?oo`00ooooooooool01?ooool00ol007oooooo
ooooo`06ooooo`04ool00?ooooooooooool000Gooooo00?o001oooooooooool02oooool01?oo003o
ooooooooool007l3ooooo`03ool00?oooooooooo00[ooooo00?o001oooooooooool01_ooool00ooo
003oooooooooo`05ooooo`03ool00?l007oooooo00gooooo00?oo`00ooooool007l00oooool00ooo
003oooooooooo`0;ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool01?ooool01?oo
003oooooooooool007l7ooooo`Goo`001?ooool00ol007ooooooooooo`09ooooo`03ool00?oooooo
oooo00?ooooo00?oo`00ooooooooool03_ooool01?l007oooooooooooooo0006ooooo`03ool00?oo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ooo003oooooooooo`02ool000cooooo00?o
001oooooooooool00_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00Cooooo00?o
001oooooooooool01oooool00ooo003oooooooooo`03ooooo`03ool00?l007oooooo00Oooooo00?o
0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`03ool00?oooooooooo00[ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0;
ooooo`04ool00?ooooooooooo`00O`;ooooo00?oo`00ooooooooool02oooool01Ol007oooooooooo
ooooooooo`0000Kooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`05ooooo`;oo`00
00?oooooool00?ooool01?ooool00ol007ooooooooooo`0;ooooo`05ool00?ooooooooooooooool0
07l00_ooool00ooo003oooooooooo`0;ooooo`03o`00Oooooooooooo00Gooooo00?oo`00oooooooo
ool01_ooool00ooo003oooooooooo`0<ooooo`04ool00?ooooooooooo`00O`;ooooo00?oo`00oooo
ooooool02oooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Gooooo00Coo`00oooo
oooooooo001o1oooool3ool000Kooooo00?o001oooooooooool02Oooool00ooo003oooooooooo`02
ooooo`03ool00?oooooooooo00oooooo00Co001oooooooooooooo`001_ooool00ooo003ooooooooo
o`04ooooo`03o`00Oooooooooooo00oooooo00Coo`00oooooooo003oo`003Oooool01Ol007oooooo
ooooooooooooo`0000Gooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`07ooooo`03
ool00?oooooooooo00?ooooo00?oo`00o`00Ooooool01_ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`0;ooooo`05
ool00?ooooooooooooooool007l03Oooool01?oo003oooooooooool007l2ooooo`03ool00?oooooo
oooo00cooooo00Co001oooooooooooooo`001_ooool00ooo003oooooooooo`04ooooo`03o`00Oooo
oooooooo00Kooooo00?oo`00oooooooo00001_ooool00ol007ooooooooooo`0;ooooo`04ool00?oo
ooooooooo`00O`;ooooo00?oo`00ooooooooool02oooool00ol007ooooooooooo`06ooooo`03ool0
0?oooooooooo00Gooooo00?oo`00o`00Ooooool03Oooool00ooo003oooooo`00O`03ooooo`03ool0
0?oooooooooo00_ooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`04ooooo`04ool0
0?ooooooooooo`00O`Sooooo0ooo0005ooooo`03o`00Oooooooooooo00Wooooo00?oo`00oooooooo
ool00oooool00ooo003oooooooooo`0>ooooo`04o`00Ooooooooooooool000Kooooo00?oo`00oooo
ooooool01Oooool00ol007ooooooooooo`0>ooooo`03ool00?ooooooo`0000;oo`003?ooool00ol0
07ooooooooooo`02ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool01?ooool00ol0
07ooooooooooo`07ooooo`03ool00?oooooooooo00?ooooo00?oo`00o`00Ooooool01oooool00ol0
003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?oo`00ooooooooool02_ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00_o
oooo00Coo`00oooooooooooo001o0_ooool00ooo003oooooooooo`0;ooooo`05o`00Oooooooooooo
oooooooo00001Oooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?oo`00
oooooooo00001Oooool00ol007ooooooooooo`0;ooooo`05ool00?ooooooooooooooool007l00_oo
ool00ooo003oooooooooo`0;ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool01_oo
ool00ooo003oooooooooo`0=ooooo`03ool00?oooooo001o00;ooooo00?oo`00ooooooooool02ooo
ool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Gooooo00Coo`00oooooooooooo001o
2?ooool2ool000Kooooo00?o001oooooooooool02Oooool00ooo003oooooooooo`02ooooo`03ool0
0?oooooooooo00oooooo00Co001oooooooooooooo`001_ooool00ooo003oooooooooo`04ooooo`03
o`00Oooooooooooo00oooooo1?oo000=ooooo`03o`00Oooooooooooo00;ooooo00?oo`00oooooooo
ool00_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00Oooooo00?oo`00oooooooo
ool00_ooool00ooo003oooooo`00O`07ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo00_ooooo00Goo`00oooooooo
ooooooooo`00O`0=ooooo`04ool00?ooooooooooo`00O`;ooooo00?oo`00ooooooooool03?ooool0
1?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01ooo
ool2ool000Kooooo00?o001oooooooooool02oooool01?oo003oooooooooool007l2ooooo`03ool0
0?oooooooooo00_ooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`05ooooo`03ool0
0?l007oooooo00gooooo00?oo`00ooooool007l00_ooool00ooo003oooooooooo`0<ooooo`03o`00
Oooooooooooo00Cooooo00?oo`00ooooooooool01?ooool01?oo003oooooooooool007l8ooooo`;o
o`001_ooool00ol007ooooooooooo`09ooooo`03ool00?oooooooooo00?ooooo00?oo`00oooooooo
ool03_ooool01?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ooo003oooooool00002ool000cooooo00?o001oooooooooool00_ooool00ooo
003oooooooooo`03ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool01oooool00ooo
003oooooooooo`03ooooo`03ool00?l007oooooo00Oooooo00?o0000ooooooooool05_ooool002_o
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?oooooooooo00[o
oooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0;ooooo`06ool00?ooooooooooo`00
Ooooooooo`003_ooool01Ol007ooooooooooooooooooo`0000Gooooo00?oo`00ooooooooool01Ooo
ool00ol007ooooooooooo`07ooooo`;oo`001Oooool00ol007ooooooooooo`0<ooooo`06ool00?oo
ooooooooo`00Ooooooooo`003_ooool00ol007ooooooooooo`06ooooo`03ool00?oooooooooo00Co
oooo00?oo`00o`00Ooooool03_ooool00ooo003oooooo`00O`02ooooo`03ool00?oooooooooo00_o
oooo00?o001oooooooooool01?ooool00ooo003oooooooooo`04ooooo`05ool00?oooooooooooooo
ool007l02Oooool00ooo003oooooooooo`04ooooo`03o`00Oooooooooooo00Wooooo00?oo`00oooo
ooooool00_ooool00ooo003oooooooooo`0?ooooo`04o`00Ooooooooooooool000Kooooo00?oo`00
ooooooooool01?ooool00ol007ooooooooooo`0?ooooo`;oo`003oooool00ol007ooooooooooo`02
ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`07
ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooool007l01oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`0:
ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool02oooool01?oo003oooooooooool0
07l2ooooo`03ool00?oooooooooo00cooooo00Co001oooooooooooooo`001_ooool00ooo003ooooo
ooooo`04ooooo`03o`00Oooooooooooo00Oooooo0_oo0006ooooo`03o`00Oooooooooooo00_ooooo
00Coo`00oooooooooooo001o0_ooool00ooo003oooooooooo`0;ooooo`03o`00Oooooooooooo00Ko
oooo00?oo`00ooooooooool01Oooool00ooo003o001oooooo`0=ooooo`03ool00?oooooo001o00;o
oooo00?oo`00ooooooooool03?ooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Co
oooo00Coo`00oooooooooooo001o4?ooool00ol007ooooooooooo`09ooooo`03ool00?oooooooooo
00?ooooo00?oo`00ooooooooool03_ooool01?l007oooooooooooooo0006ooooo`03ool00?oooooo
oooo00Gooooo00?o001oooooooooool03_ooool01Ooo003oooooool00?ooooooo`0000cooooo00?o
001oooooooooool00_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00Cooooo00?o
001oooooooooool01oooool00ooo003oooooooooo`03ooooo`03ool00?l007oooooo00Oooooo00?o
0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`03ool00?oooooooooo00[ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0;
ooooo`06ool00?ooooooooooo`00Ooooooooo`003_ooool01Ol007ooooooooooooooooooo`0000Go
oooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`07ooooo`;oo`001Oooool00ol007oo
ooooooooo`0<ooooo`06ool00?ooooooooooo`00Ooooooooo`003_ooool00ol007ooooooooooo`06
ooooo`03ool00?oooooooooo00Cooooo00?oo`00o`00Ooooool03_ooool00ooo003oooooo`00O`02
ooooo`03ool00?oooooooooo00_ooooo00?o001oooooooooool01?ooool00ooo003oooooooooo`04
ooooo`05ool00?ooooooooooooooool007l04?ooool00ol007ooooooooooo`09ooooo`03ool00?oo
oooooooo00;ooooo00?oo`00ooooooooool03oooool01?l007oooooooooooooo0006ooooo`03ool0
0?oooooooooo00Cooooo00?o001oooooooooool03oooool2ool000oooooo00?o001oooooooooool0
0_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool0
1oooool00ooo003oooooooooo`02ooooo`03ool00?oooooo001o00Oooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00o`00Ooooool0
2_ooool00ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00_ooooo00Coo`00oooooooooooo
001o0_ooool00ooo003oooooooooo`0<ooooo`04o`00Ooooooooooooool000Kooooo00?oo`00oooo
ooooool01?ooool00ol007ooooooooooo`08ooooo`03ool00?oooooooooo00Cooooo00?o001ooooo
ooooool02oooool01_oo003oooooooooool007ooooooool000kooooo00?o001oooooooooool01_oo
ool00ooo003oooooooooo`04ooooo`;oo`0000?o001oooooooooool03?ooool00ooo003oooooo`00
O`02ooooo`03ool00?oooooooooo00cooooo00?o001oooooooooool01?ooool00ooo003ooooooooo
o`04ooooo`04ool00?ooooooooooo`00Oa3ooooo00?o001oooooooooool02Oooool2ool000Cooooo
00?oo`00ooooooooool03_ooool01?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooo`00ooooo`0>ooooo`03o`00Oooooooooooo00;o
oooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00Oo
oooo00?oo`00ooooooooool00_ooool00ooo003oooooo`00O`08ooooo`03o`000?oooooooooo01Ko
oooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003ooooo
ooooo`02ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool00_ooool00ol007oooooo
ooooo`0;ooooo`06ool00?ooooooooooo`00Ooooooooo`003_ooool01Ol007oooooooooooooooooo
o`0000Gooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00cooooo00Koo`00oooooooooooo001ooooooooo000>ooooo`03o`00Oooooooooooo00Kooooo
00?oo`00ooooooooool01?ooool00ooo003o001oooooo`0>ooooo`03ool00?oooooo001o00;ooooo
00?oo`00ooooooooool02oooool00ol007ooooooooooo`04ooooo`03ool00?oooooooooo00Cooooo
00Goo`00ooooooooooooooooo`00O`0@ooooo`03o`00Oooooooooooo00Wooooo00?oo`00oooooooo
ool00_ooool00ooo003oooooooooo`0?ooooo`04o`00Ooooooooooooool000Kooooo00?oo`00oooo
ooooool01?ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool00_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Gooooo00?o001ooooo
ooooool01oooool00ooo003oooooooooo`02ooooo`03ool00?oooooo001o00Oooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00o`00
Ooooool00oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00;ooooo00?o001ooooo
ooooool02oooool01_oo003oooooooooool007ooooooool000oooooo00Co001oooooooooooooo`00
1Oooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
2oooool01_oo003oooooooooool007ooooooool000kooooo00?o001oooooooooool01_ooool00ooo
003oooooooooo`04ooooo`03ool00?oooooo001o00kooooo00?oo`00ooooool007l00_ooool00ooo
003oooooooooo`0<ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool00oooool01Ooo
003ooooooooooooooooo001o013ooooo00?o001oooooooooool02_ooool01?oo003ooooooooooooo
ool2ool0013ooooo00Co001oooooooooooooo`001_ooool00ooo003oooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`07ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00ooooool007l02?ooool00ol0003oooooooooo`0Fooooo`00:ooo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00ooooooooool00_oo
ool2ool000Kooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0;ooooo`06ool00?oo
ooooooooo`00Ooooooooo`003_ooool01Ol007ooooooooooooooooooo`0000Gooooo00?oo`00oooo
ooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo00Koo`00oooo
oooooooo001ooooooooo000>ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool01?oo
ool00ooo003o001oooooo`0>ooooo`05ool00?oooooo001ooooooooo00003_ooool00ol007oooooo
ooooo`05ooooo`03ool00?oooooooooo00?ooooo00Goo`00ooooooooooooooooo`00O`0@ooooo`03
o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0?ooooo`04
o`00Ooooooooooooool000Kooooo00?oo`00ooooooooool01?ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool00ooo003oooooooooo`02oooo
o`03ool00?oooooooooo00Gooooo00?o001oooooooooool01oooool00ooo003oooooooooo`02oooo
o`03ool00?oooooo001o00Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?oo`00o`00Ooooool00oooool00ooo003oooooooooo`04oooo
o`03ool00?oooooooooo00;ooooo00?o001oooooooooool03?ooool01Ooo003oooooo`00Oooooooo
o`0000oooooo00Co001oooooooooooooo`001Oooool00ooo003oooooooooo`05ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool02oooool01_oo003oooooooooool007ooooooool000ko
oooo00?o001oooooooooool01_ooool00ooo003oooooooooo`04ooooo`03ool00?oooooo001o00ko
oooo00?oo`00ooooool007l00_ooool00ooo003oooooooooo`0<ooooo`03o`00Oooooooooooo00Co
oooo00?oo`00ooooooooool00oooool01Ooo003ooooooooooooooooo001o013ooooo00?o001ooooo
ooooool02_ooool01_oo003oooooooooooooooooo`00o`00Oa3ooooo00Co001oooooooooooooo`00
1_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool0
1Oooool00ol007ooooooooooo`08ooooo`07ool00?oooooooooooooooooo003oooooo`00O`08oooo
o`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ooo003oooooooooo`02ooooo`;oo`001Oooool2ool000Cooooo00?o001ooooooooo
ool02oooool01_oo003oooooooooool007ooooooool000kooooo00Go001oooooooooooooooooool0
0005ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0<ooooo`05ool00?ooooooooooo`00Oooo00003oooool00ol007ooooooooooo`06ooooo`03ool0
0?oooooooooo00Cooooo00?oo`00o`00Ooooool03_ooool01Ooo003oooooo`00Ooooooooo`0000ko
oooo00?o001oooooooooool01Oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00;o
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0:ooooo`05ool00?ooooooooooool0
0?l007l04Oooool01?l007oooooooooooooo0006ooooo`03ool00?oooooooooo00Cooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00Goo`00
ooooooooooooooooool00008ooooo`03o`00Oooooooooooo00Oooooo00Goo`00oooooooooooooooo
ool00002ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00o`00Ooooool00_ooool00ooo003ooooo
ool00005ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool03?ooool01Ooo003ooooo
o`00Ooooooooo`0000oooooo00Co001oooooooooooooo`001Oooool00ooo003oooooooooo`05oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool02oooool2ool00004ooooool007oooooo
ool000kooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`04ooooo`03ool00?oooooo
001o00kooooo00?oo`00ooooool007l00_ooool00ooo003oooooooooo`0<ooooo`03o`00Oooooooo
oooo00Cooooo00?oo`00ooooooooool00oooool01Ooo003ooooooooooooooooo001o013ooooo00?o
001oooooooooool02_ooool01_oo003oooooooooooooooooo`00o`00Oa3ooooo00Co001ooooooooo
ooooo`001_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooo
ooooool01Oooool00ol007ooooooooooo`08ooooo`07ool00?oooooooooooooooooo003oooooo`00
O`08ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ooo003oooooooooo`02ooooo`;oo`001Oooool00ooo003oooooooooo`03
ooooo`03o`00Oooooooooooo00_ooooo00Koo`00oooooooooooo001ooooooooo000>ooooo`05o`00
Oooooooooooooooooooo00001Oooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03?ooool01Ooo003oooooooooool007ooo`0000oooooo00?o001ooooo
ooooool01_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooo001o00oooooo00Goo`00oooo
ool007ooooooool0000>ooooo`03o`00Oooooooooooo00Gooooo00?oo`00ooooooooool00_ooool0
0ooo003oooooooooo`02ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02_ooool0
1Ooo003ooooooooooooo003o001o017ooooo00Co001oooooooooooooo`001_ooool00ooo003ooooo
ooooo`04ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`02ooooo`05ool00?oooooooooooooooooo00002?ooool00ol007ooooooooooo`07ooooo`05
ool00?oooooooooooooooooo00000_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo
00;ooooo00?oo`00oooooooo00001?ooool2ool000Cooooo00?o001oooooooooool03?ooool01Ooo
003oooooo`00Ooooooooo`0000oooooo00Co001oooooooooooooo`001Oooool00ooo003ooooooooo
o`05ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03?ooool01Ooo003oooooo`00
Ooooooooo`0000kooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`04ooooo`03ool0
0?oooooo001o00kooooo00?oo`00ooooool007l00_ooool00ooo003oooooooooo`0<ooooo`03o`00
Oooooooooooo00Cooooo00?oo`00ooooooooool00oooool01Ooo003ooooooooooooooooo001o013o
oooo00?o001oooooooooool02_ooool00ooo003oooooooooo`02ool00003o`00Oooooooooooo00ko
oooo00Co001oooooooooooooo`001_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`03ool00?oooooooooo
00;ooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`08ooooo`07ool00?oooooooooo
oooooooo003oooooo`00O`08ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooo
o`0000Cooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`0;ooooo`06ool00?oooooo
ooooo`00Ooooooooo`003_ooool01Ol007ooooooooooooooooooo`0000Cooooo00?oo`00oooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00gooooo00Coo`00ooooool0
07ooo`003oooool00ol007ooooooooooo`06ooooo`03ool00?oooooooooo00?ooooo00?oo`00oooo
ool007l03oooool01Ooo003oooooo`00Ooooooooo`0000kooooo00?o001oooooooooool01Oooool0
0ooo003oooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0:ooooo`05ool00?ooooooooooool00?l007l04Oooool01?l007oooooooooo
oooo0006ooooo`03ool00?oooooooooo00Cooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00Goo`00ooooooooooooooooool00008ooooo`03
o`00Oooooooooooo00Sooooo00Coo`00ooooooooooooo`000_ooool00ol007ooooooooooo`05oooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03ool00?l007oooooo00;ooooo00?oo`00oooooooo00001?ooool00ooo003oooooooooo`03oooo
o`03o`00Oooooooooooo00cooooo00Goo`00ooooool007ooooooool0000?ooooo`04o`00Oooooooo
ooooool000Gooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00cooooo00Coo`00ooooool007ooo`003oooool00ol007ooooooooooo`06ooooo`03ool0
0?oooooooooo00Cooooo00?oo`00ooooool007l03oooool01?oo003o001ooooooooo000?ooooo`03
o`00Oooooooooooo00Cooooo00?oo`00ooooooooool00oooool01Ooo003ooooooooooooooooo001o
013ooooo00?o001oooooooooool02_ooool2ool00004oooooooo003oo`00o`00Oa3ooooo00Co001o
ooooooooooooo`001_ooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`03ooooo`05ool00?oooooooooooooooooo0000
1oooool00ol007ooooooooooo`08ooooo`04ool00?ooooooooooool000;ooooo00?o001ooooooooo
ool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool2o`0000Oooooo00?o001oooooooooool0
3_ooool00ooo003oooooooooo`02ooooo`03ool00?ooooooo`0000Cooooo00?oo`00ooooooooool0
0oooool00ol007ooooooooooo`0<ooooo`05ool00?oooooo001ooooooooo00003_ooool01Ol007oo
ooooooooooooooooo`0000Cooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00gooooo00Coo`00ooooool007ooo`003oooool00ol007ooooooooooo`06
ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooool007l03oooool01Ooo003oooooo`00Oooo
ooooo`0000kooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooooooo00;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0:ooooo`05ool00?oo
ooooo`00ooooool007l04Oooool01?l007oooooooooooooo0005ooooo`03ool00?oooooooooo00Go
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;o
oooo00Goo`00ooooooooooooooooool00008ooooo`03o`00Oooooooooooo00Sooooo00Coo`00oooo
ooooooooo`000_ooool00ol007ooooooooooo`04ooooo`;o00006Oooool3o`0000Kooooo00?o001o
ooooooooool03_ooool00ooo003o001oooooo`02ooooo`03ool00?ooooooo`0000Cooooo00?oo`00
ooooooooool00oooool00ol007ooooooooooo`0<ooooo`05ool00?oooooo001ooooooooo00003ooo
ool01Ol007ooooooooooooooooooo`0000Cooooo00?oo`00ooooooooool01Oooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00gooooo00?oo`00o`00Oooo00003oooool00ol007oooooo
ooooo`06ooooo`03ool00?oooooooooo00?ooooo00Coo`00oooooooooooo001o3oooool01?oo003o
001ooooooooo000?ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool00oooool01Ooo
003ooooooooooooooooo001o013ooooo00?o001oooooooooool02oooool01Ooo003oooooool00?oo
oooo001o013ooooo00Go001oooooooooooooooooool00005ooooo`03ool00?oooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo
00Goo`00ooooooooooooooooool00007ooooo`03o`00Oooooooooooo00Sooooo00Coo`00oooooooo
ooooo`000_ooool00ol007ooooooooooo`04ooooo`?o00006?ooool002_ooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooooooo
00001?ooool00ooo003oooooooooo`03ooooo`03o`00Oooooooooooo00cooooo00Goo`00ooooool0
07ooooooool0000>ooooo`05o`00Oooooooooooooooooooo00001?ooool00ooo003oooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ooo003o001oool0000?
ooooo`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool00oooool00ooo003oooooo`00O`0?
ooooo`05ool00?oooooo001ooooooooo00003_ooool00ol007ooooooooooo`05ooooo`03ool00?oo
oooooooo00;ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00[ooooo00Goo`00oooooooo003oooooo`00O`0Aooooo`04o`00Ooooooooooooool000Go
oooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool00_ooool01Ooo003oooooooooooooooooo`0000Sooooo00?o001ooooo
ooooool02?ooool01?oo003ooooooooooooo0002ooooo`03o`00Oooooooooooo00Gooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?oo`00
o`00Ooooool00_ooool01?oo003ooooooooooooo0003ooooo`03ool00?oooooooooo00?ooooo00?o
001oooooooooool03?ooool01Ooo003oooooo`00Ooooooooo`0000oooooo00Go001ooooooooooooo
ooooool00004ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0=ooooo`03ool00?l007ooo`0000oooooo00?o001oooooooooool01_ooool00ooo003o
ooooooooo`03ooooo`04ool00?ooooooooooo`00O`oooooo00Coo`00o`00Ooooooooo`003oooool0
0ol007ooooooooooo`04ooooo`03ool00?oooooooooo00?ooooo00Goo`00ooooooooooooooooo`00
O`0@ooooo`03o`00Oooooooooooo00_ooooo0_oo0002ooooo`03o`00Oooooooooooo00kooooo00Go
001oooooooooooooooooool00005ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00Goo`00oooooooooooo
ooooool00007ooooo`03o`00Oooooooooooo00Sooooo00Coo`00ooooooooooooo`000_ooool00ol0
07ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ooo003oooooooooo`02ooooo`04ool00?ooooooooooool0
00?ooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`0<ooooo`04ool00?oooooo001o
ool000oooooo00Go001oooooooooooooooooool00004ooooo`03ool00?oooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`?oo`003oooool00ol007oooooooooo
o`06ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooool007l03oooool01Ooo003oooooo`00
Ooooooooo`0000kooooo00?o001oooooooooool01Oooool00ooo003oooooooooo`02ooooo`03ool0
0?oooooooooo00;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0;ooooo`04ool0
0?ooooooooooo`00Oa7ooooo00Co001oooooooooooooo`001Oooool00ooo003oooooooooo`05oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02oooo
o`05ool00?oooooooooooooooooo00002?ooool00ol007ooooooooooo`08ooooo`04ool00?oooooo
ooooool000;ooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`02ooooo`04ool00?oo
ooooooooool000?ooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`0<ooooo`05ool0
0?oooooo001ooooooooo00003oooool01Ol007ooooooooooooooooooo`0000Cooooo00?oo`00oooo
ooooool01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00gooooo0ooo000?oooo
o`03o`00Oooooooooooo00Kooooo00?oo`00ooooooooool00oooool01?oo003oooooooooool007l?
ooooo`04ool00?l007ooooooool000oooooo00?o001oooooooooool01?ooool00ooo003ooooooooo
o`02ooooo`03ool00?oooooooooo00;ooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0;ooooo`;oo`000_ooool00ol007ooooooooooo`0>ooooo`05o`00Oooooooooooooooooooo0000
1Oooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`03ooooo`05ool00?oooooooooooooooooo00001oooool00ol007oo
ooooooooo`09ooooo`03ool00?ooooooo`0000;ooooo00?o001oooooooooool01_ooool00ol0003o
ooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?oo`00ooooooooool00_ooool01?oo003ooooooooooooo0003ooooo`03ool00?oooooooooo00?o
oooo00?o001oooooooooool03?ooool01?oo003oooooo`00Oooo000?ooooo`05o`00Oooooooooooo
oooooooo00001?ooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ooo003oooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?oo`00
ooooooooool00oooool00ooo003oooooo`00O`0@ooooo`03ool00?l007ooo`0000oooooo00?o001o
ooooooooool01Oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0;ooooo`04ool00?ooooooooooo`00Oa7ooooo00Co
001oooooooooooooo`001Oooool00ooo003oooooooooo`05ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`05ool00?oooooooooooooooooo
00002?ooool00ol007ooooooooooo`08ooooo`04ool00?ooooooooooool000;ooooo00?o001ooooo
ooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001ooooo
ooooool03_ooool00ooo003o001oooooo`02ooooo`04ool00?ooooooooooool000?ooooo00?oo`00
ooooooooool00oooool00ol007ooooooooooo`0<ooooo`05ool00?oooooo001ooooooooo00003ooo
ool01Ol007ooooooooooooooooooo`0000Cooooo00?oo`00ooooooooool01Oooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?oo`00ooooooooool03_ooool00ol007oooooo
ooooo`07ooooo`03ool00?oooooooooo00;ooooo00Coo`00oooooooooooo001o3oooool01?oo003o
001ooooooooo000?ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool00_ooool00ooo
003oooooooooo`02ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02oooool01Ooo
003ooooooooooooooooo001o013ooooo00Go001oooooooooooooooooool00004ooooo`03ool00?oo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00?ooooo00Goo`00ooooooooooooooooool00007ooooo`03o`00Oooooooooooo00Wooooo
00?oo`00oooooooo00000_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo
000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool01Ooo003ooooooooo
ooooooooo`0000?ooooo00Coo`00ooooooooooooo`001_ooool00ol007ooooooooooo`0<ooooo`04
ool00?oooooo001oool000oooooo00Go001oooooooooooooooooool00004ooooo`03ool00?oooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooo
001o013ooooo00?oo`00o`00Oooo00003oooool00ol007ooooooooooo`05ooooo`03ool00?oooooo
oooo00;ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool01?l007oooooooooooooo0005ooooo`03ool00?oo
oooooooo00Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00?ooooo00Coo`00ooooooooooooo`002?ooool00ol007ooooooooooo`08ooooo`04ool0
0?ooooooooooool000;ooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`02ooooo`04
ool00?ooooooooooool000?ooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`0<oooo
o`04ool00?oooooo001oool0013ooooo00Go001oooooooooooooooooool00004ooooo`03ool00?oo
oooooooo00Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool01oooool00ooo003oooooooooo`02ooooo`04ool00?oo
ooooooooo`00Oa3ooooo00?oo`00oooooooo00003oooool00ol007ooooooooooo`04ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool01Ol007ooooooooooooooooooo`0000Co
oooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool00oooool01?oo003ooooooooooooo0008ooooo`03o`00Oooooooooooo
00Wooooo00?oo`00oooooooo00000_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo
01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool01Ooo003o
ooooooooooooooooo`0000?ooooo00Coo`00ooooooooooooo`001_ooool00ol007ooooooooooo`0<
ooooo`04ool00?oooooo001oool000oooooo00?o001oooooooooool00_ooool01Ooo003ooooooooo
ooooooooo`0000Sooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`03ooooo`03ool0
0?oooooo001o013ooooo00?oo`00o`00Oooo00003oooool00ol007ooooooooooo`05ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007oooooooooooooo0005ooooo`03
ool00?oooooooooo00Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00?ooooo00Coo`00ooooooooooooo`002?ooool00ol007ooooooooooo`08oooo
o`03ool00?ooooooo`0000?ooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ooo003o001oooooo`02oooo
o`04ool00?ooooooooooool000?ooooo00?oo`00ooooooooool00oooool00ol007ooooooooooo`0<
ooooo`04ool00?oooooo001oool0013ooooo00Go001oooooooooooooooooool00004ooooo`03ool0
0?oooooooooo00Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool01oooool00ooo003oooooooooo`02ooooo`04ool0
0?ooooooooooo`00Oa3ooooo00?oo`00oooooooo00003oooool00ol007ooooooooooo`04ooooo`03
ool00?oooooooooo00;ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool01Ol007ooooooooooooooooooo`00
00Cooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool00oooool01?oo003ooooooooooooo0008ooooo`03o`00Oooooooo
oooo00Wooooo00?oo`00oooooooo00000_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooo
oooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool01Ooo
003oooooooooooooooooo`0000?ooooo00Coo`00ooooooooooooo`001_ooool00ol007oooooooooo
o`0<ooooo`04ool00?oooooo001oool000oooooo00?o001oooooooooool00_ooool01Ooo003ooooo
ooooooooooooo`0000Sooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ooo003oooooooooo`03ooooo`03
ool00?oooooo001o013ooooo00?oo`00o`00Oooo00003oooool00ol007ooooooooooo`05ooooo`03
ool00?oooooooooo00;ooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01?l007oooooooooooooo0005oooo
o`03ool00?oooooooooo00Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00?ooooo00Coo`00ooooooooooooo`002?ooool00ol007ooooooooooo`09
ooooo`;oo`000oooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03ool00?l007oooooo00;ooooo00Coo`00
ooooooooooooo`000_ooool00ooo003oooooooooo`04ooooo`03o`00Oooooooooooo00cooooo00Co
o`00ooooool007ooo`004?ooool01Ol007ooooooooooooooooooo`0000Cooooo00?oo`00oooooooo
ool01Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00;ooooo00Coo`00oooooooo
oooo001o4?ooool2ool0013ooooo00?o001oooooooooool01Oooool01Ooo003ooooooooooooooooo
o`0000Cooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00Go001oooooooooooooooooool00004ooooo`03ool00?oooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00Co
o`00ooooooooooooo`002?ooool00ol007ooooooooooo`09ooooo`;oo`000oooool00ol007oooooo
ooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03_ooool01Ooo003oooooooooooooooooo`0000?ooooo00Coo`00oooooooooooo
o`001_ooool00ol007ooooooooooo`0<ooooo`04ool00?oooooo001oool000oooooo00?o001ooooo
ooooool00_ooool01Ooo003oooooooooooooooooo`0000Sooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool0
0ooo003oooooooooo`03ooooo`03ool00?oooooo001o017ooooo00?oo`00ooooooooool03_ooool0
0ol007ooooooooooo`05ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool00_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
1Ol007ooooooooooooooooooo`0000Cooooo00?oo`00ooooooooool01Oooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00oooool00ooo003oooooool0
0009ooooo`03o`00Oooooooooooo00Wooooo0_oo0003ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
o`00o`00Ooooool00_ooool01ooo003oooooooooooooooooo`00oooooooo00001_ooool00ol007oo
ooooooooo`0=ooooo`03ool00?l007ooo`00013ooooo00Go001oooooooooooooooooool00003oooo
o`03ool00?oooooooooo00Kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01oooool00ooo003oooooooooo`02oooo
o`04ool00?ooooooooooo`00Oa3ooooo0_oo000@ooooo`03o`00Oooooooooooo00Gooooo00Goo`00
ooooooooooooooooool00004ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`05o`00Oooooooooooooooooooo00001?ooool00ooo003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`03ooooo`04ool00?ooooooooooool000Sooooo00?o001oooooooooool02Oooool2ool000?o
oooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00Goo`00ooooooooooooooooool00004ooooo`03
ool00?ooooooo`0000Kooooo00?o001oooooooooool03?ooool00ooo003oooooool0000@ooooo`03
o`00Oooooooooooo00;ooooo00Goo`00ooooooooooooooooool00008ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00Kooooo00?oo`00ooooooooool00_ooool01?oo003oooooooooool007lAooooo`03ool00?oooooo
oooo00kooooo00?o001oooooooooool01Oooool01Ooo003oooooooooooooooooo`0000Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go
001oooooooooooooooooool00004ooooo`03ool00?oooooooooo00Gooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00?oo`00oooooooo0000
2Oooool00ol007ooooooooooo`09ooooo`;oo`000oooool00ol007ooooooooooo`05ooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`05ool0
0?l007oooooooooooooo00001?ooool00ooo003oooooool00006ooooo`03o`00Oooooooooooo00go
oooo00?oo`00o`00Oooo00004?ooool01Ol007ooooooooooooooooooo`0000?ooooo00?oo`00oooo
ooooool01_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`07ooooo`03ool00?oooooooooo00;ooooo00Coo`00oooo
oooooooo001o4?ooool00ooo003oooooooooo`0?ooooo`03o`00Oooooooooooo00Gooooo00Goo`00
ooooooooooooooooool00004ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`05o`00Oooooooooooooooooooo00001?ooool00ooo003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`03ooooo`04ool00?ooooooo`00ool000Sooooo00?o001oooooooooool02_ooool01Ooo003o
oooooooooooooooo001o00Sooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`05ool00?oooooooooooooooooo00001?ooool00ooo
003oooooool00006ooooo`03o`00Oooooooooooo00gooooo0_oo000@ooooo`03o`00Oooooooooooo
00;ooooo00Goo`00ooooooooooooooooool00008ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00Goo`00
ooooooooooooooooool00002ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`05ooooo`05ool00?oooooooooooooooooo00001Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol007oooooo
ooooooooooooo`0000Cooooo00?oo`00ooooooooool01Oooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool00oooool00ooo003oooooool00009ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool01Ooo003o001oooooooooooooo`00
00Cooooo00?oo`00oooooooo00001_ooool00ol007ooooooooooo`0=ooooo`03ool00?l007ooo`00
013ooooo00Go001oooooooooooooooooool00003ooooo`03ool00?oooooooooo00Kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01oooool00ooo003oooooooooo`02ooooo`04ool00?ooooooooooo`00Oa3ooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`05ooooo`05ool00?oooooooooooooooooo0000
1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool01Ol007ooooooooooooooooooo`0000Cooooo00?oo`00ooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool2ool000Wo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Ko
oooo000Looooo`?o00000oooool2o`0000Oooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`05ool00?oooooooooooooooooo00001?ooool00ooo003oooooool00006ooooo`03
o`00Oooooooooooo00gooooo0_oo000@ooooo`03o`00Oooooooooooo00;ooooo00Coo`00oooooooo
ooooo`002Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`07ooooo`05ool00?oooooooooooooooooo00000_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool0
1Ooo003oooooooooooooooooo`0000Gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00Go001oooooooooooooooooool00004ooooo`03ool0
0?oooooooooo00Gooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00?ooooo0_oo000:ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1Oooool00ol0003oooooooooo`09ooooo`?o00000oooool2o`0000Kooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`05ool00?l007oooooooooooooo00001?ooool3ool000Ko
oooo00?o001oooooooooool03Oooool2ool0017ooooo00Go001oooooooooooooooooool00003oooo
o`03ool00?oooooooooo00Kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01oooool01?oo003oooooooooooooool2
ool000;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00Gooooo00Goo`00ooooooooooooooooool00004ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`05o`00Oooooooooooooooooooo0000
1?ooool00ooo003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`04ooooo`;oo`002Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool001gooooo00Go0000oooooooooooooooo
o`000002ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`05ool00?oooooooooooooooooo00001?ooool2ool000Oooooo00?o001ooooooooo
ool03Oooool2ool0013ooooo00?o001oooooooooool00_ooool01?oo003ooooooooooooo0009oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Oooooo00Goo`00ooooooooooooooooool00002ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`05ool00?oooooo
oooooooooooo00001Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool01Ol007ooooooooooooooooooo`0000?ooooo00?oo`00ooooooooool0
1_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
0oooool2ool000[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`00
0?oooooooooo00[ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`05ool00?l007oooooooooo
oooo00001?ooool2ool000Oooooo00?o001oooooooooool03_ooool00ooo003oooooooooo`0?oooo
o`05o`00Oooooooooooooooooooo00000oooool00ooo003oooooooooo`06ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00Oooooo00Goo`00ooooooooooooooooool00003ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`05ooooo`04ool00?ooooooooooool000Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00Go001oooooooooooooooooool00004ooooo`03ool00?oooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00?oo`00oooooooo
ool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000oooooooo
ool05_ooool001[ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000oooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`05ool00?oooooooooooooooooo00001Oooool00ooo
003oooooooooo`05ooooo`03o`00Oooooooooooo00gooooo0_oo000@ooooo`03o`00Oooooooooooo
00;ooooo00Coo`00ooooooooooooo`002Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`05ool00?oooooo
oooooooooooo00000_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool01Ooo003oooooooooooooooooo`0000Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go001ooooooooooooo
ooooool00003ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo00?oo`00ooooooooool02?ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool01oooool5o`0000;o
oooo00Co0000oooooooooooo00001Oooool3o`0000Kooooo00?o001oooooooooool03_ooool01Ooo
003o001oooooooooooooo`0000gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`05o`00Oooooooooooooooooooo00000_ooool00ooo003oooooooooo`07ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Oooooo00Goo`00ooooooooooooooooool00003ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`05ooooo`04ool00?ooooooooooool000Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00Go001oooooooooooooooooool00004ooooo`03ool00?oooooooooo00Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`03ooooo`Co00006?ooool001[ooooo00Co0000oooooooo
oooo00000oooool01?l0003oooooooooool00006ooooo`?o00001_ooool00ol007ooooooooooo`0>
ooooo`05ool00?oooooooooooooooooo00003Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool00_ooool01?oo003ooooooooooooo0009ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00Oooooo00Goo`00ooooooooooooooooool00002ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`04ool00?ooooooooooool0
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00Go001oooooooooooooooooool00003ooooo`03ool00?oooooooooo00Kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`03ooooo`?o00002Oooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`05ool00?l007oooooooooooooo00003Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool00_ooool00ooo003oooooool00009ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Sooooo00Coo`00ooooooooooooo`000oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool01Oooool01?oo003ooooooooooooo0005
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`05o`00Oooooooooooooooooooo00000oooool00ooo003oooooooooo`07ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`006oooool0
0ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`05ool00?oooooooooooooooooo00003Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool01?oo003ooooo
oooooooo0009ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00Goo`00ooooooooooooooooool00002oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06oooo
o`04ool00?ooooooooooool000Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00Go001oooooooooooooooooool00003ooooo`03ool00?oo
oooooooo00Kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooool000000oooool01?l0003oooooooooool00005ooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool03_ooool01Ooo003o001oooooooooooooo`0000go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00;o
oooo00?oo`00oooooooo00002Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`08ooooo`04ool00?ooooooooooool0
00?ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00Gooooo00Coo`00ooooooooooooo`001Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool01Ol007ooooooooooooooooooo`0000?ooooo00?o
o`00ooooooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o
0000ooooooooool05_ooool001cooooo0_l00003ooooo`04o`000?ooooooooooo`0000Kooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`05ool00?oooooooooooooooooo0000
3Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
0_ooool01?oo003ooooooooooooo0009ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00Goo`00oooooooo
ooooooooool00002ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`06ooooo`04ool00?ooooooooooool000Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00Go001oooooooooooooooooool0
0003ooooo`03ool00?oooooooooo00Kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`05ooooo`03o`000?oooooooooo00Wooooo0_l00003ooooo`04o`000?ooooooooooo`0000Gooooo
00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`05ool00?l007oooooooooooooo
00003Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool00_ooool00ooo003oooooool00009ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo00Coo`00oooooooo
ooooo`000oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool01Oooool01?oo003ooooooooooooo0005ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`05o`00Oooooooooooooooooooo00000ooo
ool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_oo
ool00ol0003oooooooooo`0Fooooo`007Oooool00ol0003oooooooooo`02ooooo`;o00001oooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00Goo`00ooooooooooooooooool0
000=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`02ooooo`04ool00?ooooooooooool000Wooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01oooool01Ooo003ooooo
ooooooooooooo`0000;ooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Kooooo00Coo`00ooooooooooooo`001Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol007oooooooooooooooooo
o`0000?ooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`;o00001_ooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00Goo`00o`00Ooooooooooooool0
000=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`02ooooo`03ool00?ooooooo`0000Wooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02?ooool01?oo003ooooooooo
oooo0003ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`05ooooo`04ool00?ooooooooooool000Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00Go001oooooooooooooooooool00003oooo
o`03ool00?oooooooooo00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06oooo
o`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool03_ooool01Ooo003oooooooooooooooooo`0000gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00?oo`00oooooooo00002Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`07ooooo`04ool00?ooooooooooool000?ooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00Coo`00ooooooooooooo`001Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool01Ol007ooooooooooooooooooo`0000?ooooo00?oo`00ooooooooool01_ooool00ol007oooooo
ooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00Goo`00o`00Ooooooooooooool0000=ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`02ooooo`03
ool00?ooooooo`0000Wooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool02?ooool01?oo003ooooooooooooo0003oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`05oooo
o`04ool00?ooooooooooool000Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00Go001oooooooooooooooooool00003ooooo`03ool00?oo
oooooooo00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oo
oooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool0
1Ooo003oooooooooooooooooo`0000gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00?ooooo00?oo`00oooooooo00002Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`07ooooo`04ool00?ooooooooooool000?ooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00Coo`00ooooooooooooo`001Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol007oo
ooooooooooooooooo`0000?ooooo00?oo`00ooooooooool01_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00Goo`00o`00Ooooooooooooool0000=ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`02ooooo`03ool00?oooooo
o`0000Wooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool02?ooool00ooo003oooooool00004ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`06ooooo`03ool00?oooooo
o`0000Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooo
oooo00kooooo00Go001oooooooooooooooooool00003ooooo`03ool00?oooooooooo00Oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool01Ooo003ooooooooooooo
ooooo`0000gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00?ooooo0_oo000:ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo00Coo`00ooooooooooooo`00
0oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1_ooool01?oo003ooooooooooooo0005ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Oooooooooooooooooooo00000_ooool00ooo
003oooooooooo`07ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03oooool01?oo
003ooooooooooooo000=ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`02ooooo`03ool00?ooooooo`0000Wooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02?ooool0
0ooo003oooooool00004ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`06ooooo`03ool00?ooooooo`0000Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool0
1?oo003ooooooooooooo0009ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_oo
ool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00Goo`00ooooooooooooooooool0000=ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`03ooooo`;oo`002_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`07ooooo`04ool00?ooooooooooool000?ooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?oo`00oooooooo00001_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool01Ol007oooooo
ooooooooooooo`0000;ooooo00?oo`00ooooooooool01oooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00oooooo00Coo`00ooooooooooooo`003Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool00_ooool2ool000[ooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool02?ooool00ooo003oooooool00004ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`06ooooo`03ool00?ooooooo`0000Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool00_ooool01?oo003ooooooooooooo0009ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00Goo`00ooooooooooooooooool0000=ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`03ooooo`;oo`002_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`08ooooo`03ool00?ooooooo`0000?ooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Oooooo0_oo0006ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Oooooooo
oooooooooooo00000_ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03oooool01?oo003ooooooooooooo000=ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool02?ooool00ooo003oooooool00004ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`06ooooo`;oo`001_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`02ooooo`03ool00?ooooooo`0000[ooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03_ooool01?oo003ooooooooooooo000>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`03ooooo`;oo`002_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`08ooooo`03ool00?ooooooo`0000?ooooo00?o001oooooooooool03oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Oooooo0_oo0006ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`05o`00Oooooooooooooooooooo
00000_ooool00ooo003oooooooooo`07ooooo`03o`00Oooooooooooo00oooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool03oooool01?oo003ooooooooooooo000=ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`03ooooo`03ool00?oooooooooo00Sooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool02?ooool00ooo003oooooool00004ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`06ooooo`;oo`001_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02oooo
o`03ool00?ooooooo`0000[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06oooo
o`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool03_ooool01?oo003ooooooooooooo000>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo00?oo`00oooo
oooo00000oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01oooool2ool000Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00Go001oooooooooooooooooool00002ooooo`03ool00?oooooo
oooo00Oooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`04ool00?oooooo
ooooool000gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool02?ooool3ool000Cooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00Oooooo00?oo`00ooooooooool01?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`02ooooo`03ool00?ooooooo`0000[ooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooo
oooo00Kooooo00?o001oooooooooool03_ooool01?oo003ooooooooooooo000>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Sooooo0ooo0003ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00;ooooo00?oo`00oooooooo00002Ooo
ool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00Coo`00ooooooooooooo`00
3Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`09ooooo`;oo`001?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`03ool0
0?ooooooo`0000[ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`00
0?oooooooooo01Kooooo000[ooooo`;o00001oooool00ol007ooooooooooo`0>ooooo`04ool00?oo
ooooooooool000kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool02?ooool2ool000Cooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
0_ooool2ool000[ooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`;o0000
6Oooool3o`0000Kooooo00?o001oooooooooool03oooool01?oo003ooooooooooooo000=ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool00ooo003oooooool0000:ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool3o`0001Sooooo000[ooooo`03o`00
0?oooooooooo00Kooooo00?o001oooooooooool03_ooool01?oo003ooooooooooooo000>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Wooooo00?oo`00ooooooooool00_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`02ooooo`;o
o`002_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00Coo`00oooooooo
ooooo`003Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00?oo`00oooo
oooo00002_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000oooo
ooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`04
ool00?ooooooooooool000kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`02oooo
o`;oo`002_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00Coo`00oooo
ooooooooo`003Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00?oo`00
oooooooo00002_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000
ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`04ool00?ooooooooooool000kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`02
ooooo`;oo`002_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00Coo`00
ooooooooooooo`003Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo0_oo
000;ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooooooo
o`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00Coo`00
ooooooooooooo`003_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00;ooooo00?o
o`00ooooooooool02Oooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00?o
o`00oooooooo00003_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00?ooooo00?o
o`00ooooooooool02Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o
0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`04ool00?ooooooooooool000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03oooool00ooo003oooooool0
000>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`04o`00Oooo003oooooool000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03oooool00ooo003oooooool0000>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o
0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`04o`00Oooo003oooooool000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03oooool00ooo003oooooool0
000>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`04o`00Oooo003oooooool000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03oooool00ooo003oooooool0000>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o
0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`04o`00Oooo003oooooool000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03oooool00ooo003oooooool0
000>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`04o`00Oooo003oooooool000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool03oooool00ooo003oooooool0000>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Kooooo00?o
0000ooooooooool05_ooool002_ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`04o`00Oooo003oooooool000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03oooool00ooo003oooooool0
000>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool05_ooool002_ooooo00?o0000
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`04o`00Oooo003oooooool000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01Oooool00ol0003oooooooooo`0Gooooo`?o00001_ooool00ol007oooooooooo
o`0?ooooo`03ool00?ooooooo`0000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool3o`0001Sooooo000[
ooooo`;o00001oooool00ol007ooooooooooo`0>ooooo`04o`00Oooo003oooooool000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01?ooool2o`0001Wooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0?ooooo`03ool00?ooooooo`0000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooooooo
o`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00Co001o
ool00?ooooooo`003_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`03ool00?ooooooo`0000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00Co001oool00?ooooooo`003_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0?ooooo`03ool00?ooooooo`0000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooooooo
o`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00Co001o
ool00?ooooooo`003_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`03ool00?ooooooo`0000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00Co001oool00?ooooooo`003_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0?ooooo`03ool00?ooooooo`0000kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003ooooooooo
o`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00Co001o
ool00?ooooooo`003_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`03ool00?ooooooo`0000kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oool00?oo00003oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0?
ooooo`03ool00?ooooooo`0000kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oool0
0?oo00003oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool01_ooool00ol007ooooooooooo`0?ooooo`03ool00?ooooooo`0000kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oool00?oo00003oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooo003oo`0000kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00
:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oool00?oo0000
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
1_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo003oo`0000kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
1_ooool00ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oool00?oo00003oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
003ooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Fooooo`00:oooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oool00?oo00003oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`05ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooo003ooooo00kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool0
0ol0003oooooooooo`0Fooooo`00:oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oool00?oo00003oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo
01Oooooo0ol00006ooooo`03o`00Oooooooooooo00oooooo00?o001oool00?ooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`04ooooo`?o00006?ooool002_ooooo0_l00007ooooo`03o`00Oooooooooooo00ko
oooo00?o001ooooooooo00003oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`;o00006Oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00?o001oool00?ooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo
00?o001oooooooooool03_ooool00ol007ooooooool0000?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo
00?o001oool00?ooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo
000[ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`06ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0?ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`06ooooo`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Gooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0?ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool03oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[oooo
o`03o`000?oooooooooo00Gooooo00?o0000o`00Ooooool03oooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0003oooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`000?oooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0003oooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol007ooooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03_ooool00ol0003oooooooooo`0?oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`000?oooooooooo00kooooo00?o001oooooooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00kooooo00?o0000o`00Ooooool03oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo00?o001oooooooooool03_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo01Kooooo000[ooooo`03o`000?oooooooooo00Gooooo00?o0000o`00Oooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003o001oooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Oooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003o001oooooo`0?ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Oooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Oooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?l007oooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003o001oooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000o`00Oooo
ool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01Kooooo000[oooooooo0000
Kol0000Ioooooooo0000L?l0000Hooooo`00oooooooooooooooooooo??ooool00?oooooooooooooo
oooooccooooo003ooooooooooooooooooollooooo`00oooooooooooooooooooo??ooool00?oooooo
oooooooooooooccooooo003ooooooooooooooooooollooooo`00oooooooooooooooooooo??ooool0
0001\
\>"],
  ImageRangeCache->{{{0, 824.188}, {254, 0}} -> {-0.0528646, -0.0154541, \
0.00255492, 0.00255492}, {{20.6875, 412.062}, {247.938, 6}} -> {-149.269, \
-40.5537, 2.87274, 0.397985}, {{412.062, 803.438}, {247.938, 6}} -> \
{-1273.59, -41.1221, 2.87274, 0.401848}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["(Y[[10//Range]]~ii~Z[[10//Range]])//MatrixForm", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "0.01`", "0.01`", "0.01`", "10.`", "28.`", 
                "2.6666666666666665`", \(-0.4056214814518112`\), \
\(-0.04376335451103954`\), "0.17841843523247317`"},
              {
                "2", \(-0.6080732644858033`\), \(-0.33100886648079203`\), \
\(-0.042507664191491434`\), "10.00001338074435`", "27.9999884013718`", 
                "2.666645522347795`", \(-1.0081298034450528`\), 
                "0.0020253104375005937`", \(-0.14852208667850805`\)},
              {"3", \(-0.45950490139199485`\), \(-0.30201900400892046`\), 
                "0.03832905890300544`", "10.00003066031493`", 
                "28.00000238814777`", 
                "2.6666440998287624`", \(-0.38934461481214483`\), \
\(-0.24102130866342322`\), \(-0.013764007411046726`\)},
              {
                "4", \(-0.533003280867734`\), \(-0.6157759717019662`\), \
\(-0.037959628397826836`\), "10.000009853834323`", "28.000000037495997`", 
                "2.666639713030213`", \(-0.36621739281481647`\), \
\(-0.20377038933106056`\), "0.1129373922816893`"},
              {"5", \(-0.5154641301338136`\), \(-0.7217596318601512`\), 
                "0.28491985813850196`", "10.000008987702047`", 
                "27.999985691898356`", "2.666649554991071`", 
                "0.06667388587948064`", \(-1.1536680373896557`\), 
                "0.08495138393883045`"},
              {"6", \(-0.20251537735961528`\), \(-1.2382261920215996`\), 
                "0.30237114098936263`", "10.000009422888883`", 
                "27.999983854657348`", 
                "2.666665131948707`", \(-0.04246335107907773`\), \
\(-1.0555495434686448`\), "0.20103660855918842`"},
              {"7", \(-0.26010370627680623`\), \(-1.1765874079995329`\), 
                "0.0633556463576718`", "10.000018519198932`", 
                "27.999988848984692`", 
                "2.6666593592547443`", \(-0.5754730117632862`\), \
\(-1.2362007895075984`\), "0.28556094383301434`"},
              {"8", \(-0.9275825341649712`\), \(-1.5174984175329467`\), 
                "0.34634529934726455`", "10.000024782390286`", 
                "27.99999218371144`", 
                "2.6666606780512883`", \(-0.698813287172286`\), \
\(-1.5081415610766429`\), "0.5820246238135593`"},
              {
                "9", \(-0.8030156832367522`\), \(-1.4051011289461082`\), \
\(-0.12754355237610404`\), "10.000036064630374`", "28.000012269009478`", 
                "2.666649067879792`", \(-0.31419798304524044`\), \
\(-1.9337879956066326`\), "0.1568627416792872`"},
              {"10", \(-0.4852385104447743`\), \(-1.5533138018082038`\), 
                "0.08528124952289048`", "10.000039796041756`", 
                "28.000002705641695`", 
                "2.66666515007433`", \(-0.49926213484989335`\), \
\(-1.0503163712587928`\), \(-0.5490912993317678`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Show[Graphics3D[{Hue[.4],Line[Z],Hue[.0],Line[Y[[All,{1,2,3}]]]}],\
ViewPoint->{2.063, -2.575, 0.751}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.08294 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0920717 1.22748 -1.11022e-16 1.22748 [
[ 0 0 0 0 ]
[ 1 1.08294 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03453 .16052 m
0 1.0388 L
s
0 1.0388 m
.53699 1.08294 L
s
.53699 1.08294 m
.53615 .35473 L
s
.53615 .35473 m
.03453 .16052 L
s
.50163 0 m
.97081 .24778 L
s
.97081 .24778 m
1 1.05877 L
s
1 1.05877 m
.49999 1.00149 L
s
.49999 1.00149 m
.50163 0 L
s
.03453 .16052 m
0 1.0388 L
s
0 1.0388 m
.49999 1.00149 L
s
.49999 1.00149 m
.50163 0 L
s
.50163 0 m
.03453 .16052 L
s
.53615 .35473 m
.97081 .24778 L
s
.97081 .24778 m
1 1.05877 L
s
1 1.05877 m
.53699 1.08294 L
s
.53699 1.08294 m
.53615 .35473 L
s
0 0 m
1 0 L
1 1.08294 L
0 1.08294 L
closepath
clip
newpath
0 1 .4 r
.5 Mabswid
.66671 .85797 m
.68772 .8179 L
s
.60448 .90653 m
.66671 .85797 L
s
1 0 0 r
.65469 .86172 m
.68936 .82571 L
s
.60841 .90318 m
.65469 .86172 L
s
0 1 .4 r
.55566 .93771 m
.60448 .90653 L
s
.68772 .8179 m
.7098 .79287 L
s
1 0 0 r
.68936 .82571 m
.71433 .79884 L
s
.55857 .9376 m
.60841 .90318 L
s
0 1 .4 r
.50449 .98586 m
.55566 .93771 L
s
1 0 0 r
.71433 .79884 m
.74488 .7675 L
s
.50673 .98251 m
.55857 .9376 L
s
0 1 .4 r
.7098 .79287 m
.7519 .76145 L
s
.7519 .76145 m
.75803 .7495 L
s
1 0 0 r
.74488 .7675 m
.75964 .74457 L
s
0 1 .4 r
.45124 1.00454 m
.50449 .98586 L
s
1 0 0 r
.44275 1.01346 m
.50673 .98251 L
s
.75964 .74457 m
.77706 .73065 L
s
0 1 .4 r
.75803 .7495 m
.77799 .72872 L
s
1 0 0 r
.77706 .73065 m
.8072 .73347 L
s
0 1 .4 r
.77799 .72872 m
.80408 .7297 L
s
.80408 .7297 m
.82968 .73587 L
s
1 0 0 r
.8072 .73347 m
.83306 .73396 L
s
.37267 1.03086 m
.44275 1.01346 L
s
0 1 .4 r
.85171 .5085 m
.88181 .54694 L
s
.84236 .49093 m
.85171 .5085 L
s
.37632 1.03704 m
.45124 1.00454 L
s
.75599 .43484 m
.77117 .44662 L
s
.74333 .43366 m
.75599 .43484 L
s
.82804 .47945 m
.84236 .49093 L
s
.81535 .47141 m
.82804 .47945 L
s
1 0 0 r
.83011 .47761 m
.8487 .49819 L
s
.81805 .46558 m
.83011 .47761 L
s
0 1 .4 r
.73533 .43574 m
.74333 .43366 L
s
.73672 .42137 m
.73533 .43574 L
s
1 0 0 r
.801 .45613 m
.81805 .46558 L
s
.76563 .44513 m
.78797 .44883 L
s
.75192 .43485 m
.76563 .44513 L
s
.73784 .42745 m
.75192 .43485 L
s
.85452 .51998 m
.87365 .54964 L
s
.8487 .49819 m
.85452 .51998 L
s
0 1 .4 r
.77117 .44662 m
.7852 .45252 L
s
.88939 .58511 m
.90428 .60038 L
s
.88181 .54694 m
.88939 .58511 L
s
.84848 .54906 m
.86066 .56719 L
s
.83477 .53311 m
.84848 .54906 L
s
1 0 0 r
.73281 .43311 m
.73784 .42745 L
s
.72955 .42604 m
.73281 .43311 L
s
0 1 .4 r
.82968 .73587 m
.84201 .73221 L
s
1 0 0 r
.88966 .58103 m
.89866 .60064 L
s
.87365 .54964 m
.88966 .58103 L
s
.78797 .44883 m
.801 .45613 L
s
.84264 .54761 m
.8597 .55869 L
s
.83814 .53071 m
.84264 .54761 L
s
.83306 .73396 m
.84411 .73502 L
s
0 1 .4 r
.8094 .50978 m
.82084 .52035 L
s
.79971 .48958 m
.8094 .50978 L
s
.72295 .41709 m
.73672 .42137 L
s
.71978 .40294 m
.72295 .41709 L
s
1 0 0 r
.89866 .60064 m
.91621 .62081 L
s
.8228 .52188 m
.83814 .53071 L
s
0 1 .4 r
.80575 .45626 m
.81535 .47141 L
s
.90428 .60038 m
.92173 .62769 L
s
1 0 0 r
.72574 .41712 m
.72955 .42604 L
s
.7179 .41096 m
.72574 .41712 L
s
0 1 .4 r
.70684 .42088 m
.71978 .40294 L
s
.69439 .43336 m
.70684 .42088 L
s
.7852 .45252 m
.80575 .45626 L
s
1 0 0 r
.80711 .50801 m
.8228 .52188 L
s
0 1 .4 r
.82084 .52035 m
.83477 .53311 L
s
1 0 0 r
.7969 .49013 m
.80711 .50801 L
s
0 1 .4 r
.77721 .4871 m
.79971 .48958 L
s
.76602 .46664 m
.77721 .4871 L
s
1 0 0 r
.8597 .55869 m
.87213 .56467 L
s
.77652 .48603 m
.7969 .49013 L
s
.76115 .47348 m
.77652 .48603 L
s
.70324 .41999 m
.7179 .41096 L
s
.69922 .42366 m
.70324 .41999 L
s
0 1 .4 r
.54808 .79207 m
.5647 .7757 L
s
.51995 .80214 m
.54808 .79207 L
s
1 0 0 r
.87213 .56467 m
.88769 .58766 L
s
0 1 .4 r
.93817 .64108 m
.92596 .67004 L
s
.92173 .62769 m
.93817 .64108 L
s
.86988 .56022 m
.88557 .59019 L
s
.86066 .56719 m
.86988 .56022 L
s
1 0 0 r
.69211 .42783 m
.69922 .42366 L
s
.68413 .4304 m
.69211 .42783 L
s
.54898 .79005 m
.56602 .77511 L
s
.53006 .80342 m
.54898 .79005 L
s
0 1 .4 r
.68709 .42873 m
.69439 .43336 L
s
.79658 .51737 m
.80975 .51023 L
s
.78335 .5136 m
.79658 .51737 L
s
.62344 .70629 m
.63399 .69244 L
s
.60302 .72505 m
.62344 .70629 L
s
.68265 .43596 m
.68831 .43676 L
s
.67319 .41435 m
.68265 .43596 L
s
1 0 0 r
.7529 .46936 m
.76115 .47348 L
s
.91621 .62081 m
.93468 .64056 L
s
.93468 .64056 m
.93888 .67408 L
s
.86102 .58995 m
.87613 .61706 L
s
.85279 .57488 m
.86102 .58995 L
s
0 1 .4 r
.85728 .57417 m
.86493 .58918 L
s
.84187 .55602 m
.85728 .57417 L
s
.75098 .4685 m
.76602 .46664 L
s
.73381 .46684 m
.75098 .4685 L
s
1 0 0 r
.68095 .42481 m
.68413 .4304 L
s
.67411 .42212 m
.68095 .42481 L
s
.56602 .77511 m
.58433 .74669 L
s
.62054 .70268 m
.63217 .69185 L
s
.60441 .72672 m
.62054 .70268 L
s
0 1 .4 r
.84201 .73221 m
.84859 .73745 L
s
1 0 0 r
.84379 .55647 m
.85279 .57488 L
s
.58433 .74669 m
.60441 .72672 L
s
0 1 .4 r
.68831 .43676 m
.68709 .42873 L
s
1 0 0 r
.84411 .73502 m
.84609 .7387 L
s
.88769 .58766 m
.89391 .60597 L
s
0 1 .4 r
.58378 .75244 m
.60302 .72505 L
s
.88557 .59019 m
.88347 .60676 L
s
.86493 .58918 m
.87403 .61711 L
s
.80975 .51023 m
.81593 .52002 L
s
1 0 0 r
.73321 .46166 m
.7529 .46936 L
s
0 1 .4 r
.72254 .46708 m
.73381 .46684 L
s
.81593 .52002 m
.83271 .53696 L
s
.66435 .41416 m
.67319 .41435 L
s
1 0 0 r
.50686 .8194 m
.53006 .80342 L
s
0 1 .4 r
.60547 .76936 m
.62636 .74943 L
s
.58714 .7822 m
.60547 .76936 L
s
1 0 0 r
.79234 .51371 m
.80921 .51674 L
s
.77959 .51322 m
.79234 .51371 L
s
0 1 .4 r
.5647 .7757 m
.58378 .75244 L
s
1 0 0 r
.80921 .51674 m
.81545 .52171 L
s
0 1 .4 r
.50914 .81782 m
.51995 .80214 L
s
.87403 .61711 m
.87694 .63825 L
s
1 0 0 r
.83622 .54965 m
.84379 .55647 L
s
.81545 .52171 m
.83177 .53133 L
s
0 1 .4 r
.73332 .5028 m
.7512 .50949 L
s
.73405 .50804 m
.73332 .5028 L
s
1 0 0 r
.63217 .69185 m
.6364 .68905 L
s
0 1 .4 r
.83317 .55269 m
.84187 .55602 L
s
1 0 0 r
.72974 .4675 m
.73321 .46166 L
s
0 1 .4 r
.57661 .24582 m
.58138 .24483 L
s
.58289 .24816 m
.57661 .24582 L
s
1 0 0 r
.60201 .76958 m
.62672 .75077 L
s
.58585 .78857 m
.60201 .76958 L
s
0 1 .4 r
.63399 .69244 m
.63726 .6991 L
s
.76624 .51199 m
.78335 .5136 L
s
1 0 0 r
.87613 .61706 m
.87662 .64245 L
s
.77351 .5069 m
.77959 .51322 L
s
.76706 .50425 m
.77351 .5069 L
s
.66797 .41882 m
.67411 .42212 L
s
0 1 .4 r
.90402 .62997 m
.91119 .6535 L
s
.88347 .60676 m
.90402 .62997 L
s
1 0 0 r
.87662 .64245 m
.88372 .65635 L
s
.83177 .53133 m
.83622 .54965 L
s
0 1 .4 r
.92596 .67004 m
.93247 .69919 L
s
1 0 0 r
.66523 .42569 m
.66797 .41882 L
s
.75451 .50569 m
.76706 .50425 L
s
0 1 .4 r
.83271 .53696 m
.83317 .55269 L
s
1 0 0 r
.56543 .80983 m
.58585 .78857 L
s
0 1 .4 r
.87694 .63825 m
.88292 .6551 L
s
1 0 0 r
.74208 .50322 m
.74632 .50681 L
s
.73395 .50636 m
.74208 .50322 L
s
.62672 .75077 m
.63755 .72713 L
s
0 1 .4 r
.75885 .50914 m
.76624 .51199 L
s
.75151 .50741 m
.75885 .50914 L
s
1 0 0 r
.5782 .24477 m
.58009 .2455 L
s
.58794 .24489 m
.5782 .24477 L
s
.93888 .67408 m
.94299 .70219 L
s
.30945 1.03543 m
.37267 1.03086 L
s
0 1 .4 r
.65896 .68869 m
.67684 .68195 L
s
.6346 .72399 m
.65896 .68869 L
s
.30936 1.04033 m
.37632 1.03704 L
s
.58138 .24483 m
.58196 .24658 L
s
.67354 .42671 m
.66435 .41416 L
s
.64168 .44087 m
.64981 .42829 L
s
.63797 .44464 m
.64168 .44087 L
s
.58196 .24658 m
.57866 .24132 L
s
1 0 0 r
.58009 .2455 m
.5766 .24353 L
s
0 1 .4 r
.64069 .42633 m
.66158 .4121 L
s
.64981 .42829 m
.64069 .42633 L
s
.54863 .82692 m
.5681 .80969 L
s
.51292 .84845 m
.54863 .82692 L
s
.78682 .52931 m
.79253 .5321 L
s
.7612 .5187 m
.78682 .52931 L
s
.8349 .5873 m
.83328 .59607 L
s
.81037 .58834 m
.8349 .5873 L
s
1 0 0 r
.64799 .43022 m
.64532 .42988 L
s
.64496 .44113 m
.64799 .43022 L
s
0 1 .4 r
.5681 .80969 m
.58714 .7822 L
s
1 0 0 r
.72319 .47553 m
.72974 .4675 L
s
.66241 .41829 m
.66523 .42569 L
s
0 1 .4 r
.7279 .47263 m
.72254 .46708 L
s
.47446 .83197 m
.50914 .81782 L
s
.45575 .84905 m
.47446 .83197 L
s
1 0 0 r
.74632 .50681 m
.75451 .50569 L
s
0 1 .4 r
.62636 .74943 m
.6346 .72399 L
s
1 0 0 r
.90041 .63217 m
.91079 .656 L
s
.89391 .60597 m
.90041 .63217 L
s
0 1 .4 r
.70952 .49594 m
.7249 .49279 L
s
.71362 .49815 m
.70952 .49594 L
s
.91377 .68756 m
.91635 .70538 L
s
.91119 .6535 m
.91377 .68756 L
s
1 0 0 r
.5766 .24353 m
.57591 .24736 L
s
.54237 .82262 m
.56543 .80983 L
s
0 1 .4 r
.7518 .51635 m
.7612 .5187 L
s
.75213 .50712 m
.7518 .51635 L
s
.79705 .61765 m
.80128 .6221 L
s
.79177 .62543 m
.79705 .61765 L
s
1 0 0 r
.64537 .44795 m
.64496 .44113 L
s
0 1 .4 r
.76239 .58621 m
.76899 .59719 L
s
.75789 .58783 m
.76239 .58621 L
s
1 0 0 r
.63755 .72713 m
.65696 .69579 L
s
0 1 .4 r
.80781 .56053 m
.8157 .57627 L
s
.79353 .54839 m
.80781 .56053 L
s
1 0 0 r
.57396 .23985 m
.5697 .23492 L
s
.58034 .24074 m
.57396 .23985 L
s
.64532 .42988 m
.66241 .41829 L
s
0 1 .4 r
.63726 .6991 m
.6449 .66135 L
s
1 0 0 r
.4776 .83601 m
.50686 .8194 L
s
0 1 .4 r
.7512 .50949 m
.75151 .50741 L
s
1 0 0 r
.57591 .24736 m
.57496 .2447 L
s
0 1 .4 r
.71012 .47418 m
.7279 .47263 L
s
.7249 .49279 m
.73405 .50804 L
s
1 0 0 r
.65696 .69579 m
.6704 .67981 L
s
0 1 .4 r
.78609 .61278 m
.79177 .62543 L
s
.765 .61382 m
.78609 .61278 L
s
1 0 0 r
.51719 .83936 m
.54237 .82262 L
s
.78329 .52718 m
.79857 .5366 L
s
.76648 .51621 m
.78329 .52718 L
s
0 1 .4 r
.57323 .23503 m
.56794 .24289 L
s
.56773 .24047 m
.57323 .23503 L
s
.57605 .24649 m
.56837 .25197 L
s
.57476 .24391 m
.57605 .24649 L
s
1 0 0 r
.71371 .5002 m
.725 .49914 L
s
.70653 .49975 m
.71371 .5002 L
s
0 1 .4 r
.73944 .52385 m
.75213 .50712 L
s
1 0 0 r
.80031 .62317 m
.79667 .62205 L
s
.79204 .62287 m
.80031 .62317 L
s
.80588 .5618 m
.81825 .57572 L
s
.79323 .54934 m
.80588 .5618 L
s
.78438 .61638 m
.79204 .62287 L
s
.77126 .609 m
.78438 .61638 L
s
.6364 .68905 m
.6446 .66416 L
s
0 1 .4 r
.66158 .4121 m
.67354 .42671 L
s
1 0 0 r
.88372 .65635 m
.89367 .67587 L
s
.75994 .51693 m
.76648 .51621 L
s
.74847 .51784 m
.75994 .51693 L
s
0 1 .4 r
.88292 .6551 m
.89368 .68206 L
s
.73215 .51326 m
.73944 .52385 L
s
.62568 .45468 m
.63797 .44464 L
s
.57087 .80439 m
.59182 .79848 L
s
.54502 .8301 m
.57087 .80439 L
s
1 0 0 r
.78948 .53377 m
.79323 .54934 L
s
.73902 .51882 m
.74847 .51784 L
s
.56685 .24019 m
.56911 .24148 L
s
.56453 .24642 m
.56685 .24019 L
s
0 1 .4 r
.78781 .538 m
.79353 .54839 L
s
.57551 .23972 m
.57181 .23295 L
s
.58729 .24505 m
.57551 .23972 L
s
1 0 0 r
.57297 .2345 m
.56863 .23475 L
s
.5697 .23492 m
.57297 .2345 L
s
.81553 .53993 m
.82668 .55182 L
s
.79857 .5366 m
.81553 .53993 L
s
.71304 .47399 m
.72319 .47553 L
s
.83291 .58784 m
.83668 .59797 L
s
.82133 .58836 m
.83291 .58784 L
s
0 1 .4 r
.57299 .23079 m
.56601 .23631 L
s
.57181 .23295 m
.57299 .23079 L
s
.71125 .47897 m
.71012 .47418 L
s
.81417 .53436 m
.82651 .54614 L
s
.79253 .5321 m
.81417 .53436 L
s
1 0 0 r
.84609 .7387 m
.84957 .74103 L
s
0 1 .4 r
.57084 .24561 m
.56715 .24889 L
s
.57829 .24356 m
.57084 .24561 L
s
1 0 0 r
.57483 .24194 m
.56453 .24642 L
s
0 1 .4 r
.60409 .77101 m
.62215 .74726 L
s
.59182 .79848 m
.60409 .77101 L
s
.55194 .23752 m
.54995 .23143 L
s
.55844 .23573 m
.55194 .23752 L
s
1 0 0 r
.91079 .656 m
.91779 .68234 L
s
.725 .49914 m
.73395 .50636 L
s
.79667 .62205 m
.79992 .62275 L
s
0 1 .4 r
.7649 .53045 m
.78781 .538 L
s
.76303 .53402 m
.7649 .53045 L
s
1 0 0 r
.57496 .2447 m
.57483 .24194 L
s
.62551 .75097 m
.63923 .73556 L
s
.60882 .76785 m
.62551 .75097 L
s
.81825 .57572 m
.82133 .58836 L
s
.76821 .52613 m
.78948 .53377 L
s
.76122 .52943 m
.76821 .52613 L
s
0 1 .4 r
.89368 .68206 m
.90402 .69301 L
s
1 0 0 r
.63923 .73556 m
.65163 .72014 L
s
.63592 .4505 m
.64537 .44795 L
s
0 1 .4 r
.57034 .2357 m
.5663 .23163 L
s
.56837 .25197 m
.57034 .2357 L
s
1 0 0 r
.57118 .25111 m
.56869 .247 L
s
.57504 .24441 m
.57118 .25111 L
s
.57638 .23748 m
.57865 .24241 L
s
.56863 .23475 m
.57638 .23748 L
s
0 1 .4 r
.57866 .24132 m
.57829 .24356 L
s
1 0 0 r
.6704 .67981 m
.67999 .66495 L
s
.59408 .79595 m
.60882 .76785 L
s
0 1 .4 r
.56715 .24889 m
.56773 .24047 L
s
.57528 .22753 m
.58729 .24505 L
s
.74199 .53567 m
.76303 .53402 L
s
1 0 0 r
.57052 .8099 m
.59408 .79595 L
s
.54079 .82762 m
.57052 .8099 L
s
.56869 .247 m
.56741 .23749 L
s
.65163 .72014 m
.66192 .70904 L
s
0 1 .4 r
.56601 .23631 m
.57849 .23821 L
s
1 0 0 r
.70582 .47843 m
.71304 .47399 L
s
.8277 .55463 m
.84064 .56873 L
s
.82668 .55182 m
.8277 .55463 L
s
.56911 .24148 m
.57477 .24253 L
s
.58275 .23725 m
.58034 .24074 L
s
.91779 .68234 m
.90834 .70163 L
s
.57477 .24253 m
.58275 .23725 L
s
0 1 .4 r
.65755 .72181 m
.66177 .70476 L
s
.63237 .73241 m
.65755 .72181 L
s
1 0 0 r
.57865 .24241 m
.57504 .24441 L
s
0 1 .4 r
.62215 .74726 m
.63237 .73241 L
s
.57849 .23821 m
.57476 .24391 L
s
1 0 0 r
.70741 .49279 m
.70653 .49975 L
s
0 1 .4 r
.56794 .24289 m
.57528 .22753 L
s
.8157 .57627 m
.81037 .58834 L
s
.6449 .66135 m
.66015 .64733 L
s
.83328 .59607 m
.83923 .60774 L
s
.74754 .57333 m
.75789 .58783 L
s
.70588 .4865 m
.70943 .49075 L
s
.69876 .49172 m
.70588 .4865 L
s
1 0 0 r
.75975 .59206 m
.77003 .59851 L
s
.76137 .58492 m
.75975 .59206 L
s
0 1 .4 r
.93247 .69919 m
.9418 .72679 L
s
1 0 0 r
.55089 .23536 m
.54643 .23137 L
s
.55744 .23109 m
.55089 .23536 L
s
.74484 .531 m
.76122 .52943 L
s
.84805 .62364 m
.8559 .63951 L
s
.84303 .61061 m
.84805 .62364 L
s
.44983 .85062 m
.4776 .83601 L
s
.73936 .51128 m
.73902 .51882 L
s
.70318 .48443 m
.70582 .47843 L
s
0 1 .4 r
.5663 .23163 m
.56458 .23858 L
s
.85638 .59694 m
.86228 .61093 L
s
.85503 .58171 m
.85638 .59694 L
s
1 0 0 r
.56741 .23749 m
.5626 .23267 L
s
.89367 .67587 m
.90615 .69676 L
s
.94299 .70219 m
.94558 .72581 L
s
.77003 .59851 m
.77126 .609 L
s
0 1 .4 r
.80128 .6221 m
.79563 .61699 L
s
1 0 0 r
.6446 .66416 m
.65678 .65254 L
s
0 1 .4 r
.84859 .73745 m
.85424 .74622 L
s
1 0 0 r
.83668 .59797 m
.84303 .61061 L
s
0 1 .4 r
.70005 .49636 m
.69876 .49172 L
s
.69828 .49109 m
.71125 .47897 L
s
.72979 .614 m
.73423 .60947 L
s
.71932 .61702 m
.72979 .614 L
s
1 0 0 r
.8617 .60211 m
.86232 .61946 L
s
.85031 .57949 m
.8617 .60211 L
s
0 1 .4 r
.67684 .68195 m
.68439 .65917 L
s
.82651 .54614 m
.8316 .55912 L
s
1 0 0 r
.70275 .49085 m
.70741 .49279 L
s
0 1 .4 r
.72112 .62839 m
.71932 .61702 L
s
.72757 .63447 m
.72112 .62839 L
s
1 0 0 r
.51999 .84255 m
.54079 .82762 L
s
.84064 .56873 m
.85031 .57949 L
s
0 1 .4 r
.70943 .49075 m
.71362 .49815 L
s
.521 .83837 m
.54502 .8301 L
s
.49242 .8488 m
.521 .83837 L
s
.52756 .24081 m
.5095 .23297 L
s
.54995 .23143 m
.52756 .24081 L
s
.55649 .23605 m
.55844 .23573 L
s
.83994 .57057 m
.85503 .58171 L
s
.8316 .55912 m
.83994 .57057 L
s
.73827 .531 m
.73437 .53348 L
s
.73754 .5281 m
.73827 .531 L
s
1 0 0 r
.50071 .85077 m
.51719 .83936 L
s
.75378 .57789 m
.76137 .58492 L
s
.69991 .48873 m
.70275 .49085 L
s
0 1 .4 r
.79563 .61699 m
.79246 .62964 L
s
.56458 .23858 m
.56547 .22919 L
s
.76899 .59719 m
.765 .61382 L
s
1 0 0 r
.54643 .23137 m
.52654 .23282 L
s
0 1 .4 r
.67706 .65271 m
.68724 .63054 L
s
.66015 .64733 m
.67706 .65271 L
s
1 0 0 r
.68545 .63437 m
.69503 .62479 L
s
.6719 .64477 m
.68545 .63437 L
s
0 1 .4 r
.91635 .70538 m
.90724 .718 L
s
1 0 0 r
.84957 .74103 m
.84908 .75088 L
s
0 1 .4 r
.73134 .50614 m
.73215 .51326 L
s
.86228 .61093 m
.86368 .63152 L
s
.78944 .57926 m
.80564 .58115 L
s
.78069 .57497 m
.78944 .57926 L
s
1 0 0 r
.65678 .65254 m
.6719 .64477 L
s
0 1 .4 r
.85224 .62353 m
.85774 .63266 L
s
.83923 .60774 m
.85224 .62353 L
s
1 0 0 r
.8559 .63951 m
.86119 .65833 L
s
.72318 .62873 m
.72608 .62027 L
s
.72285 .62704 m
.72318 .62873 L
s
0 1 .4 r
.66499 .51437 m
.67509 .5121 L
s
.66399 .52685 m
.66499 .51437 L
s
1 0 0 r
.49027 .8565 m
.51999 .84255 L
s
0 1 .4 r
.68439 .65917 m
.68559 .6502 L
s
.85774 .63266 m
.86249 .65896 L
s
.76097 .61822 m
.7585 .61892 L
s
.74326 .60599 m
.76097 .61822 L
s
1 0 0 r
.80316 .58477 m
.80303 .5902 L
s
.79084 .57765 m
.80316 .58477 L
s
0 1 .4 r
.85424 .74622 m
.84833 .75134 L
s
.5095 .23297 m
.5057 .23433 L
s
.56547 .22919 m
.55649 .23605 L
s
.68724 .63054 m
.68212 .61641 L
s
1 0 0 r
.5626 .23267 m
.56258 .2338 L
s
0 1 .4 r
.63563 .4583 m
.62568 .45468 L
s
1 0 0 r
.55999 .23595 m
.55744 .23109 L
s
0 1 .4 r
.64398 .48308 m
.63785 .48527 L
s
.63417 .48304 m
.64398 .48308 L
s
.77386 .56473 m
.78069 .57497 L
s
.77108 .5548 m
.77386 .56473 L
s
1 0 0 r
.41856 .85493 m
.44983 .85062 L
s
.69537 .49149 m
.69991 .48873 L
s
.63749 .45781 m
.63592 .4505 L
s
.66192 .70904 m
.67115 .70204 L
s
0 1 .4 r
.73437 .53348 m
.74199 .53567 L
s
.50264 .84896 m
.51292 .84845 L
s
.47478 .86865 m
.50264 .84896 L
s
1 0 0 r
.73972 .52803 m
.74484 .531 L
s
0 1 .4 r
.75227 .61077 m
.74326 .60599 L
s
1 0 0 r
.72608 .62027 m
.72853 .61626 L
s
.52654 .23282 m
.51159 .23643 L
s
.79992 .62275 m
.79679 .6329 L
s
0 1 .4 r
.73423 .60947 m
.75227 .61077 L
s
.70547 .54568 m
.71516 .54323 L
s
.69965 .54168 m
.70547 .54568 L
s
.74851 .56771 m
.74754 .57333 L
s
.74538 .58042 m
.74851 .56771 L
s
1 0 0 r
.72759 .50773 m
.72887 .50349 L
s
.72578 .49826 m
.72759 .50773 L
s
0 1 .4 r
.70272 .54765 m
.69965 .54168 L
s
.70539 .55665 m
.70272 .54765 L
s
.9418 .72679 m
.9331 .75199 L
s
1 0 0 r
.72853 .61626 m
.73213 .6072 L
s
0 1 .4 r
.70641 .6396 m
.70983 .63927 L
s
.70443 .65476 m
.70641 .6396 L
s
1 0 0 r
.56258 .2338 m
.55999 .23595 L
s
.71036 .5393 m
.71423 .53632 L
s
.7032 .54356 m
.71036 .5393 L
s
0 1 .4 r
.79246 .62964 m
.79704 .64084 L
s
1 0 0 r
.73517 .5322 m
.74024 .53138 L
s
.72758 .54402 m
.73517 .5322 L
s
0 1 .4 r
.68559 .6502 m
.70443 .65476 L
s
.73299 .5083 m
.72031 .50979 L
s
.7218 .49675 m
.73299 .5083 L
s
1 0 0 r
.80303 .5902 m
.80433 .597 L
s
.90834 .70163 m
.91199 .71764 L
s
0 1 .4 r
.41754 .85501 m
.45575 .84905 L
s
1 0 0 r
.73898 .50473 m
.73936 .51128 L
s
.77817 .58004 m
.79084 .57765 L
s
.77585 .56187 m
.77817 .58004 L
s
.79679 .6329 m
.80666 .64421 L
s
0 1 .4 r
.66177 .70476 m
.66841 .7076 L
s
1 0 0 r
.51159 .23643 m
.5052 .23207 L
s
0 1 .4 r
.63785 .48527 m
.64433 .47367 L
s
1 0 0 r
.75102 .61008 m
.7556 .61506 L
s
.74574 .60904 m
.75102 .61008 L
s
.75397 .57256 m
.75378 .57789 L
s
0 1 .4 r
.76946 .55024 m
.77108 .5548 L
s
1 0 0 r
.67115 .70204 m
.67786 .68519 L
s
0 1 .4 r
.69341 .50453 m
.70066 .49771 L
s
.68403 .50654 m
.69341 .50453 L
s
1 0 0 r
.70065 .65015 m
.70705 .63885 L
s
.69415 .65286 m
.70065 .65015 L
s
.70286 .54552 m
.69895 .54627 L
s
.70322 .55192 m
.70286 .54552 L
s
0 1 .4 r
.72149 .50351 m
.7218 .49675 L
s
.70066 .49771 m
.70005 .49636 L
s
1 0 0 r
.68302 .48618 m
.70318 .48443 L
s
.75821 .54343 m
.76452 .55128 L
s
.75332 .53664 m
.75821 .54343 L
s
.72887 .50349 m
.73898 .50473 L
s
.67999 .66495 m
.69415 .65286 L
s
.68193 .48781 m
.68302 .48618 L
s
.6822 .49117 m
.68193 .48781 L
s
.74024 .53138 m
.73972 .52803 L
s
.69755 .49559 m
.69537 .49149 L
s
.69472 .50593 m
.69755 .49559 L
s
.74855 .57359 m
.75397 .57256 L
s
.67786 .68519 m
.6818 .67243 L
s
0 1 .4 r
.87127 .66518 m
.86913 .67232 L
s
.87123 .64031 m
.87127 .66518 L
s
.72665 .54068 m
.73754 .5281 L
s
1 0 0 r
.86232 .61946 m
.86514 .62963 L
s
0 1 .4 r
.63875 .50203 m
.63417 .48304 L
s
1 0 0 r
.47126 .86664 m
.50071 .85077 L
s
0 1 .4 r
.5057 .23433 m
.48122 .23528 L
s
1 0 0 r
.69895 .54627 m
.7032 .54356 L
s
0 1 .4 r
.71541 .53334 m
.7124 .53913 L
s
.71516 .54323 m
.71541 .53334 L
s
.70983 .63927 m
.72757 .63447 L
s
1 0 0 r
.76452 .55128 m
.77138 .55301 L
s
0 1 .4 r
.66841 .7076 m
.68052 .68832 L
s
.80564 .58115 m
.81011 .59625 L
s
1 0 0 r
.63954 .48161 m
.64211 .47619 L
s
.63736 .48611 m
.63954 .48161 L
s
0 1 .4 r
.74689 .57458 m
.74538 .58042 L
s
1 0 0 r
.63737 .48931 m
.63736 .48611 L
s
.73213 .6072 m
.74574 .60904 L
s
.80746 .61063 m
.80783 .61771 L
s
.80433 .597 m
.80746 .61063 L
s
.7556 .61506 m
.76286 .61815 L
s
.86514 .62963 m
.86991 .64636 L
s
0 1 .4 r
.75053 .53872 m
.76946 .55024 L
s
.75098 .54124 m
.75053 .53872 L
s
.68025 .48607 m
.6822 .48301 L
s
.68449 .49171 m
.68025 .48607 L
s
1 0 0 r
.66681 .51791 m
.67134 .51061 L
s
.6638 .52554 m
.66681 .51791 L
s
0 1 .4 r
.81056 .6075 m
.8098 .62185 L
s
.80383 .59824 m
.81056 .6075 L
s
1 0 0 r
.77138 .55301 m
.77585 .56187 L
s
0 1 .4 r
.68052 .68832 m
.6799 .66566 L
s
.6419 .47271 m
.63563 .4583 L
s
1 0 0 r
.70705 .63885 m
.71393 .63071 L
s
0 1 .4 r
.81011 .59625 m
.80383 .59824 L
s
1 0 0 r
.71423 .53632 m
.71532 .54111 L
s
.71393 .63071 m
.72285 .62704 L
s
0 1 .4 r
.69117 .54608 m
.70539 .55665 L
s
1 0 0 r
.69503 .62479 m
.70413 .60932 L
s
0 1 .4 r
.8098 .62185 m
.81025 .62806 L
s
.74604 .53975 m
.75098 .54124 L
s
.72031 .50979 m
.73134 .50614 L
s
.6822 .48301 m
.69828 .49109 L
s
1 0 0 r
.71532 .54111 m
.72758 .54402 L
s
.63309 .49865 m
.63737 .48931 L
s
.72499 .50706 m
.72578 .49826 L
s
.80666 .64421 m
.82391 .64846 L
s
0 1 .4 r
.65471 .53177 m
.65568 .52879 L
s
.65173 .53776 m
.65471 .53177 L
s
.7124 .53913 m
.72665 .54068 L
s
1 0 0 r
.86991 .64636 m
.87311 .66019 L
s
.45755 .86735 m
.49027 .8565 L
s
.71747 .50929 m
.72499 .50706 L
s
.94558 .72581 m
.93327 .75135 L
s
0 1 .4 r
.86368 .63152 m
.87123 .64031 L
s
1 0 0 r
.6841 .50507 m
.69472 .50593 L
s
0 1 .4 r
.70957 .60222 m
.70429 .60834 L
s
.68212 .61641 m
.70957 .60222 L
s
1 0 0 r
.49949 .69226 m
.5151 .67904 L
s
.48572 .70814 m
.49949 .69226 L
s
.90615 .69676 m
.91083 .7228 L
s
0 1 .4 r
.66833 .52738 m
.66399 .52685 L
s
1 0 0 r
.74926 .53556 m
.75332 .53664 L
s
0 1 .4 r
.71841 .5149 m
.72149 .50351 L
s
.79704 .64084 m
.82859 .64317 L
s
1 0 0 r
.63765 .46785 m
.63749 .45781 L
s
0 1 .4 r
.73045 .57451 m
.73628 .56356 L
s
.73683 .57786 m
.73045 .57451 L
s
1 0 0 r
.5151 .67904 m
.52647 .6617 L
s
.47487 .71764 m
.48572 .70814 L
s
.66229 .52929 m
.6638 .52554 L
s
.86119 .65833 m
.87189 .6709 L
s
.67134 .51061 m
.67848 .50731 L
s
.73945 .56885 m
.74855 .57359 L
s
.5052 .23207 m
.48522 .24087 L
s
.64211 .47619 m
.63765 .46785 L
s
0 1 .4 r
.67691 .515 m
.68403 .50654 L
s
.64433 .47367 m
.6419 .47271 L
s
.45396 .87331 m
.49242 .8488 L
s
1 0 0 r
.67848 .50731 m
.6841 .50507 L
s
0 1 .4 r
.54048 .67064 m
.54605 .6581 L
s
.52852 .67466 m
.54048 .67064 L
s
.73539 .55089 m
.74604 .53975 L
s
.5503 .65101 m
.54348 .64082 L
s
.54605 .6581 m
.5503 .65101 L
s
1 0 0 r
.64631 .53473 m
.65237 .53203 L
s
.64579 .53775 m
.64631 .53473 L
s
0 1 .4 r
.67815 .4993 m
.68449 .49171 L
s
1 0 0 r
.74272 .54213 m
.74926 .53556 L
s
.70413 .60932 m
.70733 .60713 L
s
.54988 .64723 m
.54658 .63547 L
s
.54579 .66243 m
.54988 .64723 L
s
0 1 .4 r
.53238 .39315 m
.52603 .37897 L
s
.55316 .41036 m
.53238 .39315 L
s
.70452 .58709 m
.70889 .56836 L
s
.71038 .60024 m
.70452 .58709 L
s
.7585 .61892 m
.76654 .61582 L
s
.48996 .70241 m
.49747 .69349 L
s
.47085 .72017 m
.48996 .70241 L
s
.70429 .60834 m
.70769 .59271 L
s
1 0 0 r
.62443 .50732 m
.63309 .49865 L
s
.62557 .51607 m
.62443 .50732 L
s
0 1 .4 r
.86249 .65896 m
.87066 .6634 L
s
.90402 .69301 m
.91315 .72853 L
s
.7384 .56835 m
.74689 .57458 L
s
.62186 .50728 m
.63875 .50203 L
s
.62573 .52119 m
.62186 .50728 L
s
1 0 0 r
.53768 .66494 m
.54579 .66243 L
s
.53012 .67714 m
.53768 .66494 L
s
.52647 .6617 m
.53022 .64668 L
s
0 1 .4 r
.74371 .53889 m
.73539 .55089 L
s
.72854 .56927 m
.73683 .57786 L
s
1 0 0 r
.84908 .75088 m
.84337 .76352 L
s
0 1 .4 r
.71726 .59468 m
.71038 .60024 L
s
.65568 .52879 m
.65115 .52772 L
s
.52761 .64744 m
.53996 .63204 L
s
.52701 .66091 m
.52761 .64744 L
s
.49747 .69349 m
.5109 .67901 L
s
1 0 0 r
.53022 .64668 m
.53925 .63551 L
s
.42858 .8823 m
.45755 .86735 L
s
.73126 .58081 m
.73617 .57206 L
s
.72431 .57309 m
.73126 .58081 L
s
0 1 .4 r
.5109 .67901 m
.52701 .66091 L
s
1 0 0 r
.71013 .59105 m
.71573 .58356 L
s
.70733 .60713 m
.71013 .59105 L
s
.6795 .49226 m
.6822 .49117 L
s
.80783 .61771 m
.81573 .62462 L
s
.45864 .73286 m
.47487 .71764 L
s
.87311 .66019 m
.87443 .66974 L
s
0 1 .4 r
.66525 .50214 m
.67815 .4993 L
s
1 0 0 r
.65237 .53203 m
.6544 .52974 L
s
0 1 .4 r
.54348 .64082 m
.54828 .61942 L
s
.55953 .41884 m
.55316 .41036 L
s
1 0 0 r
.6818 .67243 m
.67879 .66284 L
s
0 1 .4 r
.81025 .62806 m
.80848 .63103 L
s
1 0 0 r
.6544 .52974 m
.66229 .52929 L
s
.68789 .54758 m
.70322 .55192 L
s
0 1 .4 r
.73628 .56356 m
.74278 .56305 L
s
.64365 .5259 m
.65975 .51087 L
s
.65457 .5296 m
.64365 .5259 L
s
1 0 0 r
.81573 .62462 m
.81318 .63468 L
s
.54424 .4076 m
.53232 .39395 L
s
.55805 .41728 m
.54424 .4076 L
s
.71425 .57385 m
.72431 .57309 L
s
.71209 .57534 m
.71425 .57385 L
s
.76286 .61815 m
.77281 .60963 L
s
0 1 .4 r
.63418 .52157 m
.62573 .52119 L
s
.71244 .57848 m
.72854 .56927 L
s
1 0 0 r
.43926 .88119 m
.47126 .86664 L
s
0 1 .4 r
.67509 .5121 m
.67691 .515 L
s
.71154 .52012 m
.71841 .5149 L
s
1 0 0 r
.70958 .58654 m
.71209 .57534 L
s
.717 .59131 m
.70958 .58654 L
s
0 1 .4 r
.6799 .66566 m
.68457 .66606 L
s
.68881 .55874 m
.68378 .55282 L
s
.68808 .56467 m
.68881 .55874 L
s
1 0 0 r
.74092 .5661 m
.73945 .56885 L
s
0 1 .4 r
.78274 .61403 m
.77616 .62004 L
s
.76603 .62025 m
.78274 .61403 L
s
1 0 0 r
.44227 .75068 m
.45864 .73286 L
s
.4238 .76202 m
.44227 .75068 L
s
.55893 .42032 m
.55805 .41728 L
s
.91199 .71764 m
.91433 .74261 L
s
0 1 .4 r
.77013 .64292 m
.77993 .63352 L
s
.77314 .63101 m
.77013 .64292 L
s
.84833 .75134 m
.84049 .7643 L
s
1 0 0 r
.66517 .49927 m
.6795 .49226 L
s
.65536 .50984 m
.66517 .49927 L
s
0 1 .4 r
.65115 .52772 m
.66833 .52738 L
s
1 0 0 r
.77343 .61908 m
.77201 .63092 L
s
.77319 .61493 m
.77343 .61908 L
s
0 1 .4 r
.42395 .87709 m
.45396 .87331 L
s
1 0 0 r
.53232 .39395 m
.52527 .38063 L
s
.6363 .53349 m
.62557 .51607 L
s
0 1 .4 r
.87066 .6634 m
.86835 .67953 L
s
.46131 .72868 m
.47085 .72017 L
s
1 0 0 r
.70276 .53063 m
.71377 .51784 L
s
.70031 .53274 m
.70276 .53063 L
s
.77201 .63092 m
.77446 .63325 L
s
.77258 .61483 m
.77319 .61493 L
s
.77281 .60963 m
.77258 .61483 L
s
0 1 .4 r
.76654 .61582 m
.76603 .62025 L
s
.38245 .86355 m
.41754 .85501 L
s
1 0 0 r
.52527 .38063 m
.52089 .37154 L
s
0 1 .4 r
.56181 .48518 m
.57362 .47194 L
s
.56353 .49272 m
.56181 .48518 L
s
.52603 .37897 m
.52281 .37142 L
s
1 0 0 r
.73641 .54879 m
.74272 .54213 L
s
.87189 .6709 m
.87023 .68232 L
s
0 1 .4 r
.51703 .67679 m
.52852 .67466 L
s
.70236 .53577 m
.71154 .52012 L
s
.70545 .52713 m
.70236 .53577 L
s
1 0 0 r
.71497 .59053 m
.717 .59131 L
s
.71513 .59007 m
.71497 .59053 L
s
0 1 .4 r
.43612 .75412 m
.46131 .72868 L
s
.4247 .76163 m
.43612 .75412 L
s
.65975 .51087 m
.66525 .50214 L
s
.77616 .62004 m
.77314 .63101 L
s
1 0 0 r
.71377 .51784 m
.71747 .50929 L
s
0 1 .4 r
.70909 .53692 m
.70545 .52713 L
s
.71272 .53528 m
.70909 .53692 L
s
.71883 .58327 m
.70879 .5839 L
s
.70769 .59271 m
.71883 .58327 L
s
1 0 0 r
.73617 .57206 m
.73685 .56706 L
s
.52273 .68317 m
.53012 .67714 L
s
.54658 .63547 m
.54997 .61476 L
s
0 1 .4 r
.70879 .5839 m
.71726 .59468 L
s
1 0 0 r
.71573 .58356 m
.71513 .59007 L
s
0 1 .4 r
.5417 .5961 m
.54621 .59128 L
s
.54828 .61942 m
.5417 .5961 L
s
1 0 0 r
.71126 .5296 m
.70031 .53274 L
s
0 1 .4 r
.64965 .54287 m
.65173 .53776 L
s
.54621 .59128 m
.54066 .57699 L
s
.52281 .37142 m
.51649 .36414 L
s
.73846 .57373 m
.7384 .56835 L
s
1 0 0 r
.65317 .52123 m
.65536 .50984 L
s
.65201 .52549 m
.65317 .52123 L
s
0 1 .4 r
.48122 .23528 m
.45942 .23965 L
s
.64705 .55532 m
.64965 .54287 L
s
.64726 .54432 m
.64705 .55532 L
s
.56672 .50117 m
.55674 .49253 L
s
.572 .50879 m
.56672 .50117 L
s
.70889 .56836 m
.71244 .57848 L
s
1 0 0 r
.73685 .56706 m
.73907 .55592 L
s
.82391 .64846 m
.82278 .66202 L
s
0 1 .4 r
.82859 .64317 m
.82596 .66241 L
s
1 0 0 r
.54997 .61476 m
.5459 .6033 L
s
.37691 .85957 m
.41856 .85493 L
s
.64714 .54766 m
.64579 .53775 L
s
0 1 .4 r
.86913 .67232 m
.88402 .69327 L
s
1 0 0 r
.64252 .55652 m
.64714 .54766 L
s
.5459 .6033 m
.54393 .59676 L
s
.6837 .55507 m
.68789 .54758 L
s
0 1 .4 r
.53183 .43675 m
.52693 .43762 L
s
.5337 .43948 m
.53183 .43675 L
s
.44 .88409 m
.47478 .86865 L
s
1 0 0 r
.7648 .64343 m
.76461 .63569 L
s
.77339 .62971 m
.7648 .64343 L
s
0 1 .4 r
.56693 .4131 m
.55953 .41884 L
s
.48889 .70956 m
.5133 .70345 L
s
.48456 .7277 m
.48889 .70956 L
s
.84049 .7643 m
.8503 .77051 L
s
.90724 .718 m
.91411 .73626 L
s
1 0 0 r
.56707 .48929 m
.57341 .47139 L
s
.56656 .48994 m
.56707 .48929 L
s
.54393 .59676 m
.5459 .57914 L
s
0 1 .4 r
.5133 .70345 m
.51703 .67679 L
s
1 0 0 r
.23873 1.01105 m
.30945 1.03543 L
s
0 1 .4 r
.55674 .49253 m
.55845 .48682 L
s
1 0 0 r
.48522 .24087 m
.46609 .23897 L
s
.70948 .53445 m
.71126 .5296 L
s
.53622 .43464 m
.53432 .43752 L
s
.53322 .43828 m
.53622 .43464 L
s
0 1 .4 r
.54935 .57055 m
.5561 .56512 L
s
.54066 .57699 m
.54935 .57055 L
s
.4986 .35717 m
.50051 .35298 L
s
.51649 .36414 m
.4986 .35717 L
s
.55253 .51138 m
.56353 .49272 L
s
.56218 .50734 m
.55253 .51138 L
s
1 0 0 r
.546 .56141 m
.55145 .54899 L
s
.55099 .56456 m
.546 .56141 L
s
0 1 .4 r
.77993 .63352 m
.7638 .64849 L
s
.41017 .88402 m
.44 .88409 L
s
1 0 0 r
.81318 .63468 m
.81191 .65095 L
s
.55014 .56738 m
.55099 .56456 L
s
.73907 .55592 m
.73641 .54879 L
s
0 1 .4 r
.54352 .5521 m
.54791 .5475 L
s
.5561 .56512 m
.54352 .5521 L
s
.74278 .56305 m
.74371 .53889 L
s
1 0 0 r
.5459 .57914 m
.55014 .56738 L
s
.68918 .55612 m
.6837 .55507 L
s
.6895 .5601 m
.68918 .55612 L
s
0 1 .4 r
.63308 .53675 m
.63418 .52157 L
s
1 0 0 r
.77446 .63325 m
.77339 .62971 L
s
0 1 .4 r
.75878 .63099 m
.75964 .63527 L
s
.7638 .64849 m
.75878 .63099 L
s
.70334 .55459 m
.71272 .53528 L
s
1 0 0 r
.67879 .66284 m
.66949 .64308 L
s
.57341 .47139 m
.57285 .45873 L
s
0 1 .4 r
.52055 .40625 m
.53231 .40547 L
s
.53615 .41438 m
.52055 .40625 L
s
1 0 0 r
.55339 .48919 m
.55795 .48853 L
s
.56318 .49758 m
.55339 .48919 L
s
0 1 .4 r
.68457 .66606 m
.67031 .63066 L
s
1 0 0 r
.52626 .40941 m
.52772 .39798 L
s
.53216 .41384 m
.52626 .40941 L
s
.73921 .57381 m
.74092 .5661 L
s
0 1 .4 r
.69349 .55022 m
.68808 .56467 L
s
1 0 0 r
.46582 .72726 m
.4852 .71713 L
s
.45468 .72647 m
.46582 .72726 L
s
0 1 .4 r
.68935 .55992 m
.69349 .55022 L
s
.6891 .557 m
.68935 .55992 L
s
.80848 .63103 m
.80644 .64382 L
s
.63689 .55934 m
.6395 .5387 L
s
.63272 .56216 m
.63689 .55934 L
s
1 0 0 r
.5601 .4243 m
.55893 .42032 L
s
.56006 .42716 m
.5601 .4243 L
s
.56894 .51158 m
.56318 .49758 L
s
.514 .36572 m
.50204 .35505 L
s
.52089 .37154 m
.514 .36572 L
s
0 1 .4 r
.53845 .44229 m
.5337 .43948 L
s
.65466 .5427 m
.65206 .54745 L
s
.66079 .54577 m
.65466 .5427 L
s
.68378 .55282 m
.69117 .54608 L
s
1 0 0 r
.39609 .77466 m
.4238 .76202 L
s
.56912 .4406 m
.57277 .43497 L
s
.57285 .45873 m
.56912 .4406 L
s
.51603 .70165 m
.52273 .68317 L
s
.80861 .65285 m
.80909 .65353 L
s
.81191 .65095 m
.80861 .65285 L
s
0 1 .4 r
.55732 .41689 m
.56693 .4131 L
s
.56036 .42402 m
.55732 .41689 L
s
1 0 0 r
.52392 .42723 m
.52553 .41732 L
s
.53272 .42629 m
.52392 .42723 L
s
.87443 .66974 m
.881 .68862 L
s
.76461 .63569 m
.76357 .64169 L
s
.55145 .54899 m
.56389 .53761 L
s
0 1 .4 r
.57362 .47194 m
.56876 .4593 L
s
.55845 .48682 m
.54976 .48575 L
s
1 0 0 r
.64285 .55046 m
.64252 .55652 L
s
0 1 .4 r
.24015 1.00938 m
.30936 1.04033 L
s
.66435 .52195 m
.65457 .5296 L
s
.67335 .56661 m
.67193 .56742 L
s
.67824 .57411 m
.67335 .56661 L
s
1 0 0 r
.5632 .50885 m
.56656 .48994 L
s
.56143 .51219 m
.5632 .50885 L
s
.53641 .45361 m
.53756 .44292 L
s
.53859 .4611 m
.53641 .45361 L
s
0 1 .4 r
.39061 .77157 m
.4247 .76163 L
s
1 0 0 r
.91083 .7228 m
.91333 .73612 L
s
0 1 .4 r
.50291 .39548 m
.51203 .38757 L
s
.53231 .40547 m
.50291 .39548 L
s
.53327 .45039 m
.53845 .44229 L
s
.54833 .45928 m
.53327 .45039 L
s
1 0 0 r
.69145 .55782 m
.69153 .5522 L
s
.68543 .56033 m
.69145 .55782 L
s
.53756 .44292 m
.53322 .43828 L
s
.69933 .55223 m
.70948 .53445 L
s
.69554 .56279 m
.69933 .55223 L
s
.65289 .55389 m
.65571 .5415 L
s
.65805 .55263 m
.65289 .55389 L
s
0 1 .4 r
.9331 .75199 m
.92403 .78311 L
s
.67885 .58539 m
.6961 .58894 L
s
.69658 .58148 m
.67885 .58539 L
s
.91315 .72853 m
.90336 .73496 L
s
1 0 0 r
.56162 .42971 m
.56006 .42716 L
s
0 1 .4 r
.80644 .64382 m
.81097 .6488 L
s
1 0 0 r
.63838 .54626 m
.6349 .53801 L
s
.63379 .55984 m
.63838 .54626 L
s
.49138 .70564 m
.51603 .70165 L
s
.4852 .71713 m
.49138 .70564 L
s
.93327 .75135 m
.9253 .78153 L
s
0 1 .4 r
.54976 .48575 m
.56071 .47624 L
s
1 0 0 r
.53432 .43752 m
.53272 .42629 L
s
0 1 .4 r
.47333 .73209 m
.48456 .7277 L
s
.45653 .72485 m
.47333 .73209 L
s
.80592 .6537 m
.80997 .66053 L
s
.81097 .6488 m
.80592 .6537 L
s
.55794 .42527 m
.56036 .42402 L
s
.56472 .42601 m
.55794 .42527 L
s
1 0 0 r
.5666 .53054 m
.56143 .51219 L
s
.62985 .53652 m
.6363 .53349 L
s
.56334 .42155 m
.56162 .42971 L
s
0 1 .4 r
.54791 .5475 m
.56608 .54821 L
s
1 0 0 r
.84337 .76352 m
.85188 .76535 L
s
0 1 .4 r
.65444 .53323 m
.66435 .52195 L
s
.65206 .54745 m
.65444 .53323 L
s
1 0 0 r
.69731 .58263 m
.69554 .56279 L
s
.69153 .5522 m
.6895 .5601 L
s
.41032 .8899 m
.43926 .88119 L
s
0 1 .4 r
.67031 .63066 m
.68123 .62907 L
s
.50051 .35298 m
.49765 .34813 L
s
.56788 .51645 m
.572 .50879 L
s
.55048 .47343 m
.55181 .46718 L
s
.56071 .47624 m
.55048 .47343 L
s
1 0 0 r
.65016 .52128 m
.65201 .52549 L
s
0 1 .4 r
.70003 .5683 m
.69376 .56285 L
s
.6961 .58894 m
.70003 .5683 L
s
1 0 0 r
.52158 .41296 m
.53002 .41625 L
s
.52553 .41732 m
.52158 .41296 L
s
0 1 .4 r
.56876 .4593 m
.57707 .43307 L
s
1 0 0 r
.65571 .5415 m
.64948 .529 L
s
0 1 .4 r
.52693 .43762 m
.53843 .42694 L
s
1 0 0 r
.6899 .59047 m
.69731 .58263 L
s
.6349 .53801 m
.62985 .53652 L
s
.55795 .48853 m
.55687 .48772 L
s
.55687 .48772 m
.5555 .47592 L
s
0 1 .4 r
.55411 .46238 m
.54833 .45928 L
s
1 0 0 r
.54156 .45978 m
.53859 .4611 L
s
.87023 .68232 m
.86439 .69534 L
s
0 1 .4 r
.51803 .41315 m
.53526 .41808 L
s
.52473 .42009 m
.51803 .41315 L
s
1 0 0 r
.5555 .47592 m
.54694 .47217 L
s
.54694 .47217 m
.54491 .46362 L
s
.66949 .64308 m
.67567 .62851 L
s
.64948 .529 m
.65016 .52128 L
s
.80909 .65353 m
.81083 .66381 L
s
0 1 .4 r
.55181 .46718 m
.55411 .46238 L
s
.57707 .43307 m
.56839 .435 L
s
.86835 .67953 m
.86418 .70525 L
s
1 0 0 r
.43695 .73173 m
.45468 .72647 L
s
.50135 .35892 m
.49666 .35471 L
s
.50204 .35505 m
.50135 .35892 L
s
0 1 .4 r
.63997 .54806 m
.64726 .54432 L
s
.57215 .52695 m
.56218 .50734 L
s
.56608 .54821 m
.57215 .52695 L
s
.6395 .5387 m
.63308 .53675 L
s
1 0 0 r
.68338 .59025 m
.6899 .59047 L
s
.69124 .58157 m
.68338 .59025 L
s
.51485 .39172 m
.5032 .3882 L
s
.52772 .39798 m
.51485 .39172 L
s
0 1 .4 r
.69376 .56285 m
.70334 .55459 L
s
.80997 .66053 m
.80931 .66101 L
s
.92403 .78311 m
.91451 .81485 L
s
1 0 0 r
.76357 .64169 m
.76052 .63785 L
s
.67886 .55693 m
.69144 .55754 L
s
.67665 .55975 m
.67886 .55693 L
s
0 1 .4 r
.56839 .435 m
.56985 .44059 L
s
1 0 0 r
.72526 .56642 m
.73921 .57381 L
s
0 1 .4 r
.75964 .63527 m
.75087 .6404 L
s
1 0 0 r
.53002 .41625 m
.53216 .41384 L
s
.56954 .42849 m
.56334 .42155 L
s
0 1 .4 r
.5693 .43443 m
.56472 .42601 L
s
1 0 0 r
.54491 .46362 m
.54156 .45978 L
s
.56389 .53761 m
.5666 .53054 L
s
.91433 .74261 m
.89612 .75273 L
s
0 1 .4 r
.52232 .4169 m
.52473 .42009 L
s
.53843 .42694 m
.52232 .4169 L
s
.53526 .41808 m
.53615 .41438 L
s
1 0 0 r
.49666 .35471 m
.47597 .35374 L
s
.82278 .66202 m
.81685 .66623 L
s
.63883 .5567 m
.64285 .55046 L
s
.46609 .23897 m
.45102 .23692 L
s
.68711 .5555 m
.68543 .56033 L
s
0 1 .4 r
.43637 .7266 m
.45653 .72485 L
s
.72999 .56865 m
.73846 .57373 L
s
.88402 .69327 m
.8903 .71408 L
s
1 0 0 r
.57277 .43497 m
.56605 .43746 L
s
0 1 .4 r
.69021 .55384 m
.6891 .557 L
s
1 0 0 r
.5032 .3882 m
.48819 .39893 L
s
0 1 .4 r
.82596 .66241 m
.81805 .66624 L
s
1 0 0 r
.69144 .55754 m
.68711 .5555 L
s
.67788 .61975 m
.68042 .60699 L
s
.67567 .62851 m
.67788 .61975 L
s
.66953 .57138 m
.66983 .56443 L
s
.66692 .5756 m
.66953 .57138 L
s
0 1 .4 r
.68569 .55356 m
.69021 .55384 L
s
1 0 0 r
.38803 .87249 m
.42858 .8823 L
s
0 1 .4 r
.51203 .38757 m
.47942 .40302 L
s
.66763 .5675 m
.67909 .55354 L
s
.66889 .56063 m
.66763 .5675 L
s
.5209 .48541 m
.51192 .46936 L
s
.50538 .50111 m
.5209 .48541 L
s
1 0 0 r
.57139 .51661 m
.56894 .51158 L
s
0 1 .4 r
.56985 .44059 m
.5693 .43443 L
s
1 0 0 r
.63114 .56578 m
.63379 .55984 L
s
.9253 .78153 m
.91772 .81373 L
s
0 1 .4 r
.5016 .50826 m
.50176 .50093 L
s
.51266 .50912 m
.5016 .50826 L
s
.67665 .62133 m
.68546 .60663 L
s
.68123 .62907 m
.67665 .62133 L
s
.67569 .55535 m
.68569 .55356 L
s
.38217 .87034 m
.42395 .87709 L
s
1 0 0 r
.50183 .51099 m
.50182 .50385 L
s
.5071 .51363 m
.50183 .51099 L
s
.63444 .56513 m
.63114 .56578 L
s
.881 .68862 m
.88473 .71371 L
s
0 1 .4 r
.6321 .5642 m
.63272 .56216 L
s
.63027 .55669 m
.6321 .5642 L
s
1 0 0 r
.81083 .66381 m
.80429 .6654 L
s
0 1 .4 r
.67193 .56742 m
.66849 .55949 L
s
1 0 0 r
.50182 .50385 m
.49328 .48093 L
s
0 1 .4 r
.53829 .52564 m
.53052 .51553 L
s
.53696 .53254 m
.53829 .52564 L
s
.56964 .53071 m
.56788 .51645 L
s
.49765 .34813 m
.47238 .35541 L
s
1 0 0 r
.57423 .52844 m
.57139 .51661 L
s
.7259 .572 m
.72526 .56642 L
s
.5149 .48768 m
.50834 .47939 L
s
.50817 .50111 m
.5149 .48768 L
s
.53276 .52408 m
.5318 .51924 L
s
.53424 .53411 m
.53276 .52408 L
s
0 1 .4 r
.45942 .23965 m
.45412 .24063 L
s
1 0 0 r
.69583 .58422 m
.69124 .58157 L
s
0 1 .4 r
.46341 .3658 m
.44889 .36806 L
s
.47238 .35541 m
.46341 .3658 L
s
.6544 .56429 m
.64826 .56074 L
s
.66221 .56801 m
.6544 .56429 L
s
.42456 .73687 m
.43637 .7266 L
s
1 0 0 r
.56605 .43746 m
.56954 .42849 L
s
0 1 .4 r
.45412 .24063 m
.44444 .23123 L
s
.68896 .59511 m
.69491 .58645 L
s
.68547 .59658 m
.68896 .59511 L
s
1 0 0 r
.66983 .56443 m
.6678 .56104 L
s
0 1 .4 r
.68546 .60663 m
.68547 .59658 L
s
1 0 0 r
.5318 .51924 m
.52772 .50536 L
s
0 1 .4 r
.67909 .55354 m
.67569 .55535 L
s
.91411 .73626 m
.89447 .74929 L
s
1 0 0 r
.38644 .89363 m
.41032 .8899 L
s
.50834 .47939 m
.50553 .46843 L
s
0 1 .4 r
.4937 .64923 m
.50288 .6549 L
s
.47794 .66122 m
.4937 .64923 L
s
1 0 0 r
.38286 .77385 m
.39609 .77466 L
s
.66088 .56963 m
.65805 .55263 L
s
.66017 .56108 m
.66088 .56963 L
s
.68083 .5962 m
.68769 .59088 L
s
.68042 .60699 m
.68083 .5962 L
s
0 1 .4 r
.50176 .50093 m
.49623 .47723 L
s
.38729 .77365 m
.39061 .77157 L
s
.35965 .77516 m
.38729 .77365 L
s
1 0 0 r
.69481 .58539 m
.69583 .58422 L
s
.47597 .35374 m
.45764 .36605 L
s
0 1 .4 r
.72419 .56721 m
.72999 .56865 L
s
1 0 0 r
.81685 .66623 m
.80859 .67491 L
s
.42708 .73482 m
.43695 .73173 L
s
.34817 .85523 m
.37691 .85957 L
s
0 1 .4 r
.71544 .57359 m
.72419 .56721 L
s
.70337 .58307 m
.71544 .57359 L
s
.81805 .66624 m
.8097 .6763 L
s
.52065 .52115 m
.50953 .5234 L
s
.51767 .51494 m
.52065 .52115 L
s
.73529 .59165 m
.73433 .58562 L
s
.71625 .59748 m
.73529 .59165 L
s
1 0 0 r
.48716 .65959 m
.50522 .651 L
s
.47403 .66083 m
.48716 .65959 L
s
0 1 .4 r
.57452 .54869 m
.56964 .53071 L
s
.58697 .54379 m
.57452 .54869 L
s
.64826 .56074 m
.66079 .54577 L
s
1 0 0 r
.51194 .52259 m
.50958 .51616 L
s
.51922 .52644 m
.51194 .52259 L
s
.71739 .59441 m
.7361 .58616 L
s
.73212 .59374 m
.71739 .59441 L
s
0 1 .4 r
.44444 .23123 m
.42631 .23682 L
s
.62996 .56463 m
.63027 .55669 L
s
.62428 .56874 m
.62996 .56463 L
s
1 0 0 r
.71361 .58472 m
.71071 .58227 L
s
.71789 .59446 m
.71361 .58472 L
s
.66524 .56678 m
.66017 .56108 L
s
0 1 .4 r
.70169 .5849 m
.69658 .58148 L
s
.69491 .58645 m
.70169 .5849 L
s
1 0 0 r
.62651 .56522 m
.63444 .56513 L
s
.45102 .23692 m
.4399 .2361 L
s
0 1 .4 r
.42202 .73559 m
.42456 .73687 L
s
.53052 .51553 m
.5286 .50618 L
s
1 0 0 r
.51166 .50766 m
.50817 .50111 L
s
.71218 .57041 m
.7259 .572 L
s
.50958 .51616 m
.5071 .51363 L
s
0 1 .4 r
.47969 .4724 m
.4858 .46013 L
s
.49174 .46915 m
.47969 .4724 L
s
1 0 0 r
.67387 .56084 m
.67665 .55975 L
s
.67228 .55949 m
.67387 .56084 L
s
.76052 .63785 m
.75949 .63774 L
s
0 1 .4 r
.50953 .5234 m
.51266 .50912 L
s
1 0 0 r
.68769 .59088 m
.69481 .58539 L
s
0 1 .4 r
.5286 .50618 m
.51344 .51039 L
s
.63808 .56947 m
.63997 .54806 L
s
1 0 0 r
.52772 .50536 m
.51166 .50766 L
s
0 1 .4 r
.39171 .89721 m
.41017 .88402 L
s
1 0 0 r
.6678 .56104 m
.67228 .55949 L
s
.63167 .56267 m
.63883 .5567 L
s
0 1 .4 r
.59022 .55053 m
.58697 .54379 L
s
.58078 .56371 m
.59022 .55053 L
s
.71243 .58257 m
.71544 .58073 L
s
.71735 .59957 m
.71243 .58257 L
s
1 0 0 r
.86439 .69534 m
.85691 .7091 L
s
.58571 .53993 m
.57423 .52844 L
s
.45764 .36605 m
.44887 .36686 L
s
0 1 .4 r
.4995 .42879 m
.50158 .43706 L
s
.51259 .43081 m
.4995 .42879 L
s
1 0 0 r
.58801 .54179 m
.58571 .53993 L
s
.59064 .55146 m
.58801 .54179 L
s
0 1 .4 r
.49687 .59667 m
.51305 .59854 L
s
.50609 .60182 m
.49687 .59667 L
s
.7342 .59821 m
.71625 .59748 L
s
.34896 .85267 m
.38245 .86355 L
s
1 0 0 r
.6714 .59101 m
.66692 .5756 L
s
0 1 .4 r
.51192 .46936 m
.50505 .46827 L
s
1 0 0 r
.42016 .73094 m
.42708 .73482 L
s
.48819 .39893 m
.48213 .38773 L
s
.71436 .58445 m
.71845 .58565 L
s
.71071 .58227 m
.71436 .58445 L
s
.49054 .47679 m
.48314 .46626 L
s
.49328 .48093 m
.49054 .47679 L
s
.72238 .58587 m
.71789 .59446 L
s
0 1 .4 r
.36997 .87495 m
.38217 .87034 L
s
.67228 .59557 m
.66877 .57833 L
s
.67565 .60269 m
.67228 .59557 L
s
1 0 0 r
.67178 .59257 m
.6714 .59101 L
s
.4399 .2361 m
.42719 .24178 L
s
.52746 .54791 m
.52183 .54574 L
s
.52989 .55558 m
.52746 .54791 L
s
0 1 .4 r
.73517 .59091 m
.71735 .59957 L
s
1 0 0 r
.36801 .77147 m
.38286 .77385 L
s
0 1 .4 r
.51808 .47508 m
.51808 .46892 L
s
.52985 .48566 m
.51808 .47508 L
s
.66849 .55949 m
.66889 .56063 L
s
1 0 0 r
.37224 .87707 m
.38803 .87249 L
s
.7361 .58616 m
.73226 .58498 L
s
.74271 .60447 m
.73212 .59374 L
s
0 1 .4 r
.40956 .74394 m
.42202 .73559 L
s
.6297 .56009 m
.63808 .56947 L
s
.70408 .58946 m
.70337 .58307 L
s
1 0 0 r
.49919 .4302 m
.50321 .43004 L
s
.50044 .42672 m
.49919 .4302 L
s
0 1 .4 r
.8503 .77051 m
.846 .77391 L
s
1 0 0 r
.70538 .58125 m
.71218 .57041 L
s
.74364 .61615 m
.74271 .60447 L
s
.75124 .62017 m
.74364 .61615 L
s
0 1 .4 r
.75087 .6404 m
.76867 .64047 L
s
.53001 .54983 m
.51294 .54726 L
s
.53518 .55164 m
.53001 .54983 L
s
1 0 0 r
.85188 .76535 m
.84006 .77616 L
s
0 1 .4 r
.86418 .70525 m
.85815 .71285 L
s
1 0 0 r
.41258 .74155 m
.42016 .73094 L
s
0 1 .4 r
.54628 .55315 m
.55012 .54123 L
s
.56149 .55928 m
.54628 .55315 L
s
.72931 .60436 m
.7342 .59821 L
s
1 0 0 r
.62276 .56804 m
.62651 .56522 L
s
.72974 .59199 m
.72238 .58587 L
s
.51766 .59566 m
.53235 .58629 L
s
.50805 .60371 m
.51766 .59566 L
s
.48314 .46626 m
.47934 .4592 L
s
0 1 .4 r
.50085 .64049 m
.49355 .62358 L
s
.50288 .6549 m
.50085 .64049 L
s
1 0 0 r
.80859 .67491 m
.79953 .68642 L
s
.70908 .58795 m
.70538 .58125 L
s
0 1 .4 r
.49623 .47723 m
.49174 .46915 L
s
.75001 .62735 m
.74877 .61259 L
s
.75348 .61248 m
.75001 .62735 L
s
1 0 0 r
.58981 .56311 m
.59064 .55146 L
s
.91333 .73612 m
.89972 .75403 L
s
0 1 .4 r
.52593 .42768 m
.52124 .43633 L
s
.52014 .44815 m
.52593 .42768 L
s
1 0 0 r
.47477 .66844 m
.47403 .66083 L
s
0 1 .4 r
.47942 .40302 m
.48001 .38093 L
s
.51344 .51039 m
.50538 .50111 L
s
1 0 0 r
.52697 .56463 m
.52989 .55558 L
s
0 1 .4 r
.53112 .56997 m
.53518 .55164 L
s
.74877 .61259 m
.72931 .60436 L
s
.71952 .58643 m
.70408 .58946 L
s
.71876 .57305 m
.71952 .58643 L
s
.51066 .59405 m
.53125 .58312 L
s
.51305 .59854 m
.51066 .59405 L
s
.55012 .54123 m
.53309 .52872 L
s
.42631 .23682 m
.409 .25428 L
s
.34546 .8698 m
.36997 .87495 L
s
.66877 .57833 m
.67824 .57411 L
s
1 0 0 r
.50952 .43396 m
.50044 .42672 L
s
0 1 .4 r
.52124 .43633 m
.51373 .42567 L
s
.48555 .66794 m
.47794 .66122 L
s
.62522 .57104 m
.62428 .56874 L
s
.62176 .57848 m
.62522 .57104 L
s
.47077 .66564 m
.48555 .66794 L
s
.45726 .67086 m
.47077 .66564 L
s
1 0 0 r
.75949 .63774 m
.75458 .63526 L
s
.52037 .53445 m
.51922 .52644 L
s
.52183 .54574 m
.52037 .53445 L
s
.5069 .42872 m
.50952 .43396 L
s
.51609 .42667 m
.5069 .42872 L
s
.6559 .57586 m
.66754 .5711 L
s
.66813 .5821 m
.6559 .57586 L
s
0 1 .4 r
.71544 .58073 m
.71876 .57305 L
s
.80931 .66101 m
.80007 .66704 L
s
1 0 0 r
.73226 .58498 m
.72974 .59199 L
s
.62628 .56225 m
.63167 .56267 L
s
0 1 .4 r
.90336 .73496 m
.89285 .74553 L
s
1 0 0 r
.75052 .6182 m
.75022 .6153 L
s
.75641 .624 m
.75052 .6182 L
s
0 1 .4 r
.50295 .61035 m
.50609 .60182 L
s
1 0 0 r
.49545 .6263 m
.49878 .61367 L
s
.49605 .64147 m
.49545 .6263 L
s
.53635 .53 m
.53424 .53411 L
s
.75022 .6153 m
.75124 .62017 L
s
.50522 .651 m
.49605 .64147 L
s
.32191 .8502 m
.34817 .85523 L
s
0 1 .4 r
.75444 .62191 m
.75348 .61248 L
s
.75764 .63135 m
.75444 .62191 L
s
1 0 0 r
.71845 .58565 m
.70908 .58795 L
s
.50026 .60139 m
.50805 .60371 L
s
.50319 .60652 m
.50026 .60139 L
s
.89612 .75273 m
.88776 .76691 L
s
0 1 .4 r
.65228 .57855 m
.6773 .5695 L
s
.67608 .57664 m
.65228 .57855 L
s
.51941 .57801 m
.53112 .56997 L
s
1 0 0 r
.53147 .47833 m
.5231 .47054 L
s
.54067 .48698 m
.53147 .47833 L
s
.85691 .7091 m
.846 .71251 L
s
.80429 .6654 m
.79295 .67206 L
s
.52643 .57396 m
.52697 .56463 L
s
0 1 .4 r
.8097 .6763 m
.80204 .68743 L
s
1 0 0 r
.47402 .66705 m
.47477 .66844 L
s
.45581 .67599 m
.47402 .66705 L
s
0 1 .4 r
.51373 .42567 m
.51259 .43081 L
s
.67643 .61214 m
.67565 .60269 L
s
1 0 0 r
.67134 .60452 m
.67178 .59257 L
s
0 1 .4 r
.327 .84876 m
.34896 .85267 L
s
.42585 .67046 m
.44181 .68342 L
s
.41894 .67913 m
.42585 .67046 L
s
.50158 .43706 m
.50124 .42833 L
s
1 0 0 r
.53235 .58629 m
.52643 .57396 L
s
0 1 .4 r
.50505 .46827 m
.49831 .45655 L
s
1 0 0 r
.5185 .43071 m
.51609 .42667 L
s
.49878 .61367 m
.50319 .60652 L
s
0 1 .4 r
.49355 .62358 m
.50295 .61035 L
s
.50124 .42833 m
.5101 .42485 L
s
.49831 .45655 m
.48505 .46904 L
s
1 0 0 r
.39382 .7467 m
.41258 .74155 L
s
.54913 .55263 m
.54865 .53827 L
s
.56064 .56233 m
.54913 .55263 L
s
0 1 .4 r
.51298 .53323 m
.51767 .51494 L
s
1 0 0 r
.88473 .71371 m
.87834 .72937 L
s
0 1 .4 r
.54411 .48385 m
.52985 .48566 L
s
.76867 .64047 m
.75229 .63972 L
s
.51294 .54726 m
.51298 .53323 L
s
1 0 0 r
.50553 .46843 m
.49352 .46184 L
s
.91772 .81373 m
.90534 .82214 L
s
0 1 .4 r
.89447 .74929 m
.89113 .76762 L
s
1 0 0 r
.42719 .24178 m
.4088 .25204 L
s
0 1 .4 r
.55745 .57093 m
.56149 .55928 L
s
.53309 .52872 m
.53696 .53254 L
s
.45411 .38255 m
.43961 .39889 L
s
.45744 .38182 m
.45411 .38255 L
s
.7227 .66484 m
.72544 .65828 L
s
.7214 .68522 m
.7227 .66484 L
s
1 0 0 r
.54865 .53827 m
.53635 .53 L
s
.34884 .87206 m
.37224 .87707 L
s
0 1 .4 r
.53125 .58312 m
.51941 .57801 L
s
.44181 .68342 m
.45726 .67086 L
s
.73213 .59031 m
.73517 .59091 L
s
1 0 0 r
.5231 .47054 m
.5191 .46408 L
s
.66754 .5711 m
.66524 .56678 L
s
.62 .56545 m
.62628 .56225 L
s
0 1 .4 r
.91451 .81485 m
.90969 .81605 L
s
1 0 0 r
.75458 .63526 m
.75641 .624 L
s
.53192 .49273 m
.54067 .48698 L
s
0 1 .4 r
.85815 .71285 m
.84971 .71117 L
s
.52925 .48944 m
.54411 .48385 L
s
1 0 0 r
.62612 .56854 m
.62276 .56804 L
s
.6273 .57209 m
.62612 .56854 L
s
.846 .71251 m
.83005 .71978 L
s
.46265 .38625 m
.45103 .38679 L
s
.47019 .38177 m
.46265 .38625 L
s
.44887 .36686 m
.43224 .3681 L
s
.48213 .38773 m
.47019 .38177 L
s
0 1 .4 r
.39257 .74864 m
.40956 .74394 L
s
1 0 0 r
.43945 .6832 m
.45581 .67599 L
s
0 1 .4 r
.48505 .46904 m
.47487 .45673 L
s
1 0 0 r
.50321 .43004 m
.50324 .42553 L
s
0 1 .4 r
.8903 .71408 m
.87928 .73141 L
s
1 0 0 r
.49352 .46184 m
.48883 .46514 L
s
.89972 .75403 m
.89889 .77243 L
s
0 1 .4 r
.6773 .5695 m
.66221 .56801 L
s
.6136 .56558 m
.6297 .56009 L
s
.73433 .58562 m
.73213 .59031 L
s
.80007 .66704 m
.79623 .66528 L
s
1 0 0 r
.67875 .61882 m
.67134 .60452 L
s
0 1 .4 r
.52528 .45246 m
.52014 .44815 L
s
.54578 .53771 m
.5545 .52088 L
s
.55513 .54172 m
.54578 .53771 L
s
.84971 .71117 m
.823 .72046 L
s
.89285 .74553 m
.89716 .78284 L
s
1 0 0 r
.45103 .38679 m
.43778 .39272 L
s
.47934 .4592 m
.47791 .45601 L
s
.79953 .68642 m
.78469 .69 L
s
.51773 .44579 m
.5185 .43071 L
s
.52389 .45556 m
.51773 .44579 L
s
0 1 .4 r
.80204 .68743 m
.78189 .69106 L
s
1 0 0 r
.79295 .67206 m
.79222 .6671 L
s
.5342 .50522 m
.53192 .49273 L
s
.5191 .46408 m
.52389 .45556 L
s
0 1 .4 r
.67556 .59579 m
.67608 .57664 L
s
.67106 .6058 m
.67556 .59579 L
s
.42791 .67739 m
.41894 .67913 L
s
.74789 .66283 m
.73792 .67767 L
s
.7537 .67292 m
.74789 .66283 L
s
1 0 0 r
.50324 .42553 m
.4978 .42011 L
s
0 1 .4 r
.48001 .38093 m
.46817 .38103 L
s
1 0 0 r
.3474 .76234 m
.36801 .77147 L
s
0 1 .4 r
.46817 .38103 m
.45744 .38182 L
s
1 0 0 r
.34923 .89453 m
.38644 .89363 L
s
.72312 .66195 m
.72244 .65467 L
s
.72421 .68104 m
.72312 .66195 L
s
0 1 .4 r
.61664 .58186 m
.6136 .56558 L
s
1 0 0 r
.66917 .59527 m
.66813 .5821 L
s
0 1 .4 r
.75229 .63972 m
.75764 .63135 L
s
1 0 0 r
.42824 .67522 m
.4283 .67145 L
s
.42693 .67561 m
.42824 .67522 L
s
.4978 .42011 m
.48915 .41722 L
s
.45804 .42565 m
.44041 .42535 L
s
.47291 .41848 m
.45804 .42565 L
s
0 1 .4 r
.70827 .6167 m
.6928 .61911 L
s
.71379 .63898 m
.70827 .6167 L
s
.49937 .42375 m
.49582 .41402 L
s
.5101 .42485 m
.49937 .42375 L
s
.409 .25428 m
.37755 .26471 L
s
.51808 .46892 m
.52528 .45246 L
s
1 0 0 r
.48883 .46514 m
.48028 .46051 L
s
0 1 .4 r
.49582 .41402 m
.48815 .42267 L
s
.823 .72046 m
.82908 .72124 L
s
.45056 .45381 m
.44066 .47064 L
s
.46357 .46004 m
.45056 .45381 L
s
.43961 .39889 m
.43405 .40486 L
s
.87928 .73141 m
.86617 .73622 L
s
1 0 0 r
.62063 .57856 m
.62 .56545 L
s
.4088 .25204 m
.38011 .25619 L
s
0 1 .4 r
.47105 .46833 m
.46357 .46004 L
s
.44889 .36806 m
.43319 .36449 L
s
.46296 .42041 m
.45987 .42168 L
s
.48815 .42267 m
.46296 .42041 L
s
1 0 0 r
.55989 .56713 m
.56064 .56233 L
s
0 1 .4 r
.6799 .62292 m
.67643 .61214 L
s
1 0 0 r
.4283 .67438 m
.43945 .6832 L
s
.4283 .67145 m
.4283 .67438 L
s
.67713 .61892 m
.67875 .61882 L
s
.46075 .45441 m
.44982 .45521 L
s
.47385 .46057 m
.46075 .45441 L
s
0 1 .4 r
.72544 .65828 m
.72247 .64691 L
s
.76005 .67781 m
.7537 .67292 L
s
1 0 0 r
.48676 .41849 m
.47291 .41848 L
s
.70863 .6244 m
.69694 .62187 L
s
.71454 .63415 m
.70863 .6244 L
s
0 1 .4 r
.40849 .66699 m
.42727 .67159 L
s
.39561 .64853 m
.40849 .66699 L
s
.59186 .56457 m
.58078 .56371 L
s
1 0 0 r
.48233 .46385 m
.47385 .46057 L
s
.48028 .46051 m
.48233 .46385 L
s
0 1 .4 r
.78189 .69106 m
.77391 .69311 L
s
.34827 .76889 m
.35965 .77516 L
s
1 0 0 r
.37745 .73533 m
.39382 .7467 L
s
.78469 .69 m
.77978 .68869 L
s
.83005 .71978 m
.82694 .72247 L
s
.66942 .60708 m
.66917 .59527 L
s
.43778 .39272 m
.4333 .39355 L
s
.59376 .56443 m
.58981 .56311 L
s
0 1 .4 r
.62703 .5771 m
.62176 .57848 L
s
.37091 .73811 m
.39257 .74864 L
s
.45987 .42168 m
.44181 .417 L
s
1 0 0 r
.72502 .6786 m
.72421 .68104 L
s
0 1 .4 r
.47549 .45698 m
.46139 .45478 L
s
.4858 .46013 m
.47549 .45698 L
s
1 0 0 r
.5626 .57372 m
.56432 .56806 L
s
.56726 .59717 m
.5626 .57372 L
s
.42837 .67083 m
.42693 .67561 L
s
.4096 .66401 m
.42837 .67083 L
s
0 1 .4 r
.5603 .56835 m
.56375 .57386 L
s
.56776 .60645 m
.5603 .56835 L
s
.47487 .45673 m
.48103 .46856 L
s
1 0 0 r
.6703 .60366 m
.66942 .60708 L
s
0 1 .4 r
.52831 .50335 m
.52925 .48944 L
s
.53915 .50883 m
.52831 .50335 L
s
.82908 .72124 m
.81822 .72725 L
s
1 0 0 r
.74884 .66865 m
.73476 .67616 L
s
.74983 .67588 m
.74884 .66865 L
s
0 1 .4 r
.6928 .61911 m
.69236 .6191 L
s
.42727 .67159 m
.42812 .66312 L
s
1 0 0 r
.75995 .68082 m
.74983 .67588 L
s
.77391 .68552 m
.75995 .68082 L
s
.55584 .52194 m
.54492 .51427 L
s
.5495 .53179 m
.55584 .52194 L
s
0 1 .4 r
.38897 .65015 m
.39561 .64853 L
s
1 0 0 r
.55671 .53709 m
.5495 .53179 L
s
0 1 .4 r
.42812 .66312 m
.42791 .67739 L
s
1 0 0 r
.72244 .65467 m
.72553 .64981 L
s
.79222 .6671 m
.78728 .66903 L
s
0 1 .4 r
.68612 .62178 m
.66406 .59682 L
s
.69236 .6191 m
.68612 .62178 L
s
.66406 .59682 m
.67106 .6058 L
s
1 0 0 r
.62715 .57713 m
.6273 .57209 L
s
.35895 .72772 m
.37745 .73533 L
s
.82694 .72247 m
.82383 .72428 L
s
0 1 .4 r
.4004 .46015 m
.40475 .48008 L
s
.40249 .47005 m
.4004 .46015 L
s
.77199 .69187 m
.76005 .67781 L
s
.77391 .69311 m
.77199 .69187 L
s
.7333 .6548 m
.73327 .65397 L
s
.74232 .66714 m
.7333 .6548 L
s
.5545 .52088 m
.53915 .50883 L
s
.48103 .46856 m
.47105 .46833 L
s
1 0 0 r
.61608 .58186 m
.62063 .57856 L
s
.48915 .41722 m
.48676 .41849 L
s
.87834 .72937 m
.86358 .74457 L
s
.54492 .51427 m
.5342 .50522 L
s
0 1 .4 r
.30134 .82766 m
.327 .84876 L
s
.56375 .57386 m
.55477 .55413 L
s
.59221 .58313 m
.59186 .56457 L
s
.43319 .36449 m
.43112 .37204 L
s
.62043 .58405 m
.61664 .58186 L
s
.61784 .61456 m
.62043 .58405 L
s
.40475 .48008 m
.3802 .48563 L
s
1 0 0 r
.55634 .57201 m
.55989 .56713 L
s
.55448 .57302 m
.55634 .57201 L
s
.47791 .45601 m
.45674 .45821 L
s
.67746 .61435 m
.6703 .60366 L
s
.68572 .62001 m
.67746 .61435 L
s
.69694 .62187 m
.68572 .62001 L
s
.44982 .45521 m
.44601 .46556 L
s
0 1 .4 r
.79623 .66528 m
.78604 .66786 L
s
1 0 0 r
.73106 .66027 m
.72135 .65049 L
s
.74054 .66476 m
.73106 .66027 L
s
.56432 .56806 m
.5579 .55605 L
s
0 1 .4 r
.34858 .27318 m
.3214 .27709 L
s
.37453 .26898 m
.34858 .27318 L
s
1 0 0 r
.40346 .65608 m
.4096 .66401 L
s
.39156 .65481 m
.40346 .65608 L
s
.78728 .66903 m
.78317 .6685 L
s
.72553 .64981 m
.7165 .64119 L
s
.77978 .68869 m
.77391 .68552 L
s
0 1 .4 r
.72713 .6772 m
.7214 .68522 L
s
1 0 0 r
.34387 .71403 m
.35895 .72772 L
s
0 1 .4 r
.35412 .71985 m
.37091 .73811 L
s
1 0 0 r
.88776 .76691 m
.87405 .78334 L
s
.73476 .67616 m
.72502 .6786 L
s
0 1 .4 r
.35179 .89794 m
.39171 .89721 L
s
1 0 0 r
.84006 .77616 m
.83203 .78448 L
s
.6282 .59301 m
.62715 .57713 L
s
0 1 .4 r
.73792 .67767 m
.72713 .6772 L
s
.41361 .46094 m
.40249 .47005 L
s
1 0 0 r
.43224 .3681 m
.42928 .36368 L
s
0 1 .4 r
.63085 .64355 m
.62826 .64813 L
s
.65105 .67555 m
.63085 .64355 L
s
.46139 .45478 m
.43598 .45065 L
s
.37755 .26471 m
.37453 .26898 L
s
.32554 .76265 m
.34827 .76889 L
s
.31646 .74355 m
.32554 .76265 L
s
.78604 .66786 m
.78161 .67048 L
s
1 0 0 r
.44601 .46556 m
.42872 .45615 L
s
0 1 .4 r
.55477 .55413 m
.55513 .54172 L
s
.59474 .58016 m
.59221 .58313 L
s
.58965 .58955 m
.59474 .58016 L
s
1 0 0 r
.72135 .65049 m
.72117 .6469 L
s
.33006 .76048 m
.3474 .76234 L
s
0 1 .4 r
.72247 .64691 m
.7129 .63599 L
s
1 0 0 r
.59296 .58631 m
.59376 .56443 L
s
0 1 .4 r
.90969 .81605 m
.88996 .83271 L
s
1 0 0 r
.42351 .4644 m
.42772 .46027 L
s
.42872 .45615 m
.42351 .4644 L
s
0 1 .4 r
.63157 .59362 m
.62703 .5771 L
s
1 0 0 r
.55974 .60185 m
.56726 .59717 L
s
0 1 .4 r
.7129 .63599 m
.71379 .63898 L
s
.42819 .45887 m
.42753 .47095 L
s
.42997 .45467 m
.42819 .45887 L
s
1 0 0 r
.68929 .62817 m
.67713 .61892 L
s
0 1 .4 r
.44066 .47064 m
.42997 .45467 L
s
.55416 .60225 m
.56776 .60645 L
s
1 0 0 r
.40241 .4684 m
.39811 .48512 L
s
.40624 .46779 m
.40241 .4684 L
s
0 1 .4 r
.69025 .64317 m
.68445 .63059 L
s
.69774 .63897 m
.69025 .64317 L
s
1 0 0 r
.59169 .58471 m
.59296 .58631 L
s
.59285 .59293 m
.59169 .58471 L
s
.7165 .64119 m
.71454 .63415 L
s
0 1 .4 r
.68955 .63378 m
.6799 .62292 L
s
1 0 0 r
.5579 .55605 m
.55671 .53709 L
s
0 1 .4 r
.7547 .69118 m
.75148 .68846 L
s
.76195 .67699 m
.7547 .69118 L
s
1 0 0 r
.41598 .46013 m
.40624 .46779 L
s
.4333 .39355 m
.42967 .39765 L
s
0 1 .4 r
.18995 .97893 m
.24015 1.00938 L
s
1 0 0 r
.38011 .25619 m
.3698 .26567 L
s
0 1 .4 r
.4231 .45601 m
.41361 .46094 L
s
.81229 .72912 m
.80262 .73468 L
s
.81822 .72725 m
.81229 .72912 L
s
.5622 .57547 m
.55745 .57093 L
s
1 0 0 r
.30181 .82926 m
.32191 .8502 L
s
.6205 .60356 m
.61608 .58186 L
s
.74617 .66637 m
.74054 .66476 L
s
.31319 .8515 m
.34884 .87206 L
s
0 1 .4 r
.75128 .662 m
.74232 .66714 L
s
.41515 .42713 m
.3976 .43473 L
s
.43676 .4257 m
.41515 .42713 L
s
1 0 0 r
.45674 .45821 m
.43871 .45445 L
s
.39141 .59022 m
.39152 .60385 L
s
.39451 .58031 m
.39141 .59022 L
s
.44041 .42535 m
.43138 .42172 L
s
0 1 .4 r
.73327 .65397 m
.72112 .64787 L
s
.846 .77391 m
.83248 .7897 L
s
1 0 0 r
.41477 .46449 m
.40637 .47276 L
s
.42772 .46027 m
.41477 .46449 L
s
0 1 .4 r
.34205 .71621 m
.35412 .71985 L
s
.39906 .58387 m
.38525 .59659 L
s
.38731 .5811 m
.39906 .58387 L
s
1 0 0 r
.7531 .68577 m
.7549 .67972 L
s
.75298 .68644 m
.7531 .68577 L
s
0 1 .4 r
.43112 .37204 m
.42521 .36071 L
s
1 0 0 r
.42407 .45905 m
.41598 .46013 L
s
.43871 .45445 m
.42407 .45905 L
s
.72117 .6469 m
.69962 .64518 L
s
0 1 .4 r
.43405 .40486 m
.42183 .39834 L
s
1 0 0 r
.69962 .64518 m
.69482 .63974 L
s
0 1 .4 r
.38525 .59659 m
.39413 .60009 L
s
.89113 .76762 m
.88448 .78096 L
s
.72112 .64787 m
.69774 .63897 L
s
1 0 0 r
.90534 .82214 m
.88911 .83088 L
s
.31513 .74613 m
.33006 .76048 L
s
.4283 .42586 m
.41443 .42722 L
s
.43138 .42172 m
.4283 .42586 L
s
.40637 .47276 m
.39496 .47308 L
s
0 1 .4 r
.55646 .57116 m
.5622 .57547 L
s
1 0 0 r
.18765 .97153 m
.23873 1.01105 L
s
0 1 .4 r
.62051 .62097 m
.61784 .61456 L
s
.61848 .63387 m
.62051 .62097 L
s
1 0 0 r
.39811 .48512 m
.3835 .49438 L
s
0 1 .4 r
.43598 .45065 m
.4231 .45601 L
s
1 0 0 r
.81311 .72994 m
.80492 .73303 L
s
.82383 .72428 m
.81311 .72994 L
s
0 1 .4 r
.65987 .68439 m
.65105 .67555 L
s
1 0 0 r
.69104 .63792 m
.68929 .62817 L
s
.69482 .63974 m
.69104 .63792 L
s
0 1 .4 r
.68445 .63059 m
.68955 .63378 L
s
.39413 .60009 m
.38539 .61143 L
s
.30458 .85667 m
.34546 .8698 L
s
1 0 0 r
.63544 .64894 m
.63535 .63878 L
s
.65011 .67071 m
.63544 .64894 L
s
0 1 .4 r
.75148 .68846 m
.75501 .67328 L
s
.41687 .55177 m
.40704 .55799 L
s
.41964 .54524 m
.41687 .55177 L
s
1 0 0 r
.40342 .55887 m
.39727 .56371 L
s
.41892 .55455 m
.40342 .55887 L
s
.39888 .64261 m
.39156 .65481 L
s
0 1 .4 r
.62759 .60424 m
.63157 .59362 L
s
.42753 .47095 m
.41932 .46212 L
s
1 0 0 r
.78317 .6685 m
.77398 .67643 L
s
0 1 .4 r
.42721 .4228 m
.43676 .4257 L
s
.44181 .417 m
.42721 .4228 L
s
1 0 0 r
.39975 .37593 m
.3807 .38286 L
s
.41809 .36542 m
.39975 .37593 L
s
0 1 .4 r
.29925 .72473 m
.31646 .74355 L
s
1 0 0 r
.39255 .58316 m
.39451 .58031 L
s
.63535 .63878 m
.62697 .62555 L
s
.75591 .68382 m
.75298 .68644 L
s
0 1 .4 r
.40531 .64344 m
.38897 .65015 L
s
.39589 .37936 m
.38599 .37702 L
s
.42521 .36071 m
.39589 .37936 L
s
.62826 .64813 m
.61848 .63387 L
s
1 0 0 r
.56876 .60352 m
.55974 .60185 L
s
.62697 .62555 m
.62198 .6225 L
s
0 1 .4 r
.86617 .73622 m
.84072 .74521 L
s
.78161 .67048 m
.76494 .67605 L
s
1 0 0 r
.39152 .60385 m
.39244 .60244 L
s
.62921 .6037 m
.6282 .59301 L
s
0 1 .4 r
.3802 .48563 m
.3887 .49894 L
s
.75582 .67825 m
.76195 .67699 L
s
.63434 .6032 m
.62759 .60424 L
s
1 0 0 r
.7549 .67972 m
.74617 .66637 L
s
0 1 .4 r
.76494 .67605 m
.75582 .67825 L
s
1 0 0 r
.77398 .67643 m
.76258 .68327 L
s
.62198 .6225 m
.6205 .60356 L
s
.39727 .56371 m
.39255 .58316 L
s
.76258 .68327 m
.75591 .68382 L
s
0 1 .4 r
.30505 .88272 m
.35179 .89794 L
s
1 0 0 r
.3698 .26567 m
.3498 .27032 L
s
0 1 .4 r
.62949 .62797 m
.63177 .62485 L
s
.65238 .63215 m
.62949 .62797 L
s
1 0 0 r
.29877 .7268 m
.31513 .74613 L
s
0 1 .4 r
.41932 .46212 m
.40346 .46982 L
s
1 0 0 r
.62936 .62575 m
.62895 .61425 L
s
.64727 .63139 m
.62936 .62575 L
s
0 1 .4 r
.39744 .56216 m
.38731 .5811 L
s
.40704 .55799 m
.39744 .56216 L
s
1 0 0 r
.65728 .68367 m
.65011 .67071 L
s
0 1 .4 r
.75501 .67328 m
.75128 .662 L
s
1 0 0 r
.41703 .54681 m
.41892 .55455 L
s
.3835 .49438 m
.37996 .49722 L
s
.42967 .39765 m
.41705 .40407 L
s
.89889 .77243 m
.88681 .77328 L
s
.42928 .36368 m
.41809 .36542 L
s
0 1 .4 r
.42183 .39834 m
.41629 .40081 L
s
1 0 0 r
.55929 .58612 m
.55448 .57302 L
s
0 1 .4 r
.40346 .46982 m
.40474 .47075 L
s
.57138 .59733 m
.55416 .60225 L
s
.89716 .78284 m
.89056 .7755 L
s
.40382 .63525 m
.40531 .64344 L
s
.64674 .70667 m
.65987 .68439 L
s
.66061 .70556 m
.64674 .70667 L
s
.40158 .61463 m
.40599 .62789 L
s
.38539 .61143 m
.40158 .61463 L
s
.28439 .80516 m
.30134 .82766 L
s
1 0 0 r
.41443 .42722 m
.40195 .43045 L
s
.32893 .7025 m
.34387 .71403 L
s
.60944 .60308 m
.59285 .59293 L
s
0 1 .4 r
.57333 .58722 m
.56303 .59749 L
s
.57983 .59886 m
.57333 .58722 L
s
.49541 .56195 m
.48927 .56512 L
s
.49921 .5674 m
.49541 .56195 L
s
.56303 .59749 m
.55646 .57116 L
s
.32879 .69755 m
.34205 .71621 L
s
.33325 .68878 m
.32879 .69755 L
s
1 0 0 r
.36844 .41465 m
.35197 .4174 L
s
.38666 .40253 m
.36844 .41465 L
s
.3498 .27032 m
.31632 .28101 L
s
.39244 .60244 m
.40167 .62153 L
s
.4046 .63773 m
.39888 .64261 L
s
0 1 .4 r
.36208 .41561 m
.3465 .42498 L
s
.38938 .4063 m
.36208 .41561 L
s
1 0 0 r
.86358 .74457 m
.84394 .74738 L
s
0 1 .4 r
.3976 .43473 m
.39452 .44658 L
s
1 0 0 r
.39496 .47308 m
.38595 .46942 L
s
.65382 .70064 m
.65728 .68367 L
s
.42009 .5481 m
.41703 .54681 L
s
.40167 .62153 m
.40054 .6305 L
s
.62895 .61425 m
.60944 .60308 L
s
0 1 .4 r
.60998 .60301 m
.58965 .58955 L
s
.63177 .62485 m
.60998 .60301 L
s
1 0 0 r
.33304 .68758 m
.32893 .7025 L
s
0 1 .4 r
.41859 .54321 m
.41964 .54524 L
s
1 0 0 r
.31417 .88222 m
.34923 .89453 L
s
0 1 .4 r
.29221 .8251 m
.30458 .85667 L
s
1 0 0 r
.43792 .5609 m
.42009 .5481 L
s
0 1 .4 r
.38061 .50686 m
.37546 .51112 L
s
.3887 .49894 m
.38061 .50686 L
s
.58102 .61553 m
.57983 .59886 L
s
.40599 .62789 m
.40382 .63525 L
s
1 0 0 r
.2877 .80442 m
.30181 .82926 L
s
.46919 .55998 m
.45958 .55462 L
s
.48425 .56101 m
.46919 .55998 L
s
.50134 .56667 m
.49494 .56257 L
s
.5084 .57979 m
.50134 .56667 L
s
.29464 .8243 m
.31319 .8515 L
s
.41705 .40407 m
.41073 .39666 L
s
0 1 .4 r
.37066 .47889 m
.36909 .47199 L
s
.40474 .47075 m
.37066 .47889 L
s
1 0 0 r
.83203 .78448 m
.80007 .78213 L
s
.63548 .60977 m
.62921 .6037 L
s
0 1 .4 r
.39848 .39771 m
.38938 .4063 L
s
.41198 .39556 m
.39848 .39771 L
s
.45794 .54465 m
.44631 .54352 L
s
.45788 .55921 m
.45794 .54465 L
s
1 0 0 r
.40054 .6305 m
.4046 .63773 L
s
.3807 .38286 m
.35509 .39075 L
s
.45455 .55053 m
.44253 .55096 L
s
.45958 .55462 m
.45455 .55053 L
s
.38595 .46942 m
.36951 .4722 L
s
.37996 .49722 m
.38038 .50609 L
s
0 1 .4 r
.38599 .37702 m
.35762 .39005 L
s
.37546 .51112 m
.36749 .53004 L
s
1 0 0 r
.56964 .58958 m
.55929 .58612 L
s
.58314 .60204 m
.56964 .58958 L
s
0 1 .4 r
.31671 .68513 m
.33325 .68878 L
s
1 0 0 r
.6592 .7002 m
.65382 .70064 L
s
.34991 .53317 m
.33765 .54322 L
s
.36621 .52599 m
.34991 .53317 L
s
.40195 .43045 m
.39201 .44064 L
s
0 1 .4 r
.36749 .53004 m
.35229 .53379 L
s
.43366 .56343 m
.41859 .54321 L
s
1 0 0 r
.49494 .56257 m
.48425 .56101 L
s
0 1 .4 r
.47537 .56238 m
.45788 .55921 L
s
.80162 .78344 m
.77762 .7914 L
s
.83248 .7897 m
.80162 .78344 L
s
.29833 .70909 m
.29925 .72473 L
s
1 0 0 r
.37407 .51356 m
.36621 .52599 L
s
.38038 .50609 m
.37407 .51356 L
s
0 1 .4 r
.77762 .7914 m
.76266 .78012 L
s
.29746 .63529 m
.30193 .64961 L
s
.30247 .61912 m
.29746 .63529 L
s
1 0 0 r
.44008 .5546 m
.43792 .5609 L
s
.44253 .55096 m
.44008 .5546 L
s
.29347 .70946 m
.29877 .7268 L
s
.41073 .39666 m
.3995 .39906 L
s
0 1 .4 r
.30193 .64961 m
.3126 .6678 L
s
.41629 .40081 m
.41198 .39556 L
s
.57911 .6169 m
.57138 .59733 L
s
1 0 0 r
.3995 .39906 m
.38666 .40253 L
s
.58512 .61198 m
.58314 .60204 L
s
0 1 .4 r
.80262 .73468 m
.78925 .73023 L
s
1 0 0 r
.80492 .73303 m
.79341 .73007 L
s
0 1 .4 r
.48927 .56512 m
.47537 .56238 L
s
.59594 .61981 m
.58102 .61553 L
s
.51041 .58975 m
.49921 .5674 L
s
1 0 0 r
.51709 .57434 m
.5084 .57979 L
s
.57603 .6126 m
.56876 .60352 L
s
0 1 .4 r
.35229 .53379 m
.33691 .54744 L
s
.84072 .74521 m
.82705 .75621 L
s
.6428 .61913 m
.63434 .6032 L
s
.33691 .54744 m
.32186 .5512 L
s
1 0 0 r
.65365 .6502 m
.64727 .63139 L
s
.65859 .65668 m
.65365 .6502 L
s
.30295 .61306 m
.3015 .63363 L
s
.31102 .59789 m
.30295 .61306 L
s
.30335 .6527 m
.3164 .67234 L
s
.3015 .63363 m
.30335 .6527 L
s
.32308 .68115 m
.33304 .68758 L
s
.3164 .67234 m
.32308 .68115 L
s
0 1 .4 r
.3214 .27709 m
.28564 .2894 L
s
.50885 .58081 m
.51041 .58975 L
s
1 0 0 r
.36951 .4722 m
.35588 .48605 L
s
0 1 .4 r
.31842 .60365 m
.30247 .61912 L
s
.32123 .57951 m
.31842 .60365 L
s
1 0 0 r
.87405 .78334 m
.84046 .78447 L
s
0 1 .4 r
.65387 .65291 m
.65238 .63215 L
s
.66678 .65725 m
.65387 .65291 L
s
.44631 .54352 m
.43564 .55791 L
s
.5195 .58253 m
.50885 .58081 L
s
.3126 .6678 m
.31671 .68513 L
s
1 0 0 r
.80007 .78213 m
.78224 .78845 L
s
0 1 .4 r
.88448 .78096 m
.83646 .77746 L
s
1 0 0 r
.31632 .28101 m
.28179 .29521 L
s
.33765 .54322 m
.32745 .55606 L
s
0 1 .4 r
.64975 .64371 m
.6428 .61913 L
s
1 0 0 r
.59535 .61473 m
.58512 .61198 L
s
0 1 .4 r
.43564 .55791 m
.43366 .56343 L
s
.76266 .78012 m
.74351 .77682 L
s
.67802 .67908 m
.67042 .66347 L
s
.69648 .68033 m
.67802 .67908 L
s
1 0 0 r
.643 .6245 m
.63548 .60977 L
s
0 1 .4 r
.27454 .69784 m
.29833 .70909 L
s
.39452 .44658 m
.38228 .44426 L
s
1 0 0 r
.64334 .63687 m
.643 .6245 L
s
.52071 .57722 m
.51709 .57434 L
s
.35509 .39075 m
.33096 .40573 L
s
.79341 .73007 m
.79021 .72781 L
s
.66893 .66522 m
.65859 .65668 L
s
.68177 .67896 m
.66893 .66522 L
s
.28136 .6989 m
.29347 .70946 L
s
.88911 .83088 m
.87798 .84321 L
s
.32152 .57999 m
.31102 .59789 L
s
0 1 .4 r
.78925 .73023 m
.78984 .73017 L
s
1 0 0 r
.39201 .44064 m
.37755 .44538 L
s
.76272 .78536 m
.74451 .78186 L
s
.78224 .78845 m
.76272 .78536 L
s
0 1 .4 r
.68019 .71024 m
.66061 .70556 L
s
.67981 .72601 m
.68019 .71024 L
s
.36909 .47199 m
.35319 .49483 L
s
1 0 0 r
.67663 .71502 m
.6592 .7002 L
s
0 1 .4 r
.32186 .5512 m
.31371 .57941 L
s
.67042 .66347 m
.66678 .65725 L
s
1 0 0 r
.84394 .74738 m
.8296 .75543 L
s
.32745 .55606 m
.32017 .57349 L
s
.35197 .4174 m
.33744 .42396 L
s
.88681 .77328 m
.87139 .77185 L
s
0 1 .4 r
.58849 .62017 m
.57911 .6169 L
s
.59682 .63239 m
.58849 .62017 L
s
.3465 .42498 m
.3324 .41961 L
s
.71328 .70127 m
.70157 .69693 L
s
.72233 .70933 m
.71328 .70127 L
s
.88996 .83271 m
.88002 .84138 L
s
1 0 0 r
.35588 .48605 m
.34691 .49143 L
s
.58121 .62174 m
.57603 .6126 L
s
.32017 .57349 m
.32152 .57999 L
s
.68986 .68333 m
.68177 .67896 L
s
.59642 .63656 m
.58121 .62174 L
s
.27314 .78121 m
.2877 .80442 L
s
0 1 .4 r
.70157 .69693 m
.69648 .68033 L
s
1 0 0 r
.28179 .29521 m
.24 .32768 L
s
0 1 .4 r
.35319 .49483 m
.34341 .49737 L
s
.28564 .2894 m
.23904 .32232 L
s
1 0 0 r
.52748 .58517 m
.52071 .57722 L
s
.60541 .63286 m
.59535 .61473 L
s
0 1 .4 r
.60236 .62876 m
.59594 .61981 L
s
1 0 0 r
.28013 .86432 m
.31417 .88222 L
s
.70195 .69118 m
.68986 .68333 L
s
0 1 .4 r
.34055 .45682 m
.33823 .45393 L
s
.37616 .45085 m
.34055 .45682 L
s
.89056 .7755 m
.87057 .76726 L
s
.31371 .57941 m
.32123 .57951 L
s
1 0 0 r
.37755 .44538 m
.36656 .44456 L
s
.68139 .72766 m
.67663 .71502 L
s
0 1 .4 r
.52871 .58409 m
.5195 .58253 L
s
1 0 0 r
.26311 .67698 m
.28136 .6989 L
s
0 1 .4 r
.74141 .77525 m
.71585 .75865 L
s
.74351 .77682 m
.74141 .77525 L
s
1 0 0 r
.33096 .40573 m
.32181 .42555 L
s
0 1 .4 r
.26996 .78115 m
.28439 .80516 L
s
.34341 .49737 m
.31317 .50221 L
s
1 0 0 r
.53101 .6053 m
.52748 .58517 L
s
.53971 .61985 m
.53101 .6053 L
s
0 1 .4 r
.35762 .39005 m
.3325 .39817 L
s
1 0 0 r
.70508 .73558 m
.68139 .72766 L
s
0 1 .4 r
.53103 .60772 m
.52871 .58409 L
s
.5426 .6214 m
.53103 .60772 L
s
1 0 0 r
.33744 .42396 m
.32693 .44022 L
s
.27618 .80435 m
.29464 .8243 L
s
.71714 .69726 m
.70195 .69118 L
s
0 1 .4 r
.27994 .8035 m
.29221 .8251 L
s
1 0 0 r
.72505 .70826 m
.71714 .69726 L
s
0 1 .4 r
.264 .67659 m
.27454 .69784 L
s
.78984 .73017 m
.78473 .73348 L
s
.38228 .44426 m
.37616 .45085 L
s
.31317 .50221 m
.31165 .52325 L
s
.3324 .41961 m
.32028 .43595 L
s
.83646 .77746 m
.81942 .78249 L
s
1 0 0 r
.31604 .50032 m
.30784 .51815 L
s
.34691 .49143 m
.31604 .50032 L
s
0 1 .4 r
.28095 .86392 m
.30505 .88272 L
s
.13198 .91467 m
.18995 .97893 L
s
1 0 0 r
.73085 .77046 m
.7155 .76071 L
s
.74451 .78186 m
.73085 .77046 L
s
.25709 .74454 m
.27314 .78121 L
s
.36656 .44456 m
.34572 .45618 L
s
0 1 .4 r
.3325 .39817 m
.32484 .42495 L
s
1 0 0 r
.79021 .72781 m
.77976 .72677 L
s
0 1 .4 r
.704 .73825 m
.67981 .72601 L
s
1 0 0 r
.73989 .72899 m
.72505 .70826 L
s
0 1 .4 r
.78473 .73348 m
.75284 .72087 L
s
.73556 .72566 m
.72233 .70933 L
s
.75284 .72087 m
.73556 .72566 L
s
1 0 0 r
.77976 .72677 m
.75513 .73013 L
s
.75513 .73013 m
.73989 .72899 L
s
0 1 .4 r
.26548 .65665 m
.264 .67659 L
s
1 0 0 r
.13779 .91821 m
.18765 .97153 L
s
.84046 .78447 m
.82187 .77922 L
s
0 1 .4 r
.32028 .43595 m
.31238 .45192 L
s
1 0 0 r
.32181 .42555 m
.3019 .43911 L
s
.7155 .76071 m
.70508 .73558 L
s
.34572 .45618 m
.33241 .46039 L
s
0 1 .4 r
.27335 .56494 m
.26875 .57971 L
s
.29372 .55142 m
.27335 .56494 L
s
.61753 .65287 m
.60236 .62876 L
s
1 0 0 r
.8296 .75543 m
.81254 .7576 L
s
0 1 .4 r
.82705 .75621 m
.8189 .76158 L
s
1 0 0 r
.60362 .65562 m
.59642 .63656 L
s
.6541 .65048 m
.64334 .63687 L
s
.5459 .638 m
.53971 .61985 L
s
0 1 .4 r
.32484 .42495 m
.31457 .44099 L
s
.25891 .75028 m
.26996 .78115 L
s
1 0 0 r
.26091 .65198 m
.26311 .67698 L
s
0 1 .4 r
.31165 .52325 m
.29372 .55142 L
s
1 0 0 r
.27924 .5659 m
.26972 .58143 L
s
.29255 .5484 m
.27924 .5659 L
s
0 1 .4 r
.54882 .63477 m
.5426 .6214 L
s
1 0 0 r
.2606 .84042 m
.28013 .86432 L
s
.61714 .65118 m
.60541 .63286 L
s
.32693 .44022 m
.31607 .45985 L
s
0 1 .4 r
.65312 .6485 m
.64975 .64371 L
s
.66673 .67422 m
.65312 .6485 L
s
1 0 0 r
.6667 .66369 m
.6541 .65048 L
s
0 1 .4 r
.251 .77866 m
.27994 .8035 L
s
1 0 0 r
.30784 .51815 m
.29255 .5484 L
s
0 1 .4 r
.71585 .75865 m
.704 .73825 L
s
1 0 0 r
.25101 .77742 m
.27618 .80435 L
s
0 1 .4 r
.8189 .76158 m
.7948 .75014 L
s
.87057 .76726 m
.84307 .78028 L
s
1 0 0 r
.26248 .63083 m
.26091 .65198 L
s
0 1 .4 r
.26675 .83833 m
.28095 .86392 L
s
.26875 .57971 m
.26293 .60566 L
s
.33823 .45393 m
.32079 .4715 L
s
1 0 0 r
.33241 .46039 m
.31503 .47475 L
s
.87139 .77185 m
.84817 .78089 L
s
0 1 .4 r
.60232 .64515 m
.59682 .63239 L
s
1 0 0 r
.87798 .84321 m
.8563 .84092 L
s
.81254 .7576 m
.79555 .7491 L
s
0 1 .4 r
.88002 .84138 m
.85579 .84301 L
s
.66148 .66504 m
.66673 .67422 L
s
1 0 0 r
.26188 .60931 m
.26248 .63083 L
s
.26972 .58143 m
.26188 .60931 L
s
0 1 .4 r
.25239 .62425 m
.26548 .65665 L
s
1 0 0 r
.82187 .77922 m
.79801 .77121 L
s
0 1 .4 r
.26293 .60566 m
.25239 .62425 L
s
1 0 0 r
.24185 .72847 m
.25709 .74454 L
s
0 1 .4 r
.6292 .64992 m
.61753 .65287 L
s
1 0 0 r
.63306 .65182 m
.61714 .65118 L
s
0 1 .4 r
.81942 .78249 m
.80257 .77229 L
s
1 0 0 r
.66697 .66556 m
.6667 .66369 L
s
0 1 .4 r
.32079 .4715 m
.29207 .47771 L
s
.27724 .50819 m
.26086 .52805 L
s
.29122 .49261 m
.27724 .50819 L
s
1 0 0 r
.31503 .47475 m
.29222 .48531 L
s
0 1 .4 r
.23966 .73 m
.25891 .75028 L
s
1 0 0 r
.64554 .65526 m
.63306 .65182 L
s
0 1 .4 r
.55737 .65319 m
.54882 .63477 L
s
.28641 .45224 m
.25925 .47087 L
s
.31457 .44099 m
.28641 .45224 L
s
.23864 .74142 m
.251 .77866 L
s
1 0 0 r
.55949 .65195 m
.5459 .638 L
s
.62017 .66599 m
.60362 .65562 L
s
.31607 .45985 m
.3002 .47546 L
s
0 1 .4 r
.61088 .66066 m
.60232 .64515 L
s
.29575 .4746 m
.29122 .49261 L
s
.31238 .45192 m
.29575 .4746 L
s
1 0 0 r
.3019 .43911 m
.28513 .44941 L
s
.23914 .74253 m
.25101 .77742 L
s
.23675 .70979 m
.23914 .74253 L
s
.24 .32768 m
.19854 .35777 L
s
.77955 .74768 m
.75604 .74259 L
s
.79555 .7491 m
.77955 .74768 L
s
.28513 .44941 m
.25853 .47277 L
s
0 1 .4 r
.23577 .70981 m
.23864 .74142 L
s
.85579 .84301 m
.82362 .84637 L
s
.75571 .74773 m
.73361 .74088 L
s
.77165 .7573 m
.75571 .74773 L
s
.29207 .47771 m
.27485 .49449 L
s
.7948 .75014 m
.77165 .7573 L
s
.23904 .32232 m
.19466 .36772 L
s
1 0 0 r
.6686 .69288 m
.66697 .66556 L
s
.69239 .70598 m
.6686 .69288 L
s
.27617 .50243 m
.26093 .52981 L
s
.28264 .48996 m
.27617 .50243 L
s
0 1 .4 r
.23445 .55861 m
.2221 .60003 L
s
.26086 .52805 m
.23445 .55861 L
s
.71963 .71334 m
.69948 .70685 L
s
.73361 .74088 m
.71963 .71334 L
s
.84307 .78028 m
.82338 .76844 L
s
1 0 0 r
.3002 .47546 m
.28264 .48996 L
s
0 1 .4 r
.25925 .47087 m
.24091 .4886 L
s
.69948 .70685 m
.66339 .69951 L
s
.57306 .66119 m
.55737 .65319 L
s
.65007 .65781 m
.6292 .64992 L
s
1 0 0 r
.75604 .74259 m
.73342 .73372 L
s
0 1 .4 r
.21686 .68375 m
.23966 .73 L
s
1 0 0 r
.64567 .67588 m
.64554 .65526 L
s
.24707 .7975 m
.2606 .84042 L
s
0 1 .4 r
.24356 .79979 m
.26675 .83833 L
s
1 0 0 r
.79801 .77121 m
.77447 .76308 L
s
.71874 .71693 m
.69239 .70598 L
s
.73342 .73372 m
.71874 .71693 L
s
.29222 .48531 m
.26962 .50136 L
s
.22346 .67791 m
.23675 .70979 L
s
.2181 .68978 m
.24185 .72847 L
s
0 1 .4 r
.66339 .69951 m
.66148 .66504 L
s
1 0 0 r
.56352 .66485 m
.55949 .65195 L
s
0 1 .4 r
.21852 .65362 m
.21686 .68375 L
s
1 0 0 r
.8563 .84092 m
.8304 .8427 L
s
.19854 .35777 m
.16337 .39881 L
s
.63477 .69131 m
.62017 .66599 L
s
.26093 .52981 m
.23594 .56128 L
s
.84817 .78089 m
.81918 .77288 L
s
0 1 .4 r
.80257 .77229 m
.77654 .75586 L
s
.22943 .68799 m
.23577 .70981 L
s
1 0 0 r
.25853 .47277 m
.24383 .49291 L
s
0 1 .4 r
.19466 .36772 m
.16218 .40102 L
s
1 0 0 r
.22013 .65002 m
.2181 .68978 L
s
0 1 .4 r
.64432 .67577 m
.65007 .65781 L
s
1 0 0 r
.77447 .76308 m
.75347 .75346 L
s
.23594 .56128 m
.23716 .59625 L
s
.1083 .85182 m
.13779 .91821 L
s
0 1 .4 r
.63665 .68078 m
.61088 .66066 L
s
.77654 .75586 m
.74754 .75487 L
s
.10833 .85206 m
.13198 .91467 L
s
1 0 0 r
.22223 .60147 m
.22013 .65002 L
s
0 1 .4 r
.67082 .68596 m
.64432 .67577 L
s
.69278 .71898 m
.67082 .68596 L
s
.22541 .61235 m
.21852 .65362 L
s
1 0 0 r
.22387 .63682 m
.22346 .67791 L
s
.23716 .59625 m
.22387 .63682 L
s
.23298 .76383 m
.24707 .7975 L
s
.66291 .69248 m
.64567 .67588 L
s
0 1 .4 r
.23543 .51479 m
.23171 .56097 L
s
.27485 .49449 m
.23543 .51479 L
s
.22883 .52536 m
.22173 .5364 L
s
.24091 .4886 m
.22883 .52536 L
s
.22529 .63971 m
.22943 .68799 L
s
.2221 .60003 m
.22529 .63971 L
s
1 0 0 r
.26962 .50136 m
.24484 .5199 L
s
.24383 .49291 m
.22727 .52595 L
s
.75347 .75346 m
.73432 .74678 L
s
0 1 .4 r
.22819 .76245 m
.24356 .79979 L
s
.6455 .70576 m
.63665 .68078 L
s
1 0 0 r
.23832 .56027 m
.22223 .60147 L
s
.24484 .5199 m
.23832 .56027 L
s
0 1 .4 r
.22173 .5364 m
.20128 .5972 L
s
1 0 0 r
.65108 .70464 m
.63477 .69131 L
s
.68808 .71621 m
.66291 .69248 L
s
.57974 .67439 m
.56352 .66485 L
s
.81918 .77288 m
.78232 .77273 L
s
0 1 .4 r
.23171 .56097 m
.22541 .61235 L
s
.74754 .75487 m
.73354 .75115 L
s
.58504 .67102 m
.57306 .66119 L
s
.82338 .76844 m
.77984 .76597 L
s
.16218 .40102 m
.13386 .44779 L
s
1 0 0 r
.22727 .52595 m
.22487 .54555 L
s
.21923 .71894 m
.23298 .76383 L
s
0 1 .4 r
.21275 .68519 m
.22938 .71709 L
s
.20281 .64763 m
.21275 .68519 L
s
1 0 0 r
.6701 .71524 m
.65108 .70464 L
s
.22487 .54555 m
.20638 .59973 L
s
.16337 .39881 m
.12481 .44933 L
s
.20638 .59973 m
.20672 .64132 L
s
0 1 .4 r
.66815 .71995 m
.6455 .70576 L
s
.82362 .84637 m
.80141 .8417 L
s
.22938 .71709 m
.22819 .76245 L
s
.13386 .44779 m
.08329 .50536 L
s
1 0 0 r
.69979 .73201 m
.6701 .71524 L
s
.70956 .73135 m
.68808 .71621 L
s
.60017 .68686 m
.57974 .67439 L
s
.73432 .74678 m
.70956 .73135 L
s
.8304 .8427 m
.80297 .84119 L
s
0 1 .4 r
.75718 .76063 m
.72663 .741 L
s
.77984 .76597 m
.75718 .76063 L
s
.70792 .73185 m
.69278 .71898 L
s
.73354 .75115 m
.70792 .73185 L
s
.70531 .73182 m
.66815 .71995 L
s
1 0 0 r
.72963 .74078 m
.69979 .73201 L
s
0 1 .4 r
.60189 .68491 m
.58504 .67102 L
s
1 0 0 r
.2138 .68202 m
.21923 .71894 L
s
0 1 .4 r
.20128 .5972 m
.20281 .64763 L
s
1 0 0 r
.75825 .75824 m
.72963 .74078 L
s
.78232 .77273 m
.75825 .75824 L
s
.20672 .64132 m
.2138 .68202 L
s
0 1 .4 r
.72663 .741 m
.70531 .73182 L
s
1 0 0 r
.61766 .70474 m
.60017 .68686 L
s
0 1 .4 r
.61353 .70074 m
.60189 .68491 L
s
1 0 0 r
.08091 .76796 m
.1083 .85182 L
s
.12481 .44933 m
.09453 .51117 L
s
0 1 .4 r
.08286 .77297 m
.10833 .85206 L
s
1 0 0 r
.80297 .84119 m
.77744 .83299 L
s
0 1 .4 r
.80141 .8417 m
.77727 .82899 L
s
1 0 0 r
.62935 .71848 m
.61766 .70474 L
s
.09453 .51117 m
.07195 .58805 L
s
0 1 .4 r
.63297 .7156 m
.61353 .70074 L
s
1 0 0 r
.0673 .67807 m
.08091 .76796 L
s
0 1 .4 r
.07417 .68132 m
.08286 .77297 L
s
.08329 .50536 m
.07318 .60079 L
s
1 0 0 r
.07195 .58805 m
.0673 .67807 L
s
0 1 .4 r
.07318 .60079 m
.07417 .68132 L
s
1 0 0 r
.64642 .75646 m
.62935 .71848 L
s
.77744 .83299 m
.74154 .82655 L
s
0 1 .4 r
.64449 .7555 m
.63297 .7156 L
s
.77727 .82899 m
.74642 .82226 L
s
1 0 0 r
.74154 .82655 m
.70543 .80616 L
s
0 1 .4 r
.74642 .82226 m
.70058 .80983 L
s
1 0 0 r
.68095 .77601 m
.64642 .75646 L
s
0 1 .4 r
.67673 .76998 m
.64449 .7555 L
s
.70058 .80983 m
.67673 .76998 L
s
1 0 0 r
.70543 .80616 m
.68095 .77601 L
s
0 g
.25 Mabswid
.50163 0 m
.97081 .24778 L
s
.97081 .24778 m
1 1.05877 L
s
1 1.05877 m
.49999 1.00149 L
s
.49999 1.00149 m
.50163 0 L
s
.03453 .16052 m
0 1.0388 L
s
0 1.0388 m
.49999 1.00149 L
s
.49999 1.00149 m
.50163 0 L
s
.50163 0 m
.03453 .16052 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{355, 384.375},
  ImageMargins->{{7, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005S0001P2000`400?l00000o`00003o/?ooool3
o`000;3ooooo002]ooooo`?o000000?oooooo`000?ooool00_l0002^ooooo`00Z_ooool3o`0000Co
oooo00Co0000oooooooooooooooo0_l0002/ooooo`00Yoooool3o`0000Oooooo00?o0000oooooooo
ool00oooool2o`000:[ooooo002Tooooo`?o00002_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0:Oooooo002Qooooo`?o00003Oooool00ol0003oooooooooo`06ooooo`;o0000Yooo
ool009kooooo0ol0000@ooooo`03o`000?oooooooooo00Sooooo0_l0002Uooooo`00Voooool3o`00
01?ooooo00?o0000ooooooooool02_ooool2o`000:?ooooo002Hooooo`?o00005_ooool00ol0003o
ooooooooo`0<ooooo`;o0000XOooool009Gooooo0ol0000Iooooo`03o`000?oooooooooo00kooooo
0_l0002Oooooo`00Toooool2o`0001cooooo00?o0000ooooooooool04?ooool2o`0009gooooo002@
ooooo`?o00007_ooool00ol0003oooooooooo`0Booooo`;o0000Voooool008gooooo0ol0000Qoooo
o`03o`000?oooooooooo01Cooooo0_l0002Iooooo`00R_ooool3o`0002Cooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`2Fooooo`00Qoooool3o`0002Oooooo00?o0000ooooooooool0
5oooool2o`0009Kooooo0024ooooo`?o0000:_ooool00ol0003oooooooooo`0Iooooo`;o0000U?oo
ool0087ooooo0ol0000]ooooo`03o`000?oooooooooo01_ooooo0_l0002Booooo`00O_ooool3o`00
033ooooo00?o0000ooooooooool07Oooool2o`00093ooooo001kooooo`?o0000<oooool00ol0003o
ooooooooo`0Oooooo`;o0000S_ooool007Wooooo0_l0000fooooo`03o`000?oooooooooo027ooooo
0_l0002<ooooo`00M_ooool3o`0003Sooooo00?o0000ooooooooool08oooool2o`0008[ooooo001c
ooooo`?o0000>oooool00ol0003oooooooooo`0Uooooo`;o0000R?ooool0073ooooo0ol0000noooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0QOooool006gooooo0ol00011ooooo`03
o`000?oooooooooo02Sooooo0_l00025ooooo`00J_ooool3o`0004Cooooo00?o0000ooooooooool0
:_ooool2o`0008?ooooo001Wooooo`?o0000Aoooool00ol0003oooooooooo`0/ooooo`;o0000POoo
ool006Cooooo0ol0001:ooooo`03o`000?oooooooooo02kooooo0_l0001oooooo`00HOooool3o`00
04gooooo00?o0000ooooooooool0<?ooool2o`0007gooooo001Nooooo`?o0000D?ooool00ol0003o
ooooooooo`0booooo`;o0000Noooool005cooooo0_l0001Cooooo`03o`000?oooooooooo03Cooooo
0_l0001iooooo`00FOooool3o`0005Gooooo00?o0000ooooooooool0=_ooool2o`0007Oooooo001F
ooooo`?o0000F?ooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo07Cooooo001Coooo
o`?o0000Foooool00ol0003oooooooooo`0iooooo`;o0000M?ooool0053ooooo0ol0001Nooooo`03
o`000?oooooooooo03_ooooo0_l0001booooo`00COooool3o`00067ooooo00?o0000ooooooooool0
?Oooool2o`00073ooooo001:ooooo`?o0000I?ooool00ol0003oooooooooo`0oooooo`;o0000K_oo
ool004Oooooo0ol0001Wooooo`03o`000?oooooooooo047ooooo0_l0001/ooooo`00A?ooool3o`00
06[ooooo00?o0000ooooooooool0@oooool2o`0006[ooooo0012ooooo`;o0000KOooool00ol0003o
ooooooooo`15ooooo`;o0000J?ooool003oooooo0ol0001_ooooo`03o`000?oooooooooo04Oooooo
0_l0001Vooooo`00??ooool3o`0007;ooooo00?o0000ooooooooool0BOooool00ol0003ooooooooo
o`1Sooooo`00>Oooool3o`0007Gooooo00?o0000ooooooooool0B_ooool2o`0006?ooooo000foooo
o`?o0000N?ooool00ol0003oooooooooo`1<ooooo`;o0000HOooool003?ooooo0ol0001kooooo`03
o`000?oooooooooo04kooooo0_l0001Oooooo`00<?ooool3o`0007kooooo00?o0000ooooooooool0
D?ooool2o`0005gooooo000]ooooo`?o0000POooool00ol0003oooooooooo`1Booooo`;o0000Fooo
ool002[ooooo0ol00024ooooo`03o`000?oooooooooo05Cooooo0_l0001Iooooo`009oooool3o`00
08Oooooo00?o0000ooooooooool0E_ooool2o`0005Oooooo000Uooooo`;o0000R_ooool00ol0003o
ooooooooo`1Hooooo`03o`000?oooooooooo05Cooooo000Rooooo`?o0000S?ooool00ol0003ooooo
ooooo`1Iooooo`;o0000E?ooool001oooooo0ol0002?ooooo`03o`000?oooooooooo05_ooooo0_l0
001Booooo`007?ooool3o`0009;ooooo00?o0000ooooooooool0GOooool2o`00053ooooo000Ioooo
o`?o0000UOooool00ol0003oooooooooo`1Oooooo`;o0000C_ooool001Kooooo0ol0002Hooooo`03
o`000?oooooooooo067ooooo0_l0001<ooooo`004oooool3o`0009_ooooo00?o0000ooooooooool0
Hoooool2o`0004[ooooo000@ooooo`?o0000W_ooool00ol0003oooooooooo`1Uooooo`;o0000B?oo
ool000gooooo0ol0002Qooooo`03o`000?oooooooooo06Oooooo0_l00016ooooo`003?ooool2o`00
0:?ooooo00?o0000ooooooooool0JOooool00ol0003oooooooooo`13ooooo`003?ooool00ol0003o
ooooo`000002o`000:3ooooo00?o0000ooooooooool0J_ooool2o`0004?ooooo000<ooooo`03o`00
0?oooooooooo00;ooooo0_l0002Nooooo`03o`000?oooooooooo06cooooo0_l00011ooooo`003?oo
ool00ol0003oooooooooo`04ooooo`?o0000Voooool00ol0003oooooooooo`1^ooooo`;o0000?ooo
ool000cooooo00?o0000ooooooooool01oooool3o`0009Sooooo00?o0000ooooooooool0L?ooool2
o`0003gooooo000<ooooo`03o`000?oooooooooo00[ooooo0_l0002Fooooo`03o`000?oooooooooo
07;ooooo0_l0000kooooo`003?ooool00ol0003oooooooooo`0<ooooo`?o0000Toooool00ol0003o
ooooooooo`1dooooo`;o0000>Oooool000cooooo00?o0000ooooooooool03oooool2o`00097ooooo
00?o0000ooooooooool0M_ooool2o`0003Oooooo000<ooooo`03o`000?oooooooooo017ooooo0ol0
002>ooooo`03o`000?oooooooooo07Sooooo0_l0000eooooo`003?ooool00ol0003oooooooooo`0D
ooooo`;o0000S?ooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo03;ooooo000<oooo
o`03o`000?oooooooooo01Kooooo0ol00029ooooo`03o`000?oooooooooo07_ooooo0_l0000boooo
o`003?ooool00ol0003oooooooooo`0Iooooo`?o0000Q_ooool00ol0003oooooooooo`1mooooo`;o
0000<?ooool000cooooo00?o0000ooooooooool07?ooool2o`0008Cooooo00?o0000ooooooooool0
Ooooool2o`0002kooooo000<ooooo`03o`000?oooooooooo01kooooo0ol00021ooooo`03o`000?oo
oooooooo087ooooo0_l0000/ooooo`002oooool00ol0003oooooooooo`0Rooooo`;o0000Ooooool0
0ol0003oooooooooo`23ooooo`;o0000:_ooool000_ooooo00?o0000ooooooooool09?ooool3o`00
07cooooo00?o0000ooooooooool0QOooool2o`0002Sooooo000;ooooo`03o`000?oooooooooo02Oo
oooo0_l0001jooooo`03o`000?oooooooooo08Oooooo0_l0000Vooooo`002oooool00ol0003ooooo
ooooo`0Yooooo`?o0000Moooool00ol0003oooooooooo`29ooooo`;o00009?ooool000_ooooo00?o
0000ooooooooool0;?ooool2o`0007Gooooo00?o0000ooooooooool0Roooool00ol0003ooooooooo
o`0Qooooo`002oooool00ol0003oooooooooo`0^ooooo`?o0000L_ooool00ol0003oooooooooo`2<
ooooo`;o00008Oooool000_ooooo00?o0000ooooooooool0<Oooool3o`0006oooooo00?o0000oooo
ooooool0S_ooool2o`0001oooooo000;ooooo`03o`000?oooooooooo03Cooooo0_l0001]ooooo`03
o`000?oooooooooo093ooooo0_l0000Mooooo`002oooool00ol0003oooooooooo`0fooooo`?o0000
J_ooool00ol0003oooooooooo`2Booooo`;o00006oooool000_ooooo00?o0000ooooooooool0>Ooo
ool2o`0006Sooooo00?o0000ooooooooool0U?ooool2o`0001Wooooo000;ooooo`03o`000?oooooo
oooo03_ooooo0ol0001Uooooo`03o`000?oooooooooo01?ooooo0_l0ofH2ooooo`03o`3oI_oooooo
oooo07cooooo0_l0000Gooooo`002oooool00ol0003oooooooooo`0nooooo`;o0000COooool3o`3o
IQ?ooooo00?o0000ool00?oo00002_ooool4ool00008o`3oI_ooooooo`00ool00?l0ofKoo`00o`3o
I_ooool2o`3oIX3ooooo0_l0000Eooooo`002oooool00ol0003oooooooooo`10ooooo`?o0000Aooo
ool3o`3oIP?ooooo00?o0?mVooooooooool01oooool6o`3oIP?oo`0000Co0000o`3oI_l0ofKoo`00
0_l0ofH00oooooooo`00ool00004ool000?o0?mV00coooooo`3oI_oo003oooooool00?ooooooo`00
o`3oI_oo003o0?mVool00?l0ofJ1ooooo`;o00004oooool000_ooooo00?o0000ooooooooool0@ooo
ool3o`0004;ooooo0_l0ofH2ooooo`Woo`0000?oooooo`3oI_l0ofH00_l0ofH4ooooo`;oo`000ooo
ool01?l0003oooooooooooooool3ool000;o0?mV00Coooooo`3oI_l0ofKo0?mV1Oooool3o`3oIP03
ool00?l0ofKoo`0000Co0?mV0_oo0021ooooo`03o`000?oooooooooo013ooooo000;ooooo`03o`00
0?oooooooooo04Kooooo0_l0000oooooo`03o`3oI_oooooooooo00;oo`001_ooool3o`3oIPWoo`00
1Oooool00ol0003oooooooooo`06ooooo`03o`3oI_oooooooooo00[ooooo00?o0?mVool00?l0ofH0
0ol0ofH00ooo003oooooooooo`21ooooo`;o00004?ooool000_ooooo00?o0000ooooooooool0B?oo
ool3o`0003_ooooo00Co0?mVoooooooo003oo`006Oooool00ol0003oooooooooo`0Dooooo`05ool0
0?l0ofKoo`00o`3oI_oo00000_l0ofJ4ooooo`;o00003_ooool000_ooooo00?o0000ooooooooool0
Boooool2o`0003Sooooo0ooo000Kooooo`03o`000?oooooooooo01?ooooo00Coo`00o`3oI_oo003o
0?mV0ooo0002o`3oIP03ool00?oooooooooo08;ooooo0_l0000<ooooo`002oooool00ol0003ooooo
ooooo`1=ooooo`?o0000<oooool2ool001kooooo00?o0000ooooooooool05?ooool01?l0ofKoo`00
o`3oI_oo0002ooooo`03o`3oI_oooooooooo08Cooooo0ol0000;ooooo`002oooool00ol0003ooooo
ooooo`1@ooooo`;o0000;_ooool3ool00003o`3oI_oooooooooo01gooooo00?o0000ooooooooool0
5Oooool00ol0ofKoo`00ooooo`25ooooo`Co00000_ooool00ol0003oooooooooo`09ooooo`002ooo
ool00ol0003oooooooooo`1Booooo`?o00009_ooool5ool00003ooooool0ofKo0?mV023ooooo00?o
0000ooooooooool0VOooool4o`0000Kooooo00?o0000ooooooooool02Oooool000_ooooo00?o0000
ooooooooool0EOooool3o`0001oooooo1?oo0003ooooo`?o0?mV8_ooool00ol0003oooooooooo`2E
ooooo`Co00002_ooool00ol0003oooooooooo`09ooooo`002oooool00ol0003oooooooooo`1Hoooo
o`;o00007?ooool00ooo003oooooooooo`02ooooo`?o0?mV9Oooool00ol0003oooooooooo`2Aoooo
o`Co00003_ooool00ol0003oooooooooo`09ooooo`002oooool00ol0003oooooooooo`1Jooooo`?o
00006?ooool00ooo003oooooooooo`03o`3oIRSooooo00?o0000ooooooooool0SOooool4o`0001;o
oooo00?o0000ooooooooool02Oooool000_ooooo00?o0000ooooooooool0GOooool2o`0001?ooooo
0ooo0002ooooo`03o`3oI_oooooooooo02Wooooo00?o0000ooooooooool0ROooool4o`0001Kooooo
00?o0000ooooooooool02Oooool000_ooooo00?o0000ooooooooool0Goooool3o`0000gooooo0ooo
0002ooooo`?o0?mV;?ooool00ol0003oooooooooo`25ooooo`Co00006_ooool00ol0003ooooooooo
o`09ooooo`002oooool00ol0003oooooooooo`1Rooooo`;o00002?ooool3ool000Go0?mV;oooool0
0ol0003oooooooooo`21ooooo`Co00007_ooool00ol0003oooooooooo`09ooooo`002_ooool00ol0
003oooooooooo`1Uooooo`?o000000?oooooo`3oI_oo00000_oo0003o`3oISCooooo00?o0000oooo
ooooool0O?ooool5o`0002;ooooo00?o0000ooooooooool02Oooool000[ooooo00?o0000oooooooo
ool0Hoooool4o`3oIP?oo`00>_ooool00ol0003oooooooooo`1hooooo`Co00009oooool00ol0003o
ooooooooo`09ooooo`002_ooool00ol0003oooooooooo`1Pooooo`?o0?mV00Coooooool00?oo003o
o`000oooool3o`0003Oooooo00?o0000ooooooooool0M?ooool4o`0002_ooooo00?o0000oooooooo
ool02Oooool000[ooooo00?o0000ooooooooool0G_ooool2o`3oIP04oooooooo003oo`00ool000Wo
oooo0ol0000dooooo`03o`000?oooooooooo073ooooo1?l0000_ooooo`03o`000?oooooooooo00Wo
oooo000:ooooo`03o`000?oooooooooo05cooooo0_l0ofH3ool000oooooo0_l0000booooo`03o`00
0?oooooooooo06cooooo1?l0000cooooo`03o`000?oooooooooo00Wooooo000:ooooo`03o`000?oo
oooooooo05Wooooo0ol0ofH2ool001Cooooo0ol0000_ooooo`03o`000?oooooooooo06Sooooo1?l0
000hooooo`03o`000?oooooooooo00Sooooo000:ooooo`03o`000?oooooooooo05Oooooo0_l0ofH0
0oooooooo`00ool0000Iooooo`;o0000;Oooool00ol0003oooooooooo`1Tooooo`Co0000??ooool0
0ol0003oooooooooo`08ooooo`002_ooool00ol0003oooooooooo`1Fooooo`04o`3oI_oo003oo`00
ool001gooooo0ol0000Zooooo`03o`000?oooooooooo063ooooo1?l00010ooooo`03o`000?oooooo
oooo00Sooooo000:ooooo`03o`000?oooooooooo05Cooooo0_l0ofH00ooo003oooooooooo`0Qoooo
o`;o0000:?ooool00ol0003oooooooooo`1Looooo`Co0000A?ooool00ol0003oooooooooo`08oooo
o`002_ooool00ol0003oooooooooo`1Cooooo`03o`3oI_oo003ooooo02Kooooo0ol0000Uooooo`03
o`000?oooooooooo05Sooooo1?l00018ooooo`03o`000?oooooooooo00Sooooo000:ooooo`03o`00
0?oooooooooo057ooooo0_l0ofH00ooo003oooooooooo`0Yooooo`?o00008_ooool00ol0003ooooo
ooooo`1Dooooo`Co0000C?ooool00ol0003oooooooooo`08ooooo`002_ooool00ol0003ooooooooo
o`1?ooooo`;o0?mV0_oo000_ooooo`;o00008?ooool00ol0003oooooooooo`1@ooooo`Co0000D?oo
ool00ol0003oooooooooo`08ooooo`002_ooool00ol0003oooooooooo`1>ooooo`03o`3oI_oooooo
o`0003?ooooo0ol0000Mooooo`03o`000?oooooooooo04cooooo1?l0001Dooooo`03o`000?oooooo
oooo00Sooooo000:ooooo`03o`000?oooooooooo04cooooo0_l0ofH2ool003Oooooo0_l0000Koooo
o`03o`000?oooooooooo04Sooooo1?l0001Hooooo`03o`000?oooooooooo00Sooooo000:ooooo`03
o`000?oooooooooo04_ooooo00?o0?mVoooooooo0000>oooool3o`0001Sooooo00?o0000oooooooo
ool0A?ooool4o`0005cooooo00?o0000ooooooooool02?ooool000[ooooo00?o0000ooooooooool0
BOooool2o`3oIP03oooooooo003ooooo03kooooo0_l0000Fooooo`03o`000?oooooooooo043ooooo
1?l0001Pooooo`03o`000?oooooooooo00Sooooo000:ooooo`03o`000?oooooooooo04Sooooo00Co
0?mVoooooooo003oo`00@_ooool3o`0001?ooooo00?o0000ooooooooool0??ooool4o`0006Cooooo
00?o0000ooooooooool02?ooool000[ooooo00?o0000ooooooooool0Aoooool00ol0ofKoooooool0
0017ooooo`?o00004?ooool00ol0003oooooooooo`0hooooo`Co0000J?ooool00ol0003ooooooooo
o`08ooooo`002_ooool00ol0003oooooooooo`16ooooo`03o`3oI_ooooooo`0004_ooooo0_l0000>
ooooo`03o`000?oooooooooo03Cooooo1?l0001/ooooo`03o`000?oooooooooo00Sooooo000:oooo
o`03o`000?oooooooooo04Gooooo00?o0?mVool00?oo0000C_ooool3o`0000_ooooo00?o0000oooo
ooooool0;oooool5o`00073ooooo00?o0000ooooooooool02?ooool000[ooooo00?o0000oooooooo
ool0A?ooool00ol0ofKoo`00ooooo`1Booooo`;o00002Oooool00ol0003oooooooooo`0[ooooo`Co
0000MOooool00ol0003oooooooooo`08ooooo`002_ooool00ol0003oooooooooo`13ooooo`03o`3o
I_oo003ooooo05Gooooo0ol00006ooooo`03o`000?oooooooooo02Oooooo1?l0001iooooo`03o`00
0?oooooooooo00Sooooo000:ooooo`03o`000?oooooooooo04;ooooo00?o0?mVool00?ooool0FOoo
ool2o`0000Cooooo00?o0000ooooooooool08oooool4o`0007gooooo00?o0000ooooooooool02?oo
ool000[ooooo00?o0000ooooooooool0@Oooool00ol0ofKoo`00ooooo`1Looooo`?o000000?ooooo
o`000?ooool08?ooool4o`00087ooooo00?o0000ooooooooool02?ooool000[ooooo00?o0000oooo
ooooool0@?ooool00ol0ofKoooooooooo`1Pooooo`;o00007Oooool4o`0008Gooooo00?o0000oooo
ooooool02?ooool000[ooooo00?o0000ooooooooool0?oooool00ol0ofKoooooooooo`1Rooooo`Co
00005_ooool4o`0008Wooooo00?o0000ooooooooool02?ooool000Wooooo00?o0000ooooooooool0
?_ooool00ooo003o0?mVooooo`1Rooooo`;o0?mV00Co0000oooooooooooooooo0ol0000?ooooo`Co
0000SOooool00ol0003oooooooooo`08ooooo`002Oooool00ol0003oooooooooo`0mooooo`03ool0
0?l0ofKooooo063ooooo0ol0ofH00ooooooo0?mVo`000006ooooo`;o00002Oooool4o`00097ooooo
00?o0000ooooooooool02?ooool000Wooooo00?o0000ooooooooool0??ooool00ooo003o0?mVoooo
o`1Looooo`;oo`000ol0ofH00ooo003oooooooooo`02ooooo`03o`000?oooooooooo00Kooooo0ol0
0002ooooo`Co0000UOooool00ol0003oooooooooo`08ooooo`002Oooool00ol0003oooooooooo`0k
ooooo`03ool00?l0ofKooooo05cooooo00?oo`00o`3oI_l0ofH01?ooool4ool00003o`000?oooooo
oooo00Wooooo0_l0002Iooooo`03o`000?oooooooooo00Sooooo0009ooooo`03o`000?oooooooooo
03[ooooo00?oo`00o`3oI_ooool0G?ooool00ooo003oooooo`3oIP08ooooo`03o`3oI_l0003oo`00
00[ooooo00?o0000ooooooooool0V?ooool00ol0003oooooooooo`08ooooo`002Oooool00ol0003o
ooooooooo`0jooooo`03ool00?oooooooooo04cooooo0_l0ofH=ooooo`03ool00?oooooo0?mV00[o
oooo00?o0000oooooooo00000_l0ofH7ooooo`03o`000?oooooooooo09Wooooo00?o0000oooooooo
ool01oooool000Wooooo00?o0000ooooooooool0>Oooool00ooo003oooooooooo`1;ooooo`03o`3o
I_oo003oo`0000?oo`001?l0ofH6ooooo`03ool00?oooooo0?mV00_ooooo00Ko0000oooooooooooo
o`00ooooool0ofH6ooooo`03o`000?oooooooooo09Wooooo00?o0000ooooooooool01oooool000Wo
oooo00?o0000ooooooooool0>?ooool00ol0ofKoooooooooo`1:ooooo`03ool00?l0ofKooooo00?o
oooo00?o0?mVoooooooo00000ooo0002o`3oIPCoo`000_l0ofH<ooooo`04o`000?oooooooooooooo
o`;oo`0000?o0?mVooooooooool00oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo
00Oooooo0009ooooo`03o`000?oooooooooo03Oooooo00?oo`00o`3oI_ooool0B_ooool2o`3oIPGo
oooo0_l0ofHHooooo`03o`000?oooooooooo00?ooooo00?oo`00o`3oI_ooool00oooool00ol0003o
ooooooooo`2Iooooo`03o`000?oooooooooo00Oooooo0009ooooo`03o`000?oooooooooo03Kooooo
00?oo`00o`3oI_ooool0BOooool2o`3oIPSooooo00?o0?mVooooooooool05_ooool00ol0003ooooo
ooooo`04ooooo`03ool00?l0ofKooooo00;ooooo00?o0000ooooooooool0VOooool00ol0003ooooo
ooooo`07ooooo`002Oooool00ol0003oooooooooo`0eooooo`03ool00?l0ofKooooo04Sooooo00?o
o`00o`3oI_ooool08_ooool00ol0003oooooooooo`04ooooo`03ool00?l0ofKooooo00;ooooo00?o
0000ooooooooool0VOooool00ol0003oooooooooo`07ooooo`002Oooool00ol0003oooooooooo`0d
ooooo`03ool00?l0ofKooooo04Cooooo1_l0ofHTooooo`03o`000?oooooooooo00Gooooo00Goo`00
o`3oI_ooooooooooo`00002Kooooo`03o`000?oooooooooo00Oooooo0009ooooo`03o`000?oooooo
oooo03?ooooo00?oo`00o`3oI_ooool0@_ooool3o`3oIP;oo`006?ooool9o`3oIPOooooo00?o0000
ooooooooool01Oooool01Ooo003o0?mVoooooooooooo000009_ooooo00?o0000ooooooooool01ooo
ool000Wooooo00?o0000ooooooooool0<_ooool00ooo003o0?mVooooo`11ooooo`;o0?mV0ooo000I
ooooo`05o`3oI_oooooooooooooooooo00000oooool2ool000Oooooo00?o0000ooooooooool01Ooo
ool01Ooo003oooooo`3oI_oooooo000009_ooooo00?o0000ooooooooool01oooool000Wooooo00?o
0000ooooooooool0<Oooool00ooo003o0?mVooooo`0oooooo`?o0?mV0_oo000Jooooo`Koo`001Ooo
ool00ol0ofKoo`00ooooo`05ooooo`03o`000?oooooooooo00;o0?mV1?ooool01?oo003o0?mVoooo
ool0002Kooooo`03o`000?oooooooooo00Oooooo0009ooooo`03o`000?oooooooooo033ooooo00?o
o`00o`3oI_ooool0?Oooool00ooo003o0?mVo`3oIP0Looooo`?oo`0000?o0?mVooooooooool02?oo
ool00ol0ofKoo`00ooooo`05ooooo`04o`000?l0ofKo0?mVool000Kooooo00?oo`00ooooool00000
Voooool00ol0003oooooooooo`07ooooo`002Oooool00ol0003oooooooooo`0_ooooo`03ool00?l0
ofKooooo03cooooo0ol0ofHLooooo`;oo`000_ooool00ol0ofKoooooooooo`09ooooo`03o`3oI_oo
ooooo`0000?ooooo00Koo`00o`3oI_l0003oooooo`3oI_ooool3ool000?ooooo00?oo`00o`3oI_l0
ofH0Voooool00ol0003oooooooooo`07ooooo`002Oooool00ol0003oooooooooo`0^ooooo`03ool0
0?l0ofKooooo03[ooooo0ol0ofH00ooo003oooooooooo`0Booooo`?o0?mV1oooool01?oo003ooooo
ooooool0ofH<ooooo`05o`3oI_ooooooo`00oooooooo00000_l0ofH01?oooooo0000o`3oI_l0ofH4
ooooo`;oo`000_ooool00ooo003o0000o`3oIP2Jooooo`03o`000?oooooooooo00Oooooo0009oooo
o`03o`000?oooooooooo02gooooo00?oo`00o`3oI_ooool0>Oooool2o`3oIP03oooooooo003oo`00
01;ooooo1_oo00000ol0ofKoooooo`3oIP02o`3oIP;oo`000_ooool00ol0ofKoooooooooo`0;oooo
o`05o`3oI_ooooooooooool00?l0ofH00oooool00ol0003oooooooooo`03o`3oIP?ooooo00Koo`00
ooooooooooooo`00ooooool0ofJIooooo`03o`000?oooooooooo00Oooooo0009ooooo`03o`000?oo
oooooooo02gooooo00?oo`00ooooooooool0>Oooool00ol0ofKoooooool0000Aooooo`?oo`001_oo
ool00ooo003o0?mVool00002ool000;o0?mV00?oooooo`3oI_ooool03Oooool3o`3oIPGooooo00?o
0000ooooooooool00oooool2o`3oIP08oooooooo003oooooooooool0003oo`00ooooool0ofJHoooo
o`03o`000?oooooooooo00Oooooo0009ooooo`03o`000?oooooooooo02cooooo00?oo`00o`3oI_oo
ool0>_ooool00ol0ofKoo`00ooooo`0?ooooo`;oo`0000?oooooo`3oI_ooool01oooool00ooo003o
ooooooooo`03ooooo`03o`3oI_oooooooooo00gooooo00?o0?mVooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`?o0?mV00Koooooo`000?ooooooo`00ooooool0ofHlooooo`03o`3oI_oooooo
oooo05Sooooo00?o0000ooooooooool01oooool000Wooooo00?o0000ooooooooool0:oooool00ooo
003o0?mVooooo`0jooooo`03o`3oI_oo003ooooo00oooooo00Coo`00ooooool0ofKo0?mV9oooool0
0ol0003oooooooooo`04ooooo`;o0?mV00Coo`00o`3oI_l0ofKo00000_ooool2ool00003o`3oI_oo
oooooooo03Wooooo00?o0?mVooooooooool0F?ooool00ol0003oooooooooo`07ooooo`002Oooool0
0ol0003oooooooooo`0Zooooo`03ool00?oooooo0?mV03_ooooo00?o0?mVool00?ooool03Oooool0
1?oo003o0?mVo`3oI_l0ofHYooooo`03o`000?oooooooooo00Kooooo00Coo`00o`3oI_oooooo0000
1?ooool00ooo003o0?mVooooo`0hooooo`;o0?mVF_ooool00ol0003oooooooooo`07ooooo`002Ooo
ool00ol0003oooooooooo`0Zooooo`03ool00?l0ofKooooo03_ooooo00?o0?mVooooooooool02ooo
ool3o`3oIRcooooo00?o0000ooooooooool00oooool3o`3oIP;oo`0000?o0?mVo`000?ooool01?oo
ool01?oo003o0?mVooooooooool2o`3oIR3ooooo0_l0ofHAooooo`04o`3oI_oo003oo`00o`3oIUWo
oooo00?o0000ooooooooool01oooool000Wooooo00?o0000ooooooooool0:Oooool00ooo003o0?mV
ooooo`0kooooo`03o`3oI_oo003ooooo00Wooooo0ol0ofH00ooo003oooooooooo`0Zooooo`03o`3o
I_oooooo000000Gooooo00Co0?mVoooooooo003o0?mV0_oo00000ol0ofKoooooooooo`04ooooo`04
ool00?l0ofKo0?mVo`3oIR3ooooo00?o0?mVooooool0ofH01?l0ofH<ooooo`;oo`000_ooool00ooo
003oooooooooo`1Gooooo`03o`000?oooooooooo00Oooooo0009ooooo`03o`000?oooooooooo02So
oooo00?oo`00ooooool0ofH0??ooool00ol0ofKoooooooooo`05ooooo`?oo`0000?o0?mVoooooooo
ool06_ooool5o`3oIPKooooo2?oo0002o`3oIP03ooooool0003ooooo00Gooooo0_l0ofH01?oo003o
ooooooooool0ofH7ooooo`;o0?mV7oooool2o`3oIP07oooooooo003oo`00o`3oI_oo003oooooo`3o
IP0:ooooo`;oo`0000Ko0?mVooooooooooooooooo`3oI_oo0002o`3oIUKooooo00?o0000oooooooo
ool01oooool000Sooooo00?o0000ooooooooool0:Oooool00ooo003o0?mVooooo`0kooooo`03ool0
0?l0ofKooooo00;o0?mV00Goooooool00?oo003oo`00ooooo`02o`3oIQ[ooooo0ol0ofH5ooooo`Wo
0?mV1?ooool01Ol0ofKoooooooooool0ofKo000000Oooooo0ol0ofH00ooooooo0000ooooo`06oooo
o`03o`3oI_ooooooo`0001cooooo0_l0ofH2ooooo`08ool00?ooooooo`00ooooool0ofKoo`00oooo
ool0ofH8ooooo`03ool00?oooooo0?mV00Gooooo00?oo`00ooooooooool00_l0ofIDooooo`03o`00
0?oooooooooo00Oooooo0008ooooo`03o`000?oooooooooo02Sooooo00?oo`00ooooool0ofH0??oo
ool01_l0ofKoooooooooool0ofKoooooool000;o0?mV00?oooooo`3oI_ooool06_ooool3o`3oIP03
ool00?oooooooooo00Kooooo00?oo`00ooooooooool00oooool4o`3oIP?ooooo00?o0?mVo`000?l0
ofH01_ooool00ooo003oooooooooo`02o`3oIPSooooo00?o0?mVool00?ooool06_ooool00ol0ofKo
ooooooooo`02ool000?ooooo00?oo`00ooooool0ofH00ooo0006ooooo`03ool00?oooooo0?mV00Oo
oooo00Coo`00oooooooooooo0?mVE?ooool00ol0003oooooooooo`07ooooo`002?ooool00ol0003o
ooooooooo`0Wooooo`03ool00?oooooo0?mV03_ooooo0_oo00000ol0ofKoooooo`3oIP02ooooo`04
ool00?ooooooooooo`3oIQKooooo1ooo0003o`3oIPSoo`003_ooool00ol0003oo`00o`3oIP02o`3o
IP03ool00?oooooooooo00Coo`0000?o0000o`3oI_ooool01Oooool01?l0ofKoo`00o`3oI_oo000I
ooooo`?o0?mV00?oo`00ooooooooool00oooool01ooo003oooooooooool0ofKoooooo`3oI_oo0000
1?ooool00ooo003oooooo`3oIP09ooooo`03ool00?oooooo0?mV00;oo`00D_ooool00ol0003ooooo
ooooo`07ooooo`002?ooool00ol0003oooooooooo`0Vooooo`03ool00?oooooo0?mV03_ooooo00?o
o`00ooooooooool00_l0ofH2ooooo`03ool00?oooooooooo01Kooooo0_oo000Oooooo`03ool00?l0
003oo`0000;oo`0000?o0?mVool00?ooool00_ooool01?l0ofKoooooool00?l0ofH8ooooo`04ool0
0?l0ofKoooooool001[ooooo0_oo00000ol0ofKoooooooooo`07ooooo`04o`3oI_ooooooo`00o`3o
IP;oo`0000?oooooo`3oI_ooool02Oooool00ooo003oooooool00002ooooo`;oo`00D?ooool00ol0
003oooooooooo`07ooooo`002?ooool00ol0003oooooooooo`0Vooooo`03ool00?oooooo0?mV03Wo
oooo0_oo0002ooooo`;o0?mV0_ooool00ooo003oooooooooo`0Eooooo`;oo`008Oooool01?l0ofKo
0000oooooooo0003o`3oIP07ool00?ooooooooooo`3oI_oooooo0?mVo`00000:ooooo`03o`3oI_oo
003ooooo00;o0?mV6?ooool00ooo003o0?mVooooo`08ooooo`03o`3oI_oooooooooo00;o0?mV00?o
ooooo`3oI_ooool02oooool00ooo003o0?mVooooo`03ooooo`03ool00?oooooooooo04gooooo00?o
0000ooooooooool01oooool000Sooooo00?o0000ooooooooool09Oooool00ooo003oooooo`3oIP0i
ooooo`04ool00?ooooooooooooooo`;o0?mV0oooool00ooo003oooooooooo`0Dooooo`03ool00?oo
oooooooo02;ooooo00Co0000ooooooooooooo`000_ooool00ooo003oooooo`3oIP02o`3oIP03oooo
oooo003ooooo00Wooooo00Goo`00o`3oI_oo003oooooo`3oIP0Hooooo`03ool00?oooooooooo00Wo
oooo0ol0ofH00ooooooo0?mVooooo`0=ooooo`Ko0?mV0_oo00000ol0ofKoooooooooo`1;ooooo`03
o`000?oooooooooo00Kooooo0008ooooo`03o`000?oooooooooo02Cooooo00Coo`00oooooooooooo
0?mV>?ooool00ooo003oooooooooo`02ooooo`;o0?mV0_ooool00ooo003oooooooooo`0Dooooo`03
ool00?l0ofKooooo02?ooooo00?o0000ooooooooool00oooool00ooo003o0?mVo`3oIP02o`3oIP;o
o`002_ooool01Ooo003o0?mVool00?oooooo0?mV01Oooooo00?oo`00ooooooooool03?ooool00ol0
ofKoooooooooo`0Fooooo`03ool00?l0ofKooooo04_ooooo00?o0000ooooooooool01_ooool000So
oooo00?o0000ooooooooool09?ooool00ooo003oooooo`3oIP0gooooo`;oo`000oooool3o`3oIP;o
oooo00?oo`00ooooooooool04oooool2ool00003ooooool0ofKooooo02?ooooo00?o0000oooooooo
ool00oooool00ooo003oooooo`3oIP02ooooo`03o`3oI_oo003ooooo00[ooooo00?o0?mVooooool0
ofH05oooool00ol0ofKoo`00ooooo`0Wooooo`03ool00?l0ofKooooo04[ooooo00?o0000oooooooo
ool01_ooool000Sooooo00?o0000ooooooooool08oooool00ooo003oooooo`3oIP0fooooo`;oo`00
0_ooool3o`3oIP;ooooo00Co0?mVooooooooooooo`004_ooool01_oo003o0?mVool00?l0ofKooooo
o`3oIRGooooo00?o0000ooooooooool00oooool00ooo003oooooo`3oIP03ooooo`03o`000?oo003o
oooo00Wooooo00?oo`00ooooool0ofH05_ooool00ol0ofKoooooool0000Yooooo`03ool00?l0ofKo
oooo04Wooooo00?o0000ooooooooool01_ooool000Sooooo00?o0000ooooooooool08_ooool01?oo
003oooooooooool0ofHdooooo`;oo`000_ooool2o`3oIPCooooo00Co0?mVooooooooooooo`003Ooo
ool6ool00004ooooool0ofKoooooooooo`;o0?mV9Oooool00ol0003oooooooooo`03ooooo`03ool0
0?l0ofKooooo00?ooooo00?o0000o`3oI_ooool02Oooool00ooo003oooooo`3oIP0Dooooo`;o0?mV
0_ooool00ooo003oooooooooo`0Xooooo`03ool00?l0ofKo0?mV00;oo`00A_ooool00ol0003ooooo
ooooo`06ooooo`002?ooool00ol0003oooooooooo`0Qooooo`04ool00?ooooooooooo`3oIS?ooooo
0_oo00001?oooooo0?mVo`3oI_l0ofH6ooooo`04o`3oI_ooooooooooool000_ooooo0_oo0006oooo
o`03o`3oI_oooooooooo02Sooooo00?o0000ooooooooool00oooool00ooo003o0?mVooooo`03oooo
o`03o`3oI_oo003ooooo00Wooooo00?oo`00o`3oI_ooool04oooool01?l0ofKoooooooooooooool2
ool002gooooo0ol0ofH3ool004;ooooo00?o0000ooooooooool01_ooool000Sooooo00?o0000oooo
ooooool08Oooool01?oo003oooooooooool0ofHbooooo`04ool00?oooooo0?mVo`3oIPSooooo00Co
0?mVooooooooooooo`002oooool00ooo003oooooooooo`02ooooo`Co0?mV4oooool7o`3oIQ7ooooo
00?o0000ooooooooool01?ooool01?oo003o0?mVooooooooool2o`3oIPcooooo00?o0?mVoooooooo
ool04Oooool00ol0ofKoooooooooo`02ool003;ooooo0ol0ofH2ool0043ooooo00?o0000oooooooo
ool01_ooool000Sooooo00?o0000ooooooooool08?ooool01?oo003oooooooooool0ofHbooooo`03
ool00?oooooo0?mV00[ooooo00?o0?mVoooooooo00001_ooool01?l0ofKoooooooooooooool2ool0
00Go0?mV5?ooool3o`3oIP03oooooooo003oo`0000Coo`001ol0ofH:ooooo`03o`000?oooooooooo
00Gooooo00Go0?mVooooooooooooooooool00002o`3oIP[ooooo00?o0?mVooooooooool04?ooool3
o`3oIP03oooooooo003ooooo03Gooooo1?l0ofHnooooo`03o`000?oooooooooo00Kooooo0008oooo
o`03o`000?oooooooooo023ooooo00?oo`00ooooool0ofH0<_ooool00ooo003o0?mVo`3oIP0:oooo
o`04o`3oI_ooooooooooool000Gooooo00?o0?mVoooooooo00000_oo000Iooooo`;o0?mV00Cooooo
ool00?oo003oo`001Oooool;ool00003o`3oI_oooooooooo00;ooooo0_l0ofH00ol0003ooooooooo
o`04ooooo`03o`3oI_oo003ooooo00;ooooo00?oo`00ooooooooool00_l0ofH7ooooo`03o`3oI_oo
003ooooo01Cooooo00?o0?mVool00?ooool0>?ooool00ooo003o0?mVo`3oIP0looooo`03o`000?oo
oooooooo00Kooooo0008ooooo`03o`000?oooooooooo01oooooo00?oo`00ooooool0ofH0<_ooool0
0ooo003o0?mVooooo`0:ooooo`04o`3oI_ooooooooooool000Cooooo1?oo000Eooooo`03o`3oI_oo
oooooooo00;ooooo00?o0?mVool00?oo00000ooo00000ooooooo0?mVool00003ooooo`03ool00?oo
oooooooo00?ooooo00Go0?mVooooooooooooo`00o`3oIP02ool00007o`3oI_ooooooooooo`3oI_oo
oooo0?mVo`000006ooooo`03o`3oI_oooooooooo00;ooooo00?o0000ool00?oo00000_ooool2o`3o
IPGooooo00?o0?mVool00?ooool05Oooool00ooo003oooooooooo`0iooooo`03o`3oI_oo003ooooo
03[ooooo00?o0000ooooooooool01_ooool000Sooooo00?o0000ooooooooool07oooool00ooo003o
0?mVooooo`0aooooo`03ool00?l0ofKooooo00[ooooo00Co0?mVooooooooooooo`001?ooool00ooo
003o0?mVooooo`0Gooooo`06o`3oI_oooooooooooooooooo003ooooo0_l0ofH2ool00004o`3oI_oo
oooo0?mVooooo`;oo`0000?o0?mVool00?ooool01?ooool00ol0ofKoooooooooo`02ooooo`05o`3o
I_oo003o0?mVool00?l0ofH00_oo00000ooooooo0000ooooo`04ooooo`03ool00?l0ofKooooo00?o
oooo00Co0000ooooooooooooo`000oooool00ol0ofKoooooooooo`02ooooo`03o`3oI_oo003ooooo
01Gooooo00?oo`00o`3oI_ooool07oooool3ool001Sooooo00?o0?mVool00?oo0000>Oooool00ol0
003oooooooooo`06ooooo`002?ooool00ol0003oooooooooo`0Nooooo`03ool00?l0ofKooooo037o
oooo00?oo`00o`3oI_ooool02oooool00ol0ofKoooooool00004ooooo`03ool00?l0ofKooooo01So
oooo00?o0?mVooooooooool00ol0ofH2ooooo`03o`3oI_oooooo0?mV00;ooooo00Co0?mVoooooooo
ooooo`001oooool01?l0ofKoooooooooooooool2o`3oIP03ool00?l0ofKoo`0000;ooooo00?oo`00
o`000?ooool01?ooool00ol0ofKoooooooooo`03ooooo`04o`000?ooooooooooool000?ooooo00?o
0?mVooooooooool00oooool00ol0ofKoooooooooo`0Dooooo`03ool00?l0ofKooooo01_ooooo1?l0
ofH00ooo003o0?mVo`3oIP03ool000?ooooo1?l0ofH?ooooo`03o`3oI_ooooooo`0003Sooooo00?o
0000ooooooooool01_ooool000Sooooo00?o0000ooooooooool07_ooool00ooo003oooooooooo`0`
ooooo`03ool00?oooooooooo00_ooooo00?o0?mVoooooooo00001?ooool00ooo003o0?mVooooo`0A
ooooo`Goo`001?ooool2o`3oIP03ool00?oooooooooo00?ooooo0_l0ofH2ooooo`03o`3oI_oooooo
0?mV00Wooooo2Ol0ofH2ooooo`03o`000?oo003o0?mV00;o0?mV00?oooooo`3oI_oo00001?ooool0
1ol0003oooooooooooooooooo`00ooooool0ofH01_ooool00ol0ofKoooooooooo`0Dooooo`03ool0
0?l0ofKooooo01cooooo00?o0?mVoooooooo00001?ooool2o`3oIP;oo`0000Go0?mVoooooooooooo
ooooo`3oIP0?ooooo`04o`3oI_ooooooooooool003Oooooo00?o0000ooooooooool01_ooool000So
oooo00?o0000ooooooooool07Oooool00ooo003oooooooooo`0`ooooo`03ool00?oooooooooo00_o
oooo00?o0?mVoooooooo00000oooool3o`3oIQ3ooooo00?o0?mVool00?oo00001Oooool00ooo003o
ooooooooo`03o`3oIPOooooo00Go0?mVooooooooooooooooo`3oIP0=ooooo`?o0?mV00?oo`00oooo
ool0ofH00_ooool02?l0003oo`00oooooooooooo0?mVooooool0ofKooooo0_oo0002ooooo`04o`00
0?ooooooooooooooo`;oo`0000?o0?mVooooooooool01?ooool00ooo003o0?mVooooo`0Dooooo`03
ool00?oooooo0?mV01[ooooo1?l0ofH:ooooo`05ool00?ooooooooooooooool0ofH03oooool2o`3o
IP03oooooooo003ooooo03Gooooo00?o0000ooooooooool01_ooool000Sooooo00?o0000oooooooo
ool07?ooool00ol0ofKoo`00ooooo`0`ooooo`03o`3oI_oo003ooooo00_ooooo00?o0?mVoooooooo
00000ol0ofH2ool0017ooooo00?oo`00o`3oI_ooool01Oooool4o`3oIP03ool00?l0ofKooooo01co
oooo00Ooo`00oooooooooooo0?mVooooool0003oo`0000?ooooo0_l0ofH3ooooo`03ool00?oooooo
000000Cooooo00?o0?mVool00?l0ofH01Oooool00ooo003oooooooooo`0Eooooo`03ool00?oooooo
0?mV01Kooooo1_oo000<ooooo`;oo`0000?oooooo`3oI_ooool04?ooool2o`3oIP03ool00?oooooo
oooo03?ooooo00?o0000ooooooooool01_ooool000Sooooo00?o0000ooooooooool06oooool00ol0
ofKoo`00ooooo`0`ooooo`03o`3oI_oo003ooooo00_ooooo0_l0ofH00ooo003oooooooooo`02ool0
01;ooooo00Goo`00o`3oI_oooooo0?mVooooo`04o`3oIPCooooo00?oo`00ooooool0ofH07Oooool0
1ooo003oooooo`3oI_oooooo0000oooooooo00000_ooool00ol0ofKoooooo`3oIP03ooooo`03ool0
0?l0003ooooo00Gooooo00?oo`00o`3oI_l0ofH00_ooool00ooo003oooooooooo`0Gooooo`03ool0
0?l0ofKooooo01?ooooo0_oo00000ol0ofKoooooooooo`0Aooooo`03ool00?oooooo0?mV01;ooooo
00?o0?mVool00?ooool0<oooool00ol0003oooooooooo`06ooooo`002?ooool00ol0003ooooooooo
o`0Kooooo`03o`3oI_oo003ooooo02oooooo00?o0?mVool00?ooool02oooool01?l0ofKoooooool0
0?ooool2ool001?ooooo00Coo`00o`3oI_oooooooooo0_l0ofH8ooooo`03ool00?l0ofKo0?mV01ko
oooo00Koo`00o`3oI_oooooo0000oooooooo0003ooooo`03o`3oI_oooooo0?mV00;ooooo00?oo`00
o`000?ooool01Oooool01_oo003ooooooooooooooooo0?mVool001Wooooo00?oo`00ooooooooool0
4oooool00ooo003oooooo`3oIP0Dooooo`03ool00?l0ofKooooo01;ooooo00?o0?mVool00?ooool0
<_ooool00ol0003oooooooooo`06ooooo`002?ooool00ol0003oooooooooo`0Jooooo`03o`3oI_oo
003ooooo02oooooo00?o0?mVoooooooo00002oooool01Ol0ofKoooooool00?l0ofKoo`0001Cooooo
00?oo`00ooooool0ofH01oooool4o`3oIP03ool00?oooooooooo01oooooo00Coo`00o`3oI_oooooo
00000_ooool01?oo003oooooooooool0ofH2ooooo`04o`3oI_ooooooooooool000?o0?mV0_ooool0
1ol0ofKoo`00oooooooooooo0?mVoooooooo00005_ooool2o`3oIP03ool00?l0ofKooooo00cooooo
0_l0ofH5ooooo`03ool00?oooooo0?mV01Kooooo00?oo`00o`3oI_ooool04oooool00ooo003ooooo
ooooo`0`ooooo`03o`000?oooooooooo00Kooooo0008ooooo`03o`000?oooooooooo01Wooooo00?o
0?mVoooooooo0000;oooool00ol0ofKoooooool0000;ooooo`04o`3oI_ooooooo`00ool001Cooooo
0_oo00000ooooooo0?mVooooo`05ooooo`;o0?mV0oooool2ool002;ooooo00?oo`00o`3oI_l00000
0oooool01?oo003oooooooooool0ofH2ooooo`Co0?mV0oooool3o`3oIP04ool00?l0ofKoooooool0
01Oooooo00?o0?mVool00?ooool03Oooool00ol0ofKoo`00ool00002o`3oIPCoo`0000?o0?mVoooo
ooooool05_ooool3ool001?ooooo00?oo`00ooooooooool0;oooool00ol0003oooooooooo`06oooo
o`002?ooool00ol0003oooooooooo`0Hooooo`03o`3oI_ooooooo`0002oooooo00Co0?mVoooooooo
ooooo`002_ooool01Ol0ofKoooooool00?oooooo0?mV01?ooooo00Goo`00ooooooooooooooooo`3o
IP06ooooo`03o`3oI_oooooooooo00;oo`009?ooool00ooo003o0?mVo`000004ooooo`03ool00?l0
ofKooooo00;ooooo00?o0?mVooooool000000_oo0003ooooo`?oo`0000?o0?mVoooooooo00005ooo
ool00ol0ofKoo`00ooooo`0>ooooo`04o`3oI_ooooooooooooooo`;o0?mV00Coo`00o`3oI_oooooo
0?mV6?ooool2o`3oIPCoo`000ol0ofH=ooooo`03ool00?oooooooooo02kooooo00?o0000oooooooo
ool01_ooool000Sooooo00?o0000ooooooooool05oooool01?l0ofKooooooooooooo000_ooooo`03
o`3oI_ooooooo`0000[ooooo00?o0?mVoooooooo00000_ooool00ol0ofKoooooooooo`0>ooooo`?o
o`000oooool00ol0ofKoooooooooo`06ooooo`03o`3oI_oo003ooooo02Gooooo00?oo`00o`3oI_l0
00001?ooool00ooo003oooooooooo`02ooooo`03o`3oI_ooooooo`0000Oooooo00Coo`00ooooool0
ofKoo`006?ooool00ooo003oooooooooo`0;ooooo`?oo`0000Ko0?mVooooooooooooooooool00?l0
ofH2ool00003ooooool0ofKooooo01cooooo0_oo00000ol0ofKoooooooooo`0<ooooo`03ool00?oo
oooooooo02gooooo00?o0000ooooooooool01_ooool000Oooooo00?o0000ooooooooool05oooool0
1?l0ofKooooooooooooo000`ooooo`03o`3oI_oo003ooooo00Sooooo0_l0ofH3ool000;ooooo00?o
0?mVooooooooool02_ooool4ool000?ooooo0ol0ofH9ooooo`03ool00?l0ofKooooo02Kooooo00?o
0?mVo`000?ooool00_ooool00ooo003oooooooooo`03ooooo`03o`3oI_oo003o000000Oooooo00Co
0?mVool00?l0ofKoo`006?ooool00ooo003oooooooooo`09ooooo`;oo`000oooool01_l0ofKooooo
ooooooooooooo`00o`3oIP;ooooo00Coo`00o`3oI_oooooooooo0ol0ofHIooooo`03ool00?oooooo
0?mV00gooooo00?o0?mVool00?ooool0;Oooool00ol0003oooooooooo`06ooooo`001oooool00ol0
003oooooooooo`0Fooooo`05o`3oI_oooooooooooooooooo0000;oooool00ol0ofKoooooool00007
ooooo`;o0?mV00Coooooool00?ooooooo`000_ooool00ol0ofKoooooooooo`08ooooo`?oo`000_oo
ool5o`3oIP_ooooo00?oo`00ooooool0ofH09oooool01Ooo003o0000ooooooooooooo`0000Kooooo
00?o0?mVool00?l000002?ooool00ol0ofKoo`00ool0000Gooooo`03ool00?l0ofKooooo00Wooooo
00?oo`00ooooooooool00_ooool00ol0ofKoooooooooo`02ooooo`05ool00?l0ofKo0?mVoooooooo
00000ol0ofH00ooooooo0?mVo`3oIP0Jooooo`03ool00?l0ofKooooo00gooooo00?o0?mVool00?oo
ool0;?ooool00ol0003oooooooooo`06ooooo`001oooool00ol0003oooooooooo`0Eooooo`05o`3o
I_oooooooooooooooooo0000<?ooool00ol0ofKoo`00ooooo`05ooooo`;o0?mV0_ooool00ooo003o
ooooool00002ooooo`03o`3oI_oooooooooo00Oooooo0_oo0005o`3oIQ3ooooo00Coo`00oooooooo
oooo0?mV9_ooool01Ooo003o0000ooooool0ofKoo`0000Kooooo00?o0?mVool00?l000002?ooool0
0ol0ofKoo`00ool0000Gooooo`03ool00?oooooo0?mV00Sooooo00?oo`00ooooooooool00ol0ofH5
ooooo`04ool00?l0ofKoooooooooo`Goo`0000?o0?mVool00?oo00006Oooool00ooo003o0?mVoooo
o`0=ooooo`03o`3oI_oo003ooooo02cooooo00?o0000ooooooooool01_ooool000Oooooo00?o0000
ooooooooool05?ooool00ol0ofKoooooooooo`02ooooo`03ool00?oooooooooo02kooooo00?o0?mV
ool00?ooool00oooool2o`3oIP;ooooo0_oo00001Oooooooo`00oooooooooooo0?mV00Wooooo00?o
0?mVool00?l0ofH05Oooool00ooo003oooooo`3oIP0Wooooo`04o`000?oo003o0?mVool000Oooooo
0_l0ofH00ooo003oooooooooo`05ooooo`04o`3oI_ooooooo`00ool001Kooooo00Coo`00ooooool0
ofKo0?mV1oooool01?oo003o0?mVo`3oI_l0ofH7ooooo`03ool00?l0ofKooooo00Oooooo00?o0?mV
ool00?l0ofH01Ooo000Eooooo`03ool00?l0ofKooooo00gooooo00?oo`00ooooooooool0:oooool0
0ol0003oooooooooo`06ooooo`001oooool00ol0003oooooooooo`0Cooooo`03o`3oI_oooooooooo
00;ooooo00?oo`00ooooooooool0;_ooool00ol0ofKoo`00ooooo`02ooooo`;o0?mV0oooool01ooo
003oooooooooooooooooo`00ooooool0ofH02_ooool00ooo003oooooooooo`0Eooooo`03ool00?l0
ofKooooo02Oooooo00Go0000ool00?oooooo0?mVool00003ooooo`?oo`0000?o0?mVoooooooo0000
1oooool01Ol0ofKoooooool00?oo003o0?mV01Cooooo0ol0ofH8ooooo`03ool00?oooooo0?mV00Go
oooo1Ooo0009ooooo`04o`3oI_oo003o0?mVo`3oIP?oo`0000Co0?mVool00?l0ofKooooo1ooo000;
ooooo`03ool00?l0ofKooooo00gooooo00?o0?mVool00?ooool0:oooool00ol0003oooooooooo`06
ooooo`001oooool00ol0003oooooooooo`0Cooooo`03o`3oI_oooooooooo00;ooooo00?oo`00oooo
ooooool0;_ooool00ol0ofKoo`00ooooo`02o`3oIP?ooooo0_oo0003ooooo`03ool00?oooooo0?mV
00_ooooo00?oo`00ooooooooool05?ooool00ol0ofKoo`00ooooo`0Xooooo`03o`000?oo003o0?mV
00;o0?mV0ooo0002o`3oIP06ool00?l0ofKoooooo`000?oo003o0?mV1?ooool4o`3oIP03ool00?oo
oooo0?mV017ooooo0_l0ofH:ooooo`03ool00?oooooo0?mV00Cooooo0_oo00000ol0ofKooooooooo
o`09ooooo`;oo`0000?o0?mVool00?l0ofH00_l0ofH01Oooooooo`00ooooooooooooo`0000Ko0?mV
0_ooool00ooo003oooooooooo`09ooooo`;oo`003_ooool00ooo003oooooooooo`0[ooooo`03o`00
0?oooooooooo00Gooooo0007ooooo`03o`000?oooooooooo01?ooooo00Go0?mVoooooooooooooooo
ool0000aooooo`03ool00?l0ofKo0?mV00Cooooo00?oo`00ooooooooool00oooool00ooo003ooooo
o`3oIP0:ooooo`03ool00?l0ofKooooo01Cooooo00?o0?mVool00?ooool0:Oooool00ol0003oo`00
ool00002ooooo`;o0?mV1?ooool01_l0ofKoooooo`000?ooooooo`00o`3oIP;ooooo0_l0ofH01_oo
ooooo`00o`3oI_ooooooo`00o`3oIQ7ooooo00?o0?mVool00?ooool02?ooool00ooo003o0?mVo`3o
IP03ooooo`04ool00?l0ofKoooooo`3oIPcooooo00Coo`00o`3oI_l0ofKo0?mV0_ooool00ol0ofKo
ooooool00004ooooo`03o`3oI_oooooooooo00;ooooo0ol0ofH00ooo003oooooooooo`08ooooo`;o
0?mV00?oo`00ooooooooool02oooool00ooo003oooooooooo`0[ooooo`03o`000?oooooooooo00Go
oooo0007ooooo`03o`000?oooooooooo01?ooooo00Go0?mVooooooooooooooooool0000`ooooo`03
ool00?l0ofKooooo00?ooooo0_oo0005ooooo`03ool00?oooooo0?mV00_ooooo00?oo`00o`3oI_oo
ool05?ooool00ooo003oooooooooo`0Yooooo`08o`000?ooooooooooool00?oooooo0?mVooooool0
ofH3ooooo`03o`3oI_oooooo000000;ooooo00?oo`00o`3oI_ooool00oooool01?oo003oooooo`3o
I_oo000Booooo`03o`3oI_oo003ooooo00Sooooo00Coo`00oooooooooooooooo0_l0ofH00ooo003o
ooooo`3oIP0<ooooo`03ool00?l0ofKo0?mV00Cooooo00?o0?mVoooooooo00000oooool2o`3oIPSo
oooo00?oo`00o`3oI_l0ofH01_oo00001Ol0ofKoooooo`3oI_ooooooo`0000cooooo00?oo`00o`3o
I_ooool0:oooool00ol0003oooooooooo`05ooooo`001oooool00ol0003oooooooooo`0Cooooo`05
o`3oI_oooooooooooooooooo0000<?ooool00ooo003o0?mVooooo`02ooooo`03ool00?oooooooooo
00Gooooo00?oo`00o`3oI_ooool02oooool00ooo003o0?mVooooo`0Dooooo`03ool00?oooooooooo
02Wooooo00Go0000ooooooooooooooooo`3oIP02ooooo`07o`3oI_ooooooooooooooool0ofKooooo
o`000004ooooo`06o`3oI_oooooooooooooooooo003ooooo0_l0ofH00ooo003oooooooooo`0@oooo
o`03ool00?oooooooooo00Kooooo00?o0?mVool00?ooool00_ooool00ol0ofKoo`00ooooo`0>oooo
o`03ool00?oooooooooo00Cooooo00Co0?mVoooooooo003ooooo2_oo0007ooooo`;o0?mV0_ooool3
ool00003o`3oI_ooooooo`0000cooooo00?oo`00o`3oI_ooool0:_ooool00ol0003oooooooooo`05
ooooo`001oooool00ol0003oooooooooo`0Booooo`05o`3oI_oooooooooooooooooo0000<?ooool0
0ooo003o0?mVo`3oIP02ooooo`03ool00?oooooooooo00Gooooo00?oo`00o`3oI_ooool02oooool0
0ooo003oooooo`3oIP0Dooooo`03ool00?oooooooooo02[ooooo00Go0000ooooooooooooooooo`3o
IP02ooooo`;o0?mV0oooool00ooo003o0000ooooo`04ooooo`08o`3oI_oooooooooooooooooo003o
ooooo`3oI_oo000Booooo`03ool00?oooooooooo00Gooooo00?o0?mVoooooooo00000oooool00ol0
ofKoo`00ooooo`0=ooooo`03o`3oI_oo003ooooo00Kooooo00Co0?mVool00?oo003o0?mV1Oooool2
o`3oIP;ooooo00?oo`00ooooooooool02oooool01?oo003o0?mVooooool0ofH;ooooo`03ool00?oo
oooo0?mV02[ooooo00?o0000ooooooooool01Oooool000Oooooo00?o0000ooooooooool04_ooool0
1Ol0ofKoooooooooooooooooo`00033ooooo00?oo`00ooooool0ofH00_ooool00ooo003ooooooooo
o`05ooooo`03ool00?oooooooooo00_ooooo00?oo`00ooooool0ofH04oooool00ooo003o0?mVoooo
o`0[ooooo`06o`000?ooooooooooooooool0ofKoo`000ol0ofH3ooooo`03ool00?l0ofKooooo00Go
oooo00Oo0?mVooooooooooooo`00ooooool0ofKoo`0001;ooooo00Co0?mVool00?l0ofKo0?mV0ooo
ool01?l0ofKoooooool00?oo0002ooooo`;o0?mV3oooool00ol0ofKoooooooooo`06ooooo`03o`3o
I_oooooo0?mV00Sooooo0_l0ofH00oooooooo`00ool0000<ooooo`;oo`0000?oooooo`3oI_oo0000
2Oooool01?oo003oooooooooool0ofHYooooo`03o`000?oooooooooo00Gooooo0007ooooo`03o`00
0?oooooooooo01;ooooo00Go0?mVooooooooooooooooool0000_ooooo`04ool00?l0ofKoooooo`3o
IP;ooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`0;ooooo`04ool00?oooooooooo
o`3oIQ7ooooo0_oo00000ooooooo0?mVooooo`0[ooooo`03o`000?oooooooooo00?ooooo00?o0?mV
ool00?ooool00oooool00ooo003o0000o`3oIP05ooooo`08ool00?ooooooooooool00?oooooo0?mV
oooooooo000Cooooo`04ool00?l0ofKoooooooooo`;o0?mV00Coooooool00?oooooooooo0ol0ofH>
ooooo`03o`3oI_oooooooooo00Sooooo00?o0?mVooooooooool01oooool2ool000?o0?mV00?oo`00
ooooooooool02oooool2ool00003o`3oI_oo003oo`0000Sooooo00?oo`00ooooool0ofH0:Oooool0
0ol0003oooooooooo`05ooooo`001oooool00ol0003oooooooooo`0Booooo`04o`3oI_oooooooooo
ool0033ooooo00Coo`00o`3oI_oooooo0?mV0_ooool00ooo003oooooooooo`03ooooo`03o`3oI_oo
003ooooo00cooooo00?oo`00ooooool0ofH04?ooool2ool000;ooooo00?o0?mVooooooooool0:ooo
ool00ol0003oooooooooo`03ooooo`03o`3oI_oo003ooooo00?ooooo0ol0ofH4ooooo`03ool00?oo
oooooooo00;ooooo00Coo`00o`3oI_l0ofKoo`004oooool00ooo003o0?mVooooo`03ooooo`03ool0
0?l0ofKo0?mV00Go0?mV3?ooool2o`3oIP[ooooo00?o0?mVool00?ooool01_ooool00ooo003ooooo
ooooo`03ool00003o`3oI_oo003oo`0000cooooo00Go0?mVool00?oo003oooooool00008ooooo`03
ool00?oooooo0?mV02Sooooo00?o0000ooooooooool01Oooool000Oooooo00?o0000ooooooooool0
4_ooool01?l0ofKooooooooooooo000`ooooo`06ool00?ooooooooooo`3oI_ooooooo`001_ooool0
0ooo003oooooooooo`0;ooooo`03ool00?oooooo0?mV00oooooo0_oo00000ooooooo0?mVo`3oIP02
o`3oIRgooooo00?o0000ooooooooool00_ooool01?l0ofKooooooooooooo0004ooooo`;oo`000ooo
ool2ool000Cooooo00Goo`00o`3oI_l0ofKoooooool0000Cooooo`03o`3oI_oooooooooo00;ooooo
0_oo0002o`3oIPoooooo1?oo0008ooooo`;o0?mV2?oo0002o`3oIPCooooo1?oo0005o`3oIPOooooo
00Go0?mVoooooooo003oooooool00007ooooo`04ool00?ooooooooooo`3oIROooooo00?o0000oooo
ooooool01Oooool000Oooooo00?o0000ooooooooool04_ooool01?l0ofKooooooooooooo000_oooo
o`07o`3oI_oo003oooooooooool0ofKoooooool00005ooooo`03o`3oI_oo003ooooo00cooooo00?o
o`00ooooool0ofH03Oooool2ool000?o0?mV<Oooool00ol0003oooooooooo`02ooooo`04o`3oI_oo
ooooooooool000Cooooo00Soo`00o`3oI_oo003oo`00ooooool0ofKoooooool000?ooooo00?oo`00
o`3oI_l0ofH00_ooool00ooo003oooooooooo`0@ooooo`;oo`000_ooool01?oo003oooooool00?l0
ofH?ooooo`;oo`000_l0ofH00ooo003oooooo`3oIP05ooooo`?o0?mV1?ooool5o`3oIP04ooooool0
ofKo0?mVo`3oIPCooooo00?oo`00oooooooo00000oooool4o`3oIPCooooo00Co0?mVool00?l0ofKo
o`002?ooool01?oo003oooooooooool0ofHVooooo`03o`000?oooooooooo00Gooooo0007ooooo`03
o`000?oooooooooo01;ooooo00?o0?mVoooooooo0000;oooool00ol0ofKoo`00ooooo`02ooooo`03
o`3oI_ooooooo`0000Cooooo00?o0?mVool00?ooool03?ooool00ooo003oooooo`3oIP0=ooooo`03
ool00?oooooo0?mV03Cooooo00?o0000ooooooooool00_ooool01?l0ofKooooooooooooo0004oooo
o`03o`000?oooooooooo00?o0?mV0_ooool01?oo003oooooool00?ooool2o`3oIP?ooooo00?oo`00
ooooooooool03Oooool2ool000;o0?mV0_ooool01?oo003oooooo`3oI_oo000@ooooo`04o`3oI_oo
ooooooooool000;o0?mV1Oooool00ol0ofKoo`00ooooo`02o`3oIP?oo`002?ooool3o`3oIP04oooo
oooo003oooooooooo`Coo`000oooool00ol0ofKoooooooooo`02ooooo`04o`3oI_oooooo0?mVool0
00Sooooo00?oo`00ooooool0ofH09_ooool00ol0003oooooooooo`05ooooo`001oooool00ol0003o
ooooooooo`0Booooo`03o`3oI_ooooooo`0002oooooo00Go0?mVool00?ooooooooooo`3oIP02oooo
o`06ool00?ooooooooooooooool0ofKoo`003_ooool00ooo003o0?mVooooo`0<ooooo`03ool00?oo
oooo0?mV03Gooooo00?o0000ooooooooool00_ooool01?l0ofKooooooooooooo0004ooooo`08o`00
0?ooooooooooooooool0ofKoo`00o`3oI_ooool2ool000;ooooo0_l0ofH4ooooo`03ool00?oooooo
oooo00kooooo00Soo`00ooooool0ofKoooooool00?oooooo0?mVool001;ooooo0_oo0004o`3oIP;o
oooo00?o0?mVool00?ooool00_ooool4o`3oIP_ooooo00?o0?mVool00?ooool01Oooool3ool00003
ooooool0ofKooooo00;ooooo00Co0?mVool00?ooooooo`002?ooool01?oo003oooooooooool0ofHU
ooooo`03o`000?oooooooooo00Gooooo0007ooooo`03o`000?oooooooooo01;ooooo00?o0?mVoooo
oooo0000;oooool01Ol0ofKoo`00oooooooooooo0?mV00;ooooo00Goo`00oooooooooooo0?mVool0
000>ooooo`03ool00?l0ofKooooo00cooooo00?oo`00ooooool0ofH06_ooool00ol0ofKooooooooo
o`0Iooooo`03o`000?oooooooooo00;ooooo00Co0?mVooooooooooooo`001?ooool00ol0003ooooo
ooooo`02ooooo`04ool00?oooooo0?mVool000?ooooo0_l0ofH5ooooo`03ool00?oooooooooo00go
oooo00Goo`00ooooool0ofKoooooool00003o`3oIP03ool00?oooooooooo00cooooo0_l0ofH2ool0
00;o0?mV0ooo0002o`3oIP09ool00?oooooooooooooooooo003o0?mVooooool0ofKooooo00;o0?mV
2Oooool00ol0ofKoo`00ooooo`08ooooo`03ool00?oooooo0?mV00;ooooo00Go0?mVool00?oooooo
o`00o`3oIP08ooooo`04ool00?ooooooooooo`3oIRCooooo00?o0000ooooooooool01Oooool000Oo
oooo00?o0000ooooooooool04Oooool01?l0ofKooooooooooooo000^ooooo`03o`3oI_ooooooo`00
00;ooooo00Oo0?mVooooooooooooo`00ooooool0ofKoo`0000oooooo00?oo`00o`3oI_ooool03?oo
ool00ooo003o0?mVooooo`0Jooooo`03o`3oI_oooooooooo00Kooooo1_l0ofH=ooooo`03o`000?oo
oooooooo00;ooooo00?o0?mVooooooooool00_oo0003ooooo`03o`000?oooooooooo00;ooooo00Co
o`00ooooool0ofKoo`000_ooool01Ol0ofKoooooooooool0ofKooooo00?o0?mV00?oo`00oooooooo
ool03_ooool00ooo003o0?mVooooo`04o`3oIP03ool00?l0ofKooooo00Wooooo0_l0ofH01Ooooooo
0?mVool00?oo003o0?mV00Gooooo0_oo0003ooooo`03ool00?l0ofKo0?mV00Cooooo00?oo`00o`3o
I_ooool02?ooool00ol0ofKoo`00ooooo`08ooooo`06ool00?oooooo0?mVooooool0ofKoo`000_oo
ool00ooo003o0?mVooooo`06ooooo`05ool00?ooooooooooooooool0ofH08oooool00ol0003ooooo
ooooo`05ooooo`001oooool00ol0003oooooooooo`0Aooooo`03o`3oI_ooooooo`0002oooooo00?o
0?mVoooooooo00000_ooool01_l0ofKooooooooooooo003o0?mVool000oooooo00?oo`00o`3oI_oo
ool02_ooool2o`3oIP03ool00?l0ofKooooo01[ooooo0_oo00000ol0ofKoooooooooo`05ooooo`03
o`3oI_oooooooooo00;ooooo00?o0?mVooooooooool02oooool00ol0003oooooooooo`02ooooo`Co
0?mV00Goooooool00?ooooooooooo`000003ooooo`05o`3oI_oo003o0?mVo`3oI_oo00000ol0ofH2
ooooo`;o0?mV0_ooool00ol0ofKoooooool0000?ooooo`09ool00?l0ofKo0?mVoooooooo003o0?mV
oooooooo003o0?mV00Wooooo00Coo`00o`3oI_oooooo0?mV0_oo00000ooooooo0?mVooooo`08oooo
o`04ool00?l0ofKoooooo`3oIPGooooo00?oo`00o`3oI_l0ofH02?ooool00ol0ofKoooooooooo`08
ooooo`07ool00?l0ofKoooooo`3oI_ooooooo`00ooooo`02ool00003o`3oI_oooooooooo00Gooooo
00Goo`00ooooooooooooooooo`3oIP0Rooooo`03o`000?oooooooooo00Gooooo0007ooooo`03o`00
0?oooooooooo017ooooo00?o0?mVoooooooo0000;oooool00ol0ofKoooooool00002ooooo`06o`3o
I_ooooooo`00o`3oI_ooooooo`003_ooool00ol0ofKoo`00ooooo`08ooooo`?o0?mV00?oooooool0
0?ooool07?ooool01?oo003oooooooooool0ofH5ooooo`03o`3oI_oo003oo`0000?oo`0000?o0?mV
ooooooooool02oooool00ol0003oooooooooo`06ooooo`Go0?mV0oooool01Ol0ofKoo`00ool00?l0
ofKoo`0000[ooooo00?o0?mVool00?ooool03_ooool02?oo003o0?mVool00?ooooooo`00oooooooo
003o0?mV2_ooool00ol0ofKoooooo`3oIP03ool00003o`3oI_oooooooooo00Sooooo00Coo`00oooo
oooooooo0?mV1_ooool2ool00003o`3oI_oooooooooo00Gooooo0_oo000:ooooo`05ool00?l0ofKo
0?mVoooooooo00000oooool00ooo003oooooooooo`06ooooo`04ool00?ooooooooooo`3oIR;ooooo
00?o0000ooooooooool01Oooool000Oooooo00?o0000ooooooooool04Oooool00ol0ofKoooooool0
000^ooooo`03o`3oI_ooooooo`0000?ooooo00Go0?mVoooooooo003oooooool0000>ooooo`03o`3o
I_oo003ooooo00Wooooo00Co0?mVooooooooooooo`007Oooool01Ol0ofKoo`00ool00?oooooo0?mV
00;oo`000_ooool00ol0ofKoooooooooo`04ooooo`;oo`003?ooool00ol0003oooooooooo`08oooo
o`03ool00?oooooo0?mV00;ooooo0_l0ofH2ool00003o`3oI_oo003ooooo00Wooooo00?o0?mVool0
0?ooool03_ooool02?oo003o0?mVool00?oo003o0?mVooooool0ofKoo`001oooool6o`3oIP04oooo
oooo003o0?mVo`3oIP_ooooo00?oo`00o`3oI_ooool02?ooool00ol0ofKoo`00ooooo`07ooooo`03
ool00?oooooooooo00Sooooo1?l0ofH01?oo003oooooooooooooool2ool000Kooooo00Coo`00oooo
oooooooo0?mV8_ooool00ol0003oooooooooo`05ooooo`001oooool00ol0003oooooooooo`0Aoooo
o`03o`3oI_oo003ooooo02kooooo00?o0?mVoooooooo00000oooool2o`3oIP;oo`003Oooool2o`3o
IP03ool00?oooooooooo00Wooooo00?o0?mVoooooooo00007?ooool3ool000Cooooo00Go0?mVoooo
oooo003oooooo`3oIP06ooooo`04o`3oI_ooooooo`00ool000[ooooo00?o0000ooooooooool02?oo
ool00ooo003oooooo`3oIP03ooooo`05o`3oI_oo003o0?mVo`3oI_oo00002Oooool00ol0ofKooooo
ool0000=ooooo`03o`3oI_oo003oo`0000;oo`0000Goooooo`3oI_oooooo0?mVool00006ooooo`;o
0?mV1?oo0002ooooo`03o`3oI_oooooo0?mV00_ooooo00?oo`00o`3oI_ooool02?ooool00ol0ofKo
o`00ooooo`08ooooo`03ool00?oooooooooo00Oooooo00Co0?mVoooooooooooooooo0_l0ofH2oooo
o`03o`3oI_ooooooo`0000Kooooo00?oo`00ooooool0ofH08_ooool00ol0003oooooooooo`05oooo
o`001oooool00ol0003oooooooooo`0Aooooo`03o`3oI_oo003ooooo02kooooo00?o0?mVoooooooo
00000oooool00ol0ofKoooooool0000=ooooo`03o`3oI_ooooooo`0000_ooooo00Co0?mVoooooooo
ooooo`006_ooool3o`3oIPKooooo00Go0?mVoooooooooooo0?mVool00006ooooo`Co0?mV1?oo0006
ooooo`03o`000?oooooooooo00Sooooo00?oo`00ooooool0ofH01?ooool01Ol0ofKooooooooooooo
003o0?mV00Oooooo00?o0?mVoooooooo00003?ooool3o`3oIP03ool00?l0ofKo0?mV00?ooooo00?o
0?mVoooooooo00000oooool01?l0ofKoo`00oooooooo0002ooooo`?oo`0000?oooooo`3oI_ooool0
3Oooool00ooo003o0?mVooooo`08ooooo`03o`3oI_ooooooo`0000Wooooo00?oo`00ooooooooool0
1oooool01Ol0ofKoooooooooooooooooo`0000?ooooo00Ko0?mVoooooooo003oo`00ooooool0ofH2
ooooo`04ool00?ooooooooooo`3oIR7ooooo00?o0000ooooooooool01Oooool000Oooooo00?o0000
ooooooooool04Oooool00ol0ofKoo`00ooooo`0]ooooo`03o`3oI_ooooooo`0000Cooooo00?o0?mV
ool00?oo00003?ooool00ol0ofKoooooool0000<ooooo`03o`3oI_ooooooo`0001Wooooo0_l0ofH:
ooooo`04o`3oI_oooooo0?mVool000[ooooo1_l0ofH4ool00003o`000?oooooooooo00Oooooo00Co
o`00ooooool0ofKo00000oooool2ool00004o`3oI_oooooo0?mVool000Oooooo00Co0?mVoooooooo
003oo`002?ooool3o`3oIPCoo`0000Co0?mVoooooooooooooooo0_l0ofH00oooooooo`00ool00002
ooooo`03o`3oI_ooooooo`0000Cooooo0ol0ofH00ooo003oooooooooo`0<ooooo`03ool00?l0ofKo
oooo00Wooooo00?o0?mVool00?ooool02Oooool00ooo003oooooooooo`06ooooo`03o`3oI_oo003o
oooo00;ooooo00Goo`00ooooooooooooooooo`3oIP02ooooo`;o0?mV0oooool00ooo003oooooo`3o
IP0Qooooo`03o`000?oooooooooo00Gooooo0006ooooo`03o`000?oooooooooo01;ooooo00?o0?mV
ool00?ooool0;Oooool00ol0ofKoooooool00004ooooo`03o`3oI_oo003ooooo00_ooooo00?o0?mV
oooooooo00003Oooool00ol0ofKoooooool0000Iooooo`03o`3oI_oooooooooo00[ooooo00?o0?mV
ooooooooool04?ooool2o`3oIP03ooooool0ofKo000000Wooooo00Coo`00ooooool0ofKo00001Ooo
ool01?oo003o0?mVoooooooo0006ooooo`Go0?mV00?oo`00ooooooooool01?ooool01?l0ofKooooo
ool00?ooool2ool00003o`3oI_oo003o0?mV00Gooooo0_l0ofH2ool00003ooooool0ofKoo`0000Go
oooo00Co0?mVoooooooooooo0?mV3Oooool00ooo003oooooooooo`0:ooooo`03o`3oI_oo003ooooo
00Wooooo00?oo`00ooooooooool01oooool01_l0ofKoo`00ooooooooooooo`00o`3oIP;ooooo00?o
0?mVooooool0ofH00_ooool01_l0ofKooooooooooooo003oooooo`3oIR7ooooo00?o0000oooooooo
ool01Oooool000Kooooo00?o0000ooooooooool04Oooool00ol0ofKoo`00ooooo`0^ooooo`03o`3o
I_ooooooo`0000?ooooo0_l0ofH00ooo003oooooooooo`0:ooooo`03o`3oI_ooooooo`0000gooooo
00?o0?mVoooooooo00006?ooool00ol0ofKoo`00ooooo`0Rooooo`03o`000?oo003ooooo00Oooooo
00Coo`00ooooool0ofKo00001?ooool01?oo003o0?mVooooool0ofH2ool000Wooooo00?o0?mVool0
0?ooool01Oooool00ol0ofKoooooool00002ool000;ooooo0_l0ofH7ooooo`03ool00?l0ofKo0?mV
00?o0?mV1oooool01Ooo003o0?mVoooooooooooo0?mV00Cooooo1Ol0ofH01Ooo003o0?mVool00?oo
oooo0?mV00Sooooo00?o0?mVool00?ooool02_ooool00ooo003oooooooooo`07ooooo`06o`3oI_oo
003ooooooooooooo003o0?mV0_ooool01Ol0ofKooooooooooooooooo0?mV00?ooooo00?oo`00o`3o
I_ooool08?ooool00ol0003oooooooooo`05ooooo`001_ooool00ol0003oooooooooo`0Aooooo`03
o`3oI_oo003ooooo02gooooo00?o0?mVoooooooo00001?ooool2o`3oIP03ool00?oooooooooo00[o
oooo00?o0?mVool00?ooool03Oooool00ol0ofKoo`00ooooo`0Hooooo`03o`3oI_oo003ooooo02;o
oooo00?o0000ool00?ooool01oooool01?oo003o0?mVo`3oI_l00003ooooo`03o`3oI_oo003ooooo
00?o0?mV00?oo`00ooooooooool01oooool00ol0ofKoo`00ooooo`05ooooo`05o`3oI_ooooooo`00
oooooooo00000oooool00ol0ofKoooooooooo`05ooooo`03ool00?ooooooo`0000;oo`000_l0ofH6
ooooo`06ool00?l0ofKoooooooooool0ofKooooo0ooo00000oooooooo`00o`3oIP02ool000;o0?mV
0_oo00000ol0ofKoooooooooo`07ooooo`03ool00?oooooooooo00[ooooo00?oo`00ooooooooool0
1oooool2o`3oIP04oooooooo003oooooo`3oIPKooooo00Go0?mVooooooooooooo`00o`3oIP0Qoooo
o`03o`000?oooooooooo00Gooooo0006ooooo`03o`000?oooooooooo017ooooo00?o0?mVool00?oo
ool0;Oooool00ol0ofKoooooool00004ooooo`03o`3oI_oo003oo`0000_ooooo00?o0?mVoooooooo
00003Oooool00ol0ofKoooooool0000Hooooo`03o`3oI_oo003ooooo02?ooooo00?o0000o`3oI_oo
00000oooool2ool00003ooooool0ofKoo`0000;ooooo00Wo0000oooooooooooo0?mVoooooooo003o
ooooo`3oI_ooool00_l0ofH9ooooo`03o`3oI_oo003ooooo00Gooooo00Ko0?mVoooooooo003ooooo
o`3oI_oo000:ooooo`;oo`000ol0ofH00ooooooo0?mVo`3oIP05ooooo`04ool00?l0ofKooooooooo
o`;o0?mV00?oo`00o`3oI_l0ofH00_oo00001ooooooo0?mVo`3oI_oo003o0?mVooooool0ofH00ooo
0008ooooo`03ool00?oooooooooo00Wooooo00?o0?mVool00?ooool02Oooool01Ol0ofKoo`00oooo
oooooooo0?mV00Gooooo00Go0?mVool00?ooooooo`00o`3oIP0Qooooo`03o`000?oooooooooo00Go
oooo0006ooooo`03o`000?oooooooooo017ooooo00?o0?mVooooooooool0;Oooool00ol0ofKooooo
ool00004ooooo`03o`3oI_oo003oo`0000_ooooo00?o0?mVool00?ooool03Oooool00ol0ofKooooo
ool0000Hooooo`03o`3oI_oo003ooooo02?ooooo00Co0000o`3oI_oo003ooooo0_oo0002ooooo`03
ool00?ooooooo`0000;ooooo00Go0000ooooool0ofKoooooool00002ooooo`04o`3oI_oooooo0?mV
o`3oIPWooooo00?o0?mVool00?ooool01_ooool01Ol0ofKoo`00o`3oI_l0ofKoo`0000Wooooo2?l0
ofH6ooooo`05ool00?l0ofKoooooooooool0ofH00_oo0002o`3oIP03oooooooo003ooooo00;o0?mV
00?oo`00ooooooooool00_l0ofH00oooooooo`00ooooo`07ooooo`04ool00?l0ofKo0?mVo`3oIPWo
oooo00?o0?mVool00?ooool02Oooool01?l0ofKoo`00ooooool0ofH6ooooo`04o`3oI_oo003ooooo
ool0027ooooo00?o0000ooooooooool01Oooool000Kooooo00?o0000ooooooooool04Oooool00ol0
ofKoooooooooo`0/ooooo`03o`3oI_ooooooo`0000Cooooo0_l0ofH00oooooooo`00ooooo`0:oooo
o`03o`3oI_oo003ooooo00gooooo0ol0ofHHooooo`03o`3oI_oo003ooooo02?ooooo00Co0000oooo
ool0ofKoo`000oooool02ol0ofKoo`00ooooooooooooo`00ooooool0003oooooo`3oI_ooooooo`00
00;ooooo00Coo`00o`3oI_oooooo0?mV2Oooool00ooo003oooooooooo`06ooooo`05o`3oI_oo003o
0?mVo`3oI_oo00001oooool5o`3oIP05ool00?l0ofKoooooooooool0ofH01_ooool01_oo003o0?mV
ooooool0ofKoo`00ooooo`?o0?mV0_ooool01?oo003oooooool00?l0ofH2ooooo`?o0?mV0_oo0007
ooooo`Koo`000_l0ofH5ooooo`03o`3oI_oo003ooooo00[ooooo00Co0?mVoooooooooooo0?mV1_oo
ool01?l0ofKoooooool00?l0ofHPooooo`03o`000?oooooooooo00Gooooo0006ooooo`03o`000?oo
oooooooo017ooooo00?o0?mVooooooooool0;?ooool00ol0ofKoooooool00004ooooo`;o0?mV00?o
ooooool00?ooool02_ooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo01Gooooo00?o
0?mVool00?oo00009?ooool01?l0003oooooo`3oI_ooool8o`3oIP06ooooool0003oooooooooool0
ofKoo`000oooool00ol0ofKoooooo`3oIP09ooooo`03ool00?l0ofKooooo00Kooooo00Goo`00oooo
ooooooooooooo`3oIP0=ooooo`04ool00?ooooooooooo`3oIP?ooooo00?o0?mVool00?oo00000_l0
ofH01?ooooooo`00oooooooo0003o`3oIP?ooooo00?oo`00ooooooooool00_ooool01_l0ofKooooo
ooooool0ofKoooooool000cooooo0ooo0002o`3oIP04ooooool0ofKoooooool000_ooooo00Coo`00
o`3oI_oooooo0?mV1_ooool01?l0ofKoo`00oooooooo000Qooooo`03o`000?oooooooooo00Cooooo
0006ooooo`03o`000?oooooooooo013ooooo00?oo`00o`3oI_ooool0;Oooool00ol0ofKoooooool0
0004ooooo`;o0?mV00?oooooool00?ooool02_ooool00ooo003oooooooooo`0>ooooo`03ool00?l0
ofKooooo01Oooooo0_oo0002o`3oIR;ooooo00?o0000ooooooooool00_l0ofH5ooooo`04ool00?l0
ofKo0?mVo`0000;ooooo00?o0?mVool00?ooool00_ooool00ol0ofKoooooo`3oIP09ooooo`03ool0
0?l0ofKooooo00Kooooo00Goo`00o`3oI_ooooooooooo`3oIP0=ooooo`;oo`0000?oooooo`3oI_l0
ofH00_l0ofH01?oo003oooooool00?oo0003o`3oIP03ool00?l0ofKoo`0000;oo`001?ooool00ol0
ofKoooooooooo`05ooooo`03o`3oI_ooooooo`0000kooooo00Coo`00o`3oI_oooooo0?mV0_ooool0
0ooo003oooooooooo`09ooooo`;oo`0000?oooooo`3oI_ooool01Oooool00ol0ofKoo`00ool0000Q
ooooo`03o`000?oooooooooo00Cooooo0006ooooo`03o`000?oooooooooo013ooooo00?oo`00o`3o
I_ooool0;?ooool00ol0ofKoooooool00004ooooo`05o`3oI_oo003o0?mVoooooooo00002_ooool0
0ol0ofKoo`00ooooo`0?ooooo`03ool00?l0ofKooooo01Oooooo00?oo`00o`3oI_ooool08oooool0
0ol0003oooooooooo`02o`3oIP?ooooo0_l0ofH01?oo003o0?mVool00?l00002ooooo`03o`3oI_oo
003ooooo00;ooooo1?oo00000ooooooo0?mVooooo`05ooooo`03ool00?oooooooooo00Kooooo00Go
o`00o`3oI_ooooooooooo`3oIP0=ooooo`;oo`0000Ooooooo`3oI_ooooooooooool00?l0ofKoo`00
00;o0?mV00Coooooo`3oI_l0ofKo0?mV0_oo0002o`3oIP;oo`000_ooool00ol0ofKoo`00ooooo`06
ooooo`03o`3oI_oo003ooooo00gooooo00?oo`00o`3oI_l0ofH00ol0ofH5ool00003o`3oI_oooooo
oooo00Cooooo0_oo00000ooooooo0?mVooooo`05ooooo`04o`3oI_ooooooo`00ool0023ooooo00?o
0000ooooooooool01?ooool000Kooooo00?o0000ooooooooool04?ooool00ooo003o0?mVooooo`0/
ooooo`03o`3oI_ooooooo`0000Cooooo0_l0ofH2ooooo`03ool00?oooooooooo00Sooooo00?oo`00
ooooooooool03_ooool00ooo003oooooo`3oIP0Hooooo`03o`3oI_oooooooooo02?ooooo00Co0000
oooooooooooooooo1?l0ofH01_ooooooo`00ool00?l0ofKoooooo`0000;ooooo00?oo`00o`3oI_oo
ool00oooool2o`3oIP?oo`001Oooool2o`3oIPSooooo00Koo`00o`3oI_ooooooooooool00?l0ofH<
ooooo`;oo`0000?oooooo`3oI_ooool01?oo0002o`3oIP;ooooo1?l0ofH00ooo003oooooool00003
ool000;o0?mV1oooool00ooo003o0?mVooooo`0=ooooo`03ool00?oooooo0?mV00Oooooo00?oo`00
o`3oI_ooool01_ooool2ool00003ooooool0ofKooooo00Gooooo00Co0?mVool00?oo003o0?mV7ooo
ool00ol0003oooooooooo`04ooooo`001_ooool00ol0003oooooooooo`0@ooooo`03ool00?oooooo
oooo02cooooo00?o0?mVoooooooo00001?ooool01Ooo003o0?mVooooooooooooo`0000[ooooo00?o
o`00ooooooooool03_ooool00ooo003o0?mVooooo`0Gooooo`03o`3oI_oo003ooooo02Cooooo00Go
0000ooooooooooooooooo`3oIP03ooooo`06ool00?ooooooo`00o`3oI_oooooo00000_ooool00ooo
003oooooooooo`03ooooo`;o0?mV00Coo`00o`3oI_ooooooo`001Oooool00ooo003o0?mVooooo`06
ooooo`06ool00?l0ofKooooooooooooo003o0?mV3?ooool2ool00007ooooool0ofKooooooooooooo
003oooooo`3oIP05ooooo`04o`3oI_oo003o0?mVo`3oIP;oo`000_l0ofH2ool00003o`3oI_oooooo
oooo00Gooooo0_oo00000ol0ofKoooooooooo`0;ooooo`03ool00?oooooo0?mV00Oooooo00?o0?mV
ool00?ooool01_ooool2ool00003ooooool0ofKooooo00Gooooo00Go0?mVool00?ooooooo`00o`3o
IP0Nooooo`03o`000?oooooooooo00Cooooo0006ooooo`03o`000?oooooooooo013ooooo00?oo`00
ooooooooool0:oooool00ol0ofKoooooool00005ooooo`05ool00?l0ofKooooooooooooo00002_oo
ool00ooo003oooooooooo`0>ooooo`03ool00?l0ofKooooo01Kooooo0_l0ofH00ooo003ooooooooo
o`0Rooooo`07o`3oI_l0003o0?mVo`3oI_oooooo0?mVooooo`02ool000?ooooo00Ko0?mVooooool0
003oooooo`3oI_oo0006ooooo`;o0?mV0oooool00ooo003oooooooooo`04ooooo`;o0?mV1_ooool0
1Ooo003ooooooooooooo003o0?mV00_ooooo00Oo0?mVool00?oo003oooooo`3oI_ooooooo`0000;o
0?mV1_ooool00ol0ofKoo`00ooooo`05o`3oIP03oooooooo003ooooo00Wooooo0_oo000<ooooo`03
ool00?l0ofKo0?mV00Oooooo00?o0?mVool00?ooool01_ooool01?l0ofKoo`00ool00?l0ofH6oooo
o`06o`3oI_ooooooo`00oooooooo003o0?mV7Oooool00ol0003oooooooooo`04ooooo`001_ooool0
0ol0003oooooooooo`0@ooooo`03ool00?oooooooooo02_ooooo00?o0?mVoooooooo00001?ooool0
0ol0ofKoo`00o`3oIP02ooooo`03ool00?oooooooooo00Oooooo00?oo`00o`3oI_ooool03_ooool0
0ooo003oooooo`3oIP0Iooooo`03o`3oI_oooooooooo02?ooooo00?o0000o`3oI_l0ofH00ol0ofH5
ooooo`06o`3oI_oooooo0000ooooool0ofKoo`001_ooool4o`3oIP;ooooo00?oo`00ooooooooool0
1?ooool00ooo003o0?mVooooo`04ooooo`05ool00?ooooooooooool00?l0ofH02oooool00ol0ofKo
o`00ool00002o`3oIP03oooooooo003o0?mV00Oooooo00?o0?mVool00?l0ofH01ol0ofH00ooo003o
ooooooooo`09ooooo`03o`3oI_oooooooooo00Wooooo00?o0?mVooooooooool01oooool00ol0ofKo
ooooool00006ooooo`05o`3oI_oo003oooooool00?l0ofH01Oooool01ol0ofKoooooool00?oooooo
o`00ooooool0ofH07?ooool00ol0003oooooooooo`04ooooo`001_ooool00ol0003oooooooooo`0@
ooooo`03o`3oI_oooooooooo02_ooooo00?o0?mVoooooooo00001?ooool00ooo003oooooo`3oIP02
ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03_ooool00ooo003oooooo`3oIP0I
ooooo`03ool00?l0ofKooooo02?ooooo00Go0000ool00?oo003o0?mVool00006ooooo`03o`3oI_oo
oooo000000;ooooo00Co0?mVool00?oooooooooo0ol0ofH2ool00006ooooool0ofKoooooooooool0
ofKoo`001oooool01_l0ofKooooooooooooooooo0?mVool000;ooooo00?oo`00ooooooooool02ooo
ool01ol0ofKoo`00o`3oI_l0ofKoooooool00?l0ofH01_ooool00ol0ofKoo`00o`3oIP07ooooo`03
o`3oI_ooooooo`0000[ooooo00?o0?mVooooooooool02Oooool00ol0ofKoooooooooo`08ooooo`03
o`3oI_oo003ooooo00Kooooo00Co0?mVool00?oo003o0?mV1?ooool01?l0ofKooooooooooooo0002
ooooo`03ool00?oooooo0?mV01_ooooo00?o0000ooooooooool01?ooool000Kooooo00?o0000oooo
ooooool04?ooool00ol0ofKoooooooooo`0[ooooo`03o`3oI_ooooooo`0000Cooooo00Go0?mVoooo
ool0ofKoooooool0000:ooooo`03ool00?oooooooooo00gooooo00Coo`00oooooooooooo0?mV6Ooo
ool00ooo003o0?mVooooo`0Sooooo`04o`000?oo003oooooool000Oooooo00?o0?mVooooool00000
0_ooool00ol0ofKoo`00ooooo`03ooooo`?o0?mV00Koo`00ooooool0ofKoooooo`3oI_oo0008oooo
o`;o0?mV00?oooooo`3oI_oo00000_ooool00ooo003o0?mVo`3oIP0;ooooo`07o`3oI_oo003o0?mV
o`3oI_oo003oooooo`3oIP05ooooo`;o0?mV00?oo`00ooooooooool01Oooool2o`3oIP;ooooo00?o
o`00ooooooooool01_ooool00ol0ofKoo`00ooooo`0;ooooo`03o`3oI_oooooooooo00Sooooo00?o
0?mVool00?ooool01Oooool01?l0ofKoo`00ooooool0ofH4ooooo`09o`3oI_oooooooooooooooooo
003oooooool00?oooooo0?mV01_ooooo00?o0000ooooooooool01?ooool000Kooooo00?o0000oooo
ooooool04?ooool00ol0ofKoooooooooo`0[ooooo`03o`3oI_ooooooo`0000Cooooo0_l0ofH2oooo
o`03ool00?oooooooooo00Oooooo00?oo`00o`3oI_ooool03Oooool01?oo003oooooooooool0ofHJ
ooooo`03o`3oI_oo003ooooo02?ooooo00?o0000oooooooo00002?ooool00ol0ofKoooooo`000002
ooooo`03o`3oI_oo003ooooo00Gooooo00Oo0?mVool00?oooooo0?mVooooool0ofKoo`0000[ooooo
00?o0?mVool00?oo00000oooool00ooo003o0?mVooooo`0:ooooo`;oo`000_l0ofH00ooo003ooooo
o`3oIP03ooooo`;o0?mV00?oooooo`3oI_oo00002?ooool00ooo003o0?mVo`3oIP04o`3oIPGooooo
00?o0?mVoooooooo00002oooool00ooo003o0?mVooooo`09ooooo`03o`3oI_oooooooooo00Cooooo
00Go0?mVool00?ooooooo`00o`3oIP03ooooo`05o`3oI_oooooooooooooooooo00000_ooool00ooo
003oooooo`3oIP0Jooooo`03o`000?oooooooooo00Cooooo0006ooooo`03o`000?oooooooooo013o
oooo00?o0?mVooooooooool0:oooool00ol0ofKoooooool00004ooooo`;o0?mV0_ooool00ooo003o
ooooooooo`07ooooo`03ool00?l0ofKooooo00gooooo00?oo`00ooooool0ofH06_ooool00ol0ofKo
ooooool0000Tooooo`03o`000?oo003o0?mV00Wooooo00?o0?mVo`000?ooool00_ooool00ooo003o
ooooooooo`06ooooo`06ool00?oooooo0?mVo`3oI_ooooooo`002_ooool00ol0ofKoo`00ooooo`03
ooooo`03ool00?l0ofKooooo00_ooooo00Koo`00o`3oI_oo003oooooo`3oI_ooool2o`3oIP?ooooo
00?oo`00ooooooooool01oooool01?oo003o0?mVo`3oI_oo0002o`3oIP03ool00?l0ofKooooo00?o
oooo00Co0?mVoooooooo003oo`002_ooool00ooo003o0?mVooooo`09ooooo`03o`3oI_oo003ooooo
00Gooooo00Co0?mVoooooooooooo0?mV1?ooool01?l0ofKooooooooooooo0003ooooo`03ool00?oo
oooo0?mV01Wooooo00?o0000ooooooooool01?ooool000Kooooo00?o0000ooooooooool03oooool0
0ooo003o0?mVooooo`0/ooooo`03o`3oI_ooooooo`0000Cooooo0_l0ofH2ooooo`03ool00?oooooo
oooo00Oooooo00?o0?mVooooooooool03?ooool00ooo003oooooo`3oIP0Jooooo`Co0?mV00?oo`00
ooooooooool08Oooool00ol0003oooooo`3oIP0:ooooo`06o`3oI_ooooooooooooooool0ofKoo`00
2?ooool01?oo003o0?mVo`3oI_ooool3ool000Sooooo0_l0ofH2ool000;ooooo00?oo`00ooooool0
ofH02oooool00ooo003o0?mVool00003o`3oIPGooooo00?oo`00ooooooooool01Oooool00ol0ofKo
o`00ooooo`03ooooo`03ool00?oooooo0?mV00;o0?mV0_ooool2o`3oIP;oo`0000?o0?mVool00?l0
ofH00_l0ofH6ooooo`03ool00?l0ofKooooo00[ooooo00?o0?mVooooooooool01?ooool01Ol0ofKo
ooooooooool0ofKoo`0000Cooooo00?o0?mVoooooooo00001?ooool00ooo003o0?mVooooo`0Hoooo
o`03o`000?oooooooooo00Cooooo0006ooooo`03o`000?oooooooooo00oooooo00?oo`00o`3oI_oo
ool0;?ooool00ol0ofKoooooool00004ooooo`;o0?mV00?oooooool00?ooool02?ooool00ol0ofKo
o`00ooooo`0=ooooo`03ool00?l0ofKooooo01kooooo00?o0?mVool00?l0ofH08Oooool00ol0003o
0?mVooooo`0:ooooo`06ool00?l0ofKoooooooooool0ofKoo`002?ooool01?oo003o0?mVo`3oI_l0
ofH3ooooo`03ool00?oooooooooo00Gooooo00Go0?mVooooool0ofKoooooool00002ooooo`03ool0
0?l0ofKooooo00_ooooo0_oo00000ol0ofKoooooooooo`04ooooo`?o0?mV1?ooool2o`3oIP03ool0
0?oooooooooo00?ooooo00Coo`00oooooooo003o0?mV0ooo0002o`3oIP03oooooooo003o0?mV00;o
0?mV00?oo`00o`3oI_ooool01Oooool00ooo003o0?mVooooo`0;ooooo`03o`3oI_oooooooooo00?o
oooo00Go0?mVooooooooooooooooo`3oIP05ooooo`03o`3oI_ooooooo`0000Cooooo00?oo`00o`3o
I_ooool05oooool00ol0003oooooooooo`04ooooo`001_ooool00ol0003oooooooooo`0?ooooo`03
ool00?l0ofKooooo02cooooo00?o0?mVoooooooo00001?ooool2o`3oIP03oooooooo003ooooo00So
oooo00?o0?mVool00?ooool03Oooool00ol0ofKoooooooooo`0Oooooo`03ool00?l0ofKooooo023o
oooo00?o0000ooooooooool02_ooool00ol0003oo`00o`3oIP02ooooo`03o`3oI_oooooooooo00Oo
oooo00?oo`00o`3oI_l0ofH00ol0ofH00ooo003oooooooooo`05ooooo`05o`3oI_ooooooo`00o`3o
I_oo00000oooool00ooo003o0?mVooooo`0:ooooo`?oo`000_ooool4o`3oIP;ooooo00Go0?mVoooo
ooooooooooooo`3oIP02ooooo`03ool00?oooooooooo00Cooooo0_oo0004o`3oIP06ool00?l0ofKo
0?mVool00?oooooo0?mV0_ooool00ooo003o0?mVooooo`02o`3oIP;ooooo0_oo000<ooooo`03o`3o
I_oooooooooo00?ooooo00Koo`00ooooooooooooooooo`3oI_oo0005ooooo`03o`3oI_oo003ooooo
00Cooooo00?oo`00o`3oI_ooool05_ooool00ol0003oooooooooo`04ooooo`001_ooool00ol0003o
ooooooooo`0?ooooo`03ool00?l0ofKooooo02cooooo00?o0?mVoooooooo00001?ooool2o`3oIP03
oooooooo003ooooo00Oooooo00?o0?mVoooooooo00003_ooool00ooo003oooooooooo`0Pooooo`03
ool00?oooooooooo01kooooo00?o0?mVo`000?ooool02oooool01_l0003oooooool00?l0ofKooooo
ool000[ooooo0_oo00001Ooooooo0?mVooooool0ofKoo`0000Oooooo00Co0?mVool00?oooooo0?mV
0oooool00ooo003o0?mVooooo`0:ooooo`;o0?mV2?oo00000ooooooo0?mVooooo`02ooooo`04o`3o
I_ooooooooooool000Oooooo0_oo00002?l0ofKooooooooooooooooo0?mVoooooooo003o0?mV1?oo
ool01Ooo003oooooo`3oI_oo003o0?mV00;ooooo00?o0?mVool00?ooool02_ooool00ooo003o0?mV
ooooo`03ooooo`06ool00?ooooooooooooooool0ofKoo`001_ooool00ooo003oooooooooo`04oooo
o`03ool00?oooooooooo01Gooooo00?o0000ooooooooool01?ooool000Kooooo00?o0000oooooooo
ool03oooool00ooo003o0?mVooooo`0/ooooo`03o`3oI_ooooooo`0000Cooooo00?oo`00o`3oI_oo
00002?ooool01?l0ofKooooooooooooo000=ooooo`03ool00?oooooooooo027ooooo00?oo`00o`3o
I_ooool07Oooool00ol0ofKoo`00o`00000<ooooo`06o`000?ooooooo`00o`3oI_ooooooo`003?oo
ool01_oo003o0?mVoooooooooooo0?mVool000Kooooo00Go0?mVool00?ooooooo`00o`3oIP03oooo
o`03ool00?l0ofKooooo00Wooooo0ol0ofH01Ooo003oooooooooooooooooo`0000;ooooo0_oo0000
1?l0ofKoooooooooool0ofH2ooooo`03ool00?oooooooooo00Gooooo00?o0?mVoooooooo00001Ooo
ool00ooo003o0?mVooooo`03ooooo`03o`3oI_oo003o0?mV00;oo`000_ooool00ol0ofKoooooool0
000;ooooo`03ool00?l0ofKooooo00;ooooo00Koo`00ooooooooooooooooo`3oI_oo0006ooooo`03
ool00?l0ofKooooo00Cooooo00?oo`00o`3oI_ooool05Oooool00ol0003oooooooooo`04ooooo`00
1_ooool00ol0003oooooooooo`0?ooooo`03ool00?l0ofKooooo02cooooo00?o0?mVoooooooo0000
0oooool01?oo003o0?mVo`3oI_oo0008ooooo`04o`3oI_ooooooooooool000gooooo00?oo`00oooo
ooooool08?ooool00ooo003oooooo`3oIP0Nooooo`03o`3oI_oo003o000000cooooo00Go0000oooo
ooooooooo`00o`3oIP0>ooooo`05ool00?l0ofKoooooooooool0ofH01_ooool00ol0ofKoooooool0
0003ool000;ooooo00?oo`00o`3oI_ooool02Oooool01ooo003o0?mVooooool0ofKoo`00oooooooo
00001?ooool01?oo003o0?mVooooooooool3ool000Sooooo00?o0?mVoooooooo00001Oooool00ooo
003o0?mVooooo`04ooooo`04o`3oI_ooooooooooool000;ooooo00?o0?mVoooooooo00002oooool0
0ooo003o0?mVooooo`02ooooo`06o`3oI_oo003oooooooooool0ofKoo`001_ooool00ooo003ooooo
o`3oIP05ooooo`03ool00?l0ofKo0?mV01Cooooo00?o0000ooooooooool01?ooool000Kooooo00?o
0000ooooooooool03oooool00ooo003o0?mVooooo`0/ooooo`03o`3oI_ooooooo`0000?ooooo00Co
o`00o`3oI_l0ofKoo`002Oooool00ol0ofKoooooool0000=ooooo`03ool00?oooooooooo023ooooo
00?oo`00ooooool0ofH07oooool00ooo003o0000ooooo`0;ooooo`05o`000?ooooooooooool00?l0
ofH03oooool01Ooo003o0?mVoooooooooooo0?mV00Cooooo00Co0?mVooooooooooooo`000oooool3
ool00003o`3oI_oooooooooo00Kooooo0_l0ofH00ooo003o0?mVo`3oIP02o`3oIP03ool00?oooooo
oooo00Cooooo0ooo00000ooooooo0?mVool0000:ooooo`03ool00?l0ofKooooo00?ooooo00?oo`00
ooooooooool01?ooool00ol0ofKoooooool00003ooooo`03o`3oI_ooooooo`0000cooooo00Koo`00
o`3oI_ooooooooooo`3oI_oo0003ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooool0ofH0
1Oooool00ooo003oooooo`3oIP0Cooooo`03o`000?oooooooooo00Cooooo0006ooooo`03o`000?oo
oooooooo00oooooo00?oo`00o`3oI_ooool0;?ooool00ol0ofKoooooool00003ooooo`04ool00?l0
ofKo0?mVool000Wooooo00?o0?mVoooooooo00003?ooool00ol0ofKoo`00ooooo`0Qooooo`03ool0
0?l0ofKooooo01oooooo00?oo`00o`000?ooool02oooool01Ol0003oooooo`3oI_oo003o0?mV013o
oooo00Goo`00o`3oI_oooooo0?mVool00003ooooo`05o`3oI_oooooooooooooooooo00001?ooool2
ool000;o0?mV1_ooool00ol0ofKoooooool00002ooooo`03o`3oI_oo003o0?mV00Kooooo0_oo0003
ooooo`03o`3oI_oooooooooo00Sooooo00?oo`00o`3oI_ooool00oooool2ool00003ooooool0ofKo
oooo00;ooooo00?o0?mVoooooooo00000oooool00ol0ofKoo`00ooooo`0<ooooo`06ool00?oooooo
0?mVooooool0ofKoo`000oooool00ooo003oooooooooo`05ooooo`03ool00?oooooo0?mV00Kooooo
00?oo`00ooooool0ofH04_ooool00ol0003oooooooooo`04ooooo`001_ooool00ol0003ooooooooo
o`0?ooooo`03ool00?l0ofKooooo02cooooo00?o0?mVoooooooo00000oooool00ooo003o0?mVo`3o
IP0:ooooo`03o`3oI_ooooooo`0000cooooo00?o0?mVool00?ooool08_ooool00ooo003ooooooooo
o`0Nooooo`03ool00?l0003ooooo00_ooooo00Ko0000ool00?ooooooooooool00?l0ofH@ooooo`04
o`3oI_ooooooooooool000?ooooo00?o0?mVooooooooool00_ooool01_oo003ooooooooooooooooo
o`00ooooo`;o0?mV1oooool00ooo003oooooooooo`02ool00003o`3oI_oo003ooooo00Gooooo0_oo
00000ooooooo0?mVo`3oIP02o`3oIPWooooo00Woo`00o`3oI_ooooooo`00oooooooo003o0?mVoooo
ool0ofH01Oooool00ol0ofKoo`00ooooo`02ooooo`03o`3oI_oo003ooooo00cooooo00?oo`00oooo
ool0ofH00_ooool01Ol0ofKoooooooooooooooooo`0000Oooooo00?oo`00ooooool0ofH01oooool0
0ooo003oooooo`3oIP0Aooooo`03o`000?oooooooooo00Cooooo0005ooooo`03o`000?oooooooooo
013ooooo00?oo`00o`3oI_ooool0;?ooool00ol0ofKoooooool00003ooooo`03ool00?l0ofKo0?mV
00_ooooo00?o0?mVool00?ooool02oooool00ol0ofKoo`00ooooo`0Rooooo`03o`3oI_oo003ooooo
01kooooo00?oo`00o`000?ooool02oooool01_l0ofKoo`00ooooool0ofKoo`00o`3oIQ3ooooo00Go
o`00o`3oI_ooooooooooool00002ooooo`03o`3oI_oooooooooo00?ooooo00Goo`00oooooooooooo
o`00ooooo`02o`3oIPOooooo0ooo00001Ooooooo0?mVo`3oI_oo003ooooo00?o0?mV00Goooooool0
0?l0ofKoo`00o`3oIP0<ooooo`;o0?mV1?oo00000ooooooo0?mVo`3oIP06ooooo`03o`3oI_oooooo
o`0000;ooooo00?o0?mVool00?ooool03Oooool01_oo003o0?mVooooooooooooo`00o`3oIP;ooooo
00?o0?mVooooooooool01_ooool00ooo003oooooo`3oIP07ooooo`03ool00?oooooo0?mV013ooooo
00?o0000ooooooooool01?ooool000Gooooo00?o0000ooooooooool04?ooool00ooo003o0?mVoooo
o`0/ooooo`03o`3oI_ooooooo`0000?ooooo00?oo`00o`3oI_l0ofH02oooool00ol0ofKoo`00oooo
o`0;ooooo`03o`3oI_oo003ooooo02;ooooo00?oo`00o`3oI_ooool07_ooool00ooo003o0000o`3o
IP0:ooooo`05o`3oI_oo003oooooooooool0ofH00_oo00000ol0ofKoooooooooo`0=ooooo`05ool0
0?l0ofKooooooooooooo00000oooool00ol0ofKoooooooooo`02ooooo`07ool00?oooooooooooooo
oooo003oooooo`3oIP07ooooo`08ool00?ooooooooooo`3oI_oooooo0?mVoooooooo0003ooooo`?o
0?mV00?oooooool00?ooool02_ooool9o`3oIPSooooo1Ol0ofH00ooo003o0?mVooooo`0<ooooo`03
ool00?oooooo0?mV00;ooooo00Coo`00o`3oI_oooooo0?mV2?ooool00ooo003oooooo`3oIP08oooo
o`03ool00?oooooo0?mV00oooooo00?o0000ooooooooool01?ooool000Gooooo00?o0000oooooooo
ool04?ooool00ooo003oooooo`3oIP0/ooooo`03o`3oI_ooooooo`0000?ooooo00?oo`00o`3oI_l0
ofH02oooool00ol0ofKoo`00ooooo`0<ooooo`03o`3oI_oo003ooooo023ooooo00?oo`00o`3oI_l0
ofH07oooool00ooo003o0000o`3oIP09ooooo`03o`3oI_oo003o000000;ooooo00Co0?mVoooooooo
003oo`004?ooool01Ol0ofKoooooooooooooooooo`0000?ooooo00Go0?mVoooooooooooo0?mVool0
0004ooooo`03ool00?l0ofKo0?mV00Cooooo0_oo00001?oooooo0?mVooooool0ofH2ooooo`03o`3o
I_ooooooo`0000;ooooo00?oo`00o`3oI_ooool00ol0ofH>ooooo`04o`3oI_oo003oooooo`3oIPco
oooo00Co0?mVool00?oo003ooooo1Ol0ofH8ooooo`03ool00?oooooo0?mV00;ooooo00Goo`00o`3o
I_ooooooo`00o`3oIP08ooooo`03ool00?l0ofKooooo00Oooooo00?oo`00ooooool0ofH03oooool0
0ol0003oooooooooo`04ooooo`001Oooool00ol0003oooooooooo`0@ooooo`03ool00?oooooo0?mV
02cooooo00?o0?mVoooooooo00000oooool00ol0ofKoooooo`3oIP0<ooooo`03o`3oI_oooooooooo
00_ooooo00?o0?mVool00?ooool07_ooool3o`3oIR;ooooo00?o0000o`3oI_ooool01oooool01?l0
ofKoo`00ooooool00003ooooo`04o`3oI_oo003oooooool000oooooo00Koo`00o`3oI_oooooooooo
o`3oI_oo0003ooooo`04o`3oI_oooooo0?mVool000Gooooo0_l0ofH01ooooooo0?mVool00?oo003o
ooooool00?ooool00_l0ofH6ooooo`Soo`000_l0ofH=ooooo`;o0?mV3_ooool00ol0ofKoo`00ool0
0002ool000;ooooo00?o0?mVooooooooool01oooool02Ooo003o0?mVooooooooooooo`00o`3oI_oo
ooooo`00o`3oIP08ooooo`03ool00?l0ofKooooo00Oooooo00?oo`00o`3oI_ooool03oooool00ol0
003oooooooooo`04ooooo`001Oooool00ol0003oooooooooo`0@ooooo`03ool00?oooooo0?mV02co
oooo00?o0?mVoooooooo00000oooool00ol0ofKoooooo`3oIP0<ooooo`03o`3oI_oooooooooo00_o
oooo00?o0?mVool00?ooool07?ooool3o`3oIP03ool00?oooooooooo01kooooo0ol0ofH00ol0003o
o`00o`3oIP07ooooo`04o`3oI_oo003oooooo`0000?ooooo00Go0?mVool00?oooooo0?mVool0000>
ooooo`03ool00?l0ofKooooo00;ooooo00?oo`00ooooooooool01?l0ofH00ooo003oooooooooo`04
ooooo`03ool00?l0ofKoo`0000;ooooo0_l0ofH01?oo003oooooo`3oI_ooool3o`3oIP;ooooo0_oo
00000ol0ofKoooooooooo`03ooooo`;oo`0000?o0?mVooooooooool02_ooool00ol0ofKooooooooo
o`0>ooooo`07o`3oI_oooooooooooooooooo003oooooo`3oIP09ooooo`06ool00?l0ofKooooooooo
oooo003o0?mV0_ooool00ol0ofKoooooooooo`07ooooo`03ool00?l0ofKooooo00Kooooo00?oo`00
o`3oI_ooool03oooool00ol0003oooooooooo`04ooooo`001Oooool00ol0003oooooooooo`0@oooo
o`03ool00?oooooo0?mV02cooooo00?o0?mVoooooooo00000oooool00ol0ofKoooooo`3oIP0<oooo
o`03o`3oI_oooooooooo00_ooooo00?o0?mVool00?ooool07_ooool00ooo003o0?mVooooo`0Noooo
o`05o`3oI_ooooooooooooooool000000_oo0007ooooo`04o`3oI_oo003oooooo`0000Cooooo00Go
o`00oooooooooooo0?mVool0000>ooooo`03ool00?l0ofKooooo00;ooooo1_oo0003o`3oIPCooooo
00?o0?mVool00?ooool01?ooool01Ooo003o0?mVo`3oI_oooooo0?mV00;ooooo0_oo00000ol0ofKo
ooooo`3oIP05ooooo`;oo`0000?oooooo`3oI_ooool06_ooool2ool000?ooooo00?oo`00ooooool0
ofH02Oooool00ooo003o0?mVooooo`02ooooo`05ool00?ooooooooooool00?l0ofH02?ooool00ooo
003o0?mVooooo`06ooooo`03o`3oI_oo003ooooo00oooooo00?o0000ooooooooool01?ooool000Go
oooo00?o0000ooooooooool04?ooool00ooo003oooooo`3oIP0]ooooo`03o`3oI_ooooooo`0000;o
oooo00Co0?mVoooooooo003o0?mV2oooool00ooo003o0?mVooooo`0<ooooo`03ool00?oooooooooo
01cooooo1Ooo000Looooo`08o`3oI_oooooooooooooooooo003o0000ooooool0ofH7ooooo`04o`3o
I_ooooooooooo`0000Cooooo00Goo`00ooooooooooooooooool00002o`3oIPcooooo0_oo00000ol0
ofKoooooooooo`07ooooo`04ool00?oooooo0?mVool000;o0?mV00?oo`00o`3oI_oo00000_l0ofH3
ooooo`06ool00?l0ofKoooooo`3oI_ooooooo`000oooool2o`3oIPGooooo0_oo0002ooooo`03o`3o
I_oooooooooo01Oooooo00?o0?mVool00?ooool00oooool00ooo003o0?mVooooo`0:ooooo`05ool0
0?l0ofKooooooooooooo00000oooool00ol0ofKoooooooooo`07ooooo`03ool00?oooooooooo00Go
oooo00?o0?mVool00?ooool04?ooool00ol0003oooooooooo`03ooooo`001Oooool00ol0003ooooo
ooooo`0?ooooo`04ool00?ooooooooooo`3oIRgooooo00?o0?mVoooooooo00000_ooool01?oo003o
ooooool00?l0ofH;ooooo`03ool00?l0ofKooooo00cooooo00?o0?mVool00?ooool08?ooool00ol0
ofKoo`00ooooo`0Iooooo`03o`3oI_oooooooooo00;oo`0000?oooooo`000?ooool02?ooool01?l0
ofKoooooooooool00003ooooo`03ool00?oooooooooo00;ooooo00Coo`00oooooooooooo0?mV3Ooo
ool00ol0ofKoooooooooo`08ooooo`03ool00?ooooooo`0000;o0?mV00Koooooo`3oI_oo003oo`00
ooooool0ofH2ooooo`05ool00?oooooo0?mVo`3oI_oo00002oooool01Ooo003o0?mVool00?oooooo
0?mV01Wooooo00?o0?mVool00?ooool00oooool00ooo003o0?mVooooo`0:ooooo`05ool00?l0ofKo
0?mVoooooooo00000oooool00ol0ofKoooooooooo`07ooooo`03ool00?oooooooooo00Cooooo00?o
0?mVoooooooo00004Oooool00ol0003oooooooooo`03ooooo`001Oooool00ol0003oooooooooo`0?
ooooo`04ool00?ooooooooooo`3oIRgooooo00?o0?mVoooooooo00000_ooool01?oo003oooooool0
0?l0ofH;ooooo`03ool00?l0ofKooooo00gooooo00?o0?mVool00?ooool07oooool00ol0ofKooooo
ool0000Fooooo`;oo`0000Co0?mVool00?oo003oo`000oooool00ol0003oooooooooo`07ooooo`04
o`3oI_ooooooooooo`0000?ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`02o`3o
IPcooooo0_l0ofH9ooooo`?oo`0000Co0?mVoooooooooooo0?mV0_oo00001ol0ofKooooooooooooo
003oooooo`3oI_oo00003?ooool00ooo003o0?mVooooo`03ool000?ooooo0_l0ofHCooooo`;o0?mV
00Koo`00ooooooooooooooooool00?l0ofH;ooooo`03ool00?oooooooooo00;o0?mV00Goo`00oooo
ooooooooooooo`3oIP08ooooo`03ool00?oooooooooo00Cooooo00?o0?mVoooooooo00004Oooool0
0ol0003oooooooooo`03ooooo`001Oooool00ol0003oooooooooo`0?ooooo`04ool00?oooooooooo
o`3oIRkooooo00So0?mVool00?ooooooooooool00?ooooooo`00o`3oIP_ooooo00?oo`00o`3oI_oo
ool03_ooool00ol0ofKoo`00ooooo`0Oooooo`04o`3oI_ooooooo`00ool000Cooooo00?o0?mVoooo
ooooool03Oooool00ooo003oooooo`3oIP06ooooo`03o`000?oooooooooo00Kooooo00Go0?mVool0
0?ooooooooooo`000002ooooo`;oo`001Oooool2ool000?ooooo00?o0?mVooooooooool02oooool0
0ol0ofKoooooooooo`06ooooo`;oo`0000?o0?mVooooooooool00_ooool01?l0ofKoo`00ool00?l0
ofH2ooooo`03ool00?l0ofKooooo00cooooo00?oo`00ooooooooool00oooool2ool000?o0?mV4_oo
ool01?l0ofKoooooool00?oo0002ooooo`03ool00?l0ofKo0?mV00cooooo00Goo`00oooooooooooo
0?mVool00003ooooo`03o`3oI_oooooooooo00Kooooo00?o0?mVool00?ooool00oooool01?l0ofKo
oooooooooooo000Aooooo`03o`000?oooooooooo00?ooooo0005ooooo`03o`000?oooooooooo00oo
oooo00Coo`00oooooooooooo0?mV;_ooool02?l0ofKoo`00ooooooooooooo`00oooooooo003o0?mV
3?ooool00ooo003oooooooooo`0=ooooo`03o`3oI_oo003ooooo023ooooo0ol0ofH2ool000;ooooo
00?o0?mVooooooooool02oooool00ol0ofKoo`00ool00003o`3oIPGooooo00?o0000ooooooooool0
1Oooool00ol0ofKoo`00ooooo`02ooooo`04o`000?oo003oo`00o`3oIPSooooo00Goo`00oooooooo
ooooooooo`3oIP0=ooooo`03o`3oI_oooooooooo00Kooooo00?oo`00o`3oI_ooool00oooool01?l0
ofKoooooool00?oo0002ooooo`?o0?mV3?ooool00ooo003oooooooooo`04ooooo`05o`3oI_oooooo
o`00ooooool0ofH03?ooool00ooo003o0?mVo`3oIP02o`3oIP;oo`000oooool2o`3oIPoooooo00Co
o`00ooooool0ofKoo`000oooool00ol0ofKoo`00ooooo`06ooooo`03o`3oI_oo003ooooo00?ooooo
00Co0?mVooooooooooooo`004Oooool00ol0003oooooooooo`03ooooo`001Oooool00ol0003ooooo
ooooo`0?ooooo`04ool00?ooooooooooo`3oIRkooooo00So0?mVool00?ooooooooooool00?oooooo
o`00o`3oIPcooooo00?oo`00ooooooooool03_ooool00ol0ofKoo`00ooooo`0Rooooo`;o0?mV0_oo
00000ol0ofKoooooooooo`08ooooo`;o0?mV0_oo0002ooooo`04ool00?oooooo0?mVo`3oIPCooooo
00?o0000ooooooooool01?ooool00ol0ofKoooooool00003ooooo`04o`000?oo003oooooo`3oIPWo
oooo0_oo0002ooooo`03o`3oI_oooooooooo00[ooooo00?oo`00o`3oI_l0ofH01Oooool2ool00003
o`3oI_oooooooooo00;ooooo0_l0ofH01_oo003oooooool00?oooooo0?mVool000gooooo00?oo`00
ooooooooool01Oooool01?l0ofKoo`00ool00?l0ofH8ooooo`;o0?mV00?oo`00o`3oI_l0ofH00ooo
0005ooooo`03ool00?l0ofKooooo013ooooo00?oo`00o`3oI_oo00001?ooool00ol0ofKoo`00oooo
o`05ooooo`03o`3oI_oo003ooooo00;ooooo00?o0?mVooooooooool00_ooool00ooo003ooooooooo
o`0>ooooo`03o`000?oooooooooo00?ooooo0005ooooo`03o`000?oooooooooo00oooooo00Coo`00
oooooooooooo0?mV;_ooool02?l0ofKoo`00ooooool0ofKoo`00oooooooo003o0?mV3?ooool00ooo
003oooooooooo`0>ooooo`03o`3oI_ooooooo`0002Gooooo0ol0ofH7ooooo`;o0?mV0_oo000<oooo
o`03o`000?oooooooooo00?ooooo00?o0?mVoooooooo00001?ooool00ooo003o0?mVo`3oIP0<oooo
o`03ool00?oooooooooo00;o0?mV2oooool00ooo003oooooo`3oIP04ooooo`04ool00?l0ofKo0?mV
ool000?ooooo0_l0ofH01_oo003oooooo`3oI_oo003o0?mVool000gooooo00?o0?mVool00?ooool0
0oooool3ool00004oooooooo003o0?mVo`3oIPCooooo0ol0ofH00ooo003oooooooooo`02ooooo`03
ool00?oooooooooo00Cooooo00?oo`00o`3oI_ooool04Oooool00ol0ofKoo`00ool00004ooooo`03
o`3oI_oo003ooooo00Kooooo00Goo`00ooooooooooooooooo`3oIP04ooooo`03ool00?oooooooooo
00kooooo00?o0000ooooooooool00oooool000Gooooo00?o0000ooooooooool03oooool01?oo003o
ooooooooool0ofH_ooooo`07o`3oI_oo003o0?mVool00?ooooooo`00o`3oIP0<ooooo`03ool00?oo
oooooooo00oooooo00?o0?mVool00?ooool08oooool01Ol0ofKoooooo`3oI_oo003o0?mV00Gooooo
00?o0?mVool00?oo00003_ooool00ol0003oooooooooo`02ooooo`04o`3oI_ooooooo`00ooooo`?o
0?mV00?oo`00o`000?ooool03_ooool2ool000;ooooo00?o0?mVooooooooool02?ooool01?oo003o
ooooooooool0ofH3ooooo`;oo`0000?o0?mVool00?ooool00_ooool01_l0ofKoooooool00?oooooo
o`00o`3oIP;oo`003Oooool00ol0ofKoo`00ooooo`03ool00004ooooool0ofKoooooooooo`;oo`00
1Ol0ofH2ooooo`03ool00?oooooooooo00Wooooo00?oo`00o`3oI_ooool04_ooool00ol0ofKoo`00
ool00005ooooo`03o`3oI_oo003ooooo00Gooooo00Goo`00ooooooooooooooooo`3oIP04ooooo`03
ool00?oooooooooo00kooooo00?o0000ooooooooool00oooool000Gooooo00?o0000ooooooooool0
3oooool01?oo003oooooooooool0ofH_ooooo`07o`3oI_oo003o0?mVool00?ooooooo`00o`3oIP0<
ooooo`03ool00?oooooooooo00oooooo00?o0?mVoooooooo00008oooool3o`3oIP03oooooooo003o
0?mV00?ooooo0_oo000@ooooo`05o`000?ooooooooooooooool0ofH00_ooool2o`3oIP;ooooo00?o
o`00ooooool000004Oooool2ool00003ooooool0ofKooooo00Wooooo00Woo`00oooooooooooo0?mV
oooooooo003o0?mVoooooooo00000_l0ofH2ooooo`05o`3oI_ooooooo`00oooooooo00000_l0ofH2
ool000cooooo00?o0?mVool00?l0ofH01?l0ofH4ooooo`04ool00?l0ofKo0?mVo`3oIP;ooooo0_oo
000<ooooo`03o`3oI_oooooooooo01;ooooo0_l0ofH00oooooooo`00ooooo`03ooooo`03o`3oI_oo
003ooooo00Gooooo00?o0?mVool00?ooool00_ooool01Ol0ofKoooooooooooooooooo`00013ooooo
00?o0000ooooooooool00oooool000Gooooo00?o0000ooooooooool03oooool01?oo003ooooooooo
ool0ofH_ooooo`08o`3oI_oo003o0?mVool00?ooooooo`00ooooool0ofH;ooooo`03o`3oI_oooooo
oooo00oooooo00Co0?mVooooooooooooo`008Oooool2o`3oIPCooooo00Coo`00o`3oI_oo003oo`00
4_ooool01Ol0003ooooooooooooooooo0?mV00;oo`0000Co0?mVooooooooooooo`000_ooool00ol0
003oooooooooo`0Aooooo`03ool00?oooooo0?mV00[ooooo00Koo`00oooooooooooo0?mVool00?l0
ofH2ooooo`;oo`000ol0ofH01?ooooooo`00ool00?ooool4o`3oIP04ool00?l0ofKo0?mVo`3oIPSo
oooo00?o0?mVool00?l0ofH02Oooool00ooo003oooooo`3oIP02ool000gooooo00?o0?mVoooooooo
ool04oooool01?l0ofKoo`00o`3oI_oo0004ooooo`03o`3oI_ooooooo`0000Gooooo00?o0?mVool0
0?ooool00_ooool01Ol0ofKoooooooooooooooooo`00013ooooo00?o0000ooooooooool00oooool0
00Gooooo00?o0000ooooooooool03oooool01?oo003oooooooooool0ofH`ooooo`03ool00?l0ofKo
o`0000;ooooo00?oo`00o`3oI_ooool02oooool00ol0ofKoooooooooo`0?ooooo`04o`3oI_oooooo
ooooool002Oooooo00?oo`00o`3oI_ooool04_ooool01Ol0003oooooooooool0ofKoo`0000;ooooo
00?o0?mVoooooooo00000oooool00ol0003oooooooooo`0Booooo`;oo`0000?o0?mVooooooooool0
1oooool01Ooo003oooooooooool0ofKoo`0000Cooooo0_oo0004o`3oIP04ooooool0ofKo0?mVo`3o
IP?ooooo0_oo00000ol0ofKoooooooooo`06ooooo`;o0?mV2Oooool01Ol0ofKoo`00ool00?oo003o
0?mV00;oo`002oooool00ol0ofKoooooooooo`0Dooooo`04o`3oI_oo003o0?mVool000Gooooo00?o
0?mVool00?ooool01?ooool00ol0ofKoo`00ooooo`02ooooo`05o`3oI_oooooooooooooooooo0000
4?ooool00ol0003oooooooooo`03ooooo`001Oooool00ol0003oooooooooo`0?ooooo`04ool00?oo
ooooooooo`3oIS3ooooo00?oo`00o`3oI_oo00000_ooool00ooo003o0?mVooooo`0;ooooo`03o`3o
I_oo003ooooo00oooooo1?l0ofH00ooo003oooooooooo`0iooooo`04o`000?oooooo0?mVool000;o
oooo00Co0?mVooooooooooooo`000oooool00ol0003oooooooooo`0Dooooo`03ool00?l0ofKooooo
00Sooooo00Coo`00oooooooo003o0?mV1Oooool00ooo003o0?mVo`3oIP02ool00004o`3oI_oooooo
o`00o`3oIPGooooo00?oo`00o`3oI_ooool01_ooool00ol0ofKoooooooooo`08ooooo`03ool00?oo
oooo0?mV00;ooooo00?o0?mVoooooooo00000_oo0004ooooo`04ool00?l0ofKo0?mVo`3oIQOooooo
00Go0?mVool00?oooooo0?mVool00006ooooo`03ool00?oooooooooo00;ooooo00?o0?mVool00?oo
ool00oooool01?l0ofKooooooooooooo000@ooooo`03o`000?oooooooooo00?ooooo0005ooooo`03
o`000?oooooooooo013ooooo00?oo`00ooooool0ofH0<?ooool00ooo003oooooool00002ooooo`03
ool00?l0ofKooooo00cooooo00?o0?mVool00?ooool04_ooool00ol0ofKoo`00ooooo`0iooooo`03
o`000?oo003o0?mV00?ooooo00?o0?mVoooooooo00001?ooool00ol0003oooooooooo`0Dooooo`03
ool00?l0ofKooooo00Sooooo0ooo00000ol0ofKoooooooooo`03ooooo`;oo`0000Oo0?mVoooooooo
003o0?mVoooooooo003o0?mV00Kooooo00?oo`00ooooooooool04?ooool00ol0ofKoooooo`3oIP03
ooooo`04o`3oI_ooooooooooooooo`;oo`000ol0ofHIooooo`06o`3oI_oo003oooooooooool0ofKo
o`001_ooool00ooo003o0?mVooooo`02ooooo`03ool00?oooooooooo00?ooooo00Co0?mVoooooooo
ooooo`004?ooool00ol0003oooooooooo`03ooooo`001Oooool00ol0003oooooooooo`0@ooooo`03
ool00?oooooo0?mV033ooooo00?oo`00o`3oI_oo00000oooool00ol0ofKoooooooooo`0<ooooo`03
o`3oI_oooooooooo01;ooooo00?oo`00ooooooooool0>?ooool00ol0003o0?mVooooo`03ooooo`03
o`3oI_ooooooo`0000Cooooo00?o0000ooooooooool05Oooool00ooo003o0?mVooooo`07ooooo`?o
o`0000?o0?mVooooooooool00_ooool01Ol0ofKoo`00ool00?oo003ooooo00;oo`0000?o0?mVoooo
ool0ofH01_ooool00ol0ofKoo`00ool0000Aooooo`03o`3oI_oooooooooo00?ooooo1Ol0ofHLoooo
o`03o`3oI_oooooooooo00;ooooo00?oo`00ooooooooool01Oooool01Ooo003o0?mVoooooooooooo
o`0000Gooooo00Go0?mVooooooooooooooooool0000?ooooo`03o`000?oooooooooo00?ooooo0005
ooooo`03o`000?oooooooooo013ooooo00?oo`00ooooool0ofH0<Oooool00ooo003oooooool00002
ooooo`03o`3oI_oooooooooo00cooooo00?o0?mVool00?ooool04Oooool00ol0ofKoo`00ooooo`0i
ooooo`03o`000?oooooooooo00?ooooo00?o0?mVool00?ooool01?ooool00ol0003oooooooooo`0F
ooooo`03ool00?l0ofKooooo00Gooooo00Koo`00ooooool0ofKoooooool00?l0ofH3ooooo`;oo`00
00?oooooo`3oI_oo00000_ooool00ooo003o0?mVooooo`07ooooo`03o`3oI_ooooooo`0000;oo`00
=?ooool00ooo003o0?mVooooo`03ooooo`03ool00?l0ofKooooo00Gooooo00Goo`00o`3oI_oooooo
o`00o`3oIP05ooooo`05o`3oI_oooooooooooooooooo00003oooool00ol0003oooooooooo`03oooo
o`001Oooool00ol0003oooooooooo`0@ooooo`04ool00?ooooooooooo`3oIS3ooooo00?oo`00o`3o
I_oo00000_ooool00ooo003o0?mVooooo`0=ooooo`03o`3oI_oo003ooooo013ooooo00?oo`00oooo
ooooool0>?ooool00ol0ofKo0000ooooo`04ooooo`03o`3oI_oo003ooooo00Cooooo00?o0000oooo
ooooool05oooool00ooo003o0?mVooooo`03ooooo`07ool00?oooooo0?mVooooool0ofKoooooool0
0002ooooo`0:o`3oI_oo003oo`00ooooool0ofKoooooool00?ooooooo`00o`3oIP;oo`001_ooool3
o`3oIP;ooooo00?oo`00ooooooooool0<Oooool00ooo003o0?mVooooo`04ooooo`03ool00?oooooo
oooo00Gooooo00Co0?mVoooooooo003o0?mV1_ooool01?l0ofKooooooooooooo000?ooooo`03o`00
0?oooooooooo00?ooooo0005ooooo`03o`000?oooooooooo013ooooo00Coo`00oooooooooooo0?mV
<?ooool01?oo003o0?mVoooooooo0002ooooo`03o`3oI_oooooooooo00kooooo0_oo000?ooooo`03
ool00?oooooooooo03Oooooo00?o0?mVooooool000001?ooool00ol0ofKoooooool00005ooooo`03
o`000?oooooooooo01Sooooo00Ooo`00o`3oI_l0ofKoooooool00?oooooo0?mV00;ooooo00Ko0?mV
ooooool0ofKoo`00ooooool0ofH3ool000?o0?mV00Koo`00o`3oI_oooooo0?mVoooooooo0008oooo
o`;o0?mV00?oo`00ooooooooool0<?ooool00ooo003oooooo`3oIP05ooooo`03ool00?l0ofKooooo
00Gooooo00Goo`00o`3oI_oo003oooooo`3oIP05ooooo`04o`3oI_ooooooooooool000oooooo00?o
0000ooooooooool00oooool000Gooooo00?o0000ooooooooool04?ooool01?oo003oooooooooool0
ofH`ooooo`07ool00?oooooo0?mVo`3oI_oo003oooooo`3oIP0Booooo`03ool00?l0ofKooooo00co
oooo00?oo`00o`3oI_ooool0=Oooool2o`3oIP;ooooo00?o0000oooooooo00001?oo0006ooooo`03
o`000?oooooooooo01Wooooo00Goo`00ooooool0ofKoooooo`3oIP06ooooo`04o`3oI_oo003o0?mV
ool000?ooooo0_oo00000ol0ofKoo`00o`3oIP05o`3oIPSooooo00?o0?mVool00?ooool0<?ooool0
0ooo003o0?mVooooo`05ooooo`03ool00?l0ofKooooo00Gooooo00Goo`00o`3oI_ooooooooooo`3o
IP05ooooo`04o`3oI_ooooooooooool000oooooo00?o0000ooooooooool00oooool000Gooooo00?o
0000ooooooooool04?ooool01?oo003oooooooooool0ofH`ooooo`08ool00?ooooooooooo`3oI_oo
003oooooool00?l0ofHBooooo`03ool00?l0ofKo0?mV00gooooo00?o0?mVooooooooool0<_ooool0
0ol0ofKoo`00ool00002ool00003o`000?oo003o0?mV00[ooooo00?o0000ooooooooool06_ooool2
ool000;o0?mV1_ooool2o`3oIP;oo`001?l0ofH01_oo003o0?mVoooooooo003oooooo`3oIP?ooooo
0_oo0002o`3oIPGooooo00?o0?mVool00?ooool0;oooool00ooo003o0?mVooooo`05ooooo`03ool0
0?oooooo0?mV00Kooooo00Co0?mVoooooooooooo0?mV1_ooool00ol0ofKoooooool0000?ooooo`03
o`000?oooooooooo00?ooooo0005ooooo`03o`000?oooooooooo017ooooo00?oo`00ooooool0ofH0
<?ooool00ooo003oooooooooo`02o`3oIP03ool00?oooooo0?mV01?ooooo00?oo`00ooooool0ofH0
3Oooool00ol0ofKoooooooooo`0`ooooo`07o`3oI_oo003oooooool00?l0ofKoooooo`00000<oooo
o`03o`000?oooooooooo01[ooooo0_oo0002ooooo`03o`3oI_oooooooooo00?ooooo00Co0?mVool0
0?l0ofKooooo0ooo00002?oooooo0?mVool00?l0ofKoooooool00?oooooo0?mV1?ooool2ool000?o
0?mV0oooool00ol0ofKoo`00ooooo`0[ooooo`?oo`0000?o0?mVooooooooool01Oooool00ooo003o
ooooo`3oIP06ooooo`04o`3oI_ooooooooooo`3oIPKooooo00?o0?mVoooooooo00003oooool00ol0
003oooooooooo`03ooooo`001?ooool00ol0003oooooooooo`0Booooo`03ool00?oooooo0?mV033o
oooo00Soo`00ooooooooooooooooo`3oI_oo003oooooo`3oIQ?ooooo00?oo`00ooooool0ofH03Ooo
ool00ol0ofKoo`00ooooo`0_ooooo`05o`3oI_oo003oooooool00?l0ofH00_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo01Wooooo00Coo`00o`3oI_ooooooo`000_ooool02?l0ofKo
oooooooooooooooo0?mVoooooooo003ooooo0ol0ofH01Oooooooo`00ool00?ooooooo`0000;o0?mV
00?oo`00ooooool0ofH01Oooool3ool000;o0?mV00?oooooo`3oI_oo0000:Oooool00ooo003o0?mV
o`3oIP03o`3oIPWooooo00?oo`00o`3oI_ooool01Oooool00ooo003o0?mVo`3oIP07ooooo`03o`3o
I_ooooooo`0000oooooo00?o0000ooooooooool00oooool000Cooooo00?o0000ooooooooool04_oo
ool00ooo003oooooo`3oIP0aooooo`03ool00?oooooooooo00;o0?mV00?oo`00o`3oI_ooool04ooo
ool00ooo003o0?mVooooo`0=ooooo`03o`3oI_oo003oo`0002gooooo00Ko0?mVool00?oooooooooo
ool00?l0ofH2ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool06?ooool00ooo003o
0?mVooooo`02ooooo`04ool00?ooooooooooo`3oIP;ooooo00?o0?mVool00?ooool00_ooool00ooo
003o0?mVo`3oIP02ooooo`?oo`0000Co0?mVoooooooo003o0?mV2?ooool2ool00004o`3oI_oooooo
0?mVool002Kooooo0ol0ofH>ooooo`03ool00?oooooo0?mV00Gooooo00?oo`00o`3oI_ooool02?oo
ool00ol0ofKoo`00ooooo`0>ooooo`03o`000?oooooooooo00?ooooo0004ooooo`03o`000?oooooo
oooo01;ooooo00?oo`00ooooool0ofH0<Oooool01ooo003ooooooooooooooooo0?mVool00?l0ofH0
5?ooool00ooo003o0?mVooooo`0>ooooo`?o0?mV:oooool00ol0ofKoo`00ooooo`02ool00005o`3o
I_ooooooooooooooool000003?ooool00ol0003oooooooooo`0Hooooo`03ool00?oooooooooo00?o
oooo00Ooo`00ooooool0ofKoooooo`3oI_ooooooo`0000;ooooo00Goo`00ooooool0ofKoooooo`3o
IP03ooooo`;oo`000_ooool2ool000Wooooo00Goo`00oooooooooooo0?mVool0000Rooooo`?o0?mV
4Oooool00ooo003oooooo`3oIP05ooooo`03o`3oI_oo003ooooo00Sooooo00?o0?mVoooooooo0000
3_ooool00ol0003oooooooooo`03ooooo`001?ooool00ol0003oooooooooo`0Booooo`03ool00?oo
oooo0?mV037ooooo00Coo`00oooooooooooooooo0_l0ofH00ooo003oooooooooo`0Booooo`03ool0
0?l0ofKooooo017ooooo0_l0ofHXooooo`04o`3oI_oo003oo`00ool000;ooooo00Go0?mVoooooooo
ooooooooo`00000=ooooo`03o`000?oooooooooo01Kooooo00?oo`00ooooooooool01?ooool01_oo
003oooooo`3oI_l0ofKoooooool000;ooooo00?oo`00ooooool0ofH00oooool3o`3oIP03oooooooo
003oo`0000?ooooo0_l0ofH7ooooo`06ool00?l0ofKoooooooooool0ofKoo`001Oooool3o`3oIQOo
oooo0ol0ofHBooooo`03ool00?oooooo0?mV00Kooooo00?o0?mVool00?ooool02?ooool00ol0ofKo
ooooool0000>ooooo`03o`000?oooooooooo00?ooooo0004ooooo`03o`000?oooooooooo01;ooooo
00?oo`00ooooool0ofH0<Oooool01?oo003oooooooooooooool3o`3oIP03ool00?oooooooooo01;o
oooo00?oo`00ooooooooool04Oooool00ooo003o0?mVooooo`0Uooooo`03o`3oI_oo003oo`0000Co
oooo00Go0?mVooooooooooooooooo`00000=ooooo`03o`000?oooooooooo01Gooooo00?oo`00oooo
ooooool01_ooool01?oo003o0?mVo`3oI_oo0003ooooo`03ool00?l0ofKo0?mV00Kooooo0ol0ofH2
ool000;ooooo00?oo`00o`3oI_ooool01_ooool01Ooo003ooooooooooooooooo0?mV00;ooooo0ol0
ofH3ooooo`;o0?mV5Oooool00ol0ofKoo`00ooooo`0Aooooo`03ool00?oooooo0?mV00Oooooo00?o
0?mVool00?ooool02Oooool00ol0ofKoo`00ooooo`0=ooooo`03o`000?oooooooooo00?ooooo0004
ooooo`03o`000?oooooooooo01?ooooo00?oo`00o`3oI_ooool0<?ooool02?oo003ooooooooooooo
oooo0?mVooooool0ofKoo`005?ooool00ooo003o0?mVooooo`0Booooo`03ool00?l0ofKooooo01Wo
oooo2ol0ofH2ool000Cooooo00?o0?mVooooooooool00_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo01Cooooo00?o0?mVooooooooool01oooool01Ooo003o0?mVo`3oI_oo003ooooo
00?o0?mV2Oooool5o`3oIP05ool00?ooooooooooo`3oI_oo00001_ooool01?oo003ooooooooooooo
ool2o`3oIPSooooo0ol0ofH00oooooooo`00ool00003ool000_ooooo0_oo000Cooooo`03ool00?oo
oooo0?mV00Sooooo00?oo`00o`3oI_ooool02?ooool00ol0ofKoo`00ooooo`0=ooooo`03o`000?oo
oooooooo00?ooooo0004ooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooool0ofH0<Oooool0
1Ooo003oooooooooool0ofKooooo00;o0?mV00?oo`00ooooooooool04Oooool00ooo003oooooo`3o
IP0Cooooo`03ool00?l0ofKoo`0001Oooooo00?o0?mVooooooooool00ooo0004ooooo`04ool00?l0
ofKo0?mVo`3oIP;ooooo0ol0ofH4ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
4oooool00ooo003o0?mVooooo`08ooooo`03o`3oI_oo003o0?mV00;o0?mV00?oo`00ooooooooool0
2_ooool01?oo003o0?mVo`3oI_ooool3o`3oIP03ooooool0ofKoo`0000Kooooo00Coo`00oooooooo
oooooooo1?oo0004ooooo`Goo`001Ol0ofH00ooo003o0?mVo`3oIP06o`3oIP;oo`005?ooool00ooo
003oooooo`3oIP09ooooo`;o0?mV2Oooool00ol0ofKoo`00ooooo`0=ooooo`03o`000?oooooooooo
00?ooooo0004ooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooool0ofH0<Oooool01?oo003o
ooooooooool0ofH2ooooo`03o`3oI_ooooooo`0001?ooooo00?oo`00ooooool0ofH05?ooool01?l0
ofKoo`00ool00?oo000?ooooo`?oo`0000?oooooo`3oI_oo00000_oo0006ooooo`03o`3oI_oo003o
oooo00;ooooo0_l0ofH7ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool04_ooool0
0ooo003o0?mVooooo`09ooooo`03o`3oI_oo003o0?mV00;ooooo00?oo`00ooooooooool03?ooool0
1?oo003o0?mVo`3oI_l0ofH2ool000?o0?mV00?oo`00ooooooooool00_ooool00ol0ofKoo`00oooo
o`05ooooo`Coo`001Oooool3o`3oIP03ool00?l0ofKo0?mV00?oo`000_ooool00ol0ofKoo`00ool0
0002o`3oIPOooooo0_l0ofH;ooooo`03ool00?l0ofKooooo00Oooooo0ol0ofH00ooo003ooooooooo
o`06ooooo`03o`3oI_oo003ooooo00oooooo00?o0000ooooooooool00_ooool000Cooooo00?o0000
ooooooooool04oooool00ooo003oooooo`3oIP0aooooo`04ool00?ooooooooooo`3oIP;ooooo0_l0
ofH00oooooooo`00ooooo`0Booooo`03ool00?oooooo0?mV01Cooooo00?o0?mVooooooooool00_oo
000=ooooo`03ool00?oooooooooo00;oo`002?ooool00ol0ofKoo`00ooooo`0<ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool04Oooool00ooo003o0?mVooooo`0:ooooo`05o`3oI_oo
003oooooo`3oI_oo00004_ooool01Ooo003o0?mVo`3oI_ooooooo`0000?o0?mV1?ooool00ol0ofKo
o`00ool0000<ooooo`05o`3oI_ooooooooooooooool0ofH00ooooolBool00003o`3oI_oooooooooo
00Gooooo0_l0ofH00ooo003oooooooooo`07ooooo`05o`3oI_oooooooooooooooooo00002?ooool0
0ol0ofKoo`00ooooo`0?ooooo`03o`000?oooooooooo00;ooooo0004ooooo`03o`000?oooooooooo
01?ooooo00?oo`00ooooool0ofH0<_ooool00ooo003oooooo`3oIP02ooooo`05o`3oI_oooooo0?mV
oooooooo00004oooool00ooo003oooooo`3oIP0Dooooo`;o0?mV0_ooool00ooo003oooooooooo`09
ooooo`04ool00?l0ofKo0?mVo`3oIPWooooo00?o0?mVool00?ooool03Oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo013ooooo00?oo`00o`3oI_ooool02_ooool01Ol0ofKoooooool0
0?oo003o0?mV01Kooooo00Co0?mVoooooooooooooooo1?l0ofH01?oooooo0?mVooooooooool3ool0
00Oooooo00?oo`00o`3oI_ooool04oooool00ol0ofKoooooooooo`02ooooo`03ool00?oooooo0?mV
00Cooooo0_l0ofH00oooooooo`00ooooo`09ooooo`05o`3oI_ooooooooooo`3oI_oo00002?ooool0
0ooo003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo0004ooooo`03o`000?oooooooooo
01?ooooo00?oo`00ooooool0ofH0<_ooool00ooo003oooooo`3oIP02ooooo`06o`3oI_oooooooooo
o`3oI_ooooooo`004oooool00ooo003oooooo`3oIP0Eooooo`;o0?mV00?oooooool00?oo00001ooo
ool2o`3oIP03ool00?oooooooooo00Wooooo00?o0?mVool00?ooool03_ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00oooooo00?oo`00o`3oI_ooool02oooool01Ol0ofKoo`00oooo
oooo003o0?mV01Kooooo00?o0?mVooooooooool00_ooool2o`3oIP05ool00?l0ofKoo`00ool00?l0
ofH00oooool3ool000?ooooo00?oo`00o`3oI_ooool06_ooool2ool00004ooooool0ofKo0?mVo`3o
IP;ooooo00?oo`00ooooooooool02?ooool01_l0ofKoooooo`3oI_l0ofKoooooool000Oooooo00?o
0?mVool00?ooool04?ooool00ol0003oooooooooo`02ooooo`001?ooool00ol0003oooooooooo`0D
ooooo`03ool00?l0ofKooooo037ooooo00?oo`00o`3oI_ooool00_ooool01ol0ofKooooooooooooo
oooo0?mVoooooooo00004oooool00ooo003oooooo`3oIP0Fooooo`04o`3oI_ooooooooooool000Co
oooo0_l0ofH2ool000_ooooo00?o0?mVool00?ooool03oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00kooooo00?oo`00ooooool0ofH02oooool2o`3oIP;oo`0000?oooooool00?l0
ofH05_ooool00ol0ofKoooooooooo`03ooooo`05o`3oI_ooooooo`00o`3oI_oo00000ol0ofH3oooo
o`?oo`0000?o0?mVooooooooool06_ooool3o`3oIPCooooo00?oo`00ooooooooool02?ooool00ol0
ofKoooooo`3oIP02ooooo`;oo`001oooool00ol0ofKoo`00ooooo`0@ooooo`03o`000?oooooooooo
00;ooooo0004ooooo`03o`000?oooooooooo01Cooooo00?oo`00o`3oI_ooool0<_ooool01Ol0ofKo
ooooooooooooooooo`0000Cooooo00?o0?mVoooooooo00004oooool00ooo003o0?mVooooo`0Foooo
o`;o0?mV00?oooooool00?l0ofH00_l0ofH>ooooo`03o`3oI_oo003ooooo013ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0=ooooo`03ool00?oooooo0?mV00cooooo00?o0?mVool0
0?oo00000_ooool00ooo003o0?mVooooo`0Eooooo`03o`3oI_oooooooooo00Cooooo00Co0?mVoooo
oooo003o0?mV0_oo00001ooooooo0?mVo`3oI_l0ofKoooooool00?l0ofH01?oo000Fooooo`?o0?mV
00?oooooool00?ooool01?oo000:ooooo`?o0?mV0_ooool00ooo003oooooooooo`07ooooo`03ool0
0?oooooooooo013ooooo00?o0000ooooooooool00_ooool000Cooooo00?o0000ooooooooool05?oo
ool00ooo003o0?mVooooo`0booooo`06o`3oI_ooooooooooooooool0ofKoo`001?ooool00ol0ofKo
o`00ooooo`0Cooooo`03ool00?l0ofKooooo01Oooooo0_l0ofH@ooooo`03o`3oI_oo003ooooo017o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0=ooooo`03ool00?l0ofKooooo00_o
oooo0_l0ofH00ooo003oooooooooo`02ooooo`03o`3oI_oooooooooo01Gooooo00?o0?mVoooooooo
ool01?ooool01_l0ofKooooooooooooo003o0?mVool000?ooooo0_l0ofH5ooooo`Woo`003?ooool0
0ol0ofKoooooool00004ool000kooooo00?o0?mVooooooooool00_oo0009ooooo`03o`3oI_oo003o
oooo017ooooo00?o0000ooooooooool00_ooool000Cooooo00?o0000ooooooooool05?ooool00ooo
003o0?mVooooo`0booooo`03o`3oI_oooooooooo00;ooooo00?oo`00ooooooooool00oooool00ol0
ofKoo`00ooooo`0Cooooo`03ool00?oooooooooo02Oooooo00?o0?mVool00?ooool04_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?oo`00o`3oI_ooool03?ooool00ol0
ofKoo`00ooooo`04ooooo`03o`3oI_oooooooooo01Gooooo00?o0?mVooooooooool01Oooool4o`3o
IP05oooooooo003oo`00oooooooo00000ol0ofH8ooooo`Co0?mV0_oo0009ooooo`03o`3oI_oo003o
o`0000?ooooo00?o0?mVooooooooool03Oooool01?l0ofKoooooool00?oo000:ooooo`03ool00?oo
oooooooo017ooooo00?o0000ooooooooool00_ooool000Cooooo00?o0000ooooooooool05?ooool0
0ooo003o0?mVooooo`0booooo`03o`3oI_oo003ooooo00;ooooo00?oo`00ooooooooool00oooool0
0ol0ofKoo`00ooooo`0Dooooo`03ool00?oooooooooo02Cooooo0_l0ofHEooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool03?ooool00ooo003o0?mVooooo`0;ooooo`03o`3oI_oo003o
oooo00Gooooo00?oo`00o`3oI_ooool05_ooool00ol0ofKoooooooooo`08ooooo`;o0?mV0_oo0003
o`3oIP03ooooool0ofKo0?mV00;ooooo1?l0ofH4ooooo`;o0?mV0_oo0006ooooo`03o`3oI_oo003o
oooo00Cooooo00?o0?mVooooooooool03Oooool00ol0ofKoo`00ool0000;ooooo`03ool00?oooooo
oooo017ooooo00?o0000ooooooooool00_ooool000Cooooo00?o0000ooooooooool05?ooool00ooo
003o0?mVooooo`0booooo`03o`3oI_oo003ooooo00;ooooo00?o0?mVool00?ooool01?ooool00ol0
ofKoooooooooo`0Cooooo`03o`3oI_oo003ooooo02?ooooo00?o0?mVool00?ooool05Oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?oo`00o`3oI_ooool02oooool00ol0
ofKoo`00ooooo`07ooooo`;o0?mV5_ooool00ol0ofKoooooooooo`0;ooooo`Coo`001_l0ofH9oooo
o`;o0?mV1?oo0002o`3oIP03ool00?oooooooooo00?ooooo00?o0?mVooooooooool03_ooool00ol0
ofKoo`00ool0000;ooooo`03ool00?oooooooooo017ooooo00?o0000ooooooooool00_ooool000Co
oooo00?o0000ooooooooool05?ooool00ooo003oooooo`3oIP0booooo`03o`3oI_oo003ooooo00?o
oooo00?oo`00ooooooooool00oooool00ol0ofKoo`00ooooo`0Cooooo`03o`3oI_ooooooo`0000?o
o`007oooool00ol0ofKoooooooooo`0Fooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool02oooool00ol0ofKoooooooooo`0:ooooo`03o`3oI_oo003ooooo00[ooooo0_l0ofHEooooo`03
o`3oI_oo003ooooo00Wooooo00?oo`00ooooool0ofH00_oo00001?l0ofKoo`00ool00?oo0002oooo
o`;o0?mV2Oooool2o`3oIP03ooooool0ofKooooo00Kooooo00?o0?mVool00?ooool03_ooool2o`3o
IP03oooooooo003ooooo00Wooooo00?oo`00ooooooooool04_ooool00ol0003oooooooooo`02oooo
o`001?ooool00ol0003oooooooooo`0Eooooo`03ool00?l0ofKooooo037ooooo00?o0?mVoooooooo
00000oooool00ooo003oooooooooo`03ooooo`03o`3oI_oo003ooooo01Cooooo0ol0ofH2ooooo`Co
o`006?ooool3o`3oIQWooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03
o`3oI_oooooooooo00[ooooo00?o0?mVool00?ooool03Oooool3o`3oIQCooooo00?oo`00oooooooo
ool01oooool00ooo003o0?mVooooo`02ooooo`03ool00?l0ofKo0?mV00;o0?mV00Coo`00oooooooo
oooo0?mV2_ooool00ol0ofKoooooooooo`06ooooo`?oo`003_ooool2o`3oIP03oooooooo003ooooo
00Wooooo00?oo`00ooooooooool04_ooool00ol0003oooooooooo`02ooooo`001?ooool00ol0003o
ooooooooo`0Eooooo`03ool00?l0ofKooooo037ooooo00?o0?mVoooooooo00000oooool00ol0ofKo
o`00ooooo`04ooooo`03o`3oI_oo003ooooo01Kooooo1?l0ofH2ooooo`?oo`004Oooool4o`3oIP03
ool00?oooooooooo01Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`09ooooo`03
o`3oI_oooooooooo00[ooooo00?o0?mVool00?ooool04?ooool00ooo003o0?mVo`3oIP0Cooooo`03
ool00?l0ofKooooo00Gooooo00?oo`00ooooooooool01?ooool2ool000;ooooo2_l0ofH<ooooo`;o
0?mV0_ooool00ooo003oooooooooo`0;ooooo`04o`3oI_oooooo0?mVool000[ooooo00?oo`00oooo
ooooool04_ooool00ol0003oooooooooo`02ooooo`001?ooool00ol0003oooooooooo`0Eooooo`03
ool00?l0ofKooooo03;ooooo00?o0?mVool00?ooool00oooool00ooo003oooooooooo`03ooooo`03
o`3oI_oo003ooooo01[ooooo0ol0ofH2ooooo`?oo`002_ooool4o`3oIP;oo`007_ooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0?mVooooooooool02?ooool2o`3oIP03
ool00?oooooooooo01;ooooo00?oo`00o`3oI_l0ofH04_ooool00ooo003o0?mVooooo`03ooooo`03
ool00?oooooooooo00Oooooo0_oo0004ooooo`;oo`000_l0ofH2ooooo`So0?mV1_ooool00ol0ofKo
o`00ooooo`05ooooo`?o0?mV1?ooool01Ooo003o0?mVooooool0ofKoo`0000Wooooo00?oo`00oooo
ooooool04oooool00ol0003oooooooooo`02ooooo`001?ooool00ol0003oooooooooo`0Eooooo`03
ool00?l0ofKooooo03;ooooo00?o0?mVoooooooo00000oooool00ooo003oooooooooo`03ooooo`03
o`3oI_oo003ooooo01gooooo00?o0?mVooooooooool00_ooool4ool000Cooooo0_l0ofH01?oooooo
o`00ool00?oo000Pooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02?ooool00ol0
ofKoooooooooo`08ooooo`;o0?mV00?oooooool00?ooool05?ooool2ool00003o`3oI_oooooooooo
013ooooo0_oo0003o`3oIPcooooo00?oo`00ooooooooool01?ooool00ooo003o0?mVooooo`08oooo
o`;o0?mV1?ooool00ooo003o0?mVo`3oIP02ooooo`?o0?mV0ooo0003o`3oIP06ool00?oooooo0?mV
ooooool0ofKoo`002Oooool00ooo003oooooooooo`0Cooooo`03o`000?oooooooooo00;ooooo0004
ooooo`03o`000?oooooooooo01Kooooo00?o0?mVooooooooool0<_ooool00ol0ofKoo`00ooooo`02
ooooo`03o`3oI_oo003ooooo00Cooooo00?o0?mVool00?ooool07Oooool00ol0ofKoooooooooo`03
ooooo`;o0?mV0_oo0002o`3oIP?oo`008oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00Oooooo00?o0?mVool00?ooool01oooool2o`3oIP03ool00?l0ofKoo`0001Sooooo00?o0?mV
ool00?ooool04_ooool00ooo003o0?mVooooo`0=oooooa3oo`000oooool01Ol0ofKooooooooooooo
003o0?mV00;ooooo0_l0ofH00oooooooo`00ool00005ooooo`03ool00?l0ofKo0?mV00Coo`002Ooo
ool00ooo003oooooooooo`0Cooooo`03o`000?oooooooooo00;ooooo0004ooooo`03o`000?oooooo
oooo01Kooooo00?o0?mVooooooooool0<_ooool00ol0ofKoooooool00003ooooo`03ool00?oooooo
oooo00?ooooo00?o0?mVool00?ooool07_ooool5o`3oIRcooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`06ooooo`03o`3oI_oo003ooooo00Oooooo00Ko0?mVoooooooo003o0?mVoooo
oooo000Iooooo`03o`3oI_oo003ooooo00oooooo0_l0ofH2ool000Go0?mV4oooool2o`3oIP;oo`00
0_ooool4ool000Ko0?mV00?oooooool00?oo00001_ooool00ooo003oooooooooo`02o`3oIP03oooo
ool0ofKooooo00Wooooo00?oo`00ooooooooool04oooool00ol0003oooooooooo`02ooooo`001?oo
ool00ol0003oooooooooo`0Fooooo`03o`3oI_oooooooooo03?ooooo00?o0?mVool00?ooool00_oo
ool2o`3oIPCooooo00?o0?mVool00?ooool0Coooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00Gooooo00?oo`00o`3oI_ooool01oooool01_l0ofKoooooool00?oooooo0?mVool001_o
oooo00?oo`00ooooooooool03Oooool00ol0ofKoooooool00002ooooo`03ool00?oooooooooo00;o
oooo1?l0ofHAooooo`;o0?mV0ooo0002o`3oIP04oooooooo003oo`00ool000;ooooo0_oo0007o`3o
IP06ool00?ooooooooooooooool0ofKooooo0_l0ofH9ooooo`03ool00?oooooooooo01Cooooo00?o
0000ooooooooool00_ooool000Cooooo00?o0000ooooooooool05oooool00ol0ofKoooooooooo`0b
ooooo`03o`3oI_ooooooo`0000?ooooo00?oo`00o`3oI_ooool00oooool00ol0ofKoo`00ooooo`1>
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01?ooool00ooo003o0?mVooooo`07
ooooo`03o`3oI_ooooooo`0000;ooooo00?o0?mVool00?ooool06_ooool00ol0ofKoo`00ooooo`0<
ooooo`03o`3oI_ooooooo`0000Cooooo1Ooo0003ooooo`03o`3oI_oooooooooo00Oooooo0ooo0002
o`3oIPCoo`000_l0ofH01oooooooo`00ool00?oo003oooooo`3oI_ooool00_oo0002ooooo`Ooo`00
1?l0ofH3ooooo`03o`3oI_oooooooooo00Oooooo00?oo`00ooooooooool05?ooool00ol0003ooooo
ooooo`02ooooo`000oooool00ol0003oooooooooo`0Hooooo`03o`3oI_oooooooooo03;ooooo00?o
0?mVoooooooo00001?ooool00ooo003o0?mVooooo`02ooooo`03o`3oI_oo003ooooo04kooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03ool00?l0ofKooooo00Sooooo00Ko
0?mVool00?ooooooooooo`3oI_oo000Mooooo`03o`3oI_oo003ooooo00Wooooo0_l0ofH00ooooooo
o`00ooooo`09ooooo`Koo`001?ooool3ool00003o`3oI_oooooooooo00;ooooo1?l0ofH5ool00003
oooooooo003oo`0000Goo`006?ooool00ooo003oooooooooo`0Dooooo`03o`000?oooooooooo00;o
oooo0003ooooo`03o`000?oooooooooo01Sooooo00?o0?mVooooooooool0<oooool00ol0ofKoo`00
ooooo`04ooooo`03ool00?l0ofKooooo00;ooooo00?o0?mVool00?ooool0COooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?oo`00o`3oI_ooool02?ooool00ol0ofKoo`00
ooooo`02ooooo`03o`3oI_oo003ooooo01gooooo00?o0?mVool00?ooool01oooool01?l0ofKooooo
oooooooo000Aooooo`Coo`0000?o0?mVooooooooool02Oooool3o`3oIP;ooooo00?o0?mVoooooooo
ool07?ooool00ol0ofKoo`00ooooo`0Eooooo`03o`000?oooooooooo00;ooooo0003ooooo`03o`00
0?oooooooooo01Wooooo00?o0?mVooooooooool0<_ooool00ol0ofKoooooool00005ooooo`03ool0
0?l0ofKo0?mV00;ooooo00?o0?mVool00?ooool0C?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00;oo`0000?o0?mVooooooooool01oooool00ol0ofKoooooool00002ooooo`03o`3o
I_oo003ooooo01kooooo00?o0?mVool00?ooool01_ooool01?l0ofKooooooooooooo000Cooooo`03
o`3oI_oooooooooo00oooooo0_l0ofHOooooo`03ool00?oooooooooo01Gooooo00?o0000oooooooo
ool00_ooool000?ooooo00?o0000ooooooooool06Oooool00ol0ofKoooooooooo`0cooooo`03o`3o
I_oo003ooooo00Gooooo00Koo`00ooooool0ofKoooooo`3oI_oo001=ooooo`03o`000?oooooooooo
00_ooooo00?o0000oooooooo00000_l0ofH:ooooo`03o`3oI_oo003ooooo00;ooooo00?o0?mVool0
0?ooool07oooool00ol0ofKoo`00ooooo`04ooooo`04o`3oI_ooooooooooool004Oooooo00?oo`00
ooooooooool05Oooool00ol0003oooooooooo`02ooooo`000oooool00ol0003oooooooooo`0Ioooo
o`03o`3oI_oooooooooo03?ooooo00?o0?mVoooooooo00001_ooool01_oo003oooooo`3oI_oooooo
0?mVool004cooooo00?o0000ooooooooool02_ooool00ol0ofKoo`00ool0000<ooooo`03o`3oI_oo
003ooooo00;ooooo0_oo000Qooooo`03o`3oI_ooooooo`0000Cooooo00?o0?mVoooooooo0000Aooo
ool00ol0ofKoo`00ooooo`0Fooooo`03o`000?oooooooooo00;ooooo0003ooooo`03o`000?oooooo
oooo01[ooooo00?o0?mVooooooooool0<oooool00ol0ofKoo`00ooooo`06ooooo`05ool00?oooooo
0?mVo`3oI_oo0000C?ooool00ol0003oooooooooo`07ooooo`?o0?mV00?oo`00o`000?ooool03?oo
ool00ol0ofKoooooooooo`02ool00003o`3oI_oooooooooo027ooooo00?o0?mVool00?ooool00_oo
ool00ol0ofKoooooool00018ooooo`03ool00?oooooooooo01Kooooo00?o0000ooooooooool00_oo
ool000?ooooo00?o0000ooooooooool06_ooool00ol0ofKoooooooooo`0cooooo`03o`3oI_oo003o
oooo00Oooooo00Goo`00ooooool0ofKo0?mVool0001;ooooo`03o`000?oooooooooo00Gooooo0_l0
ofH2ooooo`03ool00?oooooo000000cooooo0_l0ofH2ool002Oooooo00Co0?mVool00?oooooo0?mV
0_ooool00ooo003oooooooooo`16ooooo`03ool00?oooooooooo01Kooooo00?o0000ooooooooool0
0_ooool000?ooooo00?o0000ooooooooool06_ooool00ol0ofKoooooooooo`0dooooo`03o`3oI_oo
003ooooo00Oooooo00Goo`00ooooool0ofKo0?mVool0001:ooooo`03o`000?oooooooooo00Gooooo
00Co0?mVoooooooo003oo`000_ooool00ol0003oooooooooo`08ooooo`?o0?mV00?oo`00oooooooo
ool09oooool00ol0ofKoooooool00002ooooo`03ool00?oooooooooo04Kooooo00?o0?mVool00?oo
ool06?ooool00ol0003oooooooooo`01ooooo`000oooool00ol0003oooooooooo`0Kooooo`03o`3o
I_oooooooooo03?ooooo00?o0?mVool00?ooool02?ooool01?oo003o0?mVo`3oI_oo001:ooooo`03
o`000?oooooooooo00Cooooo00?o0?mVoooooooo00001?ooool00ol0003oooooooooo`07ooooo`04
o`3oI_oo003oo`00ool002_ooooo00Co0?mVoooooooo003oo`00BOooool00ol0ofKoo`00ooooo`0H
ooooo`03o`000?oooooooooo007ooooo0003ooooo`03o`000?oooooooooo01_ooooo00?o0?mVoooo
ooooool0=?ooool00ol0ofKoooooooooo`08ooooo`04ool00?l0ofKo0?mVool004Wooooo00?o0000
ooooooooool00oooool00ol0ofKoo`00ool00005ooooo`03o`000?oooooooooo00Kooooo00?o0?mV
ool00?oo0000;?ooool00ol0ofKoooooo`3oIP02o`3oIP;oo`00Aoooool00ooo003oooooooooo`0H
ooooo`03o`000?oooooooooo007ooooo0003ooooo`03o`000?oooooooooo01_ooooo00?o0?mVoooo
ooooool0=Oooool00ol0ofKoooooooooo`08ooooo`03o`3oI_ooooooo`0004Wooooo00?o0000oooo
ooooool00_ooool00ooo003o0?mVooooo`06ooooo`03o`000?oooooooooo00Cooooo0ooo000]oooo
o`04o`3oI_ooooooooooool000;ooooo1?l0ofI4ooooo`;oo`006_ooool00ol0003oooooooooo`01
ooooo`000oooool00ol0003oooooooooo`0Looooo`03o`3oI_oooooooooo03Cooooo00?o0?mVoooo
ooooool02Oooool00ol0ofKoooooool00018ooooo`06o`000?oooooooooooooooooo003o0?mV2?oo
ool00ol0003oooooooooo`02ooooo`?oo`0000?o0?mVooooooooool0:oooool01?l0ofKooooooooo
oooo0007ooooo`Co0?mV?_ooool3o`3oIQ_ooooo00?o0000ooooooooool00Oooool000?ooooo00?o
0000ooooooooool07?ooool00ol0ofKoooooooooo`0dooooo`03ool00?l0ofKooooo00[ooooo0_l0
ofH00ooo003oooooooooo`15ooooo`05o`000?ooooooo`00ool00?l0ofH02Oooool00ol0003ooooo
ooooo`04ool00003o`3oI_oooooooooo02_ooooo00Co0?mVooooooooooooo`002_ooool00ooo003o
ooooo`3oIP03o`3oISWooooo00?o0?mVool00?ooool07?ooool00ol0003oooooooooo`01ooooo`00
0oooool00ol0003oooooooooo`0Looooo`03o`3oI_oooooooooo03Gooooo00?o0?mVooooooooool0
2Oooool00ol0ofKoo`00ool00017ooooo`03o`000?oo003o0?mV00_ooooo00?o0000ool00?oo0000
0_oo0002o`3oIRkooooo00?o0?mVoooooooo00003?ooool2ool000?ooooo1?l0ofHdooooo`;oo`00
7_ooool00ol0003oooooooooo`01ooooo`000oooool00ol0003oooooooooo`0Mooooo`03o`3oI_oo
oooooooo03Cooooo00?oo`00o`3oI_ooool02_ooool00ol0ofKoo`00ool00013ooooo`;o0?mV00?o
o`00o`000?ooool03?ooool01?oo003oooooool00?ooool2o`3oIRkooooo00?o0?mVoooooooo0000
3oooool2ool000Gooooo1?l0ofH^ooooo`;oo`008?ooool00ol0003oooooooooo`01ooooo`000ooo
ool00ol0003oooooooooo`0Mooooo`03o`3oI_oooooooooo03Cooooo00?oo`00o`3oI_ooool02_oo
ool00ol0ofKoo`00ool00002o`3oISoooooo0_l0ofH2ool00003ooooool0003ooooo00[ooooo1?oo
00000ooooooo0?mVo`3oIP0_ooooo`03o`3oI_oo003ooooo017ooooo1?oo0005ooooo`?o0?mV:Ooo
ool2ool00003o`3oI_oooooooooo01oooooo00?o0000ooooooooool00Oooool000?ooooo00?o0000
ooooooooool07Oooool00ol0ofKoooooooooo`0eooooo`03ool00?l0ofKooooo00[ooooo00Go0?mV
ool00?oo003oooooo`3oIP0kooooo`?o0?mV0_oo0003ooooo`03o`000?oooooooooo00Sooooo00Co
o`00oooooooo003o00000_l0ofH`ooooo`03o`3oI_oo003ooooo01Kooooo1ooo00001?oooooo0?mV
o`3oI_l0ofHUooooo`03ool00?oooooo0?mV02;ooooo00?o0000ooooooooool00Oooool000?ooooo
00?o0000ooooooooool07_ooool00ol0ofKoooooooooo`0dooooo`03ool00?oooooo0?mV00[ooooo
00Ko0?mVoooooooo003oo`00ooooool0ofHiooooo`04o`3oI_ooooooooooool000Gooooo00?o0000
ooooooooool01_ooool3ool000?o0?mV<_ooool00ooo003oooooooooo`0Mooooo`Coo`000_l0ofHS
ooooo`;o0?mV8oooool00ol0003oooooooooo`01ooooo`000oooool00ol0003oooooooooo`0Noooo
o`03o`3oI_oooooooooo03Cooooo00?oo`00ooooool0ofH02_ooool01ol0ofKoooooool00?oooooo
o`00ooooool0ofH0=oooool01?l0ofKoooooool00?oo0006ooooo`03o`000?oooooooooo00Gooooo
00?oo`00o`3oI_l0ofH00_l0ofH00ooooooo0000ooooo`0`ooooo`03ool00?oooooooooo02?ooooo
00?oo`00o`3oI_l0ofH08?ooool00ol0ofKoooooooooo`0Sooooo`03o`000?oooooooooo007ooooo
0003ooooo`03o`000?oooooooooo01kooooo00?o0?mVooooooooool0=Oooool00ooo003oooooo`3o
IP0:ooooo`07o`3oI_ooooooo`00oooooooo003oooooo`3oIP0eooooo`03o`3oI_oo003oo`0000So
oooo00?o0000ooooooooool00oooool2ool00003o`3oI_oo003o0?mV00?ooooo00?o0000oooooooo
ool0;_ooool00ooo003o0?mVooooo`0Wooooo`;o0?mV00?oo`00ooooooooool06_ooool00ol0ofKo
ooooooooo`0Tooooo`03o`000?oooooooooo007ooooo0003ooooo`03o`000?oooooooooo01oooooo
00?o0?mVooooooooool0=?ooool00ooo003oooooo`3oIP0:ooooo`03o`3oI_ooooooo`0000;ooooo
00?oo`00ooooool0ofH0<oooool2ool000[ooooo00Oo0000ooooooooooooooooo`3oI_oo003o0?mV
00;oo`0000?o0?mVooooooooool00_ooool00ol0003oooooooooo`0]ooooo`03ool00?l0ofKooooo
02[ooooo00?o0?mVool00?oo00005Ooo0005o`3oIROooooo00?o0000ooooooooool00Oooool000?o
oooo00?o0000ooooooooool07oooool00ol0ofKoooooooooo`0dooooo`04ool00?ooooooooooo`3o
IPWooooo00Co0?mVooooooooooooo`000_ooool00ooo003oooooo`3oIP0`ooooo`;oo`003?ooool0
0ol0003oooooo`3oIP04ool00003o`3oI_oooooooooo00Cooooo00?o0000ooooooooool0;?ooool0
0ooo003oooooo`3oIP0^ooooo`Co0?mV1oooool:o`3oIP04oooooooo003oo`00ool002Sooooo00?o
0000ooooooooool00Oooool000?ooooo00?o0000ooooooooool07oooool00ol0ofKoooooooooo`0e
ooooo`03ool00?oooooo0?mV00[ooooo00Co0?mVooooooooooooo`000_ooool00ooo003oooooo`3o
IP0]ooooo`;oo`0000?o0?mVooooooooool02_ooool01?l0ofKo0000o`3oI_oo0003o`3oIPSooooo
00?o0000ooooooooool0:oooool00ooo003oooooo`3oIP0cooooo`Oo0?mV=_ooool00ol0003ooooo
ooooo`01ooooo`000oooool00ol0003oooooooooo`0Pooooo`03o`3oI_oooooooooo03Gooooo00?o
o`00ooooool0ofH02Oooool01?l0ofKooooooooooooo0003ooooo`;oo`001Ol0ofHTooooo`;oo`00
1?l0ofH;ooooo`;o0?mV00Coooooo`000?oo003o0?mV2oooool00ol0003oooooooooo`0Zooooo`04
ool00?ooooooooooo`3oIW3ooooo00?o0000ooooooooool00Oooool000?ooooo00?o0000oooooooo
ool08?ooool00ol0ofKoooooooooo`0fooooo`03ool00?oooooo0?mV00Sooooo00Co0?mVoooooooo
oooooooo0_oo0005ooooo`?oo`001_l0ofHIooooo`Oo0?mV3Oooool2o`3oIP04oooooooo003oo`00
o`0000gooooo00?o0000ooooooooool0:Oooool01?oo003oooooooooool0ofIaooooo`03o`000?oo
oooooooo007ooooo0003ooooo`03o`000?oooooooooo023ooooo00?o0?mVooooooooool0=oooool0
0ooo003o0?mVooooo`08ooooo`?o0?mV0_ooool2ool000Sooooo1?oo0003o`3oIPcooooo2?oo0002
o`3oIQ?ooooo00Oo0?mVoooooooo003oo`00o`3oI_oooooo000000gooooo00?o0000ooooooooool0
:?ooool01Ooo003ooooooooooooooooo0?mV077ooooo00?o0000ooooooooool00Oooool000;ooooo
00?o0000ooooooooool08_ooool00ol0ofKoooooooooo`0gooooo`03ool00?l0ofKooooo00[ooooo
0ol0ofH00oooooooo`00ool0000=ooooo`?o0?mV2Ooo0004o`3oIQOooooo0_l0ofH2ool000;o0?mV
0_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02Oooooo00?oo`00ooooooooool0
0_l0ofIbooooo`03o`000?oooooooooo007ooooo0002ooooo`03o`000?oooooooooo02;ooooo00?o
0?mVooooooooool0>?ooool00ol0ofKoooooooooo`0<ooooo`?o0?mV0_oo000>ooooo`?o0?mV0_oo
ool4o`3oIQWooooo0_l0ofH3ool00003o`3oI_oooooooooo00;ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0Uooooo`;oo`000_ooool00ol0ofKoooooooooo`1booooo`03o`000?oo
oooooooo007ooooo0002ooooo`03o`000?oooooooooo02;ooooo00?o0?mVool00?ooool0>Oooool2
o`3oIPoooooo0ol0ofH@ooooo`;o0?mV6_ooool01?oo003o0?mVo`3oI_ooool2ool00003ooooool0
ofKooooo00Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Tooooo`05ool00?oo
ooooooooooooool0ofH0MOooool00ol0003oooooooooo`01ooooo`000_ooool00ol0003ooooooooo
o`0Sooooo`03o`3oI_oooooooooo03[ooooo00?o0?mVool00?ooool03oooool3o`3oIRKooooo0ooo
00001?l0ofKoooooool00?oo0002ooooo`03o`3oI_oooooooooo00Cooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0Sooooo`03ool00?oooooooooo00;o0?mVM_ooool00ol0003ooooo
ooooo`01ooooo`000_ooool00ol0003oooooooooo`0Sooooo`03o`3oI_oooooooooo03_ooooo00?o
0?mVool00?oo00004?ooool01?oo003o0?mVo`3oI_l0ofH9ooooo`Go0?mV4oooool2ool00003oooo
ool0ofKo0?mV00;oo`000_ooool2o`3oIPOooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0Rooooo`04ool00?ooooooooooo`3oIWSooooo00?o0000ooooooooool00Oooool000;ooooo
00?o0000ooooooooool08oooool00ol0ofKoo`00ooooo`0looooo`04o`3oI_ooooooo`00ool0013o
oooo0ooo0003o`3oIP;ooooo0ol0ofH2ooooo`?oo`001Ol0ofH<ooooo`;oo`000ol0ofH2ool00004
ooooool0ofKo0?mVo`3oIPWooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Qoooo
o`04ool00?ooooooooooo`3oIWWooooo00?o0000ooooooooool00Oooool000;ooooo00?o0000oooo
ooooool09?ooool00ol0ofKoooooooooo`0looooo`03o`3oI_oooooooooo00;oo`004Oooool4ool0
0003o`3oI_oooooooooo00?oo`001?ooool4ool000Go0?mV1?ooool5o`3oIP;oo`0000Coooooo`3o
I_l0ofKo0?mV3?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo023ooooo00Coo`00
ooooool0ofKo0?mVN_ooool00ol0003oooooooooo`01ooooo`000_ooool00ol0003oooooooooo`0T
ooooo`03o`3oI_oo003ooooo03gooooo00Co0?mVoooooooooooooooo0_oo000Cooooo`?oo`003?oo
ool4ool000Co0?mV00?oo`00ooooooooool00_oo00000ooooooo0?mVo`3oIP0?ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool07oooool00ooo003oooooo`3oIP1mooooo`7o00000Ooo
ool1ooooo`000_ooool00ol0003oooooooooo`0Tooooo`03o`3oI_oo003ooooo03kooooo00?o0?mV
ooooooooool00_ooool2ool002Gooooo0_oo00001?ooooooo`00ool00?oo0003o`3oIQ7ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0Nooooo`03ool00?l0ofKo0?mV07kooooo0Ol0
0001ooooo`7ooooo0002ooooo`03o`000?oooooooooo02Gooooo00?o0?mVool00?ooool0?_ooool3
o`3oIP?ooooo0ooo000Looooo`Ko0?mV0ooo0003o`3oIQCooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0Mooooo`03ool00?l0ofKooooo07oooooo0Ol00001ooooo`7ooooo0002oooo
o`03o`000?oooooooooo02Gooooo00?o0?mVool00?ooool0@Oooool3o`3oIP?ooooo0_oo000Ioooo
o`04o`3oI_ooooooooooooooo`?oo`006_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo01cooooo00?oo`00o`3oI_ooool0P?ooool1o`00007ooooo0Oooool000;ooooo00?o0000oooo
ooooool09_ooool00ol0ofKoooooooooo`13ooooo`Co0?mV00?oooooool00?oo00005Oooool2o`3o
IPCoo`007Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01_ooooo00?oo`00o`3o
I_ooool0POooool1o`00007ooooo0Oooool000;ooooo00?o0000ooooooooool09_ooool00ol0ofKo
o`00ooooo`17ooooo`?o0?mV0ooo0007ooooo`[oo`0000?o0?mVooooooooool08Oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo01[ooooo00?oo`00ooooooooool0P_ooool1o`00007o
oooo0Oooool000;ooooo00?o0000ooooooooool09_ooool00ol0ofKoo`00ooooo`1:ooooo`?o0?mV
1ooo0009ooooo`03o`3oI_oooooooooo02;ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0Iooooo`03ool00?oooooooooo08?ooooo0Ol00001ooooo`7ooooo0002ooooo`03o`000?oo
oooooooo02Oooooo00?o0?mVool00?ooool0C?ooool@o`3oIRGooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0Gooooo`03o`3oI_oo003ooooo08Gooooo0Ol00001ooooo`7ooooo0002
ooooo`03o`000?oooooooooo02Oooooo00?o0?mVool00?ooool0POooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo01Kooooo00?o0?mVool00?ooool0Q_ooool1o`00007ooooo0Oooool0
00;ooooo00?o0000ooooooooool09oooool00ol0ofKoooooool00021ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool05Oooool2ool008Sooooo0Ol00001ooooo`7ooooo0002ooooo`03
o`000?oooooooooo02Sooooo00?o0?mVool00?ooool0P?ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo01?ooooo00?o0?mVool00?ooool0ROooool1o`00007ooooo0Oooool000;ooooo
00?o0000ooooooooool0:?ooool00ol0ofKoo`00ooooo`20ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool04_ooool2ool008_ooooo0Ol00001ooooo`7ooooo0002ooooo`03o`000?oo
oooooooo02Sooooo00?o0?mVoooooooo0000P?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo013ooooo00?o0?mVool00?ooool0S?ooool1o`00007ooooo0Oooool000;ooooo00?o0000
ooooooooool0:Oooool00ol0ofKoo`00ooooo`1oooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool03oooool2ool008kooooo0Ol00001ooooo`7ooooo0002ooooo`03o`000?oooooooooo
02Wooooo00?o0?mVoooooooo0000Ooooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00gooooo00?o0?mVool00?ooool0Soooool1o`00007ooooo0Oooool000;ooooo00?o0000oooooooo
ool0:_ooool00ol0ofKoo`00ooooo`1nooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool02oooool00ol0ofKoo`00ool0002Aooooo`7o00000Oooool1ooooo`000_ooool00ol0003ooooo
ooooo`0[ooooo`03o`3oI_oo003ooooo07gooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0:ooooo`03o`3oI_oo003ooooo09;ooooo0Ol00001ooooo`7ooooo0002ooooo`03o`000?oo
oooooooo02cooooo00?o0?mVool00?ooool0O?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00Sooooo00?o0?mVool00?oo0000U?ooool1o`00007ooooo0Oooool000;ooooo00?o0000
ooooooooool0;Oooool00ol0ofKoo`00ooooo`1kooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool01oooool00ol0ofKoo`00ooooo`2Eooooo`7o00000Oooool1ooooo`0000?oooooo`00
0?ooool0<?ooool00ol0ofKoo`00ooooo`1jooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool01Oooool00ol0ofKoo`00ool0002Gooooo`7o00000Oooool1ooooo`0000?oooooo`000?oo
ool0<Oooool00ol0ofKoo`00ooooo`1iooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool01?ooool00ol0ofKoo`00ooooo`2Hooooo`7o00000Oooool1ooooo`0000?oooooo`000?ooool0
<_ooool00ol0ofKoo`00ooooo`1hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
0_ooool00ol0ofKoo`00ool0002Jooooo`7o00000Oooool1ooooo`0000?oooooo`000?ooool0<ooo
ool00ol0ofKoo`00ooooo`1gooooo`03o`000?oooooooooo00_ooooo00Ko0000oooooooooooooooo
o`3oI_oo002Looooo`7o00000Oooool1ooooo`0000?oooooo`000?ooool0=?ooool00ol0ofKoo`00
ooooo`1fooooo`03o`000?oooooooooo00_ooooo00Go0000oooooooooooo0?mVool0002Mooooo`7o
00000Oooool1ooooo`0000?oooooo`000?ooool0=Oooool00ol0ofKoo`00ooooo`1eooooo`03o`00
0?oooooooooo00_ooooo00Co0000ooooool0ofKoo`00W_ooool1o`00007ooooo0Oooool00003oooo
ool0003ooooo03Kooooo00?o0?mVool00?ooool0M?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?l0ofKoo`0009oooooo0Ol00001ooooo`7ooooo00000ooooooo0000ooooo`0fooooo`03o`3oI_oo
ooooo`0007Cooooo00?o0000ooooooooool02oooool00ol0ofKoo`00ooooo`2Pooooo`7o00000Ooo
ool00003ooooool0003ooooo03Oooooo00?o0?mVoooooooo0000Loooool00ol0003oooooooooo`0:
ooooo`03o`3oI_oo003ooooo0:7ooooo0Ol00001ooooo`0000?oooooo`000?ooool0>?ooool00ol0
ofKoooooool0001booooo`03o`000?oooooooooo00Wooooo00?o0?mVool00?l00000X_ooool1o`00
007ooooo00000ooooooo0000ooooo`0iooooo`03o`3oI_ooooooo`00077ooooo00?o0000oooooooo
ool02?ooool2ool00003ooooool0003ooooo0:7ooooo0Ol00001ooooo`0000?oooooo`000?ooool0
>_ooool00ol0ofKoooooool0001`ooooo`03o`000?oooooooooo00Oooooo00Goo`00oooooooooooo
ooooo`00002Rooooo`7o00000Oooool00003ooooool0003ooooo03_ooooo00?o0?mVoooooooo0000
Koooool00ol0003oooooooooo`06ooooo`03ool00?oooooooooo00;ooooo00?o0000ooooooooool0
X?ooool1o`00007ooooo00000ooooooo0000ooooo`0looooo`03o`3oI_ooooooo`0006kooooo00?o
0000ooooooooool01Oooool00ooo003oooooooooo`03ooooo`03o`000?oooooooooo0:3ooooo0Ol0
0001ooooo`0000?oooooo`000?ooool0?Oooool01?l0ofKoooooool00?oo001/ooooo`03o`000?oo
oooooooo00Cooooo00?oo`00ooooooooool01?ooool00ol0003oooooooooo`2Pooooo`7o00000Ooo
ool00003ooooool0003ooooo03kooooo00Co0?mVooooooooooooo`00Joooool00ol0003ooooooooo
o`03ooooo`03ool00?oooooooooo00Gooooo00?o0000ooooooooool0X?ooool1o`00007ooooo0000
0ooooooo0000ooooo`0oooooo`04o`3oI_ooooooooooool006[ooooo00?o0000ooooooooool00_oo
ool00ooo003oooooooooo`06ooooo`03o`000?oooooooooo0:3ooooo0Ol00001ooooo`0000?ooooo
o`000?ooool0@?ooool2o`3oIP03oooooooo003oo`0006Sooooo00Go0000ooooooooooooooooool0
0009ooooo`03o`000?oooooooooo0:3ooooo0Ol00001ooooo`0000?oooooo`000?ooool0@_ooool2
o`3oIP03oooooooo003ooooo06Kooooo00Co0000oooooooo003oo`002_ooool00ol0003ooooooooo
o`2Pooooo`7o00000Oooool00003ooooool0003ooooo04Cooooo0_l0ofH00ooo003oooooooooo`1T
ooooo`03o`000?oo003o0?mV00_ooooo00?o0000ooooooooool0X?ooool1o`00007ooooo00000ooo
oooo0000ooooo`16ooooo`03o`3oI_oo003ooooo06;ooooo0_oo00000ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo0:3ooooo0Ol00001ooooo`0000?oooooo`000?ooool0Aoooool00ol0ofKo
o`00ool0001Nooooo`03o`3oI_oo003oo`0000;ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`2Pooooo`7o00000Oooool00003ooooool0003ooooo04Wooooo00?o0?mVool00?ooool0
FOooool2o`3oIP;oo`001?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0:3ooooo
0Ol00001ooooo`0000?oooooo`000?ooool0Boooool00ooo003o0?mVooooo`1Eooooo`04o`3oI_oo
003oo`00ool000Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Pooooo`7o0000
0Oooool00003ooooool0003ooooo04cooooo0_oo00000ol0ofKoooooooooo`1?ooooo`;o0?mV0_oo
0009ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0X?ooool1o`00007ooooo0000
0ooooooo0000ooooo`1>ooooo`03ool00?l0ofKooooo04cooooo0ol0ofH2ool000Cooooo3?l00009
ooooo`03o`000?oooooooooo0:3ooooo0Ol00001ooooo`0000?o0000ooooooooool0Coooool00ooo
003o0?mVo`3oIP17ooooo`go00003?ooool:o`000:;ooooo0Ol00001ooooo`0000?o0000oooooooo
ool0D?ooool01?oo003oooooo`3oI_l0ofHgooooo`ko00000_l0ofH00oooooooo`00ool0000Moooo
o`Wo0000V_ooool1o`00007ooooo00000ol0003oooooooooo`1Aooooo`;oo`0000?oooooo`3oI_l0
ofH0:?ooool=o`0000_ooooo0_l0ofH2ooooo`;oo`007oooool00ol0003oooooooooo`06ooooo`Wo
0000TOooool1o`00007ooooo00000ol0003oooooooooo`1Cooooo`?oo`000_l0ofHHooooo`ko0000
5_ooool2o`3oIP04oooooooo003oo`00ool0027ooooo00?o0000ooooooooool03oooool9o`0008So
oooo0Ol00001ooooo`0000?o0000ooooooooool0E_ooool2ool000?o0?mV2?ooool=o`00027ooooo
0ol0ofH3ool002Cooooo00?o0000ooooooooool06?ooool9o`0007oooooo0Ol00001ooooo`0000?o
0000ooooooooool0EOooool>o`0002cooooo0_l0ofH2ool002Sooooo00?o0000ooooooooool08Ooo
ool9o`0007Kooooo0Ol00001ooooo`0000?o0000ooooooooool0Aoooool>o`0000Oooooo00?oo`00
o`3oI_l0ofH0:oooool3ool000;o0?mV;?ooool00ol0003oooooooooo`0Zooooo`Wo0000KOooool1
o`00007ooooo00000ol0003oooooooooo`0jooooo`go00006?ooool2o`3oIRGooooo1?oo0003o`3o
IRkooooo00?o0000ooooooooool0<oooool9o`0006Gooooo0Ol000000003o`000?oooooooooo02co
oooo3_l0000Wooooo`;o0?mV00?oo`00ooooooooool07?ooool4ool000;ooooo0_l0ofHaooooo`03
o`000?oooooooooo03cooooo2Ol0001Looooo`7o000000000ol0003oooooooooo`0Oooooo`go0000
=oooool3o`3oIP03ool00?oooooooooo01;ooooo1ooo0004ooooo`;o0?mV<oooool00ol0003ooooo
ooooo`15ooooo`So0000E?ooool1o`00000000?o0000ooooooooool04Oooool>o`0004Oooooo0_l0
ofH2ool000Kooooo2ooo0008ooooo`?o0?mV=Oooool00ol0003oooooooooo`1=ooooo`Wo0000Booo
ool1o`00000000?o0000ooooooooool01?ooool=o`0005Oooooo0_l0ofH6ool000Kooooo3Ol0ofHh
ooooo`03o`000?oooooooooo05Kooooo2Ol00012ooooo`7o00000007o`0006Kooooo3?l0ofI5oooo
o`03o`000?oooooooooo05oooooo2Ol0000iooooo`7o00000007ooooo`go0000Z_ooool00ol0003o
ooooooooo`1Xooooo`Wo0000<?ooool1o`0000005?ooool=o`0009gooooo00?o0000ooooooooool0
LOooool9o`0002Oooooo0Ol00000027ooooo3?l0002Aooooo`03o`000?oooooooooo07[ooooo2Ol0
000Nooooo`7o0000000]ooooo`go0000Q?ooool00ol0003oooooooooo`23ooooo`Wo00005Oooool1
o`000000>_ooool=o`0007Oooooo00?o0000ooooooooool0S?ooool9o`0000cooooo0Ol0000004Oo
oooo3?l0001[ooooo`03o`000?oooooooooo09Gooooo2Ol00003ooooo`7o0000001Cooooo`go0000
G_ooool00ol0003oooooooooo`2Gooooo`_o0000001Pooooo`go0000DOooool00ol0003ooooooooo
o`22oooooaGo00002oooool006gooooo3?l00015ooooo`03o`000?oooooooooo06kooooo5?l0000P
ooooo`00NOooool=o`0003Sooooo00?o0000ooooooooool0FOoooolEo`0003Cooooo0026ooooo`go
0000:oooool00ol0003oooooooooo`15oooooaCo0000BOooool009?ooooo3?l0000Oooooo`03o`00
0?oooooooooo033ooooo5Ol0001Mooooo`00Woooool=o`0001;ooooo00?o0000ooooooooool07?oo
oolDo`0007;ooooo002/ooooo`go00001Oooool00ol0003oooooooooo`07oooooaGo0000Q_ooool0
0;Wooooo3ol0002Kooooo`00\
\>"],
  ImageRangeCache->{{{0, 354}, {383.375, 0}} -> {0.0750046, -2.0797*^-5, \
0.00230137, 0.00230137}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF, kappa=0", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta+1, 
\t     {driftLorenzX, diffusionLorenzX, hLorenzX, RLorenzX, \
mueLorenzX,sigmaLorenzX,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(clik\\)\\\" is similar to existing symbol \\\
\"\\!\\(lik\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({1.4827530000000024`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({85.92450297702389`, 138.93458100607918`, 162.27860526602873`, 
      25.124211350457283`, 15.785943582383661`, 
      9.072893183135154`}\)], "Output"],

Cell[BoxData[
    \({{\(-0.15813944673156624`\), \(-0.28708504501483323`\), \
\(-1.0898921683179885`\), \(-0.7000809574523111`\), \
\(-0.39841203439347644`\), \(-0.09944811877569192`\)}, {2.711205724888604`, 
        4.38190785412`, 5.012002868199228`, 0.37480935633268303`, 
        0.30035798402728153`, 0.2689706809840046`}}\)], "Output"]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,15},{25,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.01{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(yrange\\)\\\" is similar to existing symbol \
\\\"\\!\\(range\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({{\(-30\), 20}, {\(-30\), 30}, {0, 60}, {5, 15}, {25, 35}, {0, 
        8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gUKF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],
            PlotLabel->\"UKF, kappa=0\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gUKF\\)\\\" is similar to existing symbols \
\\!\\({gEKF, UKF}\\). \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -38 0 ]
[.5 .42452 38 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -0.309017 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -6 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -6 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(6)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(8)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(10)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(12)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(14)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30902 m
.001 .30902 L
.002 .30902 L
.003 .30902 L
.004 .30902 L
.005 .30902 L
.00599 .30902 L
.00699 .30902 L
.00799 .30902 L
.00899 .30902 L
.00999 .30902 L
.01099 .30902 L
.01199 .30902 L
.01299 .30902 L
.01399 .30902 L
.01499 .30902 L
.01598 .30902 L
.01698 .30902 L
.01798 .30902 L
.01898 .30902 L
.01998 .30902 L
.02098 .30902 L
.02198 .30902 L
.02298 .30902 L
.02398 .30902 L
.02498 .30902 L
.02597 .30902 L
.02697 .30902 L
.02797 .30902 L
.02897 .30902 L
.02997 .30902 L
.03097 .30902 L
.03197 .30902 L
.03297 .30902 L
.03397 .30902 L
.03497 .30902 L
.03596 .30902 L
.03696 .30902 L
.03796 .30902 L
.03896 .30902 L
.03996 .30902 L
.04096 .30902 L
.04196 .30902 L
.04296 .30902 L
.04396 .30902 L
.04496 .30902 L
.04595 .30902 L
.04695 .30902 L
.04795 .30902 L
.04895 .30902 L
Mistroke
.04995 .30902 L
.05095 .30902 L
.05195 .30902 L
.05295 .30902 L
.05395 .30902 L
.05495 .30902 L
.05594 .30902 L
.05694 .30902 L
.05794 .30902 L
.05894 .30902 L
.05994 .30902 L
.06094 .30902 L
.06194 .30902 L
.06294 .30902 L
.06394 .30902 L
.06494 .30902 L
.06593 .30902 L
.06693 .30902 L
.06793 .30902 L
.06893 .30902 L
.06993 .30902 L
.07093 .30902 L
.07193 .30902 L
.07293 .30902 L
.07393 .30902 L
.07493 .30902 L
.07592 .30902 L
.07692 .30902 L
.07792 .30902 L
.07892 .30902 L
.07992 .30902 L
.08092 .30902 L
.08192 .30902 L
.08292 .30902 L
.08392 .30902 L
.08492 .30902 L
.08591 .30902 L
.08691 .30902 L
.08791 .30902 L
.08891 .30902 L
.08991 .30902 L
.09091 .30902 L
.09191 .30902 L
.09291 .30902 L
.09391 .30902 L
.09491 .30902 L
.0959 .30902 L
.0969 .30902 L
.0979 .30902 L
.0989 .30902 L
Mistroke
.0999 .30902 L
.1009 .30902 L
.1019 .30902 L
.1029 .30902 L
.1039 .30902 L
.1049 .30902 L
.10589 .30902 L
.10689 .30902 L
.10789 .30902 L
.10889 .30902 L
.10989 .30902 L
.11089 .30902 L
.11189 .30902 L
.11289 .30902 L
.11389 .30902 L
.11489 .30902 L
.11588 .30902 L
.11688 .30902 L
.11788 .30902 L
.11888 .30902 L
.11988 .30902 L
.12088 .30902 L
.12188 .30902 L
.12288 .30902 L
.12388 .30902 L
.12488 .30902 L
.12587 .30902 L
.12687 .30902 L
.12787 .30902 L
.12887 .30902 L
.12987 .30902 L
.13087 .30902 L
.13187 .30902 L
.13287 .30902 L
.13387 .30902 L
.13487 .30902 L
.13586 .30902 L
.13686 .30902 L
.13786 .30902 L
.13886 .30902 L
.13986 .30902 L
.14086 .30901 L
.14186 .30901 L
.14286 .30901 L
.14386 .30901 L
.14486 .30901 L
.14585 .30901 L
.14685 .30901 L
.14785 .30901 L
.14885 .30901 L
Mistroke
.14985 .30901 L
.15085 .30901 L
.15185 .30901 L
.15285 .30901 L
.15385 .30902 L
.15485 .30902 L
.15584 .30902 L
.15684 .30902 L
.15784 .30902 L
.15884 .30902 L
.15984 .30902 L
.16084 .30902 L
.16184 .30902 L
.16284 .30902 L
.16384 .30902 L
.16484 .30902 L
.16583 .30902 L
.16683 .30902 L
.16783 .30902 L
.16883 .30902 L
.16983 .30902 L
.17083 .30902 L
.17183 .30902 L
.17283 .30902 L
.17383 .30902 L
.17483 .30902 L
.17582 .30902 L
.17682 .30902 L
.17782 .30902 L
.17882 .30902 L
.17982 .30902 L
.18082 .30902 L
.18182 .30902 L
.18282 .30902 L
.18382 .30902 L
.18482 .30902 L
.18581 .30902 L
.18681 .30902 L
.18781 .30902 L
.18881 .30902 L
.18981 .30902 L
.19081 .30902 L
.19181 .30902 L
.19281 .30902 L
.19381 .30902 L
.19481 .30902 L
.1958 .30902 L
.1968 .30902 L
.1978 .30902 L
.1988 .30902 L
Mistroke
.1998 .30902 L
.2008 .30902 L
.2018 .30902 L
.2028 .30902 L
.2038 .30902 L
.2048 .30901 L
.20579 .30902 L
.20679 .30902 L
.20779 .30901 L
.20879 .30902 L
.20979 .30902 L
.21079 .30902 L
.21179 .30902 L
.21279 .30902 L
.21379 .30902 L
.21479 .30902 L
.21578 .30901 L
.21678 .30901 L
.21778 .30901 L
.21878 .30901 L
.21978 .30901 L
.22078 .30901 L
.22178 .30901 L
.22278 .30901 L
.22378 .30901 L
.22478 .30901 L
.22577 .30901 L
.22677 .30901 L
.22777 .30901 L
.22877 .30901 L
.22977 .30901 L
.23077 .30901 L
.23177 .30901 L
.23277 .30901 L
.23377 .30901 L
.23477 .30901 L
.23576 .30901 L
.23676 .30901 L
.23776 .30901 L
.23876 .30901 L
.23976 .30901 L
.24076 .30901 L
.24176 .30901 L
.24276 .30901 L
.24376 .30901 L
.24476 .30901 L
.24575 .30901 L
.24675 .30901 L
.24775 .30901 L
.24875 .30901 L
Mistroke
.24975 .30901 L
.25075 .30901 L
.25175 .30901 L
.25275 .30901 L
.25375 .30901 L
.25475 .30901 L
.25574 .30901 L
.25674 .30901 L
.25774 .30901 L
.25874 .30901 L
.25974 .30901 L
.26074 .30901 L
.26174 .30901 L
.26274 .30901 L
.26374 .30901 L
.26474 .30901 L
.26573 .30901 L
.26673 .30901 L
.26773 .30901 L
.26873 .30901 L
.26973 .30901 L
.27073 .30901 L
.27173 .30901 L
.27273 .30901 L
.27373 .30901 L
.27473 .30901 L
.27572 .30901 L
.27672 .30901 L
.27772 .30901 L
.27872 .30901 L
.27972 .30901 L
.28072 .30901 L
.28172 .30901 L
.28272 .30901 L
.28372 .30901 L
.28472 .30901 L
.28571 .30901 L
.28671 .30901 L
.28771 .30901 L
.28871 .30901 L
.28971 .30901 L
.29071 .30901 L
.29171 .30901 L
.29271 .30901 L
.29371 .30901 L
.29471 .30901 L
.2957 .30901 L
.2967 .30901 L
.2977 .30901 L
.2987 .30901 L
Mistroke
.2997 .30901 L
.3007 .30901 L
.3017 .30901 L
.3027 .30901 L
.3037 .30901 L
.3047 .30901 L
.30569 .30901 L
.30669 .30901 L
.30769 .30901 L
.30869 .30901 L
.30969 .30901 L
.31069 .30901 L
.31169 .30901 L
.31269 .30901 L
.31369 .30901 L
.31469 .30901 L
.31568 .30901 L
.31668 .309 L
.31768 .30901 L
.31868 .30901 L
.31968 .30901 L
.32068 .30901 L
.32168 .30901 L
.32268 .30901 L
.32368 .30901 L
.32468 .30901 L
.32567 .30901 L
.32667 .30901 L
.32767 .309 L
.32867 .309 L
.32967 .309 L
.33067 .309 L
.33167 .309 L
.33267 .309 L
.33367 .309 L
.33467 .309 L
.33566 .309 L
.33666 .309 L
.33766 .309 L
.33866 .309 L
.33966 .309 L
.34066 .309 L
.34166 .309 L
.34266 .309 L
.34366 .309 L
.34466 .309 L
.34565 .309 L
.34665 .309 L
.34765 .309 L
.34865 .309 L
Mistroke
.34965 .309 L
.35065 .309 L
.35165 .309 L
.35265 .309 L
.35365 .309 L
.35465 .309 L
.35564 .309 L
.35664 .309 L
.35764 .309 L
.35864 .309 L
.35964 .309 L
.36064 .309 L
.36164 .309 L
.36264 .309 L
.36364 .309 L
.36464 .309 L
.36563 .309 L
.36663 .309 L
.36763 .309 L
.36863 .309 L
.36963 .309 L
.37063 .309 L
.37163 .309 L
.37263 .309 L
.37363 .309 L
.37463 .309 L
.37562 .309 L
.37662 .309 L
.37762 .309 L
.37862 .309 L
.37962 .309 L
.38062 .309 L
.38162 .309 L
.38262 .309 L
.38362 .309 L
.38462 .309 L
.38561 .309 L
.38661 .309 L
.38761 .309 L
.38861 .309 L
.38961 .309 L
.39061 .309 L
.39161 .309 L
.39261 .309 L
.39361 .309 L
.39461 .309 L
.3956 .309 L
.3966 .309 L
.3976 .309 L
.3986 .309 L
Mistroke
.3996 .309 L
.4006 .309 L
.4016 .309 L
.4026 .309 L
.4036 .309 L
.4046 .309 L
.40559 .309 L
.40659 .309 L
.40759 .309 L
.40859 .309 L
.40959 .309 L
.41059 .309 L
.41159 .309 L
.41259 .309 L
.41359 .309 L
.41459 .309 L
.41558 .309 L
.41658 .309 L
.41758 .309 L
.41858 .309 L
.41958 .309 L
.42058 .309 L
.42158 .309 L
.42258 .309 L
.42358 .30901 L
.42458 .309 L
.42557 .309 L
.42657 .309 L
.42757 .309 L
.42857 .309 L
.42957 .309 L
.43057 .309 L
.43157 .309 L
.43257 .309 L
.43357 .309 L
.43457 .309 L
.43556 .309 L
.43656 .309 L
.43756 .309 L
.43856 .309 L
.43956 .309 L
.44056 .309 L
.44156 .309 L
.44256 .309 L
.44356 .309 L
.44456 .309 L
.44555 .309 L
.44655 .309 L
.44755 .309 L
.44855 .309 L
Mistroke
.44955 .309 L
.45055 .309 L
.45155 .309 L
.45255 .309 L
.45355 .309 L
.45455 .309 L
.45554 .309 L
.45654 .309 L
.45754 .309 L
.45854 .309 L
.45954 .309 L
.46054 .309 L
.46154 .309 L
.46254 .309 L
.46354 .309 L
.46454 .309 L
.46553 .309 L
.46653 .309 L
.46753 .309 L
.46853 .309 L
.46953 .309 L
.47053 .309 L
.47153 .309 L
.47253 .309 L
.47353 .309 L
.47453 .309 L
.47552 .309 L
.47652 .309 L
.47752 .309 L
.47852 .309 L
.47952 .309 L
.48052 .309 L
.48152 .309 L
.48252 .309 L
.48352 .309 L
.48452 .309 L
.48551 .309 L
.48651 .309 L
.48751 .309 L
.48851 .309 L
.48951 .309 L
.49051 .309 L
.49151 .309 L
.49251 .309 L
.49351 .309 L
.49451 .309 L
.4955 .309 L
.4965 .309 L
.4975 .309 L
.4985 .309 L
Mistroke
.4995 .309 L
.5005 .309 L
.5015 .309 L
.5025 .309 L
.5035 .309 L
.5045 .309 L
.50549 .309 L
.50649 .30901 L
.50749 .30901 L
.50849 .30901 L
.50949 .30901 L
.51049 .30901 L
.51149 .30901 L
.51249 .30901 L
.51349 .30901 L
.51449 .30901 L
.51548 .30901 L
.51648 .30901 L
.51748 .30901 L
.51848 .30901 L
.51948 .30901 L
.52048 .30901 L
.52148 .30901 L
.52248 .30901 L
.52348 .30901 L
.52448 .30901 L
.52547 .30901 L
.52647 .30901 L
.52747 .30901 L
.52847 .30901 L
.52947 .30901 L
.53047 .30901 L
.53147 .30901 L
.53247 .30901 L
.53347 .30901 L
.53447 .30901 L
.53546 .30901 L
.53646 .30901 L
.53746 .30901 L
.53846 .30901 L
.53946 .30901 L
.54046 .30901 L
.54146 .30901 L
.54246 .30901 L
.54346 .30901 L
.54446 .30901 L
.54545 .30901 L
.54645 .30901 L
.54745 .30901 L
.54845 .30901 L
Mistroke
.54945 .30901 L
.55045 .30901 L
.55145 .30901 L
.55245 .30901 L
.55345 .30901 L
.55445 .30901 L
.55544 .30901 L
.55644 .30901 L
.55744 .30901 L
.55844 .30901 L
.55944 .30901 L
.56044 .30901 L
.56144 .30901 L
.56244 .30901 L
.56344 .30901 L
.56444 .30901 L
.56543 .30901 L
.56643 .30901 L
.56743 .30901 L
.56843 .30901 L
.56943 .30901 L
.57043 .30901 L
.57143 .30901 L
.57243 .30901 L
.57343 .30901 L
.57443 .30901 L
.57542 .30901 L
.57642 .30901 L
.57742 .30901 L
.57842 .30901 L
.57942 .30901 L
.58042 .30901 L
.58142 .30901 L
.58242 .30901 L
.58342 .30901 L
.58442 .30901 L
.58541 .30901 L
.58641 .30901 L
.58741 .30901 L
.58841 .30901 L
.58941 .30901 L
.59041 .30901 L
.59141 .30901 L
.59241 .30901 L
.59341 .30901 L
.59441 .30901 L
.5954 .30901 L
.5964 .30901 L
.5974 .30901 L
.5984 .30901 L
Mistroke
.5994 .30901 L
.6004 .30901 L
.6014 .30901 L
.6024 .30901 L
.6034 .30901 L
.6044 .30901 L
.60539 .30901 L
.60639 .30901 L
.60739 .30901 L
.60839 .30901 L
.60939 .30901 L
.61039 .30901 L
.61139 .30901 L
.61239 .30901 L
.61339 .30901 L
.61439 .30901 L
.61538 .30901 L
.61638 .30901 L
.61738 .30901 L
.61838 .30901 L
.61938 .30901 L
.62038 .30901 L
.62138 .30901 L
.62238 .30901 L
.62338 .30901 L
.62438 .30901 L
.62537 .30901 L
.62637 .30901 L
.62737 .30901 L
.62837 .30901 L
.62937 .30901 L
.63037 .30901 L
.63137 .30901 L
.63237 .30901 L
.63337 .30901 L
.63437 .30901 L
.63536 .30901 L
.63636 .30901 L
.63736 .30901 L
.63836 .30901 L
.63936 .30901 L
.64036 .30901 L
.64136 .30901 L
.64236 .30901 L
.64336 .30901 L
.64436 .30901 L
.64535 .30901 L
.64635 .30901 L
.64735 .30901 L
.64835 .30901 L
Mistroke
.64935 .30901 L
.65035 .30901 L
.65135 .30901 L
.65235 .30901 L
.65335 .30901 L
.65435 .30901 L
.65534 .30901 L
.65634 .30901 L
.65734 .30901 L
.65834 .30901 L
.65934 .30901 L
.66034 .30901 L
.66134 .30901 L
.66234 .30901 L
.66334 .30901 L
.66434 .30901 L
.66533 .30901 L
.66633 .30901 L
.66733 .30901 L
.66833 .30901 L
.66933 .30901 L
.67033 .30901 L
.67133 .30901 L
.67233 .30901 L
.67333 .30901 L
.67433 .30901 L
.67532 .30901 L
.67632 .30901 L
.67732 .30901 L
.67832 .30901 L
.67932 .30901 L
.68032 .30901 L
.68132 .30901 L
.68232 .30901 L
.68332 .30901 L
.68432 .30901 L
.68531 .30901 L
.68631 .30901 L
.68731 .30901 L
.68831 .30901 L
.68931 .30901 L
.69031 .30901 L
.69131 .30901 L
.69231 .30901 L
.69331 .30901 L
.69431 .30901 L
.6953 .30901 L
.6963 .30901 L
.6973 .30901 L
.6983 .30901 L
Mistroke
.6993 .30901 L
.7003 .30901 L
.7013 .30901 L
.7023 .30901 L
.7033 .30901 L
.7043 .30901 L
.70529 .30901 L
.70629 .30901 L
.70729 .30901 L
.70829 .30901 L
.70929 .30901 L
.71029 .30901 L
.71129 .30901 L
.71229 .30901 L
.71329 .30901 L
.71429 .30901 L
.71528 .30901 L
.71628 .30901 L
.71728 .30901 L
.71828 .30901 L
.71928 .30901 L
.72028 .30901 L
.72128 .309 L
.72228 .309 L
.72328 .309 L
.72428 .309 L
.72527 .309 L
.72627 .309 L
.72727 .309 L
.72827 .309 L
.72927 .309 L
.73027 .309 L
.73127 .309 L
.73227 .309 L
.73327 .309 L
.73427 .309 L
.73526 .309 L
.73626 .30901 L
.73726 .30901 L
.73826 .30901 L
.73926 .30901 L
.74026 .30901 L
.74126 .30901 L
.74226 .30901 L
.74326 .30901 L
.74426 .30901 L
.74525 .30901 L
.74625 .30901 L
.74725 .30901 L
.74825 .30901 L
Mistroke
.74925 .30901 L
.75025 .30901 L
.75125 .30901 L
.75225 .30901 L
.75325 .30901 L
.75425 .30901 L
.75524 .30901 L
.75624 .30901 L
.75724 .30901 L
.75824 .30901 L
.75924 .30901 L
.76024 .30901 L
.76124 .30901 L
.76224 .30901 L
.76324 .30901 L
.76424 .30901 L
.76523 .30901 L
.76623 .30901 L
.76723 .30901 L
.76823 .30901 L
.76923 .30901 L
.77023 .30901 L
.77123 .30901 L
.77223 .30901 L
.77323 .30901 L
.77423 .30901 L
.77522 .30901 L
.77622 .30901 L
.77722 .30901 L
.77822 .30901 L
.77922 .30901 L
.78022 .30901 L
.78122 .30901 L
.78222 .30901 L
.78322 .30901 L
.78422 .30901 L
.78521 .30901 L
.78621 .30901 L
.78721 .30901 L
.78821 .30901 L
.78921 .30901 L
.79021 .30901 L
.79121 .30901 L
.79221 .30901 L
.79321 .30901 L
.79421 .30901 L
.7952 .30901 L
.7962 .30901 L
.7972 .30901 L
.7982 .30901 L
Mistroke
.7992 .30901 L
.8002 .30901 L
.8012 .30901 L
.8022 .30901 L
.8032 .30901 L
.8042 .30901 L
.80519 .309 L
.80619 .309 L
.80719 .309 L
.80819 .309 L
.80919 .309 L
.81019 .30901 L
.81119 .309 L
.81219 .309 L
.81319 .309 L
.81419 .309 L
.81518 .309 L
.81618 .309 L
.81718 .309 L
.81818 .309 L
.81918 .309 L
.82018 .309 L
.82118 .309 L
.82218 .309 L
.82318 .309 L
.82418 .309 L
.82517 .309 L
.82617 .309 L
.82717 .309 L
.82817 .309 L
.82917 .309 L
.83017 .309 L
.83117 .309 L
.83217 .309 L
.83317 .309 L
.83417 .309 L
.83516 .309 L
.83616 .309 L
.83716 .309 L
.83816 .309 L
.83916 .309 L
.84016 .309 L
.84116 .309 L
.84216 .309 L
.84316 .309 L
.84416 .309 L
.84515 .309 L
.84615 .309 L
.84715 .309 L
.84815 .309 L
Mistroke
.84915 .309 L
.85015 .309 L
.85115 .309 L
.85215 .309 L
.85315 .309 L
.85415 .309 L
.85514 .309 L
.85614 .309 L
.85714 .309 L
.85814 .309 L
.85914 .309 L
.86014 .309 L
.86114 .309 L
.86214 .309 L
.86314 .309 L
.86414 .309 L
.86513 .309 L
.86613 .309 L
.86713 .309 L
.86813 .309 L
.86913 .309 L
.87013 .309 L
.87113 .309 L
.87213 .309 L
.87313 .309 L
.87413 .309 L
.87512 .309 L
.87612 .309 L
.87712 .309 L
.87812 .309 L
.87912 .309 L
.88012 .30901 L
.88112 .309 L
.88212 .30901 L
.88312 .30901 L
.88412 .30901 L
.88511 .309 L
.88611 .309 L
.88711 .309 L
.88811 .309 L
.88911 .309 L
.89011 .309 L
.89111 .309 L
.89211 .309 L
.89311 .309 L
.89411 .309 L
.8951 .309 L
.8961 .309 L
.8971 .309 L
.8981 .309 L
Mistroke
.8991 .309 L
.9001 .309 L
.9011 .309 L
.9021 .309 L
.9031 .309 L
.9041 .309 L
.90509 .309 L
.90609 .309 L
.90709 .309 L
.90809 .309 L
.90909 .309 L
.91009 .309 L
.91109 .309 L
.91209 .309 L
.91309 .309 L
.91409 .309 L
.91508 .309 L
.91608 .309 L
.91708 .309 L
.91808 .309 L
.91908 .309 L
.92008 .309 L
.92108 .309 L
.92208 .309 L
.92308 .309 L
.92408 .309 L
.92507 .309 L
.92607 .309 L
.92707 .30901 L
.92807 .30901 L
.92907 .30901 L
.93007 .30901 L
.93107 .30901 L
.93207 .30901 L
.93307 .30901 L
.93407 .30901 L
.93506 .30901 L
.93606 .30901 L
.93706 .30901 L
.93806 .30901 L
.93906 .30901 L
.94006 .30901 L
.94106 .30901 L
.94206 .30901 L
.94306 .30901 L
.94406 .30901 L
.94505 .30901 L
.94605 .30901 L
.94705 .30901 L
.94805 .30901 L
Mistroke
.94905 .30901 L
.95005 .30901 L
.95105 .309 L
.95205 .309 L
.95305 .309 L
.95405 .309 L
.95504 .309 L
.95604 .309 L
.95704 .309 L
.95804 .309 L
.95904 .309 L
.96004 .309 L
.96104 .309 L
.96204 .30901 L
.96304 .30901 L
.96404 .30901 L
.96503 .30901 L
.96603 .30901 L
.96703 .30901 L
.96803 .30901 L
.96903 .30901 L
.97003 .30901 L
.97103 .30901 L
.97203 .309 L
.97303 .309 L
.97403 .30901 L
.97502 .309 L
.97602 .309 L
.97702 .309 L
.97802 .309 L
.97902 .309 L
.98002 .309 L
.98102 .309 L
.98202 .309 L
.98302 .309 L
.98402 .309 L
.98501 .309 L
.98601 .309 L
.98701 .309 L
.98801 .309 L
.98901 .309 L
.99001 .309 L
.99101 .309 L
.99201 .309 L
.99301 .309 L
.99401 .309 L
.995 .309 L
.996 .309 L
.997 .309 L
.998 .309 L
Mistroke
.999 .309 L
Mfstroke
0 .98 .604 r
gsave
.999 .25726 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .24969 m
.001 .24969 L
.002 .24969 L
.003 .24969 L
.004 .24969 L
.005 .24969 L
.00599 .24969 L
.00699 .24969 L
.00799 .24969 L
.00899 .24969 L
.00999 .24969 L
.01099 .24969 L
.01199 .24969 L
.01299 .24969 L
.01399 .24969 L
.01499 .24969 L
.01598 .24969 L
.01698 .24969 L
.01798 .24969 L
.01898 .24969 L
.01998 .24969 L
.02098 .24969 L
.02198 .24969 L
.02298 .24969 L
.02398 .24969 L
.02498 .24969 L
.02597 .24969 L
.02697 .24969 L
.02797 .24969 L
.02897 .24969 L
.02997 .24969 L
.03097 .24969 L
.03197 .24969 L
.03297 .24969 L
.03397 .24969 L
.03497 .24969 L
.03596 .24969 L
.03696 .24969 L
.03796 .24969 L
.03896 .24969 L
.03996 .24969 L
.04096 .24969 L
.04196 .24969 L
.04296 .24969 L
.04396 .24969 L
.04496 .24969 L
.04595 .24969 L
.04695 .24969 L
.04795 .24969 L
.04895 .24969 L
Mistroke
.04995 .26724 L
.05095 .26724 L
.05195 .26724 L
.05295 .26724 L
.05395 .26724 L
.05495 .26724 L
.05594 .26724 L
.05694 .26724 L
.05794 .26724 L
.05894 .26724 L
.05994 .26724 L
.06094 .26724 L
.06194 .26724 L
.06294 .26724 L
.06394 .26724 L
.06494 .26724 L
.06593 .26724 L
.06693 .26724 L
.06793 .26724 L
.06893 .26724 L
.06993 .26724 L
.07093 .26724 L
.07193 .26724 L
.07293 .26724 L
.07393 .26724 L
.07493 .26724 L
.07592 .26724 L
.07692 .26724 L
.07792 .26724 L
.07892 .26724 L
.07992 .26724 L
.08092 .26724 L
.08192 .26724 L
.08292 .26724 L
.08392 .26724 L
.08492 .26724 L
.08591 .26724 L
.08691 .26724 L
.08791 .26724 L
.08891 .26724 L
.08991 .26724 L
.09091 .26724 L
.09191 .26724 L
.09291 .26724 L
.09391 .26724 L
.09491 .26724 L
.0959 .26724 L
.0969 .26724 L
.0979 .26724 L
.0989 .26724 L
Mistroke
.0999 .28982 L
.1009 .28982 L
.1019 .28982 L
.1029 .28982 L
.1039 .28982 L
.1049 .28982 L
.10589 .28982 L
.10689 .28982 L
.10789 .28982 L
.10889 .28982 L
.10989 .28982 L
.11089 .28982 L
.11189 .28982 L
.11289 .28982 L
.11389 .28982 L
.11489 .28982 L
.11588 .28982 L
.11688 .28982 L
.11788 .28982 L
.11888 .28982 L
.11988 .28982 L
.12088 .28982 L
.12188 .28982 L
.12288 .28982 L
.12388 .28982 L
.12488 .28982 L
.12587 .28982 L
.12687 .28982 L
.12787 .28982 L
.12887 .28982 L
.12987 .28982 L
.13087 .28982 L
.13187 .28982 L
.13287 .28982 L
.13387 .28982 L
.13487 .28982 L
.13586 .28982 L
.13686 .28982 L
.13786 .28982 L
.13886 .28982 L
.13986 .28982 L
.14086 .28982 L
.14186 .28982 L
.14286 .28982 L
.14386 .28982 L
.14486 .28982 L
.14585 .28982 L
.14685 .28982 L
.14785 .28982 L
.14885 .28982 L
Mistroke
.14985 .27367 L
.15085 .27367 L
.15185 .27367 L
.15285 .27367 L
.15385 .27367 L
.15485 .27367 L
.15584 .27367 L
.15684 .27367 L
.15784 .27367 L
.15884 .27367 L
.15984 .27367 L
.16084 .27367 L
.16184 .27367 L
.16284 .27367 L
.16384 .27367 L
.16484 .27367 L
.16583 .27367 L
.16683 .27367 L
.16783 .27367 L
.16883 .27367 L
.16983 .27367 L
.17083 .27367 L
.17183 .27367 L
.17283 .27367 L
.17383 .27367 L
.17483 .27367 L
.17582 .27367 L
.17682 .27367 L
.17782 .27367 L
.17882 .27367 L
.17982 .27367 L
.18082 .27367 L
.18182 .27367 L
.18282 .27367 L
.18382 .27367 L
.18482 .27367 L
.18581 .27367 L
.18681 .27367 L
.18781 .27367 L
.18881 .27367 L
.18981 .27367 L
.19081 .27367 L
.19181 .27367 L
.19281 .27367 L
.19381 .27367 L
.19481 .27367 L
.1958 .27367 L
.1968 .27367 L
.1978 .27367 L
.1988 .27367 L
Mistroke
.1998 .25839 L
.2008 .25839 L
.2018 .25839 L
.2028 .25839 L
.2038 .25839 L
.2048 .25839 L
.20579 .25839 L
.20679 .25839 L
.20779 .25839 L
.20879 .25839 L
.20979 .25839 L
.21079 .25839 L
.21179 .25839 L
.21279 .25839 L
.21379 .25839 L
.21479 .25839 L
.21578 .25839 L
.21678 .25839 L
.21778 .25839 L
.21878 .25839 L
.21978 .25839 L
.22078 .25839 L
.22178 .25839 L
.22278 .25839 L
.22378 .25839 L
.22478 .25839 L
.22577 .25839 L
.22677 .25839 L
.22777 .25839 L
.22877 .25839 L
.22977 .25839 L
.23077 .25839 L
.23177 .25839 L
.23277 .25839 L
.23377 .25839 L
.23477 .25839 L
.23576 .25839 L
.23676 .25839 L
.23776 .25839 L
.23876 .25839 L
.23976 .25839 L
.24076 .25839 L
.24176 .25839 L
.24276 .25839 L
.24376 .25839 L
.24476 .25839 L
.24575 .25839 L
.24675 .25839 L
.24775 .25839 L
.24875 .25839 L
Mistroke
.24975 .2638 L
.25075 .2638 L
.25175 .2638 L
.25275 .2638 L
.25375 .2638 L
.25475 .2638 L
.25574 .2638 L
.25674 .2638 L
.25774 .2638 L
.25874 .2638 L
.25974 .2638 L
.26074 .2638 L
.26174 .2638 L
.26274 .2638 L
.26374 .2638 L
.26474 .2638 L
.26573 .2638 L
.26673 .2638 L
.26773 .2638 L
.26873 .2638 L
.26973 .2638 L
.27073 .2638 L
.27173 .2638 L
.27273 .2638 L
.27373 .2638 L
.27473 .2638 L
.27572 .2638 L
.27672 .2638 L
.27772 .2638 L
.27872 .2638 L
.27972 .2638 L
.28072 .2638 L
.28172 .2638 L
.28272 .2638 L
.28372 .2638 L
.28472 .2638 L
.28571 .2638 L
.28671 .2638 L
.28771 .2638 L
.28871 .2638 L
.28971 .2638 L
.29071 .2638 L
.29171 .2638 L
.29271 .2638 L
.29371 .2638 L
.29471 .2638 L
.2957 .2638 L
.2967 .2638 L
.2977 .2638 L
.2987 .2638 L
Mistroke
.2997 .26961 L
.3007 .26961 L
.3017 .26961 L
.3027 .26961 L
.3037 .26961 L
.3047 .26961 L
.30569 .26961 L
.30669 .26961 L
.30769 .26961 L
.30869 .26961 L
.30969 .26961 L
.31069 .26961 L
.31169 .26961 L
.31269 .26961 L
.31369 .26961 L
.31469 .26961 L
.31568 .26961 L
.31668 .26961 L
.31768 .26961 L
.31868 .26961 L
.31968 .26961 L
.32068 .26961 L
.32168 .26961 L
.32268 .26961 L
.32368 .26961 L
.32468 .26961 L
.32567 .26961 L
.32667 .26961 L
.32767 .26961 L
.32867 .26961 L
.32967 .26961 L
.33067 .26961 L
.33167 .26961 L
.33267 .26961 L
.33367 .26961 L
.33467 .26961 L
.33566 .26961 L
.33666 .26961 L
.33766 .26961 L
.33866 .26961 L
.33966 .26961 L
.34066 .26961 L
.34166 .26961 L
.34266 .26961 L
.34366 .26961 L
.34466 .26961 L
.34565 .26961 L
.34665 .26961 L
.34765 .26961 L
.34865 .26961 L
Mistroke
.34965 .26564 L
.35065 .26564 L
.35165 .26564 L
.35265 .26564 L
.35365 .26564 L
.35465 .26564 L
.35564 .26564 L
.35664 .26564 L
.35764 .26564 L
.35864 .26564 L
.35964 .26564 L
.36064 .26564 L
.36164 .26564 L
.36264 .26564 L
.36364 .26564 L
.36464 .26564 L
.36563 .26564 L
.36663 .26564 L
.36763 .26564 L
.36863 .26564 L
.36963 .26564 L
.37063 .26564 L
.37163 .26564 L
.37263 .26564 L
.37363 .26564 L
.37463 .26564 L
.37562 .26564 L
.37662 .26564 L
.37762 .26564 L
.37862 .26564 L
.37962 .26564 L
.38062 .26564 L
.38162 .26564 L
.38262 .26564 L
.38362 .26564 L
.38462 .26564 L
.38561 .26564 L
.38661 .26564 L
.38761 .26564 L
.38861 .26564 L
.38961 .26564 L
.39061 .26564 L
.39161 .26564 L
.39261 .26564 L
.39361 .26564 L
.39461 .26564 L
.3956 .26564 L
.3966 .26564 L
.3976 .26564 L
.3986 .26564 L
Mistroke
.3996 .25217 L
.4006 .25217 L
.4016 .25217 L
.4026 .25217 L
.4036 .25217 L
.4046 .25217 L
.40559 .25217 L
.40659 .25217 L
.40759 .25217 L
.40859 .25217 L
.40959 .25217 L
.41059 .25217 L
.41159 .25217 L
.41259 .25217 L
.41359 .25217 L
.41459 .25217 L
.41558 .25217 L
.41658 .25217 L
.41758 .25217 L
.41858 .25217 L
.41958 .25217 L
.42058 .25217 L
.42158 .25217 L
.42258 .25217 L
.42358 .25217 L
.42458 .25217 L
.42557 .25217 L
.42657 .25217 L
.42757 .25217 L
.42857 .25217 L
.42957 .25217 L
.43057 .25217 L
.43157 .25217 L
.43257 .25217 L
.43357 .25217 L
.43457 .25217 L
.43556 .25217 L
.43656 .25217 L
.43756 .25217 L
.43856 .25217 L
.43956 .25217 L
.44056 .25217 L
.44156 .25217 L
.44256 .25217 L
.44356 .25217 L
.44456 .25217 L
.44555 .25217 L
.44655 .25217 L
.44755 .25217 L
.44855 .25217 L
Mistroke
.44955 .24788 L
.45055 .24788 L
.45155 .24788 L
.45255 .24788 L
.45355 .24788 L
.45455 .24788 L
.45554 .24788 L
.45654 .24788 L
.45754 .24788 L
.45854 .24788 L
.45954 .24788 L
.46054 .24788 L
.46154 .24788 L
.46254 .24788 L
.46354 .24788 L
.46454 .24788 L
.46553 .24788 L
.46653 .24788 L
.46753 .24788 L
.46853 .24788 L
.46953 .24788 L
.47053 .24788 L
.47153 .24788 L
.47253 .24788 L
.47353 .24788 L
.47453 .24788 L
.47552 .24788 L
.47652 .24788 L
.47752 .24788 L
.47852 .24788 L
.47952 .24788 L
.48052 .24788 L
.48152 .24788 L
.48252 .24788 L
.48352 .24788 L
.48452 .24788 L
.48551 .24788 L
.48651 .24788 L
.48751 .24788 L
.48851 .24788 L
.48951 .24788 L
.49051 .24788 L
.49151 .24788 L
.49251 .24788 L
.49351 .24788 L
.49451 .24788 L
.4955 .24788 L
.4965 .24788 L
.4975 .24788 L
.4985 .24788 L
Mistroke
.4995 .25093 L
.5005 .25093 L
.5015 .25093 L
.5025 .25093 L
.5035 .25093 L
.5045 .25093 L
.50549 .25093 L
.50649 .25093 L
.50749 .25093 L
.50849 .25093 L
.50949 .25093 L
.51049 .25093 L
.51149 .25093 L
.51249 .25093 L
.51349 .25093 L
.51449 .25093 L
.51548 .25093 L
.51648 .25093 L
.51748 .25093 L
.51848 .25093 L
.51948 .25093 L
.52048 .25093 L
.52148 .25093 L
.52248 .25093 L
.52348 .25093 L
.52448 .25093 L
.52547 .25093 L
.52647 .25093 L
.52747 .25093 L
.52847 .25093 L
.52947 .25093 L
.53047 .25093 L
.53147 .25093 L
.53247 .25093 L
.53347 .25093 L
.53447 .25093 L
.53546 .25093 L
.53646 .25093 L
.53746 .25093 L
.53846 .25093 L
.53946 .25093 L
.54046 .25093 L
.54146 .25093 L
.54246 .25093 L
.54346 .25093 L
.54446 .25093 L
.54545 .25093 L
.54645 .25093 L
.54745 .25093 L
.54845 .25093 L
Mistroke
.54945 .2534 L
.55045 .2534 L
.55145 .2534 L
.55245 .2534 L
.55345 .2534 L
.55445 .2534 L
.55544 .2534 L
.55644 .2534 L
.55744 .2534 L
.55844 .2534 L
.55944 .2534 L
.56044 .2534 L
.56144 .2534 L
.56244 .2534 L
.56344 .2534 L
.56444 .2534 L
.56543 .2534 L
.56643 .2534 L
.56743 .2534 L
.56843 .2534 L
.56943 .2534 L
.57043 .2534 L
.57143 .2534 L
.57243 .2534 L
.57343 .2534 L
.57443 .2534 L
.57542 .2534 L
.57642 .2534 L
.57742 .2534 L
.57842 .2534 L
.57942 .2534 L
.58042 .2534 L
.58142 .2534 L
.58242 .2534 L
.58342 .2534 L
.58442 .2534 L
.58541 .2534 L
.58641 .2534 L
.58741 .2534 L
.58841 .2534 L
.58941 .2534 L
.59041 .2534 L
.59141 .2534 L
.59241 .2534 L
.59341 .2534 L
.59441 .2534 L
.5954 .2534 L
.5964 .2534 L
.5974 .2534 L
.5984 .2534 L
Mistroke
.5994 .23435 L
.6004 .23435 L
.6014 .23435 L
.6024 .23435 L
.6034 .23435 L
.6044 .23435 L
.60539 .23435 L
.60639 .23435 L
.60739 .23435 L
.60839 .23435 L
.60939 .23435 L
.61039 .23435 L
.61139 .23435 L
.61239 .23435 L
.61339 .23435 L
.61439 .23435 L
.61538 .23435 L
.61638 .23435 L
.61738 .23435 L
.61838 .23435 L
.61938 .23435 L
.62038 .23435 L
.62138 .23435 L
.62238 .23435 L
.62338 .23435 L
.62438 .23435 L
.62537 .23435 L
.62637 .23435 L
.62737 .23435 L
.62837 .23435 L
.62937 .23435 L
.63037 .23435 L
.63137 .23435 L
.63237 .23435 L
.63337 .23435 L
.63437 .23435 L
.63536 .23435 L
.63636 .23435 L
.63736 .23435 L
.63836 .23435 L
.63936 .23435 L
.64036 .23435 L
.64136 .23435 L
.64236 .23435 L
.64336 .23435 L
.64436 .23435 L
.64535 .23435 L
.64635 .23435 L
.64735 .23435 L
.64835 .23435 L
Mistroke
.64935 .25029 L
.65035 .25029 L
.65135 .25029 L
.65235 .25029 L
.65335 .25029 L
.65435 .25029 L
.65534 .25029 L
.65634 .25029 L
.65734 .25029 L
.65834 .25029 L
.65934 .25029 L
.66034 .25029 L
.66134 .25029 L
.66234 .25029 L
.66334 .25029 L
.66434 .25029 L
.66533 .25029 L
.66633 .25029 L
.66733 .25029 L
.66833 .25029 L
.66933 .25029 L
.67033 .25029 L
.67133 .25029 L
.67233 .25029 L
.67333 .25029 L
.67433 .25029 L
.67532 .25029 L
.67632 .25029 L
.67732 .25029 L
.67832 .25029 L
.67932 .25029 L
.68032 .25029 L
.68132 .25029 L
.68232 .25029 L
.68332 .25029 L
.68432 .25029 L
.68531 .25029 L
.68631 .25029 L
.68731 .25029 L
.68831 .25029 L
.68931 .25029 L
.69031 .25029 L
.69131 .25029 L
.69231 .25029 L
.69331 .25029 L
.69431 .25029 L
.6953 .25029 L
.6963 .25029 L
.6973 .25029 L
.6983 .25029 L
Mistroke
.6993 .25619 L
.7003 .25619 L
.7013 .25619 L
.7023 .25619 L
.7033 .25619 L
.7043 .25619 L
.70529 .25619 L
.70629 .25619 L
.70729 .25619 L
.70829 .25619 L
.70929 .25619 L
.71029 .25619 L
.71129 .25619 L
.71229 .25619 L
.71329 .25619 L
.71429 .25619 L
.71528 .25619 L
.71628 .25619 L
.71728 .25619 L
.71828 .25619 L
.71928 .25619 L
.72028 .25619 L
.72128 .25619 L
.72228 .25619 L
.72328 .25619 L
.72428 .25619 L
.72527 .25619 L
.72627 .25619 L
.72727 .25619 L
.72827 .25619 L
.72927 .25619 L
.73027 .25619 L
.73127 .25619 L
.73227 .25619 L
.73327 .25619 L
.73427 .25619 L
.73526 .25619 L
.73626 .25619 L
.73726 .25619 L
.73826 .25619 L
.73926 .25619 L
.74026 .25619 L
.74126 .25619 L
.74226 .25619 L
.74326 .25619 L
.74426 .25619 L
.74525 .25619 L
.74625 .25619 L
.74725 .25619 L
.74825 .25619 L
Mistroke
.74925 .25361 L
.75025 .25361 L
.75125 .25361 L
.75225 .25361 L
.75325 .25361 L
.75425 .25361 L
.75524 .25361 L
.75624 .25361 L
.75724 .25361 L
.75824 .25361 L
.75924 .25361 L
.76024 .25361 L
.76124 .25361 L
.76224 .25361 L
.76324 .25361 L
.76424 .25361 L
.76523 .25361 L
.76623 .25361 L
.76723 .25361 L
.76823 .25361 L
.76923 .25361 L
.77023 .25361 L
.77123 .25361 L
.77223 .25361 L
.77323 .25361 L
.77423 .25361 L
.77522 .25361 L
.77622 .25361 L
.77722 .25361 L
.77822 .25361 L
.77922 .25361 L
.78022 .25361 L
.78122 .25361 L
.78222 .25361 L
.78322 .25361 L
.78422 .25361 L
.78521 .25361 L
.78621 .25361 L
.78721 .25361 L
.78821 .25361 L
.78921 .25361 L
.79021 .25361 L
.79121 .25361 L
.79221 .25361 L
.79321 .25361 L
.79421 .25361 L
.7952 .25361 L
.7962 .25361 L
.7972 .25361 L
.7982 .25361 L
Mistroke
.7992 .24316 L
.8002 .24316 L
.8012 .24316 L
.8022 .24316 L
.8032 .24316 L
.8042 .24316 L
.80519 .24316 L
.80619 .24316 L
.80719 .24316 L
.80819 .24316 L
.80919 .24316 L
.81019 .24316 L
.81119 .24316 L
.81219 .24316 L
.81319 .24316 L
.81419 .24316 L
.81518 .24316 L
.81618 .24316 L
.81718 .24316 L
.81818 .24316 L
.81918 .24316 L
.82018 .24316 L
.82118 .24316 L
.82218 .24316 L
.82318 .24316 L
.82418 .24316 L
.82517 .24316 L
.82617 .24316 L
.82717 .24316 L
.82817 .24316 L
.82917 .24316 L
.83017 .24316 L
.83117 .24316 L
.83217 .24316 L
.83317 .24316 L
.83417 .24316 L
.83516 .24316 L
.83616 .24316 L
.83716 .24316 L
.83816 .24316 L
.83916 .24316 L
.84016 .24316 L
.84116 .24316 L
.84216 .24316 L
.84316 .24316 L
.84416 .24316 L
.84515 .24316 L
.84615 .24316 L
.84715 .24316 L
.84815 .24316 L
Mistroke
.84915 .24702 L
.85015 .24702 L
.85115 .24702 L
.85215 .24702 L
.85315 .24702 L
.85415 .24702 L
.85514 .24702 L
.85614 .24702 L
.85714 .24702 L
.85814 .24702 L
.85914 .24702 L
.86014 .24702 L
.86114 .24702 L
.86214 .24702 L
.86314 .24702 L
.86414 .24702 L
.86513 .24702 L
.86613 .24702 L
.86713 .24702 L
.86813 .24702 L
.86913 .24702 L
.87013 .24702 L
.87113 .24702 L
.87213 .24702 L
.87313 .24702 L
.87413 .24702 L
.87512 .24702 L
.87612 .24702 L
.87712 .24702 L
.87812 .24702 L
.87912 .24702 L
.88012 .24702 L
.88112 .24702 L
.88212 .24702 L
.88312 .24702 L
.88412 .24702 L
.88511 .24702 L
.88611 .24702 L
.88711 .24702 L
.88811 .24702 L
.88911 .24702 L
.89011 .24702 L
.89111 .24702 L
.89211 .24702 L
.89311 .24702 L
.89411 .24702 L
.8951 .24702 L
.8961 .24702 L
.8971 .24702 L
.8981 .24702 L
Mistroke
.8991 .25276 L
.9001 .25276 L
.9011 .25276 L
.9021 .25276 L
.9031 .25276 L
.9041 .25276 L
.90509 .25276 L
.90609 .25276 L
.90709 .25276 L
.90809 .25276 L
.90909 .25276 L
.91009 .25276 L
.91109 .25276 L
.91209 .25276 L
.91309 .25276 L
.91409 .25276 L
.91508 .25276 L
.91608 .25276 L
.91708 .25276 L
.91808 .25276 L
.91908 .25276 L
.92008 .25276 L
.92108 .25276 L
.92208 .25276 L
.92308 .25276 L
.92408 .25276 L
.92507 .25276 L
.92607 .25276 L
.92707 .25276 L
.92807 .25276 L
.92907 .25276 L
.93007 .25276 L
.93107 .25276 L
.93207 .25276 L
.93307 .25276 L
.93407 .25276 L
.93506 .25276 L
.93606 .25276 L
.93706 .25276 L
.93806 .25276 L
.93906 .25276 L
.94006 .25276 L
.94106 .25276 L
.94206 .25276 L
.94306 .25276 L
.94406 .25276 L
.94505 .25276 L
.94605 .25276 L
.94705 .25276 L
.94805 .25276 L
Mistroke
.94905 .25835 L
.95005 .25835 L
.95105 .25835 L
.95205 .25835 L
.95305 .25835 L
.95405 .25835 L
.95504 .25835 L
.95604 .25835 L
.95704 .25835 L
.95804 .25835 L
.95904 .25835 L
.96004 .25835 L
.96104 .25835 L
.96204 .25835 L
.96304 .25835 L
.96404 .25835 L
.96503 .25835 L
.96603 .25835 L
.96703 .25835 L
.96803 .25835 L
.96903 .25835 L
.97003 .25835 L
.97103 .25835 L
.97203 .25835 L
.97303 .25835 L
.97403 .25835 L
.97502 .25835 L
.97602 .25835 L
.97702 .25835 L
.97802 .25835 L
.97902 .25835 L
.98002 .25835 L
.98102 .25835 L
.98202 .25835 L
.98302 .25835 L
.98402 .25835 L
.98501 .25835 L
.98601 .25835 L
.98701 .25835 L
.98801 .25835 L
.98901 .25835 L
.99001 .25835 L
.99101 .25835 L
.99201 .25835 L
.99301 .25835 L
.99401 .25835 L
.995 .25835 L
.996 .25835 L
.997 .25835 L
.998 .25835 L
Mistroke
.999 .25726 L
Mfstroke
gsave
.999 .40716 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .49196 m
.001 .49196 L
.002 .49196 L
.003 .49196 L
.004 .49196 L
.005 .49196 L
.00599 .49196 L
.00699 .49196 L
.00799 .49196 L
.00899 .49196 L
.00999 .49196 L
.01099 .49196 L
.01199 .49196 L
.01299 .49196 L
.01399 .49196 L
.01499 .49196 L
.01598 .49196 L
.01698 .49196 L
.01798 .49196 L
.01898 .49196 L
.01998 .49196 L
.02098 .49196 L
.02198 .49196 L
.02298 .49196 L
.02398 .49196 L
.02498 .49196 L
.02597 .49196 L
.02697 .49196 L
.02797 .49196 L
.02897 .49196 L
.02997 .49196 L
.03097 .49196 L
.03197 .49196 L
.03297 .49196 L
.03397 .49196 L
.03497 .49196 L
.03596 .49196 L
.03696 .49196 L
.03796 .49196 L
.03896 .49196 L
.03996 .49196 L
.04096 .49196 L
.04196 .49196 L
.04296 .49196 L
.04396 .49196 L
.04496 .49196 L
.04595 .49196 L
.04695 .49196 L
.04795 .49196 L
.04895 .49196 L
Mistroke
.04995 .50892 L
.05095 .50892 L
.05195 .50892 L
.05295 .50892 L
.05395 .50892 L
.05495 .50892 L
.05594 .50892 L
.05694 .50892 L
.05794 .50892 L
.05894 .50892 L
.05994 .50892 L
.06094 .50892 L
.06194 .50892 L
.06294 .50892 L
.06394 .50892 L
.06494 .50892 L
.06593 .50892 L
.06693 .50892 L
.06793 .50892 L
.06893 .50892 L
.06993 .50892 L
.07093 .50892 L
.07193 .50892 L
.07293 .50892 L
.07393 .50892 L
.07493 .50892 L
.07592 .50892 L
.07692 .50892 L
.07792 .50892 L
.07892 .50892 L
.07992 .50892 L
.08092 .50892 L
.08192 .50892 L
.08292 .50892 L
.08392 .50892 L
.08492 .50892 L
.08591 .50892 L
.08691 .50892 L
.08791 .50892 L
.08891 .50892 L
.08991 .50892 L
.09091 .50892 L
.09191 .50892 L
.09291 .50892 L
.09391 .50892 L
.09491 .50892 L
.0959 .50892 L
.0969 .50892 L
.0979 .50892 L
.0989 .50892 L
Mistroke
.0999 .51185 L
.1009 .51185 L
.1019 .51185 L
.1029 .51185 L
.1039 .51185 L
.1049 .51185 L
.10589 .51185 L
.10689 .51185 L
.10789 .51185 L
.10889 .51185 L
.10989 .51185 L
.11089 .51185 L
.11189 .51185 L
.11289 .51185 L
.11389 .51185 L
.11489 .51185 L
.11588 .51185 L
.11688 .51185 L
.11788 .51185 L
.11888 .51185 L
.11988 .51185 L
.12088 .51185 L
.12188 .51185 L
.12288 .51185 L
.12388 .51185 L
.12488 .51185 L
.12587 .51185 L
.12687 .51185 L
.12787 .51185 L
.12887 .51185 L
.12987 .51185 L
.13087 .51185 L
.13187 .51185 L
.13287 .51185 L
.13387 .51185 L
.13487 .51185 L
.13586 .51185 L
.13686 .51185 L
.13786 .51185 L
.13886 .51185 L
.13986 .51185 L
.14086 .51185 L
.14186 .51185 L
.14286 .51185 L
.14386 .51185 L
.14486 .51185 L
.14585 .51185 L
.14685 .51185 L
.14785 .51185 L
.14885 .51185 L
Mistroke
.14985 .49273 L
.15085 .49273 L
.15185 .49273 L
.15285 .49273 L
.15385 .49273 L
.15485 .49273 L
.15584 .49273 L
.15684 .49273 L
.15784 .49273 L
.15884 .49273 L
.15984 .49273 L
.16084 .49273 L
.16184 .49273 L
.16284 .49273 L
.16384 .49273 L
.16484 .49273 L
.16583 .49273 L
.16683 .49273 L
.16783 .49273 L
.16883 .49273 L
.16983 .49273 L
.17083 .49273 L
.17183 .49273 L
.17283 .49273 L
.17383 .49273 L
.17483 .49273 L
.17582 .49273 L
.17682 .49273 L
.17782 .49273 L
.17882 .49273 L
.17982 .49273 L
.18082 .49273 L
.18182 .49273 L
.18282 .49273 L
.18382 .49273 L
.18482 .49273 L
.18581 .49273 L
.18681 .49273 L
.18781 .49273 L
.18881 .49273 L
.18981 .49273 L
.19081 .49273 L
.19181 .49273 L
.19281 .49273 L
.19381 .49273 L
.19481 .49273 L
.1958 .49273 L
.1968 .49273 L
.1978 .49273 L
.1988 .49273 L
Mistroke
.1998 .47501 L
.2008 .47501 L
.2018 .47501 L
.2028 .47501 L
.2038 .47501 L
.2048 .47501 L
.20579 .47501 L
.20679 .47501 L
.20779 .47501 L
.20879 .47501 L
.20979 .47501 L
.21079 .47501 L
.21179 .47501 L
.21279 .47501 L
.21379 .47501 L
.21479 .47501 L
.21578 .47501 L
.21678 .47501 L
.21778 .47501 L
.21878 .47501 L
.21978 .47501 L
.22078 .47501 L
.22178 .47501 L
.22278 .47501 L
.22378 .47501 L
.22478 .47501 L
.22577 .47501 L
.22677 .47501 L
.22777 .47501 L
.22877 .47501 L
.22977 .47501 L
.23077 .47501 L
.23177 .47501 L
.23277 .47501 L
.23377 .47501 L
.23477 .47501 L
.23576 .47501 L
.23676 .47501 L
.23776 .47501 L
.23876 .47501 L
.23976 .47501 L
.24076 .47501 L
.24176 .47501 L
.24276 .47501 L
.24376 .47501 L
.24476 .47501 L
.24575 .47501 L
.24675 .47501 L
.24775 .47501 L
.24875 .47501 L
Mistroke
.24975 .47777 L
.25075 .47777 L
.25175 .47777 L
.25275 .47777 L
.25375 .47777 L
.25475 .47777 L
.25574 .47777 L
.25674 .47777 L
.25774 .47777 L
.25874 .47777 L
.25974 .47777 L
.26074 .47777 L
.26174 .47777 L
.26274 .47777 L
.26374 .47777 L
.26474 .47777 L
.26573 .47777 L
.26673 .47777 L
.26773 .47777 L
.26873 .47777 L
.26973 .47777 L
.27073 .47777 L
.27173 .47777 L
.27273 .47777 L
.27373 .47777 L
.27473 .47777 L
.27572 .47777 L
.27672 .47777 L
.27772 .47777 L
.27872 .47777 L
.27972 .47777 L
.28072 .47777 L
.28172 .47777 L
.28272 .47777 L
.28372 .47777 L
.28472 .47777 L
.28571 .47777 L
.28671 .47777 L
.28771 .47777 L
.28871 .47777 L
.28971 .47777 L
.29071 .47777 L
.29171 .47777 L
.29271 .47777 L
.29371 .47777 L
.29471 .47777 L
.2957 .47777 L
.2967 .47777 L
.2977 .47777 L
.2987 .47777 L
Mistroke
.2997 .48078 L
.3007 .48078 L
.3017 .48078 L
.3027 .48078 L
.3037 .48078 L
.3047 .48078 L
.30569 .48078 L
.30669 .48078 L
.30769 .48078 L
.30869 .48078 L
.30969 .48078 L
.31069 .48078 L
.31169 .48078 L
.31269 .48078 L
.31369 .48078 L
.31469 .48078 L
.31568 .48078 L
.31668 .48078 L
.31768 .48078 L
.31868 .48078 L
.31968 .48078 L
.32068 .48078 L
.32168 .48078 L
.32268 .48078 L
.32368 .48078 L
.32468 .48078 L
.32567 .48078 L
.32667 .48078 L
.32767 .48078 L
.32867 .48078 L
.32967 .48078 L
.33067 .48078 L
.33167 .48078 L
.33267 .48078 L
.33367 .48078 L
.33467 .48078 L
.33566 .48078 L
.33666 .48078 L
.33766 .48078 L
.33866 .48078 L
.33966 .48078 L
.34066 .48078 L
.34166 .48078 L
.34266 .48078 L
.34366 .48078 L
.34466 .48078 L
.34565 .48078 L
.34665 .48078 L
.34765 .48078 L
.34865 .48078 L
Mistroke
.34965 .47053 L
.35065 .47053 L
.35165 .47053 L
.35265 .47053 L
.35365 .47053 L
.35465 .47053 L
.35564 .47053 L
.35664 .47053 L
.35764 .47053 L
.35864 .47053 L
.35964 .47053 L
.36064 .47053 L
.36164 .47053 L
.36264 .47053 L
.36364 .47053 L
.36464 .47053 L
.36563 .47053 L
.36663 .47053 L
.36763 .47053 L
.36863 .47053 L
.36963 .47053 L
.37063 .47053 L
.37163 .47053 L
.37263 .47053 L
.37363 .47053 L
.37463 .47053 L
.37562 .47053 L
.37662 .47053 L
.37762 .47053 L
.37862 .47053 L
.37962 .47053 L
.38062 .47053 L
.38162 .47053 L
.38262 .47053 L
.38362 .47053 L
.38462 .47053 L
.38561 .47053 L
.38661 .47053 L
.38761 .47053 L
.38861 .47053 L
.38961 .47053 L
.39061 .47053 L
.39161 .47053 L
.39261 .47053 L
.39361 .47053 L
.39461 .47053 L
.3956 .47053 L
.3966 .47053 L
.3976 .47053 L
.3986 .47053 L
Mistroke
.3996 .4553 L
.4006 .4553 L
.4016 .4553 L
.4026 .4553 L
.4036 .4553 L
.4046 .4553 L
.40559 .4553 L
.40659 .4553 L
.40759 .4553 L
.40859 .4553 L
.40959 .4553 L
.41059 .4553 L
.41159 .4553 L
.41259 .4553 L
.41359 .4553 L
.41459 .4553 L
.41558 .4553 L
.41658 .4553 L
.41758 .4553 L
.41858 .4553 L
.41958 .4553 L
.42058 .4553 L
.42158 .4553 L
.42258 .4553 L
.42358 .4553 L
.42458 .4553 L
.42557 .4553 L
.42657 .4553 L
.42757 .4553 L
.42857 .4553 L
.42957 .4553 L
.43057 .4553 L
.43157 .4553 L
.43257 .4553 L
.43357 .4553 L
.43457 .4553 L
.43556 .4553 L
.43656 .4553 L
.43756 .4553 L
.43856 .4553 L
.43956 .4553 L
.44056 .4553 L
.44156 .4553 L
.44256 .4553 L
.44356 .4553 L
.44456 .4553 L
.44555 .4553 L
.44655 .4553 L
.44755 .4553 L
.44855 .4553 L
Mistroke
.44955 .42938 L
.45055 .42938 L
.45155 .42938 L
.45255 .42938 L
.45355 .42938 L
.45455 .42938 L
.45554 .42938 L
.45654 .42938 L
.45754 .42938 L
.45854 .42938 L
.45954 .42938 L
.46054 .42938 L
.46154 .42938 L
.46254 .42938 L
.46354 .42938 L
.46454 .42938 L
.46553 .42938 L
.46653 .42938 L
.46753 .42938 L
.46853 .42938 L
.46953 .42938 L
.47053 .42938 L
.47153 .42938 L
.47253 .42938 L
.47353 .42938 L
.47453 .42938 L
.47552 .42938 L
.47652 .42938 L
.47752 .42938 L
.47852 .42938 L
.47952 .42938 L
.48052 .42938 L
.48152 .42938 L
.48252 .42938 L
.48352 .42938 L
.48452 .42938 L
.48551 .42938 L
.48651 .42938 L
.48751 .42938 L
.48851 .42938 L
.48951 .42938 L
.49051 .42938 L
.49151 .42938 L
.49251 .42938 L
.49351 .42938 L
.49451 .42938 L
.4955 .42938 L
.4965 .42938 L
.4975 .42938 L
.4985 .42938 L
Mistroke
.4995 .43223 L
.5005 .43223 L
.5015 .43223 L
.5025 .43223 L
.5035 .43223 L
.5045 .43223 L
.50549 .43223 L
.50649 .43223 L
.50749 .43223 L
.50849 .43223 L
.50949 .43223 L
.51049 .43223 L
.51149 .43223 L
.51249 .43223 L
.51349 .43223 L
.51449 .43223 L
.51548 .43223 L
.51648 .43223 L
.51748 .43223 L
.51848 .43223 L
.51948 .43223 L
.52048 .43223 L
.52148 .43223 L
.52248 .43223 L
.52348 .43223 L
.52448 .43223 L
.52547 .43223 L
.52647 .43223 L
.52747 .43223 L
.52847 .43223 L
.52947 .43223 L
.53047 .43223 L
.53147 .43223 L
.53247 .43223 L
.53347 .43223 L
.53447 .43223 L
.53546 .43223 L
.53646 .43223 L
.53746 .43223 L
.53846 .43223 L
.53946 .43223 L
.54046 .43223 L
.54146 .43223 L
.54246 .43223 L
.54346 .43223 L
.54446 .43223 L
.54545 .43223 L
.54645 .43223 L
.54745 .43223 L
.54845 .43223 L
Mistroke
.54945 .43452 L
.55045 .43452 L
.55145 .43452 L
.55245 .43452 L
.55345 .43452 L
.55445 .43452 L
.55544 .43452 L
.55644 .43452 L
.55744 .43452 L
.55844 .43452 L
.55944 .43452 L
.56044 .43452 L
.56144 .43452 L
.56244 .43452 L
.56344 .43452 L
.56444 .43452 L
.56543 .43452 L
.56643 .43452 L
.56743 .43452 L
.56843 .43452 L
.56943 .43452 L
.57043 .43452 L
.57143 .43452 L
.57243 .43452 L
.57343 .43452 L
.57443 .43452 L
.57542 .43452 L
.57642 .43452 L
.57742 .43452 L
.57842 .43452 L
.57942 .43452 L
.58042 .43452 L
.58142 .43452 L
.58242 .43452 L
.58342 .43452 L
.58442 .43452 L
.58541 .43452 L
.58641 .43452 L
.58741 .43452 L
.58841 .43452 L
.58941 .43452 L
.59041 .43452 L
.59141 .43452 L
.59241 .43452 L
.59341 .43452 L
.59441 .43452 L
.5954 .43452 L
.5964 .43452 L
.5974 .43452 L
.5984 .43452 L
Mistroke
.5994 .40448 L
.6004 .40448 L
.6014 .40448 L
.6024 .40448 L
.6034 .40448 L
.6044 .40448 L
.60539 .40448 L
.60639 .40448 L
.60739 .40448 L
.60839 .40448 L
.60939 .40448 L
.61039 .40448 L
.61139 .40448 L
.61239 .40448 L
.61339 .40448 L
.61439 .40448 L
.61538 .40448 L
.61638 .40448 L
.61738 .40448 L
.61838 .40448 L
.61938 .40448 L
.62038 .40448 L
.62138 .40448 L
.62238 .40448 L
.62338 .40448 L
.62438 .40448 L
.62537 .40448 L
.62637 .40448 L
.62737 .40448 L
.62837 .40448 L
.62937 .40448 L
.63037 .40448 L
.63137 .40448 L
.63237 .40448 L
.63337 .40448 L
.63437 .40448 L
.63536 .40448 L
.63636 .40448 L
.63736 .40448 L
.63836 .40448 L
.63936 .40448 L
.64036 .40448 L
.64136 .40448 L
.64236 .40448 L
.64336 .40448 L
.64436 .40448 L
.64535 .40448 L
.64635 .40448 L
.64735 .40448 L
.64835 .40448 L
Mistroke
.64935 .4174 L
.65035 .4174 L
.65135 .4174 L
.65235 .4174 L
.65335 .4174 L
.65435 .4174 L
.65534 .4174 L
.65634 .4174 L
.65734 .4174 L
.65834 .4174 L
.65934 .4174 L
.66034 .4174 L
.66134 .4174 L
.66234 .4174 L
.66334 .4174 L
.66434 .4174 L
.66533 .4174 L
.66633 .4174 L
.66733 .4174 L
.66833 .4174 L
.66933 .4174 L
.67033 .4174 L
.67133 .4174 L
.67233 .4174 L
.67333 .4174 L
.67433 .4174 L
.67532 .4174 L
.67632 .4174 L
.67732 .4174 L
.67832 .4174 L
.67932 .4174 L
.68032 .4174 L
.68132 .4174 L
.68232 .4174 L
.68332 .4174 L
.68432 .4174 L
.68531 .4174 L
.68631 .4174 L
.68731 .4174 L
.68831 .4174 L
.68931 .4174 L
.69031 .4174 L
.69131 .4174 L
.69231 .4174 L
.69331 .4174 L
.69431 .4174 L
.6953 .4174 L
.6963 .4174 L
.6973 .4174 L
.6983 .4174 L
Mistroke
.6993 .42013 L
.7003 .42013 L
.7013 .42013 L
.7023 .42013 L
.7033 .42013 L
.7043 .42013 L
.70529 .42013 L
.70629 .42013 L
.70729 .42013 L
.70829 .42013 L
.70929 .42013 L
.71029 .42013 L
.71129 .42013 L
.71229 .42013 L
.71329 .42013 L
.71429 .42013 L
.71528 .42013 L
.71628 .42013 L
.71728 .42013 L
.71828 .42013 L
.71928 .42013 L
.72028 .42013 L
.72128 .42013 L
.72228 .42013 L
.72328 .42013 L
.72428 .42013 L
.72527 .42013 L
.72627 .42013 L
.72727 .42013 L
.72827 .42013 L
.72927 .42013 L
.73027 .42013 L
.73127 .42013 L
.73227 .42013 L
.73327 .42013 L
.73427 .42013 L
.73526 .42013 L
.73626 .42013 L
.73726 .42013 L
.73826 .42013 L
.73926 .42013 L
.74026 .42013 L
.74126 .42013 L
.74226 .42013 L
.74326 .42013 L
.74426 .42013 L
.74525 .42013 L
.74625 .42013 L
.74725 .42013 L
.74825 .42013 L
Mistroke
.74925 .41707 L
.75025 .41707 L
.75125 .41707 L
.75225 .41707 L
.75325 .41707 L
.75425 .41707 L
.75524 .41707 L
.75624 .41707 L
.75724 .41707 L
.75824 .41707 L
.75924 .41707 L
.76024 .41707 L
.76124 .41707 L
.76224 .41707 L
.76324 .41707 L
.76424 .41707 L
.76523 .41707 L
.76623 .41707 L
.76723 .41707 L
.76823 .41707 L
.76923 .41707 L
.77023 .41707 L
.77123 .41707 L
.77223 .41707 L
.77323 .41707 L
.77423 .41707 L
.77522 .41707 L
.77622 .41707 L
.77722 .41707 L
.77822 .41707 L
.77922 .41707 L
.78022 .41707 L
.78122 .41707 L
.78222 .41707 L
.78322 .41707 L
.78422 .41707 L
.78521 .41707 L
.78621 .41707 L
.78721 .41707 L
.78821 .41707 L
.78921 .41707 L
.79021 .41707 L
.79121 .41707 L
.79221 .41707 L
.79321 .41707 L
.79421 .41707 L
.7952 .41707 L
.7962 .41707 L
.7972 .41707 L
.7982 .41707 L
Mistroke
.7992 .40295 L
.8002 .40295 L
.8012 .40295 L
.8022 .40295 L
.8032 .40295 L
.8042 .40295 L
.80519 .40295 L
.80619 .40295 L
.80719 .40295 L
.80819 .40295 L
.80919 .40295 L
.81019 .40295 L
.81119 .40295 L
.81219 .40295 L
.81319 .40295 L
.81419 .40295 L
.81518 .40295 L
.81618 .40295 L
.81718 .40295 L
.81818 .40295 L
.81918 .40295 L
.82018 .40295 L
.82118 .40295 L
.82218 .40295 L
.82318 .40295 L
.82418 .40295 L
.82517 .40295 L
.82617 .40295 L
.82717 .40295 L
.82817 .40295 L
.82917 .40295 L
.83017 .40295 L
.83117 .40295 L
.83217 .40295 L
.83317 .40295 L
.83417 .40295 L
.83516 .40295 L
.83616 .40295 L
.83716 .40295 L
.83816 .40295 L
.83916 .40295 L
.84016 .40295 L
.84116 .40295 L
.84216 .40295 L
.84316 .40295 L
.84416 .40295 L
.84515 .40295 L
.84615 .40295 L
.84715 .40295 L
.84815 .40295 L
Mistroke
.84915 .40632 L
.85015 .40632 L
.85115 .40632 L
.85215 .40632 L
.85315 .40632 L
.85415 .40632 L
.85514 .40632 L
.85614 .40632 L
.85714 .40632 L
.85814 .40632 L
.85914 .40632 L
.86014 .40632 L
.86114 .40632 L
.86214 .40632 L
.86314 .40632 L
.86414 .40632 L
.86513 .40632 L
.86613 .40632 L
.86713 .40632 L
.86813 .40632 L
.86913 .40632 L
.87013 .40632 L
.87113 .40632 L
.87213 .40632 L
.87313 .40632 L
.87413 .40632 L
.87512 .40632 L
.87612 .40632 L
.87712 .40632 L
.87812 .40632 L
.87912 .40632 L
.88012 .40632 L
.88112 .40632 L
.88212 .40632 L
.88312 .40632 L
.88412 .40632 L
.88511 .40632 L
.88611 .40632 L
.88711 .40632 L
.88811 .40632 L
.88911 .40632 L
.89011 .40632 L
.89111 .40632 L
.89211 .40632 L
.89311 .40632 L
.89411 .40632 L
.8951 .40632 L
.8961 .40632 L
.8971 .40632 L
.8981 .40632 L
Mistroke
.8991 .41054 L
.9001 .41054 L
.9011 .41054 L
.9021 .41054 L
.9031 .41054 L
.9041 .41054 L
.90509 .41054 L
.90609 .41054 L
.90709 .41054 L
.90809 .41054 L
.90909 .41054 L
.91009 .41054 L
.91109 .41054 L
.91209 .41054 L
.91309 .41054 L
.91409 .41054 L
.91508 .41054 L
.91608 .41054 L
.91708 .41054 L
.91808 .41054 L
.91908 .41054 L
.92008 .41054 L
.92108 .41054 L
.92208 .41054 L
.92308 .41054 L
.92408 .41054 L
.92507 .41054 L
.92607 .41054 L
.92707 .41054 L
.92807 .41054 L
.92907 .41054 L
.93007 .41054 L
.93107 .41054 L
.93207 .41054 L
.93307 .41054 L
.93407 .41054 L
.93506 .41054 L
.93606 .41054 L
.93706 .41054 L
.93806 .41054 L
.93906 .41054 L
.94006 .41054 L
.94106 .41054 L
.94206 .41054 L
.94306 .41054 L
.94406 .41054 L
.94505 .41054 L
.94605 .41054 L
.94705 .41054 L
.94805 .41054 L
Mistroke
.94905 .414 L
.95005 .414 L
.95105 .414 L
.95205 .414 L
.95305 .414 L
.95405 .414 L
.95504 .414 L
.95604 .414 L
.95704 .414 L
.95804 .414 L
.95904 .414 L
.96004 .414 L
.96104 .414 L
.96204 .414 L
.96304 .414 L
.96404 .414 L
.96503 .414 L
.96603 .414 L
.96703 .414 L
.96803 .414 L
.96903 .414 L
.97003 .414 L
.97103 .414 L
.97203 .414 L
.97303 .414 L
.97403 .414 L
.97502 .414 L
.97602 .414 L
.97702 .414 L
.97802 .414 L
.97902 .414 L
.98002 .414 L
.98102 .414 L
.98202 .414 L
.98302 .414 L
.98402 .414 L
.98501 .414 L
.98601 .414 L
.98701 .414 L
.98801 .414 L
.98901 .414 L
.99001 .414 L
.99101 .414 L
.99201 .414 L
.99301 .414 L
.99401 .414 L
.995 .414 L
.996 .414 L
.997 .414 L
.998 .414 L
Mistroke
.999 .40716 L
Mfstroke
1 0 0 r
gsave
.999 .33221 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37082 m
.001 .37082 L
.002 .37082 L
.003 .37082 L
.004 .37082 L
.005 .37082 L
.00599 .37082 L
.00699 .37082 L
.00799 .37082 L
.00899 .37082 L
.00999 .37082 L
.01099 .37082 L
.01199 .37082 L
.01299 .37082 L
.01399 .37082 L
.01499 .37082 L
.01598 .37082 L
.01698 .37082 L
.01798 .37082 L
.01898 .37082 L
.01998 .37082 L
.02098 .37082 L
.02198 .37082 L
.02298 .37082 L
.02398 .37082 L
.02498 .37082 L
.02597 .37082 L
.02697 .37082 L
.02797 .37082 L
.02897 .37082 L
.02997 .37082 L
.03097 .37082 L
.03197 .37082 L
.03297 .37082 L
.03397 .37082 L
.03497 .37082 L
.03596 .37082 L
.03696 .37082 L
.03796 .37082 L
.03896 .37082 L
.03996 .37082 L
.04096 .37082 L
.04196 .37082 L
.04296 .37082 L
.04396 .37082 L
.04496 .37082 L
.04595 .37082 L
.04695 .37082 L
.04795 .37082 L
.04895 .37082 L
Mistroke
.04995 .38808 L
.05095 .38808 L
.05195 .38808 L
.05295 .38808 L
.05395 .38808 L
.05495 .38808 L
.05594 .38808 L
.05694 .38808 L
.05794 .38808 L
.05894 .38808 L
.05994 .38808 L
.06094 .38808 L
.06194 .38808 L
.06294 .38808 L
.06394 .38808 L
.06494 .38808 L
.06593 .38808 L
.06693 .38808 L
.06793 .38808 L
.06893 .38808 L
.06993 .38808 L
.07093 .38808 L
.07193 .38808 L
.07293 .38808 L
.07393 .38808 L
.07493 .38808 L
.07592 .38808 L
.07692 .38808 L
.07792 .38808 L
.07892 .38808 L
.07992 .38808 L
.08092 .38808 L
.08192 .38808 L
.08292 .38808 L
.08392 .38808 L
.08492 .38808 L
.08591 .38808 L
.08691 .38808 L
.08791 .38808 L
.08891 .38808 L
.08991 .38808 L
.09091 .38808 L
.09191 .38808 L
.09291 .38808 L
.09391 .38808 L
.09491 .38808 L
.0959 .38808 L
.0969 .38808 L
.0979 .38808 L
.0989 .38808 L
Mistroke
.0999 .40083 L
.1009 .40083 L
.1019 .40083 L
.1029 .40083 L
.1039 .40083 L
.1049 .40083 L
.10589 .40083 L
.10689 .40083 L
.10789 .40083 L
.10889 .40083 L
.10989 .40083 L
.11089 .40083 L
.11189 .40083 L
.11289 .40083 L
.11389 .40083 L
.11489 .40083 L
.11588 .40083 L
.11688 .40083 L
.11788 .40083 L
.11888 .40083 L
.11988 .40083 L
.12088 .40083 L
.12188 .40083 L
.12288 .40083 L
.12388 .40083 L
.12488 .40083 L
.12587 .40083 L
.12687 .40083 L
.12787 .40083 L
.12887 .40083 L
.12987 .40083 L
.13087 .40083 L
.13187 .40083 L
.13287 .40083 L
.13387 .40083 L
.13487 .40083 L
.13586 .40083 L
.13686 .40083 L
.13786 .40083 L
.13886 .40083 L
.13986 .40083 L
.14086 .40083 L
.14186 .40083 L
.14286 .40083 L
.14386 .40083 L
.14486 .40083 L
.14585 .40083 L
.14685 .40083 L
.14785 .40083 L
.14885 .40083 L
Mistroke
.14985 .3832 L
.15085 .3832 L
.15185 .3832 L
.15285 .3832 L
.15385 .3832 L
.15485 .3832 L
.15584 .3832 L
.15684 .3832 L
.15784 .3832 L
.15884 .3832 L
.15984 .3832 L
.16084 .3832 L
.16184 .3832 L
.16284 .3832 L
.16384 .3832 L
.16484 .3832 L
.16583 .3832 L
.16683 .3832 L
.16783 .3832 L
.16883 .3832 L
.16983 .3832 L
.17083 .3832 L
.17183 .3832 L
.17283 .3832 L
.17383 .3832 L
.17483 .3832 L
.17582 .3832 L
.17682 .3832 L
.17782 .3832 L
.17882 .3832 L
.17982 .3832 L
.18082 .3832 L
.18182 .3832 L
.18282 .3832 L
.18382 .3832 L
.18482 .3832 L
.18581 .3832 L
.18681 .3832 L
.18781 .3832 L
.18881 .3832 L
.18981 .3832 L
.19081 .3832 L
.19181 .3832 L
.19281 .3832 L
.19381 .3832 L
.19481 .3832 L
.1958 .3832 L
.1968 .3832 L
.1978 .3832 L
.1988 .3832 L
Mistroke
.1998 .3667 L
.2008 .3667 L
.2018 .3667 L
.2028 .3667 L
.2038 .3667 L
.2048 .3667 L
.20579 .3667 L
.20679 .3667 L
.20779 .3667 L
.20879 .3667 L
.20979 .3667 L
.21079 .3667 L
.21179 .3667 L
.21279 .3667 L
.21379 .3667 L
.21479 .3667 L
.21578 .3667 L
.21678 .3667 L
.21778 .3667 L
.21878 .3667 L
.21978 .3667 L
.22078 .3667 L
.22178 .3667 L
.22278 .3667 L
.22378 .3667 L
.22478 .3667 L
.22577 .3667 L
.22677 .3667 L
.22777 .3667 L
.22877 .3667 L
.22977 .3667 L
.23077 .3667 L
.23177 .3667 L
.23277 .3667 L
.23377 .3667 L
.23477 .3667 L
.23576 .3667 L
.23676 .3667 L
.23776 .3667 L
.23876 .3667 L
.23976 .3667 L
.24076 .3667 L
.24176 .3667 L
.24276 .3667 L
.24376 .3667 L
.24476 .3667 L
.24575 .3667 L
.24675 .3667 L
.24775 .3667 L
.24875 .3667 L
Mistroke
.24975 .37079 L
.25075 .37079 L
.25175 .37079 L
.25275 .37079 L
.25375 .37079 L
.25475 .37079 L
.25574 .37079 L
.25674 .37079 L
.25774 .37079 L
.25874 .37079 L
.25974 .37079 L
.26074 .37079 L
.26174 .37079 L
.26274 .37079 L
.26374 .37079 L
.26474 .37079 L
.26573 .37079 L
.26673 .37079 L
.26773 .37079 L
.26873 .37079 L
.26973 .37079 L
.27073 .37079 L
.27173 .37079 L
.27273 .37079 L
.27373 .37079 L
.27473 .37079 L
.27572 .37079 L
.27672 .37079 L
.27772 .37079 L
.27872 .37079 L
.27972 .37079 L
.28072 .37079 L
.28172 .37079 L
.28272 .37079 L
.28372 .37079 L
.28472 .37079 L
.28571 .37079 L
.28671 .37079 L
.28771 .37079 L
.28871 .37079 L
.28971 .37079 L
.29071 .37079 L
.29171 .37079 L
.29271 .37079 L
.29371 .37079 L
.29471 .37079 L
.2957 .37079 L
.2967 .37079 L
.2977 .37079 L
.2987 .37079 L
Mistroke
.2997 .37519 L
.3007 .37519 L
.3017 .37519 L
.3027 .37519 L
.3037 .37519 L
.3047 .37519 L
.30569 .37519 L
.30669 .37519 L
.30769 .37519 L
.30869 .37519 L
.30969 .37519 L
.31069 .37519 L
.31169 .37519 L
.31269 .37519 L
.31369 .37519 L
.31469 .37519 L
.31568 .37519 L
.31668 .37519 L
.31768 .37519 L
.31868 .37519 L
.31968 .37519 L
.32068 .37519 L
.32168 .37519 L
.32268 .37519 L
.32368 .37519 L
.32468 .37519 L
.32567 .37519 L
.32667 .37519 L
.32767 .37519 L
.32867 .37519 L
.32967 .37519 L
.33067 .37519 L
.33167 .37519 L
.33267 .37519 L
.33367 .37519 L
.33467 .37519 L
.33566 .37519 L
.33666 .37519 L
.33766 .37519 L
.33866 .37519 L
.33966 .37519 L
.34066 .37519 L
.34166 .37519 L
.34266 .37519 L
.34366 .37519 L
.34466 .37519 L
.34565 .37519 L
.34665 .37519 L
.34765 .37519 L
.34865 .37519 L
Mistroke
.34965 .36809 L
.35065 .36809 L
.35165 .36809 L
.35265 .36809 L
.35365 .36809 L
.35465 .36809 L
.35564 .36809 L
.35664 .36809 L
.35764 .36809 L
.35864 .36809 L
.35964 .36809 L
.36064 .36809 L
.36164 .36809 L
.36264 .36809 L
.36364 .36809 L
.36464 .36809 L
.36563 .36809 L
.36663 .36809 L
.36763 .36809 L
.36863 .36809 L
.36963 .36809 L
.37063 .36809 L
.37163 .36809 L
.37263 .36809 L
.37363 .36809 L
.37463 .36809 L
.37562 .36809 L
.37662 .36809 L
.37762 .36809 L
.37862 .36809 L
.37962 .36809 L
.38062 .36809 L
.38162 .36809 L
.38262 .36809 L
.38362 .36809 L
.38462 .36809 L
.38561 .36809 L
.38661 .36809 L
.38761 .36809 L
.38861 .36809 L
.38961 .36809 L
.39061 .36809 L
.39161 .36809 L
.39261 .36809 L
.39361 .36809 L
.39461 .36809 L
.3956 .36809 L
.3966 .36809 L
.3976 .36809 L
.3986 .36809 L
Mistroke
.3996 .35374 L
.4006 .35374 L
.4016 .35374 L
.4026 .35374 L
.4036 .35374 L
.4046 .35374 L
.40559 .35374 L
.40659 .35374 L
.40759 .35374 L
.40859 .35374 L
.40959 .35374 L
.41059 .35374 L
.41159 .35374 L
.41259 .35374 L
.41359 .35374 L
.41459 .35374 L
.41558 .35374 L
.41658 .35374 L
.41758 .35374 L
.41858 .35374 L
.41958 .35374 L
.42058 .35374 L
.42158 .35374 L
.42258 .35374 L
.42358 .35374 L
.42458 .35374 L
.42557 .35374 L
.42657 .35374 L
.42757 .35374 L
.42857 .35374 L
.42957 .35374 L
.43057 .35374 L
.43157 .35374 L
.43257 .35374 L
.43357 .35374 L
.43457 .35374 L
.43556 .35374 L
.43656 .35374 L
.43756 .35374 L
.43856 .35374 L
.43956 .35374 L
.44056 .35374 L
.44156 .35374 L
.44256 .35374 L
.44356 .35374 L
.44456 .35374 L
.44555 .35374 L
.44655 .35374 L
.44755 .35374 L
.44855 .35374 L
Mistroke
.44955 .33863 L
.45055 .33863 L
.45155 .33863 L
.45255 .33863 L
.45355 .33863 L
.45455 .33863 L
.45554 .33863 L
.45654 .33863 L
.45754 .33863 L
.45854 .33863 L
.45954 .33863 L
.46054 .33863 L
.46154 .33863 L
.46254 .33863 L
.46354 .33863 L
.46454 .33863 L
.46553 .33863 L
.46653 .33863 L
.46753 .33863 L
.46853 .33863 L
.46953 .33863 L
.47053 .33863 L
.47153 .33863 L
.47253 .33863 L
.47353 .33863 L
.47453 .33863 L
.47552 .33863 L
.47652 .33863 L
.47752 .33863 L
.47852 .33863 L
.47952 .33863 L
.48052 .33863 L
.48152 .33863 L
.48252 .33863 L
.48352 .33863 L
.48452 .33863 L
.48551 .33863 L
.48651 .33863 L
.48751 .33863 L
.48851 .33863 L
.48951 .33863 L
.49051 .33863 L
.49151 .33863 L
.49251 .33863 L
.49351 .33863 L
.49451 .33863 L
.4955 .33863 L
.4965 .33863 L
.4975 .33863 L
.4985 .33863 L
Mistroke
.4995 .34158 L
.5005 .34158 L
.5015 .34158 L
.5025 .34158 L
.5035 .34158 L
.5045 .34158 L
.50549 .34158 L
.50649 .34158 L
.50749 .34158 L
.50849 .34158 L
.50949 .34158 L
.51049 .34158 L
.51149 .34158 L
.51249 .34158 L
.51349 .34158 L
.51449 .34158 L
.51548 .34158 L
.51648 .34158 L
.51748 .34158 L
.51848 .34158 L
.51948 .34158 L
.52048 .34158 L
.52148 .34158 L
.52248 .34158 L
.52348 .34158 L
.52448 .34158 L
.52547 .34158 L
.52647 .34158 L
.52747 .34158 L
.52847 .34158 L
.52947 .34158 L
.53047 .34158 L
.53147 .34158 L
.53247 .34158 L
.53347 .34158 L
.53447 .34158 L
.53546 .34158 L
.53646 .34158 L
.53746 .34158 L
.53846 .34158 L
.53946 .34158 L
.54046 .34158 L
.54146 .34158 L
.54246 .34158 L
.54346 .34158 L
.54446 .34158 L
.54545 .34158 L
.54645 .34158 L
.54745 .34158 L
.54845 .34158 L
Mistroke
.54945 .34396 L
.55045 .34396 L
.55145 .34396 L
.55245 .34396 L
.55345 .34396 L
.55445 .34396 L
.55544 .34396 L
.55644 .34396 L
.55744 .34396 L
.55844 .34396 L
.55944 .34396 L
.56044 .34396 L
.56144 .34396 L
.56244 .34396 L
.56344 .34396 L
.56444 .34396 L
.56543 .34396 L
.56643 .34396 L
.56743 .34396 L
.56843 .34396 L
.56943 .34396 L
.57043 .34396 L
.57143 .34396 L
.57243 .34396 L
.57343 .34396 L
.57443 .34396 L
.57542 .34396 L
.57642 .34396 L
.57742 .34396 L
.57842 .34396 L
.57942 .34396 L
.58042 .34396 L
.58142 .34396 L
.58242 .34396 L
.58342 .34396 L
.58442 .34396 L
.58541 .34396 L
.58641 .34396 L
.58741 .34396 L
.58841 .34396 L
.58941 .34396 L
.59041 .34396 L
.59141 .34396 L
.59241 .34396 L
.59341 .34396 L
.59441 .34396 L
.5954 .34396 L
.5964 .34396 L
.5974 .34396 L
.5984 .34396 L
Mistroke
.5994 .31941 L
.6004 .31941 L
.6014 .31941 L
.6024 .31941 L
.6034 .31941 L
.6044 .31941 L
.60539 .31941 L
.60639 .31941 L
.60739 .31941 L
.60839 .31941 L
.60939 .31941 L
.61039 .31941 L
.61139 .31941 L
.61239 .31941 L
.61339 .31941 L
.61439 .31941 L
.61538 .31941 L
.61638 .31941 L
.61738 .31941 L
.61838 .31941 L
.61938 .31941 L
.62038 .31941 L
.62138 .31941 L
.62238 .31941 L
.62338 .31941 L
.62438 .31941 L
.62537 .31941 L
.62637 .31941 L
.62737 .31941 L
.62837 .31941 L
.62937 .31941 L
.63037 .31941 L
.63137 .31941 L
.63237 .31941 L
.63337 .31941 L
.63437 .31941 L
.63536 .31941 L
.63636 .31941 L
.63736 .31941 L
.63836 .31941 L
.63936 .31941 L
.64036 .31941 L
.64136 .31941 L
.64236 .31941 L
.64336 .31941 L
.64436 .31941 L
.64535 .31941 L
.64635 .31941 L
.64735 .31941 L
.64835 .31941 L
Mistroke
.64935 .33385 L
.65035 .33385 L
.65135 .33385 L
.65235 .33385 L
.65335 .33385 L
.65435 .33385 L
.65534 .33385 L
.65634 .33385 L
.65734 .33385 L
.65834 .33385 L
.65934 .33385 L
.66034 .33385 L
.66134 .33385 L
.66234 .33385 L
.66334 .33385 L
.66434 .33385 L
.66533 .33385 L
.66633 .33385 L
.66733 .33385 L
.66833 .33385 L
.66933 .33385 L
.67033 .33385 L
.67133 .33385 L
.67233 .33385 L
.67333 .33385 L
.67433 .33385 L
.67532 .33385 L
.67632 .33385 L
.67732 .33385 L
.67832 .33385 L
.67932 .33385 L
.68032 .33385 L
.68132 .33385 L
.68232 .33385 L
.68332 .33385 L
.68432 .33385 L
.68531 .33385 L
.68631 .33385 L
.68731 .33385 L
.68831 .33385 L
.68931 .33385 L
.69031 .33385 L
.69131 .33385 L
.69231 .33385 L
.69331 .33385 L
.69431 .33385 L
.6953 .33385 L
.6963 .33385 L
.6973 .33385 L
.6983 .33385 L
Mistroke
.6993 .33816 L
.7003 .33816 L
.7013 .33816 L
.7023 .33816 L
.7033 .33816 L
.7043 .33816 L
.70529 .33816 L
.70629 .33816 L
.70729 .33816 L
.70829 .33816 L
.70929 .33816 L
.71029 .33816 L
.71129 .33816 L
.71229 .33816 L
.71329 .33816 L
.71429 .33816 L
.71528 .33816 L
.71628 .33816 L
.71728 .33816 L
.71828 .33816 L
.71928 .33816 L
.72028 .33816 L
.72128 .33816 L
.72228 .33816 L
.72328 .33816 L
.72428 .33816 L
.72527 .33816 L
.72627 .33816 L
.72727 .33816 L
.72827 .33816 L
.72927 .33816 L
.73027 .33816 L
.73127 .33816 L
.73227 .33816 L
.73327 .33816 L
.73427 .33816 L
.73526 .33816 L
.73626 .33816 L
.73726 .33816 L
.73826 .33816 L
.73926 .33816 L
.74026 .33816 L
.74126 .33816 L
.74226 .33816 L
.74326 .33816 L
.74426 .33816 L
.74525 .33816 L
.74625 .33816 L
.74725 .33816 L
.74825 .33816 L
Mistroke
.74925 .33534 L
.75025 .33534 L
.75125 .33534 L
.75225 .33534 L
.75325 .33534 L
.75425 .33534 L
.75524 .33534 L
.75624 .33534 L
.75724 .33534 L
.75824 .33534 L
.75924 .33534 L
.76024 .33534 L
.76124 .33534 L
.76224 .33534 L
.76324 .33534 L
.76424 .33534 L
.76523 .33534 L
.76623 .33534 L
.76723 .33534 L
.76823 .33534 L
.76923 .33534 L
.77023 .33534 L
.77123 .33534 L
.77223 .33534 L
.77323 .33534 L
.77423 .33534 L
.77522 .33534 L
.77622 .33534 L
.77722 .33534 L
.77822 .33534 L
.77922 .33534 L
.78022 .33534 L
.78122 .33534 L
.78222 .33534 L
.78322 .33534 L
.78422 .33534 L
.78521 .33534 L
.78621 .33534 L
.78721 .33534 L
.78821 .33534 L
.78921 .33534 L
.79021 .33534 L
.79121 .33534 L
.79221 .33534 L
.79321 .33534 L
.79421 .33534 L
.7952 .33534 L
.7962 .33534 L
.7972 .33534 L
.7982 .33534 L
Mistroke
.7992 .32306 L
.8002 .32306 L
.8012 .32306 L
.8022 .32306 L
.8032 .32306 L
.8042 .32306 L
.80519 .32306 L
.80619 .32306 L
.80719 .32306 L
.80819 .32306 L
.80919 .32306 L
.81019 .32306 L
.81119 .32306 L
.81219 .32306 L
.81319 .32306 L
.81419 .32306 L
.81518 .32306 L
.81618 .32306 L
.81718 .32306 L
.81818 .32306 L
.81918 .32306 L
.82018 .32306 L
.82118 .32306 L
.82218 .32306 L
.82318 .32306 L
.82418 .32306 L
.82517 .32306 L
.82617 .32306 L
.82717 .32306 L
.82817 .32306 L
.82917 .32306 L
.83017 .32306 L
.83117 .32306 L
.83217 .32306 L
.83317 .32306 L
.83417 .32306 L
.83516 .32306 L
.83616 .32306 L
.83716 .32306 L
.83816 .32306 L
.83916 .32306 L
.84016 .32306 L
.84116 .32306 L
.84216 .32306 L
.84316 .32306 L
.84416 .32306 L
.84515 .32306 L
.84615 .32306 L
.84715 .32306 L
.84815 .32306 L
Mistroke
.84915 .32667 L
.85015 .32667 L
.85115 .32667 L
.85215 .32667 L
.85315 .32667 L
.85415 .32667 L
.85514 .32667 L
.85614 .32667 L
.85714 .32667 L
.85814 .32667 L
.85914 .32667 L
.86014 .32667 L
.86114 .32667 L
.86214 .32667 L
.86314 .32667 L
.86414 .32667 L
.86513 .32667 L
.86613 .32667 L
.86713 .32667 L
.86813 .32667 L
.86913 .32667 L
.87013 .32667 L
.87113 .32667 L
.87213 .32667 L
.87313 .32667 L
.87413 .32667 L
.87512 .32667 L
.87612 .32667 L
.87712 .32667 L
.87812 .32667 L
.87912 .32667 L
.88012 .32667 L
.88112 .32667 L
.88212 .32667 L
.88312 .32667 L
.88412 .32667 L
.88511 .32667 L
.88611 .32667 L
.88711 .32667 L
.88811 .32667 L
.88911 .32667 L
.89011 .32667 L
.89111 .32667 L
.89211 .32667 L
.89311 .32667 L
.89411 .32667 L
.8951 .32667 L
.8961 .32667 L
.8971 .32667 L
.8981 .32667 L
Mistroke
.8991 .33165 L
.9001 .33165 L
.9011 .33165 L
.9021 .33165 L
.9031 .33165 L
.9041 .33165 L
.90509 .33165 L
.90609 .33165 L
.90709 .33165 L
.90809 .33165 L
.90909 .33165 L
.91009 .33165 L
.91109 .33165 L
.91209 .33165 L
.91309 .33165 L
.91409 .33165 L
.91508 .33165 L
.91608 .33165 L
.91708 .33165 L
.91808 .33165 L
.91908 .33165 L
.92008 .33165 L
.92108 .33165 L
.92208 .33165 L
.92308 .33165 L
.92408 .33165 L
.92507 .33165 L
.92607 .33165 L
.92707 .33165 L
.92807 .33165 L
.92907 .33165 L
.93007 .33165 L
.93107 .33165 L
.93207 .33165 L
.93307 .33165 L
.93407 .33165 L
.93506 .33165 L
.93606 .33165 L
.93706 .33165 L
.93806 .33165 L
.93906 .33165 L
.94006 .33165 L
.94106 .33165 L
.94206 .33165 L
.94306 .33165 L
.94406 .33165 L
.94505 .33165 L
.94605 .33165 L
.94705 .33165 L
.94805 .33165 L
Mistroke
.94905 .33617 L
.95005 .33617 L
.95105 .33617 L
.95205 .33617 L
.95305 .33617 L
.95405 .33617 L
.95504 .33617 L
.95604 .33617 L
.95704 .33617 L
.95804 .33617 L
.95904 .33617 L
.96004 .33617 L
.96104 .33617 L
.96204 .33617 L
.96304 .33617 L
.96404 .33617 L
.96503 .33617 L
.96603 .33617 L
.96703 .33617 L
.96803 .33617 L
.96903 .33617 L
.97003 .33617 L
.97103 .33617 L
.97203 .33617 L
.97303 .33617 L
.97403 .33617 L
.97502 .33617 L
.97602 .33617 L
.97702 .33617 L
.97802 .33617 L
.97902 .33617 L
.98002 .33617 L
.98102 .33617 L
.98202 .33617 L
.98302 .33617 L
.98402 .33617 L
.98501 .33617 L
.98601 .33617 L
.98701 .33617 L
.98801 .33617 L
.98901 .33617 L
.99001 .33617 L
.99101 .33617 L
.99201 .33617 L
.99301 .33617 L
.99401 .33617 L
.995 .33617 L
.996 .33617 L
.997 .33617 L
.998 .33617 L
Mistroke
.999 .33221 L
Mfstroke
0 0 1 r
gsave
.001 -0.61803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -1.54508 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(26)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(28)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(32)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(34)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .18541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .18541 L
.05095 .18541 L
.05195 .18541 L
.05295 .18541 L
.05395 .18541 L
.05495 .18541 L
.05594 .18541 L
.05694 .18541 L
.05794 .18541 L
.05894 .18541 L
.05994 .18541 L
.06094 .18541 L
.06194 .18541 L
.06294 .18541 L
.06394 .18541 L
.06494 .18541 L
.06593 .18541 L
.06693 .18541 L
.06793 .18541 L
.06893 .18541 L
.06993 .18541 L
.07093 .18541 L
.07193 .18541 L
.07293 .18541 L
.07393 .18541 L
.07493 .18541 L
.07592 .18541 L
.07692 .18541 L
.07792 .18541 L
.07892 .18541 L
.07992 .18541 L
.08092 .18541 L
.08192 .18541 L
.08292 .18541 L
.08392 .18541 L
.08492 .18541 L
.08591 .18541 L
.08691 .18541 L
.08791 .18541 L
.08891 .18541 L
.08991 .18541 L
.09091 .18541 L
.09191 .18541 L
.09291 .18541 L
.09391 .18541 L
.09491 .18541 L
.0959 .18541 L
.0969 .18541 L
.0979 .18541 L
.0989 .18541 L
Mistroke
.0999 .18541 L
.1009 .18541 L
.1019 .18541 L
.1029 .18541 L
.1039 .18541 L
.1049 .18541 L
.10589 .18541 L
.10689 .18541 L
.10789 .18541 L
.10889 .18541 L
.10989 .18541 L
.11089 .18541 L
.11189 .18541 L
.11289 .18541 L
.11389 .18541 L
.11489 .18541 L
.11588 .18541 L
.11688 .18541 L
.11788 .18541 L
.11888 .18541 L
.11988 .18541 L
.12088 .18541 L
.12188 .18541 L
.12288 .18541 L
.12388 .18541 L
.12488 .18541 L
.12587 .18541 L
.12687 .18541 L
.12787 .18541 L
.12887 .18541 L
.12987 .18541 L
.13087 .18541 L
.13187 .18541 L
.13287 .18541 L
.13387 .18541 L
.13487 .18541 L
.13586 .18541 L
.13686 .18541 L
.13786 .18541 L
.13886 .18541 L
.13986 .18541 L
.14086 .18541 L
.14186 .18541 L
.14286 .18541 L
.14386 .18541 L
.14486 .18541 L
.14585 .18541 L
.14685 .18541 L
.14785 .18541 L
.14885 .18541 L
Mistroke
.14985 .18541 L
.15085 .18541 L
.15185 .18541 L
.15285 .18541 L
.15385 .18541 L
.15485 .18541 L
.15584 .18541 L
.15684 .18541 L
.15784 .18541 L
.15884 .18541 L
.15984 .18541 L
.16084 .18541 L
.16184 .18541 L
.16284 .18541 L
.16384 .18541 L
.16484 .18541 L
.16583 .18541 L
.16683 .18541 L
.16783 .18541 L
.16883 .18541 L
.16983 .18541 L
.17083 .18541 L
.17183 .18541 L
.17283 .18541 L
.17383 .18541 L
.17483 .18541 L
.17582 .18541 L
.17682 .18541 L
.17782 .18541 L
.17882 .18541 L
.17982 .18541 L
.18082 .18541 L
.18182 .18541 L
.18282 .18541 L
.18382 .18541 L
.18482 .18541 L
.18581 .18541 L
.18681 .18541 L
.18781 .18541 L
.18881 .18541 L
.18981 .18541 L
.19081 .18541 L
.19181 .18541 L
.19281 .18541 L
.19381 .18541 L
.19481 .18541 L
.1958 .18541 L
.1968 .18541 L
.1978 .18541 L
.1988 .18541 L
Mistroke
.1998 .18541 L
.2008 .18541 L
.2018 .18541 L
.2028 .18541 L
.2038 .18541 L
.2048 .18541 L
.20579 .18541 L
.20679 .18541 L
.20779 .18541 L
.20879 .18541 L
.20979 .18541 L
.21079 .18541 L
.21179 .18541 L
.21279 .18541 L
.21379 .18541 L
.21479 .18541 L
.21578 .18541 L
.21678 .18541 L
.21778 .18541 L
.21878 .18541 L
.21978 .18541 L
.22078 .18541 L
.22178 .18541 L
.22278 .18541 L
.22378 .18541 L
.22478 .18541 L
.22577 .18541 L
.22677 .18541 L
.22777 .18541 L
.22877 .18541 L
.22977 .18541 L
.23077 .18541 L
.23177 .18541 L
.23277 .18541 L
.23377 .18541 L
.23477 .18541 L
.23576 .18541 L
.23676 .18541 L
.23776 .18541 L
.23876 .18541 L
.23976 .18541 L
.24076 .18541 L
.24176 .18541 L
.24276 .18541 L
.24376 .18541 L
.24476 .18541 L
.24575 .18541 L
.24675 .18541 L
.24775 .18541 L
.24875 .18541 L
Mistroke
.24975 .18541 L
.25075 .18541 L
.25175 .18541 L
.25275 .18542 L
.25375 .18541 L
.25475 .18542 L
.25574 .18542 L
.25674 .18542 L
.25774 .18542 L
.25874 .18542 L
.25974 .18542 L
.26074 .18542 L
.26174 .18542 L
.26274 .18542 L
.26374 .18542 L
.26474 .18542 L
.26573 .18542 L
.26673 .18542 L
.26773 .18542 L
.26873 .18542 L
.26973 .18542 L
.27073 .18542 L
.27173 .18542 L
.27273 .18542 L
.27373 .18542 L
.27473 .18542 L
.27572 .18542 L
.27672 .18542 L
.27772 .18542 L
.27872 .18542 L
.27972 .18542 L
.28072 .18542 L
.28172 .18542 L
.28272 .18542 L
.28372 .18542 L
.28472 .18542 L
.28571 .18542 L
.28671 .18542 L
.28771 .18542 L
.28871 .18542 L
.28971 .18542 L
.29071 .18542 L
.29171 .18542 L
.29271 .18542 L
.29371 .18542 L
.29471 .18541 L
.2957 .18542 L
.2967 .18542 L
.2977 .18541 L
.2987 .18541 L
Mistroke
.2997 .18541 L
.3007 .18541 L
.3017 .18541 L
.3027 .18541 L
.3037 .18542 L
.3047 .18542 L
.30569 .18542 L
.30669 .18542 L
.30769 .18541 L
.30869 .18541 L
.30969 .18541 L
.31069 .18541 L
.31169 .18541 L
.31269 .18541 L
.31369 .18541 L
.31469 .18541 L
.31568 .18541 L
.31668 .18541 L
.31768 .18541 L
.31868 .18541 L
.31968 .18541 L
.32068 .18541 L
.32168 .18541 L
.32268 .18541 L
.32368 .18541 L
.32468 .18542 L
.32567 .18542 L
.32667 .18542 L
.32767 .18542 L
.32867 .18542 L
.32967 .18542 L
.33067 .18542 L
.33167 .18542 L
.33267 .18542 L
.33367 .18542 L
.33467 .18542 L
.33566 .18542 L
.33666 .18542 L
.33766 .18542 L
.33866 .18542 L
.33966 .18541 L
.34066 .18541 L
.34166 .18541 L
.34266 .18541 L
.34366 .18541 L
.34466 .18541 L
.34565 .18541 L
.34665 .18541 L
.34765 .18541 L
.34865 .18541 L
Mistroke
.34965 .18541 L
.35065 .18541 L
.35165 .18541 L
.35265 .18541 L
.35365 .18541 L
.35465 .18541 L
.35564 .18541 L
.35664 .18541 L
.35764 .18541 L
.35864 .18541 L
.35964 .18541 L
.36064 .18541 L
.36164 .18541 L
.36264 .18541 L
.36364 .18541 L
.36464 .18541 L
.36563 .18541 L
.36663 .18541 L
.36763 .18541 L
.36863 .18541 L
.36963 .18542 L
.37063 .18542 L
.37163 .18542 L
.37263 .18541 L
.37363 .18541 L
.37463 .18542 L
.37562 .18542 L
.37662 .18542 L
.37762 .18542 L
.37862 .18542 L
.37962 .18541 L
.38062 .18542 L
.38162 .18542 L
.38262 .18542 L
.38362 .18542 L
.38462 .18541 L
.38561 .18541 L
.38661 .18541 L
.38761 .18541 L
.38861 .18541 L
.38961 .18541 L
.39061 .18541 L
.39161 .18541 L
.39261 .18542 L
.39361 .18541 L
.39461 .18541 L
.3956 .18541 L
.3966 .18541 L
.3976 .18541 L
.3986 .18542 L
Mistroke
.3996 .18542 L
.4006 .18542 L
.4016 .18542 L
.4026 .18542 L
.4036 .18542 L
.4046 .18542 L
.40559 .18542 L
.40659 .18542 L
.40759 .18542 L
.40859 .18542 L
.40959 .18542 L
.41059 .18542 L
.41159 .18542 L
.41259 .18542 L
.41359 .18542 L
.41459 .18542 L
.41558 .18542 L
.41658 .18542 L
.41758 .18542 L
.41858 .18542 L
.41958 .18542 L
.42058 .18541 L
.42158 .18541 L
.42258 .18542 L
.42358 .18542 L
.42458 .18542 L
.42557 .18542 L
.42657 .18542 L
.42757 .18542 L
.42857 .18542 L
.42957 .18542 L
.43057 .18541 L
.43157 .18541 L
.43257 .18542 L
.43357 .18542 L
.43457 .18541 L
.43556 .18541 L
.43656 .18541 L
.43756 .18542 L
.43856 .18541 L
.43956 .18541 L
.44056 .18542 L
.44156 .18542 L
.44256 .18542 L
.44356 .18542 L
.44456 .18542 L
.44555 .18542 L
.44655 .18542 L
.44755 .18542 L
.44855 .18542 L
Mistroke
.44955 .18542 L
.45055 .18542 L
.45155 .18542 L
.45255 .18542 L
.45355 .18542 L
.45455 .18542 L
.45554 .18542 L
.45654 .18542 L
.45754 .18542 L
.45854 .18542 L
.45954 .18542 L
.46054 .18542 L
.46154 .18542 L
.46254 .18542 L
.46354 .18542 L
.46454 .18542 L
.46553 .18542 L
.46653 .18542 L
.46753 .18542 L
.46853 .18542 L
.46953 .18542 L
.47053 .18542 L
.47153 .18542 L
.47253 .18542 L
.47353 .18542 L
.47453 .18542 L
.47552 .18542 L
.47652 .18542 L
.47752 .18542 L
.47852 .18542 L
.47952 .18542 L
.48052 .18542 L
.48152 .18542 L
.48252 .18542 L
.48352 .18542 L
.48452 .18542 L
.48551 .18542 L
.48651 .18542 L
.48751 .18542 L
.48851 .18542 L
.48951 .18542 L
.49051 .18542 L
.49151 .18542 L
.49251 .18542 L
.49351 .18542 L
.49451 .18542 L
.4955 .18542 L
.4965 .18542 L
.4975 .18542 L
.4985 .18542 L
Mistroke
.4995 .18542 L
.5005 .18542 L
.5015 .18542 L
.5025 .18542 L
.5035 .18542 L
.5045 .18542 L
.50549 .18542 L
.50649 .18542 L
.50749 .18542 L
.50849 .18542 L
.50949 .18542 L
.51049 .18542 L
.51149 .18542 L
.51249 .18542 L
.51349 .18542 L
.51449 .18542 L
.51548 .18542 L
.51648 .18542 L
.51748 .18542 L
.51848 .18542 L
.51948 .18542 L
.52048 .18542 L
.52148 .18542 L
.52248 .18542 L
.52348 .18542 L
.52448 .18542 L
.52547 .18542 L
.52647 .18542 L
.52747 .18542 L
.52847 .18542 L
.52947 .18542 L
.53047 .18542 L
.53147 .18542 L
.53247 .18543 L
.53347 .18542 L
.53447 .18542 L
.53546 .18542 L
.53646 .18542 L
.53746 .18542 L
.53846 .18542 L
.53946 .18542 L
.54046 .18542 L
.54146 .18542 L
.54246 .18542 L
.54346 .18542 L
.54446 .18542 L
.54545 .18542 L
.54645 .18542 L
.54745 .18542 L
.54845 .18542 L
Mistroke
.54945 .18542 L
.55045 .18542 L
.55145 .18542 L
.55245 .18542 L
.55345 .18542 L
.55445 .18542 L
.55544 .18542 L
.55644 .18542 L
.55744 .18542 L
.55844 .18542 L
.55944 .18542 L
.56044 .18542 L
.56144 .18542 L
.56244 .18542 L
.56344 .18542 L
.56444 .18542 L
.56543 .18542 L
.56643 .18542 L
.56743 .18542 L
.56843 .18542 L
.56943 .18542 L
.57043 .18542 L
.57143 .18543 L
.57243 .18543 L
.57343 .18543 L
.57443 .18543 L
.57542 .18543 L
.57642 .18543 L
.57742 .18543 L
.57842 .18543 L
.57942 .18543 L
.58042 .18542 L
.58142 .18543 L
.58242 .18542 L
.58342 .18543 L
.58442 .18542 L
.58541 .18543 L
.58641 .18543 L
.58741 .18543 L
.58841 .18543 L
.58941 .18542 L
.59041 .18542 L
.59141 .18542 L
.59241 .18543 L
.59341 .18543 L
.59441 .18543 L
.5954 .18543 L
.5964 .18543 L
.5974 .18543 L
.5984 .18542 L
Mistroke
.5994 .18542 L
.6004 .18542 L
.6014 .18542 L
.6024 .18542 L
.6034 .18543 L
.6044 .18542 L
.60539 .18542 L
.60639 .18542 L
.60739 .18542 L
.60839 .18542 L
.60939 .18542 L
.61039 .18542 L
.61139 .18542 L
.61239 .18542 L
.61339 .18542 L
.61439 .18542 L
.61538 .18542 L
.61638 .18542 L
.61738 .18542 L
.61838 .18542 L
.61938 .18542 L
.62038 .18543 L
.62138 .18543 L
.62238 .18543 L
.62338 .18543 L
.62438 .18543 L
.62537 .18543 L
.62637 .18543 L
.62737 .18543 L
.62837 .18543 L
.62937 .18543 L
.63037 .18543 L
.63137 .18543 L
.63237 .18543 L
.63337 .18543 L
.63437 .18543 L
.63536 .18543 L
.63636 .18543 L
.63736 .18543 L
.63836 .18543 L
.63936 .18543 L
.64036 .18543 L
.64136 .18543 L
.64236 .18543 L
.64336 .18543 L
.64436 .18543 L
.64535 .18543 L
.64635 .18543 L
.64735 .18543 L
.64835 .18543 L
Mistroke
.64935 .18543 L
.65035 .18543 L
.65135 .18543 L
.65235 .18543 L
.65335 .18543 L
.65435 .18543 L
.65534 .18543 L
.65634 .18543 L
.65734 .18543 L
.65834 .18543 L
.65934 .18543 L
.66034 .18543 L
.66134 .18543 L
.66234 .18543 L
.66334 .18543 L
.66434 .18543 L
.66533 .18543 L
.66633 .18543 L
.66733 .18543 L
.66833 .18543 L
.66933 .18543 L
.67033 .18543 L
.67133 .18543 L
.67233 .18543 L
.67333 .18543 L
.67433 .18543 L
.67532 .18543 L
.67632 .18543 L
.67732 .18543 L
.67832 .18543 L
.67932 .18543 L
.68032 .18543 L
.68132 .18543 L
.68232 .18543 L
.68332 .18543 L
.68432 .18543 L
.68531 .18543 L
.68631 .18543 L
.68731 .18543 L
.68831 .18543 L
.68931 .18543 L
.69031 .18543 L
.69131 .18543 L
.69231 .18543 L
.69331 .18543 L
.69431 .18543 L
.6953 .18543 L
.6963 .18543 L
.6973 .18543 L
.6983 .18543 L
Mistroke
.6993 .18543 L
.7003 .18543 L
.7013 .18543 L
.7023 .18543 L
.7033 .18543 L
.7043 .18543 L
.70529 .18543 L
.70629 .18543 L
.70729 .18543 L
.70829 .18543 L
.70929 .18543 L
.71029 .18543 L
.71129 .18543 L
.71229 .18543 L
.71329 .18543 L
.71429 .18543 L
.71528 .18543 L
.71628 .18543 L
.71728 .18543 L
.71828 .18543 L
.71928 .18543 L
.72028 .18543 L
.72128 .18543 L
.72228 .18543 L
.72328 .18543 L
.72428 .18543 L
.72527 .18543 L
.72627 .18543 L
.72727 .18543 L
.72827 .18543 L
.72927 .18543 L
.73027 .18542 L
.73127 .18542 L
.73227 .18542 L
.73327 .18542 L
.73427 .18542 L
.73526 .18542 L
.73626 .18542 L
.73726 .18542 L
.73826 .18542 L
.73926 .18542 L
.74026 .18542 L
.74126 .18542 L
.74226 .18542 L
.74326 .18542 L
.74426 .18542 L
.74525 .18542 L
.74625 .18542 L
.74725 .18542 L
.74825 .18542 L
Mistroke
.74925 .18542 L
.75025 .18542 L
.75125 .18542 L
.75225 .18542 L
.75325 .18542 L
.75425 .18542 L
.75524 .18542 L
.75624 .18542 L
.75724 .18542 L
.75824 .18542 L
.75924 .18542 L
.76024 .18542 L
.76124 .18542 L
.76224 .18542 L
.76324 .18542 L
.76424 .18542 L
.76523 .18542 L
.76623 .18542 L
.76723 .18542 L
.76823 .18542 L
.76923 .18542 L
.77023 .18542 L
.77123 .18542 L
.77223 .18542 L
.77323 .18542 L
.77423 .18542 L
.77522 .18542 L
.77622 .18541 L
.77722 .18541 L
.77822 .18541 L
.77922 .18541 L
.78022 .18541 L
.78122 .18541 L
.78222 .18541 L
.78322 .18541 L
.78422 .18541 L
.78521 .18541 L
.78621 .18541 L
.78721 .18541 L
.78821 .18541 L
.78921 .18541 L
.79021 .18541 L
.79121 .18541 L
.79221 .18541 L
.79321 .18541 L
.79421 .18541 L
.7952 .18542 L
.7962 .18542 L
.7972 .18542 L
.7982 .18542 L
Mistroke
.7992 .18542 L
.8002 .18542 L
.8012 .18541 L
.8022 .18541 L
.8032 .18541 L
.8042 .18541 L
.80519 .18541 L
.80619 .18541 L
.80719 .18541 L
.80819 .18541 L
.80919 .18541 L
.81019 .18541 L
.81119 .18541 L
.81219 .18542 L
.81319 .18542 L
.81419 .18541 L
.81518 .18542 L
.81618 .18542 L
.81718 .18542 L
.81818 .18542 L
.81918 .18542 L
.82018 .18542 L
.82118 .18542 L
.82218 .18542 L
.82318 .18541 L
.82418 .18541 L
.82517 .18541 L
.82617 .18541 L
.82717 .18541 L
.82817 .18541 L
.82917 .18541 L
.83017 .18541 L
.83117 .18541 L
.83217 .18541 L
.83317 .18541 L
.83417 .18541 L
.83516 .18541 L
.83616 .18541 L
.83716 .18541 L
.83816 .18541 L
.83916 .18541 L
.84016 .18541 L
.84116 .18541 L
.84216 .18541 L
.84316 .18541 L
.84416 .18541 L
.84515 .18541 L
.84615 .18541 L
.84715 .18541 L
.84815 .18541 L
Mistroke
.84915 .18541 L
.85015 .18541 L
.85115 .18541 L
.85215 .18541 L
.85315 .18541 L
.85415 .18541 L
.85514 .18541 L
.85614 .18541 L
.85714 .18541 L
.85814 .18541 L
.85914 .18541 L
.86014 .18541 L
.86114 .18541 L
.86214 .18541 L
.86314 .18541 L
.86414 .18541 L
.86513 .18541 L
.86613 .18541 L
.86713 .18541 L
.86813 .18541 L
.86913 .18541 L
.87013 .18541 L
.87113 .18541 L
.87213 .18541 L
.87313 .18541 L
.87413 .18541 L
.87512 .18541 L
.87612 .18541 L
.87712 .18541 L
.87812 .18541 L
.87912 .18542 L
.88012 .18542 L
.88112 .18542 L
.88212 .18542 L
.88312 .18542 L
.88412 .18542 L
.88511 .18542 L
.88611 .18542 L
.88711 .18542 L
.88811 .18542 L
.88911 .18542 L
.89011 .18541 L
.89111 .18541 L
.89211 .18541 L
.89311 .18541 L
.89411 .18541 L
.8951 .18541 L
.8961 .18541 L
.8971 .18541 L
.8981 .18541 L
Mistroke
.8991 .18541 L
.9001 .18541 L
.9011 .18542 L
.9021 .18542 L
.9031 .18542 L
.9041 .18542 L
.90509 .18542 L
.90609 .18542 L
.90709 .18542 L
.90809 .18542 L
.90909 .18542 L
.91009 .18542 L
.91109 .18542 L
.91209 .18542 L
.91309 .18542 L
.91409 .18542 L
.91508 .18542 L
.91608 .18542 L
.91708 .18542 L
.91808 .18542 L
.91908 .18542 L
.92008 .18542 L
.92108 .18542 L
.92208 .18542 L
.92308 .18542 L
.92408 .18542 L
.92507 .18542 L
.92607 .18542 L
.92707 .18542 L
.92807 .18542 L
.92907 .18542 L
.93007 .18542 L
.93107 .18542 L
.93207 .18542 L
.93307 .18542 L
.93407 .18542 L
.93506 .18542 L
.93606 .18542 L
.93706 .18542 L
.93806 .18542 L
.93906 .18542 L
.94006 .18542 L
.94106 .18542 L
.94206 .18542 L
.94306 .18542 L
.94406 .18542 L
.94505 .18542 L
.94605 .18542 L
.94705 .18542 L
.94805 .18542 L
Mistroke
.94905 .18542 L
.95005 .18542 L
.95105 .18542 L
.95205 .18542 L
.95305 .18542 L
.95405 .18542 L
.95504 .18542 L
.95604 .18541 L
.95704 .18542 L
.95804 .18542 L
.95904 .18542 L
.96004 .18542 L
.96104 .18542 L
.96204 .18542 L
.96304 .18542 L
.96404 .18542 L
.96503 .18542 L
.96603 .18542 L
.96703 .18541 L
.96803 .18541 L
.96903 .18541 L
.97003 .18541 L
.97103 .18541 L
.97203 .18541 L
.97303 .18541 L
.97403 .18541 L
.97502 .18541 L
.97602 .18541 L
.97702 .18541 L
.97802 .18541 L
.97902 .18541 L
.98002 .18541 L
.98102 .18541 L
.98202 .18541 L
.98302 .18541 L
.98402 .18541 L
.98501 .18541 L
.98601 .18541 L
.98701 .18541 L
.98801 .18541 L
.98901 .18541 L
.99001 .18541 L
.99101 .18541 L
.99201 .18541 L
.99301 .18541 L
.99401 .18541 L
.995 .18541 L
.996 .18541 L
.997 .18541 L
.998 .18541 L
Mistroke
.999 .18541 L
Mfstroke
0 .98 .604 r
gsave
.999 .15648 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .12608 m
.001 .12608 L
.002 .12608 L
.003 .12608 L
.004 .12608 L
.005 .12608 L
.00599 .12608 L
.00699 .12608 L
.00799 .12608 L
.00899 .12608 L
.00999 .12608 L
.01099 .12608 L
.01199 .12608 L
.01299 .12608 L
.01399 .12608 L
.01499 .12608 L
.01598 .12608 L
.01698 .12608 L
.01798 .12608 L
.01898 .12608 L
.01998 .12608 L
.02098 .12608 L
.02198 .12608 L
.02298 .12608 L
.02398 .12608 L
.02498 .12608 L
.02597 .12608 L
.02697 .12608 L
.02797 .12608 L
.02897 .12608 L
.02997 .12608 L
.03097 .12608 L
.03197 .12608 L
.03297 .12608 L
.03397 .12608 L
.03497 .12608 L
.03596 .12608 L
.03696 .12608 L
.03796 .12608 L
.03896 .12608 L
.03996 .12608 L
.04096 .12608 L
.04196 .12608 L
.04296 .12608 L
.04396 .12608 L
.04496 .12608 L
.04595 .12608 L
.04695 .12608 L
.04795 .12608 L
.04895 .12608 L
Mistroke
.04995 .12858 L
.05095 .12858 L
.05195 .12858 L
.05295 .12858 L
.05395 .12858 L
.05495 .12858 L
.05594 .12858 L
.05694 .12858 L
.05794 .12858 L
.05894 .12858 L
.05994 .12858 L
.06094 .12858 L
.06194 .12858 L
.06294 .12858 L
.06394 .12858 L
.06494 .12858 L
.06593 .12858 L
.06693 .12858 L
.06793 .12858 L
.06893 .12858 L
.06993 .12858 L
.07093 .12858 L
.07193 .12858 L
.07293 .12858 L
.07393 .12858 L
.07493 .12858 L
.07592 .12858 L
.07692 .12858 L
.07792 .12858 L
.07892 .12858 L
.07992 .12858 L
.08092 .12858 L
.08192 .12858 L
.08292 .12858 L
.08392 .12858 L
.08492 .12858 L
.08591 .12858 L
.08691 .12858 L
.08791 .12858 L
.08891 .12858 L
.08991 .12858 L
.09091 .12858 L
.09191 .12858 L
.09291 .12858 L
.09391 .12858 L
.09491 .12858 L
.0959 .12858 L
.0969 .12858 L
.0979 .12858 L
.0989 .12858 L
Mistroke
.0999 .10012 L
.1009 .10012 L
.1019 .10012 L
.1029 .10012 L
.1039 .10012 L
.1049 .10012 L
.10589 .10012 L
.10689 .10012 L
.10789 .10012 L
.10889 .10012 L
.10989 .10012 L
.11089 .10012 L
.11189 .10012 L
.11289 .10012 L
.11389 .10012 L
.11489 .10012 L
.11588 .10012 L
.11688 .10012 L
.11788 .10012 L
.11888 .10012 L
.11988 .10012 L
.12088 .10012 L
.12188 .10012 L
.12288 .10012 L
.12388 .10012 L
.12488 .10012 L
.12587 .10012 L
.12687 .10012 L
.12787 .10012 L
.12887 .10012 L
.12987 .10012 L
.13087 .10012 L
.13187 .10012 L
.13287 .10012 L
.13387 .10012 L
.13487 .10012 L
.13586 .10012 L
.13686 .10012 L
.13786 .10012 L
.13886 .10012 L
.13986 .10012 L
.14086 .10012 L
.14186 .10012 L
.14286 .10012 L
.14386 .10012 L
.14486 .10012 L
.14585 .10012 L
.14685 .10012 L
.14785 .10012 L
.14885 .10012 L
Mistroke
.14985 .06558 L
.15085 .06558 L
.15185 .06558 L
.15285 .06558 L
.15385 .06558 L
.15485 .06558 L
.15584 .06558 L
.15684 .06558 L
.15784 .06558 L
.15884 .06558 L
.15984 .06558 L
.16084 .06558 L
.16184 .06558 L
.16284 .06558 L
.16384 .06558 L
.16484 .06558 L
.16583 .06558 L
.16683 .06558 L
.16783 .06558 L
.16883 .06558 L
.16983 .06558 L
.17083 .06558 L
.17183 .06558 L
.17283 .06558 L
.17383 .06558 L
.17483 .06558 L
.17582 .06558 L
.17682 .06558 L
.17782 .06558 L
.17882 .06558 L
.17982 .06558 L
.18082 .06558 L
.18182 .06558 L
.18282 .06558 L
.18382 .06558 L
.18482 .06558 L
.18581 .06558 L
.18681 .06558 L
.18781 .06558 L
.18881 .06558 L
.18981 .06558 L
.19081 .06558 L
.19181 .06558 L
.19281 .06558 L
.19381 .06558 L
.19481 .06558 L
.1958 .06558 L
.1968 .06558 L
.1978 .06558 L
.1988 .06558 L
Mistroke
.1998 .08749 L
.2008 .08749 L
.2018 .08749 L
.2028 .08749 L
.2038 .08749 L
.2048 .08749 L
.20579 .08749 L
.20679 .08749 L
.20779 .08749 L
.20879 .08749 L
.20979 .08749 L
.21079 .08749 L
.21179 .08749 L
.21279 .08749 L
.21379 .08749 L
.21479 .08749 L
.21578 .08749 L
.21678 .08749 L
.21778 .08749 L
.21878 .08749 L
.21978 .08749 L
.22078 .08749 L
.22178 .08749 L
.22278 .08749 L
.22378 .08749 L
.22478 .08749 L
.22577 .08749 L
.22677 .08749 L
.22777 .08749 L
.22877 .08749 L
.22977 .08749 L
.23077 .08749 L
.23177 .08749 L
.23277 .08749 L
.23377 .08749 L
.23477 .08749 L
.23576 .08749 L
.23676 .08749 L
.23776 .08749 L
.23876 .08749 L
.23976 .08749 L
.24076 .08749 L
.24176 .08749 L
.24276 .08749 L
.24376 .08749 L
.24476 .08749 L
.24575 .08749 L
.24675 .08749 L
.24775 .08749 L
.24875 .08749 L
Mistroke
.24975 .12793 L
.25075 .12793 L
.25175 .12793 L
.25275 .12793 L
.25375 .12793 L
.25475 .12793 L
.25574 .12793 L
.25674 .12793 L
.25774 .12793 L
.25874 .12793 L
.25974 .12793 L
.26074 .12793 L
.26174 .12793 L
.26274 .12793 L
.26374 .12793 L
.26474 .12793 L
.26573 .12793 L
.26673 .12793 L
.26773 .12793 L
.26873 .12793 L
.26973 .12793 L
.27073 .12793 L
.27173 .12793 L
.27273 .12793 L
.27373 .12793 L
.27473 .12793 L
.27572 .12793 L
.27672 .12793 L
.27772 .12793 L
.27872 .12793 L
.27972 .12793 L
.28072 .12793 L
.28172 .12793 L
.28272 .12793 L
.28372 .12793 L
.28472 .12793 L
.28571 .12793 L
.28671 .12793 L
.28771 .12793 L
.28871 .12793 L
.28971 .12793 L
.29071 .12793 L
.29171 .12793 L
.29271 .12793 L
.29371 .12793 L
.29471 .12793 L
.2957 .12793 L
.2967 .12793 L
.2977 .12793 L
.2987 .12793 L
Mistroke
.2997 .13315 L
.3007 .13315 L
.3017 .13315 L
.3027 .13315 L
.3037 .13315 L
.3047 .13315 L
.30569 .13315 L
.30669 .13315 L
.30769 .13315 L
.30869 .13315 L
.30969 .13315 L
.31069 .13315 L
.31169 .13315 L
.31269 .13315 L
.31369 .13315 L
.31469 .13315 L
.31568 .13315 L
.31668 .13315 L
.31768 .13315 L
.31868 .13315 L
.31968 .13315 L
.32068 .13315 L
.32168 .13315 L
.32268 .13315 L
.32368 .13315 L
.32468 .13315 L
.32567 .13315 L
.32667 .13315 L
.32767 .13315 L
.32867 .13315 L
.32967 .13315 L
.33067 .13315 L
.33167 .13315 L
.33267 .13315 L
.33367 .13315 L
.33467 .13315 L
.33566 .13315 L
.33666 .13315 L
.33766 .13315 L
.33866 .13315 L
.33966 .13315 L
.34066 .13315 L
.34166 .13315 L
.34266 .13315 L
.34366 .13315 L
.34466 .13315 L
.34565 .13315 L
.34665 .13315 L
.34765 .13315 L
.34865 .13315 L
Mistroke
.34965 .12292 L
.35065 .12292 L
.35165 .12292 L
.35265 .12292 L
.35365 .12292 L
.35465 .12292 L
.35564 .12292 L
.35664 .12292 L
.35764 .12292 L
.35864 .12292 L
.35964 .12292 L
.36064 .12292 L
.36164 .12292 L
.36264 .12292 L
.36364 .12292 L
.36464 .12292 L
.36563 .12292 L
.36663 .12292 L
.36763 .12292 L
.36863 .12292 L
.36963 .12292 L
.37063 .12292 L
.37163 .12292 L
.37263 .12292 L
.37363 .12292 L
.37463 .12292 L
.37562 .12292 L
.37662 .12292 L
.37762 .12292 L
.37862 .12292 L
.37962 .12292 L
.38062 .12292 L
.38162 .12292 L
.38262 .12292 L
.38362 .12292 L
.38462 .12292 L
.38561 .12292 L
.38661 .12292 L
.38761 .12292 L
.38861 .12292 L
.38961 .12292 L
.39061 .12292 L
.39161 .12292 L
.39261 .12292 L
.39361 .12292 L
.39461 .12292 L
.3956 .12292 L
.3966 .12292 L
.3976 .12292 L
.3986 .12292 L
Mistroke
.3996 .11978 L
.4006 .11978 L
.4016 .11978 L
.4026 .11978 L
.4036 .11978 L
.4046 .11978 L
.40559 .11978 L
.40659 .11978 L
.40759 .11978 L
.40859 .11978 L
.40959 .11978 L
.41059 .11978 L
.41159 .11978 L
.41259 .11978 L
.41359 .11978 L
.41459 .11978 L
.41558 .11978 L
.41658 .11978 L
.41758 .11978 L
.41858 .11978 L
.41958 .11978 L
.42058 .11978 L
.42158 .11978 L
.42258 .11978 L
.42358 .11978 L
.42458 .11978 L
.42557 .11978 L
.42657 .11978 L
.42757 .11978 L
.42857 .11978 L
.42957 .11978 L
.43057 .11978 L
.43157 .11978 L
.43257 .11978 L
.43357 .11978 L
.43457 .11978 L
.43556 .11978 L
.43656 .11978 L
.43756 .11978 L
.43856 .11978 L
.43956 .11978 L
.44056 .11978 L
.44156 .11978 L
.44256 .11978 L
.44356 .11978 L
.44456 .11978 L
.44555 .11978 L
.44655 .11978 L
.44755 .11978 L
.44855 .11978 L
Mistroke
.44955 .12842 L
.45055 .12842 L
.45155 .12842 L
.45255 .12842 L
.45355 .12842 L
.45455 .12842 L
.45554 .12842 L
.45654 .12842 L
.45754 .12842 L
.45854 .12842 L
.45954 .12842 L
.46054 .12842 L
.46154 .12842 L
.46254 .12842 L
.46354 .12842 L
.46454 .12842 L
.46553 .12842 L
.46653 .12842 L
.46753 .12842 L
.46853 .12842 L
.46953 .12842 L
.47053 .12842 L
.47153 .12842 L
.47253 .12842 L
.47353 .12842 L
.47453 .12842 L
.47552 .12842 L
.47652 .12842 L
.47752 .12842 L
.47852 .12842 L
.47952 .12842 L
.48052 .12842 L
.48152 .12842 L
.48252 .12842 L
.48352 .12842 L
.48452 .12842 L
.48551 .12842 L
.48651 .12842 L
.48751 .12842 L
.48851 .12842 L
.48951 .12842 L
.49051 .12842 L
.49151 .12842 L
.49251 .12842 L
.49351 .12842 L
.49451 .12842 L
.4955 .12842 L
.4965 .12842 L
.4975 .12842 L
.4985 .12842 L
Mistroke
.4995 .14031 L
.5005 .14031 L
.5015 .14031 L
.5025 .14031 L
.5035 .14031 L
.5045 .14031 L
.50549 .14031 L
.50649 .14031 L
.50749 .14031 L
.50849 .14031 L
.50949 .14031 L
.51049 .14031 L
.51149 .14031 L
.51249 .14031 L
.51349 .14031 L
.51449 .14031 L
.51548 .14031 L
.51648 .14031 L
.51748 .14031 L
.51848 .14031 L
.51948 .14031 L
.52048 .14031 L
.52148 .14031 L
.52248 .14031 L
.52348 .14031 L
.52448 .14031 L
.52547 .14031 L
.52647 .14031 L
.52747 .14031 L
.52847 .14031 L
.52947 .14031 L
.53047 .14031 L
.53147 .14031 L
.53247 .14031 L
.53347 .14031 L
.53447 .14031 L
.53546 .14031 L
.53646 .14031 L
.53746 .14031 L
.53846 .14031 L
.53946 .14031 L
.54046 .14031 L
.54146 .14031 L
.54246 .14031 L
.54346 .14031 L
.54446 .14031 L
.54545 .14031 L
.54645 .14031 L
.54745 .14031 L
.54845 .14031 L
Mistroke
.54945 .14726 L
.55045 .14726 L
.55145 .14726 L
.55245 .14726 L
.55345 .14726 L
.55445 .14726 L
.55544 .14726 L
.55644 .14726 L
.55744 .14726 L
.55844 .14726 L
.55944 .14726 L
.56044 .14726 L
.56144 .14726 L
.56244 .14726 L
.56344 .14726 L
.56444 .14726 L
.56543 .14726 L
.56643 .14726 L
.56743 .14726 L
.56843 .14726 L
.56943 .14726 L
.57043 .14726 L
.57143 .14726 L
.57243 .14726 L
.57343 .14726 L
.57443 .14726 L
.57542 .14726 L
.57642 .14726 L
.57742 .14726 L
.57842 .14726 L
.57942 .14726 L
.58042 .14726 L
.58142 .14726 L
.58242 .14726 L
.58342 .14726 L
.58442 .14726 L
.58541 .14726 L
.58641 .14726 L
.58741 .14726 L
.58841 .14726 L
.58941 .14726 L
.59041 .14726 L
.59141 .14726 L
.59241 .14726 L
.59341 .14726 L
.59441 .14726 L
.5954 .14726 L
.5964 .14726 L
.5974 .14726 L
.5984 .14726 L
Mistroke
.5994 .15087 L
.6004 .15087 L
.6014 .15087 L
.6024 .15087 L
.6034 .15087 L
.6044 .15087 L
.60539 .15087 L
.60639 .15087 L
.60739 .15087 L
.60839 .15087 L
.60939 .15087 L
.61039 .15087 L
.61139 .15087 L
.61239 .15087 L
.61339 .15087 L
.61439 .15087 L
.61538 .15087 L
.61638 .15087 L
.61738 .15087 L
.61838 .15087 L
.61938 .15087 L
.62038 .15087 L
.62138 .15087 L
.62238 .15087 L
.62338 .15087 L
.62438 .15087 L
.62537 .15087 L
.62637 .15087 L
.62737 .15087 L
.62837 .15087 L
.62937 .15087 L
.63037 .15087 L
.63137 .15087 L
.63237 .15087 L
.63337 .15087 L
.63437 .15087 L
.63536 .15087 L
.63636 .15087 L
.63736 .15087 L
.63836 .15087 L
.63936 .15087 L
.64036 .15087 L
.64136 .15087 L
.64236 .15087 L
.64336 .15087 L
.64436 .15087 L
.64535 .15087 L
.64635 .15087 L
.64735 .15087 L
.64835 .15087 L
Mistroke
.64935 .14656 L
.65035 .14656 L
.65135 .14656 L
.65235 .14656 L
.65335 .14656 L
.65435 .14656 L
.65534 .14656 L
.65634 .14656 L
.65734 .14656 L
.65834 .14656 L
.65934 .14656 L
.66034 .14656 L
.66134 .14656 L
.66234 .14656 L
.66334 .14656 L
.66434 .14656 L
.66533 .14656 L
.66633 .14656 L
.66733 .14656 L
.66833 .14656 L
.66933 .14656 L
.67033 .14656 L
.67133 .14656 L
.67233 .14656 L
.67333 .14656 L
.67433 .14656 L
.67532 .14656 L
.67632 .14656 L
.67732 .14656 L
.67832 .14656 L
.67932 .14656 L
.68032 .14656 L
.68132 .14656 L
.68232 .14656 L
.68332 .14656 L
.68432 .14656 L
.68531 .14656 L
.68631 .14656 L
.68731 .14656 L
.68831 .14656 L
.68931 .14656 L
.69031 .14656 L
.69131 .14656 L
.69231 .14656 L
.69331 .14656 L
.69431 .14656 L
.6953 .14656 L
.6963 .14656 L
.6973 .14656 L
.6983 .14656 L
Mistroke
.6993 .15218 L
.7003 .15218 L
.7013 .15218 L
.7023 .15218 L
.7033 .15218 L
.7043 .15218 L
.70529 .15218 L
.70629 .15218 L
.70729 .15218 L
.70829 .15218 L
.70929 .15218 L
.71029 .15218 L
.71129 .15218 L
.71229 .15218 L
.71329 .15218 L
.71429 .15218 L
.71528 .15218 L
.71628 .15218 L
.71728 .15218 L
.71828 .15218 L
.71928 .15218 L
.72028 .15218 L
.72128 .15218 L
.72228 .15218 L
.72328 .15218 L
.72428 .15218 L
.72527 .15218 L
.72627 .15218 L
.72727 .15218 L
.72827 .15218 L
.72927 .15218 L
.73027 .15218 L
.73127 .15218 L
.73227 .15218 L
.73327 .15218 L
.73427 .15218 L
.73526 .15218 L
.73626 .15218 L
.73726 .15218 L
.73826 .15218 L
.73926 .15218 L
.74026 .15218 L
.74126 .15218 L
.74226 .15218 L
.74326 .15218 L
.74426 .15218 L
.74525 .15218 L
.74625 .15218 L
.74725 .15218 L
.74825 .15218 L
Mistroke
.74925 .15763 L
.75025 .15763 L
.75125 .15763 L
.75225 .15763 L
.75325 .15763 L
.75425 .15763 L
.75524 .15763 L
.75624 .15763 L
.75724 .15763 L
.75824 .15763 L
.75924 .15763 L
.76024 .15763 L
.76124 .15763 L
.76224 .15763 L
.76324 .15763 L
.76424 .15763 L
.76523 .15763 L
.76623 .15763 L
.76723 .15763 L
.76823 .15763 L
.76923 .15763 L
.77023 .15763 L
.77123 .15763 L
.77223 .15763 L
.77323 .15763 L
.77423 .15763 L
.77522 .15763 L
.77622 .15763 L
.77722 .15763 L
.77822 .15763 L
.77922 .15763 L
.78022 .15763 L
.78122 .15763 L
.78222 .15763 L
.78322 .15763 L
.78422 .15763 L
.78521 .15763 L
.78621 .15763 L
.78721 .15763 L
.78821 .15763 L
.78921 .15763 L
.79021 .15763 L
.79121 .15763 L
.79221 .15763 L
.79321 .15763 L
.79421 .15763 L
.7952 .15763 L
.7962 .15763 L
.7972 .15763 L
.7982 .15763 L
Mistroke
.7992 .16805 L
.8002 .16805 L
.8012 .16805 L
.8022 .16805 L
.8032 .16805 L
.8042 .16805 L
.80519 .16805 L
.80619 .16805 L
.80719 .16805 L
.80819 .16805 L
.80919 .16805 L
.81019 .16805 L
.81119 .16805 L
.81219 .16805 L
.81319 .16805 L
.81419 .16805 L
.81518 .16805 L
.81618 .16805 L
.81718 .16805 L
.81818 .16805 L
.81918 .16805 L
.82018 .16805 L
.82118 .16805 L
.82218 .16805 L
.82318 .16805 L
.82418 .16805 L
.82517 .16805 L
.82617 .16805 L
.82717 .16805 L
.82817 .16805 L
.82917 .16805 L
.83017 .16805 L
.83117 .16805 L
.83217 .16805 L
.83317 .16805 L
.83417 .16805 L
.83516 .16805 L
.83616 .16805 L
.83716 .16805 L
.83816 .16805 L
.83916 .16805 L
.84016 .16805 L
.84116 .16805 L
.84216 .16805 L
.84316 .16805 L
.84416 .16805 L
.84515 .16805 L
.84615 .16805 L
.84715 .16805 L
.84815 .16805 L
Mistroke
.84915 .17009 L
.85015 .17009 L
.85115 .17009 L
.85215 .17009 L
.85315 .17009 L
.85415 .17009 L
.85514 .17009 L
.85614 .17009 L
.85714 .17009 L
.85814 .17009 L
.85914 .17009 L
.86014 .17009 L
.86114 .17009 L
.86214 .17009 L
.86314 .17009 L
.86414 .17009 L
.86513 .17009 L
.86613 .17009 L
.86713 .17009 L
.86813 .17009 L
.86913 .17009 L
.87013 .17009 L
.87113 .17009 L
.87213 .17009 L
.87313 .17009 L
.87413 .17009 L
.87512 .17009 L
.87612 .17009 L
.87712 .17009 L
.87812 .17009 L
.87912 .17009 L
.88012 .17009 L
.88112 .17009 L
.88212 .17009 L
.88312 .17009 L
.88412 .17009 L
.88511 .17009 L
.88611 .17009 L
.88711 .17009 L
.88811 .17009 L
.88911 .17009 L
.89011 .17009 L
.89111 .17009 L
.89211 .17009 L
.89311 .17009 L
.89411 .17009 L
.8951 .17009 L
.8961 .17009 L
.8971 .17009 L
.8981 .17009 L
Mistroke
.8991 .16059 L
.9001 .16059 L
.9011 .16059 L
.9021 .16059 L
.9031 .16059 L
.9041 .16059 L
.90509 .16059 L
.90609 .16059 L
.90709 .16059 L
.90809 .16059 L
.90909 .16059 L
.91009 .16059 L
.91109 .16059 L
.91209 .16059 L
.91309 .16059 L
.91409 .16059 L
.91508 .16059 L
.91608 .16059 L
.91708 .16059 L
.91808 .16059 L
.91908 .16059 L
.92008 .16059 L
.92108 .16059 L
.92208 .16059 L
.92308 .16059 L
.92408 .16059 L
.92507 .16059 L
.92607 .16059 L
.92707 .16059 L
.92807 .16059 L
.92907 .16059 L
.93007 .16059 L
.93107 .16059 L
.93207 .16059 L
.93307 .16059 L
.93407 .16059 L
.93506 .16059 L
.93606 .16059 L
.93706 .16059 L
.93806 .16059 L
.93906 .16059 L
.94006 .16059 L
.94106 .16059 L
.94206 .16059 L
.94306 .16059 L
.94406 .16059 L
.94505 .16059 L
.94605 .16059 L
.94705 .16059 L
.94805 .16059 L
Mistroke
.94905 .1598 L
.95005 .1598 L
.95105 .1598 L
.95205 .1598 L
.95305 .1598 L
.95405 .1598 L
.95504 .1598 L
.95604 .1598 L
.95704 .1598 L
.95804 .1598 L
.95904 .1598 L
.96004 .1598 L
.96104 .1598 L
.96204 .1598 L
.96304 .1598 L
.96404 .1598 L
.96503 .1598 L
.96603 .1598 L
.96703 .1598 L
.96803 .1598 L
.96903 .1598 L
.97003 .1598 L
.97103 .1598 L
.97203 .1598 L
.97303 .1598 L
.97403 .1598 L
.97502 .1598 L
.97602 .1598 L
.97702 .1598 L
.97802 .1598 L
.97902 .1598 L
.98002 .1598 L
.98102 .1598 L
.98202 .1598 L
.98302 .1598 L
.98402 .1598 L
.98501 .1598 L
.98601 .1598 L
.98701 .1598 L
.98801 .1598 L
.98901 .1598 L
.99001 .1598 L
.99101 .1598 L
.99201 .1598 L
.99301 .1598 L
.99401 .1598 L
.995 .1598 L
.996 .1598 L
.997 .1598 L
.998 .1598 L
Mistroke
.999 .15648 L
Mfstroke
gsave
.999 .25687 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36835 m
.001 .36835 L
.002 .36835 L
.003 .36835 L
.004 .36835 L
.005 .36835 L
.00599 .36835 L
.00699 .36835 L
.00799 .36835 L
.00899 .36835 L
.00999 .36835 L
.01099 .36835 L
.01199 .36835 L
.01299 .36835 L
.01399 .36835 L
.01499 .36835 L
.01598 .36835 L
.01698 .36835 L
.01798 .36835 L
.01898 .36835 L
.01998 .36835 L
.02098 .36835 L
.02198 .36835 L
.02298 .36835 L
.02398 .36835 L
.02498 .36835 L
.02597 .36835 L
.02697 .36835 L
.02797 .36835 L
.02897 .36835 L
.02997 .36835 L
.03097 .36835 L
.03197 .36835 L
.03297 .36835 L
.03397 .36835 L
.03497 .36835 L
.03596 .36835 L
.03696 .36835 L
.03796 .36835 L
.03896 .36835 L
.03996 .36835 L
.04096 .36835 L
.04196 .36835 L
.04296 .36835 L
.04396 .36835 L
.04496 .36835 L
.04595 .36835 L
.04695 .36835 L
.04795 .36835 L
.04895 .36835 L
Mistroke
.04995 .37053 L
.05095 .37053 L
.05195 .37053 L
.05295 .37053 L
.05395 .37053 L
.05495 .37053 L
.05594 .37053 L
.05694 .37053 L
.05794 .37053 L
.05894 .37053 L
.05994 .37053 L
.06094 .37053 L
.06194 .37053 L
.06294 .37053 L
.06394 .37053 L
.06494 .37053 L
.06593 .37053 L
.06693 .37053 L
.06793 .37053 L
.06893 .37053 L
.06993 .37053 L
.07093 .37053 L
.07193 .37053 L
.07293 .37053 L
.07393 .37053 L
.07493 .37053 L
.07592 .37053 L
.07692 .37053 L
.07792 .37053 L
.07892 .37053 L
.07992 .37053 L
.08092 .37053 L
.08192 .37053 L
.08292 .37053 L
.08392 .37053 L
.08492 .37053 L
.08591 .37053 L
.08691 .37053 L
.08791 .37053 L
.08891 .37053 L
.08991 .37053 L
.09091 .37053 L
.09191 .37053 L
.09291 .37053 L
.09391 .37053 L
.09491 .37053 L
.0959 .37053 L
.0969 .37053 L
.0979 .37053 L
.0989 .37053 L
Mistroke
.0999 .32464 L
.1009 .32464 L
.1019 .32464 L
.1029 .32464 L
.1039 .32464 L
.1049 .32464 L
.10589 .32464 L
.10689 .32464 L
.10789 .32464 L
.10889 .32464 L
.10989 .32464 L
.11089 .32464 L
.11189 .32464 L
.11289 .32464 L
.11389 .32464 L
.11489 .32464 L
.11588 .32464 L
.11688 .32464 L
.11788 .32464 L
.11888 .32464 L
.11988 .32464 L
.12088 .32464 L
.12188 .32464 L
.12288 .32464 L
.12388 .32464 L
.12488 .32464 L
.12587 .32464 L
.12687 .32464 L
.12787 .32464 L
.12887 .32464 L
.12987 .32464 L
.13087 .32464 L
.13187 .32464 L
.13287 .32464 L
.13387 .32464 L
.13487 .32464 L
.13586 .32464 L
.13686 .32464 L
.13786 .32464 L
.13886 .32464 L
.13986 .32464 L
.14086 .32464 L
.14186 .32464 L
.14286 .32464 L
.14386 .32464 L
.14486 .32464 L
.14585 .32464 L
.14685 .32464 L
.14785 .32464 L
.14885 .32464 L
Mistroke
.14985 .26268 L
.15085 .26268 L
.15185 .26268 L
.15285 .26268 L
.15385 .26268 L
.15485 .26268 L
.15584 .26268 L
.15684 .26268 L
.15784 .26268 L
.15884 .26268 L
.15984 .26268 L
.16084 .26268 L
.16184 .26268 L
.16284 .26268 L
.16384 .26268 L
.16484 .26268 L
.16583 .26268 L
.16683 .26268 L
.16783 .26268 L
.16883 .26268 L
.16983 .26268 L
.17083 .26268 L
.17183 .26268 L
.17283 .26268 L
.17383 .26268 L
.17483 .26268 L
.17582 .26268 L
.17682 .26268 L
.17782 .26268 L
.17882 .26268 L
.17982 .26268 L
.18082 .26268 L
.18182 .26268 L
.18282 .26268 L
.18382 .26268 L
.18482 .26268 L
.18581 .26268 L
.18681 .26268 L
.18781 .26268 L
.18881 .26268 L
.18981 .26268 L
.19081 .26268 L
.19181 .26268 L
.19281 .26268 L
.19381 .26268 L
.19481 .26268 L
.1958 .26268 L
.1968 .26268 L
.1978 .26268 L
.1988 .26268 L
Mistroke
.1998 .27593 L
.2008 .27593 L
.2018 .27593 L
.2028 .27593 L
.2038 .27593 L
.2048 .27593 L
.20579 .27593 L
.20679 .27593 L
.20779 .27593 L
.20879 .27593 L
.20979 .27593 L
.21079 .27593 L
.21179 .27593 L
.21279 .27593 L
.21379 .27593 L
.21479 .27593 L
.21578 .27593 L
.21678 .27593 L
.21778 .27593 L
.21878 .27593 L
.21978 .27593 L
.22078 .27593 L
.22178 .27593 L
.22278 .27593 L
.22378 .27593 L
.22478 .27593 L
.22577 .27593 L
.22677 .27593 L
.22777 .27593 L
.22877 .27593 L
.22977 .27593 L
.23077 .27593 L
.23177 .27593 L
.23277 .27593 L
.23377 .27593 L
.23477 .27593 L
.23576 .27593 L
.23676 .27593 L
.23776 .27593 L
.23876 .27593 L
.23976 .27593 L
.24076 .27593 L
.24176 .27593 L
.24276 .27593 L
.24376 .27593 L
.24476 .27593 L
.24575 .27593 L
.24675 .27593 L
.24775 .27593 L
.24875 .27593 L
Mistroke
.24975 .30148 L
.25075 .30148 L
.25175 .30148 L
.25275 .30148 L
.25375 .30148 L
.25475 .30148 L
.25574 .30148 L
.25674 .30148 L
.25774 .30148 L
.25874 .30148 L
.25974 .30148 L
.26074 .30148 L
.26174 .30148 L
.26274 .30148 L
.26374 .30148 L
.26474 .30148 L
.26573 .30148 L
.26673 .30148 L
.26773 .30148 L
.26873 .30148 L
.26973 .30148 L
.27073 .30148 L
.27173 .30148 L
.27273 .30148 L
.27373 .30148 L
.27473 .30148 L
.27572 .30148 L
.27672 .30148 L
.27772 .30148 L
.27872 .30148 L
.27972 .30148 L
.28072 .30148 L
.28172 .30148 L
.28272 .30148 L
.28372 .30148 L
.28472 .30148 L
.28571 .30148 L
.28671 .30148 L
.28771 .30148 L
.28871 .30148 L
.28971 .30148 L
.29071 .30148 L
.29171 .30148 L
.29271 .30148 L
.29371 .30148 L
.29471 .30148 L
.2957 .30148 L
.2967 .30148 L
.2977 .30148 L
.2987 .30148 L
Mistroke
.2997 .29987 L
.3007 .29987 L
.3017 .29987 L
.3027 .29987 L
.3037 .29987 L
.3047 .29987 L
.30569 .29987 L
.30669 .29987 L
.30769 .29987 L
.30869 .29987 L
.30969 .29987 L
.31069 .29987 L
.31169 .29987 L
.31269 .29987 L
.31369 .29987 L
.31469 .29987 L
.31568 .29987 L
.31668 .29987 L
.31768 .29987 L
.31868 .29987 L
.31968 .29987 L
.32068 .29987 L
.32168 .29987 L
.32268 .29987 L
.32368 .29987 L
.32468 .29987 L
.32567 .29987 L
.32667 .29987 L
.32767 .29987 L
.32867 .29987 L
.32967 .29987 L
.33067 .29987 L
.33167 .29987 L
.33267 .29987 L
.33367 .29987 L
.33467 .29987 L
.33566 .29987 L
.33666 .29987 L
.33766 .29987 L
.33866 .29987 L
.33966 .29987 L
.34066 .29987 L
.34166 .29987 L
.34266 .29987 L
.34366 .29987 L
.34466 .29987 L
.34565 .29987 L
.34665 .29987 L
.34765 .29987 L
.34865 .29987 L
Mistroke
.34965 .27789 L
.35065 .27789 L
.35165 .27789 L
.35265 .27789 L
.35365 .27789 L
.35465 .27789 L
.35564 .27789 L
.35664 .27789 L
.35764 .27789 L
.35864 .27789 L
.35964 .27789 L
.36064 .27789 L
.36164 .27789 L
.36264 .27789 L
.36364 .27789 L
.36464 .27789 L
.36563 .27789 L
.36663 .27789 L
.36763 .27789 L
.36863 .27789 L
.36963 .27789 L
.37063 .27789 L
.37163 .27789 L
.37263 .27789 L
.37363 .27789 L
.37463 .27789 L
.37562 .27789 L
.37662 .27789 L
.37762 .27789 L
.37862 .27789 L
.37962 .27789 L
.38062 .27789 L
.38162 .27789 L
.38262 .27789 L
.38362 .27789 L
.38462 .27789 L
.38561 .27789 L
.38661 .27789 L
.38761 .27789 L
.38861 .27789 L
.38961 .27789 L
.39061 .27789 L
.39161 .27789 L
.39261 .27789 L
.39361 .27789 L
.39461 .27789 L
.3956 .27789 L
.3966 .27789 L
.3976 .27789 L
.3986 .27789 L
Mistroke
.3996 .26398 L
.4006 .26398 L
.4016 .26398 L
.4026 .26398 L
.4036 .26398 L
.4046 .26398 L
.40559 .26398 L
.40659 .26398 L
.40759 .26398 L
.40859 .26398 L
.40959 .26398 L
.41059 .26398 L
.41159 .26398 L
.41259 .26398 L
.41359 .26398 L
.41459 .26398 L
.41558 .26398 L
.41658 .26398 L
.41758 .26398 L
.41858 .26398 L
.41958 .26398 L
.42058 .26398 L
.42158 .26398 L
.42258 .26398 L
.42358 .26398 L
.42458 .26398 L
.42557 .26398 L
.42657 .26398 L
.42757 .26398 L
.42857 .26398 L
.42957 .26398 L
.43057 .26398 L
.43157 .26398 L
.43257 .26398 L
.43357 .26398 L
.43457 .26398 L
.43556 .26398 L
.43656 .26398 L
.43756 .26398 L
.43856 .26398 L
.43956 .26398 L
.44056 .26398 L
.44156 .26398 L
.44256 .26398 L
.44356 .26398 L
.44456 .26398 L
.44555 .26398 L
.44655 .26398 L
.44755 .26398 L
.44855 .26398 L
Mistroke
.44955 .26724 L
.45055 .26724 L
.45155 .26724 L
.45255 .26724 L
.45355 .26724 L
.45455 .26724 L
.45554 .26724 L
.45654 .26724 L
.45754 .26724 L
.45854 .26724 L
.45954 .26724 L
.46054 .26724 L
.46154 .26724 L
.46254 .26724 L
.46354 .26724 L
.46454 .26724 L
.46553 .26724 L
.46653 .26724 L
.46753 .26724 L
.46853 .26724 L
.46953 .26724 L
.47053 .26724 L
.47153 .26724 L
.47253 .26724 L
.47353 .26724 L
.47453 .26724 L
.47552 .26724 L
.47652 .26724 L
.47752 .26724 L
.47852 .26724 L
.47952 .26724 L
.48052 .26724 L
.48152 .26724 L
.48252 .26724 L
.48352 .26724 L
.48452 .26724 L
.48551 .26724 L
.48651 .26724 L
.48751 .26724 L
.48851 .26724 L
.48951 .26724 L
.49051 .26724 L
.49151 .26724 L
.49251 .26724 L
.49351 .26724 L
.49451 .26724 L
.4955 .26724 L
.4965 .26724 L
.4975 .26724 L
.4985 .26724 L
Mistroke
.4995 .26983 L
.5005 .26983 L
.5015 .26983 L
.5025 .26983 L
.5035 .26983 L
.5045 .26983 L
.50549 .26983 L
.50649 .26983 L
.50749 .26983 L
.50849 .26983 L
.50949 .26983 L
.51049 .26983 L
.51149 .26983 L
.51249 .26983 L
.51349 .26983 L
.51449 .26983 L
.51548 .26983 L
.51648 .26983 L
.51748 .26983 L
.51848 .26983 L
.51948 .26983 L
.52048 .26983 L
.52148 .26983 L
.52248 .26983 L
.52348 .26983 L
.52448 .26983 L
.52547 .26983 L
.52647 .26983 L
.52747 .26983 L
.52847 .26983 L
.52947 .26983 L
.53047 .26983 L
.53147 .26983 L
.53247 .26983 L
.53347 .26983 L
.53447 .26983 L
.53546 .26983 L
.53646 .26983 L
.53746 .26983 L
.53846 .26983 L
.53946 .26983 L
.54046 .26983 L
.54146 .26983 L
.54246 .26983 L
.54346 .26983 L
.54446 .26983 L
.54545 .26983 L
.54645 .26983 L
.54745 .26983 L
.54845 .26983 L
Mistroke
.54945 .27299 L
.55045 .27299 L
.55145 .27299 L
.55245 .27299 L
.55345 .27299 L
.55445 .27299 L
.55544 .27299 L
.55644 .27299 L
.55744 .27299 L
.55844 .27299 L
.55944 .27299 L
.56044 .27299 L
.56144 .27299 L
.56244 .27299 L
.56344 .27299 L
.56444 .27299 L
.56543 .27299 L
.56643 .27299 L
.56743 .27299 L
.56843 .27299 L
.56943 .27299 L
.57043 .27299 L
.57143 .27299 L
.57243 .27299 L
.57343 .27299 L
.57443 .27299 L
.57542 .27299 L
.57642 .27299 L
.57742 .27299 L
.57842 .27299 L
.57942 .27299 L
.58042 .27299 L
.58142 .27299 L
.58242 .27299 L
.58342 .27299 L
.58442 .27299 L
.58541 .27299 L
.58641 .27299 L
.58741 .27299 L
.58841 .27299 L
.58941 .27299 L
.59041 .27299 L
.59141 .27299 L
.59241 .27299 L
.59341 .27299 L
.59441 .27299 L
.5954 .27299 L
.5964 .27299 L
.5974 .27299 L
.5984 .27299 L
Mistroke
.5994 .27255 L
.6004 .27255 L
.6014 .27255 L
.6024 .27255 L
.6034 .27255 L
.6044 .27255 L
.60539 .27255 L
.60639 .27255 L
.60739 .27255 L
.60839 .27255 L
.60939 .27255 L
.61039 .27255 L
.61139 .27255 L
.61239 .27255 L
.61339 .27255 L
.61439 .27255 L
.61538 .27255 L
.61638 .27255 L
.61738 .27255 L
.61838 .27255 L
.61938 .27255 L
.62038 .27255 L
.62138 .27255 L
.62238 .27255 L
.62338 .27255 L
.62438 .27255 L
.62537 .27255 L
.62637 .27255 L
.62737 .27255 L
.62837 .27255 L
.62937 .27255 L
.63037 .27255 L
.63137 .27255 L
.63237 .27255 L
.63337 .27255 L
.63437 .27255 L
.63536 .27255 L
.63636 .27255 L
.63736 .27255 L
.63836 .27255 L
.63936 .27255 L
.64036 .27255 L
.64136 .27255 L
.64236 .27255 L
.64336 .27255 L
.64436 .27255 L
.64535 .27255 L
.64635 .27255 L
.64735 .27255 L
.64835 .27255 L
Mistroke
.64935 .26432 L
.65035 .26432 L
.65135 .26432 L
.65235 .26432 L
.65335 .26432 L
.65435 .26432 L
.65534 .26432 L
.65634 .26432 L
.65734 .26432 L
.65834 .26432 L
.65934 .26432 L
.66034 .26432 L
.66134 .26432 L
.66234 .26432 L
.66334 .26432 L
.66434 .26432 L
.66533 .26432 L
.66633 .26432 L
.66733 .26432 L
.66833 .26432 L
.66933 .26432 L
.67033 .26432 L
.67133 .26432 L
.67233 .26432 L
.67333 .26432 L
.67433 .26432 L
.67532 .26432 L
.67632 .26432 L
.67732 .26432 L
.67832 .26432 L
.67932 .26432 L
.68032 .26432 L
.68132 .26432 L
.68232 .26432 L
.68332 .26432 L
.68432 .26432 L
.68531 .26432 L
.68631 .26432 L
.68731 .26432 L
.68831 .26432 L
.68931 .26432 L
.69031 .26432 L
.69131 .26432 L
.69231 .26432 L
.69331 .26432 L
.69431 .26432 L
.6953 .26432 L
.6963 .26432 L
.6973 .26432 L
.6983 .26432 L
Mistroke
.6993 .26591 L
.7003 .26591 L
.7013 .26591 L
.7023 .26591 L
.7033 .26591 L
.7043 .26591 L
.70529 .26591 L
.70629 .26591 L
.70729 .26591 L
.70829 .26591 L
.70929 .26591 L
.71029 .26591 L
.71129 .26591 L
.71229 .26591 L
.71329 .26591 L
.71429 .26591 L
.71528 .26591 L
.71628 .26591 L
.71728 .26591 L
.71828 .26591 L
.71928 .26591 L
.72028 .26591 L
.72128 .26591 L
.72228 .26591 L
.72328 .26591 L
.72428 .26591 L
.72527 .26591 L
.72627 .26591 L
.72727 .26591 L
.72827 .26591 L
.72927 .26591 L
.73027 .26591 L
.73127 .26591 L
.73227 .26591 L
.73327 .26591 L
.73427 .26591 L
.73526 .26591 L
.73626 .26591 L
.73726 .26591 L
.73826 .26591 L
.73926 .26591 L
.74026 .26591 L
.74126 .26591 L
.74226 .26591 L
.74326 .26591 L
.74426 .26591 L
.74525 .26591 L
.74625 .26591 L
.74725 .26591 L
.74825 .26591 L
Mistroke
.74925 .2698 L
.75025 .2698 L
.75125 .2698 L
.75225 .2698 L
.75325 .2698 L
.75425 .2698 L
.75524 .2698 L
.75624 .2698 L
.75724 .2698 L
.75824 .2698 L
.75924 .2698 L
.76024 .2698 L
.76124 .2698 L
.76224 .2698 L
.76324 .2698 L
.76424 .2698 L
.76523 .2698 L
.76623 .2698 L
.76723 .2698 L
.76823 .2698 L
.76923 .2698 L
.77023 .2698 L
.77123 .2698 L
.77223 .2698 L
.77323 .2698 L
.77423 .2698 L
.77522 .2698 L
.77622 .2698 L
.77722 .2698 L
.77822 .2698 L
.77922 .2698 L
.78022 .2698 L
.78122 .2698 L
.78222 .2698 L
.78322 .2698 L
.78422 .2698 L
.78521 .2698 L
.78621 .2698 L
.78721 .2698 L
.78821 .2698 L
.78921 .2698 L
.79021 .2698 L
.79121 .2698 L
.79221 .2698 L
.79321 .2698 L
.79421 .2698 L
.7952 .2698 L
.7962 .2698 L
.7972 .2698 L
.7982 .2698 L
Mistroke
.7992 .2768 L
.8002 .2768 L
.8012 .2768 L
.8022 .2768 L
.8032 .2768 L
.8042 .2768 L
.80519 .2768 L
.80619 .2768 L
.80719 .2768 L
.80819 .2768 L
.80919 .2768 L
.81019 .2768 L
.81119 .2768 L
.81219 .2768 L
.81319 .2768 L
.81419 .2768 L
.81518 .2768 L
.81618 .2768 L
.81718 .2768 L
.81818 .2768 L
.81918 .2768 L
.82018 .2768 L
.82118 .2768 L
.82218 .2768 L
.82318 .2768 L
.82418 .2768 L
.82517 .2768 L
.82617 .2768 L
.82717 .2768 L
.82817 .2768 L
.82917 .2768 L
.83017 .2768 L
.83117 .2768 L
.83217 .2768 L
.83317 .2768 L
.83417 .2768 L
.83516 .2768 L
.83616 .2768 L
.83716 .2768 L
.83816 .2768 L
.83916 .2768 L
.84016 .2768 L
.84116 .2768 L
.84216 .2768 L
.84316 .2768 L
.84416 .2768 L
.84515 .2768 L
.84615 .2768 L
.84715 .2768 L
.84815 .2768 L
Mistroke
.84915 .27681 L
.85015 .27681 L
.85115 .27681 L
.85215 .27681 L
.85315 .27681 L
.85415 .27681 L
.85514 .27681 L
.85614 .27681 L
.85714 .27681 L
.85814 .27681 L
.85914 .27681 L
.86014 .27681 L
.86114 .27681 L
.86214 .27681 L
.86314 .27681 L
.86414 .27681 L
.86513 .27681 L
.86613 .27681 L
.86713 .27681 L
.86813 .27681 L
.86913 .27681 L
.87013 .27681 L
.87113 .27681 L
.87213 .27681 L
.87313 .27681 L
.87413 .27681 L
.87512 .27681 L
.87612 .27681 L
.87712 .27681 L
.87812 .27681 L
.87912 .27681 L
.88012 .27681 L
.88112 .27681 L
.88212 .27681 L
.88312 .27681 L
.88412 .27681 L
.88511 .27681 L
.88611 .27681 L
.88711 .27681 L
.88811 .27681 L
.88911 .27681 L
.89011 .27681 L
.89111 .27681 L
.89211 .27681 L
.89311 .27681 L
.89411 .27681 L
.8951 .27681 L
.8961 .27681 L
.8971 .27681 L
.8981 .27681 L
Mistroke
.8991 .26457 L
.9001 .26457 L
.9011 .26457 L
.9021 .26457 L
.9031 .26457 L
.9041 .26457 L
.90509 .26457 L
.90609 .26457 L
.90709 .26457 L
.90809 .26457 L
.90909 .26457 L
.91009 .26457 L
.91109 .26457 L
.91209 .26457 L
.91309 .26457 L
.91409 .26457 L
.91508 .26457 L
.91608 .26457 L
.91708 .26457 L
.91808 .26457 L
.91908 .26457 L
.92008 .26457 L
.92108 .26457 L
.92208 .26457 L
.92308 .26457 L
.92408 .26457 L
.92507 .26457 L
.92607 .26457 L
.92707 .26457 L
.92807 .26457 L
.92907 .26457 L
.93007 .26457 L
.93107 .26457 L
.93207 .26457 L
.93307 .26457 L
.93407 .26457 L
.93506 .26457 L
.93606 .26457 L
.93706 .26457 L
.93806 .26457 L
.93906 .26457 L
.94006 .26457 L
.94106 .26457 L
.94206 .26457 L
.94306 .26457 L
.94406 .26457 L
.94505 .26457 L
.94605 .26457 L
.94705 .26457 L
.94805 .26457 L
Mistroke
.94905 .26215 L
.95005 .26215 L
.95105 .26215 L
.95205 .26215 L
.95305 .26215 L
.95405 .26215 L
.95504 .26215 L
.95604 .26215 L
.95704 .26215 L
.95804 .26215 L
.95904 .26215 L
.96004 .26215 L
.96104 .26215 L
.96204 .26215 L
.96304 .26215 L
.96404 .26215 L
.96503 .26215 L
.96603 .26215 L
.96703 .26215 L
.96803 .26215 L
.96903 .26215 L
.97003 .26215 L
.97103 .26215 L
.97203 .26215 L
.97303 .26215 L
.97403 .26215 L
.97502 .26215 L
.97602 .26215 L
.97702 .26215 L
.97802 .26215 L
.97902 .26215 L
.98002 .26215 L
.98102 .26215 L
.98202 .26215 L
.98302 .26215 L
.98402 .26215 L
.98501 .26215 L
.98601 .26215 L
.98701 .26215 L
.98801 .26215 L
.98901 .26215 L
.99001 .26215 L
.99101 .26215 L
.99201 .26215 L
.99301 .26215 L
.99401 .26215 L
.995 .26215 L
.996 .26215 L
.997 .26215 L
.998 .26215 L
Mistroke
.999 .25687 L
Mfstroke
1 0 0 r
gsave
.999 .20667 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24721 m
.001 .24721 L
.002 .24721 L
.003 .24721 L
.004 .24721 L
.005 .24721 L
.00599 .24721 L
.00699 .24721 L
.00799 .24721 L
.00899 .24721 L
.00999 .24721 L
.01099 .24721 L
.01199 .24721 L
.01299 .24721 L
.01399 .24721 L
.01499 .24721 L
.01598 .24721 L
.01698 .24721 L
.01798 .24721 L
.01898 .24721 L
.01998 .24721 L
.02098 .24721 L
.02198 .24721 L
.02298 .24721 L
.02398 .24721 L
.02498 .24721 L
.02597 .24721 L
.02697 .24721 L
.02797 .24721 L
.02897 .24721 L
.02997 .24721 L
.03097 .24721 L
.03197 .24721 L
.03297 .24721 L
.03397 .24721 L
.03497 .24721 L
.03596 .24721 L
.03696 .24721 L
.03796 .24721 L
.03896 .24721 L
.03996 .24721 L
.04096 .24721 L
.04196 .24721 L
.04296 .24721 L
.04396 .24721 L
.04496 .24721 L
.04595 .24721 L
.04695 .24721 L
.04795 .24721 L
.04895 .24721 L
Mistroke
.04995 .24955 L
.05095 .24955 L
.05195 .24955 L
.05295 .24955 L
.05395 .24955 L
.05495 .24955 L
.05594 .24955 L
.05694 .24955 L
.05794 .24955 L
.05894 .24955 L
.05994 .24955 L
.06094 .24955 L
.06194 .24955 L
.06294 .24955 L
.06394 .24955 L
.06494 .24955 L
.06593 .24955 L
.06693 .24955 L
.06793 .24955 L
.06893 .24955 L
.06993 .24955 L
.07093 .24955 L
.07193 .24955 L
.07293 .24955 L
.07393 .24955 L
.07493 .24955 L
.07592 .24955 L
.07692 .24955 L
.07792 .24955 L
.07892 .24955 L
.07992 .24955 L
.08092 .24955 L
.08192 .24955 L
.08292 .24955 L
.08392 .24955 L
.08492 .24955 L
.08591 .24955 L
.08691 .24955 L
.08791 .24955 L
.08891 .24955 L
.08991 .24955 L
.09091 .24955 L
.09191 .24955 L
.09291 .24955 L
.09391 .24955 L
.09491 .24955 L
.0959 .24955 L
.0969 .24955 L
.0979 .24955 L
.0989 .24955 L
Mistroke
.0999 .21238 L
.1009 .21238 L
.1019 .21238 L
.1029 .21238 L
.1039 .21238 L
.1049 .21238 L
.10589 .21238 L
.10689 .21238 L
.10789 .21238 L
.10889 .21238 L
.10989 .21238 L
.11089 .21238 L
.11189 .21238 L
.11289 .21238 L
.11389 .21238 L
.11489 .21238 L
.11588 .21238 L
.11688 .21238 L
.11788 .21238 L
.11888 .21238 L
.11988 .21238 L
.12088 .21238 L
.12188 .21238 L
.12288 .21238 L
.12388 .21238 L
.12488 .21238 L
.12587 .21238 L
.12687 .21238 L
.12787 .21238 L
.12887 .21238 L
.12987 .21238 L
.13087 .21238 L
.13187 .21238 L
.13287 .21238 L
.13387 .21238 L
.13487 .21238 L
.13586 .21238 L
.13686 .21238 L
.13786 .21238 L
.13886 .21238 L
.13986 .21238 L
.14086 .21238 L
.14186 .21238 L
.14286 .21238 L
.14386 .21238 L
.14486 .21238 L
.14585 .21238 L
.14685 .21238 L
.14785 .21238 L
.14885 .21238 L
Mistroke
.14985 .16413 L
.15085 .16413 L
.15185 .16413 L
.15285 .16413 L
.15385 .16413 L
.15485 .16413 L
.15584 .16413 L
.15684 .16413 L
.15784 .16413 L
.15884 .16413 L
.15984 .16413 L
.16084 .16413 L
.16184 .16413 L
.16284 .16413 L
.16384 .16413 L
.16484 .16413 L
.16583 .16413 L
.16683 .16413 L
.16783 .16413 L
.16883 .16413 L
.16983 .16413 L
.17083 .16413 L
.17183 .16413 L
.17283 .16413 L
.17383 .16413 L
.17483 .16413 L
.17582 .16413 L
.17682 .16413 L
.17782 .16413 L
.17882 .16413 L
.17982 .16413 L
.18082 .16413 L
.18182 .16413 L
.18282 .16413 L
.18382 .16413 L
.18482 .16413 L
.18581 .16413 L
.18681 .16413 L
.18781 .16413 L
.18881 .16413 L
.18981 .16413 L
.19081 .16413 L
.19181 .16413 L
.19281 .16413 L
.19381 .16413 L
.19481 .16413 L
.1958 .16413 L
.1968 .16413 L
.1978 .16413 L
.1988 .16413 L
Mistroke
.1998 .18171 L
.2008 .18171 L
.2018 .18171 L
.2028 .18171 L
.2038 .18171 L
.2048 .18171 L
.20579 .18171 L
.20679 .18171 L
.20779 .18171 L
.20879 .18171 L
.20979 .18171 L
.21079 .18171 L
.21179 .18171 L
.21279 .18171 L
.21379 .18171 L
.21479 .18171 L
.21578 .18171 L
.21678 .18171 L
.21778 .18171 L
.21878 .18171 L
.21978 .18171 L
.22078 .18171 L
.22178 .18171 L
.22278 .18171 L
.22378 .18171 L
.22478 .18171 L
.22577 .18171 L
.22677 .18171 L
.22777 .18171 L
.22877 .18171 L
.22977 .18171 L
.23077 .18171 L
.23177 .18171 L
.23277 .18171 L
.23377 .18171 L
.23477 .18171 L
.23576 .18171 L
.23676 .18171 L
.23776 .18171 L
.23876 .18171 L
.23976 .18171 L
.24076 .18171 L
.24176 .18171 L
.24276 .18171 L
.24376 .18171 L
.24476 .18171 L
.24575 .18171 L
.24675 .18171 L
.24775 .18171 L
.24875 .18171 L
Mistroke
.24975 .21471 L
.25075 .21471 L
.25175 .21471 L
.25275 .21471 L
.25375 .21471 L
.25475 .21471 L
.25574 .21471 L
.25674 .21471 L
.25774 .21471 L
.25874 .21471 L
.25974 .21471 L
.26074 .21471 L
.26174 .21471 L
.26274 .21471 L
.26374 .21471 L
.26474 .21471 L
.26573 .21471 L
.26673 .21471 L
.26773 .21471 L
.26873 .21471 L
.26973 .21471 L
.27073 .21471 L
.27173 .21471 L
.27273 .21471 L
.27373 .21471 L
.27473 .21471 L
.27572 .21471 L
.27672 .21471 L
.27772 .21471 L
.27872 .21471 L
.27972 .21471 L
.28072 .21471 L
.28172 .21471 L
.28272 .21471 L
.28372 .21471 L
.28472 .21471 L
.28571 .21471 L
.28671 .21471 L
.28771 .21471 L
.28871 .21471 L
.28971 .21471 L
.29071 .21471 L
.29171 .21471 L
.29271 .21471 L
.29371 .21471 L
.29471 .21471 L
.2957 .21471 L
.2967 .21471 L
.2977 .21471 L
.2987 .21471 L
Mistroke
.2997 .21651 L
.3007 .21651 L
.3017 .21651 L
.3027 .21651 L
.3037 .21651 L
.3047 .21651 L
.30569 .21651 L
.30669 .21651 L
.30769 .21651 L
.30869 .21651 L
.30969 .21651 L
.31069 .21651 L
.31169 .21651 L
.31269 .21651 L
.31369 .21651 L
.31469 .21651 L
.31568 .21651 L
.31668 .21651 L
.31768 .21651 L
.31868 .21651 L
.31968 .21651 L
.32068 .21651 L
.32168 .21651 L
.32268 .21651 L
.32368 .21651 L
.32468 .21651 L
.32567 .21651 L
.32667 .21651 L
.32767 .21651 L
.32867 .21651 L
.32967 .21651 L
.33067 .21651 L
.33167 .21651 L
.33267 .21651 L
.33367 .21651 L
.33467 .21651 L
.33566 .21651 L
.33666 .21651 L
.33766 .21651 L
.33866 .21651 L
.33966 .21651 L
.34066 .21651 L
.34166 .21651 L
.34266 .21651 L
.34366 .21651 L
.34466 .21651 L
.34565 .21651 L
.34665 .21651 L
.34765 .21651 L
.34865 .21651 L
Mistroke
.34965 .20041 L
.35065 .20041 L
.35165 .20041 L
.35265 .20041 L
.35365 .20041 L
.35465 .20041 L
.35564 .20041 L
.35664 .20041 L
.35764 .20041 L
.35864 .20041 L
.35964 .20041 L
.36064 .20041 L
.36164 .20041 L
.36264 .20041 L
.36364 .20041 L
.36464 .20041 L
.36563 .20041 L
.36663 .20041 L
.36763 .20041 L
.36863 .20041 L
.36963 .20041 L
.37063 .20041 L
.37163 .20041 L
.37263 .20041 L
.37363 .20041 L
.37463 .20041 L
.37562 .20041 L
.37662 .20041 L
.37762 .20041 L
.37862 .20041 L
.37962 .20041 L
.38062 .20041 L
.38162 .20041 L
.38262 .20041 L
.38362 .20041 L
.38462 .20041 L
.38561 .20041 L
.38661 .20041 L
.38761 .20041 L
.38861 .20041 L
.38961 .20041 L
.39061 .20041 L
.39161 .20041 L
.39261 .20041 L
.39361 .20041 L
.39461 .20041 L
.3956 .20041 L
.3966 .20041 L
.3976 .20041 L
.3986 .20041 L
Mistroke
.3996 .19188 L
.4006 .19188 L
.4016 .19188 L
.4026 .19188 L
.4036 .19188 L
.4046 .19188 L
.40559 .19188 L
.40659 .19188 L
.40759 .19188 L
.40859 .19188 L
.40959 .19188 L
.41059 .19188 L
.41159 .19188 L
.41259 .19188 L
.41359 .19188 L
.41459 .19188 L
.41558 .19188 L
.41658 .19188 L
.41758 .19188 L
.41858 .19188 L
.41958 .19188 L
.42058 .19188 L
.42158 .19188 L
.42258 .19188 L
.42358 .19188 L
.42458 .19188 L
.42557 .19188 L
.42657 .19188 L
.42757 .19188 L
.42857 .19188 L
.42957 .19188 L
.43057 .19188 L
.43157 .19188 L
.43257 .19188 L
.43357 .19188 L
.43457 .19188 L
.43556 .19188 L
.43656 .19188 L
.43756 .19188 L
.43856 .19188 L
.43956 .19188 L
.44056 .19188 L
.44156 .19188 L
.44256 .19188 L
.44356 .19188 L
.44456 .19188 L
.44555 .19188 L
.44655 .19188 L
.44755 .19188 L
.44855 .19188 L
Mistroke
.44955 .19783 L
.45055 .19783 L
.45155 .19783 L
.45255 .19783 L
.45355 .19783 L
.45455 .19783 L
.45554 .19783 L
.45654 .19783 L
.45754 .19783 L
.45854 .19783 L
.45954 .19783 L
.46054 .19783 L
.46154 .19783 L
.46254 .19783 L
.46354 .19783 L
.46454 .19783 L
.46553 .19783 L
.46653 .19783 L
.46753 .19783 L
.46853 .19783 L
.46953 .19783 L
.47053 .19783 L
.47153 .19783 L
.47253 .19783 L
.47353 .19783 L
.47453 .19783 L
.47552 .19783 L
.47652 .19783 L
.47752 .19783 L
.47852 .19783 L
.47952 .19783 L
.48052 .19783 L
.48152 .19783 L
.48252 .19783 L
.48352 .19783 L
.48452 .19783 L
.48551 .19783 L
.48651 .19783 L
.48751 .19783 L
.48851 .19783 L
.48951 .19783 L
.49051 .19783 L
.49151 .19783 L
.49251 .19783 L
.49351 .19783 L
.49451 .19783 L
.4955 .19783 L
.4965 .19783 L
.4975 .19783 L
.4985 .19783 L
Mistroke
.4995 .20507 L
.5005 .20507 L
.5015 .20507 L
.5025 .20507 L
.5035 .20507 L
.5045 .20507 L
.50549 .20507 L
.50649 .20507 L
.50749 .20507 L
.50849 .20507 L
.50949 .20507 L
.51049 .20507 L
.51149 .20507 L
.51249 .20507 L
.51349 .20507 L
.51449 .20507 L
.51548 .20507 L
.51648 .20507 L
.51748 .20507 L
.51848 .20507 L
.51948 .20507 L
.52048 .20507 L
.52148 .20507 L
.52248 .20507 L
.52348 .20507 L
.52448 .20507 L
.52547 .20507 L
.52647 .20507 L
.52747 .20507 L
.52847 .20507 L
.52947 .20507 L
.53047 .20507 L
.53147 .20507 L
.53247 .20507 L
.53347 .20507 L
.53447 .20507 L
.53546 .20507 L
.53646 .20507 L
.53746 .20507 L
.53846 .20507 L
.53946 .20507 L
.54046 .20507 L
.54146 .20507 L
.54246 .20507 L
.54346 .20507 L
.54446 .20507 L
.54545 .20507 L
.54645 .20507 L
.54745 .20507 L
.54845 .20507 L
Mistroke
.54945 .21012 L
.55045 .21012 L
.55145 .21012 L
.55245 .21012 L
.55345 .21012 L
.55445 .21012 L
.55544 .21012 L
.55644 .21012 L
.55744 .21012 L
.55844 .21012 L
.55944 .21012 L
.56044 .21012 L
.56144 .21012 L
.56244 .21012 L
.56344 .21012 L
.56444 .21012 L
.56543 .21012 L
.56643 .21012 L
.56743 .21012 L
.56843 .21012 L
.56943 .21012 L
.57043 .21012 L
.57143 .21012 L
.57243 .21012 L
.57343 .21012 L
.57443 .21012 L
.57542 .21012 L
.57642 .21012 L
.57742 .21012 L
.57842 .21012 L
.57942 .21012 L
.58042 .21012 L
.58142 .21012 L
.58242 .21012 L
.58342 .21012 L
.58442 .21012 L
.58541 .21012 L
.58641 .21012 L
.58741 .21012 L
.58841 .21012 L
.58941 .21012 L
.59041 .21012 L
.59141 .21012 L
.59241 .21012 L
.59341 .21012 L
.59441 .21012 L
.5954 .21012 L
.5964 .21012 L
.5974 .21012 L
.5984 .21012 L
Mistroke
.5994 .21171 L
.6004 .21171 L
.6014 .21171 L
.6024 .21171 L
.6034 .21171 L
.6044 .21171 L
.60539 .21171 L
.60639 .21171 L
.60739 .21171 L
.60839 .21171 L
.60939 .21171 L
.61039 .21171 L
.61139 .21171 L
.61239 .21171 L
.61339 .21171 L
.61439 .21171 L
.61538 .21171 L
.61638 .21171 L
.61738 .21171 L
.61838 .21171 L
.61938 .21171 L
.62038 .21171 L
.62138 .21171 L
.62238 .21171 L
.62338 .21171 L
.62438 .21171 L
.62537 .21171 L
.62637 .21171 L
.62737 .21171 L
.62837 .21171 L
.62937 .21171 L
.63037 .21171 L
.63137 .21171 L
.63237 .21171 L
.63337 .21171 L
.63437 .21171 L
.63536 .21171 L
.63636 .21171 L
.63736 .21171 L
.63836 .21171 L
.63936 .21171 L
.64036 .21171 L
.64136 .21171 L
.64236 .21171 L
.64336 .21171 L
.64436 .21171 L
.64535 .21171 L
.64635 .21171 L
.64735 .21171 L
.64835 .21171 L
Mistroke
.64935 .20544 L
.65035 .20544 L
.65135 .20544 L
.65235 .20544 L
.65335 .20544 L
.65435 .20544 L
.65534 .20544 L
.65634 .20544 L
.65734 .20544 L
.65834 .20544 L
.65934 .20544 L
.66034 .20544 L
.66134 .20544 L
.66234 .20544 L
.66334 .20544 L
.66434 .20544 L
.66533 .20544 L
.66633 .20544 L
.66733 .20544 L
.66833 .20544 L
.66933 .20544 L
.67033 .20544 L
.67133 .20544 L
.67233 .20544 L
.67333 .20544 L
.67433 .20544 L
.67532 .20544 L
.67632 .20544 L
.67732 .20544 L
.67832 .20544 L
.67932 .20544 L
.68032 .20544 L
.68132 .20544 L
.68232 .20544 L
.68332 .20544 L
.68432 .20544 L
.68531 .20544 L
.68631 .20544 L
.68731 .20544 L
.68831 .20544 L
.68931 .20544 L
.69031 .20544 L
.69131 .20544 L
.69231 .20544 L
.69331 .20544 L
.69431 .20544 L
.6953 .20544 L
.6963 .20544 L
.6973 .20544 L
.6983 .20544 L
Mistroke
.6993 .20905 L
.7003 .20905 L
.7013 .20905 L
.7023 .20905 L
.7033 .20905 L
.7043 .20905 L
.70529 .20905 L
.70629 .20905 L
.70729 .20905 L
.70829 .20905 L
.70929 .20905 L
.71029 .20905 L
.71129 .20905 L
.71229 .20905 L
.71329 .20905 L
.71429 .20905 L
.71528 .20905 L
.71628 .20905 L
.71728 .20905 L
.71828 .20905 L
.71928 .20905 L
.72028 .20905 L
.72128 .20905 L
.72228 .20905 L
.72328 .20905 L
.72428 .20905 L
.72527 .20905 L
.72627 .20905 L
.72727 .20905 L
.72827 .20905 L
.72927 .20905 L
.73027 .20905 L
.73127 .20905 L
.73227 .20905 L
.73327 .20905 L
.73427 .20905 L
.73526 .20905 L
.73626 .20905 L
.73726 .20905 L
.73826 .20905 L
.73926 .20905 L
.74026 .20905 L
.74126 .20905 L
.74226 .20905 L
.74326 .20905 L
.74426 .20905 L
.74525 .20905 L
.74625 .20905 L
.74725 .20905 L
.74825 .20905 L
Mistroke
.74925 .21372 L
.75025 .21372 L
.75125 .21372 L
.75225 .21372 L
.75325 .21372 L
.75425 .21372 L
.75524 .21372 L
.75624 .21372 L
.75724 .21372 L
.75824 .21372 L
.75924 .21372 L
.76024 .21372 L
.76124 .21372 L
.76224 .21372 L
.76324 .21372 L
.76424 .21372 L
.76523 .21372 L
.76623 .21372 L
.76723 .21372 L
.76823 .21372 L
.76923 .21372 L
.77023 .21372 L
.77123 .21372 L
.77223 .21372 L
.77323 .21372 L
.77423 .21372 L
.77522 .21372 L
.77622 .21372 L
.77722 .21372 L
.77822 .21372 L
.77922 .21372 L
.78022 .21372 L
.78122 .21372 L
.78222 .21372 L
.78322 .21372 L
.78422 .21372 L
.78521 .21372 L
.78621 .21372 L
.78721 .21372 L
.78821 .21372 L
.78921 .21372 L
.79021 .21372 L
.79121 .21372 L
.79221 .21372 L
.79321 .21372 L
.79421 .21372 L
.7952 .21372 L
.7962 .21372 L
.7972 .21372 L
.7982 .21372 L
Mistroke
.7992 .22243 L
.8002 .22243 L
.8012 .22243 L
.8022 .22243 L
.8032 .22243 L
.8042 .22243 L
.80519 .22243 L
.80619 .22243 L
.80719 .22243 L
.80819 .22243 L
.80919 .22243 L
.81019 .22243 L
.81119 .22243 L
.81219 .22243 L
.81319 .22243 L
.81419 .22243 L
.81518 .22243 L
.81618 .22243 L
.81718 .22243 L
.81818 .22243 L
.81918 .22243 L
.82018 .22243 L
.82118 .22243 L
.82218 .22243 L
.82318 .22243 L
.82418 .22243 L
.82517 .22243 L
.82617 .22243 L
.82717 .22243 L
.82817 .22243 L
.82917 .22243 L
.83017 .22243 L
.83117 .22243 L
.83217 .22243 L
.83317 .22243 L
.83417 .22243 L
.83516 .22243 L
.83616 .22243 L
.83716 .22243 L
.83816 .22243 L
.83916 .22243 L
.84016 .22243 L
.84116 .22243 L
.84216 .22243 L
.84316 .22243 L
.84416 .22243 L
.84515 .22243 L
.84615 .22243 L
.84715 .22243 L
.84815 .22243 L
Mistroke
.84915 .22345 L
.85015 .22345 L
.85115 .22345 L
.85215 .22345 L
.85315 .22345 L
.85415 .22345 L
.85514 .22345 L
.85614 .22345 L
.85714 .22345 L
.85814 .22345 L
.85914 .22345 L
.86014 .22345 L
.86114 .22345 L
.86214 .22345 L
.86314 .22345 L
.86414 .22345 L
.86513 .22345 L
.86613 .22345 L
.86713 .22345 L
.86813 .22345 L
.86913 .22345 L
.87013 .22345 L
.87113 .22345 L
.87213 .22345 L
.87313 .22345 L
.87413 .22345 L
.87512 .22345 L
.87612 .22345 L
.87712 .22345 L
.87812 .22345 L
.87912 .22345 L
.88012 .22345 L
.88112 .22345 L
.88212 .22345 L
.88312 .22345 L
.88412 .22345 L
.88511 .22345 L
.88611 .22345 L
.88711 .22345 L
.88811 .22345 L
.88911 .22345 L
.89011 .22345 L
.89111 .22345 L
.89211 .22345 L
.89311 .22345 L
.89411 .22345 L
.8951 .22345 L
.8961 .22345 L
.8971 .22345 L
.8981 .22345 L
Mistroke
.8991 .21258 L
.9001 .21258 L
.9011 .21258 L
.9021 .21258 L
.9031 .21258 L
.9041 .21258 L
.90509 .21258 L
.90609 .21258 L
.90709 .21258 L
.90809 .21258 L
.90909 .21258 L
.91009 .21258 L
.91109 .21258 L
.91209 .21258 L
.91309 .21258 L
.91409 .21258 L
.91508 .21258 L
.91608 .21258 L
.91708 .21258 L
.91808 .21258 L
.91908 .21258 L
.92008 .21258 L
.92108 .21258 L
.92208 .21258 L
.92308 .21258 L
.92408 .21258 L
.92507 .21258 L
.92607 .21258 L
.92707 .21258 L
.92807 .21258 L
.92907 .21258 L
.93007 .21258 L
.93107 .21258 L
.93207 .21258 L
.93307 .21258 L
.93407 .21258 L
.93506 .21258 L
.93606 .21258 L
.93706 .21258 L
.93806 .21258 L
.93906 .21258 L
.94006 .21258 L
.94106 .21258 L
.94206 .21258 L
.94306 .21258 L
.94406 .21258 L
.94505 .21258 L
.94605 .21258 L
.94705 .21258 L
.94805 .21258 L
Mistroke
.94905 .21098 L
.95005 .21098 L
.95105 .21098 L
.95205 .21098 L
.95305 .21098 L
.95405 .21098 L
.95504 .21098 L
.95604 .21098 L
.95704 .21098 L
.95804 .21098 L
.95904 .21098 L
.96004 .21098 L
.96104 .21098 L
.96204 .21098 L
.96304 .21098 L
.96404 .21098 L
.96503 .21098 L
.96603 .21098 L
.96703 .21098 L
.96803 .21098 L
.96903 .21098 L
.97003 .21098 L
.97103 .21098 L
.97203 .21098 L
.97303 .21098 L
.97403 .21098 L
.97502 .21098 L
.97602 .21098 L
.97702 .21098 L
.97802 .21098 L
.97902 .21098 L
.98002 .21098 L
.98102 .21098 L
.98202 .21098 L
.98302 .21098 L
.98402 .21098 L
.98501 .21098 L
.98601 .21098 L
.98701 .21098 L
.98801 .21098 L
.98901 .21098 L
.99001 .21098 L
.99101 .21098 L
.99201 .21098 L
.99301 .21098 L
.99401 .21098 L
.995 .21098 L
.996 .21098 L
.997 .21098 L
.998 .21098 L
Mistroke
.999 .20667 L
Mfstroke
0 0 1 r
gsave
.001 -1.8541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0772542 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -6 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -6 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -6 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -6 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -6 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(1)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(2)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(3)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(4)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(6)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(7)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .20601 m
.001 .20601 L
.002 .20601 L
.003 .20601 L
.004 .20601 L
.005 .20601 L
.00599 .20601 L
.00699 .20601 L
.00799 .20601 L
.00899 .20601 L
.00999 .20601 L
.01099 .20601 L
.01199 .20601 L
.01299 .20601 L
.01399 .20601 L
.01499 .20601 L
.01598 .20601 L
.01698 .20601 L
.01798 .20602 L
.01898 .20602 L
.01998 .20602 L
.02098 .20602 L
.02198 .20602 L
.02298 .20602 L
.02398 .20602 L
.02498 .20602 L
.02597 .20602 L
.02697 .20602 L
.02797 .20602 L
.02897 .20602 L
.02997 .20602 L
.03097 .20602 L
.03197 .20602 L
.03297 .20602 L
.03397 .20602 L
.03497 .20602 L
.03596 .20602 L
.03696 .20602 L
.03796 .20602 L
.03896 .20602 L
.03996 .20602 L
.04096 .20602 L
.04196 .20602 L
.04296 .20602 L
.04396 .20602 L
.04496 .20602 L
.04595 .20602 L
.04695 .20602 L
.04795 .20602 L
.04895 .20602 L
Mistroke
.04995 .20602 L
.05095 .20602 L
.05195 .20602 L
.05295 .20602 L
.05395 .20601 L
.05495 .20602 L
.05594 .20602 L
.05694 .20602 L
.05794 .20602 L
.05894 .20602 L
.05994 .20602 L
.06094 .20601 L
.06194 .20602 L
.06294 .20602 L
.06394 .20602 L
.06494 .20602 L
.06593 .20602 L
.06693 .20602 L
.06793 .20602 L
.06893 .20602 L
.06993 .20602 L
.07093 .20602 L
.07193 .20602 L
.07293 .20602 L
.07393 .20602 L
.07493 .20602 L
.07592 .20602 L
.07692 .20602 L
.07792 .20602 L
.07892 .20602 L
.07992 .20602 L
.08092 .20602 L
.08192 .20602 L
.08292 .20602 L
.08392 .20602 L
.08492 .20602 L
.08591 .20602 L
.08691 .20602 L
.08791 .20602 L
.08891 .20602 L
.08991 .20602 L
.09091 .20602 L
.09191 .20602 L
.09291 .20602 L
.09391 .20602 L
.09491 .20602 L
.0959 .20602 L
.0969 .20603 L
.0979 .20602 L
.0989 .20602 L
Mistroke
.0999 .20602 L
.1009 .20603 L
.1019 .20603 L
.1029 .20603 L
.1039 .20603 L
.1049 .20602 L
.10589 .20603 L
.10689 .20603 L
.10789 .20603 L
.10889 .20603 L
.10989 .20602 L
.11089 .20602 L
.11189 .20603 L
.11289 .20602 L
.11389 .20602 L
.11489 .20602 L
.11588 .20602 L
.11688 .20602 L
.11788 .20602 L
.11888 .20602 L
.11988 .20602 L
.12088 .20602 L
.12188 .20602 L
.12288 .20603 L
.12388 .20602 L
.12488 .20602 L
.12587 .20602 L
.12687 .20602 L
.12787 .20602 L
.12887 .20602 L
.12987 .20602 L
.13087 .20602 L
.13187 .20602 L
.13287 .20602 L
.13387 .20602 L
.13487 .20602 L
.13586 .20603 L
.13686 .20603 L
.13786 .20603 L
.13886 .20603 L
.13986 .20603 L
.14086 .20603 L
.14186 .20603 L
.14286 .20603 L
.14386 .20602 L
.14486 .20602 L
.14585 .20602 L
.14685 .20602 L
.14785 .20602 L
.14885 .20602 L
Mistroke
.14985 .20602 L
.15085 .20602 L
.15185 .20603 L
.15285 .20603 L
.15385 .20603 L
.15485 .20603 L
.15584 .20602 L
.15684 .20602 L
.15784 .20602 L
.15884 .20602 L
.15984 .20602 L
.16084 .20602 L
.16184 .20602 L
.16284 .20602 L
.16384 .20602 L
.16484 .20602 L
.16583 .20602 L
.16683 .20602 L
.16783 .20602 L
.16883 .20602 L
.16983 .20602 L
.17083 .20602 L
.17183 .20602 L
.17283 .20602 L
.17383 .20602 L
.17483 .20602 L
.17582 .20602 L
.17682 .20602 L
.17782 .20602 L
.17882 .20602 L
.17982 .20602 L
.18082 .20602 L
.18182 .20602 L
.18282 .20602 L
.18382 .20602 L
.18482 .20602 L
.18581 .20602 L
.18681 .20603 L
.18781 .20602 L
.18881 .20602 L
.18981 .20603 L
.19081 .20603 L
.19181 .20603 L
.19281 .20603 L
.19381 .20603 L
.19481 .20603 L
.1958 .20603 L
.1968 .20603 L
.1978 .20603 L
.1988 .20603 L
Mistroke
.1998 .20603 L
.2008 .20603 L
.2018 .20603 L
.2028 .20603 L
.2038 .20603 L
.2048 .20603 L
.20579 .20603 L
.20679 .20603 L
.20779 .20603 L
.20879 .20603 L
.20979 .20603 L
.21079 .20603 L
.21179 .20603 L
.21279 .20603 L
.21379 .20603 L
.21479 .20603 L
.21578 .20603 L
.21678 .20603 L
.21778 .20603 L
.21878 .20603 L
.21978 .20603 L
.22078 .20603 L
.22178 .20603 L
.22278 .20603 L
.22378 .20603 L
.22478 .20603 L
.22577 .20603 L
.22677 .20603 L
.22777 .20603 L
.22877 .20603 L
.22977 .20603 L
.23077 .20603 L
.23177 .20603 L
.23277 .20603 L
.23377 .20603 L
.23477 .20603 L
.23576 .20603 L
.23676 .20603 L
.23776 .20603 L
.23876 .20603 L
.23976 .20602 L
.24076 .20602 L
.24176 .20602 L
.24276 .20602 L
.24376 .20602 L
.24476 .20603 L
.24575 .20603 L
.24675 .20603 L
.24775 .20603 L
.24875 .20603 L
Mistroke
.24975 .20603 L
.25075 .20603 L
.25175 .20603 L
.25275 .20603 L
.25375 .20603 L
.25475 .20603 L
.25574 .20603 L
.25674 .20603 L
.25774 .20603 L
.25874 .20602 L
.25974 .20603 L
.26074 .20602 L
.26174 .20602 L
.26274 .20602 L
.26374 .20603 L
.26474 .20603 L
.26573 .20603 L
.26673 .20603 L
.26773 .20603 L
.26873 .20603 L
.26973 .20603 L
.27073 .20603 L
.27173 .20603 L
.27273 .20603 L
.27373 .20603 L
.27473 .20603 L
.27572 .20602 L
.27672 .20602 L
.27772 .20602 L
.27872 .20602 L
.27972 .20602 L
.28072 .20602 L
.28172 .20602 L
.28272 .20602 L
.28372 .20602 L
.28472 .20602 L
.28571 .20603 L
.28671 .20603 L
.28771 .20603 L
.28871 .20603 L
.28971 .20603 L
.29071 .20603 L
.29171 .20603 L
.29271 .20603 L
.29371 .20603 L
.29471 .20603 L
.2957 .20603 L
.2967 .20603 L
.2977 .20603 L
.2987 .20603 L
Mistroke
.2997 .20603 L
.3007 .20603 L
.3017 .20603 L
.3027 .20603 L
.3037 .20603 L
.3047 .20603 L
.30569 .20603 L
.30669 .20603 L
.30769 .20603 L
.30869 .20603 L
.30969 .20603 L
.31069 .20603 L
.31169 .20603 L
.31269 .20603 L
.31369 .20603 L
.31469 .20603 L
.31568 .20603 L
.31668 .20603 L
.31768 .20603 L
.31868 .20603 L
.31968 .20603 L
.32068 .20603 L
.32168 .20603 L
.32268 .20603 L
.32368 .20603 L
.32468 .20603 L
.32567 .20603 L
.32667 .20603 L
.32767 .20603 L
.32867 .20603 L
.32967 .20603 L
.33067 .20603 L
.33167 .20603 L
.33267 .20603 L
.33367 .20603 L
.33467 .20603 L
.33566 .20603 L
.33666 .20603 L
.33766 .20603 L
.33866 .20603 L
.33966 .20603 L
.34066 .20603 L
.34166 .20603 L
.34266 .20604 L
.34366 .20603 L
.34466 .20603 L
.34565 .20604 L
.34665 .20603 L
.34765 .20604 L
.34865 .20604 L
Mistroke
.34965 .20603 L
.35065 .20603 L
.35165 .20603 L
.35265 .20604 L
.35365 .20603 L
.35465 .20603 L
.35564 .20603 L
.35664 .20603 L
.35764 .20603 L
.35864 .20603 L
.35964 .20603 L
.36064 .20604 L
.36164 .20604 L
.36264 .20604 L
.36364 .20604 L
.36464 .20604 L
.36563 .20604 L
.36663 .20604 L
.36763 .20604 L
.36863 .20604 L
.36963 .20604 L
.37063 .20604 L
.37163 .20604 L
.37263 .20604 L
.37363 .20604 L
.37463 .20604 L
.37562 .20604 L
.37662 .20604 L
.37762 .20604 L
.37862 .20604 L
.37962 .20604 L
.38062 .20604 L
.38162 .20604 L
.38262 .20604 L
.38362 .20604 L
.38462 .20604 L
.38561 .20603 L
.38661 .20604 L
.38761 .20604 L
.38861 .20604 L
.38961 .20604 L
.39061 .20604 L
.39161 .20604 L
.39261 .20604 L
.39361 .20604 L
.39461 .20604 L
.3956 .20604 L
.3966 .20604 L
.3976 .20604 L
.3986 .20604 L
Mistroke
.3996 .20604 L
.4006 .20604 L
.4016 .20604 L
.4026 .20604 L
.4036 .20604 L
.4046 .20604 L
.40559 .20604 L
.40659 .20604 L
.40759 .20604 L
.40859 .20604 L
.40959 .20604 L
.41059 .20604 L
.41159 .20604 L
.41259 .20604 L
.41359 .20604 L
.41459 .20604 L
.41558 .20604 L
.41658 .20604 L
.41758 .20604 L
.41858 .20604 L
.41958 .20604 L
.42058 .20604 L
.42158 .20604 L
.42258 .20604 L
.42358 .20604 L
.42458 .20604 L
.42557 .20604 L
.42657 .20604 L
.42757 .20604 L
.42857 .20604 L
.42957 .20604 L
.43057 .20604 L
.43157 .20604 L
.43257 .20604 L
.43357 .20604 L
.43457 .20604 L
.43556 .20604 L
.43656 .20604 L
.43756 .20604 L
.43856 .20604 L
.43956 .20604 L
.44056 .20604 L
.44156 .20604 L
.44256 .20604 L
.44356 .20604 L
.44456 .20604 L
.44555 .20604 L
.44655 .20604 L
.44755 .20604 L
.44855 .20604 L
Mistroke
.44955 .20604 L
.45055 .20604 L
.45155 .20604 L
.45255 .20604 L
.45355 .20604 L
.45455 .20604 L
.45554 .20604 L
.45654 .20603 L
.45754 .20604 L
.45854 .20604 L
.45954 .20604 L
.46054 .20604 L
.46154 .20604 L
.46254 .20604 L
.46354 .20604 L
.46454 .20604 L
.46553 .20604 L
.46653 .20604 L
.46753 .20604 L
.46853 .20604 L
.46953 .20604 L
.47053 .20604 L
.47153 .20604 L
.47253 .20604 L
.47353 .20604 L
.47453 .20604 L
.47552 .20604 L
.47652 .20604 L
.47752 .20604 L
.47852 .20604 L
.47952 .20604 L
.48052 .20604 L
.48152 .20604 L
.48252 .20604 L
.48352 .20604 L
.48452 .20605 L
.48551 .20604 L
.48651 .20604 L
.48751 .20604 L
.48851 .20604 L
.48951 .20604 L
.49051 .20604 L
.49151 .20605 L
.49251 .20604 L
.49351 .20605 L
.49451 .20605 L
.4955 .20605 L
.4965 .20605 L
.4975 .20604 L
.4985 .20604 L
Mistroke
.4995 .20604 L
.5005 .20604 L
.5015 .20604 L
.5025 .20604 L
.5035 .20604 L
.5045 .20604 L
.50549 .20604 L
.50649 .20604 L
.50749 .20604 L
.50849 .20604 L
.50949 .20604 L
.51049 .20604 L
.51149 .20604 L
.51249 .20604 L
.51349 .20604 L
.51449 .20604 L
.51548 .20604 L
.51648 .20604 L
.51748 .20604 L
.51848 .20604 L
.51948 .20604 L
.52048 .20604 L
.52148 .20604 L
.52248 .20604 L
.52348 .20604 L
.52448 .20604 L
.52547 .20604 L
.52647 .20604 L
.52747 .20604 L
.52847 .20604 L
.52947 .20604 L
.53047 .20605 L
.53147 .20605 L
.53247 .20605 L
.53347 .20605 L
.53447 .20605 L
.53546 .20605 L
.53646 .20605 L
.53746 .20605 L
.53846 .20605 L
.53946 .20604 L
.54046 .20604 L
.54146 .20604 L
.54246 .20604 L
.54346 .20604 L
.54446 .20604 L
.54545 .20604 L
.54645 .20604 L
.54745 .20604 L
.54845 .20604 L
Mistroke
.54945 .20604 L
.55045 .20604 L
.55145 .20604 L
.55245 .20604 L
.55345 .20604 L
.55445 .20604 L
.55544 .20605 L
.55644 .20605 L
.55744 .20604 L
.55844 .20605 L
.55944 .20605 L
.56044 .20605 L
.56144 .20605 L
.56244 .20604 L
.56344 .20604 L
.56444 .20604 L
.56543 .20604 L
.56643 .20604 L
.56743 .20604 L
.56843 .20604 L
.56943 .20604 L
.57043 .20604 L
.57143 .20605 L
.57243 .20605 L
.57343 .20605 L
.57443 .20605 L
.57542 .20605 L
.57642 .20605 L
.57742 .20605 L
.57842 .20605 L
.57942 .20605 L
.58042 .20605 L
.58142 .20605 L
.58242 .20605 L
.58342 .20605 L
.58442 .20604 L
.58541 .20604 L
.58641 .20604 L
.58741 .20605 L
.58841 .20604 L
.58941 .20605 L
.59041 .20605 L
.59141 .20605 L
.59241 .20605 L
.59341 .20605 L
.59441 .20605 L
.5954 .20604 L
.5964 .20604 L
.5974 .20604 L
.5984 .20604 L
Mistroke
.5994 .20605 L
.6004 .20605 L
.6014 .20605 L
.6024 .20605 L
.6034 .20605 L
.6044 .20605 L
.60539 .20605 L
.60639 .20605 L
.60739 .20605 L
.60839 .20605 L
.60939 .20605 L
.61039 .20604 L
.61139 .20604 L
.61239 .20604 L
.61339 .20604 L
.61439 .20604 L
.61538 .20604 L
.61638 .20604 L
.61738 .20604 L
.61838 .20604 L
.61938 .20604 L
.62038 .20604 L
.62138 .20604 L
.62238 .20604 L
.62338 .20604 L
.62438 .20604 L
.62537 .20604 L
.62637 .20604 L
.62737 .20604 L
.62837 .20604 L
.62937 .20604 L
.63037 .20605 L
.63137 .20605 L
.63237 .20605 L
.63337 .20605 L
.63437 .20605 L
.63536 .20605 L
.63636 .20605 L
.63736 .20605 L
.63836 .20605 L
.63936 .20605 L
.64036 .20605 L
.64136 .20605 L
.64236 .20605 L
.64336 .20605 L
.64436 .20605 L
.64535 .20605 L
.64635 .20605 L
.64735 .20605 L
.64835 .20605 L
Mistroke
.64935 .20605 L
.65035 .20605 L
.65135 .20605 L
.65235 .20605 L
.65335 .20605 L
.65435 .20605 L
.65534 .20605 L
.65634 .20605 L
.65734 .20605 L
.65834 .20605 L
.65934 .20605 L
.66034 .20605 L
.66134 .20605 L
.66234 .20605 L
.66334 .20605 L
.66434 .20605 L
.66533 .20605 L
.66633 .20605 L
.66733 .20605 L
.66833 .20605 L
.66933 .20605 L
.67033 .20605 L
.67133 .20605 L
.67233 .20605 L
.67333 .20605 L
.67433 .20605 L
.67532 .20605 L
.67632 .20605 L
.67732 .20605 L
.67832 .20605 L
.67932 .20605 L
.68032 .20605 L
.68132 .20605 L
.68232 .20605 L
.68332 .20605 L
.68432 .20605 L
.68531 .20605 L
.68631 .20605 L
.68731 .20605 L
.68831 .20605 L
.68931 .20605 L
.69031 .20605 L
.69131 .20605 L
.69231 .20605 L
.69331 .20605 L
.69431 .20605 L
.6953 .20605 L
.6963 .20605 L
.6973 .20605 L
.6983 .20605 L
Mistroke
.6993 .20605 L
.7003 .20605 L
.7013 .20605 L
.7023 .20605 L
.7033 .20605 L
.7043 .20605 L
.70529 .20605 L
.70629 .20605 L
.70729 .20605 L
.70829 .20605 L
.70929 .20605 L
.71029 .20605 L
.71129 .20605 L
.71229 .20605 L
.71329 .20605 L
.71429 .20605 L
.71528 .20605 L
.71628 .20605 L
.71728 .20604 L
.71828 .20604 L
.71928 .20604 L
.72028 .20604 L
.72128 .20605 L
.72228 .20605 L
.72328 .20605 L
.72428 .20605 L
.72527 .20605 L
.72627 .20605 L
.72727 .20605 L
.72827 .20605 L
.72927 .20605 L
.73027 .20605 L
.73127 .20605 L
.73227 .20605 L
.73327 .20605 L
.73427 .20605 L
.73526 .20605 L
.73626 .20605 L
.73726 .20605 L
.73826 .20605 L
.73926 .20605 L
.74026 .20605 L
.74126 .20605 L
.74226 .20605 L
.74326 .20605 L
.74426 .20605 L
.74525 .20605 L
.74625 .20605 L
.74725 .20605 L
.74825 .20605 L
Mistroke
.74925 .20605 L
.75025 .20605 L
.75125 .20605 L
.75225 .20605 L
.75325 .20605 L
.75425 .20606 L
.75524 .20606 L
.75624 .20606 L
.75724 .20606 L
.75824 .20606 L
.75924 .20605 L
.76024 .20605 L
.76124 .20605 L
.76224 .20605 L
.76324 .20606 L
.76424 .20606 L
.76523 .20606 L
.76623 .20606 L
.76723 .20606 L
.76823 .20606 L
.76923 .20606 L
.77023 .20606 L
.77123 .20606 L
.77223 .20606 L
.77323 .20606 L
.77423 .20606 L
.77522 .20606 L
.77622 .20606 L
.77722 .20606 L
.77822 .20606 L
.77922 .20606 L
.78022 .20606 L
.78122 .20606 L
.78222 .20606 L
.78322 .20606 L
.78422 .20606 L
.78521 .20606 L
.78621 .20606 L
.78721 .20606 L
.78821 .20606 L
.78921 .20606 L
.79021 .20606 L
.79121 .20606 L
.79221 .20606 L
.79321 .20606 L
.79421 .20606 L
.7952 .20606 L
.7962 .20606 L
.7972 .20606 L
.7982 .20606 L
Mistroke
.7992 .20606 L
.8002 .20606 L
.8012 .20607 L
.8022 .20606 L
.8032 .20607 L
.8042 .20607 L
.80519 .20606 L
.80619 .20606 L
.80719 .20606 L
.80819 .20606 L
.80919 .20606 L
.81019 .20606 L
.81119 .20607 L
.81219 .20607 L
.81319 .20607 L
.81419 .20607 L
.81518 .20607 L
.81618 .20607 L
.81718 .20606 L
.81818 .20606 L
.81918 .20606 L
.82018 .20606 L
.82118 .20606 L
.82218 .20606 L
.82318 .20606 L
.82418 .20606 L
.82517 .20606 L
.82617 .20606 L
.82717 .20606 L
.82817 .20606 L
.82917 .20606 L
.83017 .20606 L
.83117 .20606 L
.83217 .20606 L
.83317 .20607 L
.83417 .20607 L
.83516 .20607 L
.83616 .20607 L
.83716 .20607 L
.83816 .20607 L
.83916 .20607 L
.84016 .20607 L
.84116 .20606 L
.84216 .20606 L
.84316 .20606 L
.84416 .20606 L
.84515 .20606 L
.84615 .20607 L
.84715 .20606 L
.84815 .20606 L
Mistroke
.84915 .20606 L
.85015 .20606 L
.85115 .20606 L
.85215 .20606 L
.85315 .20606 L
.85415 .20607 L
.85514 .20607 L
.85614 .20607 L
.85714 .20607 L
.85814 .20607 L
.85914 .20607 L
.86014 .20607 L
.86114 .20607 L
.86214 .20607 L
.86314 .20607 L
.86414 .20607 L
.86513 .20607 L
.86613 .20607 L
.86713 .20607 L
.86813 .20607 L
.86913 .20607 L
.87013 .20607 L
.87113 .20607 L
.87213 .20607 L
.87313 .20607 L
.87413 .20607 L
.87512 .20607 L
.87612 .20607 L
.87712 .20607 L
.87812 .20607 L
.87912 .20607 L
.88012 .20607 L
.88112 .20607 L
.88212 .20607 L
.88312 .20607 L
.88412 .20607 L
.88511 .20607 L
.88611 .20607 L
.88711 .20607 L
.88811 .20607 L
.88911 .20607 L
.89011 .20607 L
.89111 .20607 L
.89211 .20607 L
.89311 .20607 L
.89411 .20607 L
.8951 .20607 L
.8961 .20607 L
.8971 .20607 L
.8981 .20607 L
Mistroke
.8991 .20606 L
.9001 .20607 L
.9011 .20607 L
.9021 .20606 L
.9031 .20606 L
.9041 .20606 L
.90509 .20606 L
.90609 .20606 L
.90709 .20606 L
.90809 .20606 L
.90909 .20606 L
.91009 .20606 L
.91109 .20606 L
.91209 .20606 L
.91309 .20606 L
.91409 .20606 L
.91508 .20606 L
.91608 .20606 L
.91708 .20606 L
.91808 .20606 L
.91908 .20606 L
.92008 .20606 L
.92108 .20607 L
.92208 .20606 L
.92308 .20606 L
.92408 .20606 L
.92507 .20606 L
.92607 .20606 L
.92707 .20606 L
.92807 .20606 L
.92907 .20606 L
.93007 .20606 L
.93107 .20606 L
.93207 .20606 L
.93307 .20606 L
.93407 .20606 L
.93506 .20606 L
.93606 .20606 L
.93706 .20606 L
.93806 .20606 L
.93906 .20606 L
.94006 .20606 L
.94106 .20606 L
.94206 .20606 L
.94306 .20606 L
.94406 .20606 L
.94505 .20606 L
.94605 .20606 L
.94705 .20606 L
.94805 .20606 L
Mistroke
.94905 .20606 L
.95005 .20606 L
.95105 .20606 L
.95205 .20606 L
.95305 .20606 L
.95405 .20606 L
.95504 .20606 L
.95604 .20606 L
.95704 .20606 L
.95804 .20606 L
.95904 .20606 L
.96004 .20606 L
.96104 .20606 L
.96204 .20606 L
.96304 .20606 L
.96404 .20606 L
.96503 .20606 L
.96603 .20606 L
.96703 .20606 L
.96803 .20606 L
.96903 .20607 L
.97003 .20607 L
.97103 .20607 L
.97203 .20606 L
.97303 .20606 L
.97403 .20606 L
.97502 .20606 L
.97602 .20606 L
.97702 .20606 L
.97802 .20606 L
.97902 .20606 L
.98002 .20606 L
.98102 .20606 L
.98202 .20606 L
.98302 .20606 L
.98402 .20606 L
.98501 .20606 L
.98601 .20606 L
.98701 .20606 L
.98801 .20606 L
.98901 .20606 L
.99001 .20606 L
.99101 .20606 L
.99201 .20606 L
.99301 .20606 L
.99401 .20607 L
.995 .20607 L
.996 .20607 L
.997 .20607 L
.998 .20607 L
Mistroke
.999 .20607 L
Mfstroke
0 .98 .604 r
gsave
.999 .19447 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .13185 m
.001 .13185 L
.002 .13185 L
.003 .13185 L
.004 .13185 L
.005 .13185 L
.00599 .13185 L
.00699 .13185 L
.00799 .13185 L
.00899 .13185 L
.00999 .13185 L
.01099 .13185 L
.01199 .13185 L
.01299 .13185 L
.01399 .13185 L
.01499 .13185 L
.01598 .13185 L
.01698 .13185 L
.01798 .13185 L
.01898 .13185 L
.01998 .13185 L
.02098 .13185 L
.02198 .13185 L
.02298 .13185 L
.02398 .13185 L
.02498 .13185 L
.02597 .13185 L
.02697 .13185 L
.02797 .13185 L
.02897 .13185 L
.02997 .13185 L
.03097 .13185 L
.03197 .13185 L
.03297 .13185 L
.03397 .13185 L
.03497 .13185 L
.03596 .13185 L
.03696 .13185 L
.03796 .13185 L
.03896 .13185 L
.03996 .13185 L
.04096 .13185 L
.04196 .13185 L
.04296 .13185 L
.04396 .13185 L
.04496 .13185 L
.04595 .13185 L
.04695 .13185 L
.04795 .13185 L
.04895 .13185 L
Mistroke
.04995 .08728 L
.05095 .08728 L
.05195 .08728 L
.05295 .08728 L
.05395 .08728 L
.05495 .08728 L
.05594 .08728 L
.05694 .08728 L
.05794 .08728 L
.05894 .08728 L
.05994 .08728 L
.06094 .08728 L
.06194 .08728 L
.06294 .08728 L
.06394 .08728 L
.06494 .08728 L
.06593 .08728 L
.06693 .08728 L
.06793 .08728 L
.06893 .08728 L
.06993 .08728 L
.07093 .08728 L
.07193 .08728 L
.07293 .08728 L
.07393 .08728 L
.07493 .08728 L
.07592 .08728 L
.07692 .08728 L
.07792 .08728 L
.07892 .08728 L
.07992 .08728 L
.08092 .08728 L
.08192 .08728 L
.08292 .08728 L
.08392 .08728 L
.08492 .08728 L
.08591 .08728 L
.08691 .08728 L
.08791 .08728 L
.08891 .08728 L
.08991 .08728 L
.09091 .08728 L
.09191 .08728 L
.09291 .08728 L
.09391 .08728 L
.09491 .08728 L
.0959 .08728 L
.0969 .08728 L
.0979 .08728 L
.0989 .08728 L
Mistroke
.0999 .16856 L
.1009 .16856 L
.1019 .16856 L
.1029 .16856 L
.1039 .16856 L
.1049 .16856 L
.10589 .16856 L
.10689 .16856 L
.10789 .16856 L
.10889 .16856 L
.10989 .16856 L
.11089 .16856 L
.11189 .16856 L
.11289 .16856 L
.11389 .16856 L
.11489 .16856 L
.11588 .16856 L
.11688 .16856 L
.11788 .16856 L
.11888 .16856 L
.11988 .16856 L
.12088 .16856 L
.12188 .16856 L
.12288 .16856 L
.12388 .16856 L
.12488 .16856 L
.12587 .16856 L
.12687 .16856 L
.12787 .16856 L
.12887 .16856 L
.12987 .16856 L
.13087 .16856 L
.13187 .16856 L
.13287 .16856 L
.13387 .16856 L
.13487 .16856 L
.13586 .16856 L
.13686 .16856 L
.13786 .16856 L
.13886 .16856 L
.13986 .16856 L
.14086 .16856 L
.14186 .16856 L
.14286 .16856 L
.14386 .16856 L
.14486 .16856 L
.14585 .16856 L
.14685 .16856 L
.14785 .16856 L
.14885 .16856 L
Mistroke
.14985 .1993 L
.15085 .1993 L
.15185 .1993 L
.15285 .1993 L
.15385 .1993 L
.15485 .1993 L
.15584 .1993 L
.15684 .1993 L
.15784 .1993 L
.15884 .1993 L
.15984 .1993 L
.16084 .1993 L
.16184 .1993 L
.16284 .1993 L
.16384 .1993 L
.16484 .1993 L
.16583 .1993 L
.16683 .1993 L
.16783 .1993 L
.16883 .1993 L
.16983 .1993 L
.17083 .1993 L
.17183 .1993 L
.17283 .1993 L
.17383 .1993 L
.17483 .1993 L
.17582 .1993 L
.17682 .1993 L
.17782 .1993 L
.17882 .1993 L
.17982 .1993 L
.18082 .1993 L
.18182 .1993 L
.18282 .1993 L
.18382 .1993 L
.18482 .1993 L
.18581 .1993 L
.18681 .1993 L
.18781 .1993 L
.18881 .1993 L
.18981 .1993 L
.19081 .1993 L
.19181 .1993 L
.19281 .1993 L
.19381 .1993 L
.19481 .1993 L
.1958 .1993 L
.1968 .1993 L
.1978 .1993 L
.1988 .1993 L
Mistroke
.1998 .19493 L
.2008 .19493 L
.2018 .19493 L
.2028 .19493 L
.2038 .19493 L
.2048 .19493 L
.20579 .19493 L
.20679 .19493 L
.20779 .19493 L
.20879 .19493 L
.20979 .19493 L
.21079 .19493 L
.21179 .19493 L
.21279 .19493 L
.21379 .19493 L
.21479 .19493 L
.21578 .19493 L
.21678 .19493 L
.21778 .19493 L
.21878 .19493 L
.21978 .19493 L
.22078 .19493 L
.22178 .19493 L
.22278 .19493 L
.22378 .19493 L
.22478 .19493 L
.22577 .19493 L
.22677 .19493 L
.22777 .19493 L
.22877 .19493 L
.22977 .19493 L
.23077 .19493 L
.23177 .19493 L
.23277 .19493 L
.23377 .19493 L
.23477 .19493 L
.23576 .19493 L
.23676 .19493 L
.23776 .19493 L
.23876 .19493 L
.23976 .19493 L
.24076 .19493 L
.24176 .19493 L
.24276 .19493 L
.24376 .19493 L
.24476 .19493 L
.24575 .19493 L
.24675 .19493 L
.24775 .19493 L
.24875 .19493 L
Mistroke
.24975 .18035 L
.25075 .18035 L
.25175 .18035 L
.25275 .18035 L
.25375 .18035 L
.25475 .18035 L
.25574 .18035 L
.25674 .18035 L
.25774 .18035 L
.25874 .18035 L
.25974 .18035 L
.26074 .18035 L
.26174 .18035 L
.26274 .18035 L
.26374 .18035 L
.26474 .18035 L
.26573 .18035 L
.26673 .18035 L
.26773 .18035 L
.26873 .18035 L
.26973 .18035 L
.27073 .18035 L
.27173 .18035 L
.27273 .18035 L
.27373 .18035 L
.27473 .18035 L
.27572 .18035 L
.27672 .18035 L
.27772 .18035 L
.27872 .18035 L
.27972 .18035 L
.28072 .18035 L
.28172 .18035 L
.28272 .18035 L
.28372 .18035 L
.28472 .18035 L
.28571 .18035 L
.28671 .18035 L
.28771 .18035 L
.28871 .18035 L
.28971 .18035 L
.29071 .18035 L
.29171 .18035 L
.29271 .18035 L
.29371 .18035 L
.29471 .18035 L
.2957 .18035 L
.2967 .18035 L
.2977 .18035 L
.2987 .18035 L
Mistroke
.2997 .1813 L
.3007 .1813 L
.3017 .1813 L
.3027 .1813 L
.3037 .1813 L
.3047 .1813 L
.30569 .1813 L
.30669 .1813 L
.30769 .1813 L
.30869 .1813 L
.30969 .1813 L
.31069 .1813 L
.31169 .1813 L
.31269 .1813 L
.31369 .1813 L
.31469 .1813 L
.31568 .1813 L
.31668 .1813 L
.31768 .1813 L
.31868 .1813 L
.31968 .1813 L
.32068 .1813 L
.32168 .1813 L
.32268 .1813 L
.32368 .1813 L
.32468 .1813 L
.32567 .1813 L
.32667 .1813 L
.32767 .1813 L
.32867 .1813 L
.32967 .1813 L
.33067 .1813 L
.33167 .1813 L
.33267 .1813 L
.33367 .1813 L
.33467 .1813 L
.33566 .1813 L
.33666 .1813 L
.33766 .1813 L
.33866 .1813 L
.33966 .1813 L
.34066 .1813 L
.34166 .1813 L
.34266 .1813 L
.34366 .1813 L
.34466 .1813 L
.34565 .1813 L
.34665 .1813 L
.34765 .1813 L
.34865 .1813 L
Mistroke
.34965 .17852 L
.35065 .17852 L
.35165 .17852 L
.35265 .17852 L
.35365 .17852 L
.35465 .17852 L
.35564 .17852 L
.35664 .17852 L
.35764 .17852 L
.35864 .17852 L
.35964 .17852 L
.36064 .17852 L
.36164 .17852 L
.36264 .17852 L
.36364 .17852 L
.36464 .17852 L
.36563 .17852 L
.36663 .17852 L
.36763 .17852 L
.36863 .17852 L
.36963 .17852 L
.37063 .17852 L
.37163 .17852 L
.37263 .17852 L
.37363 .17852 L
.37463 .17852 L
.37562 .17852 L
.37662 .17852 L
.37762 .17852 L
.37862 .17852 L
.37962 .17852 L
.38062 .17852 L
.38162 .17852 L
.38262 .17852 L
.38362 .17852 L
.38462 .17852 L
.38561 .17852 L
.38661 .17852 L
.38761 .17852 L
.38861 .17852 L
.38961 .17852 L
.39061 .17852 L
.39161 .17852 L
.39261 .17852 L
.39361 .17852 L
.39461 .17852 L
.3956 .17852 L
.3966 .17852 L
.3976 .17852 L
.3986 .17852 L
Mistroke
.3996 .16779 L
.4006 .16779 L
.4016 .16779 L
.4026 .16779 L
.4036 .16779 L
.4046 .16779 L
.40559 .16779 L
.40659 .16779 L
.40759 .16779 L
.40859 .16779 L
.40959 .16779 L
.41059 .16779 L
.41159 .16779 L
.41259 .16779 L
.41359 .16779 L
.41459 .16779 L
.41558 .16779 L
.41658 .16779 L
.41758 .16779 L
.41858 .16779 L
.41958 .16779 L
.42058 .16779 L
.42158 .16779 L
.42258 .16779 L
.42358 .16779 L
.42458 .16779 L
.42557 .16779 L
.42657 .16779 L
.42757 .16779 L
.42857 .16779 L
.42957 .16779 L
.43057 .16779 L
.43157 .16779 L
.43257 .16779 L
.43357 .16779 L
.43457 .16779 L
.43556 .16779 L
.43656 .16779 L
.43756 .16779 L
.43856 .16779 L
.43956 .16779 L
.44056 .16779 L
.44156 .16779 L
.44256 .16779 L
.44356 .16779 L
.44456 .16779 L
.44555 .16779 L
.44655 .16779 L
.44755 .16779 L
.44855 .16779 L
Mistroke
.44955 .16424 L
.45055 .16424 L
.45155 .16424 L
.45255 .16424 L
.45355 .16424 L
.45455 .16424 L
.45554 .16424 L
.45654 .16424 L
.45754 .16424 L
.45854 .16424 L
.45954 .16424 L
.46054 .16424 L
.46154 .16424 L
.46254 .16424 L
.46354 .16424 L
.46454 .16424 L
.46553 .16424 L
.46653 .16424 L
.46753 .16424 L
.46853 .16424 L
.46953 .16424 L
.47053 .16424 L
.47153 .16424 L
.47253 .16424 L
.47353 .16424 L
.47453 .16424 L
.47552 .16424 L
.47652 .16424 L
.47752 .16424 L
.47852 .16424 L
.47952 .16424 L
.48052 .16424 L
.48152 .16424 L
.48252 .16424 L
.48352 .16424 L
.48452 .16424 L
.48551 .16424 L
.48651 .16424 L
.48751 .16424 L
.48851 .16424 L
.48951 .16424 L
.49051 .16424 L
.49151 .16424 L
.49251 .16424 L
.49351 .16424 L
.49451 .16424 L
.4955 .16424 L
.4965 .16424 L
.4975 .16424 L
.4985 .16424 L
Mistroke
.4995 .17433 L
.5005 .17433 L
.5015 .17433 L
.5025 .17433 L
.5035 .17433 L
.5045 .17433 L
.50549 .17433 L
.50649 .17433 L
.50749 .17433 L
.50849 .17433 L
.50949 .17433 L
.51049 .17433 L
.51149 .17433 L
.51249 .17433 L
.51349 .17433 L
.51449 .17433 L
.51548 .17433 L
.51648 .17433 L
.51748 .17433 L
.51848 .17433 L
.51948 .17433 L
.52048 .17433 L
.52148 .17433 L
.52248 .17433 L
.52348 .17433 L
.52448 .17433 L
.52547 .17433 L
.52647 .17433 L
.52747 .17433 L
.52847 .17433 L
.52947 .17433 L
.53047 .17433 L
.53147 .17433 L
.53247 .17433 L
.53347 .17433 L
.53447 .17433 L
.53546 .17433 L
.53646 .17433 L
.53746 .17433 L
.53846 .17433 L
.53946 .17433 L
.54046 .17433 L
.54146 .17433 L
.54246 .17433 L
.54346 .17433 L
.54446 .17433 L
.54545 .17433 L
.54645 .17433 L
.54745 .17433 L
.54845 .17433 L
Mistroke
.54945 .17941 L
.55045 .17941 L
.55145 .17941 L
.55245 .17941 L
.55345 .17941 L
.55445 .17941 L
.55544 .17941 L
.55644 .17941 L
.55744 .17941 L
.55844 .17941 L
.55944 .17941 L
.56044 .17941 L
.56144 .17941 L
.56244 .17941 L
.56344 .17941 L
.56444 .17941 L
.56543 .17941 L
.56643 .17941 L
.56743 .17941 L
.56843 .17941 L
.56943 .17941 L
.57043 .17941 L
.57143 .17941 L
.57243 .17941 L
.57343 .17941 L
.57443 .17941 L
.57542 .17941 L
.57642 .17941 L
.57742 .17941 L
.57842 .17941 L
.57942 .17941 L
.58042 .17941 L
.58142 .17941 L
.58242 .17941 L
.58342 .17941 L
.58442 .17941 L
.58541 .17941 L
.58641 .17941 L
.58741 .17941 L
.58841 .17941 L
.58941 .17941 L
.59041 .17941 L
.59141 .17941 L
.59241 .17941 L
.59341 .17941 L
.59441 .17941 L
.5954 .17941 L
.5964 .17941 L
.5974 .17941 L
.5984 .17941 L
Mistroke
.5994 .1812 L
.6004 .1812 L
.6014 .1812 L
.6024 .1812 L
.6034 .1812 L
.6044 .1812 L
.60539 .1812 L
.60639 .1812 L
.60739 .1812 L
.60839 .1812 L
.60939 .1812 L
.61039 .1812 L
.61139 .1812 L
.61239 .1812 L
.61339 .1812 L
.61439 .1812 L
.61538 .1812 L
.61638 .1812 L
.61738 .1812 L
.61838 .1812 L
.61938 .1812 L
.62038 .1812 L
.62138 .1812 L
.62238 .1812 L
.62338 .1812 L
.62438 .1812 L
.62537 .1812 L
.62637 .1812 L
.62737 .1812 L
.62837 .1812 L
.62937 .1812 L
.63037 .1812 L
.63137 .1812 L
.63237 .1812 L
.63337 .1812 L
.63437 .1812 L
.63536 .1812 L
.63636 .1812 L
.63736 .1812 L
.63836 .1812 L
.63936 .1812 L
.64036 .1812 L
.64136 .1812 L
.64236 .1812 L
.64336 .1812 L
.64436 .1812 L
.64535 .1812 L
.64635 .1812 L
.64735 .1812 L
.64835 .1812 L
Mistroke
.64935 .18224 L
.65035 .18224 L
.65135 .18224 L
.65235 .18224 L
.65335 .18224 L
.65435 .18224 L
.65534 .18224 L
.65634 .18224 L
.65734 .18224 L
.65834 .18224 L
.65934 .18224 L
.66034 .18224 L
.66134 .18224 L
.66234 .18224 L
.66334 .18224 L
.66434 .18224 L
.66533 .18224 L
.66633 .18224 L
.66733 .18224 L
.66833 .18224 L
.66933 .18224 L
.67033 .18224 L
.67133 .18224 L
.67233 .18224 L
.67333 .18224 L
.67433 .18224 L
.67532 .18224 L
.67632 .18224 L
.67732 .18224 L
.67832 .18224 L
.67932 .18224 L
.68032 .18224 L
.68132 .18224 L
.68232 .18224 L
.68332 .18224 L
.68432 .18224 L
.68531 .18224 L
.68631 .18224 L
.68731 .18224 L
.68831 .18224 L
.68931 .18224 L
.69031 .18224 L
.69131 .18224 L
.69231 .18224 L
.69331 .18224 L
.69431 .18224 L
.6953 .18224 L
.6963 .18224 L
.6973 .18224 L
.6983 .18224 L
Mistroke
.6993 .18201 L
.7003 .18201 L
.7013 .18201 L
.7023 .18201 L
.7033 .18201 L
.7043 .18201 L
.70529 .18201 L
.70629 .18201 L
.70729 .18201 L
.70829 .18201 L
.70929 .18201 L
.71029 .18201 L
.71129 .18201 L
.71229 .18201 L
.71329 .18201 L
.71429 .18201 L
.71528 .18201 L
.71628 .18201 L
.71728 .18201 L
.71828 .18201 L
.71928 .18201 L
.72028 .18201 L
.72128 .18201 L
.72228 .18201 L
.72328 .18201 L
.72428 .18201 L
.72527 .18201 L
.72627 .18201 L
.72727 .18201 L
.72827 .18201 L
.72927 .18201 L
.73027 .18201 L
.73127 .18201 L
.73227 .18201 L
.73327 .18201 L
.73427 .18201 L
.73526 .18201 L
.73626 .18201 L
.73726 .18201 L
.73826 .18201 L
.73926 .18201 L
.74026 .18201 L
.74126 .18201 L
.74226 .18201 L
.74326 .18201 L
.74426 .18201 L
.74525 .18201 L
.74625 .18201 L
.74725 .18201 L
.74825 .18201 L
Mistroke
.74925 .1836 L
.75025 .1836 L
.75125 .1836 L
.75225 .1836 L
.75325 .1836 L
.75425 .1836 L
.75524 .1836 L
.75624 .1836 L
.75724 .1836 L
.75824 .1836 L
.75924 .1836 L
.76024 .1836 L
.76124 .1836 L
.76224 .1836 L
.76324 .1836 L
.76424 .1836 L
.76523 .1836 L
.76623 .1836 L
.76723 .1836 L
.76823 .1836 L
.76923 .1836 L
.77023 .1836 L
.77123 .1836 L
.77223 .1836 L
.77323 .1836 L
.77423 .1836 L
.77522 .1836 L
.77622 .1836 L
.77722 .1836 L
.77822 .1836 L
.77922 .1836 L
.78022 .1836 L
.78122 .1836 L
.78222 .1836 L
.78322 .1836 L
.78422 .1836 L
.78521 .1836 L
.78621 .1836 L
.78721 .1836 L
.78821 .1836 L
.78921 .1836 L
.79021 .1836 L
.79121 .1836 L
.79221 .1836 L
.79321 .1836 L
.79421 .1836 L
.7952 .1836 L
.7962 .1836 L
.7972 .1836 L
.7982 .1836 L
Mistroke
.7992 .18588 L
.8002 .18588 L
.8012 .18588 L
.8022 .18588 L
.8032 .18588 L
.8042 .18588 L
.80519 .18588 L
.80619 .18588 L
.80719 .18588 L
.80819 .18588 L
.80919 .18588 L
.81019 .18588 L
.81119 .18588 L
.81219 .18588 L
.81319 .18588 L
.81419 .18588 L
.81518 .18588 L
.81618 .18588 L
.81718 .18588 L
.81818 .18588 L
.81918 .18588 L
.82018 .18588 L
.82118 .18588 L
.82218 .18588 L
.82318 .18588 L
.82418 .18588 L
.82517 .18588 L
.82617 .18588 L
.82717 .18588 L
.82817 .18588 L
.82917 .18588 L
.83017 .18588 L
.83117 .18588 L
.83217 .18588 L
.83317 .18588 L
.83417 .18588 L
.83516 .18588 L
.83616 .18588 L
.83716 .18588 L
.83816 .18588 L
.83916 .18588 L
.84016 .18588 L
.84116 .18588 L
.84216 .18588 L
.84316 .18588 L
.84416 .18588 L
.84515 .18588 L
.84615 .18588 L
.84715 .18588 L
.84815 .18588 L
Mistroke
.84915 .1892 L
.85015 .1892 L
.85115 .1892 L
.85215 .1892 L
.85315 .1892 L
.85415 .1892 L
.85514 .1892 L
.85614 .1892 L
.85714 .1892 L
.85814 .1892 L
.85914 .1892 L
.86014 .1892 L
.86114 .1892 L
.86214 .1892 L
.86314 .1892 L
.86414 .1892 L
.86513 .1892 L
.86613 .1892 L
.86713 .1892 L
.86813 .1892 L
.86913 .1892 L
.87013 .1892 L
.87113 .1892 L
.87213 .1892 L
.87313 .1892 L
.87413 .1892 L
.87512 .1892 L
.87612 .1892 L
.87712 .1892 L
.87812 .1892 L
.87912 .1892 L
.88012 .1892 L
.88112 .1892 L
.88212 .1892 L
.88312 .1892 L
.88412 .1892 L
.88511 .1892 L
.88611 .1892 L
.88711 .1892 L
.88811 .1892 L
.88911 .1892 L
.89011 .1892 L
.89111 .1892 L
.89211 .1892 L
.89311 .1892 L
.89411 .1892 L
.8951 .1892 L
.8961 .1892 L
.8971 .1892 L
.8981 .1892 L
Mistroke
.8991 .19121 L
.9001 .19121 L
.9011 .19121 L
.9021 .19121 L
.9031 .19121 L
.9041 .19121 L
.90509 .19121 L
.90609 .19121 L
.90709 .19121 L
.90809 .19121 L
.90909 .19121 L
.91009 .19121 L
.91109 .19121 L
.91209 .19121 L
.91309 .19121 L
.91409 .19121 L
.91508 .19121 L
.91608 .19121 L
.91708 .19121 L
.91808 .19121 L
.91908 .19121 L
.92008 .19121 L
.92108 .19121 L
.92208 .19121 L
.92308 .19121 L
.92408 .19121 L
.92507 .19121 L
.92607 .19121 L
.92707 .19121 L
.92807 .19121 L
.92907 .19121 L
.93007 .19121 L
.93107 .19121 L
.93207 .19121 L
.93307 .19121 L
.93407 .19121 L
.93506 .19121 L
.93606 .19121 L
.93706 .19121 L
.93806 .19121 L
.93906 .19121 L
.94006 .19121 L
.94106 .19121 L
.94206 .19121 L
.94306 .19121 L
.94406 .19121 L
.94505 .19121 L
.94605 .19121 L
.94705 .19121 L
.94805 .19121 L
Mistroke
.94905 .19319 L
.95005 .19319 L
.95105 .19319 L
.95205 .19319 L
.95305 .19319 L
.95405 .19319 L
.95504 .19319 L
.95604 .19319 L
.95704 .19319 L
.95804 .19319 L
.95904 .19319 L
.96004 .19319 L
.96104 .19319 L
.96204 .19319 L
.96304 .19319 L
.96404 .19319 L
.96503 .19319 L
.96603 .19319 L
.96703 .19319 L
.96803 .19319 L
.96903 .19319 L
.97003 .19319 L
.97103 .19319 L
.97203 .19319 L
.97303 .19319 L
.97403 .19319 L
.97502 .19319 L
.97602 .19319 L
.97702 .19319 L
.97802 .19319 L
.97902 .19319 L
.98002 .19319 L
.98102 .19319 L
.98202 .19319 L
.98302 .19319 L
.98402 .19319 L
.98501 .19319 L
.98601 .19319 L
.98701 .19319 L
.98801 .19319 L
.98901 .19319 L
.99001 .19319 L
.99101 .19319 L
.99201 .19319 L
.99301 .19319 L
.99401 .19319 L
.995 .19319 L
.996 .19319 L
.997 .19319 L
.998 .19319 L
Mistroke
.999 .19447 L
Mfstroke
gsave
.999 .22723 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .43468 m
.001 .43468 L
.002 .43468 L
.003 .43468 L
.004 .43468 L
.005 .43468 L
.00599 .43468 L
.00699 .43468 L
.00799 .43468 L
.00899 .43468 L
.00999 .43468 L
.01099 .43468 L
.01199 .43468 L
.01299 .43468 L
.01399 .43468 L
.01499 .43468 L
.01598 .43468 L
.01698 .43468 L
.01798 .43468 L
.01898 .43468 L
.01998 .43468 L
.02098 .43468 L
.02198 .43468 L
.02298 .43468 L
.02398 .43468 L
.02498 .43468 L
.02597 .43468 L
.02697 .43468 L
.02797 .43468 L
.02897 .43468 L
.02997 .43468 L
.03097 .43468 L
.03197 .43468 L
.03297 .43468 L
.03397 .43468 L
.03497 .43468 L
.03596 .43468 L
.03696 .43468 L
.03796 .43468 L
.03896 .43468 L
.03996 .43468 L
.04096 .43468 L
.04196 .43468 L
.04296 .43468 L
.04396 .43468 L
.04496 .43468 L
.04595 .43468 L
.04695 .43468 L
.04795 .43468 L
.04895 .43468 L
Mistroke
.04995 .37724 L
.05095 .37724 L
.05195 .37724 L
.05295 .37724 L
.05395 .37724 L
.05495 .37724 L
.05594 .37724 L
.05694 .37724 L
.05794 .37724 L
.05894 .37724 L
.05994 .37724 L
.06094 .37724 L
.06194 .37724 L
.06294 .37724 L
.06394 .37724 L
.06494 .37724 L
.06593 .37724 L
.06693 .37724 L
.06793 .37724 L
.06893 .37724 L
.06993 .37724 L
.07093 .37724 L
.07193 .37724 L
.07293 .37724 L
.07393 .37724 L
.07493 .37724 L
.07592 .37724 L
.07692 .37724 L
.07792 .37724 L
.07892 .37724 L
.07992 .37724 L
.08092 .37724 L
.08192 .37724 L
.08292 .37724 L
.08392 .37724 L
.08492 .37724 L
.08591 .37724 L
.08691 .37724 L
.08791 .37724 L
.08891 .37724 L
.08991 .37724 L
.09091 .37724 L
.09191 .37724 L
.09291 .37724 L
.09391 .37724 L
.09491 .37724 L
.0959 .37724 L
.0969 .37724 L
.0979 .37724 L
.0989 .37724 L
Mistroke
.0999 .26652 L
.1009 .26652 L
.1019 .26652 L
.1029 .26652 L
.1039 .26652 L
.1049 .26652 L
.10589 .26652 L
.10689 .26652 L
.10789 .26652 L
.10889 .26652 L
.10989 .26652 L
.11089 .26652 L
.11189 .26652 L
.11289 .26652 L
.11389 .26652 L
.11489 .26652 L
.11588 .26652 L
.11688 .26652 L
.11788 .26652 L
.11888 .26652 L
.11988 .26652 L
.12088 .26652 L
.12188 .26652 L
.12288 .26652 L
.12388 .26652 L
.12488 .26652 L
.12587 .26652 L
.12687 .26652 L
.12787 .26652 L
.12887 .26652 L
.12987 .26652 L
.13087 .26652 L
.13187 .26652 L
.13287 .26652 L
.13387 .26652 L
.13487 .26652 L
.13586 .26652 L
.13686 .26652 L
.13786 .26652 L
.13886 .26652 L
.13986 .26652 L
.14086 .26652 L
.14186 .26652 L
.14286 .26652 L
.14386 .26652 L
.14486 .26652 L
.14585 .26652 L
.14685 .26652 L
.14785 .26652 L
.14885 .26652 L
Mistroke
.14985 .29003 L
.15085 .29003 L
.15185 .29003 L
.15285 .29003 L
.15385 .29003 L
.15485 .29003 L
.15584 .29003 L
.15684 .29003 L
.15784 .29003 L
.15884 .29003 L
.15984 .29003 L
.16084 .29003 L
.16184 .29003 L
.16284 .29003 L
.16384 .29003 L
.16484 .29003 L
.16583 .29003 L
.16683 .29003 L
.16783 .29003 L
.16883 .29003 L
.16983 .29003 L
.17083 .29003 L
.17183 .29003 L
.17283 .29003 L
.17383 .29003 L
.17483 .29003 L
.17582 .29003 L
.17682 .29003 L
.17782 .29003 L
.17882 .29003 L
.17982 .29003 L
.18082 .29003 L
.18182 .29003 L
.18282 .29003 L
.18382 .29003 L
.18482 .29003 L
.18581 .29003 L
.18681 .29003 L
.18781 .29003 L
.18881 .29003 L
.18981 .29003 L
.19081 .29003 L
.19181 .29003 L
.19281 .29003 L
.19381 .29003 L
.19481 .29003 L
.1958 .29003 L
.1968 .29003 L
.1978 .29003 L
.1988 .29003 L
Mistroke
.1998 .27752 L
.2008 .27752 L
.2018 .27752 L
.2028 .27752 L
.2038 .27752 L
.2048 .27752 L
.20579 .27752 L
.20679 .27752 L
.20779 .27752 L
.20879 .27752 L
.20979 .27752 L
.21079 .27752 L
.21179 .27752 L
.21279 .27752 L
.21379 .27752 L
.21479 .27752 L
.21578 .27752 L
.21678 .27752 L
.21778 .27752 L
.21878 .27752 L
.21978 .27752 L
.22078 .27752 L
.22178 .27752 L
.22278 .27752 L
.22378 .27752 L
.22478 .27752 L
.22577 .27752 L
.22677 .27752 L
.22777 .27752 L
.22877 .27752 L
.22977 .27752 L
.23077 .27752 L
.23177 .27752 L
.23277 .27752 L
.23377 .27752 L
.23477 .27752 L
.23576 .27752 L
.23676 .27752 L
.23776 .27752 L
.23876 .27752 L
.23976 .27752 L
.24076 .27752 L
.24176 .27752 L
.24276 .27752 L
.24376 .27752 L
.24476 .27752 L
.24575 .27752 L
.24675 .27752 L
.24775 .27752 L
.24875 .27752 L
Mistroke
.24975 .24457 L
.25075 .24457 L
.25175 .24457 L
.25275 .24457 L
.25375 .24457 L
.25475 .24457 L
.25574 .24457 L
.25674 .24457 L
.25774 .24457 L
.25874 .24457 L
.25974 .24457 L
.26074 .24457 L
.26174 .24457 L
.26274 .24457 L
.26374 .24457 L
.26474 .24457 L
.26573 .24457 L
.26673 .24457 L
.26773 .24457 L
.26873 .24457 L
.26973 .24457 L
.27073 .24457 L
.27173 .24457 L
.27273 .24457 L
.27373 .24457 L
.27473 .24457 L
.27572 .24457 L
.27672 .24457 L
.27772 .24457 L
.27872 .24457 L
.27972 .24457 L
.28072 .24457 L
.28172 .24457 L
.28272 .24457 L
.28372 .24457 L
.28472 .24457 L
.28571 .24457 L
.28671 .24457 L
.28771 .24457 L
.28871 .24457 L
.28971 .24457 L
.29071 .24457 L
.29171 .24457 L
.29271 .24457 L
.29371 .24457 L
.29471 .24457 L
.2957 .24457 L
.2967 .24457 L
.2977 .24457 L
.2987 .24457 L
Mistroke
.2997 .24361 L
.3007 .24361 L
.3017 .24361 L
.3027 .24361 L
.3037 .24361 L
.3047 .24361 L
.30569 .24361 L
.30669 .24361 L
.30769 .24361 L
.30869 .24361 L
.30969 .24361 L
.31069 .24361 L
.31169 .24361 L
.31269 .24361 L
.31369 .24361 L
.31469 .24361 L
.31568 .24361 L
.31668 .24361 L
.31768 .24361 L
.31868 .24361 L
.31968 .24361 L
.32068 .24361 L
.32168 .24361 L
.32268 .24361 L
.32368 .24361 L
.32468 .24361 L
.32567 .24361 L
.32667 .24361 L
.32767 .24361 L
.32867 .24361 L
.32967 .24361 L
.33067 .24361 L
.33167 .24361 L
.33267 .24361 L
.33367 .24361 L
.33467 .24361 L
.33566 .24361 L
.33666 .24361 L
.33766 .24361 L
.33866 .24361 L
.33966 .24361 L
.34066 .24361 L
.34166 .24361 L
.34266 .24361 L
.34366 .24361 L
.34466 .24361 L
.34565 .24361 L
.34665 .24361 L
.34765 .24361 L
.34865 .24361 L
Mistroke
.34965 .23896 L
.35065 .23896 L
.35165 .23896 L
.35265 .23896 L
.35365 .23896 L
.35465 .23896 L
.35564 .23896 L
.35664 .23896 L
.35764 .23896 L
.35864 .23896 L
.35964 .23896 L
.36064 .23896 L
.36164 .23896 L
.36264 .23896 L
.36364 .23896 L
.36464 .23896 L
.36563 .23896 L
.36663 .23896 L
.36763 .23896 L
.36863 .23896 L
.36963 .23896 L
.37063 .23896 L
.37163 .23896 L
.37263 .23896 L
.37363 .23896 L
.37463 .23896 L
.37562 .23896 L
.37662 .23896 L
.37762 .23896 L
.37862 .23896 L
.37962 .23896 L
.38062 .23896 L
.38162 .23896 L
.38262 .23896 L
.38362 .23896 L
.38462 .23896 L
.38561 .23896 L
.38661 .23896 L
.38761 .23896 L
.38861 .23896 L
.38961 .23896 L
.39061 .23896 L
.39161 .23896 L
.39261 .23896 L
.39361 .23896 L
.39461 .23896 L
.3956 .23896 L
.3966 .23896 L
.3976 .23896 L
.3986 .23896 L
Mistroke
.3996 .22244 L
.4006 .22244 L
.4016 .22244 L
.4026 .22244 L
.4036 .22244 L
.4046 .22244 L
.40559 .22244 L
.40659 .22244 L
.40759 .22244 L
.40859 .22244 L
.40959 .22244 L
.41059 .22244 L
.41159 .22244 L
.41259 .22244 L
.41359 .22244 L
.41459 .22244 L
.41558 .22244 L
.41658 .22244 L
.41758 .22244 L
.41858 .22244 L
.41958 .22244 L
.42058 .22244 L
.42158 .22244 L
.42258 .22244 L
.42358 .22244 L
.42458 .22244 L
.42557 .22244 L
.42657 .22244 L
.42757 .22244 L
.42857 .22244 L
.42957 .22244 L
.43057 .22244 L
.43157 .22244 L
.43257 .22244 L
.43357 .22244 L
.43457 .22244 L
.43556 .22244 L
.43656 .22244 L
.43756 .22244 L
.43856 .22244 L
.43956 .22244 L
.44056 .22244 L
.44156 .22244 L
.44256 .22244 L
.44356 .22244 L
.44456 .22244 L
.44555 .22244 L
.44655 .22244 L
.44755 .22244 L
.44855 .22244 L
Mistroke
.44955 .21412 L
.45055 .21412 L
.45155 .21412 L
.45255 .21412 L
.45355 .21412 L
.45455 .21412 L
.45554 .21412 L
.45654 .21412 L
.45754 .21412 L
.45854 .21412 L
.45954 .21412 L
.46054 .21412 L
.46154 .21412 L
.46254 .21412 L
.46354 .21412 L
.46454 .21412 L
.46553 .21412 L
.46653 .21412 L
.46753 .21412 L
.46853 .21412 L
.46953 .21412 L
.47053 .21412 L
.47153 .21412 L
.47253 .21412 L
.47353 .21412 L
.47453 .21412 L
.47552 .21412 L
.47652 .21412 L
.47752 .21412 L
.47852 .21412 L
.47952 .21412 L
.48052 .21412 L
.48152 .21412 L
.48252 .21412 L
.48352 .21412 L
.48452 .21412 L
.48551 .21412 L
.48651 .21412 L
.48751 .21412 L
.48851 .21412 L
.48951 .21412 L
.49051 .21412 L
.49151 .21412 L
.49251 .21412 L
.49351 .21412 L
.49451 .21412 L
.4955 .21412 L
.4965 .21412 L
.4975 .21412 L
.4985 .21412 L
Mistroke
.4995 .2225 L
.5005 .2225 L
.5015 .2225 L
.5025 .2225 L
.5035 .2225 L
.5045 .2225 L
.50549 .2225 L
.50649 .2225 L
.50749 .2225 L
.50849 .2225 L
.50949 .2225 L
.51049 .2225 L
.51149 .2225 L
.51249 .2225 L
.51349 .2225 L
.51449 .2225 L
.51548 .2225 L
.51648 .2225 L
.51748 .2225 L
.51848 .2225 L
.51948 .2225 L
.52048 .2225 L
.52148 .2225 L
.52248 .2225 L
.52348 .2225 L
.52448 .2225 L
.52547 .2225 L
.52647 .2225 L
.52747 .2225 L
.52847 .2225 L
.52947 .2225 L
.53047 .2225 L
.53147 .2225 L
.53247 .2225 L
.53347 .2225 L
.53447 .2225 L
.53546 .2225 L
.53646 .2225 L
.53746 .2225 L
.53846 .2225 L
.53946 .2225 L
.54046 .2225 L
.54146 .2225 L
.54246 .2225 L
.54346 .2225 L
.54446 .2225 L
.54545 .2225 L
.54645 .2225 L
.54745 .2225 L
.54845 .2225 L
Mistroke
.54945 .22502 L
.55045 .22502 L
.55145 .22502 L
.55245 .22502 L
.55345 .22502 L
.55445 .22502 L
.55544 .22502 L
.55644 .22502 L
.55744 .22502 L
.55844 .22502 L
.55944 .22502 L
.56044 .22502 L
.56144 .22502 L
.56244 .22502 L
.56344 .22502 L
.56444 .22502 L
.56543 .22502 L
.56643 .22502 L
.56743 .22502 L
.56843 .22502 L
.56943 .22502 L
.57043 .22502 L
.57143 .22502 L
.57243 .22502 L
.57343 .22502 L
.57443 .22502 L
.57542 .22502 L
.57642 .22502 L
.57742 .22502 L
.57842 .22502 L
.57942 .22502 L
.58042 .22502 L
.58142 .22502 L
.58242 .22502 L
.58342 .22502 L
.58442 .22502 L
.58541 .22502 L
.58641 .22502 L
.58741 .22502 L
.58841 .22502 L
.58941 .22502 L
.59041 .22502 L
.59141 .22502 L
.59241 .22502 L
.59341 .22502 L
.59441 .22502 L
.5954 .22502 L
.5964 .22502 L
.5974 .22502 L
.5984 .22502 L
Mistroke
.5994 .22317 L
.6004 .22317 L
.6014 .22317 L
.6024 .22317 L
.6034 .22317 L
.6044 .22317 L
.60539 .22317 L
.60639 .22317 L
.60739 .22317 L
.60839 .22317 L
.60939 .22317 L
.61039 .22317 L
.61139 .22317 L
.61239 .22317 L
.61339 .22317 L
.61439 .22317 L
.61538 .22317 L
.61638 .22317 L
.61738 .22317 L
.61838 .22317 L
.61938 .22317 L
.62038 .22317 L
.62138 .22317 L
.62238 .22317 L
.62338 .22317 L
.62438 .22317 L
.62537 .22317 L
.62637 .22317 L
.62737 .22317 L
.62837 .22317 L
.62937 .22317 L
.63037 .22317 L
.63137 .22317 L
.63237 .22317 L
.63337 .22317 L
.63437 .22317 L
.63536 .22317 L
.63636 .22317 L
.63736 .22317 L
.63836 .22317 L
.63936 .22317 L
.64036 .22317 L
.64136 .22317 L
.64236 .22317 L
.64336 .22317 L
.64436 .22317 L
.64535 .22317 L
.64635 .22317 L
.64735 .22317 L
.64835 .22317 L
Mistroke
.64935 .22379 L
.65035 .22379 L
.65135 .22379 L
.65235 .22379 L
.65335 .22379 L
.65435 .22379 L
.65534 .22379 L
.65634 .22379 L
.65734 .22379 L
.65834 .22379 L
.65934 .22379 L
.66034 .22379 L
.66134 .22379 L
.66234 .22379 L
.66334 .22379 L
.66434 .22379 L
.66533 .22379 L
.66633 .22379 L
.66733 .22379 L
.66833 .22379 L
.66933 .22379 L
.67033 .22379 L
.67133 .22379 L
.67233 .22379 L
.67333 .22379 L
.67433 .22379 L
.67532 .22379 L
.67632 .22379 L
.67732 .22379 L
.67832 .22379 L
.67932 .22379 L
.68032 .22379 L
.68132 .22379 L
.68232 .22379 L
.68332 .22379 L
.68432 .22379 L
.68531 .22379 L
.68631 .22379 L
.68731 .22379 L
.68831 .22379 L
.68931 .22379 L
.69031 .22379 L
.69131 .22379 L
.69231 .22379 L
.69331 .22379 L
.69431 .22379 L
.6953 .22379 L
.6963 .22379 L
.6973 .22379 L
.6983 .22379 L
Mistroke
.6993 .22305 L
.7003 .22305 L
.7013 .22305 L
.7023 .22305 L
.7033 .22305 L
.7043 .22305 L
.70529 .22305 L
.70629 .22305 L
.70729 .22305 L
.70829 .22305 L
.70929 .22305 L
.71029 .22305 L
.71129 .22305 L
.71229 .22305 L
.71329 .22305 L
.71429 .22305 L
.71528 .22305 L
.71628 .22305 L
.71728 .22305 L
.71828 .22305 L
.71928 .22305 L
.72028 .22305 L
.72128 .22305 L
.72228 .22305 L
.72328 .22305 L
.72428 .22305 L
.72527 .22305 L
.72627 .22305 L
.72727 .22305 L
.72827 .22305 L
.72927 .22305 L
.73027 .22305 L
.73127 .22305 L
.73227 .22305 L
.73327 .22305 L
.73427 .22305 L
.73526 .22305 L
.73626 .22305 L
.73726 .22305 L
.73826 .22305 L
.73926 .22305 L
.74026 .22305 L
.74126 .22305 L
.74226 .22305 L
.74326 .22305 L
.74426 .22305 L
.74525 .22305 L
.74625 .22305 L
.74725 .22305 L
.74825 .22305 L
Mistroke
.74925 .22417 L
.75025 .22417 L
.75125 .22417 L
.75225 .22417 L
.75325 .22417 L
.75425 .22417 L
.75524 .22417 L
.75624 .22417 L
.75724 .22417 L
.75824 .22417 L
.75924 .22417 L
.76024 .22417 L
.76124 .22417 L
.76224 .22417 L
.76324 .22417 L
.76424 .22417 L
.76523 .22417 L
.76623 .22417 L
.76723 .22417 L
.76823 .22417 L
.76923 .22417 L
.77023 .22417 L
.77123 .22417 L
.77223 .22417 L
.77323 .22417 L
.77423 .22417 L
.77522 .22417 L
.77622 .22417 L
.77722 .22417 L
.77822 .22417 L
.77922 .22417 L
.78022 .22417 L
.78122 .22417 L
.78222 .22417 L
.78322 .22417 L
.78422 .22417 L
.78521 .22417 L
.78621 .22417 L
.78721 .22417 L
.78821 .22417 L
.78921 .22417 L
.79021 .22417 L
.79121 .22417 L
.79221 .22417 L
.79321 .22417 L
.79421 .22417 L
.7952 .22417 L
.7962 .22417 L
.7972 .22417 L
.7982 .22417 L
Mistroke
.7992 .22313 L
.8002 .22313 L
.8012 .22313 L
.8022 .22313 L
.8032 .22313 L
.8042 .22313 L
.80519 .22313 L
.80619 .22313 L
.80719 .22313 L
.80819 .22313 L
.80919 .22313 L
.81019 .22313 L
.81119 .22313 L
.81219 .22313 L
.81319 .22313 L
.81419 .22313 L
.81518 .22313 L
.81618 .22313 L
.81718 .22313 L
.81818 .22313 L
.81918 .22313 L
.82018 .22313 L
.82118 .22313 L
.82218 .22313 L
.82318 .22313 L
.82418 .22313 L
.82517 .22313 L
.82617 .22313 L
.82717 .22313 L
.82817 .22313 L
.82917 .22313 L
.83017 .22313 L
.83117 .22313 L
.83217 .22313 L
.83317 .22313 L
.83417 .22313 L
.83516 .22313 L
.83616 .22313 L
.83716 .22313 L
.83816 .22313 L
.83916 .22313 L
.84016 .22313 L
.84116 .22313 L
.84216 .22313 L
.84316 .22313 L
.84416 .22313 L
.84515 .22313 L
.84615 .22313 L
.84715 .22313 L
.84815 .22313 L
Mistroke
.84915 .22585 L
.85015 .22585 L
.85115 .22585 L
.85215 .22585 L
.85315 .22585 L
.85415 .22585 L
.85514 .22585 L
.85614 .22585 L
.85714 .22585 L
.85814 .22585 L
.85914 .22585 L
.86014 .22585 L
.86114 .22585 L
.86214 .22585 L
.86314 .22585 L
.86414 .22585 L
.86513 .22585 L
.86613 .22585 L
.86713 .22585 L
.86813 .22585 L
.86913 .22585 L
.87013 .22585 L
.87113 .22585 L
.87213 .22585 L
.87313 .22585 L
.87413 .22585 L
.87512 .22585 L
.87612 .22585 L
.87712 .22585 L
.87812 .22585 L
.87912 .22585 L
.88012 .22585 L
.88112 .22585 L
.88212 .22585 L
.88312 .22585 L
.88412 .22585 L
.88511 .22585 L
.88611 .22585 L
.88711 .22585 L
.88811 .22585 L
.88911 .22585 L
.89011 .22585 L
.89111 .22585 L
.89211 .22585 L
.89311 .22585 L
.89411 .22585 L
.8951 .22585 L
.8961 .22585 L
.8971 .22585 L
.8981 .22585 L
Mistroke
.8991 .22605 L
.9001 .22605 L
.9011 .22605 L
.9021 .22605 L
.9031 .22605 L
.9041 .22605 L
.90509 .22605 L
.90609 .22605 L
.90709 .22605 L
.90809 .22605 L
.90909 .22605 L
.91009 .22605 L
.91109 .22605 L
.91209 .22605 L
.91309 .22605 L
.91409 .22605 L
.91508 .22605 L
.91608 .22605 L
.91708 .22605 L
.91808 .22605 L
.91908 .22605 L
.92008 .22605 L
.92108 .22605 L
.92208 .22605 L
.92308 .22605 L
.92408 .22605 L
.92507 .22605 L
.92607 .22605 L
.92707 .22605 L
.92807 .22605 L
.92907 .22605 L
.93007 .22605 L
.93107 .22605 L
.93207 .22605 L
.93307 .22605 L
.93407 .22605 L
.93506 .22605 L
.93606 .22605 L
.93706 .22605 L
.93806 .22605 L
.93906 .22605 L
.94006 .22605 L
.94106 .22605 L
.94206 .22605 L
.94306 .22605 L
.94406 .22605 L
.94505 .22605 L
.94605 .22605 L
.94705 .22605 L
.94805 .22605 L
Mistroke
.94905 .22626 L
.95005 .22626 L
.95105 .22626 L
.95205 .22626 L
.95305 .22626 L
.95405 .22626 L
.95504 .22626 L
.95604 .22626 L
.95704 .22626 L
.95804 .22626 L
.95904 .22626 L
.96004 .22626 L
.96104 .22626 L
.96204 .22626 L
.96304 .22626 L
.96404 .22626 L
.96503 .22626 L
.96603 .22626 L
.96703 .22626 L
.96803 .22626 L
.96903 .22626 L
.97003 .22626 L
.97103 .22626 L
.97203 .22626 L
.97303 .22626 L
.97403 .22626 L
.97502 .22626 L
.97602 .22626 L
.97702 .22626 L
.97802 .22626 L
.97902 .22626 L
.98002 .22626 L
.98102 .22626 L
.98202 .22626 L
.98302 .22626 L
.98402 .22626 L
.98501 .22626 L
.98601 .22626 L
.98701 .22626 L
.98801 .22626 L
.98901 .22626 L
.99001 .22626 L
.99101 .22626 L
.99201 .22626 L
.99301 .22626 L
.99401 .22626 L
.995 .22626 L
.996 .22626 L
.997 .22626 L
.998 .22626 L
Mistroke
.999 .22723 L
Mfstroke
1 0 0 r
gsave
.999 .21085 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .28327 m
.001 .28327 L
.002 .28327 L
.003 .28327 L
.004 .28327 L
.005 .28327 L
.00599 .28327 L
.00699 .28327 L
.00799 .28327 L
.00899 .28327 L
.00999 .28327 L
.01099 .28327 L
.01199 .28327 L
.01299 .28327 L
.01399 .28327 L
.01499 .28327 L
.01598 .28327 L
.01698 .28327 L
.01798 .28327 L
.01898 .28327 L
.01998 .28327 L
.02098 .28327 L
.02198 .28327 L
.02298 .28327 L
.02398 .28327 L
.02498 .28327 L
.02597 .28327 L
.02697 .28327 L
.02797 .28327 L
.02897 .28327 L
.02997 .28327 L
.03097 .28327 L
.03197 .28327 L
.03297 .28327 L
.03397 .28327 L
.03497 .28327 L
.03596 .28327 L
.03696 .28327 L
.03796 .28327 L
.03896 .28327 L
.03996 .28327 L
.04096 .28327 L
.04196 .28327 L
.04296 .28327 L
.04396 .28327 L
.04496 .28327 L
.04595 .28327 L
.04695 .28327 L
.04795 .28327 L
.04895 .28327 L
Mistroke
.04995 .23226 L
.05095 .23226 L
.05195 .23226 L
.05295 .23226 L
.05395 .23226 L
.05495 .23226 L
.05594 .23226 L
.05694 .23226 L
.05794 .23226 L
.05894 .23226 L
.05994 .23226 L
.06094 .23226 L
.06194 .23226 L
.06294 .23226 L
.06394 .23226 L
.06494 .23226 L
.06593 .23226 L
.06693 .23226 L
.06793 .23226 L
.06893 .23226 L
.06993 .23226 L
.07093 .23226 L
.07193 .23226 L
.07293 .23226 L
.07393 .23226 L
.07493 .23226 L
.07592 .23226 L
.07692 .23226 L
.07792 .23226 L
.07892 .23226 L
.07992 .23226 L
.08092 .23226 L
.08192 .23226 L
.08292 .23226 L
.08392 .23226 L
.08492 .23226 L
.08591 .23226 L
.08691 .23226 L
.08791 .23226 L
.08891 .23226 L
.08991 .23226 L
.09091 .23226 L
.09191 .23226 L
.09291 .23226 L
.09391 .23226 L
.09491 .23226 L
.0959 .23226 L
.0969 .23226 L
.0979 .23226 L
.0989 .23226 L
Mistroke
.0999 .21754 L
.1009 .21754 L
.1019 .21754 L
.1029 .21754 L
.1039 .21754 L
.1049 .21754 L
.10589 .21754 L
.10689 .21754 L
.10789 .21754 L
.10889 .21754 L
.10989 .21754 L
.11089 .21754 L
.11189 .21754 L
.11289 .21754 L
.11389 .21754 L
.11489 .21754 L
.11588 .21754 L
.11688 .21754 L
.11788 .21754 L
.11888 .21754 L
.11988 .21754 L
.12088 .21754 L
.12188 .21754 L
.12288 .21754 L
.12388 .21754 L
.12488 .21754 L
.12587 .21754 L
.12687 .21754 L
.12787 .21754 L
.12887 .21754 L
.12987 .21754 L
.13087 .21754 L
.13187 .21754 L
.13287 .21754 L
.13387 .21754 L
.13487 .21754 L
.13586 .21754 L
.13686 .21754 L
.13786 .21754 L
.13886 .21754 L
.13986 .21754 L
.14086 .21754 L
.14186 .21754 L
.14286 .21754 L
.14386 .21754 L
.14486 .21754 L
.14585 .21754 L
.14685 .21754 L
.14785 .21754 L
.14885 .21754 L
Mistroke
.14985 .24466 L
.15085 .24466 L
.15185 .24466 L
.15285 .24466 L
.15385 .24466 L
.15485 .24466 L
.15584 .24466 L
.15684 .24466 L
.15784 .24466 L
.15884 .24466 L
.15984 .24466 L
.16084 .24466 L
.16184 .24466 L
.16284 .24466 L
.16384 .24466 L
.16484 .24466 L
.16583 .24466 L
.16683 .24466 L
.16783 .24466 L
.16883 .24466 L
.16983 .24466 L
.17083 .24466 L
.17183 .24466 L
.17283 .24466 L
.17383 .24466 L
.17483 .24466 L
.17582 .24466 L
.17682 .24466 L
.17782 .24466 L
.17882 .24466 L
.17982 .24466 L
.18082 .24466 L
.18182 .24466 L
.18282 .24466 L
.18382 .24466 L
.18482 .24466 L
.18581 .24466 L
.18681 .24466 L
.18781 .24466 L
.18881 .24466 L
.18981 .24466 L
.19081 .24466 L
.19181 .24466 L
.19281 .24466 L
.19381 .24466 L
.19481 .24466 L
.1958 .24466 L
.1968 .24466 L
.1978 .24466 L
.1988 .24466 L
Mistroke
.1998 .23622 L
.2008 .23622 L
.2018 .23622 L
.2028 .23622 L
.2038 .23622 L
.2048 .23622 L
.20579 .23622 L
.20679 .23622 L
.20779 .23622 L
.20879 .23622 L
.20979 .23622 L
.21079 .23622 L
.21179 .23622 L
.21279 .23622 L
.21379 .23622 L
.21479 .23622 L
.21578 .23622 L
.21678 .23622 L
.21778 .23622 L
.21878 .23622 L
.21978 .23622 L
.22078 .23622 L
.22178 .23622 L
.22278 .23622 L
.22378 .23622 L
.22478 .23622 L
.22577 .23622 L
.22677 .23622 L
.22777 .23622 L
.22877 .23622 L
.22977 .23622 L
.23077 .23622 L
.23177 .23622 L
.23277 .23622 L
.23377 .23622 L
.23477 .23622 L
.23576 .23622 L
.23676 .23622 L
.23776 .23622 L
.23876 .23622 L
.23976 .23622 L
.24076 .23622 L
.24176 .23622 L
.24276 .23622 L
.24376 .23622 L
.24476 .23622 L
.24575 .23622 L
.24675 .23622 L
.24775 .23622 L
.24875 .23622 L
Mistroke
.24975 .21246 L
.25075 .21246 L
.25175 .21246 L
.25275 .21246 L
.25375 .21246 L
.25475 .21246 L
.25574 .21246 L
.25674 .21246 L
.25774 .21246 L
.25874 .21246 L
.25974 .21246 L
.26074 .21246 L
.26174 .21246 L
.26274 .21246 L
.26374 .21246 L
.26474 .21246 L
.26573 .21246 L
.26673 .21246 L
.26773 .21246 L
.26873 .21246 L
.26973 .21246 L
.27073 .21246 L
.27173 .21246 L
.27273 .21246 L
.27373 .21246 L
.27473 .21246 L
.27572 .21246 L
.27672 .21246 L
.27772 .21246 L
.27872 .21246 L
.27972 .21246 L
.28072 .21246 L
.28172 .21246 L
.28272 .21246 L
.28372 .21246 L
.28472 .21246 L
.28571 .21246 L
.28671 .21246 L
.28771 .21246 L
.28871 .21246 L
.28971 .21246 L
.29071 .21246 L
.29171 .21246 L
.29271 .21246 L
.29371 .21246 L
.29471 .21246 L
.2957 .21246 L
.2967 .21246 L
.2977 .21246 L
.2987 .21246 L
Mistroke
.2997 .21246 L
.3007 .21246 L
.3017 .21246 L
.3027 .21246 L
.3037 .21246 L
.3047 .21246 L
.30569 .21246 L
.30669 .21246 L
.30769 .21246 L
.30869 .21246 L
.30969 .21246 L
.31069 .21246 L
.31169 .21246 L
.31269 .21246 L
.31369 .21246 L
.31469 .21246 L
.31568 .21246 L
.31668 .21246 L
.31768 .21246 L
.31868 .21246 L
.31968 .21246 L
.32068 .21246 L
.32168 .21246 L
.32268 .21246 L
.32368 .21246 L
.32468 .21246 L
.32567 .21246 L
.32667 .21246 L
.32767 .21246 L
.32867 .21246 L
.32967 .21246 L
.33067 .21246 L
.33167 .21246 L
.33267 .21246 L
.33367 .21246 L
.33467 .21246 L
.33566 .21246 L
.33666 .21246 L
.33766 .21246 L
.33866 .21246 L
.33966 .21246 L
.34066 .21246 L
.34166 .21246 L
.34266 .21246 L
.34366 .21246 L
.34466 .21246 L
.34565 .21246 L
.34665 .21246 L
.34765 .21246 L
.34865 .21246 L
Mistroke
.34965 .20874 L
.35065 .20874 L
.35165 .20874 L
.35265 .20874 L
.35365 .20874 L
.35465 .20874 L
.35564 .20874 L
.35664 .20874 L
.35764 .20874 L
.35864 .20874 L
.35964 .20874 L
.36064 .20874 L
.36164 .20874 L
.36264 .20874 L
.36364 .20874 L
.36464 .20874 L
.36563 .20874 L
.36663 .20874 L
.36763 .20874 L
.36863 .20874 L
.36963 .20874 L
.37063 .20874 L
.37163 .20874 L
.37263 .20874 L
.37363 .20874 L
.37463 .20874 L
.37562 .20874 L
.37662 .20874 L
.37762 .20874 L
.37862 .20874 L
.37962 .20874 L
.38062 .20874 L
.38162 .20874 L
.38262 .20874 L
.38362 .20874 L
.38462 .20874 L
.38561 .20874 L
.38661 .20874 L
.38761 .20874 L
.38861 .20874 L
.38961 .20874 L
.39061 .20874 L
.39161 .20874 L
.39261 .20874 L
.39361 .20874 L
.39461 .20874 L
.3956 .20874 L
.3966 .20874 L
.3976 .20874 L
.3986 .20874 L
Mistroke
.3996 .19512 L
.4006 .19512 L
.4016 .19512 L
.4026 .19512 L
.4036 .19512 L
.4046 .19512 L
.40559 .19512 L
.40659 .19512 L
.40759 .19512 L
.40859 .19512 L
.40959 .19512 L
.41059 .19512 L
.41159 .19512 L
.41259 .19512 L
.41359 .19512 L
.41459 .19512 L
.41558 .19512 L
.41658 .19512 L
.41758 .19512 L
.41858 .19512 L
.41958 .19512 L
.42058 .19512 L
.42158 .19512 L
.42258 .19512 L
.42358 .19512 L
.42458 .19512 L
.42557 .19512 L
.42657 .19512 L
.42757 .19512 L
.42857 .19512 L
.42957 .19512 L
.43057 .19512 L
.43157 .19512 L
.43257 .19512 L
.43357 .19512 L
.43457 .19512 L
.43556 .19512 L
.43656 .19512 L
.43756 .19512 L
.43856 .19512 L
.43956 .19512 L
.44056 .19512 L
.44156 .19512 L
.44256 .19512 L
.44356 .19512 L
.44456 .19512 L
.44555 .19512 L
.44655 .19512 L
.44755 .19512 L
.44855 .19512 L
Mistroke
.44955 .18918 L
.45055 .18918 L
.45155 .18918 L
.45255 .18918 L
.45355 .18918 L
.45455 .18918 L
.45554 .18918 L
.45654 .18918 L
.45754 .18918 L
.45854 .18918 L
.45954 .18918 L
.46054 .18918 L
.46154 .18918 L
.46254 .18918 L
.46354 .18918 L
.46454 .18918 L
.46553 .18918 L
.46653 .18918 L
.46753 .18918 L
.46853 .18918 L
.46953 .18918 L
.47053 .18918 L
.47153 .18918 L
.47253 .18918 L
.47353 .18918 L
.47453 .18918 L
.47552 .18918 L
.47652 .18918 L
.47752 .18918 L
.47852 .18918 L
.47952 .18918 L
.48052 .18918 L
.48152 .18918 L
.48252 .18918 L
.48352 .18918 L
.48452 .18918 L
.48551 .18918 L
.48651 .18918 L
.48751 .18918 L
.48851 .18918 L
.48951 .18918 L
.49051 .18918 L
.49151 .18918 L
.49251 .18918 L
.49351 .18918 L
.49451 .18918 L
.4955 .18918 L
.4965 .18918 L
.4975 .18918 L
.4985 .18918 L
Mistroke
.4995 .19842 L
.5005 .19842 L
.5015 .19842 L
.5025 .19842 L
.5035 .19842 L
.5045 .19842 L
.50549 .19842 L
.50649 .19842 L
.50749 .19842 L
.50849 .19842 L
.50949 .19842 L
.51049 .19842 L
.51149 .19842 L
.51249 .19842 L
.51349 .19842 L
.51449 .19842 L
.51548 .19842 L
.51648 .19842 L
.51748 .19842 L
.51848 .19842 L
.51948 .19842 L
.52048 .19842 L
.52148 .19842 L
.52248 .19842 L
.52348 .19842 L
.52448 .19842 L
.52547 .19842 L
.52647 .19842 L
.52747 .19842 L
.52847 .19842 L
.52947 .19842 L
.53047 .19842 L
.53147 .19842 L
.53247 .19842 L
.53347 .19842 L
.53447 .19842 L
.53546 .19842 L
.53646 .19842 L
.53746 .19842 L
.53846 .19842 L
.53946 .19842 L
.54046 .19842 L
.54146 .19842 L
.54246 .19842 L
.54346 .19842 L
.54446 .19842 L
.54545 .19842 L
.54645 .19842 L
.54745 .19842 L
.54845 .19842 L
Mistroke
.54945 .20221 L
.55045 .20221 L
.55145 .20221 L
.55245 .20221 L
.55345 .20221 L
.55445 .20221 L
.55544 .20221 L
.55644 .20221 L
.55744 .20221 L
.55844 .20221 L
.55944 .20221 L
.56044 .20221 L
.56144 .20221 L
.56244 .20221 L
.56344 .20221 L
.56444 .20221 L
.56543 .20221 L
.56643 .20221 L
.56743 .20221 L
.56843 .20221 L
.56943 .20221 L
.57043 .20221 L
.57143 .20221 L
.57243 .20221 L
.57343 .20221 L
.57443 .20221 L
.57542 .20221 L
.57642 .20221 L
.57742 .20221 L
.57842 .20221 L
.57942 .20221 L
.58042 .20221 L
.58142 .20221 L
.58242 .20221 L
.58342 .20221 L
.58442 .20221 L
.58541 .20221 L
.58641 .20221 L
.58741 .20221 L
.58841 .20221 L
.58941 .20221 L
.59041 .20221 L
.59141 .20221 L
.59241 .20221 L
.59341 .20221 L
.59441 .20221 L
.5954 .20221 L
.5964 .20221 L
.5974 .20221 L
.5984 .20221 L
Mistroke
.5994 .20219 L
.6004 .20219 L
.6014 .20219 L
.6024 .20219 L
.6034 .20219 L
.6044 .20219 L
.60539 .20219 L
.60639 .20219 L
.60739 .20219 L
.60839 .20219 L
.60939 .20219 L
.61039 .20219 L
.61139 .20219 L
.61239 .20219 L
.61339 .20219 L
.61439 .20219 L
.61538 .20219 L
.61638 .20219 L
.61738 .20219 L
.61838 .20219 L
.61938 .20219 L
.62038 .20219 L
.62138 .20219 L
.62238 .20219 L
.62338 .20219 L
.62438 .20219 L
.62537 .20219 L
.62637 .20219 L
.62737 .20219 L
.62837 .20219 L
.62937 .20219 L
.63037 .20219 L
.63137 .20219 L
.63237 .20219 L
.63337 .20219 L
.63437 .20219 L
.63536 .20219 L
.63636 .20219 L
.63736 .20219 L
.63836 .20219 L
.63936 .20219 L
.64036 .20219 L
.64136 .20219 L
.64236 .20219 L
.64336 .20219 L
.64436 .20219 L
.64535 .20219 L
.64635 .20219 L
.64735 .20219 L
.64835 .20219 L
Mistroke
.64935 .20302 L
.65035 .20302 L
.65135 .20302 L
.65235 .20302 L
.65335 .20302 L
.65435 .20302 L
.65534 .20302 L
.65634 .20302 L
.65734 .20302 L
.65834 .20302 L
.65934 .20302 L
.66034 .20302 L
.66134 .20302 L
.66234 .20302 L
.66334 .20302 L
.66434 .20302 L
.66533 .20302 L
.66633 .20302 L
.66733 .20302 L
.66833 .20302 L
.66933 .20302 L
.67033 .20302 L
.67133 .20302 L
.67233 .20302 L
.67333 .20302 L
.67433 .20302 L
.67532 .20302 L
.67632 .20302 L
.67732 .20302 L
.67832 .20302 L
.67932 .20302 L
.68032 .20302 L
.68132 .20302 L
.68232 .20302 L
.68332 .20302 L
.68432 .20302 L
.68531 .20302 L
.68631 .20302 L
.68731 .20302 L
.68831 .20302 L
.68931 .20302 L
.69031 .20302 L
.69131 .20302 L
.69231 .20302 L
.69331 .20302 L
.69431 .20302 L
.6953 .20302 L
.6963 .20302 L
.6973 .20302 L
.6983 .20302 L
Mistroke
.6993 .20253 L
.7003 .20253 L
.7013 .20253 L
.7023 .20253 L
.7033 .20253 L
.7043 .20253 L
.70529 .20253 L
.70629 .20253 L
.70729 .20253 L
.70829 .20253 L
.70929 .20253 L
.71029 .20253 L
.71129 .20253 L
.71229 .20253 L
.71329 .20253 L
.71429 .20253 L
.71528 .20253 L
.71628 .20253 L
.71728 .20253 L
.71828 .20253 L
.71928 .20253 L
.72028 .20253 L
.72128 .20253 L
.72228 .20253 L
.72328 .20253 L
.72428 .20253 L
.72527 .20253 L
.72627 .20253 L
.72727 .20253 L
.72827 .20253 L
.72927 .20253 L
.73027 .20253 L
.73127 .20253 L
.73227 .20253 L
.73327 .20253 L
.73427 .20253 L
.73526 .20253 L
.73626 .20253 L
.73726 .20253 L
.73826 .20253 L
.73926 .20253 L
.74026 .20253 L
.74126 .20253 L
.74226 .20253 L
.74326 .20253 L
.74426 .20253 L
.74525 .20253 L
.74625 .20253 L
.74725 .20253 L
.74825 .20253 L
Mistroke
.74925 .20389 L
.75025 .20389 L
.75125 .20389 L
.75225 .20389 L
.75325 .20389 L
.75425 .20389 L
.75524 .20389 L
.75624 .20389 L
.75724 .20389 L
.75824 .20389 L
.75924 .20389 L
.76024 .20389 L
.76124 .20389 L
.76224 .20389 L
.76324 .20389 L
.76424 .20389 L
.76523 .20389 L
.76623 .20389 L
.76723 .20389 L
.76823 .20389 L
.76923 .20389 L
.77023 .20389 L
.77123 .20389 L
.77223 .20389 L
.77323 .20389 L
.77423 .20389 L
.77522 .20389 L
.77622 .20389 L
.77722 .20389 L
.77822 .20389 L
.77922 .20389 L
.78022 .20389 L
.78122 .20389 L
.78222 .20389 L
.78322 .20389 L
.78422 .20389 L
.78521 .20389 L
.78621 .20389 L
.78721 .20389 L
.78821 .20389 L
.78921 .20389 L
.79021 .20389 L
.79121 .20389 L
.79221 .20389 L
.79321 .20389 L
.79421 .20389 L
.7952 .20389 L
.7962 .20389 L
.7972 .20389 L
.7982 .20389 L
Mistroke
.7992 .2045 L
.8002 .2045 L
.8012 .2045 L
.8022 .2045 L
.8032 .2045 L
.8042 .2045 L
.80519 .2045 L
.80619 .2045 L
.80719 .2045 L
.80819 .2045 L
.80919 .2045 L
.81019 .2045 L
.81119 .2045 L
.81219 .2045 L
.81319 .2045 L
.81419 .2045 L
.81518 .2045 L
.81618 .2045 L
.81718 .2045 L
.81818 .2045 L
.81918 .2045 L
.82018 .2045 L
.82118 .2045 L
.82218 .2045 L
.82318 .2045 L
.82418 .2045 L
.82517 .2045 L
.82617 .2045 L
.82717 .2045 L
.82817 .2045 L
.82917 .2045 L
.83017 .2045 L
.83117 .2045 L
.83217 .2045 L
.83317 .2045 L
.83417 .2045 L
.83516 .2045 L
.83616 .2045 L
.83716 .2045 L
.83816 .2045 L
.83916 .2045 L
.84016 .2045 L
.84116 .2045 L
.84216 .2045 L
.84316 .2045 L
.84416 .2045 L
.84515 .2045 L
.84615 .2045 L
.84715 .2045 L
.84815 .2045 L
Mistroke
.84915 .20753 L
.85015 .20753 L
.85115 .20753 L
.85215 .20753 L
.85315 .20753 L
.85415 .20753 L
.85514 .20753 L
.85614 .20753 L
.85714 .20753 L
.85814 .20753 L
.85914 .20753 L
.86014 .20753 L
.86114 .20753 L
.86214 .20753 L
.86314 .20753 L
.86414 .20753 L
.86513 .20753 L
.86613 .20753 L
.86713 .20753 L
.86813 .20753 L
.86913 .20753 L
.87013 .20753 L
.87113 .20753 L
.87213 .20753 L
.87313 .20753 L
.87413 .20753 L
.87512 .20753 L
.87612 .20753 L
.87712 .20753 L
.87812 .20753 L
.87912 .20753 L
.88012 .20753 L
.88112 .20753 L
.88212 .20753 L
.88312 .20753 L
.88412 .20753 L
.88511 .20753 L
.88611 .20753 L
.88711 .20753 L
.88811 .20753 L
.88911 .20753 L
.89011 .20753 L
.89111 .20753 L
.89211 .20753 L
.89311 .20753 L
.89411 .20753 L
.8951 .20753 L
.8961 .20753 L
.8971 .20753 L
.8981 .20753 L
Mistroke
.8991 .20863 L
.9001 .20863 L
.9011 .20863 L
.9021 .20863 L
.9031 .20863 L
.9041 .20863 L
.90509 .20863 L
.90609 .20863 L
.90709 .20863 L
.90809 .20863 L
.90909 .20863 L
.91009 .20863 L
.91109 .20863 L
.91209 .20863 L
.91309 .20863 L
.91409 .20863 L
.91508 .20863 L
.91608 .20863 L
.91708 .20863 L
.91808 .20863 L
.91908 .20863 L
.92008 .20863 L
.92108 .20863 L
.92208 .20863 L
.92308 .20863 L
.92408 .20863 L
.92507 .20863 L
.92607 .20863 L
.92707 .20863 L
.92807 .20863 L
.92907 .20863 L
.93007 .20863 L
.93107 .20863 L
.93207 .20863 L
.93307 .20863 L
.93407 .20863 L
.93506 .20863 L
.93606 .20863 L
.93706 .20863 L
.93806 .20863 L
.93906 .20863 L
.94006 .20863 L
.94106 .20863 L
.94206 .20863 L
.94306 .20863 L
.94406 .20863 L
.94505 .20863 L
.94605 .20863 L
.94705 .20863 L
.94805 .20863 L
Mistroke
.94905 .20973 L
.95005 .20973 L
.95105 .20973 L
.95205 .20973 L
.95305 .20973 L
.95405 .20973 L
.95504 .20973 L
.95604 .20973 L
.95704 .20973 L
.95804 .20973 L
.95904 .20973 L
.96004 .20973 L
.96104 .20973 L
.96204 .20973 L
.96304 .20973 L
.96404 .20973 L
.96503 .20973 L
.96603 .20973 L
.96703 .20973 L
.96803 .20973 L
.96903 .20973 L
.97003 .20973 L
.97103 .20973 L
.97203 .20973 L
.97303 .20973 L
.97403 .20973 L
.97502 .20973 L
.97602 .20973 L
.97702 .20973 L
.97802 .20973 L
.97902 .20973 L
.98002 .20973 L
.98102 .20973 L
.98202 .20973 L
.98302 .20973 L
.98402 .20973 L
.98501 .20973 L
.98601 .20973 L
.98701 .20973 L
.98801 .20973 L
.98901 .20973 L
.99001 .20973 L
.99101 .20973 L
.99201 .20973 L
.99301 .20973 L
.99401 .20973 L
.995 .20973 L
.996 .20973 L
.997 .20973 L
.998 .20973 L
Mistroke
.999 .21085 L
Mfstroke
0 0 1 r
gsave
.001 -0.38627 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .3062 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .34801 L
.005 .34586 L
.00599 .34349 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33052 L
.01099 .32611 L
.01199 .3211 L
.01299 .31543 L
.01399 .30901 L
.01499 .30175 L
.01598 .29356 L
.01698 .28434 L
.01798 .27396 L
.01898 .26231 L
.01998 .24926 L
.02098 .23466 L
.02198 .21838 L
.02298 .20028 L
.02398 .18024 L
.02498 .15815 L
.02597 .13396 L
.02697 .10766 L
.02797 .07935 L
.02897 .04924 L
.02997 .01773 L
s
.02997 .01773 m
.03052 0 L
s
.04434 0 m
.04496 .02719 L
.04595 .07269 L
.04695 .11755 L
.04795 .1592 L
.04895 .19455 L
.04995 .1023 L
.05095 .08922 L
.05195 .08239 L
.05295 .0819 L
.05395 .08793 L
.05495 .10021 L
.05594 .11787 L
.05694 .13975 L
.05794 .1646 L
.05894 .19119 L
.05994 .2184 L
.06094 .24519 L
.06194 .27079 L
.06294 .29464 L
.06394 .31643 L
.06494 .33607 L
.06593 .35363 L
.06693 .36927 L
.06793 .38322 L
.06893 .39571 L
.06993 .40695 L
.07093 .4171 L
.07193 .42622 L
.07293 .43422 L
.07393 .44077 L
.07493 .44527 L
.07592 .44685 L
.07692 .44477 L
.07792 .43902 L
.07892 .43027 L
.07992 .41946 L
.08092 .40742 L
.08192 .39476 L
.08292 .38197 L
.08392 .36941 L
.08492 .35732 L
.08591 .34591 L
.08691 .3353 L
.08791 .32558 L
.08891 .3168 L
.08991 .30896 L
.09091 .30205 L
.09191 .29603 L
.09291 .29086 L
Mistroke
.09391 .28646 L
.09491 .28277 L
.0959 .2797 L
.0969 .27717 L
.0979 .27509 L
.0989 .27337 L
.0999 .39798 L
.1009 .39271 L
.1019 .38947 L
.1029 .38719 L
.1039 .38551 L
.1049 .38424 L
.10589 .38327 L
.10689 .38253 L
.10789 .38198 L
.10889 .38159 L
.10989 .38134 L
.11089 .38122 L
.11189 .38122 L
.11289 .38132 L
.11389 .38153 L
.11489 .38185 L
.11588 .38227 L
.11688 .3828 L
.11788 .38345 L
.11888 .38422 L
.11988 .38513 L
.12088 .3862 L
.12188 .38743 L
.12288 .38887 L
.12388 .39054 L
.12488 .39247 L
.12587 .39472 L
.12687 .39734 L
.12787 .40038 L
.12887 .40391 L
.12987 .40802 L
.13087 .41277 L
.13187 .41825 L
.13287 .42453 L
.13387 .43166 L
.13487 .43964 L
.13586 .44842 L
.13686 .45784 L
.13786 .46754 L
.13886 .47689 L
.13986 .4848 L
.14086 .48962 L
.14186 .48944 L
.14286 .48329 L
Mistroke
.14386 .47186 L
.14486 .45682 L
.14585 .43977 L
.14685 .42199 L
.14785 .40445 L
.14885 .38785 L
.14985 .55474 L
.15085 .53582 L
.15185 .51754 L
.15285 .49941 L
.15385 .48155 L
.15485 .46424 L
.15584 .44772 L
.15684 .4322 L
.15784 .41782 L
.15884 .40464 L
.15984 .39268 L
.16084 .38189 L
.16184 .3722 L
.16284 .36352 L
.16384 .35575 L
.16484 .34877 L
.16583 .34249 L
.16683 .3368 L
.16783 .33159 L
.16883 .32678 L
.16983 .32228 L
.17083 .31801 L
.17183 .31389 L
.17283 .30985 L
.17383 .30584 L
.17483 .3018 L
.17582 .29766 L
.17682 .29339 L
.17782 .28893 L
.17882 .28424 L
.17982 .27928 L
.18082 .27402 L
.18182 .26841 L
.18282 .26243 L
.18382 .25604 L
.18482 .24923 L
.18581 .24197 L
.18681 .23425 L
.18781 .22606 L
.18881 .21741 L
.18981 .20831 L
.19081 .19879 L
.19181 .18891 L
.19281 .17871 L
Mistroke
.19381 .16831 L
.19481 .15781 L
.1958 .14735 L
.1968 .13711 L
.1978 .12728 L
.1988 .11809 L
.1998 .27768 L
.2008 .26326 L
.2018 .25076 L
.2028 .23905 L
.2038 .22776 L
.2048 .21673 L
.20579 .20594 L
.20679 .19543 L
.20779 .18535 L
.20879 .17587 L
.20979 .16722 L
.21079 .1597 L
.21179 .15357 L
.21279 .14912 L
.21379 .14658 L
.21479 .14607 L
.21578 .14763 L
.21678 .15113 L
.21778 .15634 L
.21878 .16298 L
.21978 .17077 L
.22078 .1795 L
.22178 .18903 L
.22278 .1992 L
.22378 .20983 L
.22478 .22074 L
.22577 .2317 L
.22677 .2425 L
.22777 .25294 L
.22877 .26285 L
.22977 .27211 L
.23077 .28062 L
.23177 .28831 L
.23277 .29516 L
.23377 .30118 L
.23477 .30638 L
.23576 .31081 L
.23676 .31451 L
.23776 .31753 L
.23876 .31994 L
.23976 .32178 L
.24076 .3231 L
.24176 .32396 L
.24276 .32439 L
Mistroke
.24376 .32442 L
.24476 .3241 L
.24575 .32344 L
.24675 .32247 L
.24775 .3212 L
.24875 .31964 L
.24975 .44579 L
.25075 .44357 L
.25175 .44329 L
.25275 .44384 L
.25375 .44489 L
.25475 .44625 L
.25574 .44784 L
.25674 .44959 L
.25774 .45147 L
.25874 .45344 L
.25974 .45549 L
.26074 .45759 L
.26174 .45971 L
.26274 .46185 L
.26374 .46398 L
.26474 .46607 L
.26573 .4681 L
.26673 .47003 L
.26773 .47181 L
.26873 .47341 L
.26973 .47477 L
.27073 .47583 L
.27173 .47651 L
.27273 .47675 L
.27373 .47646 L
.27473 .47556 L
.27572 .474 L
.27672 .47173 L
.27772 .46873 L
.27872 .46501 L
.27972 .46063 L
.28072 .45569 L
.28172 .45029 L
.28272 .44455 L
.28372 .43861 L
.28472 .4326 L
.28571 .42662 L
.28671 .42077 L
.28771 .41513 L
.28871 .40975 L
.28971 .40468 L
.29071 .39993 L
.29171 .39553 L
.29271 .39148 L
Mistroke
.29371 .38776 L
.29471 .38436 L
.2957 .38127 L
.2967 .37847 L
.2977 .37593 L
.2987 .37363 L
.2997 .41535 L
.3007 .41073 L
.3017 .40812 L
.3027 .40644 L
.3037 .40535 L
.3047 .40467 L
.30569 .4043 L
.30669 .40419 L
.30769 .40431 L
.30869 .40463 L
.30969 .40514 L
.31069 .40583 L
.31169 .4067 L
.31269 .40776 L
.31369 .40899 L
.31469 .41042 L
.31568 .41204 L
.31668 .41387 L
.31768 .41592 L
.31868 .41819 L
.31968 .42071 L
.32068 .42348 L
.32168 .42653 L
.32268 .42988 L
.32368 .43353 L
.32468 .43751 L
.32567 .44181 L
.32667 .44644 L
.32767 .45139 L
.32867 .45662 L
.32967 .46207 L
.33067 .46763 L
.33167 .47315 L
.33267 .47838 L
.33367 .48301 L
.33467 .4866 L
.33566 .48865 L
.33666 .48865 L
.33766 .48629 L
.33866 .48153 L
.33966 .47465 L
.34066 .4661 L
.34166 .45641 L
.34266 .44608 L
Mistroke
.34366 .43552 L
.34466 .42508 L
.34565 .41505 L
.34665 .40559 L
.34765 .39683 L
.34865 .38883 L
.34965 .50779 L
.35065 .49711 L
.35165 .48758 L
.35265 .47835 L
.35365 .46923 L
.35465 .46023 L
.35564 .45138 L
.35664 .44276 L
.35764 .43445 L
.35864 .42649 L
.35964 .41896 L
.36064 .41188 L
.36164 .40528 L
.36264 .39916 L
.36364 .39353 L
.36464 .38837 L
.36563 .38365 L
.36663 .37935 L
.36763 .37544 L
.36863 .37189 L
.36963 .36865 L
.37063 .3657 L
.37163 .36299 L
.37263 .3605 L
.37363 .35819 L
.37463 .35604 L
.37562 .354 L
.37662 .35205 L
.37762 .35017 L
.37862 .34834 L
.37962 .34652 L
.38062 .3447 L
.38162 .34286 L
.38262 .34098 L
.38362 .33904 L
.38462 .33703 L
.38561 .33492 L
.38661 .33272 L
.38761 .3304 L
.38861 .32796 L
.38961 .32538 L
.39061 .32266 L
.39161 .3198 L
.39261 .3168 L
Mistroke
.39361 .31364 L
.39461 .31035 L
.3956 .30693 L
.3966 .3034 L
.3976 .29978 L
.3986 .29609 L
.3996 .31764 L
.4006 .31163 L
.4016 .30678 L
.4026 .30201 L
.4036 .29701 L
.4046 .2916 L
.40559 .2857 L
.40659 .27926 L
.40759 .27223 L
.40859 .26459 L
.40959 .25632 L
.41059 .24743 L
.41159 .23792 L
.41259 .22784 L
.41359 .21725 L
.41459 .20625 L
.41558 .19498 L
.41658 .18365 L
.41758 .1725 L
.41858 .16185 L
.41958 .15207 L
.42058 .14355 L
.42158 .13672 L
.42258 .13194 L
.42358 .12945 L
.42458 .1292 L
.42557 .1307 L
.42657 .13295 L
.42757 .13483 L
.42857 .13607 L
.42957 .13745 L
.43057 .14003 L
.43157 .14462 L
.43257 .1516 L
.43357 .16105 L
.43457 .17274 L
.43556 .18628 L
.43656 .20115 L
.43756 .21679 L
.43856 .23267 L
.43956 .24831 L
.44056 .26331 L
.44156 .2774 L
.44256 .29037 L
Mistroke
.44356 .30213 L
.44456 .31264 L
.44555 .32192 L
.44655 .33005 L
.44755 .3371 L
.44855 .34319 L
.44955 .39715 L
.45055 .39817 L
.45155 .40019 L
.45255 .4023 L
.45355 .40427 L
.45455 .40601 L
.45554 .40749 L
.45654 .40873 L
.45754 .40973 L
.45854 .41054 L
.45954 .41118 L
.46054 .41169 L
.46154 .4121 L
.46254 .41244 L
.46354 .41273 L
.46454 .41299 L
.46553 .41326 L
.46653 .41355 L
.46753 .41387 L
.46853 .41425 L
.46953 .41468 L
.47053 .41519 L
.47153 .41577 L
.47253 .41645 L
.47353 .41723 L
.47453 .41811 L
.47552 .41909 L
.47652 .42018 L
.47752 .42139 L
.47852 .4227 L
.47952 .42412 L
.48052 .42565 L
.48152 .42727 L
.48252 .42897 L
.48352 .43075 L
.48452 .43256 L
.48551 .43439 L
.48651 .43621 L
.48751 .43797 L
.48851 .43962 L
.48951 .4411 L
.49051 .44236 L
.49151 .44333 L
.49251 .44394 L
Mistroke
.49351 .44415 L
.49451 .44389 L
.4955 .44314 L
.4965 .44189 L
.4975 .44015 L
.4985 .43794 L
.4995 .53685 L
.5005 .5244 L
.5015 .51271 L
.5025 .50095 L
.5035 .489 L
.5045 .47694 L
.50549 .46489 L
.50649 .45303 L
.50749 .4415 L
.50849 .43042 L
.50949 .41991 L
.51049 .41004 L
.51149 .40085 L
.51249 .39235 L
.51349 .38454 L
.51449 .3774 L
.51548 .37089 L
.51648 .36496 L
.51748 .35957 L
.51848 .35466 L
.51948 .35016 L
.52048 .34604 L
.52148 .34223 L
.52248 .33868 L
.52348 .33533 L
.52448 .33215 L
.52547 .32908 L
.52647 .32608 L
.52747 .32312 L
.52847 .32014 L
.52947 .31712 L
.53047 .31401 L
.53147 .3108 L
.53247 .30743 L
.53347 .30387 L
.53447 .30011 L
.53546 .2961 L
.53646 .29181 L
.53746 .28721 L
.53846 .28227 L
.53946 .27696 L
.54046 .27124 L
.54146 .26507 L
.54246 .25844 L
Mistroke
.54346 .25129 L
.54446 .24361 L
.54545 .23536 L
.54645 .22652 L
.54745 .21706 L
.54845 .20696 L
.54945 .40681 L
.55045 .40832 L
.55145 .41153 L
.55245 .41545 L
.55345 .4198 L
.55445 .4245 L
.55544 .42951 L
.55644 .43484 L
.55744 .44049 L
.55844 .44647 L
.55944 .4528 L
.56044 .45948 L
.56144 .46651 L
.56244 .47388 L
.56344 .48158 L
.56444 .48955 L
.56543 .49773 L
.56643 .506 L
.56743 .51423 L
.56843 .52217 L
.56943 .52953 L
.57043 .53586 L
.57143 .54054 L
.57243 .54276 L
.57343 .54158 L
.57443 .53619 L
.57542 .52643 L
.57642 .51285 L
.57742 .49643 L
.57842 .47822 L
.57942 .45918 L
.58042 .44009 L
.58142 .42155 L
.58242 .40398 L
.58342 .38766 L
.58442 .37271 L
.58541 .35916 L
.58641 .34697 L
.58741 .33606 L
.58841 .32632 L
.58941 .31762 L
.59041 .30986 L
.59141 .30291 L
.59241 .29667 L
Mistroke
.59341 .29106 L
.59441 .28599 L
.5954 .28139 L
.5964 .27719 L
.5974 .27333 L
.5984 .26976 L
.5994 .3305 L
.6004 .32092 L
.6014 .31356 L
.6024 .3073 L
.6034 .30173 L
.6044 .29662 L
.60539 .29181 L
.60639 .28719 L
.60739 .28268 L
.60839 .27822 L
.60939 .27376 L
.61039 .26927 L
.61139 .26471 L
.61239 .26007 L
.61339 .25535 L
.61439 .25055 L
.61538 .24566 L
.61638 .24072 L
.61738 .23574 L
.61838 .23075 L
.61938 .22579 L
.62038 .22093 L
.62138 .2162 L
.62238 .21167 L
.62338 .2074 L
.62438 .20347 L
.62537 .19993 L
.62637 .19685 L
.62737 .19425 L
.62837 .19217 L
.62937 .19059 L
.63037 .18949 L
.63137 .18878 L
.63237 .18839 L
.63337 .1882 L
.63437 .18814 L
.63536 .18816 L
.63636 .18827 L
.63736 .18854 L
.63836 .18905 L
.63936 .18992 L
.64036 .19124 L
.64136 .19308 L
.64236 .19549 L
Mistroke
.64336 .19846 L
.64436 .20197 L
.64535 .20597 L
.64635 .21036 L
.64735 .21507 L
.64835 .21997 L
.64935 .31956 L
.65035 .31444 L
.65135 .31092 L
.65235 .30794 L
.65335 .30516 L
.65435 .30241 L
.65534 .29958 L
.65634 .29662 L
.65734 .29347 L
.65834 .29011 L
.65934 .28652 L
.66034 .28267 L
.66134 .27856 L
.66234 .27418 L
.66334 .26951 L
.66434 .26456 L
.66533 .25934 L
.66633 .25384 L
.66733 .24809 L
.66833 .2421 L
.66933 .23592 L
.67033 .22957 L
.67133 .22312 L
.67233 .21664 L
.67333 .2102 L
.67433 .20391 L
.67532 .19788 L
.67632 .19222 L
.67732 .18707 L
.67832 .18255 L
.67932 .17877 L
.68032 .17583 L
.68132 .17376 L
.68232 .17252 L
.68332 .17198 L
.68432 .17187 L
.68531 .17183 L
.68631 .17149 L
.68731 .1706 L
.68831 .1692 L
.68931 .16756 L
.69031 .16612 L
.69131 .16528 L
.69231 .16538 L
Mistroke
.69331 .16667 L
.69431 .16927 L
.6953 .17323 L
.6963 .17848 L
.6973 .1849 L
.6983 .19228 L
.6993 .28611 L
.7003 .28881 L
.7013 .29286 L
.7023 .29721 L
.7033 .30149 L
.7043 .30552 L
.70529 .3092 L
.70629 .31248 L
.70729 .31532 L
.70829 .31772 L
.70929 .3197 L
.71029 .32125 L
.71129 .32241 L
.71229 .3232 L
.71329 .32364 L
.71429 .32375 L
.71528 .32354 L
.71628 .32305 L
.71728 .32227 L
.71828 .32121 L
.71928 .3199 L
.72028 .31832 L
.72128 .31649 L
.72228 .31439 L
.72328 .31202 L
.72428 .30937 L
.72527 .30643 L
.72627 .30319 L
.72727 .29962 L
.72827 .29572 L
.72927 .29145 L
.73027 .2868 L
.73127 .28174 L
.73227 .27624 L
.73327 .27027 L
.73427 .2638 L
.73526 .25681 L
.73626 .24926 L
.73726 .24112 L
.73826 .23238 L
.73926 .223 L
.74026 .21298 L
.74126 .2023 L
.74226 .19097 L
Mistroke
.74326 .17901 L
.74426 .16645 L
.74525 .15334 L
.74625 .13978 L
.74725 .12587 L
.74825 .11176 L
.74925 .25279 L
.75025 .23783 L
.75125 .22419 L
.75225 .21084 L
.75325 .19755 L
.75425 .18436 L
.75524 .17143 L
.75624 .15905 L
.75724 .14761 L
.75824 .13756 L
.75924 .12943 L
.76024 .12373 L
.76124 .12091 L
.76224 .12127 L
.76324 .12486 L
.76424 .1315 L
.76523 .14081 L
.76623 .15235 L
.76723 .16575 L
.76823 .1807 L
.76923 .19685 L
.77023 .21382 L
.77123 .23115 L
.77223 .24843 L
.77323 .26525 L
.77423 .28129 L
.77522 .2963 L
.77622 .31014 L
.77722 .32271 L
.77822 .334 L
.77922 .34405 L
.78022 .35292 L
.78122 .36069 L
.78222 .36749 L
.78322 .3734 L
.78422 .37855 L
.78521 .38303 L
.78621 .38694 L
.78721 .39038 L
.78821 .39343 L
.78921 .39615 L
.79021 .3986 L
.79121 .40084 L
.79221 .4029 L
Mistroke
.79321 .40483 L
.79421 .40665 L
.7952 .40838 L
.7962 .41002 L
.7972 .41158 L
.7982 .41307 L
.7992 .46663 L
.8002 .46477 L
.8012 .4644 L
.8022 .46447 L
.8032 .46467 L
.8042 .46486 L
.80519 .46496 L
.80619 .46491 L
.80719 .4647 L
.80819 .4643 L
.80919 .46372 L
.81019 .46295 L
.81119 .46199 L
.81219 .46086 L
.81319 .45955 L
.81419 .45809 L
.81518 .45647 L
.81618 .45472 L
.81718 .45284 L
.81818 .45085 L
.81918 .44876 L
.82018 .44658 L
.82118 .44433 L
.82218 .44202 L
.82318 .43968 L
.82418 .43731 L
.82517 .43494 L
.82617 .43257 L
.82717 .43024 L
.82817 .42794 L
.82917 .42571 L
.83017 .42354 L
.83117 .42147 L
.83217 .41949 L
.83317 .41763 L
.83417 .41588 L
.83516 .41426 L
.83616 .41278 L
.83716 .41143 L
.83816 .41023 L
.83916 .40917 L
.84016 .40827 L
.84116 .40751 L
.84216 .40691 L
Mistroke
.84316 .40645 L
.84416 .40615 L
.84515 .40599 L
.84615 .40598 L
.84715 .40612 L
.84815 .40641 L
.84915 .50308 L
.85015 .49878 L
.85115 .49585 L
.85215 .49322 L
.85315 .49055 L
.85415 .48769 L
.85514 .48455 L
.85614 .4811 L
.85714 .47734 L
.85814 .47329 L
.85914 .46897 L
.86014 .46445 L
.86114 .45976 L
.86214 .45495 L
.86314 .4501 L
.86414 .44523 L
.86513 .44042 L
.86613 .4357 L
.86713 .43111 L
.86813 .42669 L
.86913 .42246 L
.87013 .41845 L
.87113 .41468 L
.87213 .41115 L
.87313 .40788 L
.87413 .40486 L
.87512 .40209 L
.87612 .39957 L
.87712 .3973 L
.87812 .39527 L
.87912 .39346 L
.88012 .39188 L
.88112 .39051 L
.88212 .38935 L
.88312 .38838 L
.88412 .3876 L
.88511 .387 L
.88611 .38659 L
.88711 .38635 L
.88811 .38628 L
.88911 .38639 L
.89011 .38667 L
.89111 .38714 L
.89211 .3878 L
Mistroke
.89311 .38865 L
.89411 .3897 L
.8951 .39098 L
.8961 .39248 L
.8971 .39423 L
.8981 .39625 L
.8991 .45104 L
.9001 .45236 L
.9011 .45587 L
.9021 .46044 L
.9031 .46574 L
.9041 .47155 L
.90509 .47777 L
.90609 .48428 L
.90709 .491 L
.90809 .49782 L
.90909 .50463 L
.91009 .51128 L
.91109 .51762 L
.91209 .52346 L
.91309 .52856 L
.91409 .53267 L
.91508 .53549 L
.91608 .53668 L
.91708 .53587 L
.91808 .53272 L
.91908 .52699 L
.92008 .5186 L
.92108 .50775 L
.92208 .49484 L
.92308 .48043 L
.92408 .46511 L
.92507 .44944 L
.92607 .4339 L
.92707 .41884 L
.92807 .40454 L
.92907 .39116 L
.93007 .3788 L
.93107 .36747 L
.93207 .35717 L
.93307 .34784 L
.93407 .33942 L
.93506 .33182 L
.93606 .32495 L
.93706 .31872 L
.93806 .31305 L
.93906 .30786 L
.94006 .30306 L
.94106 .29858 L
.94206 .29435 L
Mistroke
.94306 .29031 L
.94406 .28641 L
.94505 .28259 L
.94605 .27879 L
.94705 .27498 L
.94805 .27113 L
.94905 .32244 L
.95005 .31673 L
.95105 .31259 L
.95205 .30896 L
.95305 .30548 L
.95405 .30196 L
.95504 .29831 L
.95604 .29447 L
.95704 .29038 L
.95804 .28602 L
.95904 .28135 L
.96004 .27636 L
.96104 .27104 L
.96204 .26538 L
.96304 .25937 L
.96404 .25302 L
.96503 .24634 L
.96603 .23937 L
.96703 .23213 L
.96803 .22468 L
.96903 .21709 L
.97003 .20945 L
.97103 .20187 L
.97203 .19448 L
.97303 .18744 L
.97403 .18092 L
.97502 .17509 L
.97602 .17014 L
.97702 .16621 L
.97802 .16342 L
.97902 .16177 L
.98002 .16116 L
.98102 .16127 L
.98202 .16163 L
.98302 .16168 L
.98402 .16108 L
.98501 .15993 L
.98601 .15867 L
.98701 .15789 L
.98801 .15811 L
.98901 .15968 L
.99001 .16283 L
.99101 .16761 L
.99201 .17395 L
Mistroke
.99301 .1817 L
.99401 .19059 L
.995 .20032 L
.996 .21058 L
.997 .22104 L
.998 .2314 L
.999 .3062 L
Mfstroke
gsave
.999 .3211 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38342 L
.004 .38538 L
.005 .38721 L
.00599 .38905 L
.00699 .39099 L
.00799 .39308 L
.00899 .39539 L
.00999 .39797 L
.01099 .40088 L
.01199 .40416 L
.01299 .40788 L
.01399 .41208 L
.01499 .41683 L
.01598 .4222 L
.01698 .42826 L
.01798 .4351 L
.01898 .4428 L
.01998 .45145 L
.02098 .46117 L
.02198 .47205 L
.02298 .48423 L
.02398 .49782 L
.02498 .51293 L
.02597 .52968 L
.02697 .54818 L
.02797 .56848 L
.02897 .59064 L
.02997 .61464 L
s
.02997 .61464 m
.0301 .61803 L
s
.04895 .61803 m
.04995 .1176 L
.05095 .11315 L
.05195 .11149 L
.05295 .11444 L
.05395 .12315 L
.05495 .13833 L
.05594 .16016 L
.05694 .18803 L
.05794 .22052 L
.05894 .25576 L
.05994 .29181 L
.06094 .32706 L
.06194 .3603 L
.06294 .39077 L
.06394 .41804 L
.06494 .44194 L
.06593 .46244 L
.06693 .4796 L
.06793 .49351 L
.06893 .50431 L
.06993 .51215 L
.07093 .51723 L
.07193 .51984 L
.07293 .52041 L
.07393 .5196 L
.07493 .51836 L
.07592 .5179 L
.07692 .51927 L
.07792 .52284 L
.07892 .52824 L
.07992 .53481 L
.08092 .542 L
.08192 .5494 L
.08292 .55672 L
.08392 .56375 L
.08492 .57032 L
.08591 .57632 L
.08691 .58165 L
.08791 .58624 L
.08891 .59003 L
.08991 .59301 L
.09091 .59516 L
.09191 .59648 L
.09291 .597 L
.09391 .59677 L
.09491 .59584 L
.0959 .59429 L
.0969 .59221 L
.0979 .58968 L
Mistroke
.0989 .58681 L
.0999 .41292 L
.1009 .41629 L
.1019 .41826 L
.1029 .41985 L
.1039 .4214 L
.1049 .42304 L
.10589 .42487 L
.10689 .42693 L
.10789 .42925 L
.10889 .43186 L
.10989 .43476 L
.11089 .43797 L
.11189 .44152 L
.11289 .4454 L
.11389 .44965 L
.11489 .45428 L
.11588 .4593 L
.11688 .46474 L
.11788 .47061 L
.11888 .47693 L
.11988 .4837 L
.12088 .49094 L
.12188 .49863 L
.12288 .50676 L
.12388 .5153 L
.12488 .52421 L
.12587 .53342 L
.12687 .54284 L
.12787 .55233 L
.12887 .56174 L
.12987 .57088 L
.13087 .57951 L
.13187 .58738 L
.13287 .59418 L
.13387 .59962 L
.13487 .60343 L
.13586 .60538 L
.13686 .60534 L
.13786 .60342 L
.13886 .6 L
.13986 .596 L
.14086 .59295 L
.14186 .59268 L
.14286 .59616 L
.14386 .60271 L
.14486 .61073 L
Mfstroke
.14486 .61073 m
.14577 .61803 L
s
.14907 .61803 m
.14985 .56961 L
.15085 .55985 L
.15185 .54762 L
.15285 .53422 L
.15385 .52032 L
.15485 .50641 L
.15584 .49285 L
.15684 .47995 L
.15784 .4679 L
.15884 .45683 L
.15984 .44683 L
.16084 .43792 L
.16184 .4301 L
.16284 .42331 L
.16384 .41751 L
.16484 .4126 L
.16583 .40852 L
.16683 .40517 L
.16783 .40248 L
.16883 .40037 L
.16983 .39876 L
.17083 .39759 L
.17183 .39681 L
.17283 .39637 L
.17383 .39622 L
.17483 .39634 L
.17582 .39669 L
.17682 .39725 L
.17782 .39801 L
.17882 .39896 L
.17982 .40008 L
.18082 .40136 L
.18182 .40281 L
.18282 .40442 L
.18382 .40619 L
.18482 .40812 L
.18581 .4102 L
.18681 .41244 L
.18781 .41483 L
.18881 .41737 L
.18981 .42005 L
.19081 .42286 L
.19181 .42579 L
.19281 .4288 L
.19381 .43187 L
.19481 .43498 L
.1958 .43807 L
.1968 .4411 L
.1978 .44402 L
Mistroke
.1988 .44678 L
.1998 .29224 L
.2008 .28696 L
.2018 .28023 L
.2028 .273 L
.2038 .26555 L
.2048 .25801 L
.20579 .25048 L
.20679 .24304 L
.20779 .23582 L
.20879 .22892 L
.20979 .22249 L
.21079 .21671 L
.21179 .21178 L
.21279 .20792 L
.21379 .20541 L
.21479 .20453 L
.21578 .20557 L
.21678 .20882 L
.21778 .21451 L
.21878 .22271 L
.21978 .23327 L
.22078 .24587 L
.22178 .25997 L
.22278 .275 L
.22378 .2904 L
.22478 .30569 L
.22577 .32048 L
.22677 .33449 L
.22777 .34755 L
.22877 .35957 L
.22977 .37052 L
.23077 .38042 L
.23177 .38935 L
.23277 .39737 L
.23377 .40458 L
.23477 .41108 L
.23576 .41698 L
.23676 .42235 L
.23776 .4273 L
.23876 .43191 L
.23976 .43625 L
.24076 .44042 L
.24176 .44446 L
.24276 .44845 L
.24376 .45245 L
.24476 .4565 L
.24575 .46067 L
.24675 .46498 L
.24775 .4695 L
Mistroke
.24875 .47425 L
.24975 .46025 L
.25075 .46699 L
.25175 .47209 L
.25275 .47662 L
.25375 .48095 L
.25475 .48523 L
.25574 .48954 L
.25674 .49393 L
.25774 .4984 L
.25874 .50295 L
.25974 .50756 L
.26074 .51218 L
.26174 .51679 L
.26274 .52133 L
.26374 .52572 L
.26474 .52992 L
.26573 .53385 L
.26673 .53743 L
.26773 .5406 L
.26873 .5433 L
.26973 .54546 L
.27073 .54706 L
.27173 .54806 L
.27273 .54848 L
.27373 .54834 L
.27473 .54767 L
.27572 .54655 L
.27672 .54504 L
.27772 .54321 L
.27872 .54112 L
.27972 .5388 L
.28072 .5363 L
.28172 .53362 L
.28272 .53078 L
.28372 .5278 L
.28472 .52468 L
.28571 .52147 L
.28671 .51818 L
.28771 .51485 L
.28871 .51153 L
.28971 .50827 L
.29071 .5051 L
.29171 .50208 L
.29271 .49924 L
.29371 .49662 L
.29471 .49426 L
.2957 .49218 L
.2967 .4904 L
.2977 .48895 L
Mistroke
.2987 .48782 L
.2997 .43001 L
.3007 .4342 L
.3017 .43688 L
.3027 .43911 L
.3037 .44124 L
.3047 .44343 L
.30569 .44577 L
.30669 .44833 L
.30769 .45113 L
.30869 .45421 L
.30969 .45757 L
.31069 .46122 L
.31169 .46519 L
.31269 .46946 L
.31369 .47405 L
.31469 .47895 L
.31568 .48415 L
.31668 .48966 L
.31768 .49545 L
.31868 .50149 L
.31968 .50776 L
.32068 .51421 L
.32168 .52079 L
.32268 .52742 L
.32368 .53402 L
.32468 .54048 L
.32567 .54669 L
.32667 .55253 L
.32767 .55786 L
.32867 .56254 L
.32967 .56646 L
.33067 .56951 L
.33167 .57166 L
.33267 .57294 L
.33367 .57346 L
.33467 .57349 L
.33566 .57339 L
.33666 .57352 L
.33766 .57415 L
.33866 .57526 L
.33966 .57661 L
.34066 .57779 L
.34166 .57839 L
.34266 .57807 L
.34366 .57658 L
.34466 .5738 L
.34565 .56968 L
.34665 .56429 L
.34765 .55778 L
Mistroke
.34865 .55034 L
.34965 .52262 L
.35065 .52078 L
.35165 .51663 L
.35265 .51131 L
.35365 .50531 L
.35465 .49895 L
.35564 .49247 L
.35664 .48603 L
.35764 .47979 L
.35864 .47386 L
.35964 .46832 L
.36064 .46323 L
.36164 .45863 L
.36264 .45454 L
.36364 .45097 L
.36464 .44792 L
.36563 .44539 L
.36663 .44334 L
.36763 .44177 L
.36863 .44066 L
.36963 .43998 L
.37063 .43972 L
.37163 .43985 L
.37263 .44037 L
.37363 .44125 L
.37463 .44248 L
.37562 .44406 L
.37662 .44599 L
.37762 .44826 L
.37862 .45087 L
.37962 .45382 L
.38062 .45713 L
.38162 .4608 L
.38262 .46484 L
.38362 .46927 L
.38462 .47409 L
.38561 .47932 L
.38661 .48497 L
.38761 .49106 L
.38861 .49758 L
.38961 .50455 L
.39061 .51196 L
.39161 .51981 L
.39261 .52809 L
.39361 .53677 L
.39461 .54581 L
.3956 .55516 L
.3966 .56474 L
.3976 .57447 L
Mistroke
.3986 .58423 L
.3996 .33205 L
.4006 .335 L
.4016 .33561 L
.4026 .33505 L
.4036 .33369 L
.4046 .33171 L
.40559 .32923 L
.40659 .32628 L
.40759 .32291 L
.40859 .31913 L
.40959 .31493 L
.41059 .31033 L
.41159 .30529 L
.41259 .29982 L
.41359 .29389 L
.41459 .28749 L
.41558 .2806 L
.41658 .27322 L
.41758 .26536 L
.41858 .25704 L
.41958 .24831 L
.42058 .23927 L
.42158 .23011 L
.42258 .2211 L
.42358 .2127 L
.42458 .20562 L
.42557 .20096 L
.42657 .20022 L
.42757 .20482 L
.42857 .21511 L
.42957 .23015 L
.43057 .24849 L
.43157 .26872 L
.43257 .28968 L
.43357 .31045 L
.43457 .33037 L
.43556 .34896 L
.43656 .36599 L
.43756 .38134 L
.43856 .39504 L
.43956 .40718 L
.44056 .4179 L
.44156 .42735 L
.44256 .43569 L
.44356 .44307 L
.44456 .44961 L
.44555 .45541 L
.44655 .46057 L
.44755 .46516 L
Mistroke
.44855 .46925 L
.44955 .41219 L
.45055 .42196 L
.45155 .4293 L
.45255 .43528 L
.45355 .44032 L
.45455 .44465 L
.45554 .44845 L
.45654 .45185 L
.45754 .45493 L
.45854 .45779 L
.45954 .46047 L
.46054 .46304 L
.46154 .46553 L
.46254 .46798 L
.46354 .47041 L
.46454 .47285 L
.46553 .47531 L
.46653 .47782 L
.46753 .48037 L
.46853 .48299 L
.46953 .48566 L
.47053 .48839 L
.47153 .49118 L
.47253 .49403 L
.47353 .49692 L
.47453 .49984 L
.47552 .50279 L
.47652 .50574 L
.47752 .50867 L
.47852 .51157 L
.47952 .51441 L
.48052 .51717 L
.48152 .51983 L
.48252 .52236 L
.48352 .52474 L
.48452 .52695 L
.48551 .52897 L
.48651 .53081 L
.48751 .53245 L
.48851 .5339 L
.48951 .53517 L
.49051 .53628 L
.49151 .53727 L
.49251 .53815 L
.49351 .53896 L
.49451 .53972 L
.4955 .54045 L
.4965 .54113 L
.4975 .54177 L
Mistroke
.4985 .54232 L
.4995 .55143 L
.5005 .54795 L
.5015 .54177 L
.5025 .53407 L
.5035 .52538 L
.5045 .51609 L
.50549 .50648 L
.50649 .49684 L
.50749 .48736 L
.50849 .47823 L
.50949 .46959 L
.51049 .46152 L
.51149 .45411 L
.51249 .44738 L
.51349 .44135 L
.51449 .43603 L
.51548 .43139 L
.51648 .4274 L
.51748 .42402 L
.51848 .42122 L
.51948 .41896 L
.52048 .41718 L
.52148 .41586 L
.52248 .41494 L
.52348 .4144 L
.52448 .41422 L
.52547 .41435 L
.52647 .41479 L
.52747 .41551 L
.52847 .4165 L
.52947 .41775 L
.53047 .41926 L
.53147 .42103 L
.53247 .42305 L
.53347 .42534 L
.53447 .4279 L
.53546 .43074 L
.53646 .43388 L
.53746 .43733 L
.53846 .44112 L
.53946 .44526 L
.54046 .44978 L
.54146 .45471 L
.54246 .46006 L
.54346 .46589 L
.54446 .4722 L
.54545 .47905 L
.54645 .48646 L
.54745 .49447 L
Mistroke
.54845 .5031 L
.54945 .42114 L
.55045 .43172 L
.55145 .44053 L
.55245 .44876 L
.55345 .45685 L
.55445 .46503 L
.55544 .47347 L
.55644 .48225 L
.55744 .49143 L
.55844 .50104 L
.55944 .51108 L
.56044 .5215 L
.56144 .53224 L
.56244 .54316 L
.56344 .5541 L
.56444 .56483 L
.56543 .57507 L
.56643 .58449 L
.56743 .59273 L
.56843 .59943 L
.56943 .60425 L
.57043 .60699 L
.57143 .60763 L
.57243 .60643 L
.57343 .60395 L
.57443 .60077 L
.57542 .59708 L
.57642 .5926 L
.57742 .58685 L
.57842 .57944 L
.57942 .57026 L
.58042 .55937 L
.58142 .54706 L
.58242 .5337 L
.58342 .5197 L
.58442 .5055 L
.58541 .49149 L
.58641 .47799 L
.58741 .46526 L
.58841 .45347 L
.58941 .44273 L
.59041 .43308 L
.59141 .4245 L
.59241 .41697 L
.59341 .41042 L
.59441 .40475 L
.5954 .39988 L
.5964 .39571 L
.5974 .39215 L
Mistroke
.5984 .38912 L
.5994 .34533 L
.6004 .34464 L
.6014 .34271 L
.6024 .34047 L
.6034 .33818 L
.6044 .33593 L
.60539 .33375 L
.60639 .33165 L
.60739 .32961 L
.60839 .32761 L
.60939 .32564 L
.61039 .32366 L
.61139 .32166 L
.61239 .31961 L
.61339 .3175 L
.61439 .31531 L
.61538 .31303 L
.61638 .31063 L
.61738 .30811 L
.61838 .30547 L
.61938 .30268 L
.62038 .29976 L
.62138 .29671 L
.62238 .29353 L
.62338 .29025 L
.62438 .28688 L
.62537 .28348 L
.62637 .28008 L
.62737 .27678 L
.62837 .27365 L
.62937 .27083 L
.63037 .26847 L
.63137 .26672 L
.63237 .26576 L
.63337 .26577 L
.63437 .26686 L
.63536 .2691 L
.63636 .27248 L
.63736 .2769 L
.63836 .28219 L
.63936 .28818 L
.64036 .29465 L
.64136 .30141 L
.64236 .3083 L
.64336 .31516 L
.64436 .32186 L
.64535 .32832 L
.64635 .33448 L
.64735 .34029 L
Mistroke
.64835 .34574 L
.64935 .33432 L
.65035 .33799 L
.65135 .33981 L
.65235 .34081 L
.65335 .34131 L
.65435 .34148 L
.65534 .34138 L
.65634 .34108 L
.65734 .3406 L
.65834 .33995 L
.65934 .33915 L
.66034 .3382 L
.66134 .33709 L
.66234 .33581 L
.66334 .33438 L
.66434 .33277 L
.66533 .33097 L
.66633 .32898 L
.66733 .32678 L
.66833 .32435 L
.66933 .32169 L
.67033 .31877 L
.67133 .31558 L
.67233 .31209 L
.67333 .3083 L
.67433 .30419 L
.67532 .29974 L
.67632 .29497 L
.67732 .28988 L
.67832 .28452 L
.67932 .27894 L
.68032 .27324 L
.68132 .26759 L
.68232 .26222 L
.68332 .25747 L
.68432 .25376 L
.68531 .25161 L
.68631 .25153 L
.68731 .25385 L
.68831 .25856 L
.68931 .26538 L
.69031 .27384 L
.69131 .28344 L
.69231 .2937 L
.69331 .30421 L
.69431 .31464 L
.6953 .32472 L
.6963 .33427 L
.6973 .34316 L
Mistroke
.6983 .35135 L
.6993 .30092 L
.7003 .31248 L
.7013 .32193 L
.7023 .33021 L
.7033 .3376 L
.7043 .34425 L
.70529 .35027 L
.70629 .35572 L
.70729 .36065 L
.70829 .36513 L
.70929 .36919 L
.71029 .37289 L
.71129 .37626 L
.71229 .37935 L
.71329 .38219 L
.71429 .38482 L
.71528 .38728 L
.71628 .3896 L
.71728 .39181 L
.71828 .39393 L
.71928 .39601 L
.72028 .39806 L
.72128 .40011 L
.72228 .40219 L
.72328 .40431 L
.72428 .40651 L
.72527 .40881 L
.72627 .41123 L
.72727 .41379 L
.72827 .41651 L
.72927 .41943 L
.73027 .42256 L
.73127 .42593 L
.73227 .42956 L
.73327 .43349 L
.73427 .43774 L
.73526 .44234 L
.73626 .44732 L
.73726 .4527 L
.73826 .45853 L
.73926 .46483 L
.74026 .47163 L
.74126 .47897 L
.74226 .48687 L
.74326 .49536 L
.74426 .50446 L
.74525 .51419 L
.74625 .52455 L
.74725 .53556 L
Mistroke
.74825 .54719 L
.74925 .26722 L
.75025 .26142 L
.75125 .25354 L
.75225 .2447 L
.75325 .23529 L
.75425 .22558 L
.75524 .21581 L
.75624 .20624 L
.75724 .19716 L
.75824 .18892 L
.75924 .18191 L
.76024 .17659 L
.76124 .17343 L
.76224 .17299 L
.76324 .1758 L
.76424 .18231 L
.76523 .19281 L
.76623 .20719 L
.76723 .22492 L
.76823 .24513 L
.76923 .26683 L
.77023 .28906 L
.77123 .31102 L
.77223 .33209 L
.77323 .35188 L
.77423 .37013 L
.77522 .38674 L
.77622 .4017 L
.77722 .41506 L
.77822 .42692 L
.77922 .4374 L
.78022 .44662 L
.78122 .4547 L
.78222 .46177 L
.78322 .46794 L
.78422 .47331 L
.78521 .47797 L
.78621 .48199 L
.78721 .48547 L
.78821 .48847 L
.78921 .49105 L
.79021 .49327 L
.79121 .49518 L
.79221 .49683 L
.79321 .49827 L
.79421 .49955 L
.7952 .50071 L
.7962 .50179 L
.7972 .50284 L
Mistroke
.7982 .50388 L
.7992 .48116 L
.8002 .48825 L
.8012 .49327 L
.8022 .49727 L
.8032 .50061 L
.8042 .50346 L
.80519 .50591 L
.80619 .50801 L
.80719 .50981 L
.80819 .51131 L
.80919 .51255 L
.81019 .51352 L
.81119 .51423 L
.81219 .51469 L
.81319 .51491 L
.81419 .51491 L
.81518 .51469 L
.81618 .51428 L
.81718 .5137 L
.81818 .51296 L
.81918 .5121 L
.82018 .51114 L
.82118 .51011 L
.82218 .50903 L
.82318 .50794 L
.82418 .50686 L
.82517 .50581 L
.82617 .50481 L
.82717 .50388 L
.82817 .50304 L
.82917 .50231 L
.83017 .50168 L
.83117 .50118 L
.83217 .5008 L
.83317 .50056 L
.83417 .50046 L
.83516 .50049 L
.83616 .50067 L
.83716 .50098 L
.83816 .50143 L
.83916 .50201 L
.84016 .50272 L
.84116 .50355 L
.84216 .50451 L
.84316 .50558 L
.84416 .50675 L
.84515 .50803 L
.84615 .50939 L
.84715 .51084 L
Mistroke
.84815 .51236 L
.84915 .51759 L
.85015 .52223 L
.85115 .52466 L
.85215 .52589 L
.85315 .52626 L
.85415 .52591 L
.85514 .52496 L
.85614 .52348 L
.85714 .52154 L
.85814 .51921 L
.85914 .51655 L
.86014 .51363 L
.86114 .51052 L
.86214 .50729 L
.86314 .50398 L
.86414 .50068 L
.86513 .49743 L
.86613 .49428 L
.86713 .49128 L
.86813 .48847 L
.86913 .48588 L
.87013 .48354 L
.87113 .48147 L
.87213 .47968 L
.87313 .4782 L
.87413 .47701 L
.87512 .47613 L
.87612 .47556 L
.87712 .4753 L
.87812 .47534 L
.87912 .47569 L
.88012 .47633 L
.88112 .47725 L
.88212 .47847 L
.88312 .47996 L
.88412 .48172 L
.88511 .48374 L
.88611 .48602 L
.88711 .48854 L
.88811 .4913 L
.88911 .49427 L
.89011 .49746 L
.89111 .50084 L
.89211 .50439 L
.89311 .50809 L
.89411 .51191 L
.8951 .51582 L
.8961 .51979 L
.8971 .52378 L
Mistroke
.8981 .52774 L
.8991 .46546 L
.9001 .47584 L
.9011 .48491 L
.9021 .49375 L
.9031 .50267 L
.9041 .51178 L
.90509 .52111 L
.90609 .5306 L
.90709 .54017 L
.90809 .54966 L
.90909 .55889 L
.91009 .56762 L
.91109 .57558 L
.91209 .58249 L
.91309 .58805 L
.91409 .592 L
.91508 .59413 L
.91608 .59433 L
.91708 .59263 L
.91808 .58916 L
.91908 .58417 L
.92008 .57788 L
.92108 .57048 L
.92208 .56207 L
.92308 .55273 L
.92408 .54258 L
.92507 .53178 L
.92607 .52054 L
.92707 .5091 L
.92807 .4977 L
.92907 .48657 L
.93007 .4759 L
.93107 .46584 L
.93207 .45651 L
.93307 .44798 L
.93407 .44028 L
.93506 .43342 L
.93606 .42738 L
.93706 .42212 L
.93806 .41759 L
.93906 .41374 L
.94006 .4105 L
.94106 .40781 L
.94206 .40562 L
.94306 .40388 L
.94406 .40252 L
.94505 .4015 L
.94605 .40079 L
.94705 .40035 L
Mistroke
.94805 .40014 L
.94905 .33701 L
.95005 .34021 L
.95105 .34149 L
.95205 .34191 L
.95305 .3418 L
.95405 .34132 L
.95504 .34056 L
.95604 .33957 L
.95704 .33837 L
.95804 .33697 L
.95904 .33538 L
.96004 .33359 L
.96104 .33161 L
.96204 .32942 L
.96304 .32701 L
.96404 .32437 L
.96503 .32149 L
.96603 .31834 L
.96703 .3149 L
.96803 .31116 L
.96903 .3071 L
.97003 .30269 L
.97103 .29792 L
.97203 .29277 L
.97303 .28725 L
.97403 .28135 L
.97502 .27512 L
.97602 .26862 L
.97702 .26194 L
.97802 .25528 L
.97902 .24889 L
.98002 .24318 L
.98102 .2387 L
.98202 .23618 L
.98302 .23634 L
.98402 .23962 L
.98501 .246 L
.98601 .25496 L
.98701 .26583 L
.98801 .27791 L
.98901 .2906 L
.99001 .30339 L
.99101 .31589 L
.99201 .32782 L
.99301 .33897 L
.99401 .34924 L
.995 .35861 L
.996 .36709 L
.997 .37476 L
Mistroke
.998 .38169 L
.999 .3211 L
Mfstroke
1 0 0 r
gsave
.999 .31365 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36653 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .3649 L
.00999 .36425 L
.01099 .36349 L
.01199 .36263 L
.01299 .36165 L
.01399 .36054 L
.01499 .35929 L
.01598 .35788 L
.01698 .3563 L
.01798 .35453 L
.01898 .35256 L
.01998 .35036 L
.02098 .34791 L
.02198 .34522 L
.02298 .34226 L
.02398 .33903 L
.02498 .33554 L
.02597 .33182 L
.02697 .32792 L
.02797 .32392 L
.02897 .31994 L
.02997 .31619 L
.03097 .31289 L
.03197 .3104 L
.03297 .30912 L
.03397 .30952 L
.03497 .31209 L
.03596 .3173 L
.03696 .32547 L
.03796 .33667 L
.03896 .3506 L
.03996 .36654 L
.04096 .38333 L
.04196 .39951 L
.04296 .41348 L
.04396 .42381 L
.04496 .42948 L
.04595 .43008 L
.04695 .42585 L
.04795 .41761 L
.04895 .40647 L
Mistroke
.04995 .10995 L
.05095 .10119 L
.05195 .09694 L
.05295 .09817 L
.05395 .10554 L
.05495 .11927 L
.05594 .13902 L
.05694 .16389 L
.05794 .19256 L
.05894 .22347 L
.05994 .2551 L
.06094 .28613 L
.06194 .31555 L
.06294 .3427 L
.06394 .36723 L
.06494 .389 L
.06593 .40803 L
.06693 .42443 L
.06793 .43837 L
.06893 .45001 L
.06993 .45955 L
.07093 .46717 L
.07193 .47303 L
.07293 .47731 L
.07393 .48019 L
.07493 .48182 L
.07592 .48237 L
.07692 .48202 L
.07792 .48093 L
.07892 .47925 L
.07992 .47714 L
.08092 .47471 L
.08192 .47208 L
.08292 .46935 L
.08392 .46658 L
.08492 .46382 L
.08591 .46111 L
.08691 .45847 L
.08791 .45591 L
.08891 .45342 L
.08991 .45098 L
.09091 .4486 L
.09191 .44626 L
.09291 .44393 L
.09391 .44162 L
.09491 .43931 L
.0959 .43699 L
.0969 .43469 L
.0979 .43238 L
.0989 .43009 L
Mistroke
.0999 .40545 L
.1009 .4045 L
.1019 .40387 L
.1029 .40352 L
.1039 .40345 L
.1049 .40364 L
.10589 .40407 L
.10689 .40473 L
.10789 .40562 L
.10889 .40673 L
.10989 .40805 L
.11089 .4096 L
.11189 .41137 L
.11289 .41336 L
.11389 .41559 L
.11489 .41806 L
.11588 .42079 L
.11688 .42377 L
.11788 .42703 L
.11888 .43058 L
.11988 .43442 L
.12088 .43857 L
.12188 .44303 L
.12288 .44781 L
.12388 .45292 L
.12488 .45834 L
.12587 .46407 L
.12687 .47009 L
.12787 .47635 L
.12887 .48283 L
.12987 .48945 L
.13087 .49614 L
.13187 .50281 L
.13287 .50936 L
.13387 .51564 L
.13487 .52154 L
.13586 .5269 L
.13686 .53159 L
.13786 .53548 L
.13886 .53844 L
.13986 .5404 L
.14086 .54128 L
.14186 .54106 L
.14286 .53972 L
.14386 .53728 L
.14486 .53377 L
.14585 .52922 L
.14685 .52367 L
.14785 .51716 L
.14885 .50976 L
Mistroke
.14985 .56218 L
.15085 .54784 L
.15185 .53258 L
.15285 .51681 L
.15385 .50093 L
.15485 .48532 L
.15584 .47029 L
.15684 .45608 L
.15784 .44286 L
.15884 .43074 L
.15984 .41975 L
.16084 .40991 L
.16184 .40115 L
.16284 .39342 L
.16384 .38663 L
.16484 .38069 L
.16583 .37551 L
.16683 .37099 L
.16783 .36704 L
.16883 .36358 L
.16983 .36052 L
.17083 .3578 L
.17183 .35535 L
.17283 .35311 L
.17383 .35103 L
.17483 .34907 L
.17582 .34717 L
.17682 .34532 L
.17782 .34347 L
.17882 .3416 L
.17982 .33968 L
.18082 .33769 L
.18182 .33561 L
.18282 .33342 L
.18382 .33112 L
.18482 .32867 L
.18581 .32608 L
.18681 .32334 L
.18781 .32045 L
.18881 .31739 L
.18981 .31418 L
.19081 .31083 L
.19181 .30735 L
.19281 .30376 L
.19381 .30009 L
.19481 .29639 L
.1958 .29271 L
.1968 .2891 L
.1978 .28565 L
.1988 .28243 L
Mistroke
.1998 .28496 L
.2008 .27511 L
.2018 .2655 L
.2028 .25603 L
.2038 .24665 L
.2048 .23737 L
.20579 .22821 L
.20679 .21924 L
.20779 .21058 L
.20879 .20239 L
.20979 .19486 L
.21079 .1882 L
.21179 .18267 L
.21279 .17852 L
.21379 .17599 L
.21479 .1753 L
.21578 .1766 L
.21678 .17998 L
.21778 .18543 L
.21878 .19284 L
.21978 .20202 L
.22078 .21268 L
.22178 .2245 L
.22278 .2371 L
.22378 .25012 L
.22478 .26321 L
.22577 .27609 L
.22677 .28849 L
.22777 .30024 L
.22877 .31121 L
.22977 .32131 L
.23077 .33052 L
.23177 .33883 L
.23277 .34626 L
.23377 .35288 L
.23477 .35873 L
.23576 .36389 L
.23676 .36843 L
.23776 .37241 L
.23876 .37592 L
.23976 .37901 L
.24076 .38176 L
.24176 .38421 L
.24276 .38642 L
.24376 .38844 L
.24476 .3903 L
.24575 .39206 L
.24675 .39373 L
.24775 .39535 L
.24875 .39694 L
Mistroke
.24975 .45302 L
.25075 .45528 L
.25175 .45769 L
.25275 .46023 L
.25375 .46292 L
.25475 .46574 L
.25574 .46869 L
.25674 .47176 L
.25774 .47494 L
.25874 .4782 L
.25974 .48152 L
.26074 .48489 L
.26174 .48825 L
.26274 .49159 L
.26374 .49485 L
.26474 .498 L
.26573 .50097 L
.26673 .50373 L
.26773 .50621 L
.26873 .50836 L
.26973 .51012 L
.27073 .51144 L
.27173 .51229 L
.27273 .51261 L
.27373 .5124 L
.27473 .51162 L
.27572 .51028 L
.27672 .50839 L
.27772 .50597 L
.27872 .50306 L
.27972 .49972 L
.28072 .49599 L
.28172 .49195 L
.28272 .48767 L
.28372 .48321 L
.28472 .47864 L
.28571 .47404 L
.28671 .46947 L
.28771 .46499 L
.28871 .46064 L
.28971 .45647 L
.29071 .45252 L
.29171 .44881 L
.29271 .44536 L
.29371 .44219 L
.29471 .43931 L
.2957 .43673 L
.2967 .43444 L
.2977 .43244 L
.2987 .43073 L
Mistroke
.2997 .42268 L
.3007 .42246 L
.3017 .4225 L
.3027 .42278 L
.3037 .42329 L
.3047 .42405 L
.30569 .42504 L
.30669 .42626 L
.30769 .42772 L
.30869 .42942 L
.30969 .43135 L
.31069 .43353 L
.31169 .43595 L
.31269 .43861 L
.31369 .44152 L
.31469 .44468 L
.31568 .4481 L
.31668 .45176 L
.31768 .45568 L
.31868 .45984 L
.31968 .46423 L
.32068 .46885 L
.32168 .47366 L
.32268 .47865 L
.32368 .48377 L
.32468 .48899 L
.32567 .49425 L
.32667 .49949 L
.32767 .50463 L
.32867 .50958 L
.32967 .51426 L
.33067 .51857 L
.33167 .52241 L
.33267 .52566 L
.33367 .52824 L
.33467 .53005 L
.33566 .53102 L
.33666 .53109 L
.33766 .53022 L
.33866 .5284 L
.33966 .52563 L
.34066 .52194 L
.34166 .5174 L
.34266 .51207 L
.34366 .50605 L
.34466 .49944 L
.34565 .49236 L
.34665 .48494 L
.34765 .47731 L
.34865 .46958 L
Mistroke
.34965 .51521 L
.35065 .50894 L
.35165 .5021 L
.35265 .49483 L
.35365 .48727 L
.35465 .47959 L
.35564 .47193 L
.35664 .4644 L
.35764 .45712 L
.35864 .45018 L
.35964 .44364 L
.36064 .43756 L
.36164 .43195 L
.36264 .42685 L
.36364 .42225 L
.36464 .41815 L
.36563 .41452 L
.36663 .41135 L
.36763 .40861 L
.36863 .40627 L
.36963 .40432 L
.37063 .40271 L
.37163 .40142 L
.37263 .40044 L
.37363 .39972 L
.37463 .39926 L
.37562 .39903 L
.37662 .39902 L
.37762 .39922 L
.37862 .3996 L
.37962 .40017 L
.38062 .40092 L
.38162 .40183 L
.38262 .40291 L
.38362 .40416 L
.38462 .40556 L
.38561 .40712 L
.38661 .40885 L
.38761 .41073 L
.38861 .41277 L
.38961 .41496 L
.39061 .41731 L
.39161 .41981 L
.39261 .42244 L
.39361 .42521 L
.39461 .42808 L
.3956 .43105 L
.3966 .43407 L
.3976 .43712 L
.3986 .44016 L
Mistroke
.3996 .32485 L
.4006 .32331 L
.4016 .32119 L
.4026 .31853 L
.4036 .31535 L
.4046 .31166 L
.40559 .30746 L
.40659 .30277 L
.40759 .29757 L
.40859 .29186 L
.40959 .28563 L
.41059 .27888 L
.41159 .27161 L
.41259 .26383 L
.41359 .25557 L
.41459 .24687 L
.41558 .23779 L
.41658 .22844 L
.41758 .21893 L
.41858 .20944 L
.41958 .20019 L
.42058 .19141 L
.42158 .18341 L
.42258 .17652 L
.42358 .17107 L
.42458 .16741 L
.42557 .16583 L
.42657 .16659 L
.42757 .16982 L
.42857 .17559 L
.42957 .1838 L
.43057 .19426 L
.43157 .20667 L
.43257 .22064 L
.43357 .23575 L
.43457 .25155 L
.43556 .26762 L
.43656 .28357 L
.43756 .29907 L
.43856 .31385 L
.43956 .32774 L
.44056 .3406 L
.44156 .35237 L
.44256 .36303 L
.44356 .3726 L
.44456 .38112 L
.44555 .38867 L
.44655 .39531 L
.44755 .40113 L
.44855 .40622 L
Mistroke
.44955 .40467 L
.45055 .41007 L
.45155 .41475 L
.45255 .41879 L
.45355 .4223 L
.45455 .42533 L
.45554 .42797 L
.45654 .43029 L
.45754 .43233 L
.45854 .43416 L
.45954 .43583 L
.46054 .43737 L
.46154 .43882 L
.46254 .44021 L
.46354 .44157 L
.46454 .44292 L
.46553 .44429 L
.46653 .44568 L
.46753 .44712 L
.46853 .44862 L
.46953 .45017 L
.47053 .45179 L
.47153 .45348 L
.47253 .45524 L
.47353 .45707 L
.47453 .45897 L
.47552 .46094 L
.47652 .46296 L
.47752 .46503 L
.47852 .46714 L
.47952 .46927 L
.48052 .47141 L
.48152 .47355 L
.48252 .47567 L
.48352 .47774 L
.48452 .47975 L
.48551 .48168 L
.48651 .48351 L
.48751 .48521 L
.48851 .48676 L
.48951 .48813 L
.49051 .48932 L
.49151 .4903 L
.49251 .49105 L
.49351 .49155 L
.49451 .49181 L
.4955 .49179 L
.4965 .49151 L
.4975 .49096 L
.4985 .49013 L
Mistroke
.4995 .54414 L
.5005 .53617 L
.5015 .52724 L
.5025 .51751 L
.5035 .50719 L
.5045 .49651 L
.50549 .48569 L
.50649 .47493 L
.50749 .46443 L
.50849 .45433 L
.50949 .44475 L
.51049 .43578 L
.51149 .42748 L
.51249 .41987 L
.51349 .41295 L
.51449 .40672 L
.51548 .40114 L
.51648 .39618 L
.51748 .3918 L
.51848 .38794 L
.51948 .38456 L
.52048 .38161 L
.52148 .37904 L
.52248 .37681 L
.52348 .37487 L
.52448 .37318 L
.52547 .37172 L
.52647 .37044 L
.52747 .36931 L
.52847 .36832 L
.52947 .36744 L
.53047 .36664 L
.53147 .36591 L
.53247 .36524 L
.53347 .36461 L
.53447 .36401 L
.53546 .36342 L
.53646 .36285 L
.53746 .36227 L
.53846 .3617 L
.53946 .36111 L
.54046 .36051 L
.54146 .35989 L
.54246 .35925 L
.54346 .35859 L
.54446 .35791 L
.54545 .35721 L
.54645 .35649 L
.54745 .35576 L
.54845 .35503 L
Mistroke
.54945 .41398 L
.55045 .42002 L
.55145 .42603 L
.55245 .4321 L
.55345 .43832 L
.55445 .44477 L
.55544 .45149 L
.55644 .45854 L
.55744 .46596 L
.55844 .47376 L
.55944 .48194 L
.56044 .49049 L
.56144 .49937 L
.56244 .50852 L
.56344 .51784 L
.56444 .52719 L
.56543 .5364 L
.56643 .54525 L
.56743 .55348 L
.56843 .5608 L
.56943 .56689 L
.57043 .57142 L
.57143 .57408 L
.57243 .5746 L
.57343 .57276 L
.57443 .56848 L
.57542 .56175 L
.57642 .55273 L
.57742 .54164 L
.57842 .52883 L
.57942 .51472 L
.58042 .49973 L
.58142 .48431 L
.58242 .46884 L
.58342 .45368 L
.58442 .4391 L
.58541 .42532 L
.58641 .41248 L
.58741 .40066 L
.58841 .3899 L
.58941 .38018 L
.59041 .37147 L
.59141 .36371 L
.59241 .35682 L
.59341 .35074 L
.59441 .34537 L
.5954 .34063 L
.5964 .33645 L
.5974 .33274 L
.5984 .32944 L
Mistroke
.5994 .33791 L
.6004 .33278 L
.6014 .32814 L
.6024 .32389 L
.6034 .31995 L
.6044 .31627 L
.60539 .31278 L
.60639 .30942 L
.60739 .30615 L
.60839 .30292 L
.60939 .2997 L
.61039 .29646 L
.61139 .29318 L
.61239 .28984 L
.61339 .28643 L
.61439 .28293 L
.61538 .27935 L
.61638 .27567 L
.61738 .27192 L
.61838 .26811 L
.61938 .26424 L
.62038 .26034 L
.62138 .25645 L
.62238 .2526 L
.62338 .24883 L
.62438 .24518 L
.62537 .24171 L
.62637 .23846 L
.62737 .23551 L
.62837 .23291 L
.62937 .23071 L
.63037 .22898 L
.63137 .22775 L
.63237 .22708 L
.63337 .22699 L
.63437 .2275 L
.63536 .22863 L
.63636 .23038 L
.63736 .23272 L
.63836 .23562 L
.63936 .23905 L
.64036 .24294 L
.64136 .24725 L
.64236 .25189 L
.64336 .25681 L
.64436 .26192 L
.64535 .26715 L
.64635 .27242 L
.64735 .27768 L
.64835 .28285 L
Mistroke
.64935 .32694 L
.65035 .32622 L
.65135 .32537 L
.65235 .32438 L
.65335 .32324 L
.65435 .32194 L
.65534 .32048 L
.65634 .31885 L
.65734 .31703 L
.65834 .31503 L
.65934 .31284 L
.66034 .31043 L
.66134 .30782 L
.66234 .305 L
.66334 .30194 L
.66434 .29866 L
.66533 .29515 L
.66633 .29141 L
.66733 .28743 L
.66833 .28323 L
.66933 .2788 L
.67033 .27417 L
.67133 .26935 L
.67233 .26437 L
.67333 .25925 L
.67433 .25405 L
.67532 .24881 L
.67632 .2436 L
.67732 .23848 L
.67832 .23353 L
.67932 .22886 L
.68032 .22454 L
.68132 .22067 L
.68232 .21737 L
.68332 .21472 L
.68432 .21281 L
.68531 .21172 L
.68631 .21151 L
.68731 .21222 L
.68831 .21388 L
.68931 .21647 L
.69031 .21998 L
.69131 .22436 L
.69231 .22954 L
.69331 .23544 L
.69431 .24196 L
.6953 .24898 L
.6963 .25638 L
.6973 .26403 L
.6983 .27181 L
Mistroke
.6993 .29351 L
.7003 .30064 L
.7013 .30739 L
.7023 .31371 L
.7033 .31954 L
.7043 .32489 L
.70529 .32974 L
.70629 .3341 L
.70729 .33798 L
.70829 .34142 L
.70929 .34444 L
.71029 .34707 L
.71129 .34934 L
.71229 .35127 L
.71329 .35291 L
.71429 .35429 L
.71528 .35541 L
.71628 .35632 L
.71728 .35704 L
.71828 .35757 L
.71928 .35795 L
.72028 .35819 L
.72128 .3583 L
.72228 .35829 L
.72328 .35816 L
.72428 .35794 L
.72527 .35762 L
.72627 .35721 L
.72727 .3567 L
.72827 .35612 L
.72927 .35544 L
.73027 .35468 L
.73127 .35383 L
.73227 .3529 L
.73327 .35188 L
.73427 .35077 L
.73526 .34957 L
.73626 .34829 L
.73726 .34691 L
.73826 .34546 L
.73926 .34392 L
.74026 .34231 L
.74126 .34064 L
.74226 .33892 L
.74326 .33718 L
.74426 .33545 L
.74525 .33376 L
.74625 .33216 L
.74725 .33071 L
.74825 .32947 L
Mistroke
.74925 .26001 L
.75025 .24962 L
.75125 .23886 L
.75225 .22777 L
.75325 .21642 L
.75425 .20497 L
.75524 .19362 L
.75624 .18264 L
.75724 .17238 L
.75824 .16324 L
.75924 .15567 L
.76024 .15016 L
.76124 .14717 L
.76224 .14713 L
.76324 .15033 L
.76424 .15691 L
.76523 .16681 L
.76623 .17977 L
.76723 .19534 L
.76823 .21292 L
.76923 .23184 L
.77023 .25144 L
.77123 .27108 L
.77223 .29026 L
.77323 .30857 L
.77423 .32571 L
.77522 .34152 L
.77622 .35592 L
.77722 .36888 L
.77822 .38046 L
.77922 .39072 L
.78022 .39977 L
.78122 .4077 L
.78222 .41463 L
.78322 .42067 L
.78422 .42593 L
.78521 .4305 L
.78621 .43447 L
.78721 .43793 L
.78821 .44095 L
.78921 .4436 L
.79021 .44593 L
.79121 .44801 L
.79221 .44987 L
.79321 .45155 L
.79421 .4531 L
.7952 .45454 L
.7962 .45591 L
.7972 .45721 L
.7982 .45848 L
Mistroke
.7992 .4739 L
.8002 .47651 L
.8012 .47883 L
.8022 .48087 L
.8032 .48264 L
.8042 .48416 L
.80519 .48543 L
.80619 .48646 L
.80719 .48725 L
.80819 .48781 L
.80919 .48813 L
.81019 .48823 L
.81119 .48811 L
.81219 .48777 L
.81319 .48723 L
.81419 .4865 L
.81518 .48558 L
.81618 .4845 L
.81718 .48327 L
.81818 .4819 L
.81918 .48043 L
.82018 .47886 L
.82118 .47722 L
.82218 .47553 L
.82318 .47381 L
.82418 .47208 L
.82517 .47037 L
.82617 .46869 L
.82717 .46706 L
.82817 .46549 L
.82917 .46401 L
.83017 .46261 L
.83117 .46132 L
.83217 .46015 L
.83317 .45909 L
.83417 .45817 L
.83516 .45738 L
.83616 .45672 L
.83716 .4562 L
.83816 .45583 L
.83916 .45559 L
.84016 .45549 L
.84116 .45553 L
.84216 .45571 L
.84316 .45601 L
.84416 .45645 L
.84515 .45701 L
.84615 .45769 L
.84715 .45848 L
.84815 .45938 L
Mistroke
.84915 .51034 L
.85015 .51051 L
.85115 .51026 L
.85215 .50956 L
.85315 .50841 L
.85415 .5068 L
.85514 .50475 L
.85614 .50229 L
.85714 .49944 L
.85814 .49625 L
.85914 .49276 L
.86014 .48904 L
.86114 .48514 L
.86214 .48112 L
.86314 .47704 L
.86414 .47296 L
.86513 .46892 L
.86613 .46499 L
.86713 .46119 L
.86813 .45758 L
.86913 .45417 L
.87013 .451 L
.87113 .44808 L
.87213 .44542 L
.87313 .44304 L
.87413 .44093 L
.87512 .43911 L
.87612 .43757 L
.87712 .4363 L
.87812 .43531 L
.87912 .43458 L
.88012 .4341 L
.88112 .43388 L
.88212 .43391 L
.88312 .43417 L
.88412 .43466 L
.88511 .43537 L
.88611 .4363 L
.88711 .43744 L
.88811 .43879 L
.88911 .44033 L
.89011 .44207 L
.89111 .44399 L
.89211 .44609 L
.89311 .44837 L
.89411 .45081 L
.8951 .4534 L
.8961 .45614 L
.8971 .45901 L
.8981 .462 L
Mistroke
.8991 .45825 L
.9001 .4641 L
.9011 .47039 L
.9021 .4771 L
.9031 .4842 L
.9041 .49167 L
.90509 .49944 L
.90609 .50744 L
.90709 .51559 L
.90809 .52374 L
.90909 .53176 L
.91009 .53945 L
.91109 .5466 L
.91209 .55297 L
.91309 .55831 L
.91409 .56234 L
.91508 .56481 L
.91608 .56551 L
.91708 .56425 L
.91808 .56094 L
.91908 .55558 L
.92008 .54824 L
.92108 .53911 L
.92208 .52845 L
.92308 .51658 L
.92408 .50385 L
.92507 .49061 L
.92607 .47722 L
.92707 .46397 L
.92807 .45112 L
.92907 .43887 L
.93007 .42735 L
.93107 .41666 L
.93207 .40684 L
.93307 .39791 L
.93407 .38985 L
.93506 .38262 L
.93606 .37616 L
.93706 .37042 L
.93806 .36532 L
.93906 .3608 L
.94006 .35678 L
.94106 .35319 L
.94206 .34999 L
.94306 .34709 L
.94406 .34446 L
.94505 .34204 L
.94605 .33979 L
.94705 .33767 L
.94805 .33563 L
Mistroke
.94905 .32972 L
.95005 .32847 L
.95105 .32704 L
.95205 .32543 L
.95305 .32364 L
.95405 .32164 L
.95504 .31944 L
.95604 .31702 L
.95704 .31437 L
.95804 .31149 L
.95904 .30836 L
.96004 .30498 L
.96104 .30133 L
.96204 .2974 L
.96304 .29319 L
.96404 .2887 L
.96503 .28392 L
.96603 .27885 L
.96703 .27352 L
.96803 .26792 L
.96903 .26209 L
.97003 .25607 L
.97103 .24989 L
.97203 .24363 L
.97303 .23735 L
.97403 .23114 L
.97502 .22511 L
.97602 .21938 L
.97702 .21408 L
.97802 .20935 L
.97902 .20533 L
.98002 .20217 L
.98102 .19999 L
.98202 .19891 L
.98302 .19901 L
.98402 .20035 L
.98501 .20296 L
.98601 .20681 L
.98701 .21186 L
.98801 .21801 L
.98901 .22514 L
.99001 .23311 L
.99101 .24175 L
.99201 .25089 L
.99301 .26033 L
.99401 .26991 L
.995 .27947 L
.996 .28884 L
.997 .2979 L
.998 .30655 L
Mistroke
.999 .31365 L
Mfstroke
0 g
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .30606 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28377 L
.005 .2789 L
.00599 .27359 L
.00699 .26776 L
.00799 .26135 L
.00899 .25427 L
.00999 .24643 L
.01099 .23771 L
.01199 .22802 L
.01299 .21723 L
.01399 .20521 L
.01499 .1918 L
.01598 .17686 L
.01698 .16023 L
.01798 .14173 L
.01898 .1212 L
.01998 .09848 L
.02098 .07344 L
.02198 .04598 L
.02298 .01607 L
s
.02298 .01607 m
.02347 0 L
s
.04021 0 m
.04096 .05292 L
.04196 .12103 L
.04296 .17563 L
.04396 .19702 L
.04496 .16425 L
.04595 .08959 L
.04695 .00686 L
s
.04695 .00686 m
.04705 0 L
s
.0498 0 m
.04995 .02048 L
.05095 .0417 L
.05195 .07378 L
.05295 .11494 L
.05395 .1622 L
.05495 .21175 L
.05594 .25957 L
.05694 .30223 L
.05794 .33742 L
.05894 .36423 L
.05994 .38302 L
.06094 .39501 L
.06194 .4018 L
.06294 .40499 L
.06394 .40594 L
.06494 .40568 L
.06593 .40488 L
.06693 .40388 L
.06793 .40263 L
.06893 .40065 L
.06993 .39697 L
.07093 .39033 L
.07193 .37988 L
.07293 .36581 L
.07393 .34917 L
.07493 .33118 L
.07592 .31289 L
.07692 .29509 L
.07792 .27837 L
.07892 .26314 L
.07992 .24965 L
.08092 .23804 L
.08192 .22831 L
.08292 .22042 L
.08392 .21424 L
.08492 .20963 L
.08591 .20639 L
.08691 .20434 L
.08791 .20329 L
.08891 .20305 L
.08991 .20345 L
.09091 .20431 L
.09191 .2055 L
.09291 .20686 L
.09391 .20828 L
.09491 .20965 L
.0959 .21089 L
.0969 .21194 L
.0979 .21273 L
Mistroke
.0989 .21324 L
.0999 .3247 L
.1009 .32222 L
.1019 .32099 L
.1029 .32032 L
.1039 .31997 L
.1049 .31984 L
.10589 .31988 L
.10689 .32003 L
.10789 .32028 L
.10889 .32062 L
.10989 .32104 L
.11089 .32154 L
.11189 .32211 L
.11289 .32278 L
.11389 .32354 L
.11489 .32441 L
.11588 .3254 L
.11688 .32654 L
.11788 .32785 L
.11888 .32937 L
.11988 .33112 L
.12088 .33315 L
.12188 .33552 L
.12288 .33827 L
.12388 .34149 L
.12488 .34524 L
.12587 .34961 L
.12687 .35467 L
.12787 .36052 L
.12887 .3672 L
.12987 .37474 L
.13087 .38307 L
.13187 .39198 L
.13287 .401 L
.13387 .40916 L
.13487 .41476 L
.13586 .41531 L
.13686 .40856 L
.13786 .39421 L
.13886 .37389 L
.13986 .34982 L
.14086 .32405 L
.14186 .29833 L
.14286 .27414 L
.14386 .25265 L
.14486 .2347 L
.14585 .22075 L
.14685 .21089 L
.14785 .20484 L
Mistroke
.14885 .20202 L
.14985 .35545 L
.15085 .33231 L
.15185 .31231 L
.15285 .29542 L
.15385 .28162 L
.15485 .27076 L
.15584 .26251 L
.15684 .25648 L
.15784 .25226 L
.15884 .24943 L
.15984 .24762 L
.16084 .24652 L
.16184 .24586 L
.16284 .24542 L
.16384 .24505 L
.16484 .2446 L
.16583 .24397 L
.16683 .2431 L
.16783 .24193 L
.16883 .24042 L
.16983 .23853 L
.17083 .23624 L
.17183 .23354 L
.17283 .23041 L
.17383 .22683 L
.17483 .2228 L
.17582 .21831 L
.17682 .21334 L
.17782 .20787 L
.17882 .20191 L
.17982 .19543 L
.18082 .18842 L
.18182 .18089 L
.18282 .17283 L
.18382 .16425 L
.18482 .15517 L
.18581 .1456 L
.18681 .1356 L
.18781 .12523 L
.18881 .11458 L
.18981 .10375 L
.19081 .09289 L
.19181 .08217 L
.19281 .07182 L
.19381 .06207 L
.19481 .05319 L
.1958 .04548 L
.1968 .03922 L
.1978 .03469 L
Mistroke
.1988 .03212 L
.1998 .15608 L
.2008 .14558 L
.2018 .13564 L
.2028 .12583 L
.2038 .11625 L
.2048 .10717 L
.20579 .09892 L
.20679 .09191 L
.20779 .08657 L
.20879 .08333 L
.20979 .08251 L
.21079 .08437 L
.21179 .08894 L
.21279 .09612 L
.21379 .10567 L
.21479 .11728 L
.21578 .13067 L
.21678 .14552 L
.21778 .16146 L
.21878 .17805 L
.21978 .19478 L
.22078 .21108 L
.22178 .22644 L
.22278 .24039 L
.22378 .25263 L
.22478 .26297 L
.22577 .27138 L
.22677 .27796 L
.22777 .28287 L
.22877 .28633 L
.22977 .28856 L
.23077 .2898 L
.23177 .29024 L
.23277 .29005 L
.23377 .28936 L
.23477 .28829 L
.23576 .2869 L
.23676 .28528 L
.23776 .28346 L
.23876 .28147 L
.23976 .27934 L
.24076 .27707 L
.24176 .27468 L
.24276 .27216 L
.24376 .2695 L
.24476 .2667 L
.24575 .26375 L
.24675 .26062 L
.24775 .25731 L
Mistroke
.24875 .25381 L
.24975 .38847 L
.25075 .38741 L
.25175 .38759 L
.25275 .38834 L
.25375 .38941 L
.25475 .3907 L
.25574 .39213 L
.25674 .39366 L
.25774 .39522 L
.25874 .3968 L
.25974 .39833 L
.26074 .39978 L
.26174 .4011 L
.26274 .40222 L
.26374 .40309 L
.26474 .40362 L
.26573 .40374 L
.26673 .40333 L
.26773 .40229 L
.26873 .4005 L
.26973 .39789 L
.27073 .39435 L
.27173 .38987 L
.27273 .38447 L
.27373 .37823 L
.27473 .3713 L
.27572 .36388 L
.27672 .35618 L
.27772 .34843 L
.27872 .34085 L
.27972 .33361 L
.28072 .32687 L
.28172 .32073 L
.28272 .31526 L
.28372 .31049 L
.28472 .3064 L
.28571 .30297 L
.28671 .30015 L
.28771 .29788 L
.28871 .29608 L
.28971 .29471 L
.29071 .29368 L
.29171 .29294 L
.29271 .29244 L
.29371 .29213 L
.29471 .29197 L
.2957 .29193 L
.2967 .29197 L
.2977 .29206 L
Mistroke
.2987 .2922 L
.2997 .34438 L
.3007 .34209 L
.3017 .34113 L
.3027 .34081 L
.3037 .34093 L
.3047 .34136 L
.30569 .34204 L
.30669 .34296 L
.30769 .34407 L
.30869 .34537 L
.30969 .34685 L
.31069 .34853 L
.31169 .35039 L
.31269 .35244 L
.31369 .35471 L
.31469 .3572 L
.31568 .35993 L
.31668 .36291 L
.31768 .36616 L
.31868 .3697 L
.31968 .37354 L
.32068 .37769 L
.32168 .38215 L
.32268 .38689 L
.32368 .39187 L
.32468 .39701 L
.32567 .40216 L
.32667 .4071 L
.32767 .41146 L
.32867 .41474 L
.32967 .41627 L
.33067 .41535 L
.33167 .41142 L
.33267 .40429 L
.33367 .39423 L
.33467 .38181 L
.33566 .36778 L
.33666 .35288 L
.33766 .33785 L
.33866 .32336 L
.33966 .30993 L
.34066 .29798 L
.34166 .28775 L
.34266 .27931 L
.34366 .27261 L
.34466 .26745 L
.34565 .26356 L
.34665 .26063 L
.34765 .25836 L
Mistroke
.34865 .25649 L
.34965 .37539 L
.35065 .36167 L
.35165 .34964 L
.35265 .33891 L
.35365 .32943 L
.35465 .32116 L
.35564 .31409 L
.35664 .30813 L
.35764 .30322 L
.35864 .29923 L
.35964 .29605 L
.36064 .29357 L
.36164 .29165 L
.36264 .29021 L
.36364 .28912 L
.36464 .28831 L
.36563 .2877 L
.36663 .28721 L
.36763 .2868 L
.36863 .28642 L
.36963 .28602 L
.37063 .28558 L
.37163 .28507 L
.37263 .28447 L
.37363 .28377 L
.37463 .28294 L
.37562 .28199 L
.37662 .2809 L
.37762 .27966 L
.37862 .27827 L
.37962 .27672 L
.38062 .275 L
.38162 .27312 L
.38262 .27107 L
.38362 .26883 L
.38462 .26642 L
.38561 .26383 L
.38661 .26105 L
.38761 .2581 L
.38861 .25497 L
.38961 .25167 L
.39061 .24822 L
.39161 .24462 L
.39261 .2409 L
.39361 .23709 L
.39461 .2332 L
.3956 .22929 L
.3966 .22537 L
.3976 .22151 L
Mistroke
.3986 .21771 L
.3996 .25252 L
.4006 .24269 L
.4016 .2337 L
.4026 .22473 L
.4036 .2155 L
.4046 .20587 L
.40559 .19575 L
.40659 .18511 L
.40759 .17393 L
.40859 .16224 L
.40959 .15009 L
.41059 .13761 L
.41159 .12494 L
.41259 .11233 L
.41359 .10007 L
.41459 .08856 L
.41558 .07825 L
.41658 .06964 L
.41758 .06324 L
.41858 .05943 L
.41958 .05822 L
.42058 .05895 L
.42158 .06013 L
.42258 .06033 L
.42358 .05975 L
.42458 .05989 L
.42557 .06244 L
.42657 .0687 L
.42757 .07947 L
.42857 .09506 L
.42957 .11519 L
.43057 .13903 L
.43157 .1653 L
.43257 .19245 L
.43357 .21889 L
.43457 .24319 L
.43556 .26433 L
.43656 .28176 L
.43756 .29539 L
.43856 .30554 L
.43956 .31274 L
.44056 .31762 L
.44156 .32075 L
.44256 .32262 L
.44356 .3236 L
.44456 .32398 L
.44555 .32397 L
.44655 .3237 L
.44755 .3233 L
Mistroke
.44855 .32284 L
.44955 .37395 L
.45055 .36881 L
.45155 .36496 L
.45255 .36177 L
.45355 .35906 L
.45455 .35675 L
.45554 .35477 L
.45654 .3531 L
.45754 .3517 L
.45854 .35056 L
.45954 .34966 L
.46054 .34897 L
.46154 .34848 L
.46254 .34818 L
.46354 .34806 L
.46454 .34811 L
.46553 .34831 L
.46653 .34866 L
.46753 .34915 L
.46853 .34978 L
.46953 .35054 L
.47053 .35142 L
.47153 .35242 L
.47253 .35353 L
.47353 .35474 L
.47453 .35605 L
.47552 .35742 L
.47652 .35886 L
.47752 .36034 L
.47852 .36183 L
.47952 .3633 L
.48052 .3647 L
.48152 .36598 L
.48252 .36708 L
.48352 .36794 L
.48452 .36848 L
.48551 .36862 L
.48651 .3683 L
.48751 .36744 L
.48851 .36602 L
.48951 .364 L
.49051 .36139 L
.49151 .35824 L
.49251 .3546 L
.49351 .35055 L
.49451 .34619 L
.4955 .34162 L
.4965 .33695 L
.4975 .33229 L
Mistroke
.4985 .32771 L
.4995 .3841 L
.5005 .36568 L
.5015 .34887 L
.5025 .33353 L
.5035 .31978 L
.5045 .30777 L
.50549 .29752 L
.50649 .28899 L
.50749 .28206 L
.50849 .27658 L
.50949 .27235 L
.51049 .26917 L
.51149 .26683 L
.51249 .26515 L
.51349 .26396 L
.51449 .26312 L
.51548 .2625 L
.51648 .262 L
.51748 .26152 L
.51848 .26101 L
.51948 .26039 L
.52048 .25963 L
.52148 .25868 L
.52248 .25753 L
.52348 .25614 L
.52448 .25449 L
.52547 .25257 L
.52647 .25035 L
.52747 .24783 L
.52847 .24499 L
.52947 .24181 L
.53047 .23828 L
.53147 .23437 L
.53247 .23007 L
.53347 .22536 L
.53447 .22021 L
.53546 .2146 L
.53646 .2085 L
.53746 .20189 L
.53846 .19473 L
.53946 .18699 L
.54046 .17866 L
.54146 .16969 L
.54246 .16008 L
.54346 .14979 L
.54446 .13882 L
.54545 .12717 L
.54645 .11483 L
.54745 .10184 L
Mistroke
.54845 .08825 L
.54945 .38641 L
.55045 .38716 L
.55145 .38973 L
.55245 .39334 L
.55345 .39775 L
.55445 .40282 L
.55544 .4085 L
.55644 .41474 L
.55744 .42149 L
.55844 .4287 L
.55944 .43631 L
.56044 .44424 L
.56144 .45235 L
.56244 .46045 L
.56344 .46829 L
.56444 .47544 L
.56543 .48129 L
.56643 .48492 L
.56743 .485 L
.56843 .47991 L
.56943 .46841 L
.57043 .45031 L
.57143 .42651 L
.57243 .39854 L
.57343 .36822 L
.57443 .33744 L
.57542 .30797 L
.57642 .28125 L
.57742 .25827 L
.57842 .23947 L
.57942 .22481 L
.58042 .21388 L
.58142 .20606 L
.58242 .20069 L
.58342 .19717 L
.58442 .19502 L
.58541 .19389 L
.58641 .19353 L
.58741 .19371 L
.58841 .19428 L
.58941 .19508 L
.59041 .19597 L
.59141 .19685 L
.59241 .19763 L
.59341 .19825 L
.59441 .19864 L
.5954 .19879 L
.5964 .19868 L
.5974 .1983 L
Mistroke
.5984 .19765 L
.5994 .23328 L
.6004 .22901 L
.6014 .2256 L
.6024 .22237 L
.6034 .21911 L
.6044 .2157 L
.60539 .21211 L
.60639 .20831 L
.60739 .20429 L
.60839 .20005 L
.60939 .19562 L
.61039 .191 L
.61139 .18624 L
.61239 .18137 L
.61339 .17644 L
.61439 .1715 L
.61538 .16661 L
.61638 .16184 L
.61738 .15727 L
.61838 .15296 L
.61938 .14901 L
.62038 .14547 L
.62138 .1424 L
.62238 .13984 L
.62338 .13777 L
.62438 .13617 L
.62537 .13496 L
.62637 .13401 L
.62737 .13321 L
.62837 .13248 L
.62937 .1318 L
.63037 .13123 L
.63137 .13091 L
.63237 .131 L
.63337 .13171 L
.63437 .13317 L
.63536 .13552 L
.63636 .13883 L
.63736 .14311 L
.63836 .1483 L
.63936 .1543 L
.64036 .16095 L
.64136 .16805 L
.64236 .17539 L
.64336 .18273 L
.64436 .18985 L
.64535 .19657 L
.64635 .20273 L
.64735 .20821 L
Mistroke
.64835 .21296 L
.64935 .2604 L
.65035 .25482 L
.65135 .25019 L
.65235 .24584 L
.65335 .24154 L
.65435 .23717 L
.65534 .23266 L
.65634 .22797 L
.65734 .22307 L
.65834 .21794 L
.65934 .21255 L
.66034 .20691 L
.66134 .20101 L
.66234 .19486 L
.66334 .18849 L
.66434 .18191 L
.66533 .17518 L
.66633 .16834 L
.66733 .16147 L
.66833 .15464 L
.66933 .14798 L
.67033 .14158 L
.67133 .1356 L
.67233 .13017 L
.67333 .12543 L
.67433 .12152 L
.67532 .11851 L
.67632 .1164 L
.67732 .11506 L
.67832 .11421 L
.67932 .11336 L
.68032 .11199 L
.68132 .10978 L
.68232 .10676 L
.68332 .10336 L
.68432 .10017 L
.68531 .09779 L
.68631 .09679 L
.68731 .0976 L
.68831 .10055 L
.68931 .1058 L
.69031 .11335 L
.69131 .12304 L
.69231 .13454 L
.69331 .14739 L
.69431 .16103 L
.6953 .17486 L
.6963 .1883 L
.6973 .20082 L
Mistroke
.6983 .21204 L
.6993 .29506 L
.7003 .29405 L
.7013 .29344 L
.7023 .29271 L
.7033 .29175 L
.7043 .29058 L
.70529 .28921 L
.70629 .28768 L
.70729 .286 L
.70829 .2842 L
.70929 .28229 L
.71029 .28029 L
.71129 .27819 L
.71229 .27599 L
.71329 .27369 L
.71429 .27127 L
.71528 .26873 L
.71628 .26604 L
.71728 .26319 L
.71828 .26016 L
.71928 .25692 L
.72028 .25346 L
.72128 .24976 L
.72228 .24577 L
.72328 .24149 L
.72428 .23687 L
.72527 .2319 L
.72627 .22653 L
.72727 .22074 L
.72827 .21449 L
.72927 .20775 L
.73027 .20049 L
.73127 .19266 L
.73227 .18425 L
.73327 .17521 L
.73427 .16552 L
.73526 .15516 L
.73626 .14411 L
.73726 .13237 L
.73826 .11995 L
.73926 .10688 L
.74026 .09321 L
.74126 .079 L
.74226 .06439 L
.74326 .0495 L
.74426 .03455 L
.74525 .01976 L
.74625 .00543 L
Mfstroke
.74625 .00543 m
.74665 0 L
s
.74839 0 m
.74925 .12743 L
.75025 .11165 L
.75125 .09696 L
.75225 .08311 L
.75325 .07047 L
.75425 .05965 L
.75524 .05138 L
.75624 .04644 L
.75724 .04551 L
.75824 .04912 L
.75924 .05748 L
.76024 .07048 L
.76124 .08782 L
.76224 .10908 L
.76324 .13371 L
.76424 .16092 L
.76523 .18963 L
.76623 .21855 L
.76723 .24635 L
.76823 .2718 L
.76923 .294 L
.77023 .31242 L
.77123 .32696 L
.77223 .33786 L
.77323 .34557 L
.77423 .35065 L
.77522 .35369 L
.77622 .35521 L
.77722 .35564 L
.77822 .35535 L
.77922 .3546 L
.78022 .3536 L
.78122 .3525 L
.78222 .35141 L
.78322 .35041 L
.78422 .34954 L
.78521 .34882 L
.78621 .34828 L
.78721 .3479 L
.78821 .34768 L
.78921 .34759 L
.79021 .34762 L
.79121 .34773 L
.79221 .34789 L
.79321 .34808 L
.79421 .34826 L
.7952 .34841 L
.7962 .3485 L
.7972 .34852 L
Mistroke
.7982 .34845 L
.7992 .41 L
.8002 .40578 L
.8012 .4026 L
.8022 .39981 L
.8032 .39718 L
.8042 .39461 L
.80519 .39204 L
.80619 .38945 L
.80719 .38681 L
.80819 .38411 L
.80919 .38135 L
.81019 .37854 L
.81119 .37566 L
.81219 .37275 L
.81319 .36979 L
.81419 .36682 L
.81518 .36384 L
.81618 .36087 L
.81718 .35794 L
.81818 .35506 L
.81918 .35226 L
.82018 .34955 L
.82118 .34697 L
.82218 .34452 L
.82318 .34222 L
.82418 .3401 L
.82517 .33816 L
.82617 .3364 L
.82717 .33484 L
.82817 .33347 L
.82917 .33229 L
.83017 .33131 L
.83117 .33051 L
.83217 .32988 L
.83317 .32943 L
.83417 .32914 L
.83516 .329 L
.83616 .329 L
.83716 .32914 L
.83816 .32941 L
.83916 .32979 L
.84016 .33029 L
.84116 .3309 L
.84216 .33161 L
.84316 .33241 L
.84416 .3333 L
.84515 .33428 L
.84615 .33532 L
.84715 .33643 L
Mistroke
.84815 .3376 L
.84915 .42042 L
.85015 .41312 L
.85115 .40643 L
.85215 .39977 L
.85315 .39305 L
.85415 .38627 L
.85514 .37949 L
.85614 .37277 L
.85714 .3662 L
.85814 .35986 L
.85914 .35383 L
.86014 .34816 L
.86114 .3429 L
.86214 .33809 L
.86314 .33376 L
.86414 .32992 L
.86513 .32655 L
.86613 .32365 L
.86713 .3212 L
.86813 .31916 L
.86913 .3175 L
.87013 .3162 L
.87113 .3152 L
.87213 .31449 L
.87313 .31402 L
.87413 .31376 L
.87512 .31369 L
.87612 .31377 L
.87712 .314 L
.87812 .31435 L
.87912 .31481 L
.88012 .31536 L
.88112 .31601 L
.88212 .31675 L
.88312 .31757 L
.88412 .31849 L
.88511 .3195 L
.88611 .32062 L
.88711 .32186 L
.88811 .32322 L
.88911 .32472 L
.89011 .32638 L
.89111 .32822 L
.89211 .33025 L
.89311 .3325 L
.89411 .33497 L
.8951 .33768 L
.8961 .34065 L
.8971 .34388 L
Mistroke
.8981 .34736 L
.8991 .42267 L
.9001 .42706 L
.9011 .43277 L
.9021 .43902 L
.9031 .44551 L
.9041 .45205 L
.90509 .45842 L
.90609 .46444 L
.90709 .46983 L
.90809 .4743 L
.90909 .47748 L
.91009 .47889 L
.91109 .47801 L
.91209 .47418 L
.91309 .4668 L
.91409 .45539 L
.91508 .43985 L
.91608 .42053 L
.91708 .39827 L
.91808 .3742 L
.91908 .34956 L
.92008 .32558 L
.92108 .3033 L
.92208 .28348 L
.92308 .26657 L
.92408 .2527 L
.92507 .24175 L
.92607 .23343 L
.92707 .22737 L
.92807 .22316 L
.92907 .22042 L
.93007 .21879 L
.93107 .21797 L
.93207 .21769 L
.93307 .21775 L
.93407 .21796 L
.93506 .21818 L
.93606 .2183 L
.93706 .21823 L
.93806 .21791 L
.93906 .21729 L
.94006 .21634 L
.94106 .21503 L
.94206 .21335 L
.94306 .2113 L
.94406 .20888 L
.94505 .20609 L
.94605 .20293 L
.94705 .19941 L
Mistroke
.94805 .19555 L
.94905 .25853 L
.95005 .25212 L
.95105 .24665 L
.95205 .24139 L
.95305 .23611 L
.95405 .23069 L
.95504 .22505 L
.95604 .21914 L
.95704 .21293 L
.95804 .20641 L
.95904 .19956 L
.96004 .19239 L
.96104 .18492 L
.96204 .17717 L
.96304 .1692 L
.96404 .16107 L
.96503 .15287 L
.96603 .14471 L
.96703 .13674 L
.96803 .12913 L
.96903 .12205 L
.97003 .11573 L
.97103 .11037 L
.97203 .10615 L
.97303 .10318 L
.97403 .10143 L
.97502 .10062 L
.97602 .10019 L
.97702 .09933 L
.97802 .09746 L
.97902 .09458 L
.98002 .09132 L
.98102 .08852 L
.98202 .08702 L
.98302 .08751 L
.98402 .09052 L
.98501 .09635 L
.98601 .1051 L
.98701 .1166 L
.98801 .13047 L
.98901 .14611 L
.99001 .16277 L
.99101 .17967 L
.99201 .19599 L
.99301 .21108 L
.99401 .22441 L
.995 .2357 L
.996 .24486 L
.997 .252 L
Mistroke
.998 .25735 L
.999 .30606 L
Mfstroke
gsave
.999 .31865 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32501 L
.005 .328 L
.00599 .33136 L
.00699 .33513 L
.00799 .33933 L
.00899 .34402 L
.00999 .34923 L
.01099 .35502 L
.01199 .36148 L
.01299 .36867 L
.01399 .3767 L
.01499 .38565 L
.01598 .39563 L
.01698 .40678 L
.01798 .4192 L
.01898 .43305 L
.01998 .44847 L
.02098 .46559 L
.02198 .48455 L
.02298 .5055 L
.02398 .52852 L
.02498 .55368 L
.02597 .581 L
.02697 .6104 L
s
.02697 .6104 m
.02722 .61803 L
s
.04366 .61803 m
.04396 .59607 L
.04496 .56144 L
.04595 .56398 L
.04695 .57869 L
.04795 .59109 L
.04895 .59711 L
.04995 .03324 L
.05095 .06411 L
.05195 .10578 L
.05295 .15741 L
.05395 .21647 L
.05495 .27894 L
.05594 .34006 L
.05694 .39533 L
.05794 .44157 L
.05894 .47731 L
.05994 .50274 L
.06094 .51913 L
.06194 .52821 L
.06294 .53168 L
.06394 .53095 L
.06494 .52705 L
.06593 .52074 L
.06693 .51259 L
.06793 .50322 L
.06893 .49346 L
.06993 .48453 L
.07093 .4779 L
.07193 .47467 L
.07293 .47488 L
.07393 .47777 L
.07493 .48239 L
.07592 .48799 L
.07692 .49398 L
.07792 .49995 L
.07892 .50557 L
.07992 .51063 L
.08092 .51495 L
.08192 .5184 L
.08292 .52091 L
.08392 .52242 L
.08492 .52293 L
.08591 .52245 L
.08691 .521 L
.08791 .51867 L
.08891 .51552 L
.08991 .51168 L
.09091 .50727 L
.09191 .50242 L
Mistroke
.09291 .49729 L
.09391 .49204 L
.09491 .4868 L
.0959 .48173 L
.0969 .47694 L
.0979 .47254 L
.0989 .46863 L
.0999 .33719 L
.1009 .34266 L
.1019 .34708 L
.1029 .35115 L
.1039 .3551 L
.1049 .35907 L
.10589 .36314 L
.10689 .36737 L
.10789 .37181 L
.10889 .3765 L
.10989 .38148 L
.11089 .3868 L
.11189 .39247 L
.11289 .39853 L
.11389 .405 L
.11489 .41191 L
.11588 .41927 L
.11688 .42708 L
.11788 .43535 L
.11888 .44405 L
.11988 .45316 L
.12088 .46261 L
.12188 .47234 L
.12288 .48223 L
.12388 .49213 L
.12488 .50185 L
.12587 .51118 L
.12687 .51981 L
.12787 .52745 L
.12887 .53373 L
.12987 .53831 L
.13087 .54088 L
.13187 .54126 L
.13287 .53953 L
.13387 .53628 L
.13487 .53291 L
.13586 .53167 L
.13686 .53471 L
.13786 .54236 L
.13886 .55313 L
.13986 .56504 L
.14086 .57634 L
.14186 .5856 L
Mistroke
.14286 .59161 L
.14386 .59343 L
.14486 .59037 L
.14585 .5821 L
.14685 .56868 L
.14785 .55063 L
.14885 .52886 L
.14985 .36811 L
.15085 .35358 L
.15185 .34035 L
.15285 .32918 L
.15385 .32028 L
.15485 .31359 L
.15584 .30891 L
.15684 .30595 L
.15784 .30439 L
.15884 .30392 L
.15984 .30428 L
.16084 .30523 L
.16184 .30659 L
.16284 .30821 L
.16384 .31 L
.16484 .31187 L
.16583 .31378 L
.16683 .31569 L
.16783 .31758 L
.16883 .31945 L
.16983 .3213 L
.17083 .32314 L
.17183 .32497 L
.17283 .3268 L
.17383 .32866 L
.17483 .33055 L
.17582 .33248 L
.17682 .33448 L
.17782 .33656 L
.17882 .33872 L
.17982 .34099 L
.18082 .34336 L
.18182 .34586 L
.18282 .34848 L
.18382 .35123 L
.18482 .3541 L
.18581 .3571 L
.18681 .36021 L
.18781 .36342 L
.18881 .36671 L
.18981 .37005 L
.19081 .37341 L
.19181 .37674 L
Mistroke
.19281 .37999 L
.19381 .38312 L
.19481 .38608 L
.1958 .38882 L
.1968 .39133 L
.1978 .39358 L
.1988 .39564 L
.1998 .1687 L
.2008 .16623 L
.2018 .16227 L
.2028 .15771 L
.2038 .15298 L
.2048 .14841 L
.20579 .14433 L
.20679 .14108 L
.20779 .13901 L
.20879 .13855 L
.20979 .14013 L
.21079 .14425 L
.21179 .15138 L
.21279 .16192 L
.21379 .17605 L
.21479 .19362 L
.21578 .21404 L
.21678 .23641 L
.21778 .25958 L
.21878 .28241 L
.21978 .30385 L
.22078 .3231 L
.22178 .33969 L
.22278 .35341 L
.22378 .36433 L
.22478 .37268 L
.22577 .37882 L
.22677 .38312 L
.22777 .38597 L
.22877 .38771 L
.22977 .38866 L
.23077 .38908 L
.23177 .38921 L
.23277 .38921 L
.23377 .38924 L
.23477 .38941 L
.23576 .38981 L
.23676 .39052 L
.23776 .39158 L
.23876 .39303 L
.23976 .39489 L
.24076 .39718 L
.24176 .39991 L
Mistroke
.24276 .4031 L
.24376 .40675 L
.24476 .41087 L
.24575 .41546 L
.24675 .42052 L
.24775 .42607 L
.24875 .43211 L
.24975 .4009 L
.25075 .40787 L
.25175 .41385 L
.25275 .41949 L
.25375 .42498 L
.25475 .43036 L
.25574 .43566 L
.25674 .44085 L
.25774 .4459 L
.25874 .45074 L
.25974 .45532 L
.26074 .45957 L
.26174 .4634 L
.26274 .46675 L
.26374 .46954 L
.26474 .47171 L
.26573 .47322 L
.26673 .47405 L
.26773 .47422 L
.26873 .47375 L
.26973 .47272 L
.27073 .47119 L
.27173 .46924 L
.27273 .46694 L
.27373 .46433 L
.27473 .46142 L
.27572 .45824 L
.27672 .45478 L
.27772 .45106 L
.27872 .4471 L
.27972 .44294 L
.28072 .43863 L
.28172 .43425 L
.28272 .42988 L
.28372 .42559 L
.28472 .42147 L
.28571 .4176 L
.28671 .41404 L
.28771 .41085 L
.28871 .40806 L
.28971 .40571 L
.29071 .4038 L
.29171 .40233 L
Mistroke
.29271 .40131 L
.29371 .40071 L
.29471 .40053 L
.2957 .40075 L
.2967 .40133 L
.2977 .40228 L
.2987 .40357 L
.2997 .35685 L
.3007 .3625 L
.3017 .36718 L
.3027 .37157 L
.3037 .3759 L
.3047 .38029 L
.30569 .3848 L
.30669 .38948 L
.30769 .39437 L
.30869 .39949 L
.30969 .40485 L
.31069 .41047 L
.31169 .41634 L
.31269 .42248 L
.31369 .42885 L
.31469 .43544 L
.31568 .4422 L
.31668 .44909 L
.31768 .45605 L
.31868 .46298 L
.31968 .46978 L
.32068 .47635 L
.32168 .48254 L
.32268 .48821 L
.32368 .4932 L
.32468 .4974 L
.32567 .50069 L
.32667 .50305 L
.32767 .50457 L
.32867 .50547 L
.32967 .50618 L
.33067 .50719 L
.33167 .50888 L
.33267 .51132 L
.33367 .51421 L
.33467 .51703 L
.33566 .51917 L
.33666 .52007 L
.33766 .51928 L
.33866 .51647 L
.33966 .51146 L
.34066 .50424 L
.34166 .49496 L
Mistroke
.34266 .48393 L
.34366 .47161 L
.34466 .45853 L
.34565 .44529 L
.34665 .43243 L
.34765 .42046 L
.34865 .40976 L
.34965 .38799 L
.35065 .38238 L
.35165 .37637 L
.35265 .37068 L
.35365 .36557 L
.35465 .36118 L
.35564 .35756 L
.35664 .35469 L
.35764 .35256 L
.35864 .35109 L
.35964 .35024 L
.36064 .34993 L
.36164 .3501 L
.36264 .35068 L
.36364 .35163 L
.36464 .35289 L
.36563 .35443 L
.36663 .35623 L
.36763 .35827 L
.36863 .36053 L
.36963 .36301 L
.37063 .36571 L
.37163 .36863 L
.37263 .37178 L
.37363 .37517 L
.37463 .37881 L
.37562 .38273 L
.37662 .38694 L
.37762 .39145 L
.37862 .39629 L
.37962 .40148 L
.38062 .40704 L
.38162 .41298 L
.38262 .41933 L
.38362 .42609 L
.38462 .43329 L
.38561 .44092 L
.38661 .44899 L
.38761 .45749 L
.38861 .46639 L
.38961 .47568 L
.39061 .48529 L
.39161 .49517 L
Mistroke
.39261 .50522 L
.39361 .51534 L
.39461 .52538 L
.3956 .53517 L
.3966 .54453 L
.3976 .55322 L
.3986 .56102 L
.3996 .26506 L
.4006 .26325 L
.4016 .26022 L
.4026 .25663 L
.4036 .25265 L
.4046 .24832 L
.40559 .24364 L
.40659 .23858 L
.40759 .23311 L
.40859 .22722 L
.40959 .22086 L
.41059 .214 L
.41159 .20664 L
.41259 .19877 L
.41359 .19039 L
.41459 .18156 L
.41558 .17236 L
.41658 .16298 L
.41758 .15373 L
.41858 .14519 L
.41958 .13835 L
.42058 .13492 L
.42158 .13739 L
.42258 .14798 L
.42358 .16699 L
.42458 .19299 L
.42557 .22387 L
.42657 .25739 L
.42757 .29127 L
.42857 .32343 L
.42957 .35216 L
.43057 .37632 L
.43157 .39545 L
.43257 .40971 L
.43357 .4197 L
.43457 .42631 L
.43556 .43048 L
.43656 .43299 L
.43756 .43443 L
.43856 .43513 L
.43956 .43527 L
.44056 .43492 L
.44156 .43416 L
Mistroke
.44256 .43307 L
.44356 .43174 L
.44456 .43027 L
.44555 .42875 L
.44655 .42726 L
.44755 .42586 L
.44855 .4246 L
.44955 .38646 L
.45055 .38917 L
.45155 .39082 L
.45255 .39209 L
.45355 .39323 L
.45455 .39435 L
.45554 .39552 L
.45654 .39679 L
.45754 .39817 L
.45854 .3997 L
.45954 .40137 L
.46054 .4032 L
.46154 .40518 L
.46254 .40731 L
.46354 .40958 L
.46454 .41199 L
.46553 .41452 L
.46653 .41716 L
.46753 .41991 L
.46853 .42274 L
.46953 .42563 L
.47053 .42856 L
.47153 .43152 L
.47253 .43447 L
.47353 .4374 L
.47453 .44027 L
.47552 .44307 L
.47652 .44577 L
.47752 .44834 L
.47852 .45077 L
.47952 .45303 L
.48052 .45513 L
.48152 .45706 L
.48252 .45883 L
.48352 .46045 L
.48452 .46195 L
.48551 .46336 L
.48651 .46471 L
.48751 .46602 L
.48851 .46732 L
.48951 .46859 L
.49051 .46983 L
.49151 .47099 L
Mistroke
.49251 .47203 L
.49351 .47287 L
.49451 .47345 L
.4955 .47369 L
.4965 .47354 L
.4975 .47294 L
.4985 .47187 L
.4995 .39668 L
.5005 .38642 L
.5015 .37569 L
.5025 .36545 L
.5035 .35616 L
.5045 .34805 L
.50549 .34124 L
.50649 .33574 L
.50749 .33148 L
.50849 .32836 L
.50949 .32624 L
.51049 .32497 L
.51149 .32441 L
.51249 .32443 L
.51349 .32491 L
.51449 .32577 L
.51548 .32691 L
.51648 .32828 L
.51748 .32983 L
.51848 .33152 L
.51948 .33334 L
.52048 .33526 L
.52148 .33728 L
.52248 .3394 L
.52348 .34163 L
.52448 .34396 L
.52547 .34642 L
.52647 .34902 L
.52747 .35177 L
.52847 .3547 L
.52947 .35781 L
.53047 .36115 L
.53147 .36472 L
.53247 .36856 L
.53347 .3727 L
.53447 .37715 L
.53546 .38195 L
.53646 .38713 L
.53746 .39273 L
.53846 .39879 L
.53946 .40532 L
.54046 .41238 L
.54146 .42001 L
Mistroke
.54246 .42823 L
.54346 .43709 L
.54446 .44662 L
.54545 .45686 L
.54645 .46783 L
.54745 .47956 L
.54845 .49206 L
.54945 .39889 L
.55045 .40769 L
.55145 .41619 L
.55245 .42509 L
.55345 .43458 L
.55445 .44469 L
.55544 .45541 L
.55644 .46665 L
.55744 .4783 L
.55844 .49018 L
.55944 .50205 L
.56044 .51363 L
.56144 .52455 L
.56244 .53438 L
.56344 .54265 L
.56444 .54892 L
.56543 .55286 L
.56643 .55436 L
.56743 .55377 L
.56843 .55179 L
.56943 .549 L
.57043 .54526 L
.57143 .53978 L
.57243 .53168 L
.57343 .52032 L
.57443 .50543 L
.57542 .48719 L
.57642 .46617 L
.57742 .44331 L
.57842 .41977 L
.57942 .39677 L
.58042 .37542 L
.58142 .35655 L
.58242 .34066 L
.58342 .32791 L
.58442 .31813 L
.58541 .31097 L
.58641 .30597 L
.58741 .30268 L
.58841 .30069 L
.58941 .29965 L
.59041 .29928 L
.59141 .29939 L
Mistroke
.59241 .29981 L
.59341 .30043 L
.59441 .30115 L
.5954 .30191 L
.5964 .30266 L
.5974 .30335 L
.5984 .30396 L
.5994 .24573 L
.6004 .24935 L
.6014 .2515 L
.6024 .25286 L
.6034 .25365 L
.6044 .25399 L
.60539 .25394 L
.60639 .25355 L
.60739 .25286 L
.60839 .25189 L
.60939 .25065 L
.61039 .24918 L
.61139 .24748 L
.61239 .24556 L
.61339 .24343 L
.61439 .24111 L
.61538 .23861 L
.61638 .23595 L
.61738 .23316 L
.61838 .23027 L
.61938 .22733 L
.62038 .22441 L
.62138 .2216 L
.62238 .21902 L
.62338 .21682 L
.62438 .21521 L
.62537 .21442 L
.62637 .21468 L
.62737 .21624 L
.62837 .21926 L
.62937 .2238 L
.63037 .22982 L
.63137 .23714 L
.63237 .2455 L
.63337 .25459 L
.63437 .2641 L
.63536 .27369 L
.63636 .28308 L
.63736 .29201 L
.63836 .30029 L
.63936 .30777 L
.64036 .3144 L
.64136 .32014 L
Mistroke
.64236 .32505 L
.64336 .32917 L
.64436 .33262 L
.64535 .33548 L
.64635 .33786 L
.64735 .33984 L
.64835 .3415 L
.64935 .27298 L
.65035 .27526 L
.65135 .27622 L
.65235 .27653 L
.65335 .27642 L
.65435 .27598 L
.65534 .27527 L
.65634 .27434 L
.65734 .2732 L
.65834 .27185 L
.65934 .27031 L
.66034 .26858 L
.66134 .26664 L
.66234 .26449 L
.66334 .26212 L
.66434 .25951 L
.66533 .25665 L
.66633 .25352 L
.66733 .2501 L
.66833 .24638 L
.66933 .24234 L
.67033 .23798 L
.67133 .23331 L
.67233 .22834 L
.67333 .22312 L
.67433 .21776 L
.67532 .2124 L
.67632 .20732 L
.67732 .2029 L
.67832 .19972 L
.67932 .19849 L
.68032 .19995 L
.68132 .20462 L
.68232 .21255 L
.68332 .22338 L
.68432 .23647 L
.68531 .25109 L
.68631 .26649 L
.68731 .28196 L
.68831 .29686 L
.68931 .31066 L
.69031 .32295 L
.69131 .33351 L
Mistroke
.69231 .34224 L
.69331 .34921 L
.69431 .35461 L
.6953 .35871 L
.6963 .36182 L
.6973 .36424 L
.6983 .36625 L
.6993 .30767 L
.7003 .31452 L
.7013 .31945 L
.7023 .32319 L
.7033 .32605 L
.7043 .32825 L
.70529 .32994 L
.70629 .33124 L
.70729 .33226 L
.70829 .33308 L
.70929 .33379 L
.71029 .33443 L
.71129 .33507 L
.71229 .33573 L
.71329 .33646 L
.71429 .33728 L
.71528 .33822 L
.71628 .33929 L
.71728 .34052 L
.71828 .34191 L
.71928 .34349 L
.72028 .34526 L
.72128 .34723 L
.72228 .34943 L
.72328 .35187 L
.72428 .35456 L
.72527 .35752 L
.72627 .36077 L
.72727 .36432 L
.72827 .36821 L
.72927 .37245 L
.73027 .37707 L
.73127 .38209 L
.73227 .38754 L
.73327 .39346 L
.73427 .39988 L
.73526 .40682 L
.73626 .41432 L
.73726 .42241 L
.73826 .43111 L
.73926 .44046 L
.74026 .45048 L
.74126 .46117 L
Mistroke
.74226 .47256 L
.74326 .48463 L
.74426 .49737 L
.74525 .51076 L
.74625 .52475 L
.74725 .53927 L
.74825 .55426 L
.74925 .13996 L
.75025 .13228 L
.75125 .12358 L
.75225 .11492 L
.75325 .10694 L
.75425 .10024 L
.75524 .0955 L
.75624 .09351 L
.75724 .09514 L
.75824 .10138 L
.75924 .11319 L
.76024 .13132 L
.76124 .15593 L
.76224 .18635 L
.76324 .22109 L
.76424 .25802 L
.76523 .29483 L
.76623 .32935 L
.76723 .35992 L
.76823 .38554 L
.76923 .4059 L
.77023 .42125 L
.77123 .43219 L
.77223 .43949 L
.77323 .44392 L
.77423 .4462 L
.77522 .44692 L
.77622 .44658 L
.77722 .44555 L
.77822 .4441 L
.77922 .44243 L
.78022 .44069 L
.78122 .43896 L
.78222 .43731 L
.78322 .43577 L
.78422 .43436 L
.78521 .4331 L
.78621 .432 L
.78721 .43107 L
.78821 .43032 L
.78921 .42977 L
.79021 .42942 L
.79121 .4293 L
Mistroke
.79221 .42941 L
.79321 .42979 L
.79421 .43043 L
.7952 .43137 L
.7962 .43259 L
.7972 .43411 L
.7982 .43592 L
.7992 .42248 L
.8002 .42623 L
.8012 .42873 L
.8022 .43061 L
.8032 .43205 L
.8042 .43312 L
.80519 .43385 L
.80619 .43428 L
.80719 .43441 L
.80819 .43427 L
.80919 .43388 L
.81019 .43326 L
.81119 .43243 L
.81219 .43144 L
.81319 .43032 L
.81419 .4291 L
.81518 .42782 L
.81618 .42653 L
.81718 .42524 L
.81818 .424 L
.81918 .42282 L
.82018 .42174 L
.82118 .42078 L
.82218 .41993 L
.82318 .41923 L
.82418 .41868 L
.82517 .41827 L
.82617 .41802 L
.82717 .41792 L
.82817 .41798 L
.82917 .41819 L
.83017 .41855 L
.83117 .41906 L
.83217 .41971 L
.83317 .4205 L
.83417 .42142 L
.83516 .42247 L
.83616 .42363 L
.83716 .42492 L
.83816 .42631 L
.83916 .4278 L
.84016 .42939 L
.84116 .43106 L
Mistroke
.84216 .4328 L
.84316 .43462 L
.84416 .43648 L
.84515 .4384 L
.84615 .44036 L
.84715 .44234 L
.84815 .44434 L
.84915 .43292 L
.85015 .43363 L
.85115 .43271 L
.85215 .43083 L
.85315 .42828 L
.85415 .42522 L
.85514 .42181 L
.85614 .41817 L
.85714 .41442 L
.85814 .41067 L
.85914 .40702 L
.86014 .40356 L
.86114 .40036 L
.86214 .39747 L
.86314 .39493 L
.86414 .39276 L
.86513 .39098 L
.86613 .3896 L
.86713 .3886 L
.86813 .38799 L
.86913 .38774 L
.87013 .38783 L
.87113 .38825 L
.87213 .38899 L
.87313 .39002 L
.87413 .39133 L
.87512 .39291 L
.87612 .39473 L
.87712 .39681 L
.87812 .39911 L
.87912 .40164 L
.88012 .40438 L
.88112 .40734 L
.88212 .41049 L
.88312 .41383 L
.88412 .41736 L
.88511 .42106 L
.88611 .42491 L
.88711 .4289 L
.88811 .43301 L
.88911 .43721 L
.89011 .44147 L
.89111 .44576 L
Mistroke
.89211 .45004 L
.89311 .45426 L
.89411 .45837 L
.8951 .46233 L
.8961 .46607 L
.8971 .46955 L
.8981 .4727 L
.8991 .43516 L
.9001 .44758 L
.9011 .45916 L
.9021 .4705 L
.9031 .48166 L
.9041 .49252 L
.90509 .50287 L
.90609 .51243 L
.90709 .52085 L
.90809 .52775 L
.90909 .53275 L
.91009 .53553 L
.91109 .53586 L
.91209 .53366 L
.91309 .52904 L
.91409 .5222 L
.91508 .5133 L
.91608 .50244 L
.91708 .48968 L
.91808 .47514 L
.91908 .45907 L
.92008 .44191 L
.92108 .42421 L
.92208 .40661 L
.92308 .38974 L
.92408 .37418 L
.92507 .36033 L
.92607 .34848 L
.92707 .3387 L
.92807 .33093 L
.92907 .32501 L
.93007 .32071 L
.93107 .31776 L
.93207 .31592 L
.93307 .31495 L
.93407 .31467 L
.93506 .3149 L
.93606 .31552 L
.93706 .31642 L
.93806 .31753 L
.93906 .31878 L
.94006 .32013 L
.94106 .32154 L
Mistroke
.94206 .32299 L
.94306 .32447 L
.94406 .32595 L
.94505 .32744 L
.94605 .32892 L
.94705 .3304 L
.94805 .33188 L
.94905 .27095 L
.95005 .2725 L
.95105 .2727 L
.95205 .27225 L
.95305 .27137 L
.95405 .27017 L
.95504 .26868 L
.95604 .26694 L
.95704 .26496 L
.95804 .26273 L
.95904 .26025 L
.96004 .25752 L
.96104 .25451 L
.96204 .25122 L
.96304 .24761 L
.96404 .24367 L
.96503 .23938 L
.96603 .23472 L
.96703 .22968 L
.96803 .22425 L
.96903 .21845 L
.97003 .2123 L
.97103 .2059 L
.97203 .1994 L
.97303 .19304 L
.97403 .18727 L
.97502 .18274 L
.97602 .18044 L
.97702 .18151 L
.97802 .18682 L
.97902 .19657 L
.98002 .21022 L
.98102 .22685 L
.98202 .24542 L
.98302 .26489 L
.98402 .28429 L
.98501 .30273 L
.98601 .3195 L
.98701 .33411 L
.98801 .3463 L
.98901 .35605 L
.99001 .36353 L
.99101 .36908 L
Mistroke
.99201 .37312 L
.99301 .37608 L
.99401 .37835 L
.995 .38021 L
.996 .38182 L
.997 .38327 L
.998 .38454 L
.999 .31865 L
Mfstroke
1 0 0 r
gsave
.999 .31236 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30145 L
.00799 .30034 L
.00899 .29914 L
.00999 .29783 L
.01099 .29637 L
.01199 .29475 L
.01299 .29295 L
.01399 .29095 L
.01499 .28872 L
.01598 .28625 L
.01698 .2835 L
.01798 .28047 L
.01898 .27713 L
.01998 .27348 L
.02098 .26952 L
.02198 .26527 L
.02298 .26078 L
.02398 .25614 L
.02498 .25149 L
.02597 .24702 L
.02697 .24303 L
.02797 .23993 L
.02897 .23826 L
.02997 .23869 L
.03097 .24202 L
.03197 .2491 L
.03297 .26076 L
.03397 .27759 L
.03497 .29971 L
.03596 .32645 L
.03696 .35619 L
.03796 .38624 L
.03896 .41307 L
.03996 .43287 L
.04096 .44224 L
.04196 .43909 L
.04296 .42321 L
.04396 .39655 L
.04496 .36285 L
.04595 .32679 L
.04695 .29277 L
.04795 .26392 L
.04895 .24164 L
Mistroke
.04995 .02686 L
.05095 .0529 L
.05195 .08978 L
.05295 .13617 L
.05395 .18933 L
.05495 .24534 L
.05594 .29981 L
.05694 .34878 L
.05794 .38949 L
.05894 .42077 L
.05994 .44288 L
.06094 .45707 L
.06194 .46501 L
.06294 .46834 L
.06394 .46845 L
.06494 .46637 L
.06593 .46281 L
.06693 .45824 L
.06793 .45293 L
.06893 .44706 L
.06993 .44075 L
.07093 .43412 L
.07193 .42727 L
.07293 .42034 L
.07393 .41347 L
.07493 .40679 L
.07592 .40044 L
.07692 .39454 L
.07792 .38916 L
.07892 .38436 L
.07992 .38014 L
.08092 .37649 L
.08192 .37336 L
.08292 .37066 L
.08392 .36833 L
.08492 .36628 L
.08591 .36442 L
.08691 .36267 L
.08791 .36098 L
.08891 .35929 L
.08991 .35756 L
.09091 .35579 L
.09191 .35396 L
.09291 .35208 L
.09391 .35016 L
.09491 .34823 L
.0959 .34631 L
.0969 .34444 L
.0979 .34264 L
.0989 .34094 L
Mistroke
.0999 .33095 L
.1009 .33244 L
.1019 .33404 L
.1029 .33573 L
.1039 .33754 L
.1049 .33946 L
.10589 .34151 L
.10689 .3437 L
.10789 .34604 L
.10889 .34856 L
.10989 .35126 L
.11089 .35417 L
.11189 .35729 L
.11289 .36065 L
.11389 .36427 L
.11489 .36816 L
.11588 .37234 L
.11688 .37681 L
.11788 .3816 L
.11888 .38671 L
.11988 .39214 L
.12088 .39788 L
.12188 .40393 L
.12288 .41025 L
.12388 .41681 L
.12488 .42355 L
.12587 .43039 L
.12687 .43724 L
.12787 .44398 L
.12887 .45047 L
.12987 .45653 L
.13087 .46198 L
.13187 .46662 L
.13287 .47026 L
.13387 .47272 L
.13487 .47383 L
.13586 .47349 L
.13686 .47164 L
.13786 .46829 L
.13886 .46351 L
.13986 .45743 L
.14086 .45019 L
.14186 .44196 L
.14286 .43287 L
.14386 .42304 L
.14486 .41253 L
.14585 .40142 L
.14685 .38979 L
.14785 .37774 L
.14885 .36544 L
Mistroke
.14985 .36178 L
.15085 .34295 L
.15185 .32633 L
.15285 .3123 L
.15385 .30095 L
.15485 .29218 L
.15584 .28571 L
.15684 .28122 L
.15784 .27832 L
.15884 .27667 L
.15984 .27595 L
.16084 .27587 L
.16184 .27622 L
.16284 .27682 L
.16384 .27752 L
.16484 .27823 L
.16583 .27888 L
.16683 .2794 L
.16783 .27976 L
.16883 .27993 L
.16983 .27991 L
.17083 .27969 L
.17183 .27925 L
.17283 .2786 L
.17383 .27775 L
.17483 .27668 L
.17582 .2754 L
.17682 .27391 L
.17782 .27222 L
.17882 .27031 L
.17982 .26821 L
.18082 .26589 L
.18182 .26338 L
.18282 .26066 L
.18382 .25774 L
.18482 .25463 L
.18581 .25135 L
.18681 .24791 L
.18781 .24433 L
.18881 .24064 L
.18981 .2369 L
.19081 .23315 L
.19181 .22946 L
.19281 .22591 L
.19381 .2226 L
.19481 .21964 L
.1958 .21715 L
.1968 .21527 L
.1978 .21414 L
.1988 .21388 L
Mistroke
.1998 .16239 L
.2008 .1559 L
.2018 .14895 L
.2028 .14177 L
.2038 .13462 L
.2048 .12779 L
.20579 .12162 L
.20679 .11649 L
.20779 .11279 L
.20879 .11094 L
.20979 .11132 L
.21079 .11431 L
.21179 .12016 L
.21279 .12902 L
.21379 .14086 L
.21479 .15545 L
.21578 .17235 L
.21678 .19096 L
.21778 .21052 L
.21878 .23023 L
.21978 .24931 L
.22078 .26709 L
.22178 .28306 L
.22278 .2969 L
.22378 .30848 L
.22478 .31783 L
.22577 .3251 L
.22677 .33054 L
.22777 .33442 L
.22877 .33702 L
.22977 .33861 L
.23077 .33944 L
.23177 .33972 L
.23277 .33963 L
.23377 .3393 L
.23477 .33885 L
.23576 .33836 L
.23676 .3379 L
.23776 .33752 L
.23876 .33725 L
.23976 .33711 L
.24076 .33713 L
.24176 .3373 L
.24276 .33763 L
.24376 .33813 L
.24476 .33878 L
.24575 .3396 L
.24675 .34057 L
.24775 .34169 L
.24875 .34296 L
Mistroke
.24975 .39469 L
.25075 .39764 L
.25175 .40072 L
.25275 .40391 L
.25375 .40719 L
.25475 .41053 L
.25574 .4139 L
.25674 .41725 L
.25774 .42056 L
.25874 .42377 L
.25974 .42683 L
.26074 .42967 L
.26174 .43225 L
.26274 .43449 L
.26374 .43631 L
.26474 .43767 L
.26573 .43848 L
.26673 .43869 L
.26773 .43825 L
.26873 .43713 L
.26973 .4353 L
.27073 .43277 L
.27173 .42956 L
.27273 .4257 L
.27373 .42128 L
.27473 .41636 L
.27572 .41106 L
.27672 .40548 L
.27772 .39975 L
.27872 .39398 L
.27972 .38828 L
.28072 .38275 L
.28172 .37749 L
.28272 .37257 L
.28372 .36804 L
.28472 .36393 L
.28571 .36028 L
.28671 .35709 L
.28771 .35436 L
.28871 .35207 L
.28971 .35021 L
.29071 .34874 L
.29171 .34764 L
.29271 .34688 L
.29371 .34642 L
.29471 .34625 L
.2957 .34634 L
.2967 .34665 L
.2977 .34717 L
.2987 .34788 L
Mistroke
.2997 .35062 L
.3007 .35229 L
.3017 .35415 L
.3027 .35619 L
.3037 .35841 L
.3047 .36082 L
.30569 .36342 L
.30669 .36622 L
.30769 .36922 L
.30869 .37243 L
.30969 .37585 L
.31069 .3795 L
.31169 .38337 L
.31269 .38746 L
.31369 .39178 L
.31469 .39632 L
.31568 .40106 L
.31668 .406 L
.31768 .4111 L
.31868 .41634 L
.31968 .42166 L
.32068 .42702 L
.32168 .43234 L
.32268 .43755 L
.32368 .44254 L
.32468 .4472 L
.32567 .45143 L
.32667 .45507 L
.32767 .45801 L
.32867 .46011 L
.32967 .46123 L
.33067 .46127 L
.33167 .46015 L
.33267 .4578 L
.33367 .45422 L
.33467 .44942 L
.33566 .44347 L
.33666 .43647 L
.33766 .42857 L
.33866 .41991 L
.33966 .4107 L
.34066 .40111 L
.34166 .39135 L
.34266 .38162 L
.34366 .37211 L
.34466 .36299 L
.34565 .35442 L
.34665 .34653 L
.34765 .33941 L
.34865 .33313 L
Mistroke
.34965 .38169 L
.35065 .37203 L
.35165 .36301 L
.35265 .3548 L
.35365 .3475 L
.35465 .34117 L
.35564 .33582 L
.35664 .33141 L
.35764 .32789 L
.35864 .32516 L
.35964 .32315 L
.36064 .32175 L
.36164 .32088 L
.36264 .32044 L
.36364 .32037 L
.36464 .3206 L
.36563 .32106 L
.36663 .32172 L
.36763 .32254 L
.36863 .32347 L
.36963 .32452 L
.37063 .32564 L
.37163 .32685 L
.37263 .32812 L
.37363 .32947 L
.37463 .33088 L
.37562 .33236 L
.37662 .33392 L
.37762 .33556 L
.37862 .33728 L
.37962 .3391 L
.38062 .34102 L
.38162 .34305 L
.38262 .3452 L
.38362 .34746 L
.38462 .34985 L
.38561 .35237 L
.38661 .35502 L
.38761 .35779 L
.38861 .36068 L
.38961 .36367 L
.39061 .36675 L
.39161 .36989 L
.39261 .37306 L
.39361 .37621 L
.39461 .37929 L
.3956 .38223 L
.3966 .38495 L
.3976 .38736 L
.3986 .38937 L
Mistroke
.3996 .25879 L
.4006 .25297 L
.4016 .24696 L
.4026 .24068 L
.4036 .23408 L
.4046 .2271 L
.40559 .2197 L
.40659 .21184 L
.40759 .20352 L
.40859 .19473 L
.40959 .18547 L
.41059 .1758 L
.41159 .16579 L
.41259 .15555 L
.41359 .14523 L
.41459 .13506 L
.41558 .1253 L
.41658 .11631 L
.41758 .10849 L
.41858 .10231 L
.41958 .09828 L
.42058 .09694 L
.42158 .09876 L
.42258 .10415 L
.42358 .11337 L
.42458 .12644 L
.42557 .14316 L
.42657 .16304 L
.42757 .18537 L
.42857 .20924 L
.42957 .23367 L
.43057 .25767 L
.43157 .28038 L
.43257 .30108 L
.43357 .31929 L
.43457 .33475 L
.43556 .34741 L
.43656 .35738 L
.43756 .36491 L
.43856 .37034 L
.43956 .37401 L
.44056 .37627 L
.44156 .37746 L
.44256 .37784 L
.44356 .37767 L
.44456 .37712 L
.44555 .37636 L
.44655 .37548 L
.44755 .37458 L
.44855 .37372 L
Mistroke
.44955 .3802 L
.45055 .37899 L
.45155 .37789 L
.45255 .37693 L
.45355 .37615 L
.45455 .37555 L
.45554 .37515 L
.45654 .37494 L
.45754 .37494 L
.45854 .37513 L
.45954 .37551 L
.46054 .37608 L
.46154 .37683 L
.46254 .37774 L
.46354 .37882 L
.46454 .38005 L
.46553 .38141 L
.46653 .38291 L
.46753 .38453 L
.46853 .38626 L
.46953 .38808 L
.47053 .38999 L
.47153 .39197 L
.47253 .394 L
.47353 .39607 L
.47453 .39816 L
.47552 .40025 L
.47652 .40232 L
.47752 .40434 L
.47852 .4063 L
.47952 .40817 L
.48052 .40991 L
.48152 .41152 L
.48252 .41296 L
.48352 .41419 L
.48452 .41521 L
.48551 .41599 L
.48651 .4165 L
.48751 .41673 L
.48851 .41667 L
.48951 .4163 L
.49051 .41561 L
.49151 .41462 L
.49251 .41331 L
.49351 .41171 L
.49451 .40982 L
.4955 .40766 L
.4965 .40525 L
.4975 .40261 L
.4985 .39979 L
Mistroke
.4995 .39039 L
.5005 .37605 L
.5015 .36228 L
.5025 .34949 L
.5035 .33797 L
.5045 .32791 L
.50549 .31938 L
.50649 .31236 L
.50749 .30677 L
.50849 .30247 L
.50949 .29929 L
.51049 .29707 L
.51149 .29562 L
.51249 .29479 L
.51349 .29444 L
.51449 .29444 L
.51548 .29471 L
.51648 .29514 L
.51748 .29568 L
.51848 .29627 L
.51948 .29686 L
.52048 .29744 L
.52148 .29798 L
.52248 .29847 L
.52348 .29888 L
.52448 .29922 L
.52547 .29949 L
.52647 .29968 L
.52747 .2998 L
.52847 .29984 L
.52947 .29981 L
.53047 .29971 L
.53147 .29955 L
.53247 .29932 L
.53347 .29903 L
.53447 .29868 L
.53546 .29827 L
.53646 .29782 L
.53746 .29731 L
.53846 .29676 L
.53946 .29616 L
.54046 .29552 L
.54146 .29485 L
.54246 .29415 L
.54346 .29344 L
.54446 .29272 L
.54545 .29201 L
.54645 .29133 L
.54745 .2907 L
.54845 .29016 L
Mistroke
.54945 .39265 L
.55045 .39743 L
.55145 .40296 L
.55245 .40922 L
.55345 .41616 L
.55445 .42376 L
.55544 .43195 L
.55644 .44069 L
.55744 .44989 L
.55844 .45944 L
.55944 .46918 L
.56044 .47894 L
.56144 .48845 L
.56244 .49741 L
.56344 .50547 L
.56444 .51218 L
.56543 .51707 L
.56643 .51964 L
.56743 .51938 L
.56843 .51585 L
.56943 .50871 L
.57043 .49778 L
.57143 .48315 L
.57243 .46511 L
.57343 .44427 L
.57443 .42144 L
.57542 .39758 L
.57642 .37371 L
.57742 .35079 L
.57842 .32962 L
.57942 .31079 L
.58042 .29465 L
.58142 .2813 L
.58242 .27068 L
.58342 .26254 L
.58442 .25658 L
.58541 .25243 L
.58641 .24975 L
.58741 .2482 L
.58841 .24748 L
.58941 .24736 L
.59041 .24763 L
.59141 .24812 L
.59241 .24872 L
.59341 .24934 L
.59441 .2499 L
.5954 .25035 L
.5964 .25067 L
.5974 .25083 L
.5984 .25081 L
Mistroke
.5994 .23951 L
.6004 .23918 L
.6014 .23855 L
.6024 .23762 L
.6034 .23638 L
.6044 .23485 L
.60539 .23303 L
.60639 .23093 L
.60739 .22857 L
.60839 .22597 L
.60939 .22313 L
.61039 .22009 L
.61139 .21686 L
.61239 .21346 L
.61339 .20993 L
.61439 .2063 L
.61538 .20261 L
.61638 .1989 L
.61738 .19521 L
.61838 .19162 L
.61938 .18817 L
.62038 .18494 L
.62138 .182 L
.62238 .17943 L
.62338 .1773 L
.62438 .17569 L
.62537 .17469 L
.62637 .17434 L
.62737 .17472 L
.62837 .17587 L
.62937 .1778 L
.63037 .18052 L
.63137 .18402 L
.63237 .18825 L
.63337 .19315 L
.63437 .19864 L
.63536 .20461 L
.63636 .21096 L
.63736 .21756 L
.63836 .22429 L
.63936 .23104 L
.64036 .23768 L
.64136 .2441 L
.64236 .25022 L
.64336 .25595 L
.64436 .26123 L
.64535 .26602 L
.64635 .27029 L
.64735 .27403 L
.64835 .27723 L
Mistroke
.64935 .26669 L
.65035 .26504 L
.65135 .26321 L
.65235 .26119 L
.65335 .25898 L
.65435 .25657 L
.65534 .25397 L
.65634 .25116 L
.65734 .24813 L
.65834 .24489 L
.65934 .24143 L
.66034 .23774 L
.66134 .23382 L
.66234 .22968 L
.66334 .2253 L
.66434 .22071 L
.66533 .21592 L
.66633 .21093 L
.66733 .20578 L
.66833 .20051 L
.66933 .19516 L
.67033 .18978 L
.67133 .18445 L
.67233 .17925 L
.67333 .17428 L
.67433 .16964 L
.67532 .16545 L
.67632 .16186 L
.67732 .15898 L
.67832 .15696 L
.67932 .15592 L
.68032 .15597 L
.68132 .1572 L
.68232 .15966 L
.68332 .16337 L
.68432 .16832 L
.68531 .17444 L
.68631 .18164 L
.68731 .18978 L
.68831 .1987 L
.68931 .20823 L
.69031 .21815 L
.69131 .22827 L
.69231 .23839 L
.69331 .2483 L
.69431 .25782 L
.6953 .26679 L
.6963 .27506 L
.6973 .28253 L
.6983 .28915 L
Mistroke
.6993 .30136 L
.7003 .30429 L
.7013 .30644 L
.7023 .30795 L
.7033 .3089 L
.7043 .30942 L
.70529 .30958 L
.70629 .30946 L
.70729 .30913 L
.70829 .30864 L
.70929 .30804 L
.71029 .30736 L
.71129 .30663 L
.71229 .30586 L
.71329 .30508 L
.71429 .30428 L
.71528 .30347 L
.71628 .30267 L
.71728 .30185 L
.71828 .30103 L
.71928 .3002 L
.72028 .29936 L
.72128 .29849 L
.72228 .2976 L
.72328 .29668 L
.72428 .29572 L
.72527 .29471 L
.72627 .29365 L
.72727 .29253 L
.72827 .29135 L
.72927 .2901 L
.73027 .28878 L
.73127 .28737 L
.73227 .2859 L
.73327 .28434 L
.73427 .2827 L
.73526 .28099 L
.73626 .27921 L
.73726 .27739 L
.73826 .27553 L
.73926 .27367 L
.74026 .27184 L
.74126 .27009 L
.74226 .26847 L
.74326 .26707 L
.74426 .26596 L
.74525 .26526 L
.74625 .26509 L
.74725 .26559 L
.74825 .26691 L
Mistroke
.74925 .13369 L
.75025 .12197 L
.75125 .11027 L
.75225 .09901 L
.75325 .0887 L
.75425 .07995 L
.75524 .07344 L
.75624 .06997 L
.75724 .07033 L
.75824 .07525 L
.75924 .08533 L
.76024 .1009 L
.76124 .12187 L
.76224 .14772 L
.76324 .1774 L
.76424 .20947 L
.76523 .24223 L
.76623 .27395 L
.76723 .30313 L
.76823 .32867 L
.76923 .34995 L
.77023 .36684 L
.77123 .37958 L
.77223 .38867 L
.77323 .39474 L
.77423 .39842 L
.77522 .40031 L
.77622 .4009 L
.77722 .4006 L
.77822 .39972 L
.77922 .39852 L
.78022 .39715 L
.78122 .39573 L
.78222 .39436 L
.78322 .39309 L
.78422 .39195 L
.78521 .39096 L
.78621 .39014 L
.78721 .38949 L
.78821 .389 L
.78921 .38868 L
.79021 .38852 L
.79121 .38851 L
.79221 .38865 L
.79321 .38893 L
.79421 .38935 L
.7952 .38989 L
.7962 .39055 L
.7972 .39132 L
.7982 .39219 L
Mistroke
.7992 .41624 L
.8002 .41601 L
.8012 .41567 L
.8022 .41521 L
.8032 .41461 L
.8042 .41386 L
.80519 .41295 L
.80619 .41186 L
.80719 .41061 L
.80819 .40919 L
.80919 .40762 L
.81019 .4059 L
.81119 .40405 L
.81219 .40209 L
.81319 .40006 L
.81419 .39796 L
.81518 .39583 L
.81618 .3937 L
.81718 .39159 L
.81818 .38953 L
.81918 .38754 L
.82018 .38565 L
.82118 .38387 L
.82218 .38223 L
.82318 .38073 L
.82418 .37939 L
.82517 .37821 L
.82617 .37721 L
.82717 .37638 L
.82817 .37572 L
.82917 .37524 L
.83017 .37493 L
.83117 .37478 L
.83217 .3748 L
.83317 .37496 L
.83417 .37528 L
.83516 .37573 L
.83616 .37632 L
.83716 .37703 L
.83816 .37786 L
.83916 .3788 L
.84016 .37984 L
.84116 .38098 L
.84216 .38221 L
.84316 .38351 L
.84416 .38489 L
.84515 .38634 L
.84615 .38784 L
.84715 .38939 L
.84815 .39097 L
Mistroke
.84915 .42667 L
.85015 .42338 L
.85115 .41957 L
.85215 .4153 L
.85315 .41066 L
.85415 .40575 L
.85514 .40065 L
.85614 .39547 L
.85714 .39031 L
.85814 .38527 L
.85914 .38043 L
.86014 .37586 L
.86114 .37163 L
.86214 .36778 L
.86314 .36434 L
.86414 .36134 L
.86513 .35877 L
.86613 .35662 L
.86713 .3549 L
.86813 .35357 L
.86913 .35262 L
.87013 .35201 L
.87113 .35173 L
.87213 .35174 L
.87313 .35202 L
.87413 .35254 L
.87512 .3533 L
.87612 .35425 L
.87712 .3554 L
.87812 .35673 L
.87912 .35822 L
.88012 .35987 L
.88112 .36167 L
.88212 .36362 L
.88312 .3657 L
.88412 .36793 L
.88511 .37028 L
.88611 .37277 L
.88711 .37538 L
.88811 .37811 L
.88911 .38096 L
.89011 .38393 L
.89111 .38699 L
.89211 .39014 L
.89311 .39338 L
.89411 .39667 L
.8951 .40001 L
.8961 .40336 L
.8971 .40672 L
.8981 .41003 L
Mistroke
.8991 .42891 L
.9001 .43732 L
.9011 .44596 L
.9021 .45476 L
.9031 .46358 L
.9041 .47228 L
.90509 .48065 L
.90609 .48843 L
.90709 .49534 L
.90809 .50102 L
.90909 .50512 L
.91009 .50721 L
.91109 .50693 L
.91209 .50392 L
.91309 .49792 L
.91409 .48879 L
.91508 .47657 L
.91608 .46149 L
.91708 .44398 L
.91808 .42467 L
.91908 .40432 L
.92008 .38374 L
.92108 .36375 L
.92208 .34505 L
.92308 .32816 L
.92408 .31344 L
.92507 .30104 L
.92607 .29095 L
.92707 .28303 L
.92807 .27705 L
.92907 .27272 L
.93007 .26975 L
.93107 .26786 L
.93207 .2668 L
.93307 .26635 L
.93407 .26631 L
.93506 .26654 L
.93606 .26691 L
.93706 .26733 L
.93806 .26772 L
.93906 .26804 L
.94006 .26823 L
.94106 .26828 L
.94206 .26817 L
.94306 .26788 L
.94406 .26742 L
.94505 .26676 L
.94605 .26592 L
.94705 .26491 L
.94805 .26371 L
Mistroke
.94905 .26474 L
.95005 .26231 L
.95105 .25967 L
.95205 .25682 L
.95305 .25374 L
.95405 .25043 L
.95504 .24686 L
.95604 .24304 L
.95704 .23894 L
.95804 .23457 L
.95904 .22991 L
.96004 .22496 L
.96104 .21972 L
.96204 .2142 L
.96304 .20841 L
.96404 .20237 L
.96503 .19613 L
.96603 .18972 L
.96703 .18321 L
.96803 .17669 L
.96903 .17025 L
.97003 .16402 L
.97103 .15814 L
.97203 .15277 L
.97303 .14811 L
.97403 .14435 L
.97502 .14168 L
.97602 .14031 L
.97702 .14042 L
.97802 .14214 L
.97902 .14558 L
.98002 .15077 L
.98102 .15768 L
.98202 .16622 L
.98302 .1762 L
.98402 .1874 L
.98501 .19954 L
.98601 .2123 L
.98701 .22536 L
.98801 .23839 L
.98901 .25108 L
.99001 .26315 L
.99101 .27437 L
.99201 .28456 L
.99301 .29358 L
.99401 .30138 L
.995 .30795 L
.996 .31334 L
.997 .31764 L
.998 .32095 L
Mistroke
.999 .31236 L
Mfstroke
0 g
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .27969 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.04917 0 m
.04995 .40276 L
.05095 .44343 L
.05195 .47755 L
.05295 .50265 L
.05395 .51655 L
.05495 .5182 L
.05594 .50805 L
.05694 .48805 L
.05794 .46115 L
.05894 .43057 L
.05994 .3991 L
.06094 .36871 L
.06194 .34054 L
.06294 .31508 L
.06394 .29242 L
.06494 .2724 L
.06593 .25482 L
.06693 .23945 L
.06793 .22614 L
.06893 .21476 L
.06993 .20525 L
.07093 .19759 L
.07193 .19178 L
.07293 .18782 L
.07393 .18566 L
.07493 .18525 L
.07592 .18648 L
.07692 .18923 L
.07792 .19331 L
.07892 .19853 L
.07992 .20464 L
.08092 .21134 L
.08192 .21835 L
.08292 .22534 L
.08392 .23198 L
.08492 .23793 L
.08591 .24285 L
.08691 .24645 L
.08791 .24853 L
.08891 .249 L
.08991 .24794 L
.09091 .24557 L
.09191 .24218 L
.09291 .23806 L
.09391 .23349 L
.09491 .2287 L
.0959 .22385 L
.0969 .21906 L
.0979 .21441 L
Mistroke
.0989 .20993 L
.0999 .22536 L
.1009 .21552 L
.1019 .20699 L
.1029 .19917 L
.1039 .19185 L
.1049 .18495 L
.10589 .17842 L
.10689 .17223 L
.10789 .16635 L
.10889 .16078 L
.10989 .1555 L
.11089 .15049 L
.11189 .14574 L
.11289 .14125 L
.11389 .13698 L
.11489 .13293 L
.11588 .12907 L
.11688 .12537 L
.11788 .12179 L
.11888 .1183 L
.11988 .11486 L
.12088 .11142 L
.12188 .10796 L
.12288 .10444 L
.12388 .10086 L
.12488 .0972 L
.12587 .09351 L
.12687 .08983 L
.12787 .08624 L
.12887 .08286 L
.12987 .07987 L
.13087 .07748 L
.13187 .07597 L
.13287 .07567 L
.13387 .07695 L
.13487 .08025 L
.13586 .08598 L
.13686 .09456 L
.13786 .10632 L
.13886 .12149 L
.13986 .14008 L
.14086 .16188 L
.14186 .1863 L
.14286 .21233 L
.14386 .23839 L
.14486 .26217 L
.14585 .2807 L
.14685 .29106 L
.14785 .29224 L
Mistroke
.14885 .2862 L
.14985 .39677 L
.15085 .38798 L
.15185 .37695 L
.15285 .36397 L
.15385 .34974 L
.15485 .33489 L
.15584 .31997 L
.15684 .30537 L
.15784 .29135 L
.15884 .27805 L
.15984 .26551 L
.16084 .25374 L
.16184 .24269 L
.16284 .23231 L
.16384 .22254 L
.16484 .21332 L
.16583 .20459 L
.16683 .19631 L
.16783 .18843 L
.16883 .18093 L
.16983 .17377 L
.17083 .16692 L
.17183 .16036 L
.17283 .15408 L
.17383 .14806 L
.17483 .14227 L
.17582 .13669 L
.17682 .1313 L
.17782 .12609 L
.17882 .12101 L
.17982 .11604 L
.18082 .11115 L
.18182 .10627 L
.18282 .10138 L
.18382 .0964 L
.18482 .09129 L
.18581 .08599 L
.18681 .08042 L
.18781 .07454 L
.18881 .06827 L
.18981 .06158 L
.19081 .0544 L
.19181 .04672 L
.19281 .0385 L
.19381 .02974 L
.19481 .02047 L
.1958 .01072 L
.1968 .00058 L
Mfstroke
.1968 .00058 m
.19686 0 L
s
.19891 0 m
.1998 .16699 L
.2008 .16796 L
.2018 .17153 L
.2028 .17703 L
.2038 .18425 L
.2048 .19303 L
.20579 .20327 L
.20679 .21485 L
.20779 .22762 L
.20879 .24143 L
.20979 .25606 L
.21079 .27124 L
.21179 .28666 L
.21279 .3019 L
.21379 .31649 L
.21479 .32992 L
.21578 .34162 L
.21678 .35107 L
.21778 .35778 L
.21878 .36141 L
.21978 .36181 L
.22078 .35908 L
.22178 .35352 L
.22278 .34567 L
.22378 .33614 L
.22478 .32552 L
.22577 .31436 L
.22677 .30304 L
.22777 .29185 L
.22877 .28096 L
.22977 .27044 L
.23077 .26034 L
.23177 .25066 L
.23277 .24139 L
.23377 .23249 L
.23477 .22395 L
.23576 .21574 L
.23676 .20784 L
.23776 .20021 L
.23876 .19286 L
.23976 .18575 L
.24076 .17887 L
.24176 .1722 L
.24276 .16574 L
.24376 .15945 L
.24476 .15333 L
.24575 .14736 L
.24675 .14151 L
.24775 .13576 L
Mistroke
.24875 .13008 L
.24975 .22967 L
.25075 .22492 L
.25175 .22171 L
.25275 .21938 L
.25375 .21773 L
.25475 .21664 L
.25574 .21606 L
.25674 .21595 L
.25774 .21628 L
.25874 .21701 L
.25974 .21811 L
.26074 .21957 L
.26174 .22137 L
.26274 .22349 L
.26374 .2259 L
.26474 .22861 L
.26573 .2316 L
.26673 .23485 L
.26773 .23834 L
.26873 .24204 L
.26973 .24592 L
.27073 .24995 L
.27173 .25404 L
.27273 .25814 L
.27373 .26216 L
.27473 .266 L
.27572 .26954 L
.27672 .27267 L
.27772 .27527 L
.27872 .27724 L
.27972 .27847 L
.28072 .2789 L
.28172 .2785 L
.28272 .27724 L
.28372 .27517 L
.28472 .27235 L
.28571 .26885 L
.28671 .26477 L
.28771 .26022 L
.28871 .2553 L
.28971 .25009 L
.29071 .24467 L
.29171 .23912 L
.29271 .23348 L
.29371 .22781 L
.29471 .22213 L
.2957 .21647 L
.2967 .21086 L
.2977 .2053 L
Mistroke
.2987 .19981 L
.2997 .23735 L
.3007 .22849 L
.3017 .22101 L
.3027 .21426 L
.3037 .20805 L
.3047 .20228 L
.30569 .19691 L
.30669 .1919 L
.30769 .18723 L
.30869 .18289 L
.30969 .17886 L
.31069 .17513 L
.31169 .1717 L
.31269 .16854 L
.31369 .16566 L
.31469 .16303 L
.31568 .16064 L
.31668 .1585 L
.31768 .15661 L
.31868 .15496 L
.31968 .15358 L
.32068 .1525 L
.32168 .15176 L
.32268 .15142 L
.32368 .15155 L
.32468 .15225 L
.32567 .15362 L
.32667 .1558 L
.32767 .15891 L
.32867 .1631 L
.32967 .1685 L
.33067 .17524 L
.33167 .18341 L
.33267 .19303 L
.33367 .20407 L
.33467 .21638 L
.33566 .2297 L
.33666 .24359 L
.33766 .2575 L
.33866 .27067 L
.33966 .28224 L
.34066 .29129 L
.34166 .29707 L
.34266 .29921 L
.34366 .2979 L
.34466 .29381 L
.34565 .2878 L
.34665 .28064 L
.34765 .27292 L
Mistroke
.34865 .26507 L
.34965 .36108 L
.35065 .35565 L
.35165 .3499 L
.35265 .34341 L
.35365 .33619 L
.35465 .32838 L
.35564 .32012 L
.35664 .31156 L
.35764 .30285 L
.35864 .29408 L
.35964 .28535 L
.36064 .27674 L
.36164 .26828 L
.36264 .26001 L
.36364 .25196 L
.36464 .24412 L
.36563 .23652 L
.36663 .22915 L
.36763 .222 L
.36863 .21508 L
.36963 .20838 L
.37063 .20189 L
.37163 .19562 L
.37263 .18954 L
.37363 .18367 L
.37463 .17798 L
.37562 .17248 L
.37662 .16714 L
.37762 .16197 L
.37862 .15695 L
.37962 .15206 L
.38062 .14729 L
.38162 .1426 L
.38262 .13798 L
.38362 .13339 L
.38462 .12879 L
.38561 .12414 L
.38661 .1194 L
.38761 .1145 L
.38861 .10941 L
.38961 .10407 L
.39061 .09842 L
.39161 .09242 L
.39261 .08602 L
.39361 .07918 L
.39461 .07188 L
.3956 .06408 L
.3966 .05579 L
.3976 .04702 L
Mistroke
.3986 .0378 L
.3996 .11326 L
.4006 .10826 L
.4016 .10476 L
.4026 .10214 L
.4036 .10022 L
.4046 .09893 L
.40559 .09824 L
.40659 .09815 L
.40759 .09865 L
.40859 .09975 L
.40959 .10145 L
.41059 .10377 L
.41159 .10672 L
.41259 .11037 L
.41359 .1148 L
.41459 .12011 L
.41558 .12647 L
.41658 .13406 L
.41758 .14311 L
.41858 .15388 L
.41958 .16663 L
.42058 .18162 L
.42158 .19904 L
.42258 .21899 L
.42358 .24137 L
.42458 .26584 L
.42557 .29167 L
.42657 .31776 L
.42757 .34252 L
.42857 .36389 L
.42957 .37944 L
.43057 .38695 L
.43157 .38569 L
.43257 .37744 L
.43357 .36528 L
.43457 .35181 L
.43556 .33862 L
.43656 .32648 L
.43756 .31564 L
.43856 .30604 L
.43956 .29749 L
.44056 .28973 L
.44156 .28251 L
.44256 .27561 L
.44356 .26888 L
.44456 .26221 L
.44555 .25554 L
.44655 .24887 L
.44755 .2422 L
Mistroke
.44855 .23556 L
.44955 .30243 L
.45055 .29288 L
.45155 .28491 L
.45255 .2778 L
.45355 .2713 L
.45455 .26527 L
.45554 .25964 L
.45654 .25433 L
.45754 .24932 L
.45854 .24457 L
.45954 .24006 L
.46054 .23576 L
.46154 .23167 L
.46254 .22776 L
.46354 .22404 L
.46454 .22049 L
.46553 .21711 L
.46653 .21389 L
.46753 .21083 L
.46853 .20793 L
.46953 .20518 L
.47053 .20258 L
.47153 .20015 L
.47253 .19787 L
.47353 .19576 L
.47453 .19382 L
.47552 .19207 L
.47652 .19051 L
.47752 .18917 L
.47852 .18806 L
.47952 .18719 L
.48052 .1866 L
.48152 .18631 L
.48252 .18633 L
.48352 .1867 L
.48452 .18744 L
.48551 .18856 L
.48651 .19008 L
.48751 .19201 L
.48851 .19436 L
.48951 .1971 L
.49051 .20021 L
.49151 .20365 L
.49251 .20737 L
.49351 .21129 L
.49451 .21532 L
.4955 .21935 L
.4965 .22325 L
.4975 .22689 L
Mistroke
.4985 .23016 L
.4995 .38183 L
.5005 .37931 L
.5015 .37541 L
.5025 .3698 L
.5035 .36264 L
.5045 .35425 L
.50549 .34495 L
.50649 .33507 L
.50749 .32487 L
.50849 .31459 L
.50949 .3044 L
.51049 .29441 L
.51149 .28471 L
.51249 .27534 L
.51349 .26631 L
.51449 .25764 L
.51548 .24931 L
.51648 .2413 L
.51748 .2336 L
.51848 .22619 L
.51948 .21906 L
.52048 .21218 L
.52148 .20554 L
.52248 .19913 L
.52348 .19294 L
.52448 .18697 L
.52547 .18119 L
.52647 .17562 L
.52747 .17023 L
.52847 .16504 L
.52947 .16003 L
.53047 .1552 L
.53147 .15054 L
.53247 .14606 L
.53347 .14174 L
.53447 .1376 L
.53546 .13361 L
.53646 .12977 L
.53746 .12608 L
.53846 .12251 L
.53946 .11907 L
.54046 .11572 L
.54146 .11244 L
.54246 .10921 L
.54346 .10599 L
.54446 .10275 L
.54545 .09944 L
.54645 .09604 L
.54745 .09249 L
Mistroke
.54845 .08876 L
.54945 .12544 L
.55045 .12107 L
.55145 .11847 L
.55245 .11704 L
.55345 .1166 L
.55445 .11709 L
.55544 .1185 L
.55644 .12083 L
.55744 .12409 L
.55844 .12831 L
.55944 .13353 L
.56044 .13981 L
.56144 .14723 L
.56244 .1559 L
.56344 .16595 L
.56444 .17752 L
.56543 .19074 L
.56643 .20572 L
.56743 .22253 L
.56843 .24114 L
.56943 .26139 L
.57043 .28292 L
.57143 .30517 L
.57243 .3273 L
.57343 .34818 L
.57443 .36643 L
.57542 .38052 L
.57642 .38898 L
.57742 .39094 L
.57842 .38667 L
.57942 .37766 L
.58042 .36587 L
.58142 .35299 L
.58242 .34013 L
.58342 .32792 L
.58442 .31661 L
.58541 .30626 L
.58641 .29677 L
.58741 .28801 L
.58841 .27982 L
.58941 .27207 L
.59041 .26463 L
.59141 .25742 L
.59241 .25037 L
.59341 .24344 L
.59441 .23662 L
.5954 .22989 L
.5964 .22326 L
.5974 .21671 L
Mistroke
.5984 .21026 L
.5994 .24814 L
.6004 .23944 L
.6014 .23235 L
.6024 .22618 L
.6034 .22069 L
.6044 .21577 L
.60539 .21134 L
.60639 .20736 L
.60739 .20379 L
.60839 .2006 L
.60939 .19778 L
.61039 .1953 L
.61139 .19314 L
.61239 .19131 L
.61339 .18978 L
.61439 .18857 L
.61538 .18766 L
.61638 .18707 L
.61738 .18681 L
.61838 .1869 L
.61938 .18738 L
.62038 .18827 L
.62138 .18961 L
.62238 .19146 L
.62338 .19385 L
.62438 .19684 L
.62537 .20046 L
.62637 .20475 L
.62737 .20972 L
.62837 .21536 L
.62937 .22166 L
.63037 .22852 L
.63137 .23585 L
.63237 .24347 L
.63337 .25119 L
.63437 .25873 L
.63536 .2658 L
.63636 .27207 L
.63736 .27722 L
.63836 .28098 L
.63936 .28315 L
.64036 .28366 L
.64136 .28258 L
.64236 .28009 L
.64336 .27644 L
.64436 .27189 L
.64535 .2667 L
.64635 .26109 L
.64735 .25523 L
Mistroke
.64835 .24924 L
.64935 .22706 L
.65035 .21856 L
.65135 .21146 L
.65235 .20511 L
.65335 .19931 L
.65435 .19395 L
.65534 .18898 L
.65634 .18437 L
.65734 .1801 L
.65834 .17614 L
.65934 .17249 L
.66034 .16912 L
.66134 .16604 L
.66234 .16321 L
.66334 .16063 L
.66434 .1583 L
.66533 .15619 L
.66633 .15431 L
.66733 .15267 L
.66833 .15127 L
.66933 .15013 L
.67033 .1493 L
.67133 .14881 L
.67233 .14874 L
.67333 .14916 L
.67433 .15017 L
.67532 .15189 L
.67632 .15444 L
.67732 .15796 L
.67832 .1626 L
.67932 .16848 L
.68032 .17574 L
.68132 .18444 L
.68232 .19463 L
.68332 .20626 L
.68432 .21916 L
.68531 .23307 L
.68631 .24754 L
.68731 .26197 L
.68831 .2756 L
.68931 .28748 L
.69031 .29666 L
.69131 .3023 L
.69231 .30408 L
.69331 .30228 L
.69431 .2977 L
.6953 .29126 L
.6963 .28378 L
.6973 .27587 L
Mistroke
.6983 .26791 L
.6993 .33156 L
.7003 .31929 L
.7013 .30821 L
.7023 .29775 L
.7033 .28777 L
.7043 .27819 L
.70529 .26899 L
.70629 .26014 L
.70729 .25162 L
.70829 .24342 L
.70929 .23551 L
.71029 .22789 L
.71129 .22053 L
.71229 .21343 L
.71329 .20656 L
.71429 .19994 L
.71528 .19353 L
.71628 .18734 L
.71728 .18136 L
.71828 .17558 L
.71928 .16999 L
.72028 .1646 L
.72128 .15939 L
.72228 .15437 L
.72328 .14952 L
.72428 .14484 L
.72527 .14032 L
.72627 .13597 L
.72727 .13175 L
.72827 .12768 L
.72927 .12372 L
.73027 .11987 L
.73127 .1161 L
.73227 .11237 L
.73327 .10866 L
.73427 .10492 L
.73526 .1011 L
.73626 .09716 L
.73726 .09303 L
.73826 .08866 L
.73926 .084 L
.74026 .07899 L
.74126 .07359 L
.74226 .06777 L
.74326 .06151 L
.74426 .0548 L
.74525 .04766 L
.74625 .04015 L
.74725 .03235 L
Mistroke
.74825 .02439 L
.74925 .13643 L
.75025 .14448 L
.75125 .15587 L
.75225 .17 L
.75325 .1867 L
.75425 .20582 L
.75524 .2272 L
.75624 .25059 L
.75724 .27563 L
.75824 .30181 L
.75924 .32841 L
.76024 .35454 L
.76124 .3791 L
.76224 .40089 L
.76324 .41865 L
.76424 .43127 L
.76523 .4379 L
.76623 .43821 L
.76723 .43255 L
.76823 .42195 L
.76923 .40792 L
.77023 .39207 L
.77123 .37576 L
.77223 .35993 L
.77323 .34514 L
.77423 .3316 L
.77522 .31931 L
.77622 .30816 L
.77722 .29801 L
.77822 .28868 L
.77922 .28003 L
.78022 .27196 L
.78122 .26437 L
.78222 .25721 L
.78322 .25042 L
.78422 .24398 L
.78521 .23785 L
.78621 .23204 L
.78721 .22652 L
.78821 .2213 L
.78921 .21637 L
.79021 .21175 L
.79121 .20743 L
.79221 .20342 L
.79321 .19974 L
.79421 .19638 L
.7952 .19336 L
.7962 .19068 L
.7972 .18835 L
Mistroke
.7982 .18639 L
.7992 .27825 L
.8002 .27576 L
.8012 .27458 L
.8022 .274 L
.8032 .27376 L
.8042 .27372 L
.80519 .27378 L
.80619 .27387 L
.80719 .27393 L
.80819 .27392 L
.80919 .27381 L
.81019 .27355 L
.81119 .27315 L
.81219 .27258 L
.81319 .27182 L
.81419 .27089 L
.81518 .26977 L
.81618 .26848 L
.81718 .267 L
.81818 .26536 L
.81918 .26355 L
.82018 .26158 L
.82118 .25948 L
.82218 .25723 L
.82318 .25486 L
.82418 .25237 L
.82517 .24977 L
.82617 .24708 L
.82717 .2443 L
.82817 .24144 L
.82917 .23851 L
.83017 .23552 L
.83117 .23248 L
.83217 .2294 L
.83317 .22628 L
.83417 .22314 L
.83516 .21999 L
.83616 .21683 L
.83716 .21367 L
.83816 .21052 L
.83916 .20739 L
.84016 .20429 L
.84116 .20122 L
.84216 .1982 L
.84316 .19524 L
.84416 .19235 L
.84515 .18953 L
.84615 .18681 L
.84715 .18419 L
Mistroke
.84815 .18169 L
.84915 .30717 L
.85015 .30812 L
.85115 .3097 L
.85215 .31117 L
.85315 .31225 L
.85415 .3128 L
.85514 .31275 L
.85614 .31204 L
.85714 .31068 L
.85814 .30868 L
.85914 .30607 L
.86014 .30291 L
.86114 .29925 L
.86214 .29515 L
.86314 .29068 L
.86414 .2859 L
.86513 .28088 L
.86613 .27567 L
.86713 .27032 L
.86813 .26487 L
.86913 .25937 L
.87013 .25385 L
.87113 .24834 L
.87213 .24286 L
.87313 .23742 L
.87413 .23204 L
.87512 .22674 L
.87612 .22152 L
.87712 .21638 L
.87812 .21134 L
.87912 .20639 L
.88012 .20153 L
.88112 .19676 L
.88212 .19208 L
.88312 .18748 L
.88412 .18297 L
.88511 .17854 L
.88611 .17417 L
.88711 .16988 L
.88811 .16565 L
.88911 .16148 L
.89011 .15738 L
.89111 .15335 L
.89211 .14938 L
.89311 .1455 L
.89411 .14172 L
.8951 .13806 L
.8961 .13455 L
.8971 .13122 L
Mistroke
.8981 .12813 L
.8991 .1508 L
.9001 .15116 L
.9011 .15374 L
.9021 .15793 L
.9031 .16358 L
.9041 .17062 L
.90509 .17901 L
.90609 .18873 L
.90709 .19975 L
.90809 .21204 L
.90909 .22554 L
.91009 .24016 L
.91109 .25577 L
.91209 .27215 L
.91309 .28903 L
.91409 .30602 L
.91508 .32264 L
.91608 .33831 L
.91708 .35239 L
.91808 .36421 L
.91908 .37311 L
.92008 .37858 L
.92108 .38029 L
.92208 .37825 L
.92308 .37285 L
.92408 .36474 L
.92507 .35477 L
.92607 .34372 L
.92707 .33226 L
.92807 .32084 L
.92907 .30977 L
.93007 .2992 L
.93107 .28919 L
.93207 .27973 L
.93307 .27079 L
.93407 .26231 L
.93506 .25425 L
.93606 .24655 L
.93706 .23915 L
.93806 .23203 L
.93906 .22514 L
.94006 .21844 L
.94106 .21192 L
.94206 .20556 L
.94306 .19932 L
.94406 .19319 L
.94505 .18716 L
.94605 .1812 L
.94705 .1753 L
Mistroke
.94805 .16944 L
.94905 .19988 L
.95005 .19189 L
.95105 .18535 L
.95205 .17961 L
.95305 .17445 L
.95405 .16979 L
.95504 .16556 L
.95604 .16174 L
.95704 .15831 L
.95804 .15525 L
.95904 .15254 L
.96004 .15016 L
.96104 .14811 L
.96204 .14637 L
.96304 .14494 L
.96404 .1438 L
.96503 .14297 L
.96603 .14245 L
.96703 .14229 L
.96803 .14254 L
.96903 .14325 L
.97003 .14453 L
.97103 .14647 L
.97203 .14922 L
.97303 .15293 L
.97403 .15776 L
.97502 .16389 L
.97602 .1715 L
.97702 .18074 L
.97802 .19172 L
.97902 .20447 L
.98002 .21891 L
.98102 .23484 L
.98202 .25184 L
.98302 .26931 L
.98402 .28638 L
.98501 .30194 L
.98601 .31469 L
.98701 .32328 L
.98801 .32682 L
.98901 .3254 L
.99001 .32004 L
.99101 .31214 L
.99201 .30294 L
.99301 .2933 L
.99401 .28376 L
.995 .27461 L
.996 .26597 L
.997 .25787 L
Mistroke
.998 .25026 L
.999 .27969 L
Mfstroke
gsave
.999 .2923 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .01629 L
.004 .01789 L
.005 .01925 L
.00599 .02047 L
.00699 .02157 L
.00799 .0226 L
.00899 .02359 L
.00999 .02458 L
.01099 .0256 L
.01199 .02671 L
.01299 .02796 L
.01399 .02943 L
.01499 .03124 L
.01598 .03354 L
.01698 .03653 L
.01798 .0405 L
.01898 .0458 L
.01998 .05286 L
.02098 .06222 L
.02198 .07448 L
.02298 .09031 L
.02398 .11048 L
.02498 .13584 L
.02597 .16733 L
.02697 .20595 L
.02797 .25265 L
.02897 .30825 L
.02997 .37324 L
.03097 .44751 L
.03197 .53011 L
s
.03197 .53011 m
.03296 .61803 L
s
.04958 .61803 m
.04995 .41552 L
.05095 .46935 L
.05195 .5196 L
.05295 .56183 L
.05395 .59242 L
.05495 .60914 L
.05594 .61173 L
.05694 .60204 L
.05794 .58348 L
.05894 .56019 L
.05994 .53612 L
.06094 .51436 L
.06194 .49687 L
.06294 .48452 L
.06394 .47738 L
.06494 .47495 L
.06593 .47643 L
.06693 .48088 L
.06793 .48734 L
.06893 .49485 L
.06993 .5025 L
.07093 .5095 L
.07193 .51515 L
.07293 .51893 L
.07393 .52049 L
.07493 .51963 L
.07592 .51635 L
.07692 .51081 L
.07792 .50324 L
.07892 .494 L
.07992 .48352 L
.08092 .47224 L
.08192 .46062 L
.08292 .44908 L
.08392 .43804 L
.08492 .42787 L
.08591 .4189 L
.08691 .4114 L
.08791 .4055 L
.08891 .40121 L
.08991 .39837 L
.09091 .39667 L
.09191 .39576 L
.09291 .39526 L
.09391 .39484 L
.09491 .39425 L
.0959 .39331 L
.0969 .3919 L
.0979 .38998 L
Mistroke
.0989 .38752 L
.0999 .23806 L
.1009 .23608 L
.1019 .23318 L
.1029 .22997 L
.1039 .22666 L
.1049 .22334 L
.10589 .22007 L
.10689 .2169 L
.10789 .21387 L
.10889 .211 L
.10989 .20834 L
.11089 .20592 L
.11189 .20378 L
.11289 .20198 L
.11389 .20058 L
.11489 .19965 L
.11588 .19928 L
.11688 .19956 L
.11788 .2006 L
.11888 .20255 L
.11988 .20553 L
.12088 .20971 L
.12188 .21524 L
.12288 .22229 L
.12388 .23101 L
.12488 .24155 L
.12587 .25403 L
.12687 .26852 L
.12787 .28505 L
.12887 .30358 L
.12987 .32396 L
.13087 .34593 L
.13187 .3691 L
.13287 .39291 L
.13387 .41667 L
.13487 .43955 L
.13586 .46061 L
.13686 .47893 L
.13786 .49359 L
.13886 .50387 L
.13986 .50931 L
.14086 .50979 L
.14186 .50566 L
.14286 .49777 L
.14386 .48761 L
.14486 .47736 L
.14585 .46984 L
.14685 .46777 L
.14785 .47186 L
Mistroke
.14885 .47992 L
.14985 .40944 L
.15085 .40904 L
.15185 .40456 L
.15285 .39733 L
.15385 .38826 L
.15485 .37808 L
.15584 .36735 L
.15684 .3565 L
.15784 .34581 L
.15884 .33548 L
.15984 .32559 L
.16084 .31619 L
.16184 .30729 L
.16284 .29888 L
.16384 .29092 L
.16484 .28338 L
.16583 .27623 L
.16683 .26945 L
.16783 .26301 L
.16883 .25689 L
.16983 .25107 L
.17083 .24556 L
.17183 .24035 L
.17283 .23544 L
.17383 .23084 L
.17483 .22656 L
.17582 .22264 L
.17682 .21909 L
.17782 .21596 L
.17882 .21328 L
.17982 .21112 L
.18082 .20955 L
.18182 .20864 L
.18282 .20848 L
.18382 .20917 L
.18482 .21083 L
.18581 .21359 L
.18681 .21757 L
.18781 .2229 L
.18881 .22973 L
.18981 .23818 L
.19081 .24838 L
.19181 .26041 L
.19281 .27437 L
.19381 .29028 L
.19481 .30812 L
.1958 .32781 L
.1968 .34917 L
.1978 .37193 L
Mistroke
.1988 .39572 L
.1998 .1797 L
.2008 .18851 L
.2018 .19775 L
.2028 .20825 L
.2038 .22036 L
.2048 .2343 L
.20579 .25021 L
.20679 .26811 L
.20779 .28792 L
.20879 .30937 L
.20979 .33204 L
.21079 .35533 L
.21179 .37846 L
.21279 .40053 L
.21379 .42061 L
.21479 .43778 L
.21578 .4513 L
.21678 .46067 L
.21778 .46574 L
.21878 .46665 L
.21978 .46386 L
.22078 .45797 L
.22178 .44965 L
.22278 .43956 L
.22378 .42823 L
.22478 .41616 L
.22577 .40374 L
.22677 .39128 L
.22777 .37905 L
.22877 .36723 L
.22977 .35594 L
.23077 .34525 L
.23177 .3352 L
.23277 .32577 L
.23377 .31695 L
.23477 .30869 L
.23576 .30097 L
.23676 .29374 L
.23776 .28697 L
.23876 .28064 L
.23976 .27471 L
.24076 .26919 L
.24176 .26406 L
.24276 .25932 L
.24376 .25498 L
.24476 .25106 L
.24575 .24758 L
.24675 .24456 L
.24775 .24204 L
Mistroke
.24875 .24007 L
.24975 .24232 L
.25075 .24548 L
.25175 .24787 L
.25275 .25019 L
.25375 .2527 L
.25475 .25552 L
.25574 .25877 L
.25674 .26252 L
.25774 .26683 L
.25874 .27174 L
.25974 .2773 L
.26074 .28351 L
.26174 .29036 L
.26274 .29783 L
.26374 .30586 L
.26474 .31435 L
.26573 .32321 L
.26673 .33227 L
.26773 .34139 L
.26873 .35036 L
.26973 .359 L
.27073 .36711 L
.27173 .37449 L
.27273 .38097 L
.27373 .38642 L
.27473 .39074 L
.27572 .39388 L
.27672 .39583 L
.27772 .39665 L
.27872 .39642 L
.27972 .39526 L
.28072 .3933 L
.28172 .39068 L
.28272 .38753 L
.28372 .38397 L
.28472 .38008 L
.28571 .37595 L
.28671 .37163 L
.28771 .36715 L
.28871 .36256 L
.28971 .35788 L
.29071 .35316 L
.29171 .34841 L
.29271 .34367 L
.29371 .33896 L
.29471 .33432 L
.2957 .32976 L
.2967 .32533 L
.2977 .32104 L
Mistroke
.2987 .31691 L
.2997 .24998 L
.3007 .24893 L
.3017 .2469 L
.3027 .24457 L
.3037 .24216 L
.3047 .23979 L
.30569 .23753 L
.30669 .23546 L
.30769 .23363 L
.30869 .23208 L
.30969 .23089 L
.31069 .23012 L
.31169 .22982 L
.31269 .23007 L
.31369 .23095 L
.31469 .23255 L
.31568 .23495 L
.31668 .23824 L
.31768 .24251 L
.31868 .24784 L
.31968 .2543 L
.32068 .26195 L
.32168 .27083 L
.32268 .28093 L
.32368 .29223 L
.32468 .30464 L
.32567 .31803 L
.32667 .3322 L
.32767 .3469 L
.32867 .36181 L
.32967 .37653 L
.33067 .39065 L
.33167 .40373 L
.33267 .41531 L
.33367 .42502 L
.33467 .43256 L
.33566 .43777 L
.33666 .44066 L
.33766 .44148 L
.33866 .44065 L
.33966 .43883 L
.34066 .43678 L
.34166 .43519 L
.34266 .43441 L
.34366 .43432 L
.34466 .43438 L
.34565 .43396 L
.34665 .43251 L
.34765 .42976 L
Mistroke
.34865 .4256 L
.34965 .37371 L
.35065 .37627 L
.35165 .37633 L
.35265 .37467 L
.35365 .37169 L
.35465 .36765 L
.35564 .3628 L
.35664 .35734 L
.35764 .35144 L
.35864 .34525 L
.35964 .33888 L
.36064 .33242 L
.36164 .32595 L
.36264 .31951 L
.36364 .31315 L
.36464 .30689 L
.36563 .30076 L
.36663 .29477 L
.36763 .28893 L
.36863 .28324 L
.36963 .27772 L
.37063 .27238 L
.37163 .26721 L
.37263 .26223 L
.37363 .25745 L
.37463 .25287 L
.37562 .24851 L
.37662 .2444 L
.37762 .24054 L
.37862 .23697 L
.37962 .23371 L
.38062 .23081 L
.38162 .22831 L
.38262 .22626 L
.38362 .22474 L
.38462 .2238 L
.38561 .22353 L
.38661 .22402 L
.38761 .22538 L
.38861 .22771 L
.38961 .23113 L
.39061 .23574 L
.39161 .24166 L
.39261 .24902 L
.39361 .2579 L
.39461 .26841 L
.3956 .2806 L
.3966 .29453 L
.3976 .31019 L
Mistroke
.3986 .32753 L
.3996 .12595 L
.4006 .12865 L
.4016 .13048 L
.4026 .13216 L
.4036 .13398 L
.4046 .13615 L
.40559 .13884 L
.40659 .14223 L
.40759 .14653 L
.40859 .15196 L
.40959 .15878 L
.41059 .16726 L
.41159 .17768 L
.41259 .19031 L
.41359 .20541 L
.41459 .22316 L
.41558 .2437 L
.41658 .26702 L
.41758 .29296 L
.41858 .32118 L
.41958 .35105 L
.42058 .38171 L
.42158 .41201 L
.42258 .44059 L
.42358 .46596 L
.42458 .48674 L
.42557 .5018 L
.42657 .51058 L
.42757 .51329 L
.42857 .51107 L
.42957 .50599 L
.43057 .50051 L
.43157 .49609 L
.43257 .49207 L
.43357 .48676 L
.43457 .47902 L
.43556 .46868 L
.43656 .4562 L
.43756 .44238 L
.43856 .42801 L
.43956 .41383 L
.44056 .40039 L
.44156 .38806 L
.44256 .37706 L
.44356 .36748 L
.44456 .3593 L
.44555 .35241 L
.44655 .34669 L
.44755 .34198 L
Mistroke
.44855 .33812 L
.44955 .31508 L
.45055 .3134 L
.45155 .31098 L
.45255 .3084 L
.45355 .30584 L
.45455 .30335 L
.45554 .30097 L
.45654 .29872 L
.45754 .29661 L
.45854 .29465 L
.45954 .29285 L
.46054 .29123 L
.46154 .28981 L
.46254 .28859 L
.46354 .28759 L
.46454 .28684 L
.46553 .28636 L
.46653 .28615 L
.46753 .28624 L
.46853 .28665 L
.46953 .2874 L
.47053 .2885 L
.47153 .28996 L
.47253 .29181 L
.47353 .29404 L
.47453 .29666 L
.47552 .29967 L
.47652 .30306 L
.47752 .30683 L
.47852 .31093 L
.47952 .31536 L
.48052 .32007 L
.48152 .32501 L
.48252 .33013 L
.48352 .33536 L
.48452 .34065 L
.48551 .3459 L
.48651 .35106 L
.48751 .35603 L
.48851 .36075 L
.48951 .36514 L
.49051 .36915 L
.49151 .37273 L
.49251 .37586 L
.49351 .37852 L
.49451 .38072 L
.4955 .38249 L
.4965 .38388 L
.4975 .38495 L
Mistroke
.4985 .38577 L
.4995 .39446 L
.5005 .39987 L
.5015 .40169 L
.5025 .40083 L
.5035 .39781 L
.5045 .39308 L
.50549 .38705 L
.50649 .38009 L
.50749 .37253 L
.50849 .36462 L
.50949 .35657 L
.51049 .34851 L
.51149 .34056 L
.51249 .33278 L
.51349 .32522 L
.51449 .3179 L
.51548 .31082 L
.51648 .30399 L
.51748 .29739 L
.51848 .29103 L
.51948 .28488 L
.52048 .27894 L
.52148 .2732 L
.52248 .26765 L
.52348 .26229 L
.52448 .2571 L
.52547 .2521 L
.52647 .24727 L
.52747 .24262 L
.52847 .23814 L
.52947 .23385 L
.53047 .22975 L
.53147 .22586 L
.53247 .22217 L
.53347 .21871 L
.53447 .2155 L
.53546 .21256 L
.53646 .20992 L
.53746 .20763 L
.53846 .20571 L
.53946 .20424 L
.54046 .20328 L
.54146 .2029 L
.54246 .2032 L
.54346 .20429 L
.54446 .20628 L
.54545 .20932 L
.54645 .21356 L
.54745 .21915 L
Mistroke
.54845 .22627 L
.54945 .13815 L
.55045 .14147 L
.55145 .14423 L
.55245 .1472 L
.55345 .1507 L
.55445 .15497 L
.55544 .16026 L
.55644 .16681 L
.55744 .17487 L
.55844 .18471 L
.55944 .19659 L
.56044 .21076 L
.56144 .2274 L
.56244 .24662 L
.56344 .26841 L
.56444 .29262 L
.56543 .31891 L
.56643 .34671 L
.56743 .3752 L
.56843 .40336 L
.56943 .42996 L
.57043 .45371 L
.57143 .47341 L
.57243 .48811 L
.57343 .49735 L
.57443 .50131 L
.57542 .50083 L
.57642 .4973 L
.57742 .49213 L
.57842 .48603 L
.57942 .47886 L
.58042 .47012 L
.58142 .45963 L
.58242 .44758 L
.58342 .43446 L
.58442 .42083 L
.58541 .40723 L
.58641 .39412 L
.58741 .38179 L
.58841 .37046 L
.58941 .36022 L
.59041 .3511 L
.59141 .34306 L
.59241 .33604 L
.59341 .32995 L
.59441 .3247 L
.5954 .32019 L
.5964 .31635 L
.5974 .31311 L
Mistroke
.5984 .31041 L
.5994 .26077 L
.6004 .25986 L
.6014 .25819 L
.6024 .2564 L
.6034 .2547 L
.6044 .2532 L
.60539 .25195 L
.60639 .25102 L
.60739 .25045 L
.60839 .25029 L
.60939 .25059 L
.61039 .2514 L
.61139 .25277 L
.61239 .25475 L
.61339 .25739 L
.61439 .26074 L
.61538 .26484 L
.61638 .26971 L
.61738 .27537 L
.61838 .28182 L
.61938 .28904 L
.62038 .29699 L
.62138 .3056 L
.62238 .31477 L
.62338 .32439 L
.62438 .33429 L
.62537 .3443 L
.62637 .35421 L
.62737 .3638 L
.62837 .37285 L
.62937 .38115 L
.63037 .38851 L
.63137 .39477 L
.63237 .39982 L
.63337 .40365 L
.63437 .40628 L
.63536 .40783 L
.63636 .40849 L
.63736 .40846 L
.63836 .40798 L
.63936 .40722 L
.64036 .40629 L
.64136 .4052 L
.64236 .40387 L
.64336 .40218 L
.64436 .40002 L
.64535 .39732 L
.64635 .39401 L
.64735 .39013 L
Mistroke
.64835 .38569 L
.64935 .23968 L
.65035 .23892 L
.65135 .23718 L
.65235 .23512 L
.65335 .23298 L
.65435 .23087 L
.65534 .22888 L
.65634 .22708 L
.65734 .22552 L
.65834 .22425 L
.65934 .22334 L
.66034 .22286 L
.66134 .22286 L
.66234 .22342 L
.66334 .22462 L
.66434 .22655 L
.66533 .22929 L
.66633 .23294 L
.66733 .23756 L
.66833 .24325 L
.66933 .25006 L
.67033 .25806 L
.67133 .26725 L
.67233 .27765 L
.67333 .28921 L
.67433 .30184 L
.67532 .3154 L
.67632 .32971 L
.67732 .34449 L
.67832 .35943 L
.67932 .37415 L
.68032 .38823 L
.68132 .40123 L
.68232 .41273 L
.68332 .42235 L
.68432 .42981 L
.68531 .43496 L
.68631 .43782 L
.68731 .43865 L
.68831 .4379 L
.68931 .43629 L
.69031 .43461 L
.69131 .43359 L
.69231 .43356 L
.69331 .43427 L
.69431 .43509 L
.6953 .43528 L
.6963 .43428 L
.6973 .4318 L
Mistroke
.6983 .42777 L
.6993 .34417 L
.7003 .33969 L
.7013 .33403 L
.7023 .32792 L
.7033 .32162 L
.7043 .31526 L
.70529 .30891 L
.70629 .30262 L
.70729 .29643 L
.70829 .29035 L
.70929 .2844 L
.71029 .27857 L
.71129 .27288 L
.71229 .26733 L
.71329 .26192 L
.71429 .25664 L
.71528 .25151 L
.71628 .24652 L
.71728 .24168 L
.71828 .23698 L
.71928 .23243 L
.72028 .22805 L
.72128 .22382 L
.72228 .21977 L
.72328 .2159 L
.72428 .21222 L
.72527 .20876 L
.72627 .20552 L
.72727 .20255 L
.72827 .19986 L
.72927 .19751 L
.73027 .19554 L
.73127 .194 L
.73227 .19297 L
.73327 .19253 L
.73427 .19279 L
.73526 .19385 L
.73626 .19585 L
.73726 .19892 L
.73826 .20322 L
.73926 .20891 L
.74026 .21617 L
.74126 .22517 L
.74226 .23609 L
.74326 .24908 L
.74426 .2643 L
.74525 .28187 L
.74625 .30187 L
.74725 .32431 L
Mistroke
.74825 .34913 L
.74925 .14917 L
.75025 .16502 L
.75125 .18215 L
.75225 .20155 L
.75325 .22369 L
.75425 .24883 L
.75524 .27698 L
.75624 .30791 L
.75724 .341 L
.75824 .37528 L
.75924 .4094 L
.76024 .44173 L
.76124 .47049 L
.76224 .49401 L
.76324 .51101 L
.76424 .52082 L
.76523 .52356 L
.76623 .52003 L
.76723 .51143 L
.76823 .49906 L
.76923 .48412 L
.77023 .46763 L
.77123 .45054 L
.77223 .43365 L
.77323 .4176 L
.77423 .40288 L
.77522 .38976 L
.77622 .37837 L
.77722 .36871 L
.77822 .36069 L
.77922 .35416 L
.78022 .34895 L
.78122 .34485 L
.78222 .34171 L
.78322 .33935 L
.78422 .33763 L
.78521 .33643 L
.78621 .33563 L
.78721 .33515 L
.78821 .33491 L
.78921 .33485 L
.79021 .33492 L
.79121 .33508 L
.79221 .33529 L
.79321 .33552 L
.79421 .33576 L
.7952 .33599 L
.7962 .33619 L
.7972 .33637 L
Mistroke
.7982 .33653 L
.7992 .29091 L
.8002 .29623 L
.8012 .30057 L
.8022 .30457 L
.8032 .30842 L
.8042 .31218 L
.80519 .31588 L
.80619 .31951 L
.80719 .32305 L
.80819 .32648 L
.80919 .32976 L
.81019 .33286 L
.81119 .33574 L
.81219 .33837 L
.81319 .34071 L
.81419 .34274 L
.81518 .34444 L
.81618 .34579 L
.81718 .34678 L
.81818 .34741 L
.81918 .34769 L
.82018 .34763 L
.82118 .34726 L
.82218 .3466 L
.82318 .34567 L
.82418 .34451 L
.82517 .34315 L
.82617 .34163 L
.82717 .33998 L
.82817 .33824 L
.82917 .33644 L
.83017 .33462 L
.83117 .33281 L
.83217 .33103 L
.83317 .32932 L
.83417 .3277 L
.83516 .32619 L
.83616 .32482 L
.83716 .3236 L
.83816 .32256 L
.83916 .32171 L
.84016 .32107 L
.84116 .32065 L
.84216 .32046 L
.84316 .32051 L
.84416 .32081 L
.84515 .32137 L
.84615 .32218 L
.84715 .32326 L
Mistroke
.84815 .3246 L
.84915 .31982 L
.85015 .3286 L
.85115 .33576 L
.85215 .3419 L
.85315 .34715 L
.85415 .35154 L
.85514 .35506 L
.85614 .35772 L
.85714 .35954 L
.85814 .36051 L
.85914 .36069 L
.86014 .36012 L
.86114 .35886 L
.86214 .35698 L
.86314 .35455 L
.86414 .35165 L
.86513 .34836 L
.86613 .34474 L
.86713 .34088 L
.86813 .33684 L
.86913 .33267 L
.87013 .32843 L
.87113 .32417 L
.87213 .31992 L
.87313 .31574 L
.87413 .31165 L
.87512 .30768 L
.87612 .30387 L
.87712 .30023 L
.87812 .29681 L
.87912 .29363 L
.88012 .2907 L
.88112 .28807 L
.88212 .28576 L
.88312 .2838 L
.88412 .28222 L
.88511 .28105 L
.88611 .28033 L
.88711 .28009 L
.88811 .28037 L
.88911 .28119 L
.89011 .28259 L
.89111 .28461 L
.89211 .28727 L
.89311 .29058 L
.89411 .29457 L
.8951 .29924 L
.8961 .30459 L
.8971 .3106 L
Mistroke
.8981 .31725 L
.8991 .16347 L
.9001 .17158 L
.9011 .17966 L
.9021 .18854 L
.9031 .19863 L
.9041 .21021 L
.90509 .22353 L
.90609 .23876 L
.90709 .25597 L
.90809 .27515 L
.90909 .29615 L
.91009 .31867 L
.91109 .34221 L
.91209 .36612 L
.91309 .38958 L
.91409 .41168 L
.91508 .43146 L
.91608 .44806 L
.91708 .46081 L
.91808 .46932 L
.91908 .47356 L
.92008 .47387 L
.92108 .47082 L
.92208 .4651 L
.92308 .45734 L
.92408 .44804 L
.92507 .43759 L
.92607 .42631 L
.92707 .41452 L
.92807 .40251 L
.92907 .39056 L
.93007 .37889 L
.93107 .36768 L
.93207 .35704 L
.93307 .34702 L
.93407 .33766 L
.93506 .32894 L
.93606 .32086 L
.93706 .31337 L
.93806 .30645 L
.93906 .30006 L
.94006 .29418 L
.94106 .28878 L
.94206 .28385 L
.94306 .27938 L
.94406 .27536 L
.94505 .27181 L
.94605 .26873 L
.94705 .26613 L
Mistroke
.94805 .26405 L
.94905 .21249 L
.95005 .21223 L
.95105 .211 L
.95205 .2095 L
.95305 .20795 L
.95405 .2065 L
.95504 .20525 L
.95604 .20426 L
.95704 .20362 L
.95804 .20342 L
.95904 .20373 L
.96004 .20466 L
.96104 .20632 L
.96204 .20881 L
.96304 .21225 L
.96404 .21677 L
.96503 .22249 L
.96603 .22952 L
.96703 .23796 L
.96803 .24788 L
.96903 .25933 L
.97003 .27231 L
.97103 .28677 L
.97203 .30258 L
.97303 .31954 L
.97403 .33736 L
.97502 .35565 L
.97602 .37392 L
.97702 .39162 L
.97802 .40812 L
.97902 .42282 L
.98002 .43514 L
.98102 .44463 L
.98202 .45103 L
.98302 .45436 L
.98402 .45494 L
.98501 .45348 L
.98601 .45102 L
.98701 .44875 L
.98801 .44757 L
.98901 .44752 L
.99001 .44783 L
.99101 .44747 L
.99201 .44563 L
.99301 .44193 L
.99401 .43634 L
.995 .42907 L
.996 .42044 L
.997 .41084 L
Mistroke
.998 .40064 L
.999 .2923 L
Mfstroke
1 0 0 r
gsave
.999 .28599 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00166 L
.004 .00164 L
.005 .00164 L
.00599 .00167 L
.00699 .00173 L
.00799 .00183 L
.00899 .00199 L
.00999 .00221 L
.01099 .00251 L
.01199 .00291 L
.01299 .00343 L
.01399 .00412 L
.01499 .005 L
.01598 .00614 L
.01698 .00759 L
.01798 .00943 L
.01898 .01177 L
.01998 .01473 L
.02098 .01846 L
.02198 .02315 L
.02298 .02902 L
.02398 .03634 L
.02498 .04544 L
.02597 .05666 L
.02697 .07042 L
.02797 .08712 L
.02897 .10717 L
.02997 .13094 L
.03097 .15863 L
.03197 .19025 L
.03297 .2255 L
.03397 .26371 L
.03497 .30377 L
.03596 .34427 L
.03696 .38365 L
.03796 .42038 L
.03896 .45328 L
.03996 .48144 L
.04096 .50413 L
.04196 .52051 L
.04296 .52946 L
.04396 .52985 L
.04496 .52113 L
.04595 .50394 L
.04695 .48038 L
.04795 .4536 L
.04895 .42691 L
Mistroke
.04995 .40914 L
.05095 .45639 L
.05195 .49857 L
.05295 .53224 L
.05395 .55449 L
.05495 .56367 L
.05594 .55989 L
.05694 .54504 L
.05794 .52232 L
.05894 .49538 L
.05994 .46761 L
.06094 .44153 L
.06194 .4187 L
.06294 .3998 L
.06394 .3849 L
.06494 .37367 L
.06593 .36562 L
.06693 .36017 L
.06793 .35674 L
.06893 .3548 L
.06993 .35387 L
.07093 .35354 L
.07193 .35347 L
.07293 .35337 L
.07393 .35307 L
.07493 .35244 L
.07592 .35142 L
.07692 .35002 L
.07792 .34828 L
.07892 .34627 L
.07992 .34408 L
.08092 .34179 L
.08192 .33948 L
.08292 .33721 L
.08392 .33501 L
.08492 .3329 L
.08591 .33088 L
.08691 .32893 L
.08791 .32702 L
.08891 .32511 L
.08991 .32316 L
.09091 .32112 L
.09191 .31897 L
.09291 .31666 L
.09391 .31417 L
.09491 .31148 L
.0959 .30858 L
.0969 .30548 L
.0979 .30219 L
.0989 .29873 L
Mistroke
.0999 .23171 L
.1009 .2258 L
.1019 .22008 L
.1029 .21457 L
.1039 .20925 L
.1049 .20414 L
.10589 .19924 L
.10689 .19456 L
.10789 .19011 L
.10889 .18589 L
.10989 .18192 L
.11089 .1782 L
.11189 .17476 L
.11289 .17161 L
.11389 .16878 L
.11489 .16629 L
.11588 .16418 L
.11688 .16246 L
.11788 .1612 L
.11888 .16043 L
.11988 .1602 L
.12088 .16057 L
.12188 .1616 L
.12288 .16337 L
.12388 .16593 L
.12488 .16938 L
.12587 .17377 L
.12687 .17917 L
.12787 .18564 L
.12887 .19322 L
.12987 .20191 L
.13087 .21171 L
.13187 .22253 L
.13287 .23429 L
.13387 .24681 L
.13487 .2599 L
.13586 .2733 L
.13686 .28674 L
.13786 .29996 L
.13886 .31268 L
.13986 .3247 L
.14086 .33584 L
.14186 .34598 L
.14286 .35505 L
.14386 .363 L
.14486 .36977 L
.14585 .37527 L
.14685 .37941 L
.14785 .38205 L
.14885 .38306 L
Mistroke
.14985 .40311 L
.15085 .39851 L
.15185 .39075 L
.15285 .38065 L
.15385 .369 L
.15485 .35648 L
.15584 .34366 L
.15684 .33094 L
.15784 .31858 L
.15884 .30676 L
.15984 .29555 L
.16084 .28497 L
.16184 .27499 L
.16284 .2656 L
.16384 .25673 L
.16484 .24835 L
.16583 .24041 L
.16683 .23288 L
.16783 .22572 L
.16883 .21891 L
.16983 .21242 L
.17083 .20624 L
.17183 .20036 L
.17283 .19476 L
.17383 .18945 L
.17483 .18441 L
.17582 .17966 L
.17682 .1752 L
.17782 .17102 L
.17882 .16715 L
.17982 .16358 L
.18082 .16035 L
.18182 .15745 L
.18282 .15493 L
.18382 .15279 L
.18482 .15106 L
.18581 .14979 L
.18681 .14899 L
.18781 .14872 L
.18881 .149 L
.18981 .14988 L
.19081 .15139 L
.19181 .15356 L
.19281 .15643 L
.19381 .16001 L
.19481 .16429 L
.1958 .16927 L
.1968 .17488 L
.1978 .18105 L
.1988 .18767 L
Mistroke
.1998 .17335 L
.2008 .17823 L
.2018 .18464 L
.2028 .19264 L
.2038 .2023 L
.2048 .21367 L
.20579 .22674 L
.20679 .24148 L
.20779 .25777 L
.20879 .2754 L
.20979 .29405 L
.21079 .31329 L
.21179 .33256 L
.21279 .35121 L
.21379 .36855 L
.21479 .38385 L
.21578 .39646 L
.21678 .40587 L
.21778 .41176 L
.21878 .41403 L
.21978 .41283 L
.22078 .40852 L
.22178 .40159 L
.22278 .39262 L
.22378 .38219 L
.22478 .37084 L
.22577 .35905 L
.22677 .34716 L
.22777 .33545 L
.22877 .32409 L
.22977 .31319 L
.23077 .3028 L
.23177 .29293 L
.23277 .28358 L
.23377 .27472 L
.23477 .26632 L
.23576 .25835 L
.23676 .25079 L
.23776 .24359 L
.23876 .23675 L
.23976 .23023 L
.24076 .22403 L
.24176 .21813 L
.24276 .21253 L
.24376 .20722 L
.24476 .2022 L
.24575 .19747 L
.24675 .19303 L
.24775 .1889 L
.24875 .18508 L
Mistroke
.24975 .23599 L
.25075 .2352 L
.25175 .23479 L
.25275 .23479 L
.25375 .23521 L
.25475 .23608 L
.25574 .23742 L
.25674 .23924 L
.25774 .24155 L
.25874 .24437 L
.25974 .24771 L
.26074 .25154 L
.26174 .25587 L
.26274 .26066 L
.26374 .26588 L
.26474 .27148 L
.26573 .2774 L
.26673 .28356 L
.26773 .28986 L
.26873 .2962 L
.26973 .30246 L
.27073 .30853 L
.27173 .31427 L
.27273 .31956 L
.27373 .32429 L
.27473 .32837 L
.27572 .33171 L
.27672 .33425 L
.27772 .33596 L
.27872 .33683 L
.27972 .33686 L
.28072 .3361 L
.28172 .33459 L
.28272 .33239 L
.28372 .32957 L
.28472 .32622 L
.28571 .3224 L
.28671 .3182 L
.28771 .31369 L
.28871 .30893 L
.28971 .30399 L
.29071 .29892 L
.29171 .29376 L
.29271 .28858 L
.29371 .28338 L
.29471 .27822 L
.2957 .27312 L
.2967 .26809 L
.2977 .26317 L
.2987 .25836 L
Mistroke
.2997 .24366 L
.3007 .23871 L
.3017 .23396 L
.3027 .22942 L
.3037 .2251 L
.3047 .22103 L
.30569 .21722 L
.30669 .21368 L
.30769 .21043 L
.30869 .20748 L
.30969 .20488 L
.31069 .20262 L
.31169 .20076 L
.31269 .19931 L
.31369 .1983 L
.31469 .19779 L
.31568 .1978 L
.31668 .19837 L
.31768 .19956 L
.31868 .2014 L
.31968 .20394 L
.32068 .20723 L
.32168 .21129 L
.32268 .21617 L
.32368 .22189 L
.32468 .22844 L
.32567 .23583 L
.32667 .244 L
.32767 .25291 L
.32867 .26245 L
.32967 .27252 L
.33067 .28295 L
.33167 .29357 L
.33267 .30417 L
.33367 .31455 L
.33467 .32447 L
.33566 .33373 L
.33666 .34213 L
.33766 .34949 L
.33866 .35566 L
.33966 .36053 L
.34066 .36404 L
.34166 .36613 L
.34266 .36681 L
.34366 .36611 L
.34466 .3641 L
.34565 .36088 L
.34665 .35658 L
.34765 .35134 L
.34865 .34533 L
Mistroke
.34965 .3674 L
.35065 .36596 L
.35165 .36311 L
.35265 .35904 L
.35365 .35394 L
.35465 .34802 L
.35564 .34146 L
.35664 .33445 L
.35764 .32715 L
.35864 .31967 L
.35964 .31212 L
.36064 .30458 L
.36164 .29711 L
.36264 .28976 L
.36364 .28255 L
.36464 .27551 L
.36563 .26864 L
.36663 .26196 L
.36763 .25546 L
.36863 .24916 L
.36963 .24305 L
.37063 .23714 L
.37163 .23141 L
.37263 .22589 L
.37363 .22056 L
.37463 .21542 L
.37562 .21049 L
.37662 .20577 L
.37762 .20125 L
.37862 .19696 L
.37962 .19289 L
.38062 .18905 L
.38162 .18546 L
.38262 .18212 L
.38362 .17906 L
.38462 .17629 L
.38561 .17384 L
.38661 .17171 L
.38761 .16994 L
.38861 .16856 L
.38961 .1676 L
.39061 .16708 L
.39161 .16704 L
.39261 .16752 L
.39361 .16854 L
.39461 .17014 L
.3956 .17234 L
.3966 .17516 L
.3976 .1786 L
.3986 .18266 L
Mistroke
.3996 .11961 L
.4006 .11845 L
.4016 .11762 L
.4026 .11715 L
.4036 .1171 L
.4046 .11754 L
.40559 .11854 L
.40659 .12019 L
.40759 .12259 L
.40859 .12586 L
.40959 .13012 L
.41059 .13551 L
.41159 .1422 L
.41259 .15034 L
.41359 .1601 L
.41459 .17164 L
.41558 .18508 L
.41658 .20054 L
.41758 .21804 L
.41858 .23753 L
.41958 .25884 L
.42058 .28167 L
.42158 .30553 L
.42258 .32979 L
.42358 .35367 L
.42458 .37629 L
.42557 .39674 L
.42657 .41417 L
.42757 .42791 L
.42857 .43748 L
.42957 .44272 L
.43057 .44373 L
.43157 .44089 L
.43257 .43476 L
.43357 .42602 L
.43457 .41542 L
.43556 .40365 L
.43656 .39134 L
.43756 .37901 L
.43856 .36703 L
.43956 .35566 L
.44056 .34506 L
.44156 .33528 L
.44256 .32634 L
.44356 .31818 L
.44456 .31075 L
.44555 .30398 L
.44655 .29778 L
.44755 .29209 L
.44855 .28684 L
Mistroke
.44955 .30875 L
.45055 .30314 L
.45155 .29794 L
.45255 .2931 L
.45355 .28857 L
.45455 .28431 L
.45554 .28031 L
.45654 .27653 L
.45754 .27297 L
.45854 .26961 L
.45954 .26646 L
.46054 .2635 L
.46154 .26074 L
.46254 .25817 L
.46354 .25582 L
.46454 .25367 L
.46553 .25173 L
.46653 .25002 L
.46753 .24854 L
.46853 .24729 L
.46953 .24629 L
.47053 .24554 L
.47153 .24505 L
.47253 .24484 L
.47353 .2449 L
.47453 .24524 L
.47552 .24587 L
.47652 .24679 L
.47752 .248 L
.47852 .2495 L
.47952 .25128 L
.48052 .25333 L
.48152 .25566 L
.48252 .25823 L
.48352 .26103 L
.48452 .26404 L
.48551 .26723 L
.48651 .27057 L
.48751 .27402 L
.48851 .27755 L
.48951 .28112 L
.49051 .28468 L
.49151 .28819 L
.49251 .29162 L
.49351 .2949 L
.49451 .29802 L
.4955 .30092 L
.4965 .30356 L
.4975 .30592 L
.4985 .30796 L
Mistroke
.4995 .38815 L
.5005 .38959 L
.5015 .38855 L
.5025 .38531 L
.5035 .38023 L
.5045 .37366 L
.50549 .366 L
.50649 .35758 L
.50749 .3487 L
.50849 .33961 L
.50949 .33048 L
.51049 .32146 L
.51149 .31263 L
.51249 .30406 L
.51349 .29577 L
.51449 .28777 L
.51548 .28006 L
.51648 .27264 L
.51748 .2655 L
.51848 .25861 L
.51948 .25197 L
.52048 .24556 L
.52148 .23937 L
.52248 .23339 L
.52348 .22761 L
.52448 .22203 L
.52547 .21665 L
.52647 .21144 L
.52747 .20643 L
.52847 .20159 L
.52947 .19694 L
.53047 .19247 L
.53147 .1882 L
.53247 .18411 L
.53347 .18023 L
.53447 .17655 L
.53546 .17308 L
.53646 .16985 L
.53746 .16685 L
.53846 .16411 L
.53946 .16166 L
.54046 .1595 L
.54146 .15767 L
.54246 .15621 L
.54346 .15514 L
.54446 .15452 L
.54545 .15438 L
.54645 .1548 L
.54745 .15582 L
.54845 .15752 L
Mistroke
.54945 .1318 L
.55045 .13127 L
.55145 .13135 L
.55245 .13212 L
.55345 .13365 L
.55445 .13603 L
.55544 .13938 L
.55644 .14382 L
.55744 .14948 L
.55844 .15651 L
.55944 .16506 L
.56044 .17528 L
.56144 .18731 L
.56244 .20126 L
.56344 .21718 L
.56444 .23507 L
.56543 .25483 L
.56643 .27622 L
.56743 .29887 L
.56843 .32225 L
.56943 .34567 L
.57043 .36832 L
.57143 .38929 L
.57243 .40771 L
.57343 .42276 L
.57443 .43387 L
.57542 .44067 L
.57642 .44314 L
.57742 .44153 L
.57842 .43635 L
.57942 .42826 L
.58042 .418 L
.58142 .40631 L
.58242 .39386 L
.58342 .38119 L
.58442 .36872 L
.58541 .35674 L
.58641 .34544 L
.58741 .3349 L
.58841 .32514 L
.58941 .31615 L
.59041 .30787 L
.59141 .30024 L
.59241 .2932 L
.59341 .2867 L
.59441 .28066 L
.5954 .27504 L
.5964 .26981 L
.5974 .26491 L
.5984 .26033 L
Mistroke
.5994 .25446 L
.6004 .24965 L
.6014 .24527 L
.6024 .24129 L
.6034 .2377 L
.6044 .23448 L
.60539 .23165 L
.60639 .22919 L
.60739 .22712 L
.60839 .22545 L
.60939 .22418 L
.61039 .22335 L
.61139 .22295 L
.61239 .22303 L
.61339 .22359 L
.61439 .22465 L
.61538 .22625 L
.61638 .22839 L
.61738 .23109 L
.61838 .23436 L
.61938 .23821 L
.62038 .24263 L
.62138 .24761 L
.62238 .25312 L
.62338 .25912 L
.62438 .26556 L
.62537 .27238 L
.62637 .27948 L
.62737 .28676 L
.62837 .29411 L
.62937 .3014 L
.63037 .30852 L
.63137 .31531 L
.63237 .32165 L
.63337 .32742 L
.63437 .3325 L
.63536 .33681 L
.63636 .34028 L
.63736 .34284 L
.63836 .34448 L
.63936 .34519 L
.64036 .34498 L
.64136 .34389 L
.64236 .34198 L
.64336 .33931 L
.64436 .33596 L
.64535 .33201 L
.64635 .32755 L
.64735 .32268 L
.64835 .31747 L
Mistroke
.64935 .23337 L
.65035 .22874 L
.65135 .22432 L
.65235 .22012 L
.65335 .21614 L
.65435 .21241 L
.65534 .20893 L
.65634 .20573 L
.65734 .20281 L
.65834 .2002 L
.65934 .19792 L
.66034 .19599 L
.66134 .19445 L
.66234 .19331 L
.66334 .19263 L
.66434 .19242 L
.66533 .19274 L
.66633 .19363 L
.66733 .19512 L
.66833 .19726 L
.66933 .2001 L
.67033 .20368 L
.67133 .20803 L
.67233 .21319 L
.67333 .21918 L
.67433 .22601 L
.67532 .23365 L
.67632 .24208 L
.67732 .25123 L
.67832 .26101 L
.67932 .27132 L
.68032 .28198 L
.68132 .29284 L
.68232 .30368 L
.68332 .31431 L
.68432 .32449 L
.68531 .33401 L
.68631 .34268 L
.68731 .35031 L
.68831 .35675 L
.68931 .36189 L
.69031 .36563 L
.69131 .36795 L
.69231 .36882 L
.69331 .36828 L
.69431 .3664 L
.6953 .36327 L
.6963 .35903 L
.6973 .35383 L
.6983 .34784 L
Mistroke
.6993 .33787 L
.7003 .32949 L
.7013 .32112 L
.7023 .31284 L
.7033 .30469 L
.7043 .29672 L
.70529 .28895 L
.70629 .28138 L
.70729 .27403 L
.70829 .26689 L
.70929 .25996 L
.71029 .25323 L
.71129 .24671 L
.71229 .24038 L
.71329 .23424 L
.71429 .22829 L
.71528 .22252 L
.71628 .21693 L
.71728 .21152 L
.71828 .20628 L
.71928 .20121 L
.72028 .19632 L
.72128 .19161 L
.72228 .18707 L
.72328 .18271 L
.72428 .17853 L
.72527 .17454 L
.72627 .17074 L
.72727 .16715 L
.72827 .16377 L
.72927 .16062 L
.73027 .1577 L
.73127 .15505 L
.73227 .15267 L
.73327 .1506 L
.73427 .14885 L
.73526 .14748 L
.73626 .1465 L
.73726 .14597 L
.73826 .14594 L
.73926 .14646 L
.74026 .14758 L
.74126 .14938 L
.74226 .15193 L
.74326 .15529 L
.74426 .15955 L
.74525 .16477 L
.74625 .17101 L
.74725 .17833 L
.74825 .18676 L
Mistroke
.74925 .1428 L
.75025 .15475 L
.75125 .16901 L
.75225 .18578 L
.75325 .20519 L
.75425 .22732 L
.75524 .25209 L
.75624 .27925 L
.75724 .30832 L
.75824 .33854 L
.75924 .36891 L
.76024 .39813 L
.76124 .4248 L
.76224 .44745 L
.76324 .46483 L
.76424 .47604 L
.76523 .48073 L
.76623 .47912 L
.76723 .47199 L
.76823 .46051 L
.76923 .44602 L
.77023 .42985 L
.77123 .41315 L
.77223 .39679 L
.77323 .38137 L
.77423 .36724 L
.77522 .35453 L
.77622 .34327 L
.77722 .33336 L
.77822 .32468 L
.77922 .3171 L
.78022 .31045 L
.78122 .30461 L
.78222 .29946 L
.78322 .29489 L
.78422 .2908 L
.78521 .28714 L
.78621 .28383 L
.78721 .28083 L
.78821 .2781 L
.78921 .27561 L
.79021 .27334 L
.79121 .27126 L
.79221 .26936 L
.79321 .26763 L
.79421 .26607 L
.7952 .26467 L
.7962 .26344 L
.7972 .26236 L
.7982 .26146 L
Mistroke
.7992 .28458 L
.8002 .28599 L
.8012 .28757 L
.8022 .28928 L
.8032 .29109 L
.8042 .29295 L
.80519 .29483 L
.80619 .29669 L
.80719 .29849 L
.80819 .3002 L
.80919 .30178 L
.81019 .30321 L
.81119 .30445 L
.81219 .30547 L
.81319 .30627 L
.81419 .30682 L
.81518 .30711 L
.81618 .30713 L
.81718 .30689 L
.81818 .30638 L
.81918 .30562 L
.82018 .30461 L
.82118 .30337 L
.82218 .30191 L
.82318 .30026 L
.82418 .29844 L
.82517 .29646 L
.82617 .29435 L
.82717 .29214 L
.82817 .28984 L
.82917 .28748 L
.83017 .28507 L
.83117 .28264 L
.83217 .28021 L
.83317 .2778 L
.83417 .27542 L
.83516 .27309 L
.83616 .27082 L
.83716 .26864 L
.83816 .26654 L
.83916 .26455 L
.84016 .26268 L
.84116 .26093 L
.84216 .25933 L
.84316 .25788 L
.84416 .25658 L
.84515 .25545 L
.84615 .2545 L
.84715 .25372 L
.84815 .25314 L
Mistroke
.84915 .3135 L
.85015 .31836 L
.85115 .32273 L
.85215 .32654 L
.85315 .3297 L
.85415 .33217 L
.85514 .3339 L
.85614 .33488 L
.85714 .33511 L
.85814 .3346 L
.85914 .33338 L
.86014 .33152 L
.86114 .32905 L
.86214 .32606 L
.86314 .32261 L
.86414 .31878 L
.86513 .31462 L
.86613 .31021 L
.86713 .3056 L
.86813 .30086 L
.86913 .29602 L
.87013 .29114 L
.87113 .28625 L
.87213 .28139 L
.87313 .27658 L
.87413 .27184 L
.87512 .26721 L
.87612 .26269 L
.87712 .25831 L
.87812 .25407 L
.87912 .25001 L
.88012 .24611 L
.88112 .24241 L
.88212 .23892 L
.88312 .23564 L
.88412 .23259 L
.88511 .22979 L
.88611 .22725 L
.88711 .22498 L
.88811 .22301 L
.88911 .22134 L
.89011 .21999 L
.89111 .21898 L
.89211 .21832 L
.89311 .21804 L
.89411 .21815 L
.8951 .21865 L
.8961 .21957 L
.8971 .22091 L
.8981 .22269 L
Mistroke
.8991 .15713 L
.9001 .16137 L
.9011 .1667 L
.9021 .17323 L
.9031 .1811 L
.9041 .19042 L
.90509 .20127 L
.90609 .21374 L
.90709 .22786 L
.90809 .24359 L
.90909 .26085 L
.91009 .27942 L
.91109 .29899 L
.91209 .31914 L
.91309 .33931 L
.91409 .35885 L
.91508 .37705 L
.91608 .39319 L
.91708 .4066 L
.91808 .41676 L
.91908 .42334 L
.92008 .42622 L
.92108 .42555 L
.92208 .42167 L
.92308 .41509 L
.92408 .40639 L
.92507 .39618 L
.92607 .38502 L
.92707 .37339 L
.92807 .36168 L
.92907 .35017 L
.93007 .33905 L
.93107 .32844 L
.93207 .31838 L
.93307 .3089 L
.93407 .29999 L
.93506 .2916 L
.93606 .2837 L
.93706 .27626 L
.93806 .26924 L
.93906 .2626 L
.94006 .25631 L
.94106 .25035 L
.94206 .2447 L
.94306 .23935 L
.94406 .23428 L
.94505 .22949 L
.94605 .22497 L
.94705 .22072 L
.94805 .21674 L
Mistroke
.94905 .20619 L
.95005 .20206 L
.95105 .19818 L
.95205 .19455 L
.95305 .1912 L
.95405 .18815 L
.95504 .1854 L
.95604 .183 L
.95704 .18097 L
.95804 .17933 L
.95904 .17813 L
.96004 .17741 L
.96104 .17721 L
.96204 .17759 L
.96304 .17859 L
.96404 .18029 L
.96503 .18273 L
.96603 .18599 L
.96703 .19013 L
.96803 .19521 L
.96903 .20129 L
.97003 .20842 L
.97103 .21662 L
.97203 .2259 L
.97303 .23623 L
.97403 .24756 L
.97502 .25977 L
.97602 .27271 L
.97702 .28618 L
.97802 .29992 L
.97902 .31364 L
.98002 .32703 L
.98102 .33973 L
.98202 .35144 L
.98302 .36183 L
.98402 .37066 L
.98501 .37771 L
.98601 .38285 L
.98701 .38601 L
.98801 .38719 L
.98901 .38646 L
.99001 .38394 L
.99101 .37981 L
.99201 .37428 L
.99301 .36761 L
.99401 .36005 L
.995 .35184 L
.996 .34321 L
.997 .33435 L
.998 .32545 L
Mistroke
.999 .28599 L
Mfstroke
0 g
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{724.312, 298.438},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;D0001:R000`400?l00000o`00003ooooooooo
ooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo
003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo003ooooooooo
ooooe_ooool005Sooooo1Ol00003ooooo`;o00001?ooool2o`0001Gooooo0ol00003ooooo`;o0000
1?ooool2o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`0001?ooooo0ol00004ooooo`;o0000
1?ooool2o`00017ooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000iooooo`Go0000
0oooool2o`0000Cooooo0_l0000Dooooo`?o00000oooool2o`0000Cooooo0_l0000Cooooo`?o0000
1?ooool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000@ooooo`?o0000
1?ooool2o`0000Cooooo0_l00004ooooo`;o0000=_ooool5o`0000?ooooo0_l00004ooooo`;o0000
5?ooool3o`0000?ooooo0_l00004ooooo`;o00005?ooool3o`0000Cooooo0_l00004ooooo`;o0000
4oooool3o`0000Cooooo0_l00004ooooo`;o00004Oooool3o`0000Cooooo0_l00004ooooo`;o0000
1?ooool2o`0003Oooooo001Iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000Eooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Aooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0003Wooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
5?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0@ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000fooooo`00F_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004_ooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Aooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0003Oooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`00017ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00004_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000=_ooool005_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool04?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool4o`0000?ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Booooo`?o00000oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
>oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0?ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Aooooo`Co00000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001?ooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000hooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01;ooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_oo
ool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003Kooooo001Hooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00?o0000ooooool0
00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000hooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017o
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000eooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01;ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001;ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000foooo
o`00F?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Dooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool2o`0000Cooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Sooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00004oooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Booooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000oooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000eooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo
0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004oooool00ol0
003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000@ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo0000=_ooool005Wooooo0ol00004ooooo`;o00001?oo
ool2o`0001Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Booooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003[ooooo0ol00004ooooo`;o00001?oo
ool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Oooooo0ol00004ooooo`;o00001?oo
ool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Eooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Booooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Oooooo003oooooooooooooe_ooool0
0?oooooooooooooFooooo`00ooooooooooooomKooooo000oooooojgo0000:?oooon^o`0002Cooooo
[_l00010ooooo`00?oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo0_l0
000Tooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0:[ooooo00?o0000
ooooooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool08_ooool2o`000:[ooooo0_l00010oooo
o`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0:[ooooo00?o0000oooooooo
ool0?_ooool003oooooo00?o0000ooooooooool0Z?ooool2o`0002Sooooo0_l0002Zooooo`;o0000
9?ooool2o`000:[ooooo0_l00010ooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo0:[ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`2Zooooo`03o`000?oooooooooo03kooooo000gooooo`?o00001Oooool00ol0
003oooooooooo`2Yooooo`03o`000?oooooooooo01Sooooo1Ol00002ooooo`?o00001?ooool00ol0
003oooooooooo`2Zooooo`03o`000?oooooooooo02;ooooo0_l0002Zooooo`;o0000@?ooool003Ko
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0:Wooooo00?o0000oooo
ooooool06Oooool01_l0003oooooooooool0003oooooo`0000?ooooo00Go0000oooooooooooooooo
o`00002/ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Z_ooool00ol0003ooooo
ooooo`0nooooo`00=_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
ZOooool00ol0003oooooooooo`0Jooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo00000:cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`2Zoooo
o`03o`000?oooooooooo03kooooo000fooooo`Co00001Oooool2o`000:Wooooo0_l0000Mooooo`03
o`000?oooooooooo00Co00001?ooool2o`0001Sooooo2Ol0nYZ8ooooo`?o00007Oooool3o`0000Co
oooo0_l0002Zooooo`;o0000@?ooool003Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`2Yooooo`03o`000?oooooooooo01Sooooo00Oo0000ooooooooooooooooo`000?oooooo0000
00Oooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
08Sooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
0:[ooooo00?o0000ooooooooool0?_ooool003Oooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`2Yooooo`03o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`000002oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooooooo08Sooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`03oooo
o`?o0000ZOooool2o`00043ooooo000hooooo`;o00001Oooool00ol0003oooooooooo`2Yooooo`03
o`000?oooooooooo01Wooooo0ol00004ooooo`;o00001?ooool00ol0003oooooooooo`0Gooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00
?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
5oooool00ol0nY[oooooooooo`06ooooo`Wo0?ZJPOooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool01_ooool:o`3jVY[ooooo00?o0000ooooooooool0
?_ooool003oooooo00?o0000ooooooooool0Z?ooool2o`0002Sooooo0_l0000Hooooo`03o`3jV_oo
oooooooo00kooooo00?o0?ZJooooooooool0O_ooool2o`0001gooooo0_l00005ooooo`;o00001ooo
ool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo09Oooooo0_l00010ooooo`00?oooool0
0ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool:
o`3jVQ3ooooo00?o0?ZJooooooooool0Ooooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo09Sooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool05oooool00ol0
nY[oooooooooo`1oooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01_ooool00ol0
nY[oooooooooo`06ooooo`03o`3jV_oooooooooo09Sooooo00?o0000ooooooooool0?_ooool003oo
oooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00ko
oooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`1oooooo`03o`000?oooooooooo02;o
oooo0_l00007ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0Uoooool2o`00043o
oooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0Ooooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`2Hooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo0:Sooooo0_l0
000Xooooo`;o00003oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00kooooo4_l0
nYYNooooo`;o00009?ooool2o`0000Oooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`2Gooooo`;o0000@?ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0V
oooooa;o0?ZJ6Oooool:o`3jVPOooooo00?o0?ZJooooooooool03oooool9o`3jVUKooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`06ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yoooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0<Oooool9o`3jVQWooooo00?o0?ZJoooo
ooooool0E?ooool00ol0003oooooooooo`0Rooooo`[o0?ZJ2?ooool00ol0nY[oooooooooo`2Hoooo
o`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`1Cooooo`[o0?ZJCOooool00ol0003oooooooooo`0Jooooo`Go
00000oooool2o`00013ooooo00?o0?ZJooooooooool0Uoooool2o`00043ooooo000oooooo`03o`00
0?oooooooooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`1Looooo`Wo0?ZJ
2?ooool:o`3jVS?ooooo00?o0000ooooooooool06oooool01?l0003oooooooooool00003ooooo`03
o`000?oooooooooo00oooooo00?o0?ZJooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00
?oooool00ol0003oooooooooo`2Xooooo`;o0000:?ooool2o`0006Gooooo2_l0nYX8ooooo`Wo0?ZJ
:_ooool2o`0001kooooo00?o0000ooooooooool00oooool3o`0000oooooo00?o0?ZJooooooooool0
Uoooool2o`00043ooooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`1nooooo`[o0?ZJ6Oooool9o`3jVP03o`000?oooooooooo01gooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo09Sooooo00?o
0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo01Oooooo2Ooo001Wooooo`03o`3jV_oooooooooo00kooooo2_l0nYX8
ooooo`03o`000?oooooooooo01[ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oo
oooooooo00oooooo00?o0?ZJooooooooool0>Oooool:o`3jVUGooooo00?o0000ooooooooool0?_oo
ool003Oooooo0ol00005ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool06?ooool5
o`0000;ooooo0ol00004ooooo`03o`000?oooooooooo01Oooooo00?oo`00ooooooooool01Oooool0
0ooo003oooooooooo`1Uoooooa;o0?ZJ4Oooool00ol0003oooooooooo`0Jooooo`05o`000?oooooo
ooooooooool000000oooool2o`00013ooooo2Ol0nYXZooooo`[o0?ZJ2?ooool00ol0nY[ooooooooo
o`1Booooo`;o0000@?ooool003Kooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oo
oooooooo0:Wooooo00?o0000ooooooooool06Oooool01_l0003oooooooooool0003oooooo`0000?o
oooo00Go0000ooooooooooooooooo`00000Iooooo`03ool00?oooooooooo00Kooooo00?oo`00oooo
ooooool0Qoooool00ol0003oooooooooo`0Kooooo`?o00001?ooool00ol0003oooooooooo`0Goooo
o`03o`3jV_oooooooooo02Sooooo00?o0?ZJooooooooool03oooool9o`3jVTgooooo00?o0000oooo
ooooool0?_ooool003Kooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
0:Wooooo00?o0000ooooooooool06_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000Iooooo`03ool00?oooooooooo00Kooooo2Ooo0021ooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`0?oooooa[o0?ZJ6Ooo
oolTo`3jVR[ooooo00?o0000ooooooooool0?_ooool003Oooooo0ol00005ooooo`;o0000ZOooool2
o`0001gooooo00Co0000oooooooooooooooo0ol00004oooooa[o003o00?oo`00o`00ool00?l03_l0
0?l00ooo003o003oo`00o`1oo`00o`03o`000?oooooooooo02;ooooo0_l0000Hooooo`03o`3jV_oo
oooooooo00oooooo00?o0?ZJooooooooool07oooool:ool002[ooooo6_l0nYX@ooooo`;o0000@?oo
ool003Kooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0:Wooooo00?o
0000ooooooooool06?ooool01ol0003ooooooooooooooooo0000ooooool000000oooool01Ol0003o
oooooooooooooooo000001Wooooo00?oo`00ooooooooool03_ooool00ooo003oooooooooo`0Goooo
o`Woo`00Goooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01Oooooo00?o0?ZJoooo
ooooool01_ooool9o`3jVR;ooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`12oooo
oa;o0?ZJ@?ooool003Kooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
0:Wooooo00?o0000ooooooooool06?ooool01ol0003ooooooooooooooooo0000ooooool000000ooo
ool01Ol0003ooooooooooooooooo000001Wooooo00?oo`00ooooooooool03_ooool00ooo003ooooo
ooooo`0>ooooo`[oo`002?ooool9ool005Kooooo00?o0000ooooooooool08_ooool2o`0001Sooooo
2_l0nYXQooooo`[oo`002?ooool9ool004cooooo0_l00010ooooo`00=oooool3o`0000Gooooo00?o
0000ooooooooool0ZOooool00ol0003oooooooooo`0Iooooo`?o00000oooool3o`0000Cooooo00?o
0000ooooooooool05oooool00ooo003oooooooooo`0>ooooo`03ool00?oooooooooo00kooooo00?o
o`00ooooooooool05oooool:ool0013ooooo2_oo000booooo`03ool00?l0003ooooo02?oooooAOl0
0?l00ooo003o003oo`00o`0Go`00ocGoo`006_l00?m0ooooo`00?oooool00ol0003oooooooooo`2Y
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool:ool0013ooooo00?oo`00
ooooooooool03_ooool00ooo003oooooooooo`0Poooooa;oo`002?ooool9ool002;ooooo2Ooo0000
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02Wooooo6_oo001=oooooa_oo`00@?ooool0
03oooooo00?o0000ooooooooool0Z?ooool2o`0002Sooooo0_l0000?ooooo`03ool00?oooooooooo
01Oooooo4_oo0014ooooo`[oo`004?ooool:ool000Oooooo0_l0000Mooooo`?o00001?ooool2o`00
013ooooo2Ooo000Aooooo`03ool00?oooooooooo01oooooo2_l0nYYDooooo`;o0000@?ooool003oo
oooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00ko
oooo00?oo`00ooooooooool0M_oooolBool0017ooooo00?o0000ooooooooool06_ooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool03oooool00ooo003oooooooooo`05oooo
o`03ool00?oooooooooo00oooooo00?oo`00ooooooooool05_ooool:o`3jVPSooooo2Ol0nYX8oooo
oa_o0?ZJ1oooool:o`3jVQWooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000oooooooo
ool0ZOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00kooooo00?oo`00oooooooo
ool0VOooool00ol0003oooooooooo`0Nooooo`05o`000?ooooooooooooooool000004Oooool00ooo
003oooooooooo`05ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool05oooool00ol0
nY[oooooooooo`0Gooooo`[o0?ZJ6Oooool9o`3jVPSooooo6ol0nYY0ooooo`00?oooool00ol0003o
ooooooooo`1Tooooo`Wo0?ZJ??ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00ko
oooo00?oo`00ooooooooool0VOooool00ol0003oooooooooo`0Looooo`;o00001?ooool3o`0000Ko
oooo2_oo0007ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool05oooool00ol0nY[o
ooooooooo`1Tooooo`;o0000@?ooool003oooooo00?o0000ooooooooool0I?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo03[ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0>ooooo`03ool00?oooooooooo09Wooooo00?o0000ooooooooool07_ooool01Ol0003ooooo
oooooooooooo000000Sooooo00?oo`00ooooooooool03_ooool00ooo003oooooooooo`06ooooo`Wo
o`004Oooool9o`3jVVOooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0
I?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01Kooooo4ol0nYX?ooooo`;o0000
:?ooool9ool000Sooooo00?oo`00ooooooooool0V?ooool2o`0001cooooo00Go0000oooooooooooo
ooooo`000003ooooo`;o00001oooool00ooo003oooooooooo`0>ooooo`[oo`002?oooolBo`3jVVko
oooo0_l00010ooooo`00?oooool9o`3jVScooooo6_l0nYX8ooooo`03o`3jV_oooooooooo00Kooooo
2Ol0nYX@ooooo`03o`3jV_oooooooooo00oooooo2Ol0nYX8ooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool01_ooool9ool009_ooooo00?o0000ooooooooool06oooool3o`0000Cooooo
00?o0000ooooooooool01_ooool00ooo003oooooooooo`0Pooooo`03o`3jV_oooooooooo07kooooo
00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool01Oooool00ol0nY[ooooooooo
o`0Gooooo`Wo0?ZJ6_ooool00ol0nY[oooooooooo`0Fooooo`[o0?ZJ4?oooolBo`3jVQWooooo2_l0
nYXXooooo`03o`000?oooooooooo0:Wooooo00?o0?ZJo`000?ooool08oooool00ol0003ooooooooo
o`06ooooo`03ool00?oooooooooo023ooooo00?o0?ZJooooooooool0O_ooool00ol0003ooooooooo
o`0nooooo`00?oooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJ
ooooooooool01_ooool9o`3jVQ3ooooo00?o0?ZJooooooooool0IOooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo01Oooooo2Ol0nYXRooooo`Wo0?ZJ8_ooool:o`3jVR7ooooo4_l0nYX0
0ol0003oooooooooo`0Rooooo`;o00001oooool00ooo003oooooooooo`0Pooooo`03o`3jV_oooooo
oooo07gooooo0_l00010ooooo`00?oooool00ol0003oooooooooo`05ooooo`[o0?ZJ4?ooool00ol0
nY[oooooooooo`0>oooooa;o0?ZJIoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
01Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo
00Kooooo4_l0nYX@ooooo`03o`3jV_oooooooooo00Kooooo4_l0nYX@ooooo`03o`3jV_oooooooooo
00oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`06ooooo`03ool00?oooooooooo
00Kooooo2Ol0nYX@ooooo`03o`3jV_oooooooooo07oooooo00?o0000ooooooooool0?_ooool003oo
oooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`05ooooo`[o0?ZJROooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01_ooool9o`3jVQWo
oooo00?o0?ZJooooooooool05ooooolBo`3jVQWooooo00?o0?ZJooooooooool03_ooool00ol0nY[o
ooooooooo`0?ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01_ooool00ooo003o
ooooooooo`06ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool03_ooool00ol0nY[o
ooooooooo`1oooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00kooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`2?ooooo`;o0000:?ooool2o`0001Sooooo
00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0>ooooo`[o0?ZJA?oooolBo`3jVQ3ooooo
0_l0000Tooooo`;o00001oooool00ooo003oooooooooo`06ooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooooooool01_ooool9o`3jVX3ooooo0_l00010ooooo`00?oooool00ol0003ooooooooo
o`0>ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0T?ooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool03_ooool00ol0nY[ooooooooo
o`0>ooooo`03o`3jV_oooooooooo06kooooo00?o0000ooooooooool08_ooool:ool000Sooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo08Oooooo00?o
0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool03_ooool9o`3jVY;ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJ
ooooooooool03_ooool00ol0nY[oooooooooo`1^ooooo`03o`000?oooooooooo02;ooooo0_l0000@
ooooo`03o`3jV_oooooooooo00Gooooo2_l0nYZ8ooooo`;o0000@?ooool0037ooooo0ol00004oooo
o`;o00001Oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo01Wooooo0ol00004oooo
o`;o00001?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJoooo
ooooool03_ooool00ol0nY[oooooooooo`1^ooooo`03o`000?oooooooooo01cooooo0ol00003oooo
o`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0V?ooool00ol0003oooooooooo`0noooo
o`00<_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooo
ooooool0ZOooool00ol0003oooooooooo`0Hooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool03_oo
oolBo`3jVW3ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00oooooo00?o0?ZJooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00<_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo[Ol00?lNooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooooooo0_l0000Hooooo`03o`3jV_oooooooooo08ko
oooo0ol0000Looooo`Go00000oooool3o`0000oooooo00?o0?ZJooooooooool0Uoooool2o`00043o
oooo000booooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003o
ooooooooo`2Yooooo`03o`000?oooooooooo01[ooooo0_l00003ooooo`04o`000?ooooooooooo`00
00?ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`2@ooooo`03o`000?oooooooooo
01[ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooo
oooo09Sooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo06Cooooo2Ooo000looooo`03o`000?oooooo
oooo01cooooo00Co0000oooooooooooo00000_ooool01Ol0003ooooooooooooooooo000001Wooooo
00?o0?ZJooooooooool0T?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo000000Cooooo
00?o0000ooooooooool03oooool00ol0nY[oooooooooo`2Hooooo`03o`000?oooooooooo03kooooo
000aooooo`;o00001?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo06Cooooo
00?oo`00ooooooooool01Oooool00ooo003oooooooooo`0Goooooa?oo`004?ooool00ol0003ooooo
ooooo`0Hooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00003oooo
o`03o`000?oooooooooo00kooooo2_l0nYZBooooo`03o`000?oooooooooo01cooooo0_l00004oooo
o`;o00004?ooool00ol0nY[oooooooooo`2Gooooo`;o0000@?ooool003;ooooo00?o0000oooooooo
ool00oooool2o`0000Gooooo00?o0000ooooooooool0I?ooool00ooo003oooooooooo`06ooooo`Wo
o`004?ooool00ooo003oooooooooo`0?ooooo`Woo`002?ooool00ooo003oooooooooo`0Iooooo`?o
00001?ooool2o`0000Cooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Iooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03
o`3jV_oooooooooo09Sooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0
B_ooool:ool0013ooooo00?oo`00ooooooooool03_oooolBool001Wooooo2_oo000Xooooo`;o0000
3oooool00ol0nY[oooooooooo`2Hooooo`;o00009?ooool2o`00013ooooo00?o0?ZJooooooooool0
Uoooool2o`00043ooooo000oooooo`03o`000?oooooooooo04[ooooo00?oo`00ooooooooool01_oo
oolBool004Cooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oo
oooooooo09Wooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oo
oooooooo09Sooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0B_ooool0
0ooo003oooooooooo`1Looooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool0
0ol0nY[oooooooooo`2Iooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03oooool0
0ol0nY[oooooooooo`2Hooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo
04;ooooo2Ooo001Nooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool00ol0
nY[oooooooooo`2Iooooo`03o`000?oooooooooo02;ooooo0_l0000@ooooo`03o`3jV_oooooooooo
09Oooooo0_l00010ooooo`00?oooool00ol0003oooooooooo`12ooooo`03ool00?oooooooooo06Co
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo09Wo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo09So
oooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool07oooool9ool0017ooooo
2Ooo001Wooooo`03o`000?oooooooooo02Kooooo2Ol0nYX8ooooo`03o`3jV_oooooooooo09Wooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo09Sooooo
00?o0000ooooooooool0?_ooool003oooooo2Ooo000Iooooo`03ool00?oooooooooo00Kooooo2Ooo
0008ooooo`03ool00?oooooooooo06cooooo0_l0000Xooooo`;o00001oooool9o`3jVY[ooooo0_l0
000Mooooo`?o00001?ooool2o`00013ooooo00?o0?ZJooooooooool0Uoooool2o`00043ooooo000o
ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool05oooool00ooo003oooooooooo`0>
ooooo`[oo`00Koooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:[ooooo00?o0000
ooooooooool06_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool01_oo
ool:o`3jVY[ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool01Oooool0
0ooo003oooooooooo`0>ooooo`[oo`00ROooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo0:[ooooo00?o0000ooooooooool07_ooool01?l0003oooooooooooooool3o`0000Kooooo00?o
0?ZJooooooooool0X?ooool2o`00043ooooo000oooooo`03o`000?oooooooooo00Gooooo2_oo0007
ooooo`03ool00?oooooooooo093ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Z
ooooo`03o`000?oooooooooo01kooooo00Go0000ooooooooooooooooo`000008ooooo`03o`3jV_oo
oooooooo0:7ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool03_ooool0
0ooo003oooooooooo`05ooooo`03ool00?oooooooooo093ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`2Zooooo`03o`000?oooooooooo01[ooooo1?l00004ooooo`03o`000?oooooo
oooo00Kooooo00?o0?ZJooooooooool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0
003oooooooooo`0>ooooo`Woo`00Koooool:o`3jVQSooooo0_l0000Xooooo`;o0000Z_ooool2o`00
01cooooo00?o0000ooooooooool01Oooool2o`0000Oooooo00?o0?ZJooooooooool0X?ooool2o`00
043ooooo000oooooo`03o`000?oooooooooo06Cooooo2Ol0nYXIooooo`03o`3jV_oooooooooo00Ko
oooo2_l0nYX@ooooo`03o`3jV_oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003o
ooooooooo`0Jooooo`Go00000oooool00ol0003oooooooooo`06ooooo`03o`3jV_oooooooooo0:7o
oooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0I?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool03ooooolBo`3jVRSooooo
00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Kooooo
00?o0?ZJooooooooool0XOooool00ol0003oooooooooo`0nooooo`00<Oooool3o`0000;ooooo1Ol0
0004ooooo`03o`000?oooooooooo06Cooooo00?o0?ZJooooooooool01_oooolJo`3jVR;ooooo00?o
0000ooooooooool06Oooool3o`0000;ooooo1Ol00003ooooo`03o`000?oooooooooo0:[ooooo00?o
0000ooooooooool08_ooool2o`0000Oooooo00?o0?ZJooooooooool0X?ooool2o`00043ooooo000b
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`1Tooooo`03o`3jV_oooooooooo04;ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`2Zooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`2Qooooo`03
o`000?oooooooooo03kooooo000booooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1?ooool2o`0004_ooooo4_l0nYX8ooooo`03o`3jV_oooooooooo047ooooo0_l0000Nooooo`05o`00
0?ooooooooooooooool000001Oooool2o`000:Wooooo0ol0000Tooooo`;o00001oooool00ol0nY[o
ooooooooo`2Pooooo`;o0000@?ooool003;ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo04[ooooo00?o0?ZJooooooooool03_ooool:o`3jVTCooooo
00?o0000ooooooooool06_ooool2o`0000Gooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`2Zooooo`03o`000?oooooooooo02;ooooo2_l0nYZSooooo`03o`000?oooooooooo03kooooo
000booooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo04[ooooo00?o0?ZJooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooo000000?ooooo00Go0000ooooooooooooooooo`00002/ooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00<Oooool2o`0000?ooooo
00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo04[ooooo00?o0?ZJoooooooo
ool0G?ooool00ol0003oooooooooo`0Hooooo`07o`000?ooooooooooooooool0003oooooo`000003
ooooo`05o`000?ooooooooooooooool00000[?ooool00ol0003oooooooooo`0Kooooo`?o00001?oo
ool2o`000:[ooooo0_l00010ooooo`00<_ooool00ol0003oooooooooo`02ooooo`?o00001Oooool0
0ol0003oooooooooo`12ooooo`Wo0?ZJG_ooool00ol0003oooooooooo`0Iooooo`?o00000oooool3
o`0000Cooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Jooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo03kooooo000o
ooooo`03o`000?oooooooooo04;ooooo00?o0?ZJooooooooool0I?ooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool06_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00?oooool0
0ol0003oooooooooo`11ooooo`03o`3jV_oooooooooo06Cooooo0_l0000Xooooo`;o0000Z_ooool2
o`0001cooooo1?l00004ooooo`?o0000ZOooool2o`00043ooooo000oooooo`03o`000?oooooooooo
03Wooooo2Ol0nYYWooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Z_ooool00ol0
003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`0Ooooooa;o0?ZJ2?ooool00ol0nY[o
ooooooooo`1]ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo0_l0002Zooooo`;o0000@?ooool003oooooo
00?o0000ooooooooool07oooool00ol0nY[oooooooooo`0>ooooo`[o0?ZJKoooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool07?ooool2o`0000Cooooo
00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003ooooooooo
o`0Oooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Z_ooool00ol0003ooooooooo
o`0nooooo`00?oooool9o`3jVQ3ooooo2_l0nYZ8ooooo`;o0000:?ooool2o`000:[ooooo0_l0000T
ooooo`;o0000Z_ooool2o`00043ooooo000oooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooo
ooooool03_ooool00ol0nY[oooooooooo`2@ooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0:[ooooo00?o0000oooo
ooooool0?_ooool003oooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`0>ooooo`03
o`3jV_oooooooooo093ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Zooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00
?oooool00ol0003oooooooooo`05oooooa;o0?ZJT_ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo0:[ooooo00?o0000ooooooooool08_ooool2o`000:[ooooo0_l00010ooooo`00?ooo
ool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool0?_oo
ool003oooooo00?o0000ooooooooool0Z?ooool2o`0002Sooooo0_l0002Zooooo`;o00009?ooool2
o`000:[ooooo0_l00010ooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003o
ooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Z_ooool00ol0003o
ooooooooo`0nooooo`00<Oooool3o`0000Cooooo0ol00004ooooo`03o`000?oooooooooo0:Wooooo
00?o0000ooooooooool06Oooool3o`0000Cooooo0ol00003ooooo`03o`000?oooooooooo0:[ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`02ooooo`?o0000ZOooool2o`00043ooooo
000booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`2Yooooo`03o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0nooooo`00<_oo
ool01?l0003oooooooooooooool5o`0000Cooooo00?o0000ooooooooool0ZOooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooo000000Co00000oooool00ol0003oooooooooo`2Zooooo`03o`00
0?oooooooooo01kooooo00Go0000ooooooooooooooooo`00002/ooooo`03o`000?oooooooooo03ko
oooo000booooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`03ooooo`;o
0000ZOooool2o`0001cooooo0_l00002ooooo`04o`000?ooooooooooo`0000Cooooo0_l0002Yoooo
o`?o00007?ooool01Ol0003ooooooooooooooooo000000?ooooo0_l0002Zooooo`;o0000@?ooool0
03;ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo
0:Wooooo00?o0000ooooooooool07?ooool01_l0003oooooooooool0003oooooo`0000Cooooo00?o
0000ooooooooool0Z_ooool00ol0003oooooooooo`0Jooooo`Go00000oooool00ol0003ooooooooo
o`2Zooooo`03o`000?oooooooooo03kooooo000aooooo`;o00001Oooool2o`0000Gooooo00?o0000
ooooooooool0ZOooool00ol0003oooooooooo`0Hooooo`05o`000?ooooooooooooooool000000ooo
ool2o`0000Cooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Rooooo`;o0000Z_oo
ool2o`00043ooooo000booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`2Yooooo`03o`000?oooooooooo01Wooooo0ol00005ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo0:[ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`2Zooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo0:So
oooo0_l0000Xooooo`;o0000Z_ooool2o`0002Cooooo0_l0002Zooooo`;o0000@?ooool003oooooo
00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:[ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo03kooooo
000oooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Z_ooool00ol0003ooooooooo
o`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool0Z_ooool00ol0003oooooooooo`0Kooooo`?o00001?ooool2o`000:[ooooo0_l00010
ooooo`00?oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo00?o0000oooo
ooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo0_l0000Loooo
o`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0?_ooool003oooooo[Ol0000Xooooojko00007?ooool01Ol0
003ooooooooooooooooo000000?ooooo[_l00010ooooo`00oooooooPooooo`?o0000l_ooool00?oo
oooogoooool01Ol0003ooooooooooooooooo00000?7ooooo003oooooomoooooo00Go0000oooooooo
ooooooooo`00003aooooo`00oooooooPooooo`?o0000l_ooool009?ooooo0ol0003ooooooooooooo
@?ooool009Kooooo00?o0000ooooooooool0ooooooooooooocgooooo0026ooooo`Co00000_ooool5
o`0000;ooooo1?l000001_oooooo0000ooooool0003oooooo`0000;ooooo1?l00034ooooo`?o0000
d?ooool4o`0009Kooooo002:ooooo`05o`000?ooooooooooooooool000000oooool03Ol0003ooooo
oooooooooooo0000ooooool0003oooooo`000?oooooo0000ooooool000000_ooool00ol0003ooooo
ooooo`34ooooo`03o`000?oooooooooo0=3ooooo00Co0000oooooooooooo0000UOooool008Oooooo
0ol00004ooooo`05o`000?ooooooooooooooool000000oooool01ol0003oooooo`000?oooooo0000
ooooool000000_ooool3o`000<Kooooo00?o0000ooooooooool0d?ooool01?l0003oooooooooool0
002Eooooo`00Q_ooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool000000ooo
ool02Ol0003oooooo`000?oooooo0000ooooool0003oooooo`000002ooooo`03o`000?oooooooooo
0<Cooooo0_l0003Aooooo`04o`000?ooooooooooo`0009Gooooo0027ooooo`Co000000Coooooo`00
0?l0003o00001?ooool7o`000003ooooool0003ooooo00;ooooo0_l00036ooooo`;o000000?ooooo
o`000?l00000coooool3o`0009Kooooo003ooooooooooooo?Oooool00ol0003oooooooooo`2Foooo
o`00S_ooool00ol0003oooooooooo`3ooooooj[ooooo0_l0002Hooooo`00ooooooooooooomKooooo
003oooooooooooooe_ooool005_ooooo1Ol00003ooooo`;o00001?ooool2o`0001Gooooo0ol00003
ooooo`;o00001?ooool2o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`0001?ooooo0ol00004
ooooo`;o00001?ooool2o`00017ooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000i
ooooo`Go00000oooool2o`0000Cooooo0_l0000Dooooo`?o00000oooool2o`0000Cooooo0_l0000C
ooooo`?o00001?ooool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000@
ooooo`?o00001?ooool2o`0000Cooooo0_l00004ooooo`;o0000=_ooool5o`0000?ooooo0_l00004
ooooo`;o00005?ooool3o`0000?ooooo0_l00004ooooo`;o00005?ooool3o`0000Cooooo0_l00004
ooooo`;o00004oooool3o`0000Cooooo0_l00004ooooo`;o00004Oooool3o`0000Cooooo0_l00004
ooooo`;o00001?ooool2o`0003Cooooo001Looooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Eooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
4Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Aooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Wooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool03oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
=_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00005?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0@ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000cooooo`00GOooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00004_ooool5o`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Aooooo`Go00000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003Oooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`00017ooooo1Ol00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00004_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo0000<oooool005kooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool04?ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool4o`0000?o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Booooo`?o00000oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo0000>oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0?ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Aooooo`Co00000oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001?ooooo0ol00003ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000hooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00oooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001;ooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00004_ooool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Aooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0003?ooooo001Kooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017o
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000hooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01;ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`00017ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000eoooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001;ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001;ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000cooooo`00Foooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000Dooooo`;o00000oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool2o`0000Cooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
03Sooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00004oooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000Booooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000oooooo0_l00004ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000eooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001?ooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
4oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00004Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000@ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000<oooool005cooooo0ol00004oooo
o`;o00001?ooool2o`0001Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Doooo
o`;o00001?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Boooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003[ooooo0ol00004oooo
o`;o00001?ooool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Doooo
o`;o00001?ooool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000Aoooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Oooooo0ol00004oooo
o`;o00001?ooool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Eoooo
o`;o00001?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Boooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Cooooo003ooooooooo
ooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo0012ooooo`Go000000?o0?ZJ
o`000?l0nYX0YOl0000Xooooo`Co000000?o0?ZJo`000?l000000ol0nYYgo`000003o`3jV_l0003o
000002[o00009Oooool01_l0003oo`00ool00?l00?oo0000o`00o`;o000000?o0?ZJo`000?l00000
5_l00002o`3jVX[o0000?Oooool004;ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooo`3j
VP0Jooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooo
oooooooo0?ZJ00;ooooo0ol0nYXIooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Kooooo00?o0000ooooooooool0
7oooool2o`0002Gooooo00Ko0000oooooooo003oo`00ooooool00?l2ooooo`03o`3jV_oooooooooo
01Kooooo0_l0nYXQooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oooooooooo00;o
oooo00?o0?ZJooooool0nYX0Y?ooool00ol0003oooooooooo`0Vooooo`05o`000?oooooooooooooo
ool0nYX00_ooool3o`3jVWOooooo00?o0?ZJooooooooool0:Oooool00ol0003oooooooooo`0Soooo
o`05o`3jV_ooooooooooool00?ooool00_l00?l00ooooooo0?ZJooooo`0Gooooo`;o0?ZJROooool0
0ol0003oooooooooo`0kooooo`00@_ooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ
0:Cooooo00?o0000ooooooooool09_ooool2o`0000;ooooo00?o0?ZJooooooooool00ol0nYYgoooo
o`03o`3jV_oooooooooo02Sooooo0_l0000Uooooo`;o0?ZJ00Ooooooool00?ooooooooooo`00oooo
oooo0?ZJ01Sooooo0_l0nYZ8ooooo`;o0000?Oooool004;ooooo00?o0000ooooooooool00_ooool0
0ol0nY[oooooo`3jVP2Sooooo`;o0000:?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00Co
0?ZJo`000?l0003o0000M_ooool00ol0nY[oooooooooo`0Yooooo`03o`000?oooooooooo02?ooooo
00Co0000o`3jV_l0nY[oo`000_ooool00ol00?ooooooo`3jVP0Hooooo`;o0?ZJG_ooool00ol0nY[o
ooooooooo`0Xooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oooooooooo00;ooooo
00?o0?ZJooooool0nYX0Y?ooool00ol0003oooooooooo`0Vooooo`05o`000?ooooooooooooooool0
nYX00_ooool01?l0nY[o0000o`000?l0000Gooooo`03o`3jV_oooooooooo05_ooooo0_l0nYX[oooo
o`03o`000?oooooooooo02?ooooo00Wo0000ooooool0nY[oooooool00?oooooo003oooooool0nYX0
6?ooool2o`3jVUgooooo0_l0nYXZooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oo
oooooooo00;ooooo00?o0?ZJooooool0nYX0Y?ooool00ol0003oooooooooo`0Vooooo`05o`000?oo
ooooooooooooool0nYX00_ooool01?l0nY[o0000o`000?l0000Gooooo`03o`3jV_oooooooooo05_o
oooo0_l0nYX[ooooo`03o`000?oooooooooo02?ooooo00Wo0000ooooool0nY[oooooool00?oooooo
003oooooool0nYX06?ooool2o`3jVR7ooooo00?o0?ZJooooooooool0>Oooool2o`3jVR[ooooo00?o
0000ooooooooool0>oooool004;ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooo`3jVP2T
ooooo`03o`000?oooooooooo02Kooooo0_l00002ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oo`00
ooooooooool05_ooool00ol0nY[oooooooooo`1Kooooo`;o0?ZJ:_ooool2o`0002Gooooo00Wo0000
oooooooooooo0?ZJool00?oooooo003oooooool0nYX06?ooool2o`3jVR7ooooo00?o0?ZJoooooooo
ool0>Oooool2o`3jVRWooooo0_l0000mooooo`00@_ooool00ol0003oooooooooo`02ooooo`03o`3j
V_oooooo0?ZJ0:?ooooo0_l0000Xooooo`05o`000?ooooooooooooooool0nYX00_ooool2o`3jVP03
ool00?oooooooooo01Kooooo00?o0?ZJooooooooool0Foooool4o`3jVRWooooo00?o0000oooooooo
ool08oooool02Ol0003oooooooooool0nY[oo`00ooooool00?ooooooo`3jVP0Hooooo`;o0?ZJ8Ooo
ool00ol0nY[oooooooooo`0iooooo`;o0?ZJ:_ooool00ol0003oooooooooo`0kooooo`00@_ooool0
0ol0003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVZ?ooooo00?o0000ooooooooool09_oo
ool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_l0nYX00ooo003oooooooooo`0Fooooo`03o`3j
V_oooooooooo05_ooooo1?l0nYXYooooo`03o`000?oooooooooo02?ooooo00Wo0000oooooooooooo
0?ZJool00?oooooo003oooooool0nYX05oooool00ol0nY[oooooo`3jVP0Qooooo`03o`3jV_oooooo
oooo03Wooooo0_l0nYXZooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oooooooooo
00;ooooo00Co0?ZJoooooooooooo0?ZJXoooool00ol0003oooooooooo`0Vooooo`;o00000_ooool0
0ol0nY[oooooooooo`02o`3jVP03ool00?oooooooooo01Gooooo0_l0nYXUooooo`;o0?ZJ=_ooool4
o`3jVRSooooo0_l0000Uooooo`05o`000?ooooooooooo`3jV_oo00000_ooool00ol00?oo0?ZJoooo
o`0Fooooo`03o`3jV_oooooo0?ZJ027ooooo00?o0?ZJooooooooool0>Oooool2o`3jVRWooooo0_l0
000mooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool0XOoo
ool00ol0003oooooooooo`0Vooooo`05o`000?ooooooooooooooool0nYX00_ooool2o`3jVP03ool0
0?oooooooooo01Gooooo0_l0nYXUooooo`;o0?ZJ=_ooool4o`3jVRWooooo00?o0000ooooooooool0
8oooool01Ol0003oooooooooool0nY[oo`0000;ooooo00?o003oo`3jV_ooool05_ooool00ol0nY[o
ooooo`3jVP0Qooooo`03o`3jV_oooooooooo03Wooooo0_l0nYXZooooo`03o`000?oooooooooo03_o
oooo0012ooooo`05o`000?ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`2Qooooo`03
o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00oooo
ooooool05Oooool2o`3jVRGooooo00?o0?ZJooooool0nYX0=Oooool2o`3jVP;oo`00:Oooool00ol0
003oooooooooo`0Sooooo`05o`000?ooooooooooo`3jV_oo00000_ooool00ol00?oo0?ZJooooo`0F
ooooo`03o`3jV_oooooo0?ZJ027ooooo00?o0?ZJooooooooool0>?ooool00ol0nY[oooooo`3jVP0Z
ooooo`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00oooool0
0ol0nY[oooooooooo`2Pooooo`;o0000:?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_l0
nYX00ooo003oooooooooo`0Eooooo`;o0?ZJ9Oooool00ol0nY[oooooo`3jVP0eooooo`;o0?ZJ0_oo
000Yooooo`03o`000?oooooooooo02?ooooo00Go0000oooooooooooo0?ZJool00002ooooo`03o`00
ool0nY[ooooo00cooooo0_l0nYX8ooooo`03o`3jV_oooooo0?ZJ023ooooo0_l0nYXjooooo`03o`3j
V_oooooo0?ZJ02[ooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000oooooooooooooooo
o`3jVP03ooooo`;o0?ZJX_ooool00ol0003oooooooooo`0Vooooo`;o00000_ooool00ol0nY[ooooo
ooooo`02o`3jVP03ool00?oooooooooo01Gooooo0_l0nYX00ooooooo0?ZJooooo`0Rooooo`03o`3j
V_oooooo0?ZJ03Gooooo0_l0nYX2ool002Sooooo0_l0000Uooooo`05o`000?ooooooooooo`3jV_oo
00000_ooool00ol00?oo0?ZJooooo`0<ooooo`;o0?ZJ2?ooool00ol0nY[oooooo`3jVP0Pooooo`;o
0?ZJ>_ooool00ol0nY[oooooo`3jVP0Yooooo`;o0000?Oooool004;ooooo00Go0000oooooooooooo
ooooo`3jVP03ooooo`;o0?ZJX_ooool00ol0003oooooooooo`0Hooooo`Go00000oooool2o`0000Co
oooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool05Oooool2o`3j
VP03ooooool0nY[o0?ZJ02;ooooo00?o0?ZJo`00ool0nYX05?ooool00ol0nY[oooooooooo`0Noooo
o`;o0?ZJ0_oo000Uooooo`;o0?ZJ0_ooool00ol0003oooooooooo`0Eooooo`?o00001?ooool2o`00
00Gooooo00Go0000ooooooooooooooooool00002ooooo`03o`00ool0nY[ooooo00_ooooo0ol0nYX8
ooooo`03o`3jV_oooooo0?ZJ023ooooo0_l0nYXIooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJ
ooooool0nYX0:_ooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo
0?ZJ00?ooooo00?o0?ZJool00?ooool0XOooool00ol0003oooooooooo`0Iooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00;o
oooo0_l0nYX00ooo003oooooooooo`0Eooooo`;o0?ZJ00?oooooo`3jV_l0nYX08_ooool00ol0nY[o
o`00o`3jVP0Dooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool01oooool2o`3jVP;o
o`009Oooool2o`3jVP;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000Cooooo00Go0000ooooooooooooooooool00002ooooo`03o`00ool0nY[o
oooo00_ooooo00?o0?ZJooooool0nYX01oooool01?l0nY[oooooooooool0nYXPooooo`;o0?ZJ6Ooo
ool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo0?ZJ02[ooooo00?o0000ooooooooool0>ooo
ool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`00XOooool2o`0001Cooooo1Ol0
0003ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooo
oooooooooooo0?ZJ00;ooooo0_l0nYX00ooo003oooooooooo`0Eooooo`03o`3jV_oooooo0?ZJ00;o
0?ZJ8Oooool01?l0nY[oo`00ool00?l0nYXCooooo`;o0?ZJ5_ooool2o`3jVPSooooo0_l0nYX2ool0
02Cooooo0ol0nYX2ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`09o`000?ooooooooooooooool0nY[oo`00ooooool00?oo0?ZJ00co
oooo00?o0?ZJooooool0nYX01oooool01?l0nY[oooooooooool0nYXPooooo`Co0?ZJ5_ooool2o`3j
VQoooooo00Co0?ZJo`00oooooooo0?ZJ:_ooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0
003ooooooooooooooooo0?ZJ00;ooooo0ol0002Rooooo`03o`000?oooooooooo01_ooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0nY[ooooo
ooooo`02o`3jVP03ool00?oooooooooo01Gooooo00Go0?ZJooooool0nY[o003oo`3jVP0Qooooo`04
o`3jV_oo003oo`00o`3jVQ?ooooo0_l0nYXFooooo`;o0?ZJ2?ooool2o`3jVP;oo`0000?o0?ZJoooo
ooooool08Oooool00ol0nY[oooooo`3jVP03o`0001Sooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`;o00000_ooool01Ol0nY[oo`00ooooool00?oo0?ZJ00cooooo00?o
0?ZJooooool0nYX01oooool01?l0nY[oooooooooool0nYXPooooo`Go0?ZJ5Oooool2o`3jVQoooooo
00Co0?ZJo`00ool00?oo0?ZJ:Oooool2o`0003gooooo000cooooo`Go00000oooool2o`0000Gooooo
00Go0000ooooooooooooooooo`3jVP02ooooo`?o0000Moooool00ol0nY[oooooooooo`0Xooooo`03
o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000?ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool05Ooo
ool01Ol0nY[oooooo`3jV_oo003o0?ZJ027ooooo00Co0?ZJool00?oo003o0?ZJ4oooool2o`3jVQGo
oooo0ol0nYX8ooooo`;o0?ZJ0_oo00000ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooo0?ZJ00;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo00Wo0000ooooooooooooooooo`3jV_oo003oooooo`00ool0nYX02oooool01?l0nY[ooooo
ooooool0nYX7ooooo`04o`3jV_ooooooooooo`3jVR3ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo
01?ooooo0_l0nYX00ol00?ooooooooooo`0Looooo`04o`3jV_oooooo003oo`3jVR[ooooo00?o0000
ooooooooool0>oooool003Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0004ooooo`05o`000?ooooooooooooooool0nYX00_ooool3o`0001Sooooo00?o0?ZJooooooooool0
G?ooool00ol0nY[oooooooooo`0Xooooo`03o`000?oooooooooo01Sooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0?ZJ0oooool2
o`3jVP03ool00?oooooooooo01Gooooo00?o0?ZJooooool0nYX00_oo000Qooooo`04o`3jV_oo003o
o`00o`3jVQ?ooooo0_l0nYXEooooo`03o`3jV_oooooo0?ZJ00Oooooo00?o0?ZJooooool0nYX00_oo
00000ol0nY[oooooooooo`0Pooooo`04o`3jV_l00?oo003oo`3jVP;ooooo00?o0000ooooooooool0
5Oooool2o`0000Cooooo00Co0000oooooooooooo00001?ooool02Ol0003ooooooooooooooooo0?ZJ
ool00?oooooo003oo`3jVP0;ooooo`04o`3jV_ooooooooooo`3jVPOooooo00Co0?ZJoooooooooooo
0?ZJ7oooool01_l0nY[o0000o`000?l0003oooooo`3jVQGooooo0ol0nYXMooooo`;o0?ZJ00?ooooo
o`00ool0nYX0:_ooool00ol0003oooooooooo`0kooooo`00;Oooool5o`0000?ooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00004ooooo`;o00000_ooool01?l0nY[ooooooooooooo
ool2ool001Sooooo00?o0?ZJooooooooool0Foooool2o`3jVP03ooooool0nY[ooooo02Kooooo0_l0
000Kooooo`?o00001?ooool2o`0000Cooooo0_l000000ooooooo0?ZJooooo`02ooooo`;o0?ZJ00?o
o`00ooooooooool05?ooool01?l0nY[oooooooooool0nYX2ool0027ooooo00Co0?ZJool00?oo003o
0?ZJ4oooool2o`3jVQCooooo00Co0?ZJoooooooooooo0?ZJ1oooool01_l0nY[oooooool00?l0nY[o
o`00o`3jVR;ooooo00Go0?ZJo`00ool00?oo0?ZJooooo`02o`0001Sooooo00?o0000ooooooooool0
0oooool2o`0000Gooooo00Wo0000ooooooooooooooooo`3jV_oo003oooooo`00ool0nYX02oooool0
1?l0nY[oooooooooool0nYX6ooooo`05o`3jV_ooooooooooooooool0nYX07oooool01_l0nY[o0000
o`000?l0003oo`00o`3jVQCooooo00?o0?ZJo`00ool0nYX00_l0nYXLooooo`05o`3jV_l00?oooooo
o`00ool0nYX0:Oooool2o`0003gooooo000fooooo`05o`000?ooooooooooooooool000000_ooool0
0ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0nYX00oooool2ool001Sooooo00?o
0?ZJooooooooool09?ooool00ol0nY[oooooooooo`0dooooo`;o0?ZJ00?oooooo`3jV_ooool09ooo
ool00ol0003oooooooooo`0Vooooo`04o`000?ooooooooooo`3jVP?ooooo0_l0nYX00ooo003ooooo
ooooo`0Dooooo`06o`3jV_ooooooooooool00?ooooooo`008Oooool01?l0nY[oo`00ool00?l0nYXC
ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVPOooooo00Ko
0?ZJo`000?l0003o0000ool00?l0nYXRooooo`04o`3jV_l00?oo003oo`3jVP;ooooo00?o0000oooo
ooooool08oooool02Ol0003ooooooooooooooooo0?ZJool00?oooooo003oo`3jVP0;ooooo`04o`3j
V_ooooooooooo`3jVPKooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`03o`3jV_oooooooooo
01Gooooo00Ko0?ZJo`000?l0003o0000ool00?l0nYXDooooo`05o`3jV_l0003o0000o`000?l0nYX0
7?ooool01Ol0nY[o003oooooool00?oo0?ZJ01Sooooo00?o0?ZJooooooooool03oooool00ol0003o
ooooooooo`0kooooo`00<oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo0_oo000Hooooo`03o`3jV_oooooo
oooo02?ooooo0ol0nYXeooooo`Co0?ZJ:?ooool00ol0003oooooooooo`0Vooooo`04o`000?oooooo
ooooo`3jVP?ooooo0_l0nYX00ooo003oooooooooo`0Dooooo`06o`3jV_ooooooooooool00?oooooo
o`008Oooool01?l0nY[oo`00ool00?l0nYXCooooo`;o0?ZJ3?ooool3o`3jVPGooooo00Co0?ZJoooo
oooooooo0?ZJ1oooool01_l0nY[o0000o`000?l0003oo`00o`3jVR;ooooo00Co0?ZJo`00ool00?oo
0?ZJ0_ooool00ol0003oooooooooo`0Sooooo`09o`000?ooooooooooooooool0nY[oo`00ooooool0
0?oo0?ZJ00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`05o`3jV_oo
ooooooooooooool0nYX01oooool00ol0nY[oooooooooo`0Eooooo`06o`3jV_l00?ooo`00o`3jV_oo
003o0?ZJ5?ooool01Ol0nY[o0000o`000?l0003o0?ZJ01cooooo00Go0?ZJo`00ooooooooooooo`3j
VP0Hooooo`03o`3jV_oooooooooo00oooooo00?o0000ooooooooool0>oooool003?ooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00Go0000oooooooooooo
ooooo`3jVP03ooooo`;oo`006?ooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooo0?ZJ03Go
oooo0ol0nYX00ooooooo0?ZJooooo`0Vooooo`03o`000?oooooooooo02Kooooo00Co0000oooooooo
oooo0?ZJ0oooool2o`3jVP03ool00?oooooooooo01Cooooo00Ko0?ZJooooooooooooo`00o`3jV_oo
000Qooooo`04o`3jV_oo003oo`00o`3jVQ?ooooo0_l0nYX;ooooo`;o0?ZJ00?oooooo`3jV_ooool0
1?ooool01?l0nY[oooooooooool0nYX7ooooo`06o`3jV_l0003o0000o`000?l0nY[oo`008_ooool0
1ol0nY[oo`00ool00?oooooo0?ZJooooool000009Oooool02Ol0003ooooooooooooooooo0?ZJool0
0?oooooo003oo`3jVP0:ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool0
1Ol0nY[ooooooooooooooooo0?ZJ00Oooooo00?o0?ZJooooooooool05?ooool2o`3jVP06o`00oooo
003o0?ZJo`3jV_oo003o0?ZJ4oooool01Ol0nY[o0000o`000?l0003o0?ZJ01cooooo00?o0?ZJoooo
ooooool00ol0000Gooooo`03o`3jV_oooooooooo00Wooooo0_l0nYX4ooooo`03o`000?oooooooooo
03_ooooo000dooooo`?o00001?ooool2o`0000Gooooo00Go0000ooooooooooooooooo`3jVP03oooo
o`;oo`005oooool2o`3jVP03ooooool0nY[o0?ZJ02;ooooo00?o0?ZJooooool0nYX0=Oooool3o`3j
VP03ool00?l0nY[ooooo02Gooooo0_l0000Xooooo`;o000000?oooooo`3jV_ooool00_ooool2o`3j
VP03ool00?oooooooooo01Cooooo00Ko0?ZJooooooooooooo`00o`3jV_oo000Qooooo`04ool00?l0
nY[oo`00o`3jVQ?ooooo0_l0nYX;ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`04ooooo`06o`3jV_ooooooo`00ooooool0nY[oo`008_ooool0
1Ol0nY[oo`00ool00?oooooo0?ZJ00;o00009Oooool02Ol0003ooooooooooooooooo0?ZJool00?oo
oooo003oo`3jVP0:ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool01Ol0
nY[o003oool00?l00?oo0?ZJ00Oooooo00?o0?ZJooooooooool05?ooool02?l0nY[oooooo`00oooo
003oooooo`3jV_oo003o0?ZJ4_ooool00ol0nY[o003oooooo`02ool00003o`3jV_oooooooooo013o
oooo0_l0nYX7ooooo`04o`3jV_l00?ooo`00ool000?o00005oooool2o`3jVPWooooo0ol0nYX3oooo
o`;o0000?Oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`005oooool2o`3j
VP03ooooool0nY[o0?ZJ02;ooooo00?o0?ZJooooool0nYX0=Oooool3o`3jVP03ool00?l0nY[ooooo
02Kooooo00?o0000ooooooooool09_ooool01?l0003oooooooooool0nYX3ooooo`;o0?ZJ00?oo`00
ooooooooool05?ooool01_l0nY[ooooooooooooo003oooooool0027ooooo00Coo`00o`3jV_oo003o
0?ZJ4oooool2o`3jVP_ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`00o`02oooo
o`03o`3jV_oooooooooo00Cooooo00Ko0?ZJoooooooo003oooooo`3jV_oo000Qooooo`08o`3jV_oo
ooooo`00ool00?oooooo0?ZJooooool0000Uooooo`09o`000?ooooooooooooooool0nY[oo`00oooo
ool00?oo0?ZJ00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_ooooooo`0000;oo`0000?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`09ooooo`?o0?ZJ
2?ooool02?l0nY[oooooo`00oooo003oooooo`3jV_oo003o0?ZJ4_ooool01_l0nY[o003oool00?oo
003o0?ZJool0017ooooo0ol0nYX7ooooo`04o`3jV_ooooooo`00ool000?o00005_ooool3o`0000Wo
oooo00?o0?ZJooooool0nYX01?ooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooo
oooooooooooo0?ZJ00?ooooo0_oo00000ol0nY[oooooooooo`0Dooooo`;o0?ZJ00?oooooo`3jV_l0
nYX08_ooool00ol0nY[oooooo`3jVP0eooooo`?o0?ZJ00?oo`00o`3jV_ooool08oooool2o`3jVP03
ooooool0003ooooo02Oooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oooooooooo
01Cooooo00Oo0?ZJo`000?l0003o0000oooooooo003o0?ZJ023ooooo00Coo`00o`3jV_l0nY[oo`00
4oooool2o`3jVP_ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01_l0nY[oooooool00?oo003ooooo
o`3jVPKooooo00Ko0?ZJoooooooo003oooooo`3jV_oo000Qooooo`08o`3jV_l00?ooo`00ool00?oo
oooo0?ZJooooool0000Uooooo`09o`000?ooooooooooooooool0nY[oo`00ooooool00?oo0?ZJ00Wo
oooo00?o0?ZJoooooooo00000oooool00ol0nY[oooooooooo`02ooooo`06o`3jV_ooooooo`00oooo
oooo003o0?ZJ1oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo0?ZJ00Sooooo00So0?ZJ
o`00ooooooooo`00ooooool0nY[oo`00o`3jVQ;ooooo00Oo0?ZJo`00oooo003oo`00o`3jV_oo003o
0?ZJ013ooooo00?o0?ZJooooool0nYX01oooool01?l0nY[oo`00ool00?ooool2ool001Oooooo0ol0
0009ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000
ooooooooooooooooo`3jVP03ooooo`;oo`0000?o0?ZJooooooooool05?ooool2o`3jVP03ooooool0
nY[o0?ZJ02;ooooo00?o0?ZJool00?l0nYX0;?ooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ0_oo
00000ol0nY[oooooooooo`0Qooooo`?o0?ZJ00?oooooo`000?ooool09oooool2o`000003ooooool0
nY[ooooo00;ooooo0_l0nYX00ooo003oooooooooo`0Dooooo`07o`3jV_l0003o0000o`000?oooooo
o`00o`3jVP0Pooooo`04ool00?l0nY[o0?ZJool001?ooooo0_l0nYX:ooooo`05o`3jV_oooooooooo
ooooool0nYX01?ooool01_l0nY[oooooool00?oo003oooooo`3jVPKooooo00Ko0?ZJoooooooo003o
ooooo`3jV_oo000Qooooo`06o`3jV_oo003oooooool00?oooooo0?ZJ0_l0000Uooooo`09o`000?oo
ooooooooooooool0nY[oo`00ooooool00?oo0?ZJ00Wooooo00Co0?ZJool00?oo003oo`000_ooool0
0ol0nY[oooooooooo`02ooooo`06o`3jV_ooooooo`00oooooooo003o0?ZJ1_ooool2o`3jVP_ooooo
00?o0?ZJooooool0nYX02?ooool02?l0nY[o003ooooooooo003oooooo`3jV_oo003o0?ZJ4_ooool0
0ol0nY[oo`00ool00002o`3jVP03ool00?l0nY[ooooo00oooooo00Co0?ZJoooooooooooo0?ZJ1_oo
ool01?l0nY[oo`00ooooooooool2ool001Oooooo0ol00008ooooo`05o`3jV_ooooooooooooooool0
nYX00_ooool2o`0003gooooo0012ooooo`05o`000?ooooooooooooooool0nYX00oooool2ool00003
o`3jV_oooooooooo01Cooooo0_l0nYX01?oooooo0?ZJooooool0nYXQooooo`03o`3jV_oo003o0?ZJ
02[ooooo0ol0nYX8ooooo`;o0?ZJ00?oo`00oooooooo00008oooool01Ol0nY[oooooo`3jV_oooooo
000002Sooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oooooooooo01Cooooo00Oo
0?ZJo`000?l0003o0000oooooooo003o0?ZJ023ooooo00Coo`00o`3jV_l0nY[oo`004_ooool00ol0
nY[oooooo`3jVP0:ooooo`03o`3jV_oooooooooo00;ooooo00[o0?ZJooooooooooooooooo`3jV_oo
003oooooool00?oooooo0?ZJ1_ooool01_l0nY[oooooool00?oooooo0?ZJool0027ooooo00So0?ZJ
ool00?ooooooo`00o`00ool0nY[oooooo`0002Gooooo00Wo0000ooooooooooooooooo`3jV_oo003o
ooooo`00ool0nYX02Oooool01?l0nY[oo`00oooooooo0002ooooo`03o`3jV_oooooooooo00;ooooo
00Co0?ZJool00?oooooooooo0ol00005ooooo`;o0?ZJ2_ooool01?l0nY[oooooooooool0nYX7oooo
o`03o`3jV_ooooooo`0000;oo`0000Coooooo`3jV_oo003o0?ZJ4Oooool01?l0nY[oooooool00?oo
ool2o`3jVP03ool00?l0nY[ooooo00kooooo00Go0?ZJo`00ooooooooooooo`3jVP06ooooo`04o`3j
V_oo003oooooooooo`;oo`005oooool00ol0nY[o003oool00007ooooo`;o0?ZJ00Co003ooooooooo
oooo0?ZJ0oooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ
00?ooooo0_oo00000ol0nY[oooooooooo`0Dooooo`;o0?ZJ00Coooooool00?oo003o0?ZJ8Oooool0
1?oo003o003oool00?l0nYXYooooo`03o`3jV_oooooo0?ZJ00Sooooo0_l0nYX00ooo003o0?ZJool0
000Sooooo`05o`3jV_ooooooooooo`3jV_l00000:?ooool01?l0003oooooooooool0nYX2ooooo`04
o`00ool0nY[o0?ZJool001Kooooo00Oo0?ZJooooool00?ooo`00oooooooo003o0?ZJ01oooooo00Go
0?ZJool00?l0nY[o0?ZJool0000Booooo`03o`3jV_oooooo0?ZJ00[ooooo00Ko0?ZJoooooooo003o
o`00ooooool0nYX3ooooo`06o`3jV_oo003oooooool00?oooooo0?ZJ1_ooool00ol0nY[oooooool0
0002ooooo`03ool00?oooooooooo01oooooo00So0?ZJool00?ooooooooooool00?l0nY[oooooo`00
02Gooooo00Wo0000ooooooooooooooooo`3jV_oo003oooooo`00ool0nYX02Oooool01?l0nY[oo`00
oooooooo0002ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJool00?oooooooooo0ol00005oooo
o`;o0?ZJ2_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00Go0?ZJo`00oooo003oooooool0
0002ooooo`03ool00?l0nY[ooooo013ooooo00So0?ZJoooooooo003oooooo`3jV_ooooooo`00o`3j
VPoooooo00Go0?ZJo`00ooooooooooooo`3jVP05ooooo`03o`3jV_l00?ooo`0000;ooooo0_oo000F
ooooo`04o`3jV_l00?ooooooool000Oooooo0_l0nYX01?oo003o003oooooool0nYX3ooooo`03o`00
0?oooooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00_ooool01?l00?ooo`00
o`3jV_oo000Fooooo`;o0?ZJ00Coooooool00?oo003o0?ZJ8?ooool01Ol0nY[oo`00o`00oooo003o
0?ZJ02Wooooo00Co0?ZJoooooooooooo0?ZJ1oooool2o`3jVP03ool00?l0nY[oo`0002?ooooo00Go
0?ZJoooooooooooo0?ZJo`00000Xooooo`04o`000?ooooooooooo`3jVP;ooooo00Co003oo`3jV_l0
nY[oo`005Oooool02?l0nY[oooooooooool00?ooo`00oooooooo003o0?ZJ7oooool01_l0nY[oo`00
o`3jV_l0nY[oo`00o`3jVQ7ooooo00?o0?ZJooooool0nYX02_ooool01_l0nY[oo`00oooooooo003o
ooooo`3jVP?ooooo00Ko0?ZJool00?ooooooo`00ooooool0nYX6ooooo`03o`3jV_ooooooo`0000;o
oooo00?oo`00ooooooooool07oooool02?l0nY[oo`00o`3jV_l0nY[oo`00o`3jV_oooooo00009Ooo
ool02Ol0003ooooooooooooooooo0?ZJool00?oooooo003oo`3jVP09ooooo`;oo`0000Go003oool0
0?ooooooooooo`3jVP04ooooo`04o`3jV_oo003oooooooooo`?o00001Oooool00ol0nY[oooooo`3j
VP09ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01Ol0nY[o003oool00?ooooooo`0000;o
oooo00?oo`00o`3jV_ooool04?ooool02?l0nY[o003oool00?oooooo0?ZJoooooooo003o0?ZJ3ooo
ool01Ol0nY[o003oo`00oooooooo0?ZJ00Gooooo00?o0?ZJool00?ooool00_ooool2ool0013ooooo
00?o0?ZJooooooooool00oooool01Ol0nY[o003ooooooooo003o0?ZJ00Kooooo00Ko0?ZJool00?oo
003oo`00ooooool0nYX3ooooo`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?oooooooooo
ooooool0nYX00_ooool01?l00?ooo`00o`3jV_oo000Fooooo`?o0?ZJ0_oo00000ol0nY[ooooooooo
o`0Nooooo`05o`3jV_oo003o003oool00?l0nYX08?ooool3o`3jVPGooooo00Go0?ZJoooooooooooo
ooooo`3jVP07ooooo`;o0?ZJ00?oo`00o`3jV_oo00008_ooool01_l0nY[oooooo`00oooooooo0?ZJ
o`0002Sooooo0_l000001Ooooooo0?ZJoooooooooooo003o00;o0?ZJ00?oo`00ooooooooool04ooo
ool02?l0nY[oooooooooool00?ooo`00oooooooo003o0?ZJ7oooool01_l0nY[oo`00o`3jV_l0nY[o
o`00o`3jVQ7ooooo00?o0?ZJooooool0nYX02Oooool01ol0nY[oooooool00?ooooooo`00ooooool0
nYX00_ooool01ol0nY[o003oool00?ooooooo`00ooooool0nYX01Oooool01?l0nY[ooooooooooooo
0002ooooo`03ool00?oooooooooo01oooooo00Ko0?ZJool00?l0nY[o0?ZJool00?l0nYX2o`0002Go
oooo00Wo0000ooooooooooooooooo`3jV_oo003oooooo`00ool0nYX00oooool2o`3jVPCooooo00Oo
o`00o`00ool00?oo003oool00?oooooo0?ZJ00?ooooo00?o0?ZJoooooooo00000oooool00ooo003o
0?ZJooooo`04ooooo`03o`3jV_oo003o0?ZJ00Wooooo00Go0?ZJooooooooooooooooo`3jVP06oooo
o`05o`3jV_oo003oooooooooool0nYX00_ooool00ooo003o0?ZJooooo`07ooooo`03o`00ool0nY[o
0?ZJ00Kooooo00So0?ZJool00?ooooooooooo`3jV_ooooooo`00o`3jVPOooooo0ol0nYX5ooooo`05
o`3jV_oooooo003oooooool0nYX01Oooool00ol0nY[oo`00ooooo`03ooooo`03ool00?oooooooooo
00Gooooo00?o0?ZJooooooooool01Oooool2o`3jVPGooooo00Go0?ZJo`00ooooooooo`00o`3jVP05
ooooo`;o0?ZJ00Goo`00oooooooo003o003oo`3jVP02ooooo`;o0000?Oooool004;ooooo00Go0000
ooooooooooooooooo`3jVP02ooooo`04o`00oooo003o0?ZJool001Kooooo0ol0nYX2ool00003o`3j
V_oooooooooo01kooooo00Go0?ZJool00?l00?ooo`00o`3jVP0Pooooo`03o`3jV_oooooo0?ZJ00Go
oooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;o0?ZJ00?oo`00o`00oooo00008_ooool01_l0
nY[o003oo`00oooooooo0?ZJo`0001_ooooo0ol00004ooooo`;o00001?ooool01?l0003ooooooooo
ool0nYX2ooooo`05o`00oooooooo0?ZJool00?l0nYX05?ooool02?l0nY[ooooooooooooo003o0?ZJ
oooooooo003o0?ZJ7oooool01_l0nY[oo`00ooooool0nY[oo`00o`3jVQ7ooooo00?o0?ZJooooool0
nYX01Oooool2o`3jVP;ooooo00Oo0?ZJoooooooo003oooooool00?oooooo0?ZJ00;ooooo00?o0?ZJ
ool00?oo00000_ooool00ooo003o0?ZJooooo`04ooooo`04o`3jV_oooooo003oool000;ooooo00?o
o`00ooooooooool07Oooool01?l0nY[oooooo`3jV_oo0002o`3jVP04ool00?l0nY[oooooo`0001Ko
oooo1Ol00003ooooo`;o00001Oooool02Ol0003ooooooooooooooooo0?ZJool00?oooooo003oo`3j
VP03ooooo`;o0?ZJ0oooool02?l0nY[oo`00o`00oooooooo003oool00?oooooo0?ZJ0oooool00ol0
nY[oo`00o`00o`03ooooo`03o`3jV_oo003ooooo00Cooooo00?o0?ZJool00?l0nYX02?ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJool00?ooooooooooo`3jVP02
ooooo`03ool00?l0nY[ooooo00Oooooo1?l0nYX5ooooo`08o`3jV_oo003oooooooooool0nY[ooooo
ool00?l0nYX7ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Ko0?ZJo`00oooo003oo`00ooooool0nYX5
ooooo`04o`3jV_oo003o0?ZJo`3jVP;ooooo00?oo`00ooooooooool01Oooool00ol0nY[ooooooooo
o`05ooooo`;o0?ZJ1Oooool01Ol0nY[o003oool00?oo003o0?ZJ00Gooooo0_l0nYX01Ooo003ooooo
ool00?l00?oo0?ZJ00?ooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000oooooooooooo
ooooo`3jVP02ooooo`04o`00oooo003o0?ZJool001Kooooo0ol0nYX2ool00003o`3jV_oooooooooo
01kooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Oooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`02
ooooo`05o`3jV_l00?ooooooooooool0nYX01oooool2o`3jVP03ool00?ooooooo`0002;ooooo00Ko
0?ZJo`00oooo003o003oo`3jV_l0000Looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00000oooool01?l0003oooooooooool0nYX2ooooo`05o`00oooooooo0?ZJool00?l0nYX05?oo
ool02?l0nY[ooooooooooooo003o0?ZJoooooooo003o0?ZJ7oooool01_l0nY[oo`00ooooool0nY[o
o`00o`3jVQ7ooooo00?o0?ZJooooool0nYX01Oooool3o`3jVP03ooooool0nY[oo`0000;ooooo00?o
o`00ooooool0nYX00_ooool01ol0nY[oo`00ooooool0nY[oooooool00?l0nYX01Oooool01?l0nY[o
ooooo`00oooo0002ooooo`03ool00?oooooooooo01cooooo0ol0nYX02?oo003o003oo`3jV_l0nY[o
o`00o`3jV_oooooo00005oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00Cooooo00Wo0000ooooooooooooooooo`3jV_oo003oooooo`00ool0nYX00oooool2o`3jVP?ooooo
00So0?ZJool00?l0nY[o0?ZJoooooooo003oooooo`3jVP?ooooo00?o0?ZJool00?l00?l00oooool0
0ol0nY[oo`00ooooo`04ooooo`03o`3jV_oo003o0?ZJ00Oooooo0_l0nYX2ool000;ooooo00?o0?ZJ
ooooooooool01?ooool01Ol0nY[oo`00oooooooooooo0?ZJ00;ooooo00?oo`00o`3jV_ooool01ooo
ool01?l0nY[o003oooooool0nYX5ooooo`08o`3jV_oo003oooooooooool0nY[oooooo`3jV_oo0006
ooooo`;o0?ZJ00?oooooo`3jV_ooool00oooool01_l0nY[oo`00oooooooo003oooooo`3jVPGooooo
00?o0?ZJool00?l0nYX00_l0nYX00oooooooo`00o`3jVP05ooooo`;o0?ZJ1oooool2o`3jVPCooooo
00Ko0?ZJo`00ooooooooo`00o`3jV_oo0005ooooo`?o00000_ooool00ooo003o0?ZJooooo`02oooo
o`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00_ooool01?l0
0?ooo`00o`3jV_oo000Fooooo`?o0?ZJ00?oo`00o`3jV_oo00008?ooool01Ol0nY[oo`00o`3jV_oo
003o0?ZJ01;ooooo00?o0?ZJooooooooool02_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo
00Go0?ZJo`00ool00?ooooooo`3jVP06ooooo`06o`3jV_oooooo0?ZJool00?ooooooo`008_ooool0
1_l0nY[oo`00ool00?oo003o0?ZJo`0001Cooooo1Ol00003ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000oooool2o`000005o`3jV_ooooooooooooooool00?l00_ooool00ooo
003o0?ZJooooo`03ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`02ooooo`08o`3jV_oooooo003o
ool00?l0nY[oooooo`3jV_oo000Oooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ4Oooool00ol0
nY[oooooo`3jVP04ooooo`08o`3jV_ooooooooooo`3jV_oooooo0?ZJool00?l00?l2ooooo`07ool0
0?oooooo0?ZJooooool0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo00Cooooo00Co0?ZJoooo
ool00?ooo`000_ooool00ooo003oooooooooo`0Looooo`?o0?ZJ00Koo`00ooooool0nY[o0?ZJool0
0?l0nYX2o`0001Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`;o
00000_ooool01Ol0nY[oo`00ooooool00?oo0?ZJ00?ooooo0_l0nYX3ooooo`08o`3jV_oo003o0?ZJ
o`3jV_ooooooo`00ooooool0nYX3ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJool00?ooool0
1?ooool00ol0nY[oo`00o`3jVP07ooooo`;o0?ZJ0ooo00000ol00?oo0?ZJooooo`04ooooo`03o`3j
V_oo003ooooo00;ooooo00Go0?ZJooooooooooooo`00o`3jVP08ooooo`04o`3jV_oooooo003oo`3j
VPCooooo00?o0?ZJool00?oo00000ol0nYX00ooooooo0?ZJool00006ooooo`05o`3jV_oooooooooo
ooooool0nYX00oooool01_l0nY[oo`00oooooooo003oooooo`3jVPGooooo00Soo`00ooooool0nY[o
ooooo`3jV_ooooooo`00o`3jVPGooooo0_l0nYX6ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Ko0?ZJ
o`00ooooooooo`00o`3jV_oo0005ooooo`?o000000Co0?ZJoooooooo003o0?ZJ0_ooool2o`0003go
oooo0012ooooo`04o`000?ooooooooooo`3jVP?ooooo00Co003oool00?ooooooo`005Oooool01?l0
nY[oooooo`3jV_oo0002o`3jVP03ool00?oooooooooo01kooooo00Go0?ZJool00?l0nY[oo`00o`3j
VP0Booooo`03o`3jV_oooooooooo00[ooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`05o`3j
V_l00?ooo`00ooooool0nYX01_ooool01_l0nY[oooooo`3jV_oo003oooooool002;ooooo00Ko0?ZJ
ool00?ooooooo`00o`3jV_l0000Looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000oooool00ol0003oooooo`3jVP03ooooo`05o`00ooooooooooooool00?l0nYX01?ooool3o`3j
VPOooooo0_l0nYX4ooooo`08o`3jV_oooooo003oool00?l0nY[oooooo`3jV_oo000Oooooo`06ool0
0?l0nY[oooooo`3jV_oo003o0?ZJ4Oooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo
00?o0?ZJ00_oo`00o`00ooooooooooooool00?oooooo0?ZJooooool0nY[oo`00ooooo`02o`3jVP03
ool00?l0nY[ooooo00Cooooo00Co0?ZJooooool00?ooo`000_ooool00ooo003oooooooooo`0Loooo
o`?o0?ZJ00Soo`00o`3jV_oooooo0?ZJool00?l0nY[oooooo`0001Wooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00;ooooo00Wo0000ooooooooooooooooo`3jV_oo003o
ooooo`00ool0nYX00oooool00ol0nY[oooooo`3jVP02ooooo`08ool00?l0nY[oooooo`3jV_oooooo
o`00ooooool0nYX3ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?o0?ZJool00?ooool00oooool0
1?l0nY[oo`00ool00?l0nYX7ooooo`;o0?ZJ00Goo`00oooooooo003o003oo`3jVP05ooooo`03o`3j
V_oo003ooooo00;ooooo00Go0?ZJoooooooooooo0?ZJool00007ooooo`04o`3jV_l00?ooooooo`00
o`;o0?ZJ0oooool02Ol0nY[oo`00o`00ool0nY[oooooo`3jV_oooooo0?ZJool00005ooooo`;o0?ZJ
0oooool01?l0nY[oooooooooooooool2ool00004oooooooo003oooooo`3jVPGooooo00Soo`00o`3j
V_l0nY[oooooo`3jV_ooooooo`00o`3jVPGooooo0_l0nYX6ooooo`03o`3jV_oooooo0?ZJ00Cooooo
00Ko0?ZJo`00ooooooooo`00o`3jV_oo0005ooooo`?o00000_l0nYX00ooo003o0?ZJooooo`02oooo
o`03o`000?oooooooooo03_ooooo0012ooooo`04o`000?ooooooooooo`3jVP?ooooo00Co003oool0
0?ooooooo`005Oooool01?l0nY[oooooo`3jV_oo0002o`3jVP03ool00?oooooooooo01kooooo00Go
0?ZJool00?l0nY[oo`00o`3jVP0Booooo`03o`3jV_oooooooooo00[ooooo00Go0?ZJoooooooooooo
ooooo`3jVP04ooooo`05o`3jV_oo003oo`00ooooool0nYX01_ooool01_l0nY[oooooool00?l0nY[o
ooooool002;ooooo00Ko0?ZJool00?ooooooo`00o`3jV_l0000Looooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000oooool00ol0003oooooo`3jVP03ooooo`05o`00oooooooooooo
ool00?l0nYX01?ooool00ol0nY[oooooo`3jVP07ooooo`;o0?ZJ0oooool2o`3jVP07ooooool00?oo
o`00o`3jV_oooooo0?ZJool0000Nooooo`07o`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP0@oooo
o`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooooooool00_l0nYX2ool0000>o`00ool0nY[o
ooooool00?oooooo0?ZJooooool0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX5ooooo`04o`3jV_oo
oooo003oool000;ooooo00?oo`00ooooooooool06_ooool5o`3jVP08ool00?l0nY[oooooo`3jV_oo
003o0?ZJooooool0000Fooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00004ooooo`06o`000?ooooooooooooooool0nY[oo`000_ooool01?l0nY[oooooooooool0nYX2
ooooo`05o`3jV_oooooo0?ZJool00?l0nYX00_ooool01?l0nY[oo`00o`00ool0nYX3ooooo`08o`3j
V_oo003o0?ZJooooool0nY[oooooo`3jV_oo0004ooooo`05o`3jV_oo003oooooool00?l0nYX01_oo
ool01ol0nY[oo`00ooooool00?ooo`00o`00ool0nYX01Oooool00ol0nY[oo`00ooooo`02ooooo`05
o`3jV_ooooooooooo`3jV_oo00001oooool01_l0nY[oooooooooool00?ooooooo`3jVP?ooooo00Wo
0?ZJool00?oooooo0?ZJooooool0nY[oooooo`3jV_oo00001Oooool2o`3jVP?ooooo00Go0?ZJoooo
ooooooooooooool00002ooooo`04ool00?ooooooooooo`3jVP?ooooo00?o0?ZJool00?l0nYX00_oo
ool01?l0nY[oooooool00?l0nYX5ooooo`;o0?ZJ1_ooool00ol0nY[oooooo`3jVP04ooooo`06o`3j
V_l00?ooo`00ool00?l0nY[oo`001Oooool02?l0nY[oo`00oooooooooooo0?ZJool00?oooooo0?ZJ
0_ooool00ol0003oooooooooo`0kooooo`00@_ooool01?l0003oooooooooool0nYX3ooooo`04o`00
oooo003oooooool001Gooooo00Co0?ZJooooool0nY[oo`000_l0nYX00ooo003oooooooooo`0Noooo
o`05o`3jV_oo003oooooool00?l0nYX04_ooool00ol0nY[oooooooooo`0:ooooo`05o`3jV_oooooo
ooooooooool0nYX00oooool01_l0nY[oooooool00?l00?ooo`00o`3jVPKooooo00Ko0?ZJoooooooo
003o0?ZJoooooooo000Rooooo`06o`3jV_oo003oooooool00?l0003o0?ZJ6oooool2o`0000Cooooo
00Co0000oooooooooooo00000oooool00ol0003oooooo`3jVP03ooooo`03o`00oooooooooooo00;o
o`000oooool01?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02ool0
0004o`3jV_oooooo0?ZJool001kooooo00Oo0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ013ooooo
00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooooooo`02o`3jVP03ool00?oooooo0?ZJ00;o
0?ZJ00_oo`00ooooool0nY[o0?ZJo`00oooo003o0?ZJooooool0nY[oo`00o`3jVP04ooooo`05o`3j
V_ooooooooooo`00oooo00000_ooool00ooo003oooooooooo`0Iooooo`04o`3jV_oooooooooooooo
o`;o0?ZJ00Soo`00o`3jV_oooooo0?ZJool00?l0nY[oooooo`0001Kooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00Ko0000ooooooooooooooooo`3jV_oo
0002ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00Go0?ZJooooool0nY[oo`00o`3jVP02ooooo`04
o`3jV_oo003o003oo`3jVP?ooooo00So0?ZJool00?l0nY[oooooo`3jV_oooooo0?ZJool000Cooooo
00Ko0?ZJool00?ooooooo`00o`00ool0nYX4ooooo`;o0?ZJ00Koo`00ooooool00?ooo`00o`00ool0
nYX5ooooo`06o`3jV_oo003oooooo`3jV_oooooo0?ZJ0_ooool00ol0nY[oo`00ooooo`05ooooo`;o
0?ZJ0_ooool00ol00?ooooooo`3jVP03ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Co0?ZJooooool0
nY[oo`001?ooool3o`3jVP04ool00?ooooooooooo`3jVP?ooooo00Ooo`00o`3jV_l0nY[o003oool0
0?oooooo0?ZJ00?ooooo00?o0?ZJool00?l0nYX00_ooool01?l0nY[oooooo`3jV_oo0004ooooo`03
o`3jV_oooooo0?ZJ00Gooooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`06o`3jV_ooooooo`00ool0
0?l0nY[oo`001Oooool02?l0nY[oo`00oooooooooooo0?ZJool00?oooooo0?ZJ0_ooool00ol0003o
ooooooooo`0kooooo`00@_ooool01?l0003oooooooooool0nYX3ooooo`04o`00oooo003oooooool0
01Gooooo00Co0?ZJooooool0nY[oo`000_l0nYX00ooo003oooooooooo`0Nooooo`05ool00?l0nY[o
ooooool00?l0nYX04_ooool00ol0nY[oooooooooo`09ooooo`06o`3jV_ooooooo`00ool00?oooooo
0?ZJ0oooool01_l0nY[o003oool00?ooooooo`00o`3jVPKooooo00Oo0?ZJoooooooo003o0?ZJoooo
oooo003o0?ZJ027ooooo00Ko0?ZJool00?ooooooo`00ooooool0nYXLooooo`03o`000?oooooooooo
00?ooooo0_l00004ooooo`;o000000Go0?ZJooooooooooooooooo`00o`02ooooo`;oo`000oooool0
1?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ0oooool02Ol0nY[ooooooooooooo003oooooo`3jV_oo
oooo0?ZJool0000Mooooo`;o0?ZJ00Koo`00o`3jV_oooooo0?ZJool00?l0nYX@ooooo`04o`3jV_oo
ooooooooo`3jVPCooooo00?o0?ZJooooooooool00_l0nYX01ooo003oooooo`3jV_l00?oo0?ZJool0
0?ooool00_l0nYX01ooo003oooooo`3jV_oooooo0?ZJool00?l0nYX01?ooool01Ol0nY[ooooooooo
ool00?ooo`0000;ooooo00?oo`00ooooooooool06Oooool01Ol0nY[ooooooooooooooooo0?ZJ00;o
o`0000Go0?ZJooooool0nY[oo`00o`3jVP02o`0001Oooooo0ol00004ooooo`;o00001Oooool01_l0
003ooooooooooooooooo0?ZJool000;ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[ooooo
o`000002o`0000;ooooo00Co0?ZJool00?l00?oo0?ZJ0oooool02?oo003o003oo`3jV_oooooo0?ZJ
ooooool0nY[oo`001?ooool01_l0nY[oo`00oooooooo003o003oo`3jVPCooooo0_l0nYX01_oo003o
0?ZJo`00ooooooooo`00o`3jVPGooooo00?o0?ZJool00?l0nYX00ol0nYX2ooooo`03o`3jV_oo003o
oooo00Gooooo00Ko0?ZJo`00ooooooooooooo`00ooooool2o`3jVP;ooooo00?o0?ZJool00?l0nYX0
0_ooool01?l0nY[oooooo`3jV_oo0004ooooo`;o0?ZJ0ooo00000ooooooo0?ZJooooo`03o`0000;o
0?ZJ00Coooooool00?oooooo0?ZJ0oooool00ol0nY[oo`00o`3jVP02ooooo`04o`3jV_oooooo0?ZJ
ool000Cooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[oooooooooool0nYX3ooooo`07o`3jV_l0
0?ooo`00ool00?oooooo0?ZJool00004ooooo`03o`3jV_oo003oo`0000;ooooo00Go0?ZJool00?oo
oooo0?ZJooooo`02o`0003gooooo000dooooo`?o00001?ooool2o`0000Gooooo00Co0000oooooooo
oooo0?ZJ0oooool01?l00?ooo`00oooooooo000Eooooo`04o`3jV_oooooo0?ZJool000;ooooo00?o
o`00o`3jV_ooool07_ooool01Ooo003o0?ZJoooooooo003o0?ZJ01;ooooo00?o0?ZJooooooooool0
2Oooool00ol0nY[oooooool00002ool0000:o`3jV_ooooooooooooooool0nY[o003oool00?oooooo
o`00o`3jVPKooooo00?o0?ZJoooooooo00000_ooool00ooo003o0?ZJooooo`0Oooooo`07o`3jV_oo
ooooo`00oooooooo003oooooo`3jVP0Xooooo`03o`000?oooooo0?ZJ00?ooooo00?o003ooooooooo
ool00_oo0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX3ooooo`09o`3jV_oooooooooo
ool00?oooooo0?ZJooooool0nY[oo`0001gooooo0_l0nYX01_oo003oooooooooool0nY[oo`00o`3j
VQ3ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`000002o`000007ool00?l0nY[o
0?ZJo`00ool0nY[oo`00ooooo`02o`3jVP07ool00?oooooo0?ZJooooool0nY[oo`00o`3jVP04oooo
o`05o`3jV_ooooooooooo`00oooo00000_ooool00ooo003oooooooooo`0Iooooo`0>o`3jV_oooooo
ooooooooool0nY[oo`00ooooool0nY[oooooo`3jV_oo003oooooo`3jV_l0000Uooooo`06o`000?oo
ooooooooooooool0nY[oo`000_ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooo0000
00;o00000_ooool01?l0nY[oo`00o`00ool0nYX3ooooo`08ool00?l0nY[o0?ZJooooool0nY[ooooo
o`3jV_oo0004ooooo`05o`3jV_l0003o0000o`000?l00?l00_l0nYX3ooooo`;o0?ZJ00Koo`00o`3j
V_l0nY[oooooool00?l0nYX5ooooo`04o`3jV_oo003o0?ZJooooo`;o0?ZJ0_ooool00ol0nY[oo`00
o`3jVP03ooooo`04o`3jV_oooooo0?ZJo`00o`;ooooo00Co003ooooooooooooo0?ZJ0_ooool00ol0
nY[oo`00o`3jVP04ooooo`03o`3jV_oo003o0?ZJ00?ooooo0_l0nYX01_oo003oooooool00?oooooo
0?ZJooooo`?o000000Koooooo`3jV_ooooooo`00ooooool0nYX3ooooo`03o`3jV_oo003o0?ZJ00?o
oooo0_l0nYX00ooo003oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Gooooo00Co0?ZJoooooooo
oooo0?ZJ0oooool00ol0nY[o003oool00002ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJool0
0?l0nYX00_ooool01?l0nY[oo`00ooooool0nYX2ooooo`03o`000?oooooooooo03_ooooo000eoooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool0
nYX3ooooo`04o`00oooo003oooooool001Gooooo00Co0?ZJooooool0nY[oo`000_ooool00ooo003o
0?ZJooooo`0Nooooo`05ool00?l0nY[oooooool00?l0nYX04_ooool00ol0nY[oooooooooo`09oooo
o`06o`3jV_oo003oo`00oooooooo003o0?ZJ0oooool01_l0nY[oo`00ooooooooooooo`00o`3jVPKo
oooo00?o0?ZJoooooooo00000_ooool00ooo003o0?ZJooooo`0Oooooo`07o`3jV_oo003oooooo`3j
V_oo003oooooo`3jVP0Xooooo`03o`000?oooooo0?ZJ00;ooooo00Coo`00o`00oooooooooooo0_oo
0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX2ooooo`;o0?ZJ0_ooool01_oo003ooooo
o`3jV_oooooo0?ZJool001gooooo00?o0?ZJool00?l0nYX00_ooool00ol0nY[oo`00o`3jVP0?oooo
o`;o0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo000000;o000000Ooooooo`3j
V_oooooo003oo`3jV_oo003ooooo00;o0?ZJ00Ooo`00ooooool0nY[oooooo`3jV_oo003o0?ZJ00Co
oooo00Go0?ZJoooooooooooo003oool00002ooooo`03ool00?oooooooooo01Wooooo00Oo0?ZJoooo
ooooooooooooo`3jV_oo003o0?ZJ00;ooooo00Go0?ZJool00?oooooo0?ZJo`00000Uooooo`06o`00
0?ooooooooooooooool0nY[oo`000_ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooo
000000;o00000_ooool01?l0nY[oo`00o`00ool0nYX3ooooo`09ool00?l0nY[oooooooooool0nY[o
ooooo`3jV_oo003o0?ZJ00?ooooo00Oo0?ZJo`000?l0003o0000ool00?oooooo0?ZJ00?ooooo0ol0
00001_l00?oo0?ZJoooooooo003o003oo`3jVPCooooo00Coo`00o`00ool0nY[ooooo0_l0nYX2oooo
o`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJooooool0nYX00oooool01?l00?ooooooooooool0nYX2
ooooo`03ool00?l00?oo0?ZJ00Gooooo00?oo`00o`3jV_ooool00_ooool02?l0nY[oo`00ool00?l0
0?ooo`00ooooool0nY[ooooo0ol00002ooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?oo`00o`3j
V_ooool00oooool2o`3jVP03ool00?oooooooooo00;ooooo00?o0?ZJooooool0nYX01?ooool2o`3j
VP;ooooo00Oo0?ZJooooooooooooooooo`3jV_l00?ooo`0000;ooooo00?o0?ZJool00?ooool00ooo
ool00ol0nY[oo`00o`3jVP02ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?o0000ooooooooool0
>oooool002gooooo1Ol00003ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool2o`000003ooooool0nY[ooooo00;ooooo00Co003oool00?ooooooo`005Oooool01?l0nY[o
ooooo`3jV_oo0002ooooo`03ool00?l0nY[ooooo01gooooo00Ko0?ZJool00?l0nY[oooooo`3jV_oo
000Aooooo`;o0?ZJ2oooool01_l0nY[oo`00ooooooooooooo`00o`3jVP?ooooo00Ko0?ZJool00?oo
ooooooooool00?l0nYX6ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_ooool07oooool0
1ol0nY[oo`00ooooool0nY[oo`00o`00ool0nYX0:?ooool2o`000004o`3jV_ooooooooooool000?o
oooo0_oo0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX00ooooooo0?ZJo`3jVP02oooo
o`07ool00?ooooooooooo`3jV_oooooo0?ZJool0000Mooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o
o`00o`3jV_ooool03_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo00?o0?ZJo`00ool00000
0_l00002o`3jVP;ooooo00?o0?ZJoooooooo00000_l0nYX01ooo003o0?ZJoooooooooooo0?ZJool0
0?l0nYX01?ooool01Ol0nY[oooooooooool00?ooo`0000;ooooo00?oo`00ooooooooool06Oooool0
1ol0nY[ooooooooooooooooo0?ZJool00?l0nYX00_ooool01Ol0nY[oo`00ooooool0nY[o000002Go
oooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`04o`3jV_ooooooooooo`3jVP;ooooo0_l0
nYX00ol00?ooo`00ooooo`02ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?o0?ZJool00?l0nYX0
0_ooool01Ol0nY[oooooo`3jV_oo003o0?ZJ00?ooooo00Oo0?ZJo`000?l0003o0000ool00?l00?oo
0?ZJ00?ooooo0ol000001_oooooo0?ZJoooooooo003o003oo`3jVP?ooooo00?o0?ZJool00?l0nYX0
0_ooool2o`3jVP;ooooo00?o0?ZJool00?l0nYX00oooool00ol0nY[oooooo`3jVP03ool00004oooo
ool00?ooooooo`3jVP;ooooo00?oo`00o`3jV_ooool01Oooool00ooo003o0?ZJooooo`02ooooo`0;
o`3jV_oo003o003oo`00ooooooooo`00ooooool0nY[oooooo`3jV_oo00000_ooool01?l0nY[oo`00
ooooool0nYX3ooooo`03ool00?l0nY[ooooo00?ooooo0_l0nYX00ooo003oooooooooo`02ooooo`03
o`3jV_oooooo0?ZJ00Cooooo00Go0?ZJo`00ool00?ooooooo`3jVP03ooooo`07o`3jV_oo003ooooo
ooooool0nY[oooooool00004ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Go0?ZJool00?oooooo0?ZJ
ooooo`02o`0003gooooo000eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool01?l0003oooooooooool0nYX3ooooo`04o`00oooo003oooooool001Cooooo00Go0?ZJoooo
oooooooo0?ZJool00002ooooo`03ool00?l0nY[ooooo01gooooo00Ko0?ZJool00?l0nY[oooooo`3j
V_oo000Aooooo`;o0?ZJ2oooool01_l0nY[oo`00ooooooooooooo`00o`3jVP?ooooo00Ko0?ZJool0
0?oooooo0?ZJool00?l0nYX6ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_ooool07ooo
ool01ol0nY[oo`00o`3jV_l0nY[oooooool00?l0nYX0:?ooool01ol0003oooooo`3jV_ooooooo`00
o`00oooo00000_ooool2ool000?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool3o`3jVP?ooooo00Wo
003oool00?ooooooooooo`3jV_oooooo0?ZJool00?l0nYX06oooool01?l0nY[oooooool00?l0nYX3
ooooo`03ool00?l0nY[ooooo00kooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`04o`3jV_oo
003oo`00ool000;o0?ZJ0oooool01ol0nY[oooooool00?l0nY[oo`00o`00ool0nYX00_ooool00ol0
nY[o003oool00003ooooo`06o`3jV_ooooooooooo`00ooooooooo`000_ooool00ooo003ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?l0nYX00_ooool01Ol0nY[oooooool0
0?l0nY[o000002Gooooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`04o`3jV_oooooooooo
o`3jVP?ooooo00?o0?ZJo`00oooo00000oooool01?l0nY[oooooool00?l0nYX2ooooo`03o`3jV_oo
003o0?ZJ00;ooooo00Go0?ZJooooool0nY[oo`00o`3jVP03ooooo`07ool00?l00?oo0?ZJo`3jV_oo
ooooo`00o`3jVP03ooooo`?o000000Koooooo`3jV_ooooooo`00o`00ool0nYX3ooooo`03o`3jV_oo
003o0?ZJ00;ooooo0_l0nYX2ooooo`03o`3jV_oo003o0?ZJ00?ooooo0_l0nYX03?l00?ooo`00oooo
oooo003oooooo`00oooooooo0?ZJooooool0nY[oo`00o`3jVPKooooo00?oo`00o`3jV_ooool00_oo
ool3o`000008o`3jV_ooooooo`00ooooool0nY[oooooo`3jV_oo0002ooooo`04o`3jV_oo003ooooo
o`3jVP?ooooo00?oo`00o`3jV_ooool00oooool2o`3jVP03ool00?oooooooooo00;ooooo00?o0?ZJ
ooooool0nYX01?ooool01Ol0nY[oooooo`00ooooooooo`0000?ooooo00So0?ZJool00?oooooooooo
o`3jV_ooooooo`00o`3jVP?ooooo00?o0?ZJool00?l0nYX00_ooool01?l0nY[oo`00ooooool0nYX2
ooooo`03o`3jV_oooooooooo03_ooooo000eooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00001?ooool01?l0003oooooooooool0nYX3ooooo`04o`00oooo003oooooool001Cooooo
00Go0?ZJoooooooooooo0?ZJool00002ooooo`03ool00?l0nY[ooooo01gooooo00Ko0?ZJool00?l0
nY[oooooo`3jV_oo000Aooooo`;o0?ZJ2_ooool01?l0nY[o003oool00?l00?l2ooooo`03ool00?oo
oooooooo00;o0?ZJ00Goo`00o`3jV_l0nY[oooooool00005ooooo`03o`3jV_oooooo000000;o0000
00?oooooool00?l0nYX08?ooool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX0:?ooool02ol0
003oooooo`3jV_ooooooo`00o`00oooo003oooooool00?l0nY[oo`0000?ooooo00Co0?ZJoooooooo
oooo0?ZJ1oooool3o`3jVP?ooooo00Go003oool00?ooooooooooo`3jVP02ooooo`03ool00?l0nY[o
oooo00;ooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`04ooooo`04o`3jV_l0003o
0000o`0000?ooooo00?oo`00o`3jV_ooool03Oooool2o`3jVP?ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oo`00ooooo`02o`3jVPCooooo00Oo0?ZJoooooooo003o0?ZJool00?oooooo0?ZJ00;o
oooo00Co0?ZJoooooooo003o0?ZJ0_ooool01_l0nY[oooooooooool00?ooooooool000;ooooo00?o
o`00ooooooooool06?ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooo0?ZJ00?ooooo00Co
0?ZJool00?l0nY[o00009Oooool01_l0003ooooooooooooooooo0?ZJool000;ooooo00Co0?ZJoooo
oooooooo0?ZJ1?ooool00ol00?ooo`00ooooo`02ooooo`09o`3jV_ooooooo`00ooooool0nY[ooooo
o`3jV_oo003o0?ZJ00;ooooo00Go0?ZJooooool0nY[oo`00o`3jVP03ooooo`03ool00?l0nY[o0?ZJ
00;o0?ZJ00Ooo`00o`3jV_l0nY[oooooo`3jV_ooooooo`0000?ooooo00Co0?ZJool00?l00?oo0?ZJ
0oooool00ol0nY[oo`00o`3jVP02ooooo`;o0?ZJ0_ooool00ol0nY[oo`00o`3jVP02ooooo`?o0?ZJ
0_oo0002ooooo`08ool00?l00?ooooooo`3jV_oooooo0?ZJool00?l0nYX6ooooo`03ool00?l0nY[o
oooo00;ooooo0ol000002?l0nY[oooooool00?oooooo0?ZJooooool0nY[oo`000_ooool01?l0nY[o
o`00ooooool0nYX3ooooo`03ool00?l0nY[ooooo00?ooooo0_l0nYX01Ooo003ooooooooooooooooo
0?ZJ00;ooooo00So0?ZJoooooooooooo003oo`3jV_l00?ooooooo`00o`;oo`000oooool02?l0nY[o
o`00oooooooooooo0?ZJoooooooo003o0?ZJ0oooool00ol0nY[oo`00o`3jVP03ooooo`04o`3jV_oo
003o0?ZJooooo`;o0?ZJ?Oooool003Cooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo
00Co0000oooooooooooo0?ZJ0oooool01?l00?ooo`00oooooooo000Dooooo`05o`3jV_oooooooooo
o`3jV_oo00000_ooool00ooo003o0?ZJooooo`0Mooooo`07o`3jV_oo003o0?ZJooooool0nY[oo`00
o`3jVP0@ooooo`;o0?ZJ2_ooool01?l0nY[oo`00ool00?l00?l2ooooo`06ool00?ooooooooooo`3j
V_l00?ooo`000_l0nYX00oooooooo`00ooooo`04ooooo`03o`3jV_oooooo000000;o000000?ooooo
ool00?l0nYX08?ooool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX0:?ooool02ol0003o0?ZJ
ooooooooooooo`00o`00oooo003oooooool00?l0nY[oo`0000?ooooo00Co0?ZJoooooooooooo0?ZJ
1oooool3o`3jVP;ooooo00?o003oool00?oo00000_ooool01Ol0nY[ooooooooooooo003o0?ZJ00;o
oooo0_l0nYX@ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJo`000?l0003o00000oooool00ooo
003o0?ZJooooo`0;ooooo`?o0?ZJ1?ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo003ooooo
o`3jVPGooooo00?o0?ZJooooool000000_l00002o`3jVP;ooooo00Co0?ZJoooooooo003o0?ZJ0_oo
ool01_l0nY[oooooooooool00?ooooooool000;ooooo00?oo`00o`3jV_ooool06?ooool01?l0nY[o
ooooooooooooool3o`0000Cooooo00Co0?ZJool00?l0nY[o00009Oooool01_l0003ooooooooooooo
oooo0?ZJool000;ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol00?ooo`00ooooo`02ooooo`08
o`3jV_ooooooo`00ooooool0nY[oooooo`3jV_oo0004ooooo`;o0?ZJ00Ooo`00o`3jV_oooooooooo
o`3jV_oo003o0?ZJ00;ooooo00So0?ZJool00?oooooo0?ZJooooool0nY[oooooool000?ooooo00[o
0?ZJool00?l00?oo0?ZJooooool0nY[oooooo`3jV_oo003o0?ZJ0_ooool2o`3jVP;ooooo00?o0?ZJ
ool00?l0nYX00_ooool3o`3jVP0<ool00?oooooooooooooooooo003o003oooooool0nY[oooooo`3j
V_oo003o0?ZJ1_ooool01Ooo003o0?ZJoooooooooooo0?ZJ00?o00000_l0nYX01_oo003oooooo`3j
V_oooooo0?ZJool000;ooooo00Co0?ZJo`00oooo003o0?ZJ0_ooool00ol0nY[oo`00o`3jVP04oooo
o`;o0?ZJ00Goo`00ooooooooooooooooo`3jVP02ooooo`07ool00?ooooooooooo`00ool0nY[o003o
ooooo`03ool000;ooooo00?o0?ZJo`00oooo00000_ooool01?l0nY[oooooool00?l0nYX3ooooo`03
ool00?oooooo0?ZJ00?ooooo00Co0?ZJool00?l0nY[ooooo0_l0nYXmooooo`00=Oooool00ol0003o
ooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool0nYX3ooooo`04o`00oooo003ooooo
ool001Cooooo00Go0?ZJooooooooooooo`00o`3jVP02ooooo`03ool00?l0nY[ooooo01gooooo00Oo
0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ013ooooo0_l0nYX8ooooo`05o`3jV_oooooo0?ZJool0
0?l00?l00_l0nYX01oooooooo`00oooooooooooo0?ZJool00?ooool00_l0nYX00oooooooo`00oooo
o`04ooooo`03o`3jV_oooooo000000;o000000?oooooo`3jV_oo00007oooool02?l0nY[oooooool0
0?l0nY[oooooo`3jV_oo003o0?ZJ:?ooool02ol0003o0?ZJooooooooooooo`00o`00oooo003ooooo
ool00?l0nY[oo`0000?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool3o`3jVP04o`00oooooooo003o
ool000?ooooo00Go0?ZJooooooooooooo`00o`3jVP02ooooo`;o0?ZJ4?ooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooo000000;o00000oooool00ooo003o0?ZJooooo`0;ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool00_ooool01?l0nY[oo`00ooooool0nYX5ooooo`03o`3j
V_l00?oo000000;o000000Wo0?ZJooooooooooooooooo`3jV_ooooooo`00o`3jV_ooool00_l0nYX2
ooooo`03o`00oooo003oo`0000;ooooo00?oo`00o`3jV_ooool06?ooool01?l0nY[oo`00ool00?oo
0003o`0000Cooooo00Co0?ZJool00?l0nY[o00009Oooool01_l0003ooooooooooooooooo0?ZJool0
00;ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol00?ooo`00ooooo`02ooooo`08o`3jV_oooooo
o`00ooooool0nY[oooooo`3jV_oo0004ooooo`?o0?ZJ00Koo`00oooooooooooo0?ZJool00?l0nYX2
ooooo`08o`3jV_oo003oooooo`3jV_oooooo0?ZJoooooooo0003ooooo`0:o`3jV_oo003o003oo`3j
V_oooooo0?ZJooooool0nY[oo`00o`3jVP?ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX2oooo
o`?o0?ZJ00coo`00ooooooooooooooooool00?l00?ooooooo`3jV_oooooo0?ZJool00?l0nYX6oooo
o`07ool00?l0nY[oooooooooool0nY[oo`00o`3jVP02ooooo`07o`3jV_oo003oooooo`3jV_l00?oo
0?ZJool00002ooooo`05o`3jV_ooooooo`00o`3jV_ooool00_l0nYX00ooo003oooooooooo`03oooo
o`;o0?ZJ00Koo`00ooooooooooooooooo`3jV_ooool2ool000;ooooo0_l0nYX2ooooo`03ool00?oo
ooooo`0000;ooooo00?o0?ZJool00?ooool00_ooool01?l0nY[oooooool00?l0nYX2ooooo`04o`3j
V_oo003oooooo`3jVP?ooooo00Co0?ZJool00?l0nY[ooooo0_l0nYXmooooo`00@_ooool01?l0003o
ooooooooool0nYX3ooooo`04o`00oooo003oooooool000Gooooo0_l0nYX=ooooo`05o`3jV_oooooo
ooooool00?l0nYX00_ooool00ol0nY[oo`00ooooo`0Mooooo`07o`3jV_oo003oooooooooool0nY[o
o`00o`3jVP0@ooooo`;o0?ZJ2?ooool01Ol0nY[oooooo`3jV_oo003ooooo00;o0?ZJ00_oooooool0
0?l0nY[oooooo`3jV_oo003oooooo`3jV_oooooo0?ZJool00005ooooo`04o`3jV_ooooooooooool0
00;ooooo00?o0?ZJool00?ooool07?ooool02_l0nY[oooooo`3jV_oo003o003oo`3jV_oooooo0?ZJ
ool00?l0nYXXooooo`0;o`000?l0nY[ooooooooooooo003o003oool00?ooooooo`00o`3jV_oo0000
0oooool01?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ0_oo00000ol00?ooo`00ool00003ooooo`05
o`3jV_ooooooooooool00?l0nYX00_ooool2o`3jVPoooooo0_l0nYX5ooooo`04o`3jV_oooooo003o
ool000Cooooo00?oo`00o`3jV_ooool02oooool00ol0nY[oooooooooo`04ooooo`09o`3jV_oooooo
ooooooooool0nY[oooooool00?oooooo0?ZJ00Gooooo00?o003oo`3jV_l000000_l000002_l0nY[o
oooooooooooooooo0?ZJoooooooo003o0?ZJooooool0nYX3ooooo`;oo`0000Go0?ZJoooooooooooo
o`00o`3jVP0Iooooo`04o`3jV_oo003o003oo`00o`?o00001?ooool01?l0nY[oo`00o`3jV_l0000U
ooooo`06o`000?ooooooooooooooool0nY[oo`000_ooool01?l0nY[oooooooooool0nYX4ooooo`03
o`00oooo003ooooo00;ooooo00So0?ZJoooooooo003oooooo`3jV_ooooooo`00o`3jVPCooooo0ol0
nYX01_oo003oooooooooool0nY[oo`00o`3jVP;ooooo00?o0?ZJool00?ooool00ol0nYX00ol00?oo
o`00ooooo`02ooooo`03o`3jV_oo003ooooo00?o0?ZJ00?oooooool00?l0nYX01?ooool01_l0nY[o
ooooooooool0nY[oo`00o`3jVP;ooooo0_l0nYX00ooo003oooooooooo`03ooooo`06ool00?oooooo
0?ZJooooool0nY[oo`001oooool01ooo003o0?ZJoooooooooooo0?ZJool00?l0nYX00_ooool00ol0
nY[oo`00ooooo`03o`3jVP08ool00?ooooooooooo`3jV_ooooooo`00o`3jV_ooool2o`3jVP03ool0
0?oooooooooo00?ooooo0_l0nYX01_oo003ooooooooooooooooo0?ZJo`00o`;oo`000ol0nYX2oooo
o`;oo`0000Ko003oool00?ooooooooooo`3jV_oo0003ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo
00?o0?ZJool00?l0nYX01?ooool01?l0nY[oo`00o`3jV_ooool2o`3jVSgooooo0012ooooo`04o`00
0?ooooooooooo`3jVP;ooooo00Go003ooooooooo003oooooool00005ooooo`;o0?ZJ3Oooool01?l0
nY[ooooooooooooo0003ooooo`03o`3jV_oo003ooooo01gooooo00Ooo`00o`3jV_ooooooooooo`3j
V_oo003o0?ZJ00oooooo0ol0nYX7ooooo`;o0?ZJ017oooooo`3jV_oo003oooooo`3jV_oooooo0?ZJ
ool00?l0nY[oooooo`3jV_oo003oooooo`3jV_oooooo0?ZJool00005ooooo`04o`3jV_oooooo003o
ool000;ooooo00?o0?ZJool00?ooool07?ooool02_l0nY[oooooo`3jV_oo003oooooo`3jV_oooooo
0?ZJool00?l0nYXXooooo`04o`000?l0nY[oooooool000;o003o00Goo`00oooooooo003o0?ZJool0
0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX4ool000Cooooo00Ko0?ZJoooooooooooo
o`00o`3jV_ooool3o`3jVPoooooo0_l0nYX4ooooo`05o`3jV_l00?oo003ooooooooo00001?ooool0
0ooo003o0?ZJooooo`0;ooooo`03o`3jV_oooooooooo00Cooooo00Wo0?ZJooooooooooooooooo`3j
V_oo003o003oooooool0nYX01_ooool00ol0nY[o003oool00006ooooo`03o`3jV_oo003o0?ZJ00;o
0?ZJ0oooool00ooo003oooooo`3jVP02ooooo`03ool00?l0nY[ooooo01Sooooo00?o0?ZJool00?l0
0?l00_l00?l00ol0nY[oooooooooo`03ooooo`04o`3jV_oo003o0?ZJo`0002Gooooo00Ko0000oooo
ooooooooooooo`3jV_oo0002ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o003oool00?ooool0
0oooool01ol0nY[oo`00ooooool0nY[oooooool00?l0nYX01?ooool3o`3jVP06ool00?oooooooooo
o`3jV_oo003o0?ZJ0_ooool02?l0nY[oo`00o`00oooooooo0?ZJoooooooo003o0?ZJ0oooool00ol0
nY[oo`00ooooo`03o`3jVP03oooooooo003o0?ZJ00Cooooo00Ko0?ZJoooooooooooo0?ZJool00?l0
nYX2ooooo`;o0?ZJ00?oo`00ooooooooool00oooool01_oo003oooooo`3jV_ooooooo`00o`3jVPOo
oooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ00;ooooo00?o0?ZJoooooooo00000_l0nYX0
3?oo003o0?ZJoooooooooooo0?ZJoooooooo003o0?ZJooooool0nY[oo`00o`3jVPGooooo0_l0nYX0
1_oo003ooooooooooooooooo0?ZJool000?o00000_l00?l2ooooo`04ool00?oooooo003oool000;o
oooo00?o0?ZJool00?ooool00ol0nYX00oooooooo`00o`3jVP02ooooo`03o`3jV_oo003o0?ZJ00Co
oooo00Co0?ZJool00?l0nY[ooooo0_l0000mooooo`00@_ooool01?l0003oooooooooool0nYX2oooo
o`05o`00ooooooooo`00oooooooo00001Oooool2o`3jVPcooooo00?o0?ZJooooooooool00ol00002
ooooo`03o`3jV_oo003o0?ZJ01gooooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ00oooooo
00?o0?ZJooooool0nYX01oooool3o`3jVP;oo`0000Go0?ZJooooool00?oo0?ZJool00002o`3jVP07
o`00oooo003oooooo`3jV_oooooo0?ZJool00005ooooo`04o`3jV_oooooo003oool000;ooooo00?o
0?ZJool00?ooool06oooool2o`3jVP04ooooool0nY[oo`00o`3jVP;ooooo00?o0?ZJool00?l0nYX0
:?ooool01?l0003o0?ZJoooooooo0002o`00o`05ool00?ooooooo`00o`3jV_oo00000oooool01?l0
nY[oooooooooool0nYX7ooooo`;o0?ZJ00?oo`00ooooool00?l01?ooool01Ol0nY[ooooooooooooo
ooooo`0000?o0?ZJ00?oooooo`3jV_ooool03_ooool2o`3jVP;ooooo0ol0nYX01?l00?oooooooooo
oooo0004ooooo`03ool00?l0nY[ooooo00_ooooo00?o0?ZJooooooooool01?ooool02Ol0nY[ooooo
oooooooooooo0?ZJool00?l00?ooooooo`3jVP06ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Co0?ZJ
ool00?l0nY[o0?ZJ0_ooool01Ol00?ooo`00ool00?oooooo0?ZJ00;ooooo00?oo`00o`3jV_ooool0
6?ooool00ol0nY[oo`00ooooo`02o`00o`03o`3jV_oooooooooo00?ooooo00Co0?ZJool00?l0nY[o
00009Oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?o0?ZJoooo
ooooool00_ooool00ol00?ooo`00ooooo`03ooooo`07o`3jV_oo003oooooo`3jV_ooooooo`00o`3j
VP04ooooo`?o0?ZJ00Koo`00oooooooooooo0?ZJool00?l0nYX3ooooo`03o`3jV_oo003ooooo00;o
oooo00?oo`00o`3jV_ooool00_ooool00ol0nY[oooooool00003o`3jVP03oooooooo003o0?ZJ00Co
oooo00Ko0?ZJooooooooooooooooool00?l0nYX2ooooo`03o`3jV_oo003oo`0000?o0?ZJ0_ooool0
1_oo003oooooo`3jV_ooooooo`00o`3jVPOooooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ
00;ooooo00Oo0?ZJoooooooo003oooooo`3jV_oo003o0?ZJ00;ooooo00So0?ZJoooooooo003o0?ZJ
ooooool0nY[oo`00o`3jVPGooooo0_l0nYX01_oo003ooooooooooooooooo0?ZJool000?o000000So
003oooooooooooooooooool00?oooooo003oool000;ooooo00?o0?ZJool00?l0nYX00ol0nYX00ooo
ooooo`00o`3jVP02ooooo`03o`3jV_oo003o0?ZJ00Cooooo00Co0?ZJool00?l0nY[ooooo0_l0000m
ooooo`00@_ooool00ol0003oooooo`3jVP03ooooo`05o`00ooooooooo`00oooooooo00001Oooool2
o`3jVPcooooo00?o0?ZJooooooooool00ol00002ooooo`03o`3jV_oo003o0?ZJ01cooooo00?o0?ZJ
ool00?l0nYX00_ooool00ol0nY[oo`00o`3jVP0?ooooo`03o`3jV_oooooo0?ZJ00Oooooo0ol0nYX0
1ooo003oooooo`3jV_oooooo003oo`3jV_oo00000_l0nYX00ol00?ooo`00o`3jVP02ooooo`?o0000
0oooool01Ol0nY[oooooooooool00?ooo`0000;ooooo00?o0?ZJool00?ooool06oooool2o`3jVP04
ooooool0nY[oo`00o`3jVP;ooooo00?o0?ZJool00?l0nYX0:?ooool02ol0nY[o003oool00?oo003o
003ooooooooo003oooooool00?l0nY[oo`0000;ooooo00Go0?ZJooooooooooooooooo`3jVP07oooo
o`;o0?ZJ00?oo`00ooooooooool01?ooool01ol0nY[oooooooooooooooooo`00ooooool0nYX00_oo
ool00ol0nY[oooooooooo`04ooooo`?o0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Co
003oooooooooooooo`001?ooool00ooo003o003oo`3jVP0:ooooo`03o`3jV_l00?oooooo00Cooooo
0_oo0003ooooo`05o`3jV_oo003o003oooooool0nYX01_ooool00ol0nY[oooooo`3jVP06ooooo`04
o`3jV_oo003o0?ZJo`3jVP;ooooo0_oo0002ooooo`05o`3jV_ooooooooooool00?l0nYX06Oooool0
0ol0nY[oo`00ooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJool00?l0nY[o00009Ooo
ool00ol0003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00Co0?ZJoooooooooooo
oooo0_l00?l00ooo003oooooooooo`02ooooo`07o`3jV_oo003oooooo`3jV_ooooooo`00o`3jVP04
ooooo`?o0?ZJ00Goo`00oooooooooooo0?ZJool00004ooooo`03o`3jV_oo003ooooo00;ooooo00?o
o`00o`3jV_ooool00_ooool00ol0nY[oooooool00004o`3jVP03ool00?l0nY[ooooo00?ooooo00Ko
0?ZJooooooooooooooooool00?l0nYX2ooooo`06o`3jV_oo003oo`00o`3jV_oooooo0?ZJ0_ooool0
1_oo003oooooo`3jV_ooooooo`00o`3jVPOooooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ
00;ooooo00Oo0?ZJoooooooo003oooooo`00oooo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX00_l0
nYX00ooo003o0?ZJooooo`04ooooo`;o0?ZJ00Koo`00ooooooooooooooooo`3jV_oo0003o`000004
o`00ooooooooooooool000;ooooo00Oo003oool00?oooooo0?ZJo`00oooo003o0?ZJ00;ooooo00Co
0?ZJooooool0nY[oo`000_ooool00ol0nY[oo`00o`3jVP04ooooo`04o`3jV_oo003o0?ZJooooo`;o
0000?Oooool004;ooooo00?o0000ooooool0nYX00oooool01Ol00?ooooooool00?ooooooo`0000Co
oooo00?o0?ZJooooool0nYX03?ooool00ol0nY[oooooooooo`03o`0000;ooooo00?o0?ZJool00?l0
nYX06oooool2o`3jVP07ool00?l0nY[oooooooooool0nY[oo`00o`3jVP0?ooooo`03o`3jV_oooooo
0?ZJ00Oooooo0ol0nYX01ooo003oooooo`3jV_oooooo003oo`3jV_oo00000_l0nYX00ooo003ooooo
o`3jVP02ooooo`?o00000oooool01Ol0nY[oooooooooool00?ooo`0000;ooooo00?o0?ZJool00?oo
ool06oooool3o`3jVP03ool00?oooooo0?ZJ00;ooooo00?o0?ZJo`000?oo00008_ooool2o`0000Co
oooo00?o0?ZJo`00oooo00000_l00?l01_ooooooo`00oooooooo003o0?ZJool000;ooooo00Go0?ZJ
ooooooooooooooooo`3jVP07ooooo`;o0?ZJ00?oo`00ooooooooool01?ooool01Ol0nY[ooooooooo
ooooooooo`0000Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP06ooooo`;o0?ZJ
00?oooooo`3jV_l00?l00ol00?l2ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJool00?l0nYX0
2_ooool00ol0nY[oo`00ool00004ool00003oooooooo003ooooo00;ooooo00?o0?ZJool00?l00?l0
0_l0nYX6ooooo`03o`3jV_oooooo0?ZJ00Kooooo0ol000001?oooooo003oool00?oo0003ooooo`05
o`3jV_ooooooooooool00?l0nYX06Oooool00ol0nY[oo`00ooooo`02ooooo`03o`3jV_oooooooooo
00?ooooo00Co0?ZJool00?l0nY[o00005oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooo
oooo00;ooooo00Co0?ZJool00?oooooo0?ZJ0_ooool01ol0nY[ooooooooooooooooo003ooooooooo
00001?ooool01ol0nY[oo`00o`00ool0nY[oooooool00?l0nYX01?ooool3o`3jVP05ool00?oooooo
ooooo`3jV_oo00001?ooool00ol0nY[oo`00ooooo`02ooooo`03ool00?l0nY[ooooo00;ooooo00?o
0?ZJoooooooo00001?l0nYX00ooo003o0?ZJooooo`03ooooo`0:o`3jV_oooooooooooooooooo003o
0?ZJooooool0nY[oooooool000;o0?ZJ00[oooooo`3jV_l0nY[oooooo`00oooo003o0?ZJoooooooo
003o0?ZJ1oooool01ooo003o0?ZJoooooooooooo0?ZJool00?l0nYX00_ooool01ol00?oo0?ZJool0
0?l00?ooooooool00?l0nYX00oooool00ol0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo00Co
oooo0_l0nYX01?oo003oooooooooooooool2ool00004ooooool0nY[oo`00ool000;ooooo00[oo`00
ooooooooooooooooool00?oooooo0?ZJool00?oooooo0?ZJ0_ooool01?l0nY[oooooo`3jV_oo0002
ooooo`03o`3jV_oo003o0?ZJ00Cooooo00Ko0?ZJool00?l0nY[oooooo`3jV_oo000mooooo`00@_oo
ool00ol0003oooooo`3jVP03ooooo`05o`00ooooooooo`00oooooooo00001?ooool00ol0nY[ooooo
o`3jVP0<ooooo`05o`3jV_ooooooooooool00?l0nYX00oooool00ol0nY[oo`00o`3jVP0Kooooo`;o
0?ZJ00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ00oooooo00?o0?ZJooooool0nYX01oooool3
o`3jVP0<ool00?l0nY[oooooooooool00?oo0?ZJool00?l0nY[oooooool00?oooooo0?ZJ0_ooool3
o`0000?ooooo00Go0?ZJooooool00?oo003oool00003ooooo`03ool00?oooooooooo01[ooooo0ol0
nYX00ooo003oooooo`3jVP02ooooo`03o`3jV_ooooooo`00027ooooo00Co0000oooooooooooo0000
0oooool2o`000009o`00oooooooooooooooooooo003oooooool00?l0nY[oo`0000;ooooo00Go0?ZJ
oooooooooooo003oo`3jVP07ooooo`;o0?ZJ00?oo`00o`3jV_ooool01?ooool01Ol0nY[ooooooooo
ooooooooo`0000Cooooo00?o0?ZJooooooooool00oooool2o`3jVP03ooooool0nY[ooooo00Gooooo
0_l0nYX00ooooooo0?ZJo`00o`02o`00o`?ooooo00?oo`00ooooooooool00_ooool00ol0nY[oo`00
o`3jVP0:ooooo`03o`3jV_oo003o003o00Gooooo00Koo`00ooooooooooooooooo`3jV_oo0003o`3j
VPKooooo00?o0?ZJooooool0nYX01_ooool3o`000003o`00oooo003oo`0000Cooooo00Go0?ZJoooo
ooooooooo`00o`3jVP0Iooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJooooooooool00oooool0
1?l0nY[oo`00o`3jV_l0000Fooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ0_ooool01ol0
nY[ooooooooooooooooo003oool00?l0nYX01?ooool01ol0nY[oo`00o`00ool0nY[oooooool00?l0
nYX01?ooool2o`3jVP06oooooooo003ooooooooooooo003o0?ZJ1?ooool01ol0nY[oo`00oooooooo
oooo003oool00?l0nYX01?ooool01?l0nY[oo`00o`00ooooool2o`3jVP03ool00?l0nY[ooooo00?o
oooo00So0?ZJooooooooooooooooool00?l0nY[oooooo`3jVP?o00000oooool01?l0nY[oooooo`00
oooo0002o`3jVP03ool00?l0nY[ooooo00Kooooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ
00?ooooo00Ko0?ZJool00?l00?ooooooool00?l0nYX3ooooo`03o`3jV_oo003ooooo00;o0?ZJ00?o
o`00ooooooooool01?ooool2o`3jVP05ool00?oooooooooooooooooo00000_ooool2o`3jVP?oo`00
1?ooool01_oo003oooooo`3jV_oo003oooooo`3jVP;ooooo00Co0?ZJooooool0nY[oo`000_ooool0
0ol0nY[oo`00ooooo`04ooooo`06o`3jV_oo003o0?ZJooooool0nY[oo`00?Oooool004;ooooo00?o
0000ooooool0nYX00_ooool01ooo003o003ooooooooo003oooooool00?l0nYX00oooool00ol0nY[o
ooooo`3jVP0;ooooo`;o0?ZJ0_ooool00ooo003o0?ZJooooo`02ooooo`03o`3jV_oo003o0?ZJ01_o
oooo0_l0nYX01ooo003ooooooooooooooooo0?ZJool00?l0nYX03_ooool01?l0nY[oooooooooool0
nYX6ooooo`06o`3jV_oooooo0?ZJool00?oooooo0?ZJ0_ooool00ol00?oo0?ZJooooo`03ool00004
ooooool0nY[oooooooooo`;o0?ZJ00?oo`00ooooooooool00_l0nYX01?oooooo003oo`00oooo0003
ooooo`03ool00?oooooooooo01[ooooo0ol0nYX00ooo003oooooo`3jVP02ooooo`03o`3jV_l0003o
0000027ooooo00Co0000oooooooooooo00000oooool2o`0000Cooooo00Goo`00oooooooo003o0?ZJ
ool00002ooooo`05o`3jV_ooooooooooo`00ool0nYX01oooool2o`3jVP03ool00?l0nY[ooooo00Co
oooo00Ko0?ZJooooooooooooooooo`3jV_oo0003ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJ
oooooooooooo0?ZJ1_ooool2o`3jVP03ooooool0nY[o003o00Gooooo00?oo`00ooooooooool00_oo
ool00ol0nY[oo`00o`3jVP0:ooooo`03o`3jV_oo003o003o00Gooooo00Ooo`00oooooooooooooooo
o`3jV_oo003o0?ZJ00Sooooo00?o0?ZJooooool0nYX01_ooool3o`0000;oo`001Oooool01Ol0nY[o
oooooooooooo003o0?ZJ01Wooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`03oooo
o`04o`3jV_l0003o0000o`0001[ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`02ooooo`;o00000oooool01_l0nY[oo`00ooooool0nY[oooooo`3jVPCooooo00?o003oool00?l0
nYX01?ooool01_l0nY[oo`00o`00ool0nY[oooooool000Gooooo0_l0nYX01_ooooooo`00oooooooo
ooooo`00o`3jVPCooooo00Oo0?ZJool00?ooooooooooool00?oooooo0?ZJ00Cooooo00Co0?ZJool0
0?l00?oooooo0_l0nYX00ooo003oooooooooo`03ooooo`08o`3jV_oooooooooooooooooo003o0?ZJ
ooooool0nYX3o`0000?ooooo00?o0?ZJooooool00?l00_oo00000ol0nY[oo`00ooooo`07ooooo`07
ool00?l0nY[oooooo`3jV_oo003o003oo`3jVP03ooooo`06o`3jV_oo003o003ooooooooo003o0?ZJ
0oooool01_l0nY[oo`00oooooooooooo0?ZJool000Kooooo0_l0nYX01Ooo003oooooooooool0nY[o
o`0000;ooooo0_l0nYX00oooooooo`00ool00003ooooo`?o000000?o0?ZJool00?l0nYX00oooool0
1?l0nY[oooooo`3jV_oo0002ooooo`03ool00?l0nY[ooooo00Cooooo00Ko0?ZJool00?l0nY[ooooo
o`3jV_oo000mooooo`00@_ooool00ol0003oooooo`3jVP02ooooo`;oo`0000Goooooool00?oooooo
o`00o`3jVP03ooooo`03o`3jV_oooooo0?ZJ00_ooooo00Ko0?ZJooooooooooooo`00o`00ool0nYX4
ooooo`03ool00?l0nY[ooooo01Wooooo00Co0?ZJoooooooo003o0?ZJ0oooool00ol0nY[oo`00o`3j
VP0>ooooo`04o`3jV_ooooooooooo`3jVPKooooo00Ko0?ZJooooool0nY[oo`00ooooool0nYX3oooo
o`05o`00ool0nY[oo`00ool00?l00?l00_l0nYX2ooooo`;o0?ZJ00Coo`00o`3jV_oooooo0?ZJ0_oo
ool00ol00?ooooooool00003ooooo`03ool00?oooooooooo01Wooooo00?o0?ZJooooool0nYX00_oo
00001Ol0nY[ooooooooooooooooo0?ZJ00;o00008Oooool01?l0003oooooooooool00003ooooo`;o
00001?ooool01Ooo003oooooool00?l0nY[oo`0000;ooooo00Go0?ZJoooooooooooo003oo`3jVP06
ooooo`06o`3jV_ooooooo`00o`3jV_oooooo0?ZJ1?ooool01_l0nY[ooooooooooooooooo0?ZJool0
00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool0nYX6ooooo`?o0?ZJ0_l00?l5
ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJool00?l0nYX02_ooool01?oo003oooooo`00ool0
0?l4ooooo`07ool00?ooooooooooooooool0nY[oo`00o`3jVP08ooooo`03o`3jV_oooooo0?ZJ00Ko
oooo00Co0?ZJooooool0nY[o003o1_ooool01Ol0nY[ooooooooooooo003o0?ZJ013ooooo0ol0nYX6
ooooo`06ool00?oooooo0?ZJo`3jV_oooooo0?ZJ1Oooool01?l0nY[o0000o`000?l0000Hooooo`;o
00000oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00Ko0?ZJool0
0?oooooo0?ZJooooool0nYX4ooooo`03o`00oooo003o0?ZJ00Cooooo00?o0?ZJool00?l00?l00_l0
nYX00ooo003oooooooooo`03ooooo`;o0?ZJ00Koooooool00?oooooo0?ZJool00?l0nYX4ooooo`07
o`3jV_oo003o003ooooooooo003oooooo`3jVP04ooooo`04o`3jV_oo003o003oooooo`;o0?ZJ00?o
o`00ooooooooool00oooool02?l0nY[oooooooooooooooooo`00o`3jV_oooooo0?ZJ0ol00003oooo
o`07o`3jV_ooooooooooo`00oooo003o0?ZJool00008ooooo`05o`3jV_oo003oooooo`3jV_oo0000
0_l0nYX3ooooo`05o`3jV_oo003o003ooooooooo00001?ooool01_l0nY[oo`00oooooooooooo0?ZJ
ool000Kooooo0_l0nYX01Ooo003oooooooooool0nY[oo`0000;ooooo0_l0nYX6ooooo`?o000000?o
003oool00?l0nYX00oooool01?l0nY[oooooo`3jV_oo0002ooooo`03ool00?l0nY[ooooo00Cooooo
00Ko0?ZJool00?oooooo0?ZJo`00oooo000mooooo`00@_ooool00ol0003oooooo`3jVP02ooooo`;o
o`0000Goooooool00?ooooooo`00o`3jVP03ooooo`03o`3jV_oooooo0?ZJ00_ooooo00Ko0?ZJoooo
ooooooooo`00o`00ool0nYX4ooooo`03ool00?oooooo0?ZJ00;o0?ZJ5oooool3o`000007o`3jV_oo
ooooooooooooool0nY[oo`00o`3jVP0>ooooo`04o`3jV_ooooooooooo`3jVPKooooo00Go0?ZJoooo
ool0nY[oo`00o`3jVP04ooooo`?o000000?oo`00o`00ool0nYX00oooool2o`3jVP04ool00?l0nY[o
0?ZJo`3jVP;ooooo00?o003ooooooooo00000oooool00ooo003o0?ZJooooo`0Iooooo`06o`3jV_oo
oooo0?ZJool00?l00?oo0?ZJ0oooool00ol0nY[o0000o`00000Qooooo`04o`000?ooooooooooo`00
00?ooooo0_l0nYX4ooooo`05ool00?ooooooo`00o`3jV_oo00000_ooool01?l0nY[oooooo`00ool0
0?l4o`3jVP?ooooo00Go0?ZJoooooooo003o0?ZJooooo`02o`3jVP?ooooo00Ko0?ZJoooooooooooo
ooooo`3jV_oo0003ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool0
1?l0nY[oooooo`3jV_l0nYX2ool000Gooooo00?oo`00ooooooooool00_ooool01?l0nY[oo`00o`3j
V_l0nYX9ooooo`04ool00?oooooo003oo`00o`Cooooo00Ooo`00ooooooooooooooooo`3jV_oo003o
0?ZJ00Wooooo0_l0nYX6ooooo`04o`3jV_oooooo0?ZJo`00o`Kooooo00Go0?ZJoooooooooooo0?ZJ
ool0000@ooooo`04o`3jV_oooooo0?ZJo`3jVPGooooo00?oo`00o`3jV_l0nYX00ol0nYX5ooooo`04
o`3jV_l0003o0000o`0001[ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00Ko0?ZJool00?oooooo0?ZJooooool0nYX4ooooo`03ool0
0?oooooo0?ZJ00Cooooo00?o0?ZJool00?l00?l00_l0nYX00ooo003oooooooooo`03ooooo`;o0?ZJ
00Koooooool00?oooooo0?ZJool00?l0nYX4ooooo`07o`3jV_ooooooo`00o`00oooo003oooooo`3j
VP04ooooo`07o`3jV_oo003o003oooooool0nY[oo`00o`3jVP05ooooo`0:o`3jV_oooooooooooooo
oooo003o0?ZJooooool0nY[oo`00o`3jVPCooooo00Oo0?ZJoooooooooooo003oool00?l0nY[oo`00
00Sooooo00Ko0?ZJool00?oooooo0?ZJool00?l0nYX4ooooo`05o`3jV_l00?ooo`00oooooooo0000
1?ooool01_l0nY[oo`00ooooooooooooo`00o`3jVPKooooo0_l0nYX01Ooo003oooooooooool0nY[o
o`0000;ooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[o0000o`000?l00002ool00003o`3jV_oo
oooooooo00?ooooo00Ko0?ZJool00?ooooooooooool00?l0nYX5ooooo`06o`3jV_oo003oooooo`3j
V_l00?ooo`00?Oooool004;ooooo00co0000ooooool0nY[oooooool00?l00?ooo`00oooooooo003o
ooooool00?l0nYX3ooooo`03o`3jV_oooooo0?ZJ00_ooooo00Ko0?ZJoooooooo003oo`00o`00ool0
nYX4ooooo`03ool00?oooooo0?ZJ00;o0?ZJ5oooool3o`000003o`3jV_oooooooooo00;ooooo00?o
o`00o`3jV_ooool03?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00Go0?ZJoooooooo003o
ooooo`3jVP04ooooo`?o00000_ooool01?l0nY[oooooooooooooool2o`3jVP03ool00?l0nY[o0?ZJ
00?ooooo00?o003ooooooooo00000oooool00ooo003o0?ZJooooo`0Iooooo`06o`3jV_l0003o0000
o`000?oooooo0?ZJ1?ooool2o`3jVR7ooooo00Co0000oooooooooooo00000oooool00ol0003o0?ZJ
ooooo`03ooooo`05ool00?ooooooo`00o`3jV_oo00000_ooool00ol0nY[oooooo`00o`03o`000003
ooooool0nY[ooooo00;ooooo00Co0?ZJoooooooo003o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo
0?ZJ00?ooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oooooo
ooooooooool0nYX01Oooool01ol0nY[oooooo`3jV_l0nY[oo`00oooooooo00001?ooool00ooo003o
ooooooooo`02ooooo`04o`3jV_oo003o003oo`3jVPSooooo00Go0?ZJool00?l0nY[o0?ZJo`00o`04
ooooo`07ool00?ooooooooooooooool0nY[oo`00o`3jVP09ooooo`;o0?ZJ1_ooool01?l0nY[ooooo
o`3jV_l0nYX6ooooo`05o`3jV_ooooooooooo`3jV_oo00003oooool01?l0nY[oooooooooooooool2
o`3jVPCooooo00Coo`00o`3jV_oooooooooo0_l0nYX5ooooo`04o`3jV_oooooo0?ZJo`0001Kooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooo
ooooool00_ooool01_l0nY[oo`00ooooool0nY[oooooo`3jVPCooooo00?oo`00ooooool0nYX01?oo
ool00ol0nY[oooooool00002o`3jVP03ool00?oooooooooo00?ooooo0_l0nYX01_ooooooo`00o`3j
V_l0nY[oo`00o`3jVPCooooo00Oo0?ZJoooooooo003o003oool00?oooooo0?ZJ00Cooooo00Oo0?ZJ
ool00?l00?ooooooo`3jV_oo003o0?ZJ00Gooooo00[o0?ZJooooooooooooooooool00?l0nY[ooooo
o`3jV_oo003o0?ZJ1Oooool01_l0nY[oooooo`00oooo003o0?ZJool000Sooooo00Ko0?ZJool00?oo
oooo0?ZJool00?l0nYX4ooooo`05o`3jV_l00?ooo`00oooooooo00001?ooool01_l0nY[o003oool0
0?ooooooo`00o`3jVPKooooo0_l0nYX01Ooo003oooooooooool0nY[oo`0000;ooooo00?o0?ZJoooo
ool0nYX00oooool2o`3jVP06oooooooo003o003oool00?oooooo0?ZJ1Oooool01_l0nY[oo`00oooo
ooooooooo`00o`3jVPGooooo00Ko0?ZJo`00oooo003o0?ZJo`00oooo000mooooo`00@_ooool03?l0
003o0?ZJooooooooooooo`00o`00oooo003oooooool00?ooooooo`00o`3jVP?ooooo00?o0?ZJoooo
ool0nYX02oooool00ol0nY[oooooool00002o`00o`03o`3jV_oooooooooo00;ooooo00Goo`00oooo
ooooooooooooo`3jVP0Fooooo`05o`3jV_l0003o0000o`000?l0nYX01?ooool00ooo003o003oo`3j
VP0<ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01?l0nY[o0000o`000?l00005ooooo`?o
000000?oooooo`3jV_l0nYX01?ooool00ol0nY[oo`00o`00o`03ooooo`;o003o0_oo0003ooooo`03
ool00?l0nY[ooooo01Wooooo00Go0?ZJo`000?l0003o0000o`3jVP05ooooo`;o0?ZJ8_ooool2o`00
00Cooooo00?o0000o`3jV_ooool00oooool01Ooo003oooooool00?l0nY[oo`0000;ooooo00?o0?ZJ
o`00ooooool00ol00002ooooo`06o`3jV_ooooooooooo`3jV_ooooooo`000oooool2o`3jVP;ooooo
00Ko0?ZJooooooooooooooooo`3jV_oo0003ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJoooo
ooooooooooooo`3jVP05ooooo`05o`3jV_ooooooo`00o`3jV_oo00000_ooool01Ooo003ooooooooo
ooooooooo`0000Cooooo00Co0?ZJool00?l00?oo0?ZJ2?ooool00ol0nY[oo`00o`3jVP02o`3jVP05
o`00oooooooooooooooooooo00000oooool00ol0nY[oo`00o`3jVP09ooooo`;o0?ZJ1_ooool00ol0
nY[oooooo`3jVP02o`3jVPGooooo00Go0?ZJoooooooooooo0?ZJool00009ooooo`Co0?ZJ0_ooool0
0ol0nY[o003oooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Coo`00o`3jV_oooooooooo0_l0
nYX5ooooo`04o`3jV_oooooo0?ZJo`0001Oooooo0ol00004ooooo`;o00001Oooool00ol0003ooooo
ooooo`02ooooo`06o`3jV_oo003oooooo`3jV_oooooo0?ZJ0oooool01?oo003o003oooooool0nYX4
ooooo`03o`3jV_ooooooo`0000;o0?ZJ00?oo`00ooooooooool00oooool2o`3jVP06oooooooo003o
0?ZJo`3jV_oo003o0?ZJ1Oooool01?l0nY[oo`00ool00?ooool2o`3jVPCooooo00Oo0?ZJool00?l0
0?ooooooo`3jV_oo003o0?ZJ00Wooooo00Koo`00o`3jV_oooooo0?ZJool00?l0nYX5ooooo`03o`3j
V_oooooo003o00;oo`0000?o0?ZJooooooooool01_ooool01_l0nY[oo`00ooooool0nY[oo`00o`3j
VPCooooo00Go0?ZJo`00oooo003oooooool00004ooooo`03o`3jV_ooooooo`0000?o00001_ooool2
o`3jVP05ool00?ooooooooooo`3jV_oo00000_ooool00ol0nY[oooooo`3jVP03ooooo`04o`3jV_oo
ooooooooo`3jVP;oo`0000?o0?ZJooooooooool01?ooool01_l0nY[oo`00o`3jV_l0nY[oo`00o`3j
VPGooooo00Ko0?ZJoooooooo003oooooool00?l0nYXmooooo`00@_ooool03?l0003o0?ZJoooooooo
ooooo`00o`00oooo003oooooool00?ooooooo`00o`3jVP?ooooo00?o0?ZJooooool0nYX02_ooool0
1ol0nY[ooooooooooooo003o003oooooool0nYX01?ooool01Ol0nY[oo`00oooooooooooo0?ZJ01Ko
oooo00Co0?ZJo`00ool00?ooo`001Oooool00ol0nY[oo`00o`3jVP0<ooooo`05o`3jV_oooooooooo
ooooool0nYX01_ooool01?l0nY[o0000o`000?l00006ooooo`Co0?ZJ1Oooool2o`3jVP08ool00?l0
0?ooooooooooool00?ooooooool00?l0nYX3ooooo`03ool00?l0nY[ooooo01Wooooo00Go0?ZJo`00
0?l0003o0000o`3jVP05ooooo`;o0?ZJ:?ooool00ol0003o0?ZJooooo`03ooooo`05ool00?oooooo
o`00o`3jV_oo00000_ooool00ol0nY[o003oooooo`03o`0000;ooooo00Ko0?ZJoooooooooooo0?ZJ
oooooooo0004ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJoooooooo00000_oo00000ol0
nY[oooooooooo`02ooooo`05o`3jV_ooooooooooo`00ool0nYX01Oooool01?l0nY[oooooool00?oo
0003ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`04o`3jV_oo003o003oo`3jVPSooooo
00Go0?ZJool00?ooooooooooo`3jVP03o`00o`03oooooooo003ooooo00;ooooo00?o0?ZJool00?l0
nYX02Oooool2o`3jVPKooooo00Co0?ZJooooool0nY[ooooo0_l0nYX4ooooo`05o`3jV_oooooooooo
o`3jV_oo00002?ooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJ0ol00?l00ooooooo0?ZJoooo
o`03ooooo`03ool00?l0nY[ooooo00Sooooo00Co0?ZJooooool0nY[o00009Oooool00ol0003ooooo
ooooo`02ooooo`07o`3jV_oo003oooooo`3jV_oooooo0?ZJo`00o`02ooooo`04ool00?l00?oooooo
o`3jVPCooooo00?o0?ZJoooooooo00000_l0nYX00ooo003oooooooooo`03ooooo`;o0?ZJ00Kooooo
ool00?l0nY[o0?ZJool00?l0nYX5ooooo`05o`3jV_oo003oo`00ooooool0nYX01Oooool01ol0nY[o
o`00o`00oooooooo0?ZJool00?l0nYX02Oooool01_oo003o0?ZJooooool0nY[oo`00o`3jVPGooooo
00?o0?ZJooooool00?l00_oo00000ol0nY[oooooooooo`06ooooo`06o`3jV_oo003oooooo`3jV_oo
003o0?ZJ1?ooool00ol0nY[oooooool00002ool000Cooooo00?o0?ZJoooooooo00000ol00006oooo
o`;o0?ZJ00Goo`00oooooooooooo0?ZJool00003o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ0_oo
ool01?l0nY[oo`00ooooool0nYX7ooooo`05ool00?l0nY[o0?ZJool00?l0nYX01Oooool01_l0nY[o
ooooool00?ooooooo`00o`3jVSgooooo0012ooooo`;o0?ZJ00[oooooool00?oo003o003oool00?oo
ooooo`00oooooooo003o0?ZJ0_ooool01?l0nY[oooooooooool0nYX:ooooo`04o`3jV_ooooooo`00
o`00o`;ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[oo`00oooooooooooo0?ZJ01Gooooo0_l0
nYX00ooooooo003oool00005ooooo`03o`3jV_oo003o0?ZJ00_ooooo0_l0nYX3ooooo`03o`3jV_oo
oooooooo00Cooooo00Co0?ZJo`000?l0003o00001_ooool3o`3jVPKooooo0_l0nYX02?oo003o003o
oooooooooooo003oool00?oooooo0?ZJ0oooool00ooo003o0?ZJooooo`0Iooooo`04o`3jV_oo003o
o`00o`3jVPKooooo0_l0nYXXooooo`03o`000?oooooo0?ZJ00?ooooo00Goo`00oooooooo003o0?ZJ
ool00002ooooo`04o`3jV_l00?ooooooooooo`?oo`0000Ooooooo`3jV_l0nY[oooooo`3jV_oooooo
o`0000Cooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`03ool00?oo
oooooooo00;ooooo00?o0?ZJooooool00?l00ol00004ooooo`04o`3jV_ooooooo`00ool000Cooooo
00Coo`00ooooooooooooo`001?ooool01?l0nY[oo`00o`00ool0nYX7ooooo`;o0?ZJ00?oo`00oooo
ooooool00_l0nYX2o`00o`03oooooooo003ooooo00;ooooo00?o0?ZJool00?l0nYX02_ooool00ol0
nY[oooooooooo`04ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oooooooooo
o`3jV_oo00002?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJo`00ool00?l00_l0
0?l00ooooooo0?ZJooooo`02ooooo`03ool00?l0nY[ooooo00Sooooo00Co0?ZJooooool0nY[o0000
9Oooool00ol0003oooooooooo`02ooooo`08o`3jV_oo003oooooo`3jV_oooooo0?ZJo`00ooooool2
ool00003o`00oooooooo0?ZJ00Cooooo00Ko0?ZJoooooooo003o0?ZJool00?l0nYX5ooooo`;o0?ZJ
00Goooooool00?l0nY[o0?ZJool00006ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool01?l0
nY[oooooool00?l00?l2ool000[ooooo00Koo`00o`3jV_oooooo0?ZJool00?l0nYX5ooooo`03o`3j
V_oooooo003o00;oo`0000?o0?ZJooooooooool01_ooool01_l0nY[oo`00ooooool0nY[oo`00o`3j
VPCooooo00Go0?ZJoooooooo003oo`00o`3jVP04ooooo`03o`3jV_ooooooo`0000?o00001oooool0
1_l0nY[oo`00o`3jV_ooooooo`00o`3jVPGooooo0ol0nYX3ooooo`04o`3jV_ooooooooooo`3jVPOo
oooo00Goo`00o`3jV_l0nY[oo`00o`3jVP05ooooo`06o`3jV_ooooooo`00oooooooo003o0?ZJ?Ooo
ool004;ooooo00co0?ZJooooooooooooo`00ooooool00?ooo`00oooooooo003oooooool00?l0nYX2
ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Co0?ZJoooooooo003o003o0_ooool00ol0nY[ooooo
ooooo`02ooooo`05o`3jV_oo003oooooooooool0nYX05Oooool01Ol0nY[o003oooooooooooooo`00
00Gooooo00?o0?ZJool00?l0nYX02oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJool00?l0nYX04?ooool2o`3jVP04ool00?l00?oo003oooooo`;oo`0000?ooooo
o`3jV_ooool00_ooool00ooo003o0?ZJooooo`0Hooooo`04o`3jV_ooooooo`00o`3jVPOooooo0_l0
nYXXooooo`;o000000Wo0?ZJooooooooooooooooool00?ooooooo`00o`3jV_oo00000_ooool01?l0
nY[o003ooooooooo0002o`3jVP08ool00?ooooooooooo`3jV_oooooo0?ZJoooooooo0005ooooo`03
o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool00_ooool00ooo003oooooooooo`02ooooo`03
o`3jV_ooooooo`0000?o000000Ko0?ZJooooooooooooooooo`3jV_ooool2ool000;o0?ZJ0_ooool0
1?oo003ooooooooooooo0004ooooo`04o`3jV_oo003o003oooooo`Co0?ZJ0oooool2o`3jVP05ool0
0?ooooooooooooooool0nYX00_l00?l00oooooooo`00ooooo`02ooooo`03o`3jV_oo003o0?ZJ01;o
oooo00Co0?ZJoooooooooooooooo0_l0nYX3ooooo`05o`3jV_ooooooooooo`3jV_oo00001Ol0nYX2
ooooo`;o0?ZJ0oooool01?l0nY[oooooo`3jV_ooool2ool000;o003o00?oooooo`3jV_ooool00_oo
ool00ooo003o0?ZJooooo`08ooooo`04o`3jV_oooooo0?ZJo`0002Gooooo00?o0000ooooooooool0
0_ooool02_l0nY[oo`00ooooool0nY[oooooo`3jV_l00?ooooooool00?l00?l2ooooo`03o`3jV_oo
oooooooo00;ooooo00Ko0?ZJoooooooo003o0?ZJool00?l0nYX5ooooo`;o0?ZJ00Goooooool00?l0
nY[o0?ZJool00006ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool00ol0nY[oooooool00003
ool000[ooooo00Ko0?ZJool00?l0nY[oooooool00?l0nYX5ooooo`03o`3jV_oooooo003o00;oo`00
00?o0?ZJooooooooool01_ooool01Ol0nY[oo`00ooooool0nY[oo`0000Gooooo00Go0?ZJoooooooo
ooooooooo`3jVP04ooooo`05o`3jV_ooooooo`00oooooooo00002?ooool01_l0nY[oo`00o`3jV_oo
ooooo`00o`3jVPGooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Coo`00o`3jV_l0nY[o
o`001oooool01Ol0nY[oo`00oooooooo003o0?ZJ03gooooo000kooooo`;o00001Oooool03?l0nY[o
ooooool00?oo003o003ooooooooo003oooooool00?ooooooo`00o`3jVP;ooooo00Co0?ZJoooooooo
oooo0?ZJ2_ooool00ol0nY[oo`00o`00o`03ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJool0
0?ooooooooooo`3jVP0Dooooo`03o`3jV_l00?oooooo00;ooooo00?oo`00ooooooooool00oooool0
0ol0nY[oo`00o`3jVP0;ooooo`04o`3jV_ooooooooooooooo`;oo`001_ooool00ol0nY[oo`00o`3j
VP0Aooooo`03o`3jV_ooooooo`0000?oo`000_ooool01_l0nY[oooooooooooooooooo`00o`3jVQWo
oooo00Co0?ZJoooooooo003o0?ZJ1oooool2o`3jVRSooooo00?o0000ooooool0nYX00oooool01Ooo
003oooooool00?l0nY[oo`0000;ooooo00Co0?ZJo`00ooooooooo`000_l0nYX01_oo003ooooooooo
ool0nY[oooooo`3jVP?o00001?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_l00?oooooo00;o
oooo00?oo`00ooooooooool00_ooool00ol0nY[oooooool00003o`000006o`3jV_oooooooooooooo
ool0nY[ooooo0_oo0002o`3jVP?ooooo00?oo`00oooooooo00001?ooool01?l0nY[oo`00o`00oooo
ool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l0nYX02Ooo003ooooooooooooooooo0?ZJooooool0
0?ooooooool00003ooooo`03o`3jV_oo003ooooo01;ooooo00?o0?ZJooooooooool00_ooool01Ol0
nY[ooooooooooooooooo0?ZJ00;ooooo00Co0?ZJool00?l0nY[o0?ZJ0_ooool01Ol0nY[ooooooooo
ool0nY[o003o00?ooooo00?o0?ZJooooool0nYX00ooo00001?oooooo003oooooool0nYX3ooooo`03
ool00?l0nY[ooooo00Wooooo0_l0nYX00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;o
oooo00Ko0?ZJool00?oooooo0?ZJooooool0nYX2ool00005ooooool00?ooooooooooool0nYX01?oo
ool01_l0nY[oooooool00?l0nY[oo`00o`3jVPGooooo0_l0nYX01Oooooooo`00o`3jV_l0nY[oo`00
00Kooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3jV_ooooooo`0000?oo`002_ooool0
1Ol0nY[oo`00o`3jV_oo003o0?ZJ00Oooooo00Co0?ZJo`00oooo003oo`002Oooool01Ol0nY[oo`00
oooooooo003o0?ZJ00Kooooo00Co0?ZJoooooooooooo0?ZJ1Oooool01?l0nY[oo`00o`00oooo0009
ooooo`05ool00?l0nY[oooooool00?l0nYX03?ooool2o`3jVPSooooo00Coo`00o`3jV_l0nY[oo`00
1oooool01Ol0nY[oo`00oooooooo003o0?ZJ03gooooo000jooooo`04o`000?ooooooooooo`0000Co
oooo00?o0000o`00oooo00000_l00?l2ooooo`;oo`0000?oooooo`3jV_oo00000_ooool01?l0nY[o
ooooooooool0nYX:ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJooooooooool00_ooool01Ol0
nY[oo`00oooooooooooo0?ZJ01Cooooo00?o0?ZJo`00ooooool00_ooool00ooo003oooooooooo`03
ooooo`03o`3jV_oo003o0?ZJ00_ooooo00?o0?ZJooooooooool00ooo0006ooooo`03o`3jV_oo003o
0?ZJ01;ooooo00?o0?ZJoooooooo00000_l00?l2ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ
6Oooool01?l0nY[oooooool00?l0nYX7ooooo`;o0?ZJ:?ooool00ol0003oooooo`3jVP03ooooo`05
ool00?ooooooo`00o`3jV_oo00000_ooool01?l0nY[o003oool00?ooool2o`3jVP06o`00oooo003o
ooooo`3jV_oooooo0?ZJ0ol00004ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJo`00ooooool0
0_ooool00ooo003oooooooooo`02ooooo`04o`3jV_oo003o003oooooo`;oo`0000Ko003oo`3jV_oo
ooooooooo`3jV_ooool2ool00003ooooool0nY[o0?ZJ00;ooooo00?oo`00oooooooo00001?ooool0
1Ol0nY[oo`00o`00oooooooo0?ZJ00;o003o00Coooooo`3jV_l0nY[ooooo0_l0nYX00ooo003ooooo
ooooo`02ooooo`04o`3jV_l00?oo003oool000?ooooo00?o0?ZJool00?ooool04_ooool00ol0nY[o
ooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[oo`00ooooo`03oooo
o`04o`3jV_ooooooooooo`3jVP;o003o0_ooool01?l0nY[oooooo`3jV_oo0002ooooo`04ool00?l0
0?ooooooo`3jVP?ooooo00?oo`00o`3jV_ooool02Oooool2o`3jVP03o`000?oooooooooo02?ooooo
00?o0000ooooooooool00_ooool02_l0nY[oo`00ooooool0nY[oooooo`3jV_oo003o003oooooool0
0?l2ooooo`03o`3jV_oooooooooo00;ooooo00Ko0?ZJoooooooo003o0?ZJool00?l0nYX5ooooo`;o
0?ZJ00Goooooool00?l0nY[oo`00o`3jVP06ooooo`04o`3jV_ooooooooooo`3jVPKooooo00?o0?ZJ
oooooooo00000ol0000:ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01oooool01?l0nY[o003oool0
0?oo0009ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01_ooool01?l0nY[oooooooooool0nYX5oooo
o`04o`3jV_oo003oo`00ool000Wooooo00Goo`00o`3jV_ooooooo`00o`3jVP0<ooooo`;o0?ZJ2?oo
ool01?oo003o0?ZJo`3jV_oo0007ooooo`05o`3jV_oo003oooooool00?l0nYX0?Oooool003[ooooo
00Co0000oooooooooooo00001?ooool00ol0003oo`00o`00o`02o`00o`;ooooo0_oo00000ooooooo
0?ZJool00002ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?o0?ZJool00?ooool00oooool00ol0
nY[oooooooooo`02ooooo`05o`3jV_oo003oooooooooool0nYX04oooool2o`3jVPCooooo00?oo`00
ooooooooool00oooool00ol0nY[oo`00o`3jVP0;ooooo`06o`3jV_ooooooo`00ool00?ooooooo`00
1_ooool00ol0nY[oo`00o`3jVP0Booooo`04o`3jV_oooooo003oo`00o`?ooooo00Ko0?ZJoooooooo
ooooooooo`3jV_oo000Iooooo`04o`3jV_oo003o003oo`3jVPOooooo0_l0nYXXooooo`03o`000?oo
oooo0?ZJ00?ooooo00Goo`00oooooooo003o0?ZJool00002ooooo`0<o`3jV_l00?ooo`00ooooool0
nY[oooooo`3jV_oo003oooooo`3jV_oooooo0?ZJ0ol00005ooooo`;o0?ZJ1?ooool01Ol0nY[ooooo
ooooooooooooo`0000Cooooo00So0?ZJool00?ooooooooooo`3jV_oo003o003oo`3jVP;ooooo00Co
0?ZJoooooooo003oo`000_ooool01_l0nY[ooooooooooooo003oooooool000Cooooo00Oo0?ZJoooo
oooo003oooooo`3jV_oooooo003o00;ooooo0_l0nYX00ooooooo0?ZJool00004ooooo`04o`3jV_oo
oooo003oool000?ooooo00?oo`00o`3jV_ooool04_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ
0_ooool01Ol0nY[oooooooooool0nY[oo`0000Cooooo00Co0?ZJooooool0nY[o0?ZJ0_l00?l2oooo
o`04o`3jV_oooooo0?ZJool000;ooooo0_oo00001ol00?oo0?ZJoooooooooooo0?ZJool00?l0nYX0
2_ooool2o`3jVP03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool02_l0nY[oo`00
ooooool0nY[oooooo`3jV_oo003o003oooooool00?l2ooooo`03o`3jV_oooooooooo00;ooooo00Go
0?ZJoooooooo003o0?ZJool00007ooooo`06o`3jV_ooooooo`00oooooooo003o0?ZJ1_ooool01?l0
nY[oooooooooool0nYX6ooooo`03o`3jV_ooooooo`0000?o00002_ooool01Ol0nY[oo`00o`3jV_oo
003o0?ZJ00Oooooo00Co0?ZJo`00oooo003oo`002Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00Ko
oooo00Co0?ZJoooooooooooo0?ZJ1Oooool01?l0nY[o003oool00?l0nYX9ooooo`05ool00?l0nY[o
ooooool00?l0nYX05_ooool01?oo003o0?ZJo`3jV_oo0007ooooo`05o`3jV_oo003o003oool00?l0
nYX0?Oooool003[ooooo00Co0000oooooooooooo00001?ooool01?l0003o003oo`00ool00?l3oooo
o`;oo`0000?oooooo`3jV_oo00000_ooool01?l0nY[oooooooooool0nYX:ooooo`03ool00?oooooo
oooo00?ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[o003oool00?oooooo0?ZJ00Oooooo00?o
0?ZJooooooooool02Oooool00ol0nY[o003oooooo`03ooooo`03ool00?oooooooooo00?ooooo00?o
0?ZJool00?l0nYX02_ooool00ol0nY[oooooool00003ooooo`03ool00?oooooooooo00?ooooo00Co
0?ZJool00?l00?oo0?ZJ4_ooool01?l0nY[oooooo`00ool00?l3ooooo`07o`3jV_oooooooooooooo
ool0nY[oo`00o`3jVP0Hooooo`04o`3jV_oo003oooooo`3jVPOooooo00?o0000o`3jV_ooool09ooo
ool2o`000003o`3jV_oooooooooo00;ooooo0_oo00001_l0nY[oo`00oooooooooooo0?ZJool000;o
oooo00[o0?ZJooooool0nY[oo`00ooooool0nY[oooooo`3jV_ooooooo`001_ooool2o`3jVPCooooo
00Go0?ZJooooooooooooooooool00003ooooo`03o`3jV_l00?ooo`0000;ooooo00Co0?ZJool00?l0
0?oo0?ZJ0_ooool01?l0nY[oo`00ool00?oo0002ooooo`;o0?ZJ0_ooool2ool000Cooooo00So0?ZJ
oooooooo003oo`00o`3jV_oo003oooooo`00o`Cooooo00?oo`00o`3jV_ooool00oooool01?l0nY[o
ooooo`00oooo0003ooooo`03ool00?l0nY[ooooo01Sooooo00Co0?ZJoooooooooooo0?ZJ0_ooool0
0ol0nY[oo`00o`00o`03ooooo`05o`3jV_oooooo0?ZJo`00ooooool00_oo00001Ooooooo0?ZJoooo
ool0nY[oo`0000?ooooo00?oo`00o`00ool0nYX00_ooool00ol0nY[oo`00ooooo`0:ooooo`;o0?ZJ
00?o0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`0:o`3jV_oo003oooooo`3jV_oo
oooo0?ZJool00?l00?ooooooo`00o`;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`00
o`02ool000Oooooo00Ko0?ZJoooooooo003oooooool00?l0nYX6ooooo`04o`3jV_ooooooooooo`3j
VPKooooo00?o0?ZJooooooooool00ol0000:ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01oooool0
1?l0nY[o003oool00?oo0009ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01_ooool01?l0nY[ooooo
ooooool0nYX5ooooo`04o`3jV_oooooo003oo`3jVPWooooo00Goo`00o`3jV_ooooooo`00o`3jVP0F
ooooo`04ool00?l0nY[oo`00o`3jVPOooooo00Go0?ZJool00?l00?ooo`00o`3jVP0mooooo`00>_oo
ool01?l0003oooooooooool00004ooooo`03o`3jV_oooooo003o00Cooooo0_oo00000ooooooo0?ZJ
ool00002ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?oo`00ooooooooool00oooool00ol0nY[o
ooooooooo`02ooooo`05o`3jV_l00?ooo`00ooooool0nYX01oooool00ol0nY[oooooooooo`09oooo
o`03o`3jV_l00?oooooo00?ooooo00?oo`00ooooooooool00oooool00ol0nY[oo`00o`3jVP0:oooo
o`03o`3jV_ooooooo`0000?ooooo00?oo`00ooooooooool00oooool01?l0nY[oo`00o`00ool0nYXB
ooooo`03o`3jV_oooooooooo00Cooooo00Oo0?ZJooooooooooooooooo`3jV_oo003o0?ZJ01Sooooo
00Co0?ZJool00?oooooo0?ZJ2?ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooo0?ZJ00Co
oooo0_oo00001_l0nY[oo`00ooooool0nY[oooooool000;ooooo00[o0?ZJooooool0nY[oo`00oooo
ool0nY[oooooo`3jV_ooooooo`001_ooool2o`3jVPCooooo00Go0?ZJo`00ooooooooooooool00003
ooooo`03o`3jV_l00?ooo`0000;ooooo00Co0?ZJool00?oo003o0?ZJ0_ooool01?l0nY[o0000o`00
0?l00003ooooo`03o`3jV_oooooooooo00;oo`001?ooool00ol0nY[oooooo`000002o`0000;oo`00
00?o003oooooooooool00_ooool00ooo003o0?ZJooooo`03ooooo`04o`3jV_oooooo003oool000?o
oooo00?oo`00o`3jV_ooool06?ooool01?l0nY[oooooooooool0nYX3ooooo`03ool00?l00?oooooo
00;ooooo00Co0?ZJo`00ool0nY[o003o1?oo00000ol0nY[oooooool00004ooooo`03ool00?l00?oo
0?ZJ00;ooooo00?o0?ZJool00?ooool02_ooool2o`3jVP03o`000?oooooooooo02?ooooo00?o0000
ooooooooool00_ooool02_l0nY[oo`00ooooool0nY[oooooo`3jV_oo003o003oooooool00?l2oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_oo0007ooooo`03o`3jV_oooooo0?ZJ
00;oo`0000?o0?ZJooooooooool01Oooool00ol0nY[oooooo`3jVP06ooooo`05o`3jV_oooooooooo
ooooool0nYX02oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00Oooooo0_l0nYX00ooo003o0?ZJoooo
o`08ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01_ooool01?l0nY[oooooooooool0nYX5ooooo`04
o`3jV_ooooooooooo`3jVPWooooo00Coo`00o`3jV_ooooooo`005oooool01?oo003o0?ZJool00?l0
nYX7ooooo`05o`3jV_oo003oo`00ooooool0nYX0?Oooool003[ooooo00Co0000oooooooooooo0000
1?ooool00ol0nY[oooooooooo`04ooooo`;oo`0000?oooooo`3jV_oo00000_ooool00ol0nY[ooooo
ooooo`04o`3jVPKooooo00?o0?ZJool00?ooool01?ooool00ol0nY[oooooooooo`02ooooo`05o`3j
V_l00?ooo`00ooooool0nYX01_ooool2o`3jVP_ooooo00?o0?ZJo`00ooooool00oooool00ooo003o
ooooooooo`03ooooo`03o`3jV_oo003o0?ZJ00[ooooo00Co0?ZJool00?oooooo003o0_ooool00ooo
003oooooooooo`03ooooo`04o`3jV_oo003o003oo`3jVQ?ooooo00?o0?ZJooooooooool00oooool0
1ol0nY[ooooooooooooooooo0?ZJool00?l0nYX04?ooool2o`3jVPKooooo00Co0?ZJool00?oooooo
0?ZJ2?ooool00ol0nY[oooooooooo`0Vooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo00001_l0
nY[oo`00ooooool0nY[oooooool000;ooooo00?o0?ZJooooool0nYX00_oo00001Ooooooo0?ZJo`3j
V_ooooooo`0000Kooooo0_l0nYX4ooooo`05o`3jV_l00?oo003oo`00oooo00000oooool00ol0nY[o
o`00ooooo`02ooooo`;o0?ZJ00Goo`00o`00ool0nY[oooooo`3jVP03o`0000?ooooo00?o0?ZJoooo
ooooool00_oo0004ooooo`03o`3jV_oooooo000000;o000000Coooooool00?oo003o003o0_ooool3
o`0000Cooooo00Co0?ZJooooool00?ooo`000oooool00ooo003o0?ZJooooo`0Hooooo`04o`3jV_oo
ooooooooo`3jVP?ooooo00?oo`00o`00ooooool00_ooool3o`3jVP;oo`0000Ko003ooooooooo003o
o`00o`3jV_oo0005ooooo`06ool00?l0nY[oooooooooool0nY[oo`003?ooool00ol0nY[o0000oooo
o`0Tooooo`03o`000?oooooooooo00;ooooo00[o0?ZJool00?oooooo0?ZJooooool0nY[oo`00o`00
oooooooo003o0_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;oo`001oooool0
0ol0nY[oooooo`3jVP02ool00003o`3jV_oooooooooo00Gooooo0_l0nYX7ooooo`05o`3jV_oooooo
ooooooooool0nYX02oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00Oooooo0ol000000ol0nY[ooooo
ooooo`07ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01_ooool01?l0nY[oooooooooool0nYX5oooo
o`04o`3jV_ooooooooooo`3jVPWooooo00Co0?ZJool00?ooooooo`005oooool01?oo003o003oool0
0?l0nYX7ooooo`05o`3jV_l00?ooo`00ooooool0nYX0?Oooool003_ooooo0_l00005ooooo`;o0?ZJ
1Oooool2ool00003ooooool0nY[oo`0000;ooooo00Co0?ZJoooooooooooo0?ZJ0oooool02?l0nY[o
oooooooooooooooo0?ZJooooool0nY[oo`001Oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_oo
ooooo`00o`3jVPKooooo0_l0nYX8ooooo`04o`3jV_oooooo0?ZJo`00o`Cooooo00?oo`00o`3jV_oo
ool01?ooool00ol0nY[oo`00o`3jVP0:ooooo`03o`3jV_oo003ooooo00?o003o00?oo`00oooooooo
ool00oooool01?l0nY[oo`00o`00ool0nYXCooooo`03o`3jV_oooooooooo00?ooooo00Oo0?ZJoooo
ooooooooooooo`3jV_oo003o0?ZJ00oooooo1?l0nYX5ooooo`04o`3jV_oo003oooooo`3jVPSooooo
00?o0000ooooooooool09_ooool2o`000003ooooool0nY[ooooo00;ooooo0_oo00001_l0nY[oo`00
ooooool0nY[oooooool000;ooooo00Ko0?ZJooooool0nY[oooooool00?ooool2o`3jVP03ool00?l0
nY[ooooo00Kooooo00?o0?ZJooooooooool00oooool2o`3jVP?o00000_ooool00ol0nY[oo`00oooo
o`02ooooo`;o0?ZJ00Goo`00o`00ool0nY[oooooo`3jVP03o`0000?ooooo00Go0?ZJoooooooooooo
ooooool00004ooooo`03o`3jV_oooooo000000;o00000_ooool01?oo003o003oooooooooool3o`00
00Gooooo00Co0?ZJo`000?l0003o00000_ooool00ooo003o0?ZJooooo`0Hooooo`04o`3jV_oooooo
ooooo`3jVP?ooooo00?oo`00o`00oooo00000ooo00001Ol0nY[oooooool00?oooooo003o00;ooooo
00?oo`00o`3jV_oo00000ol0nYX2ooooo`06ool00?l0nY[oooooooooool0nY[oo`003?ooool2o`00
02Gooooo00?o0000ooooooooool00_ooool02ol0nY[oo`00ooooool0nY[oooooo`3jV_oo003o003o
ooooool00?oooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`02ool000Oooooo00?o0?ZJooooool0
nYX00_oo00000ol0nY[oooooooooo`05ooooo`;o0?ZJ2?ooool01?l0nY[oooooooooool0nYX;oooo
o`05o`3jV_oo003oooooool00?l0nYX01oooool3o`000003o`3jV_oooooooooo00Sooooo00Coo`00
o`3jV_oo003o0?ZJ1_ooool01?l0nY[oooooooooool0nYX5ooooo`04o`3jV_ooooooooooo`3jVPWo
oooo00Co0?ZJool00?l0nY[oo`005oooool01?l0nY[oo`00ool00?l0nYX7ooooo`05o`3jV_oooooo
o`00o`000?l0nYX0?Oooool004;ooooo00?o0000o`3jV_ooool01?ooool2ool00003ooooool0nY[o
o`0000;ooooo00Go0?ZJoooooooooooo0?ZJo`00o`02ooooo`08o`3jV_ooooooooooooooool0nY[o
ooooo`3jV_oo0002o`3jVP?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo0006
ooooo`;o0?ZJ2?ooool01?l0nY[oooooo`3jV_l00?l4ooooo`03ool00?l0nY[ooooo00Cooooo00?o
0?ZJoooooooo00002_ooool00ol0nY[oo`00o`00o`03o`00o`03ool00?oooooooooo00?ooooo00?o
0?ZJool00?l0nYX05?ooool2o`3jVPCooooo00So0?ZJooooooooooooooooo`3jV_oo003oooooo`3j
VPkooooo00Co0?ZJoooooooooooo0?ZJ1Oooool01?oo003o003oooooool0nYX7ooooo`;o00006ooo
ool3o`0000Cooooo0_l00004ooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo00001Ol0nY[oo`00
o`3jV_l0nY[oo`0000?ooooo00Ko0?ZJoooooooooooo0?ZJool00?ooool2o`3jVP03ool00?l0nY[o
oooo00Kooooo00?o0?ZJooooooooool01?ooool02?l0nY[o0000o`000?l0003o0?ZJooooool0nY[o
o`000oooool2o`3jVP07ool00?oooooo0?ZJooooool0nY[oo`00o`3jVP04ooooo`05o`3jV_oooooo
ooooooooool0nYX01?ooool01?l0nY[oooooooooooooool2o`3jVP;ooooo00?oo`00ooooooooool0
0ol00005ooooo`04o`3jV_l0003o0000o`0000;ooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[o
ooooo`3jVP03ooooo`?oo`000_ooool01?oo003o0?ZJool00?oo0002ooooo`08o`00ooooooooo`00
o`3jV_oo003o0?ZJooooool0nYX2ooooo`06ool00?l0nY[oooooooooool0nY[oo`003Oooool00ol0
003oooooooooo`0Fooooo`?o00000oooool2o`0000Gooooo00?o0000ooooooooool00_ooool02_l0
nY[oo`00ooooool0nY[oooooool00?oooooo003oooooool00?l2o`3jVPGooooo00?o0?ZJooooool0
00000_l00007ooooo`03o`3jV_oooooo0?ZJ00;oo`0000?o0?ZJooooooooool01Oooool2o`3jVPSo
oooo00Co0?ZJoooooooooooo0?ZJ2oooool01Ol0nY[oo`00oooooooo003o0?ZJ00Oooooo0ol00000
0ol0nY[oooooooooo`08ooooo`04ool00?ooooooo`00o`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ
1Oooool01?l0nY[oooooooooool0nYX9ooooo`04o`3jV_oo003o0?ZJool001Oooooo00Co0?ZJool0
0?oo003o0?ZJ1oooool01Ol0nY[ooooooooooooooooo0?ZJ03gooooo0012ooooo`03o`000?oooooo
0?ZJ00Cooooo0_oo00000ooooooo0?ZJool00002ooooo`03o`3jV_oooooo000000;o00000oooool0
1ol0nY[oooooooooool0nY[oooooo`3jV_oo00000ol0nYX2ooooo`03o`3jV_oooooooooo00?ooooo
00Co0?ZJooooooooooooo`001_ooool4o`3jVPKooooo00?o0?ZJooooool0nYX01?oo00000ooooooo
o`00o`3jVP05ooooo`04o`3jV_l0003o0000o`0000Wooooo00Coo`00o`00ool00?oooooo0_l00?l0
0ooo003oooooooooo`03ooooo`03o`3jV_oo003o0?ZJ01Gooooo00?o0?ZJooooooooool00_ooool0
2?l0nY[ooooooooooooooooo0?ZJool00?oooooo0?ZJ3_ooool01?l0nY[oooooooooool0nYX5oooo
o`04ool00?l00?oo0?ZJo`3jVPSooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0?ZJ0oooool2ool00005o`3j
V_oo003o0?ZJo`3jV_oo00000oooool01_l0nY[oooooooooool0nY[oo`00ooooo`;o0?ZJ00?oo`00
o`3jV_ooool03_ooool3o`0000;o0?ZJ00?o003oool00?ooool01?l0nYX01oooooooo`00o`3jV_l0
nY[oooooool00?l0nYX01Oooool01?l0nY[oooooooooool0nYX4ooooo`04o`3jV_oooooooooooooo
o`;o0?ZJ0_ooool01Ooo003oooooooooooooooooo`0000Kooooo00Co0?ZJo`000?l0003o00000_oo
ool00ooo003o0?ZJooooo`0Iooooo`03o`3jV_oooooo0?ZJ00?ooooo00So0?ZJool00?oooooo003o
oooooooo003o003oool000?ooooo00Oo003ooooooooo003o0?ZJool00?l0nY[ooooo00;o0?ZJ00?o
ooooool00?oo00000_ooool00ol0nY[oo`00ooooo`0<ooooo`03o`000?oooooooooo01Oooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool01_l0nY[oo`00ooooool0nY[oooooool000;ooooo0_l00?l00ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooo000000;o00002Oooool00ol0nY[oo`00ool0000Booooo`04o`3jV_oooooooooo
o`3jVP_ooooo00Go0?ZJool00?ooooooo`00o`3jVP09ooooo`03o`3jV_oooooooooo00Wooooo00Co
o`00oooooooo003o0?ZJ1oooool3o`3jVPGooooo00Co0?ZJoooooooooooo0?ZJ2Oooool01?l0nY[o
o`00o`3jV_oo000Gooooo`04o`3jV_oo003oo`00o`3jVPOooooo00Go0?ZJooooooooooooooooo`3j
VP0mooooo`00@_ooool00ol0003oooooo`3jVP04ooooo`;oo`000_ooool01Ooo003o0?ZJooooool0
nY[o003o00?o000000Coo`00oooooooooooo0?ZJ0_ooool01?l0nY[oooooool00?l0nYX2ooooo`04
o`3jV_ooooooooooo`3jVPGooooo00Co0?ZJooooooooooooo`001Oooool6o`3jVPCooooo0_l0nYX0
0ooooooo0?ZJool00002ooooo`04ool00?ooooooo`00o`3jVPGooooo00Go0?ZJo`000?l0003o0000
o`3jVP08ooooo`03ool00?l00?oooooo00;ooooo0ol00004ooooo`03o`3jV_oo003o0?ZJ01Gooooo
0_l0nYX3ooooo`07o`3jV_ooooooooooooooool0nY[oo`00ooooo`02o`3jVPKooooo0ol0nYX3oooo
o`05o`3jV_l00?oo003oooooool0nYX01Oooool00ooo003oooooo`3jVP09ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`04o`000?oo
ooooooooo`3jVP?ooooo0_oo00001Ol0nY[oo`00o`3jV_ooooooo`0000?ooooo00Ko0?ZJoooooooo
oooo0?ZJool00?ooool2o`3jVP03ool00?l0nY[ooooo00kooooo0_l0nYX01ooo003oooooooooool0
0?ooo`00ooooool0nYX00_ooool00ol0nY[oooooool00002o`3jVP03oooooooo003o0?ZJ00Gooooo
00Co0?ZJoooooooooooo0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`05o`3jV_oooooo003oool0
0?ooool00_oo0006ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool06Oooool0
0ol0nY[oooooo`3jVP03ooooo`05o`3jV_ooooooooooo`00ooooool00ooo0003ooooo`05o`00oooo
ooooo`00ool00?l0nYX00oooool01?l0nY[ooooooooooooo0002ooooo`03o`3jV_oo003ooooo00co
oooo00?o0000ooooooooool05?ooool5o`0000;ooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`02ooooo`03o`3jV_oo003o000000;o000000Koo`00oooooooooooo003oooooool0
nYX6ooooo`03o`3jV_oooooo000000;o00002Oooool00ol0nY[oo`00ool0000Booooo`04o`3jV_oo
ooooooooo`3jVP_ooooo00Go0?ZJool00?ooooooo`00o`3jVP0Eooooo`03ool00?ooooooo`0000So
oooo0_l0nYX6ooooo`04o`3jV_ooooooooooo`3jVPWooooo00Co0?ZJool00?l0nY[oo`005oooool0
1?l0nY[oo`00ool00?l0nYX7ooooo`05o`3jV_ooooooooooooooool0nYX0?Oooool004;ooooo00?o
0000ooooool0nYX01?ooool2ool000;ooooo00Goo`00o`3jV_oooooo0?ZJo`00o`03o`000004ool0
0?ooooooooooo`3jVP;ooooo00Co0?ZJoooooooo003o0?ZJ0oooool00ol0nY[oooooo`3jVP05oooo
o`04o`3jV_ooooooooooool000Gooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`02
ooooo`;o0?ZJ00?oooooo`3jV_oo00000_ooool3ool00003o`3jV_oooooooooo00?ooooo00Co0?ZJ
o`000?l0003o00000ol0nYX6ooooo`05ool00?oooooo0?ZJo`3jV_ooool00ol00004ooooo`03o`3j
V_oo003o0?ZJ01Kooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`04ool00?l00?ooooooo`3j
VPGooooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`05o`3jV_l00?ooooooo`00ool0nYX01Oooool0
0ooo003oooooo`3jVP09ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00003ooooo`;o000000?oooooo`3jV_ooool00_ooool01?oo003oooooo`3j
V_oo0002ooooo`05ool00?ooooooooooooooool0nYX00_ooool00ol0nY[oo`00o`00o`02o`3jVP03
ool00?l0nY[ooooo00kooooo0_l0nYX01ooo003o003oooooool00?ooo`00ooooool0nYX00oooool0
1ol0nY[oo`00o`00ool0nY[oooooool00?l0nYX01Oooool01?l0nY[oooooooooool0nYX5ooooo`03
o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool00ooo00000ol0nY[oooooooooo`04ooooo`04
o`3jV_ooooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[oooooo`3jVP03oooo
o`04o`3jV_ooooooooooooooo`?o00001?ooool01Ol00?ooooooool00?oo003o0?ZJ00?ooooo00Co
0?ZJooooooooooooo`000_ooool00ol0nY[oo`00ooooo`0:ooooo`?o00005_ooool01?l0003ooooo
ooooool00003ooooo`04o`000?ooooooooooo`0000Cooooo0_l00003ooooo`03o`3jV_oo003o0000
00;o000000?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ
00[ooooo00?o0?ZJool00?l0nYX04_ooool01?l0nY[oooooooooool0nYX;ooooo`05o`3jV_oo003o
o`00o`3jV_l00?l05Oooool00ooo003o003oool0000@ooooo`04o`3jV_ooooooooooo`3jVPWooooo
00Co0?ZJool00?l0nY[oo`005oooool00ol0nY[oo`00ool00008ooooo`05o`3jV_ooooooooooo`3j
V_l00000?Oooool004;ooooo00?o0000ooooool0nYX01?ooool2ool000;ooooo00Soo`00o`3jV_l0
nY[oooooo`00ooooooooo`00o`3jVP;oo`0000Soooooo`3jV_ooooooooooo`3jV_ooooooo`00o`3j
VP?ooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[ooooooooooooo0005ooooo`04o`3jV_l0003o
0000o`0000;ooooo00Co0?ZJoooooooooooooooo0_l0nYX00oooooooo`00ooooo`03ooooo`;oo`00
00?o0?ZJooooooooool01?ooool2o`3jVP03ool00?oooooooooo00;o0?ZJ1?ooool01_l0nY[oo`00
o`3jV_oooooo0?ZJooooo`?o00001?ooool00ol0nY[oo`00o`3jVP0Fooooo`05o`3jV_oooooooooo
ooooool0nYX01?ooool01?l0nY[oo`00ooooool0nYX5ooooo`04o`3jV_ooooooooooo`3jVP?ooooo
00Go0?ZJo`00oooooooo003oo`3jVP04ooooo`03o`3jV_oo003o0?ZJ00Wooooo0_l0000Looooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0nYX3
ooooo`04ool00?oooooo0?ZJool000;ooooo00Goo`00ooooooooooooooooo`3jVP02ooooo`03o`3j
V_oo003o003o00;ooooo00?oo`00o`3jV_ooool03oooool01ol0nY[oo`00ool00?ooooooo`00oooo
ool0nYX01?ooool01ol0nY[oo`00o`00ool0nY[oo`00ooooool0nYX01Oooool01?l0nY[ooooooooo
ool0nYX5ooooo`03o`3jV_oooooo0?ZJ00?ooooo00Ko0?ZJooooool00?ooo`00ooooool0nYX6oooo
o`04o`3jV_oooooo0?ZJool000;ooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[oooooo`3jVP03
ooooo`04o`3jV_ooooooooooooooo`?o000000?oooooo`3jV_l0nYX00_l0nYX01?ooooooo`00ool0
0?l0nYX4ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_ooool03?ooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001?ooool00ol0003o
ooooooooo`02ooooo`03o`3jV_oo003o000000;o000000Goo`00ooooooooooooooooo`3jVP08oooo
o`03o`3jV_oooooo0?ZJ00[ooooo00?o0?ZJo`00ool0nYX04_ooool01?l0nY[oooooooooool0nYX;
ooooo`04o`3jV_oo003oo`00o`3jVQKooooo00?oo`00o`00oooo00004?ooool01?l0nY[ooooooooo
ool0nYX9ooooo`04o`3jV_oo003o0?ZJool001Oooooo00?o0?ZJool00?oo00002?ooool01Ol0nY[o
ooooooooool0nY[o000003gooooo0012ooooo`03o`000?oooooo0?ZJ00Cooooo0_oo0002ooooo`0:
ool00?l0nY[o0?ZJooooool00?ooooooool00?l0nY[o003oool000;ooooo00Ko0?ZJooooool0nY[o
ooooool00?l0nYX4ooooo`;o0?ZJ1Oooool2o`3jVP03oooooooo003ooooo00Cooooo00Oo0?ZJo`00
0?l0003o0000ooooool00?oo0?ZJ00?ooooo0ol0nYX00ooo003oooooooooo`02ooooo`;oo`0000?o
0?ZJooooooooool01?ooool2o`3jVP04ool00?l00?ooooooooooo`;o0?ZJ0oooool01?l0nY[oo`00
o`3jV_ooool2o`3jVP03ooooool0nY[oo`0000Cooooo00?o0?ZJool00?l0nYX05oooool01?l0nY[o
ooooooooool0nYX4ooooo`04o`3jV_oo003oooooo`3jVPGooooo00Co0?ZJoooooooooooo0?ZJ0_oo
ool01_l0nY[o003oo`00oooooooo003oo`3jVPCooooo00?o0?ZJool00?l0nYX02_ooool00ol0003o
ooooooooo`0Iooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`04o`000?oooooooooo
o`3jVP?ooooo00Ooo`00ooooool0nY[oo`00oooooooo003o003o00?ooooo00Ko0?ZJoooooooooooo
0?ZJoooooooo0002ooooo`03ool00?l0nY[ooooo00oooooo0_l0nYX01Ooo003oooooool00?oooooo
0?ZJ00Cooooo00Oo0?ZJool00?oooooo003oool00?oooooo0?ZJ00Gooooo00Co0?ZJoooooooooooo
0?ZJ1Oooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJoooooooo
ool01?ooool01?l0nY[oooooo`3jV_oo0002ooooo`03ool00?l0nY[ooooo01Wooooo00?o0?ZJoooo
ool0nYX00oooool01?l0nY[oooooooooooooool3o`000005ooooool0nY[oooooooooool0nYX00ol0
00000ol0nY[oooooooooo`02ooooo`07o`3jV_l0003o0000o`000?ooooooo`00o`3jVP0=ooooo`03
o`000?oooooooooo01Kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooo
ooooool00_ooool01_l0nY[oo`00oooooooo003oooooool000?ooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooo`3jVP0:ooooo`03o`3jV_l00?oo0?ZJ01;ooooo00Co0?ZJoooooooooooo0?ZJ
2oooool01?l0nY[oo`00ool00?l0nYXFooooo`03ool00?l00?ooo`00013ooooo00Co0?ZJoooooooo
oooo0?ZJ2Oooool01?l0nY[oo`00ool00?l0nYXGooooo`03o`3jV_oo003o0?ZJ00Sooooo00Go0?ZJ
oooooooooooo0?ZJo`00000mooooo`00@_ooool01?l0003oooooooooool0nYX3ooooo`;oo`000_oo
ool01Ooo003o0?ZJo`3jV_oooooo003o00;oo`0000?o0?ZJo`00oooo00000_ooool01_l0nY[ooooo
o`3jV_ooooooo`00o`3jVPCooooo0_l0nYX6ooooo`03o`3jV_ooooooo`0000Gooooo00Oo0?ZJo`00
0?l0003o0000ool00?l00?oo0?ZJ00?ooooo0ol0nYX00ooo003oooooooooo`03ooooo`03ool00?l0
nY[ooooo00Gooooo0_l0nYX2ool000?ooooo00Ko0?ZJooooooooooooooooo`3jV_oo0003ooooo`04
o`3jV_oooooo0?ZJool000Cooooo00?o0?ZJool00?ooool05oooool01?l0nY[oooooooooool0nYX4
ooooo`04o`3jV_oo003o003oo`3jVPCooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`04o`3j
V_l00?oo003oooooo`;o003o00Oo0?ZJooooooooooooooooo`3jV_oo003o0?ZJ00[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`000003ooooool0nY[o
oooo00;ooooo00Ooo`00ooooool0nY[oo`00oooooooo003o003o00?ooooo00Ko0?ZJoooooooooooo
0?ZJoooooooo0002ooooo`03ool00?l0nY[ooooo00oooooo0_l0nYX01Ooo003o003oool00?oooooo
0?ZJ00Cooooo00Oo0?ZJoooooooo003o003oool00?oooooo0?ZJ00Gooooo00Co0?ZJoooooooooooo
0?ZJ1Oooool3o`3jVP?ooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`05ooooo`;o
0?ZJ00Goo`00ooooooooooooo`00o`3jVP0Jooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJoooo
ool0nYX01_l0nYX3ooooo`?o00001Oooool01ol0nY[o0000o`000?l0003oooooool00?l0nYX03?oo
ool2o`0001Wooooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool00_oo
ool01_l0nY[oo`00oooooooo003oooooool000?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooo`3jVP0;ooooo`;o0?ZJ4_ooool00ol0nY[oooooo`3jVP0<ooooo`04o`3jV_oo003oo`00o`3j
VQKooooo0_oo00000ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooo0?ZJ00[ooooo0_oo00000ol0
nY[oooooooooo`0Eooooo`03o`3jV_oooooo0?ZJ00Sooooo00Go0?ZJoooooooooooo0?ZJo`00000m
ooooo`00@_ooool01?l0003oooooooooool0nYX4ooooo`04o`3jV_ooooooooooool000;o0?ZJ00Oo
003ooooooooo003o0?ZJooooool0nY[oo`0000;ooooo00Go0?ZJooooool0nY[oooooool00005oooo
o`;o0?ZJ1_ooool00ol0nY[o003oool00005ooooo`04o`3jV_l00?ooo`00o`3jVP;oo`000_l0nYX2
ooooo`?o0?ZJ00?oo`00ooooooooool00oooool00ooo003o0?ZJooooo`05ooooo`?o0?ZJ00Coo`00
o`00oooooooooooo0_l0nYX01?oooooo0?ZJo`3jV_oo0003ooooo`05o`3jV_oooooo0?ZJool00?l0
nYX00oooool00ooo003o0?ZJooooo`0Gooooo`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJool0
0?l00?oo0?ZJ1?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJo`00oooo00000_oo
00000ol00?oo0?ZJooooo`02ooooo`03o`3jV_oo003o0?ZJ00[ooooo00?o0000ooooooooool09_oo
ool01?l0003oooooooooool0nYX3ooooo`07ool00?oooooo0?ZJool00?ooooooo`00o`00o`03oooo
o`06o`3jV_ooooooooooo`3jV_ooooooo`000_ooool00ooo003o0?ZJooooo`0@ooooo`04o`3jV_oo
003oo`00ool000;o0?ZJ1?ooool01ol0nY[oooooool00?l00?ooo`00o`00ool0nYX01Oooool01?l0
nY[oooooooooool0nYX6ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJo`00ooooooooooooo`3j
VP07ooooo`;o0?ZJ00Goo`00o`3jV_ooooooo`00o`3jVP0Jooooo`03o`3jV_oooooo0?ZJ00?ooooo
00?o0?ZJooooool0nYX00_ooool3o`3jVPCooooo0ol00005ooooo`07o`3jV_l0003o0000o`000?oo
ooooo`00o`3jVP0=ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool01_l0
nY[oo`00oooooooo003oooooool000?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooo`3j
VP0;ooooo`;o0?ZJ4_ooool3o`3jVPcooooo00Co0?ZJool00?oo003o0?ZJ5_ooool00ol0nY[oo`00
o`3jVP0Aooooo`?o0?ZJ2_ooool2ool00003o`3jV_oooooooooo01Gooooo00?o0?ZJooooool0nYX0
2Oooool01?l0nY[oooooo`3jV_l0000mooooo`00@_ooool01?l0003oooooooooool0nYX4ooooo`04
o`3jV_ooooooooooool000;o0?ZJ00_o003ooooooooo003o0?ZJooooool0nY[oooooool00?oooooo
0?ZJooooo`02o`3jVP03ool00?oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
003oool00004ooooo`03o`3jV_ooooooo`0000;o0?ZJ00Coooooool00?l00?oo0?ZJ0_ooool3o`3j
VP03ool00?l0nY[o0?ZJ00?ooooo00?oo`00o`3jV_ooool01Oooool3o`3jVP;oo`000oooool3o`3j
VP03ool00?l0nY[ooooo00;ooooo00Go0?ZJooooool0nY[oo`00o`3jVP03ooooo`03ool00?l0nY[o
oooo01Oooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[oooooool00?l0nYX3ooooo`;o0?ZJ
0oooool01Ol0nY[oooooooooool0nY[oo`0000;ooooo00?oo`00o`00ool0nYX00oooool00ol0nY[o
o`00o`3jVP0:ooooo`03o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP02oooo
o`07ool00?oooooo0?ZJool00?ooooooo`00o`00o`03ooooo`06o`3jV_ooooooooooooooool0nY[o
o`000_ooool00ooo003o0?ZJooooo`0@ooooo`05o`3jV_oooooo003oooooool0nYX01_ooool01_l0
nY[oo`00o`00oooo003o003oo`3jVPKooooo00?o0?ZJooooool0nYX03?ooool01Ol0nY[o003ooooo
oooooooo0?ZJ00Oooooo0_l0nYX01Ooo003o0?ZJo`3jV_oo003o0?ZJ01_ooooo0_l0nYX3ooooo`?o
0?ZJ2Oooool00ol00?oo0?ZJooooo`06ooooo`06o`3jV_oo003o0?ZJoooooooo003o0?ZJ3Oooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo00Ko0?ZJool00?ooooooo`00oooo
oooo0003ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool0nYX02oooool2o`3jVQ?ooooo
00?o0?ZJooooooooool02oooool01?l0nY[oooooool00?l0nYXFooooo`03o`3jV_oo003o0?ZJ01ko
oooo0_oo00000ol0nY[oooooooooo`0Fooooo`;o0?ZJ2Oooool01?l0nY[oooooo`3jV_l0000moooo
o`00@_ooool01?l0003oooooooooool0nYX4ooooo`0Ao`3jV_ooooooooooool00?oooooo0?ZJo`00
oooo003oooooo`3jV_oooooo0?ZJoooooooo003oooooo`3jV_ooool00_l0nYX00ooo003ooooooooo
o`04ooooo`03o`3jV_oooooooooo00Cooooo0ol000001ol0nY[ooooooooooooooooo0?ZJoooooooo
00000_l0nYX01?ooooooo`00o`00ool0nYX2ooooo`;o0?ZJ00Goo`00o`3jV_l0nY[oooooo`3jVP03
ooooo`03o`3jV_oooooooooo00Cooooo0ol0nYX01?ooooooo`00ool00?l00?l3ooooo`03o`3jV_oo
003o0?ZJ00Cooooo0_l0nYX00ooo003o0?ZJooooo`02ooooo`03ool00?l0nY[ooooo01Sooooo00?o
0?ZJooooool0nYX01?ooool01?l0nY[oooooool00?l0nYX3ooooo`03o`3jV_l00?oooooo00;ooooo
00Go0?ZJooooool0nY[o0?ZJool00002ooooo`;oo`0000Ko0?ZJooooooooooooooooo`3jV_oo000:
ooooo`;o0000:?ooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo00Go0?ZJool00?ooooooo`00
o`00o`03ooooo`0:o`3jV_ooooooooooooooool0nY[oo`00oooooooo003o003oo`3jVQ;ooooo00Co
0?ZJoooooooooooo0?ZJ1_ooool01_l0nY[oo`00o`00oooo003o003oo`3jVPKooooo00?o0?ZJoooo
ool0nYX03?ooool01Ol0nY[o003oo`00oooooooo0?ZJ00Oooooo0_l0nYX01Ooo003o0?ZJo`3jV_oo
003o0?ZJ01_ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00Sooooo00?o003oooooooooool01_oo
ool01_l0nY[oo`00o`3jV_ooooooo`00o`3jVPgooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`02ooooo`06o`3jV_oo003oooooool00?ooooooo`000oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooo0?ZJ00_ooooo0_l0nYXQooooo`04o`3jV_oooooo003oo`3jVQKooooo00?o
0?ZJo`00ool0nYX07_ooool2ool00003o`3jV_oooooooooo01Kooooo0_l0nYX9ooooo`?o0?ZJ00?o
0000ooooooooool0>oooool004;ooooo00Co0000oooooooooooo0?ZJ1?ooool01?l0nY[ooooooooo
oooo0002ooooo`0;o`00oooo003oooooo`3jV_oooooo0?ZJoooooooo003oooooo`3jV_ooool00_l0
nYX00ooo003oooooooooo`0;ooooo`?o000000go0?ZJooooooooooooooooo`3jV_l00?ooo`00o`3j
V_oooooo0?ZJool00?l00?oo0?ZJ00;ooooo0_l0nYX01Ooo003o0?ZJoooooooooooo0?ZJ00?ooooo
00?o0?ZJooooooooool01?ooool4o`3jVP03oooooooo003o003o00?ooooo00?o0?ZJool00?l0nYX0
1?ooool2o`3jVP03ool00?l0nY[ooooo00;ooooo00?oo`00o`3jV_ooool06?ooool00ol0nY[ooooo
o`3jVP04ooooo`04o`3jV_ooooooo`00ool000;ooooo0_l0nYX2o`00o`;oo`0000?o0?ZJooooool0
nYX00_oo0002ooooo`?o00000oooool00ol0nY[oo`00ooooo`0:ooooo`03o`000?oooooooooo02Ko
oooo0_l00002ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX2ool00005o`00oooooooooooooooo
ool0nYX00oooool01_l0nY[oo`00o`00oooo003o003oo`3jVQ;ooooo00Co0?ZJoooooooooooo0?ZJ
1_ooool01_l0nY[oo`00o`00oooo003o003oo`3jVPKooooo00?o0?ZJooooool0nYX03Oooool01?l0
nY[o003oooooool0nYX7ooooo`;o0?ZJ00Goo`00o`3jV_l0nY[oo`00o`3jVP0Kooooo`;o0?ZJ3ooo
ool00ol00?ooooooooooo`06ooooo`;o0?ZJ00Coo`00oooooooo003o0?ZJ3?ooool2o`0002Gooooo
00?o0000ooooooooool00_ooool01_l0nY[oo`00oooooooo003oooooool000?ooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooo`3jVP0;ooooo`;o0?ZJ8Oooool01?l0nY[oooooo`00ool0nYXF
ooooo`03o`3jV_l00?oo0?ZJ01kooooo0_oo00000ol0nY[oooooooooo`0Fooooo`;o0?ZJ2Oooool2
o`3jVP;o0000?Oooool004;ooooo00Co0000oooooooooooo0?ZJ1?ooool01_l0nY[oooooooooool0
nY[oo`00ooooo`;oo`0000Woooooo`3jV_ooooooooooo`3jV_oo003oooooo`3jV_ooool00_l0nYX0
0ooo003oooooooooo`0;ooooo`?o000000goooooo`3jV_ooooooooooo`3jV_oo003oooooo`3jV_oo
oooo0?ZJoooooooo003o0?ZJ00;ooooo0_l0nYX01Ooo003o0?ZJoooooooooooo0?ZJ00?ooooo00?o
0?ZJooooooooool01Oooool01?l0nY[oooooo`3jV_ooool2ool000?ooooo00?o0?ZJool00?l0nYX0
1?ooool3o`3jVP06ool00?oooooooooooooooooo003o0?ZJ6Oooool00ol0nY[oooooo`3jVP04oooo
o`05o`3jV_oooooo003oool00?ooool00_l0nYX2o`00o`Coo`0000?oooooo`3jV_oo00000oooool3
o`0000?ooooo00?o0?ZJool00?ooool02_ooool00ol0003oooooooooo`0Vooooo`05o`000?oooooo
ooooooooool0nYX01?ooool2o`3jVP;oo`0000Go003oooooooooooooooooo`3jVP03ooooo`06o`3j
V_ooooooo`00ool00?l00?oo0?ZJ4_ooool01?l0nY[oooooo`3jV_l0nYX6ooooo`03o`3jV_oooooo
o`0000;o003o00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP0=ooooo`;o0?ZJ00?o003o
o`3jV_ooool01_ooool2o`3jVP04ool00?l0nY[o0?ZJool001cooooo0_l0nYXHooooo`;o0?ZJ00Co
o`00oooooooo003o0?ZJ3Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo
00Ko0?ZJool00?ooooooo`00oooooooo0003ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ool0nYX02oooool2o`3jVR;ooooo00?o0?ZJo`00ool0nYX05_ooool00ol0nY[oooooo`3jVP0Noooo
o`;oo`006Oooool2o`3jVPcooooo00?o0000ooooooooool0>oooool004;ooooo00Co0000oooooooo
oooo0?ZJ1?ooool01ol0nY[oooooooooool0nY[oo`00oooooooo00000_ooool02ol0nY[ooooooooo
ool0nY[oo`00o`00ool0nY[oooooo`3jV_oo003o0?ZJ00kooooo00Co0?ZJool00?oo003o0?ZJ0_oo
ool02Ol0nY[oo`00ooooool0nY[oooooo`3jV_ooooooo`00o`00o`02o`3jVP04ooooool0nY[oo`00
o`3jVP?ooooo00?o0?ZJooooool0nYX02?ooool00ol0nY[oooooo`3jVP02ooooo`07ool00?oooooo
ooooooooool0nY[oo`00o`3jVP04ooooo`?o0?ZJ00Koo`00ooooooooooooooooool00?l0nYXIoooo
o`03o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJoooooooo00000_l0nYX2o`00o`;oo`0000Ko003ooooo
oooo003oooooo`3jV_oo0003ooooo`?o00000oooool00ooo003o0?ZJooooo`0:ooooo`03o`000?oo
oooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP04ooooo`;o0?ZJ00?oo`00ooooool00?l0
0oooool01_l0nY[ooooooooooooooooo0?ZJooooo`;oo`0000?o003oo`3jV_ooool04Oooool00ol0
nY[oooooo`3jVP07ooooo`03o`3jV_oooooooooo00;o003o00?o0?ZJooooooooool01?ooool00ol0
nY[oooooo`3jVP0>ooooo`03o`3jV_l00?oo0?ZJ00Oooooo0_l0nYX01?oo003o0?ZJo`3jV_oo000L
ooooo`;o0?ZJ6Oooool01Ol0nY[oo`00oooooooo003o0?ZJ00gooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`02ooooo`06o`3jV_oo003oooooool00?l0nY[oo`000oooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooo0?ZJ00_ooooo00?o0?ZJooooooooool08Oooool00ol0nY[o
003oo`3jVP0Fooooo`03o`3jV_oooooo0?ZJ01kooooo0_oo000Iooooo`;o0?ZJ3?ooool00ol0003o
ooooooooo`0kooooo`00@_ooool01?l0003oooooooooool0nYX4ooooo`07o`3jV_ooooooooooo`3j
V_oo003oooooool00002ooooo`06o`3jV_ooooooooooo`3jV_oo003o003o0ol0nYX00ooo003o0?ZJ
ooooo`0=ooooo`;o0?ZJ00Soo`00ooooool0nY[o0?ZJoooooooo003oooooo`3jVP;ooooo00?o0?ZJ
ool00?l00?l00_l0nYX01?ooooooo`00ool00?l0nYX3ooooo`03o`3jV_oooooo0?ZJ00Sooooo00Go
0?ZJoooooooooooo0?ZJooooo`02ool000;ooooo00?o0?ZJool00?ooool01?ooool3o`3jVP06ool0
0?l0nY[oooooo`3jV_oo003o0?ZJ6Oooool00ol0nY[oooooo`3jVP05ooooo`05o`3jV_l0003o0000
o`000?ooool00_l00?l02?oo003oooooooooool00?ooo`00ooooool0nY[oo`001Oooool01_oo003o
ooooooooooooooooo`00o`3jVP[ooooo0_l0000Xooooo`;o00000_ooool00ol0nY[oooooooooo`02
ooooo`;o0?ZJ00?oo`00o`00ooooool00oooool01_l0nY[ooooooooooooooooo0?ZJooooo`;oo`00
00?o003oo`3jV_ooool04_ooool2o`3jVPOooooo00Go0?ZJoooooooooooo003oo`3jVP07ooooo`03
o`3jV_oooooo0?ZJ00kooooo0ol0nYX7ooooo`?o0?ZJ00?oo`00o`3jV_oo00007?ooool2o`3jVQWo
oooo00Co0?ZJool00?ooooooo`003Oooool2o`0002Gooooo00?o0000ooooooooool00_ooool01_l0
nY[oo`00oooooooo003o0?ZJool000?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooo`3j
VP0_ooooo`03o`3jV_oooooo0?ZJ01Kooooo00?o0?ZJooooool0nYX07_ooool2ool001Wooooo00?o
0?ZJooooooooool02_ooool2o`0003gooooo0012ooooo`04o`000?ooooooooooo`3jVPCooooo00Co
0?ZJoooooooooooo0?ZJ0ooo0002ooooo`07o`3jV_ooooooooooo`3jV_ooooooo`00ooooo`02o`3j
VP03ool00?l0nY[ooooo00kooooo00?o0?ZJool00?ooool00_l0nYX01?ooooooo`00ooooool0nYX2
ooooo`03o`3jV_oo003o003o00;o0?ZJ00?oooooool00?oo00001?ooool00ol0nY[oooooo`3jVP0;
ooooo`04o`3jV_ooooooooooool000;ooooo00?o0?ZJool00?ooool01Oooool2o`3jVP06ool00?l0
nY[oooooo`3jV_oo003o0?ZJ6Oooool00ol0nY[oooooo`3jVP05ooooo`07o`3jV_l0003o0000o`00
0?l00?ooooooool00003ooooo`05o`00oooo003o0?ZJool00?ooool00ol0nYX2ooooo`06ool00?l0
nY[ooooooooooooo003o0?ZJ2oooool00ol0003oooooooooo`0Vooooo`05o`000?oooooooooooooo
ool0nYX01?ooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo00[o0?ZJooooooooooooooooo`3jV_oo
oooo003oooooool00?oo0?ZJ4oooool00ol0nY[oooooooooo`06ooooo`05o`3jV_oooooooooooooo
ool0nYX01oooool00ol0nY[oooooo`3jVP0Hooooo`?o0?ZJ00?oo`00o`3jV_oo00007?ooool2o`3j
VQ[ooooo00?oo`00o`3jV_oo00003_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
00;ooooo00Oo0?ZJool00?ooooooo`00o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooo`3jVP0_ooooo`;o0?ZJ5oooool2o`3jVQoooooo0_oo000Wooooo`03o`000?oo
oooooooo03_ooooo000dooooo`?o00001?ooool2o`0000Gooooo00Go0000ooooooooooooooooo`3j
VP03ooooo`04o`3jV_ooooooooooo`3jVP;oo`0000Co003ooooooooooooo0?ZJ0_ooool01?l0nY[o
ooooool00?ooool2o`3jVP03ool00?l0nY[ooooo00kooooo00?o0?ZJool00?oo00000_ooool01?l0
0?ooo`00ooooool0nYX2ooooo`03o`3jV_oo003o003o00;o0?ZJ0ooo0004ooooo`03o`3jV_oooooo
0?ZJ00_ooooo00?o0?ZJooooooooool00_oo00000ooooooo0?ZJool00006ooooo`08o`3jV_oooooo
o`00o`3jV_oooooo0?ZJool00?l0nYXIooooo`03o`3jV_oooooo0?ZJ00Gooooo00Go0?ZJo`000?l0
003o0000o`00o`02ool000?ooooo00So003oool00?l0nY[oo`00ooooool0nY[oooooo`3jVP;ooooo
00Koo`00o`3jV_ooooooooooool00?l0nYX;ooooo`03o`000?oooooooooo02Kooooo00Go0000oooo
ooooooooooooo`3jVP04ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00;ooooo0_l00?l00ol0nY[oooooooooo`0Kooooo`04o`3jV_ooooooooooo`3jVPOooooo
00?o0?ZJooooool0nYX06?ooool3o`3jVP03ool00?l0nY[oo`0001cooooo0_l0nYXJooooo`03ool0
0?ooooooo`0000kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`03o`3j
V_oo003ooooo00?oo`0000?o0?ZJooooool0nYX02Oooool00ol0nY[oooooo`3jVP0_ooooo`;o0?ZJ
5oooool2o`3jVQoooooo00?oo`00o`3jV_ooool09_ooool00ol0003oooooooooo`0kooooo`00=Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Go0000oooooooooooo
ooooo`3jVP03ooooo`06o`3jV_ooooooooooo`3jV_oooooo003o0oooool01ol0nY[oooooooooool0
nY[oooooool00?ooool00_l0nYX00ooo003o0?ZJooooo`0?ooooo`08o`3jV_oo003ooooooooooooo
003o003oooooool0nYX2ooooo`03o`3jV_ooooooo`0000;o0?ZJ0ooo0004ooooo`03o`3jV_oooooo
0?ZJ00cooooo00?o0?ZJooooool00?l01?oo0006ooooo`08o`3jV_ooooooo`00o`3jV_oooooo0?ZJ
ool00?l0nYXJooooo`;o0?ZJ1_ooool3o`3jVP;oo`001Oooool01?oo003o0?ZJool00?l0nYX2oooo
o`;o0?ZJ00?oooooool00?l0nYX00_ooool00ooo003o0?ZJooooo`0:ooooo`03o`000?oooooooooo
02Kooooo00Go0000ooooooooooooooooo`3jVP04ooooo`;o0?ZJ00?o003oo`3jV_l0nYX00_ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;o003o00?o0?ZJooooooooool06oooool0
1?l0nY[oooooooooool0nYX7ooooo`03o`3jV_oooooo0?ZJ01Wooooo0_l0nYX00ooo003oooooool0
000Looooo`;o0?ZJ6_ooool00ooo003oooooool0000>ooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool00_ooool00ol0nY[oo`00ooooo`03ool00003o`3jV_oooooo0?ZJ00Wooooo0_l0
nYX`ooooo`;o0?ZJ5oooool2o`3jVQoooooo0_l0nYXWooooo`03o`000?oooooooooo03_ooooo000e
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`0000;ooooo00Go
0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_l00?oo003o00?ooooo00Ko0?ZJoooooooooooo
0?ZJoooooooo0002ooooo`03o`3jV_oo003ooooo013ooooo00Ko0?ZJool00?ooooooooooool00?oo
ool2o`3jVP;ooooo00Go0?ZJoooooooo003o003oooooo`02ool00003o`3jV_oooooooooo00;ooooo
00?o0?ZJooooool0nYX03?ooool01?l0nY[oooooo`00ooooool3ool000Kooooo00So0?ZJoooooooo
003o0?ZJooooool0nY[oo`00o`3jVQ[ooooo0_l0nYX6ooooo`?o0?ZJ1oooool01?oo003o0?ZJool0
0?l0nYX3ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool02Oooool2o`0002So
oooo0_l00002ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX00ol00?oo0?ZJo`3jVP02ooooo`03
o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_l00?l00ol0nY[oooooooooo`0Kooooo`04
o`3jV_ooooooooooo`3jVPSooooo0_l0nYXIooooo`;o0?ZJ0_oo00000ol0nY[oooooooooo`0Joooo
o`;o0?ZJ6_ooool00ooo003o003oool0000=ooooo`;o00009Oooool00ol0003oooooooooo`02oooo
o`03o`3jV_oo003ooooo00?oo`0000?o0?ZJooooool0nYX02Oooool2o`3jVS3ooooo0_l0nYXGoooo
o`;o0?ZJ7oooool2o`3jVRKooooo0_l0000mooooo`00=Oooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000Cooooo00Go0000ooooooooooooooooo`3jVP03ooooo`04o`3jV_oooooo
ooooo`3jVP;o003o0oooool02_l0nY[ooooooooooooooooo0?ZJool00?l00?ooooooo`3jV_oo000A
ooooo`07o`3jV_oo003o003oo`00oooo003oooooo`3jVP04ooooo`04o`3jV_oo003o003oooooo`;o
o`0000?o0?ZJooooooooool00oooool2o`3jVPcooooo0_l0nYX00ol00?ooooooooooo`02ool000Ko
oooo00So0?ZJoooooooo003o0?ZJooooool0nY[oo`00o`3jVQ[ooooo0_l0nYX6ooooo`?o0?ZJ1?oo
ool2o`3jVP05oooooooo003oo`00ooooool0nYX00oooool3o`3jVP05ool00?ooooooooooool00?l0
nYX02oooool00ol0003oooooooooo`0Hooooo`Go00000oooool2o`0000Cooooo00Go0000oooooooo
ooooooooo`3jVP04ooooo`;o0?ZJ00Ko003oo`3jV_oooooo0?ZJooooool0nYX5ooooo`05o`3jV_oo
ooooooooooooool0nYX07Oooool01?l0nY[oooooooooool0nYX8ooooo`;o0?ZJ6oooool2ool00003
o`3jV_oooooooooo01[ooooo0_l0nYXJooooo`03o`3jV_oo003oo`0000kooooo00?o0000oooooooo
ool05Oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooo
003o0?ZJ0_oo00000ooooooo0?ZJo`3jVP09ooooo`;o0?ZJ<?ooool2o`3jVQOooooo0_l0nYXOoooo
o`;o0?ZJ9oooool00ol0003oooooooooo`0kooooo`00=Oooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000Cooooo00Go0000ooooooooooooooooo`3jVP03ooooo`04o`3jV_oooooo
ooooo`3jVP;o003o0oooool02_l0nY[ooooooooooooooooo0?ZJool00?l00?ooooooo`3jV_oo000A
ooooo`03o`3jV_ooooooo`0000;oo`0000?oooooo`3jV_ooool00oooool01?l0nY[oo`00o`00oooo
ool2ool00003o`3jV_oooooooooo00?ooooo0_l0nYX=ooooo`06o`3jV_l00?oooooooooooooo003o
0?ZJ1_ooool01ol0nY[oooooo`3jV_oo003oooooo`3jV_oo00006oooool2o`3jVPOooooo0ol0nYX2
ooooo`03o`3jV_oooooooooo00?o000000?o0?ZJooooooooool00_ooool3o`3jVP05ool00?oooooo
0?ZJool00?l0nYX02oooool00ol0003oooooooooo`0Iooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo0_l0nYX01_l0
0?oo0?ZJooooool0nY[oooooo`3jVPGooooo00Go0?ZJooooooooooooooooo`3jVP0Mooooo`;o0?ZJ
00?oooooo`3jV_ooool01oooool2o`3jVQ_ooooo0_oo00000ol0nY[oooooooooo`0Jooooo`;o0?ZJ
6_ooool00ol0nY[oo`00o`3jVP0>ooooo`03o`000?oooooooooo01Cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool01?l0
nY[oooooool00?l0nYX2ool00003ooooool0nY[o0?ZJ00Wooooo0_l0nYX`ooooo`;o0?ZJ>?ooool2
o`3jVROooooo00?o0000ooooooooool0>oooool003Cooooo0_l00004ooooo`04o`000?oooooooooo
o`0000Cooooo00Go0000ooooooooooooooooo`3jVP03ooooo`06o`3jV_ooooooooooooooool0nY[o
003o0oooool02?l0nY[ooooooooooooooooo0?ZJoooooooo003ooooo0_oo000Booooo`05o`3jV_oo
003oo`00ooooool0nYX01Oooool01?l0nY[oo`00o`00ool00?l3o`0000Gooooo0_l0nYX=ooooo`06
o`3jV_l00?oooooooooooooo003o0?ZJ2?ooool01Ol0nY[oo`00ooooool0nY[oo`0001_ooooo0_l0
nYX9ooooo`?o0?ZJ0oooool3o`000003o`3jV_oooooooooo00?ooooo0_l0nYX01?oo003o0?ZJo`3j
V_oo000<ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00003ooooo`05o`000?ooooooooooooooool0nYX01?ooool02?l0nY[oooooo`3jV_l0nY[o
ooooo`3jV_oooooo0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ01kooooo0ol0nYX8ooooo`;o
0?ZJ6oooool2ool00003o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool06?ooool00ol0nY[o
003oo`3jVP0>ooooo`03o`000?oooooooooo01Sooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooo003o0?ZJ0_oo0000
0ooooooo0?ZJo`3jVP0:ooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJooooooooool0=oooool2
o`3jVROooooo00?o0000ooooooooool0>oooool003Gooooo00?o0000ooooooooool00oooool2o`00
00Gooooo00Go0000ooooooooooooooooo`3jVP03ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0ooo
ool02?l0nY[ooooooooooooooooo0?ZJoooooooo003o003o0_oo000Booooo`05o`3jV_oooooooooo
ooooool0nYX01Oooool01?l0nY[oooooool00?l00?l3o`0000Gooooo0_l0nYX=ooooo`;o0?ZJ0_oo
ool00ooo003o0?ZJooooo`07ooooo`05o`3jV_oo003oooooo`3jV_oo00006oooool2o`3jVP[ooooo
00?o0?ZJooooooooool00_ooool3o`000003o`3jV_oooooooooo00?ooooo0_l0nYX01?oo003o0?ZJ
o`3jV_oo000;ooooo`;o00007Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooooooo0_l00002ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJooooool0nY[o0?ZJoooo
o`02o`3jVPKooooo00Go0?ZJooooooooooooooooo`3jVP0Oooooo`03o`3jV_oooooooooo00Oooooo
0_l0nYXKooooo`03o`3jV_oo003o0?ZJ01gooooo00?o0?ZJooooooooool06?ooool00ol0nY[ooooo
o`3jVP0<ooooo`?o00006_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00;o
oooo0_l00003ooooo`04o`3jV_ooooooo`00o`3jVP;oo`0000?oooooo`3jV_l0nYX0MOooool2o`3j
VRKooooo0_l0000mooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00Co0?ZJoooo
oooooooooooo0_l0nYX3ooooo`08o`3jV_ooooooooooooooool0nY[oooooool00?l00?l2ool001;o
oooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`04o`3jV_ooooooo`00ool000?o00001Oooool2
o`3jVPkooooo00Co0?ZJo`00ooooooooo`002Oooool01Ol0nY[oo`00o`3jV_l0nY[oo`0001_ooooo
0_l0nYX@ooooo`;o0?ZJ1_ooool00ol0nY[oooooool00002o`3jVP03ool00?oooooooooo00[ooooo
00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo00?o0?ZJooooool0nYX00_ooool2
o`3jVPKooooo00Go0?ZJooooooooooooooooo`3jVP0Yooooo`;o0?ZJ6oooool00ol0nY[o003oo`3j
VP0Mooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooool0nYX03_ooool00ol0003ooooooooo
o`0Dooooo`Co00000oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo
00Co0?ZJoooooooo003o0?ZJ0_oo00000ooooooo0?ZJooooo`1eooooo`03o`3jV_oooooooooo02Ko
oooo00?o0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03
o`3jV_oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`04o`3jV_ooooooo`00
o`00o`;oo`004_ooool00ol0nY[oooooooooo`02o`3jVPGooooo00Ko0?ZJoooooooo003oo`00o`00
ool0nYX6ooooo`;o0?ZJ3_ooool01?l0nY[o003ooooooooo0009ooooo`05o`3jV_oo003o0?ZJool0
0?l0nYX06oooool2o`3jVQ7ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooool00002o`3j
VP03ool00?oooooooooo00[ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo
00?o0?ZJooooool0nYX02_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ02Wooooo0_l0nYXKooooo`03
o`3jV_l00?oo0?ZJ01gooooo00?o0?ZJooooooooool06Oooool2o`3jVPkooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooo
ooooool00_ooool01?l0nY[oooooool00?l0nYX2ool00:7ooooo00?o0000ooooooooool0>oooool0
04;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJ
ooooooooooooooooo`3jVP03ooooo`03o`3jV_ooooooo`0000?oo`004_ooool2o`3jVP03ooooool0
nY[ooooo00Gooooo00?o0?ZJooooooooool00_l00?l00ol0nY[oooooooooo`04ooooo`;o0?ZJ3ooo
ool00ol0nY[o003oool00009ooooo`05o`3jV_oo003o0?ZJool00?l0nYX06oooool2o`3jVQ[ooooo
00Coo`00o`3jV_l0nY[oo`003?ooool00ol0003oooooooooo`0Iooooo`?o00001?ooool2o`0000Co
oooo0_l00002ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02_ooool3o`3jVP03
ooooool0nY[ooooo02Sooooo0_l0nYXKooooo`03o`3jV_oooooo0?ZJ01gooooo00?o0?ZJoooooooo
ool06Oooool00ol0nY[oooooooooo`0<ooooo`;o00005_ooool5o`0000?ooooo0_l00005ooooo`03
o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0_oo002Pooooo`;o0000?Oooool004;o
oooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooo
oooooooo0?ZJ0oooool00ol0nY[oooooooooo`03ool001?ooooo0ol0nYX7ooooo`05o`3jV_oooooo
003oo`00ool0nYX01_ooool2o`3jVQ3ooooo0ol00009ooooo`04ool00?l0nY[oo`00o`3jVQ_ooooo
0_l0nYXJooooo`04o`3jV_oo003oo`00o`3jVPcooooo00?o0000ooooooooool09_ooool01Ol0003o
oooooooooooooooo0?ZJ00Cooooo00?o0?ZJooooooooool02_ooool3o`3jVP03ooooool0nY[ooooo
02Sooooo0_l0nYXKooooo`03o`3jV_oooooo0?ZJ01gooooo00?o0?ZJooooooooool0:Oooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0
nYZQooooo`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00ooo
ool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00Co0?ZJoooooooooooo
003o0_oo000Cooooo`;o0?ZJ2?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo00?o0?ZJoooo
ooooool03_ooool3o`0000Wooooo00Coo`00oooooooo003o0?ZJ7?ooool00ol0nY[oooooooooo`0H
ooooo`04o`3jV_oo003oo`00o`3jVP_ooooo0_l0000Xooooo`05o`000?ooooooooooooooool0nYX0
1?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ02Wooooo0_l0nYXKooooo`;o0?ZJ
7_ooool00ol0nY[oooooooooo`0Yooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
0_ooool01_l0nY[oooooooooool0nY[oo`00o`3jVZ7ooooo00?o0000ooooooooool0>oooool004;o
oooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooo
oooooooo0?ZJ1?ooool00ol0nY[oooooo`00o`02ool001gooooo00Go0?ZJooooooooooooooooo`3j
VP07ooooo`03o`3jV_oooooooooo00kooooo0ol00009ooooo`04ool00?l00?ooo`00o`3jVSOooooo
00Co0?ZJool00?oo003o0?ZJ3?ooool00ol0003oooooooooo`0Vooooo`05o`000?oooooooooooooo
ool0nYX01?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ02[ooooo00?o0?ZJoooo
ooooool06_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo02Wooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`02ooooo`06o`3jV_ooooooooooo`3jV_oo003o0?ZJXOoo
ool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00?o
0?ZJooooooooool00oooool01?l0nY[oooooooooool0nYX4ooooo`03o`3jV_oooooo000000;o0000
7Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo00?o0?ZJooooooooool03_ooool00ol00?oo
ooooooooo`09ooooo`04o`3jV_oo003oo`00o`3jVSOooooo00Co0?ZJool00?oo003o0?ZJ3?ooool0
0ol0003oooooooooo`0Vooooo`;o00000_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00cooooo00?o0?ZJooooool0nYX0:_ooool00ol0nY[oooooooooo`1Tooooo`;o00009Oooool0
0ol0003oooooooooo`02ooooo`06o`3jV_ooooooooooo`3jV_oo003o0?ZJX?ooool2o`0003gooooo
0012ooooo`05o`000?ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`03ooooo`04o`3j
V_ooooooooooo`3jVPCooooo00?o0?ZJooooool000000_l0000Mooooo`04o`3jV_ooooooooooo`3j
VPSooooo00?o0?ZJooooooooool06_ooool01?l0nY[oo`00ool00?l0nYXgooooo`04o`3jV_oo003o
o`00o`3jVPcooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo
0_l0nYX>ooooo`;o0?ZJ:oooool00ol0nY[oooooooooo`1Uooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool00_ooool01_l0nY[oooooooooool0nY[oo`00o`3jVZ7ooooo00?o0000oooo
ooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo
00?ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`000002o`0001kooooo00?o0?ZJ
ooooool0nYX02?ooool00ol0nY[oooooooooo`0Jooooo`04o`3jV_oo003oo`00o`3jVSSooooo0_l0
nYX<ooooo`;o0000:?ooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00;o0?ZJ3_oo
ool2o`3jVY?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`03o`3jV_oo
oooooooo00?o0?ZJXOooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooo
oooo0?ZJ00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool0nYX4ooooo`04o`3j
V_ooooooooooo`3jVQoooooo0ol0nYX8ooooo`03o`3jV_oooooooooo01[ooooo00Co0?ZJool00?l0
0?oo0?ZJ>?ooool2o`3jVPgooooo00?o0000ooooooooool09_ooool2o`0000?ooooo00?o0?ZJoooo
ooooool00_l0nYX>ooooo`;o0?ZJT_ooool2o`0002Gooooo00?o0000ooooooooool00_ooool00ol0
nY[oooooooooo`03o`3jVZ3ooooo0_l0000mooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ
00?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP04ooooo`04o`3jV_oooooooooo
o`3jVR7ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
0?ZJ03Wooooo0_l0nYX=ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool00_ooool0
0ol0nY[oooooooooo`02o`3jVPkooooo0_l0nYZCooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool00_ooool00ol0nY[oooooooooo`03o`3jVZ7ooooo00?o0000ooooooooool0>oooool0
04;ooooo00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYX6ooooo`?o0?ZJ1?ooool0
1?l0nY[oooooooooool0nYXZooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX0>Ooo
ool2o`3jVPgooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`02ooooo`03o`3jV_oo
oooooooo00;o0?ZJ3oooool00ol0nY[oooooooooo`2Aooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool00_ooool00ol0nY[oooooooooo`03o`3jVZ7ooooo00?o0000ooooooooool0>ooo
ool004;ooooo00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYX6ooooo`;o0?ZJ1_oo
ool3o`3jVTOooooo00?o0?ZJooooool0nYX0>Oooool2o`3jVPcooooo0_l0000Xooooo`03o`000?oo
oooooooo00;ooooo00?o0?ZJooooooooool00_l0nYX?ooooo`03o`3jV_oooooooooo097ooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00?o0?ZJXOoo
ool00ol0003oooooooooo`0kooooo`00@_ooool00ol0003oooooooooo`02ooooo`04o`3jV_oooooo
ooooo`3jVPKooooo0_l0nYX6ooooo`?o0?ZJB?ooool2o`3jVTSooooo00?o0000ooooooooool09_oo
ool2o`0000?ooooo00?o0?ZJooooooooool00_l0nYZRooooo`;o00009Oooool00ol0003ooooooooo
o`02ooooo`03o`3jV_oooooooooo00;o0?ZJXOooool2o`0003gooooo000cooooo`Go00000oooool2
o`0000Gooooo00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYX>ooooo`?o0?ZJB?oo
ool00ol0nY[oooooooooo`17ooooo`03o`000?oooooooooo01Wooooo0ol00004ooooo`;o00001?oo
ool00ol0003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVZCooooo00?o0000ooooooooool0
5Oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool0
0_l0nYZRooooo`03o`000?oooooooooo03_ooooo000dooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3j
VQ3ooooo00?o0?ZJooooooooool01_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
01[ooooo00?o0?ZJooooooooool00_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVQ[ooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo
00?o0000ooooooooool07oooool2o`0001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`02o`3j
VQSooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0kooooo`00=Oooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo1Ol000001?l0nY[o0000o`000?l0nYX@
o`000003o`3jV_l0003o0000097o00007_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooooooo`Go000000Co0?ZJo`000?l0003o0?ZJYOl0000Fooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00004ooooo`Go000000Co0?ZJo`000?l0003o0?ZJY?l0
000mooooo`00=_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0booo
ool2o`0000?ooooo00Co0000oooooooooooo0000aoooool4o`0000?ooooo00Co0000oooooooooooo
0000k_ooool003?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
0<oooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`35ooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo0000k_ooool003?ooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`000<_ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`000<Sooooo00?o0000ooooooooool00oooool01?l0003oooooooooool0003^
ooooo`00=?ooool3o`0000Cooooo0_l0003=ooooo`?o00001?ooool2o`0005Oooooo0ol0001`oooo
o`;o00001?ooool2o`000>oooooo003oooooofcooooo00?o0000ooooooooool0oooooomWooooo`00
UOooool2o`000003ooooool0003o00000=;ooooo00?o0000ooooooooool0c_ooool5o`0009;ooooo
002Fooooo`03o`000?oooooo00000=?ooooo00?o0000ooooooooool0coooool01?l0003ooooooooo
ool0002Booooo`00Uoooool00ol0003oooooooooo`3Aooooo`03o`000?oooooo00000=7ooooo00?o
0000ooooooooool0T_ooool009Kooooo00?o0000ooooool00000d_ooool00ol0003oooooo`00003?
ooooo`04o`000?ooooooooooo`0009?ooooo002Eooooo`;o000000?oooooo`000?l00000d?ooool2
o`000003ooooool0003o00000<kooooo1Ol0002Booooo`00ooooooooooooomKooooo003ooooooooo
ooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo003oooooooooooooe_ooool0
0?oooooooooooooFooooo`00ooooooooooooomKooooo003oooooooooooooe_ooool00?oooooooooo
oooFooooo`00ooooooooooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00
ooooooooooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00oooooooooooo
omKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo003o
ooooooooooooe_ooool00?ooooooF_ooool00ol0003oooooooooo`0Cooooo`?o00000oooool3o`00
0?ooooooGOooool00?ooooooFoooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0oooooomLooooo`00oooooom8ooooo`;o00000_ooool3o`000003oooo
ool0003o000000?o00001_ooool00ol0003oooooooooo`06ooooo`;o000000?oooooo`000?l00000
0_ooool4o`0000;ooooo0ol00003ooooo`?o00000oooool4o`0000;ooooo1?l00003ooooo`;o0000
oooooom:ooooo`00oooooom7ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo000000;ooooo00Co0000oooooooo
oooo00000oooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo0000
0_ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`000?ooooooBOooool00?oooooo
Aoooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000?ooooo00?o0000oooooooo
ool03oooool2o`0000Cooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool3o`0000?ooooo1?l00002ooooo`04o`000?ooooooooooo`000?ooooooBOoo
ool00?ooooooAoooool01?l0003oooooooooool00002ooooo`;o00001?ooool3o`0000oooooo00?o
0000ooooool000000_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;o
oooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo00Oooooo00Co0000
oooooooooooo0000oooooom9ooooo`00oooooom7ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooool000000oooool00ol0003oooooooooo`0?ooooo`04o`000?oooooo0000o`0000;ooooo
0_l00003ooooo`Co00000_ooool4o`0000?ooooo0_l0000:ooooo`04o`000?ooooooooooo`000?oo
ooooBOooool00?ooooooAoooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`0Qooooo`04o`000?oooooo
ooooo`000?ooooooBOooool00?ooooooA_ooool3o`000003ooooool0003o000000?o000000?ooooo
o`000?l000001Ol0000=ooooo`;o00009?ooool2o`000?ooooooB_ooool00?oooooooooooooFoooo
o`00ooooooooooooomKooooo0000\
\>"],
  ImageRangeCache->{{{0, 723.312}, {297.438, 0}} -> {-0.19433, -0.0309084, \
0.00468492, 0.00468492}, {{41.4375, 254.875}, {290.812, 158.875}} -> \
{-365.886, 3.33226, 5.80218, 0.0937875}, {{254.875, 468.375}, {290.812, \
158.875}} -> {-1604.47, 23.3322, 5.80218, 0.0937875}, {{468.375, 681.812}, \
{290.812, 158.875}} -> {-2825.65, -1.33419, 5.80218, 0.07503}, {{41.4375, \
254.875}, {158.875, 27}} -> {-383.787, -100.248, 5.80545, 0.469201}, \
{{254.875, 468.375}, {158.875, 27}} -> {-1623.07, -114.297, 5.80545, \
0.56304}, {{468.375, 681.812}, {158.875, 27}} -> {-2844.94, -84.2975, \
5.80545, 0.56304}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF, kappa=-3; p+kappa=6-3=3", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta+1, 
\t     {driftLorenzX, diffusionLorenzX, hLorenzX, RLorenzX, \
mueLorenzX,sigmaLorenzX,dt,kappa=-3},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1.4708310000000324`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({100.659036047542`, 161.96937181534884`, 223.35510643446798`, 
      54.10078901914321`, 11.076293258681892`, 
      24.816919020337874`}\)], "Output"],

Cell[BoxData[
    \({{0.2596687948211193`, 
        0.2352647773062188`, \(-2.9688160002287525`\), \(-1.5972970168214966`\
\), \(-0.17662134212738312`\), 0.5804298059314938`}, {3.17091335983781`, 
        5.113953462956135`, 6.404982237386285`, 0.6104208721414276`, 
        0.302269105511632`, 0.527603493016185`}}\)], "Output"]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,15},{25,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.001{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,color->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-30\), 20}, {\(-30\), 30}, {0, 60}, {5, 15}, {25, 35}, {0, 
        8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gUKFkappam3=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{\
graph1[4],graph1[5],graph1[6]}}],PlotLabel->\"UKF, kappa=-3\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -41 0 ]
[.5 .42452 41 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -102 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
(-) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
141.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -0.309017 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -6 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -6 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(6)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(8)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(10)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(12)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(14)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30902 m
.001 .30902 L
.002 .30902 L
.003 .30902 L
.004 .30902 L
.005 .30902 L
.00599 .30902 L
.00699 .30902 L
.00799 .30902 L
.00899 .30902 L
.00999 .30902 L
.01099 .30902 L
.01199 .30902 L
.01299 .30902 L
.01399 .30902 L
.01499 .30902 L
.01598 .30902 L
.01698 .30902 L
.01798 .30902 L
.01898 .30902 L
.01998 .30902 L
.02098 .30902 L
.02198 .30902 L
.02298 .30902 L
.02398 .30902 L
.02498 .30902 L
.02597 .30902 L
.02697 .30902 L
.02797 .30902 L
.02897 .30902 L
.02997 .30902 L
.03097 .30902 L
.03197 .30902 L
.03297 .30902 L
.03397 .30902 L
.03497 .30902 L
.03596 .30902 L
.03696 .30902 L
.03796 .30902 L
.03896 .30902 L
.03996 .30902 L
.04096 .30902 L
.04196 .30902 L
.04296 .30902 L
.04396 .30902 L
.04496 .30902 L
.04595 .30902 L
.04695 .30902 L
.04795 .30902 L
.04895 .30902 L
Mistroke
.04995 .30902 L
.05095 .30902 L
.05195 .30902 L
.05295 .30902 L
.05395 .30902 L
.05495 .30902 L
.05594 .30902 L
.05694 .30902 L
.05794 .30902 L
.05894 .30902 L
.05994 .30902 L
.06094 .30902 L
.06194 .30902 L
.06294 .30902 L
.06394 .30902 L
.06494 .30902 L
.06593 .30902 L
.06693 .30902 L
.06793 .30902 L
.06893 .30902 L
.06993 .30902 L
.07093 .30902 L
.07193 .30902 L
.07293 .30902 L
.07393 .30902 L
.07493 .30902 L
.07592 .30902 L
.07692 .30902 L
.07792 .30902 L
.07892 .30902 L
.07992 .30902 L
.08092 .30902 L
.08192 .30902 L
.08292 .30902 L
.08392 .30902 L
.08492 .30902 L
.08591 .30902 L
.08691 .30902 L
.08791 .30902 L
.08891 .30902 L
.08991 .30902 L
.09091 .30902 L
.09191 .30902 L
.09291 .30902 L
.09391 .30902 L
.09491 .30902 L
.0959 .30902 L
.0969 .30902 L
.0979 .30902 L
.0989 .30902 L
Mistroke
.0999 .30902 L
.1009 .30902 L
.1019 .30902 L
.1029 .30902 L
.1039 .30902 L
.1049 .30902 L
.10589 .30902 L
.10689 .30902 L
.10789 .30902 L
.10889 .30902 L
.10989 .30902 L
.11089 .30902 L
.11189 .30902 L
.11289 .30902 L
.11389 .30902 L
.11489 .30902 L
.11588 .30902 L
.11688 .30902 L
.11788 .30902 L
.11888 .30902 L
.11988 .30902 L
.12088 .30902 L
.12188 .30902 L
.12288 .30902 L
.12388 .30902 L
.12488 .30902 L
.12587 .30902 L
.12687 .30902 L
.12787 .30902 L
.12887 .30902 L
.12987 .30902 L
.13087 .30902 L
.13187 .30902 L
.13287 .30902 L
.13387 .30902 L
.13487 .30902 L
.13586 .30902 L
.13686 .30902 L
.13786 .30902 L
.13886 .30902 L
.13986 .30902 L
.14086 .30901 L
.14186 .30901 L
.14286 .30901 L
.14386 .30901 L
.14486 .30901 L
.14585 .30901 L
.14685 .30901 L
.14785 .30901 L
.14885 .30901 L
Mistroke
.14985 .30901 L
.15085 .30901 L
.15185 .30901 L
.15285 .30901 L
.15385 .30902 L
.15485 .30902 L
.15584 .30902 L
.15684 .30902 L
.15784 .30902 L
.15884 .30902 L
.15984 .30902 L
.16084 .30902 L
.16184 .30902 L
.16284 .30902 L
.16384 .30902 L
.16484 .30902 L
.16583 .30902 L
.16683 .30902 L
.16783 .30902 L
.16883 .30902 L
.16983 .30902 L
.17083 .30902 L
.17183 .30902 L
.17283 .30902 L
.17383 .30902 L
.17483 .30902 L
.17582 .30902 L
.17682 .30902 L
.17782 .30902 L
.17882 .30902 L
.17982 .30902 L
.18082 .30902 L
.18182 .30902 L
.18282 .30902 L
.18382 .30902 L
.18482 .30902 L
.18581 .30902 L
.18681 .30902 L
.18781 .30902 L
.18881 .30902 L
.18981 .30902 L
.19081 .30902 L
.19181 .30902 L
.19281 .30902 L
.19381 .30902 L
.19481 .30902 L
.1958 .30902 L
.1968 .30902 L
.1978 .30902 L
.1988 .30902 L
Mistroke
.1998 .30902 L
.2008 .30902 L
.2018 .30902 L
.2028 .30902 L
.2038 .30902 L
.2048 .30901 L
.20579 .30902 L
.20679 .30902 L
.20779 .30901 L
.20879 .30902 L
.20979 .30902 L
.21079 .30902 L
.21179 .30902 L
.21279 .30902 L
.21379 .30902 L
.21479 .30902 L
.21578 .30901 L
.21678 .30901 L
.21778 .30901 L
.21878 .30901 L
.21978 .30901 L
.22078 .30901 L
.22178 .30901 L
.22278 .30901 L
.22378 .30901 L
.22478 .30901 L
.22577 .30901 L
.22677 .30901 L
.22777 .30901 L
.22877 .30901 L
.22977 .30901 L
.23077 .30901 L
.23177 .30901 L
.23277 .30901 L
.23377 .30901 L
.23477 .30901 L
.23576 .30901 L
.23676 .30901 L
.23776 .30901 L
.23876 .30901 L
.23976 .30901 L
.24076 .30901 L
.24176 .30901 L
.24276 .30901 L
.24376 .30901 L
.24476 .30901 L
.24575 .30901 L
.24675 .30901 L
.24775 .30901 L
.24875 .30901 L
Mistroke
.24975 .30901 L
.25075 .30901 L
.25175 .30901 L
.25275 .30901 L
.25375 .30901 L
.25475 .30901 L
.25574 .30901 L
.25674 .30901 L
.25774 .30901 L
.25874 .30901 L
.25974 .30901 L
.26074 .30901 L
.26174 .30901 L
.26274 .30901 L
.26374 .30901 L
.26474 .30901 L
.26573 .30901 L
.26673 .30901 L
.26773 .30901 L
.26873 .30901 L
.26973 .30901 L
.27073 .30901 L
.27173 .30901 L
.27273 .30901 L
.27373 .30901 L
.27473 .30901 L
.27572 .30901 L
.27672 .30901 L
.27772 .30901 L
.27872 .30901 L
.27972 .30901 L
.28072 .30901 L
.28172 .30901 L
.28272 .30901 L
.28372 .30901 L
.28472 .30901 L
.28571 .30901 L
.28671 .30901 L
.28771 .30901 L
.28871 .30901 L
.28971 .30901 L
.29071 .30901 L
.29171 .30901 L
.29271 .30901 L
.29371 .30901 L
.29471 .30901 L
.2957 .30901 L
.2967 .30901 L
.2977 .30901 L
.2987 .30901 L
Mistroke
.2997 .30901 L
.3007 .30901 L
.3017 .30901 L
.3027 .30901 L
.3037 .30901 L
.3047 .30901 L
.30569 .30901 L
.30669 .30901 L
.30769 .30901 L
.30869 .30901 L
.30969 .30901 L
.31069 .30901 L
.31169 .30901 L
.31269 .30901 L
.31369 .30901 L
.31469 .30901 L
.31568 .30901 L
.31668 .309 L
.31768 .30901 L
.31868 .30901 L
.31968 .30901 L
.32068 .30901 L
.32168 .30901 L
.32268 .30901 L
.32368 .30901 L
.32468 .30901 L
.32567 .30901 L
.32667 .30901 L
.32767 .309 L
.32867 .309 L
.32967 .309 L
.33067 .309 L
.33167 .309 L
.33267 .309 L
.33367 .309 L
.33467 .309 L
.33566 .309 L
.33666 .309 L
.33766 .309 L
.33866 .309 L
.33966 .309 L
.34066 .309 L
.34166 .309 L
.34266 .309 L
.34366 .309 L
.34466 .309 L
.34565 .309 L
.34665 .309 L
.34765 .309 L
.34865 .309 L
Mistroke
.34965 .309 L
.35065 .309 L
.35165 .309 L
.35265 .309 L
.35365 .309 L
.35465 .309 L
.35564 .309 L
.35664 .309 L
.35764 .309 L
.35864 .309 L
.35964 .309 L
.36064 .309 L
.36164 .309 L
.36264 .309 L
.36364 .309 L
.36464 .309 L
.36563 .309 L
.36663 .309 L
.36763 .309 L
.36863 .309 L
.36963 .309 L
.37063 .309 L
.37163 .309 L
.37263 .309 L
.37363 .309 L
.37463 .309 L
.37562 .309 L
.37662 .309 L
.37762 .309 L
.37862 .309 L
.37962 .309 L
.38062 .309 L
.38162 .309 L
.38262 .309 L
.38362 .309 L
.38462 .309 L
.38561 .309 L
.38661 .309 L
.38761 .309 L
.38861 .309 L
.38961 .309 L
.39061 .309 L
.39161 .309 L
.39261 .309 L
.39361 .309 L
.39461 .309 L
.3956 .309 L
.3966 .309 L
.3976 .309 L
.3986 .309 L
Mistroke
.3996 .309 L
.4006 .309 L
.4016 .309 L
.4026 .309 L
.4036 .309 L
.4046 .309 L
.40559 .309 L
.40659 .309 L
.40759 .309 L
.40859 .309 L
.40959 .309 L
.41059 .309 L
.41159 .309 L
.41259 .309 L
.41359 .309 L
.41459 .309 L
.41558 .309 L
.41658 .309 L
.41758 .309 L
.41858 .309 L
.41958 .309 L
.42058 .309 L
.42158 .309 L
.42258 .309 L
.42358 .30901 L
.42458 .309 L
.42557 .309 L
.42657 .309 L
.42757 .309 L
.42857 .309 L
.42957 .309 L
.43057 .309 L
.43157 .309 L
.43257 .309 L
.43357 .309 L
.43457 .309 L
.43556 .309 L
.43656 .309 L
.43756 .309 L
.43856 .309 L
.43956 .309 L
.44056 .309 L
.44156 .309 L
.44256 .309 L
.44356 .309 L
.44456 .309 L
.44555 .309 L
.44655 .309 L
.44755 .309 L
.44855 .309 L
Mistroke
.44955 .309 L
.45055 .309 L
.45155 .309 L
.45255 .309 L
.45355 .309 L
.45455 .309 L
.45554 .309 L
.45654 .309 L
.45754 .309 L
.45854 .309 L
.45954 .309 L
.46054 .309 L
.46154 .309 L
.46254 .309 L
.46354 .309 L
.46454 .309 L
.46553 .309 L
.46653 .309 L
.46753 .309 L
.46853 .309 L
.46953 .309 L
.47053 .309 L
.47153 .309 L
.47253 .309 L
.47353 .309 L
.47453 .309 L
.47552 .309 L
.47652 .309 L
.47752 .309 L
.47852 .309 L
.47952 .309 L
.48052 .309 L
.48152 .309 L
.48252 .309 L
.48352 .309 L
.48452 .309 L
.48551 .309 L
.48651 .309 L
.48751 .309 L
.48851 .309 L
.48951 .309 L
.49051 .309 L
.49151 .309 L
.49251 .309 L
.49351 .309 L
.49451 .309 L
.4955 .309 L
.4965 .309 L
.4975 .309 L
.4985 .309 L
Mistroke
.4995 .309 L
.5005 .309 L
.5015 .309 L
.5025 .309 L
.5035 .309 L
.5045 .309 L
.50549 .309 L
.50649 .30901 L
.50749 .30901 L
.50849 .30901 L
.50949 .30901 L
.51049 .30901 L
.51149 .30901 L
.51249 .30901 L
.51349 .30901 L
.51449 .30901 L
.51548 .30901 L
.51648 .30901 L
.51748 .30901 L
.51848 .30901 L
.51948 .30901 L
.52048 .30901 L
.52148 .30901 L
.52248 .30901 L
.52348 .30901 L
.52448 .30901 L
.52547 .30901 L
.52647 .30901 L
.52747 .30901 L
.52847 .30901 L
.52947 .30901 L
.53047 .30901 L
.53147 .30901 L
.53247 .30901 L
.53347 .30901 L
.53447 .30901 L
.53546 .30901 L
.53646 .30901 L
.53746 .30901 L
.53846 .30901 L
.53946 .30901 L
.54046 .30901 L
.54146 .30901 L
.54246 .30901 L
.54346 .30901 L
.54446 .30901 L
.54545 .30901 L
.54645 .30901 L
.54745 .30901 L
.54845 .30901 L
Mistroke
.54945 .30901 L
.55045 .30901 L
.55145 .30901 L
.55245 .30901 L
.55345 .30901 L
.55445 .30901 L
.55544 .30901 L
.55644 .30901 L
.55744 .30901 L
.55844 .30901 L
.55944 .30901 L
.56044 .30901 L
.56144 .30901 L
.56244 .30901 L
.56344 .30901 L
.56444 .30901 L
.56543 .30901 L
.56643 .30901 L
.56743 .30901 L
.56843 .30901 L
.56943 .30901 L
.57043 .30901 L
.57143 .30901 L
.57243 .30901 L
.57343 .30901 L
.57443 .30901 L
.57542 .30901 L
.57642 .30901 L
.57742 .30901 L
.57842 .30901 L
.57942 .30901 L
.58042 .30901 L
.58142 .30901 L
.58242 .30901 L
.58342 .30901 L
.58442 .30901 L
.58541 .30901 L
.58641 .30901 L
.58741 .30901 L
.58841 .30901 L
.58941 .30901 L
.59041 .30901 L
.59141 .30901 L
.59241 .30901 L
.59341 .30901 L
.59441 .30901 L
.5954 .30901 L
.5964 .30901 L
.5974 .30901 L
.5984 .30901 L
Mistroke
.5994 .30901 L
.6004 .30901 L
.6014 .30901 L
.6024 .30901 L
.6034 .30901 L
.6044 .30901 L
.60539 .30901 L
.60639 .30901 L
.60739 .30901 L
.60839 .30901 L
.60939 .30901 L
.61039 .30901 L
.61139 .30901 L
.61239 .30901 L
.61339 .30901 L
.61439 .30901 L
.61538 .30901 L
.61638 .30901 L
.61738 .30901 L
.61838 .30901 L
.61938 .30901 L
.62038 .30901 L
.62138 .30901 L
.62238 .30901 L
.62338 .30901 L
.62438 .30901 L
.62537 .30901 L
.62637 .30901 L
.62737 .30901 L
.62837 .30901 L
.62937 .30901 L
.63037 .30901 L
.63137 .30901 L
.63237 .30901 L
.63337 .30901 L
.63437 .30901 L
.63536 .30901 L
.63636 .30901 L
.63736 .30901 L
.63836 .30901 L
.63936 .30901 L
.64036 .30901 L
.64136 .30901 L
.64236 .30901 L
.64336 .30901 L
.64436 .30901 L
.64535 .30901 L
.64635 .30901 L
.64735 .30901 L
.64835 .30901 L
Mistroke
.64935 .30901 L
.65035 .30901 L
.65135 .30901 L
.65235 .30901 L
.65335 .30901 L
.65435 .30901 L
.65534 .30901 L
.65634 .30901 L
.65734 .30901 L
.65834 .30901 L
.65934 .30901 L
.66034 .30901 L
.66134 .30901 L
.66234 .30901 L
.66334 .30901 L
.66434 .30901 L
.66533 .30901 L
.66633 .30901 L
.66733 .30901 L
.66833 .30901 L
.66933 .30901 L
.67033 .30901 L
.67133 .30901 L
.67233 .30901 L
.67333 .30901 L
.67433 .30901 L
.67532 .30901 L
.67632 .30901 L
.67732 .30901 L
.67832 .30901 L
.67932 .30901 L
.68032 .30901 L
.68132 .30901 L
.68232 .30901 L
.68332 .30901 L
.68432 .30901 L
.68531 .30901 L
.68631 .30901 L
.68731 .30901 L
.68831 .30901 L
.68931 .30901 L
.69031 .30901 L
.69131 .30901 L
.69231 .30901 L
.69331 .30901 L
.69431 .30901 L
.6953 .30901 L
.6963 .30901 L
.6973 .30901 L
.6983 .30901 L
Mistroke
.6993 .30901 L
.7003 .30901 L
.7013 .30901 L
.7023 .30901 L
.7033 .30901 L
.7043 .30901 L
.70529 .30901 L
.70629 .30901 L
.70729 .30901 L
.70829 .30901 L
.70929 .30901 L
.71029 .30901 L
.71129 .30901 L
.71229 .30901 L
.71329 .30901 L
.71429 .30901 L
.71528 .30901 L
.71628 .30901 L
.71728 .30901 L
.71828 .30901 L
.71928 .30901 L
.72028 .30901 L
.72128 .309 L
.72228 .309 L
.72328 .309 L
.72428 .309 L
.72527 .309 L
.72627 .309 L
.72727 .309 L
.72827 .309 L
.72927 .309 L
.73027 .309 L
.73127 .309 L
.73227 .309 L
.73327 .309 L
.73427 .309 L
.73526 .309 L
.73626 .30901 L
.73726 .30901 L
.73826 .30901 L
.73926 .30901 L
.74026 .30901 L
.74126 .30901 L
.74226 .30901 L
.74326 .30901 L
.74426 .30901 L
.74525 .30901 L
.74625 .30901 L
.74725 .30901 L
.74825 .30901 L
Mistroke
.74925 .30901 L
.75025 .30901 L
.75125 .30901 L
.75225 .30901 L
.75325 .30901 L
.75425 .30901 L
.75524 .30901 L
.75624 .30901 L
.75724 .30901 L
.75824 .30901 L
.75924 .30901 L
.76024 .30901 L
.76124 .30901 L
.76224 .30901 L
.76324 .30901 L
.76424 .30901 L
.76523 .30901 L
.76623 .30901 L
.76723 .30901 L
.76823 .30901 L
.76923 .30901 L
.77023 .30901 L
.77123 .30901 L
.77223 .30901 L
.77323 .30901 L
.77423 .30901 L
.77522 .30901 L
.77622 .30901 L
.77722 .30901 L
.77822 .30901 L
.77922 .30901 L
.78022 .30901 L
.78122 .30901 L
.78222 .30901 L
.78322 .30901 L
.78422 .30901 L
.78521 .30901 L
.78621 .30901 L
.78721 .30901 L
.78821 .30901 L
.78921 .30901 L
.79021 .30901 L
.79121 .30901 L
.79221 .30901 L
.79321 .30901 L
.79421 .30901 L
.7952 .30901 L
.7962 .30901 L
.7972 .30901 L
.7982 .30901 L
Mistroke
.7992 .30901 L
.8002 .30901 L
.8012 .30901 L
.8022 .30901 L
.8032 .30901 L
.8042 .30901 L
.80519 .309 L
.80619 .309 L
.80719 .309 L
.80819 .309 L
.80919 .309 L
.81019 .30901 L
.81119 .309 L
.81219 .309 L
.81319 .309 L
.81419 .309 L
.81518 .309 L
.81618 .309 L
.81718 .309 L
.81818 .309 L
.81918 .309 L
.82018 .309 L
.82118 .309 L
.82218 .309 L
.82318 .309 L
.82418 .309 L
.82517 .309 L
.82617 .309 L
.82717 .309 L
.82817 .309 L
.82917 .309 L
.83017 .309 L
.83117 .309 L
.83217 .309 L
.83317 .309 L
.83417 .309 L
.83516 .309 L
.83616 .309 L
.83716 .309 L
.83816 .309 L
.83916 .309 L
.84016 .309 L
.84116 .309 L
.84216 .309 L
.84316 .309 L
.84416 .309 L
.84515 .309 L
.84615 .309 L
.84715 .309 L
.84815 .309 L
Mistroke
.84915 .309 L
.85015 .309 L
.85115 .309 L
.85215 .309 L
.85315 .309 L
.85415 .309 L
.85514 .309 L
.85614 .309 L
.85714 .309 L
.85814 .309 L
.85914 .309 L
.86014 .309 L
.86114 .309 L
.86214 .309 L
.86314 .309 L
.86414 .309 L
.86513 .309 L
.86613 .309 L
.86713 .309 L
.86813 .309 L
.86913 .309 L
.87013 .309 L
.87113 .309 L
.87213 .309 L
.87313 .309 L
.87413 .309 L
.87512 .309 L
.87612 .309 L
.87712 .309 L
.87812 .309 L
.87912 .309 L
.88012 .30901 L
.88112 .309 L
.88212 .30901 L
.88312 .30901 L
.88412 .30901 L
.88511 .309 L
.88611 .309 L
.88711 .309 L
.88811 .309 L
.88911 .309 L
.89011 .309 L
.89111 .309 L
.89211 .309 L
.89311 .309 L
.89411 .309 L
.8951 .309 L
.8961 .309 L
.8971 .309 L
.8981 .309 L
Mistroke
.8991 .309 L
.9001 .309 L
.9011 .309 L
.9021 .309 L
.9031 .309 L
.9041 .309 L
.90509 .309 L
.90609 .309 L
.90709 .309 L
.90809 .309 L
.90909 .309 L
.91009 .309 L
.91109 .309 L
.91209 .309 L
.91309 .309 L
.91409 .309 L
.91508 .309 L
.91608 .309 L
.91708 .309 L
.91808 .309 L
.91908 .309 L
.92008 .309 L
.92108 .309 L
.92208 .309 L
.92308 .309 L
.92408 .309 L
.92507 .309 L
.92607 .309 L
.92707 .30901 L
.92807 .30901 L
.92907 .30901 L
.93007 .30901 L
.93107 .30901 L
.93207 .30901 L
.93307 .30901 L
.93407 .30901 L
.93506 .30901 L
.93606 .30901 L
.93706 .30901 L
.93806 .30901 L
.93906 .30901 L
.94006 .30901 L
.94106 .30901 L
.94206 .30901 L
.94306 .30901 L
.94406 .30901 L
.94505 .30901 L
.94605 .30901 L
.94705 .30901 L
.94805 .30901 L
Mistroke
.94905 .30901 L
.95005 .30901 L
.95105 .309 L
.95205 .309 L
.95305 .309 L
.95405 .309 L
.95504 .309 L
.95604 .309 L
.95704 .309 L
.95804 .309 L
.95904 .309 L
.96004 .309 L
.96104 .309 L
.96204 .30901 L
.96304 .30901 L
.96404 .30901 L
.96503 .30901 L
.96603 .30901 L
.96703 .30901 L
.96803 .30901 L
.96903 .30901 L
.97003 .30901 L
.97103 .30901 L
.97203 .309 L
.97303 .309 L
.97403 .30901 L
.97502 .309 L
.97602 .309 L
.97702 .309 L
.97802 .309 L
.97902 .309 L
.98002 .309 L
.98102 .309 L
.98202 .309 L
.98302 .309 L
.98402 .309 L
.98501 .309 L
.98601 .309 L
.98701 .309 L
.98801 .309 L
.98901 .309 L
.99001 .309 L
.99101 .309 L
.99201 .309 L
.99301 .309 L
.99401 .309 L
.995 .309 L
.996 .309 L
.997 .309 L
.998 .309 L
Mistroke
.999 .309 L
Mfstroke
0 .98 .604 r
gsave
.999 .27552 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24969 m
.001 .24969 L
.002 .24969 L
.003 .24969 L
.004 .24969 L
.005 .24969 L
.00599 .24969 L
.00699 .24969 L
.00799 .24969 L
.00899 .24969 L
.00999 .24969 L
.01099 .24969 L
.01199 .24969 L
.01299 .24969 L
.01399 .24969 L
.01499 .24969 L
.01598 .24969 L
.01698 .24969 L
.01798 .24969 L
.01898 .24969 L
.01998 .24969 L
.02098 .24969 L
.02198 .24969 L
.02298 .24969 L
.02398 .24969 L
.02498 .24969 L
.02597 .24969 L
.02697 .24969 L
.02797 .24969 L
.02897 .24969 L
.02997 .24969 L
.03097 .24969 L
.03197 .24969 L
.03297 .24969 L
.03397 .24969 L
.03497 .24969 L
.03596 .24969 L
.03696 .24969 L
.03796 .24969 L
.03896 .24969 L
.03996 .24969 L
.04096 .24969 L
.04196 .24969 L
.04296 .24969 L
.04396 .24969 L
.04496 .24969 L
.04595 .24969 L
.04695 .24969 L
.04795 .24969 L
.04895 .24969 L
Mistroke
.04995 .31868 L
.05095 .31868 L
.05195 .31868 L
.05295 .31868 L
.05395 .31868 L
.05495 .31868 L
.05594 .31868 L
.05694 .31868 L
.05794 .31868 L
.05894 .31868 L
.05994 .31868 L
.06094 .31868 L
.06194 .31868 L
.06294 .31868 L
.06394 .31868 L
.06494 .31868 L
.06593 .31868 L
.06693 .31868 L
.06793 .31868 L
.06893 .31868 L
.06993 .31868 L
.07093 .31868 L
.07193 .31868 L
.07293 .31868 L
.07393 .31868 L
.07493 .31868 L
.07592 .31868 L
.07692 .31868 L
.07792 .31868 L
.07892 .31868 L
.07992 .31868 L
.08092 .31868 L
.08192 .31868 L
.08292 .31868 L
.08392 .31868 L
.08492 .31868 L
.08591 .31868 L
.08691 .31868 L
.08791 .31868 L
.08891 .31868 L
.08991 .31868 L
.09091 .31868 L
.09191 .31868 L
.09291 .31868 L
.09391 .31868 L
.09491 .31868 L
.0959 .31868 L
.0969 .31868 L
.0979 .31868 L
.0989 .31868 L
Mistroke
.0999 .36873 L
.1009 .36873 L
.1019 .36873 L
.1029 .36873 L
.1039 .36873 L
.1049 .36873 L
.10589 .36873 L
.10689 .36873 L
.10789 .36873 L
.10889 .36873 L
.10989 .36873 L
.11089 .36873 L
.11189 .36873 L
.11289 .36873 L
.11389 .36873 L
.11489 .36873 L
.11588 .36873 L
.11688 .36873 L
.11788 .36873 L
.11888 .36873 L
.11988 .36873 L
.12088 .36873 L
.12188 .36873 L
.12288 .36873 L
.12388 .36873 L
.12488 .36873 L
.12587 .36873 L
.12687 .36873 L
.12787 .36873 L
.12887 .36873 L
.12987 .36873 L
.13087 .36873 L
.13187 .36873 L
.13287 .36873 L
.13387 .36873 L
.13487 .36873 L
.13586 .36873 L
.13686 .36873 L
.13786 .36873 L
.13886 .36873 L
.13986 .36873 L
.14086 .36873 L
.14186 .36873 L
.14286 .36873 L
.14386 .36873 L
.14486 .36873 L
.14585 .36873 L
.14685 .36873 L
.14785 .36873 L
.14885 .36873 L
Mistroke
.14985 .36311 L
.15085 .36311 L
.15185 .36311 L
.15285 .36311 L
.15385 .36311 L
.15485 .36311 L
.15584 .36311 L
.15684 .36311 L
.15784 .36311 L
.15884 .36311 L
.15984 .36311 L
.16084 .36311 L
.16184 .36311 L
.16284 .36311 L
.16384 .36311 L
.16484 .36311 L
.16583 .36311 L
.16683 .36311 L
.16783 .36311 L
.16883 .36311 L
.16983 .36311 L
.17083 .36311 L
.17183 .36311 L
.17283 .36311 L
.17383 .36311 L
.17483 .36311 L
.17582 .36311 L
.17682 .36311 L
.17782 .36311 L
.17882 .36311 L
.17982 .36311 L
.18082 .36311 L
.18182 .36311 L
.18282 .36311 L
.18382 .36311 L
.18482 .36311 L
.18581 .36311 L
.18681 .36311 L
.18781 .36311 L
.18881 .36311 L
.18981 .36311 L
.19081 .36311 L
.19181 .36311 L
.19281 .36311 L
.19381 .36311 L
.19481 .36311 L
.1958 .36311 L
.1968 .36311 L
.1978 .36311 L
.1988 .36311 L
Mistroke
.1998 .35428 L
.2008 .35428 L
.2018 .35428 L
.2028 .35428 L
.2038 .35428 L
.2048 .35428 L
.20579 .35428 L
.20679 .35428 L
.20779 .35428 L
.20879 .35428 L
.20979 .35428 L
.21079 .35428 L
.21179 .35428 L
.21279 .35428 L
.21379 .35428 L
.21479 .35428 L
.21578 .35428 L
.21678 .35428 L
.21778 .35428 L
.21878 .35428 L
.21978 .35428 L
.22078 .35428 L
.22178 .35428 L
.22278 .35428 L
.22378 .35428 L
.22478 .35428 L
.22577 .35428 L
.22677 .35428 L
.22777 .35428 L
.22877 .35428 L
.22977 .35428 L
.23077 .35428 L
.23177 .35428 L
.23277 .35428 L
.23377 .35428 L
.23477 .35428 L
.23576 .35428 L
.23676 .35428 L
.23776 .35428 L
.23876 .35428 L
.23976 .35428 L
.24076 .35428 L
.24176 .35428 L
.24276 .35428 L
.24376 .35428 L
.24476 .35428 L
.24575 .35428 L
.24675 .35428 L
.24775 .35428 L
.24875 .35428 L
Mistroke
.24975 .33402 L
.25075 .33402 L
.25175 .33402 L
.25275 .33402 L
.25375 .33402 L
.25475 .33402 L
.25574 .33402 L
.25674 .33402 L
.25774 .33402 L
.25874 .33402 L
.25974 .33402 L
.26074 .33402 L
.26174 .33402 L
.26274 .33402 L
.26374 .33402 L
.26474 .33402 L
.26573 .33402 L
.26673 .33402 L
.26773 .33402 L
.26873 .33402 L
.26973 .33402 L
.27073 .33402 L
.27173 .33402 L
.27273 .33402 L
.27373 .33402 L
.27473 .33402 L
.27572 .33402 L
.27672 .33402 L
.27772 .33402 L
.27872 .33402 L
.27972 .33402 L
.28072 .33402 L
.28172 .33402 L
.28272 .33402 L
.28372 .33402 L
.28472 .33402 L
.28571 .33402 L
.28671 .33402 L
.28771 .33402 L
.28871 .33402 L
.28971 .33402 L
.29071 .33402 L
.29171 .33402 L
.29271 .33402 L
.29371 .33402 L
.29471 .33402 L
.2957 .33402 L
.2967 .33402 L
.2977 .33402 L
.2987 .33402 L
Mistroke
.2997 .33588 L
.3007 .33588 L
.3017 .33588 L
.3027 .33588 L
.3037 .33588 L
.3047 .33588 L
.30569 .33588 L
.30669 .33588 L
.30769 .33588 L
.30869 .33588 L
.30969 .33588 L
.31069 .33588 L
.31169 .33588 L
.31269 .33588 L
.31369 .33588 L
.31469 .33588 L
.31568 .33588 L
.31668 .33588 L
.31768 .33588 L
.31868 .33588 L
.31968 .33588 L
.32068 .33588 L
.32168 .33588 L
.32268 .33588 L
.32368 .33588 L
.32468 .33588 L
.32567 .33588 L
.32667 .33588 L
.32767 .33588 L
.32867 .33588 L
.32967 .33588 L
.33067 .33588 L
.33167 .33588 L
.33267 .33588 L
.33367 .33588 L
.33467 .33588 L
.33566 .33588 L
.33666 .33588 L
.33766 .33588 L
.33866 .33588 L
.33966 .33588 L
.34066 .33588 L
.34166 .33588 L
.34266 .33588 L
.34366 .33588 L
.34466 .33588 L
.34565 .33588 L
.34665 .33588 L
.34765 .33588 L
.34865 .33588 L
Mistroke
.34965 .32665 L
.35065 .32665 L
.35165 .32665 L
.35265 .32665 L
.35365 .32665 L
.35465 .32665 L
.35564 .32665 L
.35664 .32665 L
.35764 .32665 L
.35864 .32665 L
.35964 .32665 L
.36064 .32665 L
.36164 .32665 L
.36264 .32665 L
.36364 .32665 L
.36464 .32665 L
.36563 .32665 L
.36663 .32665 L
.36763 .32665 L
.36863 .32665 L
.36963 .32665 L
.37063 .32665 L
.37163 .32665 L
.37263 .32665 L
.37363 .32665 L
.37463 .32665 L
.37562 .32665 L
.37662 .32665 L
.37762 .32665 L
.37862 .32665 L
.37962 .32665 L
.38062 .32665 L
.38162 .32665 L
.38262 .32665 L
.38362 .32665 L
.38462 .32665 L
.38561 .32665 L
.38661 .32665 L
.38761 .32665 L
.38861 .32665 L
.38961 .32665 L
.39061 .32665 L
.39161 .32665 L
.39261 .32665 L
.39361 .32665 L
.39461 .32665 L
.3956 .32665 L
.3966 .32665 L
.3976 .32665 L
.3986 .32665 L
Mistroke
.3996 .32514 L
.4006 .32514 L
.4016 .32514 L
.4026 .32514 L
.4036 .32514 L
.4046 .32514 L
.40559 .32514 L
.40659 .32514 L
.40759 .32514 L
.40859 .32514 L
.40959 .32514 L
.41059 .32514 L
.41159 .32514 L
.41259 .32514 L
.41359 .32514 L
.41459 .32514 L
.41558 .32514 L
.41658 .32514 L
.41758 .32514 L
.41858 .32514 L
.41958 .32514 L
.42058 .32514 L
.42158 .32514 L
.42258 .32514 L
.42358 .32514 L
.42458 .32514 L
.42557 .32514 L
.42657 .32514 L
.42757 .32514 L
.42857 .32514 L
.42957 .32514 L
.43057 .32514 L
.43157 .32514 L
.43257 .32514 L
.43357 .32514 L
.43457 .32514 L
.43556 .32514 L
.43656 .32514 L
.43756 .32514 L
.43856 .32514 L
.43956 .32514 L
.44056 .32514 L
.44156 .32514 L
.44256 .32514 L
.44356 .32514 L
.44456 .32514 L
.44555 .32514 L
.44655 .32514 L
.44755 .32514 L
.44855 .32514 L
Mistroke
.44955 .30044 L
.45055 .30044 L
.45155 .30044 L
.45255 .30044 L
.45355 .30044 L
.45455 .30044 L
.45554 .30044 L
.45654 .30044 L
.45754 .30044 L
.45854 .30044 L
.45954 .30044 L
.46054 .30044 L
.46154 .30044 L
.46254 .30044 L
.46354 .30044 L
.46454 .30044 L
.46553 .30044 L
.46653 .30044 L
.46753 .30044 L
.46853 .30044 L
.46953 .30044 L
.47053 .30044 L
.47153 .30044 L
.47253 .30044 L
.47353 .30044 L
.47453 .30044 L
.47552 .30044 L
.47652 .30044 L
.47752 .30044 L
.47852 .30044 L
.47952 .30044 L
.48052 .30044 L
.48152 .30044 L
.48252 .30044 L
.48352 .30044 L
.48452 .30044 L
.48551 .30044 L
.48651 .30044 L
.48751 .30044 L
.48851 .30044 L
.48951 .30044 L
.49051 .30044 L
.49151 .30044 L
.49251 .30044 L
.49351 .30044 L
.49451 .30044 L
.4955 .30044 L
.4965 .30044 L
.4975 .30044 L
.4985 .30044 L
Mistroke
.4995 .30526 L
.5005 .30526 L
.5015 .30526 L
.5025 .30526 L
.5035 .30526 L
.5045 .30526 L
.50549 .30526 L
.50649 .30526 L
.50749 .30526 L
.50849 .30526 L
.50949 .30526 L
.51049 .30526 L
.51149 .30526 L
.51249 .30526 L
.51349 .30526 L
.51449 .30526 L
.51548 .30526 L
.51648 .30526 L
.51748 .30526 L
.51848 .30526 L
.51948 .30526 L
.52048 .30526 L
.52148 .30526 L
.52248 .30526 L
.52348 .30526 L
.52448 .30526 L
.52547 .30526 L
.52647 .30526 L
.52747 .30526 L
.52847 .30526 L
.52947 .30526 L
.53047 .30526 L
.53147 .30526 L
.53247 .30526 L
.53347 .30526 L
.53447 .30526 L
.53546 .30526 L
.53646 .30526 L
.53746 .30526 L
.53846 .30526 L
.53946 .30526 L
.54046 .30526 L
.54146 .30526 L
.54246 .30526 L
.54346 .30526 L
.54446 .30526 L
.54545 .30526 L
.54645 .30526 L
.54745 .30526 L
.54845 .30526 L
Mistroke
.54945 .31468 L
.55045 .31468 L
.55145 .31468 L
.55245 .31468 L
.55345 .31468 L
.55445 .31468 L
.55544 .31468 L
.55644 .31468 L
.55744 .31468 L
.55844 .31468 L
.55944 .31468 L
.56044 .31468 L
.56144 .31468 L
.56244 .31468 L
.56344 .31468 L
.56444 .31468 L
.56543 .31468 L
.56643 .31468 L
.56743 .31468 L
.56843 .31468 L
.56943 .31468 L
.57043 .31468 L
.57143 .31468 L
.57243 .31468 L
.57343 .31468 L
.57443 .31468 L
.57542 .31468 L
.57642 .31468 L
.57742 .31468 L
.57842 .31468 L
.57942 .31468 L
.58042 .31468 L
.58142 .31468 L
.58242 .31468 L
.58342 .31468 L
.58442 .31468 L
.58541 .31468 L
.58641 .31468 L
.58741 .31468 L
.58841 .31468 L
.58941 .31468 L
.59041 .31468 L
.59141 .31468 L
.59241 .31468 L
.59341 .31468 L
.59441 .31468 L
.5954 .31468 L
.5964 .31468 L
.5974 .31468 L
.5984 .31468 L
Mistroke
.5994 .28747 L
.6004 .28747 L
.6014 .28747 L
.6024 .28747 L
.6034 .28747 L
.6044 .28747 L
.60539 .28747 L
.60639 .28747 L
.60739 .28747 L
.60839 .28747 L
.60939 .28747 L
.61039 .28747 L
.61139 .28747 L
.61239 .28747 L
.61339 .28747 L
.61439 .28747 L
.61538 .28747 L
.61638 .28747 L
.61738 .28747 L
.61838 .28747 L
.61938 .28747 L
.62038 .28747 L
.62138 .28747 L
.62238 .28747 L
.62338 .28747 L
.62438 .28747 L
.62537 .28747 L
.62637 .28747 L
.62737 .28747 L
.62837 .28747 L
.62937 .28747 L
.63037 .28747 L
.63137 .28747 L
.63237 .28747 L
.63337 .28747 L
.63437 .28747 L
.63536 .28747 L
.63636 .28747 L
.63736 .28747 L
.63836 .28747 L
.63936 .28747 L
.64036 .28747 L
.64136 .28747 L
.64236 .28747 L
.64336 .28747 L
.64436 .28747 L
.64535 .28747 L
.64635 .28747 L
.64735 .28747 L
.64835 .28747 L
Mistroke
.64935 .29771 L
.65035 .29771 L
.65135 .29771 L
.65235 .29771 L
.65335 .29771 L
.65435 .29771 L
.65534 .29771 L
.65634 .29771 L
.65734 .29771 L
.65834 .29771 L
.65934 .29771 L
.66034 .29771 L
.66134 .29771 L
.66234 .29771 L
.66334 .29771 L
.66434 .29771 L
.66533 .29771 L
.66633 .29771 L
.66733 .29771 L
.66833 .29771 L
.66933 .29771 L
.67033 .29771 L
.67133 .29771 L
.67233 .29771 L
.67333 .29771 L
.67433 .29771 L
.67532 .29771 L
.67632 .29771 L
.67732 .29771 L
.67832 .29771 L
.67932 .29771 L
.68032 .29771 L
.68132 .29771 L
.68232 .29771 L
.68332 .29771 L
.68432 .29771 L
.68531 .29771 L
.68631 .29771 L
.68731 .29771 L
.68831 .29771 L
.68931 .29771 L
.69031 .29771 L
.69131 .29771 L
.69231 .29771 L
.69331 .29771 L
.69431 .29771 L
.6953 .29771 L
.6963 .29771 L
.6973 .29771 L
.6983 .29771 L
Mistroke
.6993 .29905 L
.7003 .29905 L
.7013 .29905 L
.7023 .29905 L
.7033 .29905 L
.7043 .29905 L
.70529 .29905 L
.70629 .29905 L
.70729 .29905 L
.70829 .29905 L
.70929 .29905 L
.71029 .29905 L
.71129 .29905 L
.71229 .29905 L
.71329 .29905 L
.71429 .29905 L
.71528 .29905 L
.71628 .29905 L
.71728 .29905 L
.71828 .29905 L
.71928 .29905 L
.72028 .29905 L
.72128 .29905 L
.72228 .29905 L
.72328 .29905 L
.72428 .29905 L
.72527 .29905 L
.72627 .29905 L
.72727 .29905 L
.72827 .29905 L
.72927 .29905 L
.73027 .29905 L
.73127 .29905 L
.73227 .29905 L
.73327 .29905 L
.73427 .29905 L
.73526 .29905 L
.73626 .29905 L
.73726 .29905 L
.73826 .29905 L
.73926 .29905 L
.74026 .29905 L
.74126 .29905 L
.74226 .29905 L
.74326 .29905 L
.74426 .29905 L
.74525 .29905 L
.74625 .29905 L
.74725 .29905 L
.74825 .29905 L
Mistroke
.74925 .29728 L
.75025 .29728 L
.75125 .29728 L
.75225 .29728 L
.75325 .29728 L
.75425 .29728 L
.75524 .29728 L
.75624 .29728 L
.75724 .29728 L
.75824 .29728 L
.75924 .29728 L
.76024 .29728 L
.76124 .29728 L
.76224 .29728 L
.76324 .29728 L
.76424 .29728 L
.76523 .29728 L
.76623 .29728 L
.76723 .29728 L
.76823 .29728 L
.76923 .29728 L
.77023 .29728 L
.77123 .29728 L
.77223 .29728 L
.77323 .29728 L
.77423 .29728 L
.77522 .29728 L
.77622 .29728 L
.77722 .29728 L
.77822 .29728 L
.77922 .29728 L
.78022 .29728 L
.78122 .29728 L
.78222 .29728 L
.78322 .29728 L
.78422 .29728 L
.78521 .29728 L
.78621 .29728 L
.78721 .29728 L
.78821 .29728 L
.78921 .29728 L
.79021 .29728 L
.79121 .29728 L
.79221 .29728 L
.79321 .29728 L
.79421 .29728 L
.7952 .29728 L
.7962 .29728 L
.7972 .29728 L
.7982 .29728 L
Mistroke
.7992 .27158 L
.8002 .27158 L
.8012 .27158 L
.8022 .27158 L
.8032 .27158 L
.8042 .27158 L
.80519 .27158 L
.80619 .27158 L
.80719 .27158 L
.80819 .27158 L
.80919 .27158 L
.81019 .27158 L
.81119 .27158 L
.81219 .27158 L
.81319 .27158 L
.81419 .27158 L
.81518 .27158 L
.81618 .27158 L
.81718 .27158 L
.81818 .27158 L
.81918 .27158 L
.82018 .27158 L
.82118 .27158 L
.82218 .27158 L
.82318 .27158 L
.82418 .27158 L
.82517 .27158 L
.82617 .27158 L
.82717 .27158 L
.82817 .27158 L
.82917 .27158 L
.83017 .27158 L
.83117 .27158 L
.83217 .27158 L
.83317 .27158 L
.83417 .27158 L
.83516 .27158 L
.83616 .27158 L
.83716 .27158 L
.83816 .27158 L
.83916 .27158 L
.84016 .27158 L
.84116 .27158 L
.84216 .27158 L
.84316 .27158 L
.84416 .27158 L
.84515 .27158 L
.84615 .27158 L
.84715 .27158 L
.84815 .27158 L
Mistroke
.84915 .2742 L
.85015 .2742 L
.85115 .2742 L
.85215 .2742 L
.85315 .2742 L
.85415 .2742 L
.85514 .2742 L
.85614 .2742 L
.85714 .2742 L
.85814 .2742 L
.85914 .2742 L
.86014 .2742 L
.86114 .2742 L
.86214 .2742 L
.86314 .2742 L
.86414 .2742 L
.86513 .2742 L
.86613 .2742 L
.86713 .2742 L
.86813 .2742 L
.86913 .2742 L
.87013 .2742 L
.87113 .2742 L
.87213 .2742 L
.87313 .2742 L
.87413 .2742 L
.87512 .2742 L
.87612 .2742 L
.87712 .2742 L
.87812 .2742 L
.87912 .2742 L
.88012 .2742 L
.88112 .2742 L
.88212 .2742 L
.88312 .2742 L
.88412 .2742 L
.88511 .2742 L
.88611 .2742 L
.88711 .2742 L
.88811 .2742 L
.88911 .2742 L
.89011 .2742 L
.89111 .2742 L
.89211 .2742 L
.89311 .2742 L
.89411 .2742 L
.8951 .2742 L
.8961 .2742 L
.8971 .2742 L
.8981 .2742 L
Mistroke
.8991 .27964 L
.9001 .27964 L
.9011 .27964 L
.9021 .27964 L
.9031 .27964 L
.9041 .27964 L
.90509 .27964 L
.90609 .27964 L
.90709 .27964 L
.90809 .27964 L
.90909 .27964 L
.91009 .27964 L
.91109 .27964 L
.91209 .27964 L
.91309 .27964 L
.91409 .27964 L
.91508 .27964 L
.91608 .27964 L
.91708 .27964 L
.91808 .27964 L
.91908 .27964 L
.92008 .27964 L
.92108 .27964 L
.92208 .27964 L
.92308 .27964 L
.92408 .27964 L
.92507 .27964 L
.92607 .27964 L
.92707 .27964 L
.92807 .27964 L
.92907 .27964 L
.93007 .27964 L
.93107 .27964 L
.93207 .27964 L
.93307 .27964 L
.93407 .27964 L
.93506 .27964 L
.93606 .27964 L
.93706 .27964 L
.93806 .27964 L
.93906 .27964 L
.94006 .27964 L
.94106 .27964 L
.94206 .27964 L
.94306 .27964 L
.94406 .27964 L
.94505 .27964 L
.94605 .27964 L
.94705 .27964 L
.94805 .27964 L
Mistroke
.94905 .28215 L
.95005 .28215 L
.95105 .28215 L
.95205 .28215 L
.95305 .28215 L
.95405 .28215 L
.95504 .28215 L
.95604 .28215 L
.95704 .28215 L
.95804 .28215 L
.95904 .28215 L
.96004 .28215 L
.96104 .28215 L
.96204 .28215 L
.96304 .28215 L
.96404 .28215 L
.96503 .28215 L
.96603 .28215 L
.96703 .28215 L
.96803 .28215 L
.96903 .28215 L
.97003 .28215 L
.97103 .28215 L
.97203 .28215 L
.97303 .28215 L
.97403 .28215 L
.97502 .28215 L
.97602 .28215 L
.97702 .28215 L
.97802 .28215 L
.97902 .28215 L
.98002 .28215 L
.98102 .28215 L
.98202 .28215 L
.98302 .28215 L
.98402 .28215 L
.98501 .28215 L
.98601 .28215 L
.98701 .28215 L
.98801 .28215 L
.98901 .28215 L
.99001 .28215 L
.99101 .28215 L
.99201 .28215 L
.99301 .28215 L
.99401 .28215 L
.995 .28215 L
.996 .28215 L
.997 .28215 L
.998 .28215 L
Mistroke
.999 .27552 L
Mfstroke
gsave
.999 .437 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .49196 m
.001 .49196 L
.002 .49196 L
.003 .49196 L
.004 .49196 L
.005 .49196 L
.00599 .49196 L
.00699 .49196 L
.00799 .49196 L
.00899 .49196 L
.00999 .49196 L
.01099 .49196 L
.01199 .49196 L
.01299 .49196 L
.01399 .49196 L
.01499 .49196 L
.01598 .49196 L
.01698 .49196 L
.01798 .49196 L
.01898 .49196 L
.01998 .49196 L
.02098 .49196 L
.02198 .49196 L
.02298 .49196 L
.02398 .49196 L
.02498 .49196 L
.02597 .49196 L
.02697 .49196 L
.02797 .49196 L
.02897 .49196 L
.02997 .49196 L
.03097 .49196 L
.03197 .49196 L
.03297 .49196 L
.03397 .49196 L
.03497 .49196 L
.03596 .49196 L
.03696 .49196 L
.03796 .49196 L
.03896 .49196 L
.03996 .49196 L
.04096 .49196 L
.04196 .49196 L
.04296 .49196 L
.04396 .49196 L
.04496 .49196 L
.04595 .49196 L
.04695 .49196 L
.04795 .49196 L
.04895 .49196 L
Mistroke
.04995 .55923 L
.05095 .55923 L
.05195 .55923 L
.05295 .55923 L
.05395 .55923 L
.05495 .55923 L
.05594 .55923 L
.05694 .55923 L
.05794 .55923 L
.05894 .55923 L
.05994 .55923 L
.06094 .55923 L
.06194 .55923 L
.06294 .55923 L
.06394 .55923 L
.06494 .55923 L
.06593 .55923 L
.06693 .55923 L
.06793 .55923 L
.06893 .55923 L
.06993 .55923 L
.07093 .55923 L
.07193 .55923 L
.07293 .55923 L
.07393 .55923 L
.07493 .55923 L
.07592 .55923 L
.07692 .55923 L
.07792 .55923 L
.07892 .55923 L
.07992 .55923 L
.08092 .55923 L
.08192 .55923 L
.08292 .55923 L
.08392 .55923 L
.08492 .55923 L
.08591 .55923 L
.08691 .55923 L
.08791 .55923 L
.08891 .55923 L
.08991 .55923 L
.09091 .55923 L
.09191 .55923 L
.09291 .55923 L
.09391 .55923 L
.09491 .55923 L
.0959 .55923 L
.0969 .55923 L
.0979 .55923 L
.0989 .55923 L
Mistroke
.0999 .58684 L
.1009 .58684 L
.1019 .58684 L
.1029 .58684 L
.1039 .58684 L
.1049 .58684 L
.10589 .58684 L
.10689 .58684 L
.10789 .58684 L
.10889 .58684 L
.10989 .58684 L
.11089 .58684 L
.11189 .58684 L
.11289 .58684 L
.11389 .58684 L
.11489 .58684 L
.11588 .58684 L
.11688 .58684 L
.11788 .58684 L
.11888 .58684 L
.11988 .58684 L
.12088 .58684 L
.12188 .58684 L
.12288 .58684 L
.12388 .58684 L
.12488 .58684 L
.12587 .58684 L
.12687 .58684 L
.12787 .58684 L
.12887 .58684 L
.12987 .58684 L
.13087 .58684 L
.13187 .58684 L
.13287 .58684 L
.13387 .58684 L
.13487 .58684 L
.13586 .58684 L
.13686 .58684 L
.13786 .58684 L
.13886 .58684 L
.13986 .58684 L
.14086 .58684 L
.14186 .58684 L
.14286 .58684 L
.14386 .58684 L
.14486 .58684 L
.14585 .58684 L
.14685 .58684 L
.14785 .58684 L
.14885 .58684 L
Mistroke
.14985 .58049 L
.15085 .58049 L
.15185 .58049 L
.15285 .58049 L
.15385 .58049 L
.15485 .58049 L
.15584 .58049 L
.15684 .58049 L
.15784 .58049 L
.15884 .58049 L
.15984 .58049 L
.16084 .58049 L
.16184 .58049 L
.16284 .58049 L
.16384 .58049 L
.16484 .58049 L
.16583 .58049 L
.16683 .58049 L
.16783 .58049 L
.16883 .58049 L
.16983 .58049 L
.17083 .58049 L
.17183 .58049 L
.17283 .58049 L
.17383 .58049 L
.17483 .58049 L
.17582 .58049 L
.17682 .58049 L
.17782 .58049 L
.17882 .58049 L
.17982 .58049 L
.18082 .58049 L
.18182 .58049 L
.18282 .58049 L
.18382 .58049 L
.18482 .58049 L
.18581 .58049 L
.18681 .58049 L
.18781 .58049 L
.18881 .58049 L
.18981 .58049 L
.19081 .58049 L
.19181 .58049 L
.19281 .58049 L
.19381 .58049 L
.19481 .58049 L
.1958 .58049 L
.1968 .58049 L
.1978 .58049 L
.1988 .58049 L
Mistroke
.1998 .56981 L
.2008 .56981 L
.2018 .56981 L
.2028 .56981 L
.2038 .56981 L
.2048 .56981 L
.20579 .56981 L
.20679 .56981 L
.20779 .56981 L
.20879 .56981 L
.20979 .56981 L
.21079 .56981 L
.21179 .56981 L
.21279 .56981 L
.21379 .56981 L
.21479 .56981 L
.21578 .56981 L
.21678 .56981 L
.21778 .56981 L
.21878 .56981 L
.21978 .56981 L
.22078 .56981 L
.22178 .56981 L
.22278 .56981 L
.22378 .56981 L
.22478 .56981 L
.22577 .56981 L
.22677 .56981 L
.22777 .56981 L
.22877 .56981 L
.22977 .56981 L
.23077 .56981 L
.23177 .56981 L
.23277 .56981 L
.23377 .56981 L
.23477 .56981 L
.23576 .56981 L
.23676 .56981 L
.23776 .56981 L
.23876 .56981 L
.23976 .56981 L
.24076 .56981 L
.24176 .56981 L
.24276 .56981 L
.24376 .56981 L
.24476 .56981 L
.24575 .56981 L
.24675 .56981 L
.24775 .56981 L
.24875 .56981 L
Mistroke
.24975 .54633 L
.25075 .54633 L
.25175 .54633 L
.25275 .54633 L
.25375 .54633 L
.25475 .54633 L
.25574 .54633 L
.25674 .54633 L
.25774 .54633 L
.25874 .54633 L
.25974 .54633 L
.26074 .54633 L
.26174 .54633 L
.26274 .54633 L
.26374 .54633 L
.26474 .54633 L
.26573 .54633 L
.26673 .54633 L
.26773 .54633 L
.26873 .54633 L
.26973 .54633 L
.27073 .54633 L
.27173 .54633 L
.27273 .54633 L
.27373 .54633 L
.27473 .54633 L
.27572 .54633 L
.27672 .54633 L
.27772 .54633 L
.27872 .54633 L
.27972 .54633 L
.28072 .54633 L
.28172 .54633 L
.28272 .54633 L
.28372 .54633 L
.28472 .54633 L
.28571 .54633 L
.28671 .54633 L
.28771 .54633 L
.28871 .54633 L
.28971 .54633 L
.29071 .54633 L
.29171 .54633 L
.29271 .54633 L
.29371 .54633 L
.29471 .54633 L
.2957 .54633 L
.2967 .54633 L
.2977 .54633 L
.2987 .54633 L
Mistroke
.2997 .54681 L
.3007 .54681 L
.3017 .54681 L
.3027 .54681 L
.3037 .54681 L
.3047 .54681 L
.30569 .54681 L
.30669 .54681 L
.30769 .54681 L
.30869 .54681 L
.30969 .54681 L
.31069 .54681 L
.31169 .54681 L
.31269 .54681 L
.31369 .54681 L
.31469 .54681 L
.31568 .54681 L
.31668 .54681 L
.31768 .54681 L
.31868 .54681 L
.31968 .54681 L
.32068 .54681 L
.32168 .54681 L
.32268 .54681 L
.32368 .54681 L
.32468 .54681 L
.32567 .54681 L
.32667 .54681 L
.32767 .54681 L
.32867 .54681 L
.32967 .54681 L
.33067 .54681 L
.33167 .54681 L
.33267 .54681 L
.33367 .54681 L
.33467 .54681 L
.33566 .54681 L
.33666 .54681 L
.33766 .54681 L
.33866 .54681 L
.33966 .54681 L
.34066 .54681 L
.34166 .54681 L
.34266 .54681 L
.34366 .54681 L
.34466 .54681 L
.34565 .54681 L
.34665 .54681 L
.34765 .54681 L
.34865 .54681 L
Mistroke
.34965 .53465 L
.35065 .53465 L
.35165 .53465 L
.35265 .53465 L
.35365 .53465 L
.35465 .53465 L
.35564 .53465 L
.35664 .53465 L
.35764 .53465 L
.35864 .53465 L
.35964 .53465 L
.36064 .53465 L
.36164 .53465 L
.36264 .53465 L
.36364 .53465 L
.36464 .53465 L
.36563 .53465 L
.36663 .53465 L
.36763 .53465 L
.36863 .53465 L
.36963 .53465 L
.37063 .53465 L
.37163 .53465 L
.37263 .53465 L
.37363 .53465 L
.37463 .53465 L
.37562 .53465 L
.37662 .53465 L
.37762 .53465 L
.37862 .53465 L
.37962 .53465 L
.38062 .53465 L
.38162 .53465 L
.38262 .53465 L
.38362 .53465 L
.38462 .53465 L
.38561 .53465 L
.38661 .53465 L
.38761 .53465 L
.38861 .53465 L
.38961 .53465 L
.39061 .53465 L
.39161 .53465 L
.39261 .53465 L
.39361 .53465 L
.39461 .53465 L
.3956 .53465 L
.3966 .53465 L
.3976 .53465 L
.3986 .53465 L
Mistroke
.3996 .53301 L
.4006 .53301 L
.4016 .53301 L
.4026 .53301 L
.4036 .53301 L
.4046 .53301 L
.40559 .53301 L
.40659 .53301 L
.40759 .53301 L
.40859 .53301 L
.40959 .53301 L
.41059 .53301 L
.41159 .53301 L
.41259 .53301 L
.41359 .53301 L
.41459 .53301 L
.41558 .53301 L
.41658 .53301 L
.41758 .53301 L
.41858 .53301 L
.41958 .53301 L
.42058 .53301 L
.42158 .53301 L
.42258 .53301 L
.42358 .53301 L
.42458 .53301 L
.42557 .53301 L
.42657 .53301 L
.42757 .53301 L
.42857 .53301 L
.42957 .53301 L
.43057 .53301 L
.43157 .53301 L
.43257 .53301 L
.43357 .53301 L
.43457 .53301 L
.43556 .53301 L
.43656 .53301 L
.43756 .53301 L
.43856 .53301 L
.43956 .53301 L
.44056 .53301 L
.44156 .53301 L
.44256 .53301 L
.44356 .53301 L
.44456 .53301 L
.44555 .53301 L
.44655 .53301 L
.44755 .53301 L
.44855 .53301 L
Mistroke
.44955 .49191 L
.45055 .49191 L
.45155 .49191 L
.45255 .49191 L
.45355 .49191 L
.45455 .49191 L
.45554 .49191 L
.45654 .49191 L
.45754 .49191 L
.45854 .49191 L
.45954 .49191 L
.46054 .49191 L
.46154 .49191 L
.46254 .49191 L
.46354 .49191 L
.46454 .49191 L
.46553 .49191 L
.46653 .49191 L
.46753 .49191 L
.46853 .49191 L
.46953 .49191 L
.47053 .49191 L
.47153 .49191 L
.47253 .49191 L
.47353 .49191 L
.47453 .49191 L
.47552 .49191 L
.47652 .49191 L
.47752 .49191 L
.47852 .49191 L
.47952 .49191 L
.48052 .49191 L
.48152 .49191 L
.48252 .49191 L
.48352 .49191 L
.48452 .49191 L
.48551 .49191 L
.48651 .49191 L
.48751 .49191 L
.48851 .49191 L
.48951 .49191 L
.49051 .49191 L
.49151 .49191 L
.49251 .49191 L
.49351 .49191 L
.49451 .49191 L
.4955 .49191 L
.4965 .49191 L
.4975 .49191 L
.4985 .49191 L
Mistroke
.4995 .49661 L
.5005 .49661 L
.5015 .49661 L
.5025 .49661 L
.5035 .49661 L
.5045 .49661 L
.50549 .49661 L
.50649 .49661 L
.50749 .49661 L
.50849 .49661 L
.50949 .49661 L
.51049 .49661 L
.51149 .49661 L
.51249 .49661 L
.51349 .49661 L
.51449 .49661 L
.51548 .49661 L
.51648 .49661 L
.51748 .49661 L
.51848 .49661 L
.51948 .49661 L
.52048 .49661 L
.52148 .49661 L
.52248 .49661 L
.52348 .49661 L
.52448 .49661 L
.52547 .49661 L
.52647 .49661 L
.52747 .49661 L
.52847 .49661 L
.52947 .49661 L
.53047 .49661 L
.53147 .49661 L
.53247 .49661 L
.53347 .49661 L
.53447 .49661 L
.53546 .49661 L
.53646 .49661 L
.53746 .49661 L
.53846 .49661 L
.53946 .49661 L
.54046 .49661 L
.54146 .49661 L
.54246 .49661 L
.54346 .49661 L
.54446 .49661 L
.54545 .49661 L
.54645 .49661 L
.54745 .49661 L
.54845 .49661 L
Mistroke
.54945 .50564 L
.55045 .50564 L
.55145 .50564 L
.55245 .50564 L
.55345 .50564 L
.55445 .50564 L
.55544 .50564 L
.55644 .50564 L
.55744 .50564 L
.55844 .50564 L
.55944 .50564 L
.56044 .50564 L
.56144 .50564 L
.56244 .50564 L
.56344 .50564 L
.56444 .50564 L
.56543 .50564 L
.56643 .50564 L
.56743 .50564 L
.56843 .50564 L
.56943 .50564 L
.57043 .50564 L
.57143 .50564 L
.57243 .50564 L
.57343 .50564 L
.57443 .50564 L
.57542 .50564 L
.57642 .50564 L
.57742 .50564 L
.57842 .50564 L
.57942 .50564 L
.58042 .50564 L
.58142 .50564 L
.58242 .50564 L
.58342 .50564 L
.58442 .50564 L
.58541 .50564 L
.58641 .50564 L
.58741 .50564 L
.58841 .50564 L
.58941 .50564 L
.59041 .50564 L
.59141 .50564 L
.59241 .50564 L
.59341 .50564 L
.59441 .50564 L
.5954 .50564 L
.5964 .50564 L
.5974 .50564 L
.5984 .50564 L
Mistroke
.5994 .46982 L
.6004 .46982 L
.6014 .46982 L
.6024 .46982 L
.6034 .46982 L
.6044 .46982 L
.60539 .46982 L
.60639 .46982 L
.60739 .46982 L
.60839 .46982 L
.60939 .46982 L
.61039 .46982 L
.61139 .46982 L
.61239 .46982 L
.61339 .46982 L
.61439 .46982 L
.61538 .46982 L
.61638 .46982 L
.61738 .46982 L
.61838 .46982 L
.61938 .46982 L
.62038 .46982 L
.62138 .46982 L
.62238 .46982 L
.62338 .46982 L
.62438 .46982 L
.62537 .46982 L
.62637 .46982 L
.62737 .46982 L
.62837 .46982 L
.62937 .46982 L
.63037 .46982 L
.63137 .46982 L
.63237 .46982 L
.63337 .46982 L
.63437 .46982 L
.63536 .46982 L
.63636 .46982 L
.63736 .46982 L
.63836 .46982 L
.63936 .46982 L
.64036 .46982 L
.64136 .46982 L
.64236 .46982 L
.64336 .46982 L
.64436 .46982 L
.64535 .46982 L
.64635 .46982 L
.64735 .46982 L
.64835 .46982 L
Mistroke
.64935 .47804 L
.65035 .47804 L
.65135 .47804 L
.65235 .47804 L
.65335 .47804 L
.65435 .47804 L
.65534 .47804 L
.65634 .47804 L
.65734 .47804 L
.65834 .47804 L
.65934 .47804 L
.66034 .47804 L
.66134 .47804 L
.66234 .47804 L
.66334 .47804 L
.66434 .47804 L
.66533 .47804 L
.66633 .47804 L
.66733 .47804 L
.66833 .47804 L
.66933 .47804 L
.67033 .47804 L
.67133 .47804 L
.67233 .47804 L
.67333 .47804 L
.67433 .47804 L
.67532 .47804 L
.67632 .47804 L
.67732 .47804 L
.67832 .47804 L
.67932 .47804 L
.68032 .47804 L
.68132 .47804 L
.68232 .47804 L
.68332 .47804 L
.68432 .47804 L
.68531 .47804 L
.68631 .47804 L
.68731 .47804 L
.68831 .47804 L
.68931 .47804 L
.69031 .47804 L
.69131 .47804 L
.69231 .47804 L
.69331 .47804 L
.69431 .47804 L
.6953 .47804 L
.6963 .47804 L
.6973 .47804 L
.6983 .47804 L
Mistroke
.6993 .47691 L
.7003 .47691 L
.7013 .47691 L
.7023 .47691 L
.7033 .47691 L
.7043 .47691 L
.70529 .47691 L
.70629 .47691 L
.70729 .47691 L
.70829 .47691 L
.70929 .47691 L
.71029 .47691 L
.71129 .47691 L
.71229 .47691 L
.71329 .47691 L
.71429 .47691 L
.71528 .47691 L
.71628 .47691 L
.71728 .47691 L
.71828 .47691 L
.71928 .47691 L
.72028 .47691 L
.72128 .47691 L
.72228 .47691 L
.72328 .47691 L
.72428 .47691 L
.72527 .47691 L
.72627 .47691 L
.72727 .47691 L
.72827 .47691 L
.72927 .47691 L
.73027 .47691 L
.73127 .47691 L
.73227 .47691 L
.73327 .47691 L
.73427 .47691 L
.73526 .47691 L
.73626 .47691 L
.73726 .47691 L
.73826 .47691 L
.73926 .47691 L
.74026 .47691 L
.74126 .47691 L
.74226 .47691 L
.74326 .47691 L
.74426 .47691 L
.74525 .47691 L
.74625 .47691 L
.74725 .47691 L
.74825 .47691 L
Mistroke
.74925 .47503 L
.75025 .47503 L
.75125 .47503 L
.75225 .47503 L
.75325 .47503 L
.75425 .47503 L
.75524 .47503 L
.75624 .47503 L
.75724 .47503 L
.75824 .47503 L
.75924 .47503 L
.76024 .47503 L
.76124 .47503 L
.76224 .47503 L
.76324 .47503 L
.76424 .47503 L
.76523 .47503 L
.76623 .47503 L
.76723 .47503 L
.76823 .47503 L
.76923 .47503 L
.77023 .47503 L
.77123 .47503 L
.77223 .47503 L
.77323 .47503 L
.77423 .47503 L
.77522 .47503 L
.77622 .47503 L
.77722 .47503 L
.77822 .47503 L
.77922 .47503 L
.78022 .47503 L
.78122 .47503 L
.78222 .47503 L
.78322 .47503 L
.78422 .47503 L
.78521 .47503 L
.78621 .47503 L
.78721 .47503 L
.78821 .47503 L
.78921 .47503 L
.79021 .47503 L
.79121 .47503 L
.79221 .47503 L
.79321 .47503 L
.79421 .47503 L
.7952 .47503 L
.7962 .47503 L
.7972 .47503 L
.7982 .47503 L
Mistroke
.7992 .4411 L
.8002 .4411 L
.8012 .4411 L
.8022 .4411 L
.8032 .4411 L
.8042 .4411 L
.80519 .4411 L
.80619 .4411 L
.80719 .4411 L
.80819 .4411 L
.80919 .4411 L
.81019 .4411 L
.81119 .4411 L
.81219 .4411 L
.81319 .4411 L
.81419 .4411 L
.81518 .4411 L
.81618 .4411 L
.81718 .4411 L
.81818 .4411 L
.81918 .4411 L
.82018 .4411 L
.82118 .4411 L
.82218 .4411 L
.82318 .4411 L
.82418 .4411 L
.82517 .4411 L
.82617 .4411 L
.82717 .4411 L
.82817 .4411 L
.82917 .4411 L
.83017 .4411 L
.83117 .4411 L
.83217 .4411 L
.83317 .4411 L
.83417 .4411 L
.83516 .4411 L
.83616 .4411 L
.83716 .4411 L
.83816 .4411 L
.83916 .4411 L
.84016 .4411 L
.84116 .4411 L
.84216 .4411 L
.84316 .4411 L
.84416 .4411 L
.84515 .4411 L
.84615 .4411 L
.84715 .4411 L
.84815 .4411 L
Mistroke
.84915 .44353 L
.85015 .44353 L
.85115 .44353 L
.85215 .44353 L
.85315 .44353 L
.85415 .44353 L
.85514 .44353 L
.85614 .44353 L
.85714 .44353 L
.85814 .44353 L
.85914 .44353 L
.86014 .44353 L
.86114 .44353 L
.86214 .44353 L
.86314 .44353 L
.86414 .44353 L
.86513 .44353 L
.86613 .44353 L
.86713 .44353 L
.86813 .44353 L
.86913 .44353 L
.87013 .44353 L
.87113 .44353 L
.87213 .44353 L
.87313 .44353 L
.87413 .44353 L
.87512 .44353 L
.87612 .44353 L
.87712 .44353 L
.87812 .44353 L
.87912 .44353 L
.88012 .44353 L
.88112 .44353 L
.88212 .44353 L
.88312 .44353 L
.88412 .44353 L
.88511 .44353 L
.88611 .44353 L
.88711 .44353 L
.88811 .44353 L
.88911 .44353 L
.89011 .44353 L
.89111 .44353 L
.89211 .44353 L
.89311 .44353 L
.89411 .44353 L
.8951 .44353 L
.8961 .44353 L
.8971 .44353 L
.8981 .44353 L
Mistroke
.8991 .44856 L
.9001 .44856 L
.9011 .44856 L
.9021 .44856 L
.9031 .44856 L
.9041 .44856 L
.90509 .44856 L
.90609 .44856 L
.90709 .44856 L
.90809 .44856 L
.90909 .44856 L
.91009 .44856 L
.91109 .44856 L
.91209 .44856 L
.91309 .44856 L
.91409 .44856 L
.91508 .44856 L
.91608 .44856 L
.91708 .44856 L
.91808 .44856 L
.91908 .44856 L
.92008 .44856 L
.92108 .44856 L
.92208 .44856 L
.92308 .44856 L
.92408 .44856 L
.92507 .44856 L
.92607 .44856 L
.92707 .44856 L
.92807 .44856 L
.92907 .44856 L
.93007 .44856 L
.93107 .44856 L
.93207 .44856 L
.93307 .44856 L
.93407 .44856 L
.93506 .44856 L
.93606 .44856 L
.93706 .44856 L
.93806 .44856 L
.93906 .44856 L
.94006 .44856 L
.94106 .44856 L
.94206 .44856 L
.94306 .44856 L
.94406 .44856 L
.94505 .44856 L
.94605 .44856 L
.94705 .44856 L
.94805 .44856 L
Mistroke
.94905 .44922 L
.95005 .44922 L
.95105 .44922 L
.95205 .44922 L
.95305 .44922 L
.95405 .44922 L
.95504 .44922 L
.95604 .44922 L
.95704 .44922 L
.95804 .44922 L
.95904 .44922 L
.96004 .44922 L
.96104 .44922 L
.96204 .44922 L
.96304 .44922 L
.96404 .44922 L
.96503 .44922 L
.96603 .44922 L
.96703 .44922 L
.96803 .44922 L
.96903 .44922 L
.97003 .44922 L
.97103 .44922 L
.97203 .44922 L
.97303 .44922 L
.97403 .44922 L
.97502 .44922 L
.97602 .44922 L
.97702 .44922 L
.97802 .44922 L
.97902 .44922 L
.98002 .44922 L
.98102 .44922 L
.98202 .44922 L
.98302 .44922 L
.98402 .44922 L
.98501 .44922 L
.98601 .44922 L
.98701 .44922 L
.98801 .44922 L
.98901 .44922 L
.99001 .44922 L
.99101 .44922 L
.99201 .44922 L
.99301 .44922 L
.99401 .44922 L
.995 .44922 L
.996 .44922 L
.997 .44922 L
.998 .44922 L
Mistroke
.999 .437 L
Mfstroke
1 0 0 r
gsave
.999 .35626 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37082 m
.001 .37082 L
.002 .37082 L
.003 .37082 L
.004 .37082 L
.005 .37082 L
.00599 .37082 L
.00699 .37082 L
.00799 .37082 L
.00899 .37082 L
.00999 .37082 L
.01099 .37082 L
.01199 .37082 L
.01299 .37082 L
.01399 .37082 L
.01499 .37082 L
.01598 .37082 L
.01698 .37082 L
.01798 .37082 L
.01898 .37082 L
.01998 .37082 L
.02098 .37082 L
.02198 .37082 L
.02298 .37082 L
.02398 .37082 L
.02498 .37082 L
.02597 .37082 L
.02697 .37082 L
.02797 .37082 L
.02897 .37082 L
.02997 .37082 L
.03097 .37082 L
.03197 .37082 L
.03297 .37082 L
.03397 .37082 L
.03497 .37082 L
.03596 .37082 L
.03696 .37082 L
.03796 .37082 L
.03896 .37082 L
.03996 .37082 L
.04096 .37082 L
.04196 .37082 L
.04296 .37082 L
.04396 .37082 L
.04496 .37082 L
.04595 .37082 L
.04695 .37082 L
.04795 .37082 L
.04895 .37082 L
Mistroke
.04995 .43895 L
.05095 .43895 L
.05195 .43895 L
.05295 .43895 L
.05395 .43895 L
.05495 .43895 L
.05594 .43895 L
.05694 .43895 L
.05794 .43895 L
.05894 .43895 L
.05994 .43895 L
.06094 .43895 L
.06194 .43895 L
.06294 .43895 L
.06394 .43895 L
.06494 .43895 L
.06593 .43895 L
.06693 .43895 L
.06793 .43895 L
.06893 .43895 L
.06993 .43895 L
.07093 .43895 L
.07193 .43895 L
.07293 .43895 L
.07393 .43895 L
.07493 .43895 L
.07592 .43895 L
.07692 .43895 L
.07792 .43895 L
.07892 .43895 L
.07992 .43895 L
.08092 .43895 L
.08192 .43895 L
.08292 .43895 L
.08392 .43895 L
.08492 .43895 L
.08591 .43895 L
.08691 .43895 L
.08791 .43895 L
.08891 .43895 L
.08991 .43895 L
.09091 .43895 L
.09191 .43895 L
.09291 .43895 L
.09391 .43895 L
.09491 .43895 L
.0959 .43895 L
.0969 .43895 L
.0979 .43895 L
.0989 .43895 L
Mistroke
.0999 .47778 L
.1009 .47778 L
.1019 .47778 L
.1029 .47778 L
.1039 .47778 L
.1049 .47778 L
.10589 .47778 L
.10689 .47778 L
.10789 .47778 L
.10889 .47778 L
.10989 .47778 L
.11089 .47778 L
.11189 .47778 L
.11289 .47778 L
.11389 .47778 L
.11489 .47778 L
.11588 .47778 L
.11688 .47778 L
.11788 .47778 L
.11888 .47778 L
.11988 .47778 L
.12088 .47778 L
.12188 .47778 L
.12288 .47778 L
.12388 .47778 L
.12488 .47778 L
.12587 .47778 L
.12687 .47778 L
.12787 .47778 L
.12887 .47778 L
.12987 .47778 L
.13087 .47778 L
.13187 .47778 L
.13287 .47778 L
.13387 .47778 L
.13487 .47778 L
.13586 .47778 L
.13686 .47778 L
.13786 .47778 L
.13886 .47778 L
.13986 .47778 L
.14086 .47778 L
.14186 .47778 L
.14286 .47778 L
.14386 .47778 L
.14486 .47778 L
.14585 .47778 L
.14685 .47778 L
.14785 .47778 L
.14885 .47778 L
Mistroke
.14985 .4718 L
.15085 .4718 L
.15185 .4718 L
.15285 .4718 L
.15385 .4718 L
.15485 .4718 L
.15584 .4718 L
.15684 .4718 L
.15784 .4718 L
.15884 .4718 L
.15984 .4718 L
.16084 .4718 L
.16184 .4718 L
.16284 .4718 L
.16384 .4718 L
.16484 .4718 L
.16583 .4718 L
.16683 .4718 L
.16783 .4718 L
.16883 .4718 L
.16983 .4718 L
.17083 .4718 L
.17183 .4718 L
.17283 .4718 L
.17383 .4718 L
.17483 .4718 L
.17582 .4718 L
.17682 .4718 L
.17782 .4718 L
.17882 .4718 L
.17982 .4718 L
.18082 .4718 L
.18182 .4718 L
.18282 .4718 L
.18382 .4718 L
.18482 .4718 L
.18581 .4718 L
.18681 .4718 L
.18781 .4718 L
.18881 .4718 L
.18981 .4718 L
.19081 .4718 L
.19181 .4718 L
.19281 .4718 L
.19381 .4718 L
.19481 .4718 L
.1958 .4718 L
.1968 .4718 L
.1978 .4718 L
.1988 .4718 L
Mistroke
.1998 .46205 L
.2008 .46205 L
.2018 .46205 L
.2028 .46205 L
.2038 .46205 L
.2048 .46205 L
.20579 .46205 L
.20679 .46205 L
.20779 .46205 L
.20879 .46205 L
.20979 .46205 L
.21079 .46205 L
.21179 .46205 L
.21279 .46205 L
.21379 .46205 L
.21479 .46205 L
.21578 .46205 L
.21678 .46205 L
.21778 .46205 L
.21878 .46205 L
.21978 .46205 L
.22078 .46205 L
.22178 .46205 L
.22278 .46205 L
.22378 .46205 L
.22478 .46205 L
.22577 .46205 L
.22677 .46205 L
.22777 .46205 L
.22877 .46205 L
.22977 .46205 L
.23077 .46205 L
.23177 .46205 L
.23277 .46205 L
.23377 .46205 L
.23477 .46205 L
.23576 .46205 L
.23676 .46205 L
.23776 .46205 L
.23876 .46205 L
.23976 .46205 L
.24076 .46205 L
.24176 .46205 L
.24276 .46205 L
.24376 .46205 L
.24476 .46205 L
.24575 .46205 L
.24675 .46205 L
.24775 .46205 L
.24875 .46205 L
Mistroke
.24975 .44017 L
.25075 .44017 L
.25175 .44017 L
.25275 .44017 L
.25375 .44017 L
.25475 .44017 L
.25574 .44017 L
.25674 .44017 L
.25774 .44017 L
.25874 .44017 L
.25974 .44017 L
.26074 .44017 L
.26174 .44017 L
.26274 .44017 L
.26374 .44017 L
.26474 .44017 L
.26573 .44017 L
.26673 .44017 L
.26773 .44017 L
.26873 .44017 L
.26973 .44017 L
.27073 .44017 L
.27173 .44017 L
.27273 .44017 L
.27373 .44017 L
.27473 .44017 L
.27572 .44017 L
.27672 .44017 L
.27772 .44017 L
.27872 .44017 L
.27972 .44017 L
.28072 .44017 L
.28172 .44017 L
.28272 .44017 L
.28372 .44017 L
.28472 .44017 L
.28571 .44017 L
.28671 .44017 L
.28771 .44017 L
.28871 .44017 L
.28971 .44017 L
.29071 .44017 L
.29171 .44017 L
.29271 .44017 L
.29371 .44017 L
.29471 .44017 L
.2957 .44017 L
.2967 .44017 L
.2977 .44017 L
.2987 .44017 L
Mistroke
.2997 .44135 L
.3007 .44135 L
.3017 .44135 L
.3027 .44135 L
.3037 .44135 L
.3047 .44135 L
.30569 .44135 L
.30669 .44135 L
.30769 .44135 L
.30869 .44135 L
.30969 .44135 L
.31069 .44135 L
.31169 .44135 L
.31269 .44135 L
.31369 .44135 L
.31469 .44135 L
.31568 .44135 L
.31668 .44135 L
.31768 .44135 L
.31868 .44135 L
.31968 .44135 L
.32068 .44135 L
.32168 .44135 L
.32268 .44135 L
.32368 .44135 L
.32468 .44135 L
.32567 .44135 L
.32667 .44135 L
.32767 .44135 L
.32867 .44135 L
.32967 .44135 L
.33067 .44135 L
.33167 .44135 L
.33267 .44135 L
.33367 .44135 L
.33467 .44135 L
.33566 .44135 L
.33666 .44135 L
.33766 .44135 L
.33866 .44135 L
.33966 .44135 L
.34066 .44135 L
.34166 .44135 L
.34266 .44135 L
.34366 .44135 L
.34466 .44135 L
.34565 .44135 L
.34665 .44135 L
.34765 .44135 L
.34865 .44135 L
Mistroke
.34965 .43065 L
.35065 .43065 L
.35165 .43065 L
.35265 .43065 L
.35365 .43065 L
.35465 .43065 L
.35564 .43065 L
.35664 .43065 L
.35764 .43065 L
.35864 .43065 L
.35964 .43065 L
.36064 .43065 L
.36164 .43065 L
.36264 .43065 L
.36364 .43065 L
.36464 .43065 L
.36563 .43065 L
.36663 .43065 L
.36763 .43065 L
.36863 .43065 L
.36963 .43065 L
.37063 .43065 L
.37163 .43065 L
.37263 .43065 L
.37363 .43065 L
.37463 .43065 L
.37562 .43065 L
.37662 .43065 L
.37762 .43065 L
.37862 .43065 L
.37962 .43065 L
.38062 .43065 L
.38162 .43065 L
.38262 .43065 L
.38362 .43065 L
.38462 .43065 L
.38561 .43065 L
.38661 .43065 L
.38761 .43065 L
.38861 .43065 L
.38961 .43065 L
.39061 .43065 L
.39161 .43065 L
.39261 .43065 L
.39361 .43065 L
.39461 .43065 L
.3956 .43065 L
.3966 .43065 L
.3976 .43065 L
.3986 .43065 L
Mistroke
.3996 .42907 L
.4006 .42907 L
.4016 .42907 L
.4026 .42907 L
.4036 .42907 L
.4046 .42907 L
.40559 .42907 L
.40659 .42907 L
.40759 .42907 L
.40859 .42907 L
.40959 .42907 L
.41059 .42907 L
.41159 .42907 L
.41259 .42907 L
.41359 .42907 L
.41459 .42907 L
.41558 .42907 L
.41658 .42907 L
.41758 .42907 L
.41858 .42907 L
.41958 .42907 L
.42058 .42907 L
.42158 .42907 L
.42258 .42907 L
.42358 .42907 L
.42458 .42907 L
.42557 .42907 L
.42657 .42907 L
.42757 .42907 L
.42857 .42907 L
.42957 .42907 L
.43057 .42907 L
.43157 .42907 L
.43257 .42907 L
.43357 .42907 L
.43457 .42907 L
.43556 .42907 L
.43656 .42907 L
.43756 .42907 L
.43856 .42907 L
.43956 .42907 L
.44056 .42907 L
.44156 .42907 L
.44256 .42907 L
.44356 .42907 L
.44456 .42907 L
.44555 .42907 L
.44655 .42907 L
.44755 .42907 L
.44855 .42907 L
Mistroke
.44955 .39617 L
.45055 .39617 L
.45155 .39617 L
.45255 .39617 L
.45355 .39617 L
.45455 .39617 L
.45554 .39617 L
.45654 .39617 L
.45754 .39617 L
.45854 .39617 L
.45954 .39617 L
.46054 .39617 L
.46154 .39617 L
.46254 .39617 L
.46354 .39617 L
.46454 .39617 L
.46553 .39617 L
.46653 .39617 L
.46753 .39617 L
.46853 .39617 L
.46953 .39617 L
.47053 .39617 L
.47153 .39617 L
.47253 .39617 L
.47353 .39617 L
.47453 .39617 L
.47552 .39617 L
.47652 .39617 L
.47752 .39617 L
.47852 .39617 L
.47952 .39617 L
.48052 .39617 L
.48152 .39617 L
.48252 .39617 L
.48352 .39617 L
.48452 .39617 L
.48551 .39617 L
.48651 .39617 L
.48751 .39617 L
.48851 .39617 L
.48951 .39617 L
.49051 .39617 L
.49151 .39617 L
.49251 .39617 L
.49351 .39617 L
.49451 .39617 L
.4955 .39617 L
.4965 .39617 L
.4975 .39617 L
.4985 .39617 L
Mistroke
.4995 .40094 L
.5005 .40094 L
.5015 .40094 L
.5025 .40094 L
.5035 .40094 L
.5045 .40094 L
.50549 .40094 L
.50649 .40094 L
.50749 .40094 L
.50849 .40094 L
.50949 .40094 L
.51049 .40094 L
.51149 .40094 L
.51249 .40094 L
.51349 .40094 L
.51449 .40094 L
.51548 .40094 L
.51648 .40094 L
.51748 .40094 L
.51848 .40094 L
.51948 .40094 L
.52048 .40094 L
.52148 .40094 L
.52248 .40094 L
.52348 .40094 L
.52448 .40094 L
.52547 .40094 L
.52647 .40094 L
.52747 .40094 L
.52847 .40094 L
.52947 .40094 L
.53047 .40094 L
.53147 .40094 L
.53247 .40094 L
.53347 .40094 L
.53447 .40094 L
.53546 .40094 L
.53646 .40094 L
.53746 .40094 L
.53846 .40094 L
.53946 .40094 L
.54046 .40094 L
.54146 .40094 L
.54246 .40094 L
.54346 .40094 L
.54446 .40094 L
.54545 .40094 L
.54645 .40094 L
.54745 .40094 L
.54845 .40094 L
Mistroke
.54945 .41016 L
.55045 .41016 L
.55145 .41016 L
.55245 .41016 L
.55345 .41016 L
.55445 .41016 L
.55544 .41016 L
.55644 .41016 L
.55744 .41016 L
.55844 .41016 L
.55944 .41016 L
.56044 .41016 L
.56144 .41016 L
.56244 .41016 L
.56344 .41016 L
.56444 .41016 L
.56543 .41016 L
.56643 .41016 L
.56743 .41016 L
.56843 .41016 L
.56943 .41016 L
.57043 .41016 L
.57143 .41016 L
.57243 .41016 L
.57343 .41016 L
.57443 .41016 L
.57542 .41016 L
.57642 .41016 L
.57742 .41016 L
.57842 .41016 L
.57942 .41016 L
.58042 .41016 L
.58142 .41016 L
.58242 .41016 L
.58342 .41016 L
.58442 .41016 L
.58541 .41016 L
.58641 .41016 L
.58741 .41016 L
.58841 .41016 L
.58941 .41016 L
.59041 .41016 L
.59141 .41016 L
.59241 .41016 L
.59341 .41016 L
.59441 .41016 L
.5954 .41016 L
.5964 .41016 L
.5974 .41016 L
.5984 .41016 L
Mistroke
.5994 .37865 L
.6004 .37865 L
.6014 .37865 L
.6024 .37865 L
.6034 .37865 L
.6044 .37865 L
.60539 .37865 L
.60639 .37865 L
.60739 .37865 L
.60839 .37865 L
.60939 .37865 L
.61039 .37865 L
.61139 .37865 L
.61239 .37865 L
.61339 .37865 L
.61439 .37865 L
.61538 .37865 L
.61638 .37865 L
.61738 .37865 L
.61838 .37865 L
.61938 .37865 L
.62038 .37865 L
.62138 .37865 L
.62238 .37865 L
.62338 .37865 L
.62438 .37865 L
.62537 .37865 L
.62637 .37865 L
.62737 .37865 L
.62837 .37865 L
.62937 .37865 L
.63037 .37865 L
.63137 .37865 L
.63237 .37865 L
.63337 .37865 L
.63437 .37865 L
.63536 .37865 L
.63636 .37865 L
.63736 .37865 L
.63836 .37865 L
.63936 .37865 L
.64036 .37865 L
.64136 .37865 L
.64236 .37865 L
.64336 .37865 L
.64436 .37865 L
.64535 .37865 L
.64635 .37865 L
.64735 .37865 L
.64835 .37865 L
Mistroke
.64935 .38787 L
.65035 .38787 L
.65135 .38787 L
.65235 .38787 L
.65335 .38787 L
.65435 .38787 L
.65534 .38787 L
.65634 .38787 L
.65734 .38787 L
.65834 .38787 L
.65934 .38787 L
.66034 .38787 L
.66134 .38787 L
.66234 .38787 L
.66334 .38787 L
.66434 .38787 L
.66533 .38787 L
.66633 .38787 L
.66733 .38787 L
.66833 .38787 L
.66933 .38787 L
.67033 .38787 L
.67133 .38787 L
.67233 .38787 L
.67333 .38787 L
.67433 .38787 L
.67532 .38787 L
.67632 .38787 L
.67732 .38787 L
.67832 .38787 L
.67932 .38787 L
.68032 .38787 L
.68132 .38787 L
.68232 .38787 L
.68332 .38787 L
.68432 .38787 L
.68531 .38787 L
.68631 .38787 L
.68731 .38787 L
.68831 .38787 L
.68931 .38787 L
.69031 .38787 L
.69131 .38787 L
.69231 .38787 L
.69331 .38787 L
.69431 .38787 L
.6953 .38787 L
.6963 .38787 L
.6973 .38787 L
.6983 .38787 L
Mistroke
.6993 .38798 L
.7003 .38798 L
.7013 .38798 L
.7023 .38798 L
.7033 .38798 L
.7043 .38798 L
.70529 .38798 L
.70629 .38798 L
.70729 .38798 L
.70829 .38798 L
.70929 .38798 L
.71029 .38798 L
.71129 .38798 L
.71229 .38798 L
.71329 .38798 L
.71429 .38798 L
.71528 .38798 L
.71628 .38798 L
.71728 .38798 L
.71828 .38798 L
.71928 .38798 L
.72028 .38798 L
.72128 .38798 L
.72228 .38798 L
.72328 .38798 L
.72428 .38798 L
.72527 .38798 L
.72627 .38798 L
.72727 .38798 L
.72827 .38798 L
.72927 .38798 L
.73027 .38798 L
.73127 .38798 L
.73227 .38798 L
.73327 .38798 L
.73427 .38798 L
.73526 .38798 L
.73626 .38798 L
.73726 .38798 L
.73826 .38798 L
.73926 .38798 L
.74026 .38798 L
.74126 .38798 L
.74226 .38798 L
.74326 .38798 L
.74426 .38798 L
.74525 .38798 L
.74625 .38798 L
.74725 .38798 L
.74825 .38798 L
Mistroke
.74925 .38615 L
.75025 .38615 L
.75125 .38615 L
.75225 .38615 L
.75325 .38615 L
.75425 .38615 L
.75524 .38615 L
.75624 .38615 L
.75724 .38615 L
.75824 .38615 L
.75924 .38615 L
.76024 .38615 L
.76124 .38615 L
.76224 .38615 L
.76324 .38615 L
.76424 .38615 L
.76523 .38615 L
.76623 .38615 L
.76723 .38615 L
.76823 .38615 L
.76923 .38615 L
.77023 .38615 L
.77123 .38615 L
.77223 .38615 L
.77323 .38615 L
.77423 .38615 L
.77522 .38615 L
.77622 .38615 L
.77722 .38615 L
.77822 .38615 L
.77922 .38615 L
.78022 .38615 L
.78122 .38615 L
.78222 .38615 L
.78322 .38615 L
.78422 .38615 L
.78521 .38615 L
.78621 .38615 L
.78721 .38615 L
.78821 .38615 L
.78921 .38615 L
.79021 .38615 L
.79121 .38615 L
.79221 .38615 L
.79321 .38615 L
.79421 .38615 L
.7952 .38615 L
.7962 .38615 L
.7972 .38615 L
.7982 .38615 L
Mistroke
.7992 .35634 L
.8002 .35634 L
.8012 .35634 L
.8022 .35634 L
.8032 .35634 L
.8042 .35634 L
.80519 .35634 L
.80619 .35634 L
.80719 .35634 L
.80819 .35634 L
.80919 .35634 L
.81019 .35634 L
.81119 .35634 L
.81219 .35634 L
.81319 .35634 L
.81419 .35634 L
.81518 .35634 L
.81618 .35634 L
.81718 .35634 L
.81818 .35634 L
.81918 .35634 L
.82018 .35634 L
.82118 .35634 L
.82218 .35634 L
.82318 .35634 L
.82418 .35634 L
.82517 .35634 L
.82617 .35634 L
.82717 .35634 L
.82817 .35634 L
.82917 .35634 L
.83017 .35634 L
.83117 .35634 L
.83217 .35634 L
.83317 .35634 L
.83417 .35634 L
.83516 .35634 L
.83616 .35634 L
.83716 .35634 L
.83816 .35634 L
.83916 .35634 L
.84016 .35634 L
.84116 .35634 L
.84216 .35634 L
.84316 .35634 L
.84416 .35634 L
.84515 .35634 L
.84615 .35634 L
.84715 .35634 L
.84815 .35634 L
Mistroke
.84915 .35886 L
.85015 .35886 L
.85115 .35886 L
.85215 .35886 L
.85315 .35886 L
.85415 .35886 L
.85514 .35886 L
.85614 .35886 L
.85714 .35886 L
.85814 .35886 L
.85914 .35886 L
.86014 .35886 L
.86114 .35886 L
.86214 .35886 L
.86314 .35886 L
.86414 .35886 L
.86513 .35886 L
.86613 .35886 L
.86713 .35886 L
.86813 .35886 L
.86913 .35886 L
.87013 .35886 L
.87113 .35886 L
.87213 .35886 L
.87313 .35886 L
.87413 .35886 L
.87512 .35886 L
.87612 .35886 L
.87712 .35886 L
.87812 .35886 L
.87912 .35886 L
.88012 .35886 L
.88112 .35886 L
.88212 .35886 L
.88312 .35886 L
.88412 .35886 L
.88511 .35886 L
.88611 .35886 L
.88711 .35886 L
.88811 .35886 L
.88911 .35886 L
.89011 .35886 L
.89111 .35886 L
.89211 .35886 L
.89311 .35886 L
.89411 .35886 L
.8951 .35886 L
.8961 .35886 L
.8971 .35886 L
.8981 .35886 L
Mistroke
.8991 .3641 L
.9001 .3641 L
.9011 .3641 L
.9021 .3641 L
.9031 .3641 L
.9041 .3641 L
.90509 .3641 L
.90609 .3641 L
.90709 .3641 L
.90809 .3641 L
.90909 .3641 L
.91009 .3641 L
.91109 .3641 L
.91209 .3641 L
.91309 .3641 L
.91409 .3641 L
.91508 .3641 L
.91608 .3641 L
.91708 .3641 L
.91808 .3641 L
.91908 .3641 L
.92008 .3641 L
.92108 .3641 L
.92208 .3641 L
.92308 .3641 L
.92408 .3641 L
.92507 .3641 L
.92607 .3641 L
.92707 .3641 L
.92807 .3641 L
.92907 .3641 L
.93007 .3641 L
.93107 .3641 L
.93207 .3641 L
.93307 .3641 L
.93407 .3641 L
.93506 .3641 L
.93606 .3641 L
.93706 .3641 L
.93806 .3641 L
.93906 .3641 L
.94006 .3641 L
.94106 .3641 L
.94206 .3641 L
.94306 .3641 L
.94406 .3641 L
.94505 .3641 L
.94605 .3641 L
.94705 .3641 L
.94805 .3641 L
Mistroke
.94905 .36569 L
.95005 .36569 L
.95105 .36569 L
.95205 .36569 L
.95305 .36569 L
.95405 .36569 L
.95504 .36569 L
.95604 .36569 L
.95704 .36569 L
.95804 .36569 L
.95904 .36569 L
.96004 .36569 L
.96104 .36569 L
.96204 .36569 L
.96304 .36569 L
.96404 .36569 L
.96503 .36569 L
.96603 .36569 L
.96703 .36569 L
.96803 .36569 L
.96903 .36569 L
.97003 .36569 L
.97103 .36569 L
.97203 .36569 L
.97303 .36569 L
.97403 .36569 L
.97502 .36569 L
.97602 .36569 L
.97702 .36569 L
.97802 .36569 L
.97902 .36569 L
.98002 .36569 L
.98102 .36569 L
.98202 .36569 L
.98302 .36569 L
.98402 .36569 L
.98501 .36569 L
.98601 .36569 L
.98701 .36569 L
.98801 .36569 L
.98901 .36569 L
.99001 .36569 L
.99101 .36569 L
.99201 .36569 L
.99301 .36569 L
.99401 .36569 L
.995 .36569 L
.996 .36569 L
.997 .36569 L
.998 .36569 L
Mistroke
.999 .35626 L
Mfstroke
0 0 1 r
gsave
.001 -0.61803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -1.54508 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(26)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(28)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(32)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(34)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .18541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .18541 L
.05095 .18541 L
.05195 .18541 L
.05295 .18541 L
.05395 .18541 L
.05495 .18541 L
.05594 .18541 L
.05694 .18541 L
.05794 .18541 L
.05894 .18541 L
.05994 .18541 L
.06094 .18541 L
.06194 .18541 L
.06294 .18541 L
.06394 .18541 L
.06494 .18541 L
.06593 .18541 L
.06693 .18541 L
.06793 .18541 L
.06893 .18541 L
.06993 .18541 L
.07093 .18541 L
.07193 .18541 L
.07293 .18541 L
.07393 .18541 L
.07493 .18541 L
.07592 .18541 L
.07692 .18541 L
.07792 .18541 L
.07892 .18541 L
.07992 .18541 L
.08092 .18541 L
.08192 .18541 L
.08292 .18541 L
.08392 .18541 L
.08492 .18541 L
.08591 .18541 L
.08691 .18541 L
.08791 .18541 L
.08891 .18541 L
.08991 .18541 L
.09091 .18541 L
.09191 .18541 L
.09291 .18541 L
.09391 .18541 L
.09491 .18541 L
.0959 .18541 L
.0969 .18541 L
.0979 .18541 L
.0989 .18541 L
Mistroke
.0999 .18541 L
.1009 .18541 L
.1019 .18541 L
.1029 .18541 L
.1039 .18541 L
.1049 .18541 L
.10589 .18541 L
.10689 .18541 L
.10789 .18541 L
.10889 .18541 L
.10989 .18541 L
.11089 .18541 L
.11189 .18541 L
.11289 .18541 L
.11389 .18541 L
.11489 .18541 L
.11588 .18541 L
.11688 .18541 L
.11788 .18541 L
.11888 .18541 L
.11988 .18541 L
.12088 .18541 L
.12188 .18541 L
.12288 .18541 L
.12388 .18541 L
.12488 .18541 L
.12587 .18541 L
.12687 .18541 L
.12787 .18541 L
.12887 .18541 L
.12987 .18541 L
.13087 .18541 L
.13187 .18541 L
.13287 .18541 L
.13387 .18541 L
.13487 .18541 L
.13586 .18541 L
.13686 .18541 L
.13786 .18541 L
.13886 .18541 L
.13986 .18541 L
.14086 .18541 L
.14186 .18541 L
.14286 .18541 L
.14386 .18541 L
.14486 .18541 L
.14585 .18541 L
.14685 .18541 L
.14785 .18541 L
.14885 .18541 L
Mistroke
.14985 .18541 L
.15085 .18541 L
.15185 .18541 L
.15285 .18541 L
.15385 .18541 L
.15485 .18541 L
.15584 .18541 L
.15684 .18541 L
.15784 .18541 L
.15884 .18541 L
.15984 .18541 L
.16084 .18541 L
.16184 .18541 L
.16284 .18541 L
.16384 .18541 L
.16484 .18541 L
.16583 .18541 L
.16683 .18541 L
.16783 .18541 L
.16883 .18541 L
.16983 .18541 L
.17083 .18541 L
.17183 .18541 L
.17283 .18541 L
.17383 .18541 L
.17483 .18541 L
.17582 .18541 L
.17682 .18541 L
.17782 .18541 L
.17882 .18541 L
.17982 .18541 L
.18082 .18541 L
.18182 .18541 L
.18282 .18541 L
.18382 .18541 L
.18482 .18541 L
.18581 .18541 L
.18681 .18541 L
.18781 .18541 L
.18881 .18541 L
.18981 .18541 L
.19081 .18541 L
.19181 .18541 L
.19281 .18541 L
.19381 .18541 L
.19481 .18541 L
.1958 .18541 L
.1968 .18541 L
.1978 .18541 L
.1988 .18541 L
Mistroke
.1998 .18541 L
.2008 .18541 L
.2018 .18541 L
.2028 .18541 L
.2038 .18541 L
.2048 .18541 L
.20579 .18541 L
.20679 .18541 L
.20779 .18541 L
.20879 .18541 L
.20979 .18541 L
.21079 .18541 L
.21179 .18541 L
.21279 .18541 L
.21379 .18541 L
.21479 .18541 L
.21578 .18541 L
.21678 .18541 L
.21778 .18541 L
.21878 .18541 L
.21978 .18541 L
.22078 .18541 L
.22178 .18541 L
.22278 .18541 L
.22378 .18541 L
.22478 .18541 L
.22577 .18541 L
.22677 .18541 L
.22777 .18541 L
.22877 .18541 L
.22977 .18541 L
.23077 .18541 L
.23177 .18541 L
.23277 .18541 L
.23377 .18541 L
.23477 .18541 L
.23576 .18541 L
.23676 .18541 L
.23776 .18541 L
.23876 .18541 L
.23976 .18541 L
.24076 .18541 L
.24176 .18541 L
.24276 .18541 L
.24376 .18541 L
.24476 .18541 L
.24575 .18541 L
.24675 .18541 L
.24775 .18541 L
.24875 .18541 L
Mistroke
.24975 .18541 L
.25075 .18541 L
.25175 .18541 L
.25275 .18542 L
.25375 .18541 L
.25475 .18542 L
.25574 .18542 L
.25674 .18542 L
.25774 .18542 L
.25874 .18542 L
.25974 .18542 L
.26074 .18542 L
.26174 .18542 L
.26274 .18542 L
.26374 .18542 L
.26474 .18542 L
.26573 .18542 L
.26673 .18542 L
.26773 .18542 L
.26873 .18542 L
.26973 .18542 L
.27073 .18542 L
.27173 .18542 L
.27273 .18542 L
.27373 .18542 L
.27473 .18542 L
.27572 .18542 L
.27672 .18542 L
.27772 .18542 L
.27872 .18542 L
.27972 .18542 L
.28072 .18542 L
.28172 .18542 L
.28272 .18542 L
.28372 .18542 L
.28472 .18542 L
.28571 .18542 L
.28671 .18542 L
.28771 .18542 L
.28871 .18542 L
.28971 .18542 L
.29071 .18542 L
.29171 .18542 L
.29271 .18542 L
.29371 .18542 L
.29471 .18541 L
.2957 .18542 L
.2967 .18542 L
.2977 .18541 L
.2987 .18541 L
Mistroke
.2997 .18541 L
.3007 .18541 L
.3017 .18541 L
.3027 .18541 L
.3037 .18542 L
.3047 .18542 L
.30569 .18542 L
.30669 .18542 L
.30769 .18541 L
.30869 .18541 L
.30969 .18541 L
.31069 .18541 L
.31169 .18541 L
.31269 .18541 L
.31369 .18541 L
.31469 .18541 L
.31568 .18541 L
.31668 .18541 L
.31768 .18541 L
.31868 .18541 L
.31968 .18541 L
.32068 .18541 L
.32168 .18541 L
.32268 .18541 L
.32368 .18541 L
.32468 .18542 L
.32567 .18542 L
.32667 .18542 L
.32767 .18542 L
.32867 .18542 L
.32967 .18542 L
.33067 .18542 L
.33167 .18542 L
.33267 .18542 L
.33367 .18542 L
.33467 .18542 L
.33566 .18542 L
.33666 .18542 L
.33766 .18542 L
.33866 .18542 L
.33966 .18541 L
.34066 .18541 L
.34166 .18541 L
.34266 .18541 L
.34366 .18541 L
.34466 .18541 L
.34565 .18541 L
.34665 .18541 L
.34765 .18541 L
.34865 .18541 L
Mistroke
.34965 .18541 L
.35065 .18541 L
.35165 .18541 L
.35265 .18541 L
.35365 .18541 L
.35465 .18541 L
.35564 .18541 L
.35664 .18541 L
.35764 .18541 L
.35864 .18541 L
.35964 .18541 L
.36064 .18541 L
.36164 .18541 L
.36264 .18541 L
.36364 .18541 L
.36464 .18541 L
.36563 .18541 L
.36663 .18541 L
.36763 .18541 L
.36863 .18541 L
.36963 .18542 L
.37063 .18542 L
.37163 .18542 L
.37263 .18541 L
.37363 .18541 L
.37463 .18542 L
.37562 .18542 L
.37662 .18542 L
.37762 .18542 L
.37862 .18542 L
.37962 .18541 L
.38062 .18542 L
.38162 .18542 L
.38262 .18542 L
.38362 .18542 L
.38462 .18541 L
.38561 .18541 L
.38661 .18541 L
.38761 .18541 L
.38861 .18541 L
.38961 .18541 L
.39061 .18541 L
.39161 .18541 L
.39261 .18542 L
.39361 .18541 L
.39461 .18541 L
.3956 .18541 L
.3966 .18541 L
.3976 .18541 L
.3986 .18542 L
Mistroke
.3996 .18542 L
.4006 .18542 L
.4016 .18542 L
.4026 .18542 L
.4036 .18542 L
.4046 .18542 L
.40559 .18542 L
.40659 .18542 L
.40759 .18542 L
.40859 .18542 L
.40959 .18542 L
.41059 .18542 L
.41159 .18542 L
.41259 .18542 L
.41359 .18542 L
.41459 .18542 L
.41558 .18542 L
.41658 .18542 L
.41758 .18542 L
.41858 .18542 L
.41958 .18542 L
.42058 .18541 L
.42158 .18541 L
.42258 .18542 L
.42358 .18542 L
.42458 .18542 L
.42557 .18542 L
.42657 .18542 L
.42757 .18542 L
.42857 .18542 L
.42957 .18542 L
.43057 .18541 L
.43157 .18541 L
.43257 .18542 L
.43357 .18542 L
.43457 .18541 L
.43556 .18541 L
.43656 .18541 L
.43756 .18542 L
.43856 .18541 L
.43956 .18541 L
.44056 .18542 L
.44156 .18542 L
.44256 .18542 L
.44356 .18542 L
.44456 .18542 L
.44555 .18542 L
.44655 .18542 L
.44755 .18542 L
.44855 .18542 L
Mistroke
.44955 .18542 L
.45055 .18542 L
.45155 .18542 L
.45255 .18542 L
.45355 .18542 L
.45455 .18542 L
.45554 .18542 L
.45654 .18542 L
.45754 .18542 L
.45854 .18542 L
.45954 .18542 L
.46054 .18542 L
.46154 .18542 L
.46254 .18542 L
.46354 .18542 L
.46454 .18542 L
.46553 .18542 L
.46653 .18542 L
.46753 .18542 L
.46853 .18542 L
.46953 .18542 L
.47053 .18542 L
.47153 .18542 L
.47253 .18542 L
.47353 .18542 L
.47453 .18542 L
.47552 .18542 L
.47652 .18542 L
.47752 .18542 L
.47852 .18542 L
.47952 .18542 L
.48052 .18542 L
.48152 .18542 L
.48252 .18542 L
.48352 .18542 L
.48452 .18542 L
.48551 .18542 L
.48651 .18542 L
.48751 .18542 L
.48851 .18542 L
.48951 .18542 L
.49051 .18542 L
.49151 .18542 L
.49251 .18542 L
.49351 .18542 L
.49451 .18542 L
.4955 .18542 L
.4965 .18542 L
.4975 .18542 L
.4985 .18542 L
Mistroke
.4995 .18542 L
.5005 .18542 L
.5015 .18542 L
.5025 .18542 L
.5035 .18542 L
.5045 .18542 L
.50549 .18542 L
.50649 .18542 L
.50749 .18542 L
.50849 .18542 L
.50949 .18542 L
.51049 .18542 L
.51149 .18542 L
.51249 .18542 L
.51349 .18542 L
.51449 .18542 L
.51548 .18542 L
.51648 .18542 L
.51748 .18542 L
.51848 .18542 L
.51948 .18542 L
.52048 .18542 L
.52148 .18542 L
.52248 .18542 L
.52348 .18542 L
.52448 .18542 L
.52547 .18542 L
.52647 .18542 L
.52747 .18542 L
.52847 .18542 L
.52947 .18542 L
.53047 .18542 L
.53147 .18542 L
.53247 .18543 L
.53347 .18542 L
.53447 .18542 L
.53546 .18542 L
.53646 .18542 L
.53746 .18542 L
.53846 .18542 L
.53946 .18542 L
.54046 .18542 L
.54146 .18542 L
.54246 .18542 L
.54346 .18542 L
.54446 .18542 L
.54545 .18542 L
.54645 .18542 L
.54745 .18542 L
.54845 .18542 L
Mistroke
.54945 .18542 L
.55045 .18542 L
.55145 .18542 L
.55245 .18542 L
.55345 .18542 L
.55445 .18542 L
.55544 .18542 L
.55644 .18542 L
.55744 .18542 L
.55844 .18542 L
.55944 .18542 L
.56044 .18542 L
.56144 .18542 L
.56244 .18542 L
.56344 .18542 L
.56444 .18542 L
.56543 .18542 L
.56643 .18542 L
.56743 .18542 L
.56843 .18542 L
.56943 .18542 L
.57043 .18542 L
.57143 .18543 L
.57243 .18543 L
.57343 .18543 L
.57443 .18543 L
.57542 .18543 L
.57642 .18543 L
.57742 .18543 L
.57842 .18543 L
.57942 .18543 L
.58042 .18542 L
.58142 .18543 L
.58242 .18542 L
.58342 .18543 L
.58442 .18542 L
.58541 .18543 L
.58641 .18543 L
.58741 .18543 L
.58841 .18543 L
.58941 .18542 L
.59041 .18542 L
.59141 .18542 L
.59241 .18543 L
.59341 .18543 L
.59441 .18543 L
.5954 .18543 L
.5964 .18543 L
.5974 .18543 L
.5984 .18542 L
Mistroke
.5994 .18542 L
.6004 .18542 L
.6014 .18542 L
.6024 .18542 L
.6034 .18543 L
.6044 .18542 L
.60539 .18542 L
.60639 .18542 L
.60739 .18542 L
.60839 .18542 L
.60939 .18542 L
.61039 .18542 L
.61139 .18542 L
.61239 .18542 L
.61339 .18542 L
.61439 .18542 L
.61538 .18542 L
.61638 .18542 L
.61738 .18542 L
.61838 .18542 L
.61938 .18542 L
.62038 .18543 L
.62138 .18543 L
.62238 .18543 L
.62338 .18543 L
.62438 .18543 L
.62537 .18543 L
.62637 .18543 L
.62737 .18543 L
.62837 .18543 L
.62937 .18543 L
.63037 .18543 L
.63137 .18543 L
.63237 .18543 L
.63337 .18543 L
.63437 .18543 L
.63536 .18543 L
.63636 .18543 L
.63736 .18543 L
.63836 .18543 L
.63936 .18543 L
.64036 .18543 L
.64136 .18543 L
.64236 .18543 L
.64336 .18543 L
.64436 .18543 L
.64535 .18543 L
.64635 .18543 L
.64735 .18543 L
.64835 .18543 L
Mistroke
.64935 .18543 L
.65035 .18543 L
.65135 .18543 L
.65235 .18543 L
.65335 .18543 L
.65435 .18543 L
.65534 .18543 L
.65634 .18543 L
.65734 .18543 L
.65834 .18543 L
.65934 .18543 L
.66034 .18543 L
.66134 .18543 L
.66234 .18543 L
.66334 .18543 L
.66434 .18543 L
.66533 .18543 L
.66633 .18543 L
.66733 .18543 L
.66833 .18543 L
.66933 .18543 L
.67033 .18543 L
.67133 .18543 L
.67233 .18543 L
.67333 .18543 L
.67433 .18543 L
.67532 .18543 L
.67632 .18543 L
.67732 .18543 L
.67832 .18543 L
.67932 .18543 L
.68032 .18543 L
.68132 .18543 L
.68232 .18543 L
.68332 .18543 L
.68432 .18543 L
.68531 .18543 L
.68631 .18543 L
.68731 .18543 L
.68831 .18543 L
.68931 .18543 L
.69031 .18543 L
.69131 .18543 L
.69231 .18543 L
.69331 .18543 L
.69431 .18543 L
.6953 .18543 L
.6963 .18543 L
.6973 .18543 L
.6983 .18543 L
Mistroke
.6993 .18543 L
.7003 .18543 L
.7013 .18543 L
.7023 .18543 L
.7033 .18543 L
.7043 .18543 L
.70529 .18543 L
.70629 .18543 L
.70729 .18543 L
.70829 .18543 L
.70929 .18543 L
.71029 .18543 L
.71129 .18543 L
.71229 .18543 L
.71329 .18543 L
.71429 .18543 L
.71528 .18543 L
.71628 .18543 L
.71728 .18543 L
.71828 .18543 L
.71928 .18543 L
.72028 .18543 L
.72128 .18543 L
.72228 .18543 L
.72328 .18543 L
.72428 .18543 L
.72527 .18543 L
.72627 .18543 L
.72727 .18543 L
.72827 .18543 L
.72927 .18543 L
.73027 .18542 L
.73127 .18542 L
.73227 .18542 L
.73327 .18542 L
.73427 .18542 L
.73526 .18542 L
.73626 .18542 L
.73726 .18542 L
.73826 .18542 L
.73926 .18542 L
.74026 .18542 L
.74126 .18542 L
.74226 .18542 L
.74326 .18542 L
.74426 .18542 L
.74525 .18542 L
.74625 .18542 L
.74725 .18542 L
.74825 .18542 L
Mistroke
.74925 .18542 L
.75025 .18542 L
.75125 .18542 L
.75225 .18542 L
.75325 .18542 L
.75425 .18542 L
.75524 .18542 L
.75624 .18542 L
.75724 .18542 L
.75824 .18542 L
.75924 .18542 L
.76024 .18542 L
.76124 .18542 L
.76224 .18542 L
.76324 .18542 L
.76424 .18542 L
.76523 .18542 L
.76623 .18542 L
.76723 .18542 L
.76823 .18542 L
.76923 .18542 L
.77023 .18542 L
.77123 .18542 L
.77223 .18542 L
.77323 .18542 L
.77423 .18542 L
.77522 .18542 L
.77622 .18541 L
.77722 .18541 L
.77822 .18541 L
.77922 .18541 L
.78022 .18541 L
.78122 .18541 L
.78222 .18541 L
.78322 .18541 L
.78422 .18541 L
.78521 .18541 L
.78621 .18541 L
.78721 .18541 L
.78821 .18541 L
.78921 .18541 L
.79021 .18541 L
.79121 .18541 L
.79221 .18541 L
.79321 .18541 L
.79421 .18541 L
.7952 .18542 L
.7962 .18542 L
.7972 .18542 L
.7982 .18542 L
Mistroke
.7992 .18542 L
.8002 .18542 L
.8012 .18541 L
.8022 .18541 L
.8032 .18541 L
.8042 .18541 L
.80519 .18541 L
.80619 .18541 L
.80719 .18541 L
.80819 .18541 L
.80919 .18541 L
.81019 .18541 L
.81119 .18541 L
.81219 .18542 L
.81319 .18542 L
.81419 .18541 L
.81518 .18542 L
.81618 .18542 L
.81718 .18542 L
.81818 .18542 L
.81918 .18542 L
.82018 .18542 L
.82118 .18542 L
.82218 .18542 L
.82318 .18541 L
.82418 .18541 L
.82517 .18541 L
.82617 .18541 L
.82717 .18541 L
.82817 .18541 L
.82917 .18541 L
.83017 .18541 L
.83117 .18541 L
.83217 .18541 L
.83317 .18541 L
.83417 .18541 L
.83516 .18541 L
.83616 .18541 L
.83716 .18541 L
.83816 .18541 L
.83916 .18541 L
.84016 .18541 L
.84116 .18541 L
.84216 .18541 L
.84316 .18541 L
.84416 .18541 L
.84515 .18541 L
.84615 .18541 L
.84715 .18541 L
.84815 .18541 L
Mistroke
.84915 .18541 L
.85015 .18541 L
.85115 .18541 L
.85215 .18541 L
.85315 .18541 L
.85415 .18541 L
.85514 .18541 L
.85614 .18541 L
.85714 .18541 L
.85814 .18541 L
.85914 .18541 L
.86014 .18541 L
.86114 .18541 L
.86214 .18541 L
.86314 .18541 L
.86414 .18541 L
.86513 .18541 L
.86613 .18541 L
.86713 .18541 L
.86813 .18541 L
.86913 .18541 L
.87013 .18541 L
.87113 .18541 L
.87213 .18541 L
.87313 .18541 L
.87413 .18541 L
.87512 .18541 L
.87612 .18541 L
.87712 .18541 L
.87812 .18541 L
.87912 .18542 L
.88012 .18542 L
.88112 .18542 L
.88212 .18542 L
.88312 .18542 L
.88412 .18542 L
.88511 .18542 L
.88611 .18542 L
.88711 .18542 L
.88811 .18542 L
.88911 .18542 L
.89011 .18541 L
.89111 .18541 L
.89211 .18541 L
.89311 .18541 L
.89411 .18541 L
.8951 .18541 L
.8961 .18541 L
.8971 .18541 L
.8981 .18541 L
Mistroke
.8991 .18541 L
.9001 .18541 L
.9011 .18542 L
.9021 .18542 L
.9031 .18542 L
.9041 .18542 L
.90509 .18542 L
.90609 .18542 L
.90709 .18542 L
.90809 .18542 L
.90909 .18542 L
.91009 .18542 L
.91109 .18542 L
.91209 .18542 L
.91309 .18542 L
.91409 .18542 L
.91508 .18542 L
.91608 .18542 L
.91708 .18542 L
.91808 .18542 L
.91908 .18542 L
.92008 .18542 L
.92108 .18542 L
.92208 .18542 L
.92308 .18542 L
.92408 .18542 L
.92507 .18542 L
.92607 .18542 L
.92707 .18542 L
.92807 .18542 L
.92907 .18542 L
.93007 .18542 L
.93107 .18542 L
.93207 .18542 L
.93307 .18542 L
.93407 .18542 L
.93506 .18542 L
.93606 .18542 L
.93706 .18542 L
.93806 .18542 L
.93906 .18542 L
.94006 .18542 L
.94106 .18542 L
.94206 .18542 L
.94306 .18542 L
.94406 .18542 L
.94505 .18542 L
.94605 .18542 L
.94705 .18542 L
.94805 .18542 L
Mistroke
.94905 .18542 L
.95005 .18542 L
.95105 .18542 L
.95205 .18542 L
.95305 .18542 L
.95405 .18542 L
.95504 .18542 L
.95604 .18541 L
.95704 .18542 L
.95804 .18542 L
.95904 .18542 L
.96004 .18542 L
.96104 .18542 L
.96204 .18542 L
.96304 .18542 L
.96404 .18542 L
.96503 .18542 L
.96603 .18542 L
.96703 .18541 L
.96803 .18541 L
.96903 .18541 L
.97003 .18541 L
.97103 .18541 L
.97203 .18541 L
.97303 .18541 L
.97403 .18541 L
.97502 .18541 L
.97602 .18541 L
.97702 .18541 L
.97802 .18541 L
.97902 .18541 L
.98002 .18541 L
.98102 .18541 L
.98202 .18541 L
.98302 .18541 L
.98402 .18541 L
.98501 .18541 L
.98601 .18541 L
.98701 .18541 L
.98801 .18541 L
.98901 .18541 L
.99001 .18541 L
.99101 .18541 L
.99201 .18541 L
.99301 .18541 L
.99401 .18541 L
.995 .18541 L
.996 .18541 L
.997 .18541 L
.998 .18541 L
Mistroke
.999 .18541 L
Mfstroke
0 .98 .604 r
gsave
.999 .13234 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .12608 m
.001 .12608 L
.002 .12608 L
.003 .12608 L
.004 .12608 L
.005 .12608 L
.00599 .12608 L
.00699 .12608 L
.00799 .12608 L
.00899 .12608 L
.00999 .12608 L
.01099 .12608 L
.01199 .12608 L
.01299 .12608 L
.01399 .12608 L
.01499 .12608 L
.01598 .12608 L
.01698 .12608 L
.01798 .12608 L
.01898 .12608 L
.01998 .12608 L
.02098 .12608 L
.02198 .12608 L
.02298 .12608 L
.02398 .12608 L
.02498 .12608 L
.02597 .12608 L
.02697 .12608 L
.02797 .12608 L
.02897 .12608 L
.02997 .12608 L
.03097 .12608 L
.03197 .12608 L
.03297 .12608 L
.03397 .12608 L
.03497 .12608 L
.03596 .12608 L
.03696 .12608 L
.03796 .12608 L
.03896 .12608 L
.03996 .12608 L
.04096 .12608 L
.04196 .12608 L
.04296 .12608 L
.04396 .12608 L
.04496 .12608 L
.04595 .12608 L
.04695 .12608 L
.04795 .12608 L
.04895 .12608 L
Mistroke
.04995 .10809 L
.05095 .10809 L
.05195 .10809 L
.05295 .10809 L
.05395 .10809 L
.05495 .10809 L
.05594 .10809 L
.05694 .10809 L
.05794 .10809 L
.05894 .10809 L
.05994 .10809 L
.06094 .10809 L
.06194 .10809 L
.06294 .10809 L
.06394 .10809 L
.06494 .10809 L
.06593 .10809 L
.06693 .10809 L
.06793 .10809 L
.06893 .10809 L
.06993 .10809 L
.07093 .10809 L
.07193 .10809 L
.07293 .10809 L
.07393 .10809 L
.07493 .10809 L
.07592 .10809 L
.07692 .10809 L
.07792 .10809 L
.07892 .10809 L
.07992 .10809 L
.08092 .10809 L
.08192 .10809 L
.08292 .10809 L
.08392 .10809 L
.08492 .10809 L
.08591 .10809 L
.08691 .10809 L
.08791 .10809 L
.08891 .10809 L
.08991 .10809 L
.09091 .10809 L
.09191 .10809 L
.09291 .10809 L
.09391 .10809 L
.09491 .10809 L
.0959 .10809 L
.0969 .10809 L
.0979 .10809 L
.0989 .10809 L
Mistroke
.0999 .07069 L
.1009 .07069 L
.1019 .07069 L
.1029 .07069 L
.1039 .07069 L
.1049 .07069 L
.10589 .07069 L
.10689 .07069 L
.10789 .07069 L
.10889 .07069 L
.10989 .07069 L
.11089 .07069 L
.11189 .07069 L
.11289 .07069 L
.11389 .07069 L
.11489 .07069 L
.11588 .07069 L
.11688 .07069 L
.11788 .07069 L
.11888 .07069 L
.11988 .07069 L
.12088 .07069 L
.12188 .07069 L
.12288 .07069 L
.12388 .07069 L
.12488 .07069 L
.12587 .07069 L
.12687 .07069 L
.12787 .07069 L
.12887 .07069 L
.12987 .07069 L
.13087 .07069 L
.13187 .07069 L
.13287 .07069 L
.13387 .07069 L
.13487 .07069 L
.13586 .07069 L
.13686 .07069 L
.13786 .07069 L
.13886 .07069 L
.13986 .07069 L
.14086 .07069 L
.14186 .07069 L
.14286 .07069 L
.14386 .07069 L
.14486 .07069 L
.14585 .07069 L
.14685 .07069 L
.14785 .07069 L
.14885 .07069 L
Mistroke
.14985 .0747 L
.15085 .0747 L
.15185 .0747 L
.15285 .0747 L
.15385 .0747 L
.15485 .0747 L
.15584 .0747 L
.15684 .0747 L
.15784 .0747 L
.15884 .0747 L
.15984 .0747 L
.16084 .0747 L
.16184 .0747 L
.16284 .0747 L
.16384 .0747 L
.16484 .0747 L
.16583 .0747 L
.16683 .0747 L
.16783 .0747 L
.16883 .0747 L
.16983 .0747 L
.17083 .0747 L
.17183 .0747 L
.17283 .0747 L
.17383 .0747 L
.17483 .0747 L
.17582 .0747 L
.17682 .0747 L
.17782 .0747 L
.17882 .0747 L
.17982 .0747 L
.18082 .0747 L
.18182 .0747 L
.18282 .0747 L
.18382 .0747 L
.18482 .0747 L
.18581 .0747 L
.18681 .0747 L
.18781 .0747 L
.18881 .0747 L
.18981 .0747 L
.19081 .0747 L
.19181 .0747 L
.19281 .0747 L
.19381 .0747 L
.19481 .0747 L
.1958 .0747 L
.1968 .0747 L
.1978 .0747 L
.1988 .0747 L
Mistroke
.1998 .13164 L
.2008 .13164 L
.2018 .13164 L
.2028 .13164 L
.2038 .13164 L
.2048 .13164 L
.20579 .13164 L
.20679 .13164 L
.20779 .13164 L
.20879 .13164 L
.20979 .13164 L
.21079 .13164 L
.21179 .13164 L
.21279 .13164 L
.21379 .13164 L
.21479 .13164 L
.21578 .13164 L
.21678 .13164 L
.21778 .13164 L
.21878 .13164 L
.21978 .13164 L
.22078 .13164 L
.22178 .13164 L
.22278 .13164 L
.22378 .13164 L
.22478 .13164 L
.22577 .13164 L
.22677 .13164 L
.22777 .13164 L
.22877 .13164 L
.22977 .13164 L
.23077 .13164 L
.23177 .13164 L
.23277 .13164 L
.23377 .13164 L
.23477 .13164 L
.23576 .13164 L
.23676 .13164 L
.23776 .13164 L
.23876 .13164 L
.23976 .13164 L
.24076 .13164 L
.24176 .13164 L
.24276 .13164 L
.24376 .13164 L
.24476 .13164 L
.24575 .13164 L
.24675 .13164 L
.24775 .13164 L
.24875 .13164 L
Mistroke
.24975 .12538 L
.25075 .12538 L
.25175 .12538 L
.25275 .12538 L
.25375 .12538 L
.25475 .12538 L
.25574 .12538 L
.25674 .12538 L
.25774 .12538 L
.25874 .12538 L
.25974 .12538 L
.26074 .12538 L
.26174 .12538 L
.26274 .12538 L
.26374 .12538 L
.26474 .12538 L
.26573 .12538 L
.26673 .12538 L
.26773 .12538 L
.26873 .12538 L
.26973 .12538 L
.27073 .12538 L
.27173 .12538 L
.27273 .12538 L
.27373 .12538 L
.27473 .12538 L
.27572 .12538 L
.27672 .12538 L
.27772 .12538 L
.27872 .12538 L
.27972 .12538 L
.28072 .12538 L
.28172 .12538 L
.28272 .12538 L
.28372 .12538 L
.28472 .12538 L
.28571 .12538 L
.28671 .12538 L
.28771 .12538 L
.28871 .12538 L
.28971 .12538 L
.29071 .12538 L
.29171 .12538 L
.29271 .12538 L
.29371 .12538 L
.29471 .12538 L
.2957 .12538 L
.2967 .12538 L
.2977 .12538 L
.2987 .12538 L
Mistroke
.2997 .11783 L
.3007 .11783 L
.3017 .11783 L
.3027 .11783 L
.3037 .11783 L
.3047 .11783 L
.30569 .11783 L
.30669 .11783 L
.30769 .11783 L
.30869 .11783 L
.30969 .11783 L
.31069 .11783 L
.31169 .11783 L
.31269 .11783 L
.31369 .11783 L
.31469 .11783 L
.31568 .11783 L
.31668 .11783 L
.31768 .11783 L
.31868 .11783 L
.31968 .11783 L
.32068 .11783 L
.32168 .11783 L
.32268 .11783 L
.32368 .11783 L
.32468 .11783 L
.32567 .11783 L
.32667 .11783 L
.32767 .11783 L
.32867 .11783 L
.32967 .11783 L
.33067 .11783 L
.33167 .11783 L
.33267 .11783 L
.33367 .11783 L
.33467 .11783 L
.33566 .11783 L
.33666 .11783 L
.33766 .11783 L
.33866 .11783 L
.33966 .11783 L
.34066 .11783 L
.34166 .11783 L
.34266 .11783 L
.34366 .11783 L
.34466 .11783 L
.34565 .11783 L
.34665 .11783 L
.34765 .11783 L
.34865 .11783 L
Mistroke
.34965 .11326 L
.35065 .11326 L
.35165 .11326 L
.35265 .11326 L
.35365 .11326 L
.35465 .11326 L
.35564 .11326 L
.35664 .11326 L
.35764 .11326 L
.35864 .11326 L
.35964 .11326 L
.36064 .11326 L
.36164 .11326 L
.36264 .11326 L
.36364 .11326 L
.36464 .11326 L
.36563 .11326 L
.36663 .11326 L
.36763 .11326 L
.36863 .11326 L
.36963 .11326 L
.37063 .11326 L
.37163 .11326 L
.37263 .11326 L
.37363 .11326 L
.37463 .11326 L
.37562 .11326 L
.37662 .11326 L
.37762 .11326 L
.37862 .11326 L
.37962 .11326 L
.38062 .11326 L
.38162 .11326 L
.38262 .11326 L
.38362 .11326 L
.38462 .11326 L
.38561 .11326 L
.38661 .11326 L
.38761 .11326 L
.38861 .11326 L
.38961 .11326 L
.39061 .11326 L
.39161 .11326 L
.39261 .11326 L
.39361 .11326 L
.39461 .11326 L
.3956 .11326 L
.3966 .11326 L
.3976 .11326 L
.3986 .11326 L
Mistroke
.3996 .10357 L
.4006 .10357 L
.4016 .10357 L
.4026 .10357 L
.4036 .10357 L
.4046 .10357 L
.40559 .10357 L
.40659 .10357 L
.40759 .10357 L
.40859 .10357 L
.40959 .10357 L
.41059 .10357 L
.41159 .10357 L
.41259 .10357 L
.41359 .10357 L
.41459 .10357 L
.41558 .10357 L
.41658 .10357 L
.41758 .10357 L
.41858 .10357 L
.41958 .10357 L
.42058 .10357 L
.42158 .10357 L
.42258 .10357 L
.42358 .10357 L
.42458 .10357 L
.42557 .10357 L
.42657 .10357 L
.42757 .10357 L
.42857 .10357 L
.42957 .10357 L
.43057 .10357 L
.43157 .10357 L
.43257 .10357 L
.43357 .10357 L
.43457 .10357 L
.43556 .10357 L
.43656 .10357 L
.43756 .10357 L
.43856 .10357 L
.43956 .10357 L
.44056 .10357 L
.44156 .10357 L
.44256 .10357 L
.44356 .10357 L
.44456 .10357 L
.44555 .10357 L
.44655 .10357 L
.44755 .10357 L
.44855 .10357 L
Mistroke
.44955 .10606 L
.45055 .10606 L
.45155 .10606 L
.45255 .10606 L
.45355 .10606 L
.45455 .10606 L
.45554 .10606 L
.45654 .10606 L
.45754 .10606 L
.45854 .10606 L
.45954 .10606 L
.46054 .10606 L
.46154 .10606 L
.46254 .10606 L
.46354 .10606 L
.46454 .10606 L
.46553 .10606 L
.46653 .10606 L
.46753 .10606 L
.46853 .10606 L
.46953 .10606 L
.47053 .10606 L
.47153 .10606 L
.47253 .10606 L
.47353 .10606 L
.47453 .10606 L
.47552 .10606 L
.47652 .10606 L
.47752 .10606 L
.47852 .10606 L
.47952 .10606 L
.48052 .10606 L
.48152 .10606 L
.48252 .10606 L
.48352 .10606 L
.48452 .10606 L
.48551 .10606 L
.48651 .10606 L
.48751 .10606 L
.48851 .10606 L
.48951 .10606 L
.49051 .10606 L
.49151 .10606 L
.49251 .10606 L
.49351 .10606 L
.49451 .10606 L
.4955 .10606 L
.4965 .10606 L
.4975 .10606 L
.4985 .10606 L
Mistroke
.4995 .12702 L
.5005 .12702 L
.5015 .12702 L
.5025 .12702 L
.5035 .12702 L
.5045 .12702 L
.50549 .12702 L
.50649 .12702 L
.50749 .12702 L
.50849 .12702 L
.50949 .12702 L
.51049 .12702 L
.51149 .12702 L
.51249 .12702 L
.51349 .12702 L
.51449 .12702 L
.51548 .12702 L
.51648 .12702 L
.51748 .12702 L
.51848 .12702 L
.51948 .12702 L
.52048 .12702 L
.52148 .12702 L
.52248 .12702 L
.52348 .12702 L
.52448 .12702 L
.52547 .12702 L
.52647 .12702 L
.52747 .12702 L
.52847 .12702 L
.52947 .12702 L
.53047 .12702 L
.53147 .12702 L
.53247 .12702 L
.53347 .12702 L
.53447 .12702 L
.53546 .12702 L
.53646 .12702 L
.53746 .12702 L
.53846 .12702 L
.53946 .12702 L
.54046 .12702 L
.54146 .12702 L
.54246 .12702 L
.54346 .12702 L
.54446 .12702 L
.54545 .12702 L
.54645 .12702 L
.54745 .12702 L
.54845 .12702 L
Mistroke
.54945 .13271 L
.55045 .13271 L
.55145 .13271 L
.55245 .13271 L
.55345 .13271 L
.55445 .13271 L
.55544 .13271 L
.55644 .13271 L
.55744 .13271 L
.55844 .13271 L
.55944 .13271 L
.56044 .13271 L
.56144 .13271 L
.56244 .13271 L
.56344 .13271 L
.56444 .13271 L
.56543 .13271 L
.56643 .13271 L
.56743 .13271 L
.56843 .13271 L
.56943 .13271 L
.57043 .13271 L
.57143 .13271 L
.57243 .13271 L
.57343 .13271 L
.57443 .13271 L
.57542 .13271 L
.57642 .13271 L
.57742 .13271 L
.57842 .13271 L
.57942 .13271 L
.58042 .13271 L
.58142 .13271 L
.58242 .13271 L
.58342 .13271 L
.58442 .13271 L
.58541 .13271 L
.58641 .13271 L
.58741 .13271 L
.58841 .13271 L
.58941 .13271 L
.59041 .13271 L
.59141 .13271 L
.59241 .13271 L
.59341 .13271 L
.59441 .13271 L
.5954 .13271 L
.5964 .13271 L
.5974 .13271 L
.5984 .13271 L
Mistroke
.5994 .12899 L
.6004 .12899 L
.6014 .12899 L
.6024 .12899 L
.6034 .12899 L
.6044 .12899 L
.60539 .12899 L
.60639 .12899 L
.60739 .12899 L
.60839 .12899 L
.60939 .12899 L
.61039 .12899 L
.61139 .12899 L
.61239 .12899 L
.61339 .12899 L
.61439 .12899 L
.61538 .12899 L
.61638 .12899 L
.61738 .12899 L
.61838 .12899 L
.61938 .12899 L
.62038 .12899 L
.62138 .12899 L
.62238 .12899 L
.62338 .12899 L
.62438 .12899 L
.62537 .12899 L
.62637 .12899 L
.62737 .12899 L
.62837 .12899 L
.62937 .12899 L
.63037 .12899 L
.63137 .12899 L
.63237 .12899 L
.63337 .12899 L
.63437 .12899 L
.63536 .12899 L
.63636 .12899 L
.63736 .12899 L
.63836 .12899 L
.63936 .12899 L
.64036 .12899 L
.64136 .12899 L
.64236 .12899 L
.64336 .12899 L
.64436 .12899 L
.64535 .12899 L
.64635 .12899 L
.64735 .12899 L
.64835 .12899 L
Mistroke
.64935 .1208 L
.65035 .1208 L
.65135 .1208 L
.65235 .1208 L
.65335 .1208 L
.65435 .1208 L
.65534 .1208 L
.65634 .1208 L
.65734 .1208 L
.65834 .1208 L
.65934 .1208 L
.66034 .1208 L
.66134 .1208 L
.66234 .1208 L
.66334 .1208 L
.66434 .1208 L
.66533 .1208 L
.66633 .1208 L
.66733 .1208 L
.66833 .1208 L
.66933 .1208 L
.67033 .1208 L
.67133 .1208 L
.67233 .1208 L
.67333 .1208 L
.67433 .1208 L
.67532 .1208 L
.67632 .1208 L
.67732 .1208 L
.67832 .1208 L
.67932 .1208 L
.68032 .1208 L
.68132 .1208 L
.68232 .1208 L
.68332 .1208 L
.68432 .1208 L
.68531 .1208 L
.68631 .1208 L
.68731 .1208 L
.68831 .1208 L
.68931 .1208 L
.69031 .1208 L
.69131 .1208 L
.69231 .1208 L
.69331 .1208 L
.69431 .1208 L
.6953 .1208 L
.6963 .1208 L
.6973 .1208 L
.6983 .1208 L
Mistroke
.6993 .12636 L
.7003 .12636 L
.7013 .12636 L
.7023 .12636 L
.7033 .12636 L
.7043 .12636 L
.70529 .12636 L
.70629 .12636 L
.70729 .12636 L
.70829 .12636 L
.70929 .12636 L
.71029 .12636 L
.71129 .12636 L
.71229 .12636 L
.71329 .12636 L
.71429 .12636 L
.71528 .12636 L
.71628 .12636 L
.71728 .12636 L
.71828 .12636 L
.71928 .12636 L
.72028 .12636 L
.72128 .12636 L
.72228 .12636 L
.72328 .12636 L
.72428 .12636 L
.72527 .12636 L
.72627 .12636 L
.72727 .12636 L
.72827 .12636 L
.72927 .12636 L
.73027 .12636 L
.73127 .12636 L
.73227 .12636 L
.73327 .12636 L
.73427 .12636 L
.73526 .12636 L
.73626 .12636 L
.73726 .12636 L
.73826 .12636 L
.73926 .12636 L
.74026 .12636 L
.74126 .12636 L
.74226 .12636 L
.74326 .12636 L
.74426 .12636 L
.74525 .12636 L
.74625 .12636 L
.74725 .12636 L
.74825 .12636 L
Mistroke
.74925 .1327 L
.75025 .1327 L
.75125 .1327 L
.75225 .1327 L
.75325 .1327 L
.75425 .1327 L
.75524 .1327 L
.75624 .1327 L
.75724 .1327 L
.75824 .1327 L
.75924 .1327 L
.76024 .1327 L
.76124 .1327 L
.76224 .1327 L
.76324 .1327 L
.76424 .1327 L
.76523 .1327 L
.76623 .1327 L
.76723 .1327 L
.76823 .1327 L
.76923 .1327 L
.77023 .1327 L
.77123 .1327 L
.77223 .1327 L
.77323 .1327 L
.77423 .1327 L
.77522 .1327 L
.77622 .1327 L
.77722 .1327 L
.77822 .1327 L
.77922 .1327 L
.78022 .1327 L
.78122 .1327 L
.78222 .1327 L
.78322 .1327 L
.78422 .1327 L
.78521 .1327 L
.78621 .1327 L
.78721 .1327 L
.78821 .1327 L
.78921 .1327 L
.79021 .1327 L
.79121 .1327 L
.79221 .1327 L
.79321 .1327 L
.79421 .1327 L
.7952 .1327 L
.7962 .1327 L
.7972 .1327 L
.7982 .1327 L
Mistroke
.7992 .14158 L
.8002 .14158 L
.8012 .14158 L
.8022 .14158 L
.8032 .14158 L
.8042 .14158 L
.80519 .14158 L
.80619 .14158 L
.80719 .14158 L
.80819 .14158 L
.80919 .14158 L
.81019 .14158 L
.81119 .14158 L
.81219 .14158 L
.81319 .14158 L
.81419 .14158 L
.81518 .14158 L
.81618 .14158 L
.81718 .14158 L
.81818 .14158 L
.81918 .14158 L
.82018 .14158 L
.82118 .14158 L
.82218 .14158 L
.82318 .14158 L
.82418 .14158 L
.82517 .14158 L
.82617 .14158 L
.82717 .14158 L
.82817 .14158 L
.82917 .14158 L
.83017 .14158 L
.83117 .14158 L
.83217 .14158 L
.83317 .14158 L
.83417 .14158 L
.83516 .14158 L
.83616 .14158 L
.83716 .14158 L
.83816 .14158 L
.83916 .14158 L
.84016 .14158 L
.84116 .14158 L
.84216 .14158 L
.84316 .14158 L
.84416 .14158 L
.84515 .14158 L
.84615 .14158 L
.84715 .14158 L
.84815 .14158 L
Mistroke
.84915 .14885 L
.85015 .14885 L
.85115 .14885 L
.85215 .14885 L
.85315 .14885 L
.85415 .14885 L
.85514 .14885 L
.85614 .14885 L
.85714 .14885 L
.85814 .14885 L
.85914 .14885 L
.86014 .14885 L
.86114 .14885 L
.86214 .14885 L
.86314 .14885 L
.86414 .14885 L
.86513 .14885 L
.86613 .14885 L
.86713 .14885 L
.86813 .14885 L
.86913 .14885 L
.87013 .14885 L
.87113 .14885 L
.87213 .14885 L
.87313 .14885 L
.87413 .14885 L
.87512 .14885 L
.87612 .14885 L
.87712 .14885 L
.87812 .14885 L
.87912 .14885 L
.88012 .14885 L
.88112 .14885 L
.88212 .14885 L
.88312 .14885 L
.88412 .14885 L
.88511 .14885 L
.88611 .14885 L
.88711 .14885 L
.88811 .14885 L
.88911 .14885 L
.89011 .14885 L
.89111 .14885 L
.89211 .14885 L
.89311 .14885 L
.89411 .14885 L
.8951 .14885 L
.8961 .14885 L
.8971 .14885 L
.8981 .14885 L
Mistroke
.8991 .14238 L
.9001 .14238 L
.9011 .14238 L
.9021 .14238 L
.9031 .14238 L
.9041 .14238 L
.90509 .14238 L
.90609 .14238 L
.90709 .14238 L
.90809 .14238 L
.90909 .14238 L
.91009 .14238 L
.91109 .14238 L
.91209 .14238 L
.91309 .14238 L
.91409 .14238 L
.91508 .14238 L
.91608 .14238 L
.91708 .14238 L
.91808 .14238 L
.91908 .14238 L
.92008 .14238 L
.92108 .14238 L
.92208 .14238 L
.92308 .14238 L
.92408 .14238 L
.92507 .14238 L
.92607 .14238 L
.92707 .14238 L
.92807 .14238 L
.92907 .14238 L
.93007 .14238 L
.93107 .14238 L
.93207 .14238 L
.93307 .14238 L
.93407 .14238 L
.93506 .14238 L
.93606 .14238 L
.93706 .14238 L
.93806 .14238 L
.93906 .14238 L
.94006 .14238 L
.94106 .14238 L
.94206 .14238 L
.94306 .14238 L
.94406 .14238 L
.94505 .14238 L
.94605 .14238 L
.94705 .14238 L
.94805 .14238 L
Mistroke
.94905 .1381 L
.95005 .1381 L
.95105 .1381 L
.95205 .1381 L
.95305 .1381 L
.95405 .1381 L
.95504 .1381 L
.95604 .1381 L
.95704 .1381 L
.95804 .1381 L
.95904 .1381 L
.96004 .1381 L
.96104 .1381 L
.96204 .1381 L
.96304 .1381 L
.96404 .1381 L
.96503 .1381 L
.96603 .1381 L
.96703 .1381 L
.96803 .1381 L
.96903 .1381 L
.97003 .1381 L
.97103 .1381 L
.97203 .1381 L
.97303 .1381 L
.97403 .1381 L
.97502 .1381 L
.97602 .1381 L
.97702 .1381 L
.97802 .1381 L
.97902 .1381 L
.98002 .1381 L
.98102 .1381 L
.98202 .1381 L
.98302 .1381 L
.98402 .1381 L
.98501 .1381 L
.98601 .1381 L
.98701 .1381 L
.98801 .1381 L
.98901 .1381 L
.99001 .1381 L
.99101 .1381 L
.99201 .1381 L
.99301 .1381 L
.99401 .1381 L
.995 .1381 L
.996 .1381 L
.997 .1381 L
.998 .1381 L
Mistroke
.999 .13234 L
Mfstroke
gsave
.999 .23155 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36835 m
.001 .36835 L
.002 .36835 L
.003 .36835 L
.004 .36835 L
.005 .36835 L
.00599 .36835 L
.00699 .36835 L
.00799 .36835 L
.00899 .36835 L
.00999 .36835 L
.01099 .36835 L
.01199 .36835 L
.01299 .36835 L
.01399 .36835 L
.01499 .36835 L
.01598 .36835 L
.01698 .36835 L
.01798 .36835 L
.01898 .36835 L
.01998 .36835 L
.02098 .36835 L
.02198 .36835 L
.02298 .36835 L
.02398 .36835 L
.02498 .36835 L
.02597 .36835 L
.02697 .36835 L
.02797 .36835 L
.02897 .36835 L
.02997 .36835 L
.03097 .36835 L
.03197 .36835 L
.03297 .36835 L
.03397 .36835 L
.03497 .36835 L
.03596 .36835 L
.03696 .36835 L
.03796 .36835 L
.03896 .36835 L
.03996 .36835 L
.04096 .36835 L
.04196 .36835 L
.04296 .36835 L
.04396 .36835 L
.04496 .36835 L
.04595 .36835 L
.04695 .36835 L
.04795 .36835 L
.04895 .36835 L
Mistroke
.04995 .34974 L
.05095 .34974 L
.05195 .34974 L
.05295 .34974 L
.05395 .34974 L
.05495 .34974 L
.05594 .34974 L
.05694 .34974 L
.05794 .34974 L
.05894 .34974 L
.05994 .34974 L
.06094 .34974 L
.06194 .34974 L
.06294 .34974 L
.06394 .34974 L
.06494 .34974 L
.06593 .34974 L
.06693 .34974 L
.06793 .34974 L
.06893 .34974 L
.06993 .34974 L
.07093 .34974 L
.07193 .34974 L
.07293 .34974 L
.07393 .34974 L
.07493 .34974 L
.07592 .34974 L
.07692 .34974 L
.07792 .34974 L
.07892 .34974 L
.07992 .34974 L
.08092 .34974 L
.08192 .34974 L
.08292 .34974 L
.08392 .34974 L
.08492 .34974 L
.08591 .34974 L
.08691 .34974 L
.08791 .34974 L
.08891 .34974 L
.08991 .34974 L
.09091 .34974 L
.09191 .34974 L
.09291 .34974 L
.09391 .34974 L
.09491 .34974 L
.0959 .34974 L
.0969 .34974 L
.0979 .34974 L
.0989 .34974 L
Mistroke
.0999 .30958 L
.1009 .30958 L
.1019 .30958 L
.1029 .30958 L
.1039 .30958 L
.1049 .30958 L
.10589 .30958 L
.10689 .30958 L
.10789 .30958 L
.10889 .30958 L
.10989 .30958 L
.11089 .30958 L
.11189 .30958 L
.11289 .30958 L
.11389 .30958 L
.11489 .30958 L
.11588 .30958 L
.11688 .30958 L
.11788 .30958 L
.11888 .30958 L
.11988 .30958 L
.12088 .30958 L
.12188 .30958 L
.12288 .30958 L
.12388 .30958 L
.12488 .30958 L
.12587 .30958 L
.12687 .30958 L
.12787 .30958 L
.12887 .30958 L
.12987 .30958 L
.13087 .30958 L
.13187 .30958 L
.13287 .30958 L
.13387 .30958 L
.13487 .30958 L
.13586 .30958 L
.13686 .30958 L
.13786 .30958 L
.13886 .30958 L
.13986 .30958 L
.14086 .30958 L
.14186 .30958 L
.14286 .30958 L
.14386 .30958 L
.14486 .30958 L
.14585 .30958 L
.14685 .30958 L
.14785 .30958 L
.14885 .30958 L
Mistroke
.14985 .26886 L
.15085 .26886 L
.15185 .26886 L
.15285 .26886 L
.15385 .26886 L
.15485 .26886 L
.15584 .26886 L
.15684 .26886 L
.15784 .26886 L
.15884 .26886 L
.15984 .26886 L
.16084 .26886 L
.16184 .26886 L
.16284 .26886 L
.16384 .26886 L
.16484 .26886 L
.16583 .26886 L
.16683 .26886 L
.16783 .26886 L
.16883 .26886 L
.16983 .26886 L
.17083 .26886 L
.17183 .26886 L
.17283 .26886 L
.17383 .26886 L
.17483 .26886 L
.17582 .26886 L
.17682 .26886 L
.17782 .26886 L
.17882 .26886 L
.17982 .26886 L
.18082 .26886 L
.18182 .26886 L
.18282 .26886 L
.18382 .26886 L
.18482 .26886 L
.18581 .26886 L
.18681 .26886 L
.18781 .26886 L
.18881 .26886 L
.18981 .26886 L
.19081 .26886 L
.19181 .26886 L
.19281 .26886 L
.19381 .26886 L
.19481 .26886 L
.1958 .26886 L
.1968 .26886 L
.1978 .26886 L
.1988 .26886 L
Mistroke
.1998 .31923 L
.2008 .31923 L
.2018 .31923 L
.2028 .31923 L
.2038 .31923 L
.2048 .31923 L
.20579 .31923 L
.20679 .31923 L
.20779 .31923 L
.20879 .31923 L
.20979 .31923 L
.21079 .31923 L
.21179 .31923 L
.21279 .31923 L
.21379 .31923 L
.21479 .31923 L
.21578 .31923 L
.21678 .31923 L
.21778 .31923 L
.21878 .31923 L
.21978 .31923 L
.22078 .31923 L
.22178 .31923 L
.22278 .31923 L
.22378 .31923 L
.22478 .31923 L
.22577 .31923 L
.22677 .31923 L
.22777 .31923 L
.22877 .31923 L
.22977 .31923 L
.23077 .31923 L
.23177 .31923 L
.23277 .31923 L
.23377 .31923 L
.23477 .31923 L
.23576 .31923 L
.23676 .31923 L
.23776 .31923 L
.23876 .31923 L
.23976 .31923 L
.24076 .31923 L
.24176 .31923 L
.24276 .31923 L
.24376 .31923 L
.24476 .31923 L
.24575 .31923 L
.24675 .31923 L
.24775 .31923 L
.24875 .31923 L
Mistroke
.24975 .29928 L
.25075 .29928 L
.25175 .29928 L
.25275 .29928 L
.25375 .29928 L
.25475 .29928 L
.25574 .29928 L
.25674 .29928 L
.25774 .29928 L
.25874 .29928 L
.25974 .29928 L
.26074 .29928 L
.26174 .29928 L
.26274 .29928 L
.26374 .29928 L
.26474 .29928 L
.26573 .29928 L
.26673 .29928 L
.26773 .29928 L
.26873 .29928 L
.26973 .29928 L
.27073 .29928 L
.27173 .29928 L
.27273 .29928 L
.27373 .29928 L
.27473 .29928 L
.27572 .29928 L
.27672 .29928 L
.27772 .29928 L
.27872 .29928 L
.27972 .29928 L
.28072 .29928 L
.28172 .29928 L
.28272 .29928 L
.28372 .29928 L
.28472 .29928 L
.28571 .29928 L
.28671 .29928 L
.28771 .29928 L
.28871 .29928 L
.28971 .29928 L
.29071 .29928 L
.29171 .29928 L
.29271 .29928 L
.29371 .29928 L
.29471 .29928 L
.2957 .29928 L
.2967 .29928 L
.2977 .29928 L
.2987 .29928 L
Mistroke
.2997 .28318 L
.3007 .28318 L
.3017 .28318 L
.3027 .28318 L
.3037 .28318 L
.3047 .28318 L
.30569 .28318 L
.30669 .28318 L
.30769 .28318 L
.30869 .28318 L
.30969 .28318 L
.31069 .28318 L
.31169 .28318 L
.31269 .28318 L
.31369 .28318 L
.31469 .28318 L
.31568 .28318 L
.31668 .28318 L
.31768 .28318 L
.31868 .28318 L
.31968 .28318 L
.32068 .28318 L
.32168 .28318 L
.32268 .28318 L
.32368 .28318 L
.32468 .28318 L
.32567 .28318 L
.32667 .28318 L
.32767 .28318 L
.32867 .28318 L
.32967 .28318 L
.33067 .28318 L
.33167 .28318 L
.33267 .28318 L
.33367 .28318 L
.33467 .28318 L
.33566 .28318 L
.33666 .28318 L
.33766 .28318 L
.33866 .28318 L
.33966 .28318 L
.34066 .28318 L
.34166 .28318 L
.34266 .28318 L
.34366 .28318 L
.34466 .28318 L
.34565 .28318 L
.34665 .28318 L
.34765 .28318 L
.34865 .28318 L
Mistroke
.34965 .26414 L
.35065 .26414 L
.35165 .26414 L
.35265 .26414 L
.35365 .26414 L
.35465 .26414 L
.35564 .26414 L
.35664 .26414 L
.35764 .26414 L
.35864 .26414 L
.35964 .26414 L
.36064 .26414 L
.36164 .26414 L
.36264 .26414 L
.36364 .26414 L
.36464 .26414 L
.36563 .26414 L
.36663 .26414 L
.36763 .26414 L
.36863 .26414 L
.36963 .26414 L
.37063 .26414 L
.37163 .26414 L
.37263 .26414 L
.37363 .26414 L
.37463 .26414 L
.37562 .26414 L
.37662 .26414 L
.37762 .26414 L
.37862 .26414 L
.37962 .26414 L
.38062 .26414 L
.38162 .26414 L
.38262 .26414 L
.38362 .26414 L
.38462 .26414 L
.38561 .26414 L
.38661 .26414 L
.38761 .26414 L
.38861 .26414 L
.38961 .26414 L
.39061 .26414 L
.39161 .26414 L
.39261 .26414 L
.39361 .26414 L
.39461 .26414 L
.3956 .26414 L
.3966 .26414 L
.3976 .26414 L
.3986 .26414 L
Mistroke
.3996 .24867 L
.4006 .24867 L
.4016 .24867 L
.4026 .24867 L
.4036 .24867 L
.4046 .24867 L
.40559 .24867 L
.40659 .24867 L
.40759 .24867 L
.40859 .24867 L
.40959 .24867 L
.41059 .24867 L
.41159 .24867 L
.41259 .24867 L
.41359 .24867 L
.41459 .24867 L
.41558 .24867 L
.41658 .24867 L
.41758 .24867 L
.41858 .24867 L
.41958 .24867 L
.42058 .24867 L
.42158 .24867 L
.42258 .24867 L
.42358 .24867 L
.42458 .24867 L
.42557 .24867 L
.42657 .24867 L
.42757 .24867 L
.42857 .24867 L
.42957 .24867 L
.43057 .24867 L
.43157 .24867 L
.43257 .24867 L
.43357 .24867 L
.43457 .24867 L
.43556 .24867 L
.43656 .24867 L
.43756 .24867 L
.43856 .24867 L
.43956 .24867 L
.44056 .24867 L
.44156 .24867 L
.44256 .24867 L
.44356 .24867 L
.44456 .24867 L
.44555 .24867 L
.44655 .24867 L
.44755 .24867 L
.44855 .24867 L
Mistroke
.44955 .24503 L
.45055 .24503 L
.45155 .24503 L
.45255 .24503 L
.45355 .24503 L
.45455 .24503 L
.45554 .24503 L
.45654 .24503 L
.45754 .24503 L
.45854 .24503 L
.45954 .24503 L
.46054 .24503 L
.46154 .24503 L
.46254 .24503 L
.46354 .24503 L
.46454 .24503 L
.46553 .24503 L
.46653 .24503 L
.46753 .24503 L
.46853 .24503 L
.46953 .24503 L
.47053 .24503 L
.47153 .24503 L
.47253 .24503 L
.47353 .24503 L
.47453 .24503 L
.47552 .24503 L
.47652 .24503 L
.47752 .24503 L
.47852 .24503 L
.47952 .24503 L
.48052 .24503 L
.48152 .24503 L
.48252 .24503 L
.48352 .24503 L
.48452 .24503 L
.48551 .24503 L
.48651 .24503 L
.48751 .24503 L
.48851 .24503 L
.48951 .24503 L
.49051 .24503 L
.49151 .24503 L
.49251 .24503 L
.49351 .24503 L
.49451 .24503 L
.4955 .24503 L
.4965 .24503 L
.4975 .24503 L
.4985 .24503 L
Mistroke
.4995 .25616 L
.5005 .25616 L
.5015 .25616 L
.5025 .25616 L
.5035 .25616 L
.5045 .25616 L
.50549 .25616 L
.50649 .25616 L
.50749 .25616 L
.50849 .25616 L
.50949 .25616 L
.51049 .25616 L
.51149 .25616 L
.51249 .25616 L
.51349 .25616 L
.51449 .25616 L
.51548 .25616 L
.51648 .25616 L
.51748 .25616 L
.51848 .25616 L
.51948 .25616 L
.52048 .25616 L
.52148 .25616 L
.52248 .25616 L
.52348 .25616 L
.52448 .25616 L
.52547 .25616 L
.52647 .25616 L
.52747 .25616 L
.52847 .25616 L
.52947 .25616 L
.53047 .25616 L
.53147 .25616 L
.53247 .25616 L
.53347 .25616 L
.53447 .25616 L
.53546 .25616 L
.53646 .25616 L
.53746 .25616 L
.53846 .25616 L
.53946 .25616 L
.54046 .25616 L
.54146 .25616 L
.54246 .25616 L
.54346 .25616 L
.54446 .25616 L
.54545 .25616 L
.54645 .25616 L
.54745 .25616 L
.54845 .25616 L
Mistroke
.54945 .25983 L
.55045 .25983 L
.55145 .25983 L
.55245 .25983 L
.55345 .25983 L
.55445 .25983 L
.55544 .25983 L
.55644 .25983 L
.55744 .25983 L
.55844 .25983 L
.55944 .25983 L
.56044 .25983 L
.56144 .25983 L
.56244 .25983 L
.56344 .25983 L
.56444 .25983 L
.56543 .25983 L
.56643 .25983 L
.56743 .25983 L
.56843 .25983 L
.56943 .25983 L
.57043 .25983 L
.57143 .25983 L
.57243 .25983 L
.57343 .25983 L
.57443 .25983 L
.57542 .25983 L
.57642 .25983 L
.57742 .25983 L
.57842 .25983 L
.57942 .25983 L
.58042 .25983 L
.58142 .25983 L
.58242 .25983 L
.58342 .25983 L
.58442 .25983 L
.58541 .25983 L
.58641 .25983 L
.58741 .25983 L
.58841 .25983 L
.58941 .25983 L
.59041 .25983 L
.59141 .25983 L
.59241 .25983 L
.59341 .25983 L
.59441 .25983 L
.5954 .25983 L
.5964 .25983 L
.5974 .25983 L
.5984 .25983 L
Mistroke
.5994 .25177 L
.6004 .25177 L
.6014 .25177 L
.6024 .25177 L
.6034 .25177 L
.6044 .25177 L
.60539 .25177 L
.60639 .25177 L
.60739 .25177 L
.60839 .25177 L
.60939 .25177 L
.61039 .25177 L
.61139 .25177 L
.61239 .25177 L
.61339 .25177 L
.61439 .25177 L
.61538 .25177 L
.61638 .25177 L
.61738 .25177 L
.61838 .25177 L
.61938 .25177 L
.62038 .25177 L
.62138 .25177 L
.62238 .25177 L
.62338 .25177 L
.62438 .25177 L
.62537 .25177 L
.62637 .25177 L
.62737 .25177 L
.62837 .25177 L
.62937 .25177 L
.63037 .25177 L
.63137 .25177 L
.63237 .25177 L
.63337 .25177 L
.63437 .25177 L
.63536 .25177 L
.63636 .25177 L
.63736 .25177 L
.63836 .25177 L
.63936 .25177 L
.64036 .25177 L
.64136 .25177 L
.64236 .25177 L
.64336 .25177 L
.64436 .25177 L
.64535 .25177 L
.64635 .25177 L
.64735 .25177 L
.64835 .25177 L
Mistroke
.64935 .2387 L
.65035 .2387 L
.65135 .2387 L
.65235 .2387 L
.65335 .2387 L
.65435 .2387 L
.65534 .2387 L
.65634 .2387 L
.65734 .2387 L
.65834 .2387 L
.65934 .2387 L
.66034 .2387 L
.66134 .2387 L
.66234 .2387 L
.66334 .2387 L
.66434 .2387 L
.66533 .2387 L
.66633 .2387 L
.66733 .2387 L
.66833 .2387 L
.66933 .2387 L
.67033 .2387 L
.67133 .2387 L
.67233 .2387 L
.67333 .2387 L
.67433 .2387 L
.67532 .2387 L
.67632 .2387 L
.67732 .2387 L
.67832 .2387 L
.67932 .2387 L
.68032 .2387 L
.68132 .2387 L
.68232 .2387 L
.68332 .2387 L
.68432 .2387 L
.68531 .2387 L
.68631 .2387 L
.68731 .2387 L
.68831 .2387 L
.68931 .2387 L
.69031 .2387 L
.69131 .2387 L
.69231 .2387 L
.69331 .2387 L
.69431 .2387 L
.6953 .2387 L
.6963 .2387 L
.6973 .2387 L
.6983 .2387 L
Mistroke
.6993 .23901 L
.7003 .23901 L
.7013 .23901 L
.7023 .23901 L
.7033 .23901 L
.7043 .23901 L
.70529 .23901 L
.70629 .23901 L
.70729 .23901 L
.70829 .23901 L
.70929 .23901 L
.71029 .23901 L
.71129 .23901 L
.71229 .23901 L
.71329 .23901 L
.71429 .23901 L
.71528 .23901 L
.71628 .23901 L
.71728 .23901 L
.71828 .23901 L
.71928 .23901 L
.72028 .23901 L
.72128 .23901 L
.72228 .23901 L
.72328 .23901 L
.72428 .23901 L
.72527 .23901 L
.72627 .23901 L
.72727 .23901 L
.72827 .23901 L
.72927 .23901 L
.73027 .23901 L
.73127 .23901 L
.73227 .23901 L
.73327 .23901 L
.73427 .23901 L
.73526 .23901 L
.73626 .23901 L
.73726 .23901 L
.73826 .23901 L
.73926 .23901 L
.74026 .23901 L
.74126 .23901 L
.74226 .23901 L
.74326 .23901 L
.74426 .23901 L
.74525 .23901 L
.74625 .23901 L
.74725 .23901 L
.74825 .23901 L
Mistroke
.74925 .24438 L
.75025 .24438 L
.75125 .24438 L
.75225 .24438 L
.75325 .24438 L
.75425 .24438 L
.75524 .24438 L
.75624 .24438 L
.75724 .24438 L
.75824 .24438 L
.75924 .24438 L
.76024 .24438 L
.76124 .24438 L
.76224 .24438 L
.76324 .24438 L
.76424 .24438 L
.76523 .24438 L
.76623 .24438 L
.76723 .24438 L
.76823 .24438 L
.76923 .24438 L
.77023 .24438 L
.77123 .24438 L
.77223 .24438 L
.77323 .24438 L
.77423 .24438 L
.77522 .24438 L
.77622 .24438 L
.77722 .24438 L
.77822 .24438 L
.77922 .24438 L
.78022 .24438 L
.78122 .24438 L
.78222 .24438 L
.78322 .24438 L
.78422 .24438 L
.78521 .24438 L
.78621 .24438 L
.78721 .24438 L
.78821 .24438 L
.78921 .24438 L
.79021 .24438 L
.79121 .24438 L
.79221 .24438 L
.79321 .24438 L
.79421 .24438 L
.7952 .24438 L
.7962 .24438 L
.7972 .24438 L
.7982 .24438 L
Mistroke
.7992 .25018 L
.8002 .25018 L
.8012 .25018 L
.8022 .25018 L
.8032 .25018 L
.8042 .25018 L
.80519 .25018 L
.80619 .25018 L
.80719 .25018 L
.80819 .25018 L
.80919 .25018 L
.81019 .25018 L
.81119 .25018 L
.81219 .25018 L
.81319 .25018 L
.81419 .25018 L
.81518 .25018 L
.81618 .25018 L
.81718 .25018 L
.81818 .25018 L
.81918 .25018 L
.82018 .25018 L
.82118 .25018 L
.82218 .25018 L
.82318 .25018 L
.82418 .25018 L
.82517 .25018 L
.82617 .25018 L
.82717 .25018 L
.82817 .25018 L
.82917 .25018 L
.83017 .25018 L
.83117 .25018 L
.83217 .25018 L
.83317 .25018 L
.83417 .25018 L
.83516 .25018 L
.83616 .25018 L
.83716 .25018 L
.83816 .25018 L
.83916 .25018 L
.84016 .25018 L
.84116 .25018 L
.84216 .25018 L
.84316 .25018 L
.84416 .25018 L
.84515 .25018 L
.84615 .25018 L
.84715 .25018 L
.84815 .25018 L
Mistroke
.84915 .25504 L
.85015 .25504 L
.85115 .25504 L
.85215 .25504 L
.85315 .25504 L
.85415 .25504 L
.85514 .25504 L
.85614 .25504 L
.85714 .25504 L
.85814 .25504 L
.85914 .25504 L
.86014 .25504 L
.86114 .25504 L
.86214 .25504 L
.86314 .25504 L
.86414 .25504 L
.86513 .25504 L
.86613 .25504 L
.86713 .25504 L
.86813 .25504 L
.86913 .25504 L
.87013 .25504 L
.87113 .25504 L
.87213 .25504 L
.87313 .25504 L
.87413 .25504 L
.87512 .25504 L
.87612 .25504 L
.87712 .25504 L
.87812 .25504 L
.87912 .25504 L
.88012 .25504 L
.88112 .25504 L
.88212 .25504 L
.88312 .25504 L
.88412 .25504 L
.88511 .25504 L
.88611 .25504 L
.88711 .25504 L
.88811 .25504 L
.88911 .25504 L
.89011 .25504 L
.89111 .25504 L
.89211 .25504 L
.89311 .25504 L
.89411 .25504 L
.8951 .25504 L
.8961 .25504 L
.8971 .25504 L
.8981 .25504 L
Mistroke
.8991 .246 L
.9001 .246 L
.9011 .246 L
.9021 .246 L
.9031 .246 L
.9041 .246 L
.90509 .246 L
.90609 .246 L
.90709 .246 L
.90809 .246 L
.90909 .246 L
.91009 .246 L
.91109 .246 L
.91209 .246 L
.91309 .246 L
.91409 .246 L
.91508 .246 L
.91608 .246 L
.91708 .246 L
.91808 .246 L
.91908 .246 L
.92008 .246 L
.92108 .246 L
.92208 .246 L
.92308 .246 L
.92408 .246 L
.92507 .246 L
.92607 .246 L
.92707 .246 L
.92807 .246 L
.92907 .246 L
.93007 .246 L
.93107 .246 L
.93207 .246 L
.93307 .246 L
.93407 .246 L
.93506 .246 L
.93606 .246 L
.93706 .246 L
.93806 .246 L
.93906 .246 L
.94006 .246 L
.94106 .246 L
.94206 .246 L
.94306 .246 L
.94406 .246 L
.94505 .246 L
.94605 .246 L
.94705 .246 L
.94805 .246 L
Mistroke
.94905 .23997 L
.95005 .23997 L
.95105 .23997 L
.95205 .23997 L
.95305 .23997 L
.95405 .23997 L
.95504 .23997 L
.95604 .23997 L
.95704 .23997 L
.95804 .23997 L
.95904 .23997 L
.96004 .23997 L
.96104 .23997 L
.96204 .23997 L
.96304 .23997 L
.96404 .23997 L
.96503 .23997 L
.96603 .23997 L
.96703 .23997 L
.96803 .23997 L
.96903 .23997 L
.97003 .23997 L
.97103 .23997 L
.97203 .23997 L
.97303 .23997 L
.97403 .23997 L
.97502 .23997 L
.97602 .23997 L
.97702 .23997 L
.97802 .23997 L
.97902 .23997 L
.98002 .23997 L
.98102 .23997 L
.98202 .23997 L
.98302 .23997 L
.98402 .23997 L
.98501 .23997 L
.98601 .23997 L
.98701 .23997 L
.98801 .23997 L
.98901 .23997 L
.99001 .23997 L
.99101 .23997 L
.99201 .23997 L
.99301 .23997 L
.99401 .23997 L
.995 .23997 L
.996 .23997 L
.997 .23997 L
.998 .23997 L
Mistroke
.999 .23155 L
Mfstroke
1 0 0 r
gsave
.999 .18194 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24721 m
.001 .24721 L
.002 .24721 L
.003 .24721 L
.004 .24721 L
.005 .24721 L
.00599 .24721 L
.00699 .24721 L
.00799 .24721 L
.00899 .24721 L
.00999 .24721 L
.01099 .24721 L
.01199 .24721 L
.01299 .24721 L
.01399 .24721 L
.01499 .24721 L
.01598 .24721 L
.01698 .24721 L
.01798 .24721 L
.01898 .24721 L
.01998 .24721 L
.02098 .24721 L
.02198 .24721 L
.02298 .24721 L
.02398 .24721 L
.02498 .24721 L
.02597 .24721 L
.02697 .24721 L
.02797 .24721 L
.02897 .24721 L
.02997 .24721 L
.03097 .24721 L
.03197 .24721 L
.03297 .24721 L
.03397 .24721 L
.03497 .24721 L
.03596 .24721 L
.03696 .24721 L
.03796 .24721 L
.03896 .24721 L
.03996 .24721 L
.04096 .24721 L
.04196 .24721 L
.04296 .24721 L
.04396 .24721 L
.04496 .24721 L
.04595 .24721 L
.04695 .24721 L
.04795 .24721 L
.04895 .24721 L
Mistroke
.04995 .22892 L
.05095 .22892 L
.05195 .22892 L
.05295 .22892 L
.05395 .22892 L
.05495 .22892 L
.05594 .22892 L
.05694 .22892 L
.05794 .22892 L
.05894 .22892 L
.05994 .22892 L
.06094 .22892 L
.06194 .22892 L
.06294 .22892 L
.06394 .22892 L
.06494 .22892 L
.06593 .22892 L
.06693 .22892 L
.06793 .22892 L
.06893 .22892 L
.06993 .22892 L
.07093 .22892 L
.07193 .22892 L
.07293 .22892 L
.07393 .22892 L
.07493 .22892 L
.07592 .22892 L
.07692 .22892 L
.07792 .22892 L
.07892 .22892 L
.07992 .22892 L
.08092 .22892 L
.08192 .22892 L
.08292 .22892 L
.08392 .22892 L
.08492 .22892 L
.08591 .22892 L
.08691 .22892 L
.08791 .22892 L
.08891 .22892 L
.08991 .22892 L
.09091 .22892 L
.09191 .22892 L
.09291 .22892 L
.09391 .22892 L
.09491 .22892 L
.0959 .22892 L
.0969 .22892 L
.0979 .22892 L
.0989 .22892 L
Mistroke
.0999 .19014 L
.1009 .19014 L
.1019 .19014 L
.1029 .19014 L
.1039 .19014 L
.1049 .19014 L
.10589 .19014 L
.10689 .19014 L
.10789 .19014 L
.10889 .19014 L
.10989 .19014 L
.11089 .19014 L
.11189 .19014 L
.11289 .19014 L
.11389 .19014 L
.11489 .19014 L
.11588 .19014 L
.11688 .19014 L
.11788 .19014 L
.11888 .19014 L
.11988 .19014 L
.12088 .19014 L
.12188 .19014 L
.12288 .19014 L
.12388 .19014 L
.12488 .19014 L
.12587 .19014 L
.12687 .19014 L
.12787 .19014 L
.12887 .19014 L
.12987 .19014 L
.13087 .19014 L
.13187 .19014 L
.13287 .19014 L
.13387 .19014 L
.13487 .19014 L
.13586 .19014 L
.13686 .19014 L
.13786 .19014 L
.13886 .19014 L
.13986 .19014 L
.14086 .19014 L
.14186 .19014 L
.14286 .19014 L
.14386 .19014 L
.14486 .19014 L
.14585 .19014 L
.14685 .19014 L
.14785 .19014 L
.14885 .19014 L
Mistroke
.14985 .17178 L
.15085 .17178 L
.15185 .17178 L
.15285 .17178 L
.15385 .17178 L
.15485 .17178 L
.15584 .17178 L
.15684 .17178 L
.15784 .17178 L
.15884 .17178 L
.15984 .17178 L
.16084 .17178 L
.16184 .17178 L
.16284 .17178 L
.16384 .17178 L
.16484 .17178 L
.16583 .17178 L
.16683 .17178 L
.16783 .17178 L
.16883 .17178 L
.16983 .17178 L
.17083 .17178 L
.17183 .17178 L
.17283 .17178 L
.17383 .17178 L
.17483 .17178 L
.17582 .17178 L
.17682 .17178 L
.17782 .17178 L
.17882 .17178 L
.17982 .17178 L
.18082 .17178 L
.18182 .17178 L
.18282 .17178 L
.18382 .17178 L
.18482 .17178 L
.18581 .17178 L
.18681 .17178 L
.18781 .17178 L
.18881 .17178 L
.18981 .17178 L
.19081 .17178 L
.19181 .17178 L
.19281 .17178 L
.19381 .17178 L
.19481 .17178 L
.1958 .17178 L
.1968 .17178 L
.1978 .17178 L
.1988 .17178 L
Mistroke
.1998 .22544 L
.2008 .22544 L
.2018 .22544 L
.2028 .22544 L
.2038 .22544 L
.2048 .22544 L
.20579 .22544 L
.20679 .22544 L
.20779 .22544 L
.20879 .22544 L
.20979 .22544 L
.21079 .22544 L
.21179 .22544 L
.21279 .22544 L
.21379 .22544 L
.21479 .22544 L
.21578 .22544 L
.21678 .22544 L
.21778 .22544 L
.21878 .22544 L
.21978 .22544 L
.22078 .22544 L
.22178 .22544 L
.22278 .22544 L
.22378 .22544 L
.22478 .22544 L
.22577 .22544 L
.22677 .22544 L
.22777 .22544 L
.22877 .22544 L
.22977 .22544 L
.23077 .22544 L
.23177 .22544 L
.23277 .22544 L
.23377 .22544 L
.23477 .22544 L
.23576 .22544 L
.23676 .22544 L
.23776 .22544 L
.23876 .22544 L
.23976 .22544 L
.24076 .22544 L
.24176 .22544 L
.24276 .22544 L
.24376 .22544 L
.24476 .22544 L
.24575 .22544 L
.24675 .22544 L
.24775 .22544 L
.24875 .22544 L
Mistroke
.24975 .21233 L
.25075 .21233 L
.25175 .21233 L
.25275 .21233 L
.25375 .21233 L
.25475 .21233 L
.25574 .21233 L
.25674 .21233 L
.25774 .21233 L
.25874 .21233 L
.25974 .21233 L
.26074 .21233 L
.26174 .21233 L
.26274 .21233 L
.26374 .21233 L
.26474 .21233 L
.26573 .21233 L
.26673 .21233 L
.26773 .21233 L
.26873 .21233 L
.26973 .21233 L
.27073 .21233 L
.27173 .21233 L
.27273 .21233 L
.27373 .21233 L
.27473 .21233 L
.27572 .21233 L
.27672 .21233 L
.27772 .21233 L
.27872 .21233 L
.27972 .21233 L
.28072 .21233 L
.28172 .21233 L
.28272 .21233 L
.28372 .21233 L
.28472 .21233 L
.28571 .21233 L
.28671 .21233 L
.28771 .21233 L
.28871 .21233 L
.28971 .21233 L
.29071 .21233 L
.29171 .21233 L
.29271 .21233 L
.29371 .21233 L
.29471 .21233 L
.2957 .21233 L
.2967 .21233 L
.2977 .21233 L
.2987 .21233 L
Mistroke
.2997 .2005 L
.3007 .2005 L
.3017 .2005 L
.3027 .2005 L
.3037 .2005 L
.3047 .2005 L
.30569 .2005 L
.30669 .2005 L
.30769 .2005 L
.30869 .2005 L
.30969 .2005 L
.31069 .2005 L
.31169 .2005 L
.31269 .2005 L
.31369 .2005 L
.31469 .2005 L
.31568 .2005 L
.31668 .2005 L
.31768 .2005 L
.31868 .2005 L
.31968 .2005 L
.32068 .2005 L
.32168 .2005 L
.32268 .2005 L
.32368 .2005 L
.32468 .2005 L
.32567 .2005 L
.32667 .2005 L
.32767 .2005 L
.32867 .2005 L
.32967 .2005 L
.33067 .2005 L
.33167 .2005 L
.33267 .2005 L
.33367 .2005 L
.33467 .2005 L
.33566 .2005 L
.33666 .2005 L
.33766 .2005 L
.33866 .2005 L
.33966 .2005 L
.34066 .2005 L
.34166 .2005 L
.34266 .2005 L
.34366 .2005 L
.34466 .2005 L
.34565 .2005 L
.34665 .2005 L
.34765 .2005 L
.34865 .2005 L
Mistroke
.34965 .1887 L
.35065 .1887 L
.35165 .1887 L
.35265 .1887 L
.35365 .1887 L
.35465 .1887 L
.35564 .1887 L
.35664 .1887 L
.35764 .1887 L
.35864 .1887 L
.35964 .1887 L
.36064 .1887 L
.36164 .1887 L
.36264 .1887 L
.36364 .1887 L
.36464 .1887 L
.36563 .1887 L
.36663 .1887 L
.36763 .1887 L
.36863 .1887 L
.36963 .1887 L
.37063 .1887 L
.37163 .1887 L
.37263 .1887 L
.37363 .1887 L
.37463 .1887 L
.37562 .1887 L
.37662 .1887 L
.37762 .1887 L
.37862 .1887 L
.37962 .1887 L
.38062 .1887 L
.38162 .1887 L
.38262 .1887 L
.38362 .1887 L
.38462 .1887 L
.38561 .1887 L
.38661 .1887 L
.38761 .1887 L
.38861 .1887 L
.38961 .1887 L
.39061 .1887 L
.39161 .1887 L
.39261 .1887 L
.39361 .1887 L
.39461 .1887 L
.3956 .1887 L
.3966 .1887 L
.3976 .1887 L
.3986 .1887 L
Mistroke
.3996 .17612 L
.4006 .17612 L
.4016 .17612 L
.4026 .17612 L
.4036 .17612 L
.4046 .17612 L
.40559 .17612 L
.40659 .17612 L
.40759 .17612 L
.40859 .17612 L
.40959 .17612 L
.41059 .17612 L
.41159 .17612 L
.41259 .17612 L
.41359 .17612 L
.41459 .17612 L
.41558 .17612 L
.41658 .17612 L
.41758 .17612 L
.41858 .17612 L
.41958 .17612 L
.42058 .17612 L
.42158 .17612 L
.42258 .17612 L
.42358 .17612 L
.42458 .17612 L
.42557 .17612 L
.42657 .17612 L
.42757 .17612 L
.42857 .17612 L
.42957 .17612 L
.43057 .17612 L
.43157 .17612 L
.43257 .17612 L
.43357 .17612 L
.43457 .17612 L
.43556 .17612 L
.43656 .17612 L
.43756 .17612 L
.43856 .17612 L
.43956 .17612 L
.44056 .17612 L
.44156 .17612 L
.44256 .17612 L
.44356 .17612 L
.44456 .17612 L
.44555 .17612 L
.44655 .17612 L
.44755 .17612 L
.44855 .17612 L
Mistroke
.44955 .17554 L
.45055 .17554 L
.45155 .17554 L
.45255 .17554 L
.45355 .17554 L
.45455 .17554 L
.45554 .17554 L
.45654 .17554 L
.45754 .17554 L
.45854 .17554 L
.45954 .17554 L
.46054 .17554 L
.46154 .17554 L
.46254 .17554 L
.46354 .17554 L
.46454 .17554 L
.46553 .17554 L
.46653 .17554 L
.46753 .17554 L
.46853 .17554 L
.46953 .17554 L
.47053 .17554 L
.47153 .17554 L
.47253 .17554 L
.47353 .17554 L
.47453 .17554 L
.47552 .17554 L
.47652 .17554 L
.47752 .17554 L
.47852 .17554 L
.47952 .17554 L
.48052 .17554 L
.48152 .17554 L
.48252 .17554 L
.48352 .17554 L
.48452 .17554 L
.48551 .17554 L
.48651 .17554 L
.48751 .17554 L
.48851 .17554 L
.48951 .17554 L
.49051 .17554 L
.49151 .17554 L
.49251 .17554 L
.49351 .17554 L
.49451 .17554 L
.4955 .17554 L
.4965 .17554 L
.4975 .17554 L
.4985 .17554 L
Mistroke
.4995 .19159 L
.5005 .19159 L
.5015 .19159 L
.5025 .19159 L
.5035 .19159 L
.5045 .19159 L
.50549 .19159 L
.50649 .19159 L
.50749 .19159 L
.50849 .19159 L
.50949 .19159 L
.51049 .19159 L
.51149 .19159 L
.51249 .19159 L
.51349 .19159 L
.51449 .19159 L
.51548 .19159 L
.51648 .19159 L
.51748 .19159 L
.51848 .19159 L
.51948 .19159 L
.52048 .19159 L
.52148 .19159 L
.52248 .19159 L
.52348 .19159 L
.52448 .19159 L
.52547 .19159 L
.52647 .19159 L
.52747 .19159 L
.52847 .19159 L
.52947 .19159 L
.53047 .19159 L
.53147 .19159 L
.53247 .19159 L
.53347 .19159 L
.53447 .19159 L
.53546 .19159 L
.53646 .19159 L
.53746 .19159 L
.53846 .19159 L
.53946 .19159 L
.54046 .19159 L
.54146 .19159 L
.54246 .19159 L
.54346 .19159 L
.54446 .19159 L
.54545 .19159 L
.54645 .19159 L
.54745 .19159 L
.54845 .19159 L
Mistroke
.54945 .19627 L
.55045 .19627 L
.55145 .19627 L
.55245 .19627 L
.55345 .19627 L
.55445 .19627 L
.55544 .19627 L
.55644 .19627 L
.55744 .19627 L
.55844 .19627 L
.55944 .19627 L
.56044 .19627 L
.56144 .19627 L
.56244 .19627 L
.56344 .19627 L
.56444 .19627 L
.56543 .19627 L
.56643 .19627 L
.56743 .19627 L
.56843 .19627 L
.56943 .19627 L
.57043 .19627 L
.57143 .19627 L
.57243 .19627 L
.57343 .19627 L
.57443 .19627 L
.57542 .19627 L
.57642 .19627 L
.57742 .19627 L
.57842 .19627 L
.57942 .19627 L
.58042 .19627 L
.58142 .19627 L
.58242 .19627 L
.58342 .19627 L
.58442 .19627 L
.58541 .19627 L
.58641 .19627 L
.58741 .19627 L
.58841 .19627 L
.58941 .19627 L
.59041 .19627 L
.59141 .19627 L
.59241 .19627 L
.59341 .19627 L
.59441 .19627 L
.5954 .19627 L
.5964 .19627 L
.5974 .19627 L
.5984 .19627 L
Mistroke
.5994 .19038 L
.6004 .19038 L
.6014 .19038 L
.6024 .19038 L
.6034 .19038 L
.6044 .19038 L
.60539 .19038 L
.60639 .19038 L
.60739 .19038 L
.60839 .19038 L
.60939 .19038 L
.61039 .19038 L
.61139 .19038 L
.61239 .19038 L
.61339 .19038 L
.61439 .19038 L
.61538 .19038 L
.61638 .19038 L
.61738 .19038 L
.61838 .19038 L
.61938 .19038 L
.62038 .19038 L
.62138 .19038 L
.62238 .19038 L
.62338 .19038 L
.62438 .19038 L
.62537 .19038 L
.62637 .19038 L
.62737 .19038 L
.62837 .19038 L
.62937 .19038 L
.63037 .19038 L
.63137 .19038 L
.63237 .19038 L
.63337 .19038 L
.63437 .19038 L
.63536 .19038 L
.63636 .19038 L
.63736 .19038 L
.63836 .19038 L
.63936 .19038 L
.64036 .19038 L
.64136 .19038 L
.64236 .19038 L
.64336 .19038 L
.64436 .19038 L
.64535 .19038 L
.64635 .19038 L
.64735 .19038 L
.64835 .19038 L
Mistroke
.64935 .17975 L
.65035 .17975 L
.65135 .17975 L
.65235 .17975 L
.65335 .17975 L
.65435 .17975 L
.65534 .17975 L
.65634 .17975 L
.65734 .17975 L
.65834 .17975 L
.65934 .17975 L
.66034 .17975 L
.66134 .17975 L
.66234 .17975 L
.66334 .17975 L
.66434 .17975 L
.66533 .17975 L
.66633 .17975 L
.66733 .17975 L
.66833 .17975 L
.66933 .17975 L
.67033 .17975 L
.67133 .17975 L
.67233 .17975 L
.67333 .17975 L
.67433 .17975 L
.67532 .17975 L
.67632 .17975 L
.67732 .17975 L
.67832 .17975 L
.67932 .17975 L
.68032 .17975 L
.68132 .17975 L
.68232 .17975 L
.68332 .17975 L
.68432 .17975 L
.68531 .17975 L
.68631 .17975 L
.68731 .17975 L
.68831 .17975 L
.68931 .17975 L
.69031 .17975 L
.69131 .17975 L
.69231 .17975 L
.69331 .17975 L
.69431 .17975 L
.6953 .17975 L
.6963 .17975 L
.6973 .17975 L
.6983 .17975 L
Mistroke
.6993 .18268 L
.7003 .18268 L
.7013 .18268 L
.7023 .18268 L
.7033 .18268 L
.7043 .18268 L
.70529 .18268 L
.70629 .18268 L
.70729 .18268 L
.70829 .18268 L
.70929 .18268 L
.71029 .18268 L
.71129 .18268 L
.71229 .18268 L
.71329 .18268 L
.71429 .18268 L
.71528 .18268 L
.71628 .18268 L
.71728 .18268 L
.71828 .18268 L
.71928 .18268 L
.72028 .18268 L
.72128 .18268 L
.72228 .18268 L
.72328 .18268 L
.72428 .18268 L
.72527 .18268 L
.72627 .18268 L
.72727 .18268 L
.72827 .18268 L
.72927 .18268 L
.73027 .18268 L
.73127 .18268 L
.73227 .18268 L
.73327 .18268 L
.73427 .18268 L
.73526 .18268 L
.73626 .18268 L
.73726 .18268 L
.73826 .18268 L
.73926 .18268 L
.74026 .18268 L
.74126 .18268 L
.74226 .18268 L
.74326 .18268 L
.74426 .18268 L
.74525 .18268 L
.74625 .18268 L
.74725 .18268 L
.74825 .18268 L
Mistroke
.74925 .18854 L
.75025 .18854 L
.75125 .18854 L
.75225 .18854 L
.75325 .18854 L
.75425 .18854 L
.75524 .18854 L
.75624 .18854 L
.75724 .18854 L
.75824 .18854 L
.75924 .18854 L
.76024 .18854 L
.76124 .18854 L
.76224 .18854 L
.76324 .18854 L
.76424 .18854 L
.76523 .18854 L
.76623 .18854 L
.76723 .18854 L
.76823 .18854 L
.76923 .18854 L
.77023 .18854 L
.77123 .18854 L
.77223 .18854 L
.77323 .18854 L
.77423 .18854 L
.77522 .18854 L
.77622 .18854 L
.77722 .18854 L
.77822 .18854 L
.77922 .18854 L
.78022 .18854 L
.78122 .18854 L
.78222 .18854 L
.78322 .18854 L
.78422 .18854 L
.78521 .18854 L
.78621 .18854 L
.78721 .18854 L
.78821 .18854 L
.78921 .18854 L
.79021 .18854 L
.79121 .18854 L
.79221 .18854 L
.79321 .18854 L
.79421 .18854 L
.7952 .18854 L
.7962 .18854 L
.7972 .18854 L
.7982 .18854 L
Mistroke
.7992 .19588 L
.8002 .19588 L
.8012 .19588 L
.8022 .19588 L
.8032 .19588 L
.8042 .19588 L
.80519 .19588 L
.80619 .19588 L
.80719 .19588 L
.80819 .19588 L
.80919 .19588 L
.81019 .19588 L
.81119 .19588 L
.81219 .19588 L
.81319 .19588 L
.81419 .19588 L
.81518 .19588 L
.81618 .19588 L
.81718 .19588 L
.81818 .19588 L
.81918 .19588 L
.82018 .19588 L
.82118 .19588 L
.82218 .19588 L
.82318 .19588 L
.82418 .19588 L
.82517 .19588 L
.82617 .19588 L
.82717 .19588 L
.82817 .19588 L
.82917 .19588 L
.83017 .19588 L
.83117 .19588 L
.83217 .19588 L
.83317 .19588 L
.83417 .19588 L
.83516 .19588 L
.83616 .19588 L
.83716 .19588 L
.83816 .19588 L
.83916 .19588 L
.84016 .19588 L
.84116 .19588 L
.84216 .19588 L
.84316 .19588 L
.84416 .19588 L
.84515 .19588 L
.84615 .19588 L
.84715 .19588 L
.84815 .19588 L
Mistroke
.84915 .20194 L
.85015 .20194 L
.85115 .20194 L
.85215 .20194 L
.85315 .20194 L
.85415 .20194 L
.85514 .20194 L
.85614 .20194 L
.85714 .20194 L
.85814 .20194 L
.85914 .20194 L
.86014 .20194 L
.86114 .20194 L
.86214 .20194 L
.86314 .20194 L
.86414 .20194 L
.86513 .20194 L
.86613 .20194 L
.86713 .20194 L
.86813 .20194 L
.86913 .20194 L
.87013 .20194 L
.87113 .20194 L
.87213 .20194 L
.87313 .20194 L
.87413 .20194 L
.87512 .20194 L
.87612 .20194 L
.87712 .20194 L
.87812 .20194 L
.87912 .20194 L
.88012 .20194 L
.88112 .20194 L
.88212 .20194 L
.88312 .20194 L
.88412 .20194 L
.88511 .20194 L
.88611 .20194 L
.88711 .20194 L
.88811 .20194 L
.88911 .20194 L
.89011 .20194 L
.89111 .20194 L
.89211 .20194 L
.89311 .20194 L
.89411 .20194 L
.8951 .20194 L
.8961 .20194 L
.8971 .20194 L
.8981 .20194 L
Mistroke
.8991 .19419 L
.9001 .19419 L
.9011 .19419 L
.9021 .19419 L
.9031 .19419 L
.9041 .19419 L
.90509 .19419 L
.90609 .19419 L
.90709 .19419 L
.90809 .19419 L
.90909 .19419 L
.91009 .19419 L
.91109 .19419 L
.91209 .19419 L
.91309 .19419 L
.91409 .19419 L
.91508 .19419 L
.91608 .19419 L
.91708 .19419 L
.91808 .19419 L
.91908 .19419 L
.92008 .19419 L
.92108 .19419 L
.92208 .19419 L
.92308 .19419 L
.92408 .19419 L
.92507 .19419 L
.92607 .19419 L
.92707 .19419 L
.92807 .19419 L
.92907 .19419 L
.93007 .19419 L
.93107 .19419 L
.93207 .19419 L
.93307 .19419 L
.93407 .19419 L
.93506 .19419 L
.93606 .19419 L
.93706 .19419 L
.93806 .19419 L
.93906 .19419 L
.94006 .19419 L
.94106 .19419 L
.94206 .19419 L
.94306 .19419 L
.94406 .19419 L
.94505 .19419 L
.94605 .19419 L
.94705 .19419 L
.94805 .19419 L
Mistroke
.94905 .18903 L
.95005 .18903 L
.95105 .18903 L
.95205 .18903 L
.95305 .18903 L
.95405 .18903 L
.95504 .18903 L
.95604 .18903 L
.95704 .18903 L
.95804 .18903 L
.95904 .18903 L
.96004 .18903 L
.96104 .18903 L
.96204 .18903 L
.96304 .18903 L
.96404 .18903 L
.96503 .18903 L
.96603 .18903 L
.96703 .18903 L
.96803 .18903 L
.96903 .18903 L
.97003 .18903 L
.97103 .18903 L
.97203 .18903 L
.97303 .18903 L
.97403 .18903 L
.97502 .18903 L
.97602 .18903 L
.97702 .18903 L
.97802 .18903 L
.97902 .18903 L
.98002 .18903 L
.98102 .18903 L
.98202 .18903 L
.98302 .18903 L
.98402 .18903 L
.98501 .18903 L
.98601 .18903 L
.98701 .18903 L
.98801 .18903 L
.98901 .18903 L
.99001 .18903 L
.99101 .18903 L
.99201 .18903 L
.99301 .18903 L
.99401 .18903 L
.995 .18903 L
.996 .18903 L
.997 .18903 L
.998 .18903 L
Mistroke
.999 .18194 L
Mfstroke
0 0 1 r
gsave
.001 -1.8541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0772542 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -6 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -6 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -6 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -6 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -6 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(1)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(2)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(3)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(4)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(6)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(7)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .20601 m
.001 .20601 L
.002 .20601 L
.003 .20601 L
.004 .20601 L
.005 .20601 L
.00599 .20601 L
.00699 .20601 L
.00799 .20601 L
.00899 .20601 L
.00999 .20601 L
.01099 .20601 L
.01199 .20601 L
.01299 .20601 L
.01399 .20601 L
.01499 .20601 L
.01598 .20601 L
.01698 .20601 L
.01798 .20602 L
.01898 .20602 L
.01998 .20602 L
.02098 .20602 L
.02198 .20602 L
.02298 .20602 L
.02398 .20602 L
.02498 .20602 L
.02597 .20602 L
.02697 .20602 L
.02797 .20602 L
.02897 .20602 L
.02997 .20602 L
.03097 .20602 L
.03197 .20602 L
.03297 .20602 L
.03397 .20602 L
.03497 .20602 L
.03596 .20602 L
.03696 .20602 L
.03796 .20602 L
.03896 .20602 L
.03996 .20602 L
.04096 .20602 L
.04196 .20602 L
.04296 .20602 L
.04396 .20602 L
.04496 .20602 L
.04595 .20602 L
.04695 .20602 L
.04795 .20602 L
.04895 .20602 L
Mistroke
.04995 .20602 L
.05095 .20602 L
.05195 .20602 L
.05295 .20602 L
.05395 .20601 L
.05495 .20602 L
.05594 .20602 L
.05694 .20602 L
.05794 .20602 L
.05894 .20602 L
.05994 .20602 L
.06094 .20601 L
.06194 .20602 L
.06294 .20602 L
.06394 .20602 L
.06494 .20602 L
.06593 .20602 L
.06693 .20602 L
.06793 .20602 L
.06893 .20602 L
.06993 .20602 L
.07093 .20602 L
.07193 .20602 L
.07293 .20602 L
.07393 .20602 L
.07493 .20602 L
.07592 .20602 L
.07692 .20602 L
.07792 .20602 L
.07892 .20602 L
.07992 .20602 L
.08092 .20602 L
.08192 .20602 L
.08292 .20602 L
.08392 .20602 L
.08492 .20602 L
.08591 .20602 L
.08691 .20602 L
.08791 .20602 L
.08891 .20602 L
.08991 .20602 L
.09091 .20602 L
.09191 .20602 L
.09291 .20602 L
.09391 .20602 L
.09491 .20602 L
.0959 .20602 L
.0969 .20603 L
.0979 .20602 L
.0989 .20602 L
Mistroke
.0999 .20602 L
.1009 .20603 L
.1019 .20603 L
.1029 .20603 L
.1039 .20603 L
.1049 .20602 L
.10589 .20603 L
.10689 .20603 L
.10789 .20603 L
.10889 .20603 L
.10989 .20602 L
.11089 .20602 L
.11189 .20603 L
.11289 .20602 L
.11389 .20602 L
.11489 .20602 L
.11588 .20602 L
.11688 .20602 L
.11788 .20602 L
.11888 .20602 L
.11988 .20602 L
.12088 .20602 L
.12188 .20602 L
.12288 .20603 L
.12388 .20602 L
.12488 .20602 L
.12587 .20602 L
.12687 .20602 L
.12787 .20602 L
.12887 .20602 L
.12987 .20602 L
.13087 .20602 L
.13187 .20602 L
.13287 .20602 L
.13387 .20602 L
.13487 .20602 L
.13586 .20603 L
.13686 .20603 L
.13786 .20603 L
.13886 .20603 L
.13986 .20603 L
.14086 .20603 L
.14186 .20603 L
.14286 .20603 L
.14386 .20602 L
.14486 .20602 L
.14585 .20602 L
.14685 .20602 L
.14785 .20602 L
.14885 .20602 L
Mistroke
.14985 .20602 L
.15085 .20602 L
.15185 .20603 L
.15285 .20603 L
.15385 .20603 L
.15485 .20603 L
.15584 .20602 L
.15684 .20602 L
.15784 .20602 L
.15884 .20602 L
.15984 .20602 L
.16084 .20602 L
.16184 .20602 L
.16284 .20602 L
.16384 .20602 L
.16484 .20602 L
.16583 .20602 L
.16683 .20602 L
.16783 .20602 L
.16883 .20602 L
.16983 .20602 L
.17083 .20602 L
.17183 .20602 L
.17283 .20602 L
.17383 .20602 L
.17483 .20602 L
.17582 .20602 L
.17682 .20602 L
.17782 .20602 L
.17882 .20602 L
.17982 .20602 L
.18082 .20602 L
.18182 .20602 L
.18282 .20602 L
.18382 .20602 L
.18482 .20602 L
.18581 .20602 L
.18681 .20603 L
.18781 .20602 L
.18881 .20602 L
.18981 .20603 L
.19081 .20603 L
.19181 .20603 L
.19281 .20603 L
.19381 .20603 L
.19481 .20603 L
.1958 .20603 L
.1968 .20603 L
.1978 .20603 L
.1988 .20603 L
Mistroke
.1998 .20603 L
.2008 .20603 L
.2018 .20603 L
.2028 .20603 L
.2038 .20603 L
.2048 .20603 L
.20579 .20603 L
.20679 .20603 L
.20779 .20603 L
.20879 .20603 L
.20979 .20603 L
.21079 .20603 L
.21179 .20603 L
.21279 .20603 L
.21379 .20603 L
.21479 .20603 L
.21578 .20603 L
.21678 .20603 L
.21778 .20603 L
.21878 .20603 L
.21978 .20603 L
.22078 .20603 L
.22178 .20603 L
.22278 .20603 L
.22378 .20603 L
.22478 .20603 L
.22577 .20603 L
.22677 .20603 L
.22777 .20603 L
.22877 .20603 L
.22977 .20603 L
.23077 .20603 L
.23177 .20603 L
.23277 .20603 L
.23377 .20603 L
.23477 .20603 L
.23576 .20603 L
.23676 .20603 L
.23776 .20603 L
.23876 .20603 L
.23976 .20602 L
.24076 .20602 L
.24176 .20602 L
.24276 .20602 L
.24376 .20602 L
.24476 .20603 L
.24575 .20603 L
.24675 .20603 L
.24775 .20603 L
.24875 .20603 L
Mistroke
.24975 .20603 L
.25075 .20603 L
.25175 .20603 L
.25275 .20603 L
.25375 .20603 L
.25475 .20603 L
.25574 .20603 L
.25674 .20603 L
.25774 .20603 L
.25874 .20602 L
.25974 .20603 L
.26074 .20602 L
.26174 .20602 L
.26274 .20602 L
.26374 .20603 L
.26474 .20603 L
.26573 .20603 L
.26673 .20603 L
.26773 .20603 L
.26873 .20603 L
.26973 .20603 L
.27073 .20603 L
.27173 .20603 L
.27273 .20603 L
.27373 .20603 L
.27473 .20603 L
.27572 .20602 L
.27672 .20602 L
.27772 .20602 L
.27872 .20602 L
.27972 .20602 L
.28072 .20602 L
.28172 .20602 L
.28272 .20602 L
.28372 .20602 L
.28472 .20602 L
.28571 .20603 L
.28671 .20603 L
.28771 .20603 L
.28871 .20603 L
.28971 .20603 L
.29071 .20603 L
.29171 .20603 L
.29271 .20603 L
.29371 .20603 L
.29471 .20603 L
.2957 .20603 L
.2967 .20603 L
.2977 .20603 L
.2987 .20603 L
Mistroke
.2997 .20603 L
.3007 .20603 L
.3017 .20603 L
.3027 .20603 L
.3037 .20603 L
.3047 .20603 L
.30569 .20603 L
.30669 .20603 L
.30769 .20603 L
.30869 .20603 L
.30969 .20603 L
.31069 .20603 L
.31169 .20603 L
.31269 .20603 L
.31369 .20603 L
.31469 .20603 L
.31568 .20603 L
.31668 .20603 L
.31768 .20603 L
.31868 .20603 L
.31968 .20603 L
.32068 .20603 L
.32168 .20603 L
.32268 .20603 L
.32368 .20603 L
.32468 .20603 L
.32567 .20603 L
.32667 .20603 L
.32767 .20603 L
.32867 .20603 L
.32967 .20603 L
.33067 .20603 L
.33167 .20603 L
.33267 .20603 L
.33367 .20603 L
.33467 .20603 L
.33566 .20603 L
.33666 .20603 L
.33766 .20603 L
.33866 .20603 L
.33966 .20603 L
.34066 .20603 L
.34166 .20603 L
.34266 .20604 L
.34366 .20603 L
.34466 .20603 L
.34565 .20604 L
.34665 .20603 L
.34765 .20604 L
.34865 .20604 L
Mistroke
.34965 .20603 L
.35065 .20603 L
.35165 .20603 L
.35265 .20604 L
.35365 .20603 L
.35465 .20603 L
.35564 .20603 L
.35664 .20603 L
.35764 .20603 L
.35864 .20603 L
.35964 .20603 L
.36064 .20604 L
.36164 .20604 L
.36264 .20604 L
.36364 .20604 L
.36464 .20604 L
.36563 .20604 L
.36663 .20604 L
.36763 .20604 L
.36863 .20604 L
.36963 .20604 L
.37063 .20604 L
.37163 .20604 L
.37263 .20604 L
.37363 .20604 L
.37463 .20604 L
.37562 .20604 L
.37662 .20604 L
.37762 .20604 L
.37862 .20604 L
.37962 .20604 L
.38062 .20604 L
.38162 .20604 L
.38262 .20604 L
.38362 .20604 L
.38462 .20604 L
.38561 .20603 L
.38661 .20604 L
.38761 .20604 L
.38861 .20604 L
.38961 .20604 L
.39061 .20604 L
.39161 .20604 L
.39261 .20604 L
.39361 .20604 L
.39461 .20604 L
.3956 .20604 L
.3966 .20604 L
.3976 .20604 L
.3986 .20604 L
Mistroke
.3996 .20604 L
.4006 .20604 L
.4016 .20604 L
.4026 .20604 L
.4036 .20604 L
.4046 .20604 L
.40559 .20604 L
.40659 .20604 L
.40759 .20604 L
.40859 .20604 L
.40959 .20604 L
.41059 .20604 L
.41159 .20604 L
.41259 .20604 L
.41359 .20604 L
.41459 .20604 L
.41558 .20604 L
.41658 .20604 L
.41758 .20604 L
.41858 .20604 L
.41958 .20604 L
.42058 .20604 L
.42158 .20604 L
.42258 .20604 L
.42358 .20604 L
.42458 .20604 L
.42557 .20604 L
.42657 .20604 L
.42757 .20604 L
.42857 .20604 L
.42957 .20604 L
.43057 .20604 L
.43157 .20604 L
.43257 .20604 L
.43357 .20604 L
.43457 .20604 L
.43556 .20604 L
.43656 .20604 L
.43756 .20604 L
.43856 .20604 L
.43956 .20604 L
.44056 .20604 L
.44156 .20604 L
.44256 .20604 L
.44356 .20604 L
.44456 .20604 L
.44555 .20604 L
.44655 .20604 L
.44755 .20604 L
.44855 .20604 L
Mistroke
.44955 .20604 L
.45055 .20604 L
.45155 .20604 L
.45255 .20604 L
.45355 .20604 L
.45455 .20604 L
.45554 .20604 L
.45654 .20603 L
.45754 .20604 L
.45854 .20604 L
.45954 .20604 L
.46054 .20604 L
.46154 .20604 L
.46254 .20604 L
.46354 .20604 L
.46454 .20604 L
.46553 .20604 L
.46653 .20604 L
.46753 .20604 L
.46853 .20604 L
.46953 .20604 L
.47053 .20604 L
.47153 .20604 L
.47253 .20604 L
.47353 .20604 L
.47453 .20604 L
.47552 .20604 L
.47652 .20604 L
.47752 .20604 L
.47852 .20604 L
.47952 .20604 L
.48052 .20604 L
.48152 .20604 L
.48252 .20604 L
.48352 .20604 L
.48452 .20605 L
.48551 .20604 L
.48651 .20604 L
.48751 .20604 L
.48851 .20604 L
.48951 .20604 L
.49051 .20604 L
.49151 .20605 L
.49251 .20604 L
.49351 .20605 L
.49451 .20605 L
.4955 .20605 L
.4965 .20605 L
.4975 .20604 L
.4985 .20604 L
Mistroke
.4995 .20604 L
.5005 .20604 L
.5015 .20604 L
.5025 .20604 L
.5035 .20604 L
.5045 .20604 L
.50549 .20604 L
.50649 .20604 L
.50749 .20604 L
.50849 .20604 L
.50949 .20604 L
.51049 .20604 L
.51149 .20604 L
.51249 .20604 L
.51349 .20604 L
.51449 .20604 L
.51548 .20604 L
.51648 .20604 L
.51748 .20604 L
.51848 .20604 L
.51948 .20604 L
.52048 .20604 L
.52148 .20604 L
.52248 .20604 L
.52348 .20604 L
.52448 .20604 L
.52547 .20604 L
.52647 .20604 L
.52747 .20604 L
.52847 .20604 L
.52947 .20604 L
.53047 .20605 L
.53147 .20605 L
.53247 .20605 L
.53347 .20605 L
.53447 .20605 L
.53546 .20605 L
.53646 .20605 L
.53746 .20605 L
.53846 .20605 L
.53946 .20604 L
.54046 .20604 L
.54146 .20604 L
.54246 .20604 L
.54346 .20604 L
.54446 .20604 L
.54545 .20604 L
.54645 .20604 L
.54745 .20604 L
.54845 .20604 L
Mistroke
.54945 .20604 L
.55045 .20604 L
.55145 .20604 L
.55245 .20604 L
.55345 .20604 L
.55445 .20604 L
.55544 .20605 L
.55644 .20605 L
.55744 .20604 L
.55844 .20605 L
.55944 .20605 L
.56044 .20605 L
.56144 .20605 L
.56244 .20604 L
.56344 .20604 L
.56444 .20604 L
.56543 .20604 L
.56643 .20604 L
.56743 .20604 L
.56843 .20604 L
.56943 .20604 L
.57043 .20604 L
.57143 .20605 L
.57243 .20605 L
.57343 .20605 L
.57443 .20605 L
.57542 .20605 L
.57642 .20605 L
.57742 .20605 L
.57842 .20605 L
.57942 .20605 L
.58042 .20605 L
.58142 .20605 L
.58242 .20605 L
.58342 .20605 L
.58442 .20604 L
.58541 .20604 L
.58641 .20604 L
.58741 .20605 L
.58841 .20604 L
.58941 .20605 L
.59041 .20605 L
.59141 .20605 L
.59241 .20605 L
.59341 .20605 L
.59441 .20605 L
.5954 .20604 L
.5964 .20604 L
.5974 .20604 L
.5984 .20604 L
Mistroke
.5994 .20605 L
.6004 .20605 L
.6014 .20605 L
.6024 .20605 L
.6034 .20605 L
.6044 .20605 L
.60539 .20605 L
.60639 .20605 L
.60739 .20605 L
.60839 .20605 L
.60939 .20605 L
.61039 .20604 L
.61139 .20604 L
.61239 .20604 L
.61339 .20604 L
.61439 .20604 L
.61538 .20604 L
.61638 .20604 L
.61738 .20604 L
.61838 .20604 L
.61938 .20604 L
.62038 .20604 L
.62138 .20604 L
.62238 .20604 L
.62338 .20604 L
.62438 .20604 L
.62537 .20604 L
.62637 .20604 L
.62737 .20604 L
.62837 .20604 L
.62937 .20604 L
.63037 .20605 L
.63137 .20605 L
.63237 .20605 L
.63337 .20605 L
.63437 .20605 L
.63536 .20605 L
.63636 .20605 L
.63736 .20605 L
.63836 .20605 L
.63936 .20605 L
.64036 .20605 L
.64136 .20605 L
.64236 .20605 L
.64336 .20605 L
.64436 .20605 L
.64535 .20605 L
.64635 .20605 L
.64735 .20605 L
.64835 .20605 L
Mistroke
.64935 .20605 L
.65035 .20605 L
.65135 .20605 L
.65235 .20605 L
.65335 .20605 L
.65435 .20605 L
.65534 .20605 L
.65634 .20605 L
.65734 .20605 L
.65834 .20605 L
.65934 .20605 L
.66034 .20605 L
.66134 .20605 L
.66234 .20605 L
.66334 .20605 L
.66434 .20605 L
.66533 .20605 L
.66633 .20605 L
.66733 .20605 L
.66833 .20605 L
.66933 .20605 L
.67033 .20605 L
.67133 .20605 L
.67233 .20605 L
.67333 .20605 L
.67433 .20605 L
.67532 .20605 L
.67632 .20605 L
.67732 .20605 L
.67832 .20605 L
.67932 .20605 L
.68032 .20605 L
.68132 .20605 L
.68232 .20605 L
.68332 .20605 L
.68432 .20605 L
.68531 .20605 L
.68631 .20605 L
.68731 .20605 L
.68831 .20605 L
.68931 .20605 L
.69031 .20605 L
.69131 .20605 L
.69231 .20605 L
.69331 .20605 L
.69431 .20605 L
.6953 .20605 L
.6963 .20605 L
.6973 .20605 L
.6983 .20605 L
Mistroke
.6993 .20605 L
.7003 .20605 L
.7013 .20605 L
.7023 .20605 L
.7033 .20605 L
.7043 .20605 L
.70529 .20605 L
.70629 .20605 L
.70729 .20605 L
.70829 .20605 L
.70929 .20605 L
.71029 .20605 L
.71129 .20605 L
.71229 .20605 L
.71329 .20605 L
.71429 .20605 L
.71528 .20605 L
.71628 .20605 L
.71728 .20604 L
.71828 .20604 L
.71928 .20604 L
.72028 .20604 L
.72128 .20605 L
.72228 .20605 L
.72328 .20605 L
.72428 .20605 L
.72527 .20605 L
.72627 .20605 L
.72727 .20605 L
.72827 .20605 L
.72927 .20605 L
.73027 .20605 L
.73127 .20605 L
.73227 .20605 L
.73327 .20605 L
.73427 .20605 L
.73526 .20605 L
.73626 .20605 L
.73726 .20605 L
.73826 .20605 L
.73926 .20605 L
.74026 .20605 L
.74126 .20605 L
.74226 .20605 L
.74326 .20605 L
.74426 .20605 L
.74525 .20605 L
.74625 .20605 L
.74725 .20605 L
.74825 .20605 L
Mistroke
.74925 .20605 L
.75025 .20605 L
.75125 .20605 L
.75225 .20605 L
.75325 .20605 L
.75425 .20606 L
.75524 .20606 L
.75624 .20606 L
.75724 .20606 L
.75824 .20606 L
.75924 .20605 L
.76024 .20605 L
.76124 .20605 L
.76224 .20605 L
.76324 .20606 L
.76424 .20606 L
.76523 .20606 L
.76623 .20606 L
.76723 .20606 L
.76823 .20606 L
.76923 .20606 L
.77023 .20606 L
.77123 .20606 L
.77223 .20606 L
.77323 .20606 L
.77423 .20606 L
.77522 .20606 L
.77622 .20606 L
.77722 .20606 L
.77822 .20606 L
.77922 .20606 L
.78022 .20606 L
.78122 .20606 L
.78222 .20606 L
.78322 .20606 L
.78422 .20606 L
.78521 .20606 L
.78621 .20606 L
.78721 .20606 L
.78821 .20606 L
.78921 .20606 L
.79021 .20606 L
.79121 .20606 L
.79221 .20606 L
.79321 .20606 L
.79421 .20606 L
.7952 .20606 L
.7962 .20606 L
.7972 .20606 L
.7982 .20606 L
Mistroke
.7992 .20606 L
.8002 .20606 L
.8012 .20607 L
.8022 .20606 L
.8032 .20607 L
.8042 .20607 L
.80519 .20606 L
.80619 .20606 L
.80719 .20606 L
.80819 .20606 L
.80919 .20606 L
.81019 .20606 L
.81119 .20607 L
.81219 .20607 L
.81319 .20607 L
.81419 .20607 L
.81518 .20607 L
.81618 .20607 L
.81718 .20606 L
.81818 .20606 L
.81918 .20606 L
.82018 .20606 L
.82118 .20606 L
.82218 .20606 L
.82318 .20606 L
.82418 .20606 L
.82517 .20606 L
.82617 .20606 L
.82717 .20606 L
.82817 .20606 L
.82917 .20606 L
.83017 .20606 L
.83117 .20606 L
.83217 .20606 L
.83317 .20607 L
.83417 .20607 L
.83516 .20607 L
.83616 .20607 L
.83716 .20607 L
.83816 .20607 L
.83916 .20607 L
.84016 .20607 L
.84116 .20606 L
.84216 .20606 L
.84316 .20606 L
.84416 .20606 L
.84515 .20606 L
.84615 .20607 L
.84715 .20606 L
.84815 .20606 L
Mistroke
.84915 .20606 L
.85015 .20606 L
.85115 .20606 L
.85215 .20606 L
.85315 .20606 L
.85415 .20607 L
.85514 .20607 L
.85614 .20607 L
.85714 .20607 L
.85814 .20607 L
.85914 .20607 L
.86014 .20607 L
.86114 .20607 L
.86214 .20607 L
.86314 .20607 L
.86414 .20607 L
.86513 .20607 L
.86613 .20607 L
.86713 .20607 L
.86813 .20607 L
.86913 .20607 L
.87013 .20607 L
.87113 .20607 L
.87213 .20607 L
.87313 .20607 L
.87413 .20607 L
.87512 .20607 L
.87612 .20607 L
.87712 .20607 L
.87812 .20607 L
.87912 .20607 L
.88012 .20607 L
.88112 .20607 L
.88212 .20607 L
.88312 .20607 L
.88412 .20607 L
.88511 .20607 L
.88611 .20607 L
.88711 .20607 L
.88811 .20607 L
.88911 .20607 L
.89011 .20607 L
.89111 .20607 L
.89211 .20607 L
.89311 .20607 L
.89411 .20607 L
.8951 .20607 L
.8961 .20607 L
.8971 .20607 L
.8981 .20607 L
Mistroke
.8991 .20606 L
.9001 .20607 L
.9011 .20607 L
.9021 .20606 L
.9031 .20606 L
.9041 .20606 L
.90509 .20606 L
.90609 .20606 L
.90709 .20606 L
.90809 .20606 L
.90909 .20606 L
.91009 .20606 L
.91109 .20606 L
.91209 .20606 L
.91309 .20606 L
.91409 .20606 L
.91508 .20606 L
.91608 .20606 L
.91708 .20606 L
.91808 .20606 L
.91908 .20606 L
.92008 .20606 L
.92108 .20607 L
.92208 .20606 L
.92308 .20606 L
.92408 .20606 L
.92507 .20606 L
.92607 .20606 L
.92707 .20606 L
.92807 .20606 L
.92907 .20606 L
.93007 .20606 L
.93107 .20606 L
.93207 .20606 L
.93307 .20606 L
.93407 .20606 L
.93506 .20606 L
.93606 .20606 L
.93706 .20606 L
.93806 .20606 L
.93906 .20606 L
.94006 .20606 L
.94106 .20606 L
.94206 .20606 L
.94306 .20606 L
.94406 .20606 L
.94505 .20606 L
.94605 .20606 L
.94705 .20606 L
.94805 .20606 L
Mistroke
.94905 .20606 L
.95005 .20606 L
.95105 .20606 L
.95205 .20606 L
.95305 .20606 L
.95405 .20606 L
.95504 .20606 L
.95604 .20606 L
.95704 .20606 L
.95804 .20606 L
.95904 .20606 L
.96004 .20606 L
.96104 .20606 L
.96204 .20606 L
.96304 .20606 L
.96404 .20606 L
.96503 .20606 L
.96603 .20606 L
.96703 .20606 L
.96803 .20606 L
.96903 .20607 L
.97003 .20607 L
.97103 .20607 L
.97203 .20606 L
.97303 .20606 L
.97403 .20606 L
.97502 .20606 L
.97602 .20606 L
.97702 .20606 L
.97802 .20606 L
.97902 .20606 L
.98002 .20606 L
.98102 .20606 L
.98202 .20606 L
.98302 .20606 L
.98402 .20606 L
.98501 .20606 L
.98601 .20606 L
.98701 .20606 L
.98801 .20606 L
.98901 .20606 L
.99001 .20606 L
.99101 .20606 L
.99201 .20606 L
.99301 .20606 L
.99401 .20607 L
.995 .20607 L
.996 .20607 L
.997 .20607 L
.998 .20607 L
Mistroke
.999 .20607 L
Mfstroke
0 .98 .604 r
gsave
.999 .16681 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .13185 m
.001 .13185 L
.002 .13185 L
.003 .13185 L
.004 .13185 L
.005 .13185 L
.00599 .13185 L
.00699 .13185 L
.00799 .13185 L
.00899 .13185 L
.00999 .13185 L
.01099 .13185 L
.01199 .13185 L
.01299 .13185 L
.01399 .13185 L
.01499 .13185 L
.01598 .13185 L
.01698 .13185 L
.01798 .13185 L
.01898 .13185 L
.01998 .13185 L
.02098 .13185 L
.02198 .13185 L
.02298 .13185 L
.02398 .13185 L
.02498 .13185 L
.02597 .13185 L
.02697 .13185 L
.02797 .13185 L
.02897 .13185 L
.02997 .13185 L
.03097 .13185 L
.03197 .13185 L
.03297 .13185 L
.03397 .13185 L
.03497 .13185 L
.03596 .13185 L
.03696 .13185 L
.03796 .13185 L
.03896 .13185 L
.03996 .13185 L
.04096 .13185 L
.04196 .13185 L
.04296 .13185 L
.04396 .13185 L
.04496 .13185 L
.04595 .13185 L
.04695 .13185 L
.04795 .13185 L
.04895 .13185 L
Mistroke
Mfstroke
.04895 .13185 m
.04952 0 L
s
.09936 0 m
.0999 .11613 L
.1009 .11613 L
.1019 .11613 L
.1029 .11613 L
.1039 .11613 L
.1049 .11613 L
.10589 .11613 L
.10689 .11613 L
.10789 .11613 L
.10889 .11613 L
.10989 .11613 L
.11089 .11613 L
.11189 .11613 L
.11289 .11613 L
.11389 .11613 L
.11489 .11613 L
.11588 .11613 L
.11688 .11613 L
.11788 .11613 L
.11888 .11613 L
.11988 .11613 L
.12088 .11613 L
.12188 .11613 L
.12288 .11613 L
.12388 .11613 L
.12488 .11613 L
.12587 .11613 L
.12687 .11613 L
.12787 .11613 L
.12887 .11613 L
.12987 .11613 L
.13087 .11613 L
.13187 .11613 L
.13287 .11613 L
.13387 .11613 L
.13487 .11613 L
.13586 .11613 L
.13686 .11613 L
.13786 .11613 L
.13886 .11613 L
.13986 .11613 L
.14086 .11613 L
.14186 .11613 L
.14286 .11613 L
.14386 .11613 L
.14486 .11613 L
.14585 .11613 L
.14685 .11613 L
.14785 .11613 L
Mistroke
.14885 .11613 L
.14985 .12313 L
.15085 .12313 L
.15185 .12313 L
.15285 .12313 L
.15385 .12313 L
.15485 .12313 L
.15584 .12313 L
.15684 .12313 L
.15784 .12313 L
.15884 .12313 L
.15984 .12313 L
.16084 .12313 L
.16184 .12313 L
.16284 .12313 L
.16384 .12313 L
.16484 .12313 L
.16583 .12313 L
.16683 .12313 L
.16783 .12313 L
.16883 .12313 L
.16983 .12313 L
.17083 .12313 L
.17183 .12313 L
.17283 .12313 L
.17383 .12313 L
.17483 .12313 L
.17582 .12313 L
.17682 .12313 L
.17782 .12313 L
.17882 .12313 L
.17982 .12313 L
.18082 .12313 L
.18182 .12313 L
.18282 .12313 L
.18382 .12313 L
.18482 .12313 L
.18581 .12313 L
.18681 .12313 L
.18781 .12313 L
.18881 .12313 L
.18981 .12313 L
.19081 .12313 L
.19181 .12313 L
.19281 .12313 L
.19381 .12313 L
.19481 .12313 L
.1958 .12313 L
.1968 .12313 L
.1978 .12313 L
Mistroke
.1988 .12313 L
.1998 .13498 L
.2008 .13498 L
.2018 .13498 L
.2028 .13498 L
.2038 .13498 L
.2048 .13498 L
.20579 .13498 L
.20679 .13498 L
.20779 .13498 L
.20879 .13498 L
.20979 .13498 L
.21079 .13498 L
.21179 .13498 L
.21279 .13498 L
.21379 .13498 L
.21479 .13498 L
.21578 .13498 L
.21678 .13498 L
.21778 .13498 L
.21878 .13498 L
.21978 .13498 L
.22078 .13498 L
.22178 .13498 L
.22278 .13498 L
.22378 .13498 L
.22478 .13498 L
.22577 .13498 L
.22677 .13498 L
.22777 .13498 L
.22877 .13498 L
.22977 .13498 L
.23077 .13498 L
.23177 .13498 L
.23277 .13498 L
.23377 .13498 L
.23477 .13498 L
.23576 .13498 L
.23676 .13498 L
.23776 .13498 L
.23876 .13498 L
.23976 .13498 L
.24076 .13498 L
.24176 .13498 L
.24276 .13498 L
.24376 .13498 L
.24476 .13498 L
.24575 .13498 L
.24675 .13498 L
.24775 .13498 L
Mistroke
.24875 .13498 L
.24975 .14221 L
.25075 .14221 L
.25175 .14221 L
.25275 .14221 L
.25375 .14221 L
.25475 .14221 L
.25574 .14221 L
.25674 .14221 L
.25774 .14221 L
.25874 .14221 L
.25974 .14221 L
.26074 .14221 L
.26174 .14221 L
.26274 .14221 L
.26374 .14221 L
.26474 .14221 L
.26573 .14221 L
.26673 .14221 L
.26773 .14221 L
.26873 .14221 L
.26973 .14221 L
.27073 .14221 L
.27173 .14221 L
.27273 .14221 L
.27373 .14221 L
.27473 .14221 L
.27572 .14221 L
.27672 .14221 L
.27772 .14221 L
.27872 .14221 L
.27972 .14221 L
.28072 .14221 L
.28172 .14221 L
.28272 .14221 L
.28372 .14221 L
.28472 .14221 L
.28571 .14221 L
.28671 .14221 L
.28771 .14221 L
.28871 .14221 L
.28971 .14221 L
.29071 .14221 L
.29171 .14221 L
.29271 .14221 L
.29371 .14221 L
.29471 .14221 L
.2957 .14221 L
.2967 .14221 L
.2977 .14221 L
Mistroke
.2987 .14221 L
.2997 .14288 L
.3007 .14288 L
.3017 .14288 L
.3027 .14288 L
.3037 .14288 L
.3047 .14288 L
.30569 .14288 L
.30669 .14288 L
.30769 .14288 L
.30869 .14288 L
.30969 .14288 L
.31069 .14288 L
.31169 .14288 L
.31269 .14288 L
.31369 .14288 L
.31469 .14288 L
.31568 .14288 L
.31668 .14288 L
.31768 .14288 L
.31868 .14288 L
.31968 .14288 L
.32068 .14288 L
.32168 .14288 L
.32268 .14288 L
.32368 .14288 L
.32468 .14288 L
.32567 .14288 L
.32667 .14288 L
.32767 .14288 L
.32867 .14288 L
.32967 .14288 L
.33067 .14288 L
.33167 .14288 L
.33267 .14288 L
.33367 .14288 L
.33467 .14288 L
.33566 .14288 L
.33666 .14288 L
.33766 .14288 L
.33866 .14288 L
.33966 .14288 L
.34066 .14288 L
.34166 .14288 L
.34266 .14288 L
.34366 .14288 L
.34466 .14288 L
.34565 .14288 L
.34665 .14288 L
.34765 .14288 L
Mistroke
.34865 .14288 L
.34965 .14293 L
.35065 .14293 L
.35165 .14293 L
.35265 .14293 L
.35365 .14293 L
.35465 .14293 L
.35564 .14293 L
.35664 .14293 L
.35764 .14293 L
.35864 .14293 L
.35964 .14293 L
.36064 .14293 L
.36164 .14293 L
.36264 .14293 L
.36364 .14293 L
.36464 .14293 L
.36563 .14293 L
.36663 .14293 L
.36763 .14293 L
.36863 .14293 L
.36963 .14293 L
.37063 .14293 L
.37163 .14293 L
.37263 .14293 L
.37363 .14293 L
.37463 .14293 L
.37562 .14293 L
.37662 .14293 L
.37762 .14293 L
.37862 .14293 L
.37962 .14293 L
.38062 .14293 L
.38162 .14293 L
.38262 .14293 L
.38362 .14293 L
.38462 .14293 L
.38561 .14293 L
.38661 .14293 L
.38761 .14293 L
.38861 .14293 L
.38961 .14293 L
.39061 .14293 L
.39161 .14293 L
.39261 .14293 L
.39361 .14293 L
.39461 .14293 L
.3956 .14293 L
.3966 .14293 L
.3976 .14293 L
Mistroke
.3986 .14293 L
.3996 .14683 L
.4006 .14683 L
.4016 .14683 L
.4026 .14683 L
.4036 .14683 L
.4046 .14683 L
.40559 .14683 L
.40659 .14683 L
.40759 .14683 L
.40859 .14683 L
.40959 .14683 L
.41059 .14683 L
.41159 .14683 L
.41259 .14683 L
.41359 .14683 L
.41459 .14683 L
.41558 .14683 L
.41658 .14683 L
.41758 .14683 L
.41858 .14683 L
.41958 .14683 L
.42058 .14683 L
.42158 .14683 L
.42258 .14683 L
.42358 .14683 L
.42458 .14683 L
.42557 .14683 L
.42657 .14683 L
.42757 .14683 L
.42857 .14683 L
.42957 .14683 L
.43057 .14683 L
.43157 .14683 L
.43257 .14683 L
.43357 .14683 L
.43457 .14683 L
.43556 .14683 L
.43656 .14683 L
.43756 .14683 L
.43856 .14683 L
.43956 .14683 L
.44056 .14683 L
.44156 .14683 L
.44256 .14683 L
.44356 .14683 L
.44456 .14683 L
.44555 .14683 L
.44655 .14683 L
.44755 .14683 L
Mistroke
.44855 .14683 L
.44955 .14709 L
.45055 .14709 L
.45155 .14709 L
.45255 .14709 L
.45355 .14709 L
.45455 .14709 L
.45554 .14709 L
.45654 .14709 L
.45754 .14709 L
.45854 .14709 L
.45954 .14709 L
.46054 .14709 L
.46154 .14709 L
.46254 .14709 L
.46354 .14709 L
.46454 .14709 L
.46553 .14709 L
.46653 .14709 L
.46753 .14709 L
.46853 .14709 L
.46953 .14709 L
.47053 .14709 L
.47153 .14709 L
.47253 .14709 L
.47353 .14709 L
.47453 .14709 L
.47552 .14709 L
.47652 .14709 L
.47752 .14709 L
.47852 .14709 L
.47952 .14709 L
.48052 .14709 L
.48152 .14709 L
.48252 .14709 L
.48352 .14709 L
.48452 .14709 L
.48551 .14709 L
.48651 .14709 L
.48751 .14709 L
.48851 .14709 L
.48951 .14709 L
.49051 .14709 L
.49151 .14709 L
.49251 .14709 L
.49351 .14709 L
.49451 .14709 L
.4955 .14709 L
.4965 .14709 L
.4975 .14709 L
Mistroke
.4985 .14709 L
.4995 .15166 L
.5005 .15166 L
.5015 .15166 L
.5025 .15166 L
.5035 .15166 L
.5045 .15166 L
.50549 .15166 L
.50649 .15166 L
.50749 .15166 L
.50849 .15166 L
.50949 .15166 L
.51049 .15166 L
.51149 .15166 L
.51249 .15166 L
.51349 .15166 L
.51449 .15166 L
.51548 .15166 L
.51648 .15166 L
.51748 .15166 L
.51848 .15166 L
.51948 .15166 L
.52048 .15166 L
.52148 .15166 L
.52248 .15166 L
.52348 .15166 L
.52448 .15166 L
.52547 .15166 L
.52647 .15166 L
.52747 .15166 L
.52847 .15166 L
.52947 .15166 L
.53047 .15166 L
.53147 .15166 L
.53247 .15166 L
.53347 .15166 L
.53447 .15166 L
.53546 .15166 L
.53646 .15166 L
.53746 .15166 L
.53846 .15166 L
.53946 .15166 L
.54046 .15166 L
.54146 .15166 L
.54246 .15166 L
.54346 .15166 L
.54446 .15166 L
.54545 .15166 L
.54645 .15166 L
.54745 .15166 L
Mistroke
.54845 .15166 L
.54945 .15198 L
.55045 .15198 L
.55145 .15198 L
.55245 .15198 L
.55345 .15198 L
.55445 .15198 L
.55544 .15198 L
.55644 .15198 L
.55744 .15198 L
.55844 .15198 L
.55944 .15198 L
.56044 .15198 L
.56144 .15198 L
.56244 .15198 L
.56344 .15198 L
.56444 .15198 L
.56543 .15198 L
.56643 .15198 L
.56743 .15198 L
.56843 .15198 L
.56943 .15198 L
.57043 .15198 L
.57143 .15198 L
.57243 .15198 L
.57343 .15198 L
.57443 .15198 L
.57542 .15198 L
.57642 .15198 L
.57742 .15198 L
.57842 .15198 L
.57942 .15198 L
.58042 .15198 L
.58142 .15198 L
.58242 .15198 L
.58342 .15198 L
.58442 .15198 L
.58541 .15198 L
.58641 .15198 L
.58741 .15198 L
.58841 .15198 L
.58941 .15198 L
.59041 .15198 L
.59141 .15198 L
.59241 .15198 L
.59341 .15198 L
.59441 .15198 L
.5954 .15198 L
.5964 .15198 L
.5974 .15198 L
Mistroke
.5984 .15198 L
.5994 .15399 L
.6004 .15399 L
.6014 .15399 L
.6024 .15399 L
.6034 .15399 L
.6044 .15399 L
.60539 .15399 L
.60639 .15399 L
.60739 .15399 L
.60839 .15399 L
.60939 .15399 L
.61039 .15399 L
.61139 .15399 L
.61239 .15399 L
.61339 .15399 L
.61439 .15399 L
.61538 .15399 L
.61638 .15399 L
.61738 .15399 L
.61838 .15399 L
.61938 .15399 L
.62038 .15399 L
.62138 .15399 L
.62238 .15399 L
.62338 .15399 L
.62438 .15399 L
.62537 .15399 L
.62637 .15399 L
.62737 .15399 L
.62837 .15399 L
.62937 .15399 L
.63037 .15399 L
.63137 .15399 L
.63237 .15399 L
.63337 .15399 L
.63437 .15399 L
.63536 .15399 L
.63636 .15399 L
.63736 .15399 L
.63836 .15399 L
.63936 .15399 L
.64036 .15399 L
.64136 .15399 L
.64236 .15399 L
.64336 .15399 L
.64436 .15399 L
.64535 .15399 L
.64635 .15399 L
.64735 .15399 L
Mistroke
.64835 .15399 L
.64935 .1537 L
.65035 .1537 L
.65135 .1537 L
.65235 .1537 L
.65335 .1537 L
.65435 .1537 L
.65534 .1537 L
.65634 .1537 L
.65734 .1537 L
.65834 .1537 L
.65934 .1537 L
.66034 .1537 L
.66134 .1537 L
.66234 .1537 L
.66334 .1537 L
.66434 .1537 L
.66533 .1537 L
.66633 .1537 L
.66733 .1537 L
.66833 .1537 L
.66933 .1537 L
.67033 .1537 L
.67133 .1537 L
.67233 .1537 L
.67333 .1537 L
.67433 .1537 L
.67532 .1537 L
.67632 .1537 L
.67732 .1537 L
.67832 .1537 L
.67932 .1537 L
.68032 .1537 L
.68132 .1537 L
.68232 .1537 L
.68332 .1537 L
.68432 .1537 L
.68531 .1537 L
.68631 .1537 L
.68731 .1537 L
.68831 .1537 L
.68931 .1537 L
.69031 .1537 L
.69131 .1537 L
.69231 .1537 L
.69331 .1537 L
.69431 .1537 L
.6953 .1537 L
.6963 .1537 L
.6973 .1537 L
Mistroke
.6983 .1537 L
.6993 .15406 L
.7003 .15406 L
.7013 .15406 L
.7023 .15406 L
.7033 .15406 L
.7043 .15406 L
.70529 .15406 L
.70629 .15406 L
.70729 .15406 L
.70829 .15406 L
.70929 .15406 L
.71029 .15406 L
.71129 .15406 L
.71229 .15406 L
.71329 .15406 L
.71429 .15406 L
.71528 .15406 L
.71628 .15406 L
.71728 .15406 L
.71828 .15406 L
.71928 .15406 L
.72028 .15406 L
.72128 .15406 L
.72228 .15406 L
.72328 .15406 L
.72428 .15406 L
.72527 .15406 L
.72627 .15406 L
.72727 .15406 L
.72827 .15406 L
.72927 .15406 L
.73027 .15406 L
.73127 .15406 L
.73227 .15406 L
.73327 .15406 L
.73427 .15406 L
.73526 .15406 L
.73626 .15406 L
.73726 .15406 L
.73826 .15406 L
.73926 .15406 L
.74026 .15406 L
.74126 .15406 L
.74226 .15406 L
.74326 .15406 L
.74426 .15406 L
.74525 .15406 L
.74625 .15406 L
.74725 .15406 L
Mistroke
.74825 .15406 L
.74925 .1561 L
.75025 .1561 L
.75125 .1561 L
.75225 .1561 L
.75325 .1561 L
.75425 .1561 L
.75524 .1561 L
.75624 .1561 L
.75724 .1561 L
.75824 .1561 L
.75924 .1561 L
.76024 .1561 L
.76124 .1561 L
.76224 .1561 L
.76324 .1561 L
.76424 .1561 L
.76523 .1561 L
.76623 .1561 L
.76723 .1561 L
.76823 .1561 L
.76923 .1561 L
.77023 .1561 L
.77123 .1561 L
.77223 .1561 L
.77323 .1561 L
.77423 .1561 L
.77522 .1561 L
.77622 .1561 L
.77722 .1561 L
.77822 .1561 L
.77922 .1561 L
.78022 .1561 L
.78122 .1561 L
.78222 .1561 L
.78322 .1561 L
.78422 .1561 L
.78521 .1561 L
.78621 .1561 L
.78721 .1561 L
.78821 .1561 L
.78921 .1561 L
.79021 .1561 L
.79121 .1561 L
.79221 .1561 L
.79321 .1561 L
.79421 .1561 L
.7952 .1561 L
.7962 .1561 L
.7972 .1561 L
Mistroke
.7982 .1561 L
.7992 .15874 L
.8002 .15874 L
.8012 .15874 L
.8022 .15874 L
.8032 .15874 L
.8042 .15874 L
.80519 .15874 L
.80619 .15874 L
.80719 .15874 L
.80819 .15874 L
.80919 .15874 L
.81019 .15874 L
.81119 .15874 L
.81219 .15874 L
.81319 .15874 L
.81419 .15874 L
.81518 .15874 L
.81618 .15874 L
.81718 .15874 L
.81818 .15874 L
.81918 .15874 L
.82018 .15874 L
.82118 .15874 L
.82218 .15874 L
.82318 .15874 L
.82418 .15874 L
.82517 .15874 L
.82617 .15874 L
.82717 .15874 L
.82817 .15874 L
.82917 .15874 L
.83017 .15874 L
.83117 .15874 L
.83217 .15874 L
.83317 .15874 L
.83417 .15874 L
.83516 .15874 L
.83616 .15874 L
.83716 .15874 L
.83816 .15874 L
.83916 .15874 L
.84016 .15874 L
.84116 .15874 L
.84216 .15874 L
.84316 .15874 L
.84416 .15874 L
.84515 .15874 L
.84615 .15874 L
.84715 .15874 L
Mistroke
.84815 .15874 L
.84915 .16085 L
.85015 .16085 L
.85115 .16085 L
.85215 .16085 L
.85315 .16085 L
.85415 .16085 L
.85514 .16085 L
.85614 .16085 L
.85714 .16085 L
.85814 .16085 L
.85914 .16085 L
.86014 .16085 L
.86114 .16085 L
.86214 .16085 L
.86314 .16085 L
.86414 .16085 L
.86513 .16085 L
.86613 .16085 L
.86713 .16085 L
.86813 .16085 L
.86913 .16085 L
.87013 .16085 L
.87113 .16085 L
.87213 .16085 L
.87313 .16085 L
.87413 .16085 L
.87512 .16085 L
.87612 .16085 L
.87712 .16085 L
.87812 .16085 L
.87912 .16085 L
.88012 .16085 L
.88112 .16085 L
.88212 .16085 L
.88312 .16085 L
.88412 .16085 L
.88511 .16085 L
.88611 .16085 L
.88711 .16085 L
.88811 .16085 L
.88911 .16085 L
.89011 .16085 L
.89111 .16085 L
.89211 .16085 L
.89311 .16085 L
.89411 .16085 L
.8951 .16085 L
.8961 .16085 L
.8971 .16085 L
Mistroke
.8981 .16085 L
.8991 .16439 L
.9001 .16439 L
.9011 .16439 L
.9021 .16439 L
.9031 .16439 L
.9041 .16439 L
.90509 .16439 L
.90609 .16439 L
.90709 .16439 L
.90809 .16439 L
.90909 .16439 L
.91009 .16439 L
.91109 .16439 L
.91209 .16439 L
.91309 .16439 L
.91409 .16439 L
.91508 .16439 L
.91608 .16439 L
.91708 .16439 L
.91808 .16439 L
.91908 .16439 L
.92008 .16439 L
.92108 .16439 L
.92208 .16439 L
.92308 .16439 L
.92408 .16439 L
.92507 .16439 L
.92607 .16439 L
.92707 .16439 L
.92807 .16439 L
.92907 .16439 L
.93007 .16439 L
.93107 .16439 L
.93207 .16439 L
.93307 .16439 L
.93407 .16439 L
.93506 .16439 L
.93606 .16439 L
.93706 .16439 L
.93806 .16439 L
.93906 .16439 L
.94006 .16439 L
.94106 .16439 L
.94206 .16439 L
.94306 .16439 L
.94406 .16439 L
.94505 .16439 L
.94605 .16439 L
.94705 .16439 L
Mistroke
.94805 .16439 L
.94905 .16634 L
.95005 .16634 L
.95105 .16634 L
.95205 .16634 L
.95305 .16634 L
.95405 .16634 L
.95504 .16634 L
.95604 .16634 L
.95704 .16634 L
.95804 .16634 L
.95904 .16634 L
.96004 .16634 L
.96104 .16634 L
.96204 .16634 L
.96304 .16634 L
.96404 .16634 L
.96503 .16634 L
.96603 .16634 L
.96703 .16634 L
.96803 .16634 L
.96903 .16634 L
.97003 .16634 L
.97103 .16634 L
.97203 .16634 L
.97303 .16634 L
.97403 .16634 L
.97502 .16634 L
.97602 .16634 L
.97702 .16634 L
.97802 .16634 L
.97902 .16634 L
.98002 .16634 L
.98102 .16634 L
.98202 .16634 L
.98302 .16634 L
.98402 .16634 L
.98501 .16634 L
.98601 .16634 L
.98701 .16634 L
.98801 .16634 L
.98901 .16634 L
.99001 .16634 L
.99101 .16634 L
.99201 .16634 L
.99301 .16634 L
.99401 .16634 L
.995 .16634 L
.996 .16634 L
.997 .16634 L
Mistroke
.998 .16634 L
.999 .16681 L
Mfstroke
gsave
.999 .18841 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .43468 m
.001 .43468 L
.002 .43468 L
.003 .43468 L
.004 .43468 L
.005 .43468 L
.00599 .43468 L
.00699 .43468 L
.00799 .43468 L
.00899 .43468 L
.00999 .43468 L
.01099 .43468 L
.01199 .43468 L
.01299 .43468 L
.01399 .43468 L
.01499 .43468 L
.01598 .43468 L
.01698 .43468 L
.01798 .43468 L
.01898 .43468 L
.01998 .43468 L
.02098 .43468 L
.02198 .43468 L
.02298 .43468 L
.02398 .43468 L
.02498 .43468 L
.02597 .43468 L
.02697 .43468 L
.02797 .43468 L
.02897 .43468 L
.02997 .43468 L
.03097 .43468 L
.03197 .43468 L
.03297 .43468 L
.03397 .43468 L
.03497 .43468 L
.03596 .43468 L
.03696 .43468 L
.03796 .43468 L
.03896 .43468 L
.03996 .43468 L
.04096 .43468 L
.04196 .43468 L
.04296 .43468 L
.04396 .43468 L
.04496 .43468 L
.04595 .43468 L
.04695 .43468 L
.04795 .43468 L
.04895 .43468 L
Mistroke
.04995 .16721 L
.05095 .16721 L
.05195 .16721 L
.05295 .16721 L
.05395 .16721 L
.05495 .16721 L
.05594 .16721 L
.05694 .16721 L
.05794 .16721 L
.05894 .16721 L
.05994 .16721 L
.06094 .16721 L
.06194 .16721 L
.06294 .16721 L
.06394 .16721 L
.06494 .16721 L
.06593 .16721 L
.06693 .16721 L
.06793 .16721 L
.06893 .16721 L
.06993 .16721 L
.07093 .16721 L
.07193 .16721 L
.07293 .16721 L
.07393 .16721 L
.07493 .16721 L
.07592 .16721 L
.07692 .16721 L
.07792 .16721 L
.07892 .16721 L
.07992 .16721 L
.08092 .16721 L
.08192 .16721 L
.08292 .16721 L
.08392 .16721 L
.08492 .16721 L
.08591 .16721 L
.08691 .16721 L
.08791 .16721 L
.08891 .16721 L
.08991 .16721 L
.09091 .16721 L
.09191 .16721 L
.09291 .16721 L
.09391 .16721 L
.09491 .16721 L
.0959 .16721 L
.0969 .16721 L
.0979 .16721 L
.0989 .16721 L
Mistroke
.0999 .15125 L
.1009 .15125 L
.1019 .15125 L
.1029 .15125 L
.1039 .15125 L
.1049 .15125 L
.10589 .15125 L
.10689 .15125 L
.10789 .15125 L
.10889 .15125 L
.10989 .15125 L
.11089 .15125 L
.11189 .15125 L
.11289 .15125 L
.11389 .15125 L
.11489 .15125 L
.11588 .15125 L
.11688 .15125 L
.11788 .15125 L
.11888 .15125 L
.11988 .15125 L
.12088 .15125 L
.12188 .15125 L
.12288 .15125 L
.12388 .15125 L
.12488 .15125 L
.12587 .15125 L
.12687 .15125 L
.12787 .15125 L
.12887 .15125 L
.12987 .15125 L
.13087 .15125 L
.13187 .15125 L
.13287 .15125 L
.13387 .15125 L
.13487 .15125 L
.13586 .15125 L
.13686 .15125 L
.13786 .15125 L
.13886 .15125 L
.13986 .15125 L
.14086 .15125 L
.14186 .15125 L
.14286 .15125 L
.14386 .15125 L
.14486 .15125 L
.14585 .15125 L
.14685 .15125 L
.14785 .15125 L
.14885 .15125 L
Mistroke
.14985 .15722 L
.15085 .15722 L
.15185 .15722 L
.15285 .15722 L
.15385 .15722 L
.15485 .15722 L
.15584 .15722 L
.15684 .15722 L
.15784 .15722 L
.15884 .15722 L
.15984 .15722 L
.16084 .15722 L
.16184 .15722 L
.16284 .15722 L
.16384 .15722 L
.16484 .15722 L
.16583 .15722 L
.16683 .15722 L
.16783 .15722 L
.16883 .15722 L
.16983 .15722 L
.17083 .15722 L
.17183 .15722 L
.17283 .15722 L
.17383 .15722 L
.17483 .15722 L
.17582 .15722 L
.17682 .15722 L
.17782 .15722 L
.17882 .15722 L
.17982 .15722 L
.18082 .15722 L
.18182 .15722 L
.18282 .15722 L
.18382 .15722 L
.18482 .15722 L
.18581 .15722 L
.18681 .15722 L
.18781 .15722 L
.18881 .15722 L
.18981 .15722 L
.19081 .15722 L
.19181 .15722 L
.19281 .15722 L
.19381 .15722 L
.19481 .15722 L
.1958 .15722 L
.1968 .15722 L
.1978 .15722 L
.1988 .15722 L
Mistroke
.1998 .16595 L
.2008 .16595 L
.2018 .16595 L
.2028 .16595 L
.2038 .16595 L
.2048 .16595 L
.20579 .16595 L
.20679 .16595 L
.20779 .16595 L
.20879 .16595 L
.20979 .16595 L
.21079 .16595 L
.21179 .16595 L
.21279 .16595 L
.21379 .16595 L
.21479 .16595 L
.21578 .16595 L
.21678 .16595 L
.21778 .16595 L
.21878 .16595 L
.21978 .16595 L
.22078 .16595 L
.22178 .16595 L
.22278 .16595 L
.22378 .16595 L
.22478 .16595 L
.22577 .16595 L
.22677 .16595 L
.22777 .16595 L
.22877 .16595 L
.22977 .16595 L
.23077 .16595 L
.23177 .16595 L
.23277 .16595 L
.23377 .16595 L
.23477 .16595 L
.23576 .16595 L
.23676 .16595 L
.23776 .16595 L
.23876 .16595 L
.23976 .16595 L
.24076 .16595 L
.24176 .16595 L
.24276 .16595 L
.24376 .16595 L
.24476 .16595 L
.24575 .16595 L
.24675 .16595 L
.24775 .16595 L
.24875 .16595 L
Mistroke
.24975 .17119 L
.25075 .17119 L
.25175 .17119 L
.25275 .17119 L
.25375 .17119 L
.25475 .17119 L
.25574 .17119 L
.25674 .17119 L
.25774 .17119 L
.25874 .17119 L
.25974 .17119 L
.26074 .17119 L
.26174 .17119 L
.26274 .17119 L
.26374 .17119 L
.26474 .17119 L
.26573 .17119 L
.26673 .17119 L
.26773 .17119 L
.26873 .17119 L
.26973 .17119 L
.27073 .17119 L
.27173 .17119 L
.27273 .17119 L
.27373 .17119 L
.27473 .17119 L
.27572 .17119 L
.27672 .17119 L
.27772 .17119 L
.27872 .17119 L
.27972 .17119 L
.28072 .17119 L
.28172 .17119 L
.28272 .17119 L
.28372 .17119 L
.28472 .17119 L
.28571 .17119 L
.28671 .17119 L
.28771 .17119 L
.28871 .17119 L
.28971 .17119 L
.29071 .17119 L
.29171 .17119 L
.29271 .17119 L
.29371 .17119 L
.29471 .17119 L
.2957 .17119 L
.2967 .17119 L
.2977 .17119 L
.2987 .17119 L
Mistroke
.2997 .17173 L
.3007 .17173 L
.3017 .17173 L
.3027 .17173 L
.3037 .17173 L
.3047 .17173 L
.30569 .17173 L
.30669 .17173 L
.30769 .17173 L
.30869 .17173 L
.30969 .17173 L
.31069 .17173 L
.31169 .17173 L
.31269 .17173 L
.31369 .17173 L
.31469 .17173 L
.31568 .17173 L
.31668 .17173 L
.31768 .17173 L
.31868 .17173 L
.31968 .17173 L
.32068 .17173 L
.32168 .17173 L
.32268 .17173 L
.32368 .17173 L
.32468 .17173 L
.32567 .17173 L
.32667 .17173 L
.32767 .17173 L
.32867 .17173 L
.32967 .17173 L
.33067 .17173 L
.33167 .17173 L
.33267 .17173 L
.33367 .17173 L
.33467 .17173 L
.33566 .17173 L
.33666 .17173 L
.33766 .17173 L
.33866 .17173 L
.33966 .17173 L
.34066 .17173 L
.34166 .17173 L
.34266 .17173 L
.34366 .17173 L
.34466 .17173 L
.34565 .17173 L
.34665 .17173 L
.34765 .17173 L
.34865 .17173 L
Mistroke
.34965 .17158 L
.35065 .17158 L
.35165 .17158 L
.35265 .17158 L
.35365 .17158 L
.35465 .17158 L
.35564 .17158 L
.35664 .17158 L
.35764 .17158 L
.35864 .17158 L
.35964 .17158 L
.36064 .17158 L
.36164 .17158 L
.36264 .17158 L
.36364 .17158 L
.36464 .17158 L
.36563 .17158 L
.36663 .17158 L
.36763 .17158 L
.36863 .17158 L
.36963 .17158 L
.37063 .17158 L
.37163 .17158 L
.37263 .17158 L
.37363 .17158 L
.37463 .17158 L
.37562 .17158 L
.37662 .17158 L
.37762 .17158 L
.37862 .17158 L
.37962 .17158 L
.38062 .17158 L
.38162 .17158 L
.38262 .17158 L
.38362 .17158 L
.38462 .17158 L
.38561 .17158 L
.38661 .17158 L
.38761 .17158 L
.38861 .17158 L
.38961 .17158 L
.39061 .17158 L
.39161 .17158 L
.39261 .17158 L
.39361 .17158 L
.39461 .17158 L
.3956 .17158 L
.3966 .17158 L
.3976 .17158 L
.3986 .17158 L
Mistroke
.3996 .17402 L
.4006 .17402 L
.4016 .17402 L
.4026 .17402 L
.4036 .17402 L
.4046 .17402 L
.40559 .17402 L
.40659 .17402 L
.40759 .17402 L
.40859 .17402 L
.40959 .17402 L
.41059 .17402 L
.41159 .17402 L
.41259 .17402 L
.41359 .17402 L
.41459 .17402 L
.41558 .17402 L
.41658 .17402 L
.41758 .17402 L
.41858 .17402 L
.41958 .17402 L
.42058 .17402 L
.42158 .17402 L
.42258 .17402 L
.42358 .17402 L
.42458 .17402 L
.42557 .17402 L
.42657 .17402 L
.42757 .17402 L
.42857 .17402 L
.42957 .17402 L
.43057 .17402 L
.43157 .17402 L
.43257 .17402 L
.43357 .17402 L
.43457 .17402 L
.43556 .17402 L
.43656 .17402 L
.43756 .17402 L
.43856 .17402 L
.43956 .17402 L
.44056 .17402 L
.44156 .17402 L
.44256 .17402 L
.44356 .17402 L
.44456 .17402 L
.44555 .17402 L
.44655 .17402 L
.44755 .17402 L
.44855 .17402 L
Mistroke
.44955 .17365 L
.45055 .17365 L
.45155 .17365 L
.45255 .17365 L
.45355 .17365 L
.45455 .17365 L
.45554 .17365 L
.45654 .17365 L
.45754 .17365 L
.45854 .17365 L
.45954 .17365 L
.46054 .17365 L
.46154 .17365 L
.46254 .17365 L
.46354 .17365 L
.46454 .17365 L
.46553 .17365 L
.46653 .17365 L
.46753 .17365 L
.46853 .17365 L
.46953 .17365 L
.47053 .17365 L
.47153 .17365 L
.47253 .17365 L
.47353 .17365 L
.47453 .17365 L
.47552 .17365 L
.47652 .17365 L
.47752 .17365 L
.47852 .17365 L
.47952 .17365 L
.48052 .17365 L
.48152 .17365 L
.48252 .17365 L
.48352 .17365 L
.48452 .17365 L
.48551 .17365 L
.48651 .17365 L
.48751 .17365 L
.48851 .17365 L
.48951 .17365 L
.49051 .17365 L
.49151 .17365 L
.49251 .17365 L
.49351 .17365 L
.49451 .17365 L
.4955 .17365 L
.4965 .17365 L
.4975 .17365 L
.4985 .17365 L
Mistroke
.4995 .17766 L
.5005 .17766 L
.5015 .17766 L
.5025 .17766 L
.5035 .17766 L
.5045 .17766 L
.50549 .17766 L
.50649 .17766 L
.50749 .17766 L
.50849 .17766 L
.50949 .17766 L
.51049 .17766 L
.51149 .17766 L
.51249 .17766 L
.51349 .17766 L
.51449 .17766 L
.51548 .17766 L
.51648 .17766 L
.51748 .17766 L
.51848 .17766 L
.51948 .17766 L
.52048 .17766 L
.52148 .17766 L
.52248 .17766 L
.52348 .17766 L
.52448 .17766 L
.52547 .17766 L
.52647 .17766 L
.52747 .17766 L
.52847 .17766 L
.52947 .17766 L
.53047 .17766 L
.53147 .17766 L
.53247 .17766 L
.53347 .17766 L
.53447 .17766 L
.53546 .17766 L
.53646 .17766 L
.53746 .17766 L
.53846 .17766 L
.53946 .17766 L
.54046 .17766 L
.54146 .17766 L
.54246 .17766 L
.54346 .17766 L
.54446 .17766 L
.54545 .17766 L
.54645 .17766 L
.54745 .17766 L
.54845 .17766 L
Mistroke
.54945 .17681 L
.55045 .17681 L
.55145 .17681 L
.55245 .17681 L
.55345 .17681 L
.55445 .17681 L
.55544 .17681 L
.55644 .17681 L
.55744 .17681 L
.55844 .17681 L
.55944 .17681 L
.56044 .17681 L
.56144 .17681 L
.56244 .17681 L
.56344 .17681 L
.56444 .17681 L
.56543 .17681 L
.56643 .17681 L
.56743 .17681 L
.56843 .17681 L
.56943 .17681 L
.57043 .17681 L
.57143 .17681 L
.57243 .17681 L
.57343 .17681 L
.57443 .17681 L
.57542 .17681 L
.57642 .17681 L
.57742 .17681 L
.57842 .17681 L
.57942 .17681 L
.58042 .17681 L
.58142 .17681 L
.58242 .17681 L
.58342 .17681 L
.58442 .17681 L
.58541 .17681 L
.58641 .17681 L
.58741 .17681 L
.58841 .17681 L
.58941 .17681 L
.59041 .17681 L
.59141 .17681 L
.59241 .17681 L
.59341 .17681 L
.59441 .17681 L
.5954 .17681 L
.5964 .17681 L
.5974 .17681 L
.5984 .17681 L
Mistroke
.5994 .17819 L
.6004 .17819 L
.6014 .17819 L
.6024 .17819 L
.6034 .17819 L
.6044 .17819 L
.60539 .17819 L
.60639 .17819 L
.60739 .17819 L
.60839 .17819 L
.60939 .17819 L
.61039 .17819 L
.61139 .17819 L
.61239 .17819 L
.61339 .17819 L
.61439 .17819 L
.61538 .17819 L
.61638 .17819 L
.61738 .17819 L
.61838 .17819 L
.61938 .17819 L
.62038 .17819 L
.62138 .17819 L
.62238 .17819 L
.62338 .17819 L
.62438 .17819 L
.62537 .17819 L
.62637 .17819 L
.62737 .17819 L
.62837 .17819 L
.62937 .17819 L
.63037 .17819 L
.63137 .17819 L
.63237 .17819 L
.63337 .17819 L
.63437 .17819 L
.63536 .17819 L
.63636 .17819 L
.63736 .17819 L
.63836 .17819 L
.63936 .17819 L
.64036 .17819 L
.64136 .17819 L
.64236 .17819 L
.64336 .17819 L
.64436 .17819 L
.64535 .17819 L
.64635 .17819 L
.64735 .17819 L
.64835 .17819 L
Mistroke
.64935 .17785 L
.65035 .17785 L
.65135 .17785 L
.65235 .17785 L
.65335 .17785 L
.65435 .17785 L
.65534 .17785 L
.65634 .17785 L
.65734 .17785 L
.65834 .17785 L
.65934 .17785 L
.66034 .17785 L
.66134 .17785 L
.66234 .17785 L
.66334 .17785 L
.66434 .17785 L
.66533 .17785 L
.66633 .17785 L
.66733 .17785 L
.66833 .17785 L
.66933 .17785 L
.67033 .17785 L
.67133 .17785 L
.67233 .17785 L
.67333 .17785 L
.67433 .17785 L
.67532 .17785 L
.67632 .17785 L
.67732 .17785 L
.67832 .17785 L
.67932 .17785 L
.68032 .17785 L
.68132 .17785 L
.68232 .17785 L
.68332 .17785 L
.68432 .17785 L
.68531 .17785 L
.68631 .17785 L
.68731 .17785 L
.68831 .17785 L
.68931 .17785 L
.69031 .17785 L
.69131 .17785 L
.69231 .17785 L
.69331 .17785 L
.69431 .17785 L
.6953 .17785 L
.6963 .17785 L
.6973 .17785 L
.6983 .17785 L
Mistroke
.6993 .17812 L
.7003 .17812 L
.7013 .17812 L
.7023 .17812 L
.7033 .17812 L
.7043 .17812 L
.70529 .17812 L
.70629 .17812 L
.70729 .17812 L
.70829 .17812 L
.70929 .17812 L
.71029 .17812 L
.71129 .17812 L
.71229 .17812 L
.71329 .17812 L
.71429 .17812 L
.71528 .17812 L
.71628 .17812 L
.71728 .17812 L
.71828 .17812 L
.71928 .17812 L
.72028 .17812 L
.72128 .17812 L
.72228 .17812 L
.72328 .17812 L
.72428 .17812 L
.72527 .17812 L
.72627 .17812 L
.72727 .17812 L
.72827 .17812 L
.72927 .17812 L
.73027 .17812 L
.73127 .17812 L
.73227 .17812 L
.73327 .17812 L
.73427 .17812 L
.73526 .17812 L
.73626 .17812 L
.73726 .17812 L
.73826 .17812 L
.73926 .17812 L
.74026 .17812 L
.74126 .17812 L
.74226 .17812 L
.74326 .17812 L
.74426 .17812 L
.74525 .17812 L
.74625 .17812 L
.74725 .17812 L
.74825 .17812 L
Mistroke
.74925 .17984 L
.75025 .17984 L
.75125 .17984 L
.75225 .17984 L
.75325 .17984 L
.75425 .17984 L
.75524 .17984 L
.75624 .17984 L
.75724 .17984 L
.75824 .17984 L
.75924 .17984 L
.76024 .17984 L
.76124 .17984 L
.76224 .17984 L
.76324 .17984 L
.76424 .17984 L
.76523 .17984 L
.76623 .17984 L
.76723 .17984 L
.76823 .17984 L
.76923 .17984 L
.77023 .17984 L
.77123 .17984 L
.77223 .17984 L
.77323 .17984 L
.77423 .17984 L
.77522 .17984 L
.77622 .17984 L
.77722 .17984 L
.77822 .17984 L
.77922 .17984 L
.78022 .17984 L
.78122 .17984 L
.78222 .17984 L
.78322 .17984 L
.78422 .17984 L
.78521 .17984 L
.78621 .17984 L
.78721 .17984 L
.78821 .17984 L
.78921 .17984 L
.79021 .17984 L
.79121 .17984 L
.79221 .17984 L
.79321 .17984 L
.79421 .17984 L
.7952 .17984 L
.7962 .17984 L
.7972 .17984 L
.7982 .17984 L
Mistroke
.7992 .18178 L
.8002 .18178 L
.8012 .18178 L
.8022 .18178 L
.8032 .18178 L
.8042 .18178 L
.80519 .18178 L
.80619 .18178 L
.80719 .18178 L
.80819 .18178 L
.80919 .18178 L
.81019 .18178 L
.81119 .18178 L
.81219 .18178 L
.81319 .18178 L
.81419 .18178 L
.81518 .18178 L
.81618 .18178 L
.81718 .18178 L
.81818 .18178 L
.81918 .18178 L
.82018 .18178 L
.82118 .18178 L
.82218 .18178 L
.82318 .18178 L
.82418 .18178 L
.82517 .18178 L
.82617 .18178 L
.82717 .18178 L
.82817 .18178 L
.82917 .18178 L
.83017 .18178 L
.83117 .18178 L
.83217 .18178 L
.83317 .18178 L
.83417 .18178 L
.83516 .18178 L
.83616 .18178 L
.83716 .18178 L
.83816 .18178 L
.83916 .18178 L
.84016 .18178 L
.84116 .18178 L
.84216 .18178 L
.84316 .18178 L
.84416 .18178 L
.84515 .18178 L
.84615 .18178 L
.84715 .18178 L
.84815 .18178 L
Mistroke
.84915 .18362 L
.85015 .18362 L
.85115 .18362 L
.85215 .18362 L
.85315 .18362 L
.85415 .18362 L
.85514 .18362 L
.85614 .18362 L
.85714 .18362 L
.85814 .18362 L
.85914 .18362 L
.86014 .18362 L
.86114 .18362 L
.86214 .18362 L
.86314 .18362 L
.86414 .18362 L
.86513 .18362 L
.86613 .18362 L
.86713 .18362 L
.86813 .18362 L
.86913 .18362 L
.87013 .18362 L
.87113 .18362 L
.87213 .18362 L
.87313 .18362 L
.87413 .18362 L
.87512 .18362 L
.87612 .18362 L
.87712 .18362 L
.87812 .18362 L
.87912 .18362 L
.88012 .18362 L
.88112 .18362 L
.88212 .18362 L
.88312 .18362 L
.88412 .18362 L
.88511 .18362 L
.88611 .18362 L
.88711 .18362 L
.88811 .18362 L
.88911 .18362 L
.89011 .18362 L
.89111 .18362 L
.89211 .18362 L
.89311 .18362 L
.89411 .18362 L
.8951 .18362 L
.8961 .18362 L
.8971 .18362 L
.8981 .18362 L
Mistroke
.8991 .18652 L
.9001 .18652 L
.9011 .18652 L
.9021 .18652 L
.9031 .18652 L
.9041 .18652 L
.90509 .18652 L
.90609 .18652 L
.90709 .18652 L
.90809 .18652 L
.90909 .18652 L
.91009 .18652 L
.91109 .18652 L
.91209 .18652 L
.91309 .18652 L
.91409 .18652 L
.91508 .18652 L
.91608 .18652 L
.91708 .18652 L
.91808 .18652 L
.91908 .18652 L
.92008 .18652 L
.92108 .18652 L
.92208 .18652 L
.92308 .18652 L
.92408 .18652 L
.92507 .18652 L
.92607 .18652 L
.92707 .18652 L
.92807 .18652 L
.92907 .18652 L
.93007 .18652 L
.93107 .18652 L
.93207 .18652 L
.93307 .18652 L
.93407 .18652 L
.93506 .18652 L
.93606 .18652 L
.93706 .18652 L
.93806 .18652 L
.93906 .18652 L
.94006 .18652 L
.94106 .18652 L
.94206 .18652 L
.94306 .18652 L
.94406 .18652 L
.94505 .18652 L
.94605 .18652 L
.94705 .18652 L
.94805 .18652 L
Mistroke
.94905 .188 L
.95005 .188 L
.95105 .188 L
.95205 .188 L
.95305 .188 L
.95405 .188 L
.95504 .188 L
.95604 .188 L
.95704 .188 L
.95804 .188 L
.95904 .188 L
.96004 .188 L
.96104 .188 L
.96204 .188 L
.96304 .188 L
.96404 .188 L
.96503 .188 L
.96603 .188 L
.96703 .188 L
.96803 .188 L
.96903 .188 L
.97003 .188 L
.97103 .188 L
.97203 .188 L
.97303 .188 L
.97403 .188 L
.97502 .188 L
.97602 .188 L
.97702 .188 L
.97802 .188 L
.97902 .188 L
.98002 .188 L
.98102 .188 L
.98202 .188 L
.98302 .188 L
.98402 .188 L
.98501 .188 L
.98601 .188 L
.98701 .188 L
.98801 .188 L
.98901 .188 L
.99001 .188 L
.99101 .188 L
.99201 .188 L
.99301 .188 L
.99401 .188 L
.995 .188 L
.996 .188 L
.997 .188 L
.998 .188 L
Mistroke
.999 .18841 L
Mfstroke
1 0 0 r
gsave
.999 .17761 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .28327 m
.001 .28327 L
.002 .28327 L
.003 .28327 L
.004 .28327 L
.005 .28327 L
.00599 .28327 L
.00699 .28327 L
.00799 .28327 L
.00899 .28327 L
.00999 .28327 L
.01099 .28327 L
.01199 .28327 L
.01299 .28327 L
.01399 .28327 L
.01499 .28327 L
.01598 .28327 L
.01698 .28327 L
.01798 .28327 L
.01898 .28327 L
.01998 .28327 L
.02098 .28327 L
.02198 .28327 L
.02298 .28327 L
.02398 .28327 L
.02498 .28327 L
.02597 .28327 L
.02697 .28327 L
.02797 .28327 L
.02897 .28327 L
.02997 .28327 L
.03097 .28327 L
.03197 .28327 L
.03297 .28327 L
.03397 .28327 L
.03497 .28327 L
.03596 .28327 L
.03696 .28327 L
.03796 .28327 L
.03896 .28327 L
.03996 .28327 L
.04096 .28327 L
.04196 .28327 L
.04296 .28327 L
.04396 .28327 L
.04496 .28327 L
.04595 .28327 L
.04695 .28327 L
.04795 .28327 L
.04895 .28327 L
Mistroke
.04995 .03395 L
.05095 .03395 L
.05195 .03395 L
.05295 .03395 L
.05395 .03395 L
.05495 .03395 L
.05594 .03395 L
.05694 .03395 L
.05794 .03395 L
.05894 .03395 L
.05994 .03395 L
.06094 .03395 L
.06194 .03395 L
.06294 .03395 L
.06394 .03395 L
.06494 .03395 L
.06593 .03395 L
.06693 .03395 L
.06793 .03395 L
.06893 .03395 L
.06993 .03395 L
.07093 .03395 L
.07193 .03395 L
.07293 .03395 L
.07393 .03395 L
.07493 .03395 L
.07592 .03395 L
.07692 .03395 L
.07792 .03395 L
.07892 .03395 L
.07992 .03395 L
.08092 .03395 L
.08192 .03395 L
.08292 .03395 L
.08392 .03395 L
.08492 .03395 L
.08591 .03395 L
.08691 .03395 L
.08791 .03395 L
.08891 .03395 L
.08991 .03395 L
.09091 .03395 L
.09191 .03395 L
.09291 .03395 L
.09391 .03395 L
.09491 .03395 L
.0959 .03395 L
.0969 .03395 L
.0979 .03395 L
.0989 .03395 L
Mistroke
.0999 .13369 L
.1009 .13369 L
.1019 .13369 L
.1029 .13369 L
.1039 .13369 L
.1049 .13369 L
.10589 .13369 L
.10689 .13369 L
.10789 .13369 L
.10889 .13369 L
.10989 .13369 L
.11089 .13369 L
.11189 .13369 L
.11289 .13369 L
.11389 .13369 L
.11489 .13369 L
.11588 .13369 L
.11688 .13369 L
.11788 .13369 L
.11888 .13369 L
.11988 .13369 L
.12088 .13369 L
.12188 .13369 L
.12288 .13369 L
.12388 .13369 L
.12488 .13369 L
.12587 .13369 L
.12687 .13369 L
.12787 .13369 L
.12887 .13369 L
.12987 .13369 L
.13087 .13369 L
.13187 .13369 L
.13287 .13369 L
.13387 .13369 L
.13487 .13369 L
.13586 .13369 L
.13686 .13369 L
.13786 .13369 L
.13886 .13369 L
.13986 .13369 L
.14086 .13369 L
.14186 .13369 L
.14286 .13369 L
.14386 .13369 L
.14486 .13369 L
.14585 .13369 L
.14685 .13369 L
.14785 .13369 L
.14885 .13369 L
Mistroke
.14985 .14017 L
.15085 .14017 L
.15185 .14017 L
.15285 .14017 L
.15385 .14017 L
.15485 .14017 L
.15584 .14017 L
.15684 .14017 L
.15784 .14017 L
.15884 .14017 L
.15984 .14017 L
.16084 .14017 L
.16184 .14017 L
.16284 .14017 L
.16384 .14017 L
.16484 .14017 L
.16583 .14017 L
.16683 .14017 L
.16783 .14017 L
.16883 .14017 L
.16983 .14017 L
.17083 .14017 L
.17183 .14017 L
.17283 .14017 L
.17383 .14017 L
.17483 .14017 L
.17582 .14017 L
.17682 .14017 L
.17782 .14017 L
.17882 .14017 L
.17982 .14017 L
.18082 .14017 L
.18182 .14017 L
.18282 .14017 L
.18382 .14017 L
.18482 .14017 L
.18581 .14017 L
.18681 .14017 L
.18781 .14017 L
.18881 .14017 L
.18981 .14017 L
.19081 .14017 L
.19181 .14017 L
.19281 .14017 L
.19381 .14017 L
.19481 .14017 L
.1958 .14017 L
.1968 .14017 L
.1978 .14017 L
.1988 .14017 L
Mistroke
.1998 .15046 L
.2008 .15046 L
.2018 .15046 L
.2028 .15046 L
.2038 .15046 L
.2048 .15046 L
.20579 .15046 L
.20679 .15046 L
.20779 .15046 L
.20879 .15046 L
.20979 .15046 L
.21079 .15046 L
.21179 .15046 L
.21279 .15046 L
.21379 .15046 L
.21479 .15046 L
.21578 .15046 L
.21678 .15046 L
.21778 .15046 L
.21878 .15046 L
.21978 .15046 L
.22078 .15046 L
.22178 .15046 L
.22278 .15046 L
.22378 .15046 L
.22478 .15046 L
.22577 .15046 L
.22677 .15046 L
.22777 .15046 L
.22877 .15046 L
.22977 .15046 L
.23077 .15046 L
.23177 .15046 L
.23277 .15046 L
.23377 .15046 L
.23477 .15046 L
.23576 .15046 L
.23676 .15046 L
.23776 .15046 L
.23876 .15046 L
.23976 .15046 L
.24076 .15046 L
.24176 .15046 L
.24276 .15046 L
.24376 .15046 L
.24476 .15046 L
.24575 .15046 L
.24675 .15046 L
.24775 .15046 L
.24875 .15046 L
Mistroke
.24975 .1567 L
.25075 .1567 L
.25175 .1567 L
.25275 .1567 L
.25375 .1567 L
.25475 .1567 L
.25574 .1567 L
.25674 .1567 L
.25774 .1567 L
.25874 .1567 L
.25974 .1567 L
.26074 .1567 L
.26174 .1567 L
.26274 .1567 L
.26374 .1567 L
.26474 .1567 L
.26573 .1567 L
.26673 .1567 L
.26773 .1567 L
.26873 .1567 L
.26973 .1567 L
.27073 .1567 L
.27173 .1567 L
.27273 .1567 L
.27373 .1567 L
.27473 .1567 L
.27572 .1567 L
.27672 .1567 L
.27772 .1567 L
.27872 .1567 L
.27972 .1567 L
.28072 .1567 L
.28172 .1567 L
.28272 .1567 L
.28372 .1567 L
.28472 .1567 L
.28571 .1567 L
.28671 .1567 L
.28771 .1567 L
.28871 .1567 L
.28971 .1567 L
.29071 .1567 L
.29171 .1567 L
.29271 .1567 L
.29371 .1567 L
.29471 .1567 L
.2957 .1567 L
.2967 .1567 L
.2977 .1567 L
.2987 .1567 L
Mistroke
.2997 .1573 L
.3007 .1573 L
.3017 .1573 L
.3027 .1573 L
.3037 .1573 L
.3047 .1573 L
.30569 .1573 L
.30669 .1573 L
.30769 .1573 L
.30869 .1573 L
.30969 .1573 L
.31069 .1573 L
.31169 .1573 L
.31269 .1573 L
.31369 .1573 L
.31469 .1573 L
.31568 .1573 L
.31668 .1573 L
.31768 .1573 L
.31868 .1573 L
.31968 .1573 L
.32068 .1573 L
.32168 .1573 L
.32268 .1573 L
.32368 .1573 L
.32468 .1573 L
.32567 .1573 L
.32667 .1573 L
.32767 .1573 L
.32867 .1573 L
.32967 .1573 L
.33067 .1573 L
.33167 .1573 L
.33267 .1573 L
.33367 .1573 L
.33467 .1573 L
.33566 .1573 L
.33666 .1573 L
.33766 .1573 L
.33866 .1573 L
.33966 .1573 L
.34066 .1573 L
.34166 .1573 L
.34266 .1573 L
.34366 .1573 L
.34466 .1573 L
.34565 .1573 L
.34665 .1573 L
.34765 .1573 L
.34865 .1573 L
Mistroke
.34965 .15725 L
.35065 .15725 L
.35165 .15725 L
.35265 .15725 L
.35365 .15725 L
.35465 .15725 L
.35564 .15725 L
.35664 .15725 L
.35764 .15725 L
.35864 .15725 L
.35964 .15725 L
.36064 .15725 L
.36164 .15725 L
.36264 .15725 L
.36364 .15725 L
.36464 .15725 L
.36563 .15725 L
.36663 .15725 L
.36763 .15725 L
.36863 .15725 L
.36963 .15725 L
.37063 .15725 L
.37163 .15725 L
.37263 .15725 L
.37363 .15725 L
.37463 .15725 L
.37562 .15725 L
.37662 .15725 L
.37762 .15725 L
.37862 .15725 L
.37962 .15725 L
.38062 .15725 L
.38162 .15725 L
.38262 .15725 L
.38362 .15725 L
.38462 .15725 L
.38561 .15725 L
.38661 .15725 L
.38761 .15725 L
.38861 .15725 L
.38961 .15725 L
.39061 .15725 L
.39161 .15725 L
.39261 .15725 L
.39361 .15725 L
.39461 .15725 L
.3956 .15725 L
.3966 .15725 L
.3976 .15725 L
.3986 .15725 L
Mistroke
.3996 .16043 L
.4006 .16043 L
.4016 .16043 L
.4026 .16043 L
.4036 .16043 L
.4046 .16043 L
.40559 .16043 L
.40659 .16043 L
.40759 .16043 L
.40859 .16043 L
.40959 .16043 L
.41059 .16043 L
.41159 .16043 L
.41259 .16043 L
.41359 .16043 L
.41459 .16043 L
.41558 .16043 L
.41658 .16043 L
.41758 .16043 L
.41858 .16043 L
.41958 .16043 L
.42058 .16043 L
.42158 .16043 L
.42258 .16043 L
.42358 .16043 L
.42458 .16043 L
.42557 .16043 L
.42657 .16043 L
.42757 .16043 L
.42857 .16043 L
.42957 .16043 L
.43057 .16043 L
.43157 .16043 L
.43257 .16043 L
.43357 .16043 L
.43457 .16043 L
.43556 .16043 L
.43656 .16043 L
.43756 .16043 L
.43856 .16043 L
.43956 .16043 L
.44056 .16043 L
.44156 .16043 L
.44256 .16043 L
.44356 .16043 L
.44456 .16043 L
.44555 .16043 L
.44655 .16043 L
.44755 .16043 L
.44855 .16043 L
Mistroke
.44955 .16037 L
.45055 .16037 L
.45155 .16037 L
.45255 .16037 L
.45355 .16037 L
.45455 .16037 L
.45554 .16037 L
.45654 .16037 L
.45754 .16037 L
.45854 .16037 L
.45954 .16037 L
.46054 .16037 L
.46154 .16037 L
.46254 .16037 L
.46354 .16037 L
.46454 .16037 L
.46553 .16037 L
.46653 .16037 L
.46753 .16037 L
.46853 .16037 L
.46953 .16037 L
.47053 .16037 L
.47153 .16037 L
.47253 .16037 L
.47353 .16037 L
.47453 .16037 L
.47552 .16037 L
.47652 .16037 L
.47752 .16037 L
.47852 .16037 L
.47952 .16037 L
.48052 .16037 L
.48152 .16037 L
.48252 .16037 L
.48352 .16037 L
.48452 .16037 L
.48551 .16037 L
.48651 .16037 L
.48751 .16037 L
.48851 .16037 L
.48951 .16037 L
.49051 .16037 L
.49151 .16037 L
.49251 .16037 L
.49351 .16037 L
.49451 .16037 L
.4955 .16037 L
.4965 .16037 L
.4975 .16037 L
.4985 .16037 L
Mistroke
.4995 .16466 L
.5005 .16466 L
.5015 .16466 L
.5025 .16466 L
.5035 .16466 L
.5045 .16466 L
.50549 .16466 L
.50649 .16466 L
.50749 .16466 L
.50849 .16466 L
.50949 .16466 L
.51049 .16466 L
.51149 .16466 L
.51249 .16466 L
.51349 .16466 L
.51449 .16466 L
.51548 .16466 L
.51648 .16466 L
.51748 .16466 L
.51848 .16466 L
.51948 .16466 L
.52048 .16466 L
.52148 .16466 L
.52248 .16466 L
.52348 .16466 L
.52448 .16466 L
.52547 .16466 L
.52647 .16466 L
.52747 .16466 L
.52847 .16466 L
.52947 .16466 L
.53047 .16466 L
.53147 .16466 L
.53247 .16466 L
.53347 .16466 L
.53447 .16466 L
.53546 .16466 L
.53646 .16466 L
.53746 .16466 L
.53846 .16466 L
.53946 .16466 L
.54046 .16466 L
.54146 .16466 L
.54246 .16466 L
.54346 .16466 L
.54446 .16466 L
.54545 .16466 L
.54645 .16466 L
.54745 .16466 L
.54845 .16466 L
Mistroke
.54945 .16439 L
.55045 .16439 L
.55145 .16439 L
.55245 .16439 L
.55345 .16439 L
.55445 .16439 L
.55544 .16439 L
.55644 .16439 L
.55744 .16439 L
.55844 .16439 L
.55944 .16439 L
.56044 .16439 L
.56144 .16439 L
.56244 .16439 L
.56344 .16439 L
.56444 .16439 L
.56543 .16439 L
.56643 .16439 L
.56743 .16439 L
.56843 .16439 L
.56943 .16439 L
.57043 .16439 L
.57143 .16439 L
.57243 .16439 L
.57343 .16439 L
.57443 .16439 L
.57542 .16439 L
.57642 .16439 L
.57742 .16439 L
.57842 .16439 L
.57942 .16439 L
.58042 .16439 L
.58142 .16439 L
.58242 .16439 L
.58342 .16439 L
.58442 .16439 L
.58541 .16439 L
.58641 .16439 L
.58741 .16439 L
.58841 .16439 L
.58941 .16439 L
.59041 .16439 L
.59141 .16439 L
.59241 .16439 L
.59341 .16439 L
.59441 .16439 L
.5954 .16439 L
.5964 .16439 L
.5974 .16439 L
.5984 .16439 L
Mistroke
.5994 .16609 L
.6004 .16609 L
.6014 .16609 L
.6024 .16609 L
.6034 .16609 L
.6044 .16609 L
.60539 .16609 L
.60639 .16609 L
.60739 .16609 L
.60839 .16609 L
.60939 .16609 L
.61039 .16609 L
.61139 .16609 L
.61239 .16609 L
.61339 .16609 L
.61439 .16609 L
.61538 .16609 L
.61638 .16609 L
.61738 .16609 L
.61838 .16609 L
.61938 .16609 L
.62038 .16609 L
.62138 .16609 L
.62238 .16609 L
.62338 .16609 L
.62438 .16609 L
.62537 .16609 L
.62637 .16609 L
.62737 .16609 L
.62837 .16609 L
.62937 .16609 L
.63037 .16609 L
.63137 .16609 L
.63237 .16609 L
.63337 .16609 L
.63437 .16609 L
.63536 .16609 L
.63636 .16609 L
.63736 .16609 L
.63836 .16609 L
.63936 .16609 L
.64036 .16609 L
.64136 .16609 L
.64236 .16609 L
.64336 .16609 L
.64436 .16609 L
.64535 .16609 L
.64635 .16609 L
.64735 .16609 L
.64835 .16609 L
Mistroke
.64935 .16578 L
.65035 .16578 L
.65135 .16578 L
.65235 .16578 L
.65335 .16578 L
.65435 .16578 L
.65534 .16578 L
.65634 .16578 L
.65734 .16578 L
.65834 .16578 L
.65934 .16578 L
.66034 .16578 L
.66134 .16578 L
.66234 .16578 L
.66334 .16578 L
.66434 .16578 L
.66533 .16578 L
.66633 .16578 L
.66733 .16578 L
.66833 .16578 L
.66933 .16578 L
.67033 .16578 L
.67133 .16578 L
.67233 .16578 L
.67333 .16578 L
.67433 .16578 L
.67532 .16578 L
.67632 .16578 L
.67732 .16578 L
.67832 .16578 L
.67932 .16578 L
.68032 .16578 L
.68132 .16578 L
.68232 .16578 L
.68332 .16578 L
.68432 .16578 L
.68531 .16578 L
.68631 .16578 L
.68731 .16578 L
.68831 .16578 L
.68931 .16578 L
.69031 .16578 L
.69131 .16578 L
.69231 .16578 L
.69331 .16578 L
.69431 .16578 L
.6953 .16578 L
.6963 .16578 L
.6973 .16578 L
.6983 .16578 L
Mistroke
.6993 .16609 L
.7003 .16609 L
.7013 .16609 L
.7023 .16609 L
.7033 .16609 L
.7043 .16609 L
.70529 .16609 L
.70629 .16609 L
.70729 .16609 L
.70829 .16609 L
.70929 .16609 L
.71029 .16609 L
.71129 .16609 L
.71229 .16609 L
.71329 .16609 L
.71429 .16609 L
.71528 .16609 L
.71628 .16609 L
.71728 .16609 L
.71828 .16609 L
.71928 .16609 L
.72028 .16609 L
.72128 .16609 L
.72228 .16609 L
.72328 .16609 L
.72428 .16609 L
.72527 .16609 L
.72627 .16609 L
.72727 .16609 L
.72827 .16609 L
.72927 .16609 L
.73027 .16609 L
.73127 .16609 L
.73227 .16609 L
.73327 .16609 L
.73427 .16609 L
.73526 .16609 L
.73626 .16609 L
.73726 .16609 L
.73826 .16609 L
.73926 .16609 L
.74026 .16609 L
.74126 .16609 L
.74226 .16609 L
.74326 .16609 L
.74426 .16609 L
.74525 .16609 L
.74625 .16609 L
.74725 .16609 L
.74825 .16609 L
Mistroke
.74925 .16797 L
.75025 .16797 L
.75125 .16797 L
.75225 .16797 L
.75325 .16797 L
.75425 .16797 L
.75524 .16797 L
.75624 .16797 L
.75724 .16797 L
.75824 .16797 L
.75924 .16797 L
.76024 .16797 L
.76124 .16797 L
.76224 .16797 L
.76324 .16797 L
.76424 .16797 L
.76523 .16797 L
.76623 .16797 L
.76723 .16797 L
.76823 .16797 L
.76923 .16797 L
.77023 .16797 L
.77123 .16797 L
.77223 .16797 L
.77323 .16797 L
.77423 .16797 L
.77522 .16797 L
.77622 .16797 L
.77722 .16797 L
.77822 .16797 L
.77922 .16797 L
.78022 .16797 L
.78122 .16797 L
.78222 .16797 L
.78322 .16797 L
.78422 .16797 L
.78521 .16797 L
.78621 .16797 L
.78721 .16797 L
.78821 .16797 L
.78921 .16797 L
.79021 .16797 L
.79121 .16797 L
.79221 .16797 L
.79321 .16797 L
.79421 .16797 L
.7952 .16797 L
.7962 .16797 L
.7972 .16797 L
.7982 .16797 L
Mistroke
.7992 .17026 L
.8002 .17026 L
.8012 .17026 L
.8022 .17026 L
.8032 .17026 L
.8042 .17026 L
.80519 .17026 L
.80619 .17026 L
.80719 .17026 L
.80819 .17026 L
.80919 .17026 L
.81019 .17026 L
.81119 .17026 L
.81219 .17026 L
.81319 .17026 L
.81419 .17026 L
.81518 .17026 L
.81618 .17026 L
.81718 .17026 L
.81818 .17026 L
.81918 .17026 L
.82018 .17026 L
.82118 .17026 L
.82218 .17026 L
.82318 .17026 L
.82418 .17026 L
.82517 .17026 L
.82617 .17026 L
.82717 .17026 L
.82817 .17026 L
.82917 .17026 L
.83017 .17026 L
.83117 .17026 L
.83217 .17026 L
.83317 .17026 L
.83417 .17026 L
.83516 .17026 L
.83616 .17026 L
.83716 .17026 L
.83816 .17026 L
.83916 .17026 L
.84016 .17026 L
.84116 .17026 L
.84216 .17026 L
.84316 .17026 L
.84416 .17026 L
.84515 .17026 L
.84615 .17026 L
.84715 .17026 L
.84815 .17026 L
Mistroke
.84915 .17223 L
.85015 .17223 L
.85115 .17223 L
.85215 .17223 L
.85315 .17223 L
.85415 .17223 L
.85514 .17223 L
.85614 .17223 L
.85714 .17223 L
.85814 .17223 L
.85914 .17223 L
.86014 .17223 L
.86114 .17223 L
.86214 .17223 L
.86314 .17223 L
.86414 .17223 L
.86513 .17223 L
.86613 .17223 L
.86713 .17223 L
.86813 .17223 L
.86913 .17223 L
.87013 .17223 L
.87113 .17223 L
.87213 .17223 L
.87313 .17223 L
.87413 .17223 L
.87512 .17223 L
.87612 .17223 L
.87712 .17223 L
.87812 .17223 L
.87912 .17223 L
.88012 .17223 L
.88112 .17223 L
.88212 .17223 L
.88312 .17223 L
.88412 .17223 L
.88511 .17223 L
.88611 .17223 L
.88711 .17223 L
.88811 .17223 L
.88911 .17223 L
.89011 .17223 L
.89111 .17223 L
.89211 .17223 L
.89311 .17223 L
.89411 .17223 L
.8951 .17223 L
.8961 .17223 L
.8971 .17223 L
.8981 .17223 L
Mistroke
.8991 .17545 L
.9001 .17545 L
.9011 .17545 L
.9021 .17545 L
.9031 .17545 L
.9041 .17545 L
.90509 .17545 L
.90609 .17545 L
.90709 .17545 L
.90809 .17545 L
.90909 .17545 L
.91009 .17545 L
.91109 .17545 L
.91209 .17545 L
.91309 .17545 L
.91409 .17545 L
.91508 .17545 L
.91608 .17545 L
.91708 .17545 L
.91808 .17545 L
.91908 .17545 L
.92008 .17545 L
.92108 .17545 L
.92208 .17545 L
.92308 .17545 L
.92408 .17545 L
.92507 .17545 L
.92607 .17545 L
.92707 .17545 L
.92807 .17545 L
.92907 .17545 L
.93007 .17545 L
.93107 .17545 L
.93207 .17545 L
.93307 .17545 L
.93407 .17545 L
.93506 .17545 L
.93606 .17545 L
.93706 .17545 L
.93806 .17545 L
.93906 .17545 L
.94006 .17545 L
.94106 .17545 L
.94206 .17545 L
.94306 .17545 L
.94406 .17545 L
.94505 .17545 L
.94605 .17545 L
.94705 .17545 L
.94805 .17545 L
Mistroke
.94905 .17717 L
.95005 .17717 L
.95105 .17717 L
.95205 .17717 L
.95305 .17717 L
.95405 .17717 L
.95504 .17717 L
.95604 .17717 L
.95704 .17717 L
.95804 .17717 L
.95904 .17717 L
.96004 .17717 L
.96104 .17717 L
.96204 .17717 L
.96304 .17717 L
.96404 .17717 L
.96503 .17717 L
.96603 .17717 L
.96703 .17717 L
.96803 .17717 L
.96903 .17717 L
.97003 .17717 L
.97103 .17717 L
.97203 .17717 L
.97303 .17717 L
.97403 .17717 L
.97502 .17717 L
.97602 .17717 L
.97702 .17717 L
.97802 .17717 L
.97902 .17717 L
.98002 .17717 L
.98102 .17717 L
.98202 .17717 L
.98302 .17717 L
.98402 .17717 L
.98501 .17717 L
.98601 .17717 L
.98701 .17717 L
.98801 .17717 L
.98901 .17717 L
.99001 .17717 L
.99101 .17717 L
.99201 .17717 L
.99301 .17717 L
.99401 .17717 L
.995 .17717 L
.996 .17717 L
.997 .17717 L
.998 .17717 L
Mistroke
.999 .17761 L
Mfstroke
0 0 1 r
gsave
.001 -0.38627 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .30672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .34801 L
.005 .34586 L
.00599 .34349 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33052 L
.01099 .32611 L
.01199 .3211 L
.01299 .31543 L
.01399 .30901 L
.01499 .30175 L
.01598 .29356 L
.01698 .28434 L
.01798 .27396 L
.01898 .26232 L
.01998 .24926 L
.02098 .23466 L
.02198 .21838 L
.02298 .20029 L
.02398 .18025 L
.02498 .15817 L
.02597 .13398 L
.02697 .1077 L
.02797 .07942 L
.02897 .04937 L
.02997 .01796 L
s
.02997 .01796 m
.03053 0 L
s
.04346 0 m
.04396 .02239 L
.04496 .06983 L
.04595 .11857 L
.04695 .16735 L
.04795 .21484 L
.04895 .25953 L
.04995 .10477 L
.05095 .09087 L
.05195 .08375 L
.05295 .0838 L
.05395 .09149 L
.05495 .10669 L
.05594 .12857 L
.05694 .15583 L
.05794 .18699 L
.05894 .22053 L
.05994 .25494 L
.06094 .28884 L
.06194 .32115 L
.06294 .3511 L
.06394 .3782 L
.06494 .40219 L
.06593 .42289 L
.06693 .44008 L
.06793 .45322 L
.06893 .46112 L
.06993 .46148 L
.07093 .45235 L
.07193 .43475 L
.07293 .41158 L
.07393 .38555 L
.07493 .35879 L
.07592 .33303 L
.07692 .30967 L
.07792 .28977 L
.07892 .27413 L
.07992 .26329 L
.08092 .2575 L
.08192 .25674 L
.08292 .26071 L
.08392 .2687 L
.08492 .27958 L
.08591 .29149 L
.08691 .30148 L
.08791 .30629 L
.08891 .30537 L
.08991 .30129 L
.09091 .29647 L
.09191 .29224 L
Mistroke
.09291 .28922 L
.09391 .28766 L
.09491 .28761 L
.0959 .28898 L
.0969 .29158 L
.0979 .29512 L
.0989 .29924 L
.0999 .39492 L
.1009 .38995 L
.1019 .38698 L
.1029 .38491 L
.1039 .38338 L
.1049 .3822 L
.10589 .38125 L
.10689 .38048 L
.10789 .37985 L
.10889 .37932 L
.10989 .37889 L
.11089 .37853 L
.11189 .37824 L
.11289 .37802 L
.11389 .37786 L
.11489 .37776 L
.11588 .37772 L
.11688 .37774 L
.11788 .37783 L
.11888 .37797 L
.11988 .37819 L
.12088 .37849 L
.12188 .37888 L
.12288 .37937 L
.12388 .37998 L
.12488 .38073 L
.12587 .38164 L
.12687 .38274 L
.12787 .38406 L
.12887 .38563 L
.12987 .38751 L
.13087 .38973 L
.13187 .39234 L
.13287 .3954 L
.13387 .39893 L
.13487 .40298 L
.13586 .40758 L
.13686 .41273 L
.13786 .41837 L
.13886 .42444 L
.13986 .43074 L
.14086 .43699 L
.14186 .44271 L
Mistroke
.14286 .44724 L
.14386 .44967 L
.14486 .44914 L
.14585 .44517 L
.14685 .43793 L
.14785 .42814 L
.14885 .41665 L
.14985 .55182 L
.15085 .5317 L
.15185 .51241 L
.15285 .49333 L
.15385 .47453 L
.15485 .45623 L
.15584 .4387 L
.15684 .42215 L
.15784 .40674 L
.15884 .39259 L
.15984 .37972 L
.16084 .36813 L
.16184 .35778 L
.16284 .34859 L
.16384 .34049 L
.16484 .33337 L
.16583 .32714 L
.16683 .32169 L
.16783 .31694 L
.16883 .31279 L
.16983 .30916 L
.17083 .30598 L
.17183 .30316 L
.17283 .30065 L
.17383 .29839 L
.17483 .29632 L
.17582 .2944 L
.17682 .29258 L
.17782 .29084 L
.17882 .28912 L
.17982 .28742 L
.18082 .28569 L
.18182 .28392 L
.18282 .28209 L
.18382 .28019 L
.18482 .2782 L
.18581 .2761 L
.18681 .2739 L
.18781 .27158 L
.18881 .26914 L
.18981 .26657 L
.19081 .26388 L
.19181 .26106 L
Mistroke
.19281 .25812 L
.19381 .25506 L
.19481 .25189 L
.1958 .24862 L
.1968 .24526 L
.1978 .24184 L
.1988 .23835 L
.1998 .27731 L
.2008 .26183 L
.2018 .24841 L
.2028 .23584 L
.2038 .22371 L
.2048 .2119 L
.20579 .20041 L
.20679 .18935 L
.20779 .1789 L
.20879 .16935 L
.20979 .16102 L
.21079 .15427 L
.21179 .14945 L
.21279 .14689 L
.21379 .1468 L
.21479 .14924 L
.21578 .15412 L
.21678 .16118 L
.21778 .17007 L
.21878 .18044 L
.21978 .19199 L
.22078 .20447 L
.22178 .21762 L
.22278 .23118 L
.22378 .24486 L
.22478 .25838 L
.22577 .2715 L
.22677 .28399 L
.22777 .29567 L
.22877 .30645 L
.22977 .31623 L
.23077 .32501 L
.23177 .33279 L
.23277 .33961 L
.23377 .34553 L
.23477 .35061 L
.23576 .35493 L
.23676 .35857 L
.23776 .36161 L
.23876 .36411 L
.23976 .36616 L
.24076 .3678 L
.24176 .3691 L
Mistroke
.24276 .37011 L
.24376 .37087 L
.24476 .37142 L
.24575 .3718 L
.24675 .37202 L
.24775 .37213 L
.24875 .37213 L
.24975 .44593 L
.25075 .4438 L
.25175 .44361 L
.25275 .44422 L
.25375 .44527 L
.25475 .44658 L
.25574 .44804 L
.25674 .44959 L
.25774 .45118 L
.25874 .45278 L
.25974 .45435 L
.26074 .45588 L
.26174 .45733 L
.26274 .4587 L
.26374 .45995 L
.26474 .46106 L
.26573 .462 L
.26673 .46274 L
.26773 .46325 L
.26873 .46348 L
.26973 .4634 L
.27073 .46296 L
.27173 .46212 L
.27273 .46082 L
.27373 .45903 L
.27473 .45671 L
.27572 .45385 L
.27672 .45044 L
.27772 .44651 L
.27872 .44211 L
.27972 .43731 L
.28072 .43219 L
.28172 .42685 L
.28272 .42139 L
.28372 .4159 L
.28472 .41045 L
.28571 .40513 L
.28671 .4 L
.28771 .3951 L
.28871 .39046 L
.28971 .3861 L
.29071 .38203 L
.29171 .37826 L
Mistroke
.29271 .37477 L
.29371 .37156 L
.29471 .36861 L
.2957 .36591 L
.2967 .36343 L
.2977 .36116 L
.2987 .35907 L
.2997 .41467 L
.3007 .41018 L
.3017 .4077 L
.3027 .40614 L
.3037 .40512 L
.3047 .40446 L
.30569 .40407 L
.30669 .4039 L
.30769 .40389 L
.30869 .40404 L
.30969 .40434 L
.31069 .40476 L
.31169 .40532 L
.31269 .40602 L
.31369 .40684 L
.31469 .40781 L
.31568 .40891 L
.31668 .41016 L
.31768 .41157 L
.31868 .41313 L
.31968 .41487 L
.32068 .41679 L
.32168 .41889 L
.32268 .4212 L
.32368 .42371 L
.32468 .42643 L
.32567 .42937 L
.32667 .43252 L
.32767 .43587 L
.32867 .4394 L
.32967 .44305 L
.33067 .44678 L
.33167 .45047 L
.33267 .454 L
.33367 .4572 L
.33467 .45983 L
.33566 .46163 L
.33666 .46232 L
.33766 .46165 L
.33866 .45948 L
.33966 .45579 L
.34066 .45071 L
.34166 .44449 L
Mistroke
.34266 .43741 L
.34366 .42977 L
.34466 .42185 L
.34565 .41388 L
.34665 .40606 L
.34765 .39855 L
.34865 .39145 L
.34965 .50706 L
.35065 .49599 L
.35165 .48608 L
.35265 .47642 L
.35365 .46681 L
.35465 .45725 L
.35564 .44778 L
.35664 .43848 L
.35764 .42945 L
.35864 .42076 L
.35964 .41248 L
.36064 .40467 L
.36164 .39735 L
.36264 .39055 L
.36364 .38427 L
.36464 .37849 L
.36563 .37321 L
.36663 .36838 L
.36763 .36399 L
.36863 .35998 L
.36963 .35633 L
.37063 .353 L
.37163 .34994 L
.37263 .34712 L
.37363 .3445 L
.37463 .34204 L
.37562 .33972 L
.37662 .33749 L
.37762 .33533 L
.37862 .33322 L
.37962 .33112 L
.38062 .32901 L
.38162 .32686 L
.38262 .32465 L
.38362 .32237 L
.38462 .31998 L
.38561 .31747 L
.38661 .31481 L
.38761 .312 L
.38861 .30899 L
.38961 .30578 L
.39061 .30234 L
.39161 .29865 L
Mistroke
.39261 .29468 L
.39361 .29042 L
.39461 .28583 L
.3956 .2809 L
.3966 .2756 L
.3976 .26989 L
.3986 .26377 L
.3996 .3164 L
.4006 .31039 L
.4016 .30553 L
.4026 .30069 L
.4036 .29555 L
.4046 .28995 L
.40559 .28382 L
.40659 .27711 L
.40759 .26979 L
.40859 .26185 L
.40959 .25327 L
.41059 .24407 L
.41159 .23428 L
.41259 .22396 L
.41359 .2132 L
.41459 .20214 L
.41558 .19095 L
.41658 .17987 L
.41758 .1692 L
.41858 .15928 L
.41958 .15053 L
.42058 .14336 L
.42158 .13815 L
.42258 .13519 L
.42358 .13454 L
.42458 .13584 L
.42557 .13826 L
.42657 .14069 L
.42757 .14261 L
.42857 .1445 L
.42957 .14736 L
.43057 .15202 L
.43157 .15894 L
.43257 .16825 L
.43357 .17977 L
.43457 .19316 L
.43556 .20791 L
.43656 .22349 L
.43756 .23936 L
.43856 .25504 L
.43956 .27013 L
.44056 .28434 L
.44156 .29745 L
Mistroke
.44256 .30936 L
.44356 .32 L
.44456 .3294 L
.44555 .33761 L
.44655 .3447 L
.44755 .35079 L
.44855 .35596 L
.44955 .39764 L
.45055 .39901 L
.45155 .40128 L
.45255 .40355 L
.45355 .40557 L
.45455 .40727 L
.45554 .40862 L
.45654 .40966 L
.45754 .4104 L
.45854 .41088 L
.45954 .41114 L
.46054 .41123 L
.46154 .41117 L
.46254 .411 L
.46354 .41075 L
.46454 .41044 L
.46553 .41011 L
.46653 .40977 L
.46753 .40944 L
.46853 .40913 L
.46953 .40886 L
.47053 .40864 L
.47153 .40847 L
.47253 .40836 L
.47353 .40833 L
.47453 .40836 L
.47552 .40848 L
.47652 .40868 L
.47752 .40896 L
.47852 .40933 L
.47952 .40979 L
.48052 .41032 L
.48152 .41095 L
.48252 .41165 L
.48352 .41243 L
.48452 .41329 L
.48551 .4142 L
.48651 .41517 L
.48751 .41618 L
.48851 .41722 L
.48951 .41826 L
.49051 .41929 L
.49151 .42029 L
Mistroke
.49251 .42122 L
.49351 .42205 L
.49451 .42276 L
.4955 .42332 L
.4965 .42368 L
.4975 .42382 L
.4985 .42373 L
.4995 .53578 L
.5005 .52282 L
.5015 .5106 L
.5025 .49824 L
.5035 .48564 L
.5045 .47288 L
.50549 .46011 L
.50649 .44752 L
.50749 .43526 L
.50849 .42351 L
.50949 .41236 L
.51049 .40191 L
.51149 .39221 L
.51249 .38327 L
.51349 .37509 L
.51449 .36764 L
.51548 .36089 L
.51648 .35479 L
.51748 .34927 L
.51848 .34429 L
.51948 .33978 L
.52048 .33569 L
.52148 .33194 L
.52248 .3285 L
.52348 .3253 L
.52448 .3223 L
.52547 .31945 L
.52647 .3167 L
.52747 .31402 L
.52847 .31137 L
.52947 .30872 L
.53047 .30603 L
.53147 .30328 L
.53247 .30043 L
.53347 .29746 L
.53447 .29435 L
.53546 .29108 L
.53646 .28762 L
.53746 .28395 L
.53846 .28006 L
.53946 .27592 L
.54046 .27152 L
.54146 .26684 L
Mistroke
.54246 .26188 L
.54346 .25661 L
.54446 .25103 L
.54545 .24513 L
.54645 .23891 L
.54745 .23237 L
.54845 .22553 L
.54945 .40723 L
.55045 .40925 L
.55145 .41293 L
.55245 .41726 L
.55345 .42199 L
.55445 .42703 L
.55544 .43236 L
.55644 .43797 L
.55744 .44389 L
.55844 .45013 L
.55944 .45668 L
.56044 .46356 L
.56144 .47074 L
.56244 .47822 L
.56344 .48595 L
.56444 .49385 L
.56543 .50184 L
.56643 .50975 L
.56743 .51739 L
.56843 .52446 L
.56943 .53056 L
.57043 .53512 L
.57143 .53739 L
.57243 .53646 L
.57343 .53149 L
.57443 .52214 L
.57542 .50878 L
.57642 .49232 L
.57742 .47385 L
.57842 .45436 L
.57942 .4347 L
.58042 .41557 L
.58142 .39743 L
.58242 .38062 L
.58342 .36529 L
.58442 .35152 L
.58541 .33929 L
.58641 .32852 L
.58741 .31911 L
.58841 .31094 L
.58941 .30389 L
.59041 .29784 L
.59141 .29269 L
Mistroke
.59241 .28833 L
.59341 .28468 L
.59441 .28164 L
.5954 .27914 L
.5964 .2771 L
.5974 .27546 L
.5984 .27415 L
.5994 .3305 L
.6004 .32056 L
.6014 .31295 L
.6024 .30653 L
.6034 .30086 L
.6044 .29572 L
.60539 .29092 L
.60639 .28638 L
.60739 .282 L
.60839 .27772 L
.60939 .2735 L
.61039 .26931 L
.61139 .26513 L
.61239 .26095 L
.61339 .25675 L
.61439 .25255 L
.61538 .24835 L
.61638 .24418 L
.61738 .24004 L
.61838 .23598 L
.61938 .23203 L
.62038 .22822 L
.62138 .2246 L
.62238 .2212 L
.62338 .21807 L
.62438 .21526 L
.62537 .2128 L
.62637 .21071 L
.62737 .209 L
.62837 .20769 L
.62937 .20675 L
.63037 .20614 L
.63137 .20582 L
.63237 .20571 L
.63337 .20577 L
.63437 .20592 L
.63536 .20614 L
.63636 .20643 L
.63736 .20679 L
.63836 .20727 L
.63936 .20792 L
.64036 .20879 L
.64136 .20993 L
Mistroke
.64236 .21139 L
.64336 .21316 L
.64436 .21527 L
.64535 .21769 L
.64635 .22039 L
.64735 .22333 L
.64835 .22647 L
.64935 .31982 L
.65035 .3146 L
.65135 .31103 L
.65235 .30802 L
.65335 .30524 L
.65435 .3025 L
.65534 .29971 L
.65634 .29681 L
.65734 .29375 L
.65834 .29052 L
.65934 .2871 L
.66034 .28347 L
.66134 .27962 L
.66234 .27556 L
.66334 .27129 L
.66434 .26679 L
.66533 .26209 L
.66633 .2572 L
.66733 .25213 L
.66833 .2469 L
.66933 .24155 L
.67033 .23612 L
.67133 .23065 L
.67233 .22521 L
.67333 .21985 L
.67433 .21467 L
.67532 .20974 L
.67632 .20515 L
.67732 .20099 L
.67832 .19736 L
.67932 .19433 L
.68032 .19196 L
.68132 .19025 L
.68232 .1892 L
.68332 .1887 L
.68432 .18859 L
.68531 .18863 L
.68631 .18857 L
.68731 .18818 L
.68831 .18739 L
.68931 .18625 L
.69031 .18499 L
.69131 .18387 L
Mistroke
.69231 .18317 L
.69331 .18312 L
.69431 .1839 L
.6953 .18562 L
.6963 .18833 L
.6973 .19201 L
.6983 .19659 L
.6993 .28684 L
.7003 .28996 L
.7013 .29442 L
.7023 .29915 L
.7033 .30378 L
.7043 .30814 L
.70529 .31212 L
.70629 .31567 L
.70729 .31878 L
.70829 .32145 L
.70929 .32368 L
.71029 .32549 L
.71129 .32692 L
.71229 .32799 L
.71329 .32873 L
.71429 .32916 L
.71528 .3293 L
.71628 .32919 L
.71728 .32882 L
.71828 .32823 L
.71928 .32743 L
.72028 .32641 L
.72128 .3252 L
.72228 .32378 L
.72328 .32217 L
.72428 .32036 L
.72527 .31834 L
.72627 .31612 L
.72727 .31367 L
.72827 .31099 L
.72927 .30807 L
.73027 .30489 L
.73127 .30144 L
.73227 .29769 L
.73327 .29362 L
.73427 .28922 L
.73526 .28446 L
.73626 .27931 L
.73726 .27375 L
.73826 .26776 L
.73926 .26129 L
.74026 .25434 L
.74126 .24686 L
Mistroke
.74226 .23883 L
.74326 .23023 L
.74426 .22105 L
.74525 .21125 L
.74625 .20085 L
.74725 .18983 L
.74825 .17823 L
.74925 .25144 L
.75025 .23593 L
.75125 .22182 L
.75225 .20807 L
.75325 .19447 L
.75425 .18107 L
.75524 .16807 L
.75624 .15582 L
.75724 .14475 L
.75824 .13538 L
.75924 .12828 L
.76024 .12396 L
.76124 .12286 L
.76224 .12519 L
.76324 .1309 L
.76424 .13967 L
.76523 .15105 L
.76623 .16458 L
.76723 .17988 L
.76823 .19658 L
.76923 .21429 L
.77023 .23253 L
.77123 .25085 L
.77223 .26878 L
.77323 .28596 L
.77423 .3021 L
.77522 .31699 L
.77622 .33053 L
.77722 .34267 L
.77822 .35343 L
.77922 .36286 L
.78022 .37105 L
.78122 .37808 L
.78222 .38406 L
.78322 .3891 L
.78422 .39329 L
.78521 .39673 L
.78621 .39949 L
.78721 .40165 L
.78821 .40327 L
.78921 .40441 L
.79021 .40511 L
.79121 .40542 L
Mistroke
.79221 .40536 L
.79321 .40498 L
.79421 .40431 L
.7952 .40338 L
.7962 .40223 L
.7972 .40089 L
.7982 .3994 L
.7992 .46611 L
.8002 .46442 L
.8012 .46413 L
.8022 .4642 L
.8032 .46431 L
.8042 .46432 L
.80519 .46414 L
.80619 .46372 L
.80719 .46305 L
.80819 .4621 L
.80919 .46089 L
.81019 .45941 L
.81119 .45767 L
.81219 .4557 L
.81319 .45351 L
.81419 .45111 L
.81518 .44853 L
.81618 .44579 L
.81718 .44293 L
.81818 .43995 L
.81918 .43689 L
.82018 .43378 L
.82118 .43063 L
.82218 .42747 L
.82318 .42432 L
.82418 .42121 L
.82517 .41816 L
.82617 .41518 L
.82717 .41229 L
.82817 .4095 L
.82917 .40684 L
.83017 .4043 L
.83117 .4019 L
.83217 .39964 L
.83317 .39752 L
.83417 .39556 L
.83516 .39374 L
.83616 .39208 L
.83716 .39056 L
.83816 .38918 L
.83916 .38795 L
.84016 .38686 L
.84116 .38591 L
Mistroke
.84216 .3851 L
.84316 .38441 L
.84416 .38386 L
.84515 .38343 L
.84615 .38313 L
.84715 .38296 L
.84815 .38292 L
.84915 .50264 L
.85015 .49844 L
.85115 .49554 L
.85215 .49285 L
.85315 .49002 L
.85415 .48687 L
.85514 .48334 L
.85614 .47939 L
.85714 .47502 L
.85814 .47026 L
.85914 .46516 L
.86014 .45977 L
.86114 .45417 L
.86214 .44842 L
.86314 .4426 L
.86414 .43676 L
.86513 .43099 L
.86613 .42532 L
.86713 .41982 L
.86813 .41452 L
.86913 .40946 L
.87013 .40465 L
.87113 .40011 L
.87213 .39586 L
.87313 .39188 L
.87413 .3882 L
.87512 .38478 L
.87612 .38163 L
.87712 .37873 L
.87812 .37607 L
.87912 .37362 L
.88012 .37138 L
.88112 .36932 L
.88212 .36743 L
.88312 .36569 L
.88412 .36408 L
.88511 .36259 L
.88611 .36121 L
.88711 .35992 L
.88811 .3587 L
.88911 .35756 L
.89011 .35647 L
.89111 .35542 L
Mistroke
.89211 .35442 L
.89311 .35346 L
.89411 .35253 L
.8951 .35163 L
.8961 .35076 L
.8971 .34992 L
.8981 .34911 L
.8991 .45175 L
.9001 .45322 L
.9011 .45686 L
.9021 .46155 L
.9031 .46692 L
.9041 .47278 L
.90509 .47898 L
.90609 .48542 L
.90709 .49199 L
.90809 .49858 L
.90909 .50506 L
.91009 .51128 L
.91109 .51707 L
.91209 .52222 L
.91309 .52649 L
.91409 .52962 L
.91508 .5313 L
.91608 .53119 L
.91708 .52896 L
.91808 .5243 L
.91908 .51706 L
.92008 .50726 L
.92108 .4952 L
.92208 .48135 L
.92308 .46628 L
.92408 .45058 L
.92507 .43477 L
.92607 .41929 L
.92707 .40444 L
.92807 .39048 L
.92907 .37753 L
.93007 .36566 L
.93107 .35488 L
.93207 .34517 L
.93307 .33647 L
.93407 .32871 L
.93506 .3218 L
.93606 .31567 L
.93706 .31021 L
.93806 .30536 L
.93906 .30103 L
.94006 .29715 L
.94106 .29364 L
Mistroke
.94206 .29045 L
.94306 .28752 L
.94406 .28478 L
.94505 .28221 L
.94605 .27974 L
.94705 .27735 L
.94805 .27499 L
.94905 .32248 L
.95005 .31676 L
.95105 .31264 L
.95205 .30903 L
.95305 .30559 L
.95405 .30212 L
.95504 .29855 L
.95604 .2948 L
.95704 .29084 L
.95804 .28663 L
.95904 .28216 L
.96004 .27741 L
.96104 .27237 L
.96204 .26704 L
.96304 .26142 L
.96404 .25553 L
.96503 .24937 L
.96603 .24298 L
.96703 .2364 L
.96803 .22967 L
.96903 .22286 L
.97003 .21605 L
.97103 .20934 L
.97203 .20285 L
.97303 .1967 L
.97403 .19104 L
.97502 .186 L
.97602 .18173 L
.97702 .17836 L
.97802 .17595 L
.97902 .17452 L
.98002 .17397 L
.98102 .1741 L
.98202 .17453 L
.98302 .17485 L
.98402 .17471 L
.98501 .17405 L
.98601 .17309 L
.98701 .17225 L
.98801 .17195 L
.98901 .17255 L
.99001 .17429 L
.99101 .17731 L
Mistroke
.99201 .18165 L
.99301 .18724 L
.99401 .19395 L
.995 .20159 L
.996 .20992 L
.997 .21871 L
.998 .22771 L
.999 .30672 L
Mfstroke
gsave
.999 .32161 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38342 L
.004 .38538 L
.005 .38721 L
.00599 .38905 L
.00699 .39099 L
.00799 .39308 L
.00899 .39539 L
.00999 .39797 L
.01099 .40088 L
.01199 .40416 L
.01299 .40788 L
.01399 .41208 L
.01499 .41683 L
.01598 .4222 L
.01698 .42826 L
.01798 .4351 L
.01898 .4428 L
.01998 .45145 L
.02098 .46117 L
.02198 .47205 L
.02298 .48423 L
.02398 .49781 L
.02498 .51292 L
.02597 .52967 L
.02697 .54815 L
.02797 .56843 L
.02897 .59056 L
.02997 .61448 L
s
.02997 .61448 m
.03011 .61803 L
s
.04898 .61803 m
.04995 .12004 L
.05095 .11473 L
.05195 .11269 L
.05295 .11608 L
.05395 .12636 L
.05495 .14455 L
.05594 .17091 L
.05694 .20467 L
.05794 .24397 L
.05894 .28636 L
.05994 .3293 L
.06094 .37063 L
.06194 .40866 L
.06294 .44219 L
.06394 .47038 L
.06494 .49264 L
.06593 .50862 L
.06693 .51828 L
.06793 .52206 L
.06893 .52138 L
.06993 .51898 L
.07093 .51762 L
.07193 .51739 L
.07293 .51678 L
.07393 .51464 L
.07493 .51048 L
.07592 .50417 L
.07692 .49582 L
.07792 .48567 L
.07892 .474 L
.07992 .46115 L
.08092 .44747 L
.08192 .43335 L
.08292 .41921 L
.08392 .40559 L
.08492 .3933 L
.08591 .38366 L
.08691 .37892 L
.08791 .38158 L
.08891 .39139 L
.08991 .40498 L
.09091 .4192 L
.09191 .43208 L
.09291 .44246 L
.09391 .44971 L
.09491 .45352 L
.0959 .45387 L
.0969 .451 L
.0979 .44537 L
Mistroke
.0989 .4376 L
.0999 .40986 L
.1009 .41339 L
.1019 .41549 L
.1029 .41719 L
.1039 .41882 L
.1049 .42052 L
.10589 .42236 L
.10689 .42438 L
.10789 .42661 L
.10889 .42905 L
.10989 .43171 L
.11089 .43461 L
.11189 .43774 L
.11289 .44112 L
.11389 .44474 L
.11489 .44863 L
.11588 .45278 L
.11688 .4572 L
.11788 .46191 L
.11888 .4669 L
.11988 .47219 L
.12088 .47775 L
.12188 .4836 L
.12288 .48972 L
.12388 .49608 L
.12488 .50267 L
.12587 .50943 L
.12687 .51631 L
.12787 .52326 L
.12887 .53018 L
.12987 .53697 L
.13087 .54351 L
.13187 .54967 L
.13287 .55529 L
.13387 .56022 L
.13487 .56429 L
.13586 .56734 L
.13686 .56923 L
.13786 .56987 L
.13886 .56923 L
.13986 .56738 L
.14086 .56453 L
.14186 .56108 L
.14286 .55771 L
.14386 .55528 L
.14486 .5547 L
.14585 .55651 L
.14685 .56056 L
.14785 .56621 L
Mistroke
.14885 .57266 L
.14985 .56645 L
.15085 .55547 L
.15185 .542 L
.15285 .52737 L
.15385 .51222 L
.15485 .49706 L
.15584 .48227 L
.15684 .46814 L
.15784 .45491 L
.15884 .44271 L
.15984 .43164 L
.16084 .42172 L
.16184 .41295 L
.16284 .40529 L
.16384 .39867 L
.16484 .39302 L
.16583 .38824 L
.16683 .38424 L
.16783 .38094 L
.16883 .37825 L
.16983 .37609 L
.17083 .37437 L
.17183 .37304 L
.17283 .37203 L
.17383 .37129 L
.17483 .37078 L
.17582 .37044 L
.17682 .37026 L
.17782 .37019 L
.17882 .37022 L
.17982 .37032 L
.18082 .37047 L
.18182 .37066 L
.18282 .37088 L
.18382 .37112 L
.18482 .37137 L
.18581 .37161 L
.18681 .37185 L
.18781 .37207 L
.18881 .37227 L
.18981 .37245 L
.19081 .3726 L
.19181 .37271 L
.19281 .37278 L
.19381 .3728 L
.19481 .37277 L
.1958 .37267 L
.1968 .37251 L
.1978 .37226 L
Mistroke
.1988 .37193 L
.1998 .29173 L
.2008 .28533 L
.2018 .27751 L
.2028 .26928 L
.2038 .26091 L
.2048 .25255 L
.20579 .24433 L
.20679 .23636 L
.20779 .2288 L
.20879 .22184 L
.20979 .21567 L
.21079 .21057 L
.21179 .20681 L
.21279 .2047 L
.21379 .20458 L
.21479 .2068 L
.21578 .21166 L
.21678 .21939 L
.21778 .23002 L
.21878 .24334 L
.21978 .25887 L
.22078 .27596 L
.22178 .29388 L
.22278 .31196 L
.22378 .32961 L
.22478 .34641 L
.22577 .36203 L
.22677 .3763 L
.22777 .38913 L
.22877 .4005 L
.22977 .41047 L
.23077 .41911 L
.23177 .42651 L
.23277 .4328 L
.23377 .43808 L
.23477 .44246 L
.23576 .44606 L
.23676 .44899 L
.23776 .45134 L
.23876 .4532 L
.23976 .45466 L
.24076 .4558 L
.24176 .45668 L
.24276 .45738 L
.24376 .45794 L
.24476 .45842 L
.24575 .45887 L
.24675 .45933 L
.24775 .45982 L
Mistroke
.24875 .46038 L
.24975 .4605 L
.25075 .46718 L
.25175 .4722 L
.25275 .47667 L
.25375 .48092 L
.25475 .4851 L
.25574 .48927 L
.25674 .49346 L
.25774 .49765 L
.25874 .50184 L
.25974 .50597 L
.26074 .51001 L
.26174 .51391 L
.26274 .5176 L
.26374 .52102 L
.26474 .5241 L
.26573 .5268 L
.26673 .52904 L
.26773 .53079 L
.26873 .532 L
.26973 .53265 L
.27073 .53274 L
.27173 .53228 L
.27273 .53132 L
.27373 .52989 L
.27473 .52807 L
.27572 .52593 L
.27672 .52354 L
.27772 .52095 L
.27872 .51824 L
.27972 .51543 L
.28072 .51257 L
.28172 .50967 L
.28272 .50676 L
.28372 .50384 L
.28472 .50094 L
.28571 .49808 L
.28671 .49527 L
.28771 .49253 L
.28871 .4899 L
.28971 .48738 L
.29071 .48501 L
.29171 .48279 L
.29271 .48076 L
.29371 .47892 L
.29471 .4773 L
.2957 .47589 L
.2967 .47471 L
.2977 .47376 L
Mistroke
.2987 .47305 L
.2997 .42934 L
.3007 .43359 L
.3017 .43629 L
.3027 .43854 L
.3037 .44067 L
.3047 .44284 L
.30569 .44514 L
.30669 .44762 L
.30769 .4503 L
.30869 .4532 L
.30969 .45632 L
.31069 .45966 L
.31169 .46324 L
.31269 .46704 L
.31369 .47106 L
.31469 .47529 L
.31568 .47972 L
.31668 .48434 L
.31768 .48912 L
.31868 .49405 L
.31968 .49909 L
.32068 .50419 L
.32168 .50933 L
.32268 .51443 L
.32368 .51945 L
.32468 .5243 L
.32567 .52891 L
.32667 .53321 L
.32767 .5371 L
.32867 .54051 L
.32967 .54337 L
.33067 .54564 L
.33167 .54728 L
.33267 .54832 L
.33367 .54883 L
.33467 .54894 L
.33566 .54882 L
.33666 .5487 L
.33766 .54878 L
.33866 .54917 L
.33966 .5499 L
.34066 .55085 L
.34166 .55183 L
.34266 .55261 L
.34366 .55296 L
.34466 .55272 L
.34565 .55175 L
.34665 .54997 L
.34765 .54736 L
Mistroke
.34865 .54392 L
.34965 .52182 L
.35065 .51956 L
.35165 .5149 L
.35265 .50904 L
.35365 .50244 L
.35465 .49543 L
.35564 .48824 L
.35664 .48107 L
.35764 .47407 L
.35864 .46734 L
.35964 .46099 L
.36064 .45507 L
.36164 .44964 L
.36264 .44471 L
.36364 .44029 L
.36464 .43639 L
.36563 .43298 L
.36663 .43006 L
.36763 .4276 L
.36863 .42557 L
.36963 .42394 L
.37063 .42269 L
.37163 .42179 L
.37263 .42122 L
.37363 .42094 L
.37463 .42095 L
.37562 .42121 L
.37662 .42173 L
.37762 .42248 L
.37862 .42346 L
.37962 .42466 L
.38062 .42608 L
.38162 .42771 L
.38262 .42957 L
.38362 .43164 L
.38462 .43394 L
.38561 .43648 L
.38661 .43926 L
.38761 .4423 L
.38861 .44561 L
.38961 .44921 L
.39061 .45311 L
.39161 .45733 L
.39261 .46189 L
.39361 .46682 L
.39461 .47213 L
.3956 .47784 L
.3966 .48399 L
.3976 .49058 L
Mistroke
.3986 .49764 L
.3996 .33074 L
.4006 .33368 L
.4016 .33418 L
.4026 .33345 L
.4036 .33191 L
.4046 .32973 L
.40559 .32704 L
.40659 .32389 L
.40759 .32031 L
.40859 .31631 L
.40959 .3119 L
.41059 .30708 L
.41159 .30183 L
.41259 .29615 L
.41359 .29003 L
.41459 .28345 L
.41558 .27641 L
.41658 .26893 L
.41758 .26102 L
.41858 .25274 L
.41958 .24418 L
.42058 .23551 L
.42158 .22697 L
.42258 .21897 L
.42358 .21214 L
.42458 .20746 L
.42557 .20629 L
.42657 .21007 L
.42757 .21945 L
.42857 .23381 L
.42957 .25179 L
.43057 .27195 L
.43157 .29307 L
.43257 .31414 L
.43357 .33442 L
.43457 .35338 L
.43556 .3707 L
.43656 .38623 L
.43756 .39995 L
.43856 .41193 L
.43956 .4223 L
.44056 .4312 L
.44156 .4388 L
.44256 .44523 L
.44356 .45064 L
.44456 .45514 L
.44555 .45886 L
.44655 .46186 L
.44755 .46425 L
Mistroke
.44855 .4661 L
.44955 .41264 L
.45055 .4227 L
.45155 .43018 L
.45255 .43621 L
.45355 .44121 L
.45455 .44544 L
.45554 .44907 L
.45654 .45224 L
.45754 .45505 L
.45854 .45756 L
.45954 .45986 L
.46054 .46198 L
.46154 .46398 L
.46254 .46587 L
.46354 .4677 L
.46454 .46949 L
.46553 .47124 L
.46653 .47299 L
.46753 .47475 L
.46853 .47651 L
.46953 .4783 L
.47053 .48012 L
.47153 .48196 L
.47253 .48383 L
.47353 .48574 L
.47453 .48768 L
.47552 .48964 L
.47652 .49162 L
.47752 .49362 L
.47852 .49562 L
.47952 .49763 L
.48052 .49962 L
.48152 .50159 L
.48252 .50353 L
.48352 .50543 L
.48452 .50728 L
.48551 .50907 L
.48651 .51078 L
.48751 .51242 L
.48851 .51398 L
.48951 .51545 L
.49051 .51683 L
.49151 .51813 L
.49251 .51935 L
.49351 .5205 L
.49451 .5216 L
.4955 .52264 L
.4965 .52365 L
.4975 .52465 L
Mistroke
.4985 .52563 L
.4995 .55031 L
.5005 .5463 L
.5015 .5395 L
.5025 .53111 L
.5035 .52168 L
.5045 .51161 L
.50549 .50122 L
.50649 .4908 L
.50749 .48056 L
.50849 .47071 L
.50949 .46138 L
.51049 .45268 L
.51149 .44468 L
.51249 .43742 L
.51349 .4309 L
.51449 .42513 L
.51548 .42007 L
.51648 .41569 L
.51748 .41194 L
.51848 .40878 L
.51948 .40615 L
.52048 .40399 L
.52148 .40227 L
.52248 .40094 L
.52348 .39995 L
.52448 .39926 L
.52547 .39885 L
.52647 .39867 L
.52747 .39871 L
.52847 .39895 L
.52947 .39936 L
.53047 .39993 L
.53147 .40066 L
.53247 .40152 L
.53347 .40253 L
.53447 .40366 L
.53546 .40493 L
.53646 .40632 L
.53746 .40785 L
.53846 .40951 L
.53946 .41131 L
.54046 .41325 L
.54146 .41534 L
.54246 .41759 L
.54346 .42 L
.54446 .42257 L
.54545 .42532 L
.54645 .42826 L
.54745 .43137 L
Mistroke
.54845 .43468 L
.54945 .42159 L
.55045 .43261 L
.55145 .44177 L
.55245 .45033 L
.55345 .45875 L
.55445 .46726 L
.55544 .47603 L
.55644 .48515 L
.55744 .49466 L
.55844 .50458 L
.55944 .5149 L
.56044 .52555 L
.56144 .53643 L
.56244 .54737 L
.56344 .55816 L
.56444 .56854 L
.56543 .57819 L
.56643 .58674 L
.56743 .59381 L
.56843 .59904 L
.56943 .60217 L
.57043 .60311 L
.57143 .60203 L
.57243 .59939 L
.57343 .5958 L
.57443 .59158 L
.57542 .58661 L
.57642 .58045 L
.57742 .57275 L
.57842 .56332 L
.57942 .55224 L
.58042 .53974 L
.58142 .52617 L
.58242 .51196 L
.58342 .49753 L
.58442 .48328 L
.58541 .46953 L
.58641 .45654 L
.58741 .4445 L
.58841 .4335 L
.58941 .42361 L
.59041 .41481 L
.59141 .40708 L
.59241 .40033 L
.59341 .39451 L
.59441 .38951 L
.5954 .38524 L
.5964 .38162 L
.5974 .37856 L
Mistroke
.5984 .37598 L
.5994 .34531 L
.6004 .34418 L
.6014 .34189 L
.6024 .33938 L
.6034 .33692 L
.6044 .33457 L
.60539 .33237 L
.60639 .33032 L
.60739 .32839 L
.60839 .32656 L
.60939 .3248 L
.61039 .3231 L
.61139 .32142 L
.61239 .31975 L
.61339 .31807 L
.61439 .31636 L
.61538 .31461 L
.61638 .31281 L
.61738 .31094 L
.61838 .30901 L
.61938 .30702 L
.62038 .30495 L
.62138 .30283 L
.62238 .30065 L
.62338 .29844 L
.62438 .29622 L
.62537 .29404 L
.62637 .29192 L
.62737 .28993 L
.62837 .28813 L
.62937 .28662 L
.63037 .28547 L
.63137 .28481 L
.63237 .28471 L
.63337 .28528 L
.63437 .28658 L
.63536 .28863 L
.63636 .29144 L
.63736 .29494 L
.63836 .29905 L
.63936 .30367 L
.64036 .30866 L
.64136 .31391 L
.64236 .31929 L
.64336 .32471 L
.64436 .33006 L
.64535 .33529 L
.64635 .34032 L
.64735 .34513 L
Mistroke
.64835 .34968 L
.64935 .33454 L
.65035 .33808 L
.65135 .33977 L
.65235 .34066 L
.65335 .34109 L
.65435 .34122 L
.65534 .34113 L
.65634 .34087 L
.65734 .34047 L
.65834 .33995 L
.65934 .3393 L
.66034 .33853 L
.66134 .33764 L
.66234 .33662 L
.66334 .33547 L
.66434 .33419 L
.66533 .33276 L
.66633 .33117 L
.66733 .32942 L
.66833 .3275 L
.66933 .32539 L
.67033 .32308 L
.67133 .32057 L
.67233 .31782 L
.67333 .31485 L
.67433 .31163 L
.67532 .30817 L
.67632 .30447 L
.67732 .30054 L
.67832 .29642 L
.67932 .29215 L
.68032 .28781 L
.68132 .28352 L
.68232 .27943 L
.68332 .27578 L
.68432 .27284 L
.68531 .27094 L
.68631 .27043 L
.68731 .27159 L
.68831 .27452 L
.68931 .27917 L
.69031 .2853 L
.69131 .29258 L
.69231 .30066 L
.69331 .30922 L
.69431 .31796 L
.6953 .32663 L
.6963 .33504 L
.6973 .34304 L
Mistroke
.6983 .35054 L
.6993 .30162 L
.7003 .31358 L
.7013 .32337 L
.7023 .33194 L
.7033 .3396 L
.7043 .34652 L
.70529 .35277 L
.70629 .35845 L
.70729 .3636 L
.70829 .36829 L
.70929 .37255 L
.71029 .37644 L
.71129 .37999 L
.71229 .38324 L
.71329 .38623 L
.71429 .38901 L
.71528 .39159 L
.71628 .39402 L
.71728 .39633 L
.71828 .39854 L
.71928 .40069 L
.72028 .40279 L
.72128 .40488 L
.72228 .40698 L
.72328 .40912 L
.72428 .41131 L
.72527 .41357 L
.72627 .41593 L
.72727 .41842 L
.72827 .42104 L
.72927 .42382 L
.73027 .42679 L
.73127 .42997 L
.73227 .43338 L
.73327 .43703 L
.73427 .44097 L
.73526 .44521 L
.73626 .44978 L
.73726 .45471 L
.73826 .46003 L
.73926 .46576 L
.74026 .47195 L
.74126 .47861 L
.74226 .48578 L
.74326 .4935 L
.74426 .50178 L
.74525 .51066 L
.74625 .52016 L
.74725 .53029 L
Mistroke
.74825 .54106 L
.74925 .26578 L
.75025 .25943 L
.75125 .25105 L
.75225 .24178 L
.75325 .23203 L
.75425 .2221 L
.75524 .21224 L
.75624 .20276 L
.75724 .19398 L
.75824 .1863 L
.75924 .18016 L
.76024 .17606 L
.76124 .17452 L
.76224 .17613 L
.76324 .1814 L
.76424 .19074 L
.76523 .20425 L
.76623 .22156 L
.76723 .24191 L
.76823 .26424 L
.76923 .2875 L
.77023 .31072 L
.77123 .33317 L
.77223 .35429 L
.77323 .37375 L
.77423 .39136 L
.77522 .40708 L
.77622 .42092 L
.77722 .43296 L
.77822 .44332 L
.77922 .45213 L
.78022 .45951 L
.78122 .46559 L
.78222 .47051 L
.78322 .47438 L
.78422 .47733 L
.78521 .47947 L
.78621 .48091 L
.78721 .48177 L
.78821 .48215 L
.78921 .48215 L
.79021 .48187 L
.79121 .4814 L
.79221 .48082 L
.79321 .48021 L
.79421 .47962 L
.7952 .47912 L
.7962 .47873 L
.7972 .4785 L
Mistroke
.7982 .47843 L
.7992 .48071 L
.8002 .48788 L
.8012 .4929 L
.8022 .49684 L
.8032 .50003 L
.8042 .50265 L
.80519 .50477 L
.80619 .50647 L
.80719 .50777 L
.80819 .50869 L
.80919 .50925 L
.81019 .50947 L
.81119 .50937 L
.81219 .50895 L
.81319 .50825 L
.81419 .50729 L
.81518 .5061 L
.81618 .50471 L
.81718 .50315 L
.81818 .50146 L
.81918 .49968 L
.82018 .49784 L
.82118 .49599 L
.82218 .49414 L
.82318 .49234 L
.82418 .4906 L
.82517 .48897 L
.82617 .48744 L
.82717 .48605 L
.82817 .4848 L
.82917 .48371 L
.83017 .48279 L
.83117 .48204 L
.83217 .48147 L
.83317 .48108 L
.83417 .48088 L
.83516 .48085 L
.83616 .481 L
.83716 .48134 L
.83816 .48185 L
.83916 .48253 L
.84016 .48338 L
.84116 .4844 L
.84216 .48557 L
.84316 .4869 L
.84416 .48838 L
.84515 .49 L
.84615 .49175 L
.84715 .49362 L
Mistroke
.84815 .49561 L
.84915 .51715 L
.85015 .52186 L
.85115 .52426 L
.85215 .52537 L
.85315 .52552 L
.85415 .52485 L
.85514 .52346 L
.85614 .52144 L
.85714 .51886 L
.85814 .5158 L
.85914 .51234 L
.86014 .50854 L
.86114 .50451 L
.86214 .50031 L
.86314 .49603 L
.86414 .49174 L
.86513 .48751 L
.86613 .48339 L
.86713 .47945 L
.86813 .47572 L
.86913 .47225 L
.87013 .46905 L
.87113 .46616 L
.87213 .46358 L
.87313 .46132 L
.87413 .45939 L
.87512 .45778 L
.87612 .4565 L
.87712 .45554 L
.87812 .45489 L
.87912 .45454 L
.88012 .45449 L
.88112 .45472 L
.88212 .45524 L
.88312 .45603 L
.88412 .4571 L
.88511 .45842 L
.88611 .46001 L
.88711 .46185 L
.88811 .46395 L
.88911 .4663 L
.89011 .46891 L
.89111 .47176 L
.89211 .47487 L
.89311 .47822 L
.89411 .48182 L
.8951 .48565 L
.8961 .48973 L
.8971 .49403 L
Mistroke
.8981 .49855 L
.8991 .46617 L
.9001 .47665 L
.9011 .48582 L
.9021 .49473 L
.9031 .5037 L
.9041 .51284 L
.90509 .52214 L
.90609 .53155 L
.90709 .54095 L
.90809 .55019 L
.90909 .55904 L
.91009 .56727 L
.91109 .57459 L
.91209 .58071 L
.91309 .58535 L
.91409 .58825 L
.91508 .58926 L
.91608 .58831 L
.91708 .58547 L
.91808 .58095 L
.91908 .57498 L
.92008 .56781 L
.92108 .55959 L
.92208 .55043 L
.92308 .54045 L
.92408 .52978 L
.92507 .51861 L
.92607 .50714 L
.92707 .49561 L
.92807 .48424 L
.92907 .47324 L
.93007 .46277 L
.93107 .45297 L
.93207 .44391 L
.93307 .43565 L
.93407 .42821 L
.93506 .42157 L
.93606 .41572 L
.93706 .4106 L
.93806 .40616 L
.93906 .40234 L
.94006 .39909 L
.94106 .39633 L
.94206 .39402 L
.94306 .39209 L
.94406 .3905 L
.94505 .3892 L
.94605 .38815 L
.94705 .38731 L
Mistroke
.94805 .38664 L
.94905 .3371 L
.95005 .34024 L
.95105 .34146 L
.95205 .34185 L
.95305 .34173 L
.95405 .34127 L
.95504 .34055 L
.95604 .33963 L
.95704 .33852 L
.95804 .33724 L
.95904 .3358 L
.96004 .33419 L
.96104 .33241 L
.96204 .33046 L
.96304 .32833 L
.96404 .326 L
.96503 .32346 L
.96603 .3207 L
.96703 .3177 L
.96803 .31445 L
.96903 .31093 L
.97003 .30713 L
.97103 .30304 L
.97203 .29864 L
.97303 .29394 L
.97403 .28894 L
.97502 .28368 L
.97602 .2782 L
.97702 .27261 L
.97802 .26704 L
.97902 .26171 L
.98002 .25691 L
.98102 .25308 L
.98202 .25074 L
.98302 .25045 L
.98402 .25265 L
.98501 .25743 L
.98601 .26456 L
.98701 .27355 L
.98801 .28385 L
.98901 .29493 L
.99001 .30634 L
.99101 .31769 L
.99201 .3287 L
.99301 .33915 L
.99401 .34891 L
.995 .35788 L
.996 .36605 L
.997 .37345 L
Mistroke
.998 .38011 L
.999 .32161 L
Mfstroke
1 0 0 r
gsave
.999 .31417 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36653 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .3649 L
.00999 .36425 L
.01099 .36349 L
.01199 .36263 L
.01299 .36165 L
.01399 .36054 L
.01499 .35929 L
.01598 .35788 L
.01698 .3563 L
.01798 .35453 L
.01898 .35256 L
.01998 .35036 L
.02098 .34791 L
.02198 .34522 L
.02298 .34226 L
.02398 .33903 L
.02498 .33554 L
.02597 .33182 L
.02697 .32792 L
.02797 .32393 L
.02897 .31996 L
.02997 .31622 L
.03097 .31296 L
.03197 .31052 L
.03297 .30932 L
.03397 .30986 L
.03497 .31267 L
.03596 .31823 L
.03696 .32694 L
.03796 .33893 L
.03896 .35399 L
.03996 .37148 L
.04096 .39035 L
.04196 .40919 L
.04296 .42648 L
.04396 .44076 L
.04496 .45091 L
.04595 .4563 L
.04695 .45687 L
.04795 .45315 L
.04895 .44603 L
Mistroke
.04995 .11241 L
.05095 .1028 L
.05195 .09822 L
.05295 .09994 L
.05395 .10893 L
.05495 .12562 L
.05594 .14974 L
.05694 .18025 L
.05794 .21548 L
.05894 .25344 L
.05994 .29212 L
.06094 .32973 L
.06194 .36491 L
.06294 .39665 L
.06394 .42429 L
.06494 .44741 L
.06593 .46576 L
.06693 .47918 L
.06793 .48764 L
.06893 .49125 L
.06993 .49023 L
.07093 .48498 L
.07193 .47607 L
.07293 .46418 L
.07393 .45009 L
.07493 .43463 L
.07592 .4186 L
.07692 .40274 L
.07792 .38772 L
.07892 .37406 L
.07992 .36222 L
.08092 .35249 L
.08192 .34505 L
.08292 .33996 L
.08392 .33715 L
.08492 .33644 L
.08591 .33757 L
.08691 .3402 L
.08791 .34394 L
.08891 .34838 L
.08991 .35314 L
.09091 .35784 L
.09191 .36216 L
.09291 .36584 L
.09391 .36869 L
.09491 .37057 L
.0959 .37143 L
.0969 .37129 L
.0979 .37024 L
.0989 .36842 L
Mistroke
.0999 .40239 L
.1009 .40167 L
.1019 .40123 L
.1029 .40105 L
.1039 .4011 L
.1049 .40136 L
.10589 .40181 L
.10689 .40243 L
.10789 .40323 L
.10889 .40419 L
.10989 .4053 L
.11089 .40657 L
.11189 .40799 L
.11289 .40957 L
.11389 .4113 L
.11489 .4132 L
.11588 .41525 L
.11688 .41747 L
.11788 .41987 L
.11888 .42244 L
.11988 .42519 L
.12088 .42812 L
.12188 .43124 L
.12288 .43454 L
.12388 .43803 L
.12488 .4417 L
.12587 .44553 L
.12687 .44953 L
.12787 .45366 L
.12887 .45791 L
.12987 .46224 L
.13087 .46662 L
.13187 .47101 L
.13287 .47534 L
.13387 .47957 L
.13487 .48363 L
.13586 .48746 L
.13686 .49098 L
.13786 .49412 L
.13886 .49684 L
.13986 .49906 L
.14086 .50076 L
.14186 .5019 L
.14286 .50247 L
.14386 .50247 L
.14486 .50192 L
.14585 .50084 L
.14685 .49925 L
.14785 .49718 L
.14885 .49466 L
Mistroke
.14985 .55914 L
.15085 .54358 L
.15185 .52721 L
.15285 .51035 L
.15385 .49338 L
.15485 .47665 L
.15584 .46048 L
.15684 .44515 L
.15784 .43083 L
.15884 .41765 L
.15984 .40568 L
.16084 .39492 L
.16184 .38536 L
.16284 .37694 L
.16384 .36958 L
.16484 .36319 L
.16583 .35769 L
.16683 .35297 L
.16783 .34894 L
.16883 .34552 L
.16983 .34263 L
.17083 .34018 L
.17183 .3381 L
.17283 .33634 L
.17383 .33484 L
.17483 .33355 L
.17582 .33242 L
.17682 .33142 L
.17782 .33051 L
.17882 .32967 L
.17982 .32887 L
.18082 .32808 L
.18182 .32729 L
.18282 .32649 L
.18382 .32566 L
.18482 .32478 L
.18581 .32386 L
.18681 .32287 L
.18781 .32182 L
.18881 .3207 L
.18981 .31951 L
.19081 .31824 L
.19181 .31688 L
.19281 .31545 L
.19381 .31393 L
.19481 .31233 L
.1958 .31065 L
.1968 .30889 L
.1978 .30705 L
.1988 .30514 L
Mistroke
.1998 .28452 L
.2008 .27358 L
.2018 .26296 L
.2028 .25256 L
.2038 .24231 L
.2048 .23223 L
.20579 .22237 L
.20679 .21285 L
.20779 .20385 L
.20879 .19559 L
.20979 .18835 L
.21079 .18242 L
.21179 .17813 L
.21279 .17579 L
.21379 .17569 L
.21479 .17802 L
.21578 .18289 L
.21678 .19029 L
.21778 .20005 L
.21878 .21189 L
.21978 .22543 L
.22078 .24021 L
.22178 .25575 L
.22278 .27157 L
.22378 .28724 L
.22478 .3024 L
.22577 .31676 L
.22677 .33014 L
.22777 .3424 L
.22877 .35347 L
.22977 .36335 L
.23077 .37206 L
.23177 .37965 L
.23277 .3862 L
.23377 .3918 L
.23477 .39653 L
.23576 .4005 L
.23676 .40378 L
.23776 .40647 L
.23876 .40866 L
.23976 .41041 L
.24076 .4118 L
.24176 .41289 L
.24276 .41375 L
.24376 .41441 L
.24476 .41492 L
.24575 .41534 L
.24675 .41567 L
.24775 .41597 L
.24875 .41625 L
Mistroke
.24975 .45322 L
.25075 .45549 L
.25175 .45791 L
.25275 .46045 L
.25375 .4631 L
.25475 .46584 L
.25574 .46866 L
.25674 .47153 L
.25774 .47442 L
.25874 .47731 L
.25974 .48016 L
.26074 .48294 L
.26174 .48562 L
.26274 .48815 L
.26374 .49048 L
.26474 .49258 L
.26573 .4944 L
.26673 .49589 L
.26773 .49702 L
.26873 .49774 L
.26973 .49802 L
.27073 .49785 L
.27173 .4972 L
.27273 .49607 L
.27373 .49446 L
.27473 .49239 L
.27572 .48989 L
.27672 .48699 L
.27772 .48373 L
.27872 .48018 L
.27972 .47637 L
.28072 .47238 L
.28172 .46826 L
.28272 .46407 L
.28372 .45987 L
.28472 .4557 L
.28571 .45161 L
.28671 .44763 L
.28771 .44382 L
.28871 .44018 L
.28971 .43674 L
.29071 .43352 L
.29171 .43052 L
.29271 .42777 L
.29371 .42524 L
.29471 .42295 L
.2957 .4209 L
.2967 .41907 L
.2977 .41746 L
.2987 .41606 L
Mistroke
.2997 .42201 L
.3007 .42188 L
.3017 .422 L
.3027 .42234 L
.3037 .42289 L
.3047 .42365 L
.30569 .42461 L
.30669 .42576 L
.30769 .4271 L
.30869 .42862 L
.30969 .43033 L
.31069 .43221 L
.31169 .43428 L
.31269 .43653 L
.31369 .43895 L
.31469 .44155 L
.31568 .44431 L
.31668 .44725 L
.31768 .45034 L
.31868 .45359 L
.31968 .45698 L
.32068 .46049 L
.32168 .46411 L
.32268 .46781 L
.32368 .47158 L
.32468 .47537 L
.32567 .47914 L
.32667 .48287 L
.32767 .48649 L
.32867 .48995 L
.32967 .49321 L
.33067 .49621 L
.33167 .49887 L
.33267 .50116 L
.33367 .50301 L
.33467 .50438 L
.33566 .50523 L
.33666 .50551 L
.33766 .50521 L
.33866 .50433 L
.33966 .50285 L
.34066 .50078 L
.34166 .49816 L
.34266 .49501 L
.34366 .49137 L
.34466 .48729 L
.34565 .48281 L
.34665 .47802 L
.34765 .47295 L
.34865 .46769 L
Mistroke
.34965 .51444 L
.35065 .50777 L
.35165 .50049 L
.35265 .49273 L
.35365 .48463 L
.35465 .47634 L
.35564 .46801 L
.35664 .45978 L
.35764 .45176 L
.35864 .44405 L
.35964 .43673 L
.36064 .42987 L
.36164 .42349 L
.36264 .41763 L
.36364 .41228 L
.36464 .40744 L
.36563 .4031 L
.36663 .39922 L
.36763 .39579 L
.36863 .39278 L
.36963 .39014 L
.37063 .38785 L
.37163 .38587 L
.37263 .38417 L
.37363 .38272 L
.37463 .38149 L
.37562 .38047 L
.37662 .37961 L
.37762 .37891 L
.37862 .37834 L
.37962 .37789 L
.38062 .37754 L
.38162 .37729 L
.38262 .37711 L
.38362 .377 L
.38462 .37696 L
.38561 .37697 L
.38661 .37704 L
.38761 .37715 L
.38861 .3773 L
.38961 .37749 L
.39061 .37772 L
.39161 .37799 L
.39261 .37829 L
.39361 .37862 L
.39461 .37898 L
.3956 .37937 L
.3966 .37979 L
.3976 .38024 L
.3986 .38071 L
Mistroke
.3996 .32357 L
.4006 .32204 L
.4016 .31985 L
.4026 .31707 L
.4036 .31373 L
.4046 .30984 L
.40559 .30543 L
.40659 .3005 L
.40759 .29505 L
.40859 .28908 L
.40959 .28258 L
.41059 .27557 L
.41159 .26805 L
.41259 .26006 L
.41359 .25161 L
.41459 .24279 L
.41558 .23368 L
.41658 .2244 L
.41758 .21511 L
.41858 .20601 L
.41958 .19736 L
.42058 .18943 L
.42158 .18256 L
.42258 .17708 L
.42358 .17334 L
.42458 .17165 L
.42557 .17228 L
.42657 .17538 L
.42757 .18103 L
.42857 .18916 L
.42957 .19957 L
.43057 .21199 L
.43157 .22601 L
.43257 .24119 L
.43357 .2571 L
.43457 .27327 L
.43556 .2893 L
.43656 .30486 L
.43756 .31965 L
.43856 .33348 L
.43956 .34622 L
.44056 .35777 L
.44156 .36813 L
.44256 .37729 L
.44356 .38532 L
.44456 .39227 L
.44555 .39823 L
.44655 .40328 L
.44755 .40752 L
.44855 .41103 L
Mistroke
.44955 .40514 L
.45055 .41085 L
.45155 .41573 L
.45255 .41988 L
.45355 .42339 L
.45455 .42635 L
.45554 .42885 L
.45654 .43095 L
.45754 .43272 L
.45854 .43422 L
.45954 .4355 L
.46054 .4366 L
.46154 .43757 L
.46254 .43843 L
.46354 .43922 L
.46454 .43996 L
.46553 .44068 L
.46653 .44138 L
.46753 .44209 L
.46853 .44282 L
.46953 .44358 L
.47053 .44438 L
.47153 .44521 L
.47253 .4461 L
.47353 .44703 L
.47453 .44802 L
.47552 .44906 L
.47652 .45015 L
.47752 .45129 L
.47852 .45248 L
.47952 .45371 L
.48052 .45497 L
.48152 .45627 L
.48252 .45759 L
.48352 .45893 L
.48452 .46028 L
.48551 .46163 L
.48651 .46298 L
.48751 .4643 L
.48851 .4656 L
.48951 .46685 L
.49051 .46806 L
.49151 .46921 L
.49251 .47028 L
.49351 .47128 L
.49451 .47218 L
.4955 .47298 L
.4965 .47367 L
.4975 .47424 L
.4985 .47468 L
Mistroke
.4995 .54304 L
.5005 .53456 L
.5015 .52505 L
.5025 .51467 L
.5035 .50366 L
.5045 .49224 L
.50549 .48067 L
.50649 .46916 L
.50749 .45791 L
.50849 .44711 L
.50949 .43687 L
.51049 .4273 L
.51149 .41844 L
.51249 .41034 L
.51349 .40299 L
.51449 .39639 L
.51548 .39048 L
.51648 .38524 L
.51748 .38061 L
.51848 .37653 L
.51948 .37296 L
.52048 .36984 L
.52148 .36711 L
.52248 .36472 L
.52348 .36262 L
.52448 .36078 L
.52547 .35915 L
.52647 .35769 L
.52747 .35637 L
.52847 .35516 L
.52947 .35404 L
.53047 .35298 L
.53147 .35197 L
.53247 .35098 L
.53347 .34999 L
.53447 .34901 L
.53546 .348 L
.53646 .34697 L
.53746 .3459 L
.53846 .34478 L
.53946 .34361 L
.54046 .34239 L
.54146 .34109 L
.54246 .33973 L
.54346 .3383 L
.54446 .3368 L
.54545 .33523 L
.54645 .33358 L
.54745 .33187 L
.54845 .3301 L
Mistroke
.54945 .41441 L
.55045 .42093 L
.55145 .42735 L
.55245 .4338 L
.55345 .44037 L
.55445 .44715 L
.55544 .45419 L
.55644 .46156 L
.55744 .46928 L
.55844 .47735 L
.55944 .48579 L
.56044 .49455 L
.56144 .50358 L
.56244 .51279 L
.56344 .52206 L
.56444 .5312 L
.56543 .54001 L
.56643 .54825 L
.56743 .5556 L
.56843 .56175 L
.56943 .56637 L
.57043 .56911 L
.57143 .56971 L
.57243 .56793 L
.57343 .56364 L
.57443 .55686 L
.57542 .54769 L
.57642 .53639 L
.57742 .5233 L
.57842 .50884 L
.57942 .49347 L
.58042 .47765 L
.58142 .4618 L
.58242 .44629 L
.58342 .43141 L
.58442 .4174 L
.58541 .40441 L
.58641 .39253 L
.58741 .3818 L
.58841 .37222 L
.58941 .36375 L
.59041 .35633 L
.59141 .34988 L
.59241 .34433 L
.59341 .33959 L
.59441 .33557 L
.5954 .33219 L
.5964 .32936 L
.5974 .32701 L
.5984 .32506 L
Mistroke
.5994 .33791 L
.6004 .33237 L
.6014 .32742 L
.6024 .32295 L
.6034 .31889 L
.6044 .31514 L
.60539 .31165 L
.60639 .30835 L
.60739 .30519 L
.60839 .30214 L
.60939 .29915 L
.61039 .29621 L
.61139 .29328 L
.61239 .29035 L
.61339 .28741 L
.61439 .28446 L
.61538 .28148 L
.61638 .27849 L
.61738 .27549 L
.61838 .2725 L
.61938 .26952 L
.62038 .26659 L
.62138 .26371 L
.62238 .26092 L
.62338 .25826 L
.62438 .25574 L
.62537 .25342 L
.62637 .25131 L
.62737 .24946 L
.62837 .24791 L
.62937 .24668 L
.63037 .24581 L
.63137 .24531 L
.63237 .24521 L
.63337 .24552 L
.63437 .24625 L
.63536 .24739 L
.63636 .24893 L
.63736 .25086 L
.63836 .25316 L
.63936 .25579 L
.64036 .25872 L
.64136 .26192 L
.64236 .26534 L
.64336 .26893 L
.64436 .27267 L
.64535 .27649 L
.64635 .28036 L
.64735 .28423 L
.64835 .28807 L
Mistroke
.64935 .32718 L
.65035 .32634 L
.65135 .3254 L
.65235 .32434 L
.65335 .32316 L
.65435 .32186 L
.65534 .32042 L
.65634 .31884 L
.65734 .31711 L
.65834 .31523 L
.65934 .3132 L
.66034 .311 L
.66134 .30863 L
.66234 .30609 L
.66334 .30338 L
.66434 .30049 L
.66533 .29743 L
.66633 .29419 L
.66733 .29077 L
.66833 .2872 L
.66933 .28347 L
.67033 .2796 L
.67133 .27561 L
.67233 .27151 L
.67333 .26735 L
.67433 .26315 L
.67532 .25895 L
.67632 .25481 L
.67732 .25077 L
.67832 .24689 L
.67932 .24324 L
.68032 .23988 L
.68132 .23689 L
.68232 .23432 L
.68332 .23224 L
.68432 .23071 L
.68531 .22978 L
.68631 .2295 L
.68731 .22988 L
.68831 .23095 L
.68931 .23271 L
.69031 .23514 L
.69131 .23822 L
.69231 .24192 L
.69331 .24617 L
.69431 .25093 L
.6953 .25613 L
.6963 .26168 L
.6973 .26752 L
.6983 .27356 L
Mistroke
.6993 .29423 L
.7003 .30177 L
.7013 .30889 L
.7023 .31554 L
.7033 .32169 L
.7043 .32733 L
.70529 .33245 L
.70629 .33706 L
.70729 .34119 L
.70829 .34487 L
.70929 .34811 L
.71029 .35097 L
.71129 .35346 L
.71229 .35562 L
.71329 .35748 L
.71429 .35908 L
.71528 .36045 L
.71628 .3616 L
.71728 .36258 L
.71828 .36339 L
.71928 .36406 L
.72028 .3646 L
.72128 .36504 L
.72228 .36538 L
.72328 .36564 L
.72428 .36583 L
.72527 .36596 L
.72627 .36603 L
.72727 .36604 L
.72827 .36602 L
.72927 .36595 L
.73027 .36584 L
.73127 .3657 L
.73227 .36553 L
.73327 .36533 L
.73427 .3651 L
.73526 .36483 L
.73626 .36455 L
.73726 .36423 L
.73826 .36389 L
.73926 .36353 L
.74026 .36314 L
.74126 .36273 L
.74226 .36231 L
.74326 .36187 L
.74426 .36141 L
.74525 .36096 L
.74625 .3605 L
.74725 .36006 L
.74825 .35964 L
Mistroke
.74925 .25861 L
.75025 .24768 L
.75125 .23644 L
.75225 .22493 L
.75325 .21325 L
.75425 .20158 L
.75524 .19016 L
.75624 .17929 L
.75724 .16937 L
.75824 .16084 L
.75924 .15422 L
.76024 .15001 L
.76124 .14869 L
.76224 .15066 L
.76324 .15615 L
.76424 .16521 L
.76523 .17765 L
.76623 .19307 L
.76723 .21089 L
.76823 .23041 L
.76923 .25089 L
.77023 .27163 L
.77123 .29201 L
.77223 .31154 L
.77323 .32985 L
.77423 .34673 L
.77522 .36203 L
.77622 .37572 L
.77722 .38782 L
.77822 .39838 L
.77922 .4075 L
.78022 .41528 L
.78122 .42183 L
.78222 .42728 L
.78322 .43174 L
.78422 .43531 L
.78521 .4381 L
.78621 .4402 L
.78721 .44171 L
.78821 .44271 L
.78921 .44328 L
.79021 .44349 L
.79121 .44341 L
.79221 .44309 L
.79321 .4426 L
.79421 .44197 L
.7952 .44125 L
.7962 .44048 L
.7972 .43969 L
.7982 .43892 L
Mistroke
.7992 .47341 L
.8002 .47615 L
.8012 .47851 L
.8022 .48052 L
.8032 .48217 L
.8042 .48348 L
.80519 .48446 L
.80619 .4851 L
.80719 .48541 L
.80819 .4854 L
.80919 .48507 L
.81019 .48444 L
.81119 .48352 L
.81219 .48233 L
.81319 .48088 L
.81419 .4792 L
.81518 .47731 L
.81618 .47525 L
.81718 .47304 L
.81818 .47071 L
.81918 .46829 L
.82018 .46581 L
.82118 .46331 L
.82218 .4608 L
.82318 .45833 L
.82418 .45591 L
.82517 .45356 L
.82617 .45131 L
.82717 .44917 L
.82817 .44715 L
.82917 .44528 L
.83017 .44355 L
.83117 .44197 L
.83217 .44056 L
.83317 .4393 L
.83417 .43822 L
.83516 .4373 L
.83616 .43654 L
.83716 .43595 L
.83816 .43551 L
.83916 .43524 L
.84016 .43512 L
.84116 .43516 L
.84216 .43533 L
.84316 .43566 L
.84416 .43612 L
.84515 .43672 L
.84615 .43744 L
.84715 .43829 L
.84815 .43926 L
Mistroke
.84915 .50989 L
.85015 .51015 L
.85115 .5099 L
.85215 .50911 L
.85315 .50777 L
.85415 .50586 L
.85514 .5034 L
.85614 .50041 L
.85714 .49694 L
.85814 .49303 L
.85914 .48875 L
.86014 .48416 L
.86114 .47934 L
.86214 .47437 L
.86314 .46931 L
.86414 .46425 L
.86513 .45925 L
.86613 .45436 L
.86713 .44964 L
.86813 .44512 L
.86913 .44085 L
.87013 .43685 L
.87113 .43313 L
.87213 .42972 L
.87313 .4266 L
.87413 .42379 L
.87512 .42128 L
.87612 .41907 L
.87712 .41713 L
.87812 .41548 L
.87912 .41408 L
.88012 .41293 L
.88112 .41202 L
.88212 .41133 L
.88312 .41086 L
.88412 .41059 L
.88511 .41051 L
.88611 .41061 L
.88711 .41089 L
.88811 .41133 L
.88911 .41193 L
.89011 .41269 L
.89111 .41359 L
.89211 .41465 L
.89311 .41584 L
.89411 .41717 L
.8951 .41864 L
.8961 .42024 L
.8971 .42197 L
.8981 .42383 L
Mistroke
.8991 .45896 L
.9001 .46494 L
.9011 .47134 L
.9021 .47814 L
.9031 .48531 L
.9041 .49281 L
.90509 .50056 L
.90609 .50848 L
.90709 .51647 L
.90809 .52438 L
.90909 .53205 L
.91009 .53928 L
.91109 .54583 L
.91209 .55147 L
.91309 .55592 L
.91409 .55894 L
.91508 .56028 L
.91608 .55975 L
.91708 .55721 L
.91808 .55262 L
.91908 .54602 L
.92008 .53753 L
.92108 .52739 L
.92208 .51589 L
.92308 .50337 L
.92408 .49018 L
.92507 .47669 L
.92607 .46321 L
.92707 .45002 L
.92807 .43736 L
.92907 .42538 L
.93007 .41421 L
.93107 .40392 L
.93207 .39454 L
.93307 .38606 L
.93407 .37846 L
.93506 .37169 L
.93606 .36569 L
.93706 .36041 L
.93806 .35576 L
.93906 .35169 L
.94006 .34812 L
.94106 .34499 L
.94206 .34223 L
.94306 .3398 L
.94406 .33764 L
.94505 .3357 L
.94605 .33394 L
.94705 .33233 L
.94805 .33082 L
Mistroke
.94905 .32979 L
.95005 .3285 L
.95105 .32705 L
.95205 .32544 L
.95305 .32366 L
.95405 .3217 L
.95504 .31955 L
.95604 .31721 L
.95704 .31468 L
.95804 .31194 L
.95904 .30898 L
.96004 .3058 L
.96104 .30239 L
.96204 .29875 L
.96304 .29487 L
.96404 .29076 L
.96503 .28641 L
.96603 .28184 L
.96703 .27705 L
.96803 .27206 L
.96903 .2669 L
.97003 .26159 L
.97103 .25619 L
.97203 .25074 L
.97303 .24532 L
.97403 .23999 L
.97502 .23484 L
.97602 .22997 L
.97702 .22548 L
.97802 .22149 L
.97902 .21811 L
.98002 .21544 L
.98102 .21359 L
.98202 .21264 L
.98302 .21265 L
.98402 .21368 L
.98501 .21574 L
.98601 .21883 L
.98701 .2229 L
.98801 .2279 L
.98901 .23374 L
.99001 .24031 L
.99101 .2475 L
.99201 .25518 L
.99301 .2632 L
.99401 .27143 L
.995 .27973 L
.996 .28799 L
.997 .29608 L
.998 .30391 L
Mistroke
.999 .31417 L
Mfstroke
0 g
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .3057 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28377 L
.005 .2789 L
.00599 .27359 L
.00699 .26776 L
.00799 .26135 L
.00899 .25427 L
.00999 .24643 L
.01099 .23771 L
.01199 .22802 L
.01299 .21723 L
.01399 .20521 L
.01499 .1918 L
.01598 .17686 L
.01698 .16023 L
.01798 .14173 L
.01898 .1212 L
.01998 .09849 L
.02098 .07346 L
.02198 .04601 L
.02298 .01612 L
s
.02298 .01612 m
.02348 0 L
s
.03908 0 m
.03996 .06735 L
.04096 .14173 L
.04196 .21076 L
.04296 .2701 L
.04396 .31027 L
.04496 .30665 L
.04595 .24497 L
.04695 .16077 L
.04795 .08185 L
.04895 .01848 L
.04995 .02117 L
.05095 .04289 L
.05195 .07764 L
.05295 .12396 L
.05395 .17874 L
.05495 .23752 L
.05594 .29523 L
.05694 .3473 L
.05794 .39047 L
.05894 .42331 L
.05994 .44603 L
.06094 .45988 L
.06194 .46646 L
.06294 .46703 L
.06394 .46207 L
.06494 .45089 L
.06593 .4316 L
.06693 .40251 L
.06793 .36431 L
.06893 .32005 L
.06993 .27364 L
.07093 .22881 L
.07193 .18874 L
.07293 .1558 L
.07393 .13149 L
.07493 .11642 L
.07592 .11053 L
.07692 .11323 L
.07792 .12347 L
.07892 .13972 L
.07992 .15957 L
.08092 .17922 L
.08192 .19347 L
.08292 .19929 L
.08392 .19892 L
.08492 .19614 L
.08591 .19338 L
.08691 .19188 L
.08791 .19224 L
Mistroke
.08891 .19464 L
.08991 .19905 L
.09091 .20523 L
.09191 .21277 L
.09291 .22112 L
.09391 .22951 L
.09491 .23698 L
.0959 .24225 L
.0969 .24394 L
.0979 .24123 L
.0989 .23488 L
.0999 .3243 L
.1009 .32164 L
.1019 .32014 L
.1029 .31914 L
.1039 .31842 L
.1049 .3179 L
.10589 .3175 L
.10689 .31721 L
.10789 .31699 L
.10889 .31684 L
.10989 .31674 L
.11089 .3167 L
.11189 .3167 L
.11289 .31675 L
.11389 .31685 L
.11489 .31701 L
.11588 .31723 L
.11688 .31753 L
.11788 .3179 L
.11888 .31838 L
.11988 .31896 L
.12088 .31969 L
.12188 .32057 L
.12288 .32164 L
.12388 .32294 L
.12488 .3245 L
.12587 .32637 L
.12687 .32859 L
.12787 .33121 L
.12887 .33427 L
.12987 .33783 L
.13087 .3419 L
.13187 .34649 L
.13287 .35156 L
.13387 .357 L
.13487 .3626 L
.13586 .36796 L
.13686 .37244 L
.13786 .37509 L
Mistroke
.13886 .37475 L
.13986 .37047 L
.14086 .3621 L
.14186 .3503 L
.14286 .33611 L
.14386 .32064 L
.14486 .3048 L
.14585 .28938 L
.14685 .27499 L
.14785 .26209 L
.14885 .251 L
.14985 .35707 L
.15085 .33431 L
.15185 .31401 L
.15285 .29625 L
.15385 .2812 L
.15485 .26885 L
.15584 .25904 L
.15684 .25149 L
.15784 .24588 L
.15884 .24186 L
.15984 .2391 L
.16084 .23731 L
.16184 .23626 L
.16284 .23573 L
.16384 .23556 L
.16484 .23562 L
.16583 .2358 L
.16683 .23603 L
.16783 .23624 L
.16883 .2364 L
.16983 .23646 L
.17083 .23639 L
.17183 .23619 L
.17283 .23583 L
.17383 .23532 L
.17483 .23463 L
.17582 .23377 L
.17682 .23274 L
.17782 .23154 L
.17882 .23017 L
.17982 .22862 L
.18082 .22691 L
.18182 .22503 L
.18282 .22299 L
.18382 .22079 L
.18482 .21844 L
.18581 .21594 L
.18681 .21329 L
.18781 .21051 L
Mistroke
.18881 .2076 L
.18981 .20457 L
.19081 .20143 L
.19181 .1982 L
.19281 .1949 L
.19381 .19154 L
.19481 .18814 L
.1958 .18474 L
.1968 .18135 L
.1978 .17801 L
.1988 .17476 L
.1998 .15782 L
.2008 .14672 L
.2018 .13621 L
.2028 .12589 L
.2038 .11593 L
.2048 .10669 L
.20579 .0986 L
.20679 .09218 L
.20779 .08795 L
.20879 .08641 L
.20979 .08794 L
.21079 .09276 L
.21179 .10083 L
.21279 .11191 L
.21379 .1256 L
.21479 .14142 L
.21578 .15891 L
.21678 .17751 L
.21778 .19666 L
.21878 .21569 L
.21978 .23398 L
.22078 .25093 L
.22178 .26611 L
.22278 .27922 L
.22378 .29016 L
.22478 .29898 L
.22577 .30584 L
.22677 .31099 L
.22777 .31468 L
.22877 .31719 L
.22977 .31876 L
.23077 .3196 L
.23177 .3199 L
.23277 .3198 L
.23377 .31942 L
.23477 .31885 L
.23576 .31815 L
.23676 .31737 L
.23776 .31656 L
Mistroke
.23876 .31573 L
.23976 .31492 L
.24076 .31412 L
.24176 .31335 L
.24276 .31262 L
.24376 .31193 L
.24476 .31128 L
.24575 .31068 L
.24675 .31011 L
.24775 .30959 L
.24875 .30911 L
.24975 .38715 L
.25075 .38598 L
.25175 .38596 L
.25275 .38639 L
.25375 .38704 L
.25475 .3878 L
.25574 .38859 L
.25674 .38937 L
.25774 .39009 L
.25874 .39071 L
.25974 .39119 L
.26074 .39149 L
.26174 .39157 L
.26274 .39138 L
.26374 .39088 L
.26474 .39 L
.26573 .38869 L
.26673 .38688 L
.26773 .38451 L
.26873 .38154 L
.26973 .37792 L
.27073 .37364 L
.27173 .36874 L
.27273 .36327 L
.27373 .35736 L
.27473 .35112 L
.27572 .34472 L
.27672 .33831 L
.27772 .33204 L
.27872 .32604 L
.27972 .32042 L
.28072 .31524 L
.28172 .31055 L
.28272 .30639 L
.28372 .30274 L
.28472 .29958 L
.28571 .2969 L
.28671 .29463 L
.28771 .29274 L
Mistroke
.28871 .29118 L
.28971 .28991 L
.29071 .28886 L
.29171 .28801 L
.29271 .28731 L
.29371 .28673 L
.29471 .28623 L
.2957 .2858 L
.2967 .2854 L
.2977 .28502 L
.2987 .28463 L
.2997 .34462 L
.3007 .34216 L
.3017 .34098 L
.3027 .34039 L
.3037 .34017 L
.3047 .34022 L
.30569 .34049 L
.30669 .34094 L
.30769 .34154 L
.30869 .34229 L
.30969 .34319 L
.31069 .34422 L
.31169 .34538 L
.31269 .34669 L
.31369 .34815 L
.31469 .34975 L
.31568 .35151 L
.31668 .35345 L
.31768 .35556 L
.31868 .35785 L
.31968 .36033 L
.32068 .363 L
.32168 .36585 L
.32268 .36888 L
.32368 .37204 L
.32468 .37529 L
.32567 .37854 L
.32667 .38167 L
.32767 .38451 L
.32867 .38681 L
.32967 .38827 L
.33067 .38853 L
.33167 .38726 L
.33267 .38421 L
.33367 .3793 L
.33467 .37267 L
.33566 .36459 L
.33666 .35545 L
.33766 .34566 L
Mistroke
.33866 .33563 L
.33966 .32572 L
.34066 .31627 L
.34166 .30751 L
.34266 .29963 L
.34366 .29274 L
.34466 .28687 L
.34565 .28199 L
.34665 .27802 L
.34765 .27486 L
.34865 .27236 L
.34965 .37601 L
.35065 .36207 L
.35165 .34961 L
.35265 .33826 L
.35365 .32802 L
.35465 .31891 L
.35564 .31094 L
.35664 .30409 L
.35764 .29828 L
.35864 .29344 L
.35964 .28946 L
.36064 .28623 L
.36164 .28364 L
.36264 .28157 L
.36364 .27992 L
.36464 .27861 L
.36563 .27755 L
.36663 .27666 L
.36763 .27589 L
.36863 .27518 L
.36963 .27449 L
.37063 .27378 L
.37163 .27302 L
.37263 .27219 L
.37363 .27127 L
.37463 .27023 L
.37562 .26906 L
.37662 .26775 L
.37762 .26629 L
.37862 .26466 L
.37962 .26285 L
.38062 .26086 L
.38162 .25866 L
.38262 .25625 L
.38362 .25362 L
.38462 .25074 L
.38561 .24762 L
.38661 .24422 L
.38761 .24053 L
Mistroke
.38861 .23654 L
.38961 .23222 L
.39061 .22755 L
.39161 .22251 L
.39261 .21707 L
.39361 .21122 L
.39461 .20493 L
.3956 .19817 L
.3966 .19092 L
.3976 .18316 L
.3986 .17487 L
.3996 .25275 L
.4006 .24287 L
.4016 .23387 L
.4026 .22493 L
.4036 .21577 L
.4046 .20623 L
.40559 .19623 L
.40659 .18574 L
.40759 .17476 L
.40859 .16333 L
.40959 .15152 L
.41059 .13945 L
.41159 .12733 L
.41259 .11541 L
.41359 .10402 L
.41459 .09356 L
.41558 .08452 L
.41658 .07739 L
.41758 .07262 L
.41858 .07046 L
.41958 .07068 L
.42058 .07234 L
.42158 .07395 L
.42258 .07475 L
.42358 .0755 L
.42458 .07769 L
.42557 .08269 L
.42657 .09146 L
.42757 .10445 L
.42857 .12159 L
.42957 .14231 L
.43057 .16559 L
.43157 .19014 L
.43257 .21453 L
.43357 .2375 L
.43457 .25803 L
.43556 .2755 L
.43656 .28968 L
.43756 .30069 L
Mistroke
.43856 .30887 L
.43956 .3147 L
.44056 .31868 L
.44156 .32125 L
.44256 .32278 L
.44356 .32357 L
.44456 .32384 L
.44555 .32375 L
.44655 .32343 L
.44755 .32295 L
.44855 .32237 L
.44955 .37316 L
.45055 .3679 L
.45155 .36388 L
.45255 .36047 L
.45355 .35749 L
.45455 .35485 L
.45554 .3525 L
.45654 .35041 L
.45754 .34856 L
.45854 .34693 L
.45954 .3455 L
.46054 .34425 L
.46154 .34318 L
.46254 .34227 L
.46354 .34152 L
.46454 .3409 L
.46553 .34042 L
.46653 .34007 L
.46753 .33983 L
.46853 .33971 L
.46953 .33969 L
.47053 .33978 L
.47153 .33996 L
.47253 .34024 L
.47353 .34059 L
.47453 .34103 L
.47552 .34155 L
.47652 .34214 L
.47752 .34278 L
.47852 .34348 L
.47952 .34423 L
.48052 .34501 L
.48152 .3458 L
.48252 .34659 L
.48352 .34736 L
.48452 .34809 L
.48551 .34875 L
.48651 .34931 L
.48751 .34974 L
Mistroke
.48851 .35 L
.48951 .35007 L
.49051 .3499 L
.49151 .34948 L
.49251 .34879 L
.49351 .34779 L
.49451 .3465 L
.4955 .34491 L
.4965 .34304 L
.4975 .34091 L
.4985 .33855 L
.4995 .38475 L
.5005 .36606 L
.5015 .34883 L
.5025 .33295 L
.5035 .31859 L
.5045 .30593 L
.50549 .29503 L
.50649 .28589 L
.50749 .27839 L
.50849 .27239 L
.50949 .26769 L
.51049 .26409 L
.51149 .2614 L
.51249 .25942 L
.51349 .25798 L
.51449 .25695 L
.51548 .25619 L
.51648 .25559 L
.51748 .25508 L
.51848 .25457 L
.51948 .25402 L
.52048 .25338 L
.52148 .25261 L
.52248 .25168 L
.52348 .25058 L
.52448 .24928 L
.52547 .24778 L
.52647 .24605 L
.52747 .24409 L
.52847 .24189 L
.52947 .23944 L
.53047 .23673 L
.53147 .23376 L
.53247 .23051 L
.53347 .22698 L
.53447 .22315 L
.53546 .21903 L
.53646 .21459 L
.53746 .20984 L
Mistroke
.53846 .20477 L
.53946 .19936 L
.54046 .19363 L
.54146 .18756 L
.54246 .18116 L
.54346 .17444 L
.54446 .16741 L
.54545 .16011 L
.54645 .15255 L
.54745 .14478 L
.54845 .13687 L
.54945 .38581 L
.55045 .38654 L
.55145 .38912 L
.55245 .39275 L
.55345 .39717 L
.55445 .40225 L
.55544 .40792 L
.55644 .4141 L
.55744 .42074 L
.55844 .42777 L
.55944 .43512 L
.56044 .44266 L
.56144 .45023 L
.56244 .45761 L
.56344 .46446 L
.56444 .4703 L
.56543 .47443 L
.56643 .47578 L
.56743 .47298 L
.56843 .46462 L
.56943 .44994 L
.57043 .4293 L
.57143 .40394 L
.57243 .37553 L
.57343 .34593 L
.57443 .31691 L
.57542 .29004 L
.57642 .26641 L
.57742 .24668 L
.57842 .23097 L
.57942 .21904 L
.58042 .21039 L
.58142 .20443 L
.58242 .20058 L
.58342 .19834 L
.58442 .19733 L
.58541 .19727 L
.58641 .19792 L
.58741 .1991 L
Mistroke
.58841 .20069 L
.58941 .20254 L
.59041 .20455 L
.59141 .20665 L
.59241 .20875 L
.59341 .21079 L
.59441 .21273 L
.5954 .21453 L
.5964 .21614 L
.5974 .21756 L
.5984 .21875 L
.5994 .23387 L
.6004 .22969 L
.6014 .22643 L
.6024 .22339 L
.6034 .22037 L
.6044 .21729 L
.60539 .21409 L
.60639 .21076 L
.60739 .2073 L
.60839 .20372 L
.60939 .20003 L
.61039 .19626 L
.61139 .19243 L
.61239 .18859 L
.61339 .18477 L
.61439 .18101 L
.61538 .17737 L
.61638 .17389 L
.61738 .17063 L
.61838 .16763 L
.61938 .16495 L
.62038 .16261 L
.62138 .16064 L
.62238 .15906 L
.62338 .15784 L
.62438 .15695 L
.62537 .15634 L
.62637 .15594 L
.62737 .15568 L
.62837 .15549 L
.62937 .15535 L
.63037 .15527 L
.63137 .1553 L
.63237 .15551 L
.63337 .15598 L
.63437 .15681 L
.63536 .15806 L
.63636 .15979 L
.63736 .16202 L
Mistroke
.63836 .16476 L
.63936 .16798 L
.64036 .17163 L
.64136 .17563 L
.64236 .17989 L
.64336 .18432 L
.64436 .1888 L
.64535 .19323 L
.64635 .19753 L
.64735 .20159 L
.64835 .20536 L
.64935 .2602 L
.65035 .25478 L
.65135 .25036 L
.65235 .24626 L
.65335 .24225 L
.65435 .23823 L
.65534 .23414 L
.65634 .22992 L
.65734 .22555 L
.65834 .22103 L
.65934 .21632 L
.66034 .21144 L
.66134 .20639 L
.66234 .20118 L
.66334 .19582 L
.66434 .19035 L
.66533 .1848 L
.66633 .17921 L
.66733 .17365 L
.66833 .16818 L
.66933 .16287 L
.67033 .15783 L
.67133 .15314 L
.67233 .14891 L
.67333 .14523 L
.67433 .14217 L
.67532 .1398 L
.67632 .13811 L
.67732 .13704 L
.67832 .1364 L
.67932 .13594 L
.68032 .13533 L
.68132 .13425 L
.68232 .1326 L
.68332 .13043 L
.68432 .12804 L
.68531 .12578 L
.68631 .12406 L
.68731 .12321 L
Mistroke
.68831 .12354 L
.68931 .12525 L
.69031 .12847 L
.69131 .13322 L
.69231 .13943 L
.69331 .14695 L
.69431 .15553 L
.6953 .16487 L
.6963 .17464 L
.6973 .18449 L
.6983 .19409 L
.6993 .29466 L
.7003 .29391 L
.7013 .29361 L
.7023 .29324 L
.7033 .29267 L
.7043 .29191 L
.70529 .29097 L
.70629 .28988 L
.70729 .28867 L
.70829 .28735 L
.70929 .28594 L
.71029 .28446 L
.71129 .28292 L
.71229 .2813 L
.71329 .27963 L
.71429 .27788 L
.71528 .27606 L
.71628 .27416 L
.71728 .27216 L
.71828 .27005 L
.71928 .26782 L
.72028 .26545 L
.72128 .26294 L
.72228 .26025 L
.72328 .25738 L
.72428 .2543 L
.72527 .251 L
.72627 .24745 L
.72727 .24363 L
.72827 .23952 L
.72927 .23509 L
.73027 .23033 L
.73127 .22519 L
.73227 .21966 L
.73327 .2137 L
.73427 .20729 L
.73526 .20039 L
.73626 .19298 L
.73726 .18503 L
Mistroke
.73826 .17651 L
.73926 .1674 L
.74026 .15768 L
.74126 .14733 L
.74226 .13635 L
.74326 .12476 L
.74426 .11257 L
.74525 .09983 L
.74625 .0866 L
.74725 .07298 L
.74825 .05911 L
.74925 .12832 L
.75025 .11277 L
.75125 .09839 L
.75225 .08496 L
.75325 .07292 L
.75425 .06293 L
.75524 .05576 L
.75624 .05221 L
.75724 .05298 L
.75824 .05855 L
.75924 .06903 L
.76024 .08422 L
.76124 .10371 L
.76224 .12694 L
.76324 .15318 L
.76424 .18145 L
.76523 .21054 L
.76623 .23909 L
.76723 .26581 L
.76823 .28963 L
.76923 .30986 L
.77023 .32622 L
.77123 .33879 L
.77223 .34794 L
.77323 .35419 L
.77423 .3581 L
.77522 .36019 L
.77622 .36092 L
.77722 .36067 L
.77822 .35973 L
.77922 .35832 L
.78022 .35658 L
.78122 .35463 L
.78222 .35254 L
.78322 .35034 L
.78422 .34807 L
.78521 .34573 L
.78621 .34333 L
.78721 .34088 L
Mistroke
.78821 .33838 L
.78921 .33586 L
.79021 .33333 L
.79121 .33083 L
.79221 .32839 L
.79321 .32603 L
.79421 .32379 L
.7952 .32168 L
.7962 .31973 L
.7972 .31793 L
.7982 .31631 L
.7992 .40948 L
.8002 .40488 L
.8012 .40124 L
.8022 .39788 L
.8032 .39458 L
.8042 .39126 L
.80519 .38786 L
.80619 .38437 L
.80719 .38078 L
.80819 .3771 L
.80919 .37333 L
.81019 .3695 L
.81119 .36563 L
.81219 .36174 L
.81319 .35787 L
.81419 .35404 L
.81518 .35028 L
.81618 .34663 L
.81718 .3431 L
.81818 .33973 L
.81918 .33654 L
.82018 .33354 L
.82118 .33075 L
.82218 .32819 L
.82318 .32586 L
.82418 .32375 L
.82517 .32188 L
.82617 .32022 L
.82717 .31877 L
.82817 .31753 L
.82917 .31648 L
.83017 .3156 L
.83117 .31488 L
.83217 .31431 L
.83317 .31388 L
.83417 .31357 L
.83516 .31338 L
.83616 .31329 L
.83716 .31329 L
Mistroke
.83816 .31338 L
.83916 .31356 L
.84016 .31382 L
.84116 .31415 L
.84216 .31456 L
.84316 .31505 L
.84416 .31562 L
.84515 .31626 L
.84615 .317 L
.84715 .31782 L
.84815 .31873 L
.84915 .42067 L
.85015 .41297 L
.85115 .40572 L
.85215 .39838 L
.85315 .39084 L
.85415 .38313 L
.85514 .37534 L
.85614 .36756 L
.85714 .35991 L
.85814 .35249 L
.85914 .34541 L
.86014 .33873 L
.86114 .33254 L
.86214 .32688 L
.86314 .32177 L
.86414 .31723 L
.86513 .31324 L
.86613 .30978 L
.86713 .30683 L
.86813 .30433 L
.86913 .30225 L
.87013 .30054 L
.87113 .29914 L
.87213 .29801 L
.87313 .29711 L
.87413 .29639 L
.87512 .29582 L
.87612 .29536 L
.87712 .29498 L
.87812 .29466 L
.87912 .29438 L
.88012 .29411 L
.88112 .29384 L
.88212 .29357 L
.88312 .29327 L
.88412 .29295 L
.88511 .2926 L
.88611 .29221 L
.88711 .29179 L
Mistroke
.88811 .29134 L
.88911 .29085 L
.89011 .29033 L
.89111 .28979 L
.89211 .28923 L
.89311 .28866 L
.89411 .28809 L
.8951 .28753 L
.8961 .287 L
.8971 .28651 L
.8981 .28608 L
.8991 .422 L
.9001 .4262 L
.9011 .43169 L
.9021 .43765 L
.9031 .44379 L
.9041 .44988 L
.90509 .45571 L
.90609 .46107 L
.90709 .46569 L
.90809 .46924 L
.90909 .47135 L
.91009 .47157 L
.91109 .46937 L
.91209 .46416 L
.91309 .4554 L
.91409 .44276 L
.91508 .42628 L
.91608 .40645 L
.91708 .38416 L
.91808 .36055 L
.91908 .33682 L
.92008 .31408 L
.92108 .29325 L
.92208 .27494 L
.92308 .25948 L
.92408 .24691 L
.92507 .23707 L
.92607 .22966 L
.92707 .22432 L
.92807 .22067 L
.92907 .21836 L
.93007 .21708 L
.93107 .21656 L
.93207 .21657 L
.93307 .21694 L
.93407 .21751 L
.93506 .21816 L
.93606 .2188 L
.93706 .21936 L
Mistroke
.93806 .21978 L
.93906 .22002 L
.94006 .22006 L
.94106 .21988 L
.94206 .21946 L
.94306 .2188 L
.94406 .21789 L
.94505 .21675 L
.94605 .21537 L
.94705 .21376 L
.94805 .21192 L
.94905 .25878 L
.95005 .2525 L
.95105 .24721 L
.95205 .24217 L
.95305 .23715 L
.95405 .23203 L
.95504 .22675 L
.95604 .22126 L
.95704 .21554 L
.95804 .20957 L
.95904 .20335 L
.96004 .19688 L
.96104 .19018 L
.96204 .18328 L
.96304 .17624 L
.96404 .16911 L
.96503 .16197 L
.96603 .15491 L
.96703 .14807 L
.96803 .14157 L
.96903 .13558 L
.97003 .13025 L
.97103 .12576 L
.97203 .12223 L
.97303 .11974 L
.97403 .11828 L
.97502 .11766 L
.97602 .11749 L
.97702 .11719 L
.97802 .11624 L
.97902 .11445 L
.98002 .11209 L
.98102 .1097 L
.98202 .10794 L
.98302 .10738 L
.98402 .1085 L
.98501 .11163 L
.98601 .11694 L
.98701 .12444 L
Mistroke
.98801 .13399 L
.98901 .14526 L
.99001 .15783 L
.99101 .17117 L
.99201 .18472 L
.99301 .19795 L
.99401 .21039 L
.995 .22167 L
.996 .23155 L
.997 .23992 L
.998 .2468 L
.999 .3057 L
Mfstroke
gsave
.999 .31826 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32501 L
.005 .328 L
.00599 .33136 L
.00699 .33513 L
.00799 .33933 L
.00899 .34402 L
.00999 .34923 L
.01099 .35502 L
.01199 .36148 L
.01299 .36867 L
.01399 .3767 L
.01499 .38565 L
.01598 .39563 L
.01698 .40677 L
.01798 .4192 L
.01898 .43305 L
.01998 .44846 L
.02098 .46557 L
.02198 .48453 L
.02298 .50546 L
.02398 .52845 L
.02498 .55355 L
.02597 .58077 L
.02697 .60999 L
s
.02697 .60999 m
.02723 .61803 L
s
.04346 .61803 m
.04396 .57923 L
.04496 .52766 L
.04595 .52548 L
.04695 .54541 L
.04795 .56658 L
.04895 .58305 L
.04995 .03393 L
.05095 .06526 L
.05195 .10954 L
.05295 .16623 L
.05395 .23266 L
.05495 .30418 L
.05594 .37496 L
.05694 .4393 L
.05794 .49294 L
.05894 .53373 L
.05994 .56144 L
.06094 .5771 L
.06194 .58224 L
.06294 .57845 L
.06394 .56746 L
.06494 .5515 L
.06593 .53365 L
.06693 .51686 L
.06793 .50205 L
.06893 .48829 L
.06993 .4743 L
.07093 .45921 L
.07193 .44264 L
.07293 .42465 L
.07393 .40564 L
.07493 .38619 L
.07592 .36693 L
.07692 .34852 L
.07792 .33162 L
.07892 .31709 L
.07992 .30633 L
.08092 .30192 L
.08192 .30763 L
.08292 .32492 L
.08392 .34991 L
.08492 .37721 L
.08591 .40294 L
.08691 .42466 L
.08791 .44086 L
.08891 .45075 L
.08991 .45409 L
.09091 .4511 L
.09191 .44243 L
Mistroke
.09291 .42909 L
.09391 .41248 L
.09491 .39436 L
.0959 .37691 L
.0969 .36246 L
.0979 .35277 L
.0989 .34793 L
.0999 .33698 L
.1009 .34215 L
.1019 .34624 L
.1029 .34993 L
.1039 .35344 L
.1049 .35691 L
.10589 .36039 L
.10689 .36394 L
.10789 .3676 L
.10889 .37141 L
.10989 .37539 L
.11089 .37957 L
.11189 .38396 L
.11289 .38859 L
.11389 .39347 L
.11489 .3986 L
.11588 .40399 L
.11688 .40965 L
.11788 .41557 L
.11888 .42174 L
.11988 .42814 L
.12088 .43473 L
.12188 .44147 L
.12288 .44831 L
.12388 .45516 L
.12488 .46194 L
.12587 .46853 L
.12687 .4748 L
.12787 .48059 L
.12887 .48573 L
.12987 .49004 L
.13087 .49333 L
.13187 .49544 L
.13287 .49623 L
.13387 .49564 L
.13487 .49374 L
.13586 .49078 L
.13686 .48733 L
.13786 .48429 L
.13886 .48282 L
.13986 .48392 L
.14086 .48788 L
.14186 .49417 L
Mistroke
.14286 .50189 L
.14386 .51013 L
.14486 .51809 L
.14585 .52508 L
.14685 .53056 L
.14785 .53405 L
.14885 .5352 L
.14985 .36963 L
.15085 .35552 L
.15185 .34199 L
.15285 .32999 L
.15385 .31985 L
.15485 .31166 L
.15584 .30533 L
.15684 .30066 L
.15784 .29742 L
.15884 .29536 L
.15984 .29423 L
.16084 .29383 L
.16184 .29397 L
.16284 .2945 L
.16384 .29529 L
.16484 .29626 L
.16583 .29733 L
.16683 .29844 L
.16783 .29956 L
.16883 .30065 L
.16983 .30171 L
.17083 .30271 L
.17183 .30365 L
.17283 .30452 L
.17383 .30532 L
.17483 .30607 L
.17582 .30674 L
.17682 .30736 L
.17782 .30792 L
.17882 .30843 L
.17982 .30889 L
.18082 .3093 L
.18182 .30966 L
.18282 .30998 L
.18382 .31026 L
.18482 .31049 L
.18581 .31069 L
.18681 .31084 L
.18781 .31094 L
.18881 .311 L
.18981 .31101 L
.19081 .31096 L
.19181 .31084 L
Mistroke
.19281 .31067 L
.19381 .31041 L
.19481 .31007 L
.1958 .30964 L
.1968 .3091 L
.1978 .30845 L
.1988 .30768 L
.1998 .17022 L
.2008 .16733 L
.2018 .1629 L
.2028 .15795 L
.2038 .15297 L
.2048 .14838 L
.20579 .14458 L
.20679 .14199 L
.20779 .14107 L
.20879 .14231 L
.20979 .14624 L
.21079 .15337 L
.21179 .16418 L
.21279 .17894 L
.21379 .19757 L
.21479 .21956 L
.21578 .2439 L
.21678 .26932 L
.21778 .29443 L
.21878 .31799 L
.21978 .33906 L
.22078 .35706 L
.22178 .37176 L
.22278 .38326 L
.22378 .39184 L
.22478 .3979 L
.22577 .40187 L
.22677 .40415 L
.22777 .40513 L
.22877 .40512 L
.22977 .40437 L
.23077 .40312 L
.23177 .40152 L
.23277 .39972 L
.23377 .39783 L
.23477 .39593 L
.23576 .3941 L
.23676 .39238 L
.23776 .39081 L
.23876 .38944 L
.23976 .38828 L
.24076 .38736 L
.24176 .38667 L
Mistroke
.24276 .38623 L
.24376 .38603 L
.24476 .38609 L
.24575 .38639 L
.24675 .38692 L
.24775 .3877 L
.24875 .3887 L
.24975 .39951 L
.25075 .40641 L
.25175 .4122 L
.25275 .41753 L
.25375 .42258 L
.25475 .4274 L
.25574 .432 L
.25674 .43635 L
.25774 .44042 L
.25874 .44414 L
.25974 .44747 L
.26074 .45033 L
.26174 .45267 L
.26274 .45444 L
.26374 .45559 L
.26474 .45611 L
.26573 .45599 L
.26673 .45525 L
.26773 .45394 L
.26873 .45213 L
.26973 .4499 L
.27073 .44735 L
.27173 .44454 L
.27273 .44156 L
.27373 .43845 L
.27473 .43525 L
.27572 .43198 L
.27672 .42867 L
.27772 .42533 L
.27872 .42198 L
.27972 .41865 L
.28072 .41537 L
.28172 .41218 L
.28272 .40911 L
.28372 .40619 L
.28472 .40345 L
.28571 .40094 L
.28671 .39866 L
.28771 .39664 L
.28871 .39488 L
.28971 .39341 L
.29071 .39221 L
.29171 .39128 L
Mistroke
.29271 .39064 L
.29371 .39025 L
.29471 .39013 L
.2957 .39026 L
.2967 .39064 L
.2977 .39125 L
.2987 .39208 L
.2997 .35703 L
.3007 .36253 L
.3017 .36699 L
.3027 .37108 L
.3037 .37505 L
.3047 .37899 L
.30569 .38297 L
.30669 .38704 L
.30769 .39121 L
.30869 .39552 L
.30969 .39996 L
.31069 .40455 L
.31169 .40929 L
.31269 .41415 L
.31369 .41914 L
.31469 .42421 L
.31568 .42936 L
.31668 .43452 L
.31768 .43966 L
.31868 .44471 L
.31968 .44961 L
.32068 .45428 L
.32168 .45864 L
.32268 .4626 L
.32368 .46607 L
.32468 .469 L
.32567 .47131 L
.32667 .47301 L
.32767 .47413 L
.32867 .47477 L
.32967 .47512 L
.33067 .47542 L
.33167 .47594 L
.33267 .47686 L
.33367 .47824 L
.33467 .47996 L
.33566 .4818 L
.33666 .48346 L
.33766 .48463 L
.33866 .48503 L
.33966 .48446 L
.34066 .48276 L
.34166 .47984 L
Mistroke
.34266 .47569 L
.34366 .47039 L
.34466 .46406 L
.34565 .4569 L
.34665 .44914 L
.34765 .44105 L
.34865 .43288 L
.34965 .38854 L
.35065 .38274 L
.35165 .37628 L
.35265 .36993 L
.35365 .36401 L
.35465 .35869 L
.35564 .35404 L
.35664 .3501 L
.35764 .34686 L
.35864 .34429 L
.35964 .34232 L
.36064 .34091 L
.36164 .33997 L
.36264 .33946 L
.36364 .33931 L
.36464 .33946 L
.36563 .33987 L
.36663 .3405 L
.36763 .34133 L
.36863 .34232 L
.36963 .34345 L
.37063 .34472 L
.37163 .34612 L
.37263 .34763 L
.37363 .34927 L
.37463 .35104 L
.37562 .35294 L
.37662 .35497 L
.37762 .35715 L
.37862 .35949 L
.37962 .36199 L
.38062 .36469 L
.38162 .36758 L
.38262 .37069 L
.38362 .37403 L
.38462 .37762 L
.38561 .38149 L
.38661 .38564 L
.38761 .39011 L
.38861 .39491 L
.38961 .40007 L
.39061 .40562 L
.39161 .41157 L
Mistroke
.39261 .41795 L
.39361 .42478 L
.39461 .43208 L
.3956 .43987 L
.3966 .44818 L
.3976 .457 L
.3986 .46635 L
.3996 .26517 L
.4006 .26338 L
.4016 .26036 L
.4026 .2568 L
.4036 .25285 L
.4046 .24856 L
.40559 .24392 L
.40659 .23891 L
.40759 .23352 L
.40859 .22771 L
.40959 .22147 L
.41059 .21478 L
.41159 .20763 L
.41259 .20004 L
.41359 .19203 L
.41459 .18368 L
.41558 .17513 L
.41658 .16662 L
.41758 .15854 L
.41858 .1516 L
.41958 .14702 L
.42058 .1467 L
.42158 .15296 L
.42258 .16713 L
.42358 .18866 L
.42458 .21579 L
.42557 .24638 L
.42657 .27827 L
.42757 .30936 L
.42857 .33789 L
.42957 .36258 L
.43057 .38272 L
.43157 .39822 L
.43257 .40945 L
.43357 .41709 L
.43457 .42195 L
.43556 .42476 L
.43656 .42614 L
.43756 .42651 L
.43856 .42614 L
.43956 .42516 L
.44056 .4237 L
.44156 .42182 L
Mistroke
.44256 .4196 L
.44356 .41714 L
.44456 .41451 L
.44555 .41178 L
.44655 .40905 L
.44755 .40637 L
.44855 .40379 L
.44955 .38562 L
.45055 .38823 L
.45155 .38972 L
.45255 .39076 L
.45355 .39161 L
.45455 .39237 L
.45554 .39312 L
.45654 .39389 L
.45754 .39472 L
.45854 .39562 L
.45954 .3966 L
.46054 .39768 L
.46154 .39885 L
.46254 .40011 L
.46354 .40146 L
.46454 .40291 L
.46553 .40444 L
.46653 .40605 L
.46753 .40774 L
.46853 .40949 L
.46953 .4113 L
.47053 .41316 L
.47153 .41507 L
.47253 .417 L
.47353 .41896 L
.47453 .42092 L
.47552 .42289 L
.47652 .42484 L
.47752 .42677 L
.47852 .42866 L
.47952 .43051 L
.48052 .43231 L
.48152 .43404 L
.48252 .43572 L
.48352 .43732 L
.48452 .43885 L
.48551 .44032 L
.48651 .44174 L
.48751 .4431 L
.48851 .44443 L
.48951 .44573 L
.49051 .44702 L
.49151 .44831 L
Mistroke
.49251 .4496 L
.49351 .45091 L
.49451 .45221 L
.4955 .4535 L
.4965 .45477 L
.4975 .45597 L
.4985 .45709 L
.4995 .39726 L
.5005 .38676 L
.5015 .37562 L
.5025 .36484 L
.5035 .35492 L
.5045 .34613 L
.50549 .33861 L
.50649 .33239 L
.50749 .32744 L
.50849 .32363 L
.50949 .32085 L
.51049 .31895 L
.51149 .31777 L
.51249 .3172 L
.51349 .3171 L
.51449 .31737 L
.51548 .31792 L
.51648 .31869 L
.51748 .31961 L
.51848 .32065 L
.51948 .32177 L
.52048 .32294 L
.52148 .32416 L
.52248 .32541 L
.52348 .32669 L
.52448 .328 L
.52547 .32933 L
.52647 .3307 L
.52747 .33211 L
.52847 .33357 L
.52947 .33508 L
.53047 .33666 L
.53147 .33831 L
.53247 .34004 L
.53347 .34187 L
.53447 .3438 L
.53546 .34585 L
.53646 .34802 L
.53746 .35032 L
.53846 .35276 L
.53946 .35536 L
.54046 .35812 L
.54146 .36105 L
Mistroke
.54246 .36416 L
.54346 .36745 L
.54446 .37092 L
.54545 .37459 L
.54645 .37846 L
.54745 .38251 L
.54845 .38675 L
.54945 .39824 L
.55045 .40704 L
.55145 .41555 L
.55245 .42447 L
.55345 .43397 L
.55445 .44407 L
.55544 .45472 L
.55644 .46584 L
.55744 .47728 L
.55844 .48883 L
.55944 .50024 L
.56044 .51118 L
.56144 .52124 L
.56244 .52999 L
.56344 .53696 L
.56444 .54172 L
.56543 .54403 L
.56643 .54392 L
.56743 .54189 L
.56843 .53861 L
.56943 .53439 L
.57043 .52886 L
.57143 .52127 L
.57243 .51094 L
.57343 .49751 L
.57443 .481 L
.57542 .46183 L
.57642 .44078 L
.57742 .41883 L
.57842 .3971 L
.57942 .3766 L
.58042 .35815 L
.58142 .34227 L
.58242 .32919 L
.58342 .31884 L
.58442 .31098 L
.58541 .30525 L
.58641 .30125 L
.58741 .2986 L
.58841 .29697 L
.58941 .29611 L
.59041 .29578 L
.59141 .29583 L
Mistroke
.59241 .29613 L
.59341 .29659 L
.59441 .29714 L
.5954 .29773 L
.5964 .29833 L
.5974 .29891 L
.5984 .29946 L
.5994 .24628 L
.6004 .25002 L
.6014 .2523 L
.6024 .25384 L
.6034 .25485 L
.6044 .25546 L
.60539 .25573 L
.60639 .25571 L
.60739 .25545 L
.60839 .25495 L
.60939 .25426 L
.61039 .25339 L
.61139 .25235 L
.61239 .25116 L
.61339 .24983 L
.61439 .24838 L
.61538 .24682 L
.61638 .24519 L
.61738 .24349 L
.61838 .24177 L
.61938 .24006 L
.62038 .23843 L
.62138 .23693 L
.62238 .23565 L
.62338 .23469 L
.62438 .23417 L
.62537 .23422 L
.62637 .23497 L
.62737 .23654 L
.62837 .239 L
.62937 .24238 L
.63037 .24667 L
.63137 .25177 L
.63237 .25754 L
.63337 .26382 L
.63437 .27041 L
.63536 .27714 L
.63636 .28382 L
.63736 .29031 L
.63836 .29646 L
.63936 .30219 L
.64036 .30742 L
.64136 .31212 L
Mistroke
.64236 .31628 L
.64336 .31991 L
.64436 .32305 L
.64535 .32574 L
.64635 .32803 L
.64735 .32998 L
.64835 .33163 L
.64935 .27273 L
.65035 .27519 L
.65135 .27636 L
.65235 .27691 L
.65335 .27705 L
.65435 .27691 L
.65534 .27652 L
.65634 .27593 L
.65734 .27516 L
.65834 .27421 L
.65934 .27311 L
.66034 .27184 L
.66134 .27041 L
.66234 .26881 L
.66334 .26704 L
.66434 .26509 L
.66533 .26294 L
.66633 .2606 L
.66733 .25804 L
.66833 .25526 L
.66933 .25226 L
.67033 .24903 L
.67133 .24558 L
.67233 .24193 L
.67333 .23812 L
.67433 .23421 L
.67532 .23033 L
.67632 .22663 L
.67732 .22336 L
.67832 .22085 L
.67932 .21953 L
.68032 .21985 L
.68132 .22222 L
.68232 .22684 L
.68332 .23365 L
.68432 .24236 L
.68531 .25254 L
.68631 .26368 L
.68731 .27529 L
.68831 .28692 L
.68931 .29813 L
.69031 .30861 L
.69131 .31809 L
Mistroke
.69231 .32641 L
.69331 .3335 L
.69431 .33938 L
.6953 .34413 L
.6963 .34789 L
.6973 .35082 L
.6983 .35311 L
.6993 .30722 L
.7003 .31435 L
.7013 .3196 L
.7023 .32369 L
.7033 .32692 L
.7043 .32949 L
.70529 .33154 L
.70629 .33318 L
.70729 .33452 L
.70829 .33564 L
.70929 .33661 L
.71029 .33749 L
.71129 .33832 L
.71229 .33915 L
.71329 .34001 L
.71429 .34092 L
.71528 .34192 L
.71628 .34302 L
.71728 .34424 L
.71828 .34559 L
.71928 .3471 L
.72028 .34876 L
.72128 .3506 L
.72228 .35262 L
.72328 .35484 L
.72428 .35728 L
.72527 .35995 L
.72627 .36286 L
.72727 .36603 L
.72827 .36949 L
.72927 .37324 L
.73027 .37731 L
.73127 .38173 L
.73227 .38651 L
.73327 .39169 L
.73427 .39729 L
.73526 .40334 L
.73626 .40987 L
.73726 .41692 L
.73826 .4245 L
.73926 .43266 L
.74026 .44142 L
.74126 .4508 L
Mistroke
.74226 .46083 L
.74326 .47153 L
.74426 .48288 L
.74525 .4949 L
.74625 .50755 L
.74725 .5208 L
.74825 .53456 L
.74925 .14076 L
.75025 .13335 L
.75125 .12497 L
.75225 .11673 L
.75325 .10934 L
.75425 .10345 L
.75524 .09978 L
.75624 .09917 L
.75724 .10252 L
.75824 .11082 L
.75924 .12497 L
.76024 .14554 L
.76124 .17243 L
.76224 .20465 L
.76324 .24043 L
.76424 .27748 L
.76523 .31347 L
.76623 .34637 L
.76723 .37478 L
.76823 .398 L
.76923 .41598 L
.77023 .42914 L
.77123 .43817 L
.77223 .44383 L
.77323 .44686 L
.77423 .44789 L
.77522 .44743 L
.77622 .44588 L
.77722 .44356 L
.77822 .4407 L
.77922 .43746 L
.78022 .43399 L
.78122 .4304 L
.78222 .42678 L
.78322 .42321 L
.78422 .41978 L
.78521 .41655 L
.78621 .41359 L
.78721 .41094 L
.78821 .40865 L
.78921 .40673 L
.79021 .40518 L
.79121 .404 L
Mistroke
.79221 .40318 L
.79321 .40269 L
.79421 .4025 L
.7952 .4026 L
.7962 .40295 L
.7972 .40353 L
.7982 .40432 L
.7992 .42193 L
.8002 .42531 L
.8012 .42734 L
.8022 .42863 L
.8032 .42938 L
.8042 .42966 L
.80519 .42952 L
.80619 .42899 L
.80719 .4281 L
.80819 .42689 L
.80919 .4254 L
.81019 .42368 L
.81119 .42177 L
.81219 .41972 L
.81319 .41759 L
.81419 .41542 L
.81518 .41326 L
.81618 .41115 L
.81718 .40914 L
.81818 .40725 L
.81918 .40551 L
.82018 .40395 L
.82118 .40257 L
.82218 .40138 L
.82318 .40039 L
.82418 .39961 L
.82517 .39904 L
.82617 .39866 L
.82717 .39849 L
.82817 .39851 L
.82917 .39871 L
.83017 .3991 L
.83117 .39967 L
.83217 .40041 L
.83317 .40132 L
.83417 .40238 L
.83516 .4036 L
.83616 .40497 L
.83716 .40648 L
.83816 .40812 L
.83916 .4099 L
.84016 .41179 L
.84116 .4138 L
Mistroke
.84216 .41591 L
.84316 .41812 L
.84416 .42041 L
.84515 .42277 L
.84615 .42519 L
.84715 .42766 L
.84815 .43015 L
.84915 .43311 L
.85015 .43344 L
.85115 .43197 L
.85215 .42939 L
.85315 .42601 L
.85415 .42201 L
.85514 .41756 L
.85614 .41282 L
.85714 .40793 L
.85814 .40304 L
.85914 .39827 L
.86014 .39371 L
.86114 .38946 L
.86214 .38558 L
.86314 .3821 L
.86414 .37907 L
.86513 .37649 L
.86613 .37435 L
.86713 .37265 L
.86813 .37136 L
.86913 .37046 L
.87013 .36993 L
.87113 .36973 L
.87213 .36985 L
.87313 .37026 L
.87413 .37094 L
.87512 .37187 L
.87612 .37303 L
.87712 .37442 L
.87812 .37603 L
.87912 .37785 L
.88012 .37987 L
.88112 .38209 L
.88212 .38452 L
.88312 .38715 L
.88412 .38999 L
.88511 .39303 L
.88611 .39628 L
.88711 .39974 L
.88811 .40341 L
.88911 .40729 L
.89011 .41139 L
.89111 .4157 L
Mistroke
.89211 .42021 L
.89311 .42491 L
.89411 .4298 L
.8951 .43485 L
.8961 .44004 L
.8971 .44535 L
.8981 .45073 L
.8991 .43443 L
.9001 .4467 L
.9011 .45806 L
.9021 .4691 L
.9031 .47988 L
.9041 .49026 L
.90509 .50001 L
.90609 .50885 L
.90709 .51641 L
.90809 .52234 L
.90909 .52626 L
.91009 .52787 L
.91109 .52698 L
.91209 .52359 L
.91309 .51782 L
.91409 .5099 L
.91508 .50002 L
.91608 .48833 L
.91708 .47493 L
.91808 .46002 L
.91908 .44392 L
.92008 .42708 L
.92108 .41004 L
.92208 .39339 L
.92308 .37768 L
.92408 .36337 L
.92507 .35077 L
.92607 .34005 L
.92707 .33125 L
.92807 .32425 L
.92907 .31888 L
.93007 .31493 L
.93107 .31215 L
.93207 .31033 L
.93307 .30926 L
.93407 .30877 L
.93506 .30872 L
.93606 .30899 L
.93706 .30947 L
.93806 .31011 L
.93906 .31085 L
.94006 .31164 L
.94106 .31244 L
Mistroke
.94206 .31324 L
.94306 .31402 L
.94406 .31477 L
.94505 .31547 L
.94605 .31612 L
.94705 .31671 L
.94805 .31725 L
.94905 .27117 L
.95005 .27286 L
.95105 .27323 L
.95205 .27297 L
.95305 .2723 L
.95405 .27133 L
.95504 .27011 L
.95604 .26865 L
.95704 .26698 L
.95804 .2651 L
.95904 .26301 L
.96004 .2607 L
.96104 .25816 L
.96204 .25538 L
.96304 .25234 L
.96404 .24904 L
.96503 .24545 L
.96603 .24158 L
.96703 .23739 L
.96803 .23291 L
.96903 .22814 L
.97003 .22312 L
.97103 .21791 L
.97203 .21264 L
.97303 .20751 L
.97403 .20283 L
.97502 .1991 L
.97602 .19698 L
.97702 .19731 L
.97802 .20082 L
.97902 .20783 L
.98002 .21815 L
.98102 .23116 L
.98202 .24609 L
.98302 .26213 L
.98402 .27849 L
.98501 .29444 L
.98601 .30939 L
.98701 .32287 L
.98801 .33457 L
.98901 .34437 L
.99001 .35227 L
.99101 .35843 L
Mistroke
.99201 .36309 L
.99301 .36653 L
.99401 .36907 L
.995 .37097 L
.996 .37245 L
.997 .37365 L
.998 .37468 L
.999 .31826 L
Mfstroke
1 0 0 r
gsave
.999 .31198 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30145 L
.00799 .30034 L
.00899 .29914 L
.00999 .29783 L
.01099 .29637 L
.01199 .29475 L
.01299 .29295 L
.01399 .29095 L
.01499 .28872 L
.01598 .28625 L
.01698 .2835 L
.01798 .28047 L
.01898 .27713 L
.01998 .27348 L
.02098 .26952 L
.02198 .26527 L
.02298 .26079 L
.02398 .25615 L
.02498 .2515 L
.02597 .24704 L
.02697 .24308 L
.02797 .24002 L
.02897 .23841 L
.02997 .23895 L
.03097 .24246 L
.03197 .24985 L
.03297 .26201 L
.03397 .27961 L
.03497 .30289 L
.03596 .33132 L
.03696 .36344 L
.03796 .39669 L
.03896 .42769 L
.03996 .45271 L
.04096 .46836 L
.04196 .47237 L
.04296 .4641 L
.04396 .44475 L
.04496 .41716 L
.04595 .38523 L
.04695 .35309 L
.04795 .32421 L
.04895 .30077 L
Mistroke
.04995 .02755 L
.05095 .05408 L
.05195 .09359 L
.05295 .14509 L
.05395 .2057 L
.05495 .27085 L
.05594 .3351 L
.05694 .3933 L
.05794 .44171 L
.05894 .47852 L
.05994 .50373 L
.06094 .51849 L
.06194 .52435 L
.06294 .52274 L
.06394 .51476 L
.06494 .50119 L
.06593 .48262 L
.06693 .45968 L
.06793 .43318 L
.06893 .40417 L
.06993 .37397 L
.07093 .34401 L
.07193 .31569 L
.07293 .29023 L
.07393 .26857 L
.07493 .2513 L
.07592 .23873 L
.07692 .23087 L
.07792 .22755 L
.07892 .2284 L
.07992 .23295 L
.08092 .24057 L
.08192 .25055 L
.08292 .26211 L
.08392 .27441 L
.08492 .28667 L
.08591 .29816 L
.08691 .30827 L
.08791 .31655 L
.08891 .3227 L
.08991 .32657 L
.09091 .32817 L
.09191 .3276 L
.09291 .3251 L
.09391 .32099 L
.09491 .31567 L
.0959 .30958 L
.0969 .3032 L
.0979 .297 L
.0989 .29141 L
Mistroke
.0999 .33064 L
.1009 .33189 L
.1019 .33319 L
.1029 .33453 L
.1039 .33593 L
.1049 .3374 L
.10589 .33894 L
.10689 .34057 L
.10789 .3423 L
.10889 .34413 L
.10989 .34607 L
.11089 .34813 L
.11189 .35033 L
.11289 .35267 L
.11389 .35516 L
.11489 .35781 L
.11588 .36061 L
.11688 .36359 L
.11788 .36674 L
.11888 .37006 L
.11988 .37355 L
.12088 .37721 L
.12188 .38102 L
.12288 .38498 L
.12388 .38905 L
.12488 .39322 L
.12587 .39745 L
.12687 .40169 L
.12787 .4059 L
.12887 .41 L
.12987 .41393 L
.13087 .41762 L
.13187 .42096 L
.13287 .42389 L
.13387 .42632 L
.13487 .42817 L
.13586 .42937 L
.13686 .42989 L
.13786 .42969 L
.13886 .42878 L
.13986 .4272 L
.14086 .42499 L
.14186 .42223 L
.14286 .419 L
.14386 .41538 L
.14486 .41144 L
.14585 .40723 L
.14685 .40278 L
.14785 .39807 L
.14885 .3931 L
Mistroke
.14985 .36335 L
.15085 .34491 L
.15185 .328 L
.15285 .31312 L
.15385 .30053 L
.15485 .29026 L
.15584 .28218 L
.15684 .27608 L
.15784 .27165 L
.15884 .26861 L
.15984 .26666 L
.16084 .26557 L
.16184 .26511 L
.16284 .26511 L
.16384 .26542 L
.16484 .26594 L
.16583 .26656 L
.16683 .26723 L
.16783 .2679 L
.16883 .26853 L
.16983 .26908 L
.17083 .26955 L
.17183 .26992 L
.17283 .27018 L
.17383 .27032 L
.17483 .27035 L
.17582 .27026 L
.17682 .27005 L
.17782 .26973 L
.17882 .2693 L
.17982 .26875 L
.18082 .2681 L
.18182 .26735 L
.18282 .26648 L
.18382 .26552 L
.18482 .26447 L
.18581 .26331 L
.18681 .26206 L
.18781 .26073 L
.18881 .2593 L
.18981 .25779 L
.19081 .25619 L
.19181 .25452 L
.19281 .25278 L
.19381 .25097 L
.19481 .24911 L
.1958 .24719 L
.1968 .24523 L
.1978 .24323 L
.1988 .24122 L
Mistroke
.1998 .16402 L
.2008 .15702 L
.2018 .14955 L
.2028 .14192 L
.2038 .13445 L
.2048 .12753 L
.20579 .12159 L
.20679 .11708 L
.20779 .11451 L
.20879 .11436 L
.20979 .11709 L
.21079 .12307 L
.21179 .13251 L
.21279 .14542 L
.21379 .16158 L
.21479 .18049 L
.21578 .2014 L
.21678 .22342 L
.21778 .24554 L
.21878 .26684 L
.21978 .28652 L
.22078 .30399 L
.22178 .31893 L
.22278 .33124 L
.22378 .341 L
.22478 .34844 L
.22577 .35385 L
.22677 .35757 L
.22777 .3599 L
.22877 .36115 L
.22977 .36156 L
.23077 .36136 L
.23177 .36071 L
.23277 .35976 L
.23377 .35863 L
.23477 .35739 L
.23576 .35612 L
.23676 .35487 L
.23776 .35369 L
.23876 .35259 L
.23976 .3516 L
.24076 .35074 L
.24176 .35001 L
.24276 .34943 L
.24376 .34898 L
.24476 .34869 L
.24575 .34853 L
.24675 .34852 L
.24775 .34864 L
.24875 .3489 L
Mistroke
.24975 .39333 L
.25075 .39619 L
.25175 .39908 L
.25275 .40196 L
.25375 .40481 L
.25475 .4076 L
.25574 .4103 L
.25674 .41286 L
.25774 .41525 L
.25874 .41743 L
.25974 .41933 L
.26074 .42091 L
.26174 .42212 L
.26274 .42291 L
.26374 .42323 L
.26474 .42305 L
.26573 .42234 L
.26673 .42106 L
.26773 .41923 L
.26873 .41684 L
.26973 .41391 L
.27073 .41049 L
.27173 .40664 L
.27273 .40242 L
.27373 .3979 L
.27473 .39318 L
.27572 .38835 L
.27672 .38349 L
.27772 .37869 L
.27872 .37401 L
.27972 .36953 L
.28072 .36531 L
.28172 .36137 L
.28272 .35775 L
.28372 .35446 L
.28472 .35152 L
.28571 .34892 L
.28671 .34665 L
.28771 .34469 L
.28871 .34303 L
.28971 .34166 L
.29071 .34053 L
.29171 .33965 L
.29271 .33897 L
.29371 .33849 L
.29471 .33818 L
.2957 .33803 L
.2967 .33802 L
.2977 .33813 L
.2987 .33836 L
Mistroke
.2997 .35082 L
.3007 .35235 L
.3017 .35398 L
.3027 .35574 L
.3037 .35761 L
.3047 .35961 L
.30569 .36173 L
.30669 .36399 L
.30769 .36638 L
.30869 .36891 L
.30969 .37158 L
.31069 .37439 L
.31169 .37734 L
.31269 .38042 L
.31369 .38364 L
.31469 .38698 L
.31568 .39044 L
.31668 .39398 L
.31768 .39761 L
.31868 .40128 L
.31968 .40497 L
.32068 .40864 L
.32168 .41225 L
.32268 .41574 L
.32368 .41906 L
.32468 .42214 L
.32567 .42493 L
.32667 .42734 L
.32767 .42932 L
.32867 .43079 L
.32967 .43169 L
.33067 .43198 L
.33167 .4316 L
.33267 .43053 L
.33367 .42877 L
.33467 .42632 L
.33566 .4232 L
.33666 .41945 L
.33766 .41514 L
.33866 .41033 L
.33966 .40509 L
.34066 .39951 L
.34166 .39367 L
.34266 .38766 L
.34366 .38156 L
.34466 .37546 L
.34565 .36944 L
.34665 .36358 L
.34765 .35795 L
.34865 .35262 L
Mistroke
.34965 .38227 L
.35065 .3724 L
.35165 .36294 L
.35265 .3541 L
.35365 .34602 L
.35465 .3388 L
.35564 .33249 L
.35664 .32709 L
.35764 .32257 L
.35864 .31886 L
.35964 .31589 L
.36064 .31357 L
.36164 .31181 L
.36264 .31051 L
.36364 .30962 L
.36464 .30904 L
.36563 .30871 L
.36663 .30858 L
.36763 .30861 L
.36863 .30875 L
.36963 .30897 L
.37063 .30925 L
.37163 .30957 L
.37263 .30991 L
.37363 .31027 L
.37463 .31063 L
.37562 .311 L
.37662 .31136 L
.37762 .31172 L
.37862 .31207 L
.37962 .31242 L
.38062 .31277 L
.38162 .31312 L
.38262 .31347 L
.38362 .31382 L
.38462 .31418 L
.38561 .31455 L
.38661 .31493 L
.38761 .31532 L
.38861 .31572 L
.38961 .31614 L
.39061 .31658 L
.39161 .31704 L
.39261 .31751 L
.39361 .318 L
.39461 .3185 L
.3956 .31902 L
.3966 .31955 L
.3976 .32008 L
.3986 .32061 L
Mistroke
.3996 .25896 L
.4006 .25312 L
.4016 .24712 L
.4026 .24087 L
.4036 .23431 L
.4046 .22739 L
.40559 .22007 L
.40659 .21233 L
.40759 .20414 L
.40859 .19552 L
.40959 .18649 L
.41059 .17712 L
.41159 .16748 L
.41259 .15772 L
.41359 .14802 L
.41459 .13862 L
.41558 .12983 L
.41658 .122 L
.41758 .11558 L
.41858 .11103 L
.41958 .10885 L
.42058 .10952 L
.42158 .11346 L
.42258 .12094 L
.42358 .13208 L
.42458 .14674 L
.42557 .16454 L
.42657 .18486 L
.42757 .2069 L
.42857 .22974 L
.42957 .25244 L
.43057 .27416 L
.43157 .29418 L
.43257 .31199 L
.43357 .3273 L
.43457 .33999 L
.43556 .35013 L
.43656 .35791 L
.43756 .3636 L
.43856 .3675 L
.43956 .36993 L
.44056 .37119 L
.44156 .37153 L
.44256 .37119 L
.44356 .37036 L
.44456 .36917 L
.44555 .36777 L
.44655 .36624 L
.44755 .36466 L
.44855 .36308 L
Mistroke
.44955 .37939 L
.45055 .37807 L
.45155 .3768 L
.45255 .37562 L
.45355 .37455 L
.45455 .37361 L
.45554 .37281 L
.45654 .37215 L
.45754 .37164 L
.45854 .37128 L
.45954 .37105 L
.46054 .37097 L
.46154 .37101 L
.46254 .37119 L
.46354 .37149 L
.46454 .37191 L
.46553 .37243 L
.46653 .37306 L
.46753 .37379 L
.46853 .3746 L
.46953 .3755 L
.47053 .37647 L
.47153 .37751 L
.47253 .37862 L
.47353 .37978 L
.47453 .38098 L
.47552 .38222 L
.47652 .38349 L
.47752 .38478 L
.47852 .38607 L
.47952 .38737 L
.48052 .38866 L
.48152 .38992 L
.48252 .39115 L
.48352 .39234 L
.48452 .39347 L
.48551 .39454 L
.48651 .39552 L
.48751 .39642 L
.48851 .39721 L
.48951 .3979 L
.49051 .39846 L
.49151 .3989 L
.49251 .39919 L
.49351 .39935 L
.49451 .39935 L
.4955 .39921 L
.4965 .3989 L
.4975 .39844 L
.4985 .39782 L
Mistroke
.4995 .391 L
.5005 .37641 L
.5015 .36223 L
.5025 .34889 L
.5035 .33675 L
.5045 .32603 L
.50549 .31682 L
.50649 .30914 L
.50749 .30291 L
.50849 .29801 L
.50949 .29427 L
.51049 .29152 L
.51149 .28958 L
.51249 .28831 L
.51349 .28754 L
.51449 .28716 L
.51548 .28705 L
.51648 .28714 L
.51748 .28734 L
.51848 .28761 L
.51948 .28789 L
.52048 .28816 L
.52148 .28838 L
.52248 .28855 L
.52348 .28863 L
.52448 .28864 L
.52547 .28855 L
.52647 .28837 L
.52747 .2881 L
.52847 .28773 L
.52947 .28726 L
.53047 .28669 L
.53147 .28603 L
.53247 .28528 L
.53347 .28442 L
.53447 .28348 L
.53546 .28244 L
.53646 .28131 L
.53746 .28008 L
.53846 .27877 L
.53946 .27736 L
.54046 .27587 L
.54146 .2743 L
.54246 .27266 L
.54346 .27094 L
.54446 .26917 L
.54545 .26735 L
.54645 .2655 L
.54745 .26365 L
.54845 .26181 L
Mistroke
.54945 .39203 L
.55045 .39679 L
.55145 .40234 L
.55245 .40861 L
.55345 .41557 L
.55445 .42316 L
.55544 .43132 L
.55644 .43997 L
.55744 .44901 L
.55844 .4583 L
.55944 .46768 L
.56044 .47692 L
.56144 .48574 L
.56244 .4938 L
.56344 .50071 L
.56444 .50601 L
.56543 .50923 L
.56643 .50985 L
.56743 .50744 L
.56843 .50161 L
.56943 .49216 L
.57043 .47908 L
.57143 .4626 L
.57243 .44324 L
.57343 .42172 L
.57443 .39896 L
.57542 .37593 L
.57642 .35359 L
.57742 .33276 L
.57842 .31404 L
.57942 .29782 L
.58042 .28427 L
.58142 .27335 L
.58242 .26488 L
.58342 .25859 L
.58442 .25416 L
.58541 .25126 L
.58641 .24958 L
.58741 .24885 L
.58841 .24883 L
.58941 .24932 L
.59041 .25017 L
.59141 .25124 L
.59241 .25244 L
.59341 .25369 L
.59441 .25494 L
.5954 .25613 L
.5964 .25724 L
.5974 .25823 L
.5984 .25911 L
Mistroke
.5994 .24008 L
.6004 .23985 L
.6014 .23936 L
.6024 .23861 L
.6034 .23761 L
.6044 .23637 L
.60539 .23491 L
.60639 .23324 L
.60739 .23137 L
.60839 .22934 L
.60939 .22715 L
.61039 .22482 L
.61139 .22239 L
.61239 .21987 L
.61339 .2173 L
.61439 .21469 L
.61538 .2121 L
.61638 .20954 L
.61738 .20706 L
.61838 .2047 L
.61938 .20251 L
.62038 .20052 L
.62138 .19878 L
.62238 .19735 L
.62338 .19626 L
.62438 .19556 L
.62537 .19528 L
.62637 .19546 L
.62737 .19611 L
.62837 .19724 L
.62937 .19887 L
.63037 .20097 L
.63137 .20353 L
.63237 .20652 L
.63337 .2099 L
.63437 .21361 L
.63536 .2176 L
.63636 .22181 L
.63736 .22616 L
.63836 .23061 L
.63936 .23508 L
.64036 .23952 L
.64136 .24387 L
.64236 .24808 L
.64336 .25211 L
.64436 .25592 L
.64535 .25949 L
.64635 .26278 L
.64735 .26578 L
.64835 .26849 L
Mistroke
.64935 .26646 L
.65035 .26498 L
.65135 .26336 L
.65235 .26158 L
.65335 .25965 L
.65435 .25757 L
.65534 .25533 L
.65634 .25292 L
.65734 .25035 L
.65834 .24762 L
.65934 .24471 L
.66034 .24164 L
.66134 .2384 L
.66234 .235 L
.66334 .23143 L
.66434 .22772 L
.66533 .22387 L
.66633 .21991 L
.66733 .21584 L
.66833 .21172 L
.66933 .20757 L
.67033 .20343 L
.67133 .19936 L
.67233 .19542 L
.67333 .19167 L
.67433 .18819 L
.67532 .18507 L
.67632 .18237 L
.67732 .1802 L
.67832 .17863 L
.67932 .17774 L
.68032 .17759 L
.68132 .17824 L
.68232 .17972 L
.68332 .18204 L
.68432 .1852 L
.68531 .18916 L
.68631 .19387 L
.68731 .19925 L
.68831 .20523 L
.68931 .21169 L
.69031 .21854 L
.69131 .22565 L
.69231 .23292 L
.69331 .24023 L
.69431 .24745 L
.6953 .2545 L
.6963 .26126 L
.6973 .26766 L
.6983 .2736 L
Mistroke
.6993 .30094 L
.7003 .30413 L
.7013 .3066 L
.7023 .30846 L
.7033 .3098 L
.7043 .3107 L
.70529 .31126 L
.70629 .31153 L
.70729 .3116 L
.70829 .3115 L
.70929 .31128 L
.71029 .31098 L
.71129 .31062 L
.71229 .31023 L
.71329 .30982 L
.71429 .3094 L
.71528 .30899 L
.71628 .30859 L
.71728 .3082 L
.71828 .30782 L
.71928 .30746 L
.72028 .30711 L
.72128 .30677 L
.72228 .30643 L
.72328 .30611 L
.72428 .30579 L
.72527 .30547 L
.72627 .30515 L
.72727 .30483 L
.72827 .3045 L
.72927 .30417 L
.73027 .30382 L
.73127 .30346 L
.73227 .30308 L
.73327 .3027 L
.73427 .30229 L
.73526 .30187 L
.73626 .30143 L
.73726 .30097 L
.73826 .30051 L
.73926 .30003 L
.74026 .29955 L
.74126 .29907 L
.74226 .29859 L
.74326 .29814 L
.74426 .29773 L
.74525 .29736 L
.74625 .29708 L
.74725 .29689 L
.74825 .29683 L
Mistroke
.74925 .13454 L
.75025 .12306 L
.75125 .11168 L
.75225 .10085 L
.75325 .09113 L
.75425 .08319 L
.75524 .07777 L
.75624 .07569 L
.75724 .07775 L
.75824 .08469 L
.75924 .097 L
.76024 .11488 L
.76124 .13807 L
.76224 .1658 L
.76324 .1968 L
.76424 .22947 L
.76523 .262 L
.76623 .29273 L
.76723 .3203 L
.76823 .34382 L
.76923 .36292 L
.77023 .37768 L
.77123 .38848 L
.77223 .39589 L
.77323 .40053 L
.77423 .40299 L
.77522 .40381 L
.77622 .4034 L
.77722 .40212 L
.77822 .40022 L
.77922 .39789 L
.78022 .39529 L
.78122 .39251 L
.78222 .38966 L
.78322 .38678 L
.78422 .38392 L
.78521 .38114 L
.78621 .37846 L
.78721 .37591 L
.78821 .37351 L
.78921 .37129 L
.79021 .36926 L
.79121 .36742 L
.79221 .36579 L
.79321 .36436 L
.79421 .36315 L
.7952 .36214 L
.7962 .36134 L
.7972 .36073 L
.7982 .36031 L
Mistroke
.7992 .4157 L
.8002 .4151 L
.8012 .41429 L
.8022 .41325 L
.8032 .41198 L
.8042 .41046 L
.80519 .40869 L
.80619 .40668 L
.80719 .40444 L
.80819 .40199 L
.80919 .39937 L
.81019 .39659 L
.81119 .3937 L
.81219 .39073 L
.81319 .38773 L
.81419 .38473 L
.81518 .38177 L
.81618 .37889 L
.81718 .37612 L
.81818 .37349 L
.81918 .37102 L
.82018 .36874 L
.82118 .36666 L
.82218 .36479 L
.82318 .36313 L
.82418 .36168 L
.82517 .36046 L
.82617 .35944 L
.82717 .35863 L
.82817 .35802 L
.82917 .3576 L
.83017 .35735 L
.83117 .35728 L
.83217 .35736 L
.83317 .3576 L
.83417 .35798 L
.83516 .35849 L
.83616 .35913 L
.83716 .35989 L
.83816 .36075 L
.83916 .36173 L
.84016 .3628 L
.84116 .36397 L
.84216 .36524 L
.84316 .36658 L
.84416 .36801 L
.84515 .36952 L
.84615 .37109 L
.84715 .37274 L
.84815 .37444 L
Mistroke
.84915 .42689 L
.85015 .42321 L
.85115 .41885 L
.85215 .41389 L
.85315 .40842 L
.85415 .40257 L
.85514 .39645 L
.85614 .39019 L
.85714 .38392 L
.85814 .37777 L
.85914 .37184 L
.86014 .36622 L
.86114 .361 L
.86214 .35623 L
.86314 .35194 L
.86414 .34815 L
.86513 .34486 L
.86613 .34207 L
.86713 .33974 L
.86813 .33784 L
.86913 .33636 L
.87013 .33523 L
.87113 .33443 L
.87213 .33393 L
.87313 .33368 L
.87413 .33366 L
.87512 .33384 L
.87612 .3342 L
.87712 .3347 L
.87812 .33535 L
.87912 .33611 L
.88012 .33699 L
.88112 .33797 L
.88212 .33904 L
.88312 .34021 L
.88412 .34147 L
.88511 .34281 L
.88611 .34425 L
.88711 .34577 L
.88811 .34737 L
.88911 .34907 L
.89011 .35086 L
.89111 .35275 L
.89211 .35472 L
.89311 .35679 L
.89411 .35895 L
.8951 .36119 L
.8961 .36352 L
.8971 .36593 L
.8981 .3684 L
Mistroke
.8991 .42821 L
.9001 .43645 L
.9011 .44487 L
.9021 .45338 L
.9031 .46183 L
.9041 .47007 L
.90509 .47786 L
.90609 .48496 L
.90709 .49105 L
.90809 .49579 L
.90909 .49881 L
.91009 .49972 L
.91109 .49818 L
.91209 .49387 L
.91309 .48661 L
.91409 .47633 L
.91508 .46315 L
.91608 .44739 L
.91708 .42955 L
.91808 .41029 L
.91908 .39037 L
.92008 .37058 L
.92108 .35164 L
.92208 .33417 L
.92308 .31858 L
.92408 .30514 L
.92507 .29392 L
.92607 .28486 L
.92707 .27778 L
.92807 .27246 L
.92907 .26862 L
.93007 .266 L
.93107 .26435 L
.93207 .26345 L
.93307 .2631 L
.93407 .26314 L
.93506 .26344 L
.93606 .26389 L
.93706 .26442 L
.93806 .26495 L
.93906 .26544 L
.94006 .26585 L
.94106 .26616 L
.94206 .26635 L
.94306 .26641 L
.94406 .26633 L
.94505 .26611 L
.94605 .26574 L
.94705 .26523 L
.94805 .26458 L
Mistroke
.94905 .26497 L
.95005 .26268 L
.95105 .26022 L
.95205 .25757 L
.95305 .25473 L
.95405 .25168 L
.95504 .24843 L
.95604 .24496 L
.95704 .24126 L
.95804 .23734 L
.95904 .23318 L
.96004 .22879 L
.96104 .22417 L
.96204 .21933 L
.96304 .21429 L
.96404 .20907 L
.96503 .20371 L
.96603 .19824 L
.96703 .19273 L
.96803 .18724 L
.96903 .18186 L
.97003 .17669 L
.97103 .17183 L
.97203 .16743 L
.97303 .16363 L
.97403 .16056 L
.97502 .15838 L
.97602 .15724 L
.97702 .15725 L
.97802 .15853 L
.97902 .16114 L
.98002 .16512 L
.98102 .17043 L
.98202 .17702 L
.98302 .18476 L
.98402 .19349 L
.98501 .20303 L
.98601 .21316 L
.98701 .22366 L
.98801 .23428 L
.98901 .24482 L
.99001 .25505 L
.99101 .2648 L
.99201 .2739 L
.99301 .28224 L
.99401 .28973 L
.995 .29632 L
.996 .302 L
.997 .30679 L
.998 .31074 L
Mistroke
.999 .31198 L
Mfstroke
0 g
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .28002 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03864 0 m
.03896 .01353 L
.03996 .05895 L
.04096 .09824 L
.04196 .12212 L
.04296 .12619 L
.04396 .11383 L
.04496 .0931 L
.04595 .07152 L
.04695 .05358 L
.04795 .04078 L
.04895 .03282 L
.04995 .40271 L
.05095 .45341 L
.05195 .49882 L
.05295 .53545 L
.05395 .56018 L
.05495 .57118 L
.05594 .56862 L
.05694 .55465 L
.05794 .53291 L
.05894 .50742 L
.05994 .48165 L
.06094 .45803 L
.06194 .43792 L
.06294 .42192 L
.06394 .4101 L
.06494 .40218 L
.06593 .39775 L
.06693 .39626 L
.06793 .39704 L
.06893 .39936 L
.06993 .40235 L
.07093 .40507 L
.07193 .40662 L
.07293 .40621 L
.07393 .40324 L
.07493 .39742 L
.07592 .38875 L
.07692 .37754 L
.07792 .36431 L
.07892 .34978 L
.07992 .33472 L
.08092 .31986 L
.08192 .3058 L
.08292 .29295 L
.08392 .28152 L
.08492 .27149 L
.08591 .26267 L
.08691 .25475 L
Mistroke
.08791 .24737 L
.08891 .24018 L
.08991 .23291 L
.09091 .22536 L
.09191 .21744 L
.09291 .20918 L
.09391 .20069 L
.09491 .19209 L
.0959 .18352 L
.0969 .17509 L
.0979 .16683 L
.0989 .15874 L
.0999 .22517 L
.1009 .21782 L
.1019 .21173 L
.1029 .20625 L
.1039 .20118 L
.1049 .19643 L
.10589 .19194 L
.10689 .18769 L
.10789 .18364 L
.10889 .17979 L
.10989 .17611 L
.11089 .1726 L
.11189 .16925 L
.11289 .16605 L
.11389 .16298 L
.11489 .16002 L
.11588 .15717 L
.11688 .15439 L
.11788 .15167 L
.11888 .14898 L
.11988 .14629 L
.12088 .14356 L
.12188 .14078 L
.12288 .13792 L
.12388 .13495 L
.12488 .13186 L
.12587 .12865 L
.12687 .12532 L
.12787 .12189 L
.12887 .1184 L
.12987 .11489 L
.13087 .11144 L
.13187 .10816 L
.13287 .10515 L
.13387 .10257 L
.13487 .10059 L
.13586 .0994 L
.13686 .09922 L
Mistroke
.13786 .10026 L
.13886 .10274 L
.13986 .10687 L
.14086 .11279 L
.14186 .12063 L
.14286 .13044 L
.14386 .14215 L
.14486 .15564 L
.14585 .17062 L
.14685 .18669 L
.14785 .20329 L
.14885 .2197 L
.14985 .39727 L
.15085 .39428 L
.15185 .38912 L
.15285 .3819 L
.15385 .37314 L
.15485 .36342 L
.15584 .35327 L
.15684 .3431 L
.15784 .3332 L
.15884 .32375 L
.15984 .31483 L
.16084 .30649 L
.16184 .29869 L
.16284 .29141 L
.16384 .28457 L
.16484 .27814 L
.16583 .27205 L
.16683 .26625 L
.16783 .2607 L
.16883 .25537 L
.16983 .25022 L
.17083 .24525 L
.17183 .24041 L
.17283 .23572 L
.17383 .23114 L
.17483 .22668 L
.17582 .22233 L
.17682 .21809 L
.17782 .21394 L
.17882 .20989 L
.17982 .20593 L
.18082 .20206 L
.18182 .19827 L
.18282 .19456 L
.18382 .19094 L
.18482 .18738 L
.18581 .18389 L
.18681 .18047 L
Mistroke
.18781 .1771 L
.18881 .17379 L
.18981 .17051 L
.19081 .16728 L
.19181 .16407 L
.19281 .16089 L
.19381 .15773 L
.19481 .15457 L
.1958 .15143 L
.1968 .14828 L
.1978 .14513 L
.1988 .14199 L
.1998 .16774 L
.2008 .17055 L
.2018 .17615 L
.2028 .18389 L
.2038 .19356 L
.2048 .20502 L
.20579 .21814 L
.20679 .23277 L
.20779 .2487 L
.20879 .26569 L
.20979 .28342 L
.21079 .30149 L
.21179 .31943 L
.21279 .33668 L
.21379 .35263 L
.21479 .36665 L
.21578 .37816 L
.21678 .38668 L
.21778 .3919 L
.21878 .39378 L
.21978 .39249 L
.22078 .38849 L
.22178 .38237 L
.22278 .37479 L
.22378 .36634 L
.22478 .35751 L
.22577 .34864 L
.22677 .33994 L
.22777 .33152 L
.22877 .32341 L
.22977 .31562 L
.23077 .30813 L
.23177 .30092 L
.23277 .29398 L
.23377 .28728 L
.23477 .2808 L
.23576 .27454 L
.23676 .26848 L
Mistroke
.23776 .2626 L
.23876 .25691 L
.23976 .25139 L
.24076 .24602 L
.24176 .24082 L
.24276 .23577 L
.24376 .23086 L
.24476 .2261 L
.24575 .22148 L
.24675 .21699 L
.24775 .21263 L
.24875 .2084 L
.24975 .23092 L
.25075 .22783 L
.25175 .22623 L
.25275 .22546 L
.25375 .22531 L
.25475 .22566 L
.25574 .22645 L
.25674 .22762 L
.25774 .22911 L
.25874 .2309 L
.25974 .23292 L
.26074 .23516 L
.26174 .23758 L
.26274 .24014 L
.26374 .24282 L
.26474 .2456 L
.26573 .24844 L
.26673 .25133 L
.26773 .25424 L
.26873 .25714 L
.26973 .26001 L
.27073 .2628 L
.27173 .26547 L
.27273 .26798 L
.27373 .27027 L
.27473 .2723 L
.27572 .274 L
.27672 .27534 L
.27772 .27625 L
.27872 .27671 L
.27972 .27669 L
.28072 .27618 L
.28172 .27518 L
.28272 .2737 L
.28372 .27176 L
.28472 .26941 L
.28571 .26668 L
.28671 .26362 L
Mistroke
.28771 .26027 L
.28871 .25669 L
.28971 .25291 L
.29071 .24897 L
.29171 .24491 L
.29271 .24076 L
.29371 .23655 L
.29471 .23229 L
.2957 .228 L
.2967 .2237 L
.2977 .2194 L
.2987 .21511 L
.2997 .2377 L
.3007 .23059 L
.3017 .22479 L
.3027 .21964 L
.3037 .21496 L
.3047 .21064 L
.30569 .20663 L
.30669 .20291 L
.30769 .19945 L
.30869 .19623 L
.30969 .19323 L
.31069 .19045 L
.31169 .18788 L
.31269 .18549 L
.31369 .18328 L
.31469 .18123 L
.31568 .17934 L
.31668 .1776 L
.31768 .176 L
.31868 .17456 L
.31968 .17327 L
.32068 .17215 L
.32168 .17123 L
.32268 .17054 L
.32368 .17012 L
.32468 .17003 L
.32567 .17032 L
.32667 .17108 L
.32767 .17237 L
.32867 .17428 L
.32967 .1769 L
.33067 .18028 L
.33167 .18451 L
.33267 .18961 L
.33367 .19562 L
.33467 .20249 L
.33566 .21016 L
.33666 .2185 L
Mistroke
.33766 .22732 L
.33866 .23635 L
.33966 .2453 L
.34066 .25379 L
.34166 .26143 L
.34266 .26785 L
.34366 .27274 L
.34466 .27589 L
.34565 .27726 L
.34665 .27698 L
.34765 .27529 L
.34865 .27249 L
.34965 .36126 L
.35065 .35837 L
.35165 .35512 L
.35265 .35102 L
.35365 .34607 L
.35465 .34037 L
.35564 .33407 L
.35664 .32732 L
.35764 .32027 L
.35864 .31305 L
.35964 .30575 L
.36064 .29846 L
.36164 .29124 L
.36264 .28414 L
.36364 .27716 L
.36464 .27035 L
.36563 .2637 L
.36663 .25721 L
.36763 .2509 L
.36863 .24475 L
.36963 .23876 L
.37063 .23293 L
.37163 .22725 L
.37263 .22172 L
.37363 .21634 L
.37463 .2111 L
.37562 .20601 L
.37662 .20105 L
.37762 .19623 L
.37862 .19155 L
.37962 .187 L
.38062 .18259 L
.38162 .17831 L
.38262 .17417 L
.38362 .17017 L
.38462 .16631 L
.38561 .16259 L
.38661 .15902 L
Mistroke
.38761 .15559 L
.38861 .15231 L
.38961 .14918 L
.39061 .14621 L
.39161 .1434 L
.39261 .14075 L
.39361 .13827 L
.39461 .13595 L
.3956 .1338 L
.3966 .13181 L
.3976 .12997 L
.3986 .1283 L
.3996 .11479 L
.4006 .11033 L
.4016 .10735 L
.4026 .10524 L
.4036 .10382 L
.4046 .10304 L
.40559 .10287 L
.40659 .1033 L
.40759 .10434 L
.40859 .106 L
.40959 .10828 L
.41059 .11121 L
.41159 .11479 L
.41259 .1191 L
.41359 .12421 L
.41459 .13025 L
.41558 .13736 L
.41658 .14573 L
.41758 .15557 L
.41858 .16714 L
.41958 .18064 L
.42058 .19629 L
.42158 .2142 L
.42258 .23435 L
.42358 .2565 L
.42458 .28015 L
.42557 .30443 L
.42657 .32812 L
.42757 .34963 L
.42857 .36716 L
.42957 .3789 L
.43057 .38372 L
.43157 .38192 L
.43257 .37532 L
.43357 .36617 L
.43457 .35623 L
.43556 .34656 L
.43656 .33763 L
Mistroke
.43756 .32953 L
.43856 .32215 L
.43956 .31531 L
.44056 .3088 L
.44156 .30245 L
.44256 .29614 L
.44356 .28983 L
.44456 .28351 L
.44555 .27721 L
.44655 .27096 L
.44755 .26481 L
.44855 .25878 L
.44955 .30281 L
.45055 .29445 L
.45155 .28765 L
.45255 .28167 L
.45355 .27626 L
.45455 .27127 L
.45554 .26661 L
.45654 .26221 L
.45754 .25804 L
.45854 .25406 L
.45954 .25023 L
.46054 .24655 L
.46154 .24298 L
.46254 .23953 L
.46354 .23618 L
.46454 .23292 L
.46553 .22974 L
.46653 .22665 L
.46753 .22364 L
.46853 .22071 L
.46953 .21785 L
.47053 .21508 L
.47153 .21238 L
.47253 .20976 L
.47353 .20723 L
.47453 .20478 L
.47552 .20242 L
.47652 .20016 L
.47752 .19801 L
.47852 .19597 L
.47952 .19404 L
.48052 .19225 L
.48152 .1906 L
.48252 .1891 L
.48352 .18777 L
.48452 .18662 L
.48551 .18567 L
.48651 .18492 L
Mistroke
.48751 .1844 L
.48851 .18411 L
.48951 .18407 L
.49051 .18429 L
.49151 .18477 L
.49251 .18553 L
.49351 .18654 L
.49451 .18782 L
.4955 .18935 L
.4965 .1911 L
.4975 .19305 L
.4985 .19517 L
.4995 .38195 L
.5005 .38118 L
.5015 .37899 L
.5025 .37501 L
.5035 .36939 L
.5045 .36244 L
.50549 .35448 L
.50649 .34585 L
.50749 .33683 L
.50849 .32767 L
.50949 .31855 L
.51049 .30959 L
.51149 .30088 L
.51249 .29246 L
.51349 .28436 L
.51449 .27658 L
.51548 .26911 L
.51648 .26193 L
.51748 .25503 L
.51848 .24837 L
.51948 .24195 L
.52048 .23574 L
.52148 .22974 L
.52248 .22392 L
.52348 .21827 L
.52448 .21279 L
.52547 .20746 L
.52647 .20228 L
.52747 .19725 L
.52847 .19234 L
.52947 .18757 L
.53047 .18291 L
.53147 .17837 L
.53247 .17394 L
.53347 .1696 L
.53447 .16535 L
.53546 .16118 L
.53646 .15707 L
Mistroke
.53746 .15301 L
.53846 .14899 L
.53946 .14498 L
.54046 .14096 L
.54146 .13691 L
.54246 .1328 L
.54346 .1286 L
.54446 .12429 L
.54545 .11984 L
.54645 .11521 L
.54745 .11037 L
.54845 .10531 L
.54945 .12532 L
.55045 .12157 L
.55145 .11963 L
.55245 .11885 L
.55345 .11909 L
.55445 .12029 L
.55544 .12243 L
.55644 .12553 L
.55744 .12959 L
.55844 .13466 L
.55944 .14076 L
.56044 .14796 L
.56144 .15633 L
.56244 .16597 L
.56344 .177 L
.56444 .18953 L
.56543 .20367 L
.56643 .21947 L
.56743 .23693 L
.56843 .25594 L
.56943 .27622 L
.57043 .29731 L
.57143 .31853 L
.57243 .33895 L
.57343 .35744 L
.57443 .37275 L
.57542 .38368 L
.57642 .38934 L
.57742 .38957 L
.57842 .38513 L
.57942 .37742 L
.58042 .36796 L
.58142 .3579 L
.58242 .348 L
.58342 .33862 L
.58442 .32987 L
.58541 .32172 L
.58641 .31405 L
Mistroke
.58741 .30675 L
.58841 .2997 L
.58941 .29283 L
.59041 .28609 L
.59141 .27946 L
.59241 .27295 L
.59341 .26656 L
.59441 .2603 L
.5954 .25419 L
.5964 .24823 L
.5974 .24243 L
.5984 .23679 L
.5994 .24857 L
.6004 .24104 L
.6014 .2351 L
.6024 .23003 L
.6034 .2256 L
.6044 .2217 L
.60539 .21823 L
.60639 .21516 L
.60739 .21245 L
.60839 .21005 L
.60939 .20795 L
.61039 .20613 L
.61139 .20456 L
.61239 .20324 L
.61339 .20215 L
.61439 .20128 L
.61538 .20063 L
.61638 .2002 L
.61738 .20001 L
.61838 .20005 L
.61938 .20034 L
.62038 .20091 L
.62138 .20177 L
.62238 .20296 L
.62338 .20449 L
.62438 .20639 L
.62537 .20869 L
.62637 .21138 L
.62737 .21449 L
.62837 .218 L
.62937 .22189 L
.63037 .22612 L
.63137 .23063 L
.63237 .23533 L
.63337 .24011 L
.63437 .24485 L
.63536 .24941 L
.63636 .25362 L
Mistroke
.63736 .25735 L
.63836 .26043 L
.63936 .26275 L
.64036 .26423 L
.64136 .26482 L
.64236 .26453 L
.64336 .26341 L
.64436 .26154 L
.64535 .25902 L
.64635 .25598 L
.64735 .25251 L
.64835 .24873 L
.64935 .22721 L
.65035 .21983 L
.65135 .2138 L
.65235 .20847 L
.65335 .20363 L
.65435 .19918 L
.65534 .19507 L
.65634 .19127 L
.65734 .18776 L
.65834 .18451 L
.65934 .1815 L
.66034 .17874 L
.66134 .17619 L
.66234 .17385 L
.66334 .17171 L
.66434 .16976 L
.66533 .16798 L
.66633 .16638 L
.66733 .16495 L
.66833 .16369 L
.66933 .16262 L
.67033 .16177 L
.67133 .16116 L
.67233 .16084 L
.67333 .16086 L
.67433 .16129 L
.67532 .1622 L
.67632 .16368 L
.67732 .16582 L
.67832 .16873 L
.67932 .17249 L
.68032 .17719 L
.68132 .1829 L
.68232 .18966 L
.68332 .19746 L
.68432 .20625 L
.68531 .2159 L
.68631 .22622 L
Mistroke
.68731 .23691 L
.68831 .2476 L
.68931 .25783 L
.69031 .2671 L
.69131 .27487 L
.69231 .28067 L
.69331 .28421 L
.69431 .28544 L
.6953 .28454 L
.6963 .28193 L
.6973 .27805 L
.6983 .27333 L
.6993 .33184 L
.7003 .3212 L
.7013 .31166 L
.7023 .30266 L
.7033 .29405 L
.7043 .28577 L
.70529 .27778 L
.70629 .27008 L
.70729 .26263 L
.70829 .25544 L
.70929 .24848 L
.71029 .24175 L
.71129 .23523 L
.71229 .2289 L
.71329 .22277 L
.71429 .21683 L
.71528 .21106 L
.71628 .20545 L
.71728 .20002 L
.71828 .19474 L
.71928 .18962 L
.72028 .18465 L
.72128 .17984 L
.72228 .17517 L
.72328 .17066 L
.72428 .16629 L
.72527 .16207 L
.72627 .15799 L
.72727 .15407 L
.72827 .1503 L
.72927 .14668 L
.73027 .14323 L
.73127 .13993 L
.73227 .1368 L
.73327 .13383 L
.73427 .13104 L
.73526 .12843 L
.73626 .126 L
Mistroke
.73726 .12375 L
.73826 .12169 L
.73926 .11981 L
.74026 .11812 L
.74126 .1166 L
.74226 .11526 L
.74326 .11408 L
.74426 .11306 L
.74525 .11218 L
.74625 .11146 L
.74725 .1109 L
.74825 .11051 L
.74925 .13692 L
.75025 .14573 L
.75125 .15797 L
.75225 .17305 L
.75325 .19078 L
.75425 .21099 L
.75524 .23347 L
.75624 .25792 L
.75724 .28388 L
.75824 .31075 L
.75924 .33771 L
.76024 .36376 L
.76124 .38774 L
.76224 .40843 L
.76324 .42463 L
.76424 .4354 L
.76523 .44018 L
.76623 .43901 L
.76723 .43256 L
.76823 .4221 L
.76923 .40915 L
.77023 .39512 L
.77123 .38113 L
.77223 .36785 L
.77323 .35561 L
.77423 .34448 L
.77522 .3344 L
.77622 .32526 L
.77722 .31691 L
.77822 .30925 L
.77922 .30219 L
.78022 .29566 L
.78122 .28958 L
.78222 .28391 L
.78322 .27861 L
.78422 .27362 L
.78521 .26893 L
.78621 .2645 L
Mistroke
.78721 .26031 L
.78821 .25633 L
.78921 .25255 L
.79021 .24896 L
.79121 .24553 L
.79221 .24225 L
.79321 .23911 L
.79421 .23608 L
.7952 .23317 L
.7962 .23035 L
.7972 .22761 L
.7982 .22494 L
.7992 .27829 L
.8002 .27697 L
.8012 .27692 L
.8022 .27742 L
.8032 .27819 L
.8042 .27907 L
.80519 .27995 L
.80619 .28076 L
.80719 .28143 L
.80819 .28191 L
.80919 .28216 L
.81019 .28215 L
.81119 .28186 L
.81219 .28129 L
.81319 .28042 L
.81419 .27927 L
.81518 .27784 L
.81618 .27614 L
.81718 .27418 L
.81818 .272 L
.81918 .26959 L
.82018 .26699 L
.82118 .26421 L
.82218 .26128 L
.82318 .2582 L
.82418 .25501 L
.82517 .25171 L
.82617 .24832 L
.82717 .24486 L
.82817 .24135 L
.82917 .23778 L
.83017 .23419 L
.83117 .23057 L
.83217 .22693 L
.83317 .22329 L
.83417 .21964 L
.83516 .216 L
.83616 .21237 L
Mistroke
.83716 .20874 L
.83816 .20514 L
.83916 .20155 L
.84016 .19798 L
.84116 .19444 L
.84216 .19092 L
.84316 .18742 L
.84416 .18394 L
.84515 .18049 L
.84615 .17707 L
.84715 .17369 L
.84815 .17034 L
.84915 .30711 L
.85015 .30947 L
.85115 .31243 L
.85215 .3152 L
.85315 .3175 L
.85415 .31916 L
.85514 .32009 L
.85614 .32023 L
.85714 .31958 L
.85814 .31816 L
.85914 .316 L
.86014 .31317 L
.86114 .30974 L
.86214 .30579 L
.86314 .3014 L
.86414 .29665 L
.86513 .29162 L
.86613 .28636 L
.86713 .28095 L
.86813 .27543 L
.86913 .26984 L
.87013 .26423 L
.87113 .25863 L
.87213 .25305 L
.87313 .24751 L
.87413 .24203 L
.87512 .23663 L
.87612 .2313 L
.87712 .22605 L
.87812 .2209 L
.87912 .21583 L
.88012 .21085 L
.88112 .20595 L
.88212 .20115 L
.88312 .19643 L
.88412 .19178 L
.88511 .18721 L
.88611 .18271 L
Mistroke
.88711 .17826 L
.88811 .17385 L
.88911 .16948 L
.89011 .16514 L
.89111 .1608 L
.89211 .15645 L
.89311 .15207 L
.89411 .14765 L
.8951 .14317 L
.8961 .1386 L
.8971 .13394 L
.8981 .12916 L
.8991 .15128 L
.9001 .1523 L
.9011 .15555 L
.9021 .1604 L
.9031 .16671 L
.9041 .1744 L
.90509 .18343 L
.90609 .19376 L
.90709 .20534 L
.90809 .21813 L
.90909 .23203 L
.91009 .24692 L
.91109 .26264 L
.91209 .27895 L
.91309 .29553 L
.91409 .31197 L
.91508 .3278 L
.91608 .34246 L
.91708 .35535 L
.91808 .36589 L
.91908 .37356 L
.92008 .37799 L
.92108 .37903 L
.92208 .37683 L
.92308 .37181 L
.92408 .36461 L
.92507 .35594 L
.92607 .34646 L
.92707 .33668 L
.92807 .32698 L
.92907 .31756 L
.93007 .30854 L
.93107 .29995 L
.93207 .29178 L
.93307 .28399 L
.93407 .27655 L
.93506 .26939 L
.93606 .26249 L
Mistroke
.93706 .25581 L
.93806 .24932 L
.93906 .243 L
.94006 .23683 L
.94106 .23079 L
.94206 .22489 L
.94306 .21909 L
.94406 .21341 L
.94505 .20783 L
.94605 .20235 L
.94705 .19696 L
.94805 .19165 L
.94905 .20043 L
.95005 .19329 L
.95105 .18754 L
.95205 .18254 L
.95305 .17808 L
.95405 .17407 L
.95504 .17046 L
.95604 .16722 L
.95704 .16431 L
.95804 .16173 L
.95904 .15946 L
.96004 .15749 L
.96104 .1558 L
.96204 .15438 L
.96304 .15322 L
.96404 .15231 L
.96503 .15166 L
.96603 .15127 L
.96703 .15116 L
.96803 .15138 L
.96903 .15197 L
.97003 .153 L
.97103 .15455 L
.97203 .15673 L
.97303 .15966 L
.97403 .16345 L
.97502 .16825 L
.97602 .1742 L
.97702 .18141 L
.97802 .18998 L
.97902 .19995 L
.98002 .2113 L
.98102 .2239 L
.98202 .23752 L
.98302 .25177 L
.98402 .26613 L
.98501 .27993 L
.98601 .29235 L
Mistroke
.98701 .30252 L
.98801 .30961 L
.98901 .31313 L
.99001 .31312 L
.99101 .31013 L
.99201 .30501 L
.99301 .29859 L
.99401 .29151 L
.995 .28423 L
.996 .27702 L
.997 .27003 L
.998 .26333 L
.999 .28002 L
Mfstroke
gsave
.999 .29263 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .01629 L
.004 .01789 L
.005 .01925 L
.00599 .02046 L
.00699 .02156 L
.00799 .02259 L
.00899 .02357 L
.00999 .02454 L
.01099 .02555 L
.01199 .02662 L
.01299 .02781 L
.01399 .02919 L
.01499 .03085 L
.01598 .03292 L
.01698 .03557 L
.01798 .03904 L
.01898 .04362 L
.01998 .04971 L
.02098 .05779 L
.02198 .0684 L
.02298 .08218 L
.02398 .09984 L
.02498 .12214 L
.02597 .14992 L
.02697 .18406 L
.02797 .22539 L
.02897 .2746 L
.02997 .33206 L
.03097 .39759 L
.03197 .47013 L
.03297 .5475 L
s
.03297 .5475 m
.03386 .61803 L
s
.04945 .61803 m
.04995 .41548 L
.05095 .47887 L
.05195 .53999 L
.05295 .59395 L
s
.05295 .59395 m
.05351 .61803 L
s
.09941 .61803 m
.0999 .23794 L
.1009 .23838 L
.1019 .23772 L
.1029 .23663 L
.1039 .23531 L
.1049 .23387 L
.10589 .23238 L
.10689 .23088 L
.10789 .22942 L
.10889 .22802 L
.10989 .22673 L
.11089 .22556 L
.11189 .22455 L
.11289 .22375 L
.11389 .22319 L
.11489 .22293 L
.11588 .22301 L
.11688 .22351 L
.11788 .22448 L
.11888 .22601 L
.11988 .22818 L
.12088 .23108 L
.12188 .2348 L
.12288 .23943 L
.12388 .24507 L
.12488 .2518 L
.12587 .25968 L
.12687 .26878 L
.12787 .27913 L
.12887 .29073 L
.12987 .30355 L
.13087 .31752 L
.13187 .33251 L
.13287 .34832 L
.13387 .36471 L
.13487 .38135 L
.13586 .39787 L
.13686 .41385 L
.13786 .42883 L
.13886 .44236 L
.13986 .45401 L
.14086 .46342 L
.14186 .47031 L
.14286 .47453 L
.14386 .47607 L
.14486 .47508 L
.14585 .47186 L
.14685 .46685 L
.14785 .46064 L
Mistroke
.14885 .45397 L
.14985 .40993 L
.15085 .41482 L
.15185 .41534 L
.15285 .41277 L
.15385 .40805 L
.15485 .40193 L
.15584 .395 L
.15684 .38775 L
.15784 .38048 L
.15884 .37343 L
.15984 .36673 L
.16084 .36043 L
.16184 .35456 L
.16284 .34912 L
.16384 .34407 L
.16484 .33939 L
.16583 .33503 L
.16683 .33096 L
.16783 .32714 L
.16883 .32354 L
.16983 .32015 L
.17083 .31693 L
.17183 .31386 L
.17283 .31094 L
.17383 .30815 L
.17483 .3055 L
.17582 .30296 L
.17682 .30055 L
.17782 .29826 L
.17882 .29611 L
.17982 .29408 L
.18082 .2922 L
.18182 .29047 L
.18282 .2889 L
.18382 .28751 L
.18482 .2863 L
.18581 .2853 L
.18681 .28452 L
.18781 .28398 L
.18881 .28371 L
.18981 .28371 L
.19081 .28403 L
.19181 .28467 L
.19281 .28566 L
.19381 .28704 L
.19481 .28881 L
.1958 .291 L
.1968 .29364 L
.1978 .29673 L
Mistroke
.1988 .30029 L
.1998 .18042 L
.2008 .19108 L
.2018 .20236 L
.2028 .21509 L
.2038 .22966 L
.2048 .24631 L
.20579 .26517 L
.20679 .28625 L
.20779 .30938 L
.20879 .33421 L
.20979 .36013 L
.21079 .38635 L
.21179 .41185 L
.21279 .43553 L
.21379 .45629 L
.21479 .47318 L
.21578 .48552 L
.21678 .49302 L
.21778 .49583 L
.21878 .49442 L
.21978 .48953 L
.22078 .482 L
.22178 .47264 L
.22278 .46221 L
.22378 .4513 L
.22478 .44043 L
.22577 .42996 L
.22677 .42014 L
.22777 .41114 L
.22877 .40302 L
.22977 .39577 L
.23077 .38934 L
.23177 .38362 L
.23277 .37853 L
.23377 .37394 L
.23477 .36976 L
.23576 .3659 L
.23676 .36229 L
.23776 .35885 L
.23876 .35554 L
.23976 .35232 L
.24076 .34916 L
.24176 .34606 L
.24276 .34299 L
.24376 .33994 L
.24476 .33693 L
.24575 .33395 L
.24675 .33102 L
.24775 .32813 L
Mistroke
.24875 .32529 L
.24975 .24359 L
.25075 .24829 L
.25175 .25218 L
.25275 .25595 L
.25375 .25984 L
.25475 .26399 L
.25574 .26849 L
.25674 .2734 L
.25774 .27877 L
.25874 .28462 L
.25974 .29096 L
.26074 .29779 L
.26174 .30506 L
.26274 .31273 L
.26374 .3207 L
.26474 .32887 L
.26573 .33711 L
.26673 .34529 L
.26773 .35323 L
.26873 .3608 L
.26973 .36783 L
.27073 .37417 L
.27173 .37972 L
.27273 .38436 L
.27373 .38804 L
.27473 .39073 L
.27572 .39243 L
.27672 .39319 L
.27772 .39306 L
.27872 .39214 L
.27972 .39052 L
.28072 .38831 L
.28172 .3856 L
.28272 .3825 L
.28372 .37908 L
.28472 .37544 L
.28571 .37162 L
.28671 .36767 L
.28771 .36366 L
.28871 .35959 L
.28971 .35551 L
.29071 .35143 L
.29171 .34738 L
.29271 .34338 L
.29371 .33942 L
.29471 .33554 L
.2957 .33175 L
.2967 .32804 L
.2977 .32445 L
Mistroke
.2987 .32097 L
.2997 .25035 L
.3007 .25098 L
.3017 .25057 L
.3027 .24977 L
.3037 .24882 L
.3047 .24783 L
.30569 .24688 L
.30669 .24604 L
.30769 .24535 L
.30869 .24488 L
.30969 .24466 L
.31069 .24475 L
.31169 .2452 L
.31269 .24606 L
.31369 .2474 L
.31469 .24927 L
.31568 .25173 L
.31668 .25484 L
.31768 .25865 L
.31868 .26321 L
.31968 .26856 L
.32068 .27473 L
.32168 .28171 L
.32268 .2895 L
.32368 .29808 L
.32468 .30736 L
.32567 .31728 L
.32667 .32769 L
.32767 .33845 L
.32867 .34937 L
.32967 .36023 L
.33067 .3708 L
.33167 .38081 L
.33267 .39004 L
.33367 .39825 L
.33467 .40525 L
.33566 .41089 L
.33666 .41511 L
.33766 .4179 L
.33866 .41937 L
.33966 .41969 L
.34066 .41911 L
.34166 .41793 L
.34266 .41649 L
.34366 .41505 L
.34466 .41383 L
.34565 .41286 L
.34665 .41207 L
.34765 .41129 L
Mistroke
.34865 .41031 L
.34965 .37388 L
.35065 .37883 L
.35165 .38113 L
.35265 .38156 L
.35365 .3805 L
.35465 .37824 L
.35564 .37503 L
.35664 .37107 L
.35764 .36656 L
.35864 .36165 L
.35964 .35647 L
.36064 .35111 L
.36164 .34567 L
.36264 .3402 L
.36364 .33475 L
.36464 .32934 L
.36563 .324 L
.36663 .31875 L
.36763 .31358 L
.36863 .30852 L
.36963 .30356 L
.37063 .29871 L
.37163 .29396 L
.37263 .28932 L
.37363 .28478 L
.37463 .28035 L
.37562 .27602 L
.37662 .2718 L
.37762 .26769 L
.37862 .26369 L
.37962 .2598 L
.38062 .25602 L
.38162 .25237 L
.38262 .24883 L
.38362 .24543 L
.38462 .24216 L
.38561 .23904 L
.38661 .23608 L
.38761 .23328 L
.38861 .23066 L
.38961 .22824 L
.39061 .22605 L
.39161 .2241 L
.39261 .22242 L
.39361 .22106 L
.39461 .22005 L
.3956 .21944 L
.3966 .2193 L
.3976 .21969 L
Mistroke
.3986 .22068 L
.3996 .12744 L
.4006 .1307 L
.4016 .13309 L
.4026 .13533 L
.4036 .13772 L
.4046 .14045 L
.40559 .14371 L
.40659 .1477 L
.40759 .15261 L
.40859 .15869 L
.40959 .1662 L
.41059 .1754 L
.41159 .18659 L
.41259 .20002 L
.41359 .21593 L
.41459 .23448 L
.41558 .25574 L
.41658 .27965 L
.41758 .30595 L
.41858 .3342 L
.41958 .36365 L
.42058 .39334 L
.42158 .42204 L
.42258 .44839 L
.42358 .47101 L
.42458 .4887 L
.42557 .5007 L
.42657 .50683 L
.42757 .50768 L
.42857 .50458 L
.42957 .4994 L
.43057 .49384 L
.43157 .48855 L
.43257 .48295 L
.43357 .47611 L
.43457 .46756 L
.43556 .45742 L
.43656 .4462 L
.43756 .43452 L
.43856 .423 L
.43956 .41213 L
.44056 .40225 L
.44156 .39355 L
.44256 .38605 L
.44356 .37971 L
.44456 .37437 L
.44555 .36987 L
.44655 .36601 L
.44755 .36265 L
Mistroke
.44855 .35963 L
.44955 .31544 L
.45055 .31487 L
.45155 .3135 L
.45255 .31194 L
.45355 .31033 L
.45455 .30874 L
.45554 .30721 L
.45654 .30573 L
.45754 .30432 L
.45854 .303 L
.45954 .30175 L
.46054 .3006 L
.46154 .29955 L
.46254 .29861 L
.46354 .29779 L
.46454 .2971 L
.46553 .29655 L
.46653 .29616 L
.46753 .29592 L
.46853 .29586 L
.46953 .29598 L
.47053 .29629 L
.47153 .2968 L
.47253 .29752 L
.47353 .29846 L
.47453 .29961 L
.47552 .30099 L
.47652 .30259 L
.47752 .30442 L
.47852 .30647 L
.47952 .30873 L
.48052 .31121 L
.48152 .31388 L
.48252 .31672 L
.48352 .31973 L
.48452 .32288 L
.48551 .32615 L
.48651 .3295 L
.48751 .33292 L
.48851 .33635 L
.48951 .33978 L
.49051 .34316 L
.49151 .34647 L
.49251 .34967 L
.49351 .35272 L
.49451 .35561 L
.4955 .35831 L
.4965 .3608 L
.4975 .36308 L
Mistroke
.4985 .36514 L
.4995 .39461 L
.5005 .40168 L
.5015 .40504 L
.5025 .40559 L
.5035 .40386 L
.5045 .40031 L
.50549 .39537 L
.50649 .38944 L
.50749 .38284 L
.50849 .37586 L
.50949 .3687 L
.51049 .36152 L
.51149 .35443 L
.51249 .34751 L
.51349 .34079 L
.51449 .33429 L
.51548 .32803 L
.51648 .322 L
.51748 .31619 L
.51848 .3106 L
.51948 .30521 L
.52048 .30001 L
.52148 .29499 L
.52248 .29014 L
.52348 .28546 L
.52448 .28095 L
.52547 .27659 L
.52647 .2724 L
.52747 .26837 L
.52847 .26451 L
.52947 .26082 L
.53047 .25731 L
.53147 .25399 L
.53247 .25087 L
.53347 .24798 L
.53447 .24532 L
.53546 .24292 L
.53646 .24081 L
.53746 .23902 L
.53846 .23759 L
.53946 .23655 L
.54046 .23595 L
.54146 .23585 L
.54246 .2363 L
.54346 .23736 L
.54446 .23909 L
.54545 .24157 L
.54645 .24487 L
.54745 .24905 L
Mistroke
.54845 .25419 L
.54945 .13796 L
.55045 .14196 L
.55145 .14542 L
.55245 .14911 L
.55345 .15335 L
.55445 .15841 L
.55544 .16452 L
.55644 .17194 L
.55744 .18093 L
.55844 .19176 L
.55944 .20469 L
.56044 .21994 L
.56144 .23769 L
.56244 .25799 L
.56344 .28077 L
.56444 .30581 L
.56543 .33264 L
.56643 .36058 L
.56743 .38872 L
.56843 .41592 L
.56943 .44096 L
.57043 .46258 L
.57143 .47975 L
.57243 .49179 L
.57343 .49856 L
.57443 .50051 L
.57542 .49864 L
.57642 .49418 L
.57742 .48818 L
.57842 .4811 L
.57942 .47291 L
.58042 .46352 L
.58142 .45304 L
.58242 .44181 L
.58342 .43026 L
.58442 .41887 L
.58541 .40803 L
.58641 .39801 L
.58741 .38898 L
.58841 .38102 L
.58941 .37409 L
.59041 .36811 L
.59141 .36296 L
.59241 .35851 L
.59341 .35461 L
.59441 .35117 L
.5954 .34806 L
.5964 .3452 L
.5974 .34253 L
Mistroke
.5984 .33999 L
.5994 .2612 L
.6004 .26144 L
.6014 .26089 L
.6024 .2602 L
.6034 .25956 L
.6044 .25907 L
.60539 .25879 L
.60639 .25877 L
.60739 .25906 L
.60839 .25968 L
.60939 .26067 L
.61039 .26209 L
.61139 .26395 L
.61239 .2663 L
.61339 .26916 L
.61439 .27256 L
.61538 .27652 L
.61638 .28104 L
.61738 .28612 L
.61838 .29175 L
.61938 .29789 L
.62038 .3045 L
.62138 .3115 L
.62238 .31882 L
.62338 .32637 L
.62438 .33402 L
.62537 .34164 L
.62637 .34911 L
.62737 .35629 L
.62837 .36303 L
.62937 .36922 L
.63037 .37473 L
.63137 .37949 L
.63237 .38343 L
.63337 .38654 L
.63437 .38883 L
.63536 .39034 L
.63636 .39117 L
.63736 .3914 L
.63836 .39116 L
.63936 .39055 L
.64036 .38968 L
.64136 .38861 L
.64236 .38738 L
.64336 .386 L
.64436 .38445 L
.64535 .3827 L
.64635 .38073 L
.64735 .3785 L
Mistroke
.64835 .376 L
.64935 .23983 L
.65035 .24019 L
.65135 .23952 L
.65235 .2385 L
.65335 .23734 L
.65435 .23617 L
.65534 .23507 L
.65634 .2341 L
.65734 .23331 L
.65834 .23276 L
.65934 .2325 L
.66034 .23257 L
.66134 .23305 L
.66234 .23399 L
.66334 .23545 L
.66434 .23749 L
.66533 .24019 L
.66633 .24361 L
.66733 .24781 L
.66833 .25284 L
.66933 .25874 L
.67033 .26555 L
.67133 .27327 L
.67233 .2819 L
.67333 .29138 L
.67433 .30166 L
.67532 .31263 L
.67632 .32414 L
.67732 .336 L
.67832 .34799 L
.67932 .35987 L
.68032 .37134 L
.68132 .38211 L
.68232 .3919 L
.68332 .40045 L
.68432 .40754 L
.68531 .41302 L
.68631 .41686 L
.68731 .41911 L
.68831 .41995 L
.68931 .41965 L
.69031 .41861 L
.69131 .41726 L
.69231 .41601 L
.69331 .41514 L
.69431 .41471 L
.6953 .41458 L
.6963 .41444 L
.6973 .41395 L
Mistroke
.6983 .41283 L
.6993 .34445 L
.7003 .34156 L
.7013 .3374 L
.7023 .33269 L
.7033 .32771 L
.7043 .32258 L
.70529 .31741 L
.70629 .31222 L
.70729 .30708 L
.70829 .30198 L
.70929 .29695 L
.71029 .29201 L
.71129 .28714 L
.71229 .28237 L
.71329 .27768 L
.71429 .27309 L
.71528 .26859 L
.71628 .26419 L
.71728 .25988 L
.71828 .25567 L
.71928 .25157 L
.72028 .24756 L
.72128 .24366 L
.72228 .23986 L
.72328 .23618 L
.72428 .23261 L
.72527 .22916 L
.72627 .22583 L
.72727 .22264 L
.72827 .21959 L
.72927 .21669 L
.73027 .21395 L
.73127 .21139 L
.73227 .20904 L
.73327 .2069 L
.73427 .205 L
.73526 .20339 L
.73626 .20209 L
.73726 .20116 L
.73826 .20064 L
.73926 .2006 L
.74026 .20112 L
.74126 .2023 L
.74226 .20422 L
.74326 .20701 L
.74426 .2108 L
.74525 .21573 L
.74625 .22194 L
.74725 .22959 L
Mistroke
.74825 .23882 L
.74925 .14962 L
.75025 .16626 L
.75125 .1843 L
.75225 .2047 L
.75325 .22793 L
.75425 .25422 L
.75524 .28352 L
.75624 .31552 L
.75724 .34948 L
.75824 .38432 L
.75924 .41854 L
.76024 .4504 L
.76124 .47811 L
.76224 .50006 L
.76324 .51513 L
.76424 .52294 L
.76523 .52387 L
.76623 .51893 L
.76723 .50946 L
.76823 .49683 L
.76923 .48228 L
.77023 .46688 L
.77123 .45157 L
.77223 .43707 L
.77323 .42395 L
.77423 .41252 L
.77522 .40294 L
.77622 .39516 L
.77722 .38905 L
.77822 .38436 L
.77922 .38084 L
.78022 .37823 L
.78122 .37629 L
.78222 .37478 L
.78322 .37353 L
.78422 .37237 L
.78521 .3712 L
.78621 .36991 L
.78721 .36843 L
.78821 .36673 L
.78921 .36476 L
.79021 .36254 L
.79121 .36006 L
.79221 .35733 L
.79321 .35439 L
.79421 .35126 L
.7952 .34799 L
.7962 .3446 L
.7972 .34114 L
Mistroke
.7982 .33764 L
.7992 .29093 L
.8002 .29741 L
.8012 .30288 L
.8022 .30796 L
.8032 .31281 L
.8042 .31748 L
.80519 .32198 L
.80619 .32628 L
.80719 .33035 L
.80819 .33416 L
.80919 .33766 L
.81019 .34082 L
.81119 .34359 L
.81219 .34595 L
.81319 .34788 L
.81419 .34936 L
.81518 .35038 L
.81618 .35095 L
.81718 .35108 L
.81818 .35079 L
.81918 .35011 L
.82018 .34906 L
.82118 .34769 L
.82218 .34604 L
.82318 .34413 L
.82418 .34201 L
.82517 .33973 L
.82617 .33731 L
.82717 .33479 L
.82817 .33221 L
.82917 .3296 L
.83017 .32698 L
.83117 .32439 L
.83217 .32185 L
.83317 .31938 L
.83417 .317 L
.83516 .31474 L
.83616 .31261 L
.83716 .31064 L
.83816 .30885 L
.83916 .30724 L
.84016 .30585 L
.84116 .30468 L
.84216 .30376 L
.84316 .3031 L
.84416 .30272 L
.84515 .30263 L
.84615 .30285 L
.84715 .30339 L
Mistroke
.84815 .30426 L
.84915 .31977 L
.85015 .32995 L
.85115 .33849 L
.85215 .34592 L
.85315 .35236 L
.85415 .35782 L
.85514 .36227 L
.85614 .36571 L
.85714 .36813 L
.85814 .36957 L
.85914 .37006 L
.86014 .36966 L
.86114 .36845 L
.86214 .36652 L
.86314 .36395 L
.86414 .36085 L
.86513 .3573 L
.86613 .35339 L
.86713 .3492 L
.86813 .34479 L
.86913 .34025 L
.87013 .3356 L
.87113 .33091 L
.87213 .32621 L
.87313 .32152 L
.87413 .31689 L
.87512 .31232 L
.87612 .30785 L
.87712 .30348 L
.87812 .29923 L
.87912 .29511 L
.88012 .29115 L
.88112 .28735 L
.88212 .28373 L
.88312 .2803 L
.88412 .27708 L
.88511 .27409 L
.88611 .27135 L
.88711 .26889 L
.88811 .26673 L
.88911 .26489 L
.89011 .26342 L
.89111 .26234 L
.89211 .26169 L
.89311 .26151 L
.89411 .26185 L
.8951 .26274 L
.8961 .26424 L
.8971 .26638 L
Mistroke
.8981 .26922 L
.8991 .16392 L
.9001 .17274 L
.9011 .18152 L
.9021 .19112 L
.9031 .20193 L
.9041 .21423 L
.90509 .22824 L
.90609 .24409 L
.90709 .26187 L
.90809 .28151 L
.90909 .30282 L
.91009 .32544 L
.91109 .34886 L
.91209 .37238 L
.91309 .39517 L
.91409 .41633 L
.91508 .43496 L
.91608 .45029 L
.91708 .46174 L
.91808 .46907 L
.91908 .47234 L
.92008 .47194 L
.92108 .46846 L
.92208 .46257 L
.92308 .45487 L
.92408 .44586 L
.92507 .43595 L
.92607 .42548 L
.92707 .41475 L
.92807 .40404 L
.92907 .39358 L
.93007 .38354 L
.93107 .37405 L
.93207 .36518 L
.93307 .35696 L
.93407 .34939 L
.93506 .34244 L
.93606 .33608 L
.93706 .33025 L
.93806 .32491 L
.93906 .32002 L
.94006 .31553 L
.94106 .3114 L
.94206 .30761 L
.94306 .30414 L
.94406 .30097 L
.94505 .29808 L
.94605 .29547 L
.94705 .29314 L
Mistroke
.94805 .2911 L
.94905 .21305 L
.95005 .21364 L
.95105 .21323 L
.95205 .21251 L
.95305 .21171 L
.95405 .21097 L
.95504 .21037 L
.95604 .21 L
.95704 .20993 L
.95804 .21023 L
.95904 .21099 L
.96004 .21228 L
.96104 .2142 L
.96204 .21685 L
.96304 .22032 L
.96404 .22472 L
.96503 .23015 L
.96603 .2367 L
.96703 .24444 L
.96803 .25343 L
.96903 .26369 L
.97003 .27523 L
.97103 .28798 L
.97203 .30184 L
.97303 .31664 L
.97403 .33214 L
.97502 .34803 L
.97602 .36393 L
.97702 .37941 L
.97802 .394 L
.97902 .40721 L
.98002 .41861 L
.98102 .42783 L
.98202 .43462 L
.98302 .43891 L
.98402 .44084 L
.98501 .44076 L
.98601 .43925 L
.98701 .43705 L
.98801 .43491 L
.98901 .43336 L
.99001 .4325 L
.99101 .43193 L
.99201 .43108 L
.99301 .4294 L
.99401 .42658 L
.995 .42251 L
.996 .41725 L
.997 .41096 L
Mistroke
.998 .40387 L
.999 .29263 L
Mfstroke
1 0 0 r
gsave
.999 .28633 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00166 L
.004 .00164 L
.005 .00164 L
.00599 .00167 L
.00699 .00173 L
.00799 .00183 L
.00899 .00199 L
.00999 .00221 L
.01099 .00251 L
.01199 .00291 L
.01299 .00343 L
.01399 .00412 L
.01499 .005 L
.01598 .00614 L
.01698 .00759 L
.01798 .00943 L
.01898 .01177 L
.01998 .01473 L
.02098 .01846 L
.02198 .02315 L
.02298 .02902 L
.02398 .03634 L
.02498 .04544 L
.02597 .05666 L
.02697 .0704 L
.02797 .08709 L
.02897 .10712 L
.02997 .13084 L
.03097 .15844 L
.03197 .1899 L
.03297 .22486 L
.03397 .26254 L
.03497 .30176 L
.03596 .34093 L
.03696 .37833 L
.03796 .41238 L
.03896 .4419 L
.03996 .4663 L
.04096 .48543 L
.04196 .49923 L
.04296 .5074 L
.04396 .50931 L
.04496 .50427 L
.04595 .49212 L
.04695 .47362 L
.04795 .45059 L
.04895 .42549 L
Mistroke
.04995 .40909 L
.05095 .46614 L
.05195 .5194 L
.05295 .5647 L
.05395 .59825 L
.05495 .61766 L
Mfstroke
.05495 .61766 m
.05502 .61803 L
s
.0566 .61803 m
.05694 .61556 L
.05794 .60017 L
.05894 .58123 L
.05994 .56302 L
.06094 .54865 L
.06194 .53984 L
.06294 .53705 L
.06394 .53981 L
.06494 .547 L
.06593 .55716 L
.06693 .56867 L
.06793 .57999 L
.06893 .58981 L
.06993 .59722 L
.07093 .60179 L
.07193 .60361 L
.07293 .60315 L
.07393 .60111 L
.07493 .5983 L
.07592 .59541 L
.07692 .59296 L
.07792 .59124 L
.07892 .59028 L
.07992 .58996 L
.08092 .59 L
.08192 .59013 L
.08292 .59008 L
.08392 .58969 L
.08492 .58891 L
.08591 .58782 L
.08691 .58657 L
.08791 .58537 L
.08891 .58439 L
.08991 .58375 L
.09091 .58349 L
.09191 .58358 L
.09291 .58391 L
.09391 .58434 L
.09491 .58471 L
.0959 .58492 L
.0969 .58489 L
.0979 .58461 L
.0989 .58412 L
.0999 .23155 L
.1009 .2281 L
.1019 .22473 L
.1029 .22144 L
.1039 .21824 L
.1049 .21515 L
Mistroke
.10589 .21216 L
.10689 .20929 L
.10789 .20653 L
.10889 .20391 L
.10989 .20142 L
.11089 .19908 L
.11189 .1969 L
.11289 .1949 L
.11389 .19309 L
.11489 .19148 L
.11588 .19009 L
.11688 .18895 L
.11788 .18808 L
.11888 .18749 L
.11988 .18723 L
.12088 .18732 L
.12188 .18779 L
.12288 .18868 L
.12388 .19001 L
.12488 .19183 L
.12587 .19416 L
.12687 .19705 L
.12787 .20051 L
.12887 .20456 L
.12987 .20922 L
.13087 .21448 L
.13187 .22033 L
.13287 .22674 L
.13387 .23364 L
.13487 .24097 L
.13586 .24864 L
.13686 .25653 L
.13786 .26455 L
.13886 .27255 L
.13986 .28044 L
.14086 .2881 L
.14186 .29547 L
.14286 .30248 L
.14386 .30911 L
.14486 .31536 L
.14585 .32124 L
.14685 .32677 L
.14785 .33197 L
.14885 .33683 L
.14985 .4036 L
.15085 .40455 L
.15185 .40223 L
.15285 .39734 L
.15385 .39059 L
.15485 .38267 L
Mistroke
.15584 .37414 L
.15684 .36542 L
.15784 .35684 L
.15884 .34859 L
.15984 .34078 L
.16084 .33346 L
.16184 .32663 L
.16284 .32026 L
.16384 .31432 L
.16484 .30876 L
.16583 .30354 L
.16683 .2986 L
.16783 .29392 L
.16883 .28946 L
.16983 .28519 L
.17083 .28109 L
.17183 .27714 L
.17283 .27333 L
.17383 .26965 L
.17483 .26609 L
.17582 .26265 L
.17682 .25932 L
.17782 .2561 L
.17882 .253 L
.17982 .25001 L
.18082 .24713 L
.18182 .24437 L
.18282 .24173 L
.18382 .23922 L
.18482 .23684 L
.18581 .2346 L
.18681 .23249 L
.18781 .23054 L
.18881 .22875 L
.18981 .22711 L
.19081 .22565 L
.19181 .22437 L
.19281 .22328 L
.19381 .22238 L
.19481 .22169 L
.1958 .22121 L
.1968 .22096 L
.1978 .22093 L
.1988 .22114 L
.1998 .17408 L
.2008 .18082 L
.2018 .18925 L
.2028 .19949 L
.2038 .21161 L
.2048 .22566 L
Mistroke
.20579 .24166 L
.20679 .25951 L
.20779 .27904 L
.20879 .29995 L
.20979 .32178 L
.21079 .34392 L
.21179 .36564 L
.21279 .38611 L
.21379 .40446 L
.21479 .41991 L
.21578 .43184 L
.21678 .43985 L
.21778 .44387 L
.21878 .4441 L
.21978 .44101 L
.22078 .43524 L
.22178 .42751 L
.22278 .4185 L
.22378 .40882 L
.22478 .39897 L
.22577 .3893 L
.22677 .38004 L
.22777 .37133 L
.22877 .36322 L
.22977 .35569 L
.23077 .34873 L
.23177 .34227 L
.23277 .33625 L
.23377 .33061 L
.23477 .32528 L
.23576 .32022 L
.23676 .31538 L
.23776 .31073 L
.23876 .30622 L
.23976 .30185 L
.24076 .29759 L
.24176 .29344 L
.24276 .28938 L
.24376 .2854 L
.24476 .28152 L
.24575 .27772 L
.24675 .274 L
.24775 .27038 L
.24875 .26685 L
.24975 .23725 L
.25075 .23806 L
.25175 .23921 L
.25275 .24071 L
.25375 .24258 L
.25475 .24483 L
Mistroke
.25574 .24747 L
.25674 .25051 L
.25774 .25394 L
.25874 .25776 L
.25974 .26194 L
.26074 .26648 L
.26174 .27132 L
.26274 .27643 L
.26374 .28176 L
.26474 .28723 L
.26573 .29278 L
.26673 .29831 L
.26773 .30374 L
.26873 .30897 L
.26973 .31392 L
.27073 .31848 L
.27173 .32259 L
.27273 .32617 L
.27373 .32916 L
.27473 .33151 L
.27572 .33322 L
.27672 .33426 L
.27772 .33466 L
.27872 .33443 L
.27972 .33361 L
.28072 .33224 L
.28172 .33039 L
.28272 .3281 L
.28372 .32542 L
.28472 .32242 L
.28571 .31915 L
.28671 .31565 L
.28771 .31196 L
.28871 .30814 L
.28971 .30421 L
.29071 .3002 L
.29171 .29615 L
.29271 .29207 L
.29371 .28799 L
.29471 .28392 L
.2957 .27987 L
.2967 .27587 L
.2977 .27192 L
.2987 .26804 L
.2997 .24402 L
.3007 .24079 L
.3017 .23768 L
.3027 .23471 L
.3037 .23189 L
.3047 .22923 L
Mistroke
.30569 .22676 L
.30669 .22448 L
.30769 .2224 L
.30869 .22055 L
.30969 .21895 L
.31069 .2176 L
.31169 .21654 L
.31269 .21577 L
.31369 .21534 L
.31469 .21525 L
.31568 .21553 L
.31668 .21622 L
.31768 .21733 L
.31868 .21889 L
.31968 .22091 L
.32068 .22344 L
.32168 .22647 L
.32268 .23002 L
.32368 .2341 L
.32468 .2387 L
.32567 .2438 L
.32667 .24939 L
.32767 .25541 L
.32867 .26183 L
.32967 .26856 L
.33067 .27554 L
.33167 .28266 L
.33267 .28983 L
.33367 .29693 L
.33467 .30387 L
.33566 .31053 L
.33666 .3168 L
.33766 .32261 L
.33866 .32786 L
.33966 .33249 L
.34066 .33645 L
.34166 .33968 L
.34266 .34217 L
.34366 .3439 L
.34466 .34486 L
.34565 .34506 L
.34665 .34453 L
.34765 .34329 L
.34865 .3414 L
.34965 .36757 L
.35065 .3686 L
.35165 .36812 L
.35265 .36629 L
.35365 .36329 L
.35465 .35931 L
Mistroke
.35564 .35455 L
.35664 .3492 L
.35764 .34342 L
.35864 .33735 L
.35964 .33111 L
.36064 .32479 L
.36164 .31846 L
.36264 .31217 L
.36364 .30596 L
.36464 .29984 L
.36563 .29385 L
.36663 .28798 L
.36763 .28224 L
.36863 .27664 L
.36963 .27116 L
.37063 .26582 L
.37163 .26061 L
.37263 .25552 L
.37363 .25056 L
.37463 .24573 L
.37562 .24101 L
.37662 .23643 L
.37762 .23196 L
.37862 .22762 L
.37962 .2234 L
.38062 .21931 L
.38162 .21534 L
.38262 .2115 L
.38362 .2078 L
.38462 .20424 L
.38561 .20082 L
.38661 .19755 L
.38761 .19443 L
.38861 .19148 L
.38961 .18871 L
.39061 .18613 L
.39161 .18375 L
.39261 .18159 L
.39361 .17966 L
.39461 .178 L
.3956 .17662 L
.3966 .17555 L
.3976 .17483 L
.3986 .17449 L
.3996 .12111 L
.4006 .12051 L
.4016 .12022 L
.4026 .12029 L
.4036 .12077 L
.4046 .12175 L
Mistroke
.40559 .12329 L
.40659 .1255 L
.40759 .12848 L
.40859 .13235 L
.40959 .13724 L
.41059 .1433 L
.41159 .15069 L
.41259 .15956 L
.41359 .17007 L
.41459 .18236 L
.41558 .19655 L
.41658 .21269 L
.41758 .23076 L
.41858 .25067 L
.41958 .27215 L
.42058 .29481 L
.42158 .31812 L
.42258 .34137 L
.42358 .36375 L
.42458 .38443 L
.42557 .40257 L
.42657 .41748 L
.42757 .42866 L
.42857 .43587 L
.42957 .43915 L
.43057 .43878 L
.43157 .43524 L
.43257 .42914 L
.43357 .42114 L
.43457 .4119 L
.43556 .40199 L
.43656 .39191 L
.43756 .38202 L
.43856 .37258 L
.43956 .36372 L
.44056 .35553 L
.44156 .348 L
.44256 .3411 L
.44356 .33477 L
.44456 .32894 L
.44555 .32354 L
.44655 .31849 L
.44755 .31373 L
.44855 .3092 L
.44955 .30913 L
.45055 .30466 L
.45155 .30058 L
.45255 .2968 L
.45355 .29329 L
.45455 .29001 L
Mistroke
.45554 .28691 L
.45654 .28397 L
.45754 .28118 L
.45854 .27853 L
.45954 .27599 L
.46054 .27357 L
.46154 .27127 L
.46254 .26907 L
.46354 .26698 L
.46454 .26501 L
.46553 .26315 L
.46653 .2614 L
.46753 .25978 L
.46853 .25828 L
.46953 .25692 L
.47053 .25568 L
.47153 .25459 L
.47253 .25364 L
.47353 .25284 L
.47453 .25219 L
.47552 .25171 L
.47652 .25138 L
.47752 .25121 L
.47852 .25122 L
.47952 .25139 L
.48052 .25173 L
.48152 .25224 L
.48252 .25291 L
.48352 .25375 L
.48452 .25475 L
.48551 .25591 L
.48651 .25721 L
.48751 .25866 L
.48851 .26023 L
.48951 .26193 L
.49051 .26373 L
.49151 .26562 L
.49251 .2676 L
.49351 .26963 L
.49451 .27172 L
.4955 .27383 L
.4965 .27595 L
.4975 .27807 L
.4985 .28015 L
.4995 .38828 L
.5005 .39143 L
.5015 .39202 L
.5025 .3903 L
.5035 .38663 L
.5045 .38137 L
Mistroke
.50549 .37493 L
.50649 .36764 L
.50749 .35984 L
.50849 .35176 L
.50949 .34362 L
.51049 .33555 L
.51149 .32766 L
.51249 .31999 L
.51349 .31258 L
.51449 .30544 L
.51548 .29857 L
.51648 .29197 L
.51748 .28561 L
.51848 .27949 L
.51948 .27358 L
.52048 .26787 L
.52148 .26236 L
.52248 .25703 L
.52348 .25187 L
.52448 .24687 L
.52547 .24203 L
.52647 .23734 L
.52747 .23281 L
.52847 .22843 L
.52947 .22419 L
.53047 .22011 L
.53147 .21618 L
.53247 .2124 L
.53347 .20879 L
.53447 .20533 L
.53546 .20205 L
.53646 .19894 L
.53746 .19602 L
.53846 .19329 L
.53946 .19076 L
.54046 .18846 L
.54146 .18638 L
.54246 .18455 L
.54346 .18298 L
.54446 .18169 L
.54545 .1807 L
.54645 .18004 L
.54745 .17971 L
.54845 .17975 L
.54945 .13164 L
.55045 .13177 L
.55145 .13252 L
.55245 .13398 L
.55345 .13622 L
.55445 .13935 L
Mistroke
.55544 .14348 L
.55644 .14873 L
.55744 .15526 L
.55844 .16321 L
.55944 .17272 L
.56044 .18395 L
.56144 .19701 L
.56244 .21198 L
.56344 .22889 L
.56444 .24767 L
.56543 .26815 L
.56643 .29003 L
.56743 .31282 L
.56843 .33593 L
.56943 .35859 L
.57043 .37995 L
.57143 .39914 L
.57243 .41537 L
.57343 .428 L
.57443 .43663 L
.57542 .44116 L
.57642 .44176 L
.57742 .43888 L
.57842 .43311 L
.57942 .42517 L
.58042 .41574 L
.58142 .40547 L
.58242 .3949 L
.58342 .38444 L
.58442 .37437 L
.58541 .36487 L
.58641 .35603 L
.58741 .34787 L
.58841 .34036 L
.58941 .33346 L
.59041 .3271 L
.59141 .32121 L
.59241 .31573 L
.59341 .31059 L
.59441 .30573 L
.5954 .30112 L
.5964 .29671 L
.5974 .29248 L
.5984 .28839 L
.5994 .25488 L
.6004 .25124 L
.6014 .24799 L
.6024 .24511 L
.6034 .24258 L
.6044 .24038 L
Mistroke
.60539 .23851 L
.60639 .23697 L
.60739 .23575 L
.60839 .23486 L
.60939 .23431 L
.61039 .23411 L
.61139 .23426 L
.61239 .23477 L
.61339 .23565 L
.61439 .23692 L
.61538 .23857 L
.61638 .24062 L
.61738 .24306 L
.61838 .2459 L
.61938 .24912 L
.62038 .2527 L
.62138 .25664 L
.62238 .26089 L
.62338 .26543 L
.62438 .2702 L
.62537 .27516 L
.62637 .28025 L
.62737 .28539 L
.62837 .29052 L
.62937 .29555 L
.63037 .30043 L
.63137 .30506 L
.63237 .30938 L
.63337 .31332 L
.63437 .31684 L
.63536 .31987 L
.63636 .32239 L
.63736 .32437 L
.63836 .32579 L
.63936 .32665 L
.64036 .32696 L
.64136 .32672 L
.64236 .32596 L
.64336 .32471 L
.64436 .32299 L
.64535 .32086 L
.64635 .31835 L
.64735 .31551 L
.64835 .31236 L
.64935 .23352 L
.65035 .23001 L
.65135 .22666 L
.65235 .22348 L
.65335 .22048 L
.65435 .21768 L
Mistroke
.65534 .21507 L
.65634 .21269 L
.65734 .21053 L
.65834 .20863 L
.65934 .207 L
.66034 .20566 L
.66134 .20462 L
.66234 .20392 L
.66334 .20358 L
.66434 .20363 L
.66533 .20409 L
.66633 .205 L
.66733 .20638 L
.66833 .20826 L
.66933 .21068 L
.67033 .21366 L
.67133 .21722 L
.67233 .22137 L
.67333 .22612 L
.67433 .23148 L
.67532 .23741 L
.67632 .24391 L
.67732 .25091 L
.67832 .25836 L
.67932 .26618 L
.68032 .27426 L
.68132 .28251 L
.68232 .29078 L
.68332 .29895 L
.68432 .30689 L
.68531 .31446 L
.68631 .32154 L
.68731 .32801 L
.68831 .33377 L
.68931 .33874 L
.69031 .34286 L
.69131 .34607 L
.69231 .34834 L
.69331 .34968 L
.69431 .35007 L
.6953 .34956 L
.6963 .34818 L
.6973 .346 L
.6983 .34308 L
.6993 .33815 L
.7003 .33138 L
.7013 .32453 L
.7023 .31768 L
.7033 .31088 L
.7043 .30417 L
Mistroke
.70529 .29759 L
.70629 .29115 L
.70729 .28485 L
.70829 .27871 L
.70929 .27272 L
.71029 .26688 L
.71129 .26118 L
.71229 .25563 L
.71329 .25023 L
.71429 .24496 L
.71528 .23982 L
.71628 .23482 L
.71728 .22995 L
.71828 .22521 L
.71928 .22059 L
.72028 .21611 L
.72128 .21175 L
.72228 .20752 L
.72328 .20342 L
.72428 .19945 L
.72527 .19561 L
.72627 .19191 L
.72727 .18835 L
.72827 .18494 L
.72927 .18168 L
.73027 .17859 L
.73127 .17566 L
.73227 .17292 L
.73327 .17036 L
.73427 .16802 L
.73526 .16591 L
.73626 .16404 L
.73726 .16245 L
.73826 .16116 L
.73926 .16021 L
.74026 .15962 L
.74126 .15945 L
.74226 .15974 L
.74326 .16054 L
.74426 .16193 L
.74525 .16396 L
.74625 .1667 L
.74725 .17024 L
.74825 .17466 L
.74925 .14327 L
.75025 .156 L
.75125 .17113 L
.75225 .18888 L
.75325 .20936 L
.75425 .2326 L
Mistroke
.75524 .2585 L
.75624 .28672 L
.75724 .31668 L
.75824 .34753 L
.75924 .37812 L
.76024 .40708 L
.76124 .43293 L
.76224 .45424 L
.76324 .46988 L
.76424 .47917 L
.76523 .48203 L
.76623 .47897 L
.76723 .47101 L
.76823 .45947 L
.76923 .44571 L
.77023 .431 L
.77123 .41635 L
.77223 .40246 L
.77323 .38978 L
.77423 .3785 L
.77522 .36867 L
.77622 .36021 L
.77722 .35298 L
.77822 .34681 L
.77922 .34152 L
.78022 .33695 L
.78122 .33293 L
.78222 .32935 L
.78322 .32607 L
.78422 .323 L
.78521 .32006 L
.78621 .3172 L
.78721 .31437 L
.78821 .31153 L
.78921 .30866 L
.79021 .30575 L
.79121 .30279 L
.79221 .29979 L
.79321 .29675 L
.79421 .29367 L
.7952 .29058 L
.7962 .28747 L
.7972 .28437 L
.7982 .28129 L
.7992 .28461 L
.8002 .28719 L
.8012 .2899 L
.8022 .29269 L
.8032 .2955 L
.8042 .29827 L
Mistroke
.80519 .30097 L
.80619 .30352 L
.80719 .30589 L
.80819 .30804 L
.80919 .30991 L
.81019 .31148 L
.81119 .31273 L
.81219 .31362 L
.81319 .31415 L
.81419 .31431 L
.81518 .31411 L
.81618 .31354 L
.81718 .31263 L
.81818 .31139 L
.81918 .30985 L
.82018 .30803 L
.82118 .30595 L
.82218 .30366 L
.82318 .30116 L
.82418 .29851 L
.82517 .29572 L
.82617 .29281 L
.82717 .28983 L
.82817 .28678 L
.82917 .28369 L
.83017 .28059 L
.83117 .27748 L
.83217 .27439 L
.83317 .27133 L
.83417 .26832 L
.83516 .26537 L
.83616 .26249 L
.83716 .25969 L
.83816 .25699 L
.83916 .2544 L
.84016 .25192 L
.84116 .24956 L
.84216 .24734 L
.84316 .24526 L
.84416 .24333 L
.84515 .24156 L
.84615 .23996 L
.84715 .23854 L
.84815 .2373 L
.84915 .31344 L
.85015 .31971 L
.85115 .32546 L
.85215 .33056 L
.85315 .33493 L
.85415 .33849 L
Mistroke
.85514 .34118 L
.85614 .34297 L
.85714 .34386 L
.85814 .34386 L
.85914 .34303 L
.86014 .34142 L
.86114 .3391 L
.86214 .33616 L
.86314 .33268 L
.86414 .32875 L
.86513 .32446 L
.86613 .31987 L
.86713 .31507 L
.86813 .31011 L
.86913 .30504 L
.87013 .29992 L
.87113 .29477 L
.87213 .28963 L
.87313 .28452 L
.87413 .27946 L
.87512 .27448 L
.87612 .26957 L
.87712 .26477 L
.87812 .26006 L
.87912 .25547 L
.88012 .251 L
.88112 .24665 L
.88212 .24244 L
.88312 .23836 L
.88412 .23443 L
.88511 .23065 L
.88611 .22703 L
.88711 .22357 L
.88811 .22029 L
.88911 .21719 L
.89011 .21428 L
.89111 .21157 L
.89211 .20907 L
.89311 .20679 L
.89411 .20475 L
.8951 .20295 L
.8961 .20142 L
.8971 .20016 L
.8981 .19919 L
.8991 .1576 L
.9001 .16252 L
.9011 .16853 L
.9021 .17576 L
.9031 .18432 L
.9041 .19431 L
Mistroke
.90509 .20583 L
.90609 .21892 L
.90709 .23361 L
.90809 .24982 L
.90909 .26742 L
.91009 .28618 L
.91109 .30575 L
.91209 .32566 L
.91309 .34535 L
.91409 .36415 L
.91508 .38138 L
.91608 .39637 L
.91708 .40855 L
.91808 .41748 L
.91908 .42295 L
.92008 .42496 L
.92108 .42375 L
.92208 .4197 L
.92308 .41334 L
.92408 .40524 L
.92507 .39595 L
.92607 .38597 L
.92707 .37572 L
.92807 .36551 L
.92907 .35557 L
.93007 .34604 L
.93107 .337 L
.93207 .32848 L
.93307 .32048 L
.93407 .31297 L
.93506 .30592 L
.93606 .29929 L
.93706 .29303 L
.93806 .28712 L
.93906 .28151 L
.94006 .27618 L
.94106 .2711 L
.94206 .26625 L
.94306 .26162 L
.94406 .25719 L
.94505 .25296 L
.94605 .24891 L
.94705 .24505 L
.94805 .24137 L
.94905 .20674 L
.95005 .20346 L
.95105 .20038 L
.95205 .19752 L
.95305 .1949 L
.95405 .19252 L
Mistroke
.95504 .19042 L
.95604 .18861 L
.95704 .18712 L
.95804 .18598 L
.95904 .18523 L
.96004 .18489 L
.96104 .185 L
.96204 .18561 L
.96304 .18677 L
.96404 .18852 L
.96503 .1909 L
.96603 .19398 L
.96703 .1978 L
.96803 .2024 L
.96903 .20783 L
.97003 .21411 L
.97103 .22127 L
.97203 .22929 L
.97303 .23815 L
.97403 .2478 L
.97502 .25814 L
.97602 .26907 L
.97702 .28041 L
.97802 .29199 L
.97902 .30358 L
.98002 .31496 L
.98102 .32586 L
.98202 .33607 L
.98302 .34534 L
.98402 .35349 L
.98501 .36035 L
.98601 .3658 L
.98701 .36978 L
.98801 .37226 L
.98901 .37325 L
.99001 .37281 L
.99101 .37103 L
.99201 .36805 L
.99301 .364 L
.99401 .35905 L
.995 .35337 L
.996 .34714 L
.997 .3405 L
.998 .3336 L
.999 .28633 L
Mfstroke
0 g
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{724.625, 298.562},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;D0001:R000`400?l00000o`00003ooooooooo
ooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo
003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo003ooooooooo
ooooe_ooool005Sooooo1Ol00003ooooo`;o00001?ooool2o`0001Gooooo0ol00003ooooo`;o0000
1?ooool2o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`0001Cooooo0ol00004ooooo`;o0000
1?ooool2o`00013ooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000iooooo`Go0000
0oooool2o`0000Cooooo0_l0000Dooooo`?o00000oooool2o`0000Cooooo0_l0000Dooooo`?o0000
1?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`?o0000
1?ooool2o`0000Cooooo0_l00004ooooo`;o0000=Oooool5o`0000?ooooo0_l00004ooooo`;o0000
5Oooool3o`0000?ooooo0_l00004ooooo`;o00004oooool3o`0000Cooooo0_l00004ooooo`;o0000
5?ooool3o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l00004ooooo`;o0000
1?ooool2o`0003Oooooo001Iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000Eooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000@ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0003Wooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool04?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`00017ooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=Oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
5Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0?ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000fooooo`00F_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004_ooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Aooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0003Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001;ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Booooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000=_ooool005_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool04?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool4o`0000?ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Cooooo`?o00000oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
>oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0?ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Booooo`Co00000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001;ooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000gooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo013ooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
017ooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004ooo
ool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003Kooooo001Hooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00?o0000ooooool0
00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000hooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;o
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01?ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`00017ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000foooo
o`00F?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Dooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00003oooool2o`0000Cooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Sooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00004oooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Cooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`00013ooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo
0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool00ol0
003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000?ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo0000=_ooool005Wooooo0ol00004ooooo`;o00001?oo
ool2o`0001Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003[ooooo0ol00004ooooo`;o00001?oo
ool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Eooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Booooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Kooooo0ol00004ooooo`;o00001?oo
ool2o`0001Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Oooooo003oooooooooooooe_ooool0
0?oooooooooooooFooooo`00ooooooooooooomKooooo000oooooojgo0000:?oooon^o`0002Gooooo
2?l000000ol0nY[o0000o`000006o`000003o`3jV_l0003o000009Wo0000@?ooool003oooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool01Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00kooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Y
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`2H
ooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool01Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo09Sooooo00?o0000oooo
ooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo0:[ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00
?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo0_l0002Zooooo`;o0000
9Oooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
V?ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo00Gooooo2_oo002Jooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooo
oooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`06ooooo`03ool00?oooooo
oooo09Sooooo00?o0000ooooooooool0?_ooool003Oooooo0ol00005ooooo`03o`000?oooooooooo
0:Wooooo00?o0000ooooooooool06?ooool5o`0000;ooooo0ol00004ooooo`03o`000?oooooooooo
0:[ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo
00Kooooo00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00=_ooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Ioooo
o`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooooooo00000:cooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo00Kooooo
00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00=_ooool01Ol0003ooooooooo
oooooooo000000Cooooo0_l0002Yooooo`;o00007?ooool01Ol0003ooooooooooooooooo000000?o
oooo00Co0000oooooooooooooooo0_l0002Zooooo`;o00009Oooool00ol0003oooooooooo`05oooo
o`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0noooo
o`00=_ooool4o`0000Gooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Co00001?ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo01co
oooo0ol00004ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ooo003o
ooooooooo`2Hooooo`03o`000?oooooooooo03kooooo000fooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Hooooo`07o`000?ooooooooooooooool0
003oooooo`000007ooooo`03o`000?oooooooooo00kooooo2_l0nYZBooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo
00Kooooo00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00=oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool06?ooool01Ol0003o
oooooooooooooooo000000;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0>oooo
o`03o`3jV_oooooooooo00Kooooo2Ol0nYZ:ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool00oooool2o`0000Kooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`2Goooo
o`;o0000@?ooool003Sooooo0_l00005ooooo`03o`000?oooooooooo0:Wooooo00?o0000oooooooo
ool06Oooool3o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo00kooooo00?o0?ZJoooooooo
ool03_ooool00ol0nY[oooooooooo`28ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooooooo
ool0V?ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0>ooooo`03o`3j
V_oooooooooo08Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`2Hooooo`03o`00
0?oooooooooo03kooooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_oo
ool2o`0000oooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`27ooooo`;o00007_oo
ool2o`0000Gooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`06ooooo`03ool00?oo
oooooooo09Sooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0ZOooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`28ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`05ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool0V?ooool0
0ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool01_ooool9o`3jVQ7ooooo00?o0?ZJooooooooool07ooooolBo`3j
VUKooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo
00Kooooo00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003o
ooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool01_ooool00ol0nY[o
ooooooooo`0Gooooo`03o`3jV_oooooooooo01Kooooo2_l0nYX@ooooo`03o`3jV_oooooooooo05Co
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo00Ko
oooo00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003ooooo
ooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool01_ooool00ol0nY[ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00kooooo2Ol0nYXIooooo`03o`3jV_oooooooooo05Cooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo00Kooooo
00?oo`00o`3jV_l0nYX01_l0nYZBooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oo
oooooooo0:Wooooo00?o0000ooooooooool09_ooool:o`3jVQWooooo00?o0?ZJooooooooool01Ooo
ool:o`3jVR7ooooo00?o0?ZJooooooooool05oooool:o`3jVS;ooooo0_l0000Uooooo`03o`000?oo
oooooooo00Gooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`06ooooo`Wo0?ZJROoo
ool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool08?ooool9o`3jVR[ooooo2_l0nYX8ooooo`Wo0?ZJ2?ooool9
o`3jVR_ooooo00?o0000ooooooooool08oooool8o`3jVP03ool00?oooooooooo00Kooooo00?oo`00
ooooooooool03_ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo03kooooo000ooooo
o`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`1Loooo
o`Wo0?ZJ6Oooool:o`3jVR;ooooo00?o0?ZJooooooooool08oooool00ol0003oooooooooo`05oooo
o`03ool00?oooooooooo00Kooooo2Ooo0008ooooo`[o0?ZJP?ooool00ol0003oooooooooo`0noooo
o`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool0Qoooool:o`3jVPOooooo4_l0nYX00ol0003oooooooooo`0Kooooo`Go00000oooool00ol0003o
ooooooooo`05ooooo`03ool00?oooooooooo00oooooo2Ooo0008oooooa_o0?ZJI_ooool00ol0003o
ooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool0T?ooool9o`3jVQ7ooooo00?o0000ooooooooool07?ooool01?l0003ooooo
ooooool00003ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool05oooool00ooo003o
ooooooooo`0Poooooa;o0?ZJEOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003ooooo
ooooo`2Yooooo`03o`000?oooooooooo02Kooooo0_l0002Zooooo`;o00007oooool00ol0003ooooo
ooooo`03ooooo`;o00001_ooool00ooo003oooooooooo`06ooooo`Wo0?ZJ2?ooool:ool002[ooooo
;?l0nYXYooooo`;o0000@?ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool01_ooool00ol0nY[ooooooooo
o`06ooooo`Wo0?ZJ2?ooool/ool002[ooooo6ol0nYX@ooooo`03o`000?oooooooooo03kooooo000o
ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Z
ooooo`03o`000?oooooooooo01_ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oo
oooooooo00Gooooo00?oo`00ooooooooool01_ooool00ol0nY[oooooooooo`0>ooooo`[o0?ZJ:_oo
ool/ool001Wooooo4_l0nYY0ooooo`00=oooool3o`0000Gooooo00?o0000ooooooooool0ZOooool0
0ol0003oooooooooo`0Hooooo`Go00000_ooool3o`0000Cooooo00?o0000ooooooooool05oooool9
ool008[ooooo00?o0000ooooooooool06oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool01Oooool00ooo003o0?ZJo`3jVP07o`3jVQWooooo6ol0nYXkoooooa_oo`004?oo
ool00ol0nY[oooooooooo`0nooooo`00=_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o
0000ooooooooool0ZOooool00ol0003oooooooooo`0Iooooo`06o`000?ooooooooooo`000?oooooo
00000oooool01Ol0003ooooooooooooooooo000001Wooooo00?oo`00ooooooooool01Oooool00ooo
003oooooooooo`0Poooooa;oo`00E_ooool00ol0003oooooooooo`0Looooo`?o00001?ooool00ol0
003oooooooooo`05ooooo`03ool00?oooooooooo03[ooooo?Ol0nYXIoooooa;oo`00@?ooool003Ko
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0:Wooooo00?o0000oooo
ooooool06_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000Iooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool08?ooool00ooo003ooooooooo
o`0>ooooo`03ool00?oooooooooo01Oooooo4_oo000[ooooo`03ool00?oooooooooo02?ooooo00?o
0000ooooooooool01Oooool00ooo003oooooooooo`1foooooa_o0?ZJ4?ooool00ol0003ooooooooo
o`0nooooo`00=oooool3o`0000Gooooo0_l0002Yooooo`;o00007Oooool01?l0003ooooooooooooo
ool3o`0000Cooooo6_l00?l00ooo003o003oo`00o`05o`00o`03ool00?l00?oo003o01Oo003o2_oo
000@o`00o`03ool00?l00?oo003o01Oo003o00?oo`00o`00ool00?l03_l00?l:ool001Wo003o2Ooo
00000ol00?ooooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool0T?oo
oolBo`3jVT3ooooo000fooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`2Yooooo`03o`000?oooooooooo01Sooooo00Oo0000ooooooooooooooooo`000?oooooo000000?o
oooo00Go0000ooooooooooooooooo`00000@ooooo`[oo`001oooool00ooo003oooooooooo`0Goooo
o`03ool00?oooooooooo01Oooooo2_oo0008ooooo`Woo`006Oooool00ooo003oooooooooo`0>oooo
o`[oo`002?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?oo`00oooo
ooooool0XOooool00ol0003oooooooooo`0nooooo`00=_ooool01Ol0003ooooooooooooooooo0000
00Cooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Hooooo`07o`000?oooooooooo
ooooool0003oooooo`000003ooooo`05o`000?ooooooooooooooool000004?ooool00ooo003ooooo
ooooo`0>ooooo`03ool00?oooooooooo00oooooo2Ooo000Rooooo`Woo`008_ooool:ool000Oooooo
00?oo`00ooooooooool03oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo
00?oo`00ooooooooool0XOooool00ol0003oooooooooo`0nooooo`00=oooool3o`0000Gooooo00?o
0000ooooooooool0ZOooool00ol0003oooooooooo`0Iooooo`?o00000oooool3o`0000Cooooo00?o
0000ooooooooool03_ooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo00kooooo00?o
o`00ooooooooool0G?ooool9ool0017ooooo00?o0000ooooooooool08oooool8o`00o`03ool00?l0
0?oo003o0:;o003o@?ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo00kooooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`05
ooooo`[oo`00N?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?oo`00
ooooooooool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yoooo
o`03o`000?oooooooooo02Kooooo0_l0000?ooooo`03ool00?oooooooooo00oooooo00?oo`00oooo
ooooool01Oooool00ooo003oooooooooo`1nooooo`;o00007_ooool3o`0000Cooooo00?o0000oooo
ooooool01Oooool00ooo003oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000oooooo`03
o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03
ool00?oooooooooo00oooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`1oooooo`03
o`000?oooooooooo01_ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
00Gooooo00?oo`00ooooooooool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003o
ooooooooo`2Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool01_ooool9ool0017o
oooo2Ooo0021ooooo`03o`000?oooooooooo01oooooo00Go0000ooooooooooooooooo`000007oooo
o`03ool00?oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000oooooooo
ool0ZOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00Kooooo00?oo`00oooooooo
ool0XOooool00ol0nY[oooooooooo`0Mooooo`;o00001?ooool2o`0000Kooooo00?oo`00oooooooo
ool0X?ooool2o`00043ooooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`06ooooo`03ool00?oooooooooo06Cooooo4_l0nYXRooooo`Wo0?ZJ
00?o0000ooooooooool07oooool01Ol0003ooooooooooooooooo000000Oooooo00?oo`00oooooooo
ool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`00
0?oooooooooo02Kooooo2_oo0014ooooo`Wo0?ZJ6Oooool00ol0nY[oooooooooo`0>ooooo`[o0?ZJ
4?ooool:o`3jVPOooooo0_l0000Mooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`05ooooo`03ool00?oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003oooooo
2Ol0nYZSooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0@_ooool:o`3jVPOooooo
00?o0?ZJooooooooool03oooool9o`3jVQWooooo2_l0nYX7ooooo`03o`3jV_oooooooooo00oooooo
00?o0000ooooooooool07?ooool3o`0000Cooooo00?o0000ooooooooool01Oooool00ooo003ooooo
ooooo`2Qooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00Gooooo00?o
0?ZJooooooooool0XOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo04;ooooo00?o
0?ZJooooooooool03_ooool:o`3jVPSooooo00?o0?ZJooooooooool0:?ooool9o`3jVQ7ooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03ool00?oooooooooo0:7ooooo00?o
0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`2Q
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0>Oooool:o`3jVQWooooo2Ol0nYY5
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`2Q
ooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooo
ooooool0XOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01Oooooo2Ol0nYXIoooo
o`03o`3jV_oooooooooo06kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05oooo
o`03ool00?oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000oooooooo
ool01Oooool00ol0nY[oooooooooo`1ooooooa;o0?ZJ4?ooool00ol0nY[oooooooooo`0Vooooo`03
o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Gooooo`03
o`3jV_oooooooooo06kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03
ool00?oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0
1Oooool00ol0nY[oooooooooo`1oooooo`03o`3jV_oooooooooo00kooooo4_l0nYXXooooo`;o0000
6?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0
KOooool2o`0002Gooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`2Qooooo`03o`00
0?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool0G?oo
ool9o`3jVQ[ooooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo01Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0?ooooo`Wo0?ZJL?oo
ool00ol0003oooooooooo`0Sooooo`Woo`00Xoooool00ol0003oooooooooo`0nooooo`00?oooool0
0ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo05cooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo023ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool03oooool0
0ol0nY[oooooooooo`1fooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool01Oooool0
0ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000aooooo`?o00001?ooool2o`00
00Gooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`1Looooo`03o`3jV_oooooooooo
00Kooooo6_l0nYXRooooo`03o`000?oooooooooo01Wooooo0ol00004ooooo`;o00001?ooool00ol0
003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01Oooool:o`3j
VWSooooo00?o0000ooooooooool07Oooool3o`0000?ooooo00?o0000ooooooooool01Oooool00ol0
nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000booooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo
04;ooooo4_l0nYX8ooooo`03o`3jV_oooooooooo04;ooooo00?o0000ooooooooool06?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`1oooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`05ooooo`03o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`So003o00?o0?ZJo`00ool00?l0@_l0
0?l00ol0nY[o003oo`00o`0>o`00o`03o`3jV_l00?oo003o00Ko003o00?o0?ZJo`00ool00?l0@ol0
0?lNooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo0_l0000?ooooo`[o
0?ZJ2?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo07kooooo0_l0000Mooooo`Go
00000oooool2o`0000Kooooo00?o0?ZJooooooooool0X?ooool2o`00043ooooo000booooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05ooooo`03
o`3jV_oooooooooo04;ooooo00?o0?ZJooooooooool03_ooool:o`3jVTCooooo00?o0000oooooooo
ool06_ooool2o`0000?ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0>oooo
o`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`1ooooo
o`03o`000?oooooooooo01_ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05
ooooo`03o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Gooooo2_l0nYXk
ooooo`03o`3jV_oooooooooo05cooooo00?o0000ooooooooool07?ooool01?l0003oooooooooool0
0002ooooo`05o`000?ooooooooooooooool000004?ooool00ol0nY[oooooooooo`0?ooooo`Wo0?ZJ
POooool00ol0003oooooooooo`0Looooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0
1Oooool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000aooooo`;o00001?oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0
:?oooolBo`3jVUkooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo
09Wooooo00?o0000ooooooooool07Oooool2o`0000Cooooo00?o0000ooooooooool01Oooool00ol0
nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000booooo`03o`000?oooooooooo00?o
oooo0_l00005ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool05oooool9o`3jVPSo
oooo00?o0?ZJooooooooool0KOooool00ol0003oooooooooo`0Iooooo`?o00001?ooool2o`0000Co
oooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Iooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo0:7o
oooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool03_ooool00ol0nY[ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00Gooooo2_l0nYY_ooooo`03o`000?oooooooooo02Kooooo
0_l0000?ooooo`03o`3jV_oooooooooo09Sooooo0_l0000Uooooo`03o`000?oooooooooo00Gooooo
00?o0?ZJooooooooool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003ooooooooo
o`0>ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0O_ooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0VOooool00ol0003ooooooooo
o`0Sooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool0XOooool00ol0003ooooooooo
o`0nooooo`00?oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJ
ooooooooool0O_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00Kooooo2Ol0nYZK
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`2Q
ooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00kooooo00?o0?ZJoooo
ooooool03_ooool:o`3jVUkooooo2Ooo000Iooooo`03ool00?oooooooooo02Kooooo00?o0000oooo
ooooool01_ooool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool01Oooool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000oooooo`03
o`000?oooooooooo00kooooo00?o0?ZJooooooooool01Oooool:o`3jVVOooooo00?oo`00oooooooo
ool01Oooool:ool0013ooooo00?oo`00ooooooooool09_ooool00ol0003oooooooooo`06ooooo`03
o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03
o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool0
3_ooool9o`3jVW3ooooo00?oo`00ooooooooool03_oooolBool002Sooooo2_l0nYZSooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`2Qooooo`03o`00
0?oooooooooo03kooooo000oooooo`Woo`00P?ooool00ooo003oooooooooo`0Pooooo`03o`000?oo
oooooooo02Kooooo0_l0002Zooooo`;o00007_ooool3o`0000Cooooo00?o0000ooooooooool01Ooo
ool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooo
oooo00Gooooo00?oo`00ooooooooool0G?ooool9ool001Wooooo00?oo`00ooooooooool08?ooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool06oooool0
1Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool01Oooool00ol0nY[ooooooooo
o`2Qooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00Gooooo00?oo`00
ooooooooool0G?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00oooooo2Ooo000R
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0O
ooooo`04o`000?ooooooooooooooo`;o00001_ooool00ol0nY[oooooooooo`2Pooooo`;o0000@?oo
ool003oooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`1Looooo`03ool00?oooooo
oooo00Kooooo4_oo000Zooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z_ooool0
0ol0003oooooooooo`0Oooooo`05o`000?ooooooooooooooool000001oooool00ol0nY[ooooooooo
o`2Qooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00Gooooo00?oo`00
ooooooooool0@_ooool:ool0013ooooo00?oo`00ooooooooool0@_ooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool06oooool4o`0000Cooooo00?o0000
ooooooooool01Oooool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000ooooo
o`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool0@_ooool00ooo003oooooooooo`06oooo
o`Woo`002?ooool00ooo003oooooooooo`12ooooo`03o`000?oooooooooo02Kooooo0_l0002Zoooo
o`;o00007Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooo
ooooool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`05ooooo`03
ool00?oooooooooo04;ooooo00?oo`00ooooooooool03_ooool00ooo003oooooooooo`06ooooo`03
ool00?oooooooooo04;ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Zooooo`03
o`000?oooooooooo01_ooooo1Ol00003ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooooooo
ool0XOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`05ooooo`03ool0
0?oooooooooo04;ooooo00?oo`00ooooooooool03_ooool:ool004Cooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
1Oooool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo03kooooo000aooooo`?o00000_oo
ool5o`0000Cooooo00?o0000ooooooooool01Oooool00ooo003oooooooooo`12ooooo`03ool00?oo
oooooooo05cooooo00?o0000ooooooooool06Oooool3o`0000;ooooo1Ol00003ooooo`03o`000?oo
oooooooo0:[ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`05ooooo`03o`3jV_oo
oooooooo0:7ooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Gooooo00?oo`00ooooooooool0@_oo
ool00ooo003oooooooooo`1Looooo`03o`000?oooooooooo01Sooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0Z_ooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool0XOooool00ol0003o
ooooooooo`0nooooo`00<_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
0_l00006ooooo`03ool00?oooooooooo037ooooo4_oo001Mooooo`;o00007_ooool01Ol0003ooooo
oooooooooooo000000Gooooo0_l0002Zooooo`;o00009Oooool00ol0003oooooooooo`05ooooo`03
o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo2_oo000Zooooo`03ool0
0?oooooooooo06gooooo00?o0?ZJooooooooool06_ooool2o`0000Gooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo02?ooooo2Ol0nYZSooooo`03o`00
0?oooooooooo03kooooo000booooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00kooooo00?oo`00ooooooooool05ooooolBool004gooooo
4_l0nYX@ooooo`03o`3jV_oooooooooo01cooooo00?o0000ooooool000000oooool01Ol0003ooooo
oooooooooooo00000:cooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`2Yooooo`03
o`000?oooooooooo03kooooo000aooooo`;o00000oooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool03_ooool00ooo003oooooooooo`0Gooooo`03ool00?oooooooooo05co
oooo00?o0?ZJooooooooool03_oooolBo`3jVQ[ooooo00Oo0000ooooooooooooooooo`000?oooooo
000000?ooooo00Go0000ooooooooooooooooo`00002/ooooo`03o`000?oooooooooo01cooooo0ol0
0004ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000
ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool03_ooool00ooo003oooooooooo`0G
ooooo`03ool00?oooooooooo05cooooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`0I
ooooo`?o00000oooool3o`0000Cooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0K
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2Yooooo`03o`000?oo
oooooooo03kooooo000oooooo`03o`000?oooooooooo00kooooo00?oo`00ooooooooool03_ooool:
ool005kooooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo0:[ooooo00?o0000ooooooooool06oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool0ZOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`0>
ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool0I?ooool00ol0nY[oooooooooo`0P
ooooo`03o`000?oooooooooo02Kooooo0_l0002Zooooo`;o00007Oooool4o`0000Cooooo0_l0002Y
ooooo`;o0000@?ooool003oooooo00?o0000ooooooooool03_ooool00ooo003oooooooooo`05oooo
o`[oo`00A?ooool9o`3jVQWooooo00?o0?ZJooooooooool08?ooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000oooooooo
ool03_ooool9ool004gooooo00?o0?ZJooooooooool01_oooolJo`3jVR;ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo03kooooo000oooooo`03o`00
0?oooooooooo06Cooooo00?o0?ZJooooooooool0@_ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo0:[ooooo00?o0000ooooooooool07Oooool2o`0000Cooooo00?o0000ooooooooool0
ZOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`1Tooooo`03o`3jV_oo
oooooooo04;ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Zooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0nooooo`00?oooool9
o`3jVTCooooo4_l0nYX8ooooo`03o`3jV_oooooooooo04;ooooo00?o0000ooooooooool09_ooool2
o`000:[ooooo0_l0000Uooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0?_ooool0
03oooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`12ooooo`03o`3jV_oooooooooo
00kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`12ooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
0:Wooooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool01Oooool00ol0nY[o
ooooooooo`12ooooo`03o`3jV_oooooooooo00kooooo2_l0nYY4ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0:Wo
oooo00?o0000ooooooooool0?_ooool003oooooo00?o0000ooooooooool01Oooool00ol0nY[ooooo
ooooo`12ooooo`03o`3jV_oooooooooo05cooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`2Zooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0ZOooool00ol0003ooooo
ooooo`0nooooo`00?oooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo04;ooooo00?o
0?ZJooooooooool0G?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:[ooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo03kooooo000o
ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool0@_ooool00ol0nY[oooooooooo`1L
ooooo`03o`000?oooooooooo02Kooooo0_l0002Zooooo`;o00009Oooool00ol0003oooooooooo`2Y
ooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooo
ooooool0@_ooool00ol0nY[oooooooooo`1Looooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool0Z_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0ZOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`05ooooo`03
o`3jV_oooooooooo037ooooo4_l0nYYNooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool0Z_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0ZOooool00ol0003oooooooooo`0nooooo`00<Oooool3o`0000Cooooo0ol00004ooooo`03o`00
0?oooooooooo00Gooooo00?o0?ZJooooooooool0<Oooool00ol0nY[oooooooooo`1]ooooo`03o`00
0?oooooooooo01Wooooo0ol00004ooooo`?o00000oooool00ol0003oooooooooo`2Zooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool00_ooool2o`000:Wooooo0_l00010ooooo`00<_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Ooo
ool00ol0nY[oooooooooo`0Poooooa;o0?ZJKoooool00ol0003oooooooooo`0Hooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:[ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:Wooooo
00?o0000ooooooooool0?_ooool003;ooooo00Co0000oooooooooooooooo1Ol00004ooooo`03o`00
0?oooooooooo00Gooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`1nooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooool000001?l00003ooooo`03o`000?oooooooooo0:[ooooo
00?o0000ooooooooool07oooool01Ol0003ooooooooooooooooo00000:_ooooo00?o0000oooooooo
ool0?_ooool003;ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00?o
oooo0_l00006ooooo`[o0?ZJ6Oooool00ol0nY[oooooooooo`1mooooo`;o00007?ooool2o`0000;o
oooo00Co0000oooooooooooo00001?ooool2o`000:[ooooo0_l0000Mooooo`05o`000?oooooooooo
ooooool000000oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo03kooooo000boooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`0>oooo
o`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0O_ooool00ol0003oooooooooo`0Loooo
o`06o`000?ooooooooooo`000?oooooo00001?ooool00ol0003oooooooooo`2Zooooo`03o`000?oo
oooooooo01_ooooo1Ol00003ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0?_oo
ool0037ooooo0_l00005ooooo`;o00001Oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooo
oooo00kooooo2_l0nYZ0ooooo`03o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`00
0003ooooo`;o00001?ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool0ZOooool00ol0003oooooooooo`0nooooo`00<_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0>
ooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool06Oooool3o`0000Gooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool0ZOooool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`0>oooo
o`03o`3jV_oooooooooo00Gooooo2_l0nYZ9ooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool0Z_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0:Wooooo00?o0000oooo
ooooool0?_ooool003oooooo00?o0000ooooooooool03_ooool9o`3jVY;ooooo00?o0000oooooooo
ool09_ooool2o`000:[ooooo0_l0000Uooooo`03o`000?oooooooooo0:Wooooo00?o0000oooooooo
ool0?_ooool003oooooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo0:[ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`2Yooooo`03o`00
0?oooooooooo03kooooo000oooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0ZOoo
ool00ol0003oooooooooo`0nooooo`00?oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0Looooo`?o00001?ooool0
0ol0003oooooooooo`2Yooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Kooooo`05o`000?oooooooooo
ooooool000000oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool0?_ooool003oooooo[Ol0000Xooooojko00007Oooool01Ol0003ooooooooooooooooo
000000?ooooo[Ol00010ooooo`00oooooooQooooo`?o0000lOooool00?ooooooh?ooool01Ol0003o
oooooooooooooooo00000?3ooooo003oooooon3ooooo00Go0000ooooooooooooooooo`00003`oooo
o`00oooooooQooooo`?o0000lOooool009?ooooo0ol0003ooooooooooooo@?ooool009Kooooo00?o
0000ooooooooool0ooooooooooooocgooooo0026ooooo`Co00000_ooool5o`0000;ooooo1?l00000
1_oooooo0000ooooool0003oooooo`0000;ooooo1?l00034ooooo`?o0000d?ooool4o`0009Kooooo
002:ooooo`05o`000?ooooooooooooooool000000oooool03Ol0003ooooooooooooooooo0000oooo
ool0003oooooo`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`34ooooo`03o`00
0?oooooooooo0=3ooooo00Co0000oooooooooooo0000UOooool008Oooooo0ol00004ooooo`05o`00
0?ooooooooooooooool000000oooool01ol0003oooooo`000?oooooo0000ooooool000000_ooool3
o`000<Kooooo00?o0000ooooooooool0d?ooool01?l0003oooooooooool0002Eooooo`00Q_ooool0
0ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool000000oooool02Ol0003oooooo`00
0?oooooo0000ooooool0003oooooo`000002ooooo`03o`000?oooooooooo0<Cooooo0_l0003Aoooo
o`04o`000?ooooooooooo`0009Gooooo0027ooooo`Co000000Coooooo`000?l0003o00001?ooool7
o`000003ooooool0003ooooo00;ooooo0_l00036ooooo`;o000000?oooooo`000?l00000coooool3
o`0009Kooooo003ooooooooooooo?Oooool00ol0003oooooooooo`2Fooooo`00S_ooool00ol0003o
ooooooooo`3ooooooj[ooooo0_l0002Hooooo`00ooooooooooooomKooooo003oooooooooooooe_oo
ool005_ooooo1Ol00003ooooo`;o00001?ooool2o`0001Gooooo0ol00003ooooo`;o00001?ooool2
o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`0001Cooooo0ol00004ooooo`;o00001?ooool2
o`00013ooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000iooooo`Go00000oooool2
o`0000Cooooo0_l0000Dooooo`?o00000oooool2o`0000Cooooo0_l0000Dooooo`?o00001?ooool2
o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`?o00001?ooool2
o`0000Cooooo0_l00004ooooo`;o0000=Oooool5o`0000?ooooo0_l00004ooooo`;o00005Oooool3
o`0000?ooooo0_l00004ooooo`;o00004oooool3o`0000Cooooo0_l00004ooooo`;o00005?ooool3
o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l00004ooooo`;o00001?ooool2
o`0003Cooooo001Looooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Eooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0003Wooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool04?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`00017ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=Oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005Oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0?ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000cooooo`00GOooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00004_ooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Aooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0003Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo0000<oooool005kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool04?ooool01?l0003oooooooooool00003ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool4o`0000?ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Cooooo`?o00000oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000>oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0?ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Booooo`Co00000oooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001;ooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000gooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo013ooooo00Co0000oooo
oooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo
1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004oooool3o`00
00?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0003?ooooo001Kooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00?o0000ooooool000000ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000oooooooo
ool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000hooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000oooo
ool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017o
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00004Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo
00?o0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
017ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000cooooo`00Fooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000Dooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001;ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00003oooool2o`0000Cooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Sooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
4oooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Coooo
o`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`00013ooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo0_l00003
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000?ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo0000<oooool005cooooo0ol00004ooooo`;o00001?ooool2o`00
01Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?ooool2o`00
00Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oooooooooo
00?ooooo0_l00004ooooo`;o00001?ooool2o`0003[ooooo0ol00004ooooo`;o00001?ooool2o`00
01Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Eooooo`;o00001?ooool2o`00
00Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Booooo`03o`000?oooooooooo
00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Kooooo0ol00004ooooo`;o00001?ooool2o`00
01Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?ooool2o`00
00Cooooo0_l0000Dooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oooooooooo
00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Cooooo003oooooooooooooe_ooool00?oooooo
oooooooFooooo`00ooooooooooooomKooooo0012ooooo`Go000000?o0?ZJo`000?l0nYX0YOl0000X
ooooo`Co000000Go0?ZJo`000?l0003o0?ZJo`00o`2Uo`0002Gooooo0_l000001Ooo003o003oo`00
ool00?oo0?ZJ0:Ko0000?Oooool004;ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooo`3j
VP0Jooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooo
oooooooo0?ZJ00;ooooo00?o0?ZJo`00ool00?l06Oooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo02?ooooo0_l00002ool00003ooooool00?oo0?ZJ01_ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0kooooo`00@_ooool00ol0003oooooooooo`02ooooo`03o`3jV_oo
oooo0?ZJ0:Cooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo
00?o0?ZJo`00ool00?l0Xoooool00ol0003oooooooooo`0Sooooo`07o`3jV_ooooooooooool00?oo
oooo003oo`3jVP2Uooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oooooooooo00;o
oooo00?o0?ZJooooool0nYX0Y?ooool00ol0003oooooooooo`0Vooooo`;o00000_ooool01_l0nY[o
ooooooooool0nY[o003oo`3jVZ;ooooo0_l0000Uooooo`;o0?ZJ00Goooooool00?ooooooooooo`3j
VP2Uooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJ
ooooool0nYX0Xoooool2o`0002Sooooo00Go0000ooooooooooooooooo`3jVP02ooooo`04o`3jV_l0
003o0000o`000:;ooooo00?o0000ooooooooool08oooool01ol0003o0?ZJo`3jV_ooooooo`00oooo
ool0nYX0YOooool00ol0003oooooooooo`0kooooo`00@_ooool00ol0003oooooooooo`02ooooo`03
o`3jV_oooooo0?ZJ0:Cooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooooooooooo0?ZJ
00;ooooo00Co0?ZJo`000?l0003o0000X_ooool00ol0003oooooooooo`0Sooooo`09o`000?oooooo
0?ZJo`3jV_oo003oooooo`3jV_oooooo0?ZJ0:?ooooo00?o0000ooooooooool0>oooool004;ooooo
00?o0000ooooooooool00_ooool00ol0nY[oooooo`3jVP2Tooooo`03o`000?oooooooooo02Kooooo
00Go0000ooooooooooooooooo`3jVP02ooooo`04o`3jV_l0003o0000o`000:;ooooo00?o0000oooo
ooooool08oooool02Ol0003oooooooooool0nY[oo`00ooooool0nY[oooooo`3jVP2Sooooo`03o`00
0?oooooooooo03_ooooo0012ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooool0nYX0Y?oo
ool00ol0003oooooooooo`0Vooooo`;o00000_ooool01_l0nY[oooooooooool0nY[o003oool00:;o
oooo0_l0000Uooooo`07o`000?ooooooooooo`3jV_oo003oooooo`00o`02o`3jVZ?ooooo00?o0000
ooooooooool0>oooool004;ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooo`3jVP2Soooo
o`;o0000:?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJo`00oooo0000Xoooool0
0ol0003oooooooooo`0Sooooo`05o`000?ooooooooooo`3jV_oo00000_ooool2o`3jVZ?ooooo00?o
0000ooooooooool0>oooool004;ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooo`3jVP2T
ooooo`03o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?o
o`00ooooooooool0M_ooool2o`3jVRWooooo00?o0000ooooooooool08oooool01Ol0003ooooooooo
ool0nY[oo`0000;ooooo0_l0nYZSooooo`03o`000?oooooooooo03_ooooo0012ooooo`03o`000?oo
oooooooo00;ooooo00?o0?ZJooooool0nYX0Y?ooool00ol0003oooooooooo`0Vooooo`;o00000_oo
ool00ol0nY[oooooooooo`02o`3jVP03ool00?oooooooooo07Gooooo0ol0nYXXooooo`;o00009Ooo
ool01Ol0003oooooooooool0nY[oo`0000;ooooo0_l0nYZSooooo`03o`000?oooooooooo03_ooooo
0012ooooo`05o`000?ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`2Rooooo`03o`00
0?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00oooooooo
ool0MOooool3o`3jVRWooooo00?o0000ooooooooool08oooool01Ol0003oooooooooool0nY[oo`00
00;ooooo0_l0nYZSooooo`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?oooooooooooooo
ool0nYX00_ooool00ol0nY[oooooooooo`2Rooooo`03o`000?oooooooooo02Kooooo00Go0000oooo
ooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool0??ooool2o`3jVSOooooo0ol0nYXY
ooooo`03o`000?oooooooooo02?ooooo00Go0000ooooooooooooooooool00002ooooo`;o0?ZJXooo
ool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00?o
0?ZJooooooooool0XOooool2o`0002Sooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ
00?oo`00ooooooooool0??ooool2o`3jVSOooooo00?o0?ZJool00?oo0000:Oooool00ol0003ooooo
ooooo`0Sooooo`05o`000?oooooooooooooooooo00000_ooool2o`3jVZ?ooooo00?o0000oooooooo
ool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooo0?ZJ0:;o
oooo00?o0000ooooooooool09_ooool2o`0000;ooooo00?o0?ZJooooooooool00_l0nYX00ooo003o
ooooooooo`0Hooooo`03o`00oooooooooooo027ooooo00?o0?ZJooooool0nYX0=_ooool00ol0nY[o
o`00ool0000Xooooo`;o00009Oooool01ol0003ooooooooooooooooo0?ZJool00?ooool00_l0nYZS
ooooo`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00_ooool3
o`3jVZ;ooooo00?o0000ooooooooool06?ooool5o`0000?ooooo0_l00004ooooo`05o`000?oooooo
ooooooooool0nYX00_ooool2o`3jVP03ool00?oooooooooo01Sooooo00?o0?ZJooooooooool08Ooo
ool00ol0nY[o003oo`3jVP0fooooo`03o`3jV_oo003oo`0002Wooooo00?o0000ooooooooool05_oo
ool3o`0000Cooooo0_l00004ooooo`07o`000?ooooooooooooooool0nY[oo`00ooooo`02o`3jVZ?o
oooo00?o0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`?o
0?ZJX_ooool00ol0003oooooooooo`0Iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_l0nYX00ooo003ooooooooo
o`0Hooooo`;o0?ZJ8_ooool00ol0nY[o003oo`3jVP0fooooo`03o`3jV_oo003oo`0002Wooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo
00Oo0000ooooooooooooooooo`3jV_oo003ooooo00;o0?ZJM_ooool00ol00?ooooooooooo`0Zoooo
o`03o`000?oooooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00oooool2ool0
0:7ooooo0_l0000Dooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000?ooooo0_l00002ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oo`00ooooooooool06?ooool2
o`3jVR;ooooo00?o0?ZJo`00ool0nYX0=_ooool01?l0nY[oo`00ool00?l0nYXWooooo`;o00006Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo0_l00002ooooo`03o`3j
V_oo003ooooo00;o0?ZJ3_ooool2o`3jVRgooooo00?o0?ZJooooooooool0=_ooool00ol00?oooooo
ooooo`0Yooooo`;o0000?Oooool004;ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`?o0000
X_ooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooooooool000000_ooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0?ZJooooooooool00_l0nYX00ooo003oooooooooo`0Hoooo
o`;o0?ZJ8_ooool00ol0nY[oo`00o`3jVP0fooooo`04o`3jV_oo003oo`00o`3jVRGooooo00Co0?ZJ
oooooooooooo00006Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo
00Oo0000ooooooooooooooooo`3jV_oo003ooooo00;o0?ZJ3Oooool3o`3jVRcooooo0_l0nYXGoooo
o`03o`3jV_oooooooooo01gooooo0ol00?l[ooooo`03o`000?oooooooooo03_ooooo000cooooo`Go
00000oooool2o`0000Gooooo00Go0000ooooooooooooooooo`3jVP02ooooo`?o0000X_ooool00ol0
003oooooooooo`0Hooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0003ooooo`05o`000?ooooooooooooooool0nYX00_ooool2o`3jVP05ool00?ooooooooooooooool0
nYX05_ooool00ooo003o0?ZJooooo`0Qooooo`;oo`0000?o0?ZJooooooooool0=?ooool01?l0nY[o
o`00ool00?l0nYXTooooo`;o0?ZJ0_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000oooool01ol0003ooooooooooooooooo0?ZJool00?ooool0
0_l0nYX=ooooo`03o`3jV_oooooo0?ZJ02cooooo00?o0?ZJooooool0nYX05_ooool00ol0nY[o003o
ooooo`0Mooooo`04o`00oooooooo0?ZJo`3jVR[ooooo00?o0000ooooooooool0>oooool003Cooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`05o`000?oooooooooo
ooooool0nYX00_ooool3o`000:;ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0nYX3ooooo`;o
0?ZJ00Goo`00ooooooooooooooooo`3jVP0Eooooo`03o`3jV_oo003o0?ZJ027ooooo00Co0?ZJool0
0?oo003o0?ZJ=_ooool01?l0nY[oo`00ool00?l0nYXSooooo`?o0?ZJ0_ooool00ol0003ooooooooo
o`0Fooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`07o`000?ooooooooooooooool0
nY[oo`00ooooo`02o`3jVPgooooo00?o0?ZJooooool0nYX0:oooool3o`000003o`3jV_oooooooooo
01Cooooo0_l0nYXNooooo`04o`00ool0nY[o0?ZJo`3jVR[ooooo00?o0000ooooooooool0>oooool0
02gooooo1Ol00003ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2
o`0000;ooooo00Co0?ZJoooooooooooooooo0_oo001iooooo`03o`3jV_oooooooooo02Gooooo0_l0
000Kooooo`?o00001?ooool2o`0000Cooooo0_l000000ooooooo0?ZJooooo`02ooooo`;o0?ZJ00Co
o`00oooooooooooooooo0_l0nYXDooooo`03o`3jV_oo003oo`00027ooooo00Co0?ZJool00?oo003o
0?ZJ:oooool2o`3jVPSooooo0_l0nYX2ool00003o`3jV_oooooooooo027ooooo00Co0?ZJo`00ool0
nY[ooooo0_l0000Iooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`07o`000?oooooooooo
ooooool0nY[oo`00ooooo`02o`3jVPgooooo00?o0?ZJooooool0nYX0:oooool3o`000003o`3jV_oo
oooooooo01Cooooo0ol0nYXMooooo`04o`00ool0nY[o003oo`3jVR[ooooo00?o0000ooooooooool0
>oooool003Kooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`00NOooool00ol0nY[oooooooooo`0Vooooo`03
o`000?oooooooooo02Kooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP04ool00?oooooooooo
ooooo`;o0?ZJ5?ooool00ol0nY[oo`00ool0000Qooooo`04o`3jV_oo003oo`00o`3jVR_ooooo0_l0
nYX8ooooo`?o000000?oo`00o`3jV_ooool08_ooool00ol0nY[o003oo`3jVP02ooooo`03o`000?oo
oooooooo02?ooooo00Wo0000ooooooooooooooooo`3jV_oo003oooooo`00ool0nYX03?ooool01?l0
nY[oooooooooool0nYX[ooooo`?o000000?o0?ZJooooooooool04oooool3o`000003o`3jV_oooooo
oooo01_ooooo0_l0nYX00ooooooo0?ZJooooo`0Hooooo`03o`3jV_oooooooooo00kooooo00?o0000
ooooooooool0>oooool003?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Cooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`00?oooool00ol0nY[ooooo
ooooo`0fooooo`;o0?ZJ:?ooool00ol0003oooooooooo`0Vooooo`04o`000?ooooooooooo`3jVP?o
oooo0_l0nYX01?oo003oooooooooooooool2o`3jVQCooooo00?oo`00oooooooo00008Oooool01?l0
nY[oo`00ool00?l0nYXDooooo`03o`3jV_oooooooooo01?ooooo0ol0nYX8ooooo`?o000000?o0?ZJ
ool00?ooool08Oooool01ol0nY[o003oo`00oooooooo0?ZJooooool000009Oooool02Ol0003ooooo
oooooooooooo0?ZJool00?oooooo003oo`3jVP0<ooooo`04o`3jV_ooooooooooo`3jVR_ooooo00Co
0?ZJool00?oo003o0?ZJ5Oooool3o`000003o`3jV_oooooooooo01_ooooo00Co0?ZJoooooooooooo
0?ZJ6Oooool00ol0nY[oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo000cooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00004ooooo`05o`000?oooooooooo
ooooool0nYX00oooool2ool003kooooo0_l0nYXhooooo`;o0?ZJ:?ooool00ol0003oooooooooo`0V
ooooo`04o`000?ooooooooooo`3jVP?ooooo0_l0nYX01?oo003oooooooooooooool2o`3jVQCooooo
00?oo`00o`3jV_oo00008Oooool01?l0nY[oo`00ool00?l0nYXDooooo`03o`3jV_oooooooooo01?o
oooo00Co0?ZJoooooooooooo0?ZJ1oooool3o`000003o`3jV_oo003ooooo027ooooo00Oo0?ZJo`00
ool00?ooooooo`3jV_oooooo000002Gooooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`03
o`3jV_oooooooooo00[ooooo00Go0?ZJooooooooooooooooo`3jVP08ooooo`03o`3jV_oooooooooo
01kooooo0_l0nYX00ooo003o0?ZJool0000Eooooo`?o000000?oo`00ooooooooool06_ooool00ol0
0?oo0?ZJooooo`03o`0001Oooooo0_l0nYX@ooooo`03o`000?oooooooooo03_ooooo000dooooo`?o
00001?ooool2o`0000Gooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`006_ooool2o`3j
VR;ooooo00?o0?ZJooooool0nYX0=oooool00ol0nY[oo`00ooooo`0Vooooo`;o0000:?ooool2o`00
0003ooooool0nY[ooooo00;ooooo0_l0nYX01?oo003oooooooooooooool2o`3jVQCooooo00?oo`00
o`3jV_oo00008Oooool01?l0nY[oo`00ool00?l0nYXDooooo`03o`3jV_oooooooooo01;ooooo00Go
0?ZJooooooooooooooooo`3jVP07ooooo`05o`3jV_oo003oooooo`3jV_oo00008_ooool01Ol0nY[o
003oo`00oooooooo0?ZJ00;o00009Oooool01_l0003ooooooooooooooooo0?ZJool000;ooooo00?o
0?ZJooooooooool02Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo0ol0
0?l00ol0nY[oooooooooo`0Nooooo`06o`3jV_ooooooo`00o`3jV_oo003o0?ZJ5?ooool01?l0nY[o
ooooool00?oo000Looooo`03o`00ool0nY[ooooo00?o00005oooool2o`3jVQ3ooooo00?o0000oooo
ooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`006_ooool2o`3j
VR;ooooo00?o0?ZJooooool0nYX0=oooool00ol0nY[oo`00o`3jVP0Wooooo`03o`000?oooooooooo
02Kooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP04ool00?ooooooooooooooo`;o0?ZJ5?oo
ool00ooo003oooooool0000Qooooo`04o`3jV_oo003oo`00o`3jVQ?ooooo0_l0nYXDooooo`05o`3j
V_l00?ooooooooooool0nYX01oooool01Ol0nY[oo`00ooooool0nY[oo`0002;ooooo00Oo0?ZJo`00
ool00?ooooooo`3jV_oooooo000002Gooooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`03
o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`;o
003o0_l0nYXPooooo`06o`3jV_ooooooo`00o`3jV_oo003o0?ZJ4oooool00ol0nY[oooooooooo`02
ool001_ooooo00Co003oo`3jV_oooooooooo0ol0000Gooooo`?o00002Oooool2o`3jVPCooooo00?o
0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`006_oo
ool2o`3jVR;ooooo00?o0?ZJooooool0nYX0=oooool2ool00003o`3jV_oooooooooo02Gooooo00?o
0000ooooooooool09_ooool01?l0003oooooooooool0nYX3ooooo`;o0?ZJ00Coo`00oooooooooooo
oooo0_l0nYXBooooo`?o000000?oooooool00?ooool08?ooool01?oo003o0?ZJo`3jV_oo000Coooo
o`;o0?ZJ2oooool4o`3jVPGooooo00Go0?ZJo`00ool00?ooooooo`3jVP07ooooo`05o`3jV_oo003o
ooooo`3jV_oo00008_ooool01ol0nY[oo`00ool00?oooooo0?ZJooooool000009Oooool01_l0003o
oooooooooooooooo0?ZJool000;ooooo00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool0
nYX4ooooo`03o`3jV_oooooooooo00?ooooo00Co003oooooool0nY[o0?ZJ7oooool2o`3jVP05oooo
oooo003o0?ZJool00?l0nYX04oooool01_l0nY[oooooool00?l0nY[oo`00o`3jVQ;ooooo00?o0?ZJ
ooooooooool01Oooool00ol00?oo0?ZJooooo`03ool001Oooooo00Co0?ZJo`000?l0003o00002?oo
ool4o`3jVP?ooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3j
VP03ooooo`;oo`0000?o003oooooooooool05oooool2o`3jVR;ooooo00?o0?ZJooooool0nYX0=ooo
ool2ool00003o`3jV_oooooooooo02Gooooo00?o0000ooooooooool09_ooool2o`000003ooooool0
nY[ooooo00;ooooo0_l0nYX01?oo003oooooooooooooool2o`3jVQ;ooooo0ol000000oooooooo`00
ooooo`0Pooooo`04ool00?l0nY[o0?ZJool001?ooooo0_l0nYX;ooooo`04o`3jV_ooooooooooo`3j
VPGooooo00Go0?ZJo`00ool00?ooooooo`3jVP07ooooo`05o`3jV_oo003ooooooooooooo00008_oo
ool01Ol0nY[oo`00ool00?l00?oo0?ZJ00;o00009Oooool01_l0003ooooooooooooooooo0?ZJool0
00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooo`3jVP05ooooo`03o`3jV_oooooooooo
00?ooooo00Co003oooooool0nY[o0?ZJ7oooool01ol0nY[ooooooooooooo003o0?ZJool00?l0nYX0
4oooool01_l0nY[oooooool00?l0nY[oo`00o`3jVQ7ooooo0ol0nYX6ooooo`03o`00ool0nY[ooooo
00?oo`005oooool01?l0nY[o0000o`000?l00008ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o
0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;oo`0000?o
003oooooooooool05oooool2o`3jVR;ooooo00?o0?ZJool00?l0nYX0=oooool2ool00003o`3jV_oo
oooooooo02?ooooo00?o0?ZJooooool00000:?ooool01?l0003oooooooooool0nYX3ooooo`;o0?ZJ
00Coo`00oooooooooooooooo0_l0nYXBooooo`?o000000?oooooool00?l0nYX08?ooool01?oo003o
0?ZJo`3jV_oo000Cooooo`;o0?ZJ2oooool00ol0nY[oooooooooo`02o`3jVP?ooooo00Ko0?ZJoooo
ool00?oo003oooooool0nYX7ooooo`05o`3jV_oo003ooooooooooooo00008_ooool01ol0nY[oo`00
ool00?l00?oo0?ZJooooool000009Oooool01_l0003ooooooooooooooooo0?ZJool000;ooooo00?o
0?ZJooooooooool01_ooool00ol0nY[oooooo`3jVP05ooooo`03o`3jV_oooooooooo00?ooooo00?o
003oo`3jV_l000000_l0000Cooooo`;o0?ZJ2Oooool01ol0nY[ooooooooooooo003o0?ZJool00?l0
nYX04oooool01_l0nY[oooooool00?l0nY[oo`00o`3jVQ3ooooo0_l0nYX00ooooooo0?ZJooooo`05
ooooo`03o`00ool0nY[oo`0000;ooooo00?oo`00o`3jV_ooool03_ooool00ol0nY[oooooooooo`04
ooooo`04o`3jV_l00?ooo`00o`3jVPSooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0003ooooo
ooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo0_oo00000ol0nY[ooooo
ooooo`0Gooooo`;oo`008_ooool00ol0nY[oo`00o`3jVP0fooooo`04o`3jV_oo003o0?ZJool002?o
oooo1?l0nYX00ol0003oooooooooo`0Vooooo`04o`000?ooooooooooo`3jVP?ooooo0_l0nYX01?oo
003oooooooooooooool2o`3jVQ?ooooo00Go0?ZJool00?ooooooo`00o`3jVP0Nooooo`03o`3jV_oo
ooooo`0000;o0?ZJ00?oo`00ooooooooool04Oooool2o`3jVP[ooooo0_l0nYX3ooooo`06o`3jV_oo
ooooooooooooool0nY[o003o0_oo00000ooooooo0?ZJooooo`06ooooo`05o`3jV_oo003ooooooooo
oooo00008Oooool02?l0nY[o003oool00?ooooooo`00o`3jV_oooooo00009Oooool01_l0003ooooo
oooooooooooo0?ZJool000;ooooo00?o0?ZJooooooooool01Oooool2o`3jVP03ooooool0nY[ooooo
00Cooooo00?o0?ZJooooooooool00_ooool00ol00?ooooooo`3jVP03o`0001;ooooo1?l0nYX8oooo
o`07o`3jV_ooooooo`00ool00?ooooooo`00o`3jVP0Booooo`;o0?ZJ00Goooooool00?l0nY[oo`00
o`3jVP0?ooooo`05o`00ool0nY[o003oooooool0nYX01_ooool00ol0nY[oooooool00002ooooo`03
ool00?l0nY[ooooo00kooooo00?o0?ZJooooooooool01?ooool01?l0nY[o003oool00?l0nYX7oooo
o`05o`3jV_l00?oo003oooooool0nYX00oooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0
003ooooooooooooooooo0?ZJ00;ooooo00Co003oool00?oo003o0?ZJ6?ooool00ol0nY[oo`00ool0
000Qooooo`04o`3jV_oo003oo`00o`3jVRcooooo00?o0?ZJooooooooool01oooool01?l0nY[oo`00
o`3jV_oo000Sooooo`05o`3jV_ooooooooooo`3jV_l00000:?ooool01?l0003oooooooooool0nYX3
ooooo`;o0?ZJ00Coo`00oooooooooooooooo0_l0nYXCooooo`05o`3jV_oo003oooooool00?l0nYX0
7_ooool00ol0nY[oooooool00002o`3jVP03ool00?l0nY[ooooo017ooooo0_l0nYX:ooooo`03o`3j
V_oooooooooo00;ooooo00Ko0?ZJooooooooooooooooo`3jV_l00?l2ool00003ooooool0nY[ooooo
00Kooooo00Go0?ZJool00?ooooooooooool0000Qooooo`08o`3jV_oo003ooooooooooooo003o0?ZJ
ooooool0000Uooooo`06o`000?ooooooooooooooool0nY[oo`000_ooool00ol0nY[oooooooooo`05
ooooo`Co0?ZJ00?o003oooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooo
0?ZJ00?o00004_ooool01?l0nY[oooooooooool0nYX7ooooo`08o`3jV_l00?ooo`00ool00?l0nY[o
ooooool00?l0nYX;ooooo`03o`3jV_oooooooooo00Cooooo00Oo0?ZJo`00ooooooooo`00o`3jV_oo
003o0?ZJ00oooooo0_l0nYX00ol00?ooooooo`3jVP06ooooo`03o`3jV_ooooooo`0000;ooooo00?o
0?ZJool00?ooool03Oooool2o`3jVPKooooo00Co0?ZJoooooooo003o0?ZJ1oooool01Ol0nY[ooooo
o`00oooooooo0?ZJ00?ooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000oooooooooooo
ooooo`3jVP02ooooo`04o`00oooo003oo`00o`3jVQSooooo00?o0?ZJool00?oo00008Oooool01?l0
nY[oo`00o`00oooo000Zooooo`Co0?ZJ2?ooool01?l0nY[oo`00o`3jV_oo000Sooooo`05o`3jV_l0
0?ooooooo`3jV_l00000:?ooool2o`000003ooooool0nY[ooooo00;ooooo0_l0nYX01?oo003ooooo
ooooooooool2o`3jVQ?ooooo00Go0?ZJool00?ooooooo`00o`3jVP0Nooooo`;o0?ZJ00Goo`00o`3j
V_l0nY[oo`00o`3jVP0Booooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`02ooooo`06o`3jV_oooooo
ooooooooool0nY[o003o0_oo00000ol00?oo0?ZJooooo`05ooooo`03o`3jV_ooooooo`0000;ooooo
00?oo`00ooooooooool07oooool01_l0nY[oo`00ooooooooooooo`00o`3jVP;o00009Oooool01_l0
003ooooooooooooooooo0?ZJool000;ooooo00?o0?ZJooooooooool01Oooool3o`3jVP04oooooooo
003oo`00o`00o`;ooooo00?o0?ZJooooooooool00_ooool01?l00?ooooooo`3jV_ooool2ool001;o
oooo00Co0?ZJoooooooooooo0?ZJ1oooool02?l0nY[oooooool00?oooooo0?ZJoooooooo003o0?ZJ
2?ooool00ol00?ooooooo`3jVP02o`3jVPGooooo00Oo0?ZJoooooooo003oooooo`3jV_oo003o0?ZJ
00oooooo00Go0?ZJooooool00?ooooooo`3jVP06ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJ
ool00?ooool03Oooool2o`3jVPGooooo00?o0?ZJo`00ooooool00_oo0007ooooo`05o`3jV_oo003o
o`00o`00ool0nYX00oooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooo
oooo0?ZJ00;ooooo00Co003oool00?oo003o0?ZJ6?ooool01?l0nY[oo`00ool00?l0nYXPooooo`05
o`3jV_oo003o003oool00?l0nYX0:Oooool01?l0nY[oooooooooool0nYX8ooooo`04o`3jV_oo003o
0?ZJool002?ooooo00Go0?ZJo`00ool00?oo0?ZJo`00000Kooooo`?o00001?ooool2o`0000Cooooo
00Co0000oooooooooooo0?ZJ0_ooool01?l00?oo0?ZJo`3jV_oo0003ooooo`Co0?ZJ4?ooool2o`3j
VP04ool00?ooooooo`00o`3jVQkooooo0_l0nYX01Ooo003o0?ZJo`3jV_oo003o0?ZJ017ooooo00?o
0?ZJooooool0nYX02_ooool00ol0nY[oooooool00003ooooo`05o`3jV_ooooooooooo`3jV_oo0000
0_ooool00ooo003oooooo`3jVP05ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00ooooooooool0
7oooool02?l0nY[oo`00ooooooooooooo`00o`3jV_oooooo00005oooool5o`0000?ooooo0_l00004
ooooo`06o`000?ooooooooooooooool0nY[oo`000_ooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ
0ooo00001?l00?ooooooooooool0nYX4ooooo`04o`00ool0nY[oooooooooo`;oo`004Oooool01Ol0
nY[ooooooooooooooooo0?ZJ00Oooooo00So0?ZJoooooooo003oooooo`3jV_ooooooo`00o`3jVPSo
oooo00Co003oo`3jV_l0nY[ooooo0_l0nYX4ooooo`04o`3jV_ooooooo`00ooooo`;o0?ZJ00?oo`00
ooooooooool03Oooool01Ol0nY[oooooo`00oooooooo0?ZJ00Kooooo00?o0?ZJool00?ooool00_oo
ool00ol0nY[oo`00ooooo`0=ooooo`;o0?ZJ1Oooool00ol0nY[o003oooooo`02ool000Kooooo00Ko
0?ZJool00?oo003oo`00o`00ool0nYX3ooooo`03o`000?oooooooooo03_ooooo0012ooooo`05o`00
0?ooooooooooooooool0nYX00_ooool01?l00?ooo`00ool00?l0nYXHooooo`04o`3jV_oo003oo`00
o`3jVR3ooooo00Go0?ZJool00?l00?ooo`00o`3jVP0Xooooo`;o0?ZJ0_ooool00ol0nY[ooooooooo
o`05ooooo`;o0?ZJ00?oo`00o`3jV_oo00008_ooool01_l0nY[o003oo`00ool00?oo0?ZJo`0001co
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`04o`000?oooooooooo
o`3jVP;ooooo00Co003oo`3jV_l0nY[oo`000oooool4o`3jVQ3ooooo00Ko0?ZJo`00oooo003ooooo
ool00?l0nYXMooooo`?o0?ZJ00Goo`00ooooool0nY[oo`00o`3jVP0Aooooo`03o`3jV_oooooo0?ZJ
00Gooooo0_l0nYX2ooooo`03o`3jV_l00?ooo`0000;oo`000_ooool01Ol0nY[oooooo`3jV_l0nY[o
o`0000;ooooo00?oo`00ooooool0nYX01Oooool00ol0nY[o003oool00002ooooo`03ool00?oooooo
oooo01oooooo00So0?ZJool00?l0nY[o0?ZJool00?oooooo0?ZJo`0001Sooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00003ooooo`06o`000?ooooooooooooooool0nY[oo`00
0_ooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ00Coo`00ooooooooooooo`000_ooool00ol0nY[o
ooooooooo`02ooooo`04o`00ool0nY[oooooooooo`;oo`004Oooool01Ol0nY[ooooooooooooooooo
0?ZJ00Oooooo00So0?ZJool00?ooooooooooo`3jV_ooooooo`00o`3jVPSooooo00?o003oo`3jV_l0
0?l00_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo003oooooooooo`;o0?ZJ00?oo`00oooo
ooooool01_ooool2o`3jVPGooooo00?o0?ZJooooool00?l00_ooool00ol0nY[oooooooooo`02oooo
o`08o`3jV_ooooooo`00ooooool0nY[oooooo`3jV_oo000>ooooo`;o0?ZJ1Oooool00ol0nY[o003o
ool00002ool000Gooooo0ol00002ooooo`03ool00?oooooo0?ZJ00;ooooo00?o0000ooooooooool0
>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`04o`00oooo003o0?ZJool001So
oooo00Coo`00o`3jV_oo003o0?ZJ8?ooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ023ooooo0ol0nYX5
ooooo`05o`3jV_l00?oo003oooooool0nYX01oooool2o`3jVP03ool00?ooooooo`0002;ooooo00Ko
0?ZJo`00oooooooo003oo`3jV_l0000Dooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000?ooooo0_l000001Ooooooo0?ZJoooooooooooo003o00;o0?ZJ00Goo`00
ooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00kooooo00Ko0?ZJool00?l0nY[ooooo
ool00?l0nYXMooooo`?o0?ZJ00Goo`00ooooool0nY[oo`00o`3jVP0Aooooo`03o`3jV_oooooo0?ZJ
00Cooooo00?o0?ZJooooool0nYX00_ooool01Ol0nY[o003oool00?ooooooo`0000;ooooo00Go0?ZJ
ooooool0nY[o003oool00002ooooo`03ool00?oooooo0?ZJ00Gooooo00?o0?ZJo`00oooo00000_oo
ool00ooo003oooooooooo`0Oooooo`08o`3jV_oo003o0?ZJo`3jV_oo003oooooo`3jV_l0000Ioooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool2o`0000;ooooo00Go0?ZJ
ool00?ooooooooooo`3jVP07ooooo`;o0?ZJ0_oo0002ooooo`04ool00?l00?ooooooo`3jVPCooooo
00Co003oo`3jV_oooooooooo0_oo000@ooooo`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`06ooooo`08
o`3jV_oo003oooooooooool0nY[oooooool00?l0nYX8ooooo`;o0?ZJ00Co003ooooooooooooo0?ZJ
1?ooool01ol0nY[oo`00ooooool0nY[oooooo`3jV_oo00001oooool3o`3jVPCooooo00Co0?ZJool0
0?oo003oo`000_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_ooooooo`0000Co0?ZJ00?oo`00
ooooooooool02oooool00ol0nY[oooooo`3jVP05ooooo`05o`3jV_l00?ooo`00o`3jV_oo00001Ooo
ool3o`0000;ooooo00Coo`00ooooool0nY[ooooo0_l0000mooooo`00@_ooool01?l0003ooooooooo
ool0nYX3ooooo`04o`00oooo003o0?ZJool001Sooooo00Coo`00o`3jV_oo003o0?ZJ8?ooool01Ol0
nY[oo`00o`3jV_oo003o0?ZJ023ooooo00Co0?ZJooooool0nY[o0?ZJ1?ooool01Ol0nY[o003oo`00
oooooooo0?ZJ00Oooooo0_l0nYX00ooo003oooooool0000Rooooo`06o`3jV_l00?ooo`00o`00ool0
nY[o00007?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000
oooooooooooo0?ZJ0_ooool01?l00?oo0?ZJo`3jV_oo0002ooooo`05o`3jV_ooooooooooooooool0
nYX04?ooool01_l0nY[oo`00o`3jV_ooooooo`00o`3jVQgooooo0_l0nYX01_oo003o0?ZJooooool0
nY[oo`00o`3jVQ7ooooo00?o0?ZJooooool0nYX01?ooool01_l0nY[oooooo`3jV_l0nY[oooooo`3j
VP;oo`0000Oo003oool00?ooooooooooo`3jV_oooooo0?ZJ00;oo`000_ooool00ooo003oooooo`3j
VP05ooooo`03o`3jV_l00?ooo`0000;ooooo00?oo`00ooooooooool07Oooool2o`3jVP08o`00oooo
003o0?ZJo`3jV_oo003oooooo`3jV_l0000Jooooo`05o`000?ooooooooooooooool000000_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00Coo`00oooooooooooo0?ZJ1oooool2o`3jVP08ool0
0?l00?oooooooooooooo003o003oooooool0nYX3ooooo`03o`00oooooooo0?ZJ00;ooooo0_oo0006
ooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`02o`00o`03ooooool0nY[ooooo00Cooooo00?o0?ZJ
o`00oooo00000_ooool01?l0nY[oooooo`3jV_oo0008ooooo`03o`3jV_oooooo003o00;ooooo00co
0?ZJooooooooooooooooo`3jV_l00?ooo`00ooooool0nY[oooooo`3jV_oo0007ooooo`04o`3jV_oo
ooooooooo`3jVP?ooooo00Oo0?ZJool00?ooooooo`00o`00oooooooo0?ZJ00Cooooo00Go0?ZJool0
0?oooooo0?ZJooooo`02o`3jVP03ool00?oooooooooo00_ooooo00?o0?ZJooooool0nYX01Oooool0
1Ol0nY[oo`00ool00?l0nY[oo`0000Gooooo0ol000001Ol0nY[oooooool00?oooooo0?ZJ00;ooooo
00?o0000ooooooooool0>oooool004;ooooo00Co0000oooooooooooo0?ZJ0oooool01?l00?ooo`00
o`3jV_oo000Hooooo`04ool00?l0nY[oo`00o`3jVR3ooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0O
ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01Ol0nY[o003oo`00oooooooo0?ZJ00Oooooo
0_l0nYX00ooo003oooooool0000Rooooo`06o`3jV_l00?ooo`00ool00?oooooo0?ZJ7?ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooool0nYX00oooool0
1ol00?oo0?ZJo`3jV_oo003o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`0=ooooo`07o`3j
V_l00?ooo`00o`3jV_oooooo0?ZJool0000Mooooo`;o0?ZJ00Koo`00o`3jV_oooooo0?ZJool00?l0
nYXAooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o0?ZJooooooooool00ol0nYX02_oo003oooooo`00
ooooooooo`00ooooool0nY[oooooo`3jV_oo0003ooooo`03ool00?oooooo0?ZJ00Gooooo00?o0?ZJ
o`00oooo00000_ooool00ooo003oooooooooo`0Iooooo`Ko0?ZJ00Soo`00ooooool0nY[o0?ZJool0
0?oooooo0?ZJo`0001Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool00_ooool01?oo003oooooooooool0nYX7ooooo`;o0?ZJ00So
o`00ooooooooooooooooool00?l00?ooooooo`3jVP?ooooo00?o003oo`3jV_ooool00_ooool2ool0
00Kooooo0_l0nYX00ol00?ooooooooooo`04ooooo`;o0?ZJ0ooo00000ol00?ooooooo`3jVP05oooo
o`03o`3jV_ooooooo`0000;ooooo00Co0?ZJooooool0nY[oo`001oooool01?l00?oo0?ZJooooool0
0?l2ooooo`06o`3jV_ooooooooooooooool0nY[oo`000_ooool01?l0nY[oooooo`3jV_oo0006oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool00ol0nY[oo`00ooooo`02ool00003ooooool0nY[o
oooo00?ooooo00Go0?ZJool00?oooooo0?ZJooooo`02o`3jVP03ool00?oooooooooo00_ooooo00?o
0?ZJooooool0nYX01?ooool01_l0nY[o003oool00?oooooo0?ZJool000Kooooo00Ooo`00o`3jV_oo
oooo0?ZJool00?oooooo0?ZJ00;ooooo00?o0000ooooooooool0>oooool004;ooooo00Co0000oooo
oooooooo0?ZJ0oooool01?l00?ooo`00o`3jV_oo000Hooooo`04ool00?l0nY[o0?ZJool0023ooooo
00Goo`00o`00ool0nY[oo`00o`3jVP0Oooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01Ol0
nY[o003oooooool00?oo0?ZJ00Oooooo0_l0nYX00ooo003oooooool0000Rooooo`06o`3jV_oo003o
ooooool00?l0003o0?ZJ6oooool2o`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooo`3jVP03ooooo`07o`00ool0nY[o0?ZJool00?l0nY[oooooo`3jVP03ooooo`03o`3jV_oooooo
oooo00gooooo00Oo0?ZJo`00oooo003o0?ZJooooool0nY[oo`0001gooooo0_l0nYX01_oo003o0?ZJ
ooooool0nY[oo`00o`3jVQ3ooooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`03o`3jV_oooooooooo
00;o0?ZJ00coooooool00?oooooo003ooooooooo003oooooo`3jV_oooooo0?ZJool00?ooool2o`3j
VP03ool00?oooooo0?ZJ00Gooooo00?o0?ZJo`00oooo00000_ooool00ooo003oooooooooo`0Ioooo
o`03o`3jV_oooooo0?ZJ00?o0?ZJ00Soo`00ooooool0nY[o0?ZJool00?oooooo0?ZJo`0001Oooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooo
ooooool00_ooool01?oo003oooooooooool0nYX7ooooo`03o`3jV_oo003oo`0000;o0?ZJ00Gooooo
ool00?l00?ooooooo`3jVP03ooooo`04o`00ool0nY[oooooooooo`?oo`001_ooool2o`3jVP03o`00
oooooooooooo00Cooooo0_l0nYX01_oo003o003oool00?oooooo003oo`3jVPGooooo00?o0?ZJool0
0?ooool00ol0nYX00ooooooo0?ZJool00007ooooo`;o0?ZJ00Goooooo`00ooooooooooooo`3jVP03
ooooo`08o`3jV_oo003oooooooooool0nY[oooooo`3jV_oo0006ooooo`05o`3jV_oooooooooooooo
ool0nYX00oooool01ooo003oooooooooooooooooo`00ooooool0nYX01?ooool00ol0nY[oo`00o`3j
VP02ooooo`;o0?ZJ00?oo`00ooooooooool02_ooool2o`3jVP03ooooool0nY[ooooo00?ooooo00Ko
0?ZJo`00oooo003oooooo`3jV_oo0005ooooo`08o`3jV_oo003oooooooooool0nY[oo`00o`00ool0
nYX2ooooo`03o`000?oooooooooo03_ooooo0012ooooo`04o`000?ooooooooooo`3jVP?ooooo00Co
003oool00?ooooooo`006?ooool01?oo003oooooo`3jV_oo000Pooooo`05ool00?l0nY[o0?ZJool0
0?l0nYX04_ooool00ol0nY[oooooooooo`0:ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool0
1Ol0nY[o003oool00?l00?oo0?ZJ00Oooooo00Ko0?ZJool00?l0nY[oooooool00?l0nYXQooooo`06
o`3jV_oo003oooooool00?oooooo0?ZJ7?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2
o`000005o`3jV_ooooooooooooooool00?l00_l0nYX02?oo003o0?ZJooooool0nY[oooooool00?oo
oooo0?ZJ3_ooool2o`3jVP06o`00oooo003o0?ZJooooool0nY[oo`007Oooool2o`3jVP06ool00?l0
nY[oooooo`3jV_oo003o0?ZJ4?ooool01?l0nY[oooooooooool0nYX4ooooo`06o`3jV_oooooooooo
ooooool0nY[oo`000_ooool01?l00?ooooooool00?ooool3o`3jVP07ool00?oooooo0?ZJo`3jV_oo
003oooooo`3jVP04ooooo`04o`3jV_oooooo003oool000;ooooo00?oo`00ooooooooool06Oooool0
1?l0nY[oooooooooooooool2o`3jVP08ool00?l0nY[oooooo`3jV_oo003oooooo`3jV_l0000Hoooo
o`?o00001?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool01?oo003oooooooooool0nYX6
ooooo`04o`3jV_l0003o0000o`0000;o0?ZJ0_ooool00ooo003oooooo`3jVP03ooooo`03o`00ool0
nY[ooooo00;oo`0000?o0?ZJool00?ooool01Oooool3o`3jVPKooooo00So0?ZJool00?oooooo003o
ool00?oooooo003oo`3jVPGooooo00Co0?ZJool00?oooooo0?ZJ0oooool00ol0nY[oo`00o`3jVP06
ooooo`07o`3jV_ooooooooooooooool00?ooooooo`3jVP03ooooo`08o`3jV_oo003oooooooooool0
nY[oooooo`3jV_oo0006ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooool000000_l00002
ooooo`03ool00?oooooo0?ZJ00Cooooo0_oo00001_l0nY[ooooooooooooooooo0?ZJool000Kooooo
00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool0nYX4ooooo`07o`3jV_l00?ooo`00oooo
ool0nY[oo`00o`3jVP04ooooo`08o`3jV_oo003oooooooooool0nY[oo`00o`00ool0nYX2ooooo`03
o`000?oooooooooo03_ooooo000dooooo`?o00001?ooool2o`0000Gooooo00Co0000oooooooooooo
0?ZJ0oooool01?l00?ooo`00oooooooo000Hooooo`04ool00?oooooo0?ZJool0023ooooo00Goo`00
o`3jV_ooooooo`00o`3jVP0Booooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_oo
ool01_l0nY[ooooooooooooooooo0?ZJo`00o`?oo`0000?o0?ZJooooooooool01Oooool01_l0nY[o
o`00o`3jV_ooooooo`00o`3jVR7ooooo00Ko0?ZJool00?ooooooo`00o`00ool0nYXXooooo`03o`00
0?oooooo0?ZJ00?ooooo00Oo003oo`3jV_l0nY[oo`00o`3jV_oooooo0?ZJ00;oo`0000?oooooo`3j
V_l0nYX02_ooool4o`3jVP07ooooool00?ooo`00o`3jV_oooooo0?ZJool0000Looooo`05o`3jV_oo
oooo0?ZJool00?l0nYX00_ooool00ooo003o0?ZJooooo`0?ooooo`04o`3jV_ooooooooooo`3jVPCo
oooo00?o0?ZJooooool000000_l000001ooo003oooooooooool0nY[oooooool00?ooool00_l0nYX2
ool00006ooooool0nY[o0?ZJo`00oooo003o0?ZJ1?ooool01?l0nY[oooooo`00oooo0002ooooo`03
ool00?oooooooooo01Wooooo00Co0?ZJoooooooooooooooo0_l0nYX02?oo003o0?ZJooooool0nY[o
003oool00?l0nY[o00009Oooool00ol0003oooooooooo`02ooooo`04ool00?ooooooooooo`3jVPKo
oooo00Co0?ZJo`000?l0003o00000_ooool01Ol0nY[oooooool00?oooooo0?ZJ00?ooooo00Oo003o
o`3jV_ooooooo`00ooooool0nY[oo`0000Kooooo0ol000000ol0nY[oooooooooo`03ooooo`08o`3j
V_oo003o003oo`00ooooooooo`00o`00ool0nYX5ooooo`04o`3jV_oo003o0?ZJo`3jVP?ooooo00?o
0?ZJool00?l0nYX01_ooool01ol0nY[ooooooooooooooooo003oooooool0nYX00oooool00ol0nY[o
o`00ooooo`02o`3jVP;ooooo00?oo`00o`3jV_ooool01?ooool00ol0nY[oo`00ool00002ooooo`03
o`3jV_oooooo000000;o000000Go0?ZJoooooooo003oooooo`3jVP03ooooo`04o`3jV_oo003ooooo
o`3jVP?ooooo00?o0?ZJool00?ooool01Oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_oooooo
ooooo`3jVPCooooo00Oo0?ZJool00?ooooooooooo`3jV_oo003o0?ZJ00Cooooo00So0?ZJool00?oo
ooooooooo`3jV_oo003o003oo`3jVP;ooooo00?o0000ooooooooool0>oooool003Gooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`3jVP?ooooo
00Co003oool00?ooooooo`005oooool01Ol0nY[oo`00ooooool0nY[oo`00023ooooo00Goo`00o`3j
V_ooooooo`00o`3jVP0Booooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_ooool0
2_l0nY[ooooooooooooooooo0?ZJo`00oooo003oooooool00?l0nYX7ooooo`06o`3jV_oo003ooooo
oooooooo003o0?ZJ8?ooool01ol0nY[o003oool00?ooooooo`00o`00ool0nYX0:?ooool00ol0003o
ooooo`3jVP02ooooo`04ool00?l00?oo0?ZJo`3jVP;oo`0000Coooooo`3jV_oo003oo`000_ooool0
0ol0nY[oooooooooo`08ooooo`;o0?ZJ0oooool01_l00?ooo`00o`3jV_oooooo0?ZJool001cooooo
00Co0?ZJooooool0nY[oo`000oooool00ooo003o0?ZJooooo`0>ooooo`;o0?ZJ0_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooo000000;o00000_ooool3o`3jVP0<oooooooo003o0?ZJo`3j
V_oo003oooooo`3jV_oooooo0?ZJo`00oooo003o0?ZJ1?ooool01?l0nY[oooooo`00oooo0002oooo
o`03ool00?l00?oooooo01Wooooo00ko0?ZJooooooooooooooooo`3jV_oo003oooooo`3jV_oooooo
0?ZJoooooooo003o0?ZJo`0002Gooooo00?o0000ooooooooool00_ooool01?oo003oooooooooool0
nYX6ooooo`04o`3jV_l0003o0000o`0000;ooooo00Go0?ZJoooooooo003oooooo`3jVP03ooooo`07
o`3jV_ooooooo`00ool00?oooooo0?ZJool00005ooooo`05o`3jV_l0003o0000o`000?l0nYX01?oo
ool3o`000006o`00ooooooooooooool00?l00?oo0?ZJ1Oooool00ol0nY[oo`00o`3jVP04ooooo`03
o`3jV_oo003o0?ZJ00Kooooo00Oo0?ZJooooooooooooooooo`00oooooooo0?ZJ00;ooooo00?o0?ZJ
ool00?oo00000ol0nYX2ooooo`03ool00?l0nY[ooooo00?ooooo00Co0?ZJool00?l00?ooo`000_oo
ool00ol0nY[oooooo`000002o`0000;o0?ZJ00?oo`00ooooool0nYX00oooool00ol0nY[oo`00o`3j
VP04ooooo`03o`3jV_oo003ooooo00Gooooo00?o0?ZJooooooooool00oooool01?l0nY[o003ooooo
oooo0004ooooo`07o`3jV_oo003oooooooooool0nY[oo`00o`3jVP04ooooo`08o`3jV_oo003ooooo
ooooool0nY[oooooool00?l0nYX2ooooo`03o`000?oooooooooo03_ooooo000]ooooo`Go00000ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo0_l000000ooooooo0?ZJ
ooooo`02ooooo`04o`00oooo003oooooool001Oooooo00Go0?ZJool00?oooooo0?ZJool0000Ooooo
o`06o`3jV_oo003o0?ZJoooooooo003o0?ZJ4_ooool00ol0nY[oooooooooo`09ooooo`06o`3jV_l0
0?ooo`00ool00?oooooo0?ZJ0oooool01_l0nY[o003oool00?ooooooo`00o`3jVPOooooo00Ko0?ZJ
ool00?ooooooooooool00?l0nYXPooooo`03o`3jV_oo003ooooo00;ooooo00?oo`00o`3jV_ooool0
9oooool2o`000003o`3jV_oooooooooo00;oo`0000Koooooo`3jV_oo003oo`00ooooool0nYX2ool0
00;ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`;o003o00Goo`00oooo
oooooooo0?ZJool0000Looooo`04o`3jV_ooooooo`00o`3jVP?ooooo00?oo`00o`3jV_ooool03_oo
ool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo00?o0?ZJo`00ool000000_l000001ooooooo0?ZJ
o`3jV_oooooo0?ZJoooooooo00000_l0nYX02?oo003oooooo`3jV_oooooo0?ZJo`00oooo003o0?ZJ
0oooool2o`3jVP03ooooool00?ooo`0000;ooooo00?oo`00o`00ooooool06Oooool02?l0nY[ooooo
oooooooooooo0?ZJool00?oooooo0?ZJ0_ooool01?l0nY[oo`00o`3jV_l0000Uooooo`03o`000?oo
oooooooo00;ooooo00Coo`00oooooooooooo0?ZJ1_ooool00ol0nY[o003oool00003ooooo`05o`3j
V_ooooooo`00ooooool0nYX00oooool00ol0nY[oooooool00002ooooo`03o`3jV_oo003o0?ZJ00Co
oooo00Go0?ZJo`000?l0003o0000o`3jVP04ooooo`?o00000_l0nYX01?ooooooo`00o`00ool0nYX4
ooooo`04o`3jV_oo003oooooo`3jVPCooooo00?o0?ZJool00?l0nYX01Oooool00ol0nY[o003ooooo
o`02ooooo`03o`00oooooooo0?ZJ00;ooooo00Ko0?ZJool00?oooooo0?ZJooooool0nYX2ooooo`03
ool00?l0nY[ooooo00?ooooo00Co0?ZJool00?l00?ooo`000_ooool01?l0nY[oooooo`00oooo0002
ooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?o0?ZJool00?l0nYX01Oooool00ooo003ooooooooo
o`03ooooo`;o0?ZJ1?ooool00ol0nY[o003oo`00o`02ool000?ooooo00?o0?ZJo`00oooo00000_oo
ool00ol0nY[oo`00o`3jVP04ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJool00?l0nYX00_oo
ool00ol0003oooooooooo`0kooooo`00=Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000Cooooo00Co0000oooooooooooo0?ZJ0oooool01?l00?ooo`00oooooooo000Fooooo`;o
0?ZJ00Coo`00ooooool0nY[oo`007oooool01_l0nY[oo`00o`3jV_ooooooo`00o`3jVQ;ooooo00?o
0?ZJooooooooool02Oooool00ol0nY[o003oool00002ool00006o`3jV_ooooooooooooooool0nY[o
o`000_ooool00ooo003o0?ZJooooo`06ooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ8?ooool0
1ol0nY[oo`00ooooool0nY[oooooool00?l0nYX0:?ooool02Ol0003oooooo`3jV_ooooooo`00oooo
oooo003oooooo`3jVP02ool00004ooooool0nY[oo`00ool000;ooooo00?o0?ZJooooooooool01_oo
ool2o`3jVP?ooooo0_l00?l2ool000;ooooo00?o0?ZJool00?ooool06_ooool2o`3jVP03oooooooo
003o0?ZJ00?ooooo00?oo`00o`3jV_ooool03Oooool2o`3jVP?ooooo00?o0?ZJooooooooool00_oo
ool01?l0nY[oo`00ool00?oo0003o`3jVP;ooooo00Co0?ZJoooooooo003o0?ZJ0_oo00001ooooooo
0?ZJooooool0nY[oooooool00?l0nYX00oooool01Ol0nY[oooooo`00ool00?ooo`0000;ooooo00?o
o`00o`00ooooool06Oooool01_l0nY[ooooooooooooooooo0?ZJool000;o0?ZJ0_ooool01?l0nY[o
o`00o`3jV_l0000Uooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ1_ooool0
0ol0nY[o003oool00003ooooo`05o`3jV_ooooooo`00ooooool0nYX00_ooool01?l00?oo0?ZJoooo
oooo0002ooooo`03o`3jV_oo003o0?ZJ00Cooooo00Ko0?ZJo`00oooo003oo`00o`00ool0nYX3oooo
o`?o000000Koooooo`3jV_ooooooo`00o`00ool0nYX4ooooo`04o`3jV_oo003oooooo`3jVPCooooo
00?o0?ZJool00?l0nYX01Oooool00ol0nY[o003oool00002ool00003o`00oooooooo0?ZJ00;ooooo
00Ko0?ZJool00?oooooo0?ZJooooool0nYX2ooooo`03ool00?l0nY[ooooo00;ooooo0ol000001?l0
0?ooooooool00?ooool3o`3jVP07ool00?ooooooooooo`3jV_l00?ooo`00o`3jVP03ooooo`03o`3j
V_oo003o0?ZJ00Gooooo00?oo`00ooooooooool00oooool2o`3jVPCooooo00?o0?ZJooooool00?l0
0_oo0003ooooo`03o`3jV_l00?ooo`0000;ooooo00?o0?ZJool00?l0nYX01?ooool00ol0nY[oo`00
ooooo`02ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0000ooooooooool0>oooool003Gooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`3jVP?o
oooo00Co003oool00?ooooooo`000oooool00ol0nY[oooooooooo`0@ooooo`;o0?ZJ00Coo`00oooo
ooooooooo`007oooool01_l0nY[oo`00o`3jV_ooooooo`00o`3jVQ7ooooo0_l0nYX:ooooo`07o`3j
V_l00?ooo`00o`00ooooooooo`00o`3jVP03ooooo`03o`3jV_oo003ooooo00;ooooo00?oo`00oooo
ooooool01?ooool01ol0nY[o0000o`000?l0003oooooool00?l0nYX08?ooool00ol0nY[oo`00oooo
o`02o`3jVP03ool00?l0nY[ooooo02Oooooo00Wo0000ooooool0nY[oooooool00?l00?ooo`00oooo
ool0nYX00_oo00001?oooooo0?ZJool00?oo0002ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX3
ooooo`;o003o00Koo`00o`3jV_ooooooooooo`3jV_oo000Kooooo`03o`3jV_oooooo000000;o0000
0oooool00ooo003o0?ZJooooo`0<ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`02ooooo`04o`3j
V_oo003oooooool000;o0?ZJ0oooool00ol0nY[oooooool00002ool00008o`00ool0nY[ooooooooo
ool0nY[oooooool00?l0nYX3ooooo`05o`3jV_oooooo003ooooooooo00000_ooool00ooo003o0?ZJ
ooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo0_oo00002?l0nY[ooooooooooooooooo0?ZJool0
0?l0nY[o00009Oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVPKooooo00?o
0?ZJo`00oooo00000oooool01Ol0nY[oooooool00?oooooo0?ZJ00;ooooo00?o003oo`3jV_oo0000
0oooool00ol0nY[oo`00o`3jVP04ooooo`06o`3jV_l00?ooo`00ool00?l00?oo0?ZJ0oooool01?l0
nY[oo`00ooooooooool2o`3jVP04ool00?l00?ooooooo`3jVP?ooooo00?o0?ZJool00?l0nYX01Ooo
ool00ol0nY[oo`00o`3jVP03ooooo`06o`3jV_oooooo0?ZJo`00oooo003ooooo0_oo00001ooooooo
0?ZJoooooooooooo0?ZJool00?l0nYX00_ooool01Ol0nY[ooooooooooooo003o0?ZJ00?ooooo0ol0
00000ol0nY[oooooool00002ooooo`;o0?ZJ00Soo`00oooooooooooo0?ZJo`00oooo003oooooo`3j
VP;ooooo00?o0?ZJool00?l0nYX01Oooool00ooo003oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ
00;ooooo00?o003oo`3jV_ooool00ooo0003ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJool0
0?l0nYX00oooool00ol0nY[o003oool00003ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0000oooo
ooooool0>oooool003Cooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooo
oooooooo0?ZJ0oooool01?l00?ooo`00oooooooo0002ooooo`;o0?ZJ4_ooool00ol0nY[oo`00o`3j
VP02ooooo`03ool00?oooooooooo01_ooooo00So0?ZJooooool0nY[oo`00o`3jV_ooooooo`00o`3j
VQ7ooooo0_l0nYX:ooooo`07o`3jV_l00?ooo`00o`00ooooooooo`00o`3jVP02ooooo`03o`3jV_l0
0?ooo`0000?ooooo00?oo`00ooooooooool01?ooool01ol0nY[o0000o`000?l0003oooooool00?l0
nYX08?ooool00ol0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo02Oooooo00Wo0000ooooool0
nY[oooooool00?l00?ooo`00ooooool0nYX00_oo00001?oooooo0?ZJool00?oo0002ooooo`03o`3j
V_oooooooooo00Kooooo0_l0nYX01?oo003oooooo`00ool00?l2ool00005o`3jV_oooooooooooooo
oooo00006oooool00ol0nY[oooooo`000002o`0000?ooooo00?oo`00o`3jV_ooool02oooool00ol0
nY[oooooooooo`04ooooo`03ool00?oooooooooo00;ooooo00Go0?ZJool00?ooooooooooo`3jVP04
ooooo`03o`3jV_oooooo000000;o000000?o003oo`3jV_ooool00_ooool00ol0nY[oo`00o`3jVP03
ooooo`05o`3jV_oooooo003ooooooooo00000_ooool00ooo003o0?ZJooooo`0Hooooo`04o`3jV_oo
ooooo`00ool000?o000000So0?ZJooooooooooooooooo`3jV_oo003o0?ZJo`0002Gooooo00?o0000
ooooooooool00_ooool01?l0nY[oo`00ooooool0nYX6ooooo`03o`3jV_l00?ooo`0000?ooooo00Go
0?ZJooooooooooooo`00o`3jVP02ooooo`03o`00ool0nY[oo`0000?ooooo00?o0?ZJool00?l0nYX0
1?ooool01_l0nY[oooooool00?l0nY[oo`00o`3jVP;ooooo00?o0?ZJoooooooo00000oooool01Ol0
nY[oo`00o`00oooooooo0?ZJ00?ooooo00?o0?ZJool00?l0nYX01Oooool00ol0nY[oo`00o`3jVP03
ooooo`04o`3jV_l00?oo0?ZJool000?ooooo00?oo`00ooooool0nYX00_ooool00ol0nY[oo`00o`3j
VP05ooooo`03ool00?l0nY[ooooo00;ooooo0ol000000ol0nY[o003oool00002ooooo`;o0?ZJ00So
o`00oooooooooooo0?ZJoooooooo003oooooo`3jVP;ooooo00?oo`00o`3jV_ooool01Oooool00ooo
003oooooooooo`02ooooo`;o0?ZJ00Coooooo`3jV_oooooo003o0_l0nYX01?ooooooo`00o`00oooo
0003ooooo`03o`3jV_oo003ooooo00Co0?ZJ00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00?o
oooo00Ko0?ZJool00?oooooo0?ZJooooool0nYXmooooo`00=Oooool00ol0003oooooooooo`03oooo
o`;o00001Oooool01?l0003oooooooooool0nYX3ooooo`04o`00oooo003oooooool000;ooooo0_l0
nYXAooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool06oooool01?l0nY[ooooo
o`3jV_oo0002ooooo`03o`3jV_oo003ooooo013ooooo0_l0nYX:ooooo`04o`3jV_oo003oo`00o`00
o`;ooooo00[oo`00oooooooooooo0?ZJo`00oooo003oooooo`3jV_ooooooo`001_ooool01ol0nY[o
0000o`000?l0003oooooo`3jV_oo00008?ooool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX0
:?ooool02Ol0003o0?ZJooooooooooooo`00o`00oooo003oooooo`3jVP02ool00004ooooool0nY[o
o`00ool000;ooooo00?o0?ZJooooooooool01_ooool2o`3jVPGoo`0000?oooooo`3jV_ooool00_oo
ool00ooo003oooooooooo`0Hooooo`03o`3jV_oooooooooo00?o00000oooool00ooo003o0?ZJoooo
o`0;ooooo`03o`3jV_oooooooooo00?ooooo0_oo0004ooooo`05o`3jV_oo003oooooooooool0nYX0
1Oooool01?l0nY[o0000o`000?l00002o`3jVP?ooooo00?o0?ZJool00?l0nYX00_ooool01_l0nY[o
ooooooooool00?ooooooool000;ooooo00?oo`00o`3jV_ooool06?ooool01?l0nY[oo`00ool00?oo
0003o`0000Cooooo00Co0?ZJool00?l0nY[o00009Oooool00ol0003oooooooooo`02ooooo`04o`3j
V_oo003oooooo`3jVPKooooo00?o0?ZJo`00oooo00001?ooool01?l0nY[oooooool00?l0nYX2oooo
o`03o`00ool0nY[oo`0000?ooooo00?o0?ZJool00?l0nYX01?ooool02ol0nY[oo`00ool00?l0nY[o
o`00ooooool0nY[oooooo`3jV_ooooooo`0000?ooooo00Go0?ZJoooooooo003o003oo`3jVP03oooo
o`03o`3jV_oo003o0?ZJ00Gooooo00?o0?ZJool00?l0nYX00oooool2o`3jVP03oooooooo003ooooo
00;ooooo00?o003oool00?l0nYX00_ooool00ol0nY[oo`00o`3jVP05ooooo`03ool00?l0nY[ooooo
00;ooooo00?o0?ZJool00?ooool00_l0nYX00ooo003oooooooooo`02o`00o`08ool00?oooooooooo
o`3jV_ooooooo`00ooooool0nYX2ooooo`03ool00?l0nY[ooooo00Gooooo00?oo`00ooooooooool0
0_ooool01ol0nY[o003oo`00ool0nY[oooooo`00ool0nYX00_ooool00ooo003o003oool00003oooo
o`05o`3jV_oo003oooooo`3jV_ooool00_l0nYX01ooo003ooooooooooooooooo0?ZJool00?l0nYX0
0oooool01_l0nY[oo`00ooooool0nY[oooooo`3jVSgooooo0012ooooo`04o`000?ooooooooooo`3j
VP?ooooo00Co003oool00?ooooooo`000_ooool2o`3jVQ7ooooo00Co0?ZJoooooooo003o0?ZJ0_oo
ool00ooo003o0?ZJooooo`0Kooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?o0?ZJool00?ooool0
4?ooool2o`3jVPSooooo00Co0?ZJooooool0nY[oo`000_ooool00ol00?ooooooool00002ooooo`07
o`3jV_oo003oo`00ooooool0nY[oooooool00006ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJ
ool00?ooool07?ooool02_l0nY[oooooo`3jV_l00?ooo`00o`3jV_oooooo0?ZJool00?l0nYXXoooo
o`09o`000?l0nY[ooooooooooooo003o003oool00?oooooo0?ZJ00;oo`0000Ooooooo`3jV_oo003o
ooooool00?oooooo0?ZJ00Sooooo00?o0?ZJool00?l00?l00_l00?l3ooooo`05o`3jV_oooooooooo
oooooooo00005Oooool00ol0nY[oooooooooo`03o`3jVP;ooooo00?o003oool00?ooool00oooool0
0ooo003o0?ZJooooo`0;ooooo`03o`3jV_oooooooooo00;ooooo0ooo0004ooooo`04ool00?l00?oo
ooooo`3jVPKooooo00Go0?ZJo`000?l0003o0000o`3jVP04ooooo`03o`3jV_l00?ooo`0000;ooooo
00Ko0?ZJoooooooooooo003ooooooooo0002ooooo`03ool00?l0nY[ooooo01Sooooo00Co0?ZJool0
0?l00?oo003o0ol00004ooooo`04o`3jV_oo003o0?ZJo`0002Gooooo00?o0000ooooooooool00_oo
ool01?l0nY[oo`00ooooool0nYX5ooooo`04o`3jV_oooooo003oool000Cooooo00Co0?ZJoooooooo
003o0?ZJ0_ooool00ol0nY[oooooool00003ooooo`;o0?ZJ00Ooo`00ooooooooooooooooo`3jV_l0
0?ooo`0000;o0?ZJ00?oo`00o`00ool0nYX00_l0nYX00oooooooo`00ooooo`02ooooo`04o`3jV_oo
ooooo`00o`00o`;o0?ZJ0_ooool00ooo003oooooo`3jVP06ooooo`03ool00?l0nY[ooooo00;ooooo
0_l0nYX00ooo003oooooooooo`02ooooo`03o`00oooo003o0?ZJ00;ooooo00?oo`00o`3jV_l0nYX0
1Oooool00ooo003o0?ZJooooo`02ooooo`08o`3jV_oo003oooooooooool0nY[oooooool00?ooool2
o`00o`07ool00?ooooooooooooooool0nY[oo`00ooooo`02o`3jVP03oooooooo003o0?ZJ00Kooooo
00?oo`00ooooooooool00_ooool03?l0nY[o003oo`00ool0nY[oooooo`00ool0nY[oooooool00?oo
oooo003oool000?ooooo00Co0?ZJool00?l0nY[o0?ZJ0_ooool00ol0nY[oo`00ooooo`02ooooo`03
o`3jV_oo003o0?ZJ00?ooooo00Ko0?ZJool00?oooooo0?ZJooooool0nYXmooooo`00@_ooool01?l0
003oooooooooool0nYX2ooooo`05o`00ooooooooo`00oooooooo00000_ooool2o`3jVQ3ooooo0_l0
nYX00oooooooo`00ooooo`02ooooo`03ool00?l0nY[ooooo01_ooooo00Co0?ZJoooooooo003o0?ZJ
0_ooool00ol0nY[oo`00o`3jVP0@ooooo`;o0?ZJ1oooool4o`3jVP0?ool00?ooooooooooo`00oooo
ooooo`00o`3jV_oooooo0?ZJool00?oooooo0?ZJooooool0nY[oo`0000Kooooo00?o0?ZJoooooooo
00000_ooool00ol0nY[oo`00ooooo`0Looooo`0:o`3jV_oooooo0?ZJool00?oooooo0?ZJooooool0
nY[oo`00o`3jVRSooooo00Co0000o`3jV_ooooooo`000_l00?l00ooo003oooooo`3jVP02ool00007
ooooool0nY[oo`00oooooooo003oooooo`3jVP08ooooo`04o`3jV_oo003o003oo`00o`Cooooo00Ko
0?ZJooooooooooooooooool00?l0nYXDooooo`04o`3jV_ooooooooooo`3jVP?ooooo0_l00?l00ooo
003oooooooooo`02ooooo`03ool00?l0nY[ooooo00_ooooo00?o0?ZJooooooooool00_ooool00ooo
003oooooool00004ooooo`04ool00?l00?ooooooo`3jVPKooooo00Co0?ZJo`00ool0nY[o0?ZJ1Ooo
ool01Ol0nY[o003oool00?oooooo0?ZJ00?ooooo00?o003ooooooooo00000_ooool00ooo003o0?ZJ
ooooo`0Hooooo`03o`3jV_oo003o003o00;o003o00?o0?ZJooooooooool00oooool01?l0nY[o003o
ool00?l0nYXUooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ1Oooool01?l0
nY[oooooo`00oooo0004ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?o0?ZJool00?ooool00ooo
ool2o`3jVP07ool00?ooooooooooooooool0nY[oooooool00002o`3jVP03ool00?l00?oooooo00?o
oooo00Soo`00ooooooooooooooooo`3jV_ooooooo`00o`00o`;o0?ZJ00Coooooo`3jV_oo003o0?ZJ
1oooool00ooo003o0?ZJooooo`02ooooo`;o0?ZJ00?oo`00ooooooooool00_ooool00ol00?oooooo
ool00002ooooo`03ool00?l0nY[ooooo00Gooooo00?oo`00o`3jV_ooool00_ooool02ol0nY[oo`00
oooooooooooo0?ZJoooooooo003oooooo`00ooooooooo`0000?ooooo00?o0?ZJool00?ooool00ol0
nYX00ooo003o0?ZJooooo`05ooooo`03ool00?oooooooooo00;ooooo00Co0?ZJo`000?l0003o0000
0_l0nYX2ooooo`04ool00?oooooo003oool000;ooooo00Co0?ZJo`00oooo003o0?ZJ0oooool00ol0
nY[oo`00ooooo`02ooooo`03o`3jV_oo003o0?ZJ00?ooooo00Co0?ZJool00?oooooo0?ZJ0_l0000m
ooooo`00@_ooool01?l0003oooooooooool0nYX2ooooo`05o`00ooooooooo`00oooooooo00000_oo
ool2o`3jVP03ooooool0nY[ooooo00gooooo00?o0?ZJooooool000000_l00002ooooo`03ool00?l0
nY[ooooo01_ooooo00Co0?ZJoooooooo003o0?ZJ0_ooool00ol0nY[oo`00o`3jVP0?ooooo`03o`3j
V_oooooo0?ZJ00Oooooo0ol0nYX2ool00005ooooool0nY[o0?ZJoooooooo00000ol0nYX01_oo003o
ooooo`3jV_oooooo0?ZJool000Gooooo00Co0?ZJooooool00?ooo`000_ooool00ol0nY[oo`00oooo
o`0Kooooo`;o0?ZJ00Woooooo`3jV_oo003oooooo`3jV_oooooo0?ZJool00?l0nYX0:?ooool01?l0
003o0?ZJoooooooo0002o`00o`03ool00?oooooo0?ZJ00;oo`0000Ooooooo`3jV_oo003oooooool0
0?oooooo0?ZJ00Oooooo0_l0nYX00ooo003oooooo`00o`04ooooo`06o`3jV_oooooooooooooooooo
003o0?ZJ2oooool2o`3jVPOooooo00Co0?ZJooooool0nY[o0?ZJ0_ooool01?l00?oooooooooooooo
0004ooooo`03o`3jV_oo003o0?ZJ00_ooooo00?o0?ZJool00?oo00000_oo0002ooooo`09ool00?oo
ooooooooooooool0nY[oo`00o`00oooooooo0?ZJ00Kooooo00?o0?ZJooooool0nYX01_ooool00ol0
nY[o003oool00002o`3jVP06ooooool00?oo003oo`00ooooooooo`000_ooool00ooo003o0?ZJoooo
o`0Cooooo`;o0?ZJ0oooool01_l0nY[oo`00o`00oooooooo003oo`3jVPGooooo00Co0?ZJo`00oooo
003o0?ZJ9Oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVPGooooo00Co0?ZJ
ooooool00?ooo`001?ooool01?l0nY[oooooool00?l0nYX2ooooo`03o`3jV_oo003ooooo00Go0?ZJ
00Ooo`00ooooooooooooooooo`3jV_ooooooo`0000;o0?ZJ00?oo`00o`00ooooool00_ooool2ool0
00?ooooo00[o0?ZJoooooooo003o003oooooool0nY[oooooo`3jV_oo003o0?ZJ1oooool01?oo003o
0?ZJooooooooool2o`3jVP;oo`001?ooool01ol00?ooooooool00?oooooo0?ZJool00?l0nYX01_oo
ool00ooo003o0?ZJooooo`02ooooo`0;o`3jV_oo003oooooooooool0nY[oooooool00?oooooo003o
oooooooo00000oooool00ol0nY[oo`00ooooo`03o`3jVP03ool00?oooooooooo00Gooooo00?oo`00
ooooooooool00_ooool01?l0nY[o0000o`000?l00002o`00o`;ooooo00Coo`00ooooooooooooo`00
0_ooool01?l0nY[oo`00ooooool0nYX3ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJool00?l0
nYX00oooool01?l0nY[oo`00ooooool0nYX2o`0003gooooo0012ooooo`03o`000?oooooo0?ZJ00?o
oooo00Go003ooooooooo003oooooool00002ooooo`Co0?ZJ3Oooool00ol0nY[oooooooooo`03o`00
00;ooooo00?oo`00o`3jV_ooool06oooool2o`3jVP07ool00?l0nY[oooooooooool0nY[oo`00o`3j
VP0?ooooo`03o`3jV_oooooo0?ZJ00Oooooo0ol0nYX00ooo003oooooooooo`02o`3jVP09oooooooo
003o0?ZJo`3jV_l00?ooo`00ooooool0nY[ooooo00?o00001?ooool01?l0nY[oooooo`00oooo0002
ooooo`03o`3jV_oo003ooooo01_ooooo0_l0nYX00ooooooo0?ZJool00002o`3jVP04ooooool0nY[o
o`00o`3jVRSooooo00Wo0000o`3jV_oo003oo`00o`00ooooooooo`00ooooool0nYX00_oo00001ooo
oooo0?ZJool00?ooooooo`00oooooooo00001oooool2o`3jVP03ool00?l0nY[ooooo00Cooooo00Ko
0?ZJooooooooooooooooool00?l0nYX:ooooo`03o`3jV_oooooo0?ZJ00Kooooo0_l0nYX01_oooooo
0?ZJo`00ool00?ooooooo`00o`;ooooo00?oo`00ooooooooool00_ooool00ol0nY[oo`00o`3jVP0;
ooooo`04ool00?ooooooo`00ool000?ooooo00Woo`00ooooooooooooooooo`3jV_oo003o003ooooo
ool0nYX01_ooool00ol0nY[oooooo`3jVP06ooooo`04o`3jV_l00?ooo`00o`3jVP;ooooo0_l00?l2
ooooo`05ool00?ooooooooooool00?l0nYX04_ooool4o`3jVP?ooooo00?o0?ZJool00?ooool00_oo
ool00ol0nY[oooooooooo`03ooooo`04o`3jV_l00?ooo`00o`3jVRGooooo00?o0000ooooooooool0
0_ooool01?l0nY[oo`00ooooool0nYX5ooooo`04o`3jV_oooooo003oool000Cooooo00_o0?ZJoooo
oooo003o0?ZJooooool00?oo0?ZJool00?oooooo0?ZJooooo`03o`3jVP05ool00?oooooooooooooo
ool0nYX00_oo00001?l0nY[oooooo`3jV_oo0003ooooo`03ool00?l0nY[ooooo00;ooooo00[o0?ZJ
oooooooo003o003oooooool0nY[oooooo`3jV_oo003o0?ZJ1oooool01?oo003o0?ZJooooooooool2
o`3jVP03ool00?oooooooooo00Cooooo00Ko003oool00?oooooo0?ZJool00?l0nYX6ooooo`07ool0
0?l0nY[oooooooooool0nY[o003oool00002ooooo`07o`3jV_ooooooo`00ooooool00?ooooooool0
0003ooooo`04o`3jV_oo003oooooooooo`;o0?ZJ00?oo`00ooooooooool01Oooool00ooo003ooooo
ooooo`02ooooo`05o`3jV_l0003o0000o`000?l00?l00_ooool01Ooo003oooooooooooooooooo`00
00;ooooo00Co0?ZJool00?oooooo0?ZJ0oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooo
0?ZJ00?ooooo00Co0?ZJool00?oooooo0?ZJ0_l0000mooooo`00@_ooool00ol0003oooooo`3jVP03
ooooo`05o`00ooooooooo`00oooooooo00000_ooool3o`3jVP03ooooool0nY[ooooo00_ooooo00?o
0?ZJooooooooool00ol00002ooooo`03ool00?l0nY[ooooo01[ooooo00Go0?ZJooooool0nY[oo`00
o`3jVP02ooooo`03o`3jV_oo003o0?ZJ00oooooo00?o0?ZJooooool0nYX01_ooool02ol0nY[ooooo
o`3jV_l0nY[oo`00ooooool0nY[oooooo`00ool0nY[oo`0000;o0?ZJ00Goo`00oooooooooooo0?ZJ
ooooo`03o`0000Cooooo00Co0?ZJooooool00?ooo`000_ooool00ol0nY[oo`00ooooo`0Kooooo`Co
0?ZJ00Ooo`00o`3jV_ooooooooooo`3jV_l0003oo`0002;ooooo0_l00004ooooo`03o`3jV_l00?oo
o`0000;o003o00Coooooool00?oooooo0?ZJ0_oo00001ooooooo0?ZJool00?ooooooo`00oooooooo
00001oooool2o`3jVP03ool00?l0nY[o0?ZJ00Cooooo00Ko0?ZJooooooooooooooooool00?l0nYX9
ooooo`;o0?ZJ00?oooooo`3jV_ooool01Oooool2o`3jVP03ooooool0nY[o003o00?o003o0_ooool0
0ooo003oooooooooo`02ooooo`03o`3jV_oo003o0?ZJ00[ooooo00?o0?ZJool00?ooool01Oooool0
1ooo003ooooooooooooooooo0?ZJool00?l00?l00_l0nYX6ooooo`03o`3jV_oooooo0?ZJ00Kooooo
00Co0?ZJo`000?l0003o00000ol00?l2ooooo`;oo`000_ooool00ooo003o0?ZJooooo`0?ooooo`?o
0?ZJ0_ooool01_l0nY[ooooooooooooooooo0?ZJool000?ooooo00?o0?ZJooooooooool00oooool0
1?l0nY[oooooool00?l0nYXHooooo`?o00001?ooool2o`0000Cooooo00?o0000ooooooooool00_oo
ool01?l0nY[oo`00ooooool0nYX5ooooo`04o`3jV_oooooo003oool000Cooooo00So0?ZJoooooooo
003o0?ZJooooool00?oo0?ZJool000;o0?ZJ0_ooool2o`3jVP0;ool00?ooooooooooooooool0nY[o
o`00ooooool0nY[oooooo`3jV_oo00000oooool00ooo003o0?ZJooooo`03ooooo`09o`3jV_oo003o
003oooooool0nY[oooooo`3jV_oo003o0?ZJ00Oooooo00Coo`00o`3jV_oooooooooo0_l0nYX00ooo
003o0?ZJo`3jVP02o`3jVP;ooooo00Ko003oool00?oooooo0?ZJool00?l0nYX6ooooo`07ool00?l0
nY[oooooooooool0nY[o003oool00003ooooo`06o`3jV_oo003oooooo`00ooooooooo`000oooool0
1ol0nY[o003oool00?oooooo0?ZJool00?l0nYX01oooool01_oo003ooooooooooooooooo0?ZJo`00
o`?oo`0000Co003oooooooooooooo`000oooool01_oo003oooooooooool0nY[oo`00o`3jVPGooooo
00Ooo`00oooooooooooo0?ZJool00?oooooo0?ZJ00?ooooo00?o0?ZJool00?ooool00_l0nYX00ooo
003oooooooooo`0kooooo`00@_ooool00ol0003oooooo`3jVP03ooooo`05o`00ooooooooo`00oooo
oooo00000_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00_ooooo00Ko0?ZJooooooooooooooooo`00
oooo0003ooooo`03ool00?l0nY[ooooo01[ooooo00Go0?ZJooooool0nY[oo`00o`3jVP02ooooo`03
o`3jV_oo003o0?ZJ00kooooo00Co0?ZJoooooooooooo0?ZJ1_ooool00ol0nY[oooooo`3jVP02ool0
0006ooooool0nY[oooooo`00ool0nY[oo`000_l0nYX00ooo003oooooo`3jVP02ooooo`?o00001?oo
ool01?l0nY[oooooo`00oooo0003ooooo`03ool00?oooooooooo01Wooooo1?l0nYX00ooo003ooooo
o`3jVP02ooooo`03o`3jV_ooooooo`00027ooooo00Co0000oooooooooooo00000oooool2o`000007
ool00?oooooooooooooooooo003oooooo`3jVP02ool00007ooooool0nY[oo`00o`3jV_oo003o003o
ool00007ooooo`;o0?ZJ00Coo`00ooooool0nY[o0?ZJ0oooool01_l0nY[oooooooooooooooooo`00
o`3jVPWooooo00Co0?ZJoooooooooooo0?ZJ1_ooool2o`3jVP03ooooool0nY[o003o00;o003o0ooo
ool00ooo003oooooooooo`02ooooo`03o`3jV_oo003o0?ZJ00[ooooo00?o0?ZJool00?l00?l01Ooo
ool01ooo003ooooooooooooooooo0?ZJool00?l0nYX02?ooool00ol0nY[oooooo`3jVP06ooooo`04
o`3jV_l0003o0000o`0000;o003o1?oo00001Ol0nY[ooooooooooooo003o0?ZJ013ooooo00?o0?ZJ
ooooooooool00_ooool01_l0nY[ooooooooooooooooo0?ZJool000?ooooo00?o0?ZJooooooooool0
0oooool01?l0nY[oooooool00?l0nYXGooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ1Ooo
ool01?l0nY[o003ooooooooo0004ooooo`09o`3jV_ooooooo`00o`3jV_oooooo003oool00?oooooo
0?ZJ00?ooooo00?o0?ZJoooooooo00000oooool01ol0nY[oo`00ooooool0nY[oooooo`3jV_oo0000
0_ooool00ol00?ooo`00o`3jVP04ooooo`09o`3jV_oo003o003oooooool0nY[oooooo`3jV_oo003o
0?ZJ00Oooooo00Coo`00o`3jV_oooooooooo0ol000001?l0nY[oooooooooool0nYX2ooooo`05o`00
oooo003oooooo`3jV_oo00001oooool01ooo003o0?ZJoooooooooooo0?ZJool00?l0nYX00oooool0
1_l0nY[oooooool00?l00?ooooooool000?ooooo00Oo0?ZJo`00oooo003oooooo`3jV_oo003o0?ZJ
00Oooooo00[oo`00o`3jV_ooooooooooo`3jV_l00?ooo`00ooooool0nY[oo`000_ooool01_oo003o
ooooooooool0nY[oo`00ooooo`;o0?ZJ00?oo`00o`3jV_ooool01?ooool01Ooo003oooooooooool0
nY[oo`0000;o0?ZJ0oooool00ol0nY[o003oool00002o`3jVP03ool00?oooooooooo03_ooooo0012
ooooo`03o`000?oooooo0?ZJ00;ooooo00Koo`00o`00ooooooooo`00oooooooo0002ooooo`05o`3j
V_oooooo0?ZJooooool0nYX02oooool01?l0nY[oooooooooooooool2ool000?ooooo00?oo`00o`3j
V_ooool06_ooool01?l0nY[oooooool00?l0nYX3ooooo`03o`3jV_oo003o0?ZJ00kooooo00Co0?ZJ
oooooooooooo0?ZJ1_ooool01_l0nY[oooooo`3jV_oo003oooooo`3jVP;ooooo00So003oo`3jV_oo
ooooo`00oooooooo003oooooo`3jVP;ooooo0_l0nYX01Ooo003ooooooooooooooooo0?ZJ00;ooooo
00?o003oool00?ooool00_ooool00ooo003o003oooooo`0Iooooo`07o`3jV_oooooo0?ZJo`3jV_oo
003oooooo`3jVP02ooooo`03o`3jV_l0003o0000027ooooo00Co0000oooooooooooo00000oooool2
o`0000Cooooo00?oo`00ooooool0nYX00_oo00001ooooooo0?ZJool00?l0nY[oo`00o`00oooo0000
1oooool2o`3jVP03ool00?oooooooooo00Go0?ZJ0oooool01?oo003o0?ZJooooooooool2o`3jVPGo
oooo00Co0?ZJoooooooooooo0?ZJ1_ooool2o`3jVP03ooooool0nY[oo`0000;oo`000oooool00ooo
003oooooooooo`02ooooo`03o`3jV_oo003o0?ZJ00[ooooo00?o0?ZJool00?l00?l01Oooool01ooo
003ooooooooooooooooo0?ZJool00?l0nYX02Oooool2o`3jVPKooooo00Co0?ZJo`000?l0003o0000
0ooo0003ooooo`05o`3jV_ooooooooooo`3jV_oo00004?ooool00ol0nY[oooooooooo`02ooooo`06
o`3jV_ooooooooooooooool0nY[oo`000_l0nYX00ooooooo0?ZJooooo`04ooooo`04o`3jV_l0003o
0000o`0001_ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooooooool2o`0000?o
oooo00Co0?ZJool00?oooooo0?ZJ1Oooool01?l0nY[o003ooooooooo0004ooooo`09o`3jV_oooooo
003oool00?oooooo0?ZJool00?oooooo0?ZJ00Gooooo013oo`00ooooooooooooooooo`3jV_oo003o
ooooo`3jV_oooooo0?ZJool00?l00?ooooooo`00oooo003o0?ZJ1?ooool02?l0nY[oooooool00?oo
oooo0?ZJoooooooo003o0?ZJ2?ooool01?oo003o0?ZJooooooooool3o`0000?ooooo0_l0nYX01_oo
oooo003oool00?oooooo0?ZJool000Oooooo00Oo0?ZJool00?ooooooooooo`3jV_oo003o0?ZJ00?o
oooo00?o0?ZJoooooooo00000_ooool02ooo003ooooooooooooooooo0?ZJo`00oooo003oooooo`3j
V_oo003o0?ZJ00Oooooo00Woo`00o`3jV_ooooooooooo`3jV_l00?ooo`00ooooool0nYX00ooo0002
ooooo`08o`3jV_l0003o0000o`000?l0nY[o003oool00?l0nYX5ooooo`06ool00?ooooooooooo`3j
V_oo003o0?ZJ1?ooool00ol0nY[o003oool00002o`3jVP03ool00?oooooooooo03_ooooo0012oooo
o`03o`000?oooooo0?ZJ00;ooooo0_oo00001?ooooooo`00oooooooo0002ooooo`05o`3jV_oooooo
ooooooooool0nYX02oooool01_l0nY[oooooooooooooooooo`00o`3jVP?ooooo00?o0?ZJool00?oo
ool06Oooool01Ol0nY[ooooooooooooo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX03Oooool2o`3j
VP;ooooo00?o0?ZJooooooooool01?ooool01_l0nY[oooooo`3jV_oo003oooooo`3jVP?ooooo00Oo
0?ZJoooooooo003oo`00o`00oooooooo0?ZJ00;ooooo0_l0nYX02Ooo003ooooooooooooooooo0?ZJ
ooooool00?ooooooool00003ooooo`03ool00?l00?oooooo01Wooooo00Oo0?ZJooooool0nY[o0?ZJ
ool00?oooooo0?ZJ00;ooooo00?o0?ZJo`000?l000008Oooool01?l0003oooooooooool00003oooo
o`;o00001?ooool00ooo003oooooooooo`02ool00007ooooool0nY[oo`00o`3jV_oo003o003oool0
0003o`3jVPCooooo0_l0nYX00ooo003oooooooooo`08ooooo`03ool00?l0nY[o0?ZJ00?o0?ZJ1Ooo
ool01?l0nY[oooooooooool0nYX6ooooo`;o0?ZJ00?oooooool00?oo00000_ooool4ool000Cooooo
00?o0?ZJool00?l0nYX02_ooool01?oo003o003oo`3jV_l00?l4ooooo`07ool00?oooooooooooooo
ool0nY[oo`00o`3jVP09ooooo`;o0?ZJ1_ooool01?l0nY[oooooo`3jV_l00?l6ooooo`05o`3jV_oo
ooooooooo`3jV_oo00001?ooool00ol0nY[oooooooooo`02ooooo`Co0?ZJ0_ooool00ol0nY[ooooo
ooooo`03ooooo`08o`3jV_oooooooooooooooooo003o003oo`3jV_ooool2o`3jVPGooooo00Co0?ZJ
o`000?l0003o00006Oooool2o`0000?ooooo00Co0000oooooooooooo00000oooool00ol0003ooooo
ooooo`02ooooo`04o`3jV_oo003oooooo`3jVPGooooo00Co0?ZJo`00ooooooooo`001?ooool01?l0
nY[oooooo`00oooo0002o`3jVP03ool00?l0nY[ooooo00Gooooo013oo`00oooooooooooo0?ZJo`00
oooo003oooooo`3jV_oooooo0?ZJool00?l00?ooooooool00?oooooo0?ZJ1?ooool02?l0nY[ooooo
ool00?oooooo0?ZJoooooooo003o0?ZJ2?ooool01?oo003o0?ZJooooooooool3o`0000Cooooo00Oo
0?ZJooooool00?ooo`00oooooooo003o0?ZJ00Oooooo00Oo0?ZJool00?ooooooooooo`3jV_oo003o
0?ZJ00?ooooo00Co0?ZJoooooooo003ooooo0_oo0003ooooo`07o`3jV_l00?ooo`00ooooool0nY[o
o`00o`3jVP07ooooo`05ool00?l0nY[oooooooooool0nYX00_oo00000ooooooo0?ZJooooo`02ool0
00;ooooo00So0?ZJo`000?l0003o0000o`3jV_oo003oooooo`3jVPGooooo00Koo`00oooooooooooo
0?ZJool00?l0nYX5ooooo`05o`3jV_oo003o0?ZJo`3jV_oo0000?Oooool004;ooooo00?o0000oooo
ool0nYX00_ooool2ool00004oooooooo003oooooool000;ooooo00Go0?ZJooooooooooooooooo`3j
VP0:ooooo`04o`3jV_ooooooooooooooo`;oo`0000Ko0?ZJooooooooooooooooo`3jV_oo000Joooo
o`05o`3jV_l0003o0000o`000?l0nYX00oooool00ol0nY[oo`00o`3jVP0=ooooo`05o`3jV_oooooo
ooooooooool0nYX01_ooool01Ol0nY[oooooo`3jV_oo003o0?ZJ00Cooooo0ol000001?oo003o003o
o`3jV_l0nYX2ooooo`;o0?ZJ00?oo`00o`3jV_ooool00_l0nYX01?oooooo003ooooooooo0003oooo
o`03ool00?l00?oooooo01Wooooo00Ko0?ZJooooool0nY[oo`00o`00ool0nYX4ooooo`;o00008Ooo
ool01?l0003oooooooooool00003ooooo`;o0?ZJ1?ooool02_oo003oooooool00?l0nY[oo`00oooo
ool0nY[oo`00o`3jV_l00?l2ool00003o`3jV_oooooooooo00;o0?ZJ0_ooool2o`3jVP03ool00?oo
oooooooo00Sooooo00Koo`00ooooool0nY[o0?ZJooooool0nYX4ooooo`05o`3jV_oooooooooooooo
ool0nYX01_ooool3o`3jVP03ool00?oooooooooo00?ooooo0_oo0004ooooo`03o`3jV_oo003o0?ZJ
00;o0?ZJ2?ooool01?oo003o0?ZJo`3jV_l0nYX4ooooo`07ool00?ooooooooooooooool0nY[oo`00
o`3jVP09ooooo`;o0?ZJ1_ooool01?l0nY[oooooo`3jV_l00?l6ooooo`05o`3jV_ooooooooooo`3j
V_oo00000oooool2o`3jVPCooooo00?o0?ZJooooooooool00_l0nYX00ooooooo0?ZJooooo`04oooo
o`06o`3jV_oooooooooooooooooo003o0?ZJ2Oooool01?l0nY[o0000o`000?l0000Kooooo`04o`00
0?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`000004ooooo`04o`3jV_oo003ooooo
o`3jVPGooooo00Co0?ZJo`00ooooooooo`001?ooool01?l0nY[oooooo`00oooo0002o`3jVP03ool0
0?l0nY[ooooo00Gooooo00Goo`00oooooooooooo0?ZJool00002ooooo`03o`3jV_oooooo0?ZJ00;o
o`0000Coooooool00?oooooo0?ZJ1?ooool01?l0nY[oooooool00?l00?l2o`3jVP03ool00?l0nY[o
oooo00Oooooo00Koo`00o`3jV_oooooo0?ZJoooooooo0005ooooo`07o`3jV_oooooo003oool00?oo
ooooo`00o`3jVP07ooooo`07o`3jV_oo003oooooooooool0nY[oo`00o`3jVP03ooooo`03o`3jV_l0
0?ooo`0000;oo`0000[o0?ZJooooooooooooooooo`3jV_l00?ooo`00ooooool0nY[oo`002?ooool0
2_oo003o0?ZJoooooooooooo0?ZJool00?oooooo0?ZJooooool0nYX3ooooo`03o`3jV_oooooo0000
00;o000000?o0?ZJool00?l0nYX01_ooool01_oo003oooooooooool0nY[oo`00o`3jVPGooooo00Go
0?ZJool00?ooooooooooool0000mooooo`00@_ooool02ol0003oooooo`3jV_ooooooo`00o`00oooo
003oooooool00?ooooooo`0000;ooooo00Go0?ZJooooooooooooooooo`3jVP0:ooooo`03o`3jV_oo
oooooooo00;oo`0000?o003oo`3jV_ooool00_ooool00ol0nY[oo`00ooooo`0Hooooo`;o0?ZJ0ol0
00001ol0nY[ooooooooooooooooo0?ZJool00?l0nYX03Oooool01Ol0nY[ooooooooooooooooo0?ZJ
00Kooooo00?o0?ZJoooooooo00000_l0nYX4ooooo`?o00000_ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oo003o0?ZJ00;o0?ZJ0_ooool00ol00?ooooooool00003ooooo`03ool00?l0nY[ooooo
01Wooooo00Ko0?ZJo`000?l0003o0000o`00ool0nYX4ooooo`;o0?ZJ8Oooool01?l0003ooooooooo
ool00003ooooo`03o`000?l0nY[ooooo00?ooooo00[oo`00oooooooo003o0?ZJool00?oooooo0?ZJ
ool00?l0nY[o003o0ol00003ooooo`06o`3jV_ooooooooooo`3jV_oo003o0?ZJ2_ooool00ooo003o
ooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP06oooo
o`?o0?ZJ00?oo`00ooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo003o003o
00;o0?ZJ2?ooool00ooo003o0?ZJooooo`02o`3jVP?ooooo00Ooo`00ooooooooooooooooo`3jV_oo
003o0?ZJ00[ooooo00?o0?ZJooooooooool01Oooool3o`3jVPKooooo00Go0?ZJoooooooooooo0?ZJ
ool00003ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Gooooo
00Ko0?ZJooooooooooooooooool00?l0nYX9ooooo`04o`3jV_ooooooooooo`3jVQOooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
0_ooool01?l0nY[oo`00ooooool0nYX5ooooo`04o`3jV_l00?ooooooool000Cooooo00Co0?ZJoooo
ool00?ooo`000_l0nYX00ooo003o0?ZJooooo`05ooooo`06ool00?ooooooooooo`3jV_oo003ooooo
0_l0nYX02?oooooo0?ZJoooooooo003o003oool00?oooooo0?ZJ1?ooool01?l0nY[oooooool00?l0
0?l2o`3jVP03ool00?l0nY[ooooo00Oooooo00Coo`00o`3jV_oooooo0?ZJ0_oo0006ooooo`06o`3j
V_l00?ooo`00o`3jV_oo003o0?ZJ1oooool01ol0nY[oo`00oooooooooooo0?ZJool00?l0nYX00ooo
ool00ol0nY[o003oo`00o`02ool0000:o`3jV_ooooooooooooooool0nY[oooooool00?oooooo0?ZJ
ool000Sooooo00[oo`00o`3jV_ooooooooooo`3jV_oo003oooooo`3jV_oooooo0?ZJ0oooool02?l0
nY[oooooooooool0nY[oo`00o`00oooo003o0?ZJ1_ooool01_oo003o0?ZJooooool0nY[oo`00o`3j
VPGooooo00Go0?ZJool00?oooooo003oool0000mooooo`00@_ooool02ol0003o0?ZJoooooooooooo
o`00o`00oooo003oooooool00?ooooooo`0000;ooooo00Go0?ZJooooooooooooooooo`3jVP0:oooo
o`03o`3jV_ooooooo`0000?o003o00Oo0?ZJooooooooooooooooo`3jV_oo003o0?ZJ01Sooooo00?o
0?ZJooooool000000_l00004ooooo`03o`3jV_oo003o0?ZJ00gooooo00Go0?ZJoooooooooooooooo
ool00006ooooo`04o`3jV_l0003o0000o`0000Gooooo0ol000000ooooooo0?ZJo`3jVP04ooooo`04
o`3jV_oo003o003oo`3jVP;ooooo0_l00?l00oooooooo`00ooooo`02ooooo`03ool00?l0nY[ooooo
01Wooooo00Co0?ZJo`000?l0003o00000_l0nYX4ooooo`;o0?ZJ8_ooool2o`0000Cooooo00?o0000
o`3jV_ooool00oooool02_oo003oooooool00?l0nY[oo`00oooooooo003oooooo`3jV_ooool3o`00
00?ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX:ooooo`03o`3jV_oo003ooooo00;ooooo00?o
0?ZJooooooooool00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00Co0?ZJooooool0nY[o
o`001_ooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oo003o003oooooool0nYX02?ooool01Ooo
003o0?ZJooooool00?oo0?ZJ00?ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00[ooooo
00?o0?ZJooooooooool01Oooool3o`3jVPKooooo00Go0?ZJoooooooooooo0?ZJool00003ooooo`;o
0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00?oo`000_ooool01_l0nY[o
ooooooooooooooooo`00o`3jVP[ooooo00?o0?ZJo`000?l0nYX06?ooool3o`0000Cooooo0_l00004
ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ1Oooool01?l0nY[o003ooooo
oooo0004ooooo`08o`3jV_oooooo003oool00?l0nY[oo`00ooooool0nYX6ooooo`07ool00?oooooo
ooooo`3jV_oo003oooooo`3jVP02ooooo`07o`3jV_ooooooo`00ool00?l00?ooooooo`3jVP04oooo
o`04o`3jV_ooooooo`00o`00o`;o0?ZJ00?oo`00o`3jV_ooool01oooool01_oo003o0?ZJooooool0
nY[oo`00o`3jVPKooooo00Ko0?ZJo`00oooo003o0?ZJool00?l0nYX7ooooo`07o`3jV_oo003o0?ZJ
oooooooo003o003oo`3jVP03ooooo`03o`3jV_oooooo003o00;ooooo00Oo0?ZJoooooooooooooooo
o`3jV_ooooooo`0000?o00002?ooool02_oo003o0?ZJooooool0nY[o003oool00?oooooo0?ZJoooo
ool0nYX2ooooo`;o0?ZJ0_ooool01Ol0nY[oo`00oooooooo003o0?ZJ00Kooooo00Goo`00o`3jV_oo
oooo0?ZJool00006ooooo`05o`3jV_oo003oooooo`00oooo0000?Oooool004;ooooo00_o0000o`3j
V_ooooooooooool00?l00?ooo`00oooooooo003oooooool00002ooooo`05o`3jV_oo003oo`00oooo
ool0nYX02_ooool00ol0nY[oo`00ooooo`02o`00o`03ooooool0nY[ooooo00;ooooo00?o0?ZJool0
0?l0nYX05oooool2o`3jVP?o003o00?oo`00ooooooooool00_ooool00ol0nY[oo`00o`3jVP0<oooo
o`04o`3jV_ooooooooooooooo`;oo`001_ooool01?l0nY[o0000o`000?l00006ooooo`Co0?ZJ1Ooo
ool01?l0nY[oo`00ooooool00?l2ooooo`04o`00ooooooooooooool000?ooooo00?oo`00o`3jV_oo
ool06Oooool01Ol0nY[o0000o`000?l0003o0?ZJ00Gooooo0_l0nYXXooooo`03o`000?l0nY[o0?ZJ
00?ooooo00[oo`00oooooooo003o0?ZJool00?ooooooo`00ooooool0nY[ooooo0ol000002Ooo003o
oooooooooooooooo0?ZJooooool0nY[oo`00o`3jVP0:ooooo`03o`3jV_oo003ooooo00;ooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooool00002ool00003o`3jV_oooooooooo00?ooooo00Go
0?ZJoooooooo003o003oo`3jVP05ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJool00?l00?oo
ooooo`3jVP02ooooo`;o0?ZJ0oooool00ol0nY[oo`00ooooo`02ooooo`05o`00ool0nY[o003ooooo
oooo00000oooool00ol0nY[oo`00o`3jVP0Booooo`Co0?ZJ1Oooool01Ol0nY[oooooooooool0nY[o
o`0000;ooooo00?o0?ZJooooool0nYX00_ooool2o`3jVPCooooo00Go0?ZJooooool0nY[oo`00o`00
o`02ool00003ooooool0nY[ooooo00;ooooo00?oo`00o`3jV_ooool02Oooool00ol0nY[oooooo`3j
VP0Uooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ0_ooool01ol00?oooooo
ooooool0nY[o003ooooooooo00001?ooool01ol0nY[oooooo`00oooo003o0?ZJool00?l0nYX01ooo
ool01ooo003oooooooooool0nY[oo`00ooooool0nYX00oooool01?l0nY[oooooooooooooool2o`3j
VPCooooo00Co0?ZJooooooooooooo`000_l0nYX00ooo003oooooooooo`07ooooo`06o`3jV_oo003o
ooooo`3jV_oo003o0?ZJ1_ooool01_l0nY[o003oool00?l0nY[oo`00o`3jVPOooooo00Oo0?ZJool0
0?l0nY[o0?ZJool00?oooooo0?ZJ00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_l00?oo000000;o00002?ooool01Ol0nY[oo`00ooooool0nY[oo`0000;ooooo
00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`02ooooo`;oo`0000?oooooo`3jV_ooool0
1Oooool01Ooo003o0?ZJoooooooo003o0?ZJ00Kooooo00Go0?ZJool00?oooooo003oool0000moooo
o`00@_ooool2o`3jVP09oooooooo003oo`00o`00oooo003oooooool00?ooooooo`0000;ooooo00Go
0?ZJool00?oo003oooooo`3jVP0:ooooo`04o`3jV_oo003o003oo`00o`;ooooo00Oo0?ZJoooooooo
ooooooooo`3jV_oo003o0?ZJ01Oooooo00Ko0?ZJo`00ool00?ooooooo`00oooo0004ooooo`04o`3j
V_oo003o003oo`3jVP_ooooo00?o0?ZJooooooooool00ooo0006ooooo`04o`3jV_l0003o0000o`00
00Kooooo0ol0nYX6ooooo`;o0?ZJ00Goo`00o`00ooooooooooooo`00o`02ooooo`06ool00?oooooo
oooooooooooo003o0?ZJ6Oooool00ol0nY[oooooool00002o`3jVPKooooo0_l0nYXXooooo`03o`00
0?oooooo0?ZJ00?ooooo00_oo`00oooooooo003o0?ZJool00?ooooooo`00o`3jV_l00?oo0?ZJoooo
o`02o`3jVP08ool00?ooooooooooooooool0nY[oooooo`3jV_oo000;ooooo`03o`3jV_oo003ooooo
00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooool00003o`000005o`3jV_oooooooooo
ooooool0nYX00_ooool01?oo003o0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo00;ooooo00Co
0?ZJool00?l00?oooooo0ol0nYX00ooooooo0?ZJo`3jVP02ooooo`03o`3jV_oo003ooooo00?ooooo
0_l0nYX00oooooooo`00ooooo`02ooooo`03o`3jV_oo003ooooo01;ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP04ooooo`05o`3jV_ooooooooooo`3jV_oo00000_ooool00ol0nY[oooooo`3jVP02ooooo`03
o`3jV_oooooooooo00?ooooo0_l0nYX2ool00005ooooool00?ooo`00ooooool0nYX00oooool00ooo
003o0?ZJooooo`09ooooo`03o`3jV_oooooo0?ZJ02Gooooo00?o0000ooooooooool00_ooool01?l0
nY[oo`00ooooool0nYX2ooooo`07o`00oooooooo0?ZJooooool00?ooooooool00005ooooo`06o`3j
V_l00?ooo`00o`3jV_oo003o0?ZJ1oooool01Ooo003oooooooooool0nY[oo`0000;o0?ZJ0oooool0
1Ol0nY[ooooooooooooooooo0?ZJ00Gooooo00?o0?ZJooooooooool00ooo00000ol0nY[ooooooooo
o`07ooooo`06o`3jV_oo003o0?ZJo`3jV_oo003o0?ZJ1_ooool2o`3jVP03ool00?l0nY[oo`0000So
oooo00Oo0?ZJool00?l0nY[o0?ZJool00?oooooo0?ZJ00Cooooo00Go0?ZJooooooooooooooooo`3j
VP04ooooo`03o`3jV_l00?oo000000;o00002?ooool01Ol0nY[oo`00ooooool0nY[oo`0000;ooooo
00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`;oo`0000?oooooo`3jV_ooool01Oooool01Ooo
003o0?ZJoooooooo003o0?ZJ00Kooooo00Go0?ZJool00?oooooo003oool0000mooooo`00@_ooool0
3_l0nY[ooooooooooooo003oooooo`00oooo003oooooool00?ooooooo`00o`00oooooooo0?ZJ0_oo
00000ooooooo0?ZJooooo`09ooooo`04o`3jV_oo003o003oo`00o`;ooooo00Oo0?ZJoooooooooooo
ooooo`3jV_oo003o0?ZJ01Oooooo00?o0?ZJo`00ool00?l00_ooool00ooo003oooooooooo`03oooo
o`03ool00?l00?oo0?ZJ00_ooooo00Ko0?ZJoooooooo003oo`00oooooooo0005ooooo`04o`3jV_oo
ooooo`00o`3jVPOooooo00?o0?ZJooooooooool01_ooool2o`3jVP05ool00?l00?oo003oooooool0
0?l00_ooool01_oo003oooooooooooooooooo`00o`3jVQ?ooooo0_l0nYX4ooooo`04o`3jV_oooooo
o`00o`3jVPOooooo0_l0nYXXooooo`;o000000?o0?ZJooooooooool00_ooool2ool00008o`3jV_oo
003oooooool00?l0nY[o003oo`3jV_ooool2o`3jVP08ool00?ooooooooooooooool0nY[oooooo`3j
V_oo000;ooooo`04o`3jV_oo003oooooooooo`;oo`001?ooool00ol0nY[oo`00ool00003o`0000;o
0?ZJ0_ooool01_l0nY[ooooooooooooo003o0?ZJooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02
ooooo`04o`3jV_oo003o003oooooo`;o0?ZJ0oooool4o`3jVP03ool00?oooooooooo00?ooooo00?o
0?ZJoooooooo00000oooool00ol0nY[oo`00ooooo`0Booooo`;o0?ZJ0_ooool2o`3jVP?ooooo00Oo
0?ZJoooooooooooo0?ZJool00?oooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool2o`3j
VP04ool00?l00?ooooooo`00o`;oo`0000Ko0?ZJooooooooooooooooool00?l0nYX:ooooo`;o0?ZJ
00?o0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVP;o
oooo0_l00?l01Ol0nY[oooooo`00ooooooooo`0000Gooooo00Ko0?ZJo`00oooo003o0?ZJool00?l0
nYX7ooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00Gooooo00Co0?ZJoooooooooooo003o0_oo00000ol0nY[oooooooooo`07ooooo`06o`3jV_oo003o
0?ZJo`3jV_oo003o0?ZJ1oooool01?l0nY[oo`00ool00?l0nYX8ooooo`06o`3jV_oo003o0?ZJo`3j
V_oo003o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo00Co0?ZJo`00oooo003oo`00
2Oooool01Ol0nY[oo`00ooooool0nY[oo`0000;ooooo00?o0?ZJooooooooool00_l0nYX5ooooo`03
o`3jV_oooooo0?ZJ00Oooooo00Goo`00o`3jV_ooooooo`00o`3jVP06ooooo`05o`3jV_oo003ooooo
o`00oooo0000?Oooool003_ooooo0_l00005ooooo`0>o`3jV_ooooooo`00ool00?l00?ooooooool0
0?ooooooo`00oooooooo003o003oooooool0nYX2ool00003ooooool0nY[ooooo00Wooooo00?oo`00
o`00ool00?l00oooool00ol0nY[oooooooooo`02ooooo`03ool00?l0nY[ooooo01Gooooo0_l0nYX0
1Ol00?oooooooooooooo003o0?ZJ00Gooooo00?o0?ZJool00?l0nYX02oooool00ol0nY[oo`00ool0
0002ooooo`03ool00?oooooooooo00?ooooo00Co0?ZJool00?oooooo0?ZJ4Oooool00ol0nY[oo`00
ool00003o`00o`;ooooo00Koo`00ooooooooooooooooool00?l0nYXBooooo`?o0?ZJ1?ooool01?l0
nY[oo`00o`00ool0nYX7ooooo`;o0?ZJ:?ooool00ol0003oooooo`3jVP04ooooo`;oo`0000So0?ZJ
ool00?ooooooo`00o`3jV_l00?oo0?ZJooooo`;o0?ZJ00Ko003oool00?ooooooooooo`3jV_ooool3
o`0000[ooooo00Ko0?ZJool00?ooooooo`00oooooooo0003ooooo`04o`3jV_ooooooo`00o`00o`?o
000000Koooooo`3jV_ooooooooooo`3jV_ooool2ool00004o`3jV_ooooooooooo`3jVP?ooooo00?o
0?ZJooooooooool00_ooool01?l0nY[oooooool00?ooool2o`3jVPKooooo00?o0?ZJool00?ooool0
1?ooool00ol0nY[o003oool00003ooooo`03o`3jV_oo003ooooo01?ooooo00Go0?ZJoooooooooooo
ooooo`3jVP03ooooo`05o`3jV_ooooooooooo`3jV_oo00000_l0nYX2ooooo`05o`3jV_oooooo0?ZJ
o`3jV_ooool00_oo0002ooooo`;o0?ZJ00Ooo`00o`00ooooooooooooo`00oooo003o0?ZJ00?ooooo
00?oo`00o`3jV_ooool02Oooool2o`3jVP03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
0_ooool01?l0nY[oo`00ooooool0nYX2ooooo`;o003o00Go0?ZJooooool00?ooooooool00005oooo
o`06o`3jV_l00?ooo`00o`3jV_oo003o0?ZJ1oooool01_oo003o0?ZJoooooooo003oooooo`3jVPCo
oooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`04o`3jV_ooooooooooo`00o`;oo`0000?o0?ZJ
ooooooooool01oooool01_l0nY[oo`00o`3jV_l0nY[oo`00o`3jVPOooooo00Co0?ZJool00?oo003o
0?ZJ2?ooool01_l0nY[oo`00o`3jV_l0nY[oo`00o`3jVPGooooo00Go0?ZJooooooooooooooooo`3j
VP04ooooo`04o`3jV_l00?ooooooo`3jVPWooooo00Ko0?ZJool00?oooooo0?ZJool00?ooool2o`3j
VPWooooo00?o0?ZJooooool0nYX01oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Kooooo00Go0?ZJ
o`00oooo003oo`00o`3jVP0mooooo`00>_ooool01?l0003oooooooooool00004ooooo`03o`000?l0
0?ooo`0000;o003o00goooooool00?ooooooo`00oooooooo003o003ooooooooo003oooooool00?oo
oooo0?ZJ00[ooooo00?oo`00o`00ooooool00oooool00ol0nY[oooooooooo`02ooooo`03ool00?l0
nY[o0?ZJ00Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[o003oo`00o`02ooooo`03ool00?l0
nY[ooooo00Cooooo00?o0?ZJool00?l0nYX02oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oo
oooooooo00?ooooo00Co0?ZJool00?oooooo0?ZJ4Oooool2o`3jVP;oo`000_l00?l3ool000?ooooo
00?oo`00o`3jV_ooool04?ooool2o`3jVP03ooooool0nY[ooooo00?ooooo00Co0?ZJool00?l00?oo
0?ZJ1oooool2o`3jVRSooooo00?o0000ooooool0nYX01?ooool2ool00008o`3jV_oo003oooooool0
0?l0nY[o003oo`3jV_ooool2o`3jVP04o`00oooo003oooooooooo`;o0?ZJ0ol0000:ooooo`06o`3j
V_oo003oo`00ool00?ooooooo`000oooool02?l0nY[oooooool00?l00?ooooooo`3jV_oo003o003o
0_l0nYX00ooooooo0?ZJooooo`02ool000Cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01Ol0nY[o
ooooool00?ooooooo`0000;o003o1Oooool00ol0nY[oo`00ooooo`04ooooo`;o0?ZJ00Koo`00oooo
ooooooooooooo`3jV_oo000Hooooo`05o`3jV_ooooooooooooooool0nYX00oooool01?oo003o0?ZJ
o`3jV_ooool2ool00003ooooool0nY[ooooo00Coo`0000Goooooo`3jV_l0nY[oo`00o`00o`03oooo
o`;oo`000oooool00ooo003o0?ZJooooo`09ooooo`;o0?ZJ00?o0000ooooooooool08oooool00ol0
003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVP;ooooo0_l00?l01Ol0nY[o003ooooooooo
ooooo`0000Gooooo00Go0?ZJoooooooo003o0?ZJool00008ooooo`06ool00?l0nY[oooooool00?oo
oooo0?ZJ1?ooool00ol0nY[oooooooooo`02o`3jVPKooooo00?o0?ZJooooool000000_l000000ol0
nY[oooooooooo`07ooooo`06o`3jV_oo003o0?ZJo`3jV_oo003o0?ZJ1oooool01?l0nY[oo`00ool0
0?l0nYX8ooooo`06o`3jV_oo003o0?ZJo`3jV_oo003o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo
0?ZJ00Cooooo00Co0?ZJo`00ool00?oo0?ZJ2Oooool01ol0nY[oo`00ooooool0nY[oo`00ooooool0
nYX02_ooool00ol0nY[oooooo`3jVP07ooooo`05ool00?l0nY[o0?ZJool00?l0nYX01_ooool01Ol0
nY[o003oool00?oo003o0?ZJ03gooooo000jooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ool00?l00?l00_l00?l2ooooo`;oo`0000Goooooool00?l0nY[oooooool00002ooooo`;oo`002Ooo
ool00ol0nY[oo`00o`00o`04ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00o`00ool0nYX02?oo
ool2o`3jVP_ooooo00?o0?ZJo`00ooooool00_ooool00ooo003o0?ZJooooo`04ooooo`03o`3jV_oo
003o0?ZJ00[ooooo00?o0?ZJoooooooo00000oooool00ooo003oooooooooo`03ooooo`04o`3jV_oo
003o003oo`3jVQ;ooooo00?o0?ZJoooooooo00000ooo00000ooooooo0?ZJooooo`02ooooo`03ool0
0?l0nY[ooooo013ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[oo`00o`00ool0nYX7oooo
o`;o0?ZJ:?ooool00ol0003oooooo`3jVP04ooooo`;oo`0000go0?ZJool00?ooooooo`00o`3jV_l0
0?oo0?ZJooooool0nY[oooooo`3jV_l00?ooo`0000;ooooo00Co0?ZJo`000?l0003o00002_ooool0
0ol0nY[o003oooooo`02ooooo`05ool00?ooooooooooooooool0nYX00_oo0002ooooo`08o`3jV_oo
003o003oooooool0nY[oooooo`3jV_ooool2ool000Cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool0
0ol0nY[oooooool00002ool00003ooooool00?oo003o00Cooooo00?o0?ZJool00?ooool01Oooool0
0ol0nY[oo`00ooooo`02ooooo`03o`3jV_oo003ooooo01Sooooo00Co0?ZJoooooooooooo0?ZJ0ooo
ool01?oo003o003oooooooooool2ool00006ooooool0nY[oooooool00?l00?oooooo0_oo0002o`3j
VP03ool00?oooooooooo00;ooooo00?o003oool00?ooool00_ooool00ooo003o0?ZJooooo`0:oooo
o`03o`3jV_l0003ooooo02Cooooo00?o0000ooooooooool00_ooool01?l0nY[oo`00ooooool0nYX2
ooooo`;o003o00Go0?ZJo`00ooooooooooooool00005ooooo`05o`3jV_ooooooo`00o`3jV_oo0000
2?ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Gooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol0
nY[oooooo`000002o`0000[ooooo00Ko0?ZJool00?l0nY[o0?ZJool00?l0nYX7ooooo`04o`00oooo
003oo`00o`3jVPSooooo00Ko0?ZJool00?l0nY[o0?ZJool00?l0nYX5ooooo`05o`3jV_oooooooooo
ooooool0nYX01?ooool01?l0nY[oooooo`00ool0nYX9ooooo`07o`3jV_oo003oooooool00?l00?oo
ooooo`3jVP0:ooooo`?o0?ZJ1oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Kooooo00Go0?ZJo`00
oooo003oo`00o`3jVP0mooooo`00>_ooool01?l0003oooooooooool00004ooooo`;o00000_l00?l3
ooooo`;oo`0000Goooooool00?l0nY[oooooool00002ooooo`;oo`002Oooool00ol0nY[oo`00o`3j
VP05o`3jVPCooooo00?oo`00o`00ooooool00_l0nYX6ooooo`;o0?ZJ2oooool00ol0nY[o003ooooo
o`02ooooo`03ool00?l0nY[ooooo00Cooooo00?o0?ZJool00?l0nYX02_ooool00ol0nY[oo`00oooo
o`03ooooo`03ool00?oooooooooo00?ooooo00Co0?ZJool00?l00?oo0?ZJ4_ooool01?l0nY[ooooo
o`00ool00?l3ooooo`06o`3jV_ooooooooooooooool0nY[oo`004?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Cooooo00Co0?ZJool00?oooooo0?ZJ1oooool00ol0003o0?ZJooooo`0Wooooo`;o0000
00?o0?ZJooooooooool00_ooool2ool0000=o`3jV_oo003oooooool00?l0nY[o003oo`3jV_oooooo
0?ZJooooool0nY[o003oool00002ooooo`03o`3jV_ooooooo`0000_ooooo00?o0?ZJo`00ooooool0
0_ooool01ooo003ooooooooooooooooo0?ZJool00?l00?l00_ooool2o`3jVP06ool00?oooooo0?ZJ
ooooool0nY[ooooo0_oo0004ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJoooooooo0000
1Ooo0004ooooo`03o`3jV_oo003ooooo00Gooooo00?o0?ZJool00?ooool00_ooool00ooo003o0?ZJ
ooooo`0Hooooo`04o`3jV_ooooooooooo`3jVP?ooooo00Soo`00o`00ooooooooo`00oooooooo003o
ooooo`3jVP;oo`0000?o003oooooooooool00ooo00001ol00?oo0?ZJo`3jV_l0nY[oooooo`00oooo
00000oooool00ooo003oooooooooo`0:ooooo`03o`3jV_l0003ooooo02Cooooo00?o0000oooooooo
ool00_ooool01?l0nY[oo`00ooooool0nYX2ooooo`;o003o00Go0?ZJo`00ooooooooooooool00005
ooooo`03o`3jV_oooooo003o00;oo`002?ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Gooooo00Co
0?ZJoooooooooooo0?ZJ1oooool00ol0nY[oooooo`000002o`0000[ooooo00Co0?ZJool00?l0nY[o
o`000_l0nYX8ooooo`;oo`0000?o0?ZJooooooooool01_ooool01Ol0nY[oo`00o`3jV_l0nY[oo`00
00Oooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[oooooo`00ool0nYX:ooooo`05ool00?oo
ooooo`00o`00ool0nYX03?ooool00ol0nY[oooooooooo`06ooooo`04ool00?l0nY[o0?ZJool000Oo
oooo00Go0?ZJo`00oooo003oo`00o`3jVP0mooooo`00>_ooool01?l0003oooooooooool00004oooo
o`03o`3jV_oooooooooo00Cooooo0_oo00002Oooooooo`00o`3jV_l0nY[oo`00ooooool0nY[ooooo
ool00004o`3jVPGooooo00?o0?ZJool00?l0nYX02Oooool01Ol0nY[oo`00oooooooooooo0?ZJ00Ko
oooo0_l0nYX;ooooo`03o`3jV_oo003oo`0000?oo`0000?o0?ZJooooooooool00oooool00ol0nY[o
o`00o`3jVP0:ooooo`03o`3jV_oo003ooooo00?ooooo00?oo`00ooooooooool00oooool01?l0nY[o
o`00o`00ool0nYXBooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJooooooooooooooooo`3jV_oo
000@ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01?l0nY[oo`00ooooool0nYX8ooooo`03
o`3jV_oooooooooo02Kooooo00Co0000oooooooooooo0?ZJ0oooool2ool0000=o`3jV_oo003ooooo
ool00?l0nY[o003oo`3jV_oooooo0?ZJooooool0nY[o003oool00004ooooo`03ool00?oooooooooo
00Wooooo00?o0?ZJo`00ool00?l00_ooool01ooo003ooooooooooooooooo0?ZJool00?l00?l00_oo
ool2o`3jVP05ool00?oooooo0?ZJooooool0nYX00ol00005ooooo`03o`3jV_oooooo0?ZJ00Cooooo
00?o0?ZJooooooooool00ol000000oooooooo`00ool00003ooooo`03o`3jV_oo003ooooo00Gooooo
00?o0?ZJool00?ooool00_ooool00ooo003o0?ZJooooo`0Hooooo`04o`3jV_ooooooooooo`3jVP?o
oooo00Koo`00o`00ooooooooo`00oooooooo0002o`3jVP03ool00?oooooo003o00?ooooo0_oo0000
1ol0nY[oooooooooool0nY[oooooo`00oooo00000_ooool00ol0nY[oo`00ooooo`0<ooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool00_ooool01?l0nY[oo`00ooooool0nYX2ooooo`;o
003o00Go0?ZJo`00ooooooooooooool00005ooooo`03o`3jV_oooooo003o00;oo`002?ooool01Ooo
003o0?ZJo`3jV_oo003o0?ZJ00Kooooo00?o0?ZJooooool0nYX01oooool00ol0nY[oooooooooo`02
o`3jVP[ooooo00Go0?ZJool00?l0nY[oo`00o`3jVP09ooooo`;oo`002_ooool01?oo003o0?ZJo`3j
V_oo0007ooooo`04o`3jV_oooooo0?ZJo`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ2_ooool00ooo
003oooooool00002o`3jVQGooooo00Co0?ZJool00?l0nY[oo`001oooool01Ol0nY[oooooo`00ool0
0?oo0?ZJ03gooooo000jooooo`04o`000?ooooooooooo`0000Cooooo00?o0?ZJooooooooool01?oo
ool2ool00005oooooooo003o0?ZJo`3jV_oo00000_l0nYX00oooooooo`00o`3jVP02ooooo`;o0?ZJ
1?ooool00ol0nY[oo`00ooooo`09ooooo`05o`3jV_oo003oooooooooool0nYX01_ooool2o`3jVP[o
oooo00?o0?ZJo`00oooo00001?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo003o0?ZJ00[o
oooo00Co0?ZJool00?oooooo003o0_ooool00ooo003oooooooooo`03ooooo`04o`3jV_oo003o0?ZJ
o`3jVQ?ooooo00?o0?ZJooooooooool00oooool01ol0nY[ooooooooooooooooo0?ZJool00?l0nYX0
2Oooool2o`3jVPCooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`04o`3jV_oo003oooooo`3j
VPSooooo00?o0000ooooooooool09_ooool01?l0003oooooooooool0nYX3ooooo`;oo`0000go0?ZJ
ool00?ooooooo`00o`3jV_l00?oo0?ZJooooool0nY[oooooo`3jV_ooooooo`0000Cooooo00?oo`00
ooooooooool02_ooool01ol0nY[o003oo`00ool0nY[oo`00o`3jV_ooool00_l0nYX01?oo003ooooo
ooooooooool2o`3jVP03ool00?l00?oo003o00;o0?ZJ0ol00005ooooo`03o`3jV_oooooo0?ZJ00Co
oooo00?o0?ZJooooooooool00ol00002ooooo`;oo`0000Coooooo`000?l0003o00001_ooool00ol0
0?ooo`00ooooo`02ooooo`03ool00?l0nY[ooooo01Sooooo0_l0nYX00ooooooo0?ZJooooo`02oooo
o`03ool00?l00?ooo`0000;ooooo00Koo`00o`3jV_l00?ooo`00ooooool00?l3ooooo`;oo`0000Oo
0?ZJoooooooooooo0?ZJooooool00?ooo`0000;ooooo00?o0?ZJool00?ooool03?ooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ0_ooool01?l0
0?ooooooo`3jV_l00?l2ooooo`03ool00?oooooooooo00?ooooo00Go0?ZJooooool00?ooo`00o`3j
VP08ooooo`05ool00?l0nY[o0?ZJool00?l0nYX01_ooool3o`3jVPOooooo00?o0?ZJooooooooool0
0_l0nYX:ooooo`05o`3jV_oo003o0?ZJool00?l0nYX02?ooool3o`0000[ooooo00Coo`00o`3jV_oo
003o0?ZJ1oooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Coo`00
oooooooo003o0?ZJ5_ooool01?l0nY[oo`00o`00oooo0007ooooo`05o`3jV_oooooo003oo`00ool0
nYX0?Oooool003_ooooo0_l00005ooooo`;o0?ZJ1Oooool2ool00005oooooooo003o0?ZJo`3jV_oo
00000_l0nYX00oooooooo`00ooooo`03ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?oo
ool02Oooool01Ol0nY[oo`00oooooooooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX02?ooool00ol0
nY[oooooo`3jVP02ool000Cooooo00?o0?ZJooooooooool00oooool00ol0nY[oo`00o`3jVP0:oooo
o`03o`3jV_oo003ooooo00?o003o00?oo`00ooooooooool00oooool00ol0nY[oo`00o`3jVP0Doooo
o`03o`3jV_oooooooooo00?ooooo00Oo0?ZJooooooooooooooooo`3jV_oo003o0?ZJ00Sooooo00?o
0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Co
0?ZJool00?l0nY[o0?ZJ2?ooool00ol0003oooooooooo`0Vooooo`;o000000?oooooo`3jV_ooool0
0_ooool2ool00009o`3jV_oo003oooooool00?l0nY[o003oo`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
o`00oooo00000oooool00ooo003oooooooooo`0:ooooo`03o`3jV_l00?oo0?ZJ00?o00000_l0nYX0
0oooooooo`00ooooo`04o`3jVP05oooooooo003o003oo`3jV_ooool00ol00005ooooo`03o`3jV_oo
oooo0?ZJ00Cooooo00?o0?ZJooooooooool00ol00002ooooo`03o`00oooo003oo`0000?o00001_oo
ool3o`0000;ooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[oooooo`3jVP03ooooo`03ool00?l0
0?ooo`0000;ooooo00?oo`00o`3jV_oo00000oooool00ol00?ooooooooooo`02ool00007o`3jV_oo
ooooooooooooool0nY[o003oool00002ooooo`03o`3jV_oo003ooooo00_ooooo0_l0000Uooooo`03
o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo0?ZJ0_ooool01?l00?ooooooo`3jV_l00?l2
ooooo`03ool00?oooooooooo00?ooooo00Go0?ZJooooool00?ooo`00o`3jVP08ooooo`05ool00?l0
nY[o0?ZJool00?l0nYX01_ooool2o`3jVPSooooo00Co0?ZJoooooooooooo0?ZJ2oooool01Ol0nY[o
o`00o`00oooo003o0?ZJ00Sooooo0ol0000:ooooo`04ool00?l0nY[oo`00o`3jVPOooooo0ol0nYX5
ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Coo`00oooooooo003o0?ZJ5_ooool01?l0nY[oo`00
o`00oooo0007ooooo`05o`3jV_oooooo003oooooool0nYX0?Oooool004;ooooo00?o0000o`3jV_oo
ool01?ooool2ool00005oooooooo003o0?ZJo`3jV_oo00000_l0nYX00oooooooo`00o`00o`04oooo
o`06o`3jV_oooooooooooooooooo003o0?ZJ2_ooool01Ol0nY[oo`00oooooooooooo0?ZJ00Gooooo
00?o0?ZJooooool0nYX02?ooool01?l0nY[oooooo`3jV_oo0005ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJool00?l0nYX02_ooool00ooo003o003oo`3jVP03o`00o`03ool00?oooooooooo00?o
oooo00?o0?ZJool00?l0nYX05?ooool2o`3jVPCooooo00Oo0?ZJooooooooooooooooo`3jV_oo003o
0?ZJ00Oooooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool00_ooool00ooo003o003oo`3jVP08ooooo`;o00006oooool3o`0000Cooooo0_l00004
ooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo00002Ol0nY[oo`00oooooooo003o0?ZJooooool0
nY[oooooo`3jVP02ooooo`03o`3jV_l00?ooo`0000?ooooo00?oo`00ooooooooool02_ooool00ol0
nY[oooooo`3jVP03o`0000;ooooo0_oo00002?oooooo0?ZJoooooooooooo0?ZJoooooooo003o003o
0_ooool00ooo003o003oo`3jVP05ooooo`03o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJooooooooool0
0ol0nYX01?oooooo003ooooooooo0003o`0000Kooooo0ol00002ooooo`03ool00?l0nY[ooooo01Wo
oooo00?o0?ZJooooool0nYX00oooool02?oo003o003oool00?l00?ooooooool00?l0nY[oo`000_oo
ool01?l0nY[o003oooooooooool2ool00007o`3jV_ooooooooooooooool0nY[oooooool00002oooo
o`03o`3jV_oo003ooooo00cooooo00?o0000ooooooooool05oooool3o`0000?ooooo0_l00004oooo
o`03o`000?oooooooooo00;ooooo00[o0?ZJool00?oooooo0?ZJooooool00?oo0?ZJooooool0nY[o
003o0_ooool00ooo003oooooooooo`03ooooo`05o`3jV_l0003o0000o`000?l0nYX02?ooool01?l0
nY[oo`00oooooooo0007ooooo`;o0?ZJ2?ooool01?l0nY[oooooooooool0nYX;ooooo`05o`3jV_oo
003o003oool00?l0nYX02?ooool3o`0000[ooooo00Coo`00o`00oooo003o0?ZJ3oooool01?l0nY[o
ooooooooool0nYX:ooooo`04ool00?ooooooo`00o`3jVQKooooo00Co0?ZJool00?oo003o0?ZJ1ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ03gooooo0012ooooo`03o`000?oooooo0?ZJ00Cooooo0_oo
00001Oooooooo`00o`3jV_l0nY[oo`0000;o0?ZJ0ol00004ooooo`06o`3jV_oooooooooooooooooo
003o0?ZJ2_ooool01Ol0nY[oo`00oooooooooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX00_l0nYX6
ooooo`04o`3jV_oooooo0?ZJool000Gooooo00?o0?ZJooooooooool00oooool01?l0nY[o0000o`00
0?l00009ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ00?o003oool00?ooool01?ooool00ol0nY[oo`00
o`3jVP0Eooooo`03o`3jV_oooooooooo00;ooooo00Ko0?ZJooooooooooooooooo`3jV_oo0003o`3j
VPGooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00;ooooo00?oo`00o`00ool0nYX02Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0nYX3ooooo`;oo`00
00Wo0?ZJool00?ooooooo`00o`3jV_oooooo0?ZJooooool0nYX00_ooool00ol0nY[o003oool00003
ooooo`03ool00?oooooooooo00[ooooo0_l0nYX01?oooooo0000o`000?l00002ooooo`03ool00?oo
oooo0?ZJ00Cooooo00?o0?ZJool00?l00?l00_ooool00ooo003o003oo`3jVP05ooooo`03o`3jV_oo
oooo0?ZJ00Gooooo00Go0?ZJoooooooooooo0?ZJooooo`02o`3jVP03o`00oooooooooooo00;oo`00
1oooool3o`0000;ooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[oooooo`3jVP03ooooo`05o`3j
V_oo003oooooo`00ool0nYX00ooo00001?oooooo0?ZJo`3jV_l0nYX2ooooo`;oo`001?ooool00ol0
nY[oooooool00002ooooo`03o`3jV_oo003ooooo00cooooo00?o0000ooooooooool06?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Go0000ooooooooooooooooo`000004ooooo`06o`3jV_oo
003oooooo`3jV_oooooo003o0ol0nYX01?l00?oooooooooooooo0005ooooo`04o`3jV_l0003o0000
o`0000Wooooo00Co0?ZJool00?l00?ooo`004Oooool01?l0nY[oooooooooool0nYX;ooooo`05o`3j
V_oo003o003oool00?l0nYX02Oooool2o`3jVP[ooooo00Coo`00o`00oooo003o0?ZJ4?ooool00ol0
nY[oooooo`3jVP0:ooooo`03ool00?ooooooo`0001Oooooo00Co0?ZJool00?oo003o0?ZJ1oooool0
1Ol0nY[ooooooooooooooooo0?ZJ03gooooo0012ooooo`03o`000?oooooo0?ZJ00Cooooo0_oo0000
1Oooooooo`00o`3jV_l0nY[oo`0000;o0?ZJ0ol000001Ooo003ooooooooooooooooo0?ZJ00?ooooo
00?oo`00o`3jV_ooool02Oooool01Ol0nY[o003oool00?oooooo0?ZJ00Gooooo00?o0?ZJooooool0
nYX00ol0nYX4ooooo`;o0?ZJ00?oooooo`3jV_oo00001Oooool00ol0nY[oooooooooo`03ooooo`05
o`3jV_l0003o0000o`000?ooool00ol0nYX5ooooo`05ool00?l0nY[oooooooooool0nYX00ol00004
ooooo`03o`3jV_oo003o0?ZJ01Gooooo00?o0?ZJooooooooool00_ooool01ol0nY[ooooooooooooo
oooo0?ZJool00?l00?l00_l0nYX5ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJo`00ool0
0?l00_ooool00ol0nY[oooooooooo`02ooooo`03ool00?l0nY[ooooo00Wooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooo
oooooooo0?ZJ0oooool2ool00006o`3jV_oo003oooooool00?l0nY[ooooo0_l0nYX3ooooo`03o`3j
V_l00?ooo`0000;ooooo00?oo`00o`3jV_ooool02oooool2o`3jVP;ooooo00Oo0?ZJool00?oooooo
ooooool00?oooooo0?ZJ00Cooooo00?o0?ZJool00?oo00000_ooool00ooo003o003oo`3jVP06oooo
o`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJoooo
ooooool01_ooool01_oo003o0?ZJooooooooooooo`00o`3jVQ[ooooo00?o0?ZJooooool0nYX00ooo
ool00ol0nY[oooooooooo`02o`3jVP;oo`0000Coooooo`3jV_l0nY[ooooo0_l0nYX00oooooooo`00
o`3jVP05ooooo`06o`3jV_oo003oooooooooool0nY[oo`003Oooool00ol0003oooooooooo`0Eoooo
o`Go00000_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJ
ool00?l000000_l000000ol00?oo0?ZJo`3jVP02o`00o`;ooooo00?oo`00ooooooooool00oooool0
1?l0nY[o0000o`000?l00009ooooo`04o`3jV_oo003oo`00o`3jVQ7ooooo00Co0?ZJoooooooooooo
0?ZJ2oooool01Ol0nY[oo`00o`00oooo003o0?ZJ00Wooooo00?o0?ZJooooooooool02Oooool01?oo
003o003oool00?l0nYX@ooooo`03o`3jV_oooooo0?ZJ00[ooooo00?oo`00o`3jV_oo00005oooool0
1?l0nY[oo`00ool00?l0nYX8ooooo`04o`3jV_ooooooooooo`3jVSgooooo0012ooooo`03o`000?oo
oooo0?ZJ00Cooooo0_oo00001Ooooooo0?ZJool00?l0nY[oo`0000;o0?ZJ0ol00002ool000;ooooo
00Ko0?ZJooooooooooooooooool00?l0nYX:ooooo`05o`3jV_l00?ooo`00ool00?l0nYX01Oooool0
0ol0nY[oooooool00002ooooo`;o0?ZJ0oooool2o`3jVP03oooooooo003o003o00Gooooo00?o0?ZJ
ooooooooool00oooool01?l0nY[o0000o`000?l00002o`3jVP;ooooo0_l0nYX3ooooo`03ool00?l0
nY[ooooo00;ooooo0ol00004ooooo`03ool00?l0nY[ooooo01Kooooo00Go0?ZJoooooooooooooooo
o`3jVP03ooooo`05o`3jV_oo003o003oooooool0nYX01?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00;ooooo00?o0?ZJoooooooo00000ooo00001ol0nY[ooooooooooooooooo0?ZJool00?l0nYX02_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0oooool2o`000003ooooool0nY[ooooo00;ooooo0_oo00001_l0nY[oo`00oooooooo003o0?ZJoooo
o`;o0?ZJ1?ooool01_l0nY[o003oool00?ooooooo`00o`3jVQ7ooooo0_oo00001?ooooooo`00oooo
ool0nYX4ooooo`04o`3jV_ooooooo`00o`00o`;oo`0000?o0?ZJooooooooool01Oooool2o`3jVPGo
oooo00?o0?ZJooooool0nYX00oooool2o`3jVP04o`00ooooooooooooo`3jVPSooooo00Ko0?ZJool0
0?ooooooooooool00?l0nYXJooooo`03o`3jV_oooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ
0ol000002Ooooooo0?ZJoooooooooooo003oo`3jV_ooooooo`00o`3jVP05ooooo`06o`3jV_oo003o
ooooooooool0nY[oo`003?ooool2o`0001Oooooo00Co0000oooooooooooo00000oooool01?l0003o
ooooooooool00003ooooo`;o00000oooool00ol0nY[oo`00o`000002o`000003o`00ool0nY[ooooo
00Cooooo00?oo`00ooooooooool00oooool01?l0nY[oooooooooool0nYX9ooooo`04o`3jV_oo003o
o`00o`3jVQ;ooooo0ol0nYX;ooooo`05o`3jV_oo003o003oool00?l0nYX05Oooool01?l0nY[oo`00
ool00?l0nYX@ooooo`?o0?ZJ2_ooool00ooo003o0?ZJool0000Gooooo`04o`3jV_oo003oo`00o`3j
VPSooooo00Co0?ZJooooool0003o0?ZJ?Oooool004;ooooo00?o0000ooooool0nYX01?ooool2ool0
0005ooooool0nY[oo`00o`3jV_oo00000_l0nYX01Ooooooo0?ZJo`3jV_l00?ooo`0000;ooooo00Go
0?ZJooooool0nY[oooooool0000;ooooo`05o`3jV_l00?oooooooooooooo00001?ooool00ol0nY[o
ooooo`000002o`0000;ooooo00Co0?ZJoooooooooooooooo0ol0nYX01?oo003oooooo`3jV_l0nYX2
ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJooooool0nY[oo`001Oooool2o`3jVP;ooooo00?o
o`00o`3jV_ooool00_ooool3o`0000Cooooo00?oo`00o`3jV_ooool05_ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00Cooooo00Coo`00o`00oooooooo0?ZJ1?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00;ooooo00Oo0?ZJo`00oooo003oooooo`00oooo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX02Ooo
ool2o`0001cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`3jVP?ooooo0_oo00001_l0nY[oo`00oooooooo003o0?ZJooooo`;o0?ZJ1?ooool0
1_l0nY[o003oool00?ooooooo`00o`3jVQ7ooooo00Go0?ZJool00?oo003oo`00o`3jVP05ooooo`07
o`3jV_ooooooo`00o`00oooo003oooooo`3jVP07ooooo`;o0?ZJ1Oooool3o`3jVPCooooo00Go0?ZJ
o`00ooooooooooooo`3jVP08ooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ6_ooool00ol0nY[o
ooooo`3jVP03ooooo`04o`3jV_oooooo0?ZJo`3jVP?o000000Wo0?ZJooooooooooooooooo`00oooo
oooo0?ZJool00?l0nYX01Oooool01_l0nY[oo`00oooooooooooo0?ZJool000gooooo00?o0000oooo
ooooool05_ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool00_ooool00ol0nY[oo`00o`000002o`000003o`00ool0nY[ooooo00Cooooo00?oo`00
ooooooooool00oooool01?l0nY[oooooooooool0nYX9ooooo`04o`3jV_oo003oo`00o`3jVQ;ooooo
0_l0nYX<ooooo`05o`3jV_oo003o003oool00?l0nYX05Oooool01?l0nY[oo`00ool00?l0nYX@oooo
o`;o0?ZJ2oooool00ooo003o0?ZJool0000Gooooo`04o`3jV_oo003oo`00o`3jVPSooooo00Co0?ZJ
oooooooooooo0?ZJ?Oooool004;ooooo00?o0000ooooool0nYX01?ooool2ool00005ooooool0nY[o
o`00o`3jV_oo00000_l0nYX01Ooooooo0?ZJo`3jV_l00?ooo`0000?ooooo0_l0nYX00oooooooo`00
ooooo`0;ooooo`04o`3jV_ooooooooooool000Cooooo00?o0?ZJooooool000000_l000001?oo003o
003oo`3jV_l0nYX2ooooo`?o0?ZJ00Coo`00o`3jV_l0nY[o0?ZJ0_ooool00ol0nY[oooooooooo`04
ooooo`05o`3jV_oooooo0?ZJool00?l00?l01Oooool3o`3jVP03ool00?oooooooooo00?ooooo00?o
0?ZJool00?ooool00oooool00ooo003o0?ZJooooo`0Fooooo`;o0?ZJ0_ooool00ol0nY[ooooooooo
o`02ooooo`04o`3jV_oo003oooooo`3jVP?ooooo0_l0nYX3ooooo`08o`3jV_ooooooooooo`3jV_oo
003o003oooooool00?l2ool000?ooooo00?o0?ZJool00?l0nYX02_ooool00ol0003oooooooooo`0I
ooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`3jVP?ooooo
0_oo00001_l0nY[oo`00oooooooo003o0?ZJooooo`;o0?ZJ1?ooool00ol0nY[o003oool00002ool0
0003o`3jV_oooooooooo00oooooo00Go0?ZJool00?oo003o003oo`3jVP05ooooo`03o`3jV_oooooo
o`0000;oo`0000?oooooo`3jV_ooool01_ooool2o`3jVPGooooo0_l0nYX5ooooo`;o0?ZJ0_ooool0
0ol0nY[oooooooooo`06ooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ6oooool2o`3jVP?ooooo
00Co0?ZJooooool0nY[ooooo0ol000000ol0nY[oooooooooo`02ooooo`?o000000?o0?ZJoooooooo
ool00oooool3o`000003oooooooo003o0?ZJ00gooooo00?o0000ooooooooool05oooool2o`0000?o
oooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`07o`3jV_oo003ooooo
ool00?oooooo003oo`3jVP05ooooo`03ool00?oooooooooo00Cooooo00?o0?ZJooooool0nYX02Ooo
ool01?l0nY[oo`00ool00?l0nYXPooooo`05o`3jV_oo003o003oool00?l00?l05Oooool01?l0nY[o
o`00ool00?l0nYXMooooo`03ool00?l0nY[oo`0001Oooooo00Co0?ZJool00?oo003o0?ZJ2?ooool0
1?l0nY[oooooo`3jV_l0000mooooo`00@_ooool01?l0003oooooooooool0nYX3ooooo`;oo`0000Go
ooooo`3jV_oo003o0?ZJool00002o`3jVP04ooooool0nY[o0?ZJo`3jVP;oo`000_ooool2o`3jVP03
oooooooo003ooooo00_ooooo00Co0?ZJo`00ooooooooo`001?ooool00ol0nY[oooooo`000002o`00
0004ool00?l00?oo003oo`3jVP;ooooo0ol0nYX00ooo003o0?ZJooooo`02o`3jVP03ooooool0nY[o
oooo00Kooooo0_l0nYX2ool000Kooooo0_l0nYX00ooo003oooooooooo`03ooooo`03o`3jV_oo003o
oooo00?ooooo00?oo`00o`3jV_ooool05oooool01?l0nY[oooooooooool0nYX4ooooo`04o`3jV_oo
003o003oo`3jVP?ooooo00?o0?ZJooooooooool00_ooool01_l0nY[oooooooooool0nY[oo`00o`00
o`;ooooo00?o003oool00?ooool00_ooool00ol0nY[oo`00o`3jVP0:ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l000000ooooooo0?ZJooooo`02oooo
o`;oo`0000Ko0?ZJool00?ooooooo`00o`3jV_ooool2o`3jVPCooooo00Ko0?ZJo`00oooo003oo`00
ooooool0nYXAooooo`05o`3jV_l00?oo003oo`00ool0nYX01_ooool01_l0nY[oooooool00?oo003o
ooooo`3jVPOooooo0_l0nYX=ooooo`04o`3jV_ooooooooooo`3jVPSooooo00Ko0?ZJool00?l0nY[o
ooooool00?l0nYXKooooo`;o0?ZJ0oooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo
00?ooooo0ol00006ooooo`?o000000?oooooool00?l0nYX03?ooool2o`0001[ooooo00?o0000oooo
ooooool00_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool01ol0nY[oo`00oooooooo003o
0?ZJo`00ool0nYX01Oooool00ooo003oooooooooo`04ooooo`03o`3jV_oooooo0?ZJ00Wooooo00Co
0?ZJool00?oo003o0?ZJ8?ooool01?l0nY[oooooool00?l0nYXFooooo`03o`3jV_oo003oo`0001ko
oooo00?oo`00o`3jV_oo00006?ooool00ol0nY[oooooo`3jVP08ooooo`?o0?ZJ00?o0000oooooooo
ool0>oooool004;ooooo00Co0000oooooooooooo0?ZJ0oooool2ool00005ooooool0nY[oo`00o`3j
V_oo00000_l0nYX01_oooooo0?ZJooooool0nY[oooooool000;ooooo0_l0nYX00oooooooo`00oooo
o`0;ooooo`04o`3jV_l00?oo003oool000Cooooo00?o0?ZJoooooooo00000_l0nYX2ool00004o`00
ool0nY[oooooooooo`?o0?ZJ00Ooo`00o`3jV_ooooooooooo`3jV_oooooo0?ZJ00Oooooo0ol0nYX2
ool000Gooooo0_l0nYX00ooo003oooooooooo`03ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?oo`00
o`3jV_ooool05oooool01?l0nY[oooooooooool0nYX4ooooo`05o`3jV_oo003o003oool00?l0nYX0
0_ooool00ol0nY[oooooooooo`03ool000;ooooo00?o0?ZJool00?ooool00_ooool00ol00?ooo`00
ooooo`02ooooo`03o`3jV_oo003o0?ZJ00[ooooo00?o0000ooooooooool09_ooool01?l0003ooooo
ooooool0nYX3ooooo`;oo`0000Ko0?ZJool00?ooooooo`00o`3jV_ooool2o`3jVPCooooo00?o0?ZJ
o`00ooooool00_ooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_l00?oo003o00;o0?ZJ1_ooool0
1_l0nY[oooooo`00oooooooo003oo`3jVPOooooo0_l0nYX=ooooo`;o0?ZJ00?oooooo`3jV_ooool0
2?ooool01Ooo003o0?ZJoooooooo003o0?ZJ01_ooooo0_l0nYX3ooooo`03o`3jV_oooooo0?ZJ00Wo
oooo0ol00006ooooo`?o000000?oooooool00?l0nYX03Oooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo00;ooooo00Co0?ZJool00?ooooooo`000_l0nYX6ooooo`03ool00?oooooooooo
00Cooooo0_l0nYX:ooooo`04o`3jV_oo003oo`00o`3jVR3ooooo00Co0?ZJoooooooo003o0?ZJ5_oo
ool00ol0nY[oo`00o`3jVP0Nooooo`03ool00?l0nY[oo`0001Sooooo0_l0nYX9ooooo`;o0?ZJ00?o
ooooo`000?ooool0??ooool004;ooooo00Co0000oooooooooooo0?ZJ0oooool2ool00007ooooool0
nY[oo`00o`3jV_oo003o0?ZJooooo`02o`3jVP04ooooool0nY[oooooool000;ooooo0_l0nYX00ooo
ooooo`00ooooo`0;ooooo`04o`3jV_l00?oo003oool000Cooooo00?o0?ZJool00?l00?l00_l0nYX0
1?ooooooo`00o`00ool0nYX2ooooo`;o0?ZJ00?oo`00o`3jV_ooool00_ooool00ol0nY[oooooo`3j
VP07ooooo`?o0?ZJ00?o003oool00?oo00001?ooool2o`3jVP03ool00?oooooooooo00Cooooo00?o
o`00o`3jV_ooool00_ooool00ooo003o0?ZJooooo`0Gooooo`04o`3jV_ooooooooooo`3jVPCooooo
00Go0?ZJool00?oo003oo`00o`3jVP02ooooo`03o`3jV_ooooooo`0000;ooooo00Goo`00oooooooo
oooo0?ZJool00003ooooo`03o`00oooo003ooooo00;ooooo00?o0?ZJool00?ooool02Oooool2o`00
02Sooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;oo`0000Ko0?ZJool00?l0nY[oo`00o`3j
V_ooool2o`3jVPCooooo00Ko0?ZJooooool00?ooooooo`00ool0nYXBooooo`03o`3jV_oooooo0?ZJ
00Oooooo00Ko0?ZJooooool00?ooooooo`00ool0nYX7ooooo`;o0?ZJ3Oooool01?l00?oo0?ZJoooo
ool0nYX9ooooo`05ool00?l0nY[o0?ZJool00?l0nYX06oooool2o`3jVP?ooooo0_l0nYX:ooooo`;o
003o2?ooool01Ol0nY[oo`00oooooooo003o0?ZJ00gooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`02ooooo`03o`3jV_oo003ooooo00;oo`0000?o0?ZJooooooooool01?ooool00ooo
003oooooooooo`04ooooo`;o0?ZJ2_ooool01?l0nY[oo`00ool00?l0nYXQooooo`03o`3jV_l00?oo
0?ZJ01Kooooo00?o0?ZJool00?l0nYX07_ooool2ool00003o`3jV_oooooooooo01Kooooo0_l0nYX:
ooooo`03o`3jV_oooooo000003gooooo0012ooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo0000
1ooooooo0?ZJool00?oo003oooooo`3jV_ooool00_l0nYX00ooooooo0?ZJooooo`02ool00005oooo
ool0nY[o0?ZJo`3jV_oo00003?ooool00ol0nY[oooooo`000002o`0000;ooooo0_l0nYX00ooo003o
003oo`3jVP02o`3jVP03ool00?l00?oooooo00;o0?ZJ00Coooooo`3jV_oo003o0?ZJ1?ooool2o`3j
VPOooooo0ol0nYX01?oooooo003oool00?oo0003ooooo`03o`3jV_oo003o0?ZJ00Kooooo00Ooo`00
o`3jV_ooooooooooo`3jV_oo003o0?ZJ01Sooooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`08o`3j
V_oooooo003oool00?l0nY[oooooo`3jV_l00?l2ool000;ooooo00Coo`00ooooool0nY[oo`001?oo
ool00ol00?ooo`00ooooo`02ooooo`03o`3jV_oo003ooooo00[ooooo00?o0000ooooooooool09_oo
ool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_oo00001Ol0nY[oo`00o`3jV_oo003o0?ZJ00;o
oooo00?o0?ZJooooooooool00_ooool01_l0nY[oooooo`00oooooooo003oo`3jVQ;ooooo00?o0?ZJ
ooooool0nYX01oooool01_l0nY[oooooo`00oooooooo003oo`3jVPSooooo00?o0?ZJooooooooool0
3?ooool00ol00?oo0?ZJo`3jVP09ooooo`05ool00?l0nY[o0?ZJool00?l0nYX06oooool2o`3jVPCo
oooo00?o0?ZJooooooooool02?ooool2o`00o`Sooooo00Go0?ZJool00?ooooooo`00o`3jVP0=oooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool00ol0nY[oo`00ooooo`02ool0
0003o`3jV_oooooooooo00Cooooo00?oo`00ooooooooool01?ooool2o`3jVP_ooooo00?o0?ZJoooo
ool0nYX08Oooool00ol0nY[o003oo`3jVP0Fooooo`03o`3jV_l00?oo0?ZJ01kooooo0_oo00000ol0
nY[oooooooooo`0Fooooo`;o0?ZJ3?ooool00ol0003oooooooooo`0kooooo`00@_ooool01?l0003o
ooooooooool0nYX3ooooo`;oo`0000Soooooo`3jV_oo003oo`00ooooool0nY[oooooo`3jVP?ooooo
00?o0?ZJo`00oooo00000_ooool2o`3jVP03ool00?oooooooooo00_ooooo013o0?ZJo`000?l0003o
0000o`3jV_oooooo0?ZJoooooooo003o003oo`3jV_oooooo0?ZJoooooooo003o003o0_l0nYX01?oo
oooo0?ZJool00?l0nYX4ooooo`;o0?ZJ1oooool4o`3jVP;ooooo0_oo0002ooooo`03o`3jV_oo003o
0?ZJ00Kooooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ01Wooooo00?o0?ZJooooool0nYX0
1?ooool02Ol0nY[oooooo`00oooo003o0?ZJooooool0nY[o003oool00002o`00o`06oooooooo003o
ooooo`3jV_oo003ooooo0_l0nYX01?oooooo0000o`000?l00002ooooo`03o`3jV_oo003ooooo00[o
oooo00?o0000ooooooooool09_ooool2o`0000;ooooo00?o0?ZJooooooooool00_oo00001Ol0nY[o
o`00o`3jV_oo003o003o00;ooooo00?o0?ZJooooooooool00oooool01Ol0nY[o003oooooool00?oo
0?ZJ01;ooooo0ol0nYX8ooooo`05o`3jV_oooooo003oo`00ool0nYX02?ooool00ol0nY[ooooooooo
o`0<ooooo`03o`00ool0nY[o0?ZJ00Wooooo00Coo`00o`3jV_l0nY[oo`007?ooool2o`3jVPoooooo
00?o003oooooooooool01oooool01Ol0nY[oo`00oooooooo003o0?ZJ00cooooo0_l0000Uooooo`03
o`000?oooooooooo00;ooooo00?o0?ZJool00?ooool00_oo00000ol0nY[oooooooooo`04ooooo`03
ool00?oooooooooo00Cooooo0_l0nYX;ooooo`;o0?ZJ8_ooool00ol0nY[o003oo`3jVP0Fooooo`03
o`3jV_oooooo0?ZJ01kooooo0_oo00000ol0nY[oooooooooo`0Fooooo`;o0?ZJ3?ooool00ol0003o
ooooooooo`0kooooo`00@_ooool01?l0003oooooooooool0nYX4ooooo`03ool00?oooooooooo00;o
o`0000?o0?ZJo`00ooooool01?ooool00ol0nY[oooooool00002ooooo`;o0?ZJ00?oo`00oooooooo
ool02oooool04?l0nY[o0000o`000?l0003o0?ZJooooool0nY[oooooool00?oooooo0?ZJooooool0
nY[oooooool00?l00?l2o`3jVP04ooooool0nY[oo`00o`3jVPCooooo0_l0nYX7ooooo`;o0?ZJ00Ko
ooooo`3jV_ooooooooooo`00oooo0002ooooo`03o`3jV_oo003o0?ZJ00Kooooo00Oo0?ZJool00?oo
ooooooooo`3jV_oo003o0?ZJ01Wooooo00?o0?ZJooooool0nYX01?ooool01Ol0nY[oooooo`00oooo
ooooo`0000;o0?ZJ0_oo0002o`00o`05oooooooo003oooooo`3jV_oo00001?l0nYX3o`0000;ooooo
00?oo`00o`3jV_ooool02_ooool00ol0003oooooooooo`0Vooooo`05o`000?ooooooooooooooool0
nYX00_ooool2ool00005o`3jV_oo003o0?ZJool00?l00?l02?ooool01Ol0nY[o003oooooool00?oo
0?ZJ01gooooo00Go0?ZJooooool00?oo003oo`3jVP08ooooo`03o`3jV_oooooooooo00cooooo00?o
003oooooool0nYX02Oooool01?l0nY[oo`00o`3jV_oo000Looooo`;o0?ZJ6_ooool01?oo003o0?ZJ
ool00?l0nYX=ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool00ol0nY[o
ooooool00002ool00003o`3jV_oooooooooo00Cooooo00?oo`00ooooooooool01?ooool2o`3jVP_o
oooo0_l0nYXRooooo`03o`3jV_l00?oo0?ZJ01Kooooo00?o0?ZJooooool0nYX07_ooool2ool00003
o`3jV_oooooooooo01Kooooo0_l0nYX<ooooo`03o`000?oooooooooo03_ooooo0012ooooo`04o`00
0?ooooooooooo`3jVPCooooo00?o0?ZJooooooooool00_oo00000ol0nY[o003oooooo`04ooooo`03
o`3jV_ooooooo`0000;ooooo0_l0nYX00ooo003oooooooooo`0=ooooo`;oo`0000Soooooo`3jV_oo
ooooo`00o`00oooooooo0?ZJooooo`;o0?ZJ00?oo`00o`00ooooool00_ooool2ool000Kooooo00?o
0?ZJooooooooool01_ooool01?l0nY[oooooo`3jV_l0nYX2ooooo`06o`00oooo003oooooo`3jV_oo
003o0?ZJ1_ooool01ol0nY[oo`00oooooooooooo0?ZJool00?l0nYX06Oooool00ol0nY[oooooo`3j
VP04ooooo`03o`3jV_oooooo000000;o000000co0?ZJo`00oooo003oooooo`00oooooooo003oool0
0?oooooo0?ZJool00?l0nYX2ooooo`04o`3jV_l0003o0000o`0000;ooooo00?oo`00o`3jV_ooool0
2_ooool00ol0003oooooooooo`0Vooooo`05o`000?ooooooooooooooool0nYX00_ooool2ool00005
o`3jV_oo003o0?ZJool00?l00?l02?ooool01Ol0nY[o003oooooool00?oo0?ZJ01gooooo00Go0?ZJ
ooooool00?oo003oo`3jVP08ooooo`03o`3jV_oooooooooo00cooooo0_l00?l:ooooo`04o`3jV_oo
003o0?ZJool001cooooo0_l0nYXJooooo`04ool00?l0nY[oo`00o`3jVPgooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`02ooooo`03o`3jV_ooooooo`0000;oo`0000?o0?ZJoooooooo
ool01?ooool00ooo003oooooooooo`04ooooo`;o0?ZJ2oooool2o`3jVR;ooooo00?o0?ZJooooool0
nYX05_ooool00ol0nY[oooooo`3jVP0Nooooo`;oo`0000?o0?ZJooooooooool05_ooool2o`3jVPco
oooo00?o0000ooooooooool0>oooool004;ooooo00Co0000oooooooooooo0?ZJ1?ooool00ol0nY[o
ooooooooo`02ool00003o`3jV_l00?oooooo00Cooooo00?o0?ZJoooooooo00000_ooool00ol0nY[o
o`00o`3jVP0?ooooo`03o`3jV_oo003ooooo00;ooooo00Coo`00o`00oooooooo0?ZJ0_ooool00ol0
nY[oo`00o`00o`03ooooo`;oo`001_ooool00ol0nY[oooooooooo`09ooooo`04o`3jV_oooooooooo
o`00o`;oo`0000?o0?ZJool00?ooool01_ooool01ol0nY[oo`00oooooooooooo0?ZJool00?l0nYX0
6Oooool00ol0nY[oooooo`3jVP05ooooo`07o`3jV_l0003o0000o`000?oooooo003oool00003oooo
o`06o`00oooo003oooooo`3jV_oo003o0?ZJ0_ooool01?l0nY[oooooool00?l0nYX2ooooo`03ool0
0?l0nY[ooooo00Wooooo0_l0000Xooooo`;o00000_ooool02_l0nY[ooooooooooooo003oooooo`3j
V_oo003o003oool00?l00?l8ooooo`05o`3jV_l00?ooooooo`00ool0nYX07Oooool2o`3jVP03o`00
ool0nY[ooooo01Oooooo0_l00?l:ooooo`04o`3jV_oo003o0?ZJool001cooooo0_l0nYXJooooo`03
ool00?l0nY[oo`0000gooooo0_l0000Uooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooooooo
00000_oo00000ol0nY[oooooooooo`04ooooo`03ool00?oooooooooo00Cooooo0_l0nYX;ooooo`;o
0?ZJ8_ooool00ol0nY[oooooo`3jVP0Fooooo`03o`3jV_oooooo0?ZJ01kooooo0_oo00000ol0nY[o
ooooooooo`0Fooooo`;o0?ZJ3?ooool00ol0003oooooooooo`0kooooo`00@_ooool01?l0003ooooo
ooooool0nYX4ooooo`03o`3jV_oooooooooo00;oo`0000?o0?ZJo`00ooooool01?ooool02?l0nY[o
ooooo`00oooo003oooooo`3jV_oo003o0?ZJ3oooool00ol0nY[oo`00ooooo`02ooooo`04ool00?l0
0?oo0?ZJo`3jVP;ooooo00?o0?ZJoooooooo00000_ooool3ool000Kooooo00?o0?ZJooooooooool0
2Oooool2o`3jVP03ooooool00?oooooo00?oo`001oooool01ol0nY[oo`00o`3jV_oooooo0?ZJool0
0?l0nYX06_ooool2o`3jVPGooooo00Ko0?ZJo`000?l0003o0000o`00oooo0004ooooo`05o`00oooo
003o0?ZJool00?l0nYX01?ooool00ol0nY[oo`00o`3jVP02ooooo`03ool00?l0nY[ooooo00[ooooo
00?o0000ooooooooool09_ooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo00Go0?ZJool00?l0
0?ooo`00o`00o`08ooooo`05o`3jV_l00?ooooooo`00ool0nYX07_ooool3o`3jVRCooooo00Co0?ZJ
ool00?l0nY[oo`007?ooool2o`3jVQ[ooooo00?oo`00oooooooo00003_ooool00ol0003ooooooooo
o`0Sooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooooooo00000_oo00000ol0nY[ooooooooo
o`04ooooo`03ool00?oooooooooo00Cooooo0_l0nYX;ooooo`;o0?ZJ8_ooool00ol0nY[oooooo`3j
VP0Fooooo`03o`3jV_oooooo0?ZJ01kooooo00?o0?ZJool00?ooool09_ooool00ol0003ooooooooo
o`0kooooo`00=?ooool3o`0000Cooooo0_l00005ooooo`05o`000?ooooooooooooooool0nYX00ooo
ool00ol0nY[oooooooooo`02ool00003o`3jV_l00?oooooo00Gooooo00Oo0?ZJo`00oooo003ooooo
o`3jV_oo003o0?ZJ00oooooo00?o0?ZJool00?oo00000_ooool00ooo003o003oo`3jVP03ooooo`05
o`3jV_ooooooo`00o`00ooooool00ooo0006ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJoooo
ool00?l00_ooool2ool000Sooooo00Koo`00o`3jV_oooooo0?ZJool00?l00?lJooooo`;o0?ZJ1Ooo
ool2o`3jVP04oooooooo003oo`00ool000;ooooo0ol0nYX01?oo003o0?ZJool00?l0nYX4ooooo`03
o`3jV_oo003o0?ZJ00;ooooo00?oo`00o`3jV_ooool02_ooool00ol0003oooooooooo`0Vooooo`05
o`000?ooooooooooooooool0nYX01?ooool01?l0nY[oo`00o`00oooo0009ooooo`05o`3jV_oooooo
0?ZJo`00ool0nYX07oooool2o`3jVRCooooo00Co0?ZJool00?ooooooo`007Oooool00ol0nY[ooooo
ooooo`0Hooooo`03o`3jV_oo003oo`0000kooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`02ooooo`03o`3jV_ooooooo`0000;oo`0000?o0?ZJooooooooool01?ooool00ooo003ooooo
ooooo`0Aooooo`;o0?ZJ8_ooool2o`3jVQOooooo00?o0?ZJooooool0nYX07_ooool00ol0nY[oo`00
ooooo`0Vooooo`03o`000?oooooooooo03_ooooo000eooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJoooooooo
ool00_oo00000ol0nY[oooooooooo`05ooooo`07o`3jV_l00?ooo`00ooooool0nY[oo`00o`3jVP0@
ooooo`05o`3jV_oo003oooooool00?l00?l00_l0nYX3ooooo`05o`3jV_ooooooo`00o`00ooooool0
0ooo0006ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX00ol00?ooooooooooo`02ool000Sooooo
00Koo`00o`3jV_oooooo0?ZJool00?l00?lJooooo`;o0?ZJ2?ooool01Ol0nY[o003ooooooooooooo
0?ZJ00;ooooo00Go0?ZJool00?l0nY[oo`00o`3jVP04ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o
o`00o`3jV_ooool02_ooool00ol0003oooooooooo`0Vooooo`05o`000?ooooooooooooooool0nYX0
1?ooool01?l0nY[oo`00o`00oooo0009ooooo`?o0?ZJ00?o003oo`3jV_ooool0AOooool2ool00003
o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oo`00ool0000>ooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooool00002ool00003
o`3jV_oooooooooo00Cooooo00?oo`00ooooooooool04Oooool2o`3jVR;ooooo0_l0nYXHooooo`03
o`3jV_oooooooooo01gooooo0_l0nYXWooooo`03o`000?oooooooooo03_ooooo000eooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`0000;ooooo00Go0?ZJoooooooo
ooooooooo`3jVP02ooooo`03o`3jV_l00?oo0?ZJ00Oooooo00?o0?ZJo`00oooo00000ooo000Aoooo
o`06o`3jV_oo003oo`00ool00?l00?oo0?ZJ1Oooool01?l0nY[oo`00ool00?ooool2ool00003o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool02oooool01?l0nY[o003oooooooooool2ool000So
oooo00Goo`00o`3jV_oooooo0?ZJool0000Kooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`02o`3j
VP?ooooo0ooo00000ol0nY[oooooooooo`02ooooo`;o0?ZJ00Goo`00ooooooooooooo`00o`3jVP0:
ooooo`;o0000:?ooool2o`0000;ooooo00?o0?ZJooooooooool00_ooool2o`3jVP03ool00?l0nY[o
oooo00Wooooo00Co0?ZJo`00ool0nY[o0?ZJA_ooool2ool00003o`3jV_oooooooooo01_ooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oo`00ool0000=ooooo`;o00009Oooool00ol0003ooooooooo
o`02ooooo`03o`3jV_ooooooo`0000;oo`0000?o0?ZJooooooooool01?ooool00ooo003ooooooooo
o`0Aooooo`03o`3jV_oooooooooo027ooooo0_l0nYXHooooo`03o`3jV_oooooooooo01gooooo0_l0
nYXWooooo`03o`000?oooooooooo03_ooooo000eooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00Ko0?ZJoooooooooooo
0?ZJo`00ool0nYX7ooooo`03o`3jV_oooooo003o00?oo`004Oooool00ol0nY[oooooool00002o`00
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo00000ooo00000ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooooooo00_ooooo0_l0nYX2ooooo`;oo`002?ooool01Ooo003o0?ZJooooool0nY[o
o`0001_ooooo0_l0nYX8ooooo`04o`3jV_ooooooooooo`3jVPCooooo0_oo00000ol0nY[ooooooooo
o`04ooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ2oooool00ol0003oooooooooo`0Hooooo`Go
00000oooool2o`0000Cooooo00Go0000ooooooooooooooooo`3jVP04ooooo`;o0?ZJ00?oo`00o`3j
V_ooool02oooool2o`3jVTKooooo0_oo00000ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo
01Sooooo00?o0?ZJool00?l0nYX03_ooool00ol0003oooooooooo`0Fooooo`?o00001?ooool2o`00
00Cooooo00?o0000ooooooooool00_ooool00ol0nY[oooooool00002ool00003o`3jV_oooooooooo
00Cooooo00?oo`00ooooooooool0=Oooool2o`3jVQSooooo00?o0?ZJooooooooool07Oooool2o`3j
VROooooo00?o0000ooooooooool0>oooool003Gooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00004ooooo`05o`000?ooooooooooooooool0nYX00oooool01_l0nY[oooooooooool0
nY[o003oo`3jVPOooooo00Co0?ZJooooool00?oooooo0_oo000Aooooo`04o`3jV_oooooo003oo`00
o`;o0?ZJ1Oooool01ol0nY[oooooool00?oo003oooooool00?l0nYX05Oooool01Ol0nY[ooooooooo
oooo003o0?ZJ00Sooooo00Goo`00o`3jV_ooooooo`00o`3jVP0Kooooo`;o0?ZJ2Oooool3o`3jVP?o
oooo0ol000000ol0nY[oooooooooo`04ooooo`05o`3jV_oo003oooooo`3jV_oo00003?ooool00ol0
003oooooooooo`0Iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000ooo
ool01Ol0003ooooooooooooooooo0?ZJ00Cooooo0_l0nYX00ooo003o0?ZJooooo`0;ooooo`;o0?ZJ
A_ooool00ol0nY[oo`00o`3jVP0Mooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJo`00ool0nYX0
3_ooool00ol0003oooooooooo`0Eooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooooooo00000_oo00000ol0
nY[oooooooooo`04ooooo`03ool00?oooooooooo03Gooooo0_l0nYXhooooo`;o0?ZJ9oooool00ol0
003oooooooooo`0kooooo`00=?ooool2o`0000Cooooo00Co0000oooooooooooo00001?ooool01Ol0
003ooooooooooooooooo0?ZJ00?ooooo00Ko0?ZJoooooooooooo0?ZJo`00ool0nYX7ooooo`04o`3j
V_oooooo003oooooo`;oo`004_ooool01?l0nY[oooooooooool0nYX6ooooo`04o`3jV_oooooooooo
o`00o`?o00005Oooool2o`3jVP03oooooooo003o0?ZJ00Sooooo00Go0?ZJool00?ooooooo`00o`3j
VP0Kooooo`;o0?ZJ2Oooool2o`3jVPCooooo0ol000000ol0nY[oooooooooo`05ooooo`04ool00?l0
nY[o0?ZJool000cooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`3jVP04ooooo`;o0?ZJ00?oo`00o`3j
V_ooool02oooool2o`3jVTKooooo00?o0?ZJool00?l0nYX07Oooool00ol0nY[oooooooooo`0Ioooo
o`;o0?ZJ3_ooool00ol0003oooooooooo`0Iooooo`04o`000?ooooooooooo`0000;ooooo00Go0000
ooooooooooooooooo`000004ooooo`06o`3jV_ooooooo`00o`3jV_oo003o0?ZJ1_ooool00ooo003o
ooooooooo`1_ooooo`;o0?ZJ9oooool00ol0003oooooooooo`0kooooo`00=Oooool00ol0003ooooo
ooooo`03ooooo`;o00001Oooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJoooooooo
ool00_l0nYX00ol00?ooooooooooo`06ooooo`03o`3jV_l00?oo003o00;oo`004_ooool01?l0nY[o
ooooooooool0nYX6ooooo`04o`3jV_ooooooooooo`00o`?o00005_ooool2o`3jVP03ool00?l0nY[o
oooo00Oooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Kooooo`;o0?ZJ3oooool3o`000003o`3jV_oo
oooooooo00Gooooo00Coo`00o`3jV_l0nY[oo`002oooool2o`0001gooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0nY[oooooooooo`02oooo
o`;o0?ZJ00?oo`00o`3jV_ooool02oooool2o`3jVTKooooo00?o0?ZJo`00ool0nYX07Oooool00ol0
nY[oooooooooo`0Iooooo`;o0?ZJ3Oooool2o`0001_ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooooooool2o`0000?ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX6ooooo`03
ool00?oooooooooo06oooooo0_l0nYXVooooo`;o0000?Oooool004;ooooo00Go0000oooooooooooo
ooooo`3jVP03ooooo`03o`3jV_oooooooooo00;o0?ZJ00?o003oooooooooool01_ooool00ol0nY[o
003oo`00o`02ool001;ooooo00Co0?ZJooooool0nY[o0?ZJ1oooool00ol0nY[oooooo`00o`03o`00
01Kooooo00?o003oo`3jV_oo00002Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01_ooooo0_l0nYX@
ooooo`;o0?ZJ2?ooool01?oo003o0?ZJo`3jV_oo000<ooooo`03o`000?oooooooooo01Sooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000oooooooo
ooooooooo`3jVP03ooooo`?o0?ZJ00?oo`00o`3jV_ooool02oooool2o`3jVTKooooo00?o0?ZJo`00
ool0nYX07Oooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ3_ooool00ol0003oooooooooo`0Eoooo
o`Co00000oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00Ko0?ZJ
oooooooooooo0?ZJool00?l0nYX6ooooo`03ool00?oooooooooo073ooooo00?o0?ZJooooooooool0
9Oooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo
00?o0?ZJooooooooool00_ooool00ol00?ooooooooooo`06ooooo`03o`3jV_oooooo003o00;oo`00
4_ooool3o`3jVPSooooo00Go0?ZJooooool00?oo003oo`3jVP0Gooooo`03o`00ooooooooo`0000Wo
oooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Looooo`03o`3jV_oooooooooo01Sooooo00Coo`00o`3j
V_l0nY[oo`003?ooool00ol0003oooooooooo`0Hooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooooooool0nYX00oooool3o`3jVP03
ooooool0nY[ooooo00cooooo00?o0?ZJooooooooool0A?ooool00ol0nY[o003oo`3jVP0Mooooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool03Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02oooo
o`06o`3jV_ooooooooooo`3jV_oo003o0?ZJ1_ooool00ooo003oooooooooo`2Hooooo`03o`000?oo
oooooooo03_ooooo0012ooooo`05o`000?ooooooooooooooool0nYX00oooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooo003o00;oo`004oooool2o`3jVPSooooo00Go0?ZJooooool00?oo003o
o`3jVP0Hooooo`03o`00oooo003ooooo00Sooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Looooo`03
o`3jV_oooooooooo01Sooooo00Coo`00oooooooo003o0?ZJ3?ooool00ol0003oooooooooo`0Ioooo
o`?o00001?ooool2o`0000Cooooo0_l00002ooooo`04o`3jV_ooooooooooooooo`?o0?ZJ00?ooooo
o`3jV_ooool03?ooool00ol0nY[oooooooooo`14ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`0X
ooooo`;o00005oooool5o`0000?ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00Oo0?ZJ
oooooooooooo0?ZJool00?l0nY[oo`0000Gooooo00?oo`00ooooooooool0V?ooool00ol0003ooooo
ooooo`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool0
2oooool00ol0nY[oooooo`00o`02ool001gooooo00Go0?ZJooooool00?oo003oo`3jVP0Hooooo`?o
00002?ooool01Ol0nY[oo`00o`00oooo003o0?ZJ01cooooo00?o0?ZJooooooooool06?ooool01?l0
nY[oo`00ool00?l0nYX<ooooo`03o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3j
VP03ooooo`?o0?ZJ00?oooooo`3jV_ooool0E?ooool00ol0nY[oooooooooo`18ooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYX3ool000Gooooo
00?oo`00ooooooooool0V?ooool00ol0003oooooooooo`0kooooo`00@_ooool01Ol0003ooooooooo
oooooooo0?ZJ00?ooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooo`00o`02ool001kooooo
0_l0nYX00ooooooo0?ZJooooo`0Gooooo`?o00002Oooool01?oo003o003oool00?l0nYXgooooo`04
o`3jV_oo003oo`00o`3jVP_ooooo0_l0000Xooooo`05o`000?ooooooooooooooool0nYX00oooool4
o`3jVUKooooo00?o0?ZJooooooooool0B?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooo
oooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0ooo0005ooooo`03ool00?oooooooooo09Sooooo00?o
0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oo
oooooooo00_ooooo00Go0?ZJooooool00?ooo`00o`3jVP0Oooooo`;o0?ZJ6Oooool3o`0000Wooooo
00Coo`00o`00oooo003o0?ZJ=oooool01?l0nY[oo`00ool00?l0nYX<ooooo`03o`000?oooooooooo
02Kooooo00Go0000ooooooooooooooooo`3jVP03ooooo`;o0?ZJ00?oooooo`3jV_ooool0X?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0ooo
0005ooooo`03ool00?oooooooooo09Sooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000
ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00cooooo00Co0?ZJo`000?l0003o0000
>_ooool00ol00?ooooooooooo`09ooooo`04o`3jV_oo003oo`00o`3jVSOooooo00Co0?ZJool00?oo
003o0?ZJ3?ooool00ol0003oooooooooo`0Vooooo`;o00000_ooool01?l0nY[oooooooooooooool2
o`3jVP03ooooool0nY[ooooo09oooooo0_l0000Uooooo`03o`000?oooooooooo00;ooooo00Co0?ZJ
oooooooooooo0?ZJ0ooo0005ooooo`03ool00?oooooooooo09Sooooo00?o0000ooooooooool0>ooo
ool004;ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00cooooo00Co
0?ZJo`000?l0003o0000A_ooool01?l0nY[oo`00ool00?l00?lgooooo`04o`3jV_l00?oo003oo`3j
VPcooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo0_l0nYX0
0ooooooo0?ZJooooo`2Pooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool0
1?l0nY[oooooooooool0nYX3ool000Gooooo00?oo`00ooooooooool0V?ooool00ol0003ooooooooo
o`0kooooo`00@_ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool03?oo
ool01?l0nY[o0000o`000?l00016ooooo`03o`3jV_oo003o0?ZJ03Wooooo0_l0nYX<ooooo`;o0000
:?ooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`3jV_ooool0
X?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo
0?ZJ0ooo0005ooooo`03ool00?oooooooooo09Sooooo00?o0000ooooooooool0>oooool004;ooooo
00Go0000ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJoooooooo
ool0AOooool00ol0nY[o003oo`3jVP0iooooo`;o0?ZJ3Oooool00ol0003oooooooooo`0Vooooo`;o
00000oooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[ooooo09oooooo0_l0000Uooooo`03
o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0ooo0005ooooo`03ool00?oooooooooo
09Sooooo00?o0000ooooooooool0>oooool004;ooooo00Go0000ooooooooooooooooo`3jVP03oooo
o`03o`3jV_oooooooooo05Kooooo00?o0?ZJooooool0nYX0>Oooool2o`3jVPgooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`3j
V_ooool0X?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooo
oooooooo0?ZJ0ooo0003ooooo`?oo`00V_ooool00ol0003oooooooooo`0kooooo`00@_ooool00ol0
003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVUSooooo00?o0?ZJooooool0nYX0>Oooool2
o`3jVPgooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`02ooooo`04o`3jV_oooooo
ooooo`3jVZCooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`03ooooo`03o`3jV_oo
oooo0?ZJ00;oo`0000?oooooool00?ooool01?oo002Jooooo`03o`000?oooooooooo03_ooooo0012
ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJFOooool2o`3jVTOooooo0_l0
000Xooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJY?ooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooool0nYX00_oo00001?ooooooo`00
ool00?oo0002ooooo`03o`3jV_oooooooooo09Sooooo00?o0000ooooooooool0>oooool004;ooooo
00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYYIooooo`;o0?ZJB?ooool00ol0003o
ooooooooo`0Vooooo`;o00000oooool01?l0nY[oooooooooool0nYZSooooo`;o00009Oooool00ol0
003oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00;oo`0000?oooooool00?oo00000oooool00ol0
nY[oooooooooo`2Hooooo`03o`000?oooooooooo03_ooooo000cooooo`Go00000oooool2o`0000Go
oooo00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYYIooooo`03o`3jV_oooooooooo
04Oooooo00?o0000ooooooooool06Oooool3o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo
00;ooooo00Co0?ZJoooooooooooo0?ZJY?ooool00ol0003oooooooooo`0Fooooo`?o00001?ooool2
o`0000Cooooo00?o0000ooooooooool00oooool00ol0nY[oooooo`3jVP02ool00003oooooooo003o
oooo00?ooooo00?o0?ZJooooooooool0V?ooool00ol0003oooooooooo`0kooooo`00=?ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_oo
ool01?l0nY[oooooooooool0nYXIooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
6?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0
003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVQ[ooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0Eooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00003ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooool0nYX00_oo0006ooooo`03o`3j
V_oooooooooo00kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0kooooo`00=Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo1Ol000001?l0nY[o0000
o`000?l0nYZTo`0001kooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooooooool5
o`000004o`3jV_l0003o0000o`3jVZGo00005oooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000oooool6o`000003o`3jV_l0003o0?ZJ00;oo`001_l000000ol0nY[o
0000o`00002Io`0003gooooo000fooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooooooo`3;ooooo`;o00000oooool01?l0003oooooooooool00038ooooo`Co00000oooool01?l0
003oooooooooool0003]ooooo`00<oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo0000coooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0<Kooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool0003]ooooo`00<oooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo0000boooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo0000bOooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`000>gooooo000dooooo`?o00001?ooool2o`000<gooooo0ol00004ooooo`;o0000Eooo
ool3o`00077ooooo0_l00004ooooo`;o0000k_ooool00?ooooooK?ooool00ol0003oooooooooo`3o
ooooofOooooo002Eooooo`;o000000?oooooo`000?l00000d_ooool00ol0003oooooooooo`3>oooo
o`Go0000T_ooool009Kooooo00?o0000ooooool00000doooool00ol0003oooooooooo`3?ooooo`04
o`000?ooooooooooo`0009;ooooo002Gooooo`03o`000?oooooooooo0=7ooooo00?o0000ooooool0
0000dOooool00ol0003oooooooooo`2Booooo`00U_ooool00ol0003oooooo`00003Booooo`03o`00
0?oooooo00000<oooooo00Co0000oooooooooooo0000Toooool009Gooooo0_l000000ooooooo0000
o`00003@ooooo`;o000000?oooooo`000?l00000c_ooool5o`0009;ooooo003oooooooooooooe_oo
ool00?oooooooooooooFooooo`00ooooooooooooomKooooo003oooooooooooooe_ooool00?oooooo
oooooooFooooo`00ooooooooooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFoooo
o`00ooooooooooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00oooooooo
ooooomKooooo003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo
003oooooooooooooe_ooool00?oooooooooooooFooooo`00ooooooooooooomKooooo003ooooooooo
ooooe_ooool00?oooooooooooooFooooo`00oooooomGooooo`03o`000?oooooooooo01?ooooo0ol0
0003ooooo`?o0000oooooomPooooo`00oooooomHooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`3ooooooeoooooo003oooooodGooooo0_l00002oooo
o`?o000000?oooooo`000?l000000ol00006ooooo`03o`000?oooooooooo00Kooooo0_l000000ooo
oooo0000o`000002ooooo`Co00000_ooool3o`0000?ooooo0ol00003ooooo`Co00000_ooool4o`00
00Sooooo0ol0003oooooodOooooo003oooooodCooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00?o0000ooooool000000_ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo
0000ooooool00002ooooo`03o`000?oooooooooo00cooooo00Go0000ooooooooooooooooo`00003o
ooooodKooooo003oooooodCooooo00Co0000oooooooooooo00000_ooool00ol0003oooooo`000003
ooooo`03o`000?oooooooooo00oooooo0_l00004ooooo`?o00000oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000;ooooo0ol00003ooooo`Co00000_ooool4o`0000Gooooo
00?o0000ooooooooool0oooooom4ooooo`00oooooom4ooooo`04o`000?ooooooooooo`0000;ooooo
0_l00004ooooo`?o00003oooool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`0000?o
oooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o
0000ooooooooool03_ooool2o`000?ooooooAoooool00?ooooooA?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool03oooool01?l0003oooooo`00
0?l00002ooooo`;o00000oooool4o`0000;ooooo1?l00003ooooo`;o00004oooool00ol0003ooooo
ooooo`3oooooodCooooo003oooooodCooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000ooooooooool09_ooool01Ol0
003ooooooooooooooooo00000?ooooooA_ooool00?oooooo@oooool3o`000003ooooool0003o0000
00?o000000?oooooo`000?l000001Ol0000=ooooo`;o0000:Oooool3o`000?ooooooAoooool00?oo
oooooooooooFooooo`00ooooooooooooomKooooo0000\
\>"],
  ImageRangeCache->{{{0, 723.625}, {297.562, 0}} -> {-0.19432, -0.0309084, \
0.00468287, 0.00468287}, {{41.4375, 255}, {290.938, 158.938}} -> {-365.765, \
3.33309, 5.79891, 0.0937347}, {{255, 468.562}, {290.938, 158.938}} -> \
{-1604.2, 23.333, 5.79891, 0.0937347}, {{468.562, 682.125}, {290.938, \
158.938}} -> {-2825.23, -1.33353, 5.79891, 0.0749878}, {{41.4375, 255}, \
{158.938, 27}} -> {-383.655, -100.238, 5.80218, 0.468937}, {{255, 468.562}, \
{158.938, 27}} -> {-1622.78, -114.286, 5.80218, 0.562723}, {{468.562, \
682.125}, {158.938, 27}} -> {-2844.51, -84.2858, 5.80218, 0.562723}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF, kappa=-5; p+kappa=6-5=1", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta+1, 
\t     {driftLorenzX, diffusionLorenzX, hLorenzX, RLorenzX, \
mueLorenzX,sigmaLorenzX,dt,kappa=-5},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
{{-0.401605, -0.0433301, 0.176652, 11., 29., 3.66667}, {{0.0990099, \
0., 0., 0., 0., 0.}, {0., 0.0990099, 0., 0., 0., 0.}, {0., 0., 0.0990099, 0., \
0., 0.}, {0., 0., 0., 1., 0., 0.}, {0., 0., 0., 0., 1., 0.}, {0., 0., 0., 0., \
0., 1.}}, -3.47862}\
\>", "Print",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{29.33333333333303*Second, Null}\
\>", "\<\
{29.3333 \
Second, Null}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{163.18997747717097, 226.4595639968892, \
313.7756700304664, 308.6236479132634, 104.67089691803372, \
50.35759082055044}\
\>", "\<\
{163.19, 226.46, 313.776, 308.624, 104.671, \
50.3576}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{0.9462890169487373, 0.9188794440742741, \
-3.404673840620957, -9.547282622736887, 3.0744259631720343, \
1.441855235350695}, {5.070394608017915, 7.098476033029531, 9.314773766859327, \
2.0006991703471124, 1.2218660347965054, 0.6740972332995647}}\
\>", \
"\<\
{{0.946289, 0.918879, -3.40467, -9.54728, 3.07443, 1.44186}, {5.07039, \
7.09848, 9.31477, 2.0007, 1.22187, 0.674097}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,25},{20,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.001{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-30, 20}, {-30, 30}, {0, 60}, {5, 25}, {20, 35}, \
{0, 8}}\
\>", "\<\
{{-30, 20}, {-30, 30}, {0, 60}, {5, 25}, {20, 35}, {0, 8}}\
\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gUKFkappam5=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{\
graph1[4],graph1[5],graph1[6]}}],
\tPlotLabel->\"UKF, kappa=-5\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -41 0 ]
[.5 .42452 41 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -102 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
(-) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
141.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 -0.154508 0.0309017 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -18 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -12 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -24 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -24 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -12 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -24 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(7.5)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(10)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(12.5)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(15)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(17.5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(20)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(22.5)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(25)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .1545 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .15451 m
.001 .15451 L
.002 .15451 L
.003 .15451 L
.004 .15451 L
.005 .15451 L
.00599 .15451 L
.00699 .15451 L
.00799 .15451 L
.00899 .15451 L
.00999 .15451 L
.01099 .15451 L
.01199 .15451 L
.01299 .15451 L
.01399 .15451 L
.01499 .15451 L
.01598 .15451 L
.01698 .15451 L
.01798 .15451 L
.01898 .15451 L
.01998 .15451 L
.02098 .15451 L
.02198 .15451 L
.02298 .15451 L
.02398 .15451 L
.02498 .15451 L
.02597 .15451 L
.02697 .15451 L
.02797 .15451 L
.02897 .15451 L
.02997 .15451 L
.03097 .15451 L
.03197 .15451 L
.03297 .15451 L
.03397 .15451 L
.03497 .15451 L
.03596 .15451 L
.03696 .15451 L
.03796 .15451 L
.03896 .15451 L
.03996 .15451 L
.04096 .15451 L
.04196 .15451 L
.04296 .15451 L
.04396 .15451 L
.04496 .15451 L
.04595 .15451 L
.04695 .15451 L
.04795 .15451 L
.04895 .15451 L
Mistroke
.04995 .15451 L
.05095 .15451 L
.05195 .15451 L
.05295 .15451 L
.05395 .15451 L
.05495 .15451 L
.05594 .15451 L
.05694 .15451 L
.05794 .15451 L
.05894 .15451 L
.05994 .15451 L
.06094 .15451 L
.06194 .15451 L
.06294 .15451 L
.06394 .15451 L
.06494 .15451 L
.06593 .15451 L
.06693 .15451 L
.06793 .15451 L
.06893 .15451 L
.06993 .15451 L
.07093 .15451 L
.07193 .15451 L
.07293 .15451 L
.07393 .15451 L
.07493 .15451 L
.07592 .15451 L
.07692 .15451 L
.07792 .15451 L
.07892 .15451 L
.07992 .15451 L
.08092 .15451 L
.08192 .15451 L
.08292 .15451 L
.08392 .15451 L
.08492 .15451 L
.08591 .15451 L
.08691 .15451 L
.08791 .15451 L
.08891 .15451 L
.08991 .15451 L
.09091 .15451 L
.09191 .15451 L
.09291 .15451 L
.09391 .15451 L
.09491 .15451 L
.0959 .15451 L
.0969 .15451 L
.0979 .15451 L
.0989 .15451 L
Mistroke
.0999 .15451 L
.1009 .15451 L
.1019 .15451 L
.1029 .15451 L
.1039 .15451 L
.1049 .15451 L
.10589 .15451 L
.10689 .15451 L
.10789 .15451 L
.10889 .15451 L
.10989 .15451 L
.11089 .15451 L
.11189 .15451 L
.11289 .15451 L
.11389 .15451 L
.11489 .15451 L
.11588 .15451 L
.11688 .15451 L
.11788 .15451 L
.11888 .15451 L
.11988 .15451 L
.12088 .15451 L
.12188 .15451 L
.12288 .15451 L
.12388 .15451 L
.12488 .15451 L
.12587 .15451 L
.12687 .15451 L
.12787 .15451 L
.12887 .15451 L
.12987 .15451 L
.13087 .15451 L
.13187 .15451 L
.13287 .15451 L
.13387 .15451 L
.13487 .15451 L
.13586 .15451 L
.13686 .15451 L
.13786 .15451 L
.13886 .15451 L
.13986 .15451 L
.14086 .15451 L
.14186 .15451 L
.14286 .15451 L
.14386 .15451 L
.14486 .15451 L
.14585 .15451 L
.14685 .15451 L
.14785 .15451 L
.14885 .15451 L
Mistroke
.14985 .15451 L
.15085 .15451 L
.15185 .15451 L
.15285 .15451 L
.15385 .15451 L
.15485 .15451 L
.15584 .15451 L
.15684 .15451 L
.15784 .15451 L
.15884 .15451 L
.15984 .15451 L
.16084 .15451 L
.16184 .15451 L
.16284 .15451 L
.16384 .15451 L
.16484 .15451 L
.16583 .15451 L
.16683 .15451 L
.16783 .15451 L
.16883 .15451 L
.16983 .15451 L
.17083 .15451 L
.17183 .15451 L
.17283 .15451 L
.17383 .15451 L
.17483 .15451 L
.17582 .15451 L
.17682 .15451 L
.17782 .15451 L
.17882 .15451 L
.17982 .15451 L
.18082 .15451 L
.18182 .15451 L
.18282 .15451 L
.18382 .15451 L
.18482 .15451 L
.18581 .15451 L
.18681 .15451 L
.18781 .15451 L
.18881 .15451 L
.18981 .15451 L
.19081 .15451 L
.19181 .15451 L
.19281 .15451 L
.19381 .15451 L
.19481 .15451 L
.1958 .15451 L
.1968 .15451 L
.1978 .15451 L
.1988 .15451 L
Mistroke
.1998 .15451 L
.2008 .15451 L
.2018 .15451 L
.2028 .15451 L
.2038 .15451 L
.2048 .15451 L
.20579 .15451 L
.20679 .15451 L
.20779 .15451 L
.20879 .15451 L
.20979 .15451 L
.21079 .15451 L
.21179 .15451 L
.21279 .15451 L
.21379 .15451 L
.21479 .15451 L
.21578 .15451 L
.21678 .15451 L
.21778 .15451 L
.21878 .15451 L
.21978 .15451 L
.22078 .15451 L
.22178 .15451 L
.22278 .15451 L
.22378 .15451 L
.22478 .15451 L
.22577 .15451 L
.22677 .15451 L
.22777 .15451 L
.22877 .15451 L
.22977 .15451 L
.23077 .15451 L
.23177 .15451 L
.23277 .15451 L
.23377 .1545 L
.23477 .1545 L
.23576 .1545 L
.23676 .1545 L
.23776 .1545 L
.23876 .1545 L
.23976 .1545 L
.24076 .1545 L
.24176 .15451 L
.24276 .15451 L
.24376 .15451 L
.24476 .15451 L
.24575 .15451 L
.24675 .15451 L
.24775 .15451 L
.24875 .15451 L
Mistroke
.24975 .1545 L
.25075 .1545 L
.25175 .1545 L
.25275 .15451 L
.25375 .1545 L
.25475 .1545 L
.25574 .1545 L
.25674 .1545 L
.25774 .1545 L
.25874 .1545 L
.25974 .1545 L
.26074 .1545 L
.26174 .1545 L
.26274 .1545 L
.26374 .1545 L
.26474 .1545 L
.26573 .1545 L
.26673 .15451 L
.26773 .15451 L
.26873 .1545 L
.26973 .15451 L
.27073 .1545 L
.27173 .1545 L
.27273 .15451 L
.27373 .15451 L
.27473 .15451 L
.27572 .15451 L
.27672 .15451 L
.27772 .15451 L
.27872 .15451 L
.27972 .1545 L
.28072 .1545 L
.28172 .15451 L
.28272 .15451 L
.28372 .15451 L
.28472 .15451 L
.28571 .15451 L
.28671 .1545 L
.28771 .1545 L
.28871 .1545 L
.28971 .1545 L
.29071 .1545 L
.29171 .1545 L
.29271 .1545 L
.29371 .1545 L
.29471 .1545 L
.2957 .1545 L
.2967 .1545 L
.2977 .1545 L
.2987 .1545 L
Mistroke
.2997 .1545 L
.3007 .1545 L
.3017 .1545 L
.3027 .1545 L
.3037 .1545 L
.3047 .1545 L
.30569 .1545 L
.30669 .1545 L
.30769 .1545 L
.30869 .1545 L
.30969 .1545 L
.31069 .1545 L
.31169 .1545 L
.31269 .1545 L
.31369 .1545 L
.31469 .1545 L
.31568 .1545 L
.31668 .1545 L
.31768 .1545 L
.31868 .1545 L
.31968 .1545 L
.32068 .1545 L
.32168 .1545 L
.32268 .1545 L
.32368 .1545 L
.32468 .1545 L
.32567 .1545 L
.32667 .1545 L
.32767 .1545 L
.32867 .1545 L
.32967 .1545 L
.33067 .1545 L
.33167 .1545 L
.33267 .1545 L
.33367 .1545 L
.33467 .1545 L
.33566 .1545 L
.33666 .1545 L
.33766 .1545 L
.33866 .1545 L
.33966 .1545 L
.34066 .1545 L
.34166 .1545 L
.34266 .1545 L
.34366 .1545 L
.34466 .1545 L
.34565 .1545 L
.34665 .1545 L
.34765 .1545 L
.34865 .1545 L
Mistroke
.34965 .1545 L
.35065 .1545 L
.35165 .1545 L
.35265 .1545 L
.35365 .1545 L
.35465 .1545 L
.35564 .1545 L
.35664 .1545 L
.35764 .1545 L
.35864 .1545 L
.35964 .1545 L
.36064 .1545 L
.36164 .1545 L
.36264 .1545 L
.36364 .1545 L
.36464 .1545 L
.36563 .1545 L
.36663 .1545 L
.36763 .1545 L
.36863 .1545 L
.36963 .1545 L
.37063 .1545 L
.37163 .1545 L
.37263 .1545 L
.37363 .1545 L
.37463 .1545 L
.37562 .1545 L
.37662 .1545 L
.37762 .1545 L
.37862 .1545 L
.37962 .1545 L
.38062 .1545 L
.38162 .1545 L
.38262 .1545 L
.38362 .1545 L
.38462 .1545 L
.38561 .1545 L
.38661 .1545 L
.38761 .1545 L
.38861 .1545 L
.38961 .1545 L
.39061 .1545 L
.39161 .1545 L
.39261 .1545 L
.39361 .1545 L
.39461 .1545 L
.3956 .1545 L
.3966 .1545 L
.3976 .1545 L
.3986 .1545 L
Mistroke
.3996 .1545 L
.4006 .1545 L
.4016 .1545 L
.4026 .1545 L
.4036 .1545 L
.4046 .1545 L
.40559 .1545 L
.40659 .1545 L
.40759 .1545 L
.40859 .1545 L
.40959 .1545 L
.41059 .1545 L
.41159 .1545 L
.41259 .1545 L
.41359 .1545 L
.41459 .1545 L
.41558 .1545 L
.41658 .1545 L
.41758 .1545 L
.41858 .1545 L
.41958 .1545 L
.42058 .1545 L
.42158 .1545 L
.42258 .1545 L
.42358 .1545 L
.42458 .1545 L
.42557 .1545 L
.42657 .1545 L
.42757 .1545 L
.42857 .1545 L
.42957 .1545 L
.43057 .1545 L
.43157 .1545 L
.43257 .1545 L
.43357 .1545 L
.43457 .1545 L
.43556 .1545 L
.43656 .1545 L
.43756 .1545 L
.43856 .1545 L
.43956 .1545 L
.44056 .1545 L
.44156 .1545 L
.44256 .1545 L
.44356 .1545 L
.44456 .1545 L
.44555 .1545 L
.44655 .1545 L
.44755 .1545 L
.44855 .1545 L
Mistroke
.44955 .1545 L
.45055 .1545 L
.45155 .1545 L
.45255 .1545 L
.45355 .1545 L
.45455 .1545 L
.45554 .1545 L
.45654 .1545 L
.45754 .1545 L
.45854 .1545 L
.45954 .1545 L
.46054 .1545 L
.46154 .1545 L
.46254 .1545 L
.46354 .1545 L
.46454 .1545 L
.46553 .1545 L
.46653 .1545 L
.46753 .1545 L
.46853 .1545 L
.46953 .1545 L
.47053 .1545 L
.47153 .1545 L
.47253 .1545 L
.47353 .1545 L
.47453 .1545 L
.47552 .1545 L
.47652 .1545 L
.47752 .1545 L
.47852 .1545 L
.47952 .1545 L
.48052 .1545 L
.48152 .1545 L
.48252 .1545 L
.48352 .1545 L
.48452 .1545 L
.48551 .1545 L
.48651 .1545 L
.48751 .1545 L
.48851 .1545 L
.48951 .1545 L
.49051 .1545 L
.49151 .1545 L
.49251 .1545 L
.49351 .1545 L
.49451 .1545 L
.4955 .1545 L
.4965 .1545 L
.4975 .1545 L
.4985 .1545 L
Mistroke
.4995 .1545 L
.5005 .1545 L
.5015 .1545 L
.5025 .1545 L
.5035 .1545 L
.5045 .1545 L
.50549 .1545 L
.50649 .1545 L
.50749 .1545 L
.50849 .1545 L
.50949 .1545 L
.51049 .1545 L
.51149 .1545 L
.51249 .1545 L
.51349 .1545 L
.51449 .1545 L
.51548 .1545 L
.51648 .1545 L
.51748 .1545 L
.51848 .1545 L
.51948 .1545 L
.52048 .1545 L
.52148 .1545 L
.52248 .1545 L
.52348 .1545 L
.52448 .1545 L
.52547 .1545 L
.52647 .1545 L
.52747 .1545 L
.52847 .1545 L
.52947 .1545 L
.53047 .1545 L
.53147 .1545 L
.53247 .1545 L
.53347 .1545 L
.53447 .1545 L
.53546 .1545 L
.53646 .1545 L
.53746 .1545 L
.53846 .1545 L
.53946 .1545 L
.54046 .1545 L
.54146 .1545 L
.54246 .1545 L
.54346 .1545 L
.54446 .15451 L
.54545 .15451 L
.54645 .15451 L
.54745 .15451 L
.54845 .15451 L
Mistroke
.54945 .15451 L
.55045 .15451 L
.55145 .15451 L
.55245 .15451 L
.55345 .15451 L
.55445 .15451 L
.55544 .15451 L
.55644 .1545 L
.55744 .1545 L
.55844 .1545 L
.55944 .1545 L
.56044 .1545 L
.56144 .1545 L
.56244 .1545 L
.56344 .1545 L
.56444 .1545 L
.56543 .1545 L
.56643 .1545 L
.56743 .1545 L
.56843 .1545 L
.56943 .1545 L
.57043 .1545 L
.57143 .1545 L
.57243 .1545 L
.57343 .1545 L
.57443 .1545 L
.57542 .1545 L
.57642 .1545 L
.57742 .1545 L
.57842 .1545 L
.57942 .1545 L
.58042 .1545 L
.58142 .1545 L
.58242 .1545 L
.58342 .1545 L
.58442 .1545 L
.58541 .1545 L
.58641 .1545 L
.58741 .1545 L
.58841 .1545 L
.58941 .1545 L
.59041 .1545 L
.59141 .1545 L
.59241 .1545 L
.59341 .1545 L
.59441 .1545 L
.5954 .1545 L
.5964 .1545 L
.5974 .1545 L
.5984 .1545 L
Mistroke
.5994 .1545 L
.6004 .1545 L
.6014 .1545 L
.6024 .1545 L
.6034 .1545 L
.6044 .1545 L
.60539 .1545 L
.60639 .15451 L
.60739 .15451 L
.60839 .15451 L
.60939 .15451 L
.61039 .1545 L
.61139 .1545 L
.61239 .15451 L
.61339 .15451 L
.61439 .15451 L
.61538 .15451 L
.61638 .15451 L
.61738 .15451 L
.61838 .15451 L
.61938 .15451 L
.62038 .15451 L
.62138 .15451 L
.62238 .15451 L
.62338 .15451 L
.62438 .15451 L
.62537 .15451 L
.62637 .15451 L
.62737 .15451 L
.62837 .15451 L
.62937 .1545 L
.63037 .15451 L
.63137 .15451 L
.63237 .15451 L
.63337 .15451 L
.63437 .15451 L
.63536 .15451 L
.63636 .15451 L
.63736 .15451 L
.63836 .15451 L
.63936 .1545 L
.64036 .1545 L
.64136 .1545 L
.64236 .1545 L
.64336 .15451 L
.64436 .15451 L
.64535 .1545 L
.64635 .1545 L
.64735 .15451 L
.64835 .15451 L
Mistroke
.64935 .15451 L
.65035 .15451 L
.65135 .15451 L
.65235 .15451 L
.65335 .15451 L
.65435 .15451 L
.65534 .15451 L
.65634 .1545 L
.65734 .1545 L
.65834 .1545 L
.65934 .1545 L
.66034 .1545 L
.66134 .1545 L
.66234 .1545 L
.66334 .1545 L
.66434 .1545 L
.66533 .1545 L
.66633 .1545 L
.66733 .1545 L
.66833 .1545 L
.66933 .1545 L
.67033 .15451 L
.67133 .15451 L
.67233 .15451 L
.67333 .15451 L
.67433 .15451 L
.67532 .15451 L
.67632 .15451 L
.67732 .15451 L
.67832 .15451 L
.67932 .15451 L
.68032 .15451 L
.68132 .1545 L
.68232 .1545 L
.68332 .15451 L
.68432 .15451 L
.68531 .15451 L
.68631 .15451 L
.68731 .15451 L
.68831 .15451 L
.68931 .1545 L
.69031 .1545 L
.69131 .1545 L
.69231 .1545 L
.69331 .1545 L
.69431 .1545 L
.6953 .1545 L
.6963 .1545 L
.6973 .1545 L
.6983 .1545 L
Mistroke
.6993 .1545 L
.7003 .1545 L
.7013 .1545 L
.7023 .1545 L
.7033 .1545 L
.7043 .1545 L
.70529 .1545 L
.70629 .1545 L
.70729 .1545 L
.70829 .1545 L
.70929 .1545 L
.71029 .1545 L
.71129 .1545 L
.71229 .1545 L
.71329 .1545 L
.71429 .1545 L
.71528 .1545 L
.71628 .1545 L
.71728 .1545 L
.71828 .1545 L
.71928 .1545 L
.72028 .1545 L
.72128 .1545 L
.72228 .1545 L
.72328 .1545 L
.72428 .1545 L
.72527 .1545 L
.72627 .1545 L
.72727 .1545 L
.72827 .1545 L
.72927 .1545 L
.73027 .1545 L
.73127 .1545 L
.73227 .1545 L
.73327 .1545 L
.73427 .1545 L
.73526 .1545 L
.73626 .1545 L
.73726 .1545 L
.73826 .1545 L
.73926 .1545 L
.74026 .1545 L
.74126 .1545 L
.74226 .1545 L
.74326 .1545 L
.74426 .1545 L
.74525 .1545 L
.74625 .1545 L
.74725 .1545 L
.74825 .1545 L
Mistroke
.74925 .1545 L
.75025 .1545 L
.75125 .1545 L
.75225 .1545 L
.75325 .1545 L
.75425 .1545 L
.75524 .1545 L
.75624 .1545 L
.75724 .1545 L
.75824 .1545 L
.75924 .1545 L
.76024 .1545 L
.76124 .1545 L
.76224 .1545 L
.76324 .1545 L
.76424 .1545 L
.76523 .15451 L
.76623 .15451 L
.76723 .15451 L
.76823 .1545 L
.76923 .1545 L
.77023 .1545 L
.77123 .1545 L
.77223 .1545 L
.77323 .1545 L
.77423 .1545 L
.77522 .1545 L
.77622 .1545 L
.77722 .1545 L
.77822 .1545 L
.77922 .1545 L
.78022 .1545 L
.78122 .1545 L
.78222 .1545 L
.78322 .1545 L
.78422 .1545 L
.78521 .1545 L
.78621 .1545 L
.78721 .1545 L
.78821 .1545 L
.78921 .1545 L
.79021 .1545 L
.79121 .1545 L
.79221 .1545 L
.79321 .1545 L
.79421 .1545 L
.7952 .1545 L
.7962 .1545 L
.7972 .1545 L
.7982 .1545 L
Mistroke
.7992 .1545 L
.8002 .1545 L
.8012 .1545 L
.8022 .1545 L
.8032 .1545 L
.8042 .1545 L
.80519 .1545 L
.80619 .1545 L
.80719 .1545 L
.80819 .1545 L
.80919 .1545 L
.81019 .1545 L
.81119 .1545 L
.81219 .1545 L
.81319 .1545 L
.81419 .1545 L
.81518 .1545 L
.81618 .1545 L
.81718 .1545 L
.81818 .1545 L
.81918 .1545 L
.82018 .1545 L
.82118 .1545 L
.82218 .1545 L
.82318 .1545 L
.82418 .1545 L
.82517 .1545 L
.82617 .1545 L
.82717 .1545 L
.82817 .1545 L
.82917 .1545 L
.83017 .1545 L
.83117 .1545 L
.83217 .1545 L
.83317 .1545 L
.83417 .1545 L
.83516 .1545 L
.83616 .1545 L
.83716 .1545 L
.83816 .1545 L
.83916 .1545 L
.84016 .1545 L
.84116 .1545 L
.84216 .1545 L
.84316 .1545 L
.84416 .1545 L
.84515 .1545 L
.84615 .1545 L
.84715 .1545 L
.84815 .1545 L
Mistroke
.84915 .1545 L
.85015 .1545 L
.85115 .1545 L
.85215 .1545 L
.85315 .1545 L
.85415 .1545 L
.85514 .1545 L
.85614 .1545 L
.85714 .1545 L
.85814 .1545 L
.85914 .1545 L
.86014 .1545 L
.86114 .1545 L
.86214 .1545 L
.86314 .1545 L
.86414 .1545 L
.86513 .1545 L
.86613 .1545 L
.86713 .1545 L
.86813 .1545 L
.86913 .1545 L
.87013 .1545 L
.87113 .1545 L
.87213 .1545 L
.87313 .1545 L
.87413 .1545 L
.87512 .1545 L
.87612 .1545 L
.87712 .1545 L
.87812 .1545 L
.87912 .1545 L
.88012 .1545 L
.88112 .1545 L
.88212 .1545 L
.88312 .1545 L
.88412 .1545 L
.88511 .1545 L
.88611 .1545 L
.88711 .1545 L
.88811 .1545 L
.88911 .1545 L
.89011 .1545 L
.89111 .1545 L
.89211 .1545 L
.89311 .1545 L
.89411 .1545 L
.8951 .1545 L
.8961 .1545 L
.8971 .1545 L
.8981 .1545 L
Mistroke
.8991 .1545 L
.9001 .1545 L
.9011 .1545 L
.9021 .1545 L
.9031 .1545 L
.9041 .1545 L
.90509 .1545 L
.90609 .1545 L
.90709 .1545 L
.90809 .1545 L
.90909 .1545 L
.91009 .1545 L
.91109 .1545 L
.91209 .1545 L
.91309 .1545 L
.91409 .1545 L
.91508 .1545 L
.91608 .1545 L
.91708 .1545 L
.91808 .1545 L
.91908 .1545 L
.92008 .1545 L
.92108 .1545 L
.92208 .1545 L
.92308 .1545 L
.92408 .1545 L
.92507 .1545 L
.92607 .1545 L
.92707 .1545 L
.92807 .1545 L
.92907 .1545 L
.93007 .1545 L
.93107 .1545 L
.93207 .1545 L
.93307 .1545 L
.93407 .1545 L
.93506 .1545 L
.93606 .1545 L
.93706 .1545 L
.93806 .1545 L
.93906 .1545 L
.94006 .1545 L
.94106 .1545 L
.94206 .1545 L
.94306 .1545 L
.94406 .1545 L
.94505 .1545 L
.94605 .1545 L
.94705 .1545 L
.94805 .1545 L
Mistroke
.94905 .1545 L
.95005 .1545 L
.95105 .1545 L
.95205 .1545 L
.95305 .1545 L
.95405 .1545 L
.95504 .1545 L
.95604 .1545 L
.95704 .1545 L
.95804 .1545 L
.95904 .1545 L
.96004 .1545 L
.96104 .1545 L
.96204 .1545 L
.96304 .1545 L
.96404 .1545 L
.96503 .1545 L
.96603 .1545 L
.96703 .1545 L
.96803 .1545 L
.96903 .1545 L
.97003 .1545 L
.97103 .1545 L
.97203 .1545 L
.97303 .1545 L
.97403 .1545 L
.97502 .1545 L
.97602 .1545 L
.97702 .1545 L
.97802 .1545 L
.97902 .1545 L
.98002 .1545 L
.98102 .1545 L
.98202 .1545 L
.98302 .1545 L
.98402 .1545 L
.98501 .1545 L
.98601 .1545 L
.98701 .1545 L
.98801 .1545 L
.98901 .1545 L
.99001 .1545 L
.99101 .1545 L
.99201 .1545 L
.99301 .1545 L
.99401 .1545 L
.995 .1545 L
.996 .1545 L
.997 .1545 L
.998 .1545 L
Mistroke
.999 .1545 L
Mfstroke
0 .98 .604 r
gsave
.999 .40474 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .12484 m
.001 .12484 L
.002 .12484 L
.003 .12484 L
.004 .12484 L
.005 .12484 L
.00599 .12484 L
.00699 .12484 L
.00799 .12484 L
.00899 .12484 L
.00999 .12484 L
.01099 .12484 L
.01199 .12484 L
.01299 .12484 L
.01399 .12484 L
.01499 .12484 L
.01598 .12484 L
.01698 .12484 L
.01798 .12484 L
.01898 .12484 L
.01998 .12484 L
.02098 .12484 L
.02198 .12484 L
.02298 .12484 L
.02398 .12484 L
.02498 .12484 L
.02597 .12484 L
.02697 .12484 L
.02797 .12484 L
.02897 .12484 L
.02997 .12484 L
.03097 .12484 L
.03197 .12484 L
.03297 .12484 L
.03397 .12484 L
.03497 .12484 L
.03596 .12484 L
.03696 .12484 L
.03796 .12484 L
.03896 .12484 L
.03996 .12484 L
.04096 .12484 L
.04196 .12484 L
.04296 .12484 L
.04396 .12484 L
.04496 .12484 L
.04595 .12484 L
.04695 .12484 L
.04795 .12484 L
.04895 .12484 L
Mistroke
.04995 .35577 L
.05095 .35577 L
.05195 .35577 L
.05295 .35577 L
.05395 .35577 L
.05495 .35577 L
.05594 .35577 L
.05694 .35577 L
.05794 .35577 L
.05894 .35577 L
.05994 .35577 L
.06094 .35577 L
.06194 .35577 L
.06294 .35577 L
.06394 .35577 L
.06494 .35577 L
.06593 .35577 L
.06693 .35577 L
.06793 .35577 L
.06893 .35577 L
.06993 .35577 L
.07093 .35577 L
.07193 .35577 L
.07293 .35577 L
.07393 .35577 L
.07493 .35577 L
.07592 .35577 L
.07692 .35577 L
.07792 .35577 L
.07892 .35577 L
.07992 .35577 L
.08092 .35577 L
.08192 .35577 L
.08292 .35577 L
.08392 .35577 L
.08492 .35577 L
.08591 .35577 L
.08691 .35577 L
.08791 .35577 L
.08891 .35577 L
.08991 .35577 L
.09091 .35577 L
.09191 .35577 L
.09291 .35577 L
.09391 .35577 L
.09491 .35577 L
.0959 .35577 L
.0969 .35577 L
.0979 .35577 L
.0989 .35577 L
Mistroke
.0999 .41433 L
.1009 .41433 L
.1019 .41433 L
.1029 .41433 L
.1039 .41433 L
.1049 .41433 L
.10589 .41433 L
.10689 .41433 L
.10789 .41433 L
.10889 .41433 L
.10989 .41433 L
.11089 .41433 L
.11189 .41433 L
.11289 .41433 L
.11389 .41433 L
.11489 .41433 L
.11588 .41433 L
.11688 .41433 L
.11788 .41433 L
.11888 .41433 L
.11988 .41433 L
.12088 .41433 L
.12188 .41433 L
.12288 .41433 L
.12388 .41433 L
.12488 .41433 L
.12587 .41433 L
.12687 .41433 L
.12787 .41433 L
.12887 .41433 L
.12987 .41433 L
.13087 .41433 L
.13187 .41433 L
.13287 .41433 L
.13387 .41433 L
.13487 .41433 L
.13586 .41433 L
.13686 .41433 L
.13786 .41433 L
.13886 .41433 L
.13986 .41433 L
.14086 .41433 L
.14186 .41433 L
.14286 .41433 L
.14386 .41433 L
.14486 .41433 L
.14585 .41433 L
.14685 .41433 L
.14785 .41433 L
.14885 .41433 L
Mistroke
.14985 .41656 L
.15085 .41656 L
.15185 .41656 L
.15285 .41656 L
.15385 .41656 L
.15485 .41656 L
.15584 .41656 L
.15684 .41656 L
.15784 .41656 L
.15884 .41656 L
.15984 .41656 L
.16084 .41656 L
.16184 .41656 L
.16284 .41656 L
.16384 .41656 L
.16484 .41656 L
.16583 .41656 L
.16683 .41656 L
.16783 .41656 L
.16883 .41656 L
.16983 .41656 L
.17083 .41656 L
.17183 .41656 L
.17283 .41656 L
.17383 .41656 L
.17483 .41656 L
.17582 .41656 L
.17682 .41656 L
.17782 .41656 L
.17882 .41656 L
.17982 .41656 L
.18082 .41656 L
.18182 .41656 L
.18282 .41656 L
.18382 .41656 L
.18482 .41656 L
.18581 .41656 L
.18681 .41656 L
.18781 .41656 L
.18881 .41656 L
.18981 .41656 L
.19081 .41656 L
.19181 .41656 L
.19281 .41656 L
.19381 .41656 L
.19481 .41656 L
.1958 .41656 L
.1968 .41656 L
.1978 .41656 L
.1988 .41656 L
Mistroke
.1998 .42133 L
.2008 .42133 L
.2018 .42133 L
.2028 .42133 L
.2038 .42133 L
.2048 .42133 L
.20579 .42133 L
.20679 .42133 L
.20779 .42133 L
.20879 .42133 L
.20979 .42133 L
.21079 .42133 L
.21179 .42133 L
.21279 .42133 L
.21379 .42133 L
.21479 .42133 L
.21578 .42133 L
.21678 .42133 L
.21778 .42133 L
.21878 .42133 L
.21978 .42133 L
.22078 .42133 L
.22178 .42133 L
.22278 .42133 L
.22378 .42133 L
.22478 .42133 L
.22577 .42133 L
.22677 .42133 L
.22777 .42133 L
.22877 .42133 L
.22977 .42133 L
.23077 .42133 L
.23177 .42133 L
.23277 .42133 L
.23377 .42133 L
.23477 .42133 L
.23576 .42133 L
.23676 .42133 L
.23776 .42133 L
.23876 .42133 L
.23976 .42133 L
.24076 .42133 L
.24176 .42133 L
.24276 .42133 L
.24376 .42133 L
.24476 .42133 L
.24575 .42133 L
.24675 .42133 L
.24775 .42133 L
.24875 .42133 L
Mistroke
.24975 .41488 L
.25075 .41488 L
.25175 .41488 L
.25275 .41488 L
.25375 .41488 L
.25475 .41488 L
.25574 .41488 L
.25674 .41488 L
.25774 .41488 L
.25874 .41488 L
.25974 .41488 L
.26074 .41488 L
.26174 .41488 L
.26274 .41488 L
.26374 .41488 L
.26474 .41488 L
.26573 .41488 L
.26673 .41488 L
.26773 .41488 L
.26873 .41488 L
.26973 .41488 L
.27073 .41488 L
.27173 .41488 L
.27273 .41488 L
.27373 .41488 L
.27473 .41488 L
.27572 .41488 L
.27672 .41488 L
.27772 .41488 L
.27872 .41488 L
.27972 .41488 L
.28072 .41488 L
.28172 .41488 L
.28272 .41488 L
.28372 .41488 L
.28472 .41488 L
.28571 .41488 L
.28671 .41488 L
.28771 .41488 L
.28871 .41488 L
.28971 .41488 L
.29071 .41488 L
.29171 .41488 L
.29271 .41488 L
.29371 .41488 L
.29471 .41488 L
.2957 .41488 L
.2967 .41488 L
.2977 .41488 L
.2987 .41488 L
Mistroke
.2997 .41592 L
.3007 .41592 L
.3017 .41592 L
.3027 .41592 L
.3037 .41592 L
.3047 .41592 L
.30569 .41592 L
.30669 .41592 L
.30769 .41592 L
.30869 .41592 L
.30969 .41592 L
.31069 .41592 L
.31169 .41592 L
.31269 .41592 L
.31369 .41592 L
.31469 .41592 L
.31568 .41592 L
.31668 .41592 L
.31768 .41592 L
.31868 .41592 L
.31968 .41592 L
.32068 .41592 L
.32168 .41592 L
.32268 .41592 L
.32368 .41592 L
.32468 .41592 L
.32567 .41592 L
.32667 .41592 L
.32767 .41592 L
.32867 .41592 L
.32967 .41592 L
.33067 .41592 L
.33167 .41592 L
.33267 .41592 L
.33367 .41592 L
.33467 .41592 L
.33566 .41592 L
.33666 .41592 L
.33766 .41592 L
.33866 .41592 L
.33966 .41592 L
.34066 .41592 L
.34166 .41592 L
.34266 .41592 L
.34366 .41592 L
.34466 .41592 L
.34565 .41592 L
.34665 .41592 L
.34765 .41592 L
.34865 .41592 L
Mistroke
.34965 .41884 L
.35065 .41884 L
.35165 .41884 L
.35265 .41884 L
.35365 .41884 L
.35465 .41884 L
.35564 .41884 L
.35664 .41884 L
.35764 .41884 L
.35864 .41884 L
.35964 .41884 L
.36064 .41884 L
.36164 .41884 L
.36264 .41884 L
.36364 .41884 L
.36464 .41884 L
.36563 .41884 L
.36663 .41884 L
.36763 .41884 L
.36863 .41884 L
.36963 .41884 L
.37063 .41884 L
.37163 .41884 L
.37263 .41884 L
.37363 .41884 L
.37463 .41884 L
.37562 .41884 L
.37662 .41884 L
.37762 .41884 L
.37862 .41884 L
.37962 .41884 L
.38062 .41884 L
.38162 .41884 L
.38262 .41884 L
.38362 .41884 L
.38462 .41884 L
.38561 .41884 L
.38661 .41884 L
.38761 .41884 L
.38861 .41884 L
.38961 .41884 L
.39061 .41884 L
.39161 .41884 L
.39261 .41884 L
.39361 .41884 L
.39461 .41884 L
.3956 .41884 L
.3966 .41884 L
.3976 .41884 L
.3986 .41884 L
Mistroke
.3996 .41882 L
.4006 .41882 L
.4016 .41882 L
.4026 .41882 L
.4036 .41882 L
.4046 .41882 L
.40559 .41882 L
.40659 .41882 L
.40759 .41882 L
.40859 .41882 L
.40959 .41882 L
.41059 .41882 L
.41159 .41882 L
.41259 .41882 L
.41359 .41882 L
.41459 .41882 L
.41558 .41882 L
.41658 .41882 L
.41758 .41882 L
.41858 .41882 L
.41958 .41882 L
.42058 .41882 L
.42158 .41882 L
.42258 .41882 L
.42358 .41882 L
.42458 .41882 L
.42557 .41882 L
.42657 .41882 L
.42757 .41882 L
.42857 .41882 L
.42957 .41882 L
.43057 .41882 L
.43157 .41882 L
.43257 .41882 L
.43357 .41882 L
.43457 .41882 L
.43556 .41882 L
.43656 .41882 L
.43756 .41882 L
.43856 .41882 L
.43956 .41882 L
.44056 .41882 L
.44156 .41882 L
.44256 .41882 L
.44356 .41882 L
.44456 .41882 L
.44555 .41882 L
.44655 .41882 L
.44755 .41882 L
.44855 .41882 L
Mistroke
.44955 .40666 L
.45055 .40666 L
.45155 .40666 L
.45255 .40666 L
.45355 .40666 L
.45455 .40666 L
.45554 .40666 L
.45654 .40666 L
.45754 .40666 L
.45854 .40666 L
.45954 .40666 L
.46054 .40666 L
.46154 .40666 L
.46254 .40666 L
.46354 .40666 L
.46454 .40666 L
.46553 .40666 L
.46653 .40666 L
.46753 .40666 L
.46853 .40666 L
.46953 .40666 L
.47053 .40666 L
.47153 .40666 L
.47253 .40666 L
.47353 .40666 L
.47453 .40666 L
.47552 .40666 L
.47652 .40666 L
.47752 .40666 L
.47852 .40666 L
.47952 .40666 L
.48052 .40666 L
.48152 .40666 L
.48252 .40666 L
.48352 .40666 L
.48452 .40666 L
.48551 .40666 L
.48651 .40666 L
.48751 .40666 L
.48851 .40666 L
.48951 .40666 L
.49051 .40666 L
.49151 .40666 L
.49251 .40666 L
.49351 .40666 L
.49451 .40666 L
.4955 .40666 L
.4965 .40666 L
.4975 .40666 L
.4985 .40666 L
Mistroke
.4995 .40906 L
.5005 .40906 L
.5015 .40906 L
.5025 .40906 L
.5035 .40906 L
.5045 .40906 L
.50549 .40906 L
.50649 .40906 L
.50749 .40906 L
.50849 .40906 L
.50949 .40906 L
.51049 .40906 L
.51149 .40906 L
.51249 .40906 L
.51349 .40906 L
.51449 .40906 L
.51548 .40906 L
.51648 .40906 L
.51748 .40906 L
.51848 .40906 L
.51948 .40906 L
.52048 .40906 L
.52148 .40906 L
.52248 .40906 L
.52348 .40906 L
.52448 .40906 L
.52547 .40906 L
.52647 .40906 L
.52747 .40906 L
.52847 .40906 L
.52947 .40906 L
.53047 .40906 L
.53147 .40906 L
.53247 .40906 L
.53347 .40906 L
.53447 .40906 L
.53546 .40906 L
.53646 .40906 L
.53746 .40906 L
.53846 .40906 L
.53946 .40906 L
.54046 .40906 L
.54146 .40906 L
.54246 .40906 L
.54346 .40906 L
.54446 .40906 L
.54545 .40906 L
.54645 .40906 L
.54745 .40906 L
.54845 .40906 L
Mistroke
.54945 .41249 L
.55045 .41249 L
.55145 .41249 L
.55245 .41249 L
.55345 .41249 L
.55445 .41249 L
.55544 .41249 L
.55644 .41249 L
.55744 .41249 L
.55844 .41249 L
.55944 .41249 L
.56044 .41249 L
.56144 .41249 L
.56244 .41249 L
.56344 .41249 L
.56444 .41249 L
.56543 .41249 L
.56643 .41249 L
.56743 .41249 L
.56843 .41249 L
.56943 .41249 L
.57043 .41249 L
.57143 .41249 L
.57243 .41249 L
.57343 .41249 L
.57443 .41249 L
.57542 .41249 L
.57642 .41249 L
.57742 .41249 L
.57842 .41249 L
.57942 .41249 L
.58042 .41249 L
.58142 .41249 L
.58242 .41249 L
.58342 .41249 L
.58442 .41249 L
.58541 .41249 L
.58641 .41249 L
.58741 .41249 L
.58841 .41249 L
.58941 .41249 L
.59041 .41249 L
.59141 .41249 L
.59241 .41249 L
.59341 .41249 L
.59441 .41249 L
.5954 .41249 L
.5964 .41249 L
.5974 .41249 L
.5984 .41249 L
Mistroke
.5994 .40567 L
.6004 .40567 L
.6014 .40567 L
.6024 .40567 L
.6034 .40567 L
.6044 .40567 L
.60539 .40567 L
.60639 .40567 L
.60739 .40567 L
.60839 .40567 L
.60939 .40567 L
.61039 .40567 L
.61139 .40567 L
.61239 .40567 L
.61339 .40567 L
.61439 .40567 L
.61538 .40567 L
.61638 .40567 L
.61738 .40567 L
.61838 .40567 L
.61938 .40567 L
.62038 .40567 L
.62138 .40567 L
.62238 .40567 L
.62338 .40567 L
.62438 .40567 L
.62537 .40567 L
.62637 .40567 L
.62737 .40567 L
.62837 .40567 L
.62937 .40567 L
.63037 .40567 L
.63137 .40567 L
.63237 .40567 L
.63337 .40567 L
.63437 .40567 L
.63536 .40567 L
.63636 .40567 L
.63736 .40567 L
.63836 .40567 L
.63936 .40567 L
.64036 .40567 L
.64136 .40567 L
.64236 .40567 L
.64336 .40567 L
.64436 .40567 L
.64535 .40567 L
.64635 .40567 L
.64735 .40567 L
.64835 .40567 L
Mistroke
.64935 .40575 L
.65035 .40575 L
.65135 .40575 L
.65235 .40575 L
.65335 .40575 L
.65435 .40575 L
.65534 .40575 L
.65634 .40575 L
.65734 .40575 L
.65834 .40575 L
.65934 .40575 L
.66034 .40575 L
.66134 .40575 L
.66234 .40575 L
.66334 .40575 L
.66434 .40575 L
.66533 .40575 L
.66633 .40575 L
.66733 .40575 L
.66833 .40575 L
.66933 .40575 L
.67033 .40575 L
.67133 .40575 L
.67233 .40575 L
.67333 .40575 L
.67433 .40575 L
.67532 .40575 L
.67632 .40575 L
.67732 .40575 L
.67832 .40575 L
.67932 .40575 L
.68032 .40575 L
.68132 .40575 L
.68232 .40575 L
.68332 .40575 L
.68432 .40575 L
.68531 .40575 L
.68631 .40575 L
.68731 .40575 L
.68831 .40575 L
.68931 .40575 L
.69031 .40575 L
.69131 .40575 L
.69231 .40575 L
.69331 .40575 L
.69431 .40575 L
.6953 .40575 L
.6963 .40575 L
.6973 .40575 L
.6983 .40575 L
Mistroke
.6993 .40554 L
.7003 .40554 L
.7013 .40554 L
.7023 .40554 L
.7033 .40554 L
.7043 .40554 L
.70529 .40554 L
.70629 .40554 L
.70729 .40554 L
.70829 .40554 L
.70929 .40554 L
.71029 .40554 L
.71129 .40554 L
.71229 .40554 L
.71329 .40554 L
.71429 .40554 L
.71528 .40554 L
.71628 .40554 L
.71728 .40554 L
.71828 .40554 L
.71928 .40554 L
.72028 .40554 L
.72128 .40554 L
.72228 .40554 L
.72328 .40554 L
.72428 .40554 L
.72527 .40554 L
.72627 .40554 L
.72727 .40554 L
.72827 .40554 L
.72927 .40554 L
.73027 .40554 L
.73127 .40554 L
.73227 .40554 L
.73327 .40554 L
.73427 .40554 L
.73526 .40554 L
.73626 .40554 L
.73726 .40554 L
.73826 .40554 L
.73926 .40554 L
.74026 .40554 L
.74126 .40554 L
.74226 .40554 L
.74326 .40554 L
.74426 .40554 L
.74525 .40554 L
.74625 .40554 L
.74725 .40554 L
.74825 .40554 L
Mistroke
.74925 .40793 L
.75025 .40793 L
.75125 .40793 L
.75225 .40793 L
.75325 .40793 L
.75425 .40793 L
.75524 .40793 L
.75624 .40793 L
.75724 .40793 L
.75824 .40793 L
.75924 .40793 L
.76024 .40793 L
.76124 .40793 L
.76224 .40793 L
.76324 .40793 L
.76424 .40793 L
.76523 .40793 L
.76623 .40793 L
.76723 .40793 L
.76823 .40793 L
.76923 .40793 L
.77023 .40793 L
.77123 .40793 L
.77223 .40793 L
.77323 .40793 L
.77423 .40793 L
.77522 .40793 L
.77622 .40793 L
.77722 .40793 L
.77822 .40793 L
.77922 .40793 L
.78022 .40793 L
.78122 .40793 L
.78222 .40793 L
.78322 .40793 L
.78422 .40793 L
.78521 .40793 L
.78621 .40793 L
.78721 .40793 L
.78821 .40793 L
.78921 .40793 L
.79021 .40793 L
.79121 .40793 L
.79221 .40793 L
.79321 .40793 L
.79421 .40793 L
.7952 .40793 L
.7962 .40793 L
.7972 .40793 L
.7982 .40793 L
Mistroke
.7992 .40724 L
.8002 .40724 L
.8012 .40724 L
.8022 .40724 L
.8032 .40724 L
.8042 .40724 L
.80519 .40724 L
.80619 .40724 L
.80719 .40724 L
.80819 .40724 L
.80919 .40724 L
.81019 .40724 L
.81119 .40724 L
.81219 .40724 L
.81319 .40724 L
.81419 .40724 L
.81518 .40724 L
.81618 .40724 L
.81718 .40724 L
.81818 .40724 L
.81918 .40724 L
.82018 .40724 L
.82118 .40724 L
.82218 .40724 L
.82318 .40724 L
.82418 .40724 L
.82517 .40724 L
.82617 .40724 L
.82717 .40724 L
.82817 .40724 L
.82917 .40724 L
.83017 .40724 L
.83117 .40724 L
.83217 .40724 L
.83317 .40724 L
.83417 .40724 L
.83516 .40724 L
.83616 .40724 L
.83716 .40724 L
.83816 .40724 L
.83916 .40724 L
.84016 .40724 L
.84116 .40724 L
.84216 .40724 L
.84316 .40724 L
.84416 .40724 L
.84515 .40724 L
.84615 .40724 L
.84715 .40724 L
.84815 .40724 L
Mistroke
.84915 .41158 L
.85015 .41158 L
.85115 .41158 L
.85215 .41158 L
.85315 .41158 L
.85415 .41158 L
.85514 .41158 L
.85614 .41158 L
.85714 .41158 L
.85814 .41158 L
.85914 .41158 L
.86014 .41158 L
.86114 .41158 L
.86214 .41158 L
.86314 .41158 L
.86414 .41158 L
.86513 .41158 L
.86613 .41158 L
.86713 .41158 L
.86813 .41158 L
.86913 .41158 L
.87013 .41158 L
.87113 .41158 L
.87213 .41158 L
.87313 .41158 L
.87413 .41158 L
.87512 .41158 L
.87612 .41158 L
.87712 .41158 L
.87812 .41158 L
.87912 .41158 L
.88012 .41158 L
.88112 .41158 L
.88212 .41158 L
.88312 .41158 L
.88412 .41158 L
.88511 .41158 L
.88611 .41158 L
.88711 .41158 L
.88811 .41158 L
.88911 .41158 L
.89011 .41158 L
.89111 .41158 L
.89211 .41158 L
.89311 .41158 L
.89411 .41158 L
.8951 .41158 L
.8961 .41158 L
.8971 .41158 L
.8981 .41158 L
Mistroke
.8991 .41524 L
.9001 .41524 L
.9011 .41524 L
.9021 .41524 L
.9031 .41524 L
.9041 .41524 L
.90509 .41524 L
.90609 .41524 L
.90709 .41524 L
.90809 .41524 L
.90909 .41524 L
.91009 .41524 L
.91109 .41524 L
.91209 .41524 L
.91309 .41524 L
.91409 .41524 L
.91508 .41524 L
.91608 .41524 L
.91708 .41524 L
.91808 .41524 L
.91908 .41524 L
.92008 .41524 L
.92108 .41524 L
.92208 .41524 L
.92308 .41524 L
.92408 .41524 L
.92507 .41524 L
.92607 .41524 L
.92707 .41524 L
.92807 .41524 L
.92907 .41524 L
.93007 .41524 L
.93107 .41524 L
.93207 .41524 L
.93307 .41524 L
.93407 .41524 L
.93506 .41524 L
.93606 .41524 L
.93706 .41524 L
.93806 .41524 L
.93906 .41524 L
.94006 .41524 L
.94106 .41524 L
.94206 .41524 L
.94306 .41524 L
.94406 .41524 L
.94505 .41524 L
.94605 .41524 L
.94705 .41524 L
.94805 .41524 L
Mistroke
.94905 .41136 L
.95005 .41136 L
.95105 .41136 L
.95205 .41136 L
.95305 .41136 L
.95405 .41136 L
.95504 .41136 L
.95604 .41136 L
.95704 .41136 L
.95804 .41136 L
.95904 .41136 L
.96004 .41136 L
.96104 .41136 L
.96204 .41136 L
.96304 .41136 L
.96404 .41136 L
.96503 .41136 L
.96603 .41136 L
.96703 .41136 L
.96803 .41136 L
.96903 .41136 L
.97003 .41136 L
.97103 .41136 L
.97203 .41136 L
.97303 .41136 L
.97403 .41136 L
.97502 .41136 L
.97602 .41136 L
.97702 .41136 L
.97802 .41136 L
.97902 .41136 L
.98002 .41136 L
.98102 .41136 L
.98202 .41136 L
.98302 .41136 L
.98402 .41136 L
.98501 .41136 L
.98601 .41136 L
.98701 .41136 L
.98801 .41136 L
.98901 .41136 L
.99001 .41136 L
.99101 .41136 L
.99201 .41136 L
.99301 .41136 L
.99401 .41136 L
.995 .41136 L
.996 .41136 L
.997 .41136 L
.998 .41136 L
Mistroke
.999 .40474 L
Mfstroke
gsave
.999 .51125 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24598 m
.001 .24598 L
.002 .24598 L
.003 .24598 L
.004 .24598 L
.005 .24598 L
.00599 .24598 L
.00699 .24598 L
.00799 .24598 L
.00899 .24598 L
.00999 .24598 L
.01099 .24598 L
.01199 .24598 L
.01299 .24598 L
.01399 .24598 L
.01499 .24598 L
.01598 .24598 L
.01698 .24598 L
.01798 .24598 L
.01898 .24598 L
.01998 .24598 L
.02098 .24598 L
.02198 .24598 L
.02298 .24598 L
.02398 .24598 L
.02498 .24598 L
.02597 .24598 L
.02697 .24598 L
.02797 .24598 L
.02897 .24598 L
.02997 .24598 L
.03097 .24598 L
.03197 .24598 L
.03297 .24598 L
.03397 .24598 L
.03497 .24598 L
.03596 .24598 L
.03696 .24598 L
.03796 .24598 L
.03896 .24598 L
.03996 .24598 L
.04096 .24598 L
.04196 .24598 L
.04296 .24598 L
.04396 .24598 L
.04496 .24598 L
.04595 .24598 L
.04695 .24598 L
.04795 .24598 L
.04895 .24598 L
Mistroke
.04995 .47165 L
.05095 .47165 L
.05195 .47165 L
.05295 .47165 L
.05395 .47165 L
.05495 .47165 L
.05594 .47165 L
.05694 .47165 L
.05794 .47165 L
.05894 .47165 L
.05994 .47165 L
.06094 .47165 L
.06194 .47165 L
.06294 .47165 L
.06394 .47165 L
.06494 .47165 L
.06593 .47165 L
.06693 .47165 L
.06793 .47165 L
.06893 .47165 L
.06993 .47165 L
.07093 .47165 L
.07193 .47165 L
.07293 .47165 L
.07393 .47165 L
.07493 .47165 L
.07592 .47165 L
.07692 .47165 L
.07792 .47165 L
.07892 .47165 L
.07992 .47165 L
.08092 .47165 L
.08192 .47165 L
.08292 .47165 L
.08392 .47165 L
.08492 .47165 L
.08591 .47165 L
.08691 .47165 L
.08791 .47165 L
.08891 .47165 L
.08991 .47165 L
.09091 .47165 L
.09191 .47165 L
.09291 .47165 L
.09391 .47165 L
.09491 .47165 L
.0959 .47165 L
.0969 .47165 L
.0979 .47165 L
.0989 .47165 L
Mistroke
.0999 .52341 L
.1009 .52341 L
.1019 .52341 L
.1029 .52341 L
.1039 .52341 L
.1049 .52341 L
.10589 .52341 L
.10689 .52341 L
.10789 .52341 L
.10889 .52341 L
.10989 .52341 L
.11089 .52341 L
.11189 .52341 L
.11289 .52341 L
.11389 .52341 L
.11489 .52341 L
.11588 .52341 L
.11688 .52341 L
.11788 .52341 L
.11888 .52341 L
.11988 .52341 L
.12088 .52341 L
.12188 .52341 L
.12288 .52341 L
.12388 .52341 L
.12488 .52341 L
.12587 .52341 L
.12687 .52341 L
.12787 .52341 L
.12887 .52341 L
.12987 .52341 L
.13087 .52341 L
.13187 .52341 L
.13287 .52341 L
.13387 .52341 L
.13487 .52341 L
.13586 .52341 L
.13686 .52341 L
.13786 .52341 L
.13886 .52341 L
.13986 .52341 L
.14086 .52341 L
.14186 .52341 L
.14286 .52341 L
.14386 .52341 L
.14486 .52341 L
.14585 .52341 L
.14685 .52341 L
.14785 .52341 L
.14885 .52341 L
Mistroke
.14985 .52553 L
.15085 .52553 L
.15185 .52553 L
.15285 .52553 L
.15385 .52553 L
.15485 .52553 L
.15584 .52553 L
.15684 .52553 L
.15784 .52553 L
.15884 .52553 L
.15984 .52553 L
.16084 .52553 L
.16184 .52553 L
.16284 .52553 L
.16384 .52553 L
.16484 .52553 L
.16583 .52553 L
.16683 .52553 L
.16783 .52553 L
.16883 .52553 L
.16983 .52553 L
.17083 .52553 L
.17183 .52553 L
.17283 .52553 L
.17383 .52553 L
.17483 .52553 L
.17582 .52553 L
.17682 .52553 L
.17782 .52553 L
.17882 .52553 L
.17982 .52553 L
.18082 .52553 L
.18182 .52553 L
.18282 .52553 L
.18382 .52553 L
.18482 .52553 L
.18581 .52553 L
.18681 .52553 L
.18781 .52553 L
.18881 .52553 L
.18981 .52553 L
.19081 .52553 L
.19181 .52553 L
.19281 .52553 L
.19381 .52553 L
.19481 .52553 L
.1958 .52553 L
.1968 .52553 L
.1978 .52553 L
.1988 .52553 L
Mistroke
.1998 .53027 L
.2008 .53027 L
.2018 .53027 L
.2028 .53027 L
.2038 .53027 L
.2048 .53027 L
.20579 .53027 L
.20679 .53027 L
.20779 .53027 L
.20879 .53027 L
.20979 .53027 L
.21079 .53027 L
.21179 .53027 L
.21279 .53027 L
.21379 .53027 L
.21479 .53027 L
.21578 .53027 L
.21678 .53027 L
.21778 .53027 L
.21878 .53027 L
.21978 .53027 L
.22078 .53027 L
.22178 .53027 L
.22278 .53027 L
.22378 .53027 L
.22478 .53027 L
.22577 .53027 L
.22677 .53027 L
.22777 .53027 L
.22877 .53027 L
.22977 .53027 L
.23077 .53027 L
.23177 .53027 L
.23277 .53027 L
.23377 .53027 L
.23477 .53027 L
.23576 .53027 L
.23676 .53027 L
.23776 .53027 L
.23876 .53027 L
.23976 .53027 L
.24076 .53027 L
.24176 .53027 L
.24276 .53027 L
.24376 .53027 L
.24476 .53027 L
.24575 .53027 L
.24675 .53027 L
.24775 .53027 L
.24875 .53027 L
Mistroke
.24975 .52363 L
.25075 .52363 L
.25175 .52363 L
.25275 .52363 L
.25375 .52363 L
.25475 .52363 L
.25574 .52363 L
.25674 .52363 L
.25774 .52363 L
.25874 .52363 L
.25974 .52363 L
.26074 .52363 L
.26174 .52363 L
.26274 .52363 L
.26374 .52363 L
.26474 .52363 L
.26573 .52363 L
.26673 .52363 L
.26773 .52363 L
.26873 .52363 L
.26973 .52363 L
.27073 .52363 L
.27173 .52363 L
.27273 .52363 L
.27373 .52363 L
.27473 .52363 L
.27572 .52363 L
.27672 .52363 L
.27772 .52363 L
.27872 .52363 L
.27972 .52363 L
.28072 .52363 L
.28172 .52363 L
.28272 .52363 L
.28372 .52363 L
.28472 .52363 L
.28571 .52363 L
.28671 .52363 L
.28771 .52363 L
.28871 .52363 L
.28971 .52363 L
.29071 .52363 L
.29171 .52363 L
.29271 .52363 L
.29371 .52363 L
.29471 .52363 L
.2957 .52363 L
.2967 .52363 L
.2977 .52363 L
.2987 .52363 L
Mistroke
.2997 .52461 L
.3007 .52461 L
.3017 .52461 L
.3027 .52461 L
.3037 .52461 L
.3047 .52461 L
.30569 .52461 L
.30669 .52461 L
.30769 .52461 L
.30869 .52461 L
.30969 .52461 L
.31069 .52461 L
.31169 .52461 L
.31269 .52461 L
.31369 .52461 L
.31469 .52461 L
.31568 .52461 L
.31668 .52461 L
.31768 .52461 L
.31868 .52461 L
.31968 .52461 L
.32068 .52461 L
.32168 .52461 L
.32268 .52461 L
.32368 .52461 L
.32468 .52461 L
.32567 .52461 L
.32667 .52461 L
.32767 .52461 L
.32867 .52461 L
.32967 .52461 L
.33067 .52461 L
.33167 .52461 L
.33267 .52461 L
.33367 .52461 L
.33467 .52461 L
.33566 .52461 L
.33666 .52461 L
.33766 .52461 L
.33866 .52461 L
.33966 .52461 L
.34066 .52461 L
.34166 .52461 L
.34266 .52461 L
.34366 .52461 L
.34466 .52461 L
.34565 .52461 L
.34665 .52461 L
.34765 .52461 L
.34865 .52461 L
Mistroke
.34965 .52747 L
.35065 .52747 L
.35165 .52747 L
.35265 .52747 L
.35365 .52747 L
.35465 .52747 L
.35564 .52747 L
.35664 .52747 L
.35764 .52747 L
.35864 .52747 L
.35964 .52747 L
.36064 .52747 L
.36164 .52747 L
.36264 .52747 L
.36364 .52747 L
.36464 .52747 L
.36563 .52747 L
.36663 .52747 L
.36763 .52747 L
.36863 .52747 L
.36963 .52747 L
.37063 .52747 L
.37163 .52747 L
.37263 .52747 L
.37363 .52747 L
.37463 .52747 L
.37562 .52747 L
.37662 .52747 L
.37762 .52747 L
.37862 .52747 L
.37962 .52747 L
.38062 .52747 L
.38162 .52747 L
.38262 .52747 L
.38362 .52747 L
.38462 .52747 L
.38561 .52747 L
.38661 .52747 L
.38761 .52747 L
.38861 .52747 L
.38961 .52747 L
.39061 .52747 L
.39161 .52747 L
.39261 .52747 L
.39361 .52747 L
.39461 .52747 L
.3956 .52747 L
.3966 .52747 L
.3976 .52747 L
.3986 .52747 L
Mistroke
.3996 .52742 L
.4006 .52742 L
.4016 .52742 L
.4026 .52742 L
.4036 .52742 L
.4046 .52742 L
.40559 .52742 L
.40659 .52742 L
.40759 .52742 L
.40859 .52742 L
.40959 .52742 L
.41059 .52742 L
.41159 .52742 L
.41259 .52742 L
.41359 .52742 L
.41459 .52742 L
.41558 .52742 L
.41658 .52742 L
.41758 .52742 L
.41858 .52742 L
.41958 .52742 L
.42058 .52742 L
.42158 .52742 L
.42258 .52742 L
.42358 .52742 L
.42458 .52742 L
.42557 .52742 L
.42657 .52742 L
.42757 .52742 L
.42857 .52742 L
.42957 .52742 L
.43057 .52742 L
.43157 .52742 L
.43257 .52742 L
.43357 .52742 L
.43457 .52742 L
.43556 .52742 L
.43656 .52742 L
.43756 .52742 L
.43856 .52742 L
.43956 .52742 L
.44056 .52742 L
.44156 .52742 L
.44256 .52742 L
.44356 .52742 L
.44456 .52742 L
.44555 .52742 L
.44655 .52742 L
.44755 .52742 L
.44855 .52742 L
Mistroke
.44955 .51474 L
.45055 .51474 L
.45155 .51474 L
.45255 .51474 L
.45355 .51474 L
.45455 .51474 L
.45554 .51474 L
.45654 .51474 L
.45754 .51474 L
.45854 .51474 L
.45954 .51474 L
.46054 .51474 L
.46154 .51474 L
.46254 .51474 L
.46354 .51474 L
.46454 .51474 L
.46553 .51474 L
.46653 .51474 L
.46753 .51474 L
.46853 .51474 L
.46953 .51474 L
.47053 .51474 L
.47153 .51474 L
.47253 .51474 L
.47353 .51474 L
.47453 .51474 L
.47552 .51474 L
.47652 .51474 L
.47752 .51474 L
.47852 .51474 L
.47952 .51474 L
.48052 .51474 L
.48152 .51474 L
.48252 .51474 L
.48352 .51474 L
.48452 .51474 L
.48551 .51474 L
.48651 .51474 L
.48751 .51474 L
.48851 .51474 L
.48951 .51474 L
.49051 .51474 L
.49151 .51474 L
.49251 .51474 L
.49351 .51474 L
.49451 .51474 L
.4955 .51474 L
.4965 .51474 L
.4975 .51474 L
.4985 .51474 L
Mistroke
.4995 .51713 L
.5005 .51713 L
.5015 .51713 L
.5025 .51713 L
.5035 .51713 L
.5045 .51713 L
.50549 .51713 L
.50649 .51713 L
.50749 .51713 L
.50849 .51713 L
.50949 .51713 L
.51049 .51713 L
.51149 .51713 L
.51249 .51713 L
.51349 .51713 L
.51449 .51713 L
.51548 .51713 L
.51648 .51713 L
.51748 .51713 L
.51848 .51713 L
.51948 .51713 L
.52048 .51713 L
.52148 .51713 L
.52248 .51713 L
.52348 .51713 L
.52448 .51713 L
.52547 .51713 L
.52647 .51713 L
.52747 .51713 L
.52847 .51713 L
.52947 .51713 L
.53047 .51713 L
.53147 .51713 L
.53247 .51713 L
.53347 .51713 L
.53447 .51713 L
.53546 .51713 L
.53646 .51713 L
.53746 .51713 L
.53846 .51713 L
.53946 .51713 L
.54046 .51713 L
.54146 .51713 L
.54246 .51713 L
.54346 .51713 L
.54446 .51713 L
.54545 .51713 L
.54645 .51713 L
.54745 .51713 L
.54845 .51713 L
Mistroke
.54945 .52051 L
.55045 .52051 L
.55145 .52051 L
.55245 .52051 L
.55345 .52051 L
.55445 .52051 L
.55544 .52051 L
.55644 .52051 L
.55744 .52051 L
.55844 .52051 L
.55944 .52051 L
.56044 .52051 L
.56144 .52051 L
.56244 .52051 L
.56344 .52051 L
.56444 .52051 L
.56543 .52051 L
.56643 .52051 L
.56743 .52051 L
.56843 .52051 L
.56943 .52051 L
.57043 .52051 L
.57143 .52051 L
.57243 .52051 L
.57343 .52051 L
.57443 .52051 L
.57542 .52051 L
.57642 .52051 L
.57742 .52051 L
.57842 .52051 L
.57942 .52051 L
.58042 .52051 L
.58142 .52051 L
.58242 .52051 L
.58342 .52051 L
.58442 .52051 L
.58541 .52051 L
.58641 .52051 L
.58741 .52051 L
.58841 .52051 L
.58941 .52051 L
.59041 .52051 L
.59141 .52051 L
.59241 .52051 L
.59341 .52051 L
.59441 .52051 L
.5954 .52051 L
.5964 .52051 L
.5974 .52051 L
.5984 .52051 L
Mistroke
.5994 .51322 L
.6004 .51322 L
.6014 .51322 L
.6024 .51322 L
.6034 .51322 L
.6044 .51322 L
.60539 .51322 L
.60639 .51322 L
.60739 .51322 L
.60839 .51322 L
.60939 .51322 L
.61039 .51322 L
.61139 .51322 L
.61239 .51322 L
.61339 .51322 L
.61439 .51322 L
.61538 .51322 L
.61638 .51322 L
.61738 .51322 L
.61838 .51322 L
.61938 .51322 L
.62038 .51322 L
.62138 .51322 L
.62238 .51322 L
.62338 .51322 L
.62438 .51322 L
.62537 .51322 L
.62637 .51322 L
.62737 .51322 L
.62837 .51322 L
.62937 .51322 L
.63037 .51322 L
.63137 .51322 L
.63237 .51322 L
.63337 .51322 L
.63437 .51322 L
.63536 .51322 L
.63636 .51322 L
.63736 .51322 L
.63836 .51322 L
.63936 .51322 L
.64036 .51322 L
.64136 .51322 L
.64236 .51322 L
.64336 .51322 L
.64436 .51322 L
.64535 .51322 L
.64635 .51322 L
.64735 .51322 L
.64835 .51322 L
Mistroke
.64935 .51327 L
.65035 .51327 L
.65135 .51327 L
.65235 .51327 L
.65335 .51327 L
.65435 .51327 L
.65534 .51327 L
.65634 .51327 L
.65734 .51327 L
.65834 .51327 L
.65934 .51327 L
.66034 .51327 L
.66134 .51327 L
.66234 .51327 L
.66334 .51327 L
.66434 .51327 L
.66533 .51327 L
.66633 .51327 L
.66733 .51327 L
.66833 .51327 L
.66933 .51327 L
.67033 .51327 L
.67133 .51327 L
.67233 .51327 L
.67333 .51327 L
.67433 .51327 L
.67532 .51327 L
.67632 .51327 L
.67732 .51327 L
.67832 .51327 L
.67932 .51327 L
.68032 .51327 L
.68132 .51327 L
.68232 .51327 L
.68332 .51327 L
.68432 .51327 L
.68531 .51327 L
.68631 .51327 L
.68731 .51327 L
.68831 .51327 L
.68931 .51327 L
.69031 .51327 L
.69131 .51327 L
.69231 .51327 L
.69331 .51327 L
.69431 .51327 L
.6953 .51327 L
.6963 .51327 L
.6973 .51327 L
.6983 .51327 L
Mistroke
.6993 .51298 L
.7003 .51298 L
.7013 .51298 L
.7023 .51298 L
.7033 .51298 L
.7043 .51298 L
.70529 .51298 L
.70629 .51298 L
.70729 .51298 L
.70829 .51298 L
.70929 .51298 L
.71029 .51298 L
.71129 .51298 L
.71229 .51298 L
.71329 .51298 L
.71429 .51298 L
.71528 .51298 L
.71628 .51298 L
.71728 .51298 L
.71828 .51298 L
.71928 .51298 L
.72028 .51298 L
.72128 .51298 L
.72228 .51298 L
.72328 .51298 L
.72428 .51298 L
.72527 .51298 L
.72627 .51298 L
.72727 .51298 L
.72827 .51298 L
.72927 .51298 L
.73027 .51298 L
.73127 .51298 L
.73227 .51298 L
.73327 .51298 L
.73427 .51298 L
.73526 .51298 L
.73626 .51298 L
.73726 .51298 L
.73826 .51298 L
.73926 .51298 L
.74026 .51298 L
.74126 .51298 L
.74226 .51298 L
.74326 .51298 L
.74426 .51298 L
.74525 .51298 L
.74625 .51298 L
.74725 .51298 L
.74825 .51298 L
Mistroke
.74925 .51535 L
.75025 .51535 L
.75125 .51535 L
.75225 .51535 L
.75325 .51535 L
.75425 .51535 L
.75524 .51535 L
.75624 .51535 L
.75724 .51535 L
.75824 .51535 L
.75924 .51535 L
.76024 .51535 L
.76124 .51535 L
.76224 .51535 L
.76324 .51535 L
.76424 .51535 L
.76523 .51535 L
.76623 .51535 L
.76723 .51535 L
.76823 .51535 L
.76923 .51535 L
.77023 .51535 L
.77123 .51535 L
.77223 .51535 L
.77323 .51535 L
.77423 .51535 L
.77522 .51535 L
.77622 .51535 L
.77722 .51535 L
.77822 .51535 L
.77922 .51535 L
.78022 .51535 L
.78122 .51535 L
.78222 .51535 L
.78322 .51535 L
.78422 .51535 L
.78521 .51535 L
.78621 .51535 L
.78721 .51535 L
.78821 .51535 L
.78921 .51535 L
.79021 .51535 L
.79121 .51535 L
.79221 .51535 L
.79321 .51535 L
.79421 .51535 L
.7952 .51535 L
.7962 .51535 L
.7972 .51535 L
.7982 .51535 L
Mistroke
.7992 .51453 L
.8002 .51453 L
.8012 .51453 L
.8022 .51453 L
.8032 .51453 L
.8042 .51453 L
.80519 .51453 L
.80619 .51453 L
.80719 .51453 L
.80819 .51453 L
.80919 .51453 L
.81019 .51453 L
.81119 .51453 L
.81219 .51453 L
.81319 .51453 L
.81419 .51453 L
.81518 .51453 L
.81618 .51453 L
.81718 .51453 L
.81818 .51453 L
.81918 .51453 L
.82018 .51453 L
.82118 .51453 L
.82218 .51453 L
.82318 .51453 L
.82418 .51453 L
.82517 .51453 L
.82617 .51453 L
.82717 .51453 L
.82817 .51453 L
.82917 .51453 L
.83017 .51453 L
.83117 .51453 L
.83217 .51453 L
.83317 .51453 L
.83417 .51453 L
.83516 .51453 L
.83616 .51453 L
.83716 .51453 L
.83816 .51453 L
.83916 .51453 L
.84016 .51453 L
.84116 .51453 L
.84216 .51453 L
.84316 .51453 L
.84416 .51453 L
.84515 .51453 L
.84615 .51453 L
.84715 .51453 L
.84815 .51453 L
Mistroke
.84915 .51883 L
.85015 .51883 L
.85115 .51883 L
.85215 .51883 L
.85315 .51883 L
.85415 .51883 L
.85514 .51883 L
.85614 .51883 L
.85714 .51883 L
.85814 .51883 L
.85914 .51883 L
.86014 .51883 L
.86114 .51883 L
.86214 .51883 L
.86314 .51883 L
.86414 .51883 L
.86513 .51883 L
.86613 .51883 L
.86713 .51883 L
.86813 .51883 L
.86913 .51883 L
.87013 .51883 L
.87113 .51883 L
.87213 .51883 L
.87313 .51883 L
.87413 .51883 L
.87512 .51883 L
.87612 .51883 L
.87712 .51883 L
.87812 .51883 L
.87912 .51883 L
.88012 .51883 L
.88112 .51883 L
.88212 .51883 L
.88312 .51883 L
.88412 .51883 L
.88511 .51883 L
.88611 .51883 L
.88711 .51883 L
.88811 .51883 L
.88911 .51883 L
.89011 .51883 L
.89111 .51883 L
.89211 .51883 L
.89311 .51883 L
.89411 .51883 L
.8951 .51883 L
.8961 .51883 L
.8971 .51883 L
.8981 .51883 L
Mistroke
.8991 .52238 L
.9001 .52238 L
.9011 .52238 L
.9021 .52238 L
.9031 .52238 L
.9041 .52238 L
.90509 .52238 L
.90609 .52238 L
.90709 .52238 L
.90809 .52238 L
.90909 .52238 L
.91009 .52238 L
.91109 .52238 L
.91209 .52238 L
.91309 .52238 L
.91409 .52238 L
.91508 .52238 L
.91608 .52238 L
.91708 .52238 L
.91808 .52238 L
.91908 .52238 L
.92008 .52238 L
.92108 .52238 L
.92208 .52238 L
.92308 .52238 L
.92408 .52238 L
.92507 .52238 L
.92607 .52238 L
.92707 .52238 L
.92807 .52238 L
.92907 .52238 L
.93007 .52238 L
.93107 .52238 L
.93207 .52238 L
.93307 .52238 L
.93407 .52238 L
.93506 .52238 L
.93606 .52238 L
.93706 .52238 L
.93806 .52238 L
.93906 .52238 L
.94006 .52238 L
.94106 .52238 L
.94206 .52238 L
.94306 .52238 L
.94406 .52238 L
.94505 .52238 L
.94605 .52238 L
.94705 .52238 L
.94805 .52238 L
Mistroke
.94905 .51821 L
.95005 .51821 L
.95105 .51821 L
.95205 .51821 L
.95305 .51821 L
.95405 .51821 L
.95504 .51821 L
.95604 .51821 L
.95704 .51821 L
.95804 .51821 L
.95904 .51821 L
.96004 .51821 L
.96104 .51821 L
.96204 .51821 L
.96304 .51821 L
.96404 .51821 L
.96503 .51821 L
.96603 .51821 L
.96703 .51821 L
.96803 .51821 L
.96903 .51821 L
.97003 .51821 L
.97103 .51821 L
.97203 .51821 L
.97303 .51821 L
.97403 .51821 L
.97502 .51821 L
.97602 .51821 L
.97702 .51821 L
.97802 .51821 L
.97902 .51821 L
.98002 .51821 L
.98102 .51821 L
.98202 .51821 L
.98302 .51821 L
.98402 .51821 L
.98501 .51821 L
.98601 .51821 L
.98701 .51821 L
.98801 .51821 L
.98901 .51821 L
.99001 .51821 L
.99101 .51821 L
.99201 .51821 L
.99301 .51821 L
.99401 .51821 L
.995 .51821 L
.996 .51821 L
.997 .51821 L
.998 .51821 L
Mistroke
.999 .51125 L
Mfstroke
1 0 0 r
gsave
.999 .45799 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .41371 L
.05095 .41371 L
.05195 .41371 L
.05295 .41371 L
.05395 .41371 L
.05495 .41371 L
.05594 .41371 L
.05694 .41371 L
.05794 .41371 L
.05894 .41371 L
.05994 .41371 L
.06094 .41371 L
.06194 .41371 L
.06294 .41371 L
.06394 .41371 L
.06494 .41371 L
.06593 .41371 L
.06693 .41371 L
.06793 .41371 L
.06893 .41371 L
.06993 .41371 L
.07093 .41371 L
.07193 .41371 L
.07293 .41371 L
.07393 .41371 L
.07493 .41371 L
.07592 .41371 L
.07692 .41371 L
.07792 .41371 L
.07892 .41371 L
.07992 .41371 L
.08092 .41371 L
.08192 .41371 L
.08292 .41371 L
.08392 .41371 L
.08492 .41371 L
.08591 .41371 L
.08691 .41371 L
.08791 .41371 L
.08891 .41371 L
.08991 .41371 L
.09091 .41371 L
.09191 .41371 L
.09291 .41371 L
.09391 .41371 L
.09491 .41371 L
.0959 .41371 L
.0969 .41371 L
.0979 .41371 L
.0989 .41371 L
Mistroke
.0999 .46887 L
.1009 .46887 L
.1019 .46887 L
.1029 .46887 L
.1039 .46887 L
.1049 .46887 L
.10589 .46887 L
.10689 .46887 L
.10789 .46887 L
.10889 .46887 L
.10989 .46887 L
.11089 .46887 L
.11189 .46887 L
.11289 .46887 L
.11389 .46887 L
.11489 .46887 L
.11588 .46887 L
.11688 .46887 L
.11788 .46887 L
.11888 .46887 L
.11988 .46887 L
.12088 .46887 L
.12188 .46887 L
.12288 .46887 L
.12388 .46887 L
.12488 .46887 L
.12587 .46887 L
.12687 .46887 L
.12787 .46887 L
.12887 .46887 L
.12987 .46887 L
.13087 .46887 L
.13187 .46887 L
.13287 .46887 L
.13387 .46887 L
.13487 .46887 L
.13586 .46887 L
.13686 .46887 L
.13786 .46887 L
.13886 .46887 L
.13986 .46887 L
.14086 .46887 L
.14186 .46887 L
.14286 .46887 L
.14386 .46887 L
.14486 .46887 L
.14585 .46887 L
.14685 .46887 L
.14785 .46887 L
.14885 .46887 L
Mistroke
.14985 .47105 L
.15085 .47105 L
.15185 .47105 L
.15285 .47105 L
.15385 .47105 L
.15485 .47105 L
.15584 .47105 L
.15684 .47105 L
.15784 .47105 L
.15884 .47105 L
.15984 .47105 L
.16084 .47105 L
.16184 .47105 L
.16284 .47105 L
.16384 .47105 L
.16484 .47105 L
.16583 .47105 L
.16683 .47105 L
.16783 .47105 L
.16883 .47105 L
.16983 .47105 L
.17083 .47105 L
.17183 .47105 L
.17283 .47105 L
.17383 .47105 L
.17483 .47105 L
.17582 .47105 L
.17682 .47105 L
.17782 .47105 L
.17882 .47105 L
.17982 .47105 L
.18082 .47105 L
.18182 .47105 L
.18282 .47105 L
.18382 .47105 L
.18482 .47105 L
.18581 .47105 L
.18681 .47105 L
.18781 .47105 L
.18881 .47105 L
.18981 .47105 L
.19081 .47105 L
.19181 .47105 L
.19281 .47105 L
.19381 .47105 L
.19481 .47105 L
.1958 .47105 L
.1968 .47105 L
.1978 .47105 L
.1988 .47105 L
Mistroke
.1998 .4758 L
.2008 .4758 L
.2018 .4758 L
.2028 .4758 L
.2038 .4758 L
.2048 .4758 L
.20579 .4758 L
.20679 .4758 L
.20779 .4758 L
.20879 .4758 L
.20979 .4758 L
.21079 .4758 L
.21179 .4758 L
.21279 .4758 L
.21379 .4758 L
.21479 .4758 L
.21578 .4758 L
.21678 .4758 L
.21778 .4758 L
.21878 .4758 L
.21978 .4758 L
.22078 .4758 L
.22178 .4758 L
.22278 .4758 L
.22378 .4758 L
.22478 .4758 L
.22577 .4758 L
.22677 .4758 L
.22777 .4758 L
.22877 .4758 L
.22977 .4758 L
.23077 .4758 L
.23177 .4758 L
.23277 .4758 L
.23377 .4758 L
.23477 .4758 L
.23576 .4758 L
.23676 .4758 L
.23776 .4758 L
.23876 .4758 L
.23976 .4758 L
.24076 .4758 L
.24176 .4758 L
.24276 .4758 L
.24376 .4758 L
.24476 .4758 L
.24575 .4758 L
.24675 .4758 L
.24775 .4758 L
.24875 .4758 L
Mistroke
.24975 .46926 L
.25075 .46926 L
.25175 .46926 L
.25275 .46926 L
.25375 .46926 L
.25475 .46926 L
.25574 .46926 L
.25674 .46926 L
.25774 .46926 L
.25874 .46926 L
.25974 .46926 L
.26074 .46926 L
.26174 .46926 L
.26274 .46926 L
.26374 .46926 L
.26474 .46926 L
.26573 .46926 L
.26673 .46926 L
.26773 .46926 L
.26873 .46926 L
.26973 .46926 L
.27073 .46926 L
.27173 .46926 L
.27273 .46926 L
.27373 .46926 L
.27473 .46926 L
.27572 .46926 L
.27672 .46926 L
.27772 .46926 L
.27872 .46926 L
.27972 .46926 L
.28072 .46926 L
.28172 .46926 L
.28272 .46926 L
.28372 .46926 L
.28472 .46926 L
.28571 .46926 L
.28671 .46926 L
.28771 .46926 L
.28871 .46926 L
.28971 .46926 L
.29071 .46926 L
.29171 .46926 L
.29271 .46926 L
.29371 .46926 L
.29471 .46926 L
.2957 .46926 L
.2967 .46926 L
.2977 .46926 L
.2987 .46926 L
Mistroke
.2997 .47027 L
.3007 .47027 L
.3017 .47027 L
.3027 .47027 L
.3037 .47027 L
.3047 .47027 L
.30569 .47027 L
.30669 .47027 L
.30769 .47027 L
.30869 .47027 L
.30969 .47027 L
.31069 .47027 L
.31169 .47027 L
.31269 .47027 L
.31369 .47027 L
.31469 .47027 L
.31568 .47027 L
.31668 .47027 L
.31768 .47027 L
.31868 .47027 L
.31968 .47027 L
.32068 .47027 L
.32168 .47027 L
.32268 .47027 L
.32368 .47027 L
.32468 .47027 L
.32567 .47027 L
.32667 .47027 L
.32767 .47027 L
.32867 .47027 L
.32967 .47027 L
.33067 .47027 L
.33167 .47027 L
.33267 .47027 L
.33367 .47027 L
.33467 .47027 L
.33566 .47027 L
.33666 .47027 L
.33766 .47027 L
.33866 .47027 L
.33966 .47027 L
.34066 .47027 L
.34166 .47027 L
.34266 .47027 L
.34366 .47027 L
.34466 .47027 L
.34565 .47027 L
.34665 .47027 L
.34765 .47027 L
.34865 .47027 L
Mistroke
.34965 .47315 L
.35065 .47315 L
.35165 .47315 L
.35265 .47315 L
.35365 .47315 L
.35465 .47315 L
.35564 .47315 L
.35664 .47315 L
.35764 .47315 L
.35864 .47315 L
.35964 .47315 L
.36064 .47315 L
.36164 .47315 L
.36264 .47315 L
.36364 .47315 L
.36464 .47315 L
.36563 .47315 L
.36663 .47315 L
.36763 .47315 L
.36863 .47315 L
.36963 .47315 L
.37063 .47315 L
.37163 .47315 L
.37263 .47315 L
.37363 .47315 L
.37463 .47315 L
.37562 .47315 L
.37662 .47315 L
.37762 .47315 L
.37862 .47315 L
.37962 .47315 L
.38062 .47315 L
.38162 .47315 L
.38262 .47315 L
.38362 .47315 L
.38462 .47315 L
.38561 .47315 L
.38661 .47315 L
.38761 .47315 L
.38861 .47315 L
.38961 .47315 L
.39061 .47315 L
.39161 .47315 L
.39261 .47315 L
.39361 .47315 L
.39461 .47315 L
.3956 .47315 L
.3966 .47315 L
.3976 .47315 L
.3986 .47315 L
Mistroke
.3996 .47312 L
.4006 .47312 L
.4016 .47312 L
.4026 .47312 L
.4036 .47312 L
.4046 .47312 L
.40559 .47312 L
.40659 .47312 L
.40759 .47312 L
.40859 .47312 L
.40959 .47312 L
.41059 .47312 L
.41159 .47312 L
.41259 .47312 L
.41359 .47312 L
.41459 .47312 L
.41558 .47312 L
.41658 .47312 L
.41758 .47312 L
.41858 .47312 L
.41958 .47312 L
.42058 .47312 L
.42158 .47312 L
.42258 .47312 L
.42358 .47312 L
.42458 .47312 L
.42557 .47312 L
.42657 .47312 L
.42757 .47312 L
.42857 .47312 L
.42957 .47312 L
.43057 .47312 L
.43157 .47312 L
.43257 .47312 L
.43357 .47312 L
.43457 .47312 L
.43556 .47312 L
.43656 .47312 L
.43756 .47312 L
.43856 .47312 L
.43956 .47312 L
.44056 .47312 L
.44156 .47312 L
.44256 .47312 L
.44356 .47312 L
.44456 .47312 L
.44555 .47312 L
.44655 .47312 L
.44755 .47312 L
.44855 .47312 L
Mistroke
.44955 .4607 L
.45055 .4607 L
.45155 .4607 L
.45255 .4607 L
.45355 .4607 L
.45455 .4607 L
.45554 .4607 L
.45654 .4607 L
.45754 .4607 L
.45854 .4607 L
.45954 .4607 L
.46054 .4607 L
.46154 .4607 L
.46254 .4607 L
.46354 .4607 L
.46454 .4607 L
.46553 .4607 L
.46653 .4607 L
.46753 .4607 L
.46853 .4607 L
.46953 .4607 L
.47053 .4607 L
.47153 .4607 L
.47253 .4607 L
.47353 .4607 L
.47453 .4607 L
.47552 .4607 L
.47652 .4607 L
.47752 .4607 L
.47852 .4607 L
.47952 .4607 L
.48052 .4607 L
.48152 .4607 L
.48252 .4607 L
.48352 .4607 L
.48452 .4607 L
.48551 .4607 L
.48651 .4607 L
.48751 .4607 L
.48851 .4607 L
.48951 .4607 L
.49051 .4607 L
.49151 .4607 L
.49251 .4607 L
.49351 .4607 L
.49451 .4607 L
.4955 .4607 L
.4965 .4607 L
.4975 .4607 L
.4985 .4607 L
Mistroke
.4995 .46309 L
.5005 .46309 L
.5015 .46309 L
.5025 .46309 L
.5035 .46309 L
.5045 .46309 L
.50549 .46309 L
.50649 .46309 L
.50749 .46309 L
.50849 .46309 L
.50949 .46309 L
.51049 .46309 L
.51149 .46309 L
.51249 .46309 L
.51349 .46309 L
.51449 .46309 L
.51548 .46309 L
.51648 .46309 L
.51748 .46309 L
.51848 .46309 L
.51948 .46309 L
.52048 .46309 L
.52148 .46309 L
.52248 .46309 L
.52348 .46309 L
.52448 .46309 L
.52547 .46309 L
.52647 .46309 L
.52747 .46309 L
.52847 .46309 L
.52947 .46309 L
.53047 .46309 L
.53147 .46309 L
.53247 .46309 L
.53347 .46309 L
.53447 .46309 L
.53546 .46309 L
.53646 .46309 L
.53746 .46309 L
.53846 .46309 L
.53946 .46309 L
.54046 .46309 L
.54146 .46309 L
.54246 .46309 L
.54346 .46309 L
.54446 .46309 L
.54545 .46309 L
.54645 .46309 L
.54745 .46309 L
.54845 .46309 L
Mistroke
.54945 .4665 L
.55045 .4665 L
.55145 .4665 L
.55245 .4665 L
.55345 .4665 L
.55445 .4665 L
.55544 .4665 L
.55644 .4665 L
.55744 .4665 L
.55844 .4665 L
.55944 .4665 L
.56044 .4665 L
.56144 .4665 L
.56244 .4665 L
.56344 .4665 L
.56444 .4665 L
.56543 .4665 L
.56643 .4665 L
.56743 .4665 L
.56843 .4665 L
.56943 .4665 L
.57043 .4665 L
.57143 .4665 L
.57243 .4665 L
.57343 .4665 L
.57443 .4665 L
.57542 .4665 L
.57642 .4665 L
.57742 .4665 L
.57842 .4665 L
.57942 .4665 L
.58042 .4665 L
.58142 .4665 L
.58242 .4665 L
.58342 .4665 L
.58442 .4665 L
.58541 .4665 L
.58641 .4665 L
.58741 .4665 L
.58841 .4665 L
.58941 .4665 L
.59041 .4665 L
.59141 .4665 L
.59241 .4665 L
.59341 .4665 L
.59441 .4665 L
.5954 .4665 L
.5964 .4665 L
.5974 .4665 L
.5984 .4665 L
Mistroke
.5994 .45945 L
.6004 .45945 L
.6014 .45945 L
.6024 .45945 L
.6034 .45945 L
.6044 .45945 L
.60539 .45945 L
.60639 .45945 L
.60739 .45945 L
.60839 .45945 L
.60939 .45945 L
.61039 .45945 L
.61139 .45945 L
.61239 .45945 L
.61339 .45945 L
.61439 .45945 L
.61538 .45945 L
.61638 .45945 L
.61738 .45945 L
.61838 .45945 L
.61938 .45945 L
.62038 .45945 L
.62138 .45945 L
.62238 .45945 L
.62338 .45945 L
.62438 .45945 L
.62537 .45945 L
.62637 .45945 L
.62737 .45945 L
.62837 .45945 L
.62937 .45945 L
.63037 .45945 L
.63137 .45945 L
.63237 .45945 L
.63337 .45945 L
.63437 .45945 L
.63536 .45945 L
.63636 .45945 L
.63736 .45945 L
.63836 .45945 L
.63936 .45945 L
.64036 .45945 L
.64136 .45945 L
.64236 .45945 L
.64336 .45945 L
.64436 .45945 L
.64535 .45945 L
.64635 .45945 L
.64735 .45945 L
.64835 .45945 L
Mistroke
.64935 .45951 L
.65035 .45951 L
.65135 .45951 L
.65235 .45951 L
.65335 .45951 L
.65435 .45951 L
.65534 .45951 L
.65634 .45951 L
.65734 .45951 L
.65834 .45951 L
.65934 .45951 L
.66034 .45951 L
.66134 .45951 L
.66234 .45951 L
.66334 .45951 L
.66434 .45951 L
.66533 .45951 L
.66633 .45951 L
.66733 .45951 L
.66833 .45951 L
.66933 .45951 L
.67033 .45951 L
.67133 .45951 L
.67233 .45951 L
.67333 .45951 L
.67433 .45951 L
.67532 .45951 L
.67632 .45951 L
.67732 .45951 L
.67832 .45951 L
.67932 .45951 L
.68032 .45951 L
.68132 .45951 L
.68232 .45951 L
.68332 .45951 L
.68432 .45951 L
.68531 .45951 L
.68631 .45951 L
.68731 .45951 L
.68831 .45951 L
.68931 .45951 L
.69031 .45951 L
.69131 .45951 L
.69231 .45951 L
.69331 .45951 L
.69431 .45951 L
.6953 .45951 L
.6963 .45951 L
.6973 .45951 L
.6983 .45951 L
Mistroke
.6993 .45926 L
.7003 .45926 L
.7013 .45926 L
.7023 .45926 L
.7033 .45926 L
.7043 .45926 L
.70529 .45926 L
.70629 .45926 L
.70729 .45926 L
.70829 .45926 L
.70929 .45926 L
.71029 .45926 L
.71129 .45926 L
.71229 .45926 L
.71329 .45926 L
.71429 .45926 L
.71528 .45926 L
.71628 .45926 L
.71728 .45926 L
.71828 .45926 L
.71928 .45926 L
.72028 .45926 L
.72128 .45926 L
.72228 .45926 L
.72328 .45926 L
.72428 .45926 L
.72527 .45926 L
.72627 .45926 L
.72727 .45926 L
.72827 .45926 L
.72927 .45926 L
.73027 .45926 L
.73127 .45926 L
.73227 .45926 L
.73327 .45926 L
.73427 .45926 L
.73526 .45926 L
.73626 .45926 L
.73726 .45926 L
.73826 .45926 L
.73926 .45926 L
.74026 .45926 L
.74126 .45926 L
.74226 .45926 L
.74326 .45926 L
.74426 .45926 L
.74525 .45926 L
.74625 .45926 L
.74725 .45926 L
.74825 .45926 L
Mistroke
.74925 .46164 L
.75025 .46164 L
.75125 .46164 L
.75225 .46164 L
.75325 .46164 L
.75425 .46164 L
.75524 .46164 L
.75624 .46164 L
.75724 .46164 L
.75824 .46164 L
.75924 .46164 L
.76024 .46164 L
.76124 .46164 L
.76224 .46164 L
.76324 .46164 L
.76424 .46164 L
.76523 .46164 L
.76623 .46164 L
.76723 .46164 L
.76823 .46164 L
.76923 .46164 L
.77023 .46164 L
.77123 .46164 L
.77223 .46164 L
.77323 .46164 L
.77423 .46164 L
.77522 .46164 L
.77622 .46164 L
.77722 .46164 L
.77822 .46164 L
.77922 .46164 L
.78022 .46164 L
.78122 .46164 L
.78222 .46164 L
.78322 .46164 L
.78422 .46164 L
.78521 .46164 L
.78621 .46164 L
.78721 .46164 L
.78821 .46164 L
.78921 .46164 L
.79021 .46164 L
.79121 .46164 L
.79221 .46164 L
.79321 .46164 L
.79421 .46164 L
.7952 .46164 L
.7962 .46164 L
.7972 .46164 L
.7982 .46164 L
Mistroke
.7992 .46088 L
.8002 .46088 L
.8012 .46088 L
.8022 .46088 L
.8032 .46088 L
.8042 .46088 L
.80519 .46088 L
.80619 .46088 L
.80719 .46088 L
.80819 .46088 L
.80919 .46088 L
.81019 .46088 L
.81119 .46088 L
.81219 .46088 L
.81319 .46088 L
.81419 .46088 L
.81518 .46088 L
.81618 .46088 L
.81718 .46088 L
.81818 .46088 L
.81918 .46088 L
.82018 .46088 L
.82118 .46088 L
.82218 .46088 L
.82318 .46088 L
.82418 .46088 L
.82517 .46088 L
.82617 .46088 L
.82717 .46088 L
.82817 .46088 L
.82917 .46088 L
.83017 .46088 L
.83117 .46088 L
.83217 .46088 L
.83317 .46088 L
.83417 .46088 L
.83516 .46088 L
.83616 .46088 L
.83716 .46088 L
.83816 .46088 L
.83916 .46088 L
.84016 .46088 L
.84116 .46088 L
.84216 .46088 L
.84316 .46088 L
.84416 .46088 L
.84515 .46088 L
.84615 .46088 L
.84715 .46088 L
.84815 .46088 L
Mistroke
.84915 .4652 L
.85015 .4652 L
.85115 .4652 L
.85215 .4652 L
.85315 .4652 L
.85415 .4652 L
.85514 .4652 L
.85614 .4652 L
.85714 .4652 L
.85814 .4652 L
.85914 .4652 L
.86014 .4652 L
.86114 .4652 L
.86214 .4652 L
.86314 .4652 L
.86414 .4652 L
.86513 .4652 L
.86613 .4652 L
.86713 .4652 L
.86813 .4652 L
.86913 .4652 L
.87013 .4652 L
.87113 .4652 L
.87213 .4652 L
.87313 .4652 L
.87413 .4652 L
.87512 .4652 L
.87612 .4652 L
.87712 .4652 L
.87812 .4652 L
.87912 .4652 L
.88012 .4652 L
.88112 .4652 L
.88212 .4652 L
.88312 .4652 L
.88412 .4652 L
.88511 .4652 L
.88611 .4652 L
.88711 .4652 L
.88811 .4652 L
.88911 .4652 L
.89011 .4652 L
.89111 .4652 L
.89211 .4652 L
.89311 .4652 L
.89411 .4652 L
.8951 .4652 L
.8961 .4652 L
.8971 .4652 L
.8981 .4652 L
Mistroke
.8991 .46881 L
.9001 .46881 L
.9011 .46881 L
.9021 .46881 L
.9031 .46881 L
.9041 .46881 L
.90509 .46881 L
.90609 .46881 L
.90709 .46881 L
.90809 .46881 L
.90909 .46881 L
.91009 .46881 L
.91109 .46881 L
.91209 .46881 L
.91309 .46881 L
.91409 .46881 L
.91508 .46881 L
.91608 .46881 L
.91708 .46881 L
.91808 .46881 L
.91908 .46881 L
.92008 .46881 L
.92108 .46881 L
.92208 .46881 L
.92308 .46881 L
.92408 .46881 L
.92507 .46881 L
.92607 .46881 L
.92707 .46881 L
.92807 .46881 L
.92907 .46881 L
.93007 .46881 L
.93107 .46881 L
.93207 .46881 L
.93307 .46881 L
.93407 .46881 L
.93506 .46881 L
.93606 .46881 L
.93706 .46881 L
.93806 .46881 L
.93906 .46881 L
.94006 .46881 L
.94106 .46881 L
.94206 .46881 L
.94306 .46881 L
.94406 .46881 L
.94505 .46881 L
.94605 .46881 L
.94705 .46881 L
.94805 .46881 L
Mistroke
.94905 .46478 L
.95005 .46478 L
.95105 .46478 L
.95205 .46478 L
.95305 .46478 L
.95405 .46478 L
.95504 .46478 L
.95604 .46478 L
.95704 .46478 L
.95804 .46478 L
.95904 .46478 L
.96004 .46478 L
.96104 .46478 L
.96204 .46478 L
.96304 .46478 L
.96404 .46478 L
.96503 .46478 L
.96603 .46478 L
.96703 .46478 L
.96803 .46478 L
.96903 .46478 L
.97003 .46478 L
.97103 .46478 L
.97203 .46478 L
.97303 .46478 L
.97403 .46478 L
.97502 .46478 L
.97602 .46478 L
.97702 .46478 L
.97802 .46478 L
.97902 .46478 L
.98002 .46478 L
.98102 .46478 L
.98202 .46478 L
.98302 .46478 L
.98402 .46478 L
.98501 .46478 L
.98601 .46478 L
.98701 .46478 L
.98801 .46478 L
.98901 .46478 L
.99001 .46478 L
.99101 .46478 L
.99201 .46478 L
.99301 .46478 L
.99401 .46478 L
.995 .46478 L
.996 .46478 L
.997 .46478 L
.998 .46478 L
Mistroke
.999 .45799 L
Mfstroke
0 0 1 r
gsave
.001 -0.30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 -0.824045 0.0412023 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0824 -12 -4.5 ]
[-0.0125 .0824 0 4.5 ]
[-0.0125 .16481 -12 -4.5 ]
[-0.0125 .16481 0 4.5 ]
[-0.0125 .24721 -12 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .32962 -12 -4.5 ]
[-0.0125 .32962 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .57683 -12 -4.5 ]
[-0.0125 .57683 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0824 m
.00625 .0824 L
s
[(22)] -0.0125 .0824 1 0 Mshowa
0 .16481 m
.00625 .16481 L
s
[(24)] -0.0125 .16481 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(26)] -0.0125 .24721 1 0 Mshowa
0 .32962 m
.00625 .32962 L
s
[(28)] -0.0125 .32962 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(30)] -0.0125 .41202 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(32)] -0.0125 .49443 1 0 Mshowa
0 .57683 m
.00625 .57683 L
s
[(34)] -0.0125 .57683 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .10301 m
.00375 .10301 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .18541 m
.00375 .18541 L
s
0 .20601 m
.00375 .20601 L
s
0 .22661 m
.00375 .22661 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .30902 m
.00375 .30902 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .51503 m
.00375 .51503 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .0824 m
1 .0824 L
s
.99375 .16481 m
1 .16481 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .32962 m
1 .32962 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .49443 m
1 .49443 L
s
.99375 .57683 m
1 .57683 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .10301 m
1 .10301 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20601 m
1 .20601 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .30902 m
1 .30902 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .51503 m
1 .51503 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .32962 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .32962 m
.001 .32962 L
.002 .32962 L
.003 .32962 L
.004 .32962 L
.005 .32962 L
.00599 .32962 L
.00699 .32962 L
.00799 .32962 L
.00899 .32962 L
.00999 .32962 L
.01099 .32962 L
.01199 .32962 L
.01299 .32962 L
.01399 .32962 L
.01499 .32962 L
.01598 .32962 L
.01698 .32962 L
.01798 .32962 L
.01898 .32962 L
.01998 .32962 L
.02098 .32962 L
.02198 .32962 L
.02298 .32962 L
.02398 .32962 L
.02498 .32962 L
.02597 .32962 L
.02697 .32962 L
.02797 .32962 L
.02897 .32962 L
.02997 .32962 L
.03097 .32962 L
.03197 .32962 L
.03297 .32962 L
.03397 .32962 L
.03497 .32962 L
.03596 .32962 L
.03696 .32962 L
.03796 .32962 L
.03896 .32962 L
.03996 .32962 L
.04096 .32962 L
.04196 .32962 L
.04296 .32962 L
.04396 .32962 L
.04496 .32962 L
.04595 .32962 L
.04695 .32962 L
.04795 .32962 L
.04895 .32962 L
Mistroke
.04995 .32962 L
.05095 .32962 L
.05195 .32962 L
.05295 .32962 L
.05395 .32962 L
.05495 .32962 L
.05594 .32962 L
.05694 .32962 L
.05794 .32962 L
.05894 .32962 L
.05994 .32962 L
.06094 .32962 L
.06194 .32962 L
.06294 .32962 L
.06394 .32962 L
.06494 .32962 L
.06593 .32962 L
.06693 .32962 L
.06793 .32962 L
.06893 .32962 L
.06993 .32962 L
.07093 .32962 L
.07193 .32962 L
.07293 .32962 L
.07393 .32962 L
.07493 .32962 L
.07592 .32962 L
.07692 .32962 L
.07792 .32962 L
.07892 .32962 L
.07992 .32962 L
.08092 .32962 L
.08192 .32962 L
.08292 .32962 L
.08392 .32962 L
.08492 .32962 L
.08591 .32962 L
.08691 .32962 L
.08791 .32962 L
.08891 .32962 L
.08991 .32962 L
.09091 .32962 L
.09191 .32962 L
.09291 .32962 L
.09391 .32962 L
.09491 .32962 L
.0959 .32962 L
.0969 .32962 L
.0979 .32962 L
.0989 .32962 L
Mistroke
.0999 .32962 L
.1009 .32962 L
.1019 .32962 L
.1029 .32962 L
.1039 .32962 L
.1049 .32962 L
.10589 .32962 L
.10689 .32962 L
.10789 .32962 L
.10889 .32962 L
.10989 .32962 L
.11089 .32962 L
.11189 .32962 L
.11289 .32962 L
.11389 .32962 L
.11489 .32962 L
.11588 .32962 L
.11688 .32962 L
.11788 .32962 L
.11888 .32962 L
.11988 .32962 L
.12088 .32962 L
.12188 .32962 L
.12288 .32962 L
.12388 .32962 L
.12488 .32962 L
.12587 .32962 L
.12687 .32962 L
.12787 .32962 L
.12887 .32962 L
.12987 .32962 L
.13087 .32962 L
.13187 .32962 L
.13287 .32962 L
.13387 .32962 L
.13487 .32962 L
.13586 .32962 L
.13686 .32962 L
.13786 .32962 L
.13886 .32962 L
.13986 .32962 L
.14086 .32962 L
.14186 .32962 L
.14286 .32962 L
.14386 .32962 L
.14486 .32962 L
.14585 .32962 L
.14685 .32962 L
.14785 .32962 L
.14885 .32962 L
Mistroke
.14985 .32962 L
.15085 .32962 L
.15185 .32962 L
.15285 .32962 L
.15385 .32962 L
.15485 .32962 L
.15584 .32962 L
.15684 .32962 L
.15784 .32962 L
.15884 .32962 L
.15984 .32962 L
.16084 .32962 L
.16184 .32962 L
.16284 .32962 L
.16384 .32962 L
.16484 .32962 L
.16583 .32962 L
.16683 .32962 L
.16783 .32962 L
.16883 .32962 L
.16983 .32962 L
.17083 .32962 L
.17183 .32962 L
.17283 .32962 L
.17383 .32962 L
.17483 .32962 L
.17582 .32962 L
.17682 .32962 L
.17782 .32962 L
.17882 .32962 L
.17982 .32962 L
.18082 .32962 L
.18182 .32962 L
.18282 .32962 L
.18382 .32962 L
.18482 .32962 L
.18581 .32962 L
.18681 .32962 L
.18781 .32962 L
.18881 .32962 L
.18981 .32962 L
.19081 .32962 L
.19181 .32962 L
.19281 .32962 L
.19381 .32962 L
.19481 .32962 L
.1958 .32962 L
.1968 .32962 L
.1978 .32962 L
.1988 .32962 L
Mistroke
.1998 .32962 L
.2008 .32962 L
.2018 .32962 L
.2028 .32962 L
.2038 .32962 L
.2048 .32962 L
.20579 .32962 L
.20679 .32962 L
.20779 .32962 L
.20879 .32962 L
.20979 .32962 L
.21079 .32962 L
.21179 .32962 L
.21279 .32962 L
.21379 .32962 L
.21479 .32962 L
.21578 .32962 L
.21678 .32962 L
.21778 .32962 L
.21878 .32962 L
.21978 .32962 L
.22078 .32962 L
.22178 .32962 L
.22278 .32962 L
.22378 .32962 L
.22478 .32962 L
.22577 .32962 L
.22677 .32962 L
.22777 .32962 L
.22877 .32962 L
.22977 .32962 L
.23077 .32962 L
.23177 .32962 L
.23277 .32962 L
.23377 .32962 L
.23477 .32962 L
.23576 .32962 L
.23676 .32962 L
.23776 .32962 L
.23876 .32962 L
.23976 .32962 L
.24076 .32962 L
.24176 .32962 L
.24276 .32962 L
.24376 .32962 L
.24476 .32962 L
.24575 .32962 L
.24675 .32962 L
.24775 .32962 L
.24875 .32962 L
Mistroke
.24975 .32962 L
.25075 .32962 L
.25175 .32962 L
.25275 .32962 L
.25375 .32962 L
.25475 .32962 L
.25574 .32962 L
.25674 .32962 L
.25774 .32962 L
.25874 .32962 L
.25974 .32962 L
.26074 .32962 L
.26174 .32962 L
.26274 .32962 L
.26374 .32962 L
.26474 .32962 L
.26573 .32962 L
.26673 .32962 L
.26773 .32962 L
.26873 .32962 L
.26973 .32962 L
.27073 .32962 L
.27173 .32963 L
.27273 .32963 L
.27373 .32962 L
.27473 .32962 L
.27572 .32962 L
.27672 .32962 L
.27772 .32962 L
.27872 .32962 L
.27972 .32962 L
.28072 .32962 L
.28172 .32962 L
.28272 .32962 L
.28372 .32962 L
.28472 .32962 L
.28571 .32962 L
.28671 .32962 L
.28771 .32962 L
.28871 .32962 L
.28971 .32962 L
.29071 .32962 L
.29171 .32962 L
.29271 .32962 L
.29371 .32962 L
.29471 .32962 L
.2957 .32962 L
.2967 .32962 L
.2977 .32962 L
.2987 .32962 L
Mistroke
.2997 .32962 L
.3007 .32962 L
.3017 .32962 L
.3027 .32962 L
.3037 .32962 L
.3047 .32962 L
.30569 .32962 L
.30669 .32962 L
.30769 .32962 L
.30869 .32962 L
.30969 .32962 L
.31069 .32962 L
.31169 .32962 L
.31269 .32962 L
.31369 .32962 L
.31469 .32962 L
.31568 .32962 L
.31668 .32962 L
.31768 .32962 L
.31868 .32962 L
.31968 .32962 L
.32068 .32962 L
.32168 .32962 L
.32268 .32962 L
.32368 .32962 L
.32468 .32962 L
.32567 .32962 L
.32667 .32962 L
.32767 .32962 L
.32867 .32962 L
.32967 .32962 L
.33067 .32962 L
.33167 .32962 L
.33267 .32962 L
.33367 .32962 L
.33467 .32962 L
.33566 .32962 L
.33666 .32962 L
.33766 .32962 L
.33866 .32962 L
.33966 .32962 L
.34066 .32962 L
.34166 .32962 L
.34266 .32962 L
.34366 .32962 L
.34466 .32962 L
.34565 .32962 L
.34665 .32962 L
.34765 .32962 L
.34865 .32962 L
Mistroke
.34965 .32962 L
.35065 .32962 L
.35165 .32962 L
.35265 .32962 L
.35365 .32962 L
.35465 .32962 L
.35564 .32962 L
.35664 .32962 L
.35764 .32962 L
.35864 .32962 L
.35964 .32962 L
.36064 .32962 L
.36164 .32962 L
.36264 .32962 L
.36364 .32962 L
.36464 .32962 L
.36563 .32962 L
.36663 .32962 L
.36763 .32962 L
.36863 .32962 L
.36963 .32962 L
.37063 .32962 L
.37163 .32962 L
.37263 .32962 L
.37363 .32962 L
.37463 .32962 L
.37562 .32962 L
.37662 .32962 L
.37762 .32962 L
.37862 .32962 L
.37962 .32962 L
.38062 .32962 L
.38162 .32962 L
.38262 .32962 L
.38362 .32962 L
.38462 .32962 L
.38561 .32962 L
.38661 .32962 L
.38761 .32962 L
.38861 .32962 L
.38961 .32962 L
.39061 .32962 L
.39161 .32962 L
.39261 .32962 L
.39361 .32962 L
.39461 .32962 L
.3956 .32962 L
.3966 .32962 L
.3976 .32962 L
.3986 .32962 L
Mistroke
.3996 .32962 L
.4006 .32962 L
.4016 .32962 L
.4026 .32962 L
.4036 .32962 L
.4046 .32962 L
.40559 .32962 L
.40659 .32962 L
.40759 .32962 L
.40859 .32962 L
.40959 .32962 L
.41059 .32962 L
.41159 .32962 L
.41259 .32962 L
.41359 .32962 L
.41459 .32962 L
.41558 .32962 L
.41658 .32962 L
.41758 .32962 L
.41858 .32962 L
.41958 .32962 L
.42058 .32962 L
.42158 .32962 L
.42258 .32962 L
.42358 .32962 L
.42458 .32962 L
.42557 .32962 L
.42657 .32962 L
.42757 .32962 L
.42857 .32962 L
.42957 .32962 L
.43057 .32962 L
.43157 .32962 L
.43257 .32962 L
.43357 .32962 L
.43457 .32962 L
.43556 .32962 L
.43656 .32962 L
.43756 .32962 L
.43856 .32962 L
.43956 .32962 L
.44056 .32962 L
.44156 .32962 L
.44256 .32962 L
.44356 .32962 L
.44456 .32962 L
.44555 .32962 L
.44655 .32962 L
.44755 .32962 L
.44855 .32962 L
Mistroke
.44955 .32962 L
.45055 .32962 L
.45155 .32962 L
.45255 .32962 L
.45355 .32962 L
.45455 .32962 L
.45554 .32962 L
.45654 .32962 L
.45754 .32962 L
.45854 .32962 L
.45954 .32962 L
.46054 .32962 L
.46154 .32962 L
.46254 .32962 L
.46354 .32962 L
.46454 .32962 L
.46553 .32962 L
.46653 .32962 L
.46753 .32962 L
.46853 .32962 L
.46953 .32962 L
.47053 .32962 L
.47153 .32962 L
.47253 .32962 L
.47353 .32962 L
.47453 .32962 L
.47552 .32962 L
.47652 .32962 L
.47752 .32962 L
.47852 .32963 L
.47952 .32963 L
.48052 .32962 L
.48152 .32962 L
.48252 .32962 L
.48352 .32962 L
.48452 .32963 L
.48551 .32963 L
.48651 .32963 L
.48751 .32963 L
.48851 .32963 L
.48951 .32963 L
.49051 .32963 L
.49151 .32963 L
.49251 .32962 L
.49351 .32963 L
.49451 .32962 L
.4955 .32962 L
.4965 .32963 L
.4975 .32963 L
.4985 .32962 L
Mistroke
.4995 .32962 L
.5005 .32962 L
.5015 .32962 L
.5025 .32962 L
.5035 .32962 L
.5045 .32962 L
.50549 .32962 L
.50649 .32962 L
.50749 .32962 L
.50849 .32962 L
.50949 .32963 L
.51049 .32962 L
.51149 .32962 L
.51249 .32962 L
.51349 .32962 L
.51449 .32962 L
.51548 .32962 L
.51648 .32962 L
.51748 .32963 L
.51848 .32962 L
.51948 .32962 L
.52048 .32962 L
.52148 .32962 L
.52248 .32963 L
.52348 .32963 L
.52448 .32963 L
.52547 .32963 L
.52647 .32963 L
.52747 .32963 L
.52847 .32963 L
.52947 .32963 L
.53047 .32963 L
.53147 .32963 L
.53247 .32963 L
.53347 .32963 L
.53447 .32963 L
.53546 .32963 L
.53646 .32963 L
.53746 .32963 L
.53846 .32963 L
.53946 .32963 L
.54046 .32963 L
.54146 .32963 L
.54246 .32963 L
.54346 .32963 L
.54446 .32963 L
.54545 .32963 L
.54645 .32963 L
.54745 .32963 L
.54845 .32963 L
Mistroke
.54945 .32963 L
.55045 .32963 L
.55145 .32963 L
.55245 .32963 L
.55345 .32963 L
.55445 .32963 L
.55544 .32963 L
.55644 .32963 L
.55744 .32963 L
.55844 .32963 L
.55944 .32963 L
.56044 .32963 L
.56144 .32963 L
.56244 .32963 L
.56344 .32963 L
.56444 .32963 L
.56543 .32963 L
.56643 .32963 L
.56743 .32963 L
.56843 .32963 L
.56943 .32963 L
.57043 .32963 L
.57143 .32963 L
.57243 .32963 L
.57343 .32963 L
.57443 .32963 L
.57542 .32963 L
.57642 .32963 L
.57742 .32963 L
.57842 .32963 L
.57942 .32963 L
.58042 .32963 L
.58142 .32963 L
.58242 .32963 L
.58342 .32963 L
.58442 .32963 L
.58541 .32963 L
.58641 .32963 L
.58741 .32963 L
.58841 .32963 L
.58941 .32963 L
.59041 .32963 L
.59141 .32963 L
.59241 .32963 L
.59341 .32963 L
.59441 .32963 L
.5954 .32963 L
.5964 .32963 L
.5974 .32963 L
.5984 .32963 L
Mistroke
.5994 .32963 L
.6004 .32963 L
.6014 .32963 L
.6024 .32963 L
.6034 .32963 L
.6044 .32963 L
.60539 .32963 L
.60639 .32963 L
.60739 .32963 L
.60839 .32963 L
.60939 .32963 L
.61039 .32963 L
.61139 .32963 L
.61239 .32963 L
.61339 .32963 L
.61439 .32963 L
.61538 .32963 L
.61638 .32963 L
.61738 .32963 L
.61838 .32963 L
.61938 .32963 L
.62038 .32963 L
.62138 .32963 L
.62238 .32963 L
.62338 .32963 L
.62438 .32963 L
.62537 .32963 L
.62637 .32963 L
.62737 .32963 L
.62837 .32963 L
.62937 .32963 L
.63037 .32963 L
.63137 .32963 L
.63237 .32963 L
.63337 .32963 L
.63437 .32963 L
.63536 .32963 L
.63636 .32963 L
.63736 .32963 L
.63836 .32963 L
.63936 .32963 L
.64036 .32963 L
.64136 .32963 L
.64236 .32963 L
.64336 .32963 L
.64436 .32963 L
.64535 .32963 L
.64635 .32963 L
.64735 .32963 L
.64835 .32963 L
Mistroke
.64935 .32963 L
.65035 .32963 L
.65135 .32963 L
.65235 .32963 L
.65335 .32963 L
.65435 .32963 L
.65534 .32963 L
.65634 .32963 L
.65734 .32963 L
.65834 .32963 L
.65934 .32963 L
.66034 .32963 L
.66134 .32963 L
.66234 .32963 L
.66334 .32963 L
.66434 .32963 L
.66533 .32963 L
.66633 .32963 L
.66733 .32963 L
.66833 .32963 L
.66933 .32963 L
.67033 .32963 L
.67133 .32963 L
.67233 .32963 L
.67333 .32963 L
.67433 .32963 L
.67532 .32963 L
.67632 .32963 L
.67732 .32963 L
.67832 .32963 L
.67932 .32963 L
.68032 .32963 L
.68132 .32963 L
.68232 .32963 L
.68332 .32963 L
.68432 .32963 L
.68531 .32963 L
.68631 .32963 L
.68731 .32963 L
.68831 .32963 L
.68931 .32963 L
.69031 .32963 L
.69131 .32963 L
.69231 .32963 L
.69331 .32963 L
.69431 .32963 L
.6953 .32963 L
.6963 .32963 L
.6973 .32963 L
.6983 .32963 L
Mistroke
.6993 .32963 L
.7003 .32963 L
.7013 .32963 L
.7023 .32963 L
.7033 .32963 L
.7043 .32963 L
.70529 .32963 L
.70629 .32963 L
.70729 .32963 L
.70829 .32963 L
.70929 .32963 L
.71029 .32963 L
.71129 .32963 L
.71229 .32963 L
.71329 .32963 L
.71429 .32963 L
.71528 .32963 L
.71628 .32963 L
.71728 .32963 L
.71828 .32963 L
.71928 .32963 L
.72028 .32963 L
.72128 .32963 L
.72228 .32963 L
.72328 .32963 L
.72428 .32963 L
.72527 .32963 L
.72627 .32963 L
.72727 .32963 L
.72827 .32963 L
.72927 .32963 L
.73027 .32963 L
.73127 .32963 L
.73227 .32963 L
.73327 .32963 L
.73427 .32963 L
.73526 .32963 L
.73626 .32963 L
.73726 .32963 L
.73826 .32963 L
.73926 .32963 L
.74026 .32963 L
.74126 .32963 L
.74226 .32963 L
.74326 .32963 L
.74426 .32963 L
.74525 .32963 L
.74625 .32963 L
.74725 .32963 L
.74825 .32963 L
Mistroke
.74925 .32963 L
.75025 .32963 L
.75125 .32963 L
.75225 .32963 L
.75325 .32963 L
.75425 .32962 L
.75524 .32962 L
.75624 .32963 L
.75724 .32963 L
.75824 .32962 L
.75924 .32963 L
.76024 .32962 L
.76124 .32962 L
.76224 .32962 L
.76324 .32962 L
.76424 .32962 L
.76523 .32962 L
.76623 .32962 L
.76723 .32962 L
.76823 .32962 L
.76923 .32962 L
.77023 .32962 L
.77123 .32962 L
.77223 .32962 L
.77323 .32962 L
.77423 .32962 L
.77522 .32962 L
.77622 .32962 L
.77722 .32962 L
.77822 .32962 L
.77922 .32962 L
.78022 .32962 L
.78122 .32962 L
.78222 .32962 L
.78322 .32962 L
.78422 .32962 L
.78521 .32962 L
.78621 .32962 L
.78721 .32962 L
.78821 .32962 L
.78921 .32962 L
.79021 .32962 L
.79121 .32962 L
.79221 .32962 L
.79321 .32962 L
.79421 .32962 L
.7952 .32962 L
.7962 .32962 L
.7972 .32962 L
.7982 .32962 L
Mistroke
.7992 .32962 L
.8002 .32962 L
.8012 .32962 L
.8022 .32962 L
.8032 .32962 L
.8042 .32962 L
.80519 .32962 L
.80619 .32962 L
.80719 .32962 L
.80819 .32962 L
.80919 .32962 L
.81019 .32962 L
.81119 .32962 L
.81219 .32962 L
.81319 .32962 L
.81419 .32962 L
.81518 .32962 L
.81618 .32962 L
.81718 .32962 L
.81818 .32962 L
.81918 .32962 L
.82018 .32962 L
.82118 .32962 L
.82218 .32962 L
.82318 .32962 L
.82418 .32962 L
.82517 .32962 L
.82617 .32962 L
.82717 .32962 L
.82817 .32962 L
.82917 .32962 L
.83017 .32962 L
.83117 .32962 L
.83217 .32962 L
.83317 .32962 L
.83417 .32962 L
.83516 .32962 L
.83616 .32962 L
.83716 .32962 L
.83816 .32962 L
.83916 .32962 L
.84016 .32962 L
.84116 .32962 L
.84216 .32962 L
.84316 .32962 L
.84416 .32962 L
.84515 .32962 L
.84615 .32962 L
.84715 .32962 L
.84815 .32962 L
Mistroke
.84915 .32962 L
.85015 .32962 L
.85115 .32962 L
.85215 .32962 L
.85315 .32962 L
.85415 .32962 L
.85514 .32962 L
.85614 .32962 L
.85714 .32962 L
.85814 .32962 L
.85914 .32962 L
.86014 .32962 L
.86114 .32962 L
.86214 .32962 L
.86314 .32962 L
.86414 .32962 L
.86513 .32962 L
.86613 .32962 L
.86713 .32962 L
.86813 .32962 L
.86913 .32962 L
.87013 .32962 L
.87113 .32962 L
.87213 .32962 L
.87313 .32962 L
.87413 .32962 L
.87512 .32962 L
.87612 .32962 L
.87712 .32962 L
.87812 .32962 L
.87912 .32962 L
.88012 .32962 L
.88112 .32962 L
.88212 .32962 L
.88312 .32962 L
.88412 .32962 L
.88511 .32962 L
.88611 .32962 L
.88711 .32962 L
.88811 .32962 L
.88911 .32962 L
.89011 .32962 L
.89111 .32962 L
.89211 .32962 L
.89311 .32962 L
.89411 .32962 L
.8951 .32962 L
.8961 .32962 L
.8971 .32962 L
.8981 .32962 L
Mistroke
.8991 .32962 L
.9001 .32962 L
.9011 .32962 L
.9021 .32962 L
.9031 .32962 L
.9041 .32962 L
.90509 .32962 L
.90609 .32962 L
.90709 .32962 L
.90809 .32962 L
.90909 .32962 L
.91009 .32962 L
.91109 .32962 L
.91209 .32962 L
.91309 .32962 L
.91409 .32962 L
.91508 .32962 L
.91608 .32962 L
.91708 .32962 L
.91808 .32962 L
.91908 .32962 L
.92008 .32962 L
.92108 .32962 L
.92208 .32962 L
.92308 .32962 L
.92408 .32962 L
.92507 .32962 L
.92607 .32962 L
.92707 .32962 L
.92807 .32962 L
.92907 .32962 L
.93007 .32962 L
.93107 .32962 L
.93207 .32962 L
.93307 .32962 L
.93407 .32962 L
.93506 .32962 L
.93606 .32962 L
.93706 .32962 L
.93806 .32962 L
.93906 .32962 L
.94006 .32962 L
.94106 .32962 L
.94206 .32962 L
.94306 .32962 L
.94406 .32962 L
.94505 .32962 L
.94605 .32962 L
.94705 .32962 L
.94805 .32962 L
Mistroke
.94905 .32962 L
.95005 .32962 L
.95105 .32962 L
.95205 .32962 L
.95305 .32962 L
.95405 .32962 L
.95504 .32962 L
.95604 .32962 L
.95704 .32962 L
.95804 .32962 L
.95904 .32962 L
.96004 .32962 L
.96104 .32962 L
.96204 .32962 L
.96304 .32962 L
.96404 .32962 L
.96503 .32962 L
.96603 .32962 L
.96703 .32962 L
.96803 .32962 L
.96903 .32962 L
.97003 .32962 L
.97103 .32962 L
.97203 .32962 L
.97303 .32962 L
.97403 .32962 L
.97502 .32962 L
.97602 .32962 L
.97702 .32962 L
.97802 .32962 L
.97902 .32962 L
.98002 .32962 L
.98102 .32962 L
.98202 .32962 L
.98302 .32962 L
.98402 .32962 L
.98501 .32962 L
.98601 .32962 L
.98701 .32962 L
.98801 .32962 L
.98901 .32962 L
.99001 .32962 L
.99101 .32962 L
.99201 .32962 L
.99301 .32962 L
.99401 .32962 L
.995 .32962 L
.996 .32962 L
.997 .32962 L
.998 .32962 L
Mistroke
.999 .32962 L
Mfstroke
0 .98 .604 r
gsave
.999 .1824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .29006 m
.001 .29006 L
.002 .29006 L
.003 .29006 L
.004 .29006 L
.005 .29006 L
.00599 .29006 L
.00699 .29006 L
.00799 .29006 L
.00899 .29006 L
.00999 .29006 L
.01099 .29006 L
.01199 .29006 L
.01299 .29006 L
.01399 .29006 L
.01499 .29006 L
.01598 .29006 L
.01698 .29006 L
.01798 .29006 L
.01898 .29006 L
.01998 .29006 L
.02098 .29006 L
.02198 .29006 L
.02298 .29006 L
.02398 .29006 L
.02498 .29006 L
.02597 .29006 L
.02697 .29006 L
.02797 .29006 L
.02897 .29006 L
.02997 .29006 L
.03097 .29006 L
.03197 .29006 L
.03297 .29006 L
.03397 .29006 L
.03497 .29006 L
.03596 .29006 L
.03696 .29006 L
.03796 .29006 L
.03896 .29006 L
.03996 .29006 L
.04096 .29006 L
.04196 .29006 L
.04296 .29006 L
.04396 .29006 L
.04496 .29006 L
.04595 .29006 L
.04695 .29006 L
.04795 .29006 L
.04895 .29006 L
Mistroke
.04995 .10036 L
.05095 .10036 L
.05195 .10036 L
.05295 .10036 L
.05395 .10036 L
.05495 .10036 L
.05594 .10036 L
.05694 .10036 L
.05794 .10036 L
.05894 .10036 L
.05994 .10036 L
.06094 .10036 L
.06194 .10036 L
.06294 .10036 L
.06394 .10036 L
.06494 .10036 L
.06593 .10036 L
.06693 .10036 L
.06793 .10036 L
.06893 .10036 L
.06993 .10036 L
.07093 .10036 L
.07193 .10036 L
.07293 .10036 L
.07393 .10036 L
.07493 .10036 L
.07592 .10036 L
.07692 .10036 L
.07792 .10036 L
.07892 .10036 L
.07992 .10036 L
.08092 .10036 L
.08192 .10036 L
.08292 .10036 L
.08392 .10036 L
.08492 .10036 L
.08591 .10036 L
.08691 .10036 L
.08791 .10036 L
.08891 .10036 L
.08991 .10036 L
.09091 .10036 L
.09191 .10036 L
.09291 .10036 L
.09391 .10036 L
.09491 .10036 L
.0959 .10036 L
.0969 .10036 L
.0979 .10036 L
.0989 .10036 L
Mistroke
.0999 .06817 L
.1009 .06817 L
.1019 .06817 L
.1029 .06817 L
.1039 .06817 L
.1049 .06817 L
.10589 .06817 L
.10689 .06817 L
.10789 .06817 L
.10889 .06817 L
.10989 .06817 L
.11089 .06817 L
.11189 .06817 L
.11289 .06817 L
.11389 .06817 L
.11489 .06817 L
.11588 .06817 L
.11688 .06817 L
.11788 .06817 L
.11888 .06817 L
.11988 .06817 L
.12088 .06817 L
.12188 .06817 L
.12288 .06817 L
.12388 .06817 L
.12488 .06817 L
.12587 .06817 L
.12687 .06817 L
.12787 .06817 L
.12887 .06817 L
.12987 .06817 L
.13087 .06817 L
.13187 .06817 L
.13287 .06817 L
.13387 .06817 L
.13487 .06817 L
.13586 .06817 L
.13686 .06817 L
.13786 .06817 L
.13886 .06817 L
.13986 .06817 L
.14086 .06817 L
.14186 .06817 L
.14286 .06817 L
.14386 .06817 L
.14486 .06817 L
.14585 .06817 L
.14685 .06817 L
.14785 .06817 L
.14885 .06817 L
Mistroke
.14985 .07111 L
.15085 .07111 L
.15185 .07111 L
.15285 .07111 L
.15385 .07111 L
.15485 .07111 L
.15584 .07111 L
.15684 .07111 L
.15784 .07111 L
.15884 .07111 L
.15984 .07111 L
.16084 .07111 L
.16184 .07111 L
.16284 .07111 L
.16384 .07111 L
.16484 .07111 L
.16583 .07111 L
.16683 .07111 L
.16783 .07111 L
.16883 .07111 L
.16983 .07111 L
.17083 .07111 L
.17183 .07111 L
.17283 .07111 L
.17383 .07111 L
.17483 .07111 L
.17582 .07111 L
.17682 .07111 L
.17782 .07111 L
.17882 .07111 L
.17982 .07111 L
.18082 .07111 L
.18182 .07111 L
.18282 .07111 L
.18382 .07111 L
.18482 .07111 L
.18581 .07111 L
.18681 .07111 L
.18781 .07111 L
.18881 .07111 L
.18981 .07111 L
.19081 .07111 L
.19181 .07111 L
.19281 .07111 L
.19381 .07111 L
.19481 .07111 L
.1958 .07111 L
.1968 .07111 L
.1978 .07111 L
.1988 .07111 L
Mistroke
.1998 .07633 L
.2008 .07633 L
.2018 .07633 L
.2028 .07633 L
.2038 .07633 L
.2048 .07633 L
.20579 .07633 L
.20679 .07633 L
.20779 .07633 L
.20879 .07633 L
.20979 .07633 L
.21079 .07633 L
.21179 .07633 L
.21279 .07633 L
.21379 .07633 L
.21479 .07633 L
.21578 .07633 L
.21678 .07633 L
.21778 .07633 L
.21878 .07633 L
.21978 .07633 L
.22078 .07633 L
.22178 .07633 L
.22278 .07633 L
.22378 .07633 L
.22478 .07633 L
.22577 .07633 L
.22677 .07633 L
.22777 .07633 L
.22877 .07633 L
.22977 .07633 L
.23077 .07633 L
.23177 .07633 L
.23277 .07633 L
.23377 .07633 L
.23477 .07633 L
.23576 .07633 L
.23676 .07633 L
.23776 .07633 L
.23876 .07633 L
.23976 .07633 L
.24076 .07633 L
.24176 .07633 L
.24276 .07633 L
.24376 .07633 L
.24476 .07633 L
.24575 .07633 L
.24675 .07633 L
.24775 .07633 L
.24875 .07633 L
Mistroke
.24975 .06969 L
.25075 .06969 L
.25175 .06969 L
.25275 .06969 L
.25375 .06969 L
.25475 .06969 L
.25574 .06969 L
.25674 .06969 L
.25774 .06969 L
.25874 .06969 L
.25974 .06969 L
.26074 .06969 L
.26174 .06969 L
.26274 .06969 L
.26374 .06969 L
.26474 .06969 L
.26573 .06969 L
.26673 .06969 L
.26773 .06969 L
.26873 .06969 L
.26973 .06969 L
.27073 .06969 L
.27173 .06969 L
.27273 .06969 L
.27373 .06969 L
.27473 .06969 L
.27572 .06969 L
.27672 .06969 L
.27772 .06969 L
.27872 .06969 L
.27972 .06969 L
.28072 .06969 L
.28172 .06969 L
.28272 .06969 L
.28372 .06969 L
.28472 .06969 L
.28571 .06969 L
.28671 .06969 L
.28771 .06969 L
.28871 .06969 L
.28971 .06969 L
.29071 .06969 L
.29171 .06969 L
.29271 .06969 L
.29371 .06969 L
.29471 .06969 L
.2957 .06969 L
.2967 .06969 L
.2977 .06969 L
.2987 .06969 L
Mistroke
.2997 .08589 L
.3007 .08589 L
.3017 .08589 L
.3027 .08589 L
.3037 .08589 L
.3047 .08589 L
.30569 .08589 L
.30669 .08589 L
.30769 .08589 L
.30869 .08589 L
.30969 .08589 L
.31069 .08589 L
.31169 .08589 L
.31269 .08589 L
.31369 .08589 L
.31469 .08589 L
.31568 .08589 L
.31668 .08589 L
.31768 .08589 L
.31868 .08589 L
.31968 .08589 L
.32068 .08589 L
.32168 .08589 L
.32268 .08589 L
.32368 .08589 L
.32468 .08589 L
.32567 .08589 L
.32667 .08589 L
.32767 .08589 L
.32867 .08589 L
.32967 .08589 L
.33067 .08589 L
.33167 .08589 L
.33267 .08589 L
.33367 .08589 L
.33467 .08589 L
.33566 .08589 L
.33666 .08589 L
.33766 .08589 L
.33866 .08589 L
.33966 .08589 L
.34066 .08589 L
.34166 .08589 L
.34266 .08589 L
.34366 .08589 L
.34466 .08589 L
.34565 .08589 L
.34665 .08589 L
.34765 .08589 L
.34865 .08589 L
Mistroke
.34965 .12829 L
.35065 .12829 L
.35165 .12829 L
.35265 .12829 L
.35365 .12829 L
.35465 .12829 L
.35564 .12829 L
.35664 .12829 L
.35764 .12829 L
.35864 .12829 L
.35964 .12829 L
.36064 .12829 L
.36164 .12829 L
.36264 .12829 L
.36364 .12829 L
.36464 .12829 L
.36563 .12829 L
.36663 .12829 L
.36763 .12829 L
.36863 .12829 L
.36963 .12829 L
.37063 .12829 L
.37163 .12829 L
.37263 .12829 L
.37363 .12829 L
.37463 .12829 L
.37562 .12829 L
.37662 .12829 L
.37762 .12829 L
.37862 .12829 L
.37962 .12829 L
.38062 .12829 L
.38162 .12829 L
.38262 .12829 L
.38362 .12829 L
.38462 .12829 L
.38561 .12829 L
.38661 .12829 L
.38761 .12829 L
.38861 .12829 L
.38961 .12829 L
.39061 .12829 L
.39161 .12829 L
.39261 .12829 L
.39361 .12829 L
.39461 .12829 L
.3956 .12829 L
.3966 .12829 L
.3976 .12829 L
.3986 .12829 L
Mistroke
.3996 .13611 L
.4006 .13611 L
.4016 .13611 L
.4026 .13611 L
.4036 .13611 L
.4046 .13611 L
.40559 .13611 L
.40659 .13611 L
.40759 .13611 L
.40859 .13611 L
.40959 .13611 L
.41059 .13611 L
.41159 .13611 L
.41259 .13611 L
.41359 .13611 L
.41459 .13611 L
.41558 .13611 L
.41658 .13611 L
.41758 .13611 L
.41858 .13611 L
.41958 .13611 L
.42058 .13611 L
.42158 .13611 L
.42258 .13611 L
.42358 .13611 L
.42458 .13611 L
.42557 .13611 L
.42657 .13611 L
.42757 .13611 L
.42857 .13611 L
.42957 .13611 L
.43057 .13611 L
.43157 .13611 L
.43257 .13611 L
.43357 .13611 L
.43457 .13611 L
.43556 .13611 L
.43656 .13611 L
.43756 .13611 L
.43856 .13611 L
.43956 .13611 L
.44056 .13611 L
.44156 .13611 L
.44256 .13611 L
.44356 .13611 L
.44456 .13611 L
.44555 .13611 L
.44655 .13611 L
.44755 .13611 L
.44855 .13611 L
Mistroke
.44955 .13628 L
.45055 .13628 L
.45155 .13628 L
.45255 .13628 L
.45355 .13628 L
.45455 .13628 L
.45554 .13628 L
.45654 .13628 L
.45754 .13628 L
.45854 .13628 L
.45954 .13628 L
.46054 .13628 L
.46154 .13628 L
.46254 .13628 L
.46354 .13628 L
.46454 .13628 L
.46553 .13628 L
.46653 .13628 L
.46753 .13628 L
.46853 .13628 L
.46953 .13628 L
.47053 .13628 L
.47153 .13628 L
.47253 .13628 L
.47353 .13628 L
.47453 .13628 L
.47552 .13628 L
.47652 .13628 L
.47752 .13628 L
.47852 .13628 L
.47952 .13628 L
.48052 .13628 L
.48152 .13628 L
.48252 .13628 L
.48352 .13628 L
.48452 .13628 L
.48551 .13628 L
.48651 .13628 L
.48751 .13628 L
.48851 .13628 L
.48951 .13628 L
.49051 .13628 L
.49151 .13628 L
.49251 .13628 L
.49351 .13628 L
.49451 .13628 L
.4955 .13628 L
.4965 .13628 L
.4975 .13628 L
.4985 .13628 L
Mistroke
.4995 .17245 L
.5005 .17245 L
.5015 .17245 L
.5025 .17245 L
.5035 .17245 L
.5045 .17245 L
.50549 .17245 L
.50649 .17245 L
.50749 .17245 L
.50849 .17245 L
.50949 .17245 L
.51049 .17245 L
.51149 .17245 L
.51249 .17245 L
.51349 .17245 L
.51449 .17245 L
.51548 .17245 L
.51648 .17245 L
.51748 .17245 L
.51848 .17245 L
.51948 .17245 L
.52048 .17245 L
.52148 .17245 L
.52248 .17245 L
.52348 .17245 L
.52448 .17245 L
.52547 .17245 L
.52647 .17245 L
.52747 .17245 L
.52847 .17245 L
.52947 .17245 L
.53047 .17245 L
.53147 .17245 L
.53247 .17245 L
.53347 .17245 L
.53447 .17245 L
.53546 .17245 L
.53646 .17245 L
.53746 .17245 L
.53846 .17245 L
.53946 .17245 L
.54046 .17245 L
.54146 .17245 L
.54246 .17245 L
.54346 .17245 L
.54446 .17245 L
.54545 .17245 L
.54645 .17245 L
.54745 .17245 L
.54845 .17245 L
Mistroke
.54945 .17022 L
.55045 .17022 L
.55145 .17022 L
.55245 .17022 L
.55345 .17022 L
.55445 .17022 L
.55544 .17022 L
.55644 .17022 L
.55744 .17022 L
.55844 .17022 L
.55944 .17022 L
.56044 .17022 L
.56144 .17022 L
.56244 .17022 L
.56344 .17022 L
.56444 .17022 L
.56543 .17022 L
.56643 .17022 L
.56743 .17022 L
.56843 .17022 L
.56943 .17022 L
.57043 .17022 L
.57143 .17022 L
.57243 .17022 L
.57343 .17022 L
.57443 .17022 L
.57542 .17022 L
.57642 .17022 L
.57742 .17022 L
.57842 .17022 L
.57942 .17022 L
.58042 .17022 L
.58142 .17022 L
.58242 .17022 L
.58342 .17022 L
.58442 .17022 L
.58541 .17022 L
.58641 .17022 L
.58741 .17022 L
.58841 .17022 L
.58941 .17022 L
.59041 .17022 L
.59141 .17022 L
.59241 .17022 L
.59341 .17022 L
.59441 .17022 L
.5954 .17022 L
.5964 .17022 L
.5974 .17022 L
.5984 .17022 L
Mistroke
.5994 .16095 L
.6004 .16095 L
.6014 .16095 L
.6024 .16095 L
.6034 .16095 L
.6044 .16095 L
.60539 .16095 L
.60639 .16095 L
.60739 .16095 L
.60839 .16095 L
.60939 .16095 L
.61039 .16095 L
.61139 .16095 L
.61239 .16095 L
.61339 .16095 L
.61439 .16095 L
.61538 .16095 L
.61638 .16095 L
.61738 .16095 L
.61838 .16095 L
.61938 .16095 L
.62038 .16095 L
.62138 .16095 L
.62238 .16095 L
.62338 .16095 L
.62438 .16095 L
.62537 .16095 L
.62637 .16095 L
.62737 .16095 L
.62837 .16095 L
.62937 .16095 L
.63037 .16095 L
.63137 .16095 L
.63237 .16095 L
.63337 .16095 L
.63437 .16095 L
.63536 .16095 L
.63636 .16095 L
.63736 .16095 L
.63836 .16095 L
.63936 .16095 L
.64036 .16095 L
.64136 .16095 L
.64236 .16095 L
.64336 .16095 L
.64436 .16095 L
.64535 .16095 L
.64635 .16095 L
.64735 .16095 L
.64835 .16095 L
Mistroke
.64935 .16181 L
.65035 .16181 L
.65135 .16181 L
.65235 .16181 L
.65335 .16181 L
.65435 .16181 L
.65534 .16181 L
.65634 .16181 L
.65734 .16181 L
.65834 .16181 L
.65934 .16181 L
.66034 .16181 L
.66134 .16181 L
.66234 .16181 L
.66334 .16181 L
.66434 .16181 L
.66533 .16181 L
.66633 .16181 L
.66733 .16181 L
.66833 .16181 L
.66933 .16181 L
.67033 .16181 L
.67133 .16181 L
.67233 .16181 L
.67333 .16181 L
.67433 .16181 L
.67532 .16181 L
.67632 .16181 L
.67732 .16181 L
.67832 .16181 L
.67932 .16181 L
.68032 .16181 L
.68132 .16181 L
.68232 .16181 L
.68332 .16181 L
.68432 .16181 L
.68531 .16181 L
.68631 .16181 L
.68731 .16181 L
.68831 .16181 L
.68931 .16181 L
.69031 .16181 L
.69131 .16181 L
.69231 .16181 L
.69331 .16181 L
.69431 .16181 L
.6953 .16181 L
.6963 .16181 L
.6973 .16181 L
.6983 .16181 L
Mistroke
.6993 .17278 L
.7003 .17278 L
.7013 .17278 L
.7023 .17278 L
.7033 .17278 L
.7043 .17278 L
.70529 .17278 L
.70629 .17278 L
.70729 .17278 L
.70829 .17278 L
.70929 .17278 L
.71029 .17278 L
.71129 .17278 L
.71229 .17278 L
.71329 .17278 L
.71429 .17278 L
.71528 .17278 L
.71628 .17278 L
.71728 .17278 L
.71828 .17278 L
.71928 .17278 L
.72028 .17278 L
.72128 .17278 L
.72228 .17278 L
.72328 .17278 L
.72428 .17278 L
.72527 .17278 L
.72627 .17278 L
.72727 .17278 L
.72827 .17278 L
.72927 .17278 L
.73027 .17278 L
.73127 .17278 L
.73227 .17278 L
.73327 .17278 L
.73427 .17278 L
.73526 .17278 L
.73626 .17278 L
.73726 .17278 L
.73826 .17278 L
.73926 .17278 L
.74026 .17278 L
.74126 .17278 L
.74226 .17278 L
.74326 .17278 L
.74426 .17278 L
.74525 .17278 L
.74625 .17278 L
.74725 .17278 L
.74825 .17278 L
Mistroke
.74925 .17235 L
.75025 .17235 L
.75125 .17235 L
.75225 .17235 L
.75325 .17235 L
.75425 .17235 L
.75524 .17235 L
.75624 .17235 L
.75724 .17235 L
.75824 .17235 L
.75924 .17235 L
.76024 .17235 L
.76124 .17235 L
.76224 .17235 L
.76324 .17235 L
.76424 .17235 L
.76523 .17235 L
.76623 .17235 L
.76723 .17235 L
.76823 .17235 L
.76923 .17235 L
.77023 .17235 L
.77123 .17235 L
.77223 .17235 L
.77323 .17235 L
.77423 .17235 L
.77522 .17235 L
.77622 .17235 L
.77722 .17235 L
.77822 .17235 L
.77922 .17235 L
.78022 .17235 L
.78122 .17235 L
.78222 .17235 L
.78322 .17235 L
.78422 .17235 L
.78521 .17235 L
.78621 .17235 L
.78721 .17235 L
.78821 .17235 L
.78921 .17235 L
.79021 .17235 L
.79121 .17235 L
.79221 .17235 L
.79321 .17235 L
.79421 .17235 L
.7952 .17235 L
.7962 .17235 L
.7972 .17235 L
.7982 .17235 L
Mistroke
.7992 .17436 L
.8002 .17436 L
.8012 .17436 L
.8022 .17436 L
.8032 .17436 L
.8042 .17436 L
.80519 .17436 L
.80619 .17436 L
.80719 .17436 L
.80819 .17436 L
.80919 .17436 L
.81019 .17436 L
.81119 .17436 L
.81219 .17436 L
.81319 .17436 L
.81419 .17436 L
.81518 .17436 L
.81618 .17436 L
.81718 .17436 L
.81818 .17436 L
.81918 .17436 L
.82018 .17436 L
.82118 .17436 L
.82218 .17436 L
.82318 .17436 L
.82418 .17436 L
.82517 .17436 L
.82617 .17436 L
.82717 .17436 L
.82817 .17436 L
.82917 .17436 L
.83017 .17436 L
.83117 .17436 L
.83217 .17436 L
.83317 .17436 L
.83417 .17436 L
.83516 .17436 L
.83616 .17436 L
.83716 .17436 L
.83816 .17436 L
.83916 .17436 L
.84016 .17436 L
.84116 .17436 L
.84216 .17436 L
.84316 .17436 L
.84416 .17436 L
.84515 .17436 L
.84615 .17436 L
.84715 .17436 L
.84815 .17436 L
Mistroke
.84915 .1959 L
.85015 .1959 L
.85115 .1959 L
.85215 .1959 L
.85315 .1959 L
.85415 .1959 L
.85514 .1959 L
.85614 .1959 L
.85714 .1959 L
.85814 .1959 L
.85914 .1959 L
.86014 .1959 L
.86114 .1959 L
.86214 .1959 L
.86314 .1959 L
.86414 .1959 L
.86513 .1959 L
.86613 .1959 L
.86713 .1959 L
.86813 .1959 L
.86913 .1959 L
.87013 .1959 L
.87113 .1959 L
.87213 .1959 L
.87313 .1959 L
.87413 .1959 L
.87512 .1959 L
.87612 .1959 L
.87712 .1959 L
.87812 .1959 L
.87912 .1959 L
.88012 .1959 L
.88112 .1959 L
.88212 .1959 L
.88312 .1959 L
.88412 .1959 L
.88511 .1959 L
.88611 .1959 L
.88711 .1959 L
.88811 .1959 L
.88911 .1959 L
.89011 .1959 L
.89111 .1959 L
.89211 .1959 L
.89311 .1959 L
.89411 .1959 L
.8951 .1959 L
.8961 .1959 L
.8971 .1959 L
.8981 .1959 L
Mistroke
.8991 .19856 L
.9001 .19856 L
.9011 .19856 L
.9021 .19856 L
.9031 .19856 L
.9041 .19856 L
.90509 .19856 L
.90609 .19856 L
.90709 .19856 L
.90809 .19856 L
.90909 .19856 L
.91009 .19856 L
.91109 .19856 L
.91209 .19856 L
.91309 .19856 L
.91409 .19856 L
.91508 .19856 L
.91608 .19856 L
.91708 .19856 L
.91808 .19856 L
.91908 .19856 L
.92008 .19856 L
.92108 .19856 L
.92208 .19856 L
.92308 .19856 L
.92408 .19856 L
.92507 .19856 L
.92607 .19856 L
.92707 .19856 L
.92807 .19856 L
.92907 .19856 L
.93007 .19856 L
.93107 .19856 L
.93207 .19856 L
.93307 .19856 L
.93407 .19856 L
.93506 .19856 L
.93606 .19856 L
.93706 .19856 L
.93806 .19856 L
.93906 .19856 L
.94006 .19856 L
.94106 .19856 L
.94206 .19856 L
.94306 .19856 L
.94406 .19856 L
.94505 .19856 L
.94605 .19856 L
.94705 .19856 L
.94805 .19856 L
Mistroke
.94905 .18892 L
.95005 .18892 L
.95105 .18892 L
.95205 .18892 L
.95305 .18892 L
.95405 .18892 L
.95504 .18892 L
.95604 .18892 L
.95704 .18892 L
.95804 .18892 L
.95904 .18892 L
.96004 .18892 L
.96104 .18892 L
.96204 .18892 L
.96304 .18892 L
.96404 .18892 L
.96503 .18892 L
.96603 .18892 L
.96703 .18892 L
.96803 .18892 L
.96903 .18892 L
.97003 .18892 L
.97103 .18892 L
.97203 .18892 L
.97303 .18892 L
.97403 .18892 L
.97502 .18892 L
.97602 .18892 L
.97702 .18892 L
.97802 .18892 L
.97902 .18892 L
.98002 .18892 L
.98102 .18892 L
.98202 .18892 L
.98302 .18892 L
.98402 .18892 L
.98501 .18892 L
.98601 .18892 L
.98701 .18892 L
.98801 .18892 L
.98901 .18892 L
.99001 .18892 L
.99101 .18892 L
.99201 .18892 L
.99301 .18892 L
.99401 .18892 L
.995 .18892 L
.996 .18892 L
.997 .18892 L
.998 .18892 L
Mistroke
.999 .1824 L
Mfstroke
gsave
.999 .25885 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .45158 m
.001 .45158 L
.002 .45158 L
.003 .45158 L
.004 .45158 L
.005 .45158 L
.00599 .45158 L
.00699 .45158 L
.00799 .45158 L
.00899 .45158 L
.00999 .45158 L
.01099 .45158 L
.01199 .45158 L
.01299 .45158 L
.01399 .45158 L
.01499 .45158 L
.01598 .45158 L
.01698 .45158 L
.01798 .45158 L
.01898 .45158 L
.01998 .45158 L
.02098 .45158 L
.02198 .45158 L
.02298 .45158 L
.02398 .45158 L
.02498 .45158 L
.02597 .45158 L
.02697 .45158 L
.02797 .45158 L
.02897 .45158 L
.02997 .45158 L
.03097 .45158 L
.03197 .45158 L
.03297 .45158 L
.03397 .45158 L
.03497 .45158 L
.03596 .45158 L
.03696 .45158 L
.03796 .45158 L
.03896 .45158 L
.03996 .45158 L
.04096 .45158 L
.04196 .45158 L
.04296 .45158 L
.04396 .45158 L
.04496 .45158 L
.04595 .45158 L
.04695 .45158 L
.04795 .45158 L
.04895 .45158 L
Mistroke
.04995 .25874 L
.05095 .25874 L
.05195 .25874 L
.05295 .25874 L
.05395 .25874 L
.05495 .25874 L
.05594 .25874 L
.05694 .25874 L
.05794 .25874 L
.05894 .25874 L
.05994 .25874 L
.06094 .25874 L
.06194 .25874 L
.06294 .25874 L
.06394 .25874 L
.06494 .25874 L
.06593 .25874 L
.06693 .25874 L
.06793 .25874 L
.06893 .25874 L
.06993 .25874 L
.07093 .25874 L
.07193 .25874 L
.07293 .25874 L
.07393 .25874 L
.07493 .25874 L
.07592 .25874 L
.07692 .25874 L
.07792 .25874 L
.07892 .25874 L
.07992 .25874 L
.08092 .25874 L
.08192 .25874 L
.08292 .25874 L
.08392 .25874 L
.08492 .25874 L
.08591 .25874 L
.08691 .25874 L
.08791 .25874 L
.08891 .25874 L
.08991 .25874 L
.09091 .25874 L
.09191 .25874 L
.09291 .25874 L
.09391 .25874 L
.09491 .25874 L
.0959 .25874 L
.0969 .25874 L
.0979 .25874 L
.0989 .25874 L
Mistroke
.0999 .22507 L
.1009 .22507 L
.1019 .22507 L
.1029 .22507 L
.1039 .22507 L
.1049 .22507 L
.10589 .22507 L
.10689 .22507 L
.10789 .22507 L
.10889 .22507 L
.10989 .22507 L
.11089 .22507 L
.11189 .22507 L
.11289 .22507 L
.11389 .22507 L
.11489 .22507 L
.11588 .22507 L
.11688 .22507 L
.11788 .22507 L
.11888 .22507 L
.11988 .22507 L
.12088 .22507 L
.12188 .22507 L
.12288 .22507 L
.12388 .22507 L
.12488 .22507 L
.12587 .22507 L
.12687 .22507 L
.12787 .22507 L
.12887 .22507 L
.12987 .22507 L
.13087 .22507 L
.13187 .22507 L
.13287 .22507 L
.13387 .22507 L
.13487 .22507 L
.13586 .22507 L
.13686 .22507 L
.13786 .22507 L
.13886 .22507 L
.13986 .22507 L
.14086 .22507 L
.14186 .22507 L
.14286 .22507 L
.14386 .22507 L
.14486 .22507 L
.14585 .22507 L
.14685 .22507 L
.14785 .22507 L
.14885 .22507 L
Mistroke
.14985 .21637 L
.15085 .21637 L
.15185 .21637 L
.15285 .21637 L
.15385 .21637 L
.15485 .21637 L
.15584 .21637 L
.15684 .21637 L
.15784 .21637 L
.15884 .21637 L
.15984 .21637 L
.16084 .21637 L
.16184 .21637 L
.16284 .21637 L
.16384 .21637 L
.16484 .21637 L
.16583 .21637 L
.16683 .21637 L
.16783 .21637 L
.16883 .21637 L
.16983 .21637 L
.17083 .21637 L
.17183 .21637 L
.17283 .21637 L
.17383 .21637 L
.17483 .21637 L
.17582 .21637 L
.17682 .21637 L
.17782 .21637 L
.17882 .21637 L
.17982 .21637 L
.18082 .21637 L
.18182 .21637 L
.18282 .21637 L
.18382 .21637 L
.18482 .21637 L
.18581 .21637 L
.18681 .21637 L
.18781 .21637 L
.18881 .21637 L
.18981 .21637 L
.19081 .21637 L
.19181 .21637 L
.19281 .21637 L
.19381 .21637 L
.19481 .21637 L
.1958 .21637 L
.1968 .21637 L
.1978 .21637 L
.1988 .21637 L
Mistroke
.1998 .22145 L
.2008 .22145 L
.2018 .22145 L
.2028 .22145 L
.2038 .22145 L
.2048 .22145 L
.20579 .22145 L
.20679 .22145 L
.20779 .22145 L
.20879 .22145 L
.20979 .22145 L
.21079 .22145 L
.21179 .22145 L
.21279 .22145 L
.21379 .22145 L
.21479 .22145 L
.21578 .22145 L
.21678 .22145 L
.21778 .22145 L
.21878 .22145 L
.21978 .22145 L
.22078 .22145 L
.22178 .22145 L
.22278 .22145 L
.22378 .22145 L
.22478 .22145 L
.22577 .22145 L
.22677 .22145 L
.22777 .22145 L
.22877 .22145 L
.22977 .22145 L
.23077 .22145 L
.23177 .22145 L
.23277 .22145 L
.23377 .22145 L
.23477 .22145 L
.23576 .22145 L
.23676 .22145 L
.23776 .22145 L
.23876 .22145 L
.23976 .22145 L
.24076 .22145 L
.24176 .22145 L
.24276 .22145 L
.24376 .22145 L
.24476 .22145 L
.24575 .22145 L
.24675 .22145 L
.24775 .22145 L
.24875 .22145 L
Mistroke
.24975 .20451 L
.25075 .20451 L
.25175 .20451 L
.25275 .20451 L
.25375 .20451 L
.25475 .20451 L
.25574 .20451 L
.25674 .20451 L
.25774 .20451 L
.25874 .20451 L
.25974 .20451 L
.26074 .20451 L
.26174 .20451 L
.26274 .20451 L
.26374 .20451 L
.26474 .20451 L
.26573 .20451 L
.26673 .20451 L
.26773 .20451 L
.26873 .20451 L
.26973 .20451 L
.27073 .20451 L
.27173 .20451 L
.27273 .20451 L
.27373 .20451 L
.27473 .20451 L
.27572 .20451 L
.27672 .20451 L
.27772 .20451 L
.27872 .20451 L
.27972 .20451 L
.28072 .20451 L
.28172 .20451 L
.28272 .20451 L
.28372 .20451 L
.28472 .20451 L
.28571 .20451 L
.28671 .20451 L
.28771 .20451 L
.28871 .20451 L
.28971 .20451 L
.29071 .20451 L
.29171 .20451 L
.29271 .20451 L
.29371 .20451 L
.29471 .20451 L
.2957 .20451 L
.2967 .20451 L
.2977 .20451 L
.2987 .20451 L
Mistroke
.2997 .21105 L
.3007 .21105 L
.3017 .21105 L
.3027 .21105 L
.3037 .21105 L
.3047 .21105 L
.30569 .21105 L
.30669 .21105 L
.30769 .21105 L
.30869 .21105 L
.30969 .21105 L
.31069 .21105 L
.31169 .21105 L
.31269 .21105 L
.31369 .21105 L
.31469 .21105 L
.31568 .21105 L
.31668 .21105 L
.31768 .21105 L
.31868 .21105 L
.31968 .21105 L
.32068 .21105 L
.32168 .21105 L
.32268 .21105 L
.32368 .21105 L
.32468 .21105 L
.32567 .21105 L
.32667 .21105 L
.32767 .21105 L
.32867 .21105 L
.32967 .21105 L
.33067 .21105 L
.33167 .21105 L
.33267 .21105 L
.33367 .21105 L
.33467 .21105 L
.33566 .21105 L
.33666 .21105 L
.33766 .21105 L
.33866 .21105 L
.33966 .21105 L
.34066 .21105 L
.34166 .21105 L
.34266 .21105 L
.34366 .21105 L
.34466 .21105 L
.34565 .21105 L
.34665 .21105 L
.34765 .21105 L
.34865 .21105 L
Mistroke
.34965 .24258 L
.35065 .24258 L
.35165 .24258 L
.35265 .24258 L
.35365 .24258 L
.35465 .24258 L
.35564 .24258 L
.35664 .24258 L
.35764 .24258 L
.35864 .24258 L
.35964 .24258 L
.36064 .24258 L
.36164 .24258 L
.36264 .24258 L
.36364 .24258 L
.36464 .24258 L
.36563 .24258 L
.36663 .24258 L
.36763 .24258 L
.36863 .24258 L
.36963 .24258 L
.37063 .24258 L
.37163 .24258 L
.37263 .24258 L
.37363 .24258 L
.37463 .24258 L
.37562 .24258 L
.37662 .24258 L
.37762 .24258 L
.37862 .24258 L
.37962 .24258 L
.38062 .24258 L
.38162 .24258 L
.38262 .24258 L
.38362 .24258 L
.38462 .24258 L
.38561 .24258 L
.38661 .24258 L
.38761 .24258 L
.38861 .24258 L
.38961 .24258 L
.39061 .24258 L
.39161 .24258 L
.39261 .24258 L
.39361 .24258 L
.39461 .24258 L
.3956 .24258 L
.3966 .24258 L
.3976 .24258 L
.3986 .24258 L
Mistroke
.3996 .2502 L
.4006 .2502 L
.4016 .2502 L
.4026 .2502 L
.4036 .2502 L
.4046 .2502 L
.40559 .2502 L
.40659 .2502 L
.40759 .2502 L
.40859 .2502 L
.40959 .2502 L
.41059 .2502 L
.41159 .2502 L
.41259 .2502 L
.41359 .2502 L
.41459 .2502 L
.41558 .2502 L
.41658 .2502 L
.41758 .2502 L
.41858 .2502 L
.41958 .2502 L
.42058 .2502 L
.42158 .2502 L
.42258 .2502 L
.42358 .2502 L
.42458 .2502 L
.42557 .2502 L
.42657 .2502 L
.42757 .2502 L
.42857 .2502 L
.42957 .2502 L
.43057 .2502 L
.43157 .2502 L
.43257 .2502 L
.43357 .2502 L
.43457 .2502 L
.43556 .2502 L
.43656 .2502 L
.43756 .2502 L
.43856 .2502 L
.43956 .2502 L
.44056 .2502 L
.44156 .2502 L
.44256 .2502 L
.44356 .2502 L
.44456 .2502 L
.44555 .2502 L
.44655 .2502 L
.44755 .2502 L
.44855 .2502 L
Mistroke
.44955 .24281 L
.45055 .24281 L
.45155 .24281 L
.45255 .24281 L
.45355 .24281 L
.45455 .24281 L
.45554 .24281 L
.45654 .24281 L
.45754 .24281 L
.45854 .24281 L
.45954 .24281 L
.46054 .24281 L
.46154 .24281 L
.46254 .24281 L
.46354 .24281 L
.46454 .24281 L
.46553 .24281 L
.46653 .24281 L
.46753 .24281 L
.46853 .24281 L
.46953 .24281 L
.47053 .24281 L
.47153 .24281 L
.47253 .24281 L
.47353 .24281 L
.47453 .24281 L
.47552 .24281 L
.47652 .24281 L
.47752 .24281 L
.47852 .24281 L
.47952 .24281 L
.48052 .24281 L
.48152 .24281 L
.48252 .24281 L
.48352 .24281 L
.48452 .24281 L
.48551 .24281 L
.48651 .24281 L
.48751 .24281 L
.48851 .24281 L
.48951 .24281 L
.49051 .24281 L
.49151 .24281 L
.49251 .24281 L
.49351 .24281 L
.49451 .24281 L
.4955 .24281 L
.4965 .24281 L
.4975 .24281 L
.4985 .24281 L
Mistroke
.4995 .27552 L
.5005 .27552 L
.5015 .27552 L
.5025 .27552 L
.5035 .27552 L
.5045 .27552 L
.50549 .27552 L
.50649 .27552 L
.50749 .27552 L
.50849 .27552 L
.50949 .27552 L
.51049 .27552 L
.51149 .27552 L
.51249 .27552 L
.51349 .27552 L
.51449 .27552 L
.51548 .27552 L
.51648 .27552 L
.51748 .27552 L
.51848 .27552 L
.51948 .27552 L
.52048 .27552 L
.52148 .27552 L
.52248 .27552 L
.52348 .27552 L
.52448 .27552 L
.52547 .27552 L
.52647 .27552 L
.52747 .27552 L
.52847 .27552 L
.52947 .27552 L
.53047 .27552 L
.53147 .27552 L
.53247 .27552 L
.53347 .27552 L
.53447 .27552 L
.53546 .27552 L
.53646 .27552 L
.53746 .27552 L
.53846 .27552 L
.53946 .27552 L
.54046 .27552 L
.54146 .27552 L
.54246 .27552 L
.54346 .27552 L
.54446 .27552 L
.54545 .27552 L
.54645 .27552 L
.54745 .27552 L
.54845 .27552 L
Mistroke
.54945 .27291 L
.55045 .27291 L
.55145 .27291 L
.55245 .27291 L
.55345 .27291 L
.55445 .27291 L
.55544 .27291 L
.55644 .27291 L
.55744 .27291 L
.55844 .27291 L
.55944 .27291 L
.56044 .27291 L
.56144 .27291 L
.56244 .27291 L
.56344 .27291 L
.56444 .27291 L
.56543 .27291 L
.56643 .27291 L
.56743 .27291 L
.56843 .27291 L
.56943 .27291 L
.57043 .27291 L
.57143 .27291 L
.57243 .27291 L
.57343 .27291 L
.57443 .27291 L
.57542 .27291 L
.57642 .27291 L
.57742 .27291 L
.57842 .27291 L
.57942 .27291 L
.58042 .27291 L
.58142 .27291 L
.58242 .27291 L
.58342 .27291 L
.58442 .27291 L
.58541 .27291 L
.58641 .27291 L
.58741 .27291 L
.58841 .27291 L
.58941 .27291 L
.59041 .27291 L
.59141 .27291 L
.59241 .27291 L
.59341 .27291 L
.59441 .27291 L
.5954 .27291 L
.5964 .27291 L
.5974 .27291 L
.5984 .27291 L
Mistroke
.5994 .25844 L
.6004 .25844 L
.6014 .25844 L
.6024 .25844 L
.6034 .25844 L
.6044 .25844 L
.60539 .25844 L
.60639 .25844 L
.60739 .25844 L
.60839 .25844 L
.60939 .25844 L
.61039 .25844 L
.61139 .25844 L
.61239 .25844 L
.61339 .25844 L
.61439 .25844 L
.61538 .25844 L
.61638 .25844 L
.61738 .25844 L
.61838 .25844 L
.61938 .25844 L
.62038 .25844 L
.62138 .25844 L
.62238 .25844 L
.62338 .25844 L
.62438 .25844 L
.62537 .25844 L
.62637 .25844 L
.62737 .25844 L
.62837 .25844 L
.62937 .25844 L
.63037 .25844 L
.63137 .25844 L
.63237 .25844 L
.63337 .25844 L
.63437 .25844 L
.63536 .25844 L
.63636 .25844 L
.63736 .25844 L
.63836 .25844 L
.63936 .25844 L
.64036 .25844 L
.64136 .25844 L
.64236 .25844 L
.64336 .25844 L
.64436 .25844 L
.64535 .25844 L
.64635 .25844 L
.64735 .25844 L
.64835 .25844 L
Mistroke
.64935 .25344 L
.65035 .25344 L
.65135 .25344 L
.65235 .25344 L
.65335 .25344 L
.65435 .25344 L
.65534 .25344 L
.65634 .25344 L
.65734 .25344 L
.65834 .25344 L
.65934 .25344 L
.66034 .25344 L
.66134 .25344 L
.66234 .25344 L
.66334 .25344 L
.66434 .25344 L
.66533 .25344 L
.66633 .25344 L
.66733 .25344 L
.66833 .25344 L
.66933 .25344 L
.67033 .25344 L
.67133 .25344 L
.67233 .25344 L
.67333 .25344 L
.67433 .25344 L
.67532 .25344 L
.67632 .25344 L
.67732 .25344 L
.67832 .25344 L
.67932 .25344 L
.68032 .25344 L
.68132 .25344 L
.68232 .25344 L
.68332 .25344 L
.68432 .25344 L
.68531 .25344 L
.68631 .25344 L
.68731 .25344 L
.68831 .25344 L
.68931 .25344 L
.69031 .25344 L
.69131 .25344 L
.69231 .25344 L
.69331 .25344 L
.69431 .25344 L
.6953 .25344 L
.6963 .25344 L
.6973 .25344 L
.6983 .25344 L
Mistroke
.6993 .25832 L
.7003 .25832 L
.7013 .25832 L
.7023 .25832 L
.7033 .25832 L
.7043 .25832 L
.70529 .25832 L
.70629 .25832 L
.70729 .25832 L
.70829 .25832 L
.70929 .25832 L
.71029 .25832 L
.71129 .25832 L
.71229 .25832 L
.71329 .25832 L
.71429 .25832 L
.71528 .25832 L
.71628 .25832 L
.71728 .25832 L
.71828 .25832 L
.71928 .25832 L
.72028 .25832 L
.72128 .25832 L
.72228 .25832 L
.72328 .25832 L
.72428 .25832 L
.72527 .25832 L
.72627 .25832 L
.72727 .25832 L
.72827 .25832 L
.72927 .25832 L
.73027 .25832 L
.73127 .25832 L
.73227 .25832 L
.73327 .25832 L
.73427 .25832 L
.73526 .25832 L
.73626 .25832 L
.73726 .25832 L
.73826 .25832 L
.73926 .25832 L
.74026 .25832 L
.74126 .25832 L
.74226 .25832 L
.74326 .25832 L
.74426 .25832 L
.74525 .25832 L
.74625 .25832 L
.74725 .25832 L
.74825 .25832 L
Mistroke
.74925 .25773 L
.75025 .25773 L
.75125 .25773 L
.75225 .25773 L
.75325 .25773 L
.75425 .25773 L
.75524 .25773 L
.75624 .25773 L
.75724 .25773 L
.75824 .25773 L
.75924 .25773 L
.76024 .25773 L
.76124 .25773 L
.76224 .25773 L
.76324 .25773 L
.76424 .25773 L
.76523 .25773 L
.76623 .25773 L
.76723 .25773 L
.76823 .25773 L
.76923 .25773 L
.77023 .25773 L
.77123 .25773 L
.77223 .25773 L
.77323 .25773 L
.77423 .25773 L
.77522 .25773 L
.77622 .25773 L
.77722 .25773 L
.77822 .25773 L
.77922 .25773 L
.78022 .25773 L
.78122 .25773 L
.78222 .25773 L
.78322 .25773 L
.78422 .25773 L
.78521 .25773 L
.78621 .25773 L
.78721 .25773 L
.78821 .25773 L
.78921 .25773 L
.79021 .25773 L
.79121 .25773 L
.79221 .25773 L
.79321 .25773 L
.79421 .25773 L
.7952 .25773 L
.7962 .25773 L
.7972 .25773 L
.7982 .25773 L
Mistroke
.7992 .25802 L
.8002 .25802 L
.8012 .25802 L
.8022 .25802 L
.8032 .25802 L
.8042 .25802 L
.80519 .25802 L
.80619 .25802 L
.80719 .25802 L
.80819 .25802 L
.80919 .25802 L
.81019 .25802 L
.81119 .25802 L
.81219 .25802 L
.81319 .25802 L
.81419 .25802 L
.81518 .25802 L
.81618 .25802 L
.81718 .25802 L
.81818 .25802 L
.81918 .25802 L
.82018 .25802 L
.82118 .25802 L
.82218 .25802 L
.82318 .25802 L
.82418 .25802 L
.82517 .25802 L
.82617 .25802 L
.82717 .25802 L
.82817 .25802 L
.82917 .25802 L
.83017 .25802 L
.83117 .25802 L
.83217 .25802 L
.83317 .25802 L
.83417 .25802 L
.83516 .25802 L
.83616 .25802 L
.83716 .25802 L
.83816 .25802 L
.83916 .25802 L
.84016 .25802 L
.84116 .25802 L
.84216 .25802 L
.84316 .25802 L
.84416 .25802 L
.84515 .25802 L
.84615 .25802 L
.84715 .25802 L
.84815 .25802 L
Mistroke
.84915 .27815 L
.85015 .27815 L
.85115 .27815 L
.85215 .27815 L
.85315 .27815 L
.85415 .27815 L
.85514 .27815 L
.85614 .27815 L
.85714 .27815 L
.85814 .27815 L
.85914 .27815 L
.86014 .27815 L
.86114 .27815 L
.86214 .27815 L
.86314 .27815 L
.86414 .27815 L
.86513 .27815 L
.86613 .27815 L
.86713 .27815 L
.86813 .27815 L
.86913 .27815 L
.87013 .27815 L
.87113 .27815 L
.87213 .27815 L
.87313 .27815 L
.87413 .27815 L
.87512 .27815 L
.87612 .27815 L
.87712 .27815 L
.87812 .27815 L
.87912 .27815 L
.88012 .27815 L
.88112 .27815 L
.88212 .27815 L
.88312 .27815 L
.88412 .27815 L
.88511 .27815 L
.88611 .27815 L
.88711 .27815 L
.88811 .27815 L
.88911 .27815 L
.89011 .27815 L
.89111 .27815 L
.89211 .27815 L
.89311 .27815 L
.89411 .27815 L
.8951 .27815 L
.8961 .27815 L
.8971 .27815 L
.8981 .27815 L
Mistroke
.8991 .28053 L
.9001 .28053 L
.9011 .28053 L
.9021 .28053 L
.9031 .28053 L
.9041 .28053 L
.90509 .28053 L
.90609 .28053 L
.90709 .28053 L
.90809 .28053 L
.90909 .28053 L
.91009 .28053 L
.91109 .28053 L
.91209 .28053 L
.91309 .28053 L
.91409 .28053 L
.91508 .28053 L
.91608 .28053 L
.91708 .28053 L
.91808 .28053 L
.91908 .28053 L
.92008 .28053 L
.92108 .28053 L
.92208 .28053 L
.92308 .28053 L
.92408 .28053 L
.92507 .28053 L
.92607 .28053 L
.92707 .28053 L
.92807 .28053 L
.92907 .28053 L
.93007 .28053 L
.93107 .28053 L
.93207 .28053 L
.93307 .28053 L
.93407 .28053 L
.93506 .28053 L
.93606 .28053 L
.93706 .28053 L
.93806 .28053 L
.93906 .28053 L
.94006 .28053 L
.94106 .28053 L
.94206 .28053 L
.94306 .28053 L
.94406 .28053 L
.94505 .28053 L
.94605 .28053 L
.94705 .28053 L
.94805 .28053 L
Mistroke
.94905 .2691 L
.95005 .2691 L
.95105 .2691 L
.95205 .2691 L
.95305 .2691 L
.95405 .2691 L
.95504 .2691 L
.95604 .2691 L
.95704 .2691 L
.95804 .2691 L
.95904 .2691 L
.96004 .2691 L
.96104 .2691 L
.96204 .2691 L
.96304 .2691 L
.96404 .2691 L
.96503 .2691 L
.96603 .2691 L
.96703 .2691 L
.96803 .2691 L
.96903 .2691 L
.97003 .2691 L
.97103 .2691 L
.97203 .2691 L
.97303 .2691 L
.97403 .2691 L
.97502 .2691 L
.97602 .2691 L
.97702 .2691 L
.97802 .2691 L
.97902 .2691 L
.98002 .2691 L
.98102 .2691 L
.98202 .2691 L
.98302 .2691 L
.98402 .2691 L
.98501 .2691 L
.98601 .2691 L
.98701 .2691 L
.98801 .2691 L
.98901 .2691 L
.99001 .2691 L
.99101 .2691 L
.99201 .2691 L
.99301 .2691 L
.99401 .2691 L
.995 .2691 L
.996 .2691 L
.997 .2691 L
.998 .2691 L
Mistroke
.999 .25885 L
Mfstroke
1 0 0 r
gsave
.999 .22062 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37082 m
.001 .37082 L
.002 .37082 L
.003 .37082 L
.004 .37082 L
.005 .37082 L
.00599 .37082 L
.00699 .37082 L
.00799 .37082 L
.00899 .37082 L
.00999 .37082 L
.01099 .37082 L
.01199 .37082 L
.01299 .37082 L
.01399 .37082 L
.01499 .37082 L
.01598 .37082 L
.01698 .37082 L
.01798 .37082 L
.01898 .37082 L
.01998 .37082 L
.02098 .37082 L
.02198 .37082 L
.02298 .37082 L
.02398 .37082 L
.02498 .37082 L
.02597 .37082 L
.02697 .37082 L
.02797 .37082 L
.02897 .37082 L
.02997 .37082 L
.03097 .37082 L
.03197 .37082 L
.03297 .37082 L
.03397 .37082 L
.03497 .37082 L
.03596 .37082 L
.03696 .37082 L
.03796 .37082 L
.03896 .37082 L
.03996 .37082 L
.04096 .37082 L
.04196 .37082 L
.04296 .37082 L
.04396 .37082 L
.04496 .37082 L
.04595 .37082 L
.04695 .37082 L
.04795 .37082 L
.04895 .37082 L
Mistroke
.04995 .17955 L
.05095 .17955 L
.05195 .17955 L
.05295 .17955 L
.05395 .17955 L
.05495 .17955 L
.05594 .17955 L
.05694 .17955 L
.05794 .17955 L
.05894 .17955 L
.05994 .17955 L
.06094 .17955 L
.06194 .17955 L
.06294 .17955 L
.06394 .17955 L
.06494 .17955 L
.06593 .17955 L
.06693 .17955 L
.06793 .17955 L
.06893 .17955 L
.06993 .17955 L
.07093 .17955 L
.07193 .17955 L
.07293 .17955 L
.07393 .17955 L
.07493 .17955 L
.07592 .17955 L
.07692 .17955 L
.07792 .17955 L
.07892 .17955 L
.07992 .17955 L
.08092 .17955 L
.08192 .17955 L
.08292 .17955 L
.08392 .17955 L
.08492 .17955 L
.08591 .17955 L
.08691 .17955 L
.08791 .17955 L
.08891 .17955 L
.08991 .17955 L
.09091 .17955 L
.09191 .17955 L
.09291 .17955 L
.09391 .17955 L
.09491 .17955 L
.0959 .17955 L
.0969 .17955 L
.0979 .17955 L
.0989 .17955 L
Mistroke
.0999 .14662 L
.1009 .14662 L
.1019 .14662 L
.1029 .14662 L
.1039 .14662 L
.1049 .14662 L
.10589 .14662 L
.10689 .14662 L
.10789 .14662 L
.10889 .14662 L
.10989 .14662 L
.11089 .14662 L
.11189 .14662 L
.11289 .14662 L
.11389 .14662 L
.11489 .14662 L
.11588 .14662 L
.11688 .14662 L
.11788 .14662 L
.11888 .14662 L
.11988 .14662 L
.12088 .14662 L
.12188 .14662 L
.12288 .14662 L
.12388 .14662 L
.12488 .14662 L
.12587 .14662 L
.12687 .14662 L
.12787 .14662 L
.12887 .14662 L
.12987 .14662 L
.13087 .14662 L
.13187 .14662 L
.13287 .14662 L
.13387 .14662 L
.13487 .14662 L
.13586 .14662 L
.13686 .14662 L
.13786 .14662 L
.13886 .14662 L
.13986 .14662 L
.14086 .14662 L
.14186 .14662 L
.14286 .14662 L
.14386 .14662 L
.14486 .14662 L
.14585 .14662 L
.14685 .14662 L
.14785 .14662 L
.14885 .14662 L
Mistroke
.14985 .14374 L
.15085 .14374 L
.15185 .14374 L
.15285 .14374 L
.15385 .14374 L
.15485 .14374 L
.15584 .14374 L
.15684 .14374 L
.15784 .14374 L
.15884 .14374 L
.15984 .14374 L
.16084 .14374 L
.16184 .14374 L
.16284 .14374 L
.16384 .14374 L
.16484 .14374 L
.16583 .14374 L
.16683 .14374 L
.16783 .14374 L
.16883 .14374 L
.16983 .14374 L
.17083 .14374 L
.17183 .14374 L
.17283 .14374 L
.17383 .14374 L
.17483 .14374 L
.17582 .14374 L
.17682 .14374 L
.17782 .14374 L
.17882 .14374 L
.17982 .14374 L
.18082 .14374 L
.18182 .14374 L
.18282 .14374 L
.18382 .14374 L
.18482 .14374 L
.18581 .14374 L
.18681 .14374 L
.18781 .14374 L
.18881 .14374 L
.18981 .14374 L
.19081 .14374 L
.19181 .14374 L
.19281 .14374 L
.19381 .14374 L
.19481 .14374 L
.1958 .14374 L
.1968 .14374 L
.1978 .14374 L
.1988 .14374 L
Mistroke
.1998 .14889 L
.2008 .14889 L
.2018 .14889 L
.2028 .14889 L
.2038 .14889 L
.2048 .14889 L
.20579 .14889 L
.20679 .14889 L
.20779 .14889 L
.20879 .14889 L
.20979 .14889 L
.21079 .14889 L
.21179 .14889 L
.21279 .14889 L
.21379 .14889 L
.21479 .14889 L
.21578 .14889 L
.21678 .14889 L
.21778 .14889 L
.21878 .14889 L
.21978 .14889 L
.22078 .14889 L
.22178 .14889 L
.22278 .14889 L
.22378 .14889 L
.22478 .14889 L
.22577 .14889 L
.22677 .14889 L
.22777 .14889 L
.22877 .14889 L
.22977 .14889 L
.23077 .14889 L
.23177 .14889 L
.23277 .14889 L
.23377 .14889 L
.23477 .14889 L
.23576 .14889 L
.23676 .14889 L
.23776 .14889 L
.23876 .14889 L
.23976 .14889 L
.24076 .14889 L
.24176 .14889 L
.24276 .14889 L
.24376 .14889 L
.24476 .14889 L
.24575 .14889 L
.24675 .14889 L
.24775 .14889 L
.24875 .14889 L
Mistroke
.24975 .1371 L
.25075 .1371 L
.25175 .1371 L
.25275 .1371 L
.25375 .1371 L
.25475 .1371 L
.25574 .1371 L
.25674 .1371 L
.25774 .1371 L
.25874 .1371 L
.25974 .1371 L
.26074 .1371 L
.26174 .1371 L
.26274 .1371 L
.26374 .1371 L
.26474 .1371 L
.26573 .1371 L
.26673 .1371 L
.26773 .1371 L
.26873 .1371 L
.26973 .1371 L
.27073 .1371 L
.27173 .1371 L
.27273 .1371 L
.27373 .1371 L
.27473 .1371 L
.27572 .1371 L
.27672 .1371 L
.27772 .1371 L
.27872 .1371 L
.27972 .1371 L
.28072 .1371 L
.28172 .1371 L
.28272 .1371 L
.28372 .1371 L
.28472 .1371 L
.28571 .1371 L
.28671 .1371 L
.28771 .1371 L
.28871 .1371 L
.28971 .1371 L
.29071 .1371 L
.29171 .1371 L
.29271 .1371 L
.29371 .1371 L
.29471 .1371 L
.2957 .1371 L
.2967 .1371 L
.2977 .1371 L
.2987 .1371 L
Mistroke
.2997 .14847 L
.3007 .14847 L
.3017 .14847 L
.3027 .14847 L
.3037 .14847 L
.3047 .14847 L
.30569 .14847 L
.30669 .14847 L
.30769 .14847 L
.30869 .14847 L
.30969 .14847 L
.31069 .14847 L
.31169 .14847 L
.31269 .14847 L
.31369 .14847 L
.31469 .14847 L
.31568 .14847 L
.31668 .14847 L
.31768 .14847 L
.31868 .14847 L
.31968 .14847 L
.32068 .14847 L
.32168 .14847 L
.32268 .14847 L
.32368 .14847 L
.32468 .14847 L
.32567 .14847 L
.32667 .14847 L
.32767 .14847 L
.32867 .14847 L
.32967 .14847 L
.33067 .14847 L
.33167 .14847 L
.33267 .14847 L
.33367 .14847 L
.33467 .14847 L
.33566 .14847 L
.33666 .14847 L
.33766 .14847 L
.33866 .14847 L
.33966 .14847 L
.34066 .14847 L
.34166 .14847 L
.34266 .14847 L
.34366 .14847 L
.34466 .14847 L
.34565 .14847 L
.34665 .14847 L
.34765 .14847 L
.34865 .14847 L
Mistroke
.34965 .18543 L
.35065 .18543 L
.35165 .18543 L
.35265 .18543 L
.35365 .18543 L
.35465 .18543 L
.35564 .18543 L
.35664 .18543 L
.35764 .18543 L
.35864 .18543 L
.35964 .18543 L
.36064 .18543 L
.36164 .18543 L
.36264 .18543 L
.36364 .18543 L
.36464 .18543 L
.36563 .18543 L
.36663 .18543 L
.36763 .18543 L
.36863 .18543 L
.36963 .18543 L
.37063 .18543 L
.37163 .18543 L
.37263 .18543 L
.37363 .18543 L
.37463 .18543 L
.37562 .18543 L
.37662 .18543 L
.37762 .18543 L
.37862 .18543 L
.37962 .18543 L
.38062 .18543 L
.38162 .18543 L
.38262 .18543 L
.38362 .18543 L
.38462 .18543 L
.38561 .18543 L
.38661 .18543 L
.38761 .18543 L
.38861 .18543 L
.38961 .18543 L
.39061 .18543 L
.39161 .18543 L
.39261 .18543 L
.39361 .18543 L
.39461 .18543 L
.3956 .18543 L
.3966 .18543 L
.3976 .18543 L
.3986 .18543 L
Mistroke
.3996 .19315 L
.4006 .19315 L
.4016 .19315 L
.4026 .19315 L
.4036 .19315 L
.4046 .19315 L
.40559 .19315 L
.40659 .19315 L
.40759 .19315 L
.40859 .19315 L
.40959 .19315 L
.41059 .19315 L
.41159 .19315 L
.41259 .19315 L
.41359 .19315 L
.41459 .19315 L
.41558 .19315 L
.41658 .19315 L
.41758 .19315 L
.41858 .19315 L
.41958 .19315 L
.42058 .19315 L
.42158 .19315 L
.42258 .19315 L
.42358 .19315 L
.42458 .19315 L
.42557 .19315 L
.42657 .19315 L
.42757 .19315 L
.42857 .19315 L
.42957 .19315 L
.43057 .19315 L
.43157 .19315 L
.43257 .19315 L
.43357 .19315 L
.43457 .19315 L
.43556 .19315 L
.43656 .19315 L
.43756 .19315 L
.43856 .19315 L
.43956 .19315 L
.44056 .19315 L
.44156 .19315 L
.44256 .19315 L
.44356 .19315 L
.44456 .19315 L
.44555 .19315 L
.44655 .19315 L
.44755 .19315 L
.44855 .19315 L
Mistroke
.44955 .18955 L
.45055 .18955 L
.45155 .18955 L
.45255 .18955 L
.45355 .18955 L
.45455 .18955 L
.45554 .18955 L
.45654 .18955 L
.45754 .18955 L
.45854 .18955 L
.45954 .18955 L
.46054 .18955 L
.46154 .18955 L
.46254 .18955 L
.46354 .18955 L
.46454 .18955 L
.46553 .18955 L
.46653 .18955 L
.46753 .18955 L
.46853 .18955 L
.46953 .18955 L
.47053 .18955 L
.47153 .18955 L
.47253 .18955 L
.47353 .18955 L
.47453 .18955 L
.47552 .18955 L
.47652 .18955 L
.47752 .18955 L
.47852 .18955 L
.47952 .18955 L
.48052 .18955 L
.48152 .18955 L
.48252 .18955 L
.48352 .18955 L
.48452 .18955 L
.48551 .18955 L
.48651 .18955 L
.48751 .18955 L
.48851 .18955 L
.48951 .18955 L
.49051 .18955 L
.49151 .18955 L
.49251 .18955 L
.49351 .18955 L
.49451 .18955 L
.4955 .18955 L
.4965 .18955 L
.4975 .18955 L
.4985 .18955 L
Mistroke
.4995 .22399 L
.5005 .22399 L
.5015 .22399 L
.5025 .22399 L
.5035 .22399 L
.5045 .22399 L
.50549 .22399 L
.50649 .22399 L
.50749 .22399 L
.50849 .22399 L
.50949 .22399 L
.51049 .22399 L
.51149 .22399 L
.51249 .22399 L
.51349 .22399 L
.51449 .22399 L
.51548 .22399 L
.51648 .22399 L
.51748 .22399 L
.51848 .22399 L
.51948 .22399 L
.52048 .22399 L
.52148 .22399 L
.52248 .22399 L
.52348 .22399 L
.52448 .22399 L
.52547 .22399 L
.52647 .22399 L
.52747 .22399 L
.52847 .22399 L
.52947 .22399 L
.53047 .22399 L
.53147 .22399 L
.53247 .22399 L
.53347 .22399 L
.53447 .22399 L
.53546 .22399 L
.53646 .22399 L
.53746 .22399 L
.53846 .22399 L
.53946 .22399 L
.54046 .22399 L
.54146 .22399 L
.54246 .22399 L
.54346 .22399 L
.54446 .22399 L
.54545 .22399 L
.54645 .22399 L
.54745 .22399 L
.54845 .22399 L
Mistroke
.54945 .22157 L
.55045 .22157 L
.55145 .22157 L
.55245 .22157 L
.55345 .22157 L
.55445 .22157 L
.55544 .22157 L
.55644 .22157 L
.55744 .22157 L
.55844 .22157 L
.55944 .22157 L
.56044 .22157 L
.56144 .22157 L
.56244 .22157 L
.56344 .22157 L
.56444 .22157 L
.56543 .22157 L
.56643 .22157 L
.56743 .22157 L
.56843 .22157 L
.56943 .22157 L
.57043 .22157 L
.57143 .22157 L
.57243 .22157 L
.57343 .22157 L
.57443 .22157 L
.57542 .22157 L
.57642 .22157 L
.57742 .22157 L
.57842 .22157 L
.57942 .22157 L
.58042 .22157 L
.58142 .22157 L
.58242 .22157 L
.58342 .22157 L
.58442 .22157 L
.58541 .22157 L
.58641 .22157 L
.58741 .22157 L
.58841 .22157 L
.58941 .22157 L
.59041 .22157 L
.59141 .22157 L
.59241 .22157 L
.59341 .22157 L
.59441 .22157 L
.5954 .22157 L
.5964 .22157 L
.5974 .22157 L
.5984 .22157 L
Mistroke
.5994 .20969 L
.6004 .20969 L
.6014 .20969 L
.6024 .20969 L
.6034 .20969 L
.6044 .20969 L
.60539 .20969 L
.60639 .20969 L
.60739 .20969 L
.60839 .20969 L
.60939 .20969 L
.61039 .20969 L
.61139 .20969 L
.61239 .20969 L
.61339 .20969 L
.61439 .20969 L
.61538 .20969 L
.61638 .20969 L
.61738 .20969 L
.61838 .20969 L
.61938 .20969 L
.62038 .20969 L
.62138 .20969 L
.62238 .20969 L
.62338 .20969 L
.62438 .20969 L
.62537 .20969 L
.62637 .20969 L
.62737 .20969 L
.62837 .20969 L
.62937 .20969 L
.63037 .20969 L
.63137 .20969 L
.63237 .20969 L
.63337 .20969 L
.63437 .20969 L
.63536 .20969 L
.63636 .20969 L
.63736 .20969 L
.63836 .20969 L
.63936 .20969 L
.64036 .20969 L
.64136 .20969 L
.64236 .20969 L
.64336 .20969 L
.64436 .20969 L
.64535 .20969 L
.64635 .20969 L
.64735 .20969 L
.64835 .20969 L
Mistroke
.64935 .20763 L
.65035 .20763 L
.65135 .20763 L
.65235 .20763 L
.65335 .20763 L
.65435 .20763 L
.65534 .20763 L
.65634 .20763 L
.65734 .20763 L
.65834 .20763 L
.65934 .20763 L
.66034 .20763 L
.66134 .20763 L
.66234 .20763 L
.66334 .20763 L
.66434 .20763 L
.66533 .20763 L
.66633 .20763 L
.66733 .20763 L
.66833 .20763 L
.66933 .20763 L
.67033 .20763 L
.67133 .20763 L
.67233 .20763 L
.67333 .20763 L
.67433 .20763 L
.67532 .20763 L
.67632 .20763 L
.67732 .20763 L
.67832 .20763 L
.67932 .20763 L
.68032 .20763 L
.68132 .20763 L
.68232 .20763 L
.68332 .20763 L
.68432 .20763 L
.68531 .20763 L
.68631 .20763 L
.68731 .20763 L
.68831 .20763 L
.68931 .20763 L
.69031 .20763 L
.69131 .20763 L
.69231 .20763 L
.69331 .20763 L
.69431 .20763 L
.6953 .20763 L
.6963 .20763 L
.6973 .20763 L
.6983 .20763 L
Mistroke
.6993 .21555 L
.7003 .21555 L
.7013 .21555 L
.7023 .21555 L
.7033 .21555 L
.7043 .21555 L
.70529 .21555 L
.70629 .21555 L
.70729 .21555 L
.70829 .21555 L
.70929 .21555 L
.71029 .21555 L
.71129 .21555 L
.71229 .21555 L
.71329 .21555 L
.71429 .21555 L
.71528 .21555 L
.71628 .21555 L
.71728 .21555 L
.71828 .21555 L
.71928 .21555 L
.72028 .21555 L
.72128 .21555 L
.72228 .21555 L
.72328 .21555 L
.72428 .21555 L
.72527 .21555 L
.72627 .21555 L
.72727 .21555 L
.72827 .21555 L
.72927 .21555 L
.73027 .21555 L
.73127 .21555 L
.73227 .21555 L
.73327 .21555 L
.73427 .21555 L
.73526 .21555 L
.73626 .21555 L
.73726 .21555 L
.73826 .21555 L
.73926 .21555 L
.74026 .21555 L
.74126 .21555 L
.74226 .21555 L
.74326 .21555 L
.74426 .21555 L
.74525 .21555 L
.74625 .21555 L
.74725 .21555 L
.74825 .21555 L
Mistroke
.74925 .21504 L
.75025 .21504 L
.75125 .21504 L
.75225 .21504 L
.75325 .21504 L
.75425 .21504 L
.75524 .21504 L
.75624 .21504 L
.75724 .21504 L
.75824 .21504 L
.75924 .21504 L
.76024 .21504 L
.76124 .21504 L
.76224 .21504 L
.76324 .21504 L
.76424 .21504 L
.76523 .21504 L
.76623 .21504 L
.76723 .21504 L
.76823 .21504 L
.76923 .21504 L
.77023 .21504 L
.77123 .21504 L
.77223 .21504 L
.77323 .21504 L
.77423 .21504 L
.77522 .21504 L
.77622 .21504 L
.77722 .21504 L
.77822 .21504 L
.77922 .21504 L
.78022 .21504 L
.78122 .21504 L
.78222 .21504 L
.78322 .21504 L
.78422 .21504 L
.78521 .21504 L
.78621 .21504 L
.78721 .21504 L
.78821 .21504 L
.78921 .21504 L
.79021 .21504 L
.79121 .21504 L
.79221 .21504 L
.79321 .21504 L
.79421 .21504 L
.7952 .21504 L
.7962 .21504 L
.7972 .21504 L
.7982 .21504 L
Mistroke
.7992 .21619 L
.8002 .21619 L
.8012 .21619 L
.8022 .21619 L
.8032 .21619 L
.8042 .21619 L
.80519 .21619 L
.80619 .21619 L
.80719 .21619 L
.80819 .21619 L
.80919 .21619 L
.81019 .21619 L
.81119 .21619 L
.81219 .21619 L
.81319 .21619 L
.81419 .21619 L
.81518 .21619 L
.81618 .21619 L
.81718 .21619 L
.81818 .21619 L
.81918 .21619 L
.82018 .21619 L
.82118 .21619 L
.82218 .21619 L
.82318 .21619 L
.82418 .21619 L
.82517 .21619 L
.82617 .21619 L
.82717 .21619 L
.82817 .21619 L
.82917 .21619 L
.83017 .21619 L
.83117 .21619 L
.83217 .21619 L
.83317 .21619 L
.83417 .21619 L
.83516 .21619 L
.83616 .21619 L
.83716 .21619 L
.83816 .21619 L
.83916 .21619 L
.84016 .21619 L
.84116 .21619 L
.84216 .21619 L
.84316 .21619 L
.84416 .21619 L
.84515 .21619 L
.84615 .21619 L
.84715 .21619 L
.84815 .21619 L
Mistroke
.84915 .23703 L
.85015 .23703 L
.85115 .23703 L
.85215 .23703 L
.85315 .23703 L
.85415 .23703 L
.85514 .23703 L
.85614 .23703 L
.85714 .23703 L
.85814 .23703 L
.85914 .23703 L
.86014 .23703 L
.86114 .23703 L
.86214 .23703 L
.86314 .23703 L
.86414 .23703 L
.86513 .23703 L
.86613 .23703 L
.86713 .23703 L
.86813 .23703 L
.86913 .23703 L
.87013 .23703 L
.87113 .23703 L
.87213 .23703 L
.87313 .23703 L
.87413 .23703 L
.87512 .23703 L
.87612 .23703 L
.87712 .23703 L
.87812 .23703 L
.87912 .23703 L
.88012 .23703 L
.88112 .23703 L
.88212 .23703 L
.88312 .23703 L
.88412 .23703 L
.88511 .23703 L
.88611 .23703 L
.88711 .23703 L
.88811 .23703 L
.88911 .23703 L
.89011 .23703 L
.89111 .23703 L
.89211 .23703 L
.89311 .23703 L
.89411 .23703 L
.8951 .23703 L
.8961 .23703 L
.8971 .23703 L
.8981 .23703 L
Mistroke
.8991 .23955 L
.9001 .23955 L
.9011 .23955 L
.9021 .23955 L
.9031 .23955 L
.9041 .23955 L
.90509 .23955 L
.90609 .23955 L
.90709 .23955 L
.90809 .23955 L
.90909 .23955 L
.91009 .23955 L
.91109 .23955 L
.91209 .23955 L
.91309 .23955 L
.91409 .23955 L
.91508 .23955 L
.91608 .23955 L
.91708 .23955 L
.91808 .23955 L
.91908 .23955 L
.92008 .23955 L
.92108 .23955 L
.92208 .23955 L
.92308 .23955 L
.92408 .23955 L
.92507 .23955 L
.92607 .23955 L
.92707 .23955 L
.92807 .23955 L
.92907 .23955 L
.93007 .23955 L
.93107 .23955 L
.93207 .23955 L
.93307 .23955 L
.93407 .23955 L
.93506 .23955 L
.93606 .23955 L
.93706 .23955 L
.93806 .23955 L
.93906 .23955 L
.94006 .23955 L
.94106 .23955 L
.94206 .23955 L
.94306 .23955 L
.94406 .23955 L
.94505 .23955 L
.94605 .23955 L
.94705 .23955 L
.94805 .23955 L
Mistroke
.94905 .22901 L
.95005 .22901 L
.95105 .22901 L
.95205 .22901 L
.95305 .22901 L
.95405 .22901 L
.95504 .22901 L
.95604 .22901 L
.95704 .22901 L
.95804 .22901 L
.95904 .22901 L
.96004 .22901 L
.96104 .22901 L
.96204 .22901 L
.96304 .22901 L
.96404 .22901 L
.96503 .22901 L
.96603 .22901 L
.96703 .22901 L
.96803 .22901 L
.96903 .22901 L
.97003 .22901 L
.97103 .22901 L
.97203 .22901 L
.97303 .22901 L
.97403 .22901 L
.97502 .22901 L
.97602 .22901 L
.97702 .22901 L
.97802 .22901 L
.97902 .22901 L
.98002 .22901 L
.98102 .22901 L
.98202 .22901 L
.98302 .22901 L
.98402 .22901 L
.98501 .22901 L
.98601 .22901 L
.98701 .22901 L
.98801 .22901 L
.98901 .22901 L
.99001 .22901 L
.99101 .22901 L
.99201 .22901 L
.99301 .22901 L
.99401 .22901 L
.995 .22901 L
.996 .22901 L
.997 .22901 L
.998 .22901 L
Mistroke
.999 .22062 L
Mfstroke
0 0 1 r
gsave
.001 -1.03006 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0 0.0772542 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -6 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -6 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -6 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -6 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -6 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(1)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(2)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(3)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(4)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(6)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(7)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .20601 m
.001 .20601 L
.002 .20601 L
.003 .20601 L
.004 .20601 L
.005 .20601 L
.00599 .20601 L
.00699 .20601 L
.00799 .20601 L
.00899 .20601 L
.00999 .20601 L
.01099 .20601 L
.01199 .20601 L
.01299 .20601 L
.01399 .20601 L
.01499 .20601 L
.01598 .20601 L
.01698 .20601 L
.01798 .20602 L
.01898 .20602 L
.01998 .20602 L
.02098 .20602 L
.02198 .20602 L
.02298 .20602 L
.02398 .20602 L
.02498 .20602 L
.02597 .20602 L
.02697 .20602 L
.02797 .20602 L
.02897 .20602 L
.02997 .20602 L
.03097 .20602 L
.03197 .20602 L
.03297 .20602 L
.03397 .20602 L
.03497 .20602 L
.03596 .20602 L
.03696 .20602 L
.03796 .20602 L
.03896 .20602 L
.03996 .20602 L
.04096 .20602 L
.04196 .20602 L
.04296 .20602 L
.04396 .20602 L
.04496 .20602 L
.04595 .20602 L
.04695 .20602 L
.04795 .20602 L
.04895 .20602 L
Mistroke
.04995 .20602 L
.05095 .20602 L
.05195 .20602 L
.05295 .20602 L
.05395 .20601 L
.05495 .20602 L
.05594 .20602 L
.05694 .20602 L
.05794 .20602 L
.05894 .20602 L
.05994 .20602 L
.06094 .20601 L
.06194 .20602 L
.06294 .20602 L
.06394 .20602 L
.06494 .20602 L
.06593 .20602 L
.06693 .20602 L
.06793 .20602 L
.06893 .20602 L
.06993 .20602 L
.07093 .20602 L
.07193 .20602 L
.07293 .20602 L
.07393 .20602 L
.07493 .20602 L
.07592 .20602 L
.07692 .20602 L
.07792 .20602 L
.07892 .20602 L
.07992 .20602 L
.08092 .20602 L
.08192 .20602 L
.08292 .20602 L
.08392 .20602 L
.08492 .20602 L
.08591 .20602 L
.08691 .20602 L
.08791 .20602 L
.08891 .20602 L
.08991 .20602 L
.09091 .20602 L
.09191 .20602 L
.09291 .20602 L
.09391 .20602 L
.09491 .20602 L
.0959 .20602 L
.0969 .20603 L
.0979 .20602 L
.0989 .20602 L
Mistroke
.0999 .20602 L
.1009 .20603 L
.1019 .20603 L
.1029 .20603 L
.1039 .20603 L
.1049 .20602 L
.10589 .20603 L
.10689 .20603 L
.10789 .20603 L
.10889 .20603 L
.10989 .20602 L
.11089 .20602 L
.11189 .20603 L
.11289 .20602 L
.11389 .20602 L
.11489 .20602 L
.11588 .20602 L
.11688 .20602 L
.11788 .20602 L
.11888 .20602 L
.11988 .20602 L
.12088 .20602 L
.12188 .20602 L
.12288 .20603 L
.12388 .20602 L
.12488 .20602 L
.12587 .20602 L
.12687 .20602 L
.12787 .20602 L
.12887 .20602 L
.12987 .20602 L
.13087 .20602 L
.13187 .20602 L
.13287 .20602 L
.13387 .20602 L
.13487 .20602 L
.13586 .20603 L
.13686 .20603 L
.13786 .20603 L
.13886 .20603 L
.13986 .20603 L
.14086 .20603 L
.14186 .20603 L
.14286 .20603 L
.14386 .20602 L
.14486 .20602 L
.14585 .20602 L
.14685 .20602 L
.14785 .20602 L
.14885 .20602 L
Mistroke
.14985 .20602 L
.15085 .20602 L
.15185 .20603 L
.15285 .20603 L
.15385 .20603 L
.15485 .20603 L
.15584 .20602 L
.15684 .20602 L
.15784 .20602 L
.15884 .20602 L
.15984 .20602 L
.16084 .20602 L
.16184 .20602 L
.16284 .20602 L
.16384 .20602 L
.16484 .20602 L
.16583 .20602 L
.16683 .20602 L
.16783 .20602 L
.16883 .20602 L
.16983 .20602 L
.17083 .20602 L
.17183 .20602 L
.17283 .20602 L
.17383 .20602 L
.17483 .20602 L
.17582 .20602 L
.17682 .20602 L
.17782 .20602 L
.17882 .20602 L
.17982 .20602 L
.18082 .20602 L
.18182 .20602 L
.18282 .20602 L
.18382 .20602 L
.18482 .20602 L
.18581 .20602 L
.18681 .20603 L
.18781 .20602 L
.18881 .20602 L
.18981 .20603 L
.19081 .20603 L
.19181 .20603 L
.19281 .20603 L
.19381 .20603 L
.19481 .20603 L
.1958 .20603 L
.1968 .20603 L
.1978 .20603 L
.1988 .20603 L
Mistroke
.1998 .20603 L
.2008 .20603 L
.2018 .20603 L
.2028 .20603 L
.2038 .20603 L
.2048 .20603 L
.20579 .20603 L
.20679 .20603 L
.20779 .20603 L
.20879 .20603 L
.20979 .20603 L
.21079 .20603 L
.21179 .20603 L
.21279 .20603 L
.21379 .20603 L
.21479 .20603 L
.21578 .20603 L
.21678 .20603 L
.21778 .20603 L
.21878 .20603 L
.21978 .20603 L
.22078 .20603 L
.22178 .20603 L
.22278 .20603 L
.22378 .20603 L
.22478 .20603 L
.22577 .20603 L
.22677 .20603 L
.22777 .20603 L
.22877 .20603 L
.22977 .20603 L
.23077 .20603 L
.23177 .20603 L
.23277 .20603 L
.23377 .20603 L
.23477 .20603 L
.23576 .20603 L
.23676 .20603 L
.23776 .20603 L
.23876 .20603 L
.23976 .20602 L
.24076 .20602 L
.24176 .20602 L
.24276 .20602 L
.24376 .20602 L
.24476 .20603 L
.24575 .20603 L
.24675 .20603 L
.24775 .20603 L
.24875 .20603 L
Mistroke
.24975 .20603 L
.25075 .20603 L
.25175 .20603 L
.25275 .20603 L
.25375 .20603 L
.25475 .20603 L
.25574 .20603 L
.25674 .20603 L
.25774 .20603 L
.25874 .20602 L
.25974 .20603 L
.26074 .20602 L
.26174 .20602 L
.26274 .20602 L
.26374 .20603 L
.26474 .20603 L
.26573 .20603 L
.26673 .20603 L
.26773 .20603 L
.26873 .20603 L
.26973 .20603 L
.27073 .20603 L
.27173 .20603 L
.27273 .20603 L
.27373 .20603 L
.27473 .20603 L
.27572 .20602 L
.27672 .20602 L
.27772 .20602 L
.27872 .20602 L
.27972 .20602 L
.28072 .20602 L
.28172 .20602 L
.28272 .20602 L
.28372 .20602 L
.28472 .20602 L
.28571 .20603 L
.28671 .20603 L
.28771 .20603 L
.28871 .20603 L
.28971 .20603 L
.29071 .20603 L
.29171 .20603 L
.29271 .20603 L
.29371 .20603 L
.29471 .20603 L
.2957 .20603 L
.2967 .20603 L
.2977 .20603 L
.2987 .20603 L
Mistroke
.2997 .20603 L
.3007 .20603 L
.3017 .20603 L
.3027 .20603 L
.3037 .20603 L
.3047 .20603 L
.30569 .20603 L
.30669 .20603 L
.30769 .20603 L
.30869 .20603 L
.30969 .20603 L
.31069 .20603 L
.31169 .20603 L
.31269 .20603 L
.31369 .20603 L
.31469 .20603 L
.31568 .20603 L
.31668 .20603 L
.31768 .20603 L
.31868 .20603 L
.31968 .20603 L
.32068 .20603 L
.32168 .20603 L
.32268 .20603 L
.32368 .20603 L
.32468 .20603 L
.32567 .20603 L
.32667 .20603 L
.32767 .20603 L
.32867 .20603 L
.32967 .20603 L
.33067 .20603 L
.33167 .20603 L
.33267 .20603 L
.33367 .20603 L
.33467 .20603 L
.33566 .20603 L
.33666 .20603 L
.33766 .20603 L
.33866 .20603 L
.33966 .20603 L
.34066 .20603 L
.34166 .20603 L
.34266 .20604 L
.34366 .20603 L
.34466 .20603 L
.34565 .20604 L
.34665 .20603 L
.34765 .20604 L
.34865 .20604 L
Mistroke
.34965 .20603 L
.35065 .20603 L
.35165 .20603 L
.35265 .20604 L
.35365 .20603 L
.35465 .20603 L
.35564 .20603 L
.35664 .20603 L
.35764 .20603 L
.35864 .20603 L
.35964 .20603 L
.36064 .20604 L
.36164 .20604 L
.36264 .20604 L
.36364 .20604 L
.36464 .20604 L
.36563 .20604 L
.36663 .20604 L
.36763 .20604 L
.36863 .20604 L
.36963 .20604 L
.37063 .20604 L
.37163 .20604 L
.37263 .20604 L
.37363 .20604 L
.37463 .20604 L
.37562 .20604 L
.37662 .20604 L
.37762 .20604 L
.37862 .20604 L
.37962 .20604 L
.38062 .20604 L
.38162 .20604 L
.38262 .20604 L
.38362 .20604 L
.38462 .20604 L
.38561 .20603 L
.38661 .20604 L
.38761 .20604 L
.38861 .20604 L
.38961 .20604 L
.39061 .20604 L
.39161 .20604 L
.39261 .20604 L
.39361 .20604 L
.39461 .20604 L
.3956 .20604 L
.3966 .20604 L
.3976 .20604 L
.3986 .20604 L
Mistroke
.3996 .20604 L
.4006 .20604 L
.4016 .20604 L
.4026 .20604 L
.4036 .20604 L
.4046 .20604 L
.40559 .20604 L
.40659 .20604 L
.40759 .20604 L
.40859 .20604 L
.40959 .20604 L
.41059 .20604 L
.41159 .20604 L
.41259 .20604 L
.41359 .20604 L
.41459 .20604 L
.41558 .20604 L
.41658 .20604 L
.41758 .20604 L
.41858 .20604 L
.41958 .20604 L
.42058 .20604 L
.42158 .20604 L
.42258 .20604 L
.42358 .20604 L
.42458 .20604 L
.42557 .20604 L
.42657 .20604 L
.42757 .20604 L
.42857 .20604 L
.42957 .20604 L
.43057 .20604 L
.43157 .20604 L
.43257 .20604 L
.43357 .20604 L
.43457 .20604 L
.43556 .20604 L
.43656 .20604 L
.43756 .20604 L
.43856 .20604 L
.43956 .20604 L
.44056 .20604 L
.44156 .20604 L
.44256 .20604 L
.44356 .20604 L
.44456 .20604 L
.44555 .20604 L
.44655 .20604 L
.44755 .20604 L
.44855 .20604 L
Mistroke
.44955 .20604 L
.45055 .20604 L
.45155 .20604 L
.45255 .20604 L
.45355 .20604 L
.45455 .20604 L
.45554 .20604 L
.45654 .20603 L
.45754 .20604 L
.45854 .20604 L
.45954 .20604 L
.46054 .20604 L
.46154 .20604 L
.46254 .20604 L
.46354 .20604 L
.46454 .20604 L
.46553 .20604 L
.46653 .20604 L
.46753 .20604 L
.46853 .20604 L
.46953 .20604 L
.47053 .20604 L
.47153 .20604 L
.47253 .20604 L
.47353 .20604 L
.47453 .20604 L
.47552 .20604 L
.47652 .20604 L
.47752 .20604 L
.47852 .20604 L
.47952 .20604 L
.48052 .20604 L
.48152 .20604 L
.48252 .20604 L
.48352 .20604 L
.48452 .20605 L
.48551 .20604 L
.48651 .20604 L
.48751 .20604 L
.48851 .20604 L
.48951 .20604 L
.49051 .20604 L
.49151 .20605 L
.49251 .20604 L
.49351 .20605 L
.49451 .20605 L
.4955 .20605 L
.4965 .20605 L
.4975 .20604 L
.4985 .20604 L
Mistroke
.4995 .20604 L
.5005 .20604 L
.5015 .20604 L
.5025 .20604 L
.5035 .20604 L
.5045 .20604 L
.50549 .20604 L
.50649 .20604 L
.50749 .20604 L
.50849 .20604 L
.50949 .20604 L
.51049 .20604 L
.51149 .20604 L
.51249 .20604 L
.51349 .20604 L
.51449 .20604 L
.51548 .20604 L
.51648 .20604 L
.51748 .20604 L
.51848 .20604 L
.51948 .20604 L
.52048 .20604 L
.52148 .20604 L
.52248 .20604 L
.52348 .20604 L
.52448 .20604 L
.52547 .20604 L
.52647 .20604 L
.52747 .20604 L
.52847 .20604 L
.52947 .20604 L
.53047 .20605 L
.53147 .20605 L
.53247 .20605 L
.53347 .20605 L
.53447 .20605 L
.53546 .20605 L
.53646 .20605 L
.53746 .20605 L
.53846 .20605 L
.53946 .20604 L
.54046 .20604 L
.54146 .20604 L
.54246 .20604 L
.54346 .20604 L
.54446 .20604 L
.54545 .20604 L
.54645 .20604 L
.54745 .20604 L
.54845 .20604 L
Mistroke
.54945 .20604 L
.55045 .20604 L
.55145 .20604 L
.55245 .20604 L
.55345 .20604 L
.55445 .20604 L
.55544 .20605 L
.55644 .20605 L
.55744 .20604 L
.55844 .20605 L
.55944 .20605 L
.56044 .20605 L
.56144 .20605 L
.56244 .20604 L
.56344 .20604 L
.56444 .20604 L
.56543 .20604 L
.56643 .20604 L
.56743 .20604 L
.56843 .20604 L
.56943 .20604 L
.57043 .20604 L
.57143 .20605 L
.57243 .20605 L
.57343 .20605 L
.57443 .20605 L
.57542 .20605 L
.57642 .20605 L
.57742 .20605 L
.57842 .20605 L
.57942 .20605 L
.58042 .20605 L
.58142 .20605 L
.58242 .20605 L
.58342 .20605 L
.58442 .20604 L
.58541 .20604 L
.58641 .20604 L
.58741 .20605 L
.58841 .20604 L
.58941 .20605 L
.59041 .20605 L
.59141 .20605 L
.59241 .20605 L
.59341 .20605 L
.59441 .20605 L
.5954 .20604 L
.5964 .20604 L
.5974 .20604 L
.5984 .20604 L
Mistroke
.5994 .20605 L
.6004 .20605 L
.6014 .20605 L
.6024 .20605 L
.6034 .20605 L
.6044 .20605 L
.60539 .20605 L
.60639 .20605 L
.60739 .20605 L
.60839 .20605 L
.60939 .20605 L
.61039 .20604 L
.61139 .20604 L
.61239 .20604 L
.61339 .20604 L
.61439 .20604 L
.61538 .20604 L
.61638 .20604 L
.61738 .20604 L
.61838 .20604 L
.61938 .20604 L
.62038 .20604 L
.62138 .20604 L
.62238 .20604 L
.62338 .20604 L
.62438 .20604 L
.62537 .20604 L
.62637 .20604 L
.62737 .20604 L
.62837 .20604 L
.62937 .20604 L
.63037 .20605 L
.63137 .20605 L
.63237 .20605 L
.63337 .20605 L
.63437 .20605 L
.63536 .20605 L
.63636 .20605 L
.63736 .20605 L
.63836 .20605 L
.63936 .20605 L
.64036 .20605 L
.64136 .20605 L
.64236 .20605 L
.64336 .20605 L
.64436 .20605 L
.64535 .20605 L
.64635 .20605 L
.64735 .20605 L
.64835 .20605 L
Mistroke
.64935 .20605 L
.65035 .20605 L
.65135 .20605 L
.65235 .20605 L
.65335 .20605 L
.65435 .20605 L
.65534 .20605 L
.65634 .20605 L
.65734 .20605 L
.65834 .20605 L
.65934 .20605 L
.66034 .20605 L
.66134 .20605 L
.66234 .20605 L
.66334 .20605 L
.66434 .20605 L
.66533 .20605 L
.66633 .20605 L
.66733 .20605 L
.66833 .20605 L
.66933 .20605 L
.67033 .20605 L
.67133 .20605 L
.67233 .20605 L
.67333 .20605 L
.67433 .20605 L
.67532 .20605 L
.67632 .20605 L
.67732 .20605 L
.67832 .20605 L
.67932 .20605 L
.68032 .20605 L
.68132 .20605 L
.68232 .20605 L
.68332 .20605 L
.68432 .20605 L
.68531 .20605 L
.68631 .20605 L
.68731 .20605 L
.68831 .20605 L
.68931 .20605 L
.69031 .20605 L
.69131 .20605 L
.69231 .20605 L
.69331 .20605 L
.69431 .20605 L
.6953 .20605 L
.6963 .20605 L
.6973 .20605 L
.6983 .20605 L
Mistroke
.6993 .20605 L
.7003 .20605 L
.7013 .20605 L
.7023 .20605 L
.7033 .20605 L
.7043 .20605 L
.70529 .20605 L
.70629 .20605 L
.70729 .20605 L
.70829 .20605 L
.70929 .20605 L
.71029 .20605 L
.71129 .20605 L
.71229 .20605 L
.71329 .20605 L
.71429 .20605 L
.71528 .20605 L
.71628 .20605 L
.71728 .20604 L
.71828 .20604 L
.71928 .20604 L
.72028 .20604 L
.72128 .20605 L
.72228 .20605 L
.72328 .20605 L
.72428 .20605 L
.72527 .20605 L
.72627 .20605 L
.72727 .20605 L
.72827 .20605 L
.72927 .20605 L
.73027 .20605 L
.73127 .20605 L
.73227 .20605 L
.73327 .20605 L
.73427 .20605 L
.73526 .20605 L
.73626 .20605 L
.73726 .20605 L
.73826 .20605 L
.73926 .20605 L
.74026 .20605 L
.74126 .20605 L
.74226 .20605 L
.74326 .20605 L
.74426 .20605 L
.74525 .20605 L
.74625 .20605 L
.74725 .20605 L
.74825 .20605 L
Mistroke
.74925 .20605 L
.75025 .20605 L
.75125 .20605 L
.75225 .20605 L
.75325 .20605 L
.75425 .20606 L
.75524 .20606 L
.75624 .20606 L
.75724 .20606 L
.75824 .20606 L
.75924 .20605 L
.76024 .20605 L
.76124 .20605 L
.76224 .20605 L
.76324 .20606 L
.76424 .20606 L
.76523 .20606 L
.76623 .20606 L
.76723 .20606 L
.76823 .20606 L
.76923 .20606 L
.77023 .20606 L
.77123 .20606 L
.77223 .20606 L
.77323 .20606 L
.77423 .20606 L
.77522 .20606 L
.77622 .20606 L
.77722 .20606 L
.77822 .20606 L
.77922 .20606 L
.78022 .20606 L
.78122 .20606 L
.78222 .20606 L
.78322 .20606 L
.78422 .20606 L
.78521 .20606 L
.78621 .20606 L
.78721 .20606 L
.78821 .20606 L
.78921 .20606 L
.79021 .20606 L
.79121 .20606 L
.79221 .20606 L
.79321 .20606 L
.79421 .20606 L
.7952 .20606 L
.7962 .20606 L
.7972 .20606 L
.7982 .20606 L
Mistroke
.7992 .20606 L
.8002 .20606 L
.8012 .20607 L
.8022 .20606 L
.8032 .20607 L
.8042 .20607 L
.80519 .20606 L
.80619 .20606 L
.80719 .20606 L
.80819 .20606 L
.80919 .20606 L
.81019 .20606 L
.81119 .20607 L
.81219 .20607 L
.81319 .20607 L
.81419 .20607 L
.81518 .20607 L
.81618 .20607 L
.81718 .20606 L
.81818 .20606 L
.81918 .20606 L
.82018 .20606 L
.82118 .20606 L
.82218 .20606 L
.82318 .20606 L
.82418 .20606 L
.82517 .20606 L
.82617 .20606 L
.82717 .20606 L
.82817 .20606 L
.82917 .20606 L
.83017 .20606 L
.83117 .20606 L
.83217 .20606 L
.83317 .20607 L
.83417 .20607 L
.83516 .20607 L
.83616 .20607 L
.83716 .20607 L
.83816 .20607 L
.83916 .20607 L
.84016 .20607 L
.84116 .20606 L
.84216 .20606 L
.84316 .20606 L
.84416 .20606 L
.84515 .20606 L
.84615 .20607 L
.84715 .20606 L
.84815 .20606 L
Mistroke
.84915 .20606 L
.85015 .20606 L
.85115 .20606 L
.85215 .20606 L
.85315 .20606 L
.85415 .20607 L
.85514 .20607 L
.85614 .20607 L
.85714 .20607 L
.85814 .20607 L
.85914 .20607 L
.86014 .20607 L
.86114 .20607 L
.86214 .20607 L
.86314 .20607 L
.86414 .20607 L
.86513 .20607 L
.86613 .20607 L
.86713 .20607 L
.86813 .20607 L
.86913 .20607 L
.87013 .20607 L
.87113 .20607 L
.87213 .20607 L
.87313 .20607 L
.87413 .20607 L
.87512 .20607 L
.87612 .20607 L
.87712 .20607 L
.87812 .20607 L
.87912 .20607 L
.88012 .20607 L
.88112 .20607 L
.88212 .20607 L
.88312 .20607 L
.88412 .20607 L
.88511 .20607 L
.88611 .20607 L
.88711 .20607 L
.88811 .20607 L
.88911 .20607 L
.89011 .20607 L
.89111 .20607 L
.89211 .20607 L
.89311 .20607 L
.89411 .20607 L
.8951 .20607 L
.8961 .20607 L
.8971 .20607 L
.8981 .20607 L
Mistroke
.8991 .20606 L
.9001 .20607 L
.9011 .20607 L
.9021 .20606 L
.9031 .20606 L
.9041 .20606 L
.90509 .20606 L
.90609 .20606 L
.90709 .20606 L
.90809 .20606 L
.90909 .20606 L
.91009 .20606 L
.91109 .20606 L
.91209 .20606 L
.91309 .20606 L
.91409 .20606 L
.91508 .20606 L
.91608 .20606 L
.91708 .20606 L
.91808 .20606 L
.91908 .20606 L
.92008 .20606 L
.92108 .20607 L
.92208 .20606 L
.92308 .20606 L
.92408 .20606 L
.92507 .20606 L
.92607 .20606 L
.92707 .20606 L
.92807 .20606 L
.92907 .20606 L
.93007 .20606 L
.93107 .20606 L
.93207 .20606 L
.93307 .20606 L
.93407 .20606 L
.93506 .20606 L
.93606 .20606 L
.93706 .20606 L
.93806 .20606 L
.93906 .20606 L
.94006 .20606 L
.94106 .20606 L
.94206 .20606 L
.94306 .20606 L
.94406 .20606 L
.94505 .20606 L
.94605 .20606 L
.94705 .20606 L
.94805 .20606 L
Mistroke
.94905 .20606 L
.95005 .20606 L
.95105 .20606 L
.95205 .20606 L
.95305 .20606 L
.95405 .20606 L
.95504 .20606 L
.95604 .20606 L
.95704 .20606 L
.95804 .20606 L
.95904 .20606 L
.96004 .20606 L
.96104 .20606 L
.96204 .20606 L
.96304 .20606 L
.96404 .20606 L
.96503 .20606 L
.96603 .20606 L
.96703 .20606 L
.96803 .20606 L
.96903 .20607 L
.97003 .20607 L
.97103 .20607 L
.97203 .20606 L
.97303 .20606 L
.97403 .20606 L
.97502 .20606 L
.97602 .20606 L
.97702 .20606 L
.97802 .20606 L
.97902 .20606 L
.98002 .20606 L
.98102 .20606 L
.98202 .20606 L
.98302 .20606 L
.98402 .20606 L
.98501 .20606 L
.98601 .20606 L
.98701 .20606 L
.98801 .20606 L
.98901 .20606 L
.99001 .20606 L
.99101 .20606 L
.99201 .20606 L
.99301 .20606 L
.99401 .20607 L
.995 .20607 L
.996 .20607 L
.997 .20607 L
.998 .20607 L
Mistroke
.999 .20607 L
Mfstroke
0 .98 .604 r
gsave
.999 .09729 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .13185 m
.001 .13185 L
.002 .13185 L
.003 .13185 L
.004 .13185 L
.005 .13185 L
.00599 .13185 L
.00699 .13185 L
.00799 .13185 L
.00899 .13185 L
.00999 .13185 L
.01099 .13185 L
.01199 .13185 L
.01299 .13185 L
.01399 .13185 L
.01499 .13185 L
.01598 .13185 L
.01698 .13185 L
.01798 .13185 L
.01898 .13185 L
.01998 .13185 L
.02098 .13185 L
.02198 .13185 L
.02298 .13185 L
.02398 .13185 L
.02498 .13185 L
.02597 .13185 L
.02697 .13185 L
.02797 .13185 L
.02897 .13185 L
.02997 .13185 L
.03097 .13185 L
.03197 .13185 L
.03297 .13185 L
.03397 .13185 L
.03497 .13185 L
.03596 .13185 L
.03696 .13185 L
.03796 .13185 L
.03896 .13185 L
.03996 .13185 L
.04096 .13185 L
.04196 .13185 L
.04296 .13185 L
.04396 .13185 L
.04496 .13185 L
.04595 .13185 L
.04695 .13185 L
.04795 .13185 L
.04895 .13185 L
Mistroke
Mfstroke
.04895 .13185 m
.04959 0 L
s
.09948 0 m
.0999 .05494 L
.1009 .05494 L
.1019 .05494 L
.1029 .05494 L
.1039 .05494 L
.1049 .05494 L
.10589 .05494 L
.10689 .05494 L
.10789 .05494 L
.10889 .05494 L
.10989 .05494 L
.11089 .05494 L
.11189 .05494 L
.11289 .05494 L
.11389 .05494 L
.11489 .05494 L
.11588 .05494 L
.11688 .05494 L
.11788 .05494 L
.11888 .05494 L
.11988 .05494 L
.12088 .05494 L
.12188 .05494 L
.12288 .05494 L
.12388 .05494 L
.12488 .05494 L
.12587 .05494 L
.12687 .05494 L
.12787 .05494 L
.12887 .05494 L
.12987 .05494 L
.13087 .05494 L
.13187 .05494 L
.13287 .05494 L
.13387 .05494 L
.13487 .05494 L
.13586 .05494 L
.13686 .05494 L
.13786 .05494 L
.13886 .05494 L
.13986 .05494 L
.14086 .05494 L
.14186 .05494 L
.14286 .05494 L
.14386 .05494 L
.14486 .05494 L
.14585 .05494 L
.14685 .05494 L
.14785 .05494 L
Mistroke
.14885 .05494 L
.14985 .05392 L
.15085 .05392 L
.15185 .05392 L
.15285 .05392 L
.15385 .05392 L
.15485 .05392 L
.15584 .05392 L
.15684 .05392 L
.15784 .05392 L
.15884 .05392 L
.15984 .05392 L
.16084 .05392 L
.16184 .05392 L
.16284 .05392 L
.16384 .05392 L
.16484 .05392 L
.16583 .05392 L
.16683 .05392 L
.16783 .05392 L
.16883 .05392 L
.16983 .05392 L
.17083 .05392 L
.17183 .05392 L
.17283 .05392 L
.17383 .05392 L
.17483 .05392 L
.17582 .05392 L
.17682 .05392 L
.17782 .05392 L
.17882 .05392 L
.17982 .05392 L
.18082 .05392 L
.18182 .05392 L
.18282 .05392 L
.18382 .05392 L
.18482 .05392 L
.18581 .05392 L
.18681 .05392 L
.18781 .05392 L
.18881 .05392 L
.18981 .05392 L
.19081 .05392 L
.19181 .05392 L
.19281 .05392 L
.19381 .05392 L
.19481 .05392 L
.1958 .05392 L
.1968 .05392 L
.1978 .05392 L
Mistroke
.1988 .05392 L
.1998 .06603 L
.2008 .06603 L
.2018 .06603 L
.2028 .06603 L
.2038 .06603 L
.2048 .06603 L
.20579 .06603 L
.20679 .06603 L
.20779 .06603 L
.20879 .06603 L
.20979 .06603 L
.21079 .06603 L
.21179 .06603 L
.21279 .06603 L
.21379 .06603 L
.21479 .06603 L
.21578 .06603 L
.21678 .06603 L
.21778 .06603 L
.21878 .06603 L
.21978 .06603 L
.22078 .06603 L
.22178 .06603 L
.22278 .06603 L
.22378 .06603 L
.22478 .06603 L
.22577 .06603 L
.22677 .06603 L
.22777 .06603 L
.22877 .06603 L
.22977 .06603 L
.23077 .06603 L
.23177 .06603 L
.23277 .06603 L
.23377 .06603 L
.23477 .06603 L
.23576 .06603 L
.23676 .06603 L
.23776 .06603 L
.23876 .06603 L
.23976 .06603 L
.24076 .06603 L
.24176 .06603 L
.24276 .06603 L
.24376 .06603 L
.24476 .06603 L
.24575 .06603 L
.24675 .06603 L
.24775 .06603 L
Mistroke
.24875 .06603 L
.24975 .06945 L
.25075 .06945 L
.25175 .06945 L
.25275 .06945 L
.25375 .06945 L
.25475 .06945 L
.25574 .06945 L
.25674 .06945 L
.25774 .06945 L
.25874 .06945 L
.25974 .06945 L
.26074 .06945 L
.26174 .06945 L
.26274 .06945 L
.26374 .06945 L
.26474 .06945 L
.26573 .06945 L
.26673 .06945 L
.26773 .06945 L
.26873 .06945 L
.26973 .06945 L
.27073 .06945 L
.27173 .06945 L
.27273 .06945 L
.27373 .06945 L
.27473 .06945 L
.27572 .06945 L
.27672 .06945 L
.27772 .06945 L
.27872 .06945 L
.27972 .06945 L
.28072 .06945 L
.28172 .06945 L
.28272 .06945 L
.28372 .06945 L
.28472 .06945 L
.28571 .06945 L
.28671 .06945 L
.28771 .06945 L
.28871 .06945 L
.28971 .06945 L
.29071 .06945 L
.29171 .06945 L
.29271 .06945 L
.29371 .06945 L
.29471 .06945 L
.2957 .06945 L
.2967 .06945 L
.2977 .06945 L
Mistroke
.2987 .06945 L
.2997 .07034 L
.3007 .07034 L
.3017 .07034 L
.3027 .07034 L
.3037 .07034 L
.3047 .07034 L
.30569 .07034 L
.30669 .07034 L
.30769 .07034 L
.30869 .07034 L
.30969 .07034 L
.31069 .07034 L
.31169 .07034 L
.31269 .07034 L
.31369 .07034 L
.31469 .07034 L
.31568 .07034 L
.31668 .07034 L
.31768 .07034 L
.31868 .07034 L
.31968 .07034 L
.32068 .07034 L
.32168 .07034 L
.32268 .07034 L
.32368 .07034 L
.32468 .07034 L
.32567 .07034 L
.32667 .07034 L
.32767 .07034 L
.32867 .07034 L
.32967 .07034 L
.33067 .07034 L
.33167 .07034 L
.33267 .07034 L
.33367 .07034 L
.33467 .07034 L
.33566 .07034 L
.33666 .07034 L
.33766 .07034 L
.33866 .07034 L
.33966 .07034 L
.34066 .07034 L
.34166 .07034 L
.34266 .07034 L
.34366 .07034 L
.34466 .07034 L
.34565 .07034 L
.34665 .07034 L
.34765 .07034 L
Mistroke
.34865 .07034 L
.34965 .07316 L
.35065 .07316 L
.35165 .07316 L
.35265 .07316 L
.35365 .07316 L
.35465 .07316 L
.35564 .07316 L
.35664 .07316 L
.35764 .07316 L
.35864 .07316 L
.35964 .07316 L
.36064 .07316 L
.36164 .07316 L
.36264 .07316 L
.36364 .07316 L
.36464 .07316 L
.36563 .07316 L
.36663 .07316 L
.36763 .07316 L
.36863 .07316 L
.36963 .07316 L
.37063 .07316 L
.37163 .07316 L
.37263 .07316 L
.37363 .07316 L
.37463 .07316 L
.37562 .07316 L
.37662 .07316 L
.37762 .07316 L
.37862 .07316 L
.37962 .07316 L
.38062 .07316 L
.38162 .07316 L
.38262 .07316 L
.38362 .07316 L
.38462 .07316 L
.38561 .07316 L
.38661 .07316 L
.38761 .07316 L
.38861 .07316 L
.38961 .07316 L
.39061 .07316 L
.39161 .07316 L
.39261 .07316 L
.39361 .07316 L
.39461 .07316 L
.3956 .07316 L
.3966 .07316 L
.3976 .07316 L
Mistroke
.3986 .07316 L
.3996 .08286 L
.4006 .08286 L
.4016 .08286 L
.4026 .08286 L
.4036 .08286 L
.4046 .08286 L
.40559 .08286 L
.40659 .08286 L
.40759 .08286 L
.40859 .08286 L
.40959 .08286 L
.41059 .08286 L
.41159 .08286 L
.41259 .08286 L
.41359 .08286 L
.41459 .08286 L
.41558 .08286 L
.41658 .08286 L
.41758 .08286 L
.41858 .08286 L
.41958 .08286 L
.42058 .08286 L
.42158 .08286 L
.42258 .08286 L
.42358 .08286 L
.42458 .08286 L
.42557 .08286 L
.42657 .08286 L
.42757 .08286 L
.42857 .08286 L
.42957 .08286 L
.43057 .08286 L
.43157 .08286 L
.43257 .08286 L
.43357 .08286 L
.43457 .08286 L
.43556 .08286 L
.43656 .08286 L
.43756 .08286 L
.43856 .08286 L
.43956 .08286 L
.44056 .08286 L
.44156 .08286 L
.44256 .08286 L
.44356 .08286 L
.44456 .08286 L
.44555 .08286 L
.44655 .08286 L
.44755 .08286 L
Mistroke
.44855 .08286 L
.44955 .08332 L
.45055 .08332 L
.45155 .08332 L
.45255 .08332 L
.45355 .08332 L
.45455 .08332 L
.45554 .08332 L
.45654 .08332 L
.45754 .08332 L
.45854 .08332 L
.45954 .08332 L
.46054 .08332 L
.46154 .08332 L
.46254 .08332 L
.46354 .08332 L
.46454 .08332 L
.46553 .08332 L
.46653 .08332 L
.46753 .08332 L
.46853 .08332 L
.46953 .08332 L
.47053 .08332 L
.47153 .08332 L
.47253 .08332 L
.47353 .08332 L
.47453 .08332 L
.47552 .08332 L
.47652 .08332 L
.47752 .08332 L
.47852 .08332 L
.47952 .08332 L
.48052 .08332 L
.48152 .08332 L
.48252 .08332 L
.48352 .08332 L
.48452 .08332 L
.48551 .08332 L
.48651 .08332 L
.48751 .08332 L
.48851 .08332 L
.48951 .08332 L
.49051 .08332 L
.49151 .08332 L
.49251 .08332 L
.49351 .08332 L
.49451 .08332 L
.4955 .08332 L
.4965 .08332 L
.4975 .08332 L
Mistroke
.4985 .08332 L
.4995 .08131 L
.5005 .08131 L
.5015 .08131 L
.5025 .08131 L
.5035 .08131 L
.5045 .08131 L
.50549 .08131 L
.50649 .08131 L
.50749 .08131 L
.50849 .08131 L
.50949 .08131 L
.51049 .08131 L
.51149 .08131 L
.51249 .08131 L
.51349 .08131 L
.51449 .08131 L
.51548 .08131 L
.51648 .08131 L
.51748 .08131 L
.51848 .08131 L
.51948 .08131 L
.52048 .08131 L
.52148 .08131 L
.52248 .08131 L
.52348 .08131 L
.52448 .08131 L
.52547 .08131 L
.52647 .08131 L
.52747 .08131 L
.52847 .08131 L
.52947 .08131 L
.53047 .08131 L
.53147 .08131 L
.53247 .08131 L
.53347 .08131 L
.53447 .08131 L
.53546 .08131 L
.53646 .08131 L
.53746 .08131 L
.53846 .08131 L
.53946 .08131 L
.54046 .08131 L
.54146 .08131 L
.54246 .08131 L
.54346 .08131 L
.54446 .08131 L
.54545 .08131 L
.54645 .08131 L
.54745 .08131 L
Mistroke
.54845 .08131 L
.54945 .08766 L
.55045 .08766 L
.55145 .08766 L
.55245 .08766 L
.55345 .08766 L
.55445 .08766 L
.55544 .08766 L
.55644 .08766 L
.55744 .08766 L
.55844 .08766 L
.55944 .08766 L
.56044 .08766 L
.56144 .08766 L
.56244 .08766 L
.56344 .08766 L
.56444 .08766 L
.56543 .08766 L
.56643 .08766 L
.56743 .08766 L
.56843 .08766 L
.56943 .08766 L
.57043 .08766 L
.57143 .08766 L
.57243 .08766 L
.57343 .08766 L
.57443 .08766 L
.57542 .08766 L
.57642 .08766 L
.57742 .08766 L
.57842 .08766 L
.57942 .08766 L
.58042 .08766 L
.58142 .08766 L
.58242 .08766 L
.58342 .08766 L
.58442 .08766 L
.58541 .08766 L
.58641 .08766 L
.58741 .08766 L
.58841 .08766 L
.58941 .08766 L
.59041 .08766 L
.59141 .08766 L
.59241 .08766 L
.59341 .08766 L
.59441 .08766 L
.5954 .08766 L
.5964 .08766 L
.5974 .08766 L
Mistroke
.5984 .08766 L
.5994 .0889 L
.6004 .0889 L
.6014 .0889 L
.6024 .0889 L
.6034 .0889 L
.6044 .0889 L
.60539 .0889 L
.60639 .0889 L
.60739 .0889 L
.60839 .0889 L
.60939 .0889 L
.61039 .0889 L
.61139 .0889 L
.61239 .0889 L
.61339 .0889 L
.61439 .0889 L
.61538 .0889 L
.61638 .0889 L
.61738 .0889 L
.61838 .0889 L
.61938 .0889 L
.62038 .0889 L
.62138 .0889 L
.62238 .0889 L
.62338 .0889 L
.62438 .0889 L
.62537 .0889 L
.62637 .0889 L
.62737 .0889 L
.62837 .0889 L
.62937 .0889 L
.63037 .0889 L
.63137 .0889 L
.63237 .0889 L
.63337 .0889 L
.63437 .0889 L
.63536 .0889 L
.63636 .0889 L
.63736 .0889 L
.63836 .0889 L
.63936 .0889 L
.64036 .0889 L
.64136 .0889 L
.64236 .0889 L
.64336 .0889 L
.64436 .0889 L
.64535 .0889 L
.64635 .0889 L
.64735 .0889 L
Mistroke
.64835 .0889 L
.64935 .08875 L
.65035 .08875 L
.65135 .08875 L
.65235 .08875 L
.65335 .08875 L
.65435 .08875 L
.65534 .08875 L
.65634 .08875 L
.65734 .08875 L
.65834 .08875 L
.65934 .08875 L
.66034 .08875 L
.66134 .08875 L
.66234 .08875 L
.66334 .08875 L
.66434 .08875 L
.66533 .08875 L
.66633 .08875 L
.66733 .08875 L
.66833 .08875 L
.66933 .08875 L
.67033 .08875 L
.67133 .08875 L
.67233 .08875 L
.67333 .08875 L
.67433 .08875 L
.67532 .08875 L
.67632 .08875 L
.67732 .08875 L
.67832 .08875 L
.67932 .08875 L
.68032 .08875 L
.68132 .08875 L
.68232 .08875 L
.68332 .08875 L
.68432 .08875 L
.68531 .08875 L
.68631 .08875 L
.68731 .08875 L
.68831 .08875 L
.68931 .08875 L
.69031 .08875 L
.69131 .08875 L
.69231 .08875 L
.69331 .08875 L
.69431 .08875 L
.6953 .08875 L
.6963 .08875 L
.6973 .08875 L
Mistroke
.6983 .08875 L
.6993 .08979 L
.7003 .08979 L
.7013 .08979 L
.7023 .08979 L
.7033 .08979 L
.7043 .08979 L
.70529 .08979 L
.70629 .08979 L
.70729 .08979 L
.70829 .08979 L
.70929 .08979 L
.71029 .08979 L
.71129 .08979 L
.71229 .08979 L
.71329 .08979 L
.71429 .08979 L
.71528 .08979 L
.71628 .08979 L
.71728 .08979 L
.71828 .08979 L
.71928 .08979 L
.72028 .08979 L
.72128 .08979 L
.72228 .08979 L
.72328 .08979 L
.72428 .08979 L
.72527 .08979 L
.72627 .08979 L
.72727 .08979 L
.72827 .08979 L
.72927 .08979 L
.73027 .08979 L
.73127 .08979 L
.73227 .08979 L
.73327 .08979 L
.73427 .08979 L
.73526 .08979 L
.73626 .08979 L
.73726 .08979 L
.73826 .08979 L
.73926 .08979 L
.74026 .08979 L
.74126 .08979 L
.74226 .08979 L
.74326 .08979 L
.74426 .08979 L
.74525 .08979 L
.74625 .08979 L
.74725 .08979 L
Mistroke
.74825 .08979 L
.74925 .09104 L
.75025 .09104 L
.75125 .09104 L
.75225 .09104 L
.75325 .09104 L
.75425 .09104 L
.75524 .09104 L
.75624 .09104 L
.75724 .09104 L
.75824 .09104 L
.75924 .09104 L
.76024 .09104 L
.76124 .09104 L
.76224 .09104 L
.76324 .09104 L
.76424 .09104 L
.76523 .09104 L
.76623 .09104 L
.76723 .09104 L
.76823 .09104 L
.76923 .09104 L
.77023 .09104 L
.77123 .09104 L
.77223 .09104 L
.77323 .09104 L
.77423 .09104 L
.77522 .09104 L
.77622 .09104 L
.77722 .09104 L
.77822 .09104 L
.77922 .09104 L
.78022 .09104 L
.78122 .09104 L
.78222 .09104 L
.78322 .09104 L
.78422 .09104 L
.78521 .09104 L
.78621 .09104 L
.78721 .09104 L
.78821 .09104 L
.78921 .09104 L
.79021 .09104 L
.79121 .09104 L
.79221 .09104 L
.79321 .09104 L
.79421 .09104 L
.7952 .09104 L
.7962 .09104 L
.7972 .09104 L
Mistroke
.7982 .09104 L
.7992 .09198 L
.8002 .09198 L
.8012 .09198 L
.8022 .09198 L
.8032 .09198 L
.8042 .09198 L
.80519 .09198 L
.80619 .09198 L
.80719 .09198 L
.80819 .09198 L
.80919 .09198 L
.81019 .09198 L
.81119 .09198 L
.81219 .09198 L
.81319 .09198 L
.81419 .09198 L
.81518 .09198 L
.81618 .09198 L
.81718 .09198 L
.81818 .09198 L
.81918 .09198 L
.82018 .09198 L
.82118 .09198 L
.82218 .09198 L
.82318 .09198 L
.82418 .09198 L
.82517 .09198 L
.82617 .09198 L
.82717 .09198 L
.82817 .09198 L
.82917 .09198 L
.83017 .09198 L
.83117 .09198 L
.83217 .09198 L
.83317 .09198 L
.83417 .09198 L
.83516 .09198 L
.83616 .09198 L
.83716 .09198 L
.83816 .09198 L
.83916 .09198 L
.84016 .09198 L
.84116 .09198 L
.84216 .09198 L
.84316 .09198 L
.84416 .09198 L
.84515 .09198 L
.84615 .09198 L
.84715 .09198 L
Mistroke
.84815 .09198 L
.84915 .09224 L
.85015 .09224 L
.85115 .09224 L
.85215 .09224 L
.85315 .09224 L
.85415 .09224 L
.85514 .09224 L
.85614 .09224 L
.85714 .09224 L
.85814 .09224 L
.85914 .09224 L
.86014 .09224 L
.86114 .09224 L
.86214 .09224 L
.86314 .09224 L
.86414 .09224 L
.86513 .09224 L
.86613 .09224 L
.86713 .09224 L
.86813 .09224 L
.86913 .09224 L
.87013 .09224 L
.87113 .09224 L
.87213 .09224 L
.87313 .09224 L
.87413 .09224 L
.87512 .09224 L
.87612 .09224 L
.87712 .09224 L
.87812 .09224 L
.87912 .09224 L
.88012 .09224 L
.88112 .09224 L
.88212 .09224 L
.88312 .09224 L
.88412 .09224 L
.88511 .09224 L
.88611 .09224 L
.88711 .09224 L
.88811 .09224 L
.88911 .09224 L
.89011 .09224 L
.89111 .09224 L
.89211 .09224 L
.89311 .09224 L
.89411 .09224 L
.8951 .09224 L
.8961 .09224 L
.8971 .09224 L
Mistroke
.8981 .09224 L
.8991 .09562 L
.9001 .09562 L
.9011 .09562 L
.9021 .09562 L
.9031 .09562 L
.9041 .09562 L
.90509 .09562 L
.90609 .09562 L
.90709 .09562 L
.90809 .09562 L
.90909 .09562 L
.91009 .09562 L
.91109 .09562 L
.91209 .09562 L
.91309 .09562 L
.91409 .09562 L
.91508 .09562 L
.91608 .09562 L
.91708 .09562 L
.91808 .09562 L
.91908 .09562 L
.92008 .09562 L
.92108 .09562 L
.92208 .09562 L
.92308 .09562 L
.92408 .09562 L
.92507 .09562 L
.92607 .09562 L
.92707 .09562 L
.92807 .09562 L
.92907 .09562 L
.93007 .09562 L
.93107 .09562 L
.93207 .09562 L
.93307 .09562 L
.93407 .09562 L
.93506 .09562 L
.93606 .09562 L
.93706 .09562 L
.93806 .09562 L
.93906 .09562 L
.94006 .09562 L
.94106 .09562 L
.94206 .09562 L
.94306 .09562 L
.94406 .09562 L
.94505 .09562 L
.94605 .09562 L
.94705 .09562 L
Mistroke
.94805 .09562 L
.94905 .09746 L
.95005 .09746 L
.95105 .09746 L
.95205 .09746 L
.95305 .09746 L
.95405 .09746 L
.95504 .09746 L
.95604 .09746 L
.95704 .09746 L
.95804 .09746 L
.95904 .09746 L
.96004 .09746 L
.96104 .09746 L
.96204 .09746 L
.96304 .09746 L
.96404 .09746 L
.96503 .09746 L
.96603 .09746 L
.96703 .09746 L
.96803 .09746 L
.96903 .09746 L
.97003 .09746 L
.97103 .09746 L
.97203 .09746 L
.97303 .09746 L
.97403 .09746 L
.97502 .09746 L
.97602 .09746 L
.97702 .09746 L
.97802 .09746 L
.97902 .09746 L
.98002 .09746 L
.98102 .09746 L
.98202 .09746 L
.98302 .09746 L
.98402 .09746 L
.98501 .09746 L
.98601 .09746 L
.98701 .09746 L
.98801 .09746 L
.98901 .09746 L
.99001 .09746 L
.99101 .09746 L
.99201 .09746 L
.99301 .09746 L
.99401 .09746 L
.995 .09746 L
.996 .09746 L
.997 .09746 L
Mistroke
.998 .09746 L
.999 .09729 L
Mfstroke
gsave
.999 .11387 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .43468 m
.001 .43468 L
.002 .43468 L
.003 .43468 L
.004 .43468 L
.005 .43468 L
.00599 .43468 L
.00699 .43468 L
.00799 .43468 L
.00899 .43468 L
.00999 .43468 L
.01099 .43468 L
.01199 .43468 L
.01299 .43468 L
.01399 .43468 L
.01499 .43468 L
.01598 .43468 L
.01698 .43468 L
.01798 .43468 L
.01898 .43468 L
.01998 .43468 L
.02098 .43468 L
.02198 .43468 L
.02298 .43468 L
.02398 .43468 L
.02498 .43468 L
.02597 .43468 L
.02697 .43468 L
.02797 .43468 L
.02897 .43468 L
.02997 .43468 L
.03097 .43468 L
.03197 .43468 L
.03297 .43468 L
.03397 .43468 L
.03497 .43468 L
.03596 .43468 L
.03696 .43468 L
.03796 .43468 L
.03896 .43468 L
.03996 .43468 L
.04096 .43468 L
.04196 .43468 L
.04296 .43468 L
.04396 .43468 L
.04496 .43468 L
.04595 .43468 L
.04695 .43468 L
.04795 .43468 L
.04895 .43468 L
Mistroke
.04995 .01083 L
.05095 .01083 L
.05195 .01083 L
.05295 .01083 L
.05395 .01083 L
.05495 .01083 L
.05594 .01083 L
.05694 .01083 L
.05794 .01083 L
.05894 .01083 L
.05994 .01083 L
.06094 .01083 L
.06194 .01083 L
.06294 .01083 L
.06394 .01083 L
.06494 .01083 L
.06593 .01083 L
.06693 .01083 L
.06793 .01083 L
.06893 .01083 L
.06993 .01083 L
.07093 .01083 L
.07193 .01083 L
.07293 .01083 L
.07393 .01083 L
.07493 .01083 L
.07592 .01083 L
.07692 .01083 L
.07792 .01083 L
.07892 .01083 L
.07992 .01083 L
.08092 .01083 L
.08192 .01083 L
.08292 .01083 L
.08392 .01083 L
.08492 .01083 L
.08591 .01083 L
.08691 .01083 L
.08791 .01083 L
.08891 .01083 L
.08991 .01083 L
.09091 .01083 L
.09191 .01083 L
.09291 .01083 L
.09391 .01083 L
.09491 .01083 L
.0959 .01083 L
.0969 .01083 L
.0979 .01083 L
.0989 .01083 L
Mistroke
.0999 .08223 L
.1009 .08223 L
.1019 .08223 L
.1029 .08223 L
.1039 .08223 L
.1049 .08223 L
.10589 .08223 L
.10689 .08223 L
.10789 .08223 L
.10889 .08223 L
.10989 .08223 L
.11089 .08223 L
.11189 .08223 L
.11289 .08223 L
.11389 .08223 L
.11489 .08223 L
.11588 .08223 L
.11688 .08223 L
.11788 .08223 L
.11888 .08223 L
.11988 .08223 L
.12088 .08223 L
.12188 .08223 L
.12288 .08223 L
.12388 .08223 L
.12488 .08223 L
.12587 .08223 L
.12687 .08223 L
.12787 .08223 L
.12887 .08223 L
.12987 .08223 L
.13087 .08223 L
.13187 .08223 L
.13287 .08223 L
.13387 .08223 L
.13487 .08223 L
.13586 .08223 L
.13686 .08223 L
.13786 .08223 L
.13886 .08223 L
.13986 .08223 L
.14086 .08223 L
.14186 .08223 L
.14286 .08223 L
.14386 .08223 L
.14486 .08223 L
.14585 .08223 L
.14685 .08223 L
.14785 .08223 L
.14885 .08223 L
Mistroke
.14985 .08009 L
.15085 .08009 L
.15185 .08009 L
.15285 .08009 L
.15385 .08009 L
.15485 .08009 L
.15584 .08009 L
.15684 .08009 L
.15784 .08009 L
.15884 .08009 L
.15984 .08009 L
.16084 .08009 L
.16184 .08009 L
.16284 .08009 L
.16384 .08009 L
.16484 .08009 L
.16583 .08009 L
.16683 .08009 L
.16783 .08009 L
.16883 .08009 L
.16983 .08009 L
.17083 .08009 L
.17183 .08009 L
.17283 .08009 L
.17383 .08009 L
.17483 .08009 L
.17582 .08009 L
.17682 .08009 L
.17782 .08009 L
.17882 .08009 L
.17982 .08009 L
.18082 .08009 L
.18182 .08009 L
.18282 .08009 L
.18382 .08009 L
.18482 .08009 L
.18581 .08009 L
.18681 .08009 L
.18781 .08009 L
.18881 .08009 L
.18981 .08009 L
.19081 .08009 L
.19181 .08009 L
.19281 .08009 L
.19381 .08009 L
.19481 .08009 L
.1958 .08009 L
.1968 .08009 L
.1978 .08009 L
.1988 .08009 L
Mistroke
.1998 .0896 L
.2008 .0896 L
.2018 .0896 L
.2028 .0896 L
.2038 .0896 L
.2048 .0896 L
.20579 .0896 L
.20679 .0896 L
.20779 .0896 L
.20879 .0896 L
.20979 .0896 L
.21079 .0896 L
.21179 .0896 L
.21279 .0896 L
.21379 .0896 L
.21479 .0896 L
.21578 .0896 L
.21678 .0896 L
.21778 .0896 L
.21878 .0896 L
.21978 .0896 L
.22078 .0896 L
.22178 .0896 L
.22278 .0896 L
.22378 .0896 L
.22478 .0896 L
.22577 .0896 L
.22677 .0896 L
.22777 .0896 L
.22877 .0896 L
.22977 .0896 L
.23077 .0896 L
.23177 .0896 L
.23277 .0896 L
.23377 .0896 L
.23477 .0896 L
.23576 .0896 L
.23676 .0896 L
.23776 .0896 L
.23876 .0896 L
.23976 .0896 L
.24076 .0896 L
.24176 .0896 L
.24276 .0896 L
.24376 .0896 L
.24476 .0896 L
.24575 .0896 L
.24675 .0896 L
.24775 .0896 L
.24875 .0896 L
Mistroke
.24975 .09227 L
.25075 .09227 L
.25175 .09227 L
.25275 .09227 L
.25375 .09227 L
.25475 .09227 L
.25574 .09227 L
.25674 .09227 L
.25774 .09227 L
.25874 .09227 L
.25974 .09227 L
.26074 .09227 L
.26174 .09227 L
.26274 .09227 L
.26374 .09227 L
.26474 .09227 L
.26573 .09227 L
.26673 .09227 L
.26773 .09227 L
.26873 .09227 L
.26973 .09227 L
.27073 .09227 L
.27173 .09227 L
.27273 .09227 L
.27373 .09227 L
.27473 .09227 L
.27572 .09227 L
.27672 .09227 L
.27772 .09227 L
.27872 .09227 L
.27972 .09227 L
.28072 .09227 L
.28172 .09227 L
.28272 .09227 L
.28372 .09227 L
.28472 .09227 L
.28571 .09227 L
.28671 .09227 L
.28771 .09227 L
.28871 .09227 L
.28971 .09227 L
.29071 .09227 L
.29171 .09227 L
.29271 .09227 L
.29371 .09227 L
.29471 .09227 L
.2957 .09227 L
.2967 .09227 L
.2977 .09227 L
.2987 .09227 L
Mistroke
.2997 .09282 L
.3007 .09282 L
.3017 .09282 L
.3027 .09282 L
.3037 .09282 L
.3047 .09282 L
.30569 .09282 L
.30669 .09282 L
.30769 .09282 L
.30869 .09282 L
.30969 .09282 L
.31069 .09282 L
.31169 .09282 L
.31269 .09282 L
.31369 .09282 L
.31469 .09282 L
.31568 .09282 L
.31668 .09282 L
.31768 .09282 L
.31868 .09282 L
.31968 .09282 L
.32068 .09282 L
.32168 .09282 L
.32268 .09282 L
.32368 .09282 L
.32468 .09282 L
.32567 .09282 L
.32667 .09282 L
.32767 .09282 L
.32867 .09282 L
.32967 .09282 L
.33067 .09282 L
.33167 .09282 L
.33267 .09282 L
.33367 .09282 L
.33467 .09282 L
.33566 .09282 L
.33666 .09282 L
.33766 .09282 L
.33866 .09282 L
.33966 .09282 L
.34066 .09282 L
.34166 .09282 L
.34266 .09282 L
.34366 .09282 L
.34466 .09282 L
.34565 .09282 L
.34665 .09282 L
.34765 .09282 L
.34865 .09282 L
Mistroke
.34965 .09508 L
.35065 .09508 L
.35165 .09508 L
.35265 .09508 L
.35365 .09508 L
.35465 .09508 L
.35564 .09508 L
.35664 .09508 L
.35764 .09508 L
.35864 .09508 L
.35964 .09508 L
.36064 .09508 L
.36164 .09508 L
.36264 .09508 L
.36364 .09508 L
.36464 .09508 L
.36563 .09508 L
.36663 .09508 L
.36763 .09508 L
.36863 .09508 L
.36963 .09508 L
.37063 .09508 L
.37163 .09508 L
.37263 .09508 L
.37363 .09508 L
.37463 .09508 L
.37562 .09508 L
.37662 .09508 L
.37762 .09508 L
.37862 .09508 L
.37962 .09508 L
.38062 .09508 L
.38162 .09508 L
.38262 .09508 L
.38362 .09508 L
.38462 .09508 L
.38561 .09508 L
.38661 .09508 L
.38761 .09508 L
.38861 .09508 L
.38961 .09508 L
.39061 .09508 L
.39161 .09508 L
.39261 .09508 L
.39361 .09508 L
.39461 .09508 L
.3956 .09508 L
.3966 .09508 L
.3976 .09508 L
.3986 .09508 L
Mistroke
.3996 .10353 L
.4006 .10353 L
.4016 .10353 L
.4026 .10353 L
.4036 .10353 L
.4046 .10353 L
.40559 .10353 L
.40659 .10353 L
.40759 .10353 L
.40859 .10353 L
.40959 .10353 L
.41059 .10353 L
.41159 .10353 L
.41259 .10353 L
.41359 .10353 L
.41459 .10353 L
.41558 .10353 L
.41658 .10353 L
.41758 .10353 L
.41858 .10353 L
.41958 .10353 L
.42058 .10353 L
.42158 .10353 L
.42258 .10353 L
.42358 .10353 L
.42458 .10353 L
.42557 .10353 L
.42657 .10353 L
.42757 .10353 L
.42857 .10353 L
.42957 .10353 L
.43057 .10353 L
.43157 .10353 L
.43257 .10353 L
.43357 .10353 L
.43457 .10353 L
.43556 .10353 L
.43656 .10353 L
.43756 .10353 L
.43856 .10353 L
.43956 .10353 L
.44056 .10353 L
.44156 .10353 L
.44256 .10353 L
.44356 .10353 L
.44456 .10353 L
.44555 .10353 L
.44655 .10353 L
.44755 .10353 L
.44855 .10353 L
Mistroke
.44955 .10388 L
.45055 .10388 L
.45155 .10388 L
.45255 .10388 L
.45355 .10388 L
.45455 .10388 L
.45554 .10388 L
.45654 .10388 L
.45754 .10388 L
.45854 .10388 L
.45954 .10388 L
.46054 .10388 L
.46154 .10388 L
.46254 .10388 L
.46354 .10388 L
.46454 .10388 L
.46553 .10388 L
.46653 .10388 L
.46753 .10388 L
.46853 .10388 L
.46953 .10388 L
.47053 .10388 L
.47153 .10388 L
.47253 .10388 L
.47353 .10388 L
.47453 .10388 L
.47552 .10388 L
.47652 .10388 L
.47752 .10388 L
.47852 .10388 L
.47952 .10388 L
.48052 .10388 L
.48152 .10388 L
.48252 .10388 L
.48352 .10388 L
.48452 .10388 L
.48551 .10388 L
.48651 .10388 L
.48751 .10388 L
.48851 .10388 L
.48951 .10388 L
.49051 .10388 L
.49151 .10388 L
.49251 .10388 L
.49351 .10388 L
.49451 .10388 L
.4955 .10388 L
.4965 .10388 L
.4975 .10388 L
.4985 .10388 L
Mistroke
.4995 .10126 L
.5005 .10126 L
.5015 .10126 L
.5025 .10126 L
.5035 .10126 L
.5045 .10126 L
.50549 .10126 L
.50649 .10126 L
.50749 .10126 L
.50849 .10126 L
.50949 .10126 L
.51049 .10126 L
.51149 .10126 L
.51249 .10126 L
.51349 .10126 L
.51449 .10126 L
.51548 .10126 L
.51648 .10126 L
.51748 .10126 L
.51848 .10126 L
.51948 .10126 L
.52048 .10126 L
.52148 .10126 L
.52248 .10126 L
.52348 .10126 L
.52448 .10126 L
.52547 .10126 L
.52647 .10126 L
.52747 .10126 L
.52847 .10126 L
.52947 .10126 L
.53047 .10126 L
.53147 .10126 L
.53247 .10126 L
.53347 .10126 L
.53447 .10126 L
.53546 .10126 L
.53646 .10126 L
.53746 .10126 L
.53846 .10126 L
.53946 .10126 L
.54046 .10126 L
.54146 .10126 L
.54246 .10126 L
.54346 .10126 L
.54446 .10126 L
.54545 .10126 L
.54645 .10126 L
.54745 .10126 L
.54845 .10126 L
Mistroke
.54945 .10659 L
.55045 .10659 L
.55145 .10659 L
.55245 .10659 L
.55345 .10659 L
.55445 .10659 L
.55544 .10659 L
.55644 .10659 L
.55744 .10659 L
.55844 .10659 L
.55944 .10659 L
.56044 .10659 L
.56144 .10659 L
.56244 .10659 L
.56344 .10659 L
.56444 .10659 L
.56543 .10659 L
.56643 .10659 L
.56743 .10659 L
.56843 .10659 L
.56943 .10659 L
.57043 .10659 L
.57143 .10659 L
.57243 .10659 L
.57343 .10659 L
.57443 .10659 L
.57542 .10659 L
.57642 .10659 L
.57742 .10659 L
.57842 .10659 L
.57942 .10659 L
.58042 .10659 L
.58142 .10659 L
.58242 .10659 L
.58342 .10659 L
.58442 .10659 L
.58541 .10659 L
.58641 .10659 L
.58741 .10659 L
.58841 .10659 L
.58941 .10659 L
.59041 .10659 L
.59141 .10659 L
.59241 .10659 L
.59341 .10659 L
.59441 .10659 L
.5954 .10659 L
.5964 .10659 L
.5974 .10659 L
.5984 .10659 L
Mistroke
.5994 .10772 L
.6004 .10772 L
.6014 .10772 L
.6024 .10772 L
.6034 .10772 L
.6044 .10772 L
.60539 .10772 L
.60639 .10772 L
.60739 .10772 L
.60839 .10772 L
.60939 .10772 L
.61039 .10772 L
.61139 .10772 L
.61239 .10772 L
.61339 .10772 L
.61439 .10772 L
.61538 .10772 L
.61638 .10772 L
.61738 .10772 L
.61838 .10772 L
.61938 .10772 L
.62038 .10772 L
.62138 .10772 L
.62238 .10772 L
.62338 .10772 L
.62438 .10772 L
.62537 .10772 L
.62637 .10772 L
.62737 .10772 L
.62837 .10772 L
.62937 .10772 L
.63037 .10772 L
.63137 .10772 L
.63237 .10772 L
.63337 .10772 L
.63437 .10772 L
.63536 .10772 L
.63636 .10772 L
.63736 .10772 L
.63836 .10772 L
.63936 .10772 L
.64036 .10772 L
.64136 .10772 L
.64236 .10772 L
.64336 .10772 L
.64436 .10772 L
.64535 .10772 L
.64635 .10772 L
.64735 .10772 L
.64835 .10772 L
Mistroke
.64935 .10736 L
.65035 .10736 L
.65135 .10736 L
.65235 .10736 L
.65335 .10736 L
.65435 .10736 L
.65534 .10736 L
.65634 .10736 L
.65734 .10736 L
.65834 .10736 L
.65934 .10736 L
.66034 .10736 L
.66134 .10736 L
.66234 .10736 L
.66334 .10736 L
.66434 .10736 L
.66533 .10736 L
.66633 .10736 L
.66733 .10736 L
.66833 .10736 L
.66933 .10736 L
.67033 .10736 L
.67133 .10736 L
.67233 .10736 L
.67333 .10736 L
.67433 .10736 L
.67532 .10736 L
.67632 .10736 L
.67732 .10736 L
.67832 .10736 L
.67932 .10736 L
.68032 .10736 L
.68132 .10736 L
.68232 .10736 L
.68332 .10736 L
.68432 .10736 L
.68531 .10736 L
.68631 .10736 L
.68731 .10736 L
.68831 .10736 L
.68931 .10736 L
.69031 .10736 L
.69131 .10736 L
.69231 .10736 L
.69331 .10736 L
.69431 .10736 L
.6953 .10736 L
.6963 .10736 L
.6973 .10736 L
.6983 .10736 L
Mistroke
.6993 .10819 L
.7003 .10819 L
.7013 .10819 L
.7023 .10819 L
.7033 .10819 L
.7043 .10819 L
.70529 .10819 L
.70629 .10819 L
.70729 .10819 L
.70829 .10819 L
.70929 .10819 L
.71029 .10819 L
.71129 .10819 L
.71229 .10819 L
.71329 .10819 L
.71429 .10819 L
.71528 .10819 L
.71628 .10819 L
.71728 .10819 L
.71828 .10819 L
.71928 .10819 L
.72028 .10819 L
.72128 .10819 L
.72228 .10819 L
.72328 .10819 L
.72428 .10819 L
.72527 .10819 L
.72627 .10819 L
.72727 .10819 L
.72827 .10819 L
.72927 .10819 L
.73027 .10819 L
.73127 .10819 L
.73227 .10819 L
.73327 .10819 L
.73427 .10819 L
.73526 .10819 L
.73626 .10819 L
.73726 .10819 L
.73826 .10819 L
.73926 .10819 L
.74026 .10819 L
.74126 .10819 L
.74226 .10819 L
.74326 .10819 L
.74426 .10819 L
.74525 .10819 L
.74625 .10819 L
.74725 .10819 L
.74825 .10819 L
Mistroke
.74925 .10889 L
.75025 .10889 L
.75125 .10889 L
.75225 .10889 L
.75325 .10889 L
.75425 .10889 L
.75524 .10889 L
.75624 .10889 L
.75724 .10889 L
.75824 .10889 L
.75924 .10889 L
.76024 .10889 L
.76124 .10889 L
.76224 .10889 L
.76324 .10889 L
.76424 .10889 L
.76523 .10889 L
.76623 .10889 L
.76723 .10889 L
.76823 .10889 L
.76923 .10889 L
.77023 .10889 L
.77123 .10889 L
.77223 .10889 L
.77323 .10889 L
.77423 .10889 L
.77522 .10889 L
.77622 .10889 L
.77722 .10889 L
.77822 .10889 L
.77922 .10889 L
.78022 .10889 L
.78122 .10889 L
.78222 .10889 L
.78322 .10889 L
.78422 .10889 L
.78521 .10889 L
.78621 .10889 L
.78721 .10889 L
.78821 .10889 L
.78921 .10889 L
.79021 .10889 L
.79121 .10889 L
.79221 .10889 L
.79321 .10889 L
.79421 .10889 L
.7952 .10889 L
.7962 .10889 L
.7972 .10889 L
.7982 .10889 L
Mistroke
.7992 .10945 L
.8002 .10945 L
.8012 .10945 L
.8022 .10945 L
.8032 .10945 L
.8042 .10945 L
.80519 .10945 L
.80619 .10945 L
.80719 .10945 L
.80819 .10945 L
.80919 .10945 L
.81019 .10945 L
.81119 .10945 L
.81219 .10945 L
.81319 .10945 L
.81419 .10945 L
.81518 .10945 L
.81618 .10945 L
.81718 .10945 L
.81818 .10945 L
.81918 .10945 L
.82018 .10945 L
.82118 .10945 L
.82218 .10945 L
.82318 .10945 L
.82418 .10945 L
.82517 .10945 L
.82617 .10945 L
.82717 .10945 L
.82817 .10945 L
.82917 .10945 L
.83017 .10945 L
.83117 .10945 L
.83217 .10945 L
.83317 .10945 L
.83417 .10945 L
.83516 .10945 L
.83616 .10945 L
.83716 .10945 L
.83816 .10945 L
.83916 .10945 L
.84016 .10945 L
.84116 .10945 L
.84216 .10945 L
.84316 .10945 L
.84416 .10945 L
.84515 .10945 L
.84615 .10945 L
.84715 .10945 L
.84815 .10945 L
Mistroke
.84915 .10942 L
.85015 .10942 L
.85115 .10942 L
.85215 .10942 L
.85315 .10942 L
.85415 .10942 L
.85514 .10942 L
.85614 .10942 L
.85714 .10942 L
.85814 .10942 L
.85914 .10942 L
.86014 .10942 L
.86114 .10942 L
.86214 .10942 L
.86314 .10942 L
.86414 .10942 L
.86513 .10942 L
.86613 .10942 L
.86713 .10942 L
.86813 .10942 L
.86913 .10942 L
.87013 .10942 L
.87113 .10942 L
.87213 .10942 L
.87313 .10942 L
.87413 .10942 L
.87512 .10942 L
.87612 .10942 L
.87712 .10942 L
.87812 .10942 L
.87912 .10942 L
.88012 .10942 L
.88112 .10942 L
.88212 .10942 L
.88312 .10942 L
.88412 .10942 L
.88511 .10942 L
.88611 .10942 L
.88711 .10942 L
.88811 .10942 L
.88911 .10942 L
.89011 .10942 L
.89111 .10942 L
.89211 .10942 L
.89311 .10942 L
.89411 .10942 L
.8951 .10942 L
.8961 .10942 L
.8971 .10942 L
.8981 .10942 L
Mistroke
.8991 .11241 L
.9001 .11241 L
.9011 .11241 L
.9021 .11241 L
.9031 .11241 L
.9041 .11241 L
.90509 .11241 L
.90609 .11241 L
.90709 .11241 L
.90809 .11241 L
.90909 .11241 L
.91009 .11241 L
.91109 .11241 L
.91209 .11241 L
.91309 .11241 L
.91409 .11241 L
.91508 .11241 L
.91608 .11241 L
.91708 .11241 L
.91808 .11241 L
.91908 .11241 L
.92008 .11241 L
.92108 .11241 L
.92208 .11241 L
.92308 .11241 L
.92408 .11241 L
.92507 .11241 L
.92607 .11241 L
.92707 .11241 L
.92807 .11241 L
.92907 .11241 L
.93007 .11241 L
.93107 .11241 L
.93207 .11241 L
.93307 .11241 L
.93407 .11241 L
.93506 .11241 L
.93606 .11241 L
.93706 .11241 L
.93806 .11241 L
.93906 .11241 L
.94006 .11241 L
.94106 .11241 L
.94206 .11241 L
.94306 .11241 L
.94406 .11241 L
.94505 .11241 L
.94605 .11241 L
.94705 .11241 L
.94805 .11241 L
Mistroke
.94905 .11412 L
.95005 .11412 L
.95105 .11412 L
.95205 .11412 L
.95305 .11412 L
.95405 .11412 L
.95504 .11412 L
.95604 .11412 L
.95704 .11412 L
.95804 .11412 L
.95904 .11412 L
.96004 .11412 L
.96104 .11412 L
.96204 .11412 L
.96304 .11412 L
.96404 .11412 L
.96503 .11412 L
.96603 .11412 L
.96703 .11412 L
.96803 .11412 L
.96903 .11412 L
.97003 .11412 L
.97103 .11412 L
.97203 .11412 L
.97303 .11412 L
.97403 .11412 L
.97502 .11412 L
.97602 .11412 L
.97702 .11412 L
.97802 .11412 L
.97902 .11412 L
.98002 .11412 L
.98102 .11412 L
.98202 .11412 L
.98302 .11412 L
.98402 .11412 L
.98501 .11412 L
.98601 .11412 L
.98701 .11412 L
.98801 .11412 L
.98901 .11412 L
.99001 .11412 L
.99101 .11412 L
.99201 .11412 L
.99301 .11412 L
.99401 .11412 L
.995 .11412 L
.996 .11412 L
.997 .11412 L
.998 .11412 L
Mistroke
.999 .11387 L
Mfstroke
1 0 0 r
gsave
.999 .10558 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .28327 m
.001 .28327 L
.002 .28327 L
.003 .28327 L
.004 .28327 L
.005 .28327 L
.00599 .28327 L
.00699 .28327 L
.00799 .28327 L
.00899 .28327 L
.00999 .28327 L
.01099 .28327 L
.01199 .28327 L
.01299 .28327 L
.01399 .28327 L
.01499 .28327 L
.01598 .28327 L
.01698 .28327 L
.01798 .28327 L
.01898 .28327 L
.01998 .28327 L
.02098 .28327 L
.02198 .28327 L
.02298 .28327 L
.02398 .28327 L
.02498 .28327 L
.02597 .28327 L
.02697 .28327 L
.02797 .28327 L
.02897 .28327 L
.02997 .28327 L
.03097 .28327 L
.03197 .28327 L
.03297 .28327 L
.03397 .28327 L
.03497 .28327 L
.03596 .28327 L
.03696 .28327 L
.03796 .28327 L
.03896 .28327 L
.03996 .28327 L
.04096 .28327 L
.04196 .28327 L
.04296 .28327 L
.04396 .28327 L
.04496 .28327 L
.04595 .28327 L
.04695 .28327 L
.04795 .28327 L
.04895 .28327 L
Mistroke
Mfstroke
.04895 .28327 m
.04985 0 L
s
.09922 0 m
.0999 .06858 L
.1009 .06858 L
.1019 .06858 L
.1029 .06858 L
.1039 .06858 L
.1049 .06858 L
.10589 .06858 L
.10689 .06858 L
.10789 .06858 L
.10889 .06858 L
.10989 .06858 L
.11089 .06858 L
.11189 .06858 L
.11289 .06858 L
.11389 .06858 L
.11489 .06858 L
.11588 .06858 L
.11688 .06858 L
.11788 .06858 L
.11888 .06858 L
.11988 .06858 L
.12088 .06858 L
.12188 .06858 L
.12288 .06858 L
.12388 .06858 L
.12488 .06858 L
.12587 .06858 L
.12687 .06858 L
.12787 .06858 L
.12887 .06858 L
.12987 .06858 L
.13087 .06858 L
.13187 .06858 L
.13287 .06858 L
.13387 .06858 L
.13487 .06858 L
.13586 .06858 L
.13686 .06858 L
.13786 .06858 L
.13886 .06858 L
.13986 .06858 L
.14086 .06858 L
.14186 .06858 L
.14286 .06858 L
.14386 .06858 L
.14486 .06858 L
.14585 .06858 L
.14685 .06858 L
.14785 .06858 L
Mistroke
.14885 .06858 L
.14985 .06701 L
.15085 .06701 L
.15185 .06701 L
.15285 .06701 L
.15385 .06701 L
.15485 .06701 L
.15584 .06701 L
.15684 .06701 L
.15784 .06701 L
.15884 .06701 L
.15984 .06701 L
.16084 .06701 L
.16184 .06701 L
.16284 .06701 L
.16384 .06701 L
.16484 .06701 L
.16583 .06701 L
.16683 .06701 L
.16783 .06701 L
.16883 .06701 L
.16983 .06701 L
.17083 .06701 L
.17183 .06701 L
.17283 .06701 L
.17383 .06701 L
.17483 .06701 L
.17582 .06701 L
.17682 .06701 L
.17782 .06701 L
.17882 .06701 L
.17982 .06701 L
.18082 .06701 L
.18182 .06701 L
.18282 .06701 L
.18382 .06701 L
.18482 .06701 L
.18581 .06701 L
.18681 .06701 L
.18781 .06701 L
.18881 .06701 L
.18981 .06701 L
.19081 .06701 L
.19181 .06701 L
.19281 .06701 L
.19381 .06701 L
.19481 .06701 L
.1958 .06701 L
.1968 .06701 L
.1978 .06701 L
Mistroke
.1988 .06701 L
.1998 .07781 L
.2008 .07781 L
.2018 .07781 L
.2028 .07781 L
.2038 .07781 L
.2048 .07781 L
.20579 .07781 L
.20679 .07781 L
.20779 .07781 L
.20879 .07781 L
.20979 .07781 L
.21079 .07781 L
.21179 .07781 L
.21279 .07781 L
.21379 .07781 L
.21479 .07781 L
.21578 .07781 L
.21678 .07781 L
.21778 .07781 L
.21878 .07781 L
.21978 .07781 L
.22078 .07781 L
.22178 .07781 L
.22278 .07781 L
.22378 .07781 L
.22478 .07781 L
.22577 .07781 L
.22677 .07781 L
.22777 .07781 L
.22877 .07781 L
.22977 .07781 L
.23077 .07781 L
.23177 .07781 L
.23277 .07781 L
.23377 .07781 L
.23477 .07781 L
.23576 .07781 L
.23676 .07781 L
.23776 .07781 L
.23876 .07781 L
.23976 .07781 L
.24076 .07781 L
.24176 .07781 L
.24276 .07781 L
.24376 .07781 L
.24476 .07781 L
.24575 .07781 L
.24675 .07781 L
.24775 .07781 L
Mistroke
.24875 .07781 L
.24975 .08086 L
.25075 .08086 L
.25175 .08086 L
.25275 .08086 L
.25375 .08086 L
.25475 .08086 L
.25574 .08086 L
.25674 .08086 L
.25774 .08086 L
.25874 .08086 L
.25974 .08086 L
.26074 .08086 L
.26174 .08086 L
.26274 .08086 L
.26374 .08086 L
.26474 .08086 L
.26573 .08086 L
.26673 .08086 L
.26773 .08086 L
.26873 .08086 L
.26973 .08086 L
.27073 .08086 L
.27173 .08086 L
.27273 .08086 L
.27373 .08086 L
.27473 .08086 L
.27572 .08086 L
.27672 .08086 L
.27772 .08086 L
.27872 .08086 L
.27972 .08086 L
.28072 .08086 L
.28172 .08086 L
.28272 .08086 L
.28372 .08086 L
.28472 .08086 L
.28571 .08086 L
.28671 .08086 L
.28771 .08086 L
.28871 .08086 L
.28971 .08086 L
.29071 .08086 L
.29171 .08086 L
.29271 .08086 L
.29371 .08086 L
.29471 .08086 L
.2957 .08086 L
.2967 .08086 L
.2977 .08086 L
Mistroke
.2987 .08086 L
.2997 .08158 L
.3007 .08158 L
.3017 .08158 L
.3027 .08158 L
.3037 .08158 L
.3047 .08158 L
.30569 .08158 L
.30669 .08158 L
.30769 .08158 L
.30869 .08158 L
.30969 .08158 L
.31069 .08158 L
.31169 .08158 L
.31269 .08158 L
.31369 .08158 L
.31469 .08158 L
.31568 .08158 L
.31668 .08158 L
.31768 .08158 L
.31868 .08158 L
.31968 .08158 L
.32068 .08158 L
.32168 .08158 L
.32268 .08158 L
.32368 .08158 L
.32468 .08158 L
.32567 .08158 L
.32667 .08158 L
.32767 .08158 L
.32867 .08158 L
.32967 .08158 L
.33067 .08158 L
.33167 .08158 L
.33267 .08158 L
.33367 .08158 L
.33467 .08158 L
.33566 .08158 L
.33666 .08158 L
.33766 .08158 L
.33866 .08158 L
.33966 .08158 L
.34066 .08158 L
.34166 .08158 L
.34266 .08158 L
.34366 .08158 L
.34466 .08158 L
.34565 .08158 L
.34665 .08158 L
.34765 .08158 L
Mistroke
.34865 .08158 L
.34965 .08412 L
.35065 .08412 L
.35165 .08412 L
.35265 .08412 L
.35365 .08412 L
.35465 .08412 L
.35564 .08412 L
.35664 .08412 L
.35764 .08412 L
.35864 .08412 L
.35964 .08412 L
.36064 .08412 L
.36164 .08412 L
.36264 .08412 L
.36364 .08412 L
.36464 .08412 L
.36563 .08412 L
.36663 .08412 L
.36763 .08412 L
.36863 .08412 L
.36963 .08412 L
.37063 .08412 L
.37163 .08412 L
.37263 .08412 L
.37363 .08412 L
.37463 .08412 L
.37562 .08412 L
.37662 .08412 L
.37762 .08412 L
.37862 .08412 L
.37962 .08412 L
.38062 .08412 L
.38162 .08412 L
.38262 .08412 L
.38362 .08412 L
.38462 .08412 L
.38561 .08412 L
.38661 .08412 L
.38761 .08412 L
.38861 .08412 L
.38961 .08412 L
.39061 .08412 L
.39161 .08412 L
.39261 .08412 L
.39361 .08412 L
.39461 .08412 L
.3956 .08412 L
.3966 .08412 L
.3976 .08412 L
Mistroke
.3986 .08412 L
.3996 .09319 L
.4006 .09319 L
.4016 .09319 L
.4026 .09319 L
.4036 .09319 L
.4046 .09319 L
.40559 .09319 L
.40659 .09319 L
.40759 .09319 L
.40859 .09319 L
.40959 .09319 L
.41059 .09319 L
.41159 .09319 L
.41259 .09319 L
.41359 .09319 L
.41459 .09319 L
.41558 .09319 L
.41658 .09319 L
.41758 .09319 L
.41858 .09319 L
.41958 .09319 L
.42058 .09319 L
.42158 .09319 L
.42258 .09319 L
.42358 .09319 L
.42458 .09319 L
.42557 .09319 L
.42657 .09319 L
.42757 .09319 L
.42857 .09319 L
.42957 .09319 L
.43057 .09319 L
.43157 .09319 L
.43257 .09319 L
.43357 .09319 L
.43457 .09319 L
.43556 .09319 L
.43656 .09319 L
.43756 .09319 L
.43856 .09319 L
.43956 .09319 L
.44056 .09319 L
.44156 .09319 L
.44256 .09319 L
.44356 .09319 L
.44456 .09319 L
.44555 .09319 L
.44655 .09319 L
.44755 .09319 L
Mistroke
.44855 .09319 L
.44955 .0936 L
.45055 .0936 L
.45155 .0936 L
.45255 .0936 L
.45355 .0936 L
.45455 .0936 L
.45554 .0936 L
.45654 .0936 L
.45754 .0936 L
.45854 .0936 L
.45954 .0936 L
.46054 .0936 L
.46154 .0936 L
.46254 .0936 L
.46354 .0936 L
.46454 .0936 L
.46553 .0936 L
.46653 .0936 L
.46753 .0936 L
.46853 .0936 L
.46953 .0936 L
.47053 .0936 L
.47153 .0936 L
.47253 .0936 L
.47353 .0936 L
.47453 .0936 L
.47552 .0936 L
.47652 .0936 L
.47752 .0936 L
.47852 .0936 L
.47952 .0936 L
.48052 .0936 L
.48152 .0936 L
.48252 .0936 L
.48352 .0936 L
.48452 .0936 L
.48551 .0936 L
.48651 .0936 L
.48751 .0936 L
.48851 .0936 L
.48951 .0936 L
.49051 .0936 L
.49151 .0936 L
.49251 .0936 L
.49351 .0936 L
.49451 .0936 L
.4955 .0936 L
.4965 .0936 L
.4975 .0936 L
Mistroke
.4985 .0936 L
.4995 .09129 L
.5005 .09129 L
.5015 .09129 L
.5025 .09129 L
.5035 .09129 L
.5045 .09129 L
.50549 .09129 L
.50649 .09129 L
.50749 .09129 L
.50849 .09129 L
.50949 .09129 L
.51049 .09129 L
.51149 .09129 L
.51249 .09129 L
.51349 .09129 L
.51449 .09129 L
.51548 .09129 L
.51648 .09129 L
.51748 .09129 L
.51848 .09129 L
.51948 .09129 L
.52048 .09129 L
.52148 .09129 L
.52248 .09129 L
.52348 .09129 L
.52448 .09129 L
.52547 .09129 L
.52647 .09129 L
.52747 .09129 L
.52847 .09129 L
.52947 .09129 L
.53047 .09129 L
.53147 .09129 L
.53247 .09129 L
.53347 .09129 L
.53447 .09129 L
.53546 .09129 L
.53646 .09129 L
.53746 .09129 L
.53846 .09129 L
.53946 .09129 L
.54046 .09129 L
.54146 .09129 L
.54246 .09129 L
.54346 .09129 L
.54446 .09129 L
.54545 .09129 L
.54645 .09129 L
.54745 .09129 L
Mistroke
.54845 .09129 L
.54945 .09712 L
.55045 .09712 L
.55145 .09712 L
.55245 .09712 L
.55345 .09712 L
.55445 .09712 L
.55544 .09712 L
.55644 .09712 L
.55744 .09712 L
.55844 .09712 L
.55944 .09712 L
.56044 .09712 L
.56144 .09712 L
.56244 .09712 L
.56344 .09712 L
.56444 .09712 L
.56543 .09712 L
.56643 .09712 L
.56743 .09712 L
.56843 .09712 L
.56943 .09712 L
.57043 .09712 L
.57143 .09712 L
.57243 .09712 L
.57343 .09712 L
.57443 .09712 L
.57542 .09712 L
.57642 .09712 L
.57742 .09712 L
.57842 .09712 L
.57942 .09712 L
.58042 .09712 L
.58142 .09712 L
.58242 .09712 L
.58342 .09712 L
.58442 .09712 L
.58541 .09712 L
.58641 .09712 L
.58741 .09712 L
.58841 .09712 L
.58941 .09712 L
.59041 .09712 L
.59141 .09712 L
.59241 .09712 L
.59341 .09712 L
.59441 .09712 L
.5954 .09712 L
.5964 .09712 L
.5974 .09712 L
Mistroke
.5984 .09712 L
.5994 .09831 L
.6004 .09831 L
.6014 .09831 L
.6024 .09831 L
.6034 .09831 L
.6044 .09831 L
.60539 .09831 L
.60639 .09831 L
.60739 .09831 L
.60839 .09831 L
.60939 .09831 L
.61039 .09831 L
.61139 .09831 L
.61239 .09831 L
.61339 .09831 L
.61439 .09831 L
.61538 .09831 L
.61638 .09831 L
.61738 .09831 L
.61838 .09831 L
.61938 .09831 L
.62038 .09831 L
.62138 .09831 L
.62238 .09831 L
.62338 .09831 L
.62438 .09831 L
.62537 .09831 L
.62637 .09831 L
.62737 .09831 L
.62837 .09831 L
.62937 .09831 L
.63037 .09831 L
.63137 .09831 L
.63237 .09831 L
.63337 .09831 L
.63437 .09831 L
.63536 .09831 L
.63636 .09831 L
.63736 .09831 L
.63836 .09831 L
.63936 .09831 L
.64036 .09831 L
.64136 .09831 L
.64236 .09831 L
.64336 .09831 L
.64436 .09831 L
.64535 .09831 L
.64635 .09831 L
.64735 .09831 L
Mistroke
.64835 .09831 L
.64935 .09805 L
.65035 .09805 L
.65135 .09805 L
.65235 .09805 L
.65335 .09805 L
.65435 .09805 L
.65534 .09805 L
.65634 .09805 L
.65734 .09805 L
.65834 .09805 L
.65934 .09805 L
.66034 .09805 L
.66134 .09805 L
.66234 .09805 L
.66334 .09805 L
.66434 .09805 L
.66533 .09805 L
.66633 .09805 L
.66733 .09805 L
.66833 .09805 L
.66933 .09805 L
.67033 .09805 L
.67133 .09805 L
.67233 .09805 L
.67333 .09805 L
.67433 .09805 L
.67532 .09805 L
.67632 .09805 L
.67732 .09805 L
.67832 .09805 L
.67932 .09805 L
.68032 .09805 L
.68132 .09805 L
.68232 .09805 L
.68332 .09805 L
.68432 .09805 L
.68531 .09805 L
.68631 .09805 L
.68731 .09805 L
.68831 .09805 L
.68931 .09805 L
.69031 .09805 L
.69131 .09805 L
.69231 .09805 L
.69331 .09805 L
.69431 .09805 L
.6953 .09805 L
.6963 .09805 L
.6973 .09805 L
Mistroke
.6983 .09805 L
.6993 .09899 L
.7003 .09899 L
.7013 .09899 L
.7023 .09899 L
.7033 .09899 L
.7043 .09899 L
.70529 .09899 L
.70629 .09899 L
.70729 .09899 L
.70829 .09899 L
.70929 .09899 L
.71029 .09899 L
.71129 .09899 L
.71229 .09899 L
.71329 .09899 L
.71429 .09899 L
.71528 .09899 L
.71628 .09899 L
.71728 .09899 L
.71828 .09899 L
.71928 .09899 L
.72028 .09899 L
.72128 .09899 L
.72228 .09899 L
.72328 .09899 L
.72428 .09899 L
.72527 .09899 L
.72627 .09899 L
.72727 .09899 L
.72827 .09899 L
.72927 .09899 L
.73027 .09899 L
.73127 .09899 L
.73227 .09899 L
.73327 .09899 L
.73427 .09899 L
.73526 .09899 L
.73626 .09899 L
.73726 .09899 L
.73826 .09899 L
.73926 .09899 L
.74026 .09899 L
.74126 .09899 L
.74226 .09899 L
.74326 .09899 L
.74426 .09899 L
.74525 .09899 L
.74625 .09899 L
.74725 .09899 L
Mistroke
.74825 .09899 L
.74925 .09997 L
.75025 .09997 L
.75125 .09997 L
.75225 .09997 L
.75325 .09997 L
.75425 .09997 L
.75524 .09997 L
.75624 .09997 L
.75724 .09997 L
.75824 .09997 L
.75924 .09997 L
.76024 .09997 L
.76124 .09997 L
.76224 .09997 L
.76324 .09997 L
.76424 .09997 L
.76523 .09997 L
.76623 .09997 L
.76723 .09997 L
.76823 .09997 L
.76923 .09997 L
.77023 .09997 L
.77123 .09997 L
.77223 .09997 L
.77323 .09997 L
.77423 .09997 L
.77522 .09997 L
.77622 .09997 L
.77722 .09997 L
.77822 .09997 L
.77922 .09997 L
.78022 .09997 L
.78122 .09997 L
.78222 .09997 L
.78322 .09997 L
.78422 .09997 L
.78521 .09997 L
.78621 .09997 L
.78721 .09997 L
.78821 .09997 L
.78921 .09997 L
.79021 .09997 L
.79121 .09997 L
.79221 .09997 L
.79321 .09997 L
.79421 .09997 L
.7952 .09997 L
.7962 .09997 L
.7972 .09997 L
Mistroke
.7982 .09997 L
.7992 .10072 L
.8002 .10072 L
.8012 .10072 L
.8022 .10072 L
.8032 .10072 L
.8042 .10072 L
.80519 .10072 L
.80619 .10072 L
.80719 .10072 L
.80819 .10072 L
.80919 .10072 L
.81019 .10072 L
.81119 .10072 L
.81219 .10072 L
.81319 .10072 L
.81419 .10072 L
.81518 .10072 L
.81618 .10072 L
.81718 .10072 L
.81818 .10072 L
.81918 .10072 L
.82018 .10072 L
.82118 .10072 L
.82218 .10072 L
.82318 .10072 L
.82418 .10072 L
.82517 .10072 L
.82617 .10072 L
.82717 .10072 L
.82817 .10072 L
.82917 .10072 L
.83017 .10072 L
.83117 .10072 L
.83217 .10072 L
.83317 .10072 L
.83417 .10072 L
.83516 .10072 L
.83616 .10072 L
.83716 .10072 L
.83816 .10072 L
.83916 .10072 L
.84016 .10072 L
.84116 .10072 L
.84216 .10072 L
.84316 .10072 L
.84416 .10072 L
.84515 .10072 L
.84615 .10072 L
.84715 .10072 L
Mistroke
.84815 .10072 L
.84915 .10083 L
.85015 .10083 L
.85115 .10083 L
.85215 .10083 L
.85315 .10083 L
.85415 .10083 L
.85514 .10083 L
.85614 .10083 L
.85714 .10083 L
.85814 .10083 L
.85914 .10083 L
.86014 .10083 L
.86114 .10083 L
.86214 .10083 L
.86314 .10083 L
.86414 .10083 L
.86513 .10083 L
.86613 .10083 L
.86713 .10083 L
.86813 .10083 L
.86913 .10083 L
.87013 .10083 L
.87113 .10083 L
.87213 .10083 L
.87313 .10083 L
.87413 .10083 L
.87512 .10083 L
.87612 .10083 L
.87712 .10083 L
.87812 .10083 L
.87912 .10083 L
.88012 .10083 L
.88112 .10083 L
.88212 .10083 L
.88312 .10083 L
.88412 .10083 L
.88511 .10083 L
.88611 .10083 L
.88711 .10083 L
.88811 .10083 L
.88911 .10083 L
.89011 .10083 L
.89111 .10083 L
.89211 .10083 L
.89311 .10083 L
.89411 .10083 L
.8951 .10083 L
.8961 .10083 L
.8971 .10083 L
Mistroke
.8981 .10083 L
.8991 .10401 L
.9001 .10401 L
.9011 .10401 L
.9021 .10401 L
.9031 .10401 L
.9041 .10401 L
.90509 .10401 L
.90609 .10401 L
.90709 .10401 L
.90809 .10401 L
.90909 .10401 L
.91009 .10401 L
.91109 .10401 L
.91209 .10401 L
.91309 .10401 L
.91409 .10401 L
.91508 .10401 L
.91608 .10401 L
.91708 .10401 L
.91808 .10401 L
.91908 .10401 L
.92008 .10401 L
.92108 .10401 L
.92208 .10401 L
.92308 .10401 L
.92408 .10401 L
.92507 .10401 L
.92607 .10401 L
.92707 .10401 L
.92807 .10401 L
.92907 .10401 L
.93007 .10401 L
.93107 .10401 L
.93207 .10401 L
.93307 .10401 L
.93407 .10401 L
.93506 .10401 L
.93606 .10401 L
.93706 .10401 L
.93806 .10401 L
.93906 .10401 L
.94006 .10401 L
.94106 .10401 L
.94206 .10401 L
.94306 .10401 L
.94406 .10401 L
.94505 .10401 L
.94605 .10401 L
.94705 .10401 L
Mistroke
.94805 .10401 L
.94905 .10579 L
.95005 .10579 L
.95105 .10579 L
.95205 .10579 L
.95305 .10579 L
.95405 .10579 L
.95504 .10579 L
.95604 .10579 L
.95704 .10579 L
.95804 .10579 L
.95904 .10579 L
.96004 .10579 L
.96104 .10579 L
.96204 .10579 L
.96304 .10579 L
.96404 .10579 L
.96503 .10579 L
.96603 .10579 L
.96703 .10579 L
.96803 .10579 L
.96903 .10579 L
.97003 .10579 L
.97103 .10579 L
.97203 .10579 L
.97303 .10579 L
.97403 .10579 L
.97502 .10579 L
.97602 .10579 L
.97702 .10579 L
.97802 .10579 L
.97902 .10579 L
.98002 .10579 L
.98102 .10579 L
.98202 .10579 L
.98302 .10579 L
.98402 .10579 L
.98501 .10579 L
.98601 .10579 L
.98701 .10579 L
.98801 .10579 L
.98901 .10579 L
.99001 .10579 L
.99101 .10579 L
.99201 .10579 L
.99301 .10579 L
.99401 .10579 L
.995 .10579 L
.996 .10579 L
.997 .10579 L
Mistroke
.998 .10579 L
.999 .10558 L
Mfstroke
0 0 1 r
gsave
.001 -0.38627 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .30946 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .34801 L
.005 .34586 L
.00599 .34349 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33052 L
.01099 .32611 L
.01199 .3211 L
.01299 .31543 L
.01399 .30901 L
.01499 .30175 L
.01598 .29356 L
.01698 .28434 L
.01798 .27396 L
.01898 .26232 L
.01998 .24926 L
.02098 .23466 L
.02198 .21839 L
.02298 .20029 L
.02398 .18025 L
.02498 .15817 L
.02597 .134 L
.02697 .10773 L
.02797 .07947 L
.02897 .04946 L
.02997 .01812 L
s
.02997 .01812 m
.03054 0 L
s
.04283 0 m
.04296 .00592 L
.04396 .05476 L
.04496 .10551 L
.04595 .15683 L
.04695 .20767 L
.04795 .25711 L
.04895 .30425 L
.04995 .11983 L
.05095 .0999 L
.05195 .09251 L
.05295 .09749 L
.05395 .11451 L
.05495 .14235 L
.05594 .17887 L
.05694 .2213 L
.05794 .26651 L
.05894 .31134 L
.05994 .35304 L
.06094 .38943 L
.06194 .41893 L
.06294 .4404 L
.06394 .45298 L
.06494 .45607 L
.06593 .44968 L
.06693 .43499 L
.06793 .41424 L
.06893 .39018 L
.06993 .36549 L
.07093 .34247 L
.07193 .32291 L
.07293 .30801 L
.07393 .2983 L
.07493 .29364 L
.07592 .29314 L
.07692 .29536 L
.07792 .29907 L
.07892 .30396 L
.07992 .31023 L
.08092 .31799 L
.08192 .32696 L
.08292 .33664 L
.08392 .34633 L
.08492 .35524 L
.08591 .36245 L
.08691 .36692 L
.08791 .36769 L
.08891 .36445 L
.08991 .35807 L
.09091 .35022 L
Mistroke
.09191 .34252 L
.09291 .33619 L
.09391 .33195 L
.09491 .33006 L
.0959 .33031 L
.0969 .33204 L
.0979 .33427 L
.0989 .3361 L
.0999 .39559 L
.1009 .3897 L
.1019 .38604 L
.1029 .38326 L
.1039 .38091 L
.1049 .37881 L
.10589 .37687 L
.10689 .37505 L
.10789 .37332 L
.10889 .37169 L
.10989 .37013 L
.11089 .36864 L
.11189 .36721 L
.11289 .36585 L
.11389 .36453 L
.11489 .36326 L
.11588 .36203 L
.11688 .36083 L
.11788 .35966 L
.11888 .35852 L
.11988 .35739 L
.12088 .35628 L
.12188 .35518 L
.12288 .35409 L
.12388 .35301 L
.12488 .35193 L
.12587 .35085 L
.12687 .34977 L
.12787 .34869 L
.12887 .34762 L
.12987 .34654 L
.13087 .34546 L
.13187 .34438 L
.13287 .3433 L
.13387 .34223 L
.13487 .34116 L
.13586 .34009 L
.13686 .33904 L
.13786 .33801 L
.13886 .33699 L
.13986 .33599 L
.14086 .33502 L
Mistroke
.14186 .33408 L
.14286 .33318 L
.14386 .33231 L
.14486 .33149 L
.14585 .33072 L
.14685 .33 L
.14785 .32934 L
.14885 .32873 L
.14985 .54579 L
.15085 .51917 L
.15185 .49308 L
.15285 .46714 L
.15385 .44186 L
.15485 .41792 L
.15584 .39592 L
.15684 .37629 L
.15784 .3593 L
.15884 .34502 L
.15984 .33343 L
.16084 .32436 L
.16184 .31762 L
.16284 .31295 L
.16384 .31008 L
.16484 .30873 L
.16583 .30861 L
.16683 .30948 L
.16783 .31108 L
.16883 .3132 L
.16983 .31566 L
.17083 .31831 L
.17183 .32103 L
.17283 .32372 L
.17383 .3263 L
.17483 .32874 L
.17582 .33099 L
.17682 .33303 L
.17782 .33486 L
.17882 .33647 L
.17982 .33787 L
.18082 .33907 L
.18182 .34007 L
.18282 .34089 L
.18382 .34154 L
.18482 .34204 L
.18581 .34241 L
.18681 .34265 L
.18781 .34279 L
.18881 .34284 L
.18981 .34281 L
.19081 .3427 L
Mistroke
.19181 .34254 L
.19281 .34234 L
.19381 .34209 L
.19481 .34181 L
.1958 .3415 L
.1968 .34117 L
.1978 .34082 L
.1988 .34045 L
.1998 .27664 L
.2008 .25629 L
.2018 .24028 L
.2028 .22673 L
.2038 .21494 L
.2048 .20464 L
.20579 .19579 L
.20679 .18848 L
.20779 .18292 L
.20879 .17933 L
.20979 .17794 L
.21079 .17892 L
.21179 .18233 L
.21279 .18812 L
.21379 .1961 L
.21479 .20592 L
.21578 .21718 L
.21678 .22939 L
.21778 .2421 L
.21878 .25487 L
.21978 .26737 L
.22078 .2793 L
.22178 .29046 L
.22278 .30072 L
.22378 .30999 L
.22478 .31824 L
.22577 .32547 L
.22677 .33172 L
.22777 .33702 L
.22877 .34144 L
.22977 .34506 L
.23077 .34795 L
.23177 .35018 L
.23277 .35183 L
.23377 .35296 L
.23477 .35365 L
.23576 .35397 L
.23676 .35396 L
.23776 .3537 L
.23876 .35323 L
.23976 .35261 L
.24076 .35187 L
Mistroke
.24176 .35104 L
.24276 .35017 L
.24376 .34928 L
.24476 .34837 L
.24575 .34748 L
.24675 .3466 L
.24775 .34575 L
.24875 .34493 L
.24975 .44571 L
.25075 .44472 L
.25175 .44486 L
.25275 .44492 L
.25375 .44457 L
.25475 .44373 L
.25574 .44241 L
.25674 .44064 L
.25774 .43848 L
.25874 .43597 L
.25974 .43318 L
.26074 .43015 L
.26174 .42694 L
.26274 .42358 L
.26374 .42012 L
.26474 .41659 L
.26573 .41304 L
.26673 .40947 L
.26773 .40593 L
.26873 .40243 L
.26973 .39899 L
.27073 .39563 L
.27173 .39236 L
.27273 .38919 L
.27373 .38613 L
.27473 .3832 L
.27572 .38039 L
.27672 .3777 L
.27772 .37515 L
.27872 .37273 L
.27972 .37044 L
.28072 .36828 L
.28172 .36624 L
.28272 .36431 L
.28372 .3625 L
.28472 .3608 L
.28571 .3592 L
.28671 .35769 L
.28771 .35626 L
.28871 .35491 L
.28971 .35362 L
.29071 .3524 L
Mistroke
.29171 .35123 L
.29271 .35011 L
.29371 .34903 L
.29471 .34798 L
.2957 .34696 L
.2967 .34596 L
.2977 .34498 L
.2987 .34401 L
.2997 .41461 L
.3007 .41019 L
.3017 .40765 L
.3027 .40568 L
.3037 .40388 L
.3047 .40211 L
.30569 .40034 L
.30669 .39856 L
.30769 .39679 L
.30869 .39504 L
.30969 .39333 L
.31069 .39166 L
.31169 .39005 L
.31269 .3885 L
.31369 .38702 L
.31469 .38559 L
.31568 .38423 L
.31668 .38294 L
.31768 .3817 L
.31868 .38052 L
.31968 .3794 L
.32068 .37833 L
.32168 .37732 L
.32268 .37635 L
.32368 .37543 L
.32468 .37456 L
.32567 .37372 L
.32667 .37293 L
.32767 .37218 L
.32867 .37147 L
.32967 .37079 L
.33067 .37014 L
.33167 .36953 L
.33267 .36895 L
.33367 .3684 L
.33467 .36788 L
.33566 .36739 L
.33666 .36692 L
.33766 .36648 L
.33866 .36607 L
.33966 .36567 L
.34066 .3653 L
Mistroke
.34166 .36495 L
.34266 .36461 L
.34366 .36429 L
.34466 .36398 L
.34565 .36368 L
.34665 .36339 L
.34765 .36311 L
.34865 .36282 L
.34965 .50388 L
.35065 .48958 L
.35165 .47595 L
.35265 .46207 L
.35365 .44795 L
.35465 .43384 L
.35564 .42006 L
.35664 .40692 L
.35764 .39468 L
.35864 .3835 L
.35964 .37351 L
.36064 .36475 L
.36164 .3572 L
.36264 .35081 L
.36364 .3455 L
.36464 .34118 L
.36563 .33773 L
.36663 .33505 L
.36763 .33301 L
.36863 .33153 L
.36963 .3305 L
.37063 .32982 L
.37163 .32944 L
.37263 .32926 L
.37363 .32925 L
.37463 .32934 L
.37562 .3295 L
.37662 .3297 L
.37762 .32991 L
.37862 .3301 L
.37962 .33028 L
.38062 .33042 L
.38162 .33052 L
.38262 .33057 L
.38362 .33056 L
.38462 .33051 L
.38561 .33039 L
.38661 .33023 L
.38761 .33 L
.38861 .32972 L
.38961 .32939 L
.39061 .329 L
Mistroke
.39161 .32855 L
.39261 .32806 L
.39361 .3275 L
.39461 .3269 L
.3956 .32624 L
.3966 .32552 L
.3976 .32475 L
.3986 .32392 L
.3996 .31556 L
.4006 .30926 L
.4016 .30414 L
.4026 .29889 L
.4036 .2932 L
.4046 .28697 L
.40559 .28016 L
.40659 .27279 L
.40759 .26485 L
.40859 .25639 L
.40959 .24745 L
.41059 .23808 L
.41159 .22839 L
.41259 .2185 L
.41359 .20857 L
.41459 .19882 L
.41558 .18952 L
.41658 .18098 L
.41758 .17354 L
.41858 .16754 L
.41958 .16332 L
.42058 .1611 L
.42158 .16094 L
.42258 .16265 L
.42358 .16571 L
.42458 .16942 L
.42557 .17321 L
.42657 .17702 L
.42757 .18121 L
.42857 .1863 L
.42957 .19268 L
.43057 .20052 L
.43157 .2098 L
.43257 .22031 L
.43357 .23174 L
.43457 .24373 L
.43556 .2559 L
.43656 .26789 L
.43756 .2794 L
.43856 .2902 L
.43956 .30012 L
.44056 .30904 L
Mistroke
.44156 .31693 L
.44256 .32378 L
.44356 .32961 L
.44456 .33449 L
.44555 .33848 L
.44655 .34167 L
.44755 .34414 L
.44855 .34598 L
.44955 .39901 L
.45055 .40369 L
.45155 .40798 L
.45255 .41099 L
.45355 .41267 L
.45455 .41314 L
.45554 .41258 L
.45654 .41119 L
.45754 .40916 L
.45854 .40665 L
.45954 .40381 L
.46054 .40074 L
.46154 .39755 L
.46254 .39431 L
.46354 .39109 L
.46454 .38794 L
.46553 .38487 L
.46653 .38193 L
.46753 .37911 L
.46853 .37645 L
.46953 .37393 L
.47053 .37155 L
.47153 .36932 L
.47253 .36723 L
.47353 .36527 L
.47453 .36344 L
.47552 .36171 L
.47652 .36009 L
.47752 .35856 L
.47852 .35712 L
.47952 .35575 L
.48052 .35444 L
.48152 .35319 L
.48252 .35198 L
.48352 .35081 L
.48452 .34967 L
.48551 .34856 L
.48651 .34746 L
.48751 .34637 L
.48851 .34529 L
.48951 .3442 L
.49051 .34311 L
Mistroke
.49151 .34201 L
.49251 .34089 L
.49351 .33975 L
.49451 .33858 L
.4955 .33738 L
.4965 .33615 L
.4975 .33489 L
.4985 .33358 L
.4995 .53012 L
.5005 .51332 L
.5015 .49679 L
.5025 .47969 L
.5035 .46216 L
.5045 .4446 L
.50549 .42746 L
.50649 .41117 L
.50749 .39609 L
.50849 .38244 L
.50949 .37036 L
.51049 .35991 L
.51149 .35104 L
.51249 .34369 L
.51349 .33772 L
.51449 .33302 L
.51548 .32941 L
.51648 .32676 L
.51748 .3249 L
.51848 .32371 L
.51948 .32305 L
.52048 .32281 L
.52148 .32288 L
.52248 .32317 L
.52348 .32363 L
.52448 .32417 L
.52547 .32476 L
.52647 .32536 L
.52747 .32593 L
.52847 .32647 L
.52947 .32694 L
.53047 .32734 L
.53147 .32767 L
.53247 .32792 L
.53347 .32808 L
.53447 .32816 L
.53546 .32817 L
.53646 .32809 L
.53746 .32793 L
.53846 .3277 L
.53946 .3274 L
.54046 .32702 L
Mistroke
.54146 .32657 L
.54246 .32604 L
.54346 .32545 L
.54446 .32479 L
.54545 .32406 L
.54645 .32326 L
.54745 .32239 L
.54845 .32144 L
.54945 .40893 L
.55045 .41475 L
.55145 .42136 L
.55245 .42783 L
.55345 .43408 L
.55445 .4402 L
.55544 .44625 L
.55644 .45232 L
.55744 .45844 L
.55844 .46463 L
.55944 .47087 L
.56044 .47713 L
.56144 .48332 L
.56244 .48935 L
.56344 .49506 L
.56444 .50027 L
.56543 .50474 L
.56643 .50813 L
.56743 .51005 L
.56843 .50999 L
.56943 .50742 L
.57043 .5018 L
.57143 .49287 L
.57243 .48076 L
.57343 .46605 L
.57443 .44961 L
.57542 .43238 L
.57642 .41522 L
.57742 .39882 L
.57842 .38369 L
.57942 .37017 L
.58042 .35843 L
.58142 .34851 L
.58242 .34037 L
.58342 .33387 L
.58442 .32888 L
.58541 .32521 L
.58641 .32266 L
.58741 .32107 L
.58841 .32025 L
.58941 .32003 L
.59041 .32027 L
Mistroke
.59141 .32083 L
.59241 .32162 L
.59341 .32252 L
.59441 .32348 L
.5954 .32443 L
.5964 .32534 L
.5974 .32617 L
.5984 .32691 L
.5994 .3295 L
.6004 .31638 L
.6014 .30708 L
.6024 .29989 L
.6034 .29412 L
.6044 .28935 L
.60539 .28533 L
.60639 .28189 L
.60739 .27892 L
.60839 .27633 L
.60939 .27407 L
.61039 .27209 L
.61139 .27035 L
.61239 .26884 L
.61339 .26753 L
.61439 .2664 L
.61538 .26544 L
.61638 .26464 L
.61738 .26398 L
.61838 .26346 L
.61938 .26306 L
.62038 .26278 L
.62138 .2626 L
.62238 .26251 L
.62338 .26249 L
.62438 .26255 L
.62537 .26266 L
.62637 .26282 L
.62737 .263 L
.62837 .26321 L
.62937 .26343 L
.63037 .26365 L
.63137 .26386 L
.63237 .26405 L
.63337 .26422 L
.63437 .26436 L
.63536 .26446 L
.63636 .26453 L
.63736 .26455 L
.63836 .26453 L
.63936 .26447 L
.64036 .26436 L
Mistroke
.64136 .26421 L
.64236 .26401 L
.64336 .26377 L
.64436 .26348 L
.64535 .26316 L
.64635 .2628 L
.64735 .2624 L
.64835 .26196 L
.64935 .31929 L
.65035 .3138 L
.65135 .31039 L
.65235 .30766 L
.65335 .30517 L
.65435 .30275 L
.65534 .30032 L
.65634 .29786 L
.65734 .29535 L
.65834 .29279 L
.65934 .29019 L
.66034 .28754 L
.66134 .28486 L
.66234 .28214 L
.66334 .2794 L
.66434 .27664 L
.66533 .27388 L
.66633 .27111 L
.66733 .26835 L
.66833 .26561 L
.66933 .26291 L
.67033 .26027 L
.67133 .2577 L
.67233 .25522 L
.67333 .25285 L
.67433 .25061 L
.67532 .24852 L
.67632 .24659 L
.67732 .24485 L
.67832 .2433 L
.67932 .24196 L
.68032 .24083 L
.68132 .23991 L
.68232 .2392 L
.68332 .23868 L
.68432 .23833 L
.68531 .23813 L
.68631 .23805 L
.68731 .23804 L
.68831 .23807 L
.68931 .2381 L
.69031 .2381 L
Mistroke
.69131 .23803 L
.69231 .23789 L
.69331 .23766 L
.69431 .23734 L
.6953 .23695 L
.6963 .23651 L
.6973 .23606 L
.6983 .23562 L
.6993 .29013 L
.7003 .29795 L
.7013 .30646 L
.7023 .3144 L
.7033 .32141 L
.7043 .32738 L
.70529 .33235 L
.70629 .33638 L
.70729 .33958 L
.70829 .34206 L
.70929 .34393 L
.71029 .34528 L
.71129 .34621 L
.71229 .34678 L
.71329 .34705 L
.71429 .34709 L
.71528 .34694 L
.71628 .34664 L
.71728 .34621 L
.71828 .34568 L
.71928 .34506 L
.72028 .34438 L
.72128 .34363 L
.72228 .34284 L
.72328 .34201 L
.72428 .34113 L
.72527 .34021 L
.72627 .33926 L
.72727 .33827 L
.72827 .33724 L
.72927 .33616 L
.73027 .33505 L
.73127 .33388 L
.73227 .33266 L
.73327 .33139 L
.73427 .33005 L
.73526 .32865 L
.73626 .32718 L
.73726 .32563 L
.73826 .32399 L
.73926 .32227 L
.74026 .32045 L
Mistroke
.74126 .31853 L
.74226 .31649 L
.74326 .31434 L
.74426 .31206 L
.74525 .30965 L
.74625 .30709 L
.74725 .30438 L
.74825 .30151 L
.74925 .2466 L
.75025 .22489 L
.75125 .2063 L
.75225 .18923 L
.75325 .17337 L
.75425 .15884 L
.75524 .14609 L
.75624 .13574 L
.75724 .12855 L
.75824 .12526 L
.75924 .12648 L
.76024 .13251 L
.76124 .14326 L
.76224 .15822 L
.76324 .17659 L
.76424 .19742 L
.76523 .21972 L
.76623 .24256 L
.76723 .26503 L
.76823 .2864 L
.76923 .30606 L
.77023 .3236 L
.77123 .33879 L
.77223 .35155 L
.77323 .36192 L
.77423 .37001 L
.77522 .37598 L
.77622 .38004 L
.77722 .38239 L
.77822 .38325 L
.77922 .38282 L
.78022 .38133 L
.78122 .379 L
.78222 .37607 L
.78322 .37275 L
.78422 .36922 L
.78521 .36567 L
.78621 .3622 L
.78721 .35893 L
.78821 .3559 L
.78921 .35317 L
.79021 .35073 L
Mistroke
.79121 .3486 L
.79221 .34674 L
.79321 .34515 L
.79421 .34379 L
.7952 .34262 L
.7962 .34163 L
.7972 .34077 L
.7982 .34003 L
.7992 .46413 L
.8002 .4646 L
.8012 .46535 L
.8022 .46529 L
.8032 .46421 L
.8042 .4621 L
.80519 .45905 L
.80619 .45517 L
.80719 .4506 L
.80819 .44549 L
.80919 .43996 L
.81019 .43415 L
.81119 .42817 L
.81219 .42213 L
.81319 .41613 L
.81419 .41025 L
.81518 .40455 L
.81618 .39908 L
.81718 .39389 L
.81818 .389 L
.81918 .38442 L
.82018 .38018 L
.82118 .37626 L
.82218 .37266 L
.82318 .36937 L
.82418 .36637 L
.82517 .36364 L
.82617 .36116 L
.82717 .3589 L
.82817 .35685 L
.82917 .35498 L
.83017 .35326 L
.83117 .35168 L
.83217 .35022 L
.83317 .34885 L
.83417 .34756 L
.83516 .34634 L
.83616 .34516 L
.83716 .34403 L
.83816 .34291 L
.83916 .34182 L
.84016 .34072 L
Mistroke
.84116 .33963 L
.84216 .33852 L
.84316 .33739 L
.84416 .33623 L
.84515 .33504 L
.84615 .3338 L
.84715 .33253 L
.84815 .33119 L
.84915 .50157 L
.85015 .49803 L
.85115 .49479 L
.85215 .49062 L
.85315 .48523 L
.85415 .47862 L
.85514 .4709 L
.85614 .4623 L
.85714 .45305 L
.85814 .44341 L
.85914 .43363 L
.86014 .42392 L
.86114 .41448 L
.86214 .40546 L
.86314 .39699 L
.86414 .38914 L
.86513 .38196 L
.86613 .37547 L
.86713 .36966 L
.86813 .36452 L
.86913 .36 L
.87013 .35605 L
.87113 .35263 L
.87213 .34969 L
.87313 .34715 L
.87413 .34497 L
.87512 .3431 L
.87612 .34149 L
.87712 .34009 L
.87812 .33887 L
.87912 .33778 L
.88012 .3368 L
.88112 .3359 L
.88212 .33505 L
.88312 .33424 L
.88412 .33345 L
.88511 .33266 L
.88611 .33187 L
.88711 .33105 L
.88811 .33021 L
.88911 .32933 L
.89011 .3284 L
Mistroke
.89111 .32743 L
.89211 .32639 L
.89311 .3253 L
.89411 .32413 L
.8951 .32289 L
.8961 .32158 L
.8971 .32017 L
.8981 .31867 L
.8991 .45528 L
.9001 .4606 L
.9011 .46755 L
.9021 .47486 L
.9031 .48218 L
.9041 .48934 L
.90509 .49622 L
.90609 .50266 L
.90709 .50851 L
.90809 .51354 L
.90909 .51753 L
.91009 .52022 L
.91109 .5213 L
.91209 .5205 L
.91309 .51752 L
.91409 .51212 L
.91508 .50415 L
.91608 .4936 L
.91708 .48069 L
.91808 .46588 L
.91908 .4498 L
.92008 .43318 L
.92108 .41672 L
.92208 .40099 L
.92308 .38646 L
.92408 .3734 L
.92507 .362 L
.92607 .35228 L
.92707 .34422 L
.92807 .3377 L
.92907 .33259 L
.93007 .32872 L
.93107 .32591 L
.93207 .32401 L
.93307 .32283 L
.93407 .32222 L
.93506 .32206 L
.93606 .32221 L
.93706 .32259 L
.93806 .3231 L
.93906 .32367 L
.94006 .32426 L
Mistroke
.94106 .32483 L
.94206 .32535 L
.94306 .32579 L
.94406 .32615 L
.94505 .32643 L
.94605 .3266 L
.94705 .32668 L
.94805 .32667 L
.94905 .32219 L
.95005 .31602 L
.95105 .31182 L
.95205 .30817 L
.95305 .30466 L
.95405 .30112 L
.95504 .29747 L
.95604 .29369 L
.95704 .28977 L
.95804 .28571 L
.95904 .28151 L
.96004 .27718 L
.96104 .27273 L
.96204 .26818 L
.96304 .26356 L
.96404 .25887 L
.96503 .25417 L
.96603 .24948 L
.96703 .24485 L
.96803 .24034 L
.96903 .236 L
.97003 .23189 L
.97103 .22809 L
.97203 .22466 L
.97303 .22166 L
.97403 .21915 L
.97502 .21718 L
.97602 .21577 L
.97702 .21491 L
.97802 .21459 L
.97902 .21472 L
.98002 .2152 L
.98102 .21589 L
.98202 .21667 L
.98302 .21738 L
.98402 .21795 L
.98501 .21834 L
.98601 .21859 L
.98701 .2188 L
.98801 .21906 L
.98901 .2195 L
.99001 .22021 L
Mistroke
.99101 .22129 L
.99201 .22279 L
.99301 .22473 L
.99401 .2271 L
.995 .2299 L
.996 .23308 L
.997 .23657 L
.998 .24032 L
.999 .30946 L
Mfstroke
gsave
.999 .32412 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38342 L
.004 .38538 L
.005 .38721 L
.00599 .38905 L
.00699 .39099 L
.00799 .39308 L
.00899 .39539 L
.00999 .39797 L
.01099 .40088 L
.01199 .40416 L
.01299 .40788 L
.01399 .41208 L
.01499 .41683 L
.01598 .4222 L
.01698 .42826 L
.01798 .4351 L
.01898 .4428 L
.01998 .45145 L
.02098 .46117 L
.02198 .47205 L
.02298 .48423 L
.02398 .49781 L
.02498 .51291 L
.02597 .52966 L
.02697 .54813 L
.02797 .5684 L
.02897 .5905 L
.02997 .61438 L
s
.02997 .61438 m
.03011 .61803 L
s
.04902 .61803 m
.04995 .13489 L
.05095 .12332 L
.05195 .12036 L
.05295 .12822 L
.05395 .14807 L
.05495 .17978 L
.05594 .2215 L
.05694 .26972 L
.05794 .32014 L
.05894 .36866 L
.05994 .41199 L
.06094 .44793 L
.06194 .4752 L
.06294 .49341 L
.06394 .50292 L
.06494 .50478 L
.06593 .50038 L
.06693 .49085 L
.06793 .47702 L
.06893 .45976 L
.06993 .44021 L
.07093 .4197 L
.07193 .39959 L
.07293 .3812 L
.07393 .3657 L
.07493 .35421 L
.07592 .3478 L
.07692 .34739 L
.07792 .35307 L
.07892 .36357 L
.07992 .37674 L
.08092 .39045 L
.08192 .40297 L
.08292 .41303 L
.08392 .41989 L
.08492 .42334 L
.08591 .42374 L
.08691 .42203 L
.08791 .41952 L
.08891 .41723 L
.08991 .41523 L
.09091 .41297 L
.09191 .40995 L
.09291 .40605 L
.09391 .40143 L
.09491 .3965 L
.0959 .39189 L
.0969 .38835 L
.0979 .38671 L
Mistroke
.0989 .3875 L
.0999 .41025 L
.1009 .41256 L
.1019 .4134 L
.1029 .41399 L
.1039 .41465 L
.1049 .41548 L
.10589 .41649 L
.10689 .41766 L
.10789 .41897 L
.10889 .42039 L
.10989 .42191 L
.11089 .42351 L
.11189 .42517 L
.11289 .42688 L
.11389 .42866 L
.11489 .43048 L
.11588 .43235 L
.11688 .43427 L
.11788 .43624 L
.11888 .43827 L
.11988 .44034 L
.12088 .44247 L
.12188 .44465 L
.12288 .44689 L
.12388 .44918 L
.12488 .45153 L
.12587 .45393 L
.12687 .45638 L
.12787 .45887 L
.12887 .46142 L
.12987 .464 L
.13087 .46662 L
.13187 .46926 L
.13287 .47192 L
.13387 .4746 L
.13487 .47727 L
.13586 .47993 L
.13686 .48256 L
.13786 .48515 L
.13886 .48768 L
.13986 .49013 L
.14086 .4925 L
.14186 .49475 L
.14286 .49686 L
.14386 .49883 L
.14486 .50063 L
.14585 .50223 L
.14685 .50363 L
.14785 .50481 L
Mistroke
.14885 .50575 L
.14985 .56014 L
.15085 .54236 L
.15185 .52128 L
.15285 .49901 L
.15385 .47681 L
.15485 .45564 L
.15584 .43617 L
.15684 .41882 L
.15784 .40383 L
.15884 .39128 L
.15984 .38111 L
.16084 .3732 L
.16184 .36737 L
.16284 .36338 L
.16384 .36102 L
.16484 .36004 L
.16583 .36021 L
.16683 .36133 L
.16783 .36319 L
.16883 .36561 L
.16983 .36841 L
.17083 .37145 L
.17183 .3746 L
.17283 .37774 L
.17383 .38079 L
.17483 .38369 L
.17582 .38638 L
.17682 .38883 L
.17782 .39103 L
.17882 .39296 L
.17982 .39465 L
.18082 .39609 L
.18182 .39731 L
.18282 .39833 L
.18382 .39918 L
.18482 .39987 L
.18581 .40044 L
.18681 .4009 L
.18781 .40128 L
.18881 .40159 L
.18981 .40184 L
.19081 .40206 L
.19181 .40225 L
.19281 .40243 L
.19381 .4026 L
.19481 .40276 L
.1958 .40293 L
.1968 .40311 L
.1978 .4033 L
Mistroke
.1988 .4035 L
.1998 .29111 L
.2008 .27933 L
.2018 .26812 L
.2028 .25826 L
.2038 .24982 L
.2048 .24281 L
.20579 .23727 L
.20679 .23327 L
.20779 .23094 L
.20879 .2304 L
.20979 .23175 L
.21079 .23509 L
.21179 .24045 L
.21279 .24779 L
.21379 .25702 L
.21479 .26792 L
.21578 .28023 L
.21678 .29357 L
.21778 .30753 L
.21878 .32165 L
.21978 .3355 L
.22078 .34868 L
.22178 .36088 L
.22278 .37188 L
.22378 .38153 L
.22478 .3898 L
.22577 .39669 L
.22677 .40228 L
.22777 .40666 L
.22877 .40996 L
.22977 .41232 L
.23077 .41389 L
.23177 .41481 L
.23277 .41521 L
.23377 .41521 L
.23477 .41492 L
.23576 .41444 L
.23676 .41382 L
.23776 .41314 L
.23876 .41244 L
.23976 .41175 L
.24076 .41109 L
.24176 .41049 L
.24276 .40995 L
.24376 .40948 L
.24476 .40909 L
.24575 .40876 L
.24675 .4085 L
.24775 .40832 L
Mistroke
.24875 .40819 L
.24975 .46018 L
.25075 .46759 L
.25175 .47228 L
.25275 .47571 L
.25375 .47835 L
.25475 .48043 L
.25574 .48204 L
.25674 .48323 L
.25774 .48402 L
.25874 .48443 L
.25974 .48445 L
.26074 .48411 L
.26174 .48342 L
.26274 .48239 L
.26374 .48107 L
.26474 .47948 L
.26573 .47766 L
.26673 .47564 L
.26773 .47348 L
.26873 .47121 L
.26973 .46888 L
.27073 .46652 L
.27173 .46417 L
.27273 .46186 L
.27373 .45962 L
.27473 .45746 L
.27572 .45541 L
.27672 .45348 L
.27772 .45168 L
.27872 .45002 L
.27972 .44849 L
.28072 .4471 L
.28172 .44585 L
.28272 .44474 L
.28372 .44376 L
.28472 .44291 L
.28571 .44218 L
.28671 .44158 L
.28771 .44109 L
.28871 .44072 L
.28971 .44045 L
.29071 .44028 L
.29171 .44022 L
.29271 .44024 L
.29371 .44037 L
.29471 .44058 L
.2957 .44087 L
.2967 .44126 L
.2977 .44172 L
Mistroke
.2987 .44226 L
.2997 .42906 L
.3007 .43308 L
.3017 .43509 L
.3027 .43645 L
.3037 .4376 L
.3047 .43869 L
.30569 .43979 L
.30669 .44092 L
.30769 .44207 L
.30869 .44325 L
.30969 .44444 L
.31069 .44564 L
.31169 .44684 L
.31269 .44804 L
.31369 .44925 L
.31469 .45045 L
.31568 .45164 L
.31668 .45284 L
.31768 .45403 L
.31868 .45523 L
.31968 .45641 L
.32068 .4576 L
.32168 .45879 L
.32268 .45997 L
.32368 .46114 L
.32468 .46231 L
.32567 .46348 L
.32667 .46464 L
.32767 .46578 L
.32867 .46692 L
.32967 .46804 L
.33067 .46915 L
.33167 .47024 L
.33267 .47131 L
.33367 .47236 L
.33467 .47339 L
.33566 .47438 L
.33666 .47535 L
.33766 .47629 L
.33866 .4772 L
.33966 .47807 L
.34066 .47891 L
.34166 .47971 L
.34266 .48048 L
.34366 .48121 L
.34466 .4819 L
.34565 .48256 L
.34665 .48318 L
.34765 .48376 L
Mistroke
.34865 .48432 L
.34965 .51826 L
.35065 .51251 L
.35165 .50346 L
.35265 .49283 L
.35365 .48148 L
.35465 .46996 L
.35564 .4587 L
.35664 .44799 L
.35764 .43805 L
.35864 .42901 L
.35964 .42096 L
.36064 .41391 L
.36164 .40787 L
.36264 .40278 L
.36364 .39859 L
.36464 .3952 L
.36563 .39255 L
.36663 .39054 L
.36763 .38909 L
.36863 .38811 L
.36963 .38754 L
.37063 .3873 L
.37163 .38733 L
.37263 .38759 L
.37363 .38803 L
.37463 .3886 L
.37562 .38927 L
.37662 .39002 L
.37762 .39082 L
.37862 .39165 L
.37962 .39251 L
.38062 .39337 L
.38162 .39423 L
.38262 .39508 L
.38362 .39593 L
.38462 .39676 L
.38561 .39759 L
.38661 .3984 L
.38761 .39921 L
.38861 .4 L
.38961 .4008 L
.39061 .40159 L
.39161 .40239 L
.39261 .40319 L
.39361 .404 L
.39461 .40482 L
.3956 .40566 L
.3966 .40651 L
.3976 .40739 L
Mistroke
.3986 .4083 L
.3996 .32998 L
.4006 .33214 L
.4016 .33169 L
.4026 .33016 L
.4036 .32799 L
.4046 .32539 L
.40559 .32244 L
.40659 .31917 L
.40759 .31561 L
.40859 .31175 L
.40959 .30761 L
.41059 .30317 L
.41159 .29846 L
.41259 .29346 L
.41359 .28819 L
.41459 .28268 L
.41558 .27695 L
.41658 .27107 L
.41758 .26513 L
.41858 .25926 L
.41958 .25368 L
.42058 .24871 L
.42158 .24481 L
.42258 .24263 L
.42358 .24301 L
.42458 .24683 L
.42557 .25464 L
.42657 .26627 L
.42757 .28091 L
.42857 .29746 L
.42957 .31482 L
.43057 .33204 L
.43157 .34838 L
.43257 .36332 L
.43357 .37653 L
.43457 .38787 L
.43556 .3973 L
.43656 .40493 L
.43756 .41087 L
.43856 .41533 L
.43956 .41849 L
.44056 .42056 L
.44156 .42172 L
.44256 .42217 L
.44356 .42206 L
.44456 .42153 L
.44555 .42071 L
.44655 .41971 L
.44755 .4186 L
Mistroke
.44855 .41747 L
.44955 .41365 L
.45055 .42666 L
.45155 .43545 L
.45255 .44167 L
.45355 .44605 L
.45455 .44905 L
.45554 .45098 L
.45654 .45205 L
.45754 .45245 L
.45854 .45231 L
.45954 .45175 L
.46054 .45088 L
.46154 .44977 L
.46254 .4485 L
.46354 .44714 L
.46454 .44573 L
.46553 .44432 L
.46653 .44295 L
.46753 .44163 L
.46853 .4404 L
.46953 .43927 L
.47053 .43826 L
.47153 .43736 L
.47253 .43658 L
.47353 .43593 L
.47453 .43541 L
.47552 .43501 L
.47652 .43474 L
.47752 .43459 L
.47852 .43455 L
.47952 .43463 L
.48052 .43482 L
.48152 .43512 L
.48252 .43553 L
.48352 .43603 L
.48452 .43665 L
.48551 .43736 L
.48651 .43817 L
.48751 .43908 L
.48851 .44009 L
.48951 .44119 L
.49051 .4424 L
.49151 .4437 L
.49251 .44511 L
.49351 .44661 L
.49451 .44822 L
.4955 .44992 L
.4965 .45174 L
.4975 .45365 L
Mistroke
.4985 .45567 L
.4995 .54448 L
.5005 .5363 L
.5015 .52445 L
.5025 .5107 L
.5035 .49599 L
.5045 .48102 L
.50549 .46635 L
.50649 .45243 L
.50749 .43955 L
.50849 .42793 L
.50949 .41769 L
.51049 .40886 L
.51149 .40141 L
.51249 .39528 L
.51349 .39035 L
.51449 .38652 L
.51548 .38366 L
.51648 .38163 L
.51748 .38031 L
.51848 .3796 L
.51948 .37937 L
.52048 .37954 L
.52148 .38004 L
.52248 .38077 L
.52348 .38169 L
.52448 .38275 L
.52547 .38389 L
.52647 .38509 L
.52747 .38632 L
.52847 .38755 L
.52947 .38876 L
.53047 .38996 L
.53147 .39112 L
.53247 .39225 L
.53347 .39334 L
.53447 .39439 L
.53546 .39541 L
.53646 .3964 L
.53746 .39736 L
.53846 .39829 L
.53946 .39921 L
.54046 .40012 L
.54146 .40102 L
.54246 .40192 L
.54346 .40282 L
.54446 .40373 L
.54545 .40465 L
.54645 .4056 L
.54745 .40657 L
Mistroke
.54845 .40756 L
.54945 .42334 L
.55045 .4377 L
.55145 .44908 L
.55245 .45932 L
.55345 .4691 L
.55445 .4788 L
.55544 .48861 L
.55644 .4986 L
.55744 .50879 L
.55844 .51913 L
.55944 .52949 L
.56044 .53969 L
.56144 .5495 L
.56244 .55862 L
.56344 .56671 L
.56444 .5734 L
.56543 .57833 L
.56643 .5812 L
.56743 .58183 L
.56843 .58024 L
.56943 .57666 L
.57043 .57147 L
.57143 .5651 L
.57243 .5578 L
.57343 .5496 L
.57443 .54046 L
.57542 .53035 L
.57642 .51936 L
.57742 .50769 L
.57842 .4956 L
.57942 .48343 L
.58042 .47146 L
.58142 .45998 L
.58242 .4492 L
.58342 .43929 L
.58442 .43036 L
.58541 .42244 L
.58641 .41554 L
.58741 .40964 L
.58841 .40469 L
.58941 .40062 L
.59041 .39734 L
.59141 .39479 L
.59241 .39288 L
.59341 .39152 L
.59441 .39065 L
.5954 .39018 L
.5964 .39005 L
.5974 .3902 L
Mistroke
.5984 .39056 L
.5994 .344 L
.6004 .33931 L
.6014 .33461 L
.6024 .3308 L
.6034 .32797 L
.6044 .32602 L
.60539 .32481 L
.60639 .3242 L
.60739 .32406 L
.60839 .32429 L
.60939 .3248 L
.61039 .32554 L
.61139 .32643 L
.61239 .32744 L
.61339 .32855 L
.61439 .32971 L
.61538 .33092 L
.61638 .33216 L
.61738 .33341 L
.61838 .33468 L
.61938 .33594 L
.62038 .33721 L
.62138 .33848 L
.62238 .33974 L
.62338 .341 L
.62438 .34226 L
.62537 .34351 L
.62637 .34477 L
.62737 .34602 L
.62837 .34728 L
.62937 .34854 L
.63037 .3498 L
.63137 .35106 L
.63237 .35233 L
.63337 .3536 L
.63437 .35486 L
.63536 .35613 L
.63636 .35739 L
.63736 .35864 L
.63836 .35988 L
.63936 .36111 L
.64036 .36232 L
.64136 .36352 L
.64236 .3647 L
.64336 .36586 L
.64436 .36699 L
.64535 .3681 L
.64635 .36919 L
.64735 .37024 L
Mistroke
.64835 .37127 L
.64935 .33373 L
.65035 .33671 L
.65135 .33788 L
.65235 .33856 L
.65335 .33911 L
.65435 .33964 L
.65534 .3402 L
.65634 .34079 L
.65734 .34138 L
.65834 .34197 L
.65934 .34253 L
.66034 .34306 L
.66134 .34355 L
.66234 .34399 L
.66334 .34438 L
.66434 .34471 L
.66533 .34498 L
.66633 .34518 L
.66733 .34533 L
.66833 .3454 L
.66933 .34541 L
.67033 .34535 L
.67133 .34521 L
.67233 .34501 L
.67333 .34473 L
.67433 .34438 L
.67532 .34397 L
.67632 .34348 L
.67732 .34294 L
.67832 .34235 L
.67932 .34172 L
.68032 .34107 L
.68132 .34041 L
.68232 .33976 L
.68332 .33916 L
.68432 .33863 L
.68531 .33821 L
.68631 .33793 L
.68731 .33784 L
.68831 .33797 L
.68931 .33836 L
.69031 .33902 L
.69131 .33999 L
.69231 .34126 L
.69331 .34283 L
.69431 .34469 L
.6953 .3468 L
.6963 .34912 L
.6973 .35163 L
Mistroke
.6983 .35425 L
.6993 .3046 L
.7003 .32097 L
.7013 .33409 L
.7023 .34528 L
.7033 .35499 L
.7043 .36346 L
.70529 .37083 L
.70629 .37723 L
.70729 .38276 L
.70829 .38752 L
.70929 .39159 L
.71029 .39505 L
.71129 .398 L
.71229 .40051 L
.71329 .40264 L
.71429 .40447 L
.71528 .40604 L
.71628 .4074 L
.71728 .40861 L
.71828 .40969 L
.71928 .41069 L
.72028 .41162 L
.72128 .41252 L
.72228 .41339 L
.72328 .41427 L
.72428 .41515 L
.72527 .41606 L
.72627 .417 L
.72727 .41799 L
.72827 .41902 L
.72927 .42012 L
.73027 .42127 L
.73127 .4225 L
.73227 .42381 L
.73327 .4252 L
.73427 .42667 L
.73526 .42824 L
.73626 .42991 L
.73726 .43169 L
.73826 .43357 L
.73926 .43558 L
.74026 .43771 L
.74126 .43997 L
.74226 .44237 L
.74326 .44492 L
.74426 .44762 L
.74525 .45048 L
.74625 .45351 L
.74725 .45672 L
Mistroke
.74825 .46011 L
.74925 .2609 L
.75025 .24796 L
.75125 .23437 L
.75225 .22123 L
.75325 .2089 L
.75425 .19772 L
.75524 .1881 L
.75624 .18056 L
.75724 .17571 L
.75824 .1742 L
.75924 .17667 L
.76024 .18366 L
.76124 .19551 L
.76224 .21221 L
.76324 .23326 L
.76424 .25764 L
.76523 .28394 L
.76623 .31066 L
.76723 .3364 L
.76823 .36011 L
.76923 .38104 L
.77023 .3988 L
.77123 .41327 L
.77223 .42452 L
.77323 .43278 L
.77423 .43835 L
.77522 .4416 L
.77622 .44293 L
.77722 .44272 L
.77822 .44136 L
.77922 .43919 L
.78022 .43652 L
.78122 .43357 L
.78222 .43052 L
.78322 .4275 L
.78422 .42457 L
.78521 .42179 L
.78621 .4192 L
.78721 .41681 L
.78821 .41463 L
.78921 .41267 L
.79021 .41092 L
.79121 .40939 L
.79221 .40807 L
.79321 .40695 L
.79421 .40602 L
.7952 .40527 L
.7962 .40468 L
.7972 .40424 L
Mistroke
.7982 .40394 L
.7992 .47862 L
.8002 .4875 L
.8012 .49278 L
.8022 .496 L
.8032 .49773 L
.8042 .49828 L
.80519 .49782 L
.80619 .4965 L
.80719 .49443 L
.80819 .49171 L
.80919 .48845 L
.81019 .48476 L
.81119 .48075 L
.81219 .47652 L
.81319 .47218 L
.81419 .46783 L
.81518 .46354 L
.81618 .45939 L
.81718 .45543 L
.81818 .45171 L
.81918 .44825 L
.82018 .44509 L
.82118 .44221 L
.82218 .43963 L
.82318 .43735 L
.82418 .43534 L
.82517 .43361 L
.82617 .43213 L
.82717 .43089 L
.82817 .42987 L
.82917 .42906 L
.83017 .42845 L
.83117 .42802 L
.83217 .42776 L
.83317 .42766 L
.83417 .4277 L
.83516 .42788 L
.83616 .4282 L
.83716 .42864 L
.83816 .42921 L
.83916 .42989 L
.84016 .43069 L
.84116 .4316 L
.84216 .43262 L
.84316 .43376 L
.84416 .435 L
.84515 .43637 L
.84615 .43784 L
.84715 .43944 L
Mistroke
.84815 .44116 L
.84915 .51594 L
.85015 .52091 L
.85115 .5222 L
.85215 .52126 L
.85315 .51863 L
.85415 .5146 L
.85514 .50942 L
.85614 .50331 L
.85714 .49647 L
.85814 .48912 L
.85914 .48148 L
.86014 .47375 L
.86114 .46611 L
.86214 .45874 L
.86314 .45175 L
.86414 .44524 L
.86513 .43928 L
.86613 .4339 L
.86713 .4291 L
.86813 .42489 L
.86913 .42124 L
.87013 .41811 L
.87113 .41547 L
.87213 .41326 L
.87313 .41145 L
.87413 .41 L
.87512 .40886 L
.87612 .40799 L
.87712 .40737 L
.87812 .40696 L
.87912 .40673 L
.88012 .40666 L
.88112 .40674 L
.88212 .40695 L
.88312 .40726 L
.88412 .40768 L
.88511 .40819 L
.88611 .40878 L
.88711 .40946 L
.88811 .41021 L
.88911 .41103 L
.89011 .41193 L
.89111 .4129 L
.89211 .41394 L
.89311 .41505 L
.89411 .41625 L
.8951 .41752 L
.8961 .41888 L
.8971 .42033 L
Mistroke
.8981 .42187 L
.8991 .46963 L
.9001 .48354 L
.9011 .49526 L
.9021 .50629 L
.9031 .51705 L
.9041 .52761 L
.90509 .5379 L
.90609 .54772 L
.90709 .55679 L
.90809 .56479 L
.90909 .57133 L
.91009 .57604 L
.91109 .57856 L
.91209 .57864 L
.91309 .57615 L
.91409 .57116 L
.91508 .5639 L
.91608 .55472 L
.91708 .54405 L
.91808 .53229 L
.91908 .51979 L
.92008 .50688 L
.92108 .49386 L
.92208 .48103 L
.92308 .46864 L
.92408 .45693 L
.92507 .44607 L
.92607 .43618 L
.92707 .42734 L
.92807 .41956 L
.92907 .41284 L
.93007 .40712 L
.93107 .40235 L
.93207 .39844 L
.93307 .39531 L
.93407 .39288 L
.93506 .39107 L
.93606 .38979 L
.93706 .38896 L
.93806 .38852 L
.93906 .38841 L
.94006 .38856 L
.94106 .38892 L
.94206 .38945 L
.94306 .39011 L
.94406 .39087 L
.94505 .39169 L
.94605 .39257 L
.94705 .39348 L
Mistroke
.94805 .39441 L
.94905 .33663 L
.95005 .3389 L
.95105 .3393 L
.95205 .33914 L
.95305 .3388 L
.95405 .33839 L
.95504 .33795 L
.95604 .33748 L
.95704 .33699 L
.95804 .33644 L
.95904 .33584 L
.96004 .33516 L
.96104 .33441 L
.96204 .33357 L
.96304 .33264 L
.96404 .33161 L
.96503 .33048 L
.96603 .32923 L
.96703 .32787 L
.96803 .3264 L
.96903 .3248 L
.97003 .32308 L
.97103 .32124 L
.97203 .3193 L
.97303 .31726 L
.97403 .31517 L
.97502 .31306 L
.97602 .31099 L
.97702 .30904 L
.97802 .30731 L
.97902 .30594 L
.98002 .30506 L
.98102 .30484 L
.98202 .30544 L
.98302 .30697 L
.98402 .30949 L
.98501 .31299 L
.98601 .31737 L
.98701 .32247 L
.98801 .32811 L
.98901 .33408 L
.99001 .3402 L
.99101 .34628 L
.99201 .3522 L
.99301 .35783 L
.99401 .36311 L
.995 .36798 L
.996 .3724 L
.997 .37638 L
Mistroke
.998 .37992 L
.999 .32412 L
Mfstroke
1 0 0 r
gsave
.999 .31679 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36653 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .3649 L
.00999 .36425 L
.01099 .36349 L
.01199 .36263 L
.01299 .36165 L
.01399 .36054 L
.01499 .35929 L
.01598 .35788 L
.01698 .3563 L
.01798 .35453 L
.01898 .35256 L
.01998 .35036 L
.02098 .34791 L
.02198 .34522 L
.02298 .34226 L
.02398 .33903 L
.02498 .33554 L
.02597 .33183 L
.02697 .32793 L
.02797 .32394 L
.02897 .31998 L
.02997 .31625 L
.03097 .31301 L
.03197 .3106 L
.03297 .30946 L
.03397 .3101 L
.03497 .31305 L
.03596 .31886 L
.03696 .32794 L
.03796 .34047 L
.03896 .35631 L
.03996 .37487 L
.04096 .39518 L
.04196 .41591 L
.04296 .4356 L
.04396 .45284 L
.04496 .46648 L
.04595 .47578 L
.04695 .48053 L
.04795 .48097 L
.04895 .47777 L
Mistroke
.04995 .12736 L
.05095 .11161 L
.05195 .10644 L
.05295 .11286 L
.05395 .13129 L
.05495 .16107 L
.05594 .20019 L
.05694 .24551 L
.05794 .29332 L
.05894 .34 L
.05994 .38252 L
.06094 .41868 L
.06194 .44706 L
.06294 .4669 L
.06394 .47795 L
.06494 .48043 L
.06593 .47503 L
.06693 .46292 L
.06793 .44563 L
.06893 .42497 L
.06993 .40285 L
.07093 .38108 L
.07193 .36125 L
.07293 .3446 L
.07393 .332 L
.07493 .32393 L
.07592 .32047 L
.07692 .32137 L
.07792 .32607 L
.07892 .33376 L
.07992 .34349 L
.08092 .35422 L
.08192 .36497 L
.08292 .37484 L
.08392 .38311 L
.08492 .38929 L
.08591 .39309 L
.08691 .39448 L
.08791 .39361 L
.08891 .39084 L
.08991 .38665 L
.09091 .38159 L
.09191 .37624 L
.09291 .37112 L
.09391 .36669 L
.09491 .36328 L
.0959 .3611 L
.0969 .36019 L
.0979 .36049 L
.0989 .3618 L
Mistroke
.0999 .40292 L
.1009 .40113 L
.1019 .39972 L
.1029 .39863 L
.1039 .39778 L
.1049 .39715 L
.10589 .39668 L
.10689 .39635 L
.10789 .39615 L
.10889 .39604 L
.10989 .39602 L
.11089 .39607 L
.11189 .39619 L
.11289 .39636 L
.11389 .39659 L
.11489 .39687 L
.11588 .39719 L
.11688 .39755 L
.11788 .39795 L
.11888 .39839 L
.11988 .39887 L
.12088 .39938 L
.12188 .39992 L
.12288 .40049 L
.12388 .40109 L
.12488 .40173 L
.12587 .40239 L
.12687 .40307 L
.12787 .40378 L
.12887 .40452 L
.12987 .40527 L
.13087 .40604 L
.13187 .40682 L
.13287 .40761 L
.13387 .40841 L
.13487 .40921 L
.13586 .41001 L
.13686 .4108 L
.13786 .41158 L
.13886 .41233 L
.13986 .41306 L
.14086 .41376 L
.14186 .41441 L
.14286 .41502 L
.14386 .41557 L
.14486 .41606 L
.14585 .41648 L
.14685 .41682 L
.14785 .41707 L
.14885 .41724 L
Mistroke
.14985 .55296 L
.15085 .53077 L
.15185 .50718 L
.15285 .48307 L
.15385 .45934 L
.15485 .43678 L
.15584 .41604 L
.15684 .39755 L
.15784 .38156 L
.15884 .36815 L
.15984 .35727 L
.16084 .34878 L
.16184 .34249 L
.16284 .33817 L
.16384 .33555 L
.16484 .33438 L
.16583 .33441 L
.16683 .3354 L
.16783 .33714 L
.16883 .3394 L
.16983 .34204 L
.17083 .34488 L
.17183 .34781 L
.17283 .35073 L
.17383 .35355 L
.17483 .35621 L
.17582 .35868 L
.17682 .36093 L
.17782 .36294 L
.17882 .36472 L
.17982 .36626 L
.18082 .36758 L
.18182 .36869 L
.18282 .36961 L
.18382 .37036 L
.18482 .37096 L
.18581 .37143 L
.18681 .37178 L
.18781 .37204 L
.18881 .37221 L
.18981 .37232 L
.19081 .37238 L
.19181 .3724 L
.19281 .37238 L
.19381 .37234 L
.19481 .37229 L
.1958 .37222 L
.1968 .37214 L
.1978 .37206 L
.1988 .37198 L
Mistroke
.1998 .28388 L
.2008 .26781 L
.2018 .2542 L
.2028 .24249 L
.2038 .23238 L
.2048 .22373 L
.20579 .21653 L
.20679 .21088 L
.20779 .20693 L
.20879 .20486 L
.20979 .20485 L
.21079 .207 L
.21179 .21139 L
.21279 .21796 L
.21379 .22656 L
.21479 .23692 L
.21578 .2487 L
.21678 .26148 L
.21778 .27481 L
.21878 .28826 L
.21978 .30143 L
.22078 .31399 L
.22178 .32567 L
.22278 .3363 L
.22378 .34576 L
.22478 .35402 L
.22577 .36108 L
.22677 .367 L
.22777 .37184 L
.22877 .3757 L
.22977 .37869 L
.23077 .38092 L
.23177 .38249 L
.23277 .38352 L
.23377 .38409 L
.23477 .38429 L
.23576 .3842 L
.23676 .38389 L
.23776 .38342 L
.23876 .38283 L
.23976 .38218 L
.24076 .38148 L
.24176 .38077 L
.24276 .38006 L
.24376 .37938 L
.24476 .37873 L
.24575 .37812 L
.24675 .37755 L
.24775 .37703 L
.24875 .37656 L
Mistroke
.24975 .45294 L
.25075 .45616 L
.25175 .45857 L
.25275 .46031 L
.25375 .46146 L
.25475 .46208 L
.25574 .46223 L
.25674 .46194 L
.25774 .46125 L
.25874 .4602 L
.25974 .45882 L
.26074 .45713 L
.26174 .45518 L
.26274 .45299 L
.26374 .45059 L
.26474 .44804 L
.26573 .44535 L
.26673 .44256 L
.26773 .4397 L
.26873 .43682 L
.26973 .43394 L
.27073 .43107 L
.27173 .42826 L
.27273 .42553 L
.27373 .42288 L
.27473 .42033 L
.27572 .4179 L
.27672 .41559 L
.27772 .41342 L
.27872 .41137 L
.27972 .40946 L
.28072 .40769 L
.28172 .40604 L
.28272 .40453 L
.28372 .40313 L
.28472 .40186 L
.28571 .40069 L
.28671 .39963 L
.28771 .39868 L
.28871 .39781 L
.28971 .39703 L
.29071 .39634 L
.29171 .39572 L
.29271 .39518 L
.29371 .3947 L
.29471 .39428 L
.2957 .39392 L
.2967 .39361 L
.2977 .39335 L
.2987 .39314 L
Mistroke
.2997 .42183 L
.3007 .42163 L
.3017 .42137 L
.3027 .42107 L
.3037 .42074 L
.3047 .4204 L
.30569 .42007 L
.30669 .41974 L
.30769 .41943 L
.30869 .41915 L
.30969 .41889 L
.31069 .41865 L
.31169 .41845 L
.31269 .41827 L
.31369 .41813 L
.31469 .41802 L
.31568 .41794 L
.31668 .41789 L
.31768 .41787 L
.31868 .41787 L
.31968 .41791 L
.32068 .41797 L
.32168 .41805 L
.32268 .41816 L
.32368 .41829 L
.32468 .41843 L
.32567 .4186 L
.32667 .41878 L
.32767 .41898 L
.32867 .41919 L
.32967 .41941 L
.33067 .41965 L
.33167 .41989 L
.33267 .42013 L
.33367 .42038 L
.33467 .42063 L
.33566 .42089 L
.33666 .42114 L
.33766 .42139 L
.33866 .42163 L
.33966 .42187 L
.34066 .42211 L
.34166 .42233 L
.34266 .42254 L
.34366 .42275 L
.34466 .42294 L
.34565 .42312 L
.34665 .42328 L
.34765 .42344 L
.34865 .42357 L
Mistroke
.34965 .51107 L
.35065 .50105 L
.35165 .4897 L
.35265 .47745 L
.35365 .46471 L
.35465 .4519 L
.35564 .43938 L
.35664 .42746 L
.35764 .41636 L
.35864 .40626 L
.35964 .39723 L
.36064 .38933 L
.36164 .38253 L
.36264 .37679 L
.36364 .37204 L
.36464 .36819 L
.36563 .36514 L
.36663 .36279 L
.36763 .36105 L
.36863 .35982 L
.36963 .35902 L
.37063 .35856 L
.37163 .35838 L
.37263 .35843 L
.37363 .35864 L
.37463 .35897 L
.37562 .35939 L
.37662 .35986 L
.37762 .36036 L
.37862 .36088 L
.37962 .36139 L
.38062 .36189 L
.38162 .36237 L
.38262 .36283 L
.38362 .36325 L
.38462 .36364 L
.38561 .36399 L
.38661 .36431 L
.38761 .3646 L
.38861 .36486 L
.38961 .36509 L
.39061 .36529 L
.39161 .36547 L
.39261 .36562 L
.39361 .36575 L
.39461 .36586 L
.3956 .36595 L
.3966 .36602 L
.3976 .36607 L
.3986 .36611 L
Mistroke
.3996 .32277 L
.4006 .3207 L
.4016 .31791 L
.4026 .31452 L
.4036 .3106 L
.4046 .30618 L
.40559 .3013 L
.40659 .29598 L
.40759 .29023 L
.40859 .28407 L
.40959 .27753 L
.41059 .27063 L
.41159 .26342 L
.41259 .25598 L
.41359 .24838 L
.41459 .24075 L
.41558 .23324 L
.41658 .22603 L
.41758 .21933 L
.41858 .2134 L
.41958 .2085 L
.42058 .2049 L
.42158 .20287 L
.42258 .20264 L
.42358 .20436 L
.42458 .20813 L
.42557 .21393 L
.42657 .22164 L
.42757 .23106 L
.42857 .24188 L
.42957 .25375 L
.43057 .26628 L
.43157 .27909 L
.43257 .29181 L
.43357 .30414 L
.43457 .3158 L
.43556 .3266 L
.43656 .33641 L
.43756 .34514 L
.43856 .35276 L
.43956 .3593 L
.44056 .3648 L
.44156 .36933 L
.44256 .37297 L
.44356 .37583 L
.44456 .37801 L
.44555 .3796 L
.44655 .38069 L
.44755 .38137 L
.44855 .38173 L
Mistroke
.44955 .40633 L
.45055 .41518 L
.45155 .42171 L
.45255 .42633 L
.45355 .42936 L
.45455 .4311 L
.45554 .43178 L
.45654 .43162 L
.45754 .4308 L
.45854 .42948 L
.45954 .42778 L
.46054 .42581 L
.46154 .42366 L
.46254 .42141 L
.46354 .41912 L
.46454 .41683 L
.46553 .4146 L
.46653 .41244 L
.46753 .41037 L
.46853 .40842 L
.46953 .4066 L
.47053 .4049 L
.47153 .40334 L
.47253 .40191 L
.47353 .4006 L
.47453 .39942 L
.47552 .39836 L
.47652 .39742 L
.47752 .39658 L
.47852 .39584 L
.47952 .39519 L
.48052 .39463 L
.48152 .39415 L
.48252 .39375 L
.48352 .39342 L
.48452 .39316 L
.48551 .39296 L
.48651 .39281 L
.48751 .39273 L
.48851 .39269 L
.48951 .3927 L
.49051 .39276 L
.49151 .39286 L
.49251 .393 L
.49351 .39318 L
.49451 .3934 L
.4955 .39365 L
.4965 .39395 L
.4975 .39427 L
.4985 .39463 L
Mistroke
.4995 .5373 L
.5005 .52481 L
.5015 .51062 L
.5025 .4952 L
.5035 .47908 L
.5045 .46281 L
.50549 .44691 L
.50649 .4318 L
.50749 .41782 L
.50849 .40519 L
.50949 .39403 L
.51049 .38438 L
.51149 .37623 L
.51249 .36948 L
.51349 .36404 L
.51449 .35977 L
.51548 .35653 L
.51648 .35419 L
.51748 .35261 L
.51848 .35165 L
.51948 .35121 L
.52048 .35118 L
.52148 .35146 L
.52248 .35197 L
.52348 .35266 L
.52448 .35346 L
.52547 .35433 L
.52647 .35522 L
.52747 .35612 L
.52847 .35701 L
.52947 .35785 L
.53047 .35865 L
.53147 .3594 L
.53247 .36008 L
.53347 .36071 L
.53447 .36128 L
.53546 .36179 L
.53646 .36224 L
.53746 .36265 L
.53846 .363 L
.53946 .3633 L
.54046 .36357 L
.54146 .36379 L
.54246 .36398 L
.54346 .36414 L
.54446 .36426 L
.54545 .36436 L
.54645 .36443 L
.54745 .36448 L
.54845 .3645 L
Mistroke
.54945 .41614 L
.55045 .42623 L
.55145 .43522 L
.55245 .44357 L
.55345 .45159 L
.55445 .4595 L
.55544 .46743 L
.55644 .47546 L
.55744 .48362 L
.55844 .49188 L
.55944 .50018 L
.56044 .50841 L
.56144 .51641 L
.56244 .52398 L
.56344 .53089 L
.56444 .53684 L
.56543 .54153 L
.56643 .54466 L
.56743 .54594 L
.56843 .54512 L
.56943 .54204 L
.57043 .53664 L
.57143 .52899 L
.57243 .51928 L
.57343 .50783 L
.57443 .49504 L
.57542 .48137 L
.57642 .46729 L
.57742 .45325 L
.57842 .43965 L
.57942 .4268 L
.58042 .41494 L
.58142 .40424 L
.58242 .39478 L
.58342 .38658 L
.58442 .37962 L
.58541 .37382 L
.58641 .3691 L
.58741 .36536 L
.58841 .36247 L
.58941 .36032 L
.59041 .3588 L
.59141 .35781 L
.59241 .35725 L
.59341 .35702 L
.59441 .35707 L
.5954 .35731 L
.5964 .3577 L
.5974 .35818 L
.5984 .35873 L
Mistroke
.5994 .33675 L
.6004 .32784 L
.6014 .32084 L
.6024 .31535 L
.6034 .31105 L
.6044 .30769 L
.60539 .30507 L
.60639 .30304 L
.60739 .30149 L
.60839 .30031 L
.60939 .29944 L
.61039 .29881 L
.61139 .29839 L
.61239 .29814 L
.61339 .29804 L
.61439 .29806 L
.61538 .29818 L
.61638 .2984 L
.61738 .2987 L
.61838 .29907 L
.61938 .2995 L
.62038 .29999 L
.62138 .30054 L
.62238 .30112 L
.62338 .30175 L
.62438 .3024 L
.62537 .30309 L
.62637 .30379 L
.62737 .30451 L
.62837 .30524 L
.62937 .30598 L
.63037 .30672 L
.63137 .30746 L
.63237 .30819 L
.63337 .30891 L
.63437 .30961 L
.63536 .31029 L
.63636 .31096 L
.63736 .31159 L
.63836 .31221 L
.63936 .31279 L
.64036 .31334 L
.64136 .31387 L
.64236 .31436 L
.64336 .31481 L
.64436 .31524 L
.64535 .31563 L
.64635 .31599 L
.64735 .31632 L
.64835 .31662 L
Mistroke
.64935 .32651 L
.65035 .32526 L
.65135 .32414 L
.65235 .32311 L
.65335 .32214 L
.65435 .3212 L
.65534 .32026 L
.65634 .31932 L
.65734 .31836 L
.65834 .31738 L
.65934 .31636 L
.66034 .3153 L
.66134 .31421 L
.66234 .31307 L
.66334 .31189 L
.66434 .31068 L
.66533 .30943 L
.66633 .30815 L
.66733 .30684 L
.66833 .30551 L
.66933 .30416 L
.67033 .30281 L
.67133 .30146 L
.67233 .30011 L
.67333 .29879 L
.67433 .2975 L
.67532 .29624 L
.67632 .29504 L
.67732 .2939 L
.67832 .29283 L
.67932 .29184 L
.68032 .29095 L
.68132 .29016 L
.68232 .28948 L
.68332 .28892 L
.68432 .28848 L
.68531 .28817 L
.68631 .28799 L
.68731 .28794 L
.68831 .28802 L
.68931 .28823 L
.69031 .28856 L
.69131 .28901 L
.69231 .28958 L
.69331 .29024 L
.69431 .29101 L
.6953 .29187 L
.6963 .29282 L
.6973 .29384 L
.6983 .29494 L
Mistroke
.6993 .29737 L
.7003 .30946 L
.7013 .32028 L
.7023 .32984 L
.7033 .3382 L
.7043 .34542 L
.70529 .35159 L
.70629 .35681 L
.70729 .36117 L
.70829 .36479 L
.70929 .36776 L
.71029 .37017 L
.71129 .37211 L
.71229 .37364 L
.71329 .37485 L
.71429 .37578 L
.71528 .37649 L
.71628 .37702 L
.71728 .37741 L
.71828 .37768 L
.71928 .37787 L
.72028 .378 L
.72128 .37808 L
.72228 .37812 L
.72328 .37814 L
.72428 .37814 L
.72527 .37814 L
.72627 .37813 L
.72727 .37813 L
.72827 .37813 L
.72927 .37814 L
.73027 .37816 L
.73127 .37819 L
.73227 .37823 L
.73327 .37829 L
.73427 .37836 L
.73526 .37845 L
.73626 .37854 L
.73726 .37866 L
.73826 .37878 L
.73926 .37892 L
.74026 .37908 L
.74126 .37925 L
.74226 .37943 L
.74326 .37963 L
.74426 .37984 L
.74525 .38007 L
.74625 .3803 L
.74725 .38055 L
.74825 .38081 L
Mistroke
.74925 .25375 L
.75025 .23642 L
.75125 .22033 L
.75225 .20523 L
.75325 .19114 L
.75425 .17828 L
.75524 .16709 L
.75624 .15815 L
.75724 .15213 L
.75824 .14973 L
.75924 .15157 L
.76024 .15808 L
.76124 .16938 L
.76224 .18522 L
.76324 .20493 L
.76424 .22753 L
.76523 .25183 L
.76623 .27661 L
.76723 .30072 L
.76823 .32325 L
.76923 .34355 L
.77023 .3612 L
.77123 .37603 L
.77223 .38804 L
.77323 .39735 L
.77423 .40418 L
.77522 .40879 L
.77622 .41149 L
.77722 .41256 L
.77822 .4123 L
.77922 .411 L
.78022 .40892 L
.78122 .40629 L
.78222 .4033 L
.78322 .40012 L
.78422 .3969 L
.78521 .39373 L
.78621 .3907 L
.78721 .38787 L
.78821 .38527 L
.78921 .38292 L
.79021 .38083 L
.79121 .379 L
.79221 .37741 L
.79321 .37605 L
.79421 .3749 L
.7952 .37394 L
.7962 .37315 L
.7972 .37251 L
.7982 .37199 L
Mistroke
.7992 .47138 L
.8002 .47605 L
.8012 .47906 L
.8022 .48064 L
.8032 .48097 L
.8042 .48019 L
.80519 .47843 L
.80619 .47584 L
.80719 .47252 L
.80819 .4686 L
.80919 .46421 L
.81019 .45945 L
.81119 .45446 L
.81219 .44933 L
.81319 .44416 L
.81419 .43904 L
.81518 .43404 L
.81618 .42923 L
.81718 .42466 L
.81818 .42035 L
.81918 .41634 L
.82018 .41263 L
.82118 .40924 L
.82218 .40615 L
.82318 .40336 L
.82418 .40086 L
.82517 .39862 L
.82617 .39664 L
.82717 .3949 L
.82817 .39336 L
.82917 .39202 L
.83017 .39086 L
.83117 .38985 L
.83217 .38899 L
.83317 .38825 L
.83417 .38763 L
.83516 .38711 L
.83616 .38668 L
.83716 .38633 L
.83816 .38606 L
.83916 .38585 L
.84016 .3857 L
.84116 .38561 L
.84216 .38557 L
.84316 .38557 L
.84416 .38562 L
.84515 .3857 L
.84615 .38582 L
.84715 .38598 L
.84815 .38617 L
Mistroke
.84915 .50875 L
.85015 .50947 L
.85115 .5085 L
.85215 .50594 L
.85315 .50193 L
.85415 .49661 L
.85514 .49016 L
.85614 .48281 L
.85714 .47476 L
.85814 .46627 L
.85914 .45755 L
.86014 .44883 L
.86114 .4403 L
.86214 .4321 L
.86314 .42437 L
.86414 .41719 L
.86513 .41062 L
.86613 .40468 L
.86713 .39938 L
.86813 .3947 L
.86913 .39062 L
.87013 .38708 L
.87113 .38405 L
.87213 .38147 L
.87313 .3793 L
.87413 .37749 L
.87512 .37598 L
.87612 .37474 L
.87712 .37373 L
.87812 .37291 L
.87912 .37225 L
.88012 .37173 L
.88112 .37132 L
.88212 .371 L
.88312 .37075 L
.88412 .37057 L
.88511 .37043 L
.88611 .37033 L
.88711 .37026 L
.88811 .37021 L
.88911 .37018 L
.89011 .37017 L
.89111 .37016 L
.89211 .37017 L
.89311 .37018 L
.89411 .37019 L
.8951 .37021 L
.8961 .37023 L
.8971 .37025 L
.8981 .37027 L
Mistroke
.8991 .46246 L
.9001 .47207 L
.9011 .48141 L
.9021 .49058 L
.9031 .49961 L
.9041 .50848 L
.90509 .51706 L
.90609 .52519 L
.90709 .53265 L
.90809 .53917 L
.90909 .54443 L
.91009 .54813 L
.91109 .54993 L
.91209 .54957 L
.91309 .54684 L
.91409 .54164 L
.91508 .53402 L
.91608 .52416 L
.91708 .51237 L
.91808 .49908 L
.91908 .48479 L
.92008 .47003 L
.92108 .45529 L
.92208 .44101 L
.92308 .42755 L
.92408 .41517 L
.92507 .40403 L
.92607 .39423 L
.92707 .38578 L
.92807 .37863 L
.92907 .37271 L
.93007 .36792 L
.93107 .36413 L
.93207 .36122 L
.93307 .35907 L
.93407 .35755 L
.93506 .35656 L
.93606 .356 L
.93706 .35577 L
.93806 .35581 L
.93906 .35604 L
.94006 .35641 L
.94106 .35688 L
.94206 .3574 L
.94306 .35795 L
.94406 .35851 L
.94505 .35906 L
.94605 .35958 L
.94705 .36008 L
.94805 .36054 L
Mistroke
.94905 .32941 L
.95005 .32746 L
.95105 .32556 L
.95205 .32366 L
.95305 .32173 L
.95405 .31975 L
.95504 .31771 L
.95604 .31559 L
.95704 .31338 L
.95804 .31107 L
.95904 .30867 L
.96004 .30617 L
.96104 .30357 L
.96204 .30088 L
.96304 .2981 L
.96404 .29524 L
.96503 .29232 L
.96603 .28936 L
.96703 .28636 L
.96803 .28337 L
.96903 .2804 L
.97003 .27749 L
.97103 .27467 L
.97203 .27198 L
.97303 .26946 L
.97403 .26716 L
.97502 .26512 L
.97602 .26338 L
.97702 .26198 L
.97802 .26095 L
.97902 .26033 L
.98002 .26013 L
.98102 .26037 L
.98202 .26105 L
.98302 .26217 L
.98402 .26372 L
.98501 .26566 L
.98601 .26798 L
.98701 .27063 L
.98801 .27359 L
.98901 .27679 L
.99001 .28021 L
.99101 .28379 L
.99201 .28749 L
.99301 .29128 L
.99401 .29511 L
.995 .29894 L
.996 .30274 L
.997 .30647 L
.998 .31012 L
Mistroke
.999 .31679 L
Mfstroke
0 0 0 r
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .30296 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28377 L
.005 .2789 L
.00599 .27359 L
.00699 .26776 L
.00799 .26135 L
.00899 .25427 L
.00999 .24643 L
.01099 .23771 L
.01199 .22802 L
.01299 .21723 L
.01399 .20521 L
.01499 .1918 L
.01598 .17686 L
.01698 .16023 L
.01798 .14173 L
.01898 .12121 L
.01998 .0985 L
.02098 .07347 L
.02198 .04603 L
.02298 .01615 L
s
.02298 .01615 m
.02348 0 L
s
.03826 0 m
.03896 .06198 L
.03996 .15102 L
.04096 .23491 L
.04196 .30973 L
.04296 .37367 L
.04396 .42458 L
.04496 .42379 L
.04595 .34093 L
.04695 .25218 L
.04795 .1714 L
.04895 .1041 L
.04995 .02839 L
.05095 .0585 L
.05195 .10211 L
.05295 .15728 L
.05395 .21976 L
.05495 .28346 L
.05594 .34187 L
.05694 .38971 L
.05794 .424 L
.05894 .44408 L
.05994 .45081 L
.06094 .44552 L
.06194 .42956 L
.06294 .40435 L
.06394 .37186 L
.06494 .33485 L
.06593 .29675 L
.06693 .26105 L
.06793 .23073 L
.06893 .20782 L
.06993 .19325 L
.07093 .18682 L
.07193 .18739 L
.07293 .19317 L
.07393 .20229 L
.07493 .21355 L
.07592 .22643 L
.07692 .24064 L
.07792 .25567 L
.07892 .27078 L
.07992 .28508 L
.08092 .29754 L
.08192 .30703 L
.08292 .31232 L
.08392 .31218 L
.08492 .30611 L
.08591 .29526 L
.08691 .28202 L
Mistroke
.08791 .2689 L
.08891 .25788 L
.08991 .25022 L
.09091 .24649 L
.09191 .24649 L
.09291 .2493 L
.09391 .2534 L
.09491 .25712 L
.0959 .25965 L
.0969 .26137 L
.0979 .26313 L
.0989 .26552 L
.0999 .3221 L
.1009 .31826 L
.1019 .31561 L
.1029 .31347 L
.1039 .31166 L
.1049 .31005 L
.10589 .30861 L
.10689 .30728 L
.10789 .30604 L
.10889 .30487 L
.10989 .30377 L
.11089 .30271 L
.11189 .30168 L
.11289 .30069 L
.11389 .29972 L
.11489 .29877 L
.11588 .29783 L
.11688 .2969 L
.11788 .29598 L
.11888 .29506 L
.11988 .29415 L
.12088 .29323 L
.12188 .29232 L
.12288 .2914 L
.12388 .29048 L
.12488 .28956 L
.12587 .28863 L
.12687 .2877 L
.12787 .28677 L
.12887 .28584 L
.12987 .28491 L
.13087 .28398 L
.13187 .28306 L
.13287 .28214 L
.13387 .28124 L
.13487 .28035 L
.13586 .27948 L
.13686 .27863 L
Mistroke
.13786 .27781 L
.13886 .27702 L
.13986 .27626 L
.14086 .27555 L
.14186 .27487 L
.14286 .27425 L
.14386 .27367 L
.14486 .27314 L
.14585 .27267 L
.14685 .27225 L
.14785 .27187 L
.14885 .27155 L
.14985 .36334 L
.15085 .33463 L
.15185 .3093 L
.15285 .28787 L
.15385 .27064 L
.15485 .25756 L
.15584 .24828 L
.15684 .2423 L
.15784 .23907 L
.15884 .23805 L
.15984 .23876 L
.16084 .24078 L
.16184 .24372 L
.16284 .24727 L
.16384 .25115 L
.16484 .25516 L
.16583 .25913 L
.16683 .26292 L
.16783 .26646 L
.16883 .26969 L
.16983 .2726 L
.17083 .27517 L
.17183 .27741 L
.17283 .27933 L
.17383 .28097 L
.17483 .28233 L
.17582 .28344 L
.17682 .28434 L
.17782 .28504 L
.17882 .28557 L
.17982 .28595 L
.18082 .28619 L
.18182 .28633 L
.18282 .28638 L
.18382 .28634 L
.18482 .28625 L
.18581 .2861 L
.18681 .28591 L
Mistroke
.18781 .28569 L
.18881 .28544 L
.18981 .28518 L
.19081 .2849 L
.19181 .28462 L
.19281 .28432 L
.19381 .28402 L
.19481 .28371 L
.1958 .2834 L
.1968 .28309 L
.1978 .28277 L
.1988 .28244 L
.1998 .16488 L
.2008 .15737 L
.2018 .15074 L
.2028 .14479 L
.2038 .13981 L
.2048 .13621 L
.20579 .13439 L
.20679 .13473 L
.20779 .1375 L
.20879 .14281 L
.20979 .15063 L
.21079 .16069 L
.21179 .17254 L
.21279 .18562 L
.21379 .19929 L
.21479 .21297 L
.21578 .22614 L
.21678 .23844 L
.21778 .2496 L
.21878 .25949 L
.21978 .26804 L
.22078 .27528 L
.22178 .28129 L
.22278 .28615 L
.22378 .28999 L
.22478 .29294 L
.22577 .29511 L
.22677 .29661 L
.22777 .29756 L
.22877 .29803 L
.22977 .29812 L
.23077 .29789 L
.23177 .29741 L
.23277 .29674 L
.23377 .29594 L
.23477 .29505 L
.23576 .29411 L
.23676 .29315 L
Mistroke
.23776 .2922 L
.23876 .29128 L
.23976 .2904 L
.24076 .28956 L
.24176 .28878 L
.24276 .28805 L
.24376 .28736 L
.24476 .28672 L
.24575 .28612 L
.24675 .28555 L
.24775 .28501 L
.24875 .2845 L
.24975 .38465 L
.25075 .37998 L
.25175 .37628 L
.25275 .37286 L
.25375 .36951 L
.25475 .36616 L
.25574 .36277 L
.25674 .35934 L
.25774 .35587 L
.25874 .35239 L
.25974 .3489 L
.26074 .34543 L
.26174 .34201 L
.26274 .33864 L
.26374 .33536 L
.26474 .33216 L
.26573 .32907 L
.26673 .3261 L
.26773 .32325 L
.26873 .32054 L
.26973 .31796 L
.27073 .31552 L
.27173 .31322 L
.27273 .31106 L
.27373 .30904 L
.27473 .30715 L
.27572 .30539 L
.27672 .30376 L
.27772 .30223 L
.27872 .30082 L
.27972 .2995 L
.28072 .29828 L
.28172 .29713 L
.28272 .29606 L
.28372 .29505 L
.28472 .2941 L
.28571 .29319 L
.28671 .29233 L
Mistroke
.28771 .2915 L
.28871 .29069 L
.28971 .28991 L
.29071 .28915 L
.29171 .2884 L
.29271 .28766 L
.29371 .28692 L
.29471 .28619 L
.2957 .28545 L
.2967 .2847 L
.2977 .28395 L
.2987 .28319 L
.2997 .34463 L
.3007 .34018 L
.3017 .33698 L
.3027 .33433 L
.3037 .33204 L
.3047 .33 L
.30569 .32816 L
.30669 .32647 L
.30769 .32491 L
.30869 .32347 L
.30969 .32212 L
.31069 .32086 L
.31169 .31969 L
.31269 .31858 L
.31369 .31753 L
.31469 .31655 L
.31568 .31562 L
.31668 .31473 L
.31768 .3139 L
.31868 .3131 L
.31968 .31235 L
.32068 .31163 L
.32168 .31095 L
.32268 .3103 L
.32368 .30968 L
.32468 .3091 L
.32567 .30854 L
.32667 .308 L
.32767 .3075 L
.32867 .30702 L
.32967 .30656 L
.33067 .30612 L
.33167 .30571 L
.33267 .30532 L
.33367 .30495 L
.33467 .30459 L
.33566 .30425 L
.33666 .30393 L
Mistroke
.33766 .30362 L
.33866 .30333 L
.33966 .30304 L
.34066 .30277 L
.34166 .3025 L
.34266 .30223 L
.34366 .30197 L
.34466 .3017 L
.34565 .30144 L
.34665 .30116 L
.34765 .30088 L
.34865 .30059 L
.34965 .37867 L
.35065 .36072 L
.35165 .34447 L
.35265 .32977 L
.35365 .31678 L
.35465 .30562 L
.35564 .29628 L
.35664 .28869 L
.35764 .2827 L
.35864 .27813 L
.35964 .27477 L
.36064 .27243 L
.36164 .27091 L
.36264 .27006 L
.36364 .26971 L
.36464 .26974 L
.36563 .27004 L
.36663 .27053 L
.36763 .27113 L
.36863 .27179 L
.36963 .27245 L
.37063 .2731 L
.37163 .27371 L
.37263 .27426 L
.37363 .27475 L
.37463 .27516 L
.37562 .27549 L
.37662 .27575 L
.37762 .27594 L
.37862 .27606 L
.37962 .27611 L
.38062 .2761 L
.38162 .27602 L
.38262 .27589 L
.38362 .2757 L
.38462 .27546 L
.38561 .27517 L
.38661 .27484 L
Mistroke
.38761 .27445 L
.38861 .27401 L
.38961 .27353 L
.39061 .27301 L
.39161 .27244 L
.39261 .27182 L
.39361 .27115 L
.39461 .27043 L
.3956 .26967 L
.3966 .26885 L
.3976 .26798 L
.3986 .26705 L
.3996 .25441 L
.4006 .24566 L
.4016 .23788 L
.4026 .23021 L
.4036 .2224 L
.4046 .21432 L
.40559 .20591 L
.40659 .19718 L
.40759 .18815 L
.40859 .17889 L
.40959 .1695 L
.41059 .16014 L
.41159 .15103 L
.41259 .14243 L
.41359 .13464 L
.41459 .12802 L
.41558 .12293 L
.41658 .11969 L
.41758 .11848 L
.41858 .11929 L
.41958 .12171 L
.42058 .12504 L
.42158 .12853 L
.42258 .13191 L
.42358 .13555 L
.42458 .14011 L
.42557 .14616 L
.42657 .15403 L
.42757 .16375 L
.42857 .17511 L
.42957 .18767 L
.43057 .20089 L
.43157 .2142 L
.43257 .22706 L
.43357 .23905 L
.43457 .24984 L
.43556 .25929 L
.43656 .26732 L
Mistroke
.43756 .27398 L
.43856 .27937 L
.43956 .28361 L
.44056 .28685 L
.44156 .28924 L
.44256 .29091 L
.44356 .292 L
.44456 .2926 L
.44555 .29283 L
.44655 .29277 L
.44755 .29249 L
.44855 .29204 L
.44955 .36956 L
.45055 .3633 L
.45155 .35795 L
.45255 .35295 L
.45355 .34819 L
.45455 .34364 L
.45554 .3393 L
.45654 .33519 L
.45754 .3313 L
.45854 .32765 L
.45954 .32424 L
.46054 .32108 L
.46154 .31815 L
.46254 .31546 L
.46354 .31298 L
.46454 .31071 L
.46553 .30863 L
.46653 .30673 L
.46753 .30499 L
.46853 .30339 L
.46953 .30192 L
.47053 .30057 L
.47153 .29931 L
.47253 .29815 L
.47353 .29705 L
.47453 .29603 L
.47552 .29505 L
.47652 .29412 L
.47752 .29322 L
.47852 .29235 L
.47952 .2915 L
.48052 .29066 L
.48152 .28983 L
.48252 .289 L
.48352 .28817 L
.48452 .28733 L
.48551 .28649 L
.48651 .28562 L
Mistroke
.48751 .28474 L
.48851 .28384 L
.48951 .28291 L
.49051 .28195 L
.49151 .28096 L
.49251 .27994 L
.49351 .27888 L
.49451 .27777 L
.4955 .27663 L
.4965 .27544 L
.4975 .2742 L
.4985 .27292 L
.4995 .38961 L
.5005 .36789 L
.5015 .34779 L
.5025 .32947 L
.5035 .3133 L
.5045 .29953 L
.50549 .28822 L
.50649 .27925 L
.50749 .27243 L
.50849 .26748 L
.50949 .2641 L
.51049 .26201 L
.51149 .26095 L
.51249 .26069 L
.51349 .26102 L
.51449 .26177 L
.51548 .2628 L
.51648 .264 L
.51748 .26528 L
.51848 .26656 L
.51948 .26781 L
.52048 .26898 L
.52148 .27004 L
.52248 .27099 L
.52348 .27182 L
.52448 .27253 L
.52547 .27312 L
.52647 .27359 L
.52747 .27395 L
.52847 .27421 L
.52947 .27438 L
.53047 .27445 L
.53147 .27445 L
.53247 .27436 L
.53347 .27421 L
.53447 .27398 L
.53546 .27369 L
.53646 .27333 L
Mistroke
.53746 .27292 L
.53846 .27244 L
.53946 .27191 L
.54046 .27132 L
.54146 .27067 L
.54246 .26997 L
.54346 .2692 L
.54446 .26837 L
.54545 .26748 L
.54645 .26652 L
.54745 .2655 L
.54845 .26441 L
.54945 .38254 L
.55045 .38235 L
.55145 .38422 L
.55245 .38721 L
.55345 .39094 L
.55445 .39521 L
.55544 .39987 L
.55644 .40479 L
.55744 .40985 L
.55844 .41492 L
.55944 .41984 L
.56044 .42442 L
.56144 .42842 L
.56244 .43155 L
.56344 .4334 L
.56444 .43345 L
.56543 .43106 L
.56643 .42555 L
.56743 .41636 L
.56843 .4034 L
.56943 .38721 L
.57043 .36882 L
.57143 .3495 L
.57243 .33049 L
.57343 .31282 L
.57443 .29725 L
.57542 .28417 L
.57642 .27373 L
.57742 .26581 L
.57842 .26016 L
.57942 .25647 L
.58042 .25438 L
.58142 .25357 L
.58242 .25375 L
.58342 .25466 L
.58442 .25608 L
.58541 .25783 L
.58641 .25976 L
Mistroke
.58741 .26176 L
.58841 .26372 L
.58941 .26559 L
.59041 .26731 L
.59141 .26886 L
.59241 .27022 L
.59341 .27139 L
.59441 .27237 L
.5954 .27318 L
.5964 .27384 L
.5974 .27434 L
.5984 .27471 L
.5994 .23719 L
.6004 .23375 L
.6014 .23145 L
.6024 .2296 L
.6034 .22799 L
.6044 .22656 L
.60539 .22525 L
.60639 .22407 L
.60739 .22299 L
.60839 .22201 L
.60939 .22115 L
.61039 .22039 L
.61139 .21973 L
.61239 .21918 L
.61339 .21874 L
.61439 .21839 L
.61538 .21814 L
.61638 .21797 L
.61738 .21789 L
.61838 .21787 L
.61938 .21792 L
.62038 .21802 L
.62138 .21816 L
.62238 .21834 L
.62338 .21853 L
.62438 .21874 L
.62537 .21895 L
.62637 .21916 L
.62737 .21935 L
.62837 .21952 L
.62937 .21967 L
.63037 .21979 L
.63137 .21987 L
.63237 .21992 L
.63337 .21993 L
.63437 .2199 L
.63536 .21983 L
.63636 .21972 L
Mistroke
.63736 .21957 L
.63836 .21939 L
.63936 .21916 L
.64036 .2189 L
.64136 .21861 L
.64236 .21828 L
.64336 .21792 L
.64436 .21753 L
.64535 .21712 L
.64635 .21668 L
.64735 .21622 L
.64835 .21574 L
.64935 .26074 L
.65035 .25624 L
.65135 .25289 L
.65235 .24996 L
.65335 .24725 L
.65435 .24466 L
.65534 .24213 L
.65634 .23963 L
.65734 .23715 L
.65834 .23468 L
.65934 .2322 L
.66034 .22972 L
.66134 .22725 L
.66234 .22478 L
.66334 .22232 L
.66434 .21989 L
.66533 .21749 L
.66633 .21514 L
.66733 .21285 L
.66833 .21065 L
.66933 .20854 L
.67033 .20655 L
.67133 .20468 L
.67233 .20297 L
.67333 .20142 L
.67433 .20005 L
.67532 .19886 L
.67632 .19787 L
.67732 .19706 L
.67832 .19644 L
.67932 .196 L
.68032 .1957 L
.68132 .19553 L
.68232 .19545 L
.68332 .19542 L
.68432 .19542 L
.68531 .1954 L
.68631 .19534 L
Mistroke
.68731 .1952 L
.68831 .19498 L
.68931 .19468 L
.69031 .1943 L
.69131 .19386 L
.69231 .1934 L
.69331 .19293 L
.69431 .19251 L
.6953 .19214 L
.6963 .19188 L
.6973 .19174 L
.6983 .19175 L
.6993 .29242 L
.7003 .29318 L
.7013 .29416 L
.7023 .29488 L
.7033 .29527 L
.7043 .29537 L
.70529 .29522 L
.70629 .29489 L
.70729 .29441 L
.70829 .29382 L
.70929 .29316 L
.71029 .29246 L
.71129 .29172 L
.71229 .29096 L
.71329 .29019 L
.71429 .28941 L
.71528 .28863 L
.71628 .28785 L
.71728 .28707 L
.71828 .28628 L
.71928 .28549 L
.72028 .28468 L
.72128 .28386 L
.72228 .28302 L
.72328 .28216 L
.72428 .28127 L
.72527 .28036 L
.72627 .27941 L
.72727 .27842 L
.72827 .27738 L
.72927 .2763 L
.73027 .27516 L
.73127 .27397 L
.73227 .27271 L
.73327 .27139 L
.73427 .26999 L
.73526 .26852 L
.73626 .26695 L
Mistroke
.73726 .2653 L
.73826 .26355 L
.73926 .2617 L
.74026 .25973 L
.74126 .25765 L
.74226 .25544 L
.74326 .25309 L
.74426 .25061 L
.74525 .24797 L
.74625 .24518 L
.74725 .24222 L
.74825 .23909 L
.74925 .13295 L
.75025 .11953 L
.75125 .1072 L
.75225 .09615 L
.75325 .08721 L
.75425 .08136 L
.75524 .07962 L
.75624 .08288 L
.75724 .09167 L
.75824 .10603 L
.75924 .12539 L
.76024 .14866 L
.76124 .17448 L
.76224 .20132 L
.76324 .22768 L
.76424 .25222 L
.76523 .27389 L
.76623 .29206 L
.76723 .30651 L
.76823 .31735 L
.76923 .32493 L
.77023 .3297 L
.77123 .33214 L
.77223 .33266 L
.77323 .33166 L
.77423 .32943 L
.77522 .32626 L
.77622 .32239 L
.77722 .31807 L
.77822 .31353 L
.77922 .30899 L
.78022 .30462 L
.78122 .30058 L
.78222 .29695 L
.78322 .29378 L
.78422 .29109 L
.78521 .28885 L
.78621 .28702 L
Mistroke
.78721 .28557 L
.78821 .28443 L
.78921 .28355 L
.79021 .28289 L
.79121 .28239 L
.79221 .28201 L
.79321 .28173 L
.79421 .2815 L
.7952 .28131 L
.7962 .28114 L
.7972 .28097 L
.7982 .28078 L
.7992 .40629 L
.8002 .39922 L
.8012 .39288 L
.8022 .38662 L
.8032 .38027 L
.8042 .37383 L
.80519 .36733 L
.80619 .36085 L
.80719 .35445 L
.80819 .34821 L
.80919 .3422 L
.81019 .3365 L
.81119 .33113 L
.81219 .32614 L
.81319 .32155 L
.81419 .31736 L
.81518 .31358 L
.81618 .31019 L
.81718 .30716 L
.81818 .30448 L
.81918 .30211 L
.82018 .30002 L
.82118 .29819 L
.82218 .29656 L
.82318 .29513 L
.82418 .29385 L
.82517 .2927 L
.82617 .29166 L
.82717 .2907 L
.82817 .28981 L
.82917 .28896 L
.83017 .28816 L
.83117 .28738 L
.83217 .28661 L
.83317 .28585 L
.83417 .28508 L
.83516 .2843 L
.83616 .2835 L
Mistroke
.83716 .28268 L
.83816 .28184 L
.83916 .28096 L
.84016 .28004 L
.84116 .27908 L
.84216 .27808 L
.84316 .27703 L
.84416 .27593 L
.84515 .27476 L
.84615 .27354 L
.84715 .27225 L
.84815 .27089 L
.84915 .42084 L
.85015 .41037 L
.85115 .40005 L
.85215 .38946 L
.85315 .37864 L
.85415 .36779 L
.85514 .35713 L
.85614 .34689 L
.85714 .33726 L
.85814 .3284 L
.85914 .32039 L
.86014 .3133 L
.86114 .30713 L
.86214 .30184 L
.86314 .29737 L
.86414 .29366 L
.86513 .29061 L
.86613 .28813 L
.86713 .28615 L
.86813 .28456 L
.86913 .28331 L
.87013 .28231 L
.87113 .28152 L
.87213 .28088 L
.87313 .28034 L
.87413 .27988 L
.87512 .27947 L
.87612 .27908 L
.87712 .2787 L
.87812 .27831 L
.87912 .2779 L
.88012 .27746 L
.88112 .27698 L
.88212 .27647 L
.88312 .2759 L
.88412 .27529 L
.88511 .27463 L
.88611 .27391 L
Mistroke
.88711 .27313 L
.88811 .27229 L
.88911 .27139 L
.89011 .27041 L
.89111 .26937 L
.89211 .26825 L
.89311 .26706 L
.89411 .26578 L
.8951 .26441 L
.8961 .26295 L
.8971 .2614 L
.8981 .25974 L
.8991 .41903 L
.9001 .4218 L
.9011 .42594 L
.9021 .43046 L
.9031 .43493 L
.9041 .43901 L
.90509 .44236 L
.90609 .44468 L
.90709 .44561 L
.90809 .44479 L
.90909 .44187 L
.91009 .43649 L
.91109 .42835 L
.91209 .41729 L
.91309 .4034 L
.91409 .38712 L
.91508 .36923 L
.91608 .35073 L
.91708 .33265 L
.91808 .31587 L
.91908 .30105 L
.92008 .28854 L
.92108 .27847 L
.92208 .27074 L
.92308 .26512 L
.92408 .26133 L
.92507 .25905 L
.92607 .25798 L
.92707 .25784 L
.92807 .25838 L
.92907 .2594 L
.93007 .26073 L
.93107 .26222 L
.93207 .26377 L
.93307 .26528 L
.93407 .26672 L
.93506 .26803 L
.93606 .26919 L
Mistroke
.93706 .27019 L
.93806 .27104 L
.93906 .27172 L
.94006 .27226 L
.94106 .27266 L
.94206 .27292 L
.94306 .27307 L
.94406 .27311 L
.94505 .27304 L
.94605 .27287 L
.94705 .27262 L
.94805 .27228 L
.94905 .26036 L
.95005 .25487 L
.95105 .25046 L
.95205 .24639 L
.95305 .24245 L
.95405 .23854 L
.95504 .23459 L
.95604 .23059 L
.95704 .22653 L
.95804 .2224 L
.95904 .21821 L
.96004 .21398 L
.96104 .20972 L
.96204 .20547 L
.96304 .20126 L
.96404 .19714 L
.96503 .19316 L
.96603 .18938 L
.96703 .18586 L
.96803 .18265 L
.96903 .17983 L
.97003 .17746 L
.97103 .17557 L
.97203 .1742 L
.97303 .17335 L
.97403 .173 L
.97502 .17308 L
.97602 .17349 L
.97702 .17407 L
.97802 .1747 L
.97902 .17523 L
.98002 .17559 L
.98102 .17576 L
.98202 .1758 L
.98302 .17582 L
.98402 .17594 L
.98501 .17629 L
.98601 .17698 L
Mistroke
.98701 .17809 L
.98801 .17968 L
.98901 .18176 L
.99001 .18433 L
.99101 .18733 L
.99201 .19072 L
.99301 .19442 L
.99401 .19834 L
.995 .2024 L
.996 .2065 L
.997 .21058 L
.998 .21455 L
.999 .30296 L
Mfstroke
gsave
.999 .31517 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32501 L
.005 .328 L
.00599 .33136 L
.00699 .33513 L
.00799 .33933 L
.00899 .34402 L
.00999 .34923 L
.01099 .35502 L
.01199 .36148 L
.01299 .36867 L
.01399 .3767 L
.01499 .38565 L
.01598 .39563 L
.01698 .40677 L
.01798 .4192 L
.01898 .43305 L
.01998 .44845 L
.02098 .46557 L
.02198 .48452 L
.02298 .50543 L
.02398 .5284 L
.02498 .55347 L
.02597 .58061 L
.02697 .60971 L
s
.02697 .60971 m
.02724 .61803 L
s
.04291 .61803 m
.04296 .61466 L
.04396 .53808 L
.04496 .49611 L
.04595 .52544 L
.04695 .55695 L
.04795 .58319 L
.04895 .60338 L
.04995 .04109 L
.05095 .08057 L
.05195 .13339 L
.05295 .19784 L
.05395 .26897 L
.05495 .33973 L
.05594 .40298 L
.05694 .45348 L
.05794 .48881 L
.05894 .50906 L
.05994 .51576 L
.06094 .51097 L
.06194 .49681 L
.06294 .47534 L
.06394 .44848 L
.06494 .41806 L
.06593 .38595 L
.06693 .35416 L
.06793 .32474 L
.06893 .29953 L
.06993 .28006 L
.07093 .26743 L
.07193 .26243 L
.07293 .2655 L
.07393 .27639 L
.07493 .29363 L
.07592 .31469 L
.07692 .33668 L
.07792 .35694 L
.07892 .37344 L
.07992 .38487 L
.08092 .39076 L
.08192 .39152 L
.08292 .38845 L
.08392 .38345 L
.08492 .37829 L
.08591 .37347 L
.08691 .36846 L
.08791 .36268 L
.08891 .35593 L
.08991 .34845 L
.09091 .34078 L
Mistroke
.09191 .33376 L
.09291 .32846 L
.09391 .32613 L
.09491 .32775 L
.0959 .33319 L
.0969 .34095 L
.0979 .34901 L
.0989 .35569 L
.0999 .33466 L
.1009 .33867 L
.1019 .34153 L
.1029 .34392 L
.1039 .34604 L
.1049 .34799 L
.10589 .34982 L
.10689 .35159 L
.10789 .35331 L
.10889 .355 L
.10989 .35669 L
.11089 .35837 L
.11189 .36007 L
.11289 .3618 L
.11389 .36354 L
.11489 .36532 L
.11588 .36714 L
.11688 .369 L
.11788 .3709 L
.11888 .37284 L
.11988 .37483 L
.12088 .37686 L
.12188 .37894 L
.12288 .38107 L
.12388 .38323 L
.12488 .38544 L
.12587 .38768 L
.12687 .38995 L
.12787 .39225 L
.12887 .39456 L
.12987 .39688 L
.13087 .39921 L
.13187 .40152 L
.13287 .40381 L
.13387 .40606 L
.13487 .40826 L
.13586 .41039 L
.13686 .41245 L
.13786 .4144 L
.13886 .41623 L
.13986 .41792 L
.14086 .41946 L
Mistroke
.14186 .42083 L
.14286 .422 L
.14386 .42298 L
.14486 .42373 L
.14585 .42426 L
.14685 .42456 L
.14785 .42462 L
.14885 .42444 L
.14985 .37553 L
.15085 .35571 L
.15185 .33734 L
.15285 .32161 L
.15385 .30892 L
.15485 .29929 L
.15584 .29251 L
.15684 .28823 L
.15784 .28604 L
.15884 .28557 L
.15984 .28647 L
.16084 .28843 L
.16184 .2912 L
.16284 .29455 L
.16384 .29829 L
.16484 .30226 L
.16583 .3063 L
.16683 .31028 L
.16783 .3141 L
.16883 .31767 L
.16983 .32093 L
.17083 .32384 L
.17183 .32637 L
.17283 .32854 L
.17383 .33034 L
.17483 .33182 L
.17582 .33299 L
.17682 .3339 L
.17782 .33459 L
.17882 .33509 L
.17982 .33544 L
.18082 .33567 L
.18182 .33581 L
.18282 .33588 L
.18382 .33591 L
.18482 .33591 L
.18581 .33589 L
.18681 .33587 L
.18781 .33586 L
.18881 .33585 L
.18981 .33586 L
.19081 .33588 L
Mistroke
.19181 .33593 L
.19281 .33599 L
.19381 .33608 L
.19481 .33619 L
.1958 .33632 L
.1968 .33648 L
.1978 .33665 L
.1988 .33685 L
.1998 .17699 L
.2008 .17772 L
.2018 .1772 L
.2028 .17664 L
.2038 .17667 L
.2048 .17775 L
.20579 .18022 L
.20679 .18438 L
.20779 .1904 L
.20879 .19838 L
.20979 .20832 L
.21079 .22006 L
.21179 .23337 L
.21279 .24784 L
.21379 .26297 L
.21479 .27817 L
.21578 .29282 L
.21678 .30638 L
.21778 .31844 L
.21878 .32872 L
.21978 .33713 L
.22078 .3437 L
.22178 .34856 L
.22278 .35193 L
.22378 .35401 L
.22478 .35504 L
.22577 .35523 L
.22677 .3548 L
.22777 .35392 L
.22877 .35274 L
.22977 .35139 L
.23077 .34997 L
.23177 .34855 L
.23277 .34718 L
.23377 .34591 L
.23477 .34476 L
.23576 .34373 L
.23676 .34283 L
.23776 .34205 L
.23876 .3414 L
.23976 .34085 L
.24076 .3404 L
Mistroke
.24176 .34005 L
.24276 .33979 L
.24376 .3396 L
.24476 .33948 L
.24575 .33942 L
.24675 .33943 L
.24775 .33949 L
.24875 .33959 L
.24975 .39676 L
.25075 .40025 L
.25175 .40238 L
.25275 .40381 L
.25375 .40471 L
.25475 .40517 L
.25574 .40522 L
.25674 .40488 L
.25774 .40419 L
.25874 .40317 L
.25974 .40186 L
.26074 .40029 L
.26174 .39851 L
.26274 .39656 L
.26374 .39447 L
.26474 .39231 L
.26573 .39011 L
.26673 .3879 L
.26773 .38573 L
.26873 .38363 L
.26973 .38161 L
.27073 .37969 L
.27173 .3779 L
.27273 .37623 L
.27373 .37469 L
.27473 .37329 L
.27572 .37202 L
.27672 .37089 L
.27772 .36988 L
.27872 .369 L
.27972 .36824 L
.28072 .36759 L
.28172 .36705 L
.28272 .36661 L
.28372 .36627 L
.28472 .36602 L
.28571 .36587 L
.28671 .3658 L
.28771 .36581 L
.28871 .3659 L
.28971 .36606 L
.29071 .3663 L
Mistroke
.29171 .36661 L
.29271 .36699 L
.29371 .36744 L
.29471 .36795 L
.2957 .36853 L
.2967 .36917 L
.2977 .36987 L
.2987 .37064 L
.2997 .35678 L
.3007 .36037 L
.3017 .3628 L
.3027 .36474 L
.3037 .3664 L
.3047 .36789 L
.30569 .36926 L
.30669 .37055 L
.30769 .37177 L
.30869 .37294 L
.30969 .37408 L
.31069 .37519 L
.31169 .37628 L
.31269 .37736 L
.31369 .37842 L
.31469 .37947 L
.31568 .38052 L
.31668 .38156 L
.31768 .38259 L
.31868 .38362 L
.31968 .38465 L
.32068 .38566 L
.32168 .38668 L
.32268 .38768 L
.32368 .38868 L
.32468 .38966 L
.32567 .39063 L
.32667 .39159 L
.32767 .39254 L
.32867 .39346 L
.32967 .39437 L
.33067 .39526 L
.33167 .39612 L
.33267 .39696 L
.33367 .39777 L
.33467 .39855 L
.33566 .3993 L
.33666 .40002 L
.33766 .40071 L
.33866 .40137 L
.33966 .402 L
.34066 .4026 L
Mistroke
.34166 .40316 L
.34266 .40369 L
.34366 .4042 L
.34466 .40468 L
.34565 .40513 L
.34665 .40556 L
.34765 .40597 L
.34865 .40637 L
.34965 .39086 L
.35065 .38124 L
.35165 .37109 L
.35265 .36136 L
.35365 .35247 L
.35465 .34464 L
.35564 .33798 L
.35664 .33249 L
.35764 .3281 L
.35864 .32471 L
.35964 .32221 L
.36064 .32047 L
.36164 .31936 L
.36264 .31877 L
.36364 .3186 L
.36464 .31875 L
.36563 .31914 L
.36663 .31973 L
.36763 .32045 L
.36863 .32126 L
.36963 .32213 L
.37063 .32302 L
.37163 .32393 L
.37263 .32482 L
.37363 .3257 L
.37463 .32655 L
.37562 .32738 L
.37662 .32817 L
.37762 .32892 L
.37862 .32965 L
.37962 .33035 L
.38062 .33102 L
.38162 .33167 L
.38262 .3323 L
.38362 .33292 L
.38462 .33354 L
.38561 .33415 L
.38661 .33476 L
.38761 .33537 L
.38861 .33599 L
.38961 .33662 L
.39061 .33727 L
Mistroke
.39161 .33793 L
.39261 .33862 L
.39361 .33933 L
.39461 .34007 L
.3956 .34083 L
.3966 .34163 L
.3976 .34247 L
.3986 .34334 L
.3996 .26654 L
.4006 .26598 L
.4016 .26415 L
.4026 .26176 L
.4036 .259 L
.4046 .25592 L
.40559 .25255 L
.40659 .24891 L
.40759 .245 L
.40859 .24083 L
.40959 .2364 L
.41059 .23173 L
.41159 .22685 L
.41259 .2218 L
.41359 .21665 L
.41459 .21151 L
.41558 .20653 L
.41658 .20199 L
.41758 .19829 L
.41858 .19604 L
.41958 .19613 L
.42058 .19964 L
.42158 .20746 L
.42258 .21975 L
.42358 .23576 L
.42458 .25417 L
.42557 .27353 L
.42657 .29251 L
.42757 .31004 L
.42857 .32538 L
.42957 .33809 L
.43057 .34809 L
.43157 .35551 L
.43257 .36062 L
.43357 .36379 L
.43457 .36541 L
.43556 .3658 L
.43656 .36529 L
.43756 .36412 L
.43856 .36251 L
.43956 .36061 L
.44056 .35856 L
Mistroke
.44156 .35646 L
.44256 .35439 L
.44356 .35242 L
.44456 .35058 L
.44555 .34892 L
.44655 .34743 L
.44755 .34613 L
.44855 .34501 L
.44955 .38172 L
.45055 .38344 L
.45155 .38362 L
.45255 .38303 L
.45355 .38198 L
.45455 .38061 L
.45554 .37905 L
.45654 .37737 L
.45754 .37565 L
.45854 .37392 L
.45954 .37223 L
.46054 .37061 L
.46154 .36909 L
.46254 .36768 L
.46354 .3664 L
.46454 .36525 L
.46553 .36424 L
.46653 .36336 L
.46753 .36262 L
.46853 .362 L
.46953 .36151 L
.47053 .36115 L
.47153 .36089 L
.47253 .36075 L
.47353 .36071 L
.47453 .36077 L
.47552 .36093 L
.47652 .36118 L
.47752 .36151 L
.47852 .36194 L
.47952 .36245 L
.48052 .36304 L
.48152 .36372 L
.48252 .36447 L
.48352 .36531 L
.48452 .36623 L
.48551 .36723 L
.48651 .36831 L
.48751 .36948 L
.48851 .37072 L
.48951 .37206 L
.49051 .37348 L
Mistroke
.49151 .37498 L
.49251 .37657 L
.49351 .37826 L
.49451 .38003 L
.4955 .38189 L
.4965 .38385 L
.4975 .38589 L
.4985 .38803 L
.4995 .40178 L
.5005 .38841 L
.5015 .37451 L
.5025 .36128 L
.5035 .34933 L
.5045 .33899 L
.50549 .3304 L
.50649 .32354 L
.50749 .3183 L
.50849 .31449 L
.50949 .3119 L
.51049 .31034 L
.51149 .30959 L
.51249 .3095 L
.51349 .30991 L
.51449 .31069 L
.51548 .31175 L
.51648 .31298 L
.51748 .31434 L
.51848 .31576 L
.51948 .3172 L
.52048 .31863 L
.52148 .32002 L
.52248 .32136 L
.52348 .32262 L
.52448 .32382 L
.52547 .32494 L
.52647 .32599 L
.52747 .32697 L
.52847 .32789 L
.52947 .32874 L
.53047 .32955 L
.53147 .33032 L
.53247 .33105 L
.53347 .33176 L
.53447 .33244 L
.53546 .33312 L
.53646 .33379 L
.53746 .33445 L
.53846 .33513 L
.53946 .33581 L
.54046 .33651 L
Mistroke
.54146 .33723 L
.54246 .33798 L
.54346 .33875 L
.54446 .33955 L
.54545 .34039 L
.54645 .34127 L
.54745 .34219 L
.54845 .34315 L
.54945 .39468 L
.55045 .40265 L
.55145 .41045 L
.55245 .41866 L
.55345 .42735 L
.55445 .43645 L
.55544 .44584 L
.55644 .45535 L
.55744 .46476 L
.55844 .47379 L
.55944 .48212 L
.56044 .48938 L
.56144 .49517 L
.56244 .49911 L
.56344 .50089 L
.56444 .50037 L
.56543 .49763 L
.56643 .493 L
.56743 .48694 L
.56843 .47978 L
.56943 .4716 L
.57043 .4623 L
.57143 .45178 L
.57243 .44012 L
.57343 .42754 L
.57443 .41443 L
.57542 .40126 L
.57642 .38851 L
.57742 .37657 L
.57842 .36576 L
.57942 .35626 L
.58042 .34814 L
.58142 .34138 L
.58242 .3359 L
.58342 .33157 L
.58442 .32825 L
.58541 .32581 L
.58641 .32409 L
.58741 .323 L
.58841 .3224 L
.58941 .32221 L
.59041 .32234 L
Mistroke
.59141 .32271 L
.59241 .32326 L
.59341 .32394 L
.59441 .32471 L
.5954 .32552 L
.5964 .32635 L
.5974 .32718 L
.5984 .328 L
.5994 .24932 L
.6004 .25389 L
.6014 .25716 L
.6024 .25985 L
.6034 .26217 L
.6044 .26425 L
.60539 .26615 L
.60639 .26791 L
.60739 .26957 L
.60839 .27115 L
.60939 .27265 L
.61039 .27409 L
.61139 .27548 L
.61239 .27683 L
.61339 .27813 L
.61439 .2794 L
.61538 .28064 L
.61638 .28186 L
.61738 .28305 L
.61838 .28422 L
.61938 .28537 L
.62038 .28651 L
.62138 .28765 L
.62238 .28877 L
.62338 .28989 L
.62438 .291 L
.62537 .29211 L
.62637 .29322 L
.62737 .29432 L
.62837 .29542 L
.62937 .29652 L
.63037 .29761 L
.63137 .29869 L
.63237 .29976 L
.63337 .30082 L
.63437 .30186 L
.63536 .30289 L
.63636 .3039 L
.63736 .30489 L
.63836 .30586 L
.63936 .30681 L
.64036 .30773 L
Mistroke
.64136 .30863 L
.64236 .3095 L
.64336 .31034 L
.64436 .31117 L
.64535 .31196 L
.64635 .31273 L
.64735 .31347 L
.64835 .31419 L
.64935 .27293 L
.65035 .27646 L
.65135 .27872 L
.65235 .2804 L
.65335 .28174 L
.65435 .28284 L
.65534 .28375 L
.65634 .28452 L
.65734 .28518 L
.65834 .28573 L
.65934 .28619 L
.66034 .28658 L
.66134 .28689 L
.66234 .28713 L
.66334 .2873 L
.66434 .28742 L
.66533 .28746 L
.66633 .28745 L
.66733 .28738 L
.66833 .28724 L
.66933 .28704 L
.67033 .28678 L
.67133 .28647 L
.67233 .28611 L
.67333 .28569 L
.67433 .28524 L
.67532 .28476 L
.67632 .28426 L
.67732 .28377 L
.67832 .28331 L
.67932 .28289 L
.68032 .28256 L
.68132 .28235 L
.68232 .28228 L
.68332 .28241 L
.68432 .28275 L
.68531 .28334 L
.68631 .28421 L
.68731 .28535 L
.68831 .28678 L
.68931 .28847 L
.69031 .29039 L
Mistroke
.69131 .29253 L
.69231 .29482 L
.69331 .29723 L
.69431 .29972 L
.6953 .30222 L
.6963 .30472 L
.6973 .30716 L
.6983 .30952 L
.6993 .30465 L
.7003 .31342 L
.7013 .31997 L
.7023 .32508 L
.7033 .32909 L
.7043 .33222 L
.70529 .33466 L
.70629 .33656 L
.70729 .33803 L
.70829 .33918 L
.70929 .34009 L
.71029 .34083 L
.71129 .34143 L
.71229 .34196 L
.71329 .34244 L
.71429 .34289 L
.71528 .34334 L
.71628 .34381 L
.71728 .34429 L
.71828 .34481 L
.71928 .34537 L
.72028 .34597 L
.72128 .34663 L
.72228 .34734 L
.72328 .3481 L
.72428 .34893 L
.72527 .34983 L
.72627 .35079 L
.72727 .35182 L
.72827 .35292 L
.72927 .3541 L
.73027 .35537 L
.73127 .35672 L
.73227 .35815 L
.73327 .35969 L
.73427 .36132 L
.73526 .36306 L
.73626 .3649 L
.73726 .36686 L
.73826 .36895 L
.73926 .37116 L
.74026 .3735 L
Mistroke
.74126 .37599 L
.74226 .37862 L
.74326 .3814 L
.74426 .38435 L
.74525 .38746 L
.74625 .39074 L
.74725 .3942 L
.74825 .39784 L
.74925 .14514 L
.75025 .13996 L
.75125 .13371 L
.75225 .12796 L
.75325 .12377 L
.75425 .12212 L
.75524 .12397 L
.75624 .13021 L
.75724 .14163 L
.75824 .15871 L
.75924 .18145 L
.76024 .20908 L
.76124 .24001 L
.76224 .27204 L
.76324 .30279 L
.76424 .33025 L
.76523 .35312 L
.76623 .37082 L
.76723 .38345 L
.76823 .39151 L
.76923 .3957 L
.77023 .39678 L
.77123 .39546 L
.77223 .39239 L
.77323 .38813 L
.77423 .38316 L
.77522 .3779 L
.77622 .37264 L
.77722 .36762 L
.77822 .36297 L
.77922 .35874 L
.78022 .35495 L
.78122 .35159 L
.78222 .34864 L
.78322 .34607 L
.78422 .34385 L
.78521 .34195 L
.78621 .34035 L
.78721 .33902 L
.78821 .33793 L
.78921 .33706 L
.79021 .33639 L
Mistroke
.79121 .33589 L
.79221 .33554 L
.79321 .33532 L
.79421 .33523 L
.7952 .33523 L
.7962 .33531 L
.7972 .33548 L
.7982 .3357 L
.7992 .41841 L
.8002 .41944 L
.8012 .4188 L
.8022 .41719 L
.8032 .41481 L
.8042 .41181 L
.80519 .40831 L
.80619 .40442 L
.80719 .40027 L
.80819 .39598 L
.80919 .39166 L
.81019 .3874 L
.81119 .38329 L
.81219 .37941 L
.81319 .37579 L
.81419 .37248 L
.81518 .36949 L
.81618 .36683 L
.81718 .36448 L
.81818 .36244 L
.81918 .36068 L
.82018 .35919 L
.82118 .35795 L
.82218 .35694 L
.82318 .35612 L
.82418 .3555 L
.82517 .35504 L
.82617 .35474 L
.82717 .35457 L
.82817 .35454 L
.82917 .35462 L
.83017 .35482 L
.83117 .35512 L
.83217 .35552 L
.83317 .35601 L
.83417 .3566 L
.83516 .35728 L
.83616 .35805 L
.83716 .3589 L
.83816 .35985 L
.83916 .36088 L
.84016 .36201 L
Mistroke
.84116 .36323 L
.84216 .36455 L
.84316 .36596 L
.84416 .36748 L
.84515 .36909 L
.84615 .37082 L
.84715 .37266 L
.84815 .37461 L
.84915 .43301 L
.85015 .43068 L
.85115 .42621 L
.85215 .42041 L
.85315 .41366 L
.85415 .40628 L
.85514 .39859 L
.85614 .39085 L
.85714 .38331 L
.85814 .37618 L
.85914 .3696 L
.86014 .36367 L
.86114 .35845 L
.86214 .35393 L
.86314 .3501 L
.86414 .3469 L
.86513 .34427 L
.86613 .34216 L
.86713 .34048 L
.86813 .33919 L
.86913 .33822 L
.87013 .33753 L
.87113 .33706 L
.87213 .33679 L
.87313 .33667 L
.87413 .33669 L
.87512 .33682 L
.87612 .33704 L
.87712 .33734 L
.87812 .33772 L
.87912 .33816 L
.88012 .33865 L
.88112 .3392 L
.88212 .33981 L
.88312 .34046 L
.88412 .34116 L
.88511 .34191 L
.88611 .34271 L
.88711 .34357 L
.88811 .34448 L
.88911 .34546 L
.89011 .34649 L
Mistroke
.89111 .3476 L
.89211 .34877 L
.89311 .35002 L
.89411 .35135 L
.8951 .35276 L
.8961 .35427 L
.8971 .35587 L
.8981 .35757 L
.8991 .43119 L
.9001 .44215 L
.9011 .45222 L
.9021 .46189 L
.9031 .47105 L
.9041 .47944 L
.90509 .48668 L
.90609 .49237 L
.90709 .49609 L
.90809 .49744 L
.90909 .49615 L
.91009 .49208 L
.91109 .48534 L
.91209 .47623 L
.91309 .46521 L
.91409 .45277 L
.91508 .43939 L
.91608 .42549 L
.91708 .4115 L
.91808 .39782 L
.91908 .38484 L
.92008 .37287 L
.92108 .36215 L
.92208 .35281 L
.92308 .34489 L
.92408 .33834 L
.92507 .33307 L
.92607 .32894 L
.92707 .32581 L
.92807 .32352 L
.92907 .32195 L
.93007 .32096 L
.93107 .32045 L
.93207 .32033 L
.93307 .32051 L
.93407 .32092 L
.93506 .3215 L
.93606 .32221 L
.93706 .32301 L
.93806 .32385 L
.93906 .32472 L
.94006 .32559 L
Mistroke
.94106 .32646 L
.94206 .32731 L
.94306 .32814 L
.94406 .32896 L
.94505 .32976 L
.94605 .33054 L
.94705 .33131 L
.94805 .33208 L
.94905 .27248 L
.95005 .27506 L
.95105 .27631 L
.95205 .27699 L
.95305 .27731 L
.95405 .27738 L
.95504 .27727 L
.95604 .27699 L
.95704 .27659 L
.95804 .27606 L
.95904 .27542 L
.96004 .27467 L
.96104 .27382 L
.96204 .27286 L
.96304 .27179 L
.96404 .27062 L
.96503 .26935 L
.96603 .26796 L
.96703 .26648 L
.96803 .2649 L
.96903 .26324 L
.97003 .26153 L
.97103 .25981 L
.97203 .25813 L
.97303 .25657 L
.97403 .25524 L
.97502 .25425 L
.97602 .25377 L
.97702 .25395 L
.97802 .25497 L
.97902 .25693 L
.98002 .25989 L
.98102 .26381 L
.98202 .26855 L
.98302 .27393 L
.98402 .27973 L
.98501 .28572 L
.98601 .29169 L
.98701 .29748 L
.98801 .30293 L
.98901 .30796 L
.99001 .31248 L
Mistroke
.99101 .31648 L
.99201 .31996 L
.99301 .32292 L
.99401 .32542 L
.995 .32749 L
.996 .3292 L
.997 .33059 L
.998 .33172 L
.999 .31517 L
Mfstroke
1 0 0 r
gsave
.999 .30907 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30145 L
.00799 .30034 L
.00899 .29914 L
.00999 .29783 L
.01099 .29637 L
.01199 .29475 L
.01299 .29295 L
.01399 .29095 L
.01499 .28872 L
.01598 .28625 L
.01698 .2835 L
.01798 .28047 L
.01898 .27713 L
.01998 .27348 L
.02098 .26952 L
.02198 .26527 L
.02298 .26079 L
.02398 .25616 L
.02498 .25151 L
.02597 .24706 L
.02697 .24311 L
.02797 .24007 L
.02897 .23851 L
.02997 .23912 L
.03097 .24276 L
.03197 .25036 L
.03297 .26285 L
.03397 .28097 L
.03497 .30504 L
.03596 .33464 L
.03696 .36838 L
.03796 .40385 L
.03896 .43777 L
.03996 .4665 L
.04096 .48675 L
.04196 .49624 L
.04296 .49416 L
.04396 .48133 L
.04496 .45995 L
.04595 .43319 L
.04695 .40456 L
.04795 .3773 L
.04895 .35374 L
Mistroke
.04995 .03474 L
.05095 .06953 L
.05195 .11775 L
.05295 .17756 L
.05395 .24436 L
.05495 .3116 L
.05594 .37243 L
.05694 .42159 L
.05794 .4564 L
.05894 .47657 L
.05994 .48329 L
.06094 .47825 L
.06194 .46319 L
.06294 .43985 L
.06394 .41017 L
.06494 .37646 L
.06593 .34135 L
.06693 .30761 L
.06793 .27773 L
.06893 .25368 L
.06993 .23665 L
.07093 .22713 L
.07193 .22491 L
.07293 .22933 L
.07393 .23934 L
.07493 .25359 L
.07592 .27056 L
.07692 .28866 L
.07792 .3063 L
.07892 .32211 L
.07992 .33497 L
.08092 .34415 L
.08192 .34928 L
.08292 .35038 L
.08392 .34782 L
.08492 .3422 L
.08591 .33436 L
.08691 .32524 L
.08791 .31579 L
.08891 .30691 L
.08991 .29934 L
.09091 .29363 L
.09191 .29012 L
.09291 .28888 L
.09391 .28976 L
.09491 .29244 L
.0959 .29642 L
.0969 .30116 L
.0979 .30607 L
.0989 .3106 L
Mistroke
.0999 .32838 L
.1009 .32846 L
.1019 .32857 L
.1029 .3287 L
.1039 .32885 L
.1049 .32902 L
.10589 .32921 L
.10689 .32943 L
.10789 .32967 L
.10889 .32994 L
.10989 .33023 L
.11089 .33054 L
.11189 .33088 L
.11289 .33124 L
.11389 .33163 L
.11489 .33205 L
.11588 .33248 L
.11688 .33295 L
.11788 .33344 L
.11888 .33395 L
.11988 .33449 L
.12088 .33505 L
.12188 .33563 L
.12288 .33623 L
.12388 .33686 L
.12488 .3375 L
.12587 .33815 L
.12687 .33883 L
.12787 .33951 L
.12887 .3402 L
.12987 .3409 L
.13087 .34159 L
.13187 .34229 L
.13287 .34297 L
.13387 .34365 L
.13487 .3443 L
.13586 .34494 L
.13686 .34554 L
.13786 .3461 L
.13886 .34662 L
.13986 .34709 L
.14086 .3475 L
.14186 .34785 L
.14286 .34813 L
.14386 .34832 L
.14486 .34844 L
.14585 .34847 L
.14685 .3484 L
.14785 .34825 L
.14885 .348 L
Mistroke
.14985 .36944 L
.15085 .34517 L
.15185 .32332 L
.15285 .30474 L
.15385 .28978 L
.15485 .27843 L
.15584 .2704 L
.15684 .26526 L
.15784 .26255 L
.15884 .26181 L
.15984 .26261 L
.16084 .2646 L
.16184 .26746 L
.16284 .27091 L
.16384 .27472 L
.16484 .27871 L
.16583 .28271 L
.16683 .2866 L
.16783 .29028 L
.16883 .29368 L
.16983 .29677 L
.17083 .2995 L
.17183 .30189 L
.17283 .30394 L
.17383 .30565 L
.17483 .30707 L
.17582 .30822 L
.17682 .30912 L
.17782 .30981 L
.17882 .31033 L
.17982 .31069 L
.18082 .31093 L
.18182 .31107 L
.18282 .31113 L
.18382 .31113 L
.18482 .31108 L
.18581 .311 L
.18681 .31089 L
.18781 .31077 L
.18881 .31065 L
.18981 .31052 L
.19081 .31039 L
.19181 .31027 L
.19281 .31016 L
.19381 .31005 L
.19481 .30995 L
.1958 .30986 L
.1968 .30978 L
.1978 .30971 L
.1988 .30965 L
Mistroke
.1998 .17093 L
.2008 .16754 L
.2018 .16397 L
.2028 .16072 L
.2038 .15824 L
.2048 .15698 L
.20579 .15731 L
.20679 .15956 L
.20779 .16395 L
.20879 .1706 L
.20979 .17947 L
.21079 .19037 L
.21179 .20295 L
.21279 .21673 L
.21379 .23113 L
.21479 .24557 L
.21578 .25948 L
.21678 .27241 L
.21778 .28402 L
.21878 .2941 L
.21978 .30258 L
.22078 .30949 L
.22178 .31493 L
.22278 .31904 L
.22378 .322 L
.22478 .32399 L
.22577 .32517 L
.22677 .32571 L
.22777 .32574 L
.22877 .32539 L
.22977 .32475 L
.23077 .32393 L
.23177 .32298 L
.23277 .32196 L
.23377 .32093 L
.23477 .3199 L
.23576 .31892 L
.23676 .31799 L
.23776 .31713 L
.23876 .31634 L
.23976 .31562 L
.24076 .31498 L
.24176 .31442 L
.24276 .31392 L
.24376 .31348 L
.24476 .3131 L
.24575 .31277 L
.24675 .31249 L
.24775 .31225 L
.24875 .31204 L
Mistroke
.24975 .39071 L
.25075 .39011 L
.25175 .38933 L
.25275 .38833 L
.25375 .38711 L
.25475 .38567 L
.25574 .38399 L
.25674 .38211 L
.25774 .38003 L
.25874 .37778 L
.25974 .37538 L
.26074 .37286 L
.26174 .37026 L
.26274 .3676 L
.26374 .36492 L
.26474 .36224 L
.26573 .35959 L
.26673 .357 L
.26773 .35449 L
.26873 .35208 L
.26973 .34978 L
.27073 .3476 L
.27173 .34556 L
.27273 .34364 L
.27373 .34186 L
.27473 .34022 L
.27572 .33871 L
.27672 .33732 L
.27772 .33606 L
.27872 .33491 L
.27972 .33387 L
.28072 .33293 L
.28172 .33209 L
.28272 .33133 L
.28372 .33066 L
.28472 .33006 L
.28571 .32953 L
.28671 .32906 L
.28771 .32865 L
.28871 .3283 L
.28971 .32799 L
.29071 .32773 L
.29171 .32751 L
.29271 .32733 L
.29371 .32718 L
.29471 .32707 L
.2957 .32699 L
.2967 .32694 L
.2977 .32691 L
.2987 .32691 L
Mistroke
.2997 .35071 L
.3007 .35028 L
.3017 .34989 L
.3027 .34954 L
.3037 .34922 L
.3047 .34895 L
.30569 .34871 L
.30669 .34851 L
.30769 .34834 L
.30869 .3482 L
.30969 .3481 L
.31069 .34803 L
.31169 .34798 L
.31269 .34797 L
.31369 .34798 L
.31469 .34801 L
.31568 .34807 L
.31668 .34815 L
.31768 .34825 L
.31868 .34836 L
.31968 .3485 L
.32068 .34865 L
.32168 .34881 L
.32268 .34899 L
.32368 .34918 L
.32468 .34938 L
.32567 .34958 L
.32667 .3498 L
.32767 .35002 L
.32867 .35024 L
.32967 .35046 L
.33067 .35069 L
.33167 .35092 L
.33267 .35114 L
.33367 .35136 L
.33467 .35157 L
.33566 .35178 L
.33666 .35198 L
.33766 .35217 L
.33866 .35235 L
.33966 .35252 L
.34066 .35268 L
.34166 .35283 L
.34266 .35296 L
.34366 .35308 L
.34466 .35319 L
.34565 .35328 L
.34665 .35336 L
.34765 .35343 L
.34865 .35348 L
Mistroke
.34965 .38477 L
.35065 .37098 L
.35165 .35778 L
.35265 .34556 L
.35365 .33463 L
.35465 .32513 L
.35564 .31713 L
.35664 .31059 L
.35764 .3054 L
.35864 .30142 L
.35964 .29849 L
.36064 .29645 L
.36164 .29514 L
.36264 .29441 L
.36364 .29415 L
.36464 .29424 L
.36563 .29459 L
.36663 .29513 L
.36763 .29579 L
.36863 .29652 L
.36963 .29729 L
.37063 .29806 L
.37163 .29882 L
.37263 .29954 L
.37363 .30022 L
.37463 .30086 L
.37562 .30143 L
.37662 .30196 L
.37762 .30243 L
.37862 .30285 L
.37962 .30323 L
.38062 .30356 L
.38162 .30385 L
.38262 .3041 L
.38362 .30431 L
.38462 .3045 L
.38561 .30466 L
.38661 .3048 L
.38761 .30491 L
.38861 .305 L
.38961 .30508 L
.39061 .30514 L
.39161 .30518 L
.39261 .30522 L
.39361 .30524 L
.39461 .30525 L
.3956 .30525 L
.3966 .30524 L
.3976 .30522 L
.3986 .3052 L
Mistroke
.3996 .26047 L
.4006 .25582 L
.4016 .25101 L
.4026 .24599 L
.4036 .2407 L
.4046 .23512 L
.40559 .22923 L
.40659 .22305 L
.40759 .21658 L
.40859 .20986 L
.40959 .20295 L
.41059 .19594 L
.41159 .18894 L
.41259 .18212 L
.41359 .17565 L
.41459 .16977 L
.41558 .16473 L
.41658 .16084 L
.41758 .15839 L
.41858 .15766 L
.41958 .15892 L
.42058 .16234 L
.42158 .16799 L
.42258 .17583 L
.42358 .18566 L
.42458 .19714 L
.42557 .20985 L
.42657 .22327 L
.42757 .2369 L
.42857 .25024 L
.42957 .26288 L
.43057 .27449 L
.43157 .28486 L
.43257 .29384 L
.43357 .30142 L
.43457 .30763 L
.43556 .31255 L
.43656 .31631 L
.43756 .31905 L
.43856 .32094 L
.43956 .32211 L
.44056 .3227 L
.44156 .32285 L
.44256 .32265 L
.44356 .32221 L
.44456 .32159 L
.44555 .32088 L
.44655 .3201 L
.44755 .31931 L
.44855 .31853 L
Mistroke
.44955 .37564 L
.45055 .37337 L
.45155 .37078 L
.45255 .36799 L
.45355 .36509 L
.45455 .36213 L
.45554 .35918 L
.45654 .35628 L
.45754 .35347 L
.45854 .35078 L
.45954 .34824 L
.46054 .34585 L
.46154 .34362 L
.46254 .34157 L
.46354 .33969 L
.46454 .33798 L
.46553 .33644 L
.46653 .33505 L
.46753 .3338 L
.46853 .3327 L
.46953 .33172 L
.47053 .33086 L
.47153 .3301 L
.47253 .32945 L
.47353 .32888 L
.47453 .3284 L
.47552 .32799 L
.47652 .32765 L
.47752 .32737 L
.47852 .32714 L
.47952 .32697 L
.48052 .32685 L
.48152 .32677 L
.48252 .32674 L
.48352 .32674 L
.48452 .32678 L
.48551 .32686 L
.48651 .32697 L
.48751 .32711 L
.48851 .32728 L
.48951 .32748 L
.49051 .32771 L
.49151 .32797 L
.49251 .32825 L
.49351 .32857 L
.49451 .3289 L
.4955 .32926 L
.4965 .32964 L
.4975 .33005 L
.4985 .33047 L
Mistroke
.4995 .39569 L
.5005 .37815 L
.5015 .36115 L
.5025 .34537 L
.5035 .33131 L
.5045 .31926 L
.50549 .30931 L
.50649 .3014 L
.50749 .29536 L
.50849 .29098 L
.50949 .288 L
.51049 .28617 L
.51149 .28527 L
.51249 .2851 L
.51349 .28546 L
.51449 .28623 L
.51548 .28727 L
.51648 .28849 L
.51748 .28981 L
.51848 .29116 L
.51948 .29251 L
.52048 .2938 L
.52148 .29503 L
.52248 .29617 L
.52348 .29722 L
.52448 .29817 L
.52547 .29903 L
.52647 .29979 L
.52747 .30046 L
.52847 .30105 L
.52947 .30156 L
.53047 .302 L
.53147 .30238 L
.53247 .30271 L
.53347 .30298 L
.53447 .30321 L
.53546 .3034 L
.53646 .30356 L
.53746 .30369 L
.53846 .30379 L
.53946 .30386 L
.54046 .30392 L
.54146 .30395 L
.54246 .30397 L
.54346 .30397 L
.54446 .30396 L
.54545 .30394 L
.54645 .3039 L
.54745 .30384 L
.54845 .30378 L
Mistroke
.54945 .38861 L
.55045 .3925 L
.55145 .39734 L
.55245 .40293 L
.55345 .40915 L
.55445 .41583 L
.55544 .42286 L
.55644 .43007 L
.55744 .43731 L
.55844 .44436 L
.55944 .45098 L
.56044 .4569 L
.56144 .4618 L
.56244 .46533 L
.56344 .46714 L
.56444 .46691 L
.56543 .46435 L
.56643 .45927 L
.56743 .45165 L
.56843 .44159 L
.56943 .42941 L
.57043 .41556 L
.57143 .40064 L
.57243 .3853 L
.57343 .37018 L
.57443 .35584 L
.57542 .34272 L
.57642 .33112 L
.57742 .32119 L
.57842 .31296 L
.57942 .30636 L
.58042 .30126 L
.58142 .29748 L
.58242 .29482 L
.58342 .29311 L
.58442 .29216 L
.58541 .29182 L
.58641 .29193 L
.58741 .29238 L
.58841 .29306 L
.58941 .2939 L
.59041 .29482 L
.59141 .29578 L
.59241 .29674 L
.59341 .29767 L
.59441 .29854 L
.5954 .29935 L
.5964 .30009 L
.5974 .30076 L
.5984 .30135 L
Mistroke
.5994 .24326 L
.6004 .24382 L
.6014 .24431 L
.6024 .24472 L
.6034 .24508 L
.6044 .2454 L
.60539 .2457 L
.60639 .24599 L
.60739 .24628 L
.60839 .24658 L
.60939 .2469 L
.61039 .24724 L
.61139 .24761 L
.61239 .24801 L
.61339 .24844 L
.61439 .2489 L
.61538 .24939 L
.61638 .24992 L
.61738 .25047 L
.61838 .25105 L
.61938 .25165 L
.62038 .25227 L
.62138 .25291 L
.62238 .25355 L
.62338 .25421 L
.62438 .25487 L
.62537 .25553 L
.62637 .25619 L
.62737 .25684 L
.62837 .25747 L
.62937 .25809 L
.63037 .2587 L
.63137 .25928 L
.63237 .25984 L
.63337 .26037 L
.63437 .26088 L
.63536 .26136 L
.63636 .26181 L
.63736 .26223 L
.63836 .26262 L
.63936 .26298 L
.64036 .26331 L
.64136 .26362 L
.64236 .26389 L
.64336 .26413 L
.64436 .26435 L
.64535 .26454 L
.64635 .26471 L
.64735 .26485 L
.64835 .26497 L
Mistroke
.64935 .26683 L
.65035 .26635 L
.65135 .2658 L
.65235 .26518 L
.65335 .2645 L
.65435 .26375 L
.65534 .26294 L
.65634 .26208 L
.65734 .26117 L
.65834 .2602 L
.65934 .2592 L
.66034 .25815 L
.66134 .25707 L
.66234 .25595 L
.66334 .25481 L
.66434 .25365 L
.66533 .25248 L
.66633 .25129 L
.66733 .25011 L
.66833 .24894 L
.66933 .24779 L
.67033 .24667 L
.67133 .24558 L
.67233 .24454 L
.67333 .24356 L
.67433 .24265 L
.67532 .24181 L
.67632 .24107 L
.67732 .24042 L
.67832 .23988 L
.67932 .23945 L
.68032 .23913 L
.68132 .23894 L
.68232 .23887 L
.68332 .23892 L
.68432 .23909 L
.68531 .23937 L
.68631 .23977 L
.68731 .24028 L
.68831 .24088 L
.68931 .24157 L
.69031 .24235 L
.69131 .24319 L
.69231 .24411 L
.69331 .24508 L
.69431 .24611 L
.6953 .24718 L
.6963 .2483 L
.6973 .24945 L
.6983 .25063 L
Mistroke
.6993 .29853 L
.7003 .3033 L
.7013 .30707 L
.7023 .30998 L
.7033 .31218 L
.7043 .31379 L
.70529 .31494 L
.70629 .31572 L
.70729 .31622 L
.70829 .3165 L
.70929 .31663 L
.71029 .31664 L
.71129 .31658 L
.71229 .31646 L
.71329 .31631 L
.71429 .31615 L
.71528 .31599 L
.71628 .31583 L
.71728 .31568 L
.71828 .31555 L
.71928 .31543 L
.72028 .31533 L
.72128 .31524 L
.72228 .31518 L
.72328 .31513 L
.72428 .3151 L
.72527 .31509 L
.72627 .3151 L
.72727 .31512 L
.72827 .31515 L
.72927 .3152 L
.73027 .31527 L
.73127 .31534 L
.73227 .31543 L
.73327 .31554 L
.73427 .31566 L
.73526 .31579 L
.73626 .31593 L
.73726 .31608 L
.73826 .31625 L
.73926 .31643 L
.74026 .31662 L
.74126 .31682 L
.74226 .31703 L
.74326 .31725 L
.74426 .31748 L
.74525 .31772 L
.74625 .31796 L
.74725 .31821 L
.74825 .31847 L
Mistroke
.74925 .13905 L
.75025 .12974 L
.75125 .12045 L
.75225 .11206 L
.75325 .10549 L
.75425 .10174 L
.75524 .10179 L
.75624 .10655 L
.75724 .11665 L
.75824 .13237 L
.75924 .15342 L
.76024 .17887 L
.76124 .20725 L
.76224 .23668 L
.76324 .26524 L
.76424 .29124 L
.76523 .31351 L
.76623 .33144 L
.76723 .34498 L
.76823 .35443 L
.76923 .36031 L
.77023 .36324 L
.77123 .3638 L
.77223 .36253 L
.77323 .35989 L
.77423 .3563 L
.77522 .35208 L
.77622 .34752 L
.77722 .34285 L
.77822 .33825 L
.77922 .33386 L
.78022 .32979 L
.78122 .32609 L
.78222 .3228 L
.78322 .31993 L
.78422 .31747 L
.78521 .3154 L
.78621 .31369 L
.78721 .31229 L
.78821 .31118 L
.78921 .31031 L
.79021 .30964 L
.79121 .30914 L
.79221 .30878 L
.79321 .30853 L
.79421 .30836 L
.7952 .30827 L
.7962 .30823 L
.7972 .30822 L
.7982 .30824 L
Mistroke
.7992 .41235 L
.8002 .40933 L
.8012 .40584 L
.8022 .4019 L
.8032 .39754 L
.8042 .39282 L
.80519 .38782 L
.80619 .38263 L
.80719 .37736 L
.80819 .37209 L
.80919 .36693 L
.81019 .36195 L
.81119 .35721 L
.81219 .35277 L
.81319 .34867 L
.81419 .34492 L
.81518 .34154 L
.81618 .33851 L
.81718 .33582 L
.81818 .33346 L
.81918 .3314 L
.82018 .32961 L
.82118 .32807 L
.82218 .32675 L
.82318 .32563 L
.82418 .32467 L
.82517 .32387 L
.82617 .3232 L
.82717 .32263 L
.82817 .32217 L
.82917 .32179 L
.83017 .32149 L
.83117 .32125 L
.83217 .32106 L
.83317 .32093 L
.83417 .32084 L
.83516 .32079 L
.83616 .32077 L
.83716 .32079 L
.83816 .32084 L
.83916 .32092 L
.84016 .32103 L
.84116 .32116 L
.84216 .32131 L
.84316 .3215 L
.84416 .3217 L
.84515 .32193 L
.84615 .32218 L
.84715 .32245 L
.84815 .32275 L
Mistroke
.84915 .42693 L
.85015 .42052 L
.85115 .41313 L
.85215 .40494 L
.85315 .39615 L
.85415 .38704 L
.85514 .37786 L
.85614 .36887 L
.85714 .36028 L
.85814 .35229 L
.85914 .345 L
.86014 .33849 L
.86114 .33279 L
.86214 .32788 L
.86314 .32373 L
.86414 .32028 L
.86513 .31744 L
.86613 .31514 L
.86713 .31331 L
.86813 .31188 L
.86913 .31077 L
.87013 .30992 L
.87113 .30929 L
.87213 .30883 L
.87313 .30851 L
.87413 .30829 L
.87512 .30814 L
.87612 .30806 L
.87712 .30802 L
.87812 .30801 L
.87912 .30803 L
.88012 .30806 L
.88112 .30809 L
.88212 .30814 L
.88312 .30818 L
.88412 .30822 L
.88511 .30827 L
.88611 .30831 L
.88711 .30835 L
.88811 .30839 L
.88911 .30842 L
.89011 .30845 L
.89111 .30848 L
.89211 .30851 L
.89311 .30854 L
.89411 .30856 L
.8951 .30859 L
.8961 .30861 L
.8971 .30863 L
.8981 .30866 L
Mistroke
.8991 .42511 L
.9001 .43197 L
.9011 .43908 L
.9021 .44618 L
.9031 .45299 L
.9041 .45922 L
.90509 .46452 L
.90609 .46852 L
.90709 .47085 L
.90809 .47112 L
.90909 .46901 L
.91009 .46429 L
.91109 .45684 L
.91209 .44676 L
.91309 .4343 L
.91409 .41994 L
.91508 .40431 L
.91608 .38811 L
.91708 .37207 L
.91808 .35685 L
.91908 .34294 L
.92008 .33071 L
.92108 .32031 L
.92208 .31177 L
.92308 .305 L
.92408 .29983 L
.92507 .29606 L
.92607 .29346 L
.92707 .29182 L
.92807 .29095 L
.92907 .29067 L
.93007 .29084 L
.93107 .29134 L
.93207 .29205 L
.93307 .2929 L
.93407 .29382 L
.93506 .29477 L
.93606 .2957 L
.93706 .2966 L
.93806 .29744 L
.93906 .29822 L
.94006 .29892 L
.94106 .29956 L
.94206 .30012 L
.94306 .30061 L
.94406 .30103 L
.94505 .3014 L
.94605 .30171 L
.94705 .30197 L
.94805 .30218 L
Mistroke
.94905 .26642 L
.95005 .26496 L
.95105 .26339 L
.95205 .26169 L
.95305 .25988 L
.95405 .25796 L
.95504 .25593 L
.95604 .25379 L
.95704 .25156 L
.95804 .24923 L
.95904 .24681 L
.96004 .24432 L
.96104 .24177 L
.96204 .23916 L
.96304 .23653 L
.96404 .23388 L
.96503 .23125 L
.96603 .22867 L
.96703 .22617 L
.96803 .22377 L
.96903 .22154 L
.97003 .21949 L
.97103 .21769 L
.97203 .21617 L
.97303 .21496 L
.97403 .21412 L
.97502 .21367 L
.97602 .21363 L
.97702 .21401 L
.97802 .21483 L
.97902 .21608 L
.98002 .21774 L
.98102 .21979 L
.98202 .22218 L
.98302 .22487 L
.98402 .22783 L
.98501 .231 L
.98601 .23434 L
.98701 .23779 L
.98801 .24131 L
.98901 .24486 L
.99001 .2484 L
.99101 .25191 L
.99201 .25534 L
.99301 .25867 L
.99401 .26188 L
.995 .26494 L
.996 .26785 L
.997 .27058 L
.998 .27313 L
Mistroke
.999 .30907 L
Mfstroke
0 0 0 r
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .28018 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03589 0 m
.03596 .00175 L
.03696 .03774 L
.03796 .08773 L
.03896 .15173 L
.03996 .22729 L
.04096 .30832 L
.04196 .38082 L
.04296 .40797 L
.04396 .37426 L
.04496 .32586 L
.04595 .28375 L
.04695 .25299 L
.04795 .23377 L
.04895 .22413 L
.04995 .40726 L
.05095 .45829 L
.05195 .50635 L
.05295 .54548 L
.05395 .5715 L
.05495 .583 L
.05594 .58196 L
.05694 .57298 L
.05794 .56149 L
.05894 .55189 L
.05994 .54663 L
.06094 .54641 L
.06194 .55063 L
.06294 .55789 L
.06394 .56641 L
.06494 .57442 L
.06593 .58054 L
.06693 .58405 L
.06793 .58492 L
.06893 .58367 L
.06993 .58114 L
.07093 .57818 L
.07193 .5755 L
.07293 .57359 L
.07393 .57263 L
.07493 .57258 L
.07592 .57315 L
.07692 .57394 L
.07792 .57455 L
.07892 .57469 L
.07992 .57419 L
.08092 .57306 L
.08192 .57144 L
.08292 .56956 L
.08392 .56766 L
Mistroke
.08492 .56597 L
.08591 .5646 L
.08691 .56354 L
.08791 .56272 L
.08891 .56196 L
.08991 .56111 L
.09091 .56006 L
.09191 .55875 L
.09291 .55721 L
.09391 .55553 L
.09491 .55381 L
.0959 .55215 L
.0969 .5506 L
.0979 .54916 L
.0989 .54779 L
.0999 .22556 L
.1009 .22009 L
.1019 .21576 L
.1029 .21195 L
.1039 .20845 L
.1049 .20518 L
.10589 .20208 L
.10689 .19912 L
.10789 .19629 L
.10889 .19357 L
.10989 .19094 L
.11089 .1884 L
.11189 .18593 L
.11289 .18355 L
.11389 .18123 L
.11489 .17897 L
.11588 .17677 L
.11688 .17463 L
.11788 .17254 L
.11888 .1705 L
.11988 .1685 L
.12088 .16654 L
.12188 .16461 L
.12288 .16271 L
.12388 .16084 L
.12488 .15899 L
.12587 .15715 L
.12687 .15532 L
.12787 .15349 L
.12887 .15166 L
.12987 .14982 L
.13087 .14796 L
.13187 .14608 L
.13287 .14417 L
.13387 .14223 L
Mistroke
.13487 .14024 L
.13586 .13821 L
.13686 .13614 L
.13786 .13401 L
.13886 .13183 L
.13986 .1296 L
.14086 .12732 L
.14186 .12499 L
.14286 .12262 L
.14386 .12021 L
.14486 .11777 L
.14585 .11531 L
.14685 .11283 L
.14785 .11035 L
.14885 .10787 L
.14985 .39619 L
.15085 .39764 L
.15185 .39594 L
.15285 .39163 L
.15385 .38571 L
.15485 .37907 L
.15584 .37241 L
.15684 .36617 L
.15784 .36054 L
.15884 .35556 L
.15984 .35116 L
.16084 .34722 L
.16184 .34362 L
.16284 .34024 L
.16384 .33697 L
.16484 .33376 L
.16583 .33055 L
.16683 .32731 L
.16783 .32403 L
.16883 .32069 L
.16983 .31732 L
.17083 .3139 L
.17183 .31046 L
.17283 .307 L
.17383 .30353 L
.17483 .30007 L
.17582 .29661 L
.17682 .29318 L
.17782 .28977 L
.17882 .28638 L
.17982 .28303 L
.18082 .2797 L
.18182 .27642 L
.18282 .27317 L
.18382 .26995 L
Mistroke
.18482 .26678 L
.18581 .26364 L
.18681 .26054 L
.18781 .25747 L
.18881 .25444 L
.18981 .25145 L
.19081 .24849 L
.19181 .24557 L
.19281 .24268 L
.19381 .23983 L
.19481 .23702 L
.1958 .23423 L
.1968 .23148 L
.1978 .22876 L
.1988 .22608 L
.1998 .16909 L
.2008 .17309 L
.2018 .18016 L
.2028 .18938 L
.2038 .20031 L
.2048 .21255 L
.20579 .2257 L
.20679 .23933 L
.20779 .25301 L
.20879 .26628 L
.20979 .27873 L
.21079 .28997 L
.21179 .2997 L
.21279 .30771 L
.21379 .31389 L
.21479 .31824 L
.21578 .32087 L
.21678 .32195 L
.21778 .32172 L
.21878 .32042 L
.21978 .3183 L
.22078 .31557 L
.22178 .31241 L
.22278 .30896 L
.22378 .30534 L
.22478 .30162 L
.22577 .29786 L
.22677 .2941 L
.22777 .29036 L
.22877 .28666 L
.22977 .28302 L
.23077 .27943 L
.23177 .2759 L
.23277 .27243 L
.23377 .26901 L
Mistroke
.23477 .26565 L
.23576 .26234 L
.23676 .25908 L
.23776 .25586 L
.23876 .25269 L
.23976 .24955 L
.24076 .24645 L
.24176 .24339 L
.24276 .24036 L
.24376 .23737 L
.24476 .23441 L
.24575 .23148 L
.24675 .22859 L
.24775 .22572 L
.24875 .2229 L
.24975 .23061 L
.25075 .22964 L
.25175 .22993 L
.25275 .23077 L
.25375 .23189 L
.25475 .23313 L
.25574 .23436 L
.25674 .23553 L
.25774 .23655 L
.25874 .23738 L
.25974 .238 L
.26074 .23838 L
.26174 .23852 L
.26274 .23841 L
.26374 .23807 L
.26474 .23751 L
.26573 .23674 L
.26673 .23578 L
.26773 .23465 L
.26873 .23338 L
.26973 .23197 L
.27073 .23044 L
.27173 .22882 L
.27273 .22711 L
.27373 .22533 L
.27473 .22349 L
.27572 .22159 L
.27672 .21965 L
.27772 .21768 L
.27872 .21568 L
.27972 .21365 L
.28072 .21161 L
.28172 .20956 L
.28272 .2075 L
.28372 .20543 L
Mistroke
.28472 .20336 L
.28571 .2013 L
.28671 .19924 L
.28771 .19718 L
.28871 .19514 L
.28971 .19311 L
.29071 .19109 L
.29171 .18908 L
.29271 .18709 L
.29371 .18512 L
.29471 .18316 L
.2957 .18123 L
.2967 .17931 L
.2977 .17742 L
.2987 .17555 L
.2997 .23707 L
.3007 .23232 L
.3017 .22871 L
.3027 .22559 L
.3037 .22276 L
.3047 .22014 L
.30569 .21765 L
.30669 .21528 L
.30769 .21299 L
.30869 .21077 L
.30969 .2086 L
.31069 .20648 L
.31169 .2044 L
.31269 .20235 L
.31369 .20033 L
.31469 .19834 L
.31568 .19637 L
.31668 .19442 L
.31768 .19248 L
.31868 .19056 L
.31968 .18866 L
.32068 .18677 L
.32168 .18489 L
.32268 .18303 L
.32368 .18118 L
.32468 .17934 L
.32567 .17751 L
.32667 .17569 L
.32767 .17388 L
.32867 .17209 L
.32967 .17031 L
.33067 .16854 L
.33167 .16679 L
.33267 .16505 L
.33367 .16332 L
Mistroke
.33467 .16162 L
.33566 .15993 L
.33666 .15826 L
.33766 .15662 L
.33866 .155 L
.33966 .15341 L
.34066 .15185 L
.34166 .15032 L
.34266 .14882 L
.34366 .14737 L
.34466 .14595 L
.34565 .14457 L
.34665 .14324 L
.34765 .14195 L
.34865 .14072 L
.34965 .36085 L
.35065 .36152 L
.35165 .36119 L
.35265 .35951 L
.35365 .35661 L
.35465 .35275 L
.35564 .34822 L
.35664 .34328 L
.35764 .33813 L
.35864 .33294 L
.35964 .32779 L
.36064 .32275 L
.36164 .31785 L
.36264 .3131 L
.36364 .30848 L
.36464 .30399 L
.36563 .29961 L
.36663 .29533 L
.36763 .29115 L
.36863 .28704 L
.36963 .28301 L
.37063 .27905 L
.37163 .27515 L
.37263 .27131 L
.37363 .26752 L
.37463 .26379 L
.37562 .26011 L
.37662 .25649 L
.37762 .25291 L
.37862 .24939 L
.37962 .24591 L
.38062 .24249 L
.38162 .23911 L
.38262 .23578 L
.38362 .2325 L
Mistroke
.38462 .22927 L
.38561 .22609 L
.38661 .22295 L
.38761 .21985 L
.38861 .21681 L
.38961 .21381 L
.39061 .21086 L
.39161 .20795 L
.39261 .20509 L
.39361 .20228 L
.39461 .19951 L
.3956 .19679 L
.3966 .19411 L
.3976 .19148 L
.3986 .1889 L
.3996 .11584 L
.4006 .11236 L
.4016 .1103 L
.4026 .10906 L
.4036 .10848 L
.4046 .1085 L
.40559 .1091 L
.40659 .11028 L
.40759 .11202 L
.40859 .11433 L
.40959 .1172 L
.41059 .12061 L
.41159 .12457 L
.41259 .12909 L
.41359 .13421 L
.41459 .13998 L
.41558 .1465 L
.41658 .15387 L
.41758 .1622 L
.41858 .17161 L
.41958 .18219 L
.42058 .19398 L
.42158 .20692 L
.42258 .22087 L
.42358 .23553 L
.42458 .25045 L
.42557 .26507 L
.42657 .27875 L
.42757 .29085 L
.42857 .30085 L
.42957 .30843 L
.43057 .31354 L
.43157 .31636 L
.43257 .31726 L
.43357 .31665 L
Mistroke
.43457 .31494 L
.43556 .31244 L
.43656 .30938 L
.43756 .30593 L
.43856 .30221 L
.43956 .29829 L
.44056 .29426 L
.44156 .29016 L
.44256 .28604 L
.44356 .28192 L
.44456 .27784 L
.44555 .2738 L
.44655 .26982 L
.44755 .2659 L
.44855 .26205 L
.44955 .30302 L
.45055 .29728 L
.45155 .2931 L
.45255 .28968 L
.45355 .28669 L
.45455 .28392 L
.45554 .28126 L
.45654 .27862 L
.45754 .27594 L
.45854 .27321 L
.45954 .27041 L
.46054 .26752 L
.46154 .26456 L
.46254 .26154 L
.46354 .25846 L
.46454 .25534 L
.46553 .25218 L
.46653 .249 L
.46753 .24581 L
.46853 .24261 L
.46953 .23941 L
.47053 .23623 L
.47153 .23306 L
.47253 .22991 L
.47353 .22679 L
.47453 .2237 L
.47552 .22063 L
.47652 .2176 L
.47752 .21461 L
.47852 .21165 L
.47952 .20873 L
.48052 .20586 L
.48152 .20302 L
.48252 .20022 L
.48352 .19747 L
Mistroke
.48452 .19476 L
.48551 .19209 L
.48651 .18946 L
.48751 .18688 L
.48851 .18433 L
.48951 .18184 L
.49051 .17938 L
.49151 .17696 L
.49251 .17459 L
.49351 .17225 L
.49451 .16995 L
.4955 .16768 L
.4965 .16545 L
.4975 .16325 L
.4985 .16108 L
.4995 .37948 L
.5005 .38264 L
.5015 .38379 L
.5025 .38269 L
.5035 .37967 L
.5045 .37521 L
.50549 .3698 L
.50649 .36386 L
.50749 .35773 L
.50849 .35162 L
.50949 .34567 L
.51049 .33995 L
.51149 .33448 L
.51249 .32923 L
.51349 .32419 L
.51449 .31933 L
.51548 .31461 L
.51648 .31002 L
.51748 .30553 L
.51848 .30112 L
.51948 .29679 L
.52048 .29253 L
.52148 .28833 L
.52248 .28418 L
.52348 .28009 L
.52448 .27605 L
.52547 .27206 L
.52647 .26812 L
.52747 .26423 L
.52847 .2604 L
.52947 .25661 L
.53047 .25288 L
.53147 .2492 L
.53247 .24557 L
.53347 .24199 L
Mistroke
.53447 .23846 L
.53546 .23498 L
.53646 .23156 L
.53746 .22818 L
.53846 .22486 L
.53946 .22159 L
.54046 .21837 L
.54146 .2152 L
.54246 .21209 L
.54346 .20903 L
.54446 .20602 L
.54545 .20306 L
.54645 .20015 L
.54745 .1973 L
.54845 .1945 L
.54945 .12734 L
.55045 .12467 L
.55145 .12396 L
.55245 .12455 L
.55345 .12627 L
.55445 .12903 L
.55544 .13283 L
.55644 .13763 L
.55744 .14342 L
.55844 .1502 L
.55944 .15794 L
.56044 .16663 L
.56144 .17628 L
.56244 .18687 L
.56344 .19839 L
.56444 .21079 L
.56543 .22398 L
.56643 .23783 L
.56743 .25209 L
.56843 .26644 L
.56943 .28047 L
.57043 .2937 L
.57143 .30562 L
.57243 .31576 L
.57343 .32378 L
.57443 .32948 L
.57542 .3329 L
.57642 .33425 L
.57742 .33387 L
.57842 .33214 L
.57942 .32942 L
.58042 .326 L
.58142 .32212 L
.58242 .31792 L
.58342 .31353 L
Mistroke
.58442 .30903 L
.58541 .30447 L
.58641 .29992 L
.58741 .29539 L
.58841 .29092 L
.58941 .28651 L
.59041 .28218 L
.59141 .27792 L
.59241 .27374 L
.59341 .26965 L
.59441 .26562 L
.5954 .26167 L
.5964 .25778 L
.5974 .25396 L
.5984 .25019 L
.5994 .24872 L
.6004 .24339 L
.6014 .23969 L
.6024 .23685 L
.6034 .23458 L
.6044 .23271 L
.60539 .23114 L
.60639 .22977 L
.60739 .22855 L
.60839 .22743 L
.60939 .22638 L
.61039 .22536 L
.61139 .22435 L
.61239 .22334 L
.61339 .22232 L
.61439 .22127 L
.61538 .2202 L
.61638 .21911 L
.61738 .21798 L
.61838 .21683 L
.61938 .21566 L
.62038 .21447 L
.62138 .21326 L
.62238 .21203 L
.62338 .2108 L
.62438 .20956 L
.62537 .20832 L
.62637 .20708 L
.62737 .20585 L
.62837 .20462 L
.62937 .20339 L
.63037 .20218 L
.63137 .20098 L
.63237 .19978 L
.63337 .1986 L
Mistroke
.63437 .19743 L
.63536 .19626 L
.63636 .19511 L
.63736 .19396 L
.63836 .19282 L
.63936 .19169 L
.64036 .19056 L
.64136 .18943 L
.64236 .18831 L
.64336 .18718 L
.64436 .18605 L
.64535 .18492 L
.64635 .18378 L
.64735 .18263 L
.64835 .18147 L
.64935 .22646 L
.65035 .22114 L
.65135 .21705 L
.65235 .21355 L
.65335 .21044 L
.65435 .20761 L
.65534 .20502 L
.65634 .20261 L
.65734 .20036 L
.65834 .19825 L
.65934 .19626 L
.66034 .19437 L
.66134 .19258 L
.66234 .19088 L
.66334 .18924 L
.66434 .18766 L
.66533 .18613 L
.66633 .18464 L
.66733 .1832 L
.66833 .18178 L
.66933 .1804 L
.67033 .17905 L
.67133 .17773 L
.67233 .17645 L
.67333 .1752 L
.67433 .17401 L
.67532 .17288 L
.67632 .17183 L
.67732 .17086 L
.67832 .16999 L
.67932 .16925 L
.68032 .16864 L
.68132 .16818 L
.68232 .16789 L
.68332 .16778 L
Mistroke
.68432 .16787 L
.68531 .16817 L
.68631 .16868 L
.68731 .16941 L
.68831 .17035 L
.68931 .1715 L
.69031 .17284 L
.69131 .17437 L
.69231 .17606 L
.69331 .17788 L
.69431 .17981 L
.6953 .1818 L
.6963 .18383 L
.6973 .18584 L
.6983 .18781 L
.6993 .332 L
.7003 .3244 L
.7013 .31768 L
.7023 .31132 L
.7033 .30524 L
.7043 .29939 L
.70529 .29376 L
.70629 .28832 L
.70729 .28307 L
.70829 .27799 L
.70929 .27307 L
.71029 .26829 L
.71129 .26364 L
.71229 .2591 L
.71329 .25468 L
.71429 .25036 L
.71528 .24614 L
.71628 .24201 L
.71728 .23796 L
.71828 .234 L
.71928 .23012 L
.72028 .22631 L
.72128 .22259 L
.72228 .21893 L
.72328 .21535 L
.72428 .21184 L
.72527 .2084 L
.72627 .20503 L
.72727 .20173 L
.72827 .1985 L
.72927 .19533 L
.73027 .19223 L
.73127 .1892 L
.73227 .18624 L
.73327 .18335 L
Mistroke
.73427 .18052 L
.73526 .17777 L
.73626 .17508 L
.73726 .17247 L
.73826 .16993 L
.73926 .16746 L
.74026 .16507 L
.74126 .16276 L
.74226 .16053 L
.74326 .15838 L
.74426 .15631 L
.74525 .15433 L
.74625 .15245 L
.74725 .15065 L
.74825 .14896 L
.74925 .13727 L
.75025 .14755 L
.75125 .16205 L
.75225 .18004 L
.75325 .20112 L
.75425 .22485 L
.75524 .25062 L
.75624 .2776 L
.75724 .30479 L
.75824 .33099 L
.75924 .35492 L
.76024 .37535 L
.76124 .3913 L
.76224 .40221 L
.76324 .40804 L
.76424 .40932 L
.76523 .40697 L
.76623 .40211 L
.76723 .39578 L
.76823 .38882 L
.76923 .38179 L
.77023 .37499 L
.77123 .36859 L
.77223 .36261 L
.77323 .35706 L
.77423 .35188 L
.77522 .347 L
.77622 .34236 L
.77722 .33789 L
.77822 .33353 L
.77922 .32924 L
.78022 .32498 L
.78122 .32072 L
.78222 .31645 L
.78322 .31217 L
Mistroke
.78422 .30787 L
.78521 .30356 L
.78621 .29924 L
.78721 .29492 L
.78821 .29062 L
.78921 .28633 L
.79021 .28207 L
.79121 .27784 L
.79221 .27364 L
.79321 .26949 L
.79421 .26539 L
.7952 .26133 L
.7962 .25732 L
.7972 .25336 L
.7982 .24946 L
.7992 .27819 L
.8002 .27897 L
.8012 .28094 L
.8022 .28325 L
.8032 .28554 L
.8042 .28758 L
.80519 .28923 L
.80619 .29038 L
.80719 .29099 L
.80819 .29103 L
.80919 .29053 L
.81019 .28952 L
.81119 .28803 L
.81219 .28613 L
.81319 .28388 L
.81419 .28132 L
.81518 .27851 L
.81618 .2755 L
.81718 .27233 L
.81818 .26904 L
.81918 .26565 L
.82018 .2622 L
.82118 .2587 L
.82218 .25518 L
.82318 .25164 L
.82418 .2481 L
.82517 .24457 L
.82617 .24105 L
.82717 .23756 L
.82817 .2341 L
.82917 .23067 L
.83017 .22727 L
.83117 .22392 L
.83217 .2206 L
.83317 .21733 L
Mistroke
.83417 .2141 L
.83516 .21092 L
.83616 .20779 L
.83716 .20471 L
.83816 .20168 L
.83916 .1987 L
.84016 .19577 L
.84116 .1929 L
.84216 .19008 L
.84316 .18731 L
.84416 .1846 L
.84515 .18194 L
.84615 .17934 L
.84715 .17679 L
.84815 .1743 L
.84915 .30577 L
.85015 .31091 L
.85115 .31639 L
.85215 .32131 L
.85315 .32529 L
.85415 .32814 L
.85514 .3298 L
.85614 .33027 L
.85714 .32963 L
.85814 .32803 L
.85914 .32561 L
.86014 .32253 L
.86114 .31895 L
.86214 .31498 L
.86314 .31076 L
.86414 .30636 L
.86513 .30185 L
.86613 .2973 L
.86713 .29273 L
.86813 .28816 L
.86913 .28363 L
.87013 .27915 L
.87113 .27471 L
.87213 .27033 L
.87313 .26601 L
.87413 .26175 L
.87512 .25756 L
.87612 .25342 L
.87712 .24936 L
.87812 .24536 L
.87912 .24142 L
.88012 .23755 L
.88112 .23374 L
.88212 .22999 L
.88312 .22631 L
Mistroke
.88412 .2227 L
.88511 .21914 L
.88611 .21565 L
.88711 .21222 L
.88811 .20886 L
.88911 .20555 L
.89011 .20231 L
.89111 .19914 L
.89211 .19603 L
.89311 .19298 L
.89411 .19 L
.8951 .18709 L
.8961 .18424 L
.8971 .18146 L
.8981 .17876 L
.8991 .15132 L
.9001 .15388 L
.9011 .15892 L
.9021 .16582 L
.9031 .17437 L
.9041 .18444 L
.90509 .19591 L
.90609 .20861 L
.90709 .22233 L
.90809 .23684 L
.90909 .25185 L
.91009 .26701 L
.91109 .28195 L
.91209 .29625 L
.91309 .30948 L
.91409 .32122 L
.91508 .33111 L
.91608 .33889 L
.91708 .34442 L
.91808 .34771 L
.91908 .34894 L
.92008 .34836 L
.92108 .34632 L
.92208 .34317 L
.92308 .33923 L
.92408 .33476 L
.92507 .32996 L
.92607 .32497 L
.92707 .3199 L
.92807 .31481 L
.92907 .30975 L
.93007 .30475 L
.93107 .29982 L
.93207 .29498 L
.93307 .29023 L
Mistroke
.93407 .28557 L
.93506 .281 L
.93606 .27651 L
.93706 .27211 L
.93806 .2678 L
.93906 .26355 L
.94006 .25938 L
.94106 .25528 L
.94206 .25125 L
.94306 .24729 L
.94406 .24338 L
.94505 .23954 L
.94605 .23576 L
.94705 .23204 L
.94805 .22838 L
.94905 .20083 L
.95005 .19553 L
.95105 .19154 L
.95205 .18821 L
.95305 .18534 L
.95405 .18283 L
.95504 .18063 L
.95604 .17869 L
.95704 .17701 L
.95804 .17554 L
.95904 .17427 L
.96004 .17319 L
.96104 .17227 L
.96204 .1715 L
.96304 .17086 L
.96404 .17033 L
.96503 .16992 L
.96603 .1696 L
.96703 .16939 L
.96803 .16928 L
.96903 .1693 L
.97003 .16947 L
.97103 .16981 L
.97203 .17037 L
.97303 .17117 L
.97403 .17227 L
.97502 .17371 L
.97602 .17553 L
.97702 .17777 L
.97802 .18045 L
.97902 .1836 L
.98002 .18721 L
.98102 .19125 L
.98202 .19569 L
.98302 .20045 L
Mistroke
.98402 .20544 L
.98501 .21056 L
.98601 .21569 L
.98701 .22068 L
.98801 .22541 L
.98901 .22974 L
.99001 .23356 L
.99101 .23679 L
.99201 .23937 L
.99301 .24127 L
.99401 .2425 L
.995 .24308 L
.996 .24309 L
.997 .24257 L
.998 .24161 L
.999 .28018 L
Mfstroke
gsave
.999 .29283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .01629 L
.004 .01789 L
.005 .01925 L
.00599 .02046 L
.00699 .02156 L
.00799 .02258 L
.00899 .02356 L
.00999 .02452 L
.01099 .02551 L
.01199 .02656 L
.01299 .02771 L
.01399 .02903 L
.01499 .03059 L
.01598 .0325 L
.01698 .03492 L
.01798 .03802 L
.01898 .04208 L
.01998 .04744 L
.02098 .05453 L
.02198 .06385 L
.02298 .076 L
.02398 .09162 L
.02498 .11145 L
.02597 .13623 L
.02697 .16676 L
.02797 .20376 L
.02897 .24784 L
.02997 .29927 L
.03097 .35779 L
.03197 .42229 L
.03297 .49054 L
.03397 .55896 L
s
.03397 .55896 m
.03489 .61803 L
s
.0413 .61803 m
.04196 .58547 L
.04296 .57265 L
.04396 .61185 L
s
.04396 .61185 m
.0441 .61803 L
s
.04908 .61803 m
.04995 .41998 L
.05095 .48046 L
.05195 .53678 L
.05295 .58387 L
.05395 .61749 L
s
.05395 .61749 m
.05398 .61803 L
s
.09938 .61803 m
.0999 .23832 L
.1009 .24067 L
.1019 .24186 L
.1029 .24255 L
.1039 .24293 L
.1049 .24311 L
.10589 .24315 L
.10689 .24309 L
.10789 .24296 L
.10889 .24278 L
.10989 .24257 L
.11089 .24234 L
.11189 .2421 L
.11289 .24187 L
.11389 .24165 L
.11489 .24145 L
.11588 .24128 L
.11688 .24115 L
.11788 .24106 L
.11888 .24103 L
.11988 .24107 L
.12088 .24118 L
.12188 .24137 L
.12288 .24166 L
.12388 .24205 L
.12488 .24255 L
.12587 .24318 L
.12687 .24394 L
.12787 .24486 L
.12887 .24592 L
.12987 .24716 L
.13087 .24858 L
.13187 .25019 L
.13287 .252 L
.13387 .25402 L
.13487 .25626 L
.13586 .25871 L
.13686 .26139 L
.13786 .26429 L
.13886 .26741 L
.13986 .27074 L
.14086 .27428 L
.14186 .27802 L
.14286 .28193 L
.14386 .286 L
.14486 .29021 L
.14585 .29452 L
.14685 .29892 L
.14785 .30336 L
Mistroke
.14885 .30781 L
.14985 .4089 L
.15085 .41828 L
.15185 .42227 L
.15285 .42264 L
.15385 .42074 L
.15485 .41766 L
.15584 .41419 L
.15684 .41085 L
.15784 .40793 L
.15884 .40554 L
.15984 .40365 L
.16084 .40218 L
.16184 .40099 L
.16284 .39996 L
.16384 .39895 L
.16484 .39787 L
.16583 .39666 L
.16683 .39528 L
.16783 .39373 L
.16883 .392 L
.16983 .39013 L
.17083 .38813 L
.17183 .38605 L
.17283 .3839 L
.17383 .38171 L
.17483 .3795 L
.17582 .37728 L
.17682 .37508 L
.17782 .37288 L
.17882 .3707 L
.17982 .36854 L
.18082 .3664 L
.18182 .36427 L
.18282 .36216 L
.18382 .36007 L
.18482 .35798 L
.18581 .35592 L
.18681 .35386 L
.18781 .35182 L
.18881 .34979 L
.18981 .34777 L
.19081 .34576 L
.19181 .34377 L
.19281 .34178 L
.19381 .33981 L
.19481 .33785 L
.1958 .33591 L
.1968 .33398 L
.1978 .33206 L
Mistroke
.1988 .33016 L
.1998 .18177 L
.2008 .19366 L
.2018 .20649 L
.2028 .22075 L
.2038 .23653 L
.2048 .25372 L
.20579 .27214 L
.20679 .29148 L
.20779 .31127 L
.20879 .33095 L
.20979 .34984 L
.21079 .36726 L
.21179 .38257 L
.21279 .39528 L
.21379 .40507 L
.21479 .41189 L
.21578 .4159 L
.21678 .41743 L
.21778 .41695 L
.21878 .41498 L
.21978 .41199 L
.22078 .40841 L
.22178 .40456 L
.22278 .40069 L
.22378 .39694 L
.22478 .39339 L
.22577 .39008 L
.22677 .38697 L
.22777 .38405 L
.22877 .38127 L
.22977 .37859 L
.23077 .37597 L
.23177 .37339 L
.23277 .37082 L
.23377 .36824 L
.23477 .36566 L
.23576 .36305 L
.23676 .36044 L
.23776 .35781 L
.23876 .35518 L
.23976 .35255 L
.24076 .34992 L
.24176 .34729 L
.24276 .34468 L
.24376 .34209 L
.24476 .33951 L
.24575 .33696 L
.24675 .33443 L
.24775 .33192 L
Mistroke
.24875 .32944 L
.24975 .24328 L
.25075 .25015 L
.25175 .25604 L
.25275 .26153 L
.25375 .26677 L
.25475 .27182 L
.25574 .27668 L
.25674 .28135 L
.25774 .28581 L
.25874 .29004 L
.25974 .29402 L
.26074 .29771 L
.26174 .30109 L
.26274 .30414 L
.26374 .30685 L
.26474 .30921 L
.26573 .3112 L
.26673 .31282 L
.26773 .3141 L
.26873 .31504 L
.26973 .31565 L
.27073 .31596 L
.27173 .31599 L
.27273 .31577 L
.27373 .31532 L
.27473 .31467 L
.27572 .31384 L
.27672 .31285 L
.27772 .31172 L
.27872 .31049 L
.27972 .30915 L
.28072 .30773 L
.28172 .30625 L
.28272 .30471 L
.28372 .30312 L
.28472 .30151 L
.28571 .29987 L
.28671 .29821 L
.28771 .29655 L
.28871 .29488 L
.28971 .29321 L
.29071 .29155 L
.29171 .28989 L
.29271 .28826 L
.29371 .28664 L
.29471 .28504 L
.2957 .28347 L
.2967 .28193 L
.2977 .28041 L
Mistroke
.2987 .27893 L
.2997 .24974 L
.3007 .25279 L
.3017 .25468 L
.3027 .25605 L
.3037 .25712 L
.3047 .25797 L
.30569 .25868 L
.30669 .25927 L
.30769 .25979 L
.30869 .26026 L
.30969 .26068 L
.31069 .26108 L
.31169 .26147 L
.31269 .26186 L
.31369 .26225 L
.31469 .26266 L
.31568 .26308 L
.31668 .26354 L
.31768 .26402 L
.31868 .26454 L
.31968 .2651 L
.32068 .26571 L
.32168 .26636 L
.32268 .26706 L
.32368 .26781 L
.32468 .26862 L
.32567 .26948 L
.32667 .2704 L
.32767 .27138 L
.32867 .27241 L
.32967 .2735 L
.33067 .27465 L
.33167 .27585 L
.33267 .2771 L
.33367 .27841 L
.33467 .27976 L
.33566 .28116 L
.33666 .2826 L
.33766 .28408 L
.33866 .28559 L
.33966 .28714 L
.34066 .2887 L
.34166 .29029 L
.34266 .29189 L
.34366 .2935 L
.34466 .29511 L
.34565 .29671 L
.34665 .29831 L
.34765 .29989 L
Mistroke
.34865 .30145 L
.34965 .37355 L
.35065 .38208 L
.35165 .38736 L
.35265 .39028 L
.35365 .39134 L
.35465 .39098 L
.35564 .38958 L
.35664 .38745 L
.35764 .38487 L
.35864 .38203 L
.35964 .37907 L
.36064 .37609 L
.36164 .37315 L
.36264 .37027 L
.36364 .36747 L
.36464 .36474 L
.36563 .36208 L
.36663 .35946 L
.36763 .35688 L
.36863 .35433 L
.36963 .3518 L
.37063 .34928 L
.37163 .34676 L
.37263 .34424 L
.37363 .34173 L
.37463 .33922 L
.37562 .33672 L
.37662 .33422 L
.37762 .33172 L
.37862 .32924 L
.37962 .32677 L
.38062 .32432 L
.38162 .32188 L
.38262 .31945 L
.38362 .31705 L
.38462 .31467 L
.38561 .3123 L
.38661 .30996 L
.38761 .30764 L
.38861 .30535 L
.38961 .30308 L
.39061 .30084 L
.39161 .29862 L
.39261 .29643 L
.39361 .29427 L
.39461 .29213 L
.3956 .29002 L
.3966 .28795 L
.3976 .2859 L
Mistroke
.3986 .28389 L
.3996 .1285 L
.4006 .13281 L
.4016 .13623 L
.4026 .13948 L
.4036 .14285 L
.4046 .14652 L
.40559 .15067 L
.40659 .15548 L
.40759 .16112 L
.40859 .1678 L
.40959 .17574 L
.41059 .18515 L
.41159 .19625 L
.41259 .2092 L
.41359 .22413 L
.41459 .24105 L
.41558 .25988 L
.41658 .28039 L
.41758 .3022 L
.41858 .32473 L
.41958 .34728 L
.42058 .36901 L
.42158 .38904 L
.42258 .40654 L
.42358 .42084 L
.42458 .43156 L
.42557 .43861 L
.42657 .44227 L
.42757 .44306 L
.42857 .44169 L
.42957 .43884 L
.43057 .43509 L
.43157 .43083 L
.43257 .4263 L
.43357 .42162 L
.43457 .4169 L
.43556 .41221 L
.43656 .40762 L
.43756 .4032 L
.43856 .39898 L
.43956 .39497 L
.44056 .39115 L
.44156 .3875 L
.44256 .38398 L
.44356 .38054 L
.44456 .37716 L
.44555 .37382 L
.44655 .37049 L
.44755 .36717 L
Mistroke
.44855 .36384 L
.44955 .31567 L
.45055 .31775 L
.45155 .31909 L
.45255 .32019 L
.45355 .32111 L
.45455 .32187 L
.45554 .32242 L
.45654 .32277 L
.45754 .3229 L
.45854 .3228 L
.45954 .32248 L
.46054 .32194 L
.46154 .3212 L
.46254 .32027 L
.46354 .31917 L
.46454 .31791 L
.46553 .31652 L
.46653 .315 L
.46753 .31338 L
.46853 .31167 L
.46953 .30989 L
.47053 .30805 L
.47153 .30616 L
.47253 .30423 L
.47353 .30227 L
.47453 .30029 L
.47552 .29831 L
.47652 .29631 L
.47752 .29432 L
.47852 .29233 L
.47952 .29035 L
.48052 .28839 L
.48152 .28646 L
.48252 .28454 L
.48352 .28266 L
.48452 .28081 L
.48551 .279 L
.48651 .27723 L
.48751 .2755 L
.48851 .27383 L
.48951 .2722 L
.49051 .27064 L
.49151 .26915 L
.49251 .26772 L
.49351 .26637 L
.49451 .2651 L
.4955 .26392 L
.4965 .26283 L
.4975 .26186 L
Mistroke
.4985 .26099 L
.4995 .39213 L
.5005 .4032 L
.5015 .41 L
.5025 .41352 L
.5035 .41447 L
.5045 .41348 L
.50549 .41114 L
.50649 .40794 L
.50749 .40428 L
.50849 .40044 L
.50949 .39661 L
.51049 .39289 L
.51149 .38935 L
.51249 .38598 L
.51349 .38277 L
.51449 .3797 L
.51548 .37673 L
.51648 .37383 L
.51748 .37097 L
.51848 .36813 L
.51948 .36529 L
.52048 .36245 L
.52148 .35959 L
.52248 .35672 L
.52348 .35384 L
.52448 .35094 L
.52547 .34805 L
.52647 .34515 L
.52747 .34225 L
.52847 .33937 L
.52947 .3365 L
.53047 .33364 L
.53147 .3308 L
.53247 .32798 L
.53347 .32519 L
.53447 .32242 L
.53546 .31968 L
.53646 .31697 L
.53746 .31429 L
.53846 .31164 L
.53946 .30902 L
.54046 .30643 L
.54146 .30388 L
.54246 .30136 L
.54346 .29888 L
.54446 .29643 L
.54545 .29401 L
.54645 .29164 L
.54745 .2893 L
Mistroke
.54845 .28701 L
.54945 .13999 L
.55045 .14513 L
.55145 .14994 L
.55245 .15513 L
.55345 .161 L
.55445 .16777 L
.55544 .17567 L
.55644 .18491 L
.55744 .19573 L
.55844 .20832 L
.55944 .22284 L
.56044 .23937 L
.56144 .25788 L
.56244 .27819 L
.56344 .29995 L
.56444 .32262 L
.56543 .3455 L
.56643 .36774 L
.56743 .38843 L
.56843 .4067 L
.56943 .42185 L
.57043 .43341 L
.57143 .44127 L
.57243 .44561 L
.57343 .44692 L
.57443 .44579 L
.57542 .44287 L
.57642 .43874 L
.57742 .43386 L
.57842 .4286 L
.57942 .42321 L
.58042 .41789 L
.58142 .41278 L
.58242 .40794 L
.58342 .40341 L
.58442 .39916 L
.58541 .39517 L
.58641 .39137 L
.58741 .38773 L
.58841 .38418 L
.58941 .38069 L
.59041 .37723 L
.59141 .37378 L
.59241 .37033 L
.59341 .36687 L
.59441 .3634 L
.5954 .35993 L
.5964 .35646 L
.5974 .353 L
Mistroke
.5984 .34954 L
.5994 .26138 L
.6004 .26385 L
.6014 .26564 L
.6024 .26729 L
.6034 .26895 L
.6044 .27063 L
.60539 .27237 L
.60639 .27415 L
.60739 .27598 L
.60839 .27786 L
.60939 .27977 L
.61039 .28171 L
.61139 .28368 L
.61239 .28566 L
.61339 .28764 L
.61439 .28962 L
.61538 .29158 L
.61638 .2935 L
.61738 .29538 L
.61838 .29721 L
.61938 .29897 L
.62038 .30064 L
.62138 .30223 L
.62238 .30372 L
.62338 .30511 L
.62438 .30639 L
.62537 .30755 L
.62637 .30859 L
.62737 .30951 L
.62837 .31032 L
.62937 .31101 L
.63037 .31159 L
.63137 .31206 L
.63237 .31242 L
.63337 .31268 L
.63437 .31286 L
.63536 .31295 L
.63636 .31297 L
.63736 .31292 L
.63836 .31281 L
.63936 .31265 L
.64036 .31245 L
.64136 .31222 L
.64236 .31196 L
.64336 .31168 L
.64436 .3114 L
.64535 .31111 L
.64635 .31084 L
.64735 .31057 L
Mistroke
.64835 .31033 L
.64935 .23915 L
.65035 .24159 L
.65135 .24296 L
.65235 .2439 L
.65335 .24462 L
.65435 .24523 L
.65534 .24578 L
.65634 .24634 L
.65734 .24692 L
.65834 .24757 L
.65934 .24831 L
.66034 .24915 L
.66134 .25013 L
.66234 .25127 L
.66334 .25258 L
.66434 .25408 L
.66533 .25579 L
.66633 .25772 L
.66733 .25988 L
.66833 .26229 L
.66933 .26494 L
.67033 .26783 L
.67133 .27097 L
.67233 .27433 L
.67333 .27792 L
.67433 .2817 L
.67532 .28566 L
.67632 .28976 L
.67732 .29397 L
.67832 .29826 L
.67932 .30257 L
.68032 .30687 L
.68132 .3111 L
.68232 .31523 L
.68332 .31921 L
.68432 .32299 L
.68531 .32653 L
.68631 .3298 L
.68731 .33278 L
.68831 .33544 L
.68931 .33776 L
.69031 .33974 L
.69131 .34139 L
.69231 .34271 L
.69331 .34373 L
.69431 .34446 L
.6953 .34493 L
.6963 .34517 L
.6973 .34523 L
Mistroke
.6983 .34514 L
.6993 .34468 L
.7003 .34485 L
.7013 .34358 L
.7023 .34163 L
.7033 .3393 L
.7043 .33676 L
.70529 .3341 L
.70629 .33137 L
.70729 .32862 L
.70829 .32585 L
.70929 .32309 L
.71029 .32034 L
.71129 .3176 L
.71229 .31489 L
.71329 .31219 L
.71429 .30951 L
.71528 .30685 L
.71628 .30421 L
.71728 .3016 L
.71828 .29901 L
.71928 .29644 L
.72028 .2939 L
.72128 .29138 L
.72228 .28889 L
.72328 .28643 L
.72428 .28401 L
.72527 .28161 L
.72627 .27925 L
.72727 .27692 L
.72827 .27463 L
.72927 .27237 L
.73027 .27016 L
.73127 .26799 L
.73227 .26586 L
.73327 .26378 L
.73427 .26175 L
.73526 .25977 L
.73626 .25785 L
.73726 .25599 L
.73826 .25419 L
.73926 .25245 L
.74026 .25079 L
.74126 .24921 L
.74226 .24771 L
.74326 .2463 L
.74426 .24499 L
.74525 .24379 L
.74625 .2427 L
.74725 .24174 L
Mistroke
.74825 .24092 L
.74925 .14991 L
.75025 .16811 L
.75125 .18851 L
.75225 .21192 L
.75325 .23858 L
.75425 .26839 L
.75524 .3009 L
.75624 .33518 L
.75724 .36985 L
.75824 .40311 L
.75924 .433 L
.76024 .45769 L
.76124 .47589 L
.76224 .48707 L
.76324 .49162 L
.76424 .49066 L
.76523 .48575 L
.76623 .4785 L
.76723 .47035 L
.76823 .46237 L
.76923 .45526 L
.77023 .44932 L
.77123 .44455 L
.77223 .44077 L
.77323 .43769 L
.77423 .43502 L
.77522 .43248 L
.77622 .42986 L
.77722 .42704 L
.77822 .42393 L
.77922 .42052 L
.78022 .41683 L
.78122 .41291 L
.78222 .40881 L
.78322 .40459 L
.78422 .4003 L
.78521 .39598 L
.78621 .39168 L
.78721 .3874 L
.78821 .38318 L
.78921 .37902 L
.79021 .37492 L
.79121 .37089 L
.79221 .36693 L
.79321 .36303 L
.79421 .3592 L
.7952 .35542 L
.7962 .35171 L
.7972 .34804 L
Mistroke
.7982 .34443 L
.7992 .29084 L
.8002 .29946 L
.8012 .30704 L
.8022 .31403 L
.8032 .32049 L
.8042 .32636 L
.80519 .3316 L
.80619 .33615 L
.80719 .33998 L
.80819 .34306 L
.80919 .34541 L
.81019 .34703 L
.81119 .34797 L
.81219 .34828 L
.81319 .34802 L
.81419 .34726 L
.81518 .34606 L
.81618 .34449 L
.81718 .34261 L
.81818 .34048 L
.81918 .33815 L
.82018 .33566 L
.82118 .33305 L
.82218 .33035 L
.82318 .32759 L
.82418 .32478 L
.82517 .32195 L
.82617 .31911 L
.82717 .31626 L
.82817 .31342 L
.82917 .3106 L
.83017 .30779 L
.83117 .30501 L
.83217 .30226 L
.83317 .29954 L
.83417 .29686 L
.83516 .29421 L
.83616 .29161 L
.83716 .28904 L
.83816 .28653 L
.83916 .28406 L
.84016 .28164 L
.84116 .27927 L
.84216 .27696 L
.84316 .2747 L
.84416 .27251 L
.84515 .27039 L
.84615 .26833 L
.84715 .26634 L
Mistroke
.84815 .26444 L
.84915 .31842 L
.85015 .33145 L
.85115 .34261 L
.85215 .35229 L
.85315 .36051 L
.85415 .36723 L
.85514 .37243 L
.85614 .37616 L
.85714 .37851 L
.85814 .37959 L
.85914 .37958 L
.86014 .37864 L
.86114 .37695 L
.86214 .37466 L
.86314 .37194 L
.86414 .36889 L
.86513 .36563 L
.86613 .36223 L
.86713 .35875 L
.86813 .35524 L
.86913 .35172 L
.87013 .34822 L
.87113 .34475 L
.87213 .34132 L
.87313 .33793 L
.87413 .33458 L
.87512 .33128 L
.87612 .32802 L
.87712 .3248 L
.87812 .32163 L
.87912 .3185 L
.88012 .31541 L
.88112 .31236 L
.88212 .30935 L
.88312 .30638 L
.88412 .30346 L
.88511 .30058 L
.88611 .29774 L
.88711 .29494 L
.88811 .29218 L
.88911 .28947 L
.89011 .28681 L
.89111 .28419 L
.89211 .28162 L
.89311 .2791 L
.89411 .27662 L
.8951 .2742 L
.8961 .27183 L
.8971 .26951 L
Mistroke
.8981 .26725 L
.8991 .16396 L
.9001 .17437 L
.9011 .18506 L
.9021 .19683 L
.9031 .21001 L
.9041 .22483 L
.90509 .24139 L
.90609 .25971 L
.90709 .27966 L
.90809 .30093 L
.90909 .32302 L
.91009 .34526 L
.91109 .36682 L
.91209 .38682 L
.91309 .40443 L
.91409 .41894 L
.91508 .42994 L
.91608 .43729 L
.91708 .44118 L
.91808 .44204 L
.91908 .44045 L
.92008 .43705 L
.92108 .43244 L
.92208 .42713 L
.92308 .42151 L
.92408 .41588 L
.92507 .41042 L
.92607 .40523 L
.92707 .40035 L
.92807 .39577 L
.92907 .39146 L
.93007 .38735 L
.93107 .38341 L
.93207 .37959 L
.93307 .37584 L
.93407 .37213 L
.93506 .36846 L
.93606 .3648 L
.93706 .36114 L
.93806 .35749 L
.93906 .35385 L
.94006 .35022 L
.94106 .3466 L
.94206 .343 L
.94306 .33943 L
.94406 .33588 L
.94505 .33237 L
.94605 .32889 L
.94705 .32544 L
Mistroke
.94805 .32204 L
.94905 .21348 L
.95005 .21596 L
.95105 .21742 L
.95205 .21851 L
.95305 .21946 L
.95405 .22038 L
.95504 .22136 L
.95604 .22246 L
.95704 .22372 L
.95804 .22522 L
.95904 .22698 L
.96004 .22908 L
.96104 .23155 L
.96204 .23444 L
.96304 .23782 L
.96404 .24171 L
.96503 .24615 L
.96603 .25117 L
.96703 .25679 L
.96803 .26299 L
.96903 .26976 L
.97003 .27707 L
.97103 .28483 L
.97203 .29298 L
.97303 .3014 L
.97403 .30996 L
.97502 .31853 L
.97602 .32694 L
.97702 .33503 L
.97802 .34265 L
.97902 .34965 L
.98002 .3559 L
.98102 .3613 L
.98202 .36579 L
.98302 .36933 L
.98402 .37196 L
.98501 .3737 L
.98601 .37466 L
.98701 .37493 L
.98801 .37463 L
.98901 .3739 L
.99001 .37285 L
.99101 .37159 L
.99201 .3702 L
.99301 .36873 L
.99401 .36723 L
.995 .36568 L
.996 .36409 L
.997 .36243 L
Mistroke
.998 .36068 L
.999 .29283 L
Mfstroke
1 0 0 r
gsave
.999 .2865 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00166 L
.004 .00164 L
.005 .00164 L
.00599 .00167 L
.00699 .00173 L
.00799 .00183 L
.00899 .00199 L
.00999 .00221 L
.01099 .00251 L
.01199 .00291 L
.01299 .00343 L
.01399 .00412 L
.01499 .005 L
.01598 .00614 L
.01698 .00759 L
.01798 .00943 L
.01898 .01177 L
.01998 .01473 L
.02098 .01846 L
.02198 .02315 L
.02298 .02902 L
.02398 .03634 L
.02498 .04543 L
.02597 .05665 L
.02697 .0704 L
.02797 .08708 L
.02897 .10709 L
.02997 .13078 L
.03097 .15832 L
.03197 .18966 L
.03297 .22442 L
.03397 .26175 L
.03497 .30038 L
.03596 .33862 L
.03696 .37463 L
.03796 .40673 L
.03896 .43377 L
.03996 .45532 L
.04096 .4716 L
.04196 .48314 L
.04296 .49031 L
.04396 .49306 L
.04496 .49098 L
.04595 .48369 L
.04695 .47128 L
.04795 .45463 L
.04895 .43525 L
Mistroke
.04995 .41362 L
.05095 .46937 L
.05195 .52157 L
.05295 .56468 L
.05395 .5945 L
.05495 .60955 L
.05594 .61172 L
.05694 .60559 L
.05794 .5968 L
.05894 .59014 L
.05994 .58852 L
.06094 .59272 L
.06194 .60182 L
.06294 .61392 L
Mfstroke
.06294 .61392 m
.06326 .61803 L
s
.09917 .61803 m
.0999 .23194 L
.1009 .23038 L
.1019 .22881 L
.1029 .22725 L
.1039 .22569 L
.1049 .22414 L
.10589 .22261 L
.10689 .22111 L
.10789 .21963 L
.10889 .21818 L
.10989 .21676 L
.11089 .21537 L
.11189 .21402 L
.11289 .21271 L
.11389 .21144 L
.11489 .21021 L
.11588 .20903 L
.11688 .20789 L
.11788 .2068 L
.11888 .20577 L
.11988 .20479 L
.12088 .20386 L
.12188 .20299 L
.12288 .20219 L
.12388 .20145 L
.12488 .20077 L
.12587 .20017 L
.12687 .19963 L
.12787 .19918 L
.12887 .19879 L
.12987 .19849 L
.13087 .19827 L
.13187 .19814 L
.13287 .19809 L
.13387 .19812 L
.13487 .19825 L
.13586 .19846 L
.13686 .19876 L
.13786 .19915 L
.13886 .19962 L
.13986 .20017 L
.14086 .2008 L
.14186 .20151 L
.14286 .20228 L
.14386 .20311 L
.14486 .20399 L
.14585 .20492 L
.14685 .20587 L
.14785 .20685 L
Mistroke
.14885 .20784 L
.14985 .40255 L
.15085 .40796 L
.15185 .4091 L
.15285 .40714 L
.15385 .40322 L
.15485 .39837 L
.15584 .3933 L
.15684 .38851 L
.15784 .38424 L
.15884 .38055 L
.15984 .37741 L
.16084 .3747 L
.16184 .37231 L
.16284 .3701 L
.16384 .36796 L
.16484 .36582 L
.16583 .36361 L
.16683 .3613 L
.16783 .35888 L
.16883 .35635 L
.16983 .35372 L
.17083 .35102 L
.17183 .34825 L
.17283 .34545 L
.17383 .34262 L
.17483 .33978 L
.17582 .33695 L
.17682 .33413 L
.17782 .33132 L
.17882 .32854 L
.17982 .32578 L
.18082 .32305 L
.18182 .32034 L
.18282 .31766 L
.18382 .31501 L
.18482 .31238 L
.18581 .30978 L
.18681 .3072 L
.18781 .30465 L
.18881 .30211 L
.18981 .29961 L
.19081 .29713 L
.19181 .29467 L
.19281 .29223 L
.19381 .28982 L
.19481 .28744 L
.1958 .28507 L
.1968 .28273 L
.1978 .28041 L
Mistroke
.1988 .27812 L
.1998 .17543 L
.2008 .18338 L
.2018 .19332 L
.2028 .20507 L
.2038 .21842 L
.2048 .23313 L
.20579 .24892 L
.20679 .26541 L
.20779 .28214 L
.20879 .29861 L
.20979 .31428 L
.21079 .32862 L
.21179 .34114 L
.21279 .35149 L
.21379 .35948 L
.21479 .36507 L
.21578 .36838 L
.21678 .36969 L
.21778 .36934 L
.21878 .3677 L
.21978 .36514 L
.22078 .36199 L
.22178 .35848 L
.22278 .35482 L
.22378 .35114 L
.22478 .34751 L
.22577 .34397 L
.22677 .34054 L
.22777 .33721 L
.22877 .33397 L
.22977 .33081 L
.23077 .3277 L
.23177 .32465 L
.23277 .32162 L
.23377 .31863 L
.23477 .31565 L
.23576 .3127 L
.23676 .30976 L
.23776 .30684 L
.23876 .30393 L
.23976 .30105 L
.24076 .29818 L
.24176 .29534 L
.24276 .29252 L
.24376 .28973 L
.24476 .28696 L
.24575 .28422 L
.24675 .28151 L
.24775 .27882 L
Mistroke
.24875 .27617 L
.24975 .23694 L
.25075 .23989 L
.25175 .24298 L
.25275 .24615 L
.25375 .24933 L
.25475 .25247 L
.25574 .25552 L
.25674 .25844 L
.25774 .26118 L
.25874 .26371 L
.25974 .26601 L
.26074 .26804 L
.26174 .2698 L
.26274 .27128 L
.26374 .27246 L
.26474 .27336 L
.26573 .27397 L
.26673 .2743 L
.26773 .27438 L
.26873 .27421 L
.26973 .27381 L
.27073 .2732 L
.27173 .27241 L
.27273 .27144 L
.27373 .27033 L
.27473 .26908 L
.27572 .26771 L
.27672 .26625 L
.27772 .2647 L
.27872 .26308 L
.27972 .2614 L
.28072 .25967 L
.28172 .2579 L
.28272 .2561 L
.28372 .25428 L
.28472 .25244 L
.28571 .25058 L
.28671 .24873 L
.28771 .24687 L
.28871 .24501 L
.28971 .24316 L
.29071 .24132 L
.29171 .23949 L
.29271 .23767 L
.29371 .23588 L
.29471 .2341 L
.2957 .23235 L
.2967 .23062 L
.2977 .22892 L
Mistroke
.2987 .22724 L
.2997 .24341 L
.3007 .24256 L
.3017 .24169 L
.3027 .24082 L
.3037 .23994 L
.3047 .23905 L
.30569 .23816 L
.30669 .23728 L
.30769 .23639 L
.30869 .23551 L
.30969 .23464 L
.31069 .23378 L
.31169 .23294 L
.31269 .23211 L
.31369 .23129 L
.31469 .2305 L
.31568 .22973 L
.31668 .22898 L
.31768 .22825 L
.31868 .22755 L
.31968 .22688 L
.32068 .22624 L
.32168 .22563 L
.32268 .22505 L
.32368 .2245 L
.32468 .22398 L
.32567 .2235 L
.32667 .22305 L
.32767 .22263 L
.32867 .22225 L
.32967 .2219 L
.33067 .22159 L
.33167 .22132 L
.33267 .22107 L
.33367 .22086 L
.33467 .22069 L
.33566 .22054 L
.33666 .22043 L
.33766 .22035 L
.33866 .2203 L
.33966 .22027 L
.34066 .22028 L
.34166 .22031 L
.34266 .22036 L
.34366 .22043 L
.34466 .22053 L
.34565 .22064 L
.34665 .22077 L
.34765 .22092 L
Mistroke
.34865 .22109 L
.34965 .3672 L
.35065 .3718 L
.35165 .37428 L
.35265 .3749 L
.35365 .37398 L
.35465 .37187 L
.35564 .3689 L
.35664 .36537 L
.35764 .3615 L
.35864 .35748 L
.35964 .35343 L
.36064 .34942 L
.36164 .3455 L
.36264 .34168 L
.36364 .33797 L
.36464 .33436 L
.36563 .33084 L
.36663 .3274 L
.36763 .32402 L
.36863 .32069 L
.36963 .31741 L
.37063 .31416 L
.37163 .31095 L
.37263 .30777 L
.37363 .30462 L
.37463 .3015 L
.37562 .29841 L
.37662 .29535 L
.37762 .29232 L
.37862 .28932 L
.37962 .28634 L
.38062 .2834 L
.38162 .2805 L
.38262 .27762 L
.38362 .27478 L
.38462 .27197 L
.38561 .26919 L
.38661 .26645 L
.38761 .26375 L
.38861 .26108 L
.38961 .25845 L
.39061 .25585 L
.39161 .25329 L
.39261 .25076 L
.39361 .24827 L
.39461 .24582 L
.3956 .24341 L
.3966 .24103 L
.3976 .23869 L
Mistroke
.3986 .2364 L
.3996 .12217 L
.4006 .12258 L
.4016 .12327 L
.4026 .12427 L
.4036 .12566 L
.4046 .12751 L
.40559 .12989 L
.40659 .13288 L
.40759 .13657 L
.40859 .14107 L
.40959 .14647 L
.41059 .15288 L
.41159 .16041 L
.41259 .16915 L
.41359 .17917 L
.41459 .19052 L
.41558 .20319 L
.41658 .21713 L
.41758 .2322 L
.41858 .24817 L
.41958 .26474 L
.42058 .28149 L
.42158 .29798 L
.42258 .3137 L
.42358 .32819 L
.42458 .341 L
.42557 .35184 L
.42657 .36051 L
.42757 .36696 L
.42857 .37127 L
.42957 .37364 L
.43057 .37432 L
.43157 .3736 L
.43257 .37178 L
.43357 .36914 L
.43457 .36592 L
.43556 .36232 L
.43656 .3585 L
.43756 .35456 L
.43856 .35059 L
.43956 .34663 L
.44056 .34271 L
.44156 .33883 L
.44256 .33501 L
.44356 .33123 L
.44456 .3275 L
.44555 .32381 L
.44655 .32016 L
.44755 .31654 L
Mistroke
.44855 .31295 L
.44955 .30934 L
.45055 .30751 L
.45155 .3061 L
.45255 .30494 L
.45355 .3039 L
.45455 .30289 L
.45554 .30184 L
.45654 .30069 L
.45754 .29942 L
.45854 .29801 L
.45954 .29644 L
.46054 .29473 L
.46154 .29288 L
.46254 .29091 L
.46354 .28882 L
.46454 .28663 L
.46553 .28435 L
.46653 .282 L
.46753 .27959 L
.46853 .27714 L
.46953 .27465 L
.47053 .27214 L
.47153 .26961 L
.47253 .26707 L
.47353 .26453 L
.47453 .262 L
.47552 .25947 L
.47652 .25696 L
.47752 .25446 L
.47852 .25199 L
.47952 .24954 L
.48052 .24713 L
.48152 .24474 L
.48252 .24238 L
.48352 .24006 L
.48452 .23778 L
.48551 .23554 L
.48651 .23334 L
.48751 .23119 L
.48851 .22908 L
.48951 .22702 L
.49051 .22501 L
.49151 .22305 L
.49251 .22115 L
.49351 .21931 L
.49451 .21752 L
.4955 .2158 L
.4965 .21414 L
.4975 .21255 L
Mistroke
.4985 .21104 L
.4995 .3858 L
.5005 .39292 L
.5015 .39689 L
.5025 .3981 L
.5035 .39707 L
.5045 .39434 L
.50549 .39047 L
.50649 .3859 L
.50749 .38101 L
.50849 .37603 L
.50949 .37114 L
.51049 .36642 L
.51149 .36191 L
.51249 .3576 L
.51349 .35348 L
.51449 .34952 L
.51548 .34567 L
.51648 .34193 L
.51748 .33825 L
.51848 .33463 L
.51948 .33104 L
.52048 .32749 L
.52148 .32396 L
.52248 .32045 L
.52348 .31696 L
.52448 .31349 L
.52547 .31005 L
.52647 .30663 L
.52747 .30324 L
.52847 .29988 L
.52947 .29655 L
.53047 .29326 L
.53147 .29 L
.53247 .28678 L
.53347 .28359 L
.53447 .28044 L
.53546 .27733 L
.53646 .27426 L
.53746 .27124 L
.53846 .26825 L
.53946 .2653 L
.54046 .2624 L
.54146 .25954 L
.54246 .25672 L
.54346 .25395 L
.54446 .25122 L
.54545 .24854 L
.54645 .2459 L
.54745 .2433 L
Mistroke
.54845 .24076 L
.54945 .13366 L
.55045 .1349 L
.55145 .13695 L
.55245 .13984 L
.55345 .14363 L
.55445 .1484 L
.55544 .15425 L
.55644 .16127 L
.55744 .16958 L
.55844 .17926 L
.55944 .19039 L
.56044 .203 L
.56144 .21708 L
.56244 .23253 L
.56344 .24917 L
.56444 .2667 L
.56543 .28474 L
.56643 .30278 L
.56743 .32026 L
.56843 .33657 L
.56943 .35116 L
.57043 .36356 L
.57143 .37344 L
.57243 .38069 L
.57343 .38535 L
.57443 .38763 L
.57542 .38789 L
.57642 .38649 L
.57742 .38386 L
.57842 .38037 L
.57942 .37631 L
.58042 .37195 L
.58142 .36745 L
.58242 .36293 L
.58342 .35847 L
.58442 .35409 L
.58541 .34982 L
.58641 .34565 L
.58741 .34156 L
.58841 .33755 L
.58941 .3336 L
.59041 .3297 L
.59141 .32585 L
.59241 .32204 L
.59341 .31826 L
.59441 .31451 L
.5954 .3108 L
.5964 .30712 L
.5974 .30348 L
Mistroke
.5984 .29987 L
.5994 .25505 L
.6004 .25362 L
.6014 .25266 L
.6024 .25207 L
.6034 .25176 L
.6044 .25167 L
.60539 .25175 L
.60639 .25196 L
.60739 .25227 L
.60839 .25264 L
.60939 .25307 L
.61039 .25353 L
.61139 .25401 L
.61239 .2545 L
.61339 .25498 L
.61439 .25545 L
.61538 .25589 L
.61638 .2563 L
.61738 .25668 L
.61838 .25702 L
.61938 .25731 L
.62038 .25756 L
.62138 .25774 L
.62238 .25788 L
.62338 .25796 L
.62438 .25797 L
.62537 .25793 L
.62637 .25784 L
.62737 .25768 L
.62837 .25747 L
.62937 .2572 L
.63037 .25688 L
.63137 .25652 L
.63237 .2561 L
.63337 .25564 L
.63437 .25514 L
.63536 .25461 L
.63636 .25404 L
.63736 .25344 L
.63836 .25282 L
.63936 .25217 L
.64036 .25151 L
.64136 .25083 L
.64236 .25013 L
.64336 .24943 L
.64436 .24873 L
.64535 .24802 L
.64635 .24731 L
.64735 .2466 L
Mistroke
.64835 .2459 L
.64935 .23281 L
.65035 .23137 L
.65135 .23 L
.65235 .22872 L
.65335 .22753 L
.65435 .22642 L
.65534 .2254 L
.65634 .22447 L
.65734 .22364 L
.65834 .22291 L
.65934 .22228 L
.66034 .22176 L
.66134 .22136 L
.66234 .22107 L
.66334 .22091 L
.66434 .22087 L
.66533 .22096 L
.66633 .22118 L
.66733 .22154 L
.66833 .22204 L
.66933 .22267 L
.67033 .22344 L
.67133 .22435 L
.67233 .22539 L
.67333 .22656 L
.67433 .22786 L
.67532 .22927 L
.67632 .23079 L
.67732 .23242 L
.67832 .23412 L
.67932 .23591 L
.68032 .23775 L
.68132 .23964 L
.68232 .24156 L
.68332 .24349 L
.68432 .24543 L
.68531 .24735 L
.68631 .24924 L
.68731 .25109 L
.68831 .25289 L
.68931 .25463 L
.69031 .25629 L
.69131 .25788 L
.69231 .25939 L
.69331 .2608 L
.69431 .26213 L
.6953 .26336 L
.6963 .2645 L
.6973 .26554 L
Mistroke
.6983 .26648 L
.6993 .33834 L
.7003 .33463 L
.7013 .33063 L
.7023 .32647 L
.7033 .32227 L
.7043 .31808 L
.70529 .31393 L
.70629 .30985 L
.70729 .30584 L
.70829 .30192 L
.70929 .29808 L
.71029 .29431 L
.71129 .29062 L
.71229 .287 L
.71329 .28343 L
.71429 .27993 L
.71528 .27649 L
.71628 .27311 L
.71728 .26978 L
.71828 .2665 L
.71928 .26328 L
.72028 .26011 L
.72128 .25698 L
.72228 .25391 L
.72328 .25089 L
.72428 .24792 L
.72527 .24501 L
.72627 .24214 L
.72727 .23932 L
.72827 .23656 L
.72927 .23385 L
.73027 .2312 L
.73127 .2286 L
.73227 .22605 L
.73327 .22356 L
.73427 .22114 L
.73526 .21877 L
.73626 .21647 L
.73726 .21423 L
.73826 .21206 L
.73926 .20996 L
.74026 .20793 L
.74126 .20598 L
.74226 .20412 L
.74326 .20234 L
.74426 .20065 L
.74525 .19906 L
.74625 .19757 L
.74725 .1962 L
Mistroke
.74825 .19494 L
.74925 .14359 L
.75025 .15783 L
.75125 .17528 L
.75225 .19598 L
.75325 .21985 L
.75425 .24662 L
.75524 .27576 L
.75624 .30639 L
.75724 .33732 L
.75824 .36705 L
.75924 .39396 L
.76024 .41652 L
.76124 .43359 L
.76224 .44464 L
.76324 .44983 L
.76424 .44999 L
.76523 .44636 L
.76623 .4403 L
.76723 .43306 L
.76823 .4256 L
.76923 .41852 L
.77023 .41215 L
.77123 .40657 L
.77223 .40169 L
.77323 .39738 L
.77423 .39345 L
.77522 .38974 L
.77622 .38611 L
.77722 .38246 L
.77822 .37873 L
.77922 .37488 L
.78022 .37091 L
.78122 .36682 L
.78222 .36263 L
.78322 .35838 L
.78422 .35408 L
.78521 .34977 L
.78621 .34546 L
.78721 .34116 L
.78821 .3369 L
.78921 .33267 L
.79021 .32849 L
.79121 .32437 L
.79221 .32029 L
.79321 .31626 L
.79421 .31229 L
.7952 .30838 L
.7962 .30451 L
.7972 .3007 L
Mistroke
.7982 .29694 L
.7992 .28452 L
.8002 .28922 L
.8012 .29399 L
.8022 .29864 L
.8032 .30301 L
.8042 .30697 L
.80519 .31041 L
.80619 .31326 L
.80719 .31548 L
.80819 .31705 L
.80919 .31797 L
.81019 .31828 L
.81119 .318 L
.81219 .31721 L
.81319 .31595 L
.81419 .31429 L
.81518 .31228 L
.81618 .30999 L
.81718 .30747 L
.81818 .30476 L
.81918 .3019 L
.82018 .29893 L
.82118 .29588 L
.82218 .29276 L
.82318 .28961 L
.82418 .28644 L
.82517 .28326 L
.82617 .28008 L
.82717 .27691 L
.82817 .27376 L
.82917 .27063 L
.83017 .26753 L
.83117 .26446 L
.83217 .26143 L
.83317 .25844 L
.83417 .25548 L
.83516 .25257 L
.83616 .2497 L
.83716 .24688 L
.83816 .2441 L
.83916 .24138 L
.84016 .23871 L
.84116 .23608 L
.84216 .23352 L
.84316 .23101 L
.84416 .22856 L
.84515 .22616 L
.84615 .22383 L
.84715 .22157 L
Mistroke
.84815 .21937 L
.84915 .3121 L
.85015 .32118 L
.85115 .3295 L
.85215 .3368 L
.85315 .3429 L
.85415 .34769 L
.85514 .35112 L
.85614 .35322 L
.85714 .35407 L
.85814 .35381 L
.85914 .3526 L
.86014 .35059 L
.86114 .34795 L
.86214 .34482 L
.86314 .34135 L
.86414 .33762 L
.86513 .33374 L
.86613 .32976 L
.86713 .32574 L
.86813 .3217 L
.86913 .31768 L
.87013 .31368 L
.87113 .30973 L
.87213 .30582 L
.87313 .30197 L
.87413 .29817 L
.87512 .29442 L
.87612 .29072 L
.87712 .28708 L
.87812 .28349 L
.87912 .27996 L
.88012 .27648 L
.88112 .27305 L
.88212 .26967 L
.88312 .26635 L
.88412 .26308 L
.88511 .25986 L
.88611 .25669 L
.88711 .25358 L
.88811 .25052 L
.88911 .24751 L
.89011 .24456 L
.89111 .24167 L
.89211 .23882 L
.89311 .23604 L
.89411 .23331 L
.8951 .23064 L
.8961 .22803 L
.8971 .22549 L
Mistroke
.8981 .22301 L
.8991 .15764 L
.9001 .16413 L
.9011 .17199 L
.9021 .18132 L
.9031 .19219 L
.9041 .20463 L
.90509 .21865 L
.90609 .23416 L
.90709 .251 L
.90809 .26889 L
.90909 .28744 L
.91009 .30614 L
.91109 .32439 L
.91209 .34154 L
.91309 .35695 L
.91409 .37008 L
.91508 .38053 L
.91608 .38809 L
.91708 .3928 L
.91808 .39488 L
.91908 .39469 L
.92008 .39271 L
.92108 .38938 L
.92208 .38515 L
.92308 .38037 L
.92408 .37532 L
.92507 .37019 L
.92607 .3651 L
.92707 .36013 L
.92807 .35529 L
.92907 .35061 L
.93007 .34605 L
.93107 .34162 L
.93207 .33728 L
.93307 .33303 L
.93407 .32885 L
.93506 .32473 L
.93606 .32066 L
.93706 .31663 L
.93806 .31264 L
.93906 .3087 L
.94006 .3048 L
.94106 .30094 L
.94206 .29713 L
.94306 .29336 L
.94406 .28963 L
.94505 .28595 L
.94605 .28232 L
.94705 .27874 L
Mistroke
.94805 .27521 L
.94905 .20716 L
.95005 .20575 L
.95105 .20448 L
.95205 .20336 L
.95305 .2024 L
.95405 .2016 L
.95504 .20099 L
.95604 .20058 L
.95704 .20037 L
.95804 .20038 L
.95904 .20063 L
.96004 .20113 L
.96104 .20191 L
.96204 .20297 L
.96304 .20434 L
.96404 .20602 L
.96503 .20803 L
.96603 .21039 L
.96703 .21309 L
.96803 .21614 L
.96903 .21953 L
.97003 .22327 L
.97103 .22732 L
.97203 .23167 L
.97303 .23628 L
.97403 .24112 L
.97502 .24612 L
.97602 .25123 L
.97702 .2564 L
.97802 .26155 L
.97902 .26662 L
.98002 .27155 L
.98102 .27627 L
.98202 .28074 L
.98302 .28489 L
.98402 .2887 L
.98501 .29213 L
.98601 .29517 L
.98701 .2978 L
.98801 .30002 L
.98901 .30182 L
.99001 .30321 L
.99101 .30419 L
.99201 .30478 L
.99301 .305 L
.99401 .30486 L
.995 .30438 L
.996 .30359 L
.997 .3025 L
Mistroke
.998 .30115 L
.999 .2865 L
Mfstroke
0 0 0 r
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{741, 305.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;U0001<B000`400?l00000o`00003oo`3ooooo
0?ooonL0oooo003o0?ooool0ooooi`3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo
003o0?ooool0ooooi`3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo003o0?ooool0
ooooi`3oool00600oooo1@0000030?ooo`800000103oool2000001D0oooo0`0000030?ooo`800000
103oool2000001D0oooo0`0000040?ooo`800000103oool2000001@0oooo0`0000040?ooo`800000
103oool200000180oooo0`0000040?ooo`800000103oool2000000@0oooo0P00000c0?ooo`D00000
0`3oool2000000@0oooo0P00000F0?ooo`<000000`3oool2000000@0oooo0P00000D0?ooo`<00000
103oool2000000@0oooo0P00000E0?ooo`<00000103oool2000000@0oooo0P00000A0?ooo`<00000
103oool2000000@0oooo0P0000040?ooo`800000=`3oool5000000<0oooo0P0000040?ooo`800000
5@3oool3000000<0oooo0P0000040?ooo`8000005@3oool3000000@0oooo0P0000040?ooo`800000
503oool3000000@0oooo0P0000040?ooo`8000004P3oool3000000@0oooo0P0000040?ooo`800000
103oool2000003P0oooo001Q0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000E0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo0140oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004P3oool01@00
0000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000B0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000003<0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001H0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0403oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000C0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000140oooo00<000000?ooo`3oool00P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000=`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
5@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`0A0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000180oooo00D000000?ooo`3oool0oooo000000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000004P3oool00`000000oooo0?ooo`02
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000g0?ooo`00HP3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000004P3oool500000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000C0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000180oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004P3oool00`000000oooo
0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000d0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000C0?ooo`D000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000180oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000004`3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000A0?ooo`030000003oool0
oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000003P0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000180oooo1@0000020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000004`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`00000B0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000180oooo00<000000?ooo`3o
ool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool00000=`3oool006<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo00000080oooo00<000000?ooo`3oool0403oool010000000oooo0?ooo`0000030?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000004`3oool4000000<0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`00000C0?ooo`<000000`3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000180oooo00<000000?ooo`3oool00P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
=@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`0A0?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000B0?ooo`@000000`3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000001@0oooo0`0000030?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000004@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000i0?ooo`050000003oool0oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0100oooo00@0
00000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
01<0oooo100000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004`3o
ool3000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000B0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000003L0oooo001P0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001<0oooo00<000000?ooo`00
00000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001<0oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000180oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000004P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`00000b0?ooo`050000003oool0oooo0?oo
o`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001@0oooo00<0
00000?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000180
oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000001<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000004@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000f0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
01<0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000001<0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000180oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000004P3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000g0?oo
o`00H03oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000D0?ooo`8000000`3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000001@0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000180oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000004@3oool2000000@0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000380oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000005@3oool2000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000C0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000C0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000100oooo0P0000040?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000f0?ooo`050000003oool0oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001@0oooo
0P0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000503oool00`00
0000oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004P3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`00000A0?ooo`800000103oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool00000=`3oool00640oooo0`0000040?ooo`800000103o
ool2000001H0oooo00<000000?ooo`3oool00P3oool2000000@0oooo0P00000F0?ooo`800000103o
ool2000000@0oooo0P00000D0?ooo`<00000103oool2000000@0oooo0P00000C0?ooo`030000003o
ool0oooo00<0oooo0P0000040?ooo`800000103oool2000003@0oooo0`0000040?ooo`800000103o
ool2000001L0oooo00<000000?ooo`3oool00P3oool2000000@0oooo0P00000E0?ooo`800000103o
ool2000000@0oooo0P00000E0?ooo`<00000103oool2000000@0oooo0P00000B0?ooo`030000003o
ool0oooo00<0oooo0P0000040?ooo`800000103oool2000003P0oooo0`0000040?ooo`800000103o
ool2000001H0oooo00<000000?ooo`3oool00P3oool2000000@0oooo0P00000F0?ooo`800000103o
ool2000000@0oooo0P00000D0?ooo`<00000103oool2000000@0oooo0P00000C0?ooo`030000003o
ool0oooo00<0oooo0P0000040?ooo`800000103oool2000003P0oooo003o0?ooool0ooooi`3oool0
0?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo00160?oook8000008P3ooonb000002H0oooo
200000000`3o0000000000000006000000030?l000000000000009h00000@@3oool004H0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo02@0oooo00<0
00000?ooo`3oool01@3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03l0oooo0016
0?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`2^
0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`3o00000?ZJ003jVP06
003jVP030?l0003oool0oooo09d0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<000000?oo
o`3oool0[@3oool200000280oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0T0?oo
o`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`2L0?oo
o`800000@@3oool004H0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0P0?ooo`80
0000[`3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3o
ool01P3oool00`3o0000oooo0?ooo`2M0?ooo`030000003oool0oooo03l0oooo00160?ooo`030000
003oool0oooo0:h0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`2^0?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`060?ooo`030?l0
003oool0oooo09d0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<000000?ooo`3oool0[@3o
ool200000280oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0T0?ooo`030000003o
ool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`2L0?ooo`800000@@3o
ool004H0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo0:h0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`050?ooo`030?l0003oool0
oooo00H0oooo00<0o`000?ooo`3oool0W@3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`00
0000oooo0?ooo`2^0?ooo`030000003oool0oooo0200oooo0P00002_0?ooo`030000003oool0oooo
02@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo
09d0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<000000?ooo`3oool0[@3oool200000280
oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00D0
oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`2L0?ooo`800000@@3oool004H0oooo
00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0:h0oooo
00<000000?ooo`3oool0903oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo00H0oooo
00<0o`00003jVP00nYX04000nYZ=0?ooo`030000003oool0oooo03l0oooo00160?ooo`030000003o
ool0oooo0:d0oooo0P00000R0?ooo`800000[`3oool00`000000oooo0?ooo`0T0?ooo`030000003o
ool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`0?0?ooo`03003jVP3o
ool0oooo08X0oooo0P0000110?ooo`00<`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo0080oooo0`0000050?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool04P3oool5
000000030?ooo`000000000000<000000`3oool00`000000oooo0?ooo`0?0?ooo`T00?ZJUP3oool0
0`000000oooo0?ooo`0L0?ooo`<000001@3oool00`000000oooo0?ooo`050?ooo`030?l0003oool0
oooo00H0oooo4`3o0009003jVX@0oooo00<000000?ooo`3oool0?`3oool003<0oooo00<000000?oo
o`3oool01`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0[P3oool0
0`000000oooo0?ooo`0C0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0`3oool00`000000oooo0?ooo`0?0?ooo`03003jVP3oool0oooo00H0oooo2@00nYX80?ooo`X00?ZJ
N`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
1@3oool00`3o0000oooo0?ooo`060?ooo`03003jVP3oool0oooo00l0oooo00<0o`000?ooo`3oool0
1P3ooolK003jVVX0oooo00<000000?ooo`3oool0?`3oool003@0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`020?ooo`800000[P3oool2000001H0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00l0oooo00<00?ZJ0?ooo`3oool03P3o
ool:003jVPP0oooo00<00?ZJ0?ooo`3oool0N@3oool00`000000oooo0?ooo`0M0?ooo`030000003o
ool0oooo00@0oooo0P0000060?ooo`030?l0003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool03`3o
ool:0?l001T0oooo00<00?ZJ0?ooo`3oool0I`3oool200000440oooo000d0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2^0?ooo`030000003oool0
oooo01D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`800000403oool0
0`00nYX0oooo0?ooo`0P0?ooo`03003jVP3oool0oooo07P0oooo0P00000O0?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`060?oooa<00?ZJ203ooolK
0?l001/00?ZJC`3oool00`000000oooo0?ooo`0o0?ooo`00=@3oool00`000000oooo0?ooo`050?oo
o`@000001@3oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo0180oooo00L000000?oo
o`3oool0oooo0000003oool0000000<0oooo00D000000?ooo`3oool0oooo0000000A0?ooo`03003j
VP3oool0oooo0200oooo2P00nYYb0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo01P0oooo2P00nYXI0?ooo`030?l0
003oool0oooo01P0oooo;@00nYXS0?ooo`030000003oool0oooo03l0oooo000a0?ooo`050000003o
ool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0:d0oooo
0P00000D0?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`050000003oool0oooo
0?ooo`0000004@3oool00`00nYX0oooo0?ooo`0Y0?ooo`03003jVP3oool0oooo0700oooo00<00000
0?ooo`3oool0703oool2000000H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`0Q
0?oooaX00?ZJ703o000[0?oooa`00?ZJ1`3oool200000440oooo000a0?ooo`D000001`3oool50000
00@0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0C0?ooo`<000000`3oool30000
00@0oooo00<000000?ooo`3oool01P3oool:003jVR/0oooo00<00?ZJ0?ooo`3oool0L03oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`3o
0000oooo0?ooo`0k0?ooo`03003jVP3oool0oooo00l0oooo2@00nYXo0?l000P0oooo2P00nYY10?oo
o`00AP3oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo0200oooo0P0000070?ooo`03
003jVP3oool0oooo0380oooo00<00?ZJ0?ooo`3oool0L03oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo00D0oooo00<0o`000?ooo`3oool0>`3ooolC003jVPP0oooo6`00nYXS0?oooa<0
o`00@@3oool004H0oooo00<000000?ooo`3oool0[@3oool200000280oooo00<000000?ooo`3oool0
1P3oool00`00nYX0oooo0?ooo`0b0?ooo`03003jVP3oool0oooo0700oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo0740oooo;@00nYX70?ooo`800000
@@3oool004H0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0P0?ooo`030000003o
ool0oooo00H0oooo00<00?ZJ0?ooo`3oool0<P3oool00`00nYX0oooo0?ooo`1`0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2M0?ooo`X00?ZJ@@3o
ool004H0oooo2@00nYZW0?ooo`8000008P3oool2000000L0oooo00<00?ZJ0?ooo`3oool0<P3oool0
0`00nYX0oooo0?ooo`1`0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool01@3oool0
0`3o0000oooo0?ooo`2U0?ooo`800000@@3oool004H0oooo00<000000?ooo`3oool01@3oool00`00
nYX0oooo0?ooo`2V0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool00`00
nYX0oooo0?ooo`0b0?ooo`X00?ZJJ@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo
00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000
oooo0?ooo`050?ooo`03003jVP3oool0oooo0:H0oooo00<000000?ooo`3oool0803oool00`000000
oooo0?ooo`060?ooo`03003jVP3oool0oooo03/0oooo4P00nYYH0?ooo`030000003oool0oooo02@0
oooo2000nYX00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo000h0?ooo`<00000
103oool2000000D0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2U0?ooo`800000
8P3oool00`000000oooo0?ooo`060?ooo`03003jVP3oool0oooo0200oooo2P3o000R0?ooo`03003j
VP3oool0oooo05H0oooo00<000000?ooo`3oool06`3oool5000000@0oooo00<000000?ooo`3oool0
1@3oool00`3o0000oooo0?ooo`2U0?ooo`800000@@3oool003T0oooo00<000000?ooo`3oool00P3o
ool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0
YP3oool00`000000oooo0?ooo`0P0?ooo`8000001`3oool00`00nYX0oooo0?ooo`060?oooa80o`00
203oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo0200oooo00<00?ZJ0?ooo`3oool0
EP3oool00`000000oooo0?ooo`0L0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo000i0?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`050?ooo`03
003jVP3oool0oooo0:H0oooo00<000000?ooo`3oool04P3oool5000000<0oooo0`0000030?ooo`03
0000003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool01P3oool00`3o0000oooo0?ooo`0>0?ooo`X0
o`00203oool:0?l001T0oooo00<00?ZJ0?ooo`3oool0EP3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`03
0000003oool0oooo03l0oooo000i0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
0000103oool80000o`03003jVP000?l0003o0:L0003o5@3oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool01P3oool00`00nYX0oooo0?ooo`060?oo
o`030?l0003oool0oooo02T0oooo00<0o`000?ooo`3oool0603oool00`00nYX0oooo0?ooo`1E0?oo
o`030000003oool0oooo01h0oooo00<000000?ooo`3oool00`3oool2000000H0oooo00<0o`000?oo
o`3oool0Y@3oool200000440oooo000i0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo0:H0oooo00<000000?oo
o`3oool0503oool010000000oooo0?ooo`3oool5000000<0oooo00<000000?ooo`3oool01P3oool0
0`00nYX0oooo0?ooo`060?ooo`030?l0003oool0oooo02T0oooo00<0o`000?ooo`3oool0603oool0
0`00nYX0oooo0?ooo`0>0?oooa<00?ZJ=03oool00`000000oooo0?ooo`0K0?ooo`050000003oool0
oooo0?ooo`000000103oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo0:H0oooo00<0
00000?ooo`3oool0?`3oool003P0oooo0P0000040?ooo`040000003oool0oooo000000@0oooo00<0
00000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2U0?ooo`8000005`3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0080oooo0P0000070?ooo`03003jVP3oool0oooo00H0oooo
00<0o`000?ooo`3oool0:@3oool00`3o0000oooo0?ooo`0H0?ooo`03003jVP3oool0oooo00h0oooo
00<00?ZJ0?ooo`3oool03`3oool00`00nYX0oooo0?ooo`0a0?ooo`8000007@3oool01@000000oooo
0?ooo`3oool0000000@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2U0?ooo`80
0000@@3oool003T0oooo00<000000?ooo`3oool00`3oool2000000D0oooo00<000000?ooo`3oool0
1@3oool00`00nYX0oooo0?ooo`2V0?ooo`030000003oool0oooo0180oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool01P3oool00`00nYX0
oooo0?ooo`060?ooo`030?l0003oool0oooo02T0oooo00<0o`000?ooo`3oool0603ooolB003jVQ40
oooo6`00nYXJ0?ooo`030000003oool0oooo01`0oooo0`0000050?ooo`030000003oool0oooo00D0
oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo
0?ooo`050?ooo`03003jVP3oool0oooo0:H0oooo00<000000?ooo`3oool04P3oool01@000000oooo
0?ooo`3oool0000000<0oooo0P0000040?ooo`030000003oool0oooo00H0oooo2P3o000[0?ooo`03
0?l0003oool0oooo05D0oooo00<00?ZJ0?ooo`3oool0603oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00
AP3oool90?l00:L0oooo0P00000E0?ooo`<000001@3oool00`000000oooo0?ooo`020?ooo`800000
1`3oool00`3o0000oooo0?ooo`0b0?ooo`X0o`00CP3oool00`00nYX0oooo0?ooo`0H0?ooo`03003j
VP3oool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2U0?ooo`800000
@@3oool004H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool01P3oool00`3o0000oooo0?ooo`0k0?ooo`030?l0003o
ool0oooo00H0oooo2@3o000n0?ooo`03003jVP3oool0oooo00h0oooo2P00nYXV0?ooo`030000003o
ool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool0
0`000000oooo0?ooo`050?ooo`030?l0003oool0oooo0:H0oooo00<000000?ooo`3oool0803oool0
0`000000oooo0?ooo`060?ooo`030?l0003oool0oooo03/0oooo2P3o00070?ooo`030?l0003oool0
oooo03`0oooo2@00nYX80?ooo`03003jVP3oool0oooo00H0oooo00<000000?ooo`3oool0903oool0
0`000000oooo0?ooo`050?ooo`030?l0003oool0oooo0:H0oooo00<000000?ooo`3oool0?`3oool0
04H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2U0?ooo`8000008P3oool00`00
0000oooo0?ooo`060?ooo`030?l0003oool0oooo04`0oooo00<0o`000?ooo`3oool0A03oool:003j
VPP0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo
0:D0oooo0P0000110?ooo`00AP3oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo0:H0
oooo00<000000?ooo`3oool0803oool2000000L0oooo00<0o`000?ooo`3oool0803oool:003jVR80
oooo00<0o`000?ooo`3oool0603oool:0?l003@0oooo00<000000?ooo`3oool0903oool80000o`03
0?l000000?l0003o0:L0003o@@3oool004H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo
0?ooo`2V0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool00`3o0000oooo
0?ooo`0P0?ooo`03003jVP3oool0oooo00H0oooo2P00nYXJ0?ooo`030?l0003oool0oooo00h0oooo
2P3o00080?ooo`030?l0003oool0oooo00H0oooo2P3o000R0?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo
000/0?ooo`<000000P3oool5000000<0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<0
00000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2U0?ooo`8000008P3oool00`000000oooo0?oo
o`060?ooo`030?l0003oool0oooo00l0oooo2@00nYX80?ooo`03003jVP3oool0oooo00l0oooo00<0
0?ZJ0?ooo`3oool0603oool00`3o0000oooo0?ooo`0>0?ooo`030?l0003oool0oooo00l0oooo2P3o
00080?ooo`T0o`006P3oool00`3o0000oooo0?ooo`0L0?ooo`<000001@3oool00`000000oooo0?oo
o`050?ooo`030?l0003oool0oooo0:D0oooo0P0000110?ooo`00;@3oool00`000000oooo0?ooo`02
0?ooo`040000003oool0oooo000000L0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000
003oool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo00H0oooo00<0o`000?ooo`3oool01P3oool9003jVPP0oooo2P00nYXA0?ooo`03003j
VP3oool0oooo01P0oooo4P3o000[0?ooo`030?l0003oool0oooo01P0oooo00<0o`000?ooo`3oool0
6`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool01@3oool00`3o0000
oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo000]0?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`020?ooo`8000001P3oool00`3o0000oooo
0?ooo`2U0?ooo`8000008P3oool2000000L0oooo00<0o`000?ooo`3oool01P3oool00`00nYX0oooo
0?ooo`0Y0?ooo`03003jVP3oool0oooo05H0oooo00<0o`000?ooo`3oool03P3oool:0?l00240oooo
00<000000?ooo`3oool00P3oool2000000H0oooo00<0o`000?ooo`3oool0Y@3oool200000440oooo
000]0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?oo
o`0B0?ooo`D000000P3oool3000000@0oooo00<000000?ooo`3oool01P3oool00`3o0000oooo0?oo
o`060?ooo`03003jVP3oool0oooo02T0oooo00<00?ZJ0?ooo`3oool0EP3oool90?l000P0oooo00<0
o`000?ooo`3oool01P3oool00`000000oooo0?ooo`0M0?ooo`8000001@3oool00`000000oooo0?oo
o`050?ooo`030?l0003oool0oooo0:H0oooo00<000000?ooo`3oool0?`3oool002d0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00D0oooo100000050?ooo`030000003o
ool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0C0?ooo`060000003o
ool0oooo0000003oool000000`3oool01@000000oooo0?ooo`3oool0000000P0oooo00<0o`000?oo
o`3oool01P3oool00`00nYX0oooo0?ooo`0Y0?ooo`X00?ZJ203oool9003jVTH0oooo2P3o00080?oo
o`030000003oool0oooo01l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`050?oo
o`030?l0003oool0oooo0:H0oooo00<000000?ooo`3oool0?`3oool002`0oooo0P0000030?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`060?ooo`P00?ZJ00<0o`000?oo
o`3oool0Y@3oool2000001H0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0
oooo0?ooo`8000001`3oool00`3o0000oooo0?ooo`060?ooo`03003jVP3oool0oooo0380oooo00<0
0?ZJ0?ooo`3oool01P3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo05D0oooo0P00
000M0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`050?ooo`030?l0
003oool0oooo0:D0oooo0P0000110?ooo`00;@3oool00`000000oooo0?ooo`020?ooo`<00000203o
ool5000000@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool0100000040?ooo`030000003oool0oooo00H0oooo00<0
o`000?ooo`3oool01P3oool00`00nYX0oooo0?ooo`0b0?ooo`X00?ZJ1`3oool00`00nYX0oooo0?oo
o`0H0?ooo`X00?ZJ=03oool00`000000oooo0?ooo`0L0?ooo`<000001@3oool00`000000oooo0?oo
o`050?ooo`030?l0003oool0oooo0:H0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<00000
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo0180oooo00L00000
0?ooo`3oool0oooo0000003oool0000000L0oooo00<000000?ooo`3oool01P3oool00`3o00000?ZJ
003jVP07003jVTD0oooo00<00?ZJ0?ooo`3oool03`3oool:003jVPP0oooo6`00nYXJ0?ooo`03003j
VP3oool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000
003oool0oooo03l0oooo00160?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0Y@3o
ool2000001@0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool01P3oool00`3o0000oooo0?ooo`1=0?ooo`03003jVP3oool0oooo00h0oooo
00<00?ZJ0?ooo`3oool0:@3oool00`00nYX0oooo0?ooo`0H0?ooo`03003jVP3oool0oooo02@0oooo
00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2U0?ooo`800000@@3oool004H0oooo00<0
00000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo01<0oooo0`00
00040?ooo`800000103oool2000000L0oooo00<0o`000?ooo`3oool0C@3oool00`00nYX0oooo0?oo
o`0>0?ooo`03003jVP3oool0oooo02T0oooo00<00?ZJ0?ooo`3oool03`3oool:003jVRH0oooo00<0
00000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo0016
0?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0P
0?ooo`030000003oool0oooo00H0oooo00<0o`000?ooo`3oool0C@3ooolB003jVR`0oooo00<00?ZJ
0?ooo`3oool03P3oool00`00nYX0oooo0?ooo`060?ooo`030000003oool0oooo02@0oooo00<00000
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo00160?oo
o`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0Y@3oool200000280oooo00<000000?oo
o`3oool01P3oool00`3o0000oooo0?ooo`2;0?oooa800?ZJ203oool00`000000oooo0?ooo`0T0?oo
o`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0Y@3oool200000440oooo00160?ooo`03
0000003oool0oooo00D0oooo00<0o`000?ooo`3oool0YP3oool00`000000oooo0?ooo`0P0?ooo`80
00001`3oool00`3o0000oooo0?ooo`2U0?ooo`030000003oool0oooo02@0oooo2@3o002X0?ooo`03
0000003oool0oooo03l0oooo00160?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0
Y@3oool200000280oooo2@00nYX00`3o0000oooo0?ooo`2U0?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2U0?ooo`800000@@3oool003P0oooo0`00
00030?ooo`<000001@3oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo0:H0oooo00<0
00000?ooo`3oool0803oool00`000000oooo0?ooo`060?ooo`030?l0003oool0oooo0:D0oooo00<0
00000?ooo`3oool07@3oool3000000@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?oo
o`2V0?ooo`030000003oool0oooo03l0oooo000i0?ooo`050000003oool0oooo0?ooo`0000000`3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0YP3o
ool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00H0oooo00<0o`000?ooo`3oool0Y@3o
ool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01@3o
ool00`00nYX0oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo000i0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool00P3oool2000000H0oooo00<0o`000?ooo`3oool0Y@3oool2
00000280oooo0P0000070?ooo`030?l0003oool0oooo0:D0oooo00<000000?ooo`3oool06`3oool5
000000@0oooo0P0000060?ooo`03003jVP3oool0oooo0:D0oooo0P0000110?ooo`00>@3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool00`3o
0000oooo0?ooo`2V0?ooo`030000003oool0oooo0180oooo1@0000020?ooo`<00000103oool00`00
0000oooo0?ooo`060?ooo`030?l0003oool0oooo0:D0oooo00<000000?ooo`3oool06`3oool01000
0000oooo0?ooo`0000050?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0YP3oool0
0`000000oooo0?ooo`0o0?ooo`00>@3oool010000000oooo0?ooo`3oool4000000D0oooo00<00000
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`030000003oool0oooo01<0oooo00H00000
0?ooo`3oool000000?ooo`0000030?ooo`050000003oool0oooo0?ooo`000000203oool00`3o0000
oooo0?ooo`2U0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`0000001@3oool00`000000
oooo0?ooo`050?ooo`03003jVP3oool0oooo0:H0oooo00<000000?ooo`3oool0?`3oool003P0oooo
0P0000030?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo
0?ooo`2U0?ooo`8000005P3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3o
ool0oooo000000080?ooo`030?l0003oool0oooo0:D0oooo00<000000?ooo`3oool07@3oool20000
00D0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2U0?ooo`800000@@3oool003T0
oooo00@000000?ooo`3oool0oooo1@0000040?ooo`030000003oool0oooo00D0oooo00<0o`000?oo
o`3oool0YP3oool00`000000oooo0?ooo`0E0?ooo`040000003oool0oooo0?ooo`<00000103oool9
0000o`030?l000000?l0003o0:H0003o803oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00D0oooo00<00?ZJ0?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`00
0000oooo0?ooo`050?ooo`030?l0003oool0oooo0:H0oooo00<000000?ooo`3oool04P3oool01`00
0000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000P0oooo
00<0o`000?ooo`3oool0Y@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00D0oooo
00<00?ZJ0?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?oo
o`050?ooo`030?l0003oool0oooo0:D0oooo0P00000D0?ooo`070000003oool0oooo0?ooo`000000
oooo000000030?ooo`050000003oool0oooo0?ooo`000000203oool00`3o0000oooo0?ooo`2U0?oo
o`030000003oool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2U0?oo
o`800000@@3oool004H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`2V0?ooo`03
0000003oool0oooo01<0oooo0`0000030?ooo`<00000103oool2000000L0oooo00<0o`000?ooo`3o
ool0Y@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3o
ool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?ooo`050?ooo`030?l0
0000nYX00?ZJ00L00?ZJWP3oool200000280oooo00<000000?ooo`3oool01P3oool00`3o0000oooo
0?ooo`2U0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo
0?ooo`2U0?ooo`800000@@3oool004H0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?oo
o`060?ooo`03003jVP3oool0oooo09d0oooo00<000000?ooo`3oool0803oool00`000000oooo0?oo
o`060?ooo`030?l0003oool0oooo0:D0oooo00<000000?ooo`3oool0903oool00`000000oooo0?oo
o`050?ooo`03003jVP3oool0oooo0:H0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<00000
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`060?ooo`03003jVP3oool0oooo09d0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`060?ooo`030?l0003oool0oooo0:D0oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo0:H0oooo00<00000
0?ooo`3oool0?`3oool002`0oooo0`0000040?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool00P3oool3000000D0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`060?oo
o`03003jVP3oool0oooo09`0oooo0P00000R0?ooo`X0o`00Y`3oool00`000000oooo0?ooo`0L0?oo
o`<000001@3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo0:D0oooo0P0000110?oo
o`00;@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`00
nYX0oooo0?ooo`2M0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool00`00
nYX0oooo0?ooo`2U0?ooo`030000003oool0oooo01/0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0YP3oool00`000000oooo0?ooo`0o
0?ooo`00;@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo00H0oooo00<00?ZJ0?oo
o`3oool0W@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00H0oooo00<00?ZJ0?oo
o`3oool0Y@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool01@3oool00`00nYX0oooo0?ooo`2V0?ooo`030000003oool0oooo03l0oooo000]0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`80
00001P3oool00`3o0000oooo0?ooo`060?ooo`03003jVP3oool0oooo09`0oooo0P00000R0?ooo`03
0000003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool0Y@3oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo0080oooo0P0000060?ooo`03003jVP3oool0oooo0:D0oooo0P0000110?ooo`00
;@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo100000050?ooo`030000
003oool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`00nYX0oooo0?ooo`2M0?ooo`030000
003oool0oooo0200oooo0P0000070?ooo`03003jVP3oool0oooo0:D0oooo00<000000?ooo`3oool0
6`3oool4000000D0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2V0?ooo`030000
003oool0oooo03l0oooo000/0?ooo`8000000`3oool01@000000oooo0?ooo`3oool0000000L0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo00H0oooo
00<00?ZJ0?ooo`3oool0W@3oool00`000000oooo0?ooo`0C0?ooo`<00000103oool2000000@0oooo
00<000000?ooo`3oool01P3oool00`00nYX0oooo0?ooo`2U0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo0:H0oooo
00<000000?ooo`3oool0?`3oool002d0oooo00@000000?ooo`3oool0oooo1@0000070?ooo`D00000
103oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool0
>`3oool:003jVQ40oooo6`00nYX[0?ooo`0300000000nYX0oooo01<0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool01P3oool00`00
nYX0oooo0?ooo`2U0?ooo`030000003oool0oooo01/0oooo1@0000040?ooo`030000003oool0oooo
00D0oooo00<00?ZJ0?ooo`3oool0Y@3oool200000440oooo00160?ooo`030000003oool0oooo00D0
oooo00<0o`000?ooo`3oool01P3oool00`00nYX0oooo0?ooo`0k0?ooo`03003jVP3oool0oooo00H0
oooo4`00nYXI0?oooa`00?ZJ203oool9003jVP030000003oool0oooo01H0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`3oool2000000L0oooo00<00?ZJ0?ooo`3oool0Y03oool2
000002H0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2V0?ooo`030000003oool0
oooo03l0oooo00160?ooo`030000003oool0oooo00D0oooo2P3o000B003jVPP0oooo4P00nYXA0?oo
o`03003jVP3oool0oooo04d0oooo2P00nYX70?ooo`8000005P3oool2000000<0oooo00@000000?oo
o`3oool000000`3oool00`000000oooo0?ooo`060?ooo`03003jVP3oool0oooo0:D0oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo0:D0oooo0P000011
0?ooo`00AP3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo00H0oooo00<0o`000?oo
o`3oool03`3oool:003jVQ40oooo4P00nYYQ0?ooo`030000003oool0oooo01H0oooo00@000000?oo
o`3oool000000P3oool01@000000oooo0?ooo`3oool0000000P0oooo00<00?ZJ0?ooo`3oool0Y@3o
ool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0YP3o
ool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0
oooo00H0oooo00<0o`000?ooo`3oool0W@3oool00`000000oooo0?ooo`0B0?ooo`050000003oool0
oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00H0oooo
00<00?ZJ0?ooo`3oool0Y@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00D0oooo
00<00?ZJ0?ooo`3oool0YP3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?oo
o`050?ooo`03003jVP3oool0oooo00H0oooo00<0o`000?ooo`3oool0W03oool2000001D0oooo0`00
00040?ooo`800000103oool2000000L0oooo00<00?ZJ0?ooo`3oool0Y@3oool00`000000oooo0?oo
o`0T0?ooo`T00?ZJY`3oool200000440oooo00160?ooo`030000003oool0oooo00D0oooo00<00?ZJ
0?ooo`3oool01P3oool00`3o0000oooo0?ooo`2M0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool01P3oool00`00nYX0oooo0?ooo`2U0?ooo`030000003oool0oooo02@0oooo00<00000
0?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?ooo`050?oo
o`03003jVP3oool0oooo00H0oooo00<0o`000?ooo`3oool0W@3oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool0Y@3oool00`000000oooo0?ooo`0T0?oo
o`030000003oool0oooo0:h0oooo00<000000?ooo`3oool0?`3oool003L0oooo1@0000030?ooo`80
00001@3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo00H0oooo00<0o`000?ooo`3o
ool0W03oool200000280oooo2P00nYZW0?ooo`030000003oool0oooo01`0oooo0`0000050?ooo`03
0000003oool0oooo0:d0oooo0P0000110?ooo`00>03oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`060?oo
o`030?l0003oool0oooo09d0oooo00<000000?ooo`3oool0803oool200000:l0oooo00<000000?oo
o`3oool06`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0[P3oool0
0`000000oooo0?ooo`0o0?ooo`00>@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`060?ooo`030?l0003oool0
oooo03/0oooo4`3o00080?ooobd0o`006P3oool00`3o0000oooo0?ooo`0P0?ooo`030000003oool0
oooo0:h0oooo00<000000?ooo`3oool06`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<0
00000?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00>P3oool01@000000oooo0?ooo`3o
ool000000080oooo00<000000?ooo`3oool00P3oool2000000H0oooo00<00?ZJ0?ooo`3oool01P3o
ool:0?l003@0oooo00<0o`000?ooo`3oool03`3oool:0?l002/0oooo6`3o00000`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool06`3oool4000000D0oooo0P00
002^0?ooo`800000@@3oool003L0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo000000@0oooo00<000000?ooo`3oool01@3oool:003jVPP0oooo2P3o00080?ooob@0o`00
H@3oool00`000000oooo0?ooo`0P0?ooo`800000[`3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00=`3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000103oool00`000000
oooo0?ooo`0>0?ooo`03003jVP3oool0oooo00l0oooo2P3o00230?ooo`8000005@3oool300000080
oooo1@0000030?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool0703oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo0:d0oooo0P0000110?ooo`00>03oool3000000@0oooo
0P0000050?ooo`030000003oool0oooo00h0oooo00<00?ZJ0?ooo`3oool0W@3oool00`000000oooo
0?ooo`0B0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?oo
o`030000003oool0oooo0:h0oooo00<000000?ooo`3oool07@3oool2000000D0oooo00<000000?oo
o`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?ooo`0>0?ooo`03
003jVP3oool0oooo09d0oooo00<000000?ooo`3oool05P3oool01@000000oooo0?ooo`3oool00000
00D0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo
0:h0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<000000?ooo`3oool03P3oool00`00nYX0
oooo0?ooo`2L0?ooo`8000005P3oool2000000D0oooo00<000000?ooo`3oool00P3oool200000:h0
oooo0P00000V0?ooo`030000003oool0oooo0:d0oooo0P0000110?ooo`00AP3oool00`000000oooo
0?ooo`0>0?ooo`03003jVP3oool0oooo09d0oooo00<000000?ooo`3oool05P3oool00`000000oooo
000000030?ooo`050000003oool0oooo0?ooo`000000/03oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo0:h0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<000000?ooo`3oool0
3P3oool00`00nYX0oooo0?ooo`2M0?ooo`030000003oool0oooo0180oooo00L000000?ooo`3oool0
oooo0000003oool0000000<0oooo00D000000?ooo`3oool0oooo0000002`0?ooo`030000003oool0
oooo02@0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`00
0000oooo0?ooo`0>0?ooo`03003jVP3oool0oooo05H0oooo6`00nYX[0?ooo`0300000000nYX0oooo
01@0oooo0`0000030?ooo`<00000103oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo
02@0oooo00<000000?ooo`3oool0[@3oool200000440oooo00160?ooo`030000003oool0oooo00h0
oooo00<00?ZJ0?ooo`3oool0>`3ooolC003jVPP0oooo00<00?ZJ0?ooo`3oool05`3ooolL003jVPP0
oooo2@00nYX00`000000oooo0?ooo`0P0?ooo`800000[`3oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo0:h0oooo00<000000?ooo`3oool0?`3oool004H0oooo00<000000?ooo`3oool0
3P3oool:003jVQ40oooo4P00nYXA0?ooo`03003jVP3oool0oooo00l0oooo2P00nYXd0?ooo`X00?ZJ
1`3oool200000280oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0T0?ooo`030000
003oool0oooo0:d0oooo0P0000110?ooo`00:`3oool5000000030?ooo`000000000000<000000`3o
ool00`000000oooo0?ooo`020?ooo`<000001@3oool00`000000oooo0?ooo`0G0?oooa<00?ZJ4@3o
oolB003jVV40oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`2^0?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2^0?ooo`030000003o
ool0oooo03l0oooo000/0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
1`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0[P3oool00`000000
oooo0?ooo`0P0?ooo`800000[`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00;@3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P3oool200000:h0oooo
0P00000R0?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool07P3oool00`000000oooo
0?ooo`030?ooo`800000[P3oool200000440oooo000^0?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0:h0oooo00<0
00000?ooo`3oool0803oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo01h0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo03l0oooo000[
0?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`030000003oool0oooo00D0oooo
100000050?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool0803oool00`000000oooo
0?ooo`2^0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`2^0?ooo`030000003oool0oooo03l0oooo000[0?ooo`070000003oool0oooo0?ooo`000000
oooo000000030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`2]0?ooo`8000008P3oool200000:l0oooo00<000000?ooo`3oool06`3oool01@000000
oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0[@3oool200000440oooo000/0?ooo`<0
00000`3oool3000000P0oooo1@0000040?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3o
ool04`3oool3000000@0oooo0`0000030?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3o
ool06`3oool5000000@0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00
AP3oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo0180oooo00D000000?ooo`3oool0
oooo000000040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0[P3oool00`000000
oooo0?ooo`0T0?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool0?`3oool004H0oooo
00<000000?ooo`3oool0[@3oool2000001P0oooo00<000000?ooo`000000100000030?ooo`030000
003oool0oooo0:h0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`2]0?ooo`800000
@@3oool004H0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0D0?ooo`8000000P3o
ool010000000oooo0?ooo`0000040?ooo`800000[P3oool2000002H0oooo00<000000?ooo`3oool0
[P3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?ooo`2]0?ooo`800000603o
ool01P000000oooo0?ooo`000000oooo000000@0oooo00<000000?ooo`3oool0[P3oool00`000000
oooo0?ooo`0T0?ooo`030000003oool0oooo0:d0oooo0P0000110?ooo`00AP3oool00`000000oooo
0?ooo`2^0?ooo`030000003oool0oooo0180oooo00D000000?ooo`3oool0oooo000000030?ooo`80
0000103oool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0[P3oool00`000000oooo0?ooo`0o0?ooo`00AP3oool00`000000oooo0?ooo`2^0?ooo`030000
003oool0oooo01<0oooo0`0000050?ooo`030000003oool0oooo0080oooo0P00002_0?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool0[P3oool00`000000oooo0?ooo`0o0?ooo`00=`3o
ool500000080oooo0`0000050?ooo`030000003oool0oooo0:d0oooo0P00000R0?ooo`030000003o
ool0oooo0:h0oooo00<000000?ooo`3oool0703oool3000000D0oooo00<000000?ooo`3oool0[@3o
ool200000440oooo000h0?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo0:h0oooo00<000000?ooo`3oool0803oool00`000000oooo
0?ooo`2^0?ooo`030000003oool0oooo01/0oooo00D000000?ooo`3oool0oooo000000040?ooo`03
0000003oool0oooo0:h0oooo00<000000?ooo`3oool0?`3oool003T0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`0K0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0?`3oool003X0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oook8000008P3ooonb000001h0oooo
0`0000050?oook800000@@3oool003L0oooo00H000000?ooo`3oool0oooo0000003oool400000?l0
ooooZ@3oool01@000000oooo0?ooo`3oool000000?L0oooo000g0?ooo`070000003oool0oooo0?oo
o`000000oooo0000003o0?oooj`0oooo00D000000?ooo`3oool0oooo0000003g0?ooo`00>03oool3
00000080oooo1@00003o0?ooojT0oooo0`00003h0?ooo`00W03oool300000?l0ooooo`3ooom80?oo
o`00W`3oool00`000000oooo0?ooo`3o0?ooool0ooooA@3oool008l0oooo100000020?ooo`D00000
0P3oool4000000060?ooo`000000oooo0000003oool000000P3oool400000<@0oooo0`00003D0?oo
o`@00000VP3oool009<0oooo00D000000?ooo`3oool0oooo000000030?ooo`0=0000003oool0oooo
0?ooo`000000oooo0000003oool000000?ooo`000000oooo000000020?ooo`030000003oool0oooo
0<@0oooo00<000000?ooo`3oool0e03oool010000000oooo0?ooo`00002I0?ooo`00T03oool30000
00@0oooo00D000000?ooo`3oool0oooo000000030?ooo`070000003oool000000?ooo`000000oooo
000000020?ooo`<00000aP3oool00`000000oooo0?ooo`3D0?ooo`040000003oool0oooo000009T0
oooo002?0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo000000030?ooo`09
0000003oool000000?ooo`000000oooo0000003oool000000080oooo00<000000?ooo`3oool0a03o
ool200000=D0oooo00@000000?ooo`3oool00000V@3oool00900oooo10000000103oool000000000
000000040?ooo`L0000000<0oooo0000003oool00P3oool200000<H0oooo0P0000000`3oool00000
0000003C0?ooo`<00000VP3oool00?l0ooooo`3ooom:0?ooo`030000003oool0oooo09X0oooo002G
0?ooo`030000003oool0oooo0?l0oooo[P3oool2000009`0oooo003o0?ooool0ooooi`3oool00?l0
ooooo`3ooooW0?ooo`00G@3oool5000000<0oooo0P0000040?ooo`8000005@3oool3000000<0oooo
0P0000040?ooo`8000005@3oool3000000@0oooo0P0000040?ooo`800000503oool3000000@0oooo
0P0000040?ooo`8000004P3oool3000000@0oooo0P0000040?ooo`800000103oool2000003T0oooo
1@0000030?ooo`800000103oool2000001H0oooo0`0000030?ooo`800000103oool2000001@0oooo
0`0000040?ooo`800000103oool2000001D0oooo0`0000040?ooo`800000103oool200000140oooo
0`0000040?ooo`800000103oool2000000@0oooo0P00000g0?ooo`D000000`3oool2000000@0oooo
0P00000E0?ooo`<000000`3oool2000000@0oooo0P00000E0?ooo`<00000103oool2000000@0oooo
0P00000D0?ooo`<00000103oool2000000@0oooo0P00000B0?ooo`<00000103oool2000000@0oooo
0P0000040?ooo`800000=@3oool005h0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000001D0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool04@3oool01@000000oooo0?oo
o`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000B0?oo
o`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000180oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool00000>@3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000005P3oool01@000000
oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0@
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000001<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000004@3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000g0?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000E0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0140oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000004P3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000B0?ooo`030000003oool0
oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000003@0oooo001O0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000B0?ooo`D000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000001<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000004P3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000B0?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000003X0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo000001<0oooo1@0000020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000004P3oool01@000000oooo0?ooo`3oool000000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`00000C0?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000140oooo00<00000
0?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool00000>03oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000004P3oool500000080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000C0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000180oooo00D000000?ooo`3oool0oooo0000
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004P3oool00`000000
oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000d0?ooo`00H03oool01@000000oooo0?ooo`3oool000000080oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0@0?ooo`040000003oool0oooo000000<0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000C0?ooo`@000000`3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001<0oooo0`0000030?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000004P3oool00`000000oooo0?ooo`020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000k0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0140oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000180oooo100000030?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool00000503oool3000000<0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000A0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003T0oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0403o
ool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000004`3oool4000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000C0?ooo`<000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000180
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000=03oool005d0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004`3oool00`000000
oooo000000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000004`3oool0
0`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
4P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000B0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003P0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000503o
ool00`000000oooo000000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00004P3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000004`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000A0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003H0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000004`3oool00`000000oooo000000030?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000004`3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000004P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000B0?ooo`030000003oool0oooo0080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
03@0oooo001M0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000001@0oooo0P0000030?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool00000503oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000004P3oool01@000000oooo0?ooo`3oool000000080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`00000A0?ooo`800000103oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000>03o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`00000E0?ooo`8000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000001<0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000001<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000403oool2000000@0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003H0oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
503oool2000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000D0?oo
o`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000140oooo0P0000040?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`00000d0?ooo`00GP3oool3000000@0oooo0P00
00040?ooo`8000005P3oool00`000000oooo0?ooo`020?ooo`800000103oool2000001H0oooo0P00
00040?ooo`800000103oool2000001@0oooo0`0000040?ooo`800000103oool2000001<0oooo00<0
00000?ooo`3oool00`3oool2000000@0oooo0P0000040?ooo`800000>P3oool3000000@0oooo0P00
00040?ooo`8000005`3oool00`000000oooo0?ooo`020?ooo`800000103oool2000001D0oooo0P00
00040?ooo`800000103oool2000001D0oooo0`0000040?ooo`800000103oool200000180oooo00<0
00000?ooo`3oool00`3oool2000000@0oooo0P0000040?ooo`800000>03oool3000000@0oooo0P00
00040?ooo`8000005P3oool00`000000oooo0?ooo`020?ooo`800000103oool2000001H0oooo0P00
00040?ooo`800000103oool2000001@0oooo0`0000040?ooo`800000103oool2000001<0oooo00<0
00000?ooo`3oool00`3oool2000000@0oooo0P0000040?ooo`800000=@3oool00?l0ooooo`3ooooW
0?ooo`00o`3ooooo0?ooonL0oooo003o0?ooool0ooooi`3oool004<0oooo1@0000000`00nYX00000
003jVP2Z000002P0oooo100000001000nYX0000000000000nYX20000ojP00000903oool3000000<0
003o00<000000000o`00nYX0Z`00000n0?ooo`00@`3oool00`000000oooo0?ooo`020?ooo`04003j
VP3oool00?ZJ000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool09P3oool01@000000oooo0?ooo`3oool00?ZJ
0080oooo00<00?ZJ0000o`000?l0203oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0R0?ooo`<000000P3o00001P00
0?l0oooo0000o`00nYX0oooo000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0?03oool004<0oooo00<00000
0?ooo`3oool00P3oool00`00nYX0oooo003jVP2Y0?ooo`030000003oool0oooo02H0oooo00D00000
0?ooo`3oool0oooo003jVP020?ooo`03003jVP000?l0003o0:L0oooo00<000000?ooo`3oool08P3o
ool3000000060?ooo`3o0000o`000?ooo`000?l00?ZJZP3oool00`000000oooo0?ooo`0l0?ooo`00
@`3oool00`000000oooo0?ooo`020?ooo`03003jVP3oool00?ZJ0:T0oooo00<000000?ooo`3oool0
9P3oool01@000000oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0000o`000?l0Y`3oool00`000000
oooo0?ooo`0S0?ooo`0500000000nYX0oooo0?ooo`3o00000P3oool00`00nYX0oooo0?ooo`2X0?oo
o`030000003oool0oooo03`0oooo00130?ooo`030000003oool0oooo0080oooo00<00?ZJ0?ooo`00
nYX0Z@3oool00`000000oooo0?ooo`0V0?ooo`8000000P3oool01000nYX0oooo0?ooo`00nYX30000
0:H0oooo00<000000?ooo`3oool08`3oool01@0000000?ZJ003jVP3oool0o`000080oooo00<00?ZJ
0?ooo`3oool0Y`3oool2000003h0oooo00130?ooo`030000003oool0oooo0080oooo00<00?ZJ0?oo
o`00nYX0Z03oool2000002P0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`04003jVP000000
000000000:H0oooo00<000000?ooo`3oool08`3oool020000000oooo003jVP00nYX0oooo0?l0003o
ool00?ZJZP3oool00`000000oooo0?ooo`0l0?ooo`00@`3oool00`000000oooo0?ooo`020?ooo`03
003jVP3oool00?ZJ0:T0oooo00<000000?ooo`3oool09P3oool01@000000oooo0?ooo`3oool00?ZJ
0080oooo00@00?ZJ0000000000000000YP3oool00`000000oooo0?ooo`0S0?ooo`080000003oool0
oooo003jVP3oool0o`000?ooo`00nYZZ0?ooo`030000003oool0oooo03`0oooo00130?ooo`030000
003oool0oooo0080oooo00<00?ZJ0?ooo`00nYX0Z@3oool00`000000oooo0?ooo`0V0?ooo`050000
003oool0oooo0?ooo`00nYX00P3oool00`00nYX0003o0?l0002W0?ooo`030000003oool0oooo02<0
oooo00<000000?ooo`3oool00P00nYX00`3o0000oooo003jVP2Z0?ooo`030000003oool0oooo03`0
oooo00130?ooo`030000003oool0oooo0080oooo00<00?ZJ0?ooo`00nYX0Z@3oool00`000000oooo
0?ooo`0V0?ooo`8000000P3oool01P00nYX0oooo0?ooo`00nYX0003o0?l00:L0oooo00<000000?oo
o`3oool08`3oool200000080oooo00@00?ZJ0?l0003oool00?ZJZ@3oool2000003h0oooo00130?oo
o`030000003oool0oooo0080oooo00<00?ZJ0?ooo`00nYX0Z03oool2000002P0oooo00D000000?oo
o`3oool0oooo003jVP020?ooo`03003jVP000?l0o`000:L0oooo00<000000?ooo`3oool08`3oool0
2@000000oooo0?ooo`3oool00?ZJ0?l0003oool00?ZJ0000o`2Y0?ooo`030000003oool0oooo03`0
oooo00130?ooo`030000003oool0oooo0080oooo00<00?ZJ0?ooo`00nYX0Z@3oool00`000000oooo
0?ooo`0V0?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0003o0?l0002W0?ooo`03
0000003oool0oooo02<0oooo00T000000?ooo`3oool0oooo003jVP3o0000oooo003jVP000?l0Z@3o
ool00`000000oooo0?ooo`0l0?ooo`00@`3oool00`000000oooo0?ooo`020?ooo`03003jVP3oool0
0?ZJ0:T0oooo00<000000?ooo`3oool09P3oool200000080oooo00H00?ZJ0?ooo`3oool00?ZJ0000
o`3o002W0?ooo`030000003oool0oooo02<0oooo0P0000020?ooo`05003jVP3o0000oooo003jVP00
0?l0Z03oool2000003h0oooo00130?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0
oooo0?ooo`2W0?ooo`030000003oool0oooo02H0oooo00D000000?ooo`3oool0oooo003jVP020?oo
o`03003jVP000?l0o`000:L0oooo00<000000?ooo`3oool08`3oool02@000000oooo0?ooo`3oool0
0?ZJ0?l0003oool00?ZJ0000o`2Y0?ooo`030000003oool0oooo03`0oooo00130?ooo`050000003o
ool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`2V0?ooo`800000:03oool01@000000oooo
0?ooo`3oool00?ZJ0080oooo00<00?ZJ0000o`3o0000O03oool20000obT0oooo00<000000?ooo`3o
ool08`3oool02@000000oooo0?ooo`3oool00?ZJ0?l0003oool00?ZJ0000o`2Y0?ooo`030000003o
ool0oooo03`0oooo00130?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?oo
o`2W0?ooo`030000003oool0oooo02H0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`03003j
VP000?l0o`0007`0oooo00<00?ZJ0000o`3oool0:03oool00`000000oooo0?ooo`0S0?ooo`030000
003oool0oooo0080oooo00@0o`000?ooo`00nYX0003oZ@3oool00`000000oooo0?ooo`0l0?ooo`00
@`3oool01@000000oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0?ooo`3oool0Y`3oool00`000000
oooo0?ooo`0V0?ooo`8000000P3oool01P00nYX0oooo0?ooo`00nYX0003o0?l001/0oooo00<0003o
0?ooo`3oool0GP3oool00`00nYX0003o0?ooo`0X0?ooo`030000003oool0oooo02<0oooo0P000003
0?ooo`040?l0003oool00?ZJ0000ojP0oooo0P00000n0?ooo`00@`3oool01@000000oooo0?ooo`3o
ool00?ZJ0080oooo00<00?ZJ0?ooo`3oool0Y`3oool00`000000oooo0?ooo`0H0?ooo`D000000`3o
ool2000000@0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`03003jVP3oool0o`0001/0oooo
00<0003o0?ooo`3oool08`3oool00`000?l0oooo0?ooo`0h0?ooo`03003jVP000?l0oooo02P0oooo
00<000000?ooo`3oool05P3oool3000000@0oooo0P0000040?ooo`030000003oool0oooo0080oooo
00@0o`000?ooo`00nYX0003oZ@3oool00`000000oooo0?ooo`0l0?ooo`00@`3oool01@000000oooo
0?ooo`3oool00?ZJ0080oooo00<00?ZJ0?ooo`00nYX0Y`3oool00`000000oooo0?ooo`0I0?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000000`3oool01@000000oooo0?ooo`3o
ool00?ZJ0080oooo00<00?ZJ0?ooo`3o00006`3oool00`000?l0oooo0?ooo`0S0?ooo`030000o`3o
ool0oooo03L0oooo0P00nYX00`000?l0oooo0?ooo`0W0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool00P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo0080oooo
00@0o`000?ooo`00nYX0003oNP3oool20000obd0oooo00<000000?ooo`3oool0?03oool004<0oooo
00D000000?ooo`3oool0oooo003jVP020?ooo`03003jVP3oool00?ZJ0:H0oooo0P00000D0?ooo`D0
00000`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00D000000?oo
o`3oool0oooo003jVP020?ooo`03003jVP3oool0o`0001/0oooo00<0003o0?ooo`3oool08`3oool0
0`000?l0oooo0?ooo`0g0?ooo`03003jVP3o0000003o02T0oooo00<000000?ooo`3oool05`3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3o
ool01000nYX0o`00003jVP000?mj0?ooo`80003o;@3oool00`000000oooo0?ooo`0l0?ooo`00@`3o
ool01@000000oooo0?ooo`3oool00?ZJ0080oooo0`00002W0?ooo`030000003oool0oooo01/0oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0?ooo`8000000P3oool01P00
nYX0oooo0?ooo`00nYX0oooo0?l001X0oooo0P000?lT0?ooo`<0003o>03oool00`00nYX0o`00003j
VP0X0?ooo`8000006@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo
0`0000020?ooo`04003jVP3o00000?ZJ0000oa80oooo00<00?ZJ0?ooo`3oool0I@3oool20000ob`0
oooo0P00000n0?ooo`00=03oool5000000<0oooo0P0000050?ooo`050000003oool0oooo0?ooo`00
nYX00P3oool300000:L0oooo00<000000?ooo`3oool0603oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000000`3oool01@000000oooo0?ooo`3oool00?ZJ0080oooo00<0
0?ZJ0?ooo`3o00006P3oool00`000?l0oooo0000o`0S0?ooo`030000o`3oool0003o03P0oooo0P3o
00000`00nYX0oooo0?ooo`0W0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool00P3o
ool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo0080oooo00@00?ZJ0?l00000nYX0
003o4P3oool00`00nYX0oooo0?ooo`0Z0?ooo`800?ZJ>@3oool30000ob`0oooo00<000000?ooo`3o
ool0?03oool003D0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?oo
o`050000003oool0oooo0?ooo`00nYX00P3oool300000:L0oooo00<000000?ooo`3oool0603oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3oool010000000oooo
0?ooo`00nYX30?ooo`03003jVP3oool0o`0001X0oooo00<0003o0?ooo`000?l08`3oool00`00nYX0
oooo0000o`0h0?ooo`80o`0000<00?ZJ0?ooo`3oool08`3oool01@000?l0oooo0?ooo`3oool00000
01P0oooo0P0000040?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool0
1000nYX0o`00003jVP000?lA0?ooo`800?ZJ:P3oool300000003003jVP3oool0oooo01H0oooo00<0
003o0?ooo`3oool07P3oool00`000?l0oooo0000o`0/0?ooo`030000003oool0oooo03`0oooo000^
0?ooo`D000000`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000@0oooo0P00
00020?ooo`04003jVP3oool0oooo003jVP80o`00YP3oool2000001/0oooo0`0000040?ooo`800000
103oool2000000030?ooo`00nYX0oooo0080oooo00<00?ZJ0?ooo`3o00006P3oool00`000?l0oooo
0000o`0S0?ooo`03003jVP3oool0003o03P0oooo0P3o00000`00nYX0oooo0?ooo`0S0?ooo`050000
o`3oool0oooo0?ooo`0000006@3oool00`000000oooo0?ooo`030?ooo`800000103oool2000000<0
oooo00@00?ZJ0?l00000nYX0003o4@3oool2003jVRX0oooo0`0000000`00nYX0oooo0?ooo`0E0?oo
o`030000o`00nYX0003o01l0oooo00<0003o0?ooo`000?l0:`3oool2000003h0oooo000g0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo
0?ooo`00nYX00P3oool00`00nYX0o`000?l0001l0?ooo`03003jVP3oool0oooo02P0oooo00<00000
0?ooo`3oool09P3oool010000000oooo0?ooo`00nYX30?ooo`03003jVP3oool0o`0001X0oooo00<0
003o0?ooo`000?l08`3oool2003jVP030000o`3oool0oooo03D0oooo0`0000000`3o0000oooo0?oo
o`0S0?ooo`80003o0P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00@0
0?ZJ0?l00000nYX0003o403oool3003jVRX0oooo0`0000000`000?l00?ZJ0?ooo`0E0?ooo`<00000
7P3oool010000?l0oooo0?ooo`000?l/0?ooo`030000003oool0oooo03`0oooo000d0?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000040?ooo`050000003oool0oooo
0?ooo`00nYX00`3oool20?l007`0oooo00<00?ZJ0?ooo`3oool0:03oool00`000000oooo0?ooo`0V
0?ooo`040000003oool0oooo003jVP<0oooo00<00?ZJ0?ooo`3o00006P3oool00`000?l00?ZJ0000
o`0R0?ooo`04003jVP000?l00?ZJ0000ocL0oooo0`0000000`3o0000oooo0?ooo`0S0?ooo`80003o
0P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00@00?ZJ0?l00000nYX0
003o403oool00`00nYX0oooo003jVP0Z0?ooo`050000o`3o00000?ZJ0?l00000nYX05@3oool01000
0?l0000000000000000N0?ooo`040000o`3oool0oooo0000ob`0oooo00<000000?ooo`3oool0?03o
ool003@0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000000@0oooo
00D000000?ooo`3oool0oooo003jVP030?ooo`80o`0000<0003o0?ooo`3oool0N@3oool00`00nYX0
oooo0?ooo`0X0?ooo`030000003oool0oooo02H0oooo00@000000?ooo`3oool00?ZJ0`3oool00`00
nYX0oooo0?l0000J0?ooo`800?ZJ00<0003o0?ooo`3oool0803oool01000nYX0003o003jVP000?lg
0?ooo`<0000000<0o`000?ooo`3oool08P3oool00`000?l0oooo0000o`020?ooo`030000003oool0
oooo02<0oooo00<000000?ooo`3oool00P3oool01000nYX0o`00003jVP000?l?0?ooo`800?ZJ00<0
oooo003jVP3oool08@3oool00`00nYX0oooo0?ooo`050?ooo`050000o`3o00000?ZJ0?l00000nYX0
5@3oool01@000?l00000000000000000003o01`0oooo0P000?l0103oool0000000000000000[0?oo
o`030000003oool0oooo03`0oooo000e0?ooo`<00000103oool2000000D0oooo00D000000?ooo`3o
ool0oooo003jVP030?ooo`80o`0000<0003o0?ooo`3oool0N03oool00`00nYX0oooo003jVP0Y0?oo
o`030000003oool0oooo02H0oooo0P0000000`3oool00?ZJ0?ooo`020?ooo`03003jVP3oool0o`00
01X0oooo0P00nYX00`000?l0oooo0?ooo`0P0?ooo`04003jVP000?l00?ZJ0000ocP0oooo00<0o`00
003jVP3o0000903oool00`000?l0oooo0000o`020?ooo`030000003oool0oooo02<0oooo0P000003
0?ooo`04003jVP3o00000?ZJ0000o`l0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool20000oaT0oooo
0P00nYX70?ooo`050000o`3o00000?ZJ0?l00000nYX05@3oool01@000?l0oooo0?l0003o0000003o
01`0oooo0P000?l0103oool0000000000000000Z0?ooo`800000?P3oool004<0oooo00D000000?oo
o`3oool0oooo003jVP030?ooo`80o`0000<0003o0?ooo`3oool0N03oool00`00nYX0o`00003jVP0X
0?ooo`800000:03oool010000000oooo0?ooo`00nYX30?ooo`03003jVP3oool0o`0001X0oooo0P00
nYX00`000?l0oooo0?ooo`0P0?ooo`04003jVP000?l00?ZJ0000ob/0oooo00<0003o0?ooo`3oool0
2P3oool00`3o0000oooo0?l0000T0?ooo`030000o`3oool0003o0080oooo00<000000?ooo`3oool0
8`3oool00`000000oooo0?ooo`020?ooo`04003jVP3o00000?ZJ0000o`h0oooo0P00nYX20?ooo`03
003jVP3oool0oooo00<0oooo0`000?lI0?ooo`800?ZJ1P3oool20000o`040?l00000nYX0o`00003j
VQD0oooo00D0003o0?ooo`3o0000o`00003jVP0L0?ooo`030000o`3oool0oooo00<00000603oool3
00000100oooo00<000000?ooo`3oool0?03oool004<0oooo00D000000?ooo`3oool0oooo003jVP03
0?ooo`80o`0000<0003o0?ooo`3oool0N03oool00`00nYX0o`00003jVP0Y0?ooo`030000003oool0
oooo02H0oooo00@000000?ooo`3oool00?ZJ0`3oool00`00nYX0oooo0?l0000H0?ooo`<0000000<0
o`000000o`3oool08@3oool01000nYX0o`000?ooo`00nYX[0?ooo`80003o2`3oool0103o0000oooo
0?l000000?lS0?ooo`030000o`3oool0003o0080oooo00<000000?ooo`3oool08`3oool00`000000
oooo0?ooo`020?ooo`04003jVP3o00000?ZJ0000o`h0oooo00D00?ZJ0?ooo`3oool0oooo003jVP05
0?ooo`030000o`3oool0003o01P0oooo0`00nYX60?ooo`060000o`3oool0o`000?ooo`3o00000?ZJ
5@3oool01@000?l0oooo0?l0003o00000?ZJ01`0oooo00@0003o0?ooo`3oool00?ZJ0P3o000H0?oo
o`<00000403oool00`000000oooo0?ooo`0l0?ooo`00@`3oool01@000000oooo0?ooo`3oool00?ZJ
00<0oooo0P3o00000`000?l0oooo0?ooo`0m0?ooo`03003jVP3oool0oooo03P0oooo00<00?ZJ0?l0
0000nYX0:@3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0oooo003jVP<0oooo00<00?ZJ
0?ooo`3o0000603oool3000000030?l000000?l0oooo0240oooo00@00?ZJ0?l0003o00000?ZJ:`3o
ool20000o`/0oooo00@0o`000?ooo`3o0000003o8`3oool00`000?l0oooo0000o`020?ooo`030000
003oool0oooo02<0oooo00<000000?ooo`3oool00P3oool01000nYX0o`00003jVP000?l=0?ooo`80
0?ZJ0`3oool00`00nYX0oooo0?ooo`020?ooo`050000o`3oool0oooo0?ooo`000?l05`3oool00`00
nYX0oooo003jVP060?ooo`070000o`3oool0o`000?ooo`3o0000003o003jVP0=0?ooo`03003jVP3o
ool0oooo00@0oooo00D0003o0?ooo`3o0000o`00003jVP0K0?ooo`050000o`3oool0oooo0?ooo`00
nYX00P3o000H0?ooo`<00000403oool00`000000oooo0?ooo`0l0?ooo`00@`3oool01@000000oooo
0?ooo`3oool00?ZJ00<0oooo0P3o00000`000?l0oooo0?ooo`0m0?ooo`800?ZJ>@3oool00`3o0000
oooo0?l0000Y0?ooo`030000003oool0oooo02H0oooo0P0000000`3oool00?ZJ0?ooo`020?ooo`04
003jVP3oool0o`000000oaL0oooo0`0000000`3o0000003o0?ooo`0Q0?ooo`04003jVP3o0000o`00
003jVR/0oooo0P000?l;0?ooo`040?l0003oool0o`000000ob<0oooo00<0003o0?ooo`000?l00P3o
ool00`000000oooo0?ooo`0S0?ooo`8000000`3oool01000nYX0o`00003jVP000?l=0?ooo`03003j
VP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool00`000?l0oooo0?ooo`03000001D0oooo
00@00?ZJ0?ooo`3oool00?ZJ1P3oool01`000?l0oooo0?l0003oool00?ZJ0?l00000nYX0303oool2
003jVPD0oooo00<0003o0?ooo`3oool00P3o00000`00nYX0oooo0?ooo`0B0?ooo`800?ZJ1@3oool0
0`000?l0oooo0?ooo`02003jVP80o`00603oool00`000?l0o`000?ooo`090?ooo`030000o`00nYX0
0?ZJ00<0oooo0P00000n0?ooo`00@`3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo0P3o0000
0`000?l0oooo0?ooo`0H0?ooo`80003o8`3oool2003jVST0oooo00<0o`00003jVP3o0000:03oool2
000002P0oooo00@000000?ooo`3oool00?ZJ0`3oool01000nYX0oooo0?l000000?lH0?ooo`040?l0
003oool0o`00003jVR80oooo00@0o`000?ooo`3o00000?ZJ:`3oool20000o`/0oooo00@0o`000?oo
o`3o0000003o8`3oool3003jVP80oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`02
0?ooo`04003jVP3o00000?ZJ0000o``0oooo0P00nYX40?ooo`03003jVP3oool0oooo0080oooo00<0
003o0?ooo`3oool00`00000?0?ooo`03003jVP3oool0oooo00<0oooo00@00?ZJ0?ooo`3oool00?ZJ
1@3oool020000?l0oooo0?ooo`3o0000oooo003jVP3o00000?ZJ303oool2003jVPD0oooo00<0003o
0?ooo`3oool00P3o00000`00nYX0oooo0?ooo`0>0?ooo`80003o00D0oooo003jVP00nYX0oooo003j
VP040?ooo`050000o`3oool0oooo003jVP3oool00P3o000@0?ooo`03003jVP3oool0oooo00D0oooo
00<0003o0?l00000nYX0203oool2003jVP030?ooo`00nYX00?ZJ00<0oooo00<000000?ooo`3oool0
?03oool004<0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`040000o`3o0000o`000000oaX0
oooo00<00?ZJ0000o`3oool08@3oool01000nYX0oooo003jVP000?lh0?ooo`030?l00000nYX0o`00
02T0oooo00<000000?ooo`3oool09P3oool010000000oooo0?ooo`00nYX30?ooo`04003jVP3oool0
o`000000oaP0oooo00@0o`00003jVP3o00000?ZJ8@3oool01@00nYX0o`000?ooo`3o00000?ZJ02X0
oooo00@0003o0?ooo`3oool0003o2@3oool01@000?l0o`000?ooo`3o0000003o02<0oooo00H00?ZJ
0?ooo`00nYX00?ZJ0?ooo`00000U0?ooo`030000003oool0oooo0080oooo00D00?ZJ0?l00000nYX0
oooo0000o`0;0?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool00`000?l0
oooo0?ooo`03000000l0oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ
00D0oooo00P0003o0?ooo`3oool0o`000?ooo`00nYX0o`00003jVP/0oooo0`00nYX50?ooo`060000
o`3oool0oooo0?l00000nYX0o`00403oool20000o`800?ZJ0P3oool2003jVP<0oooo00D0003o0?oo
o`3oool00?ZJ0?ooo`020?l00100oooo00<00?ZJ0?ooo`3oool0103oool20000o`030?l00000nYX0
oooo00L0oooo00D00?ZJ0000o`000?l0oooo003jVP030?ooo`030000003oool0oooo03`0oooo0013
0?ooo`050000003oool0oooo0?ooo`00nYX00P3oool010000?l0o`000?l000000?lI0?ooo`800?ZJ
00<0003o0?ooo`3oool0803oool01000nYX0oooo0000o`00nYXh0?ooo`030?l00000nYX0o`0002T0
oooo00<000000?ooo`3oool09P3oool2000000030?ooo`00nYX0oooo0080oooo00@00?ZJ0?ooo`3o
0000003o0P3oool00`00nYX0oooo0?ooo`0C0?ooo`040?l0003oool0o`00003jVR40oooo00H00?ZJ
0?l0003oool0o`00003jVP000?lY0?ooo`040000o`3oool0oooo0000o`T0oooo00D0003o0?l0003o
ool0o`000000o`0S0?ooo`03003jVP3oool0oooo00800?ZJ00<000000?ooo`3oool08`3oool20000
00<0oooo00D00?ZJ0?l00000nYX0oooo0000o`0:0?ooo`800?ZJ0P000?l30?ooo`03003jVP3oool0
oooo0080oooo00D0003o0?ooo`3oool0oooo0?l0000@0?ooo`04003jVP3oool0oooo0?ooo`800?ZJ
0`3oool00`00nYX0oooo0?ooo`030?ooo`080000o`3oool0oooo0?l0003oool00?ZJ0?l00000nYX;
0?ooo`03003jVP3oool00?ZJ00D0oooo00H0003o0?ooo`3oool0o`00003jVP3o000>0?ooo`03003j
VP3oool0003o00800?ZJ103oool01P00nYX0oooo0?ooo`3oool0003o0?ooo`800?ZJ00<0oooo0?l0
003o00003`3oool2003jVPH0oooo00@0003o003jVP3o00000?ZJ1`3oool01P000?l00?ZJ0?ooo`00
0?l0oooo003jVP80oooo0P00000n0?ooo`00@`3oool01@000000oooo0?ooo`3oool00?ZJ0080oooo
00@0003o0?l0003o0000003o6@3oool2003jVP030000o`3oool0oooo0200oooo00@00?ZJ0?ooo`00
0?l00?ZJ>03oool00`3o00000?ZJ0?l0000U0?ooo`80003o0P3oool00`000000oooo0?ooo`0I0?oo
o`<00000103oool2000000@0oooo00@000000?ooo`3oool00?ZJ0P3oool01@000?l00?ZJ0?ooo`3o
00000?ZJ0080oooo00<00?ZJ0?ooo`3oool04`3oool0103o0000oooo0?l00000nYXQ0?ooo`06003j
VP3o0000oooo0?l00000nYX0003o:@3oool010000?l0oooo0?ooo`000?l2003jVPL0oooo00D0003o
0?l0003oool0o`000000o`0R0?ooo`07003jVP000?l0oooo0?ooo`000?l00?ZJ0000000G0?ooo`D0
00000`3oool2000000@0oooo00<000000?ooo`3oool00P3oool01@00nYX0o`00003jVP3oool0003o
00X0oooo00<00?ZJ0000o`000?l00P000?l20?ooo`05003jVP3oool0oooo0?ooo`000?l0103oool0
0`3o0000oooo0?ooo`0=0?ooo`800?ZJ0`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0
oooo0080oooo00T0003o0?ooo`3oool0oooo0?l0003oool00?ZJ0?l00000nYX0203oool20000o`04
0?ooo`00nYX0oooo003jVPD0oooo00H0003o0?ooo`3oool0o`00003jVP3o000=0?ooo`800?ZJ00@0
oooo0000o`00nYX0003o103oool01`00nYX0oooo0?ooo`3oool0003o0?ooo`00nYX00P3oool20?l0
00l0oooo0P00nYX60?ooo`040000o`00nYX0o`000?l000L0oooo00H00?ZJ0?ooo`3oool0003o0?oo
o`00nYX30?ooo`030000003oool0oooo03`0oooo00130?ooo`050000003oool0oooo0?ooo`00nYX0
0P3oool010000?l0o`000?l000000?lI0?ooo`800?ZJ00<0003o0?ooo`3oool0803oool01000nYX0
oooo0000o`00nYXh0?ooo`030?l000000?l0o`0002D0oooo0P000?l00`3oool000000000000L0?oo
o`030000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00
nYX20?ooo`060000o`00nYX0oooo0?l00000nYX0oooo0P00nYXE0?ooo`040?l0003oool0o`00003j
VR40oooo00H00?ZJ0?l00000nYX0o`00003jVP000?lX0?ooo`80003o1@00nYX70?ooo`050000o`3o
0000oooo0?l000000?l08P3oool01`00nYX0oooo0?ooo`3oool0003o003jVP000000603oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3o
ool01@00nYX0o`000?ooo`00nYX0003o00X0oooo00D00?ZJ0000o`3oool0oooo0?l000020?ooo`05
003jVP3oool0oooo0?ooo`000?l0103oool00`3o0000oooo0?ooo`0=0?ooo`800?ZJ0P3oool2003j
VP@0oooo00<00?ZJ0?ooo`3oool00P3oool02@000?l0oooo0?ooo`3oool0o`000?ooo`00nYX0o`00
003jVP080?ooo`80003o00@00?ZJ0?ooo`3oool00?ZJ103oool01`000?l0oooo0?ooo`3oool0o`00
003jVP3o0000303oool3003jVP040?ooo`00nYX00?ZJ0000o`@0oooo00L00?ZJ0?ooo`3oool0oooo
0000o`3oool00?ZJ0080oooo0P3o000?0?ooo`800?ZJ1P3oool010000?l00?ZJ0?l0003o00070?oo
o`04003jVP3oool0oooo0000o`80oooo00@00?ZJ0?ooo`3oool00000?P3oool004<0oooo00D00000
0?ooo`3oool0oooo003jVP020?ooo`040000o`3o0000o`000000oaT0oooo0P00nYX00`000?l0oooo
0?ooo`0P0?ooo`05003jVP3o0000003o003jVP000?l0:P3oool20000o`/0oooo00<0o`000000o`3o
00009@3oool20000o`80oooo00<000000?ooo`3oool04P3oool5000000<0oooo00<000000?ooo`3o
ool00P3oool010000000oooo0?ooo`0000030?ooo`030000003oool00?ZJ00<0oooo00H0003o003j
VP3oool0o`00003jVP3oool2003jVQD0oooo00@0o`000?ooo`00nYX0o`008@3oool01P00nYX0o`00
003jVP3o00000?ZJ0000oal0oooo0P000?l70?ooo`070000o`00nYX00?ZJ0?ooo`000?l0oooo003j
VP070?ooo`050000o`3o0000oooo0?l000000?l08P3oool01@00nYX0oooo0?ooo`3oool0003o0080
0?ZJ6@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00<000000?oo
o`3oool00P3oool01@00nYX0o`000?ooo`00nYX0003o00T0oooo00<00?ZJ0000o`3oool01@3o0000
1@00nYX0oooo0?ooo`3oool0003o00@0oooo00<0o`00003jVP3oool0303oool00`00nYX0oooo003j
VP020?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool02@000?l0oooo0?oo
o`00nYX0o`000?ooo`00nYX0o`00003jVP080?ooo`80003o00@00?ZJ0?ooo`3oool00?ZJ103oool0
1`000?l0oooo0?ooo`00nYX0o`00003jVP3o00002`3oool2003jVP060?ooo`00nYX0oooo003jVP3o
ool0003o103oool01@00nYX0oooo0?ooo`3oool0003o00800?ZJ00@0oooo0?l0003o0000o`003P3o
ool00`00nYX0oooo003jVP060?ooo`800?ZJ0P3o00060?ooo`<0000000D0o`000?ooo`000?l0oooo
003jVP020?ooo`030000003oool0oooo03`0oooo00130?ooo`050000003oool0oooo0?ooo`00nYX0
0P3oool010000?l0o`000?l00000nYXI0?ooo`80o`0000<00?ZJ0?ooo`3oool0803oool01@00nYX0
o`000?l00000nYX0003o02X0oooo0P000?l;0?ooo`040?l000000?l0o`000000ob@0oooo00D0003o
0?ooo`000?l0oooo0000000L0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
0`3oool20000000:003jVP3oool0oooo0?ooo`000?l00?ZJ0?ooo`3o00000?ZJ0?ooo`800?ZJ503o
ool01@000?l0o`000?ooo`00nYX0o`000240oooo00H00?ZJ0?l00000nYX0o`00003jVP000?lN0?oo
o`<0003o1`3oool01`000?l00?ZJ0?ooo`3oool0003o0?ooo`00nYX01`3oool01@000?l0o`000?oo
o`3o0000003o0280oooo00L00?ZJ0?ooo`3oool0oooo0000o`0000000?ZJ01X0oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo0?ooo`<000000P3oool01@00nYX0o`000?oo
o`00nYX0003o00T0oooo00L00?ZJ0000o`3o0000o`000?ooo`000?l0oooo0080o`000`3oool00`00
0?l0oooo0?ooo`020?ooo`030?l00000nYX0oooo00`0oooo00<00?ZJ0?ooo`3oool00`00nYX00`3o
ool0003o0000o`020?ooo`03003jVP3oool0oooo0080oooo00D0003o0?ooo`3oool00?ZJ0?l00002
0?ooo`030?l00000nYX0oooo00L0oooo00<0003o0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`02
0?ooo`080000o`3oool0oooo003jVP3o0000oooo0?l000000?l90?ooo`800?ZJ0P3oool01@00nYX0
003o003jVP3oool0003o00@0oooo00H00?ZJ0?ooo`3oool0oooo0000o`00nYX20?ooo`030?l00000
nYX0o`0000h0oooo00<00?ZJ0?ooo`00nYX01@3oool00`000?l00?ZJ0?ooo`020?l000H0oooo0`00
00020?l000040000o`3oool00?ZJ0?ooo`800000?P3oool004<0oooo00@000000?ooo`3oool00?ZJ
0`3oool010000?l0o`000?l00000nYXI0?ooo`80o`0000<00?ZJ0000o`3oool0803oool01@00nYX0
o`000?l00000nYX0003o02X0oooo0`000?l:0?ooo`040?l0003oool0o`000000ob<0oooo00H0003o
003jVP3oool0003o0?ooo`00000L0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
00000`3oool00`000000oooo003jVP030?ooo`060000o`00nYX0oooo0?l00000nYX0oooo0P00nYXD
0?ooo`050000o`3o0000oooo003jVP3o00008@3oool01P3o0000oooo003jVP3o0000oooo003jVQd0
oooo0P000?l00`3oool0003o0?ooo`060?ooo`800?ZJ0P3oool00`000?l0oooo003jVP070?ooo`05
0000o`3o0000oooo0?l000000?l08@3oool02000nYX0003o0?ooo`3o0000oooo0000o`3oool00?ZJ
5`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3oool00`00
0000oooo0?ooo`020?ooo`05003jVP3o0000oooo003jVP000?l02@3oool00`00nYX0o`000?l00002
0?ooo`040000o`3oool0oooo0?l000<0oooo00<0003o0?ooo`3oool00P3oool00`3o00000?ZJ0?oo
o`0;0?ooo`04003jVP3oool0oooo0?ooo`800?ZJ0P3oool20000o`80oooo00<00?ZJ0?ooo`3oool0
0P3oool01@000?l0oooo0?ooo`00nYX0o`000080oooo00<0o`00003jVP3oool01P3oool20000o`05
003jVP000?l0oooo0?ooo`3o0000103oool020000?l0oooo0?ooo`00nYX0o`000?ooo`3o00000?ZJ
2@3oool00`00nYX0oooo0?ooo`020?ooo`05003jVP3oool0oooo0?ooo`000?l00`3oool01`00nYX0
oooo0?ooo`000?l0oooo003jVP3oool00P3o00000`00nYX0o`000?ooo`0<0?ooo`800?ZJ00<0oooo
003jVP3oool0103oool00`000?l00?ZJ0?ooo`020?l000H0oooo0`0000001@3oool0o`000000o`3o
ool00?ZJ0080oooo00<000000?ooo`3oool0?03oool004<0oooo00@000000?ooo`3oool00?ZJ0`3o
ool010000?l0o`000?l00000nYXI0?ooo`80o`0000<00?ZJ0000o`3oool0803oool01@00nYX0o`00
0?l00000nYX0003o02X0oooo0`000?l:0?ooo`040?l0003oool0o`000000ob<0oooo1000nYX00`3o
ool000000?ooo`0J0?ooo`800000103oool010000000oooo0?ooo`0000030?ooo`030000003oool0
0?ZJ00<0oooo00<0003o003jVP00nYX00P3o00000`3oool00?ZJ003jVP0D0?ooo`050000o`3o0000
oooo003jVP3o00008@3oool01P3o00000?ZJ0?ooo`3o0000oooo003jVQd0oooo00<0003o003jVP00
nYX01P00nYX00`3oool0003o003jVP030?ooo`030000o`3oool00?ZJ00L0oooo00D0003o0?l0003o
ool0o`000000o`0Q0?ooo`08003jVP3oool0o`000?ooo`3o0000003o0?ooo`00nYXG0?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo
0080oooo00D00?ZJ0?l0003oool00?ZJ0000o`080?ooo`800?ZJ00D0o`000?ooo`3oool0oooo0000
o`020?ooo`050?l0003oool0oooo0?ooo`000?l0103oool20?l000L0oooo0P000?l30?ooo`04003j
VP3oool0oooo0?ooo`800?ZJ00@0oooo0000o`000?l0003o0`3o00040?ooo`050000o`3oool00?ZJ
0?ooo`3o00000P3oool00`3o00000?ZJ0?ooo`060?ooo`050000o`3oool00?ZJ0000o`3oool00P3o
00040?ooo`080000o`3oool00?ZJ003jVP3o0000oooo0?l00000nYX80?ooo`03003jVP3oool0oooo
00<0oooo00D00?ZJ0?ooo`3oool0oooo0000o`030?ooo`0;003jVP3oool0oooo0000o`3oool00?ZJ
0?ooo`3o0000oooo003jVP3o00003@3oool01000nYX0oooo0?ooo`3o00050?ooo`800?ZJ00<0oooo
0?l0003o00001P3oool01`000?l0o`00003jVP3oool0o`000000o`3oool00P00nYX00`3oool00000
0?ooo`0m0?ooo`00@`3oool010000000oooo0?ooo`00nYX30?ooo`040000o`3o0000o`00003jVQP0
oooo00D00?ZJ0?l0003o00000?ZJ0000o`0Q0?ooo`050?l000000?l0o`00003jVP000?l0:P3oool0
0`000?l0oooo0000o`0:0?ooo`040?l0003oool0o`000000ob<0oooo00<00?ZJ0?ooo`3oool00P00
nYX00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`030000003o
ool00?ZJ00<0oooo00<0003o003jVP00nYX00P3o00000`3oool00?ZJ0?l0000D0?ooo`060000o`3o
0000oooo003jVP3o0000003o803oool01P3o00000?ZJ0?ooo`00nYX0o`00003jVQd0oooo0P00nYX2
0?ooo`060000o`3oool0oooo0?ooo`00nYX0oooo0P00nYX30?ooo`030000o`3oool00?ZJ00H0oooo
00H0003o0?ooo`3o0000oooo0?l000000?lQ0?ooo`08003jVP3oool0o`000?ooo`3o0000003o0?oo
o`00nYXH0?ooo`<00000103oool2000000@0oooo00<000000?ooo`3oool00P3oool00`00nYX0o`00
0?ooo`02003jVPP0oooo00<00?ZJ0?l0003oool00`3oool010000?l0oooo0?ooo`3o00030?ooo`03
0000o`3oool0oooo0080oooo0P3o00060?ooo`800?ZJ00@0003o0?ooo`3oool00?ZJ103oool00`00
nYX0oooo0000o`040?l000030?ooo`3o0000oooo00<0oooo00D0003o0?ooo`00nYX0oooo0?l00002
0?ooo`030?l00000nYX0oooo00H0oooo00@0003o0?ooo`00nYX0003o0`3o00040?ooo`080000o`3o
ool00?ZJ0?ooo`3o0000oooo0?l00000nYX70?ooo`03003jVP3oool0oooo00@0oooo00<00?ZJ0?l0
003o00000P3o00030?ooo`06003jVP3oool0oooo0000o`00nYX0oooo0P3o00000`3oool00?ZJ0?l0
000=0?ooo`04003jVP3oool0o`000?l000D0oooo00<00?ZJ0?ooo`3oool00P3o00060?ooo`030000
o`3o00000?ZJ0080oooo00H0o`000?ooo`3oool00?ZJ0?ooo`00000n0?ooo`00@`3oool010000000
oooo0?ooo`00nYX30?ooo`040000o`3o00000?ZJ0?l001P0oooo00D00?ZJ0?l0003o00000?ZJ0000
o`0Q0?ooo`050?l000000?l0o`00003jVP000?l0:P3oool00`000?l0oooo0000o`0:0?ooo`040?l0
003oool0o`000000ob<0oooo00H00?ZJ0?ooo`3oool0003o003jVP00000X0?ooo`80000000D00?ZJ
0?ooo`3oool0oooo0000o`02003jVP80o`0000<0oooo003jVP3o0000503oool01P000?l0o`000?oo
o`3oool0o`000000oal0oooo00L00?ZJ0?l00000nYX0oooo003jVP3o00000?ZJ01d0oooo00D00?ZJ
0?ooo`3oool0oooo0000o`030?ooo`03003jVP3oool00?ZJ00@0oooo00<0003o0?ooo`00nYX01P3o
ool01P000?l0oooo0?l0003oool0o`000000ob40oooo00<00?ZJ0?l0003oool00P3oool00`3o0000
oooo003jVP0U0?ooo`800000103oool0103o0000oooo003jVP00nYX70?ooo`<00000103oool01000
0?l0oooo0?ooo`3o00020?ooo`030000o`3oool0oooo0080oooo00<00?ZJ0?l0003o00001P3oool2
003jVP040000o`3oool00?ZJ003jVP<0oooo00<0o`00003jVP000?l00P3o00001@3oool0003o0?oo
o`3oool0o`0000@0oooo00D0003o0?ooo`00nYX0oooo0?l000020?ooo`03003jVP3o0000oooo00H0
oooo00L0003o003jVP3oool0oooo0?l0003oool0o`0000@0oooo00P0003o0?ooo`00nYX0oooo0?l0
003oool0o`00003jVPH0oooo00<00?ZJ0?ooo`3oool00`3oool3000000040?l0003oool0oooo0?l0
00<0oooo00L00?ZJ0?ooo`3oool0003o003jVP3oool0o`000080oooo00<00?ZJ0?l0003oool0303o
ool01000nYX0oooo0?l0003o00050?ooo`05003jVP3oool0o`00003jVP3o00001P3oool01P000?l0
o`000?ooo`00nYX0oooo0?l00080oooo00<00?ZJ000000000000?P3oool003D0oooo0`0000040?oo
o`8000001@3oool010000000oooo0?ooo`00nYX30?ooo`040000o`3o00000?ZJ0?l001P0oooo00D0
0?ZJ0?l00000nYX0o`000000o`0Q0?ooo`050?l000000?l0o`00003jVP000?l0:@3oool00`000?l0
oooo0?ooo`02003jVPT0oooo00@0o`000?ooo`3o0000003o8P3oool01`00nYX0003o0?ooo`3oool0
003o003jVP000000:03oool00`000000oooo003jVP030?ooo`030000o`00nYX00?ZJ0080o`0000<0
oooo0?l0003o0000503oool01P000?l0o`000?ooo`3oool0o`000000oal0oooo00L00?ZJ0?l00000
nYX0oooo003jVP3o00000?ZJ01/0oooo0`0000030?ooo`070000o`3oool0oooo0?ooo`00nYX0oooo
003jVP040?ooo`030000o`3oool00?ZJ00H0oooo00H0003o0?ooo`3o0000oooo0?l000000?lP0?oo
o`03003jVP000?l0o`0000<0oooo00<0o`000?ooo`00nYX09@3oool00`000000oooo0?ooo`030?oo
o`040?l0003oool00?ZJ003jVPL0oooo0`0000050?ooo`030000o`3oool0o`000080oooo00<0003o
0?ooo`3oool00P3oool00`00nYX0o`000?l000060?ooo`<000000P00nYX30?ooo`80o`0000<00?ZJ
0?l0003o00000P3oool010000?l0oooo0?ooo`3o00030?ooo`060000o`3oool00?ZJ003jVP3oool0
o`000P3oool00`00nYX0o`00003jVP060?ooo`070000o`00nYX0oooo0?ooo`3o0000oooo0?l00004
0?ooo`080000o`00nYX0oooo0?ooo`3o0000oooo0?l00000nYX50?ooo`800?ZJ1@3oool3000000<0
oooo00D0003o0?l0003oool0oooo003jVP020?ooo`040000o`00nYX0oooo0?l00080oooo00<00?ZJ
0?l0003oool02`3oool00`00nYX0oooo0?ooo`020?l000@0oooo00L0003o003jVP3oool0o`00003j
VP3o00000?ZJ00D0oooo00H00?ZJ0?l0003oool00?ZJ0?ooo`3o00020?ooo`03003jVP3oool00000
03h0oooo000f0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000103oool01000
0000oooo0?ooo`00nYX30?ooo`040000o`3o00000?ZJ0?l001P0oooo00D0o`00003jVP00nYX0o`00
0000o`0P0?ooo`06003jVP3o00000?ZJ003jVP3o00000?ZJ:@3oool00`000?l00?ZJ003jVP02003j
VPP0oooo00D00?ZJ0?l0003oool0o`000000o`0R0?ooo`07003jVP000?l0oooo0?ooo`000?l0oooo
003jVP0X0?ooo`030000003oool00?ZJ0080oooo0P3o0002003jVP80o`0000@0oooo0?l0003o0000
0?ZJ3@3oool2003jVP@0oooo00H0003o0?l0003oool0oooo0?l000000?lO0?ooo`07003jVP3o0000
oooo0?ooo`00nYX0o`00003jVP0K0?ooo`<000000`3oool20000o`80oooo0P00nYX00`000?l0oooo
0?ooo`040?l00003003jVP3oool0oooo00@0oooo00H0003o0?ooo`3o0000oooo0?l000000?lP0?oo
o`03003jVP3o0000o`0000<0oooo00<0o`000?ooo`00nYX09@3oool00`000000oooo0?ooo`030?oo
o`040?l0003oool00?ZJ003jVPL0oooo0`000004003jVP040?ooo`000?l0oooo0?l00080oooo00<0
003o0?ooo`3oool00P3oool00`00nYX0o`000?l000060?ooo`<0000000<00?ZJ0?ooo`3oool00P3o
ool3000000050?l0003oool0oooo0?ooo`000?l00P3oool01`3o0000oooo0?ooo`3oool0003o0?oo
o`00nYX00P3oool01P3o0000oooo0?ooo`00nYX0o`00003jVPH0oooo00L0003o003jVP3oool0o`00
0000o`3oool0o`0000<0oooo00<0003o0?ooo`00nYX00P3oool0103o0000oooo0?l00000nYX50?oo
o`03003jVP000?l0003o00@0oooo0`0000030?ooo`060000o`3o0000o`000?ooo`00nYX0oooo0P00
0?l00`00nYX0o`000?ooo`020?ooo`03003jVP3o0000oooo00/0oooo00<00?ZJ0000o`3o00000P3o
00040?ooo`07003jVP3oool0oooo0?l00000nYX0o`00003jVP050?ooo`06003jVP3o0000oooo003j
VP3oool0o`000P3oool3003jVSh0oooo000^0?ooo`D000000`3oool00`000000oooo0?ooo`020?oo
o`040000003oool0oooo000000@0oooo0P0000000`3oool00?ZJ0?ooo`020?ooo`040000o`3o0000
0?ZJ0?l001P0oooo00D0o`00003jVP00nYX0o`000000o`0P0?ooo`06003jVP3o00000?ZJ003jVP3o
00000?ZJ803oool00`000?l0oooo0?ooo`060?ooo`800?ZJ0P3oool00`00nYX0oooo0?ooo`060?oo
o`050?l00000nYX0oooo0?l000000?l08P3oool01`00nYX0003o0?ooo`3oool0003o00000000nYX0
:03oool200000003003jVP3oool0oooo0080o`000P00nYX20?l000060?ooo`3o0000o`00003jVP3o
ool00?ZJ2`3oool2003jVP<0oooo00<0003o0?ooo`3o00000P3oool00`3o0000003o0?ooo`0N0?oo
o`070?l00000nYX0oooo0?ooo`00nYX0o`00003jVP0J0?ooo`040000o`000000000000000080o`00
0P3oool00`000?l0oooo0?ooo`02003jVP030000o`3oool0o`0000<0oooo0P3o00060?ooo`060000
o`00nYX0o`000?ooo`3o00000?ZJ803oool00`00nYX0o`000?ooo`030?ooo`80o`0000<00?ZJ0?oo
o`3oool08`3oool2000000@0oooo00@00?ZJ0?l00000nYX00?ZJ203oool00`3o0000oooo0?ooo`02
0?ooo`800?ZJ00<0003o0?ooo`3o00000P3oool010000?l0oooo0?ooo`3oool2003jVP80o`001@3o
ool01@00nYX00000000000000000003o00<0oooo00@0o`000000000000000000103oool20000o`03
0?ooo`3o0000oooo0080oooo00@0003o0?ooo`00nYX0oooo0P3o00020?ooo`03003jVP3o00000?ZJ
00H0oooo00L00?ZJ0?ooo`3oool0o`000000o`3oool0o`000080oooo0P000?l0203oool00?ZJ0?oo
o`3o00000?ZJ0?ooo`3o00000?ZJ1@3oool00`00nYX0003o0000o`050?ooo`030?l00000nYX00?ZJ
0080oooo00X0003o0?ooo`3o0000oooo003jVP3oool0003o003jVP3oool0o`000P3oool2003jVP03
0?l0003oool0oooo00X0oooo00D00?ZJ0000o`3o0000oooo0?l000040?ooo`07003jVP3oool0o`00
0?ooo`00nYX0o`00003jVP040?ooo`030000o`00nYX0o`000080oooo00<00?ZJ0?l0003oool00P3o
ool00`0000000?ZJ0?ooo`0m0?ooo`00=P3oool00`000000oooo0?ooo`020?ooo`040000003oool0
oooo000000@0oooo00@000000?ooo`3oool00?ZJ0`3oool010000?l0o`000?ooo`3o000H0?ooo`05
0?l00000nYX00?ZJ0?l000000?l0803oool01P00nYX0o`00003jVP00nYX0o`00003jVQl0oooo0P00
0?l80?ooo`05003jVP3oool0oooo0?ooo`00nYX0203oool01@3o00000?ZJ0?ooo`3o0000003o0280
oooo00L00?ZJ0000o`3oool0oooo0000o`3oool00?ZJ02P0oooo00L000000?ooo`00nYX0oooo0?l0
003oool0o`0000800?ZJ0P3o00001@3oool0o`000?l00000nYX0oooo00800?ZJ2P3oool2003jVP80
oooo0P000?l01P3oool0o`000?ooo`3oool0o`00003jVQl0oooo00L0o`00003jVP3oool0oooo003j
VP3o00000?ZJ01T0oooo00H00?ZJ0000o`3oool0o`00003jVP3oool30?l000030000o`3oool0oooo
00800?ZJ00<0003o0?l0003oool00`3oool00`000?l0o`000?ooo`050?ooo`060000o`00nYX0o`00
0?ooo`3o00000?ZJ803oool02@00nYX0o`000?ooo`3oool00?ZJ0?ooo`000?l0o`00003jVP0U0?oo
o`030000003oool0oooo00<0oooo00@00?ZJ0?l00000nYX00?ZJ203oool00`3o0000oooo0?ooo`03
0?ooo`04003jVP000?l0oooo0?l00080oooo00H0003o0?ooo`3oool0oooo003jVP3oool20?l000D0
oooo00D00?ZJ0000o`3o0000o`000000o`030?ooo`040?l0000000000000000000@0oooo0P000?l0
0`3oool0o`000?ooo`020?ooo`060000o`00nYX00?ZJ0?ooo`3o00000?ZJ0P3oool00`00nYX0o`00
003jVP050?ooo`030000o`00nYX0oooo0080o`0000<0003o0?ooo`3o00000P3oool02P000?l0oooo
0?ooo`00nYX0oooo0?l00000nYX0oooo0?l00000nYX40?ooo`<0000000@0o`000?ooo`3oool0oooo
0`3o00001P00nYX0oooo003jVP3oool0003o0?ooo`80o`0000L00?ZJ0?ooo`000?l00?ZJ0?ooo`3o
0000oooo00800?ZJ00<0oooo0?l000000?l01P3oool02P00nYX0oooo0?ooo`3oool00?ZJ0000o`3o
ool0o`000?ooo`3o00040?ooo`07003jVP3oool0o`000?ooo`00nYX0o`00003jVP040?ooo`030000
o`00nYX0o`000080oooo00<00?ZJ0000o`3o00000`3oool00`00nYX0oooo0?ooo`0l0?ooo`00=P3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000@0oooo00@000000?ooo`3oool0
0?ZJ0`3oool010000?l0o`000?ooo`3o000H0?ooo`050?l000000?l00?ZJ0?l000000?l0803oool0
1P00nYX0o`00003jVP00nYX0o`00003jVQh0oooo10000?l70?ooo`05003jVP3oool0oooo0?ooo`00
nYX01`3oool3000000030?ooo`3o00000?ZJ0280oooo00<00?ZJ0000o`3o00000P3oool00`000?l0
0?ZJ0?ooo`0W0?ooo`070000003oool00?ZJ0?ooo`3o0000003o0?l00002003jVP80o`0000D0oooo
0?l0003o00000?ZJ0?ooo`02003jVPT0oooo00<00?ZJ0?ooo`00nYX00P3oool010000?l0oooo0?oo
o`3o00020?ooo`030?l00000nYX0oooo01d0oooo0`0000020?ooo`03003jVP3o00000?ZJ01T0oooo
0P00nYX00`3oool0o`00003jVP030?ooo`80o`000P3oool01000nYX0oooo0?l0003o00040?ooo`03
0000o`3o0000oooo00D0oooo0P00nYX0103o0000oooo0?l00000nYXF0?ooo`03003jVP3oool0oooo
0080oooo0P00nYX30?ooo`030?l0003oool0oooo00<00?ZJ00<0003o0?l00000nYX09@3oool00`00
0000oooo0?ooo`030?ooo`04003jVP3o00000?ZJ003jVPL0oooo00<0003o0?l0003oool0103oool2
003jVP050?ooo`3o0000oooo0?ooo`000?l00`3oool01000nYX0oooo0?l0003o00040?ooo`800?ZJ
00@0003o0?l0003o0000003o0P3oool20?l000040?ooo`000?l00?ZJ003jVP@0oooo00<0003o0?oo
o`3o00000`3oool01P000?l00?ZJ0?ooo`3oool0o`00003jVP80oooo00<00?ZJ0?l00000nYX01@3o
ool020000?l00?ZJ0?ooo`3o0000oooo0000o`3oool0o`000P3oool00`000?l0oooo003jVP020?oo
o`050?l00000nYX0oooo0?l00000nYX0103oool3000000D0o`0000@0oooo0000o`00nYX0oooo0P00
nYX02@3oool0003o0?ooo`3o00000?ZJ0?ooo`000?l00?ZJ0?l000020?ooo`05003jVP3oool0oooo
0?l000000?l01P3oool02P00nYX0oooo0?ooo`000?l00?ZJ0000o`3o0000003o0?ooo`3o00030?oo
o`080000o`00nYX0o`000?l0003oool00?ZJ0?l00000nYX40?ooo`03003jVP3oool0o`000080oooo
00<00?ZJ0000o`3o00000`3oool00`00nYX0oooo0?ooo`0l0?ooo`00=@3oool2000000@0oooo00@0
00000?ooo`3oool00000103oool010000000oooo0?ooo`00nYX30?ooo`040000o`3o0000oooo0?l0
01P0oooo00D0o`000?ooo`00nYX0o`000000o`0P0?ooo`06003jVP3o00000?ZJ003jVP3o00000?ZJ
7P3oool00`000?l00?ZJ003jVP05003jVP80oooo00<00?ZJ0000o`3oool00P3oool00`00nYX0oooo
0?ooo`050?ooo`<0000000<0oooo0?l00000nYX08@3oool00`00nYX0003o0?l000020?l000030?oo
o`000?l00?ZJ02P0oooo00L00000003jVP3oool0oooo0?l000000?l0o`0000800?ZJ0P3o00001@3o
ool0o`000?l00000nYX0oooo00<00?ZJ203oool01@00nYX0o`000?l00000nYX0003o00<0oooo00D0
o`000?ooo`3oool0o`00003jVP0N0?ooo`<000000P3oool00`00nYX0o`00003jVP0<0?ooo`<00?ZJ
103oool00`00nYX0oooo0?ooo`020?ooo`06003jVP3oool00?ZJ003jVP3o00000?ZJ103oool20?l0
00<0000000<0o`000?ooo`3oool00`3oool00`000?l0o`000?ooo`040?ooo`070000o`00nYX0oooo
0?l0003oool0o`00003jVP0F0?ooo`03003jVP3oool0oooo0080oooo0`00nYX300000080oooo00@0
0?ZJ0?ooo`00nYX0oooo0P3o000U0?ooo`030000003oool0oooo00<0oooo00@00?ZJ0?l00000nYX0
0?ZJ1`3oool00`000?l0o`000?ooo`050?ooo`03003jVP3oool0o`000080oooo00<0003o0?ooo`3o
ool00P00nYX0103oool0o`000?l00000nYX30?ooo`03003jVP000?l0oooo0080o`0000@0003o0?oo
o`3oool0o`000P3oool00`000?l00?ZJ003jVP02003jVP80oooo00<0003o0?ooo`3o00000`3oool0
1P000?l00?ZJ0?ooo`3o0000oooo003jVP80oooo00<00?ZJ0?l00000nYX00`3oool01000nYX0003o
003jVP00nYX20?l000040?ooo`000?l00?ZJ0?l00080oooo00X0003o0?ooo`00nYX0oooo0?l0003o
ool00?ZJ0?ooo`00nYX0o`00103oool3000000030000o`3oool0oooo00<0oooo00P0003o003jVP3o
ool0oooo003jVP3oool0003o0?ooo`80o`0000D00?ZJ0000o`00nYX0o`000?ooo`02003jVP80oooo
00<0o`000000o`3oool0103oool2003jVP80oooo00L0003o003jVP000?l0o`000000o`3oool0o`00
00<0oooo00<0003o003jVP3o00000P3oool2003jVP030?l0003oool0oooo0080oooo00<00?ZJ0?oo
o`3o00000P3oool00`00nYX0003o0?l000030?ooo`03003jVP3oool0oooo03`0oooo000f0?ooo`03
0000003oool0oooo00<0oooo0P0000050?ooo`040000003oool0oooo003jVP<0oooo00@0003o0?l0
003oool0o`00603oool01@3o0000oooo0?ooo`3o0000003o0200oooo00H0o`00003jVP3oool00?ZJ
0?l00000nYXN0?ooo`04003jVP3oool0oooo0000o`<0oooo00D00?ZJ0?ooo`3oool00?ZJ0000o`03
0?ooo`030000o`00nYX0oooo00D0oooo0`000000103oool0o`00003jVP000?lP0?ooo`04003jVP00
0?l0o`000?ooo`80o`0000<0003o003jVP3oool09`3oool01`0000000?ZJ0?ooo`3oool0o`000000
o`3o00000P00nYX20?l000080?ooo`3o0000o`00003jVP3oool00?ZJ0?ooo`00nYX80?ooo`05003j
VP3o0000o`00003jVP000?l00`3oool01@3o0000oooo0?ooo`3o00000?ZJ01P0oooo0P00nYX40?oo
o`<000000P3oool00`00nYX0o`00003jVP0<0?ooo`04003jVP3oool00?ZJ003jVP80oooo0P00nYX4
0?ooo`05003jVP3oool0003o003jVP3o00000P00nYX40?ooo`040000o`0000000000000000H0oooo
00<0003o0?l0003oool0103oool2003jVP050?ooo`3o0000oooo0?l00000nYX03@3oool00`00nYX0
oooo0?ooo`050?ooo`800?ZJ103oool00`00nYX0oooo003jVP03000000080?ooo`00nYX00?ZJ0?oo
o`00nYX0oooo0000o`3o000U0?ooo`800000103oool01000nYX0o`00003jVP00nYX70?ooo`030000
o`3o0000oooo00D0oooo00<00?ZJ0?ooo`3o00000P3oool010000?l0oooo0?ooo`00nYX20?ooo`80
o`0000/00?ZJ0?ooo`3oool0oooo003jVP000?l0oooo0?l0003oool0o`000?ooo`020?l00080oooo
00<00?ZJ0?ooo`3oool00P3oool2003jVP030000o`3oool0o`0000<0oooo00H0003o003jVP3oool0
o`000?ooo`00nYX20?ooo`03003jVP3o00000?ZJ00<0oooo00D00?ZJ0000o`00nYX0oooo0?l00002
0?ooo`800?ZJ00d0o`000?ooo`3oool0003o0?ooo`00nYX0oooo0?l0003oool00?ZJ0?ooo`00nYX0
o`0000@0oooo00D00?ZJ0?l00000nYX0oooo0000o`030?ooo`80003o00<00?ZJ0?ooo`3oool00P00
nYX010000?l0oooo0?ooo`3o0002003jVP040?ooo`3o0000oooo003jVP<0oooo00<0o`00003jVP3o
ool00`3oool00`000?l00?ZJ003jVP020?ooo`070000o`00nYX0oooo0?l0003oool00?ZJ0?l00003
0?ooo`03003jVP3oool0o`000080oooo0P00nYX00`3o0000oooo0?ooo`020?ooo`03003jVP3oool0
o`000080oooo00<00?ZJ0?ooo`3o00000P3oool00`0000000?ZJ0?ooo`0m0?ooo`00@`3oool01000
0000oooo0?ooo`00nYX30?ooo`040000o`3o0000oooo0?l001P0oooo00D0o`000?ooo`3oool0o`00
0000o`0P0?ooo`060?l00000nYX0oooo003jVP3o00000?ZJ7@3oool2003jVP<0oooo00D0003o0?oo
o`3oool00?ZJ0?ooo`02003jVP@0oooo00<0003o003jVP3oool01P3oool01P3o0000oooo0?ooo`3o
00000?ZJ0000ob00oooo00<00?ZJ0000o`3o00000P3oool00`3o0000003o003jVP0X0?ooo`030000
0000nYX0oooo0080o`0000@0003o0?l00000nYX00?ZJ0P3o0000203oool0o`000?l00000nYX0oooo
003jVP3oool00?ZJ1P3oool3003jVP80o`0000<00?ZJ0?ooo`3oool00P3oool01@3o0000oooo0?oo
o`3o00000?ZJ01P0oooo1`00nYX0203o0000oooo0?ooo`3oool00?ZJ0?l000000?l00?ZJ2@3oool0
0`00nYX0oooo003jVP020?ooo`D00?ZJ103oool01P00nYX0oooo0000o`00nYX0o`000?ooo`800?ZJ
0`3oool010000?l000000000000000060?ooo`030000o`3o0000oooo00<0oooo0P00nYX20?ooo`04
0?l0003oool0o`00003jVPd0oooo00<00?ZJ0?ooo`3oool00`3oool4003jVP@0oooo00<00?ZJ0000
o`000?l00`000002003jVP80oooo00@00?ZJ0?ooo`000?l0o`009@3oool00`000000oooo0?ooo`03
0?ooo`04003jVP3o00000?ZJ003jVPL0oooo00<0003o0?l0003oool01@3oool00`00nYX0oooo0?l0
00020?ooo`040000o`3oool0oooo003jVP80oooo0P3o00001@00nYX0oooo0?ooo`3oool00?ZJ0080
oooo00<0o`00003jVP3o00000P3o00030?ooo`03003jVP3oool0oooo00<0oooo00@00?ZJ0000o`3o
ool0o`000`3oool01P00nYX0oooo0?ooo`3o0000oooo003jVP80oooo00<00?ZJ0?l00000nYX00`3o
ool01@00nYX0003o003jVP3oool0o`000080oooo00<00?ZJ0?ooo`3o00000P3oool02P000?l0oooo
003jVP3oool0o`000?ooo`00nYX0oooo003jVP3o00040?ooo`05003jVP3o00000?ZJ0?ooo`000?l0
0`3oool00`000?l0oooo003jVP030?ooo`05003jVP000?l0oooo0?ooo`3o00000P00nYX20?l00080
0?ZJ0`3oool00`3o00000?ZJ0?ooo`030?ooo`030000o`00nYX00?ZJ0080oooo00<00?ZJ0?ooo`3o
00000P3oool00`00nYX0o`000?ooo`020?ooo`08003jVP3oool0o`000?ooo`00nYX0oooo003jVP3o
00040?ooo`03003jVP3oool0o`0000<0oooo00<00?ZJ0?l0003oool00P3oool00`00nYX0oooo0?oo
o`0l0?ooo`00@`3oool010000000oooo0?ooo`00nYX20?ooo`050000o`3oool0o`000?ooo`3o0000
603oool01P3o0000oooo0?ooo`3o00000?ZJ0000oah0oooo00L00?ZJ0?l00000nYX0oooo003jVP3o
00000?ZJ01d0oooo00<00?ZJ0000o`3oool00P3oool01`000?l0oooo0?ooo`00nYX0oooo003jVP00
0?l0103oool00`000?l00?ZJ0?ooo`060?ooo`060?l0003oool0oooo0?l00000nYX0003o803oool0
0`00nYX0o`000?l000020?ooo`030?l000000?l00?ZJ02P0oooo00@00000003jVP3oool0o`000P00
0?l00`3o00000?ZJ003jVP020?l000030?ooo`3o0000o`0000800?ZJ0P3oool00`00nYX0oooo0?oo
o`030?ooo`06003jVP3oool00?ZJ0?l000000?l0o`000P00nYX30?ooo`050?l0003oool0oooo0?l0
0000nYX05`3oool2003jVP<0oooo0P000?l00`3oool0o`000?ooo`020?ooo`04003jVP3o0000003o
003jVPP0oooo0P00nYX00`3oool00?ZJ0?ooo`050?ooo`03003jVP3oool0oooo0080oooo00D00?ZJ
0000o`3oool0oooo0?l000020?ooo`04003jVP3oool0oooo0?ooo`80003o0P00nYX40?ooo`04003j
VP3oool0003o0?l000<0oooo0P00nYX01`000?l0oooo0?ooo`3o0000oooo003jVP3o00000`3oool3
003jVPH0oooo0P00nYX30?ooo`<00?ZJ0P3oool01P00nYX0oooo0?ooo`3oool00?ZJ0?ooo`<0003o
00<0o`00003jVP3oool0103oool00`00nYX0003o0?l0000U0?ooo`030000003oool0oooo00<0oooo
00@00?ZJ0?l00000nYX00?ZJ1`3oool00`000?l0o`000?ooo`050?ooo`050000o`00nYX0o`000?oo
o`000?l00`3oool00`00nYX0oooo0?l000020?l00007003jVP3oool0oooo003jVP000?l0oooo0?l0
0002003jVP030?ooo`000?l0oooo00<0oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?l0
00020?ooo`040000o`00nYX0oooo0?l00080oooo00H00?ZJ0?ooo`3oool00?ZJ0?l00000nYX20?oo
o`<00?ZJ00@0oooo0?l0003o0000oooo0P00nYX0203oool0o`000?ooo`3oool0003o003jVP3oool0
o`000P3oool01000nYX0oooo003jVP3o00030?ooo`03003jVP000?l0o`0000800?ZJ00H0003o0?oo
o`3oool0oooo0000o`00nYX40?ooo`05003jVP000?l0oooo0?ooo`3o00000P00nYX00`3o0000oooo
003jVP040?ooo`030?l00000nYX0oooo00<0oooo00P0003o00000000000000000000o`00nYX0oooo
0?l00080oooo00<00?ZJ0?l0003oool00P3oool02000nYX0o`000?ooo`3oool00?ZJ0?ooo`00nYX0
o`000`3oool01000nYX0oooo0?l00000nYX30?ooo`03003jVP000?l0o`0000<00000?P3oool004<0
oooo00@000000?ooo`3oool00?ZJ0P3oool01@000?l0oooo0?l0003oool0o`0001L0oooo0`000000
103oool0o`00003jVP000?lN0?ooo`07003jVP3o00000?ZJ0?ooo`00nYX0o`00003jVP0M0?ooo`03
003jVP3oool0oooo0080oooo00L0003o0?ooo`3oool00?ZJ0?ooo`00nYX0003o0080oooo0P3o0000
0`000?l00?ZJ0?ooo`060?ooo`060?l0003oool0oooo0?l00000nYX0003o7`3oool00`00nYX0003o
0?l000030?ooo`030?l000000?l00?ZJ02P0oooo00@00000003jVP3oool0o`000P000?l00`3o0000
0?ZJ003jVP020?l000050?ooo`3o00000?ZJ0?l00000nYX00P3oool00`00nYX0oooo0?ooo`020?oo
o`08003jVP3oool0oooo003jVP3o00000?ZJ0000o`3o0004003jVP060?l0003oool0oooo003jVP3o
00000?ZJ0P3oool2003jVPL0oooo0P00nYX90?ooo`03003jVP3oool0oooo0080oooo00@0003o0?oo
o`3oool0o`00103oool00`00nYX0o`00003jVP070?ooo`<00?ZJ00<0oooo0?l0003o00001@3oool0
0`00nYX0oooo0?ooo`020?ooo`05003jVP000?l0oooo0?ooo`3o00000`3oool00`00nYX0oooo0?oo
o`020?ooo`P00?ZJ00@0oooo0?l0003oool0oooo0P00nYX20000o`80oooo00@0o`000?ooo`00nYX0
o`000P3oool2003jVP030?ooo`00nYX0oooo00<0oooo0P00nYX00`3oool00?ZJ0?ooo`020?ooo`03
003jVP3oool0oooo0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP020000o`030?ooo`000?l0o`00
00H0oooo00<00?ZJ0000o`3o00009@3oool00`000000oooo0?ooo`030?ooo`04003jVP3o00000?ZJ
003jVPL0oooo00<0003o0?l0003oool01@3oool01@000?l00?ZJ0?l0003oool0003o0080oooo00L0
0?ZJ0?ooo`3oool0o`00003jVP3o00000?ZJ0080oooo00@00?ZJ0000o`3oool0o`000P00nYX00`3o
ool0003o0?ooo`020?ooo`800?ZJ1P3oool2003jVP070?l0003oool0oooo0000o`00nYX0oooo0?l0
00020?ooo`06003jVP3oool0oooo003jVP3o00000?ZJ0P3oool3003jVP080?ooo`3o0000oooo0?oo
o`00nYX0003o0?ooo`3o00020?ooo`040000o`00nYX0oooo0?l00080oooo00@00?ZJ0?ooo`00nYX0
o`000`3oool01P00nYX0003o0?l0003oool00?ZJ0000o`<0oooo00<0003o003jVP3oool00`3oool0
1@00nYX0003o0?ooo`3oool0o`0000800?ZJ00<0o`000?ooo`00nYX0103oool00`3o00000?ZJ0?oo
o`030?ooo`04003jVP0000000000000000800?ZJ00H0oooo0?l0003oool00?ZJ0000o`3o00020?oo
o`800?ZJ00L0o`000?ooo`00nYX00?ZJ0?ooo`00nYX0o`0000<0oooo00@00?ZJ0?ooo`3o00000?ZJ
0`3oool00`00nYX0003o0?l00003000003h0oooo00130?ooo`030000003oool00?ZJ00<0oooo00D0
003o0?ooo`3o0000oooo0?l000020?ooo`03003jVP3oool0oooo0180oooo0`000000103oool0o`00
003jVP000?lN0?ooo`03003jVP3o00000?ZJ0080oooo00<0o`00003jVP000?l0703oool00`00nYX0
oooo0?ooo`020?ooo`030000o`3oool0oooo00800?ZJ00<0003o0?ooo`3oool00P3o0003000000L0
oooo00H0o`000?ooo`3oool00?ZJ0?l000000?lO0?ooo`03003jVP000?l0o`0000@0oooo00<0o`00
003jVP3oool09`3oool01`00nYX0003o0?l0003o0000003o0?ooo`3o00000P00nYX20?l000050?oo
o`3o00000?ZJ0?l00000nYX00P3o00000`00nYX0oooo0?ooo`02003jVP<0oooo00D00?ZJ0?l00000
nYX00?ZJ0?l000040?ooo`070?l0003oool0oooo003jVP3o00000?ZJ0?ooo`03003jVPH0oooo0`00
nYX90?ooo`03003jVP3oool0003o0080oooo00@0003o0?ooo`3oool0o`00103oool00`00nYX0o`00
003jVP02003jVP@0oooo0P00nYX01P3oool00?ZJ0?ooo`3o0000oooo0?l000@0oooo00<00?ZJ0?oo
o`3oool00P3oool00`00nYX0o`000?l000020?l000<0oooo0P00nYX30?ooo`03003jVP3oool0oooo
00@0oooo0P00nYX0103o0000oooo003jVP00nYX30000o`80oooo00@0o`000?ooo`00nYX0o`000P3o
ool01000nYX0oooo0?ooo`00nYX30?ooo`800?ZJ0P3oool01000nYX0oooo0?ooo`00nYX50?ooo`05
003jVP3oool0oooo0?ooo`00nYX00`3o00000`3oool0o`000?ooo`050?ooo`03003jVP000?l0o`00
02D0oooo0P0000040?ooo`04003jVP3o00000?ZJ003jVPL0oooo00<0003o0?l0003oool01@3oool0
1@000?l00?ZJ0?l0003oool0003o0080oooo00@00?ZJ0?ooo`3oool0o`000P00nYX01`3o0000oooo
0?ooo`00nYX0003o0?ooo`3o00000`00nYX01@000?l0oooo0?ooo`3oool00?ZJ00L0oooo00<0003o
003jVP3o00000P3oool01@000?l00?ZJ0?l0003o0000oooo00800?ZJ0P3oool00`00nYX0o`00003j
VP020?ooo`<00?ZJ0P3o00001P3oool00?ZJ003jVP3oool0003o0?l00080oooo00D0003o003jVP3o
ool0o`000?ooo`02003jVP040?ooo`00nYX0o`00003jVP80oooo00@00?ZJ0000o`3o0000oooo0P00
nYX30?ooo`030000o`00nYX0oooo00<0oooo0P00nYX20?ooo`040?l00000nYX00?ZJ0?l000800?ZJ
103oool00`3o00000?ZJ0?ooo`030?ooo`07003jVP000000000000000000nYX0oooo0?l000020?oo
o`03003jVP3oool0o`000080oooo00D00?ZJ0?ooo`3o0000oooo003jVP020?ooo`03003jVP3o0000
oooo0080oooo00@00?ZJ0?ooo`3o00000?ZJ0`3oool00`00nYX0003o0?l00003000003h0oooo0013
0?ooo`030000003oool00?ZJ00<0oooo00D0003o0?ooo`3o0000oooo0?l000020?ooo`03003jVP3o
ool0oooo0180oooo0`000000103oool0o`00003jVP000?lN0?ooo`03003jVP3o00000?ZJ0080oooo
00<0o`00003jVP000?l0703oool00`00nYX0o`000?l000020?ooo`030000o`3oool0oooo00800?ZJ
00<0003o0?ooo`3o00000P3oool3000000L0oooo00H0o`000?ooo`3oool00?ZJ0?l000000?lO0?oo
o`03003jVP3o0000o`0000@0oooo00<0o`00003jVP3oool08@3oool2000000@0oooo00<00?ZJ0000
o`3o00000P000?l0103oool0o`00003jVP00nYX20?l000050?ooo`3o00000?ZJ0?l00000nYX00P3o
00001000nYX0oooo003jVP00nYX40?ooo`05003jVP3o0000oooo003jVP3o0000103oool01@3o0000
oooo0?ooo`00nYX0o`0000<00?ZJ00<0oooo003jVP3oool0103oool2003jVP030?ooo`00nYX0oooo
00P0oooo00D00?ZJ0?l0003o0000o`000000o`030?ooo`030?l0003oool0oooo0080oooo00D00?ZJ
0?l0003oool0oooo003jVP030?ooo`800?ZJ0P3oool2003jVP040?l000000?l0oooo0?l000<0oooo
00<00?ZJ0?ooo`3oool00P3oool00`00nYX0o`000?ooo`020?l000@0oooo0P00nYX20?ooo`03003j
VP3oool0oooo00D0oooo0`0000000`3oool0003o0000o`040?ooo`040?l0003oool00?ZJ0?l00080
oooo00@00?ZJ0?ooo`3oool00?ZJ0`3oool01@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ
0?ooo`3oool00`3oool01`00nYX0oooo0?ooo`3oool00?ZJ0?l0003oool00`3o00060?ooo`03003j
VP000?l0o`0001P0oooo0`0000040?ooo`800000103oool00`000000oooo0?ooo`030?ooo`04003j
VP3o00000?ZJ003jVPL0oooo00<0003o0?l0003oool01@3oool01@000?l00?ZJ0?l0003oool0003o
0080oooo00@00?ZJ0?ooo`3o0000o`000P00nYX02`3o0000oooo0?ooo`00nYX0003o0?l0003oool0
0?ZJ0?ooo`00nYX0003o0080oooo0P00nYX80?ooo`040000o`3o0000oooo0?ooo`800?ZJ00@0o`00
0?ooo`3oool00?ZJ103oool00`3o00000?ZJ0?ooo`03003jVP050000o`3o0000oooo0?ooo`00nYX0
0P3oool01`000?l0o`000?ooo`000?l0oooo003jVP3o00000P3oool01P00nYX0oooo0?ooo`00nYX0
o`00003jVP80oooo00<00?ZJ0000o`3o00000P3oool01P00nYX0oooo0?ooo`3oool0003o003jVPD0
oooo00P00?ZJ0?ooo`3oool0o`00003jVP3o0000oooo003jVPD0oooo00<00?ZJ0?l0003oool00P3o
ool00`000?l00?ZJ0?ooo`020?l000040000o`3oool0o`000?ooo`800?ZJ00T0oooo0?l0003oool0
oooo003jVP3oool0o`000?ooo`00nYX00`3oool0203o0000oooo0?ooo`3oool00?ZJ0?ooo`3o0000
0?ZJ0`3oool01P00nYX0003o0?l0003o0000oooo0?l003h0oooo00130?ooo`030000003oool00?ZJ
00<0oooo00D0003o0?ooo`3o0000oooo0?l000020?ooo`800?ZJ4`3oool01`000?l0o`000?ooo`3o
ool0o`00003jVP000?l07P3oool00`3o00000?ZJ0?ooo`020?ooo`030?l00000nYX0003o01/0oooo
00@00?ZJ0?l0003oool0oooo0P3o00020000o`040?ooo`00nYX00?ZJ0000o`80o`000P3oool30000
00H0oooo00L0003o0?l0003oool0oooo003jVP3o0000003o01l0oooo00@00?ZJ0?l0003oool0oooo
0P00nYX00`3oool0o`00003jVP0Q0?ooo`040000003oool0oooo00000080oooo0`0000001@000?l0
oooo0?ooo`3oool0o`0000800?ZJ0P3o00001@3oool0o`00003jVP3o00000?ZJ0080o`000`00nYX5
0?ooo`04003jVP3o0000oooo003jVP80o`000`3oool01@3o0000oooo0?ooo`00nYX0o`0000@0oooo
00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo1@00nYX00`3o0000
003o0?l000050?l000@0oooo00D00?ZJ0?l0003oool0oooo003jVP020?ooo`03003jVP3oool0oooo
0080oooo0P00nYX00`3o0000003o0?ooo`050?l000@0oooo00D00?ZJ0?l0003oool0oooo0?l00005
0?ooo`800?ZJ00<0oooo003jVP3oool01P3oool3000000<0003o103oool01@3o0000oooo003jVP3o
0000oooo00800?ZJ0P3oool01000nYX0oooo0?ooo`00nYX40?ooo`04003jVP3oool0oooo003jVPD0
oooo00H00?ZJ0?ooo`3oool0oooo003jVP3o00020?ooo`80o`001P3oool00`00nYX0003o0?l0000G
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000
003oool0oooo00<0oooo00@00?ZJ0?l00000nYX00?ZJ1`3oool00`000?l0o`000?ooo`050?ooo`07
0000o`3oool0o`000?ooo`000?l0oooo003jVP020?ooo`0?0?l0003oool00?ZJ003jVP3o0000oooo
003jVP3oool0003o0?l0003oool00?ZJ0?ooo`00nYX0003o0080oooo00<00?ZJ0000o`3oool01`3o
ool01`000?l0o`000?ooo`3oool00?ZJ0?ooo`3o00000P3oool00`00nYX0oooo0?ooo`020?ooo`04
0?l00000nYX0oooo003jVP<000000P3oool2003jVP80oooo00L0003o0?l0003oool0003o003jVP3o
ool0o`000080oooo00T00?ZJ0?ooo`3oool00?ZJ0?l00000nYX0oooo003jVP3oool00P3o00030?oo
o`05003jVP3oool0003o0?ooo`00nYX01@3oool02000nYX0oooo0?ooo`3o00000?ZJ0?l0003oool0
0?ZJ1@3oool00`00nYX0o`000?ooo`020?ooo`030000o`00nYX0oooo0080o`000P3oool00`3o0000
oooo003jVP020?ooo`070?l0003oool0oooo003jVP3o0000oooo003jVP040?ooo`030?l0003oool0
oooo00800?ZJ00<0o`000?ooo`00nYX00`3oool00`00nYX0003o0?ooo`030?l003h0oooo00130?oo
o`030000003oool00?ZJ0080oooo0P3o0000203oool0o`000?ooo`3o0000oooo003jVP3oool00?ZJ
3P3oool00`00nYX0oooo0?ooo`020?ooo`070000o`3o0000oooo0?ooo`3o00000?ZJ0000o`0N0?oo
o`030?l00000nYX0oooo0080oooo00<0o`000?ooo`00nYX06`3oool00`00nYX0o`000?ooo`020?oo
o`80o`0000@0003o0?ooo`00nYX0oooo0P3o00050?ooo`030?l0003oool0oooo00@0oooo00L0003o
0?l0003oool0oooo003jVP3o0000003o01h0oooo00<00?ZJ0?ooo`3o00000P3oool2003jVP<00000
8@3oool010000000oooo0?ooo`0000020?ooo`<00000103oool00`3o00000?ZJ003jVP020?l00005
0?ooo`3o00000?ZJ0?l00000nYX00`3o00000`00nYX0oooo0?ooo`040?ooo`03003jVP3o0000oooo
00800?ZJ1@3o00020?ooo`03003jVP3o0000oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool01@00
nYX0oooo0?ooo`3oool00?ZJ00<0oooo0`00nYX20?ooo`03003jVP3o0000003o0080003o103oool0
0`00nYX0oooo0?ooo`020?ooo`06003jVP3o0000oooo0?ooo`00nYX0oooo0P00nYX40?ooo`800?ZJ
00<0o`00003jVP3oool0103oool00`3o0000oooo0?ooo`020?ooo`05003jVP3o0000oooo0?ooo`00
nYX01P3oool3003jVPL0oooo0`0000000`000?l0oooo0?ooo`040?ooo`070?l0003oool00?ZJ0?l0
00000?l00?ZJ0?ooo`030?l00080oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`00
nYX60?l000<0oooo00<00?ZJ0?l0003oool00P3oool00`00nYX0oooo0?ooo`040?ooo`04003jVP00
00000000000001X0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`3oool30000
00<0oooo00@00?ZJ0?l00000nYX00?ZJ1P3oool00`000?l0oooo0?l000060?ooo`080000o`3oool0
o`000?ooo`000?l0oooo003jVP3oool20?l000070?ooo`00nYX00?ZJ0?l0003oool00?ZJ0?ooo`02
0?l000070?ooo`00nYX0oooo003jVP000?l0oooo003jVP020000o`P0oooo00D0003o0?l0003oool0
oooo003jVP020?l000030?ooo`00nYX0oooo00@0oooo00@0o`000000o`00nYX00?ZJ0`0000020?oo
o`0=003jVP3oool0oooo0?ooo`000?l0o`000?ooo`000?l00?ZJ0?ooo`3o0000oooo003jVP030?oo
o`08003jVP3o00000?ZJ0?ooo`00nYX0oooo0?l00000nYX30?ooo`800?ZJ00<0003o0?ooo`00nYX0
1@3oool01000nYX0oooo0?ooo`3oool20?l00003003jVP3oool0oooo00@0oooo00<00?ZJ0?l0003o
ool00P3oool00`000?l00?ZJ0?ooo`020?l000060?ooo`3o0000oooo0?ooo`00nYX0oooo0`000000
1@000?l00?ZJ0?l0003oool00?ZJ00@0oooo00P0o`000?ooo`3oool00?ZJ0000o`3o0000oooo003j
VP<0oooo00H00?ZJ0000o`3oool0oooo0000o`00nYXn0?ooo`00@`3oool00`000000oooo003jVP02
0?ooo`80o`0000P0oooo0?l0003oool0o`000?ooo`00nYX0oooo003jVPd0oooo0`00nYX30?ooo`07
0000o`3o0000oooo0?ooo`00nYX0o`000000o`0M0?ooo`03003jVP3o00000?ZJ00<0oooo00<00?ZJ
0?l00000nYX06`3oool20?l000D0oooo0P3o00000`00nYX0o`000?l000060?ooo`030?l0003oool0
oooo00@0oooo00L00?ZJ0?l0003oool0oooo003jVP3o0000003o01h0oooo00@00?ZJ0?l000000?l0
oooo0`00nYX300000240oooo00@000000?ooo`3oool000000P3oool3000000@0oooo00<0o`00003j
VP00nYX00P3o0000203oool0o`00003jVP3o00000?ZJ0?l000000?l0o`001`3oool01P00nYX0o`00
0?ooo`3oool00?ZJ0?ooo`80o`0000H0oooo003jVP3oool0oooo003jVP3o00020?ooo`<0o`000`3o
ool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00800?ZJ103oool01000nYX0o`000000
o`000?l50?ooo`03003jVP3oool0oooo0080oooo00L00?ZJ0?l0003oool0oooo003jVP3oool00?ZJ
00D0oooo0P00nYX00`3o00000?ZJ003jVP040?ooo`030?l0003oool0oooo0080oooo00D00?ZJ0?l0
003oool0oooo003jVP070?ooo`800?ZJ203oool00`00nYX0o`000?l000050?l000070?ooo`3o0000
oooo003jVP3o0000003o003jVP020?l000050?ooo`3o0000oooo0?ooo`00nYX0103oool01@00nYX0
oooo0?ooo`00nYX0o`0000@0oooo00H0o`000?ooo`3oool0oooo003jVP3o00030?ooo`03003jVP3o
ool0oooo00D0oooo0`00000H0?ooo`8000000`3oool010000000oooo0?ooo`0000030?ooo`030000
003oool0oooo00<0oooo00@00?ZJ0?l00000nYX00?ZJ1P3oool00`000?l0oooo0?l000060?ooo`09
0000o`3oool0o`000?ooo`000?l0oooo003jVP3oool0o`000080oooo0P00nYX01@3o0000oooo003j
VP000?l0o`000080oooo00<00?ZJ0?ooo`3oool00`00nYX00`000?l0oooo0?ooo`070?ooo`060000
o`3o0000oooo0?ooo`00nYX0o`000P3oool00`00nYX0oooo0?ooo`030?ooo`040?l000000?l00?ZJ
003jVP<0000000<0oooo003jVP00nYX00`3oool02@000?l0o`000?ooo`000?l00?ZJ0?ooo`3o0000
oooo003jVP030?ooo`08003jVP3o00000?ZJ0?ooo`00nYX0oooo0?l00000nYX30?ooo`030000o`00
nYX00?ZJ00800?ZJ1@3oool2003jVP80oooo0P3o00000`00nYX0oooo0?ooo`040?ooo`03003jVP3o
0000oooo0080oooo00@00?ZJ0?ooo`3o00000?ZJ0`3o0000103oool00?ZJ0?ooo`3oool300000005
003jVP3oool0o`000?ooo`00nYX0103oool0203o0000oooo0?ooo`00nYX0003o0?l0003oool00?ZJ
0`3oool01P00nYX0003o0?ooo`3oool0003o003jVSh0oooo00130?ooo`030000003oool00?ZJ0080
oooo0P3o0000203oool0o`000?ooo`3o0000oooo003jVP3o00000?ZJ3@3oool00`00nYX0oooo003j
VP030?ooo`070000o`3o0000oooo0?ooo`00nYX0o`000000o`0L0?ooo`<0000000L00?ZJ0?ooo`3o
ool0oooo003jVP3o00000?ZJ0180oooo00<00?ZJ0?ooo`3oool0103oool2003jVP030?l0003oool0
oooo00@0oooo0P000?l20?l000030000o`3oool0oooo00@0oooo00<0o`000000o`3oool0103oool0
1`00nYX0o`000?ooo`3oool00?ZJ0?l000000?l0503oool2003jVPD0oooo0P00nYX00`3oool00?ZJ
0?l000020?ooo`03003jVP3oool00?ZJ00<000008@3oool010000000oooo0?ooo`0000030?ooo`03
003jVP3oool0oooo00<0oooo00<0o`00003jVP00nYX00P3o0000203oool0o`00003jVP3o0000003o
0?l000000?l0o`001`3oool01@00nYX0o`000?ooo`3oool00?ZJ00@0oooo00D00?ZJ0?ooo`3oool0
oooo003jVP030?l000030?ooo`3o0000oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0
oooo003jVP00nYX50?ooo`03003jVP3o00000?ZJ00800?ZJ103oool00`00nYX0oooo0?ooo`020?oo
o`03003jVP3oool0o`000080o`0000<0oooo003jVP3oool0103oool01000nYX0o`00003jVP3oool2
003jVP<0oooo00<0o`000?ooo`3oool00P3oool00`3o0000003o0?ooo`02003jVQ40oooo00<00?ZJ
0000o`3o0000103oool30?l00080oooo00@0o`000000o`00nYX0o`000P3oool00`3o0000oooo003j
VP020?ooo`@0o`0000<0oooo003jVP3o00001@3oool01P3o0000oooo0?ooo`3oool0o`000000o`80
0?ZJ00<0oooo003jVP3oool01P3oool3000001X0oooo00@000000?ooo`3oool000000P3oool01@00
0000oooo0?ooo`3oool0000000D0oooo00@00?ZJ0?l00000nYX00?ZJ1P3oool00`000?l0oooo0?l0
00060?ooo`050000o`3oool0o`000?ooo`000?l00P00nYX0103oool0o`000?ooo`3oool2003jVP05
0?l00000nYX0oooo0000o`3o00000P3oool01000nYX0oooo0?ooo`3oool30000o`T0oooo00L0003o
0?l0003oool0003o003jVP3o0000oooo00800?ZJ1@3oool00`3o0000003o003jVP020?ooo`040?l0
0000nYX00?ZJ003jVP@0oooo00L0003o0?l0003oool0003o003jVP3o0000oooo00800?ZJ103oool0
1`3o00000?ZJ0?ooo`00nYX0003o0?l00000nYX00`3oool30000o`P0oooo00@00?ZJ0?ooo`3oool0
o`000P00nYX60?ooo`03003jVP3o0000oooo0080oooo00<00?ZJ0?ooo`3o00000P00nYX20?l00004
0?ooo`00nYX0oooo0?ooo`<0000000@00?ZJ0?l0003o00000?ZJ1@3oool0203o00000?ZJ0?ooo`00
nYX0003o0?l0003oool00?ZJ0`3oool01P00nYX0003o0?ooo`3oool0003o003jVSh0oooo00130?oo
o`0?00000000nYX0oooo0?ooo`3o0000003o0?l0003oool0o`000?ooo`3o0000003o003jVP3o0000
0?ZJ00d0oooo00P00?ZJ0?ooo`00nYX0oooo0000o`3oool0003o0?l00080oooo00<00?ZJ0?l00000
nYX0703oool3000000@0oooo00<00?ZJ0?l00000nYX0303oool7003jVPD0oooo0`00nYX00`3o0000
0?ZJ003jVP040?ooo`<0000000<0oooo0000o`3oool01@3oool00`3o0000003o0?ooo`030?ooo`80
0?ZJ00H0o`000?ooo`3oool0oooo0?l000000?lD0?ooo`800?ZJ1@3oool2003jVP<0000000<0oooo
003jVP00nYX00P3oool00`00nYX0oooo003jVP0Q0?ooo`040000003oool0oooo000000<0oooo00<0
0000003jVP3oool00`3oool00`3o00000?ZJ003jVP020?l000030?ooo`3o00000?ZJ0080o`000`00
00080?ooo`040?l0003oool0oooo003jVP@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?l00080
oooo00@0o`000?ooo`3oool00?ZJ103oool20?l000800?ZJ1P3oool01000nYX0o`00003jVP3oool2
003jVP<0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?l000020?l000800?ZJ0P3oool3
0?l00005003jVP3o00000?ZJ0?ooo`000?l00P00nYX20?ooo`030?l0003oool0oooo0080oooo00<0
o`000000o`00nYX00P00nYXB0?ooo`03003jVP3oool0oooo00D0oooo00L00?ZJ0?ooo`3oool0o`00
0000o`00nYX0o`000080oooo00@0o`000?ooo`00nYX0oooo0P3o00020?ooo`040?l0003oool00?ZJ
0?l000D0oooo00D0o`000?ooo`3oool0oooo0?l00005003jVPL0oooo0P00nYXG0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00<0
oooo00@00?ZJ0?l00000nYX00?ZJ1P3oool00`000?l0oooo0?l000070?ooo`060000o`3o0000oooo
0000o`00nYX0oooo0P3o00020?ooo`03003jVP3oool0o`000080oooo0P3o00020?ooo`03003jVP3o
ool0oooo0080oooo0P000?l90?ooo`080000o`3o0000oooo003jVP3oool0o`000?ooo`00nYX60?oo
o`04003jVP3o0000oooo0?ooo`80o`000P00nYX50?ooo`080000o`3o0000oooo0000o`00nYX0o`00
0?ooo`00nYX50?ooo`070?l00000nYX00?ZJ0?ooo`3o0000oooo003jVP040?ooo`030000o`3oool0
oooo00L0oooo00D00?ZJ0?ooo`3oool0o`00003jVP080?ooo`070?l0003oool0oooo0?ooo`00nYX0
oooo0?l00002003jVP80oooo0P00nYX30?ooo`060?l00000nYX00?ZJ0?l0003oool00?ZJ1@3oool0
1`3o00000?ZJ0?ooo`00nYX0o`000?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`000?l00?ZJ03h0
oooo00130?ooo`0@00000000nYX0oooo0?ooo`3o0000003o0?l0003oool0o`000?ooo`3o0000003o
003jVP3o00000?ZJ0?ooo`800?ZJ1`3oool2003jVP050?ooo`00nYX0oooo0?ooo`00nYX00P000?l0
1`3oool0o`000?ooo`3oool00?ZJ0?l00000nYX0603oool4003jVP<00000103oool00`00nYX0o`00
003jVP0<0?ooo`03003jVP3oool0oooo00800?ZJ00<0oooo003jVP3oool0103oool01000nYX0oooo
0?ooo`3o0003003jVP<0oooo0`0000070?ooo`04003jVP3o00000?ZJ0000o`80oooo0P00nYX00`3o
ool0o`000?ooo`020?ooo`030?l000000?l0oooo00/0oooo00<00?ZJ0?ooo`3oool00`3oool2003j
VP030?ooo`00nYX0oooo00<0oooo00<00?ZJ0?ooo`3oool00`000002003jVP<0oooo00<00?ZJ0?oo
o`00nYX08P3oool2000000@0oooo00<00000003jVP3oool00`3oool00`3o00000?ZJ003jVP020?l0
00030?ooo`3o0000oooo0080o`000`0000030?l000D0oooo00D0o`000?ooo`3oool0oooo003jVP03
0?ooo`05003jVP3oool0oooo0?ooo`00nYX0103oool0103o0000oooo0?ooo`00nYX20?ooo`80o`00
00<0oooo0?l00000nYX01`3oool00`00nYX0o`000?ooo`020?ooo`800?ZJ0P3oool00`00nYX0oooo
0?ooo`020?ooo`07003jVP3oool0003o0?ooo`3o00000?ZJ0?ooo`020?l00080oooo0`3o00001000
nYX0oooo0?ooo`000?l2003jVP030?ooo`3o0000oooo00<0oooo00D0o`00003jVP00nYX0oooo003j
VP0B0?ooo`03003jVP3oool0oooo00D0oooo00H00?ZJ0?ooo`3oool0o`00003jVP3o00030?ooo`03
0?l0003oool00?ZJ0080o`000`3oool01@3o0000oooo003jVP3o0000003o00@0oooo00H0o`000?oo
o`3oool0oooo0?l00000nYX20?ooo`800?ZJ203oool00`00nYX0oooo0?ooo`0F0?ooo`<00000103o
ool2000000@0oooo0P0000040?ooo`04003jVP3o00000?ZJ003jVPH0oooo00<0003o0?ooo`3o0000
1`3oool01`000?l0o`000000o`3oool00?ZJ0?ooo`3o00000`3oool00`00nYX0oooo0?l000020?oo
o`030?l0003oool0oooo00800?ZJ103oool20000o`T0oooo00H0003o0?l0003oool00?ZJ0?l0003o
ool2003jVPH0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX70?ooo`080000o`3o0000oooo003j
VP3oool0o`000?ooo`00nYX50?ooo`070?l00000nYX00?ZJ0?ooo`3o0000oooo003jVP040?ooo`03
0000o`3oool0oooo00L0oooo00D00?ZJ0?ooo`3oool0o`00003jVP080?ooo`050?l0003oool0oooo
0?ooo`00nYX00P3o0002003jVP80oooo00<00?ZJ0?ooo`3oool00P3oool01P3o00000?ZJ003jVP3o
0000oooo003jVPD0oooo00L0o`00003jVP3oool00?ZJ0?l0003oool00?ZJ00D0oooo00D00?ZJ0?oo
o`3oool0003o003jVP0n0?ooo`00@`3oool03@0000000?ZJ0?ooo`3oool0o`000000o`3o0000oooo
0?l0003oool0o`000000o`00nYX00P3o00000`3oool00?ZJ003jVP060?ooo`<00?ZJ00@0oooo0?l0
003o0000oooo0P00nYX00`000?l0oooo0?l000020?ooo`03003jVP3o00000?ZJ01L0oooo0P00nYX2
0?ooo`80003o00<0o`000?ooo`3oool00`3oool01000nYX0o`00003jVP00nYX70?ooo`800?ZJ0P3o
ool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`0000000P00
00000`3oool00?ZJ003jVP020?ooo`<000001@3oool3003jVP030?l00000nYX0003o0080oooo00@0
0?ZJ0000o`3oool0o`000`3oool00`3o0000003o0?ooo`0:0?ooo`800?ZJ103oool2003jVP80oooo
00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`0300000003003jVP3oool0oooo0080oooo
00<00?ZJ0?ooo`00nYX0:03oool00`0000000?ZJ0?ooo`030?ooo`030?l00000nYX00?ZJ0080o`00
00<0oooo0?l0003oool00P3o000300000080oooo0`3o00030?ooo`040?l0003oool0oooo0?ooo`D0
0?ZJ0`3oool00`00nYX0003o0?ooo`020?ooo`050?l0003oool0oooo003jVP3oool00P3o0000103o
ool0003o0?l00000nYX70?ooo`03003jVP3o0000oooo00<0oooo1000nYX40?ooo`06003jVP3oool0
003o0?ooo`3o00000?ZJ0P3o00040?ooo`80o`000`3oool20000o`800?ZJ00<0o`000?ooo`3oool0
0P3oool00`3o00000?ZJ0?ooo`0D0?ooo`03003jVP3oool0oooo00D0oooo00L00?ZJ0?ooo`3oool0
o`000000o`3o0000oooo00800?ZJ00@0o`000?ooo`00nYX0o`00103oool0103o0000oooo003jVP3o
0003003jVP80oooo00H0o`000?ooo`3oool0oooo0?l00000nYX<0?ooo`030000003oool0oooo02<0
oooo00<000000?ooo`3oool00`3oool01000nYX0o`00003jVP00nYX60?ooo`030000o`3oool0o`00
00L0oooo00L0003o0?l000000?l0oooo003jVP3oool0o`000080oooo00@00?ZJ0?ooo`3oool0o`00
0P3oool0103o0000oooo0?ooo`00nYX50?ooo`030000o`3oool0oooo00P0oooo00L0003o0?l0003o
ool00?ZJ0?l0003oool00?ZJ00L0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX70?ooo`060000
o`3o0000oooo003jVP3o0000oooo0P00nYX50?ooo`070?l000000?l00?ZJ0?ooo`3o0000oooo003j
VP0>0?ooo`050000o`000000000000000000nYX0203oool00`3o0000oooo0?ooo`02003jVP040?l0
003oool00?ZJ003jVP80oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0o`000?ooo`3o0002003j
VPD0oooo00L0o`00003jVP00nYX0003o0?l0003oool00?ZJ00D0oooo00D00?ZJ0?ooo`3oool0003o
003jVP0n0?ooo`00@`3oool0400000000?ZJ0?ooo`3oool0o`000000o`3o0000oooo0?l0003oool0
o`000000o`3o0000oooo0?l0003oool2003jVPD0oooo0P00nYX00`3oool00?ZJ0?ooo`030?l00005
0000o`00nYX00?ZJ003jVP3o00000P3oool00`00nYX0o`00003jVP0;0?ooo`03003jVP3oool0oooo
00T0oooo00<00?ZJ0?ooo`3oool00`000?l00`3o0000oooo0?ooo`030?ooo`04003jVP3o0000003o
003jVPH0oooo0`00nYX00`3oool00?ZJ0?ooo`050?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ
0?ooo`0000000P0000020?ooo`800?ZJ0`3oool3003jVP030?ooo`00nYX00?ZJ00<00?ZJ00<0o`00
003jVP000?l00P00nYX010000?l0oooo0?ooo`3o00030?ooo`040?l000000?l0oooo0?ooo`800?ZJ
1P3oool3003jVP@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP040?ooo`05003jVP3oool0oooo0000
o`3o00001P3oool00`00nYX0oooo003jVP0X0?ooo`0300000000nYX00?ZJ00<0oooo00<0o`00003j
VP00nYX00P3o00000`3oool0o`000?ooo`020?l000<00?ZJ103oool20?l00080oooo00<0o`000?oo
o`3oool02@3oool00`00nYX0003o0?ooo`02003jVP040?l0003oool00?ZJ0?ooo`80o`0000@0oooo
0000o`000?l0o`00203oool00`00nYX0o`000?ooo`050?ooo`800?ZJ103oool01`00nYX0oooo0000
o`3oool0o`00003jVP3o00001@3oool20?l000<0oooo0`000?l00`3oool0o`000?ooo`020?ooo`03
003jVP3o00000?ZJ01H0oooo0P00nYX50?ooo`07003jVP3oool0oooo0?l000000?l0o`00003jVP02
0?ooo`040?l0003oool00?ZJ0?l000@0oooo00H0o`000?ooo`00nYX0o`00003jVP3oool3003jVP06
0?l0003oool0oooo0?ooo`3o00000?ZJ303oool00`000000oooo0?ooo`0S0?ooo`030000003oool0
oooo00<0oooo00@00?ZJ0?l00000nYX00?ZJ0P3oool01`000?l0oooo0?ooo`3oool0003o0?ooo`3o
00001`3oool01P000?l0o`000000o`00nYX0oooo0?l000<0oooo00@00?ZJ0?ooo`3oool0o`000P3o
ool0103o0000oooo0?ooo`00nYX@0?ooo`070000o`3o0000oooo003jVP3o0000oooo003jVP070?oo
o`06003jVP3o0000oooo0?ooo`3o00000?ZJ1`3oool01`000?l0o`000000o`00nYX0o`000?ooo`00
nYX01P3oool01`3o0000003o0?ooo`3oool0o`000?ooo`00nYX03P3oool010000?l0000000000000
00090?ooo`090?l0003oool0oooo003jVP000?l0o`000?ooo`00nYX0oooo00<00?ZJ103oool01@00
nYX0o`000?ooo`3o00000?ZJ00H0oooo00L0o`00003jVP00nYX0003o0?l0003oool00?ZJ00D0oooo
00D00?ZJ0?ooo`3oool0003o003jVP0n0?ooo`00@`3oool04000nYX0oooo0?ooo`3o0000oooo0000
o`3o0000oooo0?l0003oool0o`000000o`3o00000?ZJ0?l0003oool2003jVP@0oooo0P00nYX20?oo
o`05003jVP3oool0o`000?ooo`3o00000P000?l20?ooo`050?l0003oool0oooo0?ooo`3o00000P00
nYX00`3oool00?ZJ003jVP060?ooo`800?ZJ2`3oool00`00nYX0oooo0000o`020000o`030?ooo`3o
0000oooo00@0oooo00@00?ZJ0?l000000?l00?ZJ1@3oool2003jVP040?ooo`00nYX0oooo003jVPH0
oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo00000002000000<0oooo00D00?ZJ0?ooo`3o
ool0oooo003jVP020?ooo`800?ZJ0`3oool00`00nYX0o`000?ooo`02003jVP050?ooo`000?l0oooo
0?ooo`3o00000`3oool0103o0000oooo0000o`3oool2003jVPD0oooo0P00nYX00`3oool00?ZJ0?oo
o`020?ooo`800?ZJ0`3oool00`00nYX0oooo0?ooo`020?ooo`05003jVP3oool0oooo0000o`3o0000
1P3oool00`00nYX00000003jVP0X0?ooo`80000000L00?ZJ0?ooo`3oool0oooo0?l0003oool00?ZJ
0080o`0000D0oooo0?l0003oool00?ZJ0?l00004003jVP@0oooo103o000;0?ooo`03003jVP000?l0
0?ZJ0080oooo00D0o`000?ooo`00nYX0oooo0?l000020?ooo`040000o`0000000000000000@0o`00
0`3oool00`00nYX0o`000?ooo`0;0?ooo`07003jVP3oool0003o003jVP3o0000oooo0?l000050?oo
o`80o`00103oool20000o`030?ooo`3o0000oooo0080oooo00<00?ZJ0?l00000nYX05`3oool3003j
VP<0oooo00L00?ZJ0?ooo`3oool0o`000000o`3o00000?ZJ0080oooo00<0o`00003jVP3o00001@3o
ool01P3o00000?ZJ0?l00000nYX0003o0?ooo`80003o00<00?ZJ0?l0003oool00P3oool00`3o0000
0?ZJ0?ooo`0;0?ooo`030000003oool0oooo02<0oooo0P0000040?ooo`04003jVP3o00000?ZJ003j
VP80oooo0P000?l20?ooo`030000o`3oool0o`0000L0oooo00H0003o0?l000000?l00?ZJ0?ooo`3o
00020?ooo`0:003jVP3oool0oooo0?ooo`3o0000oooo0?l000000?l0oooo003jVQ40oooo00<0003o
0?l0003oool00P3o00000`00nYX0oooo0?ooo`060?ooo`06003jVP3o0000oooo0?l0003oool00?ZJ
1`3oool01`000?l0o`000000o`00nYX0o`000?ooo`00nYX01P3oool01`3o0000003o0?ooo`3o0000
003o0?ooo`00nYX03P3oool010000?l000000000000000090?ooo`090?l0003oool0oooo003jVP00
0?l0o`000?ooo`00nYX0oooo00800?ZJ1@3oool01@00nYX0o`000?l0003oool00?ZJ00H0oooo00H0
o`00003jVP00nYX0o`000?ooo`00nYX60?ooo`05003jVP3oool0oooo0000o`00nYX0?P3oool004<0
oooo00l00?ZJ0?ooo`3oool0o`000000o`3oool0o`000?ooo`3o0000oooo0?l000000?l0o`00003j
VP3o00000`00nYX30?ooo`800?ZJ0`3oool01P00nYX0oooo0?l0003oool0o`000000o`<0oooo00H0
o`000?ooo`3oool0oooo0?l000000?l2003jVP030?ooo`00nYX0oooo00D0oooo0P00nYX;0?ooo`04
003jVP3oool0003o0000o`80oooo00<0o`000?ooo`3oool00`3oool01000nYX0o`000000o`00nYX5
0?ooo`06003jVP3oool0oooo003jVP3oool00?ZJ0`3o00030?ooo`03003jVP3oool0oooo00<0oooo
00@00?ZJ0?ooo`000?l0o`001@3oool01000nYX0oooo0?ooo`00nYX70?ooo`800?ZJ00D0o`000000
o`000?l0oooo0000o`020?ooo`070?l0003oool0oooo0?ooo`3o0000oooo0000o`03003jVPD0oooo
00@00?ZJ0?ooo`3oool00?ZJ0`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo0080
oooo00D00?ZJ0?ooo`3o0000003o0?l000060?ooo`03003jVP3oool00?ZJ02P0oooo00<000000?oo
o`00nYX00`3oool00`3o0000oooo003jVP020?l000070?ooo`3o0000oooo003jVP3oool00?ZJ0?oo
o`02003jVPH0oooo0P3o000<0?ooo`800?ZJ0P3oool00`3o0000oooo003jVP020?l00080oooo00@0
003o00000000000000000`3oool60?l000d0oooo00<00?ZJ0000o`00nYX00P3o00060?ooo`80o`00
1P3oool00`000?l0o`000?ooo`020?ooo`03003jVP3o00000?ZJ01T0oooo0P00nYX20?ooo`07003j
VP3oool0oooo0?l000000?l0o`00003jVP020?ooo`040?l00000nYX0o`000?ooo`<00?ZJ00H0oooo
0?l00000nYX0o`00003jVP000?l20?ooo`80003o00H0o`000?ooo`3oool0oooo0?l00000nYX<0?oo
o`030000003oool0oooo02<0oooo00<000000?ooo`3oool00`3oool01000nYX0o`00003jVP00nYX2
0?ooo`80003o0P3oool00`000?l0oooo0?l000070?ooo`070000o`3o0000003o003jVP3oool0o`00
0?ooo`02003jVP<0oooo00H0o`000?ooo`3o0000003o0?ooo`00nYXB0?ooo`050?l00000nYX0o`00
0?ooo`00nYX0203oool01P00nYX0o`000?ooo`3o0000003o003jVPL0oooo00D0003o0?l000000?l0
0?ZJ0?l00002003jVPH0oooo00H0o`000000o`3oool0o`000000o`00nYX?0?ooo`030000o`3oool0
003o00X0oooo00P0o`000?ooo`3oool00?ZJ0000o`3o0000oooo003jVPT0oooo0P3o0002003jVPH0
oooo00H0o`000000o`3oool0o`000?ooo`00nYX60?ooo`05003jVP000?l0oooo0000o`00nYX0?P3o
ool003`0oooo0P0000030?ooo`<000000140003o0?l0003o0000003o0?ooo`3o0000oooo0?l0003o
ool0o`000000o`3o00000?ZJ0?l00000nYX0oooo0?l000020?ooo`800?ZJ103oool01P00nYX0oooo
0?l00000nYX0003o0?l000<0oooo00H0o`000?ooo`3oool0oooo003jVP3o00030?ooo`03003jVP3o
ool0oooo00<0oooo0`00nYX;0?ooo`04003jVP3o0000o`000?l00080oooo00<0o`000?ooo`3oool0
0`3oool01000nYX0o`000000o`00nYX40?ooo`09003jVP3oool0oooo0?ooo`00nYX0oooo003jVP3o
0000oooo0080o`000P3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0o`000080o`001@3o
ool2003jVP030?ooo`00nYX0oooo00L0oooo00<00?ZJ0?l0003oool00`000?l20?ooo`0:0?l0003o
ool0oooo0?ooo`3o0000oooo0000o`00nYX0oooo003jVP@0oooo00D00?ZJ0?ooo`3oool0oooo003j
VP030?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0o`000?l0
00020?l000L0oooo0P00nYXX0?ooo`030000003oool00?ZJ00@0oooo00X0o`00003jVP3o0000o`00
003jVP3o0000oooo003jVP3oool00?ZJ0P3oool00`000?l00?ZJ0?ooo`030?ooo`<00000303oool0
20000?l0oooo0?ooo`3oool0o`000?ooo`00nYX0o`000`3oool01@000?l00000000000000000003o
00H0oooo00<0o`00003jVP3oool0303oool2003jVP040?ooo`3o0000o`000000o`<00?ZJ0P3oool2
0?l000H0oooo00<0003o0?l0003oool00P3oool00`00nYX0o`00003jVP0J0?ooo`04003jVP3oool0
oooo003jVP80oooo0P3o00001`00nYX0oooo0?ooo`3oool0o`00003jVP3o00000P00nYX020000?l0
0?ZJ003jVP3o00000?ZJ0?l00000nYX0003o0`3oool00`000?l0o`000?ooo`020?ooo`030?l00000
nYX0oooo00/0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`030?ooo`04003jVP3o
00000?ZJ003jVP80oooo0P000?l20?ooo`030000o`3oool0o`0000L0oooo00D0003o0?l00000nYX0
oooo0?l000020?ooo`03003jVP3oool0oooo0080oooo00@0o`000?ooo`3o0000003o0P00nYXB0?oo
o`050?l00000nYX0o`000?ooo`00nYX0203oool01P00nYX0o`000?ooo`3o0000003o003jVPP0oooo
00D0o`00003jVP3o0000oooo003jVP070?ooo`060?l000000?l0oooo0?l000000?l00?ZJ403oool2
0000o`X0oooo00L0o`000?ooo`3oool00?ZJ0?l0003oool00?ZJ00X0oooo00<00?ZJ0?ooo`00nYX0
1`3oool01P3o0000003o0?ooo`3o0000oooo003jVPH0oooo00D00?ZJ0000o`000?l0oooo003jVP0n
0?ooo`00>`3oool010000000oooo0?ooo`0000020?ooo`<000000P3o00020000o`0;0?ooo`3o0000
oooo0?l0003oool0o`000000o`3o00000?ZJ0?l00000nYX00P3o00000`3oool00?ZJ003jVP050?oo
o`06003jVP3oool0o`00003jVP000?l0o`000`3oool01`3o0000oooo0?ooo`3oool00?ZJ0?l00000
0?l00P3oool00`00nYX0oooo0?ooo`020?ooo`800?ZJ00<0oooo003jVP3oool01@3oool3003jVP05
0?ooo`00nYX0o`000?l000000?l0103o00050?ooo`04003jVP3oool0o`00003jVP<0oooo0P00nYX3
0?ooo`04003jVP3oool00?ZJ0?l00080oooo103o00040?ooo`05003jVP3oool0o`000000o`00nYX0
1P3oool3003jVPP0oooo00<00?ZJ0?l0003oool00P000?l30?ooo`0:0?l0003oool0oooo0?ooo`3o
00000?ZJ0000o`00nYX0oooo003jVP@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?ooo`03003j
VP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0o`000000o`3oool00?ZJ00L0
oooo0P00nYXX0?ooo`030000003oool00?ZJ00@0oooo00X0o`00003jVP3o0000o`00003jVP3o0000
oooo003jVP3oool00?ZJ0`3oool2003jVP<0oooo0`00000<0?ooo`080000o`3oool0oooo0?ooo`3o
00000?ZJ0?ooo`3o00020?ooo`D00?ZJ0P000?l50?ooo`030?l00000nYX0oooo00`0oooo0P00nYX0
0`3oool0o`000?l00002003jVP040?ooo`00nYX00?ZJ0?ooo`80o`001P3oool00`000?l0o`000?oo
o`020?ooo`03003jVP3o00000?ZJ01X0oooo0P00nYX01`3oool00?ZJ0?ooo`3oool00?ZJ0?l00000
nYX00`3oool0103o00000?ZJ0?l00000nYX20000o`060?ooo`00nYX0o`00003jVP3o00000?ZJ103o
ool01P000?l0o`000?ooo`3oool00?ZJ0?l000d0oooo00<000000?ooo`3oool08`3oool00`000000
oooo0?ooo`030?ooo`04003jVP3o00000?ZJ003jVP80oooo0P000?l01@3oool0003o0?ooo`3oool0
o`0000L0oooo00D0003o0?l00000nYX0oooo0?l000020?ooo`03003jVP3oool0oooo0080oooo00D0
0?ZJ0?l0003o0000003o003jVP0B0?ooo`<0000000<0o`00003jVP3oool0203oool01P00nYX0o`00
0?ooo`3o0000003o003jVPP0oooo00D0o`00003jVP3o0000oooo003jVP070?ooo`06003jVP3o0000
oooo0?l000000?l00?ZJ403oool00`000?l0oooo0?ooo`090?ooo`070?l0003oool00?ZJ0000o`3o
0000oooo003jVP0:0?ooo`03003jVP3oool00?ZJ00L0oooo00H0o`000000o`3oool0o`000?ooo`00
nYX70?ooo`04003jVP000?l00?ZJ000003h0oooo000k0?ooo`040000003oool0oooo00000080oooo
0`0000040000o`80oooo0P3o00001`3oool0o`000000o`3o00000?ZJ0?l00000nYX00P3o00000`3o
ool00?ZJ0?ooo`050?ooo`800?ZJ00@0o`000000o`00nYX0oooo103o00030?ooo`03003jVP3o0000
003o0080oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX40?ooo`<00?ZJ00L0
oooo003jVP3oool00?ZJ0?l0003oool0003o00<0oooo00<00?ZJ0?ooo`3oool00`3oool01000nYX0
oooo0?l00000nYX30?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3o00001P3oool00`3o
0000oooo0?ooo`020?ooo`05003jVP3oool0o`000000o`00nYX01`3oool2003jVPT0oooo0P3o0000
0`3oool0003o0?ooo`020?ooo`050?l0003oool0oooo0?ooo`3o00000`00nYX00`3oool0o`000?oo
o`020?ooo`800?ZJ0`3oool01@00nYX0oooo0?ooo`00nYX0oooo00D0o`00103oool01@3o0000oooo
0000o`3oool00?ZJ00L0oooo0P00nYXX0?ooo`80000000<00?ZJ0?ooo`3oool00P3oool01`3o0000
0?ZJ0?l0003o00000?ZJ0?l0003oool00P00nYX40?ooo`030000o`00nYX0oooo0080oooo0`00000<
0?ooo`060000o`3oool0oooo0?ooo`3o00000?ZJ0P3o0000103oool00?ZJ003jVP000?l4003jVP03
0000o`3oool0oooo00<0oooo00<0o`000?ooo`3oool03@3oool01P000?l0oooo0?l0003oool00?ZJ
0000o`80oooo0P00nYX00`3oool0o`000?ooo`050?ooo`030000o`3o0000oooo0080oooo00<00?ZJ
0?l00000nYX06`3oool00`00nYX0oooo003jVP020?ooo`03003jVP000?l00?ZJ00<0oooo0P3o0002
003jVP80003o0P3oool0103o00000?ZJ0?l000000?l40?ooo`060000o`3o0000oooo0?ooo`00nYX0
o`003@3oool00`000000oooo0?ooo`0S0?ooo`800000103oool01000nYX0o`00003jVP00nYX20?oo
o`80003o00D0oooo0000o`3oool0oooo0?l000070?ooo`030000o`3o00000?ZJ0080o`0000<0oooo
003jVP3oool0103oool01@00nYX0o`000?ooo`000?l00?ZJ0180oooo0`0000000`3o00000?ZJ0?oo
o`080?ooo`06003jVP3o0000o`000?ooo`000?l00?ZJ203oool0103o00000?ZJ0?l00000nYX80?oo
o`06003jVP3o0000o`000?l000000?l00?ZJ403oool00`000?l0oooo0?ooo`090?ooo`070?l0003o
ool00?ZJ0000o`3o0000oooo003jVP0:0?ooo`03003jVP3oool00?ZJ00L0oooo00D00?ZJ0?l0003o
ool0o`00003jVP080?ooo`<00?ZJ00<000000?ooo`3oool0?03oool003/0oooo00@000000?ooo`3o
ool00000103oool01000nYX0003o0?ooo`000?l30?ooo`80o`0000L0oooo0?l000000?l0o`000?oo
o`3o0000oooo0080o`000P00nYX60?ooo`800?ZJ00<0o`000?ooo`00nYX0103oool02000nYX0oooo
0?ooo`3oool00?ZJ0?l000000?l0oooo0P3o00040?ooo`04003jVP3oool0oooo003jVP<0oooo0P00
nYX30?ooo`05003jVP3oool00?ZJ0?l000000?l0103oool00`00nYX0oooo0?ooo`030?ooo`04003j
VP3oool0o`00003jVP<0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?l000060?ooo`03
0?l0003oool0oooo0080oooo00D00?ZJ0?l0003oool0003o003jVP0B0?ooo`03003jVP3o0000o`00
00<0o`0000<0oooo0?l0003oool00P3oool0103o00000?ZJ003jVP3oool20?l000<0oooo00<00?ZJ
0?ooo`3oool00P3oool01P00nYX0oooo0?ooo`00nYX0oooo0?l000<0oooo00X0o`000?ooo`3oool0
oooo003jVP3o0000oooo0000o`3oool00?ZJ1`3oool2003jVRP0oooo00<000000?ooo`00nYX0103o
ool01`3o00000?ZJ0?l0003o00000?ZJ0?l0003oool00P00nYX40?ooo`030000o`00nYX0oooo00<0
oooo00<0003o003jVP3oool02`3oool20000o`80oooo00@0o`00003jVP3o0000oooo0P00nYX00`00
0?l0oooo0?ooo`020?ooo`800?ZJ103oool3000000h0oooo00H0003o00000000000000000?ooo`00
0?l30?ooo`800?ZJ00<0o`000?ooo`3oool01@3oool01`3o0000oooo0?ooo`3oool00?ZJ0?l00000
0?l06`3oool00`00nYX0oooo003jVP020?ooo`03003jVP000?l00?ZJ00<0oooo0P3o00001000nYX0
003o0?ooo`000?l20?ooo`030?l00000nYX0o`0000D0oooo00H0003o0?l0003oool0oooo003jVP3o
000=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00`3oool01000nYX0o`00003j
VP00nYX20?ooo`80003o00D0oooo0000o`3oool0oooo0?l000070?ooo`040000o`3o00000?ZJ0?l0
0080oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo0?ooo`02003jVQ80oooo0`000002003j
VPT0oooo00@00?ZJ0000o`3o0000oooo0P00nYX80?ooo`040?l00000nYX0o`00003jVPP0oooo00D0
0?ZJ0?l0003o0000003o003jVP0A0?ooo`030000o`3oool0oooo00T0oooo00L0o`000?ooo`00nYX0
003o0?l0003oool00?ZJ00X0oooo0P00nYX80?ooo`05003jVP3o0000o`000000o`00nYX0203oool2
003jVP030?ooo`000000oooo03d0oooo000k0?ooo`040000003oool0oooo000000@0oooo00<00?ZJ
0?ooo`3oool0103oool20?l000070?ooo`3o0000003o0?l0003oool0o`000?ooo`020?l00003003j
VP3oool0oooo00D0oooo0P00nYX0103o0000oooo003jVP00nYX30?ooo`05003jVP3oool0oooo0?oo
o`00nYX01@3o00030?ooo`03003jVP3oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJ103oool0
1@00nYX0oooo003jVP3o0000003o00@0oooo00<00?ZJ0?ooo`3oool00`3oool01000nYX0oooo0?oo
o`3o00020?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3o00000`00nYX30?ooo`030?l0
003oool0oooo0080oooo00D00?ZJ0?l0003oool0003o003jVP0B0?ooo`03003jVP3oool0oooo0080
oooo0`3o00030?ooo`030?l00000nYX00?ZJ00<0o`000`3oool00`00nYX0oooo0?ooo`020?ooo`05
003jVP3oool0oooo003jVP3o0000103oool02P3o0000oooo0?ooo`3oool00?ZJ0?l0003oool0003o
0?ooo`00nYX80?ooo`03003jVP3oool0oooo02H0oooo00<000000?ooo`00nYX0103oool01`3o0000
0?ZJ0?l0003o00000?ZJ0?l0003oool00P00nYX50?ooo`030000o`00nYX0oooo0080oooo00<0003o
003jVP3oool02`3oool20000o`030?ooo`000?l0o`000080o`0000<0oooo003jVP000?l01P3oool2
003jVP<0oooo0`00000?0?ooo`<0000000<0oooo0000o`3oool00`3oool00`00nYX0o`000?ooo`06
0?ooo`070?l00000nYX0oooo0?ooo`00nYX0o`000000o`0L0?ooo`800?ZJ0P3oool2003jVP040000
o`3oool0oooo0?ooo`80o`0000@00?ZJ0?ooo`3oool0003o0P3oool00`00nYX0o`000?l000050?oo
o`060000o`3o0000oooo0?ooo`00nYX0o`003@3oool00`000000oooo0?ooo`0S0?ooo`030000003o
ool0oooo00<0oooo00@00?ZJ0?l00000nYX00?ZJ0P3oool40000o`80oooo00<0o`000?ooo`3oool0
1@3oool01P000?l0o`000?l0003o0000oooo003jVPH0oooo00@00?ZJ0?ooo`3oool00?ZJ5@3oool2
003jVPX0oooo00D00?ZJ0000o`3oool0oooo003jVP080?ooo`<0000000<0oooo003jVP3oool01`3o
ool01@00nYX0o`000?l000000?l00?ZJ01d0oooo00<0o`000?ooo`00nYX00P3o00000`00nYX0oooo
0?ooo`0:0?ooo`03003jVP3oool0oooo00H0oooo00D00?ZJ0?l0003o0000003o003jVP080?ooo`80
003o00<0oooo0000003oool0?@3oool003/0oooo00@000000?ooo`3oool00000103oool2003jVPD0
oooo0P3o00002P3oool0o`000000o`3o0000oooo003jVP3o0000oooo0?l00000nYX70?ooo`800?ZJ
00@0o`000?ooo`3oool00?ZJ0`3oool01`00nYX0oooo0?ooo`3oool00?ZJ0?ooo`3o00000P3oool0
1@3o0000oooo0?ooo`3oool00?ZJ00@0oooo00<00?ZJ0?ooo`00nYX01@3oool01000nYX0oooo0?l0
003oool2003jVP<0oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?l000020?ooo`03003j
VP3oool0oooo00<0oooo00L00?ZJ0?ooo`3o00000?ZJ0?ooo`00nYX0oooo0080003o00<0o`000?oo
o`3oool00P3oool01@00nYX0o`000?ooo`000?l00?ZJ0180oooo00<00?ZJ0?ooo`3oool0103oool0
2P00nYX0oooo0?ooo`3oool0o`000?ooo`000?l0o`000?ooo`3o00030?ooo`03003jVP3oool0o`00
00<0o`000P3oool00`00nYX0o`000?ooo`030?ooo`070?l0003oool0oooo0?ooo`00nYX0o`000?oo
o`03003jVPP0oooo00<000000?ooo`3oool09P3oool010000000oooo0?ooo`00nYX30?ooo`070?l0
0000nYX0o`000?l00000nYX0o`000?ooo`02003jVPD0oooo00<0003o003jVP3oool00P3oool00`00
0?l00?ZJ0?ooo`0;0?ooo`<0003o0`000000103oool00?ZJ0?ooo`000?l60?ooo`030000o`00nYX0
0?ZJ0080oooo0`00000?0?ooo`<000000P3oool00`000?l0oooo0?ooo`03000000H0oooo0`000002
0?ooo`03003jVP3o0000003o01`0oooo0P00nYX20?ooo`800?ZJ0P000?l20?ooo`80o`0000@00?ZJ
0?ooo`3oool0003o0P3oool00`00nYX0o`000?l000050?ooo`060000o`3o0000oooo0?ooo`00nYX0
o`003@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo00<0oooo00@00?ZJ0?l00000
nYX00?ZJ0P3oool010000?l0oooo0000o`000?l20?ooo`030?l0003oool0oooo00D0oooo00<0003o
0?l0003o00000P3oool00`00nYX0oooo0?ooo`040?ooo`04003jVP3oool0003o003jVQD0oooo0P00
nYX:0?ooo`05003jVP000?l0oooo0?ooo`00nYX0203oool300000003003jVP3oool0oooo00L0oooo
00D00?ZJ0?l0003o0000003o003jVP0M0?ooo`060?l00000nYX00?ZJ0?l0003oool00?ZJ5@3oool0
1000nYX0o`000?l00000nYX90?ooo`80003o00<0oooo0000003oool0?@3oool003`0oooo0P000005
0?ooo`0300000000nYX0oooo00@0oooo0P3o00002P3oool0o`000000o`3o0000oooo003jVP3o0000
oooo0?l000000?l70?ooo`03003jVP3o00000?ZJ0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP03
0?ooo`03003jVP3oool0003o0080oooo00D0o`000?ooo`3oool0oooo003jVP020?ooo`80o`000`00
nYX50?ooo`03003jVP3oool0o`0000@00?ZJ0P3oool00`00nYX0oooo0?ooo`040?ooo`03003jVP3o
ool0o`000080oooo00<00?ZJ0?ooo`3oool0103o00000`3oool0o`00003jVP020000o`04003jVP00
0?l0003o0?l000@0oooo00<00?ZJ0?l00000nYX00P00nYXB0?ooo`800?ZJ1@3oool02P00nYX0oooo
0?ooo`3oool0o`000?ooo`000?l0o`000?ooo`3o00020?ooo`04003jVP3oool0o`000?l00080oooo
00<0o`000?ooo`3oool00P3o00040?ooo`080?l0003oool0oooo0?ooo`00nYX0o`00003jVP3oool2
003jVPP0oooo00<000000?ooo`3oool09P3oool2000000030?ooo`00nYX0oooo0080oooo0P3o0000
1@00nYX0o`00003jVP3o0000oooo00800?ZJ1@3oool00`000?l0oooo003jVP020?ooo`030000o`00
nYX0oooo00`0oooo0P000?l3000000040?ooo`00nYX0oooo0000o`L0oooo00<0003o003jVP00nYX0
0P3oool00`00nYX0oooo0?ooo`0>0?ooo`80003o0`3oool00`000?l0oooo0?ooo`03000000H0oooo
0`0000020?ooo`03003jVP3o0000003o01`0oooo0P00nYX20?ooo`800?ZJ0P000?l20?ooo`80o`00
00<00?ZJ0?ooo`3oool00P000?l0103oool00?ZJ0?l0003o00060?ooo`050?l0003oool0oooo003j
VP3o00003@3oool00`000000oooo0?ooo`0S0?ooo`800000103oool01000nYX0o`00003jVP00nYX2
0?ooo`040000o`3oool0003o0000o`80oooo00<0o`000?ooo`3oool01@3oool010000?l0o`000?l0
003oool2003jVPH0oooo00@00?ZJ0?ooo`00nYX00?ZJ5@3oool00`00nYX0oooo0?ooo`090?ooo`03
003jVP000?l0oooo00800?ZJ203oool300000003003jVP3oool0oooo00L0oooo00@00?ZJ0000o`3o
ool00?ZJ7P3oool01P3o00000?ZJ003jVP3o0000oooo003jVQD0oooo00@00?ZJ0?l0003o00000?ZJ
2P3oool00`000?l000000000000n0?ooo`00@`3oool00`0000000?ZJ0?ooo`040?ooo`80o`0000P0
oooo0?l000000?l0o`000?ooo`00nYX0oooo003jVPD0o`00103oool00`00nYX0o`00003jVP030?oo
o`800?ZJ00<0oooo003jVP3oool00`3oool01@00nYX0003o0?ooo`3oool0o`000080oooo0P00nYX0
103oool0o`000?l0003o0002003jVPH0oooo00D00?ZJ0?ooo`3o00000?ZJ0000o`020?ooo`<00?ZJ
1P3oool01@00nYX000000000000000000?ZJ0080oooo00P0o`000?ooo`3oool0oooo0?l0003oool0
o`000?ooo`<0003o0P00nYX00`3o0000oooo0?ooo`020?ooo`03003jVP3o00000?ZJ01D0oooo00<0
0?ZJ0?ooo`3oool00`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0o`0000L0oooo0?l0003oool0
oooo003jVP3oool0o`0000<0oooo00@0o`000?ooo`3oool0o`001@3oool01`3o0000oooo0?ooo`3o
ool00?ZJ0?l00000nYX02P3oool2000001/0oooo0`0000040?ooo`800000103oool010000000oooo
0?ooo`00nYX30?ooo`80o`0000H00?ZJ0?l0003o00000?ZJ0?ooo`000?l60?ooo`80003o00D00?ZJ
0?ooo`3oool0003o003jVP0?0?ooo`<000000P00nYX00`3oool0003o0?ooo`060?ooo`80003o0P00
nYX00`3oool00?ZJ0?ooo`0D0?ooo`80003o00@0oooo00000000000000001P3oool300000005003j
VP3oool0o`00003jVP000?l07@3oool00`00nYX0oooo0?ooo`02003jVP80003o0P3oool00`3o0000
0?ZJ0?ooo`030?ooo`050000o`3oool00?ZJ0?l00000nYX01P3oool01@3o0000oooo0?ooo`3o0000
0?ZJ00d0oooo00<000000?ooo`3oool05`3oool3000000<0oooo0P0000040?ooo`030000003oool0
oooo00<0oooo00H00?ZJ0?l00000nYX00?ZJ0?ooo`000?l20?ooo`80003o0P3oool00`3o0000oooo
0?ooo`050?ooo`<000000P00nYX70?ooo`03003jVP3oool00?ZJ0280oooo00D00?ZJ0000o`3oool0
0?ZJ0000o`090?ooo`80o`0000<00?ZJ0?ooo`3oool01`3oool01000nYX0003o0?ooo`00nYXN0?oo
o`060?l00000nYX00?ZJ0?l0003oool00?ZJ5@3oool01000nYX0003o0000o`00nYX<0?ooo`030000
003oool0oooo03`0oooo00130?ooo`030000003oool00?ZJ00@0oooo0P3o00001`3oool0o`000000
o`3o0000oooo003jVP3oool00`0000000`000?l0oooo0?ooo`020?l00080oooo00<00?ZJ0?l00000
nYX0103oool3003jVP@0oooo00D00?ZJ0000o`3oool0oooo0?l000020?ooo`06003jVP3oool0o`00
0?l0003oool0o`000P00nYX60?ooo`04003jVP3oool0o`00003jVP@0oooo0P00nYX60?ooo`07003j
VP000000000000000000nYX0oooo0?l000040?ooo`030?l0003oool0o`000080003o0`3oool00`00
nYX0o`000?ooo`030?ooo`03003jVP3o00000?ZJ01D0oooo00<00?ZJ0?ooo`3oool00`3oool01@00
nYX0oooo0?ooo`3oool00?ZJ0080o`0000<0oooo003jVP3o00000P3oool00`00nYX0o`000?l00003
0?ooo`050?l0003oool00?ZJ0?l0003oool00P00nYX00`000?l0oooo0?l000030?ooo`03003jVP3o
00000?ZJ00/0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo000000<0oooo00@000000?ooo`3oool00?ZJ0`3oool20?l00006003jVP3o0000o`00003j
VP3oool0003o1`3oool01@000?l00?ZJ003jVP3oool00?ZJ0180oooo0P00nYX20?ooo`030000o`3o
ool0oooo00H0oooo00<0003o0?ooo`00nYX00P00nYXF0?ooo`050000o`3oool0oooo0000o`00nYX0
203oool01P3o00000?ZJ0?ooo`3o00000?ZJ0000ob<0oooo0P000?l00`3oool0o`00003jVP040?oo
o`050000o`3oool00?ZJ0?l00000nYX01P3oool01@3o0000oooo0?ooo`3o00000?ZJ00d0oooo00<0
00000?ooo`3oool0603oool01@000000oooo0?ooo`3oool000000080oooo00D000000?ooo`3oool0
oooo000000050?ooo`03003jVP3o000000000080000000<0003o0?ooo`3oool00P000?l20?ooo`03
0?l0003oool0oooo00D0oooo0`0000000`00nYX0oooo0?ooo`060?ooo`03003jVP3oool00?ZJ0280
oooo00D00?ZJ0000o`3oool00?ZJ0000o`090?ooo`800?ZJ2P3oool01000nYX0003o0?ooo`00nYXN
0?ooo`050?l00000nYX0o`000000o`00nYX05P3oool01000nYX0003o0000o`00nYX<0?ooo`030000
003oool0oooo03`0oooo00130?ooo`030000003oool00?ZJ00@0oooo0P3o00001`3oool0o`000000
o`3o0000oooo003jVP000?l00`00000010000?l0oooo0?ooo`3oool20?l000040?ooo`00nYX0o`00
003jVP/0oooo00D00?ZJ0000o`00nYX00?ZJ0?l000020?ooo`03003jVP3oool0o`0000<0oooo00<0
o`000?ooo`3oool01@3oool01000nYX0oooo0?l00000nYX50?ooo`03003jVP3oool0oooo00@0oooo
00D00?ZJ0000000000000000003jVP020?l000@0oooo00@0o`00003jVP3o0000003o103oool30000
00<0oooo00<00?ZJ0?l00000nYX05P3oool00`00nYX0oooo0?ooo`020?ooo`05003jVP3oool0oooo
0?ooo`00nYX00P3o00000`3oool00?ZJ0?l000020?ooo`03003jVP3o0000oooo00<0oooo00@0o`00
0?ooo`00nYX0o`001000nYX00`3oool0o`000?ooo`020?ooo`03003jVP3o0000003o00/0oooo00<0
00000?ooo`3oool06P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo
0P0000000`3oool00?ZJ0?ooo`020?ooo`80o`0000D00?ZJ0?l0003o00000?ZJ0000o`080?ooo`05
0000o`3oool00?ZJ0?ooo`00nYX04P3oool20000o`80oooo00<0003o0?ooo`3oool01P3oool00`00
0?l0oooo0?ooo`020000oaH0oooo00@0003o0?ooo`3oool0003o2@3oool01@3o00000?ZJ0?ooo`3o
00000?ZJ02D0oooo00@0003o0?ooo`3o00000?ZJ103oool01@000?l0oooo0?ooo`3o00000?ZJ00H0
oooo00D0o`000?ooo`3oool0o`00003jVP0<0?ooo`8000005`3oool500000080oooo00@000000?oo
o`3oool000000`3oool3000000<0oooo00<00?ZJ0?l0000000000P00000010000?l0oooo0?ooo`00
0?l30?ooo`030?l0003oool0oooo00D0oooo0`0000090?ooo`030000o`00nYX00?ZJ0280oooo00D0
0?ZJ0000o`3oool00?ZJ0000o`090?ooo`800?ZJ2P3oool01000nYX0003o0?ooo`00nYXN0?ooo`05
0?l00000nYX0o`000000o`00nYX05P3oool01000nYX0oooo0000o`00nYX;0?ooo`800000?P3oool0
04<0oooo00<000000?ooo`00nYX0103oool20?l000050?ooo`3o0000003o0?l0003oool00P00nYX3
000000030000o`3oool0oooo0080oooo103o00000`000?l0oooo0?ooo`090?ooo`<00?ZJ00<0oooo
0?l0003oool00P00nYX20?l000050?ooo`00000000000000003oool00`3o00030?ooo`04003jVP3o
ool0o`000000o``0oooo00H00?ZJ0?ooo`3o00000?ZJ0?ooo`3o00050?ooo`040?l00000nYX0o`00
0000o`@0oooo0`0000030?ooo`030?l0003oool00?ZJ01H0oooo0`00nYX20?ooo`0:003jVP3oool0
oooo0?ooo`00nYX0o`000000o`00nYX0oooo0?l00080oooo00<00?ZJ0?l0003oool00`3oool02P3o
0000oooo003jVP3o00000?ZJ0000o`3oool0003o003jVP3o00030?ooo`030?l00000nYX0003o00/0
oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
00<0oooo00@000000?ooo`3oool00?ZJ0`3oool20?l00005003jVP3o0000o`00003jVP000?l0203o
ool00`000?l0oooo003jVP02003jVQ<0oooo00<0003o0?ooo`000?l02@3oool010000?l0oooo0?oo
o`000?lG0?ooo`040000o`3oool0oooo0000o`T0oooo00D0o`00003jVP3oool0o`00003jVP0V0?oo
o`<00000103oool010000?l0oooo0?ooo`3o00070?ooo`050?l0003oool0oooo0?l00000nYX03@3o
ool00`000000oooo0?ooo`0E0?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool0
00000`3oool00`000000oooo0?ooo`030?ooo`03003jVP3o000000000080000000<0003o0?ooo`3o
ool0103oool00`3o0000oooo0?ooo`060?ooo`800?ZJ2P3oool00`00nYX0003o0?ooo`0R0?ooo`04
003jVP000?l00?ZJ0000o`X0oooo00<00?ZJ0?ooo`3oool0203oool01000nYX0003o003jVP00nYXN
0?ooo`050?l000000?l0o`000000o`00nYX05`3oool2003jVPd0oooo00<000000?ooo`3oool0?03o
ool004<0oooo00<000000?ooo`00nYX0103oool20?l000050?ooo`3o0000003o0?l0003oool00P00
nYX30?ooo`03003jVP000?l0oooo00@0oooo0P3o00000`000?l0oooo0?ooo`0:0?ooo`080000o`3o
ool0oooo0?l0003oool00?ZJ0?ooo`3o00020?ooo`<000000P3o00000`3oool0o`000?l000030?l0
00030?ooo`3o0000003o00`0oooo0`00nYX30?l000D0oooo00@0o`00003jVP3o0000003o103oool3
000000<0oooo00<0o`00003jVP000?l0603oool01000nYX0oooo0?ooo`00nYX30?ooo`06003jVP3o
ool0oooo003jVP3oool0o`000P3oool00`00nYX0o`000?ooo`030?ooo`0:0?l0003oool00?ZJ0?l0
0000nYX0003o0?ooo`000?l00?ZJ0?l000<0oooo00<0o`00003jVP000?l02P3oool2000001`0oooo
00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo003j
VP<0oooo0P3o00001@00nYX0o`000?l00000nYX0003o00P0oooo00<0003o0?ooo`3oool00P00nYXC
0?ooo`030000o`3oool0003o00T0oooo00@0003o0?ooo`3oool0003o5`3oool010000?l0oooo0?oo
o`000?l90?ooo`05003jVP3o0000oooo0?l00000nYX09P3oool3000000@0oooo00@0003o00000000
000000001`3oool01@3o00000?ZJ0?ooo`3o00000?ZJ00d0oooo00<000000?ooo`3oool05P3oool0
0`000000oooo000000030?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00`3o
ool01P00nYX0o`000?ooo`3o0000oooo0000o`H0oooo00<0o`000?ooo`3oool01P3oool2003jVPX0
oooo0P000?lS0?ooo`800?ZJ00<0003o0?ooo`3oool0503oool01000nYX0003o003jVP000?lN0?oo
o`050?l000000?l0o`000000o`00nYX05`3oool2003jVPd0oooo00<000000?ooo`3oool0?03oool0
04<0oooo00@000000?ooo`3oool00?ZJ0`3oool20?l000040?ooo`3o00000?ZJ0?l00080oooo00@0
0?ZJ0?ooo`3oool0oooo0P00nYX00`000?l0oooo0?ooo`020?ooo`80o`0000<0003o0?ooo`3oool0
2`3oool01`000?l0oooo0?l0003oool00?ZJ0?ooo`3o00000P3oool3000000<0003o103oool0103o
0000oooo0?l000000?l>0?ooo`03003jVP3o0000o`0000H0oooo0P3o00000`00nYX0003o0?ooo`04
0?ooo`030?l00000nYX0oooo0080oooo00<0o`00003jVP000?l0603oool2003jVP030?ooo`00nYX0
oooo0080oooo00T00?ZJ0?ooo`00nYX00?ZJ0?ooo`3o0000oooo003jVP3o00000P3oool2003jVP05
0?ooo`3o0000oooo003jVP3o00000P000?l0103oool0003o0000o`3o00030?ooo`030?l00000nYX0
003o00/0oooo00<000000?ooo`3oool06@3oool2000000@0oooo00@000000?ooo`3oool000000`3o
ool010000000oooo0?ooo`00nYX30?ooo`80o`0000D00?ZJ0?l0003o00000?ZJ0000o`090?ooo`04
0000o`3oool0oooo003jVQ<0oooo00<0003o0?ooo`000?l02@3oool010000?l0oooo0?ooo`000?lG
0?ooo`040000o`3oool0oooo0000o`T0oooo00D00?ZJ0?l00000nYX0o`00003jVP0V0?ooo`<00000
1@3oool3000000H0oooo0`0000000`3oool0o`00003jVP0=0?ooo`030000003oool0oooo01L0oooo
0P0000030?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00`3oool01P00nYX0
o`000?ooo`3o0000oooo0000o`H0oooo00<0o`000?ooo`3oool04P3oool20000ob<0oooo0P00nYX0
0`000?l0oooo0?ooo`0D0?ooo`04003jVP3oool00?ZJ0000oah0oooo00<00?ZJ0?l0003o00000P00
nYXG0?ooo`800?ZJ3@3oool00`000000oooo0?ooo`0l0?ooo`00@`3oool010000000oooo0?ooo`00
nYX30?ooo`80o`0000@0oooo0?l00000nYX0o`000P3oool00`000?l0oooo0?ooo`020?ooo`03003j
VP000?l0oooo00<0oooo0P3o00000`000?l0oooo0?ooo`0;0?ooo`80003o00<0o`000?ooo`00nYX0
0P3o00030?ooo`030000o`00nYX0003o0080003o103oool0103o00000?ZJ0?l000000?l>0?ooo`05
003jVP3o0000o`000000o`3oool00P00nYX20?ooo`80o`0000<00?ZJ0?ooo`3oool0103oool00`3o
00000?ZJ0?ooo`020?ooo`030?l00000nYX0003o01T0oooo00<00?ZJ0?ooo`00nYX0103oool2003j
VP090000o`3oool0o`000?ooo`00nYX0o`000?ooo`00nYX0oooo00800?ZJ00@0o`000?ooo`3o0000
0?ZJ0P000?l20?ooo`030000o`3o0000oooo0080oooo00<0o`00003jVP000?l02`3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`80000000<0oooo003jVP3o
ool00P3oool20?l00005003jVP3o0000o`00003jVP000?l02@3oool010000?l0oooo0?ooo`000?lC
0?ooo`<0003o2@3oool010000?l0oooo0?ooo`000?lG0?ooo`80003o00<0oooo0000o`3oool0203o
ool01@00nYX0o`00003jVP3o00000?ZJ02h0oooo0`0000060?ooo`<0000000<0oooo0?l00000nYX0
3@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0080oooo0P0000040?ooo`800000
103oool01P00nYX0o`000?ooo`3o0000oooo0000o`H0oooo00<0o`000?ooo`3oool04P3oool20000
ob<0oooo0P00nYX00`000?l0oooo0?ooo`0E0?ooo`800?ZJ00<0003o0?ooo`3oool0703oool01000
nYX0o`000?l00000nYXH0?ooo`800?ZJ303oool2000003h0oooo00130?ooo`040000003oool0oooo
003jVP<0oooo0P3o0000103oool0o`00003jVP3o00020?ooo`030000o`3oool0oooo0080oooo0P00
nYX40?ooo`80o`0000<0003o0?ooo`3oool02`3oool20000o`040?l00000nYX0oooo0?l000<0oooo
1000nYX00`3oool0003o0?ooo`030?ooo`040?l00000nYX0o`000000o`l0oooo00<00?ZJ0000o`00
0?l01000nYX0103oool0o`000?l00000nYX60?ooo`030?l00000nYX0oooo0080oooo00<0o`00003j
VP000?l06P3oool2003jVP@0oooo0P00nYX01P000?l0oooo0?l0003oool00?ZJ0?l000800?ZJ0P3o
ool01P00nYX0o`000?ooo`3o00000?ZJ0000o`<0oooo00<0003o0?l0003oool00P3oool00`3o0000
0?ZJ0?ooo`0;0?ooo`030000003oool0oooo02H0oooo00@000000?ooo`3oool00?ZJ0`3oool20?l0
0005003jVP3o0000o`000?ooo`000?l02@3oool010000?l0oooo0?ooo`000?lC0?ooo`80003o2P3o
ool010000?l0oooo0?ooo`000?lH0?ooo`030000o`3oool0003o00T0oooo00D00?ZJ0?l0003oool0
o`00003jVP0^0?ooo`80003o1`3oool300000003003jVP3o0000003o00d0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`030?ooo`06003jVP3o0000oooo0?l00000nYX0003o1P3oool0
0`3o0000oooo0?ooo`0B0?ooo`80003o8`3oool2003jVP030000o`3oool0oooo01D0oooo0P00nYX0
0`000?l0oooo0?ooo`0L0?ooo`04003jVP3o0000003o003jVQP0oooo0P00nYX=0?ooo`030000003o
ool0oooo03`0oooo00130?ooo`040000003oool0oooo003jVP<0oooo0P3o0000103oool0o`00003j
VP3o00020?ooo`030000o`3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool20?l000030000
o`3oool0oooo00`0oooo00H0003o0?l00000nYX0oooo0?l0003oool4003jVP030?ooo`00nYX00?ZJ
0080003o0`3oool00`3o00000?ZJ0?l0000@0?ooo`04003jVP000?l00?ZJ0000o`80oooo0P00nYX2
0?l00003003jVP3oool0oooo00@0oooo00P00?ZJ0?l0003oool0oooo003jVP3o00000?ZJ0000oaX0
oooo0P00nYX40?ooo`800?ZJ00L0oooo0000o`3o0000oooo003jVP3o00000?ZJ00@0oooo00@0o`00
0?ooo`3o00000?ZJ103oool00`000?l0o`000?ooo`020?ooo`030?l00000nYX0oooo00X0oooo0P00
000X0?ooo`050000003oool0oooo0?ooo`00nYX00P3oool20?l00005003jVP3o0000o`000?ooo`00
0?l02@3oool010000?l0oooo0?ooo`000?lO0?ooo`040000o`3oool0oooo0000oaP0oooo00<0003o
0?ooo`000?l02P3oool0103o0000oooo0?l00000nYX^0?ooo`80003o2@3oool0103o00000?ZJ0?l0
00000?l=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00`3oool01P00nYX0o`00
0?ooo`3o00000?ZJ0000o`H0oooo00<0o`000?ooo`3oool04P3oool00`000?l0oooo0?ooo`0R0?oo
o`03003jVP000?l0003o01L0oooo0P00nYX00`000?l0oooo0?ooo`0L0?ooo`03003jVP3o00000?ZJ
01T0oooo00<00?ZJ0?ooo`3oool0303oool00`000000oooo0?ooo`0l0?ooo`00@`3oool010000000
oooo0?ooo`00nYX30?ooo`80o`0000D0oooo0?l00000nYX0o`000?ooo`020000o`D0oooo0P00nYX3
0?ooo`80o`003`3oool3000000060?l0003oool0oooo003jVP3oool0003o0`3oool2003jVP040000
o`3oool0oooo0?ooo`80o`0000<00?ZJ0?ooo`3oool03P3oool3003jVP80003o0P3oool01000nYX0
o`000?l000000?l60?ooo`08003jVP3o0000oooo0?ooo`00nYX0o`00003jVP000?lK0?ooo`03003j
VP3oool0oooo00D0oooo00L0003o0?l0003oool00?ZJ0?l00000nYX0003o00<0oooo00@0o`000?oo
o`3o00000?ZJ1@3oool01P3o0000oooo0?ooo`3oool0o`00003jVP`0oooo00<000000?ooo`3oool0
9P3oool01@000000oooo0?ooo`3oool00?ZJ0080oooo0P3o00001@00nYX0o`000?l0003oool0003o
00T0oooo00@0003o0?ooo`3oool0003o803oool00`000?l0oooo0000o`0H0?ooo`030000o`3oool0
003o00X0oooo00@0o`000?ooo`3o0000003o;P3oool20000o`T0oooo00@0o`000?ooo`3o0000003o
3@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo00<0oooo00<00?ZJ0?ooo`3o0000
0P3o00000`000?l0oooo0?ooo`040?ooo`030?l0003oool0oooo0180oooo00<0003o0?ooo`3oool0
8`3oool20000oaL0oooo00<00?ZJ0000o`000?l07P3oool00`00nYX0o`00003jVP0X0?ooo`030000
003oool0oooo03`0oooo00130?ooo`040000003oool0oooo003jVP<0oooo0P3o00001P3oool0o`00
0?l00000nYX0oooo0000o`L0oooo00@00?ZJ0?ooo`3oool0oooo0P3o000?0?ooo`<0000000H0o`00
0?ooo`00nYX00?ZJ0?ooo`000?l40?ooo`03003jVP000?l0oooo0080oooo0P3o00000`00nYX0oooo
0?ooo`0>0?ooo`800?ZJ0P3oool010000?l0oooo0?ooo`3oool20?l000030000o`3oool0oooo00@0
oooo00P00?ZJ0?l0003oool0oooo003jVP3o00000?ZJ0000oa/0oooo00<00?ZJ0?ooo`3oool01@3o
ool01@000?l0o`000?ooo`3o00000?ZJ00@0003o00D0oooo0?l0003oool0o`00003jVP040?ooo`<0
00000P3oool00`3o0000003o0?ooo`0;0?ooo`030000003oool0oooo02H0oooo0P0000020?ooo`03
003jVP3oool0oooo0080o`0000D00?ZJ0?l0003o0000oooo0000o`090?ooo`040000o`3oool0oooo
0000ob00oooo00<0003o0?ooo`000?l0603oool00`000?l0oooo0000o`0:0?ooo`040?l0003oool0
o`000000obh0oooo00<0003o0?ooo`3oool0203oool0103o0000oooo0?l000000?l=0?ooo`030000
003oool0oooo02<0oooo0P0000040?ooo`03003jVP3oool0o`000080o`0000<0003o0?ooo`3oool0
103oool00`3o0000oooo0?ooo`0h0?ooo`80003o603oool00`000?l0oooo0?ooo`0M0?ooo`03003j
VP000?l00?ZJ02L0oooo0P00000n0?ooo`00@`3oool010000000oooo0?ooo`00nYX30?ooo`80o`00
00H0oooo003jVP3o00000?ZJ0?ooo`000?l70?ooo`04003jVP3oool0oooo0?ooo`80o`003`3oool3
000000030?l0003oool00?ZJ0080oooo00<0003o0?ooo`3oool00P3oool2003jVP<0oooo0P3o0000
0`00nYX0oooo0?ooo`0C0?ooo`030000o`3oool0oooo0080o`0000<0003o0?ooo`3oool01@3oool0
1`3o0000003o0?ooo`00nYX0o`00003jVP000?l06`3oool00`00nYX0oooo0?ooo`050?ooo`050000
o`3o00000?ZJ0?l00000nYX010000?l01@3oool0o`00003jVP3o0000003o00@0oooo0`000000103o
ool00?ZJ0?l000000?l<0?ooo`030000003oool0oooo02H0oooo00D000000?ooo`3oool0oooo003j
VP020?ooo`80o`0000D00?ZJ0?l0003o0000oooo0000o`0:0?ooo`030000o`3oool0003o0200oooo
0P000?lI0?ooo`030000o`3oool0003o00X0oooo00@00?ZJ0?l00000nYX0003o>@3oool0103o0000
oooo0?l000000?l=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00`3oool00`00
nYX0oooo0?l000020?l000030000o`3oool0oooo00@0oooo00<0o`000?ooo`3oool0>03oool20000
ocP0oooo00<00?ZJ0000o`00nYX0:03oool00`000000oooo0?ooo`0l0?ooo`00@`3oool010000000
oooo0?ooo`00nYX30?ooo`80o`0000H0oooo003jVP3o00000?ZJ0?ooo`000?l70?ooo`040000o`00
nYX0oooo0?ooo`80o`00403oool01P00nYX0003o0?ooo`3oool00?ZJ0?ooo`80003o1@3oool2003j
VP80oooo0P3o00000`00nYX0oooo0?ooo`0C0?ooo`030000o`3oool0oooo0080o`0000<0003o0?oo
o`3oool01@3oool01`3o00000?ZJ0?ooo`00nYX0o`00003jVP000?l08`3oool30000000;0?l00000
nYX0003o0?ooo`000?l0oooo0000o`3o00000?ZJ0?l000000?l0103oool3000000040?ooo`00nYX0
o`000000o``0oooo00<000000?ooo`3oool09P3oool01@000000oooo0?ooo`3oool00?ZJ0080oooo
0P3o00001@00nYX0o`000?l0003oool0003o00X0oooo00<0003o0?ooo`000?l08@3oool00`000?l0
oooo0?ooo`0G0?ooo`<0003o2P3oool01000nYX0o`00003jVP000?li0?ooo`04003jVP3o00000?ZJ
0000o`d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0
o`000080o`0000<0003o0?ooo`3oool0103oool00`3o0000oooo0?ooo`0h0?ooo`80003o>03oool0
0`00nYX0003o003jVP0X0?ooo`030000003oool0oooo03`0oooo00130?ooo`040000003oool0oooo
003jVP<0oooo0P3o00001P3oool00?ZJ0?l00000nYX0oooo0000o`P0oooo00<00?ZJ0?ooo`3oool0
0P3o000@0?ooo`04003jVP000?l0003o003jVP80oooo00<0003o0?ooo`3oool01@3oool2003jVP80
oooo00<0o`000000o`3oool0503oool00`000?l0oooo0?ooo`020?l000P0oooo00L0o`00003jVP3o
ool00?ZJ0?l0003oool0003o02<0oooo0`0000000`3o00000?ZJ0?ooo`030?ooo`040000o`3o0000
0?ZJ0?l000H0oooo00H0o`000?ooo`3oool00?ZJ0?l000000?l;0?ooo`800000:03oool200000080
oooo00<00?ZJ0?ooo`3oool00P3o00001@00nYX0o`000?l0003oool0003o00X0oooo00<0003o0?oo
o`000?l08@3oool00`000?l0oooo0?ooo`0H0?ooo`030000o`3oool0oooo00T0oooo00@00?ZJ0?oo
o`00nYX0003o>@3oool01000nYX0o`00003jVP000?l=0?ooo`030000003oool0oooo02<0oooo0P00
00040?ooo`03003jVP3oool0o`000080o`0000<0003o0?ooo`3oool0103oool00`3o0000oooo0?oo
o`1c0?ooo`800?ZJ9`3oool2000003h0oooo00130?ooo`040000003oool0oooo003jVP@0oooo00L0
o`000?ooo`00nYX0o`00003jVP3oool0003o00P0oooo0P00nYX00`3oool0o`000?l0000@0?ooo`@0
0?ZJ0P3oool00`000?l0oooo0?ooo`050?ooo`060000o`00nYX00?ZJ0?ooo`3o0000003o5@3oool0
0`000?l0oooo0?ooo`020?l000P0oooo00H0o`00003jVP3oool00?ZJ0?l000000?lT0?ooo`<00000
00<0o`00003jVP3oool00`3oool010000?l0o`00003jVP3o00060?ooo`060?l00000nYX0oooo003j
VP3o0000003o303oool00`000000oooo0?ooo`0V0?ooo`050000003oool0oooo0?ooo`00nYX00P3o
ool20?l00005003jVP3o0000o`000?ooo`000?l02P3oool00`000?l0oooo0000o`180?ooo`04003j
VP000?l00?ZJ0000ocT0oooo00<00?ZJ0?ooo`00nYX03P3oool00`000000oooo0?ooo`0S0?ooo`03
0000003oool0oooo00<0oooo00<00?ZJ0?ooo`3o00000P3o00000`000?l0oooo0?ooo`040?ooo`03
0?l0003oool0oooo07<0oooo00<00?ZJ0000o`3oool09`3oool00`000000oooo0?ooo`0l0?ooo`00
=@3oool3000000@0oooo0P0000050?ooo`050000003oool0oooo0?ooo`00nYX00`3oool01`3o0000
oooo003jVP3o00000?ZJ0?ooo`000?l0203oool00`000?l00?ZJ0?ooo`020?l00140oooo0P00nYX2
0?ooo`80003o1`3oool01@000?l0oooo003jVP00nYX0o`0001H0oooo00<0003o0?ooo`3oool00P3o
00080?ooo`060?l00000nYX0oooo003jVP3o0000003o9@3oool00`00nYX0o`00003jVP050?ooo`04
0000o`3o0000o`00003jVPH0oooo00H0o`00003jVP3oool00?ZJ0?l000000?l<0?ooo`030000003o
ool0oooo02H0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`80o`000P00nYX00`3o0000003o
0000o`0:0?ooo`80003oB@3oool01000nYX0003o003jVP000?li0?ooo`03003jVP000?l00?ZJ00h0
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0o`000080
o`0000<0003o0?ooo`3oool0103oool00`3o0000oooo0?ooo`1c0?ooo`03003jVP3oool0oooo02L0
oooo00<000000?ooo`3oool0?03oool003H0oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`0000040?ooo`050000003oool0oooo0?ooo`00nYX00`3oool01`00nYX0oooo0?ooo`00nYX0
003o0?ooo`000?l0203oool00`000?l00?ZJ0?ooo`020?l00180oooo00<0003o0?ooo`3oool00P00
0?l70?ooo`050000o`3oool0oooo003jVP3o00005P3oool00`000?l0oooo0?ooo`020?l000P0oooo
00H0o`00003jVP3oool00?ZJ0?l000000?lU0?ooo`03003jVP3oool00?ZJ00H0oooo0P3o00000`00
nYX0oooo0?ooo`040?ooo`06003jVP3o0000oooo003jVP3o0000003o303oool00`000000oooo0?oo
o`0V0?ooo`050000003oool0oooo0?ooo`00nYX00P3oool20?l000<00?ZJ00<0003o0?ooo`3oool0
2@3oool20000odT0oooo00@00?ZJ0000o`00nYX0003o>P3oool2003jVPh0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`030?ooo`06003jVP3oool0o`00003jVP3o0000003o1P3oool0
0`3o0000oooo0?ooo`1c0?ooo`03003jVP3oool0oooo02L0oooo00<000000?ooo`3oool0?03oool0
03H0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000040?ooo`8000000P3oool0
1@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00@00?ZJ0000o`3oool0003o203oool00`000?l00?ZJ
003jVP020?l00180oooo0P000?l00`3oool0003o0?ooo`070?ooo`80003o00<0oooo003jVP3o0000
5P3oool00`000?l0oooo0?ooo`020?l000P0oooo00H00?ZJ0?l0003oool0o`00003jVP000?lV0?oo
o`800?ZJ1P3oool20?l00003003jVP3oool0oooo00@0oooo00H00?ZJ0?l0003oool0o`00003jVP00
0?l;0?ooo`800000:03oool200000080oooo00<00?ZJ0?ooo`3oool00P3o0003003jVP030000o`3o
ool0oooo00T0oooo0P000?m:0?ooo`03003jVP3oool0003o03X0oooo00<00?ZJ0000o`3oool03@3o
ool00`000000oooo0?ooo`0S0?ooo`800000103oool01P00nYX0oooo0?l00000nYX0o`000000o`H0
oooo00<0o`000?ooo`3oool0L`3oool00`00nYX0oooo0?ooo`0V0?ooo`800000?P3oool003H0oooo
00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000040?ooo`050000003oool0oooo0?oo
o`00nYX00`3oool01`00nYX0oooo0?ooo`00nYX0003o0?ooo`000?l0203oool01@000?l0oooo003j
VP3o00000?ZJ01<0oooo0`000?l80?ooo`80003o00<0oooo003jVP3o00005P3oool00`000?l0oooo
0?ooo`020?l000P0oooo00H00?ZJ0?l00000nYX0o`00003jVP000?lV0?ooo`03003jVP3oool0oooo
00D0oooo0P3o00000`00nYX0oooo0?ooo`040?ooo`06003jVP3o0000oooo0?l00000nYX0003o303o
ool00`000000oooo0?ooo`0H0?ooo`D000000`3oool2000000@0oooo00D000000?ooo`3oool0oooo
003jVP030?ooo`@00?ZJ00<0003o0?ooo`3oool0E@3oool00`00nYX0oooo0000o`0j0?ooo`03003j
VP000?l0oooo00d0oooo00<000000?ooo`3oool05P3oool3000000@0oooo0P0000040?ooo`030000
003oool0oooo00<0oooo00H00?ZJ0?ooo`3oool00?ZJ0?l000000?l60?ooo`030?l0003oool0oooo
09d0oooo00<000000?ooo`3oool0?03oool003H0oooo00<000000?ooo`3oool00P3oool010000000
oooo0?ooo`0000040?ooo`050000003oool0oooo0?ooo`00nYX00`3oool01000nYX0oooo0?ooo`00
nYX20000o`T0oooo0P000?l00`3oool0o`00003jVP0C0?ooo`<0003o2@3oool010000?l0oooo0?oo
o`3o000F0?ooo`80003o00<0oooo0?l00000nYX0203oool01P00nYX0o`00003jVP3o00000?ZJ0000
obd0oooo0`0000080?ooo`050?l0003oool0o`00003jVP000?l0303oool00`000000oooo0?ooo`0I
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000`3oool01@000000oooo
0?ooo`3oool00?ZJ00<0oooo1000nYX00`000?l0oooo0?ooo`1E0?ooo`030000o`3oool0003o03/0
oooo00<0003o0?ooo`3oool0303oool00`000000oooo0?ooo`0E0?ooo`050000003oool0oooo0?oo
o`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00<0oooo00H00?ZJ
0?ooo`3oool00?ZJ0?l000000?l60?ooo`030?l0003oool0oooo09d0oooo00<000000?ooo`3oool0
?03oool003D0oooo0P0000040?ooo`040000003oool0oooo000000@0oooo00D000000?ooo`3oool0
oooo003jVP030?ooo`04003jVP3oool0oooo0?ooo`80003o2P3oool010000?l0oooo0?l00000nYXO
0?ooo`040000o`0000000000000001L0oooo00@0003o0?ooo`3o00000?ZJ203oool01P00nYX0o`00
003jVP3o00000?ZJ0000obd0oooo0`0000080?ooo`040?l00000nYX0o`00003jVPd0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00D0
00000?ooo`3oool0oooo003jVP030?ooo`@00?ZJ00<0003o0?ooo`3oool0E@3oool20000oc`0oooo
00<0003o0?ooo`3oool0303oool00`000000oooo0?ooo`0I0?ooo`040000003oool0oooo00000080
oooo00D000000?ooo`3oool0oooo000000050?ooo`06003jVP3oool0oooo003jVP3o0000003o1P3o
ool00`3o0000oooo0?ooo`2M0?ooo`030000003oool0oooo03`0oooo000f0?ooo`030000003oool0
oooo00<0oooo0P0000050?ooo`050000003oool0oooo0?ooo`00nYX00`3oool01000nYX0oooo0?oo
o`3oool20000o`X0oooo00@0003o0?ooo`3o0000003o7`3oool010000?l0000000000000000G0?oo
o`040000o`3oool0o`00003jVPT0oooo00D0o`000000o`3o00000?ZJ0000o`0]0?ooo`<00000203o
ool0103o00000?ZJ0?l00000nYX<0?ooo`8000007@3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool0oooo0P0000020?ooo`04003jVP3oool0oooo0?ooo`800?ZJ00<0oooo
003jVP3oool0E`3oool20000odX0oooo0P00000K0?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool0oooo0`0000030?ooo`06003jVP3oool0oooo003jVP3o0000003o1P3oool00`3o
0000oooo0?ooo`2L0?ooo`800000?P3oool004<0oooo00D000000?ooo`3oool0oooo003jVP030?oo
o`03003jVP3oool0oooo0080oooo00<0003o0?ooo`3oool0203oool010000?l0oooo0?l000000?lO
0?ooo`040000o`0000000000000001L0oooo00@0003o0?ooo`3o0000003o2@3oool01@3o0000003o
0?l00000nYX0003o02h0oooo0P00nYX80?ooo`040?l00000nYX0o`00003jVPd0oooo00<000000?oo
o`3oool0603oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3o
ool01@000000oooo0?ooo`3oool00?ZJ00<0oooo0P00nYYK0?ooo`030000o`3oool0oooo04T0oooo
00<000000?ooo`3oool05@3oool4000000<0oooo00@000000?ooo`3oool000000`3oool00`000000
oooo0?ooo`030?ooo`06003jVP3oool0oooo003jVP3o0000003o1P3oool00`3o0000oooo0?ooo`2M
0?ooo`030000003oool0oooo03`0oooo00130?ooo`050000003oool0oooo0?ooo`00nYX00`3oool0
0`00nYX0oooo0?ooo`020?ooo`030000o`3oool0oooo00P0oooo00<0003o0?ooo`3o00008@3oool2
0000oaP0oooo0P000?l00`3o0000003o0?ooo`080?ooo`050?l000000?l0o`00003jVP000?l0>03o
ool0103o0000003o0?l00000nYX=0?ooo`030000003oool0oooo01P0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo000000<0oooo00D000000?ooo`3oool0oooo003jVP03
0?ooo`800?ZJF`3oool00`000?l0oooo0?ooo`190?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00@0oooo00D0
0?ZJ0?ooo`00nYX0o`000000o`060?ooo`030?l0003oool0oooo09d0oooo00<000000?ooo`3oool0
?03oool004<0oooo00D000000?ooo`3oool0oooo003jVP030?ooo`03003jVP3oool0oooo0080oooo
00<0003o0?ooo`3oool0203oool00`000?l0oooo0?l0000Q0?ooo`030000o`3oool0oooo01P0oooo
00<0003o0?l000000?l02@3oool01@3o0000003o0?l00000nYX0003o03P0oooo00@0o`000000o`3o
0000003o3@3oool00`000000oooo0?ooo`0I0?ooo`<00000103oool2000000@0oooo0P0000020?oo
o`04003jVP3oool0oooo0?ooo`800?ZJF`3oool00`000?l0oooo0?ooo`190?ooo`030000003oool0
oooo01D0oooo1@0000030?ooo`800000103oool2000000D0oooo00D00?ZJ0?ooo`00nYX0o`000000
o`060?ooo`030?l0003oool0oooo09`0oooo0P00000n0?ooo`00@`3oool01@000000oooo0?ooo`3o
ool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool03@3oool00`000?l0oooo0?l0000Q0?ooo`030000o`3o
ool0oooo01P0oooo00<0003o0?l0003oool02@3oool01@00nYX0o`000?l0003oool0003o03P0oooo
00@00?ZJ0?l0003o0000003o3@3oool00`000000oooo0?ooo`0V0?ooo`050000003oool0oooo0?oo
o`00nYX00`3oool2003jVZL0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`040?oo
o`05003jVP3oool00?ZJ0?l000000?l01P3oool00`3o0000oooo0?ooo`2M0?ooo`030000003oool0
oooo03`0oooo00130?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0>
0?ooo`030000o`3o0000oooo03/0oooo0`0000090?ooo`05003jVP3o00000?ZJ0?ooo`000?l0>03o
ool01000nYX0o`00003jVP000?l<0?ooo`800000:03oool01@000000oooo0?ooo`3oool00?ZJ00<0
oooo0P00nYZW0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0103oool01@00nYX0
oooo003jVP3o00000?ZJ00H0oooo00<0o`000?ooo`3oool0W@3oool00`000000oooo0?ooo`0l0?oo
o`00@`3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool03P3oool00`00
0?l0o`000?ooo`0k0?ooo`<000002@3oool01@00nYX0003o003jVP3oool0003o03P0oooo00@00?ZJ
0?l00000nYX0003o3@3oool00`000000oooo0?ooo`0V0?ooo`050000003oool0oooo0?ooo`00nYX0
0`3oool2003jVZL0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`040?ooo`05003j
VP3oool00?ZJ0?l00000nYX01@3oool00`00nYX0o`000?ooo`2N0?ooo`030000003oool0oooo03`0
oooo00130?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0>0?ooo`03
0000o`00nYX0oooo03/0oooo0`0000090?ooo`04003jVP000?l00?ZJ0000ocT0oooo00@00?ZJ0?oo
o`00nYX0003o3@3oool00`000000oooo0?ooo`0V0?ooo`8000000P3oool01000nYX0oooo0?ooo`3o
ool2003jVZL0oooo00<000000?ooo`3oool08`3oool2000000D0oooo00@00?ZJ0?ooo`00nYX0o`00
0P00nYX40?ooo`03003jVP3o0000oooo09d0oooo0P00000n0?ooo`00@`3oool01@000000oooo0?oo
o`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool03P3oool3000004L0oooo00@00?ZJ0?ooo`00nYX0
003o>@3oool00`00nYX0oooo003jVP0>0?ooo`030000003oool0oooo02H0oooo00D000000?ooo`3o
ool0oooo003jVP030?ooo`800?ZJY`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
00@0oooo00@00?ZJ0?ooo`00nYX0o`000P00nYX30?ooo`800?ZJ00<0o`000?ooo`3oool0W@3oool0
0`000000oooo0?ooo`0l0?ooo`00@`3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ
0?ooo`3oool03P3oool3000004L0oooo00@00?ZJ0?ooo`00nYX0003o>P3oool2003jVPd0oooo0P00
000X0?ooo`050000003oool0oooo0?ooo`00nYX00`3oool2003jVZL0oooo00<000000?ooo`3oool0
8`3oool00`000000oooo0?ooo`040?ooo`04003jVP3oool00?ZJ0?l000800?ZJ0P3oool2003jVP03
0?ooo`3o0000oooo09h0oooo00<000000?ooo`3oool0?03oool004<0oooo00D000000?ooo`3oool0
oooo003jVP030?ooo`03003jVP3oool0oooo00h0oooo0`0000180?ooo`800?ZJ00<0003o0?ooo`3o
ool0>03oool2003jVPh0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`020?ooo`03
003jVP3oool0oooo00800?ZJY`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo00@0
oooo0`00nYX00`3o00000?ZJ003jVP03003jVP80oooo00<0o`000?ooo`3oool0W@3oool00`000000
oooo0?ooo`0l0?ooo`00@`3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3o
ool03`3oool00`000?l0oooo0?ooo`170?ooo`800?ZJ>`3oool00`00nYX0oooo0?ooo`0=0?ooo`03
0000003oool0oooo02H0oooo0P0000030?ooo`03003jVP3oool0oooo00800?ZJY`3oool00`000000
oooo0?ooo`0S0?ooo`8000001@3oool3003jVP040?l00000nYX00?ZJ003jVP@0oooo00<0o`000?oo
o`3oool0W03oool2000003h0oooo00130?ooo`030000003oool0oooo0080oooo00@00?ZJ0?ooo`3o
ool00?ZJF`3oool00`00nYX0oooo0?ooo`1:0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool00P3oool00`00nYX0oooo0?ooo`02003jVZL0oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`040?ooo`<00?ZJ00@0o`000?ooo`00nYX00?ZJ103oool00`3o0000oooo0?ooo`2M
0?ooo`030000003oool0oooo03`0oooo00130?ooo`030000003oool0oooo0080oooo00@00?ZJ0?oo
o`3oool00?ZJZ03oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo0080oooo00<00?ZJ
0?ooo`3oool00P00nYZW0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0103oool3
003jVP80o`001P3oool00`3o0000oooo0?ooo`2M0?ooo`030000003oool0oooo03`0oooo00130?oo
o`030000003oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJY`3oool2000002P0oooo0P000003
0?ooo`03003jVP3oool0oooo00800?ZJY`3oool00`000000oooo0?ooo`0S0?ooo`8000001@3oool3
003jVP80o`001P3oool00`3o0000oooo0?ooo`2L0?ooo`800000?P3oool003@0oooo1@0000030?oo
o`8000001@3oool00`000000oooo0?ooo`020?ooo`04003jVP3oool0oooo003jVZP0oooo00<00000
0?ooo`3oool06@3oool3000000@0oooo0P0000040?ooo`030000003oool0oooo0080oooo00<00?ZJ
0?ooo`3oool00P00nYZW0?ooo`030000003oool0oooo01H0oooo0`0000040?ooo`800000103oool0
0`000000oooo0?ooo`040?ooo`<00?ZJ0P3o00060?ooo`030?l0003oool0oooo09d0oooo00<00000
0?ooo`3oool0?03oool003D0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00040?ooo`030000003oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJZ03oool00`000000oooo
0?ooo`0H0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?oo
o`030000003oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJZ03oool00`000000oooo0?ooo`0E
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000
003oool0oooo00@0oooo0`00nYX20?l000H0oooo00<0o`000?ooo`3oool0W@3oool00`000000oooo
0?ooo`0l0?ooo`00=P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000@0oooo
00<000000?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX80?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01`0
oooo00@000000?ooo`3oool000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo00D00?ZJ
0?ooo`3oool00?ZJ000000080?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01D0oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool3003jVP03
0?l0003oool0o`0000D0oooo00<0o`000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0?03oool003L0oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo0080oooo1@0000001000nYX0000000000000nYZY0000
01`0oooo0P0000030?ooo`040000003oool0oooo000000<0oooo1@0000001000nYX0000000000000
nYZY000001L0oooo100000030?ooo`040000003oool0oooo000000<0oooo1`000004003jVP030000
003o0000000000@0000000<0o`00000000000000WP00000n0?ooo`00=03oool01@000000oooo0?oo
o`3oool000000080oooo00@000000?ooo`3oool00000e03oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0<X0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00003d
0?ooo`00=03oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000d03o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000c@3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000?@0oooo000e0?ooo`<00000103oool200000=80
oooo0`0000040?ooo`800000c`3oool2000000@0oooo0P00003e0?ooo`00o`3ooomd0?ooo`<00000
o`3ooom`0?ooo`00o`3ooome0?ooo`030000003oool0oooo0?l0ooooK`3oool009P0oooo0P000000
0`3oool000000000003H0?ooo`030000003oool0oooo0=80oooo1@00002F0?ooo`00V@3oool00`00
0000oooo0000003I0?ooo`030000003oool0oooo0=<0oooo00@000000?ooo`3oool00000UP3oool0
09X0oooo00<000000?ooo`3oool0e`3oool00`000000oooo0000003E0?ooo`030000003oool0oooo
09H0oooo002I0?ooo`030000003oool000000=P0oooo00<000000?ooo`000000d`3oool010000000
oooo0?ooo`00002G0?ooo`00V03oool2000000030?ooo`00000000000=H0oooo0P0000000`3oool0
00000000003B0?ooo`D00000UP3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo003o
0?ooool0ooooi`3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo003o0?ooool0oooo
i`3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo003o0?ooool0ooooi`3oool00?l0
ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo003o0?ooool0ooooi`3oool00?l0ooooo`3ooooW
0?ooo`00o`3ooooo0?ooonL0oooo003o0?ooool0ooooi`3oool00?l0ooooo`3ooooW0?ooo`00o`3o
oooo0?ooonL0oooo003o0?ooool0ooooi`3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0
oooo003o0?ooof00oooo00<000000?ooo`3oool04`3oool3000000<0oooo0`00003o0?ooofP0oooo
003o0?ooof40oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo0?l0ooooI`3oool00?l0ooooCP3oool200000080oooo0`0000000`3oool0000000000003
000000H0oooo00<000000?ooo`3oool01P3oool2000000030?ooo`00000000000080oooo10000002
0?ooo`<000000`3oool3000000<0oooo100000020?ooo`@00000203oool300000?l0ooooC`3oool0
0?l0ooooC@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool03`3oool00`000000oooo000000020?ooo`040000003oool0oooo000000<0oooo
00@000000?ooo`3oool000000P3oool01P000000oooo0?ooo`000000oooo00000080oooo00<00000
0?ooo`3oool0303oool01@000000oooo0?ooo`3oool000000?l0ooooCP3oool00?l0ooooC@3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool03`3o
ool2000000@0oooo0`0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool3000000<0oooo100000020?ooo`@000001@3oool00`000000oooo0?ooo`3o0?oood`0
oooo003o0?ooodd0oooo00@000000?ooo`3oool000000P3oool2000000@0oooo0`00000?0?ooo`03
0000003oool000000080oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`000002
0?ooo`060000003oool0oooo0000003oool000000P3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo0?l0ooooC03oool00?l0ooooC@3oool010000000oooo0?ooo`0000020?ooo`030000
003oool0000000<0oooo00<000000?ooo`3oool03`3oool010000000oooo0000000000020?ooo`80
00000`3oool400000080oooo100000030?ooo`8000003`3oool400000?l0ooooC`3oool00?l0oooo
C@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000003P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo0?l0ooooD03oool0
0?l0ooooC03oool3000000030?ooo`000000000000<0000000<0oooo0000000000001@00000=0?oo
o`800000:03oool500000?l0ooooCP3oool00?l0ooooo`3ooooW0?ooo`00o`3ooooo0?ooonL0oooo
0000\
\>"],
  ImageRangeCache->{{{0, 740}, {304.188, 0}} -> {-0.193375, -0.0309084, \
0.00457669, 0.00457669}, {{42.25, 260.75}, {297.375, 162.375}} -> {-395.551, \
1.70902, 5.64631, 0.182536}, {{260.75, 479.25}, {297.375, 162.375}} -> \
{-1595.39, 17.5318, 5.64631, 0.136902}, {{479.25, 697.688}, {297.375, \
162.375}} -> {-2812, -1.31639, 5.64631, 0.0730144}, {{42.25, 260.75}, \
{162.375, 27.3125}} -> {-378.134, -99.7954, 5.64322, 0.456089}, {{260.75, \
479.25}, {162.375, 27.3125}} -> {-1611.18, -113.754, 5.64322, 0.547306}, \
{{479.25, 697.688}, {162.375, 27.3125}} -> {-2827.11, -83.7544, 5.64322, \
0.547306}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["HNF(2,2) (with 1/4 f'' M4 f'')", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tHNF22[{ZM[[All]], X}, Theta+1, 
\t     {driftLorenzX, DdriftLorenzX,DDdriftLorenzX,
\t      OmegaLorenzX, DDOmegaLorenzX,
\t      hLorenzX, DhLorenzX, RLorenzX, mueLorenzX,sigmaLorenzX,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1.9577810000000113`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["YF//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1001, 6}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({91.04657774580946`, 150.24159737198272`, 160.37692819005485`, 
      28.322492481535523`, 15.644266384113926`, 
      9.478478727060098`}\)], "Output"],

Cell[BoxData[
    \({{\(-0.18080706793888926`\), \(-0.34722388300764573`\), \
\(-1.0458512467135053`\), \(-0.8181449489025155`\), \
\(-0.37906603817959267`\), \(-0.13334089472872596`\)}, {2.8720214005619744`, 
        4.7359711958964406`, 4.959965645182854`, 0.36331950227559756`, 
        0.3175019855431138`, 0.26827600147068964`}}\)], "Output"]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,15},{25,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.01{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-30\), 20}, {\(-30\), 30}, {0, 60}, {5, 15}, {25, 35}, {0, 
        8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gHNF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],
\t\tPlotLabel->\"HNF(2,2)\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -26 0 ]
[.5 .42452 26 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -87 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(HNF) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.000 13.000 moveto
(H) show
87.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
99.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
105.000 13.000 moveto
(L) show
111.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -0.309017 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -6 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -6 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(6)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(8)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(10)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(12)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(14)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30902 m
.001 .30902 L
.002 .30902 L
.003 .30902 L
.004 .30902 L
.005 .30902 L
.00599 .30902 L
.00699 .30902 L
.00799 .30902 L
.00899 .30902 L
.00999 .30902 L
.01099 .30902 L
.01199 .30902 L
.01299 .30902 L
.01399 .30902 L
.01499 .30902 L
.01598 .30902 L
.01698 .30902 L
.01798 .30902 L
.01898 .30902 L
.01998 .30902 L
.02098 .30902 L
.02198 .30902 L
.02298 .30902 L
.02398 .30902 L
.02498 .30902 L
.02597 .30902 L
.02697 .30902 L
.02797 .30902 L
.02897 .30902 L
.02997 .30902 L
.03097 .30902 L
.03197 .30902 L
.03297 .30902 L
.03397 .30902 L
.03497 .30902 L
.03596 .30902 L
.03696 .30902 L
.03796 .30902 L
.03896 .30902 L
.03996 .30902 L
.04096 .30902 L
.04196 .30902 L
.04296 .30902 L
.04396 .30902 L
.04496 .30902 L
.04595 .30902 L
.04695 .30902 L
.04795 .30902 L
.04895 .30902 L
Mistroke
.04995 .30902 L
.05095 .30902 L
.05195 .30902 L
.05295 .30902 L
.05395 .30902 L
.05495 .30902 L
.05594 .30902 L
.05694 .30902 L
.05794 .30902 L
.05894 .30902 L
.05994 .30902 L
.06094 .30902 L
.06194 .30902 L
.06294 .30902 L
.06394 .30902 L
.06494 .30902 L
.06593 .30902 L
.06693 .30902 L
.06793 .30902 L
.06893 .30902 L
.06993 .30902 L
.07093 .30902 L
.07193 .30902 L
.07293 .30902 L
.07393 .30902 L
.07493 .30902 L
.07592 .30902 L
.07692 .30902 L
.07792 .30902 L
.07892 .30902 L
.07992 .30902 L
.08092 .30902 L
.08192 .30902 L
.08292 .30902 L
.08392 .30902 L
.08492 .30902 L
.08591 .30902 L
.08691 .30902 L
.08791 .30902 L
.08891 .30902 L
.08991 .30902 L
.09091 .30902 L
.09191 .30902 L
.09291 .30902 L
.09391 .30902 L
.09491 .30902 L
.0959 .30902 L
.0969 .30902 L
.0979 .30902 L
.0989 .30902 L
Mistroke
.0999 .30902 L
.1009 .30902 L
.1019 .30902 L
.1029 .30902 L
.1039 .30902 L
.1049 .30902 L
.10589 .30902 L
.10689 .30902 L
.10789 .30902 L
.10889 .30902 L
.10989 .30902 L
.11089 .30902 L
.11189 .30902 L
.11289 .30902 L
.11389 .30902 L
.11489 .30902 L
.11588 .30902 L
.11688 .30902 L
.11788 .30902 L
.11888 .30902 L
.11988 .30902 L
.12088 .30902 L
.12188 .30902 L
.12288 .30902 L
.12388 .30902 L
.12488 .30902 L
.12587 .30902 L
.12687 .30902 L
.12787 .30902 L
.12887 .30902 L
.12987 .30902 L
.13087 .30902 L
.13187 .30902 L
.13287 .30902 L
.13387 .30902 L
.13487 .30902 L
.13586 .30902 L
.13686 .30902 L
.13786 .30902 L
.13886 .30902 L
.13986 .30902 L
.14086 .30901 L
.14186 .30901 L
.14286 .30901 L
.14386 .30901 L
.14486 .30901 L
.14585 .30901 L
.14685 .30901 L
.14785 .30901 L
.14885 .30901 L
Mistroke
.14985 .30901 L
.15085 .30901 L
.15185 .30901 L
.15285 .30901 L
.15385 .30902 L
.15485 .30902 L
.15584 .30902 L
.15684 .30902 L
.15784 .30902 L
.15884 .30902 L
.15984 .30902 L
.16084 .30902 L
.16184 .30902 L
.16284 .30902 L
.16384 .30902 L
.16484 .30902 L
.16583 .30902 L
.16683 .30902 L
.16783 .30902 L
.16883 .30902 L
.16983 .30902 L
.17083 .30902 L
.17183 .30902 L
.17283 .30902 L
.17383 .30902 L
.17483 .30902 L
.17582 .30902 L
.17682 .30902 L
.17782 .30902 L
.17882 .30902 L
.17982 .30902 L
.18082 .30902 L
.18182 .30902 L
.18282 .30902 L
.18382 .30902 L
.18482 .30902 L
.18581 .30902 L
.18681 .30902 L
.18781 .30902 L
.18881 .30902 L
.18981 .30902 L
.19081 .30902 L
.19181 .30902 L
.19281 .30902 L
.19381 .30902 L
.19481 .30902 L
.1958 .30902 L
.1968 .30902 L
.1978 .30902 L
.1988 .30902 L
Mistroke
.1998 .30902 L
.2008 .30902 L
.2018 .30902 L
.2028 .30902 L
.2038 .30902 L
.2048 .30901 L
.20579 .30902 L
.20679 .30902 L
.20779 .30901 L
.20879 .30902 L
.20979 .30902 L
.21079 .30902 L
.21179 .30902 L
.21279 .30902 L
.21379 .30902 L
.21479 .30902 L
.21578 .30901 L
.21678 .30901 L
.21778 .30901 L
.21878 .30901 L
.21978 .30901 L
.22078 .30901 L
.22178 .30901 L
.22278 .30901 L
.22378 .30901 L
.22478 .30901 L
.22577 .30901 L
.22677 .30901 L
.22777 .30901 L
.22877 .30901 L
.22977 .30901 L
.23077 .30901 L
.23177 .30901 L
.23277 .30901 L
.23377 .30901 L
.23477 .30901 L
.23576 .30901 L
.23676 .30901 L
.23776 .30901 L
.23876 .30901 L
.23976 .30901 L
.24076 .30901 L
.24176 .30901 L
.24276 .30901 L
.24376 .30901 L
.24476 .30901 L
.24575 .30901 L
.24675 .30901 L
.24775 .30901 L
.24875 .30901 L
Mistroke
.24975 .30901 L
.25075 .30901 L
.25175 .30901 L
.25275 .30901 L
.25375 .30901 L
.25475 .30901 L
.25574 .30901 L
.25674 .30901 L
.25774 .30901 L
.25874 .30901 L
.25974 .30901 L
.26074 .30901 L
.26174 .30901 L
.26274 .30901 L
.26374 .30901 L
.26474 .30901 L
.26573 .30901 L
.26673 .30901 L
.26773 .30901 L
.26873 .30901 L
.26973 .30901 L
.27073 .30901 L
.27173 .30901 L
.27273 .30901 L
.27373 .30901 L
.27473 .30901 L
.27572 .30901 L
.27672 .30901 L
.27772 .30901 L
.27872 .30901 L
.27972 .30901 L
.28072 .30901 L
.28172 .30901 L
.28272 .30901 L
.28372 .30901 L
.28472 .30901 L
.28571 .30901 L
.28671 .30901 L
.28771 .30901 L
.28871 .30901 L
.28971 .30901 L
.29071 .30901 L
.29171 .30901 L
.29271 .30901 L
.29371 .30901 L
.29471 .30901 L
.2957 .30901 L
.2967 .30901 L
.2977 .30901 L
.2987 .30901 L
Mistroke
.2997 .30901 L
.3007 .30901 L
.3017 .30901 L
.3027 .30901 L
.3037 .30901 L
.3047 .30901 L
.30569 .30901 L
.30669 .30901 L
.30769 .30901 L
.30869 .30901 L
.30969 .30901 L
.31069 .30901 L
.31169 .30901 L
.31269 .30901 L
.31369 .30901 L
.31469 .30901 L
.31568 .30901 L
.31668 .309 L
.31768 .30901 L
.31868 .30901 L
.31968 .30901 L
.32068 .30901 L
.32168 .30901 L
.32268 .30901 L
.32368 .30901 L
.32468 .30901 L
.32567 .30901 L
.32667 .30901 L
.32767 .309 L
.32867 .309 L
.32967 .309 L
.33067 .309 L
.33167 .309 L
.33267 .309 L
.33367 .309 L
.33467 .309 L
.33566 .309 L
.33666 .309 L
.33766 .309 L
.33866 .309 L
.33966 .309 L
.34066 .309 L
.34166 .309 L
.34266 .309 L
.34366 .309 L
.34466 .309 L
.34565 .309 L
.34665 .309 L
.34765 .309 L
.34865 .309 L
Mistroke
.34965 .309 L
.35065 .309 L
.35165 .309 L
.35265 .309 L
.35365 .309 L
.35465 .309 L
.35564 .309 L
.35664 .309 L
.35764 .309 L
.35864 .309 L
.35964 .309 L
.36064 .309 L
.36164 .309 L
.36264 .309 L
.36364 .309 L
.36464 .309 L
.36563 .309 L
.36663 .309 L
.36763 .309 L
.36863 .309 L
.36963 .309 L
.37063 .309 L
.37163 .309 L
.37263 .309 L
.37363 .309 L
.37463 .309 L
.37562 .309 L
.37662 .309 L
.37762 .309 L
.37862 .309 L
.37962 .309 L
.38062 .309 L
.38162 .309 L
.38262 .309 L
.38362 .309 L
.38462 .309 L
.38561 .309 L
.38661 .309 L
.38761 .309 L
.38861 .309 L
.38961 .309 L
.39061 .309 L
.39161 .309 L
.39261 .309 L
.39361 .309 L
.39461 .309 L
.3956 .309 L
.3966 .309 L
.3976 .309 L
.3986 .309 L
Mistroke
.3996 .309 L
.4006 .309 L
.4016 .309 L
.4026 .309 L
.4036 .309 L
.4046 .309 L
.40559 .309 L
.40659 .309 L
.40759 .309 L
.40859 .309 L
.40959 .309 L
.41059 .309 L
.41159 .309 L
.41259 .309 L
.41359 .309 L
.41459 .309 L
.41558 .309 L
.41658 .309 L
.41758 .309 L
.41858 .309 L
.41958 .309 L
.42058 .309 L
.42158 .309 L
.42258 .309 L
.42358 .30901 L
.42458 .309 L
.42557 .309 L
.42657 .309 L
.42757 .309 L
.42857 .309 L
.42957 .309 L
.43057 .309 L
.43157 .309 L
.43257 .309 L
.43357 .309 L
.43457 .309 L
.43556 .309 L
.43656 .309 L
.43756 .309 L
.43856 .309 L
.43956 .309 L
.44056 .309 L
.44156 .309 L
.44256 .309 L
.44356 .309 L
.44456 .309 L
.44555 .309 L
.44655 .309 L
.44755 .309 L
.44855 .309 L
Mistroke
.44955 .309 L
.45055 .309 L
.45155 .309 L
.45255 .309 L
.45355 .309 L
.45455 .309 L
.45554 .309 L
.45654 .309 L
.45754 .309 L
.45854 .309 L
.45954 .309 L
.46054 .309 L
.46154 .309 L
.46254 .309 L
.46354 .309 L
.46454 .309 L
.46553 .309 L
.46653 .309 L
.46753 .309 L
.46853 .309 L
.46953 .309 L
.47053 .309 L
.47153 .309 L
.47253 .309 L
.47353 .309 L
.47453 .309 L
.47552 .309 L
.47652 .309 L
.47752 .309 L
.47852 .309 L
.47952 .309 L
.48052 .309 L
.48152 .309 L
.48252 .309 L
.48352 .309 L
.48452 .309 L
.48551 .309 L
.48651 .309 L
.48751 .309 L
.48851 .309 L
.48951 .309 L
.49051 .309 L
.49151 .309 L
.49251 .309 L
.49351 .309 L
.49451 .309 L
.4955 .309 L
.4965 .309 L
.4975 .309 L
.4985 .309 L
Mistroke
.4995 .309 L
.5005 .309 L
.5015 .309 L
.5025 .309 L
.5035 .309 L
.5045 .309 L
.50549 .309 L
.50649 .30901 L
.50749 .30901 L
.50849 .30901 L
.50949 .30901 L
.51049 .30901 L
.51149 .30901 L
.51249 .30901 L
.51349 .30901 L
.51449 .30901 L
.51548 .30901 L
.51648 .30901 L
.51748 .30901 L
.51848 .30901 L
.51948 .30901 L
.52048 .30901 L
.52148 .30901 L
.52248 .30901 L
.52348 .30901 L
.52448 .30901 L
.52547 .30901 L
.52647 .30901 L
.52747 .30901 L
.52847 .30901 L
.52947 .30901 L
.53047 .30901 L
.53147 .30901 L
.53247 .30901 L
.53347 .30901 L
.53447 .30901 L
.53546 .30901 L
.53646 .30901 L
.53746 .30901 L
.53846 .30901 L
.53946 .30901 L
.54046 .30901 L
.54146 .30901 L
.54246 .30901 L
.54346 .30901 L
.54446 .30901 L
.54545 .30901 L
.54645 .30901 L
.54745 .30901 L
.54845 .30901 L
Mistroke
.54945 .30901 L
.55045 .30901 L
.55145 .30901 L
.55245 .30901 L
.55345 .30901 L
.55445 .30901 L
.55544 .30901 L
.55644 .30901 L
.55744 .30901 L
.55844 .30901 L
.55944 .30901 L
.56044 .30901 L
.56144 .30901 L
.56244 .30901 L
.56344 .30901 L
.56444 .30901 L
.56543 .30901 L
.56643 .30901 L
.56743 .30901 L
.56843 .30901 L
.56943 .30901 L
.57043 .30901 L
.57143 .30901 L
.57243 .30901 L
.57343 .30901 L
.57443 .30901 L
.57542 .30901 L
.57642 .30901 L
.57742 .30901 L
.57842 .30901 L
.57942 .30901 L
.58042 .30901 L
.58142 .30901 L
.58242 .30901 L
.58342 .30901 L
.58442 .30901 L
.58541 .30901 L
.58641 .30901 L
.58741 .30901 L
.58841 .30901 L
.58941 .30901 L
.59041 .30901 L
.59141 .30901 L
.59241 .30901 L
.59341 .30901 L
.59441 .30901 L
.5954 .30901 L
.5964 .30901 L
.5974 .30901 L
.5984 .30901 L
Mistroke
.5994 .30901 L
.6004 .30901 L
.6014 .30901 L
.6024 .30901 L
.6034 .30901 L
.6044 .30901 L
.60539 .30901 L
.60639 .30901 L
.60739 .30901 L
.60839 .30901 L
.60939 .30901 L
.61039 .30901 L
.61139 .30901 L
.61239 .30901 L
.61339 .30901 L
.61439 .30901 L
.61538 .30901 L
.61638 .30901 L
.61738 .30901 L
.61838 .30901 L
.61938 .30901 L
.62038 .30901 L
.62138 .30901 L
.62238 .30901 L
.62338 .30901 L
.62438 .30901 L
.62537 .30901 L
.62637 .30901 L
.62737 .30901 L
.62837 .30901 L
.62937 .30901 L
.63037 .30901 L
.63137 .30901 L
.63237 .30901 L
.63337 .30901 L
.63437 .30901 L
.63536 .30901 L
.63636 .30901 L
.63736 .30901 L
.63836 .30901 L
.63936 .30901 L
.64036 .30901 L
.64136 .30901 L
.64236 .30901 L
.64336 .30901 L
.64436 .30901 L
.64535 .30901 L
.64635 .30901 L
.64735 .30901 L
.64835 .30901 L
Mistroke
.64935 .30901 L
.65035 .30901 L
.65135 .30901 L
.65235 .30901 L
.65335 .30901 L
.65435 .30901 L
.65534 .30901 L
.65634 .30901 L
.65734 .30901 L
.65834 .30901 L
.65934 .30901 L
.66034 .30901 L
.66134 .30901 L
.66234 .30901 L
.66334 .30901 L
.66434 .30901 L
.66533 .30901 L
.66633 .30901 L
.66733 .30901 L
.66833 .30901 L
.66933 .30901 L
.67033 .30901 L
.67133 .30901 L
.67233 .30901 L
.67333 .30901 L
.67433 .30901 L
.67532 .30901 L
.67632 .30901 L
.67732 .30901 L
.67832 .30901 L
.67932 .30901 L
.68032 .30901 L
.68132 .30901 L
.68232 .30901 L
.68332 .30901 L
.68432 .30901 L
.68531 .30901 L
.68631 .30901 L
.68731 .30901 L
.68831 .30901 L
.68931 .30901 L
.69031 .30901 L
.69131 .30901 L
.69231 .30901 L
.69331 .30901 L
.69431 .30901 L
.6953 .30901 L
.6963 .30901 L
.6973 .30901 L
.6983 .30901 L
Mistroke
.6993 .30901 L
.7003 .30901 L
.7013 .30901 L
.7023 .30901 L
.7033 .30901 L
.7043 .30901 L
.70529 .30901 L
.70629 .30901 L
.70729 .30901 L
.70829 .30901 L
.70929 .30901 L
.71029 .30901 L
.71129 .30901 L
.71229 .30901 L
.71329 .30901 L
.71429 .30901 L
.71528 .30901 L
.71628 .30901 L
.71728 .30901 L
.71828 .30901 L
.71928 .30901 L
.72028 .30901 L
.72128 .309 L
.72228 .309 L
.72328 .309 L
.72428 .309 L
.72527 .309 L
.72627 .309 L
.72727 .309 L
.72827 .309 L
.72927 .309 L
.73027 .309 L
.73127 .309 L
.73227 .309 L
.73327 .309 L
.73427 .309 L
.73526 .309 L
.73626 .30901 L
.73726 .30901 L
.73826 .30901 L
.73926 .30901 L
.74026 .30901 L
.74126 .30901 L
.74226 .30901 L
.74326 .30901 L
.74426 .30901 L
.74525 .30901 L
.74625 .30901 L
.74725 .30901 L
.74825 .30901 L
Mistroke
.74925 .30901 L
.75025 .30901 L
.75125 .30901 L
.75225 .30901 L
.75325 .30901 L
.75425 .30901 L
.75524 .30901 L
.75624 .30901 L
.75724 .30901 L
.75824 .30901 L
.75924 .30901 L
.76024 .30901 L
.76124 .30901 L
.76224 .30901 L
.76324 .30901 L
.76424 .30901 L
.76523 .30901 L
.76623 .30901 L
.76723 .30901 L
.76823 .30901 L
.76923 .30901 L
.77023 .30901 L
.77123 .30901 L
.77223 .30901 L
.77323 .30901 L
.77423 .30901 L
.77522 .30901 L
.77622 .30901 L
.77722 .30901 L
.77822 .30901 L
.77922 .30901 L
.78022 .30901 L
.78122 .30901 L
.78222 .30901 L
.78322 .30901 L
.78422 .30901 L
.78521 .30901 L
.78621 .30901 L
.78721 .30901 L
.78821 .30901 L
.78921 .30901 L
.79021 .30901 L
.79121 .30901 L
.79221 .30901 L
.79321 .30901 L
.79421 .30901 L
.7952 .30901 L
.7962 .30901 L
.7972 .30901 L
.7982 .30901 L
Mistroke
.7992 .30901 L
.8002 .30901 L
.8012 .30901 L
.8022 .30901 L
.8032 .30901 L
.8042 .30901 L
.80519 .309 L
.80619 .309 L
.80719 .309 L
.80819 .309 L
.80919 .309 L
.81019 .30901 L
.81119 .309 L
.81219 .309 L
.81319 .309 L
.81419 .309 L
.81518 .309 L
.81618 .309 L
.81718 .309 L
.81818 .309 L
.81918 .309 L
.82018 .309 L
.82118 .309 L
.82218 .309 L
.82318 .309 L
.82418 .309 L
.82517 .309 L
.82617 .309 L
.82717 .309 L
.82817 .309 L
.82917 .309 L
.83017 .309 L
.83117 .309 L
.83217 .309 L
.83317 .309 L
.83417 .309 L
.83516 .309 L
.83616 .309 L
.83716 .309 L
.83816 .309 L
.83916 .309 L
.84016 .309 L
.84116 .309 L
.84216 .309 L
.84316 .309 L
.84416 .309 L
.84515 .309 L
.84615 .309 L
.84715 .309 L
.84815 .309 L
Mistroke
.84915 .309 L
.85015 .309 L
.85115 .309 L
.85215 .309 L
.85315 .309 L
.85415 .309 L
.85514 .309 L
.85614 .309 L
.85714 .309 L
.85814 .309 L
.85914 .309 L
.86014 .309 L
.86114 .309 L
.86214 .309 L
.86314 .309 L
.86414 .309 L
.86513 .309 L
.86613 .309 L
.86713 .309 L
.86813 .309 L
.86913 .309 L
.87013 .309 L
.87113 .309 L
.87213 .309 L
.87313 .309 L
.87413 .309 L
.87512 .309 L
.87612 .309 L
.87712 .309 L
.87812 .309 L
.87912 .309 L
.88012 .30901 L
.88112 .309 L
.88212 .30901 L
.88312 .30901 L
.88412 .30901 L
.88511 .309 L
.88611 .309 L
.88711 .309 L
.88811 .309 L
.88911 .309 L
.89011 .309 L
.89111 .309 L
.89211 .309 L
.89311 .309 L
.89411 .309 L
.8951 .309 L
.8961 .309 L
.8971 .309 L
.8981 .309 L
Mistroke
.8991 .309 L
.9001 .309 L
.9011 .309 L
.9021 .309 L
.9031 .309 L
.9041 .309 L
.90509 .309 L
.90609 .309 L
.90709 .309 L
.90809 .309 L
.90909 .309 L
.91009 .309 L
.91109 .309 L
.91209 .309 L
.91309 .309 L
.91409 .309 L
.91508 .309 L
.91608 .309 L
.91708 .309 L
.91808 .309 L
.91908 .309 L
.92008 .309 L
.92108 .309 L
.92208 .309 L
.92308 .309 L
.92408 .309 L
.92507 .309 L
.92607 .309 L
.92707 .30901 L
.92807 .30901 L
.92907 .30901 L
.93007 .30901 L
.93107 .30901 L
.93207 .30901 L
.93307 .30901 L
.93407 .30901 L
.93506 .30901 L
.93606 .30901 L
.93706 .30901 L
.93806 .30901 L
.93906 .30901 L
.94006 .30901 L
.94106 .30901 L
.94206 .30901 L
.94306 .30901 L
.94406 .30901 L
.94505 .30901 L
.94605 .30901 L
.94705 .30901 L
.94805 .30901 L
Mistroke
.94905 .30901 L
.95005 .30901 L
.95105 .309 L
.95205 .309 L
.95305 .309 L
.95405 .309 L
.95504 .309 L
.95604 .309 L
.95704 .309 L
.95804 .309 L
.95904 .309 L
.96004 .309 L
.96104 .309 L
.96204 .30901 L
.96304 .30901 L
.96404 .30901 L
.96503 .30901 L
.96603 .30901 L
.96703 .30901 L
.96803 .30901 L
.96903 .30901 L
.97003 .30901 L
.97103 .30901 L
.97203 .309 L
.97303 .309 L
.97403 .30901 L
.97502 .309 L
.97602 .309 L
.97702 .309 L
.97802 .309 L
.97902 .309 L
.98002 .309 L
.98102 .309 L
.98202 .309 L
.98302 .309 L
.98402 .309 L
.98501 .309 L
.98601 .309 L
.98701 .309 L
.98801 .309 L
.98901 .309 L
.99001 .309 L
.99101 .309 L
.99201 .309 L
.99301 .309 L
.99401 .309 L
.995 .309 L
.996 .309 L
.997 .309 L
.998 .309 L
Mistroke
.999 .309 L
Mfstroke
0 .98 .604 r
gsave
.999 .26444 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .24969 m
.001 .24969 L
.002 .24969 L
.003 .24969 L
.004 .24969 L
.005 .24969 L
.00599 .24969 L
.00699 .24969 L
.00799 .24969 L
.00899 .24969 L
.00999 .24969 L
.01099 .24969 L
.01199 .24969 L
.01299 .24969 L
.01399 .24969 L
.01499 .24969 L
.01598 .24969 L
.01698 .24969 L
.01798 .24969 L
.01898 .24969 L
.01998 .24969 L
.02098 .24969 L
.02198 .24969 L
.02298 .24969 L
.02398 .24969 L
.02498 .24969 L
.02597 .24969 L
.02697 .24969 L
.02797 .24969 L
.02897 .24969 L
.02997 .24969 L
.03097 .24969 L
.03197 .24969 L
.03297 .24969 L
.03397 .24969 L
.03497 .24969 L
.03596 .24969 L
.03696 .24969 L
.03796 .24969 L
.03896 .24969 L
.03996 .24969 L
.04096 .24969 L
.04196 .24969 L
.04296 .24969 L
.04396 .24969 L
.04496 .24969 L
.04595 .24969 L
.04695 .24969 L
.04795 .24969 L
.04895 .24969 L
Mistroke
.04995 .26378 L
.05095 .26378 L
.05195 .26378 L
.05295 .26378 L
.05395 .26378 L
.05495 .26378 L
.05594 .26378 L
.05694 .26378 L
.05794 .26378 L
.05894 .26378 L
.05994 .26378 L
.06094 .26378 L
.06194 .26378 L
.06294 .26378 L
.06394 .26378 L
.06494 .26378 L
.06593 .26378 L
.06693 .26378 L
.06793 .26378 L
.06893 .26378 L
.06993 .26378 L
.07093 .26378 L
.07193 .26378 L
.07293 .26378 L
.07393 .26378 L
.07493 .26378 L
.07592 .26378 L
.07692 .26378 L
.07792 .26378 L
.07892 .26378 L
.07992 .26378 L
.08092 .26378 L
.08192 .26378 L
.08292 .26378 L
.08392 .26378 L
.08492 .26378 L
.08591 .26378 L
.08691 .26378 L
.08791 .26378 L
.08891 .26378 L
.08991 .26378 L
.09091 .26378 L
.09191 .26378 L
.09291 .26378 L
.09391 .26378 L
.09491 .26378 L
.0959 .26378 L
.0969 .26378 L
.0979 .26378 L
.0989 .26378 L
Mistroke
.0999 .30321 L
.1009 .30321 L
.1019 .30321 L
.1029 .30321 L
.1039 .30321 L
.1049 .30321 L
.10589 .30321 L
.10689 .30321 L
.10789 .30321 L
.10889 .30321 L
.10989 .30321 L
.11089 .30321 L
.11189 .30321 L
.11289 .30321 L
.11389 .30321 L
.11489 .30321 L
.11588 .30321 L
.11688 .30321 L
.11788 .30321 L
.11888 .30321 L
.11988 .30321 L
.12088 .30321 L
.12188 .30321 L
.12288 .30321 L
.12388 .30321 L
.12488 .30321 L
.12587 .30321 L
.12687 .30321 L
.12787 .30321 L
.12887 .30321 L
.12987 .30321 L
.13087 .30321 L
.13187 .30321 L
.13287 .30321 L
.13387 .30321 L
.13487 .30321 L
.13586 .30321 L
.13686 .30321 L
.13786 .30321 L
.13886 .30321 L
.13986 .30321 L
.14086 .30321 L
.14186 .30321 L
.14286 .30321 L
.14386 .30321 L
.14486 .30321 L
.14585 .30321 L
.14685 .30321 L
.14785 .30321 L
.14885 .30321 L
Mistroke
.14985 .28283 L
.15085 .28283 L
.15185 .28283 L
.15285 .28283 L
.15385 .28283 L
.15485 .28283 L
.15584 .28283 L
.15684 .28283 L
.15784 .28283 L
.15884 .28283 L
.15984 .28283 L
.16084 .28283 L
.16184 .28283 L
.16284 .28283 L
.16384 .28283 L
.16484 .28283 L
.16583 .28283 L
.16683 .28283 L
.16783 .28283 L
.16883 .28283 L
.16983 .28283 L
.17083 .28283 L
.17183 .28283 L
.17283 .28283 L
.17383 .28283 L
.17483 .28283 L
.17582 .28283 L
.17682 .28283 L
.17782 .28283 L
.17882 .28283 L
.17982 .28283 L
.18082 .28283 L
.18182 .28283 L
.18282 .28283 L
.18382 .28283 L
.18482 .28283 L
.18581 .28283 L
.18681 .28283 L
.18781 .28283 L
.18881 .28283 L
.18981 .28283 L
.19081 .28283 L
.19181 .28283 L
.19281 .28283 L
.19381 .28283 L
.19481 .28283 L
.1958 .28283 L
.1968 .28283 L
.1978 .28283 L
.1988 .28283 L
Mistroke
.1998 .26729 L
.2008 .26729 L
.2018 .26729 L
.2028 .26729 L
.2038 .26729 L
.2048 .26729 L
.20579 .26729 L
.20679 .26729 L
.20779 .26729 L
.20879 .26729 L
.20979 .26729 L
.21079 .26729 L
.21179 .26729 L
.21279 .26729 L
.21379 .26729 L
.21479 .26729 L
.21578 .26729 L
.21678 .26729 L
.21778 .26729 L
.21878 .26729 L
.21978 .26729 L
.22078 .26729 L
.22178 .26729 L
.22278 .26729 L
.22378 .26729 L
.22478 .26729 L
.22577 .26729 L
.22677 .26729 L
.22777 .26729 L
.22877 .26729 L
.22977 .26729 L
.23077 .26729 L
.23177 .26729 L
.23277 .26729 L
.23377 .26729 L
.23477 .26729 L
.23576 .26729 L
.23676 .26729 L
.23776 .26729 L
.23876 .26729 L
.23976 .26729 L
.24076 .26729 L
.24176 .26729 L
.24276 .26729 L
.24376 .26729 L
.24476 .26729 L
.24575 .26729 L
.24675 .26729 L
.24775 .26729 L
.24875 .26729 L
Mistroke
.24975 .27629 L
.25075 .27629 L
.25175 .27629 L
.25275 .27629 L
.25375 .27629 L
.25475 .27629 L
.25574 .27629 L
.25674 .27629 L
.25774 .27629 L
.25874 .27629 L
.25974 .27629 L
.26074 .27629 L
.26174 .27629 L
.26274 .27629 L
.26374 .27629 L
.26474 .27629 L
.26573 .27629 L
.26673 .27629 L
.26773 .27629 L
.26873 .27629 L
.26973 .27629 L
.27073 .27629 L
.27173 .27629 L
.27273 .27629 L
.27373 .27629 L
.27473 .27629 L
.27572 .27629 L
.27672 .27629 L
.27772 .27629 L
.27872 .27629 L
.27972 .27629 L
.28072 .27629 L
.28172 .27629 L
.28272 .27629 L
.28372 .27629 L
.28472 .27629 L
.28571 .27629 L
.28671 .27629 L
.28771 .27629 L
.28871 .27629 L
.28971 .27629 L
.29071 .27629 L
.29171 .27629 L
.29271 .27629 L
.29371 .27629 L
.29471 .27629 L
.2957 .27629 L
.2967 .27629 L
.2977 .27629 L
.2987 .27629 L
Mistroke
.2997 .28173 L
.3007 .28173 L
.3017 .28173 L
.3027 .28173 L
.3037 .28173 L
.3047 .28173 L
.30569 .28173 L
.30669 .28173 L
.30769 .28173 L
.30869 .28173 L
.30969 .28173 L
.31069 .28173 L
.31169 .28173 L
.31269 .28173 L
.31369 .28173 L
.31469 .28173 L
.31568 .28173 L
.31668 .28173 L
.31768 .28173 L
.31868 .28173 L
.31968 .28173 L
.32068 .28173 L
.32168 .28173 L
.32268 .28173 L
.32368 .28173 L
.32468 .28173 L
.32567 .28173 L
.32667 .28173 L
.32767 .28173 L
.32867 .28173 L
.32967 .28173 L
.33067 .28173 L
.33167 .28173 L
.33267 .28173 L
.33367 .28173 L
.33467 .28173 L
.33566 .28173 L
.33666 .28173 L
.33766 .28173 L
.33866 .28173 L
.33966 .28173 L
.34066 .28173 L
.34166 .28173 L
.34266 .28173 L
.34366 .28173 L
.34466 .28173 L
.34565 .28173 L
.34665 .28173 L
.34765 .28173 L
.34865 .28173 L
Mistroke
.34965 .27928 L
.35065 .27928 L
.35165 .27928 L
.35265 .27928 L
.35365 .27928 L
.35465 .27928 L
.35564 .27928 L
.35664 .27928 L
.35764 .27928 L
.35864 .27928 L
.35964 .27928 L
.36064 .27928 L
.36164 .27928 L
.36264 .27928 L
.36364 .27928 L
.36464 .27928 L
.36563 .27928 L
.36663 .27928 L
.36763 .27928 L
.36863 .27928 L
.36963 .27928 L
.37063 .27928 L
.37163 .27928 L
.37263 .27928 L
.37363 .27928 L
.37463 .27928 L
.37562 .27928 L
.37662 .27928 L
.37762 .27928 L
.37862 .27928 L
.37962 .27928 L
.38062 .27928 L
.38162 .27928 L
.38262 .27928 L
.38362 .27928 L
.38462 .27928 L
.38561 .27928 L
.38661 .27928 L
.38761 .27928 L
.38861 .27928 L
.38961 .27928 L
.39061 .27928 L
.39161 .27928 L
.39261 .27928 L
.39361 .27928 L
.39461 .27928 L
.3956 .27928 L
.3966 .27928 L
.3976 .27928 L
.3986 .27928 L
Mistroke
.3996 .26563 L
.4006 .26563 L
.4016 .26563 L
.4026 .26563 L
.4036 .26563 L
.4046 .26563 L
.40559 .26563 L
.40659 .26563 L
.40759 .26563 L
.40859 .26563 L
.40959 .26563 L
.41059 .26563 L
.41159 .26563 L
.41259 .26563 L
.41359 .26563 L
.41459 .26563 L
.41558 .26563 L
.41658 .26563 L
.41758 .26563 L
.41858 .26563 L
.41958 .26563 L
.42058 .26563 L
.42158 .26563 L
.42258 .26563 L
.42358 .26563 L
.42458 .26563 L
.42557 .26563 L
.42657 .26563 L
.42757 .26563 L
.42857 .26563 L
.42957 .26563 L
.43057 .26563 L
.43157 .26563 L
.43257 .26563 L
.43357 .26563 L
.43457 .26563 L
.43556 .26563 L
.43656 .26563 L
.43756 .26563 L
.43856 .26563 L
.43956 .26563 L
.44056 .26563 L
.44156 .26563 L
.44256 .26563 L
.44356 .26563 L
.44456 .26563 L
.44555 .26563 L
.44655 .26563 L
.44755 .26563 L
.44855 .26563 L
Mistroke
.44955 .25997 L
.45055 .25997 L
.45155 .25997 L
.45255 .25997 L
.45355 .25997 L
.45455 .25997 L
.45554 .25997 L
.45654 .25997 L
.45754 .25997 L
.45854 .25997 L
.45954 .25997 L
.46054 .25997 L
.46154 .25997 L
.46254 .25997 L
.46354 .25997 L
.46454 .25997 L
.46553 .25997 L
.46653 .25997 L
.46753 .25997 L
.46853 .25997 L
.46953 .25997 L
.47053 .25997 L
.47153 .25997 L
.47253 .25997 L
.47353 .25997 L
.47453 .25997 L
.47552 .25997 L
.47652 .25997 L
.47752 .25997 L
.47852 .25997 L
.47952 .25997 L
.48052 .25997 L
.48152 .25997 L
.48252 .25997 L
.48352 .25997 L
.48452 .25997 L
.48551 .25997 L
.48651 .25997 L
.48751 .25997 L
.48851 .25997 L
.48951 .25997 L
.49051 .25997 L
.49151 .25997 L
.49251 .25997 L
.49351 .25997 L
.49451 .25997 L
.4955 .25997 L
.4965 .25997 L
.4975 .25997 L
.4985 .25997 L
Mistroke
.4995 .26081 L
.5005 .26081 L
.5015 .26081 L
.5025 .26081 L
.5035 .26081 L
.5045 .26081 L
.50549 .26081 L
.50649 .26081 L
.50749 .26081 L
.50849 .26081 L
.50949 .26081 L
.51049 .26081 L
.51149 .26081 L
.51249 .26081 L
.51349 .26081 L
.51449 .26081 L
.51548 .26081 L
.51648 .26081 L
.51748 .26081 L
.51848 .26081 L
.51948 .26081 L
.52048 .26081 L
.52148 .26081 L
.52248 .26081 L
.52348 .26081 L
.52448 .26081 L
.52547 .26081 L
.52647 .26081 L
.52747 .26081 L
.52847 .26081 L
.52947 .26081 L
.53047 .26081 L
.53147 .26081 L
.53247 .26081 L
.53347 .26081 L
.53447 .26081 L
.53546 .26081 L
.53646 .26081 L
.53746 .26081 L
.53846 .26081 L
.53946 .26081 L
.54046 .26081 L
.54146 .26081 L
.54246 .26081 L
.54346 .26081 L
.54446 .26081 L
.54545 .26081 L
.54645 .26081 L
.54745 .26081 L
.54845 .26081 L
Mistroke
.54945 .2626 L
.55045 .2626 L
.55145 .2626 L
.55245 .2626 L
.55345 .2626 L
.55445 .2626 L
.55544 .2626 L
.55644 .2626 L
.55744 .2626 L
.55844 .2626 L
.55944 .2626 L
.56044 .2626 L
.56144 .2626 L
.56244 .2626 L
.56344 .2626 L
.56444 .2626 L
.56543 .2626 L
.56643 .2626 L
.56743 .2626 L
.56843 .2626 L
.56943 .2626 L
.57043 .2626 L
.57143 .2626 L
.57243 .2626 L
.57343 .2626 L
.57443 .2626 L
.57542 .2626 L
.57642 .2626 L
.57742 .2626 L
.57842 .2626 L
.57942 .2626 L
.58042 .2626 L
.58142 .2626 L
.58242 .2626 L
.58342 .2626 L
.58442 .2626 L
.58541 .2626 L
.58641 .2626 L
.58741 .2626 L
.58841 .2626 L
.58941 .2626 L
.59041 .2626 L
.59141 .2626 L
.59241 .2626 L
.59341 .2626 L
.59441 .2626 L
.5954 .2626 L
.5964 .2626 L
.5974 .2626 L
.5984 .2626 L
Mistroke
.5994 .24328 L
.6004 .24328 L
.6014 .24328 L
.6024 .24328 L
.6034 .24328 L
.6044 .24328 L
.60539 .24328 L
.60639 .24328 L
.60739 .24328 L
.60839 .24328 L
.60939 .24328 L
.61039 .24328 L
.61139 .24328 L
.61239 .24328 L
.61339 .24328 L
.61439 .24328 L
.61538 .24328 L
.61638 .24328 L
.61738 .24328 L
.61838 .24328 L
.61938 .24328 L
.62038 .24328 L
.62138 .24328 L
.62238 .24328 L
.62338 .24328 L
.62438 .24328 L
.62537 .24328 L
.62637 .24328 L
.62737 .24328 L
.62837 .24328 L
.62937 .24328 L
.63037 .24328 L
.63137 .24328 L
.63237 .24328 L
.63337 .24328 L
.63437 .24328 L
.63536 .24328 L
.63636 .24328 L
.63736 .24328 L
.63836 .24328 L
.63936 .24328 L
.64036 .24328 L
.64136 .24328 L
.64236 .24328 L
.64336 .24328 L
.64436 .24328 L
.64535 .24328 L
.64635 .24328 L
.64735 .24328 L
.64835 .24328 L
Mistroke
.64935 .25858 L
.65035 .25858 L
.65135 .25858 L
.65235 .25858 L
.65335 .25858 L
.65435 .25858 L
.65534 .25858 L
.65634 .25858 L
.65734 .25858 L
.65834 .25858 L
.65934 .25858 L
.66034 .25858 L
.66134 .25858 L
.66234 .25858 L
.66334 .25858 L
.66434 .25858 L
.66533 .25858 L
.66633 .25858 L
.66733 .25858 L
.66833 .25858 L
.66933 .25858 L
.67033 .25858 L
.67133 .25858 L
.67233 .25858 L
.67333 .25858 L
.67433 .25858 L
.67532 .25858 L
.67632 .25858 L
.67732 .25858 L
.67832 .25858 L
.67932 .25858 L
.68032 .25858 L
.68132 .25858 L
.68232 .25858 L
.68332 .25858 L
.68432 .25858 L
.68531 .25858 L
.68631 .25858 L
.68731 .25858 L
.68831 .25858 L
.68931 .25858 L
.69031 .25858 L
.69131 .25858 L
.69231 .25858 L
.69331 .25858 L
.69431 .25858 L
.6953 .25858 L
.6963 .25858 L
.6973 .25858 L
.6983 .25858 L
Mistroke
.6993 .26442 L
.7003 .26442 L
.7013 .26442 L
.7023 .26442 L
.7033 .26442 L
.7043 .26442 L
.70529 .26442 L
.70629 .26442 L
.70729 .26442 L
.70829 .26442 L
.70929 .26442 L
.71029 .26442 L
.71129 .26442 L
.71229 .26442 L
.71329 .26442 L
.71429 .26442 L
.71528 .26442 L
.71628 .26442 L
.71728 .26442 L
.71828 .26442 L
.71928 .26442 L
.72028 .26442 L
.72128 .26442 L
.72228 .26442 L
.72328 .26442 L
.72428 .26442 L
.72527 .26442 L
.72627 .26442 L
.72727 .26442 L
.72827 .26442 L
.72927 .26442 L
.73027 .26442 L
.73127 .26442 L
.73227 .26442 L
.73327 .26442 L
.73427 .26442 L
.73526 .26442 L
.73626 .26442 L
.73726 .26442 L
.73826 .26442 L
.73926 .26442 L
.74026 .26442 L
.74126 .26442 L
.74226 .26442 L
.74326 .26442 L
.74426 .26442 L
.74525 .26442 L
.74625 .26442 L
.74725 .26442 L
.74825 .26442 L
Mistroke
.74925 .263 L
.75025 .263 L
.75125 .263 L
.75225 .263 L
.75325 .263 L
.75425 .263 L
.75524 .263 L
.75624 .263 L
.75724 .263 L
.75824 .263 L
.75924 .263 L
.76024 .263 L
.76124 .263 L
.76224 .263 L
.76324 .263 L
.76424 .263 L
.76523 .263 L
.76623 .263 L
.76723 .263 L
.76823 .263 L
.76923 .263 L
.77023 .263 L
.77123 .263 L
.77223 .263 L
.77323 .263 L
.77423 .263 L
.77522 .263 L
.77622 .263 L
.77722 .263 L
.77822 .263 L
.77922 .263 L
.78022 .263 L
.78122 .263 L
.78222 .263 L
.78322 .263 L
.78422 .263 L
.78521 .263 L
.78621 .263 L
.78721 .263 L
.78821 .263 L
.78921 .263 L
.79021 .263 L
.79121 .263 L
.79221 .263 L
.79321 .263 L
.79421 .263 L
.7952 .263 L
.7962 .263 L
.7972 .263 L
.7982 .263 L
Mistroke
.7992 .25343 L
.8002 .25343 L
.8012 .25343 L
.8022 .25343 L
.8032 .25343 L
.8042 .25343 L
.80519 .25343 L
.80619 .25343 L
.80719 .25343 L
.80819 .25343 L
.80919 .25343 L
.81019 .25343 L
.81119 .25343 L
.81219 .25343 L
.81319 .25343 L
.81419 .25343 L
.81518 .25343 L
.81618 .25343 L
.81718 .25343 L
.81818 .25343 L
.81918 .25343 L
.82018 .25343 L
.82118 .25343 L
.82218 .25343 L
.82318 .25343 L
.82418 .25343 L
.82517 .25343 L
.82617 .25343 L
.82717 .25343 L
.82817 .25343 L
.82917 .25343 L
.83017 .25343 L
.83117 .25343 L
.83217 .25343 L
.83317 .25343 L
.83417 .25343 L
.83516 .25343 L
.83616 .25343 L
.83716 .25343 L
.83816 .25343 L
.83916 .25343 L
.84016 .25343 L
.84116 .25343 L
.84216 .25343 L
.84316 .25343 L
.84416 .25343 L
.84515 .25343 L
.84615 .25343 L
.84715 .25343 L
.84815 .25343 L
Mistroke
.84915 .25649 L
.85015 .25649 L
.85115 .25649 L
.85215 .25649 L
.85315 .25649 L
.85415 .25649 L
.85514 .25649 L
.85614 .25649 L
.85714 .25649 L
.85814 .25649 L
.85914 .25649 L
.86014 .25649 L
.86114 .25649 L
.86214 .25649 L
.86314 .25649 L
.86414 .25649 L
.86513 .25649 L
.86613 .25649 L
.86713 .25649 L
.86813 .25649 L
.86913 .25649 L
.87013 .25649 L
.87113 .25649 L
.87213 .25649 L
.87313 .25649 L
.87413 .25649 L
.87512 .25649 L
.87612 .25649 L
.87712 .25649 L
.87812 .25649 L
.87912 .25649 L
.88012 .25649 L
.88112 .25649 L
.88212 .25649 L
.88312 .25649 L
.88412 .25649 L
.88511 .25649 L
.88611 .25649 L
.88711 .25649 L
.88811 .25649 L
.88911 .25649 L
.89011 .25649 L
.89111 .25649 L
.89211 .25649 L
.89311 .25649 L
.89411 .25649 L
.8951 .25649 L
.8961 .25649 L
.8971 .25649 L
.8981 .25649 L
Mistroke
.8991 .26109 L
.9001 .26109 L
.9011 .26109 L
.9021 .26109 L
.9031 .26109 L
.9041 .26109 L
.90509 .26109 L
.90609 .26109 L
.90709 .26109 L
.90809 .26109 L
.90909 .26109 L
.91009 .26109 L
.91109 .26109 L
.91209 .26109 L
.91309 .26109 L
.91409 .26109 L
.91508 .26109 L
.91608 .26109 L
.91708 .26109 L
.91808 .26109 L
.91908 .26109 L
.92008 .26109 L
.92108 .26109 L
.92208 .26109 L
.92308 .26109 L
.92408 .26109 L
.92507 .26109 L
.92607 .26109 L
.92707 .26109 L
.92807 .26109 L
.92907 .26109 L
.93007 .26109 L
.93107 .26109 L
.93207 .26109 L
.93307 .26109 L
.93407 .26109 L
.93506 .26109 L
.93606 .26109 L
.93706 .26109 L
.93806 .26109 L
.93906 .26109 L
.94006 .26109 L
.94106 .26109 L
.94206 .26109 L
.94306 .26109 L
.94406 .26109 L
.94505 .26109 L
.94605 .26109 L
.94705 .26109 L
.94805 .26109 L
Mistroke
.94905 .26591 L
.95005 .26591 L
.95105 .26591 L
.95205 .26591 L
.95305 .26591 L
.95405 .26591 L
.95504 .26591 L
.95604 .26591 L
.95704 .26591 L
.95804 .26591 L
.95904 .26591 L
.96004 .26591 L
.96104 .26591 L
.96204 .26591 L
.96304 .26591 L
.96404 .26591 L
.96503 .26591 L
.96603 .26591 L
.96703 .26591 L
.96803 .26591 L
.96903 .26591 L
.97003 .26591 L
.97103 .26591 L
.97203 .26591 L
.97303 .26591 L
.97403 .26591 L
.97502 .26591 L
.97602 .26591 L
.97702 .26591 L
.97802 .26591 L
.97902 .26591 L
.98002 .26591 L
.98102 .26591 L
.98202 .26591 L
.98302 .26591 L
.98402 .26591 L
.98501 .26591 L
.98601 .26591 L
.98701 .26591 L
.98801 .26591 L
.98901 .26591 L
.99001 .26591 L
.99101 .26591 L
.99201 .26591 L
.99301 .26591 L
.99401 .26591 L
.995 .26591 L
.996 .26591 L
.997 .26591 L
.998 .26591 L
Mistroke
.999 .26444 L
Mfstroke
gsave
.999 .41279 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .49196 m
.001 .49196 L
.002 .49196 L
.003 .49196 L
.004 .49196 L
.005 .49196 L
.00599 .49196 L
.00699 .49196 L
.00799 .49196 L
.00899 .49196 L
.00999 .49196 L
.01099 .49196 L
.01199 .49196 L
.01299 .49196 L
.01399 .49196 L
.01499 .49196 L
.01598 .49196 L
.01698 .49196 L
.01798 .49196 L
.01898 .49196 L
.01998 .49196 L
.02098 .49196 L
.02198 .49196 L
.02298 .49196 L
.02398 .49196 L
.02498 .49196 L
.02597 .49196 L
.02697 .49196 L
.02797 .49196 L
.02897 .49196 L
.02997 .49196 L
.03097 .49196 L
.03197 .49196 L
.03297 .49196 L
.03397 .49196 L
.03497 .49196 L
.03596 .49196 L
.03696 .49196 L
.03796 .49196 L
.03896 .49196 L
.03996 .49196 L
.04096 .49196 L
.04196 .49196 L
.04296 .49196 L
.04396 .49196 L
.04496 .49196 L
.04595 .49196 L
.04695 .49196 L
.04795 .49196 L
.04895 .49196 L
Mistroke
.04995 .50568 L
.05095 .50568 L
.05195 .50568 L
.05295 .50568 L
.05395 .50568 L
.05495 .50568 L
.05594 .50568 L
.05694 .50568 L
.05794 .50568 L
.05894 .50568 L
.05994 .50568 L
.06094 .50568 L
.06194 .50568 L
.06294 .50568 L
.06394 .50568 L
.06494 .50568 L
.06593 .50568 L
.06693 .50568 L
.06793 .50568 L
.06893 .50568 L
.06993 .50568 L
.07093 .50568 L
.07193 .50568 L
.07293 .50568 L
.07393 .50568 L
.07493 .50568 L
.07592 .50568 L
.07692 .50568 L
.07792 .50568 L
.07892 .50568 L
.07992 .50568 L
.08092 .50568 L
.08192 .50568 L
.08292 .50568 L
.08392 .50568 L
.08492 .50568 L
.08591 .50568 L
.08691 .50568 L
.08791 .50568 L
.08891 .50568 L
.08991 .50568 L
.09091 .50568 L
.09191 .50568 L
.09291 .50568 L
.09391 .50568 L
.09491 .50568 L
.0959 .50568 L
.0969 .50568 L
.0979 .50568 L
.0989 .50568 L
Mistroke
.0999 .51918 L
.1009 .51918 L
.1019 .51918 L
.1029 .51918 L
.1039 .51918 L
.1049 .51918 L
.10589 .51918 L
.10689 .51918 L
.10789 .51918 L
.10889 .51918 L
.10989 .51918 L
.11089 .51918 L
.11189 .51918 L
.11289 .51918 L
.11389 .51918 L
.11489 .51918 L
.11588 .51918 L
.11688 .51918 L
.11788 .51918 L
.11888 .51918 L
.11988 .51918 L
.12088 .51918 L
.12188 .51918 L
.12288 .51918 L
.12388 .51918 L
.12488 .51918 L
.12587 .51918 L
.12687 .51918 L
.12787 .51918 L
.12887 .51918 L
.12987 .51918 L
.13087 .51918 L
.13187 .51918 L
.13287 .51918 L
.13387 .51918 L
.13487 .51918 L
.13586 .51918 L
.13686 .51918 L
.13786 .51918 L
.13886 .51918 L
.13986 .51918 L
.14086 .51918 L
.14186 .51918 L
.14286 .51918 L
.14386 .51918 L
.14486 .51918 L
.14585 .51918 L
.14685 .51918 L
.14785 .51918 L
.14885 .51918 L
Mistroke
.14985 .49494 L
.15085 .49494 L
.15185 .49494 L
.15285 .49494 L
.15385 .49494 L
.15485 .49494 L
.15584 .49494 L
.15684 .49494 L
.15784 .49494 L
.15884 .49494 L
.15984 .49494 L
.16084 .49494 L
.16184 .49494 L
.16284 .49494 L
.16384 .49494 L
.16484 .49494 L
.16583 .49494 L
.16683 .49494 L
.16783 .49494 L
.16883 .49494 L
.16983 .49494 L
.17083 .49494 L
.17183 .49494 L
.17283 .49494 L
.17383 .49494 L
.17483 .49494 L
.17582 .49494 L
.17682 .49494 L
.17782 .49494 L
.17882 .49494 L
.17982 .49494 L
.18082 .49494 L
.18182 .49494 L
.18282 .49494 L
.18382 .49494 L
.18482 .49494 L
.18581 .49494 L
.18681 .49494 L
.18781 .49494 L
.18881 .49494 L
.18981 .49494 L
.19081 .49494 L
.19181 .49494 L
.19281 .49494 L
.19381 .49494 L
.19481 .49494 L
.1958 .49494 L
.1968 .49494 L
.1978 .49494 L
.1988 .49494 L
Mistroke
.1998 .47772 L
.2008 .47772 L
.2018 .47772 L
.2028 .47772 L
.2038 .47772 L
.2048 .47772 L
.20579 .47772 L
.20679 .47772 L
.20779 .47772 L
.20879 .47772 L
.20979 .47772 L
.21079 .47772 L
.21179 .47772 L
.21279 .47772 L
.21379 .47772 L
.21479 .47772 L
.21578 .47772 L
.21678 .47772 L
.21778 .47772 L
.21878 .47772 L
.21978 .47772 L
.22078 .47772 L
.22178 .47772 L
.22278 .47772 L
.22378 .47772 L
.22478 .47772 L
.22577 .47772 L
.22677 .47772 L
.22777 .47772 L
.22877 .47772 L
.22977 .47772 L
.23077 .47772 L
.23177 .47772 L
.23277 .47772 L
.23377 .47772 L
.23477 .47772 L
.23576 .47772 L
.23676 .47772 L
.23776 .47772 L
.23876 .47772 L
.23976 .47772 L
.24076 .47772 L
.24176 .47772 L
.24276 .47772 L
.24376 .47772 L
.24476 .47772 L
.24575 .47772 L
.24675 .47772 L
.24775 .47772 L
.24875 .47772 L
Mistroke
.24975 .48458 L
.25075 .48458 L
.25175 .48458 L
.25275 .48458 L
.25375 .48458 L
.25475 .48458 L
.25574 .48458 L
.25674 .48458 L
.25774 .48458 L
.25874 .48458 L
.25974 .48458 L
.26074 .48458 L
.26174 .48458 L
.26274 .48458 L
.26374 .48458 L
.26474 .48458 L
.26573 .48458 L
.26673 .48458 L
.26773 .48458 L
.26873 .48458 L
.26973 .48458 L
.27073 .48458 L
.27173 .48458 L
.27273 .48458 L
.27373 .48458 L
.27473 .48458 L
.27572 .48458 L
.27672 .48458 L
.27772 .48458 L
.27872 .48458 L
.27972 .48458 L
.28072 .48458 L
.28172 .48458 L
.28272 .48458 L
.28372 .48458 L
.28472 .48458 L
.28571 .48458 L
.28671 .48458 L
.28771 .48458 L
.28871 .48458 L
.28971 .48458 L
.29071 .48458 L
.29171 .48458 L
.29271 .48458 L
.29371 .48458 L
.29471 .48458 L
.2957 .48458 L
.2967 .48458 L
.2977 .48458 L
.2987 .48458 L
Mistroke
.2997 .48734 L
.3007 .48734 L
.3017 .48734 L
.3027 .48734 L
.3037 .48734 L
.3047 .48734 L
.30569 .48734 L
.30669 .48734 L
.30769 .48734 L
.30869 .48734 L
.30969 .48734 L
.31069 .48734 L
.31169 .48734 L
.31269 .48734 L
.31369 .48734 L
.31469 .48734 L
.31568 .48734 L
.31668 .48734 L
.31768 .48734 L
.31868 .48734 L
.31968 .48734 L
.32068 .48734 L
.32168 .48734 L
.32268 .48734 L
.32368 .48734 L
.32468 .48734 L
.32567 .48734 L
.32667 .48734 L
.32767 .48734 L
.32867 .48734 L
.32967 .48734 L
.33067 .48734 L
.33167 .48734 L
.33267 .48734 L
.33367 .48734 L
.33467 .48734 L
.33566 .48734 L
.33666 .48734 L
.33766 .48734 L
.33866 .48734 L
.33966 .48734 L
.34066 .48734 L
.34166 .48734 L
.34266 .48734 L
.34366 .48734 L
.34466 .48734 L
.34565 .48734 L
.34665 .48734 L
.34765 .48734 L
.34865 .48734 L
Mistroke
.34965 .47803 L
.35065 .47803 L
.35165 .47803 L
.35265 .47803 L
.35365 .47803 L
.35465 .47803 L
.35564 .47803 L
.35664 .47803 L
.35764 .47803 L
.35864 .47803 L
.35964 .47803 L
.36064 .47803 L
.36164 .47803 L
.36264 .47803 L
.36364 .47803 L
.36464 .47803 L
.36563 .47803 L
.36663 .47803 L
.36763 .47803 L
.36863 .47803 L
.36963 .47803 L
.37063 .47803 L
.37163 .47803 L
.37263 .47803 L
.37363 .47803 L
.37463 .47803 L
.37562 .47803 L
.37662 .47803 L
.37762 .47803 L
.37862 .47803 L
.37962 .47803 L
.38062 .47803 L
.38162 .47803 L
.38262 .47803 L
.38362 .47803 L
.38462 .47803 L
.38561 .47803 L
.38661 .47803 L
.38761 .47803 L
.38861 .47803 L
.38961 .47803 L
.39061 .47803 L
.39161 .47803 L
.39261 .47803 L
.39361 .47803 L
.39461 .47803 L
.3956 .47803 L
.3966 .47803 L
.3976 .47803 L
.3986 .47803 L
Mistroke
.3996 .46292 L
.4006 .46292 L
.4016 .46292 L
.4026 .46292 L
.4036 .46292 L
.4046 .46292 L
.40559 .46292 L
.40659 .46292 L
.40759 .46292 L
.40859 .46292 L
.40959 .46292 L
.41059 .46292 L
.41159 .46292 L
.41259 .46292 L
.41359 .46292 L
.41459 .46292 L
.41558 .46292 L
.41658 .46292 L
.41758 .46292 L
.41858 .46292 L
.41958 .46292 L
.42058 .46292 L
.42158 .46292 L
.42258 .46292 L
.42358 .46292 L
.42458 .46292 L
.42557 .46292 L
.42657 .46292 L
.42757 .46292 L
.42857 .46292 L
.42957 .46292 L
.43057 .46292 L
.43157 .46292 L
.43257 .46292 L
.43357 .46292 L
.43457 .46292 L
.43556 .46292 L
.43656 .46292 L
.43756 .46292 L
.43856 .46292 L
.43956 .46292 L
.44056 .46292 L
.44156 .46292 L
.44256 .46292 L
.44356 .46292 L
.44456 .46292 L
.44555 .46292 L
.44655 .46292 L
.44755 .46292 L
.44855 .46292 L
Mistroke
.44955 .43773 L
.45055 .43773 L
.45155 .43773 L
.45255 .43773 L
.45355 .43773 L
.45455 .43773 L
.45554 .43773 L
.45654 .43773 L
.45754 .43773 L
.45854 .43773 L
.45954 .43773 L
.46054 .43773 L
.46154 .43773 L
.46254 .43773 L
.46354 .43773 L
.46454 .43773 L
.46553 .43773 L
.46653 .43773 L
.46753 .43773 L
.46853 .43773 L
.46953 .43773 L
.47053 .43773 L
.47153 .43773 L
.47253 .43773 L
.47353 .43773 L
.47453 .43773 L
.47552 .43773 L
.47652 .43773 L
.47752 .43773 L
.47852 .43773 L
.47952 .43773 L
.48052 .43773 L
.48152 .43773 L
.48252 .43773 L
.48352 .43773 L
.48452 .43773 L
.48551 .43773 L
.48651 .43773 L
.48751 .43773 L
.48851 .43773 L
.48951 .43773 L
.49051 .43773 L
.49151 .43773 L
.49251 .43773 L
.49351 .43773 L
.49451 .43773 L
.4955 .43773 L
.4965 .43773 L
.4975 .43773 L
.4985 .43773 L
Mistroke
.4995 .43845 L
.5005 .43845 L
.5015 .43845 L
.5025 .43845 L
.5035 .43845 L
.5045 .43845 L
.50549 .43845 L
.50649 .43845 L
.50749 .43845 L
.50849 .43845 L
.50949 .43845 L
.51049 .43845 L
.51149 .43845 L
.51249 .43845 L
.51349 .43845 L
.51449 .43845 L
.51548 .43845 L
.51648 .43845 L
.51748 .43845 L
.51848 .43845 L
.51948 .43845 L
.52048 .43845 L
.52148 .43845 L
.52248 .43845 L
.52348 .43845 L
.52448 .43845 L
.52547 .43845 L
.52647 .43845 L
.52747 .43845 L
.52847 .43845 L
.52947 .43845 L
.53047 .43845 L
.53147 .43845 L
.53247 .43845 L
.53347 .43845 L
.53447 .43845 L
.53546 .43845 L
.53646 .43845 L
.53746 .43845 L
.53846 .43845 L
.53946 .43845 L
.54046 .43845 L
.54146 .43845 L
.54246 .43845 L
.54346 .43845 L
.54446 .43845 L
.54545 .43845 L
.54645 .43845 L
.54745 .43845 L
.54845 .43845 L
Mistroke
.54945 .44013 L
.55045 .44013 L
.55145 .44013 L
.55245 .44013 L
.55345 .44013 L
.55445 .44013 L
.55544 .44013 L
.55644 .44013 L
.55744 .44013 L
.55844 .44013 L
.55944 .44013 L
.56044 .44013 L
.56144 .44013 L
.56244 .44013 L
.56344 .44013 L
.56444 .44013 L
.56543 .44013 L
.56643 .44013 L
.56743 .44013 L
.56843 .44013 L
.56943 .44013 L
.57043 .44013 L
.57143 .44013 L
.57243 .44013 L
.57343 .44013 L
.57443 .44013 L
.57542 .44013 L
.57642 .44013 L
.57742 .44013 L
.57842 .44013 L
.57942 .44013 L
.58042 .44013 L
.58142 .44013 L
.58242 .44013 L
.58342 .44013 L
.58442 .44013 L
.58541 .44013 L
.58641 .44013 L
.58741 .44013 L
.58841 .44013 L
.58941 .44013 L
.59041 .44013 L
.59141 .44013 L
.59241 .44013 L
.59341 .44013 L
.59441 .44013 L
.5954 .44013 L
.5964 .44013 L
.5974 .44013 L
.5984 .44013 L
Mistroke
.5994 .41104 L
.6004 .41104 L
.6014 .41104 L
.6024 .41104 L
.6034 .41104 L
.6044 .41104 L
.60539 .41104 L
.60639 .41104 L
.60739 .41104 L
.60839 .41104 L
.60939 .41104 L
.61039 .41104 L
.61139 .41104 L
.61239 .41104 L
.61339 .41104 L
.61439 .41104 L
.61538 .41104 L
.61638 .41104 L
.61738 .41104 L
.61838 .41104 L
.61938 .41104 L
.62038 .41104 L
.62138 .41104 L
.62238 .41104 L
.62338 .41104 L
.62438 .41104 L
.62537 .41104 L
.62637 .41104 L
.62737 .41104 L
.62837 .41104 L
.62937 .41104 L
.63037 .41104 L
.63137 .41104 L
.63237 .41104 L
.63337 .41104 L
.63437 .41104 L
.63536 .41104 L
.63636 .41104 L
.63736 .41104 L
.63836 .41104 L
.63936 .41104 L
.64036 .41104 L
.64136 .41104 L
.64236 .41104 L
.64336 .41104 L
.64436 .41104 L
.64535 .41104 L
.64635 .41104 L
.64735 .41104 L
.64835 .41104 L
Mistroke
.64935 .42329 L
.65035 .42329 L
.65135 .42329 L
.65235 .42329 L
.65335 .42329 L
.65435 .42329 L
.65534 .42329 L
.65634 .42329 L
.65734 .42329 L
.65834 .42329 L
.65934 .42329 L
.66034 .42329 L
.66134 .42329 L
.66234 .42329 L
.66334 .42329 L
.66434 .42329 L
.66533 .42329 L
.66633 .42329 L
.66733 .42329 L
.66833 .42329 L
.66933 .42329 L
.67033 .42329 L
.67133 .42329 L
.67233 .42329 L
.67333 .42329 L
.67433 .42329 L
.67532 .42329 L
.67632 .42329 L
.67732 .42329 L
.67832 .42329 L
.67932 .42329 L
.68032 .42329 L
.68132 .42329 L
.68232 .42329 L
.68332 .42329 L
.68432 .42329 L
.68531 .42329 L
.68631 .42329 L
.68731 .42329 L
.68831 .42329 L
.68931 .42329 L
.69031 .42329 L
.69131 .42329 L
.69231 .42329 L
.69331 .42329 L
.69431 .42329 L
.6953 .42329 L
.6963 .42329 L
.6973 .42329 L
.6983 .42329 L
Mistroke
.6993 .42584 L
.7003 .42584 L
.7013 .42584 L
.7023 .42584 L
.7033 .42584 L
.7043 .42584 L
.70529 .42584 L
.70629 .42584 L
.70729 .42584 L
.70829 .42584 L
.70929 .42584 L
.71029 .42584 L
.71129 .42584 L
.71229 .42584 L
.71329 .42584 L
.71429 .42584 L
.71528 .42584 L
.71628 .42584 L
.71728 .42584 L
.71828 .42584 L
.71928 .42584 L
.72028 .42584 L
.72128 .42584 L
.72228 .42584 L
.72328 .42584 L
.72428 .42584 L
.72527 .42584 L
.72627 .42584 L
.72727 .42584 L
.72827 .42584 L
.72927 .42584 L
.73027 .42584 L
.73127 .42584 L
.73227 .42584 L
.73327 .42584 L
.73427 .42584 L
.73526 .42584 L
.73626 .42584 L
.73726 .42584 L
.73826 .42584 L
.73926 .42584 L
.74026 .42584 L
.74126 .42584 L
.74226 .42584 L
.74326 .42584 L
.74426 .42584 L
.74525 .42584 L
.74625 .42584 L
.74725 .42584 L
.74825 .42584 L
Mistroke
.74925 .42403 L
.75025 .42403 L
.75125 .42403 L
.75225 .42403 L
.75325 .42403 L
.75425 .42403 L
.75524 .42403 L
.75624 .42403 L
.75724 .42403 L
.75824 .42403 L
.75924 .42403 L
.76024 .42403 L
.76124 .42403 L
.76224 .42403 L
.76324 .42403 L
.76424 .42403 L
.76523 .42403 L
.76623 .42403 L
.76723 .42403 L
.76823 .42403 L
.76923 .42403 L
.77023 .42403 L
.77123 .42403 L
.77223 .42403 L
.77323 .42403 L
.77423 .42403 L
.77522 .42403 L
.77622 .42403 L
.77722 .42403 L
.77822 .42403 L
.77922 .42403 L
.78022 .42403 L
.78122 .42403 L
.78222 .42403 L
.78322 .42403 L
.78422 .42403 L
.78521 .42403 L
.78621 .42403 L
.78721 .42403 L
.78821 .42403 L
.78921 .42403 L
.79021 .42403 L
.79121 .42403 L
.79221 .42403 L
.79321 .42403 L
.79421 .42403 L
.7952 .42403 L
.7962 .42403 L
.7972 .42403 L
.7982 .42403 L
Mistroke
.7992 .41097 L
.8002 .41097 L
.8012 .41097 L
.8022 .41097 L
.8032 .41097 L
.8042 .41097 L
.80519 .41097 L
.80619 .41097 L
.80719 .41097 L
.80819 .41097 L
.80919 .41097 L
.81019 .41097 L
.81119 .41097 L
.81219 .41097 L
.81319 .41097 L
.81419 .41097 L
.81518 .41097 L
.81618 .41097 L
.81718 .41097 L
.81818 .41097 L
.81918 .41097 L
.82018 .41097 L
.82118 .41097 L
.82218 .41097 L
.82318 .41097 L
.82418 .41097 L
.82517 .41097 L
.82617 .41097 L
.82717 .41097 L
.82817 .41097 L
.82917 .41097 L
.83017 .41097 L
.83117 .41097 L
.83217 .41097 L
.83317 .41097 L
.83417 .41097 L
.83516 .41097 L
.83616 .41097 L
.83716 .41097 L
.83816 .41097 L
.83916 .41097 L
.84016 .41097 L
.84116 .41097 L
.84216 .41097 L
.84316 .41097 L
.84416 .41097 L
.84515 .41097 L
.84615 .41097 L
.84715 .41097 L
.84815 .41097 L
Mistroke
.84915 .41368 L
.85015 .41368 L
.85115 .41368 L
.85215 .41368 L
.85315 .41368 L
.85415 .41368 L
.85514 .41368 L
.85614 .41368 L
.85714 .41368 L
.85814 .41368 L
.85914 .41368 L
.86014 .41368 L
.86114 .41368 L
.86214 .41368 L
.86314 .41368 L
.86414 .41368 L
.86513 .41368 L
.86613 .41368 L
.86713 .41368 L
.86813 .41368 L
.86913 .41368 L
.87013 .41368 L
.87113 .41368 L
.87213 .41368 L
.87313 .41368 L
.87413 .41368 L
.87512 .41368 L
.87612 .41368 L
.87712 .41368 L
.87812 .41368 L
.87912 .41368 L
.88012 .41368 L
.88112 .41368 L
.88212 .41368 L
.88312 .41368 L
.88412 .41368 L
.88511 .41368 L
.88611 .41368 L
.88711 .41368 L
.88811 .41368 L
.88911 .41368 L
.89011 .41368 L
.89111 .41368 L
.89211 .41368 L
.89311 .41368 L
.89411 .41368 L
.8951 .41368 L
.8961 .41368 L
.8971 .41368 L
.8981 .41368 L
Mistroke
.8991 .41699 L
.9001 .41699 L
.9011 .41699 L
.9021 .41699 L
.9031 .41699 L
.9041 .41699 L
.90509 .41699 L
.90609 .41699 L
.90709 .41699 L
.90809 .41699 L
.90909 .41699 L
.91009 .41699 L
.91109 .41699 L
.91209 .41699 L
.91309 .41699 L
.91409 .41699 L
.91508 .41699 L
.91608 .41699 L
.91708 .41699 L
.91808 .41699 L
.91908 .41699 L
.92008 .41699 L
.92108 .41699 L
.92208 .41699 L
.92308 .41699 L
.92408 .41699 L
.92507 .41699 L
.92607 .41699 L
.92707 .41699 L
.92807 .41699 L
.92907 .41699 L
.93007 .41699 L
.93107 .41699 L
.93207 .41699 L
.93307 .41699 L
.93407 .41699 L
.93506 .41699 L
.93606 .41699 L
.93706 .41699 L
.93806 .41699 L
.93906 .41699 L
.94006 .41699 L
.94106 .41699 L
.94206 .41699 L
.94306 .41699 L
.94406 .41699 L
.94505 .41699 L
.94605 .41699 L
.94705 .41699 L
.94805 .41699 L
Mistroke
.94905 .41996 L
.95005 .41996 L
.95105 .41996 L
.95205 .41996 L
.95305 .41996 L
.95405 .41996 L
.95504 .41996 L
.95604 .41996 L
.95704 .41996 L
.95804 .41996 L
.95904 .41996 L
.96004 .41996 L
.96104 .41996 L
.96204 .41996 L
.96304 .41996 L
.96404 .41996 L
.96503 .41996 L
.96603 .41996 L
.96703 .41996 L
.96803 .41996 L
.96903 .41996 L
.97003 .41996 L
.97103 .41996 L
.97203 .41996 L
.97303 .41996 L
.97403 .41996 L
.97502 .41996 L
.97602 .41996 L
.97702 .41996 L
.97802 .41996 L
.97902 .41996 L
.98002 .41996 L
.98102 .41996 L
.98202 .41996 L
.98302 .41996 L
.98402 .41996 L
.98501 .41996 L
.98601 .41996 L
.98701 .41996 L
.98801 .41996 L
.98901 .41996 L
.99001 .41996 L
.99101 .41996 L
.99201 .41996 L
.99301 .41996 L
.99401 .41996 L
.995 .41996 L
.996 .41996 L
.997 .41996 L
.998 .41996 L
Mistroke
.999 .41279 L
Mfstroke
1 0 0 r
gsave
.999 .33862 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37082 m
.001 .37082 L
.002 .37082 L
.003 .37082 L
.004 .37082 L
.005 .37082 L
.00599 .37082 L
.00699 .37082 L
.00799 .37082 L
.00899 .37082 L
.00999 .37082 L
.01099 .37082 L
.01199 .37082 L
.01299 .37082 L
.01399 .37082 L
.01499 .37082 L
.01598 .37082 L
.01698 .37082 L
.01798 .37082 L
.01898 .37082 L
.01998 .37082 L
.02098 .37082 L
.02198 .37082 L
.02298 .37082 L
.02398 .37082 L
.02498 .37082 L
.02597 .37082 L
.02697 .37082 L
.02797 .37082 L
.02897 .37082 L
.02997 .37082 L
.03097 .37082 L
.03197 .37082 L
.03297 .37082 L
.03397 .37082 L
.03497 .37082 L
.03596 .37082 L
.03696 .37082 L
.03796 .37082 L
.03896 .37082 L
.03996 .37082 L
.04096 .37082 L
.04196 .37082 L
.04296 .37082 L
.04396 .37082 L
.04496 .37082 L
.04595 .37082 L
.04695 .37082 L
.04795 .37082 L
.04895 .37082 L
Mistroke
.04995 .38473 L
.05095 .38473 L
.05195 .38473 L
.05295 .38473 L
.05395 .38473 L
.05495 .38473 L
.05594 .38473 L
.05694 .38473 L
.05794 .38473 L
.05894 .38473 L
.05994 .38473 L
.06094 .38473 L
.06194 .38473 L
.06294 .38473 L
.06394 .38473 L
.06494 .38473 L
.06593 .38473 L
.06693 .38473 L
.06793 .38473 L
.06893 .38473 L
.06993 .38473 L
.07093 .38473 L
.07193 .38473 L
.07293 .38473 L
.07393 .38473 L
.07493 .38473 L
.07592 .38473 L
.07692 .38473 L
.07792 .38473 L
.07892 .38473 L
.07992 .38473 L
.08092 .38473 L
.08192 .38473 L
.08292 .38473 L
.08392 .38473 L
.08492 .38473 L
.08591 .38473 L
.08691 .38473 L
.08791 .38473 L
.08891 .38473 L
.08991 .38473 L
.09091 .38473 L
.09191 .38473 L
.09291 .38473 L
.09391 .38473 L
.09491 .38473 L
.0959 .38473 L
.0969 .38473 L
.0979 .38473 L
.0989 .38473 L
Mistroke
.0999 .41119 L
.1009 .41119 L
.1019 .41119 L
.1029 .41119 L
.1039 .41119 L
.1049 .41119 L
.10589 .41119 L
.10689 .41119 L
.10789 .41119 L
.10889 .41119 L
.10989 .41119 L
.11089 .41119 L
.11189 .41119 L
.11289 .41119 L
.11389 .41119 L
.11489 .41119 L
.11588 .41119 L
.11688 .41119 L
.11788 .41119 L
.11888 .41119 L
.11988 .41119 L
.12088 .41119 L
.12188 .41119 L
.12288 .41119 L
.12388 .41119 L
.12488 .41119 L
.12587 .41119 L
.12687 .41119 L
.12787 .41119 L
.12887 .41119 L
.12987 .41119 L
.13087 .41119 L
.13187 .41119 L
.13287 .41119 L
.13387 .41119 L
.13487 .41119 L
.13586 .41119 L
.13686 .41119 L
.13786 .41119 L
.13886 .41119 L
.13986 .41119 L
.14086 .41119 L
.14186 .41119 L
.14286 .41119 L
.14386 .41119 L
.14486 .41119 L
.14585 .41119 L
.14685 .41119 L
.14785 .41119 L
.14885 .41119 L
Mistroke
.14985 .38889 L
.15085 .38889 L
.15185 .38889 L
.15285 .38889 L
.15385 .38889 L
.15485 .38889 L
.15584 .38889 L
.15684 .38889 L
.15784 .38889 L
.15884 .38889 L
.15984 .38889 L
.16084 .38889 L
.16184 .38889 L
.16284 .38889 L
.16384 .38889 L
.16484 .38889 L
.16583 .38889 L
.16683 .38889 L
.16783 .38889 L
.16883 .38889 L
.16983 .38889 L
.17083 .38889 L
.17183 .38889 L
.17283 .38889 L
.17383 .38889 L
.17483 .38889 L
.17582 .38889 L
.17682 .38889 L
.17782 .38889 L
.17882 .38889 L
.17982 .38889 L
.18082 .38889 L
.18182 .38889 L
.18282 .38889 L
.18382 .38889 L
.18482 .38889 L
.18581 .38889 L
.18681 .38889 L
.18781 .38889 L
.18881 .38889 L
.18981 .38889 L
.19081 .38889 L
.19181 .38889 L
.19281 .38889 L
.19381 .38889 L
.19481 .38889 L
.1958 .38889 L
.1968 .38889 L
.1978 .38889 L
.1988 .38889 L
Mistroke
.1998 .3725 L
.2008 .3725 L
.2018 .3725 L
.2028 .3725 L
.2038 .3725 L
.2048 .3725 L
.20579 .3725 L
.20679 .3725 L
.20779 .3725 L
.20879 .3725 L
.20979 .3725 L
.21079 .3725 L
.21179 .3725 L
.21279 .3725 L
.21379 .3725 L
.21479 .3725 L
.21578 .3725 L
.21678 .3725 L
.21778 .3725 L
.21878 .3725 L
.21978 .3725 L
.22078 .3725 L
.22178 .3725 L
.22278 .3725 L
.22378 .3725 L
.22478 .3725 L
.22577 .3725 L
.22677 .3725 L
.22777 .3725 L
.22877 .3725 L
.22977 .3725 L
.23077 .3725 L
.23177 .3725 L
.23277 .3725 L
.23377 .3725 L
.23477 .3725 L
.23576 .3725 L
.23676 .3725 L
.23776 .3725 L
.23876 .3725 L
.23976 .3725 L
.24076 .3725 L
.24176 .3725 L
.24276 .3725 L
.24376 .3725 L
.24476 .3725 L
.24575 .3725 L
.24675 .3725 L
.24775 .3725 L
.24875 .3725 L
Mistroke
.24975 .38043 L
.25075 .38043 L
.25175 .38043 L
.25275 .38043 L
.25375 .38043 L
.25475 .38043 L
.25574 .38043 L
.25674 .38043 L
.25774 .38043 L
.25874 .38043 L
.25974 .38043 L
.26074 .38043 L
.26174 .38043 L
.26274 .38043 L
.26374 .38043 L
.26474 .38043 L
.26573 .38043 L
.26673 .38043 L
.26773 .38043 L
.26873 .38043 L
.26973 .38043 L
.27073 .38043 L
.27173 .38043 L
.27273 .38043 L
.27373 .38043 L
.27473 .38043 L
.27572 .38043 L
.27672 .38043 L
.27772 .38043 L
.27872 .38043 L
.27972 .38043 L
.28072 .38043 L
.28172 .38043 L
.28272 .38043 L
.28372 .38043 L
.28472 .38043 L
.28571 .38043 L
.28671 .38043 L
.28771 .38043 L
.28871 .38043 L
.28971 .38043 L
.29071 .38043 L
.29171 .38043 L
.29271 .38043 L
.29371 .38043 L
.29471 .38043 L
.2957 .38043 L
.2967 .38043 L
.2977 .38043 L
.2987 .38043 L
Mistroke
.2997 .38453 L
.3007 .38453 L
.3017 .38453 L
.3027 .38453 L
.3037 .38453 L
.3047 .38453 L
.30569 .38453 L
.30669 .38453 L
.30769 .38453 L
.30869 .38453 L
.30969 .38453 L
.31069 .38453 L
.31169 .38453 L
.31269 .38453 L
.31369 .38453 L
.31469 .38453 L
.31568 .38453 L
.31668 .38453 L
.31768 .38453 L
.31868 .38453 L
.31968 .38453 L
.32068 .38453 L
.32168 .38453 L
.32268 .38453 L
.32368 .38453 L
.32468 .38453 L
.32567 .38453 L
.32667 .38453 L
.32767 .38453 L
.32867 .38453 L
.32967 .38453 L
.33067 .38453 L
.33167 .38453 L
.33267 .38453 L
.33367 .38453 L
.33467 .38453 L
.33566 .38453 L
.33666 .38453 L
.33766 .38453 L
.33866 .38453 L
.33966 .38453 L
.34066 .38453 L
.34166 .38453 L
.34266 .38453 L
.34366 .38453 L
.34466 .38453 L
.34565 .38453 L
.34665 .38453 L
.34765 .38453 L
.34865 .38453 L
Mistroke
.34965 .37866 L
.35065 .37866 L
.35165 .37866 L
.35265 .37866 L
.35365 .37866 L
.35465 .37866 L
.35564 .37866 L
.35664 .37866 L
.35764 .37866 L
.35864 .37866 L
.35964 .37866 L
.36064 .37866 L
.36164 .37866 L
.36264 .37866 L
.36364 .37866 L
.36464 .37866 L
.36563 .37866 L
.36663 .37866 L
.36763 .37866 L
.36863 .37866 L
.36963 .37866 L
.37063 .37866 L
.37163 .37866 L
.37263 .37866 L
.37363 .37866 L
.37463 .37866 L
.37562 .37866 L
.37662 .37866 L
.37762 .37866 L
.37862 .37866 L
.37962 .37866 L
.38062 .37866 L
.38162 .37866 L
.38262 .37866 L
.38362 .37866 L
.38462 .37866 L
.38561 .37866 L
.38661 .37866 L
.38761 .37866 L
.38861 .37866 L
.38961 .37866 L
.39061 .37866 L
.39161 .37866 L
.39261 .37866 L
.39361 .37866 L
.39461 .37866 L
.3956 .37866 L
.3966 .37866 L
.3976 .37866 L
.3986 .37866 L
Mistroke
.3996 .36427 L
.4006 .36427 L
.4016 .36427 L
.4026 .36427 L
.4036 .36427 L
.4046 .36427 L
.40559 .36427 L
.40659 .36427 L
.40759 .36427 L
.40859 .36427 L
.40959 .36427 L
.41059 .36427 L
.41159 .36427 L
.41259 .36427 L
.41359 .36427 L
.41459 .36427 L
.41558 .36427 L
.41658 .36427 L
.41758 .36427 L
.41858 .36427 L
.41958 .36427 L
.42058 .36427 L
.42158 .36427 L
.42258 .36427 L
.42358 .36427 L
.42458 .36427 L
.42557 .36427 L
.42657 .36427 L
.42757 .36427 L
.42857 .36427 L
.42957 .36427 L
.43057 .36427 L
.43157 .36427 L
.43257 .36427 L
.43357 .36427 L
.43457 .36427 L
.43556 .36427 L
.43656 .36427 L
.43756 .36427 L
.43856 .36427 L
.43956 .36427 L
.44056 .36427 L
.44156 .36427 L
.44256 .36427 L
.44356 .36427 L
.44456 .36427 L
.44555 .36427 L
.44655 .36427 L
.44755 .36427 L
.44855 .36427 L
Mistroke
.44955 .34885 L
.45055 .34885 L
.45155 .34885 L
.45255 .34885 L
.45355 .34885 L
.45455 .34885 L
.45554 .34885 L
.45654 .34885 L
.45754 .34885 L
.45854 .34885 L
.45954 .34885 L
.46054 .34885 L
.46154 .34885 L
.46254 .34885 L
.46354 .34885 L
.46454 .34885 L
.46553 .34885 L
.46653 .34885 L
.46753 .34885 L
.46853 .34885 L
.46953 .34885 L
.47053 .34885 L
.47153 .34885 L
.47253 .34885 L
.47353 .34885 L
.47453 .34885 L
.47552 .34885 L
.47652 .34885 L
.47752 .34885 L
.47852 .34885 L
.47952 .34885 L
.48052 .34885 L
.48152 .34885 L
.48252 .34885 L
.48352 .34885 L
.48452 .34885 L
.48551 .34885 L
.48651 .34885 L
.48751 .34885 L
.48851 .34885 L
.48951 .34885 L
.49051 .34885 L
.49151 .34885 L
.49251 .34885 L
.49351 .34885 L
.49451 .34885 L
.4955 .34885 L
.4965 .34885 L
.4975 .34885 L
.4985 .34885 L
Mistroke
.4995 .34963 L
.5005 .34963 L
.5015 .34963 L
.5025 .34963 L
.5035 .34963 L
.5045 .34963 L
.50549 .34963 L
.50649 .34963 L
.50749 .34963 L
.50849 .34963 L
.50949 .34963 L
.51049 .34963 L
.51149 .34963 L
.51249 .34963 L
.51349 .34963 L
.51449 .34963 L
.51548 .34963 L
.51648 .34963 L
.51748 .34963 L
.51848 .34963 L
.51948 .34963 L
.52048 .34963 L
.52148 .34963 L
.52248 .34963 L
.52348 .34963 L
.52448 .34963 L
.52547 .34963 L
.52647 .34963 L
.52747 .34963 L
.52847 .34963 L
.52947 .34963 L
.53047 .34963 L
.53147 .34963 L
.53247 .34963 L
.53347 .34963 L
.53447 .34963 L
.53546 .34963 L
.53646 .34963 L
.53746 .34963 L
.53846 .34963 L
.53946 .34963 L
.54046 .34963 L
.54146 .34963 L
.54246 .34963 L
.54346 .34963 L
.54446 .34963 L
.54545 .34963 L
.54645 .34963 L
.54745 .34963 L
.54845 .34963 L
Mistroke
.54945 .35137 L
.55045 .35137 L
.55145 .35137 L
.55245 .35137 L
.55345 .35137 L
.55445 .35137 L
.55544 .35137 L
.55644 .35137 L
.55744 .35137 L
.55844 .35137 L
.55944 .35137 L
.56044 .35137 L
.56144 .35137 L
.56244 .35137 L
.56344 .35137 L
.56444 .35137 L
.56543 .35137 L
.56643 .35137 L
.56743 .35137 L
.56843 .35137 L
.56943 .35137 L
.57043 .35137 L
.57143 .35137 L
.57243 .35137 L
.57343 .35137 L
.57443 .35137 L
.57542 .35137 L
.57642 .35137 L
.57742 .35137 L
.57842 .35137 L
.57942 .35137 L
.58042 .35137 L
.58142 .35137 L
.58242 .35137 L
.58342 .35137 L
.58442 .35137 L
.58541 .35137 L
.58641 .35137 L
.58741 .35137 L
.58841 .35137 L
.58941 .35137 L
.59041 .35137 L
.59141 .35137 L
.59241 .35137 L
.59341 .35137 L
.59441 .35137 L
.5954 .35137 L
.5964 .35137 L
.5974 .35137 L
.5984 .35137 L
Mistroke
.5994 .32716 L
.6004 .32716 L
.6014 .32716 L
.6024 .32716 L
.6034 .32716 L
.6044 .32716 L
.60539 .32716 L
.60639 .32716 L
.60739 .32716 L
.60839 .32716 L
.60939 .32716 L
.61039 .32716 L
.61139 .32716 L
.61239 .32716 L
.61339 .32716 L
.61439 .32716 L
.61538 .32716 L
.61638 .32716 L
.61738 .32716 L
.61838 .32716 L
.61938 .32716 L
.62038 .32716 L
.62138 .32716 L
.62238 .32716 L
.62338 .32716 L
.62438 .32716 L
.62537 .32716 L
.62637 .32716 L
.62737 .32716 L
.62837 .32716 L
.62937 .32716 L
.63037 .32716 L
.63137 .32716 L
.63237 .32716 L
.63337 .32716 L
.63437 .32716 L
.63536 .32716 L
.63636 .32716 L
.63736 .32716 L
.63836 .32716 L
.63936 .32716 L
.64036 .32716 L
.64136 .32716 L
.64236 .32716 L
.64336 .32716 L
.64436 .32716 L
.64535 .32716 L
.64635 .32716 L
.64735 .32716 L
.64835 .32716 L
Mistroke
.64935 .34094 L
.65035 .34094 L
.65135 .34094 L
.65235 .34094 L
.65335 .34094 L
.65435 .34094 L
.65534 .34094 L
.65634 .34094 L
.65734 .34094 L
.65834 .34094 L
.65934 .34094 L
.66034 .34094 L
.66134 .34094 L
.66234 .34094 L
.66334 .34094 L
.66434 .34094 L
.66533 .34094 L
.66633 .34094 L
.66733 .34094 L
.66833 .34094 L
.66933 .34094 L
.67033 .34094 L
.67133 .34094 L
.67233 .34094 L
.67333 .34094 L
.67433 .34094 L
.67532 .34094 L
.67632 .34094 L
.67732 .34094 L
.67832 .34094 L
.67932 .34094 L
.68032 .34094 L
.68132 .34094 L
.68232 .34094 L
.68332 .34094 L
.68432 .34094 L
.68531 .34094 L
.68631 .34094 L
.68731 .34094 L
.68831 .34094 L
.68931 .34094 L
.69031 .34094 L
.69131 .34094 L
.69231 .34094 L
.69331 .34094 L
.69431 .34094 L
.6953 .34094 L
.6963 .34094 L
.6973 .34094 L
.6983 .34094 L
Mistroke
.6993 .34513 L
.7003 .34513 L
.7013 .34513 L
.7023 .34513 L
.7033 .34513 L
.7043 .34513 L
.70529 .34513 L
.70629 .34513 L
.70729 .34513 L
.70829 .34513 L
.70929 .34513 L
.71029 .34513 L
.71129 .34513 L
.71229 .34513 L
.71329 .34513 L
.71429 .34513 L
.71528 .34513 L
.71628 .34513 L
.71728 .34513 L
.71828 .34513 L
.71928 .34513 L
.72028 .34513 L
.72128 .34513 L
.72228 .34513 L
.72328 .34513 L
.72428 .34513 L
.72527 .34513 L
.72627 .34513 L
.72727 .34513 L
.72827 .34513 L
.72927 .34513 L
.73027 .34513 L
.73127 .34513 L
.73227 .34513 L
.73327 .34513 L
.73427 .34513 L
.73526 .34513 L
.73626 .34513 L
.73726 .34513 L
.73826 .34513 L
.73926 .34513 L
.74026 .34513 L
.74126 .34513 L
.74226 .34513 L
.74326 .34513 L
.74426 .34513 L
.74525 .34513 L
.74625 .34513 L
.74725 .34513 L
.74825 .34513 L
Mistroke
.74925 .34352 L
.75025 .34352 L
.75125 .34352 L
.75225 .34352 L
.75325 .34352 L
.75425 .34352 L
.75524 .34352 L
.75624 .34352 L
.75724 .34352 L
.75824 .34352 L
.75924 .34352 L
.76024 .34352 L
.76124 .34352 L
.76224 .34352 L
.76324 .34352 L
.76424 .34352 L
.76523 .34352 L
.76623 .34352 L
.76723 .34352 L
.76823 .34352 L
.76923 .34352 L
.77023 .34352 L
.77123 .34352 L
.77223 .34352 L
.77323 .34352 L
.77423 .34352 L
.77522 .34352 L
.77622 .34352 L
.77722 .34352 L
.77822 .34352 L
.77922 .34352 L
.78022 .34352 L
.78122 .34352 L
.78222 .34352 L
.78322 .34352 L
.78422 .34352 L
.78521 .34352 L
.78621 .34352 L
.78721 .34352 L
.78821 .34352 L
.78921 .34352 L
.79021 .34352 L
.79121 .34352 L
.79221 .34352 L
.79321 .34352 L
.79421 .34352 L
.7952 .34352 L
.7962 .34352 L
.7972 .34352 L
.7982 .34352 L
Mistroke
.7992 .3322 L
.8002 .3322 L
.8012 .3322 L
.8022 .3322 L
.8032 .3322 L
.8042 .3322 L
.80519 .3322 L
.80619 .3322 L
.80719 .3322 L
.80819 .3322 L
.80919 .3322 L
.81019 .3322 L
.81119 .3322 L
.81219 .3322 L
.81319 .3322 L
.81419 .3322 L
.81518 .3322 L
.81618 .3322 L
.81718 .3322 L
.81818 .3322 L
.81918 .3322 L
.82018 .3322 L
.82118 .3322 L
.82218 .3322 L
.82318 .3322 L
.82418 .3322 L
.82517 .3322 L
.82617 .3322 L
.82717 .3322 L
.82817 .3322 L
.82917 .3322 L
.83017 .3322 L
.83117 .3322 L
.83217 .3322 L
.83317 .3322 L
.83417 .3322 L
.83516 .3322 L
.83616 .3322 L
.83716 .3322 L
.83816 .3322 L
.83916 .3322 L
.84016 .3322 L
.84116 .3322 L
.84216 .3322 L
.84316 .3322 L
.84416 .3322 L
.84515 .3322 L
.84615 .3322 L
.84715 .3322 L
.84815 .3322 L
Mistroke
.84915 .33509 L
.85015 .33509 L
.85115 .33509 L
.85215 .33509 L
.85315 .33509 L
.85415 .33509 L
.85514 .33509 L
.85614 .33509 L
.85714 .33509 L
.85814 .33509 L
.85914 .33509 L
.86014 .33509 L
.86114 .33509 L
.86214 .33509 L
.86314 .33509 L
.86414 .33509 L
.86513 .33509 L
.86613 .33509 L
.86713 .33509 L
.86813 .33509 L
.86913 .33509 L
.87013 .33509 L
.87113 .33509 L
.87213 .33509 L
.87313 .33509 L
.87413 .33509 L
.87512 .33509 L
.87612 .33509 L
.87712 .33509 L
.87812 .33509 L
.87912 .33509 L
.88012 .33509 L
.88112 .33509 L
.88212 .33509 L
.88312 .33509 L
.88412 .33509 L
.88511 .33509 L
.88611 .33509 L
.88711 .33509 L
.88811 .33509 L
.88911 .33509 L
.89011 .33509 L
.89111 .33509 L
.89211 .33509 L
.89311 .33509 L
.89411 .33509 L
.8951 .33509 L
.8961 .33509 L
.8971 .33509 L
.8981 .33509 L
Mistroke
.8991 .33904 L
.9001 .33904 L
.9011 .33904 L
.9021 .33904 L
.9031 .33904 L
.9041 .33904 L
.90509 .33904 L
.90609 .33904 L
.90709 .33904 L
.90809 .33904 L
.90909 .33904 L
.91009 .33904 L
.91109 .33904 L
.91209 .33904 L
.91309 .33904 L
.91409 .33904 L
.91508 .33904 L
.91608 .33904 L
.91708 .33904 L
.91808 .33904 L
.91908 .33904 L
.92008 .33904 L
.92108 .33904 L
.92208 .33904 L
.92308 .33904 L
.92408 .33904 L
.92507 .33904 L
.92607 .33904 L
.92707 .33904 L
.92807 .33904 L
.92907 .33904 L
.93007 .33904 L
.93107 .33904 L
.93207 .33904 L
.93307 .33904 L
.93407 .33904 L
.93506 .33904 L
.93606 .33904 L
.93706 .33904 L
.93806 .33904 L
.93906 .33904 L
.94006 .33904 L
.94106 .33904 L
.94206 .33904 L
.94306 .33904 L
.94406 .33904 L
.94505 .33904 L
.94605 .33904 L
.94705 .33904 L
.94805 .33904 L
Mistroke
.94905 .34293 L
.95005 .34293 L
.95105 .34293 L
.95205 .34293 L
.95305 .34293 L
.95405 .34293 L
.95504 .34293 L
.95604 .34293 L
.95704 .34293 L
.95804 .34293 L
.95904 .34293 L
.96004 .34293 L
.96104 .34293 L
.96204 .34293 L
.96304 .34293 L
.96404 .34293 L
.96503 .34293 L
.96603 .34293 L
.96703 .34293 L
.96803 .34293 L
.96903 .34293 L
.97003 .34293 L
.97103 .34293 L
.97203 .34293 L
.97303 .34293 L
.97403 .34293 L
.97502 .34293 L
.97602 .34293 L
.97702 .34293 L
.97802 .34293 L
.97902 .34293 L
.98002 .34293 L
.98102 .34293 L
.98202 .34293 L
.98302 .34293 L
.98402 .34293 L
.98501 .34293 L
.98601 .34293 L
.98701 .34293 L
.98801 .34293 L
.98901 .34293 L
.99001 .34293 L
.99101 .34293 L
.99201 .34293 L
.99301 .34293 L
.99401 .34293 L
.995 .34293 L
.996 .34293 L
.997 .34293 L
.998 .34293 L
Mistroke
.999 .33862 L
Mfstroke
0 0 1 r
gsave
.001 -0.61803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -1.54508 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(26)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(28)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(32)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(34)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .18541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .18541 L
.05095 .18541 L
.05195 .18541 L
.05295 .18541 L
.05395 .18541 L
.05495 .18541 L
.05594 .18541 L
.05694 .18541 L
.05794 .18541 L
.05894 .18541 L
.05994 .18541 L
.06094 .18541 L
.06194 .18541 L
.06294 .18541 L
.06394 .18541 L
.06494 .18541 L
.06593 .18541 L
.06693 .18541 L
.06793 .18541 L
.06893 .18541 L
.06993 .18541 L
.07093 .18541 L
.07193 .18541 L
.07293 .18541 L
.07393 .18541 L
.07493 .18541 L
.07592 .18541 L
.07692 .18541 L
.07792 .18541 L
.07892 .18541 L
.07992 .18541 L
.08092 .18541 L
.08192 .18541 L
.08292 .18541 L
.08392 .18541 L
.08492 .18541 L
.08591 .18541 L
.08691 .18541 L
.08791 .18541 L
.08891 .18541 L
.08991 .18541 L
.09091 .18541 L
.09191 .18541 L
.09291 .18541 L
.09391 .18541 L
.09491 .18541 L
.0959 .18541 L
.0969 .18541 L
.0979 .18541 L
.0989 .18541 L
Mistroke
.0999 .18541 L
.1009 .18541 L
.1019 .18541 L
.1029 .18541 L
.1039 .18541 L
.1049 .18541 L
.10589 .18541 L
.10689 .18541 L
.10789 .18541 L
.10889 .18541 L
.10989 .18541 L
.11089 .18541 L
.11189 .18541 L
.11289 .18541 L
.11389 .18541 L
.11489 .18541 L
.11588 .18541 L
.11688 .18541 L
.11788 .18541 L
.11888 .18541 L
.11988 .18541 L
.12088 .18541 L
.12188 .18541 L
.12288 .18541 L
.12388 .18541 L
.12488 .18541 L
.12587 .18541 L
.12687 .18541 L
.12787 .18541 L
.12887 .18541 L
.12987 .18541 L
.13087 .18541 L
.13187 .18541 L
.13287 .18541 L
.13387 .18541 L
.13487 .18541 L
.13586 .18541 L
.13686 .18541 L
.13786 .18541 L
.13886 .18541 L
.13986 .18541 L
.14086 .18541 L
.14186 .18541 L
.14286 .18541 L
.14386 .18541 L
.14486 .18541 L
.14585 .18541 L
.14685 .18541 L
.14785 .18541 L
.14885 .18541 L
Mistroke
.14985 .18541 L
.15085 .18541 L
.15185 .18541 L
.15285 .18541 L
.15385 .18541 L
.15485 .18541 L
.15584 .18541 L
.15684 .18541 L
.15784 .18541 L
.15884 .18541 L
.15984 .18541 L
.16084 .18541 L
.16184 .18541 L
.16284 .18541 L
.16384 .18541 L
.16484 .18541 L
.16583 .18541 L
.16683 .18541 L
.16783 .18541 L
.16883 .18541 L
.16983 .18541 L
.17083 .18541 L
.17183 .18541 L
.17283 .18541 L
.17383 .18541 L
.17483 .18541 L
.17582 .18541 L
.17682 .18541 L
.17782 .18541 L
.17882 .18541 L
.17982 .18541 L
.18082 .18541 L
.18182 .18541 L
.18282 .18541 L
.18382 .18541 L
.18482 .18541 L
.18581 .18541 L
.18681 .18541 L
.18781 .18541 L
.18881 .18541 L
.18981 .18541 L
.19081 .18541 L
.19181 .18541 L
.19281 .18541 L
.19381 .18541 L
.19481 .18541 L
.1958 .18541 L
.1968 .18541 L
.1978 .18541 L
.1988 .18541 L
Mistroke
.1998 .18541 L
.2008 .18541 L
.2018 .18541 L
.2028 .18541 L
.2038 .18541 L
.2048 .18541 L
.20579 .18541 L
.20679 .18541 L
.20779 .18541 L
.20879 .18541 L
.20979 .18541 L
.21079 .18541 L
.21179 .18541 L
.21279 .18541 L
.21379 .18541 L
.21479 .18541 L
.21578 .18541 L
.21678 .18541 L
.21778 .18541 L
.21878 .18541 L
.21978 .18541 L
.22078 .18541 L
.22178 .18541 L
.22278 .18541 L
.22378 .18541 L
.22478 .18541 L
.22577 .18541 L
.22677 .18541 L
.22777 .18541 L
.22877 .18541 L
.22977 .18541 L
.23077 .18541 L
.23177 .18541 L
.23277 .18541 L
.23377 .18541 L
.23477 .18541 L
.23576 .18541 L
.23676 .18541 L
.23776 .18541 L
.23876 .18541 L
.23976 .18541 L
.24076 .18541 L
.24176 .18541 L
.24276 .18541 L
.24376 .18541 L
.24476 .18541 L
.24575 .18541 L
.24675 .18541 L
.24775 .18541 L
.24875 .18541 L
Mistroke
.24975 .18541 L
.25075 .18541 L
.25175 .18541 L
.25275 .18542 L
.25375 .18541 L
.25475 .18542 L
.25574 .18542 L
.25674 .18542 L
.25774 .18542 L
.25874 .18542 L
.25974 .18542 L
.26074 .18542 L
.26174 .18542 L
.26274 .18542 L
.26374 .18542 L
.26474 .18542 L
.26573 .18542 L
.26673 .18542 L
.26773 .18542 L
.26873 .18542 L
.26973 .18542 L
.27073 .18542 L
.27173 .18542 L
.27273 .18542 L
.27373 .18542 L
.27473 .18542 L
.27572 .18542 L
.27672 .18542 L
.27772 .18542 L
.27872 .18542 L
.27972 .18542 L
.28072 .18542 L
.28172 .18542 L
.28272 .18542 L
.28372 .18542 L
.28472 .18542 L
.28571 .18542 L
.28671 .18542 L
.28771 .18542 L
.28871 .18542 L
.28971 .18542 L
.29071 .18542 L
.29171 .18542 L
.29271 .18542 L
.29371 .18542 L
.29471 .18541 L
.2957 .18542 L
.2967 .18542 L
.2977 .18541 L
.2987 .18541 L
Mistroke
.2997 .18541 L
.3007 .18541 L
.3017 .18541 L
.3027 .18541 L
.3037 .18542 L
.3047 .18542 L
.30569 .18542 L
.30669 .18542 L
.30769 .18541 L
.30869 .18541 L
.30969 .18541 L
.31069 .18541 L
.31169 .18541 L
.31269 .18541 L
.31369 .18541 L
.31469 .18541 L
.31568 .18541 L
.31668 .18541 L
.31768 .18541 L
.31868 .18541 L
.31968 .18541 L
.32068 .18541 L
.32168 .18541 L
.32268 .18541 L
.32368 .18541 L
.32468 .18542 L
.32567 .18542 L
.32667 .18542 L
.32767 .18542 L
.32867 .18542 L
.32967 .18542 L
.33067 .18542 L
.33167 .18542 L
.33267 .18542 L
.33367 .18542 L
.33467 .18542 L
.33566 .18542 L
.33666 .18542 L
.33766 .18542 L
.33866 .18542 L
.33966 .18541 L
.34066 .18541 L
.34166 .18541 L
.34266 .18541 L
.34366 .18541 L
.34466 .18541 L
.34565 .18541 L
.34665 .18541 L
.34765 .18541 L
.34865 .18541 L
Mistroke
.34965 .18541 L
.35065 .18541 L
.35165 .18541 L
.35265 .18541 L
.35365 .18541 L
.35465 .18541 L
.35564 .18541 L
.35664 .18541 L
.35764 .18541 L
.35864 .18541 L
.35964 .18541 L
.36064 .18541 L
.36164 .18541 L
.36264 .18541 L
.36364 .18541 L
.36464 .18541 L
.36563 .18541 L
.36663 .18541 L
.36763 .18541 L
.36863 .18541 L
.36963 .18542 L
.37063 .18542 L
.37163 .18542 L
.37263 .18541 L
.37363 .18541 L
.37463 .18542 L
.37562 .18542 L
.37662 .18542 L
.37762 .18542 L
.37862 .18542 L
.37962 .18541 L
.38062 .18542 L
.38162 .18542 L
.38262 .18542 L
.38362 .18542 L
.38462 .18541 L
.38561 .18541 L
.38661 .18541 L
.38761 .18541 L
.38861 .18541 L
.38961 .18541 L
.39061 .18541 L
.39161 .18541 L
.39261 .18542 L
.39361 .18541 L
.39461 .18541 L
.3956 .18541 L
.3966 .18541 L
.3976 .18541 L
.3986 .18542 L
Mistroke
.3996 .18542 L
.4006 .18542 L
.4016 .18542 L
.4026 .18542 L
.4036 .18542 L
.4046 .18542 L
.40559 .18542 L
.40659 .18542 L
.40759 .18542 L
.40859 .18542 L
.40959 .18542 L
.41059 .18542 L
.41159 .18542 L
.41259 .18542 L
.41359 .18542 L
.41459 .18542 L
.41558 .18542 L
.41658 .18542 L
.41758 .18542 L
.41858 .18542 L
.41958 .18542 L
.42058 .18541 L
.42158 .18541 L
.42258 .18542 L
.42358 .18542 L
.42458 .18542 L
.42557 .18542 L
.42657 .18542 L
.42757 .18542 L
.42857 .18542 L
.42957 .18542 L
.43057 .18541 L
.43157 .18541 L
.43257 .18542 L
.43357 .18542 L
.43457 .18541 L
.43556 .18541 L
.43656 .18541 L
.43756 .18542 L
.43856 .18541 L
.43956 .18541 L
.44056 .18542 L
.44156 .18542 L
.44256 .18542 L
.44356 .18542 L
.44456 .18542 L
.44555 .18542 L
.44655 .18542 L
.44755 .18542 L
.44855 .18542 L
Mistroke
.44955 .18542 L
.45055 .18542 L
.45155 .18542 L
.45255 .18542 L
.45355 .18542 L
.45455 .18542 L
.45554 .18542 L
.45654 .18542 L
.45754 .18542 L
.45854 .18542 L
.45954 .18542 L
.46054 .18542 L
.46154 .18542 L
.46254 .18542 L
.46354 .18542 L
.46454 .18542 L
.46553 .18542 L
.46653 .18542 L
.46753 .18542 L
.46853 .18542 L
.46953 .18542 L
.47053 .18542 L
.47153 .18542 L
.47253 .18542 L
.47353 .18542 L
.47453 .18542 L
.47552 .18542 L
.47652 .18542 L
.47752 .18542 L
.47852 .18542 L
.47952 .18542 L
.48052 .18542 L
.48152 .18542 L
.48252 .18542 L
.48352 .18542 L
.48452 .18542 L
.48551 .18542 L
.48651 .18542 L
.48751 .18542 L
.48851 .18542 L
.48951 .18542 L
.49051 .18542 L
.49151 .18542 L
.49251 .18542 L
.49351 .18542 L
.49451 .18542 L
.4955 .18542 L
.4965 .18542 L
.4975 .18542 L
.4985 .18542 L
Mistroke
.4995 .18542 L
.5005 .18542 L
.5015 .18542 L
.5025 .18542 L
.5035 .18542 L
.5045 .18542 L
.50549 .18542 L
.50649 .18542 L
.50749 .18542 L
.50849 .18542 L
.50949 .18542 L
.51049 .18542 L
.51149 .18542 L
.51249 .18542 L
.51349 .18542 L
.51449 .18542 L
.51548 .18542 L
.51648 .18542 L
.51748 .18542 L
.51848 .18542 L
.51948 .18542 L
.52048 .18542 L
.52148 .18542 L
.52248 .18542 L
.52348 .18542 L
.52448 .18542 L
.52547 .18542 L
.52647 .18542 L
.52747 .18542 L
.52847 .18542 L
.52947 .18542 L
.53047 .18542 L
.53147 .18542 L
.53247 .18543 L
.53347 .18542 L
.53447 .18542 L
.53546 .18542 L
.53646 .18542 L
.53746 .18542 L
.53846 .18542 L
.53946 .18542 L
.54046 .18542 L
.54146 .18542 L
.54246 .18542 L
.54346 .18542 L
.54446 .18542 L
.54545 .18542 L
.54645 .18542 L
.54745 .18542 L
.54845 .18542 L
Mistroke
.54945 .18542 L
.55045 .18542 L
.55145 .18542 L
.55245 .18542 L
.55345 .18542 L
.55445 .18542 L
.55544 .18542 L
.55644 .18542 L
.55744 .18542 L
.55844 .18542 L
.55944 .18542 L
.56044 .18542 L
.56144 .18542 L
.56244 .18542 L
.56344 .18542 L
.56444 .18542 L
.56543 .18542 L
.56643 .18542 L
.56743 .18542 L
.56843 .18542 L
.56943 .18542 L
.57043 .18542 L
.57143 .18543 L
.57243 .18543 L
.57343 .18543 L
.57443 .18543 L
.57542 .18543 L
.57642 .18543 L
.57742 .18543 L
.57842 .18543 L
.57942 .18543 L
.58042 .18542 L
.58142 .18543 L
.58242 .18542 L
.58342 .18543 L
.58442 .18542 L
.58541 .18543 L
.58641 .18543 L
.58741 .18543 L
.58841 .18543 L
.58941 .18542 L
.59041 .18542 L
.59141 .18542 L
.59241 .18543 L
.59341 .18543 L
.59441 .18543 L
.5954 .18543 L
.5964 .18543 L
.5974 .18543 L
.5984 .18542 L
Mistroke
.5994 .18542 L
.6004 .18542 L
.6014 .18542 L
.6024 .18542 L
.6034 .18543 L
.6044 .18542 L
.60539 .18542 L
.60639 .18542 L
.60739 .18542 L
.60839 .18542 L
.60939 .18542 L
.61039 .18542 L
.61139 .18542 L
.61239 .18542 L
.61339 .18542 L
.61439 .18542 L
.61538 .18542 L
.61638 .18542 L
.61738 .18542 L
.61838 .18542 L
.61938 .18542 L
.62038 .18543 L
.62138 .18543 L
.62238 .18543 L
.62338 .18543 L
.62438 .18543 L
.62537 .18543 L
.62637 .18543 L
.62737 .18543 L
.62837 .18543 L
.62937 .18543 L
.63037 .18543 L
.63137 .18543 L
.63237 .18543 L
.63337 .18543 L
.63437 .18543 L
.63536 .18543 L
.63636 .18543 L
.63736 .18543 L
.63836 .18543 L
.63936 .18543 L
.64036 .18543 L
.64136 .18543 L
.64236 .18543 L
.64336 .18543 L
.64436 .18543 L
.64535 .18543 L
.64635 .18543 L
.64735 .18543 L
.64835 .18543 L
Mistroke
.64935 .18543 L
.65035 .18543 L
.65135 .18543 L
.65235 .18543 L
.65335 .18543 L
.65435 .18543 L
.65534 .18543 L
.65634 .18543 L
.65734 .18543 L
.65834 .18543 L
.65934 .18543 L
.66034 .18543 L
.66134 .18543 L
.66234 .18543 L
.66334 .18543 L
.66434 .18543 L
.66533 .18543 L
.66633 .18543 L
.66733 .18543 L
.66833 .18543 L
.66933 .18543 L
.67033 .18543 L
.67133 .18543 L
.67233 .18543 L
.67333 .18543 L
.67433 .18543 L
.67532 .18543 L
.67632 .18543 L
.67732 .18543 L
.67832 .18543 L
.67932 .18543 L
.68032 .18543 L
.68132 .18543 L
.68232 .18543 L
.68332 .18543 L
.68432 .18543 L
.68531 .18543 L
.68631 .18543 L
.68731 .18543 L
.68831 .18543 L
.68931 .18543 L
.69031 .18543 L
.69131 .18543 L
.69231 .18543 L
.69331 .18543 L
.69431 .18543 L
.6953 .18543 L
.6963 .18543 L
.6973 .18543 L
.6983 .18543 L
Mistroke
.6993 .18543 L
.7003 .18543 L
.7013 .18543 L
.7023 .18543 L
.7033 .18543 L
.7043 .18543 L
.70529 .18543 L
.70629 .18543 L
.70729 .18543 L
.70829 .18543 L
.70929 .18543 L
.71029 .18543 L
.71129 .18543 L
.71229 .18543 L
.71329 .18543 L
.71429 .18543 L
.71528 .18543 L
.71628 .18543 L
.71728 .18543 L
.71828 .18543 L
.71928 .18543 L
.72028 .18543 L
.72128 .18543 L
.72228 .18543 L
.72328 .18543 L
.72428 .18543 L
.72527 .18543 L
.72627 .18543 L
.72727 .18543 L
.72827 .18543 L
.72927 .18543 L
.73027 .18542 L
.73127 .18542 L
.73227 .18542 L
.73327 .18542 L
.73427 .18542 L
.73526 .18542 L
.73626 .18542 L
.73726 .18542 L
.73826 .18542 L
.73926 .18542 L
.74026 .18542 L
.74126 .18542 L
.74226 .18542 L
.74326 .18542 L
.74426 .18542 L
.74525 .18542 L
.74625 .18542 L
.74725 .18542 L
.74825 .18542 L
Mistroke
.74925 .18542 L
.75025 .18542 L
.75125 .18542 L
.75225 .18542 L
.75325 .18542 L
.75425 .18542 L
.75524 .18542 L
.75624 .18542 L
.75724 .18542 L
.75824 .18542 L
.75924 .18542 L
.76024 .18542 L
.76124 .18542 L
.76224 .18542 L
.76324 .18542 L
.76424 .18542 L
.76523 .18542 L
.76623 .18542 L
.76723 .18542 L
.76823 .18542 L
.76923 .18542 L
.77023 .18542 L
.77123 .18542 L
.77223 .18542 L
.77323 .18542 L
.77423 .18542 L
.77522 .18542 L
.77622 .18541 L
.77722 .18541 L
.77822 .18541 L
.77922 .18541 L
.78022 .18541 L
.78122 .18541 L
.78222 .18541 L
.78322 .18541 L
.78422 .18541 L
.78521 .18541 L
.78621 .18541 L
.78721 .18541 L
.78821 .18541 L
.78921 .18541 L
.79021 .18541 L
.79121 .18541 L
.79221 .18541 L
.79321 .18541 L
.79421 .18541 L
.7952 .18542 L
.7962 .18542 L
.7972 .18542 L
.7982 .18542 L
Mistroke
.7992 .18542 L
.8002 .18542 L
.8012 .18541 L
.8022 .18541 L
.8032 .18541 L
.8042 .18541 L
.80519 .18541 L
.80619 .18541 L
.80719 .18541 L
.80819 .18541 L
.80919 .18541 L
.81019 .18541 L
.81119 .18541 L
.81219 .18542 L
.81319 .18542 L
.81419 .18541 L
.81518 .18542 L
.81618 .18542 L
.81718 .18542 L
.81818 .18542 L
.81918 .18542 L
.82018 .18542 L
.82118 .18542 L
.82218 .18542 L
.82318 .18541 L
.82418 .18541 L
.82517 .18541 L
.82617 .18541 L
.82717 .18541 L
.82817 .18541 L
.82917 .18541 L
.83017 .18541 L
.83117 .18541 L
.83217 .18541 L
.83317 .18541 L
.83417 .18541 L
.83516 .18541 L
.83616 .18541 L
.83716 .18541 L
.83816 .18541 L
.83916 .18541 L
.84016 .18541 L
.84116 .18541 L
.84216 .18541 L
.84316 .18541 L
.84416 .18541 L
.84515 .18541 L
.84615 .18541 L
.84715 .18541 L
.84815 .18541 L
Mistroke
.84915 .18541 L
.85015 .18541 L
.85115 .18541 L
.85215 .18541 L
.85315 .18541 L
.85415 .18541 L
.85514 .18541 L
.85614 .18541 L
.85714 .18541 L
.85814 .18541 L
.85914 .18541 L
.86014 .18541 L
.86114 .18541 L
.86214 .18541 L
.86314 .18541 L
.86414 .18541 L
.86513 .18541 L
.86613 .18541 L
.86713 .18541 L
.86813 .18541 L
.86913 .18541 L
.87013 .18541 L
.87113 .18541 L
.87213 .18541 L
.87313 .18541 L
.87413 .18541 L
.87512 .18541 L
.87612 .18541 L
.87712 .18541 L
.87812 .18541 L
.87912 .18542 L
.88012 .18542 L
.88112 .18542 L
.88212 .18542 L
.88312 .18542 L
.88412 .18542 L
.88511 .18542 L
.88611 .18542 L
.88711 .18542 L
.88811 .18542 L
.88911 .18542 L
.89011 .18541 L
.89111 .18541 L
.89211 .18541 L
.89311 .18541 L
.89411 .18541 L
.8951 .18541 L
.8961 .18541 L
.8971 .18541 L
.8981 .18541 L
Mistroke
.8991 .18541 L
.9001 .18541 L
.9011 .18542 L
.9021 .18542 L
.9031 .18542 L
.9041 .18542 L
.90509 .18542 L
.90609 .18542 L
.90709 .18542 L
.90809 .18542 L
.90909 .18542 L
.91009 .18542 L
.91109 .18542 L
.91209 .18542 L
.91309 .18542 L
.91409 .18542 L
.91508 .18542 L
.91608 .18542 L
.91708 .18542 L
.91808 .18542 L
.91908 .18542 L
.92008 .18542 L
.92108 .18542 L
.92208 .18542 L
.92308 .18542 L
.92408 .18542 L
.92507 .18542 L
.92607 .18542 L
.92707 .18542 L
.92807 .18542 L
.92907 .18542 L
.93007 .18542 L
.93107 .18542 L
.93207 .18542 L
.93307 .18542 L
.93407 .18542 L
.93506 .18542 L
.93606 .18542 L
.93706 .18542 L
.93806 .18542 L
.93906 .18542 L
.94006 .18542 L
.94106 .18542 L
.94206 .18542 L
.94306 .18542 L
.94406 .18542 L
.94505 .18542 L
.94605 .18542 L
.94705 .18542 L
.94805 .18542 L
Mistroke
.94905 .18542 L
.95005 .18542 L
.95105 .18542 L
.95205 .18542 L
.95305 .18542 L
.95405 .18542 L
.95504 .18542 L
.95604 .18541 L
.95704 .18542 L
.95804 .18542 L
.95904 .18542 L
.96004 .18542 L
.96104 .18542 L
.96204 .18542 L
.96304 .18542 L
.96404 .18542 L
.96503 .18542 L
.96603 .18542 L
.96703 .18541 L
.96803 .18541 L
.96903 .18541 L
.97003 .18541 L
.97103 .18541 L
.97203 .18541 L
.97303 .18541 L
.97403 .18541 L
.97502 .18541 L
.97602 .18541 L
.97702 .18541 L
.97802 .18541 L
.97902 .18541 L
.98002 .18541 L
.98102 .18541 L
.98202 .18541 L
.98302 .18541 L
.98402 .18541 L
.98501 .18541 L
.98601 .18541 L
.98701 .18541 L
.98801 .18541 L
.98901 .18541 L
.99001 .18541 L
.99101 .18541 L
.99201 .18541 L
.99301 .18541 L
.99401 .18541 L
.995 .18541 L
.996 .18541 L
.997 .18541 L
.998 .18541 L
Mistroke
.999 .18541 L
Mfstroke
0 .98 .604 r
gsave
.999 .15755 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .12608 m
.001 .12608 L
.002 .12608 L
.003 .12608 L
.004 .12608 L
.005 .12608 L
.00599 .12608 L
.00699 .12608 L
.00799 .12608 L
.00899 .12608 L
.00999 .12608 L
.01099 .12608 L
.01199 .12608 L
.01299 .12608 L
.01399 .12608 L
.01499 .12608 L
.01598 .12608 L
.01698 .12608 L
.01798 .12608 L
.01898 .12608 L
.01998 .12608 L
.02098 .12608 L
.02198 .12608 L
.02298 .12608 L
.02398 .12608 L
.02498 .12608 L
.02597 .12608 L
.02697 .12608 L
.02797 .12608 L
.02897 .12608 L
.02997 .12608 L
.03097 .12608 L
.03197 .12608 L
.03297 .12608 L
.03397 .12608 L
.03497 .12608 L
.03596 .12608 L
.03696 .12608 L
.03796 .12608 L
.03896 .12608 L
.03996 .12608 L
.04096 .12608 L
.04196 .12608 L
.04296 .12608 L
.04396 .12608 L
.04496 .12608 L
.04595 .12608 L
.04695 .12608 L
.04795 .12608 L
.04895 .12608 L
Mistroke
.04995 .12432 L
.05095 .12432 L
.05195 .12432 L
.05295 .12432 L
.05395 .12432 L
.05495 .12432 L
.05594 .12432 L
.05694 .12432 L
.05794 .12432 L
.05894 .12432 L
.05994 .12432 L
.06094 .12432 L
.06194 .12432 L
.06294 .12432 L
.06394 .12432 L
.06494 .12432 L
.06593 .12432 L
.06693 .12432 L
.06793 .12432 L
.06893 .12432 L
.06993 .12432 L
.07093 .12432 L
.07193 .12432 L
.07293 .12432 L
.07393 .12432 L
.07493 .12432 L
.07592 .12432 L
.07692 .12432 L
.07792 .12432 L
.07892 .12432 L
.07992 .12432 L
.08092 .12432 L
.08192 .12432 L
.08292 .12432 L
.08392 .12432 L
.08492 .12432 L
.08591 .12432 L
.08691 .12432 L
.08791 .12432 L
.08891 .12432 L
.08991 .12432 L
.09091 .12432 L
.09191 .12432 L
.09291 .12432 L
.09391 .12432 L
.09491 .12432 L
.0959 .12432 L
.0969 .12432 L
.0979 .12432 L
.0989 .12432 L
Mistroke
.0999 .08782 L
.1009 .08782 L
.1019 .08782 L
.1029 .08782 L
.1039 .08782 L
.1049 .08782 L
.10589 .08782 L
.10689 .08782 L
.10789 .08782 L
.10889 .08782 L
.10989 .08782 L
.11089 .08782 L
.11189 .08782 L
.11289 .08782 L
.11389 .08782 L
.11489 .08782 L
.11588 .08782 L
.11688 .08782 L
.11788 .08782 L
.11888 .08782 L
.11988 .08782 L
.12088 .08782 L
.12188 .08782 L
.12288 .08782 L
.12388 .08782 L
.12488 .08782 L
.12587 .08782 L
.12687 .08782 L
.12787 .08782 L
.12887 .08782 L
.12987 .08782 L
.13087 .08782 L
.13187 .08782 L
.13287 .08782 L
.13387 .08782 L
.13487 .08782 L
.13586 .08782 L
.13686 .08782 L
.13786 .08782 L
.13886 .08782 L
.13986 .08782 L
.14086 .08782 L
.14186 .08782 L
.14286 .08782 L
.14386 .08782 L
.14486 .08782 L
.14585 .08782 L
.14685 .08782 L
.14785 .08782 L
.14885 .08782 L
Mistroke
.14985 .06128 L
.15085 .06128 L
.15185 .06128 L
.15285 .06128 L
.15385 .06128 L
.15485 .06128 L
.15584 .06128 L
.15684 .06128 L
.15784 .06128 L
.15884 .06128 L
.15984 .06128 L
.16084 .06128 L
.16184 .06128 L
.16284 .06128 L
.16384 .06128 L
.16484 .06128 L
.16583 .06128 L
.16683 .06128 L
.16783 .06128 L
.16883 .06128 L
.16983 .06128 L
.17083 .06128 L
.17183 .06128 L
.17283 .06128 L
.17383 .06128 L
.17483 .06128 L
.17582 .06128 L
.17682 .06128 L
.17782 .06128 L
.17882 .06128 L
.17982 .06128 L
.18082 .06128 L
.18182 .06128 L
.18282 .06128 L
.18382 .06128 L
.18482 .06128 L
.18581 .06128 L
.18681 .06128 L
.18781 .06128 L
.18881 .06128 L
.18981 .06128 L
.19081 .06128 L
.19181 .06128 L
.19281 .06128 L
.19381 .06128 L
.19481 .06128 L
.1958 .06128 L
.1968 .06128 L
.1978 .06128 L
.1988 .06128 L
Mistroke
.1998 .08453 L
.2008 .08453 L
.2018 .08453 L
.2028 .08453 L
.2038 .08453 L
.2048 .08453 L
.20579 .08453 L
.20679 .08453 L
.20779 .08453 L
.20879 .08453 L
.20979 .08453 L
.21079 .08453 L
.21179 .08453 L
.21279 .08453 L
.21379 .08453 L
.21479 .08453 L
.21578 .08453 L
.21678 .08453 L
.21778 .08453 L
.21878 .08453 L
.21978 .08453 L
.22078 .08453 L
.22178 .08453 L
.22278 .08453 L
.22378 .08453 L
.22478 .08453 L
.22577 .08453 L
.22677 .08453 L
.22777 .08453 L
.22877 .08453 L
.22977 .08453 L
.23077 .08453 L
.23177 .08453 L
.23277 .08453 L
.23377 .08453 L
.23477 .08453 L
.23576 .08453 L
.23676 .08453 L
.23776 .08453 L
.23876 .08453 L
.23976 .08453 L
.24076 .08453 L
.24176 .08453 L
.24276 .08453 L
.24376 .08453 L
.24476 .08453 L
.24575 .08453 L
.24675 .08453 L
.24775 .08453 L
.24875 .08453 L
Mistroke
.24975 .12924 L
.25075 .12924 L
.25175 .12924 L
.25275 .12924 L
.25375 .12924 L
.25475 .12924 L
.25574 .12924 L
.25674 .12924 L
.25774 .12924 L
.25874 .12924 L
.25974 .12924 L
.26074 .12924 L
.26174 .12924 L
.26274 .12924 L
.26374 .12924 L
.26474 .12924 L
.26573 .12924 L
.26673 .12924 L
.26773 .12924 L
.26873 .12924 L
.26973 .12924 L
.27073 .12924 L
.27173 .12924 L
.27273 .12924 L
.27373 .12924 L
.27473 .12924 L
.27572 .12924 L
.27672 .12924 L
.27772 .12924 L
.27872 .12924 L
.27972 .12924 L
.28072 .12924 L
.28172 .12924 L
.28272 .12924 L
.28372 .12924 L
.28472 .12924 L
.28571 .12924 L
.28671 .12924 L
.28771 .12924 L
.28871 .12924 L
.28971 .12924 L
.29071 .12924 L
.29171 .12924 L
.29271 .12924 L
.29371 .12924 L
.29471 .12924 L
.2957 .12924 L
.2967 .12924 L
.2977 .12924 L
.2987 .12924 L
Mistroke
.2997 .1351 L
.3007 .1351 L
.3017 .1351 L
.3027 .1351 L
.3037 .1351 L
.3047 .1351 L
.30569 .1351 L
.30669 .1351 L
.30769 .1351 L
.30869 .1351 L
.30969 .1351 L
.31069 .1351 L
.31169 .1351 L
.31269 .1351 L
.31369 .1351 L
.31469 .1351 L
.31568 .1351 L
.31668 .1351 L
.31768 .1351 L
.31868 .1351 L
.31968 .1351 L
.32068 .1351 L
.32168 .1351 L
.32268 .1351 L
.32368 .1351 L
.32468 .1351 L
.32567 .1351 L
.32667 .1351 L
.32767 .1351 L
.32867 .1351 L
.32967 .1351 L
.33067 .1351 L
.33167 .1351 L
.33267 .1351 L
.33367 .1351 L
.33467 .1351 L
.33566 .1351 L
.33666 .1351 L
.33766 .1351 L
.33866 .1351 L
.33966 .1351 L
.34066 .1351 L
.34166 .1351 L
.34266 .1351 L
.34366 .1351 L
.34466 .1351 L
.34565 .1351 L
.34665 .1351 L
.34765 .1351 L
.34865 .1351 L
Mistroke
.34965 .12395 L
.35065 .12395 L
.35165 .12395 L
.35265 .12395 L
.35365 .12395 L
.35465 .12395 L
.35564 .12395 L
.35664 .12395 L
.35764 .12395 L
.35864 .12395 L
.35964 .12395 L
.36064 .12395 L
.36164 .12395 L
.36264 .12395 L
.36364 .12395 L
.36464 .12395 L
.36563 .12395 L
.36663 .12395 L
.36763 .12395 L
.36863 .12395 L
.36963 .12395 L
.37063 .12395 L
.37163 .12395 L
.37263 .12395 L
.37363 .12395 L
.37463 .12395 L
.37562 .12395 L
.37662 .12395 L
.37762 .12395 L
.37862 .12395 L
.37962 .12395 L
.38062 .12395 L
.38162 .12395 L
.38262 .12395 L
.38362 .12395 L
.38462 .12395 L
.38561 .12395 L
.38661 .12395 L
.38761 .12395 L
.38861 .12395 L
.38961 .12395 L
.39061 .12395 L
.39161 .12395 L
.39261 .12395 L
.39361 .12395 L
.39461 .12395 L
.3956 .12395 L
.3966 .12395 L
.3976 .12395 L
.3986 .12395 L
Mistroke
.3996 .12171 L
.4006 .12171 L
.4016 .12171 L
.4026 .12171 L
.4036 .12171 L
.4046 .12171 L
.40559 .12171 L
.40659 .12171 L
.40759 .12171 L
.40859 .12171 L
.40959 .12171 L
.41059 .12171 L
.41159 .12171 L
.41259 .12171 L
.41359 .12171 L
.41459 .12171 L
.41558 .12171 L
.41658 .12171 L
.41758 .12171 L
.41858 .12171 L
.41958 .12171 L
.42058 .12171 L
.42158 .12171 L
.42258 .12171 L
.42358 .12171 L
.42458 .12171 L
.42557 .12171 L
.42657 .12171 L
.42757 .12171 L
.42857 .12171 L
.42957 .12171 L
.43057 .12171 L
.43157 .12171 L
.43257 .12171 L
.43357 .12171 L
.43457 .12171 L
.43556 .12171 L
.43656 .12171 L
.43756 .12171 L
.43856 .12171 L
.43956 .12171 L
.44056 .12171 L
.44156 .12171 L
.44256 .12171 L
.44356 .12171 L
.44456 .12171 L
.44555 .12171 L
.44655 .12171 L
.44755 .12171 L
.44855 .12171 L
Mistroke
.44955 .13042 L
.45055 .13042 L
.45155 .13042 L
.45255 .13042 L
.45355 .13042 L
.45455 .13042 L
.45554 .13042 L
.45654 .13042 L
.45754 .13042 L
.45854 .13042 L
.45954 .13042 L
.46054 .13042 L
.46154 .13042 L
.46254 .13042 L
.46354 .13042 L
.46454 .13042 L
.46553 .13042 L
.46653 .13042 L
.46753 .13042 L
.46853 .13042 L
.46953 .13042 L
.47053 .13042 L
.47153 .13042 L
.47253 .13042 L
.47353 .13042 L
.47453 .13042 L
.47552 .13042 L
.47652 .13042 L
.47752 .13042 L
.47852 .13042 L
.47952 .13042 L
.48052 .13042 L
.48152 .13042 L
.48252 .13042 L
.48352 .13042 L
.48452 .13042 L
.48551 .13042 L
.48651 .13042 L
.48751 .13042 L
.48851 .13042 L
.48951 .13042 L
.49051 .13042 L
.49151 .13042 L
.49251 .13042 L
.49351 .13042 L
.49451 .13042 L
.4955 .13042 L
.4965 .13042 L
.4975 .13042 L
.4985 .13042 L
Mistroke
.4995 .14153 L
.5005 .14153 L
.5015 .14153 L
.5025 .14153 L
.5035 .14153 L
.5045 .14153 L
.50549 .14153 L
.50649 .14153 L
.50749 .14153 L
.50849 .14153 L
.50949 .14153 L
.51049 .14153 L
.51149 .14153 L
.51249 .14153 L
.51349 .14153 L
.51449 .14153 L
.51548 .14153 L
.51648 .14153 L
.51748 .14153 L
.51848 .14153 L
.51948 .14153 L
.52048 .14153 L
.52148 .14153 L
.52248 .14153 L
.52348 .14153 L
.52448 .14153 L
.52547 .14153 L
.52647 .14153 L
.52747 .14153 L
.52847 .14153 L
.52947 .14153 L
.53047 .14153 L
.53147 .14153 L
.53247 .14153 L
.53347 .14153 L
.53447 .14153 L
.53546 .14153 L
.53646 .14153 L
.53746 .14153 L
.53846 .14153 L
.53946 .14153 L
.54046 .14153 L
.54146 .14153 L
.54246 .14153 L
.54346 .14153 L
.54446 .14153 L
.54545 .14153 L
.54645 .14153 L
.54745 .14153 L
.54845 .14153 L
Mistroke
.54945 .14806 L
.55045 .14806 L
.55145 .14806 L
.55245 .14806 L
.55345 .14806 L
.55445 .14806 L
.55544 .14806 L
.55644 .14806 L
.55744 .14806 L
.55844 .14806 L
.55944 .14806 L
.56044 .14806 L
.56144 .14806 L
.56244 .14806 L
.56344 .14806 L
.56444 .14806 L
.56543 .14806 L
.56643 .14806 L
.56743 .14806 L
.56843 .14806 L
.56943 .14806 L
.57043 .14806 L
.57143 .14806 L
.57243 .14806 L
.57343 .14806 L
.57443 .14806 L
.57542 .14806 L
.57642 .14806 L
.57742 .14806 L
.57842 .14806 L
.57942 .14806 L
.58042 .14806 L
.58142 .14806 L
.58242 .14806 L
.58342 .14806 L
.58442 .14806 L
.58541 .14806 L
.58641 .14806 L
.58741 .14806 L
.58841 .14806 L
.58941 .14806 L
.59041 .14806 L
.59141 .14806 L
.59241 .14806 L
.59341 .14806 L
.59441 .14806 L
.5954 .14806 L
.5964 .14806 L
.5974 .14806 L
.5984 .14806 L
Mistroke
.5994 .15162 L
.6004 .15162 L
.6014 .15162 L
.6024 .15162 L
.6034 .15162 L
.6044 .15162 L
.60539 .15162 L
.60639 .15162 L
.60739 .15162 L
.60839 .15162 L
.60939 .15162 L
.61039 .15162 L
.61139 .15162 L
.61239 .15162 L
.61339 .15162 L
.61439 .15162 L
.61538 .15162 L
.61638 .15162 L
.61738 .15162 L
.61838 .15162 L
.61938 .15162 L
.62038 .15162 L
.62138 .15162 L
.62238 .15162 L
.62338 .15162 L
.62438 .15162 L
.62537 .15162 L
.62637 .15162 L
.62737 .15162 L
.62837 .15162 L
.62937 .15162 L
.63037 .15162 L
.63137 .15162 L
.63237 .15162 L
.63337 .15162 L
.63437 .15162 L
.63536 .15162 L
.63636 .15162 L
.63736 .15162 L
.63836 .15162 L
.63936 .15162 L
.64036 .15162 L
.64136 .15162 L
.64236 .15162 L
.64336 .15162 L
.64436 .15162 L
.64535 .15162 L
.64635 .15162 L
.64735 .15162 L
.64835 .15162 L
Mistroke
.64935 .14774 L
.65035 .14774 L
.65135 .14774 L
.65235 .14774 L
.65335 .14774 L
.65435 .14774 L
.65534 .14774 L
.65634 .14774 L
.65734 .14774 L
.65834 .14774 L
.65934 .14774 L
.66034 .14774 L
.66134 .14774 L
.66234 .14774 L
.66334 .14774 L
.66434 .14774 L
.66533 .14774 L
.66633 .14774 L
.66733 .14774 L
.66833 .14774 L
.66933 .14774 L
.67033 .14774 L
.67133 .14774 L
.67233 .14774 L
.67333 .14774 L
.67433 .14774 L
.67532 .14774 L
.67632 .14774 L
.67732 .14774 L
.67832 .14774 L
.67932 .14774 L
.68032 .14774 L
.68132 .14774 L
.68232 .14774 L
.68332 .14774 L
.68432 .14774 L
.68531 .14774 L
.68631 .14774 L
.68731 .14774 L
.68831 .14774 L
.68931 .14774 L
.69031 .14774 L
.69131 .14774 L
.69231 .14774 L
.69331 .14774 L
.69431 .14774 L
.6953 .14774 L
.6963 .14774 L
.6973 .14774 L
.6983 .14774 L
Mistroke
.6993 .15319 L
.7003 .15319 L
.7013 .15319 L
.7023 .15319 L
.7033 .15319 L
.7043 .15319 L
.70529 .15319 L
.70629 .15319 L
.70729 .15319 L
.70829 .15319 L
.70929 .15319 L
.71029 .15319 L
.71129 .15319 L
.71229 .15319 L
.71329 .15319 L
.71429 .15319 L
.71528 .15319 L
.71628 .15319 L
.71728 .15319 L
.71828 .15319 L
.71928 .15319 L
.72028 .15319 L
.72128 .15319 L
.72228 .15319 L
.72328 .15319 L
.72428 .15319 L
.72527 .15319 L
.72627 .15319 L
.72727 .15319 L
.72827 .15319 L
.72927 .15319 L
.73027 .15319 L
.73127 .15319 L
.73227 .15319 L
.73327 .15319 L
.73427 .15319 L
.73526 .15319 L
.73626 .15319 L
.73726 .15319 L
.73826 .15319 L
.73926 .15319 L
.74026 .15319 L
.74126 .15319 L
.74226 .15319 L
.74326 .15319 L
.74426 .15319 L
.74525 .15319 L
.74625 .15319 L
.74725 .15319 L
.74825 .15319 L
Mistroke
.74925 .15879 L
.75025 .15879 L
.75125 .15879 L
.75225 .15879 L
.75325 .15879 L
.75425 .15879 L
.75524 .15879 L
.75624 .15879 L
.75724 .15879 L
.75824 .15879 L
.75924 .15879 L
.76024 .15879 L
.76124 .15879 L
.76224 .15879 L
.76324 .15879 L
.76424 .15879 L
.76523 .15879 L
.76623 .15879 L
.76723 .15879 L
.76823 .15879 L
.76923 .15879 L
.77023 .15879 L
.77123 .15879 L
.77223 .15879 L
.77323 .15879 L
.77423 .15879 L
.77522 .15879 L
.77622 .15879 L
.77722 .15879 L
.77822 .15879 L
.77922 .15879 L
.78022 .15879 L
.78122 .15879 L
.78222 .15879 L
.78322 .15879 L
.78422 .15879 L
.78521 .15879 L
.78621 .15879 L
.78721 .15879 L
.78821 .15879 L
.78921 .15879 L
.79021 .15879 L
.79121 .15879 L
.79221 .15879 L
.79321 .15879 L
.79421 .15879 L
.7952 .15879 L
.7962 .15879 L
.7972 .15879 L
.7982 .15879 L
Mistroke
.7992 .16914 L
.8002 .16914 L
.8012 .16914 L
.8022 .16914 L
.8032 .16914 L
.8042 .16914 L
.80519 .16914 L
.80619 .16914 L
.80719 .16914 L
.80819 .16914 L
.80919 .16914 L
.81019 .16914 L
.81119 .16914 L
.81219 .16914 L
.81319 .16914 L
.81419 .16914 L
.81518 .16914 L
.81618 .16914 L
.81718 .16914 L
.81818 .16914 L
.81918 .16914 L
.82018 .16914 L
.82118 .16914 L
.82218 .16914 L
.82318 .16914 L
.82418 .16914 L
.82517 .16914 L
.82617 .16914 L
.82717 .16914 L
.82817 .16914 L
.82917 .16914 L
.83017 .16914 L
.83117 .16914 L
.83217 .16914 L
.83317 .16914 L
.83417 .16914 L
.83516 .16914 L
.83616 .16914 L
.83716 .16914 L
.83816 .16914 L
.83916 .16914 L
.84016 .16914 L
.84116 .16914 L
.84216 .16914 L
.84316 .16914 L
.84416 .16914 L
.84515 .16914 L
.84615 .16914 L
.84715 .16914 L
.84815 .16914 L
Mistroke
.84915 .1709 L
.85015 .1709 L
.85115 .1709 L
.85215 .1709 L
.85315 .1709 L
.85415 .1709 L
.85514 .1709 L
.85614 .1709 L
.85714 .1709 L
.85814 .1709 L
.85914 .1709 L
.86014 .1709 L
.86114 .1709 L
.86214 .1709 L
.86314 .1709 L
.86414 .1709 L
.86513 .1709 L
.86613 .1709 L
.86713 .1709 L
.86813 .1709 L
.86913 .1709 L
.87013 .1709 L
.87113 .1709 L
.87213 .1709 L
.87313 .1709 L
.87413 .1709 L
.87512 .1709 L
.87612 .1709 L
.87712 .1709 L
.87812 .1709 L
.87912 .1709 L
.88012 .1709 L
.88112 .1709 L
.88212 .1709 L
.88312 .1709 L
.88412 .1709 L
.88511 .1709 L
.88611 .1709 L
.88711 .1709 L
.88811 .1709 L
.88911 .1709 L
.89011 .1709 L
.89111 .1709 L
.89211 .1709 L
.89311 .1709 L
.89411 .1709 L
.8951 .1709 L
.8961 .1709 L
.8971 .1709 L
.8981 .1709 L
Mistroke
.8991 .16155 L
.9001 .16155 L
.9011 .16155 L
.9021 .16155 L
.9031 .16155 L
.9041 .16155 L
.90509 .16155 L
.90609 .16155 L
.90709 .16155 L
.90809 .16155 L
.90909 .16155 L
.91009 .16155 L
.91109 .16155 L
.91209 .16155 L
.91309 .16155 L
.91409 .16155 L
.91508 .16155 L
.91608 .16155 L
.91708 .16155 L
.91808 .16155 L
.91908 .16155 L
.92008 .16155 L
.92108 .16155 L
.92208 .16155 L
.92308 .16155 L
.92408 .16155 L
.92507 .16155 L
.92607 .16155 L
.92707 .16155 L
.92807 .16155 L
.92907 .16155 L
.93007 .16155 L
.93107 .16155 L
.93207 .16155 L
.93307 .16155 L
.93407 .16155 L
.93506 .16155 L
.93606 .16155 L
.93706 .16155 L
.93806 .16155 L
.93906 .16155 L
.94006 .16155 L
.94106 .16155 L
.94206 .16155 L
.94306 .16155 L
.94406 .16155 L
.94505 .16155 L
.94605 .16155 L
.94705 .16155 L
.94805 .16155 L
Mistroke
.94905 .16099 L
.95005 .16099 L
.95105 .16099 L
.95205 .16099 L
.95305 .16099 L
.95405 .16099 L
.95504 .16099 L
.95604 .16099 L
.95704 .16099 L
.95804 .16099 L
.95904 .16099 L
.96004 .16099 L
.96104 .16099 L
.96204 .16099 L
.96304 .16099 L
.96404 .16099 L
.96503 .16099 L
.96603 .16099 L
.96703 .16099 L
.96803 .16099 L
.96903 .16099 L
.97003 .16099 L
.97103 .16099 L
.97203 .16099 L
.97303 .16099 L
.97403 .16099 L
.97502 .16099 L
.97602 .16099 L
.97702 .16099 L
.97802 .16099 L
.97902 .16099 L
.98002 .16099 L
.98102 .16099 L
.98202 .16099 L
.98302 .16099 L
.98402 .16099 L
.98501 .16099 L
.98601 .16099 L
.98701 .16099 L
.98801 .16099 L
.98901 .16099 L
.99001 .16099 L
.99101 .16099 L
.99201 .16099 L
.99301 .16099 L
.99401 .16099 L
.995 .16099 L
.996 .16099 L
.997 .16099 L
.998 .16099 L
Mistroke
.999 .15755 L
Mfstroke
gsave
.999 .25705 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36835 m
.001 .36835 L
.002 .36835 L
.003 .36835 L
.004 .36835 L
.005 .36835 L
.00599 .36835 L
.00699 .36835 L
.00799 .36835 L
.00899 .36835 L
.00999 .36835 L
.01099 .36835 L
.01199 .36835 L
.01299 .36835 L
.01399 .36835 L
.01499 .36835 L
.01598 .36835 L
.01698 .36835 L
.01798 .36835 L
.01898 .36835 L
.01998 .36835 L
.02098 .36835 L
.02198 .36835 L
.02298 .36835 L
.02398 .36835 L
.02498 .36835 L
.02597 .36835 L
.02697 .36835 L
.02797 .36835 L
.02897 .36835 L
.02997 .36835 L
.03097 .36835 L
.03197 .36835 L
.03297 .36835 L
.03397 .36835 L
.03497 .36835 L
.03596 .36835 L
.03696 .36835 L
.03796 .36835 L
.03896 .36835 L
.03996 .36835 L
.04096 .36835 L
.04196 .36835 L
.04296 .36835 L
.04396 .36835 L
.04496 .36835 L
.04595 .36835 L
.04695 .36835 L
.04795 .36835 L
.04895 .36835 L
Mistroke
.04995 .36614 L
.05095 .36614 L
.05195 .36614 L
.05295 .36614 L
.05395 .36614 L
.05495 .36614 L
.05594 .36614 L
.05694 .36614 L
.05794 .36614 L
.05894 .36614 L
.05994 .36614 L
.06094 .36614 L
.06194 .36614 L
.06294 .36614 L
.06394 .36614 L
.06494 .36614 L
.06593 .36614 L
.06693 .36614 L
.06793 .36614 L
.06893 .36614 L
.06993 .36614 L
.07093 .36614 L
.07193 .36614 L
.07293 .36614 L
.07393 .36614 L
.07493 .36614 L
.07592 .36614 L
.07692 .36614 L
.07792 .36614 L
.07892 .36614 L
.07992 .36614 L
.08092 .36614 L
.08192 .36614 L
.08292 .36614 L
.08392 .36614 L
.08492 .36614 L
.08591 .36614 L
.08691 .36614 L
.08791 .36614 L
.08891 .36614 L
.08991 .36614 L
.09091 .36614 L
.09191 .36614 L
.09291 .36614 L
.09391 .36614 L
.09491 .36614 L
.0959 .36614 L
.0969 .36614 L
.0979 .36614 L
.0989 .36614 L
Mistroke
.0999 .3104 L
.1009 .3104 L
.1019 .3104 L
.1029 .3104 L
.1039 .3104 L
.1049 .3104 L
.10589 .3104 L
.10689 .3104 L
.10789 .3104 L
.10889 .3104 L
.10989 .3104 L
.11089 .3104 L
.11189 .3104 L
.11289 .3104 L
.11389 .3104 L
.11489 .3104 L
.11588 .3104 L
.11688 .3104 L
.11788 .3104 L
.11888 .3104 L
.11988 .3104 L
.12088 .3104 L
.12188 .3104 L
.12288 .3104 L
.12388 .3104 L
.12488 .3104 L
.12587 .3104 L
.12687 .3104 L
.12787 .3104 L
.12887 .3104 L
.12987 .3104 L
.13087 .3104 L
.13187 .3104 L
.13287 .3104 L
.13387 .3104 L
.13487 .3104 L
.13586 .3104 L
.13686 .3104 L
.13786 .3104 L
.13886 .3104 L
.13986 .3104 L
.14086 .3104 L
.14186 .3104 L
.14286 .3104 L
.14386 .3104 L
.14486 .3104 L
.14585 .3104 L
.14685 .3104 L
.14785 .3104 L
.14885 .3104 L
Mistroke
.14985 .25233 L
.15085 .25233 L
.15185 .25233 L
.15285 .25233 L
.15385 .25233 L
.15485 .25233 L
.15584 .25233 L
.15684 .25233 L
.15784 .25233 L
.15884 .25233 L
.15984 .25233 L
.16084 .25233 L
.16184 .25233 L
.16284 .25233 L
.16384 .25233 L
.16484 .25233 L
.16583 .25233 L
.16683 .25233 L
.16783 .25233 L
.16883 .25233 L
.16983 .25233 L
.17083 .25233 L
.17183 .25233 L
.17283 .25233 L
.17383 .25233 L
.17483 .25233 L
.17582 .25233 L
.17682 .25233 L
.17782 .25233 L
.17882 .25233 L
.17982 .25233 L
.18082 .25233 L
.18182 .25233 L
.18282 .25233 L
.18382 .25233 L
.18482 .25233 L
.18581 .25233 L
.18681 .25233 L
.18781 .25233 L
.18881 .25233 L
.18981 .25233 L
.19081 .25233 L
.19181 .25233 L
.19281 .25233 L
.19381 .25233 L
.19481 .25233 L
.1958 .25233 L
.1968 .25233 L
.1978 .25233 L
.1988 .25233 L
Mistroke
.1998 .26788 L
.2008 .26788 L
.2018 .26788 L
.2028 .26788 L
.2038 .26788 L
.2048 .26788 L
.20579 .26788 L
.20679 .26788 L
.20779 .26788 L
.20879 .26788 L
.20979 .26788 L
.21079 .26788 L
.21179 .26788 L
.21279 .26788 L
.21379 .26788 L
.21479 .26788 L
.21578 .26788 L
.21678 .26788 L
.21778 .26788 L
.21878 .26788 L
.21978 .26788 L
.22078 .26788 L
.22178 .26788 L
.22278 .26788 L
.22378 .26788 L
.22478 .26788 L
.22577 .26788 L
.22677 .26788 L
.22777 .26788 L
.22877 .26788 L
.22977 .26788 L
.23077 .26788 L
.23177 .26788 L
.23277 .26788 L
.23377 .26788 L
.23477 .26788 L
.23576 .26788 L
.23676 .26788 L
.23776 .26788 L
.23876 .26788 L
.23976 .26788 L
.24076 .26788 L
.24176 .26788 L
.24276 .26788 L
.24376 .26788 L
.24476 .26788 L
.24575 .26788 L
.24675 .26788 L
.24775 .26788 L
.24875 .26788 L
Mistroke
.24975 .29996 L
.25075 .29996 L
.25175 .29996 L
.25275 .29996 L
.25375 .29996 L
.25475 .29996 L
.25574 .29996 L
.25674 .29996 L
.25774 .29996 L
.25874 .29996 L
.25974 .29996 L
.26074 .29996 L
.26174 .29996 L
.26274 .29996 L
.26374 .29996 L
.26474 .29996 L
.26573 .29996 L
.26673 .29996 L
.26773 .29996 L
.26873 .29996 L
.26973 .29996 L
.27073 .29996 L
.27173 .29996 L
.27273 .29996 L
.27373 .29996 L
.27473 .29996 L
.27572 .29996 L
.27672 .29996 L
.27772 .29996 L
.27872 .29996 L
.27972 .29996 L
.28072 .29996 L
.28172 .29996 L
.28272 .29996 L
.28372 .29996 L
.28472 .29996 L
.28571 .29996 L
.28671 .29996 L
.28771 .29996 L
.28871 .29996 L
.28971 .29996 L
.29071 .29996 L
.29171 .29996 L
.29271 .29996 L
.29371 .29996 L
.29471 .29996 L
.2957 .29996 L
.2967 .29996 L
.2977 .29996 L
.2987 .29996 L
Mistroke
.2997 .29956 L
.3007 .29956 L
.3017 .29956 L
.3027 .29956 L
.3037 .29956 L
.3047 .29956 L
.30569 .29956 L
.30669 .29956 L
.30769 .29956 L
.30869 .29956 L
.30969 .29956 L
.31069 .29956 L
.31169 .29956 L
.31269 .29956 L
.31369 .29956 L
.31469 .29956 L
.31568 .29956 L
.31668 .29956 L
.31768 .29956 L
.31868 .29956 L
.31968 .29956 L
.32068 .29956 L
.32168 .29956 L
.32268 .29956 L
.32368 .29956 L
.32468 .29956 L
.32567 .29956 L
.32667 .29956 L
.32767 .29956 L
.32867 .29956 L
.32967 .29956 L
.33067 .29956 L
.33167 .29956 L
.33267 .29956 L
.33367 .29956 L
.33467 .29956 L
.33566 .29956 L
.33666 .29956 L
.33766 .29956 L
.33866 .29956 L
.33966 .29956 L
.34066 .29956 L
.34166 .29956 L
.34266 .29956 L
.34366 .29956 L
.34466 .29956 L
.34565 .29956 L
.34665 .29956 L
.34765 .29956 L
.34865 .29956 L
Mistroke
.34965 .27685 L
.35065 .27685 L
.35165 .27685 L
.35265 .27685 L
.35365 .27685 L
.35465 .27685 L
.35564 .27685 L
.35664 .27685 L
.35764 .27685 L
.35864 .27685 L
.35964 .27685 L
.36064 .27685 L
.36164 .27685 L
.36264 .27685 L
.36364 .27685 L
.36464 .27685 L
.36563 .27685 L
.36663 .27685 L
.36763 .27685 L
.36863 .27685 L
.36963 .27685 L
.37063 .27685 L
.37163 .27685 L
.37263 .27685 L
.37363 .27685 L
.37463 .27685 L
.37562 .27685 L
.37662 .27685 L
.37762 .27685 L
.37862 .27685 L
.37962 .27685 L
.38062 .27685 L
.38162 .27685 L
.38262 .27685 L
.38362 .27685 L
.38462 .27685 L
.38561 .27685 L
.38661 .27685 L
.38761 .27685 L
.38861 .27685 L
.38961 .27685 L
.39061 .27685 L
.39161 .27685 L
.39261 .27685 L
.39361 .27685 L
.39461 .27685 L
.3956 .27685 L
.3966 .27685 L
.3976 .27685 L
.3986 .27685 L
Mistroke
.3996 .26388 L
.4006 .26388 L
.4016 .26388 L
.4026 .26388 L
.4036 .26388 L
.4046 .26388 L
.40559 .26388 L
.40659 .26388 L
.40759 .26388 L
.40859 .26388 L
.40959 .26388 L
.41059 .26388 L
.41159 .26388 L
.41259 .26388 L
.41359 .26388 L
.41459 .26388 L
.41558 .26388 L
.41658 .26388 L
.41758 .26388 L
.41858 .26388 L
.41958 .26388 L
.42058 .26388 L
.42158 .26388 L
.42258 .26388 L
.42358 .26388 L
.42458 .26388 L
.42557 .26388 L
.42657 .26388 L
.42757 .26388 L
.42857 .26388 L
.42957 .26388 L
.43057 .26388 L
.43157 .26388 L
.43257 .26388 L
.43357 .26388 L
.43457 .26388 L
.43556 .26388 L
.43656 .26388 L
.43756 .26388 L
.43856 .26388 L
.43956 .26388 L
.44056 .26388 L
.44156 .26388 L
.44256 .26388 L
.44356 .26388 L
.44456 .26388 L
.44555 .26388 L
.44655 .26388 L
.44755 .26388 L
.44855 .26388 L
Mistroke
.44955 .26713 L
.45055 .26713 L
.45155 .26713 L
.45255 .26713 L
.45355 .26713 L
.45455 .26713 L
.45554 .26713 L
.45654 .26713 L
.45754 .26713 L
.45854 .26713 L
.45954 .26713 L
.46054 .26713 L
.46154 .26713 L
.46254 .26713 L
.46354 .26713 L
.46454 .26713 L
.46553 .26713 L
.46653 .26713 L
.46753 .26713 L
.46853 .26713 L
.46953 .26713 L
.47053 .26713 L
.47153 .26713 L
.47253 .26713 L
.47353 .26713 L
.47453 .26713 L
.47552 .26713 L
.47652 .26713 L
.47752 .26713 L
.47852 .26713 L
.47952 .26713 L
.48052 .26713 L
.48152 .26713 L
.48252 .26713 L
.48352 .26713 L
.48452 .26713 L
.48551 .26713 L
.48651 .26713 L
.48751 .26713 L
.48851 .26713 L
.48951 .26713 L
.49051 .26713 L
.49151 .26713 L
.49251 .26713 L
.49351 .26713 L
.49451 .26713 L
.4955 .26713 L
.4965 .26713 L
.4975 .26713 L
.4985 .26713 L
Mistroke
.4995 .26937 L
.5005 .26937 L
.5015 .26937 L
.5025 .26937 L
.5035 .26937 L
.5045 .26937 L
.50549 .26937 L
.50649 .26937 L
.50749 .26937 L
.50849 .26937 L
.50949 .26937 L
.51049 .26937 L
.51149 .26937 L
.51249 .26937 L
.51349 .26937 L
.51449 .26937 L
.51548 .26937 L
.51648 .26937 L
.51748 .26937 L
.51848 .26937 L
.51948 .26937 L
.52048 .26937 L
.52148 .26937 L
.52248 .26937 L
.52348 .26937 L
.52448 .26937 L
.52547 .26937 L
.52647 .26937 L
.52747 .26937 L
.52847 .26937 L
.52947 .26937 L
.53047 .26937 L
.53147 .26937 L
.53247 .26937 L
.53347 .26937 L
.53447 .26937 L
.53546 .26937 L
.53646 .26937 L
.53746 .26937 L
.53846 .26937 L
.53946 .26937 L
.54046 .26937 L
.54146 .26937 L
.54246 .26937 L
.54346 .26937 L
.54446 .26937 L
.54545 .26937 L
.54645 .26937 L
.54745 .26937 L
.54845 .26937 L
Mistroke
.54945 .27216 L
.55045 .27216 L
.55145 .27216 L
.55245 .27216 L
.55345 .27216 L
.55445 .27216 L
.55544 .27216 L
.55644 .27216 L
.55744 .27216 L
.55844 .27216 L
.55944 .27216 L
.56044 .27216 L
.56144 .27216 L
.56244 .27216 L
.56344 .27216 L
.56444 .27216 L
.56543 .27216 L
.56643 .27216 L
.56743 .27216 L
.56843 .27216 L
.56943 .27216 L
.57043 .27216 L
.57143 .27216 L
.57243 .27216 L
.57343 .27216 L
.57443 .27216 L
.57542 .27216 L
.57642 .27216 L
.57742 .27216 L
.57842 .27216 L
.57942 .27216 L
.58042 .27216 L
.58142 .27216 L
.58242 .27216 L
.58342 .27216 L
.58442 .27216 L
.58541 .27216 L
.58641 .27216 L
.58741 .27216 L
.58841 .27216 L
.58941 .27216 L
.59041 .27216 L
.59141 .27216 L
.59241 .27216 L
.59341 .27216 L
.59441 .27216 L
.5954 .27216 L
.5964 .27216 L
.5974 .27216 L
.5984 .27216 L
Mistroke
.5994 .27183 L
.6004 .27183 L
.6014 .27183 L
.6024 .27183 L
.6034 .27183 L
.6044 .27183 L
.60539 .27183 L
.60639 .27183 L
.60739 .27183 L
.60839 .27183 L
.60939 .27183 L
.61039 .27183 L
.61139 .27183 L
.61239 .27183 L
.61339 .27183 L
.61439 .27183 L
.61538 .27183 L
.61638 .27183 L
.61738 .27183 L
.61838 .27183 L
.61938 .27183 L
.62038 .27183 L
.62138 .27183 L
.62238 .27183 L
.62338 .27183 L
.62438 .27183 L
.62537 .27183 L
.62637 .27183 L
.62737 .27183 L
.62837 .27183 L
.62937 .27183 L
.63037 .27183 L
.63137 .27183 L
.63237 .27183 L
.63337 .27183 L
.63437 .27183 L
.63536 .27183 L
.63636 .27183 L
.63736 .27183 L
.63836 .27183 L
.63936 .27183 L
.64036 .27183 L
.64136 .27183 L
.64236 .27183 L
.64336 .27183 L
.64436 .27183 L
.64535 .27183 L
.64635 .27183 L
.64735 .27183 L
.64835 .27183 L
Mistroke
.64935 .26417 L
.65035 .26417 L
.65135 .26417 L
.65235 .26417 L
.65335 .26417 L
.65435 .26417 L
.65534 .26417 L
.65634 .26417 L
.65734 .26417 L
.65834 .26417 L
.65934 .26417 L
.66034 .26417 L
.66134 .26417 L
.66234 .26417 L
.66334 .26417 L
.66434 .26417 L
.66533 .26417 L
.66633 .26417 L
.66733 .26417 L
.66833 .26417 L
.66933 .26417 L
.67033 .26417 L
.67133 .26417 L
.67233 .26417 L
.67333 .26417 L
.67433 .26417 L
.67532 .26417 L
.67632 .26417 L
.67732 .26417 L
.67832 .26417 L
.67932 .26417 L
.68032 .26417 L
.68132 .26417 L
.68232 .26417 L
.68332 .26417 L
.68432 .26417 L
.68531 .26417 L
.68631 .26417 L
.68731 .26417 L
.68831 .26417 L
.68931 .26417 L
.69031 .26417 L
.69131 .26417 L
.69231 .26417 L
.69331 .26417 L
.69431 .26417 L
.6953 .26417 L
.6963 .26417 L
.6973 .26417 L
.6983 .26417 L
Mistroke
.6993 .26558 L
.7003 .26558 L
.7013 .26558 L
.7023 .26558 L
.7033 .26558 L
.7043 .26558 L
.70529 .26558 L
.70629 .26558 L
.70729 .26558 L
.70829 .26558 L
.70929 .26558 L
.71029 .26558 L
.71129 .26558 L
.71229 .26558 L
.71329 .26558 L
.71429 .26558 L
.71528 .26558 L
.71628 .26558 L
.71728 .26558 L
.71828 .26558 L
.71928 .26558 L
.72028 .26558 L
.72128 .26558 L
.72228 .26558 L
.72328 .26558 L
.72428 .26558 L
.72527 .26558 L
.72627 .26558 L
.72727 .26558 L
.72827 .26558 L
.72927 .26558 L
.73027 .26558 L
.73127 .26558 L
.73227 .26558 L
.73327 .26558 L
.73427 .26558 L
.73526 .26558 L
.73626 .26558 L
.73726 .26558 L
.73826 .26558 L
.73926 .26558 L
.74026 .26558 L
.74126 .26558 L
.74226 .26558 L
.74326 .26558 L
.74426 .26558 L
.74525 .26558 L
.74625 .26558 L
.74725 .26558 L
.74825 .26558 L
Mistroke
.74925 .2697 L
.75025 .2697 L
.75125 .2697 L
.75225 .2697 L
.75325 .2697 L
.75425 .2697 L
.75524 .2697 L
.75624 .2697 L
.75724 .2697 L
.75824 .2697 L
.75924 .2697 L
.76024 .2697 L
.76124 .2697 L
.76224 .2697 L
.76324 .2697 L
.76424 .2697 L
.76523 .2697 L
.76623 .2697 L
.76723 .2697 L
.76823 .2697 L
.76923 .2697 L
.77023 .2697 L
.77123 .2697 L
.77223 .2697 L
.77323 .2697 L
.77423 .2697 L
.77522 .2697 L
.77622 .2697 L
.77722 .2697 L
.77822 .2697 L
.77922 .2697 L
.78022 .2697 L
.78122 .2697 L
.78222 .2697 L
.78322 .2697 L
.78422 .2697 L
.78521 .2697 L
.78621 .2697 L
.78721 .2697 L
.78821 .2697 L
.78921 .2697 L
.79021 .2697 L
.79121 .2697 L
.79221 .2697 L
.79321 .2697 L
.79421 .2697 L
.7952 .2697 L
.7962 .2697 L
.7972 .2697 L
.7982 .2697 L
Mistroke
.7992 .27681 L
.8002 .27681 L
.8012 .27681 L
.8022 .27681 L
.8032 .27681 L
.8042 .27681 L
.80519 .27681 L
.80619 .27681 L
.80719 .27681 L
.80819 .27681 L
.80919 .27681 L
.81019 .27681 L
.81119 .27681 L
.81219 .27681 L
.81319 .27681 L
.81419 .27681 L
.81518 .27681 L
.81618 .27681 L
.81718 .27681 L
.81818 .27681 L
.81918 .27681 L
.82018 .27681 L
.82118 .27681 L
.82218 .27681 L
.82318 .27681 L
.82418 .27681 L
.82517 .27681 L
.82617 .27681 L
.82717 .27681 L
.82817 .27681 L
.82917 .27681 L
.83017 .27681 L
.83117 .27681 L
.83217 .27681 L
.83317 .27681 L
.83417 .27681 L
.83516 .27681 L
.83616 .27681 L
.83716 .27681 L
.83816 .27681 L
.83916 .27681 L
.84016 .27681 L
.84116 .27681 L
.84216 .27681 L
.84316 .27681 L
.84416 .27681 L
.84515 .27681 L
.84615 .27681 L
.84715 .27681 L
.84815 .27681 L
Mistroke
.84915 .27665 L
.85015 .27665 L
.85115 .27665 L
.85215 .27665 L
.85315 .27665 L
.85415 .27665 L
.85514 .27665 L
.85614 .27665 L
.85714 .27665 L
.85814 .27665 L
.85914 .27665 L
.86014 .27665 L
.86114 .27665 L
.86214 .27665 L
.86314 .27665 L
.86414 .27665 L
.86513 .27665 L
.86613 .27665 L
.86713 .27665 L
.86813 .27665 L
.86913 .27665 L
.87013 .27665 L
.87113 .27665 L
.87213 .27665 L
.87313 .27665 L
.87413 .27665 L
.87512 .27665 L
.87612 .27665 L
.87712 .27665 L
.87812 .27665 L
.87912 .27665 L
.88012 .27665 L
.88112 .27665 L
.88212 .27665 L
.88312 .27665 L
.88412 .27665 L
.88511 .27665 L
.88611 .27665 L
.88711 .27665 L
.88811 .27665 L
.88911 .27665 L
.89011 .27665 L
.89111 .27665 L
.89211 .27665 L
.89311 .27665 L
.89411 .27665 L
.8951 .27665 L
.8961 .27665 L
.8971 .27665 L
.8981 .27665 L
Mistroke
.8991 .26465 L
.9001 .26465 L
.9011 .26465 L
.9021 .26465 L
.9031 .26465 L
.9041 .26465 L
.90509 .26465 L
.90609 .26465 L
.90709 .26465 L
.90809 .26465 L
.90909 .26465 L
.91009 .26465 L
.91109 .26465 L
.91209 .26465 L
.91309 .26465 L
.91409 .26465 L
.91508 .26465 L
.91608 .26465 L
.91708 .26465 L
.91808 .26465 L
.91908 .26465 L
.92008 .26465 L
.92108 .26465 L
.92208 .26465 L
.92308 .26465 L
.92408 .26465 L
.92507 .26465 L
.92607 .26465 L
.92707 .26465 L
.92807 .26465 L
.92907 .26465 L
.93007 .26465 L
.93107 .26465 L
.93207 .26465 L
.93307 .26465 L
.93407 .26465 L
.93506 .26465 L
.93606 .26465 L
.93706 .26465 L
.93806 .26465 L
.93906 .26465 L
.94006 .26465 L
.94106 .26465 L
.94206 .26465 L
.94306 .26465 L
.94406 .26465 L
.94505 .26465 L
.94605 .26465 L
.94705 .26465 L
.94805 .26465 L
Mistroke
.94905 .26248 L
.95005 .26248 L
.95105 .26248 L
.95205 .26248 L
.95305 .26248 L
.95405 .26248 L
.95504 .26248 L
.95604 .26248 L
.95704 .26248 L
.95804 .26248 L
.95904 .26248 L
.96004 .26248 L
.96104 .26248 L
.96204 .26248 L
.96304 .26248 L
.96404 .26248 L
.96503 .26248 L
.96603 .26248 L
.96703 .26248 L
.96803 .26248 L
.96903 .26248 L
.97003 .26248 L
.97103 .26248 L
.97203 .26248 L
.97303 .26248 L
.97403 .26248 L
.97502 .26248 L
.97602 .26248 L
.97702 .26248 L
.97802 .26248 L
.97902 .26248 L
.98002 .26248 L
.98102 .26248 L
.98202 .26248 L
.98302 .26248 L
.98402 .26248 L
.98501 .26248 L
.98601 .26248 L
.98701 .26248 L
.98801 .26248 L
.98901 .26248 L
.99001 .26248 L
.99101 .26248 L
.99201 .26248 L
.99301 .26248 L
.99401 .26248 L
.995 .26248 L
.996 .26248 L
.997 .26248 L
.998 .26248 L
Mistroke
.999 .25705 L
Mfstroke
1 0 0 r
gsave
.999 .2073 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24721 m
.001 .24721 L
.002 .24721 L
.003 .24721 L
.004 .24721 L
.005 .24721 L
.00599 .24721 L
.00699 .24721 L
.00799 .24721 L
.00899 .24721 L
.00999 .24721 L
.01099 .24721 L
.01199 .24721 L
.01299 .24721 L
.01399 .24721 L
.01499 .24721 L
.01598 .24721 L
.01698 .24721 L
.01798 .24721 L
.01898 .24721 L
.01998 .24721 L
.02098 .24721 L
.02198 .24721 L
.02298 .24721 L
.02398 .24721 L
.02498 .24721 L
.02597 .24721 L
.02697 .24721 L
.02797 .24721 L
.02897 .24721 L
.02997 .24721 L
.03097 .24721 L
.03197 .24721 L
.03297 .24721 L
.03397 .24721 L
.03497 .24721 L
.03596 .24721 L
.03696 .24721 L
.03796 .24721 L
.03896 .24721 L
.03996 .24721 L
.04096 .24721 L
.04196 .24721 L
.04296 .24721 L
.04396 .24721 L
.04496 .24721 L
.04595 .24721 L
.04695 .24721 L
.04795 .24721 L
.04895 .24721 L
Mistroke
.04995 .24523 L
.05095 .24523 L
.05195 .24523 L
.05295 .24523 L
.05395 .24523 L
.05495 .24523 L
.05594 .24523 L
.05694 .24523 L
.05794 .24523 L
.05894 .24523 L
.05994 .24523 L
.06094 .24523 L
.06194 .24523 L
.06294 .24523 L
.06394 .24523 L
.06494 .24523 L
.06593 .24523 L
.06693 .24523 L
.06793 .24523 L
.06893 .24523 L
.06993 .24523 L
.07093 .24523 L
.07193 .24523 L
.07293 .24523 L
.07393 .24523 L
.07493 .24523 L
.07592 .24523 L
.07692 .24523 L
.07792 .24523 L
.07892 .24523 L
.07992 .24523 L
.08092 .24523 L
.08192 .24523 L
.08292 .24523 L
.08392 .24523 L
.08492 .24523 L
.08591 .24523 L
.08691 .24523 L
.08791 .24523 L
.08891 .24523 L
.08991 .24523 L
.09091 .24523 L
.09191 .24523 L
.09291 .24523 L
.09391 .24523 L
.09491 .24523 L
.0959 .24523 L
.0969 .24523 L
.0979 .24523 L
.0989 .24523 L
Mistroke
.0999 .19911 L
.1009 .19911 L
.1019 .19911 L
.1029 .19911 L
.1039 .19911 L
.1049 .19911 L
.10589 .19911 L
.10689 .19911 L
.10789 .19911 L
.10889 .19911 L
.10989 .19911 L
.11089 .19911 L
.11189 .19911 L
.11289 .19911 L
.11389 .19911 L
.11489 .19911 L
.11588 .19911 L
.11688 .19911 L
.11788 .19911 L
.11888 .19911 L
.11988 .19911 L
.12088 .19911 L
.12188 .19911 L
.12288 .19911 L
.12388 .19911 L
.12488 .19911 L
.12587 .19911 L
.12687 .19911 L
.12787 .19911 L
.12887 .19911 L
.12987 .19911 L
.13087 .19911 L
.13187 .19911 L
.13287 .19911 L
.13387 .19911 L
.13487 .19911 L
.13586 .19911 L
.13686 .19911 L
.13786 .19911 L
.13886 .19911 L
.13986 .19911 L
.14086 .19911 L
.14186 .19911 L
.14286 .19911 L
.14386 .19911 L
.14486 .19911 L
.14585 .19911 L
.14685 .19911 L
.14785 .19911 L
.14885 .19911 L
Mistroke
.14985 .1568 L
.15085 .1568 L
.15185 .1568 L
.15285 .1568 L
.15385 .1568 L
.15485 .1568 L
.15584 .1568 L
.15684 .1568 L
.15784 .1568 L
.15884 .1568 L
.15984 .1568 L
.16084 .1568 L
.16184 .1568 L
.16284 .1568 L
.16384 .1568 L
.16484 .1568 L
.16583 .1568 L
.16683 .1568 L
.16783 .1568 L
.16883 .1568 L
.16983 .1568 L
.17083 .1568 L
.17183 .1568 L
.17283 .1568 L
.17383 .1568 L
.17483 .1568 L
.17582 .1568 L
.17682 .1568 L
.17782 .1568 L
.17882 .1568 L
.17982 .1568 L
.18082 .1568 L
.18182 .1568 L
.18282 .1568 L
.18382 .1568 L
.18482 .1568 L
.18581 .1568 L
.18681 .1568 L
.18781 .1568 L
.18881 .1568 L
.18981 .1568 L
.19081 .1568 L
.19181 .1568 L
.19281 .1568 L
.19381 .1568 L
.19481 .1568 L
.1958 .1568 L
.1968 .1568 L
.1978 .1568 L
.1988 .1568 L
Mistroke
.1998 .1762 L
.2008 .1762 L
.2018 .1762 L
.2028 .1762 L
.2038 .1762 L
.2048 .1762 L
.20579 .1762 L
.20679 .1762 L
.20779 .1762 L
.20879 .1762 L
.20979 .1762 L
.21079 .1762 L
.21179 .1762 L
.21279 .1762 L
.21379 .1762 L
.21479 .1762 L
.21578 .1762 L
.21678 .1762 L
.21778 .1762 L
.21878 .1762 L
.21978 .1762 L
.22078 .1762 L
.22178 .1762 L
.22278 .1762 L
.22378 .1762 L
.22478 .1762 L
.22577 .1762 L
.22677 .1762 L
.22777 .1762 L
.22877 .1762 L
.22977 .1762 L
.23077 .1762 L
.23177 .1762 L
.23277 .1762 L
.23377 .1762 L
.23477 .1762 L
.23576 .1762 L
.23676 .1762 L
.23776 .1762 L
.23876 .1762 L
.23976 .1762 L
.24076 .1762 L
.24176 .1762 L
.24276 .1762 L
.24376 .1762 L
.24476 .1762 L
.24575 .1762 L
.24675 .1762 L
.24775 .1762 L
.24875 .1762 L
Mistroke
.24975 .2146 L
.25075 .2146 L
.25175 .2146 L
.25275 .2146 L
.25375 .2146 L
.25475 .2146 L
.25574 .2146 L
.25674 .2146 L
.25774 .2146 L
.25874 .2146 L
.25974 .2146 L
.26074 .2146 L
.26174 .2146 L
.26274 .2146 L
.26374 .2146 L
.26474 .2146 L
.26573 .2146 L
.26673 .2146 L
.26773 .2146 L
.26873 .2146 L
.26973 .2146 L
.27073 .2146 L
.27173 .2146 L
.27273 .2146 L
.27373 .2146 L
.27473 .2146 L
.27572 .2146 L
.27672 .2146 L
.27772 .2146 L
.27872 .2146 L
.27972 .2146 L
.28072 .2146 L
.28172 .2146 L
.28272 .2146 L
.28372 .2146 L
.28472 .2146 L
.28571 .2146 L
.28671 .2146 L
.28771 .2146 L
.28871 .2146 L
.28971 .2146 L
.29071 .2146 L
.29171 .2146 L
.29271 .2146 L
.29371 .2146 L
.29471 .2146 L
.2957 .2146 L
.2967 .2146 L
.2977 .2146 L
.2987 .2146 L
Mistroke
.2997 .21733 L
.3007 .21733 L
.3017 .21733 L
.3027 .21733 L
.3037 .21733 L
.3047 .21733 L
.30569 .21733 L
.30669 .21733 L
.30769 .21733 L
.30869 .21733 L
.30969 .21733 L
.31069 .21733 L
.31169 .21733 L
.31269 .21733 L
.31369 .21733 L
.31469 .21733 L
.31568 .21733 L
.31668 .21733 L
.31768 .21733 L
.31868 .21733 L
.31968 .21733 L
.32068 .21733 L
.32168 .21733 L
.32268 .21733 L
.32368 .21733 L
.32468 .21733 L
.32567 .21733 L
.32667 .21733 L
.32767 .21733 L
.32867 .21733 L
.32967 .21733 L
.33067 .21733 L
.33167 .21733 L
.33267 .21733 L
.33367 .21733 L
.33467 .21733 L
.33566 .21733 L
.33666 .21733 L
.33766 .21733 L
.33866 .21733 L
.33966 .21733 L
.34066 .21733 L
.34166 .21733 L
.34266 .21733 L
.34366 .21733 L
.34466 .21733 L
.34565 .21733 L
.34665 .21733 L
.34765 .21733 L
.34865 .21733 L
Mistroke
.34965 .2004 L
.35065 .2004 L
.35165 .2004 L
.35265 .2004 L
.35365 .2004 L
.35465 .2004 L
.35564 .2004 L
.35664 .2004 L
.35764 .2004 L
.35864 .2004 L
.35964 .2004 L
.36064 .2004 L
.36164 .2004 L
.36264 .2004 L
.36364 .2004 L
.36464 .2004 L
.36563 .2004 L
.36663 .2004 L
.36763 .2004 L
.36863 .2004 L
.36963 .2004 L
.37063 .2004 L
.37163 .2004 L
.37263 .2004 L
.37363 .2004 L
.37463 .2004 L
.37562 .2004 L
.37662 .2004 L
.37762 .2004 L
.37862 .2004 L
.37962 .2004 L
.38062 .2004 L
.38162 .2004 L
.38262 .2004 L
.38362 .2004 L
.38462 .2004 L
.38561 .2004 L
.38661 .2004 L
.38761 .2004 L
.38861 .2004 L
.38961 .2004 L
.39061 .2004 L
.39161 .2004 L
.39261 .2004 L
.39361 .2004 L
.39461 .2004 L
.3956 .2004 L
.3966 .2004 L
.3976 .2004 L
.3986 .2004 L
Mistroke
.3996 .19279 L
.4006 .19279 L
.4016 .19279 L
.4026 .19279 L
.4036 .19279 L
.4046 .19279 L
.40559 .19279 L
.40659 .19279 L
.40759 .19279 L
.40859 .19279 L
.40959 .19279 L
.41059 .19279 L
.41159 .19279 L
.41259 .19279 L
.41359 .19279 L
.41459 .19279 L
.41558 .19279 L
.41658 .19279 L
.41758 .19279 L
.41858 .19279 L
.41958 .19279 L
.42058 .19279 L
.42158 .19279 L
.42258 .19279 L
.42358 .19279 L
.42458 .19279 L
.42557 .19279 L
.42657 .19279 L
.42757 .19279 L
.42857 .19279 L
.42957 .19279 L
.43057 .19279 L
.43157 .19279 L
.43257 .19279 L
.43357 .19279 L
.43457 .19279 L
.43556 .19279 L
.43656 .19279 L
.43756 .19279 L
.43856 .19279 L
.43956 .19279 L
.44056 .19279 L
.44156 .19279 L
.44256 .19279 L
.44356 .19279 L
.44456 .19279 L
.44555 .19279 L
.44655 .19279 L
.44755 .19279 L
.44855 .19279 L
Mistroke
.44955 .19877 L
.45055 .19877 L
.45155 .19877 L
.45255 .19877 L
.45355 .19877 L
.45455 .19877 L
.45554 .19877 L
.45654 .19877 L
.45754 .19877 L
.45854 .19877 L
.45954 .19877 L
.46054 .19877 L
.46154 .19877 L
.46254 .19877 L
.46354 .19877 L
.46454 .19877 L
.46553 .19877 L
.46653 .19877 L
.46753 .19877 L
.46853 .19877 L
.46953 .19877 L
.47053 .19877 L
.47153 .19877 L
.47253 .19877 L
.47353 .19877 L
.47453 .19877 L
.47552 .19877 L
.47652 .19877 L
.47752 .19877 L
.47852 .19877 L
.47952 .19877 L
.48052 .19877 L
.48152 .19877 L
.48252 .19877 L
.48352 .19877 L
.48452 .19877 L
.48551 .19877 L
.48651 .19877 L
.48751 .19877 L
.48851 .19877 L
.48951 .19877 L
.49051 .19877 L
.49151 .19877 L
.49251 .19877 L
.49351 .19877 L
.49451 .19877 L
.4955 .19877 L
.4965 .19877 L
.4975 .19877 L
.4985 .19877 L
Mistroke
.4995 .20545 L
.5005 .20545 L
.5015 .20545 L
.5025 .20545 L
.5035 .20545 L
.5045 .20545 L
.50549 .20545 L
.50649 .20545 L
.50749 .20545 L
.50849 .20545 L
.50949 .20545 L
.51049 .20545 L
.51149 .20545 L
.51249 .20545 L
.51349 .20545 L
.51449 .20545 L
.51548 .20545 L
.51648 .20545 L
.51748 .20545 L
.51848 .20545 L
.51948 .20545 L
.52048 .20545 L
.52148 .20545 L
.52248 .20545 L
.52348 .20545 L
.52448 .20545 L
.52547 .20545 L
.52647 .20545 L
.52747 .20545 L
.52847 .20545 L
.52947 .20545 L
.53047 .20545 L
.53147 .20545 L
.53247 .20545 L
.53347 .20545 L
.53447 .20545 L
.53546 .20545 L
.53646 .20545 L
.53746 .20545 L
.53846 .20545 L
.53946 .20545 L
.54046 .20545 L
.54146 .20545 L
.54246 .20545 L
.54346 .20545 L
.54446 .20545 L
.54545 .20545 L
.54645 .20545 L
.54745 .20545 L
.54845 .20545 L
Mistroke
.54945 .21011 L
.55045 .21011 L
.55145 .21011 L
.55245 .21011 L
.55345 .21011 L
.55445 .21011 L
.55544 .21011 L
.55644 .21011 L
.55744 .21011 L
.55844 .21011 L
.55944 .21011 L
.56044 .21011 L
.56144 .21011 L
.56244 .21011 L
.56344 .21011 L
.56444 .21011 L
.56543 .21011 L
.56643 .21011 L
.56743 .21011 L
.56843 .21011 L
.56943 .21011 L
.57043 .21011 L
.57143 .21011 L
.57243 .21011 L
.57343 .21011 L
.57443 .21011 L
.57542 .21011 L
.57642 .21011 L
.57742 .21011 L
.57842 .21011 L
.57942 .21011 L
.58042 .21011 L
.58142 .21011 L
.58242 .21011 L
.58342 .21011 L
.58442 .21011 L
.58541 .21011 L
.58641 .21011 L
.58741 .21011 L
.58841 .21011 L
.58941 .21011 L
.59041 .21011 L
.59141 .21011 L
.59241 .21011 L
.59341 .21011 L
.59441 .21011 L
.5954 .21011 L
.5964 .21011 L
.5974 .21011 L
.5984 .21011 L
Mistroke
.5994 .21173 L
.6004 .21173 L
.6014 .21173 L
.6024 .21173 L
.6034 .21173 L
.6044 .21173 L
.60539 .21173 L
.60639 .21173 L
.60739 .21173 L
.60839 .21173 L
.60939 .21173 L
.61039 .21173 L
.61139 .21173 L
.61239 .21173 L
.61339 .21173 L
.61439 .21173 L
.61538 .21173 L
.61638 .21173 L
.61738 .21173 L
.61838 .21173 L
.61938 .21173 L
.62038 .21173 L
.62138 .21173 L
.62238 .21173 L
.62338 .21173 L
.62438 .21173 L
.62537 .21173 L
.62637 .21173 L
.62737 .21173 L
.62837 .21173 L
.62937 .21173 L
.63037 .21173 L
.63137 .21173 L
.63237 .21173 L
.63337 .21173 L
.63437 .21173 L
.63536 .21173 L
.63636 .21173 L
.63736 .21173 L
.63836 .21173 L
.63936 .21173 L
.64036 .21173 L
.64136 .21173 L
.64236 .21173 L
.64336 .21173 L
.64436 .21173 L
.64535 .21173 L
.64635 .21173 L
.64735 .21173 L
.64835 .21173 L
Mistroke
.64935 .20596 L
.65035 .20596 L
.65135 .20596 L
.65235 .20596 L
.65335 .20596 L
.65435 .20596 L
.65534 .20596 L
.65634 .20596 L
.65734 .20596 L
.65834 .20596 L
.65934 .20596 L
.66034 .20596 L
.66134 .20596 L
.66234 .20596 L
.66334 .20596 L
.66434 .20596 L
.66533 .20596 L
.66633 .20596 L
.66733 .20596 L
.66833 .20596 L
.66933 .20596 L
.67033 .20596 L
.67133 .20596 L
.67233 .20596 L
.67333 .20596 L
.67433 .20596 L
.67532 .20596 L
.67632 .20596 L
.67732 .20596 L
.67832 .20596 L
.67932 .20596 L
.68032 .20596 L
.68132 .20596 L
.68232 .20596 L
.68332 .20596 L
.68432 .20596 L
.68531 .20596 L
.68631 .20596 L
.68731 .20596 L
.68831 .20596 L
.68931 .20596 L
.69031 .20596 L
.69131 .20596 L
.69231 .20596 L
.69331 .20596 L
.69431 .20596 L
.6953 .20596 L
.6963 .20596 L
.6973 .20596 L
.6983 .20596 L
Mistroke
.6993 .20939 L
.7003 .20939 L
.7013 .20939 L
.7023 .20939 L
.7033 .20939 L
.7043 .20939 L
.70529 .20939 L
.70629 .20939 L
.70729 .20939 L
.70829 .20939 L
.70929 .20939 L
.71029 .20939 L
.71129 .20939 L
.71229 .20939 L
.71329 .20939 L
.71429 .20939 L
.71528 .20939 L
.71628 .20939 L
.71728 .20939 L
.71828 .20939 L
.71928 .20939 L
.72028 .20939 L
.72128 .20939 L
.72228 .20939 L
.72328 .20939 L
.72428 .20939 L
.72527 .20939 L
.72627 .20939 L
.72727 .20939 L
.72827 .20939 L
.72927 .20939 L
.73027 .20939 L
.73127 .20939 L
.73227 .20939 L
.73327 .20939 L
.73427 .20939 L
.73526 .20939 L
.73626 .20939 L
.73726 .20939 L
.73826 .20939 L
.73926 .20939 L
.74026 .20939 L
.74126 .20939 L
.74226 .20939 L
.74326 .20939 L
.74426 .20939 L
.74525 .20939 L
.74625 .20939 L
.74725 .20939 L
.74825 .20939 L
Mistroke
.74925 .21425 L
.75025 .21425 L
.75125 .21425 L
.75225 .21425 L
.75325 .21425 L
.75425 .21425 L
.75524 .21425 L
.75624 .21425 L
.75724 .21425 L
.75824 .21425 L
.75924 .21425 L
.76024 .21425 L
.76124 .21425 L
.76224 .21425 L
.76324 .21425 L
.76424 .21425 L
.76523 .21425 L
.76623 .21425 L
.76723 .21425 L
.76823 .21425 L
.76923 .21425 L
.77023 .21425 L
.77123 .21425 L
.77223 .21425 L
.77323 .21425 L
.77423 .21425 L
.77522 .21425 L
.77622 .21425 L
.77722 .21425 L
.77822 .21425 L
.77922 .21425 L
.78022 .21425 L
.78122 .21425 L
.78222 .21425 L
.78322 .21425 L
.78422 .21425 L
.78521 .21425 L
.78621 .21425 L
.78721 .21425 L
.78821 .21425 L
.78921 .21425 L
.79021 .21425 L
.79121 .21425 L
.79221 .21425 L
.79321 .21425 L
.79421 .21425 L
.7952 .21425 L
.7962 .21425 L
.7972 .21425 L
.7982 .21425 L
Mistroke
.7992 .22297 L
.8002 .22297 L
.8012 .22297 L
.8022 .22297 L
.8032 .22297 L
.8042 .22297 L
.80519 .22297 L
.80619 .22297 L
.80719 .22297 L
.80819 .22297 L
.80919 .22297 L
.81019 .22297 L
.81119 .22297 L
.81219 .22297 L
.81319 .22297 L
.81419 .22297 L
.81518 .22297 L
.81618 .22297 L
.81718 .22297 L
.81818 .22297 L
.81918 .22297 L
.82018 .22297 L
.82118 .22297 L
.82218 .22297 L
.82318 .22297 L
.82418 .22297 L
.82517 .22297 L
.82617 .22297 L
.82717 .22297 L
.82817 .22297 L
.82917 .22297 L
.83017 .22297 L
.83117 .22297 L
.83217 .22297 L
.83317 .22297 L
.83417 .22297 L
.83516 .22297 L
.83616 .22297 L
.83716 .22297 L
.83816 .22297 L
.83916 .22297 L
.84016 .22297 L
.84116 .22297 L
.84216 .22297 L
.84316 .22297 L
.84416 .22297 L
.84515 .22297 L
.84615 .22297 L
.84715 .22297 L
.84815 .22297 L
Mistroke
.84915 .22377 L
.85015 .22377 L
.85115 .22377 L
.85215 .22377 L
.85315 .22377 L
.85415 .22377 L
.85514 .22377 L
.85614 .22377 L
.85714 .22377 L
.85814 .22377 L
.85914 .22377 L
.86014 .22377 L
.86114 .22377 L
.86214 .22377 L
.86314 .22377 L
.86414 .22377 L
.86513 .22377 L
.86613 .22377 L
.86713 .22377 L
.86813 .22377 L
.86913 .22377 L
.87013 .22377 L
.87113 .22377 L
.87213 .22377 L
.87313 .22377 L
.87413 .22377 L
.87512 .22377 L
.87612 .22377 L
.87712 .22377 L
.87812 .22377 L
.87912 .22377 L
.88012 .22377 L
.88112 .22377 L
.88212 .22377 L
.88312 .22377 L
.88412 .22377 L
.88511 .22377 L
.88611 .22377 L
.88711 .22377 L
.88811 .22377 L
.88911 .22377 L
.89011 .22377 L
.89111 .22377 L
.89211 .22377 L
.89311 .22377 L
.89411 .22377 L
.8951 .22377 L
.8961 .22377 L
.8971 .22377 L
.8981 .22377 L
Mistroke
.8991 .2131 L
.9001 .2131 L
.9011 .2131 L
.9021 .2131 L
.9031 .2131 L
.9041 .2131 L
.90509 .2131 L
.90609 .2131 L
.90709 .2131 L
.90809 .2131 L
.90909 .2131 L
.91009 .2131 L
.91109 .2131 L
.91209 .2131 L
.91309 .2131 L
.91409 .2131 L
.91508 .2131 L
.91608 .2131 L
.91708 .2131 L
.91808 .2131 L
.91908 .2131 L
.92008 .2131 L
.92108 .2131 L
.92208 .2131 L
.92308 .2131 L
.92408 .2131 L
.92507 .2131 L
.92607 .2131 L
.92707 .2131 L
.92807 .2131 L
.92907 .2131 L
.93007 .2131 L
.93107 .2131 L
.93207 .2131 L
.93307 .2131 L
.93407 .2131 L
.93506 .2131 L
.93606 .2131 L
.93706 .2131 L
.93806 .2131 L
.93906 .2131 L
.94006 .2131 L
.94106 .2131 L
.94206 .2131 L
.94306 .2131 L
.94406 .2131 L
.94505 .2131 L
.94605 .2131 L
.94705 .2131 L
.94805 .2131 L
Mistroke
.94905 .21174 L
.95005 .21174 L
.95105 .21174 L
.95205 .21174 L
.95305 .21174 L
.95405 .21174 L
.95504 .21174 L
.95604 .21174 L
.95704 .21174 L
.95804 .21174 L
.95904 .21174 L
.96004 .21174 L
.96104 .21174 L
.96204 .21174 L
.96304 .21174 L
.96404 .21174 L
.96503 .21174 L
.96603 .21174 L
.96703 .21174 L
.96803 .21174 L
.96903 .21174 L
.97003 .21174 L
.97103 .21174 L
.97203 .21174 L
.97303 .21174 L
.97403 .21174 L
.97502 .21174 L
.97602 .21174 L
.97702 .21174 L
.97802 .21174 L
.97902 .21174 L
.98002 .21174 L
.98102 .21174 L
.98202 .21174 L
.98302 .21174 L
.98402 .21174 L
.98501 .21174 L
.98601 .21174 L
.98701 .21174 L
.98801 .21174 L
.98901 .21174 L
.99001 .21174 L
.99101 .21174 L
.99201 .21174 L
.99301 .21174 L
.99401 .21174 L
.995 .21174 L
.996 .21174 L
.997 .21174 L
.998 .21174 L
Mistroke
.999 .2073 L
Mfstroke
0 0 1 r
gsave
.001 -1.8541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0772542 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -6 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -6 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -6 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -6 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -6 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(1)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(2)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(3)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(4)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(6)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(7)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .20601 m
.001 .20601 L
.002 .20601 L
.003 .20601 L
.004 .20601 L
.005 .20601 L
.00599 .20601 L
.00699 .20601 L
.00799 .20601 L
.00899 .20601 L
.00999 .20601 L
.01099 .20601 L
.01199 .20601 L
.01299 .20601 L
.01399 .20601 L
.01499 .20601 L
.01598 .20601 L
.01698 .20601 L
.01798 .20602 L
.01898 .20602 L
.01998 .20602 L
.02098 .20602 L
.02198 .20602 L
.02298 .20602 L
.02398 .20602 L
.02498 .20602 L
.02597 .20602 L
.02697 .20602 L
.02797 .20602 L
.02897 .20602 L
.02997 .20602 L
.03097 .20602 L
.03197 .20602 L
.03297 .20602 L
.03397 .20602 L
.03497 .20602 L
.03596 .20602 L
.03696 .20602 L
.03796 .20602 L
.03896 .20602 L
.03996 .20602 L
.04096 .20602 L
.04196 .20602 L
.04296 .20602 L
.04396 .20602 L
.04496 .20602 L
.04595 .20602 L
.04695 .20602 L
.04795 .20602 L
.04895 .20602 L
Mistroke
.04995 .20602 L
.05095 .20602 L
.05195 .20602 L
.05295 .20602 L
.05395 .20601 L
.05495 .20602 L
.05594 .20602 L
.05694 .20602 L
.05794 .20602 L
.05894 .20602 L
.05994 .20602 L
.06094 .20601 L
.06194 .20602 L
.06294 .20602 L
.06394 .20602 L
.06494 .20602 L
.06593 .20602 L
.06693 .20602 L
.06793 .20602 L
.06893 .20602 L
.06993 .20602 L
.07093 .20602 L
.07193 .20602 L
.07293 .20602 L
.07393 .20602 L
.07493 .20602 L
.07592 .20602 L
.07692 .20602 L
.07792 .20602 L
.07892 .20602 L
.07992 .20602 L
.08092 .20602 L
.08192 .20602 L
.08292 .20602 L
.08392 .20602 L
.08492 .20602 L
.08591 .20602 L
.08691 .20602 L
.08791 .20602 L
.08891 .20602 L
.08991 .20602 L
.09091 .20602 L
.09191 .20602 L
.09291 .20602 L
.09391 .20602 L
.09491 .20602 L
.0959 .20602 L
.0969 .20603 L
.0979 .20602 L
.0989 .20602 L
Mistroke
.0999 .20602 L
.1009 .20603 L
.1019 .20603 L
.1029 .20603 L
.1039 .20603 L
.1049 .20602 L
.10589 .20603 L
.10689 .20603 L
.10789 .20603 L
.10889 .20603 L
.10989 .20602 L
.11089 .20602 L
.11189 .20603 L
.11289 .20602 L
.11389 .20602 L
.11489 .20602 L
.11588 .20602 L
.11688 .20602 L
.11788 .20602 L
.11888 .20602 L
.11988 .20602 L
.12088 .20602 L
.12188 .20602 L
.12288 .20603 L
.12388 .20602 L
.12488 .20602 L
.12587 .20602 L
.12687 .20602 L
.12787 .20602 L
.12887 .20602 L
.12987 .20602 L
.13087 .20602 L
.13187 .20602 L
.13287 .20602 L
.13387 .20602 L
.13487 .20602 L
.13586 .20603 L
.13686 .20603 L
.13786 .20603 L
.13886 .20603 L
.13986 .20603 L
.14086 .20603 L
.14186 .20603 L
.14286 .20603 L
.14386 .20602 L
.14486 .20602 L
.14585 .20602 L
.14685 .20602 L
.14785 .20602 L
.14885 .20602 L
Mistroke
.14985 .20602 L
.15085 .20602 L
.15185 .20603 L
.15285 .20603 L
.15385 .20603 L
.15485 .20603 L
.15584 .20602 L
.15684 .20602 L
.15784 .20602 L
.15884 .20602 L
.15984 .20602 L
.16084 .20602 L
.16184 .20602 L
.16284 .20602 L
.16384 .20602 L
.16484 .20602 L
.16583 .20602 L
.16683 .20602 L
.16783 .20602 L
.16883 .20602 L
.16983 .20602 L
.17083 .20602 L
.17183 .20602 L
.17283 .20602 L
.17383 .20602 L
.17483 .20602 L
.17582 .20602 L
.17682 .20602 L
.17782 .20602 L
.17882 .20602 L
.17982 .20602 L
.18082 .20602 L
.18182 .20602 L
.18282 .20602 L
.18382 .20602 L
.18482 .20602 L
.18581 .20602 L
.18681 .20603 L
.18781 .20602 L
.18881 .20602 L
.18981 .20603 L
.19081 .20603 L
.19181 .20603 L
.19281 .20603 L
.19381 .20603 L
.19481 .20603 L
.1958 .20603 L
.1968 .20603 L
.1978 .20603 L
.1988 .20603 L
Mistroke
.1998 .20603 L
.2008 .20603 L
.2018 .20603 L
.2028 .20603 L
.2038 .20603 L
.2048 .20603 L
.20579 .20603 L
.20679 .20603 L
.20779 .20603 L
.20879 .20603 L
.20979 .20603 L
.21079 .20603 L
.21179 .20603 L
.21279 .20603 L
.21379 .20603 L
.21479 .20603 L
.21578 .20603 L
.21678 .20603 L
.21778 .20603 L
.21878 .20603 L
.21978 .20603 L
.22078 .20603 L
.22178 .20603 L
.22278 .20603 L
.22378 .20603 L
.22478 .20603 L
.22577 .20603 L
.22677 .20603 L
.22777 .20603 L
.22877 .20603 L
.22977 .20603 L
.23077 .20603 L
.23177 .20603 L
.23277 .20603 L
.23377 .20603 L
.23477 .20603 L
.23576 .20603 L
.23676 .20603 L
.23776 .20603 L
.23876 .20603 L
.23976 .20602 L
.24076 .20602 L
.24176 .20602 L
.24276 .20602 L
.24376 .20602 L
.24476 .20603 L
.24575 .20603 L
.24675 .20603 L
.24775 .20603 L
.24875 .20603 L
Mistroke
.24975 .20603 L
.25075 .20603 L
.25175 .20603 L
.25275 .20603 L
.25375 .20603 L
.25475 .20603 L
.25574 .20603 L
.25674 .20603 L
.25774 .20603 L
.25874 .20602 L
.25974 .20603 L
.26074 .20602 L
.26174 .20602 L
.26274 .20602 L
.26374 .20603 L
.26474 .20603 L
.26573 .20603 L
.26673 .20603 L
.26773 .20603 L
.26873 .20603 L
.26973 .20603 L
.27073 .20603 L
.27173 .20603 L
.27273 .20603 L
.27373 .20603 L
.27473 .20603 L
.27572 .20602 L
.27672 .20602 L
.27772 .20602 L
.27872 .20602 L
.27972 .20602 L
.28072 .20602 L
.28172 .20602 L
.28272 .20602 L
.28372 .20602 L
.28472 .20602 L
.28571 .20603 L
.28671 .20603 L
.28771 .20603 L
.28871 .20603 L
.28971 .20603 L
.29071 .20603 L
.29171 .20603 L
.29271 .20603 L
.29371 .20603 L
.29471 .20603 L
.2957 .20603 L
.2967 .20603 L
.2977 .20603 L
.2987 .20603 L
Mistroke
.2997 .20603 L
.3007 .20603 L
.3017 .20603 L
.3027 .20603 L
.3037 .20603 L
.3047 .20603 L
.30569 .20603 L
.30669 .20603 L
.30769 .20603 L
.30869 .20603 L
.30969 .20603 L
.31069 .20603 L
.31169 .20603 L
.31269 .20603 L
.31369 .20603 L
.31469 .20603 L
.31568 .20603 L
.31668 .20603 L
.31768 .20603 L
.31868 .20603 L
.31968 .20603 L
.32068 .20603 L
.32168 .20603 L
.32268 .20603 L
.32368 .20603 L
.32468 .20603 L
.32567 .20603 L
.32667 .20603 L
.32767 .20603 L
.32867 .20603 L
.32967 .20603 L
.33067 .20603 L
.33167 .20603 L
.33267 .20603 L
.33367 .20603 L
.33467 .20603 L
.33566 .20603 L
.33666 .20603 L
.33766 .20603 L
.33866 .20603 L
.33966 .20603 L
.34066 .20603 L
.34166 .20603 L
.34266 .20604 L
.34366 .20603 L
.34466 .20603 L
.34565 .20604 L
.34665 .20603 L
.34765 .20604 L
.34865 .20604 L
Mistroke
.34965 .20603 L
.35065 .20603 L
.35165 .20603 L
.35265 .20604 L
.35365 .20603 L
.35465 .20603 L
.35564 .20603 L
.35664 .20603 L
.35764 .20603 L
.35864 .20603 L
.35964 .20603 L
.36064 .20604 L
.36164 .20604 L
.36264 .20604 L
.36364 .20604 L
.36464 .20604 L
.36563 .20604 L
.36663 .20604 L
.36763 .20604 L
.36863 .20604 L
.36963 .20604 L
.37063 .20604 L
.37163 .20604 L
.37263 .20604 L
.37363 .20604 L
.37463 .20604 L
.37562 .20604 L
.37662 .20604 L
.37762 .20604 L
.37862 .20604 L
.37962 .20604 L
.38062 .20604 L
.38162 .20604 L
.38262 .20604 L
.38362 .20604 L
.38462 .20604 L
.38561 .20603 L
.38661 .20604 L
.38761 .20604 L
.38861 .20604 L
.38961 .20604 L
.39061 .20604 L
.39161 .20604 L
.39261 .20604 L
.39361 .20604 L
.39461 .20604 L
.3956 .20604 L
.3966 .20604 L
.3976 .20604 L
.3986 .20604 L
Mistroke
.3996 .20604 L
.4006 .20604 L
.4016 .20604 L
.4026 .20604 L
.4036 .20604 L
.4046 .20604 L
.40559 .20604 L
.40659 .20604 L
.40759 .20604 L
.40859 .20604 L
.40959 .20604 L
.41059 .20604 L
.41159 .20604 L
.41259 .20604 L
.41359 .20604 L
.41459 .20604 L
.41558 .20604 L
.41658 .20604 L
.41758 .20604 L
.41858 .20604 L
.41958 .20604 L
.42058 .20604 L
.42158 .20604 L
.42258 .20604 L
.42358 .20604 L
.42458 .20604 L
.42557 .20604 L
.42657 .20604 L
.42757 .20604 L
.42857 .20604 L
.42957 .20604 L
.43057 .20604 L
.43157 .20604 L
.43257 .20604 L
.43357 .20604 L
.43457 .20604 L
.43556 .20604 L
.43656 .20604 L
.43756 .20604 L
.43856 .20604 L
.43956 .20604 L
.44056 .20604 L
.44156 .20604 L
.44256 .20604 L
.44356 .20604 L
.44456 .20604 L
.44555 .20604 L
.44655 .20604 L
.44755 .20604 L
.44855 .20604 L
Mistroke
.44955 .20604 L
.45055 .20604 L
.45155 .20604 L
.45255 .20604 L
.45355 .20604 L
.45455 .20604 L
.45554 .20604 L
.45654 .20603 L
.45754 .20604 L
.45854 .20604 L
.45954 .20604 L
.46054 .20604 L
.46154 .20604 L
.46254 .20604 L
.46354 .20604 L
.46454 .20604 L
.46553 .20604 L
.46653 .20604 L
.46753 .20604 L
.46853 .20604 L
.46953 .20604 L
.47053 .20604 L
.47153 .20604 L
.47253 .20604 L
.47353 .20604 L
.47453 .20604 L
.47552 .20604 L
.47652 .20604 L
.47752 .20604 L
.47852 .20604 L
.47952 .20604 L
.48052 .20604 L
.48152 .20604 L
.48252 .20604 L
.48352 .20604 L
.48452 .20605 L
.48551 .20604 L
.48651 .20604 L
.48751 .20604 L
.48851 .20604 L
.48951 .20604 L
.49051 .20604 L
.49151 .20605 L
.49251 .20604 L
.49351 .20605 L
.49451 .20605 L
.4955 .20605 L
.4965 .20605 L
.4975 .20604 L
.4985 .20604 L
Mistroke
.4995 .20604 L
.5005 .20604 L
.5015 .20604 L
.5025 .20604 L
.5035 .20604 L
.5045 .20604 L
.50549 .20604 L
.50649 .20604 L
.50749 .20604 L
.50849 .20604 L
.50949 .20604 L
.51049 .20604 L
.51149 .20604 L
.51249 .20604 L
.51349 .20604 L
.51449 .20604 L
.51548 .20604 L
.51648 .20604 L
.51748 .20604 L
.51848 .20604 L
.51948 .20604 L
.52048 .20604 L
.52148 .20604 L
.52248 .20604 L
.52348 .20604 L
.52448 .20604 L
.52547 .20604 L
.52647 .20604 L
.52747 .20604 L
.52847 .20604 L
.52947 .20604 L
.53047 .20605 L
.53147 .20605 L
.53247 .20605 L
.53347 .20605 L
.53447 .20605 L
.53546 .20605 L
.53646 .20605 L
.53746 .20605 L
.53846 .20605 L
.53946 .20604 L
.54046 .20604 L
.54146 .20604 L
.54246 .20604 L
.54346 .20604 L
.54446 .20604 L
.54545 .20604 L
.54645 .20604 L
.54745 .20604 L
.54845 .20604 L
Mistroke
.54945 .20604 L
.55045 .20604 L
.55145 .20604 L
.55245 .20604 L
.55345 .20604 L
.55445 .20604 L
.55544 .20605 L
.55644 .20605 L
.55744 .20604 L
.55844 .20605 L
.55944 .20605 L
.56044 .20605 L
.56144 .20605 L
.56244 .20604 L
.56344 .20604 L
.56444 .20604 L
.56543 .20604 L
.56643 .20604 L
.56743 .20604 L
.56843 .20604 L
.56943 .20604 L
.57043 .20604 L
.57143 .20605 L
.57243 .20605 L
.57343 .20605 L
.57443 .20605 L
.57542 .20605 L
.57642 .20605 L
.57742 .20605 L
.57842 .20605 L
.57942 .20605 L
.58042 .20605 L
.58142 .20605 L
.58242 .20605 L
.58342 .20605 L
.58442 .20604 L
.58541 .20604 L
.58641 .20604 L
.58741 .20605 L
.58841 .20604 L
.58941 .20605 L
.59041 .20605 L
.59141 .20605 L
.59241 .20605 L
.59341 .20605 L
.59441 .20605 L
.5954 .20604 L
.5964 .20604 L
.5974 .20604 L
.5984 .20604 L
Mistroke
.5994 .20605 L
.6004 .20605 L
.6014 .20605 L
.6024 .20605 L
.6034 .20605 L
.6044 .20605 L
.60539 .20605 L
.60639 .20605 L
.60739 .20605 L
.60839 .20605 L
.60939 .20605 L
.61039 .20604 L
.61139 .20604 L
.61239 .20604 L
.61339 .20604 L
.61439 .20604 L
.61538 .20604 L
.61638 .20604 L
.61738 .20604 L
.61838 .20604 L
.61938 .20604 L
.62038 .20604 L
.62138 .20604 L
.62238 .20604 L
.62338 .20604 L
.62438 .20604 L
.62537 .20604 L
.62637 .20604 L
.62737 .20604 L
.62837 .20604 L
.62937 .20604 L
.63037 .20605 L
.63137 .20605 L
.63237 .20605 L
.63337 .20605 L
.63437 .20605 L
.63536 .20605 L
.63636 .20605 L
.63736 .20605 L
.63836 .20605 L
.63936 .20605 L
.64036 .20605 L
.64136 .20605 L
.64236 .20605 L
.64336 .20605 L
.64436 .20605 L
.64535 .20605 L
.64635 .20605 L
.64735 .20605 L
.64835 .20605 L
Mistroke
.64935 .20605 L
.65035 .20605 L
.65135 .20605 L
.65235 .20605 L
.65335 .20605 L
.65435 .20605 L
.65534 .20605 L
.65634 .20605 L
.65734 .20605 L
.65834 .20605 L
.65934 .20605 L
.66034 .20605 L
.66134 .20605 L
.66234 .20605 L
.66334 .20605 L
.66434 .20605 L
.66533 .20605 L
.66633 .20605 L
.66733 .20605 L
.66833 .20605 L
.66933 .20605 L
.67033 .20605 L
.67133 .20605 L
.67233 .20605 L
.67333 .20605 L
.67433 .20605 L
.67532 .20605 L
.67632 .20605 L
.67732 .20605 L
.67832 .20605 L
.67932 .20605 L
.68032 .20605 L
.68132 .20605 L
.68232 .20605 L
.68332 .20605 L
.68432 .20605 L
.68531 .20605 L
.68631 .20605 L
.68731 .20605 L
.68831 .20605 L
.68931 .20605 L
.69031 .20605 L
.69131 .20605 L
.69231 .20605 L
.69331 .20605 L
.69431 .20605 L
.6953 .20605 L
.6963 .20605 L
.6973 .20605 L
.6983 .20605 L
Mistroke
.6993 .20605 L
.7003 .20605 L
.7013 .20605 L
.7023 .20605 L
.7033 .20605 L
.7043 .20605 L
.70529 .20605 L
.70629 .20605 L
.70729 .20605 L
.70829 .20605 L
.70929 .20605 L
.71029 .20605 L
.71129 .20605 L
.71229 .20605 L
.71329 .20605 L
.71429 .20605 L
.71528 .20605 L
.71628 .20605 L
.71728 .20604 L
.71828 .20604 L
.71928 .20604 L
.72028 .20604 L
.72128 .20605 L
.72228 .20605 L
.72328 .20605 L
.72428 .20605 L
.72527 .20605 L
.72627 .20605 L
.72727 .20605 L
.72827 .20605 L
.72927 .20605 L
.73027 .20605 L
.73127 .20605 L
.73227 .20605 L
.73327 .20605 L
.73427 .20605 L
.73526 .20605 L
.73626 .20605 L
.73726 .20605 L
.73826 .20605 L
.73926 .20605 L
.74026 .20605 L
.74126 .20605 L
.74226 .20605 L
.74326 .20605 L
.74426 .20605 L
.74525 .20605 L
.74625 .20605 L
.74725 .20605 L
.74825 .20605 L
Mistroke
.74925 .20605 L
.75025 .20605 L
.75125 .20605 L
.75225 .20605 L
.75325 .20605 L
.75425 .20606 L
.75524 .20606 L
.75624 .20606 L
.75724 .20606 L
.75824 .20606 L
.75924 .20605 L
.76024 .20605 L
.76124 .20605 L
.76224 .20605 L
.76324 .20606 L
.76424 .20606 L
.76523 .20606 L
.76623 .20606 L
.76723 .20606 L
.76823 .20606 L
.76923 .20606 L
.77023 .20606 L
.77123 .20606 L
.77223 .20606 L
.77323 .20606 L
.77423 .20606 L
.77522 .20606 L
.77622 .20606 L
.77722 .20606 L
.77822 .20606 L
.77922 .20606 L
.78022 .20606 L
.78122 .20606 L
.78222 .20606 L
.78322 .20606 L
.78422 .20606 L
.78521 .20606 L
.78621 .20606 L
.78721 .20606 L
.78821 .20606 L
.78921 .20606 L
.79021 .20606 L
.79121 .20606 L
.79221 .20606 L
.79321 .20606 L
.79421 .20606 L
.7952 .20606 L
.7962 .20606 L
.7972 .20606 L
.7982 .20606 L
Mistroke
.7992 .20606 L
.8002 .20606 L
.8012 .20607 L
.8022 .20606 L
.8032 .20607 L
.8042 .20607 L
.80519 .20606 L
.80619 .20606 L
.80719 .20606 L
.80819 .20606 L
.80919 .20606 L
.81019 .20606 L
.81119 .20607 L
.81219 .20607 L
.81319 .20607 L
.81419 .20607 L
.81518 .20607 L
.81618 .20607 L
.81718 .20606 L
.81818 .20606 L
.81918 .20606 L
.82018 .20606 L
.82118 .20606 L
.82218 .20606 L
.82318 .20606 L
.82418 .20606 L
.82517 .20606 L
.82617 .20606 L
.82717 .20606 L
.82817 .20606 L
.82917 .20606 L
.83017 .20606 L
.83117 .20606 L
.83217 .20606 L
.83317 .20607 L
.83417 .20607 L
.83516 .20607 L
.83616 .20607 L
.83716 .20607 L
.83816 .20607 L
.83916 .20607 L
.84016 .20607 L
.84116 .20606 L
.84216 .20606 L
.84316 .20606 L
.84416 .20606 L
.84515 .20606 L
.84615 .20607 L
.84715 .20606 L
.84815 .20606 L
Mistroke
.84915 .20606 L
.85015 .20606 L
.85115 .20606 L
.85215 .20606 L
.85315 .20606 L
.85415 .20607 L
.85514 .20607 L
.85614 .20607 L
.85714 .20607 L
.85814 .20607 L
.85914 .20607 L
.86014 .20607 L
.86114 .20607 L
.86214 .20607 L
.86314 .20607 L
.86414 .20607 L
.86513 .20607 L
.86613 .20607 L
.86713 .20607 L
.86813 .20607 L
.86913 .20607 L
.87013 .20607 L
.87113 .20607 L
.87213 .20607 L
.87313 .20607 L
.87413 .20607 L
.87512 .20607 L
.87612 .20607 L
.87712 .20607 L
.87812 .20607 L
.87912 .20607 L
.88012 .20607 L
.88112 .20607 L
.88212 .20607 L
.88312 .20607 L
.88412 .20607 L
.88511 .20607 L
.88611 .20607 L
.88711 .20607 L
.88811 .20607 L
.88911 .20607 L
.89011 .20607 L
.89111 .20607 L
.89211 .20607 L
.89311 .20607 L
.89411 .20607 L
.8951 .20607 L
.8961 .20607 L
.8971 .20607 L
.8981 .20607 L
Mistroke
.8991 .20606 L
.9001 .20607 L
.9011 .20607 L
.9021 .20606 L
.9031 .20606 L
.9041 .20606 L
.90509 .20606 L
.90609 .20606 L
.90709 .20606 L
.90809 .20606 L
.90909 .20606 L
.91009 .20606 L
.91109 .20606 L
.91209 .20606 L
.91309 .20606 L
.91409 .20606 L
.91508 .20606 L
.91608 .20606 L
.91708 .20606 L
.91808 .20606 L
.91908 .20606 L
.92008 .20606 L
.92108 .20607 L
.92208 .20606 L
.92308 .20606 L
.92408 .20606 L
.92507 .20606 L
.92607 .20606 L
.92707 .20606 L
.92807 .20606 L
.92907 .20606 L
.93007 .20606 L
.93107 .20606 L
.93207 .20606 L
.93307 .20606 L
.93407 .20606 L
.93506 .20606 L
.93606 .20606 L
.93706 .20606 L
.93806 .20606 L
.93906 .20606 L
.94006 .20606 L
.94106 .20606 L
.94206 .20606 L
.94306 .20606 L
.94406 .20606 L
.94505 .20606 L
.94605 .20606 L
.94705 .20606 L
.94805 .20606 L
Mistroke
.94905 .20606 L
.95005 .20606 L
.95105 .20606 L
.95205 .20606 L
.95305 .20606 L
.95405 .20606 L
.95504 .20606 L
.95604 .20606 L
.95704 .20606 L
.95804 .20606 L
.95904 .20606 L
.96004 .20606 L
.96104 .20606 L
.96204 .20606 L
.96304 .20606 L
.96404 .20606 L
.96503 .20606 L
.96603 .20606 L
.96703 .20606 L
.96803 .20606 L
.96903 .20607 L
.97003 .20607 L
.97103 .20607 L
.97203 .20606 L
.97303 .20606 L
.97403 .20606 L
.97502 .20606 L
.97602 .20606 L
.97702 .20606 L
.97802 .20606 L
.97902 .20606 L
.98002 .20606 L
.98102 .20606 L
.98202 .20606 L
.98302 .20606 L
.98402 .20606 L
.98501 .20606 L
.98601 .20606 L
.98701 .20606 L
.98801 .20606 L
.98901 .20606 L
.99001 .20606 L
.99101 .20606 L
.99201 .20606 L
.99301 .20606 L
.99401 .20607 L
.995 .20607 L
.996 .20607 L
.997 .20607 L
.998 .20607 L
Mistroke
.999 .20607 L
Mfstroke
0 .98 .604 r
gsave
.999 .19682 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .13185 m
.001 .13185 L
.002 .13185 L
.003 .13185 L
.004 .13185 L
.005 .13185 L
.00599 .13185 L
.00699 .13185 L
.00799 .13185 L
.00899 .13185 L
.00999 .13185 L
.01099 .13185 L
.01199 .13185 L
.01299 .13185 L
.01399 .13185 L
.01499 .13185 L
.01598 .13185 L
.01698 .13185 L
.01798 .13185 L
.01898 .13185 L
.01998 .13185 L
.02098 .13185 L
.02198 .13185 L
.02298 .13185 L
.02398 .13185 L
.02498 .13185 L
.02597 .13185 L
.02697 .13185 L
.02797 .13185 L
.02897 .13185 L
.02997 .13185 L
.03097 .13185 L
.03197 .13185 L
.03297 .13185 L
.03397 .13185 L
.03497 .13185 L
.03596 .13185 L
.03696 .13185 L
.03796 .13185 L
.03896 .13185 L
.03996 .13185 L
.04096 .13185 L
.04196 .13185 L
.04296 .13185 L
.04396 .13185 L
.04496 .13185 L
.04595 .13185 L
.04695 .13185 L
.04795 .13185 L
.04895 .13185 L
Mistroke
.04995 .082 L
.05095 .082 L
.05195 .082 L
.05295 .082 L
.05395 .082 L
.05495 .082 L
.05594 .082 L
.05694 .082 L
.05794 .082 L
.05894 .082 L
.05994 .082 L
.06094 .082 L
.06194 .082 L
.06294 .082 L
.06394 .082 L
.06494 .082 L
.06593 .082 L
.06693 .082 L
.06793 .082 L
.06893 .082 L
.06993 .082 L
.07093 .082 L
.07193 .082 L
.07293 .082 L
.07393 .082 L
.07493 .082 L
.07592 .082 L
.07692 .082 L
.07792 .082 L
.07892 .082 L
.07992 .082 L
.08092 .082 L
.08192 .082 L
.08292 .082 L
.08392 .082 L
.08492 .082 L
.08591 .082 L
.08691 .082 L
.08791 .082 L
.08891 .082 L
.08991 .082 L
.09091 .082 L
.09191 .082 L
.09291 .082 L
.09391 .082 L
.09491 .082 L
.0959 .082 L
.0969 .082 L
.0979 .082 L
.0989 .082 L
Mistroke
.0999 .17835 L
.1009 .17835 L
.1019 .17835 L
.1029 .17835 L
.1039 .17835 L
.1049 .17835 L
.10589 .17835 L
.10689 .17835 L
.10789 .17835 L
.10889 .17835 L
.10989 .17835 L
.11089 .17835 L
.11189 .17835 L
.11289 .17835 L
.11389 .17835 L
.11489 .17835 L
.11588 .17835 L
.11688 .17835 L
.11788 .17835 L
.11888 .17835 L
.11988 .17835 L
.12088 .17835 L
.12188 .17835 L
.12288 .17835 L
.12388 .17835 L
.12488 .17835 L
.12587 .17835 L
.12687 .17835 L
.12787 .17835 L
.12887 .17835 L
.12987 .17835 L
.13087 .17835 L
.13187 .17835 L
.13287 .17835 L
.13387 .17835 L
.13487 .17835 L
.13586 .17835 L
.13686 .17835 L
.13786 .17835 L
.13886 .17835 L
.13986 .17835 L
.14086 .17835 L
.14186 .17835 L
.14286 .17835 L
.14386 .17835 L
.14486 .17835 L
.14585 .17835 L
.14685 .17835 L
.14785 .17835 L
.14885 .17835 L
Mistroke
.14985 .205 L
.15085 .205 L
.15185 .205 L
.15285 .205 L
.15385 .205 L
.15485 .205 L
.15584 .205 L
.15684 .205 L
.15784 .205 L
.15884 .205 L
.15984 .205 L
.16084 .205 L
.16184 .205 L
.16284 .205 L
.16384 .205 L
.16484 .205 L
.16583 .205 L
.16683 .205 L
.16783 .205 L
.16883 .205 L
.16983 .205 L
.17083 .205 L
.17183 .205 L
.17283 .205 L
.17383 .205 L
.17483 .205 L
.17582 .205 L
.17682 .205 L
.17782 .205 L
.17882 .205 L
.17982 .205 L
.18082 .205 L
.18182 .205 L
.18282 .205 L
.18382 .205 L
.18482 .205 L
.18581 .205 L
.18681 .205 L
.18781 .205 L
.18881 .205 L
.18981 .205 L
.19081 .205 L
.19181 .205 L
.19281 .205 L
.19381 .205 L
.19481 .205 L
.1958 .205 L
.1968 .205 L
.1978 .205 L
.1988 .205 L
Mistroke
.1998 .20803 L
.2008 .20803 L
.2018 .20803 L
.2028 .20803 L
.2038 .20803 L
.2048 .20803 L
.20579 .20803 L
.20679 .20803 L
.20779 .20803 L
.20879 .20803 L
.20979 .20803 L
.21079 .20803 L
.21179 .20803 L
.21279 .20803 L
.21379 .20803 L
.21479 .20803 L
.21578 .20803 L
.21678 .20803 L
.21778 .20803 L
.21878 .20803 L
.21978 .20803 L
.22078 .20803 L
.22178 .20803 L
.22278 .20803 L
.22378 .20803 L
.22478 .20803 L
.22577 .20803 L
.22677 .20803 L
.22777 .20803 L
.22877 .20803 L
.22977 .20803 L
.23077 .20803 L
.23177 .20803 L
.23277 .20803 L
.23377 .20803 L
.23477 .20803 L
.23576 .20803 L
.23676 .20803 L
.23776 .20803 L
.23876 .20803 L
.23976 .20803 L
.24076 .20803 L
.24176 .20803 L
.24276 .20803 L
.24376 .20803 L
.24476 .20803 L
.24575 .20803 L
.24675 .20803 L
.24775 .20803 L
.24875 .20803 L
Mistroke
.24975 .18763 L
.25075 .18763 L
.25175 .18763 L
.25275 .18763 L
.25375 .18763 L
.25475 .18763 L
.25574 .18763 L
.25674 .18763 L
.25774 .18763 L
.25874 .18763 L
.25974 .18763 L
.26074 .18763 L
.26174 .18763 L
.26274 .18763 L
.26374 .18763 L
.26474 .18763 L
.26573 .18763 L
.26673 .18763 L
.26773 .18763 L
.26873 .18763 L
.26973 .18763 L
.27073 .18763 L
.27173 .18763 L
.27273 .18763 L
.27373 .18763 L
.27473 .18763 L
.27572 .18763 L
.27672 .18763 L
.27772 .18763 L
.27872 .18763 L
.27972 .18763 L
.28072 .18763 L
.28172 .18763 L
.28272 .18763 L
.28372 .18763 L
.28472 .18763 L
.28571 .18763 L
.28671 .18763 L
.28771 .18763 L
.28871 .18763 L
.28971 .18763 L
.29071 .18763 L
.29171 .18763 L
.29271 .18763 L
.29371 .18763 L
.29471 .18763 L
.2957 .18763 L
.2967 .18763 L
.2977 .18763 L
.2987 .18763 L
Mistroke
.2997 .18813 L
.3007 .18813 L
.3017 .18813 L
.3027 .18813 L
.3037 .18813 L
.3047 .18813 L
.30569 .18813 L
.30669 .18813 L
.30769 .18813 L
.30869 .18813 L
.30969 .18813 L
.31069 .18813 L
.31169 .18813 L
.31269 .18813 L
.31369 .18813 L
.31469 .18813 L
.31568 .18813 L
.31668 .18813 L
.31768 .18813 L
.31868 .18813 L
.31968 .18813 L
.32068 .18813 L
.32168 .18813 L
.32268 .18813 L
.32368 .18813 L
.32468 .18813 L
.32567 .18813 L
.32667 .18813 L
.32767 .18813 L
.32867 .18813 L
.32967 .18813 L
.33067 .18813 L
.33167 .18813 L
.33267 .18813 L
.33367 .18813 L
.33467 .18813 L
.33566 .18813 L
.33666 .18813 L
.33766 .18813 L
.33866 .18813 L
.33966 .18813 L
.34066 .18813 L
.34166 .18813 L
.34266 .18813 L
.34366 .18813 L
.34466 .18813 L
.34565 .18813 L
.34665 .18813 L
.34765 .18813 L
.34865 .18813 L
Mistroke
.34965 .18514 L
.35065 .18514 L
.35165 .18514 L
.35265 .18514 L
.35365 .18514 L
.35465 .18514 L
.35564 .18514 L
.35664 .18514 L
.35764 .18514 L
.35864 .18514 L
.35964 .18514 L
.36064 .18514 L
.36164 .18514 L
.36264 .18514 L
.36364 .18514 L
.36464 .18514 L
.36563 .18514 L
.36663 .18514 L
.36763 .18514 L
.36863 .18514 L
.36963 .18514 L
.37063 .18514 L
.37163 .18514 L
.37263 .18514 L
.37363 .18514 L
.37463 .18514 L
.37562 .18514 L
.37662 .18514 L
.37762 .18514 L
.37862 .18514 L
.37962 .18514 L
.38062 .18514 L
.38162 .18514 L
.38262 .18514 L
.38362 .18514 L
.38462 .18514 L
.38561 .18514 L
.38661 .18514 L
.38761 .18514 L
.38861 .18514 L
.38961 .18514 L
.39061 .18514 L
.39161 .18514 L
.39261 .18514 L
.39361 .18514 L
.39461 .18514 L
.3956 .18514 L
.3966 .18514 L
.3976 .18514 L
.3986 .18514 L
Mistroke
.3996 .17141 L
.4006 .17141 L
.4016 .17141 L
.4026 .17141 L
.4036 .17141 L
.4046 .17141 L
.40559 .17141 L
.40659 .17141 L
.40759 .17141 L
.40859 .17141 L
.40959 .17141 L
.41059 .17141 L
.41159 .17141 L
.41259 .17141 L
.41359 .17141 L
.41459 .17141 L
.41558 .17141 L
.41658 .17141 L
.41758 .17141 L
.41858 .17141 L
.41958 .17141 L
.42058 .17141 L
.42158 .17141 L
.42258 .17141 L
.42358 .17141 L
.42458 .17141 L
.42557 .17141 L
.42657 .17141 L
.42757 .17141 L
.42857 .17141 L
.42957 .17141 L
.43057 .17141 L
.43157 .17141 L
.43257 .17141 L
.43357 .17141 L
.43457 .17141 L
.43556 .17141 L
.43656 .17141 L
.43756 .17141 L
.43856 .17141 L
.43956 .17141 L
.44056 .17141 L
.44156 .17141 L
.44256 .17141 L
.44356 .17141 L
.44456 .17141 L
.44555 .17141 L
.44655 .17141 L
.44755 .17141 L
.44855 .17141 L
Mistroke
.44955 .16798 L
.45055 .16798 L
.45155 .16798 L
.45255 .16798 L
.45355 .16798 L
.45455 .16798 L
.45554 .16798 L
.45654 .16798 L
.45754 .16798 L
.45854 .16798 L
.45954 .16798 L
.46054 .16798 L
.46154 .16798 L
.46254 .16798 L
.46354 .16798 L
.46454 .16798 L
.46553 .16798 L
.46653 .16798 L
.46753 .16798 L
.46853 .16798 L
.46953 .16798 L
.47053 .16798 L
.47153 .16798 L
.47253 .16798 L
.47353 .16798 L
.47453 .16798 L
.47552 .16798 L
.47652 .16798 L
.47752 .16798 L
.47852 .16798 L
.47952 .16798 L
.48052 .16798 L
.48152 .16798 L
.48252 .16798 L
.48352 .16798 L
.48452 .16798 L
.48551 .16798 L
.48651 .16798 L
.48751 .16798 L
.48851 .16798 L
.48951 .16798 L
.49051 .16798 L
.49151 .16798 L
.49251 .16798 L
.49351 .16798 L
.49451 .16798 L
.4955 .16798 L
.4965 .16798 L
.4975 .16798 L
.4985 .16798 L
Mistroke
.4995 .17683 L
.5005 .17683 L
.5015 .17683 L
.5025 .17683 L
.5035 .17683 L
.5045 .17683 L
.50549 .17683 L
.50649 .17683 L
.50749 .17683 L
.50849 .17683 L
.50949 .17683 L
.51049 .17683 L
.51149 .17683 L
.51249 .17683 L
.51349 .17683 L
.51449 .17683 L
.51548 .17683 L
.51648 .17683 L
.51748 .17683 L
.51848 .17683 L
.51948 .17683 L
.52048 .17683 L
.52148 .17683 L
.52248 .17683 L
.52348 .17683 L
.52448 .17683 L
.52547 .17683 L
.52647 .17683 L
.52747 .17683 L
.52847 .17683 L
.52947 .17683 L
.53047 .17683 L
.53147 .17683 L
.53247 .17683 L
.53347 .17683 L
.53447 .17683 L
.53546 .17683 L
.53646 .17683 L
.53746 .17683 L
.53846 .17683 L
.53946 .17683 L
.54046 .17683 L
.54146 .17683 L
.54246 .17683 L
.54346 .17683 L
.54446 .17683 L
.54545 .17683 L
.54645 .17683 L
.54745 .17683 L
.54845 .17683 L
Mistroke
.54945 .18238 L
.55045 .18238 L
.55145 .18238 L
.55245 .18238 L
.55345 .18238 L
.55445 .18238 L
.55544 .18238 L
.55644 .18238 L
.55744 .18238 L
.55844 .18238 L
.55944 .18238 L
.56044 .18238 L
.56144 .18238 L
.56244 .18238 L
.56344 .18238 L
.56444 .18238 L
.56543 .18238 L
.56643 .18238 L
.56743 .18238 L
.56843 .18238 L
.56943 .18238 L
.57043 .18238 L
.57143 .18238 L
.57243 .18238 L
.57343 .18238 L
.57443 .18238 L
.57542 .18238 L
.57642 .18238 L
.57742 .18238 L
.57842 .18238 L
.57942 .18238 L
.58042 .18238 L
.58142 .18238 L
.58242 .18238 L
.58342 .18238 L
.58442 .18238 L
.58541 .18238 L
.58641 .18238 L
.58741 .18238 L
.58841 .18238 L
.58941 .18238 L
.59041 .18238 L
.59141 .18238 L
.59241 .18238 L
.59341 .18238 L
.59441 .18238 L
.5954 .18238 L
.5964 .18238 L
.5974 .18238 L
.5984 .18238 L
Mistroke
.5994 .1839 L
.6004 .1839 L
.6014 .1839 L
.6024 .1839 L
.6034 .1839 L
.6044 .1839 L
.60539 .1839 L
.60639 .1839 L
.60739 .1839 L
.60839 .1839 L
.60939 .1839 L
.61039 .1839 L
.61139 .1839 L
.61239 .1839 L
.61339 .1839 L
.61439 .1839 L
.61538 .1839 L
.61638 .1839 L
.61738 .1839 L
.61838 .1839 L
.61938 .1839 L
.62038 .1839 L
.62138 .1839 L
.62238 .1839 L
.62338 .1839 L
.62438 .1839 L
.62537 .1839 L
.62637 .1839 L
.62737 .1839 L
.62837 .1839 L
.62937 .1839 L
.63037 .1839 L
.63137 .1839 L
.63237 .1839 L
.63337 .1839 L
.63437 .1839 L
.63536 .1839 L
.63636 .1839 L
.63736 .1839 L
.63836 .1839 L
.63936 .1839 L
.64036 .1839 L
.64136 .1839 L
.64236 .1839 L
.64336 .1839 L
.64436 .1839 L
.64535 .1839 L
.64635 .1839 L
.64735 .1839 L
.64835 .1839 L
Mistroke
.64935 .18475 L
.65035 .18475 L
.65135 .18475 L
.65235 .18475 L
.65335 .18475 L
.65435 .18475 L
.65534 .18475 L
.65634 .18475 L
.65734 .18475 L
.65834 .18475 L
.65934 .18475 L
.66034 .18475 L
.66134 .18475 L
.66234 .18475 L
.66334 .18475 L
.66434 .18475 L
.66533 .18475 L
.66633 .18475 L
.66733 .18475 L
.66833 .18475 L
.66933 .18475 L
.67033 .18475 L
.67133 .18475 L
.67233 .18475 L
.67333 .18475 L
.67433 .18475 L
.67532 .18475 L
.67632 .18475 L
.67732 .18475 L
.67832 .18475 L
.67932 .18475 L
.68032 .18475 L
.68132 .18475 L
.68232 .18475 L
.68332 .18475 L
.68432 .18475 L
.68531 .18475 L
.68631 .18475 L
.68731 .18475 L
.68831 .18475 L
.68931 .18475 L
.69031 .18475 L
.69131 .18475 L
.69231 .18475 L
.69331 .18475 L
.69431 .18475 L
.6953 .18475 L
.6963 .18475 L
.6973 .18475 L
.6983 .18475 L
Mistroke
.6993 .18453 L
.7003 .18453 L
.7013 .18453 L
.7023 .18453 L
.7033 .18453 L
.7043 .18453 L
.70529 .18453 L
.70629 .18453 L
.70729 .18453 L
.70829 .18453 L
.70929 .18453 L
.71029 .18453 L
.71129 .18453 L
.71229 .18453 L
.71329 .18453 L
.71429 .18453 L
.71528 .18453 L
.71628 .18453 L
.71728 .18453 L
.71828 .18453 L
.71928 .18453 L
.72028 .18453 L
.72128 .18453 L
.72228 .18453 L
.72328 .18453 L
.72428 .18453 L
.72527 .18453 L
.72627 .18453 L
.72727 .18453 L
.72827 .18453 L
.72927 .18453 L
.73027 .18453 L
.73127 .18453 L
.73227 .18453 L
.73327 .18453 L
.73427 .18453 L
.73526 .18453 L
.73626 .18453 L
.73726 .18453 L
.73826 .18453 L
.73926 .18453 L
.74026 .18453 L
.74126 .18453 L
.74226 .18453 L
.74326 .18453 L
.74426 .18453 L
.74525 .18453 L
.74625 .18453 L
.74725 .18453 L
.74825 .18453 L
Mistroke
.74925 .18801 L
.75025 .18801 L
.75125 .18801 L
.75225 .18801 L
.75325 .18801 L
.75425 .18801 L
.75524 .18801 L
.75624 .18801 L
.75724 .18801 L
.75824 .18801 L
.75924 .18801 L
.76024 .18801 L
.76124 .18801 L
.76224 .18801 L
.76324 .18801 L
.76424 .18801 L
.76523 .18801 L
.76623 .18801 L
.76723 .18801 L
.76823 .18801 L
.76923 .18801 L
.77023 .18801 L
.77123 .18801 L
.77223 .18801 L
.77323 .18801 L
.77423 .18801 L
.77522 .18801 L
.77622 .18801 L
.77722 .18801 L
.77822 .18801 L
.77922 .18801 L
.78022 .18801 L
.78122 .18801 L
.78222 .18801 L
.78322 .18801 L
.78422 .18801 L
.78521 .18801 L
.78621 .18801 L
.78721 .18801 L
.78821 .18801 L
.78921 .18801 L
.79021 .18801 L
.79121 .18801 L
.79221 .18801 L
.79321 .18801 L
.79421 .18801 L
.7952 .18801 L
.7962 .18801 L
.7972 .18801 L
.7982 .18801 L
Mistroke
.7992 .18982 L
.8002 .18982 L
.8012 .18982 L
.8022 .18982 L
.8032 .18982 L
.8042 .18982 L
.80519 .18982 L
.80619 .18982 L
.80719 .18982 L
.80819 .18982 L
.80919 .18982 L
.81019 .18982 L
.81119 .18982 L
.81219 .18982 L
.81319 .18982 L
.81419 .18982 L
.81518 .18982 L
.81618 .18982 L
.81718 .18982 L
.81818 .18982 L
.81918 .18982 L
.82018 .18982 L
.82118 .18982 L
.82218 .18982 L
.82318 .18982 L
.82418 .18982 L
.82517 .18982 L
.82617 .18982 L
.82717 .18982 L
.82817 .18982 L
.82917 .18982 L
.83017 .18982 L
.83117 .18982 L
.83217 .18982 L
.83317 .18982 L
.83417 .18982 L
.83516 .18982 L
.83616 .18982 L
.83716 .18982 L
.83816 .18982 L
.83916 .18982 L
.84016 .18982 L
.84116 .18982 L
.84216 .18982 L
.84316 .18982 L
.84416 .18982 L
.84515 .18982 L
.84615 .18982 L
.84715 .18982 L
.84815 .18982 L
Mistroke
.84915 .19264 L
.85015 .19264 L
.85115 .19264 L
.85215 .19264 L
.85315 .19264 L
.85415 .19264 L
.85514 .19264 L
.85614 .19264 L
.85714 .19264 L
.85814 .19264 L
.85914 .19264 L
.86014 .19264 L
.86114 .19264 L
.86214 .19264 L
.86314 .19264 L
.86414 .19264 L
.86513 .19264 L
.86613 .19264 L
.86713 .19264 L
.86813 .19264 L
.86913 .19264 L
.87013 .19264 L
.87113 .19264 L
.87213 .19264 L
.87313 .19264 L
.87413 .19264 L
.87512 .19264 L
.87612 .19264 L
.87712 .19264 L
.87812 .19264 L
.87912 .19264 L
.88012 .19264 L
.88112 .19264 L
.88212 .19264 L
.88312 .19264 L
.88412 .19264 L
.88511 .19264 L
.88611 .19264 L
.88711 .19264 L
.88811 .19264 L
.88911 .19264 L
.89011 .19264 L
.89111 .19264 L
.89211 .19264 L
.89311 .19264 L
.89411 .19264 L
.8951 .19264 L
.8961 .19264 L
.8971 .19264 L
.8981 .19264 L
Mistroke
.8991 .19402 L
.9001 .19402 L
.9011 .19402 L
.9021 .19402 L
.9031 .19402 L
.9041 .19402 L
.90509 .19402 L
.90609 .19402 L
.90709 .19402 L
.90809 .19402 L
.90909 .19402 L
.91009 .19402 L
.91109 .19402 L
.91209 .19402 L
.91309 .19402 L
.91409 .19402 L
.91508 .19402 L
.91608 .19402 L
.91708 .19402 L
.91808 .19402 L
.91908 .19402 L
.92008 .19402 L
.92108 .19402 L
.92208 .19402 L
.92308 .19402 L
.92408 .19402 L
.92507 .19402 L
.92607 .19402 L
.92707 .19402 L
.92807 .19402 L
.92907 .19402 L
.93007 .19402 L
.93107 .19402 L
.93207 .19402 L
.93307 .19402 L
.93407 .19402 L
.93506 .19402 L
.93606 .19402 L
.93706 .19402 L
.93806 .19402 L
.93906 .19402 L
.94006 .19402 L
.94106 .19402 L
.94206 .19402 L
.94306 .19402 L
.94406 .19402 L
.94505 .19402 L
.94605 .19402 L
.94705 .19402 L
.94805 .19402 L
Mistroke
.94905 .19566 L
.95005 .19566 L
.95105 .19566 L
.95205 .19566 L
.95305 .19566 L
.95405 .19566 L
.95504 .19566 L
.95604 .19566 L
.95704 .19566 L
.95804 .19566 L
.95904 .19566 L
.96004 .19566 L
.96104 .19566 L
.96204 .19566 L
.96304 .19566 L
.96404 .19566 L
.96503 .19566 L
.96603 .19566 L
.96703 .19566 L
.96803 .19566 L
.96903 .19566 L
.97003 .19566 L
.97103 .19566 L
.97203 .19566 L
.97303 .19566 L
.97403 .19566 L
.97502 .19566 L
.97602 .19566 L
.97702 .19566 L
.97802 .19566 L
.97902 .19566 L
.98002 .19566 L
.98102 .19566 L
.98202 .19566 L
.98302 .19566 L
.98402 .19566 L
.98501 .19566 L
.98601 .19566 L
.98701 .19566 L
.98801 .19566 L
.98901 .19566 L
.99001 .19566 L
.99101 .19566 L
.99201 .19566 L
.99301 .19566 L
.99401 .19566 L
.995 .19566 L
.996 .19566 L
.997 .19566 L
.998 .19566 L
Mistroke
.999 .19682 L
Mfstroke
gsave
.999 .22833 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .43468 m
.001 .43468 L
.002 .43468 L
.003 .43468 L
.004 .43468 L
.005 .43468 L
.00599 .43468 L
.00699 .43468 L
.00799 .43468 L
.00899 .43468 L
.00999 .43468 L
.01099 .43468 L
.01199 .43468 L
.01299 .43468 L
.01399 .43468 L
.01499 .43468 L
.01598 .43468 L
.01698 .43468 L
.01798 .43468 L
.01898 .43468 L
.01998 .43468 L
.02098 .43468 L
.02198 .43468 L
.02298 .43468 L
.02398 .43468 L
.02498 .43468 L
.02597 .43468 L
.02697 .43468 L
.02797 .43468 L
.02897 .43468 L
.02997 .43468 L
.03097 .43468 L
.03197 .43468 L
.03297 .43468 L
.03397 .43468 L
.03497 .43468 L
.03596 .43468 L
.03696 .43468 L
.03796 .43468 L
.03896 .43468 L
.03996 .43468 L
.04096 .43468 L
.04196 .43468 L
.04296 .43468 L
.04396 .43468 L
.04496 .43468 L
.04595 .43468 L
.04695 .43468 L
.04795 .43468 L
.04895 .43468 L
Mistroke
.04995 .36338 L
.05095 .36338 L
.05195 .36338 L
.05295 .36338 L
.05395 .36338 L
.05495 .36338 L
.05594 .36338 L
.05694 .36338 L
.05794 .36338 L
.05894 .36338 L
.05994 .36338 L
.06094 .36338 L
.06194 .36338 L
.06294 .36338 L
.06394 .36338 L
.06494 .36338 L
.06593 .36338 L
.06693 .36338 L
.06793 .36338 L
.06893 .36338 L
.06993 .36338 L
.07093 .36338 L
.07193 .36338 L
.07293 .36338 L
.07393 .36338 L
.07493 .36338 L
.07592 .36338 L
.07692 .36338 L
.07792 .36338 L
.07892 .36338 L
.07992 .36338 L
.08092 .36338 L
.08192 .36338 L
.08292 .36338 L
.08392 .36338 L
.08492 .36338 L
.08591 .36338 L
.08691 .36338 L
.08791 .36338 L
.08891 .36338 L
.08991 .36338 L
.09091 .36338 L
.09191 .36338 L
.09291 .36338 L
.09391 .36338 L
.09491 .36338 L
.0959 .36338 L
.0969 .36338 L
.0979 .36338 L
.0989 .36338 L
Mistroke
.0999 .27025 L
.1009 .27025 L
.1019 .27025 L
.1029 .27025 L
.1039 .27025 L
.1049 .27025 L
.10589 .27025 L
.10689 .27025 L
.10789 .27025 L
.10889 .27025 L
.10989 .27025 L
.11089 .27025 L
.11189 .27025 L
.11289 .27025 L
.11389 .27025 L
.11489 .27025 L
.11588 .27025 L
.11688 .27025 L
.11788 .27025 L
.11888 .27025 L
.11988 .27025 L
.12088 .27025 L
.12188 .27025 L
.12288 .27025 L
.12388 .27025 L
.12488 .27025 L
.12587 .27025 L
.12687 .27025 L
.12787 .27025 L
.12887 .27025 L
.12987 .27025 L
.13087 .27025 L
.13187 .27025 L
.13287 .27025 L
.13387 .27025 L
.13487 .27025 L
.13586 .27025 L
.13686 .27025 L
.13786 .27025 L
.13886 .27025 L
.13986 .27025 L
.14086 .27025 L
.14186 .27025 L
.14286 .27025 L
.14386 .27025 L
.14486 .27025 L
.14585 .27025 L
.14685 .27025 L
.14785 .27025 L
.14885 .27025 L
Mistroke
.14985 .29091 L
.15085 .29091 L
.15185 .29091 L
.15285 .29091 L
.15385 .29091 L
.15485 .29091 L
.15584 .29091 L
.15684 .29091 L
.15784 .29091 L
.15884 .29091 L
.15984 .29091 L
.16084 .29091 L
.16184 .29091 L
.16284 .29091 L
.16384 .29091 L
.16484 .29091 L
.16583 .29091 L
.16683 .29091 L
.16783 .29091 L
.16883 .29091 L
.16983 .29091 L
.17083 .29091 L
.17183 .29091 L
.17283 .29091 L
.17383 .29091 L
.17483 .29091 L
.17582 .29091 L
.17682 .29091 L
.17782 .29091 L
.17882 .29091 L
.17982 .29091 L
.18082 .29091 L
.18182 .29091 L
.18282 .29091 L
.18382 .29091 L
.18482 .29091 L
.18581 .29091 L
.18681 .29091 L
.18781 .29091 L
.18881 .29091 L
.18981 .29091 L
.19081 .29091 L
.19181 .29091 L
.19281 .29091 L
.19381 .29091 L
.19481 .29091 L
.1958 .29091 L
.1968 .29091 L
.1978 .29091 L
.1988 .29091 L
Mistroke
.1998 .28443 L
.2008 .28443 L
.2018 .28443 L
.2028 .28443 L
.2038 .28443 L
.2048 .28443 L
.20579 .28443 L
.20679 .28443 L
.20779 .28443 L
.20879 .28443 L
.20979 .28443 L
.21079 .28443 L
.21179 .28443 L
.21279 .28443 L
.21379 .28443 L
.21479 .28443 L
.21578 .28443 L
.21678 .28443 L
.21778 .28443 L
.21878 .28443 L
.21978 .28443 L
.22078 .28443 L
.22178 .28443 L
.22278 .28443 L
.22378 .28443 L
.22478 .28443 L
.22577 .28443 L
.22677 .28443 L
.22777 .28443 L
.22877 .28443 L
.22977 .28443 L
.23077 .28443 L
.23177 .28443 L
.23277 .28443 L
.23377 .28443 L
.23477 .28443 L
.23576 .28443 L
.23676 .28443 L
.23776 .28443 L
.23876 .28443 L
.23976 .28443 L
.24076 .28443 L
.24176 .28443 L
.24276 .28443 L
.24376 .28443 L
.24476 .28443 L
.24575 .28443 L
.24675 .28443 L
.24775 .28443 L
.24875 .28443 L
Mistroke
.24975 .24903 L
.25075 .24903 L
.25175 .24903 L
.25275 .24903 L
.25375 .24903 L
.25475 .24903 L
.25574 .24903 L
.25674 .24903 L
.25774 .24903 L
.25874 .24903 L
.25974 .24903 L
.26074 .24903 L
.26174 .24903 L
.26274 .24903 L
.26374 .24903 L
.26474 .24903 L
.26573 .24903 L
.26673 .24903 L
.26773 .24903 L
.26873 .24903 L
.26973 .24903 L
.27073 .24903 L
.27173 .24903 L
.27273 .24903 L
.27373 .24903 L
.27473 .24903 L
.27572 .24903 L
.27672 .24903 L
.27772 .24903 L
.27872 .24903 L
.27972 .24903 L
.28072 .24903 L
.28172 .24903 L
.28272 .24903 L
.28372 .24903 L
.28472 .24903 L
.28571 .24903 L
.28671 .24903 L
.28771 .24903 L
.28871 .24903 L
.28971 .24903 L
.29071 .24903 L
.29171 .24903 L
.29271 .24903 L
.29371 .24903 L
.29471 .24903 L
.2957 .24903 L
.2967 .24903 L
.2977 .24903 L
.2987 .24903 L
Mistroke
.2997 .24789 L
.3007 .24789 L
.3017 .24789 L
.3027 .24789 L
.3037 .24789 L
.3047 .24789 L
.30569 .24789 L
.30669 .24789 L
.30769 .24789 L
.30869 .24789 L
.30969 .24789 L
.31069 .24789 L
.31169 .24789 L
.31269 .24789 L
.31369 .24789 L
.31469 .24789 L
.31568 .24789 L
.31668 .24789 L
.31768 .24789 L
.31868 .24789 L
.31968 .24789 L
.32068 .24789 L
.32168 .24789 L
.32268 .24789 L
.32368 .24789 L
.32468 .24789 L
.32567 .24789 L
.32667 .24789 L
.32767 .24789 L
.32867 .24789 L
.32967 .24789 L
.33067 .24789 L
.33167 .24789 L
.33267 .24789 L
.33367 .24789 L
.33467 .24789 L
.33566 .24789 L
.33666 .24789 L
.33766 .24789 L
.33866 .24789 L
.33966 .24789 L
.34066 .24789 L
.34166 .24789 L
.34266 .24789 L
.34366 .24789 L
.34466 .24789 L
.34565 .24789 L
.34665 .24789 L
.34765 .24789 L
.34865 .24789 L
Mistroke
.34965 .24314 L
.35065 .24314 L
.35165 .24314 L
.35265 .24314 L
.35365 .24314 L
.35465 .24314 L
.35564 .24314 L
.35664 .24314 L
.35764 .24314 L
.35864 .24314 L
.35964 .24314 L
.36064 .24314 L
.36164 .24314 L
.36264 .24314 L
.36364 .24314 L
.36464 .24314 L
.36563 .24314 L
.36663 .24314 L
.36763 .24314 L
.36863 .24314 L
.36963 .24314 L
.37063 .24314 L
.37163 .24314 L
.37263 .24314 L
.37363 .24314 L
.37463 .24314 L
.37562 .24314 L
.37662 .24314 L
.37762 .24314 L
.37862 .24314 L
.37962 .24314 L
.38062 .24314 L
.38162 .24314 L
.38262 .24314 L
.38362 .24314 L
.38462 .24314 L
.38561 .24314 L
.38661 .24314 L
.38761 .24314 L
.38861 .24314 L
.38961 .24314 L
.39061 .24314 L
.39161 .24314 L
.39261 .24314 L
.39361 .24314 L
.39461 .24314 L
.3956 .24314 L
.3966 .24314 L
.3976 .24314 L
.3986 .24314 L
Mistroke
.3996 .22317 L
.4006 .22317 L
.4016 .22317 L
.4026 .22317 L
.4036 .22317 L
.4046 .22317 L
.40559 .22317 L
.40659 .22317 L
.40759 .22317 L
.40859 .22317 L
.40959 .22317 L
.41059 .22317 L
.41159 .22317 L
.41259 .22317 L
.41359 .22317 L
.41459 .22317 L
.41558 .22317 L
.41658 .22317 L
.41758 .22317 L
.41858 .22317 L
.41958 .22317 L
.42058 .22317 L
.42158 .22317 L
.42258 .22317 L
.42358 .22317 L
.42458 .22317 L
.42557 .22317 L
.42657 .22317 L
.42757 .22317 L
.42857 .22317 L
.42957 .22317 L
.43057 .22317 L
.43157 .22317 L
.43257 .22317 L
.43357 .22317 L
.43457 .22317 L
.43556 .22317 L
.43656 .22317 L
.43756 .22317 L
.43856 .22317 L
.43956 .22317 L
.44056 .22317 L
.44156 .22317 L
.44256 .22317 L
.44356 .22317 L
.44456 .22317 L
.44555 .22317 L
.44655 .22317 L
.44755 .22317 L
.44855 .22317 L
Mistroke
.44955 .21547 L
.45055 .21547 L
.45155 .21547 L
.45255 .21547 L
.45355 .21547 L
.45455 .21547 L
.45554 .21547 L
.45654 .21547 L
.45754 .21547 L
.45854 .21547 L
.45954 .21547 L
.46054 .21547 L
.46154 .21547 L
.46254 .21547 L
.46354 .21547 L
.46454 .21547 L
.46553 .21547 L
.46653 .21547 L
.46753 .21547 L
.46853 .21547 L
.46953 .21547 L
.47053 .21547 L
.47153 .21547 L
.47253 .21547 L
.47353 .21547 L
.47453 .21547 L
.47552 .21547 L
.47652 .21547 L
.47752 .21547 L
.47852 .21547 L
.47952 .21547 L
.48052 .21547 L
.48152 .21547 L
.48252 .21547 L
.48352 .21547 L
.48452 .21547 L
.48551 .21547 L
.48651 .21547 L
.48751 .21547 L
.48851 .21547 L
.48951 .21547 L
.49051 .21547 L
.49151 .21547 L
.49251 .21547 L
.49351 .21547 L
.49451 .21547 L
.4955 .21547 L
.4965 .21547 L
.4975 .21547 L
.4985 .21547 L
Mistroke
.4995 .22287 L
.5005 .22287 L
.5015 .22287 L
.5025 .22287 L
.5035 .22287 L
.5045 .22287 L
.50549 .22287 L
.50649 .22287 L
.50749 .22287 L
.50849 .22287 L
.50949 .22287 L
.51049 .22287 L
.51149 .22287 L
.51249 .22287 L
.51349 .22287 L
.51449 .22287 L
.51548 .22287 L
.51648 .22287 L
.51748 .22287 L
.51848 .22287 L
.51948 .22287 L
.52048 .22287 L
.52148 .22287 L
.52248 .22287 L
.52348 .22287 L
.52448 .22287 L
.52547 .22287 L
.52647 .22287 L
.52747 .22287 L
.52847 .22287 L
.52947 .22287 L
.53047 .22287 L
.53147 .22287 L
.53247 .22287 L
.53347 .22287 L
.53447 .22287 L
.53546 .22287 L
.53646 .22287 L
.53746 .22287 L
.53846 .22287 L
.53946 .22287 L
.54046 .22287 L
.54146 .22287 L
.54246 .22287 L
.54346 .22287 L
.54446 .22287 L
.54545 .22287 L
.54645 .22287 L
.54745 .22287 L
.54845 .22287 L
Mistroke
.54945 .22525 L
.55045 .22525 L
.55145 .22525 L
.55245 .22525 L
.55345 .22525 L
.55445 .22525 L
.55544 .22525 L
.55644 .22525 L
.55744 .22525 L
.55844 .22525 L
.55944 .22525 L
.56044 .22525 L
.56144 .22525 L
.56244 .22525 L
.56344 .22525 L
.56444 .22525 L
.56543 .22525 L
.56643 .22525 L
.56743 .22525 L
.56843 .22525 L
.56943 .22525 L
.57043 .22525 L
.57143 .22525 L
.57243 .22525 L
.57343 .22525 L
.57443 .22525 L
.57542 .22525 L
.57642 .22525 L
.57742 .22525 L
.57842 .22525 L
.57942 .22525 L
.58042 .22525 L
.58142 .22525 L
.58242 .22525 L
.58342 .22525 L
.58442 .22525 L
.58541 .22525 L
.58641 .22525 L
.58741 .22525 L
.58841 .22525 L
.58941 .22525 L
.59041 .22525 L
.59141 .22525 L
.59241 .22525 L
.59341 .22525 L
.59441 .22525 L
.5954 .22525 L
.5964 .22525 L
.5974 .22525 L
.5984 .22525 L
Mistroke
.5994 .22367 L
.6004 .22367 L
.6014 .22367 L
.6024 .22367 L
.6034 .22367 L
.6044 .22367 L
.60539 .22367 L
.60639 .22367 L
.60739 .22367 L
.60839 .22367 L
.60939 .22367 L
.61039 .22367 L
.61139 .22367 L
.61239 .22367 L
.61339 .22367 L
.61439 .22367 L
.61538 .22367 L
.61638 .22367 L
.61738 .22367 L
.61838 .22367 L
.61938 .22367 L
.62038 .22367 L
.62138 .22367 L
.62238 .22367 L
.62338 .22367 L
.62438 .22367 L
.62537 .22367 L
.62637 .22367 L
.62737 .22367 L
.62837 .22367 L
.62937 .22367 L
.63037 .22367 L
.63137 .22367 L
.63237 .22367 L
.63337 .22367 L
.63437 .22367 L
.63536 .22367 L
.63636 .22367 L
.63736 .22367 L
.63836 .22367 L
.63936 .22367 L
.64036 .22367 L
.64136 .22367 L
.64236 .22367 L
.64336 .22367 L
.64436 .22367 L
.64535 .22367 L
.64635 .22367 L
.64735 .22367 L
.64835 .22367 L
Mistroke
.64935 .22416 L
.65035 .22416 L
.65135 .22416 L
.65235 .22416 L
.65335 .22416 L
.65435 .22416 L
.65534 .22416 L
.65634 .22416 L
.65734 .22416 L
.65834 .22416 L
.65934 .22416 L
.66034 .22416 L
.66134 .22416 L
.66234 .22416 L
.66334 .22416 L
.66434 .22416 L
.66533 .22416 L
.66633 .22416 L
.66733 .22416 L
.66833 .22416 L
.66933 .22416 L
.67033 .22416 L
.67133 .22416 L
.67233 .22416 L
.67333 .22416 L
.67433 .22416 L
.67532 .22416 L
.67632 .22416 L
.67732 .22416 L
.67832 .22416 L
.67932 .22416 L
.68032 .22416 L
.68132 .22416 L
.68232 .22416 L
.68332 .22416 L
.68432 .22416 L
.68531 .22416 L
.68631 .22416 L
.68731 .22416 L
.68831 .22416 L
.68931 .22416 L
.69031 .22416 L
.69131 .22416 L
.69231 .22416 L
.69331 .22416 L
.69431 .22416 L
.6953 .22416 L
.6963 .22416 L
.6973 .22416 L
.6983 .22416 L
Mistroke
.6993 .22349 L
.7003 .22349 L
.7013 .22349 L
.7023 .22349 L
.7033 .22349 L
.7043 .22349 L
.70529 .22349 L
.70629 .22349 L
.70729 .22349 L
.70829 .22349 L
.70929 .22349 L
.71029 .22349 L
.71129 .22349 L
.71229 .22349 L
.71329 .22349 L
.71429 .22349 L
.71528 .22349 L
.71628 .22349 L
.71728 .22349 L
.71828 .22349 L
.71928 .22349 L
.72028 .22349 L
.72128 .22349 L
.72228 .22349 L
.72328 .22349 L
.72428 .22349 L
.72527 .22349 L
.72627 .22349 L
.72727 .22349 L
.72827 .22349 L
.72927 .22349 L
.73027 .22349 L
.73127 .22349 L
.73227 .22349 L
.73327 .22349 L
.73427 .22349 L
.73526 .22349 L
.73626 .22349 L
.73726 .22349 L
.73826 .22349 L
.73926 .22349 L
.74026 .22349 L
.74126 .22349 L
.74226 .22349 L
.74326 .22349 L
.74426 .22349 L
.74525 .22349 L
.74625 .22349 L
.74725 .22349 L
.74825 .22349 L
Mistroke
.74925 .22634 L
.75025 .22634 L
.75125 .22634 L
.75225 .22634 L
.75325 .22634 L
.75425 .22634 L
.75524 .22634 L
.75624 .22634 L
.75724 .22634 L
.75824 .22634 L
.75924 .22634 L
.76024 .22634 L
.76124 .22634 L
.76224 .22634 L
.76324 .22634 L
.76424 .22634 L
.76523 .22634 L
.76623 .22634 L
.76723 .22634 L
.76823 .22634 L
.76923 .22634 L
.77023 .22634 L
.77123 .22634 L
.77223 .22634 L
.77323 .22634 L
.77423 .22634 L
.77522 .22634 L
.77622 .22634 L
.77722 .22634 L
.77822 .22634 L
.77922 .22634 L
.78022 .22634 L
.78122 .22634 L
.78222 .22634 L
.78322 .22634 L
.78422 .22634 L
.78521 .22634 L
.78621 .22634 L
.78721 .22634 L
.78821 .22634 L
.78921 .22634 L
.79021 .22634 L
.79121 .22634 L
.79221 .22634 L
.79321 .22634 L
.79421 .22634 L
.7952 .22634 L
.7962 .22634 L
.7972 .22634 L
.7982 .22634 L
Mistroke
.7992 .22524 L
.8002 .22524 L
.8012 .22524 L
.8022 .22524 L
.8032 .22524 L
.8042 .22524 L
.80519 .22524 L
.80619 .22524 L
.80719 .22524 L
.80819 .22524 L
.80919 .22524 L
.81019 .22524 L
.81119 .22524 L
.81219 .22524 L
.81319 .22524 L
.81419 .22524 L
.81518 .22524 L
.81618 .22524 L
.81718 .22524 L
.81818 .22524 L
.81918 .22524 L
.82018 .22524 L
.82118 .22524 L
.82218 .22524 L
.82318 .22524 L
.82418 .22524 L
.82517 .22524 L
.82617 .22524 L
.82717 .22524 L
.82817 .22524 L
.82917 .22524 L
.83017 .22524 L
.83117 .22524 L
.83217 .22524 L
.83317 .22524 L
.83417 .22524 L
.83516 .22524 L
.83616 .22524 L
.83716 .22524 L
.83816 .22524 L
.83916 .22524 L
.84016 .22524 L
.84116 .22524 L
.84216 .22524 L
.84316 .22524 L
.84416 .22524 L
.84515 .22524 L
.84615 .22524 L
.84715 .22524 L
.84815 .22524 L
Mistroke
.84915 .22758 L
.85015 .22758 L
.85115 .22758 L
.85215 .22758 L
.85315 .22758 L
.85415 .22758 L
.85514 .22758 L
.85614 .22758 L
.85714 .22758 L
.85814 .22758 L
.85914 .22758 L
.86014 .22758 L
.86114 .22758 L
.86214 .22758 L
.86314 .22758 L
.86414 .22758 L
.86513 .22758 L
.86613 .22758 L
.86713 .22758 L
.86813 .22758 L
.86913 .22758 L
.87013 .22758 L
.87113 .22758 L
.87213 .22758 L
.87313 .22758 L
.87413 .22758 L
.87512 .22758 L
.87612 .22758 L
.87712 .22758 L
.87812 .22758 L
.87912 .22758 L
.88012 .22758 L
.88112 .22758 L
.88212 .22758 L
.88312 .22758 L
.88412 .22758 L
.88511 .22758 L
.88611 .22758 L
.88711 .22758 L
.88811 .22758 L
.88911 .22758 L
.89011 .22758 L
.89111 .22758 L
.89211 .22758 L
.89311 .22758 L
.89411 .22758 L
.8951 .22758 L
.8961 .22758 L
.8971 .22758 L
.8981 .22758 L
Mistroke
.8991 .2274 L
.9001 .2274 L
.9011 .2274 L
.9021 .2274 L
.9031 .2274 L
.9041 .2274 L
.90509 .2274 L
.90609 .2274 L
.90709 .2274 L
.90809 .2274 L
.90909 .2274 L
.91009 .2274 L
.91109 .2274 L
.91209 .2274 L
.91309 .2274 L
.91409 .2274 L
.91508 .2274 L
.91608 .2274 L
.91708 .2274 L
.91808 .2274 L
.91908 .2274 L
.92008 .2274 L
.92108 .2274 L
.92208 .2274 L
.92308 .2274 L
.92408 .2274 L
.92507 .2274 L
.92607 .2274 L
.92707 .2274 L
.92807 .2274 L
.92907 .2274 L
.93007 .2274 L
.93107 .2274 L
.93207 .2274 L
.93307 .2274 L
.93407 .2274 L
.93506 .2274 L
.93606 .2274 L
.93706 .2274 L
.93806 .2274 L
.93906 .2274 L
.94006 .2274 L
.94106 .2274 L
.94206 .2274 L
.94306 .2274 L
.94406 .2274 L
.94505 .2274 L
.94605 .2274 L
.94705 .2274 L
.94805 .2274 L
Mistroke
.94905 .22744 L
.95005 .22744 L
.95105 .22744 L
.95205 .22744 L
.95305 .22744 L
.95405 .22744 L
.95504 .22744 L
.95604 .22744 L
.95704 .22744 L
.95804 .22744 L
.95904 .22744 L
.96004 .22744 L
.96104 .22744 L
.96204 .22744 L
.96304 .22744 L
.96404 .22744 L
.96503 .22744 L
.96603 .22744 L
.96703 .22744 L
.96803 .22744 L
.96903 .22744 L
.97003 .22744 L
.97103 .22744 L
.97203 .22744 L
.97303 .22744 L
.97403 .22744 L
.97502 .22744 L
.97602 .22744 L
.97702 .22744 L
.97802 .22744 L
.97902 .22744 L
.98002 .22744 L
.98102 .22744 L
.98202 .22744 L
.98302 .22744 L
.98402 .22744 L
.98501 .22744 L
.98601 .22744 L
.98701 .22744 L
.98801 .22744 L
.98901 .22744 L
.99001 .22744 L
.99101 .22744 L
.99201 .22744 L
.99301 .22744 L
.99401 .22744 L
.995 .22744 L
.996 .22744 L
.997 .22744 L
.998 .22744 L
Mistroke
.999 .22833 L
Mfstroke
1 0 0 r
gsave
.999 .21257 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .28327 m
.001 .28327 L
.002 .28327 L
.003 .28327 L
.004 .28327 L
.005 .28327 L
.00599 .28327 L
.00699 .28327 L
.00799 .28327 L
.00899 .28327 L
.00999 .28327 L
.01099 .28327 L
.01199 .28327 L
.01299 .28327 L
.01399 .28327 L
.01499 .28327 L
.01598 .28327 L
.01698 .28327 L
.01798 .28327 L
.01898 .28327 L
.01998 .28327 L
.02098 .28327 L
.02198 .28327 L
.02298 .28327 L
.02398 .28327 L
.02498 .28327 L
.02597 .28327 L
.02697 .28327 L
.02797 .28327 L
.02897 .28327 L
.02997 .28327 L
.03097 .28327 L
.03197 .28327 L
.03297 .28327 L
.03397 .28327 L
.03497 .28327 L
.03596 .28327 L
.03696 .28327 L
.03796 .28327 L
.03896 .28327 L
.03996 .28327 L
.04096 .28327 L
.04196 .28327 L
.04296 .28327 L
.04396 .28327 L
.04496 .28327 L
.04595 .28327 L
.04695 .28327 L
.04795 .28327 L
.04895 .28327 L
Mistroke
.04995 .22269 L
.05095 .22269 L
.05195 .22269 L
.05295 .22269 L
.05395 .22269 L
.05495 .22269 L
.05594 .22269 L
.05694 .22269 L
.05794 .22269 L
.05894 .22269 L
.05994 .22269 L
.06094 .22269 L
.06194 .22269 L
.06294 .22269 L
.06394 .22269 L
.06494 .22269 L
.06593 .22269 L
.06693 .22269 L
.06793 .22269 L
.06893 .22269 L
.06993 .22269 L
.07093 .22269 L
.07193 .22269 L
.07293 .22269 L
.07393 .22269 L
.07493 .22269 L
.07592 .22269 L
.07692 .22269 L
.07792 .22269 L
.07892 .22269 L
.07992 .22269 L
.08092 .22269 L
.08192 .22269 L
.08292 .22269 L
.08392 .22269 L
.08492 .22269 L
.08591 .22269 L
.08691 .22269 L
.08791 .22269 L
.08891 .22269 L
.08991 .22269 L
.09091 .22269 L
.09191 .22269 L
.09291 .22269 L
.09391 .22269 L
.09491 .22269 L
.0959 .22269 L
.0969 .22269 L
.0979 .22269 L
.0989 .22269 L
Mistroke
.0999 .2243 L
.1009 .2243 L
.1019 .2243 L
.1029 .2243 L
.1039 .2243 L
.1049 .2243 L
.10589 .2243 L
.10689 .2243 L
.10789 .2243 L
.10889 .2243 L
.10989 .2243 L
.11089 .2243 L
.11189 .2243 L
.11289 .2243 L
.11389 .2243 L
.11489 .2243 L
.11588 .2243 L
.11688 .2243 L
.11788 .2243 L
.11888 .2243 L
.11988 .2243 L
.12088 .2243 L
.12188 .2243 L
.12288 .2243 L
.12388 .2243 L
.12488 .2243 L
.12587 .2243 L
.12687 .2243 L
.12787 .2243 L
.12887 .2243 L
.12987 .2243 L
.13087 .2243 L
.13187 .2243 L
.13287 .2243 L
.13387 .2243 L
.13487 .2243 L
.13586 .2243 L
.13686 .2243 L
.13786 .2243 L
.13886 .2243 L
.13986 .2243 L
.14086 .2243 L
.14186 .2243 L
.14286 .2243 L
.14386 .2243 L
.14486 .2243 L
.14585 .2243 L
.14685 .2243 L
.14785 .2243 L
.14885 .2243 L
Mistroke
.14985 .24796 L
.15085 .24796 L
.15185 .24796 L
.15285 .24796 L
.15385 .24796 L
.15485 .24796 L
.15584 .24796 L
.15684 .24796 L
.15784 .24796 L
.15884 .24796 L
.15984 .24796 L
.16084 .24796 L
.16184 .24796 L
.16284 .24796 L
.16384 .24796 L
.16484 .24796 L
.16583 .24796 L
.16683 .24796 L
.16783 .24796 L
.16883 .24796 L
.16983 .24796 L
.17083 .24796 L
.17183 .24796 L
.17283 .24796 L
.17383 .24796 L
.17483 .24796 L
.17582 .24796 L
.17682 .24796 L
.17782 .24796 L
.17882 .24796 L
.17982 .24796 L
.18082 .24796 L
.18182 .24796 L
.18282 .24796 L
.18382 .24796 L
.18482 .24796 L
.18581 .24796 L
.18681 .24796 L
.18781 .24796 L
.18881 .24796 L
.18981 .24796 L
.19081 .24796 L
.19181 .24796 L
.19281 .24796 L
.19381 .24796 L
.19481 .24796 L
.1958 .24796 L
.1968 .24796 L
.1978 .24796 L
.1988 .24796 L
Mistroke
.1998 .24623 L
.2008 .24623 L
.2018 .24623 L
.2028 .24623 L
.2038 .24623 L
.2048 .24623 L
.20579 .24623 L
.20679 .24623 L
.20779 .24623 L
.20879 .24623 L
.20979 .24623 L
.21079 .24623 L
.21179 .24623 L
.21279 .24623 L
.21379 .24623 L
.21479 .24623 L
.21578 .24623 L
.21678 .24623 L
.21778 .24623 L
.21878 .24623 L
.21978 .24623 L
.22078 .24623 L
.22178 .24623 L
.22278 .24623 L
.22378 .24623 L
.22478 .24623 L
.22577 .24623 L
.22677 .24623 L
.22777 .24623 L
.22877 .24623 L
.22977 .24623 L
.23077 .24623 L
.23177 .24623 L
.23277 .24623 L
.23377 .24623 L
.23477 .24623 L
.23576 .24623 L
.23676 .24623 L
.23776 .24623 L
.23876 .24623 L
.23976 .24623 L
.24076 .24623 L
.24176 .24623 L
.24276 .24623 L
.24376 .24623 L
.24476 .24623 L
.24575 .24623 L
.24675 .24623 L
.24775 .24623 L
.24875 .24623 L
Mistroke
.24975 .21833 L
.25075 .21833 L
.25175 .21833 L
.25275 .21833 L
.25375 .21833 L
.25475 .21833 L
.25574 .21833 L
.25674 .21833 L
.25774 .21833 L
.25874 .21833 L
.25974 .21833 L
.26074 .21833 L
.26174 .21833 L
.26274 .21833 L
.26374 .21833 L
.26474 .21833 L
.26573 .21833 L
.26673 .21833 L
.26773 .21833 L
.26873 .21833 L
.26973 .21833 L
.27073 .21833 L
.27173 .21833 L
.27273 .21833 L
.27373 .21833 L
.27473 .21833 L
.27572 .21833 L
.27672 .21833 L
.27772 .21833 L
.27872 .21833 L
.27972 .21833 L
.28072 .21833 L
.28172 .21833 L
.28272 .21833 L
.28372 .21833 L
.28472 .21833 L
.28571 .21833 L
.28671 .21833 L
.28771 .21833 L
.28871 .21833 L
.28971 .21833 L
.29071 .21833 L
.29171 .21833 L
.29271 .21833 L
.29371 .21833 L
.29471 .21833 L
.2957 .21833 L
.2967 .21833 L
.2977 .21833 L
.2987 .21833 L
Mistroke
.2997 .21801 L
.3007 .21801 L
.3017 .21801 L
.3027 .21801 L
.3037 .21801 L
.3047 .21801 L
.30569 .21801 L
.30669 .21801 L
.30769 .21801 L
.30869 .21801 L
.30969 .21801 L
.31069 .21801 L
.31169 .21801 L
.31269 .21801 L
.31369 .21801 L
.31469 .21801 L
.31568 .21801 L
.31668 .21801 L
.31768 .21801 L
.31868 .21801 L
.31968 .21801 L
.32068 .21801 L
.32168 .21801 L
.32268 .21801 L
.32368 .21801 L
.32468 .21801 L
.32567 .21801 L
.32667 .21801 L
.32767 .21801 L
.32867 .21801 L
.32967 .21801 L
.33067 .21801 L
.33167 .21801 L
.33267 .21801 L
.33367 .21801 L
.33467 .21801 L
.33566 .21801 L
.33666 .21801 L
.33766 .21801 L
.33866 .21801 L
.33966 .21801 L
.34066 .21801 L
.34166 .21801 L
.34266 .21801 L
.34366 .21801 L
.34466 .21801 L
.34565 .21801 L
.34665 .21801 L
.34765 .21801 L
.34865 .21801 L
Mistroke
.34965 .21414 L
.35065 .21414 L
.35165 .21414 L
.35265 .21414 L
.35365 .21414 L
.35465 .21414 L
.35564 .21414 L
.35664 .21414 L
.35764 .21414 L
.35864 .21414 L
.35964 .21414 L
.36064 .21414 L
.36164 .21414 L
.36264 .21414 L
.36364 .21414 L
.36464 .21414 L
.36563 .21414 L
.36663 .21414 L
.36763 .21414 L
.36863 .21414 L
.36963 .21414 L
.37063 .21414 L
.37163 .21414 L
.37263 .21414 L
.37363 .21414 L
.37463 .21414 L
.37562 .21414 L
.37662 .21414 L
.37762 .21414 L
.37862 .21414 L
.37962 .21414 L
.38062 .21414 L
.38162 .21414 L
.38262 .21414 L
.38362 .21414 L
.38462 .21414 L
.38561 .21414 L
.38661 .21414 L
.38761 .21414 L
.38861 .21414 L
.38961 .21414 L
.39061 .21414 L
.39161 .21414 L
.39261 .21414 L
.39361 .21414 L
.39461 .21414 L
.3956 .21414 L
.3966 .21414 L
.3976 .21414 L
.3986 .21414 L
Mistroke
.3996 .19729 L
.4006 .19729 L
.4016 .19729 L
.4026 .19729 L
.4036 .19729 L
.4046 .19729 L
.40559 .19729 L
.40659 .19729 L
.40759 .19729 L
.40859 .19729 L
.40959 .19729 L
.41059 .19729 L
.41159 .19729 L
.41259 .19729 L
.41359 .19729 L
.41459 .19729 L
.41558 .19729 L
.41658 .19729 L
.41758 .19729 L
.41858 .19729 L
.41958 .19729 L
.42058 .19729 L
.42158 .19729 L
.42258 .19729 L
.42358 .19729 L
.42458 .19729 L
.42557 .19729 L
.42657 .19729 L
.42757 .19729 L
.42857 .19729 L
.42957 .19729 L
.43057 .19729 L
.43157 .19729 L
.43257 .19729 L
.43357 .19729 L
.43457 .19729 L
.43556 .19729 L
.43656 .19729 L
.43756 .19729 L
.43856 .19729 L
.43956 .19729 L
.44056 .19729 L
.44156 .19729 L
.44256 .19729 L
.44356 .19729 L
.44456 .19729 L
.44555 .19729 L
.44655 .19729 L
.44755 .19729 L
.44855 .19729 L
Mistroke
.44955 .19173 L
.45055 .19173 L
.45155 .19173 L
.45255 .19173 L
.45355 .19173 L
.45455 .19173 L
.45554 .19173 L
.45654 .19173 L
.45754 .19173 L
.45854 .19173 L
.45954 .19173 L
.46054 .19173 L
.46154 .19173 L
.46254 .19173 L
.46354 .19173 L
.46454 .19173 L
.46553 .19173 L
.46653 .19173 L
.46753 .19173 L
.46853 .19173 L
.46953 .19173 L
.47053 .19173 L
.47153 .19173 L
.47253 .19173 L
.47353 .19173 L
.47453 .19173 L
.47552 .19173 L
.47652 .19173 L
.47752 .19173 L
.47852 .19173 L
.47952 .19173 L
.48052 .19173 L
.48152 .19173 L
.48252 .19173 L
.48352 .19173 L
.48452 .19173 L
.48551 .19173 L
.48651 .19173 L
.48751 .19173 L
.48851 .19173 L
.48951 .19173 L
.49051 .19173 L
.49151 .19173 L
.49251 .19173 L
.49351 .19173 L
.49451 .19173 L
.4955 .19173 L
.4965 .19173 L
.4975 .19173 L
.4985 .19173 L
Mistroke
.4995 .19985 L
.5005 .19985 L
.5015 .19985 L
.5025 .19985 L
.5035 .19985 L
.5045 .19985 L
.50549 .19985 L
.50649 .19985 L
.50749 .19985 L
.50849 .19985 L
.50949 .19985 L
.51049 .19985 L
.51149 .19985 L
.51249 .19985 L
.51349 .19985 L
.51449 .19985 L
.51548 .19985 L
.51648 .19985 L
.51748 .19985 L
.51848 .19985 L
.51948 .19985 L
.52048 .19985 L
.52148 .19985 L
.52248 .19985 L
.52348 .19985 L
.52448 .19985 L
.52547 .19985 L
.52647 .19985 L
.52747 .19985 L
.52847 .19985 L
.52947 .19985 L
.53047 .19985 L
.53147 .19985 L
.53247 .19985 L
.53347 .19985 L
.53447 .19985 L
.53546 .19985 L
.53646 .19985 L
.53746 .19985 L
.53846 .19985 L
.53946 .19985 L
.54046 .19985 L
.54146 .19985 L
.54246 .19985 L
.54346 .19985 L
.54446 .19985 L
.54545 .19985 L
.54645 .19985 L
.54745 .19985 L
.54845 .19985 L
Mistroke
.54945 .20382 L
.55045 .20382 L
.55145 .20382 L
.55245 .20382 L
.55345 .20382 L
.55445 .20382 L
.55544 .20382 L
.55644 .20382 L
.55744 .20382 L
.55844 .20382 L
.55944 .20382 L
.56044 .20382 L
.56144 .20382 L
.56244 .20382 L
.56344 .20382 L
.56444 .20382 L
.56543 .20382 L
.56643 .20382 L
.56743 .20382 L
.56843 .20382 L
.56943 .20382 L
.57043 .20382 L
.57143 .20382 L
.57243 .20382 L
.57343 .20382 L
.57443 .20382 L
.57542 .20382 L
.57642 .20382 L
.57742 .20382 L
.57842 .20382 L
.57942 .20382 L
.58042 .20382 L
.58142 .20382 L
.58242 .20382 L
.58342 .20382 L
.58442 .20382 L
.58541 .20382 L
.58641 .20382 L
.58741 .20382 L
.58841 .20382 L
.58941 .20382 L
.59041 .20382 L
.59141 .20382 L
.59241 .20382 L
.59341 .20382 L
.59441 .20382 L
.5954 .20382 L
.5964 .20382 L
.5974 .20382 L
.5984 .20382 L
Mistroke
.5994 .20379 L
.6004 .20379 L
.6014 .20379 L
.6024 .20379 L
.6034 .20379 L
.6044 .20379 L
.60539 .20379 L
.60639 .20379 L
.60739 .20379 L
.60839 .20379 L
.60939 .20379 L
.61039 .20379 L
.61139 .20379 L
.61239 .20379 L
.61339 .20379 L
.61439 .20379 L
.61538 .20379 L
.61638 .20379 L
.61738 .20379 L
.61838 .20379 L
.61938 .20379 L
.62038 .20379 L
.62138 .20379 L
.62238 .20379 L
.62338 .20379 L
.62438 .20379 L
.62537 .20379 L
.62637 .20379 L
.62737 .20379 L
.62837 .20379 L
.62937 .20379 L
.63037 .20379 L
.63137 .20379 L
.63237 .20379 L
.63337 .20379 L
.63437 .20379 L
.63536 .20379 L
.63636 .20379 L
.63736 .20379 L
.63836 .20379 L
.63936 .20379 L
.64036 .20379 L
.64136 .20379 L
.64236 .20379 L
.64336 .20379 L
.64436 .20379 L
.64535 .20379 L
.64635 .20379 L
.64735 .20379 L
.64835 .20379 L
Mistroke
.64935 .20446 L
.65035 .20446 L
.65135 .20446 L
.65235 .20446 L
.65335 .20446 L
.65435 .20446 L
.65534 .20446 L
.65634 .20446 L
.65734 .20446 L
.65834 .20446 L
.65934 .20446 L
.66034 .20446 L
.66134 .20446 L
.66234 .20446 L
.66334 .20446 L
.66434 .20446 L
.66533 .20446 L
.66633 .20446 L
.66733 .20446 L
.66833 .20446 L
.66933 .20446 L
.67033 .20446 L
.67133 .20446 L
.67233 .20446 L
.67333 .20446 L
.67433 .20446 L
.67532 .20446 L
.67632 .20446 L
.67732 .20446 L
.67832 .20446 L
.67932 .20446 L
.68032 .20446 L
.68132 .20446 L
.68232 .20446 L
.68332 .20446 L
.68432 .20446 L
.68531 .20446 L
.68631 .20446 L
.68731 .20446 L
.68831 .20446 L
.68931 .20446 L
.69031 .20446 L
.69131 .20446 L
.69231 .20446 L
.69331 .20446 L
.69431 .20446 L
.6953 .20446 L
.6963 .20446 L
.6973 .20446 L
.6983 .20446 L
Mistroke
.6993 .20401 L
.7003 .20401 L
.7013 .20401 L
.7023 .20401 L
.7033 .20401 L
.7043 .20401 L
.70529 .20401 L
.70629 .20401 L
.70729 .20401 L
.70829 .20401 L
.70929 .20401 L
.71029 .20401 L
.71129 .20401 L
.71229 .20401 L
.71329 .20401 L
.71429 .20401 L
.71528 .20401 L
.71628 .20401 L
.71728 .20401 L
.71828 .20401 L
.71928 .20401 L
.72028 .20401 L
.72128 .20401 L
.72228 .20401 L
.72328 .20401 L
.72428 .20401 L
.72527 .20401 L
.72627 .20401 L
.72727 .20401 L
.72827 .20401 L
.72927 .20401 L
.73027 .20401 L
.73127 .20401 L
.73227 .20401 L
.73327 .20401 L
.73427 .20401 L
.73526 .20401 L
.73626 .20401 L
.73726 .20401 L
.73826 .20401 L
.73926 .20401 L
.74026 .20401 L
.74126 .20401 L
.74226 .20401 L
.74326 .20401 L
.74426 .20401 L
.74525 .20401 L
.74625 .20401 L
.74725 .20401 L
.74825 .20401 L
Mistroke
.74925 .20717 L
.75025 .20717 L
.75125 .20717 L
.75225 .20717 L
.75325 .20717 L
.75425 .20717 L
.75524 .20717 L
.75624 .20717 L
.75724 .20717 L
.75824 .20717 L
.75924 .20717 L
.76024 .20717 L
.76124 .20717 L
.76224 .20717 L
.76324 .20717 L
.76424 .20717 L
.76523 .20717 L
.76623 .20717 L
.76723 .20717 L
.76823 .20717 L
.76923 .20717 L
.77023 .20717 L
.77123 .20717 L
.77223 .20717 L
.77323 .20717 L
.77423 .20717 L
.77522 .20717 L
.77622 .20717 L
.77722 .20717 L
.77822 .20717 L
.77922 .20717 L
.78022 .20717 L
.78122 .20717 L
.78222 .20717 L
.78322 .20717 L
.78422 .20717 L
.78521 .20717 L
.78621 .20717 L
.78721 .20717 L
.78821 .20717 L
.78921 .20717 L
.79021 .20717 L
.79121 .20717 L
.79221 .20717 L
.79321 .20717 L
.79421 .20717 L
.7952 .20717 L
.7962 .20717 L
.7972 .20717 L
.7982 .20717 L
Mistroke
.7992 .20753 L
.8002 .20753 L
.8012 .20753 L
.8022 .20753 L
.8032 .20753 L
.8042 .20753 L
.80519 .20753 L
.80619 .20753 L
.80719 .20753 L
.80819 .20753 L
.80919 .20753 L
.81019 .20753 L
.81119 .20753 L
.81219 .20753 L
.81319 .20753 L
.81419 .20753 L
.81518 .20753 L
.81618 .20753 L
.81718 .20753 L
.81818 .20753 L
.81918 .20753 L
.82018 .20753 L
.82118 .20753 L
.82218 .20753 L
.82318 .20753 L
.82418 .20753 L
.82517 .20753 L
.82617 .20753 L
.82717 .20753 L
.82817 .20753 L
.82917 .20753 L
.83017 .20753 L
.83117 .20753 L
.83217 .20753 L
.83317 .20753 L
.83417 .20753 L
.83516 .20753 L
.83616 .20753 L
.83716 .20753 L
.83816 .20753 L
.83916 .20753 L
.84016 .20753 L
.84116 .20753 L
.84216 .20753 L
.84316 .20753 L
.84416 .20753 L
.84515 .20753 L
.84615 .20753 L
.84715 .20753 L
.84815 .20753 L
Mistroke
.84915 .21011 L
.85015 .21011 L
.85115 .21011 L
.85215 .21011 L
.85315 .21011 L
.85415 .21011 L
.85514 .21011 L
.85614 .21011 L
.85714 .21011 L
.85814 .21011 L
.85914 .21011 L
.86014 .21011 L
.86114 .21011 L
.86214 .21011 L
.86314 .21011 L
.86414 .21011 L
.86513 .21011 L
.86613 .21011 L
.86713 .21011 L
.86813 .21011 L
.86913 .21011 L
.87013 .21011 L
.87113 .21011 L
.87213 .21011 L
.87313 .21011 L
.87413 .21011 L
.87512 .21011 L
.87612 .21011 L
.87712 .21011 L
.87812 .21011 L
.87912 .21011 L
.88012 .21011 L
.88112 .21011 L
.88212 .21011 L
.88312 .21011 L
.88412 .21011 L
.88511 .21011 L
.88611 .21011 L
.88711 .21011 L
.88811 .21011 L
.88911 .21011 L
.89011 .21011 L
.89111 .21011 L
.89211 .21011 L
.89311 .21011 L
.89411 .21011 L
.8951 .21011 L
.8961 .21011 L
.8971 .21011 L
.8981 .21011 L
Mistroke
.8991 .21071 L
.9001 .21071 L
.9011 .21071 L
.9021 .21071 L
.9031 .21071 L
.9041 .21071 L
.90509 .21071 L
.90609 .21071 L
.90709 .21071 L
.90809 .21071 L
.90909 .21071 L
.91009 .21071 L
.91109 .21071 L
.91209 .21071 L
.91309 .21071 L
.91409 .21071 L
.91508 .21071 L
.91608 .21071 L
.91708 .21071 L
.91808 .21071 L
.91908 .21071 L
.92008 .21071 L
.92108 .21071 L
.92208 .21071 L
.92308 .21071 L
.92408 .21071 L
.92507 .21071 L
.92607 .21071 L
.92707 .21071 L
.92807 .21071 L
.92907 .21071 L
.93007 .21071 L
.93107 .21071 L
.93207 .21071 L
.93307 .21071 L
.93407 .21071 L
.93506 .21071 L
.93606 .21071 L
.93706 .21071 L
.93806 .21071 L
.93906 .21071 L
.94006 .21071 L
.94106 .21071 L
.94206 .21071 L
.94306 .21071 L
.94406 .21071 L
.94505 .21071 L
.94605 .21071 L
.94705 .21071 L
.94805 .21071 L
Mistroke
.94905 .21155 L
.95005 .21155 L
.95105 .21155 L
.95205 .21155 L
.95305 .21155 L
.95405 .21155 L
.95504 .21155 L
.95604 .21155 L
.95704 .21155 L
.95804 .21155 L
.95904 .21155 L
.96004 .21155 L
.96104 .21155 L
.96204 .21155 L
.96304 .21155 L
.96404 .21155 L
.96503 .21155 L
.96603 .21155 L
.96703 .21155 L
.96803 .21155 L
.96903 .21155 L
.97003 .21155 L
.97103 .21155 L
.97203 .21155 L
.97303 .21155 L
.97403 .21155 L
.97502 .21155 L
.97602 .21155 L
.97702 .21155 L
.97802 .21155 L
.97902 .21155 L
.98002 .21155 L
.98102 .21155 L
.98202 .21155 L
.98302 .21155 L
.98402 .21155 L
.98501 .21155 L
.98601 .21155 L
.98701 .21155 L
.98801 .21155 L
.98901 .21155 L
.99001 .21155 L
.99101 .21155 L
.99201 .21155 L
.99301 .21155 L
.99401 .21155 L
.995 .21155 L
.996 .21155 L
.997 .21155 L
.998 .21155 L
Mistroke
.999 .21257 L
Mfstroke
0 0 1 r
gsave
.001 -0.38627 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .3062 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .348 L
.005 .34585 L
.00599 .34348 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33051 L
.01099 .3261 L
.01199 .32109 L
.01299 .31542 L
.01399 .30899 L
.01499 .30173 L
.01598 .29354 L
.01698 .28431 L
.01798 .27394 L
.01898 .26228 L
.01998 .24922 L
.02098 .23462 L
.02198 .21833 L
.02298 .20023 L
.02398 .18018 L
.02498 .15808 L
.02597 .13389 L
.02697 .10759 L
.02797 .0793 L
.02897 .04923 L
.02997 .0178 L
s
.02997 .0178 m
.03052 0 L
s
.04361 0 m
.04396 .01479 L
.04496 .05968 L
.04595 .10507 L
.04695 .14932 L
.04795 .19052 L
.04895 .22618 L
.04995 .10227 L
.05095 .08924 L
.05195 .08245 L
.05295 .082 L
.05395 .0881 L
.05495 .10046 L
.05594 .11825 L
.05694 .1403 L
.05794 .16536 L
.05894 .19221 L
.05994 .21971 L
.06094 .24684 L
.06194 .27278 L
.06294 .29699 L
.06394 .31915 L
.06494 .33915 L
.06593 .35705 L
.06693 .37302 L
.06793 .38726 L
.06893 .4 L
.06993 .41145 L
.07093 .42172 L
.07193 .43084 L
.07293 .43865 L
.07393 .44474 L
.07493 .44836 L
.07592 .44856 L
.07692 .44479 L
.07792 .43738 L
.07892 .42724 L
.07992 .41533 L
.08092 .40245 L
.08192 .38919 L
.08292 .37598 L
.08392 .36316 L
.08492 .35096 L
.08591 .33955 L
.08691 .32904 L
.08791 .3195 L
.08891 .31094 L
.08991 .30335 L
.09091 .2967 L
.09191 .29093 L
Mistroke
.09291 .28599 L
.09391 .2818 L
.09491 .27827 L
.0959 .27532 L
.0969 .27288 L
.0979 .27086 L
.0989 .26918 L
.0999 .39807 L
.1009 .39278 L
.1019 .38952 L
.1029 .38721 L
.1039 .38551 L
.1049 .38421 L
.10589 .38321 L
.10689 .38244 L
.10789 .38186 L
.10889 .38145 L
.10989 .38117 L
.11089 .38102 L
.11189 .38098 L
.11289 .38105 L
.11389 .38123 L
.11489 .38152 L
.11588 .3819 L
.11688 .3824 L
.11788 .38302 L
.11888 .38375 L
.11988 .38462 L
.12088 .38565 L
.12188 .38685 L
.12288 .38824 L
.12388 .38987 L
.12488 .39176 L
.12587 .39397 L
.12687 .39654 L
.12787 .39955 L
.12887 .40307 L
.12987 .40717 L
.13087 .41195 L
.13187 .41749 L
.13287 .42387 L
.13387 .43117 L
.13487 .4394 L
.13586 .44856 L
.13686 .45848 L
.13786 .46888 L
.13886 .47913 L
.13986 .48811 L
.14086 .49397 L
.14186 .49438 L
Mistroke
.14286 .48805 L
.14386 .47591 L
.14486 .46 L
.14585 .44213 L
.14685 .42367 L
.14785 .40561 L
.14885 .38865 L
.14985 .55473 L
.15085 .5357 L
.15185 .51732 L
.15285 .49909 L
.15385 .48116 L
.15485 .46377 L
.15584 .44719 L
.15684 .43162 L
.15784 .41719 L
.15884 .40397 L
.15984 .39197 L
.16084 .38115 L
.16184 .37144 L
.16284 .36274 L
.16384 .35496 L
.16484 .34799 L
.16583 .3417 L
.16683 .33601 L
.16783 .33081 L
.16883 .326 L
.16983 .32149 L
.17083 .31721 L
.17183 .31308 L
.17283 .30904 L
.17383 .305 L
.17483 .30093 L
.17582 .29676 L
.17682 .29244 L
.17782 .28793 L
.17882 .28319 L
.17982 .27816 L
.18082 .27283 L
.18182 .26714 L
.18282 .26107 L
.18382 .2546 L
.18482 .24769 L
.18581 .24033 L
.18681 .23252 L
.18781 .22424 L
.18881 .21551 L
.18981 .20635 L
.19081 .19679 L
.19181 .18689 L
Mistroke
.19281 .17673 L
.19381 .16641 L
.19481 .15606 L
.1958 .14585 L
.1968 .13596 L
.1978 .12663 L
.1988 .11811 L
.1998 .27727 L
.2008 .26286 L
.2018 .25039 L
.2028 .23871 L
.2038 .22744 L
.2048 .21644 L
.20579 .20567 L
.20679 .19518 L
.20779 .18509 L
.20879 .1756 L
.20979 .16693 L
.21079 .15936 L
.21179 .15318 L
.21279 .14866 L
.21379 .14604 L
.21479 .14545 L
.21578 .14691 L
.21678 .15031 L
.21778 .15543 L
.21878 .16197 L
.21978 .16968 L
.22078 .17832 L
.22178 .18776 L
.22278 .19782 L
.22378 .20835 L
.22478 .21914 L
.22577 .22998 L
.22677 .24065 L
.22777 .25097 L
.22877 .26075 L
.22977 .26988 L
.23077 .27825 L
.23177 .2858 L
.23277 .29251 L
.23377 .29838 L
.23477 .30343 L
.23576 .30769 L
.23676 .31122 L
.23776 .31406 L
.23876 .31627 L
.23976 .3179 L
.24076 .319 L
.24176 .3196 L
Mistroke
.24276 .31976 L
.24376 .3195 L
.24476 .31884 L
.24575 .31782 L
.24675 .31645 L
.24775 .31473 L
.24875 .31267 L
.24975 .4456 L
.25075 .44346 L
.25175 .44325 L
.25275 .44388 L
.25375 .44499 L
.25475 .44643 L
.25574 .44809 L
.25674 .44991 L
.25774 .45187 L
.25874 .45393 L
.25974 .45606 L
.26074 .45825 L
.26174 .46048 L
.26274 .46274 L
.26374 .46498 L
.26474 .4672 L
.26573 .46936 L
.26673 .47143 L
.26773 .47336 L
.26873 .4751 L
.26973 .4766 L
.27073 .47778 L
.27173 .47858 L
.27273 .47892 L
.27373 .47869 L
.27473 .47783 L
.27572 .47627 L
.27672 .47394 L
.27772 .47084 L
.27872 .46698 L
.27972 .46243 L
.28072 .45729 L
.28172 .45168 L
.28272 .44574 L
.28372 .43961 L
.28472 .43342 L
.28571 .42728 L
.28671 .4213 L
.28771 .41554 L
.28871 .41008 L
.28971 .40495 L
.29071 .40017 L
.29171 .39575 L
Mistroke
.29271 .39169 L
.29371 .38798 L
.29471 .3846 L
.2957 .38155 L
.2967 .37878 L
.2977 .37629 L
.2987 .37405 L
.2997 .4154 L
.3007 .41078 L
.3017 .40817 L
.3027 .4065 L
.3037 .40542 L
.3047 .40475 L
.30569 .4044 L
.30669 .40431 L
.30769 .40445 L
.30869 .4048 L
.30969 .40535 L
.31069 .40608 L
.31169 .407 L
.31269 .4081 L
.31369 .4094 L
.31469 .41089 L
.31568 .41259 L
.31668 .41451 L
.31768 .41665 L
.31868 .41903 L
.31968 .42167 L
.32068 .42459 L
.32168 .42779 L
.32268 .43131 L
.32368 .43516 L
.32468 .43934 L
.32567 .44388 L
.32667 .44877 L
.32767 .454 L
.32867 .45952 L
.32967 .46527 L
.33067 .47113 L
.33167 .47692 L
.33267 .48237 L
.33367 .48709 L
.33467 .4906 L
.33566 .49232 L
.33666 .49173 L
.33766 .48855 L
.33866 .48286 L
.33966 .47506 L
.34066 .4657 L
.34166 .45533 L
Mistroke
.34266 .44447 L
.34366 .43355 L
.34466 .4229 L
.34565 .41276 L
.34665 .40332 L
.34765 .39466 L
.34865 .38681 L
.34965 .50784 L
.35065 .49705 L
.35165 .48742 L
.35265 .47811 L
.35365 .46893 L
.35465 .45988 L
.35564 .451 L
.35664 .44236 L
.35764 .43405 L
.35864 .42612 L
.35964 .41863 L
.36064 .4116 L
.36164 .40507 L
.36264 .39903 L
.36364 .39348 L
.36464 .38841 L
.36563 .38379 L
.36663 .37959 L
.36763 .37578 L
.36863 .37233 L
.36963 .36919 L
.37063 .36634 L
.37163 .36374 L
.37263 .36134 L
.37363 .35913 L
.37463 .35706 L
.37562 .35511 L
.37662 .35326 L
.37762 .35146 L
.37862 .34971 L
.37962 .34798 L
.38062 .34625 L
.38162 .3445 L
.38262 .34271 L
.38362 .34087 L
.38462 .33896 L
.38561 .33698 L
.38661 .3349 L
.38761 .33272 L
.38861 .33044 L
.38961 .32805 L
.39061 .32554 L
.39161 .32292 L
Mistroke
.39261 .3202 L
.39361 .31739 L
.39461 .3145 L
.3956 .31155 L
.3966 .30857 L
.3976 .30561 L
.3986 .3027 L
.3996 .31791 L
.4006 .31186 L
.4016 .30698 L
.4026 .30218 L
.4036 .29713 L
.4046 .29167 L
.40559 .28572 L
.40659 .27921 L
.40759 .2721 L
.40859 .26438 L
.40959 .25602 L
.41059 .24701 L
.41159 .23739 L
.41259 .22718 L
.41359 .21645 L
.41459 .2053 L
.41558 .19389 L
.41658 .18242 L
.41758 .17114 L
.41858 .16039 L
.41958 .15054 L
.42058 .142 L
.42158 .13521 L
.42258 .13054 L
.42358 .12822 L
.42458 .12817 L
.42557 .12983 L
.42657 .13209 L
.42757 .13383 L
.42857 .13493 L
.42957 .1363 L
.43057 .13907 L
.43157 .144 L
.43257 .15145 L
.43357 .16144 L
.43457 .17369 L
.43556 .18779 L
.43656 .20316 L
.43756 .21923 L
.43856 .23545 L
.43956 .25134 L
.44056 .26651 L
.44156 .28069 L
Mistroke
.44256 .29369 L
.44356 .30542 L
.44456 .31586 L
.44555 .32505 L
.44655 .33305 L
.44755 .33998 L
.44855 .34593 L
.44955 .39727 L
.45055 .39836 L
.45155 .40044 L
.45255 .40259 L
.45355 .40459 L
.45455 .40635 L
.45554 .40784 L
.45654 .40908 L
.45754 .41008 L
.45854 .41089 L
.45954 .41153 L
.46054 .41204 L
.46154 .41245 L
.46254 .4128 L
.46354 .4131 L
.46454 .41338 L
.46553 .41368 L
.46653 .41399 L
.46753 .41435 L
.46853 .41476 L
.46953 .41524 L
.47053 .4158 L
.47153 .41645 L
.47253 .4172 L
.47353 .41805 L
.47453 .41901 L
.47552 .42008 L
.47652 .42127 L
.47752 .42258 L
.47852 .424 L
.47952 .42553 L
.48052 .42718 L
.48152 .42892 L
.48252 .43075 L
.48352 .43264 L
.48452 .43458 L
.48551 .43652 L
.48651 .43843 L
.48751 .44027 L
.48851 .44197 L
.48951 .44347 L
.49051 .44471 L
.49151 .44561 L
Mistroke
.49251 .4461 L
.49351 .44614 L
.49451 .44566 L
.4955 .44465 L
.4965 .44311 L
.4975 .44105 L
.4985 .43853 L
.4995 .53689 L
.5005 .52434 L
.5015 .51256 L
.5025 .50071 L
.5035 .48869 L
.5045 .47657 L
.50549 .46447 L
.50649 .45257 L
.50749 .44101 L
.50849 .42993 L
.50949 .41942 L
.51049 .40956 L
.51149 .40039 L
.51249 .39192 L
.51349 .38415 L
.51449 .37705 L
.51548 .37058 L
.51648 .3647 L
.51748 .35935 L
.51848 .35449 L
.51948 .35004 L
.52048 .34596 L
.52148 .34219 L
.52248 .33868 L
.52348 .33537 L
.52448 .33222 L
.52547 .32918 L
.52647 .3262 L
.52747 .32325 L
.52847 .32029 L
.52947 .31727 L
.53047 .31416 L
.53147 .31094 L
.53247 .30755 L
.53347 .30398 L
.53447 .30019 L
.53546 .29614 L
.53646 .29181 L
.53746 .28716 L
.53846 .28215 L
.53946 .27677 L
.54046 .27096 L
.54146 .2647 L
Mistroke
.54246 .25796 L
.54346 .25069 L
.54446 .24287 L
.54545 .23447 L
.54645 .22545 L
.54745 .2158 L
.54845 .2055 L
.54945 .40678 L
.55045 .40836 L
.55145 .41165 L
.55245 .41563 L
.55345 .42005 L
.55445 .42481 L
.55544 .42989 L
.55644 .43527 L
.55744 .44098 L
.55844 .44703 L
.55944 .45343 L
.56044 .46018 L
.56144 .46729 L
.56244 .47474 L
.56344 .48252 L
.56444 .49057 L
.56543 .49883 L
.56643 .50718 L
.56743 .51547 L
.56843 .52346 L
.56943 .53083 L
.57043 .53711 L
.57143 .54168 L
.57243 .54368 L
.57343 .54214 L
.57443 .53631 L
.57542 .52607 L
.57642 .51206 L
.57742 .49528 L
.57842 .4768 L
.57942 .45757 L
.58042 .43837 L
.58142 .41979 L
.58242 .40224 L
.58342 .38597 L
.58442 .37111 L
.58541 .35767 L
.58641 .3456 L
.58741 .33482 L
.58841 .32521 L
.58941 .31664 L
.59041 .30899 L
.59141 .30216 L
Mistroke
.59241 .29603 L
.59341 .29052 L
.59441 .28554 L
.5954 .28102 L
.5964 .27689 L
.5974 .27309 L
.5984 .26956 L
.5994 .3304 L
.6004 .32079 L
.6014 .3134 L
.6024 .30711 L
.6034 .30153 L
.6044 .2964 L
.60539 .29157 L
.60639 .28693 L
.60739 .2824 L
.60839 .27791 L
.60939 .27342 L
.61039 .2689 L
.61139 .26431 L
.61239 .25963 L
.61339 .25487 L
.61439 .25002 L
.61538 .2451 L
.61638 .24011 L
.61738 .23508 L
.61838 .23005 L
.61938 .22505 L
.62038 .22015 L
.62138 .21539 L
.62238 .21083 L
.62338 .20656 L
.62438 .20263 L
.62537 .1991 L
.62637 .19604 L
.62737 .19348 L
.62837 .19144 L
.62937 .18992 L
.63037 .18887 L
.63137 .18821 L
.63237 .18785 L
.63337 .18768 L
.63437 .18762 L
.63536 .18762 L
.63636 .18772 L
.63736 .18798 L
.63836 .18852 L
.63936 .18944 L
.64036 .19084 L
.64136 .19279 L
Mistroke
.64236 .19532 L
.64336 .19845 L
.64436 .20212 L
.64535 .20627 L
.64635 .21083 L
.64735 .21568 L
.64835 .22071 L
.64935 .31956 L
.65035 .31444 L
.65135 .31091 L
.65235 .30793 L
.65335 .30514 L
.65435 .30238 L
.65534 .29954 L
.65634 .29655 L
.65734 .29338 L
.65834 .29 L
.65934 .28637 L
.66034 .28249 L
.66134 .27833 L
.66234 .2739 L
.66334 .26919 L
.66434 .26419 L
.66533 .2589 L
.66633 .25335 L
.66733 .24753 L
.66833 .24148 L
.66933 .23522 L
.67033 .22881 L
.67133 .2223 L
.67233 .21575 L
.67333 .20927 L
.67433 .20294 L
.67532 .19688 L
.67632 .19121 L
.67732 .18608 L
.67832 .1816 L
.67932 .1779 L
.68032 .17506 L
.68132 .17311 L
.68232 .17201 L
.68332 .17159 L
.68432 .17157 L
.68531 .17154 L
.68631 .17111 L
.68731 .17007 L
.68831 .16849 L
.68931 .16673 L
.69031 .16523 L
.69131 .16442 L
Mistroke
.69231 .16464 L
.69331 .16613 L
.69431 .169 L
.6953 .17326 L
.6963 .17885 L
.6973 .18561 L
.6983 .19333 L
.6993 .28613 L
.7003 .2889 L
.7013 .29303 L
.7023 .29743 L
.7033 .30176 L
.7043 .30583 L
.70529 .30953 L
.70629 .31281 L
.70729 .31565 L
.70829 .31804 L
.70929 .32 L
.71029 .32153 L
.71129 .32267 L
.71229 .32342 L
.71329 .32383 L
.71429 .3239 L
.71528 .32366 L
.71628 .32313 L
.71728 .32231 L
.71828 .32122 L
.71928 .31986 L
.72028 .31824 L
.72128 .31636 L
.72228 .31421 L
.72328 .31179 L
.72428 .30908 L
.72527 .30609 L
.72627 .30278 L
.72727 .29914 L
.72827 .29516 L
.72927 .29081 L
.73027 .28607 L
.73127 .2809 L
.73227 .27529 L
.73327 .2692 L
.73427 .2626 L
.73526 .25547 L
.73626 .24776 L
.73726 .23946 L
.73826 .23054 L
.73926 .22097 L
.74026 .21075 L
.74126 .19986 L
Mistroke
.74226 .18832 L
.74326 .17614 L
.74426 .16338 L
.74525 .15008 L
.74625 .13636 L
.74725 .12233 L
.74825 .10816 L
.74925 .25279 L
.75025 .23773 L
.75125 .224 L
.75225 .21056 L
.75325 .19719 L
.75425 .18392 L
.75524 .17091 L
.75624 .15846 L
.75724 .14695 L
.75824 .13686 L
.75924 .12871 L
.76024 .12302 L
.76124 .12024 L
.76224 .12067 L
.76324 .12436 L
.76424 .13113 L
.76523 .14058 L
.76623 .15229 L
.76723 .16587 L
.76823 .181 L
.76923 .19732 L
.77023 .21444 L
.77123 .2319 L
.77223 .24926 L
.77323 .26612 L
.77423 .28216 L
.77522 .29713 L
.77622 .3109 L
.77722 .32337 L
.77822 .33456 L
.77922 .34448 L
.78022 .35322 L
.78122 .36087 L
.78222 .36753 L
.78322 .37332 L
.78422 .37835 L
.78521 .38272 L
.78621 .38654 L
.78721 .3899 L
.78821 .39287 L
.78921 .39553 L
.79021 .39794 L
.79121 .40015 L
Mistroke
.79221 .40221 L
.79321 .40415 L
.79421 .406 L
.7952 .40777 L
.7962 .40949 L
.7972 .41116 L
.7982 .41278 L
.7992 .46672 L
.8002 .4649 L
.8012 .46455 L
.8022 .46464 L
.8032 .46487 L
.8042 .46508 L
.80519 .46519 L
.80619 .46515 L
.80719 .46495 L
.80819 .46457 L
.80919 .46401 L
.81019 .46326 L
.81119 .46233 L
.81219 .46122 L
.81319 .45995 L
.81419 .45852 L
.81518 .45694 L
.81618 .45523 L
.81718 .4534 L
.81818 .45146 L
.81918 .44942 L
.82018 .44729 L
.82118 .4451 L
.82218 .44285 L
.82318 .44056 L
.82418 .43824 L
.82517 .43592 L
.82617 .43361 L
.82717 .43132 L
.82817 .42907 L
.82917 .42688 L
.83017 .42476 L
.83117 .42272 L
.83217 .42078 L
.83317 .41896 L
.83417 .41725 L
.83516 .41566 L
.83616 .41421 L
.83716 .4129 L
.83816 .41173 L
.83916 .41071 L
.84016 .40984 L
.84116 .40912 L
Mistroke
.84216 .40855 L
.84316 .40814 L
.84416 .40787 L
.84515 .40776 L
.84615 .40779 L
.84715 .40798 L
.84815 .40831 L
.84915 .50312 L
.85015 .49883 L
.85115 .49589 L
.85215 .49326 L
.85315 .49058 L
.85415 .48771 L
.85514 .48455 L
.85614 .4811 L
.85714 .47733 L
.85814 .47327 L
.85914 .46896 L
.86014 .46444 L
.86114 .45976 L
.86214 .45498 L
.86314 .45015 L
.86414 .44532 L
.86513 .44055 L
.86613 .43587 L
.86713 .43134 L
.86813 .42697 L
.86913 .42281 L
.87013 .41887 L
.87113 .41516 L
.87213 .41171 L
.87313 .4085 L
.87413 .40556 L
.87512 .40287 L
.87612 .40043 L
.87712 .39824 L
.87812 .39629 L
.87912 .39457 L
.88012 .39308 L
.88112 .3918 L
.88212 .39073 L
.88312 .38986 L
.88412 .38918 L
.88511 .38869 L
.88611 .38838 L
.88711 .38826 L
.88811 .38832 L
.88911 .38857 L
.89011 .389 L
.89111 .38962 L
Mistroke
.89211 .39044 L
.89311 .39147 L
.89411 .39273 L
.8951 .39421 L
.8961 .39595 L
.8971 .39794 L
.8981 .40022 L
.8991 .45108 L
.9001 .45247 L
.9011 .45604 L
.9021 .46069 L
.9031 .46606 L
.9041 .47194 L
.90509 .47823 L
.90609 .48482 L
.90709 .49161 L
.90809 .4985 L
.90909 .50538 L
.91009 .51209 L
.91109 .51849 L
.91209 .52436 L
.91309 .52949 L
.91409 .5336 L
.91508 .53639 L
.91608 .5375 L
.91708 .53658 L
.91808 .53327 L
.91908 .52733 L
.92008 .5187 L
.92108 .5076 L
.92208 .49445 L
.92308 .47982 L
.92408 .46433 L
.92507 .44853 L
.92607 .43289 L
.92707 .41778 L
.92807 .40345 L
.92907 .39008 L
.93007 .37774 L
.93107 .36646 L
.93207 .35621 L
.93307 .34695 L
.93407 .3386 L
.93506 .33106 L
.93606 .32426 L
.93706 .3181 L
.93806 .31249 L
.93906 .30735 L
.94006 .3026 L
.94106 .29816 L
Mistroke
.94206 .29396 L
.94306 .28994 L
.94406 .28604 L
.94505 .28221 L
.94605 .2784 L
.94705 .27457 L
.94805 .27067 L
.94905 .32241 L
.95005 .31669 L
.95105 .31255 L
.95205 .30891 L
.95305 .30541 L
.95405 .30188 L
.95504 .29821 L
.95604 .29434 L
.95704 .29022 L
.95804 .28582 L
.95904 .28111 L
.96004 .27608 L
.96104 .2707 L
.96204 .26498 L
.96304 .2589 L
.96404 .25248 L
.96503 .24574 L
.96603 .23868 L
.96703 .23136 L
.96803 .22383 L
.96903 .21616 L
.97003 .20845 L
.97103 .2008 L
.97203 .19336 L
.97303 .18629 L
.97403 .17975 L
.97502 .17394 L
.97602 .16904 L
.97702 .1652 L
.97802 .16253 L
.97902 .16103 L
.98002 .16056 L
.98102 .16078 L
.98202 .16116 L
.98302 .16113 L
.98402 .16038 L
.98501 .15907 L
.98601 .15773 L
.98701 .15698 L
.98801 .15733 L
.98901 .15913 L
.99001 .16257 L
.99101 .16769 L
Mistroke
.99201 .17441 L
.99301 .18253 L
.99401 .19179 L
.995 .20186 L
.996 .21241 L
.997 .22312 L
.998 .23368 L
.999 .3062 L
Mfstroke
gsave
.999 .32111 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38342 L
.004 .38538 L
.005 .38722 L
.00599 .38906 L
.00699 .39099 L
.00799 .39308 L
.00899 .3954 L
.00999 .39798 L
.01099 .40089 L
.01199 .40417 L
.01299 .40789 L
.01399 .41209 L
.01499 .41685 L
.01598 .42222 L
.01698 .42829 L
.01798 .43513 L
.01898 .44283 L
.01998 .45149 L
.02098 .46121 L
.02198 .47211 L
.02298 .48429 L
.02398 .49788 L
.02498 .513 L
.02597 .52976 L
.02697 .54826 L
.02797 .56857 L
.02897 .59071 L
.02997 .61466 L
s
.02997 .61466 m
.0301 .61803 L
s
.04904 .61803 m
.04995 .11757 L
.05095 .11317 L
.05195 .11155 L
.05295 .11455 L
.05395 .12332 L
.05495 .13859 L
.05594 .16053 L
.05694 .18853 L
.05794 .22118 L
.05894 .25658 L
.05994 .2928 L
.06094 .3282 L
.06194 .36158 L
.06294 .39215 L
.06394 .4195 L
.06494 .44344 L
.06593 .46393 L
.06693 .48102 L
.06793 .49479 L
.06893 .50537 L
.06993 .51292 L
.07093 .51763 L
.07193 .51985 L
.07293 .52005 L
.07393 .519 L
.07493 .51781 L
.07592 .51775 L
.07692 .51974 L
.07792 .52379 L
.07892 .52934 L
.07992 .53572 L
.08092 .54242 L
.08192 .54909 L
.08292 .5555 L
.08392 .56147 L
.08492 .56687 L
.08591 .57164 L
.08691 .57571 L
.08791 .57906 L
.08891 .58167 L
.08991 .58355 L
.09091 .58473 L
.09191 .58525 L
.09291 .58515 L
.09391 .5845 L
.09491 .58336 L
.0959 .58181 L
.0969 .57993 L
.0979 .57779 L
Mistroke
.0989 .57547 L
.0999 .41305 L
.1009 .41637 L
.1019 .41829 L
.1029 .41983 L
.1039 .42134 L
.1049 .42295 L
.10589 .42474 L
.10689 .42678 L
.10789 .42907 L
.10889 .43165 L
.10989 .43454 L
.11089 .43774 L
.11189 .44127 L
.11289 .44515 L
.11389 .44939 L
.11489 .45402 L
.11588 .45905 L
.11688 .4645 L
.11788 .47039 L
.11888 .47673 L
.11988 .48354 L
.12088 .49082 L
.12188 .49856 L
.12288 .50676 L
.12388 .51539 L
.12488 .5244 L
.12587 .53372 L
.12687 .54326 L
.12787 .55288 L
.12887 .56244 L
.12987 .57173 L
.13087 .5805 L
.13187 .58848 L
.13287 .59537 L
.13387 .60085 L
.13487 .60461 L
.13586 .6064 L
.13686 .60606 L
.13786 .60363 L
.13886 .59951 L
.13986 .59463 L
.14086 .59072 L
.14186 .59006 L
.14286 .59392 L
.14386 .60139 L
.14486 .6105 L
Mfstroke
.14486 .6105 m
.14569 .61803 L
s
.14911 .61803 m
.14985 .56958 L
.15085 .55971 L
.15185 .54731 L
.15285 .53372 L
.15385 .51963 L
.15485 .50553 L
.15584 .49183 L
.15684 .4788 L
.15784 .46666 L
.15884 .45554 L
.15984 .44552 L
.16084 .43662 L
.16184 .42882 L
.16284 .42208 L
.16384 .41632 L
.16484 .41147 L
.16583 .40745 L
.16683 .40415 L
.16783 .40151 L
.16883 .39944 L
.16983 .39787 L
.17083 .39674 L
.17183 .39598 L
.17283 .39556 L
.17383 .39543 L
.17483 .39555 L
.17582 .39591 L
.17682 .39647 L
.17782 .39722 L
.17882 .39815 L
.17982 .39925 L
.18082 .40051 L
.18182 .40193 L
.18282 .40349 L
.18382 .40521 L
.18482 .40708 L
.18581 .40909 L
.18681 .41125 L
.18781 .41354 L
.18881 .41596 L
.18981 .4185 L
.19081 .42114 L
.19181 .42386 L
.19281 .42663 L
.19381 .42942 L
.19481 .43217 L
.1958 .43484 L
.1968 .43736 L
.1978 .43965 L
Mistroke
.1988 .44166 L
.1998 .29177 L
.2008 .2865 L
.2018 .27977 L
.2028 .27254 L
.2038 .26509 L
.2048 .25755 L
.20579 .25002 L
.20679 .24259 L
.20779 .23536 L
.20879 .22845 L
.20979 .22201 L
.21079 .21621 L
.21179 .21125 L
.21279 .20736 L
.21379 .2048 L
.21479 .20385 L
.21578 .2048 L
.21678 .20795 L
.21778 .2135 L
.21878 .22155 L
.21978 .23195 L
.22078 .24438 L
.22178 .25832 L
.22278 .27319 L
.22378 .28845 L
.22478 .30359 L
.22577 .31825 L
.22677 .33213 L
.22777 .34507 L
.22877 .35696 L
.22977 .36779 L
.23077 .37759 L
.23177 .3864 L
.23277 .39433 L
.23377 .40144 L
.23477 .40786 L
.23576 .41368 L
.23676 .41899 L
.23776 .4239 L
.23876 .42847 L
.23976 .43281 L
.24076 .43698 L
.24176 .44106 L
.24276 .44511 L
.24376 .44919 L
.24476 .45335 L
.24575 .45765 L
.24675 .46215 L
.24775 .46687 L
Mistroke
.24875 .47187 L
.24975 .46004 L
.25075 .46686 L
.25175 .47202 L
.25275 .47662 L
.25375 .48101 L
.25475 .48536 L
.25574 .48976 L
.25674 .49423 L
.25774 .4988 L
.25874 .50345 L
.25974 .50817 L
.26074 .51291 L
.26174 .51765 L
.26274 .52231 L
.26374 .52684 L
.26474 .53117 L
.26573 .53522 L
.26673 .53893 L
.26773 .54221 L
.26873 .545 L
.26973 .54725 L
.27073 .5489 L
.27173 .54995 L
.27273 .55039 L
.27373 .55025 L
.27473 .54958 L
.27572 .54844 L
.27672 .54691 L
.27772 .54505 L
.27872 .54293 L
.27972 .54058 L
.28072 .53804 L
.28172 .5353 L
.28272 .53239 L
.28372 .52932 L
.28472 .52611 L
.28571 .52277 L
.28671 .51936 L
.28771 .5159 L
.28871 .51245 L
.28971 .50906 L
.29071 .50577 L
.29171 .50264 L
.29271 .49971 L
.29371 .49702 L
.29471 .4946 L
.2957 .49248 L
.2967 .49068 L
.2977 .48923 L
Mistroke
.2987 .48812 L
.2997 .43005 L
.3007 .43423 L
.3017 .4369 L
.3027 .43913 L
.3037 .44126 L
.3047 .44347 L
.30569 .44584 L
.30669 .44843 L
.30769 .45128 L
.30869 .45441 L
.30969 .45783 L
.31069 .46156 L
.31169 .46561 L
.31269 .46998 L
.31369 .47468 L
.31469 .4797 L
.31568 .48504 L
.31668 .49069 L
.31768 .49663 L
.31868 .50284 L
.31968 .50928 L
.32068 .51591 L
.32168 .52266 L
.32268 .52946 L
.32368 .53622 L
.32468 .54283 L
.32567 .54916 L
.32667 .55508 L
.32767 .56045 L
.32867 .56512 L
.32967 .56897 L
.33067 .5719 L
.33167 .57387 L
.33267 .57494 L
.33367 .57528 L
.33467 .5752 L
.33566 .57511 L
.33666 .57543 L
.33766 .57635 L
.33866 .57778 L
.33966 .57933 L
.34066 .58056 L
.34166 .58101 L
.34266 .58036 L
.34366 .57838 L
.34466 .57497 L
.34565 .57014 L
.34665 .564 L
.34765 .55672 L
Mistroke
.34865 .54854 L
.34965 .52268 L
.35065 .52072 L
.35165 .51644 L
.35265 .511 L
.35365 .5049 L
.35465 .49847 L
.35564 .49192 L
.35664 .48546 L
.35764 .47923 L
.35864 .47333 L
.35964 .46784 L
.36064 .46283 L
.36164 .45832 L
.36264 .45434 L
.36364 .4509 L
.36464 .44799 L
.36563 .44559 L
.36663 .4437 L
.36763 .44229 L
.36863 .44133 L
.36963 .44082 L
.37063 .44072 L
.37163 .44103 L
.37263 .44172 L
.37363 .44278 L
.37463 .4442 L
.37562 .44598 L
.37662 .44811 L
.37762 .4506 L
.37862 .45344 L
.37962 .45663 L
.38062 .4602 L
.38162 .46414 L
.38262 .46846 L
.38362 .47319 L
.38462 .47832 L
.38561 .48388 L
.38661 .48986 L
.38761 .49629 L
.38861 .50317 L
.38961 .51049 L
.39061 .51824 L
.39161 .52642 L
.39261 .53499 L
.39361 .54391 L
.39461 .55313 L
.3956 .56257 L
.3966 .57213 L
.3976 .5817 L
Mistroke
.3986 .59112 L
.3996 .33231 L
.4006 .33522 L
.4016 .33578 L
.4026 .33517 L
.4036 .33376 L
.4046 .33174 L
.40559 .32921 L
.40659 .32621 L
.40759 .32279 L
.40859 .31894 L
.40959 .31469 L
.41059 .31001 L
.41159 .30489 L
.41259 .29933 L
.41359 .2933 L
.41459 .28679 L
.41558 .27978 L
.41658 .27226 L
.41758 .26425 L
.41858 .25576 L
.41958 .24685 L
.42058 .23763 L
.42158 .22829 L
.42258 .21912 L
.42358 .2106 L
.42458 .2035 L
.42557 .199 L
.42657 .1987 L
.42757 .20403 L
.42857 .21517 L
.42957 .23101 L
.43057 .25001 L
.43157 .27075 L
.43257 .29208 L
.43357 .31307 L
.43457 .33309 L
.43556 .35168 L
.43656 .36862 L
.43756 .38384 L
.43856 .39736 L
.43956 .40929 L
.44056 .4198 L
.44156 .42904 L
.44256 .43717 L
.44356 .44434 L
.44456 .45069 L
.44555 .45631 L
.44655 .4613 L
.44755 .46574 L
Mistroke
.44855 .46969 L
.44955 .4123 L
.45055 .42213 L
.45155 .42951 L
.45255 .43551 L
.45355 .44056 L
.45455 .44491 L
.45554 .44872 L
.45654 .45213 L
.45754 .45523 L
.45854 .4581 L
.45954 .4608 L
.46054 .4634 L
.46154 .46592 L
.46254 .4684 L
.46354 .47087 L
.46454 .47335 L
.46553 .47587 L
.46653 .47843 L
.46753 .48104 L
.46853 .48371 L
.46953 .48645 L
.47053 .48925 L
.47153 .49211 L
.47253 .49503 L
.47353 .49799 L
.47453 .50098 L
.47552 .50399 L
.47652 .507 L
.47752 .50999 L
.47852 .51294 L
.47952 .51582 L
.48052 .51861 L
.48152 .52128 L
.48252 .52381 L
.48352 .52618 L
.48452 .52837 L
.48551 .53037 L
.48651 .53216 L
.48751 .53375 L
.48851 .53515 L
.48951 .53637 L
.49051 .53745 L
.49151 .53842 L
.49251 .53929 L
.49351 .54012 L
.49451 .54091 L
.4955 .54168 L
.4965 .5424 L
.4975 .54307 L
Mistroke
.4985 .54363 L
.4995 .55148 L
.5005 .54789 L
.5015 .54159 L
.5025 .53378 L
.5035 .52498 L
.5045 .51559 L
.50549 .5059 L
.50649 .4962 L
.50749 .48668 L
.50849 .47753 L
.50949 .46889 L
.51049 .46084 L
.51149 .45346 L
.51249 .44678 L
.51349 .44081 L
.51449 .43556 L
.51548 .43098 L
.51648 .42707 L
.51748 .42377 L
.51848 .42104 L
.51948 .41885 L
.52048 .41715 L
.52148 .4159 L
.52248 .41505 L
.52348 .41459 L
.52448 .41447 L
.52547 .41467 L
.52647 .41518 L
.52747 .41597 L
.52847 .41703 L
.52947 .41836 L
.53047 .41995 L
.53147 .4218 L
.53247 .42391 L
.53347 .42629 L
.53447 .42894 L
.53546 .43189 L
.53646 .43515 L
.53746 .43873 L
.53846 .44265 L
.53946 .44694 L
.54046 .45163 L
.54146 .45673 L
.54246 .46228 L
.54346 .46832 L
.54446 .47487 L
.54545 .48197 L
.54645 .48966 L
.54745 .49796 L
Mistroke
.54845 .50692 L
.54945 .42112 L
.55045 .43177 L
.55145 .44063 L
.55245 .44891 L
.55345 .45705 L
.55445 .46529 L
.55544 .47378 L
.55644 .48262 L
.55744 .49187 L
.55844 .50155 L
.55944 .51166 L
.56044 .52216 L
.56144 .53298 L
.56244 .54397 L
.56344 .55498 L
.56444 .56576 L
.56543 .57604 L
.56643 .58547 L
.56743 .5937 L
.56843 .60034 L
.56943 .60507 L
.57043 .60769 L
.57143 .60819 L
.57243 .60688 L
.57343 .60432 L
.57443 .60109 L
.57542 .59733 L
.57642 .59272 L
.57742 .58675 L
.57842 .57908 L
.57942 .56959 L
.58042 .55841 L
.58142 .54582 L
.58242 .53221 L
.58342 .51802 L
.58442 .50368 L
.58541 .48958 L
.58641 .47605 L
.58741 .46334 L
.58841 .4516 L
.58941 .44093 L
.59041 .43138 L
.59141 .42292 L
.59241 .41551 L
.59341 .40907 L
.59441 .40352 L
.5954 .39877 L
.5964 .39471 L
.5974 .39126 L
Mistroke
.5984 .38832 L
.5994 .34522 L
.6004 .34448 L
.6014 .34251 L
.6024 .34023 L
.6034 .33791 L
.6044 .33564 L
.60539 .33345 L
.60639 .33133 L
.60739 .32928 L
.60839 .32727 L
.60939 .32528 L
.61039 .32328 L
.61139 .32127 L
.61239 .3192 L
.61339 .31707 L
.61439 .31485 L
.61538 .31254 L
.61638 .31011 L
.61738 .30755 L
.61838 .30486 L
.61938 .30203 L
.62038 .29906 L
.62138 .29595 L
.62238 .29271 L
.62338 .28937 L
.62438 .28594 L
.62537 .28247 L
.62637 .27901 L
.62737 .27565 L
.62837 .27249 L
.62937 .26965 L
.63037 .26729 L
.63137 .26559 L
.63237 .26472 L
.63337 .26485 L
.63437 .26612 L
.63536 .26858 L
.63636 .27219 L
.63736 .27684 L
.63836 .28235 L
.63936 .28853 L
.64036 .29518 L
.64136 .30208 L
.64236 .30907 L
.64336 .31599 L
.64436 .32274 L
.64535 .32921 L
.64635 .33536 L
.64735 .34114 L
Mistroke
.64835 .34654 L
.64935 .33432 L
.65035 .33798 L
.65135 .33979 L
.65235 .34077 L
.65335 .34126 L
.65435 .34141 L
.65534 .3413 L
.65634 .34099 L
.65734 .3405 L
.65834 .33984 L
.65934 .33902 L
.66034 .33805 L
.66134 .33692 L
.66234 .33562 L
.66334 .33416 L
.66434 .33252 L
.66533 .3307 L
.66633 .32867 L
.66733 .32643 L
.66833 .32396 L
.66933 .32125 L
.67033 .31828 L
.67133 .31502 L
.67233 .31146 L
.67333 .30759 L
.67433 .30339 L
.67532 .29885 L
.67632 .29397 L
.67732 .28877 L
.67832 .28328 L
.67932 .27756 L
.68032 .27174 L
.68132 .26597 L
.68232 .26052 L
.68332 .25572 L
.68432 .25206 L
.68531 .25009 L
.68631 .25032 L
.68731 .25304 L
.68831 .25822 L
.68931 .2655 L
.69031 .27437 L
.69131 .2843 L
.69231 .29481 L
.69331 .3055 L
.69431 .31602 L
.6953 .32614 L
.6963 .33566 L
.6973 .34449 L
Mistroke
.6983 .35257 L
.6993 .30095 L
.7003 .31258 L
.7013 .32208 L
.7023 .33039 L
.7033 .33782 L
.7043 .34449 L
.70529 .35052 L
.70629 .35598 L
.70729 .36092 L
.70829 .36539 L
.70929 .36945 L
.71029 .37314 L
.71129 .37651 L
.71229 .37959 L
.71329 .38242 L
.71429 .38505 L
.71528 .3875 L
.71628 .38981 L
.71728 .39202 L
.71828 .39415 L
.71928 .39622 L
.72028 .39828 L
.72128 .40034 L
.72228 .40243 L
.72328 .40457 L
.72428 .40679 L
.72527 .40911 L
.72627 .41156 L
.72727 .41415 L
.72827 .41692 L
.72927 .41988 L
.73027 .42306 L
.73127 .4265 L
.73227 .4302 L
.73327 .4342 L
.73427 .43854 L
.73526 .44323 L
.73626 .44832 L
.73726 .45382 L
.73826 .45977 L
.73926 .46621 L
.74026 .47317 L
.74126 .48067 L
.74226 .48874 L
.74326 .49742 L
.74426 .50671 L
.74525 .51663 L
.74625 .5272 L
.74725 .5384 L
Mistroke
.74825 .55022 L
.74925 .26728 L
.75025 .26133 L
.75125 .25332 L
.75225 .24436 L
.75325 .23484 L
.75425 .22503 L
.75524 .21517 L
.75624 .20551 L
.75724 .19637 L
.75824 .18808 L
.75924 .18104 L
.76024 .17572 L
.76124 .17262 L
.76224 .17227 L
.76324 .17522 L
.76424 .18192 L
.76523 .19265 L
.76623 .20727 L
.76723 .22523 L
.76823 .24564 L
.76923 .2675 L
.77023 .28984 L
.77123 .31186 L
.77223 .33296 L
.77323 .35273 L
.77423 .37093 L
.77522 .38747 L
.77622 .40234 L
.77722 .41561 L
.77822 .42736 L
.77922 .43774 L
.78022 .44686 L
.78122 .45485 L
.78222 .46184 L
.78322 .46794 L
.78422 .47325 L
.78521 .47787 L
.78621 .48188 L
.78721 .48535 L
.78821 .48837 L
.78921 .49098 L
.79021 .49325 L
.79121 .49523 L
.79221 .49697 L
.79321 .49851 L
.79421 .4999 L
.7952 .50117 L
.7962 .50237 L
.7972 .50353 L
Mistroke
.7982 .50468 L
.7992 .48124 L
.8002 .48836 L
.8012 .49339 L
.8022 .4974 L
.8032 .50076 L
.8042 .50362 L
.80519 .50608 L
.80619 .50821 L
.80719 .51002 L
.80819 .51156 L
.80919 .51283 L
.81019 .51383 L
.81119 .51458 L
.81219 .51508 L
.81319 .51535 L
.81419 .51539 L
.81518 .51522 L
.81618 .51486 L
.81718 .51432 L
.81818 .51363 L
.81918 .51282 L
.82018 .5119 L
.82118 .51092 L
.82218 .50989 L
.82318 .50884 L
.82418 .5078 L
.82517 .50679 L
.82617 .50583 L
.82717 .50494 L
.82817 .50414 L
.82917 .50344 L
.83017 .50285 L
.83117 .50238 L
.83217 .50203 L
.83317 .50182 L
.83417 .50175 L
.83516 .5018 L
.83616 .502 L
.83716 .50233 L
.83816 .50279 L
.83916 .50339 L
.84016 .50411 L
.84116 .50495 L
.84216 .5059 L
.84316 .50697 L
.84416 .50814 L
.84515 .5094 L
.84615 .51075 L
.84715 .51217 L
Mistroke
.84815 .51366 L
.84915 .51763 L
.85015 .52227 L
.85115 .52468 L
.85215 .52589 L
.85315 .52624 L
.85415 .52588 L
.85514 .52492 L
.85614 .52343 L
.85714 .52149 L
.85814 .51917 L
.85914 .51652 L
.86014 .51362 L
.86114 .51054 L
.86214 .50733 L
.86314 .50407 L
.86414 .50081 L
.86513 .49761 L
.86613 .49451 L
.86713 .49157 L
.86813 .48882 L
.86913 .4863 L
.87013 .48403 L
.87113 .48203 L
.87213 .48031 L
.87313 .4789 L
.87413 .47779 L
.87512 .47698 L
.87612 .47649 L
.87712 .47631 L
.87812 .47642 L
.87912 .47684 L
.88012 .47756 L
.88112 .47857 L
.88212 .47985 L
.88312 .48142 L
.88412 .48325 L
.88511 .48534 L
.88611 .48769 L
.88711 .49027 L
.88811 .49308 L
.88911 .49611 L
.89011 .49934 L
.89111 .50275 L
.89211 .50632 L
.89311 .51002 L
.89411 .51383 L
.8951 .51772 L
.8961 .52163 L
.8971 .52554 L
Mistroke
.8981 .52939 L
.8991 .46549 L
.9001 .47593 L
.9011 .48506 L
.9021 .49396 L
.9031 .50294 L
.9041 .51212 L
.90509 .52152 L
.90609 .53108 L
.90709 .54072 L
.90809 .55028 L
.90909 .55958 L
.91009 .56837 L
.91109 .57638 L
.91209 .58331 L
.91309 .58888 L
.91409 .59281 L
.91508 .59489 L
.91608 .59502 L
.91708 .59323 L
.91808 .58966 L
.91908 .58455 L
.92008 .57815 L
.92108 .57061 L
.92208 .56206 L
.92308 .55257 L
.92408 .54227 L
.92507 .53132 L
.92607 .51994 L
.92707 .50839 L
.92807 .4969 L
.92907 .48571 L
.93007 .47501 L
.93107 .46495 L
.93207 .45564 L
.93307 .44715 L
.93407 .43951 L
.93506 .43272 L
.93606 .42675 L
.93706 .42158 L
.93806 .41713 L
.93906 .41337 L
.94006 .41022 L
.94106 .40762 L
.94206 .40551 L
.94306 .40385 L
.94406 .40257 L
.94505 .40164 L
.94605 .401 L
.94705 .40063 L
Mistroke
.94805 .4005 L
.94905 .33697 L
.95005 .34017 L
.95105 .34143 L
.95205 .34183 L
.95305 .3417 L
.95405 .34121 L
.95504 .34043 L
.95604 .33942 L
.95704 .3382 L
.95804 .33678 L
.95904 .33516 L
.96004 .33335 L
.96104 .33134 L
.96204 .32912 L
.96304 .32667 L
.96404 .32399 L
.96503 .32106 L
.96603 .31785 L
.96703 .31436 L
.96803 .31055 L
.96903 .30642 L
.97003 .30193 L
.97103 .29706 L
.97203 .29182 L
.97303 .28618 L
.97403 .28017 L
.97502 .27381 L
.97602 .26717 L
.97702 .26037 L
.97802 .25358 L
.97902 .2471 L
.98002 .24135 L
.98102 .23694 L
.98202 .23463 L
.98302 .23515 L
.98402 .23894 L
.98501 .24586 L
.98601 .25533 L
.98701 .26662 L
.98801 .27904 L
.98901 .29197 L
.99001 .30492 L
.99101 .31749 L
.99201 .32942 L
.99301 .34052 L
.99401 .3507 L
.995 .35993 L
.996 .36827 L
.997 .37577 L
Mistroke
.998 .38254 L
.999 .32111 L
Mfstroke
1 0 0 r
gsave
.999 .31365 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36653 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .3649 L
.00999 .36425 L
.01099 .36349 L
.01199 .36263 L
.01299 .36165 L
.01399 .36054 L
.01499 .35929 L
.01598 .35788 L
.01698 .3563 L
.01798 .35453 L
.01898 .35256 L
.01998 .35036 L
.02098 .34791 L
.02198 .34522 L
.02298 .34226 L
.02398 .33903 L
.02498 .33554 L
.02597 .33183 L
.02697 .32793 L
.02797 .32393 L
.02897 .31997 L
.02997 .31623 L
.03097 .31297 L
.03197 .31053 L
.03297 .30934 L
.03397 .30989 L
.03497 .3127 L
.03596 .31829 L
.03696 .32702 L
.03796 .33904 L
.03896 .35415 L
.03996 .37172 L
.04096 .39067 L
.04196 .40964 L
.04296 .42708 L
.04396 .44151 L
.04496 .45178 L
.04595 .45721 L
.04695 .45772 L
.04795 .45378 L
.04895 .44628 L
Mistroke
.04995 .10992 L
.05095 .1012 L
.05195 .097 L
.05295 .09827 L
.05395 .10571 L
.05495 .11952 L
.05594 .13939 L
.05694 .16442 L
.05794 .19327 L
.05894 .2244 L
.05994 .25625 L
.06094 .28752 L
.06194 .31718 L
.06294 .34457 L
.06394 .36932 L
.06494 .39129 L
.06593 .41049 L
.06693 .42702 L
.06793 .44103 L
.06893 .45269 L
.06993 .46218 L
.07093 .46967 L
.07193 .47534 L
.07293 .47935 L
.07393 .48187 L
.07493 .48308 L
.07592 .48315 L
.07692 .48226 L
.07792 .48059 L
.07892 .47829 L
.07992 .47553 L
.08092 .47244 L
.08192 .46914 L
.08292 .46574 L
.08392 .46231 L
.08492 .45891 L
.08591 .45559 L
.08691 .45238 L
.08791 .44928 L
.08891 .4463 L
.08991 .44345 L
.09091 .44071 L
.09191 .43809 L
.09291 .43557 L
.09391 .43315 L
.09491 .43082 L
.0959 .42857 L
.0969 .4264 L
.0979 .42432 L
.0989 .42232 L
Mistroke
.0999 .40556 L
.1009 .40457 L
.1019 .4039 L
.1029 .40352 L
.1039 .40342 L
.1049 .40358 L
.10589 .40397 L
.10689 .40461 L
.10789 .40547 L
.10889 .40655 L
.10989 .40785 L
.11089 .40938 L
.11189 .41112 L
.11289 .4131 L
.11389 .41531 L
.11489 .41777 L
.11588 .42048 L
.11688 .42345 L
.11788 .4267 L
.11888 .43024 L
.11988 .43408 L
.12088 .43823 L
.12188 .4427 L
.12288 .4475 L
.12388 .45263 L
.12488 .45808 L
.12587 .46384 L
.12687 .4699 L
.12787 .47622 L
.12887 .48275 L
.12987 .48945 L
.13087 .49622 L
.13187 .50298 L
.13287 .50962 L
.13387 .51601 L
.13487 .52201 L
.13586 .52748 L
.13686 .53227 L
.13786 .53626 L
.13886 .53932 L
.13986 .54137 L
.14086 .54235 L
.14186 .54222 L
.14286 .54098 L
.14386 .53865 L
.14486 .53525 L
.14585 .53081 L
.14685 .52537 L
.14785 .51896 L
.14885 .51163 L
Mistroke
.14985 .56216 L
.15085 .5477 L
.15185 .53232 L
.15285 .51641 L
.15385 .50039 L
.15485 .48465 L
.15584 .46951 L
.15684 .45521 L
.15784 .44192 L
.15884 .42976 L
.15984 .41875 L
.16084 .40889 L
.16184 .40013 L
.16284 .39241 L
.16384 .38564 L
.16484 .37973 L
.16583 .37457 L
.16683 .37008 L
.16783 .36616 L
.16883 .36272 L
.16983 .35968 L
.17083 .35698 L
.17183 .35453 L
.17283 .3523 L
.17383 .35022 L
.17483 .34824 L
.17582 .34633 L
.17682 .34446 L
.17782 .34258 L
.17882 .34067 L
.17982 .33871 L
.18082 .33667 L
.18182 .33453 L
.18282 .33228 L
.18382 .3299 L
.18482 .32738 L
.18581 .32471 L
.18681 .32188 L
.18781 .31889 L
.18881 .31574 L
.18981 .31242 L
.19081 .30896 L
.19181 .30537 L
.19281 .30168 L
.19381 .29791 L
.19481 .29411 L
.1958 .29034 L
.1968 .28666 L
.1978 .28314 L
.1988 .27988 L
Mistroke
.1998 .28452 L
.2008 .27468 L
.2018 .26508 L
.2028 .25562 L
.2038 .24626 L
.2048 .23699 L
.20579 .22784 L
.20679 .21888 L
.20779 .21022 L
.20879 .20202 L
.20979 .19447 L
.21079 .18779 L
.21179 .18222 L
.21279 .17801 L
.21379 .17542 L
.21479 .17465 L
.21578 .17586 L
.21678 .17913 L
.21778 .18447 L
.21878 .19176 L
.21978 .20081 L
.22078 .21135 L
.22178 .22304 L
.22278 .23551 L
.22378 .2484 L
.22478 .26136 L
.22577 .27411 L
.22677 .28639 L
.22777 .29802 L
.22877 .30886 L
.22977 .31884 L
.23077 .32792 L
.23177 .3361 L
.23277 .34342 L
.23377 .34991 L
.23477 .35564 L
.23576 .36069 L
.23676 .36511 L
.23776 .36898 L
.23876 .37237 L
.23976 .37536 L
.24076 .37799 L
.24176 .38033 L
.24276 .38243 L
.24376 .38434 L
.24476 .3861 L
.24575 .38774 L
.24675 .3893 L
.24775 .3908 L
.24875 .39227 L
Mistroke
.24975 .45282 L
.25075 .45516 L
.25175 .45763 L
.25275 .46025 L
.25375 .463 L
.25475 .4659 L
.25574 .46892 L
.25674 .47207 L
.25774 .47533 L
.25874 .47869 L
.25974 .48211 L
.26074 .48558 L
.26174 .48906 L
.26274 .49252 L
.26374 .49591 L
.26474 .49919 L
.26573 .50229 L
.26673 .50518 L
.26773 .50778 L
.26873 .51005 L
.26973 .51192 L
.27073 .51334 L
.27173 .51427 L
.27273 .51465 L
.27373 .51447 L
.27473 .51371 L
.27572 .51235 L
.27672 .51042 L
.27772 .50795 L
.27872 .50496 L
.27972 .50151 L
.28072 .49766 L
.28172 .49349 L
.28272 .48907 L
.28372 .48447 L
.28472 .47976 L
.28571 .47503 L
.28671 .47033 L
.28771 .46572 L
.28871 .46127 L
.28971 .457 L
.29071 .45297 L
.29171 .44919 L
.29271 .4457 L
.29371 .4425 L
.29471 .4396 L
.2957 .43701 L
.2967 .43473 L
.2977 .43276 L
.2987 .43108 L
Mistroke
.2997 .42273 L
.3007 .4225 L
.3017 .42253 L
.3027 .42281 L
.3037 .42334 L
.3047 .42411 L
.30569 .42512 L
.30669 .42637 L
.30769 .42787 L
.30869 .42961 L
.30969 .43159 L
.31069 .43382 L
.31169 .43631 L
.31269 .43904 L
.31369 .44204 L
.31469 .4453 L
.31568 .44882 L
.31668 .4526 L
.31768 .45664 L
.31868 .46093 L
.31968 .46548 L
.32068 .47025 L
.32168 .47523 L
.32268 .48038 L
.32368 .48569 L
.32468 .49109 L
.32567 .49652 L
.32667 .50193 L
.32767 .50723 L
.32867 .51232 L
.32967 .51712 L
.33067 .52152 L
.33167 .5254 L
.33267 .52865 L
.33367 .53119 L
.33467 .5329 L
.33566 .53372 L
.33666 .53358 L
.33766 .53245 L
.33866 .53032 L
.33966 .5272 L
.34066 .52313 L
.34166 .51817 L
.34266 .51242 L
.34366 .50596 L
.34466 .49893 L
.34565 .49145 L
.34665 .48366 L
.34765 .47569 L
.34865 .46767 L
Mistroke
.34965 .51526 L
.35065 .50888 L
.35165 .50193 L
.35265 .49455 L
.35365 .48692 L
.35465 .47917 L
.35564 .47146 L
.35664 .46391 L
.35764 .45664 L
.35864 .44972 L
.35964 .44323 L
.36064 .43721 L
.36164 .43169 L
.36264 .42669 L
.36364 .42219 L
.36464 .4182 L
.36563 .41469 L
.36663 .41165 L
.36763 .40903 L
.36863 .40683 L
.36963 .40501 L
.37063 .40353 L
.37163 .40238 L
.37263 .40153 L
.37363 .40095 L
.37463 .40063 L
.37562 .40055 L
.37662 .40069 L
.37762 .40103 L
.37862 .40157 L
.37962 .40231 L
.38062 .40322 L
.38162 .40432 L
.38262 .40559 L
.38362 .40703 L
.38462 .40864 L
.38561 .41043 L
.38661 .41238 L
.38761 .41451 L
.38861 .4168 L
.38961 .41927 L
.39061 .42189 L
.39161 .42467 L
.39261 .4276 L
.39361 .43065 L
.39461 .43381 L
.3956 .43706 L
.3966 .44035 L
.3976 .44365 L
.3986 .44691 L
Mistroke
.3996 .32511 L
.4006 .32354 L
.4016 .32138 L
.4026 .31868 L
.4036 .31545 L
.4046 .31171 L
.40559 .30746 L
.40659 .30271 L
.40759 .29744 L
.40859 .29166 L
.40959 .28535 L
.41059 .27851 L
.41159 .27114 L
.41259 .26325 L
.41359 .25487 L
.41459 .24604 L
.41558 .23683 L
.41658 .22734 L
.41758 .2177 L
.41858 .20807 L
.41958 .19869 L
.42058 .18982 L
.42158 .18175 L
.42258 .17483 L
.42358 .16941 L
.42458 .16583 L
.42557 .16441 L
.42657 .1654 L
.42757 .16893 L
.42857 .17505 L
.42957 .18366 L
.43057 .19454 L
.43157 .20738 L
.43257 .22176 L
.43357 .23726 L
.43457 .25339 L
.43556 .26973 L
.43656 .28589 L
.43756 .30153 L
.43856 .3164 L
.43956 .33032 L
.44056 .34316 L
.44156 .35487 L
.44256 .36543 L
.44356 .37488 L
.44456 .38327 L
.44555 .39068 L
.44655 .39718 L
.44755 .40286 L
.44855 .40781 L
Mistroke
.44955 .40478 L
.45055 .41025 L
.45155 .41497 L
.45255 .41905 L
.45355 .42258 L
.45455 .42563 L
.45554 .42828 L
.45654 .4306 L
.45754 .43265 L
.45854 .43449 L
.45954 .43617 L
.46054 .43772 L
.46154 .43918 L
.46254 .4406 L
.46354 .44198 L
.46454 .44337 L
.46553 .44477 L
.46653 .44621 L
.46753 .44769 L
.46853 .44924 L
.46953 .45085 L
.47053 .45253 L
.47153 .45428 L
.47253 .45611 L
.47353 .45802 L
.47453 .45999 L
.47552 .46204 L
.47652 .46414 L
.47752 .46628 L
.47852 .46847 L
.47952 .47068 L
.48052 .47289 L
.48152 .4751 L
.48252 .47728 L
.48352 .47941 L
.48452 .48148 L
.48551 .48344 L
.48651 .4853 L
.48751 .48701 L
.48851 .48856 L
.48951 .48992 L
.49051 .49108 L
.49151 .49201 L
.49251 .4927 L
.49351 .49313 L
.49451 .49328 L
.4955 .49316 L
.4965 .49276 L
.4975 .49206 L
.4985 .49108 L
Mistroke
.4995 .54418 L
.5005 .53611 L
.5015 .52707 L
.5025 .51724 L
.5035 .50684 L
.5045 .49608 L
.50549 .48519 L
.50649 .47438 L
.50749 .46385 L
.50849 .45373 L
.50949 .44415 L
.51049 .4352 L
.51149 .42692 L
.51249 .41935 L
.51349 .41248 L
.51449 .4063 L
.51548 .40078 L
.51648 .39588 L
.51748 .39156 L
.51848 .38776 L
.51948 .38445 L
.52048 .38156 L
.52148 .37904 L
.52248 .37687 L
.52348 .37498 L
.52448 .37335 L
.52547 .37193 L
.52647 .37069 L
.52747 .36961 L
.52847 .36866 L
.52947 .36781 L
.53047 .36706 L
.53147 .36637 L
.53247 .36573 L
.53347 .36513 L
.53447 .36457 L
.53546 .36402 L
.53646 .36348 L
.53746 .36294 L
.53846 .3624 L
.53946 .36185 L
.54046 .36129 L
.54146 .36072 L
.54246 .36012 L
.54346 .35951 L
.54446 .35887 L
.54545 .35822 L
.54645 .35756 L
.54745 .35688 L
.54845 .35621 L
Mistroke
.54945 .41395 L
.55045 .42007 L
.55145 .42614 L
.55245 .43227 L
.55345 .43855 L
.55445 .44505 L
.55544 .45183 L
.55644 .45895 L
.55744 .46643 L
.55844 .47429 L
.55944 .48254 L
.56044 .49117 L
.56144 .50013 L
.56244 .50936 L
.56344 .51875 L
.56444 .52817 L
.56543 .53743 L
.56643 .54633 L
.56743 .55458 L
.56843 .5619 L
.56943 .56795 L
.57043 .5724 L
.57143 .57493 L
.57243 .57528 L
.57343 .57323 L
.57443 .5687 L
.57542 .5617 L
.57642 .55239 L
.57742 .54101 L
.57842 .52794 L
.57942 .51358 L
.58042 .49839 L
.58142 .4828 L
.58242 .46722 L
.58342 .45199 L
.58442 .43739 L
.58541 .42363 L
.58641 .41083 L
.58741 .39908 L
.58841 .3884 L
.58941 .37879 L
.59041 .37019 L
.59141 .36254 L
.59241 .35577 L
.59341 .3498 L
.59441 .34453 L
.5954 .33989 L
.5964 .3358 L
.5974 .33217 L
.5984 .32894 L
Mistroke
.5994 .33781 L
.6004 .33264 L
.6014 .32795 L
.6024 .32367 L
.6034 .31972 L
.6044 .31602 L
.60539 .31251 L
.60639 .30913 L
.60739 .30584 L
.60839 .30259 L
.60939 .29935 L
.61039 .29609 L
.61139 .29279 L
.61239 .28942 L
.61339 .28597 L
.61439 .28244 L
.61538 .27882 L
.61638 .27511 L
.61738 .27131 L
.61838 .26745 L
.61938 .26354 L
.62038 .2596 L
.62138 .25567 L
.62238 .25177 L
.62338 .24796 L
.62438 .24428 L
.62537 .24078 L
.62637 .23753 L
.62737 .23457 L
.62837 .23197 L
.62937 .22979 L
.63037 .22808 L
.63137 .2269 L
.63237 .22628 L
.63337 .22627 L
.63437 .22687 L
.63536 .2281 L
.63636 .22995 L
.63736 .23241 L
.63836 .23544 L
.63936 .23899 L
.64036 .24301 L
.64136 .24743 L
.64236 .2522 L
.64336 .25722 L
.64436 .26243 L
.64535 .26774 L
.64635 .27309 L
.64735 .27841 L
.64835 .28363 L
Mistroke
.64935 .32694 L
.65035 .32621 L
.65135 .32535 L
.65235 .32435 L
.65335 .3232 L
.65435 .3219 L
.65534 .32042 L
.65634 .31877 L
.65734 .31694 L
.65834 .31492 L
.65934 .31269 L
.66034 .31027 L
.66134 .30762 L
.66234 .30476 L
.66334 .30168 L
.66434 .29836 L
.66533 .2948 L
.66633 .29101 L
.66733 .28698 L
.66833 .28272 L
.66933 .27824 L
.67033 .27354 L
.67133 .26866 L
.67233 .26361 L
.67333 .25843 L
.67433 .25316 L
.67532 .24786 L
.67632 .24259 L
.67732 .23742 L
.67832 .23244 L
.67932 .22773 L
.68032 .2234 L
.68132 .21954 L
.68232 .21626 L
.68332 .21366 L
.68432 .21181 L
.68531 .21081 L
.68631 .21071 L
.68731 .21155 L
.68831 .21336 L
.68931 .21611 L
.69031 .2198 L
.69131 .22436 L
.69231 .22973 L
.69331 .23581 L
.69431 .24251 L
.6953 .2497 L
.6963 .25725 L
.6973 .26505 L
.6983 .27295 L
Mistroke
.6993 .29354 L
.7003 .30074 L
.7013 .30755 L
.7023 .31391 L
.7033 .31979 L
.7043 .32516 L
.70529 .33002 L
.70629 .33439 L
.70729 .33828 L
.70829 .34171 L
.70929 .34472 L
.71029 .34734 L
.71129 .34959 L
.71229 .35151 L
.71329 .35313 L
.71429 .35448 L
.71528 .35558 L
.71628 .35647 L
.71728 .35716 L
.71828 .35768 L
.71928 .35804 L
.72028 .35826 L
.72128 .35835 L
.72228 .35832 L
.72328 .35818 L
.72428 .35794 L
.72527 .3576 L
.72627 .35717 L
.72727 .35665 L
.72827 .35604 L
.72927 .35535 L
.73027 .35457 L
.73127 .3537 L
.73227 .35275 L
.73327 .3517 L
.73427 .35057 L
.73526 .34935 L
.73626 .34804 L
.73726 .34664 L
.73826 .34516 L
.73926 .34359 L
.74026 .34196 L
.74126 .34027 L
.74226 .33853 L
.74326 .33678 L
.74426 .33504 L
.74525 .33336 L
.74625 .33178 L
.74725 .33037 L
.74825 .32919 L
Mistroke
.74925 .26003 L
.75025 .24953 L
.75125 .23866 L
.75225 .22746 L
.75325 .21602 L
.75425 .20447 L
.75524 .19304 L
.75624 .18199 L
.75724 .17166 L
.75824 .16247 L
.75924 .15488 L
.76024 .14937 L
.76124 .14643 L
.76224 .14647 L
.76324 .14979 L
.76424 .15653 L
.76523 .16662 L
.76623 .17978 L
.76723 .19555 L
.76823 .21332 L
.76923 .23241 L
.77023 .25214 L
.77123 .27188 L
.77223 .29111 L
.77323 .30942 L
.77423 .32654 L
.77522 .3423 L
.77622 .35662 L
.77722 .36949 L
.77822 .38096 L
.77922 .39111 L
.78022 .40004 L
.78122 .40786 L
.78222 .41468 L
.78322 .42063 L
.78422 .4258 L
.78521 .43029 L
.78621 .43421 L
.78721 .43762 L
.78821 .44062 L
.78921 .44325 L
.79021 .44559 L
.79121 .44769 L
.79221 .44959 L
.79321 .45133 L
.79421 .45295 L
.7952 .45447 L
.7962 .45593 L
.7972 .45734 L
.7982 .45873 L
Mistroke
.7992 .47398 L
.8002 .47663 L
.8012 .47897 L
.8022 .48102 L
.8032 .48281 L
.8042 .48435 L
.80519 .48563 L
.80619 .48668 L
.80719 .48749 L
.80819 .48807 L
.80919 .48842 L
.81019 .48854 L
.81119 .48845 L
.81219 .48815 L
.81319 .48765 L
.81419 .48696 L
.81518 .48608 L
.81618 .48505 L
.81718 .48386 L
.81818 .48255 L
.81918 .48112 L
.82018 .4796 L
.82118 .47801 L
.82218 .47637 L
.82318 .4747 L
.82418 .47302 L
.82517 .47135 L
.82617 .46972 L
.82717 .46813 L
.82817 .4666 L
.82917 .46516 L
.83017 .4638 L
.83117 .46255 L
.83217 .46141 L
.83317 .46039 L
.83417 .4595 L
.83516 .45873 L
.83616 .45811 L
.83716 .45762 L
.83816 .45726 L
.83916 .45705 L
.84016 .45697 L
.84116 .45704 L
.84216 .45723 L
.84316 .45755 L
.84416 .45801 L
.84515 .45858 L
.84615 .45927 L
.84715 .46007 L
.84815 .46098 L
Mistroke
.84915 .51038 L
.85015 .51055 L
.85115 .51028 L
.85215 .50958 L
.85315 .50841 L
.85415 .50679 L
.85514 .50474 L
.85614 .50226 L
.85714 .49941 L
.85814 .49622 L
.85914 .49274 L
.86014 .48903 L
.86114 .48515 L
.86214 .48116 L
.86314 .47711 L
.86414 .47307 L
.86513 .46908 L
.86613 .46519 L
.86713 .46145 L
.86813 .4579 L
.86913 .45455 L
.87013 .45145 L
.87113 .44859 L
.87213 .44601 L
.87313 .4437 L
.87413 .44167 L
.87512 .43993 L
.87612 .43846 L
.87712 .43727 L
.87812 .43636 L
.87912 .43571 L
.88012 .43532 L
.88112 .43518 L
.88212 .43529 L
.88312 .43564 L
.88412 .43621 L
.88511 .43702 L
.88611 .43803 L
.88711 .43927 L
.88811 .4407 L
.88911 .44234 L
.89011 .44417 L
.89111 .44618 L
.89211 .44838 L
.89311 .45075 L
.89411 .45328 L
.8951 .45596 L
.8961 .45879 L
.8971 .46174 L
.8981 .4648 L
Mistroke
.8991 .45829 L
.9001 .4642 L
.9011 .47055 L
.9021 .47732 L
.9031 .4845 L
.9041 .49203 L
.90509 .49987 L
.90609 .50795 L
.90709 .51617 L
.90809 .52439 L
.90909 .53248 L
.91009 .54023 L
.91109 .54743 L
.91209 .55384 L
.91309 .55919 L
.91409 .56321 L
.91508 .56564 L
.91608 .56626 L
.91708 .5649 L
.91808 .56146 L
.91908 .55594 L
.92008 .54843 L
.92108 .53911 L
.92208 .52825 L
.92308 .5162 L
.92408 .5033 L
.92507 .48992 L
.92607 .47642 L
.92707 .46308 L
.92807 .45018 L
.92907 .43789 L
.93007 .42637 L
.93107 .4157 L
.93207 .40593 L
.93307 .39705 L
.93407 .38905 L
.93506 .38189 L
.93606 .37551 L
.93706 .36984 L
.93806 .36481 L
.93906 .36036 L
.94006 .35641 L
.94106 .35289 L
.94206 .34974 L
.94306 .34689 L
.94406 .34431 L
.94505 .34192 L
.94605 .3397 L
.94705 .3376 L
.94805 .33558 L
Mistroke
.94905 .32969 L
.95005 .32843 L
.95105 .32699 L
.95205 .32537 L
.95305 .32356 L
.95405 .32154 L
.95504 .31932 L
.95604 .31688 L
.95704 .31421 L
.95804 .3113 L
.95904 .30814 L
.96004 .30471 L
.96104 .30102 L
.96204 .29705 L
.96304 .29279 L
.96404 .28824 L
.96503 .2834 L
.96603 .27827 L
.96703 .27286 L
.96803 .26719 L
.96903 .26129 L
.97003 .25519 L
.97103 .24893 L
.97203 .24259 L
.97303 .23624 L
.97403 .22996 L
.97502 .22388 L
.97602 .21811 L
.97702 .21278 L
.97802 .20805 L
.97902 .20406 L
.98002 .20095 L
.98102 .19886 L
.98202 .19789 L
.98302 .19814 L
.98402 .19966 L
.98501 .20246 L
.98601 .20653 L
.98701 .2118 L
.98801 .21818 L
.98901 .22555 L
.99001 .23374 L
.99101 .24259 L
.99201 .25191 L
.99301 .26153 L
.99401 .27124 L
.995 .2809 L
.996 .29034 L
.997 .29945 L
.998 .30811 L
Mistroke
.999 .31365 L
Mfstroke
0 g
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .30608 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28377 L
.005 .27889 L
.00599 .27358 L
.00699 .26776 L
.00799 .26135 L
.00899 .25426 L
.00999 .24642 L
.01099 .2377 L
.01199 .22801 L
.01299 .21721 L
.01399 .20518 L
.01499 .19178 L
.01598 .17683 L
.01698 .16019 L
.01798 .14169 L
.01898 .12115 L
.01998 .09843 L
.02098 .07339 L
.02198 .04593 L
.02298 .01602 L
s
.02298 .01602 m
.02347 0 L
s
.03934 0 m
.03996 .04305 L
.04096 .10754 L
.04196 .16277 L
.04296 .20266 L
.04396 .21822 L
.04496 .19993 L
.04595 .1488 L
.04695 .08047 L
.04795 .01242 L
s
.04795 .01242 m
.04817 0 L
s
.04963 0 m
.04995 .0205 L
.05095 .04188 L
.05195 .07423 L
.05295 .11579 L
.05395 .16359 L
.05495 .21377 L
.05594 .26228 L
.05694 .30561 L
.05794 .3414 L
.05894 .36871 L
.05994 .38788 L
.06094 .40014 L
.06194 .4071 L
.06294 .41039 L
.06394 .41136 L
.06494 .41105 L
.06593 .41011 L
.06693 .40885 L
.06793 .40714 L
.06893 .40438 L
.06993 .39945 L
.07093 .39106 L
.07193 .37858 L
.07293 .36257 L
.07393 .34427 L
.07493 .32495 L
.07592 .30565 L
.07692 .28717 L
.07792 .27008 L
.07892 .25477 L
.07992 .24146 L
.08092 .23024 L
.08192 .22106 L
.08292 .21381 L
.08392 .20831 L
.08492 .20438 L
.08591 .20178 L
.08691 .20029 L
.08791 .19971 L
.08891 .19985 L
.08991 .20052 L
.09091 .20158 L
.09191 .20287 L
.09291 .2043 L
.09391 .20575 L
.09491 .20714 L
.0959 .20841 L
.0969 .20951 L
.0979 .21039 L
Mistroke
.0989 .21101 L
.0999 .32463 L
.1009 .32209 L
.1019 .32082 L
.1029 .3201 L
.1039 .31971 L
.1049 .31955 L
.10589 .31955 L
.10689 .31967 L
.10789 .3199 L
.10889 .32021 L
.10989 .32059 L
.11089 .32106 L
.11189 .3216 L
.11289 .32223 L
.11389 .32295 L
.11489 .32378 L
.11588 .32473 L
.11688 .32582 L
.11788 .32709 L
.11888 .32855 L
.11988 .33024 L
.12088 .33222 L
.12188 .33452 L
.12288 .33722 L
.12388 .34039 L
.12488 .3441 L
.12587 .34845 L
.12687 .35353 L
.12787 .35945 L
.12887 .36627 L
.12987 .37407 L
.13087 .38282 L
.13187 .39238 L
.13287 .40238 L
.13387 .41193 L
.13487 .41932 L
.13586 .42164 L
.13686 .41581 L
.13786 .40125 L
.13886 .38006 L
.13986 .35492 L
.14086 .3281 L
.14186 .30147 L
.14286 .27658 L
.14386 .25461 L
.14486 .23643 L
.14585 .22249 L
.14685 .21288 L
.14785 .20732 L
Mistroke
.14885 .20523 L
.14985 .35547 L
.15085 .33217 L
.15185 .31206 L
.15285 .2951 L
.15385 .28127 L
.15485 .2704 L
.15584 .26217 L
.15684 .25618 L
.15784 .252 L
.15884 .24921 L
.15984 .24744 L
.16084 .24637 L
.16184 .24572 L
.16284 .24529 L
.16384 .24491 L
.16484 .24444 L
.16583 .24378 L
.16683 .24288 L
.16783 .24166 L
.16883 .24009 L
.16983 .23814 L
.17083 .23579 L
.17183 .23302 L
.17283 .22981 L
.17383 .22616 L
.17483 .22206 L
.17582 .21748 L
.17682 .21242 L
.17782 .20687 L
.17882 .20081 L
.17982 .19424 L
.18082 .18715 L
.18182 .17953 L
.18282 .17139 L
.18382 .16274 L
.18482 .1536 L
.18581 .144 L
.18681 .134 L
.18781 .12366 L
.18881 .1131 L
.18981 .10244 L
.19081 .09185 L
.19181 .08153 L
.19281 .07173 L
.19381 .06272 L
.19481 .05484 L
.1958 .04841 L
.1968 .0438 L
.1978 .04135 L
Mistroke
.1988 .04133 L
.1998 .15645 L
.2008 .14597 L
.2018 .13604 L
.2028 .12625 L
.2038 .11667 L
.2048 .10757 L
.20579 .09929 L
.20679 .09223 L
.20779 .08682 L
.20879 .08346 L
.20979 .08252 L
.21079 .08422 L
.21179 .08863 L
.21279 .09562 L
.21379 .10496 L
.21479 .11635 L
.21578 .12949 L
.21678 .14408 L
.21778 .15976 L
.21878 .17609 L
.21978 .19258 L
.22078 .20867 L
.22178 .22384 L
.22278 .23765 L
.22378 .24978 L
.22478 .26003 L
.22577 .26839 L
.22677 .27491 L
.22777 .27978 L
.22877 .28318 L
.22977 .28537 L
.23077 .28654 L
.23177 .28689 L
.23277 .28659 L
.23377 .28577 L
.23477 .28454 L
.23576 .28298 L
.23676 .28115 L
.23776 .27909 L
.23876 .27684 L
.23976 .2744 L
.24076 .2718 L
.24176 .26902 L
.24276 .26608 L
.24376 .26295 L
.24476 .25962 L
.24575 .25609 L
.24675 .25232 L
.24775 .24829 L
Mistroke
.24875 .24399 L
.24975 .38863 L
.25075 .38758 L
.25175 .38779 L
.25275 .38858 L
.25375 .38972 L
.25475 .39108 L
.25574 .3926 L
.25674 .39422 L
.25774 .3959 L
.25874 .3976 L
.25974 .39927 L
.26074 .40086 L
.26174 .40233 L
.26274 .40362 L
.26374 .40465 L
.26474 .40535 L
.26573 .40562 L
.26673 .40536 L
.26773 .40444 L
.26873 .40276 L
.26973 .40019 L
.27073 .39665 L
.27173 .39211 L
.27273 .38659 L
.27373 .38018 L
.27473 .37305 L
.27572 .3654 L
.27672 .35747 L
.27772 .34949 L
.27872 .3417 L
.27972 .33428 L
.28072 .3274 L
.28172 .32115 L
.28272 .31562 L
.28372 .3108 L
.28472 .30671 L
.28571 .3033 L
.28671 .30051 L
.28771 .29829 L
.28871 .29655 L
.28971 .29523 L
.29071 .29427 L
.29171 .2936 L
.29271 .29317 L
.29371 .29292 L
.29471 .29283 L
.2957 .29284 L
.2967 .29294 L
.2977 .2931 L
Mistroke
.2987 .29329 L
.2997 .34437 L
.3007 .34209 L
.3017 .34114 L
.3027 .34085 L
.3037 .34099 L
.3047 .34145 L
.30569 .34218 L
.30669 .34313 L
.30769 .34429 L
.30869 .34564 L
.30969 .34719 L
.31069 .34892 L
.31169 .35086 L
.31269 .353 L
.31369 .35536 L
.31469 .35795 L
.31568 .3608 L
.31668 .36391 L
.31768 .36731 L
.31868 .37102 L
.31968 .37505 L
.32068 .37941 L
.32168 .3841 L
.32268 .38911 L
.32368 .39438 L
.32468 .39982 L
.32567 .40528 L
.32667 .41051 L
.32767 .4151 L
.32867 .41847 L
.32967 .41988 L
.33067 .41852 L
.33167 .41384 L
.33267 .40574 L
.33367 .39464 L
.33467 .38122 L
.33566 .36631 L
.33666 .35072 L
.33766 .33522 L
.33866 .32048 L
.33966 .30703 L
.34066 .29526 L
.34166 .28536 L
.34266 .27736 L
.34366 .27115 L
.34466 .26648 L
.34565 .26305 L
.34665 .26051 L
.34765 .25856 L
Mistroke
.34865 .25694 L
.34965 .37531 L
.35065 .36159 L
.35165 .34961 L
.35265 .33896 L
.35365 .32958 L
.35465 .32144 L
.35564 .3145 L
.35664 .30869 L
.35764 .30392 L
.35864 .30008 L
.35964 .29703 L
.36064 .29467 L
.36164 .29286 L
.36264 .29151 L
.36364 .2905 L
.36464 .28976 L
.36563 .2892 L
.36663 .28876 L
.36763 .28839 L
.36863 .28804 L
.36963 .28767 L
.37063 .28726 L
.37163 .28677 L
.37263 .2862 L
.37363 .28552 L
.37463 .28473 L
.37562 .28381 L
.37662 .28276 L
.37762 .28158 L
.37862 .28025 L
.37962 .27877 L
.38062 .27714 L
.38162 .27536 L
.38262 .27343 L
.38362 .27133 L
.38462 .26909 L
.38561 .26669 L
.38661 .26415 L
.38761 .26147 L
.38861 .25867 L
.38961 .25576 L
.39061 .25276 L
.39161 .24971 L
.39261 .24665 L
.39361 .24362 L
.39461 .24067 L
.3956 .23787 L
.3966 .23529 L
.3976 .233 L
Mistroke
.3986 .23107 L
.3996 .25266 L
.4006 .24285 L
.4016 .23386 L
.4026 .22489 L
.4036 .21565 L
.4046 .206 L
.40559 .19585 L
.40659 .18517 L
.40759 .17393 L
.40859 .16216 L
.40959 .14992 L
.41059 .13734 L
.41159 .12456 L
.41259 .11184 L
.41359 .09947 L
.41459 .08786 L
.41558 .07747 L
.41658 .06883 L
.41758 .06246 L
.41858 .05875 L
.41958 .05771 L
.42058 .05863 L
.42158 .05989 L
.42258 .06001 L
.42358 .0593 L
.42458 .05941 L
.42557 .06208 L
.42657 .06863 L
.42757 .07987 L
.42857 .09605 L
.42957 .11683 L
.43057 .1413 L
.43157 .16811 L
.43257 .19564 L
.43357 .22227 L
.43457 .24658 L
.43556 .26758 L
.43656 .28477 L
.43756 .29811 L
.43856 .30795 L
.43956 .31487 L
.44056 .31949 L
.44156 .3224 L
.44256 .32408 L
.44356 .3249 L
.44456 .32514 L
.44555 .32501 L
.44655 .32465 L
.44755 .32418 L
Mistroke
.44855 .32366 L
.44955 .37388 L
.45055 .36874 L
.45155 .3649 L
.45255 .36172 L
.45355 .35903 L
.45455 .35674 L
.45554 .35479 L
.45654 .35315 L
.45754 .35179 L
.45854 .35069 L
.45954 .34983 L
.46054 .34919 L
.46154 .34875 L
.46254 .34851 L
.46354 .34845 L
.46454 .34855 L
.46553 .34882 L
.46653 .34924 L
.46753 .34981 L
.46853 .35052 L
.46953 .35136 L
.47053 .35233 L
.47153 .35343 L
.47253 .35463 L
.47353 .35595 L
.47453 .35735 L
.47552 .35884 L
.47652 .36039 L
.47752 .36198 L
.47852 .36358 L
.47952 .36514 L
.48052 .36663 L
.48152 .36798 L
.48252 .36912 L
.48352 .36999 L
.48452 .37049 L
.48551 .37055 L
.48651 .37009 L
.48751 .36905 L
.48851 .36739 L
.48951 .36509 L
.49051 .36219 L
.49151 .35872 L
.49251 .35476 L
.49351 .35042 L
.49451 .34581 L
.4955 .34102 L
.4965 .33619 L
.4975 .3314 L
Mistroke
.4985 .32675 L
.4995 .38409 L
.5005 .36568 L
.5015 .34891 L
.5025 .33361 L
.5035 .31993 L
.5045 .30799 L
.50549 .29781 L
.50649 .28937 L
.50749 .28252 L
.50849 .27712 L
.50949 .27295 L
.51049 .26982 L
.51149 .26753 L
.51249 .26588 L
.51349 .26472 L
.51449 .26389 L
.51548 .26327 L
.51648 .26276 L
.51748 .26228 L
.51848 .26174 L
.51948 .26111 L
.52048 .26032 L
.52148 .25935 L
.52248 .25816 L
.52348 .25674 L
.52448 .25506 L
.52547 .2531 L
.52647 .25085 L
.52747 .2483 L
.52847 .24542 L
.52947 .2422 L
.53047 .23862 L
.53147 .23467 L
.53247 .23032 L
.53347 .22555 L
.53447 .22034 L
.53546 .21467 L
.53646 .20849 L
.53746 .20179 L
.53846 .19453 L
.53946 .18669 L
.54046 .17824 L
.54146 .16914 L
.54246 .15938 L
.54346 .14892 L
.54446 .13777 L
.54545 .12591 L
.54645 .11336 L
.54745 .10014 L
Mistroke
.54845 .0863 L
.54945 .38644 L
.55045 .38718 L
.55145 .38975 L
.55245 .39338 L
.55345 .39781 L
.55445 .40291 L
.55544 .40862 L
.55644 .4149 L
.55744 .4217 L
.55844 .42896 L
.55944 .43663 L
.56044 .44462 L
.56144 .45278 L
.56244 .46095 L
.56344 .46883 L
.56444 .47601 L
.56543 .48187 L
.56643 .48546 L
.56743 .4854 L
.56843 .48007 L
.56943 .46823 L
.57043 .44974 L
.57143 .42556 L
.57243 .39729 L
.57343 .36677 L
.57443 .33592 L
.57542 .3065 L
.57642 .27996 L
.57742 .25724 L
.57842 .23875 L
.57942 .22441 L
.58042 .21378 L
.58142 .20624 L
.58242 .20111 L
.58342 .19779 L
.58442 .19581 L
.58541 .19482 L
.58641 .19457 L
.58741 .19483 L
.58841 .19544 L
.58941 .19626 L
.59041 .19714 L
.59141 .19798 L
.59241 .19871 L
.59341 .19925 L
.59441 .19956 L
.5954 .19961 L
.5964 .1994 L
.5974 .19891 L
Mistroke
.5984 .19816 L
.5994 .23334 L
.6004 .22906 L
.6014 .22564 L
.6024 .2224 L
.6034 .21912 L
.6044 .21569 L
.60539 .21208 L
.60639 .20825 L
.60739 .20419 L
.60839 .19992 L
.60939 .19545 L
.61039 .19079 L
.61139 .18599 L
.61239 .18108 L
.61339 .17611 L
.61439 .17113 L
.61538 .1662 L
.61638 .1614 L
.61738 .1568 L
.61838 .15249 L
.61938 .14853 L
.62038 .145 L
.62138 .14195 L
.62238 .13942 L
.62338 .1374 L
.62438 .13585 L
.62537 .13467 L
.62637 .13375 L
.62737 .13297 L
.62837 .13223 L
.62937 .13153 L
.63037 .13095 L
.63137 .13062 L
.63237 .13074 L
.63337 .13149 L
.63437 .13304 L
.63536 .13551 L
.63636 .13896 L
.63736 .14341 L
.63836 .14878 L
.63936 .15497 L
.64036 .16179 L
.64136 .16905 L
.64236 .17651 L
.64336 .18394 L
.64436 .19113 L
.64535 .19787 L
.64635 .20403 L
.64735 .20949 L
Mistroke
.64835 .21419 L
.64935 .26041 L
.65035 .25483 L
.65135 .2502 L
.65235 .24584 L
.65335 .24152 L
.65435 .23714 L
.65534 .23262 L
.65634 .22791 L
.65734 .22298 L
.65834 .21782 L
.65934 .2124 L
.66034 .20672 L
.66134 .20078 L
.66234 .19459 L
.66334 .18817 L
.66434 .18154 L
.66533 .17476 L
.66633 .16787 L
.66733 .16094 L
.66833 .15408 L
.66933 .14737 L
.67033 .14096 L
.67133 .13497 L
.67233 .12956 L
.67333 .12487 L
.67433 .12103 L
.67532 .11813 L
.67632 .11616 L
.67732 .11499 L
.67832 .11427 L
.67932 .11349 L
.68032 .1121 L
.68132 .10975 L
.68232 .10654 L
.68332 .10297 L
.68432 .09966 L
.68531 .09726 L
.68631 .09633 L
.68731 .09733 L
.68831 .10055 L
.68931 .10616 L
.69031 .11412 L
.69131 .12425 L
.69231 .13619 L
.69331 .14944 L
.69431 .16343 L
.6953 .17754 L
.6963 .19118 L
.6973 .20382 L
Mistroke
.6983 .21509 L
.6993 .29505 L
.7003 .29404 L
.7013 .29342 L
.7023 .29268 L
.7033 .29171 L
.7043 .29053 L
.70529 .28915 L
.70629 .2876 L
.70729 .28591 L
.70829 .2841 L
.70929 .28218 L
.71029 .28017 L
.71129 .27806 L
.71229 .27585 L
.71329 .27353 L
.71429 .2711 L
.71528 .26854 L
.71628 .26583 L
.71728 .26296 L
.71828 .2599 L
.71928 .25664 L
.72028 .25315 L
.72128 .2494 L
.72228 .24537 L
.72328 .24104 L
.72428 .23637 L
.72527 .23133 L
.72627 .22589 L
.72727 .22001 L
.72827 .21368 L
.72927 .20684 L
.73027 .19946 L
.73127 .19152 L
.73227 .18297 L
.73327 .17379 L
.73427 .16395 L
.73526 .15343 L
.73626 .14221 L
.73726 .1303 L
.73826 .1177 L
.73926 .10446 L
.74026 .09063 L
.74126 .0763 L
.74226 .0616 L
.74326 .04669 L
.74426 .03179 L
.74525 .01719 L
.74625 .0032 L
Mfstroke
.74625 .0032 m
.7465 0 L
s
.74839 0 m
.74925 .12754 L
.75025 .11179 L
.75125 .0971 L
.75225 .08323 L
.75325 .07057 L
.75425 .05971 L
.75524 .05141 L
.75624 .04643 L
.75724 .04549 L
.75824 .04911 L
.75924 .0575 L
.76024 .07056 L
.76124 .08797 L
.76224 .10931 L
.76324 .134 L
.76424 .16125 L
.76523 .18997 L
.76623 .21885 L
.76723 .24654 L
.76823 .27185 L
.76923 .29385 L
.77023 .31207 L
.77123 .3264 L
.77223 .33711 L
.77323 .34465 L
.77423 .3496 L
.77522 .35253 L
.77622 .35397 L
.77722 .35435 L
.77822 .35402 L
.77922 .35325 L
.78022 .35225 L
.78122 .35116 L
.78222 .3501 L
.78322 .34913 L
.78422 .3483 L
.78521 .34765 L
.78621 .34718 L
.78721 .3469 L
.78821 .34679 L
.78921 .34684 L
.79021 .34702 L
.79121 .34731 L
.79221 .34769 L
.79321 .34811 L
.79421 .34855 L
.7952 .34899 L
.7962 .34939 L
.7972 .34973 L
Mistroke
.7982 .34999 L
.7992 .41 L
.8002 .40578 L
.8012 .40263 L
.8022 .39986 L
.8032 .39727 L
.8042 .39475 L
.80519 .39224 L
.80619 .3897 L
.80719 .38713 L
.80819 .38451 L
.80919 .38183 L
.81019 .37909 L
.81119 .37631 L
.81219 .37348 L
.81319 .37062 L
.81419 .36773 L
.81518 .36484 L
.81618 .36196 L
.81718 .3591 L
.81818 .35629 L
.81918 .35355 L
.82018 .3509 L
.82118 .34836 L
.82218 .34596 L
.82318 .3437 L
.82418 .3416 L
.82517 .33967 L
.82617 .33793 L
.82717 .33638 L
.82817 .33502 L
.82917 .33385 L
.83017 .33286 L
.83117 .33206 L
.83217 .33143 L
.83317 .33098 L
.83417 .33069 L
.83516 .33055 L
.83616 .33055 L
.83716 .3307 L
.83816 .33097 L
.83916 .33137 L
.84016 .33188 L
.84116 .3325 L
.84216 .33322 L
.84316 .33403 L
.84416 .33494 L
.84515 .33593 L
.84615 .33699 L
.84715 .33811 L
Mistroke
.84815 .33928 L
.84915 .42041 L
.85015 .41312 L
.85115 .40644 L
.85215 .39981 L
.85315 .39313 L
.85415 .38641 L
.85514 .37969 L
.85614 .37305 L
.85714 .36656 L
.85814 .36031 L
.85914 .35437 L
.86014 .34879 L
.86114 .34363 L
.86214 .33892 L
.86314 .33468 L
.86414 .33091 L
.86513 .32763 L
.86613 .3248 L
.86713 .32241 L
.86813 .32043 L
.86913 .31884 L
.87013 .31758 L
.87113 .31663 L
.87213 .31596 L
.87313 .31554 L
.87413 .31532 L
.87512 .31529 L
.87612 .31542 L
.87712 .31569 L
.87812 .31609 L
.87912 .3166 L
.88012 .31722 L
.88112 .31794 L
.88212 .31875 L
.88312 .31966 L
.88412 .32067 L
.88511 .3218 L
.88611 .32304 L
.88711 .32441 L
.88811 .32592 L
.88911 .32759 L
.89011 .32943 L
.89111 .33147 L
.89211 .33372 L
.89311 .3362 L
.89411 .33893 L
.8951 .34192 L
.8961 .34517 L
.8971 .34869 L
Mistroke
.8981 .35245 L
.8991 .42268 L
.9001 .42707 L
.9011 .4328 L
.9021 .43909 L
.9031 .44562 L
.9041 .45219 L
.90509 .45862 L
.90609 .46468 L
.90709 .47013 L
.90809 .47465 L
.90909 .47786 L
.91009 .4793 L
.91109 .47842 L
.91209 .47457 L
.91309 .46712 L
.91409 .4556 L
.91508 .4399 L
.91608 .42043 L
.91708 .39801 L
.91808 .3738 L
.91908 .34907 L
.92008 .32506 L
.92108 .30281 L
.92208 .28307 L
.92308 .26628 L
.92408 .25255 L
.92507 .24175 L
.92607 .23359 L
.92707 .22767 L
.92807 .22359 L
.92907 .22095 L
.93007 .21941 L
.93107 .21864 L
.93207 .21841 L
.93307 .21848 L
.93407 .21869 L
.93506 .21889 L
.93606 .21898 L
.93706 .21886 L
.93806 .21848 L
.93906 .21779 L
.94006 .21675 L
.94106 .21536 L
.94206 .21359 L
.94306 .21144 L
.94406 .20891 L
.94505 .20601 L
.94605 .20274 L
.94705 .1991 L
Mistroke
.94805 .19512 L
.94905 .25855 L
.95005 .25212 L
.95105 .24664 L
.95205 .24137 L
.95305 .23607 L
.95405 .23063 L
.95504 .22496 L
.95604 .21902 L
.95704 .21278 L
.95804 .20621 L
.95904 .19932 L
.96004 .1921 L
.96104 .18457 L
.96204 .17676 L
.96304 .16872 L
.96404 .16053 L
.96503 .15226 L
.96603 .14405 L
.96703 .13602 L
.96803 .12837 L
.96903 .12128 L
.97003 .11496 L
.97103 .10964 L
.97203 .10551 L
.97303 .10267 L
.97403 .10108 L
.97502 .10044 L
.97602 .10011 L
.97702 .09926 L
.97802 .09726 L
.97902 .0942 L
.98002 .09079 L
.98102 .08793 L
.98202 .08649 L
.98302 .08716 L
.98402 .09047 L
.98501 .09671 L
.98601 .10592 L
.98701 .11793 L
.98801 .1323 L
.98901 .14838 L
.99001 .16542 L
.99101 .18258 L
.99201 .19908 L
.99301 .21424 L
.99401 .22755 L
.995 .23876 L
.996 .24779 L
.997 .25478 L
Mistroke
.998 .25996 L
.999 .30608 L
Mfstroke
gsave
.999 .31867 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32502 L
.005 .328 L
.00599 .33137 L
.00699 .33514 L
.00799 .33934 L
.00899 .34402 L
.00999 .34924 L
.01099 .35504 L
.01199 .3615 L
.01299 .36869 L
.01399 .37672 L
.01499 .38567 L
.01598 .39566 L
.01698 .40681 L
.01798 .41925 L
.01898 .4331 L
.01998 .44852 L
.02098 .46565 L
.02198 .48462 L
.02298 .50556 L
.02398 .52857 L
.02498 .5537 L
.02597 .58095 L
.02697 .61021 L
s
.02697 .61021 m
.02722 .61803 L
s
.04898 .61803 m
.04995 .03326 L
.05095 .06428 L
.05195 .10621 L
.05295 .15819 L
.05395 .21764 L
.05495 .28052 L
.05594 .34201 L
.05694 .39762 L
.05794 .44412 L
.05894 .48006 L
.05994 .50562 L
.06094 .52208 L
.06194 .53115 L
.06294 .53453 L
.06394 .53361 L
.06494 .52944 L
.06593 .52276 L
.06693 .51418 L
.06793 .50438 L
.06893 .4943 L
.06993 .48533 L
.07093 .479 L
.07193 .4762 L
.07293 .47666 L
.07393 .47946 L
.07493 .48367 L
.07592 .48855 L
.07692 .49357 L
.07792 .49833 L
.07892 .50256 L
.07992 .50607 L
.08092 .50876 L
.08192 .51054 L
.08292 .51142 L
.08392 .5114 L
.08492 .51055 L
.08591 .50892 L
.08691 .5066 L
.08791 .50369 L
.08891 .50029 L
.08991 .49652 L
.09091 .49248 L
.09191 .4883 L
.09291 .48408 L
.09391 .47992 L
.09491 .47592 L
.0959 .47217 L
.0969 .46872 L
.0979 .46566 L
Mistroke
.0989 .46301 L
.0999 .33713 L
.1009 .34253 L
.1019 .34689 L
.1029 .3509 L
.1039 .35481 L
.1049 .35873 L
.10589 .36275 L
.10689 .36694 L
.10789 .37134 L
.10889 .37599 L
.10989 .38094 L
.11089 .38622 L
.11189 .39187 L
.11289 .39791 L
.11389 .40437 L
.11489 .41127 L
.11588 .41863 L
.11688 .42645 L
.11788 .43474 L
.11888 .44348 L
.11988 .45264 L
.12088 .46216 L
.12188 .47197 L
.12288 .48196 L
.12388 .49199 L
.12488 .50185 L
.12587 .51131 L
.12687 .52009 L
.12787 .52783 L
.12887 .53418 L
.12987 .53874 L
.13087 .54115 L
.13187 .54115 L
.13287 .53873 L
.13387 .53438 L
.13487 .5295 L
.13586 .52679 L
.13686 .52921 L
.13786 .53738 L
.13886 .54934 L
.13986 .56269 L
.14086 .57544 L
.14186 .58605 L
.14286 .59324 L
.14386 .59599 L
.14486 .59359 L
.14585 .58565 L
.14685 .57219 L
.14785 .55367 L
Mistroke
.14885 .531 L
.14985 .36813 L
.15085 .35339 L
.15185 .33999 L
.15285 .32872 L
.15385 .31977 L
.15485 .31308 L
.15584 .30841 L
.15684 .30548 L
.15784 .30395 L
.15884 .30352 L
.15984 .3039 L
.16084 .30487 L
.16184 .30625 L
.16284 .30788 L
.16384 .30967 L
.16484 .31154 L
.16583 .31344 L
.16683 .31534 L
.16783 .31722 L
.16883 .31907 L
.16983 .32089 L
.17083 .32269 L
.17183 .32449 L
.17283 .32628 L
.17383 .32809 L
.17483 .32994 L
.17582 .33182 L
.17682 .33376 L
.17782 .33577 L
.17882 .33787 L
.17982 .34006 L
.18082 .34234 L
.18182 .34474 L
.18282 .34724 L
.18382 .34986 L
.18482 .35258 L
.18581 .3554 L
.18681 .3583 L
.18781 .36126 L
.18881 .36424 L
.18981 .36721 L
.19081 .37011 L
.19181 .37289 L
.19281 .37547 L
.19381 .37776 L
.19481 .37969 L
.1958 .38115 L
.1968 .38206 L
.1978 .38236 L
Mistroke
.1988 .382 L
.1998 .16904 L
.2008 .1666 L
.2018 .16266 L
.2028 .1581 L
.2038 .15336 L
.2048 .14877 L
.20579 .14464 L
.20679 .14132 L
.20779 .13916 L
.20879 .13856 L
.20979 .13997 L
.21079 .14388 L
.21179 .15074 L
.21279 .16097 L
.21379 .17476 L
.21479 .19196 L
.21578 .21203 L
.21678 .23406 L
.21778 .25694 L
.21878 .27949 L
.21978 .3007 L
.22078 .31977 L
.22178 .33619 L
.22278 .34978 L
.22378 .36058 L
.22478 .36883 L
.22577 .37487 L
.22677 .3791 L
.22777 .38188 L
.22877 .38358 L
.22977 .3845 L
.23077 .38492 L
.23177 .38505 L
.23277 .38509 L
.23377 .38517 L
.23477 .38542 L
.23576 .38592 L
.23676 .38675 L
.23776 .38795 L
.23876 .38956 L
.23976 .3916 L
.24076 .3941 L
.24176 .39707 L
.24276 .40052 L
.24376 .40447 L
.24476 .40892 L
.24575 .41388 L
.24675 .41937 L
.24775 .4254 L
Mistroke
.24875 .43197 L
.24975 .40105 L
.25075 .40804 L
.25175 .41404 L
.25275 .41972 L
.25375 .42526 L
.25475 .43072 L
.25574 .43611 L
.25674 .4414 L
.25774 .44656 L
.25874 .45153 L
.25974 .45625 L
.26074 .46063 L
.26174 .4646 L
.26274 .46808 L
.26374 .471 L
.26474 .47328 L
.26573 .47489 L
.26673 .4758 L
.26773 .47602 L
.26873 .4756 L
.26973 .47459 L
.27073 .47307 L
.27173 .47113 L
.27273 .46882 L
.27373 .4662 L
.27473 .46327 L
.27572 .46004 L
.27672 .45651 L
.27772 .45269 L
.27872 .4486 L
.27972 .44429 L
.28072 .43982 L
.28172 .43526 L
.28272 .4307 L
.28372 .42624 L
.28472 .42196 L
.28571 .41795 L
.28671 .41427 L
.28771 .41099 L
.28871 .40813 L
.28971 .40574 L
.29071 .40381 L
.29171 .40236 L
.29271 .40137 L
.29371 .40082 L
.29471 .4007 L
.2957 .40098 L
.2967 .40166 L
.2977 .4027 L
Mistroke
.2987 .40409 L
.2997 .35684 L
.3007 .3625 L
.3017 .36719 L
.3027 .37161 L
.3037 .37598 L
.3047 .3804 L
.30569 .38496 L
.30669 .38971 L
.30769 .39466 L
.30869 .39986 L
.30969 .40532 L
.31069 .41104 L
.31169 .41704 L
.31269 .42331 L
.31369 .42982 L
.31469 .43656 L
.31568 .44349 L
.31668 .45055 L
.31768 .45767 L
.31868 .46477 L
.31968 .47174 L
.32068 .47844 L
.32168 .48474 L
.32268 .49048 L
.32368 .49549 L
.32468 .49965 L
.32567 .50284 L
.32667 .50504 L
.32767 .50636 L
.32867 .5071 L
.32967 .50775 L
.33067 .50887 L
.33167 .51084 L
.33267 .51366 L
.33367 .51688 L
.33467 .51988 L
.33566 .522 L
.33666 .52265 L
.33766 .52136 L
.33866 .51783 L
.33966 .51192 L
.34066 .50366 L
.34166 .49329 L
.34266 .48119 L
.34366 .4679 L
.34466 .454 L
.34565 .44014 L
.34665 .42689 L
.34765 .41477 L
Mistroke
.34865 .40411 L
.34965 .38791 L
.35065 .3823 L
.35165 .37632 L
.35265 .37069 L
.35365 .36567 L
.35465 .36138 L
.35564 .35787 L
.35664 .35513 L
.35764 .35311 L
.35864 .35177 L
.35964 .35104 L
.36064 .35085 L
.36164 .35113 L
.36264 .35182 L
.36364 .35287 L
.36464 .35424 L
.36563 .3559 L
.36663 .35781 L
.36763 .35996 L
.36863 .36234 L
.36963 .36495 L
.37063 .36779 L
.37163 .37086 L
.37263 .37417 L
.37363 .37773 L
.37463 .38157 L
.37562 .38569 L
.37662 .39011 L
.37762 .39486 L
.37862 .39996 L
.37962 .40541 L
.38062 .41125 L
.38162 .41749 L
.38262 .42414 L
.38362 .43122 L
.38462 .43873 L
.38561 .44668 L
.38661 .45504 L
.38761 .46381 L
.38861 .47294 L
.38961 .4824 L
.39061 .4921 L
.39161 .50195 L
.39261 .51183 L
.39361 .5216 L
.39461 .53105 L
.3956 .53998 L
.3966 .54814 L
.3976 .55525 L
Mistroke
.3986 .56101 L
.3996 .26518 L
.4006 .2634 L
.4016 .26038 L
.4026 .2568 L
.4036 .25282 L
.4046 .24848 L
.40559 .24378 L
.40659 .2387 L
.40759 .23321 L
.40859 .22727 L
.40959 .22085 L
.41059 .21393 L
.41159 .20649 L
.41259 .19852 L
.41359 .19003 L
.41459 .18107 L
.41558 .17172 L
.41658 .16217 L
.41758 .15274 L
.41858 .144 L
.41958 .13699 L
.42058 .13351 L
.42158 .13618 L
.42258 .14727 L
.42358 .16699 L
.42458 .19373 L
.42557 .22529 L
.42657 .25933 L
.42757 .29353 L
.42857 .32577 L
.42957 .35435 L
.43057 .37819 L
.43157 .39688 L
.43257 .41063 L
.43357 .42013 L
.43457 .42629 L
.43556 .43007 L
.43656 .43226 L
.43756 .43342 L
.43856 .43389 L
.43956 .43384 L
.44056 .43335 L
.44156 .4325 L
.44256 .43135 L
.44356 .43001 L
.44456 .42856 L
.44555 .42709 L
.44655 .42568 L
.44755 .42439 L
Mistroke
.44855 .42325 L
.44955 .38638 L
.45055 .3891 L
.45155 .39076 L
.45255 .39205 L
.45355 .3932 L
.45455 .39435 L
.45554 .39555 L
.45654 .39685 L
.45754 .39828 L
.45854 .39985 L
.45954 .40157 L
.46054 .40345 L
.46154 .40549 L
.46254 .40769 L
.46354 .41002 L
.46454 .4125 L
.46553 .4151 L
.46653 .41782 L
.46753 .42064 L
.46853 .42353 L
.46953 .42649 L
.47053 .42949 L
.47153 .4325 L
.47253 .43551 L
.47353 .43848 L
.47453 .4414 L
.47552 .44422 L
.47652 .44693 L
.47752 .44951 L
.47852 .45192 L
.47952 .45417 L
.48052 .45624 L
.48152 .45814 L
.48252 .45987 L
.48352 .46146 L
.48452 .46294 L
.48551 .46434 L
.48651 .4657 L
.48751 .46705 L
.48851 .46839 L
.48951 .46973 L
.49051 .47102 L
.49151 .47221 L
.49251 .47325 L
.49351 .47406 L
.49451 .47455 L
.4955 .47466 L
.4965 .47431 L
.4975 .47347 L
Mistroke
.4985 .47211 L
.4995 .39667 L
.5005 .38642 L
.5015 .37571 L
.5025 .3655 L
.5035 .35625 L
.5045 .3482 L
.50549 .34145 L
.50649 .33601 L
.50749 .33181 L
.50849 .32874 L
.50949 .32666 L
.51049 .32543 L
.51149 .3249 L
.51249 .32495 L
.51349 .32546 L
.51449 .32634 L
.51548 .3275 L
.51648 .32888 L
.51748 .33044 L
.51848 .33215 L
.51948 .33398 L
.52048 .33592 L
.52148 .33796 L
.52248 .3401 L
.52348 .34236 L
.52448 .34472 L
.52547 .34722 L
.52647 .34986 L
.52747 .35266 L
.52847 .35564 L
.52947 .35883 L
.53047 .36224 L
.53147 .36589 L
.53247 .36983 L
.53347 .37406 L
.53447 .37863 L
.53546 .38356 L
.53646 .38889 L
.53746 .39466 L
.53846 .40088 L
.53946 .40762 L
.54046 .41489 L
.54146 .42275 L
.54246 .43123 L
.54346 .44037 L
.54446 .4502 L
.54545 .46077 L
.54645 .47209 L
.54745 .48419 L
Mistroke
.54845 .49707 L
.54945 .39891 L
.55045 .40771 L
.55145 .41621 L
.55245 .42513 L
.55345 .43464 L
.55445 .44478 L
.55544 .45554 L
.55644 .46683 L
.55744 .47852 L
.55844 .49045 L
.55944 .50238 L
.56044 .514 L
.56144 .52494 L
.56244 .53477 L
.56344 .54303 L
.56444 .54925 L
.56543 .55309 L
.56643 .55448 L
.56743 .55378 L
.56843 .55171 L
.56943 .54884 L
.57043 .54499 L
.57143 .53935 L
.57243 .53102 L
.57343 .51937 L
.57443 .50417 L
.57542 .48561 L
.57642 .46432 L
.57742 .44128 L
.57842 .41766 L
.57942 .39469 L
.58042 .37348 L
.58142 .35482 L
.58242 .3392 L
.58342 .32671 L
.58442 .31719 L
.58541 .31025 L
.58641 .30545 L
.58741 .30231 L
.58841 .30045 L
.58941 .29951 L
.59041 .29923 L
.59141 .2994 L
.59241 .29988 L
.59341 .30054 L
.59441 .30129 L
.5954 .30208 L
.5964 .30284 L
.5974 .30354 L
Mistroke
.5984 .30415 L
.5994 .24578 L
.6004 .2494 L
.6014 .25154 L
.6024 .25289 L
.6034 .25367 L
.6044 .25399 L
.60539 .25392 L
.60639 .25351 L
.60739 .25279 L
.60839 .25179 L
.60939 .25052 L
.61039 .24902 L
.61139 .24728 L
.61239 .24532 L
.61339 .24315 L
.61439 .24078 L
.61538 .23823 L
.61638 .23552 L
.61738 .23267 L
.61838 .22972 L
.61938 .22671 L
.62038 .22373 L
.62138 .22085 L
.62238 .21821 L
.62338 .21597 L
.62438 .21433 L
.62537 .21354 L
.62637 .21385 L
.62737 .21549 L
.62837 .21865 L
.62937 .22337 L
.63037 .22959 L
.63137 .23711 L
.63237 .24566 L
.63337 .25493 L
.63437 .26457 L
.63536 .27426 L
.63636 .28369 L
.63736 .29262 L
.63836 .30086 L
.63936 .30828 L
.64036 .31481 L
.64136 .32045 L
.64236 .32523 L
.64336 .32924 L
.64436 .33256 L
.64535 .33531 L
.64635 .33758 L
.64735 .33947 L
Mistroke
.64835 .34105 L
.64935 .27299 L
.65035 .27527 L
.65135 .27623 L
.65235 .27653 L
.65335 .27641 L
.65435 .27596 L
.65534 .27525 L
.65634 .2743 L
.65734 .27314 L
.65834 .27178 L
.65934 .27023 L
.66034 .26847 L
.66134 .26651 L
.66234 .26433 L
.66334 .26193 L
.66434 .25929 L
.66533 .25638 L
.66633 .25321 L
.66733 .24973 L
.66833 .24595 L
.66933 .24184 L
.67033 .2374 L
.67133 .23262 L
.67233 .22754 L
.67333 .2222 L
.67433 .2167 L
.67532 .21121 L
.67632 .20598 L
.67732 .20145 L
.67832 .1982 L
.67932 .19702 L
.68032 .19869 L
.68132 .20371 L
.68232 .2121 L
.68332 .2234 L
.68432 .23693 L
.68531 .25192 L
.68631 .26759 L
.68731 .28322 L
.68831 .29817 L
.68931 .31191 L
.69031 .32405 L
.69131 .33439 L
.69231 .34285 L
.69331 .34953 L
.69431 .35463 L
.6953 .35844 L
.6963 .36128 L
.6973 .36347 L
Mistroke
.6983 .36526 L
.6993 .30766 L
.7003 .31451 L
.7013 .31943 L
.7023 .32315 L
.7033 .326 L
.7043 .32819 L
.70529 .32986 L
.70629 .33115 L
.70729 .33216 L
.70829 .33299 L
.70929 .33369 L
.71029 .33434 L
.71129 .33498 L
.71229 .33566 L
.71329 .3364 L
.71429 .33724 L
.71528 .3382 L
.71628 .33929 L
.71728 .34054 L
.71828 .34196 L
.71928 .34357 L
.72028 .34537 L
.72128 .34738 L
.72228 .34962 L
.72328 .3521 L
.72428 .35484 L
.72527 .35785 L
.72627 .36115 L
.72727 .36477 L
.72827 .36872 L
.72927 .37303 L
.73027 .37773 L
.73127 .38284 L
.73227 .38839 L
.73327 .39441 L
.73427 .40094 L
.73526 .40801 L
.73626 .41564 L
.73726 .42387 L
.73826 .43272 L
.73926 .44223 L
.74026 .4524 L
.74126 .46325 L
.74226 .47478 L
.74326 .48698 L
.74426 .49981 L
.74525 .51324 L
.74625 .5272 L
.74725 .54161 L
Mistroke
.74825 .55634 L
.74925 .14008 L
.75025 .13242 L
.75125 .12372 L
.75225 .11504 L
.75325 .10702 L
.75425 .10028 L
.75524 .09551 L
.75624 .09347 L
.75724 .09507 L
.75824 .10129 L
.75924 .1131 L
.76024 .13124 L
.76124 .15589 L
.76224 .18636 L
.76324 .22113 L
.76424 .25805 L
.76523 .2948 L
.76623 .3292 L
.76723 .3596 L
.76823 .38501 L
.76923 .40515 L
.77023 .42027 L
.77123 .431 L
.77223 .43811 L
.77323 .44239 L
.77423 .44455 L
.77522 .4452 L
.77622 .44482 L
.77722 .44377 L
.77822 .44235 L
.77922 .44073 L
.78022 .43906 L
.78122 .43743 L
.78222 .4359 L
.78322 .43449 L
.78422 .43323 L
.78521 .43214 L
.78621 .43121 L
.78721 .43046 L
.78821 .42989 L
.78921 .42952 L
.79021 .42934 L
.79121 .42937 L
.79221 .42964 L
.79321 .43014 L
.79421 .43089 L
.7952 .43191 L
.7962 .43321 L
.7972 .43479 L
Mistroke
.7982 .43665 L
.7992 .42247 L
.8002 .42623 L
.8012 .42875 L
.8022 .43066 L
.8032 .43213 L
.8042 .43324 L
.80519 .43403 L
.80619 .43451 L
.80719 .43471 L
.80819 .43463 L
.80919 .43431 L
.81019 .43375 L
.81119 .433 L
.81219 .43207 L
.81319 .43102 L
.81419 .42986 L
.81518 .42865 L
.81618 .42741 L
.81718 .42617 L
.81818 .42498 L
.81918 .42386 L
.82018 .42282 L
.82118 .42189 L
.82218 .42109 L
.82318 .42042 L
.82418 .4199 L
.82517 .41952 L
.82617 .41929 L
.82717 .41922 L
.82817 .41929 L
.82917 .41952 L
.83017 .41989 L
.83117 .4204 L
.83217 .42105 L
.83317 .42184 L
.83417 .42276 L
.83516 .4238 L
.83616 .42495 L
.83716 .42622 L
.83816 .42759 L
.83916 .42906 L
.84016 .43062 L
.84116 .43225 L
.84216 .43396 L
.84316 .43573 L
.84416 .43755 L
.84515 .43941 L
.84615 .44131 L
.84715 .44324 L
Mistroke
.84815 .44519 L
.84915 .43291 L
.85015 .43362 L
.85115 .43271 L
.85215 .43086 L
.85315 .42835 L
.85415 .42534 L
.85514 .42197 L
.85614 .41839 L
.85714 .41471 L
.85814 .41103 L
.85914 .40745 L
.86014 .40407 L
.86114 .40093 L
.86214 .39811 L
.86314 .39564 L
.86414 .39354 L
.86513 .39183 L
.86613 .3905 L
.86713 .38957 L
.86813 .38901 L
.86913 .38881 L
.87013 .38895 L
.87113 .38943 L
.87213 .39021 L
.87313 .39129 L
.87413 .39265 L
.87512 .39427 L
.87612 .39614 L
.87712 .39825 L
.87812 .4006 L
.87912 .40317 L
.88012 .40595 L
.88112 .40894 L
.88212 .41213 L
.88312 .4155 L
.88412 .41905 L
.88511 .42276 L
.88611 .42661 L
.88711 .43059 L
.88811 .43468 L
.88911 .43884 L
.89011 .44304 L
.89111 .44725 L
.89211 .45141 L
.89311 .4555 L
.89411 .45944 L
.8951 .46319 L
.8961 .46669 L
.8971 .4699 L
Mistroke
.8981 .47275 L
.8991 .43515 L
.9001 .44759 L
.9011 .4592 L
.9021 .47057 L
.9031 .48176 L
.9041 .49267 L
.90509 .50307 L
.90609 .51268 L
.90709 .52115 L
.90809 .52808 L
.90909 .53311 L
.91009 .53589 L
.91109 .53619 L
.91209 .53395 L
.91309 .52926 L
.91409 .52234 L
.91508 .51334 L
.91608 .50238 L
.91708 .4895 L
.91808 .47483 L
.91908 .45864 L
.92008 .44137 L
.92108 .42359 L
.92208 .40594 L
.92308 .38908 L
.92408 .37356 L
.92507 .35981 L
.92607 .34806 L
.92707 .33841 L
.92807 .33077 L
.92907 .32498 L
.93007 .32079 L
.93107 .31795 L
.93207 .31619 L
.93307 .3153 L
.93407 .31508 L
.93506 .31537 L
.93606 .31603 L
.93706 .31697 L
.93806 .31811 L
.93906 .3194 L
.94006 .32078 L
.94106 .32222 L
.94206 .3237 L
.94306 .3252 L
.94406 .32671 L
.94505 .32822 L
.94605 .32974 L
.94705 .33125 L
Mistroke
.94805 .33276 L
.94905 .27096 L
.95005 .2725 L
.95105 .27269 L
.95205 .27223 L
.95305 .27134 L
.95405 .27012 L
.95504 .26862 L
.95604 .26686 L
.95704 .26485 L
.95804 .2626 L
.95904 .26009 L
.96004 .25733 L
.96104 .25428 L
.96204 .25094 L
.96304 .24728 L
.96404 .24329 L
.96503 .23894 L
.96603 .2342 L
.96703 .22908 L
.96803 .22356 L
.96903 .21764 L
.97003 .21138 L
.97103 .20485 L
.97203 .1982 L
.97303 .1917 L
.97403 .18579 L
.97502 .18119 L
.97602 .17893 L
.97702 .18022 L
.97802 .18595 L
.97902 .19623 L
.98002 .21044 L
.98102 .22757 L
.98202 .24656 L
.98302 .26633 L
.98402 .28588 L
.98501 .30434 L
.98601 .321 L
.98701 .3354 L
.98801 .3473 L
.98901 .35671 L
.99001 .36385 L
.99101 .36906 L
.99201 .37279 L
.99301 .37547 L
.99401 .3775 L
.995 .37914 L
.996 .38058 L
.997 .38187 L
Mistroke
.998 .38302 L
.999 .31867 L
Mfstroke
1 0 0 r
gsave
.999 .31237 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30145 L
.00799 .30034 L
.00899 .29914 L
.00999 .29783 L
.01099 .29637 L
.01199 .29475 L
.01299 .29295 L
.01399 .29095 L
.01499 .28872 L
.01598 .28625 L
.01698 .2835 L
.01798 .28047 L
.01898 .27713 L
.01998 .27348 L
.02098 .26952 L
.02198 .26527 L
.02298 .26079 L
.02398 .25615 L
.02498 .2515 L
.02597 .24705 L
.02697 .24308 L
.02797 .24003 L
.02897 .23843 L
.02997 .23897 L
.03097 .2425 L
.03197 .2499 L
.03297 .26208 L
.03397 .27971 L
.03497 .30304 L
.03596 .33155 L
.03696 .36376 L
.03796 .39716 L
.03896 .42837 L
.03996 .45364 L
.04096 .46957 L
.04196 .47384 L
.04296 .46572 L
.04396 .44628 L
.04496 .41826 L
.04595 .38551 L
.04695 .35218 L
.04795 .32182 L
.04895 .29675 L
Mistroke
.04995 .02688 L
.05095 .05308 L
.05195 .09022 L
.05295 .13699 L
.05395 .19061 L
.05495 .24714 L
.05594 .30214 L
.05694 .35161 L
.05794 .39276 L
.05894 .42439 L
.05994 .44675 L
.06094 .46111 L
.06194 .46912 L
.06294 .47246 L
.06394 .47249 L
.06494 .47024 L
.06593 .46644 L
.06693 .46152 L
.06793 .45576 L
.06893 .44934 L
.06993 .44239 L
.07093 .43503 L
.07193 .42739 L
.07293 .41961 L
.07393 .41187 L
.07493 .40431 L
.07592 .3971 L
.07692 .39037 L
.07792 .3842 L
.07892 .37867 L
.07992 .37377 L
.08092 .3695 L
.08192 .3658 L
.08292 .36261 L
.08392 .35986 L
.08492 .35746 L
.08591 .35535 L
.08691 .35344 L
.08791 .3517 L
.08891 .35007 L
.08991 .34852 L
.09091 .34703 L
.09191 .34559 L
.09291 .34419 L
.09391 .34283 L
.09491 .34153 L
.0959 .34029 L
.0969 .33912 L
.0979 .33802 L
.0989 .33701 L
Mistroke
.0999 .33088 L
.1009 .33231 L
.1019 .33385 L
.1029 .3355 L
.1039 .33726 L
.1049 .33914 L
.10589 .34115 L
.10689 .34331 L
.10789 .34562 L
.10889 .3481 L
.10989 .35077 L
.11089 .35364 L
.11189 .35674 L
.11289 .36007 L
.11389 .36366 L
.11489 .36752 L
.11588 .37168 L
.11688 .37614 L
.11788 .38091 L
.11888 .38601 L
.11988 .39144 L
.12088 .39719 L
.12188 .40325 L
.12288 .40959 L
.12388 .41619 L
.12488 .42298 L
.12587 .42988 L
.12687 .43681 L
.12787 .44364 L
.12887 .45023 L
.12987 .45641 L
.13087 .46199 L
.13187 .46677 L
.13287 .47056 L
.13387 .47316 L
.13487 .47441 L
.13586 .47422 L
.13686 .47251 L
.13786 .46932 L
.13886 .4647 L
.13986 .4588 L
.14086 .45177 L
.14186 .44376 L
.14286 .43491 L
.14386 .4253 L
.14486 .41501 L
.14585 .40407 L
.14685 .39253 L
.14785 .38049 L
.14885 .36811 L
Mistroke
.14985 .3618 L
.15085 .34278 L
.15185 .32603 L
.15285 .31191 L
.15385 .30052 L
.15485 .29174 L
.15584 .28529 L
.15684 .28083 L
.15784 .27797 L
.15884 .27636 L
.15984 .27567 L
.16084 .27562 L
.16184 .27598 L
.16284 .27659 L
.16384 .27729 L
.16484 .27799 L
.16583 .27861 L
.16683 .27911 L
.16783 .27944 L
.16883 .27958 L
.16983 .27951 L
.17083 .27924 L
.17183 .27875 L
.17283 .27805 L
.17383 .27713 L
.17483 .276 L
.17582 .27465 L
.17682 .27309 L
.17782 .27132 L
.17882 .26934 L
.17982 .26715 L
.18082 .26474 L
.18182 .26213 L
.18282 .25932 L
.18382 .2563 L
.18482 .25309 L
.18581 .2497 L
.18681 .24615 L
.18781 .24246 L
.18881 .23867 L
.18981 .23483 L
.19081 .23098 L
.19181 .22721 L
.19281 .2236 L
.19381 .22024 L
.19481 .21726 L
.1958 .21478 L
.1968 .21293 L
.1978 .21185 L
.1988 .21166 L
Mistroke
.1998 .16275 L
.2008 .15628 L
.2018 .14935 L
.2028 .14217 L
.2038 .13501 L
.2048 .12817 L
.20579 .12197 L
.20679 .11677 L
.20779 .11299 L
.20879 .11101 L
.20979 .11125 L
.21079 .11405 L
.21179 .11968 L
.21279 .12829 L
.21379 .13986 L
.21479 .15415 L
.21578 .17076 L
.21678 .18907 L
.21778 .20835 L
.21878 .22779 L
.21978 .24664 L
.22078 .26422 L
.22178 .28002 L
.22278 .29371 L
.22378 .30518 L
.22478 .31443 L
.22577 .32163 L
.22677 .32701 L
.22777 .33083 L
.22877 .33338 L
.22977 .33493 L
.23077 .33573 L
.23177 .33597 L
.23277 .33584 L
.23377 .33547 L
.23477 .33498 L
.23576 .33445 L
.23676 .33395 L
.23776 .33352 L
.23876 .3332 L
.23976 .333 L
.24076 .33295 L
.24176 .33305 L
.24276 .3333 L
.24376 .33371 L
.24476 .33427 L
.24575 .33498 L
.24675 .33584 L
.24775 .33685 L
.24875 .33798 L
Mistroke
.24975 .39484 L
.25075 .39781 L
.25175 .40092 L
.25275 .40415 L
.25375 .40749 L
.25475 .4109 L
.25574 .41435 L
.25674 .41781 L
.25774 .42123 L
.25874 .42457 L
.25974 .42776 L
.26074 .43075 L
.26174 .43347 L
.26274 .43585 L
.26374 .43783 L
.26474 .43932 L
.26573 .44026 L
.26673 .44058 L
.26773 .44023 L
.26873 .43918 L
.26973 .43739 L
.27073 .43486 L
.27173 .43162 L
.27273 .42771 L
.27373 .42319 L
.27473 .41816 L
.27572 .41272 L
.27672 .40699 L
.27772 .40109 L
.27872 .39515 L
.27972 .38929 L
.28072 .38361 L
.28172 .37821 L
.28272 .37316 L
.28372 .36852 L
.28472 .36433 L
.28571 .36062 L
.28671 .35739 L
.28771 .35464 L
.28871 .35234 L
.28971 .35049 L
.29071 .34904 L
.29171 .34798 L
.29271 .34727 L
.29371 .34687 L
.29471 .34676 L
.2957 .34691 L
.2967 .3473 L
.2977 .3479 L
.2987 .34869 L
Mistroke
.2997 .35061 L
.3007 .35229 L
.3017 .35417 L
.3027 .35623 L
.3037 .35848 L
.3047 .36093 L
.30569 .36357 L
.30669 .36642 L
.30769 .36948 L
.30869 .37275 L
.30969 .37625 L
.31069 .37998 L
.31169 .38395 L
.31269 .38815 L
.31369 .39259 L
.31469 .39726 L
.31568 .40214 L
.31668 .40723 L
.31768 .41249 L
.31868 .4179 L
.31968 .42339 L
.32068 .42893 L
.32168 .43442 L
.32268 .43979 L
.32368 .44494 L
.32468 .44973 L
.32567 .45406 L
.32667 .45777 L
.32767 .46073 L
.32867 .46279 L
.32967 .46381 L
.33067 .46369 L
.33167 .46234 L
.33267 .4597 L
.33367 .45576 L
.33467 .45055 L
.33566 .44416 L
.33666 .43668 L
.33766 .42829 L
.33866 .41916 L
.33966 .40948 L
.34066 .39946 L
.34166 .38932 L
.34266 .37928 L
.34366 .36952 L
.34466 .36024 L
.34565 .35159 L
.34665 .3437 L
.34765 .33666 L
.34865 .33052 L
Mistroke
.34965 .38161 L
.35065 .37195 L
.35165 .36297 L
.35265 .35482 L
.35365 .34762 L
.35465 .34141 L
.35564 .33618 L
.35664 .33191 L
.35764 .32852 L
.35864 .32593 L
.35964 .32404 L
.36064 .32276 L
.36164 .322 L
.36264 .32166 L
.36364 .32169 L
.36464 .322 L
.36563 .32255 L
.36663 .32329 L
.36763 .32418 L
.36863 .32519 L
.36963 .32631 L
.37063 .32752 L
.37163 .32881 L
.37263 .33018 L
.37363 .33163 L
.37463 .33315 L
.37562 .33475 L
.37662 .33644 L
.37762 .33822 L
.37862 .3401 L
.37962 .34209 L
.38062 .3442 L
.38162 .34643 L
.38262 .34878 L
.38362 .35128 L
.38462 .35391 L
.38561 .35668 L
.38661 .3596 L
.38761 .36264 L
.38861 .36581 L
.38961 .36908 L
.39061 .37243 L
.39161 .37583 L
.39261 .37924 L
.39361 .38261 L
.39461 .38586 L
.3956 .38893 L
.3966 .39171 L
.3976 .39412 L
.3986 .39604 L
Mistroke
.3996 .25892 L
.4006 .25312 L
.4016 .24712 L
.4026 .24084 L
.4036 .23424 L
.4046 .22724 L
.40559 .21982 L
.40659 .21193 L
.40759 .20357 L
.40859 .19471 L
.40959 .18539 L
.41059 .17563 L
.41159 .16553 L
.41259 .15518 L
.41359 .14475 L
.41459 .13446 L
.41558 .12459 L
.41658 .1155 L
.41758 .1076 L
.41858 .10137 L
.41958 .09735 L
.42058 .09607 L
.42158 .09803 L
.42258 .10364 L
.42358 .11314 L
.42458 .12657 L
.42557 .14369 L
.42657 .16398 L
.42757 .1867 L
.42857 .21091 L
.42957 .23559 L
.43057 .25975 L
.43157 .28249 L
.43257 .30314 L
.43357 .3212 L
.43457 .33644 L
.43556 .34883 L
.43656 .35851 L
.43756 .36576 L
.43856 .37092 L
.43956 .37436 L
.44056 .37642 L
.44156 .37745 L
.44256 .37771 L
.44356 .37745 L
.44456 .37685 L
.44555 .37605 L
.44655 .37517 L
.44755 .37428 L
.44855 .37345 L
Mistroke
.44955 .38013 L
.45055 .37892 L
.45155 .37783 L
.45255 .37688 L
.45355 .37612 L
.45455 .37554 L
.45554 .37517 L
.45654 .375 L
.45754 .37504 L
.45854 .37527 L
.45954 .3757 L
.46054 .37632 L
.46154 .37712 L
.46254 .3781 L
.46354 .37924 L
.46454 .38053 L
.46553 .38196 L
.46653 .38353 L
.46753 .38522 L
.46853 .38703 L
.46953 .38893 L
.47053 .39091 L
.47153 .39296 L
.47253 .39507 L
.47353 .39721 L
.47453 .39937 L
.47552 .40153 L
.47652 .40366 L
.47752 .40574 L
.47852 .40775 L
.47952 .40966 L
.48052 .41143 L
.48152 .41306 L
.48252 .41449 L
.48352 .41572 L
.48452 .41672 L
.48551 .41745 L
.48651 .4179 L
.48751 .41805 L
.48851 .41789 L
.48951 .41741 L
.49051 .4166 L
.49151 .41547 L
.49251 .41401 L
.49351 .41224 L
.49451 .41018 L
.4955 .40784 L
.4965 .40525 L
.4975 .40244 L
.4985 .39943 L
Mistroke
.4995 .39038 L
.5005 .37605 L
.5015 .36231 L
.5025 .34956 L
.5035 .33809 L
.5045 .32809 L
.50549 .31963 L
.50649 .31269 L
.50749 .30717 L
.50849 .30293 L
.50949 .29981 L
.51049 .29763 L
.51149 .29622 L
.51249 .29542 L
.51349 .29509 L
.51449 .29511 L
.51548 .29538 L
.51648 .29582 L
.51748 .29636 L
.51848 .29695 L
.51948 .29754 L
.52048 .29812 L
.52148 .29866 L
.52248 .29913 L
.52348 .29955 L
.52448 .29989 L
.52547 .30016 L
.52647 .30036 L
.52747 .30048 L
.52847 .30053 L
.52947 .30051 L
.53047 .30043 L
.53147 .30028 L
.53247 .30007 L
.53347 .29981 L
.53447 .29949 L
.53546 .29911 L
.53646 .29869 L
.53746 .29822 L
.53846 .29771 L
.53946 .29716 L
.54046 .29657 L
.54146 .29595 L
.54246 .2953 L
.54346 .29465 L
.54446 .29399 L
.54545 .29334 L
.54645 .29272 L
.54745 .29216 L
.54845 .29168 L
Mistroke
.54945 .39267 L
.55045 .39744 L
.55145 .40298 L
.55245 .40925 L
.55345 .41622 L
.55445 .42385 L
.55544 .43208 L
.55644 .44086 L
.55744 .45011 L
.55844 .45971 L
.55944 .4695 L
.56044 .47931 L
.56144 .48886 L
.56244 .49786 L
.56344 .50593 L
.56444 .51263 L
.56543 .51748 L
.56643 .51997 L
.56743 .51959 L
.56843 .51589 L
.56943 .50853 L
.57043 .49736 L
.57143 .48246 L
.57243 .46415 L
.57343 .44307 L
.57443 .42004 L
.57542 .39606 L
.57642 .37214 L
.57742 .34926 L
.57842 .3282 L
.57942 .30955 L
.58042 .29363 L
.58142 .28053 L
.58242 .27015 L
.58342 .26225 L
.58442 .2565 L
.58541 .25254 L
.58641 .25001 L
.58741 .24857 L
.58841 .24794 L
.58941 .24788 L
.59041 .24818 L
.59141 .24869 L
.59241 .24929 L
.59341 .24989 L
.59441 .25043 L
.5954 .25085 L
.5964 .25112 L
.5974 .25123 L
.5984 .25115 L
Mistroke
.5994 .23956 L
.6004 .23923 L
.6014 .23859 L
.6024 .23765 L
.6034 .23639 L
.6044 .23484 L
.60539 .233 L
.60639 .23088 L
.60739 .22849 L
.60839 .22585 L
.60939 .22299 L
.61039 .21991 L
.61139 .21663 L
.61239 .2132 L
.61339 .20963 L
.61439 .20595 L
.61538 .20222 L
.61638 .19846 L
.61738 .19474 L
.61838 .1911 L
.61938 .18762 L
.62038 .18436 L
.62138 .1814 L
.62238 .17881 L
.62338 .17668 L
.62438 .17509 L
.62537 .1741 L
.62637 .1738 L
.62737 .17423 L
.62837 .17544 L
.62937 .17745 L
.63037 .18027 L
.63137 .18387 L
.63237 .1882 L
.63337 .19321 L
.63437 .19881 L
.63536 .20488 L
.63636 .21133 L
.63736 .21802 L
.63836 .22482 L
.63936 .23162 L
.64036 .2383 L
.64136 .24475 L
.64236 .25087 L
.64336 .25659 L
.64436 .26184 L
.64535 .26659 L
.64635 .27081 L
.64735 .27448 L
.64835 .27762 L
Mistroke
.64935 .2667 L
.65035 .26505 L
.65135 .26321 L
.65235 .26119 L
.65335 .25897 L
.65435 .25655 L
.65534 .25393 L
.65634 .2511 L
.65734 .24806 L
.65834 .2448 L
.65934 .24131 L
.66034 .23759 L
.66134 .23364 L
.66234 .22946 L
.66334 .22505 L
.66434 .22041 L
.66533 .21557 L
.66633 .21054 L
.66733 .20534 L
.66833 .20001 L
.66933 .19461 L
.67033 .18918 L
.67133 .1838 L
.67233 .17855 L
.67333 .17354 L
.67433 .16887 L
.67532 .16467 L
.67632 .16107 L
.67732 .15822 L
.67832 .15624 L
.67932 .15526 L
.68032 .15539 L
.68132 .15673 L
.68232 .15932 L
.68332 .16318 L
.68432 .16829 L
.68531 .17459 L
.68631 .18196 L
.68731 .19027 L
.68831 .19936 L
.68931 .20903 L
.69031 .21909 L
.69131 .22932 L
.69231 .23952 L
.69331 .24949 L
.69431 .25903 L
.6953 .26799 L
.6963 .27623 L
.6973 .28364 L
.6983 .29017 L
Mistroke
.6993 .30136 L
.7003 .30428 L
.7013 .30642 L
.7023 .30791 L
.7033 .30886 L
.7043 .30936 L
.70529 .3095 L
.70629 .30937 L
.70729 .30904 L
.70829 .30854 L
.70929 .30794 L
.71029 .30725 L
.71129 .30652 L
.71229 .30575 L
.71329 .30497 L
.71429 .30417 L
.71528 .30337 L
.71628 .30256 L
.71728 .30175 L
.71828 .30093 L
.71928 .3001 L
.72028 .29926 L
.72128 .29839 L
.72228 .2975 L
.72328 .29657 L
.72428 .2956 L
.72527 .29459 L
.72627 .29352 L
.72727 .29239 L
.72827 .2912 L
.72927 .28993 L
.73027 .2886 L
.73127 .28718 L
.73227 .28568 L
.73327 .2841 L
.73427 .28245 L
.73526 .28072 L
.73626 .27892 L
.73726 .27708 L
.73826 .27521 L
.73926 .27334 L
.74026 .27152 L
.74126 .26978 L
.74226 .26819 L
.74326 .26683 L
.74426 .2658 L
.74525 .26522 L
.74625 .2652 L
.74725 .26591 L
.74825 .26751 L
Mistroke
.74925 .13381 L
.75025 .12211 L
.75125 .11041 L
.75225 .09913 L
.75325 .08879 L
.75425 .08 L
.75524 .07346 L
.75624 .06995 L
.75724 .07028 L
.75824 .0752 L
.75924 .0853 L
.76024 .1009 L
.76124 .12193 L
.76224 .14784 L
.76324 .17757 L
.76424 .20965 L
.76523 .24238 L
.76623 .27403 L
.76723 .30307 L
.76823 .32843 L
.76923 .3495 L
.77023 .36617 L
.77123 .3787 L
.77223 .38761 L
.77323 .39352 L
.77423 .39708 L
.77522 .39887 L
.77622 .39939 L
.77722 .39906 L
.77822 .39818 L
.77922 .39699 L
.78022 .39566 L
.78122 .3943 L
.78222 .393 L
.78322 .39181 L
.78422 .39077 L
.78521 .3899 L
.78621 .3892 L
.78721 .38868 L
.78821 .38834 L
.78921 .38818 L
.79021 .38818 L
.79121 .38834 L
.79221 .38866 L
.79321 .38912 L
.79421 .38972 L
.7952 .39045 L
.7962 .3913 L
.7972 .39226 L
.7982 .39332 L
Mistroke
.7992 .41624 L
.8002 .41601 L
.8012 .41569 L
.8022 .41526 L
.8032 .4147 L
.8042 .414 L
.80519 .41313 L
.80619 .41211 L
.80719 .41092 L
.80819 .40957 L
.80919 .40807 L
.81019 .40642 L
.81119 .40465 L
.81219 .40278 L
.81319 .40082 L
.81419 .3988 L
.81518 .39674 L
.81618 .39468 L
.81718 .39264 L
.81818 .39064 L
.81918 .3887 L
.82018 .38686 L
.82118 .38513 L
.82218 .38352 L
.82318 .38206 L
.82418 .38075 L
.82517 .3796 L
.82617 .37861 L
.82717 .3778 L
.82817 .37715 L
.82917 .37668 L
.83017 .37637 L
.83117 .37623 L
.83217 .37624 L
.83317 .37641 L
.83417 .37672 L
.83516 .37717 L
.83616 .37775 L
.83716 .37846 L
.83816 .37928 L
.83916 .38021 L
.84016 .38125 L
.84116 .38237 L
.84216 .38359 L
.84316 .38488 L
.84416 .38624 L
.84515 .38767 L
.84615 .38915 L
.84715 .39067 L
.84815 .39223 L
Mistroke
.84915 .42666 L
.85015 .42337 L
.85115 .41957 L
.85215 .41534 L
.85315 .41074 L
.85415 .40587 L
.85514 .40083 L
.85614 .39572 L
.85714 .39064 L
.85814 .38567 L
.85914 .38091 L
.86014 .37643 L
.86114 .37228 L
.86214 .36851 L
.86314 .36516 L
.86414 .36223 L
.86513 .35973 L
.86613 .35765 L
.86713 .35599 L
.86813 .35472 L
.86913 .35382 L
.87013 .35327 L
.87113 .35303 L
.87213 .35309 L
.87313 .35341 L
.87413 .35398 L
.87512 .35478 L
.87612 .35578 L
.87712 .35697 L
.87812 .35834 L
.87912 .35989 L
.88012 .36159 L
.88112 .36344 L
.88212 .36544 L
.88312 .36758 L
.88412 .36986 L
.88511 .37228 L
.88611 .37482 L
.88711 .3775 L
.88811 .3803 L
.88911 .38321 L
.89011 .38624 L
.89111 .38936 L
.89211 .39257 L
.89311 .39585 L
.89411 .39919 L
.8951 .40255 L
.8961 .40593 L
.8971 .40929 L
.8981 .4126 L
Mistroke
.8991 .42892 L
.9001 .43733 L
.9011 .446 L
.9021 .45483 L
.9031 .46369 L
.9041 .47243 L
.90509 .48085 L
.90609 .48868 L
.90709 .49564 L
.90809 .50137 L
.90909 .50549 L
.91009 .5076 L
.91109 .5073 L
.91209 .50426 L
.91309 .49819 L
.91409 .48897 L
.91508 .47662 L
.91608 .4614 L
.91708 .44375 L
.91808 .42431 L
.91908 .40385 L
.92008 .38321 L
.92108 .3632 L
.92208 .34451 L
.92308 .32768 L
.92408 .31306 L
.92507 .30078 L
.92607 .29083 L
.92707 .28304 L
.92807 .27718 L
.92907 .27297 L
.93007 .2701 L
.93107 .26829 L
.93207 .2673 L
.93307 .26689 L
.93407 .26689 L
.93506 .26713 L
.93606 .26751 L
.93706 .26792 L
.93806 .2683 L
.93906 .26859 L
.94006 .26877 L
.94106 .26879 L
.94206 .26864 L
.94306 .26832 L
.94406 .26781 L
.94505 .26712 L
.94605 .26624 L
.94705 .26518 L
.94805 .26394 L
Mistroke
.94905 .26475 L
.95005 .26231 L
.95105 .25967 L
.95205 .2568 L
.95305 .25371 L
.95405 .25038 L
.95504 .24679 L
.95604 .24294 L
.95704 .23881 L
.95804 .2344 L
.95904 .22971 L
.96004 .22471 L
.96104 .21942 L
.96204 .21385 L
.96304 .208 L
.96404 .20191 L
.96503 .1956 L
.96603 .18912 L
.96703 .18255 L
.96803 .17596 L
.96903 .16946 L
.97003 .16317 L
.97103 .15725 L
.97203 .15185 L
.97303 .14718 L
.97403 .14343 L
.97502 .14081 L
.97602 .13952 L
.97702 .13974 L
.97802 .1416 L
.97902 .14522 L
.98002 .15061 L
.98102 .15775 L
.98202 .16652 L
.98302 .17675 L
.98402 .18817 L
.98501 .20052 L
.98601 .21346 L
.98701 .22667 L
.98801 .2398 L
.98901 .25255 L
.99001 .26463 L
.99101 .27582 L
.99201 .28594 L
.99301 .29486 L
.99401 .30253 L
.995 .30895 L
.996 .31419 L
.997 .31833 L
.998 .32149 L
Mistroke
.999 .31237 L
Mfstroke
0 g
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .27968 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.03876 0 m
.03896 .00817 L
.03996 .05173 L
.04096 .08935 L
.04196 .11238 L
.04296 .11685 L
.04396 .106 L
.04496 .08736 L
.04595 .0681 L
.04695 .05255 L
.04795 .04221 L
.04895 .03674 L
.04995 .40277 L
.05095 .44407 L
.05195 .4789 L
.05295 .50468 L
.05395 .51917 L
.05495 .52127 L
.05594 .51145 L
.05694 .49165 L
.05794 .46486 L
.05894 .43436 L
.05994 .40298 L
.06094 .37273 L
.06194 .34479 L
.06294 .31964 L
.06394 .29737 L
.06494 .27784 L
.06593 .26082 L
.06693 .2461 L
.06793 .23348 L
.06893 .22285 L
.06993 .21414 L
.07093 .2073 L
.07193 .20232 L
.07293 .19916 L
.07393 .19777 L
.07493 .19804 L
.07592 .19984 L
.07692 .20299 L
.07792 .20726 L
.07892 .21242 L
.07992 .21821 L
.08092 .22435 L
.08192 .23059 L
.08292 .23666 L
.08392 .24233 L
.08492 .24736 L
.08591 .25157 L
.08691 .25478 L
Mistroke
.08791 .2569 L
.08891 .25788 L
.08991 .25775 L
.09091 .2566 L
.09191 .25458 L
.09291 .25187 L
.09391 .24862 L
.09491 .24501 L
.0959 .24114 L
.0969 .23714 L
.0979 .23307 L
.0989 .229 L
.0999 .22551 L
.1009 .21546 L
.1019 .20676 L
.1029 .19878 L
.1039 .19132 L
.1049 .18429 L
.10589 .17764 L
.10689 .17135 L
.10789 .16537 L
.10889 .15971 L
.10989 .15434 L
.11089 .14925 L
.11189 .14443 L
.11289 .13987 L
.11389 .13554 L
.11489 .13143 L
.11588 .12751 L
.11688 .12375 L
.11788 .12012 L
.11888 .11656 L
.11988 .11306 L
.12088 .10955 L
.12188 .10601 L
.12288 .1024 L
.12388 .09871 L
.12488 .09494 L
.12587 .09111 L
.12687 .08727 L
.12787 .08349 L
.12887 .07989 L
.12987 .07665 L
.13087 .07397 L
.13187 .07213 L
.13287 .07148 L
.13387 .07241 L
.13487 .07535 L
.13586 .08078 L
.13686 .08915 L
Mistroke
.13786 .10083 L
.13886 .11611 L
.13986 .13505 L
.14086 .15747 L
.14186 .18284 L
.14286 .21017 L
.14386 .23791 L
.14486 .26368 L
.14585 .28418 L
.14685 .29579 L
.14785 .29695 L
.14885 .28992 L
.14985 .39677 L
.15085 .38785 L
.15185 .37669 L
.15285 .36361 L
.15385 .34928 L
.15485 .33435 L
.15584 .31937 L
.15684 .30471 L
.15784 .29064 L
.15884 .2773 L
.15984 .26473 L
.16084 .25293 L
.16184 .24186 L
.16284 .23146 L
.16384 .22168 L
.16484 .21245 L
.16583 .20371 L
.16683 .19543 L
.16783 .18755 L
.16883 .18004 L
.16983 .17288 L
.17083 .16604 L
.17183 .15949 L
.17283 .15321 L
.17383 .14719 L
.17483 .1414 L
.17582 .13583 L
.17682 .13045 L
.17782 .12524 L
.17882 .12016 L
.17982 .11519 L
.18082 .11029 L
.18182 .10541 L
.18282 .1005 L
.18382 .09552 L
.18482 .0904 L
.18581 .08508 L
.18681 .0795 L
Mistroke
.18781 .07361 L
.18881 .06734 L
.18981 .06064 L
.19081 .05347 L
.19181 .04579 L
.19281 .03758 L
.19381 .02884 L
.19481 .01958 L
.1958 .00984 L
Mfstroke
.1958 .00984 m
.19677 0 L
s
.19891 0 m
.1998 .16702 L
.2008 .1678 L
.2018 .17118 L
.2028 .17651 L
.2038 .18354 L
.2048 .19213 L
.20579 .20218 L
.20679 .21355 L
.20779 .22612 L
.20879 .23972 L
.20979 .25414 L
.21079 .26913 L
.21179 .28435 L
.21279 .29942 L
.21379 .31387 L
.21479 .32718 L
.21578 .33881 L
.21678 .34822 L
.21778 .35494 L
.21878 .35861 L
.21978 .35907 L
.22078 .3564 L
.22178 .35089 L
.22278 .34306 L
.22378 .3335 L
.22478 .32283 L
.22577 .31158 L
.22677 .30016 L
.22777 .28886 L
.22877 .27784 L
.22977 .26721 L
.23077 .25701 L
.23177 .24725 L
.23277 .2379 L
.23377 .22896 L
.23477 .22038 L
.23576 .21216 L
.23676 .20427 L
.23776 .19668 L
.23876 .18937 L
.23976 .18234 L
.24076 .17556 L
.24176 .16902 L
.24276 .16271 L
.24376 .15661 L
.24476 .1507 L
.24575 .14497 L
.24675 .1394 L
.24775 .13397 L
Mistroke
.24875 .12865 L
.24975 .22931 L
.25075 .22439 L
.25175 .22104 L
.25275 .21858 L
.25375 .2168 L
.25475 .21561 L
.25574 .21494 L
.25674 .21476 L
.25774 .21502 L
.25874 .2157 L
.25974 .21677 L
.26074 .21821 L
.26174 .22001 L
.26274 .22214 L
.26374 .22459 L
.26474 .22735 L
.26573 .23041 L
.26673 .23376 L
.26773 .23737 L
.26873 .24122 L
.26973 .24527 L
.27073 .24948 L
.27173 .25379 L
.27273 .25811 L
.27373 .26235 L
.27473 .26641 L
.27572 .27016 L
.27672 .27347 L
.27772 .27622 L
.27872 .27829 L
.27972 .27957 L
.28072 .27999 L
.28172 .27951 L
.28272 .27814 L
.28372 .2759 L
.28472 .27287 L
.28571 .26914 L
.28671 .26482 L
.28771 .26003 L
.28871 .25487 L
.28971 .24943 L
.29071 .2438 L
.29171 .23804 L
.29271 .23222 L
.29371 .22637 L
.29471 .22054 L
.2957 .21474 L
.2967 .209 L
.2977 .20332 L
Mistroke
.2987 .19772 L
.2997 .23731 L
.3007 .22828 L
.3017 .22065 L
.3027 .21377 L
.3037 .20743 L
.3047 .20154 L
.30569 .19606 L
.30669 .19094 L
.30769 .18618 L
.30869 .18176 L
.30969 .17766 L
.31069 .17387 L
.31169 .17037 L
.31269 .16716 L
.31369 .16423 L
.31469 .16156 L
.31568 .15914 L
.31668 .15697 L
.31768 .15505 L
.31868 .15339 L
.31968 .15201 L
.32068 .15094 L
.32168 .15023 L
.32268 .14994 L
.32368 .15016 L
.32468 .15098 L
.32567 .15252 L
.32667 .15493 L
.32767 .15834 L
.32867 .1629 L
.32967 .16877 L
.33067 .17607 L
.33167 .18489 L
.33267 .19526 L
.33367 .20711 L
.33467 .22026 L
.33566 .23439 L
.33666 .24902 L
.33766 .26347 L
.33866 .2769 L
.33966 .28833 L
.34066 .29676 L
.34166 .30147 L
.34266 .30225 L
.34366 .29955 L
.34466 .29424 L
.34565 .28726 L
.34665 .27938 L
.34765 .27116 L
Mistroke
.34865 .26294 L
.34965 .36106 L
.35065 .35537 L
.35165 .34939 L
.35265 .34267 L
.35365 .33526 L
.35465 .32726 L
.35564 .31884 L
.35664 .31014 L
.35764 .30129 L
.35864 .29241 L
.35964 .28359 L
.36064 .27488 L
.36164 .26634 L
.36264 .258 L
.36364 .24988 L
.36464 .24199 L
.36563 .23434 L
.36663 .22692 L
.36763 .21973 L
.36863 .21277 L
.36963 .20604 L
.37063 .19952 L
.37163 .19322 L
.37263 .18713 L
.37363 .18123 L
.37463 .17553 L
.37562 .17001 L
.37662 .16466 L
.37762 .15947 L
.37862 .15442 L
.37962 .14951 L
.38062 .14469 L
.38162 .13996 L
.38262 .13527 L
.38362 .13059 L
.38462 .12589 L
.38561 .12111 L
.38661 .11621 L
.38761 .11113 L
.38861 .10583 L
.38961 .10025 L
.39061 .09433 L
.39161 .08804 L
.39261 .08133 L
.39361 .07417 L
.39461 .06653 L
.3956 .0584 L
.3966 .04978 L
.3976 .04068 L
Mistroke
.3986 .03115 L
.3996 .113 L
.4006 .10796 L
.4016 .10443 L
.4026 .10177 L
.4036 .09981 L
.4046 .09849 L
.40559 .09778 L
.40659 .09767 L
.40759 .09815 L
.40859 .09924 L
.40959 .10094 L
.41059 .10325 L
.41159 .10622 L
.41259 .10989 L
.41359 .11434 L
.41459 .1197 L
.41558 .12612 L
.41658 .1338 L
.41758 .14297 L
.41858 .1539 L
.41958 .16685 L
.42058 .1821 L
.42158 .19984 L
.42258 .22017 L
.42358 .24299 L
.42458 .26792 L
.42557 .29421 L
.42657 .32067 L
.42757 .34565 L
.42857 .36699 L
.42957 .38216 L
.43057 .38894 L
.43157 .3868 L
.43257 .37784 L
.43357 .36526 L
.43457 .35162 L
.43556 .33841 L
.43656 .32632 L
.43756 .31556 L
.43856 .30604 L
.43956 .29754 L
.44056 .28981 L
.44156 .28261 L
.44256 .27571 L
.44356 .26898 L
.44456 .26231 L
.44555 .25565 L
.44655 .249 L
.44755 .24236 L
Mistroke
.44855 .23576 L
.44955 .30238 L
.45055 .29275 L
.45155 .2847 L
.45255 .27752 L
.45355 .27096 L
.45455 .26488 L
.45554 .25919 L
.45654 .25384 L
.45754 .24879 L
.45854 .244 L
.45954 .23945 L
.46054 .23512 L
.46154 .231 L
.46254 .22707 L
.46354 .22332 L
.46454 .21975 L
.46553 .21635 L
.46653 .21311 L
.46753 .21004 L
.46853 .20712 L
.46953 .20437 L
.47053 .20177 L
.47153 .19933 L
.47253 .19706 L
.47353 .19496 L
.47453 .19304 L
.47552 .19132 L
.47652 .1898 L
.47752 .18851 L
.47852 .18746 L
.47952 .18668 L
.48052 .18618 L
.48152 .18601 L
.48252 .18617 L
.48352 .18671 L
.48452 .18764 L
.48551 .18897 L
.48651 .19074 L
.48751 .19294 L
.48851 .19556 L
.48951 .1986 L
.49051 .20203 L
.49151 .20578 L
.49251 .20979 L
.49351 .21398 L
.49451 .21824 L
.4955 .22244 L
.4965 .22645 L
.4975 .23012 L
Mistroke
.4985 .23332 L
.4995 .38182 L
.5005 .37924 L
.5015 .37528 L
.5025 .36961 L
.5035 .36242 L
.5045 .35399 L
.50549 .34466 L
.50649 .33476 L
.50749 .32455 L
.50849 .31427 L
.50949 .30408 L
.51049 .29409 L
.51149 .28439 L
.51249 .27502 L
.51349 .26599 L
.51449 .25732 L
.51548 .24898 L
.51648 .24097 L
.51748 .23327 L
.51848 .22585 L
.51948 .21871 L
.52048 .21183 L
.52148 .20518 L
.52248 .19878 L
.52348 .19259 L
.52448 .18661 L
.52547 .18085 L
.52647 .17528 L
.52747 .16991 L
.52847 .16474 L
.52947 .15976 L
.53047 .15496 L
.53147 .15036 L
.53247 .14594 L
.53347 .14171 L
.53447 .13767 L
.53546 .13381 L
.53646 .13014 L
.53746 .12666 L
.53846 .12337 L
.53946 .12026 L
.54046 .11733 L
.54146 .11457 L
.54246 .11198 L
.54346 .10954 L
.54446 .10725 L
.54545 .10508 L
.54645 .10303 L
.54745 .10108 L
Mistroke
.54845 .09922 L
.54945 .12551 L
.55045 .1211 L
.55145 .11848 L
.55245 .11703 L
.55345 .11658 L
.55445 .11707 L
.55544 .11848 L
.55644 .12082 L
.55744 .12411 L
.55844 .12836 L
.55944 .13363 L
.56044 .13996 L
.56144 .14745 L
.56244 .15621 L
.56344 .16637 L
.56444 .17806 L
.56543 .19142 L
.56643 .20656 L
.56743 .22355 L
.56843 .24235 L
.56943 .26278 L
.57043 .28448 L
.57143 .30686 L
.57243 .32905 L
.57343 .3499 L
.57443 .36799 L
.57542 .38177 L
.57642 .3898 L
.57742 .39126 L
.57842 .38653 L
.57942 .3772 L
.58042 .36525 L
.58142 .3523 L
.58242 .33945 L
.58342 .32728 L
.58442 .31603 L
.58541 .30573 L
.58641 .29628 L
.58741 .28754 L
.58841 .27938 L
.58941 .27164 L
.59041 .26421 L
.59141 .25701 L
.59241 .24998 L
.59341 .24307 L
.59441 .23628 L
.5954 .22957 L
.5964 .22296 L
.5974 .21644 L
Mistroke
.5984 .21001 L
.5994 .24811 L
.6004 .23936 L
.6014 .23223 L
.6024 .22603 L
.6034 .22052 L
.6044 .21558 L
.60539 .21113 L
.60639 .20713 L
.60739 .20355 L
.60839 .20035 L
.60939 .19752 L
.61039 .19503 L
.61139 .19288 L
.61239 .19104 L
.61339 .18952 L
.61439 .1883 L
.61538 .1874 L
.61638 .18682 L
.61738 .18658 L
.61838 .18669 L
.61938 .18719 L
.62038 .18812 L
.62138 .18951 L
.62238 .19141 L
.62338 .19387 L
.62438 .19693 L
.62537 .20065 L
.62637 .20505 L
.62737 .21014 L
.62837 .21593 L
.62937 .22236 L
.63037 .22938 L
.63137 .23686 L
.63237 .24462 L
.63337 .25245 L
.63437 .26007 L
.63536 .26717 L
.63636 .27341 L
.63736 .27848 L
.63836 .28208 L
.63936 .28404 L
.64036 .28431 L
.64136 .28297 L
.64236 .28023 L
.64336 .27635 L
.64436 .27161 L
.64535 .26627 L
.64635 .26053 L
.64735 .25456 L
Mistroke
.64835 .24849 L
.64935 .22706 L
.65035 .21852 L
.65135 .21138 L
.65235 .205 L
.65335 .19916 L
.65435 .19378 L
.65534 .18879 L
.65634 .18416 L
.65734 .17987 L
.65834 .17589 L
.65934 .17223 L
.66034 .16885 L
.66134 .16575 L
.66234 .16292 L
.66334 .16034 L
.66434 .158 L
.66533 .15589 L
.66633 .15401 L
.66733 .15237 L
.66833 .15097 L
.66933 .14984 L
.67033 .14902 L
.67133 .14855 L
.67233 .1485 L
.67333 .14896 L
.67433 .15003 L
.67532 .15182 L
.67632 .15446 L
.67732 .1581 L
.67832 .16288 L
.67932 .16895 L
.68032 .17643 L
.68132 .1854 L
.68232 .19589 L
.68332 .20785 L
.68432 .2211 L
.68531 .23534 L
.68631 .25012 L
.68731 .26479 L
.68831 .27853 L
.68931 .29037 L
.69031 .29929 L
.69131 .30448 L
.69231 .30568 L
.69331 .3033 L
.69431 .2982 L
.6953 .29137 L
.6963 .28361 L
.6973 .27549 L
Mistroke
.6983 .2674 L
.6993 .33156 L
.7003 .31923 L
.7013 .3081 L
.7023 .2976 L
.7033 .28757 L
.7043 .27796 L
.70529 .26873 L
.70629 .25985 L
.70729 .2513 L
.70829 .24307 L
.70929 .23514 L
.71029 .2275 L
.71129 .22012 L
.71229 .213 L
.71329 .20612 L
.71429 .19948 L
.71528 .19306 L
.71628 .18686 L
.71728 .18087 L
.71828 .17509 L
.71928 .1695 L
.72028 .16411 L
.72128 .15891 L
.72228 .1539 L
.72328 .14907 L
.72428 .14441 L
.72527 .13993 L
.72627 .13561 L
.72727 .13146 L
.72827 .12746 L
.72927 .1236 L
.73027 .11987 L
.73127 .11625 L
.73227 .11271 L
.73327 .10924 L
.73427 .10578 L
.73526 .10232 L
.73626 .09879 L
.73726 .09517 L
.73826 .09139 L
.73926 .08742 L
.74026 .08321 L
.74126 .07874 L
.74226 .07399 L
.74326 .06894 L
.74426 .06362 L
.74525 .05807 L
.74625 .05235 L
.74725 .04659 L
Mistroke
.74825 .04093 L
.74925 .13672 L
.75025 .14468 L
.75125 .156 L
.75225 .17008 L
.75325 .18674 L
.75425 .20584 L
.75524 .22721 L
.75624 .25061 L
.75724 .27566 L
.75824 .30186 L
.75924 .32848 L
.76024 .35461 L
.76124 .37915 L
.76224 .40087 L
.76324 .41854 L
.76424 .43101 L
.76523 .43747 L
.76623 .43761 L
.76723 .43178 L
.76823 .42103 L
.76923 .40691 L
.77023 .391 L
.77123 .37467 L
.77223 .35884 L
.77323 .34405 L
.77423 .3305 L
.77522 .31821 L
.77622 .30705 L
.77722 .29686 L
.77822 .2875 L
.77922 .27881 L
.78022 .27069 L
.78122 .26304 L
.78222 .25581 L
.78322 .24895 L
.78422 .24242 L
.78521 .23621 L
.78621 .2303 L
.78721 .22468 L
.78821 .21935 L
.78921 .21431 L
.79021 .20957 L
.79121 .20512 L
.79221 .20098 L
.79321 .19717 L
.79421 .19367 L
.7952 .19052 L
.7962 .18771 L
.7972 .18526 L
Mistroke
.7982 .18317 L
.7992 .27822 L
.8002 .27563 L
.8012 .27436 L
.8022 .2737 L
.8032 .27338 L
.8042 .27327 L
.80519 .27326 L
.80619 .27329 L
.80719 .2733 L
.80819 .27325 L
.80919 .27309 L
.81019 .2728 L
.81119 .27237 L
.81219 .27177 L
.81319 .27101 L
.81419 .27007 L
.81518 .26895 L
.81618 .26765 L
.81718 .26619 L
.81818 .26456 L
.81918 .26278 L
.82018 .26084 L
.82118 .25877 L
.82218 .25656 L
.82318 .25423 L
.82418 .25179 L
.82517 .24924 L
.82617 .2466 L
.82717 .24387 L
.82817 .24106 L
.82917 .23818 L
.83017 .23525 L
.83117 .23226 L
.83217 .22923 L
.83317 .22617 L
.83417 .22309 L
.83516 .21998 L
.83616 .21687 L
.83716 .21377 L
.83816 .21067 L
.83916 .20759 L
.84016 .20454 L
.84116 .20153 L
.84216 .19857 L
.84316 .19567 L
.84416 .19284 L
.84515 .19009 L
.84615 .18744 L
.84715 .1849 L
Mistroke
.84815 .18249 L
.84915 .30717 L
.85015 .30802 L
.85115 .3095 L
.85215 .31088 L
.85315 .31188 L
.85415 .31235 L
.85514 .31222 L
.85614 .31145 L
.85714 .31002 L
.85814 .30797 L
.85914 .30532 L
.86014 .30211 L
.86114 .29842 L
.86214 .29429 L
.86314 .2898 L
.86414 .28501 L
.86513 .27998 L
.86613 .27476 L
.86713 .26941 L
.86813 .26396 L
.86913 .25847 L
.87013 .25296 L
.87113 .24745 L
.87213 .24198 L
.87313 .23655 L
.87413 .23119 L
.87512 .2259 L
.87612 .22069 L
.87712 .21558 L
.87812 .21055 L
.87912 .20562 L
.88012 .20078 L
.88112 .19604 L
.88212 .19139 L
.88312 .18682 L
.88412 .18234 L
.88511 .17794 L
.88611 .17362 L
.88711 .16938 L
.88811 .16521 L
.88911 .16111 L
.89011 .15709 L
.89111 .15314 L
.89211 .14929 L
.89311 .14554 L
.89411 .14192 L
.8951 .13844 L
.8961 .13515 L
.8971 .13209 L
Mistroke
.8981 .1293 L
.8991 .15077 L
.9001 .15109 L
.9011 .15365 L
.9021 .15782 L
.9031 .16346 L
.9041 .1705 L
.90509 .17891 L
.90609 .18866 L
.90709 .19972 L
.90809 .21206 L
.90909 .22563 L
.91009 .24033 L
.91109 .25602 L
.91209 .2725 L
.91309 .28947 L
.91409 .30655 L
.91508 .32323 L
.91608 .33894 L
.91708 .35303 L
.91808 .3648 L
.91908 .37361 L
.92008 .37893 L
.92108 .38046 L
.92208 .37822 L
.92308 .37261 L
.92408 .36434 L
.92507 .35423 L
.92607 .3431 L
.92707 .33157 L
.92807 .32013 L
.92907 .30904 L
.93007 .29846 L
.93107 .28843 L
.93207 .27897 L
.93307 .27002 L
.93407 .26154 L
.93506 .25347 L
.93606 .24576 L
.93706 .23836 L
.93806 .23123 L
.93906 .22434 L
.94006 .21764 L
.94106 .21113 L
.94206 .20477 L
.94306 .19854 L
.94406 .19242 L
.94505 .1864 L
.94605 .18046 L
.94705 .17457 L
Mistroke
.94805 .16872 L
.94905 .19986 L
.95005 .19182 L
.95105 .18524 L
.95205 .17946 L
.95305 .17427 L
.95405 .16957 L
.95504 .16532 L
.95604 .16148 L
.95704 .15803 L
.95804 .15494 L
.95904 .15222 L
.96004 .14984 L
.96104 .14778 L
.96204 .14604 L
.96304 .1446 L
.96404 .14347 L
.96503 .14265 L
.96603 .14215 L
.96703 .14202 L
.96803 .14229 L
.96903 .14304 L
.97003 .14437 L
.97103 .14638 L
.97203 .14922 L
.97303 .15304 L
.97403 .15801 L
.97502 .16432 L
.97602 .17214 L
.97702 .18164 L
.97802 .19292 L
.97902 .206 L
.98002 .22082 L
.98102 .23712 L
.98202 .25448 L
.98302 .27225 L
.98402 .28952 L
.98501 .3051 L
.98601 .31763 L
.98701 .32573 L
.98801 .32859 L
.98901 .32644 L
.99001 .32045 L
.99101 .31209 L
.99201 .30257 L
.99301 .29274 L
.99401 .28307 L
.995 .27385 L
.996 .26515 L
.997 .257 L
Mistroke
.998 .24934 L
.999 .27968 L
Mfstroke
gsave
.999 .29229 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .0163 L
.004 .01789 L
.005 .01926 L
.00599 .02047 L
.00699 .02157 L
.00799 .02259 L
.00899 .02358 L
.00999 .02456 L
.01099 .02556 L
.01199 .02663 L
.01299 .02783 L
.01399 .02922 L
.01499 .03089 L
.01598 .03296 L
.01698 .03562 L
.01798 .0391 L
.01898 .04369 L
.01998 .04979 L
.02098 .05788 L
.02198 .06851 L
.02298 .08231 L
.02398 .09998 L
.02498 .1223 L
.02597 .15011 L
.02697 .18428 L
.02797 .22565 L
.02897 .27491 L
.02997 .33245 L
.03097 .39808 L
.03197 .47077 L
.03297 .54837 L
s
.03297 .54837 m
.03385 .61803 L
s
.04948 .61803 m
.04995 .41554 L
.05095 .46976 L
.05195 .52031 L
.05295 .56281 L
.05395 .59364 L
.05495 .61056 L
.05594 .61332 L
.05694 .60376 L
.05794 .58534 L
.05894 .56223 L
.05994 .53839 L
.06094 .51694 L
.06194 .49986 L
.06294 .48802 L
.06394 .48146 L
.06494 .47968 L
.06593 .48183 L
.06693 .48695 L
.06793 .49403 L
.06893 .50207 L
.06993 .51013 L
.07093 .51736 L
.07193 .52308 L
.07293 .52673 L
.07393 .52798 L
.07493 .52667 L
.07592 .52285 L
.07692 .51672 L
.07792 .5086 L
.07892 .49891 L
.07992 .48808 L
.08092 .47657 L
.08192 .4648 L
.08292 .45314 L
.08392 .44193 L
.08492 .43143 L
.08591 .42184 L
.08691 .41331 L
.08791 .4059 L
.08891 .39962 L
.08991 .39438 L
.09091 .39003 L
.09191 .38639 L
.09291 .38326 L
.09391 .38045 L
.09491 .37778 L
.0959 .37515 L
.0969 .37244 L
.0979 .36962 L
Mistroke
.0989 .36664 L
.0999 .2382 L
.1009 .23602 L
.1019 .23289 L
.1029 .22946 L
.1039 .22593 L
.1049 .22239 L
.10589 .21891 L
.10689 .21553 L
.10789 .21228 L
.10889 .20921 L
.10989 .20635 L
.11089 .20373 L
.11189 .2014 L
.11289 .19941 L
.11389 .19782 L
.11489 .19671 L
.11588 .19615 L
.11688 .19625 L
.11788 .19711 L
.11888 .19888 L
.11988 .2017 L
.12088 .20571 L
.12188 .21109 L
.12288 .218 L
.12388 .2266 L
.12488 .23705 L
.12587 .24945 L
.12687 .26391 L
.12787 .28046 L
.12887 .29905 L
.12987 .31956 L
.13087 .34173 L
.13187 .36515 L
.13287 .38928 L
.13387 .41339 L
.13487 .43663 L
.13586 .45803 L
.13686 .47658 L
.13786 .49136 L
.13886 .50157 L
.13986 .50671 L
.14086 .50663 L
.14186 .50166 L
.14286 .49267 L
.14386 .48112 L
.14486 .46927 L
.14585 .46027 L
.14685 .4575 L
.14785 .46218 L
Mistroke
.14885 .47175 L
.14985 .40943 L
.15085 .40882 L
.15185 .40408 L
.15285 .39656 L
.15385 .3872 L
.15485 .37674 L
.15584 .36577 L
.15684 .35471 L
.15784 .34385 L
.15884 .33337 L
.15984 .32336 L
.16084 .31386 L
.16184 .30488 L
.16284 .29639 L
.16384 .28836 L
.16484 .28076 L
.16583 .27356 L
.16683 .26673 L
.16783 .26024 L
.16883 .25408 L
.16983 .24824 L
.17083 .2427 L
.17183 .23747 L
.17283 .23255 L
.17383 .22795 L
.17483 .22369 L
.17582 .21978 L
.17682 .21627 L
.17782 .21318 L
.17882 .21056 L
.17982 .20848 L
.18082 .207 L
.18182 .20621 L
.18282 .20618 L
.18382 .20703 L
.18482 .20888 L
.18581 .21183 L
.18681 .21604 L
.18781 .22162 L
.18881 .22872 L
.18981 .23745 L
.19081 .24795 L
.19181 .2603 L
.19281 .27457 L
.19381 .29079 L
.19481 .30892 L
.1958 .32887 L
.1968 .35042 L
.1978 .37329 L
Mistroke
.1988 .39705 L
.1998 .17972 L
.2008 .18832 L
.2018 .19735 L
.2028 .20762 L
.2038 .21948 L
.2048 .23317 L
.20579 .2488 L
.20679 .26643 L
.20779 .28595 L
.20879 .30711 L
.20979 .3295 L
.21079 .35251 L
.21179 .37538 L
.21279 .39722 L
.21379 .41709 L
.21479 .43408 L
.21578 .44745 L
.21678 .45671 L
.21778 .46167 L
.21878 .4625 L
.21978 .45963 L
.22078 .45367 L
.22178 .44529 L
.22278 .43513 L
.22378 .42375 L
.22478 .41162 L
.22577 .39911 L
.22677 .38654 L
.22777 .37416 L
.22877 .36215 L
.22977 .35064 L
.23077 .3397 L
.23177 .32934 L
.23277 .31958 L
.23377 .3104 L
.23477 .30176 L
.23576 .29363 L
.23676 .28597 L
.23776 .27876 L
.23876 .27197 L
.23976 .26558 L
.24076 .25958 L
.24176 .25395 L
.24276 .24872 L
.24376 .24386 L
.24476 .23942 L
.24575 .23539 L
.24675 .23182 L
.24775 .22874 L
Mistroke
.24875 .22619 L
.24975 .24194 L
.25075 .24493 L
.25175 .24714 L
.25275 .2493 L
.25375 .25165 L
.25475 .25433 L
.25574 .25746 L
.25674 .26111 L
.25774 .26533 L
.25874 .27019 L
.25974 .27572 L
.26074 .28194 L
.26174 .28883 L
.26274 .29637 L
.26374 .30451 L
.26474 .31314 L
.26573 .32217 L
.26673 .33143 L
.26773 .34076 L
.26873 .34996 L
.26973 .35883 L
.27073 .36714 L
.27173 .37472 L
.27273 .38136 L
.27373 .38694 L
.27473 .39134 L
.27572 .39451 L
.27672 .39646 L
.27772 .39724 L
.27872 .39694 L
.27972 .39569 L
.28072 .39364 L
.28172 .39092 L
.28272 .38767 L
.28372 .38402 L
.28472 .38004 L
.28571 .3758 L
.28671 .37137 L
.28771 .36678 L
.28871 .36207 L
.28971 .35727 L
.29071 .35241 L
.29171 .34752 L
.29271 .34264 L
.29371 .3378 L
.29471 .33302 L
.2957 .32834 L
.2967 .32378 L
.2977 .31937 L
Mistroke
.2987 .31515 L
.2997 .24994 L
.3007 .24871 L
.3017 .24651 L
.3027 .244 L
.3037 .24143 L
.3047 .2389 L
.30569 .23649 L
.30669 .23428 L
.30769 .23232 L
.30869 .23066 L
.30969 .22937 L
.31069 .22851 L
.31169 .22815 L
.31269 .22836 L
.31369 .22922 L
.31469 .23083 L
.31568 .23327 L
.31668 .23665 L
.31768 .24104 L
.31868 .24654 L
.31968 .25323 L
.32068 .26115 L
.32168 .27035 L
.32268 .28083 L
.32368 .29254 L
.32468 .3054 L
.32567 .31926 L
.32667 .33392 L
.32767 .34908 L
.32867 .36441 L
.32967 .37947 L
.33067 .39383 L
.33167 .407 L
.33267 .41852 L
.33367 .42799 L
.33467 .43513 L
.33566 .4398 L
.33666 .44208 L
.33766 .44228 L
.33866 .44094 L
.33966 .43883 L
.34066 .43678 L
.34166 .43549 L
.34266 .43515 L
.34366 .43542 L
.34466 .43559 L
.34565 .43497 L
.34665 .43308 L
.34765 .4297 L
Mistroke
.34865 .42482 L
.34965 .37368 L
.35065 .37597 L
.35165 .37575 L
.35265 .37381 L
.35365 .37056 L
.35465 .36627 L
.35564 .36118 L
.35664 .35551 L
.35764 .34942 L
.35864 .34306 L
.35964 .33653 L
.36064 .32994 L
.36164 .32334 L
.36264 .31679 L
.36364 .31032 L
.36464 .30398 L
.36563 .29776 L
.36663 .29169 L
.36763 .28579 L
.36863 .28005 L
.36963 .27448 L
.37063 .26911 L
.37163 .26392 L
.37263 .25893 L
.37363 .25415 L
.37463 .2496 L
.37562 .24529 L
.37662 .24124 L
.37762 .23748 L
.37862 .23404 L
.37962 .23095 L
.38062 .22826 L
.38162 .22602 L
.38262 .22429 L
.38362 .22313 L
.38462 .22264 L
.38561 .2229 L
.38661 .22401 L
.38761 .22607 L
.38861 .2292 L
.38961 .23351 L
.39061 .23912 L
.39161 .24614 L
.39261 .25469 L
.39361 .26485 L
.39461 .2767 L
.3956 .29029 L
.3966 .30563 L
.3976 .32267 L
Mistroke
.3986 .3413 L
.3996 .12569 L
.4006 .12834 L
.4016 .13012 L
.4026 .13176 L
.4036 .13355 L
.4046 .13567 L
.40559 .13832 L
.40659 .14168 L
.40759 .14595 L
.40859 .15137 L
.40959 .1582 L
.41059 .1667 L
.41159 .17717 L
.41259 .18988 L
.41359 .2051 L
.41459 .22302 L
.41558 .24377 L
.41658 .26735 L
.41758 .2936 L
.41858 .32214 L
.41958 .35236 L
.42058 .38334 L
.42158 .4139 L
.42258 .44262 L
.42358 .46801 L
.42458 .48861 L
.42557 .50333 L
.42657 .51163 L
.42757 .51378 L
.42857 .51107 L
.42957 .50567 L
.43057 .50013 L
.43157 .49576 L
.43257 .49166 L
.43357 .48605 L
.43457 .47789 L
.43556 .4671 L
.43656 .45426 L
.43756 .44017 L
.43856 .42565 L
.43956 .41142 L
.44056 .39801 L
.44156 .38575 L
.44256 .37486 L
.44356 .36538 L
.44456 .35728 L
.44555 .35045 L
.44655 .34476 L
.44755 .34005 L
Mistroke
.44855 .33615 L
.44955 .31503 L
.45055 .31325 L
.45155 .31073 L
.45255 .30805 L
.45355 .3054 L
.45455 .30283 L
.45554 .30037 L
.45654 .29804 L
.45754 .29585 L
.45854 .29383 L
.45954 .29198 L
.46054 .29031 L
.46154 .28884 L
.46254 .28759 L
.46354 .28658 L
.46454 .28582 L
.46553 .28534 L
.46653 .28515 L
.46753 .28528 L
.46853 .28574 L
.46953 .28655 L
.47053 .28773 L
.47153 .28929 L
.47253 .29125 L
.47353 .29361 L
.47453 .29638 L
.47552 .29955 L
.47652 .30312 L
.47752 .30707 L
.47852 .31136 L
.47952 .31599 L
.48052 .32088 L
.48152 .32601 L
.48252 .33131 L
.48352 .3367 L
.48452 .34213 L
.48551 .3475 L
.48651 .35273 L
.48751 .35775 L
.48851 .36248 L
.48951 .36684 L
.49051 .37079 L
.49151 .37427 L
.49251 .37727 L
.49351 .37978 L
.49451 .38183 L
.4955 .38346 L
.4965 .38472 L
.4975 .38569 L
Mistroke
.4985 .38645 L
.4995 .39445 L
.5005 .39978 L
.5015 .40151 L
.5025 .40056 L
.5035 .39745 L
.5045 .39263 L
.50549 .38653 L
.50649 .37952 L
.50749 .37191 L
.50849 .36396 L
.50949 .35587 L
.51049 .34779 L
.51149 .33982 L
.51249 .33202 L
.51349 .32444 L
.51449 .31709 L
.51548 .30999 L
.51648 .30313 L
.51748 .2965 L
.51848 .2901 L
.51948 .28392 L
.52048 .27794 L
.52148 .27217 L
.52248 .26658 L
.52348 .26117 L
.52448 .25594 L
.52547 .25089 L
.52647 .24601 L
.52747 .24131 L
.52847 .23678 L
.52947 .23243 L
.53047 .22827 L
.53147 .2243 L
.53247 .22053 L
.53347 .21697 L
.53447 .21364 L
.53546 .21057 L
.53646 .20776 L
.53746 .20526 L
.53846 .2031 L
.53946 .20132 L
.54046 .19998 L
.54146 .19914 L
.54246 .19888 L
.54346 .19928 L
.54446 .20045 L
.54545 .20249 L
.54645 .20556 L
.54745 .20977 L
Mistroke
.54845 .2153 L
.54945 .13818 L
.55045 .14148 L
.55145 .14422 L
.55245 .14717 L
.55345 .15066 L
.55445 .15493 L
.55544 .16022 L
.55644 .16678 L
.55744 .17487 L
.55844 .18475 L
.55944 .1967 L
.56044 .21095 L
.56144 .2277 L
.56244 .24705 L
.56344 .26899 L
.56444 .29336 L
.56543 .31981 L
.56643 .34776 L
.56743 .37637 L
.56843 .40459 L
.56943 .43118 L
.57043 .45483 L
.57143 .47433 L
.57243 .48876 L
.57343 .49767 L
.57443 .50128 L
.57542 .5005 L
.57642 .49675 L
.57742 .49142 L
.57842 .48516 L
.57942 .47777 L
.58042 .46878 L
.58142 .45804 L
.58242 .44579 L
.58342 .43253 L
.58442 .41883 L
.58541 .40522 L
.58641 .39213 L
.58741 .37986 L
.58841 .36859 L
.58941 .35842 L
.59041 .34935 L
.59141 .34134 L
.59241 .33433 L
.59341 .32823 L
.59441 .32295 L
.5954 .31841 L
.5964 .31452 L
.5974 .31123 L
Mistroke
.5984 .30846 L
.5994 .26073 L
.6004 .25977 L
.6014 .25805 L
.6024 .25621 L
.6034 .25447 L
.6044 .25293 L
.60539 .25165 L
.60639 .25069 L
.60739 .25009 L
.60839 .24991 L
.60939 .2502 L
.61039 .251 L
.61139 .25238 L
.61239 .25437 L
.61339 .25704 L
.61439 .26043 L
.61538 .26457 L
.61638 .2695 L
.61738 .27524 L
.61838 .28177 L
.61938 .28908 L
.62038 .29714 L
.62138 .30585 L
.62238 .31514 L
.62338 .32486 L
.62438 .33487 L
.62537 .34496 L
.62637 .35495 L
.62737 .36459 L
.62837 .37366 L
.62937 .38195 L
.63037 .38925 L
.63137 .39543 L
.63237 .40038 L
.63337 .40408 L
.63437 .40658 L
.63536 .408 L
.63636 .40855 L
.63736 .40844 L
.63836 .40791 L
.63936 .40712 L
.64036 .40618 L
.64136 .40507 L
.64236 .4037 L
.64336 .40195 L
.64436 .39971 L
.64535 .39689 L
.64635 .39347 L
.64735 .38945 L
Mistroke
.64835 .38487 L
.64935 .23968 L
.65035 .23887 L
.65135 .23708 L
.65235 .23497 L
.65335 .23279 L
.65435 .23064 L
.65534 .22862 L
.65634 .22677 L
.65734 .22518 L
.65834 .22389 L
.65934 .22295 L
.66034 .22245 L
.66134 .22244 L
.66234 .223 L
.66334 .22421 L
.66434 .22616 L
.66533 .22893 L
.66633 .23262 L
.66733 .2373 L
.66833 .24307 L
.66933 .24998 L
.67033 .25809 L
.67133 .26741 L
.67233 .27796 L
.67333 .28968 L
.67433 .30249 L
.67532 .31623 L
.67632 .33071 L
.67732 .34565 L
.67832 .36072 L
.67932 .37553 L
.68032 .38964 L
.68132 .40262 L
.68232 .41401 L
.68332 .42345 L
.68432 .43066 L
.68531 .4355 L
.68631 .43802 L
.68731 .43851 L
.68831 .4375 L
.68931 .43571 L
.69031 .43401 L
.69131 .43311 L
.69231 .43328 L
.69331 .43418 L
.69431 .43508 L
.6953 .43523 L
.6963 .43408 L
.6973 .43139 L
Mistroke
.6983 .42712 L
.6993 .34418 L
.7003 .33962 L
.7013 .3339 L
.7023 .32772 L
.7033 .32135 L
.7043 .31492 L
.70529 .30851 L
.70629 .30217 L
.70729 .29592 L
.70829 .28979 L
.70929 .28378 L
.71029 .27791 L
.71129 .27218 L
.71229 .26658 L
.71329 .26112 L
.71429 .25581 L
.71528 .25064 L
.71628 .24561 L
.71728 .24073 L
.71828 .236 L
.71928 .23142 L
.72028 .227 L
.72128 .22274 L
.72228 .21865 L
.72328 .21474 L
.72428 .21103 L
.72527 .20752 L
.72627 .20424 L
.72727 .20121 L
.72827 .19846 L
.72927 .19603 L
.73027 .19396 L
.73127 .19231 L
.73227 .19114 L
.73327 .19053 L
.73427 .19057 L
.73526 .19137 L
.73626 .19306 L
.73726 .19576 L
.73826 .19964 L
.73926 .20483 L
.74026 .21151 L
.74126 .21984 L
.74226 .22999 L
.74326 .2421 L
.74426 .25631 L
.74525 .27271 L
.74625 .29136 L
.74725 .31223 L
Mistroke
.74825 .33522 L
.74925 .14944 L
.75025 .16521 L
.75125 .18227 L
.75225 .20161 L
.75325 .2237 L
.75425 .2488 L
.75524 .27695 L
.75624 .30787 L
.75724 .34097 L
.75824 .37526 L
.75924 .40939 L
.76024 .4417 L
.76124 .47041 L
.76224 .49384 L
.76324 .51069 L
.76424 .52032 L
.76523 .52284 L
.76623 .51909 L
.76723 .51027 L
.76823 .49772 L
.76923 .48262 L
.77023 .46602 L
.77123 .44885 L
.77223 .43192 L
.77323 .41586 L
.77423 .40112 L
.77522 .38799 L
.77622 .37658 L
.77722 .36688 L
.77822 .35879 L
.77922 .35216 L
.78022 .34682 L
.78122 .34259 L
.78222 .33929 L
.78322 .33677 L
.78422 .33489 L
.78521 .33353 L
.78621 .33258 L
.78721 .33197 L
.78821 .33163 L
.78921 .33149 L
.79021 .3315 L
.79121 .33164 L
.79221 .33185 L
.79321 .33213 L
.79421 .33245 L
.7952 .3328 L
.7962 .33316 L
.7972 .33353 L
Mistroke
.7982 .33391 L
.7992 .29089 L
.8002 .29609 L
.8012 .30032 L
.8022 .30422 L
.8032 .30798 L
.8042 .31165 L
.80519 .31527 L
.80619 .31882 L
.80719 .3223 L
.80819 .32568 L
.80919 .32892 L
.81019 .33199 L
.81119 .33486 L
.81219 .33749 L
.81319 .33984 L
.81419 .34189 L
.81518 .34362 L
.81618 .345 L
.81718 .34604 L
.81818 .34673 L
.81918 .34707 L
.82018 .34708 L
.82118 .34678 L
.82218 .34618 L
.82318 .34532 L
.82418 .34423 L
.82517 .34295 L
.82617 .3415 L
.82717 .33992 L
.82817 .33825 L
.82917 .33653 L
.83017 .33477 L
.83117 .33303 L
.83217 .33132 L
.83317 .32968 L
.83417 .32813 L
.83516 .32669 L
.83616 .32539 L
.83716 .32424 L
.83816 .32327 L
.83916 .32249 L
.84016 .32192 L
.84116 .32157 L
.84216 .32144 L
.84316 .32156 L
.84416 .32192 L
.84515 .32254 L
.84615 .32341 L
.84715 .32453 L
Mistroke
.84815 .32591 L
.84915 .31982 L
.85015 .32849 L
.85115 .33554 L
.85215 .34158 L
.85315 .34672 L
.85415 .351 L
.85514 .35443 L
.85614 .35701 L
.85714 .35875 L
.85814 .35966 L
.85914 .35979 L
.86014 .35917 L
.86114 .35788 L
.86214 .35598 L
.86314 .35354 L
.86414 .35063 L
.86513 .34735 L
.86613 .34375 L
.86713 .33991 L
.86813 .33589 L
.86913 .33175 L
.87013 .32755 L
.87113 .32332 L
.87213 .31913 L
.87313 .31499 L
.87413 .31096 L
.87512 .30706 L
.87612 .30331 L
.87712 .29976 L
.87812 .29642 L
.87912 .29333 L
.88012 .29051 L
.88112 .28799 L
.88212 .2858 L
.88312 .28398 L
.88412 .28255 L
.88511 .28154 L
.88611 .281 L
.88711 .28095 L
.88811 .28143 L
.88911 .28246 L
.89011 .28409 L
.89111 .28634 L
.89211 .28924 L
.89311 .29279 L
.89411 .29702 L
.8951 .30192 L
.8961 .30748 L
.8971 .31369 L
Mistroke
.8981 .3205 L
.8991 .16344 L
.9001 .17152 L
.9011 .17956 L
.9021 .18841 L
.9031 .19849 L
.9041 .21008 L
.90509 .22342 L
.90609 .23867 L
.90709 .25593 L
.90809 .27519 L
.90909 .29628 L
.91009 .31889 L
.91109 .34254 L
.91209 .36655 L
.91309 .3901 L
.91409 .41225 L
.91508 .43205 L
.91608 .44862 L
.91708 .46128 L
.91808 .46966 L
.91908 .47374 L
.92008 .47387 L
.92108 .47064 L
.92208 .46475 L
.92308 .45683 L
.92408 .44738 L
.92507 .43679 L
.92607 .42539 L
.92707 .41349 L
.92807 .40141 L
.92907 .3894 L
.93007 .37769 L
.93107 .36646 L
.93207 .35579 L
.93307 .34576 L
.93407 .33637 L
.93506 .32764 L
.93606 .31952 L
.93706 .312 L
.93806 .30503 L
.93906 .2986 L
.94006 .29266 L
.94106 .2872 L
.94206 .28221 L
.94306 .27768 L
.94406 .2736 L
.94505 .26999 L
.94605 .26685 L
.94705 .26421 L
Mistroke
.94805 .26207 L
.94905 .21246 L
.95005 .21215 L
.95105 .21088 L
.95205 .20933 L
.95305 .20774 L
.95405 .20625 L
.95504 .20496 L
.95604 .20394 L
.95704 .20327 L
.95804 .20305 L
.95904 .20335 L
.96004 .20428 L
.96104 .20594 L
.96204 .20845 L
.96304 .21192 L
.96404 .21649 L
.96503 .22227 L
.96603 .22939 L
.96703 .23793 L
.96803 .24799 L
.96903 .25959 L
.97003 .27275 L
.97103 .2874 L
.97203 .30342 L
.97303 .32059 L
.97403 .33861 L
.97502 .35708 L
.97602 .37549 L
.97702 .39326 L
.97802 .40977 L
.97902 .42438 L
.98002 .43651 L
.98102 .44572 L
.98202 .45176 L
.98302 .45469 L
.98402 .45488 L
.98501 .45311 L
.98601 .45049 L
.98701 .44826 L
.98801 .44726 L
.98901 .44741 L
.99001 .4478 L
.99101 .44734 L
.99201 .44529 L
.99301 .4413 L
.99401 .4354 L
.995 .42783 L
.996 .41895 L
.997 .40914 L
Mistroke
.998 .39877 L
.999 .29229 L
Mfstroke
1 0 0 r
gsave
.999 .28598 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00166 L
.004 .00164 L
.005 .00164 L
.00599 .00167 L
.00699 .00173 L
.00799 .00183 L
.00899 .00199 L
.00999 .00221 L
.01099 .00251 L
.01199 .00291 L
.01299 .00343 L
.01399 .00412 L
.01499 .005 L
.01598 .00614 L
.01698 .00759 L
.01798 .00943 L
.01898 .01177 L
.01998 .01473 L
.02098 .01847 L
.02198 .02316 L
.02298 .02903 L
.02398 .03636 L
.02498 .04546 L
.02597 .05669 L
.02697 .07045 L
.02797 .08715 L
.02897 .10719 L
.02997 .13093 L
.03097 .15856 L
.03197 .19005 L
.03297 .22506 L
.03397 .26281 L
.03497 .30212 L
.03596 .34143 L
.03696 .37903 L
.03796 .41338 L
.03896 .44334 L
.03996 .46838 L
.04096 .48838 L
.04196 .50334 L
.04296 .51297 L
.04396 .51663 L
.04496 .51358 L
.04595 .50353 L
.04695 .48716 L
.04795 .46621 L
.04895 .44313 L
Mistroke
.04995 .40915 L
.05095 .45691 L
.05195 .4996 L
.05295 .53374 L
.05395 .5564 L
.05495 .56592 L
.05594 .56238 L
.05694 .5477 L
.05794 .5251 L
.05894 .4983 L
.05994 .47069 L
.06094 .44484 L
.06194 .42232 L
.06294 .40383 L
.06394 .38942 L
.06494 .37876 L
.06593 .37133 L
.06693 .36653 L
.06793 .36376 L
.06893 .36246 L
.06993 .36213 L
.07093 .36233 L
.07193 .3627 L
.07293 .36294 L
.07393 .36287 L
.07493 .36235 L
.07592 .36135 L
.07692 .35985 L
.07792 .35793 L
.07892 .35567 L
.07992 .35314 L
.08092 .35046 L
.08192 .34769 L
.08292 .3449 L
.08392 .34213 L
.08492 .3394 L
.08591 .3367 L
.08691 .33405 L
.08791 .3314 L
.08891 .32875 L
.08991 .32606 L
.09091 .32331 L
.09191 .32049 L
.09291 .31756 L
.09391 .31454 L
.09491 .3114 L
.0959 .30815 L
.0969 .30479 L
.0979 .30135 L
.0989 .29782 L
Mistroke
.0999 .23186 L
.1009 .22574 L
.1019 .21983 L
.1029 .21412 L
.1039 .20862 L
.1049 .20334 L
.10589 .19827 L
.10689 .19344 L
.10789 .18883 L
.10889 .18446 L
.10989 .18034 L
.11089 .17649 L
.11189 .17292 L
.11289 .16964 L
.11389 .16668 L
.11489 .16407 L
.11588 .16183 L
.11688 .16 L
.11788 .15861 L
.11888 .15772 L
.11988 .15738 L
.12088 .15763 L
.12188 .15855 L
.12288 .1602 L
.12388 .16266 L
.12488 .16599 L
.12587 .17028 L
.12687 .17559 L
.12787 .18197 L
.12887 .18947 L
.12987 .1981 L
.13087 .20785 L
.13187 .21864 L
.13287 .23038 L
.13387 .2429 L
.13487 .25599 L
.13586 .2694 L
.13686 .28287 L
.13786 .2961 L
.13886 .30884 L
.13986 .32088 L
.14086 .33205 L
.14186 .34225 L
.14286 .35142 L
.14386 .35951 L
.14486 .36648 L
.14585 .37223 L
.14685 .37664 L
.14785 .37956 L
.14885 .38083 L
Mistroke
.14985 .4031 L
.15085 .39833 L
.15185 .39038 L
.15285 .38008 L
.15385 .36824 L
.15485 .35555 L
.15584 .34257 L
.15684 .32971 L
.15784 .31725 L
.15884 .30533 L
.15984 .29404 L
.16084 .2834 L
.16184 .27337 L
.16284 .26392 L
.16384 .25502 L
.16484 .2466 L
.16583 .23864 L
.16683 .23108 L
.16783 .2239 L
.16883 .21706 L
.16983 .21056 L
.17083 .20437 L
.17183 .19848 L
.17283 .19288 L
.17383 .18757 L
.17483 .18254 L
.17582 .17781 L
.17682 .17336 L
.17782 .16921 L
.17882 .16536 L
.17982 .16184 L
.18082 .15865 L
.18182 .15581 L
.18282 .15334 L
.18382 .15128 L
.18482 .14964 L
.18581 .14846 L
.18681 .14777 L
.18781 .14761 L
.18881 .14803 L
.18981 .14904 L
.19081 .15071 L
.19181 .15304 L
.19281 .15608 L
.19381 .15981 L
.19481 .16425 L
.1958 .16935 L
.1968 .17506 L
.1978 .18128 L
.1988 .18788 L
Mistroke
.1998 .17337 L
.2008 .17806 L
.2018 .18427 L
.2028 .19206 L
.2038 .20151 L
.2048 .21265 L
.20579 .22549 L
.20679 .23999 L
.20779 .25604 L
.20879 .27342 L
.20979 .29182 L
.21079 .31082 L
.21179 .32987 L
.21279 .34832 L
.21379 .36548 L
.21479 .38063 L
.21578 .39313 L
.21678 .40247 L
.21778 .40831 L
.21878 .41055 L
.21978 .40935 L
.22078 .40503 L
.22178 .39809 L
.22278 .3891 L
.22378 .37863 L
.22478 .36722 L
.22577 .35534 L
.22677 .34335 L
.22777 .33151 L
.22877 .32 L
.22977 .30893 L
.23077 .29836 L
.23177 .2883 L
.23277 .27874 L
.23377 .26968 L
.23477 .26107 L
.23576 .25289 L
.23676 .24512 L
.23776 .23772 L
.23876 .23067 L
.23976 .22396 L
.24076 .21757 L
.24176 .21149 L
.24276 .20571 L
.24376 .20024 L
.24476 .19506 L
.24575 .19018 L
.24675 .18561 L
.24775 .18135 L
.24875 .17742 L
Mistroke
.24975 .23562 L
.25075 .23466 L
.25175 .23409 L
.25275 .23394 L
.25375 .23422 L
.25475 .23497 L
.25574 .2362 L
.25674 .23793 L
.25774 .24018 L
.25874 .24295 L
.25974 .24625 L
.26074 .25007 L
.26174 .25442 L
.26274 .25925 L
.26374 .26455 L
.26474 .27025 L
.26573 .27629 L
.26673 .2826 L
.26773 .28907 L
.26873 .29559 L
.26973 .30205 L
.27073 .30831 L
.27173 .31425 L
.27273 .31974 L
.27373 .32464 L
.27473 .32887 L
.27572 .33233 L
.27672 .33497 L
.27772 .33673 L
.27872 .33761 L
.27972 .33763 L
.28072 .33681 L
.28172 .33522 L
.28272 .33291 L
.28372 .32996 L
.28472 .32645 L
.28571 .32247 L
.28671 .3181 L
.28771 .31341 L
.28871 .30847 L
.28971 .30335 L
.29071 .2981 L
.29171 .29278 L
.29271 .28743 L
.29371 .28209 L
.29471 .27678 L
.2957 .27154 L
.2967 .26639 L
.2977 .26135 L
.2987 .25643 L
Mistroke
.2997 .24362 L
.3007 .2385 L
.3017 .23358 L
.3027 .22888 L
.3037 .22443 L
.3047 .22022 L
.30569 .21627 L
.30669 .21261 L
.30769 .20925 L
.30869 .20621 L
.30969 .20352 L
.31069 .20119 L
.31169 .19926 L
.31269 .19776 L
.31369 .19672 L
.31469 .19619 L
.31568 .19621 L
.31668 .19681 L
.31768 .19805 L
.31868 .19997 L
.31968 .20262 L
.32068 .20604 L
.32168 .21029 L
.32268 .21538 L
.32368 .22135 L
.32468 .22819 L
.32567 .23589 L
.32667 .24442 L
.32767 .25371 L
.32867 .26365 L
.32967 .27412 L
.33067 .28495 L
.33167 .29594 L
.33267 .30689 L
.33367 .31755 L
.33467 .32769 L
.33566 .3371 L
.33666 .34555 L
.33766 .35287 L
.33866 .35892 L
.33966 .36358 L
.34066 .36677 L
.34166 .36848 L
.34266 .3687 L
.34366 .36748 L
.34466 .36492 L
.34565 .36112 L
.34665 .35623 L
.34765 .35043 L
.34865 .34388 L
Mistroke
.34965 .36737 L
.35065 .36567 L
.35165 .36257 L
.35265 .35824 L
.35365 .35291 L
.35465 .34676 L
.35564 .34001 L
.35664 .33282 L
.35764 .32536 L
.35864 .31773 L
.35964 .31006 L
.36064 .30241 L
.36164 .29484 L
.36264 .2874 L
.36364 .2801 L
.36464 .27298 L
.36563 .26605 L
.36663 .25931 L
.36763 .25276 L
.36863 .24641 L
.36963 .24026 L
.37063 .23431 L
.37163 .22857 L
.37263 .22303 L
.37363 .21769 L
.37463 .21256 L
.37562 .20765 L
.37662 .20295 L
.37762 .19848 L
.37862 .19423 L
.37962 .19023 L
.38062 .18648 L
.38162 .18299 L
.38262 .17978 L
.38362 .17686 L
.38462 .17427 L
.38561 .17201 L
.38661 .17011 L
.38761 .1686 L
.38861 .16751 L
.38961 .16688 L
.39061 .16673 L
.39161 .16709 L
.39261 .16801 L
.39361 .16951 L
.39461 .17162 L
.3956 .17435 L
.3966 .1777 L
.3976 .18167 L
.3986 .18623 L
Mistroke
.3996 .11935 L
.4006 .11815 L
.4016 .11728 L
.4026 .11677 L
.4036 .11668 L
.4046 .11708 L
.40559 .11805 L
.40659 .11967 L
.40759 .12205 L
.40859 .12531 L
.40959 .12957 L
.41059 .13498 L
.41159 .14169 L
.41259 .14988 L
.41359 .15972 L
.41459 .17136 L
.41558 .18494 L
.41658 .20057 L
.41758 .21828 L
.41858 .23802 L
.41958 .25961 L
.42058 .28272 L
.42158 .30687 L
.42258 .3314 L
.42358 .3555 L
.42458 .37827 L
.42557 .39877 L
.42657 .41615 L
.42757 .42972 L
.42857 .43903 L
.42957 .44392 L
.43057 .44454 L
.43157 .44128 L
.43257 .43475 L
.43357 .42566 L
.43457 .41475 L
.43556 .40276 L
.43656 .39029 L
.43756 .37786 L
.43856 .36585 L
.43956 .35448 L
.44056 .34391 L
.44156 .33418 L
.44256 .32529 L
.44356 .31718 L
.44456 .30979 L
.44555 .30305 L
.44655 .29688 L
.44755 .2912 L
.44855 .28596 L
Mistroke
.44955 .30871 L
.45055 .303 L
.45155 .29771 L
.45255 .29279 L
.45355 .28818 L
.45455 .28385 L
.45554 .27978 L
.45654 .27594 L
.45754 .27232 L
.45854 .26892 L
.45954 .26571 L
.46054 .26271 L
.46154 .25992 L
.46254 .25733 L
.46354 .25495 L
.46454 .25279 L
.46553 .25084 L
.46653 .24913 L
.46753 .24766 L
.46853 .24643 L
.46953 .24546 L
.47053 .24475 L
.47153 .24431 L
.47253 .24416 L
.47353 .24429 L
.47453 .24471 L
.47552 .24544 L
.47652 .24646 L
.47752 .24779 L
.47852 .24941 L
.47952 .25133 L
.48052 .25353 L
.48152 .25601 L
.48252 .25874 L
.48352 .26171 L
.48452 .26488 L
.48551 .26824 L
.48651 .27174 L
.48751 .27534 L
.48851 .27902 L
.48951 .28272 L
.49051 .28641 L
.49151 .29002 L
.49251 .29353 L
.49351 .29688 L
.49451 .30004 L
.4955 .30295 L
.4965 .30559 L
.4975 .30791 L
.4985 .30988 L
Mistroke
.4995 .38813 L
.5005 .38951 L
.5015 .38839 L
.5025 .38509 L
.5035 .37993 L
.5045 .37331 L
.50549 .3656 L
.50649 .35714 L
.50749 .34823 L
.50849 .33912 L
.50949 .32997 L
.51049 .32094 L
.51149 .3121 L
.51249 .30352 L
.51349 .29522 L
.51449 .2872 L
.51548 .27949 L
.51648 .27205 L
.51748 .26488 L
.51848 .25798 L
.51948 .25132 L
.52048 .24489 L
.52148 .23868 L
.52248 .23268 L
.52348 .22688 L
.52448 .22128 L
.52547 .21587 L
.52647 .21065 L
.52747 .20561 L
.52847 .20076 L
.52947 .19609 L
.53047 .19162 L
.53147 .18733 L
.53247 .18323 L
.53347 .17934 L
.53447 .17565 L
.53546 .17219 L
.53646 .16895 L
.53746 .16596 L
.53846 .16323 L
.53946 .16079 L
.54046 .15865 L
.54146 .15686 L
.54246 .15543 L
.54346 .15441 L
.54446 .15385 L
.54545 .15379 L
.54645 .15429 L
.54745 .15543 L
.54845 .15726 L
Mistroke
.54945 .13185 L
.55045 .13129 L
.55145 .13135 L
.55245 .1321 L
.55345 .13362 L
.55445 .136 L
.55544 .13935 L
.55644 .1438 L
.55744 .14949 L
.55844 .15656 L
.55944 .16516 L
.56044 .17546 L
.56144 .18758 L
.56244 .20163 L
.56344 .21768 L
.56444 .23571 L
.56543 .25562 L
.56643 .27716 L
.56743 .29996 L
.56843 .32347 L
.56943 .34698 L
.57043 .36966 L
.57143 .3906 L
.57243 .4089 L
.57343 .42378 L
.57443 .43463 L
.57542 .44114 L
.57642 .44328 L
.57742 .44134 L
.57842 .43585 L
.57942 .42749 L
.58042 .41701 L
.58142 .40517 L
.58242 .39262 L
.58342 .37991 L
.58442 .36743 L
.58541 .35547 L
.58641 .3442 L
.58741 .3337 L
.58841 .32399 L
.58941 .31503 L
.59041 .30678 L
.59141 .29918 L
.59241 .29215 L
.59341 .28565 L
.59441 .27961 L
.5954 .27399 L
.5964 .26874 L
.5974 .26383 L
.5984 .25924 L
Mistroke
.5994 .25442 L
.6004 .24956 L
.6014 .24514 L
.6024 .24112 L
.6034 .2375 L
.6044 .23425 L
.60539 .23139 L
.60639 .22891 L
.60739 .22682 L
.60839 .22513 L
.60939 .22386 L
.61039 .22302 L
.61139 .22263 L
.61239 .22271 L
.61339 .22328 L
.61439 .22437 L
.61538 .22599 L
.61638 .22816 L
.61738 .23091 L
.61838 .23423 L
.61938 .23814 L
.62038 .24263 L
.62138 .24768 L
.62238 .25327 L
.62338 .25937 L
.62438 .2659 L
.62537 .27281 L
.62637 .28 L
.62737 .28736 L
.62837 .29479 L
.62937 .30216 L
.63037 .30932 L
.63137 .31614 L
.63237 .3225 L
.63337 .32826 L
.63437 .33332 L
.63536 .33759 L
.63636 .34098 L
.63736 .34346 L
.63836 .34499 L
.63936 .34558 L
.64036 .34524 L
.64136 .34402 L
.64236 .34197 L
.64336 .33915 L
.64436 .33566 L
.64535 .33158 L
.64635 .327 L
.64735 .322 L
.64835 .31668 L
Mistroke
.64935 .23337 L
.65035 .22869 L
.65135 .22423 L
.65235 .21999 L
.65335 .21598 L
.65435 .21221 L
.65534 .2087 L
.65634 .20547 L
.65734 .20252 L
.65834 .19989 L
.65934 .19759 L
.66034 .19565 L
.66134 .1941 L
.66234 .19296 L
.66334 .19227 L
.66434 .19208 L
.66533 .19241 L
.66633 .19331 L
.66733 .19483 L
.66833 .19702 L
.66933 .19991 L
.67033 .20355 L
.67133 .20798 L
.67233 .21323 L
.67333 .21932 L
.67433 .22626 L
.67532 .23402 L
.67632 .24258 L
.67732 .25187 L
.67832 .2618 L
.67932 .27224 L
.68032 .28304 L
.68132 .29401 L
.68232 .30495 L
.68332 .31565 L
.68432 .32588 L
.68531 .33542 L
.68631 .34407 L
.68731 .35165 L
.68831 .35802 L
.68931 .36304 L
.69031 .36665 L
.69131 .36879 L
.69231 .36948 L
.69331 .36874 L
.69431 .36664 L
.6953 .3633 L
.6963 .35885 L
.6973 .35344 L
.6983 .34726 L
Mistroke
.6993 .33787 L
.7003 .32943 L
.7013 .321 L
.7023 .31266 L
.7033 .30446 L
.7043 .29644 L
.70529 .28862 L
.70629 .28101 L
.70729 .27361 L
.70829 .26643 L
.70929 .25946 L
.71029 .25271 L
.71129 .24615 L
.71229 .23979 L
.71329 .23362 L
.71429 .22764 L
.71528 .22185 L
.71628 .21624 L
.71728 .2108 L
.71828 .20554 L
.71928 .20046 L
.72028 .19556 L
.72128 .19083 L
.72228 .18628 L
.72328 .1819 L
.72428 .17772 L
.72527 .17373 L
.72627 .16993 L
.72727 .16634 L
.72827 .16296 L
.72927 .15982 L
.73027 .15692 L
.73127 .15428 L
.73227 .15192 L
.73327 .14988 L
.73427 .14818 L
.73526 .14684 L
.73626 .14593 L
.73726 .14547 L
.73826 .14551 L
.73926 .14612 L
.74026 .14736 L
.74126 .14929 L
.74226 .15199 L
.74326 .15552 L
.74426 .15996 L
.74525 .16539 L
.74625 .17186 L
.74725 .17941 L
.74825 .18808 L
Mistroke
.74925 .14308 L
.75025 .15495 L
.75125 .16914 L
.75225 .18584 L
.75325 .20522 L
.75425 .22732 L
.75524 .25208 L
.75624 .27924 L
.75724 .30832 L
.75824 .33856 L
.75924 .36893 L
.76024 .39815 L
.76124 .42478 L
.76224 .44735 L
.76324 .46461 L
.76424 .47566 L
.76523 .48016 L
.76623 .47835 L
.76723 .47103 L
.76823 .45938 L
.76923 .44476 L
.77023 .42851 L
.77123 .41176 L
.77223 .39538 L
.77323 .37995 L
.77423 .36581 L
.77522 .3531 L
.77622 .34181 L
.77722 .33187 L
.77822 .32314 L
.77922 .31548 L
.78022 .30875 L
.78122 .30282 L
.78222 .29755 L
.78322 .29286 L
.78422 .28866 L
.78521 .28487 L
.78621 .28144 L
.78721 .27833 L
.78821 .27549 L
.78921 .2729 L
.79021 .27053 L
.79121 .26838 L
.79221 .26642 L
.79321 .26465 L
.79421 .26306 L
.7952 .26166 L
.7962 .26044 L
.7972 .25939 L
.7982 .25854 L
Mistroke
.7992 .28456 L
.8002 .28586 L
.8012 .28734 L
.8022 .28896 L
.8032 .29068 L
.8042 .29246 L
.80519 .29427 L
.80619 .29606 L
.80719 .2978 L
.80819 .29946 L
.80919 .30101 L
.81019 .3024 L
.81119 .30361 L
.81219 .30463 L
.81319 .30542 L
.81419 .30598 L
.81518 .30628 L
.81618 .30633 L
.81718 .30612 L
.81818 .30565 L
.81918 .30492 L
.82018 .30396 L
.82118 .30277 L
.82218 .30137 L
.82318 .29978 L
.82418 .29801 L
.82517 .29609 L
.82617 .29405 L
.82717 .29189 L
.82817 .28966 L
.82917 .28735 L
.83017 .28501 L
.83117 .28265 L
.83217 .28028 L
.83317 .27792 L
.83417 .27561 L
.83516 .27333 L
.83616 .27113 L
.83716 .269 L
.83816 .26697 L
.83916 .26504 L
.84016 .26323 L
.84116 .26155 L
.84216 .26001 L
.84316 .25861 L
.84416 .25738 L
.84515 .25631 L
.84615 .25542 L
.84715 .25472 L
.84815 .2542 L
Mistroke
.84915 .31349 L
.85015 .31825 L
.85115 .32252 L
.85215 .32623 L
.85315 .3293 L
.85415 .33168 L
.85514 .33333 L
.85614 .33423 L
.85714 .33439 L
.85814 .33381 L
.85914 .33255 L
.86014 .33064 L
.86114 .32815 L
.86214 .32513 L
.86314 .32167 L
.86414 .31782 L
.86513 .31366 L
.86613 .30925 L
.86713 .30466 L
.86813 .29993 L
.86913 .29511 L
.87013 .29025 L
.87113 .28539 L
.87213 .28055 L
.87313 .27577 L
.87413 .27107 L
.87512 .26648 L
.87612 .262 L
.87712 .25767 L
.87812 .25348 L
.87912 .24947 L
.88012 .24564 L
.88112 .24201 L
.88212 .23859 L
.88312 .2354 L
.88412 .23244 L
.88511 .22974 L
.88611 .22731 L
.88711 .22516 L
.88811 .22332 L
.88911 .22179 L
.89011 .22059 L
.89111 .21974 L
.89211 .21926 L
.89311 .21917 L
.89411 .21947 L
.8951 .22018 L
.8961 .22132 L
.8971 .22289 L
.8981 .2249 L
Mistroke
.8991 .15711 L
.9001 .16131 L
.9011 .1666 L
.9021 .17312 L
.9031 .18098 L
.9041 .19029 L
.90509 .20116 L
.90609 .21366 L
.90709 .22783 L
.90809 .24362 L
.90909 .26095 L
.91009 .27961 L
.91109 .29928 L
.91209 .31953 L
.91309 .33979 L
.91409 .3594 L
.91508 .37764 L
.91608 .39378 L
.91708 .40715 L
.91808 .41723 L
.91908 .42367 L
.92008 .4264 L
.92108 .42555 L
.92208 .42148 L
.92308 .41472 L
.92408 .40586 L
.92507 .39551 L
.92607 .38424 L
.92707 .37253 L
.92807 .36077 L
.92907 .34922 L
.93007 .33808 L
.93107 .32745 L
.93207 .31738 L
.93307 .30789 L
.93407 .29896 L
.93506 .29055 L
.93606 .28264 L
.93706 .27518 L
.93806 .26813 L
.93906 .26147 L
.94006 .25515 L
.94106 .24917 L
.94206 .24349 L
.94306 .23811 L
.94406 .23301 L
.94505 .2282 L
.94605 .22365 L
.94705 .21939 L
.94805 .2154 L
Mistroke
.94905 .20616 L
.95005 .20199 L
.95105 .19806 L
.95205 .19439 L
.95305 .191 L
.95405 .18791 L
.95504 .18514 L
.95604 .18271 L
.95704 .18065 L
.95804 .179 L
.95904 .17779 L
.96004 .17706 L
.96104 .17686 L
.96204 .17724 L
.96304 .17826 L
.96404 .17998 L
.96503 .18246 L
.96603 .18577 L
.96703 .18998 L
.96803 .19514 L
.96903 .20132 L
.97003 .20856 L
.97103 .21689 L
.97203 .22632 L
.97303 .23681 L
.97403 .24831 L
.97502 .2607 L
.97602 .27382 L
.97702 .28745 L
.97802 .30134 L
.97902 .31519 L
.98002 .32866 L
.98102 .34142 L
.98202 .35312 L
.98302 .36347 L
.98402 .3722 L
.98501 .37911 L
.98601 .38406 L
.98701 .387 L
.98801 .38793 L
.98901 .38692 L
.99001 .38412 L
.99101 .37972 L
.99201 .37393 L
.99301 .36702 L
.99401 .35924 L
.995 .35084 L
.996 .34205 L
.997 .33307 L
.998 .32406 L
Mistroke
.999 .28598 L
Mfstroke
0 g
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{719.125, 296.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;?0001:2000`400?l00000o`00003ooooooooo
ooooom7ooooo003ooooooooooooodOooool00?oooooooooooooAooooo`00ooooooooooooom7ooooo
003ooooooooooooodOooool00?oooooooooooooAooooo`00ooooooooooooom7ooooo003ooooooooo
oooodOooool005Sooooo1Ol00003ooooo`;o00001?ooool2o`0001Cooooo0ol00003ooooo`;o0000
1?ooool2o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`0001?ooooo0ol00004ooooo`;o0000
1?ooool2o`00013ooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000hooooo`Go0000
0oooool2o`0000Cooooo0_l0000Eooooo`?o00000oooool2o`0000Cooooo0_l0000Cooooo`?o0000
1?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000@ooooo`?o0000
1?ooool2o`0000Cooooo0_l00004ooooo`;o0000=Oooool5o`0000?ooooo0_l00004ooooo`;o0000
5?ooool3o`0000?ooooo0_l00004ooooo`;o00005?ooool3o`0000Cooooo0_l00004ooooo`;o0000
4oooool3o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l00004ooooo`;o0000
1?ooool2o`0003Oooooo001Iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000Dooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000@ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0003Sooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Gooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=Oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
5?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0@ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000fooooo`00F_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004Oooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000iooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Booooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0003Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`00017ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00004_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000=_ooool005_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool03oooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool4o`0000?ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Booooo`?o00000oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
>_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0@ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Aooooo`Co00000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001;ooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000gooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01;ooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_oo
ool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003Kooooo001Hooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000ooooool0
00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000gooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017o
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01;ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001;ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000foooo
o`00F?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Cooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00003oooool2o`0000Cooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Oooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00005?ooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Booooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Aooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000oooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000dooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo
0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004oooool00ol0
003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000?ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo0000=_ooool005Wooooo0ol00004ooooo`;o00001?oo
ool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Wooooo0ol00004ooooo`;o00001?oo
ool2o`0001Kooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Dooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Kooooo0ol00004ooooo`;o00001?oo
ool2o`0001Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Eooooo`;o00001?oo
ool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0003Oooooo003ooooooooooooodOooool0
0?oooooooooooooAooooo`00ooooooooooooom7ooooo000nooooojco0000:?oooon/o`0002Gooooo
[?l00010ooooo`00?_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`2X
ooooo`03o`000?oooooooooo03kooooo000nooooo`03o`000?oooooooooo0:Sooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02?ooooo0_l0002Xoooo
o`;o0000@?ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo0:Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`2Xooooo`03
o`000?oooooooooo03kooooo000nooooo`;o0000ZOooool00ol0003oooooooooo`0Vooooo`;o0000
ZOooool00ol0003oooooooooo`0Sooooo`;o0000Z?ooool2o`00043ooooo000nooooo`03o`000?oo
oooooooo0:Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Xooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0nooooo`00?_ooool0
0ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0?_ooool0
03Oooooo0ol00004ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool06?ooool5o`00
00;ooooo0ol00004ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool08oooool2o`00
0:Sooooo0_l00010ooooo`00=_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ooooool0Z?ooool00ol0003oooooooooo`0Iooooo`06o`000?ooooooooooo`000?oooooo00000ooo
ool01Ol0003ooooooooooooooooo00000:[ooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`2Xooooo`03o`000?oooooooooo03kooooo000fooooo`05o`000?ooooooooooooooool00000
0oooool2o`000:Sooooo0_l0000Looooo`05o`000?ooooooooooooooool000000oooool01?l0003o
ooooooooooooool2o`0001Sooooo2Ol0nYZ7ooooo`;o00009Oooool2o`000:Sooooo0_l00010oooo
o`00=_ooool4o`0000Cooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Co00001?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool0Q_ooool00ol0003oooooooooo`0Looooo`?o00001?ooool00ol0003o
ooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000fooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Hooooo`07o`000?ooooooooooooooool0
003oooooo`000007ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`26ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000gooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Hooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJoooo
ooooool01Oooool00ol0nY[oooooooooo`26ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool00oooool2o`000:Sooooo0_l00010ooooo`00>?ooool2o`0000Cooooo00?o0000oooooooo
ool0Z?ooool00ol0003oooooooooo`0Iooooo`?o00001?ooool2o`0000Cooooo00?o0000oooooooo
ool05oooool00ol0nY[oooooooooo`05ooooo`[o0?ZJOoooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool01_ooool9o`3jVYWooooo00?o0000oooooooo
ool0?_ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo00kooooo2_l0nYX@ooooo`03o`3jV_oooooooooo07gooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooooooo03kooooo000nooooo`;o0000ZOoo
ool00ol0003oooooooooo`0Vooooo`;o00003oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oo
oooooooo07gooooo00?o0000ooooooooool07?ooool2o`0000Gooooo0_l00007ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool0U_ooool2o`00043ooooo000nooooo`03o`000?oooooo
oooo0:Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooo
oooo01Oooooo00?o0?ZJooooooooool0OOooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo09Oooooo00?o0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool05oooool00ol0
nY[oooooooooo`1mooooo`03o`000?oooooooooo02?ooooo0_l00007ooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool0U_ooool2o`00043ooooo000nooooo`03o`000?oooooooooo0:So
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01Oo
oooo00?o0?ZJooooooooool0OOooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Go
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooooooo03ko
oooo000nooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0OOooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`2Gooooo`03o`000?oooooooooo03kooooo000nooooo`;o0000ZOooool00ol0003ooooooooo
o`0Voooooa;o0?ZJ6Oooool00ol0nY[oooooooooo`0>oooooa;o0?ZJGOooool00ol0003ooooooooo
o`0Sooooo`;o00001_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo09Kooooo0_l0
0010ooooo`00?_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool0:?ooool9o`3jVPSooooo00?o0?ZJooooooooool03_ooool9o`3jVUGooooo00?o0000
ooooooooool08oooool9o`3jVPSooooo00?o0?ZJooooooooool0Uoooool00ol0003oooooooooo`0n
ooooo`00?_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool0<?ooool:o`3jVQSooooo00?o0?ZJooooooooool0Doooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0Uoooool00ol0003oooooooooo`0noooo
o`00?_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool0Doooool9o`3jVTcooooo00?o0000ooooooooool06oooool5o`0000?ooooo0_l0000?ooooo`03
o`3jV_oooooooooo09Kooooo0_l00010ooooo`00?_ooool00ol0003oooooooooo`2Xooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool0Foooool:o`3jVPOooooo2_l0nYXbooooo`03o`00
0?oooooooooo01cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0>ooooo`03
o`3jV_oooooooooo09Oooooo00?o0000ooooooooool0?_ooool003kooooo0_l0002Yooooo`03o`00
0?oooooooooo02Kooooo0_l0001Uooooo`Wo0?ZJ2?ooool9o`3jVR[ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`03ooooo`;o00003oooool00ol0nY[oooooooooo`2Fooooo`;o0000
@?ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo01Oooooo2Ooo001Mooooo`[o0?ZJ6?ooool:o`3jVR3ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo09Oooooo00?o0000ooooooooool0?_oo
ool003kooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo01Oooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`1Tooooo`03o`3jV_oooooo
oooo00kooooo2Ol0nYX8ooooo`03o`000?oooooooooo01_ooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0Uoooool00ol0003ooooooooo
o`0nooooo`00=oooool3o`0000Cooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0H
ooooo`Go00000_ooool3o`0000Cooooo00?o0000ooooooooool05oooool00ooo003oooooooooo`05
ooooo`03ool00?oooooooooo06Cooooo4_l0nYX@ooooo`03o`000?oooooooooo01_ooooo00Go0000
ooooooooooooooooo`000003ooooo`;o00003oooool00ol0nY[oooooooooo`0`oooooa;o0?ZJE?oo
ool2o`00043ooooo000fooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooooooo
o`2Xooooo`03o`000?oooooooooo01Wooooo00Ko0000oooooooooooo0000ooooool00003ooooo`05
o`000?ooooooooooooooool000006Oooool00ooo003oooooooooo`05ooooo`[oo`00Ooooool00ol0
003oooooooooo`0Looooo`?o00001?ooool00ol0003oooooooooo`0>ooooo`Wo0?ZJ:_ooool00ol0
nY[oooooooooo`0>ooooo`[o0?ZJC?ooool00ol0003oooooooooo`0nooooo`00=_ooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Joooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000001Wooooo00?o
o`00ooooooooool03_ooool00ooo003oooooooooo`1mooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool05_ooool00ol0nY[oooooooooo`0Xooooo`03o`3jV_oooooooooo01Oooooo8ol0
nYXZooooo`03o`000?oooooooooo03kooooo000gooooo`?o00001?ooool2o`000:Sooooo0_l0000M
ooooo`04o`000?ooooooooooooooo`?o00001?oooolJo`00o`03ool00?l00?oo003o00ko003o00?o
o`00o`00ool00?l0O_l00?lUooooo`;o00005oooool00ol0nY[oooooooooo`0?oooooa[o0?ZJ>ooo
oolBo`3jVQSooooo0_l00010ooooo`00=_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool0Z?ooool00ol0003oooooooooo`0Hooooo`07o`000?ooooooooooooooool0003o
ooooo`000003ooooo`05o`000?ooooooooooooooool000006Oooool00ooo003oooooooooo`0>oooo
o`03ool00?oooooooooo01Oooooo2Ooo001Mooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool05oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01oooooo2Ooo000koooo
oa_o0?ZJ@?ooool003Kooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
0:Sooooo00?o0000ooooooooool06?ooool01ol0003ooooooooooooooooo0000ooooool000000ooo
ool01Ol0003ooooooooooooooooo0000013ooooo2_oo000@ooooo`03ool00?oooooooooo00kooooo
2Ooo0008ooooo`Woo`00EOooool00ol0003oooooooooo`0Sooooo`;o00006?ooool00ol0nY[ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo01Kooooo2_oo0007ooooo`[oo`00Boooool00ol0003o0?ZJ
ooooo`0oooooo`00=oooool3o`0000Cooooo00?o0000ooooooooool0Z?ooool00ol0003ooooooooo
o`0Iooooo`?o00000oooool3o`0000Cooooo00?o0000ooooooooool03_ooool00ooo003ooooooooo
o`0Gooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool05oooool9ool0013ooooo2_oo
000booooo`03ool00?oooooooooo02?ooooo6_l00?lBo`3jVQSo003o00?oo`00o`00ool00?l05ol0
0?ldool001[o003o@?ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo00kooooo00?oo`00ooooooooool05oooool00ooo003oooooooooo`0>
ooooo`03ool00?oooooooooo01oooooo4_oo0008ooooo`Woo`006OoooolBool002Gooooo00?o0000
ooooooooool0>Oooool9ool004cooooo6ooo0010ooooo`00?_ooool2o`000:Wooooo00?o0000oooo
ooooool09_ooool2o`0000oooooo00?oo`00ooooooooool05ooooolBool004?ooooo2_oo000@oooo
o`03ool00?oooooooooo00kooooo00?o0000ooooooooool07?ooool3o`0000Cooooo0_l0000Yoooo
oa;oo`004?ooool9o`3jVUCooooo0_l00010ooooo`00?_ooool00ol0003oooooooooo`2Xooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool00ooo003oooooooooo`1eoooooa;o
o`004?ooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`06oooooa7oo`004Oooool00ooo003oooooooooo`0Fooooo`[o0?ZJ1oooool/o`3j
VPSooooo2Ol0nYXIooooo`03o`000?oooooooooo03kooooo000nooooo`03o`000?oooooooooo0:So
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03ool00?oooooooooo09Oo
oooo00?o0000ooooooooool07oooool01Ol0003ooooooooooooooooo000000Sooooo00?oo`00oooo
ooooool03Oooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo01Kooooo00?o0?ZJoooo
ooooool0>Oooool:o`3jVPOooooo6ol0nYY0ooooo`00?_ooool00ol0003oooooooooo`2Xooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool00ooo003oooooooooo`2Gooooo`03
o`000?oooooooooo01gooooo0_l00004ooooo`;o00001oooool00ooo003oooooooooo`0=ooooo`03
ool00?oooooooooo00oooooo00?oo`00ooooooooool05_ooool00ol0nY[oooooooooo`1Sooooo`;o
0000@?ooool003kooooo00?o0000ooooooooool0I?ooool9o`3jVS_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0>ooooo`03ool00?oooooooooo09Oooooo00?o0000ooooooooool0
7oooool01Ol0003ooooooooooooooooo000000Sooooo00?oo`00ooooooooool03_ooool00ooo003o
ooooooooo`0>ooooo`03ool00?oooooooooo00kooooo2Ol0nYYVooooo`03o`000?oooooooooo03ko
oooo000nooooo`;o0000IOooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo03Wooooo
00?o0000ooooooooool09_oooolBool009Wooooo00?o0000ooooooooool06oooool01Ol0003ooooo
oooooooooooo000000?ooooo0_l00007ooooo`03ool00?oooooooooo00kooooo4_oo000Ao`3jVVgo
oooo0_l00010ooooo`00?_ooool:o`3jVUgooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Gooooo`Wo0?ZJ6Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01Oooooo
2Ol0nYZ8ooooo`03o`000?oooooooooo01cooooo0ol00004ooooo`03o`000?oooooooooo00Kooooo
00?oo`00ooooooooool07oooool00ol0nY[oooooooooo`1mooooo`03o`000?oooooooooo03kooooo
000nooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooooooool0@OoooolBo`3jVPSooooo00?o
0?ZJooooooooool01Oooool:o`3jVQ3ooooo00?o0?ZJooooooooool01_ooool9o`3jVQ3ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool0Q_ooool00ol0nY[oooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?o
o`00ooooooooool08?ooool00ol0nY[oooooooooo`1mooooo`03o`000?oooooooooo03kooooo000n
ooooo`03o`000?oooooooooo00Kooooo2Ol0nYXcooooo`Wo0?ZJ4?ooool:o`3jVQ3ooooo4_l0nYX@
oooooa;o0?ZJ:?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJ
ooooooooool08?ooool9o`3jVR7ooooo4_l0nYXIoooooa;o0?ZJ9Oooool2o`0000Kooooo00?oo`00
ooooooooool08?ooool00ol0nY[oooooooooo`1looooo`;o0000@?ooool003kooooo00?o0000oooo
ooooool03_ooool00ol0nY[oooooooooo`0?ooooo`Wo0?ZJ6Oooool00ol0nY[oooooooooo`1Soooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`05oooo
o`[o0?ZJ6Oooool00ol0nY[oooooooooo`05ooooob?o0?ZJ4?ooool:o`3jVQ3ooooo00?o0?ZJoooo
ooooool03_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?oo`00oooo
ooooool01_ooool9o`3jVQ7ooooo00?o0?ZJooooooooool0OOooool00ol0003oooooooooo`0noooo
o`00?_ooool2o`0000oooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`05ooooo`Wo
0?ZJ4Oooool00ol0nY[oooooooooo`1Sooooo`03o`000?oooooooooo02Kooooo0_l0000Hooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool03_ooool9o`3jVTCooooo4_l0nYX@ooooo`03
o`000?oooooooooo02?ooooo0_l00006ooooo`03ool00?oooooooooo00Kooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo07cooooo0_l00010ooooo`00
?_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo00Kooooo2Ol0nYXAoooooa;o0?ZJ
IOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool0
3_ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo06cooooo00?o0000ooooooooool0
8oooool9ool000Sooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0?ooooo`03o`3j
V_oooooooooo07gooooo00?o0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool03_oo
ool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo08kooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool03_oo
ool00ol0nY[oooooooooo`1/ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03_oo
ool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Gooooo2_l0nYYoooooo`03o`000?oo
oooooooo03kooooo000aooooo`?o00001?ooool2o`0000Cooooo00?o0000ooooooooool03_ooool0
0ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo08kooooo00?o0000ooooooooool06Oooool3
o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo06cooooo00?o0000ooooooooool07Oooool3
o`0000?ooooo0_l0000?ooooo`03o`3jV_oooooooooo00Kooooo2Ol0nYZ7ooooo`;o0000@?ooool0
03;ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooo
oooo00kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`2>ooooo`03o`000?oooooo
oooo01Sooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo
00?o0000ooooooooool05oooool00ol0nY[oooooooooo`0>oooooa;o0?ZJK_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03_ooool00ol0nY[ooooo
ooooo`2Gooooo`03o`000?oooooooooo03kooooo000booooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000oooool00ol0003oooooooooo`0>ooooo`[o0?ZJT?ooool00ol0003ooooo
ooooo`0Looooo`04o`000?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`00000Ioooo
o`03o`3jV_oooooooooo08kooooo00?o0000ooooooooool06oooool5o`0000?ooooo00?o0000oooo
ooooool03_ooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooooooo03kooooo000booooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000ooooon/o`00oacooooo0_l00003oooo
o`04o`000?ooooooooooo`0000?ooooo0_l0000?ooooo`[o0?ZJSoooool2o`0001gooooo00Co0000
oooooooooooo00001?ooool2o`0000oooooo00?o0?ZJooooooooool0U_ooool2o`00043ooooo000b
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool00ol0003ooooooooo
o`2Xooooo`03o`000?oooooooooo01cooooo00Co0000oooooooooooo00000_ooool01Ol0003ooooo
oooooooooooo0000013ooooo00?o0?ZJooooooooool0Uoooool00ol0003oooooooooo`0Looooo`03
o`000?oooooo000000Cooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Gooooo`03
o`000?oooooooooo03kooooo000aooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`03
o`000?oooooooooo0:Sooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooo
oooo09Oooooo00?o0000ooooooooool07Oooool2o`0000Cooooo0_l0000?ooooo`03o`3jV_oooooo
oooo09Kooooo0_l00010ooooo`00<_ooool00ol0003oooooooooo`03ooooo`;o00001?ooool00ol0
003oooooooooo`1Tooooo`Woo`00>oooool00ol0003oooooooooo`0Iooooo`?o00001?ooool2o`00
00Cooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo
09Oooooo00?o0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool0I?ooool00ooo003o
ooooooooo`05ooooo`03ool00?oooooooooo01Oooooo4_oo000@ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooooooo03ko
oooo000nooooo`;o0000IOooool00ooo003oooooooooo`05ooooo`[oo`004?ooool00ooo003ooooo
ooooo`0>ooooo`Woo`002?ooool00ooo003oooooooooo`0Vooooo`;o00003oooool00ol0nY[ooooo
ooooo`2Gooooo`03o`000?oooooooooo02?ooooo0_l0000?ooooo`03o`3jV_oooooooooo09Kooooo
0_l00010ooooo`00?_ooool00ol0003oooooooooo`1Tooooo`03ool00?oooooooooo00kooooo4_oo
000Iooooo`Woo`00:?ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo09Oooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo09Oooooo00?o
0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool0B_oooolKool004?ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo09Oooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo09Oooooo00?o0000
ooooooooool0?_ooool003kooooo00?o0000ooooooooool0B_ooool00ooo003oooooooooo`1Koooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`2Goooo
o`03o`000?oooooooooo02?ooooo0_l0000?ooooo`03o`3jV_oooooooooo09Kooooo0_l00010oooo
o`00?_ooool00ol0003oooooooooo`12ooooo`Woo`00GOooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo00Kooooo2Ol0nYZIooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool01_ooool9o`3jVYWooooo00?o0000ooooooooool0?_ooool003kooooo2_oo000kooooo`03ool0
0?oooooooooo06?ooooo00?o0000ooooooooool09_ooool:o`3jVZ7ooooo00?o0000ooooooooool0
7?ooool3o`0000Cooooo0_l00007ooooo`03o`3jV_oooooooooo09kooooo0_l00010ooooo`00?_oo
ool00ol0003oooooooooo`06ooooo`03ool00?oooooooooo01Oooooo2Ooo000Iooooo`03ool00?oo
oooooooo06?ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Xooooo`03o`000?oo
oooooooo01_ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00Kooooo
00?o0?ZJooooooooool0Woooool00ol0003oooooooooo`0nooooo`00?_ooool00ol0003ooooooooo
o`06ooooo`03ool00?oooooooooo01Oooooo00?oo`00ooooooooool01Oooool9ool000Sooooo2_oo
001Uooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z?ooool00ol0003ooooooooo
o`0Oooooo`05o`000?ooooooooooooooool000002?ooool00ol0nY[oooooooooo`2Oooooo`03o`00
0?oooooooooo03kooooo000nooooo`03o`000?oooooooooo00Kooooo2Ooo0008ooooo`Woo`004Ooo
ool9ool006kooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Xooooo`03o`000?oo
oooooooo01oooooo00Co0000oooooooooooooooo0_l00007ooooo`03o`3jV_oooooooooo09kooooo
0_l00010ooooo`00?_ooool00ol0003oooooooooo`0>ooooo`03ool00?oooooooooo00Kooooo00?o
o`00ooooooooool0S_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:Sooooo00?o
0000ooooooooool06oooool4o`0000Cooooo00?o0000ooooooooool01_ooool00ol0nY[ooooooooo
o`2Oooooo`03o`000?oooooooooo03kooooo000nooooo`03o`000?oooooooooo00kooooo00?oo`00
ooooooooool01_ooool00ooo003oooooooooo`2>ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool0Z?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0nY[oooooooooo`2Oooooo`03o`000?oooooooooo03kooooo000noooo
o`;o00003oooool00ooo003oooooooooo`06ooooo`03ool00?oooooooooo08kooooo00?o0000oooo
ooooool09_ooool2o`000:Wooooo00?o0000ooooooooool06oooool5o`0000?ooooo0_l00006oooo
o`03o`3jV_oooooooooo09oooooo0_l00010ooooo`00?_ooool00ol0003oooooooooo`0>ooooo`[o
o`00C?ooool9o`3jVQWooooo2Ol0nYXIooooo`03o`3jV_oooooooooo02Kooooo00?o0000oooooooo
ool0Z?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooooooo
ool0X?ooool00ol0003oooooooooo`0nooooo`00<Oooool3o`0000;ooooo1Ol00003ooooo`03o`00
0?oooooooooo06Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Gooooo`03o`3j
V_oooooooooo00Kooooo4Ol0nYX8ooooo`03o`3jV_oooooooooo01Wooooo0ol00002ooooo`Go0000
0oooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02?ooooo0_l00006ooooo`03o`3j
V_oooooooooo09oooooo0_l00010ooooo`00<_ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool0I?ooool00ol0nY[oooooooooo`05ooooo`[o0?ZJ
1oooool:o`3jVQWooooo2Ol0nYXJooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`05ooooo`03o`3jV_oooooooooo0:3ooooo00?o0000ooooooooool0?_ooool003;o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06Co
oooo00?o0?ZJooooooooool03_ooool9o`3jVR[ooooo00?o0000ooooooooool07?ooool01Ol0003o
oooooooooooooooo000000Gooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool0X?ooool00ol0003oooooooooo`0noooo
o`00<_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0_l0001Uooooo`03
o`3jV_oooooooooo043ooooo0_l0000Looooo`;o00001Oooool00ol0003oooooooooo`02ooooo`;o
0000Z?ooool2o`0002Gooooo2Ol0nYZQooooo`;o0000@?ooool003;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000C?oooolKo`3jVT?ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooo`000003ooooo`05o`000?ooooooooooooooool00000Z_ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0?_ooool0
037ooooo0_l00003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1:
ooooo`03o`3jV_oooooooooo05_ooooo00?o0000ooooooooool06?ooool01ol0003ooooooooooooo
oooo0000ooooool000000oooool01Ol0003ooooooooooooooooo00000:[ooooo00?o0000oooooooo
ool08oooool2o`000:Sooooo0_l00010ooooo`00<_ooool00ol0003oooooooooo`02ooooo`?o0000
1?ooool00ol0003oooooooooo`1:ooooo`03o`3jV_oooooooooo05_ooooo00?o0000ooooooooool0
6Oooool3o`0000?ooooo0ol00004ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0
7?ooool3o`0000Cooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0nooooo`00?_oo
ool00ol0003oooooooooo`1:ooooo`03o`3jV_oooooooooo05_ooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo01_ooooo00Go0000oooooooooooooooo
o`000003ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0?_ooool003kooooo0_l0
0013ooooo`Wo0?ZJGOooool00ol0003oooooooooo`0Vooooo`;o0000ZOooool00ol0003ooooooooo
o`0Kooooo`05o`000?ooooooooooooooool000000oooool2o`000:Sooooo0_l00010ooooo`00?_oo
ool00ol0003oooooooooo`12ooooo`03o`3jV_oooooooooo06?ooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo01_ooooo1?l00004ooooo`03o`000?oo
oooooooo0:Sooooo00?o0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool0@_ooool0
0ol0nY[oooooooooo`1Sooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`0nooooo`00?_ooool00ol0003oooooooooo`0Pooooo`Wo0?ZJ4?ooool:o`3j
VVGooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01?ooool2o`000:Sooooo0_l00010ooooo`00?_ooool00ol0003o
ooooooooo`0Pooooo`03o`3jV_oooooooooo00Gooooo4_l0nYY^ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Mooooo`;o00001?ooool00ol0003o
ooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000nooooo`[o0?ZJ6?ooool00ol0nY[ooooo
ooooo`26ooooo`03o`000?oooooooooo02Kooooo0_l0002Yooooo`03o`000?oooooooooo02?ooooo
0_l0002Xooooo`;o0000@?ooool003kooooo00?o0000ooooooooool01_ooool00ol0nY[ooooooooo
o`0>ooooo`Wo0?ZJR?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:Sooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000n
ooooo`03o`000?oooooooooo00Kooooo2Ol0nYX8ooooo`03o`3jV_oooooooooo08kooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool0Z?ooool00ol0003oooooooooo`0nooooo`00?_ooool00ol0003oooooooooo`0>oooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0S_ooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool08oooool2o`000:Sooooo0_l00010oooo
o`00?_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooooooo
ool0S_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:Sooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000nooooo`03o`00
0?oooooooooo00kooooo2_l0nYZ@ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
Z?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0
?_ooool003kooooo0_l0002Yooooo`03o`000?oooooooooo02Kooooo0_l0002Yooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool00oooool2o`000:Sooooo0_l00010ooooo`00?_ooool0
0ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`0nooooo`00<Oooool3o`0000Cooooo0ol00003ooooo`03o`000?oooooooooo
0:Sooooo00?o0000ooooooooool06Oooool3o`0000Cooooo0ol00003ooooo`03o`000?oooooooooo
0:Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`02ooooo`;o0000Z?ooool2o`00
043ooooo000booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`2Xooooo`03o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0noooo
o`00<_ooool01?l0003oooooooooooooool5o`0000?ooooo00?o0000ooooooooool0Z?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooo000000Co00000oooool00ol0003oooooooooo`2Xoooo
o`03o`000?oooooooooo01oooooo00Go0000ooooooooooooooooo`00002Zooooo`03o`000?oooooo
oooo03kooooo000booooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`02
ooooo`;o0000Z?ooool2o`0001cooooo0_l00002ooooo`04o`000?ooooooooooo`0000Cooooo0_l0
002Xooooo`;o00007Oooool01Ol0003ooooooooooooooooo000000?ooooo0_l0002Xooooo`;o0000
@?ooool003;ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000004ooooo`03o`000?oo
oooooooo0:Sooooo00?o0000ooooooooool07?ooool01_l0003oooooooooool0003oooooo`0000Co
oooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Kooooo`Go00000oooool00ol0003o
ooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000aooooo`;o00001Oooool2o`0000Cooooo
00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Hooooo`05o`000?ooooooooooooooool0
00000oooool2o`0000Cooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo0:Sooooo00?o0000ooooooooool0?_ooool003;ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0
6Oooool3o`0000Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Xooooo`03o`00
0?oooooooooo02?ooooo0_l0002Xooooo`;o0000@?ooool003kooooo00?o0000ooooooooool0Z?oo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo03kooooo000nooooo`;o0000ZOooool0
0ol0003oooooooooo`0Vooooo`;o0000ZOooool00ol0003oooooooooo`0Sooooo`;o0000Z?ooool2
o`00043ooooo000nooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool09_ooool00ol0
003oooooooooo`2Xooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0Z?ooool00ol0
003oooooooooo`0nooooo`00?_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0:So
oooo00?o0000ooooooooool0?_ooool003kooooo00?o0000ooooooooool0Z?ooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool07?ooool3o`0000Cooooo
0_l0002Xooooo`;o0000@?ooool003kooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo01_ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0nooooo`00?_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool06ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo03kooooo000nooooojco0000:?oooon/o`0001kooooo0ol0
0004ooooojco0000@?ooool00?oooooog?ooool01Ol0003ooooooooooooooooo00000>oooooo003o
ooooomcooooo00Go0000ooooooooooooooooo`00003_ooooo`00oooooooMooooo`?o0000l?ooool0
09;ooooo0ol0003ooooooooooooo??ooool009Gooooo00?o0000ooooooooool0ooooooooooooocWo
oooo0025ooooo`Co00000_ooool5o`0000;ooooo1?l000001_oooooo0000ooooool0003oooooo`00
00;ooooo1?l00033ooooo`?o0000c_ooool4o`0009Gooooo0029ooooo`05o`000?oooooooooooooo
ool000000oooool03Ol0003ooooooooooooooooo0000ooooool0003oooooo`000?oooooo0000oooo
ool000000_ooool00ol0003oooooooooo`33ooooo`03o`000?oooooooooo0<kooooo00Co0000oooo
oooooooo0000U?ooool008Kooooo0ol00004ooooo`05o`000?ooooooooooooooool000000oooool0
1ol0003oooooo`000?oooooo0000ooooool000000_ooool3o`000<Gooooo00?o0000ooooooooool0
c_ooool01?l0003oooooooooool0002Dooooo`00QOooool00ol0003oooooooooo`05ooooo`05o`00
0?ooooooooooooooool000000oooool02Ol0003oooooo`000?oooooo0000ooooool0003oooooo`00
0002ooooo`03o`000?oooooooooo0<?ooooo0_l0003?ooooo`04o`000?ooooooooooo`0009Cooooo
0026ooooo`Co000000Coooooo`000?l0003o00001?ooool7o`000003ooooool0003ooooo00;ooooo
0_l00035ooooo`;o000000?oooooo`000?l00000cOooool3o`0009Gooooo003ooooooooooooo>Ooo
ool00ol0003oooooooooo`2Eooooo`00SOooool00ol0003oooooooooo`3oooooojOooooo0_l0002G
ooooo`00ooooooooooooom7ooooo003ooooooooooooodOooool005_ooooo1Ol00003ooooo`;o0000
1?ooool2o`0001Cooooo0ol00003ooooo`;o00001?ooool2o`0001?ooooo0ol00004ooooo`;o0000
1?ooool2o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`00013ooooo0ol00004ooooo`;o0000
1?ooool2o`0000Cooooo0_l0000hooooo`Go00000oooool2o`0000Cooooo0_l0000Eooooo`?o0000
0oooool2o`0000Cooooo0_l0000Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`?o0000
1?ooool2o`0000Cooooo0_l0000@ooooo`?o00001?ooool2o`0000Cooooo0_l00004ooooo`;o0000
=Oooool5o`0000?ooooo0_l00004ooooo`;o00005?ooool3o`0000?ooooo0_l00004ooooo`;o0000
5?ooool3o`0000Cooooo0_l00004ooooo`;o00004oooool3o`0000Cooooo0_l00004ooooo`;o0000
4?ooool3o`0000Cooooo0_l00004ooooo`;o00001?ooool2o`0003Cooooo001Looooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Doooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0003Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00013ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo0000=Oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00005?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0@ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000cooooo`00GOooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool5o`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00004?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000iooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Booooo`Go0000
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
4Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000@ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo1Ol00002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000A
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`00013ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000<oooool005kooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
3oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004Oooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Booooo`?o00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
013ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo0000>_ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0@ooooo`04o`000?oooooooooo
o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`Co0000
0oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo0ol00003oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000gooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00oooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo1?l00003ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00004_ooool3o`0000?ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003?ooooo001K
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001;ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`00017ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000gooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001?ooooo00?o0000ooooool000000oooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`00017ooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000ooooool000000oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004?oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000cooooo`00Foooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Cooooo`;o00000ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000oooooooo
ool00oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00003oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005?ooool2o`0000?ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000Booooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000oooooo0_l0
0004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001?ooooo0_l00003ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004oooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`;o00001?ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
<oooool005cooooo0ol00004ooooo`;o00001?ooool2o`0001Gooooo00?o0000ooooooooool00_oo
ool2o`0000Cooooo0_l0000Dooooo`;o00001?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?oo
ool2o`0000Cooooo0_l0000Aooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?oo
ool2o`0003Wooooo0ol00004ooooo`;o00001?ooool2o`0001Kooooo00?o0000ooooooooool00_oo
ool2o`0000Cooooo0_l0000Dooooo`;o00001?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?oo
ool2o`0000Cooooo0_l0000Aooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?oo
ool2o`0003Kooooo0ol00004ooooo`;o00001?ooool2o`0001Gooooo00?o0000ooooooooool00_oo
ool2o`0000Cooooo0_l0000Eooooo`;o00001?ooool2o`0000Cooooo0_l0000Cooooo`?o00001?oo
ool2o`0000Cooooo0_l0000Aooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?oo
ool2o`0003Cooooo003ooooooooooooodOooool00?oooooooooooooAooooo`00ooooooooooooom7o
oooo0011ooooo`Ko000000?o0?ZJo`000?l0nYX0Xol0000Xooooo`Co000000?o0?ZJo`000?l00000
0ol0nYYfo`000003o`3jV_l0003o000002Wo00009Oooool2o`000006ool00?l00?oo003oo`00ool0
003o0?ZJ6_l000000ol0nY[o0000o`000027o`0003gooooo0011ooooo`03o`000?oooooooooo00?o
oooo00?o0?ZJooooool0nYX06_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo02Ko
oooo00Go0000ooooooooooooooooo`3jVP02ooooo`?o0?ZJ6?ooool00ol0003oooooooooo`0Poooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`06oooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool08oooool2o`0000;oo`0000Co003ooooo
ool00?oo0?ZJ6_ooool00ol0nY[oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo03_ooooo0011oooo
o`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJX_ooool00ol0003oooooooooo`0V
ooooo`05o`000?ooooooooooooooool0nYX00_ooool3o`3jVWKooooo00?o0?ZJooooooooool0:?oo
ool00ol0003oooooooooo`0Sooooo`04o`3jV_ooooooooooool000;ooooo00?o003oo`3jV_ooool0
6Oooool00ol0nY[oooooooooo`26ooooo`03o`000?oooooooooo03_ooooo0011ooooo`03o`000?oo
oooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJX_ooool00ol0003oooooooooo`0Vooooo`;o0000
0_ooool00ol0nY[oooooooooo`03o`3jVWKooooo00?o0?ZJooooooooool0:?ooool00ol0003ooooo
ooooo`0Sooooo`08o`000?l0nY[ooooooooooooo003oooooo`00ool0nYXIooooo`;o0?ZJQoooool2
o`0003gooooo0011ooooo`;o00000oooool01?l0nY[oooooooooool0nYZRooooo`03o`000?oooooo
oooo02Kooooo00Go0000ooooooooooooooooo`3jVP02ooooo`04o`3jV_l0003o0000o`0007Gooooo
00?o0?ZJooooooooool0:?ooool00ol0003oooooooooo`0Sooooo`08o`000?l0nY[o0?ZJoooooooo
003oooooo`00ool0nYXIooooo`;o0?ZJR?ooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0
003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVZ;ooooo00?o0000ooooooooool09_ooool0
1Ol0003ooooooooooooooooo0?ZJ00;ooooo00Co0?ZJo`000?l0003o0000M?ooool2o`3jVR[ooooo
00?o0000ooooooooool08oooool02?l0003oooooo`3jV_l0nY[oo`00ooooool00?oo0?ZJ6Oooool2
o`3jVR7ooooo00?o0?ZJooooooooool0I?ooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0
003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVZ;ooooo00?o0000ooooooooool09_ooool0
1Ol0003ooooooooooooooooo0?ZJ00;ooooo00Co0?ZJo`000?l0003o0000M?ooool2o`3jVR[ooooo
00?o0000ooooooooool08oooool01Ol0003oooooooooool0nY[oo`0000;ooooo0_l0nYXHooooo`;o
0?ZJ8Oooool00ol0nY[oooooooooo`1Tooooo`03o`000?oooooooooo03_ooooo0011ooooo`03o`00
0?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJX_ooool00ol0003oooooooooo`0Vooooo`;o
00000_ooool00ol0nY[oooooooooo`02o`3jVP03ool00?oooooooooo01Kooooo00?o0?ZJoooooooo
ool0F_ooool2o`3jVR[ooooo00?o0000ooooooooool08oooool2o`000003ooooool0nY[oo`0000;o
oooo0_l0nYXHooooo`;o0?ZJ8Oooool00ol0nY[oooooooooo`0iooooo`03o`3jV_oooooooooo02Oo
oooo0_l0000mooooo`00@Oooool2o`0000?ooooo00Co0?ZJoooooooooooo0?ZJX_ooool00ol0003o
ooooooooo`0Vooooo`05o`000?ooooooooooooooool0nYX00_ooool2o`3jVP03ool00?oooooooooo
01Kooooo00?o0?ZJooooooooool0F_ooool4o`3jVRSooooo00?o0000ooooooooool08oooool01Ol0
003oooooooooool0nY[oo`0000;ooooo0_l0nYXHooooo`;o0?ZJ8Oooool00ol0nY[oooooooooo`0i
ooooo`03o`3jV_oooooooooo02Sooooo00?o0000ooooooooool0>oooool0047ooooo00?o0000oooo
ooooool00_ooool01?l0nY[oooooooooool0nYZRooooo`03o`000?oooooooooo02Kooooo00Go0000
ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool05_ooool00ol0nY[ooooooooo
o`1Jooooo`Co0?ZJ:?ooool00ol0003oooooooooo`0Sooooo`05o`000?ooooooooooo`3jV_oo0000
0_ooool2o`3jVQSooooo0_l0nYXQooooo`03o`3jV_oooooooooo03Wooooo00?o0?ZJooooooooool0
:?ooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo
ooooooooo`3jVZ;ooooo00?o0000ooooooooool09_ooool2o`0000;ooooo00?o0?ZJooooooooool0
0_l0nYX00ooo003oooooooooo`0Fooooo`03o`3jV_oooooooooo02?ooooo0_l0nYXeooooo`Co0?ZJ
:?ooool00ol0003oooooooooo`0Sooooo`;o00000_ooool00ooo003oooooooooo`02o`3jVQOooooo
00?o0?ZJooooool0nYX08Oooool00ol0nY[oooooooooo`0hooooo`;o0?ZJ:Oooool2o`0003gooooo
0011ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJX_ooool00ol0003ooooo
ooooo`0Vooooo`05o`000?ooooooooooooooool0nYX00_ooool2o`3jVP03ool00?oooooooooo01Go
oooo0_l0nYXUooooo`;o0?ZJ=Oooool4o`3jVRSooooo00?o0000ooooooooool08oooool01Ol0003o
ooooooooooooooooo`0000;ooooo0_l0nYXGooooo`03o`3jV_oooooo0?ZJ027ooooo00?o0?ZJoooo
ooooool0>?ooool2o`3jVR[ooooo00?o0000ooooooooool0>oooool0047ooooo00?o0000oooooooo
ool00_ooool01?l0nY[oooooooooool0nYZRooooo`03o`000?oooooooooo02Kooooo00Go0000oooo
ooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool05Oooool2o`3jVRCooooo00?o0?ZJ
ooooool0nYX0=Oooool2o`3jVP;oo`00:?ooool00ol0003oooooooooo`0Sooooo`07o`000?oooooo
ooooooooool0nY[oo`00ooooo`02o`3jVPgooooo0_l0nYX8ooooo`03o`3jV_oooooo0?ZJ027ooooo
00?o0?ZJooooooooool0>?ooool2o`3jVR[ooooo00?o0000ooooooooool0>oooool0047ooooo0_l0
0003ooooo`04o`3jV_ooooooooooo`3jVZ;ooooo00?o0000ooooooooool09_ooool01Ol0003ooooo
oooooooooooo0?ZJ00;ooooo0_l0nYX00ooo003oooooooooo`0Eooooo`;o0?ZJ9?ooool00ol0nY[o
ooooo`3jVP0eooooo`;o0?ZJ0_oo000Xooooo`03o`000?oooooooooo02?ooooo00Oo0000oooooooo
ooooooooo`3jV_oo003ooooo00;o0?ZJ3Oooool2o`3jVPSooooo00?o0?ZJooooool0nYX08?ooool2
o`3jVS[ooooo0_l0nYXZooooo`03o`000?oooooooooo03_ooooo0011ooooo`03o`000?oooooooooo
00;ooooo00?o0?ZJooooooooool00_l0nYZQooooo`03o`000?oooooooooo02Kooooo0_l00002oooo
o`03o`3jV_oooooooooo00;o0?ZJ00?oo`00ooooooooool05Oooool2o`3jVP03ooooool0nY[ooooo
027ooooo00?o0?ZJooooool0nYX0=Oooool2o`3jVP;oo`00:?ooool00ol0003oooooooooo`0Soooo
o`;o00000_ooool00ol0nY[oo`00ooooo`02o`3jVPgooooo0_l0nYX8ooooo`03o`3jV_oooooo0?ZJ
023ooooo0_l0nYXjooooo`;o0?ZJ:Oooool2o`0003gooooo0011ooooo`03o`000?oooooooooo00;o
oooo00?o0?ZJooooooooool00ol0nYZPooooo`03o`000?oooooooooo01Sooooo1Ol00003ooooo`;o
00001?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_l0nYX00ooo003oooooooooo`0Eoooo
o`;o0?ZJ00?oooooo`3jV_ooool08Oooool00ol0nY[o003oo`3jVP0Dooooo`03o`3jV_oooooooooo
01kooooo0_l0nYX2ool002Gooooo00Co0?ZJoooooooooooo00006?ooool3o`0000Cooooo0_l00004
ooooo`07o`000?ooooooooooooooool0nY[oo`00ooooo`02o`3jVPgooooo0_l0nYX8ooooo`03o`3j
V_oooooo0?ZJ023ooooo0_l0nYXiooooo`03o`3jV_oooooo0?ZJ02[ooooo00?o0000ooooooooool0
>oooool0047ooooo00?o0000ooooooooool00_ooool01_l0nY[oooooooooool0nY[oo`00o`3jVZ3o
oooo00?o0000ooooooooool06Oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000?ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool05Ooo
ool2o`3jVP03o`00ool0nY[o0?ZJ027ooooo00?o0?ZJool00?l0nYX05?ooool00ol0nY[ooooooooo
o`0Dooooo`;o0?ZJ2?ooool2o`3jVP;oo`009?ooool3o`3jVP03ooooool0003ooooo01Sooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`07o`000?ooooooooooooooool0
nY[oo`00ooooo`02o`3jVPcooooo00?o0?ZJooooool0nYX01oooool01?l0nY[oooooooooool0nYXP
ooooo`;o0?ZJ>Oooool00ol0nY[o003oo`3jVP0Zooooo`03o`000?oooooooooo03_ooooo0011oooo
o`;o00000oooool01_l0nY[oooooooooool0nY[oo`00o`3jVZ3ooooo00?o0000ooooooooool04_oo
ool5o`0000?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`;o0000
0_ooool00ol0nY[oooooooooo`02o`3jVP03ool00?oooooooooo01Gooooo0ol0nYX00ol00?oo0?ZJ
ooooo`0Pooooo`03o`3jV_oo003o0?ZJ01Cooooo00?o0?ZJooooooooool05?ooool2o`3jVPSooooo
0_l0nYX2ool002Cooooo00?o0?ZJooooool0nYX00_l0000Iooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000oooool2o`0000;ooooo00?o0?ZJool00?ooool00_l0nYX<ooooo`04
o`3jV_ooooooooooo`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ8?ooool4o`3jVQKooooo0_l0nYXO
ooooo`03o`3jV_l00?oo0?ZJ02Wooooo0_l0000mooooo`00<oooool5o`0000?ooooo0_l00004oooo
o`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool00ol0001eooooo`03o`3jV_oooooooooo
02Sooooo00?o0000ooooooooool06oooool01Ol0003ooooooooooooooooo000000;ooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oo`00ooooooooool05Ooo
ool3o`3jVP03o`00ool0nY[ooooo023ooooo00?o0?ZJool00?l0nYX05?ooool00ol0nY[ooooooooo
o`0Dooooo`;o0?ZJ2?ooool2o`3jVP;oo`0000?o0?ZJooooooooool08?ooool01_l0nY[ooooooooo
ool0nY[oooooo`0001Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003oooo
o`07o`000?ooooooooooooooool0nY[oo`00ooooo`02o`3jVPcooooo00Co0?ZJoooooooooooo0?ZJ
1_ooool01?l0nY[oooooooooool0nYXOooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ5_ooool2o`3jVQko
oooo0_l0nYX00ol00?oo0?ZJooooo`0Yooooo`03o`000?oooooooooo03_ooooo000dooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02oooo
o`03o`3jV_oooooooooo00?o0000MOooool00ol0nY[oooooooooo`0Xooooo`03o`000?oooooooooo
01Sooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00Go
0000ooooooooooooooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool05?ooool01_l0nY[ooooo
o`3jV_l0nY[oo`00o`3jVR7ooooo00Co0?ZJool00?oo003o0?ZJ4oooool00ol0nY[oooooooooo`0C
ooooo`?o0?ZJ2?ooool2o`3jVP;oo`0000?o0?ZJooooooooool08?ooool01_l0nY[oooooooooool0
nY[oooooo`0001Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`07
o`000?ooooooooooooooool0nY[oo`00ooooo`02o`3jVPcooooo00Co0?ZJoooooooooooo0?ZJ1_oo
ool01?l0nY[oooooooooool0nYXOooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0
4oooool2o`3jVQkooooo00Co0?ZJo`00ool00?oo0?ZJ:_ooool00ol0003oooooooooo`0kooooo`00
;Oooool5o`0000?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`03
o`000?oooooooooo00;ooooo00?o0?ZJooooooooool00ol0000Gooooo`03o`3jV_oooooooooo05_o
oooo00Co0?ZJoooooooooooo0?ZJ9oooool00ol0003oooooooooo`0Hooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`3jVP?ooooo
0_l0nYX00ooo003oooooooooo`0Dooooo`06o`3jV_oooooo0?ZJo`3jV_oo003o0?ZJ8Oooool01?oo
003o003oool00?l0nYXCooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooool0nYX01oooool0
0ol0nY[oooooo`3jVP02ool00003o`3jV_oooooooooo023ooooo00Ko0?ZJo`00oooooooo0?ZJoooo
ool0000Hooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`07o`000?oooooooooooooo
ool0nY[oo`00ooooo`02o`3jVP_ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`04o`3jV_oo
ooooooooo`3jVQoooooo00Ko0?ZJo`000?l0003o0000ool00?l0nYXDooooo`04o`3jV_oooooo0?ZJ
o`3jVQgooooo00Co0?ZJoooooooooooo0?ZJ:_ooool00ol0003oooooooooo`0kooooo`00=_ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooooooo0_l00003ooooo`04o`3j
V_ooooooooooo`3jVP;oo`005oooool00ol0nY[oooooooooo`1Kooooo`04o`3jV_oooooo0?ZJo`3j
VRKooooo0_l0000Kooooo`?o00001?ooool2o`0000Cooooo0_l000000ooooooo0?ZJooooo`02oooo
o`;o0?ZJ00?oo`00ooooooooool05?ooool00ol0nY[oooooo`3jVP02ool00003o`3jV_oooooooooo
01oooooo00Coo`00o`00oooo003o0?ZJ4_ooool2o`3jVQCooooo00Co0?ZJoooooooooooo0?ZJ1ooo
ool01_l0nY[oooooool00?l0nY[oo`00o`3jVR;ooooo00Ko0?ZJo`00ool00?oo0?ZJooooool0000I
ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00000_ooool01Ol0nY[oo`00oooooooo
oooo0?ZJ00_ooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`05o`3jV_ooooooooooooooool0
nYX07oooool01_l0nY[o0000o`000?l0003oo`00o`3jVQCooooo00Co0?ZJo`000?l0003o00007Ooo
ool01?l0nY[oooooooooool0nYXYooooo`;o0000?Oooool003?ooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool01?l0nY[o
ooooooooool0nYX2ool001Oooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooooooo`0doooo
o`04o`3jV_oooooo0?ZJo`3jVROooooo00?o0000ooooooooool09_ooool01?l0003oooooooooool0
nYX3ooooo`;o0?ZJ00?oo`00ooooooooool05?ooool01_l0nY[oooooo`3jV_oo003oooooool0027o
oooo00Coo`00oooooooo003o0?ZJ4_ooool2o`3jVPgooooo00?o0?ZJooooooooool01?ooool01?l0
nY[oooooooooool0nYX7ooooo`06o`3jV_l0003o0000o`000?oo003o0?ZJ8_ooool01_l0nY[o003o
o`00ool0nY[oooooo`0002Gooooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`03o`3jV_oo
oooooooo00Wooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`05o`3jV_ooooooooooooooool0
nYX02?ooool00ol0nY[oooooooooo`0Dooooo`06o`3jV_l0003o0000o`000?oo003o0?ZJ5?ooool0
1Ol0nY[o0000o`000?l0003o0?ZJ01_ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01Kooooo0_l0
nYX@ooooo`03o`000?oooooooooo03_ooooo000cooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo
0?ZJ0_oo000Gooooo`03o`3jV_oooooooooo02?ooooo0ol0nYXeooooo`04o`3jV_oooooo0?ZJo`3j
VROooooo00?o0000ooooooooool09_ooool01?l0003oooooooooool0nYX3ooooo`;o0?ZJ00?oo`00
ooooooooool05?ooool01_l0nY[oooooo`3jV_oo003oooooool0023ooooo00Go0?ZJool00?l0nY[o
o`00o`3jVP0Booooo`;o0?ZJ3?ooool00ol0nY[oooooo`3jVP05ooooo`05o`3jV_oooooooooooooo
ool0nYX01_ooool01_l0nY[o0000o`000?l0003oo`00o`3jVR;ooooo00Ko0?ZJo`00ool00?oo0?ZJ
ooooool0000Uooooo`06o`000?ooooooooooooooool0nY[oo`000_ooool00ol0nY[oooooooooo`09
ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo
0_l0nYXEooooo`07o`3jV_oooooo003oool00?l0nY[oo`00o`3jVP0Cooooo`;o0?ZJ0ol000000ol0
nY[oooooooooo`0Iooooo`03o`3jV_l00?oooooo00?o00005oooool2o`3jVQ3ooooo00?o0000oooo
ooooool0>oooool003Cooooo0ol00004ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`04
o`3jV_ooooooooooo`3jVP;oo`005oooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooo0?ZJ
03Gooooo00Co0?ZJooooool0nY[o0?ZJ9oooool00ol0003oooooooooo`0Vooooo`;o000000?ooooo
o`3jV_ooool00_ooool2o`3jVP03ool00?oooooooooo01Cooooo00Ko0?ZJooooool0nY[oo`00o`3j
V_oo000Pooooo`05o`3jV_oo003o0?ZJool00?l0nYX04_ooool2o`3jVP_ooooo0_l0nYX00ooooooo
0?ZJooooo`04ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01_l0nY[o0000o`000?l0003o
0?ZJool0027ooooo00Oo0?ZJo`00oooo003o003oo`3jV_oooooo000002Gooooo0_l00002ooooo`05
o`3jV_oo003oooooooooool0nYX02_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
00?ooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;o0?ZJ5Oooool01ol0nY[oooooo`00oooo
003oooooool00?l0nYX04oooool00ol0nY[o003oooooo`02ool00003o`3jV_oooooooooo01Wooooo
00?o0?ZJo`00ooooool00ol0000Gooooo`;o0?ZJ2_ooool2o`3jVP?ooooo0_l0000mooooo`00@Ooo
ool2o`0000?ooooo00Co0?ZJoooooooooooo0?ZJ0_oo000Gooooo`04o`3jV_ooooooooooo`3jVR;o
oooo00?o0?ZJooooool0nYX0=Oooool01?l0nY[oooooool00?oo000Wooooo`03o`000?oooooooooo
02Kooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oooooooooo01Cooooo00Ko0?ZJ
ooooool0nY[oo`00o`3jV_oo000Pooooo`05o`3jV_oo003o0?ZJool00?l0nYX04_ooool2o`3jVP_o
oooo00Co0?ZJoooooooooooo0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00Ko0?ZJ
oooooooo003oooooo`3jV_oo000Qooooo`07o`3jV_l00?ooo`00ool00?l0nY[oooooo`00000Uoooo
o`06o`000?ooooooooooooooool0nY[oo`000_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool00oooool01Ol0nY[o003oool00?l00?oo0?ZJ00Oooooo
0_l0nYX;ooooo`03o`3jV_oooooooooo00Oooooo00Oo0?ZJooooool00?ooo`00ooooool0nY[oo`00
01?ooooo00?o0?ZJo`00ooooool00_oo00000ol0nY[oooooooooo`0?ooooo`;o0?ZJ2?ooool00ol0
nY[oo`00ool00003o`0001Oooooo0_l0nYX9ooooo`?o0?ZJ1?ooool00ol0003oooooooooo`0koooo
o`00@Oooool00ol0003oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVP;oo`005oooool00ol0
nY[oooooooooo`02o`3jVR7ooooo00?o0?ZJooooool0nYX0=Oooool01?l0nY[oooooool00?oo000W
ooooo`03o`000?oooooooooo02Kooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oo
oooooooo01Cooooo00Ko0?ZJooooool0nY[oo`00o`3jV_oo000Pooooo`05o`3jV_oo003o0?ZJool0
0?l0nYX04_ooool2o`3jVP_ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`06o`3jV_oooooo
o`00ool00?oooooo0?ZJ1_ooool01_l0nY[oooooool00?oooooo0?ZJool0027ooooo00Oo0?ZJool0
0?ooooooo`00o`3jV_oooooo000002Gooooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`05
o`3jV_oo003o003oool00?l0nYX01oooool2o`3jVP[ooooo0ol0nYX8ooooo`08o`3jV_l00?oooooo
ool00?oooooo0?ZJool00?l0nYXBooooo`03o`3jV_l00?ooo`0000;oo`0000?o0?ZJooooooooool0
3oooool00ol0nY[oooooo`3jVP07ooooo`03o`3jV_oo003ooooo00;oo`005oooool01?l0nY[o0000
o`000?l00008ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o0000ooooooooool0>oooool0047ooooo
00?o0000ooooooooool00_ooool01?l0nY[oooooooooool0nYX2ool001Oooooo00Go0?ZJooooool0
nY[oooooo`3jVP0Qooooo`03o`3jV_oooooo0?ZJ03Gooooo00Co0?ZJoooooooo003oo`009?ooool2
o`3jVP03ooooool0003ooooo02Oooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oo
oooooooo01Cooooo00Ko0?ZJo`000?l0003o0000oooooooo000Pooooo`05o`3jV_oo003o0?ZJool0
0?l0nYX04_ooool2o`3jVP_ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`06o`3jV_oooooo
o`00ool00?oooooo0?ZJ1_ooool01_l0nY[oooooool00?oooooo0?ZJool0027ooooo00Oo0?ZJool0
0?ooooooo`00o`3jV_oooooo000002Gooooo00Ko0000ooooooooooooooooo`3jV_oo0002ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJool00?oo00000_ooool00ol0nY[oooooooooo`02ooooo`06
o`3jV_ooooooo`00oooooooo003o0?ZJ1oooool2o`3jVP[ooooo00?o0?ZJooooool0nYX02?ooool0
2?l0nY[o003ooooooooo003oooooo`3jV_oo003o0?ZJ4_ooool01_l0nY[oo`00ool00?oo003o0?ZJ
ool0013ooooo0_l0nYX00ooooooo0?ZJooooo`05ooooo`04o`3jV_l00?ooo`00ooooo`;oo`005ooo
ool01?l0nY[o0000o`000?l00007ooooo`;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo000003go
oooo0011ooooo`03o`000?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0_oo000Fooooo`;o
0?ZJ00Coooooo`3jV_oooooo0?ZJ8Oooool00ol0nY[oo`00o`3jVP0[ooooo`;o0?ZJ2?ooool01Ol0
nY[oooooool00?oo003o0?ZJ02;ooooo0_l0nYX00ooooooo0?ZJo`00000Xooooo`;o000000?ooooo
o`3jV_ooool00_ooool2o`3jVP03ool00?oooooooooo01Cooooo00Ko0?ZJo`000?l0003o0000oooo
oooo000Pooooo`05o`3jV_oo003oooooool00?l0nYX04_ooool2o`3jVP[ooooo00?o0?ZJoooooooo
ool00_ooool01_l0nY[ooooooooooooooooo0?ZJooooo`;oo`0000?oooooo`3jV_ooool01Oooool0
1_l0nY[oooooool00?oooooo0?ZJool0027ooooo00Oo0?ZJool00?ooooooo`00o`3jV_oooooo0000
02Gooooo0_l00002ooooo`05o`3jV_oo003oooooooooool0nYX02Oooool01?l0nY[oooooool00?oo
0002ooooo`03o`3jV_oooooooooo00;ooooo00Ko0?ZJoooooooo003oooooool00?l0nYX7ooooo`;o
0?ZJ2_ooool00ol0nY[oooooo`3jVP07ooooo`03o`3jV_ooooooo`0000;oo`0000Coooooo`3jV_oo
003o0?ZJ4Oooool01?l0nY[oooooool00?ooool2o`3jVP03ool00?oooooooooo00kooooo00Co0?ZJ
oooooooooooo0?ZJ1_ooool01?l0nY[oo`00ool00?ooool2ool00003o`3jV_oooooooooo01Cooooo
00Co0?ZJo`000?l0003o00001oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo0_l0000moooo
o`00@Oooool2o`0000?ooooo00Co0?ZJoooooooooooo003o0_oo000Fooooo`;o0?ZJ00Coooooo`3j
V_oooooo0?ZJ8Oooool01?l0nY[oo`00ooooool0nYXYooooo`?o0?ZJ2?ooool2o`3jVP;oo`0000?o
0?ZJooooooooool08?ooool01Ol0nY[oooooooooool0nY[o000002Sooooo00Co0000oooooooooooo
0?ZJ0oooool2o`3jVP03ool00?oooooooooo01?ooooo00?o0?ZJooooool000000_l000000ooooooo
o`00o`3jVP0Oooooo`05o`3jV_oo003oooooool00?l0nYX04_ooool2o`3jVP[ooooo00?o0?ZJoooo
ooooool00_ooool02_l0nY[ooooooooooooooooo0?ZJool00?ooooooo`00ooooool0nYX6ooooo`06
o`3jV_ooooooo`00ooooool0nY[oo`008Oooool01ol0nY[oo`00oooooooo003o0?ZJooooool00000
9Oooool00ol0003oooooooooo`02ooooo`04ool00?ooooooooooo`3jVPWooooo00Oo0?ZJool00?oo
ooooooooool00?oooooo0?ZJ00Cooooo00Co0?ZJool00?l00?oooooo0ol00005ooooo`03o`3jV_oo
oooo0?ZJ00Wooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol0nY[oooooool00002ool00004oooo
ool0nY[oo`00o`3jVQ7ooooo00Co0?ZJoooooooo003ooooo0_l0nYX00ooo003oooooooooo`0>oooo
o`04o`3jV_ooooooooooo`3jVPKooooo00?o0?ZJool00?ooool00_ooool00ooo003o0?ZJooooo`0E
ooooo`04o`3jV_l00?ooo`00o`3jVPKooooo0_l0nYX2o`00o`03ooooool0nY[ooooo00;ooooo00?o
0000ooooooooool0>oooool0047ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`00oooo
003oo`0001Kooooo0_l0nYX01?oooooo0?ZJool00?l0nYXQooooo`04o`3jV_oo003oo`00o`3jVRWo
oooo00?o0?ZJooooool0nYX01oooool3o`3jVP;oo`0000?o0?ZJooooooooool08?ooool01Ol0nY[o
ooooooooool0nY[o000002Sooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oooooo
oooo01?ooooo00Co0?ZJooooooooooooo`000_ooool00ooo003o0?ZJooooo`0Nooooo`05ool00?l0
nY[oooooool00?l0nYX04_ooool2o`3jVP[ooooo00Ko0?ZJoooooooo003oo`00ooooool0nYX3oooo
o`06o`3jV_oo003oooooool00?oooooo0?ZJ1_ooool00ol0nY[oooooool00002ooooo`03ool00?oo
oooooooo01oooooo00Oo0?ZJool00?l0nY[oo`00ooooool0nY[o000002Gooooo00?o0000oooooooo
ool00_ooool01?l0nY[oo`00ooooool0nYX9ooooo`07o`3jV_oo003ooooooooooooo003oooooo`3j
VP04ooooo`04o`3jV_oo003oooooooooo`?o00001Oooool00ol0nY[oooooool00009ooooo`05o`3j
V_ooooooooooooooool0nYX01_ooool02Ol0nY[o003oool00?ooooooo`00ooooool0nY[oo`00o`3j
VP0Aooooo`04o`3jV_oo003oooooooooo`;o0?ZJ00?oo`00o`3jV_ooool03_ooool01?l0nY[o003o
ooooool0nYX6ooooo`03o`3jV_oo003ooooo00;ooooo00?oo`00o`3jV_ooool05?ooool2o`3jVP03
o`00oooo003o0?ZJ00Kooooo0_l0nYX2ool00003ooooool0nY[ooooo00;ooooo00?o0000oooooooo
ool0>oooool0047ooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03o`00oooo003oo`0001Ko
oooo0_l0nYX01?oooooo0?ZJool00?oo000Qooooo`04ool00?l00?ooo`00o`3jVRSooooo00Co0?ZJ
oooooooooooo0?ZJ1oooool3o`3jVP;oo`0000?o0?ZJooooooooool08?ooool01Ol0nY[ooooooooo
ool0nY[o000002Sooooo00Co0000oooooooooooo0?ZJ0oooool2o`3jVP03ool00?oooooooooo01?o
oooo00Co0?ZJooooooooooooo`000_ooool00ooo003o0?ZJooooo`0Nooooo`05ool00?l0nY[ooooo
ool00?l0nYX04_ooool2o`3jVP[ooooo00Ko0?ZJool00?ooooooo`00ooooool0nYX3ooooo`06o`3j
V_oo003ooooooooooooo003o0?ZJ1Oooool01?l0nY[ooooooooooooo0002ooooo`03ool00?oooooo
oooo01oooooo00Oo0?ZJool00?l0nY[oo`00ooooool0nY[o000002Gooooo00?o0000ooooooooool0
0_ooool01?l0nY[oo`00ooooool0nYX9ooooo`07o`3jV_oo003o003oo`00oooo003oooooo`3jVP04
ooooo`04o`3jV_oo003oooooooooo`?o00001Oooool00ol0nY[oo`00ool00009ooooo`05o`3jV_oo
ooooooooooooool0nYX01_ooool02Ol0nY[oo`00ooooooooooooo`00ooooool0nY[oo`00o`3jVP0A
ooooo`08o`3jV_oo003oooooooooool0nY[oooooool00?l0nYX>ooooo`05o`3jV_l00?oo003ooooo
ool0nYX01_ooool00ol0nY[oo`00ooooo`02ooooo`;oo`001_ooool2o`3jVPOooooo00?o0?ZJoooo
ooooool00oooool01Ol0nY[o003ooooooooo003o0?ZJ00Kooooo00Ko0?ZJool00?oo003oo`00oooo
ool0nYX3ooooo`03o`000?oooooooooo03_ooooo0011ooooo`05o`000?ooooooooooooooool0nYX0
0oooool00ol00?ooo`00ool0000Fooooo`;o0?ZJ00Coooooool00?ooooooo`008Oooool01?oo003o
003oool00?l0nYXPooooo`?o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo0ol0nYX2
ool00003o`3jV_oooooooooo023ooooo00Go0?ZJo`00ool00?oo0?ZJo`00000Xooooo`;o000000So
ooooo`3jV_ooooooooooo`00oooooooo0?ZJool001Gooooo00Co0?ZJooooooooooooo`000_ooool0
0ooo003o0?ZJooooo`0Nooooo`05ool00?l0nY[oooooool00?l0nYX04Oooool00ol0nY[oooooo`3j
VP0:ooooo`06o`3jV_oo003oooooool00?oooooo0?ZJ0oooool01_l0nY[oo`00ooooooooooooo`00
o`3jVPGooooo00Co0?ZJooooool00?ooo`000_ooool00ooo003oooooooooo`0Oooooo`07ool00?l0
0?oo0?ZJool00?oooooo0?ZJo`00000Uooooo`;o00000oooool01?l0nY[oo`00ooooool0nYX9oooo
o`07ool00?oooooo003oo`00oooo003oooooo`3jVP04ooooo`03o`3jV_oo003ooooo00;ooooo0_oo
0005ooooo`03o`3jV_oo003oo`0000Sooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Cooooo00Go
0?ZJool00?ooooooooooool00002ooooo`03ool00?l0nY[ooooo00Oooooo00?o003oo`3jV_l0nYX0
1_ooool02?l0nY[oo`00oooooooooooo0?ZJoooooooo003o0?ZJ1oooool2o`3jVPGooooo00?o0?ZJ
ooooool00?l00_ooool00ol0nY[oooooooooo`03ooooo`;oo`000_l0nYX00oooooooo`00ool00006
ooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_l00?oooooo00;oo`001_ooool0
1_l0nY[oo`00oooooooo003o003oo`3jVP;ooooo0_l0000mooooo`00@Oooool01Ol0003ooooooooo
oooooooo0?ZJ00?ooooo00?o003oool00?oo00005_ooool2o`3jVP04oooooooo003oooooool0023o
oooo00Go0?ZJool00?l00?ooo`00o`3jVP0Oooooo`;o0?ZJ00?oooooo`3jV_ooool01?ooool01Ol0
nY[ooooooooooooooooo0?ZJ00Kooooo0_l0nYX01?oo003o0?ZJo`3jV_oo000Rooooo`05o`3jV_l0
0?oo003oo`3jV_l000006oooool3o`0000Cooooo0_l00004ooooo`04o`000?ooooooooooo`3jVP;o
oooo00Go003oooooool0nY[oo`00o`3jVP0Dooooo`04o`3jV_ooooooooooool000;ooooo00?oo`00
o`3jV_ooool07_ooool01Ooo003o0?ZJoooooooo003o0?ZJ017ooooo00?o0?ZJooooool0nYX01Ooo
ool2o`3jVP;ooooo00Oo0?ZJoooooooo003oooooool00?oooooo0?ZJ00;ooooo00?o0?ZJo`00oooo
00000_ooool00ooo003o0?ZJooooo`04ooooo`04o`3jV_oooooo003oool000;ooooo00?oo`00oooo
ooooool07?ooool02_l0nY[oooooo`3jV_oo003o003oo`3jV_oo003oooooo`3jV_l0000Gooooo`Go
00000oooool2o`0000Cooooo00?o0000ooooooooool00_ooool01?l0nY[oo`00ooooool0nYX9oooo
o`07ool00?l00?oo0?ZJoooooooo003oooooo`3jVP04ooooo`03o`3jV_oo003ooooo00;ooooo00?o
0?ZJool00?ooool01?ooool00ol0nY[oo`00ool00008ooooo`03o`3jV_ooooooo`0000;ooooo00?o
0?ZJooooooooool01?ooool01Ol0nY[oo`00oooooooooooo0?ZJ00;ooooo00?oo`00o`3jV_ooool0
1oooool01?l0nY[o003oo`3jV_l0nYX5ooooo`08o`3jV_oo003oooooooooool0nY[oooooool00?l0
nYX6ooooo`Co0?ZJ1?ooool00ol0nY[oo`00ool00002ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJool00?ooool00_l0nYX00ooooooo0?ZJool00006ooooo`;o0?ZJ1_ooool2o`3jVPGooooo00?o
0?ZJo`00ooooool00_oo0005ooooo`;o0?ZJ00Goo`00ooooooooooooo`00o`3jVP03ooooo`03o`00
0?oooooooooo03_ooooo0011ooooo`;o00000_ooool01Ol0nY[ooooooooooooooooo003o00;oo`00
5_ooool01_l0nY[oooooo`3jV_oo003oooooool0023ooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0O
ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool01Ol0nY[o003ooooooooooooo0?ZJ00Kooooo0_l0
nYX01?oo003o0?ZJo`3jV_oo000Qooooo`06o`3jV_l00?ooo`00ool00?l0nY[o00007?ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0?ZJ0_oo
ool01Ol00?ooooooo`3jV_oo003o0?ZJ00Cooooo0_l0nYX>ooooo`04o`3jV_ooooooooooool000;o
oooo00?oo`00o`3jV_ooool07_ooool01Ooo003o0?ZJoooooooo003o0?ZJ017ooooo00?o0?ZJoooo
ool0nYX01Oooool5o`3jVP;oo`000_ooool01ooo003oooooo`3jV_oooooo0?ZJool00?ooool00_l0
nYX00ooo003o0?ZJooooo`04ooooo`04o`3jV_oooooo003oool000;ooooo00?oo`00ooooooooool0
7?ooool02_l0nY[oooooo`3jV_oo003o0?ZJooooool0nY[oo`00o`3jV_l0000Hooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`04
o`3jV_oo003oooooo`3jVP?ooooo0_l0nYX4ooooo`07ool00?l0nY[o0?ZJo`3jV_oo003o003oo`3j
VP04ooooo`03ool00?l00?oooooo00;ooooo00?o0?ZJool00?ooool01?ooool00ol0nY[oo`00ool0
0007ooooo`;o0?ZJ0ooo00000ooooooo0?ZJooooo`04ooooo`03o`3jV_ooooooo`0000;ooooo00Go
0?ZJooooooooooooo`00o`3jVP07ooooo`;o0?ZJ00?o003oooooool0nYX01?ooool00ol0nY[oo`00
o`00o`03o`3jVP03oooooooo003o0?ZJ00Kooooo00Co0?ZJoooooooooooo0?ZJ1?ooool3ool000;o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oo`00o`3jVP02o`3jVP03ooooool0nY[oo`0000Go
oooo0ol0nYX6ooooo`;o0?ZJ1Oooool00ol0nY[o003oooooo`02ool000Gooooo0ol00002ooooo`03
ool00?l0nY[ooooo00;ooooo00?o0000ooooooooool0>oooool0047ooooo00Go0000oooooooooooo
ooooo`3jVP03ooooo`03o`00oooo003oo`0001Kooooo00Oo0?ZJooooool0nY[oo`00o`3jV_oo003o
0?ZJ01oooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Booooo`03o`3jV_oooooooooo00[ooooo00Go
0?ZJooooooooooooooooo`3jVP04ooooo`05o`3jV_l00?oo003oooooool0nYX01_ooool2o`3jVP04
ool00?l0nY[o0?ZJool0027ooooo00Ko0?ZJo`00oooo003oo`00o`3jV_l0000Dooooo`Go00000ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo0_l000002Ooooooo0?ZJ
oooooooooooo003oooooool0nY[oo`00o`3jVP04ooooo`?o0?ZJ1oooool2o`3jVPCooooo00Co0?ZJ
ooooool00?ooo`000_ooool00ooo003o0?ZJooooo`0Mooooo`06o`3jV_oo003o0?ZJoooooooo003o
0?ZJ4Oooool00ol0nY[oooooo`3jVP05ooooo`03o`3jV_oooooooooo00;o0?ZJ00_oo`00o`00oooo
ooooooooool00?oooooo0?ZJooooool0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo00Cooooo
00Co0?ZJooooool00?ooo`000_ooool00ooo003oooooooooo`0Looooo`0:o`3jV_oooooo0?ZJool0
0?l0nY[oooooo`3jV_oo003o0?ZJo`0001Wooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00003ooooo`;o00000oooool01?l0nY[oo`00ooooool0nYX3ooooo`;o0?ZJ0oooool02?l0
nY[oo`00o`3jV_oooooo0?ZJool00?l00?oo0?ZJ0oooool01?l0nY[oo`00o`00ool0nYX2ooooo`03
o`3jV_oo003ooooo00Cooooo00?o0?ZJool00?oo00001oooool2o`3jVP05ool00?ooooooo`00o`00
ool0nYX01Oooool00ol0nY[oo`00ooooo`02ooooo`05o`3jV_ooooooooooool00?l0nYX01oooool0
1Ol0nY[oooooo`00oooooooo0?ZJ00Cooooo00?o0?ZJool00?ooool00ol0nYX00oooooooo`00o`3j
VP06ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Koo`00ooooooooooooo`00ooooool0nYX4oooo
o`08o`3jV_oo003o0?ZJooooool0nY[oooooo`3jV_oo0005ooooo`03o`3jV_oooooo0?ZJ00Kooooo
0_l0nYX4ooooo`04o`3jV_l00?ooooooooooo`;oo`001Oooool3o`0000;o0?ZJ00Coo`00o`3jV_oo
oooooooo0_l0000mooooo`00@Oooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00Co003oool0
0?oo003o0?ZJ5Oooool01ol0nY[oooooo`3jV_oo003o0?ZJool00?l0nYX07oooool01Ol0nY[oo`00
o`3jV_oo003o0?ZJ01;ooooo00?o0?ZJooooooooool02_ooool01Ol0nY[ooooooooooooooooo0?ZJ
00?ooooo00Ko0?ZJoooooooo003oo`00ooooool0nYX6ooooo`;o0?ZJ00Coo`00o`3jV_l0nY[oo`00
8Oooool01_l0nY[oo`00oooooooo003oooooo`3jVQcooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`3jVP;ooooo00Go003oooooool0nY[oo`00
o`3jVP03ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX3ooooo`05o`3jV_ooooooooooo`00
oooo00000_ooool00ooo003o0?ZJooooo`0Mooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ4Ooo
ool00ol0nY[oooooo`3jVP04ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00_oo`00o`00ool0nY[o
ooooool00?oooooo0?ZJooooool0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo00Cooooo00Co
0?ZJooooool00?ooo`000_ooool00ooo003oooooooooo`0Kooooo`;o0?ZJ00Woooooo`3jV_oo003o
0?ZJooooool0nY[oo`00o`3jV_l000006_ooool01Ol0003ooooooooooooooooo000000;ooooo00Go
0000ooooooooooooooooo`000004ooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?o0?ZJooooool0
nYX00_ooool02?l0nY[oo`00o`3jV_oooooo0?ZJool00?l00?oo0?ZJ0oooool00ol0nY[oo`00o`3j
VP02o`3jVP03ooooool0nY[oo`0000Cooooo00Co0?ZJool00?ooooooo`001oooool01ol0nY[oo`00
ool00?ooooooo`00o`00ool0nYX01Oooool00ol0nY[oo`00ooooo`02ooooo`05o`3jV_oooooooooo
ool00?l0nYX01oooool01Ol0nY[oooooooooool00?oo0?ZJ00Cooooo00Wo0?ZJool00?l0nY[o0?ZJ
ooooool0nY[oooooool00?l0nYX01?ooool00ol0nY[oooooo`3jVP02ooooo`06o`3jV_oooooooooo
ooooool0nY[oo`000_ooool00ooo003oooooo`3jVP04ooooo`03o`3jV_oo003o0?ZJ00;ooooo0_l0
nYX00ooo003oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX01?oo
ool01?l0nY[o003oooooooooool2ool000Gooooo0ol000001?oooooo0?ZJool00?l0nYX3ooooo`03
o`000?oooooooooo03_ooooo0011ooooo`05o`000?ooooooooooooooool0nYX00oooool01?l00?oo
o`00ool00?l0nYXEooooo`07o`3jV_oooooo0?ZJool00?ooooooo`00o`3jVP0Oooooo`05o`3jV_oo
003o0?ZJool00?l0nYX04_ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ0oooool01_l0nY[ooooo
oooooooooooo0?ZJooooo`;oo`0000?oooooo`3jV_ooool01Oooool2o`3jVP04ool00?oooooooooo
ool0027ooooo00Ko0?ZJool00?ooooooo`00ooooool0nYXLooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000oooool00ol0003oooooo`3jVP03ooooo`05o`00oooooooo0?ZJool0
0?l0nYX00oooool01?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02
ool000;ooooo00?oo`00o`3jV_ooool07Oooool01_l0nY[oo`00ooooooooooooo`00o`3jVQ7ooooo
00?o0?ZJooooool0nYX01?ooool01?l0nY[oooooooooooooool2o`3jVP0@ool00?oooooo0?ZJo`3j
V_oo003oooooo`3jV_oooooo0?ZJool00?l0nY[oooooo`3jV_oo003oooooo`3jVPCooooo00Co0?ZJ
ooooool00?ooo`000_ooool00ooo003oooooooooo`0Iooooo`Co0?ZJ00Woooooo`3jV_oo003o0?ZJ
ooooool0nY[oo`00o`3jV_l000005oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVP?ooooo
00?o0?ZJooooool0nYX00_ooool02?oo003o0?ZJoooooooooooo0?ZJoooooooo003o0?ZJ0oooool0
2?l0nY[oo`00o`3jV_oooooo0?ZJooooool0nY[oo`001?ooool01?l0nY[oo`00oooooooo0002o`3j
VPGooooo00Oo0?ZJool00?oooooo003oool00?l00?oo0?ZJ00Gooooo00?o0?ZJool00?ooool00_oo
ool01Ol0nY[ooooooooooooo003o0?ZJ00Kooooo0_l0nYX2ooooo`03o`00oooooooo0?ZJ00?ooooo
00?o0?ZJool00?l0nYX00_ooool01?l0nY[oooooool00?l0nYX4ooooo`;o0?ZJ0oooool01_l0nY[o
oooooooooooooooo0?ZJool000;ooooo00?oo`00ooooool0nYX01?ooool00ol0nY[oo`00o`3jVP02
ooooo`;o0?ZJ00?oo`00ooooooooool00oooool00ol0nY[oooooo`3jVP05ooooo`03o`3jV_oooooo
0?ZJ00Cooooo00?o0?ZJo`00oooo00000ooo0005ooooo`08o`3jV_oo003oooooooooool0nY[oo`00
ooooool0nYX2ooooo`03o`000?oooooooooo03_ooooo0011ooooo`;o00000_ooool01Ol0nY[ooooo
oooooooooooo003o00;oo`0000?o0?ZJooooooooool04_ooool02?l0nY[oooooooooool0nY[oo`00
oooooooo003o0?ZJ7oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01;ooooo00?o0?ZJooooooooool0
2Oooool00ol0nY[oooooooooo`02ooooo`0:o`3jV_ooooooooooooooool0nY[oooooool00?l00?oo
o`00o`3jVPKooooo0_l0nYX01?oo003ooooooooooooo000Qooooo`06o`3jV_oo003oooooool00?l0
0?oo0?ZJ6oooool2o`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooo`3jVP03
ooooo`03o`00oooooooooooo00;oo`000oooool01?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ0ooo
ool01Ol0nY[ooooooooooooo003o0?ZJ00;ooooo00?o0?ZJool00?ooool07Oooool01_l0nY[oo`00
ooooooooooooo`00o`3jVQ3ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool05_l0nY[ooooooooooooo
oooo0?ZJool00?oooooo0?ZJo`00ool0nY[oo`00ooooool0nY[oooooo`3jV_oo003o0?ZJooooool0
nY[oo`00ooooool0nYX3ooooo`05o`3jV_ooooooooooo`00oooo00000_ooool00ooo003ooooooooo
o`0Iooooo`03o`3jV_oooooooooo00;o0?ZJ00Soo`00ooooool0nY[oooooo`3jV_oo003o0?ZJo`00
01Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool00_ooool01Ol0nY[oo`00ooooool00?oo0?ZJ00;ooooo00?o0?ZJooooool0nYX0
0_ooool02?oo003o0?ZJoooooooooooo0?ZJoooooooo003o0?ZJ0oooool02Ol0nY[oo`00o`3jV_oo
oooo0?ZJooooool0nY[oo`00o`3jVP03ooooo`06o`3jV_oo003oooooool00?l00?oo0?ZJ1?ooool2
o`3jVP06ool00?oooooo003oool00?l00?oo0?ZJ1Oooool01_l0nY[oo`00o`3jV_l0nY[oooooo`3j
VP;ooooo00?oo`00o`3jV_ooool01Oooool01ol0nY[o003ooooooooooooo003oooooool0nYX00ooo
ool00ol0nY[oo`00o`3jVP04ooooo`03ool00?l0nY[ooooo00?ooooo0_l0nYX2ool000;ooooo00Co
0?ZJooooooooooooo`000ol0nYX00ooo003oooooo`3jVP04ooooo`03ool00?l0nY[ooooo00;ooooo
0_l0nYX00ooo003oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00Cooooo0_l0nYX00ooooooo0?ZJ
ooooo`03ooooo`03o`3jV_l00?ooo`0000?oo`001Oooool02?l0nY[oo`00oooooooooooo0?ZJool0
0?oooooo0?ZJ0_ooool00ol0003oooooooooo`0kooooo`00@Oooool01Ol0003ooooooooooooooooo
0?ZJ00?ooooo00Co003oool00?oo003o0?ZJ5?ooool02?l0nY[oooooooooool0nY[oo`00oooooooo
003o0?ZJ7oooool01Ol0nY[oo`00oooooooo003o0?ZJ01;ooooo00?o0?ZJooooooooool02Oooool0
1_l0nY[oooooool00?oo003oooooo`3jVP?ooooo00Ko0?ZJo`00oooo003o003oool00?l0nYX6oooo
o`;o0?ZJ00Coo`00ooooooooooooo`008Oooool01_l0nY[oo`00oooooooo003o003oo`3jVQcooooo
00?o0000ooooooooool00oooool2o`0000Cooooo0_l000001Ol0nY[ooooooooooooooooo003o00;o
oooo0_oo0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX3ooooo`05o`3jV_oooooooooo
ool00?l0nYX00_ooool00ol0nY[oo`00ooooo`0Looooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJ
ool00?ooool03oooool01?l0nY[oooooooooool0nYX4ooooo`0<o`3jV_ooooooooooooooool0nY[o
o`00ooooool0nY[o003oo`3jV_ooooooo`000_l0nYX02?oo003oooooo`3jV_oooooo0?ZJool00?oo
oooo0?ZJ0oooool01Ol0nY[oooooooooool00?ooo`0000;ooooo00?oo`00ooooooooool06Oooool0
0ol0nY[oooooooooo`02o`3jVP08ool00?oooooo0?ZJooooool0nY[oo`00o`3jV_l0000Hooooo`?o
00001?ooool2o`0000Cooooo0_l00003ooooo`05o`3jV_oo003oooooo`00ool0nYX00_ooool01?l0
nY[oooooo`3jV_ooool3o`0000;ooooo00Go0?ZJoooooooo003oooooo`3jVP02ooooo`09o`3jV_oo
003o0?ZJooooool0nY[oooooo`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?l000000_l000000ol0
nY[oooooooooo`02ooooo`;o0?ZJ00Koo`00o`3jV_l0nY[oooooool00?l0nYX5ooooo`06o`3jV_oo
003o0?ZJo`3jV_oooooo0?ZJ0_ooool00ooo003o0?ZJooooo`05ooooo`07o`3jV_oooooooooooooo
ool00?ooooooo`3jVP03ooooo`03o`3jV_oo003o0?ZJ00Cooooo00?o0?ZJool00?ooool00oooool2
o`3jVP?oo`0000?oooooo`3jV_ooool00ol000001Ooooooo0?ZJool00?oooooo0?ZJ00?ooooo00?o
0?ZJool00?l0nYX00oooool2o`3jVP03ool00?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ
1?ooool01?l0nY[oooooooooool0nYX3ooooo`07o`3jV_ooooooo`00ool00?oooooo0?ZJool00004
ooooo`03o`3jV_l00?ooo`0000;ooooo00Go0?ZJool00?oooooo0?ZJooooo`02o`0003gooooo000d
ooooo`?o00001?ooool2o`0000Cooooo00Go0000ooooooooooooooooo`3jVP03ooooo`04o`00oooo
003oo`00o`3jVQCooooo00So0?ZJooooooooooooo`00o`3jV_ooooooo`00o`3jVQoooooo00Goo`00
o`3jV_ooooooo`00o`3jVP0Booooo`03o`3jV_oooooooooo00Wooooo00Ko0?ZJool00?oo003oo`00
ooooool0nYX3ooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ1_ooool2o`3jVP04ool00?oooooo
ooooool0027ooooo00Ko0?ZJool00?l0nY[oooooool00?l0nYXXooooo`03o`000?oooooo0?ZJ00?o
oooo00?o003oooooooooool00_oo0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX2oooo
o`;o0?ZJ0_ooool01_oo003o0?ZJoooooooooooo0?ZJool001gooooo00?o0?ZJool00?l0nYX00_oo
ool00ol0nY[oo`00ooooo`0?ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooool00000
0_l000001ooo003oooooo`3jV_l00?oo0?ZJoooooooo00000_l0nYX02?oo003oooooo`3jV_oooooo
0?ZJool00?oooooo0?ZJ0oooool01Ol0nY[oooooooooool00?ooo`0000;ooooo00?oo`00oooooooo
ool06Oooool00ol0nY[oooooooooo`02o`3jVP08ool00?l0nY[oooooooooool0nY[oo`00o`3jV_l0
000Uooooo`03o`000?oooooooooo00;ooooo00Go0?ZJool00?oooooo003oo`3jVP02ooooo`04o`3j
V_oooooo0?ZJooooo`?o00000_ooool01Ol0nY[oooooool00?oooooo0?ZJ00;ooooo00Wo0?ZJool0
0?l0nY[oooooo`3jV_oooooo0?ZJool00?l0nYX00oooool00ol0nY[oo`00o`000002o`000003oooo
ool0nY[ooooo00;ooooo0_l0nYX01_oo003o0?ZJo`3jV_ooooooo`00o`3jVPGooooo00Coo`00o`00
ool0nY[ooooo0_l0nYX2ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJooooool0nYX00oooool0
0ol00?ooooooo`3jVP03ooooo`03ool00?l0nY[o0?ZJ00Cooooo00?o0?ZJool00?ooool00oooool0
2?l0nY[oo`00ooooooooooooo`00ooooool0nY[ooooo0ol000001Ooooooo0?ZJo`00oooo003o0?ZJ
00?ooooo00?o0?ZJool00?l0nYX00oooool2o`3jVP03ool00?oooooooooo00;ooooo00Co0?ZJoooo
oooooooo0?ZJ1?ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_l00?ooo`0000;ooooo00?o
0?ZJool00?l0nYX00oooool00ol0nY[oo`00o`3jVP02ooooo`04o`3jV_oo003oooooo`3jVP;ooooo
00?o0000ooooooooool0>oooool003Gooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00003ooooo`05o`000?ooooooooooooooool0nYX00oooool01?l00?ooo`00ool00?l0nYXDoooo
o`08o`3jV_ooooooooooool00?l0nY[oooooool00?l0nYXOooooo`05ool00?l0nY[oooooool00?l0
nYX04Oooool2o`3jVP_ooooo00Ko0?ZJool00?ooooooooooool00?l0nYX3ooooo`06o`3jV_oo003o
oooooooooooo003o0?ZJ1Oooool01?l0nY[oooooo`3jV_oo0002ooooo`03ool00?oooooooooo01oo
oooo00Ko0?ZJool00?l0nY[o0?ZJool00?l0nYXXooooo`03o`000?oooooo0?ZJ00;ooooo00Coo`00
o`00oooooooooooo0_oo0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX2ooooo`06o`3j
V_ooooooooooool00?oooooo0?ZJ0_ooool00ol0nY[oo`00ooooo`0Kooooo`;o0?ZJ00Ooo`00o`3j
V_ooooooooooo`3jV_oo003o0?ZJ00oooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[ooooo
o`000002o`000007ooooool0nY[oooooo`00ool0nY[oooooool00002o`3jVP08ool00?oooooo0?ZJ
ooooool0nY[o003oool00?l0nYX3ooooo`05o`3jV_ooooooooooo`00oooo00000_ooool00ooo003o
ooooooooo`0Hooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00Soo`00o`3jV_ooooooooooo`3jV_oo
003o0?ZJo`0002Gooooo00?o0000ooooooooool00_ooool01Ol0nY[oo`00ooooool00?oo0?ZJ00;o
oooo00Co0?ZJooooool0nY[ooooo0ol00002ooooo`05o`3jV_ooooooo`00ooooool0nYX00_ooool0
2Ooo003o0?ZJoooooooooooo0?ZJooooool0nY[oo`00o`3jVP03ooooo`03o`3jV_oo003o000000;o
000000?oooooo`3jV_ooool00_ooool3o`000005o`00ool0nY[oooooool00?l0nYX01?ooool00ol0
nY[oo`00o`3jVP02ooooo`;o0?ZJ0_ooool00ol0nY[oo`00ooooo`03ooooo`03o`3jV_oooooo0?ZJ
00?ooooo00?o003oooooool0nYX00_ooool00ol0nY[oo`00o`3jVP05ooooo`03o`3jV_oo003ooooo
00?ooooo00So0?ZJool00?l00?ooooooool00?oooooo0?ZJooooo`?o000000Goooooo`3jV_oooooo
o`00o`3jVP03ooooo`03o`3jV_oo003o0?ZJ00?ooooo0_l0nYX00ooo003oooooooooo`02ooooo`04
o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJo`00oooooooo0?ZJ0oooool00ol0nY[o003oool00002
ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX00_ooool01?l0nY[oo`00o`00ool0
nYX2ooooo`03o`000?oooooooooo03_ooooo000]ooooo`Go00000oooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000?ooooo0_l00002ooooo`08o`3jV_ooooooooooo`00oooooooo
o`00o`3jV_oo000Dooooo`08o`3jV_ooooooooooool00?l0nY[oooooo`3jV_oo000Oooooo`06ool0
0?l0nY[oooooo`3jV_oo003o0?ZJ4?ooool2o`3jVP_ooooo00Ko0?ZJool00?ooooooooooool00?l0
nYX2ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_ooool01?ooool01?l0nY[oooooo`3j
V_oo0002ooooo`03ool00?oooooooooo01kooooo00?o0?ZJool00?l00?l00_l0nYX00ooo003o0?ZJ
ooooo`0Wooooo`;o000000Co0?ZJooooooooooooo`000oooool2ool000?ooooo00Co0?ZJoooooooo
oooo0?ZJ1oooool5o`3jVP;ooooo00?oo`00ooooool0nYX00_ooool00ol0nY[oo`00ooooo`03oooo
o`03o`3jV_oooooooooo01Gooooo00Co0?ZJoooooooo003o0?ZJ0_ooool00ol0nY[oo`00o`3jVP0>
ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_l00?oo000000;o000000Oooooo
o`3jV_ooooooooooo`3jV_ooooooo`0000;o0?ZJ00Soo`00o`3jV_ooooooooooo`3jV_l00?ooo`00
o`3jVP?ooooo00Go0?ZJoooooooooooo003oool00002ooooo`03ool00?oooooooooo01Sooooo00So
0?ZJooooooooooooooooo`3jV_oo003oooooo`3jVP;ooooo00Co0?ZJool00?l0nY[o00009Oooool2
o`0000?ooooo00Oo0?ZJool00?oooooo003oo`3jV_oooooo0?ZJ00?ooooo0_l0nYX00ooo003ooooo
ooooo`02ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?oo`00o`3jV_ooool00_ooool2o`3jVP03
ool00?l0nY[ooooo00;ooooo00Oo0?ZJool00?l0nY[o0?ZJool00?l00?oo0?ZJ00?ooooo0ol00002
ooooo`04o`3jV_oo003o003oo`3jVP?ooooo00?o0?ZJool00?l0nYX00_ooool2o`3jVP;ooooo00?o
0?ZJool00?ooool00_ooool3o`3jVP07o`00oooo003oo`00ool00?l00?ooooooo`3jVP02ooooo`03
o`3jV_oo003o0?ZJ00Gooooo00?o0?ZJool00?ooool00oooool01ol0nY[oo`00o`00ool00?ooo`00
ooooool0nYX00_ooool01ooo003oooooooooool0nY[oooooool00?l0nYX00oooool00ol0nY[oo`00
o`3jVP03ooooo`;o0?ZJ00?oo`00ooooooooool00_ooool01?l0nY[oooooooooool0nYX3ooooo`05
o`3jV_l00?oo003oooooool0nYX00oooool00ol0nY[oo`00ool00002ooooo`03o`3jV_oo003o0?ZJ
00?ooooo00?o0?ZJool00?l0nYX00oooool01_l0nY[oo`00o`3jV_oooooo0000o`3jVSgooooo000e
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooo
oooooooo0?ZJ00;ooooo00Go003ooooooooo003o0?ZJool0000Dooooo`08o`3jV_ooooooooooool0
0?l0nY[oooooo`3jV_oo000Oooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ4?ooool2o`3jVP[o
oooo00?o0?ZJo`00oooo00000_ooool01ooo003o0?ZJoooooooooooo0?ZJo`00oooo00000_l0nYX0
0ooo003o0?ZJooooo`04ooooo`04o`3jV_oooooo0?ZJool000;ooooo00?oo`00ooooooooool07_oo
ool00ol0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo02Oooooo00Oo0000ooooool0nY[ooooo
ool00?l00?ooo`0000;ooooo0_oo0003ooooo`04o`3jV_ooooooooooo`3jVPOooooo0ol0nYX3oooo
o`04o`00oooo003oooooo`3jVP;ooooo00?o0?ZJool00?ooool00_ooool2o`3jVQOooooo0ol00003
ooooo`03o`3jV_oo003o0?ZJ00kooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`03o`3jV_oo
003ooooo00;oo`0000_o0?ZJooooooooooooooooo`3jV_ooooooo`00o`3jV_oo003o003oo`3jVP02
ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00Ko0?ZJoooooooooooo003ooooooooo0002ooooo`03
ool00?oooooooooo01Sooooo00So0?ZJooooooooooooooooo`3jV_oo003oooooo`3jVP;ooooo00Co
0?ZJool00?oooooo0?ZJ9Oooool00ol0003oooooooooo`02ooooo`07o`3jV_oo003oooooo`00ool0
nY[oooooo`3jVP03ooooo`;o0?ZJ00?oo`00ooooooooool00_ooool01?l0nY[oo`00ooooool0nYX2
ooooo`03ool00?l0nY[ooooo00;ooooo0ol0nYX01ooo003oooooooooooooooooo`00o`3jV_l00?l0
0_l0nYX01Ooo003oooooo`3jV_oooooo0?ZJ00?o00000_ooool01?l0nY[oo`00o`00ool0nYX3oooo
o`03o`3jV_oo003o0?ZJ00;ooooo0_l0nYX2ooooo`03o`3jV_oo003ooooo00;ooooo0ol0nYX2ool0
0005oooooooo003o003oooooool0nYX00_ooool00ol0nY[oo`00o`3jVP05ooooo`03o`3jV_oo003o
oooo00;ooooo0ol00002o`3jVP06ool00?oooooo0?ZJooooool00?ooo`000_ooool01?l0nY[ooooo
ool00?l0nYX3ooooo`03ool00?l0nY[ooooo00?ooooo0_l0nYX00ooo003oooooooooo`02ooooo`04
o`3jV_ooooooooooo`3jVP?ooooo00Go0?ZJooooool00?ooooooool00003ooooo`03o`3jV_oo003o
oooo00;ooooo00?o0?ZJool00?l0nYX00oooool00ol0nY[oo`00o`3jVP03ooooo`03o`3jV_oo003o
0?ZJ00;ooooo00?o0?ZJooooooooool0>oooool003Gooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00003ooooo`05o`000?ooooooooooooooool0nYX00_ooool01Ol00?ooooooool0
0?l0nY[oo`0001Cooooo00Co0?ZJooooooooooooo`000_ooool00ol0nY[oo`00ooooo`0Mooooo`07
o`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP0@ooooo`;o0?ZJ2_ooool01ol0nY[oo`00ool00?l0
0?ooooooool00?l0nYX00_ooool00ol0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[ooooo00Cooooo
00Co0?ZJo`000?l0003o00000_ooool00ooo003o0?ZJooooo`0Nooooo`07o`3jV_oo003o0?ZJoooo
ool0nY[oo`00o`3jVP0Xooooo`07o`000?oooooo0?ZJoooooooo003o003oool00002ooooo`;oo`00
0oooool01?l0nY[oooooooooool0nYX7ooooo`?o0?ZJ0_ooool01Ol00?ooo`00ool00?oooooo0?ZJ
00;ooooo00?o0?ZJool00?l0nYX00_ooool2o`3jVPoooooo0_l0nYX6ooooo`?o00000oooool00ol0
nY[oo`00o`3jVP0=ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oo003ooooo
ooooool0nYX01?ooool01ol0nY[oooooool00?l0nY[oo`00o`00ool0nYX00_ooool01?l0nY[ooooo
ool00?l0nYX2ooooo`06o`3jV_ooooooooooo`00ooooooooo`000_ooool00ooo003oooooooooo`0H
ooooo`03o`3jV_oooooooooo00?o000000So0?ZJooooooooooooooooo`3jV_oo003oooooo`3jVRGo
oooo00?o0000ooooooooool00_ooool01ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX00oooool2
o`3jVP03ool00?oooooooooo00;ooooo00Co0?ZJool00?l00?oo0?ZJ0_ooool00ooo003o0?ZJoooo
o`02ooooo`?o0?ZJ013oo`00ooooooooooooooooool00?l0nY[o003oooooool0nY[oo`00ooooool0
nY[oooooo`3jV_ooooooo`000oooool01?l0nY[oo`00o`00ool0nYX3ooooo`03o`3jV_oo003o0?ZJ
00;ooooo0_l0nYX2ooooo`03o`3jV_oo003o0?ZJ00;ooooo0ol0nYX00ooo003oooooooooo`02ool0
0007o`00ool0nY[oooooooooool0nY[oo`00o`3jVP05ooooo`03o`3jV_oo003ooooo00;ooooo0ol0
00002?oooooo0?ZJoooooooo003oooooo`3jV_l00?ooo`000oooool00ol0nY[oo`00o`3jVP03oooo
o`03ool00?l0nY[ooooo00?ooooo0_l0nYX00ooo003oooooooooo`02ooooo`04o`3jV_ooooooo`00
ool000;ooooo0_l0nYX01?oooooo003oool00?oo0003ooooo`03o`3jV_oo003ooooo00;ooooo00?o
0?ZJool00?l0nYX00oooool00ol0nY[oo`00o`3jVP03ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o
0?ZJooooooooool0>oooool003Cooooo0_l00004ooooo`04o`000?ooooooooooo`0000?ooooo00Go
0000ooooooooooooooooo`3jVP02ooooo`05o`00ooooooooo`00o`3jV_oo00004oooool01Ol0nY[o
ooooooooooooooooo`0000;ooooo00?o0?ZJool00?ooool07Oooool01ol0nY[oo`00o`3jV_oooooo
0?ZJool00?l0nYX04?ooool2o`3jVP[ooooo00?o0?ZJool00?l00?l00_l0nYX01oooooooo`00oooo
oooooooo0?ZJool00?ooool00_l0nYX00ol00?ooo`00ooooo`04ooooo`04o`3jV_l0003o0000o`00
00;ooooo00?oo`00o`3jV_ooool07_ooool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX0:?oo
ool01ol0003oooooo`3jV_ooooooo`00o`00oooo00000_ooool2ool000?ooooo00Co0?ZJoooooooo
oooo0?ZJ1oooool3o`3jVP;ooooo00Go003oool00?ooooooooooo`3jVP02ooooo`03o`3jV_oo003o
0?ZJ00;ooooo0_l0nYX?ooooo`;o0?ZJ1Oooool01?l0nY[o0000o`000?l00003ooooo`03o`3jV_oo
003o0?ZJ00cooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJool00?oooooooooo
o`3jVP04ooooo`03o`00ool0nY[o000000;o00000_l0nYX3ooooo`03o`3jV_oo003o0?ZJ00;ooooo
00Co0?ZJoooooooooooo003o0_oo0002ooooo`03ool00?l0nY[ooooo01Sooooo00?o0?ZJoooooooo
00000ol000002?l0nY[ooooooooooooooooo0?ZJool00?oooooo0?ZJ9Oooool00ol0003ooooooooo
o`02ooooo`07o`3jV_oo003oooooo`00ool0nY[oooooo`3jVP04ooooo`03o`00oooo003ooooo00?o
oooo00So0?ZJool00?l00?oo0?ZJooooool0nY[oo`00o`3jVP?ooooo0ol0nYX01_oo003ooooooooo
ooooooooo`00o`3jVP;ooooo00So0?ZJool00?oooooo0?ZJooooool0nY[oooooool000?ooooo00[o
0?ZJool00?l00?oo0?ZJooooool0nY[oooooo`3jV_oo003o0?ZJ0_ooool2o`3jVP;ooooo00?o0?ZJ
ool00?l0nYX00_ooool3o`3jVP07ool00?oooooooooooooooooo003o003oo`3jVP02ooooo`03o`3j
V_oo003ooooo00Gooooo00?o0?ZJool00?ooool00_ooool3o`000005ooooool0nY[oooooool00?oo
ool00_l0nYX02?oo003ooooooooooooooooo0?ZJool00?oooooo0?ZJ0_ooool00ooo003o0?ZJoooo
o`03ooooo`;o0?ZJ00?oo`00ooooooooool00_ooool02Ol0nY[oo`00ool00?oo003oooooo`00ool0
nY[o003oooooo`03ool000;ooooo00?o0?ZJo`00oooo00000oooool00ol0nY[oo`00o`3jVP03oooo
o`03o`3jV_oo003o0?ZJ00?ooooo00Co0?ZJool00?l0nY[ooooo0_l0nYXmooooo`00=Oooool00ol0
003oooooooooo`03ooooo`;o00001?ooool2o`0000;ooooo00So0?ZJoooooooooooo003ooooooooo
003o0?ZJool000Gooooo00?o0?ZJooooooooool02oooool01Ol0nY[oooooooooooooooooo`0000;o
oooo00?o0?ZJool00?l0nYX07Oooool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX04?ooool2
o`3jVPSooooo00Go0?ZJooooool0nY[oo`00ooooo`02o`3jVP07oooooooo003oooooooooool0nY[o
o`00ooooo`02o`3jVP03oooooooo003ooooo00Cooooo00Co0?ZJo`000?l0003o00000_ooool00ooo
003o0?ZJooooo`0Kooooo`0:o`3jV_ooooooooooo`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVRSo
oooo00Oo0000o`3jV_ooooooooooool00?l00?ooo`0000;ooooo0_oo0003ooooo`04o`3jV_oooooo
ooooo`3jVPOooooo0ol0nYX01?l00?ooooooo`00oooo0002ooooo`07o`3jV_ooooooooooo`3jV_oo
003o0?ZJooooo`03o`3jVPoooooo0_l0nYX5ooooo`04o`3jV_l00?oo003oool000?ooooo00?o0?ZJ
ool00?l0nYX02oooool2o`3jVPGooooo00?o0?ZJooooooooool00_ooool01Ol0nY[oo`00oooooooo
oooo0?ZJ00Gooooo00Go0?ZJo`000?l0003o0000o`3jVP04ooooo`05o`3jV_oo003o0?ZJooooool0
nYX00oooool00ol00?ooo`00ool00002ooooo`03ool00?l0nY[ooooo01Sooooo00?o0?ZJool00?oo
00000ol00004ooooo`04o`3jV_oo003oooooo`3jVRGooooo0_l00003ooooo`07o`3jV_oo003ooooo
o`00ool0nY[oooooo`3jVP04ooooo`03o`00oooo003ooooo00?ooooo00So0?ZJool00?l00?oo0?ZJ
ooooool0nY[oo`00o`3jVP?ooooo0ol0nYX01_oo003oooooooooool0nY[oo`00o`3jVP;ooooo00So
0?ZJool00?oooooo0?ZJooooool0nY[oooooool000?ooooo00?o0?ZJool00?l00?l00ol0nYX00ooo
ooooo`00o`3jVP03ooooo`;o0?ZJ0_ooool00ol0nY[oo`00o`3jVP02ooooo`;o0?ZJ00?oo`00oooo
ooooool00_ooool00ooo003o003oo`3jVP02ooooo`03ool00?l0nY[ooooo00Gooooo00?o0?ZJool0
0?ooool00_ooool02?l0nY[oo`00o`3jV_oooooo0?ZJoooooooo003ooooo0_l0nYX01ooo003ooooo
oooooooooooo0?ZJool00?ooool00_l0nYX00oooooooo`00o`3jVP04ooooo`;o0?ZJ00[oo`00o`3j
V_ooooooooooo`3jV_ooooooo`00o`00oooo003ooooo0_l0nYX2ooooo`03ool00?l00?ooo`0000;o
oooo00?o0?ZJool00?ooool00oooool00ol0nY[oo`00o`3jVP03ooooo`03ool00?oooooo0?ZJ00?o
oooo00Co0?ZJool00?l0nY[ooooo0_l0nYXmooooo`00@Oooool01?l0003oooooooooool0nYX3oooo
o`05o`00ooooooooo`00o`3jV_oo00001Oooool00ol0nY[oooooooooo`0;ooooo`05o`3jV_oooooo
oooooooooooo00000_ooool00ol0nY[oo`00o`3jVP0Mooooo`07o`3jV_oo003o0?ZJooooool0nY[o
o`00o`3jVP0@ooooo`;o0?ZJ1oooool4o`3jVP07ool00?oooooo0?ZJo`3jV_ooooooo`00ooooo`02
o`3jVP06ool00?oooooo0?ZJo`3jV_ooooooo`001Oooool00ol0nY[oooooool00003ooooo`03ool0
0?l0nY[ooooo01_ooooo00[o0?ZJooooool0nY[oooooool00?l0nY[oooooo`3jV_oo003o0?ZJ:?oo
ool00ol0003o0?ZJooooo`02ool00004o`00oooo003oooooooooo`;oo`000oooool01?l0nY[ooooo
ooooool0nYX7ooooo`;o0?ZJ1?oo0003ooooo`0:o`3jV_oooooooooooooooooo003o0?ZJooooool0
nY[oooooo`3jVPoooooo0_l0nYX4ooooo`;o0?ZJ0_l00?l01ooo003ooooooooooooooooo0?ZJool0
0?l0nYX02oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJool0
0?ooooooooooo`3jVP05ooooo`05o`3jV_l0003o0000o`000?l0nYX01?ooool01Ol0nY[oo`00o`3j
V_oooooo0?ZJ00?ooooo0_oo00001Ol0nY[ooooooooooooo003o0?ZJ01Wooooo00Go0?ZJool00?l0
0?oo003oo`3jVP05ooooo`04o`3jV_l00?ooo`00o`3jVRGooooo00?o0000ooooooooool00_ooool0
1ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX01?ooool00ol00?ooo`00ooooo`03ooooo`07o`3j
V_oo003o003oo`3jV_oooooo0?ZJool00004ooooo`?o0?ZJ00Koo`00oooooooooooo0?ZJool00?l0
nYX2ooooo`03o`3jV_oo003ooooo00?o0?ZJ00?oo`00o`3jV_ooool00_ooool00ol0nY[oo`00oooo
o`03o`3jVP03oooooooo003o0?ZJ00Cooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX2ooooo`;o
0?ZJ00?oo`00ooooooooool00_ooool00ooo003o003oo`3jVP02ooooo`03ool00?l0nY[ooooo00Go
oooo00?o0?ZJool00?l0nYX00_ooool02?l0nY[oo`00o`3jV_oooooo003oo`3jV_oo003ooooo0_l0
nYX01ooo003ooooooooooooooooo0?ZJool00?ooool00ol0nYX00ooo003oooooooooo`03ooooo`;o
0?ZJ00_oo`00o`3jV_ooooooooooo`3jV_ooooooo`00o`00oooo003o0?ZJo`00o`02ooooo`;oo`00
00Ko003oool00?ooooooooooo`3jV_oo0004ooooo`;o0?ZJ00Koo`00ooooooooooooooooool00?l0
nYX4ooooo`04o`3jV_oo003o0?ZJooooo`;o0?ZJ?Oooool0047ooooo00Co0000oooooooooooo0?ZJ
0oooool01Ol00?ooooooool00?ooooooo`0000Cooooo0_l0nYX=ooooo`03o`3jV_oooooo000000;o
00000_ooool00ol0nY[oo`00o`3jVP0Mooooo`07o`3jV_oo003oooooooooool0nY[oo`00o`3jVP0?
ooooo`03o`3jV_oooooo0?ZJ00Oooooo0ol0nYX03?oo003oooooo`3jV_l00?oo0?ZJoooooooo003o
ooooo`3jV_l00?ooo`00o`3jVP;ooooo00?o0?ZJool00?ooool00oooool01?l0nY[ooooooooooooo
0003ooooo`03ool00?l0nY[ooooo01_ooooo00[o0?ZJooooool0nY[oo`00ooooool0nY[oooooo`3j
V_oo003o0?ZJ:?ooool01?l0003o0?ZJoooooooo0002o`00o`03ool00?oooooooooo00;oo`000_oo
ool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo0_l0nYX00ooo003o003oool00004ooooo`05o`3j
V_oooooooooooooooooo00000ol0nYX00ooooooo0?ZJooooo`0>ooooo`;o0?ZJ0oooool2o`3jVP;o
003o00?oooooool00?ooool00_ooool00ol0nY[oo`00o`3jVP0;ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool00_ooool01Ol0nY[oo`00oooooooooooo0?ZJ00Gooooo00?o0?ZJo`00
ool0nYX01_ooool00ol0nY[oo`00o`3jVP02o`3jVP06ooooool00?ooooooool00?oooooo0?ZJ0_oo
ool00ooo003o0?ZJooooo`0Hooooo`05o`3jV_oo003o003oo`00ool0nYX01Oooool01?l0nY[ooooo
ool00?l0nYXUooooo`03o`000?oooooooooo00;ooooo00Oo0?ZJool00?oooooo003oo`3jV_oooooo
0?ZJ00Cooooo00?o003oool00?ooool00oooool01ol0nY[oo`00o`00ool0nY[oooooo`3jV_oo0000
1?ooool2o`3jVP07oooooooo003oooooooooool0nY[oo`00o`3jVP03ooooo`07o`3jV_oo003ooooo
o`3jV_ooooooo`00o`3jVP03ooooo`03o`3jV_oo003ooooo00?o0?ZJ00?oooooool00?l0nYX01?oo
ool01_l0nY[oooooooooool0nY[oo`00o`3jVP;ooooo0_l0nYX00ooo003oooooooooo`03ooooo`06
ool00?l0nY[oooooo`3jV_oo003o0?ZJ1_ooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003o
0?ZJ00;ooooo00?o0?ZJool00?ooool00_l0nYX01ooo003ooooooooooooooooo0?ZJool00?ooool0
0ol0nYX00ooo003oooooooooo`03ooooo`;o0?ZJ00Koo`00o`3jV_ooooooooooo`3jV_oo0003o`00
00;o003o0_ooool01?oo003ooooooooooooo0002ooooo`03o`3jV_oo003ooooo00;o0?ZJ00Cooooo
o`3jV_l0nY[oo`000_ooool00ol0nY[oo`00o`3jVP04ooooo`04o`3jV_oo003o0?ZJooooo`;o0000
?Oooool0047ooooo00Co0000oooooooooooo0?ZJ0oooool01Ol00?ooooooool00?ooooooo`0000Co
oooo0_l0nYX=ooooo`03o`3jV_oooooo000000;o00000oooool00ooo003o0?ZJooooo`0Looooo`07
ool00?l0nY[oooooooooool0nY[oo`00o`3jVP0?ooooo`03o`3jV_oooooo0?ZJ00Oooooo0ol0nYX0
0ooo003oooooo`3jVP02o`00o`07o`3jV_oo003oooooo`3jV_oo003oooooo`3jVP02ooooo`?o0000
0oooool01?l0nY[ooooooooooooo0003ooooo`03ool00?l0nY[ooooo01_ooooo00[o0?ZJooooool0
nY[oo`00ooooool0nY[oooooo`3jV_ooooooo`00:?ooool01ol0003o0?ZJoooooooo003o003ooooo
oooo00000_ooool2ool000;ooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;o0?ZJ00?oo`00
o`00ool00?l01?ooool01Ol0nY[oooooooooooooooooo`0000;o0?ZJ0_ooool00ol0nY[ooooooooo
o`0=ooooo`;o0?ZJ00Koooooo`3jV_l0nY[o0?ZJooooool00?l2ooooo`07ool00?oooooooooooooo
ool0nY[oo`00o`3jVP0;ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_ooool0
1Ol0nY[oo`00oooooooooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX01_ooool01?l0nY[o003oool0
0?l0nYX2ooooo`05o`00oooo003oooooooooool0nYX00_ooool00ooo003o0?ZJooooo`0Hooooo`05
o`3jV_oo003oooooo`00ool0nYX01Oooool01?l0nY[oooooool00?l0nYXUooooo`;o00000oooool0
1ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX01?ooool00ol00?ooo`00ooooo`03ooooo`07o`3j
V_oo003o003oo`3jV_oooooo0?ZJool00004ooooo`;o0?ZJ00Ooooooool00?ooooooooooo`3jV_oo
003o0?ZJ00?ooooo00?o0?ZJool00?ooool00_ooool00ooo003o0?ZJooooo`02ooooo`03o`3jV_oo
ooooo`0000?o0?ZJ00?oooooool00?l0nYX01?ooool02Ol0nY[oooooooooool0nY[oo`00o`3jV_oo
oooo0?ZJooooo`02ool000?o0?ZJ0_ooool01_oo003o0?ZJooooool0nY[oo`00o`3jVPOooooo00Ko
o`00o`3jV_oooooo0?ZJoooooooo0003ooooo`06o`3jV_oo003oooooo`00ooooooooo`000oooool0
0ol0nY[oo`00ooooo`03o`3jVP03ool00?oooooooooo00Cooooo00?o0?ZJool00?l0nYX00_ooool0
0ol0nY[oo`00o`000002o`000005o`00oooooooooooooooooooo00000_ooool01_oo003ooooooooo
ool0nY[oo`00ooooo`Go0?ZJ00Koo`00oooooooooooo0?ZJool00?l0nYX4ooooo`04o`3jV_oo003o
0?ZJooooo`;o0000?Oooool0047ooooo00Co0000oooooooooooo0?ZJ0oooool01Ol00?ooooooool0
0?ooooooo`0000Cooooo0_l0nYX=ooooo`03o`3jV_oooooo000000;o00000oooool00ooo003o0?ZJ
ooooo`0Looooo`07ool00?l0nY[oooooooooool0nY[oo`00o`3jVP0?ooooo`03o`3jV_oooooo0?ZJ
00Oooooo0ol0nYX03?oo003oooooo`3jV_oooooo003oo`3jV_oo003oooooo`3jV_oo003oooooo`3j
VP;ooooo0ol00003ooooo`04o`3jV_ooooooooooool000?ooooo00?oo`00o`3jV_ooool06_ooool2
o`3jVP09ooooool0nY[oo`00ooooool0nY[oooooo`3jV_ooooooo`0002;ooooo0_l00004ooooo`07
o`000?l0nY[oo`00ool00?l00?ooooooool00002ooooo`;oo`000_ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Kooooo00Co0?ZJooooool0nY[oo`001_ooool01Ol0nY[oooooooooooooooooo`0000Co
oooo00?o0?ZJooooooooool01?ooool2o`3jVPKooooo00So0?ZJooooool0nY[oooooo`3jV_l00?oo
ooooo`00o`?ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00_ooooo00?o0?ZJool00?oo
00000oooool2ool000Cooooo00Goo`00o`00ooooooooooooo`3jVP05ooooo`03o`3jV_oooooo0?ZJ
00Kooooo00?o0?ZJo`00oooo00000oooool2ool000;ooooo00Go0?ZJooooooooooooo`00o`3jVP0I
ooooo`05o`3jV_oo003oooooooooool0nYX01Oooool01?l0nY[oooooool00?l0nYXHooooo`?o0000
1?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool01ol0nY[oo`00ooooool00?oo0?ZJoooo
ool0nYX01?ooool00ol00?ooo`00ooooo`03ooooo`07o`3jV_ooooooo`00o`3jV_ooooooo`00o`3j
VP04ooooo`;o0?ZJ00Koooooool00?ooooooooooo`3jV_oo0004ooooo`03o`3jV_oo003ooooo00;o
oooo00?oo`00o`3jV_ooool00_ooool00ol0nY[oooooool00004o`3jVP03ool00?l0nY[ooooo00?o
oooo00[o0?ZJoooooooooooo0?ZJool00?l0nY[oooooo`3jV_ooooooo`000_l0nYX02_oooooo0?ZJ
ooooooooooooo`00o`3jV_oooooo0?ZJool00?l0nYX7ooooo`06ool00?l0nY[oooooo`3jV_oo003o
0?ZJ0oooool01_l0nY[oo`00ooooool00?ooooooool000?ooooo00?o0?ZJo`00oooo00000ol0nYX0
0ooo003oooooooooo`04ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?l000000_l00000
1?oo003ooooooooooooo0003ooooo`06ool00?oooooo0?ZJo`00oooo003o0?ZJ0_ooool3o`3jVP06
ool00?ooooooooooo`3jV_oo003o0?ZJ1?ooool01?l0nY[oo`00o`3jV_ooool2o`0003gooooo0011
ooooo`;o000000?oooooo`3jV_ooool00_ooool01Ol00?ooooooool00?ooooooo`0000Cooooo0_l0
nYX<ooooo`06o`3jV_ooooooooooool00?l00?oo0?ZJ0oooool00ooo003o0?ZJooooo`0Kooooo`03
o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?l0nYX03oooool00ol0nY[oooooo`3jVP06ooooo`06
o`3jV_oooooo0?ZJo`3jV_oo003o0?ZJ0_ooool00ol00?oo0?ZJool00002o`3jVP03ool00?oooooo
0?ZJ00;ooooo0ol00003ooooo`04o`3jV_ooooooooooool000?ooooo00?oo`00o`3jV_ooool06_oo
ool01_l0nY[oooooo`3jV_l0nY[oo`00o`3jVP;ooooo00?o0?ZJoooooooo00008Oooool01?l0003o
ooooooooool00003ooooo`04o`3jV_oo003oo`00o`00o`;ooooo00?oo`00ooooooooool00_oo0002
ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01?l0nY[oooooo`3jV_oo0006ooooo`05o`3j
V_oooooooooooooooooo00001?ooool00ol0nY[oooooooooo`03ooooo`?o0?ZJ1_ooool01Ol0nY[o
ooooo`3jV_oooooo0?ZJ00?o003o0oooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX02ooo
ool00ooo003o003oool00005ool000Cooooo00?oo`00o`00ool0nYX00_l0nYX5ooooo`03o`3jV_oo
oooo0?ZJ00Kooooo00Go0?ZJo`000?l0003o0000o`00o`02ool000?ooooo00Go0?ZJoooooooooooo
o`00o`3jVP0Iooooo`05ool00?l00?ooooooooooool0nYX01_ooool00ol0nY[oo`00o`3jVP0Goooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00003ooooo`03o`000?oo
oooooooo00;ooooo00Oo0?ZJool00?oooooo003oo`3jV_oooooo0?ZJ00Cooooo00?o003oool00?oo
ool00oooool01ol0nY[oooooool00?l0nY[oooooool00?l0nYX01?ooool2o`3jVP06oooooooo003o
ooooooooool0nY[oo`001?ooool00ol0nY[oo`00ooooo`02ooooo`03ool00?l0nY[ooooo00;ooooo
00?o0?ZJoooooooo00001?l0nYX00ooo003o0?ZJooooo`03ooooo`08o`3jV_ooooooooooo`3jV_oo
003o0?ZJooooool0nYX2ool00004o`3jV_ooooooooooo`3jVP;ooooo0_oo00001?oooooo0?ZJool0
0?l0nYX7ooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ0oooool01_l0nY[oooooool00?l00?oo
ooooool000?ooooo00?o0?ZJoooooooo00000_l0nYX00ooo003o0?ZJooooo`05ooooo`;o0?ZJ00Go
o`00oooooooooooo0?ZJool00002ooooo`05o`3jV_oo003ooooooooooooo00000oooool01_oo003o
ooooo`3jV_oo003oooooo`3jVP;ooooo0ol0nYX01_oo003oooooooooool0nY[oo`00o`3jVPCooooo
00Ko0?ZJool00?l0nY[oooooo`3jV_oo000mooooo`00@Oooool01?l0003oooooooooool0nYX3oooo
o`05o`00ooooooooo`00oooooooo00001?ooool2o`3jVPcooooo00Ko0?ZJooooooooooooo`00oooo
ool0nYX3ooooo`03ool00?l0nY[o0?ZJ01[ooooo0_l0nYX01ooo003o0?ZJoooooooooooo0?ZJool0
0?l0nYX03_ooool2o`3jVP03ooooool0nY[ooooo00Gooooo00Ko0?ZJooooool0nY[oo`00ooooool0
nYX2ooooo`04o`00ool0nY[oo`00o`3jVP;oo`000_l0nYX2ooooo`03o`3jV_oo003o0?ZJ00;ooooo
0_l0nYX00ooooooo003oool00003ooooo`03o`3jV_oo003ooooo01[ooooo00Ko0?ZJooooool0nY[o
o`00ooooool0nYX3ooooo`;o00008Oooool01?l0003oooooooooool00003ooooo`;o00001?ooool0
0ooo003oooooooooo`02ool000;ooooo00Go0?ZJoooooooooooo003oo`3jVP06ooooo`05o`3jV_oo
oooo0?ZJool00?l0nYX01Oooool01Ol0nY[oooooooooooooooooo`0000Cooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooo`3jVP06ooooo`05o`3jV_oooooo0?ZJo`3jV_ooool00_l00?l4oooo
o`07ool00?ooooooooooooooool0nY[oo`00o`3jVP0:ooooo`03o`3jV_oo003o003o00Gooooo00?o
o`00ooooooooool00_ooool00ooo003o0?ZJo`3jVP02o`3jVPGooooo00?o0?ZJooooool0nYX01_oo
ool01?l0nY[o0000o`000?l00002ool000Cooooo00Go0?ZJooooooooooooo`00o`3jVP0Iooooo`05
ool00?ooooooooooooooool0nYX01_ooool00ol0nY[o0000o`00000Kooooo`04o`000?oooooooooo
o`0000;ooooo00Go0000ooooooooooooooooo`000004ooooo`07o`3jV_oo003oooooo`00ool0nY[o
ooooo`3jVP03ooooo`03o`00ooooooooo`0000Cooooo00Oo0?ZJoooooooo003o0?ZJoooooooo003o
0?ZJ00Cooooo0_l0nYX01_ooooooo`00oooooooooooo0?ZJool000Cooooo00Oo0?ZJool00?oooooo
ooooo`00oooo003o0?ZJ00Cooooo00Co0?ZJool00?l00?oooooo0_l0nYX00ooo003oooooooooo`03
ooooo`08o`3jV_ooooooooooo`3jV_oo003o0?ZJooooool0nYX3o`0000?ooooo00Oo0?ZJooooool0
0?ooo`00ooooool0nY[oo`0000Sooooo00Koo`00o`3jV_oooooo0?ZJool00?l0nYX3ooooo`06o`3j
V_ooooooo`00o`00ooooooooo`000oooool00ol0nY[oooooool00002o`3jVP03ool00?l0nY[ooooo
00Gooooo0_l0nYX01Ooo003oooooooooool0nY[oo`0000;ooooo00Co0?ZJoooooooo003oo`001?oo
ool01_oo003oooooo`3jV_oo003oooooo`3jVP;ooooo0ol0nYX01Ooo003oooooooooool0nY[oo`00
00Gooooo00Ko0?ZJool00?l0nY[oooooo`3jV_oo000mooooo`00@Oooool01?l0003oooooooooool0
nYX2ooooo`06ool00?ooooooooooool00?ooooooo`001?ooool2o`3jVPcooooo00Ko0?ZJoooooooo
ooooo`00ooooool0nYX3ooooo`05ool00?oooooo0?ZJooooool0nYX06?ooool2o`3jVP07ool00?l0
nY[oooooooooool0nY[oo`00o`3jVP0>ooooo`04o`3jV_ooooooooooo`3jVPKooooo00Ko0?ZJoooo
ool0nY[oo`00ooooool0nYX3ooooo`06o`3jV_oo003o0?ZJool00?l00?oo0?ZJ0oooool00ol0nY[o
o`00o`3jVP02ooooo`05o`3jV_ooooooooooo`00oooo00000oooool00ol0nY[oo`00ooooo`0Joooo
o`06o`3jV_oooooo0?ZJool00?oooooo0?ZJ0oooool2o`00027ooooo00Co0000oooooooooooo0000
0oooool2o`0000Cooooo00?oo`00ooooooooool00_oo0002ooooo`05o`3jV_ooooooooooo`00ool0
nYX01_ooool00ol0nY[oooooool00003o`3jVPCooooo00Go0?ZJooooooooooooooooool00004oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool0nYX01_ooool01Ol0nY[oooooo`3jV_l0nY[o
003o00Kooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00[ooooo00Co0?ZJool00?oooooo
003o1?ooool00ooo003oooooooooo`02ooooo`03ool00?l0nY[ooooo00Sooooo0_l0nYX6ooooo`04
o`3jV_l0003o0000o`0000Kooooo00Go0?ZJooooooooooooo`00o`3jVP0Iooooo`05ool00?oooooo
ooooooooool0nYX01_ooool00ol0nY[o0000o`00000Iooooo`;o00000oooool01?l0003ooooooooo
ool00003ooooo`;o00000oooool01ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX00oooool00ol0
0?ooo`00o`3jVP04ooooo`07o`3jV_ooooooo`00o`3jV_ooooooo`00o`3jVP04ooooo`;o0?ZJ00Ko
ooooool00?l0nY[oooooool00?l0nYX4ooooo`07o`3jV_oo003o003ooooooooo003oooooo`3jVP04
ooooo`04o`3jV_oo003o003oooooo`;o0?ZJ00?oo`00ooooooooool00oooool02?l0nY[ooooooooo
ooooooooo`00o`3jV_oooooo0?ZJ0ol00003ooooo`07o`3jV_oooooo003oool00?ooooooo`00o`3j
VP08ooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ0oooool01_l0nY[o003oool00?l00?oooooo
ool000?ooooo00?o0?ZJoooooooo00000_ooool00ooo003o0?ZJooooo`05ooooo`;o0?ZJ00Goo`00
ooooooooooooo`00o`00o`02ooooo`;o0?ZJ1Oooool3o`000003o`3jV_oo003o0?ZJ00?ooooo0_l0
nYX01_ooooooo`00oooooooooooo0?ZJool000Gooooo00Ko0?ZJool00?l0nY[o0?ZJo`000?oo000m
ooooo`00@Oooool03?l0003oooooooooool0nY[oooooool00?l00?ooo`00oooooooo003oooooool0
00?ooooo00?o0?ZJooooool0nYX03?ooool01_l0nY[oooooool00?oo003oooooo`3jVP?ooooo00?o
0?ZJool00?l0nYX00_l0nYXGooooo`?o000000Oo0?ZJooooooooooooooooo`3jV_oo003o0?ZJ00ko
oooo00Co0?ZJoooooooooooo0?ZJ1_ooool01Ol0nY[oooooo`3jV_oo003o0?ZJ00Cooooo00Ko0?ZJ
ool00?l0nY[oo`00o`00ool0nYX3ooooo`;o0?ZJ00Coo`00oooooooooooo0?ZJ0_ooool00ol00?oo
o`00ooooo`02ooooo`03o`3jV_oo003ooooo01[ooooo00Ko0?ZJooooool0nY[oo`00ooooool0nYX3
ooooo`;o00008Oooool01?l0003oooooooooool00003ooooo`;o00001?ooool01Ooo003oooooool0
0?l0nY[oo`0000;ooooo00Co0?ZJooooool00?oo003o0_l0nYX5ooooo`06o`3jV_ooooooo`00o`3j
V_oooooo0?ZJ1?ooool01_l0nY[ooooooooooooooooo0?ZJool000?ooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooo`3jVP06ooooo`05o`3jV_oooooo0?ZJo`3jV_l00?l01_ooool01_oo003o
oooooooooooooooo0?ZJool000;o0?ZJ2Oooool01?l0nY[oo`00ooooool00?l4ooooo`03ool00?oo
oooooooo00;ooooo00?oo`00o`3jV_ooool02?ooool2o`3jVPKooooo00Co0?ZJooooool0nY[o003o
1_ooool01Ol0nY[ooooooooooooo003o0?ZJ013ooooo0ol0nYX6ooooo`03ool00?l0nY[o0?ZJ00;o
0?ZJ1_ooool00ol0nY[o0000o`00000Kooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooo
ooooooooooooo`000004ooooo`07o`3jV_oo003oooooo`00ool0nY[oooooo`3jVP03ooooo`03o`00
oooo003o0?ZJ00Cooooo00Oo0?ZJoooooooo003o0?ZJoooooooo003o0?ZJ00Cooooo0_l0nYX01_oo
ooooo`00o`3jV_ooooooo`00o`3jVPCooooo00Oo0?ZJoooooooo003oooooool00?oooooo0?ZJ00Co
oooo00Oo0?ZJool00?l00?ooooooo`3jV_oo003o0?ZJ00Gooooo00So0?ZJooooooooooooooooool0
0?l0nY[oooooo`3jVP?o00000oooool01ol0nY[oooooo`00oooo003oooooool00?l0nYX02?ooool0
1_oo003o0?ZJooooool0nY[oo`00o`3jVP?ooooo00?o0?ZJo`00oooo00000_ooool00ooo003ooooo
ooooo`02ooooo`05o`3jV_oo003ooooooooooooo00001oooool2o`3jVP04ool00?ooooooooooool0
00?ooooo0_l0nYX5ooooo`?o000000?o003oool00?l0nYX00oooool2o`3jVP06oooooooo003ooooo
oooooooo003o0?ZJ1Oooool01_l0nY[oo`00ooooool0nY[o003oool003gooooo0011ooooo`;o0000
00[o0?ZJooooooooooooo`00o`00oooo003oooooool00?ooooooo`000oooool00ol0nY[oooooo`3j
VP0;ooooo`07o`3jV_ooooooooooool00?l00?ooooooo`3jVP03ooooo`05o`3jV_oo003ooooooooo
ool0nYX05oooool3o`000008o`3jV_ooooooooooooooool0nY[oo`00o`00ool0nYX=ooooo`04o`3j
V_ooooooooooo`3jVPKooooo00Go0?ZJoooooooo003oooooo`3jVP04ooooo`?o000000?o003ooooo
ool0nYX00oooool2o`3jVP03ool00?l0nY[o0?ZJ00?ooooo00?o003oool00?ooool00_ooool00ol0
nY[oo`00ooooo`0Iooooo`06o`3jV_l0003o0000o`000?l00?oo0?ZJ1?ooool2o`3jVR7ooooo00Co
0000oooooooooooo00000oooool00ol0003o0?ZJooooo`03ooooo`05ool00?ooooooo`00o`3jV_oo
00000_ooool01?l0nY[oooooo`00ool00?l4o`3jVP?ooooo00Go0?ZJoooooooo003o0?ZJooooo`02
o`3jVP?ooooo00Ko0?ZJooooooooooooooooo`3jV_oo0003ooooo`03o`3jV_oooooooooo00;ooooo
00Co0?ZJoooooooooooo0?ZJ1_ooool01?l0nY[oooooo`3jV_l0nYX2ool000Gooooo00Ooo`00oooo
ooooooooooooo`3jV_oo003o003o00;o0?ZJ2?ooool01?l0nY[oo`00o`3jV_l00?l4ooooo`07ool0
0?ooooooooooooooool0nY[oo`00o`3jVP09ooooo`;o0?ZJ1_ooool01?l0nY[oooooo`3jV_l00?l6
ooooo`05o`3jV_ooooooooooo`3jV_oo00003oooool2o`3jVP03ooooool0nY[o0?ZJ00Gooooo00?o
o`00o`3jV_ooool00_l0nYX6ooooo`03o`3jV_ooooooo`0001Oooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool01ol0nY[o
o`00ooooool00?oo0?ZJooooool0nYX00oooool00ol00?ooo`00o`3jVP04ooooo`06o`3jV_oooooo
o`00o`3jV_ooooooo`001_ooool00ol0nY[oooooool00002o`3jVP03ool00?l0nY[ooooo00?ooooo
00Oo0?ZJoooooooo003oooooool00?oooooo0?ZJ00Cooooo00Oo0?ZJool00?l00?ooooooo`3jV_oo
003o0?ZJ00Gooooo00[o0?ZJooooooooooooooooool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool0
1ol0nY[ooooooooooooo003oooooool00?l0nYX02?ooool01_oo003o0?ZJooooool0nY[oo`00o`3j
VPCooooo00Go0?ZJool00?ooooooooooool00004ooooo`05o`3jV_oo003ooooooooooooo00001ooo
ool2o`3jVP04ool00?ooooooooooool000?ooooo0_l0nYX4ooooo`04o`3jV_l0003o0000o`0000;o
o`0000?o0?ZJooooooooool00_ooool00ol0nY[oooooool00002ooooo`03ool00?l0nY[ooooo00Co
oooo00Ko0?ZJool00?oooooo0?ZJo`00oooo000mooooo`00@Oooool00ol0003oooooo`3jVP02oooo
o`07ool00?l00?ooo`00oooooooo003oooooool00003ooooo`03o`3jV_oooooo0?ZJ00_ooooo00Oo
0?ZJooooooooooooo`00o`00oooooooo0?ZJ00?ooooo00Go0?ZJool00?ooooooooooo`3jVP0Goooo
o`?o000000?o0?ZJooooooooool00_ooool00ol0nY[oo`00o`3jVP0<ooooo`05o`3jV_oooooooooo
ooooool0nYX01_ooool01?l0nY[oooooool00?l0nYX5ooooo`?o000000?oooooo`3jV_ooool00ooo
ool2o`3jVP03ool00?l00?oooooo00;ooooo0_l00?l01_oo003ooooooooooooooooo0?ZJool001[o
oooo00Ko0?ZJo`000?l0003o0000ooooool0nYX4ooooo`;o0?ZJ8_ooool2o`0000Cooooo00?o0000
o`3jV_ooool00oooool01Ooo003oooooool00?l0nY[oo`0000;ooooo00?o0?ZJooooool00?l00ol0
00000ooooooo0?ZJo`3jVP02ooooo`03o`3jV_ooooooo`0000?ooooo00Go0?ZJoooooooooooooooo
o`3jVP03ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJooooooooool00_ooool01?l0nY[ooooo
ooooool0nYX6ooooo`03o`3jV_ooooooo`0000Coo`001?ooool02Ooo003ooooooooooooooooo0?ZJ
ool00?l00?ooooooo`3jVP07ooooo`03o`3jV_oo003o0?ZJ00;o0?ZJ1?ooool01ooo003ooooooooo
oooooooo0?ZJool00?l0nYX02Oooool2o`3jVPKooooo00Co0?ZJooooool0nY[o0?ZJ1_ooool01Ol0
nY[oooooooooool0nY[oo`0000Wooooo0ol0nYX3ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?oo
ool01Ooo003o0?ZJoooooooooooo0?ZJ00Kooooo00?o0?ZJooooool0nYX06?ooool3o`0000Cooooo
0_l00004ooooo`;o00000oooool01ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX00oooool00ooo
003oooooo`3jVP04ooooo`06o`3jV_ooooooo`00o`3jV_ooooooo`001_ooool00ol0nY[oooooool0
0002o`3jVP03ool00?l0nY[ooooo00Cooooo00Ko0?ZJool00?l00?ooo`00ooooool0nYX4ooooo`07
o`3jV_oo003o003oooooool0nY[oo`00o`3jVP05ooooo`0:o`3jV_oooooooooooooooooo003o0?ZJ
ooooool0nY[oo`00o`3jVPCooooo0_l0nYX01Oooooooo`00oooooooo003o0?ZJ00Sooooo00Koo`00
o`3jV_oooooo0?ZJool00?l0nYX4ooooo`05o`3jV_oo003ooooooooooooo00001?ooool01Ol0nY[o
o`00ooooooooooooo`0000Oooooo00Wo0?ZJoooooooo003oooooo`3jV_oo003oooooo`3jV_ooool0
0_l0nYX3ooooo`;o0?ZJ00Koooooo`3jV_oo003oo`00ooooool0nYX6ooooo`05ool00?oooooooooo
ool00?l0nYX01Oooool01_l0nY[oooooool00?l0nY[o003oool003gooooo0011ooooo`03o`000?oo
oooo0?ZJ00;ooooo00Ooo`00o`00oooo003oooooool00?ooooooo`0000?ooooo00?o0?ZJooooool0
nYX02oooool01ol0nY[oooooool00?oo003o003oooooool0nYX00oooool01Ol0nY[oo`00oooooooo
oooo0?ZJ01Kooooo0_l0nYX00ol00?ooo`00o`3jVP04ooooo`03o`3jV_oo003o0?ZJ00cooooo00Go
0?ZJooooooooooooooooo`3jVP06ooooo`04o`3jV_l0003o0000o`0000Gooooo0ol00002o`3jVPCo
oooo0_l0nYX00ooo003o003oooooo`02ooooo`03o`00oooo003oo`0000?ooooo00?o0?ZJool00?oo
ool06Oooool01Ol0nY[o0000o`000?l0003o0?ZJ00Gooooo0_l0nYXXooooo`03o`000?l0nY[ooooo
00?ooooo00Goo`00oooooooo003o0?ZJool00002ooooo`03o`3jV_l00?oooooo00?o00000_ooool0
1_l0nY[oooooooooool0nY[oooooool000?ooooo0_l0nYX2ooooo`05o`3jV_ooooooooooooooool0
nYX01Ooo0004ooooo`04o`3jV_ooooooooooo`3jVPKooooo00Co0?ZJoooooooo003oo`000_ooool2
ool000;ooooo00?oo`00o`3jV_ooool00_ooool01Ol0nY[oooooool00?oooooo0?ZJ00Oooooo00Go
0?ZJool00?l0nY[oooooo`3jVP02o`00o`;ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ
00Wooooo0_l0nYX6ooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ1Oooool01Ol0nY[oooooooooool0nY[o
o`0000Wooooo00Co0?ZJooooool0nY[o0?ZJ0_ooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_oo
oooooooo00;ooooo00Goo`00o`3jV_ooooooooooo`3jVP06ooooo`03o`3jV_oooooo0?ZJ02Gooooo
00?o0000ooooooooool00_ooool01ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX00oooool00ooo
003oooooo`3jVP04ooooo`06o`3jV_ooooooo`00o`3jV_ooooooo`001_ooool00ol0nY[oooooool0
0002o`3jVP03ool00?l0nY[ooooo00Cooooo00Go0?ZJool00?oo003oooooo`3jVP05ooooo`07o`3j
V_oo003o003oooooool0nY[oo`00o`3jVP05ooooo`0:o`3jV_oooooooooooooooooo003o0?ZJoooo
ool0nY[oo`00o`3jVPGooooo00Ko0?ZJoooooooo003oooooool00?l0nYX8ooooo`05ool00?l0nY[o
ooooool00?l0nYX01Oooool01Ol0nY[oooooool00?oo003o0?ZJ00Cooooo00?o0?ZJool00?l00000
0_l00007ooooo`06o`3jV_ooooooo`00ooooool0nY[oo`001?l0nYX01Ooooooo0?ZJoooooooooooo
0?ZJ00?ooooo0_oo0002o`3jVPKooooo00Goo`00o`3jV_ooooooo`00o`3jVP06ooooo`05o`3jV_oo
003oooooo`00oooo0000?Oooool0047ooooo00co0000ooooool0nY[oooooool00?l00?ooooooool0
0?ooooooo`00oooooooo0003ooooo`03o`3jV_oooooo0?ZJ00_ooooo00Co0?ZJoooooooo003o003o
0_ooool01_l0nY[ooooooooooooooooo0?ZJool000;ooooo00?o0?ZJooooooooool05?ooool01?l0
nY[o003oo`00oooo0005ooooo`03o`3jV_oo003o0?ZJ00cooooo00Go0?ZJooooooooooooooooo`3j
VP06ooooo`04o`3jV_l0003o0000o`0000Kooooo0ol0nYX5ooooo`;o0?ZJ00?oo`00o`00ooooool0
0_ooool00ol00?ooo`00o`3jVP03ooooo`03o`3jV_oo003ooooo01Wooooo00?o0?ZJoooooooo0000
0_l0nYX5ooooo`;o0?ZJ:?ooool00ol0003oooooo`3jVP03ooooo`05ool00?ooooooo`00o`3jV_oo
00000_ooool00ol0nY[o003oooooo`03o`0000;ooooo00Ko0?ZJoooooooooooo0?ZJoooooooo0004
ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJooooooooool00_ooool00ooo003ooooooooo
o`02ooooo`03o`3jV_oooooo003o00?o0?ZJ1?ooool01?l0nY[oooooool00?oo0003ooooo`05ool0
0?ooooooooooool00?l0nYX00oooool01Ol0nY[oooooool00?oooooo0?ZJ00Oooooo00Co0?ZJool0
0?l0nY[ooooo0_l0nYX2o`00o`03oooooooo003ooooo00;ooooo00?o0?ZJool00?l0nYX02_ooool0
0ol0nY[oooooooooo`05ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?ooool01Ol0nY[oooooooooool0
nY[oo`0000Sooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`06o`3jV_l00?oo003oo`00oooo
oooo0?ZJ0oooool00ol0nY[oo`00o`3jVP09ooooo`03o`3jV_oooooo0?ZJ02Gooooo00?o0000oooo
ooooool00_ooool01ol0nY[oo`00ooooool00?oo0?ZJooooool0nYX00_ooool2ool00003ooooool0
nY[ooooo00?ooooo00Ko0?ZJoooooooo003o0?ZJoooooooo0006ooooo`03o`3jV_ooooooo`0000;o
0?ZJ00?oo`00o`3jV_ooool01?ooool01Ol0nY[oooooool00?oooooo0?ZJ00Gooooo00Ko0?ZJool0
0?l00?ooooooo`3jV_oo0006ooooo`0:o`3jV_oooooooooooooooooo003o0?ZJooooool0nY[oo`00
o`3jVPGooooo00Go0?ZJoooooooo003oooooool00009ooooo`05ool00?l0nY[oooooool00?l0nYX0
1Oooool01Ol0nY[oooooool00?oo003o0?ZJ00Cooooo00?o0?ZJool00?l000000_l00009ooooo`05
ool00?oooooo0?ZJool00?l0nYX01?ooool01?l0nY[oooooo`3jV_l0nYX3ooooo`03o`3jV_oooooo
0?ZJ00Oooooo00Goo`00o`3jV_l0nY[oo`00o`3jVP06ooooo`05o`3jV_oo003oooooool00?l0nYX0
?Oooool0047ooooo00co0000o`3jV_ooooooooooool00?l00?ooooooool00?ooooooo`00oooooooo
0003ooooo`03o`3jV_oooooo0?ZJ00_ooooo00?o0?ZJool00?oo00000oooool01_l0nY[ooooooooo
oooooooo0?ZJool000;ooooo00?o0?ZJooooooooool04oooool2o`3jVP;o003o00?oo`00oooooooo
ool00oooool00ol0nY[oo`00o`3jVP0;ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool01?ooool01?l0nY[o0000o`000?l00006ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX01?oo
003o003oooooooooool2ool00003o`3jV_oooooooooo00;ooooo00?oo`00o`3jV_ooool06?ooool0
1?l0nY[oooooool00?l0nYX6ooooo`;o0?ZJ:?ooool00ol0003oooooo`3jVP03ooooo`05ool00?oo
ooooo`00o`3jV_oo00000_ooool01Ol0nY[o003ooooooooo003o0?ZJ00;oo`000_ooool01Ol0nY[o
ooooo`3jV_ooooooo`0000Cooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`02
ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooool000000_l000000ol0nY[oooooooooo`02
ooooo`04o`3jV_oo003oo`00ool000?ooooo0_oo00000oooooooo`00o`3jVP04ooooo`05o`3jV_oo
003oooooo`3jV_ooool00_l0nYX4ooooo`03o`3jV_oo003ooooo00;ooooo00Go0?ZJo`00ool00?oo
ooooool00003ooooo`03o`3jV_oo003o0?ZJ01;ooooo0_l0nYX2ooooo`;o0?ZJ0oooool01_l0nY[o
ooooooooool0nY[oo`00ooooo`?o0?ZJ1?ooool02Ol0nY[ooooooooooooooooo0?ZJooooool0nY[o
003oooooo`03o`00o`;o0?ZJ0_ooool00ol0nY[oo`00o`3jVP09ooooo`03o`3jV_oooooo0?ZJ02Go
oooo00?o0000ooooooooool00_ooool03Ol0nY[oo`00ooooool00?oo0?ZJooooool0nY[o003ooooo
oooo003o003oooooool0nYX01?ooool01_l0nY[oooooool00?oooooo0?ZJool000Kooooo00?o0?ZJ
oooooooo00000_l0nYX00ooo003o0?ZJooooo`04ooooo`05o`3jV_ooooooooooooooool0nYX01Ooo
ool01?l0nY[oooooool00?l00?l2ool000[ooooo00Goo`00o`3jV_ooooooo`00o`3jVP06ooooo`05
o`3jV_ooooooo`00o`3jV_oo00002Oooool01Ooo003o0?ZJoooooooo003o0?ZJ00Gooooo00Go0?ZJ
oooooooo003oo`00o`3jVP04ooooo`03o`3jV_oo003o000000;o00002Oooool01?oo003oooooo`3j
V_oo0005ooooo`?o0?ZJ1?ooool00ol0nY[oooooo`3jVP07ooooo`05ool00?l0nY[o0?ZJool00?l0
nYX01_ooool01Ol0nY[oo`00oooooooo003o0?ZJ03gooooo0011ooooo`03o`000?l0nY[ooooo00;o
o`0000So003ooooooooo003oooooool00?ooooooo`00o`3jVP;ooooo00?o0?ZJooooool0nYX02ooo
ool00ol0nY[oo`00ooooo`03ooooo`06o`3jV_ooooooooooooooool0nY[oo`000_ooool00ol0nY[o
ooooooooo`0Cooooo`05o`3jV_l00?oooooooooooooo00001Oooool00ol0nY[oo`00o`3jVP0;oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oo`00o`3jVP0@oooo
o`;o0?ZJ00?oo`00o`00ooooool00_oo00000ooooooo0?ZJooooo`03ooooo`03ool00?l0nY[ooooo
01Sooooo00Co0?ZJool00?l00?oo0?ZJ1_ooool2o`3jVRSooooo0_l000000ol0nY[oooooooooo`02
ooooo`;oo`0000So0?ZJool00?ooooooooooo`3jV_l00?ooo`00ooooo`;o0?ZJ00Soo`00oooooooo
oooo0?ZJooooool0nY[oooooool000Gooooo00?o0?ZJooooool0nYX00oooool00ol0nY[ooooooooo
o`02ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJool00?l000000_l00002o`3jVP?ooooo00?o
0?ZJool00?oo00000ol0nYX2ooooo`04ool00?ooooooo`00o`3jVPCooooo00?o0?ZJool00?ooool0
1Ol0nYX2ooooo`;o0?ZJ00Woo`00ooooooooooooooooo`3jV_oooooo003ooooooooo00000oooool0
0ol0nY[oo`00o`3jVP0Booooo`;o0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Go
0?ZJool00?l0nY[o0?ZJooooo`02o`3jVP;ooooo00?o0?ZJooooooooool00_ooool01?l0nY[ooooo
o`3jV_l00?l2ool00004ooooool00?ooooooo`3jVP;ooooo00?o0?ZJool00?l0nYX02Oooool00ol0
nY[oooooo`3jVP0Uooooo`;o00000oooool03Ol0nY[oo`00ooooool00?oo0?ZJooooool0nY[o003o
oooooooo003o003oooooool0nYX01?ooool01_l0nY[oooooool00?oooooo0?ZJool000Kooooo00?o
0?ZJoooooooo00000_l0nYX00ooo003oooooooooo`04ooooo`05o`3jV_ooooooooooooooool0nYX0
1Oooool00ol0nY[oooooool00003ool000[ooooo00Goo`00o`3jV_l0nY[oo`00o`3jVP06ooooo`05
o`3jV_ooooooo`00o`3jV_oo00002Oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Gooooo00Go0?ZJ
ooooooooooooooooo`3jVP04ooooo`05o`3jV_ooooooo`00ool00?l0nYX02Oooool01?oo003ooooo
o`3jV_oo000<ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Goo`00o`3jV_l0nY[oo`00o`3jVP06oooo
o`05o`3jV_oo003oooooool00?l0nYX0?Oooool003_ooooo0_l00004ooooo`0=o`3jV_oooooo003o
ool00?oooooo003ooooooooo003oooooool00?ooooooo`00o`3jVP02ooooo`03o`3jV_oooooo0?ZJ
00[ooooo00?o0?ZJool00?oo00001?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;oo`0000?ooooo
o`3jV_ooool04oooool2o`3jVP?ooooo00?oo`00ooooooooool00oooool00ol0nY[oo`00o`3jVP0;
ooooo`04o`3jV_ooooooooooooooo`;oo`001Oooool01?l0nY[oooooool00?l0nYXAooooo`03o`3j
V_ooooooo`0000;oo`000_ooool00ol0nY[oooooooooo`02ooooo`03ool00?l0nY[ooooo01Sooooo
00Co0?ZJool00?oooooo0?ZJ1_ooool2o`3jVRSooooo00?o0000ooooool0nYX01?ooool2ool00008
o`3jV_oo003oooooooooool0nY[o003oool00?ooool2o`3jVP;oo`0000Coooooo`3jV_oooooo0?ZJ
0ol00004ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool00_ooool00ooo003ooooo
ooooo`02ooooo`03o`3jV_oo003o000000;o000000?o003oo`3jV_ooool00_ooool01_l0nY[oo`00
ool00?l0nY[oooooo`3jVP;ooooo00Coo`00oooooooo003o0?ZJ1?ooool00ol0nY[oo`00ooooo`02
o`3jVP08o`00oooooooo0?ZJo`3jV_oooooo0?ZJoooooooo0004ooooo`04o`3jV_l00?oo003oool0
00?ooooo00?o0?ZJool00?l0nYX04_ooool2o`3jVP?ooooo00Go0?ZJooooooooooooooooo`3jVP02
ooooo`03o`3jV_oo003ooooo00?ooooo00Go0?ZJoooooooooooo0?ZJo`00o`03ooooo`05o`3jV_oo
oooo0?ZJool00?ooool00_oo00000ol00?ooooooo`3jVP02ooooo`03o`3jV_oo003ooooo00Wooooo
00?o0?ZJooooool0nYX09Oooool00ol0003oooooooooo`02ooooo`08o`3jV_oo003oooooo`00ool0
nY[oooooo`3jV_l00?l2ool00003o`00oooooooo0?ZJ00Gooooo00Go0?ZJo`00oooo003o0?ZJool0
0006ooooo`06o`3jV_oooooo0?ZJool00?l0nY[oo`001_ooool01Ol0nY[ooooooooooooooooo0?ZJ
00Gooooo00?o0?ZJoooooooo00000_oo00000ol0nY[oooooooooo`08ooooo`05ool00?l0nY[o0?ZJ
ool00?l0nYX01_ooool01Ol0nY[oooooool00?l0nY[oo`0000Wooooo00Goo`00o`3jV_l0nY[oo`00
o`3jVP05ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01Ol0nY[oooooool00?oo003o0?ZJ
00Wooooo00Coo`00ooooool0nY[oo`003?ooool2o`3jVPSooooo00Coo`00o`3jV_l0nY[oo`001ooo
ool01Ol0nY[oo`00oooooooo003o0?ZJ03gooooo000jooooo`04o`000?ooooooooooo`0000?ooooo
0_l00002ool000;o003o00Ooooooool00?ooooooo`00oooooooo003o0?ZJ00;ooooo00?o0?ZJoooo
ool0nYX02_ooool00ol0nY[oo`00o`00o`04ooooo`09o`3jV_ooooooooooooooool0nY[o003oool0
0?oooooo0?ZJ01Cooooo00?o0?ZJo`00ooooool00_ooool00ooo003oooooooooo`03ooooo`03o`3j
V_oo003o0?ZJ00_ooooo00?o0?ZJoooooooo00000ooo0005ooooo`04o`3jV_oo003o003oo`3jVQ7o
oooo00?o0?ZJooooooooool00_l00?l2ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00o`3jV_oo
ool06?ooool01?l0nY[oo`00ooooool0nYX6ooooo`;o0?ZJ:?ooool00ol0003oooooo`3jVP04oooo
o`;oo`0000Ko0?ZJool00?ooooooooooo`3jV_oo0002ooooo`;o0?ZJ00Ko003oool00?oooooo0?ZJ
ooooool0nYX3o`0000Cooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`02ooooo`09
ool00?ooooooooooooooool0nY[oooooool00?oooooo0?ZJ00;oo`0000Go0?ZJoooooooooooooooo
o`3jVP02ool00003o`3jV_oooooo0?ZJ00;ooooo0ooo00000ol0nY[oooooooooo`02ooooo`03o`3j
V_oo003o003o00;o0?ZJ00So003ooooooooooooo0?ZJooooool0nY[oooooool000Cooooo00Co0?ZJ
ooooool00?ooo`000oooool00ol0nY[oo`00o`3jVP0Booooo`;o0?ZJ0oooool2o`3jVP;ooooo00Go
0?ZJoooooooooooo0?ZJool00004ooooo`04o`3jV_ooooooooooo`3jVP;o003o0_ooool01?l0nY[o
ooooo`3jV_oo0002ooooo`04ool00?l00?ooooooo`3jVP;ooooo00?o0?ZJool00?ooool02Oooool0
0ol0nY[oooooo`3jVP0Uooooo`03o`000?oooooooooo00;ooooo00Co0?ZJool00?oooooo003o0_l0
nYX3ool00004ooooool00?ooooooo`3jVPGooooo00Go0?ZJoooooooo003o0?ZJool00006ooooo`06
o`3jV_oooooo0?ZJool00?ooooooo`001_ooool01?l0nY[oooooooooool0nYX6ooooo`03o`3jV_oo
ooooo`0000?o00002_ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Oooooo00Co0?ZJool00?oo003o
0?ZJ2Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00Gooooo00Go0?ZJooooooooooooooooo`3jVP04
ooooo`05o`3jV_ooooooo`00ool00?l0nYX02Oooool01?oo003oooooool00?l0nYXFooooo`04ool0
0?l0nY[o0?ZJool000Oooooo00Go0?ZJool00?ooooooo`00o`3jVP0mooooo`00>_ooool01?l0003o
ooooooooool00003ooooo`;o00000ol00?l2ooooo`06ool00?ooooooo`00oooooooo003o0?ZJ0_oo
ool00ol0nY[oooooo`3jVP0:ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJooooooooool00ooo
ool01?l0nY[oo`00ooooool0nYXCooooo`;o0?ZJ1?ooool00ooo003oooooooooo`03ooooo`03o`3j
V_oo003o0?ZJ00[ooooo00Co0?ZJoooooooo003oo`000_ooool00ooo003oooooooooo`03ooooo`04
o`3jV_oo003o003oo`3jVQ;ooooo00?o0?ZJooooool00?l00oooool00ol0nY[oooooooooo`02oooo
o`03ool00?l0nY[ooooo01Sooooo00?o0?ZJool00?l0nYX01oooool00ol0003o0?ZJooooo`0Woooo
o`;o000000?o0?ZJooooooooool00_ooool2ool00006o`3jV_oo003oooooooooool0nY[oo`000_oo
ool3o`3jVP05ool00?oooooo0?ZJooooool0nYX00ol00005ooooo`;o0?ZJ1?ooool01Ol0nY[ooooo
ooooooooooooo`0000?ooooo00Co0?ZJoooooooo003ooooo0_l0nYX00ooo003o003oo`3jVP02oooo
o`03o`3jV_oo003oo`0000?ooooo00?o0?ZJooooooooool00_oo00000ol0nY[oooooooooo`02oooo
o`05o`3jV_oo003o003oo`3jV_ooool00_l00?l01_oooooo0?ZJo`3jV_l0nY[oooooool000Cooooo
00Co0?ZJooooool00?ooo`000oooool00ol0nY[oo`00ooooo`0Hooooo`04o`3jV_ooooooooooo`3j
VP;ooooo00?o0?ZJool00?l00?l00oooool00ol0nY[oooooo`3jVP03o`00o`;ooooo00Co0?ZJoooo
oooo003oo`000_ooool2ool00006o`00ool0nY[oooooooooool0nY[oo`002oooool2o`3jVRGooooo
0_l00003ooooo`04o`3jV_oo003oooooo`00o`;o0?ZJ00Coo`00o`00oooooooo003o0_ooool00ol0
nY[oooooooooo`03ooooo`05o`3jV_ooooooo`00ool00?l0nYX01_ooool00ol0nY[oooooo`3jVP02
ool00003o`3jV_oooooooooo00Cooooo00Co0?ZJoooooooooooo0?ZJ1_ooool00ol0nY[oooooool0
0003o`0000[ooooo00Go0?ZJool00?l0nY[oo`00o`3jVP07ooooo`04o`3jV_oo003oo`00o`3jVPWo
oooo00Go0?ZJool00?l0nY[oo`00o`3jVP05ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool0
1Ol0nY[oooooool00?oo003o0?ZJ00Wooooo00Coo`00oooooooo003o0?ZJ5_ooool01?oo003o0?ZJ
o`3jV_oo0007ooooo`05o`3jV_oo003o003oool00?l0nYX0?Oooool003[ooooo00Co0000oooooooo
oooo00000oooool2o`0000;o003o0oooool01_oo003oooooool00?ooooooo`00o`3jVP;ooooo00?o
0?ZJooooool0nYX02_ooool00ol0nY[oo`00ooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co
0?ZJool00?oo003o0?ZJ1oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_l00?oooooo00?ooooo
00?oo`00ooooooooool00oooool00ol0nY[oo`00o`3jVP0:ooooo`03o`3jV_ooooooo`0000?ooooo
00?oo`00ooooooooool00oooool01?l0nY[oo`00o`00ool0nYXBooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool00_ooool00ooo003o0?ZJooooo`0Gooooo`04o`3jV_oo003o003oo`3j
VPSooooo00?o0?ZJooooooooool09_ooool01?l0003oooooooooool0nYX3ooooo`;oo`0000Ko0?ZJ
ool00?ooooooooooo`3jV_oo0002ooooo`0:o`3jV_oooooo0?ZJool00?oooooo0?ZJooooool0nY[o
ooooool000Kooooo0_l0nYX4ooooo`05o`3jV_l00?oooooooooooooo00000oooool01?l0nY[oo`00
ool00?ooool2o`3jVP06ool00?l00?oo0?ZJooooool0nY[ooooo0ol00002ooooo`03o`3jV_oooooo
oooo00;oo`0000?o0?ZJooooooooool00_ooool00ol0nY[oo`00o`000002o`000003ool00?l00?oo
003o00Cooooo00?oo`00ooooooooool00_ooool01?l0nY[oooooo`00oooo0003ooooo`03o`3jV_oo
003ooooo01Sooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ooo003o003oooooo`02ooooo`05o`3j
V_oooooo0?ZJo`00ooooool00_oo00001?oooooo0?ZJoooooooo0004ooooo`03ool00?l00?oo0?ZJ
00;ooooo00?o0?ZJool00?ooool02_ooool2o`3jVRGooooo00?o0000ooooooooool00_ooool01?l0
nY[oo`00ooooool00?l2o`3jVP06ool00?l00?ooooooo`00oooooooo0?ZJ1_ooool01Ol0nY[ooooo
ool00?oo003o0?ZJ00Kooooo00?o0?ZJooooool0nYX00_oo00000ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooo0?ZJ00Kooooo00?o0?ZJooooooooool00ol0000:ooooo`05o`3jV_oo003o0?ZJool0
0?l0nYX01oooool01?l0nY[oo`00ool00?l0nYX9ooooo`05o`3jV_oo003o0?ZJool00?l0nYX01Ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo00Go0?ZJooooool00?ooooooo`3jVP09ooooo`04
ool00?ooooooo`00o`3jVQKooooo00Coo`00o`3jV_l0nY[oo`001oooool01Ol0nY[oo`00o`00oooo
003o0?ZJ03gooooo000jooooo`04o`000?ooooooooooo`0000?ooooo00?o0000o`3jV_ooool01?oo
ool01_oo003oooooool00?ooooooo`00o`3jVP;ooooo00?o0?ZJooooool0nYX01?l0nYX6ooooo`03
o`3jV_oo003ooooo00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?l0nYX7oooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJo`00ooooool00oooool00ooo003oooooooooo`03oooo
o`03o`3jV_oo003o0?ZJ00[ooooo00Co0?ZJool00?oo003o003o0_ooool00ooo003oooooooooo`03
ooooo`04o`3jV_oo003o003oo`3jVQ;ooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`02ooooo`03ool00?l0nY[o0?ZJ01Oooooo00Co0?ZJool00?oooooo0?ZJ2?ooool00ol0nY[ooooo
ooooo`0Vooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo00001_l0nY[oo`00oooooooooooo0?ZJ
ool000;ooooo00Co0?ZJooooool0nY[oo`000_ooool2o`3jVP03ool00?l0nY[ooooo00Kooooo00?o
0?ZJooooooooool00_ooool01Ol0nY[o003oooooool00?ooo`0000?ooooo00Co0?ZJool00?oooooo
oooo0_l0nYX01_oo003o003oo`3jV_oooooo0?ZJooooo`?o00000_ooool00ol0nY[oooooooooo`02
ool00003o`3jV_oooooooooo00;ooooo00?o0?ZJooooool000000_l00002ool00003o`00oooooooo
oooo00;ooooo00?oo`00ooooooooool00oooool00ol0nY[o003oool00003ooooo`03o`3jV_oo003o
oooo01Sooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ooo003o003oooooo`02ooooo`06o`3jV_l0
0?oo0?ZJoooooooo003o003o0_oo0002o`3jVP03ool00?oooooooooo00;ooooo00?oo`00o`00ool0
nYX00_ooool00ol0nY[oo`00ooooo`0:ooooo`;o0?ZJ9Oooool00ol0003oooooooooo`02ooooo`04
o`3jV_oo003oooooooooo`;o0?ZJ00Koo`00ooooool00?oo003oooooool0nYX6ooooo`05o`3jV_oo
ooooo`00ool00?l0nYX01_ooool00ol0nY[oooooo`3jVP02ool00003o`3jV_oooooooooo00Gooooo
00?o0?ZJooooool0nYX01_ooool01Ol0nY[ooooooooooooooooo0?ZJ00_ooooo00Go0?ZJool00?l0
nY[oo`00o`3jVP07ooooo`?o000000?o0?ZJooooooooool01oooool01?l0nY[oo`00o`3jV_oo0007
ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`04ool0
0?ooooooo`00o`3jVQKooooo00Coo`00o`3jV_l0nY[oo`001oooool01Ol0nY[oo`00ool00?oooooo
0?ZJ03gooooo000jooooo`04o`000?ooooooooooo`0000?ooooo00?o0000o`3jV_ooool01?ooool0
2?oo003oooooool00?ooooooo`00o`3jV_oooooo0?ZJ0_ooool2o`3jVP;ooooo0_l0nYX3ooooo`03
o`3jV_ooooooo`0000Gooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo0007oooo
o`03o`3jV_oooooooooo00Kooooo00Go0?ZJoooooooooooo0?ZJo`00o`04ooooo`03ool00?oooooo
oooo00?ooooo00?o0?ZJool00?l0nYX02_ooool01ol0nY[oo`00ooooool00?ooooooo`00oooo0000
1Oooool01?l0nY[oo`00o`00ool0nYXBooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`02ooooo`03
ool00?l00?oo0?ZJ00oooooo0ol0nYX5ooooo`04o`3jV_oo003oooooo`3jVPSooooo00?o0000oooo
ooooool09_ooool01?l0003oooooooooool0nYX3ooooo`;oo`0000Ko0?ZJool00?ooooooooooo`3j
V_oo0002ooooo`06o`3jV_oooooo0?ZJoooooooo003ooooo0_l0nYX00ooo003o0?ZJooooo`0;oooo
o`?o0?ZJ0ol00002ooooo`04o`3jV_oo003oooooooooo`?o0?ZJ00Goo`00o`3jV_oooooo0?ZJoooo
o`03o`0000;ooooo00Ko0?ZJooooooooooooooooool00?l0nYX4ooooo`03o`3jV_oooooo000000;o
000000?oooooool00?l00?l00_ooool3o`0000Gooooo00Co0?ZJo`000?l0003o00000_ooool00ol0
nY[oo`00ooooo`0Hooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?oo`00o`00oooo00000_oo0002
o`3jVP05oooooooo003oo`00o`00ooooool00_oo00001?l0nY[oo`00o`3jV_l0nYX2ooooo`;oo`00
00Go0?ZJoooooooooooo0?ZJool0000<ooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool00_ooool01?l0nY[oo`00ooooooooool2o`3jVP06ool00?oooooo003oo`00oooooooo0?ZJ1_oo
ool01?l0nY[oooooool00?oo0007ooooo`03o`3jV_oooooo0?ZJ00;oo`0000?o0?ZJooooooooool0
1Oooool2o`3jVPOooooo00Go0?ZJooooooooooooooooo`3jVP0;ooooo`05o`3jV_oo003o0?ZJool0
0?l0nYX01oooool3o`0000[ooooo00Co0?ZJool00?l0nY[oo`001oooool01?l0nY[oooooooooool0
nYX4ooooo`05o`3jV_ooooooooooooooool0nYX02Oooool01?oo003oooooool00?l0nYXFooooo`04
o`3jV_oo003oo`00o`3jVPOooooo00Go0?ZJo`00oooo003oooooo`3jVP0mooooo`00>oooool2o`00
00Cooooo0_l000000ol0nY[oooooooooo`02ooooo`08ool00?ooooooo`00oooooooo003o0?ZJoooo
ool0nYX2ooooo`;o0?ZJ0oooool02Ol0nY[ooooooooooooooooo0?ZJoooooooo003oooooo`3jVP03
ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJooooooooooooo`001_ooool2o`3jVPSooooo00Co
0?ZJoooooooooooo0?ZJ1Oooool00ooo003oooooooooo`03ooooo`03o`3jV_ooooooo`0000[ooooo
00?o0?ZJool00?l00?l00ol00?l00ooo003oooooooooo`03ooooo`03o`3jV_oo003o0?ZJ01Cooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo003o0?ZJ00oooooo
00?o0?ZJooooool0nYX01Oooool01?l0nY[oo`00ooooool0nYX8ooooo`03o`000?oooooooooo02Ko
oooo0_l000000ooooooo0?ZJooooo`02ooooo`;oo`0000Go0?ZJool00?oooooo0?ZJool00003oooo
o`06o`3jV_oooooo0?ZJoooooooo003ooooo0_l0nYX00ooo003o0?ZJooooo`0;ooooo`;o003o00Co
0?ZJo`000?l0003o00000_ooool02Ol0nY[oo`00oooooooooooo0?ZJooooool0nY[oo`00o`00o`02
o`3jVP03oooooooo003o0?ZJ00Cooooo00Go0?ZJooooooooooooo`00o`3jVP04ooooo`03o`3jV_oo
oooo003o00;o0?ZJ0_ooool00ooo003oooooooooo`03o`0000Gooooo00Co0?ZJo`000?l0003o0000
0_ooool00ol0nY[oo`00ooooo`0Iooooo`03o`3jV_oooooo0?ZJ00?ooooo00Coo`00o`00oooo003o
oooo0_oo00001Ol0nY[oooooool00?oooooo003o00;ooooo00?oo`00o`3jV_oo00000ol0nYX2oooo
o`06ool00?l0nY[oooooooooool0nY[oo`003?ooool00ol0003oooooooooo`0Sooooo`;o00000ooo
ool01?l0nY[oo`00ooooooooool2o`3jVP04ool00?oooooo003oo`00o`;o0?ZJ1_ooool01?l0nY[o
ooooool00?oo0007ooooo`03o`3jV_oooooo0?ZJ00;oo`0000?o0?ZJooooooooool01Oooool2o`3j
VPSooooo00Co0?ZJoooooooooooo0?ZJ2oooool01Ol0nY[oo`00oooooooo003o0?ZJ00Oooooo0ol0
000:ooooo`04o`3jV_oo003o0?ZJool000Oooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[o
ooooooooool0nYX:ooooo`04ool00?ooooooo`00o`3jVQKooooo00Co0?ZJool00?oo003o0?ZJ1ooo
ool01Ol0nY[oooooo`00ool0003o0?ZJ03gooooo0011ooooo`03o`000?oooooo0?ZJ00Cooooo00Wo
o`00oooooooo003oooooool00?l0nY[oooooo`3jV_ooool00ol00003ooooo`07o`3jV_oooooooooo
ooooool0nY[oooooool00003o`3jVP;ooooo00?o0?ZJooooooooool00oooool01?l0nY[ooooooooo
oooo0006ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Co0?ZJooooool0nY[o003o0_oo0003ooooo`03
ool00?oooooooooo00?ooooo00Co0?ZJo`000?l0003o00002Oooool2ool000Co003o00?oo`00oooo
ooooool00oooool00ol0nY[oo`00o`3jVP0Dooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02oooo
o`04o`3jV_oo003o0?ZJo`3jVPgooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`04o`3jV_oo
003oooooo`3jVPSooooo00?o0000ooooooooool06Oooool3o`0000Cooooo0_l00004ooooo`04o`00
0?ooooooooooo`3jVP?ooooo0_oo00001Ol0nY[oo`00o`3jV_l0nY[oo`0000?ooooo00Ko0?ZJoooo
oooooooo0?ZJool00?ooool2o`3jVP03ool00?l0nY[ooooo00kooooo0ol00002o`3jVP03o`00oooo
003ooooo00;o0?ZJ00Coooooo`3jV_oo003o003o0_l0nYX00ooo003oooooo`3jVP04ooooo`05o`3j
V_ooooooooooool00?l0nYX01?ooool00ol0nY[oooooooooo`03o`3jVP04oooooooo003oo`00oooo
o`?o00001Oooool01?l0nY[o0000o`000?l00002ooooo`03o`3jV_oo003ooooo01Wooooo00?o0?ZJ
ooooool0nYX00oooool01ol0nY[oo`00o`00ool00?ooooooool00?l0nYX00_oo00001?oooooo003o
ooooooooool2ool000;o0?ZJ00Koooooo`3jV_ooooooooooool00?l0nYX2ooooo`03ool00?l0nY[o
oooo00_ooooo00?o0000ooooooooool05oooool3o`0000?ooooo0_l00004ooooo`03o`000?oooooo
oooo00;ooooo00Co0?ZJoooooooo003ooooo0_l0nYX01Ooo003oooooo`00ool00?oo0?ZJ00Oooooo
00Co0?ZJo`000?l0003o00001oooool00ol0nY[oooooo`3jVP02ool00003o`3jV_oooooooooo00Go
oooo0_l0nYX8ooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Go0?ZJool00?ooooooo`00o`00o`09
ooooo`03o`3jV_oooooooooo00Sooooo00Co0?ZJool00?ooooooo`001oooool00ol0nY[oooooo`3j
VP06ooooo`03o`3jV_oooooo0?ZJ00[ooooo00Coo`00oooooooo003o003o5_ooool01?l0nY[oo`00
ool00?l0nYX7ooooo`05o`3jV_ooooooooooooooool0nYX0?Oooool0047ooooo00?o0000ooooool0
nYX01Oooool2ool00006ooooool0nY[oo`00ooooool0nY[ooooo0ol000000ooo003oooooooooo`02
o`3jVP;ooooo00Go0?ZJoooooooo003o0?ZJooooo`02o`3jVP03ooooool0nY[ooooo00Cooooo00Co
0?ZJooooooooooooo`001_ooool00ol0nY[oooooo`3jVP02o`3jVPGooooo00?o0?ZJooooool0nYX0
1?oo0002ooooo`03ool00?oooooooooo00?ooooo00Co0?ZJo`000?l0003o00002Oooool00ooo003o
003oooooo`02ooooo`?o00001?ooool00ol0nY[oo`00o`3jVP0Eooooo`05o`3jV_oooooooooooooo
ool0nYX01?ooool01?l0nY[oo`00ooooool0nYX=ooooo`05o`3jV_l00?oo003oooooool0nYX01?oo
ool01?l0nY[oo`00o`3jV_l0nYX8ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo00001Ol0
nY[oo`00o`3jV_l0nY[oo`0000?ooooo00Ko0?ZJoooooooooooo0?ZJool00?ooool2o`3jVP03ool0
0?l0nY[ooooo00kooooo00?o0?ZJool00?oo00000_l0nYX00ol00?ooo`00ooooo`02o`3jVP04oooo
ool0nY[oo`00ooooo`;o0?ZJ00?oo`00ooooool0nYX01?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00Cooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX2ooooo`05ool00?ooooooooooool00?l0nYX0
1Oooool01?l0nY[oooooool00?l0nYX2ooooo`03o`3jV_oo003ooooo01Wooooo00?o0?ZJooooool0
nYX00oooool02?l0nY[oooooooooool00?ooooooool00?l00?ooo`000oooool01Ol00?ooooooool0
0?oo003o0?ZJ00?ooooo00Co0?ZJoooooooo003o0?ZJ0_ooool00ooo003o0?ZJooooo`0;ooooo`03
o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0nY[oooooo`000002o`000003o`3jV_oo003ooooo00;o003o00?o0?ZJ
ooooooooool01Oooool01?l0nY[o0000o`000?l00009ooooo`04o`3jV_oo003oo`00o`3jVQ7ooooo
00Co0?ZJoooooooooooo0?ZJ2oooool01Ol0nY[oo`00oooooooo003o003o01Cooooo00Co0?ZJool0
0?oo003o0?ZJ1oooool3o`3jVPKooooo00?o0?ZJooooool0nYX02_ooool00ooo003oooooool0000G
ooooo`04o`3jV_oo003oo`00o`3jVPOooooo00Go0?ZJooooooooooooooooo`3jVP0mooooo`00@Ooo
ool01?l0003oooooooooool0nYX4ooooo`;oo`0000Koooooo`3jV_oo003oooooo`3jV_ooool3o`00
00;oo`000_ooool01ol0nY[oooooooooool0nY[oooooool00?l0nYX00_ooool00ol0nY[oooooo`3j
VP05ooooo`04o`3jV_l00?ooooooool000Kooooo00Go0?ZJooooool0nY[oooooo`3jVP04ooooo`;o
0?ZJ00?oooooo`3jV_oo00000_ooool01?oo003ooooooooooooo0006ooooo`?o00000_l0nYX7oooo
o`03ool00?l00?oooooo00;ooooo0ol00004ooooo`03o`3jV_oo003o0?ZJ01Gooooo0_l0nYX2oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?ooool00_l0nYX5ooooo`?o0?ZJ0oooool2o`3j
VP;o003o00?oooooo`3jV_ooool00oooool00ol0nY[oo`00o`3jVP09ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`;o000000?ooooo
o`3jV_ooool00_ooool2ool00005o`3jV_oo003o0?ZJo`3jV_oo00000oooool01_l0nY[ooooooooo
ool0nY[oo`00ooooo`;o0?ZJ00?oo`00o`3jV_ooool03_ooool2o`3jVP05ool00?ooooooooooool0
0?ooool00_l0nYX2ooooo`03o`3jV_ooooooo`0000;o0?ZJ00?oo`00o`00ool0nYX01?ooool01Ol0
nY[ooooooooooooooooo0?ZJ00Cooooo00Go0?ZJoooooooooooo0?ZJooooo`02o`3jVP06oooooooo
003oo`00oooooooo003o0?ZJ1Oooool01?l0nY[oooooo`3jV_oo0002ooooo`03o`3jV_oo003ooooo
01Wooooo00?o0?ZJooooool0nYX00oooool01?l0nY[oooooooooool00?l3o`000006ool00?oooooo
ooooooooool00?oooooo0_oo00001Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Goo`00oooooooo
ooooo`00o`3jVP0;ooooo`;o00005oooool5o`0000;ooooo00Co0000oooooooooooo00000oooool2
o`0000?ooooo00?o0?ZJooooool000000_l000001_l0nY[oo`00ooooool00?ooooooo`3jVPOooooo
00Co0?ZJo`000?l0003o00002_ooool2ool001;ooooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0
nY[oo`00oooooooo000Eooooo`04o`3jV_oo003oo`00o`3jVPSooooo00?o0?ZJooooooooool01Ooo
ool00ol0nY[oooooo`3jVP0:ooooo`03ool00?l0nY[oo`0001Oooooo00Co0?ZJool00?oo003o0?ZJ
1oooool01Ol0nY[oooooooooool0003o0?ZJ03gooooo0011ooooo`04o`000?ooooooooooo`3jVPCo
oooo0_oo00002ooooooo0?ZJool00?oooooo0?ZJooooool00?ooo`00o`3jV_l00?ooo`0000;ooooo
00?o0?ZJooooool0nYX00_l0nYX01?oo003oooooooooooooool3o`3jVPKooooo00?o0?ZJoooooooo
00001_ooool3o`0000;ooooo00Co0?ZJoooooooooooooooo0_l0nYX00ooooooo0?ZJool00003oooo
o`03ool00?ooooooo`0000Kooooo0_l0nYX01?oo003oooooo`3jV_l0nYX6ooooo`05ool00?l0nY[o
0?ZJo`3jV_ooool00ol00004ooooo`03o`3jV_oo003o0?ZJ01Kooooo00Co0?ZJoooooooooooo0?ZJ
1?ooool01Ol0nY[oo`00oooooooooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX00oooool01_l0nY[o
003oo`00ool00?ooooooo`3jVPCooooo00?o0?ZJool00?l0nYX02Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01?l0003ooooooooo
ool0nYX3ooooo`;oo`0000Go0?ZJool00?ooooooooooool00003ooooo`06o`3jV_ooooooooooo`3j
V_oo003o003o0_l0nYX00ooo003o0?ZJooooo`0>ooooo`;o0?ZJ00Koo`00ooooooooooooo`00oooo
ool0nYX3ooooo`03o`3jV_ooooooo`0000;o0?ZJ00?oo`00o`00ool0nYX01?ooool01?l0nY[ooooo
ooooool0nYX5ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooool00?l00_oo00000ol0
0?oo0?ZJooooo`05ooooo`;o0?ZJ00Goo`00ooooooooooooo`00o`3jVP0Jooooo`03o`3jV_oooooo
0?ZJ00?ooooo00Co0?ZJoooooooooooooooo0ol00003ooooo`03o`3jV_l00?oooooo00;oo`0000Go
0?ZJooooooooooooooooo`3jVP02ooooo`05ool00?ooooooooooool00?l0nYX03?ooool00ol0003o
ooooooooo`0Eooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`02ooooo`03o`3jV_oooooo000000;o000000?o0?ZJool00?ooool00_ooool0
0ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`3jVP[ooooo0_l0nYXBooooo`04o`3jV_oo
ooooooooo`3jVP_ooooo00Co0?ZJool00?oo003o0?ZJ5Oooool01?l0nY[oo`00ool00?l0nYX@oooo
o`03o`3jV_oooooo0?ZJ00[ooooo00?oo`00o`3jV_oo00005oooool01?l0nY[oo`00ool00?l0nYX7
ooooo`05o`3jV_ooooooooooo`3jV_l00000?Oooool0047ooooo0_l000000ooooooo0?ZJooooo`03
ooooo`;oo`0000Goooooo`3jV_oo003oooooo`3jVP02o`00o`04ool00?l0nY[o003oool000;ooooo
00?o0?ZJooooool0nYX00_l0nYX00ooo003oooooooooo`02ooooo`;o0?ZJ1_ooool00ol0nY[ooooo
ool00005ooooo`07o`3jV_l0003o0000o`000?oooooo003oo`3jVP03ooooo`;o0?ZJ00?oooooo`3j
V_oo00000oooool00ooo003oooooool00006ooooo`;o0?ZJ00Goo`00o`00ooooooooooooo`3jVP04
ooooo`05o`3jV_oo003o0?ZJooooool0nYX00_ooool00ooo003o0?ZJooooo`03ooooo`03ool00?l0
nY[ooooo01Kooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01Ol0nY[oo`00oooooooooooo0?ZJ00Co
oooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_l00?oooooo00;o003o00?o0?ZJoooooooo
ool00_ooool00ol0nY[oo`00o`3jVP09ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`3jVP?ooooo0_oo0000
1Ol0nY[oo`00ooooooooooooo`0000?ooooo00[o0?ZJoooooooooooo0?ZJoooooooo003o0?ZJoooo
oooo003o0?ZJ3oooool2o`3jVP06ool00?l00?ooooooool00?oooooo0?ZJ1?ooool01ol0nY[oo`00
o`00ool0nY[oo`00o`00ool0nYX01Oooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_oooooooooo
o`3jVP;ooooo00?o0?ZJooooool00?l00_ooool00ol00?oo0?ZJooooo`05ooooo`;o0?ZJ00Goo`00
o`3jV_ooooooo`00o`3jVP0Jooooo`03o`3jV_oooooo0?ZJ00?ooooo00Co0?ZJoooooooooooooooo
0ol000000ooooooo0?ZJo`3jVP02o`3jVP?o00001Oooool01ol0nY[o0000o`000?l0003oooooool0
0?l0nYX03?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo000000?ooooo00Co0000oooo
oooooooo00000oooool00ol0003oooooooooo`02ooooo`07o`3jV_ooooooo`00oooooooo003o0?ZJ
ool00003ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ2_ooool2o`3jVQ;o
oooo00Co0?ZJoooooooooooo0?ZJ2oooool01?l0nY[oo`00ool00?l0nYXEooooo`04o`3jV_oo003o
o`00o`3jVQ3ooooo00?o0?ZJooooool0nYX02_ooool00ooo003o0?ZJool0000Gooooo`04o`3jV_oo
003oo`00o`3jVPOooooo00Go0?ZJoooooooooooo0?ZJo`00000mooooo`00@Oooool01?l0003ooooo
ooooool0nYX4ooooo`;oo`0000?oooooo`3jV_oo00000_l0nYX02_l00?ooooooool00?oooooo0?ZJ
o`00oooo003oooooo`3jV_ooool3o`3jVP03ool00?oooooooooo00;ooooo0_l0nYX6ooooo`03o`3j
V_ooooooo`0000Gooooo00Oo0?ZJo`000?l0003o0000ool00?l00?oo0?ZJ00?ooooo0_l0nYX00ooo
ooooo`00ooooo`03ooooo`?oo`001_ooool2o`3jVP04ool00?l00?ooooooooooo`;o0?ZJ0oooool0
0ol0nY[oo`00o`3jVP02ooooo`04o`3jV_oooooo0?ZJool000Cooooo00?oo`00o`3jV_ooool05_oo
ool2o`3jVP03ooooool0nY[ooooo00?ooooo00Go0?ZJool00?oo003oooooo`3jVP04ooooo`04o`3j
V_ooooooooooo`3jVP?ooooo00?o0?ZJo`00ooooool00_l00?l00ol0nY[oooooooooo`02ooooo`03
ool00?l0nY[ooooo00Wooooo00?o0000ooooooooool06Oooool2o`0000Cooooo00Co0000oooooooo
oooo00000oooool01?l0003oooooooooool0nYX3ooooo`;oo`0000Go0?ZJool00?ooooooooooool0
0003ooooo`06o`3jV_ooooooooooo`3jV_ooooooo`000_ooool00ooo003o0?ZJooooo`0?ooooo`;o
0?ZJ00Goo`00o`00oooo003oooooo`3jVP04ooooo`06o`3jV_oo003o003ooooooooo003o0?ZJ1_oo
ool00ol0nY[oooooo`3jVP06ooooo`?o0?ZJ0_ooool2o`3jVP05o`00ooooooooooooo`00ool0nYX0
1_ooool2o`3jVP05ool00?l0nY[oooooool00?l0nYX06_ooool00ol0nY[oooooo`3jVP03ooooo`03
o`3jV_oooooooooo00?o0?ZJ00?oooooo`3jV_l0nYX00_ooool01?l0nY[o0000o`000?l00005oooo
o`07o`3jV_l0003o0000o`000?ooooooo`00o`3jVP0<ooooo`03o`000?oooooooooo01Oooooo0_l0
0003ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool01ol0nY[ooooo
ool00?ooooooo`00o`3jV_oo00000oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_oooooooooo
o`3jVP[ooooo0_l0nYXBooooo`03o`3jV_oooooo0?ZJ00cooooo00Co0?ZJool00?oo003o0?ZJ5Ooo
ool01?l0nY[oo`00ool00?l0nYX@ooooo`03o`3jV_oooooo0?ZJ00[ooooo00?oo`00o`3jV_oo0000
5oooool00ol0nY[oo`00ool00008ooooo`05o`3jV_ooooooooooo`3jV_l00000?Oooool0047ooooo
00Co0000oooooooooooo0?ZJ1?ooool2ool00003ooooool0nY[oo`0000;o0?ZJ00[o003oool00?l0
nY[oooooo`3jV_ooooooo`00ooooool0nY[ooooo0ol0nYX00ooo003oooooooooo`03ooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJo`00oooo00001Oooool01?l0nY[oooooool00?l0nYX2ool00004
o`00ool0nY[oooooooooo`;o0?ZJ00?oooooool00?ooool01?ooool2ool000Kooooo0ol0nYX01Ooo
003o003ooooooooooooo0?ZJ00?ooooo00?o0?ZJool00?ooool00_ooool01?l0nY[oooooo`3jV_oo
0004ooooo`03ool00?l0nY[ooooo01Oooooo00?o0?ZJooooool0nYX01?ooool01Ol0nY[oooooool0
0?oooooo0?ZJ00?ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00;o0?ZJ0ooo00000ol00?oo0?ZJ
ooooo`03ooooo`03ool00?l0nY[ooooo00Wooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`03ooooo`;o00001?ooool2o`000003ooooool0nY[ooooo00;ooooo0_oo00001Ol0nY[oo`00
oooooooo003o003o00?ooooo00Ko0?ZJoooooooooooo0?ZJoooooooo0002ooooo`03ool00?l0nY[o
oooo00oooooo0_l0nYX3ool00003o`3jV_oooooooooo00?ooooo00Ko0?ZJool00?l00?ooooooool0
0?l0nYX6ooooo`03o`3jV_oooooo0?ZJ00Kooooo0_l0nYX4ooooo`06o`3jV_oooooo003oooooool0
0?oo0?ZJ1_ooool2o`3jVP05ool00?l0nY[oooooool00?l0nYX06_ooool00ol0nY[oooooo`3jVP03
ooooo`03o`3jV_oooooo0?ZJ00Go0?ZJ1?ooool3o`0000Gooooo00Oo0?ZJo`000?l0003o0000oooo
oooo003o0?ZJ00cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`02ooooo`;o0000
1?ooool2o`0000?ooooo00?o0?ZJoooooooo00000_oo00000ol0nY[oo`00ooooo`02ooooo`03o`3j
V_oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ2_ooool2o`3jVQ;ooooo0ol0nYX<ooooo`04
o`3jV_oo003oo`00o`3jVQGooooo00Co0?ZJool00?oo003o0?ZJ4?ooool3o`3jVP[ooooo00?oo`00
o`3jV_oo00005oooool00ol0nY[oooooo`3jVP09ooooo`04o`3jV_oooooo0?ZJo`0003gooooo0011
ooooo`04o`000?ooooooooooo`3jVPCooooo0_oo00000ooooooo0?ZJool00002o`3jVP0:o`00oooo
003o0?ZJooooool0nY[oooooool00?oooooo0?ZJooooo`;o0?ZJ00?oo`00o`3jV_ooool01?ooool0
0ol0nY[oooooooooo`04ooooo`03o`00ool0nY[oo`0000Gooooo00So0?ZJo`00oooo003o0?ZJoooo
oooo003o003oo`3jVP;ooooo0ol0nYX00ooo003o0?ZJo`3jVP03ooooo`;oo`001_ooool3o`3jVP;o
o`000oooool4o`3jVP09ool00?ooooooooooooooool0nY[oooooo`3jV_oo003o0?ZJ00?ooooo00?o
o`00o`3jV_ooool05oooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_oo003oooooo`3jVP?ooooo
00Go0?ZJooooooooooooooooo`3jVP02ooooo`07o`3jV_l00?ooo`00oooooooo003o003oo`3jVP04
ooooo`03ool00?l0nY[ooooo00Wooooo00?o0000ooooooooool09_ooool01?l0003oooooooooool0
nYX3ooooo`;oo`0000Go0?ZJool00?ooooooo`00o`00o`03ooooo`06o`3jV_ooooooooooo`3jV_oo
ooooo`000_ooool00ooo003o0?ZJooooo`0@ooooo`05o`3jV_oo003oo`00ooooool0nYX01Oooool0
1_l0nY[oo`00ooooool00?ooo`00o`3jVPKooooo00?o0?ZJooooool0nYX03?ooool01Ol0nY[ooooo
o`00oooooooo0?ZJ00Oooooo0_l0nYX01Ooo003o0?ZJoooooooo003o0?ZJ01_ooooo0_l0nYX3oooo
o`?o0?ZJ2Oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3j
V_ooool02oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00?ooooo00?o0?ZJool0
0?oo00000_oo0003ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooo0?ZJ2_ooool2
o`3jVQ;ooooo0_l0nYX=ooooo`04o`3jV_oo003oo`00o`3jVQGooooo00Co0?ZJool00?oo003o0?ZJ
4?ooool2o`3jVP_ooooo00?oo`00o`3jV_oo00005oooool00ol0nY[oooooo`3jVP09ooooo`04o`3j
V_oooooo0?ZJo`0003gooooo0011ooooo`;o00000_ooool01?l0nY[oooooooooooooool2ool00003
ooooool0nY[oo`0000;o0?ZJ00?o003oool00?l0nYX00_ooool01Ol0nY[oo`00o`00ool0nY[ooooo
00;o0?ZJ00?oo`00o`3jV_ooool03?ooool00ol0nY[oo`00o`3jVP04ooooo`03o`3jV_oo003ooooo
00;o0?ZJ00?oo`00o`00ool0nYX00_ooool3o`3jVP04ool00?l0nY[o0?ZJo`3jVP;ooooo0_oo0006
ooooo`?o0?ZJ00Goooooool00?l00?oo003oooooo`03o`3jVP03ool00?l0nY[ooooo00;ooooo0ol0
nYX00ooo003o0?ZJooooo`02ooooo`03ool00?l0nY[ooooo01Oooooo00?o0?ZJooooool0nYX01Ooo
ool01?l0nY[oo`00ool00?l0nYX3ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[o
o`00ool00002ooooo`03ool00?l0nY[ooooo00?ooooo00?oo`00o`3jV_ooool02Oooool00ol0003o
ooooooooo`0Vooooo`05o`000?ooooooooooooooool0nYX00_ooool2ool00005o`3jV_oo003ooooo
ool00?l00?l00oooool02_l0nY[ooooooooooooooooo0?ZJool00?ooooooo`00o`00ool0nYXAoooo
o`05o`3jV_ooooooooooooooool0nYX01Oooool01_l0nY[oooooool00?l00?ooo`00o`3jVPKooooo
00?o0?ZJooooool0nYX03Oooool01?l0nY[o003oooooool0nYX7ooooo`;o0?ZJ00Goo`00o`3jV_oo
ooooo`00o`3jVP0Kooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`08ooooo`03o`00ool0nY[ooooo
00Gooooo0_l0nYX01Ooo003o0?ZJoooooooo003o0?ZJ00cooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`03ooooo`03o`3jV_oo003oo`0000;oo`000oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooo0?ZJ00_ooooo0_l0nYXQooooo`04o`3jV_oo003oo`00o`3jVQGooooo00Co
0?ZJoooooooo003o0?ZJ7Oooool00ooo003o003oool0000Hooooo`;o0?ZJ2Oooool3o`3jVP03o`00
0?oooooooooo03_ooooo0011ooooo`05o`000?ooooooooooooooool0nYX00oooool2ool00008oooo
ool0nY[oo`00o`3jV_ooooooo`00ooooool0nYX2ooooo`04o`3jV_ooooooo`00ooooo`?o0?ZJ00?o
o`00o`3jV_ooool03?ooool3o`000007o`3jV_ooooooooooooooool0nY[oo`00ooooo`02o`3jVP;o
o`0000?o0?ZJooooooooool00ol0nYX01?oo003o0?ZJooooool0nYX3ooooo`03o`3jV_oooooooooo
00Cooooo0ol0nYX01?ooooooo`00ool00?l00?l3ooooo`03o`3jV_oo003o0?ZJ00Cooooo0_l0nYX0
1ooo003o0?ZJoooooooooooo0?ZJool00?l0nYX06?ooool00ol0nY[oooooo`3jVP05ooooo`04o`3j
V_ooooooo`00o`3jVP;ooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX2ooooo`03o`3jV_oo003o
oooo00;ooooo00?oo`00o`3jV_ooool00oooool00ooo003o0?ZJooooo`09ooooo`03o`000?oooooo
oooo02Kooooo0_l00002ooooo`03o`3jV_oooooooooo00;oo`0000Go0?ZJool00?ooooooo`00o`00
o`03ooooo`0:o`3jV_ooooooooooooooool0nY[oo`00o`00oooo003o003oo`3jVQ7ooooo00Go0?ZJ
ooooooooooooooooo`3jVP05ooooo`06o`3jV_ooooooo`00ool00?oooooo0?ZJ1_ooool00ol0nY[o
ooooo`3jVP0=ooooo`04o`3jV_l00?ooooooo`3jVPOooooo0ol0nYX01?oo003oooooool00?l0nYXK
ooooo`;o0?ZJ3oooool00ol00?ooooooooooo`06ooooo`05o`3jV_oo003o0?ZJo`3jV_oo00003Ooo
ool00ol0003oooooooooo`0Sooooo`;o00001?ooool00ol0nY[oo`00ool00002ool000?ooooo00?o
0?ZJooooooooool01_ooool00ol0nY[oooooo`3jVP0;ooooo`;o0?ZJ8Oooool01?l0nY[oooooo`00
ool0nYXFooooo`03o`3jV_l00?oo0?ZJ01gooooo00?oo`00o`00oooo00006?ooool2o`3jVPWooooo
0_l0nYX2o`0003gooooo0011ooooo`05o`000?ooooooooooooooool0nYX00oooool01Ooo003o0?ZJ
ooooooooooooo`0000;ooooo00?oo`00ooooool0nYX00_ooool01?l0nY[oooooool00?ooool3o`3j
VP03ool00?l0nY[ooooo00cooooo0ol000001ol0nY[oooooooooool0nY[oooooool00?ooool00_l0
nYX01Oooooooo`00o`00ool0nY[ooooo00?o0?ZJ00Coo`00oooooooooooo0?ZJ0oooool00ol0nY[o
ooooooooo`05ooooo`06o`3jV_oooooo0?ZJoooooooo003o003o0oooool00ol0nY[oo`00o`3jVP04
ooooo`;o0?ZJ00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ01Wooooo0_l0nYX5ooooo`05o`3j
V_ooooooo`00ool00?ooool00_l0nYX2o`00o`?oo`0000Coooooo`00ool0nY[oo`000oooool3o`00
00?ooooo00?oo`00o`3jV_ooool02Oooool00ol0003oooooooooo`0Vooooo`05o`000?oooooooooo
ooooool0nYX00_ooool2ool000;o0?ZJ0_oo00001Ol00?oooooooooooooooooo0?ZJ00?ooooo00Ko
0?ZJool00?l00?ooo`00o`00ool0nYXBooooo`04o`3jV_oooooo0?ZJo`3jVPKooooo00Go0?ZJool0
0?oo003o003oo`3jVP06ooooo`03o`3jV_oooooo0?ZJ00gooooo0_l0nYX00ol00?oo0?ZJooooo`06
ooooo`?o0?ZJ00Coo`00oooooooo003o0?ZJ6oooool2o`3jVQSooooo00Go0?ZJool00?l0nY[o0?ZJ
ool0000=ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00oooool00ol0nY[oo`00
ool00002ool000?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooo`3jVP0;ooooo`;o0?ZJ
8Oooool01?l0nY[oooooo`00ool0nYXFooooo`;o0?ZJ7_ooool00ol0nY[oo`00o`3jVP0Hooooo`;o
0?ZJ2Oooool01?l0nY[oooooooooool0000mooooo`00@Oooool01Ol0003ooooooooooooooooo0?ZJ
00Cooooo00Co0?ZJooooooooooooo`000_ooool00ooo003oooooo`3jVP02ooooo`04o`3jV_oooooo
o`00ooooo`?o0?ZJ00?oo`00o`3jV_ooool03?ooool3o`000008o`3jV_ooooooooooo`3jV_l00?oo
o`00o`3jV_ooool2o`3jVP04ool00?l00?oo0?ZJooooo`;o0?ZJ00Coo`00o`3jV_oooooooooo0_l0
nYX2ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool0nYX00_ooool01ooo003o003ooooo
oooooooo0?ZJool00?l0nYX01?ooool2o`3jVP07ool00?l0nY[oooooooooool0nY[oo`00o`3jVP0I
ooooo`;o0?ZJ1Oooool01?l0nY[oooooo`00oooo0002o`3jVP06o`00ooooooooo`00ool00?l00?oo
o`000_l0nYX2ool000?ooooo0ol00002ooooo`03o`3jV_oo003o0?ZJ00[ooooo00?o0000oooooooo
ool09_ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_oo0002o`3jVP;oo`0000Go003ooooo
ooooooooooooo`3jVP03ooooo`06o`3jV_ooooooo`00ool00?l00?oo0?ZJ4_ooool00ol0nY[ooooo
o`3jVP07ooooo`05o`3jV_oo003oo`00o`00ool0nYX01_ooool00ol0nY[oooooo`3jVP0>ooooo`03
o`3jV_l00?oo0?ZJ00Oooooo0ol0nYX01?oo003oooooool00?l0nYXKooooo`;o0?ZJ6?ooool2o`3j
VP03ool00?l0nY[oo`0000gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`03oooo
o`03o`3jV_oo003oo`0000;oo`000oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ
00_ooooo00?o0?ZJooooooooool08?ooool01?l0nY[oooooo`00ool0nYXFooooo`;o0?ZJ7_ooool0
0ol0nY[oo`00o`3jVP0Hooooo`;o0?ZJ3?ooool00ol0003oooooooooo`0kooooo`00@Oooool2o`00
00;ooooo00?o0?ZJooooooooool00_ooool02Ol0nY[ooooooooooooo003oooooool00?l00?oooooo
o`3jVP03ooooo`03o`3jV_oo003ooooo00?o0?ZJ00?oo`00ooooooooool03Oooool02Ol0nY[oo`00
ooooool0nY[oooooo`3jV_oo003o003oo`3jVP02ooooo`06o`3jV_oo003o003oo`3jV_oooooo0?ZJ
0_oo00001Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool01Oooool01ol0nY[o
ooooo`3jV_l0nY[oooooool00?l00?l00_ooool00ol0nY[oo`00ooooo`04ooooo`?o0?ZJ00Koo`00
oooooooooooo0?ZJool00?l0nYXIooooo`;o0?ZJ1Oooool00ol0nY[oooooo`000002o`0000;o003o
0_oo00000ooooooo003oool00002o`3jVP03ool00?oooooooooo00;ooooo0ol00002ooooo`03o`3j
V_oo003o0?ZJ00[ooooo00?o0000ooooooooool09_ooool01Ol0003ooooooooooooooooo0?ZJ00;o
oooo0_oo0002o`3jVP03ool00?oooooo003o00?ooooo00Ko0?ZJooooooooooooooooo`3jV_ooool2
ool00003o`00ool0nY[ooooo017ooooo00?o0?ZJooooool0nYX01oooool01Ol0nY[oooooooooool0
0?oo0?ZJ00Kooooo00?o0?ZJooooool0nYX03oooool2o`3jVPOooooo0ol0nYX01?oo003o0?ZJool0
0?l0nYXKooooo`;o0?ZJ6?ooool2o`3jVP03ool00?l0nY[oo`0000gooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`03ooooo`03o`3jV_oo003oo`0000;oo`000oooool00ol0nY[ooooo
ooooo`06ooooo`03o`3jV_oooooo0?ZJ02kooooo00Co0?ZJoooooooooooo0?ZJ5_ooool2o`3jVQko
oooo00?o0?ZJool00?l0nYX06?ooool2o`3jVPcooooo00?o0000ooooooooool0>oooool0047ooooo
00Go0000ooooooooooooooooo`3jVP04ooooo`04o`3jV_ooooooooooo`3jVP;oo`000_ooool01ol0
nY[ooooooooooooooooo0?ZJool00?l00?l00ol0nYX00ooo003oooooooooo`0=ooooo`03o`3jV_oo
003o003o00?o0?ZJ00?oo`00ooooool0nYX00_ooool00ol0nY[oo`00o`00o`02o`3jVP04oooooooo
003oo`00o`3jVP?ooooo00Co0?ZJoooooooooooo0?ZJ2_ooool01?l0nY[ooooooooooooo0002oooo
o`03o`3jV_oo003ooooo00Cooooo0ol0nYX01_oo003o0?ZJooooool0nY[oo`00o`3jVQWooooo0_l0
nYX5ooooo`03o`3jV_oooooo000000;o000000?o003ooooooooo00000_ooool01_l00?ooo`00o`3j
V_l0nY[oo`00ooooo`;o0?ZJ0_ooool01_l0nY[oo`00oooooooooooo0?ZJool000_ooooo00?o0000
ooooooooool09_ooool2o`0000;ooooo00Go0?ZJooooooooooooo`00ooooo`02o`3jVP03ool00?oo
oooo0?ZJ00;ooooo0_l0nYX3ooooo`06o`3jV_ooooooo`00ool00?l00?oo0?ZJ4_ooool2o`3jVPSo
oooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;o0?ZJ3oooool2o`3jVPSooooo0_l0nYX01?oo
003o0?ZJool00?l0nYXKooooo`;o0?ZJ6Oooool01?l0nY[oo`00o`3jV_oo000=ooooo`03o`000?oo
oooooooo02?ooooo0_l00004ooooo`03o`3jV_oo003oo`0000;oo`000oooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooo0?ZJ02kooooo00Co0?ZJoooooooooooo0?ZJ5_ooool2o`3jVQkooooo
00?o0?ZJool00?l0nYX06?ooool00ol0nY[oooooooooo`0:ooooo`;o0000?Oooool003Cooooo0ol0
0004ooooo`;o00001?ooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo00Co0?ZJoooooooooooo
0?ZJ0_oo0002ooooo`07o`3jV_ooooooooooooooool0nY[oo`00o`00o`03o`3jVP03ool00?oooooo
oooo00kooooo00So0?ZJool00?oooooo0?ZJoooooooo003oooooo`3jVP;ooooo00?o0?ZJoooooooo
00000_l0nYX01?ooooooo`00ool00?l0nYX3ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Co0?ZJ
ooooooooooooo`000_ooool00ol0nY[oo`00ooooo`05ooooo`;o0?ZJ00Koo`00o`3jV_oooooo0?ZJ
ool00?l0nYXIooooo`;o0?ZJ1_ooool01Ol0nY[o0000o`000?l0003o003o00;oo`000oooool01?oo
003o0?ZJo`3jV_oo0004o`3jVP03ooooool0nY[oo`0000;ooooo00?o0?ZJool00?ooool02_ooool0
0ol0003oooooooooo`0Vooooo`05o`000?ooooooooooooooool0nYX01?ooool2o`3jVP03ooooool0
nY[o0?ZJ00;ooooo00?o0?ZJooooooooool00_ooool01_l0nY[oooooo`00oooooooo003oo`3jVQco
oooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;o0?ZJ6Oooool01_l0nY[oooooool00?l0nY[o
o`00o`3jVQ_ooooo0_l0nYXJooooo`03ool00?l0nY[oo`0000gooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`03ooooo`03o`3jV_oo003oo`0000;oo`0000Co0?ZJoooooooooooo0?ZJ
2?ooool00ol0nY[oooooo`3jVP0_ooooo`;o0?ZJ5oooool2o`3jVQkooooo00?o0?ZJool00?l0nYX0
9_ooool00ol0003oooooooooo`0kooooo`00=Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000?ooooo00Go0000ooooooooooooooooo`3jVP04ooooo`06o`3jV_ooooooooooo`3j
V_oooooo003o0_ooool01ol0nY[ooooooooooooooooo0?ZJool00?l00?l00ol0nYX00ooo003ooooo
ooooo`0>ooooo`08o`3jV_oo003oooooooooool00?ooo`00ooooool0nYX2ooooo`03o`3jV_oooooo
o`0000;o0?ZJ00?oooooool00?oo00001?ooool01?l0nY[oooooooooool0nYX:ooooo`;o0?ZJ00Ko
ooooo`00oooo003oooooo`3jV_oo0006ooooo`;o0?ZJ00Goo`00o`3jV_oooooo0?ZJool0000Joooo
o`;o0?ZJ1_ooool00ol0nY[oooooo`3jVP03ool000Cooooo00Goo`00o`3jV_oo003oo`00o`3jVP02
ooooo`04o`3jV_oooooo0?ZJool000;ooooo00?o0?ZJool00?ooool02_ooool00ol0003ooooooooo
o`0Vooooo`05o`000?ooooooooooooooool0nYX01?ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo
00?o0?ZJooooooooool00_ooool01_l0nY[oooooo`00oooooooo003oo`3jVQcooooo00Go0?ZJoooo
ooooooooooooo`3jVP07ooooo`;o0?ZJ6Oooool01_l0nY[oooooool00?l0nY[oo`00o`3jVQ_ooooo
0_l0nYXJooooo`;oo`0000?o0?ZJooooooooool02oooool00ol0003oooooooooo`0Sooooo`03o`00
0?oooooooooo00?ooooo00?o0?ZJool00?oo00000_oo00001?l0nY[oooooooooool0nYX9ooooo`;o
0?ZJ;oooool2o`3jVQOooooo0_l0nYXNooooo`03o`3jV_oooooo0?ZJ02Kooooo00?o0000oooooooo
ool0>oooool003Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`;o
00000_ooool00ol0nY[oooooooooo`02ooooo`06o`3jV_ooooooooooo`3jV_oooooo003o0_ooool0
1ol0nY[ooooooooooooooooo0?ZJoooooooo00000ol0nYX00ooo003oooooooooo`0>ooooo`08o`3j
V_oo003o003oooooool00?ooo`00ooooool0nYX3ooooo`04o`3jV_oo003o003oo`3jVP?oo`001?oo
ool01?l0nY[oooooooooool0nYX;ooooo`03o`3jV_oooooo003o00Coo`001_ooool01ol0nY[ooooo
ool00?l0nY[oooooo`3jV_oo00006_ooool2o`3jVPKooooo0ol0nYX7ooooo`03o`00oooo003oo`00
00;o0?ZJ0_ooool01?l0nY[oooooo`3jV_oo0002ooooo`03o`3jV_oo003ooooo00Wooooo0_l0000X
ooooo`;o00000_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ00?o003oo`3jV_l0nYX00_ooool0
0ol0nY[oooooooooo`02ooooo`06o`3jV_ooooooooooo`00oooooooo0?ZJ7?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ00Oooooo0_l0nYXIooooo`06o`3jV_ooooooo`00o`00oooo003o0?ZJ6oooool2
o`3jVQ[ooooo0_oo00000ol0nY[oooooooooo`0;ooooo`03o`000?oooooooooo02?ooooo0_l00004
ooooo`03o`3jV_oo003oo`0000;oo`000_l0nYX00ooooooo0?ZJooooo`08ooooo`03o`3jV_oooooo
oooo02kooooo0_l0nYXGooooo`;o0?ZJ7_ooool2o`3jVRKooooo0_l0000mooooo`00=Oooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`3j
VP04ooooo`06o`3jV_ooooooooooo`3jV_oooooo003o0_ooool01ol0nY[ooooooooooooooooo0?ZJ
oooooooo00000_ooool00ol0nY[oo`00ooooo`0?ooooo`06o`3jV_oo003oo`00o`00oooo003ooooo
0_l0nYX3ooooo`04o`3jV_oo003o003oooooo`?oo`001Oooool00ol0nY[oooooo`3jVP0;ooooo`03
o`3jV_oooooo003o00;ooooo0_oo0006ooooo`07o`3jV_ooooooo`00o`3jV_oooooo0?ZJool0000J
ooooo`;o0?ZJ1oooool3o`3jVPKooooo00Co003oool00?oo003o0?ZJ0oooool3o`3jVP05ool00?l0
nY[oooooo`3jV_oo00002oooool00ol0003oooooooooo`0Hooooo`Go00000oooool2o`0000Cooooo
00Go0000ooooooooooooooooo`3jVP04ooooo`;o0?ZJ00?o003oo`3jV_ooool00ol0nYX4ooooo`06
o`3jV_ooooooooooo`00oooooooo0?ZJ7Oooool01?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ6Ooo
ool01Ol0nY[oooooool00?l00?ooo`0001cooooo0_l0nYXJooooo`;oo`0000?o0?ZJooooooooool0
2oooool00ol0003oooooooooo`0Fooooo`?o00001?ooool2o`0000Cooooo00?o0000ooooooooool0
0oooool00ol0nY[oo`00ool00002ool000;o0?ZJ00?oooooo`3jV_ooool02?ooool00ol0nY[ooooo
ooooo`0^ooooo`;o0?ZJ5oooool2o`3jVQkooooo0_l0nYXWooooo`03o`000?oooooooooo03_ooooo
000eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooo
oooooooooooo0?ZJ00Cooooo00Ko0?ZJoooooooooooo0?ZJooooool00?l2ooooo`0;o`3jV_oooooo
ooooooooool0nY[oooooool00?l00?ooooooo`3jV_oo00004Oooool01_l0nY[oo`00o`00oooo003o
ooooo`3jVPCooooo00Co0?ZJool00?l00?oo003o0_oo00000ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooo0?ZJ00cooooo00Ko0?ZJo`00ooooooooooooool00?l0nYX6ooooo`07o`3jV_ooooooo`00
o`3jV_oooooo0?ZJool0000Kooooo`03o`3jV_oooooooooo00Gooooo0ol0nYX2ooooo`?o0?ZJ0ol0
00000ooo003o0?ZJooooo`03ooooo`;o0?ZJ00Goo`00o`3jV_ooooooo`00o`3jVP0;ooooo`03o`00
0?oooooooooo01Wooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00003oooo
o`05o`000?ooooooooooooooool0nYX01?ooool2o`3jVP03o`00ool0nY[ooooo00;o0?ZJ1_ooool0
1Ol0nY[ooooooooooooooooo0?ZJ01gooooo00?o0?ZJooooool0nYX02?ooool2o`3jVQ_ooooo00?o
0?ZJool00?oo00007?ooool2o`3jVQ[ooooo0_oo00000ol0nY[oooooooooo`0;ooooo`03o`000?oo
oooooooo01Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool00oooool00ol0nY[oo`00ool00002ool000;o0?ZJ00?oooooo`3jV_oo
ool02?ooool00ol0nY[oooooooooo`0^ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooooooo03_ooooo000dooooo`;o0000
1?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJoooooooo
ooooooooo`3jVP02ooooo`03o`3jV_l00?oo003o00;ooooo00_o0?ZJooooooooooooooooo`3jV_oo
ooooo`00o`00ooooooooo`00o`3jVP0Aooooo`06o`3jV_oo003oo`00ool00?oooooo0?ZJ1?ooool0
1?l0nY[oo`00ool00?l00?l3o`0000Gooooo00?o0?ZJooooool0nYX03?ooool01_l0nY[o003ooooo
ooooooooo`00o`3jVPSooooo00Go0?ZJool00?ooooooo`00o`3jVP0Kooooo`03o`3jV_oooooooooo
00Oooooo1?l0nYX2ooooo`?o000000?oooooo`3jV_ooool00oooool2o`3jVP05ool00?l0nY[ooooo
ool00?l0nYX02oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00Cooooo0_l0nYX00ol00?oo0?ZJ
ooooo`02o`3jVPKooooo00Go0?ZJooooooooooooooooo`3jVP0Mooooo`?o0?ZJ2?ooool2o`3jVQ_o
oooo00?o0?ZJool00?oo00007Oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo003o0?ZJ00go
oooo00?o0000ooooooooool06Oooool01?l0003oooooooooool00002ooooo`05o`000?oooooooooo
ooooool000001Oooool00ol0nY[oo`00ool00002ool00003ooooool0nY[o0?ZJ03_ooooo00?o0?ZJ
ooooooooool0=oooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooooooo03_ooooo000eoooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJoooo
ooooooooooooo`3jVP02ooooo`;o0?ZJ00Co003ooooooooooooo0?ZJ1?ooool01_l0nY[oo`00o`00
ooooooooo`00o`3jVQ7ooooo00?o0?ZJoooooooo00000_ooool00ol0nY[oooooooooo`02ooooo`04
o`3jV_ooooooo`00o`00o`?o00001Oooool00ol0nY[oooooo`3jVP0<ooooo`;o0?ZJ00Co003ooooo
oooo003o0?ZJ2?ooool01Ol0nY[oo`00oooooooo003o0?ZJ01_ooooo00?o0?ZJooooooooool02?oo
ool2o`3jVP?ooooo0ol000000ol0nY[oooooooooo`03ooooo`;o0?ZJ00Goo`00o`3jV_ooooooo`00
o`3jVP0;ooooo`03o`000?oooooooooo01_ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooooooo`;o00000_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo0?ZJ
o`3jVPWooooo00Go0?ZJooooooooooooooooo`3jVP0Nooooo`;o0?ZJ2?ooool2o`3jVQ_ooooo00?o
0?ZJool00?l0nYX07Oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooo0?ZJ00cooooo0_l0
000Kooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo0_l00004ooooo`03
o`3jV_oo003oo`0000;oo`0000?oooooo`3jV_l0nYX0>oooool00ol0nY[oooooooooo`0gooooo`03
o`3jV_oooooooooo02Cooooo0_l0000mooooo`00@Oooool2o`0000?ooooo00Go0?ZJoooooooooooo
ooooo`3jVP03ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`06o`3jV_oo003o003ooooo
oooo003o0?ZJ4Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo00Co0?ZJoooooooo003o003o
0ol00005ooooo`03o`3jV_oooooo0?ZJ00gooooo00Go0?ZJo`00ooooooooo`00o`3jVP08ooooo`05
o`3jV_oo003o0?ZJool00?l0nYX06oooool00ol0nY[oooooooooo`0?ooooo`;o0?ZJ1_ooool2o`3j
VP04ool00?ooooooo`00o`3jVP_ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00Co
oooo00?o0?ZJooooool0nYX02_ooool01Ol0nY[ooooooooooooooooo0?ZJ01kooooo0_l0nYX8oooo
o`;o0?ZJ6oooool00ol0nY[oo`00o`3jVP0Mooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX>oooo
o`03o`000?oooooooooo01Gooooo1?l00003ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool00oooool00ol0nY[oooooooooo`02ool00003ooooool0nY[o0?ZJ07Gooooo00?o0?ZJ
ooooooooool09Oooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0003oooooooooo`02oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool01Ol00?oo0?ZJoooooooooooo0?ZJ00Cooooo00?o
0?ZJoooooooo00000_oo00000ol0nY[oooooooooo`0?ooooo`05o`3jV_ooooooooooooooool0nYX0
1_ooool01Ol0nY[oo`00ool00?l00?oo0?ZJ00Kooooo00?o0?ZJooooool0nYX03Oooool01?l0nY[o
003ooooooooo0009ooooo`05o`3jV_oo003o0?ZJool00?l0nYX06oooool00ol0nY[oooooooooo`0?
ooooo`;o0?ZJ1_ooool2o`3jVP04ool00?l0nY[oo`00o`3jVP_ooooo00?o0000ooooooooool06?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool01Ol0003o
oooooooooooooooo0?ZJ00Cooooo00?o0?ZJooooool0nYX02_ooool3o`3jVP03ooooool0nY[ooooo
02Oooooo0_l0nYXKooooo`03o`3jV_l00?oo0?ZJ01gooooo00?o0?ZJooooooooool06?ooool2o`3j
VPkooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`04ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool00oooool00ol0nY[oooooooooo`02ool000;ooooo00?o0?ZJ
ooooooooool0Voooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0003oooooooooo`02oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool01Ol00?oo0?ZJoooooooooooo0?ZJ00Cooooo00?o
0?ZJoooooooo00000_oo000Cooooo`04o`3jV_ooooooooooo`3jVPKooooo00Go0?ZJool00?oo003o
003oo`3jVP06ooooo`03o`3jV_oooooo0?ZJ00kooooo00?o0?ZJo`00oooo00002Oooool01Ol0nY[o
o`00o`3jV_oo003o0?ZJ01_ooooo00?o0?ZJooooooooool06?ooool01Ol0nY[oo`00o`3jV_oo003o
0?ZJ00_ooooo00?o0000ooooooooool06Oooool3o`0000Cooooo0_l00004ooooo`;o00000_ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00[ooooo0ol0nYX00ooooooo0?ZJooooo`0X
ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJo`00ool0nYX07Oooool00ol0nY[oooooooooo`0I
ooooo`03o`3jV_oooooooooo00cooooo00?o0000ooooooooool05Oooool5o`0000?ooooo0_l00004
ooooo`;o00001?ooool00ol0nY[oooooooooo`02ool009oooooo0_l0000mooooo`00@Oooool00ol0
003oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01?l0nY[oooooooooool0
nYX4ooooo`03o`3jV_ooooooo`0000;oo`004oooool00ol0nY[oooooo`3jVP07ooooo`05o`3jV_oo
ooooooooo`00ool0nYX01_ooool00ol0nY[oooooo`3jVP0>ooooo`04o`3jV_l0003o0000o`0000So
oooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Kooooo`03o`3jV_oooooooooo01Sooooo00Go0?ZJool0
0?l0nY[oo`00o`3jVP0;ooooo`03o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3j
VP04ooooo`03o`3jV_oooooooooo00[ooooo0ol0nYX00ooooooo0?ZJooooo`0Xooooo`03o`3jV_oo
oooooooo01Wooooo00?o0?ZJooooool0nYX07Oooool00ol0nY[oooooooooo`0Xooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool00oooool00ol0nY[oooooooooo`02ool00:3ooooo00?o
0000ooooooooool0>oooool0047ooooo0_l00003ooooo`05o`3jV_ooooooooooooooool0nYX01?oo
ool01?l0nY[oooooooooool0nYX4ooooo`03o`3jV_ooooooo`0000;oo`004oooool00ol0nY[ooooo
o`3jVP07ooooo`05o`3jV_ooooooooooooooool0nYX01oooool2o`3jVPoooooo0ol00009ooooo`04
ool00?l0nY[oo`00o`3jVQ_ooooo00?o0?ZJooooooooool06?ooool01?l0nY[oo`00oooooooo000<
ooooo`03o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP04ooooo`03o`3jV_oo
oooooooo00cooooo0_l0nYXZooooo`03o`3jV_oooooooooo01[ooooo0_l0nYXMooooo`03o`3jV_oo
oooooooo02Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`03ooooo`03o`3jV_oo
oooooooo00;oo`00X?ooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0003oooooooooo`02
ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01?l0nY[oooooooooool0nYX4ooooo`05o`3j
V_ooooooooooo`00oooo00005?ooool00ol0nY[oooooooooo`06ooooo`05o`3jV_oooooooooooooo
ool0nYX01oooool2o`3jVPoooooo0ol00009ooooo`04ool00?ooooooo`00o`3jVQ_ooooo00?o0?ZJ
ooooooooool06Oooool00ooo003o003oool0000<ooooo`03o`000?oooooooooo02Kooooo00Go0000
ooooooooooooooooo`3jVP04ooooo`03o`3jV_oooooooooo00cooooo0_l0nYXZooooo`03o`3jV_oo
oooooooo01[ooooo0_l0nYXMooooo`03o`3jV_oooooooooo02Sooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo00;oo`00X?ooool00ol0003ooooooooo
o`0kooooo`00@Oooool00ol0003oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX01Ooo
ool00ol0nY[oooooo`3jVP04ooooo`05o`3jV_ooooooooooo`00oooo00007Oooool01Ol0nY[ooooo
oooooooooooo0?ZJ00Oooooo0_l0nYX?ooooo`03o`00oooooooooooo00Wooooo00Coo`00o`00oooo
003o0?ZJ=oooool2ool00003o`3jV_oooooooooo00[ooooo00?o0000ooooooooool09_ooool2o`00
00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ:_ooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0:?ooool00ol0
003oooooooooo`0Sooooo`;o00001?ooool00ol0nY[oooooooooo`02ool009oooooo0_l0000moooo
o`00@Oooool00ol0003oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool00ol0
nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00?o00007?ooool2o`3jVP;ooooo00?o0?ZJoooo
ooooool01Oooool2o`3jVQ_ooooo00Co0?ZJool00?oo003o0?ZJ=oooool00ol0nY[oo`00o`3jVP0<
ooooo`03o`000?oooooooooo02Kooooo00Go0000ooooooooooooooooo`3jVP04ooooo`03o`3jV_oo
oooooooo00cooooo0_l0nYXZooooo`03o`3jV_oooooooooo06Cooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo00;oo`00X?ooool00ol0003ooooooooo
o`0kooooo`00@Oooool2o`0000?ooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3jV_oo
oooo0?ZJ00Cooooo00?o0?ZJooooooooool00ol0000Mooooo`03o`3jV_oooooo0?ZJ00Sooooo0_l0
nYXKooooo`03o`3jV_oo003oo`0003Sooooo00?o0?ZJool00?l0nYX03?ooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP0>ooooo`;o0?ZJ
TOooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00?ooooo00Go0?ZJoooooooooooo
o`00o`3jVP2Pooooo`03o`000?oooooooooo03_ooooo0011ooooo`03o`000?oooooooooo00;ooooo
00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJooooool0
00000_l0000Mooooo`?o0?ZJ2?ooool2o`3jVQ_ooooo00?o0?ZJool00?l0nYX0>?ooool00ol0nY[o
ooooo`3jVP0<ooooo`03o`000?oooooooooo02Kooooo0_l00003ooooo`05o`3jV_oooooooooooooo
ool0nYX03_ooool2o`3jVY7ooooo00?o0000ooooooooool08oooool2o`0000Cooooo00?o0?ZJoooo
ooooool00_l0nYZOooooo`;o0000?Oooool0047ooooo00?o0000ooooooooool00_ooool01Ol0nY[o
oooooooooooooooo0?ZJ00Gooooo0ol0nYX5ooooo`04o`3jV_ooooooooooo`3jVQoooooo0_l0nYX8
ooooo`;o0?ZJ6oooool00ol0nY[oooooo`3jVP0hooooo`03o`3jV_oooooo0?ZJ00cooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX03_oo
ool2o`3jVY7ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`03ooooo`03o`3jV_oo
oooooooo00;o0?ZJX?ooool00ol0003oooooooooo`0kooooo`00@Oooool00ol0003oooooooooo`02
ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool2o`3jVPGooooo00Co0?ZJoooooooooooo0?ZJ
:Oooool2o`3jVQ_ooooo00?o0?ZJooooool0nYX0>?ooool2o`3jVPgooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX03_ooool2o`3jVY7o
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo00;o
0?ZJX?ooool00ol0003oooooooooo`0kooooo`00@Oooool2o`0000?ooooo00Go0?ZJoooooooooooo
ooooo`3jVP0=ooooo`Co0?ZJ:_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo0?ZJ03So
oooo0_l0nYX=ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool00_ooool01Ol0nY[o
oooooooooooooooo0?ZJ00oooooo00?o0?ZJooooooooool0Soooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool00_l0nYZPooooo`03o`000?oooooooooo
03_ooooo0011ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP0=oooo
o`Co0?ZJAoooool2o`3jVSWooooo00?o0?ZJooooooooool02oooool00ol0003oooooooooo`0Voooo
o`;o00000oooool01Ol0nY[ooooooooooooooooo0?ZJ00oooooo00?o0?ZJooooooooool0Soooool0
0ol0003oooooooooo`0Sooooo`;o00001?ooool00ol0nY[oooooooooo`02o`3jVYoooooo0_l0000m
ooooo`00<oooool5o`0000?ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJoooo
ooooooooooooo`3jVP0=ooooo`Co0?ZJAoooool2o`3jVTOooooo00?o0000ooooooooool06Oooool3
o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJooooooooooooooooo`3j
VP2Qooooo`03o`000?oooooooooo01Kooooo0ol00004ooooo`;o00001?ooool00ol0003ooooooooo
o`03ooooo`03o`3jV_oooooooooo00;o0?ZJX?ooool00ol0003oooooooooo`0kooooo`00=?ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
0_ooool01Ol0nY[ooooooooooooooooo0?ZJ00oooooo0_l0nYX8ooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool06_ooool00ol0nY[oooooooooo`02ooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Hooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJ
ooooooooooooooooo`3jVP0Hooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07ooo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool05Ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJ5oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo03_ooooo000eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000oooool5o`0000;o0?ZJ0_l000000ol0nY[o0000o`00000=o`0000;o0?ZJTOl0000Nooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo1Ol000001Ol0nY[o0000o`000?l0
003o0?ZJ0:;o00005oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000oooool6o`000003o`3jV_l0003o000000;o0?ZJXOl0000mooooo`00=_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool0bOooool2o`0000?ooooo00Co0000oooooooo
oooo0000a_ooool4o`0000?ooooo00Co0000oooooooooooo0000k?ooool003?ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`000<gooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
0000k?ooool003?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
0<Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`000<Oooooo00?o
0000ooooooooool00oooool01?l0003oooooooooool0003/ooooo`00=?ooool3o`0000Cooooo0_l0
003;ooooo`?o00001?ooool2o`000<Wooooo0_l00004ooooo`;o0000kOooool00?ooooooJOooool3
o`000?ooooooIOooool00?ooooooJ_ooool00ol0003oooooooooo`3oooooofCooooo002Dooooo`;o
000000?oooooo`000?l00000dOooool00ol0003oooooooooo`3<ooooo`Go0000TOooool009Gooooo
00?o0000ooooool00000d_ooool00ol0003oooooooooo`3=ooooo`04o`000?ooooooooooo`00097o
oooo002Fooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooool00000coooool00ol0003ooooo
ooooo`2Aooooo`00UOooool00ol0003oooooo`00003Aooooo`03o`000?oooooo00000<gooooo00Co
0000oooooooooooo0000T_ooool009Cooooo0_l000000ooooooo0000o`00003?ooooo`;o000000?o
ooooo`000?l00000c?ooool5o`00097ooooo003ooooooooooooodOooool00?oooooooooooooAoooo
o`00ooooooooooooom7ooooo003ooooooooooooodOooool00?oooooooooooooAooooo`00oooooooo
ooooom7ooooo003ooooooooooooodOooool00?oooooooooooooAooooo`00ooooooooooooom7ooooo
003ooooooooooooodOooool00?oooooooooooooAooooo`00ooooooooooooom7ooooo003ooooooooo
oooodOooool00?oooooooooooooAooooo`00ooooooooooooom7ooooo003ooooooooooooodOooool0
0?oooooooooooooAooooo`00ooooooooooooom7ooooo003ooooooooooooodOooool00?ooooooI_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooo
oomCooooo`00oooooomUooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`3ooooooe;ooooo003ooooooe3ooooo0ol000000ooooooo0000o`000003o`00
0003ooooool0003ooooo00?o00001Oooool01?l0003oooooooooooooool5o`0000Cooooo00?o0000
ooooooooool01Ol00004ooooo`03o`000?oooooooooo0?ooooooDOooool00?ooooooDOooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00001?ooool00ol0003oooooooooo`3ooooooe7ooooo003ooooooe7ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooo`000?l00002ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool0oooooomAooooo`00oooooomAooooo`Co00000_ooool01?l0003oooooo`000?l00002oooo
o`?o00001?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`3ooooooe7ooooo003ooooooe7ooooo00Co0000oooooooo
oooo00000_ooool2o`000005ooooool0003oooooooooool000001oooool01?l0003oooooooooool0
0003ooooo`03o`000?oooooooooo00Gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo0?ooooooD_ooool00?ooooooDOooool01?l0003oooooooooool00002ooooo`;o0000
00Goooooo`000?ooooooooooo`000002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool0
00000oooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool000000_ooool00ol0
003oooooooooo`3ooooooe?ooooo003ooooooe3ooooo0ol000000ooooooo0000o`000002o`000003
ooooool0003o000000Ko00002?ooool3o`0000Wooooo0ol0003ooooooeWooooo003ooooooooooooo
dOooool00?oooooooooooooAooooo`00\
\>"],
  ImageRangeCache->{{{0, 718.125}, {295.312, 0}} -> {-0.194796, -0.0309084, \
0.00472006, 0.00472006}, {{41.25, 253.125}, {288.75, 157.812}} -> {-368.033, \
3.32485, 5.85496, 0.0946406}, {{253.125, 464.938}, {288.75, 157.812}} -> \
{-1608.37, 23.3248, 5.85496, 0.0946406}, {{464.938, 676.812}, {288.75, \
157.812}} -> {-2831.14, -1.34012, 5.85496, 0.0757125}, {{41.25, 253.125}, \
{157.812, 26.875}} -> {-385.598, -100.336, 5.85496, 0.473202}, {{253.125, \
464.938}, {157.812, 26.875}} -> {-1625.93, -114.403, 5.85496, 0.567842}, \
{{464.938, 676.812}, {157.812, 26.875}} -> {-2848.71, -84.4026, 5.85496, \
0.567842}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["YMAX = 5000.", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(5000.`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
sel=Range[T1];
{YF,PF,clik} = 
\tEKF[{ZM[[sel]], X[[sel]]}, Theta+1, 
\t     {driftLorenzX, DdriftLorenzX,diffusionLorenzX, hLorenzX, DhLorenzX, \
RLorenzX, mueLorenzX,sigmaLorenzX,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(clik\\)\\\" is similar to existing symbol \\\
\"\\!\\(lik\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]41\),
      SequenceForm[ "Warnung: Overflow", 41],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]44\),
      SequenceForm[ "Warnung: Overflow", 44],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]49\),
      SequenceForm[ "Warnung: Overflow", 49],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.36439600000000016`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({71.03466677841946`, 110.05990103226164`, 116.9465139771275`, 
      24.40256895206031`, 19.62390147246676`, 
      14.804577753043278`}\)], "Output"],

Cell[BoxData[
    \({{0.08865823710683535`, 0.22384448410174917`, \(-0.976826942594324`\), 
        0.5015049279477162`, \(-0.5593143246927194`\), 
        0.11910491945257236`}, {2.243439929731322`, 3.471451336463461`, 
        3.564917030074782`, 0.5859891536737133`, 0.26810498391190984`, 
        0.45251583844349597`}}\)], "Output"]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,15},{25,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.01{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(yrange\\)\\\" is similar to existing symbol \
\\\"\\!\\(range\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({{\(-30\), 20}, {\(-30\), 30}, {0, 60}, {5, 15}, {25, 35}, {0, 
        8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gEKF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],PlotLabel->\"EKF\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gEKF\\)\\\" is similar to existing symbol \\\
\"\\!\\(EKF\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -11 0 ]
[.5 .42452 11 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -0.309017 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -6 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -6 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(6)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(8)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(10)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(12)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(14)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30902 m
.001 .30902 L
.002 .30902 L
.003 .30902 L
.004 .30902 L
.005 .30902 L
.00599 .30902 L
.00699 .30902 L
.00799 .30902 L
.00899 .30902 L
.00999 .30902 L
.01099 .30902 L
.01199 .30902 L
.01299 .30902 L
.01399 .30902 L
.01499 .30902 L
.01598 .30902 L
.01698 .30902 L
.01798 .30902 L
.01898 .30902 L
.01998 .30902 L
.02098 .30902 L
.02198 .30902 L
.02298 .30902 L
.02398 .30902 L
.02498 .30902 L
.02597 .30902 L
.02697 .30902 L
.02797 .30902 L
.02897 .30902 L
.02997 .30902 L
.03097 .30902 L
.03197 .30902 L
.03297 .30902 L
.03397 .30902 L
.03497 .30902 L
.03596 .30902 L
.03696 .30902 L
.03796 .30902 L
.03896 .30902 L
.03996 .30902 L
.04096 .30902 L
.04196 .30902 L
.04296 .30902 L
.04396 .30902 L
.04496 .30902 L
.04595 .30902 L
.04695 .30902 L
.04795 .30902 L
.04895 .30902 L
Mistroke
.04995 .30902 L
.05095 .30902 L
.05195 .30902 L
.05295 .30902 L
.05395 .30902 L
.05495 .30902 L
.05594 .30902 L
.05694 .30902 L
.05794 .30902 L
.05894 .30902 L
.05994 .30902 L
.06094 .30902 L
.06194 .30902 L
.06294 .30902 L
.06394 .30902 L
.06494 .30902 L
.06593 .30902 L
.06693 .30902 L
.06793 .30902 L
.06893 .30902 L
.06993 .30902 L
.07093 .30902 L
.07193 .30902 L
.07293 .30902 L
.07393 .30902 L
.07493 .30902 L
.07592 .30902 L
.07692 .30902 L
.07792 .30902 L
.07892 .30902 L
.07992 .30902 L
.08092 .30902 L
.08192 .30902 L
.08292 .30902 L
.08392 .30902 L
.08492 .30902 L
.08591 .30902 L
.08691 .30902 L
.08791 .30902 L
.08891 .30902 L
.08991 .30902 L
.09091 .30902 L
.09191 .30902 L
.09291 .30902 L
.09391 .30902 L
.09491 .30902 L
.0959 .30902 L
.0969 .30902 L
.0979 .30902 L
.0989 .30902 L
Mistroke
.0999 .30902 L
.1009 .30902 L
.1019 .30902 L
.1029 .30902 L
.1039 .30902 L
.1049 .30902 L
.10589 .30902 L
.10689 .30902 L
.10789 .30902 L
.10889 .30902 L
.10989 .30902 L
.11089 .30902 L
.11189 .30902 L
.11289 .30902 L
.11389 .30902 L
.11489 .30902 L
.11588 .30902 L
.11688 .30902 L
.11788 .30902 L
.11888 .30902 L
.11988 .30902 L
.12088 .30902 L
.12188 .30902 L
.12288 .30902 L
.12388 .30902 L
.12488 .30902 L
.12587 .30902 L
.12687 .30902 L
.12787 .30902 L
.12887 .30902 L
.12987 .30902 L
.13087 .30902 L
.13187 .30902 L
.13287 .30902 L
.13387 .30902 L
.13487 .30902 L
.13586 .30902 L
.13686 .30902 L
.13786 .30902 L
.13886 .30902 L
.13986 .30902 L
.14086 .30901 L
.14186 .30901 L
.14286 .30901 L
.14386 .30901 L
.14486 .30901 L
.14585 .30901 L
.14685 .30901 L
.14785 .30901 L
.14885 .30901 L
Mistroke
.14985 .30901 L
.15085 .30901 L
.15185 .30901 L
.15285 .30901 L
.15385 .30902 L
.15485 .30902 L
.15584 .30902 L
.15684 .30902 L
.15784 .30902 L
.15884 .30902 L
.15984 .30902 L
.16084 .30902 L
.16184 .30902 L
.16284 .30902 L
.16384 .30902 L
.16484 .30902 L
.16583 .30902 L
.16683 .30902 L
.16783 .30902 L
.16883 .30902 L
.16983 .30902 L
.17083 .30902 L
.17183 .30902 L
.17283 .30902 L
.17383 .30902 L
.17483 .30902 L
.17582 .30902 L
.17682 .30902 L
.17782 .30902 L
.17882 .30902 L
.17982 .30902 L
.18082 .30902 L
.18182 .30902 L
.18282 .30902 L
.18382 .30902 L
.18482 .30902 L
.18581 .30902 L
.18681 .30902 L
.18781 .30902 L
.18881 .30902 L
.18981 .30902 L
.19081 .30902 L
.19181 .30902 L
.19281 .30902 L
.19381 .30902 L
.19481 .30902 L
.1958 .30902 L
.1968 .30902 L
.1978 .30902 L
.1988 .30902 L
Mistroke
.1998 .30902 L
.2008 .30902 L
.2018 .30902 L
.2028 .30902 L
.2038 .30902 L
.2048 .30901 L
.20579 .30902 L
.20679 .30902 L
.20779 .30901 L
.20879 .30902 L
.20979 .30902 L
.21079 .30902 L
.21179 .30902 L
.21279 .30902 L
.21379 .30902 L
.21479 .30902 L
.21578 .30901 L
.21678 .30901 L
.21778 .30901 L
.21878 .30901 L
.21978 .30901 L
.22078 .30901 L
.22178 .30901 L
.22278 .30901 L
.22378 .30901 L
.22478 .30901 L
.22577 .30901 L
.22677 .30901 L
.22777 .30901 L
.22877 .30901 L
.22977 .30901 L
.23077 .30901 L
.23177 .30901 L
.23277 .30901 L
.23377 .30901 L
.23477 .30901 L
.23576 .30901 L
.23676 .30901 L
.23776 .30901 L
.23876 .30901 L
.23976 .30901 L
.24076 .30901 L
.24176 .30901 L
.24276 .30901 L
.24376 .30901 L
.24476 .30901 L
.24575 .30901 L
.24675 .30901 L
.24775 .30901 L
.24875 .30901 L
Mistroke
.24975 .30901 L
.25075 .30901 L
.25175 .30901 L
.25275 .30901 L
.25375 .30901 L
.25475 .30901 L
.25574 .30901 L
.25674 .30901 L
.25774 .30901 L
.25874 .30901 L
.25974 .30901 L
.26074 .30901 L
.26174 .30901 L
.26274 .30901 L
.26374 .30901 L
.26474 .30901 L
.26573 .30901 L
.26673 .30901 L
.26773 .30901 L
.26873 .30901 L
.26973 .30901 L
.27073 .30901 L
.27173 .30901 L
.27273 .30901 L
.27373 .30901 L
.27473 .30901 L
.27572 .30901 L
.27672 .30901 L
.27772 .30901 L
.27872 .30901 L
.27972 .30901 L
.28072 .30901 L
.28172 .30901 L
.28272 .30901 L
.28372 .30901 L
.28472 .30901 L
.28571 .30901 L
.28671 .30901 L
.28771 .30901 L
.28871 .30901 L
.28971 .30901 L
.29071 .30901 L
.29171 .30901 L
.29271 .30901 L
.29371 .30901 L
.29471 .30901 L
.2957 .30901 L
.2967 .30901 L
.2977 .30901 L
.2987 .30901 L
Mistroke
.2997 .30901 L
.3007 .30901 L
.3017 .30901 L
.3027 .30901 L
.3037 .30901 L
.3047 .30901 L
.30569 .30901 L
.30669 .30901 L
.30769 .30901 L
.30869 .30901 L
.30969 .30901 L
.31069 .30901 L
.31169 .30901 L
.31269 .30901 L
.31369 .30901 L
.31469 .30901 L
.31568 .30901 L
.31668 .309 L
.31768 .30901 L
.31868 .30901 L
.31968 .30901 L
.32068 .30901 L
.32168 .30901 L
.32268 .30901 L
.32368 .30901 L
.32468 .30901 L
.32567 .30901 L
.32667 .30901 L
.32767 .309 L
.32867 .309 L
.32967 .309 L
.33067 .309 L
.33167 .309 L
.33267 .309 L
.33367 .309 L
.33467 .309 L
.33566 .309 L
.33666 .309 L
.33766 .309 L
.33866 .309 L
.33966 .309 L
.34066 .309 L
.34166 .309 L
.34266 .309 L
.34366 .309 L
.34466 .309 L
.34565 .309 L
.34665 .309 L
.34765 .309 L
.34865 .309 L
Mistroke
.34965 .309 L
.35065 .309 L
.35165 .309 L
.35265 .309 L
.35365 .309 L
.35465 .309 L
.35564 .309 L
.35664 .309 L
.35764 .309 L
.35864 .309 L
.35964 .309 L
.36064 .309 L
.36164 .309 L
.36264 .309 L
.36364 .309 L
.36464 .309 L
.36563 .309 L
.36663 .309 L
.36763 .309 L
.36863 .309 L
.36963 .309 L
.37063 .309 L
.37163 .309 L
.37263 .309 L
.37363 .309 L
.37463 .309 L
.37562 .309 L
.37662 .309 L
.37762 .309 L
.37862 .309 L
.37962 .309 L
.38062 .309 L
.38162 .309 L
.38262 .309 L
.38362 .309 L
.38462 .309 L
.38561 .309 L
.38661 .309 L
.38761 .309 L
.38861 .309 L
.38961 .309 L
.39061 .309 L
.39161 .309 L
.39261 .309 L
.39361 .309 L
.39461 .309 L
.3956 .309 L
.3966 .309 L
.3976 .309 L
.3986 .309 L
Mistroke
.3996 .309 L
.4006 .309 L
.4016 .309 L
.4026 .309 L
.4036 .309 L
.4046 .309 L
.40559 .309 L
.40659 .309 L
.40759 .309 L
.40859 .309 L
.40959 .309 L
.41059 .309 L
.41159 .309 L
.41259 .309 L
.41359 .309 L
.41459 .309 L
.41558 .309 L
.41658 .309 L
.41758 .309 L
.41858 .309 L
.41958 .309 L
.42058 .309 L
.42158 .309 L
.42258 .309 L
.42358 .30901 L
.42458 .309 L
.42557 .309 L
.42657 .309 L
.42757 .309 L
.42857 .309 L
.42957 .309 L
.43057 .309 L
.43157 .309 L
.43257 .309 L
.43357 .309 L
.43457 .309 L
.43556 .309 L
.43656 .309 L
.43756 .309 L
.43856 .309 L
.43956 .309 L
.44056 .309 L
.44156 .309 L
.44256 .309 L
.44356 .309 L
.44456 .309 L
.44555 .309 L
.44655 .309 L
.44755 .309 L
.44855 .309 L
Mistroke
.44955 .309 L
.45055 .309 L
.45155 .309 L
.45255 .309 L
.45355 .309 L
.45455 .309 L
.45554 .309 L
.45654 .309 L
.45754 .309 L
.45854 .309 L
.45954 .309 L
.46054 .309 L
.46154 .309 L
.46254 .309 L
.46354 .309 L
.46454 .309 L
.46553 .309 L
.46653 .309 L
.46753 .309 L
.46853 .309 L
.46953 .309 L
.47053 .309 L
.47153 .309 L
.47253 .309 L
.47353 .309 L
.47453 .309 L
.47552 .309 L
.47652 .309 L
.47752 .309 L
.47852 .309 L
.47952 .309 L
.48052 .309 L
.48152 .309 L
.48252 .309 L
.48352 .309 L
.48452 .309 L
.48551 .309 L
.48651 .309 L
.48751 .309 L
.48851 .309 L
.48951 .309 L
.49051 .309 L
.49151 .309 L
.49251 .309 L
.49351 .309 L
.49451 .309 L
.4955 .309 L
.4965 .309 L
.4975 .309 L
.4985 .309 L
Mistroke
.4995 .309 L
.5005 .309 L
.5015 .309 L
.5025 .309 L
.5035 .309 L
.5045 .309 L
.50549 .309 L
.50649 .30901 L
.50749 .30901 L
.50849 .30901 L
.50949 .30901 L
.51049 .30901 L
.51149 .30901 L
.51249 .30901 L
.51349 .30901 L
.51449 .30901 L
.51548 .30901 L
.51648 .30901 L
.51748 .30901 L
.51848 .30901 L
.51948 .30901 L
.52048 .30901 L
.52148 .30901 L
.52248 .30901 L
.52348 .30901 L
.52448 .30901 L
.52547 .30901 L
.52647 .30901 L
.52747 .30901 L
.52847 .30901 L
.52947 .30901 L
.53047 .30901 L
.53147 .30901 L
.53247 .30901 L
.53347 .30901 L
.53447 .30901 L
.53546 .30901 L
.53646 .30901 L
.53746 .30901 L
.53846 .30901 L
.53946 .30901 L
.54046 .30901 L
.54146 .30901 L
.54246 .30901 L
.54346 .30901 L
.54446 .30901 L
.54545 .30901 L
.54645 .30901 L
.54745 .30901 L
.54845 .30901 L
Mistroke
.54945 .30901 L
.55045 .30901 L
.55145 .30901 L
.55245 .30901 L
.55345 .30901 L
.55445 .30901 L
.55544 .30901 L
.55644 .30901 L
.55744 .30901 L
.55844 .30901 L
.55944 .30901 L
.56044 .30901 L
.56144 .30901 L
.56244 .30901 L
.56344 .30901 L
.56444 .30901 L
.56543 .30901 L
.56643 .30901 L
.56743 .30901 L
.56843 .30901 L
.56943 .30901 L
.57043 .30901 L
.57143 .30901 L
.57243 .30901 L
.57343 .30901 L
.57443 .30901 L
.57542 .30901 L
.57642 .30901 L
.57742 .30901 L
.57842 .30901 L
.57942 .30901 L
.58042 .30901 L
.58142 .30901 L
.58242 .30901 L
.58342 .30901 L
.58442 .30901 L
.58541 .30901 L
.58641 .30901 L
.58741 .30901 L
.58841 .30901 L
.58941 .30901 L
.59041 .30901 L
.59141 .30901 L
.59241 .30901 L
.59341 .30901 L
.59441 .30901 L
.5954 .30901 L
.5964 .30901 L
.5974 .30901 L
.5984 .30901 L
Mistroke
.5994 .30901 L
.6004 .30901 L
.6014 .30901 L
.6024 .30901 L
.6034 .30901 L
.6044 .30901 L
.60539 .30901 L
.60639 .30901 L
.60739 .30901 L
.60839 .30901 L
.60939 .30901 L
.61039 .30901 L
.61139 .30901 L
.61239 .30901 L
.61339 .30901 L
.61439 .30901 L
.61538 .30901 L
.61638 .30901 L
.61738 .30901 L
.61838 .30901 L
.61938 .30901 L
.62038 .30901 L
.62138 .30901 L
.62238 .30901 L
.62338 .30901 L
.62438 .30901 L
.62537 .30901 L
.62637 .30901 L
.62737 .30901 L
.62837 .30901 L
.62937 .30901 L
.63037 .30901 L
.63137 .30901 L
.63237 .30901 L
.63337 .30901 L
.63437 .30901 L
.63536 .30901 L
.63636 .30901 L
.63736 .30901 L
.63836 .30901 L
.63936 .30901 L
.64036 .30901 L
.64136 .30901 L
.64236 .30901 L
.64336 .30901 L
.64436 .30901 L
.64535 .30901 L
.64635 .30901 L
.64735 .30901 L
.64835 .30901 L
Mistroke
.64935 .30901 L
.65035 .30901 L
.65135 .30901 L
.65235 .30901 L
.65335 .30901 L
.65435 .30901 L
.65534 .30901 L
.65634 .30901 L
.65734 .30901 L
.65834 .30901 L
.65934 .30901 L
.66034 .30901 L
.66134 .30901 L
.66234 .30901 L
.66334 .30901 L
.66434 .30901 L
.66533 .30901 L
.66633 .30901 L
.66733 .30901 L
.66833 .30901 L
.66933 .30901 L
.67033 .30901 L
.67133 .30901 L
.67233 .30901 L
.67333 .30901 L
.67433 .30901 L
.67532 .30901 L
.67632 .30901 L
.67732 .30901 L
.67832 .30901 L
.67932 .30901 L
.68032 .30901 L
.68132 .30901 L
.68232 .30901 L
.68332 .30901 L
.68432 .30901 L
.68531 .30901 L
.68631 .30901 L
.68731 .30901 L
.68831 .30901 L
.68931 .30901 L
.69031 .30901 L
.69131 .30901 L
.69231 .30901 L
.69331 .30901 L
.69431 .30901 L
.6953 .30901 L
.6963 .30901 L
.6973 .30901 L
.6983 .30901 L
Mistroke
.6993 .30901 L
.7003 .30901 L
.7013 .30901 L
.7023 .30901 L
.7033 .30901 L
.7043 .30901 L
.70529 .30901 L
.70629 .30901 L
.70729 .30901 L
.70829 .30901 L
.70929 .30901 L
.71029 .30901 L
.71129 .30901 L
.71229 .30901 L
.71329 .30901 L
.71429 .30901 L
.71528 .30901 L
.71628 .30901 L
.71728 .30901 L
.71828 .30901 L
.71928 .30901 L
.72028 .30901 L
.72128 .309 L
.72228 .309 L
.72328 .309 L
.72428 .309 L
.72527 .309 L
.72627 .309 L
.72727 .309 L
.72827 .309 L
.72927 .309 L
.73027 .309 L
.73127 .309 L
.73227 .309 L
.73327 .309 L
.73427 .309 L
.73526 .309 L
.73626 .30901 L
.73726 .30901 L
.73826 .30901 L
.73926 .30901 L
.74026 .30901 L
.74126 .30901 L
.74226 .30901 L
.74326 .30901 L
.74426 .30901 L
.74525 .30901 L
.74625 .30901 L
.74725 .30901 L
.74825 .30901 L
Mistroke
.74925 .30901 L
.75025 .30901 L
.75125 .30901 L
.75225 .30901 L
.75325 .30901 L
.75425 .30901 L
.75524 .30901 L
.75624 .30901 L
.75724 .30901 L
.75824 .30901 L
.75924 .30901 L
.76024 .30901 L
.76124 .30901 L
.76224 .30901 L
.76324 .30901 L
.76424 .30901 L
.76523 .30901 L
.76623 .30901 L
.76723 .30901 L
.76823 .30901 L
.76923 .30901 L
.77023 .30901 L
.77123 .30901 L
.77223 .30901 L
.77323 .30901 L
.77423 .30901 L
.77522 .30901 L
.77622 .30901 L
.77722 .30901 L
.77822 .30901 L
.77922 .30901 L
.78022 .30901 L
.78122 .30901 L
.78222 .30901 L
.78322 .30901 L
.78422 .30901 L
.78521 .30901 L
.78621 .30901 L
.78721 .30901 L
.78821 .30901 L
.78921 .30901 L
.79021 .30901 L
.79121 .30901 L
.79221 .30901 L
.79321 .30901 L
.79421 .30901 L
.7952 .30901 L
.7962 .30901 L
.7972 .30901 L
.7982 .30901 L
Mistroke
.7992 .30901 L
.8002 .30901 L
.8012 .30901 L
.8022 .30901 L
.8032 .30901 L
.8042 .30901 L
.80519 .309 L
.80619 .309 L
.80719 .309 L
.80819 .309 L
.80919 .309 L
.81019 .30901 L
.81119 .309 L
.81219 .309 L
.81319 .309 L
.81419 .309 L
.81518 .309 L
.81618 .309 L
.81718 .309 L
.81818 .309 L
.81918 .309 L
.82018 .309 L
.82118 .309 L
.82218 .309 L
.82318 .309 L
.82418 .309 L
.82517 .309 L
.82617 .309 L
.82717 .309 L
.82817 .309 L
.82917 .309 L
.83017 .309 L
.83117 .309 L
.83217 .309 L
.83317 .309 L
.83417 .309 L
.83516 .309 L
.83616 .309 L
.83716 .309 L
.83816 .309 L
.83916 .309 L
.84016 .309 L
.84116 .309 L
.84216 .309 L
.84316 .309 L
.84416 .309 L
.84515 .309 L
.84615 .309 L
.84715 .309 L
.84815 .309 L
Mistroke
.84915 .309 L
.85015 .309 L
.85115 .309 L
.85215 .309 L
.85315 .309 L
.85415 .309 L
.85514 .309 L
.85614 .309 L
.85714 .309 L
.85814 .309 L
.85914 .309 L
.86014 .309 L
.86114 .309 L
.86214 .309 L
.86314 .309 L
.86414 .309 L
.86513 .309 L
.86613 .309 L
.86713 .309 L
.86813 .309 L
.86913 .309 L
.87013 .309 L
.87113 .309 L
.87213 .309 L
.87313 .309 L
.87413 .309 L
.87512 .309 L
.87612 .309 L
.87712 .309 L
.87812 .309 L
.87912 .309 L
.88012 .30901 L
.88112 .309 L
.88212 .30901 L
.88312 .30901 L
.88412 .30901 L
.88511 .309 L
.88611 .309 L
.88711 .309 L
.88811 .309 L
.88911 .309 L
.89011 .309 L
.89111 .309 L
.89211 .309 L
.89311 .309 L
.89411 .309 L
.8951 .309 L
.8961 .309 L
.8971 .309 L
.8981 .309 L
Mistroke
.8991 .309 L
.9001 .309 L
.9011 .309 L
.9021 .309 L
.9031 .309 L
.9041 .309 L
.90509 .309 L
.90609 .309 L
.90709 .309 L
.90809 .309 L
.90909 .309 L
.91009 .309 L
.91109 .309 L
.91209 .309 L
.91309 .309 L
.91409 .309 L
.91508 .309 L
.91608 .309 L
.91708 .309 L
.91808 .309 L
.91908 .309 L
.92008 .309 L
.92108 .309 L
.92208 .309 L
.92308 .309 L
.92408 .309 L
.92507 .309 L
.92607 .309 L
.92707 .30901 L
.92807 .30901 L
.92907 .30901 L
.93007 .30901 L
.93107 .30901 L
.93207 .30901 L
.93307 .30901 L
.93407 .30901 L
.93506 .30901 L
.93606 .30901 L
.93706 .30901 L
.93806 .30901 L
.93906 .30901 L
.94006 .30901 L
.94106 .30901 L
.94206 .30901 L
.94306 .30901 L
.94406 .30901 L
.94505 .30901 L
.94605 .30901 L
.94705 .30901 L
.94805 .30901 L
Mistroke
.94905 .30901 L
.95005 .30901 L
.95105 .309 L
.95205 .309 L
.95305 .309 L
.95405 .309 L
.95504 .309 L
.95604 .309 L
.95704 .309 L
.95804 .309 L
.95904 .309 L
.96004 .309 L
.96104 .309 L
.96204 .30901 L
.96304 .30901 L
.96404 .30901 L
.96503 .30901 L
.96603 .30901 L
.96703 .30901 L
.96803 .30901 L
.96903 .30901 L
.97003 .30901 L
.97103 .30901 L
.97203 .309 L
.97303 .309 L
.97403 .30901 L
.97502 .309 L
.97602 .309 L
.97702 .309 L
.97802 .309 L
.97902 .309 L
.98002 .309 L
.98102 .309 L
.98202 .309 L
.98302 .309 L
.98402 .309 L
.98501 .309 L
.98601 .309 L
.98701 .309 L
.98801 .309 L
.98901 .309 L
.99001 .309 L
.99101 .309 L
.99201 .309 L
.99301 .309 L
.99401 .309 L
.995 .309 L
.996 .309 L
.997 .309 L
.998 .309 L
Mistroke
.999 .309 L
Mfstroke
0 .98 .604 r
gsave
.999 .20894 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .24969 m
.001 .24969 L
.002 .24969 L
.003 .24969 L
.004 .24969 L
.005 .24969 L
.00599 .24969 L
.00699 .24969 L
.00799 .24969 L
.00899 .24969 L
.00999 .24969 L
.01099 .24969 L
.01199 .24969 L
.01299 .24969 L
.01399 .24969 L
.01499 .24969 L
.01598 .24969 L
.01698 .24969 L
.01798 .24969 L
.01898 .24969 L
.01998 .24969 L
.02098 .24969 L
.02198 .24969 L
.02298 .24969 L
.02398 .24969 L
.02498 .24969 L
.02597 .24969 L
.02697 .24969 L
.02797 .24969 L
.02897 .24969 L
.02997 .24969 L
.03097 .24969 L
.03197 .24969 L
.03297 .24969 L
.03397 .24969 L
.03497 .24969 L
.03596 .24969 L
.03696 .24969 L
.03796 .24969 L
.03896 .24969 L
.03996 .24969 L
.04096 .24969 L
.04196 .24969 L
.04296 .24969 L
.04396 .24969 L
.04496 .24969 L
.04595 .24969 L
.04695 .24969 L
.04795 .24969 L
.04895 .24969 L
Mistroke
.04995 .24788 L
.05095 .24788 L
.05195 .24788 L
.05295 .24788 L
.05395 .24788 L
.05495 .24788 L
.05594 .24788 L
.05694 .24788 L
.05794 .24788 L
.05894 .24788 L
.05994 .24788 L
.06094 .24788 L
.06194 .24788 L
.06294 .24788 L
.06394 .24788 L
.06494 .24788 L
.06593 .24788 L
.06693 .24788 L
.06793 .24788 L
.06893 .24788 L
.06993 .24788 L
.07093 .24788 L
.07193 .24788 L
.07293 .24788 L
.07393 .24788 L
.07493 .24788 L
.07592 .24788 L
.07692 .24788 L
.07792 .24788 L
.07892 .24788 L
.07992 .24788 L
.08092 .24788 L
.08192 .24788 L
.08292 .24788 L
.08392 .24788 L
.08492 .24788 L
.08591 .24788 L
.08691 .24788 L
.08791 .24788 L
.08891 .24788 L
.08991 .24788 L
.09091 .24788 L
.09191 .24788 L
.09291 .24788 L
.09391 .24788 L
.09491 .24788 L
.0959 .24788 L
.0969 .24788 L
.0979 .24788 L
.0989 .24788 L
Mistroke
.0999 .22475 L
.1009 .22475 L
.1019 .22475 L
.1029 .22475 L
.1039 .22475 L
.1049 .22475 L
.10589 .22475 L
.10689 .22475 L
.10789 .22475 L
.10889 .22475 L
.10989 .22475 L
.11089 .22475 L
.11189 .22475 L
.11289 .22475 L
.11389 .22475 L
.11489 .22475 L
.11588 .22475 L
.11688 .22475 L
.11788 .22475 L
.11888 .22475 L
.11988 .22475 L
.12088 .22475 L
.12188 .22475 L
.12288 .22475 L
.12388 .22475 L
.12488 .22475 L
.12587 .22475 L
.12687 .22475 L
.12787 .22475 L
.12887 .22475 L
.12987 .22475 L
.13087 .22475 L
.13187 .22475 L
.13287 .22475 L
.13387 .22475 L
.13487 .22475 L
.13586 .22475 L
.13686 .22475 L
.13786 .22475 L
.13886 .22475 L
.13986 .22475 L
.14086 .22475 L
.14186 .22475 L
.14286 .22475 L
.14386 .22475 L
.14486 .22475 L
.14585 .22475 L
.14685 .22475 L
.14785 .22475 L
.14885 .22475 L
Mistroke
.14985 .20071 L
.15085 .20071 L
.15185 .20071 L
.15285 .20071 L
.15385 .20071 L
.15485 .20071 L
.15584 .20071 L
.15684 .20071 L
.15784 .20071 L
.15884 .20071 L
.15984 .20071 L
.16084 .20071 L
.16184 .20071 L
.16284 .20071 L
.16384 .20071 L
.16484 .20071 L
.16583 .20071 L
.16683 .20071 L
.16783 .20071 L
.16883 .20071 L
.16983 .20071 L
.17083 .20071 L
.17183 .20071 L
.17283 .20071 L
.17383 .20071 L
.17483 .20071 L
.17582 .20071 L
.17682 .20071 L
.17782 .20071 L
.17882 .20071 L
.17982 .20071 L
.18082 .20071 L
.18182 .20071 L
.18282 .20071 L
.18382 .20071 L
.18482 .20071 L
.18581 .20071 L
.18681 .20071 L
.18781 .20071 L
.18881 .20071 L
.18981 .20071 L
.19081 .20071 L
.19181 .20071 L
.19281 .20071 L
.19381 .20071 L
.19481 .20071 L
.1958 .20071 L
.1968 .20071 L
.1978 .20071 L
.1988 .20071 L
Mistroke
.1998 .16915 L
.2008 .16915 L
.2018 .16915 L
.2028 .16915 L
.2038 .16915 L
.2048 .16915 L
.20579 .16915 L
.20679 .16915 L
.20779 .16915 L
.20879 .16915 L
.20979 .16915 L
.21079 .16915 L
.21179 .16915 L
.21279 .16915 L
.21379 .16915 L
.21479 .16915 L
.21578 .16915 L
.21678 .16915 L
.21778 .16915 L
.21878 .16915 L
.21978 .16915 L
.22078 .16915 L
.22178 .16915 L
.22278 .16915 L
.22378 .16915 L
.22478 .16915 L
.22577 .16915 L
.22677 .16915 L
.22777 .16915 L
.22877 .16915 L
.22977 .16915 L
.23077 .16915 L
.23177 .16915 L
.23277 .16915 L
.23377 .16915 L
.23477 .16915 L
.23576 .16915 L
.23676 .16915 L
.23776 .16915 L
.23876 .16915 L
.23976 .16915 L
.24076 .16915 L
.24176 .16915 L
.24276 .16915 L
.24376 .16915 L
.24476 .16915 L
.24575 .16915 L
.24675 .16915 L
.24775 .16915 L
.24875 .16915 L
Mistroke
.24975 .17911 L
.25075 .17911 L
.25175 .17911 L
.25275 .17911 L
.25375 .17911 L
.25475 .17911 L
.25574 .17911 L
.25674 .17911 L
.25774 .17911 L
.25874 .17911 L
.25974 .17911 L
.26074 .17911 L
.26174 .17911 L
.26274 .17911 L
.26374 .17911 L
.26474 .17911 L
.26573 .17911 L
.26673 .17911 L
.26773 .17911 L
.26873 .17911 L
.26973 .17911 L
.27073 .17911 L
.27173 .17911 L
.27273 .17911 L
.27373 .17911 L
.27473 .17911 L
.27572 .17911 L
.27672 .17911 L
.27772 .17911 L
.27872 .17911 L
.27972 .17911 L
.28072 .17911 L
.28172 .17911 L
.28272 .17911 L
.28372 .17911 L
.28472 .17911 L
.28571 .17911 L
.28671 .17911 L
.28771 .17911 L
.28871 .17911 L
.28971 .17911 L
.29071 .17911 L
.29171 .17911 L
.29271 .17911 L
.29371 .17911 L
.29471 .17911 L
.2957 .17911 L
.2967 .17911 L
.2977 .17911 L
.2987 .17911 L
Mistroke
.2997 .18615 L
.3007 .18615 L
.3017 .18615 L
.3027 .18615 L
.3037 .18615 L
.3047 .18615 L
.30569 .18615 L
.30669 .18615 L
.30769 .18615 L
.30869 .18615 L
.30969 .18615 L
.31069 .18615 L
.31169 .18615 L
.31269 .18615 L
.31369 .18615 L
.31469 .18615 L
.31568 .18615 L
.31668 .18615 L
.31768 .18615 L
.31868 .18615 L
.31968 .18615 L
.32068 .18615 L
.32168 .18615 L
.32268 .18615 L
.32368 .18615 L
.32468 .18615 L
.32567 .18615 L
.32667 .18615 L
.32767 .18615 L
.32867 .18615 L
.32967 .18615 L
.33067 .18615 L
.33167 .18615 L
.33267 .18615 L
.33367 .18615 L
.33467 .18615 L
.33566 .18615 L
.33666 .18615 L
.33766 .18615 L
.33866 .18615 L
.33966 .18615 L
.34066 .18615 L
.34166 .18615 L
.34266 .18615 L
.34366 .18615 L
.34466 .18615 L
.34565 .18615 L
.34665 .18615 L
.34765 .18615 L
.34865 .18615 L
Mistroke
.34965 .17936 L
.35065 .17936 L
.35165 .17936 L
.35265 .17936 L
.35365 .17936 L
.35465 .17936 L
.35564 .17936 L
.35664 .17936 L
.35764 .17936 L
.35864 .17936 L
.35964 .17936 L
.36064 .17936 L
.36164 .17936 L
.36264 .17936 L
.36364 .17936 L
.36464 .17936 L
.36563 .17936 L
.36663 .17936 L
.36763 .17936 L
.36863 .17936 L
.36963 .17936 L
.37063 .17936 L
.37163 .17936 L
.37263 .17936 L
.37363 .17936 L
.37463 .17936 L
.37562 .17936 L
.37662 .17936 L
.37762 .17936 L
.37862 .17936 L
.37962 .17936 L
.38062 .17936 L
.38162 .17936 L
.38262 .17936 L
.38362 .17936 L
.38462 .17936 L
.38561 .17936 L
.38661 .17936 L
.38761 .17936 L
.38861 .17936 L
.38961 .17936 L
.39061 .17936 L
.39161 .17936 L
.39261 .17936 L
.39361 .17936 L
.39461 .17936 L
.3956 .17936 L
.3966 .17936 L
.3976 .17936 L
.3986 .17936 L
Mistroke
.3996 .1509 L
.4006 .1509 L
.4016 .1509 L
.4026 .1509 L
.4036 .1509 L
.4046 .1509 L
.40559 .1509 L
.40659 .1509 L
.40759 .1509 L
.40859 .1509 L
.40959 .1509 L
.41059 .1509 L
.41159 .1509 L
.41259 .1509 L
.41359 .1509 L
.41459 .1509 L
.41558 .1509 L
.41658 .1509 L
.41758 .1509 L
.41858 .1509 L
.41958 .1509 L
.42058 .1509 L
.42158 .1509 L
.42258 .1509 L
.42358 .1509 L
.42458 .1509 L
.42557 .1509 L
.42657 .1509 L
.42757 .1509 L
.42857 .1509 L
.42957 .1509 L
.43057 .1509 L
.43157 .1509 L
.43257 .1509 L
.43357 .1509 L
.43457 .1509 L
.43556 .1509 L
.43656 .1509 L
.43756 .1509 L
.43856 .1509 L
.43956 .1509 L
.44056 .1509 L
.44156 .1509 L
.44256 .1509 L
.44356 .1509 L
.44456 .1509 L
.44555 .1509 L
.44655 .1509 L
.44755 .1509 L
.44855 .1509 L
Mistroke
.44955 .17367 L
.45055 .17367 L
.45155 .17367 L
.45255 .17367 L
.45355 .17367 L
.45455 .17367 L
.45554 .17367 L
.45654 .17367 L
.45754 .17367 L
.45854 .17367 L
.45954 .17367 L
.46054 .17367 L
.46154 .17367 L
.46254 .17367 L
.46354 .17367 L
.46454 .17367 L
.46553 .17367 L
.46653 .17367 L
.46753 .17367 L
.46853 .17367 L
.46953 .17367 L
.47053 .17367 L
.47153 .17367 L
.47253 .17367 L
.47353 .17367 L
.47453 .17367 L
.47552 .17367 L
.47652 .17367 L
.47752 .17367 L
.47852 .17367 L
.47952 .17367 L
.48052 .17367 L
.48152 .17367 L
.48252 .17367 L
.48352 .17367 L
.48452 .17367 L
.48551 .17367 L
.48651 .17367 L
.48751 .17367 L
.48851 .17367 L
.48951 .17367 L
.49051 .17367 L
.49151 .17367 L
.49251 .17367 L
.49351 .17367 L
.49451 .17367 L
.4955 .17367 L
.4965 .17367 L
.4975 .17367 L
.4985 .17367 L
Mistroke
.4995 .18254 L
.5005 .18254 L
.5015 .18254 L
.5025 .18254 L
.5035 .18254 L
.5045 .18254 L
.50549 .18254 L
.50649 .18254 L
.50749 .18254 L
.50849 .18254 L
.50949 .18254 L
.51049 .18254 L
.51149 .18254 L
.51249 .18254 L
.51349 .18254 L
.51449 .18254 L
.51548 .18254 L
.51648 .18254 L
.51748 .18254 L
.51848 .18254 L
.51948 .18254 L
.52048 .18254 L
.52148 .18254 L
.52248 .18254 L
.52348 .18254 L
.52448 .18254 L
.52547 .18254 L
.52647 .18254 L
.52747 .18254 L
.52847 .18254 L
.52947 .18254 L
.53047 .18254 L
.53147 .18254 L
.53247 .18254 L
.53347 .18254 L
.53447 .18254 L
.53546 .18254 L
.53646 .18254 L
.53746 .18254 L
.53846 .18254 L
.53946 .18254 L
.54046 .18254 L
.54146 .18254 L
.54246 .18254 L
.54346 .18254 L
.54446 .18254 L
.54545 .18254 L
.54645 .18254 L
.54745 .18254 L
.54845 .18254 L
Mistroke
.54945 .18192 L
.55045 .18192 L
.55145 .18192 L
.55245 .18192 L
.55345 .18192 L
.55445 .18192 L
.55544 .18192 L
.55644 .18192 L
.55744 .18192 L
.55844 .18192 L
.55944 .18192 L
.56044 .18192 L
.56144 .18192 L
.56244 .18192 L
.56344 .18192 L
.56444 .18192 L
.56543 .18192 L
.56643 .18192 L
.56743 .18192 L
.56843 .18192 L
.56943 .18192 L
.57043 .18192 L
.57143 .18192 L
.57243 .18192 L
.57343 .18192 L
.57443 .18192 L
.57542 .18192 L
.57642 .18192 L
.57742 .18192 L
.57842 .18192 L
.57942 .18192 L
.58042 .18192 L
.58142 .18192 L
.58242 .18192 L
.58342 .18192 L
.58442 .18192 L
.58541 .18192 L
.58641 .18192 L
.58741 .18192 L
.58841 .18192 L
.58941 .18192 L
.59041 .18192 L
.59141 .18192 L
.59241 .18192 L
.59341 .18192 L
.59441 .18192 L
.5954 .18192 L
.5964 .18192 L
.5974 .18192 L
.5984 .18192 L
Mistroke
.5994 .17734 L
.6004 .17734 L
.6014 .17734 L
.6024 .17734 L
.6034 .17734 L
.6044 .17734 L
.60539 .17734 L
.60639 .17734 L
.60739 .17734 L
.60839 .17734 L
.60939 .17734 L
.61039 .17734 L
.61139 .17734 L
.61239 .17734 L
.61339 .17734 L
.61439 .17734 L
.61538 .17734 L
.61638 .17734 L
.61738 .17734 L
.61838 .17734 L
.61938 .17734 L
.62038 .17734 L
.62138 .17734 L
.62238 .17734 L
.62338 .17734 L
.62438 .17734 L
.62537 .17734 L
.62637 .17734 L
.62737 .17734 L
.62837 .17734 L
.62937 .17734 L
.63037 .17734 L
.63137 .17734 L
.63237 .17734 L
.63337 .17734 L
.63437 .17734 L
.63536 .17734 L
.63636 .17734 L
.63736 .17734 L
.63836 .17734 L
.63936 .17734 L
.64036 .17734 L
.64136 .17734 L
.64236 .17734 L
.64336 .17734 L
.64436 .17734 L
.64535 .17734 L
.64635 .17734 L
.64735 .17734 L
.64835 .17734 L
Mistroke
.64935 .1889 L
.65035 .1889 L
.65135 .1889 L
.65235 .1889 L
.65335 .1889 L
.65435 .1889 L
.65534 .1889 L
.65634 .1889 L
.65734 .1889 L
.65834 .1889 L
.65934 .1889 L
.66034 .1889 L
.66134 .1889 L
.66234 .1889 L
.66334 .1889 L
.66434 .1889 L
.66533 .1889 L
.66633 .1889 L
.66733 .1889 L
.66833 .1889 L
.66933 .1889 L
.67033 .1889 L
.67133 .1889 L
.67233 .1889 L
.67333 .1889 L
.67433 .1889 L
.67532 .1889 L
.67632 .1889 L
.67732 .1889 L
.67832 .1889 L
.67932 .1889 L
.68032 .1889 L
.68132 .1889 L
.68232 .1889 L
.68332 .1889 L
.68432 .1889 L
.68531 .1889 L
.68631 .1889 L
.68731 .1889 L
.68831 .1889 L
.68931 .1889 L
.69031 .1889 L
.69131 .1889 L
.69231 .1889 L
.69331 .1889 L
.69431 .1889 L
.6953 .1889 L
.6963 .1889 L
.6973 .1889 L
.6983 .1889 L
Mistroke
.6993 .19345 L
.7003 .19345 L
.7013 .19345 L
.7023 .19345 L
.7033 .19345 L
.7043 .19345 L
.70529 .19345 L
.70629 .19345 L
.70729 .19345 L
.70829 .19345 L
.70929 .19345 L
.71029 .19345 L
.71129 .19345 L
.71229 .19345 L
.71329 .19345 L
.71429 .19345 L
.71528 .19345 L
.71628 .19345 L
.71728 .19345 L
.71828 .19345 L
.71928 .19345 L
.72028 .19345 L
.72128 .19345 L
.72228 .19345 L
.72328 .19345 L
.72428 .19345 L
.72527 .19345 L
.72627 .19345 L
.72727 .19345 L
.72827 .19345 L
.72927 .19345 L
.73027 .19345 L
.73127 .19345 L
.73227 .19345 L
.73327 .19345 L
.73427 .19345 L
.73526 .19345 L
.73626 .19345 L
.73726 .19345 L
.73826 .19345 L
.73926 .19345 L
.74026 .19345 L
.74126 .19345 L
.74226 .19345 L
.74326 .19345 L
.74426 .19345 L
.74525 .19345 L
.74625 .19345 L
.74725 .19345 L
.74825 .19345 L
Mistroke
.74925 .19566 L
.75025 .19566 L
.75125 .19566 L
.75225 .19566 L
.75325 .19566 L
.75425 .19566 L
.75524 .19566 L
.75624 .19566 L
.75724 .19566 L
.75824 .19566 L
.75924 .19566 L
.76024 .19566 L
.76124 .19566 L
.76224 .19566 L
.76324 .19566 L
.76424 .19566 L
.76523 .19566 L
.76623 .19566 L
.76723 .19566 L
.76823 .19566 L
.76923 .19566 L
.77023 .19566 L
.77123 .19566 L
.77223 .19566 L
.77323 .19566 L
.77423 .19566 L
.77522 .19566 L
.77622 .19566 L
.77722 .19566 L
.77822 .19566 L
.77922 .19566 L
.78022 .19566 L
.78122 .19566 L
.78222 .19566 L
.78322 .19566 L
.78422 .19566 L
.78521 .19566 L
.78621 .19566 L
.78721 .19566 L
.78821 .19566 L
.78921 .19566 L
.79021 .19566 L
.79121 .19566 L
.79221 .19566 L
.79321 .19566 L
.79421 .19566 L
.7952 .19566 L
.7962 .19566 L
.7972 .19566 L
.7982 .19566 L
Mistroke
.7992 .1884 L
.8002 .1884 L
.8012 .1884 L
.8022 .1884 L
.8032 .1884 L
.8042 .1884 L
.80519 .1884 L
.80619 .1884 L
.80719 .1884 L
.80819 .1884 L
.80919 .1884 L
.81019 .1884 L
.81119 .1884 L
.81219 .1884 L
.81319 .1884 L
.81419 .1884 L
.81518 .1884 L
.81618 .1884 L
.81718 .1884 L
.81818 .1884 L
.81918 .1884 L
.82018 .1884 L
.82118 .1884 L
.82218 .1884 L
.82318 .1884 L
.82418 .1884 L
.82517 .1884 L
.82617 .1884 L
.82717 .1884 L
.82817 .1884 L
.82917 .1884 L
.83017 .1884 L
.83117 .1884 L
.83217 .1884 L
.83317 .1884 L
.83417 .1884 L
.83516 .1884 L
.83616 .1884 L
.83716 .1884 L
.83816 .1884 L
.83916 .1884 L
.84016 .1884 L
.84116 .1884 L
.84216 .1884 L
.84316 .1884 L
.84416 .1884 L
.84515 .1884 L
.84615 .1884 L
.84715 .1884 L
.84815 .1884 L
Mistroke
.84915 .19256 L
.85015 .19256 L
.85115 .19256 L
.85215 .19256 L
.85315 .19256 L
.85415 .19256 L
.85514 .19256 L
.85614 .19256 L
.85714 .19256 L
.85814 .19256 L
.85914 .19256 L
.86014 .19256 L
.86114 .19256 L
.86214 .19256 L
.86314 .19256 L
.86414 .19256 L
.86513 .19256 L
.86613 .19256 L
.86713 .19256 L
.86813 .19256 L
.86913 .19256 L
.87013 .19256 L
.87113 .19256 L
.87213 .19256 L
.87313 .19256 L
.87413 .19256 L
.87512 .19256 L
.87612 .19256 L
.87712 .19256 L
.87812 .19256 L
.87912 .19256 L
.88012 .19256 L
.88112 .19256 L
.88212 .19256 L
.88312 .19256 L
.88412 .19256 L
.88511 .19256 L
.88611 .19256 L
.88711 .19256 L
.88811 .19256 L
.88911 .19256 L
.89011 .19256 L
.89111 .19256 L
.89211 .19256 L
.89311 .19256 L
.89411 .19256 L
.8951 .19256 L
.8961 .19256 L
.8971 .19256 L
.8981 .19256 L
Mistroke
.8991 .20099 L
.9001 .20099 L
.9011 .20099 L
.9021 .20099 L
.9031 .20099 L
.9041 .20099 L
.90509 .20099 L
.90609 .20099 L
.90709 .20099 L
.90809 .20099 L
.90909 .20099 L
.91009 .20099 L
.91109 .20099 L
.91209 .20099 L
.91309 .20099 L
.91409 .20099 L
.91508 .20099 L
.91608 .20099 L
.91708 .20099 L
.91808 .20099 L
.91908 .20099 L
.92008 .20099 L
.92108 .20099 L
.92208 .20099 L
.92308 .20099 L
.92408 .20099 L
.92507 .20099 L
.92607 .20099 L
.92707 .20099 L
.92807 .20099 L
.92907 .20099 L
.93007 .20099 L
.93107 .20099 L
.93207 .20099 L
.93307 .20099 L
.93407 .20099 L
.93506 .20099 L
.93606 .20099 L
.93706 .20099 L
.93806 .20099 L
.93906 .20099 L
.94006 .20099 L
.94106 .20099 L
.94206 .20099 L
.94306 .20099 L
.94406 .20099 L
.94505 .20099 L
.94605 .20099 L
.94705 .20099 L
.94805 .20099 L
Mistroke
.94905 .20832 L
.95005 .20832 L
.95105 .20832 L
.95205 .20832 L
.95305 .20832 L
.95405 .20832 L
.95504 .20832 L
.95604 .20832 L
.95704 .20832 L
.95804 .20832 L
.95904 .20832 L
.96004 .20832 L
.96104 .20832 L
.96204 .20832 L
.96304 .20832 L
.96404 .20832 L
.96503 .20832 L
.96603 .20832 L
.96703 .20832 L
.96803 .20832 L
.96903 .20832 L
.97003 .20832 L
.97103 .20832 L
.97203 .20832 L
.97303 .20832 L
.97403 .20832 L
.97502 .20832 L
.97602 .20832 L
.97702 .20832 L
.97802 .20832 L
.97902 .20832 L
.98002 .20832 L
.98102 .20832 L
.98202 .20832 L
.98302 .20832 L
.98402 .20832 L
.98501 .20832 L
.98601 .20832 L
.98701 .20832 L
.98801 .20832 L
.98901 .20832 L
.99001 .20832 L
.99101 .20832 L
.99201 .20832 L
.99301 .20832 L
.99401 .20832 L
.995 .20832 L
.996 .20832 L
.997 .20832 L
.998 .20832 L
Mistroke
.999 .20894 L
Mfstroke
gsave
.999 .3336 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .49196 m
.001 .49196 L
.002 .49196 L
.003 .49196 L
.004 .49196 L
.005 .49196 L
.00599 .49196 L
.00699 .49196 L
.00799 .49196 L
.00899 .49196 L
.00999 .49196 L
.01099 .49196 L
.01199 .49196 L
.01299 .49196 L
.01399 .49196 L
.01499 .49196 L
.01598 .49196 L
.01698 .49196 L
.01798 .49196 L
.01898 .49196 L
.01998 .49196 L
.02098 .49196 L
.02198 .49196 L
.02298 .49196 L
.02398 .49196 L
.02498 .49196 L
.02597 .49196 L
.02697 .49196 L
.02797 .49196 L
.02897 .49196 L
.02997 .49196 L
.03097 .49196 L
.03197 .49196 L
.03297 .49196 L
.03397 .49196 L
.03497 .49196 L
.03596 .49196 L
.03696 .49196 L
.03796 .49196 L
.03896 .49196 L
.03996 .49196 L
.04096 .49196 L
.04196 .49196 L
.04296 .49196 L
.04396 .49196 L
.04496 .49196 L
.04595 .49196 L
.04695 .49196 L
.04795 .49196 L
.04895 .49196 L
Mistroke
.04995 .48941 L
.05095 .48941 L
.05195 .48941 L
.05295 .48941 L
.05395 .48941 L
.05495 .48941 L
.05594 .48941 L
.05694 .48941 L
.05794 .48941 L
.05894 .48941 L
.05994 .48941 L
.06094 .48941 L
.06194 .48941 L
.06294 .48941 L
.06394 .48941 L
.06494 .48941 L
.06593 .48941 L
.06693 .48941 L
.06793 .48941 L
.06893 .48941 L
.06993 .48941 L
.07093 .48941 L
.07193 .48941 L
.07293 .48941 L
.07393 .48941 L
.07493 .48941 L
.07592 .48941 L
.07692 .48941 L
.07792 .48941 L
.07892 .48941 L
.07992 .48941 L
.08092 .48941 L
.08192 .48941 L
.08292 .48941 L
.08392 .48941 L
.08492 .48941 L
.08591 .48941 L
.08691 .48941 L
.08791 .48941 L
.08891 .48941 L
.08991 .48941 L
.09091 .48941 L
.09191 .48941 L
.09291 .48941 L
.09391 .48941 L
.09491 .48941 L
.0959 .48941 L
.0969 .48941 L
.0979 .48941 L
.0989 .48941 L
Mistroke
.0999 .43833 L
.1009 .43833 L
.1019 .43833 L
.1029 .43833 L
.1039 .43833 L
.1049 .43833 L
.10589 .43833 L
.10689 .43833 L
.10789 .43833 L
.10889 .43833 L
.10989 .43833 L
.11089 .43833 L
.11189 .43833 L
.11289 .43833 L
.11389 .43833 L
.11489 .43833 L
.11588 .43833 L
.11688 .43833 L
.11788 .43833 L
.11888 .43833 L
.11988 .43833 L
.12088 .43833 L
.12188 .43833 L
.12288 .43833 L
.12388 .43833 L
.12488 .43833 L
.12587 .43833 L
.12687 .43833 L
.12787 .43833 L
.12887 .43833 L
.12987 .43833 L
.13087 .43833 L
.13187 .43833 L
.13287 .43833 L
.13387 .43833 L
.13487 .43833 L
.13586 .43833 L
.13686 .43833 L
.13786 .43833 L
.13886 .43833 L
.13986 .43833 L
.14086 .43833 L
.14186 .43833 L
.14286 .43833 L
.14386 .43833 L
.14486 .43833 L
.14585 .43833 L
.14685 .43833 L
.14785 .43833 L
.14885 .43833 L
Mistroke
.14985 .40673 L
.15085 .40673 L
.15185 .40673 L
.15285 .40673 L
.15385 .40673 L
.15485 .40673 L
.15584 .40673 L
.15684 .40673 L
.15784 .40673 L
.15884 .40673 L
.15984 .40673 L
.16084 .40673 L
.16184 .40673 L
.16284 .40673 L
.16384 .40673 L
.16484 .40673 L
.16583 .40673 L
.16683 .40673 L
.16783 .40673 L
.16883 .40673 L
.16983 .40673 L
.17083 .40673 L
.17183 .40673 L
.17283 .40673 L
.17383 .40673 L
.17483 .40673 L
.17582 .40673 L
.17682 .40673 L
.17782 .40673 L
.17882 .40673 L
.17982 .40673 L
.18082 .40673 L
.18182 .40673 L
.18282 .40673 L
.18382 .40673 L
.18482 .40673 L
.18581 .40673 L
.18681 .40673 L
.18781 .40673 L
.18881 .40673 L
.18981 .40673 L
.19081 .40673 L
.19181 .40673 L
.19281 .40673 L
.19381 .40673 L
.19481 .40673 L
.1958 .40673 L
.1968 .40673 L
.1978 .40673 L
.1988 .40673 L
Mistroke
.1998 .3654 L
.2008 .3654 L
.2018 .3654 L
.2028 .3654 L
.2038 .3654 L
.2048 .3654 L
.20579 .3654 L
.20679 .3654 L
.20779 .3654 L
.20879 .3654 L
.20979 .3654 L
.21079 .3654 L
.21179 .3654 L
.21279 .3654 L
.21379 .3654 L
.21479 .3654 L
.21578 .3654 L
.21678 .3654 L
.21778 .3654 L
.21878 .3654 L
.21978 .3654 L
.22078 .3654 L
.22178 .3654 L
.22278 .3654 L
.22378 .3654 L
.22478 .3654 L
.22577 .3654 L
.22677 .3654 L
.22777 .3654 L
.22877 .3654 L
.22977 .3654 L
.23077 .3654 L
.23177 .3654 L
.23277 .3654 L
.23377 .3654 L
.23477 .3654 L
.23576 .3654 L
.23676 .3654 L
.23776 .3654 L
.23876 .3654 L
.23976 .3654 L
.24076 .3654 L
.24176 .3654 L
.24276 .3654 L
.24376 .3654 L
.24476 .3654 L
.24575 .3654 L
.24675 .3654 L
.24775 .3654 L
.24875 .3654 L
Mistroke
.24975 .36993 L
.25075 .36993 L
.25175 .36993 L
.25275 .36993 L
.25375 .36993 L
.25475 .36993 L
.25574 .36993 L
.25674 .36993 L
.25774 .36993 L
.25874 .36993 L
.25974 .36993 L
.26074 .36993 L
.26174 .36993 L
.26274 .36993 L
.26374 .36993 L
.26474 .36993 L
.26573 .36993 L
.26673 .36993 L
.26773 .36993 L
.26873 .36993 L
.26973 .36993 L
.27073 .36993 L
.27173 .36993 L
.27273 .36993 L
.27373 .36993 L
.27473 .36993 L
.27572 .36993 L
.27672 .36993 L
.27772 .36993 L
.27872 .36993 L
.27972 .36993 L
.28072 .36993 L
.28172 .36993 L
.28272 .36993 L
.28372 .36993 L
.28472 .36993 L
.28571 .36993 L
.28671 .36993 L
.28771 .36993 L
.28871 .36993 L
.28971 .36993 L
.29071 .36993 L
.29171 .36993 L
.29271 .36993 L
.29371 .36993 L
.29471 .36993 L
.2957 .36993 L
.2967 .36993 L
.2977 .36993 L
.2987 .36993 L
Mistroke
.2997 .37396 L
.3007 .37396 L
.3017 .37396 L
.3027 .37396 L
.3037 .37396 L
.3047 .37396 L
.30569 .37396 L
.30669 .37396 L
.30769 .37396 L
.30869 .37396 L
.30969 .37396 L
.31069 .37396 L
.31169 .37396 L
.31269 .37396 L
.31369 .37396 L
.31469 .37396 L
.31568 .37396 L
.31668 .37396 L
.31768 .37396 L
.31868 .37396 L
.31968 .37396 L
.32068 .37396 L
.32168 .37396 L
.32268 .37396 L
.32368 .37396 L
.32468 .37396 L
.32567 .37396 L
.32667 .37396 L
.32767 .37396 L
.32867 .37396 L
.32967 .37396 L
.33067 .37396 L
.33167 .37396 L
.33267 .37396 L
.33367 .37396 L
.33467 .37396 L
.33566 .37396 L
.33666 .37396 L
.33766 .37396 L
.33866 .37396 L
.33966 .37396 L
.34066 .37396 L
.34166 .37396 L
.34266 .37396 L
.34366 .37396 L
.34466 .37396 L
.34565 .37396 L
.34665 .37396 L
.34765 .37396 L
.34865 .37396 L
Mistroke
.34965 .36214 L
.35065 .36214 L
.35165 .36214 L
.35265 .36214 L
.35365 .36214 L
.35465 .36214 L
.35564 .36214 L
.35664 .36214 L
.35764 .36214 L
.35864 .36214 L
.35964 .36214 L
.36064 .36214 L
.36164 .36214 L
.36264 .36214 L
.36364 .36214 L
.36464 .36214 L
.36563 .36214 L
.36663 .36214 L
.36763 .36214 L
.36863 .36214 L
.36963 .36214 L
.37063 .36214 L
.37163 .36214 L
.37263 .36214 L
.37363 .36214 L
.37463 .36214 L
.37562 .36214 L
.37662 .36214 L
.37762 .36214 L
.37862 .36214 L
.37962 .36214 L
.38062 .36214 L
.38162 .36214 L
.38262 .36214 L
.38362 .36214 L
.38462 .36214 L
.38561 .36214 L
.38661 .36214 L
.38761 .36214 L
.38861 .36214 L
.38961 .36214 L
.39061 .36214 L
.39161 .36214 L
.39261 .36214 L
.39361 .36214 L
.39461 .36214 L
.3956 .36214 L
.3966 .36214 L
.3976 .36214 L
.3986 .36214 L
Mistroke
.3996 .33036 L
.4006 .33036 L
.4016 .33036 L
.4026 .33036 L
.4036 .33036 L
.4046 .33036 L
.40559 .33036 L
.40659 .33036 L
.40759 .33036 L
.40859 .33036 L
.40959 .33036 L
.41059 .33036 L
.41159 .33036 L
.41259 .33036 L
.41359 .33036 L
.41459 .33036 L
.41558 .33036 L
.41658 .33036 L
.41758 .33036 L
.41858 .33036 L
.41958 .33036 L
.42058 .33036 L
.42158 .33036 L
.42258 .33036 L
.42358 .33036 L
.42458 .33036 L
.42557 .33036 L
.42657 .33036 L
.42757 .33036 L
.42857 .33036 L
.42957 .33036 L
.43057 .33036 L
.43157 .33036 L
.43257 .33036 L
.43357 .33036 L
.43457 .33036 L
.43556 .33036 L
.43656 .33036 L
.43756 .33036 L
.43856 .33036 L
.43956 .33036 L
.44056 .33036 L
.44156 .33036 L
.44256 .33036 L
.44356 .33036 L
.44456 .33036 L
.44555 .33036 L
.44655 .33036 L
.44755 .33036 L
.44855 .33036 L
Mistroke
.44955 .32818 L
.45055 .32818 L
.45155 .32818 L
.45255 .32818 L
.45355 .32818 L
.45455 .32818 L
.45554 .32818 L
.45654 .32818 L
.45754 .32818 L
.45854 .32818 L
.45954 .32818 L
.46054 .32818 L
.46154 .32818 L
.46254 .32818 L
.46354 .32818 L
.46454 .32818 L
.46553 .32818 L
.46653 .32818 L
.46753 .32818 L
.46853 .32818 L
.46953 .32818 L
.47053 .32818 L
.47153 .32818 L
.47253 .32818 L
.47353 .32818 L
.47453 .32818 L
.47552 .32818 L
.47652 .32818 L
.47752 .32818 L
.47852 .32818 L
.47952 .32818 L
.48052 .32818 L
.48152 .32818 L
.48252 .32818 L
.48352 .32818 L
.48452 .32818 L
.48551 .32818 L
.48651 .32818 L
.48751 .32818 L
.48851 .32818 L
.48951 .32818 L
.49051 .32818 L
.49151 .32818 L
.49251 .32818 L
.49351 .32818 L
.49451 .32818 L
.4955 .32818 L
.4965 .32818 L
.4975 .32818 L
.4985 .32818 L
Mistroke
.4995 .33658 L
.5005 .33658 L
.5015 .33658 L
.5025 .33658 L
.5035 .33658 L
.5045 .33658 L
.50549 .33658 L
.50649 .33658 L
.50749 .33658 L
.50849 .33658 L
.50949 .33658 L
.51049 .33658 L
.51149 .33658 L
.51249 .33658 L
.51349 .33658 L
.51449 .33658 L
.51548 .33658 L
.51648 .33658 L
.51748 .33658 L
.51848 .33658 L
.51948 .33658 L
.52048 .33658 L
.52148 .33658 L
.52248 .33658 L
.52348 .33658 L
.52448 .33658 L
.52547 .33658 L
.52647 .33658 L
.52747 .33658 L
.52847 .33658 L
.52947 .33658 L
.53047 .33658 L
.53147 .33658 L
.53247 .33658 L
.53347 .33658 L
.53447 .33658 L
.53546 .33658 L
.53646 .33658 L
.53746 .33658 L
.53846 .33658 L
.53946 .33658 L
.54046 .33658 L
.54146 .33658 L
.54246 .33658 L
.54346 .33658 L
.54446 .33658 L
.54545 .33658 L
.54645 .33658 L
.54745 .33658 L
.54845 .33658 L
Mistroke
.54945 .33523 L
.55045 .33523 L
.55145 .33523 L
.55245 .33523 L
.55345 .33523 L
.55445 .33523 L
.55544 .33523 L
.55644 .33523 L
.55744 .33523 L
.55844 .33523 L
.55944 .33523 L
.56044 .33523 L
.56144 .33523 L
.56244 .33523 L
.56344 .33523 L
.56444 .33523 L
.56543 .33523 L
.56643 .33523 L
.56743 .33523 L
.56843 .33523 L
.56943 .33523 L
.57043 .33523 L
.57143 .33523 L
.57243 .33523 L
.57343 .33523 L
.57443 .33523 L
.57542 .33523 L
.57642 .33523 L
.57742 .33523 L
.57842 .33523 L
.57942 .33523 L
.58042 .33523 L
.58142 .33523 L
.58242 .33523 L
.58342 .33523 L
.58442 .33523 L
.58541 .33523 L
.58641 .33523 L
.58741 .33523 L
.58841 .33523 L
.58941 .33523 L
.59041 .33523 L
.59141 .33523 L
.59241 .33523 L
.59341 .33523 L
.59441 .33523 L
.5954 .33523 L
.5964 .33523 L
.5974 .33523 L
.5984 .33523 L
Mistroke
.5994 .31783 L
.6004 .31783 L
.6014 .31783 L
.6024 .31783 L
.6034 .31783 L
.6044 .31783 L
.60539 .31783 L
.60639 .31783 L
.60739 .31783 L
.60839 .31783 L
.60939 .31783 L
.61039 .31783 L
.61139 .31783 L
.61239 .31783 L
.61339 .31783 L
.61439 .31783 L
.61538 .31783 L
.61638 .31783 L
.61738 .31783 L
.61838 .31783 L
.61938 .31783 L
.62038 .31783 L
.62138 .31783 L
.62238 .31783 L
.62338 .31783 L
.62438 .31783 L
.62537 .31783 L
.62637 .31783 L
.62737 .31783 L
.62837 .31783 L
.62937 .31783 L
.63037 .31783 L
.63137 .31783 L
.63237 .31783 L
.63337 .31783 L
.63437 .31783 L
.63536 .31783 L
.63636 .31783 L
.63736 .31783 L
.63836 .31783 L
.63936 .31783 L
.64036 .31783 L
.64136 .31783 L
.64236 .31783 L
.64336 .31783 L
.64436 .31783 L
.64535 .31783 L
.64635 .31783 L
.64735 .31783 L
.64835 .31783 L
Mistroke
.64935 .32783 L
.65035 .32783 L
.65135 .32783 L
.65235 .32783 L
.65335 .32783 L
.65435 .32783 L
.65534 .32783 L
.65634 .32783 L
.65734 .32783 L
.65834 .32783 L
.65934 .32783 L
.66034 .32783 L
.66134 .32783 L
.66234 .32783 L
.66334 .32783 L
.66434 .32783 L
.66533 .32783 L
.66633 .32783 L
.66733 .32783 L
.66833 .32783 L
.66933 .32783 L
.67033 .32783 L
.67133 .32783 L
.67233 .32783 L
.67333 .32783 L
.67433 .32783 L
.67532 .32783 L
.67632 .32783 L
.67732 .32783 L
.67832 .32783 L
.67932 .32783 L
.68032 .32783 L
.68132 .32783 L
.68232 .32783 L
.68332 .32783 L
.68432 .32783 L
.68531 .32783 L
.68631 .32783 L
.68731 .32783 L
.68831 .32783 L
.68931 .32783 L
.69031 .32783 L
.69131 .32783 L
.69231 .32783 L
.69331 .32783 L
.69431 .32783 L
.6953 .32783 L
.6963 .32783 L
.6973 .32783 L
.6983 .32783 L
Mistroke
.6993 .33081 L
.7003 .33081 L
.7013 .33081 L
.7023 .33081 L
.7033 .33081 L
.7043 .33081 L
.70529 .33081 L
.70629 .33081 L
.70729 .33081 L
.70829 .33081 L
.70929 .33081 L
.71029 .33081 L
.71129 .33081 L
.71229 .33081 L
.71329 .33081 L
.71429 .33081 L
.71528 .33081 L
.71628 .33081 L
.71728 .33081 L
.71828 .33081 L
.71928 .33081 L
.72028 .33081 L
.72128 .33081 L
.72228 .33081 L
.72328 .33081 L
.72428 .33081 L
.72527 .33081 L
.72627 .33081 L
.72727 .33081 L
.72827 .33081 L
.72927 .33081 L
.73027 .33081 L
.73127 .33081 L
.73227 .33081 L
.73327 .33081 L
.73427 .33081 L
.73526 .33081 L
.73626 .33081 L
.73726 .33081 L
.73826 .33081 L
.73926 .33081 L
.74026 .33081 L
.74126 .33081 L
.74226 .33081 L
.74326 .33081 L
.74426 .33081 L
.74525 .33081 L
.74625 .33081 L
.74725 .33081 L
.74825 .33081 L
Mistroke
.74925 .33197 L
.75025 .33197 L
.75125 .33197 L
.75225 .33197 L
.75325 .33197 L
.75425 .33197 L
.75524 .33197 L
.75624 .33197 L
.75724 .33197 L
.75824 .33197 L
.75924 .33197 L
.76024 .33197 L
.76124 .33197 L
.76224 .33197 L
.76324 .33197 L
.76424 .33197 L
.76523 .33197 L
.76623 .33197 L
.76723 .33197 L
.76823 .33197 L
.76923 .33197 L
.77023 .33197 L
.77123 .33197 L
.77223 .33197 L
.77323 .33197 L
.77423 .33197 L
.77522 .33197 L
.77622 .33197 L
.77722 .33197 L
.77822 .33197 L
.77922 .33197 L
.78022 .33197 L
.78122 .33197 L
.78222 .33197 L
.78322 .33197 L
.78422 .33197 L
.78521 .33197 L
.78621 .33197 L
.78721 .33197 L
.78821 .33197 L
.78921 .33197 L
.79021 .33197 L
.79121 .33197 L
.79221 .33197 L
.79321 .33197 L
.79421 .33197 L
.7952 .33197 L
.7962 .33197 L
.7972 .33197 L
.7982 .33197 L
Mistroke
.7992 .32046 L
.8002 .32046 L
.8012 .32046 L
.8022 .32046 L
.8032 .32046 L
.8042 .32046 L
.80519 .32046 L
.80619 .32046 L
.80719 .32046 L
.80819 .32046 L
.80919 .32046 L
.81019 .32046 L
.81119 .32046 L
.81219 .32046 L
.81319 .32046 L
.81419 .32046 L
.81518 .32046 L
.81618 .32046 L
.81718 .32046 L
.81818 .32046 L
.81918 .32046 L
.82018 .32046 L
.82118 .32046 L
.82218 .32046 L
.82318 .32046 L
.82418 .32046 L
.82517 .32046 L
.82617 .32046 L
.82717 .32046 L
.82817 .32046 L
.82917 .32046 L
.83017 .32046 L
.83117 .32046 L
.83217 .32046 L
.83317 .32046 L
.83417 .32046 L
.83516 .32046 L
.83616 .32046 L
.83716 .32046 L
.83816 .32046 L
.83916 .32046 L
.84016 .32046 L
.84116 .32046 L
.84216 .32046 L
.84316 .32046 L
.84416 .32046 L
.84515 .32046 L
.84615 .32046 L
.84715 .32046 L
.84815 .32046 L
Mistroke
.84915 .32415 L
.85015 .32415 L
.85115 .32415 L
.85215 .32415 L
.85315 .32415 L
.85415 .32415 L
.85514 .32415 L
.85614 .32415 L
.85714 .32415 L
.85814 .32415 L
.85914 .32415 L
.86014 .32415 L
.86114 .32415 L
.86214 .32415 L
.86314 .32415 L
.86414 .32415 L
.86513 .32415 L
.86613 .32415 L
.86713 .32415 L
.86813 .32415 L
.86913 .32415 L
.87013 .32415 L
.87113 .32415 L
.87213 .32415 L
.87313 .32415 L
.87413 .32415 L
.87512 .32415 L
.87612 .32415 L
.87712 .32415 L
.87812 .32415 L
.87912 .32415 L
.88012 .32415 L
.88112 .32415 L
.88212 .32415 L
.88312 .32415 L
.88412 .32415 L
.88511 .32415 L
.88611 .32415 L
.88711 .32415 L
.88811 .32415 L
.88911 .32415 L
.89011 .32415 L
.89111 .32415 L
.89211 .32415 L
.89311 .32415 L
.89411 .32415 L
.8951 .32415 L
.8961 .32415 L
.8971 .32415 L
.8981 .32415 L
Mistroke
.8991 .33151 L
.9001 .33151 L
.9011 .33151 L
.9021 .33151 L
.9031 .33151 L
.9041 .33151 L
.90509 .33151 L
.90609 .33151 L
.90709 .33151 L
.90809 .33151 L
.90909 .33151 L
.91009 .33151 L
.91109 .33151 L
.91209 .33151 L
.91309 .33151 L
.91409 .33151 L
.91508 .33151 L
.91608 .33151 L
.91708 .33151 L
.91808 .33151 L
.91908 .33151 L
.92008 .33151 L
.92108 .33151 L
.92208 .33151 L
.92308 .33151 L
.92408 .33151 L
.92507 .33151 L
.92607 .33151 L
.92707 .33151 L
.92807 .33151 L
.92907 .33151 L
.93007 .33151 L
.93107 .33151 L
.93207 .33151 L
.93307 .33151 L
.93407 .33151 L
.93506 .33151 L
.93606 .33151 L
.93706 .33151 L
.93806 .33151 L
.93906 .33151 L
.94006 .33151 L
.94106 .33151 L
.94206 .33151 L
.94306 .33151 L
.94406 .33151 L
.94505 .33151 L
.94605 .33151 L
.94705 .33151 L
.94805 .33151 L
Mistroke
.94905 .3366 L
.95005 .3366 L
.95105 .3366 L
.95205 .3366 L
.95305 .3366 L
.95405 .3366 L
.95504 .3366 L
.95604 .3366 L
.95704 .3366 L
.95804 .3366 L
.95904 .3366 L
.96004 .3366 L
.96104 .3366 L
.96204 .3366 L
.96304 .3366 L
.96404 .3366 L
.96503 .3366 L
.96603 .3366 L
.96703 .3366 L
.96803 .3366 L
.96903 .3366 L
.97003 .3366 L
.97103 .3366 L
.97203 .3366 L
.97303 .3366 L
.97403 .3366 L
.97502 .3366 L
.97602 .3366 L
.97702 .3366 L
.97802 .3366 L
.97902 .3366 L
.98002 .3366 L
.98102 .3366 L
.98202 .3366 L
.98302 .3366 L
.98402 .3366 L
.98501 .3366 L
.98601 .3366 L
.98701 .3366 L
.98801 .3366 L
.98901 .3366 L
.99001 .3366 L
.99101 .3366 L
.99201 .3366 L
.99301 .3366 L
.99401 .3366 L
.995 .3366 L
.996 .3366 L
.997 .3366 L
.998 .3366 L
Mistroke
.999 .3336 L
Mfstroke
1 0 0 r
gsave
.999 .27127 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37082 m
.001 .37082 L
.002 .37082 L
.003 .37082 L
.004 .37082 L
.005 .37082 L
.00599 .37082 L
.00699 .37082 L
.00799 .37082 L
.00899 .37082 L
.00999 .37082 L
.01099 .37082 L
.01199 .37082 L
.01299 .37082 L
.01399 .37082 L
.01499 .37082 L
.01598 .37082 L
.01698 .37082 L
.01798 .37082 L
.01898 .37082 L
.01998 .37082 L
.02098 .37082 L
.02198 .37082 L
.02298 .37082 L
.02398 .37082 L
.02498 .37082 L
.02597 .37082 L
.02697 .37082 L
.02797 .37082 L
.02897 .37082 L
.02997 .37082 L
.03097 .37082 L
.03197 .37082 L
.03297 .37082 L
.03397 .37082 L
.03497 .37082 L
.03596 .37082 L
.03696 .37082 L
.03796 .37082 L
.03896 .37082 L
.03996 .37082 L
.04096 .37082 L
.04196 .37082 L
.04296 .37082 L
.04396 .37082 L
.04496 .37082 L
.04595 .37082 L
.04695 .37082 L
.04795 .37082 L
.04895 .37082 L
Mistroke
.04995 .36865 L
.05095 .36865 L
.05195 .36865 L
.05295 .36865 L
.05395 .36865 L
.05495 .36865 L
.05594 .36865 L
.05694 .36865 L
.05794 .36865 L
.05894 .36865 L
.05994 .36865 L
.06094 .36865 L
.06194 .36865 L
.06294 .36865 L
.06394 .36865 L
.06494 .36865 L
.06593 .36865 L
.06693 .36865 L
.06793 .36865 L
.06893 .36865 L
.06993 .36865 L
.07093 .36865 L
.07193 .36865 L
.07293 .36865 L
.07393 .36865 L
.07493 .36865 L
.07592 .36865 L
.07692 .36865 L
.07792 .36865 L
.07892 .36865 L
.07992 .36865 L
.08092 .36865 L
.08192 .36865 L
.08292 .36865 L
.08392 .36865 L
.08492 .36865 L
.08591 .36865 L
.08691 .36865 L
.08791 .36865 L
.08891 .36865 L
.08991 .36865 L
.09091 .36865 L
.09191 .36865 L
.09291 .36865 L
.09391 .36865 L
.09491 .36865 L
.0959 .36865 L
.0969 .36865 L
.0979 .36865 L
.0989 .36865 L
Mistroke
.0999 .33154 L
.1009 .33154 L
.1019 .33154 L
.1029 .33154 L
.1039 .33154 L
.1049 .33154 L
.10589 .33154 L
.10689 .33154 L
.10789 .33154 L
.10889 .33154 L
.10989 .33154 L
.11089 .33154 L
.11189 .33154 L
.11289 .33154 L
.11389 .33154 L
.11489 .33154 L
.11588 .33154 L
.11688 .33154 L
.11788 .33154 L
.11888 .33154 L
.11988 .33154 L
.12088 .33154 L
.12188 .33154 L
.12288 .33154 L
.12388 .33154 L
.12488 .33154 L
.12587 .33154 L
.12687 .33154 L
.12787 .33154 L
.12887 .33154 L
.12987 .33154 L
.13087 .33154 L
.13187 .33154 L
.13287 .33154 L
.13387 .33154 L
.13487 .33154 L
.13586 .33154 L
.13686 .33154 L
.13786 .33154 L
.13886 .33154 L
.13986 .33154 L
.14086 .33154 L
.14186 .33154 L
.14286 .33154 L
.14386 .33154 L
.14486 .33154 L
.14585 .33154 L
.14685 .33154 L
.14785 .33154 L
.14885 .33154 L
Mistroke
.14985 .30372 L
.15085 .30372 L
.15185 .30372 L
.15285 .30372 L
.15385 .30372 L
.15485 .30372 L
.15584 .30372 L
.15684 .30372 L
.15784 .30372 L
.15884 .30372 L
.15984 .30372 L
.16084 .30372 L
.16184 .30372 L
.16284 .30372 L
.16384 .30372 L
.16484 .30372 L
.16583 .30372 L
.16683 .30372 L
.16783 .30372 L
.16883 .30372 L
.16983 .30372 L
.17083 .30372 L
.17183 .30372 L
.17283 .30372 L
.17383 .30372 L
.17483 .30372 L
.17582 .30372 L
.17682 .30372 L
.17782 .30372 L
.17882 .30372 L
.17982 .30372 L
.18082 .30372 L
.18182 .30372 L
.18282 .30372 L
.18382 .30372 L
.18482 .30372 L
.18581 .30372 L
.18681 .30372 L
.18781 .30372 L
.18881 .30372 L
.18981 .30372 L
.19081 .30372 L
.19181 .30372 L
.19281 .30372 L
.19381 .30372 L
.19481 .30372 L
.1958 .30372 L
.1968 .30372 L
.1978 .30372 L
.1988 .30372 L
Mistroke
.1998 .26728 L
.2008 .26728 L
.2018 .26728 L
.2028 .26728 L
.2038 .26728 L
.2048 .26728 L
.20579 .26728 L
.20679 .26728 L
.20779 .26728 L
.20879 .26728 L
.20979 .26728 L
.21079 .26728 L
.21179 .26728 L
.21279 .26728 L
.21379 .26728 L
.21479 .26728 L
.21578 .26728 L
.21678 .26728 L
.21778 .26728 L
.21878 .26728 L
.21978 .26728 L
.22078 .26728 L
.22178 .26728 L
.22278 .26728 L
.22378 .26728 L
.22478 .26728 L
.22577 .26728 L
.22677 .26728 L
.22777 .26728 L
.22877 .26728 L
.22977 .26728 L
.23077 .26728 L
.23177 .26728 L
.23277 .26728 L
.23377 .26728 L
.23477 .26728 L
.23576 .26728 L
.23676 .26728 L
.23776 .26728 L
.23876 .26728 L
.23976 .26728 L
.24076 .26728 L
.24176 .26728 L
.24276 .26728 L
.24376 .26728 L
.24476 .26728 L
.24575 .26728 L
.24675 .26728 L
.24775 .26728 L
.24875 .26728 L
Mistroke
.24975 .27452 L
.25075 .27452 L
.25175 .27452 L
.25275 .27452 L
.25375 .27452 L
.25475 .27452 L
.25574 .27452 L
.25674 .27452 L
.25774 .27452 L
.25874 .27452 L
.25974 .27452 L
.26074 .27452 L
.26174 .27452 L
.26274 .27452 L
.26374 .27452 L
.26474 .27452 L
.26573 .27452 L
.26673 .27452 L
.26773 .27452 L
.26873 .27452 L
.26973 .27452 L
.27073 .27452 L
.27173 .27452 L
.27273 .27452 L
.27373 .27452 L
.27473 .27452 L
.27572 .27452 L
.27672 .27452 L
.27772 .27452 L
.27872 .27452 L
.27972 .27452 L
.28072 .27452 L
.28172 .27452 L
.28272 .27452 L
.28372 .27452 L
.28472 .27452 L
.28571 .27452 L
.28671 .27452 L
.28771 .27452 L
.28871 .27452 L
.28971 .27452 L
.29071 .27452 L
.29171 .27452 L
.29271 .27452 L
.29371 .27452 L
.29471 .27452 L
.2957 .27452 L
.2967 .27452 L
.2977 .27452 L
.2987 .27452 L
Mistroke
.2997 .28005 L
.3007 .28005 L
.3017 .28005 L
.3027 .28005 L
.3037 .28005 L
.3047 .28005 L
.30569 .28005 L
.30669 .28005 L
.30769 .28005 L
.30869 .28005 L
.30969 .28005 L
.31069 .28005 L
.31169 .28005 L
.31269 .28005 L
.31369 .28005 L
.31469 .28005 L
.31568 .28005 L
.31668 .28005 L
.31768 .28005 L
.31868 .28005 L
.31968 .28005 L
.32068 .28005 L
.32168 .28005 L
.32268 .28005 L
.32368 .28005 L
.32468 .28005 L
.32567 .28005 L
.32667 .28005 L
.32767 .28005 L
.32867 .28005 L
.32967 .28005 L
.33067 .28005 L
.33167 .28005 L
.33267 .28005 L
.33367 .28005 L
.33467 .28005 L
.33566 .28005 L
.33666 .28005 L
.33766 .28005 L
.33866 .28005 L
.33966 .28005 L
.34066 .28005 L
.34166 .28005 L
.34266 .28005 L
.34366 .28005 L
.34466 .28005 L
.34565 .28005 L
.34665 .28005 L
.34765 .28005 L
.34865 .28005 L
Mistroke
.34965 .27075 L
.35065 .27075 L
.35165 .27075 L
.35265 .27075 L
.35365 .27075 L
.35465 .27075 L
.35564 .27075 L
.35664 .27075 L
.35764 .27075 L
.35864 .27075 L
.35964 .27075 L
.36064 .27075 L
.36164 .27075 L
.36264 .27075 L
.36364 .27075 L
.36464 .27075 L
.36563 .27075 L
.36663 .27075 L
.36763 .27075 L
.36863 .27075 L
.36963 .27075 L
.37063 .27075 L
.37163 .27075 L
.37263 .27075 L
.37363 .27075 L
.37463 .27075 L
.37562 .27075 L
.37662 .27075 L
.37762 .27075 L
.37862 .27075 L
.37962 .27075 L
.38062 .27075 L
.38162 .27075 L
.38262 .27075 L
.38362 .27075 L
.38462 .27075 L
.38561 .27075 L
.38661 .27075 L
.38761 .27075 L
.38861 .27075 L
.38961 .27075 L
.39061 .27075 L
.39161 .27075 L
.39261 .27075 L
.39361 .27075 L
.39461 .27075 L
.3956 .27075 L
.3966 .27075 L
.3976 .27075 L
.3986 .27075 L
Mistroke
.3996 .24063 L
.4006 .24063 L
.4016 .24063 L
.4026 .24063 L
.4036 .24063 L
.4046 .24063 L
.40559 .24063 L
.40659 .24063 L
.40759 .24063 L
.40859 .24063 L
.40959 .24063 L
.41059 .24063 L
.41159 .24063 L
.41259 .24063 L
.41359 .24063 L
.41459 .24063 L
.41558 .24063 L
.41658 .24063 L
.41758 .24063 L
.41858 .24063 L
.41958 .24063 L
.42058 .24063 L
.42158 .24063 L
.42258 .24063 L
.42358 .24063 L
.42458 .24063 L
.42557 .24063 L
.42657 .24063 L
.42757 .24063 L
.42857 .24063 L
.42957 .24063 L
.43057 .24063 L
.43157 .24063 L
.43257 .24063 L
.43357 .24063 L
.43457 .24063 L
.43556 .24063 L
.43656 .24063 L
.43756 .24063 L
.43856 .24063 L
.43956 .24063 L
.44056 .24063 L
.44156 .24063 L
.44256 .24063 L
.44356 .24063 L
.44456 .24063 L
.44555 .24063 L
.44655 .24063 L
.44755 .24063 L
.44855 .24063 L
Mistroke
.44955 .25092 L
.45055 .25092 L
.45155 .25092 L
.45255 .25092 L
.45355 .25092 L
.45455 .25092 L
.45554 .25092 L
.45654 .25092 L
.45754 .25092 L
.45854 .25092 L
.45954 .25092 L
.46054 .25092 L
.46154 .25092 L
.46254 .25092 L
.46354 .25092 L
.46454 .25092 L
.46553 .25092 L
.46653 .25092 L
.46753 .25092 L
.46853 .25092 L
.46953 .25092 L
.47053 .25092 L
.47153 .25092 L
.47253 .25092 L
.47353 .25092 L
.47453 .25092 L
.47552 .25092 L
.47652 .25092 L
.47752 .25092 L
.47852 .25092 L
.47952 .25092 L
.48052 .25092 L
.48152 .25092 L
.48252 .25092 L
.48352 .25092 L
.48452 .25092 L
.48551 .25092 L
.48651 .25092 L
.48751 .25092 L
.48851 .25092 L
.48951 .25092 L
.49051 .25092 L
.49151 .25092 L
.49251 .25092 L
.49351 .25092 L
.49451 .25092 L
.4955 .25092 L
.4965 .25092 L
.4975 .25092 L
.4985 .25092 L
Mistroke
.4995 .25956 L
.5005 .25956 L
.5015 .25956 L
.5025 .25956 L
.5035 .25956 L
.5045 .25956 L
.50549 .25956 L
.50649 .25956 L
.50749 .25956 L
.50849 .25956 L
.50949 .25956 L
.51049 .25956 L
.51149 .25956 L
.51249 .25956 L
.51349 .25956 L
.51449 .25956 L
.51548 .25956 L
.51648 .25956 L
.51748 .25956 L
.51848 .25956 L
.51948 .25956 L
.52048 .25956 L
.52148 .25956 L
.52248 .25956 L
.52348 .25956 L
.52448 .25956 L
.52547 .25956 L
.52647 .25956 L
.52747 .25956 L
.52847 .25956 L
.52947 .25956 L
.53047 .25956 L
.53147 .25956 L
.53247 .25956 L
.53347 .25956 L
.53447 .25956 L
.53546 .25956 L
.53646 .25956 L
.53746 .25956 L
.53846 .25956 L
.53946 .25956 L
.54046 .25956 L
.54146 .25956 L
.54246 .25956 L
.54346 .25956 L
.54446 .25956 L
.54545 .25956 L
.54645 .25956 L
.54745 .25956 L
.54845 .25956 L
Mistroke
.54945 .25857 L
.55045 .25857 L
.55145 .25857 L
.55245 .25857 L
.55345 .25857 L
.55445 .25857 L
.55544 .25857 L
.55644 .25857 L
.55744 .25857 L
.55844 .25857 L
.55944 .25857 L
.56044 .25857 L
.56144 .25857 L
.56244 .25857 L
.56344 .25857 L
.56444 .25857 L
.56543 .25857 L
.56643 .25857 L
.56743 .25857 L
.56843 .25857 L
.56943 .25857 L
.57043 .25857 L
.57143 .25857 L
.57243 .25857 L
.57343 .25857 L
.57443 .25857 L
.57542 .25857 L
.57642 .25857 L
.57742 .25857 L
.57842 .25857 L
.57942 .25857 L
.58042 .25857 L
.58142 .25857 L
.58242 .25857 L
.58342 .25857 L
.58442 .25857 L
.58541 .25857 L
.58641 .25857 L
.58741 .25857 L
.58841 .25857 L
.58941 .25857 L
.59041 .25857 L
.59141 .25857 L
.59241 .25857 L
.59341 .25857 L
.59441 .25857 L
.5954 .25857 L
.5964 .25857 L
.5974 .25857 L
.5984 .25857 L
Mistroke
.5994 .24759 L
.6004 .24759 L
.6014 .24759 L
.6024 .24759 L
.6034 .24759 L
.6044 .24759 L
.60539 .24759 L
.60639 .24759 L
.60739 .24759 L
.60839 .24759 L
.60939 .24759 L
.61039 .24759 L
.61139 .24759 L
.61239 .24759 L
.61339 .24759 L
.61439 .24759 L
.61538 .24759 L
.61638 .24759 L
.61738 .24759 L
.61838 .24759 L
.61938 .24759 L
.62038 .24759 L
.62138 .24759 L
.62238 .24759 L
.62338 .24759 L
.62438 .24759 L
.62537 .24759 L
.62637 .24759 L
.62737 .24759 L
.62837 .24759 L
.62937 .24759 L
.63037 .24759 L
.63137 .24759 L
.63237 .24759 L
.63337 .24759 L
.63437 .24759 L
.63536 .24759 L
.63636 .24759 L
.63736 .24759 L
.63836 .24759 L
.63936 .24759 L
.64036 .24759 L
.64136 .24759 L
.64236 .24759 L
.64336 .24759 L
.64436 .24759 L
.64535 .24759 L
.64635 .24759 L
.64735 .24759 L
.64835 .24759 L
Mistroke
.64935 .25837 L
.65035 .25837 L
.65135 .25837 L
.65235 .25837 L
.65335 .25837 L
.65435 .25837 L
.65534 .25837 L
.65634 .25837 L
.65734 .25837 L
.65834 .25837 L
.65934 .25837 L
.66034 .25837 L
.66134 .25837 L
.66234 .25837 L
.66334 .25837 L
.66434 .25837 L
.66533 .25837 L
.66633 .25837 L
.66733 .25837 L
.66833 .25837 L
.66933 .25837 L
.67033 .25837 L
.67133 .25837 L
.67233 .25837 L
.67333 .25837 L
.67433 .25837 L
.67532 .25837 L
.67632 .25837 L
.67732 .25837 L
.67832 .25837 L
.67932 .25837 L
.68032 .25837 L
.68132 .25837 L
.68232 .25837 L
.68332 .25837 L
.68432 .25837 L
.68531 .25837 L
.68631 .25837 L
.68731 .25837 L
.68831 .25837 L
.68931 .25837 L
.69031 .25837 L
.69131 .25837 L
.69231 .25837 L
.69331 .25837 L
.69431 .25837 L
.6953 .25837 L
.6963 .25837 L
.6973 .25837 L
.6983 .25837 L
Mistroke
.6993 .26213 L
.7003 .26213 L
.7013 .26213 L
.7023 .26213 L
.7033 .26213 L
.7043 .26213 L
.70529 .26213 L
.70629 .26213 L
.70729 .26213 L
.70829 .26213 L
.70929 .26213 L
.71029 .26213 L
.71129 .26213 L
.71229 .26213 L
.71329 .26213 L
.71429 .26213 L
.71528 .26213 L
.71628 .26213 L
.71728 .26213 L
.71828 .26213 L
.71928 .26213 L
.72028 .26213 L
.72128 .26213 L
.72228 .26213 L
.72328 .26213 L
.72428 .26213 L
.72527 .26213 L
.72627 .26213 L
.72727 .26213 L
.72827 .26213 L
.72927 .26213 L
.73027 .26213 L
.73127 .26213 L
.73227 .26213 L
.73327 .26213 L
.73427 .26213 L
.73526 .26213 L
.73626 .26213 L
.73726 .26213 L
.73826 .26213 L
.73926 .26213 L
.74026 .26213 L
.74126 .26213 L
.74226 .26213 L
.74326 .26213 L
.74426 .26213 L
.74525 .26213 L
.74625 .26213 L
.74725 .26213 L
.74825 .26213 L
Mistroke
.74925 .26381 L
.75025 .26381 L
.75125 .26381 L
.75225 .26381 L
.75325 .26381 L
.75425 .26381 L
.75524 .26381 L
.75624 .26381 L
.75724 .26381 L
.75824 .26381 L
.75924 .26381 L
.76024 .26381 L
.76124 .26381 L
.76224 .26381 L
.76324 .26381 L
.76424 .26381 L
.76523 .26381 L
.76623 .26381 L
.76723 .26381 L
.76823 .26381 L
.76923 .26381 L
.77023 .26381 L
.77123 .26381 L
.77223 .26381 L
.77323 .26381 L
.77423 .26381 L
.77522 .26381 L
.77622 .26381 L
.77722 .26381 L
.77822 .26381 L
.77922 .26381 L
.78022 .26381 L
.78122 .26381 L
.78222 .26381 L
.78322 .26381 L
.78422 .26381 L
.78521 .26381 L
.78621 .26381 L
.78721 .26381 L
.78821 .26381 L
.78921 .26381 L
.79021 .26381 L
.79121 .26381 L
.79221 .26381 L
.79321 .26381 L
.79421 .26381 L
.7952 .26381 L
.7962 .26381 L
.7972 .26381 L
.7982 .26381 L
Mistroke
.7992 .25443 L
.8002 .25443 L
.8012 .25443 L
.8022 .25443 L
.8032 .25443 L
.8042 .25443 L
.80519 .25443 L
.80619 .25443 L
.80719 .25443 L
.80819 .25443 L
.80919 .25443 L
.81019 .25443 L
.81119 .25443 L
.81219 .25443 L
.81319 .25443 L
.81419 .25443 L
.81518 .25443 L
.81618 .25443 L
.81718 .25443 L
.81818 .25443 L
.81918 .25443 L
.82018 .25443 L
.82118 .25443 L
.82218 .25443 L
.82318 .25443 L
.82418 .25443 L
.82517 .25443 L
.82617 .25443 L
.82717 .25443 L
.82817 .25443 L
.82917 .25443 L
.83017 .25443 L
.83117 .25443 L
.83217 .25443 L
.83317 .25443 L
.83417 .25443 L
.83516 .25443 L
.83616 .25443 L
.83716 .25443 L
.83816 .25443 L
.83916 .25443 L
.84016 .25443 L
.84116 .25443 L
.84216 .25443 L
.84316 .25443 L
.84416 .25443 L
.84515 .25443 L
.84615 .25443 L
.84715 .25443 L
.84815 .25443 L
Mistroke
.84915 .25836 L
.85015 .25836 L
.85115 .25836 L
.85215 .25836 L
.85315 .25836 L
.85415 .25836 L
.85514 .25836 L
.85614 .25836 L
.85714 .25836 L
.85814 .25836 L
.85914 .25836 L
.86014 .25836 L
.86114 .25836 L
.86214 .25836 L
.86314 .25836 L
.86414 .25836 L
.86513 .25836 L
.86613 .25836 L
.86713 .25836 L
.86813 .25836 L
.86913 .25836 L
.87013 .25836 L
.87113 .25836 L
.87213 .25836 L
.87313 .25836 L
.87413 .25836 L
.87512 .25836 L
.87612 .25836 L
.87712 .25836 L
.87812 .25836 L
.87912 .25836 L
.88012 .25836 L
.88112 .25836 L
.88212 .25836 L
.88312 .25836 L
.88412 .25836 L
.88511 .25836 L
.88611 .25836 L
.88711 .25836 L
.88811 .25836 L
.88911 .25836 L
.89011 .25836 L
.89111 .25836 L
.89211 .25836 L
.89311 .25836 L
.89411 .25836 L
.8951 .25836 L
.8961 .25836 L
.8971 .25836 L
.8981 .25836 L
Mistroke
.8991 .26625 L
.9001 .26625 L
.9011 .26625 L
.9021 .26625 L
.9031 .26625 L
.9041 .26625 L
.90509 .26625 L
.90609 .26625 L
.90709 .26625 L
.90809 .26625 L
.90909 .26625 L
.91009 .26625 L
.91109 .26625 L
.91209 .26625 L
.91309 .26625 L
.91409 .26625 L
.91508 .26625 L
.91608 .26625 L
.91708 .26625 L
.91808 .26625 L
.91908 .26625 L
.92008 .26625 L
.92108 .26625 L
.92208 .26625 L
.92308 .26625 L
.92408 .26625 L
.92507 .26625 L
.92607 .26625 L
.92707 .26625 L
.92807 .26625 L
.92907 .26625 L
.93007 .26625 L
.93107 .26625 L
.93207 .26625 L
.93307 .26625 L
.93407 .26625 L
.93506 .26625 L
.93606 .26625 L
.93706 .26625 L
.93806 .26625 L
.93906 .26625 L
.94006 .26625 L
.94106 .26625 L
.94206 .26625 L
.94306 .26625 L
.94406 .26625 L
.94505 .26625 L
.94605 .26625 L
.94705 .26625 L
.94805 .26625 L
Mistroke
.94905 .27246 L
.95005 .27246 L
.95105 .27246 L
.95205 .27246 L
.95305 .27246 L
.95405 .27246 L
.95504 .27246 L
.95604 .27246 L
.95704 .27246 L
.95804 .27246 L
.95904 .27246 L
.96004 .27246 L
.96104 .27246 L
.96204 .27246 L
.96304 .27246 L
.96404 .27246 L
.96503 .27246 L
.96603 .27246 L
.96703 .27246 L
.96803 .27246 L
.96903 .27246 L
.97003 .27246 L
.97103 .27246 L
.97203 .27246 L
.97303 .27246 L
.97403 .27246 L
.97502 .27246 L
.97602 .27246 L
.97702 .27246 L
.97802 .27246 L
.97902 .27246 L
.98002 .27246 L
.98102 .27246 L
.98202 .27246 L
.98302 .27246 L
.98402 .27246 L
.98501 .27246 L
.98601 .27246 L
.98701 .27246 L
.98801 .27246 L
.98901 .27246 L
.99001 .27246 L
.99101 .27246 L
.99201 .27246 L
.99301 .27246 L
.99401 .27246 L
.995 .27246 L
.996 .27246 L
.997 .27246 L
.998 .27246 L
Mistroke
.999 .27127 L
Mfstroke
0 0 1 r
gsave
.001 -0.61803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -1.54508 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(26)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(28)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(32)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(34)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .18541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .18541 L
.05095 .18541 L
.05195 .18541 L
.05295 .18541 L
.05395 .18541 L
.05495 .18541 L
.05594 .18541 L
.05694 .18541 L
.05794 .18541 L
.05894 .18541 L
.05994 .18541 L
.06094 .18541 L
.06194 .18541 L
.06294 .18541 L
.06394 .18541 L
.06494 .18541 L
.06593 .18541 L
.06693 .18541 L
.06793 .18541 L
.06893 .18541 L
.06993 .18541 L
.07093 .18541 L
.07193 .18541 L
.07293 .18541 L
.07393 .18541 L
.07493 .18541 L
.07592 .18541 L
.07692 .18541 L
.07792 .18541 L
.07892 .18541 L
.07992 .18541 L
.08092 .18541 L
.08192 .18541 L
.08292 .18541 L
.08392 .18541 L
.08492 .18541 L
.08591 .18541 L
.08691 .18541 L
.08791 .18541 L
.08891 .18541 L
.08991 .18541 L
.09091 .18541 L
.09191 .18541 L
.09291 .18541 L
.09391 .18541 L
.09491 .18541 L
.0959 .18541 L
.0969 .18541 L
.0979 .18541 L
.0989 .18541 L
Mistroke
.0999 .18541 L
.1009 .18541 L
.1019 .18541 L
.1029 .18541 L
.1039 .18541 L
.1049 .18541 L
.10589 .18541 L
.10689 .18541 L
.10789 .18541 L
.10889 .18541 L
.10989 .18541 L
.11089 .18541 L
.11189 .18541 L
.11289 .18541 L
.11389 .18541 L
.11489 .18541 L
.11588 .18541 L
.11688 .18541 L
.11788 .18541 L
.11888 .18541 L
.11988 .18541 L
.12088 .18541 L
.12188 .18541 L
.12288 .18541 L
.12388 .18541 L
.12488 .18541 L
.12587 .18541 L
.12687 .18541 L
.12787 .18541 L
.12887 .18541 L
.12987 .18541 L
.13087 .18541 L
.13187 .18541 L
.13287 .18541 L
.13387 .18541 L
.13487 .18541 L
.13586 .18541 L
.13686 .18541 L
.13786 .18541 L
.13886 .18541 L
.13986 .18541 L
.14086 .18541 L
.14186 .18541 L
.14286 .18541 L
.14386 .18541 L
.14486 .18541 L
.14585 .18541 L
.14685 .18541 L
.14785 .18541 L
.14885 .18541 L
Mistroke
.14985 .18541 L
.15085 .18541 L
.15185 .18541 L
.15285 .18541 L
.15385 .18541 L
.15485 .18541 L
.15584 .18541 L
.15684 .18541 L
.15784 .18541 L
.15884 .18541 L
.15984 .18541 L
.16084 .18541 L
.16184 .18541 L
.16284 .18541 L
.16384 .18541 L
.16484 .18541 L
.16583 .18541 L
.16683 .18541 L
.16783 .18541 L
.16883 .18541 L
.16983 .18541 L
.17083 .18541 L
.17183 .18541 L
.17283 .18541 L
.17383 .18541 L
.17483 .18541 L
.17582 .18541 L
.17682 .18541 L
.17782 .18541 L
.17882 .18541 L
.17982 .18541 L
.18082 .18541 L
.18182 .18541 L
.18282 .18541 L
.18382 .18541 L
.18482 .18541 L
.18581 .18541 L
.18681 .18541 L
.18781 .18541 L
.18881 .18541 L
.18981 .18541 L
.19081 .18541 L
.19181 .18541 L
.19281 .18541 L
.19381 .18541 L
.19481 .18541 L
.1958 .18541 L
.1968 .18541 L
.1978 .18541 L
.1988 .18541 L
Mistroke
.1998 .18541 L
.2008 .18541 L
.2018 .18541 L
.2028 .18541 L
.2038 .18541 L
.2048 .18541 L
.20579 .18541 L
.20679 .18541 L
.20779 .18541 L
.20879 .18541 L
.20979 .18541 L
.21079 .18541 L
.21179 .18541 L
.21279 .18541 L
.21379 .18541 L
.21479 .18541 L
.21578 .18541 L
.21678 .18541 L
.21778 .18541 L
.21878 .18541 L
.21978 .18541 L
.22078 .18541 L
.22178 .18541 L
.22278 .18541 L
.22378 .18541 L
.22478 .18541 L
.22577 .18541 L
.22677 .18541 L
.22777 .18541 L
.22877 .18541 L
.22977 .18541 L
.23077 .18541 L
.23177 .18541 L
.23277 .18541 L
.23377 .18541 L
.23477 .18541 L
.23576 .18541 L
.23676 .18541 L
.23776 .18541 L
.23876 .18541 L
.23976 .18541 L
.24076 .18541 L
.24176 .18541 L
.24276 .18541 L
.24376 .18541 L
.24476 .18541 L
.24575 .18541 L
.24675 .18541 L
.24775 .18541 L
.24875 .18541 L
Mistroke
.24975 .18541 L
.25075 .18541 L
.25175 .18541 L
.25275 .18542 L
.25375 .18541 L
.25475 .18542 L
.25574 .18542 L
.25674 .18542 L
.25774 .18542 L
.25874 .18542 L
.25974 .18542 L
.26074 .18542 L
.26174 .18542 L
.26274 .18542 L
.26374 .18542 L
.26474 .18542 L
.26573 .18542 L
.26673 .18542 L
.26773 .18542 L
.26873 .18542 L
.26973 .18542 L
.27073 .18542 L
.27173 .18542 L
.27273 .18542 L
.27373 .18542 L
.27473 .18542 L
.27572 .18542 L
.27672 .18542 L
.27772 .18542 L
.27872 .18542 L
.27972 .18542 L
.28072 .18542 L
.28172 .18542 L
.28272 .18542 L
.28372 .18542 L
.28472 .18542 L
.28571 .18542 L
.28671 .18542 L
.28771 .18542 L
.28871 .18542 L
.28971 .18542 L
.29071 .18542 L
.29171 .18542 L
.29271 .18542 L
.29371 .18542 L
.29471 .18541 L
.2957 .18542 L
.2967 .18542 L
.2977 .18541 L
.2987 .18541 L
Mistroke
.2997 .18541 L
.3007 .18541 L
.3017 .18541 L
.3027 .18541 L
.3037 .18542 L
.3047 .18542 L
.30569 .18542 L
.30669 .18542 L
.30769 .18541 L
.30869 .18541 L
.30969 .18541 L
.31069 .18541 L
.31169 .18541 L
.31269 .18541 L
.31369 .18541 L
.31469 .18541 L
.31568 .18541 L
.31668 .18541 L
.31768 .18541 L
.31868 .18541 L
.31968 .18541 L
.32068 .18541 L
.32168 .18541 L
.32268 .18541 L
.32368 .18541 L
.32468 .18542 L
.32567 .18542 L
.32667 .18542 L
.32767 .18542 L
.32867 .18542 L
.32967 .18542 L
.33067 .18542 L
.33167 .18542 L
.33267 .18542 L
.33367 .18542 L
.33467 .18542 L
.33566 .18542 L
.33666 .18542 L
.33766 .18542 L
.33866 .18542 L
.33966 .18541 L
.34066 .18541 L
.34166 .18541 L
.34266 .18541 L
.34366 .18541 L
.34466 .18541 L
.34565 .18541 L
.34665 .18541 L
.34765 .18541 L
.34865 .18541 L
Mistroke
.34965 .18541 L
.35065 .18541 L
.35165 .18541 L
.35265 .18541 L
.35365 .18541 L
.35465 .18541 L
.35564 .18541 L
.35664 .18541 L
.35764 .18541 L
.35864 .18541 L
.35964 .18541 L
.36064 .18541 L
.36164 .18541 L
.36264 .18541 L
.36364 .18541 L
.36464 .18541 L
.36563 .18541 L
.36663 .18541 L
.36763 .18541 L
.36863 .18541 L
.36963 .18542 L
.37063 .18542 L
.37163 .18542 L
.37263 .18541 L
.37363 .18541 L
.37463 .18542 L
.37562 .18542 L
.37662 .18542 L
.37762 .18542 L
.37862 .18542 L
.37962 .18541 L
.38062 .18542 L
.38162 .18542 L
.38262 .18542 L
.38362 .18542 L
.38462 .18541 L
.38561 .18541 L
.38661 .18541 L
.38761 .18541 L
.38861 .18541 L
.38961 .18541 L
.39061 .18541 L
.39161 .18541 L
.39261 .18542 L
.39361 .18541 L
.39461 .18541 L
.3956 .18541 L
.3966 .18541 L
.3976 .18541 L
.3986 .18542 L
Mistroke
.3996 .18542 L
.4006 .18542 L
.4016 .18542 L
.4026 .18542 L
.4036 .18542 L
.4046 .18542 L
.40559 .18542 L
.40659 .18542 L
.40759 .18542 L
.40859 .18542 L
.40959 .18542 L
.41059 .18542 L
.41159 .18542 L
.41259 .18542 L
.41359 .18542 L
.41459 .18542 L
.41558 .18542 L
.41658 .18542 L
.41758 .18542 L
.41858 .18542 L
.41958 .18542 L
.42058 .18541 L
.42158 .18541 L
.42258 .18542 L
.42358 .18542 L
.42458 .18542 L
.42557 .18542 L
.42657 .18542 L
.42757 .18542 L
.42857 .18542 L
.42957 .18542 L
.43057 .18541 L
.43157 .18541 L
.43257 .18542 L
.43357 .18542 L
.43457 .18541 L
.43556 .18541 L
.43656 .18541 L
.43756 .18542 L
.43856 .18541 L
.43956 .18541 L
.44056 .18542 L
.44156 .18542 L
.44256 .18542 L
.44356 .18542 L
.44456 .18542 L
.44555 .18542 L
.44655 .18542 L
.44755 .18542 L
.44855 .18542 L
Mistroke
.44955 .18542 L
.45055 .18542 L
.45155 .18542 L
.45255 .18542 L
.45355 .18542 L
.45455 .18542 L
.45554 .18542 L
.45654 .18542 L
.45754 .18542 L
.45854 .18542 L
.45954 .18542 L
.46054 .18542 L
.46154 .18542 L
.46254 .18542 L
.46354 .18542 L
.46454 .18542 L
.46553 .18542 L
.46653 .18542 L
.46753 .18542 L
.46853 .18542 L
.46953 .18542 L
.47053 .18542 L
.47153 .18542 L
.47253 .18542 L
.47353 .18542 L
.47453 .18542 L
.47552 .18542 L
.47652 .18542 L
.47752 .18542 L
.47852 .18542 L
.47952 .18542 L
.48052 .18542 L
.48152 .18542 L
.48252 .18542 L
.48352 .18542 L
.48452 .18542 L
.48551 .18542 L
.48651 .18542 L
.48751 .18542 L
.48851 .18542 L
.48951 .18542 L
.49051 .18542 L
.49151 .18542 L
.49251 .18542 L
.49351 .18542 L
.49451 .18542 L
.4955 .18542 L
.4965 .18542 L
.4975 .18542 L
.4985 .18542 L
Mistroke
.4995 .18542 L
.5005 .18542 L
.5015 .18542 L
.5025 .18542 L
.5035 .18542 L
.5045 .18542 L
.50549 .18542 L
.50649 .18542 L
.50749 .18542 L
.50849 .18542 L
.50949 .18542 L
.51049 .18542 L
.51149 .18542 L
.51249 .18542 L
.51349 .18542 L
.51449 .18542 L
.51548 .18542 L
.51648 .18542 L
.51748 .18542 L
.51848 .18542 L
.51948 .18542 L
.52048 .18542 L
.52148 .18542 L
.52248 .18542 L
.52348 .18542 L
.52448 .18542 L
.52547 .18542 L
.52647 .18542 L
.52747 .18542 L
.52847 .18542 L
.52947 .18542 L
.53047 .18542 L
.53147 .18542 L
.53247 .18543 L
.53347 .18542 L
.53447 .18542 L
.53546 .18542 L
.53646 .18542 L
.53746 .18542 L
.53846 .18542 L
.53946 .18542 L
.54046 .18542 L
.54146 .18542 L
.54246 .18542 L
.54346 .18542 L
.54446 .18542 L
.54545 .18542 L
.54645 .18542 L
.54745 .18542 L
.54845 .18542 L
Mistroke
.54945 .18542 L
.55045 .18542 L
.55145 .18542 L
.55245 .18542 L
.55345 .18542 L
.55445 .18542 L
.55544 .18542 L
.55644 .18542 L
.55744 .18542 L
.55844 .18542 L
.55944 .18542 L
.56044 .18542 L
.56144 .18542 L
.56244 .18542 L
.56344 .18542 L
.56444 .18542 L
.56543 .18542 L
.56643 .18542 L
.56743 .18542 L
.56843 .18542 L
.56943 .18542 L
.57043 .18542 L
.57143 .18543 L
.57243 .18543 L
.57343 .18543 L
.57443 .18543 L
.57542 .18543 L
.57642 .18543 L
.57742 .18543 L
.57842 .18543 L
.57942 .18543 L
.58042 .18542 L
.58142 .18543 L
.58242 .18542 L
.58342 .18543 L
.58442 .18542 L
.58541 .18543 L
.58641 .18543 L
.58741 .18543 L
.58841 .18543 L
.58941 .18542 L
.59041 .18542 L
.59141 .18542 L
.59241 .18543 L
.59341 .18543 L
.59441 .18543 L
.5954 .18543 L
.5964 .18543 L
.5974 .18543 L
.5984 .18542 L
Mistroke
.5994 .18542 L
.6004 .18542 L
.6014 .18542 L
.6024 .18542 L
.6034 .18543 L
.6044 .18542 L
.60539 .18542 L
.60639 .18542 L
.60739 .18542 L
.60839 .18542 L
.60939 .18542 L
.61039 .18542 L
.61139 .18542 L
.61239 .18542 L
.61339 .18542 L
.61439 .18542 L
.61538 .18542 L
.61638 .18542 L
.61738 .18542 L
.61838 .18542 L
.61938 .18542 L
.62038 .18543 L
.62138 .18543 L
.62238 .18543 L
.62338 .18543 L
.62438 .18543 L
.62537 .18543 L
.62637 .18543 L
.62737 .18543 L
.62837 .18543 L
.62937 .18543 L
.63037 .18543 L
.63137 .18543 L
.63237 .18543 L
.63337 .18543 L
.63437 .18543 L
.63536 .18543 L
.63636 .18543 L
.63736 .18543 L
.63836 .18543 L
.63936 .18543 L
.64036 .18543 L
.64136 .18543 L
.64236 .18543 L
.64336 .18543 L
.64436 .18543 L
.64535 .18543 L
.64635 .18543 L
.64735 .18543 L
.64835 .18543 L
Mistroke
.64935 .18543 L
.65035 .18543 L
.65135 .18543 L
.65235 .18543 L
.65335 .18543 L
.65435 .18543 L
.65534 .18543 L
.65634 .18543 L
.65734 .18543 L
.65834 .18543 L
.65934 .18543 L
.66034 .18543 L
.66134 .18543 L
.66234 .18543 L
.66334 .18543 L
.66434 .18543 L
.66533 .18543 L
.66633 .18543 L
.66733 .18543 L
.66833 .18543 L
.66933 .18543 L
.67033 .18543 L
.67133 .18543 L
.67233 .18543 L
.67333 .18543 L
.67433 .18543 L
.67532 .18543 L
.67632 .18543 L
.67732 .18543 L
.67832 .18543 L
.67932 .18543 L
.68032 .18543 L
.68132 .18543 L
.68232 .18543 L
.68332 .18543 L
.68432 .18543 L
.68531 .18543 L
.68631 .18543 L
.68731 .18543 L
.68831 .18543 L
.68931 .18543 L
.69031 .18543 L
.69131 .18543 L
.69231 .18543 L
.69331 .18543 L
.69431 .18543 L
.6953 .18543 L
.6963 .18543 L
.6973 .18543 L
.6983 .18543 L
Mistroke
.6993 .18543 L
.7003 .18543 L
.7013 .18543 L
.7023 .18543 L
.7033 .18543 L
.7043 .18543 L
.70529 .18543 L
.70629 .18543 L
.70729 .18543 L
.70829 .18543 L
.70929 .18543 L
.71029 .18543 L
.71129 .18543 L
.71229 .18543 L
.71329 .18543 L
.71429 .18543 L
.71528 .18543 L
.71628 .18543 L
.71728 .18543 L
.71828 .18543 L
.71928 .18543 L
.72028 .18543 L
.72128 .18543 L
.72228 .18543 L
.72328 .18543 L
.72428 .18543 L
.72527 .18543 L
.72627 .18543 L
.72727 .18543 L
.72827 .18543 L
.72927 .18543 L
.73027 .18542 L
.73127 .18542 L
.73227 .18542 L
.73327 .18542 L
.73427 .18542 L
.73526 .18542 L
.73626 .18542 L
.73726 .18542 L
.73826 .18542 L
.73926 .18542 L
.74026 .18542 L
.74126 .18542 L
.74226 .18542 L
.74326 .18542 L
.74426 .18542 L
.74525 .18542 L
.74625 .18542 L
.74725 .18542 L
.74825 .18542 L
Mistroke
.74925 .18542 L
.75025 .18542 L
.75125 .18542 L
.75225 .18542 L
.75325 .18542 L
.75425 .18542 L
.75524 .18542 L
.75624 .18542 L
.75724 .18542 L
.75824 .18542 L
.75924 .18542 L
.76024 .18542 L
.76124 .18542 L
.76224 .18542 L
.76324 .18542 L
.76424 .18542 L
.76523 .18542 L
.76623 .18542 L
.76723 .18542 L
.76823 .18542 L
.76923 .18542 L
.77023 .18542 L
.77123 .18542 L
.77223 .18542 L
.77323 .18542 L
.77423 .18542 L
.77522 .18542 L
.77622 .18541 L
.77722 .18541 L
.77822 .18541 L
.77922 .18541 L
.78022 .18541 L
.78122 .18541 L
.78222 .18541 L
.78322 .18541 L
.78422 .18541 L
.78521 .18541 L
.78621 .18541 L
.78721 .18541 L
.78821 .18541 L
.78921 .18541 L
.79021 .18541 L
.79121 .18541 L
.79221 .18541 L
.79321 .18541 L
.79421 .18541 L
.7952 .18542 L
.7962 .18542 L
.7972 .18542 L
.7982 .18542 L
Mistroke
.7992 .18542 L
.8002 .18542 L
.8012 .18541 L
.8022 .18541 L
.8032 .18541 L
.8042 .18541 L
.80519 .18541 L
.80619 .18541 L
.80719 .18541 L
.80819 .18541 L
.80919 .18541 L
.81019 .18541 L
.81119 .18541 L
.81219 .18542 L
.81319 .18542 L
.81419 .18541 L
.81518 .18542 L
.81618 .18542 L
.81718 .18542 L
.81818 .18542 L
.81918 .18542 L
.82018 .18542 L
.82118 .18542 L
.82218 .18542 L
.82318 .18541 L
.82418 .18541 L
.82517 .18541 L
.82617 .18541 L
.82717 .18541 L
.82817 .18541 L
.82917 .18541 L
.83017 .18541 L
.83117 .18541 L
.83217 .18541 L
.83317 .18541 L
.83417 .18541 L
.83516 .18541 L
.83616 .18541 L
.83716 .18541 L
.83816 .18541 L
.83916 .18541 L
.84016 .18541 L
.84116 .18541 L
.84216 .18541 L
.84316 .18541 L
.84416 .18541 L
.84515 .18541 L
.84615 .18541 L
.84715 .18541 L
.84815 .18541 L
Mistroke
.84915 .18541 L
.85015 .18541 L
.85115 .18541 L
.85215 .18541 L
.85315 .18541 L
.85415 .18541 L
.85514 .18541 L
.85614 .18541 L
.85714 .18541 L
.85814 .18541 L
.85914 .18541 L
.86014 .18541 L
.86114 .18541 L
.86214 .18541 L
.86314 .18541 L
.86414 .18541 L
.86513 .18541 L
.86613 .18541 L
.86713 .18541 L
.86813 .18541 L
.86913 .18541 L
.87013 .18541 L
.87113 .18541 L
.87213 .18541 L
.87313 .18541 L
.87413 .18541 L
.87512 .18541 L
.87612 .18541 L
.87712 .18541 L
.87812 .18541 L
.87912 .18542 L
.88012 .18542 L
.88112 .18542 L
.88212 .18542 L
.88312 .18542 L
.88412 .18542 L
.88511 .18542 L
.88611 .18542 L
.88711 .18542 L
.88811 .18542 L
.88911 .18542 L
.89011 .18541 L
.89111 .18541 L
.89211 .18541 L
.89311 .18541 L
.89411 .18541 L
.8951 .18541 L
.8961 .18541 L
.8971 .18541 L
.8981 .18541 L
Mistroke
.8991 .18541 L
.9001 .18541 L
.9011 .18542 L
.9021 .18542 L
.9031 .18542 L
.9041 .18542 L
.90509 .18542 L
.90609 .18542 L
.90709 .18542 L
.90809 .18542 L
.90909 .18542 L
.91009 .18542 L
.91109 .18542 L
.91209 .18542 L
.91309 .18542 L
.91409 .18542 L
.91508 .18542 L
.91608 .18542 L
.91708 .18542 L
.91808 .18542 L
.91908 .18542 L
.92008 .18542 L
.92108 .18542 L
.92208 .18542 L
.92308 .18542 L
.92408 .18542 L
.92507 .18542 L
.92607 .18542 L
.92707 .18542 L
.92807 .18542 L
.92907 .18542 L
.93007 .18542 L
.93107 .18542 L
.93207 .18542 L
.93307 .18542 L
.93407 .18542 L
.93506 .18542 L
.93606 .18542 L
.93706 .18542 L
.93806 .18542 L
.93906 .18542 L
.94006 .18542 L
.94106 .18542 L
.94206 .18542 L
.94306 .18542 L
.94406 .18542 L
.94505 .18542 L
.94605 .18542 L
.94705 .18542 L
.94805 .18542 L
Mistroke
.94905 .18542 L
.95005 .18542 L
.95105 .18542 L
.95205 .18542 L
.95305 .18542 L
.95405 .18542 L
.95504 .18542 L
.95604 .18541 L
.95704 .18542 L
.95804 .18542 L
.95904 .18542 L
.96004 .18542 L
.96104 .18542 L
.96204 .18542 L
.96304 .18542 L
.96404 .18542 L
.96503 .18542 L
.96603 .18542 L
.96703 .18541 L
.96803 .18541 L
.96903 .18541 L
.97003 .18541 L
.97103 .18541 L
.97203 .18541 L
.97303 .18541 L
.97403 .18541 L
.97502 .18541 L
.97602 .18541 L
.97702 .18541 L
.97802 .18541 L
.97902 .18541 L
.98002 .18541 L
.98102 .18541 L
.98202 .18541 L
.98302 .18541 L
.98402 .18541 L
.98501 .18541 L
.98601 .18541 L
.98701 .18541 L
.98801 .18541 L
.98901 .18541 L
.99001 .18541 L
.99101 .18541 L
.99201 .18541 L
.99301 .18541 L
.99401 .18541 L
.995 .18541 L
.996 .18541 L
.997 .18541 L
.998 .18541 L
Mistroke
.999 .18541 L
Mfstroke
0 .98 .604 r
gsave
.999 .16247 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .12608 m
.001 .12608 L
.002 .12608 L
.003 .12608 L
.004 .12608 L
.005 .12608 L
.00599 .12608 L
.00699 .12608 L
.00799 .12608 L
.00899 .12608 L
.00999 .12608 L
.01099 .12608 L
.01199 .12608 L
.01299 .12608 L
.01399 .12608 L
.01499 .12608 L
.01598 .12608 L
.01698 .12608 L
.01798 .12608 L
.01898 .12608 L
.01998 .12608 L
.02098 .12608 L
.02198 .12608 L
.02298 .12608 L
.02398 .12608 L
.02498 .12608 L
.02597 .12608 L
.02697 .12608 L
.02797 .12608 L
.02897 .12608 L
.02997 .12608 L
.03097 .12608 L
.03197 .12608 L
.03297 .12608 L
.03397 .12608 L
.03497 .12608 L
.03596 .12608 L
.03696 .12608 L
.03796 .12608 L
.03896 .12608 L
.03996 .12608 L
.04096 .12608 L
.04196 .12608 L
.04296 .12608 L
.04396 .12608 L
.04496 .12608 L
.04595 .12608 L
.04695 .12608 L
.04795 .12608 L
.04895 .12608 L
Mistroke
.04995 .12465 L
.05095 .12465 L
.05195 .12465 L
.05295 .12465 L
.05395 .12465 L
.05495 .12465 L
.05594 .12465 L
.05694 .12465 L
.05794 .12465 L
.05894 .12465 L
.05994 .12465 L
.06094 .12465 L
.06194 .12465 L
.06294 .12465 L
.06394 .12465 L
.06494 .12465 L
.06593 .12465 L
.06693 .12465 L
.06793 .12465 L
.06893 .12465 L
.06993 .12465 L
.07093 .12465 L
.07193 .12465 L
.07293 .12465 L
.07393 .12465 L
.07493 .12465 L
.07592 .12465 L
.07692 .12465 L
.07792 .12465 L
.07892 .12465 L
.07992 .12465 L
.08092 .12465 L
.08192 .12465 L
.08292 .12465 L
.08392 .12465 L
.08492 .12465 L
.08591 .12465 L
.08691 .12465 L
.08791 .12465 L
.08891 .12465 L
.08991 .12465 L
.09091 .12465 L
.09191 .12465 L
.09291 .12465 L
.09391 .12465 L
.09491 .12465 L
.0959 .12465 L
.0969 .12465 L
.0979 .12465 L
.0989 .12465 L
Mistroke
.0999 .14211 L
.1009 .14211 L
.1019 .14211 L
.1029 .14211 L
.1039 .14211 L
.1049 .14211 L
.10589 .14211 L
.10689 .14211 L
.10789 .14211 L
.10889 .14211 L
.10989 .14211 L
.11089 .14211 L
.11189 .14211 L
.11289 .14211 L
.11389 .14211 L
.11489 .14211 L
.11588 .14211 L
.11688 .14211 L
.11788 .14211 L
.11888 .14211 L
.11988 .14211 L
.12088 .14211 L
.12188 .14211 L
.12288 .14211 L
.12388 .14211 L
.12488 .14211 L
.12587 .14211 L
.12687 .14211 L
.12787 .14211 L
.12887 .14211 L
.12987 .14211 L
.13087 .14211 L
.13187 .14211 L
.13287 .14211 L
.13387 .14211 L
.13487 .14211 L
.13586 .14211 L
.13686 .14211 L
.13786 .14211 L
.13886 .14211 L
.13986 .14211 L
.14086 .14211 L
.14186 .14211 L
.14286 .14211 L
.14386 .14211 L
.14486 .14211 L
.14585 .14211 L
.14685 .14211 L
.14785 .14211 L
.14885 .14211 L
Mistroke
.14985 .08679 L
.15085 .08679 L
.15185 .08679 L
.15285 .08679 L
.15385 .08679 L
.15485 .08679 L
.15584 .08679 L
.15684 .08679 L
.15784 .08679 L
.15884 .08679 L
.15984 .08679 L
.16084 .08679 L
.16184 .08679 L
.16284 .08679 L
.16384 .08679 L
.16484 .08679 L
.16583 .08679 L
.16683 .08679 L
.16783 .08679 L
.16883 .08679 L
.16983 .08679 L
.17083 .08679 L
.17183 .08679 L
.17283 .08679 L
.17383 .08679 L
.17483 .08679 L
.17582 .08679 L
.17682 .08679 L
.17782 .08679 L
.17882 .08679 L
.17982 .08679 L
.18082 .08679 L
.18182 .08679 L
.18282 .08679 L
.18382 .08679 L
.18482 .08679 L
.18581 .08679 L
.18681 .08679 L
.18781 .08679 L
.18881 .08679 L
.18981 .08679 L
.19081 .08679 L
.19181 .08679 L
.19281 .08679 L
.19381 .08679 L
.19481 .08679 L
.1958 .08679 L
.1968 .08679 L
.1978 .08679 L
.1988 .08679 L
Mistroke
.1998 .10817 L
.2008 .10817 L
.2018 .10817 L
.2028 .10817 L
.2038 .10817 L
.2048 .10817 L
.20579 .10817 L
.20679 .10817 L
.20779 .10817 L
.20879 .10817 L
.20979 .10817 L
.21079 .10817 L
.21179 .10817 L
.21279 .10817 L
.21379 .10817 L
.21479 .10817 L
.21578 .10817 L
.21678 .10817 L
.21778 .10817 L
.21878 .10817 L
.21978 .10817 L
.22078 .10817 L
.22178 .10817 L
.22278 .10817 L
.22378 .10817 L
.22478 .10817 L
.22577 .10817 L
.22677 .10817 L
.22777 .10817 L
.22877 .10817 L
.22977 .10817 L
.23077 .10817 L
.23177 .10817 L
.23277 .10817 L
.23377 .10817 L
.23477 .10817 L
.23576 .10817 L
.23676 .10817 L
.23776 .10817 L
.23876 .10817 L
.23976 .10817 L
.24076 .10817 L
.24176 .10817 L
.24276 .10817 L
.24376 .10817 L
.24476 .10817 L
.24575 .10817 L
.24675 .10817 L
.24775 .10817 L
.24875 .10817 L
Mistroke
.24975 .14656 L
.25075 .14656 L
.25175 .14656 L
.25275 .14656 L
.25375 .14656 L
.25475 .14656 L
.25574 .14656 L
.25674 .14656 L
.25774 .14656 L
.25874 .14656 L
.25974 .14656 L
.26074 .14656 L
.26174 .14656 L
.26274 .14656 L
.26374 .14656 L
.26474 .14656 L
.26573 .14656 L
.26673 .14656 L
.26773 .14656 L
.26873 .14656 L
.26973 .14656 L
.27073 .14656 L
.27173 .14656 L
.27273 .14656 L
.27373 .14656 L
.27473 .14656 L
.27572 .14656 L
.27672 .14656 L
.27772 .14656 L
.27872 .14656 L
.27972 .14656 L
.28072 .14656 L
.28172 .14656 L
.28272 .14656 L
.28372 .14656 L
.28472 .14656 L
.28571 .14656 L
.28671 .14656 L
.28771 .14656 L
.28871 .14656 L
.28971 .14656 L
.29071 .14656 L
.29171 .14656 L
.29271 .14656 L
.29371 .14656 L
.29471 .14656 L
.2957 .14656 L
.2967 .14656 L
.2977 .14656 L
.2987 .14656 L
Mistroke
.2997 .1498 L
.3007 .1498 L
.3017 .1498 L
.3027 .1498 L
.3037 .1498 L
.3047 .1498 L
.30569 .1498 L
.30669 .1498 L
.30769 .1498 L
.30869 .1498 L
.30969 .1498 L
.31069 .1498 L
.31169 .1498 L
.31269 .1498 L
.31369 .1498 L
.31469 .1498 L
.31568 .1498 L
.31668 .1498 L
.31768 .1498 L
.31868 .1498 L
.31968 .1498 L
.32068 .1498 L
.32168 .1498 L
.32268 .1498 L
.32368 .1498 L
.32468 .1498 L
.32567 .1498 L
.32667 .1498 L
.32767 .1498 L
.32867 .1498 L
.32967 .1498 L
.33067 .1498 L
.33167 .1498 L
.33267 .1498 L
.33367 .1498 L
.33467 .1498 L
.33566 .1498 L
.33666 .1498 L
.33766 .1498 L
.33866 .1498 L
.33966 .1498 L
.34066 .1498 L
.34166 .1498 L
.34266 .1498 L
.34366 .1498 L
.34466 .1498 L
.34565 .1498 L
.34665 .1498 L
.34765 .1498 L
.34865 .1498 L
Mistroke
.34965 .1396 L
.35065 .1396 L
.35165 .1396 L
.35265 .1396 L
.35365 .1396 L
.35465 .1396 L
.35564 .1396 L
.35664 .1396 L
.35764 .1396 L
.35864 .1396 L
.35964 .1396 L
.36064 .1396 L
.36164 .1396 L
.36264 .1396 L
.36364 .1396 L
.36464 .1396 L
.36563 .1396 L
.36663 .1396 L
.36763 .1396 L
.36863 .1396 L
.36963 .1396 L
.37063 .1396 L
.37163 .1396 L
.37263 .1396 L
.37363 .1396 L
.37463 .1396 L
.37562 .1396 L
.37662 .1396 L
.37762 .1396 L
.37862 .1396 L
.37962 .1396 L
.38062 .1396 L
.38162 .1396 L
.38262 .1396 L
.38362 .1396 L
.38462 .1396 L
.38561 .1396 L
.38661 .1396 L
.38761 .1396 L
.38861 .1396 L
.38961 .1396 L
.39061 .1396 L
.39161 .1396 L
.39261 .1396 L
.39361 .1396 L
.39461 .1396 L
.3956 .1396 L
.3966 .1396 L
.3976 .1396 L
.3986 .1396 L
Mistroke
.3996 .1444 L
.4006 .1444 L
.4016 .1444 L
.4026 .1444 L
.4036 .1444 L
.4046 .1444 L
.40559 .1444 L
.40659 .1444 L
.40759 .1444 L
.40859 .1444 L
.40959 .1444 L
.41059 .1444 L
.41159 .1444 L
.41259 .1444 L
.41359 .1444 L
.41459 .1444 L
.41558 .1444 L
.41658 .1444 L
.41758 .1444 L
.41858 .1444 L
.41958 .1444 L
.42058 .1444 L
.42158 .1444 L
.42258 .1444 L
.42358 .1444 L
.42458 .1444 L
.42557 .1444 L
.42657 .1444 L
.42757 .1444 L
.42857 .1444 L
.42957 .1444 L
.43057 .1444 L
.43157 .1444 L
.43257 .1444 L
.43357 .1444 L
.43457 .1444 L
.43556 .1444 L
.43656 .1444 L
.43756 .1444 L
.43856 .1444 L
.43956 .1444 L
.44056 .1444 L
.44156 .1444 L
.44256 .1444 L
.44356 .1444 L
.44456 .1444 L
.44555 .1444 L
.44655 .1444 L
.44755 .1444 L
.44855 .1444 L
Mistroke
.44955 .15101 L
.45055 .15101 L
.45155 .15101 L
.45255 .15101 L
.45355 .15101 L
.45455 .15101 L
.45554 .15101 L
.45654 .15101 L
.45754 .15101 L
.45854 .15101 L
.45954 .15101 L
.46054 .15101 L
.46154 .15101 L
.46254 .15101 L
.46354 .15101 L
.46454 .15101 L
.46553 .15101 L
.46653 .15101 L
.46753 .15101 L
.46853 .15101 L
.46953 .15101 L
.47053 .15101 L
.47153 .15101 L
.47253 .15101 L
.47353 .15101 L
.47453 .15101 L
.47552 .15101 L
.47652 .15101 L
.47752 .15101 L
.47852 .15101 L
.47952 .15101 L
.48052 .15101 L
.48152 .15101 L
.48252 .15101 L
.48352 .15101 L
.48452 .15101 L
.48551 .15101 L
.48651 .15101 L
.48751 .15101 L
.48851 .15101 L
.48951 .15101 L
.49051 .15101 L
.49151 .15101 L
.49251 .15101 L
.49351 .15101 L
.49451 .15101 L
.4955 .15101 L
.4965 .15101 L
.4975 .15101 L
.4985 .15101 L
Mistroke
.4995 .16053 L
.5005 .16053 L
.5015 .16053 L
.5025 .16053 L
.5035 .16053 L
.5045 .16053 L
.50549 .16053 L
.50649 .16053 L
.50749 .16053 L
.50849 .16053 L
.50949 .16053 L
.51049 .16053 L
.51149 .16053 L
.51249 .16053 L
.51349 .16053 L
.51449 .16053 L
.51548 .16053 L
.51648 .16053 L
.51748 .16053 L
.51848 .16053 L
.51948 .16053 L
.52048 .16053 L
.52148 .16053 L
.52248 .16053 L
.52348 .16053 L
.52448 .16053 L
.52547 .16053 L
.52647 .16053 L
.52747 .16053 L
.52847 .16053 L
.52947 .16053 L
.53047 .16053 L
.53147 .16053 L
.53247 .16053 L
.53347 .16053 L
.53447 .16053 L
.53546 .16053 L
.53646 .16053 L
.53746 .16053 L
.53846 .16053 L
.53946 .16053 L
.54046 .16053 L
.54146 .16053 L
.54246 .16053 L
.54346 .16053 L
.54446 .16053 L
.54545 .16053 L
.54645 .16053 L
.54745 .16053 L
.54845 .16053 L
Mistroke
.54945 .17131 L
.55045 .17131 L
.55145 .17131 L
.55245 .17131 L
.55345 .17131 L
.55445 .17131 L
.55544 .17131 L
.55644 .17131 L
.55744 .17131 L
.55844 .17131 L
.55944 .17131 L
.56044 .17131 L
.56144 .17131 L
.56244 .17131 L
.56344 .17131 L
.56444 .17131 L
.56543 .17131 L
.56643 .17131 L
.56743 .17131 L
.56843 .17131 L
.56943 .17131 L
.57043 .17131 L
.57143 .17131 L
.57243 .17131 L
.57343 .17131 L
.57443 .17131 L
.57542 .17131 L
.57642 .17131 L
.57742 .17131 L
.57842 .17131 L
.57942 .17131 L
.58042 .17131 L
.58142 .17131 L
.58242 .17131 L
.58342 .17131 L
.58442 .17131 L
.58541 .17131 L
.58641 .17131 L
.58741 .17131 L
.58841 .17131 L
.58941 .17131 L
.59041 .17131 L
.59141 .17131 L
.59241 .17131 L
.59341 .17131 L
.59441 .17131 L
.5954 .17131 L
.5964 .17131 L
.5974 .17131 L
.5984 .17131 L
Mistroke
.5994 .16862 L
.6004 .16862 L
.6014 .16862 L
.6024 .16862 L
.6034 .16862 L
.6044 .16862 L
.60539 .16862 L
.60639 .16862 L
.60739 .16862 L
.60839 .16862 L
.60939 .16862 L
.61039 .16862 L
.61139 .16862 L
.61239 .16862 L
.61339 .16862 L
.61439 .16862 L
.61538 .16862 L
.61638 .16862 L
.61738 .16862 L
.61838 .16862 L
.61938 .16862 L
.62038 .16862 L
.62138 .16862 L
.62238 .16862 L
.62338 .16862 L
.62438 .16862 L
.62537 .16862 L
.62637 .16862 L
.62737 .16862 L
.62837 .16862 L
.62937 .16862 L
.63037 .16862 L
.63137 .16862 L
.63237 .16862 L
.63337 .16862 L
.63437 .16862 L
.63536 .16862 L
.63636 .16862 L
.63736 .16862 L
.63836 .16862 L
.63936 .16862 L
.64036 .16862 L
.64136 .16862 L
.64236 .16862 L
.64336 .16862 L
.64436 .16862 L
.64535 .16862 L
.64635 .16862 L
.64735 .16862 L
.64835 .16862 L
Mistroke
.64935 .16019 L
.65035 .16019 L
.65135 .16019 L
.65235 .16019 L
.65335 .16019 L
.65435 .16019 L
.65534 .16019 L
.65634 .16019 L
.65734 .16019 L
.65834 .16019 L
.65934 .16019 L
.66034 .16019 L
.66134 .16019 L
.66234 .16019 L
.66334 .16019 L
.66434 .16019 L
.66533 .16019 L
.66633 .16019 L
.66733 .16019 L
.66833 .16019 L
.66933 .16019 L
.67033 .16019 L
.67133 .16019 L
.67233 .16019 L
.67333 .16019 L
.67433 .16019 L
.67532 .16019 L
.67632 .16019 L
.67732 .16019 L
.67832 .16019 L
.67932 .16019 L
.68032 .16019 L
.68132 .16019 L
.68232 .16019 L
.68332 .16019 L
.68432 .16019 L
.68531 .16019 L
.68631 .16019 L
.68731 .16019 L
.68831 .16019 L
.68931 .16019 L
.69031 .16019 L
.69131 .16019 L
.69231 .16019 L
.69331 .16019 L
.69431 .16019 L
.6953 .16019 L
.6963 .16019 L
.6973 .16019 L
.6983 .16019 L
Mistroke
.6993 .16468 L
.7003 .16468 L
.7013 .16468 L
.7023 .16468 L
.7033 .16468 L
.7043 .16468 L
.70529 .16468 L
.70629 .16468 L
.70729 .16468 L
.70829 .16468 L
.70929 .16468 L
.71029 .16468 L
.71129 .16468 L
.71229 .16468 L
.71329 .16468 L
.71429 .16468 L
.71528 .16468 L
.71628 .16468 L
.71728 .16468 L
.71828 .16468 L
.71928 .16468 L
.72028 .16468 L
.72128 .16468 L
.72228 .16468 L
.72328 .16468 L
.72428 .16468 L
.72527 .16468 L
.72627 .16468 L
.72727 .16468 L
.72827 .16468 L
.72927 .16468 L
.73027 .16468 L
.73127 .16468 L
.73227 .16468 L
.73327 .16468 L
.73427 .16468 L
.73526 .16468 L
.73626 .16468 L
.73726 .16468 L
.73826 .16468 L
.73926 .16468 L
.74026 .16468 L
.74126 .16468 L
.74226 .16468 L
.74326 .16468 L
.74426 .16468 L
.74525 .16468 L
.74625 .16468 L
.74725 .16468 L
.74825 .16468 L
Mistroke
.74925 .16906 L
.75025 .16906 L
.75125 .16906 L
.75225 .16906 L
.75325 .16906 L
.75425 .16906 L
.75524 .16906 L
.75624 .16906 L
.75724 .16906 L
.75824 .16906 L
.75924 .16906 L
.76024 .16906 L
.76124 .16906 L
.76224 .16906 L
.76324 .16906 L
.76424 .16906 L
.76523 .16906 L
.76623 .16906 L
.76723 .16906 L
.76823 .16906 L
.76923 .16906 L
.77023 .16906 L
.77123 .16906 L
.77223 .16906 L
.77323 .16906 L
.77423 .16906 L
.77522 .16906 L
.77622 .16906 L
.77722 .16906 L
.77822 .16906 L
.77922 .16906 L
.78022 .16906 L
.78122 .16906 L
.78222 .16906 L
.78322 .16906 L
.78422 .16906 L
.78521 .16906 L
.78621 .16906 L
.78721 .16906 L
.78821 .16906 L
.78921 .16906 L
.79021 .16906 L
.79121 .16906 L
.79221 .16906 L
.79321 .16906 L
.79421 .16906 L
.7952 .16906 L
.7962 .16906 L
.7972 .16906 L
.7982 .16906 L
Mistroke
.7992 .17367 L
.8002 .17367 L
.8012 .17367 L
.8022 .17367 L
.8032 .17367 L
.8042 .17367 L
.80519 .17367 L
.80619 .17367 L
.80719 .17367 L
.80819 .17367 L
.80919 .17367 L
.81019 .17367 L
.81119 .17367 L
.81219 .17367 L
.81319 .17367 L
.81419 .17367 L
.81518 .17367 L
.81618 .17367 L
.81718 .17367 L
.81818 .17367 L
.81918 .17367 L
.82018 .17367 L
.82118 .17367 L
.82218 .17367 L
.82318 .17367 L
.82418 .17367 L
.82517 .17367 L
.82617 .17367 L
.82717 .17367 L
.82817 .17367 L
.82917 .17367 L
.83017 .17367 L
.83117 .17367 L
.83217 .17367 L
.83317 .17367 L
.83417 .17367 L
.83516 .17367 L
.83616 .17367 L
.83716 .17367 L
.83816 .17367 L
.83916 .17367 L
.84016 .17367 L
.84116 .17367 L
.84216 .17367 L
.84316 .17367 L
.84416 .17367 L
.84515 .17367 L
.84615 .17367 L
.84715 .17367 L
.84815 .17367 L
Mistroke
.84915 .17675 L
.85015 .17675 L
.85115 .17675 L
.85215 .17675 L
.85315 .17675 L
.85415 .17675 L
.85514 .17675 L
.85614 .17675 L
.85714 .17675 L
.85814 .17675 L
.85914 .17675 L
.86014 .17675 L
.86114 .17675 L
.86214 .17675 L
.86314 .17675 L
.86414 .17675 L
.86513 .17675 L
.86613 .17675 L
.86713 .17675 L
.86813 .17675 L
.86913 .17675 L
.87013 .17675 L
.87113 .17675 L
.87213 .17675 L
.87313 .17675 L
.87413 .17675 L
.87512 .17675 L
.87612 .17675 L
.87712 .17675 L
.87812 .17675 L
.87912 .17675 L
.88012 .17675 L
.88112 .17675 L
.88212 .17675 L
.88312 .17675 L
.88412 .17675 L
.88511 .17675 L
.88611 .17675 L
.88711 .17675 L
.88811 .17675 L
.88911 .17675 L
.89011 .17675 L
.89111 .17675 L
.89211 .17675 L
.89311 .17675 L
.89411 .17675 L
.8951 .17675 L
.8961 .17675 L
.8971 .17675 L
.8981 .17675 L
Mistroke
.8991 .16852 L
.9001 .16852 L
.9011 .16852 L
.9021 .16852 L
.9031 .16852 L
.9041 .16852 L
.90509 .16852 L
.90609 .16852 L
.90709 .16852 L
.90809 .16852 L
.90909 .16852 L
.91009 .16852 L
.91109 .16852 L
.91209 .16852 L
.91309 .16852 L
.91409 .16852 L
.91508 .16852 L
.91608 .16852 L
.91708 .16852 L
.91808 .16852 L
.91908 .16852 L
.92008 .16852 L
.92108 .16852 L
.92208 .16852 L
.92308 .16852 L
.92408 .16852 L
.92507 .16852 L
.92607 .16852 L
.92707 .16852 L
.92807 .16852 L
.92907 .16852 L
.93007 .16852 L
.93107 .16852 L
.93207 .16852 L
.93307 .16852 L
.93407 .16852 L
.93506 .16852 L
.93606 .16852 L
.93706 .16852 L
.93806 .16852 L
.93906 .16852 L
.94006 .16852 L
.94106 .16852 L
.94206 .16852 L
.94306 .16852 L
.94406 .16852 L
.94505 .16852 L
.94605 .16852 L
.94705 .16852 L
.94805 .16852 L
Mistroke
.94905 .16599 L
.95005 .16599 L
.95105 .16599 L
.95205 .16599 L
.95305 .16599 L
.95405 .16599 L
.95504 .16599 L
.95604 .16599 L
.95704 .16599 L
.95804 .16599 L
.95904 .16599 L
.96004 .16599 L
.96104 .16599 L
.96204 .16599 L
.96304 .16599 L
.96404 .16599 L
.96503 .16599 L
.96603 .16599 L
.96703 .16599 L
.96803 .16599 L
.96903 .16599 L
.97003 .16599 L
.97103 .16599 L
.97203 .16599 L
.97303 .16599 L
.97403 .16599 L
.97502 .16599 L
.97602 .16599 L
.97702 .16599 L
.97802 .16599 L
.97902 .16599 L
.98002 .16599 L
.98102 .16599 L
.98202 .16599 L
.98302 .16599 L
.98402 .16599 L
.98501 .16599 L
.98601 .16599 L
.98701 .16599 L
.98801 .16599 L
.98901 .16599 L
.99001 .16599 L
.99101 .16599 L
.99201 .16599 L
.99301 .16599 L
.99401 .16599 L
.995 .16599 L
.996 .16599 L
.997 .16599 L
.998 .16599 L
Mistroke
.999 .16247 L
Mfstroke
gsave
.999 .25638 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36835 m
.001 .36835 L
.002 .36835 L
.003 .36835 L
.004 .36835 L
.005 .36835 L
.00599 .36835 L
.00699 .36835 L
.00799 .36835 L
.00899 .36835 L
.00999 .36835 L
.01099 .36835 L
.01199 .36835 L
.01299 .36835 L
.01399 .36835 L
.01499 .36835 L
.01598 .36835 L
.01698 .36835 L
.01798 .36835 L
.01898 .36835 L
.01998 .36835 L
.02098 .36835 L
.02198 .36835 L
.02298 .36835 L
.02398 .36835 L
.02498 .36835 L
.02597 .36835 L
.02697 .36835 L
.02797 .36835 L
.02897 .36835 L
.02997 .36835 L
.03097 .36835 L
.03197 .36835 L
.03297 .36835 L
.03397 .36835 L
.03497 .36835 L
.03596 .36835 L
.03696 .36835 L
.03796 .36835 L
.03896 .36835 L
.03996 .36835 L
.04096 .36835 L
.04196 .36835 L
.04296 .36835 L
.04396 .36835 L
.04496 .36835 L
.04595 .36835 L
.04695 .36835 L
.04795 .36835 L
.04895 .36835 L
Mistroke
.04995 .36611 L
.05095 .36611 L
.05195 .36611 L
.05295 .36611 L
.05395 .36611 L
.05495 .36611 L
.05594 .36611 L
.05694 .36611 L
.05794 .36611 L
.05894 .36611 L
.05994 .36611 L
.06094 .36611 L
.06194 .36611 L
.06294 .36611 L
.06394 .36611 L
.06494 .36611 L
.06593 .36611 L
.06693 .36611 L
.06793 .36611 L
.06893 .36611 L
.06993 .36611 L
.07093 .36611 L
.07193 .36611 L
.07293 .36611 L
.07393 .36611 L
.07493 .36611 L
.07592 .36611 L
.07692 .36611 L
.07792 .36611 L
.07892 .36611 L
.07992 .36611 L
.08092 .36611 L
.08192 .36611 L
.08292 .36611 L
.08392 .36611 L
.08492 .36611 L
.08591 .36611 L
.08691 .36611 L
.08791 .36611 L
.08891 .36611 L
.08991 .36611 L
.09091 .36611 L
.09191 .36611 L
.09291 .36611 L
.09391 .36611 L
.09491 .36611 L
.0959 .36611 L
.0969 .36611 L
.0979 .36611 L
.0989 .36611 L
Mistroke
.0999 .35258 L
.1009 .35258 L
.1019 .35258 L
.1029 .35258 L
.1039 .35258 L
.1049 .35258 L
.10589 .35258 L
.10689 .35258 L
.10789 .35258 L
.10889 .35258 L
.10989 .35258 L
.11089 .35258 L
.11189 .35258 L
.11289 .35258 L
.11389 .35258 L
.11489 .35258 L
.11588 .35258 L
.11688 .35258 L
.11788 .35258 L
.11888 .35258 L
.11988 .35258 L
.12088 .35258 L
.12188 .35258 L
.12288 .35258 L
.12388 .35258 L
.12488 .35258 L
.12587 .35258 L
.12687 .35258 L
.12787 .35258 L
.12887 .35258 L
.12987 .35258 L
.13087 .35258 L
.13187 .35258 L
.13287 .35258 L
.13387 .35258 L
.13487 .35258 L
.13586 .35258 L
.13686 .35258 L
.13786 .35258 L
.13886 .35258 L
.13986 .35258 L
.14086 .35258 L
.14186 .35258 L
.14286 .35258 L
.14386 .35258 L
.14486 .35258 L
.14585 .35258 L
.14685 .35258 L
.14785 .35258 L
.14885 .35258 L
Mistroke
.14985 .26265 L
.15085 .26265 L
.15185 .26265 L
.15285 .26265 L
.15385 .26265 L
.15485 .26265 L
.15584 .26265 L
.15684 .26265 L
.15784 .26265 L
.15884 .26265 L
.15984 .26265 L
.16084 .26265 L
.16184 .26265 L
.16284 .26265 L
.16384 .26265 L
.16484 .26265 L
.16583 .26265 L
.16683 .26265 L
.16783 .26265 L
.16883 .26265 L
.16983 .26265 L
.17083 .26265 L
.17183 .26265 L
.17283 .26265 L
.17383 .26265 L
.17483 .26265 L
.17582 .26265 L
.17682 .26265 L
.17782 .26265 L
.17882 .26265 L
.17982 .26265 L
.18082 .26265 L
.18182 .26265 L
.18282 .26265 L
.18382 .26265 L
.18482 .26265 L
.18581 .26265 L
.18681 .26265 L
.18781 .26265 L
.18881 .26265 L
.18981 .26265 L
.19081 .26265 L
.19181 .26265 L
.19281 .26265 L
.19381 .26265 L
.19481 .26265 L
.1958 .26265 L
.1968 .26265 L
.1978 .26265 L
.1988 .26265 L
Mistroke
.1998 .27612 L
.2008 .27612 L
.2018 .27612 L
.2028 .27612 L
.2038 .27612 L
.2048 .27612 L
.20579 .27612 L
.20679 .27612 L
.20779 .27612 L
.20879 .27612 L
.20979 .27612 L
.21079 .27612 L
.21179 .27612 L
.21279 .27612 L
.21379 .27612 L
.21479 .27612 L
.21578 .27612 L
.21678 .27612 L
.21778 .27612 L
.21878 .27612 L
.21978 .27612 L
.22078 .27612 L
.22178 .27612 L
.22278 .27612 L
.22378 .27612 L
.22478 .27612 L
.22577 .27612 L
.22677 .27612 L
.22777 .27612 L
.22877 .27612 L
.22977 .27612 L
.23077 .27612 L
.23177 .27612 L
.23277 .27612 L
.23377 .27612 L
.23477 .27612 L
.23576 .27612 L
.23676 .27612 L
.23776 .27612 L
.23876 .27612 L
.23976 .27612 L
.24076 .27612 L
.24176 .27612 L
.24276 .27612 L
.24376 .27612 L
.24476 .27612 L
.24575 .27612 L
.24675 .27612 L
.24775 .27612 L
.24875 .27612 L
Mistroke
.24975 .3014 L
.25075 .3014 L
.25175 .3014 L
.25275 .3014 L
.25375 .3014 L
.25475 .3014 L
.25574 .3014 L
.25674 .3014 L
.25774 .3014 L
.25874 .3014 L
.25974 .3014 L
.26074 .3014 L
.26174 .3014 L
.26274 .3014 L
.26374 .3014 L
.26474 .3014 L
.26573 .3014 L
.26673 .3014 L
.26773 .3014 L
.26873 .3014 L
.26973 .3014 L
.27073 .3014 L
.27173 .3014 L
.27273 .3014 L
.27373 .3014 L
.27473 .3014 L
.27572 .3014 L
.27672 .3014 L
.27772 .3014 L
.27872 .3014 L
.27972 .3014 L
.28072 .3014 L
.28172 .3014 L
.28272 .3014 L
.28372 .3014 L
.28472 .3014 L
.28571 .3014 L
.28671 .3014 L
.28771 .3014 L
.28871 .3014 L
.28971 .3014 L
.29071 .3014 L
.29171 .3014 L
.29271 .3014 L
.29371 .3014 L
.29471 .3014 L
.2957 .3014 L
.2967 .3014 L
.2977 .3014 L
.2987 .3014 L
Mistroke
.2997 .29893 L
.3007 .29893 L
.3017 .29893 L
.3027 .29893 L
.3037 .29893 L
.3047 .29893 L
.30569 .29893 L
.30669 .29893 L
.30769 .29893 L
.30869 .29893 L
.30969 .29893 L
.31069 .29893 L
.31169 .29893 L
.31269 .29893 L
.31369 .29893 L
.31469 .29893 L
.31568 .29893 L
.31668 .29893 L
.31768 .29893 L
.31868 .29893 L
.31968 .29893 L
.32068 .29893 L
.32168 .29893 L
.32268 .29893 L
.32368 .29893 L
.32468 .29893 L
.32567 .29893 L
.32667 .29893 L
.32767 .29893 L
.32867 .29893 L
.32967 .29893 L
.33067 .29893 L
.33167 .29893 L
.33267 .29893 L
.33367 .29893 L
.33467 .29893 L
.33566 .29893 L
.33666 .29893 L
.33766 .29893 L
.33866 .29893 L
.33966 .29893 L
.34066 .29893 L
.34166 .29893 L
.34266 .29893 L
.34366 .29893 L
.34466 .29893 L
.34565 .29893 L
.34665 .29893 L
.34765 .29893 L
.34865 .29893 L
Mistroke
.34965 .27899 L
.35065 .27899 L
.35165 .27899 L
.35265 .27899 L
.35365 .27899 L
.35465 .27899 L
.35564 .27899 L
.35664 .27899 L
.35764 .27899 L
.35864 .27899 L
.35964 .27899 L
.36064 .27899 L
.36164 .27899 L
.36264 .27899 L
.36364 .27899 L
.36464 .27899 L
.36563 .27899 L
.36663 .27899 L
.36763 .27899 L
.36863 .27899 L
.36963 .27899 L
.37063 .27899 L
.37163 .27899 L
.37263 .27899 L
.37363 .27899 L
.37463 .27899 L
.37562 .27899 L
.37662 .27899 L
.37762 .27899 L
.37862 .27899 L
.37962 .27899 L
.38062 .27899 L
.38162 .27899 L
.38262 .27899 L
.38362 .27899 L
.38462 .27899 L
.38561 .27899 L
.38661 .27899 L
.38761 .27899 L
.38861 .27899 L
.38961 .27899 L
.39061 .27899 L
.39161 .27899 L
.39261 .27899 L
.39361 .27899 L
.39461 .27899 L
.3956 .27899 L
.3966 .27899 L
.3976 .27899 L
.3986 .27899 L
Mistroke
.3996 .2761 L
.4006 .2761 L
.4016 .2761 L
.4026 .2761 L
.4036 .2761 L
.4046 .2761 L
.40559 .2761 L
.40659 .2761 L
.40759 .2761 L
.40859 .2761 L
.40959 .2761 L
.41059 .2761 L
.41159 .2761 L
.41259 .2761 L
.41359 .2761 L
.41459 .2761 L
.41558 .2761 L
.41658 .2761 L
.41758 .2761 L
.41858 .2761 L
.41958 .2761 L
.42058 .2761 L
.42158 .2761 L
.42258 .2761 L
.42358 .2761 L
.42458 .2761 L
.42557 .2761 L
.42657 .2761 L
.42757 .2761 L
.42857 .2761 L
.42957 .2761 L
.43057 .2761 L
.43157 .2761 L
.43257 .2761 L
.43357 .2761 L
.43457 .2761 L
.43556 .2761 L
.43656 .2761 L
.43756 .2761 L
.43856 .2761 L
.43956 .2761 L
.44056 .2761 L
.44156 .2761 L
.44256 .2761 L
.44356 .2761 L
.44456 .2761 L
.44555 .2761 L
.44655 .2761 L
.44755 .2761 L
.44855 .2761 L
Mistroke
.44955 .27786 L
.45055 .27786 L
.45155 .27786 L
.45255 .27786 L
.45355 .27786 L
.45455 .27786 L
.45554 .27786 L
.45654 .27786 L
.45754 .27786 L
.45854 .27786 L
.45954 .27786 L
.46054 .27786 L
.46154 .27786 L
.46254 .27786 L
.46354 .27786 L
.46454 .27786 L
.46553 .27786 L
.46653 .27786 L
.46753 .27786 L
.46853 .27786 L
.46953 .27786 L
.47053 .27786 L
.47153 .27786 L
.47253 .27786 L
.47353 .27786 L
.47453 .27786 L
.47552 .27786 L
.47652 .27786 L
.47752 .27786 L
.47852 .27786 L
.47952 .27786 L
.48052 .27786 L
.48152 .27786 L
.48252 .27786 L
.48352 .27786 L
.48452 .27786 L
.48551 .27786 L
.48651 .27786 L
.48751 .27786 L
.48851 .27786 L
.48951 .27786 L
.49051 .27786 L
.49151 .27786 L
.49251 .27786 L
.49351 .27786 L
.49451 .27786 L
.4955 .27786 L
.4965 .27786 L
.4975 .27786 L
.4985 .27786 L
Mistroke
.4995 .28006 L
.5005 .28006 L
.5015 .28006 L
.5025 .28006 L
.5035 .28006 L
.5045 .28006 L
.50549 .28006 L
.50649 .28006 L
.50749 .28006 L
.50849 .28006 L
.50949 .28006 L
.51049 .28006 L
.51149 .28006 L
.51249 .28006 L
.51349 .28006 L
.51449 .28006 L
.51548 .28006 L
.51648 .28006 L
.51748 .28006 L
.51848 .28006 L
.51948 .28006 L
.52048 .28006 L
.52148 .28006 L
.52248 .28006 L
.52348 .28006 L
.52448 .28006 L
.52547 .28006 L
.52647 .28006 L
.52747 .28006 L
.52847 .28006 L
.52947 .28006 L
.53047 .28006 L
.53147 .28006 L
.53247 .28006 L
.53347 .28006 L
.53447 .28006 L
.53546 .28006 L
.53646 .28006 L
.53746 .28006 L
.53846 .28006 L
.53946 .28006 L
.54046 .28006 L
.54146 .28006 L
.54246 .28006 L
.54346 .28006 L
.54446 .28006 L
.54545 .28006 L
.54645 .28006 L
.54745 .28006 L
.54845 .28006 L
Mistroke
.54945 .28797 L
.55045 .28797 L
.55145 .28797 L
.55245 .28797 L
.55345 .28797 L
.55445 .28797 L
.55544 .28797 L
.55644 .28797 L
.55744 .28797 L
.55844 .28797 L
.55944 .28797 L
.56044 .28797 L
.56144 .28797 L
.56244 .28797 L
.56344 .28797 L
.56444 .28797 L
.56543 .28797 L
.56643 .28797 L
.56743 .28797 L
.56843 .28797 L
.56943 .28797 L
.57043 .28797 L
.57143 .28797 L
.57243 .28797 L
.57343 .28797 L
.57443 .28797 L
.57542 .28797 L
.57642 .28797 L
.57742 .28797 L
.57842 .28797 L
.57942 .28797 L
.58042 .28797 L
.58142 .28797 L
.58242 .28797 L
.58342 .28797 L
.58442 .28797 L
.58541 .28797 L
.58641 .28797 L
.58741 .28797 L
.58841 .28797 L
.58941 .28797 L
.59041 .28797 L
.59141 .28797 L
.59241 .28797 L
.59341 .28797 L
.59441 .28797 L
.5954 .28797 L
.5964 .28797 L
.5974 .28797 L
.5984 .28797 L
Mistroke
.5994 .28183 L
.6004 .28183 L
.6014 .28183 L
.6024 .28183 L
.6034 .28183 L
.6044 .28183 L
.60539 .28183 L
.60639 .28183 L
.60739 .28183 L
.60839 .28183 L
.60939 .28183 L
.61039 .28183 L
.61139 .28183 L
.61239 .28183 L
.61339 .28183 L
.61439 .28183 L
.61538 .28183 L
.61638 .28183 L
.61738 .28183 L
.61838 .28183 L
.61938 .28183 L
.62038 .28183 L
.62138 .28183 L
.62238 .28183 L
.62338 .28183 L
.62438 .28183 L
.62537 .28183 L
.62637 .28183 L
.62737 .28183 L
.62837 .28183 L
.62937 .28183 L
.63037 .28183 L
.63137 .28183 L
.63237 .28183 L
.63337 .28183 L
.63437 .28183 L
.63536 .28183 L
.63636 .28183 L
.63736 .28183 L
.63836 .28183 L
.63936 .28183 L
.64036 .28183 L
.64136 .28183 L
.64236 .28183 L
.64336 .28183 L
.64436 .28183 L
.64535 .28183 L
.64635 .28183 L
.64735 .28183 L
.64835 .28183 L
Mistroke
.64935 .26972 L
.65035 .26972 L
.65135 .26972 L
.65235 .26972 L
.65335 .26972 L
.65435 .26972 L
.65534 .26972 L
.65634 .26972 L
.65734 .26972 L
.65834 .26972 L
.65934 .26972 L
.66034 .26972 L
.66134 .26972 L
.66234 .26972 L
.66334 .26972 L
.66434 .26972 L
.66533 .26972 L
.66633 .26972 L
.66733 .26972 L
.66833 .26972 L
.66933 .26972 L
.67033 .26972 L
.67133 .26972 L
.67233 .26972 L
.67333 .26972 L
.67433 .26972 L
.67532 .26972 L
.67632 .26972 L
.67732 .26972 L
.67832 .26972 L
.67932 .26972 L
.68032 .26972 L
.68132 .26972 L
.68232 .26972 L
.68332 .26972 L
.68432 .26972 L
.68531 .26972 L
.68631 .26972 L
.68731 .26972 L
.68831 .26972 L
.68931 .26972 L
.69031 .26972 L
.69131 .26972 L
.69231 .26972 L
.69331 .26972 L
.69431 .26972 L
.6953 .26972 L
.6963 .26972 L
.6973 .26972 L
.6983 .26972 L
Mistroke
.6993 .27027 L
.7003 .27027 L
.7013 .27027 L
.7023 .27027 L
.7033 .27027 L
.7043 .27027 L
.70529 .27027 L
.70629 .27027 L
.70729 .27027 L
.70829 .27027 L
.70929 .27027 L
.71029 .27027 L
.71129 .27027 L
.71229 .27027 L
.71329 .27027 L
.71429 .27027 L
.71528 .27027 L
.71628 .27027 L
.71728 .27027 L
.71828 .27027 L
.71928 .27027 L
.72028 .27027 L
.72128 .27027 L
.72228 .27027 L
.72328 .27027 L
.72428 .27027 L
.72527 .27027 L
.72627 .27027 L
.72727 .27027 L
.72827 .27027 L
.72927 .27027 L
.73027 .27027 L
.73127 .27027 L
.73227 .27027 L
.73327 .27027 L
.73427 .27027 L
.73526 .27027 L
.73626 .27027 L
.73726 .27027 L
.73826 .27027 L
.73926 .27027 L
.74026 .27027 L
.74126 .27027 L
.74226 .27027 L
.74326 .27027 L
.74426 .27027 L
.74525 .27027 L
.74625 .27027 L
.74725 .27027 L
.74825 .27027 L
Mistroke
.74925 .27336 L
.75025 .27336 L
.75125 .27336 L
.75225 .27336 L
.75325 .27336 L
.75425 .27336 L
.75524 .27336 L
.75624 .27336 L
.75724 .27336 L
.75824 .27336 L
.75924 .27336 L
.76024 .27336 L
.76124 .27336 L
.76224 .27336 L
.76324 .27336 L
.76424 .27336 L
.76523 .27336 L
.76623 .27336 L
.76723 .27336 L
.76823 .27336 L
.76923 .27336 L
.77023 .27336 L
.77123 .27336 L
.77223 .27336 L
.77323 .27336 L
.77423 .27336 L
.77522 .27336 L
.77622 .27336 L
.77722 .27336 L
.77822 .27336 L
.77922 .27336 L
.78022 .27336 L
.78122 .27336 L
.78222 .27336 L
.78322 .27336 L
.78422 .27336 L
.78521 .27336 L
.78621 .27336 L
.78721 .27336 L
.78821 .27336 L
.78921 .27336 L
.79021 .27336 L
.79121 .27336 L
.79221 .27336 L
.79321 .27336 L
.79421 .27336 L
.7952 .27336 L
.7962 .27336 L
.7972 .27336 L
.7982 .27336 L
Mistroke
.7992 .27508 L
.8002 .27508 L
.8012 .27508 L
.8022 .27508 L
.8032 .27508 L
.8042 .27508 L
.80519 .27508 L
.80619 .27508 L
.80719 .27508 L
.80819 .27508 L
.80919 .27508 L
.81019 .27508 L
.81119 .27508 L
.81219 .27508 L
.81319 .27508 L
.81419 .27508 L
.81518 .27508 L
.81618 .27508 L
.81718 .27508 L
.81818 .27508 L
.81918 .27508 L
.82018 .27508 L
.82118 .27508 L
.82218 .27508 L
.82318 .27508 L
.82418 .27508 L
.82517 .27508 L
.82617 .27508 L
.82717 .27508 L
.82817 .27508 L
.82917 .27508 L
.83017 .27508 L
.83117 .27508 L
.83217 .27508 L
.83317 .27508 L
.83417 .27508 L
.83516 .27508 L
.83616 .27508 L
.83716 .27508 L
.83816 .27508 L
.83916 .27508 L
.84016 .27508 L
.84116 .27508 L
.84216 .27508 L
.84316 .27508 L
.84416 .27508 L
.84515 .27508 L
.84615 .27508 L
.84715 .27508 L
.84815 .27508 L
Mistroke
.84915 .27626 L
.85015 .27626 L
.85115 .27626 L
.85215 .27626 L
.85315 .27626 L
.85415 .27626 L
.85514 .27626 L
.85614 .27626 L
.85714 .27626 L
.85814 .27626 L
.85914 .27626 L
.86014 .27626 L
.86114 .27626 L
.86214 .27626 L
.86314 .27626 L
.86414 .27626 L
.86513 .27626 L
.86613 .27626 L
.86713 .27626 L
.86813 .27626 L
.86913 .27626 L
.87013 .27626 L
.87113 .27626 L
.87213 .27626 L
.87313 .27626 L
.87413 .27626 L
.87512 .27626 L
.87612 .27626 L
.87712 .27626 L
.87812 .27626 L
.87912 .27626 L
.88012 .27626 L
.88112 .27626 L
.88212 .27626 L
.88312 .27626 L
.88412 .27626 L
.88511 .27626 L
.88611 .27626 L
.88711 .27626 L
.88811 .27626 L
.88911 .27626 L
.89011 .27626 L
.89111 .27626 L
.89211 .27626 L
.89311 .27626 L
.89411 .27626 L
.8951 .27626 L
.8961 .27626 L
.8971 .27626 L
.8981 .27626 L
Mistroke
.8991 .26581 L
.9001 .26581 L
.9011 .26581 L
.9021 .26581 L
.9031 .26581 L
.9041 .26581 L
.90509 .26581 L
.90609 .26581 L
.90709 .26581 L
.90809 .26581 L
.90909 .26581 L
.91009 .26581 L
.91109 .26581 L
.91209 .26581 L
.91309 .26581 L
.91409 .26581 L
.91508 .26581 L
.91608 .26581 L
.91708 .26581 L
.91808 .26581 L
.91908 .26581 L
.92008 .26581 L
.92108 .26581 L
.92208 .26581 L
.92308 .26581 L
.92408 .26581 L
.92507 .26581 L
.92607 .26581 L
.92707 .26581 L
.92807 .26581 L
.92907 .26581 L
.93007 .26581 L
.93107 .26581 L
.93207 .26581 L
.93307 .26581 L
.93407 .26581 L
.93506 .26581 L
.93606 .26581 L
.93706 .26581 L
.93806 .26581 L
.93906 .26581 L
.94006 .26581 L
.94106 .26581 L
.94206 .26581 L
.94306 .26581 L
.94406 .26581 L
.94505 .26581 L
.94605 .26581 L
.94705 .26581 L
.94805 .26581 L
Mistroke
.94905 .26187 L
.95005 .26187 L
.95105 .26187 L
.95205 .26187 L
.95305 .26187 L
.95405 .26187 L
.95504 .26187 L
.95604 .26187 L
.95704 .26187 L
.95804 .26187 L
.95904 .26187 L
.96004 .26187 L
.96104 .26187 L
.96204 .26187 L
.96304 .26187 L
.96404 .26187 L
.96503 .26187 L
.96603 .26187 L
.96703 .26187 L
.96803 .26187 L
.96903 .26187 L
.97003 .26187 L
.97103 .26187 L
.97203 .26187 L
.97303 .26187 L
.97403 .26187 L
.97502 .26187 L
.97602 .26187 L
.97702 .26187 L
.97802 .26187 L
.97902 .26187 L
.98002 .26187 L
.98102 .26187 L
.98202 .26187 L
.98302 .26187 L
.98402 .26187 L
.98501 .26187 L
.98601 .26187 L
.98701 .26187 L
.98801 .26187 L
.98901 .26187 L
.99001 .26187 L
.99101 .26187 L
.99201 .26187 L
.99301 .26187 L
.99401 .26187 L
.995 .26187 L
.996 .26187 L
.997 .26187 L
.998 .26187 L
Mistroke
.999 .25638 L
Mfstroke
1 0 0 r
gsave
.999 .20942 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24721 m
.001 .24721 L
.002 .24721 L
.003 .24721 L
.004 .24721 L
.005 .24721 L
.00599 .24721 L
.00699 .24721 L
.00799 .24721 L
.00899 .24721 L
.00999 .24721 L
.01099 .24721 L
.01199 .24721 L
.01299 .24721 L
.01399 .24721 L
.01499 .24721 L
.01598 .24721 L
.01698 .24721 L
.01798 .24721 L
.01898 .24721 L
.01998 .24721 L
.02098 .24721 L
.02198 .24721 L
.02298 .24721 L
.02398 .24721 L
.02498 .24721 L
.02597 .24721 L
.02697 .24721 L
.02797 .24721 L
.02897 .24721 L
.02997 .24721 L
.03097 .24721 L
.03197 .24721 L
.03297 .24721 L
.03397 .24721 L
.03497 .24721 L
.03596 .24721 L
.03696 .24721 L
.03796 .24721 L
.03896 .24721 L
.03996 .24721 L
.04096 .24721 L
.04196 .24721 L
.04296 .24721 L
.04396 .24721 L
.04496 .24721 L
.04595 .24721 L
.04695 .24721 L
.04795 .24721 L
.04895 .24721 L
Mistroke
.04995 .24538 L
.05095 .24538 L
.05195 .24538 L
.05295 .24538 L
.05395 .24538 L
.05495 .24538 L
.05594 .24538 L
.05694 .24538 L
.05794 .24538 L
.05894 .24538 L
.05994 .24538 L
.06094 .24538 L
.06194 .24538 L
.06294 .24538 L
.06394 .24538 L
.06494 .24538 L
.06593 .24538 L
.06693 .24538 L
.06793 .24538 L
.06893 .24538 L
.06993 .24538 L
.07093 .24538 L
.07193 .24538 L
.07293 .24538 L
.07393 .24538 L
.07493 .24538 L
.07592 .24538 L
.07692 .24538 L
.07792 .24538 L
.07892 .24538 L
.07992 .24538 L
.08092 .24538 L
.08192 .24538 L
.08292 .24538 L
.08392 .24538 L
.08492 .24538 L
.08591 .24538 L
.08691 .24538 L
.08791 .24538 L
.08891 .24538 L
.08991 .24538 L
.09091 .24538 L
.09191 .24538 L
.09291 .24538 L
.09391 .24538 L
.09491 .24538 L
.0959 .24538 L
.0969 .24538 L
.0979 .24538 L
.0989 .24538 L
Mistroke
.0999 .24734 L
.1009 .24734 L
.1019 .24734 L
.1029 .24734 L
.1039 .24734 L
.1049 .24734 L
.10589 .24734 L
.10689 .24734 L
.10789 .24734 L
.10889 .24734 L
.10989 .24734 L
.11089 .24734 L
.11189 .24734 L
.11289 .24734 L
.11389 .24734 L
.11489 .24734 L
.11588 .24734 L
.11688 .24734 L
.11788 .24734 L
.11888 .24734 L
.11988 .24734 L
.12088 .24734 L
.12188 .24734 L
.12288 .24734 L
.12388 .24734 L
.12488 .24734 L
.12587 .24734 L
.12687 .24734 L
.12787 .24734 L
.12887 .24734 L
.12987 .24734 L
.13087 .24734 L
.13187 .24734 L
.13287 .24734 L
.13387 .24734 L
.13487 .24734 L
.13586 .24734 L
.13686 .24734 L
.13786 .24734 L
.13886 .24734 L
.13986 .24734 L
.14086 .24734 L
.14186 .24734 L
.14286 .24734 L
.14386 .24734 L
.14486 .24734 L
.14585 .24734 L
.14685 .24734 L
.14785 .24734 L
.14885 .24734 L
Mistroke
.14985 .17472 L
.15085 .17472 L
.15185 .17472 L
.15285 .17472 L
.15385 .17472 L
.15485 .17472 L
.15584 .17472 L
.15684 .17472 L
.15784 .17472 L
.15884 .17472 L
.15984 .17472 L
.16084 .17472 L
.16184 .17472 L
.16284 .17472 L
.16384 .17472 L
.16484 .17472 L
.16583 .17472 L
.16683 .17472 L
.16783 .17472 L
.16883 .17472 L
.16983 .17472 L
.17083 .17472 L
.17183 .17472 L
.17283 .17472 L
.17383 .17472 L
.17483 .17472 L
.17582 .17472 L
.17682 .17472 L
.17782 .17472 L
.17882 .17472 L
.17982 .17472 L
.18082 .17472 L
.18182 .17472 L
.18282 .17472 L
.18382 .17472 L
.18482 .17472 L
.18581 .17472 L
.18681 .17472 L
.18781 .17472 L
.18881 .17472 L
.18981 .17472 L
.19081 .17472 L
.19181 .17472 L
.19281 .17472 L
.19381 .17472 L
.19481 .17472 L
.1958 .17472 L
.1968 .17472 L
.1978 .17472 L
.1988 .17472 L
Mistroke
.1998 .19215 L
.2008 .19215 L
.2018 .19215 L
.2028 .19215 L
.2038 .19215 L
.2048 .19215 L
.20579 .19215 L
.20679 .19215 L
.20779 .19215 L
.20879 .19215 L
.20979 .19215 L
.21079 .19215 L
.21179 .19215 L
.21279 .19215 L
.21379 .19215 L
.21479 .19215 L
.21578 .19215 L
.21678 .19215 L
.21778 .19215 L
.21878 .19215 L
.21978 .19215 L
.22078 .19215 L
.22178 .19215 L
.22278 .19215 L
.22378 .19215 L
.22478 .19215 L
.22577 .19215 L
.22677 .19215 L
.22777 .19215 L
.22877 .19215 L
.22977 .19215 L
.23077 .19215 L
.23177 .19215 L
.23277 .19215 L
.23377 .19215 L
.23477 .19215 L
.23576 .19215 L
.23676 .19215 L
.23776 .19215 L
.23876 .19215 L
.23976 .19215 L
.24076 .19215 L
.24176 .19215 L
.24276 .19215 L
.24376 .19215 L
.24476 .19215 L
.24575 .19215 L
.24675 .19215 L
.24775 .19215 L
.24875 .19215 L
Mistroke
.24975 .22398 L
.25075 .22398 L
.25175 .22398 L
.25275 .22398 L
.25375 .22398 L
.25475 .22398 L
.25574 .22398 L
.25674 .22398 L
.25774 .22398 L
.25874 .22398 L
.25974 .22398 L
.26074 .22398 L
.26174 .22398 L
.26274 .22398 L
.26374 .22398 L
.26474 .22398 L
.26573 .22398 L
.26673 .22398 L
.26773 .22398 L
.26873 .22398 L
.26973 .22398 L
.27073 .22398 L
.27173 .22398 L
.27273 .22398 L
.27373 .22398 L
.27473 .22398 L
.27572 .22398 L
.27672 .22398 L
.27772 .22398 L
.27872 .22398 L
.27972 .22398 L
.28072 .22398 L
.28172 .22398 L
.28272 .22398 L
.28372 .22398 L
.28472 .22398 L
.28571 .22398 L
.28671 .22398 L
.28771 .22398 L
.28871 .22398 L
.28971 .22398 L
.29071 .22398 L
.29171 .22398 L
.29271 .22398 L
.29371 .22398 L
.29471 .22398 L
.2957 .22398 L
.2967 .22398 L
.2977 .22398 L
.2987 .22398 L
Mistroke
.2997 .22436 L
.3007 .22436 L
.3017 .22436 L
.3027 .22436 L
.3037 .22436 L
.3047 .22436 L
.30569 .22436 L
.30669 .22436 L
.30769 .22436 L
.30869 .22436 L
.30969 .22436 L
.31069 .22436 L
.31169 .22436 L
.31269 .22436 L
.31369 .22436 L
.31469 .22436 L
.31568 .22436 L
.31668 .22436 L
.31768 .22436 L
.31868 .22436 L
.31968 .22436 L
.32068 .22436 L
.32168 .22436 L
.32268 .22436 L
.32368 .22436 L
.32468 .22436 L
.32567 .22436 L
.32667 .22436 L
.32767 .22436 L
.32867 .22436 L
.32967 .22436 L
.33067 .22436 L
.33167 .22436 L
.33267 .22436 L
.33367 .22436 L
.33467 .22436 L
.33566 .22436 L
.33666 .22436 L
.33766 .22436 L
.33866 .22436 L
.33966 .22436 L
.34066 .22436 L
.34166 .22436 L
.34266 .22436 L
.34366 .22436 L
.34466 .22436 L
.34565 .22436 L
.34665 .22436 L
.34765 .22436 L
.34865 .22436 L
Mistroke
.34965 .20929 L
.35065 .20929 L
.35165 .20929 L
.35265 .20929 L
.35365 .20929 L
.35465 .20929 L
.35564 .20929 L
.35664 .20929 L
.35764 .20929 L
.35864 .20929 L
.35964 .20929 L
.36064 .20929 L
.36164 .20929 L
.36264 .20929 L
.36364 .20929 L
.36464 .20929 L
.36563 .20929 L
.36663 .20929 L
.36763 .20929 L
.36863 .20929 L
.36963 .20929 L
.37063 .20929 L
.37163 .20929 L
.37263 .20929 L
.37363 .20929 L
.37463 .20929 L
.37562 .20929 L
.37662 .20929 L
.37762 .20929 L
.37862 .20929 L
.37962 .20929 L
.38062 .20929 L
.38162 .20929 L
.38262 .20929 L
.38362 .20929 L
.38462 .20929 L
.38561 .20929 L
.38661 .20929 L
.38761 .20929 L
.38861 .20929 L
.38961 .20929 L
.39061 .20929 L
.39161 .20929 L
.39261 .20929 L
.39361 .20929 L
.39461 .20929 L
.3956 .20929 L
.3966 .20929 L
.3976 .20929 L
.3986 .20929 L
Mistroke
.3996 .21025 L
.4006 .21025 L
.4016 .21025 L
.4026 .21025 L
.4036 .21025 L
.4046 .21025 L
.40559 .21025 L
.40659 .21025 L
.40759 .21025 L
.40859 .21025 L
.40959 .21025 L
.41059 .21025 L
.41159 .21025 L
.41259 .21025 L
.41359 .21025 L
.41459 .21025 L
.41558 .21025 L
.41658 .21025 L
.41758 .21025 L
.41858 .21025 L
.41958 .21025 L
.42058 .21025 L
.42158 .21025 L
.42258 .21025 L
.42358 .21025 L
.42458 .21025 L
.42557 .21025 L
.42657 .21025 L
.42757 .21025 L
.42857 .21025 L
.42957 .21025 L
.43057 .21025 L
.43157 .21025 L
.43257 .21025 L
.43357 .21025 L
.43457 .21025 L
.43556 .21025 L
.43656 .21025 L
.43756 .21025 L
.43856 .21025 L
.43956 .21025 L
.44056 .21025 L
.44156 .21025 L
.44256 .21025 L
.44356 .21025 L
.44456 .21025 L
.44555 .21025 L
.44655 .21025 L
.44755 .21025 L
.44855 .21025 L
Mistroke
.44955 .21444 L
.45055 .21444 L
.45155 .21444 L
.45255 .21444 L
.45355 .21444 L
.45455 .21444 L
.45554 .21444 L
.45654 .21444 L
.45754 .21444 L
.45854 .21444 L
.45954 .21444 L
.46054 .21444 L
.46154 .21444 L
.46254 .21444 L
.46354 .21444 L
.46454 .21444 L
.46553 .21444 L
.46653 .21444 L
.46753 .21444 L
.46853 .21444 L
.46953 .21444 L
.47053 .21444 L
.47153 .21444 L
.47253 .21444 L
.47353 .21444 L
.47453 .21444 L
.47552 .21444 L
.47652 .21444 L
.47752 .21444 L
.47852 .21444 L
.47952 .21444 L
.48052 .21444 L
.48152 .21444 L
.48252 .21444 L
.48352 .21444 L
.48452 .21444 L
.48551 .21444 L
.48651 .21444 L
.48751 .21444 L
.48851 .21444 L
.48951 .21444 L
.49051 .21444 L
.49151 .21444 L
.49251 .21444 L
.49351 .21444 L
.49451 .21444 L
.4955 .21444 L
.4965 .21444 L
.4975 .21444 L
.4985 .21444 L
Mistroke
.4995 .22029 L
.5005 .22029 L
.5015 .22029 L
.5025 .22029 L
.5035 .22029 L
.5045 .22029 L
.50549 .22029 L
.50649 .22029 L
.50749 .22029 L
.50849 .22029 L
.50949 .22029 L
.51049 .22029 L
.51149 .22029 L
.51249 .22029 L
.51349 .22029 L
.51449 .22029 L
.51548 .22029 L
.51648 .22029 L
.51748 .22029 L
.51848 .22029 L
.51948 .22029 L
.52048 .22029 L
.52148 .22029 L
.52248 .22029 L
.52348 .22029 L
.52448 .22029 L
.52547 .22029 L
.52647 .22029 L
.52747 .22029 L
.52847 .22029 L
.52947 .22029 L
.53047 .22029 L
.53147 .22029 L
.53247 .22029 L
.53347 .22029 L
.53447 .22029 L
.53546 .22029 L
.53646 .22029 L
.53746 .22029 L
.53846 .22029 L
.53946 .22029 L
.54046 .22029 L
.54146 .22029 L
.54246 .22029 L
.54346 .22029 L
.54446 .22029 L
.54545 .22029 L
.54645 .22029 L
.54745 .22029 L
.54845 .22029 L
Mistroke
.54945 .22964 L
.55045 .22964 L
.55145 .22964 L
.55245 .22964 L
.55345 .22964 L
.55445 .22964 L
.55544 .22964 L
.55644 .22964 L
.55744 .22964 L
.55844 .22964 L
.55944 .22964 L
.56044 .22964 L
.56144 .22964 L
.56244 .22964 L
.56344 .22964 L
.56444 .22964 L
.56543 .22964 L
.56643 .22964 L
.56743 .22964 L
.56843 .22964 L
.56943 .22964 L
.57043 .22964 L
.57143 .22964 L
.57243 .22964 L
.57343 .22964 L
.57443 .22964 L
.57542 .22964 L
.57642 .22964 L
.57742 .22964 L
.57842 .22964 L
.57942 .22964 L
.58042 .22964 L
.58142 .22964 L
.58242 .22964 L
.58342 .22964 L
.58442 .22964 L
.58541 .22964 L
.58641 .22964 L
.58741 .22964 L
.58841 .22964 L
.58941 .22964 L
.59041 .22964 L
.59141 .22964 L
.59241 .22964 L
.59341 .22964 L
.59441 .22964 L
.5954 .22964 L
.5964 .22964 L
.5974 .22964 L
.5984 .22964 L
Mistroke
.5994 .22523 L
.6004 .22523 L
.6014 .22523 L
.6024 .22523 L
.6034 .22523 L
.6044 .22523 L
.60539 .22523 L
.60639 .22523 L
.60739 .22523 L
.60839 .22523 L
.60939 .22523 L
.61039 .22523 L
.61139 .22523 L
.61239 .22523 L
.61339 .22523 L
.61439 .22523 L
.61538 .22523 L
.61638 .22523 L
.61738 .22523 L
.61838 .22523 L
.61938 .22523 L
.62038 .22523 L
.62138 .22523 L
.62238 .22523 L
.62338 .22523 L
.62438 .22523 L
.62537 .22523 L
.62637 .22523 L
.62737 .22523 L
.62837 .22523 L
.62937 .22523 L
.63037 .22523 L
.63137 .22523 L
.63237 .22523 L
.63337 .22523 L
.63437 .22523 L
.63536 .22523 L
.63636 .22523 L
.63736 .22523 L
.63836 .22523 L
.63936 .22523 L
.64036 .22523 L
.64136 .22523 L
.64236 .22523 L
.64336 .22523 L
.64436 .22523 L
.64535 .22523 L
.64635 .22523 L
.64735 .22523 L
.64835 .22523 L
Mistroke
.64935 .21495 L
.65035 .21495 L
.65135 .21495 L
.65235 .21495 L
.65335 .21495 L
.65435 .21495 L
.65534 .21495 L
.65634 .21495 L
.65734 .21495 L
.65834 .21495 L
.65934 .21495 L
.66034 .21495 L
.66134 .21495 L
.66234 .21495 L
.66334 .21495 L
.66434 .21495 L
.66533 .21495 L
.66633 .21495 L
.66733 .21495 L
.66833 .21495 L
.66933 .21495 L
.67033 .21495 L
.67133 .21495 L
.67233 .21495 L
.67333 .21495 L
.67433 .21495 L
.67532 .21495 L
.67632 .21495 L
.67732 .21495 L
.67832 .21495 L
.67932 .21495 L
.68032 .21495 L
.68132 .21495 L
.68232 .21495 L
.68332 .21495 L
.68432 .21495 L
.68531 .21495 L
.68631 .21495 L
.68731 .21495 L
.68831 .21495 L
.68931 .21495 L
.69031 .21495 L
.69131 .21495 L
.69231 .21495 L
.69331 .21495 L
.69431 .21495 L
.6953 .21495 L
.6963 .21495 L
.6973 .21495 L
.6983 .21495 L
Mistroke
.6993 .21747 L
.7003 .21747 L
.7013 .21747 L
.7023 .21747 L
.7033 .21747 L
.7043 .21747 L
.70529 .21747 L
.70629 .21747 L
.70729 .21747 L
.70829 .21747 L
.70929 .21747 L
.71029 .21747 L
.71129 .21747 L
.71229 .21747 L
.71329 .21747 L
.71429 .21747 L
.71528 .21747 L
.71628 .21747 L
.71728 .21747 L
.71828 .21747 L
.71928 .21747 L
.72028 .21747 L
.72128 .21747 L
.72228 .21747 L
.72328 .21747 L
.72428 .21747 L
.72527 .21747 L
.72627 .21747 L
.72727 .21747 L
.72827 .21747 L
.72927 .21747 L
.73027 .21747 L
.73127 .21747 L
.73227 .21747 L
.73327 .21747 L
.73427 .21747 L
.73526 .21747 L
.73626 .21747 L
.73726 .21747 L
.73826 .21747 L
.73926 .21747 L
.74026 .21747 L
.74126 .21747 L
.74226 .21747 L
.74326 .21747 L
.74426 .21747 L
.74525 .21747 L
.74625 .21747 L
.74725 .21747 L
.74825 .21747 L
Mistroke
.74925 .22121 L
.75025 .22121 L
.75125 .22121 L
.75225 .22121 L
.75325 .22121 L
.75425 .22121 L
.75524 .22121 L
.75624 .22121 L
.75724 .22121 L
.75824 .22121 L
.75924 .22121 L
.76024 .22121 L
.76124 .22121 L
.76224 .22121 L
.76324 .22121 L
.76424 .22121 L
.76523 .22121 L
.76623 .22121 L
.76723 .22121 L
.76823 .22121 L
.76923 .22121 L
.77023 .22121 L
.77123 .22121 L
.77223 .22121 L
.77323 .22121 L
.77423 .22121 L
.77522 .22121 L
.77622 .22121 L
.77722 .22121 L
.77822 .22121 L
.77922 .22121 L
.78022 .22121 L
.78122 .22121 L
.78222 .22121 L
.78322 .22121 L
.78422 .22121 L
.78521 .22121 L
.78621 .22121 L
.78721 .22121 L
.78821 .22121 L
.78921 .22121 L
.79021 .22121 L
.79121 .22121 L
.79221 .22121 L
.79321 .22121 L
.79421 .22121 L
.7952 .22121 L
.7962 .22121 L
.7972 .22121 L
.7982 .22121 L
Mistroke
.7992 .22438 L
.8002 .22438 L
.8012 .22438 L
.8022 .22438 L
.8032 .22438 L
.8042 .22438 L
.80519 .22438 L
.80619 .22438 L
.80719 .22438 L
.80819 .22438 L
.80919 .22438 L
.81019 .22438 L
.81119 .22438 L
.81219 .22438 L
.81319 .22438 L
.81419 .22438 L
.81518 .22438 L
.81618 .22438 L
.81718 .22438 L
.81818 .22438 L
.81918 .22438 L
.82018 .22438 L
.82118 .22438 L
.82218 .22438 L
.82318 .22438 L
.82418 .22438 L
.82517 .22438 L
.82617 .22438 L
.82717 .22438 L
.82817 .22438 L
.82917 .22438 L
.83017 .22438 L
.83117 .22438 L
.83217 .22438 L
.83317 .22438 L
.83417 .22438 L
.83516 .22438 L
.83616 .22438 L
.83716 .22438 L
.83816 .22438 L
.83916 .22438 L
.84016 .22438 L
.84116 .22438 L
.84216 .22438 L
.84316 .22438 L
.84416 .22438 L
.84515 .22438 L
.84615 .22438 L
.84715 .22438 L
.84815 .22438 L
Mistroke
.84915 .22651 L
.85015 .22651 L
.85115 .22651 L
.85215 .22651 L
.85315 .22651 L
.85415 .22651 L
.85514 .22651 L
.85614 .22651 L
.85714 .22651 L
.85814 .22651 L
.85914 .22651 L
.86014 .22651 L
.86114 .22651 L
.86214 .22651 L
.86314 .22651 L
.86414 .22651 L
.86513 .22651 L
.86613 .22651 L
.86713 .22651 L
.86813 .22651 L
.86913 .22651 L
.87013 .22651 L
.87113 .22651 L
.87213 .22651 L
.87313 .22651 L
.87413 .22651 L
.87512 .22651 L
.87612 .22651 L
.87712 .22651 L
.87812 .22651 L
.87912 .22651 L
.88012 .22651 L
.88112 .22651 L
.88212 .22651 L
.88312 .22651 L
.88412 .22651 L
.88511 .22651 L
.88611 .22651 L
.88711 .22651 L
.88811 .22651 L
.88911 .22651 L
.89011 .22651 L
.89111 .22651 L
.89211 .22651 L
.89311 .22651 L
.89411 .22651 L
.8951 .22651 L
.8961 .22651 L
.8971 .22651 L
.8981 .22651 L
Mistroke
.8991 .21717 L
.9001 .21717 L
.9011 .21717 L
.9021 .21717 L
.9031 .21717 L
.9041 .21717 L
.90509 .21717 L
.90609 .21717 L
.90709 .21717 L
.90809 .21717 L
.90909 .21717 L
.91009 .21717 L
.91109 .21717 L
.91209 .21717 L
.91309 .21717 L
.91409 .21717 L
.91508 .21717 L
.91608 .21717 L
.91708 .21717 L
.91808 .21717 L
.91908 .21717 L
.92008 .21717 L
.92108 .21717 L
.92208 .21717 L
.92308 .21717 L
.92408 .21717 L
.92507 .21717 L
.92607 .21717 L
.92707 .21717 L
.92807 .21717 L
.92907 .21717 L
.93007 .21717 L
.93107 .21717 L
.93207 .21717 L
.93307 .21717 L
.93407 .21717 L
.93506 .21717 L
.93606 .21717 L
.93706 .21717 L
.93806 .21717 L
.93906 .21717 L
.94006 .21717 L
.94106 .21717 L
.94206 .21717 L
.94306 .21717 L
.94406 .21717 L
.94505 .21717 L
.94605 .21717 L
.94705 .21717 L
.94805 .21717 L
Mistroke
.94905 .21393 L
.95005 .21393 L
.95105 .21393 L
.95205 .21393 L
.95305 .21393 L
.95405 .21393 L
.95504 .21393 L
.95604 .21393 L
.95704 .21393 L
.95804 .21393 L
.95904 .21393 L
.96004 .21393 L
.96104 .21393 L
.96204 .21393 L
.96304 .21393 L
.96404 .21393 L
.96503 .21393 L
.96603 .21393 L
.96703 .21393 L
.96803 .21393 L
.96903 .21393 L
.97003 .21393 L
.97103 .21393 L
.97203 .21393 L
.97303 .21393 L
.97403 .21393 L
.97502 .21393 L
.97602 .21393 L
.97702 .21393 L
.97802 .21393 L
.97902 .21393 L
.98002 .21393 L
.98102 .21393 L
.98202 .21393 L
.98302 .21393 L
.98402 .21393 L
.98501 .21393 L
.98601 .21393 L
.98701 .21393 L
.98801 .21393 L
.98901 .21393 L
.99001 .21393 L
.99101 .21393 L
.99201 .21393 L
.99301 .21393 L
.99401 .21393 L
.995 .21393 L
.996 .21393 L
.997 .21393 L
.998 .21393 L
Mistroke
.999 .20942 L
Mfstroke
0 0 1 r
gsave
.001 -1.8541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0772542 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -6 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -6 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -6 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -6 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -6 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(1)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(2)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(3)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(4)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(6)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(7)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .20601 m
.001 .20601 L
.002 .20601 L
.003 .20601 L
.004 .20601 L
.005 .20601 L
.00599 .20601 L
.00699 .20601 L
.00799 .20601 L
.00899 .20601 L
.00999 .20601 L
.01099 .20601 L
.01199 .20601 L
.01299 .20601 L
.01399 .20601 L
.01499 .20601 L
.01598 .20601 L
.01698 .20601 L
.01798 .20602 L
.01898 .20602 L
.01998 .20602 L
.02098 .20602 L
.02198 .20602 L
.02298 .20602 L
.02398 .20602 L
.02498 .20602 L
.02597 .20602 L
.02697 .20602 L
.02797 .20602 L
.02897 .20602 L
.02997 .20602 L
.03097 .20602 L
.03197 .20602 L
.03297 .20602 L
.03397 .20602 L
.03497 .20602 L
.03596 .20602 L
.03696 .20602 L
.03796 .20602 L
.03896 .20602 L
.03996 .20602 L
.04096 .20602 L
.04196 .20602 L
.04296 .20602 L
.04396 .20602 L
.04496 .20602 L
.04595 .20602 L
.04695 .20602 L
.04795 .20602 L
.04895 .20602 L
Mistroke
.04995 .20602 L
.05095 .20602 L
.05195 .20602 L
.05295 .20602 L
.05395 .20601 L
.05495 .20602 L
.05594 .20602 L
.05694 .20602 L
.05794 .20602 L
.05894 .20602 L
.05994 .20602 L
.06094 .20601 L
.06194 .20602 L
.06294 .20602 L
.06394 .20602 L
.06494 .20602 L
.06593 .20602 L
.06693 .20602 L
.06793 .20602 L
.06893 .20602 L
.06993 .20602 L
.07093 .20602 L
.07193 .20602 L
.07293 .20602 L
.07393 .20602 L
.07493 .20602 L
.07592 .20602 L
.07692 .20602 L
.07792 .20602 L
.07892 .20602 L
.07992 .20602 L
.08092 .20602 L
.08192 .20602 L
.08292 .20602 L
.08392 .20602 L
.08492 .20602 L
.08591 .20602 L
.08691 .20602 L
.08791 .20602 L
.08891 .20602 L
.08991 .20602 L
.09091 .20602 L
.09191 .20602 L
.09291 .20602 L
.09391 .20602 L
.09491 .20602 L
.0959 .20602 L
.0969 .20603 L
.0979 .20602 L
.0989 .20602 L
Mistroke
.0999 .20602 L
.1009 .20603 L
.1019 .20603 L
.1029 .20603 L
.1039 .20603 L
.1049 .20602 L
.10589 .20603 L
.10689 .20603 L
.10789 .20603 L
.10889 .20603 L
.10989 .20602 L
.11089 .20602 L
.11189 .20603 L
.11289 .20602 L
.11389 .20602 L
.11489 .20602 L
.11588 .20602 L
.11688 .20602 L
.11788 .20602 L
.11888 .20602 L
.11988 .20602 L
.12088 .20602 L
.12188 .20602 L
.12288 .20603 L
.12388 .20602 L
.12488 .20602 L
.12587 .20602 L
.12687 .20602 L
.12787 .20602 L
.12887 .20602 L
.12987 .20602 L
.13087 .20602 L
.13187 .20602 L
.13287 .20602 L
.13387 .20602 L
.13487 .20602 L
.13586 .20603 L
.13686 .20603 L
.13786 .20603 L
.13886 .20603 L
.13986 .20603 L
.14086 .20603 L
.14186 .20603 L
.14286 .20603 L
.14386 .20602 L
.14486 .20602 L
.14585 .20602 L
.14685 .20602 L
.14785 .20602 L
.14885 .20602 L
Mistroke
.14985 .20602 L
.15085 .20602 L
.15185 .20603 L
.15285 .20603 L
.15385 .20603 L
.15485 .20603 L
.15584 .20602 L
.15684 .20602 L
.15784 .20602 L
.15884 .20602 L
.15984 .20602 L
.16084 .20602 L
.16184 .20602 L
.16284 .20602 L
.16384 .20602 L
.16484 .20602 L
.16583 .20602 L
.16683 .20602 L
.16783 .20602 L
.16883 .20602 L
.16983 .20602 L
.17083 .20602 L
.17183 .20602 L
.17283 .20602 L
.17383 .20602 L
.17483 .20602 L
.17582 .20602 L
.17682 .20602 L
.17782 .20602 L
.17882 .20602 L
.17982 .20602 L
.18082 .20602 L
.18182 .20602 L
.18282 .20602 L
.18382 .20602 L
.18482 .20602 L
.18581 .20602 L
.18681 .20603 L
.18781 .20602 L
.18881 .20602 L
.18981 .20603 L
.19081 .20603 L
.19181 .20603 L
.19281 .20603 L
.19381 .20603 L
.19481 .20603 L
.1958 .20603 L
.1968 .20603 L
.1978 .20603 L
.1988 .20603 L
Mistroke
.1998 .20603 L
.2008 .20603 L
.2018 .20603 L
.2028 .20603 L
.2038 .20603 L
.2048 .20603 L
.20579 .20603 L
.20679 .20603 L
.20779 .20603 L
.20879 .20603 L
.20979 .20603 L
.21079 .20603 L
.21179 .20603 L
.21279 .20603 L
.21379 .20603 L
.21479 .20603 L
.21578 .20603 L
.21678 .20603 L
.21778 .20603 L
.21878 .20603 L
.21978 .20603 L
.22078 .20603 L
.22178 .20603 L
.22278 .20603 L
.22378 .20603 L
.22478 .20603 L
.22577 .20603 L
.22677 .20603 L
.22777 .20603 L
.22877 .20603 L
.22977 .20603 L
.23077 .20603 L
.23177 .20603 L
.23277 .20603 L
.23377 .20603 L
.23477 .20603 L
.23576 .20603 L
.23676 .20603 L
.23776 .20603 L
.23876 .20603 L
.23976 .20602 L
.24076 .20602 L
.24176 .20602 L
.24276 .20602 L
.24376 .20602 L
.24476 .20603 L
.24575 .20603 L
.24675 .20603 L
.24775 .20603 L
.24875 .20603 L
Mistroke
.24975 .20603 L
.25075 .20603 L
.25175 .20603 L
.25275 .20603 L
.25375 .20603 L
.25475 .20603 L
.25574 .20603 L
.25674 .20603 L
.25774 .20603 L
.25874 .20602 L
.25974 .20603 L
.26074 .20602 L
.26174 .20602 L
.26274 .20602 L
.26374 .20603 L
.26474 .20603 L
.26573 .20603 L
.26673 .20603 L
.26773 .20603 L
.26873 .20603 L
.26973 .20603 L
.27073 .20603 L
.27173 .20603 L
.27273 .20603 L
.27373 .20603 L
.27473 .20603 L
.27572 .20602 L
.27672 .20602 L
.27772 .20602 L
.27872 .20602 L
.27972 .20602 L
.28072 .20602 L
.28172 .20602 L
.28272 .20602 L
.28372 .20602 L
.28472 .20602 L
.28571 .20603 L
.28671 .20603 L
.28771 .20603 L
.28871 .20603 L
.28971 .20603 L
.29071 .20603 L
.29171 .20603 L
.29271 .20603 L
.29371 .20603 L
.29471 .20603 L
.2957 .20603 L
.2967 .20603 L
.2977 .20603 L
.2987 .20603 L
Mistroke
.2997 .20603 L
.3007 .20603 L
.3017 .20603 L
.3027 .20603 L
.3037 .20603 L
.3047 .20603 L
.30569 .20603 L
.30669 .20603 L
.30769 .20603 L
.30869 .20603 L
.30969 .20603 L
.31069 .20603 L
.31169 .20603 L
.31269 .20603 L
.31369 .20603 L
.31469 .20603 L
.31568 .20603 L
.31668 .20603 L
.31768 .20603 L
.31868 .20603 L
.31968 .20603 L
.32068 .20603 L
.32168 .20603 L
.32268 .20603 L
.32368 .20603 L
.32468 .20603 L
.32567 .20603 L
.32667 .20603 L
.32767 .20603 L
.32867 .20603 L
.32967 .20603 L
.33067 .20603 L
.33167 .20603 L
.33267 .20603 L
.33367 .20603 L
.33467 .20603 L
.33566 .20603 L
.33666 .20603 L
.33766 .20603 L
.33866 .20603 L
.33966 .20603 L
.34066 .20603 L
.34166 .20603 L
.34266 .20604 L
.34366 .20603 L
.34466 .20603 L
.34565 .20604 L
.34665 .20603 L
.34765 .20604 L
.34865 .20604 L
Mistroke
.34965 .20603 L
.35065 .20603 L
.35165 .20603 L
.35265 .20604 L
.35365 .20603 L
.35465 .20603 L
.35564 .20603 L
.35664 .20603 L
.35764 .20603 L
.35864 .20603 L
.35964 .20603 L
.36064 .20604 L
.36164 .20604 L
.36264 .20604 L
.36364 .20604 L
.36464 .20604 L
.36563 .20604 L
.36663 .20604 L
.36763 .20604 L
.36863 .20604 L
.36963 .20604 L
.37063 .20604 L
.37163 .20604 L
.37263 .20604 L
.37363 .20604 L
.37463 .20604 L
.37562 .20604 L
.37662 .20604 L
.37762 .20604 L
.37862 .20604 L
.37962 .20604 L
.38062 .20604 L
.38162 .20604 L
.38262 .20604 L
.38362 .20604 L
.38462 .20604 L
.38561 .20603 L
.38661 .20604 L
.38761 .20604 L
.38861 .20604 L
.38961 .20604 L
.39061 .20604 L
.39161 .20604 L
.39261 .20604 L
.39361 .20604 L
.39461 .20604 L
.3956 .20604 L
.3966 .20604 L
.3976 .20604 L
.3986 .20604 L
Mistroke
.3996 .20604 L
.4006 .20604 L
.4016 .20604 L
.4026 .20604 L
.4036 .20604 L
.4046 .20604 L
.40559 .20604 L
.40659 .20604 L
.40759 .20604 L
.40859 .20604 L
.40959 .20604 L
.41059 .20604 L
.41159 .20604 L
.41259 .20604 L
.41359 .20604 L
.41459 .20604 L
.41558 .20604 L
.41658 .20604 L
.41758 .20604 L
.41858 .20604 L
.41958 .20604 L
.42058 .20604 L
.42158 .20604 L
.42258 .20604 L
.42358 .20604 L
.42458 .20604 L
.42557 .20604 L
.42657 .20604 L
.42757 .20604 L
.42857 .20604 L
.42957 .20604 L
.43057 .20604 L
.43157 .20604 L
.43257 .20604 L
.43357 .20604 L
.43457 .20604 L
.43556 .20604 L
.43656 .20604 L
.43756 .20604 L
.43856 .20604 L
.43956 .20604 L
.44056 .20604 L
.44156 .20604 L
.44256 .20604 L
.44356 .20604 L
.44456 .20604 L
.44555 .20604 L
.44655 .20604 L
.44755 .20604 L
.44855 .20604 L
Mistroke
.44955 .20604 L
.45055 .20604 L
.45155 .20604 L
.45255 .20604 L
.45355 .20604 L
.45455 .20604 L
.45554 .20604 L
.45654 .20603 L
.45754 .20604 L
.45854 .20604 L
.45954 .20604 L
.46054 .20604 L
.46154 .20604 L
.46254 .20604 L
.46354 .20604 L
.46454 .20604 L
.46553 .20604 L
.46653 .20604 L
.46753 .20604 L
.46853 .20604 L
.46953 .20604 L
.47053 .20604 L
.47153 .20604 L
.47253 .20604 L
.47353 .20604 L
.47453 .20604 L
.47552 .20604 L
.47652 .20604 L
.47752 .20604 L
.47852 .20604 L
.47952 .20604 L
.48052 .20604 L
.48152 .20604 L
.48252 .20604 L
.48352 .20604 L
.48452 .20605 L
.48551 .20604 L
.48651 .20604 L
.48751 .20604 L
.48851 .20604 L
.48951 .20604 L
.49051 .20604 L
.49151 .20605 L
.49251 .20604 L
.49351 .20605 L
.49451 .20605 L
.4955 .20605 L
.4965 .20605 L
.4975 .20604 L
.4985 .20604 L
Mistroke
.4995 .20604 L
.5005 .20604 L
.5015 .20604 L
.5025 .20604 L
.5035 .20604 L
.5045 .20604 L
.50549 .20604 L
.50649 .20604 L
.50749 .20604 L
.50849 .20604 L
.50949 .20604 L
.51049 .20604 L
.51149 .20604 L
.51249 .20604 L
.51349 .20604 L
.51449 .20604 L
.51548 .20604 L
.51648 .20604 L
.51748 .20604 L
.51848 .20604 L
.51948 .20604 L
.52048 .20604 L
.52148 .20604 L
.52248 .20604 L
.52348 .20604 L
.52448 .20604 L
.52547 .20604 L
.52647 .20604 L
.52747 .20604 L
.52847 .20604 L
.52947 .20604 L
.53047 .20605 L
.53147 .20605 L
.53247 .20605 L
.53347 .20605 L
.53447 .20605 L
.53546 .20605 L
.53646 .20605 L
.53746 .20605 L
.53846 .20605 L
.53946 .20604 L
.54046 .20604 L
.54146 .20604 L
.54246 .20604 L
.54346 .20604 L
.54446 .20604 L
.54545 .20604 L
.54645 .20604 L
.54745 .20604 L
.54845 .20604 L
Mistroke
.54945 .20604 L
.55045 .20604 L
.55145 .20604 L
.55245 .20604 L
.55345 .20604 L
.55445 .20604 L
.55544 .20605 L
.55644 .20605 L
.55744 .20604 L
.55844 .20605 L
.55944 .20605 L
.56044 .20605 L
.56144 .20605 L
.56244 .20604 L
.56344 .20604 L
.56444 .20604 L
.56543 .20604 L
.56643 .20604 L
.56743 .20604 L
.56843 .20604 L
.56943 .20604 L
.57043 .20604 L
.57143 .20605 L
.57243 .20605 L
.57343 .20605 L
.57443 .20605 L
.57542 .20605 L
.57642 .20605 L
.57742 .20605 L
.57842 .20605 L
.57942 .20605 L
.58042 .20605 L
.58142 .20605 L
.58242 .20605 L
.58342 .20605 L
.58442 .20604 L
.58541 .20604 L
.58641 .20604 L
.58741 .20605 L
.58841 .20604 L
.58941 .20605 L
.59041 .20605 L
.59141 .20605 L
.59241 .20605 L
.59341 .20605 L
.59441 .20605 L
.5954 .20604 L
.5964 .20604 L
.5974 .20604 L
.5984 .20604 L
Mistroke
.5994 .20605 L
.6004 .20605 L
.6014 .20605 L
.6024 .20605 L
.6034 .20605 L
.6044 .20605 L
.60539 .20605 L
.60639 .20605 L
.60739 .20605 L
.60839 .20605 L
.60939 .20605 L
.61039 .20604 L
.61139 .20604 L
.61239 .20604 L
.61339 .20604 L
.61439 .20604 L
.61538 .20604 L
.61638 .20604 L
.61738 .20604 L
.61838 .20604 L
.61938 .20604 L
.62038 .20604 L
.62138 .20604 L
.62238 .20604 L
.62338 .20604 L
.62438 .20604 L
.62537 .20604 L
.62637 .20604 L
.62737 .20604 L
.62837 .20604 L
.62937 .20604 L
.63037 .20605 L
.63137 .20605 L
.63237 .20605 L
.63337 .20605 L
.63437 .20605 L
.63536 .20605 L
.63636 .20605 L
.63736 .20605 L
.63836 .20605 L
.63936 .20605 L
.64036 .20605 L
.64136 .20605 L
.64236 .20605 L
.64336 .20605 L
.64436 .20605 L
.64535 .20605 L
.64635 .20605 L
.64735 .20605 L
.64835 .20605 L
Mistroke
.64935 .20605 L
.65035 .20605 L
.65135 .20605 L
.65235 .20605 L
.65335 .20605 L
.65435 .20605 L
.65534 .20605 L
.65634 .20605 L
.65734 .20605 L
.65834 .20605 L
.65934 .20605 L
.66034 .20605 L
.66134 .20605 L
.66234 .20605 L
.66334 .20605 L
.66434 .20605 L
.66533 .20605 L
.66633 .20605 L
.66733 .20605 L
.66833 .20605 L
.66933 .20605 L
.67033 .20605 L
.67133 .20605 L
.67233 .20605 L
.67333 .20605 L
.67433 .20605 L
.67532 .20605 L
.67632 .20605 L
.67732 .20605 L
.67832 .20605 L
.67932 .20605 L
.68032 .20605 L
.68132 .20605 L
.68232 .20605 L
.68332 .20605 L
.68432 .20605 L
.68531 .20605 L
.68631 .20605 L
.68731 .20605 L
.68831 .20605 L
.68931 .20605 L
.69031 .20605 L
.69131 .20605 L
.69231 .20605 L
.69331 .20605 L
.69431 .20605 L
.6953 .20605 L
.6963 .20605 L
.6973 .20605 L
.6983 .20605 L
Mistroke
.6993 .20605 L
.7003 .20605 L
.7013 .20605 L
.7023 .20605 L
.7033 .20605 L
.7043 .20605 L
.70529 .20605 L
.70629 .20605 L
.70729 .20605 L
.70829 .20605 L
.70929 .20605 L
.71029 .20605 L
.71129 .20605 L
.71229 .20605 L
.71329 .20605 L
.71429 .20605 L
.71528 .20605 L
.71628 .20605 L
.71728 .20604 L
.71828 .20604 L
.71928 .20604 L
.72028 .20604 L
.72128 .20605 L
.72228 .20605 L
.72328 .20605 L
.72428 .20605 L
.72527 .20605 L
.72627 .20605 L
.72727 .20605 L
.72827 .20605 L
.72927 .20605 L
.73027 .20605 L
.73127 .20605 L
.73227 .20605 L
.73327 .20605 L
.73427 .20605 L
.73526 .20605 L
.73626 .20605 L
.73726 .20605 L
.73826 .20605 L
.73926 .20605 L
.74026 .20605 L
.74126 .20605 L
.74226 .20605 L
.74326 .20605 L
.74426 .20605 L
.74525 .20605 L
.74625 .20605 L
.74725 .20605 L
.74825 .20605 L
Mistroke
.74925 .20605 L
.75025 .20605 L
.75125 .20605 L
.75225 .20605 L
.75325 .20605 L
.75425 .20606 L
.75524 .20606 L
.75624 .20606 L
.75724 .20606 L
.75824 .20606 L
.75924 .20605 L
.76024 .20605 L
.76124 .20605 L
.76224 .20605 L
.76324 .20606 L
.76424 .20606 L
.76523 .20606 L
.76623 .20606 L
.76723 .20606 L
.76823 .20606 L
.76923 .20606 L
.77023 .20606 L
.77123 .20606 L
.77223 .20606 L
.77323 .20606 L
.77423 .20606 L
.77522 .20606 L
.77622 .20606 L
.77722 .20606 L
.77822 .20606 L
.77922 .20606 L
.78022 .20606 L
.78122 .20606 L
.78222 .20606 L
.78322 .20606 L
.78422 .20606 L
.78521 .20606 L
.78621 .20606 L
.78721 .20606 L
.78821 .20606 L
.78921 .20606 L
.79021 .20606 L
.79121 .20606 L
.79221 .20606 L
.79321 .20606 L
.79421 .20606 L
.7952 .20606 L
.7962 .20606 L
.7972 .20606 L
.7982 .20606 L
Mistroke
.7992 .20606 L
.8002 .20606 L
.8012 .20607 L
.8022 .20606 L
.8032 .20607 L
.8042 .20607 L
.80519 .20606 L
.80619 .20606 L
.80719 .20606 L
.80819 .20606 L
.80919 .20606 L
.81019 .20606 L
.81119 .20607 L
.81219 .20607 L
.81319 .20607 L
.81419 .20607 L
.81518 .20607 L
.81618 .20607 L
.81718 .20606 L
.81818 .20606 L
.81918 .20606 L
.82018 .20606 L
.82118 .20606 L
.82218 .20606 L
.82318 .20606 L
.82418 .20606 L
.82517 .20606 L
.82617 .20606 L
.82717 .20606 L
.82817 .20606 L
.82917 .20606 L
.83017 .20606 L
.83117 .20606 L
.83217 .20606 L
.83317 .20607 L
.83417 .20607 L
.83516 .20607 L
.83616 .20607 L
.83716 .20607 L
.83816 .20607 L
.83916 .20607 L
.84016 .20607 L
.84116 .20606 L
.84216 .20606 L
.84316 .20606 L
.84416 .20606 L
.84515 .20606 L
.84615 .20607 L
.84715 .20606 L
.84815 .20606 L
Mistroke
.84915 .20606 L
.85015 .20606 L
.85115 .20606 L
.85215 .20606 L
.85315 .20606 L
.85415 .20607 L
.85514 .20607 L
.85614 .20607 L
.85714 .20607 L
.85814 .20607 L
.85914 .20607 L
.86014 .20607 L
.86114 .20607 L
.86214 .20607 L
.86314 .20607 L
.86414 .20607 L
.86513 .20607 L
.86613 .20607 L
.86713 .20607 L
.86813 .20607 L
.86913 .20607 L
.87013 .20607 L
.87113 .20607 L
.87213 .20607 L
.87313 .20607 L
.87413 .20607 L
.87512 .20607 L
.87612 .20607 L
.87712 .20607 L
.87812 .20607 L
.87912 .20607 L
.88012 .20607 L
.88112 .20607 L
.88212 .20607 L
.88312 .20607 L
.88412 .20607 L
.88511 .20607 L
.88611 .20607 L
.88711 .20607 L
.88811 .20607 L
.88911 .20607 L
.89011 .20607 L
.89111 .20607 L
.89211 .20607 L
.89311 .20607 L
.89411 .20607 L
.8951 .20607 L
.8961 .20607 L
.8971 .20607 L
.8981 .20607 L
Mistroke
.8991 .20606 L
.9001 .20607 L
.9011 .20607 L
.9021 .20606 L
.9031 .20606 L
.9041 .20606 L
.90509 .20606 L
.90609 .20606 L
.90709 .20606 L
.90809 .20606 L
.90909 .20606 L
.91009 .20606 L
.91109 .20606 L
.91209 .20606 L
.91309 .20606 L
.91409 .20606 L
.91508 .20606 L
.91608 .20606 L
.91708 .20606 L
.91808 .20606 L
.91908 .20606 L
.92008 .20606 L
.92108 .20607 L
.92208 .20606 L
.92308 .20606 L
.92408 .20606 L
.92507 .20606 L
.92607 .20606 L
.92707 .20606 L
.92807 .20606 L
.92907 .20606 L
.93007 .20606 L
.93107 .20606 L
.93207 .20606 L
.93307 .20606 L
.93407 .20606 L
.93506 .20606 L
.93606 .20606 L
.93706 .20606 L
.93806 .20606 L
.93906 .20606 L
.94006 .20606 L
.94106 .20606 L
.94206 .20606 L
.94306 .20606 L
.94406 .20606 L
.94505 .20606 L
.94605 .20606 L
.94705 .20606 L
.94805 .20606 L
Mistroke
.94905 .20606 L
.95005 .20606 L
.95105 .20606 L
.95205 .20606 L
.95305 .20606 L
.95405 .20606 L
.95504 .20606 L
.95604 .20606 L
.95704 .20606 L
.95804 .20606 L
.95904 .20606 L
.96004 .20606 L
.96104 .20606 L
.96204 .20606 L
.96304 .20606 L
.96404 .20606 L
.96503 .20606 L
.96603 .20606 L
.96703 .20606 L
.96803 .20606 L
.96903 .20607 L
.97003 .20607 L
.97103 .20607 L
.97203 .20606 L
.97303 .20606 L
.97403 .20606 L
.97502 .20606 L
.97602 .20606 L
.97702 .20606 L
.97802 .20606 L
.97902 .20606 L
.98002 .20606 L
.98102 .20606 L
.98202 .20606 L
.98302 .20606 L
.98402 .20606 L
.98501 .20606 L
.98601 .20606 L
.98701 .20606 L
.98801 .20606 L
.98901 .20606 L
.99001 .20606 L
.99101 .20606 L
.99201 .20606 L
.99301 .20606 L
.99401 .20607 L
.995 .20607 L
.996 .20607 L
.997 .20607 L
.998 .20607 L
Mistroke
.999 .20607 L
Mfstroke
0 .98 .604 r
gsave
.999 .17355 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .13185 m
.001 .13185 L
.002 .13185 L
.003 .13185 L
.004 .13185 L
.005 .13185 L
.00599 .13185 L
.00699 .13185 L
.00799 .13185 L
.00899 .13185 L
.00999 .13185 L
.01099 .13185 L
.01199 .13185 L
.01299 .13185 L
.01399 .13185 L
.01499 .13185 L
.01598 .13185 L
.01698 .13185 L
.01798 .13185 L
.01898 .13185 L
.01998 .13185 L
.02098 .13185 L
.02198 .13185 L
.02298 .13185 L
.02398 .13185 L
.02498 .13185 L
.02597 .13185 L
.02697 .13185 L
.02797 .13185 L
.02897 .13185 L
.02997 .13185 L
.03097 .13185 L
.03197 .13185 L
.03297 .13185 L
.03397 .13185 L
.03497 .13185 L
.03596 .13185 L
.03696 .13185 L
.03796 .13185 L
.03896 .13185 L
.03996 .13185 L
.04096 .13185 L
.04196 .13185 L
.04296 .13185 L
.04396 .13185 L
.04496 .13185 L
.04595 .13185 L
.04695 .13185 L
.04795 .13185 L
.04895 .13185 L
Mistroke
.04995 .13233 L
.05095 .13233 L
.05195 .13233 L
.05295 .13233 L
.05395 .13233 L
.05495 .13233 L
.05594 .13233 L
.05694 .13233 L
.05794 .13233 L
.05894 .13233 L
.05994 .13233 L
.06094 .13233 L
.06194 .13233 L
.06294 .13233 L
.06394 .13233 L
.06494 .13233 L
.06593 .13233 L
.06693 .13233 L
.06793 .13233 L
.06893 .13233 L
.06993 .13233 L
.07093 .13233 L
.07193 .13233 L
.07293 .13233 L
.07393 .13233 L
.07493 .13233 L
.07592 .13233 L
.07692 .13233 L
.07792 .13233 L
.07892 .13233 L
.07992 .13233 L
.08092 .13233 L
.08192 .13233 L
.08292 .13233 L
.08392 .13233 L
.08492 .13233 L
.08591 .13233 L
.08691 .13233 L
.08791 .13233 L
.08891 .13233 L
.08991 .13233 L
.09091 .13233 L
.09191 .13233 L
.09291 .13233 L
.09391 .13233 L
.09491 .13233 L
.0959 .13233 L
.0969 .13233 L
.0979 .13233 L
.0989 .13233 L
Mistroke
.0999 .15413 L
.1009 .15413 L
.1019 .15413 L
.1029 .15413 L
.1039 .15413 L
.1049 .15413 L
.10589 .15413 L
.10689 .15413 L
.10789 .15413 L
.10889 .15413 L
.10989 .15413 L
.11089 .15413 L
.11189 .15413 L
.11289 .15413 L
.11389 .15413 L
.11489 .15413 L
.11588 .15413 L
.11688 .15413 L
.11788 .15413 L
.11888 .15413 L
.11988 .15413 L
.12088 .15413 L
.12188 .15413 L
.12288 .15413 L
.12388 .15413 L
.12488 .15413 L
.12587 .15413 L
.12687 .15413 L
.12787 .15413 L
.12887 .15413 L
.12987 .15413 L
.13087 .15413 L
.13187 .15413 L
.13287 .15413 L
.13387 .15413 L
.13487 .15413 L
.13586 .15413 L
.13686 .15413 L
.13786 .15413 L
.13886 .15413 L
.13986 .15413 L
.14086 .15413 L
.14186 .15413 L
.14286 .15413 L
.14386 .15413 L
.14486 .15413 L
.14585 .15413 L
.14685 .15413 L
.14785 .15413 L
.14885 .15413 L
Mistroke
.14985 .19325 L
.15085 .19325 L
.15185 .19325 L
.15285 .19325 L
.15385 .19325 L
.15485 .19325 L
.15584 .19325 L
.15684 .19325 L
.15784 .19325 L
.15884 .19325 L
.15984 .19325 L
.16084 .19325 L
.16184 .19325 L
.16284 .19325 L
.16384 .19325 L
.16484 .19325 L
.16583 .19325 L
.16683 .19325 L
.16783 .19325 L
.16883 .19325 L
.16983 .19325 L
.17083 .19325 L
.17183 .19325 L
.17283 .19325 L
.17383 .19325 L
.17483 .19325 L
.17582 .19325 L
.17682 .19325 L
.17782 .19325 L
.17882 .19325 L
.17982 .19325 L
.18082 .19325 L
.18182 .19325 L
.18282 .19325 L
.18382 .19325 L
.18482 .19325 L
.18581 .19325 L
.18681 .19325 L
.18781 .19325 L
.18881 .19325 L
.18981 .19325 L
.19081 .19325 L
.19181 .19325 L
.19281 .19325 L
.19381 .19325 L
.19481 .19325 L
.1958 .19325 L
.1968 .19325 L
.1978 .19325 L
.1988 .19325 L
Mistroke
.1998 .18193 L
.2008 .18193 L
.2018 .18193 L
.2028 .18193 L
.2038 .18193 L
.2048 .18193 L
.20579 .18193 L
.20679 .18193 L
.20779 .18193 L
.20879 .18193 L
.20979 .18193 L
.21079 .18193 L
.21179 .18193 L
.21279 .18193 L
.21379 .18193 L
.21479 .18193 L
.21578 .18193 L
.21678 .18193 L
.21778 .18193 L
.21878 .18193 L
.21978 .18193 L
.22078 .18193 L
.22178 .18193 L
.22278 .18193 L
.22378 .18193 L
.22478 .18193 L
.22577 .18193 L
.22677 .18193 L
.22777 .18193 L
.22877 .18193 L
.22977 .18193 L
.23077 .18193 L
.23177 .18193 L
.23277 .18193 L
.23377 .18193 L
.23477 .18193 L
.23576 .18193 L
.23676 .18193 L
.23776 .18193 L
.23876 .18193 L
.23976 .18193 L
.24076 .18193 L
.24176 .18193 L
.24276 .18193 L
.24376 .18193 L
.24476 .18193 L
.24575 .18193 L
.24675 .18193 L
.24775 .18193 L
.24875 .18193 L
Mistroke
.24975 .1665 L
.25075 .1665 L
.25175 .1665 L
.25275 .1665 L
.25375 .1665 L
.25475 .1665 L
.25574 .1665 L
.25674 .1665 L
.25774 .1665 L
.25874 .1665 L
.25974 .1665 L
.26074 .1665 L
.26174 .1665 L
.26274 .1665 L
.26374 .1665 L
.26474 .1665 L
.26573 .1665 L
.26673 .1665 L
.26773 .1665 L
.26873 .1665 L
.26973 .1665 L
.27073 .1665 L
.27173 .1665 L
.27273 .1665 L
.27373 .1665 L
.27473 .1665 L
.27572 .1665 L
.27672 .1665 L
.27772 .1665 L
.27872 .1665 L
.27972 .1665 L
.28072 .1665 L
.28172 .1665 L
.28272 .1665 L
.28372 .1665 L
.28472 .1665 L
.28571 .1665 L
.28671 .1665 L
.28771 .1665 L
.28871 .1665 L
.28971 .1665 L
.29071 .1665 L
.29171 .1665 L
.29271 .1665 L
.29371 .1665 L
.29471 .1665 L
.2957 .1665 L
.2967 .1665 L
.2977 .1665 L
.2987 .1665 L
Mistroke
.2997 .16796 L
.3007 .16796 L
.3017 .16796 L
.3027 .16796 L
.3037 .16796 L
.3047 .16796 L
.30569 .16796 L
.30669 .16796 L
.30769 .16796 L
.30869 .16796 L
.30969 .16796 L
.31069 .16796 L
.31169 .16796 L
.31269 .16796 L
.31369 .16796 L
.31469 .16796 L
.31568 .16796 L
.31668 .16796 L
.31768 .16796 L
.31868 .16796 L
.31968 .16796 L
.32068 .16796 L
.32168 .16796 L
.32268 .16796 L
.32368 .16796 L
.32468 .16796 L
.32567 .16796 L
.32667 .16796 L
.32767 .16796 L
.32867 .16796 L
.32967 .16796 L
.33067 .16796 L
.33167 .16796 L
.33267 .16796 L
.33367 .16796 L
.33467 .16796 L
.33566 .16796 L
.33666 .16796 L
.33766 .16796 L
.33866 .16796 L
.33966 .16796 L
.34066 .16796 L
.34166 .16796 L
.34266 .16796 L
.34366 .16796 L
.34466 .16796 L
.34565 .16796 L
.34665 .16796 L
.34765 .16796 L
.34865 .16796 L
Mistroke
.34965 .16632 L
.35065 .16632 L
.35165 .16632 L
.35265 .16632 L
.35365 .16632 L
.35465 .16632 L
.35564 .16632 L
.35664 .16632 L
.35764 .16632 L
.35864 .16632 L
.35964 .16632 L
.36064 .16632 L
.36164 .16632 L
.36264 .16632 L
.36364 .16632 L
.36464 .16632 L
.36563 .16632 L
.36663 .16632 L
.36763 .16632 L
.36863 .16632 L
.36963 .16632 L
.37063 .16632 L
.37163 .16632 L
.37263 .16632 L
.37363 .16632 L
.37463 .16632 L
.37562 .16632 L
.37662 .16632 L
.37762 .16632 L
.37862 .16632 L
.37962 .16632 L
.38062 .16632 L
.38162 .16632 L
.38262 .16632 L
.38362 .16632 L
.38462 .16632 L
.38561 .16632 L
.38661 .16632 L
.38761 .16632 L
.38861 .16632 L
.38961 .16632 L
.39061 .16632 L
.39161 .16632 L
.39261 .16632 L
.39361 .16632 L
.39461 .16632 L
.3956 .16632 L
.3966 .16632 L
.3976 .16632 L
.3986 .16632 L
Mistroke
.3996 .14434 L
.4006 .14434 L
.4016 .14434 L
.4026 .14434 L
.4036 .14434 L
.4046 .14434 L
.40559 .14434 L
.40659 .14434 L
.40759 .14434 L
.40859 .14434 L
.40959 .14434 L
.41059 .14434 L
.41159 .14434 L
.41259 .14434 L
.41359 .14434 L
.41459 .14434 L
.41558 .14434 L
.41658 .14434 L
.41758 .14434 L
.41858 .14434 L
.41958 .14434 L
.42058 .14434 L
.42158 .14434 L
.42258 .14434 L
.42358 .14434 L
.42458 .14434 L
.42557 .14434 L
.42657 .14434 L
.42757 .14434 L
.42857 .14434 L
.42957 .14434 L
.43057 .14434 L
.43157 .14434 L
.43257 .14434 L
.43357 .14434 L
.43457 .14434 L
.43556 .14434 L
.43656 .14434 L
.43756 .14434 L
.43856 .14434 L
.43956 .14434 L
.44056 .14434 L
.44156 .14434 L
.44256 .14434 L
.44356 .14434 L
.44456 .14434 L
.44555 .14434 L
.44655 .14434 L
.44755 .14434 L
.44855 .14434 L
Mistroke
.44955 .14295 L
.45055 .14295 L
.45155 .14295 L
.45255 .14295 L
.45355 .14295 L
.45455 .14295 L
.45554 .14295 L
.45654 .14295 L
.45754 .14295 L
.45854 .14295 L
.45954 .14295 L
.46054 .14295 L
.46154 .14295 L
.46254 .14295 L
.46354 .14295 L
.46454 .14295 L
.46553 .14295 L
.46653 .14295 L
.46753 .14295 L
.46853 .14295 L
.46953 .14295 L
.47053 .14295 L
.47153 .14295 L
.47253 .14295 L
.47353 .14295 L
.47453 .14295 L
.47552 .14295 L
.47652 .14295 L
.47752 .14295 L
.47852 .14295 L
.47952 .14295 L
.48052 .14295 L
.48152 .14295 L
.48252 .14295 L
.48352 .14295 L
.48452 .14295 L
.48551 .14295 L
.48651 .14295 L
.48751 .14295 L
.48851 .14295 L
.48951 .14295 L
.49051 .14295 L
.49151 .14295 L
.49251 .14295 L
.49351 .14295 L
.49451 .14295 L
.4955 .14295 L
.4965 .14295 L
.4975 .14295 L
.4985 .14295 L
Mistroke
.4995 .1528 L
.5005 .1528 L
.5015 .1528 L
.5025 .1528 L
.5035 .1528 L
.5045 .1528 L
.50549 .1528 L
.50649 .1528 L
.50749 .1528 L
.50849 .1528 L
.50949 .1528 L
.51049 .1528 L
.51149 .1528 L
.51249 .1528 L
.51349 .1528 L
.51449 .1528 L
.51548 .1528 L
.51648 .1528 L
.51748 .1528 L
.51848 .1528 L
.51948 .1528 L
.52048 .1528 L
.52148 .1528 L
.52248 .1528 L
.52348 .1528 L
.52448 .1528 L
.52547 .1528 L
.52647 .1528 L
.52747 .1528 L
.52847 .1528 L
.52947 .1528 L
.53047 .1528 L
.53147 .1528 L
.53247 .1528 L
.53347 .1528 L
.53447 .1528 L
.53546 .1528 L
.53646 .1528 L
.53746 .1528 L
.53846 .1528 L
.53946 .1528 L
.54046 .1528 L
.54146 .1528 L
.54246 .1528 L
.54346 .1528 L
.54446 .1528 L
.54545 .1528 L
.54645 .1528 L
.54745 .1528 L
.54845 .1528 L
Mistroke
.54945 .14996 L
.55045 .14996 L
.55145 .14996 L
.55245 .14996 L
.55345 .14996 L
.55445 .14996 L
.55544 .14996 L
.55644 .14996 L
.55744 .14996 L
.55844 .14996 L
.55944 .14996 L
.56044 .14996 L
.56144 .14996 L
.56244 .14996 L
.56344 .14996 L
.56444 .14996 L
.56543 .14996 L
.56643 .14996 L
.56743 .14996 L
.56843 .14996 L
.56943 .14996 L
.57043 .14996 L
.57143 .14996 L
.57243 .14996 L
.57343 .14996 L
.57443 .14996 L
.57542 .14996 L
.57642 .14996 L
.57742 .14996 L
.57842 .14996 L
.57942 .14996 L
.58042 .14996 L
.58142 .14996 L
.58242 .14996 L
.58342 .14996 L
.58442 .14996 L
.58541 .14996 L
.58641 .14996 L
.58741 .14996 L
.58841 .14996 L
.58941 .14996 L
.59041 .14996 L
.59141 .14996 L
.59241 .14996 L
.59341 .14996 L
.59441 .14996 L
.5954 .14996 L
.5964 .14996 L
.5974 .14996 L
.5984 .14996 L
Mistroke
.5994 .15371 L
.6004 .15371 L
.6014 .15371 L
.6024 .15371 L
.6034 .15371 L
.6044 .15371 L
.60539 .15371 L
.60639 .15371 L
.60739 .15371 L
.60839 .15371 L
.60939 .15371 L
.61039 .15371 L
.61139 .15371 L
.61239 .15371 L
.61339 .15371 L
.61439 .15371 L
.61538 .15371 L
.61638 .15371 L
.61738 .15371 L
.61838 .15371 L
.61938 .15371 L
.62038 .15371 L
.62138 .15371 L
.62238 .15371 L
.62338 .15371 L
.62438 .15371 L
.62537 .15371 L
.62637 .15371 L
.62737 .15371 L
.62837 .15371 L
.62937 .15371 L
.63037 .15371 L
.63137 .15371 L
.63237 .15371 L
.63337 .15371 L
.63437 .15371 L
.63536 .15371 L
.63636 .15371 L
.63736 .15371 L
.63836 .15371 L
.63936 .15371 L
.64036 .15371 L
.64136 .15371 L
.64236 .15371 L
.64336 .15371 L
.64436 .15371 L
.64535 .15371 L
.64635 .15371 L
.64735 .15371 L
.64835 .15371 L
Mistroke
.64935 .15436 L
.65035 .15436 L
.65135 .15436 L
.65235 .15436 L
.65335 .15436 L
.65435 .15436 L
.65534 .15436 L
.65634 .15436 L
.65734 .15436 L
.65834 .15436 L
.65934 .15436 L
.66034 .15436 L
.66134 .15436 L
.66234 .15436 L
.66334 .15436 L
.66434 .15436 L
.66533 .15436 L
.66633 .15436 L
.66733 .15436 L
.66833 .15436 L
.66933 .15436 L
.67033 .15436 L
.67133 .15436 L
.67233 .15436 L
.67333 .15436 L
.67433 .15436 L
.67532 .15436 L
.67632 .15436 L
.67732 .15436 L
.67832 .15436 L
.67932 .15436 L
.68032 .15436 L
.68132 .15436 L
.68232 .15436 L
.68332 .15436 L
.68432 .15436 L
.68531 .15436 L
.68631 .15436 L
.68731 .15436 L
.68831 .15436 L
.68931 .15436 L
.69031 .15436 L
.69131 .15436 L
.69231 .15436 L
.69331 .15436 L
.69431 .15436 L
.6953 .15436 L
.6963 .15436 L
.6973 .15436 L
.6983 .15436 L
Mistroke
.6993 .15436 L
.7003 .15436 L
.7013 .15436 L
.7023 .15436 L
.7033 .15436 L
.7043 .15436 L
.70529 .15436 L
.70629 .15436 L
.70729 .15436 L
.70829 .15436 L
.70929 .15436 L
.71029 .15436 L
.71129 .15436 L
.71229 .15436 L
.71329 .15436 L
.71429 .15436 L
.71528 .15436 L
.71628 .15436 L
.71728 .15436 L
.71828 .15436 L
.71928 .15436 L
.72028 .15436 L
.72128 .15436 L
.72228 .15436 L
.72328 .15436 L
.72428 .15436 L
.72527 .15436 L
.72627 .15436 L
.72727 .15436 L
.72827 .15436 L
.72927 .15436 L
.73027 .15436 L
.73127 .15436 L
.73227 .15436 L
.73327 .15436 L
.73427 .15436 L
.73526 .15436 L
.73626 .15436 L
.73726 .15436 L
.73826 .15436 L
.73926 .15436 L
.74026 .15436 L
.74126 .15436 L
.74226 .15436 L
.74326 .15436 L
.74426 .15436 L
.74525 .15436 L
.74625 .15436 L
.74725 .15436 L
.74825 .15436 L
Mistroke
.74925 .1594 L
.75025 .1594 L
.75125 .1594 L
.75225 .1594 L
.75325 .1594 L
.75425 .1594 L
.75524 .1594 L
.75624 .1594 L
.75724 .1594 L
.75824 .1594 L
.75924 .1594 L
.76024 .1594 L
.76124 .1594 L
.76224 .1594 L
.76324 .1594 L
.76424 .1594 L
.76523 .1594 L
.76623 .1594 L
.76723 .1594 L
.76823 .1594 L
.76923 .1594 L
.77023 .1594 L
.77123 .1594 L
.77223 .1594 L
.77323 .1594 L
.77423 .1594 L
.77522 .1594 L
.77622 .1594 L
.77722 .1594 L
.77822 .1594 L
.77922 .1594 L
.78022 .1594 L
.78122 .1594 L
.78222 .1594 L
.78322 .1594 L
.78422 .1594 L
.78521 .1594 L
.78621 .1594 L
.78721 .1594 L
.78821 .1594 L
.78921 .1594 L
.79021 .1594 L
.79121 .1594 L
.79221 .1594 L
.79321 .1594 L
.79421 .1594 L
.7952 .1594 L
.7962 .1594 L
.7972 .1594 L
.7982 .1594 L
Mistroke
.7992 .16212 L
.8002 .16212 L
.8012 .16212 L
.8022 .16212 L
.8032 .16212 L
.8042 .16212 L
.80519 .16212 L
.80619 .16212 L
.80719 .16212 L
.80819 .16212 L
.80919 .16212 L
.81019 .16212 L
.81119 .16212 L
.81219 .16212 L
.81319 .16212 L
.81419 .16212 L
.81518 .16212 L
.81618 .16212 L
.81718 .16212 L
.81818 .16212 L
.81918 .16212 L
.82018 .16212 L
.82118 .16212 L
.82218 .16212 L
.82318 .16212 L
.82418 .16212 L
.82517 .16212 L
.82617 .16212 L
.82717 .16212 L
.82817 .16212 L
.82917 .16212 L
.83017 .16212 L
.83117 .16212 L
.83217 .16212 L
.83317 .16212 L
.83417 .16212 L
.83516 .16212 L
.83616 .16212 L
.83716 .16212 L
.83816 .16212 L
.83916 .16212 L
.84016 .16212 L
.84116 .16212 L
.84216 .16212 L
.84316 .16212 L
.84416 .16212 L
.84515 .16212 L
.84615 .16212 L
.84715 .16212 L
.84815 .16212 L
Mistroke
.84915 .16551 L
.85015 .16551 L
.85115 .16551 L
.85215 .16551 L
.85315 .16551 L
.85415 .16551 L
.85514 .16551 L
.85614 .16551 L
.85714 .16551 L
.85814 .16551 L
.85914 .16551 L
.86014 .16551 L
.86114 .16551 L
.86214 .16551 L
.86314 .16551 L
.86414 .16551 L
.86513 .16551 L
.86613 .16551 L
.86713 .16551 L
.86813 .16551 L
.86913 .16551 L
.87013 .16551 L
.87113 .16551 L
.87213 .16551 L
.87313 .16551 L
.87413 .16551 L
.87512 .16551 L
.87612 .16551 L
.87712 .16551 L
.87812 .16551 L
.87912 .16551 L
.88012 .16551 L
.88112 .16551 L
.88212 .16551 L
.88312 .16551 L
.88412 .16551 L
.88511 .16551 L
.88611 .16551 L
.88711 .16551 L
.88811 .16551 L
.88911 .16551 L
.89011 .16551 L
.89111 .16551 L
.89211 .16551 L
.89311 .16551 L
.89411 .16551 L
.8951 .16551 L
.8961 .16551 L
.8971 .16551 L
.8981 .16551 L
Mistroke
.8991 .17002 L
.9001 .17002 L
.9011 .17002 L
.9021 .17002 L
.9031 .17002 L
.9041 .17002 L
.90509 .17002 L
.90609 .17002 L
.90709 .17002 L
.90809 .17002 L
.90909 .17002 L
.91009 .17002 L
.91109 .17002 L
.91209 .17002 L
.91309 .17002 L
.91409 .17002 L
.91508 .17002 L
.91608 .17002 L
.91708 .17002 L
.91808 .17002 L
.91908 .17002 L
.92008 .17002 L
.92108 .17002 L
.92208 .17002 L
.92308 .17002 L
.92408 .17002 L
.92507 .17002 L
.92607 .17002 L
.92707 .17002 L
.92807 .17002 L
.92907 .17002 L
.93007 .17002 L
.93107 .17002 L
.93207 .17002 L
.93307 .17002 L
.93407 .17002 L
.93506 .17002 L
.93606 .17002 L
.93706 .17002 L
.93806 .17002 L
.93906 .17002 L
.94006 .17002 L
.94106 .17002 L
.94206 .17002 L
.94306 .17002 L
.94406 .17002 L
.94505 .17002 L
.94605 .17002 L
.94705 .17002 L
.94805 .17002 L
Mistroke
.94905 .1725 L
.95005 .1725 L
.95105 .1725 L
.95205 .1725 L
.95305 .1725 L
.95405 .1725 L
.95504 .1725 L
.95604 .1725 L
.95704 .1725 L
.95804 .1725 L
.95904 .1725 L
.96004 .1725 L
.96104 .1725 L
.96204 .1725 L
.96304 .1725 L
.96404 .1725 L
.96503 .1725 L
.96603 .1725 L
.96703 .1725 L
.96803 .1725 L
.96903 .1725 L
.97003 .1725 L
.97103 .1725 L
.97203 .1725 L
.97303 .1725 L
.97403 .1725 L
.97502 .1725 L
.97602 .1725 L
.97702 .1725 L
.97802 .1725 L
.97902 .1725 L
.98002 .1725 L
.98102 .1725 L
.98202 .1725 L
.98302 .1725 L
.98402 .1725 L
.98501 .1725 L
.98601 .1725 L
.98701 .1725 L
.98801 .1725 L
.98901 .1725 L
.99001 .1725 L
.99101 .1725 L
.99201 .1725 L
.99301 .1725 L
.99401 .1725 L
.995 .1725 L
.996 .1725 L
.997 .1725 L
.998 .1725 L
Mistroke
.999 .17355 L
Mfstroke
gsave
.999 .2018 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .43468 m
.001 .43468 L
.002 .43468 L
.003 .43468 L
.004 .43468 L
.005 .43468 L
.00599 .43468 L
.00699 .43468 L
.00799 .43468 L
.00899 .43468 L
.00999 .43468 L
.01099 .43468 L
.01199 .43468 L
.01299 .43468 L
.01399 .43468 L
.01499 .43468 L
.01598 .43468 L
.01698 .43468 L
.01798 .43468 L
.01898 .43468 L
.01998 .43468 L
.02098 .43468 L
.02198 .43468 L
.02298 .43468 L
.02398 .43468 L
.02498 .43468 L
.02597 .43468 L
.02697 .43468 L
.02797 .43468 L
.02897 .43468 L
.02997 .43468 L
.03097 .43468 L
.03197 .43468 L
.03297 .43468 L
.03397 .43468 L
.03497 .43468 L
.03596 .43468 L
.03696 .43468 L
.03796 .43468 L
.03896 .43468 L
.03996 .43468 L
.04096 .43468 L
.04196 .43468 L
.04296 .43468 L
.04396 .43468 L
.04496 .43468 L
.04595 .43468 L
.04695 .43468 L
.04795 .43468 L
.04895 .43468 L
Mistroke
.04995 .43545 L
.05095 .43545 L
.05195 .43545 L
.05295 .43545 L
.05395 .43545 L
.05495 .43545 L
.05594 .43545 L
.05694 .43545 L
.05794 .43545 L
.05894 .43545 L
.05994 .43545 L
.06094 .43545 L
.06194 .43545 L
.06294 .43545 L
.06394 .43545 L
.06494 .43545 L
.06593 .43545 L
.06693 .43545 L
.06793 .43545 L
.06893 .43545 L
.06993 .43545 L
.07093 .43545 L
.07193 .43545 L
.07293 .43545 L
.07393 .43545 L
.07493 .43545 L
.07592 .43545 L
.07692 .43545 L
.07792 .43545 L
.07892 .43545 L
.07992 .43545 L
.08092 .43545 L
.08192 .43545 L
.08292 .43545 L
.08392 .43545 L
.08492 .43545 L
.08591 .43545 L
.08691 .43545 L
.08791 .43545 L
.08891 .43545 L
.08991 .43545 L
.09091 .43545 L
.09191 .43545 L
.09291 .43545 L
.09391 .43545 L
.09491 .43545 L
.0959 .43545 L
.0969 .43545 L
.0979 .43545 L
.0989 .43545 L
Mistroke
.0999 .27461 L
.1009 .27461 L
.1019 .27461 L
.1029 .27461 L
.1039 .27461 L
.1049 .27461 L
.10589 .27461 L
.10689 .27461 L
.10789 .27461 L
.10889 .27461 L
.10989 .27461 L
.11089 .27461 L
.11189 .27461 L
.11289 .27461 L
.11389 .27461 L
.11489 .27461 L
.11588 .27461 L
.11688 .27461 L
.11788 .27461 L
.11888 .27461 L
.11988 .27461 L
.12088 .27461 L
.12188 .27461 L
.12288 .27461 L
.12388 .27461 L
.12488 .27461 L
.12587 .27461 L
.12687 .27461 L
.12787 .27461 L
.12887 .27461 L
.12987 .27461 L
.13087 .27461 L
.13187 .27461 L
.13287 .27461 L
.13387 .27461 L
.13487 .27461 L
.13586 .27461 L
.13686 .27461 L
.13786 .27461 L
.13886 .27461 L
.13986 .27461 L
.14086 .27461 L
.14186 .27461 L
.14286 .27461 L
.14386 .27461 L
.14486 .27461 L
.14585 .27461 L
.14685 .27461 L
.14785 .27461 L
.14885 .27461 L
Mistroke
.14985 .29703 L
.15085 .29703 L
.15185 .29703 L
.15285 .29703 L
.15385 .29703 L
.15485 .29703 L
.15584 .29703 L
.15684 .29703 L
.15784 .29703 L
.15884 .29703 L
.15984 .29703 L
.16084 .29703 L
.16184 .29703 L
.16284 .29703 L
.16384 .29703 L
.16484 .29703 L
.16583 .29703 L
.16683 .29703 L
.16783 .29703 L
.16883 .29703 L
.16983 .29703 L
.17083 .29703 L
.17183 .29703 L
.17283 .29703 L
.17383 .29703 L
.17483 .29703 L
.17582 .29703 L
.17682 .29703 L
.17782 .29703 L
.17882 .29703 L
.17982 .29703 L
.18082 .29703 L
.18182 .29703 L
.18282 .29703 L
.18382 .29703 L
.18482 .29703 L
.18581 .29703 L
.18681 .29703 L
.18781 .29703 L
.18881 .29703 L
.18981 .29703 L
.19081 .29703 L
.19181 .29703 L
.19281 .29703 L
.19381 .29703 L
.19481 .29703 L
.1958 .29703 L
.1968 .29703 L
.1978 .29703 L
.1988 .29703 L
Mistroke
.1998 .26009 L
.2008 .26009 L
.2018 .26009 L
.2028 .26009 L
.2038 .26009 L
.2048 .26009 L
.20579 .26009 L
.20679 .26009 L
.20779 .26009 L
.20879 .26009 L
.20979 .26009 L
.21079 .26009 L
.21179 .26009 L
.21279 .26009 L
.21379 .26009 L
.21479 .26009 L
.21578 .26009 L
.21678 .26009 L
.21778 .26009 L
.21878 .26009 L
.21978 .26009 L
.22078 .26009 L
.22178 .26009 L
.22278 .26009 L
.22378 .26009 L
.22478 .26009 L
.22577 .26009 L
.22677 .26009 L
.22777 .26009 L
.22877 .26009 L
.22977 .26009 L
.23077 .26009 L
.23177 .26009 L
.23277 .26009 L
.23377 .26009 L
.23477 .26009 L
.23576 .26009 L
.23676 .26009 L
.23776 .26009 L
.23876 .26009 L
.23976 .26009 L
.24076 .26009 L
.24176 .26009 L
.24276 .26009 L
.24376 .26009 L
.24476 .26009 L
.24575 .26009 L
.24675 .26009 L
.24775 .26009 L
.24875 .26009 L
Mistroke
.24975 .22694 L
.25075 .22694 L
.25175 .22694 L
.25275 .22694 L
.25375 .22694 L
.25475 .22694 L
.25574 .22694 L
.25674 .22694 L
.25774 .22694 L
.25874 .22694 L
.25974 .22694 L
.26074 .22694 L
.26174 .22694 L
.26274 .22694 L
.26374 .22694 L
.26474 .22694 L
.26573 .22694 L
.26673 .22694 L
.26773 .22694 L
.26873 .22694 L
.26973 .22694 L
.27073 .22694 L
.27173 .22694 L
.27273 .22694 L
.27373 .22694 L
.27473 .22694 L
.27572 .22694 L
.27672 .22694 L
.27772 .22694 L
.27872 .22694 L
.27972 .22694 L
.28072 .22694 L
.28172 .22695 L
.28272 .22695 L
.28372 .22695 L
.28472 .22695 L
.28571 .22695 L
.28671 .22695 L
.28771 .22695 L
.28871 .22695 L
.28971 .22695 L
.29071 .22695 L
.29171 .22695 L
.29271 .22695 L
.29371 .22695 L
.29471 .22695 L
.2957 .22695 L
.2967 .22695 L
.2977 .22695 L
.2987 .22695 L
Mistroke
.2997 .22655 L
.3007 .22655 L
.3017 .22655 L
.3027 .22655 L
.3037 .22655 L
.3047 .22655 L
.30569 .22655 L
.30669 .22655 L
.30769 .22655 L
.30869 .22655 L
.30969 .22655 L
.31069 .22655 L
.31169 .22655 L
.31269 .22655 L
.31369 .22655 L
.31469 .22655 L
.31568 .22655 L
.31668 .22655 L
.31768 .22655 L
.31868 .22655 L
.31968 .22655 L
.32068 .22655 L
.32168 .22655 L
.32268 .22655 L
.32368 .22655 L
.32468 .22655 L
.32567 .22655 L
.32667 .22655 L
.32767 .22655 L
.32867 .22655 L
.32967 .22655 L
.33067 .22655 L
.33167 .22655 L
.33267 .22655 L
.33367 .22655 L
.33467 .22655 L
.33566 .22655 L
.33666 .22655 L
.33766 .22655 L
.33866 .22655 L
.33966 .22655 L
.34066 .22655 L
.34166 .22655 L
.34266 .22655 L
.34366 .22655 L
.34466 .22655 L
.34565 .22655 L
.34665 .22655 L
.34765 .22655 L
.34865 .22655 L
Mistroke
.34965 .22322 L
.35065 .22322 L
.35165 .22322 L
.35265 .22322 L
.35365 .22322 L
.35465 .22322 L
.35564 .22322 L
.35664 .22322 L
.35764 .22322 L
.35864 .22322 L
.35964 .22322 L
.36064 .22322 L
.36164 .22322 L
.36264 .22322 L
.36364 .22322 L
.36464 .22322 L
.36563 .22322 L
.36663 .22322 L
.36763 .22322 L
.36863 .22322 L
.36963 .22322 L
.37063 .22322 L
.37163 .22322 L
.37263 .22322 L
.37363 .22322 L
.37463 .22322 L
.37562 .22322 L
.37662 .22322 L
.37762 .22322 L
.37862 .22322 L
.37962 .22322 L
.38062 .22322 L
.38162 .22322 L
.38262 .22322 L
.38362 .22322 L
.38462 .22322 L
.38561 .22322 L
.38661 .22322 L
.38761 .22322 L
.38861 .22322 L
.38961 .22322 L
.39061 .22322 L
.39161 .22322 L
.39261 .22322 L
.39361 .22322 L
.39461 .22322 L
.3956 .22322 L
.3966 .22322 L
.3976 .22322 L
.3986 .22322 L
Mistroke
.3996 .19259 L
.4006 .19259 L
.4016 .19259 L
.4026 .19259 L
.4036 .19259 L
.4046 .19259 L
.40559 .19259 L
.40659 .19259 L
.40759 .19259 L
.40859 .19259 L
.40959 .19259 L
.41059 .19259 L
.41159 .19259 L
.41259 .19259 L
.41359 .19259 L
.41459 .19259 L
.41558 .19259 L
.41658 .19259 L
.41758 .19259 L
.41858 .19259 L
.41958 .19259 L
.42058 .19259 L
.42158 .19259 L
.42258 .19259 L
.42358 .19259 L
.42458 .19259 L
.42557 .19259 L
.42657 .19259 L
.42757 .19259 L
.42857 .19259 L
.42957 .19259 L
.43057 .19259 L
.43157 .19259 L
.43257 .19259 L
.43357 .19259 L
.43457 .19259 L
.43556 .19259 L
.43656 .19259 L
.43756 .19259 L
.43856 .19259 L
.43956 .19259 L
.44056 .19259 L
.44156 .19259 L
.44256 .19259 L
.44356 .19259 L
.44456 .19259 L
.44555 .19259 L
.44655 .19259 L
.44755 .19259 L
.44855 .19259 L
Mistroke
.44955 .18791 L
.45055 .18791 L
.45155 .18791 L
.45255 .18791 L
.45355 .18791 L
.45455 .18791 L
.45554 .18791 L
.45654 .18791 L
.45754 .18791 L
.45854 .18791 L
.45954 .18791 L
.46054 .18791 L
.46154 .18791 L
.46254 .18791 L
.46354 .18791 L
.46454 .18791 L
.46553 .18791 L
.46653 .18791 L
.46753 .18791 L
.46853 .18791 L
.46953 .18791 L
.47053 .18791 L
.47153 .18791 L
.47253 .18791 L
.47353 .18791 L
.47453 .18791 L
.47552 .18791 L
.47652 .18791 L
.47752 .18791 L
.47852 .18791 L
.47952 .18791 L
.48052 .18791 L
.48152 .18791 L
.48252 .18791 L
.48352 .18791 L
.48452 .18791 L
.48551 .18791 L
.48651 .18791 L
.48751 .18791 L
.48851 .18791 L
.48951 .18791 L
.49051 .18791 L
.49151 .18791 L
.49251 .18791 L
.49351 .18791 L
.49451 .18791 L
.4955 .18791 L
.4965 .18791 L
.4975 .18791 L
.4985 .18791 L
Mistroke
.4995 .19612 L
.5005 .19612 L
.5015 .19612 L
.5025 .19612 L
.5035 .19612 L
.5045 .19612 L
.50549 .19612 L
.50649 .19612 L
.50749 .19612 L
.50849 .19612 L
.50949 .19612 L
.51049 .19612 L
.51149 .19612 L
.51249 .19612 L
.51349 .19612 L
.51449 .19612 L
.51548 .19612 L
.51648 .19612 L
.51748 .19612 L
.51848 .19612 L
.51948 .19612 L
.52048 .19612 L
.52148 .19612 L
.52248 .19612 L
.52348 .19612 L
.52448 .19612 L
.52547 .19612 L
.52647 .19612 L
.52747 .19612 L
.52847 .19612 L
.52947 .19612 L
.53047 .19612 L
.53147 .19612 L
.53247 .19612 L
.53347 .19612 L
.53447 .19612 L
.53546 .19612 L
.53646 .19612 L
.53746 .19612 L
.53846 .19612 L
.53946 .19612 L
.54046 .19612 L
.54146 .19612 L
.54246 .19612 L
.54346 .19612 L
.54446 .19612 L
.54545 .19612 L
.54645 .19612 L
.54745 .19612 L
.54845 .19612 L
Mistroke
.54945 .18854 L
.55045 .18854 L
.55145 .18854 L
.55245 .18854 L
.55345 .18854 L
.55445 .18854 L
.55544 .18854 L
.55644 .18854 L
.55744 .18854 L
.55844 .18854 L
.55944 .18854 L
.56044 .18854 L
.56144 .18854 L
.56244 .18854 L
.56344 .18854 L
.56444 .18854 L
.56543 .18854 L
.56643 .18854 L
.56743 .18854 L
.56843 .18854 L
.56943 .18854 L
.57043 .18854 L
.57143 .18854 L
.57243 .18854 L
.57343 .18854 L
.57443 .18854 L
.57542 .18854 L
.57642 .18854 L
.57742 .18854 L
.57842 .18854 L
.57942 .18854 L
.58042 .18854 L
.58142 .18854 L
.58242 .18854 L
.58342 .18854 L
.58442 .18854 L
.58541 .18854 L
.58641 .18854 L
.58741 .18854 L
.58841 .18854 L
.58941 .18854 L
.59041 .18854 L
.59141 .18854 L
.59241 .18854 L
.59341 .18854 L
.59441 .18854 L
.5954 .18854 L
.5964 .18854 L
.5974 .18854 L
.5984 .18854 L
Mistroke
.5994 .18986 L
.6004 .18986 L
.6014 .18986 L
.6024 .18986 L
.6034 .18986 L
.6044 .18986 L
.60539 .18986 L
.60639 .18986 L
.60739 .18986 L
.60839 .18986 L
.60939 .18986 L
.61039 .18986 L
.61139 .18986 L
.61239 .18986 L
.61339 .18986 L
.61439 .18986 L
.61538 .18986 L
.61638 .18986 L
.61738 .18986 L
.61838 .18986 L
.61938 .18986 L
.62038 .18986 L
.62138 .18986 L
.62238 .18986 L
.62338 .18986 L
.62438 .18986 L
.62537 .18986 L
.62637 .18986 L
.62737 .18986 L
.62837 .18986 L
.62937 .18986 L
.63037 .18986 L
.63137 .18986 L
.63237 .18986 L
.63337 .18986 L
.63437 .18986 L
.63536 .18986 L
.63636 .18986 L
.63736 .18986 L
.63836 .18986 L
.63936 .18986 L
.64036 .18986 L
.64136 .18986 L
.64236 .18986 L
.64336 .18986 L
.64436 .18986 L
.64535 .18986 L
.64635 .18986 L
.64735 .18986 L
.64835 .18986 L
Mistroke
.64935 .19025 L
.65035 .19025 L
.65135 .19025 L
.65235 .19025 L
.65335 .19025 L
.65435 .19025 L
.65534 .19025 L
.65634 .19025 L
.65734 .19025 L
.65834 .19025 L
.65934 .19025 L
.66034 .19025 L
.66134 .19025 L
.66234 .19025 L
.66334 .19025 L
.66434 .19025 L
.66533 .19025 L
.66633 .19025 L
.66733 .19025 L
.66833 .19025 L
.66933 .19025 L
.67033 .19025 L
.67133 .19025 L
.67233 .19025 L
.67333 .19025 L
.67433 .19025 L
.67532 .19025 L
.67632 .19025 L
.67732 .19025 L
.67832 .19025 L
.67932 .19025 L
.68032 .19025 L
.68132 .19025 L
.68232 .19025 L
.68332 .19025 L
.68432 .19025 L
.68531 .19025 L
.68631 .19025 L
.68731 .19025 L
.68831 .19025 L
.68931 .19025 L
.69031 .19025 L
.69131 .19025 L
.69231 .19025 L
.69331 .19025 L
.69431 .19025 L
.6953 .19025 L
.6963 .19025 L
.6973 .19025 L
.6983 .19025 L
Mistroke
.6993 .18991 L
.7003 .18991 L
.7013 .18991 L
.7023 .18991 L
.7033 .18991 L
.7043 .18991 L
.70529 .18991 L
.70629 .18991 L
.70729 .18991 L
.70829 .18991 L
.70929 .18991 L
.71029 .18991 L
.71129 .18991 L
.71229 .18991 L
.71329 .18991 L
.71429 .18991 L
.71528 .18991 L
.71628 .18991 L
.71728 .18991 L
.71828 .18991 L
.71928 .18991 L
.72028 .18991 L
.72128 .18991 L
.72228 .18991 L
.72328 .18991 L
.72428 .18991 L
.72527 .18991 L
.72627 .18991 L
.72727 .18991 L
.72827 .18991 L
.72927 .18991 L
.73027 .18991 L
.73127 .18991 L
.73227 .18991 L
.73327 .18991 L
.73427 .18991 L
.73526 .18991 L
.73626 .18991 L
.73726 .18991 L
.73826 .18991 L
.73926 .18991 L
.74026 .18991 L
.74126 .18991 L
.74226 .18991 L
.74326 .18991 L
.74426 .18991 L
.74525 .18991 L
.74625 .18991 L
.74725 .18991 L
.74825 .18991 L
Mistroke
.74925 .19289 L
.75025 .19289 L
.75125 .19289 L
.75225 .19289 L
.75325 .19289 L
.75425 .19289 L
.75524 .19289 L
.75624 .19289 L
.75724 .19289 L
.75824 .19289 L
.75924 .19289 L
.76024 .19289 L
.76124 .19289 L
.76224 .19289 L
.76324 .19289 L
.76424 .19289 L
.76523 .19289 L
.76623 .19289 L
.76723 .19289 L
.76823 .19289 L
.76923 .19289 L
.77023 .19289 L
.77123 .19289 L
.77223 .19289 L
.77323 .19289 L
.77423 .19289 L
.77522 .19289 L
.77622 .19289 L
.77722 .19289 L
.77822 .19289 L
.77922 .19289 L
.78022 .19289 L
.78122 .19289 L
.78222 .19289 L
.78322 .19289 L
.78422 .19289 L
.78521 .19289 L
.78621 .19289 L
.78721 .19289 L
.78821 .19289 L
.78921 .19289 L
.79021 .19289 L
.79121 .19289 L
.79221 .19289 L
.79321 .19289 L
.79421 .19289 L
.7952 .19289 L
.7962 .19289 L
.7972 .19289 L
.7982 .19289 L
Mistroke
.7992 .19381 L
.8002 .19381 L
.8012 .19381 L
.8022 .19381 L
.8032 .19381 L
.8042 .19381 L
.80519 .19381 L
.80619 .19381 L
.80719 .19381 L
.80819 .19381 L
.80919 .19381 L
.81019 .19381 L
.81119 .19381 L
.81219 .19381 L
.81319 .19381 L
.81419 .19381 L
.81518 .19381 L
.81618 .19381 L
.81718 .19381 L
.81818 .19381 L
.81918 .19381 L
.82018 .19381 L
.82118 .19381 L
.82218 .19381 L
.82318 .19381 L
.82418 .19381 L
.82517 .19381 L
.82617 .19381 L
.82717 .19381 L
.82817 .19381 L
.82917 .19381 L
.83017 .19381 L
.83117 .19381 L
.83217 .19381 L
.83317 .19381 L
.83417 .19381 L
.83516 .19381 L
.83616 .19381 L
.83716 .19381 L
.83816 .19381 L
.83916 .19381 L
.84016 .19381 L
.84116 .19381 L
.84216 .19381 L
.84316 .19381 L
.84416 .19381 L
.84515 .19381 L
.84615 .19381 L
.84715 .19381 L
.84815 .19381 L
Mistroke
.84915 .1966 L
.85015 .1966 L
.85115 .1966 L
.85215 .1966 L
.85315 .1966 L
.85415 .1966 L
.85514 .1966 L
.85614 .1966 L
.85714 .1966 L
.85814 .1966 L
.85914 .1966 L
.86014 .1966 L
.86114 .1966 L
.86214 .1966 L
.86314 .1966 L
.86414 .1966 L
.86513 .1966 L
.86613 .1966 L
.86713 .1966 L
.86813 .1966 L
.86913 .1966 L
.87013 .1966 L
.87113 .1966 L
.87213 .1966 L
.87313 .1966 L
.87413 .1966 L
.87512 .1966 L
.87612 .1966 L
.87712 .1966 L
.87812 .1966 L
.87912 .1966 L
.88012 .1966 L
.88112 .1966 L
.88212 .1966 L
.88312 .1966 L
.88412 .1966 L
.88511 .1966 L
.88611 .1966 L
.88711 .1966 L
.88811 .1966 L
.88911 .1966 L
.89011 .1966 L
.89111 .1966 L
.89211 .1966 L
.89311 .1966 L
.89411 .1966 L
.8951 .1966 L
.8961 .1966 L
.8971 .1966 L
.8981 .1966 L
Mistroke
.8991 .19965 L
.9001 .19965 L
.9011 .19965 L
.9021 .19965 L
.9031 .19965 L
.9041 .19965 L
.90509 .19965 L
.90609 .19965 L
.90709 .19965 L
.90809 .19965 L
.90909 .19965 L
.91009 .19965 L
.91109 .19965 L
.91209 .19965 L
.91309 .19965 L
.91409 .19965 L
.91508 .19965 L
.91608 .19965 L
.91708 .19965 L
.91808 .19965 L
.91908 .19965 L
.92008 .19965 L
.92108 .19965 L
.92208 .19965 L
.92308 .19965 L
.92408 .19965 L
.92507 .19965 L
.92607 .19965 L
.92707 .19965 L
.92807 .19965 L
.92907 .19965 L
.93007 .19965 L
.93107 .19965 L
.93207 .19965 L
.93307 .19965 L
.93407 .19965 L
.93506 .19965 L
.93606 .19965 L
.93706 .19965 L
.93806 .19965 L
.93906 .19965 L
.94006 .19965 L
.94106 .19965 L
.94206 .19965 L
.94306 .19965 L
.94406 .19965 L
.94505 .19965 L
.94605 .19965 L
.94705 .19965 L
.94805 .19965 L
Mistroke
.94905 .20095 L
.95005 .20095 L
.95105 .20095 L
.95205 .20095 L
.95305 .20095 L
.95405 .20095 L
.95504 .20095 L
.95604 .20095 L
.95704 .20095 L
.95804 .20095 L
.95904 .20095 L
.96004 .20095 L
.96104 .20095 L
.96204 .20095 L
.96304 .20095 L
.96404 .20095 L
.96503 .20095 L
.96603 .20095 L
.96703 .20095 L
.96803 .20095 L
.96903 .20095 L
.97003 .20095 L
.97103 .20095 L
.97203 .20095 L
.97303 .20095 L
.97403 .20095 L
.97502 .20095 L
.97602 .20095 L
.97702 .20095 L
.97802 .20095 L
.97902 .20095 L
.98002 .20095 L
.98102 .20095 L
.98202 .20095 L
.98302 .20095 L
.98402 .20095 L
.98501 .20095 L
.98601 .20095 L
.98701 .20095 L
.98801 .20095 L
.98901 .20095 L
.99001 .20095 L
.99101 .20095 L
.99201 .20095 L
.99301 .20095 L
.99401 .20095 L
.995 .20095 L
.996 .20095 L
.997 .20095 L
.998 .20095 L
Mistroke
.999 .2018 L
Mfstroke
1 0 0 r
gsave
.999 .18767 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .28327 m
.001 .28327 L
.002 .28327 L
.003 .28327 L
.004 .28327 L
.005 .28327 L
.00599 .28327 L
.00699 .28327 L
.00799 .28327 L
.00899 .28327 L
.00999 .28327 L
.01099 .28327 L
.01199 .28327 L
.01299 .28327 L
.01399 .28327 L
.01499 .28327 L
.01598 .28327 L
.01698 .28327 L
.01798 .28327 L
.01898 .28327 L
.01998 .28327 L
.02098 .28327 L
.02198 .28327 L
.02298 .28327 L
.02398 .28327 L
.02498 .28327 L
.02597 .28327 L
.02697 .28327 L
.02797 .28327 L
.02897 .28327 L
.02997 .28327 L
.03097 .28327 L
.03197 .28327 L
.03297 .28327 L
.03397 .28327 L
.03497 .28327 L
.03596 .28327 L
.03696 .28327 L
.03796 .28327 L
.03896 .28327 L
.03996 .28327 L
.04096 .28327 L
.04196 .28327 L
.04296 .28327 L
.04396 .28327 L
.04496 .28327 L
.04595 .28327 L
.04695 .28327 L
.04795 .28327 L
.04895 .28327 L
Mistroke
.04995 .28389 L
.05095 .28389 L
.05195 .28389 L
.05295 .28389 L
.05395 .28389 L
.05495 .28389 L
.05594 .28389 L
.05694 .28389 L
.05794 .28389 L
.05894 .28389 L
.05994 .28389 L
.06094 .28389 L
.06194 .28389 L
.06294 .28389 L
.06394 .28389 L
.06494 .28389 L
.06593 .28389 L
.06693 .28389 L
.06793 .28389 L
.06893 .28389 L
.06993 .28389 L
.07093 .28389 L
.07193 .28389 L
.07293 .28389 L
.07393 .28389 L
.07493 .28389 L
.07592 .28389 L
.07692 .28389 L
.07792 .28389 L
.07892 .28389 L
.07992 .28389 L
.08092 .28389 L
.08192 .28389 L
.08292 .28389 L
.08392 .28389 L
.08492 .28389 L
.08591 .28389 L
.08691 .28389 L
.08791 .28389 L
.08891 .28389 L
.08991 .28389 L
.09091 .28389 L
.09191 .28389 L
.09291 .28389 L
.09391 .28389 L
.09491 .28389 L
.0959 .28389 L
.0969 .28389 L
.0979 .28389 L
.0989 .28389 L
Mistroke
.0999 .21437 L
.1009 .21437 L
.1019 .21437 L
.1029 .21437 L
.1039 .21437 L
.1049 .21437 L
.10589 .21437 L
.10689 .21437 L
.10789 .21437 L
.10889 .21437 L
.10989 .21437 L
.11089 .21437 L
.11189 .21437 L
.11289 .21437 L
.11389 .21437 L
.11489 .21437 L
.11588 .21437 L
.11688 .21437 L
.11788 .21437 L
.11888 .21437 L
.11988 .21437 L
.12088 .21437 L
.12188 .21437 L
.12288 .21437 L
.12388 .21437 L
.12488 .21437 L
.12587 .21437 L
.12687 .21437 L
.12787 .21437 L
.12887 .21437 L
.12987 .21437 L
.13087 .21437 L
.13187 .21437 L
.13287 .21437 L
.13387 .21437 L
.13487 .21437 L
.13586 .21437 L
.13686 .21437 L
.13786 .21437 L
.13886 .21437 L
.13986 .21437 L
.14086 .21437 L
.14186 .21437 L
.14286 .21437 L
.14386 .21437 L
.14486 .21437 L
.14585 .21437 L
.14685 .21437 L
.14785 .21437 L
.14885 .21437 L
Mistroke
.14985 .24514 L
.15085 .24514 L
.15185 .24514 L
.15285 .24514 L
.15385 .24514 L
.15485 .24514 L
.15584 .24514 L
.15684 .24514 L
.15784 .24514 L
.15884 .24514 L
.15984 .24514 L
.16084 .24514 L
.16184 .24514 L
.16284 .24514 L
.16384 .24514 L
.16484 .24514 L
.16583 .24514 L
.16683 .24514 L
.16783 .24514 L
.16883 .24514 L
.16983 .24514 L
.17083 .24514 L
.17183 .24514 L
.17283 .24514 L
.17383 .24514 L
.17483 .24514 L
.17582 .24514 L
.17682 .24514 L
.17782 .24514 L
.17882 .24514 L
.17982 .24514 L
.18082 .24514 L
.18182 .24514 L
.18282 .24514 L
.18382 .24514 L
.18482 .24514 L
.18581 .24514 L
.18681 .24514 L
.18781 .24514 L
.18881 .24514 L
.18981 .24514 L
.19081 .24514 L
.19181 .24514 L
.19281 .24514 L
.19381 .24514 L
.19481 .24514 L
.1958 .24514 L
.1968 .24514 L
.1978 .24514 L
.1988 .24514 L
Mistroke
.1998 .22101 L
.2008 .22101 L
.2018 .22101 L
.2028 .22101 L
.2038 .22101 L
.2048 .22101 L
.20579 .22101 L
.20679 .22101 L
.20779 .22101 L
.20879 .22101 L
.20979 .22101 L
.21079 .22101 L
.21179 .22101 L
.21279 .22101 L
.21379 .22101 L
.21479 .22101 L
.21578 .22101 L
.21678 .22101 L
.21778 .22101 L
.21878 .22101 L
.21978 .22101 L
.22078 .22101 L
.22178 .22101 L
.22278 .22101 L
.22378 .22101 L
.22478 .22101 L
.22577 .22101 L
.22677 .22101 L
.22777 .22101 L
.22877 .22101 L
.22977 .22101 L
.23077 .22101 L
.23177 .22101 L
.23277 .22101 L
.23377 .22101 L
.23477 .22101 L
.23576 .22101 L
.23676 .22101 L
.23776 .22101 L
.23876 .22101 L
.23976 .22101 L
.24076 .22101 L
.24176 .22101 L
.24276 .22101 L
.24376 .22101 L
.24476 .22101 L
.24575 .22101 L
.24675 .22101 L
.24775 .22101 L
.24875 .22101 L
Mistroke
.24975 .19672 L
.25075 .19672 L
.25175 .19672 L
.25275 .19672 L
.25375 .19672 L
.25475 .19672 L
.25574 .19672 L
.25674 .19672 L
.25774 .19672 L
.25874 .19672 L
.25974 .19672 L
.26074 .19672 L
.26174 .19672 L
.26274 .19672 L
.26374 .19672 L
.26474 .19672 L
.26573 .19672 L
.26673 .19672 L
.26773 .19672 L
.26873 .19672 L
.26973 .19672 L
.27073 .19672 L
.27173 .19672 L
.27273 .19672 L
.27373 .19672 L
.27473 .19672 L
.27572 .19672 L
.27672 .19672 L
.27772 .19672 L
.27872 .19672 L
.27972 .19672 L
.28072 .19672 L
.28172 .19672 L
.28272 .19672 L
.28372 .19672 L
.28472 .19672 L
.28571 .19672 L
.28671 .19672 L
.28771 .19672 L
.28871 .19672 L
.28971 .19672 L
.29071 .19672 L
.29171 .19672 L
.29271 .19672 L
.29371 .19672 L
.29471 .19672 L
.2957 .19672 L
.2967 .19672 L
.2977 .19672 L
.2987 .19672 L
Mistroke
.2997 .19725 L
.3007 .19725 L
.3017 .19725 L
.3027 .19725 L
.3037 .19725 L
.3047 .19725 L
.30569 .19725 L
.30669 .19725 L
.30769 .19725 L
.30869 .19725 L
.30969 .19725 L
.31069 .19725 L
.31169 .19725 L
.31269 .19725 L
.31369 .19725 L
.31469 .19725 L
.31568 .19725 L
.31668 .19725 L
.31768 .19725 L
.31868 .19725 L
.31968 .19725 L
.32068 .19725 L
.32168 .19725 L
.32268 .19725 L
.32368 .19725 L
.32468 .19725 L
.32567 .19725 L
.32667 .19725 L
.32767 .19725 L
.32867 .19725 L
.32967 .19725 L
.33067 .19725 L
.33167 .19725 L
.33267 .19725 L
.33367 .19725 L
.33467 .19725 L
.33566 .19725 L
.33666 .19725 L
.33766 .19725 L
.33866 .19725 L
.33966 .19725 L
.34066 .19725 L
.34166 .19725 L
.34266 .19725 L
.34366 .19725 L
.34466 .19725 L
.34565 .19725 L
.34665 .19725 L
.34765 .19725 L
.34865 .19725 L
Mistroke
.34965 .19477 L
.35065 .19477 L
.35165 .19477 L
.35265 .19477 L
.35365 .19477 L
.35465 .19477 L
.35564 .19477 L
.35664 .19477 L
.35764 .19477 L
.35864 .19477 L
.35964 .19477 L
.36064 .19477 L
.36164 .19477 L
.36264 .19477 L
.36364 .19477 L
.36464 .19477 L
.36563 .19477 L
.36663 .19477 L
.36763 .19477 L
.36863 .19477 L
.36963 .19477 L
.37063 .19477 L
.37163 .19477 L
.37263 .19477 L
.37363 .19477 L
.37463 .19477 L
.37562 .19477 L
.37662 .19477 L
.37762 .19477 L
.37862 .19477 L
.37962 .19477 L
.38062 .19477 L
.38162 .19477 L
.38262 .19477 L
.38362 .19477 L
.38462 .19477 L
.38561 .19477 L
.38661 .19477 L
.38761 .19477 L
.38861 .19477 L
.38961 .19477 L
.39061 .19477 L
.39161 .19477 L
.39261 .19477 L
.39361 .19477 L
.39461 .19477 L
.3956 .19477 L
.3966 .19477 L
.3976 .19477 L
.3986 .19477 L
Mistroke
.3996 .16846 L
.4006 .16846 L
.4016 .16846 L
.4026 .16846 L
.4036 .16846 L
.4046 .16846 L
.40559 .16846 L
.40659 .16846 L
.40759 .16846 L
.40859 .16846 L
.40959 .16846 L
.41059 .16846 L
.41159 .16846 L
.41259 .16846 L
.41359 .16846 L
.41459 .16846 L
.41558 .16846 L
.41658 .16846 L
.41758 .16846 L
.41858 .16846 L
.41958 .16846 L
.42058 .16846 L
.42158 .16846 L
.42258 .16846 L
.42358 .16846 L
.42458 .16846 L
.42557 .16846 L
.42657 .16846 L
.42757 .16846 L
.42857 .16846 L
.42957 .16846 L
.43057 .16846 L
.43157 .16846 L
.43257 .16846 L
.43357 .16846 L
.43457 .16846 L
.43556 .16846 L
.43656 .16846 L
.43756 .16846 L
.43856 .16846 L
.43956 .16846 L
.44056 .16846 L
.44156 .16846 L
.44256 .16846 L
.44356 .16846 L
.44456 .16846 L
.44555 .16846 L
.44655 .16846 L
.44755 .16846 L
.44855 .16846 L
Mistroke
.44955 .16543 L
.45055 .16543 L
.45155 .16543 L
.45255 .16543 L
.45355 .16543 L
.45455 .16543 L
.45554 .16543 L
.45654 .16543 L
.45754 .16543 L
.45854 .16543 L
.45954 .16543 L
.46054 .16543 L
.46154 .16543 L
.46254 .16543 L
.46354 .16543 L
.46454 .16543 L
.46553 .16543 L
.46653 .16543 L
.46753 .16543 L
.46853 .16543 L
.46953 .16543 L
.47053 .16543 L
.47153 .16543 L
.47253 .16543 L
.47353 .16543 L
.47453 .16543 L
.47552 .16543 L
.47652 .16543 L
.47752 .16543 L
.47852 .16543 L
.47952 .16543 L
.48052 .16543 L
.48152 .16543 L
.48252 .16543 L
.48352 .16543 L
.48452 .16543 L
.48551 .16543 L
.48651 .16543 L
.48751 .16543 L
.48851 .16543 L
.48951 .16543 L
.49051 .16543 L
.49151 .16543 L
.49251 .16543 L
.49351 .16543 L
.49451 .16543 L
.4955 .16543 L
.4965 .16543 L
.4975 .16543 L
.4985 .16543 L
Mistroke
.4995 .17446 L
.5005 .17446 L
.5015 .17446 L
.5025 .17446 L
.5035 .17446 L
.5045 .17446 L
.50549 .17446 L
.50649 .17446 L
.50749 .17446 L
.50849 .17446 L
.50949 .17446 L
.51049 .17446 L
.51149 .17446 L
.51249 .17446 L
.51349 .17446 L
.51449 .17446 L
.51548 .17446 L
.51648 .17446 L
.51748 .17446 L
.51848 .17446 L
.51948 .17446 L
.52048 .17446 L
.52148 .17446 L
.52248 .17446 L
.52348 .17446 L
.52448 .17446 L
.52547 .17446 L
.52647 .17446 L
.52747 .17446 L
.52847 .17446 L
.52947 .17446 L
.53047 .17446 L
.53147 .17446 L
.53247 .17446 L
.53347 .17446 L
.53447 .17446 L
.53546 .17446 L
.53646 .17446 L
.53746 .17446 L
.53846 .17446 L
.53946 .17446 L
.54046 .17446 L
.54146 .17446 L
.54246 .17446 L
.54346 .17446 L
.54446 .17446 L
.54545 .17446 L
.54645 .17446 L
.54745 .17446 L
.54845 .17446 L
Mistroke
.54945 .16925 L
.55045 .16925 L
.55145 .16925 L
.55245 .16925 L
.55345 .16925 L
.55445 .16925 L
.55544 .16925 L
.55644 .16925 L
.55744 .16925 L
.55844 .16925 L
.55944 .16925 L
.56044 .16925 L
.56144 .16925 L
.56244 .16925 L
.56344 .16925 L
.56444 .16925 L
.56543 .16925 L
.56643 .16925 L
.56743 .16925 L
.56843 .16925 L
.56943 .16925 L
.57043 .16925 L
.57143 .16925 L
.57243 .16925 L
.57343 .16925 L
.57443 .16925 L
.57542 .16925 L
.57642 .16925 L
.57742 .16925 L
.57842 .16925 L
.57942 .16925 L
.58042 .16925 L
.58142 .16925 L
.58242 .16925 L
.58342 .16925 L
.58442 .16925 L
.58541 .16925 L
.58641 .16925 L
.58741 .16925 L
.58841 .16925 L
.58941 .16925 L
.59041 .16925 L
.59141 .16925 L
.59241 .16925 L
.59341 .16925 L
.59441 .16925 L
.5954 .16925 L
.5964 .16925 L
.5974 .16925 L
.5984 .16925 L
Mistroke
.5994 .17179 L
.6004 .17179 L
.6014 .17179 L
.6024 .17179 L
.6034 .17179 L
.6044 .17179 L
.60539 .17179 L
.60639 .17179 L
.60739 .17179 L
.60839 .17179 L
.60939 .17179 L
.61039 .17179 L
.61139 .17179 L
.61239 .17179 L
.61339 .17179 L
.61439 .17179 L
.61538 .17179 L
.61638 .17179 L
.61738 .17179 L
.61838 .17179 L
.61938 .17179 L
.62038 .17179 L
.62138 .17179 L
.62238 .17179 L
.62338 .17179 L
.62438 .17179 L
.62537 .17179 L
.62637 .17179 L
.62737 .17179 L
.62837 .17179 L
.62937 .17179 L
.63037 .17179 L
.63137 .17179 L
.63237 .17179 L
.63337 .17179 L
.63437 .17179 L
.63536 .17179 L
.63636 .17179 L
.63736 .17179 L
.63836 .17179 L
.63936 .17179 L
.64036 .17179 L
.64136 .17179 L
.64236 .17179 L
.64336 .17179 L
.64436 .17179 L
.64535 .17179 L
.64635 .17179 L
.64735 .17179 L
.64835 .17179 L
Mistroke
.64935 .17231 L
.65035 .17231 L
.65135 .17231 L
.65235 .17231 L
.65335 .17231 L
.65435 .17231 L
.65534 .17231 L
.65634 .17231 L
.65734 .17231 L
.65834 .17231 L
.65934 .17231 L
.66034 .17231 L
.66134 .17231 L
.66234 .17231 L
.66334 .17231 L
.66434 .17231 L
.66533 .17231 L
.66633 .17231 L
.66733 .17231 L
.66833 .17231 L
.66933 .17231 L
.67033 .17231 L
.67133 .17231 L
.67233 .17231 L
.67333 .17231 L
.67433 .17231 L
.67532 .17231 L
.67632 .17231 L
.67732 .17231 L
.67832 .17231 L
.67932 .17231 L
.68032 .17231 L
.68132 .17231 L
.68232 .17231 L
.68332 .17231 L
.68432 .17231 L
.68531 .17231 L
.68631 .17231 L
.68731 .17231 L
.68831 .17231 L
.68931 .17231 L
.69031 .17231 L
.69131 .17231 L
.69231 .17231 L
.69331 .17231 L
.69431 .17231 L
.6953 .17231 L
.6963 .17231 L
.6973 .17231 L
.6983 .17231 L
Mistroke
.6993 .17214 L
.7003 .17214 L
.7013 .17214 L
.7023 .17214 L
.7033 .17214 L
.7043 .17214 L
.70529 .17214 L
.70629 .17214 L
.70729 .17214 L
.70829 .17214 L
.70929 .17214 L
.71029 .17214 L
.71129 .17214 L
.71229 .17214 L
.71329 .17214 L
.71429 .17214 L
.71528 .17214 L
.71628 .17214 L
.71728 .17214 L
.71828 .17214 L
.71928 .17214 L
.72028 .17214 L
.72128 .17214 L
.72228 .17214 L
.72328 .17214 L
.72428 .17214 L
.72527 .17214 L
.72627 .17214 L
.72727 .17214 L
.72827 .17214 L
.72927 .17214 L
.73027 .17214 L
.73127 .17214 L
.73227 .17214 L
.73327 .17214 L
.73427 .17214 L
.73526 .17214 L
.73626 .17214 L
.73726 .17214 L
.73826 .17214 L
.73926 .17214 L
.74026 .17214 L
.74126 .17214 L
.74226 .17214 L
.74326 .17214 L
.74426 .17214 L
.74525 .17214 L
.74625 .17214 L
.74725 .17214 L
.74825 .17214 L
Mistroke
.74925 .17615 L
.75025 .17615 L
.75125 .17615 L
.75225 .17615 L
.75325 .17615 L
.75425 .17615 L
.75524 .17615 L
.75624 .17615 L
.75724 .17615 L
.75824 .17615 L
.75924 .17615 L
.76024 .17615 L
.76124 .17615 L
.76224 .17615 L
.76324 .17615 L
.76424 .17615 L
.76523 .17615 L
.76623 .17615 L
.76723 .17615 L
.76823 .17615 L
.76923 .17615 L
.77023 .17615 L
.77123 .17615 L
.77223 .17615 L
.77323 .17615 L
.77423 .17615 L
.77522 .17615 L
.77622 .17615 L
.77722 .17615 L
.77822 .17615 L
.77922 .17615 L
.78022 .17615 L
.78122 .17615 L
.78222 .17615 L
.78322 .17615 L
.78422 .17615 L
.78521 .17615 L
.78621 .17615 L
.78721 .17615 L
.78821 .17615 L
.78921 .17615 L
.79021 .17615 L
.79121 .17615 L
.79221 .17615 L
.79321 .17615 L
.79421 .17615 L
.7952 .17615 L
.7962 .17615 L
.7972 .17615 L
.7982 .17615 L
Mistroke
.7992 .17797 L
.8002 .17797 L
.8012 .17797 L
.8022 .17797 L
.8032 .17797 L
.8042 .17797 L
.80519 .17797 L
.80619 .17797 L
.80719 .17797 L
.80819 .17797 L
.80919 .17797 L
.81019 .17797 L
.81119 .17797 L
.81219 .17797 L
.81319 .17797 L
.81419 .17797 L
.81518 .17797 L
.81618 .17797 L
.81718 .17797 L
.81818 .17797 L
.81918 .17797 L
.82018 .17797 L
.82118 .17797 L
.82218 .17797 L
.82318 .17797 L
.82418 .17797 L
.82517 .17797 L
.82617 .17797 L
.82717 .17797 L
.82817 .17797 L
.82917 .17797 L
.83017 .17797 L
.83117 .17797 L
.83217 .17797 L
.83317 .17797 L
.83417 .17797 L
.83516 .17797 L
.83616 .17797 L
.83716 .17797 L
.83816 .17797 L
.83916 .17797 L
.84016 .17797 L
.84116 .17797 L
.84216 .17797 L
.84316 .17797 L
.84416 .17797 L
.84515 .17797 L
.84615 .17797 L
.84715 .17797 L
.84815 .17797 L
Mistroke
.84915 .18106 L
.85015 .18106 L
.85115 .18106 L
.85215 .18106 L
.85315 .18106 L
.85415 .18106 L
.85514 .18106 L
.85614 .18106 L
.85714 .18106 L
.85814 .18106 L
.85914 .18106 L
.86014 .18106 L
.86114 .18106 L
.86214 .18106 L
.86314 .18106 L
.86414 .18106 L
.86513 .18106 L
.86613 .18106 L
.86713 .18106 L
.86813 .18106 L
.86913 .18106 L
.87013 .18106 L
.87113 .18106 L
.87213 .18106 L
.87313 .18106 L
.87413 .18106 L
.87512 .18106 L
.87612 .18106 L
.87712 .18106 L
.87812 .18106 L
.87912 .18106 L
.88012 .18106 L
.88112 .18106 L
.88212 .18106 L
.88312 .18106 L
.88412 .18106 L
.88511 .18106 L
.88611 .18106 L
.88711 .18106 L
.88811 .18106 L
.88911 .18106 L
.89011 .18106 L
.89111 .18106 L
.89211 .18106 L
.89311 .18106 L
.89411 .18106 L
.8951 .18106 L
.8961 .18106 L
.8971 .18106 L
.8981 .18106 L
Mistroke
.8991 .18483 L
.9001 .18483 L
.9011 .18483 L
.9021 .18483 L
.9031 .18483 L
.9041 .18483 L
.90509 .18483 L
.90609 .18483 L
.90709 .18483 L
.90809 .18483 L
.90909 .18483 L
.91009 .18483 L
.91109 .18483 L
.91209 .18483 L
.91309 .18483 L
.91409 .18483 L
.91508 .18483 L
.91608 .18483 L
.91708 .18483 L
.91808 .18483 L
.91908 .18483 L
.92008 .18483 L
.92108 .18483 L
.92208 .18483 L
.92308 .18483 L
.92408 .18483 L
.92507 .18483 L
.92607 .18483 L
.92707 .18483 L
.92807 .18483 L
.92907 .18483 L
.93007 .18483 L
.93107 .18483 L
.93207 .18483 L
.93307 .18483 L
.93407 .18483 L
.93506 .18483 L
.93606 .18483 L
.93706 .18483 L
.93806 .18483 L
.93906 .18483 L
.94006 .18483 L
.94106 .18483 L
.94206 .18483 L
.94306 .18483 L
.94406 .18483 L
.94505 .18483 L
.94605 .18483 L
.94705 .18483 L
.94805 .18483 L
Mistroke
.94905 .18672 L
.95005 .18672 L
.95105 .18672 L
.95205 .18672 L
.95305 .18672 L
.95405 .18672 L
.95504 .18672 L
.95604 .18672 L
.95704 .18672 L
.95804 .18672 L
.95904 .18672 L
.96004 .18672 L
.96104 .18672 L
.96204 .18672 L
.96304 .18672 L
.96404 .18672 L
.96503 .18672 L
.96603 .18672 L
.96703 .18672 L
.96803 .18672 L
.96903 .18672 L
.97003 .18672 L
.97103 .18672 L
.97203 .18672 L
.97303 .18672 L
.97403 .18672 L
.97502 .18672 L
.97602 .18672 L
.97702 .18672 L
.97802 .18672 L
.97902 .18672 L
.98002 .18672 L
.98102 .18672 L
.98202 .18672 L
.98302 .18672 L
.98402 .18672 L
.98501 .18672 L
.98601 .18672 L
.98701 .18672 L
.98801 .18672 L
.98901 .18672 L
.99001 .18672 L
.99101 .18672 L
.99201 .18672 L
.99301 .18672 L
.99401 .18672 L
.995 .18672 L
.996 .18672 L
.997 .18672 L
.998 .18672 L
Mistroke
.999 .18767 L
Mfstroke
0 0 1 r
gsave
.001 -0.38627 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .30618 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .34801 L
.005 .34586 L
.00599 .34349 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33051 L
.01099 .32609 L
.01199 .32108 L
.01299 .31539 L
.01399 .30894 L
.01499 .30165 L
.01598 .2934 L
.01698 .28409 L
.01798 .27359 L
.01898 .26176 L
.01998 .24843 L
.02098 .23343 L
.02198 .21658 L
.02298 .19765 L
.02398 .17642 L
.02498 .15263 L
.02597 .12603 L
.02697 .09634 L
.02797 .06327 L
.02897 .02656 L
s
.02897 .02656 m
.02962 0 L
s
.04995 .10152 m
.05095 .08876 L
.05195 .08209 L
.05295 .08154 L
.05395 .08722 L
.05495 .0988 L
.05594 .11543 L
.05694 .13596 L
.05794 .15921 L
.05894 .18403 L
.05994 .20939 L
.06094 .23434 L
.06194 .25816 L
.06294 .28034 L
.06394 .3006 L
.06494 .31886 L
.06593 .33519 L
.06693 .34977 L
.06793 .36285 L
.06893 .37469 L
.06993 .38558 L
.07093 .39579 L
.07193 .40554 L
.07293 .41502 L
.07393 .42433 L
.07493 .43347 L
.07592 .44232 L
.07692 .45051 L
.07792 .45739 L
.07892 .46199 L
.07992 .46333 L
.08092 .46101 L
.08192 .45544 L
.08292 .44742 L
.08392 .43773 L
.08492 .427 L
.08591 .41575 L
.08691 .40443 L
.08791 .3934 L
.08891 .38301 L
.08991 .37353 L
.09091 .36522 L
.09191 .35825 L
.09291 .35277 L
.09391 .34886 L
.09491 .34656 L
.0959 .34585 L
.0969 .34668 L
.0979 .34895 L
.0989 .35252 L
Mistroke
.0999 .39922 L
.1009 .39383 L
.1019 .39047 L
.1029 .3881 L
.1039 .38633 L
.1049 .38501 L
.10589 .38401 L
.10689 .38328 L
.10789 .38275 L
.10889 .3824 L
.10989 .38221 L
.11089 .38217 L
.11189 .38225 L
.11289 .38246 L
.11389 .38278 L
.11489 .38323 L
.11588 .3838 L
.11688 .3845 L
.11788 .38533 L
.11888 .38631 L
.11988 .38746 L
.12088 .38879 L
.12188 .39033 L
.12288 .39211 L
.12388 .39418 L
.12488 .39658 L
.12587 .39937 L
.12687 .40263 L
.12787 .40643 L
.12887 .41087 L
.12987 .41605 L
.13087 .42209 L
.13187 .4291 L
.13287 .43719 L
.13387 .44644 L
.13487 .45689 L
.13586 .46849 L
.13686 .48102 L
.13786 .494 L
.13886 .50644 L
.13986 .51648 L
.14086 .52117 L
.14186 .51769 L
.14286 .50607 L
.14386 .48866 L
.14486 .46796 L
.14585 .44587 L
.14685 .42382 L
.14785 .40291 L
.14885 .38394 L
Mistroke
.14985 .5555 L
.15085 .53804 L
.15185 .52118 L
.15285 .50436 L
.15385 .4877 L
.15485 .4714 L
.15584 .4557 L
.15684 .44081 L
.15784 .42686 L
.15884 .41394 L
.15984 .40209 L
.16084 .39128 L
.16184 .38147 L
.16284 .37259 L
.16384 .36457 L
.16484 .35731 L
.16583 .35071 L
.16683 .34469 L
.16783 .33917 L
.16883 .33405 L
.16983 .32925 L
.17083 .3247 L
.17183 .32034 L
.17283 .31608 L
.17383 .31187 L
.17483 .30766 L
.17582 .30337 L
.17682 .29897 L
.17782 .29439 L
.17882 .28958 L
.17982 .28451 L
.18082 .27911 L
.18182 .27334 L
.18282 .26715 L
.18382 .26051 L
.18482 .25335 L
.18581 .24564 L
.18681 .23734 L
.18781 .22839 L
.18881 .21876 L
.18981 .20841 L
.19081 .19733 L
.19181 .18548 L
.19281 .17286 L
.19381 .15948 L
.19481 .14538 L
.1958 .13063 L
.1968 .11533 L
.1978 .09963 L
.1988 .08375 L
Mistroke
.1998 .27763 L
.2008 .26448 L
.2018 .25311 L
.2028 .24242 L
.2038 .23206 L
.2048 .2219 L
.20579 .21192 L
.20679 .20215 L
.20779 .19269 L
.20879 .1837 L
.20979 .17536 L
.21079 .1679 L
.21179 .16156 L
.21279 .15659 L
.21379 .15319 L
.21479 .15154 L
.21578 .1517 L
.21678 .15364 L
.21778 .15722 L
.21878 .16222 L
.21978 .16838 L
.22078 .17548 L
.22178 .18338 L
.22278 .19196 L
.22378 .20112 L
.22478 .21074 L
.22577 .22066 L
.22677 .23071 L
.22777 .2407 L
.22877 .25046 L
.22977 .25984 L
.23077 .26871 L
.23177 .27697 L
.23277 .28454 L
.23377 .2914 L
.23477 .29753 L
.23576 .30292 L
.23676 .30761 L
.23776 .31162 L
.23876 .31499 L
.23976 .31777 L
.24076 .31999 L
.24176 .32172 L
.24276 .32298 L
.24376 .32381 L
.24476 .32426 L
.24575 .32435 L
.24675 .32412 L
.24775 .32358 L
.24875 .32275 L
Mistroke
.24975 .44523 L
.25075 .44275 L
.25175 .44216 L
.25275 .44243 L
.25375 .44321 L
.25475 .44434 L
.25574 .44572 L
.25674 .44728 L
.25774 .44899 L
.25874 .45081 L
.25974 .45272 L
.26074 .45469 L
.26174 .45671 L
.26274 .45875 L
.26374 .46079 L
.26474 .46282 L
.26573 .46481 L
.26673 .46672 L
.26773 .46852 L
.26873 .47019 L
.26973 .47166 L
.27073 .47289 L
.27173 .47383 L
.27273 .47439 L
.27373 .47453 L
.27473 .47416 L
.27572 .47323 L
.27672 .47167 L
.27772 .46946 L
.27872 .46659 L
.27972 .46307 L
.28072 .45896 L
.28172 .45434 L
.28272 .4493 L
.28372 .44395 L
.28472 .43841 L
.28571 .43279 L
.28671 .42717 L
.28771 .42165 L
.28871 .41631 L
.28971 .41118 L
.29071 .40633 L
.29171 .40176 L
.29271 .39751 L
.29371 .39358 L
.29471 .38997 L
.2957 .38667 L
.2967 .38367 L
.2977 .38096 L
.2987 .37851 L
Mistroke
.2997 .41527 L
.3007 .41065 L
.3017 .40797 L
.3027 .40619 L
.3037 .40499 L
.3047 .40421 L
.30569 .40374 L
.30669 .40353 L
.30769 .40355 L
.30869 .40376 L
.30969 .40416 L
.31069 .40474 L
.31169 .40548 L
.31269 .4064 L
.31369 .40748 L
.31469 .40874 L
.31568 .41018 L
.31668 .41181 L
.31768 .41364 L
.31868 .41568 L
.31968 .41794 L
.32068 .42045 L
.32168 .42322 L
.32268 .42626 L
.32368 .42959 L
.32468 .43324 L
.32567 .43722 L
.32667 .44153 L
.32767 .44619 L
.32867 .45118 L
.32967 .45646 L
.33067 .462 L
.33167 .46769 L
.33267 .47338 L
.33367 .47887 L
.33467 .48384 L
.33566 .48792 L
.33666 .49062 L
.33766 .49144 L
.33866 .49003 L
.33966 .48626 L
.34066 .48031 L
.34166 .47257 L
.34266 .46351 L
.34366 .45361 L
.34466 .4433 L
.34565 .43296 L
.34665 .42287 L
.34765 .41328 L
.34865 .40432 L
Mistroke
.34965 .50759 L
.35065 .4978 L
.35165 .48913 L
.35265 .48075 L
.35365 .47244 L
.35465 .46418 L
.35564 .45599 L
.35664 .44794 L
.35764 .44007 L
.35864 .43246 L
.35964 .42514 L
.36064 .41817 L
.36164 .41158 L
.36264 .40539 L
.36364 .39959 L
.36464 .39421 L
.36563 .38922 L
.36663 .38461 L
.36763 .38037 L
.36863 .37648 L
.36963 .37289 L
.37063 .3696 L
.37163 .36657 L
.37263 .36378 L
.37363 .36119 L
.37463 .35878 L
.37562 .35652 L
.37662 .35439 L
.37762 .35236 L
.37862 .35042 L
.37962 .34853 L
.38062 .34668 L
.38162 .34484 L
.38262 .34301 L
.38362 .34116 L
.38462 .33927 L
.38561 .33734 L
.38661 .33534 L
.38761 .33327 L
.38861 .33112 L
.38961 .32887 L
.39061 .32653 L
.39161 .32408 L
.39261 .32154 L
.39361 .31889 L
.39461 .31616 L
.3956 .31336 L
.3966 .31051 L
.3976 .30765 L
.3986 .30482 L
Mistroke
.3996 .31775 L
.4006 .31198 L
.4016 .30741 L
.4026 .30301 L
.4036 .29843 L
.4046 .29354 L
.40559 .28825 L
.40659 .2825 L
.40759 .27626 L
.40859 .2695 L
.40959 .2622 L
.41059 .25435 L
.41159 .24596 L
.41259 .23705 L
.41359 .22766 L
.41459 .21785 L
.41558 .20772 L
.41658 .19739 L
.41758 .18702 L
.41858 .17684 L
.41958 .16711 L
.42058 .15811 L
.42158 .15019 L
.42258 .14369 L
.42358 .13893 L
.42458 .13612 L
.42557 .13531 L
.42657 .13619 L
.42757 .13802 L
.42857 .13979 L
.42957 .14088 L
.43057 .14167 L
.43157 .14313 L
.43257 .14611 L
.43357 .15114 L
.43457 .15843 L
.43556 .1679 L
.43656 .17927 L
.43756 .19216 L
.43856 .20609 L
.43956 .2206 L
.44056 .23525 L
.44156 .24966 L
.44256 .26353 L
.44356 .27664 L
.44456 .28883 L
.44555 .30002 L
.44655 .31018 L
.44755 .31931 L
.44855 .32747 L
Mistroke
.44955 .39633 L
.45055 .39674 L
.45155 .39825 L
.45255 .39999 L
.45355 .40171 L
.45455 .40329 L
.45554 .4047 L
.45654 .40592 L
.45754 .40697 L
.45854 .40785 L
.45954 .40859 L
.46054 .40921 L
.46154 .40972 L
.46254 .41015 L
.46354 .41051 L
.46454 .41084 L
.46553 .41114 L
.46653 .41143 L
.46753 .41173 L
.46853 .41205 L
.46953 .4124 L
.47053 .4128 L
.47153 .41325 L
.47253 .41376 L
.47353 .41434 L
.47453 .415 L
.47552 .41574 L
.47652 .41657 L
.47752 .41749 L
.47852 .4185 L
.47952 .4196 L
.48052 .42079 L
.48152 .42208 L
.48252 .42345 L
.48352 .4249 L
.48452 .42642 L
.48551 .42799 L
.48651 .42959 L
.48751 .43121 L
.48851 .4328 L
.48951 .43435 L
.49051 .4358 L
.49151 .43712 L
.49251 .43826 L
.49351 .43917 L
.49451 .4398 L
.4955 .44011 L
.4965 .44007 L
.4975 .43963 L
.4985 .4388 L
Mistroke
.4995 .53646 L
.5005 .52504 L
.5015 .51442 L
.5025 .50374 L
.5035 .49285 L
.5045 .48176 L
.50549 .47057 L
.50649 .45941 L
.50749 .4484 L
.50849 .43768 L
.50949 .42733 L
.51049 .41746 L
.51149 .40812 L
.51249 .39934 L
.51349 .39115 L
.51449 .38355 L
.51548 .37652 L
.51648 .37004 L
.51748 .36407 L
.51848 .35858 L
.51948 .35353 L
.52048 .34886 L
.52148 .34455 L
.52248 .34053 L
.52348 .33677 L
.52448 .33322 L
.52547 .32983 L
.52647 .32658 L
.52747 .32342 L
.52847 .3203 L
.52947 .31721 L
.53047 .31409 L
.53147 .31092 L
.53247 .30766 L
.53347 .30429 L
.53447 .30076 L
.53546 .29706 L
.53646 .29314 L
.53746 .28897 L
.53846 .28453 L
.53946 .27978 L
.54046 .27469 L
.54146 .26922 L
.54246 .26333 L
.54346 .25699 L
.54446 .25015 L
.54545 .24278 L
.54645 .23484 L
.54745 .22627 L
.54845 .21704 L
Mistroke
.54945 .40634 L
.55045 .40707 L
.55145 .40956 L
.55245 .41281 L
.55345 .41655 L
.55445 .42067 L
.55544 .42512 L
.55644 .42988 L
.55744 .43495 L
.55844 .44034 L
.55944 .44605 L
.56044 .45209 L
.56144 .45846 L
.56244 .46515 L
.56344 .47216 L
.56444 .47946 L
.56543 .48702 L
.56643 .49476 L
.56743 .50259 L
.56843 .51035 L
.56943 .51785 L
.57043 .52478 L
.57143 .53072 L
.57243 .5351 L
.57343 .53716 L
.57443 .53605 L
.57542 .53105 L
.57642 .52201 L
.57742 .5094 L
.57842 .49408 L
.57942 .47697 L
.58042 .45893 L
.58142 .44068 L
.58242 .42279 L
.58342 .40568 L
.58442 .3896 L
.58541 .37473 L
.58641 .36113 L
.58741 .34877 L
.58841 .3376 L
.58941 .32754 L
.59041 .31849 L
.59141 .31035 L
.59241 .30302 L
.59341 .29641 L
.59441 .29044 L
.5954 .28503 L
.5964 .28012 L
.5974 .27565 L
.5984 .27156 L
Mistroke
.5994 .33141 L
.6004 .32228 L
.6014 .3152 L
.6024 .30915 L
.6034 .30375 L
.6044 .29879 L
.60539 .29413 L
.60639 .28967 L
.60739 .28535 L
.60839 .2811 L
.60939 .27689 L
.61039 .27269 L
.61139 .26846 L
.61239 .2642 L
.61339 .2599 L
.61439 .25555 L
.61538 .25116 L
.61638 .24673 L
.61738 .24229 L
.61838 .23785 L
.61938 .23344 L
.62038 .2291 L
.62138 .22487 L
.62238 .22078 L
.62338 .21688 L
.62438 .21323 L
.62537 .20987 L
.62637 .20684 L
.62737 .20419 L
.62837 .20193 L
.62937 .20009 L
.63037 .19866 L
.63137 .19761 L
.63237 .19688 L
.63337 .19643 L
.63437 .19617 L
.63536 .19605 L
.63636 .19604 L
.63736 .19613 L
.63836 .19637 L
.63936 .19681 L
.64036 .19753 L
.64136 .19861 L
.64236 .20009 L
.64336 .20202 L
.64436 .2044 L
.64535 .20722 L
.64635 .21045 L
.64735 .21402 L
.64835 .21788 L
Mistroke
.64935 .31977 L
.65035 .31467 L
.65135 .31114 L
.65235 .30817 L
.65335 .30543 L
.65435 .30276 L
.65534 .30006 L
.65634 .29727 L
.65734 .29434 L
.65834 .29126 L
.65934 .28799 L
.66034 .28452 L
.66134 .28083 L
.66234 .27693 L
.66334 .2728 L
.66434 .26845 L
.66533 .26386 L
.66633 .25906 L
.66733 .25404 L
.66833 .24882 L
.66933 .24342 L
.67033 .23788 L
.67133 .23222 L
.67233 .2265 L
.67333 .22077 L
.67433 .21509 L
.67532 .20954 L
.67632 .2042 L
.67732 .19917 L
.67832 .19455 L
.67932 .19043 L
.68032 .18691 L
.68132 .18404 L
.68232 .18187 L
.68332 .18037 L
.68432 .17947 L
.68531 .17897 L
.68631 .17863 L
.68731 .17816 L
.68831 .17735 L
.68931 .17616 L
.69031 .17477 L
.69131 .17348 L
.69231 .17263 L
.69331 .17253 L
.69431 .17338 L
.6953 .17534 L
.6963 .17844 L
.6973 .18266 L
.6983 .1879 L
Mistroke
.6993 .28613 L
.7003 .28796 L
.7013 .29123 L
.7023 .29493 L
.7033 .29869 L
.7043 .30234 L
.70529 .30577 L
.70629 .30892 L
.70729 .31174 L
.70829 .31423 L
.70929 .31636 L
.71029 .31815 L
.71129 .3196 L
.71229 .32073 L
.71329 .32154 L
.71429 .32206 L
.71528 .32229 L
.71628 .32225 L
.71728 .32196 L
.71828 .32142 L
.71928 .32064 L
.72028 .31963 L
.72128 .31839 L
.72228 .31692 L
.72328 .31523 L
.72428 .31329 L
.72527 .31112 L
.72627 .30871 L
.72727 .30603 L
.72827 .30308 L
.72927 .29985 L
.73027 .29631 L
.73127 .29245 L
.73227 .28824 L
.73327 .28366 L
.73427 .27867 L
.73526 .27325 L
.73626 .26737 L
.73726 .26099 L
.73826 .25406 L
.73926 .24655 L
.74026 .23842 L
.74126 .2296 L
.74226 .22006 L
.74326 .20974 L
.74426 .19858 L
.74525 .18653 L
.74625 .17353 L
.74725 .15953 L
.74825 .14448 L
Mistroke
.74925 .25376 L
.75025 .23978 L
.75125 .22708 L
.75225 .21466 L
.75325 .20229 L
.75425 .19 L
.75524 .17791 L
.75624 .16628 L
.75724 .15542 L
.75824 .14573 L
.75924 .13766 L
.76024 .13165 L
.76124 .12813 L
.76224 .1274 L
.76324 .12961 L
.76424 .13467 L
.76523 .14234 L
.76623 .15223 L
.76723 .16398 L
.76823 .17729 L
.76923 .19188 L
.77023 .20744 L
.77123 .22361 L
.77223 .24001 L
.77323 .25629 L
.77423 .27211 L
.77522 .28722 L
.77622 .30141 L
.77722 .31456 L
.77822 .32661 L
.77922 .33754 L
.78022 .34739 L
.78122 .3562 L
.78222 .36404 L
.78322 .37101 L
.78422 .37718 L
.78521 .38266 L
.78621 .38752 L
.78721 .39186 L
.78821 .39573 L
.78921 .39922 L
.79021 .40237 L
.79121 .40524 L
.79221 .40786 L
.79321 .41027 L
.79421 .41248 L
.7952 .4145 L
.7962 .41633 L
.7972 .41797 L
.7982 .41941 L
Mistroke
.7992 .46579 L
.8002 .46374 L
.8012 .46318 L
.8022 .46311 L
.8032 .46319 L
.8042 .46329 L
.80519 .46332 L
.80619 .46322 L
.80719 .46295 L
.80819 .46251 L
.80919 .46186 L
.81019 .46102 L
.81119 .45997 L
.81219 .45872 L
.81319 .45727 L
.81419 .45564 L
.81518 .45383 L
.81618 .45185 L
.81718 .44972 L
.81818 .44745 L
.81918 .44506 L
.82018 .44256 L
.82118 .43998 L
.82218 .43733 L
.82318 .43463 L
.82418 .43191 L
.82517 .42918 L
.82617 .42647 L
.82717 .42379 L
.82817 .42117 L
.82917 .41861 L
.83017 .41614 L
.83117 .41377 L
.83217 .41151 L
.83317 .40938 L
.83417 .40738 L
.83516 .40552 L
.83616 .40381 L
.83716 .40225 L
.83816 .40084 L
.83916 .39959 L
.84016 .39851 L
.84116 .39759 L
.84216 .39682 L
.84316 .39623 L
.84416 .3958 L
.84515 .39554 L
.84615 .39544 L
.84715 .39552 L
.84815 .39576 L
Mistroke
.84915 .50255 L
.85015 .49828 L
.85115 .49539 L
.85215 .49283 L
.85315 .49027 L
.85415 .48753 L
.85514 .48453 L
.85614 .48122 L
.85714 .47759 L
.85814 .47364 L
.85914 .46939 L
.86014 .46488 L
.86114 .46016 L
.86214 .45525 L
.86314 .45023 L
.86414 .44514 L
.86513 .44004 L
.86613 .43497 L
.86713 .42997 L
.86813 .4251 L
.86913 .42038 L
.87013 .41584 L
.87113 .41151 L
.87213 .4074 L
.87313 .40353 L
.87413 .3999 L
.87512 .39652 L
.87612 .39339 L
.87712 .39049 L
.87812 .38784 L
.87912 .38541 L
.88012 .3832 L
.88112 .3812 L
.88212 .3794 L
.88312 .37779 L
.88412 .37636 L
.88511 .37509 L
.88611 .37399 L
.88711 .37303 L
.88811 .37223 L
.88911 .37157 L
.89011 .37104 L
.89111 .37065 L
.89211 .37041 L
.89311 .3703 L
.89411 .37035 L
.8951 .37055 L
.8961 .37092 L
.8971 .37149 L
.8981 .37225 L
Mistroke
.8991 .45087 L
.9001 .45158 L
.9011 .45446 L
.9021 .45843 L
.9031 .46313 L
.9041 .46837 L
.90509 .47402 L
.90609 .47998 L
.90709 .48616 L
.90809 .49246 L
.90909 .49878 L
.91009 .505 L
.91109 .51099 L
.91209 .51657 L
.91309 .52157 L
.91409 .52576 L
.91508 .52889 L
.91608 .53067 L
.91708 .53079 L
.91808 .52895 L
.91908 .52487 L
.92008 .51841 L
.92108 .50959 L
.92208 .49866 L
.92308 .48602 L
.92408 .47217 L
.92507 .45762 L
.92607 .44284 L
.92707 .4282 L
.92807 .41402 L
.92907 .40051 L
.93007 .38782 L
.93107 .37603 L
.93207 .36515 L
.93307 .35519 L
.93407 .34609 L
.93506 .33781 L
.93606 .33028 L
.93706 .32342 L
.93806 .31717 L
.93906 .31144 L
.94006 .30616 L
.94106 .30127 L
.94206 .2967 L
.94306 .29239 L
.94406 .28828 L
.94505 .28432 L
.94605 .28046 L
.94705 .27666 L
.94805 .27288 L
Mistroke
.94905 .32273 L
.95005 .31708 L
.95105 .31298 L
.95205 .30941 L
.95305 .30601 L
.95405 .30262 L
.95504 .29914 L
.95604 .29551 L
.95704 .29168 L
.95804 .28762 L
.95904 .2833 L
.96004 .27872 L
.96104 .27384 L
.96204 .26867 L
.96304 .2632 L
.96404 .25743 L
.96503 .25138 L
.96603 .24505 L
.96703 .23847 L
.96803 .23168 L
.96903 .22473 L
.97003 .21769 L
.97103 .21063 L
.97203 .20366 L
.97303 .19688 L
.97403 .19043 L
.97502 .18446 L
.97602 .17912 L
.97702 .17454 L
.97802 .17087 L
.97902 .16819 L
.98002 .1665 L
.98102 .1657 L
.98202 .16551 L
.98302 .16552 L
.98402 .16528 L
.98501 .16451 L
.98601 .16332 L
.98701 .16212 L
.98801 .16145 L
.98901 .16176 L
.99001 .16336 L
.99101 .16644 L
.99201 .17102 L
.99301 .17705 L
.99401 .18434 L
.995 .19267 L
.996 .20176 L
.997 .21133 L
.998 .22109 L
Mistroke
.999 .30618 L
Mfstroke
gsave
.999 .32109 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38342 L
.004 .38538 L
.005 .38721 L
.00599 .38905 L
.00699 .39099 L
.00799 .39308 L
.00899 .39539 L
.00999 .39797 L
.01099 .40088 L
.01199 .40416 L
.01299 .40788 L
.01399 .41208 L
.01499 .41684 L
.01598 .42222 L
.01698 .42831 L
.01798 .43517 L
.01898 .44291 L
.01998 .45163 L
.02098 .46144 L
.02198 .47247 L
.02298 .48484 L
.02398 .49871 L
.02498 .51422 L
.02597 .53154 L
.02697 .55082 L
.02797 .57221 L
.02897 .59585 L
s
.02897 .59585 m
.02982 .61803 L
s
.04409 .61803 m
.04496 .40844 L
s
.04995 .11685 m
.05095 .11271 L
.05195 .11124 L
.05295 .11417 L
.05395 .12254 L
.05495 .13703 L
.05594 .15778 L
.05694 .18422 L
.05794 .21504 L
.05894 .2485 L
.05994 .28283 L
.06094 .31651 L
.06194 .34843 L
.06294 .37792 L
.06394 .4046 L
.06494 .42838 L
.06593 .44929 L
.06693 .46748 L
.06793 .48309 L
.06893 .49629 L
.06993 .50725 L
.07093 .51611 L
.07193 .52301 L
.07293 .52808 L
.07393 .53149 L
.07493 .53346 L
.07592 .53431 L
.07692 .53455 L
.07792 .53494 L
.07892 .53656 L
.07992 .54046 L
.08092 .54709 L
.08192 .55608 L
.08292 .56666 L
.08392 .57811 L
.08492 .5898 L
.08591 .60126 L
.08691 .61208 L
s
.08691 .61208 m
.08752 .61803 L
s
.09893 .61803 m
.0999 .41402 L
.1009 .4174 L
.1019 .41939 L
.1029 .421 L
.1039 .42255 L
.1049 .42419 L
.10589 .426 L
.10689 .42804 L
.10789 .43033 L
.10889 .4329 L
.10989 .43577 L
.11089 .43895 L
.11189 .44246 L
.11289 .44631 L
.11389 .45053 L
.11489 .45514 L
.11588 .46015 L
.11688 .46559 L
.11788 .47147 L
.11888 .47781 L
.11988 .48463 L
.12088 .49194 L
.12188 .49975 L
.12288 .50804 L
.12388 .5168 L
.12488 .526 L
.12587 .53558 L
.12687 .54548 L
.12787 .55557 L
.12887 .56572 L
.12987 .57575 L
.13087 .58542 L
.13187 .59447 L
.13287 .60257 L
.13387 .60939 L
.13487 .61455 L
.13586 .61775 L
s
.13586 .61775 m
.13615 .61803 L
s
.13745 .61803 m
.13786 .61754 L
.13886 .61462 L
.13986 .61132 L
.14086 .61014 L
.14186 .61349 L
s
.14186 .61349 m
.14246 .61803 L
s
.14918 .61803 m
.14985 .57045 L
.15085 .56218 L
.15185 .55144 L
.15285 .53945 L
.15385 .52681 L
.15485 .51397 L
.15584 .50128 L
.15684 .48901 L
.15784 .47738 L
.15884 .46653 L
.15984 .45658 L
.16084 .44757 L
.16184 .43954 L
.16284 .43245 L
.16384 .42629 L
.16484 .421 L
.16583 .41652 L
.16683 .41278 L
.16783 .40972 L
.16883 .40726 L
.16983 .40534 L
.17083 .4039 L
.17183 .40289 L
.17283 .40226 L
.17383 .40197 L
.17483 .40198 L
.17582 .40227 L
.17682 .40281 L
.17782 .40359 L
.17882 .40459 L
.17982 .4058 L
.18082 .40721 L
.18182 .40881 L
.18282 .41062 L
.18382 .41261 L
.18482 .4148 L
.18581 .41717 L
.18681 .41973 L
.18781 .42248 L
.18881 .42539 L
.18981 .42846 L
.19081 .43167 L
.19181 .43498 L
.19281 .43834 L
.19381 .44171 L
.19481 .44499 L
.1958 .44808 L
.1968 .45084 L
.1978 .45308 L
Mistroke
.1988 .45458 L
.1998 .29193 L
.2008 .28823 L
.2018 .28283 L
.2028 .27677 L
.2038 .27035 L
.2048 .26372 L
.20579 .257 L
.20679 .25028 L
.20779 .24364 L
.20879 .23718 L
.20979 .23104 L
.21079 .22533 L
.21179 .22023 L
.21279 .2159 L
.21379 .21256 L
.21479 .21043 L
.21578 .20979 L
.21678 .21089 L
.21778 .21399 L
.21878 .21929 L
.21978 .22686 L
.22078 .23657 L
.22178 .24811 L
.22278 .26105 L
.22378 .27488 L
.22478 .28913 L
.22577 .30336 L
.22677 .31725 L
.22777 .33053 L
.22877 .34305 L
.22977 .3547 L
.23077 .36544 L
.23177 .37528 L
.23277 .38426 L
.23377 .39243 L
.23477 .39987 L
.23576 .40666 L
.23676 .41288 L
.23776 .41861 L
.23876 .42393 L
.23976 .42891 L
.24076 .43364 L
.24176 .43817 L
.24276 .44258 L
.24376 .44691 L
.24476 .45124 L
.24575 .45561 L
.24675 .46007 L
.24775 .46469 L
Mistroke
.24875 .46949 L
.24975 .45977 L
.25075 .46631 L
.25175 .47126 L
.25275 .47565 L
.25375 .47981 L
.25475 .4839 L
.25574 .48798 L
.25674 .49211 L
.25774 .49628 L
.25874 .50051 L
.25974 .50477 L
.26074 .50905 L
.26174 .5133 L
.26274 .51748 L
.26374 .52155 L
.26474 .52545 L
.26573 .52912 L
.26673 .53251 L
.26773 .53556 L
.26873 .53822 L
.26973 .54043 L
.27073 .54217 L
.27173 .54341 L
.27273 .54413 L
.27373 .54436 L
.27473 .54411 L
.27572 .54343 L
.27672 .54237 L
.27772 .54098 L
.27872 .53931 L
.27972 .5374 L
.28072 .53528 L
.28172 .53298 L
.28272 .53051 L
.28372 .52788 L
.28472 .5251 L
.28571 .52219 L
.28671 .51918 L
.28771 .5161 L
.28871 .51298 L
.28971 .50987 L
.29071 .5068 L
.29171 .50383 L
.29271 .50099 L
.29371 .49832 L
.29471 .49586 L
.2957 .49363 L
.2967 .49167 L
.2977 .48999 L
Mistroke
.2987 .48862 L
.2997 .42999 L
.3007 .43425 L
.3017 .43701 L
.3027 .43929 L
.3037 .44141 L
.3047 .44353 L
.30569 .44576 L
.30669 .44814 L
.30769 .45072 L
.30869 .45352 L
.30969 .45655 L
.31069 .45984 L
.31169 .46339 L
.31269 .46721 L
.31369 .4713 L
.31469 .47567 L
.31568 .48032 L
.31668 .48523 L
.31768 .4904 L
.31868 .49582 L
.31968 .50146 L
.32068 .5073 L
.32168 .5133 L
.32268 .5194 L
.32368 .52556 L
.32468 .5317 L
.32567 .53774 L
.32667 .54358 L
.32767 .54911 L
.32867 .55423 L
.32967 .55882 L
.33067 .56278 L
.33167 .56601 L
.33267 .56846 L
.33367 .57015 L
.33467 .57115 L
.33566 .57166 L
.33666 .57197 L
.33766 .57238 L
.33866 .57315 L
.33966 .5743 L
.34066 .57562 L
.34166 .57677 L
.34266 .57735 L
.34366 .57706 L
.34466 .57565 L
.34565 .57301 L
.34665 .56911 L
.34765 .56402 L
Mistroke
.34865 .55787 L
.34965 .52242 L
.35065 .52155 L
.35165 .51841 L
.35265 .51407 L
.35365 .50898 L
.35465 .5034 L
.35564 .49755 L
.35664 .4916 L
.35764 .48569 L
.35864 .47992 L
.35964 .4744 L
.36064 .4692 L
.36164 .46437 L
.36264 .45994 L
.36364 .45595 L
.36464 .45242 L
.36563 .44933 L
.36663 .4467 L
.36763 .44451 L
.36863 .44276 L
.36963 .44142 L
.37063 .44049 L
.37163 .43995 L
.37263 .43978 L
.37363 .43997 L
.37463 .44051 L
.37562 .44138 L
.37662 .44259 L
.37762 .44413 L
.37862 .446 L
.37962 .44819 L
.38062 .45071 L
.38162 .45357 L
.38262 .45677 L
.38362 .46034 L
.38462 .46427 L
.38561 .46859 L
.38661 .47332 L
.38761 .47847 L
.38861 .48407 L
.38961 .49014 L
.39061 .4967 L
.39161 .50377 L
.39261 .51138 L
.39361 .51955 L
.39461 .52829 L
.3956 .53761 L
.3966 .54752 L
.3976 .55802 L
Mistroke
.3986 .56909 L
.3996 .33207 L
.4006 .33543 L
.4016 .33653 L
.4026 .33648 L
.4036 .33564 L
.4046 .33421 L
.40559 .33227 L
.40659 .32989 L
.40759 .32711 L
.40859 .32394 L
.40959 .32041 L
.41059 .3165 L
.41159 .31221 L
.41259 .30754 L
.41359 .30247 L
.41459 .29698 L
.41558 .29106 L
.41658 .28469 L
.41758 .27785 L
.41858 .27055 L
.41958 .26279 L
.42058 .2546 L
.42158 .24607 L
.42258 .23732 L
.42358 .22857 L
.42458 .22018 L
.42557 .21271 L
.42657 .20703 L
.42757 .20437 L
.42857 .20614 L
.42957 .21316 L
.43057 .22507 L
.43157 .2407 L
.43257 .25877 L
.43357 .27815 L
.43457 .29791 L
.43556 .31732 L
.43656 .33586 L
.43756 .35317 L
.43856 .36905 L
.43956 .38344 L
.44056 .39637 L
.44156 .40793 L
.44256 .41823 L
.44356 .42741 L
.44456 .43562 L
.44555 .44297 L
.44655 .44958 L
.44755 .45555 L
Mistroke
.44855 .46096 L
.44955 .41147 L
.45055 .42067 L
.45155 .42764 L
.45255 .43339 L
.45355 .43829 L
.45455 .44255 L
.45554 .44632 L
.45654 .4497 L
.45754 .45277 L
.45854 .4556 L
.45954 .45825 L
.46054 .46075 L
.46154 .46315 L
.46254 .46547 L
.46354 .46774 L
.46454 .46998 L
.46553 .47221 L
.46653 .47444 L
.46753 .47668 L
.46853 .47895 L
.46953 .48125 L
.47053 .48357 L
.47153 .48594 L
.47253 .48834 L
.47353 .49077 L
.47453 .49323 L
.47552 .49572 L
.47652 .49822 L
.47752 .50072 L
.47852 .50323 L
.47952 .50571 L
.48052 .50817 L
.48152 .51058 L
.48252 .51294 L
.48352 .51522 L
.48452 .51741 L
.48551 .5195 L
.48651 .52147 L
.48751 .52332 L
.48851 .52504 L
.48951 .52662 L
.49051 .52808 L
.49151 .5294 L
.49251 .53062 L
.49351 .53172 L
.49451 .53274 L
.4955 .53368 L
.4965 .53455 L
.4975 .53536 L
Mistroke
.4985 .5361 L
.4995 .55107 L
.5005 .54865 L
.5015 .54362 L
.5025 .53707 L
.5035 .52946 L
.5045 .52112 L
.50549 .51232 L
.50649 .50329 L
.50749 .49424 L
.50849 .48534 L
.50949 .47673 L
.51049 .46854 L
.51149 .46083 L
.51249 .45368 L
.51349 .44712 L
.51449 .44117 L
.51548 .43583 L
.51648 .43109 L
.51748 .42692 L
.51848 .42331 L
.51948 .42022 L
.52048 .41762 L
.52148 .41547 L
.52248 .41373 L
.52348 .41238 L
.52448 .41138 L
.52547 .4107 L
.52647 .41033 L
.52747 .41022 L
.52847 .41038 L
.52947 .41077 L
.53047 .4114 L
.53147 .41224 L
.53247 .41329 L
.53347 .41455 L
.53447 .41601 L
.53546 .41767 L
.53646 .41955 L
.53746 .42164 L
.53846 .42394 L
.53946 .42648 L
.54046 .42926 L
.54146 .43228 L
.54246 .43558 L
.54346 .43915 L
.54446 .44303 L
.54545 .44722 L
.54645 .45174 L
.54745 .45661 L
Mistroke
.54845 .46186 L
.54945 .42068 L
.55045 .43054 L
.55145 .43873 L
.55245 .44639 L
.55345 .45391 L
.55445 .46152 L
.55544 .46933 L
.55644 .47744 L
.55744 .4859 L
.55844 .49474 L
.55944 .50397 L
.56044 .51355 L
.56144 .52344 L
.56244 .53355 L
.56344 .54375 L
.56444 .55387 L
.56543 .56371 L
.56643 .57299 L
.56743 .58144 L
.56843 .58874 L
.56943 .59458 L
.57043 .59869 L
.57143 .60093 L
.57243 .60131 L
.57343 .60011 L
.57443 .59782 L
.57542 .59492 L
.57642 .59157 L
.57742 .58748 L
.57842 .58222 L
.57942 .57544 L
.58042 .567 L
.58142 .55695 L
.58242 .54552 L
.58342 .53304 L
.58442 .51987 L
.58541 .5064 L
.58641 .49298 L
.58741 .4799 L
.58841 .46741 L
.58941 .45568 L
.59041 .44482 L
.59141 .43489 L
.59241 .42591 L
.59341 .41786 L
.59441 .4107 L
.5954 .40436 L
.5964 .39877 L
.5974 .39385 L
Mistroke
.5984 .38953 L
.5994 .34637 L
.6004 .34611 L
.6014 .34456 L
.6024 .34263 L
.6034 .34059 L
.6044 .33853 L
.60539 .33651 L
.60639 .33453 L
.60739 .3326 L
.60839 .33071 L
.60939 .32885 L
.61039 .32699 L
.61139 .32512 L
.61239 .32323 L
.61339 .32131 L
.61439 .31932 L
.61538 .31728 L
.61638 .31515 L
.61738 .31293 L
.61838 .31062 L
.61938 .3082 L
.62038 .30567 L
.62138 .30303 L
.62238 .30028 L
.62338 .29744 L
.62438 .29451 L
.62537 .29152 L
.62637 .28851 L
.62737 .28553 L
.62837 .28264 L
.62937 .27992 L
.63037 .27747 L
.63137 .27541 L
.63237 .27387 L
.63337 .27299 L
.63437 .27291 L
.63536 .27373 L
.63636 .27551 L
.63736 .27825 L
.63836 .28189 L
.63936 .28633 L
.64036 .29144 L
.64136 .29704 L
.64236 .303 L
.64336 .30914 L
.64436 .31535 L
.64535 .32149 L
.64635 .32748 L
.64735 .33323 L
Mistroke
.64835 .33871 L
.64935 .33455 L
.65035 .33831 L
.65135 .34026 L
.65235 .34139 L
.65335 .34201 L
.65435 .3423 L
.65534 .34232 L
.65634 .34214 L
.65734 .34178 L
.65834 .34126 L
.65934 .3406 L
.66034 .3398 L
.66134 .33887 L
.66234 .33779 L
.66334 .33657 L
.66434 .3352 L
.66533 .33368 L
.66633 .33198 L
.66733 .33011 L
.66833 .32805 L
.66933 .32579 L
.67033 .32331 L
.67133 .32059 L
.67233 .31761 L
.67333 .31437 L
.67433 .31084 L
.67532 .30701 L
.67632 .30287 L
.67732 .29843 L
.67832 .2937 L
.67932 .2887 L
.68032 .28349 L
.68132 .27816 L
.68232 .27285 L
.68332 .26776 L
.68432 .26315 L
.68531 .25939 L
.68631 .25689 L
.68731 .25609 L
.68831 .25733 L
.68931 .2607 L
.69031 .26607 L
.69131 .27313 L
.69231 .28146 L
.69331 .29064 L
.69431 .3003 L
.6953 .31009 L
.6963 .31975 L
.6973 .32904 L
Mistroke
.6983 .33782 L
.6993 .30094 L
.7003 .31169 L
.7013 .32046 L
.7023 .32819 L
.7033 .33514 L
.7043 .34146 L
.70529 .34724 L
.70629 .35253 L
.70729 .35737 L
.70829 .36182 L
.70929 .3659 L
.71029 .36965 L
.71129 .3731 L
.71229 .37628 L
.71329 .37923 L
.71429 .38196 L
.71528 .38451 L
.71628 .3869 L
.71728 .38916 L
.71828 .39132 L
.71928 .39339 L
.72028 .3954 L
.72128 .39737 L
.72228 .39932 L
.72328 .40127 L
.72428 .40325 L
.72527 .40526 L
.72627 .40734 L
.72727 .4095 L
.72827 .41176 L
.72927 .41413 L
.73027 .41664 L
.73127 .41931 L
.73227 .42216 L
.73327 .42521 L
.73427 .42848 L
.73526 .43199 L
.73626 .43576 L
.73726 .43983 L
.73826 .44422 L
.73926 .44895 L
.74026 .45405 L
.74126 .45956 L
.74226 .46549 L
.74326 .47188 L
.74426 .47876 L
.74525 .48616 L
.74625 .49409 L
.74725 .5026 L
Mistroke
.74825 .51168 L
.74925 .26804 L
.75025 .26333 L
.75125 .25648 L
.75225 .2486 L
.75325 .2401 L
.75425 .23124 L
.75524 .22226 L
.75624 .21339 L
.75724 .20488 L
.75824 .19703 L
.75924 .19018 L
.76024 .18471 L
.76124 .18104 L
.76224 .17961 L
.76324 .18091 L
.76424 .18535 L
.76523 .19328 L
.76623 .20478 L
.76723 .21961 L
.76823 .23718 L
.76923 .25669 L
.77023 .27729 L
.77123 .29821 L
.77223 .31879 L
.77323 .33855 L
.77423 .35717 L
.77522 .37445 L
.77622 .3903 L
.77722 .40472 L
.77822 .41773 L
.77922 .42941 L
.78022 .43984 L
.78122 .44912 L
.78222 .45735 L
.78322 .46461 L
.78422 .47099 L
.78521 .47657 L
.78621 .48142 L
.78721 .4856 L
.78821 .48917 L
.78921 .4922 L
.79021 .49473 L
.79121 .49682 L
.79221 .49851 L
.79321 .49986 L
.79421 .50091 L
.7952 .50173 L
.7962 .50235 L
.7972 .50285 L
Mistroke
.7982 .50326 L
.7992 .4804 L
.8002 .48732 L
.8012 .49226 L
.8022 .49623 L
.8032 .49954 L
.8042 .50234 L
.80519 .50473 L
.80619 .50674 L
.80719 .50841 L
.80819 .50976 L
.80919 .51079 L
.81019 .51153 L
.81119 .51197 L
.81219 .51214 L
.81319 .51203 L
.81419 .51168 L
.81518 .51109 L
.81618 .51029 L
.81718 .50931 L
.81818 .50817 L
.81918 .5069 L
.82018 .50553 L
.82118 .50409 L
.82218 .50262 L
.82318 .50113 L
.82418 .49966 L
.82517 .49824 L
.82617 .49687 L
.82717 .49559 L
.82817 .49441 L
.82917 .49334 L
.83017 .4924 L
.83117 .4916 L
.83217 .49094 L
.83317 .49044 L
.83417 .49009 L
.83516 .48991 L
.83616 .48988 L
.83716 .49003 L
.83816 .49034 L
.83916 .49081 L
.84016 .49145 L
.84116 .49225 L
.84216 .49321 L
.84316 .49433 L
.84416 .4956 L
.84515 .49702 L
.84615 .49857 L
.84715 .50027 L
Mistroke
.84815 .50209 L
.84915 .51711 L
.85015 .52182 L
.85115 .52441 L
.85215 .52583 L
.85315 .52639 L
.85415 .52622 L
.85514 .52541 L
.85614 .52403 L
.85714 .52212 L
.85814 .51976 L
.85914 .51701 L
.86014 .51393 L
.86114 .51058 L
.86214 .50704 L
.86314 .50338 L
.86414 .49965 L
.86513 .49592 L
.86613 .49225 L
.86713 .48869 L
.86813 .48528 L
.86913 .48207 L
.87013 .47907 L
.87113 .47633 L
.87213 .47385 L
.87313 .47165 L
.87413 .46975 L
.87512 .46815 L
.87612 .46685 L
.87712 .46585 L
.87812 .46516 L
.87912 .46477 L
.88012 .46467 L
.88112 .46487 L
.88212 .46536 L
.88312 .46613 L
.88412 .46719 L
.88511 .46853 L
.88611 .47014 L
.88711 .47203 L
.88811 .47419 L
.88911 .47662 L
.89011 .47932 L
.89111 .48229 L
.89211 .48552 L
.89311 .48901 L
.89411 .49275 L
.8951 .49674 L
.8961 .50098 L
.8971 .50544 L
Mistroke
.8981 .51011 L
.8991 .46532 L
.9001 .47511 L
.9011 .48364 L
.9021 .49193 L
.9031 .50028 L
.9041 .5088 L
.90509 .5175 L
.90609 .52636 L
.90709 .53528 L
.90809 .54415 L
.90909 .5528 L
.91009 .56104 L
.91109 .56864 L
.91209 .57535 L
.91309 .58092 L
.91409 .58511 L
.91508 .58771 L
.91608 .5886 L
.91708 .58775 L
.91808 .58522 L
.91908 .5812 L
.92008 .57589 L
.92108 .56946 L
.92208 .56205 L
.92308 .55375 L
.92408 .54463 L
.92507 .5348 L
.92607 .52444 L
.92707 .51373 L
.92807 .50289 L
.92907 .49212 L
.93007 .48161 L
.93107 .47153 L
.93207 .46201 L
.93307 .45314 L
.93407 .44499 L
.93506 .43757 L
.93606 .43091 L
.93706 .42497 L
.93806 .41973 L
.93906 .41515 L
.94006 .41118 L
.94106 .40776 L
.94206 .40484 L
.94306 .40237 L
.94406 .4003 L
.94505 .39857 L
.94605 .39715 L
.94705 .39599 L
Mistroke
.94805 .39505 L
.94905 .33738 L
.95005 .34067 L
.95105 .34208 L
.95205 .34264 L
.95305 .34267 L
.95405 .34234 L
.95504 .34173 L
.95604 .34089 L
.95704 .33984 L
.95804 .33861 L
.95904 .3372 L
.96004 .33561 L
.96104 .33384 L
.96204 .33188 L
.96304 .32973 L
.96404 .32737 L
.96503 .32479 L
.96603 .32197 L
.96703 .31889 L
.96803 .31554 L
.96903 .3119 L
.97003 .30793 L
.97103 .30362 L
.97203 .29896 L
.97303 .29392 L
.97403 .2885 L
.97502 .28272 L
.97602 .2766 L
.97702 .2702 L
.97802 .26364 L
.97902 .25709 L
.98002 .25081 L
.98102 .24519 L
.98202 .24077 L
.98302 .23822 L
.98402 .23819 L
.98501 .24112 L
.98601 .24697 L
.98701 .25532 L
.98801 .26556 L
.98901 .27706 L
.99001 .28925 L
.99101 .30164 L
.99201 .31383 L
.99301 .32553 L
.99401 .33651 L
.995 .34665 L
.996 .35589 L
.997 .36423 L
Mistroke
.998 .37173 L
.999 .32109 L
Mfstroke
1 0 0 r
gsave
.999 .31363 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36654 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .36489 L
.00999 .36424 L
.01099 .36349 L
.01199 .36262 L
.01299 .36163 L
.01399 .36051 L
.01499 .35924 L
.01598 .35781 L
.01698 .3562 L
.01798 .35438 L
.01898 .35233 L
.01998 .35003 L
.02098 .34744 L
.02198 .34452 L
.02298 .34125 L
.02398 .33756 L
.02498 .33343 L
.02597 .32879 L
.02697 .32358 L
.02797 .31774 L
.02897 .31121 L
.02997 .3039 L
.03097 .29575 L
.03197 .28667 L
.03297 .27659 L
.03397 .26544 L
.03497 .25316 L
.03596 .23972 L
.03696 .22511 L
.03796 .2094 L
.03896 .19271 L
.03996 .17527 L
.04096 .15744 L
.04196 .13976 L
.04296 .12293 L
.04396 .10788 L
.04496 .09567 L
.04595 .0875 L
.04695 .08454 L
.04795 .08777 L
.04895 .09779 L
Mistroke
.04995 .10918 L
.05095 .10073 L
.05195 .09667 L
.05295 .09786 L
.05395 .10488 L
.05495 .11792 L
.05594 .13661 L
.05694 .16009 L
.05794 .18712 L
.05894 .21627 L
.05994 .24611 L
.06094 .27542 L
.06194 .3033 L
.06294 .32913 L
.06394 .3526 L
.06494 .37362 L
.06593 .39224 L
.06693 .40862 L
.06793 .42297 L
.06893 .43549 L
.06993 .44642 L
.07093 .45595 L
.07193 .46428 L
.07293 .47155 L
.07393 .47791 L
.07493 .48346 L
.07592 .48831 L
.07692 .49253 L
.07792 .49617 L
.07892 .49928 L
.07992 .5019 L
.08092 .50405 L
.08192 .50576 L
.08292 .50704 L
.08392 .50792 L
.08492 .5084 L
.08591 .5085 L
.08691 .50825 L
.08791 .50767 L
.08891 .50677 L
.08991 .5056 L
.09091 .50417 L
.09191 .50253 L
.09291 .50071 L
.09391 .49876 L
.09491 .4967 L
.0959 .49458 L
.0969 .49244 L
.0979 .49032 L
.0989 .48825 L
Mistroke
.0999 .40662 L
.1009 .40561 L
.1019 .40493 L
.1029 .40455 L
.1039 .40444 L
.1049 .4046 L
.10589 .40501 L
.10689 .40566 L
.10789 .40654 L
.10889 .40765 L
.10989 .40899 L
.11089 .41056 L
.11189 .41235 L
.11289 .41438 L
.11389 .41666 L
.11489 .41919 L
.11588 .42198 L
.11688 .42504 L
.11788 .4284 L
.11888 .43206 L
.11988 .43605 L
.12088 .44037 L
.12188 .44504 L
.12288 .45007 L
.12388 .45549 L
.12488 .46129 L
.12587 .46748 L
.12687 .47405 L
.12787 .481 L
.12887 .4883 L
.12987 .4959 L
.13087 .50376 L
.13187 .51178 L
.13287 .51988 L
.13387 .52791 L
.13487 .53572 L
.13586 .54312 L
.13686 .54988 L
.13786 .55577 L
.13886 .56053 L
.13986 .5639 L
.14086 .56566 L
.14186 .56559 L
.14286 .56356 L
.14386 .5595 L
.14486 .55345 L
.14585 .54551 L
.14685 .53589 L
.14785 .52488 L
.14885 .51282 L
Mistroke
.14985 .56297 L
.15085 .55011 L
.15185 .53631 L
.15285 .52191 L
.15385 .50725 L
.15485 .49268 L
.15584 .47849 L
.15684 .46491 L
.15784 .45212 L
.15884 .44024 L
.15984 .42933 L
.16084 .41943 L
.16184 .4105 L
.16284 .40252 L
.16384 .39543 L
.16484 .38915 L
.16583 .38362 L
.16683 .37874 L
.16783 .37444 L
.16883 .37065 L
.16983 .36729 L
.17083 .3643 L
.17183 .36161 L
.17283 .35917 L
.17383 .35692 L
.17483 .35482 L
.17582 .35282 L
.17682 .35089 L
.17782 .34899 L
.17882 .34709 L
.17982 .34515 L
.18082 .34316 L
.18182 .34108 L
.18282 .33889 L
.18382 .33656 L
.18482 .33408 L
.18581 .33141 L
.18681 .32854 L
.18781 .32543 L
.18881 .32207 L
.18981 .31844 L
.19081 .3145 L
.19181 .31023 L
.19281 .3056 L
.19381 .3006 L
.19481 .29519 L
.1958 .28936 L
.1968 .28308 L
.1978 .27635 L
.1988 .26916 L
Mistroke
.1998 .28478 L
.2008 .27636 L
.2018 .26797 L
.2028 .25959 L
.2038 .2512 L
.2048 .24281 L
.20579 .23446 L
.20679 .22621 L
.20779 .21816 L
.20879 .21044 L
.20979 .2032 L
.21079 .19662 L
.21179 .19089 L
.21279 .18624 L
.21379 .18287 L
.21479 .18098 L
.21578 .18074 L
.21678 .18226 L
.21778 .18561 L
.21878 .19076 L
.21978 .19762 L
.22078 .20602 L
.22178 .21574 L
.22278 .2265 L
.22378 .238 L
.22478 .24993 L
.22577 .26201 L
.22677 .27398 L
.22777 .28562 L
.22877 .29676 L
.22977 .30727 L
.23077 .31708 L
.23177 .32612 L
.23277 .3344 L
.23377 .34192 L
.23477 .3487 L
.23576 .35479 L
.23676 .36024 L
.23776 .36511 L
.23876 .36946 L
.23976 .37334 L
.24076 .37682 L
.24176 .37994 L
.24276 .38278 L
.24376 .38536 L
.24476 .38775 L
.24575 .38998 L
.24675 .3921 L
.24775 .39413 L
.24875 .39612 L
Mistroke
.24975 .4525 L
.25075 .45453 L
.25175 .45671 L
.25275 .45904 L
.25375 .46151 L
.25475 .46412 L
.25574 .46685 L
.25674 .46969 L
.25774 .47264 L
.25874 .47566 L
.25974 .47875 L
.26074 .48187 L
.26174 .485 L
.26274 .48811 L
.26374 .49117 L
.26474 .49413 L
.26573 .49696 L
.26673 .49961 L
.26773 .50204 L
.26873 .5042 L
.26973 .50605 L
.27073 .50753 L
.27173 .50862 L
.27273 .50926 L
.27373 .50945 L
.27473 .50914 L
.27572 .50833 L
.27672 .50702 L
.27772 .50522 L
.27872 .50295 L
.27972 .50024 L
.28072 .49712 L
.28172 .49366 L
.28272 .4899 L
.28372 .48591 L
.28472 .48175 L
.28571 .47749 L
.28671 .47318 L
.28771 .46888 L
.28871 .46464 L
.28971 .46053 L
.29071 .45657 L
.29171 .4528 L
.29271 .44925 L
.29371 .44595 L
.29471 .44291 L
.2957 .44015 L
.2967 .43767 L
.2977 .43547 L
.2987 .43357 L
Mistroke
.2997 .42263 L
.3007 .42245 L
.3017 .42249 L
.3027 .42274 L
.3037 .4232 L
.3047 .42387 L
.30569 .42475 L
.30669 .42584 L
.30769 .42713 L
.30869 .42864 L
.30969 .43036 L
.31069 .43229 L
.31169 .43444 L
.31269 .4368 L
.31369 .43939 L
.31469 .44221 L
.31568 .44525 L
.31668 .44852 L
.31768 .45202 L
.31868 .45575 L
.31968 .4597 L
.32068 .46388 L
.32168 .46826 L
.32268 .47283 L
.32368 .47758 L
.32468 .48247 L
.32567 .48748 L
.32667 .49255 L
.32767 .49765 L
.32867 .5027 L
.32967 .50764 L
.33067 .51239 L
.33167 .51685 L
.33267 .52092 L
.33367 .52451 L
.33467 .5275 L
.33566 .52979 L
.33666 .53129 L
.33766 .53191 L
.33866 .53159 L
.33966 .53028 L
.34066 .52797 L
.34166 .52467 L
.34266 .52043 L
.34366 .51533 L
.34466 .50948 L
.34565 .50298 L
.34665 .49599 L
.34765 .48865 L
.34865 .48109 L
Mistroke
.34965 .51501 L
.35065 .50967 L
.35165 .50377 L
.35265 .49741 L
.35365 .49071 L
.35465 .48379 L
.35564 .47677 L
.35664 .46977 L
.35764 .46288 L
.35864 .45619 L
.35964 .44977 L
.36064 .44369 L
.36164 .43797 L
.36264 .43266 L
.36364 .42777 L
.36464 .42331 L
.36563 .41928 L
.36663 .41566 L
.36763 .41244 L
.36863 .40962 L
.36963 .40716 L
.37063 .40505 L
.37163 .40326 L
.37263 .40178 L
.37363 .40058 L
.37463 .39964 L
.37562 .39895 L
.37662 .39849 L
.37762 .39825 L
.37862 .39821 L
.37962 .39836 L
.38062 .39869 L
.38162 .39921 L
.38262 .39989 L
.38362 .40075 L
.38462 .40177 L
.38561 .40296 L
.38661 .40433 L
.38761 .40587 L
.38861 .40759 L
.38961 .4095 L
.39061 .41161 L
.39161 .41393 L
.39261 .41646 L
.39361 .41922 L
.39461 .42223 L
.3956 .42549 L
.3966 .42902 L
.3976 .43283 L
.3986 .43695 L
Mistroke
.3996 .32491 L
.4006 .3237 L
.4016 .32197 L
.4026 .31974 L
.4036 .31704 L
.4046 .31387 L
.40559 .31026 L
.40659 .3062 L
.40759 .30169 L
.40859 .29672 L
.40959 .2913 L
.41059 .28542 L
.41159 .27909 L
.41259 .2723 L
.41359 .26507 L
.41459 .25742 L
.41558 .24939 L
.41658 .24104 L
.41758 .23244 L
.41858 .2237 L
.41958 .21495 L
.42058 .20636 L
.42158 .19813 L
.42258 .19051 L
.42358 .18375 L
.42458 .17815 L
.42557 .17401 L
.42657 .17161 L
.42757 .17119 L
.42857 .17296 L
.42957 .17702 L
.43057 .18337 L
.43157 .19191 L
.43257 .20244 L
.43357 .21465 L
.43457 .22817 L
.43556 .24261 L
.43656 .25757 L
.43756 .27266 L
.43856 .28757 L
.43956 .30202 L
.44056 .31581 L
.44156 .32879 L
.44256 .34088 L
.44356 .35202 L
.44456 .36222 L
.44555 .37149 L
.44655 .37988 L
.44755 .38743 L
.44855 .39422 L
Mistroke
.44955 .4039 L
.45055 .4087 L
.45155 .41295 L
.45255 .41669 L
.45355 .42 L
.45455 .42292 L
.45554 .42551 L
.45654 .42781 L
.45754 .42987 L
.45854 .43173 L
.45954 .43342 L
.46054 .43498 L
.46154 .43643 L
.46254 .43781 L
.46354 .43912 L
.46454 .44041 L
.46553 .44167 L
.46653 .44293 L
.46753 .44421 L
.46853 .4455 L
.46953 .44682 L
.47053 .44819 L
.47153 .44959 L
.47253 .45105 L
.47353 .45256 L
.47453 .45412 L
.47552 .45573 L
.47652 .45739 L
.47752 .4591 L
.47852 .46086 L
.47952 .46266 L
.48052 .46448 L
.48152 .46633 L
.48252 .4682 L
.48352 .47006 L
.48452 .47191 L
.48551 .47374 L
.48651 .47553 L
.48751 .47726 L
.48851 .47892 L
.48951 .48048 L
.49051 .48194 L
.49151 .48326 L
.49251 .48444 L
.49351 .48545 L
.49451 .48627 L
.4955 .4869 L
.4965 .48731 L
.4975 .48749 L
.4985 .48745 L
Mistroke
.4995 .54377 L
.5005 .53685 L
.5015 .52902 L
.5025 .5204 L
.5035 .51115 L
.5045 .50144 L
.50549 .49144 L
.50649 .48135 L
.50749 .47132 L
.50849 .46151 L
.50949 .45203 L
.51049 .443 L
.51149 .43448 L
.51249 .42651 L
.51349 .41914 L
.51449 .41236 L
.51548 .40617 L
.51648 .40056 L
.51748 .3955 L
.51848 .39095 L
.51948 .38687 L
.52048 .38324 L
.52148 .38001 L
.52248 .37713 L
.52348 .37457 L
.52448 .3723 L
.52547 .37027 L
.52647 .36845 L
.52747 .36682 L
.52847 .36534 L
.52947 .36399 L
.53047 .36274 L
.53147 .36158 L
.53247 .36048 L
.53347 .35942 L
.53447 .35839 L
.53546 .35737 L
.53646 .35634 L
.53746 .35531 L
.53846 .35424 L
.53946 .35313 L
.54046 .35197 L
.54146 .35075 L
.54246 .34945 L
.54346 .34807 L
.54446 .34659 L
.54545 .345 L
.54645 .34329 L
.54745 .34144 L
.54845 .33945 L
Mistroke
.54945 .41351 L
.55045 .4188 L
.55145 .42414 L
.55245 .4296 L
.55345 .43523 L
.55445 .44109 L
.55544 .44722 L
.55644 .45366 L
.55744 .46043 L
.55844 .46754 L
.55944 .47501 L
.56044 .48282 L
.56144 .49095 L
.56244 .49935 L
.56344 .50796 L
.56444 .51667 L
.56543 .52536 L
.56643 .53388 L
.56743 .54201 L
.56843 .54954 L
.56943 .55621 L
.57043 .56173 L
.57143 .56582 L
.57243 .56821 L
.57343 .56864 L
.57443 .56693 L
.57542 .56298 L
.57642 .55679 L
.57742 .54844 L
.57842 .53815 L
.57942 .52621 L
.58042 .51296 L
.58142 .49882 L
.58242 .48416 L
.58342 .46936 L
.58442 .45474 L
.58541 .44057 L
.58641 .42705 L
.58741 .41433 L
.58841 .4025 L
.58941 .39161 L
.59041 .38165 L
.59141 .37262 L
.59241 .36446 L
.59341 .35714 L
.59441 .35057 L
.5954 .34469 L
.5964 .33944 L
.5974 .33475 L
.5984 .33054 L
Mistroke
.5994 .33889 L
.6004 .33419 L
.6014 .32988 L
.6024 .32589 L
.6034 .32217 L
.6044 .31866 L
.60539 .31532 L
.60639 .3121 L
.60739 .30898 L
.60839 .30591 L
.60939 .30287 L
.61039 .29984 L
.61139 .29679 L
.61239 .29372 L
.61339 .2906 L
.61439 .28744 L
.61538 .28422 L
.61638 .28094 L
.61738 .27761 L
.61838 .27423 L
.61938 .27082 L
.62038 .26739 L
.62138 .26395 L
.62238 .26053 L
.62338 .25716 L
.62438 .25387 L
.62537 .25069 L
.62637 .24768 L
.62737 .24486 L
.62837 .24229 L
.62937 .24001 L
.63037 .23806 L
.63137 .23651 L
.63237 .23538 L
.63337 .23471 L
.63437 .23454 L
.63536 .23489 L
.63636 .23577 L
.63736 .23719 L
.63836 .23913 L
.63936 .24157 L
.64036 .24448 L
.64136 .24783 L
.64236 .25154 L
.64336 .25558 L
.64436 .25987 L
.64535 .26436 L
.64635 .26896 L
.64735 .27363 L
.64835 .27829 L
Mistroke
.64935 .32716 L
.65035 .32649 L
.65135 .3257 L
.65235 .32478 L
.65335 .32372 L
.65435 .32253 L
.65534 .32119 L
.65634 .3197 L
.65734 .31806 L
.65834 .31626 L
.65934 .31429 L
.66034 .31216 L
.66134 .30985 L
.66234 .30736 L
.66334 .30469 L
.66434 .30182 L
.66533 .29877 L
.66633 .29552 L
.66733 .29207 L
.66833 .28844 L
.66933 .28461 L
.67033 .28059 L
.67133 .27641 L
.67233 .27206 L
.67333 .26757 L
.67433 .26296 L
.67532 .25827 L
.67632 .25354 L
.67732 .2488 L
.67832 .24412 L
.67932 .23956 L
.68032 .2352 L
.68132 .2311 L
.68232 .22736 L
.68332 .22406 L
.68432 .22131 L
.68531 .21918 L
.68631 .21776 L
.68731 .21713 L
.68831 .21734 L
.68931 .21843 L
.69031 .22042 L
.69131 .2233 L
.69231 .22704 L
.69331 .23158 L
.69431 .23684 L
.6953 .24272 L
.6963 .24909 L
.6973 .25585 L
.6983 .26286 L
Mistroke
.6993 .29354 L
.7003 .29983 L
.7013 .30585 L
.7023 .31156 L
.7033 .31692 L
.7043 .3219 L
.70529 .32651 L
.70629 .33072 L
.70729 .33456 L
.70829 .33802 L
.70929 .34113 L
.71029 .3439 L
.71129 .34635 L
.71229 .3485 L
.71329 .35038 L
.71429 .35201 L
.71528 .3534 L
.71628 .35458 L
.71728 .35556 L
.71828 .35637 L
.71928 .35702 L
.72028 .35751 L
.72128 .35788 L
.72228 .35812 L
.72328 .35825 L
.72428 .35827 L
.72527 .35819 L
.72627 .35802 L
.72727 .35777 L
.72827 .35742 L
.72927 .35699 L
.73027 .35648 L
.73127 .35588 L
.73227 .3552 L
.73327 .35443 L
.73427 .35357 L
.73526 .35262 L
.73626 .35157 L
.73726 .35041 L
.73826 .34914 L
.73926 .34775 L
.74026 .34623 L
.74126 .34458 L
.74226 .34277 L
.74326 .34081 L
.74426 .33867 L
.74525 .33634 L
.74625 .33381 L
.74725 .33107 L
.74825 .32808 L
Mistroke
.74925 .2609 L
.75025 .25155 L
.75125 .24178 L
.75225 .23163 L
.75325 .2212 L
.75425 .21062 L
.75524 .20009 L
.75624 .18983 L
.75724 .18015 L
.75824 .17138 L
.75924 .16392 L
.76024 .15818 L
.76124 .15459 L
.76224 .15351 L
.76324 .15526 L
.76424 .16001 L
.76523 .16781 L
.76623 .1785 L
.76723 .19179 L
.76823 .20724 L
.76923 .22429 L
.77023 .24237 L
.77123 .26091 L
.77223 .2794 L
.77323 .29742 L
.77423 .31464 L
.77522 .33083 L
.77622 .34586 L
.77722 .35964 L
.77822 .37217 L
.77922 .38348 L
.78022 .39362 L
.78122 .40266 L
.78222 .4107 L
.78322 .41781 L
.78422 .42409 L
.78521 .42962 L
.78621 .43447 L
.78721 .43873 L
.78821 .44245 L
.78921 .44571 L
.79021 .44855 L
.79121 .45103 L
.79221 .45319 L
.79321 .45506 L
.79421 .45669 L
.7952 .45811 L
.7962 .45934 L
.7972 .46041 L
.7982 .46134 L
Mistroke
.7992 .4731 L
.8002 .47553 L
.8012 .47772 L
.8022 .47967 L
.8032 .48137 L
.8042 .48282 L
.80519 .48402 L
.80619 .48498 L
.80719 .48568 L
.80819 .48613 L
.80919 .48633 L
.81019 .48627 L
.81119 .48597 L
.81219 .48543 L
.81319 .48465 L
.81419 .48366 L
.81518 .48246 L
.81618 .48107 L
.81718 .47951 L
.81818 .47781 L
.81918 .47598 L
.82018 .47404 L
.82118 .47204 L
.82218 .46997 L
.82318 .46788 L
.82418 .46579 L
.82517 .46371 L
.82617 .46167 L
.82717 .45969 L
.82817 .45779 L
.82917 .45598 L
.83017 .45427 L
.83117 .45268 L
.83217 .45123 L
.83317 .44991 L
.83417 .44873 L
.83516 .44771 L
.83616 .44684 L
.83716 .44614 L
.83816 .44559 L
.83916 .4452 L
.84016 .44498 L
.84116 .44492 L
.84216 .44502 L
.84316 .44528 L
.84416 .4457 L
.84515 .44628 L
.84615 .44701 L
.84715 .44789 L
.84815 .44892 L
Mistroke
.84915 .50983 L
.85015 .51005 L
.85115 .5099 L
.85215 .50933 L
.85315 .50833 L
.85415 .50688 L
.85514 .50497 L
.85614 .50262 L
.85714 .49986 L
.85814 .4967 L
.85914 .4932 L
.86014 .48941 L
.86114 .48537 L
.86214 .48115 L
.86314 .47681 L
.86414 .4724 L
.86513 .46798 L
.86613 .46361 L
.86713 .45933 L
.86813 .45519 L
.86913 .45122 L
.87013 .44746 L
.87113 .44392 L
.87213 .44062 L
.87313 .43759 L
.87413 .43483 L
.87512 .43233 L
.87612 .43012 L
.87712 .42817 L
.87812 .4265 L
.87912 .42509 L
.88012 .42394 L
.88112 .42304 L
.88212 .42238 L
.88312 .42196 L
.88412 .42177 L
.88511 .42181 L
.88611 .42206 L
.88711 .42253 L
.88811 .42321 L
.88911 .42409 L
.89011 .42518 L
.89111 .42647 L
.89211 .42796 L
.89311 .42965 L
.89411 .43155 L
.8951 .43365 L
.8961 .43595 L
.8971 .43846 L
.8981 .44118 L
Mistroke
.8991 .45809 L
.9001 .46334 L
.9011 .46905 L
.9021 .47518 L
.9031 .48171 L
.9041 .48858 L
.90509 .49576 L
.90609 .50317 L
.90709 .51072 L
.90809 .51831 L
.90909 .52579 L
.91009 .53302 L
.91109 .53982 L
.91209 .54596 L
.91309 .55125 L
.91409 .55543 L
.91508 .5583 L
.91608 .55963 L
.91708 .55927 L
.91808 .55709 L
.91908 .55304 L
.92008 .54715 L
.92108 .53953 L
.92208 .53036 L
.92308 .51988 L
.92408 .5084 L
.92507 .49621 L
.92607 .48364 L
.92707 .47097 L
.92807 .45845 L
.92907 .44631 L
.93007 .43471 L
.93107 .42378 L
.93207 .41358 L
.93307 .40416 L
.93407 .39554 L
.93506 .38769 L
.93606 .38059 L
.93706 .3742 L
.93806 .36845 L
.93906 .36329 L
.94006 .35867 L
.94106 .35451 L
.94206 .35077 L
.94306 .34738 L
.94406 .34429 L
.94505 .34145 L
.94605 .33881 L
.94705 .33632 L
.94805 .33396 L
Mistroke
.94905 .33005 L
.95005 .32887 L
.95105 .32753 L
.95205 .32602 L
.95305 .32434 L
.95405 .32248 L
.95504 .32044 L
.95604 .3182 L
.95704 .31576 L
.95804 .31311 L
.95904 .31025 L
.96004 .30716 L
.96104 .30384 L
.96204 .30027 L
.96304 .29646 L
.96404 .2924 L
.96503 .28808 L
.96603 .28351 L
.96703 .27868 L
.96803 .27361 L
.96903 .26832 L
.97003 .26281 L
.97103 .25713 L
.97203 .25131 L
.97303 .2454 L
.97403 .23947 L
.97502 .23359 L
.97602 .22786 L
.97702 .22237 L
.97802 .21726 L
.97902 .21264 L
.98002 .20865 L
.98102 .20544 L
.98202 .20314 L
.98302 .20187 L
.98402 .20174 L
.98501 .20281 L
.98601 .20514 L
.98701 .20872 L
.98801 .2135 L
.98901 .21941 L
.99001 .2263 L
.99101 .23404 L
.99201 .24243 L
.99301 .25129 L
.99401 .26042 L
.995 .26966 L
.996 .27882 L
.997 .28778 L
.998 .29641 L
Mistroke
.999 .31363 L
Mfstroke
0 g
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .30614 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28377 L
.005 .2789 L
.00599 .27358 L
.00699 .26776 L
.00799 .26134 L
.00899 .25425 L
.00999 .24638 L
.01099 .23764 L
.01199 .22789 L
.01299 .21702 L
.01399 .20488 L
.01499 .1913 L
.01598 .1761 L
.01698 .15908 L
.01798 .14002 L
.01898 .11868 L
.01998 .09479 L
.02098 .06807 L
.02198 .03821 L
.02298 .00489 L
s
.02298 .00489 m
.02311 0 L
s
0 .30902 m
.01284 0 L
s
.04993 0 m
.04995 .02038 L
.05095 .04184 L
.05195 .07357 L
.05295 .11369 L
.05395 .15922 L
.05495 .20646 L
.05594 .25167 L
.05694 .29172 L
.05794 .32454 L
.05894 .34939 L
.05994 .36666 L
.06094 .37754 L
.06194 .38357 L
.06294 .3863 L
.06394 .38709 L
.06494 .38702 L
.06593 .38687 L
.06693 .38719 L
.06793 .38831 L
.06893 .39033 L
.06993 .39315 L
.07093 .3964 L
.07193 .39932 L
.07293 .40068 L
.07393 .39907 L
.07493 .39361 L
.07592 .38451 L
.07692 .37265 L
.07792 .35892 L
.07892 .34409 L
.07992 .32877 L
.08092 .31351 L
.08192 .29881 L
.08292 .28512 L
.08392 .27285 L
.08492 .26236 L
.08591 .25393 L
.08691 .24778 L
.08791 .24404 L
.08891 .24272 L
.08991 .24378 L
.09091 .24707 L
.09191 .25235 L
.09291 .25934 L
.09391 .26768 L
.09491 .27698 L
.0959 .2868 L
.0969 .29668 L
.0979 .3061 L
Mistroke
.0989 .31451 L
.0999 .32446 L
.1009 .32226 L
.1019 .32128 L
.1029 .32085 L
.1039 .32073 L
.1049 .32082 L
.10589 .32107 L
.10689 .32143 L
.10789 .32189 L
.10889 .32244 L
.10989 .32308 L
.11089 .3238 L
.11189 .32461 L
.11289 .32553 L
.11389 .32656 L
.11489 .32773 L
.11588 .32907 L
.11688 .33059 L
.11788 .33234 L
.11888 .33435 L
.11988 .33669 L
.12088 .3394 L
.12188 .34257 L
.12288 .34628 L
.12388 .35062 L
.12488 .35572 L
.12587 .3617 L
.12687 .36869 L
.12787 .37685 L
.12887 .38628 L
.12987 .39706 L
.13087 .40918 L
.13187 .42238 L
.13287 .43596 L
.13387 .44828 L
.13487 .4559 L
.13586 .45392 L
.13686 .43991 L
.13786 .4158 L
.13886 .38475 L
.13986 .34954 L
.14086 .31272 L
.14186 .27679 L
.14286 .2441 L
.14386 .21663 L
.14486 .19577 L
.14585 .1821 L
.14685 .1754 L
.14785 .17466 L
Mistroke
.14885 .17838 L
.14985 .3547 L
.15085 .33184 L
.15185 .312 L
.15285 .29513 L
.15385 .28121 L
.15485 .27012 L
.15584 .2616 L
.15684 .25531 L
.15784 .25085 L
.15884 .24785 L
.15984 .24596 L
.16084 .24485 L
.16184 .24425 L
.16284 .24394 L
.16384 .24373 L
.16484 .24349 L
.16583 .24309 L
.16683 .24245 L
.16783 .2415 L
.16883 .2402 L
.16983 .23849 L
.17083 .23636 L
.17183 .23376 L
.17283 .2307 L
.17383 .22714 L
.17483 .22306 L
.17582 .21844 L
.17682 .21326 L
.17782 .2075 L
.17882 .20113 L
.17982 .19412 L
.18082 .18644 L
.18182 .17806 L
.18282 .16894 L
.18382 .15904 L
.18482 .14835 L
.18581 .13683 L
.18681 .12446 L
.18781 .11123 L
.18881 .09715 L
.18981 .08224 L
.19081 .06657 L
.19181 .05022 L
.19281 .03334 L
.19381 .01613 L
Mfstroke
.19381 .01613 m
.19474 0 L
s
.19908 0 m
.1998 .15577 L
.2008 .1451 L
.2018 .13518 L
.2028 .12552 L
.2038 .11618 L
.2048 .10734 L
.20579 .09932 L
.20679 .09246 L
.20779 .08712 L
.20879 .08366 L
.20979 .08239 L
.21079 .08351 L
.21179 .08707 L
.21279 .09302 L
.21379 .10115 L
.21479 .11127 L
.21578 .12317 L
.21678 .13667 L
.21778 .15154 L
.21878 .16745 L
.21978 .18399 L
.22078 .20064 L
.22178 .21686 L
.22278 .23214 L
.22378 .24603 L
.22478 .25821 L
.22577 .2685 L
.22677 .27686 L
.22777 .28337 L
.22877 .28819 L
.22977 .29154 L
.23077 .29365 L
.23177 .29474 L
.23277 .29501 L
.23377 .29465 L
.23477 .29378 L
.23576 .29252 L
.23676 .29097 L
.23776 .28918 L
.23876 .2872 L
.23976 .28507 L
.24076 .28282 L
.24176 .28045 L
.24276 .27799 L
.24376 .27543 L
.24476 .27278 L
.24575 .27003 L
.24675 .26718 L
.24775 .26423 L
Mistroke
.24875 .26115 L
.24975 .38876 L
.25075 .3878 L
.25175 .38806 L
.25275 .38884 L
.25375 .38993 L
.25475 .39122 L
.25574 .39263 L
.25674 .39411 L
.25774 .39563 L
.25874 .39714 L
.25974 .3986 L
.26074 .39997 L
.26174 .40121 L
.26274 .40226 L
.26374 .40306 L
.26474 .40354 L
.26573 .40361 L
.26673 .40318 L
.26773 .40214 L
.26873 .4004 L
.26973 .39786 L
.27073 .39445 L
.27173 .39013 L
.27273 .3849 L
.27373 .37885 L
.27473 .37209 L
.27572 .36478 L
.27672 .35712 L
.27772 .34932 L
.27872 .34158 L
.27972 .33409 L
.28072 .32701 L
.28172 .32047 L
.28272 .31456 L
.28372 .30933 L
.28472 .30482 L
.28571 .30099 L
.28671 .29784 L
.28771 .2953 L
.28871 .29332 L
.28971 .29184 L
.29071 .2908 L
.29171 .29012 L
.29271 .28975 L
.29371 .28965 L
.29471 .28975 L
.2957 .29003 L
.2967 .29045 L
.2977 .29097 L
Mistroke
.2987 .29158 L
.2997 .34437 L
.3007 .34215 L
.3017 .34123 L
.3027 .34095 L
.3037 .34108 L
.3047 .34152 L
.30569 .34221 L
.30669 .34311 L
.30769 .34421 L
.30869 .34548 L
.30969 .34694 L
.31069 .34857 L
.31169 .35038 L
.31269 .35238 L
.31369 .35459 L
.31469 .35701 L
.31568 .35967 L
.31668 .36258 L
.31768 .36576 L
.31868 .36924 L
.31968 .37303 L
.32068 .37715 L
.32168 .3816 L
.32268 .38638 L
.32368 .39148 L
.32468 .39683 L
.32567 .40234 L
.32667 .40783 L
.32767 .41305 L
.32867 .41757 L
.32967 .42083 L
.33067 .42211 L
.33167 .42071 L
.33267 .41611 L
.33367 .40825 L
.33467 .3974 L
.33566 .38414 L
.33666 .36913 L
.33766 .35312 L
.33866 .33684 L
.33966 .32098 L
.34066 .30618 L
.34166 .29293 L
.34266 .28157 L
.34366 .27227 L
.34466 .26502 L
.34565 .25966 L
.34665 .25593 L
.34765 .25348 L
Mistroke
.34865 .25195 L
.34965 .37547 L
.35065 .36195 L
.35165 .34999 L
.35265 .3392 L
.35365 .32952 L
.35465 .32095 L
.35564 .31348 L
.35664 .30709 L
.35764 .30172 L
.35864 .29729 L
.35964 .2937 L
.36064 .29085 L
.36164 .28863 L
.36264 .28695 L
.36364 .2857 L
.36464 .2848 L
.36563 .28415 L
.36663 .2837 L
.36763 .28337 L
.36863 .28312 L
.36963 .2829 L
.37063 .28266 L
.37163 .28238 L
.37263 .28203 L
.37363 .28159 L
.37463 .28105 L
.37562 .28038 L
.37662 .27958 L
.37762 .27864 L
.37862 .27756 L
.37962 .27631 L
.38062 .27492 L
.38162 .27336 L
.38262 .27163 L
.38362 .26975 L
.38462 .26769 L
.38561 .26548 L
.38661 .2631 L
.38761 .26057 L
.38861 .25789 L
.38961 .25509 L
.39061 .25218 L
.39161 .24918 L
.39261 .24614 L
.39361 .24311 L
.39461 .24015 L
.3956 .23735 L
.3966 .23481 L
.3976 .23267 L
Mistroke
.3986 .23112 L
.3996 .25322 L
.4006 .24324 L
.4016 .23415 L
.4026 .22517 L
.4036 .216 L
.4046 .2065 L
.40559 .1966 L
.40659 .18624 L
.40759 .17542 L
.40859 .16415 L
.40959 .15248 L
.41059 .14049 L
.41159 .1283 L
.41259 .11609 L
.41359 .1041 L
.41459 .09263 L
.41558 .08203 L
.41658 .07273 L
.41758 .06517 L
.41858 .05975 L
.41958 .05672 L
.42058 .05588 L
.42158 .05632 L
.42258 .0564 L
.42358 .05505 L
.42458 .05294 L
.42557 .0518 L
.42657 .05329 L
.42757 .05873 L
.42857 .06898 L
.42957 .0844 L
.43057 .10478 L
.43157 .12934 L
.43257 .1568 L
.43357 .18558 L
.43457 .21401 L
.43556 .24057 L
.43656 .26409 L
.43756 .28384 L
.43856 .29957 L
.43956 .31147 L
.44056 .32 L
.44156 .3258 L
.44256 .32949 L
.44356 .33165 L
.44456 .33275 L
.44555 .33312 L
.44655 .33303 L
.44755 .33267 L
Mistroke
.44855 .33217 L
.44955 .37445 L
.45055 .3694 L
.45155 .36562 L
.45255 .36248 L
.45355 .35978 L
.45455 .35745 L
.45554 .35543 L
.45654 .35368 L
.45754 .35218 L
.45854 .35091 L
.45954 .34985 L
.46054 .34899 L
.46154 .34831 L
.46254 .34781 L
.46354 .34747 L
.46454 .34728 L
.46553 .34725 L
.46653 .34735 L
.46753 .34759 L
.46853 .34795 L
.46953 .34844 L
.47053 .34904 L
.47153 .34976 L
.47253 .35059 L
.47353 .35151 L
.47453 .35253 L
.47552 .35363 L
.47652 .3548 L
.47752 .35602 L
.47852 .35729 L
.47952 .35856 L
.48052 .35982 L
.48152 .36103 L
.48252 .36215 L
.48352 .36314 L
.48452 .36393 L
.48551 .36448 L
.48651 .36473 L
.48751 .36462 L
.48851 .36409 L
.48951 .3631 L
.49051 .36163 L
.49151 .35966 L
.49251 .35719 L
.49351 .35426 L
.49451 .35091 L
.4955 .3472 L
.4965 .3432 L
.4975 .339 L
Mistroke
.4985 .33468 L
.4995 .38414 L
.5005 .36611 L
.5015 .34944 L
.5025 .33396 L
.5035 .31984 L
.5045 .30723 L
.50549 .29624 L
.50649 .28687 L
.50749 .27907 L
.50849 .27275 L
.50949 .26773 L
.51049 .26385 L
.51149 .26093 L
.51249 .25879 L
.51349 .25726 L
.51449 .25619 L
.51548 .25545 L
.51648 .25491 L
.51748 .25449 L
.51848 .25411 L
.51948 .25368 L
.52048 .25316 L
.52148 .2525 L
.52248 .25166 L
.52348 .25062 L
.52448 .24933 L
.52547 .24779 L
.52647 .24598 L
.52747 .24387 L
.52847 .24145 L
.52947 .23871 L
.53047 .23562 L
.53147 .23218 L
.53247 .22836 L
.53347 .22413 L
.53447 .21949 L
.53546 .21441 L
.53646 .20885 L
.53746 .20279 L
.53846 .1962 L
.53946 .18904 L
.54046 .18127 L
.54146 .17286 L
.54246 .16376 L
.54346 .15393 L
.54446 .14332 L
.54545 .13187 L
.54645 .11956 L
.54745 .10632 L
Mistroke
.54845 .09211 L
.54945 .38635 L
.55045 .38719 L
.55145 .38974 L
.55245 .39325 L
.55345 .39747 L
.55445 .40229 L
.55544 .40767 L
.55644 .41355 L
.55744 .4199 L
.55844 .4267 L
.55944 .4339 L
.56044 .44143 L
.56144 .4492 L
.56244 .45707 L
.56344 .46484 L
.56444 .4722 L
.56543 .47866 L
.56643 .48349 L
.56743 .48559 L
.56843 .48346 L
.56943 .47559 L
.57043 .46119 L
.57143 .44055 L
.57243 .41474 L
.57343 .38527 L
.57443 .35385 L
.57542 .32227 L
.57642 .2922 L
.57742 .26504 L
.57842 .24173 L
.57942 .22274 L
.58042 .20805 L
.58142 .19725 L
.58242 .18972 L
.58342 .18478 L
.58442 .18178 L
.58541 .18018 L
.58641 .1796 L
.58741 .17975 L
.58841 .18041 L
.58941 .18141 L
.59041 .18263 L
.59141 .18394 L
.59241 .18526 L
.59341 .1865 L
.59441 .18761 L
.5954 .18855 L
.5964 .1893 L
.5974 .18983 L
Mistroke
.5984 .19016 L
.5994 .23267 L
.6004 .2284 L
.6014 .22503 L
.6024 .22188 L
.6034 .21875 L
.6044 .21553 L
.60539 .21217 L
.60639 .20866 L
.60739 .20497 L
.60839 .20113 L
.60939 .19713 L
.61039 .19299 L
.61139 .18875 L
.61239 .18442 L
.61339 .18006 L
.61439 .17569 L
.61538 .17137 L
.61638 .16715 L
.61738 .16309 L
.61838 .15923 L
.61938 .15565 L
.62038 .15238 L
.62138 .14947 L
.62238 .14696 L
.62338 .14483 L
.62438 .14307 L
.62537 .14164 L
.62637 .14045 L
.62737 .13943 L
.62837 .13849 L
.62937 .13762 L
.63037 .13684 L
.63137 .13622 L
.63237 .1359 L
.63337 .13603 L
.63437 .13674 L
.63536 .13818 L
.63636 .14042 L
.63736 .14353 L
.63836 .14749 L
.63936 .15225 L
.64036 .15772 L
.64136 .16375 L
.64236 .17017 L
.64336 .1768 L
.64436 .18344 L
.64535 .18991 L
.64635 .19606 L
.64735 .20174 L
Mistroke
.64835 .20685 L
.64935 .26026 L
.65035 .25465 L
.65135 .25004 L
.65235 .24573 L
.65335 .24151 L
.65435 .23727 L
.65534 .23294 L
.65634 .22848 L
.65734 .22386 L
.65834 .21906 L
.65934 .21405 L
.66034 .20885 L
.66134 .20345 L
.66234 .19784 L
.66334 .19206 L
.66434 .18611 L
.66533 .18003 L
.66633 .17386 L
.66733 .16764 L
.66833 .16144 L
.66933 .15534 L
.67033 .14942 L
.67133 .14378 L
.67233 .13853 L
.67333 .13376 L
.67433 .1296 L
.67532 .1261 L
.67632 .12332 L
.67732 .1212 L
.67832 .1196 L
.67932 .11823 L
.68032 .11668 L
.68132 .11459 L
.68232 .11177 L
.68332 .10837 L
.68432 .10479 L
.68531 .10159 L
.68631 .0993 L
.68731 .09843 L
.68831 .09937 L
.68931 .10239 L
.69031 .10761 L
.69131 .11501 L
.69231 .12441 L
.69331 .13548 L
.69431 .14778 L
.6953 .16081 L
.6963 .17403 L
.6973 .18691 L
Mistroke
.6983 .19901 L
.6993 .295 L
.7003 .29392 L
.7013 .29334 L
.7023 .29271 L
.7033 .29192 L
.7043 .29094 L
.70529 .28977 L
.70629 .28845 L
.70729 .28698 L
.70829 .28539 L
.70929 .2837 L
.71029 .28191 L
.71129 .28003 L
.71229 .27807 L
.71329 .27601 L
.71429 .27386 L
.71528 .27162 L
.71628 .26925 L
.71728 .26677 L
.71828 .26415 L
.71928 .26137 L
.72028 .25842 L
.72128 .25528 L
.72228 .25193 L
.72328 .24835 L
.72428 .24451 L
.72527 .24038 L
.72627 .23595 L
.72727 .23118 L
.72827 .22604 L
.72927 .22049 L
.73027 .2145 L
.73127 .20804 L
.73227 .20105 L
.73327 .19351 L
.73427 .18535 L
.73526 .17653 L
.73626 .167 L
.73726 .15669 L
.73826 .14556 L
.73926 .13354 L
.74026 .12056 L
.74126 .10657 L
.74226 .09149 L
.74326 .07527 L
.74426 .05786 L
.74525 .03919 L
.74625 .01924 L
Mfstroke
.74625 .01924 m
.74716 0 L
s
.74841 0 m
.74925 .12715 L
.75025 .11142 L
.75125 .09693 L
.75225 .08339 L
.75325 .07111 L
.75425 .06064 L
.75524 .05264 L
.75624 .04778 L
.75724 .0467 L
.75824 .04987 L
.75924 .05747 L
.76024 .06945 L
.76124 .08555 L
.76224 .10547 L
.76324 .12879 L
.76424 .15491 L
.76523 .18293 L
.76623 .21175 L
.76723 .24012 L
.76823 .2668 L
.76923 .29078 L
.77023 .31135 L
.77123 .32817 L
.77223 .34129 L
.77323 .35099 L
.77423 .35777 L
.77522 .36216 L
.77622 .36471 L
.77722 .36588 L
.77822 .36608 L
.77922 .36563 L
.78022 .36478 L
.78122 .36371 L
.78222 .36257 L
.78322 .36144 L
.78422 .36039 L
.78521 .35946 L
.78621 .35866 L
.78721 .35799 L
.78821 .35743 L
.78921 .35694 L
.79021 .35647 L
.79121 .35598 L
.79221 .35542 L
.79321 .35473 L
.79421 .35386 L
.7952 .35278 L
.7962 .35148 L
.7972 .34994 L
Mistroke
.7982 .34819 L
.7992 .41027 L
.8002 .40605 L
.8012 .40281 L
.8022 .39987 L
.8032 .39703 L
.8042 .39418 L
.80519 .39128 L
.80619 .38828 L
.80719 .38519 L
.80819 .38198 L
.80919 .37867 L
.81019 .37527 L
.81119 .37178 L
.81219 .36822 L
.81319 .36462 L
.81419 .36099 L
.81518 .35738 L
.81618 .35379 L
.81718 .35027 L
.81818 .34684 L
.81918 .34354 L
.82018 .34039 L
.82118 .33741 L
.82218 .33463 L
.82318 .33207 L
.82418 .32973 L
.82517 .32762 L
.82617 .32575 L
.82717 .32412 L
.82817 .32272 L
.82917 .32155 L
.83017 .3206 L
.83117 .31986 L
.83217 .31932 L
.83317 .31896 L
.83417 .31879 L
.83516 .31878 L
.83616 .31892 L
.83716 .31921 L
.83816 .31965 L
.83916 .32021 L
.84016 .32091 L
.84116 .32173 L
.84216 .32268 L
.84316 .32375 L
.84416 .32494 L
.84515 .32626 L
.84615 .32771 L
.84715 .32929 L
Mistroke
.84815 .331 L
.84915 .42063 L
.85015 .4134 L
.85115 .40666 L
.85215 .39985 L
.85315 .39285 L
.85415 .38569 L
.85514 .37841 L
.85614 .3711 L
.85714 .36385 L
.85814 .35676 L
.85914 .34992 L
.86014 .34342 L
.86114 .33732 L
.86214 .33168 L
.86314 .32655 L
.86414 .32194 L
.86513 .31786 L
.86613 .31431 L
.86713 .31126 L
.86813 .3087 L
.86913 .30658 L
.87013 .30487 L
.87113 .30352 L
.87213 .30249 L
.87313 .30174 L
.87413 .30123 L
.87512 .30092 L
.87612 .30078 L
.87712 .30079 L
.87812 .3009 L
.87912 .30111 L
.88012 .30139 L
.88112 .30173 L
.88212 .30213 L
.88312 .30257 L
.88412 .30305 L
.88511 .30357 L
.88611 .30414 L
.88711 .30476 L
.88811 .30545 L
.88911 .30621 L
.89011 .30706 L
.89111 .30802 L
.89211 .30912 L
.89311 .31038 L
.89411 .31183 L
.8951 .31352 L
.8961 .31548 L
.8971 .31775 L
Mistroke
.8981 .32039 L
.8991 .42253 L
.9001 .42694 L
.9011 .43258 L
.9021 .43869 L
.9031 .44498 L
.9041 .45126 L
.90509 .45735 L
.90609 .46307 L
.90709 .46818 L
.90809 .47242 L
.90909 .47545 L
.91009 .47685 L
.91109 .47611 L
.91209 .47268 L
.91309 .46594 L
.91409 .45542 L
.91508 .44093 L
.91608 .42272 L
.91708 .40141 L
.91808 .37797 L
.91908 .35354 L
.92008 .32928 L
.92108 .30623 L
.92208 .28524 L
.92308 .2669 L
.92408 .25148 L
.92507 .23901 L
.92607 .22931 L
.92707 .22207 L
.92807 .2169 L
.92907 .21343 L
.93007 .21129 L
.93107 .21014 L
.93207 .20971 L
.93307 .20976 L
.93407 .21009 L
.93506 .21053 L
.93606 .21097 L
.93706 .21129 L
.93806 .21142 L
.93906 .2113 L
.94006 .21088 L
.94106 .21013 L
.94206 .20904 L
.94306 .20759 L
.94406 .20577 L
.94505 .20358 L
.94605 .20103 L
.94705 .19811 L
Mistroke
.94805 .19484 L
.94905 .25837 L
.95005 .25198 L
.95105 .24655 L
.95205 .24138 L
.95305 .23622 L
.95405 .23094 L
.95504 .22549 L
.95604 .21982 L
.95704 .21389 L
.95804 .20769 L
.95904 .2012 L
.96004 .19443 L
.96104 .1874 L
.96204 .18012 L
.96304 .17264 L
.96404 .16499 L
.96503 .15727 L
.96603 .14954 L
.96703 .14193 L
.96803 .13456 L
.96903 .12759 L
.97003 .12119 L
.97103 .11553 L
.97203 .11079 L
.97303 .10708 L
.97403 .10444 L
.97502 .10275 L
.97602 .10164 L
.97702 .10047 L
.97802 .09856 L
.97902 .09561 L
.98002 .09191 L
.98102 .08824 L
.98202 .08545 L
.98302 .08432 L
.98402 .08551 L
.98501 .08947 L
.98601 .09641 L
.98701 .10632 L
.98801 .11892 L
.98901 .13372 L
.99001 .15005 L
.99101 .16712 L
.99201 .18413 L
.99301 .20034 L
.99401 .21513 L
.995 .22807 L
.996 .23893 L
.997 .24766 L
Mistroke
.998 .25439 L
.999 .30614 L
Mfstroke
gsave
.999 .31876 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32501 L
.005 .328 L
.00599 .33136 L
.00699 .33513 L
.00799 .33934 L
.00899 .34402 L
.00999 .34924 L
.01099 .35504 L
.01199 .36151 L
.01299 .36872 L
.01399 .37677 L
.01499 .38576 L
.01598 .3958 L
.01698 .40704 L
.01798 .41959 L
.01898 .43363 L
.01998 .44932 L
.02098 .46683 L
.02198 .48635 L
.02298 .50807 L
.02398 .53217 L
.02498 .55883 L
.02597 .58817 L
s
.02597 .58817 m
.0269 .61803 L
s
.04014 .61803 m
.04096 .39939 L
s
0 .30902 m
.02068 .61803 L
s
.04948 .61803 m
.04995 .03315 L
.05095 .06425 L
.05195 .10559 L
.05295 .15624 L
.05395 .21371 L
.05495 .27412 L
.05594 .33296 L
.05694 .38601 L
.05794 .43032 L
.05894 .46461 L
.05994 .48913 L
.06094 .50519 L
.06194 .51458 L
.06294 .51904 L
.06394 .52007 L
.06494 .51876 L
.06593 .51586 L
.06693 .51186 L
.06793 .50702 L
.06893 .50159 L
.06993 .49579 L
.07093 .49004 L
.07193 .48503 L
.07293 .48188 L
.07393 .48191 L
.07493 .48587 L
.07592 .49341 L
.07692 .50356 L
.07792 .51531 L
.07892 .52784 L
.07992 .54044 L
.08092 .55254 L
.08192 .56363 L
.08292 .57324 L
.08392 .581 L
.08492 .58658 L
.08591 .58977 L
.08691 .59041 L
.08791 .58847 L
.08891 .58402 L
.08991 .57721 L
.09091 .56828 L
.09191 .55756 L
.09291 .54543 L
.09391 .53232 L
.09491 .51868 L
.0959 .505 L
.0969 .49181 L
.0979 .47964 L
Mistroke
.0989 .46906 L
.0999 .33707 L
.1009 .34276 L
.1019 .34741 L
.1029 .35171 L
.1039 .35589 L
.1049 .3601 L
.10589 .3644 L
.10689 .36887 L
.10789 .37355 L
.10889 .3785 L
.10989 .38375 L
.11089 .38934 L
.11189 .39531 L
.11289 .40169 L
.11389 .40851 L
.11489 .41578 L
.11588 .42354 L
.11688 .4318 L
.11788 .44055 L
.11888 .4498 L
.11988 .45951 L
.12088 .46966 L
.12188 .48016 L
.12288 .49092 L
.12388 .5018 L
.12488 .51263 L
.12587 .52316 L
.12687 .53312 L
.12787 .54214 L
.12887 .54983 L
.12987 .55575 L
.13087 .5595 L
.13187 .56079 L
.13287 .55969 L
.13387 .55717 L
.13487 .5559 L
.13586 .56002 L
.13686 .57124 L
.13786 .587 L
.13886 .60373 L
Mfstroke
.13886 .60373 m
.13983 .61803 L
s
.14388 .61803 m
.14486 .59895 L
.14585 .57245 L
.14685 .54075 L
.14785 .5061 L
.14885 .47097 L
.14985 .36739 L
.15085 .35298 L
.15185 .3397 L
.15285 .32838 L
.15385 .31928 L
.15485 .31241 L
.15584 .30758 L
.15684 .30453 L
.15784 .30296 L
.15884 .30255 L
.15984 .30304 L
.16084 .30418 L
.16184 .30578 L
.16284 .30769 L
.16384 .3098 L
.16484 .31201 L
.16583 .31427 L
.16683 .31656 L
.16783 .31884 L
.16883 .32111 L
.16983 .32336 L
.17083 .32561 L
.17183 .32785 L
.17283 .33011 L
.17383 .3324 L
.17483 .33473 L
.17582 .33712 L
.17682 .33959 L
.17782 .34215 L
.17882 .34482 L
.17982 .34761 L
.18082 .35052 L
.18182 .35358 L
.18282 .35678 L
.18382 .36013 L
.18482 .36361 L
.18581 .36722 L
.18681 .37093 L
.18781 .37471 L
.18881 .3785 L
.18981 .38223 L
.19081 .3858 L
.19181 .38907 L
.19281 .39186 L
Mistroke
.19381 .39396 L
.19481 .39506 L
.1958 .39481 L
.1968 .39276 L
.1978 .38835 L
.1988 .38094 L
.1998 .16827 L
.2008 .16567 L
.2018 .16168 L
.2028 .15717 L
.2038 .15252 L
.2048 .14805 L
.20579 .14401 L
.20679 .1407 L
.20779 .13845 L
.20879 .13762 L
.20979 .13862 L
.21079 .1419 L
.21179 .14794 L
.21279 .15718 L
.21379 .16988 L
.21479 .18604 L
.21578 .20528 L
.21678 .22687 L
.21778 .24984 L
.21878 .2731 L
.21978 .2956 L
.22078 .31646 L
.22178 .33501 L
.22278 .35086 L
.22378 .36391 L
.22478 .37423 L
.22577 .38209 L
.22677 .38781 L
.22777 .39177 L
.22877 .39433 L
.22977 .39583 L
.23077 .39655 L
.23177 .39675 L
.23277 .39666 L
.23377 .39645 L
.23477 .39627 L
.23576 .39625 L
.23676 .39647 L
.23776 .39702 L
.23876 .39794 L
.23976 .3993 L
.24076 .40111 L
.24176 .4034 L
.24276 .4062 L
Mistroke
.24376 .40951 L
.24476 .41336 L
.24575 .41775 L
.24675 .4227 L
.24775 .42822 L
.24875 .43433 L
.24975 .40122 L
.25075 .40826 L
.25175 .41425 L
.25275 .41986 L
.25375 .42527 L
.25475 .43053 L
.25574 .43567 L
.25674 .44067 L
.25774 .44549 L
.25874 .4501 L
.25974 .45443 L
.26074 .45844 L
.26174 .46205 L
.26274 .46521 L
.26374 .46786 L
.26474 .46996 L
.26573 .47147 L
.26673 .47239 L
.26773 .47272 L
.26873 .47249 L
.26973 .47176 L
.27073 .47058 L
.27173 .469 L
.27273 .46707 L
.27373 .46481 L
.27473 .46223 L
.27572 .45934 L
.27672 .45613 L
.27772 .4526 L
.27872 .44878 L
.27972 .4447 L
.28072 .44041 L
.28172 .436 L
.28272 .43153 L
.28372 .42709 L
.28472 .42279 L
.28571 .41869 L
.28671 .41489 L
.28771 .41144 L
.28871 .4084 L
.28971 .40579 L
.29071 .40364 L
.29171 .40196 L
.29271 .40074 L
Mistroke
.29371 .39998 L
.29471 .39966 L
.2957 .39976 L
.2967 .40025 L
.2977 .40113 L
.2987 .40236 L
.2997 .3569 L
.3007 .36258 L
.3017 .36727 L
.3027 .37166 L
.3037 .37596 L
.3047 .38029 L
.30569 .38472 L
.30669 .38928 L
.30769 .39402 L
.30869 .39895 L
.30969 .4041 L
.31069 .40947 L
.31169 .41507 L
.31269 .4209 L
.31369 .42695 L
.31469 .43319 L
.31568 .43961 L
.31668 .44617 L
.31768 .45281 L
.31868 .45948 L
.31968 .4661 L
.32068 .47258 L
.32168 .47881 L
.32268 .48468 L
.32368 .49006 L
.32468 .49483 L
.32567 .4989 L
.32667 .5022 L
.32767 .50474 L
.32867 .50665 L
.32967 .5082 L
.33067 .50983 L
.33167 .51194 L
.33267 .51479 L
.33367 .51824 L
.33467 .52187 L
.33566 .52507 L
.33666 .52721 L
.33766 .52774 L
.33866 .52624 L
.33966 .52239 L
.34066 .5161 L
.34166 .50744 L
.34266 .49666 L
Mistroke
.34366 .48419 L
.34466 .47056 L
.34565 .45639 L
.34665 .4423 L
.34765 .42886 L
.34865 .41656 L
.34965 .38811 L
.35065 .38264 L
.35165 .37661 L
.35265 .37077 L
.35365 .36542 L
.35465 .36071 L
.35564 .35671 L
.35664 .35344 L
.35764 .35089 L
.35864 .34903 L
.35964 .3478 L
.36064 .34714 L
.36164 .34699 L
.36264 .34729 L
.36364 .34798 L
.36464 .34901 L
.36563 .35035 L
.36663 .35196 L
.36763 .35381 L
.36863 .35589 L
.36963 .35818 L
.37063 .36067 L
.37163 .36337 L
.37263 .36629 L
.37363 .36941 L
.37463 .37277 L
.37562 .37637 L
.37662 .38023 L
.37762 .38437 L
.37862 .38881 L
.37962 .39357 L
.38062 .39868 L
.38162 .40416 L
.38262 .41004 L
.38362 .41636 L
.38462 .42313 L
.38561 .43039 L
.38661 .43817 L
.38761 .44649 L
.38861 .45539 L
.38961 .46487 L
.39061 .47497 L
.39161 .48569 L
.39261 .49702 L
Mistroke
.39361 .50896 L
.39461 .52149 L
.3956 .53454 L
.3966 .54803 L
.3976 .56186 L
.3986 .57587 L
.3996 .26572 L
.4006 .26378 L
.4016 .26067 L
.4026 .25706 L
.4036 .25312 L
.4046 .24888 L
.40559 .24437 L
.40659 .23954 L
.40759 .23437 L
.40859 .22883 L
.40959 .22287 L
.41059 .21648 L
.41159 .2096 L
.41259 .20223 L
.41359 .19434 L
.41459 .18595 L
.41558 .17709 L
.41658 .16784 L
.41758 .1584 L
.41858 .1491 L
.41958 .14055 L
.42058 .13389 L
.42158 .13101 L
.42258 .13451 L
.42358 .14631 L
.42458 .16634 L
.42557 .19319 L
.42657 .22498 L
.42757 .25972 L
.42857 .2953 L
.42957 .32965 L
.43057 .36094 L
.43157 .38777 L
.43257 .40938 L
.43357 .42561 L
.43457 .43689 L
.43556 .44405 L
.43656 .44809 L
.43756 .44998 L
.43856 .45053 L
.43956 .45031 L
.44056 .44964 L
.44156 .44869 L
.44256 .44751 L
Mistroke
.44356 .44616 L
.44456 .4447 L
.44555 .44317 L
.44655 .44165 L
.44755 .44019 L
.44855 .43884 L
.44955 .38704 L
.45055 .38981 L
.45155 .39151 L
.45255 .39282 L
.45355 .39395 L
.45455 .39502 L
.45554 .39611 L
.45654 .39724 L
.45754 .39846 L
.45854 .39977 L
.45954 .40118 L
.46054 .40271 L
.46154 .40436 L
.46254 .40612 L
.46354 .408 L
.46454 .40999 L
.46553 .41208 L
.46653 .41428 L
.46753 .41655 L
.46853 .41891 L
.46953 .42134 L
.47053 .42382 L
.47153 .42634 L
.47253 .42888 L
.47353 .43144 L
.47453 .43399 L
.47552 .43653 L
.47652 .43902 L
.47752 .44147 L
.47852 .44384 L
.47952 .44614 L
.48052 .44835 L
.48152 .45046 L
.48252 .45248 L
.48352 .4544 L
.48452 .45623 L
.48551 .45798 L
.48651 .45967 L
.48751 .46131 L
.48851 .4629 L
.48951 .46445 L
.49051 .46595 L
.49151 .4674 L
.49251 .46876 L
Mistroke
.49351 .46998 L
.49451 .47104 L
.4955 .47187 L
.4965 .47241 L
.4975 .47263 L
.4985 .47247 L
.4995 .39675 L
.5005 .38683 L
.5015 .37618 L
.5025 .36577 L
.5035 .35609 L
.5045 .34743 L
.50549 .33995 L
.50649 .33371 L
.50749 .32868 L
.50849 .32481 L
.50949 .32198 L
.51049 .32006 L
.51149 .31893 L
.51249 .31846 L
.51349 .31852 L
.51449 .31901 L
.51548 .31984 L
.51648 .32094 L
.51748 .32224 L
.51848 .3237 L
.51948 .32529 L
.52048 .32697 L
.52148 .32873 L
.52248 .33056 L
.52348 .33245 L
.52448 .33441 L
.52547 .33643 L
.52647 .33853 L
.52747 .3407 L
.52847 .34298 L
.52947 .34535 L
.53047 .34785 L
.53147 .35048 L
.53247 .35326 L
.53347 .35621 L
.53447 .35934 L
.53546 .36268 L
.53646 .36625 L
.53746 .37006 L
.53846 .37414 L
.53946 .37852 L
.54046 .3832 L
.54146 .38822 L
.54246 .3936 L
Mistroke
.54346 .39937 L
.54446 .40554 L
.54545 .41213 L
.54645 .41917 L
.54745 .42667 L
.54845 .43465 L
.54945 .39885 L
.55045 .40773 L
.55145 .41621 L
.55245 .42499 L
.55345 .43428 L
.55445 .44412 L
.55544 .45451 L
.55644 .46536 L
.55744 .4766 L
.55844 .48806 L
.55944 .49954 L
.56044 .5108 L
.56144 .52152 L
.56244 .53135 L
.56344 .53987 L
.56444 .54668 L
.56543 .55144 L
.56643 .55397 L
.56743 .55445 L
.56843 .55344 L
.56943 .55165 L
.57043 .54926 L
.57143 .54572 L
.57243 .54009 L
.57343 .5315 L
.57443 .51939 L
.57542 .50358 L
.57642 .48432 L
.57742 .46227 L
.57842 .43841 L
.57942 .41396 L
.58042 .39016 L
.58142 .36809 L
.58242 .3486 L
.58342 .33217 L
.58442 .31896 L
.58541 .30879 L
.58641 .30134 L
.58741 .29613 L
.58841 .29269 L
.58941 .29061 L
.59041 .28951 L
.59141 .28911 L
.59241 .28918 L
Mistroke
.59341 .28954 L
.59441 .29007 L
.5954 .29066 L
.5964 .29125 L
.5974 .29176 L
.5984 .29216 L
.5994 .24518 L
.6004 .24878 L
.6014 .25095 L
.6024 .25237 L
.6034 .25326 L
.6044 .25373 L
.60539 .25385 L
.60639 .25366 L
.60739 .2532 L
.60839 .25249 L
.60939 .25154 L
.61039 .25038 L
.61139 .24901 L
.61239 .24745 L
.61339 .2457 L
.61439 .24378 L
.61538 .2417 L
.61638 .23947 L
.61738 .23711 L
.61838 .23466 L
.61938 .23215 L
.62038 .22963 L
.62138 .22718 L
.62238 .22489 L
.62338 .22288 L
.62438 .2213 L
.62537 .22034 L
.62637 .22019 L
.62737 .22106 L
.62837 .22311 L
.62937 .22645 L
.63037 .23112 L
.63137 .23704 L
.63237 .24408 L
.63337 .25203 L
.63437 .26063 L
.63536 .26962 L
.63636 .27872 L
.63736 .28768 L
.63836 .29626 L
.63936 .30428 L
.64036 .31159 L
.64136 .3181 L
.64236 .32378 L
Mistroke
.64336 .32861 L
.64436 .33263 L
.64535 .33593 L
.64635 .33857 L
.64735 .34066 L
.64835 .34228 L
.64935 .27288 L
.65035 .27511 L
.65135 .27607 L
.65235 .2764 L
.65335 .27634 L
.65435 .27597 L
.65534 .27537 L
.65634 .27455 L
.65734 .27355 L
.65834 .27237 L
.65934 .27102 L
.66034 .26949 L
.66134 .26778 L
.66234 .26588 L
.66334 .26378 L
.66434 .26147 L
.66533 .25893 L
.66633 .25614 L
.66733 .25309 L
.66833 .24976 L
.66933 .24614 L
.67033 .2422 L
.67133 .23795 L
.67233 .2334 L
.67333 .22857 L
.67433 .22353 L
.67532 .21838 L
.67632 .21329 L
.67732 .20853 L
.67832 .20451 L
.67932 .20175 L
.68032 .20093 L
.68132 .20267 L
.68232 .20735 L
.68332 .21503 L
.68432 .2254 L
.68531 .23796 L
.68631 .25212 L
.68731 .26724 L
.68831 .28268 L
.68931 .29782 L
.69031 .3121 L
.69131 .32508 L
.69231 .33643 L
Mistroke
.69331 .34595 L
.69431 .3536 L
.6953 .35948 L
.6963 .36378 L
.6973 .36677 L
.6983 .36875 L
.6993 .30764 L
.7003 .3144 L
.7013 .31935 L
.7023 .32319 L
.7033 .32621 L
.7043 .32859 L
.70529 .33046 L
.70629 .33193 L
.70729 .33309 L
.70829 .33402 L
.70929 .33479 L
.71029 .33546 L
.71129 .33606 L
.71229 .33665 L
.71329 .33726 L
.71429 .33791 L
.71528 .33864 L
.71628 .33946 L
.71728 .34039 L
.71828 .34145 L
.71928 .34266 L
.72028 .34401 L
.72128 .34554 L
.72228 .34724 L
.72328 .34913 L
.72428 .35123 L
.72527 .35354 L
.72627 .35609 L
.72727 .35887 L
.72827 .36192 L
.72927 .36525 L
.73027 .36887 L
.73127 .37281 L
.73227 .37708 L
.73327 .38172 L
.73427 .38675 L
.73526 .39219 L
.73626 .39807 L
.73726 .40443 L
.73826 .41129 L
.73926 .41868 L
.74026 .42664 L
.74126 .43519 L
.74226 .44436 L
Mistroke
.74326 .45417 L
.74426 .46463 L
.74525 .47576 L
.74625 .48754 L
.74725 .49995 L
.74825 .51294 L
.74925 .13965 L
.75025 .13202 L
.75125 .1235 L
.75225 .11509 L
.75325 .1074 L
.75425 .10097 L
.75524 .09642 L
.75624 .09446 L
.75724 .09588 L
.75824 .10161 L
.75924 .11257 L
.76024 .12952 L
.76124 .15274 L
.76224 .1818 L
.76324 .21548 L
.76424 .25195 L
.76523 .28908 L
.76623 .32475 L
.76723 .3572 L
.76823 .38519 L
.76923 .40813 L
.77023 .426 L
.77123 .43921 L
.77223 .44841 L
.77323 .45437 L
.77423 .4578 L
.77522 .45936 L
.77622 .45956 L
.77722 .45884 L
.77822 .45752 L
.77922 .45582 L
.78022 .45391 L
.78122 .45189 L
.78222 .44985 L
.78322 .44781 L
.78422 .44581 L
.78521 .44386 L
.78621 .44199 L
.78721 .44021 L
.78821 .43854 L
.78921 .43701 L
.79021 .43566 L
.79121 .43452 L
.79221 .43364 L
Mistroke
.79321 .43305 L
.79421 .43279 L
.7952 .43287 L
.7962 .43331 L
.7972 .43409 L
.7982 .4352 L
.7992 .4228 L
.8002 .42652 L
.8012 .42892 L
.8022 .43062 L
.8032 .43181 L
.8042 .43255 L
.80519 .4329 L
.80619 .43287 L
.80719 .43251 L
.80819 .43183 L
.80919 .43087 L
.81019 .42966 L
.81119 .42824 L
.81219 .42666 L
.81319 .42495 L
.81419 .42316 L
.81518 .42134 L
.81618 .41952 L
.81718 .41774 L
.81818 .41604 L
.81918 .41443 L
.82018 .41296 L
.82118 .41162 L
.82218 .41045 L
.82318 .40944 L
.82418 .40861 L
.82517 .40796 L
.82617 .4075 L
.82717 .40723 L
.82817 .40714 L
.82917 .40723 L
.83017 .40751 L
.83117 .40797 L
.83217 .40861 L
.83317 .40942 L
.83417 .41041 L
.83516 .41155 L
.83616 .41286 L
.83716 .41433 L
.83816 .41594 L
.83916 .4177 L
.84016 .4196 L
.84116 .42163 L
.84216 .42379 L
Mistroke
.84316 .42606 L
.84416 .42843 L
.84515 .43091 L
.84615 .43346 L
.84715 .43609 L
.84815 .43877 L
.84915 .43314 L
.85015 .4339 L
.85115 .43289 L
.85215 .43083 L
.85315 .42797 L
.85415 .42451 L
.85514 .42059 L
.85614 .41637 L
.85714 .41198 L
.85814 .40754 L
.85914 .40317 L
.86014 .39897 L
.86114 .39501 L
.86214 .39137 L
.86314 .3881 L
.86414 .38522 L
.86513 .38276 L
.86613 .38072 L
.86713 .3791 L
.86813 .3779 L
.86913 .37708 L
.87013 .37665 L
.87113 .37656 L
.87213 .37682 L
.87313 .37738 L
.87413 .37824 L
.87512 .37938 L
.87612 .38078 L
.87712 .38243 L
.87812 .38433 L
.87912 .38646 L
.88012 .38883 L
.88112 .39142 L
.88212 .39424 L
.88312 .39729 L
.88412 .40056 L
.88511 .40407 L
.88611 .4078 L
.88711 .41175 L
.88811 .41594 L
.88911 .42035 L
.89011 .42499 L
.89111 .42983 L
.89211 .43488 L
Mistroke
.89311 .44012 L
.89411 .44552 L
.8951 .45105 L
.8961 .45669 L
.8971 .46238 L
.8981 .46807 L
.8991 .43501 L
.9001 .44745 L
.9011 .45895 L
.9021 .47011 L
.9031 .48102 L
.9041 .49156 L
.90509 .50156 L
.90609 .51076 L
.90709 .51885 L
.90809 .52549 L
.90909 .53035 L
.91009 .53315 L
.91109 .53366 L
.91209 .53184 L
.91309 .52776 L
.91409 .52159 L
.91508 .51347 L
.91608 .50348 L
.91708 .49164 L
.91808 .478 L
.91908 .46273 L
.92008 .44617 L
.92108 .42879 L
.92208 .41117 L
.92308 .39393 L
.92408 .37766 L
.92507 .36285 L
.92607 .34984 L
.92707 .33882 L
.92807 .32982 L
.92907 .32274 L
.93007 .3174 L
.93107 .31357 L
.93207 .31099 L
.93307 .30942 L
.93407 .30866 L
.93506 .30851 L
.93606 .30882 L
.93706 .30946 L
.93806 .31034 L
.93906 .31137 L
.94006 .3125 L
.94106 .31368 L
.94206 .31486 L
Mistroke
.94306 .31603 L
.94406 .31716 L
.94505 .31822 L
.94605 .31921 L
.94705 .32011 L
.94805 .32091 L
.94905 .27081 L
.95005 .27237 L
.95105 .2726 L
.95205 .27221 L
.95305 .27141 L
.95405 .2703 L
.95504 .26893 L
.95604 .26732 L
.95704 .26549 L
.95804 .26344 L
.95904 .26116 L
.96004 .25864 L
.96104 .25587 L
.96204 .25282 L
.96304 .24949 L
.96404 .24583 L
.96503 .24184 L
.96603 .23749 L
.96703 .23276 L
.96803 .22762 L
.96903 .22209 L
.97003 .21616 L
.97103 .2099 L
.97203 .20341 L
.97303 .19685 L
.97403 .19054 L
.97502 .18499 L
.97602 .18098 L
.97702 .17953 L
.97802 .18172 L
.97902 .18822 L
.98002 .19897 L
.98102 .21338 L
.98202 .23062 L
.98302 .24974 L
.98402 .26979 L
.98501 .28979 L
.98601 .30888 L
.98701 .3263 L
.98801 .3415 L
.98901 .35413 L
.99001 .36411 L
.99101 .37158 L
.99201 .37685 L
Mistroke
.99301 .38033 L
.99401 .38248 L
.995 .38373 L
.996 .38443 L
.997 .38483 L
.998 .38508 L
.999 .31876 L
Mfstroke
1 0 0 r
gsave
.999 .31245 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30145 L
.00799 .30034 L
.00899 .29913 L
.00999 .29781 L
.01099 .29634 L
.01199 .2947 L
.01299 .29287 L
.01399 .29082 L
.01499 .28853 L
.01598 .28595 L
.01698 .28306 L
.01798 .27981 L
.01898 .27616 L
.01998 .27205 L
.02098 .26745 L
.02198 .26228 L
.02298 .25648 L
.02398 .24997 L
.02498 .24269 L
.02597 .23454 L
.02697 .22543 L
.02797 .21529 L
.02897 .204 L
.02997 .19149 L
.03097 .17769 L
.03197 .16254 L
.03297 .14602 L
.03397 .12817 L
.03497 .10913 L
.03596 .08912 L
.03696 .06855 L
.03796 .04804 L
.03896 .02846 L
.03996 .01102 L
s
.03996 .01102 m
.04076 0 L
s
.04408 0 m
.04496 .01782 L
.04595 .0505 L
.04695 .09496 L
.04795 .14905 L
.04895 .20897 L
.04995 .02677 L
.05095 .05304 L
.05195 .08958 L
.05295 .13497 L
.05395 .18646 L
.05495 .24029 L
.05594 .29231 L
.05694 .33886 L
.05794 .37743 L
.05894 .407 L
.05994 .42789 L
.06094 .44137 L
.06194 .44907 L
.06294 .45267 L
.06394 .45358 L
.06494 .45289 L
.06593 .45137 L
.06693 .44952 L
.06793 .44766 L
.06893 .44596 L
.06993 .44447 L
.07093 .44322 L
.07193 .44217 L
.07293 .44128 L
.07393 .44049 L
.07493 .43974 L
.07592 .43896 L
.07692 .4381 L
.07792 .43712 L
.07892 .43596 L
.07992 .43461 L
.08092 .43303 L
.08192 .43122 L
.08292 .42918 L
.08392 .42693 L
.08492 .42447 L
.08591 .42185 L
.08691 .4191 L
.08791 .41625 L
.08891 .41337 L
.08991 .4105 L
.09091 .40768 L
.09191 .40496 L
.09291 .40239 L
Mistroke
.09391 .4 L
.09491 .39783 L
.0959 .3959 L
.0969 .39424 L
.0979 .39287 L
.0989 .39178 L
.0999 .33077 L
.1009 .33251 L
.1019 .33435 L
.1029 .33628 L
.1039 .33831 L
.1049 .34046 L
.10589 .34273 L
.10689 .34515 L
.10789 .34772 L
.10889 .35047 L
.10989 .35341 L
.11089 .35657 L
.11189 .35996 L
.11289 .36361 L
.11389 .36753 L
.11489 .37176 L
.11588 .37631 L
.11688 .38119 L
.11788 .38645 L
.11888 .39208 L
.11988 .3981 L
.12088 .40453 L
.12188 .41136 L
.12288 .4186 L
.12388 .42621 L
.12488 .43417 L
.12587 .44243 L
.12687 .4509 L
.12787 .45949 L
.12887 .46805 L
.12987 .47641 L
.13087 .48434 L
.13187 .49158 L
.13287 .49783 L
.13387 .50273 L
.13487 .5059 L
.13586 .50697 L
.13686 .50558 L
.13786 .5014 L
.13886 .49424 L
.13986 .48402 L
.14086 .47084 L
.14186 .45501 L
.14286 .43702 L
Mistroke
.14386 .41755 L
.14486 .39736 L
.14585 .37728 L
.14685 .35807 L
.14785 .34038 L
.14885 .32467 L
.14985 .36105 L
.15085 .34241 L
.15185 .32585 L
.15285 .31175 L
.15385 .30025 L
.15485 .29127 L
.15584 .28459 L
.15684 .27992 L
.15784 .27691 L
.15884 .2752 L
.15984 .2745 L
.16084 .27452 L
.16184 .27502 L
.16284 .27582 L
.16384 .27677 L
.16484 .27775 L
.16583 .27868 L
.16683 .27951 L
.16783 .28017 L
.16883 .28065 L
.16983 .28093 L
.17083 .28098 L
.17183 .28081 L
.17283 .2804 L
.17383 .27977 L
.17483 .27889 L
.17582 .27778 L
.17682 .27643 L
.17782 .27483 L
.17882 .27298 L
.17982 .27086 L
.18082 .26848 L
.18182 .26582 L
.18282 .26286 L
.18382 .25958 L
.18482 .25598 L
.18581 .25202 L
.18681 .24769 L
.18781 .24297 L
.18881 .23782 L
.18981 .23224 L
.19081 .22618 L
.19181 .21964 L
.19281 .2126 L
Mistroke
.19381 .20504 L
.19481 .19697 L
.1958 .1884 L
.1968 .17935 L
.1978 .16986 L
.1988 .16002 L
.1998 .16202 L
.2008 .15539 L
.2018 .14843 L
.2028 .14135 L
.2038 .13435 L
.2048 .12769 L
.20579 .12166 L
.20679 .11658 L
.20779 .11279 L
.20879 .11064 L
.20979 .11051 L
.21079 .1127 L
.21179 .11751 L
.21279 .1251 L
.21379 .13552 L
.21479 .14865 L
.21578 .16422 L
.21678 .18177 L
.21778 .20069 L
.21878 .22028 L
.21978 .2398 L
.22078 .25855 L
.22178 .27594 L
.22278 .2915 L
.22378 .30497 L
.22478 .31622 L
.22577 .32529 L
.22677 .33234 L
.22777 .33757 L
.22877 .34126 L
.22977 .34368 L
.23077 .3451 L
.23177 .34575 L
.23277 .34584 L
.23377 .34555 L
.23477 .34503 L
.23576 .34439 L
.23676 .34372 L
.23776 .3431 L
.23876 .34257 L
.23976 .34218 L
.24076 .34196 L
.24176 .34193 L
.24276 .34209 L
Mistroke
.24376 .34247 L
.24476 .34307 L
.24575 .34389 L
.24675 .34494 L
.24775 .34622 L
.24875 .34774 L
.24975 .39499 L
.25075 .39803 L
.25175 .40115 L
.25275 .40435 L
.25375 .4076 L
.25475 .41087 L
.25574 .41415 L
.25674 .41739 L
.25774 .42056 L
.25874 .42362 L
.25974 .42652 L
.26074 .4292 L
.26174 .43163 L
.26274 .43374 L
.26374 .43546 L
.26474 .43675 L
.26573 .43754 L
.26673 .43778 L
.26773 .43743 L
.26873 .43645 L
.26973 .43481 L
.27073 .43251 L
.27173 .42956 L
.27273 .42599 L
.27373 .42183 L
.27473 .41716 L
.27572 .41206 L
.27672 .40662 L
.27772 .40096 L
.27872 .39518 L
.27972 .38939 L
.28072 .38371 L
.28172 .37823 L
.28272 .37304 L
.28372 .36821 L
.28472 .3638 L
.28571 .35984 L
.28671 .35637 L
.28771 .35337 L
.28871 .35086 L
.28971 .34882 L
.29071 .34722 L
.29171 .34604 L
.29271 .34525 L
Mistroke
.29371 .34481 L
.29471 .34471 L
.2957 .34489 L
.2967 .34535 L
.2977 .34605 L
.2987 .34697 L
.2997 .35063 L
.3007 .35236 L
.3017 .35425 L
.3027 .35631 L
.3037 .35852 L
.3047 .36091 L
.30569 .36347 L
.30669 .3662 L
.30769 .36911 L
.30869 .37222 L
.30969 .37552 L
.31069 .37902 L
.31169 .38273 L
.31269 .38664 L
.31369 .39077 L
.31469 .3951 L
.31568 .39964 L
.31668 .40437 L
.31768 .40929 L
.31868 .41436 L
.31968 .41956 L
.32068 .42486 L
.32168 .4302 L
.32268 .43553 L
.32368 .44077 L
.32468 .44583 L
.32567 .45062 L
.32667 .45502 L
.32767 .45889 L
.32867 .46211 L
.32967 .46452 L
.33067 .46597 L
.33167 .46632 L
.33267 .46545 L
.33367 .46324 L
.33467 .45964 L
.33566 .4546 L
.33666 .44817 L
.33766 .44043 L
.33866 .43154 L
.33966 .42169 L
.34066 .41114 L
.34166 .40019 L
.34266 .38912 L
Mistroke
.34366 .37823 L
.34466 .36779 L
.34565 .35803 L
.34665 .34911 L
.34765 .34117 L
.34865 .33426 L
.34965 .38179 L
.35065 .37229 L
.35165 .3633 L
.35265 .35498 L
.35365 .34747 L
.35465 .34083 L
.35564 .33509 L
.35664 .33027 L
.35764 .32631 L
.35864 .32316 L
.35964 .32075 L
.36064 .31899 L
.36164 .31781 L
.36264 .31712 L
.36364 .31684 L
.36464 .3169 L
.36563 .31725 L
.36663 .31783 L
.36763 .31859 L
.36863 .3195 L
.36963 .32054 L
.37063 .32167 L
.37163 .32288 L
.37263 .32416 L
.37363 .3255 L
.37463 .32691 L
.37562 .32838 L
.37662 .32991 L
.37762 .33151 L
.37862 .33318 L
.37962 .33494 L
.38062 .3368 L
.38162 .33876 L
.38262 .34084 L
.38362 .34305 L
.38462 .34541 L
.38561 .34793 L
.38661 .35063 L
.38761 .35353 L
.38861 .35664 L
.38961 .35998 L
.39061 .36357 L
.39161 .36743 L
.39261 .37158 L
Mistroke
.39361 .37604 L
.39461 .38082 L
.3956 .38594 L
.3966 .39142 L
.3976 .39727 L
.3986 .40349 L
.3996 .25947 L
.4006 .25351 L
.4016 .24741 L
.4026 .24111 L
.4036 .23456 L
.4046 .22769 L
.40559 .22048 L
.40659 .21289 L
.40759 .2049 L
.40859 .19649 L
.40959 .18768 L
.41059 .17848 L
.41159 .16895 L
.41259 .15916 L
.41359 .14922 L
.41459 .13929 L
.41558 .12956 L
.41658 .12028 L
.41758 .11178 L
.41858 .10442 L
.41958 .09863 L
.42058 .09488 L
.42158 .09366 L
.42258 .09545 L
.42358 .10068 L
.42458 .10964 L
.42557 .12249 L
.42657 .13914 L
.42757 .15923 L
.42857 .18214 L
.42957 .20703 L
.43057 .23286 L
.43157 .25856 L
.43257 .28309 L
.43357 .30559 L
.43457 .32545 L
.43556 .34231 L
.43656 .35609 L
.43756 .36691 L
.43856 .37505 L
.43956 .38089 L
.44056 .38482 L
.44156 .38724 L
.44256 .3885 L
Mistroke
.44356 .38891 L
.44456 .38872 L
.44555 .38815 L
.44655 .38734 L
.44755 .38643 L
.44855 .38551 L
.44955 .38074 L
.45055 .37961 L
.45155 .37857 L
.45255 .37765 L
.45355 .37687 L
.45455 .37624 L
.45554 .37577 L
.45654 .37546 L
.45754 .37532 L
.45854 .37534 L
.45954 .37552 L
.46054 .37585 L
.46154 .37634 L
.46254 .37697 L
.46354 .37774 L
.46454 .37864 L
.46553 .37967 L
.46653 .38081 L
.46753 .38207 L
.46853 .38343 L
.46953 .38489 L
.47053 .38643 L
.47153 .38805 L
.47253 .38974 L
.47353 .39148 L
.47453 .39326 L
.47552 .39508 L
.47652 .39691 L
.47752 .39874 L
.47852 .40056 L
.47952 .40235 L
.48052 .40408 L
.48152 .40575 L
.48252 .40731 L
.48352 .40877 L
.48452 .41008 L
.48551 .41123 L
.48651 .4122 L
.48751 .41296 L
.48851 .41349 L
.48951 .41377 L
.49051 .41379 L
.49151 .41353 L
.49251 .41297 L
Mistroke
.49351 .41212 L
.49451 .41097 L
.4955 .40953 L
.4965 .40781 L
.4975 .40582 L
.4985 .40358 L
.4995 .39045 L
.5005 .37647 L
.5015 .36281 L
.5025 .34987 L
.5035 .33797 L
.5045 .32733 L
.50549 .31809 L
.50649 .31029 L
.50749 .30388 L
.50849 .29878 L
.50949 .29485 L
.51049 .29196 L
.51149 .28993 L
.51249 .28862 L
.51349 .28789 L
.51449 .2876 L
.51548 .28764 L
.51648 .28792 L
.51748 .28837 L
.51848 .2889 L
.51948 .28948 L
.52048 .29006 L
.52148 .29062 L
.52248 .29111 L
.52348 .29153 L
.52448 .29187 L
.52547 .29211 L
.52647 .29225 L
.52747 .29229 L
.52847 .29221 L
.52947 .29203 L
.53047 .29173 L
.53147 .29133 L
.53247 .29081 L
.53347 .29017 L
.53447 .28942 L
.53546 .28854 L
.53646 .28755 L
.53746 .28643 L
.53846 .28517 L
.53946 .28378 L
.54046 .28224 L
.54146 .28054 L
.54246 .27868 L
Mistroke
.54346 .27665 L
.54446 .27443 L
.54545 .272 L
.54645 .26936 L
.54745 .2665 L
.54845 .26338 L
.54945 .3926 L
.55045 .39746 L
.55145 .40297 L
.55245 .40912 L
.55345 .41587 L
.55445 .42321 L
.55544 .43109 L
.55644 .43946 L
.55744 .44825 L
.55844 .45738 L
.55944 .46672 L
.56044 .47611 L
.56144 .48536 L
.56244 .49421 L
.56344 .50236 L
.56444 .50944 L
.56543 .51505 L
.56643 .51873 L
.56743 .52002 L
.56843 .51845 L
.56943 .51362 L
.57043 .50523 L
.57143 .49313 L
.57243 .47741 L
.57343 .45838 L
.57443 .43662 L
.57542 .41293 L
.57642 .38826 L
.57742 .36365 L
.57842 .34007 L
.57942 .31835 L
.58042 .2991 L
.58142 .28267 L
.58242 .26916 L
.58342 .25848 L
.58442 .25037 L
.58541 .24449 L
.58641 .24047 L
.58741 .23794 L
.58841 .23655 L
.58941 .23601 L
.59041 .23607 L
.59141 .23653 L
.59241 .23722 L
Mistroke
.59341 .23802 L
.59441 .23884 L
.5954 .23961 L
.5964 .24027 L
.5974 .2408 L
.5984 .24116 L
.5994 .23893 L
.6004 .23859 L
.6014 .23799 L
.6024 .23713 L
.6034 .236 L
.6044 .23463 L
.60539 .23301 L
.60639 .23116 L
.60739 .22909 L
.60839 .22681 L
.60939 .22433 L
.61039 .22169 L
.61139 .21888 L
.61239 .21594 L
.61339 .21288 L
.61439 .20974 L
.61538 .20653 L
.61638 .20331 L
.61738 .2001 L
.61838 .19694 L
.61938 .1939 L
.62038 .191 L
.62138 .18833 L
.62238 .18592 L
.62338 .18385 L
.62438 .18219 L
.62537 .18099 L
.62637 .18032 L
.62737 .18024 L
.62837 .1808 L
.62937 .18204 L
.63037 .18398 L
.63137 .18663 L
.63237 .18999 L
.63337 .19403 L
.63437 .19869 L
.63536 .2039 L
.63636 .20957 L
.63736 .2156 L
.63836 .22187 L
.63936 .22827 L
.64036 .23466 L
.64136 .24093 L
.64236 .24697 L
Mistroke
.64336 .2527 L
.64436 .25804 L
.64535 .26292 L
.64635 .26731 L
.64735 .2712 L
.64835 .27456 L
.64935 .26657 L
.65035 .26488 L
.65135 .26305 L
.65235 .26106 L
.65335 .25892 L
.65435 .25662 L
.65534 .25416 L
.65634 .25152 L
.65734 .24871 L
.65834 .24571 L
.65934 .24254 L
.66034 .23917 L
.66134 .23561 L
.66234 .23186 L
.66334 .22792 L
.66434 .22379 L
.66533 .21948 L
.66633 .215 L
.66733 .21037 L
.66833 .2056 L
.66933 .20074 L
.67033 .19581 L
.67133 .19087 L
.67233 .18596 L
.67333 .18117 L
.67433 .17656 L
.67532 .17224 L
.67632 .1683 L
.67732 .16487 L
.67832 .16205 L
.67932 .15999 L
.68032 .15881 L
.68132 .15863 L
.68232 .15956 L
.68332 .1617 L
.68432 .16509 L
.68531 .16977 L
.68631 .17571 L
.68731 .18284 L
.68831 .19102 L
.68931 .2001 L
.69031 .20986 L
.69131 .22005 L
.69231 .23042 L
Mistroke
.69331 .24071 L
.69431 .25069 L
.6953 .26015 L
.6963 .2689 L
.6973 .27684 L
.6983 .28388 L
.6993 .30132 L
.7003 .30416 L
.7013 .30635 L
.7023 .30795 L
.7033 .30907 L
.7043 .30976 L
.70529 .31012 L
.70629 .31019 L
.70729 .31004 L
.70829 .30971 L
.70929 .30925 L
.71029 .30868 L
.71129 .30805 L
.71229 .30736 L
.71329 .30664 L
.71429 .30589 L
.71528 .30513 L
.71628 .30436 L
.71728 .30358 L
.71828 .3028 L
.71928 .30201 L
.72028 .30122 L
.72128 .30041 L
.72228 .29959 L
.72328 .29874 L
.72428 .29787 L
.72527 .29696 L
.72627 .29602 L
.72727 .29503 L
.72827 .29398 L
.72927 .29287 L
.73027 .29169 L
.73127 .29042 L
.73227 .28907 L
.73327 .28762 L
.73427 .28605 L
.73526 .28436 L
.73626 .28254 L
.73726 .28056 L
.73826 .27842 L
.73926 .27611 L
.74026 .2736 L
.74126 .27088 L
.74226 .26792 L
Mistroke
.74326 .26472 L
.74426 .26124 L
.74525 .25748 L
.74625 .25339 L
.74725 .24897 L
.74825 .24418 L
.74925 .1334 L
.75025 .12172 L
.75125 .11021 L
.75225 .09924 L
.75325 .08925 L
.75425 .08081 L
.75524 .07453 L
.75624 .07112 L
.75724 .07129 L
.75824 .07574 L
.75924 .08502 L
.76024 .09948 L
.76124 .11915 L
.76224 .14364 L
.76324 .17214 L
.76424 .20343 L
.76523 .236 L
.76623 .26825 L
.76723 .29866 L
.76823 .326 L
.76923 .34946 L
.77023 .36867 L
.77123 .38369 L
.77223 .39485 L
.77323 .40268 L
.77423 .40779 L
.77522 .41076 L
.77622 .41214 L
.77722 .41236 L
.77822 .4118 L
.77922 .41073 L
.78022 .40934 L
.78122 .4078 L
.78222 .40621 L
.78322 .40462 L
.78422 .4031 L
.78521 .40166 L
.78621 .40033 L
.78721 .3991 L
.78821 .39799 L
.78921 .39698 L
.79021 .39607 L
.79121 .39525 L
.79221 .39453 L
Mistroke
.79321 .39389 L
.79421 .39332 L
.7952 .39283 L
.7962 .39239 L
.7972 .39202 L
.7982 .39169 L
.7992 .41653 L
.8002 .41629 L
.8012 .41587 L
.8022 .41525 L
.8032 .41442 L
.8042 .41337 L
.80519 .41209 L
.80619 .41058 L
.80719 .40885 L
.80819 .40691 L
.80919 .40477 L
.81019 .40246 L
.81119 .40001 L
.81219 .39744 L
.81319 .39478 L
.81419 .39208 L
.81518 .38936 L
.81618 .38666 L
.81718 .38401 L
.81818 .38144 L
.81918 .37899 L
.82018 .37667 L
.82118 .37452 L
.82218 .37254 L
.82318 .37075 L
.82418 .36917 L
.82517 .36779 L
.82617 .36663 L
.82717 .36567 L
.82817 .36493 L
.82917 .36439 L
.83017 .36406 L
.83117 .36392 L
.83217 .36397 L
.83317 .36419 L
.83417 .3646 L
.83516 .36517 L
.83616 .36589 L
.83716 .36677 L
.83816 .36779 L
.83916 .36896 L
.84016 .37026 L
.84116 .37168 L
.84216 .37323 L
Mistroke
.84316 .3749 L
.84416 .37669 L
.84515 .37859 L
.84615 .38059 L
.84715 .38269 L
.84815 .38488 L
.84915 .42689 L
.85015 .42365 L
.85115 .41978 L
.85215 .41534 L
.85315 .41041 L
.85415 .4051 L
.85514 .3995 L
.85614 .39373 L
.85714 .38791 L
.85814 .38215 L
.85914 .37655 L
.86014 .37119 L
.86114 .36617 L
.86214 .36153 L
.86314 .35732 L
.86414 .35358 L
.86513 .35031 L
.86613 .34751 L
.86713 .34518 L
.86813 .3433 L
.86913 .34183 L
.87013 .34076 L
.87113 .34004 L
.87213 .33965 L
.87313 .33956 L
.87413 .33973 L
.87512 .34015 L
.87612 .34078 L
.87712 .34161 L
.87812 .34262 L
.87912 .34379 L
.88012 .34511 L
.88112 .34658 L
.88212 .34819 L
.88312 .34993 L
.88412 .35181 L
.88511 .35382 L
.88611 .35597 L
.88711 .35826 L
.88811 .36069 L
.88911 .36328 L
.89011 .36602 L
.89111 .36893 L
.89211 .372 L
Mistroke
.89311 .37525 L
.89411 .37867 L
.8951 .38229 L
.8961 .38608 L
.8971 .39007 L
.8981 .39423 L
.8991 .42877 L
.9001 .43719 L
.9011 .44576 L
.9021 .4544 L
.9031 .463 L
.9041 .47141 L
.90509 .47946 L
.90609 .48691 L
.90709 .49352 L
.90809 .49896 L
.90909 .5029 L
.91009 .505 L
.91109 .50489 L
.91209 .50226 L
.91309 .49685 L
.91409 .4885 L
.91508 .4772 L
.91608 .4631 L
.91708 .44652 L
.91808 .42799 L
.91908 .40814 L
.92008 .38772 L
.92108 .36751 L
.92208 .34821 L
.92308 .33042 L
.92408 .31457 L
.92507 .30093 L
.92607 .28957 L
.92707 .28044 L
.92807 .27336 L
.92907 .26808 L
.93007 .26434 L
.93107 .26185 L
.93207 .26035 L
.93307 .25959 L
.93407 .25937 L
.93506 .25952 L
.93606 .25989 L
.93706 .26038 L
.93806 .26088 L
.93906 .26134 L
.94006 .26169 L
.94106 .26191 L
.94206 .26195 L
Mistroke
.94306 .26181 L
.94406 .26146 L
.94505 .2609 L
.94605 .26012 L
.94705 .25911 L
.94805 .25788 L
.94905 .26459 L
.95005 .26217 L
.95105 .25958 L
.95205 .25679 L
.95305 .25381 L
.95405 .25062 L
.95504 .24721 L
.95604 .24357 L
.95704 .23969 L
.95804 .23556 L
.95904 .23118 L
.96004 .22654 L
.96104 .22163 L
.96204 .21647 L
.96304 .21106 L
.96404 .20541 L
.96503 .19955 L
.96603 .19352 L
.96703 .18734 L
.96803 .18109 L
.96903 .17484 L
.97003 .16868 L
.97103 .16272 L
.97203 .1571 L
.97303 .15196 L
.97403 .14749 L
.97502 .14387 L
.97602 .14131 L
.97702 .14 L
.97802 .14014 L
.97902 .14191 L
.98002 .14544 L
.98102 .15081 L
.98202 .15803 L
.98302 .16703 L
.98402 .17765 L
.98501 .18963 L
.98601 .20264 L
.98701 .21631 L
.98801 .23021 L
.98901 .24393 L
.99001 .25708 L
.99101 .26935 L
.99201 .28049 L
Mistroke
.99301 .29033 L
.99401 .2988 L
.995 .3059 L
.996 .31168 L
.997 .31625 L
.998 .31973 L
.999 .31245 L
Mfstroke
0 g
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .27977 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.04995 .40282 m
.05095 .44078 L
.05195 .47174 L
.05295 .49356 L
.05395 .50437 L
.05495 .50333 L
.05594 .49104 L
.05694 .46943 L
.05794 .44129 L
.05894 .40965 L
.05994 .37711 L
.06094 .34554 L
.06194 .31603 L
.06294 .28902 L
.06394 .26456 L
.06494 .24252 L
.06593 .22265 L
.06693 .20474 L
.06793 .18862 L
.06893 .17418 L
.06993 .1614 L
.07093 .1503 L
.07193 .14098 L
.07293 .13355 L
.07393 .12816 L
.07493 .12497 L
.07592 .12411 L
.07692 .1257 L
.07792 .12982 L
.07892 .13647 L
.07992 .14559 L
.08092 .15701 L
.08192 .17047 L
.08292 .18553 L
.08392 .20155 L
.08492 .21764 L
.08591 .23243 L
.08691 .24394 L
.08791 .24977 L
.08891 .24836 L
.08991 .24042 L
.09091 .22827 L
.09191 .21408 L
.09291 .19936 L
.09391 .18508 L
.09491 .17182 L
.0959 .15996 L
.0969 .14972 L
.0979 .14121 L
.0989 .13447 L
Mistroke
.0999 .22465 L
.1009 .21487 L
.1019 .20636 L
.1029 .19851 L
.1039 .19116 L
.1049 .18421 L
.10589 .17762 L
.10689 .17136 L
.10789 .16541 L
.10889 .15974 L
.10989 .15436 L
.11089 .14924 L
.11189 .14438 L
.11289 .13976 L
.11389 .13537 L
.11489 .13118 L
.11588 .12718 L
.11688 .12333 L
.11788 .1196 L
.11888 .11594 L
.11988 .11233 L
.12088 .1087 L
.12188 .10503 L
.12288 .1013 L
.12388 .09748 L
.12488 .09358 L
.12587 .08965 L
.12687 .08576 L
.12787 .08203 L
.12887 .07865 L
.12987 .07587 L
.13087 .07403 L
.13187 .07357 L
.13287 .07501 L
.13387 .07899 L
.13487 .08621 L
.13586 .09739 L
.13686 .1132 L
.13786 .13414 L
.13886 .16042 L
.13986 .19175 L
.14086 .22721 L
.14186 .26501 L
.14286 .3023 L
.14386 .33459 L
.14486 .3551 L
.14585 .35757 L
.14685 .34429 L
.14785 .32361 L
.14885 .30163 L
Mistroke
.14985 .39686 L
.15085 .38783 L
.15185 .37656 L
.15285 .36335 L
.15385 .34885 L
.15485 .33369 L
.15584 .31842 L
.15684 .30343 L
.15784 .28899 L
.15884 .27526 L
.15984 .2623 L
.16084 .25011 L
.16184 .23867 L
.16284 .22791 L
.16384 .21779 L
.16484 .20823 L
.16583 .19918 L
.16683 .19059 L
.16783 .18241 L
.16883 .1746 L
.16983 .16713 L
.17083 .15997 L
.17183 .15309 L
.17283 .14647 L
.17383 .14008 L
.17483 .13392 L
.17582 .12794 L
.17682 .12213 L
.17782 .11646 L
.17882 .1109 L
.17982 .10541 L
.18082 .09994 L
.18182 .09444 L
.18282 .08884 L
.18382 .08308 L
.18482 .07706 L
.18581 .07069 L
.18681 .06386 L
.18781 .05645 L
.18881 .04832 L
.18981 .03934 L
.19081 .02937 L
.19181 .01825 L
.19281 .00584 L
Mfstroke
.19281 .00584 m
.19323 0 L
s
.19918 0 m
.1998 .16682 L
.2008 .16815 L
.2018 .17193 L
.2028 .1775 L
.2038 .18463 L
.2048 .19319 L
.20579 .20308 L
.20679 .21421 L
.20779 .22645 L
.20879 .23969 L
.20979 .25376 L
.21079 .26847 L
.21179 .28356 L
.21279 .29871 L
.21379 .31354 L
.21479 .32759 L
.21578 .34035 L
.21678 .35129 L
.21778 .35988 L
.21878 .36564 L
.21978 .36826 L
.22078 .36757 L
.22178 .36371 L
.22278 .35704 L
.22378 .34813 L
.22478 .33764 L
.22577 .32621 L
.22677 .31437 L
.22777 .30252 L
.22877 .29093 L
.22977 .27976 L
.23077 .26906 L
.23177 .25887 L
.23277 .24917 L
.23377 .23991 L
.23477 .23107 L
.23576 .22261 L
.23676 .21447 L
.23776 .20664 L
.23876 .19907 L
.23976 .19173 L
.24076 .18462 L
.24176 .17768 L
.24276 .17091 L
.24376 .16429 L
.24476 .15777 L
.24575 .15135 L
.24675 .14499 L
.24775 .13865 L
Mistroke
.24875 .1323 L
.24975 .22955 L
.25075 .22526 L
.25175 .22249 L
.25275 .22056 L
.25375 .21927 L
.25475 .21851 L
.25574 .21823 L
.25674 .21837 L
.25774 .2189 L
.25874 .2198 L
.25974 .22105 L
.26074 .22262 L
.26174 .2245 L
.26274 .22668 L
.26374 .22915 L
.26474 .23189 L
.26573 .2349 L
.26673 .23817 L
.26773 .24169 L
.26873 .24542 L
.26973 .24935 L
.27073 .25344 L
.27173 .25763 L
.27273 .26186 L
.27373 .26604 L
.27473 .27008 L
.27572 .27386 L
.27672 .27728 L
.27772 .28021 L
.27872 .28253 L
.27972 .28414 L
.28072 .28494 L
.28172 .2849 L
.28272 .28398 L
.28372 .2822 L
.28472 .27961 L
.28571 .27629 L
.28671 .27234 L
.28771 .26785 L
.28871 .26294 L
.28971 .25771 L
.29071 .25224 L
.29171 .24661 L
.29271 .24088 L
.29371 .2351 L
.29471 .2293 L
.2957 .22352 L
.2967 .21777 L
.2977 .21207 L
Mistroke
.2987 .20643 L
.2997 .23743 L
.3007 .22904 L
.3017 .22202 L
.3027 .2157 L
.3037 .20988 L
.3047 .20448 L
.30569 .19944 L
.30669 .19472 L
.30769 .19031 L
.30869 .18619 L
.30969 .18234 L
.31069 .17876 L
.31169 .17542 L
.31269 .17233 L
.31369 .16947 L
.31469 .16683 L
.31568 .1644 L
.31668 .16218 L
.31768 .16018 L
.31868 .15838 L
.31968 .15683 L
.32068 .15553 L
.32168 .15454 L
.32268 .15389 L
.32368 .15368 L
.32468 .15398 L
.32567 .1549 L
.32667 .15656 L
.32767 .15911 L
.32867 .1627 L
.32967 .16748 L
.33067 .1736 L
.33167 .1812 L
.33267 .19036 L
.33367 .20111 L
.33467 .21339 L
.33566 .22702 L
.33666 .24166 L
.33766 .25684 L
.33866 .27187 L
.33966 .28591 L
.34066 .29797 L
.34166 .30701 L
.34266 .31221 L
.34366 .31323 L
.34466 .31042 L
.34565 .30465 L
.34665 .29696 L
.34765 .28823 L
Mistroke
.34865 .27911 L
.34965 .36127 L
.35065 .3565 L
.35165 .35146 L
.35265 .3457 L
.35365 .33919 L
.35465 .33203 L
.35564 .32437 L
.35664 .31634 L
.35764 .30808 L
.35864 .2997 L
.35964 .2913 L
.36064 .28295 L
.36164 .27471 L
.36264 .26662 L
.36364 .2587 L
.36464 .25098 L
.36563 .24347 L
.36663 .23616 L
.36763 .22905 L
.36863 .22214 L
.36963 .21543 L
.37063 .20891 L
.37163 .20257 L
.37263 .1964 L
.37363 .19041 L
.37463 .18457 L
.37562 .17888 L
.37662 .17333 L
.37762 .16792 L
.37862 .16263 L
.37962 .15744 L
.38062 .15234 L
.38162 .14731 L
.38262 .14233 L
.38362 .13736 L
.38462 .13238 L
.38561 .12734 L
.38661 .12219 L
.38761 .11689 L
.38861 .11136 L
.38961 .10554 L
.39061 .09935 L
.39161 .0927 L
.39261 .08552 L
.39361 .07769 L
.39461 .06914 L
.3956 .05975 L
.3966 .04943 L
.3976 .03807 L
Mistroke
.3986 .02556 L
.3996 .11246 L
.4006 .10783 L
.4016 .10469 L
.4026 .10238 L
.4036 .10072 L
.4046 .09963 L
.40559 .09908 L
.40659 .09906 L
.40759 .09954 L
.40859 .10052 L
.40959 .10201 L
.41059 .10401 L
.41159 .10653 L
.41259 .10961 L
.41359 .1133 L
.41459 .11772 L
.41558 .12297 L
.41658 .12924 L
.41758 .13672 L
.41858 .14567 L
.41958 .15635 L
.42058 .16907 L
.42158 .18411 L
.42258 .2017 L
.42358 .222 L
.42458 .24495 L
.42557 .27026 L
.42657 .29727 L
.42757 .32488 L
.42857 .35153 L
.42957 .37512 L
.43057 .39307 L
.43157 .40259 L
.43257 .40212 L
.43357 .3931 L
.43457 .37905 L
.43556 .3632 L
.43656 .34761 L
.43756 .33335 L
.43856 .32082 L
.43956 .31005 L
.44056 .30084 L
.44156 .29289 L
.44256 .28588 L
.44356 .27952 L
.44456 .27355 L
.44555 .26777 L
.44655 .26203 L
.44755 .25625 L
Mistroke
.44855 .2504 L
.44955 .30256 L
.45055 .29393 L
.45155 .28681 L
.45255 .28049 L
.45355 .27472 L
.45455 .26938 L
.45554 .2644 L
.45654 .2597 L
.45754 .25526 L
.45854 .25104 L
.45954 .24702 L
.46054 .24317 L
.46154 .2395 L
.46254 .23597 L
.46354 .2326 L
.46454 .22935 L
.46553 .22624 L
.46653 .22326 L
.46753 .2204 L
.46853 .21767 L
.46953 .21505 L
.47053 .21256 L
.47153 .21019 L
.47253 .20795 L
.47353 .20584 L
.47453 .20387 L
.47552 .20205 L
.47652 .20038 L
.47752 .19889 L
.47852 .19758 L
.47952 .19647 L
.48052 .19558 L
.48152 .19493 L
.48252 .19453 L
.48352 .19442 L
.48452 .1946 L
.48551 .19511 L
.48651 .19596 L
.48751 .19716 L
.48851 .19872 L
.48951 .20065 L
.49051 .20293 L
.49151 .20556 L
.49251 .20851 L
.49351 .21173 L
.49451 .21518 L
.4955 .21877 L
.4965 .22244 L
.4975 .22608 L
Mistroke
.4985 .22959 L
.4995 .38197 L
.5005 .38064 L
.5015 .37801 L
.5025 .37369 L
.5035 .36779 L
.5045 .36055 L
.50549 .35226 L
.50649 .34325 L
.50749 .33377 L
.50849 .32408 L
.50949 .31436 L
.51049 .30475 L
.51149 .29536 L
.51249 .28626 L
.51349 .27747 L
.51449 .26901 L
.51548 .26089 L
.51648 .25308 L
.51748 .24557 L
.51848 .23834 L
.51948 .23138 L
.52048 .22465 L
.52148 .21815 L
.52248 .21185 L
.52348 .20574 L
.52448 .19981 L
.52547 .19404 L
.52647 .18843 L
.52747 .18296 L
.52847 .17763 L
.52947 .17243 L
.53047 .16734 L
.53147 .16237 L
.53247 .15749 L
.53347 .1527 L
.53447 .14799 L
.53546 .14334 L
.53646 .13874 L
.53746 .13416 L
.53846 .12958 L
.53946 .12497 L
.54046 .12029 L
.54146 .11551 L
.54246 .11057 L
.54346 .10542 L
.54446 .09997 L
.54545 .09417 L
.54645 .0879 L
.54745 .08108 L
Mistroke
.54845 .07359 L
.54945 .12461 L
.55045 .12075 L
.55145 .1186 L
.55245 .11753 L
.55345 .11738 L
.55445 .11807 L
.55544 .11959 L
.55644 .12193 L
.55744 .1251 L
.55844 .12912 L
.55944 .13402 L
.56044 .13986 L
.56144 .14671 L
.56244 .15467 L
.56344 .16386 L
.56444 .17442 L
.56543 .18651 L
.56643 .20027 L
.56743 .21583 L
.56843 .23325 L
.56943 .2525 L
.57043 .27341 L
.57143 .29561 L
.57243 .31849 L
.57343 .34116 L
.57443 .36244 L
.57542 .3809 L
.57642 .39491 L
.57742 .40296 L
.57842 .40415 L
.57942 .39888 L
.58042 .38882 L
.58142 .37611 L
.58242 .36247 L
.58342 .34908 L
.58442 .33656 L
.58541 .32517 L
.58641 .31495 L
.58741 .30578 L
.58841 .29748 L
.58941 .28986 L
.59041 .28273 L
.59141 .27595 L
.59241 .26938 L
.59341 .26294 L
.59441 .25657 L
.5954 .25025 L
.5964 .24398 L
.5974 .23774 L
Mistroke
.5984 .23155 L
.5994 .24858 L
.6004 .24082 L
.6014 .23461 L
.6024 .22925 L
.6034 .22451 L
.6044 .22027 L
.60539 .21648 L
.60639 .21307 L
.60739 .21002 L
.60839 .20729 L
.60939 .20487 L
.61039 .20274 L
.61139 .20088 L
.61239 .19929 L
.61339 .19795 L
.61439 .19687 L
.61538 .19603 L
.61638 .19546 L
.61738 .19516 L
.61838 .19515 L
.61938 .19545 L
.62038 .1961 L
.62138 .19712 L
.62238 .19856 L
.62338 .20047 L
.62438 .20288 L
.62537 .20583 L
.62637 .20937 L
.62737 .21352 L
.62837 .21828 L
.62937 .22366 L
.63037 .2296 L
.63137 .23604 L
.63237 .24288 L
.63337 .24996 L
.63437 .2571 L
.63536 .26406 L
.63636 .27059 L
.63736 .2764 L
.63836 .28124 L
.63936 .28485 L
.64036 .28708 L
.64136 .28783 L
.64236 .28715 L
.64336 .28514 L
.64436 .282 L
.64535 .27797 L
.64635 .27326 L
.64735 .26808 L
Mistroke
.64835 .2626 L
.64935 .22729 L
.65035 .2197 L
.65135 .21346 L
.65235 .20793 L
.65335 .20288 L
.65435 .19823 L
.65534 .19392 L
.65634 .18991 L
.65734 .18619 L
.65834 .18272 L
.65934 .17951 L
.66034 .17653 L
.66134 .17377 L
.66234 .17121 L
.66334 .16886 L
.66434 .16669 L
.66533 .1647 L
.66633 .16289 L
.66733 .16125 L
.66833 .15981 L
.66933 .15857 L
.67033 .15756 L
.67133 .15683 L
.67233 .15643 L
.67333 .15642 L
.67433 .1569 L
.67532 .15795 L
.67632 .1597 L
.67732 .16228 L
.67832 .16582 L
.67932 .17045 L
.68032 .17632 L
.68132 .18354 L
.68232 .19219 L
.68332 .20228 L
.68432 .21376 L
.68531 .22649 L
.68631 .24018 L
.68731 .25442 L
.68831 .26866 L
.68931 .28219 L
.69031 .29416 L
.69131 .30369 L
.69231 .30999 L
.69331 .31261 L
.69431 .31163 L
.6953 .30766 L
.6963 .30156 L
.6973 .29417 L
Mistroke
.6983 .28615 L
.6993 .33167 L
.7003 .32072 L
.7013 .31091 L
.7023 .30165 L
.7033 .29279 L
.7043 .28426 L
.70529 .27603 L
.70629 .26809 L
.70729 .26041 L
.70829 .25298 L
.70929 .24579 L
.71029 .23882 L
.71129 .23207 L
.71229 .22552 L
.71329 .21915 L
.71429 .21297 L
.71528 .20695 L
.71628 .20111 L
.71728 .19541 L
.71828 .18987 L
.71928 .18447 L
.72028 .1792 L
.72128 .17407 L
.72228 .16906 L
.72328 .16417 L
.72428 .1594 L
.72527 .15473 L
.72627 .15017 L
.72727 .14569 L
.72827 .1413 L
.72927 .13697 L
.73027 .13271 L
.73127 .12848 L
.73227 .12427 L
.73327 .12006 L
.73427 .1158 L
.73526 .11147 L
.73626 .10701 L
.73726 .10237 L
.73826 .09748 L
.73926 .09225 L
.74026 .08661 L
.74126 .08043 L
.74226 .0736 L
.74326 .06599 L
.74426 .05745 L
.74525 .04781 L
.74625 .0369 L
.74725 .02451 L
Mistroke
.74825 .01041 L
.74925 .13703 L
.75025 .14543 L
.75125 .15705 L
.75225 .17126 L
.75325 .18788 L
.75425 .20677 L
.75524 .22777 L
.75624 .25067 L
.75724 .27516 L
.75824 .30081 L
.75924 .32701 L
.76024 .35298 L
.76124 .37777 L
.76224 .4003 L
.76324 .4194 L
.76424 .43395 L
.76523 .44302 L
.76623 .44602 L
.76723 .44294 L
.76823 .43443 L
.76923 .42177 L
.77023 .40654 L
.77123 .39023 L
.77223 .37402 L
.77323 .35867 L
.77423 .34459 L
.77522 .33188 L
.77622 .3205 L
.77722 .3103 L
.77822 .30111 L
.77922 .29274 L
.78022 .28506 L
.78122 .27794 L
.78222 .2713 L
.78322 .26508 L
.78422 .25923 L
.78521 .25374 L
.78621 .24857 L
.78721 .24374 L
.78821 .23922 L
.78921 .23503 L
.79021 .23116 L
.79121 .22764 L
.79221 .22446 L
.79321 .22164 L
.79421 .21917 L
.7952 .21707 L
.7962 .21533 L
.7972 .21396 L
Mistroke
.7982 .21293 L
.7992 .27857 L
.8002 .27699 L
.8012 .27669 L
.8022 .27696 L
.8032 .27752 L
.8042 .27823 L
.80519 .279 L
.80619 .27975 L
.80719 .28042 L
.80819 .28096 L
.80919 .28134 L
.81019 .28154 L
.81119 .28152 L
.81219 .28128 L
.81319 .2808 L
.81419 .28008 L
.81518 .27911 L
.81618 .27791 L
.81718 .27647 L
.81818 .27481 L
.81918 .27293 L
.82018 .27084 L
.82118 .26856 L
.82218 .2661 L
.82318 .26347 L
.82418 .26069 L
.82517 .25777 L
.82617 .25472 L
.82717 .25156 L
.82817 .2483 L
.82917 .24495 L
.83017 .24153 L
.83117 .23806 L
.83217 .23453 L
.83317 .23096 L
.83417 .22736 L
.83516 .22374 L
.83616 .22011 L
.83716 .21647 L
.83816 .21283 L
.83916 .2092 L
.84016 .20559 L
.84116 .202 L
.84216 .19843 L
.84316 .1949 L
.84416 .19141 L
.84515 .18797 L
.84615 .18459 L
.84715 .18128 L
Mistroke
.84815 .17805 L
.84915 .30723 L
.85015 .30922 L
.85115 .31184 L
.85215 .31434 L
.85315 .31644 L
.85415 .31797 L
.85514 .31884 L
.85614 .31901 L
.85714 .31846 L
.85814 .31719 L
.85914 .31524 L
.86014 .31266 L
.86114 .30948 L
.86214 .30579 L
.86314 .30164 L
.86414 .29711 L
.86513 .29227 L
.86613 .28717 L
.86713 .28189 L
.86813 .27645 L
.86913 .27092 L
.87013 .26534 L
.87113 .25972 L
.87213 .25411 L
.87313 .24852 L
.87413 .24297 L
.87512 .23746 L
.87612 .23202 L
.87712 .22665 L
.87812 .22134 L
.87912 .21611 L
.88012 .21095 L
.88112 .20586 L
.88212 .20084 L
.88312 .19589 L
.88412 .19099 L
.88511 .18614 L
.88611 .18133 L
.88711 .17654 L
.88811 .17178 L
.88911 .16703 L
.89011 .16226 L
.89111 .15748 L
.89211 .15266 L
.89311 .1478 L
.89411 .14288 L
.8951 .13789 L
.8961 .13283 L
.8971 .12769 L
Mistroke
.8981 .12249 L
.8991 .15108 L
.9001 .15187 L
.9011 .15483 L
.9021 .15931 L
.9031 .16516 L
.9041 .17231 L
.90509 .18071 L
.90609 .19034 L
.90709 .20117 L
.90809 .21318 L
.90909 .22631 L
.91009 .2405 L
.91109 .25564 L
.91209 .27156 L
.91309 .28802 L
.91409 .30472 L
.91508 .32123 L
.91608 .33705 L
.91708 .35161 L
.91808 .36427 L
.91908 .3744 L
.92008 .38141 L
.92108 .38488 L
.92208 .38465 L
.92308 .38089 L
.92408 .3741 L
.92507 .36503 L
.92607 .3545 L
.92707 .34324 L
.92807 .33182 L
.92907 .32063 L
.93007 .30989 L
.93107 .29973 L
.93207 .29016 L
.93307 .28116 L
.93407 .27269 L
.93506 .26467 L
.93606 .25705 L
.93706 .24975 L
.93806 .24274 L
.93906 .23595 L
.94006 .22934 L
.94106 .22289 L
.94206 .21656 L
.94306 .21033 L
.94406 .20417 L
.94505 .19806 L
.94605 .19199 L
.94705 .18593 L
Mistroke
.94805 .17987 L
.94905 .20012 L
.95005 .19272 L
.95105 .18674 L
.95205 .18151 L
.95305 .17682 L
.95405 .17259 L
.95504 .16874 L
.95604 .16526 L
.95704 .16212 L
.95804 .1593 L
.95904 .15677 L
.96004 .15454 L
.96104 .15258 L
.96204 .15088 L
.96304 .14943 L
.96404 .14822 L
.96503 .14727 L
.96603 .14658 L
.96703 .14618 L
.96803 .14611 L
.96903 .14643 L
.97003 .14723 L
.97103 .1486 L
.97203 .15068 L
.97303 .15361 L
.97403 .15755 L
.97502 .1627 L
.97602 .16924 L
.97702 .17736 L
.97802 .1872 L
.97902 .19888 L
.98002 .21241 L
.98102 .22768 L
.98202 .24441 L
.98302 .26215 L
.98402 .2802 L
.98501 .29764 L
.98601 .31328 L
.98701 .32577 L
.98801 .33378 L
.98901 .33649 L
.99001 .33407 L
.99101 .32768 L
.99201 .3188 L
.99301 .3087 L
.99401 .29829 L
.995 .28811 L
.996 .27845 L
.997 .26944 L
Mistroke
.998 .26107 L
.999 .27977 L
Mfstroke
gsave
.999 .29238 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .01628 L
.004 .01784 L
.005 .01917 L
.00599 .02031 L
.00699 .02131 L
.00799 .02221 L
.00899 .02301 L
.00999 .02375 L
.01099 .02445 L
.01199 .02512 L
.01299 .02578 L
.01399 .02648 L
.01499 .02726 L
.01598 .02817 L
.01698 .02932 L
.01798 .03084 L
.01898 .03291 L
.01998 .03579 L
.02098 .03982 L
.02198 .0454 L
.02298 .05301 L
.02398 .06322 L
.02498 .07669 L
.02597 .0942 L
.02697 .11672 L
.02797 .14542 L
.02897 .18173 L
.02997 .22741 L
.03097 .28453 L
.03197 .35555 L
.03297 .44327 L
.03397 .55076 L
s
.03397 .55076 m
.03448 .61803 L
s
.04995 .41559 m
.05095 .46704 L
.05195 .51459 L
.05295 .55386 L
.05395 .58144 L
.05495 .59531 L
.05594 .59535 L
.05694 .58337 L
.05794 .56264 L
.05894 .53706 L
.05994 .5103 L
.06094 .48527 L
.06194 .46382 L
.06294 .44688 L
.06394 .4346 L
.06494 .42669 L
.06593 .42261 L
.06693 .42175 L
.06793 .42344 L
.06893 .42708 L
.06993 .4321 L
.07093 .43796 L
.07193 .44415 L
.07293 .45021 L
.07393 .45571 L
.07493 .46023 L
.07592 .46341 L
.07692 .46493 L
.07792 .46453 L
.07892 .46202 L
.07992 .45729 L
.08092 .45034 L
.08192 .4413 L
.08292 .43045 L
.08392 .41827 L
.08492 .40556 L
.08591 .39357 L
.08691 .38419 L
.08791 .37975 L
.08891 .38178 L
.08991 .38952 L
.09091 .40065 L
.09191 .41302 L
.09291 .42513 L
.09391 .4361 L
.09491 .44536 L
.0959 .45263 L
.0969 .45776 L
.0979 .46072 L
.0989 .46155 L
Mistroke
.0999 .23729 L
.1009 .23551 L
.1019 .23285 L
.1029 .2299 L
.1039 .22685 L
.1049 .22379 L
.10589 .22078 L
.10689 .21785 L
.10789 .21505 L
.10889 .21239 L
.10989 .20992 L
.11089 .20767 L
.11189 .20569 L
.11289 .20401 L
.11389 .20271 L
.11489 .20186 L
.11588 .20153 L
.11688 .20183 L
.11788 .20287 L
.11888 .20479 L
.11988 .20774 L
.12088 .21188 L
.12188 .2174 L
.12288 .22448 L
.12388 .23332 L
.12488 .24409 L
.12587 .25697 L
.12687 .27211 L
.12787 .2896 L
.12887 .3095 L
.12987 .33173 L
.13087 .35614 L
.13187 .38238 L
.13287 .40992 L
.13387 .43803 L
.13487 .4657 L
.13586 .49174 L
.13686 .51477 L
.13786 .53334 L
.13886 .54612 L
.13986 .55203 L
.14086 .55062 L
.14186 .54224 L
.14286 .52856 L
.14386 .51314 L
.14486 .50223 L
.14585 .50208 L
.14685 .5108 L
.14785 .52085 L
.14885 .52722 L
Mistroke
.14985 .40951 L
.15085 .40913 L
.15185 .4048 L
.15285 .39772 L
.15385 .38874 L
.15485 .37856 L
.15584 .36773 L
.15684 .35669 L
.15784 .34575 L
.15884 .33512 L
.15984 .32492 L
.16084 .3152 L
.16184 .306 L
.16284 .29728 L
.16384 .28904 L
.16484 .28123 L
.16583 .27382 L
.16683 .26677 L
.16783 .26006 L
.16883 .25366 L
.16983 .24755 L
.17083 .24172 L
.17183 .23615 L
.17283 .23084 L
.17383 .22579 L
.17483 .22101 L
.17582 .2165 L
.17682 .21229 L
.17782 .2084 L
.17882 .20486 L
.17982 .20172 L
.18082 .19902 L
.18182 .19685 L
.18282 .19528 L
.18382 .19441 L
.18482 .19437 L
.18581 .19528 L
.18681 .1973 L
.18781 .20063 L
.18881 .20545 L
.18981 .21199 L
.19081 .22049 L
.19181 .23123 L
.19281 .24449 L
.19381 .26058 L
.19481 .27983 L
.1958 .30256 L
.1968 .32912 L
.1978 .35978 L
.1988 .39478 L
Mistroke
.1998 .17951 L
.2008 .18874 L
.2018 .19822 L
.2028 .20879 L
.2038 .22078 L
.2048 .23443 L
.20579 .24986 L
.20679 .26711 L
.20779 .28613 L
.20879 .30669 L
.20979 .32847 L
.21079 .35094 L
.21179 .37346 L
.21279 .39527 L
.21379 .41552 L
.21479 .43337 L
.21578 .4481 L
.21678 .45913 L
.21778 .46618 L
.21878 .46925 L
.21978 .46861 L
.22078 .46475 L
.22178 .45825 L
.22278 .44971 L
.22378 .43963 L
.22478 .42845 L
.22577 .41656 L
.22677 .40428 L
.22777 .39192 L
.22877 .3797 L
.22977 .36783 L
.23077 .35643 L
.23177 .34559 L
.23277 .33535 L
.23377 .32571 L
.23477 .31666 L
.23576 .30817 L
.23676 .3002 L
.23776 .29272 L
.23876 .28569 L
.23976 .27908 L
.24076 .27286 L
.24176 .26703 L
.24276 .26156 L
.24376 .25645 L
.24476 .25172 L
.24575 .24736 L
.24675 .2434 L
.24775 .23986 L
.24875 .23678 L
Mistroke
.24975 .24219 L
.25075 .24583 L
.25175 .24866 L
.25275 .25139 L
.25375 .25427 L
.25475 .25744 L
.25574 .26098 L
.25674 .26498 L
.25774 .26947 L
.25874 .27451 L
.25974 .28012 L
.26074 .2863 L
.26174 .29306 L
.26274 .30035 L
.26374 .30813 L
.26474 .31633 L
.26573 .32484 L
.26673 .33355 L
.26773 .34231 L
.26873 .35097 L
.26973 .35936 L
.27073 .36729 L
.27173 .37462 L
.27273 .38117 L
.27373 .38681 L
.27473 .39145 L
.27572 .39502 L
.27672 .3975 L
.27772 .3989 L
.27872 .39928 L
.27972 .39873 L
.28072 .39736 L
.28172 .3953 L
.28272 .39265 L
.28372 .38954 L
.28472 .38605 L
.28571 .38225 L
.28671 .37821 L
.28771 .37397 L
.28871 .36957 L
.28971 .36505 L
.29071 .36044 L
.29171 .35576 L
.29271 .35107 L
.29371 .34637 L
.29471 .34172 L
.2957 .33712 L
.2967 .33262 L
.2977 .32823 L
.2987 .32399 L
Mistroke
.2997 .25006 L
.3007 .24949 L
.3017 .24792 L
.3027 .24603 L
.3037 .24402 L
.3047 .24203 L
.30569 .24013 L
.30669 .23837 L
.30769 .23681 L
.30869 .23551 L
.30969 .2345 L
.31069 .23385 L
.31169 .23361 L
.31269 .23384 L
.31369 .23462 L
.31469 .23601 L
.31568 .2381 L
.31668 .24095 L
.31768 .24466 L
.31868 .24928 L
.31968 .25491 L
.32068 .26159 L
.32168 .26938 L
.32268 .2783 L
.32368 .28836 L
.32468 .29954 L
.32567 .31175 L
.32667 .3249 L
.32767 .33882 L
.32867 .35327 L
.32967 .36799 L
.33067 .38262 L
.33167 .39677 L
.33267 .41002 L
.33367 .42193 L
.33467 .4321 L
.33566 .44017 L
.33666 .44594 L
.33766 .44934 L
.33866 .45053 L
.33966 .44991 L
.34066 .44814 L
.34166 .44601 L
.34266 .44428 L
.34366 .44334 L
.34466 .44302 L
.34565 .44273 L
.34665 .44182 L
.34765 .43981 L
.34865 .43647 L
Mistroke
.34965 .37389 L
.35065 .37711 L
.35165 .37786 L
.35265 .37692 L
.35365 .37463 L
.35465 .37124 L
.35564 .36699 L
.35664 .36206 L
.35764 .35662 L
.35864 .35082 L
.35964 .34477 L
.36064 .33858 L
.36164 .33233 L
.36264 .32607 L
.36364 .31985 L
.36464 .31371 L
.36563 .30766 L
.36663 .30172 L
.36763 .2959 L
.36863 .29022 L
.36963 .28467 L
.37063 .27926 L
.37163 .274 L
.37263 .26887 L
.37363 .2639 L
.37463 .25908 L
.37562 .25442 L
.37662 .24992 L
.37762 .2456 L
.37862 .24146 L
.37962 .23753 L
.38062 .23383 L
.38162 .23038 L
.38262 .2272 L
.38362 .22435 L
.38462 .22186 L
.38561 .21979 L
.38661 .21821 L
.38761 .21719 L
.38861 .21682 L
.38961 .2172 L
.39061 .21845 L
.39161 .22068 L
.39261 .22404 L
.39361 .22868 L
.39461 .23476 L
.3956 .24245 L
.3966 .25196 L
.3976 .26349 L
.3986 .27724 L
Mistroke
.3996 .12511 L
.4006 .12823 L
.4016 .13046 L
.4026 .13251 L
.4036 .13466 L
.4046 .1371 L
.40559 .13998 L
.40659 .14347 L
.40759 .14775 L
.40859 .15302 L
.40959 .15949 L
.41059 .1674 L
.41159 .177 L
.41259 .18853 L
.41359 .20222 L
.41459 .21827 L
.41558 .23683 L
.41658 .25798 L
.41758 .28168 L
.41858 .30778 L
.41958 .33591 L
.42058 .36552 L
.42158 .39581 L
.42258 .42574 L
.42358 .45407 L
.42458 .47943 L
.42557 .50048 L
.42657 .51607 L
.42757 .52548 L
.42857 .52867 L
.42957 .5265 L
.43057 .52087 L
.43157 .51452 L
.43257 .5096 L
.43357 .5058 L
.43457 .50112 L
.43556 .49398 L
.43656 .48397 L
.43756 .47147 L
.43856 .45725 L
.43956 .44216 L
.44056 .42697 L
.44156 .4123 L
.44256 .39861 L
.44356 .3862 L
.44456 .37522 L
.44555 .36575 L
.44655 .35775 L
.44755 .35116 L
.44855 .34586 L
Mistroke
.44955 .3152 L
.45055 .31444 L
.45155 .31286 L
.45255 .31109 L
.45355 .30928 L
.45455 .30751 L
.45554 .30581 L
.45654 .3042 L
.45754 .30269 L
.45854 .3013 L
.45954 .30003 L
.46054 .2989 L
.46154 .2979 L
.46254 .29706 L
.46354 .29639 L
.46454 .2959 L
.46553 .2956 L
.46653 .29551 L
.46753 .29564 L
.46853 .296 L
.46953 .2966 L
.47053 .29747 L
.47153 .29861 L
.47253 .30003 L
.47353 .30174 L
.47453 .30374 L
.47552 .30605 L
.47652 .30866 L
.47752 .31156 L
.47852 .31476 L
.47952 .31823 L
.48052 .32197 L
.48152 .32595 L
.48252 .33014 L
.48352 .3345 L
.48452 .33901 L
.48551 .3436 L
.48651 .34824 L
.48751 .35287 L
.48851 .35743 L
.48951 .36187 L
.49051 .36613 L
.49151 .37015 L
.49251 .37389 L
.49351 .37731 L
.49451 .38037 L
.4955 .38307 L
.4965 .38539 L
.4975 .38735 L
.4985 .38898 L
Mistroke
.4995 .39461 L
.5005 .40119 L
.5015 .40428 L
.5025 .4047 L
.5035 .40291 L
.5045 .39932 L
.50549 .39432 L
.50649 .38825 L
.50749 .38143 L
.50849 .37414 L
.50949 .36659 L
.51049 .35895 L
.51149 .35136 L
.51249 .3439 L
.51349 .33662 L
.51449 .32955 L
.51548 .32272 L
.51648 .31613 L
.51748 .30977 L
.51848 .30363 L
.51948 .2977 L
.52048 .29197 L
.52148 .28643 L
.52248 .28106 L
.52348 .27585 L
.52448 .2708 L
.52547 .2659 L
.52647 .26114 L
.52747 .25652 L
.52847 .25204 L
.52947 .24769 L
.53047 .24347 L
.53147 .2394 L
.53247 .23546 L
.53347 .23168 L
.53447 .22806 L
.53546 .22461 L
.53646 .22135 L
.53746 .2183 L
.53846 .21549 L
.53946 .21295 L
.54046 .21071 L
.54146 .20884 L
.54246 .20738 L
.54346 .2064 L
.54446 .20599 L
.54545 .20625 L
.54645 .20727 L
.54745 .20919 L
.54845 .21215 L
Mistroke
.54945 .13724 L
.55045 .14114 L
.55145 .14442 L
.55245 .14783 L
.55345 .15169 L
.55445 .15624 L
.55544 .16169 L
.55644 .16828 L
.55744 .17624 L
.55844 .1858 L
.55944 .19721 L
.56044 .21071 L
.56144 .22646 L
.56244 .2446 L
.56344 .26518 L
.56444 .28812 L
.56543 .31319 L
.56643 .34 L
.56743 .36794 L
.56843 .39618 L
.56943 .4237 L
.57043 .44935 L
.57143 .47193 L
.57243 .49032 L
.57343 .50371 L
.57443 .51173 L
.57542 .51462 L
.57642 .51329 L
.57742 .50919 L
.57842 .50372 L
.57942 .49751 L
.58042 .49027 L
.58142 .48145 L
.58242 .47084 L
.58342 .45867 L
.58442 .44544 L
.58541 .43172 L
.58641 .41808 L
.58741 .40496 L
.58841 .39268 L
.58941 .38147 L
.59041 .37143 L
.59141 .36261 L
.59241 .35498 L
.59341 .34848 L
.59441 .34302 L
.5954 .3385 L
.5964 .33481 L
.5974 .33186 L
.5984 .32955 L
Mistroke
.5994 .26121 L
.6004 .26125 L
.6014 .26048 L
.6024 .25954 L
.6034 .25863 L
.6044 .25787 L
.60539 .25731 L
.60639 .25701 L
.60739 .25701 L
.60839 .25735 L
.60939 .25807 L
.61039 .25922 L
.61139 .26083 L
.61239 .26295 L
.61339 .26563 L
.61439 .26888 L
.61538 .27275 L
.61638 .27726 L
.61738 .28242 L
.61838 .28824 L
.61938 .29471 L
.62038 .30179 L
.62138 .30944 L
.62238 .31761 L
.62338 .32619 L
.62438 .33509 L
.62537 .34417 L
.62637 .35329 L
.62737 .36227 L
.62837 .37095 L
.62937 .37914 L
.63037 .38667 L
.63137 .39338 L
.63237 .39914 L
.63337 .40387 L
.63437 .40752 L
.63536 .4101 L
.63636 .41171 L
.63736 .41245 L
.63836 .4125 L
.63936 .41202 L
.64036 .41119 L
.64136 .41011 L
.64236 .40883 L
.64336 .40733 L
.64436 .40557 L
.64535 .40346 L
.64635 .40096 L
.64735 .39802 L
.64835 .39464 L
Mistroke
.64935 .23991 L
.65035 .24008 L
.65135 .23923 L
.65235 .23803 L
.65335 .2367 L
.65435 .23536 L
.65534 .2341 L
.65634 .23296 L
.65734 .23201 L
.65834 .23129 L
.65934 .23086 L
.66034 .23077 L
.66134 .23108 L
.66234 .23185 L
.66334 .23313 L
.66434 .23502 L
.66533 .23756 L
.66633 .24084 L
.66733 .24492 L
.66833 .24988 L
.66933 .25577 L
.67033 .26263 L
.67133 .27052 L
.67233 .27944 L
.67333 .28939 L
.67433 .30033 L
.67532 .31219 L
.67632 .32486 L
.67732 .33818 L
.67832 .35194 L
.67932 .36589 L
.68032 .3797 L
.68132 .39304 L
.68232 .40554 L
.68332 .41681 L
.68432 .4265 L
.68531 .43431 L
.68631 .44005 L
.68731 .44364 L
.68831 .44521 L
.68931 .44507 L
.69031 .44373 L
.69131 .44187 L
.69231 .44018 L
.69331 .43912 L
.69431 .43872 L
.6953 .43859 L
.6963 .43818 L
.6973 .43697 L
.6983 .43467 L
Mistroke
.6993 .34428 L
.7003 .34113 L
.7013 .33675 L
.7023 .33186 L
.7033 .32671 L
.7043 .32143 L
.70529 .3161 L
.70629 .31078 L
.70729 .30548 L
.70829 .30024 L
.70929 .29506 L
.71029 .28997 L
.71129 .28495 L
.71229 .28003 L
.71329 .27519 L
.71429 .27043 L
.71528 .26577 L
.71628 .2612 L
.71728 .25671 L
.71828 .25232 L
.71928 .24801 L
.72028 .24379 L
.72128 .23967 L
.72228 .23564 L
.72328 .2317 L
.72428 .22786 L
.72527 .22413 L
.72627 .2205 L
.72727 .21698 L
.72827 .21359 L
.72927 .21033 L
.73027 .20722 L
.73127 .20428 L
.73227 .20152 L
.73327 .19898 L
.73427 .1967 L
.73526 .19471 L
.73626 .19307 L
.73726 .19185 L
.73826 .19112 L
.73926 .19099 L
.74026 .19156 L
.74126 .19295 L
.74226 .1953 L
.74326 .19879 L
.74426 .20358 L
.74525 .20988 L
.74625 .21793 L
.74725 .22797 L
.74825 .24031 L
Mistroke
.74925 .14965 L
.75025 .16594 L
.75125 .18337 L
.75225 .2029 L
.75325 .225 L
.75425 .24991 L
.75524 .27765 L
.75624 .308 L
.75724 .34044 L
.75824 .3741 L
.75924 .40779 L
.76024 .44005 L
.76124 .46927 L
.76224 .49386 L
.76324 .51252 L
.76424 .52446 L
.76523 .52956 L
.76623 .52836 L
.76723 .52191 L
.76823 .51142 L
.76923 .49802 L
.77023 .4827 L
.77123 .46633 L
.77223 .44973 L
.77323 .43359 L
.77423 .41849 L
.77522 .40482 L
.77622 .39282 L
.77722 .38259 L
.77822 .37412 L
.77922 .36731 L
.78022 .36203 L
.78122 .35809 L
.78222 .35532 L
.78322 .35352 L
.78422 .35253 L
.78521 .35219 L
.78621 .35235 L
.78721 .35289 L
.78821 .3537 L
.78921 .35469 L
.79021 .35576 L
.79121 .35685 L
.79221 .3579 L
.79321 .35884 L
.79421 .35964 L
.7952 .36025 L
.7962 .36067 L
.7972 .36085 L
.7982 .3608 L
Mistroke
.7992 .29122 L
.8002 .29747 L
.8012 .30271 L
.8022 .30758 L
.8032 .31226 L
.8042 .31681 L
.80519 .32125 L
.80619 .32555 L
.80719 .3297 L
.80819 .33365 L
.80919 .33737 L
.81019 .34082 L
.81119 .34396 L
.81219 .34674 L
.81319 .34915 L
.81419 .35116 L
.81518 .35275 L
.81618 .3539 L
.81718 .35464 L
.81818 .35495 L
.81918 .35486 L
.82018 .35439 L
.82118 .35357 L
.82218 .35242 L
.82318 .351 L
.82418 .34932 L
.82517 .34743 L
.82617 .34537 L
.82717 .34318 L
.82817 .34088 L
.82917 .33852 L
.83017 .33613 L
.83117 .33373 L
.83217 .33136 L
.83317 .32904 L
.83417 .3268 L
.83516 .32466 L
.83616 .32265 L
.83716 .32078 L
.83816 .31908 L
.83916 .31756 L
.84016 .31626 L
.84116 .31518 L
.84216 .31434 L
.84316 .31377 L
.84416 .31348 L
.84515 .31348 L
.84615 .31381 L
.84715 .31446 L
.84815 .31546 L
Mistroke
.84915 .31988 L
.85015 .32971 L
.85115 .33794 L
.85215 .34513 L
.85315 .35141 L
.85415 .35679 L
.85514 .36125 L
.85614 .36478 L
.85714 .36738 L
.85814 .36904 L
.85914 .3698 L
.86014 .36971 L
.86114 .36882 L
.86214 .36721 L
.86314 .36496 L
.86414 .36215 L
.86513 .35886 L
.86613 .35519 L
.86713 .3512 L
.86813 .34698 L
.86913 .34258 L
.87013 .33805 L
.87113 .33346 L
.87213 .32884 L
.87313 .32423 L
.87413 .31966 L
.87512 .31516 L
.87612 .31075 L
.87712 .30645 L
.87812 .30228 L
.87912 .29827 L
.88012 .29443 L
.88112 .29077 L
.88212 .28733 L
.88312 .28411 L
.88412 .28115 L
.88511 .27846 L
.88611 .27608 L
.88711 .27403 L
.88811 .27236 L
.88911 .27108 L
.89011 .27026 L
.89111 .26992 L
.89211 .27011 L
.89311 .27089 L
.89411 .27231 L
.8951 .27441 L
.8961 .27725 L
.8971 .2809 L
.8981 .2854 L
Mistroke
.8991 .16374 L
.9001 .17232 L
.9011 .1808 L
.9021 .19001 L
.9031 .20035 L
.9041 .21209 L
.90509 .22544 L
.90609 .24054 L
.90709 .2575 L
.90809 .27628 L
.90909 .29677 L
.91009 .31868 L
.91109 .3416 L
.91209 .36495 L
.91309 .38802 L
.91409 .40998 L
.91508 .42999 L
.91608 .4472 L
.91708 .46095 L
.91808 .47078 L
.91908 .47653 L
.92008 .47839 L
.92108 .4768 L
.92208 .47238 L
.92308 .46575 L
.92408 .45745 L
.92507 .44786 L
.92607 .4373 L
.92707 .42607 L
.92807 .41445 L
.92907 .40273 L
.93007 .39116 L
.93107 .37993 L
.93207 .3692 L
.93307 .35905 L
.93407 .34954 L
.93506 .34069 L
.93606 .33248 L
.93706 .32489 L
.93806 .31789 L
.93906 .31145 L
.94006 .30554 L
.94106 .30012 L
.94206 .29518 L
.94306 .2907 L
.94406 .28666 L
.94505 .28307 L
.94605 .27992 L
.94705 .27722 L
.94805 .27498 L
Mistroke
.94905 .21273 L
.95005 .21308 L
.95105 .21243 L
.95205 .21148 L
.95305 .21045 L
.95405 .20948 L
.95504 .20865 L
.95604 .20805 L
.95704 .20774 L
.95804 .2078 L
.95904 .20831 L
.96004 .20935 L
.96104 .21101 L
.96204 .21339 L
.96304 .2166 L
.96404 .22074 L
.96503 .22593 L
.96603 .23225 L
.96703 .23981 L
.96803 .24869 L
.96903 .25895 L
.97003 .2706 L
.97103 .28366 L
.97203 .29804 L
.97303 .31365 L
.97403 .33028 L
.97502 .34767 L
.97602 .36547 L
.97702 .38322 L
.97802 .40042 L
.97902 .4165 L
.98002 .43087 L
.98102 .44297 L
.98202 .45236 L
.98302 .45874 L
.98402 .46208 L
.98501 .46264 L
.98601 .46108 L
.98701 .45839 L
.98801 .45574 L
.98901 .45401 L
.99001 .45327 L
.99101 .45277 L
.99201 .45157 L
.99301 .44897 L
.99401 .44469 L
.995 .43874 L
.996 .43133 L
.997 .4228 L
.998 .41346 L
Mistroke
.999 .29238 L
Mfstroke
1 0 0 r
gsave
.999 .28608 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00164 L
.004 .0016 L
.005 .00155 L
.00599 .00151 L
.00699 .00148 L
.00799 .00146 L
.00899 .00144 L
.00999 .00144 L
.01099 .00144 L
.01199 .00147 L
.01299 .00151 L
.01399 .00157 L
.01499 .00167 L
.01598 .0018 L
.01698 .00197 L
.01798 .00221 L
.01898 .00252 L
.01998 .00292 L
.02098 .00343 L
.02198 .00409 L
.02298 .00494 L
.02398 .00601 L
.02498 .00738 L
.02597 .00912 L
.02697 .01131 L
.02797 .01409 L
.02897 .0176 L
.02997 .02202 L
.03097 .02758 L
.03197 .03454 L
.03297 .04325 L
.03397 .05409 L
.03497 .06752 L
.03596 .08407 L
.03696 .10431 L
.03796 .12883 L
.03896 .15819 L
.03996 .19282 L
.04096 .23289 L
.04196 .27817 L
.04296 .32779 L
.04396 .38008 L
.04496 .43243 L
.04595 .4814 L
.04695 .523 L
.04795 .5534 L
.04895 .56974 L
Mistroke
.04995 .40921 L
.05095 .45391 L
.05195 .49316 L
.05295 .52371 L
.05395 .5429 L
.05495 .54932 L
.05594 .54319 L
.05694 .5264 L
.05794 .50197 L
.05894 .47335 L
.05994 .44371 L
.06094 .41541 L
.06194 .38993 L
.06294 .36795 L
.06394 .34958 L
.06494 .3346 L
.06593 .32263 L
.06693 .31324 L
.06793 .30603 L
.06893 .30063 L
.06993 .29675 L
.07093 .29413 L
.07193 .29257 L
.07293 .29188 L
.07393 .29193 L
.07493 .2926 L
.07592 .29376 L
.07692 .29531 L
.07792 .29717 L
.07892 .29924 L
.07992 .30144 L
.08092 .30368 L
.08192 .30589 L
.08292 .30799 L
.08392 .30991 L
.08492 .3116 L
.08591 .313 L
.08691 .31407 L
.08791 .31476 L
.08891 .31507 L
.08991 .31497 L
.09091 .31446 L
.09191 .31355 L
.09291 .31225 L
.09391 .31059 L
.09491 .30859 L
.0959 .30629 L
.0969 .30374 L
.0979 .30096 L
.0989 .29801 L
Mistroke
.0999 .23097 L
.1009 .22519 L
.1019 .2196 L
.1029 .21421 L
.1039 .20901 L
.1049 .204 L
.10589 .1992 L
.10689 .19461 L
.10789 .19023 L
.10889 .18607 L
.10989 .18214 L
.11089 .17845 L
.11189 .17503 L
.11289 .17189 L
.11389 .16904 L
.11489 .16652 L
.11588 .16435 L
.11688 .16258 L
.11788 .16123 L
.11888 .16037 L
.11988 .16003 L
.12088 .16029 L
.12188 .16122 L
.12288 .16289 L
.12388 .1654 L
.12488 .16883 L
.12587 .17331 L
.12687 .17893 L
.12787 .18582 L
.12887 .19407 L
.12987 .2038 L
.13087 .21509 L
.13187 .22797 L
.13287 .24247 L
.13387 .25851 L
.13487 .27595 L
.13586 .29456 L
.13686 .31398 L
.13786 .33374 L
.13886 .35327 L
.13986 .37189 L
.14086 .38891 L
.14186 .40363 L
.14286 .41543 L
.14386 .42386 L
.14486 .42867 L
.14585 .42982 L
.14685 .42754 L
.14785 .42223 L
.14885 .41442 L
Mistroke
.14985 .40319 L
.15085 .39848 L
.15185 .39068 L
.15285 .38054 L
.15385 .3688 L
.15485 .35612 L
.15584 .34307 L
.15684 .33006 L
.15784 .31737 L
.15884 .30519 L
.15984 .29361 L
.16084 .28266 L
.16184 .27233 L
.16284 .2626 L
.16384 .25341 L
.16484 .24473 L
.16583 .2365 L
.16683 .22868 L
.16783 .22124 L
.16883 .21413 L
.16983 .20734 L
.17083 .20084 L
.17183 .19462 L
.17283 .18865 L
.17383 .18294 L
.17483 .17746 L
.17582 .17222 L
.17682 .16721 L
.17782 .16243 L
.17882 .15788 L
.17982 .15356 L
.18082 .14948 L
.18182 .14564 L
.18282 .14206 L
.18382 .13875 L
.18482 .13571 L
.18581 .13299 L
.18681 .13058 L
.18781 .12854 L
.18881 .12688 L
.18981 .12566 L
.19081 .12493 L
.19181 .12474 L
.19281 .12516 L
.19381 .12628 L
.19481 .12818 L
.1958 .13097 L
.1968 .13476 L
.1978 .13969 L
.1988 .14589 L
Mistroke
.1998 .17316 L
.2008 .17844 L
.2018 .18508 L
.2028 .19314 L
.2038 .20271 L
.2048 .21381 L
.20579 .22647 L
.20679 .24066 L
.20779 .25629 L
.20879 .27319 L
.20979 .29111 L
.21079 .30971 L
.21179 .32851 L
.21279 .34699 L
.21379 .36453 L
.21479 .38048 L
.21578 .39422 L
.21678 .40521 L
.21778 .41303 L
.21878 .41745 L
.21978 .41843 L
.22078 .41616 L
.22178 .41098 L
.22278 .40338 L
.22378 .39388 L
.22478 .38305 L
.22577 .37138 L
.22677 .35933 L
.22777 .34722 L
.22877 .33532 L
.22977 .32379 L
.23077 .31275 L
.23177 .30223 L
.23277 .29226 L
.23377 .28281 L
.23477 .27387 L
.23576 .26539 L
.23676 .25734 L
.23776 .24968 L
.23876 .24238 L
.23976 .23541 L
.24076 .22874 L
.24176 .22235 L
.24276 .21624 L
.24376 .21037 L
.24476 .20474 L
.24575 .19935 L
.24675 .19419 L
.24775 .18925 L
.24875 .18454 L
Mistroke
.24975 .23587 L
.25075 .23554 L
.25175 .23557 L
.25275 .23598 L
.25375 .23677 L
.25475 .23798 L
.25574 .2396 L
.25674 .24167 L
.25774 .24419 L
.25874 .24716 L
.25974 .25058 L
.26074 .25446 L
.26174 .25878 L
.26274 .26351 L
.26374 .26864 L
.26474 .27411 L
.26573 .27987 L
.26673 .28586 L
.26773 .292 L
.26873 .2982 L
.26973 .30435 L
.27073 .31037 L
.27173 .31612 L
.27273 .32151 L
.27373 .32642 L
.27473 .33076 L
.27572 .33444 L
.27672 .33739 L
.27772 .33955 L
.27872 .3409 L
.27972 .34143 L
.28072 .34115 L
.28172 .3401 L
.28272 .33832 L
.28372 .33587 L
.28472 .33283 L
.28571 .32927 L
.28671 .32527 L
.28771 .32091 L
.28871 .31626 L
.28971 .31138 L
.29071 .30634 L
.29171 .30119 L
.29271 .29597 L
.29371 .29074 L
.29471 .28551 L
.2957 .28032 L
.2967 .27519 L
.2977 .27015 L
.2987 .26521 L
Mistroke
.2997 .24375 L
.3007 .23927 L
.3017 .23497 L
.3027 .23086 L
.3037 .22695 L
.3047 .22326 L
.30569 .21978 L
.30669 .21655 L
.30769 .21356 L
.30869 .21085 L
.30969 .20842 L
.31069 .2063 L
.31169 .20452 L
.31269 .20309 L
.31369 .20205 L
.31469 .20142 L
.31568 .20125 L
.31668 .20157 L
.31768 .20242 L
.31868 .20383 L
.31968 .20587 L
.32068 .20856 L
.32168 .21196 L
.32268 .2161 L
.32368 .22102 L
.32468 .22676 L
.32567 .23333 L
.32667 .24073 L
.32767 .24896 L
.32867 .25799 L
.32967 .26773 L
.33067 .27811 L
.33167 .28898 L
.33267 .30019 L
.33367 .31152 L
.33467 .32274 L
.33566 .33359 L
.33666 .3438 L
.33766 .35309 L
.33866 .3612 L
.33966 .36791 L
.34066 .37305 L
.34166 .37651 L
.34266 .37825 L
.34366 .37828 L
.34466 .37672 L
.34565 .37369 L
.34665 .36939 L
.34765 .36402 L
.34865 .35779 L
Mistroke
.34965 .36758 L
.35065 .3668 L
.35165 .36466 L
.35265 .36131 L
.35365 .35691 L
.35465 .35164 L
.35564 .34568 L
.35664 .3392 L
.35764 .33235 L
.35864 .32526 L
.35964 .31803 L
.36064 .31077 L
.36164 .30352 L
.36264 .29634 L
.36364 .28928 L
.36464 .28235 L
.36563 .27556 L
.36663 .26894 L
.36763 .26248 L
.36863 .25618 L
.36963 .25005 L
.37063 .24409 L
.37163 .23828 L
.37263 .23264 L
.37363 .22715 L
.37463 .22182 L
.37562 .21665 L
.37662 .21163 L
.37762 .20676 L
.37862 .20205 L
.37962 .19749 L
.38062 .19309 L
.38162 .18884 L
.38262 .18477 L
.38362 .18086 L
.38462 .17712 L
.38561 .17357 L
.38661 .1702 L
.38761 .16704 L
.38861 .16409 L
.38961 .16137 L
.39061 .1589 L
.39161 .15669 L
.39261 .15478 L
.39361 .15319 L
.39461 .15195 L
.3956 .1511 L
.3966 .1507 L
.3976 .15078 L
.3986 .1514 L
Mistroke
.3996 .11878 L
.4006 .11803 L
.4016 .11758 L
.4026 .11745 L
.4036 .11769 L
.4046 .11837 L
.40559 .11953 L
.40659 .12126 L
.40759 .12364 L
.40859 .12677 L
.40959 .13075 L
.41059 .13571 L
.41159 .14177 L
.41259 .14907 L
.41359 .15776 L
.41459 .16799 L
.41558 .1799 L
.41658 .19361 L
.41758 .2092 L
.41858 .22672 L
.41958 .24613 L
.42058 .26729 L
.42158 .28996 L
.42258 .31372 L
.42358 .33803 L
.42458 .36219 L
.42557 .38537 L
.42657 .40667 L
.42757 .42518 L
.42857 .4401 L
.42957 .45081 L
.43057 .45697 L
.43157 .45856 L
.43257 .45586 L
.43357 .44945 L
.43457 .44008 L
.43556 .42859 L
.43656 .41579 L
.43756 .40241 L
.43856 .38904 L
.43956 .37611 L
.44056 .3639 L
.44156 .3526 L
.44256 .34225 L
.44356 .33286 L
.44456 .32439 L
.44555 .31676 L
.44655 .30989 L
.44755 .30371 L
.44855 .29813 L
Mistroke
.44955 .30888 L
.45055 .30419 L
.45155 .29984 L
.45255 .29579 L
.45355 .292 L
.45455 .28845 L
.45554 .2851 L
.45654 .28195 L
.45754 .27898 L
.45854 .27617 L
.45954 .27352 L
.46054 .27103 L
.46154 .2687 L
.46254 .26652 L
.46354 .26449 L
.46454 .26263 L
.46553 .26092 L
.46653 .25938 L
.46753 .25802 L
.46853 .25683 L
.46953 .25583 L
.47053 .25501 L
.47153 .2544 L
.47253 .25399 L
.47353 .25379 L
.47453 .25381 L
.47552 .25405 L
.47652 .25452 L
.47752 .25522 L
.47852 .25617 L
.47952 .25735 L
.48052 .25877 L
.48152 .26044 L
.48252 .26233 L
.48352 .26446 L
.48452 .26681 L
.48551 .26936 L
.48651 .2721 L
.48751 .27502 L
.48851 .27808 L
.48951 .28126 L
.49051 .28453 L
.49151 .28786 L
.49251 .2912 L
.49351 .29452 L
.49451 .29777 L
.4955 .30092 L
.4965 .30392 L
.4975 .30672 L
.4985 .30929 L
Mistroke
.4995 .38829 L
.5005 .39091 L
.5015 .39114 L
.5025 .3892 L
.5035 .38535 L
.5045 .37993 L
.50549 .37329 L
.50649 .36575 L
.50749 .3576 L
.50849 .34911 L
.50949 .34047 L
.51049 .33185 L
.51149 .32336 L
.51249 .31508 L
.51349 .30704 L
.51449 .29928 L
.51548 .2918 L
.51648 .2846 L
.51748 .27767 L
.51848 .27099 L
.51948 .26454 L
.52048 .25831 L
.52148 .25229 L
.52248 .24645 L
.52348 .2408 L
.52448 .23531 L
.52547 .22997 L
.52647 .22479 L
.52747 .21974 L
.52847 .21483 L
.52947 .21006 L
.53047 .20541 L
.53147 .20088 L
.53247 .19648 L
.53347 .19219 L
.53447 .18803 L
.53546 .18398 L
.53646 .18004 L
.53746 .17623 L
.53846 .17253 L
.53946 .16896 L
.54046 .1655 L
.54146 .16217 L
.54246 .15897 L
.54346 .15591 L
.54446 .15298 L
.54545 .15021 L
.54645 .14759 L
.54745 .14514 L
.54845 .14287 L
Mistroke
.54945 .13092 L
.55045 .13094 L
.55145 .13151 L
.55245 .13268 L
.55345 .13453 L
.55445 .13715 L
.55544 .14064 L
.55644 .1451 L
.55744 .15067 L
.55844 .15746 L
.55944 .16562 L
.56044 .17528 L
.56144 .18658 L
.56244 .19964 L
.56344 .21452 L
.56444 .23127 L
.56543 .24985 L
.56643 .27014 L
.56743 .29188 L
.56843 .31471 L
.56943 .3381 L
.57043 .36138 L
.57143 .38377 L
.57243 .40441 L
.57343 .42244 L
.57443 .43709 L
.57542 .44776 L
.57642 .4541 L
.57742 .45607 L
.57842 .45393 L
.57942 .44819 L
.58042 .43955 L
.58142 .42878 L
.58242 .41666 L
.58342 .40387 L
.58442 .391 L
.58541 .37845 L
.58641 .36652 L
.58741 .35537 L
.58841 .34508 L
.58941 .33566 L
.59041 .32708 L
.59141 .31928 L
.59241 .31218 L
.59341 .30571 L
.59441 .2998 L
.5954 .29438 L
.5964 .28939 L
.5974 .2848 L
.5984 .28055 L
Mistroke
.5994 .2549 L
.6004 .25104 L
.6014 .24754 L
.6024 .24439 L
.6034 .24157 L
.6044 .23907 L
.60539 .23689 L
.60639 .23504 L
.60739 .23351 L
.60839 .23232 L
.60939 .23147 L
.61039 .23098 L
.61139 .23086 L
.61239 .23112 L
.61339 .23179 L
.61439 .23287 L
.61538 .23439 L
.61638 .23636 L
.61738 .23879 L
.61838 .2417 L
.61938 .24508 L
.62038 .24894 L
.62138 .25328 L
.62238 .25808 L
.62338 .26333 L
.62438 .26898 L
.62537 .275 L
.62637 .28133 L
.62737 .28789 L
.62837 .29462 L
.62937 .3014 L
.63037 .30813 L
.63137 .31471 L
.63237 .32101 L
.63337 .32692 L
.63437 .33231 L
.63536 .33708 L
.63636 .34115 L
.63736 .34443 L
.63836 .34687 L
.63936 .34844 L
.64036 .34913 L
.64136 .34897 L
.64236 .34799 L
.64336 .34623 L
.64436 .34379 L
.64535 .34072 L
.64635 .33711 L
.64735 .33305 L
.64835 .32862 L
Mistroke
.64935 .2336 L
.65035 .22989 L
.65135 .22635 L
.65235 .22298 L
.65335 .21979 L
.65435 .2168 L
.65534 .21401 L
.65634 .21144 L
.65734 .2091 L
.65834 .20701 L
.65934 .20519 L
.66034 .20365 L
.66134 .20242 L
.66234 .20153 L
.66334 .201 L
.66434 .20085 L
.66533 .20113 L
.66633 .20186 L
.66733 .20309 L
.66833 .20484 L
.66933 .20717 L
.67033 .2101 L
.67133 .21368 L
.67233 .21793 L
.67333 .22291 L
.67433 .22861 L
.67532 .23507 L
.67632 .24228 L
.67732 .25023 L
.67832 .25888 L
.67932 .26817 L
.68032 .27801 L
.68132 .28829 L
.68232 .29886 L
.68332 .30954 L
.68432 .32013 L
.68531 .3304 L
.68631 .34011 L
.68731 .34903 L
.68831 .35694 L
.68931 .36363 L
.69031 .36895 L
.69131 .37278 L
.69231 .37509 L
.69331 .37586 L
.69431 .37517 L
.6953 .37313 L
.6963 .36987 L
.6973 .36557 L
.6983 .36041 L
Mistroke
.6993 .33798 L
.7003 .33093 L
.7013 .32383 L
.7023 .31676 L
.7033 .30975 L
.7043 .30284 L
.70529 .29607 L
.70629 .28943 L
.70729 .28294 L
.70829 .27661 L
.70929 .27043 L
.71029 .2644 L
.71129 .25851 L
.71229 .25277 L
.71329 .24717 L
.71429 .2417 L
.71528 .23636 L
.71628 .23115 L
.71728 .22606 L
.71828 .22109 L
.71928 .21624 L
.72028 .2115 L
.72128 .20687 L
.72228 .20235 L
.72328 .19794 L
.72428 .19363 L
.72527 .18943 L
.72627 .18533 L
.72727 .18134 L
.72827 .17745 L
.72927 .17365 L
.73027 .16997 L
.73127 .16638 L
.73227 .1629 L
.73327 .15952 L
.73427 .15625 L
.73526 .15309 L
.73626 .15004 L
.73726 .14711 L
.73826 .1443 L
.73926 .14162 L
.74026 .13908 L
.74126 .13669 L
.74226 .13445 L
.74326 .13239 L
.74426 .13051 L
.74525 .12885 L
.74625 .12741 L
.74725 .12624 L
.74825 .12536 L
Mistroke
.74925 .14334 L
.75025 .15569 L
.75125 .17021 L
.75225 .18708 L
.75325 .20644 L
.75425 .22834 L
.75524 .25271 L
.75624 .27933 L
.75724 .3078 L
.75824 .33745 L
.75924 .3674 L
.76024 .39651 L
.76124 .42352 L
.76224 .44708 L
.76324 .46596 L
.76424 .47921 L
.76523 .48629 L
.76623 .48719 L
.76723 .48243 L
.76823 .47293 L
.76923 .4599 L
.77023 .44462 L
.77123 .42828 L
.77223 .41187 L
.77323 .39613 L
.77423 .38154 L
.77522 .36835 L
.77622 .35666 L
.77722 .34645 L
.77822 .33761 L
.77922 .33003 L
.78022 .32354 L
.78122 .31802 L
.78222 .31331 L
.78322 .3093 L
.78422 .30588 L
.78521 .30296 L
.78621 .30046 L
.78721 .29831 L
.78821 .29646 L
.78921 .29486 L
.79021 .29346 L
.79121 .29225 L
.79221 .29118 L
.79321 .29024 L
.79421 .2894 L
.7952 .28866 L
.7962 .288 L
.7972 .2874 L
.7982 .28687 L
Mistroke
.7992 .2849 L
.8002 .28723 L
.8012 .2897 L
.8022 .29227 L
.8032 .29489 L
.8042 .29752 L
.80519 .30012 L
.80619 .30265 L
.80719 .30506 L
.80819 .3073 L
.80919 .30936 L
.81019 .31118 L
.81119 .31274 L
.81219 .31401 L
.81319 .31498 L
.81419 .31562 L
.81518 .31593 L
.81618 .31591 L
.81718 .31555 L
.81818 .31488 L
.81918 .31389 L
.82018 .31262 L
.82118 .31106 L
.82218 .30926 L
.82318 .30723 L
.82418 .305 L
.82517 .3026 L
.82617 .30004 L
.82717 .29737 L
.82817 .29459 L
.82917 .29174 L
.83017 .28883 L
.83117 .28589 L
.83217 .28294 L
.83317 .28 L
.83417 .27708 L
.83516 .2742 L
.83616 .27138 L
.83716 .26862 L
.83816 .26595 L
.83916 .26338 L
.84016 .26092 L
.84116 .25859 L
.84216 .25639 L
.84316 .25433 L
.84416 .25244 L
.84515 .25073 L
.84615 .2492 L
.84715 .24787 L
.84815 .24675 L
Mistroke
.84915 .31356 L
.85015 .31946 L
.85115 .32489 L
.85215 .32974 L
.85315 .33392 L
.85415 .33738 L
.85514 .34005 L
.85614 .3419 L
.85714 .34292 L
.85814 .34312 L
.85914 .34252 L
.86014 .34118 L
.86114 .33915 L
.86214 .3365 L
.86314 .3333 L
.86414 .32963 L
.86513 .32557 L
.86613 .32118 L
.86713 .31654 L
.86813 .31172 L
.86913 .30675 L
.87013 .3017 L
.87113 .29659 L
.87213 .29148 L
.87313 .28637 L
.87413 .28131 L
.87512 .27631 L
.87612 .27138 L
.87712 .26655 L
.87812 .26181 L
.87912 .25719 L
.88012 .25269 L
.88112 .24832 L
.88212 .24409 L
.88312 .24 L
.88412 .23607 L
.88511 .2323 L
.88611 .2287 L
.88711 .22529 L
.88811 .22207 L
.88911 .21905 L
.89011 .21626 L
.89111 .2137 L
.89211 .21139 L
.89311 .20934 L
.89411 .20759 L
.8951 .20615 L
.8961 .20504 L
.8971 .2043 L
.8981 .20394 L
Mistroke
.8991 .15741 L
.9001 .1621 L
.9011 .16781 L
.9021 .17466 L
.9031 .18276 L
.9041 .1922 L
.90509 .20307 L
.90609 .21544 L
.90709 .22934 L
.90809 .24473 L
.90909 .26154 L
.91009 .27959 L
.91109 .29862 L
.91209 .31825 L
.91309 .33802 L
.91409 .35735 L
.91508 .37561 L
.91608 .39213 L
.91708 .40628 L
.91808 .41753 L
.91908 .42546 L
.92008 .4299 L
.92108 .43084 L
.92208 .42852 L
.92308 .42332 L
.92408 .41577 L
.92507 .40644 L
.92607 .3959 L
.92707 .38465 L
.92807 .37313 L
.92907 .36168 L
.93007 .35053 L
.93107 .33983 L
.93207 .32968 L
.93307 .32011 L
.93407 .31112 L
.93506 .30268 L
.93606 .29476 L
.93706 .28732 L
.93806 .28031 L
.93906 .2737 L
.94006 .26744 L
.94106 .26151 L
.94206 .25587 L
.94306 .25051 L
.94406 .24542 L
.94505 .24057 L
.94605 .23595 L
.94705 .23157 L
.94805 .22743 L
Mistroke
.94905 .20642 L
.95005 .2029 L
.95105 .19958 L
.95205 .19649 L
.95305 .19364 L
.95405 .19103 L
.95504 .1887 L
.95604 .18666 L
.95704 .18493 L
.95804 .18355 L
.95904 .18254 L
.96004 .18194 L
.96104 .18179 L
.96204 .18213 L
.96304 .18301 L
.96404 .18448 L
.96503 .1866 L
.96603 .18941 L
.96703 .19299 L
.96803 .1974 L
.96903 .20269 L
.97003 .20892 L
.97103 .21613 L
.97203 .22436 L
.97303 .23363 L
.97403 .24392 L
.97502 .25519 L
.97602 .26735 L
.97702 .28029 L
.97802 .29381 L
.97902 .30769 L
.98002 .32164 L
.98102 .33533 L
.98202 .34839 L
.98302 .36045 L
.98402 .37114 L
.98501 .38014 L
.98601 .38718 L
.98701 .39208 L
.98801 .39476 L
.98901 .39525 L
.99001 .39367 L
.99101 .39023 L
.99201 .38518 L
.99301 .37884 L
.99401 .37149 L
.995 .36342 L
.996 .35489 L
.997 .34612 L
.998 .33727 L
Mistroke
.999 .28608 L
Mfstroke
0 g
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{670.75, 276.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:N000152000`400?l00000o`00003ooooooooo
oooooj3ooooo003oooooooooooooX?ooool00?oooooooooooonPooooo`00oooooooooooooj3ooooo
003oooooooooooooX?ooool00?oooooooooooonPooooo`00oooooooooooooj3ooooo001Booooo`Go
00000oooool2o`0000Cooooo0_l0000Booooo`?o00000oooool2o`0000Cooooo0_l0000@ooooo`?o
00001?ooool2o`0000Cooooo0_l0000@ooooo`?o00001?ooool2o`0000Cooooo0_l0000>ooooo`?o
00001?ooool2o`0000Cooooo0_l00004ooooo`;o0000=?ooool5o`0000?ooooo0_l00004ooooo`;o
00004_ooool3o`0000?ooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l00004ooooo`;o
00004?ooool3o`0000Cooooo0_l00004ooooo`;o00003_ooool3o`0000Cooooo0_l00004ooooo`;o
00001?ooool2o`00037ooooo1Ol00003ooooo`;o00001?ooool2o`0001;ooooo0ol00003ooooo`;o
00001?ooool2o`00013ooooo0ol00004ooooo`;o00001?ooool2o`00013ooooo0ol00004ooooo`;o
00001?ooool2o`0000gooooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000eooooo`00
Doooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00004_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0<ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000dooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000>ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`00037ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000>ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000gooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=?ooool005Co
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000oooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
3_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000>ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00003oooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000boooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000?ooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000ko
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00003_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000=ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Cooooo
001Eooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00gooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000kooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00003oooool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000>ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Kooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03Oooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00003_ooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?
ooooo`?o00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo0000<oooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0=ooooo`04o`000?ooooooooooo`0000?o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`Co00000oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000oooooo0ol00003ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003Oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000dooooo`00D_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooo000000?ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000>ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo0000<oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooo000000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooo
000000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=?ooool005;ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
4Oooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?oooo
o`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000>ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000gooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000cooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo0_l00003
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000=ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Aooooo`;o00000oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000oooooo00?o0000ooooooooool00oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003?ooool2
o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0003Cooooo001Cooooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`03o`00
0?oooooooooo00;ooooo0_l00004ooooo`;o00004Oooool2o`0000Cooooo0_l00004ooooo`;o0000
4?ooool3o`0000Cooooo0_l00004ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`;o0000
1?ooool2o`0000Cooooo0_l0000eooooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`03o`00
0?oooooooooo00;ooooo0_l00004ooooo`;o00004Oooool2o`0000Cooooo0_l00004ooooo`;o0000
4?ooool3o`0000Cooooo0_l00004ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`;o0000
1?ooool2o`0000Cooooo0_l0000booooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`03o`00
0?oooooooooo00;ooooo0_l00004ooooo`;o00004Oooool2o`0000Cooooo0_l00004ooooo`;o0000
4?ooool3o`0000Cooooo0_l00004ooooo`;o00003_ooool00ol0003oooooooooo`03ooooo`;o0000
1?ooool2o`0000Cooooo0_l0000eooooo`00oooooooooooooj3ooooo003oooooooooooooX?ooool0
0?oooooooooooonPooooo`00??oooonNo`0002OoooooW_l0000Toooooiko0000?Oooool003cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`;o0000?Oooool003cooooo00?o
0000ooooooooool0V_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo09[ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000l
ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2J
ooooo`03o`000?oooooooooo02;ooooo0_l0002Jooooo`;o0000?Oooool003cooooo00?o0000oooo
ooooool0V_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo09[ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000looooo`;o
0000V_ooool2o`0002Oooooo0_l0002Jooooo`;o00009?ooool2o`0009[ooooo0_l0000mooooo`00
??ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
V_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0
>oooool003Gooooo0ol00004ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool05ooo
ool5o`0000;ooooo0ol00004ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool08_oo
ool2o`0009[ooooo0_l0000mooooo`00=?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool0V_ooool00ol0003oooooooooo`0Hooooo`06o`000?ooooooooooo`000?oooooo
00000oooool01Ol0003ooooooooooooooooo000009cooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000dooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01Wooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000W?ooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0>oooool003Cooooo1?l00004
ooooo`;o0000V_ooool2o`0001cooooo00?o0000ooooooooool01?l00004ooooo`;o0000V_ooool2
o`0001gooooo0ol00004ooooo`;o0000V_ooool2o`0003gooooo000dooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Gooooo`07o`000?oooooooooo
ooooool0003oooooo`000007ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0>ooo
ool003Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooo
oooo01Oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0V_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00?ooooo0_l0
002Jooooo`;o0000?Oooool003Kooooo0_l00004ooooo`03o`000?oooooooooo09[ooooo00?o0000
ooooooooool06?ooool3o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo09[ooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo09[ooooo00?o0000
ooooooooool0>oooool003cooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo01Gooooo2?l0nYYmooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000looooo`;o
0000V_ooool2o`0002Oooooo0_l0000Fooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooooooo
ool0N_ooool2o`0001gooooo0_l00005ooooo`;o0000V_ooool2o`0003gooooo000looooo`03o`00
0?oooooooooo09[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Eooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool0Noooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0kooooo`00??oo
ool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05Ooo
ool00ol0nY[oooooooooo`04ooooo`Wo0?ZJMOooool00ol0003oooooooooo`0Rooooo`;o0000V_oo
ool2o`0003gooooo000looooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0Loooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0>oooool0
03cooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
01Cooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`1cooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0kooooo`00??ooool2o`0009[o
oooo0_l0000Woooooa7o0?ZJ1_ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo07;o
oooo0_l0000Tooooo`;o0000V_ooool2o`0003gooooo000looooo`03o`000?oooooooooo09[ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`1cooooo`03o`000?oooooooooo02;ooooo
4Ol0nYZ<ooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oooooooooo09[ooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0=ooooo`So0?ZJ3oooool00ol0nY[ooooooooo
o`0=ooooo`Wo0?ZJGOooool00ol0003oooooooooo`0Jooooo`Go00000oooool2o`0000kooooo00?o
0?ZJooooooooool0ROooool2o`0003gooooo000looooo`03o`000?oooooooooo09[ooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0Tooooo`Wo0?ZJ1oooool00ol0nY[oooooooooo`05
ooooo`So0?ZJE_ooool00ol0003oooooooooo`0Kooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool03Oooool00ol0nY[oooooooooo`0/oooooa3o0?ZJC_ooool00ol0003ooooooooo
o`0kooooo`00??ooool2o`0003gooooo2?l0nYYEooooo`;o00009oooool2o`0002gooooo2Ol0nYX?
ooooo`So0?ZJCOooool2o`0001kooooo00?o0000ooooooooool00oooool2o`0000kooooo2?l0nYXW
ooooo`03o`3jV_oooooooooo00cooooo:?l0nYXVooooo`;o0000?Oooool003cooooo00?o0000oooo
ooooool0??ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo05Cooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`1;ooooo`Wo0?ZJ3oooool8o`3jVRoooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJoooo
ooooool09?ooool00ol0nY[oooooooooo`0dooooo`Wo0?ZJ7oooool00ol0003oooooooooo`0koooo
o`00??ooool00ol0003oooooooooo`0looooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool0Doooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo05?ooooo00?o0?ZJoooooooo
ool03Oooool00ol0nY[oooooooooo`05ooooo`So0?ZJ7oooool9o`3jVQcooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool03Oooool9o`3j
VPOooooo2?l0nYX7ooooo`Woo`00;_oooolAo`3jVPoooooo00?o0000ooooooooool0>oooool003Go
oooo0ol00004ooooo`03o`000?oooooooooo01cooooo2Ol0nYXGooooo`03o`3jV_oooooooooo00Go
oooo2?l0nYY>ooooo`03o`000?oooooooooo01Oooooo1Ol00002ooooo`?o00001?ooool00ol0003o
ooooooooo`1Coooooa7o0?ZJ3_oooolAo`3jVPOooooo2Ol0nYX7ooooo`03o`000?oooooooooo01[o
oooo00Go0000ooooooooooooooooo`000003ooooo`;o00005Oooool00ol0nY[oooooooooo`0=oooo
o`03o`3jV_oooooooooo00Gooooo2Ol0nYX7ooooo`Soo`001oooool00ooo003oooooooooo`05oooo
ob3oo`005oooool@o`3jVP03o`000?oooooooooo03_ooooo000dooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`0Looooo`03o`3jV_oooooooooo00Gooooo2Ol0nYX7oooo
o`Wo0?ZJ3_ooool00ol0nY[oooooooooo`0=ooooo`Wo0?ZJ=_ooool00ol0003oooooooooo`0Hoooo
o`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooooooo000001Oooooo
2?oo001Uooooo`Wo0?ZJ3oooool00ol0003oooooooooo`0Kooooo`?o00001?ooool00ol0003ooooo
ooooo`0Eooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool05Oooool00ooo003ooooo
ooooo`0<ooooo`Woo`007_oooolAool001Oooooo00?o0000ooooooooool0>oooool003Cooooo00Go
0000ooooooooooooooooo`000003ooooo`;o00007Oooool00ol0nY[oooooooooo`0=ooooo`Wo0?ZJ
5_oooolAo`3jVPOooooo00?o0?ZJooooooooool0<oooool2o`0001_ooooo00Go0000oooooooooooo
ooooo`000003ooooo`04o`000?oooooooooooooooaSo003o00?oo`00o`00ool00?l01?l00?l00ooo
003o003oo`00o`1lo`00obCooooo0_l0000Fooooo`03o`3jV_oooooooooo00Cooooo2Ol0nYXGoooo
o`03ool00?oooooooooo04?ooooo6?oo00000ol0003oooooooooo`0kooooo`00=Oooool3o`0000Co
oooo00?o0000ooooooooool07?ooool00ol0nY[oooooooooo`14oooooa3o0?ZJ1ooooolAo`3jVPoo
oooo00?o0000ooooooooool06_ooool01?l0003oooooooooooooool3o`0000Cooooo00?o0000oooo
ooooool05Oooool00ooo003oooooooooo`04ooooo`Woo`00MOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo01Gooooo2?l0nYXNooooo`03ool00?l0nY[o0?ZJ00ko0?ZJ1ooooolXo`3j
VQkooooo00?oo`00o`000?ooool0??ooool003Cooooo00Go0000ooooooooooooooooo`000003oooo
o`03o`000?oooooooooo01cooooo00?o0?ZJooooooooool0Doooool9o`3jVPoooooo00?o0?ZJoooo
ooooool03Oooool00ol0003oooooooooo`0Gooooo`07o`000?ooooooooooooooool0003oooooo`00
0003ooooo`05o`000?ooooooooooooooool000005oooool00ooo003oooooooooo`0<ooooo`03ool0
0?oooooooooo07?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0ToooooaSoo`00
00?o0?ZJooooooooool03?ooool9o`3jVRKooooo6?l0nYX8ooooo`03o`000?oooooooooo03_ooooo
000dooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Eooooo`So0?ZJ
KOooool9o`3jVPOooooo00?o0000ooooooooool05oooool01ol0003ooooooooooooooooo0000oooo
ool000000oooool01Ol0003ooooooooooooooooo000001Oooooo00?oo`00ooooooooool03?ooool0
0ooo003oooooooooo`1cooooo`03o`000?oooooooooo02;ooooo9ol00?l00ooo003o003oo`00o`0E
o`00o`03o`3jV_l00?oo003o05?o003o2?l0nYX00ol0003oooooooooo`0kooooo`00=Oooool3o`00
00Cooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`1jooooo`Wo0?ZJ6_ooool3o`00
00?ooooo0ol00004ooooo`03o`000?oooooooooo01Gooooo00?oo`00ooooooooool03?ooool00ooo
003oooooooooo`0=oooooa3oo`00E_ooool00ooo003oooooooooo`0Rooooo`03o`000?oooooooooo
02Cooooo00?oo`00ooooooooool05?ooool00ol0nY[oooooooooo`1Looooo`03o`000?oooooooooo
03_ooooo000looooo`;o00005Oooool00ol0nY[oooooooooo`22ooooo`;o00009oooool2o`0001Go
oooo00?oo`00ooooooooool03Oooool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00go
oooo2?oo000Goooooa3oo`005oooool@ool00003o`000?oooooooooo01_ooooo0ol00004ooooo`;o
00003_ooool8ool000oooooo00?oo`00ooooooooool05?ooool00ol0nY[oooooooooo`1Kooooo`;o
0000?Oooool003cooooo00?o0000ooooooooool03Oooool8o`3jVXGooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0Dooooo`03ool00?oooooooooo00gooooo4Ooo000Fooooo`Woo`00
1oooool9ool000kooooo4Ooo0007ooooo`03ool00?oooooooooo00gooooo00?o0000ooooooooool0
6_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool03Oooool00ooo003o
ooooooooo`04ooooo`03ool00?oooooooooo00Gooooo2Ooo000?ooooo`So0?ZJG_ooool00ol0003o
ooooooooo`0kooooo`00??ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Dooooo`03ool00?oooooooooo03cooooo
2Ooo000Vooooo`Woo`003oooool00ol0003oooooooooo`0Nooooo`04o`000?ooooooooooooooo`;o
00003_ooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo
ool01OoooolAo`3jVVCooooo0_l0000mooooo`00??ooool00ol0003oooooooooo`0=ooooo`03o`3j
V_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Dooooo`03ool0
0?oooooooooo08?ooooo00?o0000ooooooooool07?ooool2o`0000Cooooo00?o0000ooooooooool0
3Oooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool0
1Oooool00ol0nY[oooooooooo`1cooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oo
oooooooo00gooooo00?o0?ZJooooooooool0;?ooool8ool005Kooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Dooooo`03ool00?oooooooooo08?ooooo00?o0000ooooooooool07_oo
ool01Ol0003ooooooooooooooooo000000oooooo00?oo`00ooooooooool01Oooool00ooo003ooooo
ooooo`04ooooo`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool0Loooool00ol0003ooooo
ooooo`0kooooo`00??oooolAo`3jVRkooooo00?oo`00ooooooooool01Oooool8ool000oooooo2Ooo
000eooooo`;o00009ooooolHool008Cooooo0_l0000Looooo`05o`000?ooooooooooooooool00000
0oooool2o`0000kooooo00?oo`00ooooooooool01Oooool8ool000Oooooo00?o0?ZJooooooooool0
L_ooool2o`0003gooooo000looooo`03o`000?oooooooooo03cooooo00?oo`00ooooooooool03?oo
ool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool05?oo
ool9ool001Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Jooooo`03o`3jV_oo
oooooooo01_ooooo0ol00004ooooo`03o`000?oooooooooo00gooooo00?oo`00ooooooooool05?oo
ool00ol0nY[oooooooooo`1cooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oooooo
oooo03cooooo00?oo`00ooooooooool03?oooolAool000Oooooo4?oo0007ooooo`03ool00?oooooo
oooo00Gooooo2Ooo000?ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05Oooool8
o`3jVWGooooo2?l0nYX00ol0003oooooooooo`0Rooooo`;o00003_ooool00ooo003oooooooooo`0<
ooooo`Wo0?ZJM?ooool2o`0003gooooo000looooo`03o`000?oooooooooo01cooooo2Ooo000Goooo
o`03ool00?oooooooooo03?ooooo2Ooo000?ooooo`Woo`001oooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`14oooo
o`So0?ZJ7oooool9o`3jVPOooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0=oooo
o`03ool00?oooooooooo00cooooo00?o0?ZJooooooooool0Noooool00ol0003oooooooooo`0koooo
o`00??ooool00ol0003oooooooooo`0Looooo`03ool00?oooooooooo00Gooooo2Ooo0007ooooo`Wo
o`00EOooool9ool002Oooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`04ooooo`Wo
0?ZJ5oooool8o`3jVQoooooo00?o0?ZJooooooooool01OoooolPo`3jVPoooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ00Go0?ZJ1oooool00ol0nY[o
ooooooooo`1kooooo`03o`000?oooooooooo03_ooooo000looooo`;o00007Oooool00ooo003ooooo
ooooo`0=ooooo`Woo`00I?ooool2o`0002Oooooo0_l0000Fooooo`03o`3jV_oooooooooo00cooooo
00?o0?ZJooooooooool03Oooool9o`3jVPOooooo4?l0nYX7ooooo`Wo0?ZJ=Oooool2o`0002Cooooo
0_l0000>ooooo`03ool00?oooooooooo00Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`1jooooo`;o0000?Oooool003cooooo00?o0000ooooooooool07?ooool00ooo003ooooooooo
o`1kooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05Oooool00ol0nY[ooooooooo
o`0<ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool07?ooool9o`3jVSkooooo00?o
0000ooooooooool08_oooolAool000Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`1kooooo`03o`000?oooooooooo03_ooooo000_ooooo`?o00001?ooool2o`0000Cooooo00?o0000
ooooooooool07?ooool00ooo003oooooooooo`1kooooo`03o`000?oooooooooo01Sooooo0ol00004
ooooo`;o00001?ooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJ
ooooooooool03Oooool00ol0nY[oooooooooo`1Sooooo`03o`000?oooooooooo01cooooo0ol00003
ooooo`;o00003_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJ
ooooooooool0N_ooool2o`0003gooooo000`ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000oooool00ol0003oooooooooo`0Looooo`03ool00?oooooooooo07_ooooo00?o0000
ooooooooool05oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0oooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo00cooooo4Ol0nYYUooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0=ooooo`03o`3j
V_oooooooooo00Gooooo2?l0nYYmooooo`03o`000?oooooooooo03_ooooo000`ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0Eooooo`Soo`00
OOooool00ol0003oooooooooo`0Kooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooo
ooooooooo`00000Gooooo`03o`3jV_oooooooooo08;ooooo00?o0000ooooooooool06_ooool5o`00
00?ooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo
03_ooooo000`ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000ooooolHo`00
o`03ool00?l00?oo003o08?o003o6oooool2o`0000?ooooo00Co0000oooooooooooo00000oooool2
o`0001Gooooo00?o0?ZJooooooooool0P_ooool2o`0001cooooo00Co0000oooooooooooo00001?oo
ool2o`0000kooooo00?o0?ZJooooooooool0ROooool2o`0003gooooo000`ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0Eooooo`03ool00?oo
oooooooo04?ooooo2Ol0nYXFooooo`Wo0?ZJ5oooool00ol0003oooooooooo`0Kooooo`04o`000?oo
ooooooooo`0000;ooooo00Go0000ooooooooooooooooo`00000Fooooo`03o`3jV_oooooooooo08?o
oooo00?o0000ooooooooool06oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00go
oooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0kooooo`00;oooool2o`0000Cooooo
00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0Dooooo`03ool00?oooooooooo04Co
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Go
oooo2Ol0nYX?ooooo`03o`000?oooooooooo01Oooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`23
ooooo`03o`000?oooooooooo01cooooo0_l00004ooooo`;o00003_ooool00ol0nY[oooooooooo`29
ooooo`;o0000?Oooool0033ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00?o0000oooo
ooooool03Oooool8ool002Oooooo4?l0nYX?ooooo`03o`3jV_oooooooooo00Gooooo6?l0nYX?oooo
o`Wo0?ZJ1oooool00ol0nY[oooooooooo`0Hooooo`?o00001?ooool2o`0000Cooooo00?o0000oooo
ooooool05?ooool00ol0nY[oooooooooo`23ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000oooo
ooooool0>oooool003cooooo0_l0000>ooooo`03ool00?oooooooooo02cooooo00?o0?ZJoooooooo
ool03?oooolAo`3jVSKooooo2?l0nYX00ol0003oooooooooo`0Uooooo`;o00005Oooool00ol0nY[o
ooooooooo`22ooooo`;o00009?ooool2o`0000kooooo00?o0?ZJooooooooool0ROooool2o`0003go
oooo000looooo`03o`000?oooooooooo00gooooo00?oo`00ooooooooool0;?ooool00ol0nY[ooooo
ooooo`1Kooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05?ooool00ol0nY[ooooo
ooooo`23ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03Oooool00ol0nY[ooooo
ooooo`2:ooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oooooooooo00gooooo00?o
o`00ooooooooool0;?ooool00ol0nY[oooooooooo`1Kooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool03Oooool8o`3jVXGooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool0>oooool003cooooo00?o0000
ooooooooool03Oooool00ooo003oooooooooo`0/ooooo`03o`3jV_oooooooooo05_ooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000
ooooooooool08_ooool2o`0000kooooo00?o0?ZJooooooooool0ROooool2o`0003gooooo000loooo
o`03o`000?oooooooooo00gooooo00?oo`00ooooooooool03?ooool9o`3jVPoooooo2Ol0nYYMoooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`2:oooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`2:oooo
o`03o`000?oooooooooo03_ooooo000loooooa7oo`003_ooool00ol0nY[oooooooooo`05ooooo`Wo
0?ZJ1oooool00ol0nY[oooooooooo`1Rooooo`;o00009ooooolAo`3jVX_ooooo0_l0000Mooooo`?o
00001?ooool2o`0000kooooo00?o0?ZJooooooooool0ROooool2o`0003gooooo000looooo`03o`00
0?oooooooooo01cooooo00?o0?ZJooooooooool03Oooool9o`3jVVGooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01[ooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0R_ooool00ol0003o
ooooooooo`0kooooo`00??ooool00ol0003oooooooooo`0Looooo`03o`3jV_oooooooooo07_ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01kooooo
00Go0000ooooooooooooooooo`00000?ooooo`03o`3jV_oooooooooo08[ooooo00?o0000oooooooo
ool0>oooool003cooooo00?o0000ooooooooool07?ooool00ol0nY[oooooooooo`1kooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Nooooo`04o`00
0?ooooooooooooooo`;o00003_ooool00ol0nY[oooooooooo`29ooooo`;o0000?Oooool003cooooo
00?o0000ooooooooool07?ooool00ol0nY[oooooooooo`1kooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Jooooo`Co00001?ooool00ol0003ooooo
ooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool0>oooool003cooooo0_l0
000Mooooo`03o`3jV_oooooooooo07[ooooo0_l0000Wooooo`;o0000V_ooool2o`0001cooooo00?o
0000ooooooooool01Oooool2o`0000kooooo00?o0?ZJooooooooool0ROooool2o`0003gooooo000l
ooooo`03o`000?oooooooooo01Gooooo2?l0nYYmooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0V_ooool00ol0003oooooooooo`0Jooooo`Go00000oooool00ol0003oooooooooo`0=
ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool0>oooool002oooooo0ol00002oooo
o`Go00000oooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo08;ooooo00?o0000oooo
ooooool06?ooool3o`0000;ooooo1Ol00003ooooo`03o`000?oooooooooo09[ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000oooo
ooooool0>oooool0033ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003oooo
o`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool0P_ooool00ol0003oooooooooo`0Goooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00003ooooo`03o`000?oo
oooooooo09[ooooo00?o0000ooooooooool08_ooool2o`0000kooooo00?o0?ZJooooooooool0ROoo
ool2o`0003gooooo000`ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo08?ooooo00?o0000ooooooooool06oooool0
1Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0V_ooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0R_ooool00ol0003ooooooooo
o`0kooooo`00<?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0_l0000E
ooooo`03o`3jV_oooooooooo08;ooooo0_l0000Kooooo`;o00001Oooool00ol0003oooooooooo`02
ooooo`;o0000V_ooool2o`0002Cooooo4Ol0nYZ;ooooo`;o0000?Oooool0033ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000003oooool8o`3jVXGooooo00?o
0000ooooooooool06oooool00ol0003oooooo`000003ooooo`05o`000?ooooooooooooooool00000
W?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0
>oooool002oooooo0_l00003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool05oooool01ol0003ooooo
oooooooooooo0000ooooool000000oooool01Ol0003ooooooooooooooooo000009cooooo00?o0000
ooooooooool06oooool3o`0000Cooooo0_l0002Jooooo`;o0000?Oooool0033ooooo00?o0000oooo
ooooool00_ooool3o`0000Cooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`2:oooo
o`03o`000?oooooooooo01Sooooo0ol00003ooooo`?o00001?ooool00ol0003oooooooooo`2Joooo
o`03o`000?oooooooooo01[ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo09[ooooo00?o0000ooooooooool0>oooool003cooooo00?o0000ooooooooool03Oooool00ol0
nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0V_ooool00ol0
003oooooooooo`0Jooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2J
ooooo`03o`000?oooooooooo03_ooooo000looooo`;o00003_ooool00ol0nY[oooooooooo`29oooo
o`;o00009oooool2o`0009[ooooo0_l0000Looooo`Co00001?ooool2o`0009[ooooo0_l0000moooo
o`00??ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000looooo`03o`00
0?oooooooooo00gooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo09[ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`04ooooo`;o0000
V_ooool2o`0003gooooo000looooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0R_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool07?oo
ool2o`0000Cooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0kooooo`00??oooolA
o`3jVXcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0kooooo`00??ooool2o`00
09[ooooo0_l0000Wooooo`;o0000V_ooool2o`0002Cooooo0_l0002Jooooo`;o0000?Oooool003co
oooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo09[o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_o
oooo000looooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`2Jooooo`03o`000?oooooooooo02;ooooo0_l0002Jooooo`;o0000?Oooool003cooooo00?o
0000ooooooooool0V_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo09[ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000l
ooooo`;o0000V_ooool2o`0002Oooooo0_l0002Jooooo`;o00007_ooool00ol0003oooooooooo`03
ooooo`;o0000V_ooool2o`0003gooooo000looooo`03o`000?oooooooooo09[ooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000looooo`03
o`000?oooooooooo09[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Jooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Jooooo`03
o`000?oooooooooo03_ooooo000_ooooo`?o00001?ooool3o`0000?ooooo00?o0000ooooooooool0
V_ooool00ol0003oooooooooo`0Hooooo`?o00001?ooool3o`0000?ooooo00?o0000ooooooooool0
V_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00;ooooo0_l0002Jooooo`;o0000
?Oooool0033ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo09[ooooo00?o0000ooooooooool05oooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01kooooo
00Go0000ooooooooooooooooo`00002Looooo`03o`000?oooooooooo03_ooooo000`ooooo`04o`00
0?ooooooooooooooo`Go00000oooool2o`0009[ooooo0_l0000Mooooo`03o`000?oooooo000000Co
00000oooool2o`0009[ooooo0_l0000Looooo`05o`000?ooooooooooooooool000000oooool2o`00
09[ooooo0_l0000mooooo`00<?ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo01Wooooo0_l00002oooo
o`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0J
ooooo`Go00000oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000`oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`2Joooo
o`03o`000?oooooooooo01_ooooo00Ko0000oooooooooooo0000ooooool00004ooooo`03o`000?oo
oooooooo09[ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`2Jooooo`03o`000?oo
oooooooo03_ooooo000_ooooo`;o00001Oooool2o`0000Cooooo00?o0000ooooooooool0V_ooool0
0ol0003oooooooooo`0Gooooo`05o`000?ooooooooooooooool000000oooool2o`0000Cooooo00?o
0000ooooooooool0V_ooool00ol0003oooooooooo`0Rooooo`;o0000V_ooool2o`0003gooooo000`
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2J
ooooo`03o`000?oooooooooo01Sooooo0ol00005ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0V_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09[ooooo00?o0000
ooooooooool0>oooool003cooooo0_l0002Jooooo`;o00009oooool2o`0009[ooooo0_l0000Toooo
o`;o0000V_ooool2o`0003gooooo000looooo`03o`000?oooooooooo09[ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0V_ooool00ol0003oooooooooo`0kooooo`00??ooool00ol0003oooooooooo`2Jooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0Kooooo`?o0000
1?ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oo
oooooooo09[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Jooooo`03o`000?oo
oooooooo01[ooooo00Go0000ooooooooooooooooo`000003ooooo`;o0000V_ooool2o`0003gooooo
000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`0Jooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Cooooo0_l0000mooooo`00??oooonNo`0002OoooooW_l0000Mooooo`?o00001?oo
oonNo`0003gooooo003ooooookcooooo00Go0000ooooooooooooooooo`00003Nooooo`00oooooonl
ooooo`05o`000?ooooooooooooooool00000g_ooool00?oooooo_Oooool3o`000=oooooo0028oooo
o`?o0000oooooooooooooaGooooo002;ooooo`03o`000?oooooooooo0?oooooooooooolBooooo`00
Noooool4o`0000;ooooo1Ol00002ooooo`Co000000Koooooo`000?oooooo0000ooooool00002oooo
o`Co0000]?ooool3o`000;oooooo1?l0002<ooooo`00Ooooool01Ol0003ooooooooooooooooo0000
00?ooooo00go0000ooooooooooooooooo`000?oooooo0000ooooool0003oooooo`000?oooooo0000
00;ooooo00?o0000ooooooooool0]?ooool00ol0003oooooooooo`2oooooo`04o`000?oooooooooo
o`0008_ooooo001looooo`?o00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Oo0000
ooooool0003oooooo`000?oooooo000000;ooooo0ol0002fooooo`03o`000?oooooooooo0;oooooo
00Co0000oooooooooooo0000Roooool007_ooooo00?o0000ooooooooool01Oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Wo0000ooooool0003oooooo`000?oooooo0000ooooool000000_oo
ool00ol0003oooooooooo`2dooooo`;o0000`?ooool01?l0003oooooooooool0002;ooooo`00O?oo
ool4o`000004ooooool0003o0000o`0000Cooooo1ol000000ooooooo0000ooooo`02ooooo`;o0000
]_ooool2o`000003ooooool0003o00000;kooooo0ol0002<ooooo`00oooooooooooooa7ooooo00?o
0000ooooooooool0S?ooool008?ooooo00?o0000ooooooooool0oooooon9ooooo`;o0000S_ooool0
0?oooooooooooonPooooo`00oooooooooooooj3ooooo001Eooooo`Go00000oooool2o`0000Cooooo
0_l0000Booooo`?o00000oooool2o`0000Cooooo0_l0000@ooooo`?o00001?ooool2o`0000Cooooo
0_l0000@ooooo`?o00001?ooool2o`0000Cooooo0_l0000>ooooo`?o00001?ooool2o`0000Cooooo
0_l00004ooooo`;o0000=?ooool5o`0000?ooooo0_l00004ooooo`;o00004_ooool3o`0000?ooooo
0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo
0_l00004ooooo`;o00003_ooool3o`0000Cooooo0_l00004ooooo`;o00001?ooool2o`00037ooooo
1Ol00003ooooo`;o00001?ooool2o`0001;ooooo0ol00003ooooo`;o00001?ooool2o`00013ooooo
0ol00004ooooo`;o00001?ooool2o`00013ooooo0ol00004ooooo`;o00001?ooool2o`0000kooooo
0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l0000aooooo`00E_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`0<ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000d
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Booooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`00037ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo0000<?ooool005Oooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000oooooo1Ol00002oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000=Oooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003oooool5o`0000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00003_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000booooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`Go00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000>ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`00033ooooo001Hooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00gooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000kooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
3oooool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0003Kooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03Oooool01?l0003oooooooooool00003
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool4o`0000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`?o00000oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo0000<oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0=ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000>ooooo`Co00000oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000oooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000`ooooo`00EOooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000@ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000>ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000>ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
0000<oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000@ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000>ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000@ooooo`03o`000?oooooo000000?ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000>ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo0000<?ooool005Gooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004Oooool2o`0000?ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo00?o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000go
oooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000cooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`00017ooooo0_l00003ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00003oooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000=ooooo`;o00001?oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo0000<?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Aooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000oooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003Oooool2o`0000Cooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00033ooooo
001Fooooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`03o`000?oooooooooo00;ooooo0_l0
0004ooooo`;o00004Oooool2o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l0
0004ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000Cooooo0_l0
000eooooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`03o`000?oooooooooo00;ooooo0_l0
0004ooooo`;o00004Oooool2o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l0
0004ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000Cooooo0_l0
000booooo`?o00001?ooool2o`0000Cooooo0_l0000Cooooo`03o`000?oooooooooo00;ooooo0_l0
0004ooooo`;o00004Oooool2o`0000Cooooo0_l00004ooooo`;o00004?ooool3o`0000Cooooo0_l0
0004ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000Cooooo0_l0
000aooooo`00oooooooooooooj3ooooo003oooooooooooooX?ooool00?oooooooooooonPooooo`00
?oooool5o`000003o`3jV_l0003o000009Ko00009oooool2o`000004o`3jV_l0003o0?ZJo`0000;o
o`0000?o0?ZJo`000?l000005?l000000ol0nY[o0000o`00001Co`000003o`3jV_l0003o000002Ko
00009?ooool2o`0000;oo`0000?o0000o`00ool000005ol00002o`3jVWko0000>_ooool003oooooo
00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`0Gooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool09Oooool01_l0003oooooo`3jV_oooooo0?ZJooooo`;oo`0000?o0?ZJoooo
ooooool05?ooool00ol0nY[oooooooooo`0Mooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool05?ooool00ol0nY[oooooooooo`05ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool08_ooool2o`000004oooooooo003oo`00o`00oaSooooo0_l0nYXOooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo03Sooooo000oooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool0UOooool00ol0
003oooooooooo`0Uooooo`06o`000?oooooo0?ZJooooool0nY[ooooo0_oo00000ol0nY[ooooooooo
o`0Cooooo`;o0?ZJEOooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooooooo02;ooooo00Ko
0?ZJooooooooooooooooool00?l00?lHooooo`;o0?ZJEOooool00ol0nY[oooooooooo`0Uooooo`03
o`000?oooooooooo03Sooooo000oooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool0
UOooool00ol0003oooooooooo`0Uooooo`;o000000Go0?ZJooooool0nY[oooooool00003o`0001Co
oooo0_l0nYYEooooo`03o`3jV_oooooooooo02Cooooo0_l0000Tooooo`03o`000?l0nY[ooooo00;o
oooo00?oo`00o`00ooooool05_ooool2o`3jVUGooooo00?o0?ZJooooooooool09?ooool2o`0003[o
oooo000oooooo`;o00000oooool00ol0nY[oooooooooo`2Dooooo`;o00009oooool01ol0003ooooo
o`3jV_oooooo0?ZJoooooooo00000ol0000Dooooo`;o0?ZJEOooool00ol0nY[oooooooooo`0Uoooo
o`03o`000?oooooooooo02;ooooo00Oo0000ooooool0nY[o0?ZJoooooooo003o003o01Oooooo0_l0
nYXNooooo`03o`3jV_oooooooooo03Cooooo00?o0?ZJooooooooool09Oooool00ol0003ooooooooo
o`0hooooo`00?oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo09Gooooo00?o0000
ooooooooool09Oooool01ol0003oooooo`3jV_oooooo0?ZJoooooooo00000ol0000Dooooo`;o0?ZJ
EOooool00ol0nY[oooooooooo`0Uooooo`03o`000?oooooooooo02;ooooo00Oo0000oooooooooooo
0?ZJoooooooo003o003o01Oooooo0_l0nYXNooooo`03o`3jV_oooooooooo03Cooooo00?o0?ZJoooo
ooooool09Oooool00ol0003oooooooooo`0hooooo`00?oooool00ol0003oooooooooo`02ooooo`03
o`3jV_oooooooooo09Gooooo00?o0000ooooooooool09Oooool2o`000004o`3jV_oooooo0?ZJoooo
o`?oo`005Oooool2o`3jVUGooooo00?o0?ZJooooooooool09?ooool2o`0002Cooooo0_l000001Ooo
oooo0?ZJoooooooo003o003o01Oooooo0_l0nYXNooooo`03o`3jV_oooooooooo03Cooooo00?o0?ZJ
ooooooooool09?ooool2o`0003[ooooo000oooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooo
ooooool0UOooool00ol0003oooooooooo`0Uooooo`06o`000?oooooo0?ZJooooool0nY[ooooo0ooo
000Eooooo`;o0?ZJEOooool00ol0nY[oooooo`3jVP0Uooooo`03o`000?oooooooooo02;ooooo00Oo
0000oooooooooooo0?ZJoooooooo003o003o01Oooooo0_l0nYXNooooo`03o`3jV_oooooooooo03Co
oooo00?o0?ZJooooooooool09Oooool00ol0003oooooooooo`0hooooo`00?oooool2o`0000?ooooo
00?o0?ZJooooooooool0U?ooool2o`0002Oooooo00Ko0000ooooool0nY[oooooo`3jV_ooool3ool0
01Gooooo0_l0nYXSooooo`03o`3jV_oooooooooo02oooooo0ol0nYXUooooo`03o`000?oooooooooo
02;ooooo00Oo0000ooooooooooooooooo`3jV_oo003o003o01Oooooo0_l0nYXNooooo`03o`3jV_oo
oooooooo03Cooooo00?o0?ZJooooooooool09Oooool00ol0003oooooooooo`0hooooo`00?oooool0
0ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo09Gooooo00?o0000ooooooooool09Oooool0
1?l0003oooooo`3jV_l0nYX2ooooo`?oo`005Oooool2o`3jVR;ooooo0_l0nYXaooooo`?o0?ZJ9Ooo
ool00ol0003oooooooooo`0Rooooo`07o`000?ooooooooooooooool0nY[oo`00o`00o`0Fooooo`03
o`3jV_oooooo0?ZJ01kooooo00?o0?ZJooooooooool0=?ooool00ol0nY[oooooooooo`0Uooooo`03
o`000?oooooooooo03Sooooo000oooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool0
UOooool00ol0003oooooooooo`0Uooooo`;o00000_l0nYX2ooooo`?oo`005Oooool2o`3jVR7ooooo
00?o0?ZJooooool0nYX0<Oooool3o`3jVRCooooo0_l0000Tooooo`;o00000_ooool00ol0nY[oo`00
o`00o`0Fooooo`03o`3jV_oooooo0?ZJ01kooooo00?o0?ZJooooooooool0<oooool2o`3jVRKooooo
0_l0000jooooo`00?oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo09Gooooo00?o
0000ooooooooool09Oooool01?l0003oooooo`3jV_l0nYX2ooooo`?oo`005Oooool2o`3jVR7ooooo
00?o0?ZJooooool0nYX0<Oooool2o`3jVP03ool00?oooooooooo02?ooooo00?o0000ooooooooool0
8_ooool02?l0003ooooooooooooooooo0?ZJool00?oooooo003o3Oooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooo0?ZJ01kooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0K
ooooo`;o0?ZJ9oooool00ol0003oooooooooo`0hooooo`00?oooool2o`0000?ooooo00?o0?ZJoooo
ooooool0U?ooool2o`0002Oooooo00Co0000ooooool0nY[o0?ZJ0_ooool3ool001Gooooo0_l0nYXQ
ooooo`03o`3jV_oooooo0?ZJ037ooooo00?o0?ZJool00?oo00009Oooool00ol0003oooooooooo`0R
ooooo`08o`000?ooooooooooooooool0nY[oooooool00?l00?l<ooooo`;o0?ZJ1oooool00ol0nY[o
ooooo`3jVP0Nooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ9oooool00ol0003o
ooooooooo`0hooooo`00?oooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00?oo`00o`3jV_oo
ool05Oooool00ol0nY[oooooooooo`1kooooo`03o`000?oooooooooo02Gooooo00Co0000o`3jV_oo
oooo0?ZJ0_ooool3ool001Gooooo0_l0nYX00ol00?oo0?ZJooooo`0Nooooo`03o`3jV_oooooo0?ZJ
037ooooo00?o0?ZJool00?oo00008_ooool01?l0nY[oooooo`000?l0000Tooooo`;o00000_ooool0
1?l0nY[oooooool00?l00?l<ooooo`;o0?ZJ1oooool00ol0nY[oooooo`3jVP0Nooooo`;o0?ZJ5_oo
ool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ9_ooool2o`0003[ooooo000oooooo`05o`000?oooooo
ooooooooool0nYX00_ooool2ool00003o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool0Nooo
ool00ol0003oooooooooo`0Gooooo`Go00000oooool2o`0000Cooooo00Co0000o`3jV_oooooo0?ZJ
0_ooool3ool001Gooooo1?l0nYXOooooo`03o`3jV_l00?oo0?ZJ01;ooooo00?o0?ZJooooooooool0
6oooool2o`3jVP;oo`008_ooool01?l0nY[oooooooooool0000Gooooo`?o00001?ooool2o`0000Co
oooo00So0000ooooooooooooooooo`3jV_ooooooo`00o`00o`cooooo0_l0nYX7ooooo`03o`3jV_oo
oooo0?ZJ01gooooo00?o0?ZJooooool0nYX05_ooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ9ooo
ool00ol0003oooooooooo`0hooooo`00?oooool2o`0000;ooooo00?o0?ZJooooooooool00_oo0000
0ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo07[ooooo0_l0000Jooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000oooool01?l0003o0?ZJooooool0nYX2ooooo`?o
o`005Oooool4o`3jVQoooooo00Co0?ZJool00?l00?oo0?ZJ4Oooool00ol0nY[oooooooooo`0Coooo
o`03o`3jV_oooooooooo00Gooooo0_l0nYX2ool0027ooooo00Go0?ZJooooool0nY[oooooo`00000H
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool02?l0003ooooooooo
oooooooo0?ZJoooooooo003o003o2oooool3o`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ7Oooool0
1?l0nY[oooooo`3jV_l0nYXDooooo`;o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP0Wooooo`03o`000?oo
oooooooo03Sooooo000oooooo`05o`000?ooooooooooooooool0nYX00_ooool3o`0001Gooooo00?o
0?ZJooooooooool0Noooool00ol0003oooooooooo`0Aooooo`Go00000oooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000o`3jV_oooooo0?ZJ0_ooool3ool001Go
oooo0ol0nYX00ol00?oo0?ZJooooo`0Mooooo`04o`3jV_oo003o003oo`3jVQ7ooooo00?o0?ZJoooo
ooooool04_ooool2o`3jVPOooooo0_l0nYX2ool0027ooooo00?o0?ZJooooool0nYX00_l0000Hoooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool2o`0000;ooooo00Co0?ZJ
oooooooo003o003o2oooool00ol0nY[oooooo`3jVP06ooooo`04o`3jV_ooooooooooo`3jVQgooooo
00Co0?ZJooooool0nY[o0?ZJ5?ooool2o`3jVQcooooo00?o003oo`3jV_l0nYX09_ooool2o`0003[o
oooo000aooooo`Go00000oooool2o`0000Cooooo00Go0000ooooooooooooooooo`3jVP02ooooo`?o
00005Oooool00ol0nY[oooooooooo`1kooooo`03o`000?oooooooooo01[ooooo00Go0000oooooooo
ooooooooo`000002ooooo`08o`000?ooooooooooooooool0003o0?ZJooooool0nYX2ooooo`?oo`00
5?ooool01_l0nY[oooooo`3jV_l0nY[oo`00o`3jVQkooooo00Coo`00o`00oooo003o0?ZJ4Oooool0
0ol0nY[oooooooooo`0Booooo`;o0?ZJ1oooool2o`3jVP;oo`008?ooool2o`3jVP04ooooool0nY[o
ooooo`0001Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`08o`00
0?ooooooooooooooool0nY[oooooool00?l00?l;ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Co0?ZJ
oooooooooooo0?ZJ7Oooool00ol0nY[oooooo`3jVP02o`3jVQ?ooooo0_l0nYXLooooo`03o`3jV_l0
0?oo0?ZJ02Oooooo00?o0000ooooooooool0>?ooool003;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooooooool0nYX00_ooool3o`0001Go
oooo00?o0?ZJooooooooool0Noooool00ol0003oooooooooo`0Gooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00003ooooo`04o`000?l0nY[oooooo`3jVP;ooooo0ooo
000Dooooo`03o`3jV_oooooo0?ZJ00;oo`0000?o0?ZJooooooooool07?ooool01?oo003o003oool0
0?l0nYXAooooo`03o`3jV_oooooooooo017ooooo0ol0nYX7ooooo`;o0?ZJ0_oo000Pooooo`06o`3j
V_l00?ooooooo`3jV_oooooo00006?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000?ooooo00So0000ooooooooooooooooo`3jV_ooooooo`00o`00o`_ooooo00?o0?ZJooooool0
nYX01_ooool01?l0nY[oooooooooool0nYXMooooo`05o`3jV_l0003o0000o`000?l0nYX04oooool3
o`3jVQ_ooooo00?o0?ZJooooool0nYX09oooool00ol0003oooooooooo`0hooooo`00:oooool5o`00
00?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`;o00000_ooool0
1_l0nY[ooooooooooooo003o003oool001Gooooo00?o0?ZJooooooooool0N_ooool2o`0001Wooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00Oo0000o`3j
V_oooooo0?ZJoooooooo003o003o00;oo`005?ooool00ol0nY[oooooo`3jVP02ool00003o`3jV_oo
oooooooo01cooooo00Coo`00oooooooo003o0?ZJ4Oooool00ol0nY[oooooooooo`0Aooooo`04o`3j
V_ooooooooooo`3jVPKooooo0_l0nYX2ool00003o`3jV_oooooooooo01gooooo00Co0?ZJo`00oooo
oooo0?ZJ0_l0000Gooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`;o00000_ooool0
1?l0nY[oooooool00?l00?l4ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ
1_ooool01?l0nY[oooooool00?l0nYXMooooo`05o`3jV_l0003o0000o`000?l0nYX04oooool3o`3j
VQ_ooooo00?o0?ZJooooool0nYX05oooool00ol0nY[oooooooooo`0<ooooo`;o0000>_ooool003Co
oooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?ooooooooooooooool000000oooool0
1_l0nY[ooooooooooooo003o003oool001Gooooo00?o0?ZJooooooooool0EOooool2o`3jVRCooooo
00?o0000ooooooooool06?ooool3o`0000Cooooo0_l00004ooooo`09o`000?l0nY[oooooo`3jV_oo
ooooo`00o`00ooooooooo`0001Cooooo00?o0?ZJooooool0nYX00_oo00000ol0nY[oooooooooo`0L
ooooo`04ool00?l0nY[oo`00o`3jVQ7ooooo00?o0?ZJooooooooool04Oooool01?l0nY[ooooooooo
ool0nYX6ooooo`?o000000?oo`00o`3jV_ooool07_ooool01_l0nY[o003oooooool0nY[oooooo`00
01Sooooo00?o0000ooooooooool00oooool2o`0000Cooooo00So0000ooooooooooooooooo`3jV_oo
ooooo`00o`00o`Cooooo00?o0?ZJooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ00Go
oooo00Co0?ZJool00?oo003oo`007?ooool00ol0nY[oooooo`000002o`000003o`3jV_oooooooooo
013ooooo00Co0?ZJo`000?l0003o00006oooool00ol0nY[oooooool0000Gooooo`03o`3jV_oooooo
oooo00gooooo00?o0000ooooooooool0>?ooool0037ooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`3jVP02ooooo`03ool0
0?l00?ooo`0001Gooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`0aooooo`;o0?ZJ
9?ooool00ol0003oooooooooo`0Uooooo`09o`000?l0nY[oooooo`3jV_ooooooo`00o`00oooooooo
o`0001Cooooo00Ko0?ZJooooool0nY[oo`00o`3jV_oo000Nooooo`04ool00?l0nY[oo`00o`3jVQ7o
oooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3j
VPKooooo0ol000000ooo003o0?ZJooooo`0Nooooo`06o`3jV_l00?oo003oo`3jV_oooooo00009?oo
ool02?l0003ooooooooooooooooo0?ZJoooooooo003o003o0oooool2o`3jVP;ooooo00Co0?ZJoooo
oooooooo0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_ooooooo`00oooooooo00001ooo
ool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooo003o00;oo`0000?o0?ZJooooooooool04?oo
ool01Ol0nY[o0000o`000?l0003o0?ZJ01Wooooo00?o0?ZJo`00ool000000_l0000Eooooo`;o0?ZJ
3oooool00ol0003oooooooooo`0hooooo`00<Oooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00?oo`00oooo
oooo00005Oooool00ol0nY[oooooooooo`0Pooooo`?o0?ZJ<_ooool2o`3jVRCooooo00?o0000oooo
ooooool09Oooool02_l0003o0?ZJooooool0nY[oooooool00?l00?ooooooool00?l0nYXCooooo`06
o`3jV_oooooo0?ZJool00?l0nY[oo`007Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ013ooooo0_l0
nYX;ooooo`?o0?ZJ1?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo0ol000000ooo003o0?ZJ
ooooo`0Nooooo`04o`3jV_oo003o003oo`3jVP;o00009?ooool2o`0000;ooooo00Co0?ZJoooooooo
003o003o0oooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`02
ooooo`05o`3jV_ooooooo`00oooooooo00001oooool00ol0nY[oooooooooo`0Booooo`06o`3jV_l0
0?ooo`00o`3jV_oo003o0?ZJ4_ooool01Ol0nY[o0000o`000?l0003o0?ZJ01Wooooo00?o0?ZJoooo
ool000000_l0000Eooooo`;o0?ZJ3_ooool2o`0003[ooooo000booooo`?o00001?ooool2o`0000Co
oooo0_l00002ooooo`06o`3jV_ooooooooooool00?ooooooo`005Oooool00ol0nY[oooooooooo`0P
ooooo`03o`3jV_oooooo0?ZJ033ooooo00Co0?ZJooooool0nY[o0?ZJ8oooool2o`0002Oooooo00[o
0000o`3jV_oooooo0?ZJoooooooo003o003ooooooooo003o0?ZJ4oooool01_l0nY[oooooo`3jV_oo
003o0?ZJool001gooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0@ooooo`;o0?ZJ2_ooool2o`3jVP03
ooooool0nY[ooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`05o`3jV_oo003ooooo
ool00?l0nYX07_ooool01ol0nY[o003oool00?oo003o0?ZJooooool000009?ooool02?l0003ooooo
oooooooooooo0?ZJoooooooo003o003o0oooool01_l0nY[oooooo`3jV_oooooo0?ZJooooo`;o0?ZJ
0oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oo003o003oo`00oooo00001oooool00ol0nY[o
ooooooooo`0Booooo`03o`3jV_l00?ooo`0000;o0?ZJ00?oo`00o`3jV_ooool04?ooool01Ol0nY[o
o`00ool00?oo003o0?ZJ01Sooooo00?o003oo`3jV_oo00000ol0000Eooooo`?o00002?ooool2o`3j
VPCooooo00?o0000ooooooooool0>?ooool003oooooo00Go0000ooooooooooooooooo`3jVP02oooo
o`03ool00?ooooooo`0001Gooooo00Co0?ZJooooool0nY[o0?ZJ7oooool00ol0nY[oooooo`3jVP0`
ooooo`04o`3jV_ooooooo`00ool002Cooooo00?o0000ooooooooool09Oooool02_l0003o0?ZJoooo
ool0nY[oooooool00?l00?ooooooool00?l0nYXCooooo`06o`3jV_l0003o0000o`000?l0nY[oo`00
7Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ013ooooo0_l0nYX:ooooo`04o`3jV_ooooooooooo`3j
VPCooooo00Go0?ZJo`00ool00?ooooooo`3jVP06ooooo`05o`3jV_oo003oooooool00?l0nYX07_oo
ool01ol0nY[o003oool00?oo003o0?ZJooooool000009?ooool02?l0003ooooooooooooooooo0?ZJ
oooooooo003o003o0oooool01ol0nY[oooooo`3jV_oooooo0?ZJooooool0nYX01?ooool00ol0nY[o
ooooooooo`02ooooo`05o`3jV_oo003o003oo`00oooo00001oooool00ol0nY[oooooooooo`08oooo
o`;o0?ZJ2?ooool00ol0nY[oo`00ool00002o`3jVP03ool00?l0nY[ooooo013ooooo00Go0?ZJool0
0?l0nY[oo`00o`3jVP0@ooooo`;o0?ZJ1_ooool01_l00?oo0?ZJool00?oooooo0?ZJool001Gooooo
0ol00007ooooo`?o0?ZJ1?ooool00ol0003oooooooooo`0hooooo`00?oooool01Ol0003ooooooooo
oooooooo0?ZJ00;ooooo00?oo`00oooooooo00005?ooool2o`3jVP03ooooool0nY[o0?ZJ01oooooo
00?o0?ZJooooool0nYX0<?ooool01?l0nY[oooooool00?oo000Rooooo`03o`3jV_oooooo000002Oo
oooo00[o0000o`3jV_oooooo0?ZJoooooooo003o003ooooooooo003o0?ZJ4oooool01_l0nY[o0000
o`000?l0003o0?ZJool001gooooo00Go0?ZJool00?ooooooo`00o`3jVP0@ooooo`;o0?ZJ2_ooool0
1?l0nY[oooooooooool0nYX4ooooo`05o`3jV_oo003oo`00ooooool0nYX01_ooool01Ol0nY[oo`00
ooooool0nY[oo`0001kooooo00Oo0?ZJool00?ooooooo`00o`3jV_oooooo000002Cooooo00So0000
ooooooooooooooooo`3jV_ooooooo`00o`00o`?ooooo00Oo0?ZJooooool0nY[oooooo`3jV_oooooo
0?ZJ00;oo`000_ooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oo003ooooooooooooo00001_oo
ool2o`3jVP[ooooo0_l0nYX7ooooo`04o`3jV_ooooooo`00ooooo`;o0?ZJ00?oo`00o`3jV_ooool0
3oooool01_l0nY[o003oool00?l0nY[oo`00o`3jVPoooooo0ol0nYX6ooooo`06o`3jV_ooooooo`00
ooooool0nY[oo`005?ooool01?l0nY[o0000o`000?l00007ooooo`04o`3jV_ooooooooooo`3jVP?o
oooo00?o0000ooooooooool0>?ooool003oooooo00Go0000ooooooooooooooooo`3jVP02ooooo`03
ool00?ooooooo`0001Cooooo0_l0nYX01?oooooo0?ZJooooool0nYXNooooo`03o`3jV_oooooo0?ZJ
033ooooo00Co0?ZJoooooooo003oo`008Oooool2o`3jVP03ooooool0003ooooo02Kooooo00So0000
o`3jV_oooooo0?ZJoooooooo003o003oooooo`;oo`004oooool01_l0nY[o0000o`000?l0003o0?ZJ
ool001gooooo00Go0?ZJool00?ooooooo`00o`3jVP0@ooooo`;o0?ZJ2_ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00?ooooo00Go0?ZJool00?oo003oooooo`3jVP05ooooo`06o`3jV_ooooooo`00oooo
ool0nY[oo`007_ooool01Ol0nY[oo`00oooooooo003o0?ZJ00;o00009?ooool2o`0000?ooooo00?o
0?ZJool00?l00?l00oooool01ol0nY[oooooo`3jV_oooooo0?ZJooooool0nYX00ooo00000ooooooo
0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00?o00001Oooool2o`3jVPWooooo00Co0?ZJoooooooo
oooo0?ZJ1_ooool01?l0nY[o003oool00?ooool2o`3jVP03ool00?l0nY[ooooo00oooooo00?o0?ZJ
o`00oooo00000_l0nYX00ooo003oooooooooo`0=ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Ko0?ZJ
oooooooo003oooooo`3jV_oo000Dooooo`03o`3jV_l00?ooo`0000Sooooo00Co0?ZJoooooooooooo
0?ZJ0_ooool2o`0003[ooooo000oooooo`;o00000_ooool01_l0nY[oooooool00?l00?ooooooool0
01Cooooo0_l0nYX01?oooooo0?ZJo`00ool0nYXNooooo`03o`3jV_oo003o0?ZJ02Oooooo0_l0nYX7
ooooo`04o`3jV_ooooooo`00ool0023ooooo00Go0?ZJoooooooooooo0?ZJo`00000Wooooo`08o`00
0?l0nY[oooooo`3jV_ooooooo`00o`00ooooool2ool000gooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooool00002ooooo`03ool00?oooooooooo01_ooooo00Go0?ZJool00?ooooooo`00o`3j
VP0@ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`02ooooo`09o`3jV_ooooooooooo`3jV_oooooo
o`00o`00oooo003o0?ZJ00Gooooo00Ko0?ZJoooooooo003oooooo`3jV_oo000Nooooo`07o`3jV_oo
003oooooool00?l0nY[oooooo`00000Tooooo`03o`000?oooooooooo00;ooooo00?o0?ZJool00?l0
0?l00oooool03?l0nY[oooooo`3jV_oooooo0?ZJooooool0nY[oo`00oooooooo003oooooo`3jVP?o
oooo00Co0?ZJoooooooo003ooooo0ol00005ooooo`;o0?ZJ2Oooool01?l0nY[oooooooooool0nYX6
ooooo`04o`3jV_oo003oo`00ooooo`;o0?ZJ00?oo`00o`3jV_ooool03oooool00ol0nY[oo`00oooo
o`02o`3jVP03ool00?oooooooooo00cooooo00Co003oo`3jV_oooooo0?ZJ1_ooool01_l0nY[oo`00
oooooooooooo0?ZJool001Cooooo00Co0?ZJo`00oooo003o0?ZJ1_ooool01Ol0nY[o003oo`00oooo
oooo0?ZJ00?ooooo00?o0000ooooooooool0>?ooool003oooooo00[o0000ooooooooooooooooo`3j
V_ooooooo`00o`00ooooooooo`005?ooool2o`3jVP04ooooool0nY[oo`00o`3jVQkooooo00Co0?ZJ
ool00?l00?oo0?ZJ9Oooool3o`3jVPOooooo0_l0nYX2ool0023ooooo00Go0?ZJoooooooooooo0?ZJ
o`00000Wooooo`08o`000?l0nY[oooooo`3jV_ooooooo`00o`00ooooool2ool000gooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooool00002ooooo`03ool00?oooooooooo01_ooooo00Goo`00
o`3jV_ooooooo`00o`3jVP0@ooooo`;o0?ZJ1Oooool01_l0nY[ooooooooooooooooo0?ZJooooo`;o
o`0000[oooooo`3jV_ooooooooooo`3jV_l00?ooo`00o`00oooo003o0?ZJ1Oooool01_l0nY[ooooo
ool00?oooooo0?ZJool001kooooo00Oo0?ZJool00?l0nY[oo`00o`3jV_oooooo000002Cooooo00?o
0000ooooooooool00_ooool00ol0nY[oo`00o`00o`03ooooo`07o`3jV_oooooo0?ZJooooool0nY[o
ooooool00002o`00o`03ool00?oooooo0?ZJ00?ooooo00Co0?ZJool00?l00?oooooo0ol00005oooo
o`;o0?ZJ2Oooool01?l0nY[oooooooooool0nYX6ooooo`04o`3jV_oo003oooooooooo`;o0?ZJ00?o
o`00o`3jV_ooool03oooool00ol0nY[oo`00ooooo`02o`3jVP03ool00?oooooooooo00cooooo00Go
0?ZJo`00ool00?ooooooo`3jVP05ooooo`06o`3jV_oo003oooooooooool0nY[oo`003_ooool00ol0
nY[oooooooooo`03ooooo`04o`3jV_l00?ooo`00o`3jVPKooooo00Go0?ZJool00?oo003oooooo`3j
VP03ooooo`03o`000?oooooooooo03Sooooo000oooooo`0:o`000?ooooooooooooooool0nY[ooooo
ool00?l00?ooooooool001Cooooo0_l0nYX01?ooooooo`00ool00?l0nYXNooooo`04ool00?l00?oo
o`00o`3jVRGooooo00Co0?ZJooooool0nY[o0?ZJ1_ooool2o`3jVP;oo`008?ooool01Ol0nY[o003o
ooooool0nY[o000002Oooooo00?o0000o`3jV_l0nYX00_ooool00ooo003o003oooooo`02ool000go
oooo00?o0?ZJooooooooool00_ooool01?l0nY[ooooooooooooo0002ooooo`03ool00?oooooooooo
01_ooooo00Goo`00o`3jV_ooooooo`00o`3jVP0@ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP02
ooooo`06o`3jV_oo003oo`00ool00?oooooo0?ZJ0_ooool01_l0nY[oo`00ooooooooooooo`00o`3j
VPGooooo00Ko0?ZJoooooooo003oooooo`3jV_oo000Nooooo`05o`3jV_oo003o0?ZJool00?l0nYX0
0_l0000Tooooo`;o00000oooool00ol0nY[oo`00o`00o`03ooooo`04o`3jV_oooooo0?ZJooooo`;o
0?ZJ00Koo`00o`00ool00?ooo`00ooooool0nYX3ooooo`03o`3jV_oo003o003o00;ooooo00?o0?ZJ
ool00?ooool01?ooool00ol0nY[oo`00ooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX01_oo
ool02?l0nY[oo`00oooooooooooo0?ZJoooooooo003o0?ZJ1oooool00ol00?ooooooooooo`05oooo
o`;o0?ZJ00Koo`00ooooool0nY[o0?ZJool00?l0nYX=ooooo`05o`3jV_oooooo003oooooool0nYX0
1Oooool01_l0nY[oo`00oooooooooooo0?ZJool000gooooo0_l0nYX5ooooo`04o`3jV_ooooooo`00
o`3jVPGooooo0_l0nYX2ool00004o`00ool0nY[oooooooooo`;o0000>_ooool003oooooo00[o0000
ooooooooooooooooo`3jV_ooooooo`00o`00ooooooooo`005?ooool2o`3jVP04oooooooo003oo`00
o`3jVQkooooo00Coo`00o`00oooo003o0?ZJ9?ooool2o`3jVP;ooooo00?o0?ZJooooooooool01?oo
ool2o`3jVP;oo`0000?o0?ZJooooooooool07Oooool01Ol0nY[o003oooooool0nY[o000001[ooooo
0ol00004ooooo`;o00001?ooool00ol0003o0?ZJo`3jVP02ooooo`03ool00?l00?oooooo00;oo`00
3Oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooool000;ooooo00?oo`00oooooooo
ool06oooool01Ooo003o0?ZJoooooooo003o0?ZJ013ooooo0_l0nYX4ooooo`0;o`3jV_oooooooooo
o`3jV_oooooo0?ZJool00?ooooooo`00ooooool0nYX00_ooool01_l0nY[oo`00ooooooooooooo`00
o`3jVPGooooo00Ko0?ZJoooooooo003oooooo`3jV_oo000Looooo`;o0?ZJ00Ooo`00o`00ool0nY[o
o`00o`3jV_oooooo000001Kooooo1Ol00003ooooo`;o00001?ooool00ol0003oooooooooo`02oooo
o`03o`3jV_oo003o003o00?ooooo00Co0?ZJooooool0nY[ooooo0_l0nYX01_oo003o003oo`00oooo
003o003oo`3jVP?ooooo00Oo0?ZJool00?oooooo0?ZJooooool0nY[oo`0000Gooooo00?o0?ZJool0
0?ooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00So0?ZJool00?ooooooooooo`3j
V_ooooooo`00o`3jVPOooooo00?o003oo`3jV_l0nYX01Oooool01?l0nY[o003oool00?ooool2o`3j
VP03ool00?l0nY[ooooo00Kooooo00?o0?ZJooooooooool00oooool01Ol0nY[oooooo`00oooooooo
0?ZJ00Gooooo0_oo0003o`3jVP03ool00?oooooooooo00_ooooo0_l0nYX5ooooo`04o`3jV_oooooo
o`00ool000Gooooo00?o0?ZJool00?ooool00_oo00001Ol0nY[ooooooooooooooooo000003[ooooo
000oooooo`;o00000_ooool01_l0nY[oooooool00?l00?ooooooool001Cooooo0_l0nYX01?oooooo
o`00o`00oooo000Mooooo`05o`3jV_oo003oooooool00?l0nYX07Oooool3o`3jVPCooooo00Go0?ZJ
o`00ooooooooooooo`3jVP06ooooo`05o`3jV_oo003o0?ZJool00?l0nYX07oooool01Ol0nY[ooooo
o`00ool0nY[o000001_ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003oooo
o`03o`000?l0nY[o0?ZJ00;ooooo00?oo`00o`00ooooool00_oo000=ooooo`03o`3jV_oooooooooo
00;ooooo00Co0?ZJooooooooooooo`000_ooool00ooo003o0?ZJooooo`0Kooooo`05ool00?l0nY[o
ooooool00?l0nYX03oooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00?o0?ZJ00Go
o`00oooooooo003oooooo`3jVP02ooooo`06o`3jV_oo003oooooo`3jV_oo003o0?ZJ1Oooool01_l0
nY[oooooool00?oooooo0?ZJool001_ooooo0ol0nYX01ooo003oooooo`3jV_oo003oooooo`3jV_l0
00005oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool00_ooool00ol0nY[oo`00o`00o`02ooooo`05o`3jV_ooooooooooo`3jV_ooool00_l0
nYX01_oo003o0?ZJoooooooo003o003oo`3jVP?ooooo00Oo0?ZJool00?l0nY[o0?ZJooooool0nY[o
o`0000Cooooo00?o0?ZJoooooooo00002?ooool01Ol0nY[oo`00ool00?oooooo0?ZJ00Gooooo00?o
0?ZJool00?ooool00_ooool01?l0nY[oooooool00?l0nYX7ooooo`04o`00ool0nY[o0?ZJo`3jVPCo
oooo00So0?ZJool00?ooooooooooo`3jV_ooooooo`00o`3jVPKooooo0ol0nYX4ooooo`05o`3jV_oo
003o003oooooool0nYX01?ooool00ol0nY[oo`00ooooo`03o`3jVP03ool00?oooooooooo00_ooooo
0_l0nYX4ooooo`03o`3jV_l00?oooooo00;oo`001Oooool3o`000003oooooooo003o0?ZJ00?ooooo
00?o0000ooooooooool0>?ooool003oooooo00_o0000ooooooooooooooooo`3jV_ooooooo`00o`00
ooooooooo`00o`3jVP0Cooooo`;o0?ZJ00Coooooool00?ooooooo`007Oooool01Ol0nY[oo`00o`3j
V_oo003o0?ZJ01cooooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`05o`3jV_l00?oo003oooooool0
nYX01_ooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01kooooo00Ko0?ZJo`00oooo003oo`00o`3jV_l0
000Cooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo
00?o0000o`3jV_l0nYX00_ooool00ooo003oooooooooo`02ool000gooooo00?o0?ZJooooooooool0
0_ooool01?l0nY[oooooool00?l0nYX2ooooo`03ool00?l0nY[ooooo01[ooooo00Ko0?ZJool00?l0
nY[oooooool00?l0nYX?ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o0?ZJooooooooool00_l0nYX2
ool000;ooooo00Koo`00o`3jV_l0nY[oooooo`3jV_oo0002o`3jVP03ool00?l0nY[ooooo00Cooooo
00?o0?ZJoooooooo00000_ooool00ooo003oooooooooo`0Iooooo`?o0?ZJ00Ooo`00o`3jV_oooooo
0?ZJool00?l0nY[o000001Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003
ooooo`;o00000oooool00ol0nY[oo`00o`00o`02ooooo`07o`3jV_ooooooooooo`3jV_oooooo0?ZJ
ool00003o`3jVP03ool00?l00?oo0?ZJ00?ooooo00Co0?ZJool00?l0nY[ooooo0_l0nYX00ooo003o
ooooooooo`02ooooo`03o`3jV_oo003oo`0000Oooooo0_l0nYX2ool00003o`00ool0nY[ooooo00Co
oooo00Go0?ZJool00?ooooooooooo`3jVP02ooooo`03ool00?l0nY[ooooo00Kooooo0_l0nYX00ooo
oooo0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00;o0?ZJ00?oooooool00?l0nYX01Oooool2o`3j
VP03ooooool0nY[ooooo00;ooooo00Ko0?ZJool00?oo003oo`00ooooool0nYX4ooooo`07o`3jV_oo
003o0?ZJo`3jV_oooooo0?ZJool0000=ooooo`;o0?ZJ1?ooool00ol0nY[o003oool00002ool000Go
oooo0ol000000oooooooo`00o`3jVP02ooooo`;o0000>_ooool003oooooo00_o0000oooooooooooo
ooooo`3jV_ooooooo`00o`00ooooooooo`00o`3jVP0Cooooo`?o0?ZJ00?oo`00o`3jV_oo00007Ooo
ool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01cooooo00?o0?ZJooooooooool00_l0nYX3ooooo`05o`3j
V_l00?oo003oooooool0nYX01_ooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01kooooo00Ko0?ZJo`00
oooo003oo`00o`3jV_l0000Kooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0oooool00ol0003o0?ZJo`3jVP02ooooo`03ool00?oooooooooo00;oo`003Oooool00ol0nY[ooooo
ooooo`02ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool06_ooool01_l0nY[o
o`00o`3jV_ooooooo`00o`3jVPoooooo00?o0?ZJooooool0nYX01?ooool00ol0nY[oooooooooo`02
o`3jVP06ool00?l00?oo003ooooooooo003ooooo0ol0nYX01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Go
oooo00?o0?ZJo`00oooo00000_ooool00ooo003oooooooooo`0Gooooo`Go0?ZJ00Ooo`00o`3jV_oo
oooo0?ZJool00?l0nY[o000001Wooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0nY[oo`00o`00o`02ooooo`03o`3jV_oooooooooo00;o0?ZJ
00Soooooool00?l0nY[oooooo`3jV_oo003o003oo`3jVP?ooooo00Coo`00o`00ool0nY[ooooo0_l0
nYX00ooo003oooooooooo`02ooooo`03o`3jV_oo003oo`0000Oooooo00Ko0?ZJool00?oo003oo`00
o`00ool0nYX5ooooo`05o`3jV_oo003oooooooooool0nYX00_ooool00ooo003o0?ZJooooo`05oooo
o`05o`00ool0nY[oooooo`00ool0nYX01?ooool00ol0nY[oo`00ooooo`02o`3jVP03oooooooo003o
0?ZJ00Gooooo00Co0?ZJoooooooooooo0?ZJ0oooool01_l0nY[oo`00oooooooo003oooooo`3jVPCo
oooo00?o0?ZJool00?l0nYX00_ooool00ol0nY[oo`00ooooo`05ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooool0nYX01?ooool01Ol0nY[o003oool00?l0nY[oo`0000Gooooo0ol000001?l0
nY[oo`00ooooool0nYX2ooooo`03o`000?oooooooooo03Sooooo000oooooo`0;o`000?oooooooooo
ooooool0nY[oooooool00?l00?ooooooool00?l0nYX04oooool3o`3jVP03ool00?l0nY[oo`0001go
oooo00Go0?ZJool00?l0nY[oo`00o`3jVP0@ooooo`03o`3jV_oooooooooo00Wooooo00Go0?ZJoooo
ooooooooooooo`3jVP03ooooo`05o`3jV_oo003oo`00ooooool0nYX01Oooool00ol0nY[oooooool0
0002o`3jVP03ool00?oooooooooo01cooooo00Ko0?ZJool00?ooooooo`00o`3jV_l0000Kooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01_l0003o0?ZJo`3jV_oooooo
o`00o`00o`;ooooo00?o0?ZJool00?ooool03?ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo
ooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool06_ooool01_l0nY[oo`00ooooooooooooo`00o`3j
VPoooooo00?o0?ZJooooool0nYX01?ooool00ol0nY[oooooooooo`02o`3jVP06ool00?oooooo0?ZJ
oooooooo003ooooo0_l0nYX01_oo003oooooo`3jV_l0nY[oo`00o`3jVPCooooo00Co0?ZJooooool0
0?ooo`000_ooool00ooo003oooooooooo`0Fooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00Ooo`00
o`3jV_oooooo0?ZJool00?l0nY[o000001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0nY[oo`00o`00o`02oooo
o`03o`3jV_oooooooooo00;o0?ZJ00Soooooool00?l0nY[oooooo`3jV_ooooooo`00o`3jVP?ooooo
00Coo`00o`00ool0nY[ooooo0_l0nYX00ooo003oooooooooo`02ooooo`03o`3jV_oo003oo`0000;o
0?ZJ1?ooool2o`3jVP05ool00?oooooo003oool00?l0nYX01Oooool00ol0nY[oo`00o`3jVP02o`3j
VP;ooooo00?oo`00o`3jV_ooool01Oooool2o`3jVP04ooooool00?oo0?ZJo`3jVP?ooooo00?o0?ZJ
ool00?l0nYX00oooool00ooo003o0?ZJooooo`04ooooo`04o`3jV_ooooooooooo`3jVP?ooooo0_oo
00001?ooooooo`00ooooool0nYX4ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?ooool0
1?ooool2o`3jVPGooooo00?o0?ZJooooool0nYX01?ooool01Ol0nY[oo`00ooooool0nY[oo`0000Go
oooo00Oo0?ZJool00?oooooo0?ZJool00?oooooo0?ZJ00;ooooo00?o0000ooooooooool0>?ooool0
03oooooo0_l00002ooooo`07o`3jV_ooooooo`00o`00ooooooooo`00o`3jVP0Cooooo`?o0?ZJ00?o
o`00oooooooo00007Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ013ooooo00?o0?ZJooooooooool0
2?ooool00ol0nY[oooooooooo`02ooooo`05o`3jV_ooooooooooo`3jV_ooool00ooo00000ol0nY[o
ooooooooo`03ooooo`06o`3jV_ooooooo`00ooooool0nY[oo`007_ooool01_l0nY[oo`00oooooooo
003o0?ZJo`0001[ooooo0_l00004ooooo`04o`000?ooooooooooo`0000?ooooo00Ko0000o`3jV_l0
nY[oooooool00?l00?l2ooooo`03o`3jV_oo003ooooo00cooooo00Go0?ZJooooooooooooooooo`3j
VP02ooooo`06ool00?l0nY[ooooooooooooo003o0?ZJ6oooool01_l0nY[oo`00oooooooooooo0?ZJ
ool000oooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oooooooooool0nYX2ool000?o0?ZJ00Ko
o`00ooooool0nY[o0?ZJool00?ooool2o`3jVP03ool00?l0nY[ooooo00?ooooo00Co0?ZJooooool0
0?ooo`000_ooool00ooo003oooooooooo`0Fooooo`05o`3jV_ooooooooooooooool0nYX00_oo0000
1_l0nY[oooooo`3jV_oo003o0?ZJo`0001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000?ooooo0_l00003ooooo`03o`3jV_oo003o003o00;ooooo00?o0?ZJoooo
ooooool00_l0nYX3o`000005ooooool0nY[oooooool00?l0nYX00oooool01?oo003o0?ZJoooooooo
ool2o`3jVP03ool00?l0nY[ooooo00;ooooo00Go0?ZJool00?oo003o003oo`3jVP04ooooo`;o0?ZJ
00Koo`00o`00ool00?ooo`00o`00ool0nYX4ooooo`05o`3jV_oo003o0?ZJooooool0nYX00_ooool0
0ol0nY[oo`00ooooo`05ooooo`06o`3jV_ooooooooooo`00oooooooo0?ZJ0oooool00ooo003ooooo
o`3jVP03ooooo`03ool00?l0nY[ooooo00Cooooo00Ko0?ZJooooooooooooooooo`3jV_ooool3o`00
0004oooooooo003oooooo`3jVPCooooo0_oo00001Ol0nY[oooooooooool0nY[oo`0000Gooooo0_l0
nYX5ooooo`03o`3jV_oooooo0?ZJ00?ooooo0_l0nYX01?oo003oooooo`3jV_oo0004ooooo`09o`3j
V_l00?ooo`00ooooool0nY[oo`00ooooool0nY[ooooo00;o0000>_ooool003;ooooo0ol00004oooo
o`;o00001?ooool01?l0003oooooooooool0nYX2ooooo`05ool00?l00?ooooooool00?l0nYX04ooo
ool3o`3jVP04ool00?ooooooo`00o`3jVQcooooo00Go0?ZJool00?ooooooo`00o`3jVP0@ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool02Ol0nY[oooooooooool0nY[o003o
ool00?l00?ooo`00o`3jVP05ooooo`06o`3jV_ooooooo`00ooooool0nY[oo`007_ooool01_l0nY[o
o`00oooooooo003o0?ZJo`0001_ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00Ko0000
o`3jV_l0nY[oooooool00?l00?l2ooooo`03o`3jV_oo003ooooo00cooooo00Go0?ZJoooooooooooo
ooooo`3jVP02ooooo`06ool00?l0nY[ooooooooooooo003o0?ZJ6_ooool00ol0nY[oo`00o`3jVP02
ooooo`03o`3jV_oo003ooooo00gooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`00
0002o`000006ooooool0nY[o003oo`3jV_oo003ooooo0_l0nYX01_oo003o0?ZJo`3jV_l0nY[o003o
ool000Cooooo00Co0?ZJooooool00?ooo`000_ooool00ooo003oooooooooo`0Fooooo`0=o`3jV_oo
ooooooooooooool0nY[oo`00ooooool0nY[oooooo`3jV_oo003o0?ZJo`00000Gooooo`?o00001?oo
ool2o`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[oo`00o`00o`02ooooo`03o`3jV_oo
oooooooo00;o0?ZJ0ol000001Ooooooo0?ZJoooooooo003o0?ZJ00?ooooo00Coo`00o`3jV_oooooo
oooo0_l0nYX00ooo003o0?ZJooooo`02ooooo`05o`3jV_l0003o0000o`000?l0nYX01?ooool02?l0
nY[oo`00ooooool0nY[oooooool00?l00?oo0?ZJ1?ooool01Ooo003oooooo`3jV_oooooo0?ZJ00;o
oooo00?o0?ZJool00?ooool01Oooool01_l0nY[oooooooooool00?ooooooo`3jVP;ooooo00Co0?ZJ
ool00?oooooo0?ZJ0oooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003oo`0000;ooooo00?o
0?ZJooooool000000_l000001?l0nY[oooooool00?l0nYX3ooooo`03o`3jV_oo003o0?ZJ00?ooooo
00?o0?ZJool00?ooool01?ooool2o`3jVPGooooo00?o0?ZJooooool0nYX00oooool01_l0nY[o003o
ool00?oooooo0?ZJool000Cooooo00So0?ZJool00?oo003oooooo`3jV_oo003oooooo`3jVP;ooooo
00?o0000ooooooooool0>?ooool003?ooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00003ooooo`04o`000?ooooooooooo`3jVP;ooooo00Goo`00o`00oooooooo0?ZJool0000Boooo
o`08o`3jV_oooooo0?ZJool00?l0nY[oooooool00?l0nYXLooooo`05o`3jV_oo003oooooool00?l0
nYX04?ooool00ol0nY[oooooooooo`08ooooo`06o`3jV_ooooooo`00ool00?oooooo0?ZJ0_ooool0
1_l0nY[o003oool00?l00?ooo`00o`3jVPGooooo00Ko0?ZJoooooooo003oooooo`3jV_oo000Noooo
o`06o`3jV_oo003o0?ZJool00?l0nY[o00009oooool01_l0nY[oooooo`3jV_ooooooo`00o`00o`;o
oooo00?o0?ZJool00?ooool02oooool2o`3jVP?ooooo00Go0?ZJooooooooooooo`00o`3jVP02oooo
o`03ool00?l0nY[ooooo01Wooooo00?o0?ZJool00?l0nYX00_ooool00ol0nY[oo`00ooooo`0=oooo
o`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJool00?l000000_l000001_oooooo0?ZJo`00ool0
nY[oo`00ooooo`;o0?ZJ00Koo`00o`3jV_oooooo0?ZJo`00oooo0004ooooo`04o`3jV_oooooo003o
ool000;ooooo00?oo`00ooooooooool05_ooool01ol0nY[ooooooooooooooooo0?ZJool00?l0nYX0
0_ooool01?l0nY[oo`00o`3jV_l0000Tooooo`03o`000?oooooooooo00;ooooo00?o0?ZJool00?l0
0?l00_ooool00ol0nY[oooooooooo`02o`3jVP?o000000Goooooo`3jV_ooooooo`00o`3jVP02oooo
o`03o`3jV_oo003o0?ZJ00;ooooo0_l0nYX00ooo003o0?ZJooooo`02ooooo`06o`3jV_l0003o0000
o`000?l00?oo0?ZJ0oooool3o`000005o`3jV_ooooooo`00o`00ool0nYX00oooool01_l0nY[oo`00
o`3jV_l0nY[oooooo`3jVP;ooooo00?o0?ZJool00?l0nYX01?ooool01ol0nY[o003ooooooooooooo
003oooooool0nYX00_ooool00ol0nY[oo`00o`3jVP04ooooo`03ool00?l0nY[ooooo00?ooooo00Oo
0?ZJool00?oo003oo`00ooooool0nY[ooooo00?o000000Go0?ZJoooooooo003oooooo`3jVP02oooo
o`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?ooool00oooool3o`3jVPCooooo00Co0?ZJoooo
oooooooo0?ZJ0oooool01ol0nY[oo`00ool00?oooooo0?ZJool00?l0nYX00oooool00ol0nY[oo`00
o`3jVP02ooooo`03ool00?oooooo0?ZJ00;ooooo00?o0000ooooooooool0>?ooool002_ooooo1Ol0
0003ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool0nYX2ooooo`05ool00?l00?ooooooo`3jV_oo00004_ooool02?l0nY[oooooo`3jV_oo003o
0?ZJoooooooo003o0?ZJ7?ooool01Ooo003o0?ZJoooooooo003o0?ZJ013ooooo00?o0?ZJoooooooo
ool02?ooool01_l0nY[oo`00ool00?oo003oooooo`3jVP;ooooo00Ko0?ZJool00?ooooooooooool0
0?l0nYX5ooooo`06o`3jV_ooooooo`00ooooool0nY[oo`007Oooool01ol0nY[o003oool00?l0nY[o
ooooool00?l000009oooool01_l0nY[oooooo`3jV_ooooooo`00o`00o`;ooooo00?o0?ZJool00?oo
ool00oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ00Soooooo`3jV_l0nY[o0?ZJoooooooo003o
ooooo`3jVP;ooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo
003ooooo00gooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oo`00o`000002o`00000>o`3j
V_oooooo003oo`3jV_ooooooo`00o`3jV_oo003o003oo`3jV_oooooo0?ZJo`00oooo0004ooooo`04
o`3jV_oooooo003oool000;ooooo00?oo`00ooooooooool05_ooool01ol0nY[ooooooooooooooooo
0?ZJool00?l0nYX00_ooool01?l0nY[oo`00o`3jV_l0000Tooooo`03o`000?oooooooooo00;ooooo
00?o0?ZJool00?l00?l00_ooool01ol0nY[ooooooooooooooooo0?ZJo`00oooo00000oooool00ol0
nY[oo`00o`3jVP02ooooo`03o`3jV_oo003o0?ZJ00;ooooo0_l0nYX00ooo003o0?ZJooooo`02oooo
o`06ool00?l0003o0000o`000?l00?oo0?ZJ0oooool3o`000005ooooool0nY[oo`00o`00ool0nYX0
0oooool00ol0nY[oo`00o`3jVP02ooooo`06o`3jV_ooooooooooo`3jV_oo003o0?ZJ1?ooool01ol0
nY[o003ooooooooooooo003oooooool0nYX00_ooool00ol0nY[oo`00o`3jVP04ooooo`03o`3jV_oo
003ooooo00;ooooo00_o0?ZJool00?oo003o003oool00?oooooo0?ZJooooool00?ooo`00ooooo`02
o`3jVP03ool00?oooooo0?ZJ00;ooooo00?o0?ZJool00?l0nYX00oooool00ol0nY[oo`00ooooo`03
ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJo`00oooooooo0?ZJ0oooool01ol0nY[oo`00oooo
oooooooo0?ZJool00?l0nYX00oooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003o0?ZJ00;o
oooo00?o0000ooooooooool0>?ooool003?ooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00003ooooo`;o000000Woooooo`3jV_ooooooooooool00?l00?ooooooo`3jV_oo00004_oo
ool02?l0nY[oooooo`3jV_oo003o0?ZJoooooooo003o0?ZJ7?ooool01Ooo003o0?ZJoooooooo003o
0?ZJ00oooooo0_l0nYX:ooooo`06o`3jV_oo003ooooooooooooo003o0?ZJ0_ooool01_l0nY[oo`00
ooooooooooooo`00o`3jVPGooooo00?o0?ZJoooooooo00000_ooool00ooo003oooooooooo`0Koooo
o`03o`3jV_oo003ooooo00;o0?ZJ00?oo`00o`000?ooool09_ooool01_l0nY[o0000o`3jV_oooooo
o`00o`00o`;ooooo00?o0?ZJool00?ooool00oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ00So
ooooo`3jV_ooooooooooo`00oooo003oooooo`3jVP;ooooo00?o0?ZJool00?ooool04_ooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_ooooooo`0000?ooooo00?o0?ZJool00?ooool03?ooool01Ol0
nY[ooooooooooooooooo0?ZJ00Cooooo00?o0?ZJool00?l00?l00ol0nYX2ooooo`07o`3jV_oooooo
o`00o`3jV_oo003oooooo`3jVP02ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Go0?ZJoooooooooooo
003oool00002ooooo`03ool00?oooooooooo01Kooooo00Oo0?ZJooooooooooooooooo`3jV_oo003o
0?ZJ00;ooooo00Co0?ZJool00?l0nY[o00009?ooool2o`0000?ooooo00?o0?ZJool00?l00?l00_oo
ool01ol0nY[ooooooooooooooooo0?ZJo`00oooo00000oooool00ol0nY[oo`00o`3jVP02ooooo`03
o`3jV_oo003o0?ZJ00;ooooo0_l0nYX01_oo003o0?ZJoooooooooooo0?ZJool000?o0?ZJ00?oo`00
o`3jV_ooool00_ooool3o`000005ooooool0nY[oo`00o`00ool0nYX00oooool00ol0nY[oo`00o`3j
VP02ooooo`06o`3jV_ooooooooooo`3jV_oo003o0?ZJ0_ooool00ol0nY[oooooo`3jVP03ooooo`03
o`00oooooooo0?ZJ00;ooooo00?o0?ZJool00?l0nYX01?ooool00ol0nY[oo`00ooooo`02ooooo`?o
000000Oo003oool00?oooooo0?ZJooooool00?ooo`0000;ooooo00Co0?ZJool00?oooooo0?ZJ0_oo
ool00ol0nY[oo`00o`3jVP04ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooool0nYX01?oo
ool01?l0nY[o003oool00?oo0003ooooo`07o`3jV_oo003oooooooooool0nY[oo`00o`3jVP03oooo
o`03o`3jV_oo003o0?ZJ00;ooooo00Co0?ZJool00?l0nY[ooooo0_l0000jooooo`00<oooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0?ZJ0_oo
ool01Ooo003o003oooooool0nY[oo`0001;ooooo00Co0?ZJooooool0nY[oo`000_ooool00ooo003o
0?ZJooooo`0Jooooo`06o`3jV_oo003o0?ZJooooool0nY[oo`003oooool2o`3jVPWooooo00?o0?ZJ
o`00oooo00000_ooool02_oo003o0?ZJoooooooooooo0?ZJool00?oooooo0?ZJool00?l0nYX5oooo
o`?o00000_ooool00ooo003oooooooooo`0Kooooo`03o`3jV_oo003ooooo00;o0?ZJ00?oo`00o`00
0?ooool09_ooool2o`3jVP;ooooo00Koo`00o`00ooooooooooooo`3jV_oo0004ooooo`03o`3jV_oo
oooooooo00Gooooo0_l0nYX02?oooooo0?ZJoooooooooooo003oool00?oooooo0?ZJ0_ooool00ol0
nY[oo`00ooooo`0Aooooo`;o0?ZJ1Oooool01?l0nY[o0000o`000?l00002ooooo`03o`3jV_oo003o
oooo00[ooooo0ol0nYX3ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00o`00ooooool00_l0nYX3
ooooo`03o`3jV_ooooooo`0000;oo`000_l0nYX2ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Go0?ZJ
oooooooooooo003oool00002ooooo`03ool00?oooooooooo01Kooooo00?o0?ZJooooooooool00_oo
0002o`3jVP;ooooo00Co0?ZJool00?l0nY[o00009?ooool00ol0003oooooooooo`02ooooo`03o`3j
V_ooooooo`0000;ooooo00?o0?ZJooooooooool00_ooool00ol00?ooo`00ooooo`02ooooo`03o`3j
V_oo003o0?ZJ00;ooooo00?o0?ZJool00?ooool00_ooool3o`3jVP09ool00?ooooooooooo`3jV_oo
003o0?ZJooooool0nY[oo`0000;o0?ZJ00Coooooo`3jV_ooooooo`000_ooool01?l0nY[oo`00o`00
ool0nYX3ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX2oooo
o`03o`3jV_oooooo0?ZJ00?oo`0000?oooooo`00ool0nYX00_ooool00ol0nY[oo`00o`3jVP04oooo
o`03o`3jV_oo003ooooo00;ooooo0ol000001ol00?ooo`00ool00?l0nY[oooooo`00oooo00000_oo
ool01?l0nY[oo`00ooooool0nYX2ooooo`03ool00?l0nY[ooooo00Cooooo00?oo`00ooooooooool0
0_ooool00ol0nY[oooooo`3jVP02ooooo`04o`00ool0nY[oooooo`00o`;oo`000oooool01ol0nY[o
o`00oooooooooooo0?ZJool00?l0nYX00oooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003o
0?ZJ00;ooooo00?o0000ooooooooool0>?ooool003;ooooo0_l00004ooooo`04o`000?oooooooooo
o`0000?ooooo00_o0000oooooooooooo0?ZJoooooooo003oooooo`00oooooooo0?ZJool0000Boooo
o`04o`3jV_oooooo0?ZJool000;ooooo00?oo`00o`3jV_ooool06_ooool01_l0nY[oo`00o`3jV_oo
oooo0?ZJool000oooooo0_l0nYX9ooooo`0;o`3jV_oo003oo`00o`00ooooooooo`00o`3jV_oooooo
0?ZJo`00oooo00000_l0nYX00ol00?ooo`00ooooo`04ooooo`?o00000_ooool00ooo003ooooooooo
o`0Kooooo`07o`3jV_oo003o0?ZJooooool0nY[oo`00o`00000Wooooo`;o0?ZJ0_ooool01_oo003o
003ooooooooooooo0?ZJool000?ooooo00?o0?ZJooooool0nYX01_ooool3o`3jVP;ooooo0_l00?l0
0ooo003oooooo`3jVP02ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJooooooooool03?ooool2
o`3jVPCooooo0_l0nYX3o`0000;ooooo00?o0?ZJool00?ooool02_ooool00ol0nY[oooooooooo`03
ooooo`03ool00?oooooooooo00;ooooo00Coo`00o`00oooooooo0?ZJ1?ooool00ol0nY[oooooo`00
0002o`000007o`3jV_ooooooooooooooool0nY[oo`00o`3jVP02ooooo`05o`3jV_oooooo003ooooo
oooo00000_ooool00ooo003oooooooooo`0Fooooo`03o`3jV_oo003oo`0000?o00000oooool01?l0
nY[oo`00o`3jV_l0000Tooooo`03o`000?oooooooooo00;ooooo00?o0?ZJoooooooo00000_ooool0
0ol0nY[oooooooooo`02ooooo`03o`00oooo003ooooo00;ooooo00?o0?ZJool00?l0nYX00_ooool0
0ol0nY[oo`00ooooo`02ooooo`?o0?ZJ00ooo`00oooooooooooo0?ZJool00?l0nY[oooooo`3jV_oo
003oooooo`3jV_oooooo0?ZJo`00oooo00000_ooool01?l0nY[oo`00o`00ool0nYX3ooooo`03o`3j
V_oo003o0?ZJ00;ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX2ooooo`?o0?ZJ00Koo`00oooo
oooo003oo`00o`00ool0nYX2ooooo`03ool00?l0nY[ooooo00Cooooo00?o0?ZJool00?ooool00_oo
ool3o`000007o`3jV_ooooooo`00ooooool0nY[o003oool00002ooooo`04o`3jV_oo003oooooo`3j
VP;ooooo00?oo`00o`3jV_ooool01?ooool00ooo003oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ
00;ooooo00?o003oo`3jV_ooool00ooo0002ooooo`03o`3jV_l00?ooo`0000;ooooo00?o0?ZJool0
0?l0nYX00oooool00ooo003oooooo`3jVP02ooooo`06o`3jV_oo003o0?ZJooooool0nY[o0000>_oo
ool003?ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00Oo0000oooooooooooo0?ZJoooo
oooo003o003o00?ooooo00?oo`00ooooooooool04?ooool01?l0nY[oooooool00?oo0002ooooo`03
ool00?l0nY[ooooo01[ooooo00Ko0?ZJool00?l0nY[oooooo`3jV_oo000?ooooo`;o0?ZJ1oooool0
3Ol0nY[oooooo`3jV_oo003oooooo`00ooooooooo`00o`3jV_oooooo0?ZJo`00oooo00000_l0nYX0
0ol00?ooo`00ooooo`03ooooo`04o`3jV_l0003o0000o`0000;ooooo00?oo`00ooooooooool06ooo
ool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX09oooool2o`3jVP04oooooooo003oooooo`00
o`;ooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooo`3jVP06ooooo`06o`3jV_oooooo0?ZJ
o`00oooooooo003o0_oo00001_oooooo0?ZJoooooooooooo0?ZJool000?ooooo00?o0?ZJoooooooo
ool03?ooool2o`3jVPCooooo00?o0?ZJooooool000000_l00002ooooo`03o`3jV_oo003ooooo00[o
oooo00?o0?ZJooooooooool00oooool00ooo003oooooooooo`02ooooo`04ool00?l00?ooooooo`3j
VPCooooo00?o003oo`3jV_l000000_l000002Ol0nY[ooooooooooooooooo0?ZJool00?l0nY[ooooo
o`3jVP02ooooo`03o`00oooo003o0?ZJ00;ooooo00?oo`00ooooooooool05_ooool00ol0nY[oo`00
o`00o`03o`0000?ooooo00Co0?ZJool00?l0nY[o00009?ooool2o`0000?ooooo00Ko0?ZJoooooooo
003o003oooooool0nYX4ooooo`03ool00?l0nY[ooooo00;ooooo00?o0?ZJool00?l0nYX00_ooool0
0ol0nY[oo`00ooooo`02ooooo`?o0?ZJ00ooo`00oooooooooooo0?ZJool00?l0nY[oooooo`3jV_oo
003oooooo`3jV_oooooo0?ZJo`00oooo00000_ooool01?l0nY[oooooool00?l0nYX3ooooo`03ool0
0?l0nY[ooooo00;ooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX2ooooo`;o0?ZJ00Ooo`00oooo
ooooooooooooool00?l00?oo0?ZJ00;ooooo00?oo`00o`3jV_ooool01?ooool00ol0nY[oo`00oooo
o`02ooooo`07o`3jV_oo003oooooo`3jV_ooooooo`00ooooo`02o`3jVP07ool00?ooooooooooo`3j
V_oo003oooooo`3jVP02ooooo`03ool00?l0nY[ooooo00Cooooo00?oo`00o`3jV_ooool00_ooool0
2ol0nY[o003oo`3jV_oooooo003oooooool0nY[oooooool00?l00?ooo`0000;ooooo00?o0?ZJool0
0?ooool00ol0nYX00ooo003o0?ZJooooo`02ooooo`03ool00?oooooo0?ZJ00;ooooo00Ko0?ZJool0
0?l0nY[oooooo`3jV_l0000jooooo`00?oooool2o`000005ooooool0nY[oooooool00?l00?l00ooo
ool00ooo003oooooooooo`0@ooooo`04o`3jV_ooooooo`00ool000;ooooo00?o0?ZJool00?ooool0
6_ooool01ol0nY[oo`00o`3jV_oooooo0?ZJool00?l0nYX03_ooool2o`3jVPOooooo00Go0?ZJoooo
ool0nY[oo`00ooooo`02o`3jVP06oooooooo003oooooo`3jV_oo003ooooo0_l0nYX00ol00?ooo`00
ooooo`03ooooo`04o`3jV_oooooo003oool000;ooooo00?oo`00ooooooooool06Oooool02Ol0nY[o
ooooo`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP0Wooooo`;o0?ZJ00?oooooool00?l00?l00ooo
ool00ol0nY[oo`00ooooo`02ooooo`03o`3jV_oooooo0?ZJ00Kooooo00?o0?ZJooooool0nYX00_oo
00001Ol00?ooo`00oooooooooooo0?ZJ00;ooooo00Co0?ZJool00?l0nY[ooooo0_l0nYX>ooooo`;o
0?ZJ0oooool2o`3jVP;o003o00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00[ooooo00?o0?ZJ
ooooooooool00_ooool2ool000Cooooo00Coo`00o`00oooooooo0?ZJ1Oooool01?l0nY[o0000o`00
0?l00004ooooo`05o`3jV_oo003o0?ZJooooool0nYX00_ooool00ol00?ooo`00o`3jVP02ooooo`03
ool00?oooooooooo01Kooooo00?oo`00o`00ool00?l00ol00003ooooo`04o`3jV_oo003o0?ZJo`00
02Cooooo00?o0000ooooooooool00_ooool01_l0nY[oooooool00?l00?ooooooo`3jVPCooooo00?o
o`00o`3jV_ooool00_ooool00ol0nY[oo`00o`3jVP02ooooo`03ool00?l0nY[ooooo00?ooooo0_l0
nYX01_oo003oooooooooool0nY[oo`00o`3jVP;ooooo00Ooo`00o`00ool0nY[oooooo`3jV_oo003o
0?ZJ00?ooooo00?o0?ZJool00?l0nYX00oooool00ooo003o0?ZJooooo`02ooooo`06o`3jV_oooooo
ooooo`3jV_oo003o0?ZJ0_ooool2o`3jVP04ool00?ooooooooooooooo`;oo`0000Go0?ZJooooool0
nY[oo`00o`3jVP05ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJool00?ooool00_l0nYX01Ooo
003oooooo`3jV_l0nY[oo`0000;ooooo00Co0?ZJo`00oooo003o0?ZJ0_ooool00ooo003o0?ZJoooo
o`04ooooo`05ool00?l0nY[oooooooooool0nYX00_l00?l2o`3jVP07o`00ool0nY[ooooooooooooo
003o003oool00002ooooo`03o`3jV_oo003ooooo00Co0?ZJ00Goo`00oooooooooooo0?ZJool00002
o`3jVP;ooooo00Co0?ZJool00?l0nY[ooooo0_l0nYXjooooo`00?oooool01ol0003oooooooooool0
nY[oooooool00?l00?l00oooool00ooo003oooooooooo`0?ooooo`03o`3jV_oooooo000000;o0000
0_ooool00ol0nY[oo`00o`3jVP0Jooooo`07o`3jV_oo003oooooooooool0nY[oo`00o`3jVP0=oooo
o`?o0?ZJ1oooool2o`3jVP03o`00oooo003ooooo00;o0?ZJ00[oooooool00?oooooo0?ZJool00?oo
oooo0?ZJooooool0nY[oo`001?ooool01?l0nY[oooooo`00oooo0002ooooo`03ool00?oooooooooo
01Sooooo0ol0nYX2ool00005o`3jV_oooooo0?ZJool00?l0nYX09oooool2o`3jVP03oooooooo003o
003o00?ooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooo`3jVP06ooooo`03o`3jV_oooooo
o`0000?oo`000oooool01ol0nY[oooooooooool0nY[oo`00o`3jV_ooool00_l0nYX>ooooo`;o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ0_l00?l00oooooooo`00ooooo`02ooooo`03o`3jV_oo003o0?ZJ00[o
oooo00?o0?ZJooooooooool00_ooool2ool000?ooooo00Go0?ZJool00?ooooooooooo`3jVP05oooo
o`03o`3jV_l00?oo0?ZJ00Gooooo00?o0?ZJool00?l0nYX00_l0nYX01Ooooooo003oool00?oo003o
0?ZJ00;ooooo00?oo`00o`3jV_ooool05_ooool01Ooo003o003oo`00ool00?oo0?ZJ00Cooooo00Co
0?ZJool00?l0nY[o00009?ooool00ol0003oooooooooo`02ooooo`06o`3jV_ooooooo`00o`00oooo
oooo0?ZJ1?ooool00ooo003o0?ZJooooo`02ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00o`3j
V_ooool00oooool00ol0nY[oooooool00002ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool0
0?ooool00_l0nYX00ooo003o0?ZJooooo`02ooooo`08o`3jV_oo003o0?ZJooooool0nY[oooooool0
0?l0nYX6ooooo`04o`3jV_oo003o0?ZJooooo`?o0?ZJ00?oo`00ooooooooool00_ooool01_oo003o
0?ZJooooool0nY[oo`00o`3jVPGooooo00?o0?ZJool00?ooool00_ooool01ol0nY[oo`00oooooooo
oooo0?ZJool00?ooool00_l0nYX02ooo003oooooooooool0nY[o003oool00?l0nY[oooooo`3jV_oo
003o0?ZJ00Gooooo00Koo`00o`3jV_ooooooooooo`3jV_l00?l3o`0000;o0?ZJ00Goooooool00?oo
003o003oool00002ooooo`05o`3jV_oo003o0?ZJo`3jV_ooool00_l0nYX01_oo003oooooooooool0
nY[oo`00o`3jVP?ooooo00?o0?ZJool00?l0nYX00ol0000jooooo`00?oooool01ol0003ooooooooo
ool0nY[oooooool00?l00?l00oooool00ooo003oooooooooo`0?ooooo`03o`3jV_oooooo000000;o
00000_ooool00ol0nY[oo`00o`3jVP0Jooooo`07ool00?l0nY[oooooooooool0nY[oo`00o`3jVP0=
ooooo`03o`3jV_oooooo0?ZJ00Kooooo0ol0nYX03Ooo003oooooo`3jV_l00?oo0?ZJoooooooo003o
0?ZJo`00oooo003oooooo`3jV_ooool00ol00003ooooo`04o`3jV_oooooo003oool000;ooooo00?o
o`00o`3jV_ooool06?ooool3o`3jVP07ool00?oooooo0?ZJooooool0nY[oo`00o`3jVP0Wooooo`;o
0?ZJ0_oo00001_l00?oooooooooooooooooo0?ZJool000?ooooo00?o0?ZJooooool0nYX01_ooool0
1Ol0nY[oooooool00?oooooo003o00Cooooo00Go0?ZJoooooooooooo0?ZJool00004o`3jVPKooooo
0_l0nYX6ooooo`;o0?ZJ00Goooooo`3jV_l00?ooooooo`00o`02ooooo`07ool00?oooooooooooooo
ool0nY[oo`00o`3jVP09ooooo`03o`3jV_oo003oo`0000?oo`0000?oooooool00?ooool00_ooool0
0ol0nY[oo`00o`3jVP02o`3jVPGooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[oo`00o`3jV_l0
nYX2ooooo`04o`00oooo003oooooo`3jVP;ooooo00?oo`00o`3jV_ooool05_ooool01Ooo003ooooo
ooooool00?oo0?ZJ00Cooooo00Co0?ZJo`00oooo003o0?ZJ9?ooool2o`0000?ooooo00Ko0?ZJoooo
oooo003o003oooooool0nYX4ooooo`03ool00?l0nY[ooooo00;ooooo00?o0?ZJool00?l0nYX00_oo
ool00ooo003o0?ZJooooo`03ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJool00?ooool00_oo
ool01ol0nY[oo`00ooooool0nY[oooooool00?l0nYX00oooool00ol0nY[oo`00o`3jVP02o`3jVP03
oooooooo003o0?ZJ00Kooooo00Co0?ZJool00?l0nY[ooooo0_l0nYX00ooo003oooooooooo`03oooo
o`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ1Oooool01Ol0nY[oo`00o`3jV_oooooo0?ZJ00;oo`00
0_ooool00ol0nY[oo`00ooooo`02o`3jVP06ool00?ooooooooooo`3jV_ooooooo`000ol0nYX00ooo
003oooooooooo`04ooooo`06ool00?l0nY[oooooooooool0nY[o003o0ol000001ol00?oooooooooo
oooo003oooooo`00oooo00000_ooool00ol0nY[oo`00o`3jVP02ooooo`;o0?ZJ00Koo`00oooooooo
oooo0?ZJool00?l0nYX3ooooo`03o`3jV_oo003o0?ZJ00?o0000>_ooool003oooooo0_l000001Ooo
oooo0?ZJoooooooo003o003o00?ooooo00?oo`00ooooooooool03oooool00ol0nY[oooooo`000002
o`0000;ooooo00?o0?ZJool00?l0nYX06_ooool01ooo003o0?ZJoooooooooooo0?ZJool00?l0nYX0
3Oooool00ol0nY[oooooo`3jVP06ooooo`?o0?ZJ00Coo`00ooooool0nY[ooooo0_l0nYX01Ooo003o
0?ZJo`00oooo003o0?ZJ00;ooooo0ol00003ooooo`04o`3jV_oooooo003oool000;ooooo00?oo`00
o`3jV_ooool06?ooool3o`3jVP07ool00?oooooo0?ZJooooool0nY[oo`00o`3jVP0Qooooo`;o0000
1?ooool01?l0nY[o003oool00?l00?l4ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJooooool0
nYX01_ooool00ol0nY[oooooool00006ooooo`05o`3jV_ooooooooooo`3jV_oo00000_l0nYX00ooo
oooo0?ZJooooo`04ooooo`03o`3jV_oooooo0?ZJ00Kooooo0ol0nYX4o`00o`;ooooo00Ooo`00oooo
ooooooooooooo`3jV_oo003o0?ZJ00Wooooo00?o0?ZJool00?ooool00_oo0002ooooo`09ool00?oo
ooooooooooooool0nY[oo`00o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJooooool0nYX01Oooool01?l0
nY[o0000o`000?l00002o`00o`04ool00?l00?ooooooo`3jVP;ooooo00?oo`00o`3jV_ooool05_oo
ool01Ooo003ooooooooooooooooo0?ZJ00Cooooo00Co0?ZJoooooooo003o0?ZJ5oooool3o`0000Co
oooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00Ko0?ZJoooooooo003o003oooooool0nYX2
ool00004ooooool00?ooo`00o`3jVP?ooooo00?o0?ZJool00?l0nYX00_ooool00ooo003o0?ZJoooo
o`03ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_ooool00_ooool00ol0nY[oo`00oooo
o`02ooooo`03ool00?l0nY[ooooo00;ooooo00?o0?ZJool00?l0nYX00ol0nYX00ooo003o0?ZJoooo
o`05ooooo`04o`3jV_oo003o0?ZJooooo`;o0?ZJ00Coo`00o`3jV_l0nY[o0?ZJ0_ooool01_oo003o
0?ZJooooool0nY[oo`00o`3jVPGooooo00Oo0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ00;ooooo
00Ko0?ZJool00?oooooo003ooooooooo0002ooooo`03o`3jV_ooooooo`0000?o0?ZJ00?oo`00oooo
ooooool01?ooool01_oo003o0?ZJoooooooooooo0?ZJool000?o00000oooool01_oo003ooooooooo
oooo003oooooo`3jVP;oo`0000Ko0?ZJooooooooooooooooo`3jV_oo0002ooooo`03o`3jV_oo003o
0?ZJ00?ooooo00?o0?ZJool00?l0nYX00ol0000jooooo`00?oooool00ol0003oooooo`3jVP02oooo
o`03ool00?l00?oooooo00;ooooo00?oo`00ooooooooool03oooool01?l0nY[oooooool00?l0nYX3
ooooo`03o`3jV_oo003o0?ZJ01Wooooo00?o0?ZJool00?l0nYX00_ooool00ol0nY[oo`00o`3jVP0=
ooooo`03o`3jV_oooooo0?ZJ00Kooooo0ol0nYX02ooo003o0?ZJo`3jV_oooooo003oo`3jV_oo003o
0?ZJool00?oooooo0?ZJ00;ooooo0ol00002ooooo`05o`3jV_ooooooooooool00?l0nYX00_ooool0
0ooo003o0?ZJooooo`0Hooooo`?o0?ZJ00Ooo`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ023ooooo
00Co0000oooooooooooo00000oooool2o`000003ool00?oooooooooo00?ooooo00?o0?ZJool00?oo
ool00_ooool00ol0nY[oooooo`3jVP06ooooo`04o`3jV_ooooooo`00o`3jVPGooooo00Go0?ZJoooo
oooooooo0?ZJool00003ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool0nYX01_ooool3
o`3jVP?o003o0oooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX02Oooool00ol0nY[oo`00
o`00o`04ooooo`07ool00?ooooooooooooooool0nY[oo`00o`3jVP07ooooo`03o`3jV_oooooo0?ZJ
00Gooooo00Co0?ZJo`000?l0003o00000ooo0002ooooo`05o`3jV_ooooooooooool00?l0nYX03ooo
ool3o`3jVPCooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
003o0?ZJ01Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool00_ooool01_l0nY[oooooool00?l00?ooooooo`3jVP?oo`0000?o003o
ool00?l0nYX00oooool01ol0nY[oo`00o`3jV_l0nY[oooooool00?l0nYX01?ooool00ol0nY[ooooo
ool00002ooooo`03ool00?l0nY[ooooo00;ooooo00Oo0?ZJool00?ooooooooooo`00oooo003o0?ZJ
00?ooooo00?o0?ZJool00?l0nYX00ol0nYX00ooo003oooooooooo`06ooooo`03ool00?l0nY[ooooo
00?o000000?o0?ZJooooool0nYX00_ooool2ool00003ooooool0nY[oo`0000Kooooo00Oo0?ZJool0
0?l0nY[oooooo`3jV_oo003o0?ZJ00;ooooo00Ko0?ZJoooooooo003o003ooooooooo0003ooooo`06
o`3jV_oo003o0?ZJo`3jV_oo003o0?ZJ1_ooool02Ol0nY[oo`00oooooooooooo0?ZJool00?oooooo
0?ZJool00002ooooo`0:ool00?oooooooooooooooooo003oooooo`3jV_oo003oooooo`3jVP?ooooo
00Ko0?ZJool00?ooooooooooo`3jV_oo0004ooooo`06o`3jV_oo003o0?ZJooooool0nY[oo`00>_oo
ool003oooooo00?o0000ooooool0nYX00_ooool00ooo003o003oooooo`02ooooo`03ool00?oooooo
oooo00oooooo00Co0?ZJoooooooo003o0?ZJ0oooool00ol0nY[oo`00o`3jVP0Hooooo`;o0?ZJ00Oo
o`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ00gooooo00?o0?ZJooooool0nYX01_ooool2o`3jVP03
ool00?oooooo0?ZJ00;ooooo00Oo003oo`3jV_oo003oooooool00?oooooo0?ZJ00;ooooo00?o0?ZJ
ool00?l0nYX00_ooool01Ol0nY[oooooo`00oooo003o0?ZJ00;ooooo00?oo`00o`3jV_ooool05ooo
ool01_l0nY[oooooo`3jV_l00?ooo`00o`3jVP;ooooo00?o0?ZJo`000?l000008?ooool01?l0003o
ooooooooool00003ooooo`;o00001_ooool00ol0nY[oo`00ooooo`02ooooo`03o`3jV_oooooo0?ZJ
00Kooooo00?o0?ZJoooooooo00000_l0nYX4ooooo`05o`3jV_oooooooooooooooooo00000oooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00Gooooo00Co0?ZJooooool0nY[o0?ZJ0_l0
0?l4ooooo`07ool00?ooooooooooooooool0nY[oo`00o`3jVP09ooooo`03o`3jV_oo003o003o00Co
oooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00Oooooo00?o0?ZJooooool0nYX01Oooool0
1Ol0nY[o0000o`000?l0003oo`0000Cooooo00Go0?ZJooooooooooooo`00o`3jVP0>ooooo`03o`3j
V_oooooooooo00;o0?ZJ0oooool01_l0nY[oo`00o`3jV_l0nY[oooooo`3jVPGooooo00?o0?ZJo`00
0?l000006_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooooooo`;o00000ooo
ool03?l0nY[oooooool00?l00?ooooooo`3jV_oo003oooooool00?l00?ooo`00o`3jVP?ooooo00Ko
0?ZJool00?l0nY[o0?ZJoooooooo0005ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_oo
ool00_ooool01ol0nY[oo`00oooooooooooo003oool00?l0nYX00oooool00ol0nY[oo`00o`00o`03
o`3jVP03ool00?oooooooooo00Kooooo00?oo`00o`3jV_ooool00ol000002_l0nY[oooooooooool0
nY[oooooo`00oooo003oooooool00?l0nYX7ooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ0_oo
ool01_l0nY[oooooool00?l00?ooooooool000?ooooo00Ko0?ZJool00?l0nY[o0?ZJool00?l0nYX6
ooooo`08o`3jV_oo003oooooooooool0nY[oo`00ooooool0nYX2ool00004oooooooo003ooooooooo
o`?o000000?o0?ZJool00?l0nYX01?ooool01_l0nY[oo`00oooooooooooo0?ZJool000Cooooo00Ko
0?ZJool00?l0nY[oooooo`3jV_oo000jooooo`00?oooool00ol0003oooooo`3jVP02ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00ooooooooool03_ooool01Ol0nY[ooooooooooooo003o0?ZJ00Co
oooo00?oo`00o`3jV_l0nYX05oooool3o`000006o`3jV_ooooooooooo`3jV_oo003o0?ZJ3?ooool0
1?l0nY[oooooooooool0nYX6ooooo`;o0?ZJ00?oo`00ooooool0nYX00_ooool00ol00?oo0?ZJool0
0002ool00008ooooool0nY[oooooooooool0nY[oo`00o`3jV_ooool2o`3jVP04ooooool00?ooo`00
o`3jVP;ooooo00?oo`00o`3jV_ooool05oooool01_l0nY[oooooo`3jV_oo003oooooo`3jVP?ooooo
0_l0000Pooooo`04o`000?ooooooooooo`0000?ooooo0_l00006ooooo`03o`3jV_oo003ooooo00;o
oooo00Co0?ZJo`00ool00?oo0?ZJ1Oooool01Ol0nY[oooooool00?oooooo0?ZJ00Cooooo00Go0?ZJ
ooooooooooooooooool00003ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ
1Oooool01Ol0nY[oooooo`3jV_l0nY[o003o00Gooooo00Ooo`00ooooooooooooooooo`3jV_oo003o
0?ZJ00Wooooo00?oo`00ooooool00?l01?ooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX0
1oooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_oooooo0?ZJo`00o`Gooooo00Go0?ZJoooooooo
ooooo`00o`3jVP0>ooooo`05o`3jV_ooooooooooooooool0nYX00oooool00ol0nY[oo`00o`3jVP03
o`3jVPGooooo00?o0?ZJo`000?l000006?ooool2o`0000?ooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`02ooooo`06o`3jV_ooooooo`00o`00ooooooooo`000_ooool3ool00006
o`3jV_ooooooooooooooool0nY[oo`000ol0nYX00ooo003oooooooooo`03ooooo`03o`3jV_oooooo
o`0000;ooooo00?oo`00o`3jV_ooool00_ooool01ol0nY[oo`00ool00?ooooooo`00ooooool0nYX0
0oooool00ol0nY[oo`00o`00o`03o`3jVP03ool00?oooooooooo00Kooooo00?oo`00o`3jV_ooool0
0ol00003ooooo`07o`3jV_oooooo003oool00?ooooooo`00o`3jVP07ooooo`06ool00?l0nY[ooooo
o`3jV_oo003o0?ZJ0_ooool00ol0nY[o003oool00002ooooo`0:ool00?ooooooooooooooool0nY[o
o`00ooooool0nY[oo`00o`3jVPKooooo00Oo0?ZJool00?ooooooooooo`3jV_oo003ooooo00;o0?ZJ
0ooo0002ooooo`?o000000?o0?ZJool00?l0nYX01Oooool01Ooo003ooooooooooooo003o0?ZJ00Co
oooo00Ko0?ZJool00?l0nY[oooooo`3jV_oo000jooooo`00?oooool2o`000004o`3jV_oooooooooo
ool000Cooooo00?oo`00ooooooooool03_ooool01Ol0nY[ooooooooooooo003o0?ZJ00Cooooo00Co
o`00ooooool0nY[o0?ZJ5_ooool3o`0000?ooooo00?o0?ZJool00?l0nYX03?ooool01?l0nY[ooooo
ooooool0nYX6ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX00oooool3o`000003o`00ool0nY[ooooo00;o
oooo00?o0?ZJool00?l0nYX00_l0nYX2ooooo`03o`00oooo003o0?ZJ00;ooooo00?oo`00o`3jV_oo
ool05oooool01?l0nY[o0000o`000?l00002o`3jVP?ooooo0_l0000Pooooo`04o`000?oooooooooo
o`0000?ooooo0_l0nYX6ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJo`00ool00?l00_l0nYX4
ooooo`04o`3jV_ooooooo`00ooooo`;o0?ZJ0oooool01Ol0nY[oooooooooooooooooo`0000?ooooo
00?o0?ZJooooooooool00_ooool01?l0nY[oooooooooool0nYX5ooooo`03o`3jV_oooooo0?ZJ00?o
o`001?ooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX02Oooool00ooo003o0?ZJo`3jVP04
ooooo`07ool00?ooooooooooooooool0nY[oo`00o`3jVP08ooooo`;o0?ZJ1Oooool00ol0nY[ooooo
o`3jVP06ooooo`05o`3jV_ooooooooooool00?l0nYX02?ooool3o`3jVP;ooooo0_l0nYX4ooooo`07
o`3jV_ooooooooooo`3jV_oo003o0?ZJooooo`02o`3jVPGooooo00?o0?ZJo`000?l000006_ooool0
1?l0003oooooooooool00002ooooo`05o`000?ooooooooooooooool000001?ooool01_l0nY[ooooo
ool00?l00?ooooooool000?ooooo00?o003oooooool0nYX00oooool00ol0nY[oo`00o`00o`02o`3j
VP03ool00?oooooooooo00?ooooo00?o0?ZJoooooooo00000_ooool00ooo003o0?ZJooooo`02oooo
o`07o`3jV_ooooooo`00o`00oooo003oooooo`3jVP03ooooo`07o`3jV_oo003o003oooooool0nY[o
o`00o`3jVP08ooooo`05ool00?l0nY[oooooo`3jV_oo00001?ooool01ol0nY[oooooo`00oooo003o
ooooool00?l0nYX01oooool01_oo003o0?ZJooooool0nY[oo`00o`3jVP?ooooo00Go0?ZJool00?oo
ooooooooool00003ooooo`05o`3jV_oo003ooooooooooooo00001oooool01Ol0nY[oo`00oooooooo
ooooo`0000;ooooo0_l0nYX4ooooo`07o`3jV_l0003o0000o`000?l00?ooo`00o`3jVP05ooooo`05
ool00?ooooooooooool00?l0nYX01?ooool01_l0nY[o003oool00?l0nY[oo`00o`3jVS[ooooo000o
ooooo`06o`000?oooooo0?ZJoooooooo003o003o1?ooool00ooo003oooooooooo`0>ooooo`05o`3j
V_ooooooo`00ool00?l0nYX01?ooool01?oo003oooooo`3jV_l0nYXEooooo`04o`3jV_l0003o0000
o`0000?ooooo00?o0?ZJool00?l0nYX03?ooool01?l0nY[oooooooooool0nYX5ooooo`05o`3jV_oo
oooo0?ZJool00?l0nYX01?ooool3o`000003o`00ool0nY[ooooo00;ooooo0_l0nYX00ooo003ooooo
ooooo`02ooooo`03o`00oooo003o0?ZJ00;ooooo00?o0?ZJool00?ooool05oooool01Ol0nY[o0000
o`000?l0003o0?ZJ00Cooooo0_l0nYXPooooo`04o`000?ooooooooooo`0000?ooooo0_l0nYX6oooo
o`03o`3jV_oo003ooooo00;ooooo00?o0?ZJo`00ool000000_l000001Ol0nY[ooooooooooooooooo
0?ZJ00;oo`000_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Goo`00oooooooooooooooo
o`3jVP04ooooo`04o`3jV_ooooooooooo`3jVPGooooo00Go0?ZJooooool0nY[oo`00ooooo`02ool0
00?ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00Wooooo00Coo`00o`3jV_l0nY[o0?ZJ
0oooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX02?ooool2o`3jVPGooooo00?o0?ZJoooo
ool0nYX01_ooool01Ol0nY[ooooooooooooo003o0?ZJ00Oooooo0_l0nYX01Ooooooo0?ZJo`3jV_oo
oooo0?ZJ00Gooooo00Ko0?ZJoooooooooooo0?ZJool00?l0nYX8ooooo`03o`3jV_oooooo0?ZJ01Ko
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool00_ooool01_l0nY[oooooool00?l00?ooooooool000?ooooo00?o003oooooool0nYX0
0oooool00ol0nY[oooooool00002o`3jVP03ool00?oooooooooo00?ooooo00?o0?ZJoooooooo0000
0_l0nYX00ooo003o0?ZJooooo`03ooooo`06o`3jV_oo003o003oool00?oooooo0?ZJ0oooool01ol0
nY[oo`00o`00oooooooo0?ZJool00?l0nYX02?ooool01Ooo003o0?ZJooooool0nY[oo`0000Cooooo
00Oo0?ZJooooool00?ooo`00oooooooo003o0?ZJ00Oooooo00Koo`00o`3jV_oooooo0?ZJool00?l0
nYX3ooooo`05o`3jV_oo003ooooooooooooo00000oooool01Ol0nY[oo`00ooooooooooooo`0000So
oooo00Coo`00ooooooooooooo`000_ooool2o`3jVPCooooo00?o0?ZJoooooooo00000_l00?l00ooo
003o0?ZJooooo`04ooooo`05ool00?ooooooooooool00?l0nYX01Oooool01Ol0nY[oo`00o`3jV_oo
003o0?ZJ03[ooooo000oooooo`06o`000?oooooo0?ZJoooooooo003o003o1?ooool00ooo003ooooo
ooooo`0>ooooo`05o`3jV_ooooooo`00o`00ool0nYX01?ooool01?l0nY[oo`00ooooool0nYXEoooo
o`04o`3jV_l00?ooo`00o`3jVPCooooo00?oo`00o`3jV_ooool02_ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Gooooo00Co0?ZJo`000?l0003o00001Oooool3o`0000;o0?ZJ0oooool2o`3jVP04ool0
0?l00?ooooooooooo`;o003o00Koo`00o`3jV_ooooooooooo`3jV_oo000Hooooo`05o`3jV_l0003o
0000o`000?l0nYX01?ooool2o`3jVR7ooooo0_l00004ooooo`;o0?ZJ1_ooool00ol0nY[oo`00oooo
o`02ooooo`03o`3jV_oooooo000000;o00000_l0nYX2ooooo`03o`3jV_oo003oo`0000;ooooo00Go
0?ZJooooooooooooooooo`3jVP03ooooo`05o`3jV_oo003oooooooooool0nYX01?ooool01?l0nY[o
ooooooooool0nYX5ooooo`04o`3jV_ooooooo`00ool000;ooooo0_oo0002ooooo`06ool00?oooooo
ooooooooool0nY[oo`000_l0nYX7ooooo`06o`3jV_oo003oooooooooool0nY[o003o0_ooool01_oo
003ooooooooooooooooo0?ZJool000Wooooo0_l0nYX5ooooo`04o`3jV_oooooo0?ZJo`3jVPGooooo
00Go0?ZJooooooooooooo`00o`3jVP07ooooo`08o`3jV_ooooooooooooooool0nY[oooooo`3jV_l0
0?l4ooooo`05o`3jV_ooooooooooo`3jV_oo00002Oooool00ol0nY[o0000o`3jVP0Gooooo`?o0000
1?ooool2o`0000Cooooo0_l00003ooooo`06o`3jV_ooooooo`00o`00ooooooooo`000oooool00ol0
0?ooooooo`3jVP03ooooo`03o`3jV_ooooooo`0000;o0?ZJ00?oo`00ooooooooool00oooool00ol0
nY[oooooool00002o`3jVP03ool00?oooooooooo00?ooooo00Go0?ZJool00?l00?ooo`00o`3jVP04
ooooo`07o`3jV_ooooooo`00o`00ool0nY[oo`00o`3jVP08ooooo`05ool00?l0nY[oooooool00?l0
nYX01Oooool01_l0nY[o003oool00?ooooooo`00o`3jVPOooooo00Coo`00o`3jV_ooooooo`000_l0
nYX3ooooo`05o`3jV_oo003oooooool00?l0nYX00oooool00ol0nY[oo`00ooooo`03o`0000Oooooo
00Coo`00ooooool0nY[oo`000_ooool3o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJ0_oo00000ol0
nY[oooooooooo`04ooooo`05ool00?l0nY[o0?ZJool00?l0nYX01Oooool01Ol0nY[oo`00o`3jV_oo
003o0?ZJ03[ooooo000oooooo`06o`000?l0nY[ooooooooooooo003o003o1?ooool00ooo003ooooo
ooooo`0=ooooo`06o`3jV_ooooooooooool00?l00?oo0?ZJ1?ooool01?l0nY[oo`00ooooool0nYXD
ooooo`;o0?ZJ00?o003oool00?ooool01?ooool00ooo003o0?ZJooooo`0:ooooo`05o`3jV_oooooo
oooooooooooo00001Oooool01?l0nY[o0000o`000?l00006ooooo`?o0?ZJ1Oooool00ol0nY[oo`00
o`00o`02ooooo`04o`00ooooooooo`00o`3jVP;ooooo00?o0?ZJool00?ooool05oooool01?l0nY[o
o`00ool00?l0nYX5ooooo`;o0?ZJ9oooool2o`3jVPKooooo00Oo0?ZJool00?ooooooooooo`3jV_l0
0?oooooo00?o000000Goooooo`3jV_ooooooooooo`3jVP02ool000?ooooo00Co0?ZJoooooooooooo
0?ZJ0oooool01Ol0nY[oo`00oooooooo003o0?ZJ00Cooooo00?o0?ZJooooool00?l00_l0nYX4oooo
o`04o`3jV_ooooooo`00ool000?ooooo00Coo`00ooooooooooooo`000oooool01?l0nY[oo`00o`00
ool0nYX7ooooo`04o`3jV_oo003oooooooooo`;o0?ZJ00?o003ooooooooo00000oooool00ol0nY[o
o`00ooooo`08ooooo`;o0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo00Go0?ZJoooooooo
ooooo`00o`3jVP07ooooo`07o`3jV_ooooooooooooooool0nY[oooooo`3jVP02ool000;o003o00Ko
ooooo`3jV_ooooooooooo`3jV_oo0009ooooo`03o`3jV_oooooo0?ZJ02Cooooo00?o0000oooooooo
ool00_ooool01_l0nY[oooooool00?l00?ooooooool000?ooooo00?o003oooooool0nYX00oooool0
0ol0nY[oooooool00002o`3jVP03ool00?oooooooooo00?ooooo00?o0?ZJoooooooo00000_l0nYX0
0ooo003oooooooooo`03ooooo`05o`3jV_oo003oo`00ooooool0nYX01?ooool01ol0nY[oooooool0
0?l00?oo0?ZJool00?l0nYX02?ooool01Ooo003o0?ZJoooooooo003o0?ZJ00Gooooo00Go0?ZJo`00
oooo003oooooool00008ooooo`05ool00?l0nY[oooooool00?l0nYX01?ooool01Ol0nY[oooooool0
0?oo003o0?ZJ00?ooooo00?o0?ZJo`00oooo00000ol00007ooooo`04ool00?oooooo0?ZJool000;o
oooo00?o0?ZJooooool0nYX00_ooool01?l0nY[oooooooooool0nYX2ool00003o`3jV_oooooooooo
00Cooooo00Goo`00o`3jV_l0nY[oo`00o`3jVP05ooooo`05o`3jV_oo003o0?ZJool00?l0nYX0>_oo
ool003oooooo00?o0000o`3jV_ooool00_oo00000ol00?ooooooooooo`02ooooo`03ool00?l0nY[o
oooo00;ooooo00?o0?ZJooooooooool02?ooool01_l0nY[oooooool00?l00?ooooooo`3jVPCooooo
00Co0?ZJool00?oooooo0?ZJ4oooool01Ol00?oo0?ZJo`00ool00?ooo`0000Gooooo00?oo`00o`3j
V_ooool02_ooool00ol0nY[oooooooooo`02ool000Gooooo00Co0?ZJo`000?l0003o00001oooool0
0ol0nY[oooooooooo`05ooooo`;oo`000_ooool01?l00?ooo`00ooooool0nYX2ooooo`03o`3jV_oo
003ooooo01Kooooo00?o0?ZJoooooooo00000_l0nYX5ooooo`;o0?ZJ9oooool2o`3jVPKooooo00Ko
0?ZJool00?ooooooooooo`3jV_l00?l2ooooo`;oo`0000Goooooo`3jV_ooooooooooo`3jVP02ool0
00?ooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oo`00ool00002ool000Cooooo00?o0?ZJ
o`00ool000000_l000001ol0nY[ooooooooooooooooo0?ZJoooooooo00000_l0nYX2ooooo`04ool0
0?ooooooooooool000?ooooo00Go0?ZJool00?l00?oo0?ZJooooo`03o`3jVP?ooooo00?o0?ZJool0
0?ooool00_ooool01?l0nY[o003ooooooooo0003ooooo`03o`3jV_oo003ooooo00Wooooo00?o0?ZJ
ooooooooool01?ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Go0?ZJoooooooooooo0?ZJ
ool00003ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Wo0?ZJooooool0nY[oo`00o`00oooo003o
003oooooool0nYX00_ooool00ol0nY[oo`00ooooo`08ooooo`03o`3jV_oooooo0?ZJ02Cooooo00?o
0000ooooooooool00_ooool02?l0nY[oooooool00?l00?ooooooool00?l00?oooooo0_l00?l00ooo
oooo0?ZJooooo`02ooooo`06o`3jV_ooooooo`00o`3jV_oo003o0?ZJ1Oooool00ol0nY[oooooool0
0002o`3jVP03ool00?oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`06o`3j
V_ooooooo`00o`00ool0nY[oo`002Oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Gooooo00Go0?ZJ
oooooooo003o0?ZJool00008ooooo`05ool00?l0nY[oooooool00?l0nYX01?ooool01Ol0nY[ooooo
ool00?oo003o0?ZJ00?ooooo00?o0?ZJoooooooo00000ol00007ooooo`04ool00?oooooo0?ZJool0
00;ooooo00Co0?ZJooooool0nY[ooooo0_l0nYX3ooooo`;oo`0000?o0?ZJooooooooool01?ooool0
1Ooo003o0?ZJo`3jV_oo003o0?ZJ00Gooooo00Go0?ZJool00?ooooooo`00o`3jVP0jooooo`00>Ooo
ool2o`0000Cooooo0_l0nYX01?ooooooo`00o`00ool00?l4ooooo`03ool00?l0nY[ooooo00;ooooo
0_l0nYX9ooooo`03o`3jV_l00?ooo`0000;ooooo00?o0?ZJooooooooool00_ooool01?l0nY[oo`00
ooooool0nYXCooooo`;o0?ZJ0_ooool00ooo003oooooooooo`03ooooo`03o`3jV_oo003ooooo00[o
oooo00?o0?ZJoooooooo00000_oo0005ooooo`03o`3jV_oo003o0?ZJ013ooooo00Co0?ZJool00?l0
0?oooooo0_oo00001_oooooo0?ZJoooooooooooo0?ZJool001Oooooo00Co0?ZJoooooooo003o0?ZJ
1_ooool00ol0nY[o0000ooooo`0Vooooo`03o`3jV_l0003o0?ZJ00Gooooo00Ko0?ZJool00?oooooo
ooooo`3jV_l00?l2ooooo`;oo`0000Coooooo`3jV_oooooooooo0ol00003ooooo`;o0?ZJ00?ooooo
o`3jV_ooool00_ooool01Ol0nY[oooooooooooooooooo`0000Cooooo00?o0?ZJool00?l000000_l0
00001Ol0nY[ooooooooooooooooo0?ZJ00;oo`000ol0nYX2ooooo`03ool00?ooooooo`0000Cooooo
00Koo`00o`00ool0nY[oooooo`3jV_ooool2o`3jVP04ooooool0nY[o0?ZJool000?ooooo00Co0?ZJ
o`00ooooooooo`000oooool00ol0nY[oo`00ooooo`0@ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ
0_ooool01Ol0nY[oooooooooool0nY[oo`0000;ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00;o
oooo00Go0?ZJoooooooo003oo`00ooooo`02ool00006ooooool0nY[oooooooooool0nY[oo`002Ooo
ool00ol0nY[o0000o`3jVP0Tooooo`;o00000oooool02ol0nY[oooooool00?l00?ooooooool00?l0
0?ooooooo`00oooooooo0?ZJ00Gooooo00Go0?ZJool00?l0nY[oo`00o`3jVP05ooooo`03o`3jV_oo
ooooo`0000;o0?ZJ00?oo`00ooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo
00Ko0?ZJoooooooo003o003oo`3jV_oo0009ooooo`05ool00?l0nY[o0?ZJool00?l0nYX01Oooool0
1Ol0nY[oooooool00?l0nY[oo`0000Sooooo00Goo`00o`3jV_l0nY[oo`00o`3jVP04ooooo`05o`3j
V_ooooooo`00ooooool0nYX00oooool01Ol0nY[oooooool00?oo003o0?ZJ00Sooooo00Coo`00oooo
ool0nY[oo`000ol0nYX01?oooooo0?ZJo`3jV_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Co
o`00o`3jV_l0nY[oo`001_ooool01Ol0nY[oo`00oooooooo003o0?ZJ03[ooooo000hooooo`04o`00
0?ooooooooooo`0000?ooooo0_l00002ool00003o`00oooooooooooo00?ooooo00?oo`00o`3jV_oo
ool00_ooool2o`3jVPWooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`02ooooo`04
o`3jV_oo003oooooo`3jVQ?ooooo00Go0?ZJooooooooooooooooool00005ooooo`03o`3jV_oo003o
oooo00Wooooo00Ko0?ZJooooooooooooo`00oooooooo0005ooooo`03o`3jV_oo003o0?ZJ013ooooo
00?o0?ZJoooooooo00000_oo0002ooooo`06o`3jV_ooooooooooo`3jV_oo003o0?ZJ5_ooool01?l0
nY[oo`00o`00ool0nYX6ooooo`03o`3jV_l0003ooooo02Kooooo00?o0?ZJooooool0nYX01Oooool0
1_l0nY[oo`00oooooooooooo0?ZJo`00o`;ooooo0ooo00000ooooooo0?ZJooooo`03o`0000Cooooo
00?o0?ZJooooool0nYX00oooool01Ol0nY[oooooooooooooooooo`0000?ooooo00?o0?ZJoooooooo
00000ol00002o`3jVP;ooooo00Ko0?ZJool00?oo003o0?ZJooooool0nYX2ooooo`03ool00?oooooo
o`0000Cooooo00Goo`00o`00ool0nY[o0?ZJo`00o`02ooooo`Co0?ZJ00?oo`00ooooooooool00_oo
ool00ol0nY[o003oool00003ooooo`03o`3jV_oo003ooooo013ooooo00?o0?ZJooooooooool00_oo
ool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oo003ooooo00?o0?ZJ0_ooool00ol0nY[o003o
o`00o`02ooooo`04o`3jV_ooooooo`00o`00o`;ooooo00?oo`00ooooool0nYX00_ooool00ooo003o
0?ZJooooo`08ooooo`;o0?ZJ00?o0000ooooooooool08_ooool00ol0003oooooooooo`02ooooo`0;
o`3jV_ooooooo`00o`00ooooooooo`00o`00oooooooo003oooooool0nYX01Oooool01Ol0nY[oo`00
o`3jV_oo003o0?ZJ00Gooooo00?o0?ZJoooooooo00000_l0nYX00ooo003oooooooooo`03ooooo`05
o`3jV_ooooooooooooooool0nYX01?ooool01_l0nY[oooooool00?l00?ooo`00o`3jVPWooooo00Go
0?ZJool00?l0nY[oo`00o`3jVP06ooooo`04o`3jV_oo003o0?ZJool000Sooooo00Goo`00o`3jV_l0
nY[oo`00o`3jVP04ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01Ol0nY[oooooool00?oo
003o0?ZJ00Sooooo00Coo`00ooooool0nY[oo`000ol0nYX2ooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooool0nYX01_ooool01?oo003o0?ZJo`3jV_oo0006ooooo`05o`3jV_oo003o003oool0
0?l00000>_ooool003Sooooo00Co0000oooooooooooo00000oooool2o`000003ool00?l00?oo003o
00Gooooo00Ooo`00o`3jV_ooooooooooo`3jV_oooooo0?ZJ00Wooooo00?o0?ZJool00?ooool00_oo
ool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo003oooooo`3jVQ;ooooo0_l0nYX3ooooo`03ool0
0?oooooooooo00?ooooo00?o0?ZJool00?l0nYX02Oooool00ol0nY[oooooool00002ooooo`03ool0
0?oooooooooo00?ooooo00?o0?ZJool00?l0nYX04?ooool01?l0nY[oooooo`00ool00?l3ooooo`06
o`3jV_ooooooooooo`3jV_oo003o0?ZJ5_ooool01?l0nY[oo`00o`00ool0nYX6ooooo`03o`3jV_l0
003ooooo02Kooooo00?o0000o`3jV_l0nYX01Oooool01_l0nY[oo`00oooooooooooo0?ZJo`00o`;o
oooo00Koo`00o`3jV_oo003oooooo`3jV_ooool3o`0000Cooooo00?o0?ZJooooool0nYX00oooool0
1Ol0nY[oooooooooooooooooo`0000?ooooo00So0?ZJoooooooo003oooooo`3jV_oo003o003oo`3j
VP;ooooo00?o0?ZJool00?oo00000_ooool01_l0nY[ooooooooooooo003oooooool000Cooooo00Co
0?ZJool00?l0nY[o0?ZJ0_l00?l2ooooo`?o0?ZJ00?oo`00ooooooooool00_ooool00ol0nY[o003o
ool00003ooooo`03o`3jV_oo003ooooo013ooooo00?o0?ZJooooooooool00_ooool01?l0nY[ooooo
ooooool0nYX2ooooo`0:o`3jV_oo003o0?ZJo`3jV_oooooo0?ZJooooool0nY[oooooo`00o`;oo`00
00Coooooo`3jV_l0nY[oo`000oooool2ool00005o`3jV_ooooooooooool00?l0nYX02Oooool2o`3j
VP03o`000?oooooooooo02;ooooo00?o0000ooooooooool00_ooool02ol0nY[oooooool00?l00?oo
0?ZJool00?l00?ooooooo`00oooooooo0?ZJ00Gooooo00Go0?ZJool00?l0nY[oo`00o`3jVP05oooo
o`03o`3jV_ooooooo`0000;o0?ZJ00?oo`00ooooooooool00oooool01?l0nY[oooooooooool0nYX6
ooooo`03o`3jV_oo003o000000;o00002Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00Kooooo00Co
0?ZJool00?oo003o0?ZJ2?ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Cooooo00Go0?ZJoooooooo
ooooooooo`3jVP03ooooo`05o`3jV_ooooooo`00ool00?l0nYX02?ooool01?oo003oooooo`3jV_oo
000;ooooo`;o0?ZJ1oooool01?oo003o0?ZJo`3jV_oo0006ooooo`05o`3jV_oo003o003oool00?l0
0000>_ooool003Sooooo00Co0000oooooooooooo00000oooool2o`0000?o003o1Oooool01ooo003o
0?ZJoooooooooooo0?ZJooooool0nYX02Oooool00ol0nY[oo`00ooooo`02ooooo`03o`3jV_oooooo
oooo00;ooooo00Co0?ZJoooooooo003o0?ZJ4_ooool00ol0nY[o003oooooo`02ooooo`03ool00?oo
oooooooo00?ooooo00?o0?ZJool00?l0nYX02Oooool00ol0nY[oo`00ool00002ooooo`03ool00?oo
oooooooo00?ooooo00?o0?ZJool00?l0nYX04?ooool2o`3jVP;o003o0oooool01_l0nY[ooooooooo
ooooooooo`00o`3jVPoooooo0ol0nYX4ooooo`04o`3jV_oo003oooooo`3jVPKooooo00?o0?ZJo`00
0?ooool09_ooool00ol0003o0?ZJo`3jVP05ooooo`05o`3jV_oo003oooooooooool0nYX00oooool0
2Ooo003o0?ZJool00?oooooo0?ZJooooool0nY[oo`00o`3jVP04ooooo`03o`3jV_oooooo0?ZJ00?o
oooo00Go0?ZJooooooooooooooooool00003ooooo`08o`3jV_oo003oo`00ooooool0nY[oo`00o`00
ool0nYX2ooooo`03o`3jV_oo003oo`0000?ooooo00?o0?ZJooooooooool00_oo0004ooooo`06o`3j
V_oo003o0?ZJo`3jV_oooooo003o1?ooool00ol0nY[oo`00ooooo`03ooooo`03o`3jV_l00?ooo`00
00?ooooo00?o0?ZJool00?ooool04?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ00Koooooo`3j
V_ooooooooooo`3jV_oo0003ooooo`06o`3jV_oooooo0?ZJo`00oooo003o003o0_oo0002o`3jVP03
ool00?oooooooooo00;ooooo00Koo`00o`3jV_ooooooooooool00?l0nYX9ooooo`;o0?ZJ00?o0000
ooooooooool08_ooool2o`0000?ooooo00_o0?ZJoooooooo003o003oo`3jV_oo003o003oooooool0
0?ooooooo`3jVP05ooooo`04o`3jV_oo003o0?ZJool000Kooooo00Ko0?ZJoooooooo003o0?ZJool0
0?l0nYX5ooooo`04o`3jV_ooooooooooo`3jVPKooooo00?o0?ZJool00?l000000_l00009ooooo`05
o`3jV_oo003o0?ZJool00?l0nYX01_ooool01?l0nY[oo`00ool00?l0nYX8ooooo`05ool00?l0nY[o
0?ZJool00?l0nYX01?ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Go0?ZJoooooooo003o
o`00o`3jVP08ooooo`04ool00?ooooooo`00o`3jVP_ooooo0_l0nYX7ooooo`04ool00?l0nY[oo`00
o`3jVPKooooo00Go0?ZJool00?l00?ooo`00o`00000jooooo`00>?ooool01?l0003oooooooooool0
0003ooooo`03o`3jV_oooooo003o00Oooooo00Ooo`00o`3jV_ooooooooooo`3jV_oooooo0?ZJ00Wo
oooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_l00?ooo`00o`3j
VPOooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo
00?ooooo00?o0?ZJool00?l0nYX02Oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooooooo
00?ooooo00?o0?ZJool00?l0nYX04Oooool00ol0nY[oooooooooo`03ooooo`06o`3jV_oooooooooo
oooooooo003o0?ZJ3_ooool2o`3jVP03ooooool0nY[ooooo00?ooooo00Co0?ZJool00?oooooo0?ZJ
1oooool00ol0003oooooooooo`0Uooooo`03o`000?l0nY[o0?ZJ00Gooooo00Go0?ZJool00?l0nY[o
ooooo`3jVP03ooooo`09ool00?l0nY[oo`00ooooool0nY[oooooo`3jV_oo003o0?ZJ00Cooooo0ol0
nYX3ooooo`05o`3jV_l00?oo003ooooooooo00000oooool01?l0nY[oo`00ooooooooool2o`3jVP05
ool00?l0nY[oooooooooool0nYX00ol00002ooooo`03o`3jV_oooooooooo00;oo`001?ooool01?l0
nY[o0000o`000?l00002ool00006o`00oooooooooooooooooooo003o0?ZJ1?ooool2o`3jVP06ool0
0?ooooooooooooooool0nY[oo`005oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oo003o003o
00;ooooo00?o0?ZJooooool0nYX00_oo00000ol00?ooooooool00002o`3jVP03ool00?l0nY[o0?ZJ
00;ooooo00Koo`00o`3jV_ooooooooooool00?l0nYX9ooooo`;o0?ZJ00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`02ooooo`09o`3jV_ooooooo`00o`00ool0nY[oo`00o`00oooooooo003o
00;o0?ZJ1Oooool01?l0nY[oo`00o`3jV_oo0006ooooo`03o`3jV_oooooo0?ZJ00;oo`0000?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooo`3jVP06ooooo`03o`3jV_oooooo000000;o00002Oooool0
1Ol0nY[oo`00o`3jV_oo003o0?ZJ00Kooooo00Co0?ZJool00?oo003o0?ZJ2?ooool01Ol0nY[oo`00
o`3jV_oo003o0?ZJ00Gooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[oo`00ool00?l0nYX8
ooooo`04ool00?ooooooo`00o`3jVQCooooo00Coo`00o`3jV_oo003o0?ZJ1_ooool01Ol0nY[oo`00
o`00oooo003o000003[ooooo000hooooo`04o`000?ooooooooooo`0000?ooooo0_l0nYX8ooooo`06
ool00?l0nY[oooooooooool0nY[ooooo1?l0nYX3ooooo`04o`3jV_oooooo0?ZJool000Cooooo00?o
0?ZJooooooooool00oooool00ol0nY[oo`00o`3jVP06ooooo`;o0?ZJ2_ooool00ol0nY[ooooooooo
o`02ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJool00?l0nYX02Oooool00ol0nY[oo`00o`00
o`02ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJool00?l0nYX04Oooool00ol0nY[ooooooooo
o`03ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ3_ooool01?l0nY[oooooooooool0nYX4oooo
o`04o`3jV_oo003oooooo`3jVPOooooo00?o0000ooooooooool09Oooool00ol0003o0?ZJo`3jVP05
ooooo`05o`3jV_oo003o0?ZJooooool0nYX00oooool02Ooo003o0?ZJool00?oo003o0?ZJooooool0
nY[oo`00o`3jVP05ooooo`;o0?ZJ0oooool01Ol0nY[o003oo`00ool00?ooo`0000?ooooo00Co0?ZJ
ool00?oooooooooo0_l0nYX01Ooo003o0?ZJo`3jV_oooooo0?ZJ00?o00000_ooool00ol0nY[ooooo
ooooo`02ool000Cooooo00Go0?ZJo`000?l0003o0000ooooo`02ool000;ooooo0ol00005ooooo`03
o`3jV_oo003ooooo00;ooooo00?oo`00o`3jV_ooool05_ooool00ol0nY[oooooo`3jVP02ooooo`03
o`3jV_oo003o003o00;ooooo00Ko0?ZJooooool0nY[oo`00ooooool00?l2ooooo`03ool00?l0nY[o
o`0000?o0?ZJ00?oooooool00?l0nYX00_ooool00ooo003o0?ZJooooo`09ooooo`03o`3jV_l0003o
oooo02?ooooo00?o0000ooooooooool00_ooool01ol0nY[oooooool00?l00?oo0?ZJool00?ooool0
0_l00?l2o`3jVPGooooo00Co0?ZJool00?l0nY[oo`001_ooool00ol0nY[oooooo`3jVP02ool00003
o`3jV_oooooooooo00Cooooo00?o0?ZJooooool0nYX01_ooool01?l0nY[oooooooooool0nYX:oooo
o`04o`3jV_oo003o0?ZJool000Oooooo0ol000000ol0nY[oooooooooo`06ooooo`04o`3jV_oo003o
0?ZJool000Kooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[oooooooooool0nYX8ooooo`04
ool00?ooooooo`00o`3jVQCooooo00Coo`00o`3jV_oo003o0?ZJ1_ooool01Ol0nY[oo`00ool00?l0
nY[o000003[ooooo000iooooo`;o00001?ooool00ol0003o0?ZJooooo`07ooooo`07ool00?l0nY[o
ooooooooool0nY[oooooo`3jVP02ooooo`08o`3jV_ooooooooooooooool0nY[oooooo`3jV_oo0004
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJool00?oo00001_ooool2o`3jVPWooooo00?o0?ZJ
o`00ooooool00oooool00ooo003oooooooooo`03ooooo`03o`3jV_oo003o0?ZJ00Wooooo0_oo0003
o`00o`03ool00?oooooooooo00?ooooo00?oo`00o`00ool0nYX04Oooool2o`3jVPCooooo00Ko0?ZJ
ooooooooooooooooool00?l0nYX>ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJool00?oo
oooo0?ZJ1oooool00ol0003oooooooooo`0Uooooo`03o`000?l0nY[o0?ZJ00Gooooo00?o0?ZJool0
0?l0nYX00_l0nYX2ooooo`;oo`0000So0?ZJoooooooo003o0?ZJooooool0nY[oo`00o`3jVPGooooo
0_l0nYX4ooooo`03o`3jV_l00?oo000000;o00000_ooool01?l0nY[oo`00ooooooooool2o`3jVP05
ool00?l00?oo0?ZJooooool0nYX00ol00002ooooo`03o`3jV_oooooooooo00;oo`001?ooool01?l0
nY[o0000o`000?l00002ooooo`03ool00?oooooooooo00?o00001Oooool3o`0000;ooooo00?oo`00
o`3jV_ooool05_ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oo003o003o00;ooooo00Koo`00
o`3jV_ooooooo`00ooooool00?l2ooooo`;oo`0000Oo0?ZJoooooooooooo0?ZJooooool00?ooo`00
00;ooooo00?oo`00o`3jV_ooool02Oooool2o`0002Cooooo0_l00003ooooo`07o`3jV_ooooooo`00
o`00ool0nY[oo`00ooooo`02o`00o`;o0?ZJ1Oooool01?l0nY[oo`00o`3jV_oo0006ooooo`03o`3j
V_oooooo0?ZJ00;oo`0000?o0?ZJooooooooool01?ooool2o`3jVPOooooo00Co0?ZJoooooooooooo
0?ZJ2_ooool01?l0nY[oo`00o`3jV_oo0007ooooo`?o00002Oooool01?l0nY[oo`00o`3jV_oo0006
ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ2?ooool01?oo003ooooo
ool00?l0nYXDooooo`04o`3jV_oo003oo`00o`3jVPKooooo00Go0?ZJool00?oo003o0?ZJo`00000j
ooooo`00?oooool2o`000003o`3jV_oooooooooo00Gooooo00Soo`00o`3jV_ooooooooooo`3jV_oo
oooo0?ZJo`00o`;ooooo00Oo0?ZJoooooooooooo0?ZJooooool0nY[oo`0000Cooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[oooooool00006ooooo`;o0?ZJ2Oooool01?l0nY[o003oool00?oo0002
ooooo`03ool00?oooooooooo00?ooooo0ol00008ooooo`03o`3jV_oo003o003o00?o003o00?oo`00
ooooooooool00oooool00ooo003o003oo`3jVP0Booooo`05o`3jV_ooooooooooooooool0nYX01?oo
ool00ooo003o003oo`3jVP07ooooo`;o0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo
00Coo`00ooooool0nY[o0?ZJ1_ooool2o`0001[ooooo0ol00004ooooo`;o00001?ooool01?l0003o
0?ZJooooool0nYX2ooooo`05o`3jV_oooooo0?ZJool00?ooool00_l0nYX2ooooo`0:ool00?l0nY[o
ooooo`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVPGooooo0_l0nYX4ooooo`;o0?ZJ0ol00002o`3j
VP04o`00oooo003oooooooooo`;o0?ZJ00Ooo`00ooooool0nY[o0?ZJoooooooo003o0?ZJ00Cooooo
00Co0?ZJoooooooo003oo`001?ooool00ol0nY[oooooo`3jVP02o`3jVP04oooooooo003oo`00oooo
o`?o00001Oooool3o`0000;ooooo00?oo`00o`3jV_ooool05_ooool00ol0nY[oooooo`3jVP02oooo
o`03o`3jV_oo003o003o00?oo`0000Go0?ZJool00?ooooooooooo`00o`02ooooo`;oo`0000Oo0?ZJ
oooooooooooo0?ZJooooool00?ooo`0000;ooooo00?oo`00o`3jV_ooool02_ooool00ol0003ooooo
ooooo`0Fooooo`?o00000oooool2o`0000Cooooo00?o0000ooooooooool00_ooool02?l0nY[ooooo
ool00?l00?oo0?ZJool00?oooooo003o0ol0nYX5ooooo`04o`3jV_l0003o0000o`0000Kooooo00?o
0?ZJooooool0nYX00_oo00000ol0nY[oooooooooo`04ooooo`;o0?ZJ1oooool01?l0nY[ooooooooo
ool0nYX:ooooo`04o`3jV_oo003o0?ZJool000Oooooo0ol00009ooooo`04o`3jV_oo003o0?ZJool0
00Kooooo00Co0?ZJooooool0nY[o0?ZJ1?ooool00ol0nY[oooooo`3jVP09ooooo`04ool00?oooooo
o`00o`3jVQCooooo00Co0?ZJool00?oo003o0?ZJ1_ooool01Ol0nY[oooooool00?l0nY[o000003[o
oooo000oooooo`03o`000?oooooo0?ZJ00Oooooo00Go0?ZJool00?ooooooooooo`3jVP03o`0000;o
oooo00Oo0?ZJoooooooooooo0?ZJooooool0nY[oo`0000;o0?ZJ0_ooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_ooooooo`0000Kooooo1?l0nYX5ooooo`03o`3jV_oooooo0?ZJ00Coo`0000?ooooo
ool00?ooool01?ooool3o`000003o`3jV_oooooooooo00Gooooo00?o0?ZJool00?l00?l00_ooool3
o`0000Cooooo00?oo`00o`3jV_ooool04_ooool2o`3jVP;ooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oo`00o`3jVP06ooooo`?o0?ZJ0oooool01Ol0nY[o003oo`00oooooooo0?ZJ00Cooooo00?o
o`00ooooool0nYX02?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000oooool01?l0003o0?ZJooooool0nYX2ooooo`08o`3jV_oooooo0?ZJool0
0?oooooo0?ZJo`00ooooool2ool00009o`3jV_oooooo0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ
00gooooo0ol00002o`3jVP03o`00oooo003o0?ZJ00;o0?ZJ00?oooooo`3jV_oo00000_l0nYX00ooo
ooooo`00o`3jVP04ooooo`04o`3jV_ooooooooooool000Cooooo00Go0?ZJooooool0nY[oooooo`3j
VP02ooooo`;oo`0000?oooooool00?ooool01Oooool3o`0000;ooooo00?oo`00o`3jV_ooool05ooo
ool2o`3jVP?ooooo00Ooo`00oooooooo003o003oool00?l0nY[oo`0000?ooooo00Go003ooooooooo
003oo`00o`3jVP03ooooo`03o`3jV_l00?ooo`0000;ooooo00?oo`00o`3jV_ooool02_ooool00ol0
003oooooooooo`0Gooooo`05o`000?ooooooooooooooool000000_ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0?ZJooooool000000_l000000ooo003oooooo`00o`03o`3jVPGooooo00Co
0?ZJo`000?l0003o00002?ooool01?l0nY[oo`00ool00?l0nYX?ooooo`04o`3jV_ooooooooooo`3j
VP[ooooo00Co0?ZJool00?l0nY[oo`002?ooool2o`3jVPWooooo00Co0?ZJool00?oo003o0?ZJ1_oo
ool00ol0nY[oooooo`3jVP05ooooo`03o`3jV_oooooo0?ZJ00Wooooo00?oo`00oooooooo00005Ooo
ool01?l0nY[oo`00ool00?l0nYX6ooooo`05o`3jV_ooooooooooo`3jV_l00000>_ooool003oooooo
00?o0000ooooool0nYX01?ooool01Ol0nY[oooooooooool0nY[oo`0000;ooooo00Oo0?ZJo`000?l0
003o0000ool00?oooooo0?ZJ00;ooooo00?o0?ZJoooooooo00001?l0nYX00ooooooo0?ZJooooo`04
ooooo`03o`3jV_ooooooo`0000Kooooo1Ol0nYX4ooooo`04o`3jV_oooooo0?ZJool000;ooooo00?o
o`00oooooooo00001Oooool3o`0000?o0?ZJ1Oooool01Ol0nY[oo`00o`3jV_l0nY[ooooo00?o0000
1?ooool00ooo003o0?ZJooooo`0Cooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJool00?l0
nYX01_ooool00ol0nY[oooooo`3jVP03ooooo`05o`3jV_l00?oo003oooooool0nYX01?ooool00ooo
003o0?ZJo`3jVP08ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00003ooooo`04o`000?l0nY[oooooo`3jVP;ooooo00Co0?ZJooooool0nY[oo`00
0_ooool02Ol00?ooooooool00?oooooo0?ZJooooool0nY[oo`00ooooo`02o`3jVP03ool00?l0nY[o
oooo00cooooo0_l0nYX01_oo003ooooooooooooo003oooooo`3jVP?ooooo00Oo0?ZJool00?l0nY[o
0?ZJool00?l00?oo0?ZJ00Cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`3jVP02
ooooo`03o`3jV_oooooo003o00?oo`001oooool01_l0nY[oo`00ooooooooooooo`00o`3jVQSooooo
0_l0nYX3ooooo`?oo`000ol000000ooo003oooooo`3jVP02o`3jVP04oooooooo003oo`00o`3jVP?o
oooo00?o0?ZJoooooooo00000_ooool00ooo003o0?ZJooooo`09ooooo`;o00005_ooool5o`0000;o
oooo00Co0000oooooooooooo00000oooool2o`0000?ooooo00?o0?ZJooooool000000_l000000ooo
003oooooo`00o`03o`3jVPGooooo00Co0?ZJo`000?l0003o00002?ooool01?l0nY[oo`00ool00?l0
nYX?ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Co0?ZJool00?ooooooo`004oooool01?l0nY[o
o`00ool00?l0nYX6ooooo`?o0?ZJ1Oooool00ol0nY[oooooo`3jVP09ooooo`03ool00?ooooooo`00
01Gooooo00Co0?ZJool00?oo003o0?ZJ1_ooool01Ol0nY[oooooooooool0nY[o000003[ooooo000o
ooooo`03o`000?oooooo0?ZJ00Cooooo00So0?ZJoooooooooooo0?ZJool00?l0nY[oooooo`3jVP?o
000000?oo`00ooooool0nYX00_ooool01?l0nY[oooooool00?l0nYX2ooooo`03o`3jV_oooooo0?ZJ
00Gooooo00?o0?ZJoooooooo00001Oooool01_l0nY[o0000o`000?l0003oooooo`3jVPCooooo00Co
0?ZJooooool0nY[oo`000_ooool3ool000Gooooo00?o0?ZJoooooooo00000_ooool2o`3jVPCooooo
00Go0?ZJool00?l0nY[oooooo`3jVP03o`0000?ooooo00?o0?ZJool00?l0nYX05?ooool2o`3jVP03
ooooool0nY[ooooo00?ooooo00Co0?ZJool00?oooooo0?ZJ1?ooool01?l0nY[oooooooooool0nYX2
ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ1?ooool00ooo003o0?ZJooooo`08ooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`04
o`000?l0nY[oooooo`3jVP;ooooo00Co0?ZJooooool0nY[oo`000_ooool02Ol00?ooooooool00?oo
oooo0?ZJooooool0nY[oo`00o`00o`02o`3jVP03ool00?l0nY[ooooo00cooooo0_l0nYX01_oo003o
003ooooooooo003oooooo`3jVP?ooooo00Oo0?ZJool00?l0nY[o0?ZJool00?l00?oo0?ZJ00Cooooo
00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooo003o00;o
o`0000?o0?ZJooooooooool01Oooool01_l0nY[oo`00ooooooooooooo`00o`3jVQSooooo0_l0nYX3
ooooo`03o`3jV_oo003ooooo00?o000000Coooooo`3jV_l0nY[ooooo0_l0nYX2ool000Cooooo00?o
0?ZJoooooooo00000_ooool00ooo003o0?ZJooooo`0:ooooo`03o`000?oooooooooo01Cooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;o
oooo00?o0?ZJooooool000000_l000000ooo003oooooooooo`03o`3jVPGooooo00?o0?ZJool00?oo
00002Oooool00ol0nY[oo`00ool0000@ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Co0?ZJool0
0?oo003o0?ZJ4oooool01?l0nY[oo`00ool00?l0nYX7ooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooool0nYX02Oooool00ooo003o0?ZJool0000Eooooo`03o`3jV_oo003oo`0000Oooooo00Go
0?ZJoooooooooooo0?ZJo`00000jooooo`00?oooool2o`000003ooooool0nY[ooooo00;ooooo00co
0?ZJoooooooooooo0?ZJool00?l0nY[oooooo`3jV_ooooooo`00o`3jV_oo0002ooooo`06o`3jV_oo
oooo0?ZJoooooooo003o0?ZJ0_ooool3o`3jVPGooooo00?o003oo`3jV_oo00001Oooool01Ol0nY[o
0000o`000?l0003o003o00;o0?ZJ0_ooool2o`3jVP03oooooooo003ooooo00?ooooo0_oo0005oooo
o`04o`3jV_ooooooo`00o`00o`;ooooo0_l0nYX3ooooo`06o`3jV_oo003o0?ZJooooool0nY[ooooo
0_oo0003ooooo`03o`3jV_oo003o0?ZJ01Gooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oo`00
ooooool0nYX4ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00Ko0?ZJo`00oooo003oo`00o`00ool0
nYX4ooooo`03ool00?l0nY[ooooo00Oooooo0_l0000Kooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000oooool01?l0003o0?ZJooooool0nYX2ooooo`04o`3jV_oooooo0?ZJool0
00;ooooo00Wo003oool00?oo003oooooo`3jV_oooooo0?ZJool00?l00?l00_l0nYX00ooo003ooooo
ooooo`0=ooooo`07o`3jV_oo003oo`00oooooooo003oooooo`3jVP03ooooo`07o`3jV_oo003o003o
o`3jV_oo003o003oo`3jVP04ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooool0nYX0
0_ooool2o`3jVP04o`00ooooooooooooo`3jVPOooooo00Ko0?ZJool00?ooooooooooool00?l0nYXH
ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`03o`0000;o0?ZJ0_ooool01?l00?oo0000o`000?l0
0004ooooo`06o`3jV_l0003o0000o`000?ooooooo`003?ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooo000000?ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02oooo
o`08o`3jV_ooooooo`00ool00?l0nY[oo`00o`3jV_ooool3o`3jVPGooooo00?o0?ZJoooooooo0000
2Oooool00ol0nY[o003oo`3jVP0@ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Co0?ZJool00?oo
003o0?ZJ4oooool01?l0nY[oo`00ool00?l0nYX>ooooo`03o`3jV_oooooo0?ZJ00Wooooo00?oo`00
o`3jV_oo00005Oooool00ol0nY[oo`00ool00007ooooo`05o`3jV_ooooooooooo`3jV_l00000>_oo
ool003oooooo00Co0000oooooooooooo0?ZJ0oooool01Ol0nY[oooooooooool0nY[oo`0000;o0?ZJ
00go003ooooooooo003o0?ZJo`00oooo003oooooo`3jV_oooooo0?ZJoooooooo003o0?ZJ00?ooooo
0_l0nYX5ooooo`03o`00ool0nY[oo`0000Gooooo00Oo0?ZJo`000?l0003o0000ool00?l00?oo0?ZJ
00;ooooo0ol0nYX00ooo003oooooooooo`02ooooo`;oo`001_ooool00ol0nY[oo`00ool00003oooo
o`;o0?ZJ0_ooool00ooo003o0?ZJooooo`02ooooo`;o0?ZJ00Ooo`00ooooooooooooooooo`3jV_oo
003o0?ZJ01Gooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oo`00ooooool0nYX3ooooo`;o0?ZJ
0_ooool01?l0nY[oooooooooool0nYX2ool00003o`00oooo003o0?ZJ00?ooooo00?o0?ZJool00?l0
nYX02Oooool00ol0003oooooooooo`0Hooooo`;o00001?ooool01?l0003oooooooooool00003oooo
o`04o`000?l0nY[oooooo`3jVP;ooooo00Co0?ZJooooool0nY[oo`000_ooool03?l00?ooo`00oooo
oooooooo0?ZJooooool0nY[oo`00o`00ool0nY[oo`00o`3jVPoooooo0_l0nYX01Ooo003o003oool0
0?oooooo0?ZJ00?ooooo00Oo0?ZJool00?l00?ooooooool00?l00?oo0?ZJ00Cooooo00Co0?ZJoooo
oooooooo0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`05o`3jV_l00?ooooooooooool0nYX01ooo
ool01_l0nY[oo`00o`3jV_ooooooo`00o`3jVQSooooo0_l0nYX3ooooo`04o`3jV_oooooooooooooo
o`?o0?ZJ0oooool01?l00?oo0000o`000?l00005ooooo`?o000000?oooooool00?ooool02oooool0
0ol0003oooooooooo`0Fooooo`;o00000oooool01?l0003oooooooooool00003ooooo`03o`000?oo
oooooooo00;ooooo00_o0?ZJoooooooo003oo`00o`3jV_oo003o0?ZJooooool0nY[oooooo`3jVP05
ooooo`03o`3jV_ooooooo`0000[ooooo0_l0nYX@ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00Co
0?ZJool00?oo003o0?ZJ4oooool01?l0nY[oo`00ool00?l0nYX>ooooo`03o`3jV_oooooo0?ZJ00Wo
oooo00?oo`00o`3jV_oo00005Oooool00ol0nY[oo`00o`3jVP08ooooo`04o`3jV_oooooo0?ZJo`00
03[ooooo000oooooo`04o`000?ooooooooooo`3jVP?ooooo00Go0?ZJoooooooooooo0?ZJool00002
o`3jVP0=o`00ooooooooo`00o`3jV_ooooooo`00ooooool0nY[oooooo`3jV_ooooooo`00o`3jVP03
ooooo`;o0?ZJ1_ooool00ol0nY[oo`00ooooo`04ooooo`07o`3jV_l00?ooo`00o`00oooo003o003o
o`3jVP02ooooo`?o0?ZJ00?oo`00ooooooooool00_ooool2ool000Kooooo0_l0nYX2ool00004o`00
ooooooooooooo`3jVP;ooooo00?oo`00o`3jV_ooool00_ooool2o`3jVP07ool00?oooooooooooooo
ool0nY[oo`00o`3jVP0Eooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJool00?l00?oo0?ZJ0ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Co0?ZJool00?oooooooooo0_oo0003ooooo`03
o`3jV_oo003o0?ZJ00Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`03ooooo`;o
00001?ooool01?l0003o0?ZJooooool0nYX2ooooo`04o`3jV_oooooo0?ZJool000;ooooo0_oo0002
ooooo`08o`3jV_oooooo0?ZJoooooooo003o0?ZJool00?l0nYX?ooooo`;o0?ZJ0_oo00000ooooooo
0?ZJooooo`03ooooo`07o`3jV_ooooooo`00o`00oooo003o003oo`3jVP04ooooo`04o`3jV_oooooo
ooooo`3jVPCooooo00?o0?ZJooooool0nYX00oooool2o`3jVP03o`00oooooooo0?ZJ00Oooooo00Ko
0?ZJool00?l0nY[oooooool00?l0nYXHooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`04o`3jVPCo
oooo0ol00005ooooo`?o000000?o0?ZJool00?ooool02_ooool2o`0001Wooooo00?o0000oooooooo
ool00_ooool2o`0000Cooooo0_l00003ooooo`03o`3jV_ooooooo`0000;oo`000_l0nYX01?oooooo
0?ZJooooool0nYX5ooooo`03o`3jV_oooooo0?ZJ00[ooooo0_l0nYX@ooooo`04o`3jV_oooooooooo
o`3jVP[ooooo00Co0?ZJool00?oo003o0?ZJ4oooool01?l0nY[oo`00ool00?l0nYX>ooooo`03o`3j
V_oooooo0?ZJ00Wooooo00?oo`00o`3jV_oo00005Oooool00ol0nY[oooooo`3jVP08ooooo`04o`3j
V_oooooo0?ZJo`0003[ooooo000oooooo`04o`000?ooooooooooo`3jVP?ooooo00Go0?ZJoooooooo
oooo0?ZJool00002o`3jVP0<o`00ooooooooo`00ooooool0nY[oo`00o`00ool0nY[oooooo`3jV_oo
ooooo`001?ooool2o`3jVPKooooo00?o0?ZJool00?l0nYX01?ooool01ol0nY[oo`00o`3jV_l0nY[o
o`00o`00ool0nYX00_ooool3o`3jVP03ool00?l0nY[o0?ZJ00?ooooo00?o0?ZJooooooooool01?oo
ool2o`3jVP03o`00oooo003o003o00;ooooo0_l0nYX00oooooooo`00o`3jVP03ooooo`;o0?ZJ00Oo
o`00o`3jV_ooooooooooo`3jV_oo003o0?ZJ01Kooooo0_l0nYX4ooooo`04o`3jV_oo003oo`00o`3j
VP?ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`06o`3jV_oo003oooooooooool00?ooo`00
0oooool00ol0nY[oo`00o`3jVP09ooooo`03o`000?oooooooooo02Gooooo00Co0000o`3jV_oooooo
0?ZJ0_ooool01?l0nY[oooooo`3jV_l0nYX3ool000?ooooo00So0?ZJoooooooooooo0?ZJool00?l0
nY[oo`00o`3jVQ3ooooo00Go0?ZJo`00ool00?ooooooo`3jVP05ooooo`05o`3jV_oo003o003oool0
0?l0nYX01_ooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJo`00
oooooooo0?ZJ2?ooool01Ooo003o0?ZJoooooooo003o0?ZJ01Sooooo0_l0nYX3ooooo`04o`3jV_oo
oooo0?ZJo`3jVPOooooo00?o003oo`3jV_ooool01Oooool01Ol0nY[oo`00ooooool0nY[oo`0000co
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`02ooooo`03o`3jV_ooooooo`0000;o
o`000_l0nYX01?oooooo0?ZJooooool0nYX5ooooo`03o`3jV_oooooo0?ZJ00[ooooo0_l0nYXAoooo
o`;o0?ZJ2oooool01?l0nY[oo`00ool00?l0nYXCooooo`04o`3jV_oo003oo`00o`3jVPoooooo0_l0
nYX9ooooo`03ool00?l0nY[oo`0001Kooooo0_l0nYX8ooooo`04o`3jV_oooooo0?ZJo`0003[ooooo
000oooooo`;o000000?oooooo`3jV_ooool00_ooool01Ol0nY[oooooooooool0nY[oo`0000;o0?ZJ
0_ooool02_oo003oooooo`3jV_oo003o003oo`3jV_oooooo0?ZJoooooooo0005ooooo`03o`3jV_oo
oooooooo00Cooooo0ol000001_l0nY[oooooooooool0nY[oooooool000;o0?ZJ00?oooooool00?l0
nYX00_ooool2o`3jVP03ool00?l0nY[o0?ZJ00;o0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`?o
0?ZJ00?o003oool00?l00?l00_ooool01?l0nY[oooooool00?l0nYX4ooooo`03o`3jV_oo003o0?ZJ
00;ooooo00?o0?ZJool00?l0nYX05_ooool2o`3jVPGooooo00?o0?ZJool00?l0nYX00_ooool00ol0
nY[o003oo`00o`03ool00003ooooool0nY[oo`0000Cooooo00Koo`00ooooooooooooooooo`3jV_oo
0009ooooo`;o00009oooool01?l0003o0?ZJooooool0nYX2ooooo`04o`3jV_oooooo0?ZJo`3jVP;o
o`0000Go003oooooooooooooooooo`3jVP02ooooo`05o`3jV_oo003o0?ZJool00?l0nYX04?ooool2
o`3jVP;ooooo00?o0?ZJooooooooool00oooool01Ol0nY[oo`00o`00oooo003o0?ZJ00Kooooo00?o
0?ZJooooool0nYX01?ooool3o`3jVPCooooo0_l0nYX00ooooooo0?ZJooooo`07ooooo`05ool00?l0
nY[oooooool00?l0nYX06?ooool2o`3jVP?ooooo00?o0?ZJooooool0nYX02?ooool00ol00?oooooo
ooooo`05ooooo`05o`3jV_oo003o0?ZJo`3jV_oo00003?ooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00;ooooo00?o0?ZJoooooooo00000_oo0002o`3jVP04ooooool0nY[oooooo`3j
VPGooooo00?o0?ZJooooool0nYX02_ooool2o`3jVQ7ooooo0_l0nYX;ooooo`04o`3jV_oo003oo`00
o`3jVQ?ooooo00Co0?ZJool00?oo003o0?ZJ3oooool00ol0nY[oooooooooo`08ooooo`03ool00?l0
nY[oo`0001Kooooo0_l0nYX8ooooo`04o`3jV_oooooo0?ZJo`0003[ooooo000oooooo`04o`000?oo
ooooooooo`3jVP?ooooo00Go0?ZJoooooooooooo0?ZJool00002o`3jVP;ooooo00[oo`00ooooool0
nY[oooooool00?l0nY[oooooo`3jV_ooooooo`001Oooool00ol0nY[oooooooooo`04ooooo`?o0000
00Ko0?ZJoooooooooooo0?ZJo`00oooo0003o`3jVP04ool00?l00?oo0?ZJooooo`;o0?ZJ00Goo`00
o`3jV_ooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJooooool0nY[ooooo
0_oo0002ooooo`03o`3jV_ooooooo`0000Gooooo00?o0?ZJool00?l0nYX00_ooool00ol0nY[oo`00
ooooo`0Fooooo`;o0?ZJ1Oooool00ol0nY[oo`00ool00002ooooo`09o`3jV_l00?ooo`00ool00?oo
ooooo`00ooooool0nY[oo`0000?ooooo0ol00002ooooo`03o`3jV_oo003ooooo00Wooooo00?o0000
ooooooooool09Oooool01?l0003o0?ZJooooool0nYX2ooooo`07o`3jV_oooooo0?ZJo`3jV_oo003o
ooooo`00o`03ooooo`08o`3jV_ooooooooooo`3jV_oo003o0?ZJool00?l0nYXAooooo`04o`3jV_oo
oooo0?ZJo`3jVPGooooo00Go0?ZJool00?l00?ooo`00o`3jVP06ooooo`03o`3jV_oooooo0?ZJ00co
oooo00?o0?ZJooooool0nYX02?ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ01Wooooo00Co0?ZJoooo
oooooooooooo0_l0nYX9ooooo`03o`00oooooooooooo00Gooooo00Go0?ZJool00?l0nY[o0?ZJool0
000;ooooo`;o00009?ooool2o`0000?ooooo00?o0?ZJoooooooo00000_oo00001_l0nY[oooooo`3j
V_l0nY[oooooo`3jVPGooooo00?o0?ZJooooool0nYX02_ooool2o`3jVQkooooo00Co0?ZJool00?oo
003o0?ZJ4oooool01?l0nY[oo`00ool00?l0nYXJooooo`03ool00?l00?ooo`0001Kooooo0_l0nYX8
ooooo`;o0?ZJ0_l0000jooooo`00?oooool01?l0003oooooooooool0nYX3ooooo`05o`3jV_oooooo
oooooooooooo00000_l0nYX2ooooo`0:ool00?oooooo0?ZJoooooooo003o0?ZJooooool0nY[ooooo
ool000cooooo0ol00002o`3jVP0;ooooool0nY[o003oool00?l0nY[oooooo`3jV_oo003o003oo`3j
V_ooool00_l0nYX01Ooo003o0?ZJoooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooo`3jVP02ooooo`03ool00?oooooooooo00;o0?ZJ00?oo`00ooooooooool00oooool0
0ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003ooooo01Kooooo0_l0nYX5ooooo`03o`3jV_l00?oo
o`0000?o0?ZJ00So003oool00?l00?oo003oool00?oooooo0?ZJool000?ooooo0ol00002ooooo`03
o`3jV_oo003ooooo00Wooooo00?o0000ooooooooool09Oooool01?l0003o0?ZJooooool0nYX2oooo
o`06o`3jV_oooooo0?ZJo`3jV_oooooo003o1?ooool02?l0nY[oooooooooool0nY[oo`00o`00oooo
003o0?ZJ4Oooool00ol0nY[oooooo`3jVP06ooooo`05o`3jV_oo003oo`00o`00ool0nYX01_ooool0
0ol0nY[oooooo`3jVP0<ooooo`?o0?ZJ2?ooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01Wooooo00Co
0?ZJoooooooooooooooo0_l0nYXBooooo`04o`3jV_oo003o0?ZJool000cooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`02ooooo`03o`3jV_ooooooo`0000;oo`0000Ko0?ZJooooool0
nY[o0?ZJooooool0nYX5ooooo`03o`3jV_oooooo0?ZJ00[ooooo0_l0nYXNooooo`04o`3jV_oooooo
o`00o`3jVQ?ooooo00?o0?ZJooooool0nYX06oooool00ol0nY[oo`00ool0000Fooooo`;o0?ZJ2?oo
ool2o`3jVP03ooooool0003ooooo03Wooooo000oooooo`;o000000?oooooo`3jV_ooool00_ooool0
1ol0nY[oooooooooooooooooo`00ooooool00?l00_ooool01ooo003oooooo`3jV_ooooooo`00o`3j
V_ooool00_l0nYX00ooo003oooooooooo`0;ooooo`0;o`3jV_oo003oooooo`3jV_oooooo0?ZJool0
0?oooooo0?ZJooooool0nYX00_oo00001_l0nY[oooooo`3jV_l0nY[oo`00o`3jVP;ooooo0_l0nYX0
0ooooooo0?ZJooooo`08ooooo`05o`3jV_ooooooo`00ool00?ooool00_l0nYX00ooo003ooooooooo
o`04ooooo`06o`3jV_oo003oooooooooool0nY[oo`005oooool2o`3jVPGooooo00ko0?ZJo`000?l0
003o0000ooooool00?ooo`00o`00oooooooo003oool00?oooooo0?ZJool000?o0?ZJ0ol00002oooo
o`03o`3jV_oo003ooooo00Sooooo0_l0000Wooooo`04o`000?oooooo0?ZJo`3jVP;ooooo00Ko0?ZJ
ooooool0nY[o0?ZJooooool00?l4ooooo`08o`3jV_ooooooooooo`3jV_oo003o003oool00?l0nYXA
ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Go0?ZJoooooooo003o003oo`3jVP06ooooo`03o`3jV_oo
oooo0?ZJ00cooooo00?o003oo`3jV_l0nYX02?ooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01Wooooo
00?o0?ZJooooooooool05Oooool01?l0nY[oo`00o`3jV_oo000<ooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool00_ooool00ol0nY[oooooool00002ool00003o`3jV_oooooo0?ZJ00So
oooo00?o0?ZJooooool0nYX02_ooool2o`3jVQkooooo00Co0?ZJooooool00?oo0?ZJ5?ooool2o`3j
VQ_ooooo00?o0?ZJool00?oo00005_ooool2o`3jVP_ooooo00?o0000ooooooooool0>?ooool003oo
oooo00Go0000ooooooooooooooooo`3jVP02ooooo`07o`3jV_ooooooooooooooool0nY[oo`00o`00
o`02ooooo`07ool00?ooooooooooo`3jV_oo003o0?ZJooooo`02o`3jVP03ool00?oooooooooo00co
oooo00ko0?ZJool00?l0nY[o0?ZJoooooooo003oooooo`3jV_oooooo0?ZJoooooooo003o0?ZJoooo
o`;o0?ZJ00?oo`00ooooooooool00_ooool00ol0nY[oooooo`3jVP09ooooo`05o`3jV_oooooooooo
ool00?ooool00_l0nYX00ooo003oooooooooo`04ooooo`06o`3jV_oo003oooooooooool0nY[oo`00
6?ooool00ol0nY[oooooooooo`03ooooo`05o`3jV_l0003o0000o`000?l00?l00_oo0002ooooo`0;
o`00oooo003oooooo`3jV_oo003o0?ZJooooool0nY[oooooool00?l0nYX00_ooool00ooo003o0?ZJ
ooooo`09ooooo`03o`000?oooooooooo02Gooooo0_l00002o`3jVP;ooooo00Ko0?ZJooooool0nY[o
0?ZJooooool00?l4ooooo`08o`3jV_ooooooooooo`3jV_oo003o003oool00?l0nYXBooooo`03o`3j
V_oooooooooo00Gooooo00Go0?ZJoooooooooooo003oo`3jVP06ooooo`03o`3jV_oooooo0?ZJ00go
oooo0_l0nYX8ooooo`05o`3jV_oo003o0?ZJool00?l0nYX06Oooool00ol0nY[oooooooooo`0Eoooo
o`04o`3jV_oo003oo`00o`3jVP_ooooo0_l0000Tooooo`;o00000oooool00ol0nY[oooooool00002
ool00003o`3jV_oooooooooo00Sooooo00?o0?ZJooooool0nYX0:oooool00ol0nY[oooooo`3jVP0D
ooooo`;o0?ZJ6oooool00ol0nY[oo`00o`3jVP0Fooooo`03o`3jV_oooooooooo00Wooooo0_l0000j
ooooo`00<_ooool3o`0000Cooooo0_l00004ooooo`05o`000?ooooooooooooooool0nYX00_ooool0
1ol0nY[ooooooooooooooooo0?ZJool00?l00?l00_ooool01_oo003oooooooooool0nY[oo`00oooo
o`?o0?ZJ00?oo`00ooooooooool03?ooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooo0?ZJ
00;ooooo00Go0?ZJool00?l0nY[oooooo`3jVP02ool000Cooooo00?o0?ZJooooool0nYX02Oooool2
o`3jVP06ooooool00?ooo`00o`3jV_oo003o0?ZJ1_ooool01_l0nY[oo`00o`3jV_ooooooo`00o`3j
VQSooooo00?o0?ZJooooooooool00oooool01_l0nY[o0000o`000?l0003o003oool000?ooooo00Co
003oool00?l0nY[oo`000_l0nYX01Ooooooo0?ZJo`3jV_l0nY[oo`0000;ooooo00?oo`00o`3jV_oo
ool02Oooool00ol0003oooooooooo`0Uooooo`08o`000?oooooo0?ZJooooool0nY[oooooo`3jV_oo
ool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Wo0?ZJooooooooooooooooo`3jV_oo003o003oool0
0?l0nYX06_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00?o0?ZJooooool0nYX05oooool0
1?l0nY[oo`00o`3jV_oo000Jooooo`03o`3jV_oooooooooo01Kooooo0_oo00000ol0nY[ooooooooo
o`0:ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooool0
0002ool00003o`3jV_oooooooooo00Sooooo00?o0?ZJooooool0nYX0:oooool00ol0nY[oooooo`3j
VP0Dooooo`;o0?ZJ6oooool00ol0nY[oo`00o`3jVP0Fooooo`03o`3jV_oooooooooo00[ooooo00?o
0000ooooooooool0>?ooool003?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`05o`000?ooooooooooooooool0nYX00_ooool01ol0nY[ooooooooooooooooo0?ZJool0
0?l00?l00_ooool01_oo003oooooooooool0nY[oo`00o`00o`?o0?ZJ00?oo`00ooooooooool03?oo
ool02?l0nY[oo`00oooooooooooo003oool00?oooooo0?ZJ0_ooool01Ol0nY[oo`00o`00ool0nY[o
oooo00;oo`001?ooool00ol0nY[oooooo`3jVP0:ooooo`03o`3jV_oooooo003o00?oo`0000?o0?ZJ
ooooooooool01?ooool01_l0nY[oo`00o`3jV_ooooooo`00o`3jVQSooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooo`3jVP03ool000Cooooo00Coo`00o`3jV_oo003o0?ZJ0oooool2o`3jVP05
ool00?ooooooooooool00?l0nYX02_ooool00ol0003oooooooooo`0Uooooo`08o`000?oooooo0?ZJ
ooooool0nY[oooooo`3jV_ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Ko0?ZJoooooooooooo
ooooo`3jV_ooool2ool00003o`3jV_oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJ1_ooool0
0ol0nY[oooooo`3jVP0Hooooo`03ool00?l0nY[oo`0001[ooooo00?o0?ZJooooooooool05_ooool2
ool00003o`3jV_oooooooooo00[ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`02
ooooo`03o`3jV_ooooooo`0000;oo`0000?o0?ZJooooooooool02?ooool00ol0nY[oooooo`3jVP0[
ooooo`;o0?ZJ5Oooool2o`3jVQ_ooooo00?o0?ZJool00?l0nYX08oooool00ol0003oooooooooo`0h
ooooo`00<oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo0_l00002
ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00Ko0?ZJool00?ooooooooooool00?l0nYX2ooooo`03
o`3jV_oo003o003o00;o0?ZJ00?oo`00o`3jV_ooool03Oooool01_l0nY[oo`00ool00?ooooooo`00
ooooo`;o0?ZJ0_ooool01Ol0nY[oo`00o`00ool0nY[ooooo00;oo`001?ooool00ol0nY[oooooo`3j
VP0:ooooo`04o`3jV_oooooo003oooooo`;oo`0000?o0?ZJooooooooool01Oooool01Ooo003o0?ZJ
oooooooo003o0?ZJ01Sooooo00?o0?ZJooooooooool01?ooool3o`3jVP?ooooo0ol0nYX01?oo003o
0?ZJool00?l0nYX3ooooo`;o0?ZJ00Goo`00ooooooooooooo`00o`3jVP09ooooo`;o00009oooool2
o`000006o`3jV_oooooo0?ZJooooool0nY[ooooo0_l0nYX00ol00?oo0?ZJo`3jVP02ooooo`06o`3j
V_ooooooooooooooool0nY[ooooo0_oo00000ol0nY[oooooooooo`0Iooooo`04o`3jV_oooooooooo
o`3jVPKooooo00?o0?ZJooooool0nYX06?ooool00ooo003oooooool0000Jooooo`03o`3jV_oooooo
oooo01Kooooo0_oo00000ol0nY[oooooooooo`09ooooo`;o00009?ooool2o`0000?ooooo00?o0?ZJ
oooooooo00000_oo00000ol0nY[oooooooooo`08ooooo`03o`3jV_oooooo0?ZJ02_ooooo0_l0nYXE
ooooo`;o0?ZJ6oooool00ol0nY[oooooo`3jVP0Rooooo`;o0000>_ooool003?ooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooooooool0nYX00_oo
ool01_l0nY[ooooooooooooooooo0?ZJool000;ooooo00Ooo`00o`3jV_ooooooooooo`3jV_oo003o
003o00;o0?ZJ00?oo`00o`3jV_ooool03_ooool01_l0nY[oo`00o`00oooo003oooooo`3jVP?ooooo
00Co0?ZJool00?l00?oooooo0_oo00000ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00_o
oooo00?o0?ZJo`00ooooool00_oo00000ol0nY[oooooooooo`05ooooo`05ool00?l0nY[oooooool0
0?l0nYX06?ooool00ol0nY[oooooooooo`04ooooo`?o0?ZJ0_ooool2o`3jVP03ooooool0nY[oo`00
00;oo`0000Co0?ZJoooooooooooooooo0_l0nYX01Ooo003o0?ZJoooooooo003o0?ZJ00[ooooo00?o
0000ooooooooool05oooool5o`0000?ooooo0_l00004ooooo`08o`000?oooooo0?ZJooooool0nY[o
ooooo`3jV_ooool2o`3jVP03o`00ool0nY[o0?ZJ00;ooooo00Ko0?ZJooooooooooooooooo`3jV_oo
ool2ool00003o`3jV_oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJ1oooool2o`3jVQSooooo
00?oo`00oooooooo00006_ooool00ol0nY[oooooooooo`0Fooooo`;oo`0000?o0?ZJooooooooool0
2_ooool00ol0003oooooooooo`0Eooooo`?o00001?ooool2o`0000Cooooo00?o0000ooooooooool0
0_ooool00ol0nY[oooooool00002ool00003o`3jV_oooooooooo00Sooooo00?o0?ZJooooool0nYX0
:oooool2o`3jVQGooooo0_l0nYXKooooo`03o`3jV_oooooo0?ZJ02?ooooo00?o0000ooooooooool0
>?ooool003?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`05o`00
0?ooooooooooooooool0nYX00_ooool01_l0nY[ooooooooooooooooo0?ZJo`00o`?oo`0000Ko0?ZJ
oooooooooooo0?ZJoooooooo0002o`3jVP03ool00?l0nY[ooooo00kooooo00Ko0?ZJool00?oo003o
o`00ooooool0nYX3ooooo`04o`3jV_ooooooo`00o`00o`;oo`0000?o0?ZJooooooooool00_ooool0
0ol0nY[oooooo`3jVP0;ooooo`03o`3jV_l00?oooooo00;oo`002?ooool01Ooo003o0?ZJoooooooo
003o0?ZJ01Sooooo00?o0?ZJooooooooool01Oooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo0ol0
00000ol0nY[oooooooooo`03ooooo`06o`3jV_oo003o0?ZJoooooooo003o0?ZJ2_ooool00ol0003o
ooooooooo`0Hooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool0
2_l0003oooooo`3jV_oooooo0?ZJooooool0nY[oooooo`3jV_ooool3o`3jVP;ooooo00Ko0?ZJoooo
ooooooooooooo`3jV_ooool2ool00003o`3jV_oooooooooo01Wooooo0_l0nYX00ooooooo0?ZJoooo
o`06ooooo`;o0?ZJ6?ooool2ool00003o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool05_oo
ool2ool00003o`3jV_oooooooooo00[ooooo00?o0000ooooooooool05?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03
o`3jV_ooooooo`0000;oo`002oooool00ol0nY[oooooo`3jVP0[ooooo`;o0?ZJ5Oooool2o`3jVQco
oooo0_l0nYXSooooo`03o`000?oooooooooo03Sooooo000booooo`;o00001?ooool01?l0003ooooo
ooooool00003ooooo`05o`000?ooooooooooooooool0nYX00_ooool01_l0nY[ooooooooooooooooo
0?ZJo`00o`;oo`0000Soooooo`3jV_ooooooooooo`3jV_ooooooo`00o`3jVP;oo`004?ooool01?l0
nY[oooooool00?ooool2o`3jVPCooooo00?o0?ZJool00?l00?l00ol00005ooooo`;o0?ZJ2oooool2
o`3jVP03oooooooo003oo`0000Sooooo00Goo`00o`3jV_ooooooo`00o`3jVP0Hooooo`03o`3jV_oo
oooooooo00Oooooo0_l0nYX3ooooo`?o000000?o0?ZJooooooooool00oooool01Ol0nY[oo`00o`3j
V_l0nY[oo`0000_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000?ooooo00[o0000ooooool0nY[oooooo`3jV_oooooo0?ZJooooool0nY[ooooo
0ol0nYX2ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ7?ooool00ol0nY[o
ooooo`3jVP07ooooo`;o0?ZJ6?ooool2ool00003o`3jV_oooooooooo01Sooooo00?o0?ZJoooooooo
ool05_ooool2o`3jVPgooooo00?o0000ooooooooool06?ooool01?l0003oooooooooool00002oooo
o`05o`000?ooooooooooooooool000001?ooool00ol0nY[oooooool00002ool000_ooooo00?o0?ZJ
ooooool0nYX0:oooool2o`3jVQGooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0R
ooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`000?oooooooooo00?ooooo0_l00004oooo
o`;o00000_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_l00?oooooo00;ooooo00Oo0?ZJ
ooooooooooooooooo`3jV_oo003o0?ZJ00;oo`004?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Go
oooo00?o0?ZJool00?l00?l00ol00005ooooo`;o0?ZJ3?ooool01?l0nY[o003oool00?oo0008oooo
o`05o`3jV_oo003oooooool00?l0nYX09oooool3o`000003o`3jV_oooooooooo00Cooooo00Coo`00
o`3jV_l0nY[oo`002_ooool2o`0001cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooooooo`;o000000_o0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJooooool0nY[ooooo
o`3jVP02ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ7?ooool2o`3jVPSo
oooo0_l0nYXHooooo`03o`3jV_oo003o0?ZJ03?ooooo0_l0nYX<ooooo`;o00006_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooooooo`;o00000oooool00ol0nY[oooooool00002
ool000_ooooo00?o0?ZJooooool0nYX0:oooool2o`3jVQGooooo00?o0?ZJooooooooool06oooool0
0ol0nY[oooooooooo`0Qooooo`;o0000>_ooool003oooooo00Go0000ooooooooooooooooo`3jVP02
ooooo`06o`3jV_ooooooooooooooool0nY[o003o0oooool01ol0nY[ooooooooooooooooo0?ZJool0
0?l0nYX00_oo000@ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo003o003o
00?o00001Oooool2o`3jVPcooooo0_l0nYX2ool000Sooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0X
ooooo`;o0?ZJ1oooool01?l0nY[oo`00o`3jV_oo000;ooooo`03o`000?oooooooooo01Oooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00Wo0000ooooool0
nY[oooooo`3jV_oooooo0?ZJooooool0nYX00oooool01?l0nY[oooooooooool0nYX4ooooo`04o`3j
V_ooooooooooo`3jVQcooooo0_l0nYX8ooooo`;o0?ZJ6?ooool00ol0nY[o003oo`3jVP0cooooo`;o
0?ZJ3Oooool00ol0003oooooooooo`0Dooooo`Co00000oooool01?l0003oooooooooool00003oooo
o`03o`000?oooooooooo00;ooooo00?o0?ZJoooooooo00000_oo000;ooooo`?o0?ZJ:oooool00ol0
nY[oooooooooo`0booooo`03o`3jV_oooooooooo02;ooooo00?o0000ooooooooool0>?ooool003oo
oooo00Go0000ooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00;ooooo00Go0?ZJoooo
ooooooooooooo`3jVP03ooooo`03o`3jV_oo003o003o00;oo`004Oooool01?l0nY[oooooo`3jV_l0
nYX5ooooo`05o`3jV_ooooooo`00ool00?l0nYX01_ooool2o`3jVPgooooo00?o0?ZJool00?oo0000
2?ooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ037ooooo00Co0?ZJool00?l0nY[oo`002oooool00ol0
003oooooooooo`0Gooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0003ooooo`09o`000?oooooo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00Co0?ZJoooo
oooooooo0?ZJ1?ooool01?l0nY[oooooooooool0nYXMooooo`03o`3jV_oooooooooo00Kooooo0_l0
nYXHooooo`03o`3jV_l00?oo0?ZJ03?ooooo0_l0nYX=ooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo
00?o0?ZJoooooooo00000_oo000<ooooo`03o`3jV_oooooooooo02[ooooo00?o0?ZJooooooooool0
<_ooool00ol0nY[oooooooooo`0Rooooo`03o`000?oooooooooo03Sooooo000oooooo`05o`000?oo
ooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0
nYX00oooool00ol0nY[oo`00o`00o`02ool0017ooooo00?o0?ZJooooool0nYX01_ooool01Ol0nY[o
ooooo`00ool00?oo0?ZJ00Kooooo0_l0nYX=ooooo`03o`00oooo003oo`0000Sooooo00Go0?ZJool0
0?l0nY[oo`00o`3jVP0aooooo`04o`3jV_oo003oo`00o`3jVP_ooooo00?o0000ooooooooool06?oo
ool3o`0000Cooooo0_l00004ooooo`;o000000Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00?o
oooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[oooooooooool0nYXVooooo`;o0?ZJ6?ooool0
0ol0nY[oooooo`3jVP0dooooo`03o`3jV_oooooooooo00[ooooo0_l0000Fooooo`Go00000oooool2
o`0000Cooooo0_l00003ooooo`03o`3jV_ooooooo`0000;oo`003?ooool00ol0nY[oooooooooo`23
ooooo`;o0000>_ooool003oooooo0_l00002ooooo`04o`3jV_ooooooooooo`3jVPGooooo00Co0?ZJ
oooooooooooo0?ZJ0oooool00ol0nY[oo`00o`00o`02ool0017ooooo0ol0nYX6ooooo`05o`3jV_oo
ooooooooo`00ool0nYX01_ooool2o`3jVPgooooo0ol00008ooooo`04o`3jV_oo003oooooool003;o
oooo00Co0?ZJool00?oo003o0?ZJ2_ooool2o`0002Oooooo00Wo0000ooooool0nY[oooooo`3jV_oo
oooo0?ZJooooool0nYX01?ooool00ol0nY[oooooo`3jVP04ooooo`04o`3jV_ooooooooooo`3jVRKo
oooo0_l0nYXHooooo`03o`3jV_oooooo0?ZJ04;ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`02ooooo`03o`3jV_oooooooooo00;oo`003?ooool00ol0nY[oooooooooo`24ooooo`03
o`000?oooooooooo03Sooooo000oooooo`05o`000?ooooooooooooooool0nYX00_ooool00ol0nY[o
ooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJoooooooo00000_oo000Joooo
o`05o`3jV_ooooooooooooooool0nYX01_ooool2o`3jVPgooooo0ol00008ooooo`04o`3jV_oo003o
ooooool003;ooooo00Co0?ZJool00?oo003o0?ZJ2oooool00ol0003oooooooooo`0Uooooo`09o`00
0?oooooo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00Cooooo00?o0?ZJooooool0nYX01?ooool0
1?l0nY[oooooooooool0nYXVooooo`;o0?ZJ6?ooool2o`3jVT?ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00;oo`003?ooool00ol0nY[ooooooooo
o`24ooooo`03o`000?oooooooooo03Sooooo000oooooo`05o`000?ooooooooooooooool0nYX00_oo
ool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJoooooooo0000
0ol0000Jooooo`04o`3jV_ooooooooooo`3jVPKooooo0_l0nYX=ooooo`?o00002Oooool2ool00003
o`3jV_oooooooooo037ooooo0_oo00000ol0nY[oooooooooo`09ooooo`03o`000?oooooooooo02Go
oooo0_l000001ol0nY[oooooo`3jV_oooooo0?ZJooooool0nYX01?ooool2o`3jVPGooooo0_l0nYX0
0ooooooo0?ZJooooo`0Uooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`10ooooo`;o00009?ooool2
o`0000?ooooo00Go0?ZJooooooooooooo`00o`3jVP2Booooo`;o0000>_ooool003oooooo00Go0000
ooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ
0oooool00ol0nY[oooooool00003o`0001[ooooo00Co0?ZJoooooooooooo0?ZJ1_ooool2o`3jVQWo
oooo00?o0?ZJool00?l0nYX0<oooool00ol0nY[oo`00o`3jVP0;ooooo`03o`000?oooooooooo02Go
oooo00Wo0000ooooool0nY[oooooo`3jV_oooooo0?ZJooooool0nYX01?ooool2o`3jVPKooooo00?o
0?ZJooooool0nYX09_ooool2o`3jVUgooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`02ooooo`05o`3jV_ooooooooooool00?l0nYX0Toooool00ol0003oooooooooo`0hooooo`00?ooo
ool2o`0000?ooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[oooooooooool0nYX3ooooo`03o`3j
V_ooooooo`0000?o00006_ooool3o`3jVPSooooo00?o0?ZJooooooooool05oooool00ol0nY[oo`00
o`3jVP0cooooo`;o0?ZJ2oooool2o`0002Oooooo00Wo0000ooooool0nY[oooooo`3jV_oooooo0?ZJ
ooooool0nYX01?ooool2o`3jVPOooooo0_l0nYXVooooo`;o0?ZJGOooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo00;ooooo00Go0?ZJooooooooooooo`00o`3jVP2Cooooo`03o`000?oo
oooooooo03Sooooo000oooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooool0nYX01Oooool0
1?l0nY[oooooooooool0nYX3ooooo`05o`3jV_ooooooooooo`00ool0nYX07?ooool2o`3jVR;ooooo
00?o0?ZJo`00ool0nYX0<oooool2o`3jVPcooooo00?o0000ooooooooool09Oooool2o`000007oooo
ool0nY[o0?ZJooooool0nY[oooooo`3jVP04ooooo`;o0?ZJ1oooool2o`3jVROooooo00?o0?ZJoooo
ooooool0F_ooool2o`0002Cooooo0_l00003ooooo`03o`3jV_oooooooooo00;o0?ZJT_ooool2o`00
03[ooooo000oooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[o
ooooooooool0nYX3ooooo`05o`3jV_ooooooooooooooool0nYX0@?ooool00ol0nY[oooooo`3jVP0c
ooooo`;o0?ZJ3?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00;o0?ZJ00Cooooo
o`3jV_oooooo0?ZJ1?ooool2o`3jVPOooooo0_l0nYZ5ooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool00_ooool00ol0nY[oooooooooo`02o`3jVY?ooooo00?o0000ooooooooool0>?oo
ool003oooooo00?o0000ooooooooool00_ooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_oooooo
ooooo`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ@?ooool00ol0nY[oooooo`3jVP0cooooo`;o0?ZJ
3?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00;o0?ZJ00Coooooo`3jV_oooooo
0?ZJ1?ooool2o`3jVPOooooo0_l0nYZ5ooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool00_ooool00ol0nY[oooooooooo`02o`3jVY?ooooo00?o0000ooooooooool0>?ooool003oooooo
0_l00003ooooo`03o`3jV_oooooo0?ZJ00Gooooo00Co0?ZJoooooooooooo0?ZJ1?ooool01?l0nY[o
ooooooooool0nYY0ooooo`;o0?ZJ@Oooool2o`0002Oooooo0_l000001ooooooo0?ZJo`3jV_oooooo
0?ZJooooool0nYX03Oooool2o`3jVXCooooo0_l0000Tooooo`;o00000oooool01Ol0nY[ooooooooo
oooooooo0?ZJ09;ooooo0_l0000jooooo`00<Oooool5o`0000?ooooo0_l00004ooooo`03o`000?oo
oooooooo00;ooooo00?o0?ZJooooool0nYX01_ooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oo
oooo0?ZJ04;ooooo00?o0?ZJooooooooool0@?ooool00ol0003oooooooooo`0Hooooo`?o00001?oo
ool2o`0000Cooooo00?o0000ooooooooool00_l0nYX01?oooooo0?ZJooooool0nYX=ooooo`;o0?ZJ
QOooool00ol0003oooooooooo`0Eooooo`?o00001?ooool2o`0000Cooooo00?o0000ooooooooool0
0_ooool00ol0nY[oooooooooo`2Eooooo`03o`000?oooooooooo03Sooooo000booooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03
o`3jV_oooooo0?ZJ00Kooooo00?o0?ZJooooool0nYX01?ooool3o`3jVXGooooo00?o0000oooooooo
ool05oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`02o`3jVP04ooooool0nY[oooooo`3jVPgooooo0_l0nYZ5ooooo`03o`000?oo
oooooooo01Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`2Eooooo`03o`000?oooooooooo03So
oooo000cooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`02ooooo`04o`3jV_oooooo0?ZJo`0000Gooooo00?o0?ZJooooool0nYX01?ooool3o`3j
VP03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Koooo
o`04o`000?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`000002ooooo`;o0?ZJ00Co
ooooo`3jV_oooooo0?ZJ1oooool00ol0003oooooooooo`03ooooo`;o0?ZJ00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool01?l0
nY[oooooooooool00007ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Sooooo000dooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooooooool5o`000003o`3jV_l0003o0?ZJ00Ko000000?o
0?ZJo`000?l0nYX01?l00003o`3jVXKo00006oooool2o`0000?ooooo00Co0000oooooooooooo0000
0oooool3o`0000;o0?ZJ00Co0000o`3jV_l0003o0?ZJ3Ol00002o`3jVXKo00005_ooool4o`0000?o
oooo00Co0000oooooooooooo00000oooool5o`000003o`3jV_l0003o000009Ko0000>_ooool0037o
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`000;kooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo0000foooool0037ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`000;[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`000;Sooooo00?o0000ooooooooool00oooool01?l0003oooooooooool0003Kooooo`00<_ooool3
o`0000Cooooo0_l0002looooo`?o00001?ooool2o`000;[ooooo0_l00004ooooo`;o0000g?ooool0
0?ooooooD?ooool3o`000?ooooooCOooool00?ooooooDOooool00ol0003oooooooooo`3oooooodco
oooo002:ooooo`;o000000?oooooo`000?l00000`_ooool00ol0003oooooooooo`2mooooo`Go0000
R?ooool008_ooooo00?o0000ooooool00000`oooool00ol0003oooooooooo`2nooooo`04o`000?oo
ooooooooo`0008Sooooo002<ooooo`03o`000?oooooooooo0<7ooooo00?o0000ooooool00000`?oo
ool00ol0003oooooooooo`28ooooo`00Roooool00ol0003oooooo`000032ooooo`03o`000?oooooo
00000;kooooo00Co0000oooooooooooo0000ROooool008[ooooo0_l000000ooooooo0000o`000030
ooooo`;o000000?oooooo`000?l00000_Oooool5o`0008Sooooo003oooooooooooooX?ooool00?oo
oooooooooonPooooo`00oooooooooooooj3ooooo003oooooooooooooX?ooool00?oooooooooooonP
ooooo`00oooooooooooooj3ooooo003oooooooooooooX?ooool00?oooooooooooonPooooo`00oooo
oooooooooj3ooooo003oooooooooooooX?ooool00?oooooooooooonPooooo`00oooooooooooooj3o
oooo003oooooooooooooX?ooool00?oooooooooooonPooooo`00oooooooooooooj3ooooo003ooooo
ooooooooX?ooool00?oooooooooooonPooooo`00oooooooooooooj3ooooo003oooooooooooooX?oo
ool00?oooooooooooonPooooo`00oooooom6ooooo`Go000000Goooooo`000?l0003o0000ooooo`05
o`000?ooooooBoooool00?ooooooAoooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool0oooooom:ooooo`00oooooom7ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3ooooood[ooooo003ooooo
odOooooo0ol00003ooooo`;o00001?ooool3o`000?ooooooB_ooool00?ooooooAoooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooom:ooooo`00
oooooom7ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0003oooooodWooooo003oooooodKooooo1Ol000001Ooooooo0000o`000?l0003o
oooo00Oo0000oooooom9ooooo`00oooooooooooooj3ooooo003oooooooooooooX?ooool00001\
\>"],
  ImageRangeCache->{{{0, 669.75}, {275.375, 0}} -> {-0.200283, -0.0309084, \
0.00507737, 0.00507737}, {{39.4375, 236.375}, {269.25, 147.562}} -> {-387.87, \
3.23475, 6.39284, 0.103335}, {{236.375, 433.312}, {269.25, 147.562}} -> \
{-1646.86, 23.2347, 6.39284, 0.103335}, {{433.312, 630.25}, {269.25, \
147.562}} -> {-2886.67, -1.4122, 6.39284, 0.0826681}, {{39.4375, 236.375}, \
{147.562, 25.8125}} -> {-406.49, -101.655, 6.38888, 0.516354}, {{236.375, \
433.312}, {147.562, 25.8125}} -> {-1664.7, -115.986, 6.38888, 0.619624}, \
{{433.312, 630.25}, {147.562, 25.8125}} -> {-2903.74, -85.9861, 6.38888, \
0.619624}}],

Cell[BoxData[
    RowBox[{\(Graphics::"gptn"\), \(\(:\)\(\ \)\), "\<\"Coordinate \
\\!\\(\\(\\(-22.921498521129628`\\)\\) - \\(\\(29.514863584618034`\\\\ \
\[ImaginaryI]\\)\\)\\) in \\!\\({46.`, \\(\\(\\(\\(-22.921498521129628`\\)\\) \
- \\(\\(29.514863584618034`\\\\ \[ImaginaryI]\\)\\)\\)\\)}\\) is not a \
floating-point number. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Graphics::gptn\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Graphics::"gptn"\), \(\(:\)\(\ \)\), "\<\"Coordinate \
\\!\\(\\(\\(-23.160831110821054`\\)\\) - \\(\\(48.314676314811344`\\\\ \
\[ImaginaryI]\\)\\)\\) in \\!\\({47.`, \\(\\(\\(\\(-23.160831110821054`\\)\\) \
- \\(\\(48.314676314811344`\\\\ \[ImaginaryI]\\)\\)\\)\\)}\\) is not a \
floating-point number. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Graphics::gptn\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Graphics::"gptn"\), \(\(:\)\(\ \)\), "\<\"Coordinate \
\\!\\(\\(\\(-22.8990607073307`\\)\\) - \\(\\(57.85600693398073`\\\\ \
\[ImaginaryI]\\)\\)\\) in \\!\\({48.`, \\(\\(\\(\\(-22.8990607073307`\\)\\) - \
\\(\\(57.85600693398073`\\\\ \[ImaginaryI]\\)\\)\\)\\)}\\) is not a \
floating-point number. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Graphics::gptn\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Graphics :: \\\"gptn\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SetDirectory["\</HermannTeX/Amsterdam/Neapel/Graphiken/\>"]\)], "Input"],

Cell[BoxData[
    \("/HermannTeX/Amsterdam/Neapel/Graphiken"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Export["\<EKF.pdf\>", gEKF, ImageSize \[Rule] Automatic]\)], "Input"],

Cell[BoxData[
    RowBox[{\(Graphics::"gptn"\), \(\(:\)\(\ \)\), "\<\"Coordinate \
\\!\\(\\(\\(-22.921498521129628`\\)\\) - \\(\\(29.514863584618034`\\\\ \
\[ImaginaryI]\\)\\)\\) in \\!\\({46.`, \\(\\(\\(\\(-22.921498521129628`\\)\\) \
- \\(\\(29.514863584618034`\\\\ \[ImaginaryI]\\)\\)\\)\\)}\\) is not a \
floating-point number. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Graphics::gptn\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Graphics::"gptn"\), \(\(:\)\(\ \)\), "\<\"Coordinate \
\\!\\(\\(\\(-23.160831110821054`\\)\\) - \\(\\(48.314676314811344`\\\\ \
\[ImaginaryI]\\)\\)\\) in \\!\\({47.`, \\(\\(\\(\\(-23.160831110821054`\\)\\) \
- \\(\\(48.314676314811344`\\\\ \[ImaginaryI]\\)\\)\\)\\)}\\) is not a \
floating-point number. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Graphics::gptn\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Graphics::"gptn"\), \(\(:\)\(\ \)\), "\<\"Coordinate \
\\!\\(\\(\\(-22.8990607073307`\\)\\) - \\(\\(57.85600693398073`\\\\ \
\[ImaginaryI]\\)\\)\\) in \\!\\({48.`, \\(\\(\\(\\(-22.8990607073307`\\)\\) - \
\\(\\(57.85600693398073`\\\\ \[ImaginaryI]\\)\\)\\)\\)}\\) is not a \
floating-point number. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Graphics::gptn\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Graphics :: \\\"gptn\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    \("EKF.pdf"\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["SNF (without terms 1/4 f'' M4 f'')", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF2[{ZM, X}, Theta+1, 
\t     {driftLorenzX, DdriftLorenzX,DDdriftLorenzX,diffusionLorenzX, \
hLorenzX, DhLorenzX, RLorenzX, mueLorenzX,sigmaLorenzX,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{6.233333333333121*Second, Null}\
\>", "\<\
{6.23333 \
Second, Null}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["YF//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{1001, 6}\
\>", "\<\
{1001, 6}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{146.60189526077576, 210.0567470688367, \
250.1448862633178, 260.0111266167884, 86.93804040821321, \
38.421051671157855}\
\>", "\<\
{146.602, 210.057, 250.145, 260.011, 86.938, \
38.4211}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
 {{0.7924047543155442, 0.7535832399176229, \
-2.2518978442923574, -8.050977273487419, 2.5176901192422987,\\
  1.0672058894486671}, 
 {4.565384951385872, 6.596352744693432, 7.578846235964292, \
1.6492460879455864, 1.1008672314552692,\\
  0.5794601785583305}}\
\>", "\<\
{{0.792405, 0.753583, -2.2519, -8.05098, \
2.51769, 1.06721}, {4.56538, 6.59635, 7.57885, 1.64925, 1.10087, \
0.57946}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,25},{20,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.01{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-30, 20}, {-30, 30}, {0, 60}, {5, 25}, {20, 35}, \
{0, 8}}\
\>", "\<\
{{-30, 20}, {-30, 30}, {0, 60}, {5, 25}, {20, 35}, {0, 8}}\
\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gSNF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],PlotLabel->\"SNF\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {21, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {21, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {21, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {2}
Dimension der Daten  {2, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {2}
Dimension der Daten  {2, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {2}
Dimension der Daten  {2, 2}\
\>", "Print",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PICT", "\<\
=/@020070JT3o@0A0_l<0?ooool01`0000P000?m0001Z@000000000N00402P08
00L1Z@?m09X0003oSmP000000J43mP0000@0000004P0E@1804@0400P00<02000
000KR>jD000000000001X@?f00P01`6Y0od0901;POn1oh7oSOon00?o003on@21
oh7oPOn1oh7oPOn1oi[ooP03o`00ooT0POn1oh7oPOn1oh7oPOnJooh00ol00?oi
087oPOn1ohko06>1oh7oPOn>o`l0ool0ool00?l0ool0ool0POn1oh7oPOn1oh7o
POnKo`l0ool0ool00?l0ool0ool0POn1oh7oPOn1oh7oPOnKo`l0ool0ool00?l0
ool0ool0POn1oh7oS_l0E87oPOn1ohko003lo`H00?l0ool0POn1oh7oPOn1oh7o
POnHo`00o?l6003o0?oo087oPOn1oh7oPOn1oh7oV?l00?co1P00o`3oo`21oh7o
POn;o`1JPOn1oh7oSOl1003no`D0o`00ooon087oPOn1oh7oPOn1oh7oVOl1003n
o`D0o`00ooon087oPOn1oh7oPOn1oh7oVOl1003no`D0o`00ooon087oPOn1ohgo
0561oh7oPOn;o`T0ool0o`00ool0POn1oh7oPOn1oh7oPOnEo`T0ool0o`00ool0
POn1oh7oPOn1oh7oPOnEo`T0ool0o`00ool0POn1oh7oRol0FX7oPOn1ohko303o
o`3oo`3oo`3oo`21oh7oPOn1oh7oPOn1oiSo303oo`3oo`3oo`3oo`21oh7oPOn1
oh7oPOn1oiSo303oo`3oo`3oo`3oo`21oh7oPOn;o`1GPOn1oh7oS_on007oooh0
0_l0ooh0POn1oh7oPOn1oh7oPOnIooh00OoooP02o`3ooP21oh7oPOn1oh7oPOn1
oiWooP01ooon00;o0?on087oPOn1ohco0321oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oioo0321oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0<87o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oioo
0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
Wol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0IX7o]Ol4003o0021oh7oe_l4003o
0021oh7of?ol087oPOn1onko1000o`00POn1omKo1000o`00POn1omSoo021oh7o
POo^o`@00?l0087oPOoFo`@00?l0087oPOoHoo`0POnjo`1SPOndo`80o`21oh7o
e?l20?l0POn1omOo0`3oo`21oh7oPOo/o`80o`21oh7oe?l20?l0POn1omOo0`3o
o`21oh7oPOo/o`80o`21oh7oe?l20?l0POn1omOo0`3oo`21okWo05B1ok?o0021
oh7odol20?l0POn1omGo0021oh7oPOoZo`00POn1om?o0P3o087oPOoEo`00POn1
oh7oj_l0087oPOoCo`80o`21oh7oeOl0087o^?l0GH7o]?l20?l0POn1om?o0021
oh7oeOl30?oo087oPOn1ongo0P3o087oPOoCo`00POn1omGo0`3oo`21oh7oPOo]
o`80o`21oh7odol0087oPOoEo`<0ool0POnjo`1JPOneo`@00?l0087oPOoDo`00
POn1omKoo021oh7oPOo^o`@00?l0087oPOoDo`00POn1omKoo021oh7oPOo^o`@0
0?l0087oPOoDo`00POn1omKoo021ok[o03J1oh7oPOn4o`00POn1oh7oPOn1oh7o
POn<o`00POn1oh7oPOn1oh7oPOn<o`00POn1oh7oROl0=X7oPOn1ohGooP21oh7o
POn1oh7oPOn1ohkooP21oh7oPOn1oh7oPOn1ohkooP21oh7oPOn:o`1naOon0?go
0@00POn1omWooP3mo`40087oPOoLo`400?go0@00POn1oh7ol_on0?go0@00POn1
omWooP3mo`40087oPOoLo`400?go0@00POn1oh7ol_on0?go0@00POn1omWooP3m
o`40087oPOoLo`400?go0@00POn1ojko09o6o`00o_l60?oo0?oo087oPOoKo`00
o_l60?oo0?oo087oPOoNo`00o?l30?oo087oPOn1ooCo003no`H0ool0ool0POn1
om_o003no`H0ool0ool0POn1omko003lo`<0ool0POn1oh7om?l00?ko1P3oo`3o
o`21oh7ofol00?ko1P3oo`3oo`21oh7og_l00?co0`3oo`21oh7o[ol0f/Ko003n
o`H0ool0ool0mOon007oooh0POn1on_o1P3oo`3oo`3gooh00?on087oPOo`o`00
nol30?oo0?Com`3jooh0POn1oiGo003no`H0ool0ool0mOonnP7oookjPOn1on_o
1P3oo`3oo`3gookj0?onnX7oPOo`o`00nol30?oo0?Como[jookjPOn1oiGo003n
o`H0ool0ool0mOonVP7ooojJPOn1on_o1P3oo`3oo`3goojJ0?onVX7oPOo`o`00
nol30?oo0?Comi[joojJPOn1om3o0=[3o`00o_l30?oo0?coP@210?P0iol1003n
o`<0ool0oOn10840n03/ood0o_l30?oo0?coP@210?P0POl2ool0o_l30?oo0?co
nP3nnP400?kjP@270>Oo0@00o_l30?oo0?gon`3nnP00o_Z108D0k?om0?ko0`3o
o`3looT0mo[j0?kjP@2D087o0_oo0?ko0`3oo`3looX0oYX1003nVX40Q`3Wo`40
0?ko0`3oo`3moo/0oYX00?jJP@250>coo@3no`<0ool0o?oi0?NJnP3nVX40U02m
o`>0a?l00?go0`3oo`3lo`00noon007oooh0m_l00?Go003eo`00m?l00?Go003e
o`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003d
o`00mOl00>Go1P3oo`3oo`3mo`00o?on003oo@3do`00mOl00?Go003eo`00mOl0
0?Co003eo`00mOl00?Go003eo`00m?l00?Go003eo`00mOl00?Go003do`00mOl0
0?Go003eo`00k?l00?ko1P3oo`3oo`3lo`00n_og0?[ooP3fo`00mOl00?Co003e
o`00mOl00?Go003eo`00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003e
o`00m?l00?Go0021o`7o0?go0`3oo`3lo`00noonnP7oookjm_l00?Go003eo`00
m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00
mOl00?Go003do`00mOl00>Go1P3oo`3oo`3mo`00o?onnP3oo_X00?Co003eo`00
mOl00?Go003eo`00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00
mOl00?Co003eo`00mOl00?Go003/o`00o_l60?oo0?oo0?co003jooOjn_onn_Ko
003eo`00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co
003eo`00mOl00?Go003do`00mOl0087o0Ol0oOl30?oo0?co003koojJ0OoooY[f
o`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003e
o`00m?l00?Go003eo`00mOl00?Co003eo`00iOl60?oo0?oo0?go003loojJ0?on
VP00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co003e
o`00mOl00?Go003eo`00m?l00?Go003eo`00mOl00>co003no`H0ool0ool0o?l0
0?[omi[joojJm_l00?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl0
0?Go003eo`00m?l00?Go003eo`00mOl00?Co003eo`00_Ol1X<Go2@3oo`3oo`3o
o`3lo`00noon007oooh0g?l00<go003=o`00cOl00<go003Yo`00o_l60?oo0?oo
0?go003looh00?on0=Wo003=o`00cOl00<ko003=o`00k?l00?ko1P3oo`3oo`3l
o`00n_og0?[ooP3Yo`00cOl00<go003=o`00cOl0087o2@3oo`3oo`3oo`3lo`00
noonnP7oookjg?l00<go003=o`00cOl00<go003Yo`00o_l60?oo0?oo0?go003l
ookj0?onn]Wo003=o`00cOl00<ko003=o`00k?l00?ko1P3oo`3oo`3lo`00n_og
n_[oo_[Yo`00cOl00<go003=o`00cOl0087o2@3oo`3oo`3oo`3lo`00noonVP7o
oojJg?l00<go003=o`00cOl00<go003Yo`00o_l60?oo0?oo0?go003loojJ0?on
V]Wo003=o`00cOl00<ko003=o`00k?l00?ko1P3oo`3oo`3lo`00n_ogV_[ooY[Y
o`00cOl00<go003=o`00cOl00;go0?S6oo`0o_l1003ko`00noon007oooh0POn8
o`00j?on0?go0@00o?l00?cooP00oo`0POn8o`00joon0?go0@00nol00?[om`3j
ooh0POnEo`00P_ol0?ko0@00nol00?_oo_X1ooonnX7oR?l00>SooP3mo`400?co
003lookj0?olnX7oR?l00>_ooP3mo`400?_o003jooOjn_onnX7oUOl008;oo03n
o`400?_o003koojJ0OoooYZ1ohSo003Xooh0oOl1003lo`00o?onVP3oo9Z1ohSo
003[ooh0oOl1003ko`00n_ogV_[ooYZ1oiGo002mo`2[]_l00?coo@01ooon087o
R?l00=[o003looh00?ol087oR?l00=co003jooL0n_on087oUOl0087ol_l00?co
oOX1ooonnX7oR?l00=[o003lookj0?olnX7oR?l00=co003jooOjn_onnX7oUOl0
087ol_l00?cooIX1ooonVX7oR?l00=[o003loojJ0?olVX7oR?l00=co003jooNJ
n_onVX7oUOl00;go0:nfo`00o?om007oooh0POn8o`00f_l00?cooP00oo`0POn8
o`00g?l00?[oo03eooh0POnEo`00POobo`00o?omnP7oookjPOn8o`00f_l00?co
o_X0oocjPOn8o`00g?l00?[oo?[j0?coo_Z1oiGo0021oo;o003loofJ0OoooYZ1
ohSo003Jo`00o?onVP3oo9Z1ohSo003Lo`00n_olV_X0o?onVX7oUOl00;go0;Rf
o`00o?on0?kooP21ohSo003Jo`400?gooP00oo`0POn9o`400=co0@00nool0?Go
oP21oiKo0@00POobo`00o?onn_koo_Z1ohSo003Jo`400?goo_X0oocjPOn9o`40
0=co0@00nooln_P0o_onnX7oU_l10021oo;o003loojJo_onVX7oR?l00=[o0@00
oOonVP3oo9Z1ohWo0@00g?l1003koobJn03noojJPOnFo`400;go0;jfo`400?go
oP3nooh0POolood0T_l1003Jo`00o?on003oo021ohSo003Lo`00n_ol0?GooP21
oiGo0021oo;o0@00oOonn_koo_Z1oocooOZBo`400=[o003lookj0?olnX7oR?l0
0=co003joocjmP00ookjPOnEo`00POobo`400?gooY[noojJPOoloofJT_l1003J
o`00o?onVP3oo9Z1ohSo003Lo`00n_olV_H00?onVX7oUOl00;go0<>fo`00o?on
0?kooP21oocoo@2Yooh0k?l00=[o003looh00?ol087oR?l00=co003joo`0m?l1
0021oiGo0021oo;o003lookjo_onnX7oo?omnZWoo_[/o`00f_l00?coo_X0oocj
POn8o`00g?l00?[oo?[d007jnX7oUOl0087ol_l00?cooY[noojJPOoloofJZOon
V^co003Jo`00o?onVP3oo9Z1ohSo003Lo`00n_olV_@00IZJPOnEo`00_Ol0`;Ko
003looh0o_on087oo?om0:[oo@3/o`00f_l00?cooP00oo`0POn8o`00g?l00?[o
o03co`00POnEo`00POobo`00o?onn_koo_Z1oocooOZZoogjk?l00=[o003lookj
0?olnX7oR?l00=co003joocjl`00nX7oUOl0087ol_l00?cooY[noojJPOoloofJ
Z_omV^co003Jo`00o?onVP3oo9Z1ohSo003Lo`00n_olV_<009Z1oiGo002mo`36
]_l00?cooP3nooh0joom09Koo02[oo`0kOl00=[o003looh00?ol087oR?l00=co
003joo`0POn6o`00POobo`00o?onn_koo_[[ood0U_olnZ_oo?[]o`00f_l00?co
o_X0oocjPOn8o`00g?l00?[oo?[k007oooX0POnEo`00POobo`00o?onV_kooYZ1
oocoo9Z[oobJkOl00=[o003loojJ0?olVX7oR?l00=co003joobJn`01oooj087o
UOl00;go0=:fo`00o?on0?kooP3[ood0U_ok0:coo03]o`00f_l1003mooh00?ol
087oROl1003Lo`400?_oo021ohOo0@00POobo`00o?onn_koo_[[ood0U_olnP00
[?oln^go003Jo`400?goo_X0oocjPOn9o`400=co0@00nooln_/0oOol087oU_l1
0021oo;o003loojJo_onVX7oo?olVZ_oo9[]o`00f_l1003moojJ0?olVX7oROl1
003Lo`400?_oo9[k0?goo021oiKo0@00_Ol0c;Ko003looh0o_on0>_oo@2FooX0
[Ool0>go003Jo`00o?on007oood0POn8o`00g?l00?[oo021ohKo0021oo;o003l
ookjo_onn^_oo@2Foocj0@00[Ooln^go003Jo`00o?onnP7ooogjPOn8o`00g?l0
0?[oo?[l0?[ooP21oiGo0021oo;o003loojJo_onV^[ooP2FoobJZoolV^go003J
o`00o?onVP7ooofJPOn8o`00g?l00?[oo9[l0?[ooP21oiGo002mo`3K]_l1003m
ooh0o_on0>_oo02HooT0[Ool0>ko0@00f_l00?cooP01ooom087oR?l00=co003j
ooh00Ol0POn6o`00POobo`400?goo_[nookjjool09SonoX1002]oocjk_l1003J
o`00o?onnP7ooogjPOn8o`00g?l00?[oo_X1oo[l0?[ooP21oiGo0021oo;o0@00
oOonV_kooY[[oo`0V?okVZ_oo9[^o`400=[o003loojJ0OoooIZ1ohSo003Lo`00
n_onVP7oV_`0n_on087oUOl00;go0=Ffo`00o?on0?kooP3/oo/0V?oi0:goo03]
o`00f_l00?cooP01ooom087oR?l00=co003jooh00Ol0POn6o`00POobo`00o?on
n_koo_[/oo/0V?oknP400:goo?[]o`00f_l00?coo_X1ooomnX7oR?l00=co003j
ookj0Oojo03jooh0POnEo`00POobo`00o?onV_kooY[[oo`0V?okVZ_oo9[]o`00
f_l00?cooYX1ooomVX7oR?l00=co003joojJ0OnJo03jooh0POnEo`00_Ol0gKKo
003looh0o_on0>con`2Yooh0looi0:kon`3]o`00f_l00?cooP01ooom087oR?l0
0=co003jooh00Ol0POn6o`00POobo`00o?onn_koo_[/oo/0ZOon0??onoX1002^
oo_jkOl00=[o003lookj0OoooOZ1ohSo003Lo`00n_onnP7on_`0n_on087oUOl0
087ol_l00?cooY[noojJjool09SoniZ/oo^JkOl00=[o003loojJ0OoooIZ1ohSo
003Lo`00n_onVP7oV_`0n_on087oUOl00;go0?Vfo`00o?on0?kooP3/oo`0Z?on
0??o0@00o_on0:ko003mo`400>ko003Jo`00o?on007oood0POn8o`00g?l00?[o
oP01o`21ohKo0021oo;o003lookjo_onn^coo02Xooh0lol1n_[n00;j002^o`3j
o@01nP3^o`00f_l00?coo_X1ooomnX7oR?l00=co003jookj0Oojo03jooh0POnE
o`00POobo`00o?onV_kooY[Zooh0Uol1VY[n002J[?l0V_d009[]o`00f_l00?co
oYX1ooomVX7oR?l00=co003joojJ0OnJo03jooh0POnEo`00_Ol11kKo003looh0
o_on0>co0@00Y_ol0?Co003mooh0[_l00?go0@00k_l00=[o0@00oOon007oood0
POn9o`400=co0@00noon007o087oQol10021oo;o003lookjo_onn^coo02Yoo`0
m?l0n_d00_X00:ko0?[m007j0>ko003Jo`400?goo_X1ooomnX7oROl1003Lo`40
0?_oo_X1oo[l0?[ooP21oiKo0@00POobo`00o?onV_kooY[Zooh0Yoon0?Co09[m
002J[?l0V_d009[]o`00f_l1003moojJ0OoooIZ1ohWo0@00g?l1003koojJ0OnJ
o03jooh0POnFo`400;go0?jfo`00o?on0?kooP3/o`400:Kon`3eo`00oOon0:ko
003lo`00k_l00=[o003looh00Oooo@21ohSo003Lo`00n_on007o0?ko0021oh[o
0021oo;o003lookjo_onn^coo02Yoo/0mOl0n_d00_[j0:ko0?[k0>ko003Jo`00
o?onnP7ooogjPOn8o`00g?l00?[oo_X1oo[n003jnOon087oUOl0087ol_l00?co
oY[noojJj_on0:Soo03eo`2Jo@01VYZ]o`2Jo03]o`00f_l00?cooYX1ooomVX7o
R?l00=co003joojJ0OnJoP00V_WooP21oiGo002mo`3m]_l00?cooP3nooh0k?l1
002Voo/0mOl00?co0@00[_l00?co003^o`00f_l00?cooP01ooom087oR?l00=co
003jooh00Ol0o_l0087oR_l0087ol_l00?coo_[nookjk?ol0:Won`3eo`3jo001
nP2^o`3jn`3^o`00f_l00?coo_X1ooomnX7oR?l00=co003jookj0OojoP00n_Wo
oP21oiGo0021oo;o003loojJo_onV^[ooP2Xoo`0mOl0V_`009Z]o`2Jo03]o`00
f_l00?cooYX1ooomVX7oR?l00=co003joojJ0OnJoP00V_WooP21oiGo002mo`4?
]_l1003mooh0o_on0>co0@00c_on0=con`3eo`00o?l1002^o`00o?l00>oo0@00
f_l00?goo@01ooom087oR?l00=co003jooh00Ol0o_l0087oR_l0087ol_l1003m
ookjo_onn^coo03Aooh0g?ok0?Go0?[l007j0:ko0?[l003jkol1003Jo`00oOom
nP7ooogjPOn8o`00g?l00?[oo_X1oo[n003jnOon087oUOl0087ol_l1003moojJ
o_onV^[ooP2Xoo`0mOl0V_`009Z]o`2Jo000V^oo0@00f_l00?gooIX1ooomVX7o
R?l00=co003joojJ0OnJoP00V_WooP21oiGo002mo`40]_l00?goo@3nooh0k?l1
003no`00doom0=coo03do`00o?on0:Wo003^o`00f_l00?goo@01ooom087oR?l0
0=co003jooh0o?l0087oR_l0087ol_l00?gooO[nookjk?ok0=?oo@3Loo`0m?l0
n_`00_X00:oon`00n^ko003Jo`00oOomnP7ooogjPOn8o`00g?l00?[oo_X0ood0
0?[iooh0POnEo`00POobo`00oOomV_kooY[Zooh0Yoon0?Co09[l002J[Ook002J
k_l00=[o003moofJ0OoooIZ1ohSo003Lo`00n_onVP3oo@00V_WooP21oiGo002m
o`4V]_l00?goo@3nooh0oOon0??o0@00o_l00=?oo@3Lo`400?;o0@00o?on0:Wo
003^o`00f_l1003nooh0o_om087onoon09;o0@00g?l1003kooh0o?on087oSOl1
0021oo;o003moogjo_onn_gooP3co`40n_h00?[Cood0g?ol0?Go0O[jo002nP00
[ook003jk_l00=[o0@00o_onn_kooOZ1oo_ooP2Bo`400=co0@00noonnP3oo@3n
n__ooP21oiKo0@00POobo`00oOomV_kooY[[o`2JoP00VZSooP3eo`6JV_`009Z]
oo/009[^o`00f_l1003noojJo_omVX7oROl1003Lo`400?_ooYX0ood0oY[kooh0
POnFo`400;go0ANfo`00oOon0?gooP3nood0lol1003no`00dool0=kooP3bo`00
noon0:Wo003^o`00f_l00?gooP3nood0POokood0T_l00=co003jooh0oOol087o
SOl0087ol_l00?goo_[mookjo_om0??o0O[joP00n]?oo03Noo/0mOl0n_/00_X0
0:oon`00n^ko003Jo`00oOonn_kooOZ1oo_oo@2Bo`00g?l00?[oo_X0ooh0o?[l
ooh0POnEo`00POobo`00oOonV_gooY[/o`6JV_h009ZXooh0mOl0V_/009Z]oo/0
09[^o`00f_l00?gooY[noofJPOn8o`00g?l00?[ooYX0ooh0o9[looh0POnEo`00
_Ol19KKo003mooh0oOon0?koo@3dooh0o_l00=?on`3Oooh0l_l00?_ooP2mooh0
l?l1003_o`00f_l00?gooP3nood0POokood0T_l00=co003kood0oOol087oSOl0
087ol_l00?goo_[mookjo_om0?Co0P3jn_h00?[Coo/0gook0?Go0?[k00;j002m
ookjm_ok007j0>oo003Jo`00oOonn_kooOZ1oo_oo@2Bo`00g?l00?_ooOX0ooh0
o?[looh0POnEo`00POobo`00oOonV_gooY[/o`6JV_h009ZXooh0mOl0V_/009Zk
oojJm_ok002Jk_l00=[o003moojJo_omVX7oR?l00=co003koofJ0?on0?bJo?on
087oUOl00;go0FFfo`00oOon0?gooP3nood0m?on0<oonP3Qood0l_l00?_ooP2n
ood0mol00?_o0@00kol00>SooP3mo`400?co003mooh0o_om087onoom09;o003/
oo`0o_l1003ko`00noom0?goo021ohgo0021oo;o003mookjoOonn_koo@3do`80
n_[m0=?onP3Qooh00?[n0?Go0?[k00;j002noogjmol0n_/00OX0kol00>SooP3m
o`400?co003mookjo_omnX7onoom09;o003/oo`0o_l1003ko`00noomnP3ooP3l
n_cooP21oiGo0021oo;o003moojJoOonV^co0IZJo@3@ooh0gOl0V_h0mOl0V_/0
09ZloofJmol0V_/009[^o`00j?on0?go0@00o?l00?gooY[noofJPOn8o`00k?ol
0?ko0@00nol00?_ooIX0ooh0o9[looh0POnEo`00_Ol1PkKo0@00o_on0?gooP3n
ood0m?on0<oonP3Qood0o_l00?Ko003kooh0__om0?Oo003ko`400?3o0@00jOl0
0?ko1P3oo`3oo`3mo`00oOon0?koo@21oo_oo@2Bo`00k?l00?_o0`3oo`3lo`00
noon0?coo021ohgo0021oo;o0@00o_onn_goo_[nood0m?onn_d0dooj0>7ooP00
n_d0m_l0n_/00_X00;kooO[go`3jn`01nP3`o`400>Wo003no`H0ool0ool0oOl0
0?goo_[noogjPOokood0T_l00>co003ko`<0ool0o?l00?_oo_X1ooon0?cjo?on
087oUOl0087ol_l1003noojJoOonV^gooY[m0=7oo03No`2JoP3eo`2Jn`00V[co
oI[go`2Jn`00V^oo0@00jOl00?ko1P3oo`3oo`3mo`00oOonV_kooIZ1ohSo003/
o`00nol30?oo0?co003koojJ0OoooP3lV_cooP21oiGo002mo`6>]_l00?gooP3m
ooh0o_om0?CooP3@ooT0hOom0?ko003fo`00noon0;koo03ho`00nol1003_o`00
jOl00?ko1P3oo`3oo`3mo`00oOon0?koo@00ooh0POl1ooom09;o003/ood0o_l3
0?oo0?co003kooh0o?ok087oS_l0087ol_l00?goo_[mookjo_om0?Coo_[m0=Co
n@3Qooh00?[m0?Ko0?[k00;jnP2nooh00O[jn?l0n_/00OX0kol00>Wo003no`H0
ool0ool0oOl00?goo_[noogj0?on087o0Oooo@2Bo`00k?om0?ko0`3oo`3lo`00
noonnP7oooh0no[mooh0POnEo`00POobo`00oOonV_gooY[]oojJo@3Aoo`0g_l0
V_h0mOl0V_/00IZJ_Oon006JV_So09[k002Jk_l00>Wo003no`H0ool0ool0oOl0
0?gooY[noofJPOn8o`00k?om0?ko0`3oo`3lo`00noonVP7oooh0ni[mooh0POnE
o`00_Ol1SkKo003mooh0oOon0?koo@3dooh0d?oi0>7oo@3no`00m_l00?_ooP2o
oo/0n?l00?_o0@00kol00>Ko003no`<0ool0oOon007oooh0o_oi087o0?ol0:[o
oP3]o`400>So1P3oo`3oo`3lo`400?cooP3loo/0POn@ooh0POobo`00oOonn_go
o_[nood0m?onn_d0e?oi0>7ooP00n_d0m_l0n_/00_[j0;ooo000n_So0?[k007j
0>oo003Vo`00o_l30?oo0?gooP01ooonn_kooO[m087o0?omnP00Z_on0>go0@00
j?l60?oo0?oo0?co0@00o?onnP7oooh0no[mooh0POnGooh0POobo`00oOonV_go
oY[]oojJo@3Aoo`0g_l0V_h0mOl0V_/00IZJ__ol002Jn?l0V_/009[^o`00i_l0
0?ko0`3oo`3mooh00OoooY[noofJPOoloofJT_l1003Xo`H0ool0ool0o?l1003l
oojJ0OoooP3kV_gooP21oiOooP2mo`6D]_l00?gooP3mooh0o_om0?Goo@3Qoo`0
mOoi0>7oo@3no`00koon0;oon`3ho`00n_l00>oo003Wo`00oOl30?oo0?go003m
ooh0o_oh087oo02[ood0k?l00>So1P3oo`3oo`3lo`00noon0?con`21ohko0021
oo;o003mookjoOonn_koo@3eo`00o_[m0>Goo03eo`00o_[n003jhOon003joP00
n_KonP02n_X0_ool003jn?l0n_T0kol00>Oo003mo`<0ool0oOl00?goo_[noo[j
0@00POomnP00ZoonnP00k?l00>So1P3oo`3oo`3lo`00noonnP7oooh0no[mooh0
POnEo`00POobo`00oOonV_gooY[]oojJo@3CoojJoP00V]ko09[n002Jm_oj006J
V[koo000V_So09[j0>ko003Wo`00oOl30?oo0?go003moojJo_ojVX7o0OoooIZZ
oojJjol00>So1P3oo`3oo`3lo`00noonVP7oooh0ni[mooh0POnEo`00_Ol1f/Co
003lo`400?_o003mooh0oOon003on`3eood0h_ok0?Goo@3no`00hOom0?ko003^
o`400=WooP3eood0n_ok0?3o003_o`00j?l90?oo0?oo0?oo0?go003mooh0o_oh
087oo02[ood0k?l00>co003no`H0ool0ool0o?l00?_ooP3lo`800?on087oS_l0
087o0Ol0o?l1003ko`00oOonn_goo_X0ookjoP3eoogjo@3Voo/0mOomn_h00?[Q
ooh00?[n003jm_oi007j0=Woo_[eoogjn_ol003jn?oh0>oo003Xo`T0ool0ool0
ool0oOl00?goo_[noo[j0@00POomnP00Zoomn^co003/o`00o_l60?oo0?oo0?co
003kookj0Oooo000ookjoOon087oUOl0087o0Ol0o?l1003ko`00oOonV_gooYX0
oojJl_omV_d0e?omV_h009[No`2JoP00V_Kon@00V]SooY[eoofJn_ol002Jn?oi
0>ko003Xo`T0ool0ool0ool0oOl00?gooY[nooZJPOl1ooomVZ[ooI[/o`00k?l0
0?ko1P3oo`3oo`3lo`00noonVP7oooh0o_onV_gooP21oiGo002mo`7XaOl1003m
o`<0ool0o?l00?gooP3mooh00?ok0?Goo@3Roo/0m_ol0?ko003Roo`0o_l00??o
003mo`400=WooP3eood0nOon007o0?Co003no`00kol00>Woo03no`400?co003m
ooh0o_oh0?7ooP2Eoo/0Zoom0>co003[ooh0oOl1003ko`00noon0?co0P00ooh0
POn>o`00POl1003mo`<0ool0o?l00?goo_[mookj0?onn_h0mOomn_d0i_ok0?Ko
o?[n003jh_om003joP00n_KooP00n_d00OX0fOonn_GooO[iood00?[hood00?[m
0>oo003Yoo`0o_l1003lo`00oOonn_kon_X1003aooh0UOolnP00Zoomn^co003[
ooh0oOl1003ko`00noonnP7ooo`00?onn_gooP21oiGo0021o`400?go0`3oo`3l
o`00oOonV_gooYX0oojJl_omV_d0eOolV_h009[No`2JoP00V_KooP00V_d009[H
oojJmOomV_Woo@00V_Soo@00V_h0k_l00>Woo03no`400?co003moojJo_ojVX7o
0?olVZ[ooI[/o`00joon0?go0@00nol00?_ooYX1ooon0?kooY[mooh0POnEo`00
_Ol1`lCo003mo`<0ool0o?l00?gooP3mooh00?ok0?Koo@3RooX0m_ol0=koo03n
o`00lol1003no`400=WooP3foo/0nol00?3o0@00o_l00>oo003Jo`00oOon0?co
nP3aood0U_oj0:gon`3]o`00g?l00?_ooP3lo`800?om087ocoom0<Go0021o`7o
0?go0`3oo`3lo`00oOonn_goo_X0ookjoP3fo`00o_X0ood0ioomn_h0m_oln_d0
h_om003joP00n_KooP01n_[n007j0=Woo_[foo_jnook0?SooP01n_[m0>oo003J
o`00oOonnP7oooh0o?X1003aood0U_olnP400:goo?X00>go003Lo`00noonn_X0
0?omn_kooP21omGooO[5o`00POl1o`3mo`<0ool0o?l00?gooY[moojJ0?onV_;o
oYX0ood0ioomV_?oo9[m0=ko09[n002Jm_on006JV_h009[HoojJm_okV_[oo03h
ooh00IZJoP3^o`00f_l00?gooYX1ooon0?bJPOl0oobJZoolV^co003Lo`00noon
V_`0o_omV_kooP21omGooI[5o`00_Ol1elCo003mo`<0ool0o?l1003nooh0oOog
0?Koo@3SooP0n?ol0=gooP01o`3co`00o_l1003no`400=WooP3foo/0nol00?co
003fo`400?ko003aooh0f_l1003nooh0o?oi0??oo02FooX0[Ook0>ko0@00g?l1
003looh0o?l2003oo@21olooo@36o`40087o0Ol0oOl30?oo0?co0@00o_onn_go
n_[n0?KooOX0ood0j?oln_d0n?olnP3oo@3Rooh00Oojo@3go`3joP01n_[n007j
0=Woo_[foo_jnook003jnOon007jn_h00?[aooh0f_l1003nookj0OoooP3ln_h0
lool09Koo?X1002]oocj003^o`400=co0@00o?onn_X00?omn_kooP21omGooO[6
o`40087o0Ol0oOl30?oo0?co0@00o_onV_gonY[coofJ0?om0>Soo9[doobJ0?om
0=ko09[m0?Oo09[n006JV_h009[HoojJm_okV_[oo000V_WooP01VY[n002JlOon
0=[o0@00o_onVP7oooh0o9Z1o`3oo9Z[oobJkOl1003Lo`400?cooY[l0?kooI[n
ooh0POoEoofJa_l1002mo`7?a?l00?go0`3oo`3lo`00oOon0?gomP3good0i?of
0?Woo03Mooh00Ol0oOl00?So003no`400?ko0@00fOon0?Kon`3ko`00o?l00?Ko
0@00o_l00>oo003Jo`00oOon0?_onP3coo`0U_oj0:gon`3]o`00g?l00?_ooP3l
o`<00?oooP21olooo@35o`00POl1o`3mo`<0ool0o?l00?goo_[moo[jo@3googj
0?om0>Won_[m0?WooOX10?om0>;ooP01oo[l0?So0?[n007jn_h00OX0fOonn_Ko
no[koo/00?[iooh00O[joP00n^oo003Jo`00oOonnP7oood0oO[n0??oo02Foo_j
002]oocj003]o`00g?l00?_oo_[j007oookjo_on087oeOomn/Go0021o`7o0?go
0`3oo`3lo`00oOonV_gonY[coofJ0?om0>WonY[eoofJ0Oooo@3No`2Jo@3go`2J
oP01VY[n002Jf?onV_Koni[joo`009[iooh00IZJoP00V^oo003Jo`00oOonVP7o
ood0oIZ1o`3oniZ/oobJk?l00=co003koojJo03moojJo_on087oeOomV/Go002m
o`7Oa?l00?go0`3oo`3lo`00oOon0?gomP3gooh0nol00>[omP3joo`0g?om0?co
003ho`00o_l1003no`400=[oo@3fo`00o_on0?co003lo`00m_l1003no`00kol0
0=[o003mooh0nooj0??oo02FooX0[Ook0>go003Lo`00noon0?co0`00ooom087o
d?om0<Go0021o`7o0?go0`3oo`3lo`00oOonn_gonO[n0?Ooo_X1oool0>[onO[n
0?[ooOX20?ooo@3Rooh00?[k0?So0?[n007jn_h00OX0f_omn_Ko0?[n0?kjo?ok
003jnOon007jn_h00?[_o`00f_l00?goo_X1ooom0?gjoP3coo`0U_oknP00[Ool
nP00kOl00=co003kookjnP01ooomnP7oooh0POoEoogjaOl0087o0Ol0oOl30?oo
0?co003moojJoOoiV_CooYX1ooom0>WonI[goofJo_om0=oo09[l0?Oo09[n006J
V_h009[IoofJm_l0V_h0oY[koo`009[iooh00IZJoP00V^oo003Jo`00oOonVP7o
ood0oIZ1o`3oniZ/oobJk?l00=co003koojJo03moofJ0OoooP21omGooI[5o`00
_Ol1kLGooP3mo`400?_o003mooh0n_oi0?OooP3ko`00j_of0?[oo03ko`00hoom
0?co003ho`00o_l1003no`400=[oo@3ao`400?co003lo`00m_l1003no`00kol0
0=[o003mooh0nooj0??oo02FooX0[Ol00?ko0@00kOl00=co003kooh0o?l3003o
ood0POo@ood0aOl0087ooP3mo`400?_o003mookjo_om0?cjoP3gookj0Oooo03Z
ookj003mn_h0n_omnP80oool0>?ooP00n_/0n?l0n_h00O[joP01nP3Joogjm_ol
007jn_con`00n_WooP01n_[n003jkol00=[o003mookj0Oooo@3lnP400??oo02F
oo_j002]o`3joP01nP3]o`00g?l00?_oo_[j007ooogj0OoooP21omGooO[5o`00
POon0?go0@00nol00?gooY[nood0o9[doojJ0Oooo@3YoojJ0?omV_OooI[nood0
gol0V_`0mol0V_h00IZJoP00V]WooI[foo`00IZJnool002JnOon006JV_h009[_
o`00f_l00?gooYX1ooom0?bJPOokVZco09[n002Jk?l00=co003koojJo03moofJ
0OoooP21omGooI[5o`00_Ol1n[Ko003nood0n_l00?koo@3hood0nol00>_om@3j
oo`0nol00>?oo@3lo`00n?l00?ko0@00o_l1003Jood0moom00?oo`00oOl1003l
o`00n_l00?go003no`400?3o003Jo`00oOon0?_onP3coo`0U_l00?go0@00[Ol0
0?go003]o`00g?l00?_o0@00nol3003oood0POo@ood0aOl0087ol_l00?kooO[n
ood00?[n003joP3hoogj0Oooo03[oogj003lnP400?[ooOX20?ooo03Sooh00?[k
0?So0?[n007jn_h00OX0f_omn_Oon`01n_[mooX00?[jo`3joP01oo[n007j0?3o
003Jo`00oOonnP7oood0o?X1003coo`0U_l0n_d00OX0[Ol0n_`0kOl00=co003k
o`7jn_T00OoooOX1ooon087oeOomn/Go0021oo;o003noofJo_om002JoP00V_Go
oIX1ooom0>[ooIX0oobJn?omV_koo@3Oo`2Jo03go`2JoP01VY[n002JfOomV_Ko
o001VY[koo`009[jo`2JoP01oi[n002Jkol00=[o003moojJ0Oooo@3lVX7o09[m
002J[?l0V_d0k?l00=co003ko`6JV_/0oOomVP7oooh0POoEoofJaOl00;go0R:f
o`00o_om0?[o003noo`0nOom0?_o003[ooD0nook0?_o003Sood0o?l00?Co0@00
o_on0=_oo@3goo`00_oo0?go0@00o?l1003ko`00oOl00?ko0@00l?l00=[o0@00
o_on0?_o003nooh0lool0=7ooP3Lood0lol1003mo`400:So003^o`400=co0@00
o?l1003ko`400?koo@21om7oo037o`40087ol_l00?kooOX1oool003joP00n_d0
nOomnP7oood00?[[oogj0@00oOX1003koogj0`00oool0>?o0`00n_[k0?Soo@01
n_[n00;j003Koogjmooj003joOoj007jn__o0?[n007on_h00OX0l?l00=[o0@00
o_onnP7oood00?[n00;j003coo`0dOon0=coo@3co`7jn_d00OX0[Ool003jk_l1
003Lo`400?co0O[jn@3noogj0?on087oeOomnP00aol10021oo;o003noofJ0Ooo
o000V_h009[eoofJ0Oooo@00V^_ooIX1ooomV_WooI[mood0h?l1VY[l0?Ooo@01
VY[n002JfOomV_OonP00V__oo001VY[ko`2JoP01oi[n002Jkol00=[o0@00o_on
VP7oood009[n002JP_l1VY[m002J[?ol002Jk_l1003Lo`400?co0IZJn`3loofJ
0?on087oeOomV/Ko0@00_Ol26KKo003nooh0nOl00?koo03iood0nol00>_o0@00
oOoj0?coo03jo`00hoom0?co003co`00o_on0=_oo@3goo`00ooo003no`400?_o
003ko`00nOl1003`o`00f_l00?gooP3ko`00o_on0?Con`3Aood0gOom0??o0@00
oOl1002Xo`00kOl00=co003ko`400?_o0@00o_om087odOol0<Ko0021oo;o003n
ookjo_ol003joP00n_d0nOonnP80ooom003jjol1n_[n003oo?X1003loogj003n
ood00?[So`00o_[k0?Soo@01oo[n00;j003Koogjmooj007jn_kon@00n__o0?[n
007oooh00OX0l?l00=[o003mookj0Oooo@00n_h00_X00?Con`3Aood0gOom0??o
0O[jo@01nP2]oo`00?[]o`00g?l00?_o0O[jn@3noogj0?on087oeOomnP00a_l0
087ol_l00?kooY[noo`009[n002JmOonV_koo@00V^_o0IZJoP00oobJn_omV_go
o@00V^;ooY[l0?Ooo@01oi[n002JfOomV_OonP01VY[loo/009[ko`2JoP01ooon
002Jkol00=[o003moojJ0Oooo@00V_h009Z2o`6JV_d009Z/oo`009[]o`00g?l0
0?_o0IZJn`3loofJ0?on087oeOomV/Go002mo`8D]_l3003oooh0mOl10?on0?Wo
o@3ko`00jol00?_on000oo/0n_l00>?oo@3lo`00mOl20?l0o_on0=_oo@3goo`0
0OoonP3ko`00noon0?_o0@00lOl1003Jo`00oOon0?_o003nooh0m?ok0=7oo@3M
oo`0m?l00?co0@00Z?l00>go003Lo`00nol1003ko`400?gooP2Xood0[_ol0<Ko
0021oo;o0`00ooonn_kon001n_on0?Woo_X20?ooo@00n^_o0?[l003on?X0oogj
0@00o_om003jhol00?kjo000n_SooP02n_ojoP02nP00foomn_OonP01n_[m003j
n`00n__oo@01ooon007j0?7o0@00f_l00?goo_X1ooom003joP02nP00m?ok0=7o
o@3Moo`0m?l0n_`00OX0[Ool003jkOl00=co003ko`7jn_T0oOonnP3ooP2/ood0
[_oln/Ko0021oo;o0`00ooonV_kon000V_GooY[nood009[[o`2Jo000ooRJ0?om
V_coo@00V^;ooY[l002Jn?on00:Joi[n002JfOomV_OonP01VY[mo`2Jn`00V__o
o@01ooon002Jl?l1003Jo`00oOonVP7oood009[n002JP_l0V_`009Z/oo`009[]
o`00g?l00?_o0IZJn`3koojJ0?on087oeOolV/Ko002mo`86]_l00?kooP3eo`40
ooh0n_ol0?_o003SooT00?ok0?[o003Too`0o?l00?Go0P3o0?kooP3Loo`0n?ol
0?konP3ko`00o?ol0?co0@00l?l00=[o003mooh0nol00?kooP3doo/0d_ol0=go
o03do`00o?l1002Xo`00kOl00=co003ko`400?_o0@00oOon0:Soo@2^oo`0a_l0
087ol_l00?koo_[nooP00O[ooP3joogj0P3oood00?[[ooX00?oinP3ooOX1003n
ood00?[To`00oO[l003jn?on00;joo[n00;jnP3Loocjn?oi007jn_d00?[k003j
o?ol007oooh00OX0l?l00=[o003mookj0Oooo@00n_h00_X00?Con`3Boo`0gOol
0?Co0?[l007j0:goo000n^go003Lo`00nol1n_[i0?goo_X0ooh0[?om0:koo?[6
o`00POobo`00o_onV_kon000V_KooI[nood009[[ooX00?oiVP3ooI[lood009[S
oofJo000V_SooP02V_nJoP01VY[KoobJm_ok006JV_go09[k002Jo?ol007oooh0
09[_o`00f_l00?gooYX1ooom002JoP00VX;o09[l002J[?ol002JkOl00=co003k
o`6JV_/0noonVP3ooP21omGoo9[6o`00_Ol21;Ko003nooh0loon0?[oo@3jo`00
k?om0?con@00oo/0n_l00>Wom`3lo`00mOl20?l0oOl1003Loo`0n?l1003joo/0
nol1003moo`0o?l1003`o`00f_l00?koo@3gooh0m?oj0=?oo03Moo`0m?l00?co
0@00[_l00?co0@00k_l00=co003ko`400?_o0@00oOom0:Woo@2^oo`0a_l0087o
l_l00?koo_[nooL00?on0?[ooO[nood00?[/ooT00?oinP3ooOX1003nood00?[Y
oogj003ln_`00?[hooh00_[on_d00OX0g?oln_Son005n_X00?[jn`01nP3moo`0
0OoooP01nP3`o`00f_l00?kooOX1oooi00;j003dooX0dool0=goo03do`3jo001
nP2^o`3jo001nP3^o`00g?l00?_o0O[jn@3moogjoP2/ood0[_oln/Ko0021oo;o
003noojJo_og0?KooI[nood009[[ooX00?oiVP3ooI[lood009[YoofJ0?olV_`0
09[hooh00Y[oV_d009[KoobJm_oj00FJV_ooVY[k002Jo?ol007oooh009[_o`00
f_l00?kooIX1oooi002JP_l0V_`009Z]o`2Jo000V^go003Lo`00nol1VY[k0?_o
oI[n087oeOolV/Ko002mo`8O]_l00?kooP3cooh0n_om0>Coo03koo@0n_l00>[o
mP3lo`400?[o003no`80o`3mo`400=coo03ho`400?[on`3ko`400?goo03lo`40
0?3o003Jo`00o_om0?Ooo@3eooX0dool0=kon`3do`00o?l1003Fooh0joon0?Go
003lo`400>ko003Lo`00nol1003ko`400?goo@2[oo/0h?ol0=3o0036o`00POob
o`00o_onn_kom`00ooh0n_onnP00o_ol0>con001ooogn_h00?ok003jj_ofn_`0
0OX0n_l0n_h00_[on_d00OX0g?oln_Son005n_X00?[jn`01nP3moo`00OoooP01
nP3`o`00f_l00?kooOX0ooP00?[n0?GonP3Coo`0g_ok0?Co0?[l007j0=Koo_[[
ooh0mOl0n_`00OX0k_l00=co003ko`7jn_T0oOomn_h0[_omnP400>3oo_X1003D
ood00?[6o`00POobo`00o_onV_kom`3foojJoOol0>con001ooogV_gon`00V^[o
mY[l002JnOl0V_h00Y[oV_d009[KoobJm_oj00FJV_ooVY[k002Jo?ol007oooh0
09[_o`00f_l00?kooIX0ooP009Z2o`2Jo000V]GooY[Lo`2Jo000V^go003Lo`00
nol1VY[k0?_ooI[n0:kooI[NoojJd_om002Ja_l00;go0TVfo`00o_on0??ooP3k
oo`0i?ol0?_om03io`00joog0?_o0@00n_l00?ko0`3o003no`400=coo03loo/0
o_l00?kon`3ko`400?cooP3jo`00l?l00=[o0`00ooon0?Koo@3food00?on0=?o
o03Noo/0m?l00?co0@00e_on0>coo@3eo`00o?l1003_o`400=co0@00o?l1003k
o`400?cooP3Rooh0cOok0>3oo03@o`00gOon0>ko0@00POobo`00o_onn_kom`00
ooh0noomnP00o_ol0>con001ooon0?[jm@3[ooOj0?ol007j0?[o0?[n00?joo[j
oP01nP3Loocjo?omn_`00?[n0?_jn`01n_[looh0o_ol0?3o003Jo`<00?ooo_X1
oooh003joP3food00?on0=?oo03Noo/0m?l0n_`00OX0e_onn^coo@3eo`3jo001
nP3_o`400=co0@00o?l1n_[i0?coo_[n0>GooP3=oogj0@00h?omnP00e?om003j
gOonn^ko0@00POobo`00o_onV_kom`3goofJoOol0>con03looZJo_oi0>[omiX0
oo`009[io`2JoP03V_nJV_h009[KoobJo?omVP7oooh009[n0?^Jn`01VY[looh0
o_om0>oo003Jo`<00?oooYX1oooh002JP_l0V_`009[EoojJg?l0V_`009[^o`40
0=co0@00o?l1VY[k0?[ooY[n0:kooI[NoofJdoom002JgOonV^ko0@00_Ol28KKo
003nooh0loon0?_oo03Too`0nooe0?So003[ooP0nOl00?[o003no`<0ool0o_l1
003Moo/0o?ok0?ko003noo/0n_l00?;o003`o`00f_l00?kooP3eooh0m_oi0=?o
n`3Ooo/0kOl00=KooP3/ood0kol1003^o`00g?l00?_o0@00noon0?gooP3Rood0
c_ok0>3on`3Ao`00gOom0>ko0021oo;o003nookjo_og003ooP3koogj003noo`0
k?ol003oo@00ooh0no[d0>_on?X1oooj0?[o0?[n00?jooojoP01nP3Moo_jo?om
n_`00?[n0?_jnP00n_cooP3noo`0l?l00=[o003nookj0Ooom03fooh0oOX00=?o
n`3Ooo/0m?oj003je_onn^coo@3eoo/00OX0k_l00=co003ko`7jn_P0oOonn_h0
iOom0<kooOX1003Poogj0@00eOom003jgOomn^ko0021oo;o003noojJo_og0?Oo
oI[moo`0k?ol003oo@3moo^Jo_oh0>[on9X1oook0?Wo09[n00>JoonJoP00V]co
ni[loofJ0OoooP00V_h0ni[j002Jo?on0?koo@3_o`00f_l00?kooYX1ooog0?3o
oIZGooX009[FoojJg?ok002JkOl00=co003ko`6JV_/0n_onV_h0[_omV]kooI[C
ood009[MoofJk_l00;go0Tffo`<00?oooP3cooh0o?ok0>Kon@3looH0o?l1003n
o`00k?og0?Wo003jo`00o_l30?oo0?ko0@00gOok0?con`3no`00o_ok0?[o003m
o`00nol00?ko003ao`400=[o003nooh0mOon0?Kon@3DooX0gook0>go003Good0
k?ol0>oo003^o`00g?l00?_o0@00noon0?gooP3Rood0c_ok0>7onP3Fo`00oOl0
0=goo@3^o`00POobo`<00?ooo_[nooL00?on0?cooOX3003ooo/0k_ok007jn_d0
0?on0?_jnP01n_[m0>cooO[k007oooX0n_l0n_d00_oon_h00OX0gOokn_coo?[m
003joP3kn_X00?[mo`3joP3no`3joP00n_7o0@00f_l00?koo_X1oood0?Ko0@00
no[DooX0gook0?ConP00n]OooO[/oo`0m_oi0>ko003Lo`00nol1n_[h0?goo_[n
0>Goo@3>oogj0@00hOolnP400=Ko0?[m003jgOomn^ko0021oo;o0`00ooonV_ko
m`3hoofJoOok0>_ooP01VY[m0?goniX1oool006JV_h0joomV_Won`3io`2JoP3n
o`2JoP00V]coni[loobJ0?on002JoP3kV_X009[mo`2JoP3no`2JoP00V_7o0@00
f_l00?kooYX1ooog0?7oniZHooX009[GoofJg?oj0>go003Lo`00nol1VY[k0?[o
oY[n0:kooI[OoobJe?l0V_d009[MoofJk_l00;go0V^fo`80ooom0??ooP3loo`0
iOon0?ko0@00nooh0?_o0@00o_l00>con03ho`00m_l30?oo0?ko0@00g_oj0?go
nP3no`00oOol0?ko003no`00oOl00?_o003no`00l?l00=[o003nooh0mOon0?Ko
n@3Voo`0m?oj0=oon`3ao`00o_l00=Ooo@3/oo`0kol00>ko003Lo`00nol1003k
ooh0oOon0>;oo@3>ooX0h_oj0=Ko003mo`00gOom0>ko0021oo;o0P3ooogjo_og
003ooP3loogj0P3oooX0k_l2003joP01n_[m00?oo`00o?[j00;on_[m0>cooO[l
0?konP3joo`00_oon_h00OX0g_ojn_gono[m003jo@3ln_h00?[n003joOl0n_h0
o_l0n_h00?[`o`00f_l00?koo_X1oood0?Ko0@00no[Voo`0m?oj0=oon`3dooh0
0?[n003jeoomn^coo03fooT0k_l00=co003ko`7jn_P0oOonn_h0iOom0<koo?X1
003Roocj0@00e_l0n_d00?[Moogjk_l0087ol_l20?oooI[nooL0n?omV_konP3/
o`2JoP01VY[m0?goo9X1oool00;oVY[n0>_ooI[ioo/0nOom0?ko09[n002JgOoj
V_goniX0ooh009[m0?bJoP00V_h009[mo`2JoP3no`2JoP00V_3o003Jo`00o_on
VP7oooL0lOokVYSooP00V_h009[GoofJg?oj0>go003Lo`00nol1VY[k0?[ooY[n
0:koo9[PoobJe?l0V_d009[MoofJk_l00;go0Y:fo`80ooom0??ooP3loo`0iOon
0?kooP3looT0n_l1003no`00k?l00?go0@00m_l00?Ko0`3oo`3no`400=konP3m
ooX0o_l00?Go003no`D00?oo003ko`00o_l1003ao`00f_l00?kooP3eooh0m_oi
0>Koo03dooh00?on0>3on@3fo`00o_l00?ko003Good0k?ok0?Ooo@3no`00k_l0
0=co003ko`400?_ooP3mooh0h_om0<konP3RooX0e_l00?go0@00g_om0>ko0021
oo;o0P3ooogjo_og003ooP3loogj0@3on@3^o`800?[n0?kjo@02o`00o?[k00?o
oo[jo@3/o`3jn`3looX0n_ol00;ooo[n007j0=kon_[moo_jo@00n_d0o?on003j
oP05nP3ooo[joP3no`3joP01nP3ao`00f_l00?koo_X1oood0?Ko003jn^Koo03d
ooh00?on0>3on@3fo`3joP00n_h00?[Googjk?on0?kjmoon003jo@3^o`00g?l0
0?_o0O[jn03mookjoP3Uood0c_olnP400>;onoX00=Ko0?[m007j0=kooO[^o`00
POobo`80ooomV_kom`3hoofJ0Ooon@3/o`2JoP3nV_d0o_olVP3oo003oonJV_h0
jol0V_d0n_ok0?Woo@3no`2JoP00V]gonY[moo^J0?on002Jo@3looh009[n002J
o_l1VY[n0?ko09[n002Jl?l00=[o003noojJ0Ooom`3booZJVOl0V_h009[n002J
eoomV^WooY[gooh009[n0>go003Lo`00nol1VY[k0?[ooY[n0:koo9[Poo^JeOl0
V_d009[MoofJk_l00;go0[Ffo`80ooon0?;ooP3moo/0n?l00?3oo@3nooh0o?oj
0?Wo0@00o_l00>kooP3lo`00m_l00?Oo003no`00o_l1003Nooh00?on0?gonP3n
o`400?Ko003nooh00_l00?_o003no`400?7o003Jo`<00?oooP3eooh0m_oi0>Ko
o03dooh00?om0>7on@3fo`00o_l00?ko003Good0k?ok0?Soo03no`00kol1003L
o`400?co0@00noon0?co0@00h_om0<konP3RooX0e_l00?go0@00g_om0>oo0@00
POobo`80ooonn_gom`00ooh0oOomnP800?oh0?3ooP00n_h0o_[j0?gjn`3no`7j
n_h00?[^ookjn`3looX0n_on003jo_l0n_h00OX0g_onnP3oo_[moo[joP01n_[n
0?cooP00n_h01O[j0?ojn_h0o_l0n_h00OX0lOl00=[o0`00ooonnP7ooo@0m_l0
0?[ji_ol0?CooP00oogjhOoi0?Ko0?[n003joP00n]OooO[/oo/0n?oi003jkol1
003Lo`400?co0O[jn03lo`7jn_h0iOom0<koo?X1003Roo_j003Fo`3jo@01n_[N
oogjkol10021oo;o0P3ooojJoOog0?WooI[nooT0k?l0V_h0oY[l007ooofJ0?ol
0?ko0IZJoP00V^kooY[l0?_on`3iooh009[no`2JoP00V]gooYX0oojJoOojV_h0
0IZJoP3looh009[n00FJV_ooVY[n0?ko09[n002Jl?l00=[o0`00ooonVP7oooL0
l_ojV]3ooI[>o`2JoP00V_h009[GoofJjOon0?Son@00V^oo0@00g?l1003lo`6J
V_/0nOl1VY[n0:koo9[Poo^JeOl0V_d00IZJg_omV^oo0@00_Ol2_[Ko0P3oooh0
l_om0?kon`3lo`00o_l00?3oo@3nood0oOok0?So0@00o_l00>oooP3ko`00m_l0
0?Oo003no`00o_l1003Oood00?on0?gonP3no`400?Ko003noo/0nol00?ko0@00
lOl00=[o003nooh0mOon0?Koo@00ooh0i_ok0?Gon@3Qood00?on0?Ko003no`00
o_l1003Hood0kOoi0?Woo03no`00k_l00=co003ko`400?_ooP3lo`400>?oo03?
ooT0h_oj0=Ko003lo`00gook0>oo0021oo;o0P3oookjoOog003oo@3noogjnP00
n_d0l?on003joP3mn_40o_l1n_[n003jkoonn_X0o?oj0?[ooP00n_ko0?[n007j
0=oooOX0ookjoOojn_h00O[joP3looh00?[n00;jnP3nn_h0o_l0n_h00OX0lOl0
0=[o003nookj0Ooom03fo`00o_X0ookji_ok0?Go0@00no[Qood00?on0?Ko0?[n
003joP01nP3HoogjkOoi0?Won@00n^ko003Lo`00nol1n_[h0?co0O[joP3Vo`00
o_X00<oonoX1003Roo_j003Fo`3jo000n]oono[_o`00POobo`80ooonV_gom`3i
oofJ0Oooo000V_h0k?l0V_h0oI[m007oooh00?ok0?ko0IZJoP00V^oooY[k0?_o
n`3iooh009[no`2JoP00V]kooIX0oojJoOojV_h00IZJoP3looh009[n00:JV_on
V_h0o_l0V_h009[`o`00f_l00?kooYX1ooog0?;ooYX0oojJd_okV/ko09[n002J
oP00V]OooI[Zoo`0nOoi002Jk_l00=co003ko`6JV_/0nOl1VY[n0>GooY[>oo^J
h?okV]Go09[l002JgookV^oo002mo`;?]_l20?oooP3coo`00Ooon`3lo`400?ko
003`ood0o_om0?coo03ho`400?ko003_ooh0kol1003ho`00o_l00?ko0@00goom
003ooP3mooX0oOl00?Ko003noo/0nol00?ko0@00lOl00=[o003nooh0mOon0?Oo
o000ooh0i_ok0?Gon@3Qooh00OoooP3fo`00o_l00?ko0@00f?om0?Ooo@3kooT0
nOol0?ko003^o`00g?l00?_o0@00noon0?co0@00hool0<oon@3RooX0e_l00?co
003Ooo/0kol0087ol_l20?ooo_[mooL00?[m007ooogjnP01n_[m0?3ooP00n_h0
oO[b0?go0O[joP00n^ooo_[j0?con@3kooh00?[no`3joP01n_[Ooogj0?onn_go
o_X00?kjoP01oo[m0?gooP00n_h0no[n0?ko0?[n007j0?7o003Jo`00o_onnP7o
oo@0mol1003nnP3oo_[Voo/0mOl00?[jhOon007oookjm_l0n_h00?[n007j0=So
oO[gooh00?[kooT0nOoi003jk_l00=co003ko`7jn_P0o?l1n_[n0>Ko003nnP00
cooknP400>;onoX00=Ko0?[l003jgookn^oo0021oo;o0P3ooojJoOog002Jnoom
VP7ooo`00IZJoP3/o`2JoP3mV_80oOl1VY[n002JkoonV_X0o?ok0?WooP00V_ko
09[n006JV]oooIX0oojJoOonVP3ooY[n007oV_d0oOon002JoP3kV_h0o_l0V_h0
09[`o`00f_l00?kooYX1ooog0?;ooYX0oojJdoojV]cooY[fo`2JoP00V_h009[G
oofJmoon002Jn?ol0?Won@00V^ko003Lo`00nol1VY[k0?Wo0IZJoP3UoojJc_ok
V^3oni[Eo`2Jo000V]ooni[_o`00_Ol39KKo0P3oooh0lol10?on003onP3lo`40
0?ko003aoo`0oOom0?goo03ho`400?ko0@00noon0?WooP3_o`400?So003no`00
o_l1003Pood00OoooP3mooX0oOl00?Ko003moo`0nol00?ko0@00lOl00>Oo003l
o`400?co003nooh0mOon0?Ooo000ooh0i_ok0?Kon03Qooh00?om0?Ko003no`00
o_l1003Hood0n?ol0?_on@3hood0o_l00>ko003Yo`00oOl1003ko`00nol1003k
ooh0nol00?Coo@3doo`0cooi0>;onP3Fo`00o?l00=oon`3_o`00POobo`80ooon
n_gom`01n_on003oo?[j007jn_d0lOoln_h00?omn_@0o?l1n_[n007j0?_oo_[i
ookjn@3nooX00OX0noon003jo_l0n_h00O[jh?omnP7oookjoOonnP00o_[n007o
n_d0oOon003jo@3ln_h0o_l0n_h00OX0lOl00>Oo003lo`400?co003nookj0Ooo
m03go`00oOX0ookji_ok0?Ko003in^7ooP00oogjm_l0n_h00?[n007j0=SooO[h
oo`0nooi0?SooP00n_h00?[^o`00jOl00?go0@00nol00?_o0O[jn03ko`3joP3g
oogjm?oln/oonoX1003Roo_j003Fo`3jo000n]oono[_o`00POobo`80ooonV_go
m`00V_coo9X1oool006JV_h0l?olV_h00?omV_@0o?l1VY[n002Jn_onV_WooY[i
0?konP00V_[ooP00V_ko09[n006JV^3ooIX1ooonV_gooYX0oojJoP01oi[m0?go
oP00V_d0o9[n0?ko09[n002Jl?l00>Oo003lo`400?co003noojJ0Ooom`3coofJ
0?onV]ConI[MoofJm_l0V_h009[n002JeoomV_Soo03hoo`0n?on002JoP00V^ko
003Yo`00oOl1003ko`00nol1VY[k0?So09[n0?OooI[doobJcookV^3oni[Eo`2J
o000V]ooni[_o`00_Ol3?[Kon`3co`40ooP0n_l1003no`00lOom0?coo@3moo`0
n?l1003no`400?coo@3jood0kol1003kooh0oOl00?kooP3Roo`00OoooP3mo`00
oOl1003mo`400?Oo003moo`0nol00?ko0@00l_l1003Xo`400?go0`3oo`3mo`00
o_on0?GooP3goo`00?on0>OonP3fooP0hOon003oo@3bo`00o_l1003Ioo`0n?ok
0?con@3io`00o_l00?ko003^o`00j_l1003no`<0ool0o?l00?_o0@00noon0?_o
003dood0m?ol0<oon@3RooX0e_l00?co0@00h?ok0>oo0021oo;o0@00oO[mooL0
0O[onOX10?ol00;on_[m0?7ooO[m003ooO[f0?[o0O[joP01nP3loogjn_omn^l0
0OX0noon0?go0?[n00;jnP3Roocj0Oooo_[mo`3jo@01n_[n00;on_[m0?kooP00
n_d0o?[n0?ko0?[n007j0?;o0@00j?l1003mo`<0ool0oOl00?koo_X1oood0?Oo
003mnP3oo_[WoogjoP3fooSjhOon003ooO[food00?[n007j0=Woo?[hoo`00?[l
ooh00?[n003jnOom003joP00n^ko003Zo`400?ko0`3oo`3lo`00nol1n_[h0?_o
0?[n0?OooO[doocjcoojnP00h_oknP00e_l0n_`00O[jh?okn^oo0021oo;o0@00
oI[mooL00I[onIX1oool00;oVY[n0?3ooI[m003ooI[f0?[o0IZJoP00V__ooI[j
oofJk`00V_[ooP3mo`2JoP01VY[QoobJ0OoooY[mo`2Jo@01VY[n00;oVY[m0?ko
oP00V_d0o9[n0?ko09[n002JlOl1003Xo`400?go0`3oo`3mo`00o_onVP7oooL0
loomVP3ooY[WoofJloohV]gooI[food009[n002Jf?olV_Soo000V_Wo09[n002J
n?on002JoP00V^ko003Zo`400?ko0`3oo`3lo`00nol1VY[k0?So09[n0?OooI[d
oobJcoojV^7oni[Eo`2Jo001VY[Poo^Jkol00;go0gRfo`40ood0loof0?[o0@00
o_l00?;oo03kooh0o?on0?Oo0@00o_l1003moo`0n_on0?go003go`00o_l1003l
oo`0o_l00?kooP3Soo`0o_on0?ko0@00o?l00?go0@00m_l00?koo03ko`00o_l1
003ao`00iol00?go0`3oo`3mo`00o_on0?GooP3good00OoooP3XooT0m_om003o
o@3RooP0l_l00?ko0@00fOol0?WonP3lood0o_l00?Wo003no`00o_l00>ko003[
o`80o`3no`<0ool0o?l00?_o0@00o_ok0?_o003doo`0mOol0<oon@3dood0looj
0=Ko003lo`400>3on`3_o`00POobo`40oogjoOog0?cjoP01n_[k00?ooo[jo@3b
oocjo@01ooonnP3onP3go`7jn_h00OX0oOoln_[oo_[m003jm`00n_h00OX0o?ol
0?ko0?[n00;jnP3Soocjo_onn_ko0O[jo000n_h00_ojn_d0o_on007on_h0oO[m
0?ko0?[n007jn_7o003Wo`00oOl30?oo0?go003nookj0Ooom03go`00o_X1ooon
n^SonoX1003foogj0Ol0o_[Rood0o?[food00?[n007j0=Woo?[ioo/00?[looh0
0?[n003jnOom003joP00n^ko003[o`80o`3no`<0ool0o?l00?_o0O[jn03ko`3j
oP3goocjmOoln/oon_X00?CooO[coo_j003Fo`3jo001n_[Poo_jkol0087ol_l1
0?omV_gom`3lV_h00YZJoo`00oooVY[n0?7oo9[m007ooojJ0?oj0?Oo0IZJoP00
V_coo9[joojJo@00V_L009[n002Jnool0?ko09[n006JV^;oo9[noojJo_l1VY[l
002JoP02oiZJo@3nooh00OnJoP3mVP3ooP3no`2JoP01VY[ao`00iol00?go0`3o
o`3mo`00o_onVP7oooL0loonVP7ooojJj?okV_CooIX1ooonV]koo9[food009[n
002Jf?olV_Soo000V_Wo09[n002Jn?on002JoP00V^ko003[o`80o`3no`<0ool0
o?l00?_o0IZJn`3ho`2JoP3goobJmOolV/oonY[coofJlookV]Go09[l006JV^3o
ni[_o`00_Ol3/[Ko0@3ooP3booH0n_l1003no`00noom0?coo03no`80ooom0?[o
003ho`400?go003moo`0n_ok00;o003io`400?ko0@00oOok0?ko003nooh0hool
0?kooP3no`400?Oo0@00m_l00?koo03ko`00o_l1003ao`00iol00?go0`3oo`3m
ooh00?on0?GooP3good00OoooP3XooT0mool007oood0hooh0??o0@00o_l1003I
oo`0n_ok007o0?goo03no`00nOl00?ko003no`00kol1003/o`<0ool0o_l30?oo
0?co0@00o?l3003oooX00?on00;oo`3dooh00Ol0mOok0=3on@3dood0looj0=Ko
003lo`400>3on`3aooh0POobo`40ookjo?og0?gjm@03ooojn_d0noomn_cooO[m
00;jooomnP3on`00n_So0O[jo@00n_goo?[jookjo@01n_[i007jn_h00OX0oOok
0?ko0?[n00;jnP3Soocjo_onn_ko0O[jo000ooh00_ojn_`00OoooP01oo[f0?ko
0?[n007jn_7o003Wo`00oOl30?oo0?gooP00ookj0Ooom`02nP00moomnP7oookj
j?oknP400?Ooo?X1ooomn^?oo@3ln_KooP01n_[n007j0=Woo?[jooX00?[mood0
0?[n003jnOom003joP00n^oo0@00k?l30?oo0?ko0`3oo`3lo`400?co0O[jn000
ooh00_oon_h0moom003jmOolnP00d?onnP00o_X00?CooO[coo_j003Fo`3jo001
n_[Poo_jlOon087ol_l10?onV_com`3mV_`00Oooo003oonJV_h0n_omV_cooIX0
ooh00Y[ooofJ0?ok002Jn?l1VY[m002JoOolV_[ooY[m006JV_T00IZJoP00V__o
o03no`2JoP01VY[RoobJo_onV_ko0IZJo000ooh00_nJV_`00OoooP01oi[n0?co
oP3no`2JoP01VY[ao`00iol00?go0`3oo`3mooh00?onVP7oooL009[eoofJ0Ooo
oY[Xoo^JmOolVP7ooofJgoolV_KooP01VY[n002Jf?olV_Ooo@00V_Wo09[n002J
n?on002JoP00V^oo0@00k?l30?oo0?ko0`3oo`3lo`400?co0IZJnP3io`2JoP3g
ood009[eoobJcoonVP3ooY[coofJlookV]Go09[l006JV^3oni[aooh0_Ol3P[Ko
0@3ooP3booP0n?l1003no`00o?ol0?coo03no`80ooom0?[o003ho`400?go003n
oo/0n_og0?_ooP3nooh0o_ok0?ko003mo`400>Coo03mooh0o_l00?KooP3go`00
o_ol0?_o003no`400?7o003Wo`00oOl30?oo0?go003nooh0mOon0?Ooo@01ooom
0>[on03good0o_om0>?ooP00oo`0lol1003no`400=Woo03nooh00?on0?go0@00
o_ol0?Go003no`00o_l00>ko003/oo`01Ooo0?oo0?co003ko`<00?oonP00ood0
look0?Gon`3@ooT0m?om0??onP3@ooh0hOok0>oo0021oo;o0@3oo_[mooH0oO[f
0?ko0O[jo@3loocjo?onn_`00_[ooogj0Oooo000n_So0O[jo@00n_kono[jo`7j
n_`0o_[k0?kjoP02nP00o_l0n_`0o_l0n_d00OX0i?oln_goo_[no`3jn`00ooh0
0?onn_P00OojmP3no`3joP01n_[ao`00iol00?go0`3oo`3mo`00o_onnP7oooL0
0_X00?OooOX1ooomn^[onOX00?OooO[noogjhoon003oo?[fooh00O[joP01nP3I
oocjo_onnP3onP01n_[nood00?[m0?Woo@00n_h00?[^o`00k?ol00Goo`3oo`3l
o`00nol1n_[h003oo@01ooon0?Soo000n_Goo?X00=3oo_X00?kj003doogjlooj
n]Kon`3nn^7ono[_o`00POobo`40oojJoOof0?fJmP3no`6JV_h0noolV_cooYX1
ooon00:JooomVP7ooo`009[ho`6JV_d009[noo^Jn_l1VY[l0?jJn`3nV_h009[l
o`2Jo03no`2Jo@00V^?oo9[moojJo_l0V_/00?on003ooY[h007oV_h0o?on0?ko
09[n006JV_7o003Wo`00oOl30?oo0?go003noojJ0Ooom`00V_GooIX1ooomV^[o
nI[foofJo_omV]ooo9[fooh00IZJoP00V]Soo9[noojJoOom006JV_[o09[m0?So
oP00V_h009[^o`00k?ol00Goo`3oo`3lo`00nol1VY[j0?SooP3hoo`009[eoobJ
coonVP3ooY[coofJloojV]Kon`3nV^7oni[_o`00_Ol3L;Koo03booP0n?l1003n
o`00oOok0?coo03no`00o_on0?goo03iooh0o_l20?oonP3jooL0noon0?kooP00
ooX0oOl00?go0@00i?om0?cooP3no`00mOl1003go`00oOom0?Ko003ao`00iol0
0?go0`3oo`3mo`80ooom0?GooP3hood0o_om0>[om`3ioo`0o_om0>?on03go`00
o_l1003no`400=Woo001oooi0?go0@00o_on007o0?Go003jo`00k_l00>Wo003n
o`<0ool0o?l00?_o0`00oooe0??on`3eoo/0d?oi0?Coo03dooX0d?on0>7o003m
o`00kol0087ol_l00?gjoOof0?gjm`3mo`7jn_h00?[moo_jo?onn_`00?[nookj
oOoln_Woo_[n00;jooojn_[o0O[jo03nn__oo_[n00Cj003o0?kjoP3mo`3jo@01
n_[Toogjo?onn_ko0?[g00?ooo[jn001oo[f0?goo@00n_7o003Wo`00oOl30?oo
0?go0P3ooogj0Ooom`02nP00n?l00?kjo_omn^[onOX1003ioogj003no`00o_[S
ooh0no[go`3joP01n_[n007j0=Woo?X1oooln_X00O[jo_on007on_d0nOom003o
oP00n^ko003Yo`00o_l30?oo0?co003ko`7jn_<00OoooP3hoo`00?[eoocj003@
ookj003nnP00m?oln_Con_[Foo/0o_[Qo`3jo@00n^oo0021oo;o003mV_gomP3m
V_L0oOl1VY[n002JoOokV_cooYX1ooon002Jo_onV_goo9[ioojJoP02V_oonY[j
o`6JV_`0oY[koojJoP00V_gooY[n0?go09[m006JV^CooI[loojJo_l0V_L00ooo
VY[h007oV_d0oOon0?goo@00V_7o003Wo`00oOl30?oo0?go0P3ooofJ0Ooom`00
V_GooY[noofJj_oiV_OooI[loojJh?okV_Oo09[n006JV_h009[HoobJ0Oooo9[n
ood00IZJn_l0V_d0n?on003ooP00V^ko003Yo`00o_l30?oo0?co003ko`6JV_X0
n?on0?Soo000V_Goo9[?oojJ0?onV_?oo9[dooZJe_ok0?jJhOl0V_d009[_o`00
_Ol3L;Koo03booT0mol1003no`00o_oj0?gon`3no`00o_om0?kon`3moo/0o_og
0?[om`3kooh0oOoj0?[o0@00o_l1003Tood0o?on0?ko003eooh0n?l00?goo@3f
o`400?;o003Xooh0oOl1003lo`80ooom0?GooP3hood0o_om0>[oo@00oo`0nOol
0?koo@3Soo/0m?on007o0?go0@00f_ok007oooT0o?l00?kooP01o`3eo`00n_l0
0>ko003Zooh0o_l1003ko`00nol1003nooH0look0?Gon`3@ooT0lOl1003do`00
o_on0<oo0@00hOl00?go0@00l?l0087ol_l00?gjoOof0?cjn@3lo`7jn_h00?[n
oo[joOomn_`00?[noogjo_okn_gono[n0?Ojn_l1n_[l0?kjnoonn_X0oO[n0?go
0O[joP01n_[Toogjo?onn_ko0?[g007oookjn@01oo[f0?goo@01n_[bo`00j?on
0?go0@00o?l20?oooOX1ooog00;j003ho`00o_[no`00o_[Zooh00O[ooOX00?Wo
oOX00?ko003nn^?ooP3nn_h0moom007jooh00OX0f_oknP7ooocjn@00n_kooP01
oo[m0?Woo@00ooh00?[^o`00j_on0?ko0@00nol00?_o0O[jl`01ooon0?Soo000
n_Gono[@ookj003mn_CooP01n_[do`3joP3nn]KonP01n_[Qo`3jo@01n_[`o`00
POobo`00oI[mooH0o9[i0?co0IZJoP00V_konY[moofJ0OoooP00V_kooI[noo^J
oOokV_h0mi[jo`6JV_`0oY[koojJo@3noofJoP3mo`6JV_h00IZJi?omV_cooY[n
o`2Jm`01ooonV_T00OnJo@3mooh0oOom006JV_;o003Xooh0oOl1003lo`80ooom
VP7oooL009[eoojJoOonV^[ooP01V_omV_SooI[loojJh?onV_h0moom006Jooh0
09[Ioo^J0Oooo9[noo`009[jo`2Jo@3hooh00?on002Jk_l00>[ooP3no`400?_o
003ko`6JV_/0moon0?Soo000V_Goni[@oojJ0?omV_CooP01VY[do`2JoP3nV]Ko
nP01VY[Qo`2Jo@01VY[`o`00_Ol3N[Koo03boo`0m?l1003no`00o_oj0?gon`3n
o`00o_om0?konP01oooj0?kom`3kooX00?om0?cooP3mooX0nOl00?kooP3Vood0
noon0?ko003no`00nOon0?_o1000o`00lol00?koo03fo`400=[o0P3oooh0m?on
0?Soo@3nood0kooh003oo03nooh00?ok0?koo@3[ood0o_og0?Son`3mo`400=[o
n`01oooi0?co0`00oool0?go003ko`400>Ko003Lo`00nol1003nooH0loom00;o
o`3foo/0d?oi0?CooP01o`3do`00oOl1003?o`400>7o003mo`400?Koo001o`21
oo;oo?[mooH0o?[j0?_o0O[joP00n_kon_[moogjo000n_kooO[noo[j0Ooon_[n
0?Ojnoomn_h00?omn_coo_[m007j0?cjoP3lo`3joP3nn^KooO[kookjo_l0n_L0
0Oooo_X1ooom00Cjn_ojn_h0oOon0?go0?[n0?cjm_l1003Jo`80ooonn_kom`02
nP00n?omn_ko003nn^oom`3ln_koo_X0oocj003no`00o_[[ood0o_on0?gjoP3h
oo`00O[ooP01nP3Joo_j0Oooo?[i00?jn_oooP01n_[m003jnool003oo@3^o`00
g?l00?_o0O[joP3nn_T00OoooP3hoo/00?[foo_jd?onnP00oO[dood00?[do`3j
o@01n_[FooX00O[jhOl0n_d00O[jm_olnP7o087ol_olV_gomP3lV_X0nol1VY[n
002Jo_ojV_gooIX1ooon002Jo_omV_konYX1ooojV_h0mi[koofJoP00oofJo?on
V_d00I[oo9[n0?co09[n0?jJi_omV__ooY[no`2JoP00oo/00OoooYX1ooom00BJ
V_nJV_h0oOon0?go09[n0?bJm_l1003Jo`80ooonV_kom`00V_KooI[moojJjook
0?bJo_onVP3oo9[loojJhOomV_h0n?ol006Jooh009[Ioo^J0Oooo9[noo`00IZJ
o?l1VY[m002JnOon003oo@3^o`00g?l00?_o0IZJoP3nV_OooP3goo`009[foo^J
d?onVP3ooI[dood009[do`2Jo@01VY[FooX00IZJhOl0V_d00IZJm_olVP7o0;go
0hJfood0lOom0?go003ho`400?ko0P3oooT0oOok0?Woo@01oooa0?koo001ooon
0?_oo@3mood0o?om0?konP3io`00o_om0>Ooo@3kooh0o_l00?ko003iood0oOon
00;o003co`00o_ol0?Go003Jo`800?on0?Coo@3iood0o_om0?3om`01oool003o
o@00oo/0o_om0>_oo@3nooH0nOok0?go0@00f_ok007oooT0o?l3003ooo`0oOl0
0?_o0@00iol1003Lo`400?co003mooH0lol00?co003foo/0d?oh0?Kon`3do`00
oOl1003Co`00o_l1003Qo`00oOl1003fooX0POoboogjo?of0?gj0?on003jn?l1
n_[n00;joooin_goo_[k0?cooOX1oooan_h0o?X1ooonn__ooO[n003ooO[loogj
oP01nP3ln_h0o?l0n_h0oO[Woogjnoonn_ko0?[g007ooogjoOonnP;on_[m0?ko
oP3mo`3joP3ln_Go003Jo`800?onn_kom`00n_h0nOomn_ko003nn_3om@3lnP3o
oOX0oogj0@00o_l00?kjjoom0?ko0@00oO[l0?Woo001n_on007jn][onoX1oool
n_T00o[jooon007jn_d00?[koo`00?om0>oo0@00g?l1003lo`3jo@3nn_T00Ooo
oP3hoo/00?[foo_jd?onnP400?kj003foo`00?[do`3jo@01n_[Fooh00?[n007j
n^7o0?[m007jn_KonoX0087ol_omV_comP3mVP3ooP00V_So0IZJoP02V_oonI[m
oojJo_on0?cooIX1oooaV_h0o9X1ooonV__ooI[n003ooI[loofJoP01V_olV_h0
o?l0V_h0oI[WoofJnoonV_ko09[n003on`01ooomV_gooYX2oiZJo@3nooh0oOl0
V_h0o9[eo`00f_l2003ooY[nooL009[foofJoOonV^_onP3lVP3ooIX0oofJnoon
V^;ooI[l0?Woo001V_on006JV][oniX1ooolV_koo001VY[lo`6JV_d009[iooh0
0?om0>oo0@00g?l1003lo`2Jo@3nV_OooP3goo`009[foo^Jd?onVP7ooojJmOol
002Jm?l0V_d00IZJe_on002JoP01VY[Qo`2Jo@01VY[foo^J002mo`>R]ool0?3o
003ko`00n?l1003no`800?om003ooP3mo`400?Goo@01oood00;oo`3nood0o_on
0?_ooP3kood0oOom0?konP3io`00o_om0>OooP3do`00o_l1003jood0oOon00;o
003co`00o_ol0?OooP3Jo`80ooon0?Coo@3iooh0oOom0?3om`01ooog003oo03m
ood0k?ok007oooH0nOol0?_o003Joo/00OoonP3ko`<00?ooo@3lo`00nol1003m
o`00jol00=co003ko`00oOof0??o003lo`00m_ok0>;ooP3bo`400?gooP3foo/0
m?l00?co0@00e?l00?kooP3Ro`00o?l00?KonP21oo?oo?[looD00?[k003jn?l1
n_[n00;j0?omnP3oo_[mo`7jn_X0o?omnP7oooCj0_oon_h0oO[nookjnoonn_d0
0OoooO[moogjoP3kn_d0o?l0n_h0oO[Wookjnoom0?ko0?[n007jn_`00OoooO[m
ookj0_ojn_d0o_on0?go0?[n0?cjmoonn][o0P3oookjo_og003joP3iookjoOl0
0?kjl?oe0?Oj0?omnP00oOom0>coo004n_oo003mn_`0nOol007oood00?[Joo_j
0Oooo?X2003oo007n_[oo`00n_[l003jnol10?[n007on_h0k_l00=co003ko`3j
o@3nn_T00OoooP3hoo/00?[foo_jh_onn_;o0O[jo@02n_X0m_ol003jm?l0n_`0
0OX0eoon003joP3nn^;o0?[l003jm_oknP00POocoobJo?oe002Jn`00V_So0IZJ
oP02V_oooIX0oojJoOl1VY[j0?cooIX1ooodVP;ooi[n0?fJo_onV__ooY[m007o
oofJoOomV_h0niX0ooh0o?l0V_h0oI[WoojJnoom0?ko09[n006JV_`00OoooI[m
oojJ0_nJV_d0o_on0?go09[n0?bJmoonV][o0P3ooojJo_og002Jm_onV_cooY[[
ooX0miX0oofJnoon0>[ooP00V_gooI[l0?Woo001ooom002Jf_okVP7ooobJo_ol
006JV_go0IZJo000V_[o09[n007oV_h0k_l00=co003ko`2Jo@3nV_OooP3goo`0
09[foo^Jh_onV_;o0IZJo@01VY[eoo`009[do`2Jo000V]KooP00V_h0oY[Ro`2J
o000V_KoniX00;go0i6good0kol00?_o0@00nOl1003moo`00OoooP3mo`400?Co
o@00ooh00OoonP3no`00oOl1003mooh0noon0?_oo@3mood0o_oj0?Wo003nood0
ioon0?Oo0`3oo`3no`400?WooP3mooh00_oo0??o003noo`0moon0=[o0P3oooh0
m?om0?[oo@3mood0l?oh0?golP3moo`0kOo^0?Woo03ko`00fooj007oooX0n_l2
003oo@3lo`00nol1003mo`00jol00=co003ko`00o_od0?Co003lo`00m_oj0>Co
o03co`400?gooP3foo`00Ol0mOl00?co0@00e?l00?kooP3Ro`00o?l00?KonP21
oo?ooO[kooD00?[k007jn_Wo0O[jo03mnP7oookjoOl1n_[j0?_ooOX0ookj0Ooo
n_[no`3jn`3mookjnoonn_d00OoooO[moogjoP3ln_`0o?l0n_h0oO[Wookj0Ooo
n@03n_oon_h00O[jo03nookjoOonnP;ooo[g0?go0?[n0?cjmoonn][o0P3oookj
o_og003joP3joogjoOl00?kjl?od0?Cj0@00oOol0>gon`02nP00o?[l0?Woo@02
n_ooo@00n]_on_X1oooknP40oo/01_[jo`00n_[l003jnol10?[n007on_h0k_l0
0=co003ko`3joP3mn_P00?on0?Son`00n_Kon_[Toocjlol1n_[m00;jnP3foo/0
0?[eo`3jo001n_[Gooh00?[n0?kjh_l0n_`00?[foo[jPOocoofJnooe002Jn`01
VY[io`6JV_d00?omVP7ooojJoOl1VY[j0?_ooIX0oojJ0OoonY[no`2Jo@3koojJ
noonV_d00OoooI[moofJoP3lVP7oooh0o?l0V_h0oI[WoojJ0Ooon@03V_ooV_h0
0IZJo03noojJoOonVP;ooi[g0?go09[n0?bJmoonV][o0P3ooojJo_og002Jmoom
V_cooY[ZooX0m9[koo`0k?ol00:JooolV_`0n?on00:Jooom002JfoojVP7ooo^J
0Ooon`01VY[no`6JV_`009[jo`2JoP01oi[n0>ko003Lo`00nol0V_h0oI[gooh0
mool002Jm_ojV^Coo9[co`6JV_d00IZJmOok002JmOl0V_`00IZJeoon002JoP3n
V^;o09[l002Jm_ojV[go0j>no`400?con`3eo`00mol1003io`400?goo001ooon
0?go003cood00?on0?3o0@00oOon0?_ooP3koo`0o_om0?koo03go`00o_om0>So
oP3fo`<0ool0o_on0?[oo@3nooh00ooo003do`00o_ol0?OooP3Jo`80ooon0?Co
o@3koo`0oOom0?3on`3ioo<0oOol0>gom001ooom0?Wo003no`<0ool0o_l00=_o
nP01oook0?WonP3lo`00nol1003mo`00jol00=co003ko`00o_od0?Co003lo`40
0?So0@00o_on0>Coo03co`00o?on0?Koo@02ool0m_l1003lo`400=Co003mo`40
0=co003fooX0POojo`400?cooOX1003mooT00?[g007jn_Wo0O[jo03mnP7oookj
oOl0n_T0noomnP3oo_[doo/0oOonn__oo_[m007ooocjo_omn_h0oOX20?oooP3l
o`3jo@3nn^Soo_[f00?jooojoP3nn_d0o_omn_koo_X3ooojn_P0oOl0n_`0o_[g
ookjf_l20?ooo_[nooL00?[n0?_o003mn_go003nn_3om000ooGjmP3]oo/0n_X1
ooon003jnOom00?jooojoP00n]_on_X1oooknP7ooo/00o[j003nn_`00?[ko`7j
n_h00OojoP3^o`00g?l00?_o0?[n0?gjn000ooh0n?ok007jn_So0O[joP3nn^Co
o?[co`3jo03nn_Kon`00n_Ko0O[jo001n_[Gooh00?[m007jn^;on`00n_Kon_Z1
oo[o0@00o?omV__on@00V_L00IZJnOl1VY[m003ooIX1ooonV_go09[i0?_ooIX0
oojJm?om0?_ooY[koojJo@01ooolV_kooI[n0?fJo_on0?co09[n003ooY[XoojJ
mP03V_ooV_h0oY[m0?kooI[noojJ0oooVY[h0?go09[n007ooojJmoonV][o0P3o
oojJo_og002JmoomV_cooY[ZooX00?oeVP7oooP0k?ol0?ZJ0OoooP00V_SooP03
V_ooV_h009[KooZJ0OooniX1oook00>JV_oooY[l002Jnol1VY[n007oV_h0k_l0
0=co003ko`2JoP3mV_OooP3goo`00IZJn?l1VY[n0?jJi?olV_?o09[l0?jJmOol
002Jm_l1VY[l006JV]OooP00V_d00IZJh_ok002Jm_ojV[go0oVoo`<0ool0oOoj
0?Ko003gooh0n_on0?koo@3nooh0oOl00??oo@00ooh0m?l00?ko0@00oOon0?_o
0@00oOl00?koo001ooom0?kooP3eo`00oOon0>So0@00mOl30?oo0?kooP3jood0
o_on007oooh0mOl00?koo03gooh0f_l20?oooP3dood0noom0?coo@3`oo/0o_l0
0?goo@00ooT0o?ol0>oolP3lo`00nOl00?_o003no`00foon003ooP01oook0?Wo
nP3lo`00nol1003mo`00o_l00>oo003Lo`00nol00?kom03do`00o?l1003ho`00
oOon0>Co003no`00lol00?cooP3fo`00o?l00?Ko003ko`400>WooP3_o`00oOl1
003aood0mol00?_o0@00n?oi087onol30?oo0?goo_[m0?kon@00n_L0o_[jookj
o@3nn_koo_[mo`3jo@00ooh0noomnP3oo_[do`3jo03mookjnol1n_[m003jo_ol
nP7ooogjoP3nn_gooP3lo`3jo@3nn^So0O[jm@03n_oon_h0o_X0ooh0o_omn_ko
o_X1ooonn_T0oOl0n_`0o_[gookjf_l20?ooo_[nooL00?[n0?_ooO[lo`00o_[`
ooP00?[i003ono[e0>ooo_[l0?[j0OoooP00n_Woo@3no`3joP00n]_oo_X0ookj
0OoonoX1oook0?[jo000n__o0O[joP01oo[n003jkol00=co003ko`3joP3mn_P0
0?on0?Son`01n_[ho`3jo@3nn^Co0?[n003jlol0n_`0o_[foo/00?[fo`3jn`01
n_[Yooh0l_on003jo@01n_[aoogjmol0n_/00O[jn?oinX7onol30?oo0?gooY[j
ooT009[g0?jJn_onV_h00?onV_kooY[mo`2Jo@00ooh0noomVP3ooY[do`2JoP3k
oojJnol1VY[m002Jo_olVP7ooofJoP3nV_gooP3lo`2Jo@3nV^So0IZJm@03V_oo
V_h0oYX0ooh0o_omV_kooYX1ooonV_T0oOl0V_h00OoooY[goojJf_l20?oooY[n
ooL009[hoofJnoonV^[ooP00V_d0o?okVP7oooL0koonV_`0nYX1ooon002Jn?on
0?ko09[n002JfoonVP3ooYX1oookVP7ooo/0nY[l002Jnol1VY[n007oV_h009[_
o`00g?l00?_o09[n0?fJmoon0?Ooo001VY[ho`2Jo@3nV^Co09[n002Jlol0V_`0
oY[eoo`009[fo`2Jn`01VY[Gooh009[m006JV_7ooI[go`2Jn`01VY[hooVJ_Ol3
m[oo0`3oo`3mooP0n?l00?Ooo@3kooh0o_om0?kooP3mo`00o?on0?[onP3do`00
oOl1003nooh0nol1003mo`00oOom007oood0kol00?gooP3Xo`00m?l00?_onP3m
ood00OoooP01ooon0?[o003mo`00oOom0?OooP3Jo`80ooon0??oo03mood0nOl0
0?3oo03mo`00oOoe0?[ooP3_ooT00?ok0?;o003ko`00o_l00=coo@00ooh00_oo
0?ko0@00nOoj0?_o003mooh0oOl00?ko003_o`00g?l00?_o003noo@0m?l00?co
oP3io`00o?l1003Tooh00Ol0lol00?cooP3fo`00o?l00?Ko003ko`400>WooP3_
o`400?ko0@00lOom0?Oo003ko`400?Son@21oo_o0`3oo`3mooP00?oi003jm`3m
n__oo_[n0?gjo_onn_go0?[m003oo_[joo[jm?l0n_/0o_onn__o0O[jo@00n_go
oOX1ooomn_h0n_on0?co0?[m0?kjj?l0n_T00OoooP02n_ooo@3jn_gooOX1ooon
nP7oookj0?ok003joOl0n_`0o_[gookjf_l20?ooo_[nooD0oO[moogjo_ol003j
l?ol003ooP00n_P0no[f0>ooo?[m0?_jo_om0?Woo@3no`3joP00n]cooOX0ookj
0_oon_h00o[joook0?[jn`00n_go0P3jn_h00OojoP00n^oo003Lo`00nol0n_h0
oO[h003ooP3hoo/0o_[io`3jo001n_[Tood00?[co`3jo03nn_Kon`00n_Ko0?[k
007jn^WooP3booh00O[joP01n_[aoogjmol0n_/00O[jn?omnP00o_Z1oo_o0`3o
o`3mooh0n_oi002Jm`3mV__ooY[n0?fJo_onV_go09[m003ooY[jooZJm?l0V_d0
o?onV__o0IZJo@00V_gooIX1ooomV_h0n_on0?co09[m0?jJj?l0V_T00OoooP02
V_ooo@3jV_gooIX1ooonVP7ooojJ0?ok002JoOl0V_d00?onV_OooY[Jo`80ooon
V_komP00oofJoOomV_koo000V^[ooP00V_d0o?okVP3om`3_oobJo@3kV_koo@3h
ooh0o_l0V_h009[LoofJ0?onVP;ooi[n00>JV_oon`3jV_/009[lo`6JV_h00OnJ
oP00V^oo003Lo`00nol0V_h0oI[gooh0mool0?jJnOl0V_`00IZJi?om002Jlol0
V_`0oY[eoo`009[fo`2Jn`01VY[Gooh00IZJoP01VY[aoofJmol0V_/00IZJn?om
VP3ooYZmo`@1_ol30?oo0?koo000ood0n?l00?Ooo@3kooh0o_om0?So0@00o_l1
0?on0?[onP3do`00oOl1003nooh0nol1003no`400?goo000ood0kol1003nooh0
j?l00?cooP3lo`00nooj0?goo@01ooon007oood0oOon0?go003mood0n?om0=[o
n`3coo`0oOom0?_ooP3aood0nol00?gomP3Too`0oOom0?3o003ko`00o_l00=co
o@00ooh00_oo0?go003hoo/0nol00?gooP3mo`00o_l00?3o0@00g?l1003lo`00
o_om003on@3do`00nol1003io`00o?l1003UooX0m?l00?_o0@00m_l00?co003f
o`00nol1003Yood0l?l1003nooh0l_ol0?So003ko`400?Son@21oo_o0`3oo`3n
ooL00?oi003jm`3mn__oo_[n0?gjn`3no`7jn_d00?onn_[on_[do`3jn`3nookj
nol1n_[n007jn_goo?X0oogjo@3kooh0o?l1n_[n0?kjj?l0n_T00OoooP02n_oo
o@3jn_gooOX1ooonnP7ooogjoOonn_go0?[l0?kjn?omn][o0@00oO[nooH0o?[m
oogj0OoonP3aood0o_on003jn03ln_X00OoooP3_oocjo@3mn_coo@3iood0o_l0
n_h00?[Loogj0?onnP;ooo[m00;joooj0?_jn`00n_goo_[n007on_h00?[`o`40
0=co0@00o?l0n_h0oOX0ooT00?on0?SonP01n_[io`3jo001n_[Uoo`00O[jm?l0
n_/00O[jm_ok003jm_l0n_/00O[jjOom0??ooP01n_[n0?kjl_oln_So0?[k007j
n_Soo_X1003nnX7onol30?oo0?kon`3looT009[g0?fJnoonV_h0oI[k0?ko0IZJ
oP01ooonV_[onY[do`2Jo@3loojJnol1VY[n006JV_goo9X0oofJo@3kooh0o?l1
VY[n0?jJj?l0V_`0o?on00:Jooom0?ZJoOomVP7ooojJ0OoooI[moojJoOl0V_d0
0?onV_SooI[Jo`400?fJo_of0?bJoOomVP7oooX0j_on002Jo@3loobJ0?ok007o
ooh0koolV_d0oI[lood0n?on0?ko09[n002Jg?omVP3ooYX2oonJo@02V_oonP3k
V_/009[moojJoP01oi[n002Jl?l1003Lo`400?co09[n0?fJmoon0?Oon`01VY[i
o`2Jo001VY[Uoo`00IZJm?l0V_/00IZJmOol002Jm_l0V_/00IZJeoon006JV_h0
oY[boobJn?l0V_/00IZJn?onVP7ooojJ_Ol3lKoo0`3oo`3noo`00OoooP3ho`00
mook0?gooP3nooh0mol1003no`40ooh0nOok0?Co003go`400?_o0@00o_l1003l
ooT0k_l1003nooh0j?l00?goo@3lo`00o?oi0?coo@00ooh00Oooo@3mooh0oOl1
003noo`0nOom0=[o0@3oo@3coo`0o_om0?_oo03bood0nol1003mooP0hool0?co
oP3ao`400?_o003no`00gOom007oooh0n_l1003ioo`0n_l00?gooP3mo`00o_l0
0>oo003Lo`00nol00?koo@00ooT0m?l00?_o0@00nOl00?cooP3Voo`00Ol0m?l0
0?_o0@00m_l00?co003fo`00n_l1003Zoo`0lOl1003nooh0look0?So003ko`40
0?Son@21oo_o0`3oo`3nooL00?oi003jm`3kn_goo_[n0?kjnP3no`7jn_d00?on
n_Wono[do`3jm`01n_[ko`7jn_h00O[jo?oinP3oo@3kooh0o?l1n_[n0?kjj?l0
n_T00OoooP02n_oooP3in_cooOX0ookj0OoooO[mookjoOl1n_[m0?gjnOomn][o
0@3ooO[nooH0o?[noogj0Ooon03bood0o_on007jn_T0o?[k0?kooP3_oocjn@3l
ood0n_ol0?ko0?[n003jgOomnP7oookj0Oooo002n_[onP3lnP3on`00n_goo_[n
007on_h00?[_o`00g?l00?_o0?[n0?gj0?oi003ooP3hooX00O[jnOl0n_`0o_[V
oo/00?[do`3jn`01n_[foo/00?[fo`3jnP01n_[Zoocjm?on007jn_h0o_[coo_j
n?l0n_/00O[jn?onnP400?kjPOoko`<0ool0o_oj0?gon@00V_L0ni[moojJoP3n
V_X0o_l1VY[n007ooojJnOokV_Co09[g006JV__o0IZJoP01VY[looVJ0?om0?_o
oP3lo`6JV_h0oY[Xo`2Jo@3kooh00Y[oooh0nI[loofJ0?onVP7ooofJoOonV_go
0IZJoP00oofJnOomV][o0@3ooI[nooH0o9[noofJ0Ooon03[ooh00IZJo@3moobJ
n`3nooh0koolV_`0nOom0?SooP3no`2JoP00V]gooIX1ooonVP7ooo`00YZJooX0
o9X0oo/009[moojJoP01oi[n002Jkol00=co003ko`2JoP3mV_OooP3goo/00IZJ
nOl0V_`0oY[Voo/009[do`2Jn`01VY[eoo`009[fo`2JnP01VY[ZoobJm?on006J
V_h0oY[coo^Jn?l0V_/00IZJn?onVP7ooojJ_Ol49;oo0`3oo`3noo`0o_on0?Wo
003kood00?ok0?kooP3no`400?Ko003mo`40ooh0nOok0?Co0@00l?l1003no`40
0?_onP01o`3`o`400?go0@00j?l00?kon`3mo`00o?oi0?coo@00ooh0o_on0?go
oP3mo`400?goo@3iood0f_l10?on0?;oo03nood0nool0?;oo03lo`400?gon@3d
o`00nOon0?_oo03lo`400?3o0@00nol00?ko003Mood00OoooP01o`3lo`400?go
003nood0nOl3003oood0oOl00?ko003_o`00g?l00?_o003nood00?oi0?Go0@00
noon0?[o003looh0i_ol007o0?Co003kooh0mol00?co0@00mol00?[o0@00jook
0?7o0@00oOl1003coo/0n?l00?[o0@00nOoi087onol30?oo0?kokP00n_/0oOX0
oo_jo_onn_h00O[jn@3no`3jo000ookjnOokn_Co0O[jmP3ko`7jn_h00O[jnooj
nP7on_h0noon0?co0O[jo@01n_[Xo`3jn000ooh00_[oooh00OX0no[loogj0?on
n_koo_[mookjoOl1n_[m0?gjnOomn][o0@3oo_[mooH0o?[noogj0Ooon03boocj
0OoooP01n_[i0?gjn`3mooh00?[iookjnooln_X0o?ol0?[oo03no`3joP00n]go
oOX1ooonnP7on_`00_[jooh00?[j007ooo/00oX0ooomn_h00OojoP00n^oo003L
o`00nol0n_h0oOX0ooT00?on0?Won@3nn_[o0?[l0?kji_ok003jm?l0n_/0o_[g
oo/00O[jmol0n_X00O[jjol00?cjm?on007jn_d00O[jlookn_So0?[j007jn_Wo
o_X1003nnX7onol30?oo0?kon@3nooT009[k0?fJ0?okV_kooY[n006JV_T0o_l0
V_d00OoooY[ioo^Jm?l1VY[f0?_o0IZJoP01VY[kooZJ0OnJoP3kooh0o?l1VY[m
006JV^So09[n0?[ooP02V_oooP01V_okV_cooIX0oojJo_onV_gooY[mo`6JV_d0
oI[ioofJf_l10?onV_gomP3lV_kooIX1oooh0?;oo9X1ooon006JV_d0oOomV_/0
oOon002JnOonV__oo9[l0?[oo03hooh0o_l0V_h009[MoofJ0OoooYX1oi[l00:J
V_on002JoP3koo/009[noofJoP01oi[n002Jkol00=co003ko`2JoP3mV_OooP3g
oo/0oY[jo`2Jo03nV^Kon`00V_Co09[k0?jJm_ol006JV_Oo09[j006JV^[oo9[d
ooh00IZJo@01VY[coo^Jn?l0V_X00IZJnOonVP7ooojJ_Ol3okko0@00o?on0?co
0@00nOl00?_oo@01oook003oo@3no`400?Ko003moo`0n?ol0?Co0@00l?l1003n
o`400?[on`01o`3`o`400?7ooP3aoo/0oOl00?con@3looT0o_om0?kooP3mo`40
0?[o003ioo`0fol10?on0?;on`00oo`0nool0?;on`3mooh0oOok0??o003iooh0
nool0>[ooP3ko`00o_l1003Ooo`00OoooP01o`3ko`400?ko003nood0nOl3003o
ood0oOl00?ko003_o`00g?l00?_o003nood00?om003ooP3eo`400?_ooP3jo`00
o?on0>Koo@02ool0m?l00?_ooP3go`00nol00?Oo003no`00o_l1003[oo/0lOl1
003mo`400??on`3ho`00n_l1003iooT0POojo`400?cok`00n_/0oOX1oooknP3o
oO[n007jn_T0o_l0n_d0o?[hoocjm?l1n_[f0?_o0O[joP01n_[joo_j0Oojm@3l
o`7jn_/0moonn_Gom`00ooh00_[oooh00_X00?cjo?oin_kooO[nookjoOl1n_[j
003jnOoln]_o0@3oo_[mooH0noX0oogj0@3om`3boo_j0?on0?kjl@3looh00?[i
ookjnooln_/0o?ok0?_on`3no`3joP01n_[Ooocj0Oooo_X1oo[k007jn_h00?[j
007ooo/00o[jooomn_h00OojoP00n^oo003Lo`00nol0n_h0oOX0ood00?on003o
oP3iooT0o_[jo`3jo03nn^Kon`00n_Co0?[k0?kjmooj003jmol0n_X00O[jjook
n_CooP01n_[m007jn_?ono[ho`3jnP01n_[iookj0@00o_Z1oo[o0@00o?oi007o
ooT009[k0?fJ0OooniX0oofJoP01VY[i0?ko09[m0?bJn?olV_Co0IZJmP3ko`6J
V_h00IZJn_okVP7oV_D0o?l1VY[k0?OooY[eood0n_on00:Jooon00:JooolV_co
nI[noofJo_onV_go0IZJnP00V_Woo9[Ko`40oojJoOof0?^J0?omVP7oooL0l_ok
VP3ooP3nV_d0o_oh0?cooP00V_WooY[koobJn`3loo/0n?on0?ko09[n006JV]oo
o9X1ooonVP7oV_/00IZJoP00V_h0nook00>JV_oooI[n007oV_h009[_o`00g?l0
0?_o09[n0?fJmoon0?Oon`3nV_[o09[l0?jJiOol002Jm?l0V_/0oY[foo/009[g
o`2JoP00ooh00IZJjookV_CooP01VY[m006JV_?oni[ho`2JnP01VY[ioojJ0Ooo
oYZmo`@D]oom0?go0@00nOl00?_oo@3nooL0o_l00?Go003noo/0moom0?Coo@3b
o`400?ko0@00nOol007o0?3o0@00l_om0?Oo0@00oOok0?go003looT0nooj0?ko
o@3nooh0oOon0?_o003ioo`0fol10?on0?;on`00ood0nOon0?7onP3nooh0o?ok
0?Co003jood0nool0>[ooP3ko`00o_l1003Oood0o_on007o0?_o0@00o_l00?go
0@00n?l2003oo03mo`00o_l00>oo003Lo`00nol00?koo@00ood00?on0?Go0@00
n_on0?_o003kooh0j?l1003lo`400?Go003jo`400?Oo003ko`00mol00?ko003n
o`400>_on`3`o`400?kooP3dooX0nOl00?ko003no`400?Won@21oo?oo_[b003j
n`3mn_komo[n003jo000ooh0o_l0n_h0no[googjm?omn_d00?om0?_o0O[joP01
n_[ioocj0Oojm@3lo`7jn_/0n?omn_Oo0O[jm`00ooh00_[oooh00_X00?cjnooj
n_kooO[nookjoOonn_/00?[ioocjfol10?onn_gomP3knP3ooOX0oo`00OoooP3a
oo[joP3nn_80noon003jn_omn__oo_X10?[k0?gonP3koo/0o_l0n_h00O[jgoom
n_koo_X1oo[k007jn_h00?[k0?kon`02n_[oo?[n007on_h00?[_o`00g?l00?_o
0?[n0?gj0?om003ooP00ooh0nOl10?[j0?kjnol0n_/0o_[XooX00O[jmOl0n_X0
0O[jmooj003jmol0n_X00O[jjookn_CooP02oo[joP3nn_Con_[io`3joP00n_h0
0O[jnOonnP400?kjPOocoojJ0?om007oooT009[k0?fJo_ogV_h009[l003ooP3n
o`2JoP3kV_OooI[doofJo@00ood0nol1VY[n006JV_Woo9X1oi[e0?co0IZJn`3h
oofJmol1VY[m0?[ooP02V_oooP02V_ooo9[kooZJo_omV_kooY[moojJn`00V_Wo
o9[Ko`40oojJoOof0?^J0?omVP3oo001ooon0?7onY[n0?jJo000ooP0noon002J
n_omV__ooYX1oi[k0?gonP3hooh0o_l0V_h00IZJgoomV_kooYX1oi[k006JV_h0
09[m0?con`02VY[oo9[n007oV_h009[_o`00g?l00?_o09[n0?fJmoon0?So09[j
0?jJnol0V_/0oY[Voo`00IZJmOl0V_X00IZJm_ok002Jmol0V_h00?on006JV^_o
ni[dooh00_nJV_h0oY[dooZJnOl0V_h009[n006JV_WooYX1ooonV[go0o>good0
oOl1003io`00o?ol0?gon03no`00mOl00?kon`3UooT0mol00?go0@00moon007o
0?3ooP3doo`0mol1003nooX0oOl00?co0P00oo`0n_ok0?koo@3nooh0o?l1003k
o`00nOol0=_oo03booH0iooi0?koo@3loo`0n?l00?ko003jood0nool0>_oo@3k
o`00o_l1003Qoo/0o_on007o0?_o0@00o_l00?;on@3mo`00o_l00?3o0@00g?l1
003lo`00o_om003oo@00ood0m_l1003jooh0nol00?_ooP3Xo`400?co0@00mOl0
0?[o0@00mol00?_o003go`00o_l00?kooP3/oo/0l?l1003nooh0m?l00?go0@00
nOl00?ko003no`400?Won@21oo?ooO[c003jo03ln_gon?[i007oooh0o_l0n_h0
no[Uookjo000ooh0nol0n_d00O[jmoonnP7on_D0o?onn_`0nOoln_Oo0O[jm`00
ooh00_[oooh00_X0oocjn_okn_kooO[nookjo?l1n_[k003jnOoln]_o003mn_go
mP3gnP40ood0o_on0?;onO[n0?gjm03ko`3joP00n_[ooO[kookj0@3jnP01oooi
0?conP3no`3joP01n_[Qoo_jo_onnP7on_/00O[joP00n_d0o?ok0?[jo@01oo[n
003jl?l1003Lo`400?co0?[n0?gj0?om003onP3io`40n_X0o_[ko`3jn`3nn^So
nP01n_[eo`3jnP01n_[gooX00?[go`3jnP3nn^cono[dooh00_ojn_h0o_[do`3j
o@01n_[io`3joP00n_h00O[jnOonnP400?kjPOocoofJo@01oooi002Jo03lV_go
n9[n003oo@01ooon0?ko09[n0?^JiOonV__ooP3ko`2Jo@01VY[goojJ0OnJm@3l
oojJo03ioobJmol1VY[n0?WooP02V_oooP02V_ooo9[joo^Jo_omV_kooY[lo`6J
V_/009[ioobJfol00?fJoOof0?NJ0Oooo@3nooh0l_oiV_h0oI[d0?_o09[n002J
n_omV__ooYX1oi[j007oooT0n?on0?ko09[n006JV^7oni[noojJ0OnJn`01VY[n
002Jo@3loo/0nYX0ooh00OnJoP00V_3o0@00g?l1003lo`2JoP3mV_OooP3ho`2J
nP3nV__o09[k0?jJi_ol006JV_Go09[j006JV_Kon`00V_Oo09[n003ooP3nV^co
ni[dooh00_nJV_h0oY[do`2Jo@01VY[io`2JoP00V_h00IZJnOonVP7ooojJ_Ol4
<KOoo@3lo`00nOl00?coo03looX0nOl1003jo`00o_ok0>Gon03ho`00oOl1003c
o`400?7oo@00ooh0nOol0?Oo0@00o_oj0?go003lo`<00?ooo@3joo/0oOom007o
ooh0o?on0?co003ioo`0fool0?;om`3/ood00Ooon@3mooh0o?ol0?So003no`00
nool0?_oo03[ood0nol00?ko0@00h_ok0?gooP01o`3ko`400?ko0@00l_oj0?Wo
003_o`00g?l00?_o003nood00?om003oo@3fo`400?ko003nooh0nol00?_ooP3X
o`400?_o003eo`00n_l1003go`00nol1003ho`00o_l00?kooP3/ooX0lOl1003n
ooh00Oooo@3eo`400?Wo003no`00o_l1003iooT0POocoogj0?od003jo03ln_co
n_X0ooP00?on0?ko0?[n0?_jiOonn_P0nol0n_d00O[jlol1n_[k003oo@3loogj
0?on0?Woo?[go`7jn_h0oO[n003ooP02n_oooP03nP3ooogjn_okn_gooOX1ooon
n_coo_[l003jnOoln]_o003mn_gomP3gnP3oo03nooh0n?omnP7oooWjoP00ookj
0?og0?Wo0?[n003jnooln__oo_[^0?cooP00n_h0o_l0n_h00O[jh_okn_goo_X1
oo[k007jn_h00O[jo@3mooX0o?[l007oooh00?[_o`00g?l00?_o0?[n0?gj0?om
003onP3io`40n_h00?[n0?kjnol0n_/0o_[XooT00?[eo`3joP00ooh00O[jmooj
007jn_So0?[n003joP3nn^coo_[n003jmOon00;on_[n0?kj0OoooO[joo`00O[j
nOl0n_h00?[n007jn_Woo_X1003nnX7oloomVP3oo@00ooT009[l0?bJo?ojVP3o
nP3nooh0o_l0V_h0ni[UoojJnoon0?_o09[m006JV_?o0IZJn`00ood0o?omVP3o
oP3ioobJmol1VY[n0?fJoOon00:Jooon002Jo_omV_[oni[moofJ0OoooY[loojJ
o000V_Woo9[Ko`00oI[mooH0miX0oo`0o_on0?SooIX1oooiV_h00?onVP3om`3i
o`2JoP00V__oo9[koojJ0Oool03io`2JoP3no`2JoP01VY[Roo^JoOonVP7oV_/0
0IZJoP01VY[m0?gonP3lVP7oooh00OoooP00V^oo003Lo`00nol0V_h0oI[gooh0
n?l0V_h009[n0?jJnol0V_/0oY[Voo/009[eo`2JoP00ooh00IZJm_ok006JV_So
09[n002JoP3nV^cooY[n002JmOon00;oVY[n0?jJ0OoooI[joo`00IZJnOl0V_h0
09[n006JV_WooYX1ooonV[go14Bfood0oOl00?Wo003loo`0n_om0?SooP3ko`00
o_l2003ooP3UooP0n?l00?kooP3cood0noon0?_on@3kooD0o_on0?kon@3no`00
o?l3003oood0n?om0?goo000ooh0o?on007o0?go003koo/0foom0?7om`3]oo`0
0Oooo@00ooh0oOom0?coo@3ho`00n?ok0?_oo03no`00n?l00?_on`3ko`00o_l1
003Soo/0o?on007o0?_o0@00o_l1003boo/0n?l1003bood0gOl00?_o003nood0
0?om003oo@3fo`400?ko003nooh0nol00?_ooP3Xo`400?_o0@00mol1003jo`40
0?So0@00nol1003ho`00o_l00?go0@00kOoi0?7o0@00oOl2003on`3fo`400?Wo
003no`00o_on0?[on@21oo;ooO[^0?cjn_omnP7ooo@0o_l0n_h00_[jookjiOom
n_T0nol0n_h0o_[coogjnoonn__oo_[l0?_omO[nookjoP3ln_/00_[oooh00oX0
ooomn_SooO[moocj0?onn_coo_X0oo`00?[koo_jfol00?kjo?of0?Ojo03mooh0
nOolnP7oookj0@3oo_[n003ooO[i003jn?l0n_d0o?okn__oo_[l003jn000n_h0
o_om007jn_h0o_l0n_h00O[jhookn_coo_X1oo[k007jn_h00O[jo@3nooT0oOX2
003ooP01ooon007jn_;ooO[Mo`00nol0n_h0oOX0ood00?oj0?Wo0@3joP00n_h0
o_[ko`3jn`3nn^Son@01n_[go`7jn_h00?on007jn_Son@01n_[ho`3joP00n_d0
0O[jkOonn_`0mOon00;on_[m00;jn_okn__oo001n_[io`3joP00n_h0o_[jookj
0@00o_Z1oo;ooI[m003on@00oo`0o9[joofJ0OoonP3nooh0o_l0V_h00YZJoojJ
iOomV_cooP3ko`2JoP3nV_?ooI[koojJnoonV_`0nooeV_kooY[n0?bJo_on00:J
ooon002Jo_omV_SooI[moobJ0?onV_cooYX1ooom002JnookV]_o003nV_comP3g
V_`0oOon0?Woo9X1ooonVP7ooojJoP00oofJn@00V_So09[m0?coni[koojJ0Ooo
oP00V_P009[n0?[o0IZJoP3no`2JoP01VY[Soo^Jo?onVP7oV_/00IZJoP01VY[m
0?kon@3mV_kooP01ooon006JV_;ooI[Mo`00nol0V_h0oI[gooh0n?l0V_h009[n
0?jJnol0V_/0oY[Voo/00IZJmol1VY[n003ooP01VY[foo/00IZJn?l0V_h009[m
006JV^gooY[l0?GooP02oiZJo@02VY[oni[koo`00IZJnOl0V_h009[n0?jJn_on
VP7ooojJ_Ol4B;Koo@3mo`00nOl00?coo03do`00noon0?_o003no`400>7on03h
o`00o_on0??oo@3kooh0nooi0?_om001ooon0?kon@3no`00o?l1003bood0o?oi
0?cooP01o`3mo`400?con`3Kood0lOl00?goo@3^ooX00Oooo@3iood0nOl00?So
003iooX0o?ok0?ko0@00nOl00?ko0@3onP3ko`00o_l1003Soo`0noon007o0?Go
003fo`00o_ok0?So0@00l_om0=go003ko`00o_om003ooP3nooh0m_l1003no`00
oOon0?CooP3iooh0m?l1003ko`400?Oo0@00n_l1003ho`400?_o0@00n?l00?ko
003mo`400>gon03bo`400?go0P00oo/0o?l00?_o0@00n_l00?ko003mo`400?[o
n@21oo;ooOX0onl0o?[do`3jm@3no`3joP01n_[Qoogjn@3ko`3joP3nn_?ooO[k
ookjnoonn_`0noodnP7oookjoP3kn_`00_[oooh00OX0l_omn_conO[lookj0?ol
007jn_cono[Ko`00o_[looH00?[m003jn@3looh0noojnP7oookj003mooh00?om
nP3onP00n_So0?[m0?gon_[loogjo001n_[j007on_h00O[oo@3nn_h0o_l0n_h0
0O[jhooln__oo_X1oo[j003ooP01oo[f003jn000ooh00OoooP01n_[boogjgOl0
0?_o0?[n0?gj0?on0?kon`3io`40n_h00?[m0?kjo?oi0?kjnOon0?Co0@3jn`01
n_[go`7jn_h00?on007jn_So0@3jn`01n_[ho`3joP00n_d00O[jkOonn_`00?[f
ooh00_ojn_d00_[joo_jo?l0n_/00O[jn_l0n_h00?[m007jn_[oo_X1003nnX7o
l_omVP3ooP00ooT00?ol0?bJm?l0V_/0o_on0?ko09[n006JV^7ooI[looh0nol0
V_h0oY[coofJnoonV__ooY[l0?_om9X1ooonV_h0niX1ooon00:Jooon002JlOom
V_conI[loojJ0Oooo@01VY[loo^Jfol00?jJo?of002Jo@00V_T0o?on0?_onYX1
ooonV_cooP00oofJ0?oj002Jn?l0V_d0oOojV_cooIX1ooon006JV_X00OnJoP00
V_cooY[n0?ko09[n006JV^?oo9[koojJ0OnJnP00ooh00OnJmP00V_h0n_on007o
ooh00IZJl_omV]go003ko`2JoP3mV_OooP3ho`2JoP00V_d0oY[looT0oY[Xo`2J
n`01VY[go`6JV_h00?on006JV_Oo09[k006JV_So09[n002Jo@01VY[]oojJo000
V_KooP02oiZJo@02VY[oni[lo`2Jn`01VY[jo`2JoP00V_d00IZJn_onVP7ooojJ
_Ol4E[Koo@3do`00o?ol0?Co003lood0nol00?ko003Oood00?on0?ko003mo`40
0?ko0@00lOon0?_ooP3kooT0oOob00?oo`00oOoi0?ko0P3o0?ko0@00j?oj0?co
oP01oooj0?gon`3Kood0lOl00?goo03io`00n_oh007oood0n?om007oooX0noom
0?ko0P3oooT0o?ok0?ko0@00nOl00?ko0@3onP3ko`00o_l1003Too`0n_on007o
0?Go0@00mol00?kon`3ho`400?kooP3ioo`0gOl00?_o003nood00?on0?kooP3f
o`400?ko003mooh0m?on0?[oo@3do`400?_o0@00mol00?go003no`400?So0@00
n_l00?So003no`400?kooP3^ooP0lOl1003nooP0o?l00?_o0@00n_l00?ko003m
o`400?_om`21oo?ooOX0onl0o?[do`3jm@3no`3joP00n]oooOX0oo/00?[mo`7j
n_h00O[jlOonn__oo_[kookjo03moocjoP3jnP?ooo[jo@3kn_`00_[on_h00OX0
j?ojn_coo_X1ooom0?kjoOokn]_o003nn_comP00n_@0oOl0n_h0oOohnP7oookj
003mooh00OoooOX3ool00?cjnoomn_h00_[oooWjo?omn_`00O[jnOl0n_h00O[o
oP3mn_h0o_l0n_h00O[ji?oln_[oo_X1oo[j003ooP02oo[jm`00n_P00?on007o
ooh00O[jo_onn_Woo?[Mo`00nol0n_h0oOX0ooh0o_ok0?Wo0@3joP00n_d0o_[l
ooT0o_[jood0m?l1n_[k007jn_Oo0?[m003joP01n_[ho`40n_X00?[ho`3joP01
n_[n0?kjk_onn_`00?[fooh00ooon_[n0?Sjo?l0n_/00O[jn_l0n_h00?[m007j
n__ooOX1003mnX7oloomVP3om@00oo`0o9[do`2Jo03mooh0o_l0V_h009[OoofJ
oOon002JoOl1VY[n006JV_7ooY[koojJnoonV_`0oOolV_h0nYX3oonJV_d0niX1
ooon00:Joi[n002JioojV_cooY[nooh0oY[moo^Jfol00?jJo?of002Jm03mo`2J
oP3mooRJ0OoooY[looh00OoooI[moobJnoomV_h00Y[oooVJo?omVP7oooh00IZJ
nOl0V_h009[moofJoP3no`2JoP01VY[ToobJn_onVP7oV_X00?on00;oVY[g002J
oP3jooh00OoooP01VY[noojJnOolV]go003ko`2JoP3mV_OooP3ho`2JoP00V_d0
oY[looT0oY[Yo`6JV_/00IZJmol0V_d009[n006JV_Oo09[j002Jn?l0V_h00IZJ
oP3nV^kooY[l002Jm_on00?ooiZJoP3hV_co09[k006JV_[o09[n002Jo@01VY[k
oofJ0OoooIZno`B1]_ol0?Go0@00oOl00?3o003moo`0mol00=ooo000oo/0oOl1
003no`400?7ooP3kooh0noon003oo@01ooof007ooo`00_l00?gon@3no`80o`3n
o`400>SonP3lood00?oj0?gon`3Kood0lOl00?goo03io`00o_l00?kon003ool0
0?Koo@3moo/0o_ok0?komP3looh0noon0?[o003no`40ooX0nol00?kooP3Uood0
nOon007o0?ko003iooh0nOl1003mooh0mOl20?ooo@3ioo`0gOl00?_o003nood0
n_on0?Ko0@00o_l1003nooh0nOl1003nooh0n_om0?Co0@00nol1003go`00oOl0
0?go003ho`400?[o0@00nOl00?ko0@00o_on0?con@3kooX00Ol0lOl1003nooL0
oOl00?_o0@00m_l1003no`400?_om`21oo?o003mn_@00?[m003jl?l0n_d0o?[n
0?koo@00n]ooo?X0oo`00?[mo`7jn_h00O[jlOonn__oo_[kookj0?on00;joook
n_`00Oooo?X2oo[jo@01nP3ln_d00_[on_h00OX0j?ojn_cooOX0oo`00O[joOok
n]_ooO[looH00?[f0?_o0?[n003jo_ohnP?ooo[jo@01ooon007ooogjoOokn_ko
no[n0?Kjo?onn_/0o_[jo`3joP03n_l00?cjoP3no`3joP3nn^GooO[iookj0Ooj
oP00n_h00?on003oo_[i007jn_X0o_on007oood00_[ooogjnOoln]go003ko`3j
oP3mn_[on`3io`40n_h00O[joP3nn_cooP01n_[n0?kjn_om0?Co0O[jn`01n_[g
o`3jo@00n_d00?[ho`40n_X00O[jnOl0n_h00O[joP3nn_co0@00no[kookjo000
n_KooP03ooojn_h0mo[mo`3jn`01n_[jood00O[joP01n_[koogj0@00oOZ1oo?o
003mV_D00OnJo@00V_3o09[m0?bJoP3nood009[OoobJo_on002JoOl1VY[n006J
V_7ooY[koojJnoonVP3ooP02V_ooni[l007ooobJ0_nJV_d00I[oo9X0ooh00Y[o
V_h009[WooZJo?omVP3oo001VY[moo^JfoomV_comP00V_H0nol0V_h009[nooRJ
0oooVY[m007oooh00OoooI[moo^Jo_okV_h0mY[loojJn`3nV_[o09[n002Jo_ol
V_h0o_l0V_h0oY[UoofJnOonVP7oV_h009[n003ooP00oojJn@01VY[m0?_ooP01
ooom00:JooomV_Woo9[Mo`00nol0V_h0oI[gooh0n?l0V_h00IZJoP3nV_cooP01
VY[n0?jJjOl1VY[k006JV_Oo09[m002Jo@00V_Oo09[j006JV_Wo09[n006JV_h0
oY[joo^JnoonVP3oo@00V_KooP03oonJV_h0mi[mo`2Jn`01VY[jood00IZJoP01
VY[koofJ0OoooIZno`A[]_ol0?Go0@00o_l1003`o`00oOol0?Oo003Ooo@0o_l1
003no`400?7oo@3looh0noon0?colP00ood00_l00?kooP00oo`0o_l20?l0o_l1
003Woo/0o?om003on@3noo/0foom0>coo03io`00o_l20?ooo001ooon00?oo`00
m_om0?golP3noo/00OoooP3looh0noon0?[o003no`40ooX0nol00?goo03Xooh0
m?l00?ko003iood0o?om0?go003cooX0nOol0=go0@00o?l00?koo@3jooh0m_l1
003no`400?koo@3jo`400?koo@3koo`0mOl1003kooh0n?l00?ko0@00oOl00?So
0@00o_l00?ko0@00nOl00?ko0@00o_on0?gon03loo`0oOl00?7o0@00o_og0?Ko
0@00m_l1003nooh0o?om0?go0@00POoco`00oO[k003on`00n_h00O[jl?l0n_d0
o?[n0?koo@00n]oono[k003jo_l1n_[n007jn_7ooO[lookjnoonnP3oo@3in_X0
0?omnP;on_[n00?j003ooO[m00;joo[l0>Oono[loogj0?ol0?kjo_okn]_ooO[l
on/0n_l0n_h00_[ooocj0Oooo_X3ooojn_`00?on007ooogjoOobn_h0noX1ooon
n_coo_[k0?kjn_l0n_h00_[o0?_joP3no`3jo@3ln^Soo_[iood00OojoP00n_X0
0?omn_`0oO[l0?cooP01ooom0?[jnOoln]go0@00o?l0n_h0oO[joo/0nOl10?[n
007jn_h0oO[mooh00O[joP3mn__oo03eo`7jn_/0o_[ho`3joP01n_[m003jn?l1
0?[n003joP01n_[io`3joP01n_[n0?kjoOl1003jn_cooO[l003jm_on00?ooo[j
oP3gn_gonP01n_[jood00O[joP3nn_coo_[l007jnX7olol00?fJn`00oo`00OnJ
oP01VY[`o`2Jo@3lV_h0o_om002JgookVP3oo000V_ko0IZJoP01VY[aoofJo?on
V__ooYX0ood0nI[l0?kooIX2oiZJoP00V_kooIX0ooh00Y[oV_h0iOokV_cooIX0
oo`0oY[noo^JfoomV_coj`3jo`2JoP02V_ooo9X1ooonVP?ooiZJo000ooh00Ooo
oI[moo:JoP3kVP7ooojJo?onV_/0oY[jo`2JoP02V_ooni[n0?ko09[m0?bJj?on
V_Woo@01oi[n002JnP00oofJo03mV_d0noon007oood0nY[ioobJgOl1003lo`2J
oP3mV_OooP3ho`2JoP01VY[n0?fJoOon006JV_h0oI[Zo`6JV_/0oY[ho`2JoP01
VY[m002Jmol0V_h009[n006JV_Wo09[n006JV_h0oY[kooZJo?omVP3oo@00V_Ko
oP03oonJV_h0mi[mooX00IZJn_om006JV_h0oY[loojJ0?om006JV[ko16bfo`40
ooh0mOl1003no`400?3ooP00oo/0n?l1003NooD0o_l1003no`400?7oo03mooh0
noom0?gonP00oo`00_l0ooX0o_on007oood0o?l00?ko0@00i_ol0?_ooP00ooP0
0Ooon`3Kooh0j_on0?So003no`80ooom0?kooP02ool0m?om0?kolP3noo`0o_on
0?co0@00n_om0?_o003nooT0n_l00?goo03Xooh0m?l00?ko003iood0o?ol0??o
003nooX0nOol0=go003ko`00o_om0?[ooP3fo`400?ko0@00oOon0?[o0@00o_om
0?gonP3eo`400?[o0@00n?l00?kooP3no`00n?l1003no`00o_l1003io`00o_l1
003nooh0oOoh0?coo@3ko`00l_l1003mood00OoooP3eo`00moon0?kooP3lood0
o?l0087olol10?onnP3oo000oo/00?[n007jn_3oo_X0oo_joP3nooh00O[jg_ok
n_`00?[no`7jn_h00O[jlOoln_goo_[koogjo@3jnP3onP00oo[joP04nP00ooom
n_d00Oojo03VoocjnoonnP3oo03mnP7ooo_jfoonn_cok03ho`3joP02n_oooO[n
ookj0_oon_L0o_omn_kol_[n0?cjo_onn_co0O[jnP3mn__o0?[n007j0?_j0?on
0?ko0?[m0?cjj?onn_conP01oo[n003jnP00oogjo?oln_d0o?on00;ooo[n0?[j
nOoln]go003ko`3joP3mn_[on`3io`7jn_h00O[jo@3nn_gooP01n_[n0?gjoOol
nP400?Go0O[jnP01n_[ho`3joP3nn_h00?[ho`40n_h00?[n007jn_Wo0?[n007j
n_h0o_[mo`00nO[loogj0?ol003jmoon00?ooo[jo@3mnP7oookjoOoi003jn_on
0?kjoP3nn_coo_[k003jPOoco`40oojJ0?ol003oo001oi[n006JV_3ooYX0oo^J
oP3nooh00IZJg_okV_`009[no`6JV_h00IZJlOolV_gooY[koofJo@3jVP3on`01
ooojV_h009[moofJo@01oi[n0>Coo9[koojJ0?ol0?fJ0Oooni[KoojJo?o/0?So
09[n00:JooomV_kooYX2oonJm`3noofJo_obV_h0o9[noojJo?l1VY[j0?fJnol0
V_h00I[oniX0ooh0o_l0V_d0o9[XoojJo?oj007oV_h009[j003ooI[loobJo@3l
ooh00_ooV_h0nY[ioobJgOl00?_o09[n0?fJmoon0?Wo0IZJoP01VY[m0?jJoOon
006JV_h0oI[moobJlol1VY[j006JV_So09[n0?jJoP00V_Oo09[n002JoP01VY[i
o`2JoP01VY[n0?jJo?oiV_cooIX0oo`009[gooh00oooVY[m0?fJ0OoooY[mooT0
09[jooh0oY[n0?jJo?onVP3oo000V[ko19jfoo`0mOoj0?3om`3ho`400=gomP3n
o`00oOl1003`ooX00?on0?_oo03nood0o_ol0?ko0@3on`3no`400?koo@3lo`00
o_l1003Voo`0nooi003oo@01oook0>;o0@00oOom0=ko003no`40ood0oOon00;o
o`3doo`00OoooP00ooT00_l00?koo@3mooh0o?l1003jood0nol00?konP3ho`00
o_ol0>Wo0@00k_l1003iooh0o?ol0??o003nooX0nOol0>cooP3mo`400?_o003k
o`00o_om0?[ooP3fo`400?ko0@00oOon0?[o0@00oOon0?kon@3fooh0n_l1003h
o`00o_on0?kooP3jo`400?ko003nooh0n_l00?ko0@00oOl1003moo`00?on0?co
o@3ko`00l_l1003mood00Oooo@3nood0oOl1003hooh0oOl1003looh0nol0087o
lol1003nnP3oo000oo/0no[`ooWjo03nooh00O[jgOoln_`00?[no`3jo@01n_[`
oo[j0?onn__oo?[n0?gjo_oh003ono[n007j0?kooO[m007on_`0i_oln__oo?[m
0?gj0Oooo_[n0>;o0@00oOomn_cok03ho`3joP01n_omn_goo_X2ooojm`3noocj
0Oooo_X0ooWj0_ojn_h0oO[mookjo?l1n_[j0?gjnol0n_h0n_X1ooon0?go0?[n
0?cjjOl1n_[c003oo@01n_[k007oookjo?oln_D00_oon_h0n_[io`7jn_h0k?on
0?go0@00nol00?_o0?[n0?gjn_ok0?Wo0O[joP01n_[m0?kjoOon007jn_d0o_[n
oo[j003fookjnP01n_[ho`3joP3nn_h0o_[jo`40n_h00?[n0?kjn_l0n_h00O[j
o@01n_[mo`00oOX0ookjo?onnP40oo`00?[gooh00ooon_[m0?gj0OoooO[nooh0
0?[m007jn__ooP3nn_d00O[jo?onn_/00?Z1oo?o0@00oYX0oo`00?ol003oni[`
ooVJ0OoooP3nooh00IZJgOolV_`009[no`2Jo@01VY[`ooZJ0?onV__oo9[n0?fJ
o?ok007ooo^JoP00V_gooI[m007oV_h0i?olV__oo9[m0?fJ0OoooY[n0>;o0@00
oOomV_cok03ho`2JoP01V_omV_gooYX2oonJm`3noobJ0OoooYX0ooVJ0_nJV_h0
oI[moojJo?l1VY[j0?fJnol0V_h0nYX1ooon0?go09[n0?bJjOl1VY[c003oo@01
VY[k007ooojJo?olV_D00_ooV_h0nY[io`6JV_h0k?on0?go0@00nol00?_o09[n
0?fJmoon0?Wo0IZJoP01VY[m0?jJoOon006JV_d0oY[nooZJmOonV_X00IZJn?l0
V_h0oY[n0?jJnOl0V_h009[n0?jJn_l0V_h00IZJo@01VY[loofJ0?onV_cooYX1
oool002Jmoon00?ooiZJo@3mVP7ooofJo_on002Jo@01VY[kooh0oY[m006JV_co
oY[k002J__l4iKKo0@3ooP3eoo/0kooj00;o003lo`00o_l1003KooX01Ol00?oo
0?go003_ooH0n_om0?Oo0@00nol20?ooo03no`00o?om0?go003no`400>Goo@3k
oo/0oOon007oooX0i?l30?oo0?koo@3io`00l?l00?Wo003lood0oOon00;oo`3c
ood00OoooP3go`400?ko0@00noom0?go0@00o_om003oo@3lo`00oOol0?Oo003n
oo`0j_l1003]o`400?Woo@3moo`0lol00?konP3jooX0k_l00?ko1P3oo`3oo`3l
o`00nol00?koo@3jooh0m_l1003nooh0oOon0?_o0@00oOon0?kon@3fooh0o_l0
0?ko0@00n?l00?kooP00oo/0nol1003no`00o_on0?[o003no`400?go0@00o_ok
003ooP3lood0nol00?So003looh0o_l1003mood00Ooon`3no`400?So0P3o0?go
0@00o?on0?_o0021oo?o0@3oo_X0oo`00?ok0?cjkoojnP3oo002ooojoP01nP3K
oogjo@04n_[ooo[m003jkoofn_[ooO[n0?[on001oooln_h00?[loogjoP01oo[l
0>GooO[koo_jo@3nnP?ooo[jo03To`<0ool0o_on003jo?on003jl000n_Wo0?[m
003ooO[mookj0_oon_h00?ok0?gooOX1ooonn_Oo0O[jo03koogjoOl1n_[m0?kj
0?omn_co0?[m0?cjo_on0?go0?[n0?cjj_l1n_[b003oo@01n_[k007ooogjoOol
n_D00_oon_h0n_[jo`7jn_`0k_l00?ko1P3oo`3oo`3lo`00nol0n_h0oO[joo/0
nOl1n_[m007jn_d0o_[nooh00O[jo@3nn_kon_X00?Koo_[n003joP01n_[ho`3j
oP3nn_d0o_[ko`40n_h00?[n0?kjn_l0n_h00O[jo@01n_[no`00o?X0ookjo?on
nP40oo`00?[ho`3joP01ooonn_h00O[jo@3mnP7ooo`00?[n007jn__ooP02n_oj
o@01n_[lookjn`00nX7olol10?onVP3oo000oo`00?olV^oonY[nooh00_ooV_h0
09[JoofJo@04VY[ooi[m002JkoofV_[ooI[n0?Son`3noobJoP00V_cooI[n007o
V_h0hoomV__oni[m0?jJ0oooVY[l0>Co0`3oo`3nooh009[looh009[`002JnOl0
V_d00?omV_gooYX2oonJoP00oo/0oOomVP7ooojJmol1VY[n0?WooI[mo`6JV_h0
0?onVP3ooI[lo`2Jo@3lV_kooP3mo`2JoP3lV^[o0IZJlP00ood00IZJn`01ooom
V_goo9[e00;ooi[n0?ZJn_l1VY[l0>ko003no`H0ool0ool0o?l00?_o09[n0?fJ
moon0?Wo0IZJoP02oiZJo@3nV_kooP01VY[m0?jJo_ojV_GooY[n002JoP01VY[h
o`2JoP3nV_d0oY[jo`2JoP00V_h0oY[jo`2JoP01VY[m006JV_goo9X0oojJo?on
VP7ooo`009[ho`2JoP01ooonV_h00IZJo@3mVP7ooo`009[n006JV__ooP02V_nJ
o@01VY[loojJn`00V[ko1<6fo`40ooh0mOok0>kon`02o`00o?l00?ko0@00f_om
0?ko1000ool0o_l1003]ooP0n_om0?SooP3hoo`0o_l00?coo@3mo`00o_l1003U
ood0n_ol0?gom@3To`D0ool0oool0?Wo003`o`400?[o003mood0o?on0?3oo000
ooh0lOl00?_oo@3mo`400?koo@00oo`0oOl00?goo@3fo`00o_l10?on0>[o0@00
k_om0?[oo@3mooh00_l00?Co003jooh0n_oj0>[o1P3oo`3oo`3lo`00nol00?ko
o@3jooh0m_l1003nooh0oOon0?_ooP3nood00Ooon@3fooh0o_l00?go0@00nOl0
0?komP3lo`400?ko003mo`400?KooP3no`400?kom`3lood0nol00?So003ko`40
0?ko0@00o?on007ooo/0o_l1003ho`<0o`00o_l1003looh0nol0087olol10?on
nP7oood00?ok0?cjk_oknP3oo002ooojoP01nP3JoogjoP04n_[ooo[n007jn^go
n?[joogjoP3kooL00Oooo?[m0?cooO[n007on_`0iOomn_[oo?[m0?[jo03To`D0
ool0oool0?cooP00n_000O[jn_l0n_d0oO[lookj0Oooo@01oool0?goo?X0ookj
mOol0?_ooO[mo`7jn_d0o_X0oocjoOl0n_d0oO[mooh0oOl0n_d00?onn^[o0O[j
mP00ooh00?on0?gjo001ooomn_goo_X2oo[jmP02ooojoP3mookjn_l1n_[l0>[o
1P3oo`3oo`3lo`00nol0n_h0oO[joo/0nOl1n_[m007jn_d0o_[nooh0o_[n0?gj
0OoonO[fookjoP00n_d00O[jnOl0n_h0o_[l0?kjo?l10?[n003jo@01n_[jood0
o_[n007jn_ko003mnP400?kjo?onnP40oo`00?[ho`3joP3no`7jn_h00O[jo03n
nP7ooo`00?[n007jn__ooP03n_ojn_h00O[jo?onn_/00?Z1oo?o0@3ooYX1ooom
003oo000oobJk_okV_kooP02oonJoP00V]WooI[n00BJV_ooV_h00IZJkOohV_[o
oI[n0?SonP01ooolV_h0noomV_h00OnJoP3SoofJn_olV_d0nY[l0>Co1@3oo`3o
oo`0o?on002Jl001VY[jo`2Jo@3mV_cooYX1ooom007ooo`0oOolVP3ooY[eood0
n_omV_go0IZJoP00oojJ0?olV_go09[m0?fJoOon0?go09[n007ooojJj_l1VY[f
003ooP00ooh0oI[l007ooofJoOonVP;oVY[f00;ooi[n0?gooY[jo`6JV_`0j_l6
0?oo0?oo0?co003ko`2JoP3mV_OooP3io`6JV_h00_nJV_d0oY[nooh0oY[n0?fJ
0OoonI[foojJoP00V_d00IZJnOl0V_h0oY[l0?jJnol0V_h009[m006JV_[oo@3n
V_h00IZJoOomVP7ooojJo?onVP7ooo`009[ho`2JoP3no`6JV_h00IZJo03nVP7o
oo`009[n006JV__ooP03V_nJV_h00IZJo?onV_/009Zno`CM]_l10?om0?Kon`3^
oo`0o_l00?co003no`400=WooP3mo`<0ool0o_l1003[ooX0n_om0?SooP3good0
o_l00?_ooP3mo`00o_l1003Tooh0moon0?kom@3To`D0ool0oool0?Wo003aood0
nol1003nood0n?l00?WooP3looT0lOom0?gooP3mo`400?koo@01oool0?ko0@00
o_on0?Go003no`40ooh0moom0?Soo@01ooon0?Goo000ooh00Oooo03nooh00?on
0?[ooP02ool0o_l00?kooP3jooX0k?l1003no`<0ool0o?l1003lo`00o_om0?[o
oP3fo`400?koo@3nood0o?on0?koo@00ooL0n?om0?ko003mo`400?Wo003nooD0
oOl1003no`00oOl1003fooh0o_l1003nooL0o?om0?_o0@00nOl00?_o0@00moom
003on`3no`400?So0`3o003nooh0oOl1003jo`00POoco`40oogj0?om003on`3l
n^koo?[nood00_oon_h00OX0fOonn_d00o[ooo[n007jn^_on_[joogjo@3looL0
o_omn_d0noonn_h00Oojo03Tookjmoonn_h0n_[l0>Co1@3oo`3ooo`0o?on003j
l@3mn__o0O[joP3mn_T00Oojo@3mookjo?oin_Gon@3mookjoOl1n_[m0?kj0Ooo
o?[no`7jn_h0o_[looh0oOl0n_d00?onn_OooO[ho`3jn@3looh00?on007j0?kj
0?onnP7ooocjo_onnP3oo_[k003oo_X2ooojo@3nookjn_l1n_[l0>co0@00o_l3
0?oo0?co0@00o?l0n_h0oO[joo/0nOl1n_[m0?kjoP3mnP7oooh0o_[n0?gj0?om
nP00oOX00?SooO[n003jo@01n_[io`3joP3nn_`0oO[mo`40n_h00?[m007jn_[o
o@3nn_h00O[jo_omn_h0o_[lookj0@3oo001n_[io`3joP3no`7jn_L0oOX0oo`0
0?[n007jn__ooP03n_ojn_h0o_[mo`7jn_X00?Z1oo?o0@3ooIX0ood00?ol003o
o9[^oobJoOon00;ooi[n002Jf?onV_d00i[ooi[n006JV^_onY[joofJo@3iooX0
o_omV_h0n_onV_h00OnJoP3RoojJmoonV_h0nY[l0>Co1@3oo`3ooo`0o?on002J
l@3mV__o0IZJoP3mV_T00OnJo@3moojJo?oiV_Goo@3ioojJoOl1VY[n003ooYX1
ooolV_ko0IZJoP3nV_cooP3mo`2JoP01ooonV_OooI[ho`2Jo03iooh00?on006J
oojJ0?onVP7ooobJo_onVP3ooY[k003ooYX2oonJoP3moojJn_l1VY[l0>co0@00
o_l30?oo0?co0@00o?l0V_h0oI[gooh0nOl1VY[n003ooY[n0?fJ0OoooP3nV_h0
oIX0oofJ0?omV_OooI[n002Jo@01VY[io`2JoP3nV_`0oI[lo`2JoP00V_d00IZJ
n_om0?jJoP01VY[noofJo_onV_cooYX1oool006JV_Wo09[n0?ko0IZJm`3mVP3o
o000V_h00IZJnoon00>JoiZJoP3nV_go0IZJnP00V[ko1=Jfo`40ood0m_ok0>ko
o03no`00o?l00?ko0@00fOon0?go0`3oo`3no`400>[on`3]ooh0o_l00>gooP3m
o`00o_l1003Tooh0m_l1003moo/00?on0>?o1@3oo`3ooo`00_l00?co003aoo`0
o?l1003nooh0mol00?WooP3looT0mOl00?ko003io`400?go003mood00OoonP02
o`00o_l1003do`00o?on0?Soo03hooL0m_ol003ooP3noo`00OoooP00ood0noon
00;oo`3no`00o_on0?[on`3Yo`H0ool0ool0o?l00?_o003nood0n_on0?Ko0@00
o_om0?koo@3looh0oOon003oo000ood0n?om0?ko0@00o_l1003io`00o_oe0?go
0@00o_l1003nooh0n?om0?ko0@00o_og0?coo@3ko`400?Wo003ko`400?KooP01
ooon007o0?go0@00nOl30?l00?kooP3mo`400?[o0021oo?o0@3ooOX0ood00?ok
0?cjk_oln_koo@02ooojoP01nP3Iookjo@03n_oon_h00O[jj_okn_Koo@3loo/0
0?[m0?coo@3jookjoP01oo[l0>Coo_[fo`7jn_d0no[m0>?o1@3oo`3oooT00Ooo
oP00n_40o?[lo`7jn_h0o_[h007on_h0o?onn_conO[eo`3jm@01n_[mo`3jo03n
nP7ooo[j0_ojn_`0noon0?go0?[m003oo_[hoocjn?og0?gooP00ooh00OX0o_X0
ookjo_olnP7oookj0?omn__oo_X2ooojo@3nookjn_onn_h0jOl60?oo0?oo0?co
003ko`3joP3mn_[on`3io`7jn_d0o_[n0?gj0OoooP3nn_d0o_X0oogj0@3ooO[h
oogjoP01n_[n007jn_Wo0?[n0?kjo03mn_go0@3joP01n_[n0?kjnoon0?gjoP01
n_[noogjoP3nn_coo_X10?ol007jn_Wo0?[n0?ko0O[jmP3nnP7oooh00Oojo@01
n_[looh00o[on_[n0?kjoOl1n_[j003jPOoco`40oofJ0?om003oo000oobJk_ol
V_gooP02oonJoP00V]SooY[m00>JoonJoP01VY[Zoo^Jm_om0?WooP00V_d0o?om
0?[ooY[n007oV_h0h_onV_Ko0IZJo@3kV_d0hol50?oo0?oon`3mooh009[a0?bJ
o?l1VY[n0?jJn001oi[n0?cooY[looVJmOl0V_h00?oi006JV_go09[m003ooYX1
ooojVP;oVY[n0?WooP3mo`2Jo@00oojJn?olV_Soo03hooh00?on006JoojJ0?on
V_koo9X1ooonVP3ooI[koojJ0_ooV_h0oOonV_[ooY[n0>Wo1P3oo`3oo`3lo`00
nol0V_h0oI[gooh0nOl1VY[n003ooY[n0?fJ0OoooP3nV_d0oYX0oofJ0OoooI[h
oofJoP01VY[n006JV_Wo09[n0?jJo03mV_co09[n006JV_h0oY[kooh0oI[n006J
V_kooI[noojJo?onVP7ooo`00IZJnOl0V_h0o_l1VY[f0?jJ0OoooP01oi[m006J
V_cooP03V_nJV_h0oY[mo`6JV_X009Zno`CI]_l20?oooP01ooon0?_oo03]ood0
oOl00?co003no`400=SooP3no`<0ool0o_l1003Yoo`0m_l00?Wo0@00oOl00?So
oP3iooh0oOl00?ko0@00eOl00?gon`3no`00hol30?oo0?kooP3no`400?go003f
o`00oOoj007oooh0o_l1003fo`00o_om003ooP3kooX0mOl00?Co003mo`00oOom
0?kon03no`400?Co003`oo`0nOof0?Kon03noo/00?on003oo@3kooh00_oo0?ko
003nooh0n_on0>[o003no`H0ool0ool0o?l00?_o003nood0nOl1003fo`400?ko
o@3mooh00Ol0o_on0?gooP00oo`00?ol0?Woo@3no`400?kooP3jo`00o_oj007o
ood0o_l00?go0@00o_on0?So0`3o003mo`80ooof0?goo03jo`00nOl00?_ooP3g
ooh0nol00?go0@00nOl30?l00?go0@00oOl10021on_o0P3oookj0OoooP00oo/0
oO[]oogjoOom00;ooo[n007j0=Soo_[n00?jooojoP01n_[Yoocjm_l0n_d0oOok
003jo03mood0n_onn_h00Oojo03Eo`3jo@3kn_h00?[So`<0ool0o_oi003ooP00
n_H00?[m0?[j0Oooo_[n007jn_L00OojoP3mnP3oo_[koo[jmOl0n_@00?[mo`3j
o@3mn_kon?[l0?_ooP3mo`3jo@00ooh0n?oln_Wo0?[g0?gooP00ooh00OX0n_[n
oo_j0?onnP3ooO[kookj0_oon_d0o_onn_[oo_[n0>go003no`H0ool0ool0o?l0
0?_o0?[n0?gjnOol0?Wo0O[jo@3nn_d0o_X1oo[n0?kjo@3nnP3oo_X2003ooOX0
0?Woo_[m007jn_h0o_[jo`3joP3mn_`0oO[noo`00O[joP3nn__ooP03n_ojn_d0
0o[oo`3mn_h0o_[moogj0@3on`00n_Wo0?[n0?koo_[g0?kj0OoooP01oo[m007j
n_cooP03n_ojn_d00O[joOl1n_[n003oo@21oo?o0P3ooojJnool003ooI[]oofJ
o?on00;ooi[n002JeoonV_h00i[ooi[n006JV^Woo9[fo`2Jo@3kood009[l0?go
o@3joojJoP01oi[n0=?o09[m0?^JoP00V^?o0`3oo`3noo/0o_on002JmP00V_d0
nYX1ooonV_h00IZJm`01oi[n0?fJ0?onV__onY[eo`2Jm000V_go09[m0?fJo_oh
V_h0nOon0?go09[m003ooP3hoobJnOl0V_`0n?on003ooP01V_ojV_koniX0oojJ
0?omV__ooYX2oonJoP3moojJn_onV_h0kOl00?ko1P3oo`3oo`3lo`00nol0V_h0
oI[gooh0nOl1VY[n003ooY[m0?jJ0OnJoP3nV_d0oYX0oojJo_omV_SooYX0ooh0
0IZJoP3nV_[o09[n0?fJo03mV_goo@01VY[n0?jJnoon00>JoiZJo@00V_kooI[n
oojJoOomVP7ooo/009[io`2JoP3noojJm`3nVP7oooh00OnJo@01VY[looh00i[o
VY[m006JV_go0IZJoP00ood0__l4[KKo0P00ooh00OoooP3ko`40ooh0iOl00?co
003no`400=SooP3no`<00?l0o_l1003Yoo`0m_l00?Wo003lo`400?[oo03io`40
0?Wo0@00eOl1003noo`0oOl00>;o0@00oOl1003lo`400?ko003fo`00oOoi003o
oP3no`400?Ko003nooT0n_ok0?Go003do`00oOl00?koo03looX0kol1003boo/0
nOod0?So0@3onP3mooP00OoooP3kooh00_oo0?3ooP3Yooh0oOl1003ko`00nol0
0?koo@3io`400?Ko0@00o_om0?goo03nood0o_on003oo001ooom0?Woo@3no`40
0?kooP3jo`00o_l30?l00?coo@3no`00oOl1003mo`400?So0`3o003mo`80ooom
003on`3moo`0n_l00?Wo003kooh0nol00?koo03mo`400?ko0@00nOl30?l00?go
0@00oOl10021on_o0P00ookj0OoooP00oo/00?onn^Goo@02ooojoP01nP3Hookj
oP03n_[on_h00O[jjOoln_Ko0?[l0?kon`01n_[m0?koo03io`7jn_h00?ok0=Go
0O[joP3ln_d00?[Ro`400?go0O[jm`00n_H00?[m0?Wj0?onn_h00O[jo@3nooh0
0OojoP3in_[ono[eo`3jm000n_go0?[n0?cjo?ojn_<0oOl1n_[j0?Wono[io`3j
o001n_[l007oooh00?on007joo[joOohnP7oookjnoonnP;ooo[g0?[oo_[n0>co
oP3mo`400?_o003ko`3joP3mn_Woo03io`7jn_`00O[jo@3ln_h0oO[n0?kj0?on
nP<00?oooO[iookjo@01n_[n0?kjn_l0n_h00o[on_[l0?gjo_ok003jo@01n_[k
ooh00o[on_[m00;jooomnP3ooP3nn_gooOX10?ok003jnOl0n_h0o_onn_L0oO[m
00;on_[n007jn_cooP03n_ojn_d00O[joOl1n_[n003oo@21oo?o0P00oojJnool
007ooojJi?on00;ooi[n002JeoonV_h00iZJoi[n006JV^Woo9[fo`2Jo03moo`0
0IZJo@3noo`0nOl1VY[n003oo@3Co`6JV_h0o9[m002Jh_l1003mo`6JV_`00Ooo
oP00V_H009[m0?VJ0?onV_h00IZJo@3nooh00OnJoP3iV_[oni[eo`2Jm000V_go
09[n0?bJo?ojV_<0oOl1VY[j0?Woni[io`2Jo001VY[jooh00?on006JooZJoOoh
VP7ooojJnoonVP;ooi[g0?[ooY[n0>cooP3mo`400?_o003ko`2JoP3mV_OooP3i
o`6JV_h00oooVY[m0?bJoP3mV_h0oYX0oojJoOomV_WooYX0ooh00IZJoP3nV_[o
09[n00>JoiZJo03mV_goo@01oi[m006JV__ooP03V_nJV_d00Y[ooofJoOonV_go
oIX1oook002JnOl0V_h0o_onV_/00?on0?fJ0?on00;oVY[n006JV_cooP03V_nJ
V_d00IZJoOl1VY[n003oo@2no`Aa]_l20?oooP01ooom0?co003Qood00_oo0?ko
0@00eol1003no`<00?l0o_l1003Xood0m_l00??o0@00n_ol0?Wo0@00nOl1003E
o`400?koo03mo`00g?l1003lo`400?ko003foo`0o_oh0?ko003eo`00o_oi0?Wo
o03eo`400?_o0@00oOl00?go003noo`0nook0>oo0@00looj0?Wol`3io`80oook
0?con@01ooom0?cooP02ool0l?on0=[o003ko`00o_om0?Wo0@00moon0?koo03n
oo`0o_om0?kon001oool0?[oo@3no`400?go0@00n_l00?ko0@3oo@3mood00_oo
0?kooP3mooh0nOl40?oo003no`80ooom003on`3moo`0n_l1003jo`00noon007o
ooh00Ol0oOom0?go0@00o_on0?[o103oo`00o_l1003nooh0oOom087olol20?oo
o_X1ooog0>7oo@02ooojoP01nP3Go`7jn_h00o[joo[n007jn^SooO[fo`3jn`00
ooX00O[jo@3noo`0nOl1n_[n003on`3Eo`7jn_h0o?[m003jg?l1n_[g003jmP3l
n_kon?[n003jo@3mooh00OojoP3in_Woo?[eo`7jn_D00?[mo`3joP3ln__ono[c
0?go0O[jnP3joo[jnOl1n_[n0?gjo000ooh00?on00;joookn_conOX1ooomn_co
o_X2ooojm`3jookjoP3Mo`00nol0n_h0oO[ioo`0n_onn_`0o_[n0?cjoP3mn_h0
n_X3003ooocjn_onn_d00O[jo@01n_[jo`3joP01n_omn_d0oOX1ooom00;j0?[m
0?kjo?on00Cjooojn_h00_[ooogj0?on0?kjoOonnP800?ok007jn_[o0?[n0?ko
o_[f0?kjo@02oo[joP3nn_gooP04n_oon_[n007jn_koo_[n003oo@21oo?o0P3o
oojJnool0=oooP02oonJoP00V]Ko0IZJoP03VY[oV_h00IZJj?omV_Ko09[k003o
nP01VY[m0?koo03io`6JV_h00?om0=?o0IZJoP3lV_d009[Lo`6JV_`00OoooP00
V_H0o9[nooRJoP00V_d0oOon007oV_h0nI[ioobJmOl1VY[k007oood009[mo`2J
oP3lV__oni[c0?go0IZJnP3jooZJnOl1VY[n0?fJnoon003ooP02V_ooni[looVJ
0OoooI[loojJ0_ooV_L0n_onV_h0gOl00?_o09[n0?fJmoon0?[ooY[n007ooojJ
oP3lV_h0oI[n0?ZJoOolV_[ooYX0ooh00IZJo@01VY[jo`2JoP01V_omV_d0oI[n
ooh00Y[oV_d0oY[looh019[ooiZJoP02V_oooI[moojJoOonV_kon`01VY[jo`2J
oP3noojJn`00ood0oYX0ooh00_nJV_h0oY[mooh019[ooiZJoP01VY[noojJoP01
ooon0;ko182fo`80ooon007oood0o?l00>7oo001o`3no`400=Ko003mo`80o`3n
o`400>Soo@3fo`400?Goo@3koo`0nOl1003jo`400=Co0@00oOom0?ko0@00fol1
003mo`400?ko003foo`0oOoi0?ko003eo`00o_oi0?Soo@3eooL0oOl00?go003n
oo`0n?om0?3o0@00n_l00?_onP3io`400?kon03io`80oook0?_onP01oool0?go
oP03ool00?7ooP3Jo`400?co003nood0nOl1003gooh0o_ol0?koo03lo`400?go
nP3mood0nool0?go003mo`400?[o003no`40ood0oOom00;o003nood0o_on0?go
003no`@0ool00?_ooP01oook0?goo@3io`400?;o0P00oo/0oOom0?go0@00o_on
0?ko003no`@0ool00?ko0@00o_on0?goo021ooCo0P3oookj0Ooom`3Qoo`00Ooj
oP01nP3Fo`3jo@02n_ojoP01n_[Xoogjm_l1n_[e0?gjo@01oool0?Wo0O[joP00
ooh00OX0e?l1n_[m0?gjoP01n_[Ko`7jn_P00?[f0?cjoOoin_h00?[m0?gooP01
oo[n0?Wjn?omn_GooO[k003ooP00n_go0?[n0?cjn?omn_@0oOl1n_[j003jnooj
n_Wo0O[joP3ln_d00?on003ooP02n_oono[koo[j0Oooo?[mookj0ooon_[h0?[o
o_[n0=go0@00o?l0n_h0oO[ioo`0n_onn_`0o_[n0?cjoP03ooojn_d0noX00?go
oO[koogjo@01oo[m007jn_[o0?[n007joogjo@3mnP3oo003nP3jn_h0o_[mo`3j
oP04n_oon_[m007oookj0OoooP3nn_goo_X10?oj007jn_[oo@3mo`7jn_/00?[m
0?kjo@02oo[joP3nn_ko0?[n00Cjooojn_h00O[jo_onn_h00?ol087om?l20?oo
oY[koo`0h?ol007oV_h009[Eo`2Jo@02V_nJoP01VY[XoofJm_l1VY[e0?fJo@01
oool0?Wo0IZJoP00ooh009[Co`6JV_d0oI[n006JV]_o0IZJo@01ooon002JmP3l
V_gonI[n002Jo@3mooh00OnJoP3iV_SooI[eoofJn_on002JoOl0V_h0o9[hoofJ
m03mo`6JV_X009[kooZJnOl1VY[n0?bJo?on003ooP02V_ooni[kooZJ0Oooo9[m
oojJ0oooVY[h0?[ooY[n0=go0@00o?l0V_h0oI[gooh0n_onV_h00OoooY[n0?bJ
oP03oonJV_d0ni[loofJnoomVP3ooP01oi[m006JV_[o09[n006JoofJo@3mV_ko
oP03V_nJV_h0oY[mo`2JoP04V_ooVY[m007ooojJo?onV_gooYX1oooj006JV_[o
o@3mo`6JV_/009[m0?jJ0?on00;oVY[n0?jJo_l0V_h019[ooiZJoP01VY[noojJ
oP00oo`0_ol4E;Ko0P3oooh0o_on0?co003Qoo`00Ol0o_l00=3o0P3o0?ko0@00
ioon0?KooP3goo`0n_on0?So0@00n_l1003Co`00oOom0?ko0@00foon0?go003n
o`00m_ol0?con`3`o`00o_oi0>Son`00ood0o_l00?go003nooh0lol00?3o0@00
n_l00?com@3nooh0o_oh0?Wo0P3ooo/0n_ok007ooo/0o_on00?oo`00l_om0=[o
003ko`00o_om0?Wo0@00moon0?koo03mood0o?l1003mooX0oOol0?coo03mo`40
0?kooP3ko`00o_l10?ol0?gon`3nood0o_on0?go003no`@0ool00?coo@01oook
0?goo@3io`400?;o0P00ooX0o_om0?co003mo`400?ko003no`@0ool00?ko0@00
o_l1003loo`0POodo`80ooonn_kon03Qoo`00Oojo@3Dood00_[on_h00O[jioon
n_Koo_[g0?cjo@3nooh0n?l1n_[n003ooP01nP3Co`3jo@3mn_h00O[jfoonn_T0
0?[f0?cjo?oknP3onP3looh00OojoP3in^SooOX2003onP00n_go0?[n0?kjlol0
n_/0o_om0?go0O[jnP00n_comO[nookjoP3kn_h00?on003ooP02n_oono[joo_j
0Ooono[nookj0ooon_[h0?_ooO[n0=go003ko`3joP3mn_Woo03jookjo03nn_d0
oO[n00?ooo[jo@3lnP400?goo?[loogjo@02oo[joP3nn__o0?[n007joocjo@3m
n_`00oX0n_[n0?kjoOl0n_h01?[ooo[jo@00oogj0OoooP3nn_goo_X10?oj007j
n_[oo@3mo`7jn_/00O[joP3mn_h00_oon_d00O[jo_l0n_h01?[ooo[joP01n_[n
o`7jn_d00?ol087om?l20?oooY[koo`0h?ol007oV_h0doom00:Joi[n006JV^Oo
oY[foojJm`3lV_d0o_on0?So0IZJoP00ooh009[Bo`2Jo@3mV_h00IZJfoonV_d0
0?on002JmP3lV_coniX0ooX0o?on007oV_h0nI[XoofJn_on002JoOl0V_h0oY[c
o`2Jn`3nood0oOl1VY[j002Jo?oeV_kooY[n0?^JoOon003ooP02V_ooni[joo^J
0Oooni[noojJ0oooVY[h0?_ooI[n0=go003ko`2JoP3mV_OooP3joojJoP01ooon
V_d0oI[n00?ooiZJo@3lV__oo9[loofJ0?on00;oVY[n0?jJnol0V_h00I[oo9[m
0?fJ0OoooP03V_nJV_h0oY[mo`2JoP04V_ooVY[m003ooI[loojJoOonVP7oooX0
0IZJn_om0?go0IZJn`01VY[n0?fJoP02oonJo@01VY[no`2JoP04V_ooVY[n006J
V_ko0IZJo@00oo`0_ol4J[Ko0P3oooh0o_on0?co003Qoo`0o?l00=Co003no`80
o`3no`400=Soo@3jooX0k_l00?[o0@00dol1003nood0o_l1003Kooh0oOl00?ko
003foo`0iOl00?ko003nood0ioon0?koo@3io`00o_l1003bo`00moon0?gooP3k
o`00oOoc007oooh0oOoi0?Wo003noo`0nOol0?kon`01ooon00?oo`00o?l00?So
o@3Jo`00nol00?koo@3io`400?OooP3noo`0oOom0?cooP3nooX0oOol0?gon`3m
o`400?kooP3ko`00o_l10?ol0?gon`3nood0oOl1003mo`00o_l20?oooP3mood0
0Ooon`3mood0oOl00?go003go`00oOog0?koo@3lo`00oOl1003no`00nol1003m
o`00o_l1003loo`0POodo`80ooonn_ko0P00n_/0hOol003oo03Do`3joP02n_oj
oP01n_[HookjnP00oo[jo@01ooon0?Oo0?[n003ooP01nP3Co`7jn_h0oO[n007j
n]_oo_[i003jmP3ln_GonP3looh00OojoP00n_kooO[Wookjo_oi0?go0?[n007j
n_;o0?[l0?coo_[mookjn`00n_goo?X00?Wj0Oooo_[n003oo?[n003ooP00ooh0
0?[noocjnOoln_konoX1ooonnP?ooo[jn03koogjoP3Mo`00nol0n_h0oO[ioo`0
n_onn_/00O[jo@3mn_h00Oooo_[n0?cj0@00oOl00?gjoOomn_`00_ojn_h0o_[k
o`3joP01n_oln_d0o?[m00?j0?[jo@01n_[mo`3joP02n_ooo_[n003ooOX1ooon
0?kjoOonn_`00?[m003jn_on003joOonn_`00O[joP3mn_h00_oon_d00O[jo_l0
n_h0o_l1n_[m003jo_l1n_[m003oo021ooCo0P3ooojJo?l0V_`0h?ol003oo@3C
o`2JoP02V_nJoP01VY[HoojJ0?ok003onY[m007oooh0mol0V_h00?on002Jd_l1
VY[n0?fJoP01VY[KoojJo@00ooh009[f0?bJmOoj0?cooP01oi[n002Jo_omV^Oo
oY[jood0oOl0V_h00IZJl_l0V_`0o?onV_gooY[k002JoOolVP3onIX1ooonV_h0
0?olV_gooP00ooh009[noobJnOolV_koniX1ooonVP?ooiZJo000ooh0noomV_h0
gOl00?_o09[n0?fJmoon0?[ooY[n0?ko0IZJo@3mV_h00OoooY[n0?bJn_omV_go
oIX1ooon00;oVY[n0?jJnol0V_h00I[oo9[m0?bJ0?on00>JoiZJo@01VY[mo`2J
oP02V_oooY[n003ooI[loojJoOonVP3oo@00V_d009[jooh009[moojJo001VY[n
0?fJoP02oonJo@01VY[no`2JoP3no`6JV_d009[no`6JV_d00?ol0;oo172fo`80
ooon0?kooP3lo`00h?on0?_o003Do`00o_l20?l0o_l1003Hood0o_on003onP3^
o`00n_l1003Co`400?gooP3no`400=_oo@3no`00o_l00?Koo03_oo/0oOl00?ko
003Pood0o_on0?Wo003no`400?;ooP3iooh0oOok0?ko0P3ooo000?on0?conP3i
o`00oOom0?Soo@3moo/00?on0?konP3no`400?gooP3Io`00nol00?koo@3io`40
0?OooP3moo`0oOon0?cooP3mooh0n_ol0?gon`3mo`400?gooP3lo`00o_l20?oo
o@3loo`0o_l30?l00?gooP3no`00o_l20?oooP3noo`0o_ol0?goo@3mo`00oOl1
003ho`00oOon003on`3mooh0o?l1003nooh00_oo0?_o0@00oOl00?ko0@00noon
087olol20?ooo_[no`800?[k0>3oo@00oo`0e?l0n_h00_[on_h00OX0f?onnP00
o_on003on_[m003oo@3go`3joP00ooh00OX0dol1n_[m0?kjoP01n_[KoogjnP00
n_H0o?[eoo/0no[n007on_h00?[Poogjo_oj0?go0?[n007jn_;oo_[iookjoOon
n_/00_[ooo[j003hnP3oo_[n007ooocj0P00ooh00?on003joOomn_SooO[moo_j
0?onn_koo_[j007jn_goo_[m0=go003ko`3joP3mn_Woo03jookjoP02o`00o_[n
003oo_[n007oookjo@3nn_`00ooo003nn_gooO[l00;on_[m0?kjo?l0n_h00_[o
oogjo@00oogjo@03n_ojn_d0o_[no`3joP02n_ooo_[n0?gj003no`400?kjoOon
n_`00?[m007jn__ooP00n_goo_[m0?kjo@3nn_h00ooon_[n0?kj0_oon_h0o_l1
n_[m003jo_l1n_[n0?kooP21oo?o0P3ooojJo?l0V_`0goom003oo@3Co`2JoP02
V_nJoP00V]OooY[iooZJo@00ood0mol0V_h00?on002Jd_l1VY[m0?jJoP01VY[K
oofJoP00ooh009[f0?bJmOok0?^JoP01oi[n002Jh?omV__oo@3mo`2JoP01VY[b
oojJnOonV_gooY[nooh00Y[oooZJ0?ohVP3ooY[n007ooobJo_on003ooP00V_go
oI[hoofJoOokVP3ooY[noojJoOon006JV_gooY[m0=go003ko`2JoP3mV_OooP3j
oojJoP3noojJoP00oojJoP01ooonV_d0oY[l0?gooY[moofJ0OoooP02oiZJo@3n
V_co09[n00:JooomV_d00?omVP3ooP03V_nJV_d0oY[no`2JoP02V_oooY[n0?fJ
noonV_gooYX0ood009[m006JV__ooP00V_gooY[m0?jJo@3nV_h00oooVY[n0?jJ
0_ooV_h0o_l1VY[m002Jo_l1VY[n0?kooP2no`@n]_l20?oooP3nooh0o?l00=So
0@00e?l00?ko0P3o0?ko0@00f?om007oood00?on003ooP3^o`00n_l1003Co`40
0?Oo0@00foom0?[o003goo/0kook0?Wo003PooH0n_l00?ko0@00l_om0?[ooP3m
oo/0oOo^003ooP3koo/0nOl00>oooP3looP0o_oj0?kooP3nooh0fOl00?co0@00
o_om0?Wo0@00moon0?goo03mo`400?_ooP3mo`400?Soo@3moo/0oOl1003mooh0
oOl1003no`80oool0?goo03no`40ooh0o_on0?ko003no`80ooon0?koo03noo`0
o_ol0?kooP3no`400?So003mooh0oOon0?gooP3lo`400?kooP02ool0n_l1003n
o`00o_l1003kooh0POoco`80ooonn_ko0P00n_/0h?om003ooP01nP3Do`3joP02
n_ojoP01nP3Hoogj0Oooo@00ookj0?onn_P0mol0n_h00?on007j0=?o0O[jo@01
ooom007jn]_ooO[j003jm`3kn_Gon`3kn_h00?om003jh?oin_/0oOl0n_h00O[j
l_omn_[oo_[mookjnP3in_`0noX0ookjoP3noocj0@3ooP00ooh00?[_ookjo?oh
n_koo_[j0?kjo_onn_d0gOl00?co0O[joP3mn_Woo03jookjoP02o`00o_[n00;o
n_[m007oookjo@01n_[k0?ko003nn_goo_[k00;o0?[m0?kjoOl1n_[n00;joool
n_d0o?[n00Cjo`3jn_h0o_[no`3joP02n_ooo_[n0?gj003no`400?kjo_omn_d0
o_[n007jn__ooP00n_goo_[m0?kjo@3nn_h00ooon_[n0?kj0_oon_h0oOl1n_[n
003jo_l1n_[n0?koo_Z1oo?o0P3ooojJo?l0V_`0goom003ooP00V]?o09[n00:J
oi[n002JeoomV_[ooYX0oojJn03go`2JoP00ooh009[Bo`6JV_d00Oooo@01VY[K
oofJnP00V_L0ni[eoo/0ni[n003oo@00V^3onI[nooh0oOl0V_h00IZJl_omV_[o
oY[moojJo_om0?VJ0OoooP3kVP3ooY[n0?koo9X1ooon003ooP00V^oooY[looRJ
o_onV_gooP3nV_kooY[m0=go003lo`6JV_h0oI[gooh0n_onV_h0o_onV_h00_nJ
V_d00OoooY[m006JV_/0oOonV_gooY[nooh00_ooV_d0oY[mo`6JV_h00Y[ooobJ
o@3lV_h019[ooiZJoP3nV_ko09[n00:JooonV_h0oI[koojJo_omVP3ooP3nV_h0
0IZJnoon002JoOonV_d0oY[m0?jJoP03oonJV_h0oYX2oonJoP3mo`6JV_h009[n
o`6JV_h0o_onV[ko14^fo`800?om007oooh0o?l00>3o003jo`400=Co003nooh0
o_l1003Hood00Oooo@00ooh00?om0?[o003go`00n_l1003Cooh0n?l00=[oo@3j
o`00oOl00?con`3_oo/0nOl00>3omP3jo`00o_l1003bood0n_on0?gon`3monX0
n_ol0?Wo003VooT0o_od0?kooP3no`00gOl00?co0@00o_om0?Wo0@00moon0?go
o03mo`400?[ooP3no`400?Soo@3nooX0o?l1003nooh0oOl1003no`80oool0?co
o@3no`40ooh0o_on0?ko003no`00o_l1003noo`0o_ol0?koo@3mooh0o_on0?Wo
003lo`400?cooP3nooh0o?l1003nooh00_oo0?[o0@00o_l00?ko0@00noon087o
lol2003ooOX4ool00?[k0>3o0?[n003ooP01nP3Do`3joP3nn_h00OX0f?omnP7o
ood00?onnP3oo_[i003jmol0n_h00?on007j0=?oo_[n007oood00?[Jo`00o_[j
003jo@00n_`0no[eoo/0no[n003oo@00n^3on?[l0?go0?[n007jn_;ooO[jookj
oOomn_/0n_[i0?WjoP3moogj0@3ooP00ood0i_oin_koo_[j0?kjo_onn_h00?[M
o`00o?l1n_[n0?gjnOol0?[oo_[n003ooP01n_[m007jn_d0o_onn_h00O[jnP02
ool0o_[noogjn`03ooojn_h0o_[mo`7jn_h00_[ooocjo@00oogjoP04n_l0n_[n
0?kjo_l0n_h00?[no`7jn_h0o_X1003no`400?kjo_omn_d0o_[n0?kjo?on003j
o?l1n_[m003oo_[n0?kjoP03ooojn_h0o_X2ooojoP3mo`7jn_h00?[no`7jn_h0
o_onnX7olol2003ooI[mo`2Jo03Oo`2JoP00ooh009[Co`2JoP3nV_h009[GoofJ
n_onVP3ooYX0ooX009[go`2JoP00ooh009[BoojJoP01ooom002Jf_l00?jJnP00
V_d009[l0?^JmOok0?^JoP00ood009[PooRJ0OoooP3mo`2JoP01VY[boofJn_on
V_gooIX1ooom0?ZJ0Oooo000ooVJoP3moofJ0OoooP00ooh0iOoiV_kooY[mooh0
oY[noojJoP00V]go003lo`6JV_h0oI[gooh0n_onV_h0oOl1VY[m006JV_d0o_on
V_h00IZJnP3noojJo_omV_kooP03oonJV_h0oY[mo`6JV_h00Y[ooobJo@00oofJ
oP04V_ooVY[n0?jJo_l0V_h009[no`6JV_h0oY[joojJo_omV_d0oY[n0?jJo?on
002Jo?l1VY[m003ooY[n0?jJoP03oonJV_h0oYX2oonJoP3mo`6JV_h009[no`6J
V_h0o_onV[ko17Bfo`80ooom007oooh0o?l00>3o003jo`400=Co003no`400?go
0@00eooi007oooh00?om0?[o003good0oOl1003Bo`400?Wo0@00f_om0?[o003m
o`00o?l10?om0?3oo@02o`00n_l00=kom03mo`00o_l1003aooP00?on0?gonP3n
oo800?oj0?[on`3jo`00iOoj0?kooP00ooL00OoooP3no`00gOl1003mo`400?ko
o@3io`400?Soo@3moo`0oOl1003no`00o_on0?ko0@00n?om0?kon`3ko`400?ko
o@3no`400?ko0P3ooo/0o?on0?ko0@3ooP3mooh00_oo0?ko003no`400?koo@3e
ood0oOon0?kooP3io`00o?on0?gooP3mo`400?co0@00oOon007o0?[o0@00n_l1
003noo/0POoco`80ooomnPCoo`00n_/0h?l0n_h00?on007j0=Co0?[n007jn_d0
0OX0eoomn_d00Oooo_X0oogjnP00n_Oo0?[n003ooP01nP3Bo`7jn_h00OoooP01
n_[Jo`00o_X0oo/00?[m003jo001n_omn_Goo03mnP;on_[n003ooP00n]kon?[m
0?go0?[n007jn_7on?X0ookjoOomnP80n_[n0?cjm`00oo[joP3moocjo@00ood0
iOojn_koo_X2oo[jo03nnP7oookjoP00n]go0@00oOl1n_[n0?gjnOol0?_ooO[n
003ooP01n_[m007jn_h00?[nookjoP01n_[i007o0?kjo_omnP800?on00?ooo[j
oP3mn_ko0O[joP02n_oono[n007oookjoP04n_l0n_[m0?kj0_oon_h00?[no`7j
n_h0o_X00?kon`3nookjo03nn_h0o_[looh00?[lookjoP00ookjo@01n_[n00?o
oo[jo@3nnP7on_h0oOl1n_[m0?ko0O[joP3knX7olol20?oooI[mo`2Jo03Oo`2J
oP00ooh009[Co`2JoP01VY[m002Je_omV__ooYX0oofJnP00V_Oo09[n003ooP00
V]7o0IZJoP01ooon006JV][o003nVP3on`00V_d009[l006JoofJmOol0?fJ0_nJ
V_h00?on002Jg_ohVP3ooP3mo`2JoP01VY[aooRJ0?onV_gooIX2oiZJoP3lV_go
o001ooojV_h0oOolVP3ooP00ooh0i?ojV_kooYX2oiZJo03nVP7ooojJoP00V]go
0@00oOl1VY[n0?fJmoon0?_ooI[n0?go0IZJo@01VY[n002Jo_onV_h00IZJn@01
ooonV_kooI[nooh00oooVY[n0?fJo_l1VY[n00:JoookV_h00OoooY[n00BJoonJ
V_d0oYX2oonJoP00V_ko0IZJoP3nV_gon`3noojJ0?om0?jJoP3nV_cooP00V_co
oY[n003ooY[m006JV_h00oooVY[m0?jJ0OnJoP3mo`6JV_d0o_l1VY[n0?^J__l4
E;Ko003nooh00OoooP3lo`00h?l00?[o0@00e?l00?ko0@00oOl1003GooT00Ooo
oP00oo`0o?l1003goo`0o_l1003Bo`400?Wo0@00f_om0?[o003mo`400?go0@3o
oP3do`00oOom00;oo`3jo`00f_og00?oo`00o_l00?3on000ooh0o?ok0?ko0@00
o_oh0?kon`3ioo`0n_l00>Con`3noo<00ooo003mo`00gOl00?co0@00o_om0?So
003hood0oOok0?go003no`00o_on0?Wo003lood00OoonP3ko`400?gooP3no`40
0?ko0P3ooo/0nol1003no`40ooh0oOon00;oo`3no`00o_oh0?Goo@3nood0oOl1
003io`00o?ok003ooP3mo`400?_o003mooh00Ol0n_l1003jo`400?kon`21oo?o
003nookj1?oo003jn`3Po`3joP00ooh00OX0e?l0n_h00O[jo@01nP3Googjo@01
ooonnP3ooO[k007jn_Oon@01nP3Bo`7jn_d00?on007jn][o003nnP3on`00n_d0
0O[jo@01n_onn_Co0?[m0?kj0`3ooo[n003ooP00n][oo?[l00?ooo[joP00n_3o
n?X0ookjo?okn_h00O[jo_og007ooo_joP3loogjo@00ood0i?okn_kono[l0?kj
0ooon_[m003jgOl00?co0O[joP3mn_Soo@3koogjoP00ooh0o_[m003joP00n_ko
o_[d007o0?kj0Oooo?X2003ooP03ooojn_d0o_[no`7jn_h00_[ooo_jo@01oool
00Cjo`3jn_d0o_X2ooojoP00n_ko0O[joP04n_X00?oi0?koo_[m0?gjo@01n_[l
ooh00?[loo_j0ol0n_[m007jn_h0o_l0n_d0o_X1oo[n0?go0O[jo@3no`7jn_h0
noZ1oo?o003noojJoOl0V_`0gol0V_h00?on002Jdol0V_h00IZJo@00V]KooI[k
oojJ0?omVP3oo001VY[gooT009[Ao`6JV_d00?on006JV][o003nVP3on`00V_d0
0IZJo@01V_onV_Co09[m0?jJo_l0V_h00?on002Jf_olV_`00oooVY[n002Jl?oh
VP3ooY[loo^JoP01VY[joo/00Oooni[n0?cooIX0ooh00?on0>?oni[noo^Jo03n
VP?ooiZJo@00V]go003lo`6JV_h0oI[gooh0noomV_h0oOonV_d009[n002Jo_on
V_T00?om007ooojJ0Oooo9[nooh00oooVY[m0?jJo_l1VY[n00:JoookV_d0oOon
00BJoonJV_d0oYX2oonJoP00V_ko0IZJoP01VY[nooT0o_onVP3ooP3mV_d00IZJ
o?on002Jo?okVP?ooiZJo@01VY[n0?ko09[m0?jJ0OnJoP3mo`6JV_d0o_l1VY[n
0?^J__l4:<Co003lo`400?_o003nooh00OoooP3lo`00g?l00?ko0@00e?l00?go
003nooh0eooi007oooh00Oooo03nooh0mool0?ko0@00d_l1003io`400=[oo@3j
o`00oOl1003mo`00l?l00?goo@3go`00f?oi00;oo`3mo`00l?od0?con`3no`00
oOom003ooP3moo/0nOol0?[o003Soo`0o_o_0?go003Mo`00o?l1003nood0n?l0
0?Soo@3moo/0oOl00?ko003nooh0loom003on@3ko`400?goo@02ool0oOl00?ko
o03ko`400?ko0@3oo@3nood00Ol0o_l00?kon03foo`0o_om0?gooP3jo`00nool
003oo@3no`400?_o0@00o_on0?SooP3no`40ooh0o_ol087o0Ol0o?l1003ko`00
o_onnPCoo`00n_/0goon003joP01nP3Do`3jo@00n_h00_[j0=Ooo?[n007oookj
0Oooo_X1003nookjmooi007j0=;o0O[jo@00ooh00O[jf_l00?kj0?ok003jo@01
n_[m003jl?l0n_d00o[j003nooh00?on003jf?onn_`00_oon_d00?[`ooCjo?ok
n_h00?[mood00?ol007ooocjo@3loogjo@00ood0hooln_kono[l0?[jo@00n]go
003lo`7jn_h0oO[hood0noonn_d00?on0?kjo@00n_h00?[nookjn@01oool0?kj
0?oln_h00?on00?ooo[jo@3mnP;ooo[m003jo_oln_d00Oooo002n_l0o_[n0?gj
0OojoP00n_ko0?[`007ooogjo@3mn_d0o_[mooh00?[koocj0Ol0o_[m003joP3n
o`7jn_h0o_X0ood0oOonn_h00O[oo_[n0?cjPOl1o`3lo`400?_o003noojJoOl0
V_`0g_on002JoP00V]?o09[m002JoP01VY[FoobJo?onVP7ooojJo?onV_Oon@00
V]7o0IZJo@00ooh00IZJf_l00?jJ0?ok002Jo@01VY[m002Jl?l0V_d00IZJo?on
003ooP00V]SooY[l00;ooi[m002Jl?odV_coni[n002Jn?ol007ooobJ0?on0?co
oIX0ooh00?on0>;oo9[noo^Jo03jV_d009[Mo`00o?l1VY[n0?fJmoon0?_ooYX0
ooh0oOonV_d009[n002Jo_onV_T00Oooo@00oojJ0?olV_gooP03oonJV_d0oIX2
oonJo@00V_koo9[m0?gooP02V_oooY[n0?fJ0OnJoP00V_ko09[l0?kon001ooom
VP3ooP3mV_d0oY[mooh009[koobJ0OoooY[n007oV_h0o_l1VY[n0?jJ0?om0?go
oY[n006JoojJoP3lV[go10S5o`400?go0`3oo`3lo`00o_on007oooh0o?l00=co
003no`400<oo003nooh0e_oj007oooh00Oooo001ooom0?Ooo03no`400=;ooP3j
o`400=[oo@3jo`00oOl1003mo`00l?l00?konP3io`00f?oi00;oo`3mo`00l?ol
003onP3loo/0o_l00?gooP3do`400?Soo@3jo`00hool0?kom`01oook0?ko0@00
gOl00?co0@00o_om0?So003hood0oOoj0?ko003no`00o_om0?_o003koo@0noon
0?koo@02ool0oOl00?kon`3mooh0o_l10?om0?koo@01o`3no`00o_oi0?_o003l
ood0oOol0?kooP3jo`00nool003oo@3mo`00nol1003mooh0nOon0?ko0`3o003m
oo`0POl1003mo`<0ool0o?l00?koo_X4ool00?[k0=oooP00n_h00OX0doom003j
oP02n_X0e_omn_h00Oooo_X1ooomnP<0ool0o_[gooL0d_onn_X00O[jf_l00?kj
0?ok003jo@01n_[m003jl?l0n_h0o_[m003ooP00ooh00?[Hookjo002ooojo@00
n_3oo?X0oo[jo?okn_h00?[mooh00?oj0?coo03koogjoP00ood0hooln_kon_[l
0?_joP01n_[Mo`00o?l1n_[n0?gjn?om0?_oo_[m003ooP3mn_h00?[n003jo_om
n_X00Oooo03hn_h00?on007oookjoP3mnP;ooo[m003jo_okn_L01O[o003jn_h0
oOX1oo[n003jo_l0n_000OoooO[m0?cjoP3nn_goo@3koocj0Ol0o_[i0?ko0O[j
o@3nn_d0oOonn_h00o[on_[m0?cjPOl1003mo`<0ool0o?l00?kooY[mo`2Jo03N
ooh009[n002Jd_om002JoP01VY[EoofJo?onVP7ooofJoOonV_Oon@3@oojJnP01
VY[Jo`00oYX0oo/009[m006JV_d009[`o`2JoP3nV_cooP00ooh009[HoojJo002
oonJo@00V_3oo9X0ooZJo?okV_h009[iooX0n_on0?_ooI[n003ooP3RoobJo_oj
V_`0ni[n006JV]go003lo`6JV_h0oI[gooh0noonVP3ooP3moofJoP00V_h009[n
oofJn`3nood00?ohV_gooP01ooonV_h0oIX2oonJo@00V_koni[m0?kooP00V_ko
0IZJoP3mVP7oV_h009[no`2Jo001oook003ooP01ooomV_d0o9[n0?jJoOon0?[o
o9X1ooonV_d00?on0?ko0IZJo@3nV_d0oOonV_h00i[oVY[m0?bJ_Ol3klCo003m
o`<0ool0o?l00?kooP01ooon0=Ko003no`400=?o003no`00o_l1003Eoo/0o_on
007ooo`00Oooo@3fooh0oOl00=7ooP3jo`400=[oo03ko`00oOl1003mo`00l?of
0?Wo003GooX00_oo0?ko0@00jOok0?con`3io`400??o0@00n?om0?[o003Rood0
o_ok007o0?gon`3no`400=go003lo`400?koo@3ho`00nOol0?gonP3jo`00oOon
0?_o003jooT00?on0?_ooP3nood00_oo0?ko0@00o_ok0?gooP3lood0oOol0?ko
003noo/0nOl00?goo03moo`0o_on0?[o003koo`00OoooP3mo`00nol1003mooh0
o_l00?co0@00o_l30?l00?goo021o`7o0?go0`3oo`3lo`00o_onnPCoo`00n_`0
g_on003joP01nP3Co`3joP00n_h00O[jeOolnP00o_onnP7ooogj0`3oo`3nn_Ko
oP00ood0dOonn_X00O[jf_l00?gjn`00n_d00O[jo@00n_3ono[l003ooP00ooh0
0?[GookjoP03n_oon_h00O[jjOokn_cono[n0?comP3loo`0noomn_h00?om0>;o
oO[noo_j0Oojo@3kn_h00O[jgOl00?co0O[joP3mn_Soo@3loogjo@00ood0o_[j
003joOonn_X0o_oj0?cj0?on003ooP04ool0n_[n0?gj0_oon_h00O[jo_okn_L0
1Ooo003jn_d0o?[n003jo_l0n_D00?om003ooO[l0?cjoP3nn_goo@3koocj0Ooo
o_[i0?ko0O[jo@3nn_h00?[lo`7jn_h00o[on_[m0?cjPOl1o`3mo`<0ool0o?l0
0?kooY[mo`2Jo03Nooh009[n002Jd_l0V_h009[n006JV]Goo9[moojJ0OoooI[m
oojJm_on003ooP3@oojJnP01VY[Jo`00oI[k002Jo@01VY[m002Jl?okV__ooP00
ooh009[GoojJoP03V_ooV_h00IZJjOokV_coni[n0?[on03jooh0noomV_h00?on
0>7ooI[noo^J0OnJo@3kV_h00IZJgOl00?co0IZJoP3mV_OooP3loofJ0?on0?co
oY[j002JoOonV_/0oOoj0?bJo?on0?ko0IZJoP3mVP;ooi[n006JV_koni[m0?ko
oP3mo`6JV_d0o9[n002Jo_l0V_D00OoooP00oofJ0?om0?bJoP3nV_gooP3joobJ
0OoooY[m003ooP3no`6JV_d0oY[n002Jo?l1VY[n00>JoiZJo@3lV[go0oG4o`00
oOl30?oo0?co0`00ooon007oooh0e_l00?ko0@00dol00?ko003no`400=Gom@3n
ood00Oooo@3_o`00d?l1003kooh0f_ol0?_o003mo`400?go003`oo/00?ol0?ko
003no`00e_l1003mo`80o`3no`400>Won`3loo/0nOl00?;o003fooh0n_l00>;o
o@3mood0o_l00?kon`3no`400=go0@00oOl00?goo@3ho`00nOol0?gonP3jo`00
oOon0?co0@00nooi003oo@3kooh0oOom007o0?ko0@00o_oj0?kooP3lood0oOol
0?ko003mood0n?l00?goo03moo`0oOon0?_o003koo`0o_on0?ko003kooh0o_on
0?ko003lo`400?ko0`3o003noo/0POl1o`3mo`<0ool0o?l3003oookj1?oo003j
o03Nooh00?[n007j0=?o0?[n003joP01n_[Eo`00m_[nookj0`3oo`3nn_KooP00
ood0d?l1n_[k0?kjf_l00?gj0?ol003jo@01n_[m003jl?oknP3on@00n_h00?[F
o`7jn_d00_[on_h00O[jjOokn_coo?[l0?gom@3moo`0n_onn_h00?om0>;ooO[m
oogjo_l0n_h0no[n007jn]go0@00oOl0n_d0oO[hood0o?omn_d00?om0?kjnP00
n_goo_[j0?kon@3nnP3on@04ool0n_[m0?gj0OojoP01n_[nookj003nn_P01Ooo
003jn_d0o?[n003joOl0n_L00Oooo@00oogjo@00ookj0@3jo@3nn_koo@3koocj
o_onn_X0o_onn_h0o_[n003jo?l1n_[n00?joo[joP3knX7o0Ol0oOl30?oo0?co
0`00ooonV_go09[l0=kooP00V_h009[Bo`2JoP00V_h00IZJe?ofV_kooY[moojJ
m_on003ooP3?o`6JV_/0oY[Jo`00oIX0oo`009[m006JV_d009[`oo^Jnoon002J
oP00V]Ko0IZJo@02V_nJoP01VY[Yoo^Jo?olVP3oo@3looH0o?om0?[ooY[n003o
oP3QoofJoOomV_ko09[n0?^JoP01VY[Mo`400?go09[m0?fJmoon0?cooIX0ooh0
o?onV_X009[moojJo03looT0oY[lood0o_l1VY[m0?fJ0OnJoP01VY[noojJ0?on
V_h0o_on0?go0IZJo@3lV_h009[mo`2Jm`3nooh00?omVP3ooP00oojJ0OnJo@3n
V_kooP3joobJo_onV_h00?on0?kooY[n0?jJoP00V_co0IZJoP03V_nJV_h0niZm
o`@3c?ol0?ko003mo`<0ool0o?l00?kooP01ooon0=Ko003no`00d_l00?ko003n
o`400=?om`3nood00Oooo@3_o`00d?l1003kooh0f_l10?on0?_o003mo`400?go
003`oo/00Oooo@3no`00o_l00=Ko0@00oOl20?l0o_l1003Xoo`0nooi0?Ko0@00
nOl00?KooP3no`00o_l00>;oo@3fo`00oOom0?go0@00gOl00?co003mood0n?l0
0?ko003moo`0o?ok0?[o003mooh00?on00;o003koo`0oOom0?_ooP3mood00Ol0
o_l1003jooh0oOl1003kood0oOom0?ko003mo`400?Ko003noo`0o?ol0?gooP3k
o`00nool0?kooP3no`00n_l1003nooh0o_l00?co0@00o_l30?l00?koo@01o`28
oo`0o_l00?go0`3oo`3lo`00o_onnPCoo`00n_`0g_on003joP00n];o0?[n003j
oP01n_[CooOjo_onnP<0ool0o_[fooh00?om0=3o0O[jn`3nn][o0@3oo_X0oo`0
0?[l003jo@00n_3onoX1oooj003joP00n]Ko0O[jo@02n_ojoP01n_[Xoocjnoom
n_800O[jo03noo`0n_onn_h00?[m0>;ooO[fo`3jo@3mn_d00O[jgOl00?co0?[m
0?gjn?om003joOonn_`00OoooP3nn_X00?[mookjnP3mooX0oOoi00Coo`3jn_d0
oOX1oo[n007jn_[oo_[h0?ko003nn_h00?omn_h00?[mo`7jn_X0oOom0?cjo@00
ookj0@3jo@3nn_koo@3koocjo_onn_X0oOl1n_[n0?kjoP00n_co0O[joP03n_oj
n_h0oOX1o`28oo`0o_l00?go0`3oo`3lo`00o_onV_go09[l0=kooP00V_h009[B
o`2JoP00V_h00IZJdoogV_kooY[moojJm_on003ooP3?o`6JV_/0oY[Jo`40oojJ
0?ol002Jo@01oi[m002Jl?okV__ooP00V_h009[Fo`6JV_d00Y[oV_h00IZJj?ol
V__ooIX0oo<00IZJo03mood0n_onV_h009[n0>7ooI[fo`2Jo@3mV_d00IZJgOl0
0?co09[m0?fJmoon002JoOonVP7oooh0o?onV_X009[moojJo03kooX0nOom0?ko
0IZJo@3mVP7oV_h00IZJn_onV_d00OoooP3moojJoP00oofJoP00V_go0IZJnP3l
ooh0o9[m003ooYX1oi[m0?jJo_on0?[oo9[noojJoP00ooh0oOl1VY[n0?jJoP00
V_co0IZJoP03V_nJV_h0oIX1o`2mo`?7a?l00?go0`3oo`3lo`00o_on0?ko0@00
e_l00?ko003Bo`00o_l00?ko0@00doog0?koo@00oo`0kol00=3ooP3looh0f_l1
0?on0?co0@00oOl1003mo`00koom0?koo@3no`00o_l00=Go0@00o_l20?l0o_l1
003Wood0nooh0?Soo@3jo`00o_l00?[ooP3no`00o_l00=?o003mood0oOl1003M
o`00o?l00?koo03ho`00o_l3003ooo/0o?oj0?Kom`3kooX00OoooP3iooh0oOon
007o0?ko0@00n_on0?go0@00noom0?gooP3hooh0mooh0?con`3nooh0loom0?ko
oP3fo`400?go0@00o_l00?co0@00o_om0?kooP02ool0POl1o`3mo`<0ool0o?l0
0?koo_[no`40n_`0g_on003jo@3Bo`3joP00n_h00O[jdoogn_kooOX2o`00o_[f
ooh00?om0=3oo_[l0?kjf_l10?onnP3oo@01n_[l003jo@00n^oooO[nooX00?[n
003jeOl1n_[n00;joo[n007jn^OooO[kookjlP3mn_d0o_om003jn_onn_h00?[m
0=?o0?[m0?gjo@01n_[Mo`00o?l0n_h0o?[hood00o[jooomn_`00OoooP3mn_/0
o?onn_X0oOoh007oooT0o_onn_h00?onnP7on_h00O[jn_onn_P0o_l3003jn_h0
0?onn_d0o?onn_`0o?om0?gjo000ookj0P3jn_h0o_[nooh0nOomn_koo_[j0?go
0O[jo@01n_[n003jo?l1n_[n0?gjoP3nnP;oo`21o`7o0?go0`3oo`3lo`00o_on
V_go09[l0=kooP00V_h0dOl0V_h009[n006JV]?omi[noofJo_onV_KooP00ooh0
coonV_`0oY[Jo`40oojJ0?om006JV_d00OnJo@00V^oooI[jooh009[n002JeOl1
VY[n00:Joi[n006JV^OooI[koojJ0?oc0?fJo@3mooh009[joojJoP00V_h0d_l0
V_d0oI[m006JV]go003lo`2JoP3lV_OooP03VY[ooofJ0OoooP3loofJn`3loojJ
o03kooX0n_ol0?kooY[n003ooYX1oi[n006JV_[ooY[m007oooh0o?l1VY[n003o
oY[m0?cooY[l0?_ooP3mVP3oo@00oojJ0_nJV_h0oY[nooh0nOomV_kooY[j0?go
0IZJo@01VY[n002Jo?l1VY[n0?fJoP3nVP;oo`2mo`?1aOon0?go0@00nol00?ko
oP3no`400=Ko003no`00d_l00?ko003no`400<koo03nood00?ol0??o003no`00
d?on0?goo@3Jo`40ooh0o?l1003mo`400?ko003^ood0oOon0?ko003no`00eOl1
003no`80o`3no`400>Ooo@3iooX0n?om0?Ko003io`400?ko003no`00dol1003n
ood0o_on0=go003lo`00o_ol0?Oom03looh00?on0?KomP3kooh01_oo0?oo003l
o`00o_on0?gooP01o`3no`400?[oo@3mo`00n_on0?gooP3goo/0nooj007o0?co
n`3mooh0m?om0?kooP3fo`400?go0@00o_l00?co0@00o_om0?kooP02ool0POon
0?go0@00nol00?koo_[no`40n_`0g_on003jo@3Bo`3joP00n_h00OX0c_oln_ko
oOX2o`00o_[fooT0d?onn_`0o_[Jo`40ookj0?om007jn_`00?[n003jk_omn_go
n`00n_h00?[Eo`7jn_h00_[on_h00O[jioomn_WolP00oogjo001ooom003jnOl1
n_[n003jo@3Co`7jn_h0oO[n0?kjgOl00?co0?[n0?cjmoon0?Wjo001ooon003o
o_[k0?coo_[l0?kjoOoi007oooX00?[nookjo@3nnP7on_h00O[jn_l00?kjn@3m
o`80n_[m0?kjo@3koogj0@00nool00;jn_om007oookj0P3jn_d0o_X1ooon0?Wo
oO[nookjnP3mo`7jn_d00O[joP00n_co0O[joP3mn_h0o_X2ool0POon0?go0@00
nol00?kooY[mo`2Jo03Nooh009[n0=7o09[n002JoP00V/goo9[noofJo_onV_Ko
oP00ooh0coonV_d00?onV][o0@3ooYX0ood00IZJo@01oi[n002Jk_omV_[ooP00
V_h009[Eo`6JV_h00Y[oV_h00IZJioomV_Oom000oofJo001ooom002JnOl1VY[n
002JoP3Bo`6JV_h0oI[n0?jJgOl00?co09[n0?bJmoon0?VJ0OoooP3koojJn`3l
oojJo03nV_gonP3loo`009[noojJo@3nVP7oV_h00IZJnOonV_d00?on0?co0IZJ
o@3nV_d0noomV_Woo003VY[oooh00OoooYX2oiZJo@3nVP7oooh0nOomV_kooY[j
0?go0IZJo@01VY[n002Jo?l1VY[n0?fJoP3nVP;oo`2mo`>=]_l00?kooP3no`40
0=Ko003no`00d_l00?ko003no`400<Gon03co`00o_l00=3oo001ooom0=[o0@3o
oP3lo`400?gon`3^ood0oOon0?ko003no`00eOl1003nooh0o_l1003Wood0nOoj
0?Soo03go`00nOl1003no`00o_l00=?o0@00oOon0?kooP3Mo`00o?l00?koo03h
oo<0o?on003ooP3eooH0mol4003o003mo`400?kooP3mooh00Ol0o_l1003jood0
oOl00?[ooP3mooh0o_l00?_on`3koo`0n?on00;o003mood0mOom0?gooP3gooh0
o_l1003no`00nol00?gooP3nooh00_oo087ol_l00?koo_[no`40n_`0g_on003j
o@3Bo`3joP00n_h00OX0aOonn_h0o_[fooh00?[m0=3ooOX30?oo0?kjf_l10?on
nP7oooh00O[jo03ln^kooO[moo/00?[n003jeOl1n_[n0?kjoP01n_[WoogjnOod
0?koo?[m007oood00?[io`7jn_h00?[m0=?o0O[jo@3nn_h0o_[Mo`00o?l0n_h0
o?[hoo`0n_[l007oooh00?onn_/0nol1n_[l0?gjo_oh003on`01n_[no`80n_[m
0?kj0OojoP01n_[jo`00o_[i0?go0P3jn_d0o_[n003jnoomnP400?_oo03nood0
0Oooo_X2oo[jo@3mnP3ooP3ioogjoOonn_/0oOonn_h00O[joP00n__o0?[m0?kj
oP3nnP;oo`21oo;o003noojJoOl0V_`0g_on002JoP3Ao`2JoP00V_h009[4oojJ
o_onV_KooP00V_h0coomV_gooY[Jo`40oojJ0OoooP01VY[m003oo9[^oofJn_on
002JoP00V]Go0IZJoP3nV_h00IZJioomV_OomP3noobJo@01ooom002JnOl1VY[n
002JoP3Bo`6JV_d0oY[n0?jJgOl00?co09[n0?bJn?ol0?ZJ0OoooP3koojJn`3k
o`6JV_`0oI[nooX0o?om006JV_go0IZJo@3nVP7oV_h00IZJnOonV_d00?on0?co
0IZJo@3nV_h009[koofJnOol0?koo@01ooonVP;oVY[m0?fJ0?on0?WooI[moojJ
n`3moojJoP01VY[n002Jnol0V_d0oY[n0?jJ0_oo0;go0d:fo`00o_on0?ko0@00
d_l00=;o003jo`400<Gon03co`00o_l00<ooo@00oo`0f_l10?on0?koo@3moo/0
i_on0?ko003no`00d?on0?ko003Uooh0m_om007oooh0oOol0?So0@00nOl1003n
o`00o_l00=;o003mooh0o_on0=go003lo`00o_ol0?Sol`3looh00?om0?Kom@3g
o`80o`3lo`400?koo@3nooh00Ol0o_l00?Woo03food0o_on0?ko003koo`0n_ol
0?SooP00ooh0o_ol0?Koo@3mooh0moon0?ko0@00o_l00?_o003mo`400?gooP02
ool0POobo`00o_onn_ko0@3jo03NooT0d_l0n_X00OX0aOomnP400?kjm_on003j
o@3?ookj0`3o003nn][o0@3oo_[no`<00?[jo03ln^Kon`00n_d0doon0?kjoP00
n^Goo_[fooh00_[oooh0oOoln_P00O[jnOl1n_[n003jo@3Bo`3jo@3nn_h0o_[M
o`00o?l0n_h0o?[hoo`0no[k007oooh00?omn_`0noonn_h0no[nooT00?ok007j
n_ko003nn_h0o_X1oo[n003jnOl00?gjnP3mo`00o_[n0?kjoP00n__oo?[joo`0
o_om007oookj0ol0n_[n0?cjoP3ioogjoOonn_/0oOonn_h00O[joP00n__o0?[m
007jn_d0o_X2ool0POobo`00o_onV_go09[l0=konP3Ao`2JnP00V/CooIX1ooon
V_KooP00V_h0c_onV_gooY[Jo`40oojJo?l1VY[m003oo9[Sooh009[n0=;ooP3n
V_h009[UoojJm_on002Jn?olV_P00IZJnOl1VY[n002JoP3Ao`2Jo@3nV_h0oY[M
o`00o?l0V_h0o9[hoo`0ni[nooh0noomV_`0noonV_h0ni[nooX0o_ol006JV_go
oY[n0?jJ0OnJoP00V_SooI[j0?cooY[n0?jJoP00V__oo9[joo`0o_om007ooojJ
0oooVY[n0?bJoP3ioofJoOonV_/0oOonV_h00IZJoP00V__o09[m006JV_d0oYX2
ool0_Ol3>kKo003nooh0o_l1003Bo`00d_l00?[o0@00aOoh0??o003no`00coom
003oo03Joo/00Oooo@3moo/0iOl1003no`00o_l00<oo0@00o_l00>GooP3food0
0OoooP3moo/0nOl1003io`400?ko003no`00d_l1003hooh0gOl1003mo`00o_ol
0?Sol`3looT0m_oe0?Ko003looh0o_om0?go0`00o`3no`00nOol0?Koo@3mo`40
0?ko003jood0nOon0?ko003kooh00?on0?koo03food0oOon0?Ko0@00oOl00?ko
003ko`400?ko0@00oOon00;o0021oo;o003nookjo_l10?[l0=kon@3Bo`3jnP01
nP35oocj003nn_KooP00n_d0coonnP<0o`00o_[Jo`400?gj1Ooo003jn_`0o?[U
oo`00?[m0=?oo@01n_[n003jiOonn_KooOX1ooon0?gono[i007jn_Wo0O[joP00
n_d0d_l1n_[n0?kooP3nn]go0@00oOl0n_h0o?[hoo`0o?[j007oood0oO[l0?_o
n_X00?gjo_oc0?kjo_l00?kjo@03n_[on_h00?[io`00oO[j0?go003nn_d00O[j
oP00n_[ooO[ioo`00?om0?koo_X3o`3jn_h0o?[n0?WooO[mookjn`3lo`7jn_d0
0?[n003jnol1n_[n007jn_d0o_X2o`00POobo`00o_onV_go09[l0=konP3Ao`2J
nP00V/Coo9X0oojJm_on002JoP3>oojJoOonV][o0@00oI[mo`6JV_d00?olV^?o
oP00V_h0d_om006JV_h009[UoojJm_omV_Soni[i006JV_Wo0IZJoP00V_h0dOl1
VY[n0?kooP3nV]go0@00oOl0V_h0o9[hoo`0o9[mooh0noomV_`0noojVP3ooI[n
ooT00?ol0?jJoOonV_d00iZJoi[n002Jn?omV_X0o?onV_d00IZJoP00V_[ooI[i
oo`00OoooP3noojJ0oooVY[n0?bJoP3ioofJoOonV_/0o?l1VY[m002JoP00V__o
0IZJoP01VY[m0?jJ0_l00;go0d:fo`<00?oooP3no`400=Wo003lo`400=;o0@00
nol10034ooT0lol00?ko003?ood00?ol0=[o0@3oo@01ooom0?gon`3Uo`400?ko
003no`00col1003no`00eool003ooP3moo/0nOl1003io`400?ko003no`00d_l1
003hooh0gOl00?co003noo`0moon0?_ooP3kood00?on0?Gon`00oo`0o_l1003f
ooh0o_om0?go0`00o`3no`00nOol0?Koo@3mo`400?ko003iood0n_l00?GooP00
ooh0oOom0?GooP3looh0mol1003mo`00mol1003no`400?koo@02ool0POobo`<0
0?ooo_[no`40n_`0g_l0n_`00OX0d_l1n_[k007j0<ConO[fooh00?[m0<ooo_X2
0?l0oO[Jo`40oogj1Ooo003jn_`0o?[Uoo`00?[m0=?oo@01n_[n003jeol00?gj
0?on0?gono[i007jn_Wo0@3joP00n_d0d_l1n_[n007oood0o_[Mo`00o?l0n_h0
o?[goo`0oOon003ooP01ooom003oo_[l0?[oo?X10?oln_ko0O[jmP3nn_ko003n
n_d00o[joo[n003jnOl1003nn_X0oOl3003jn_d00O[joP00n_WooO[jo`3jn03n
ookj0ol0n_[m0?gjoP3hookjo?onn_`0o?l1n_[m003joP3jo`7jn_h00O[joP3m
nP;oo`21oo;o0`00ooonV_go09[l0=ko09[l002JdOl1VY[k002J`ooiV_KooP00
V_h0c_onV_kooI[Jo`40oofJoOl1VY[m003oo9[Sooh009[n0=;oo@01VY[n002J
e_omV_Woni[i006JV_So09[n002JoP3Ao`6JV_h00Oooo@3nV]go003lo`2JoP3l
V_Ooo03iooh0n_onV_`0n_olVP7ooobJo_l1VY[f0?jJoOonV_d00iZJoi[n002J
moonV_X0nol1VY[m006JV_h009[ioofJn_l0V_P0o_onVP?ooiZJo@3mV_h0n?on
V_cooY[l0?co0IZJo@00V_h0n_l1VY[n006JV_h0oIX2ool0_Ol3R;Ko003nooh0
o_l1003mo`00g_l00?co0@00dOl00?_o0@00a?oi0??o003no`00coom003oo03W
o`00o?l1003lo`80ooon007oood0noom0>Go0@00o_l00?ko003Co`00o_l1003n
o`00e_om003ooP3moo/0n_on0?Wo0@00o_l00?ko003Bo`400?SooP3/ooh0oOl1
003ko`00o?l00?koo03go`00nOon0?[ooP00ooh0oOl00?[on`01oool007oooh0
moon0?goo@3no`<00?l0o_l00?Soo03food0oOl00?ko003ioo`0nol1003fooh0
0?on0?cooP3]ooh0moon0?ko003go`400?ko0@00o_on0?ko0021oo;o003nookj
o_l10?[m003jg_l0n_`00OX0dOl0n_/00OX0a?oin_KooP00n_d0coonnP80o`3m
n^Oo003lo`400?co0P3oookj1Ooo003jn_d00OoooO[Uoo`00?[m0=?o0?[n007j
n_h00?[Foogj0?on0?gonoX0oo/0o_[io`40n_h00?[m0=;o0O[jo@00ood0o_[/
ooh0oOl1003ko`00o?l0n_h0o?[go`3jo@3mooh00?on0?kooP00ookjo@00n_[o
o?X20?ooo?X1ooonn_P00?onn_go003nn_h00o[joo[n003jn?l00?gjn`3lo`00
o_[m003joP00n_Woo?[ko`7jn_T0o_onnP?o0?[jo@00ookjoP3`ookjo03lookj
oP00n_h0n_l1n_[n007jn_h0o_[no`00POobo`00o_onV_go09[m002Jg_l0V_`0
09[@o`2Jn`00V/?onI[fooh009[n0<kooY[noofJiol00?co0@00o?l20?oooY[m
o`6JV_d00OoooI[Sooh009[n0=;o09[n006JV_h009[FoofJnOokVP3on`3nV_So
09[n002JoP3Ao`6JV_d00?om0?jJk?on0?go0@00nol00?co09[n0?bJmol0V_d0
nOon0?[ooY[m002Jn_olV_koo9X1ooonV_P00?onV_cooY[n00>JV_nJoP00V_Oo
oI[k0?_ooY[m002JoP00V_Woo9[ko`6JV_T0o_onVP?ooiZJo@00oojJoP3`oojJ
o03loojJoP00V_h0n_l1VY[n006JV_h0oY[no`00_Ol3L[Ko003nooh0o_l1003m
o`00g_l00?co0@00dOl00?_o0@00a?oi0??o003no`00coog0>So0@00oOl30?oo
0?go0P3oooh00Oooo@3kood0iOl1003;o`00o_l1003no`00e_oi0?gonP3lood0
nOl1003jo`00d_l1003iood0kOl00?ko1P3oo`3oo`3lo`00o?l00?koo@3fo`00
nOon0?[ooP00ooh0oOl00?[on`3nood00Oooo@3hooh0oOom0?go0P3o0?ko003h
oo`0m_om0?go003no`00n?ol0?co0@00moom007oooh0o?l1003]ood0n?on0?;o
n`3nooh0o_l0087ol_l00?koo_[no`40n_d00?[No`3jo001nP3Ao`3jn`01nP34
o`00n_[fooh00?[m0<oooOX1003nnP00j?l1003mo`<0ool0oOl20?ooo_X5ool0
0?[jo@01ooomn^Gon03Bo`3joP01n_[n003je_l00?gjoP3moo[j0?ol0?kjnOl1
0?[i0=;o0O[jo@00ooh0oO[]o`00o_l60?oo0?oo0?co003lo`3joP03n_X00?Ko
0?[l0?konP3nooh00?onn_d00?[joocj003noogj0OoooO[j007oookjoOl00?kj
o@02n_ojoP00n_So003mn_/0o?l00?kjo@00n_h00?[hoocjo?l1n_[j0?kooOX1
ooonn_h00ooon_[n0?3ooO[m0?coo_[j0?Wo0?[n007jn_h0o_[no`00POobo`00
o_onV_go09[m002Jg_l0V_`009[@o`2Jn`00V/;onY[fooh009[n0<kooIX1ooon
VP00j?l1003mo`<0ool0oOl20?oooY[mo`6JV_d00OoooI[SooX0d_l0V_h00IZJ
oP00V]GooI[jooZJ0?om003ooY[ho`2JnP3Ao`6JV_d00?on0?fJkOl00?ko1P3o
o`3oo`3lo`00o?l0V_h00IZJm?l0V_`0noom0?[ooY[m002Jn_olV_gooIX1ooom
V_X00OoooY[loojJo@02V_nJoP00V_OooI[k0?_ooY[m002JoP00V_Soo9[lo`6J
V_X0o_omVP7ooojJoP03oonJV_h0l?omV_d0o?onV_X0nOl0V_h00IZJoP3nV_ko
002mo`=L]_l00?koo@03ool00?go003No`00o?l1003Ao`00nol10034ooT0lol0
0?ko003?ooL0iol00?go0`3oo`3mo`80ooon007oood0noom0>Go0@00bol00?ko
0@00o_l00=Kon@3mooX0o_ok0?Wo0@00n_l00=7o0@00n_on0>co003no`H0ool0
ool0o?l00?co003nood0mOl00?[ooP3jooh00ooo003mo`00n_ok0?koo@01ooog
0?kooP3mood0oOl00?co003hoo/0mool0?ko003no`00n?ok0?gooP3hood00Ooo
oP3lo`400>goo@3go`400?;oo03mooh0o_l0087ol_l00?kooOX3ool0n_d00?[N
o`3jo001nP3Ao`3jn`01nP34ood0oO[fooh00?[m0<oooOX1003nnP00iol00?go
0`3oo`3mo`80ooonnPGoo`00n_[m007ooogjiOoh0=;o0?[n007jn_h00?[Fo`00
o?X1003moo[jo_on0?kjnOl10?[i0=7o0O[joP00ooh0o_[/o`00o_l60?oo0?oo
0?co003lo`3joP03n_X00?Go0?[m0?konP3nooh00ooon_[m003jn_omnP400?ko
oOX1oooln_`0o_onn_go003nn_d00O[oo@00n_So0@00o_[k0?co003mn_h00?[n
003jn?okn_goo_[k0?kooOX4ool0n_[m00;on_[n0?3ooO[m0?_o0O[jnP3iooP0
o_[no`00POobo`00o_omV_ko09[m002Jg_l0V_`009[@o`2Jn`00V[oooI[fooh0
09[n0<kooIX1ooonVP00iol00?go0`3oo`3mo`80ooonV_go0IZJo@01ooomV^?o
nP3Bo`2JoP01VY[n002JeOolV__onY[koojJn?l0V_X0d?l1VY[n003ooP3nV^co
003no`H0ool0ool0o?l00?co09[n006JV_?o09[m0?_oo@3io`6JV_d009[joofJ
o?omVP7ooobJnOonV_cooY[m006Jood009[foojJ0?ol0?_ooI[n002JoP00V_So
ni[moojJn`3noofJo_l1VY[m00;oVY[n0?3ooI[m0?_o0IZJnP3iooP0oY[no`00
_Ol3C[Ko003nood00ooo003mo`00g_l00?co0@00dOl00?cooP34oo/0lOl00?ko
003>ooP0iol00?go0`3oo`3moo/00Oooo@3kood0iOl1003ko`00d_l00?ko0@00
o_l00=Kon@3mooT00Ooon`3io`400?_o0@00dOl1003jooh0jOl00?ko0`3oo`3l
o`400?go003nood0mOl00?[o0@00oOl00?kooP03ool00?go003iooh0noom003o
o000ood0o_on0?goo03ho`00mook0?Soo03jo`00mook0?koo@3mo`00o_on0?ko
oP3lo`00joon0?OooP3coo`0oOon003ooP21oo;o003noogj0ooo0?[m003jg_l0
n_`00OX0dOl0n_`00_[j0<Con`3dooh00?[m0<koo_X00?gj003Wo`00oOl30?oo
0?gooP3nnPGoo`00n_[m007ooogjiOoi003jd_l0n_h00O[joP00n]Ko0@00no[m
ookj003mnP7oooh0o_[io`40n_/00OX0dOl1n_[j0?kjjOl00?ko0`3oo`3lo`40
0?go0?[n00?jnP00mOl0n_`00Ooon`00n_kooP03ooojn_d00?[iookjnoomnP3o
o?X0ood0o_onn_go003mn_d00?om003jmol00?gjo03lo`400?kjnP00n_Oono[n
oogjo03nookjo_l20?[jo@01oo[m0>ooo_X0ooh0noonn_/0nOoh0?kj0?on087o
l_l00?kooI[no`2Jo@00V]ko09[l002Jd?l0V_`00IZJ/?on002JoP3=oojJ0?om
VP00iol00?go0`3oo`3mooh0oY[mo`6JV_d00OoooI[Soo/009[Bo`2JoP01VY[n
002Je?okV_gooYX0oofJo?onV_So09[k002Jd?l1VY[j0?jJjOl00?ko0`3oo`3l
o`400?go09[n006JV_?o09[l0?goo@00V_Wo0IZJo@00V_WooY[koofJ0?olV_Wo
oY[loofJo@00ood009[foofJ0?om0?[ooY[j002JmookV_kooI[m0?gooY[mo`6J
V_d00OnJo@3_oojJ0?on0?_ooY[k0?Won03nVP3ooP2mo`<n]_l00?gooP03ool0
0?go003Ho`400=7o003lo`400<?oo03/o`00c_oh0>ooo03no`00oOl30?oo0?go
0P3oooh00Oooo@3kooh0i?l1003ko`00d_l00?ko0@00o_l00=Gol`00ood00Ooo
n`3ho`00nol1003Ao`400?[ooP3Zo`00oOl30?oo0?co003lo`00o_om0?Go0@00
o?on0?go003nood00_l00?go003iooh0noom003on`00ooh0o_on0?goo03mo`00
o_l1003goo/0n?ol0?[o003fooX00?oh0?kooP3nood0oOl00>_ooP00ooh0noon
0??oo03nood0o_l0087ol_l00?goo_X3ool0n_d00?[Moo`00OX0dOl0n_`00O[j
`ool0??on@3>ooWj003_oo`0o_l00?go0`3oo`3mo`80ooonnPGoo`00n_[m007o
ookji?oi003jd_l0n_h00O[joP00n]Go0@00mOX0oogj0OoooP3nn_SonP01nP3A
o`7jn_X0o_[Zo`00oOl30?oo0?co003lo`3joP03n_X00?Go0O[jo@00ooX00?[n
ood00_ojn_d00?[iookjnoomnP3onoX0ooh0o_onn_go003mn_d00?[n007jn_Oo
003mnP40ooh0o?l1003nn_X00?[foo[j0?oln_d0o_onn_ko003nn_h00Oojo@3_
ookj0?onn__oo_[k0?Won03nn_ko0021oo;o003moojJo_l0V_d009[Moo`009[@
o`2Jo001VYZ`ooX0cOoiVP00kool0?ko003mo`<0ool0oOl20?oooY[mo`6JV_d0
0OoooY[Roo/009[Bo`2JoP01VY[n002JdooeVP3ooI[loojJmook002Jd?l1VY[j
0?jJj_l00?go0`3oo`3lo`00o?l0V_h00IZJlol1VY[m0?goo@00V_Wo0IZJo@00
V_WooY[koofJ0?okV_[ooY[loofJo@00V_h00IZJm_omVP7oooh0n_onV_X009[f
ooZJ0?olV_[ooY[moojJoP01oi[m0>oooYX0oojJnoonV_/0nOoi003ooY[no`00
_Ol35KKo0@00o_on00?oo`00oOl00=go003mo`400=7o0@00oOl10033ood0]ooh
0>Oo003mo`<0ool0oOl20?oooP01ooom0?_ooP3So`00nol00=;o003io`00eOoc
003oo@01oook0?So003ko`00d?on0?coo@3[o`T0ool0ool0ool0o?l00?co003n
ood0mOl1003lo`400?go0@00o_om00;o003dooh0n_og003ooP3nooh0oOol0?go
003no`400?Oon`00ooh0o?ol0?[o003eoo400Oooo@3nood0oOl00?ko003_ooX0
noom0?Coo@3mood0o_l0087ol_l1003nookj0ooo0?[m003jgOl0n_d00OX0dOl1
n_[m007jn/?oo@3booX0cOoinP00iol00?go0`3oo`3mo`80ooonnPGoo`00n_[m
007oookjhooj003jd_l0n_T00?[Eo`400?Gj0?omnP7oooh0o_[hooX00?[@ookj
n`3nn^_o2@3oo`3oo`3oo`3lo`00o?l0n_h00o[j003eo`7jn_H00O[jo_om00;o
n_[m0?Soo_[jooOj0?on0?koo_[mo`400?kjo@00n_h00O[jmol00?gj0@3oo_[l
o`400?kj0?ok003jmOoen_d00OoooO[no`00o_[m003joP00n^oon_[koogjo03i
ooP0o_[no`00POobo`400?kooY[no`2Jo@00V]go09[m002Jd?l1VY[m006JV[3o
nP3=ooVJ003Wo`00oOl30?oo0?go0P3ooojJoOl1VY[m007ooojJh_ok002Jd_l0
V_T009[CooFJ0?omV_cooY[goo/009[@oojJo000oojJjol90?oo0?oo0?oo0?co
003lo`2JoP01VY[co`6JV_`00Oooo@01VY[io`6JV_d0n?onV_[omi[joojJnoon
V_d009[n006JV_KooIX1ooonV_[ooYX0oo/009[eooFJnoomV_gooY[m002JoP00
V^oonY[koofJo03hooX00?onV_ko002mo`;M]_l00?gooP03ool00?go003Mo`00
oOl00=3o0@00oOl10032ooh0l_l00?co003<oo/00Ol0j?on0?go0@00o?l20?oo
oP01ooom0=[o003ko`00bOl00=Com000ood00Ooon`3ho`00nol00=3ooP3lood0
k?ol0?ko0@00nol00?co003nood0mOon0?Oo0@00oOon00;oo`3dooh0n_of0?_o
oP3moo/0o_l00?ko0@00mook003ooP3koo`0nol00?Col`3nood0o_om0?go003n
o`00kooj0?[ooP3do`00n_om0?ko0021oo;o003mookj0ooo0?[l0=go0?[m003j
d?l1n_[m007jn/;ooP3bo`3jo000n/conoX1o`3Xooh0oOl1003lo`80ooonnPGo
o`00n_[m0=konP00n]7on@00n]CooP3gnP7o0?kj0OoooP3nn_SonP00n]3oo_[l
0?gjk?ol0?ko0@00nol00?co0?[n00?jnP00mOonn_L00O[joOon00;ooo[m0?So
o_[jooKjnoonn_go0@00oO[n003joP01n_[go`400?kj0@3oo_[ko`00oO[k003j
m?oenP400?kooO[no`<00?[jo@00n_h00?[_oo[jn_onn_`0nOoi0?gjo_l0087o
l_l00?gooY[no`2Jo@3Lo`2Jo@00V]3o0IZJo@01VYZ`o`2Jo000V/coniX1o`3X
ooh0oOl1003lo`80ooonV_go0IZJo@3Moo/009[AooT009[AooNJ0OoooY[loojJ
mook002Jd?onV_`0oI[/oo`0o_l1003ko`00o?l0V_h00IZJloonV_L00IZJn?l0
V_d0n?onV_[omY[koojJnoomV_h009[n006JV_GooYX1ooonV_[ooI[k002Jm?oe
V_cooI[lo`6JV_d009[n002JkoojV_[ooY[l0?SonP3mV_ko002mo`9n]_l00?go
oP03ool00?go003Moo/0d?l1003mo`400;3o003lo`00c?ol00;oo`3Jo`80ooon
0?kooP3Jo`00nol00=7o003ko`400<Goo@00oo/0n?l00?_o003?ooh0oOom0=co
003lo`00o_om0?Co0@00n?on0?gooP02ool0jOog0?_ooP3moo/0o_l00?ko0@00
mook003ooP3koo`0nol00?;om@3nooh0oOol0?[o003^oo/0n_on0?go003ho`00
o?ol0?ko0021oo;o003mookj0ooo0?[l0=goo?X00=3o0O[jo@01n_Z`o`3jo000
n/coo002ool0f_l20?ooo_[no`80n_[m0=konP00n]7o0?[k007jn/GooOX0ooh0
o_[hooX00?[?ookjo@3mn]co003lo`3joP03n_X00?Co0O[jn03nn_gooP02oooj
o@3]ooOjnoonn_go0@00oO[n003joP01n_[go`400?gj0?onn__o003mn_/00?[b
ooOj0@00o_onn_go0@00o_[j003jk_okn_[oo_[m003jn?l0n_/0oO[no`00POob
o`00oOonV_ko09[m0=coo9[?o`6JV_d00IZJ/?l0V_`009[5o`00f_l20?oooY[m
o`6JV_d0gOok002JdOl0V_/00IZJaOomV_gooY[goo/009[?oojJo@3mV]co003l
o`2JoP01VY[bo`6JV_P0oY[ho`2Jo@3]ooNJnoonV__ooI[n002JoP01VY[eoofJ
0?onV_[ooI[k002Jl_ogV_cooY[koojJnP00V^koni[joojJo@00V_So09[l003o
oI[no`00_Ol2R[Ko003mooh00ooo003mo`00gOok0=3o0@00oOl1002`o`00o?l0
0<coo002ool0f_l20?oooP3nooh0f_l00?_o003Ao`00nol10035ood00?ok0?So
003ko`00coom003on`3Lo`00o?l00?koo@3dooh0nOon0?gooP02ool0jOok003o
o@3looh0oOok0?ko003no`400?Koo000ooh0nool0?co0@00k?ok0?kooP3moo`0
n_l00>kon`3jooh0oOl00?Som`3mo`00POobo`00oOonnP?oo`3jo03Moocj003@
o`7jn_d00OX0/?l0n_`00?[<oo`00_oo0=[o0P3oookjo_l20?[jo@3NooX00?[A
o`3jn`01n_[5oogj0?on0?kjn?oj003jcoonnP<0o`00o_X00=co003lo`3joP03
n_X00?Coo_[i0?kjoOon00;ooo[m0>gonoX0oogjo?onn_gooP3nn_h00?[n007j
n_Ko003mnP3oo_[ko`400?kjo001n_[/o`00oOX00?koo_[mo`400?kjnP00n^ko
no[jookjo@00n_SooO[n0?kjoOl0087ol_l00?gooY[no`2Jo@3LoobJcol1VY[m
002J[ol0V_`009[5o`00f_l20?oooY[mo`6JV_d0gOok002JdOl0V_/00IZJaOom
V_gooY[goo/009[?oojJoOonVP00g?l00?co09[n006JV_;ooY[i0?jJn?l0V_d0
kOokVP3ooI[loojJn_onV_h009[n006JV_GooIX0oojJnOonV_`00IZJjoomV_go
oY[koojJnP00V^koni[joojJo@00V_SooI[noojJoOl00;go0W:fo`00oOon00?o
o`00oOl00=gon`3@ooT0/?l00?co003;ood00_oo0=[o0P00ooh0o_on0=[o003k
o`00dOl00?_o0@00aOof0?So003ko`00coom003on`3Lo`400?go003nood0m?om
0?[ooP3mooh0iOol003oo@3looh0o?ol0?ko003no`400?Koo000ooh0nool0?co
0@00k?ok0?kooP3moo/0iook0?[ooP3mo`00n?og0?ko0@00POobo`00oOonnP?o
o`3jo03Moocj003@oo[j002`o`3jo000n/_oo@02ool0f_l2003oo_[no`80n_[m
0=konP00n]7o0?[k007jn/Go003mn_h0o_[hooX00?[?ookj0`3o003nnP00g?l1
003mo`3joP03n_X00?CooO[k003oo_[mooh0o_om0>coo?X0oogjo?onn_co0@00
o_[n003joP01n_[fo`400?kj0?onn__o0@00o_[l007j0>co003mnP00o_onn_go
0@00oO[k0>gono[jookjo@00n_SooO[n0?kjo_l10021oo;o003moojJo_l0V_d0
g?olV/oonYZ_o`2Jo000V/Go003Jo`800?onV_go0IZJo@3Moo/009[Ao`2Jn`01
VY[4oofJo_onV_Oon`00V/oooY[moojJ003Lo`400?go09[n006JV_;ooI[k003o
oY[good0k?olVP3ooI[loojJn_onV_h009[n006JV_CooYX0oojJnOonV_`009[Z
oofJoOonV__ooI[k0>goni[joojJo@00V_SooI[noojJo_l1002mo`9C]_l00?go
oP03ool00?go003Moo/0d?oi0:[o0035o`00f_l20?oooP3nooh0f_l00?_o003A
o`00nol10035ooH0n?l00?_o003?ood00?ok0=co003lo`00o_om0??onP3nooh0
oOom007oooh0jool003oo@3looh0o?ol0?ko003no`400?ConP3koo`0o?l00>_o
n`01ooom0?coo03Woo/0nOl1003mo`00n?og0?go0021oo;o003mookj0ooo0?[l
0=goo?X00=3on_X00:ooo000n/Go003Jo`80ooonn_ko0P3jn_d0g_oj003jdOl0
n_/00O[jaOl00?_j003nn_SonP00n/ooo_X30?l00?kj003Lo`00o?l0n_h00o[j
003cookjo@3nookjoOom007oood0k?olnP3ooO[lookjo?l1003nn_h00?[n007j
n_Con_[ko`400?kjo000n^_o003lnP7ooogjo?l1003nn_/0kOokn_Wo0O[jo@00
n_SooO[n0?kjoOl0087ol_l00?gooY[no`2Jo@3LoobJcoojVZkoo000V/Go003J
o`80ooonV_go0IZJo@3Moo/009[Ao`2Jn`01VY[4oo^J0?onV_Oon`00V/oooY[m
oojJ003Lo`00o?l0V_h00IZJlOonV_[ooY[good0k?olVP3ooI[loojJn_onV_h0
09[n006JV_ConY[ioojJo000V^[oo9X1ooomV_[ooY[k0>goni[io`6JV_d009[h
oofJo_onV_go002mo`9?]_l00?gooP03ool00?go003Loo`0cooj0:[o0035o`00
f_l20?oooP3nooh0f_l00?_o003Ao`00nol10035ooH0n?l00?_o003?ood00?ok
0=co003lo`00o_om0??oo03looh0oOom003oo03[ood00Oooo@3mooh0o?ol0?ko
003no`400?ConP3koo`0o?l00>[oo001ooom0?coo03Voo`0nOl1003mo`00n?og
0?go0021oo;o003mookj0ooo0?[l0=cooOX00<oonoX00:ooo000n/Go003Jo`80
ooonn_ko0P3jn_d0g_oi0=7o0?[k007jn/Go003gn_SonP00n/oooOX2o`00o_X0
0=co003lo`3joP03n_X00??ooOX00?coo_[mood00?ol0>_ooOX1ooomn_goo_[l
ooh00O[joP00n_h00O[jm?ojn__ooP01n_[l003jj_l00?gj0OoooO[lo`400?kj
0?ol0>coo?[io`7jn_d00?[ho`00oOX00?gjoOl0087ol_l00?gooY[no`2Jo@3K
oofJc_okVZkoo000V/Go003Jo`80ooonV_go0IZJo@3Moo/0d?l0V_/00IZJa?og
V_Oon`00V/oooI[noojJ003Lo`00o?l0V_h00IZJlOomV__ooY[hoo`0joomVP7o
oofJoOonV_Wo0IZJoP00V_h00IZJm?ojV_So0IZJo000V^WooIX1ooomV_[ooYX0
oo`0k?olV_Wo0IZJo@00V_OooIX0oofJoOl00;go0SZfo`400?kooP03ool00?go
003Loo`0cook0:Wo0036o`400=[o0P3oood00OoooP3Co`00dOl00?_o0@00a?og
0?So003ko`00coom003on`3Lo`00o?l00?koo@3cood0noon0?cooP00oo`0joom
007oood0oOon0?coo03no`00o_l00?;on`3jood0o?l00>[on`00ooh0nook0>Oo
o03io`400?;on03mo`00POobo`400?koo_X3ool0n_`0g?omnP00cooknZkoo000
n/Ko0@00f_l20?oooOX4ool0n_[m0=gonP3Ao`3jn`01n_[4o`00n?[hooX00?[?
oogj0_l00?kj003Lo`00o?l0n_h00o[j003coogjnoonn_cooP00oo`0joomnP7o
oogjoOonn_cooP01n_[n003joP00n_;ono[jo`<00?[jo000n^[o003lnP3oo_[k
o`400?gjo03/oocjnOl1n_[m0?KooOX00?gjoOl0087ol_l1003noojJo_l0V_d0
foomV/koniZ^oo`009[6o`400=[o0P3ooofJo_l1VY[m0=gon`3@o`2Jn`01VY[3
ooRJmook002JcoomV_kooYX00=co003lo`2JoP01VY[aoofJnoonV_Soo03[oofJ
0OoooI[moojJnOl1VY[n002JoP00V_;oni[ho`6JV_`009[YoobJ0?onV_WooI[l
0>coo9[io`6JV_d0m_omVP3ooI[mo`00_Ol25;Ko003mooh0o_l00?go003Loo`0
cook087ok?l00=[o0P3oood00OoooP3Iooh0o_l00=7o003ko`400<Con03`o`00
c_on003on`3Lo`00o?l00?kooP3bood0noon0?cooP00oo`0j_on0?koo@3nooh0
noom0?ko003no`00l_ok0?[oo@3lo`00j_og0?_on`3Vood0nOl1003booP0oOl0
087ol_l00?goo_[no`3jo03Loogj003?oo_j[_ol0<Co003Jo`80ooomnPCoo`3j
n_d0gOoj0=7o0?[k007j0<Coo@3ln_KonP3>ookj0Ol0oOX00=co003lo`3joP02
n_X0l_omn__oo_[looh00?ol0>[oo_[noogjo_onn__o0`00n_[n003joP00n_;o
no[jo`<00?[jo000n^[o0@00nO[ko`400?gj0?om0>_ooO[io`7jn_d0m_ohn_go
0021oo;o003moojJo_l0V_d0foomV/koniZ^oo`0a?l00=[o0P3ooofJo_l1VY[m
0=gon`3@o`2Jn`00V[ooo9[foo/0cOonVP7ooofJ003Lo`00o?l0V_h00IZJlOom
V__ooY[hoo`0j_onV_kooI[noojJnOl1VY[n002JoP00V_;oni[ho`6JV_`009[X
ooVJnOomVP3oo@3[oofJnOl1VY[m0?Kon9[mo`00_Ol1m[Ko003mooh0o_l00?go
003Looh0cOok087ok?l00=[o0`00ooon007oooh0f_ol00;oo`3Ao`00nol10034
ooP0l?l00<kom`3Lo`400?go003nooh0lOom0?cooP3looh00OoooP3Sood0o_on
0?_oo@3jo`00l_ok0?[oo@3lo`00iooj0?_on`3Vood0n?om0?ConP3mo`40087o
l_l00?goo_[no`3jo03LookjcOoknZkoo034o`00f_l3003oookj1?oo0?[jo@3N
ooT0dOl0n_/00OX0a?ol0?gjm_oj0<kooOX00?gj003Lo`400?go0?[n00;jnP3a
oogjo?onn_cooP01ooon0>?ooO[nookjnol3003jn_X00?[boo_jn_on003jo000
n^Oon_[kooh0o_X0ood0joomn_So0?[m0?Gon_[mo`40087ol_l00?gooY[no`2J
o@3KoojJcOokVZkoo034o`00f_l3003ooojJo_l1VY[m0=konP3@o`2Jn`00V[ko
oI[foo/0cOomVP3ooIX00=co0@00oOl0V_h00IZJl?omV_cooY[gooh0hoomV_ko
oY[io`6JV_X009[boo^Jmol0V_`009[WooZJn?onVP3oo@3[oofJn?l0V_d0mOoj
V_go0@00_Ol1d;Ko003mooh0o_l00?go002Uoo`0POo[o`00f_l00?kooP01ooon
0=[oo002ool0dOl1003lo`400<?oo@3/o`00c_oi007o0=co003lo`00o_on0?7o
o@3looh0o?on007oooh0h_om007oooh0noom0?[o003aoo`0n_om0?co003Woo/0
n_oj0>Ooo@3hoo`0mOoj0?co0021oo;o003mookjo_l0n_`0YOolnZgoo034o`00
f_l00?koo_X4ool0n_[m0=kon@3Ao`7jn_`00OX0`oom0?;onP3>ooWj0Ol0g?l0
0?co0?[n00;jnP3aoogjo?onn_cooP01ooon0>;ooOX1ooonn__ooP00n_X00?[a
oocjn_on003jo000n^Oono[jooh0oO[m0>_ooO[hoo`0mOojn_co0021oo;o003m
oojJo_l0V_d0Y?olVZgoo034o`00f_l00?kooY[no`6JV_d0g_oj0=3o0IZJo000
VZoon`3=ooVJ0Ol0g?l00?co09[n006JV_3ooI[loojJeOomVP7ooojJn?l0V_X0
09[aoobJmol0V_`009[Woo^JmoomV_d0joomV_Soo03eooZJo?l00;go0M6fo`00
oOon0?ko003mo`00YOol0:go0030o`00f_l00?kooP01ooon0=[oo002o`00dOl1
003lo`400<?oo@3/o`00cOoj007o0=co003lo`00o_on0?3oo@3mooh0o?oi0>;o
o000ooh0n_on0?_o0@00lOol0?[oo@3lo`00i_ol0?[onP3Vooh0n?ol0?Coo03k
o`00POobo`00oOonn_ko0?[l0:Goo?Z]o`3jo@34o`00f_l00?koo_X4ool0n_[m
0=kon`01nP3Ao`7jn_`00OX0`oom0?;onP3=oo[j0Ol0g?l00?co0?[n00;jnP3`
oogjoOonn_con@3Roocj0?onn_[o0P00n_/00O[jlOoln_[ooP00n_`00?[Voocj
n_on0?gjo@3Zookjn?ol0?Coo?[ko`00POobo`00oOonV_ko09[m0:Coo9Z]o`2J
o@34o`00f_l00?kooY[no`6JV_d0g_ok002Jd?l1VY[l002J[ook0<conYX1o`3L
o`00o?l0V_h00IZJkoomV_gooY[EoobJ0?onV_So09[k006JV_7oo9[go`2Jo000
V^Koo9[goofJo@3ZoojJn?ol0?Coo9[ko`00_Ol1Y;Ko003mooh0o_l00?go002T
ood0[Ol00<3o003Jo`00o_on007oooh0fOon00?oo`00d?l00?co0@00`oom0>co
003=ooX00Ol0g?l00?go0@00o_on0?3oo@3mooh0o?oi0>7on@3jooh0nol1003`
ood0nOon0?co003IooX0ioon0?Soo03Yo`00POobo`00oOonn_ko0?[l0:CooOZ]
o`3jo@34o`00f_l00?koo_X4ool0n_[m0=goo001nP3@o`3jo001nP33ood0l_oj
0<gon_X1o`3Lo`00oOl1n_[n00;jnP3`oogjoOonn_con@3QooWjn_l2003jn`01
n_[`oogjnOoh0=WooP3mn_h0j_onn_Soo03Yo`00POobo`00oOonV_ko09[m0:?o
oIZ]o`2Jo@34o`00f_l00?kooY[no`6JV_d0gOol002Jcol0V_`009Z_oo/0c?oj
VP7o0=co003mo`6JV_h00IZJkoomV_gooY[DooVJn?l0V_/00IZJl?omV_Koo03E
oofJoP3ZoojJn?ol0>Wo002mo`6V]_l1003nooh0o_l00?go002Tood0[Ol00<7o
0@00f_l00?kooP01ooon0=Wo003mo`400=3o003lo`400<?oo@3/o`00cOoj007o
0=co003mo`400?kooP3_ood0o_on0?con@3QooT0n_on0?_o0@00l?om0?WooP3m
o`400=Wom`3Mood0jOl0087ol_l1003nookjo_l0n_`0Y?omnZgo0?[m0<Go0@00
f_l00?koo_X4ool0n_[m0=go0?[m007j0=3o0?[l007j0<?oo@3booX0cOojnP7o
0=co003mo`7jn_h00_[j0>oooO[nookjo?oi0>7onO[jooP00O[jl?omn_WonP01
nP3Iooh0oO[n0=gooP00n^Wo0021oo;o0@00o_onV_ko09[m0:?ooIZ]o`2Jo@35
o`400=[o003noojJo_l1VY[m0=go09[m002Jcol0V_`009Z_oo/0c?ojVP7o0=co
003mo`6JV_h00IZJk_omV_kooY[DooVJmook006JV_3ooI[food009[EoofJoP3M
ooh009[Yo`00_Ol1U;Ko003mooh0o_l00?go002Tooh0[?l00<3o003Jo`00o_on
007oooh0fOl00?go0@00d?l00?gooP2Zo`00cOol0?ko003Lo`00oOl1003nooh0
koom0?kooP3koo/0gooj0?[ooP3ko`400?3oo@3iooh0oOl1003IooH0g_on0>So
0021oo;o003mookjo_l0n_`0Y?onnZco0?[m0<Co003Jo`00o_onnPCoo`3jn_d0
gOl0n_d00OX0d?l0n_d00_[j0;3onP3=oo`0o_l00=co003mo`7jn_h00_[j0>oo
oO[nookjnook0=oon_[jooP00O[jl?omn_WonP01nP3Iooh0o_[l0=koo_[Xo`00
POobo`00oOonV_ko09[m0:?ooYZ/o`2Jo@34o`00f_l00?kooY[no`6JV_d0gOl0
V_d009[?o`2Jo@01VYZ_oo/0a?l00=co003mo`6JV_h00IZJk_omV_kooY[CooZJ
mook006JV_3ooI[food009[EoojJo03NoojJj?l00;go0HNfo`00oOon0?ko003m
o`00POo<o`00o_l00<Co003Jo`<00?oooP3no`400=WonP3@o`00oOon0:[o003=
oo`00ooo003Lo`400?ko0@00o_on0>ooo@3nooh0nool0=goo03ho`400?_o003_
ood0nOon0?go003HooH0`ol10021oo;o003mookjo_l0n_`0POo<o`3joP00n/Co
003Jo`<00?ooo_[no`7jn_d0gOoknP00d?l0n_d00_[j0;3onP3=oo`00ooo003L
o`400?ko0O[joP02n_X0koomn_koo_[koo`0gOoln_Son@00n^oooO[iooX00?[H
ood00O[jo033o`40087ol_l00?gooY[no`2Jo@21ol_o09[n002Ja?l00=[o0`00
ooonV_ko0IZJo@3Moo^Jcol0V_d00IZJ[ook0<Go0@00g?l1003no`6JV_h00IZJ
k_omV_kooY[BoobJm_ok002JkoomV_Koo@00V]Co0IZJo033o`400;go0Ebfo`00
oOon0?ko003mo`00POo<oo`0a?l00=[o003nooh0o_l1003Ioo/0cooi0;3ooP3n
o`00cOol0?ko003Lo`00oOl1003nooh0k_om007oooh0a?l1003ko`00k_on0?Wo
n`01o`3GooL0`_l0087ol_l00?goo_[no`3jo021olcoo?[4o`00f_l00?koo_[n
o`7jn_d0gOl00?cjcoonnP00o_X00;3onP3=oo`0o_l00=co003mo`7jn_h00_[j
0>kooOX1ooonn/Con@00n^koo_[iooX00?[Gooh00O[jo032o`00POobo`00oOon
V_ko09[m087oboolV/Co003Jo`00o_onV_ko0IZJo@3LoobJcoonVP3ooYZ_oo/0
a?l00=co003mo`6JV_h00IZJkOomVP7ooojJ`_ok002Jk_onV_Koo@00V]Co0IZJ
o032o`00_Ol1K/GooP3mo`400?_o003mooh00ooo003mo`00POo;ood0a?l00=[o
003nooh0o_l1003Hoo`0cooj0;3oo002ool0cOol0?ko003Lo`00oOl1003nooh0
k_om007oooh0`ol00?_o003^ooh0nOoi0=Oon031o`00POon0?go0@00nol00?go
o_X3ooojn_`0POo;oogja?l00=[o003nookjo_l1n_[m0=coo?[?ookj003nn[3o
n@3=oo`0o_l00=co003mo`7jn_h00_[j0>kooOX1ooonn/?onP00n^koo_[iooX0
0?[Good00O[joP31o`00POon0?go0@00nol00?gooYX3oonJV_d0POo:oofJa?l0
0=[o003noojJo_l1VY[m0=coo9[?oojJ0?onV[3onP34o`00g?l00?go0IZJoP01
VY[]oofJ0OoooY[2oo/009[^oojJmool002Jdol1VY[n0<7o002mo`5`a_l00?ko
1P3oo`3oo`3lo`00oOon00?oo`00POo6ood0a?l00=[o003nooh0o_l1003Hoo`0
cooj0;3oo002ool0cOol0?ko003Lo`00oOl1003nooh0kOon007oooh0`ol00?co
0@00k_on0?Won@3FooT0`Ol008;o003no`H0ool0ool0o?l00?goo_X3ooojn_d0
POo:oogja?l00=[o003nookjo_l1n_[m0=cooOX00<oon_Z`ooT0cOol0?ko003L
o`00oOl1n_[n00;jnP3]ookj0Oooo_[3oo/00O[jk_onn_WonP00n]KooP3ln/7o
0022o`00o_l60?oo0?oo0?co003moojJ0oooVY[m087ob_omV/Co003Jo`00o_on
V_ko0IZJo@3LoofJc_ojV[3onP34o`00g?l00?go0IZJoP01VY[/oojJ0OoooY[2
oo`00IZJk_onV_Ooo000V]?oo9[1o`00_Ol1HlKo003no`H0ool0ool0o?l00?go
oP03ool0087oa_om0<Co003Jo`00o_on0?ko0@00f?ol0<oonP2`oo`00_oo0<go
o03no`00g?l00?go0@00o_on0>goo@00ooh0`oom00?oo`00h_oj0=KooP00ooh0
`?l008;o003no`H0ool0ool0o?l00?goo_X3ooojn_d0POo:oogja?l00=[o003n
ookjo_l1n_[m0=cooOX00<oon_Z`ooT0cOol0?ko003Lo`00oOl1n_[n00;jnP3]
oogj0?onn/?on`01n_[RooX0e_on003oo_[0o`00P_l00?ko1P3oo`3oo`3lo`00
oOonVP?ooiZJo@21ol[ooI[4o`00f_l00?kooY[no`6JV_d0g?omV/konYZ`ooX0
a?l00=co003mo`6JV_h00IZJk?omVP3ooY[2oo`00IZJhOol0=7ooY[0o`00_Ol1
Kl?o003no`<0ool0o?l1003nood00_l0087oa_om0<KooP3Jo`<00?oooP3no`40
0=Soo03?ooX0[oon0?ko003<ood00ooo003Lo`400?ko003mooh0kOom003ooP33
oo`00_l00>;onP3Fooh00?on0<7o0@00POl2ool0o_l30?oo0?co0@00o_omnP;o
n_[m087ob_omn/KooP3Jo`<00?ooo_[no`7jn_d0g?l00?kj003?oo_j002_ooX0
c?om00?oo`00g?l1003no`3jo@02n_X0kOomnP3oo_[3oo/00O[jh_ol007j0=Ko
oP00ookj`Ol10021o`;oo`3no`<0ool0o?l1003noofJ0_nJV_d0POo:oofJa_on
0=[o0`00ooonV_ko0IZJo@3KoojJc_okVZkon`35o`400=co0@00o_l0V_d00IZJ
k?omVP3ooY[3oo/00IZJh?on002JdOonV/7o0@00_Ol1DLcoo03no`00oOl30?oo
0?co003mood00_l0087oa_on0<?o003Jo`00o_on0?ko0@00f?ol0<kon`2Yo`00
c?om0?ko003Lo`00oOl00?gooP3/ooX0`ool00;o003Qoo`0eOon003ooP30o`00
R?ol0?ko003mo`<0ool0o?l00?gooOX2oo[jo@21ol[oo_[3o`00f_l00?koo_[n
o`7jn_d0g?l00?kj003>oocj002_ooX0c?om0?ko003Lo`00oOl0n_d00_[j0>co
n_[3oo/00O[jhOl00?gjeOon003ooP30o`00R?ol0?ko003mo`<0ool0o?l00?go
oIX2oiZJo@21ol[ooY[3o`00f_l00?kooY[no`6JV_d0foonV/goo9Z^oo/0a?l0
0=co003mo`2Jo@01VY[[ooZJ`ook006JV^3ooIZ=o`00_Ol1I<Go2@3oo`3oo`3o
o`3lo`00o?on003oo021ohSo003Xooh0oOl1003lo`00o_on0?ko0@00f?ol0<ko
n`2_o`00o?l00<coo@3no`00j_l00?co0@00nol00?go003nood0k?oj0<?onP3O
ood0eOoj0<3o0021o`T0ool0ool0ool0o?l00?coo_X2oo[jo@21ohWo003Xooh0
oOl1003lo`00o_onn_ko0O[jo@3Loo`0c_olnP00[ol0n_/0c?om0?ko003Zo`00
o?l1003ko`00oOl0n_h0o_X00>con_[3oo`00O[jgoom0=GonP30o`00POl90?oo
0?oo0?oo0?co003loojJ0_nJV_d0POn9o`00j?on0?go0@00o?l00?kooY[no`6J
V_d0Y?olVZko09[l0<Co003Zo`00o?l1003ko`00oOl0V_h0oY[[ooZJ`ool006J
VX7oiol00;go0FC6oo`0o_l1003ko`00o?on003on`21ohWo003Yo`00o_l60?oo
0?oo0?go003nooh0o_l1003Hoo`0c_ok0:oo003lo`00aOl00>_o0@00oOl30?oo
0?co003mo`00o_om0>conP32oo/0goom0=GonP30o`00P_ol0?ko0@00nol00?co
o_X1oo[l087oROl00>Wo003no`H0ool0ool0oOl00?koo_[no`7jn_d0g?ol0<ko
o?X00:oo0?[k0<Go003[o`400?go0`3oo`3lo`00oOl0n_h0o_X00>con_[2ooh0
o_[Oood0eOoj0<3o0022oo`0o_l1003ko`00o?onVP7oV_`0POn9o`00jOl00?ko
1P3oo`3oo`3mo`00o_onV_ko0IZJo@2ToobJ[_l0V_`0a?l00>_o0@00oOl30?oo
0?co003mo`2JoP3nV^_onY[2ooh0oYZ1onOo002mo`5;]_l00?cooP00oo/0POn9
o`00jOl00?ko1P3oo`3oo`3mo`00o_on007oooh0f?ol0<kon`2_o`00oOl00<Co
003Zo`00oOl30?oo0?co003mo`00o_om0>_on`31oo`0goon0=?on`30o`00POob
o`00o?onnP7on_`0POn9o`00jOl00?ko1P3oo`3oo`3mo`00o_onnP7oookjo@3L
oo`0c_omnP400:oo0?[m003ja?l00>[o003mo`<0ool0o?l00?go0?[n0?kj003[
oo_j`Ooln]oooP3Coo/0`?l0087ol_l00?cooYX1oi[l087oROl00>Wo003no`H0
ool0ool0oOl00?kooYX1ooonV_d0Y?omVZgo09[m002Ja?l00>[o003mo`<0ool0
o?l00?go09[n0?jJj_okV/7oo9Z1onOo002mo`4h]_l00?cooP00oo/0POn9o`00
i_l00?ko0`3oo`3mooh00?on007oooh0f?ol0<kon`2Zo`00aOl1003Zo`00oOl3
0?oo0?co0@00o_l00?koo@3[oo/0`Oom0:goo031ooh0POobo`00o?onnP7on_`0
POn9o`00i_l00?ko0`3oo`3mooh00?onnP7oookjo@3Loo`0c_omnP400:koo@00
n/Go0@00j_l00?go0`3oo`3lo`400?ko0?[n0?kj003[oo_j`OomnZgoo031ooh0
POobo`00o?onVP7oV_`0POn9o`00i_l00?ko0`3oo`3mooh00?onVP7ooojJo@2T
oofJ[?om002JaOl1003Zo`00oOl30?oo0?co0@00o_l0V_h0oY[Zoo^J`OomVX7o
j?on0;go0DBfo`00o?on003on`21ohWo003_oo`0o_l00?go0`3oo`3mo`00o_on
007oooh0f?ol0<kon`2Zo`00a?l00>[o003mo`<0ool0o?l00?go003nood0jook
0<7oo@2]oo`0_ol0087ol_l00?coo_X2oo[joP00nX7oROl00>ooo03no`00oOl3
0?oo0?go003nookj0Oooo_[m0=coo03>oogj0@00[_om003ja?l00>[o003mo`<0
ool0o?l00?go0?[n0?kj003[oo_j`OomnZgoo02oo`00POobo`00o?onVP;oVY[n
002JPOn9o`00kool0?ko003mo`<0ool0oOl00?kooYX1ooonV_d0Y?omVZcoo@00
V/Co003Zo`00oOl30?oo0?co003mo`2JoP3nV^[oni[1oofJPOoVo`00_Ol1;kKo
0@00oOon003on`21oh[o0@00j?l90?oo0?oo0?oo0?go003nooh00OoooP3Good0
c?om0:[o0034o`00j_l00?go0`3oo`3lo`00oOl00?koo@3Zoo`0POoYoo`0_ol0
087ol_l1003mookj0?oknX7oR_l1003Xo`T0ool0ool0ool0oOl00?koo_X1ooon
n_d0foom0<coo@2^ood00?[4o`00j_l00?go0`3oo`3lo`00oOl0n_h0o_X00>[o
o?Z1onWoo02oo`00POobo`400?gooYX0oo^JPOn:o`400>So2@3oo`3oo`3oo`3m
o`00o_onVP7ooojJo@21ol_oo@00V/Co003Zo`00oOl30?oo0?co003mo`2JoP3n
V^Woo9Z1oj;o002mo`4O]_l00?cooP00oo/0POn9o`00jOol0?ko0@00o?l00?ko
oP01ooon0=Ooo@3<ood0[_l00?ko0034o`00joon0?go0@00nol00?go003nood0
j_ol087ojOom0;ko0021oo;o003lookj0?oknX7oROl00>Woo03no`400?co003n
ookj0Oooo_[m0=_oo@3<ood0[_l0n_h00?[4o`00joon0?go0@00nol00?go0?[n
0?kj003ZoocjPOoYood0__l0087ol_l00?cooYX0oo^JPOn9o`00jOol0?ko0@00
o?l00?kooYX1ooonV_d0POo;o`2JoP00V/Co003[ooh0oOl1003ko`00oOl0V_h0
oY[YoobJPOnRo`00_Ol0f[Ko003looh00?ol087oR?l00=[o003nood00?on0=Oo
o@3<ooh0[Ool0<Co003Lo`00oOl00?koo@3Zoo`0POoXooh0__l0087ol_l00?co
o_X0oocjPOn8o`00f_l00?kooOX0ookjo@3Kood0c?on0:goo?[4o`00g?l00?go
0?[n0?kj003ZoocjPOoXooh0__l0087ol_l00?cooYX0oobJPOn8o`00f_l00?ko
oIX0oojJo@21ol_oo9[4o`00g?l00?go09[n0?jJjOolVX7oX_l00;go0=:fo`00
o?on003ooP21ohKo003Jo`00o_om003ooP3Good0c?on0:goo034o`00g?l00?go
003nood0j_ol087oX_l0087ol_l00?coo_X0ookjPOn6o`00f_l00?kooOX0ookj
o@3Kood0c?on0:goo?[4o`00g?l00?go0?[n0?kj003ZoocjPOnRo`00POobo`00
o?onVP3ooYZ1ohKo003Jo`00o_omVP3ooY[m087oboolV/Co003Lo`00oOl0V_h0
oY[YoobJPOnRo`00_Ol0g;Ko003looh00?on087oQ_l00=[o0@00o_on003ooP3G
ooh0POodoo`0aOl1003Lo`400?ko003nood0jOom087oXol10021oo;o003lookj
0?onnX7oQ_l00=[o0@00o_onnP3oo_[m0=_ooP21ooCooOX00<Go0@00g?l1003n
o`3joP3nnP00jOomnX7oXol10021oo;o003loojJ0?onVX7oQ_l00=[o0@00o_on
VP3ooY[m087oboomV/Co0@00g?l1003no`2JoP3nV^SooIZ1oj?o0@00_Ol0d;Ko
003looh00?on087oQ_l00=[o003mooh00?on0=OooP21ooCoo034o`00g?l00?go
003nood0jOom087oX_l0087ol_l00?coo_X0ookjPOn6o`00f_l00?goo_X0ookj
o@3Kooh0POodoogj0034o`00g?l00?go0?[n0?kj003YoogjPOnRo`00POobo`00
o?onVP3ooYZ1ohKo003Jo`00oOonVP3ooY[m087oboomV/?o003Lo`00oOl0V_h0
oY[XoofJPOnRo`00_Ol0c[Ko0@00oOon003ooP21ohOo0@00f_l00?gooP00ooh0
POo6ood0a?l00=co003mo`00o_om0>Woo@21oj;o0021oo;o0@00oOonnP3oo_Z1
ohOo0@00f_l00?goo_X0ookjo@21ol[oo_X00<Co003Lo`00oOl0n_h0o_X00>Wo
oOZ1oj;o0021oo;o0@00oOonVP3ooYZ1ohOo0@00f_l00?gooYX0oojJo@21ol[o
oY[3o`00g?l00?go09[n0?jJj?omVX7oX_l00;go0<^fo`00o?on003ooP21ohKo
003Jo`00oOon003ooP21olKoo@34o`00g?l00?ko0@00o_om0>SooP21oj;o0021
oo;o003lookj0?onnX7oQ_l00=[o003mookj0?onn_d0POo:ookj0034o`00g?l0
0?ko0O[joP3nnP00j?onnX7oX_l0087ol_l00?cooYX0oojJPOn6o`00f_l00?go
oYX0oojJo@21ol[ooY[3o`00g?l00?ko0IZJoP3nV^OooYZ1oj;o002mo`2j]_l0
0?cooP00ooh0POn6o`00f_l00?gooP00ooh0POn5o`00g?l00?ko003mood0j?on
087oX_l0087ol_l00?coo_X0ookjPOn6o`00f_l00?goo_X0ookjo@21ohWo003L
o`00o_l0n_d0o_X00>Soo_Z1oj;o0021oo;o003loojJ0?onVX7oQ_l00=[o003m
oojJ0?onV_d0POn9o`00g?l00?ko09[m0?jJioonVX7oX_l00;go0;Nfo`00o?on
003ooP21ohKo003Jo`400?kooP00ooh0POn6o`400=co1000ool0oOom087oQol1
0021oo;o003lookj0?onnX7oQ_l00=[o0@00o_onnP3oo_[m087oR_l1003Lo`@0
0?oon_d0o_X0087oQol10021oo;o003loojJ0?onVX7oQ_l00=[o0@00o_onVP3o
oY[m087oR_l1003Lo`@00?ooV_d0oYZ1ohKo0@00_Ol0[;Ko003looh00?on087o
Q_l00=[o003mooh00?on087oQOl00=co003no`00o_om087oQOl0087ol_l00?co
o_X0ookjPOn6o`00f_l00?goo_X0ookjo@21ohWo003Lo`00o_l0n_h0oOZ1ohGo
0021oo;o003loojJ0?onVX7oQ_l00=[o003moojJ0?onV_d0POn9o`00g?l00?ko
09[n0?fJPOn5o`00_Ol0[[Ko003looh00?on087oQ_l00=[o003mooh00?on087o
QOl00=co003no`00o_om087oQOl0087ol_l00?coo_X0ookjPOn6o`00f_l00?go
o_X0ookjo@21ohWo003Lo`00o_l0n_h0o_X0087oQOl0087ol_l00?cooYX0oojJ
POn6o`00f_l00?gooYX0oojJo@21ohWo003Lo`00o_l0V_h0oYZ1ohCo002mo`2^
]_l00?cooP00ooh0POn6o`00f_l00?gooP00ooh0POn5o`00g?l00?ko003nood0
POn5o`00POobo`00o?onnP3oo_Z1ohKo003Jo`00oOonnP3oo_[m087oROl00=co
003no`3joP3nnP00POn5o`00POobo`00o?onVP3ooYZ1ohKo003Jo`00oOonVP3o
oY[m087oROl00=co003no`2JoP3nVX7oQ?l00;go0;bfo`400?gooP00ooh0POn7
o`400=[o003mooh00?on0?ko0021ohWo003Lo`00o_l00?koo@21ohGo0021oo;o
0@00oOonnP3oo_Z1ohOo0@00f_l00?goo_X0ookjoP00nX7oROl00=co003no`3j
oP3nnP00POn5o`00POobo`400?gooYX0oojJPOn7o`400=[o003moojJ0?onV_h0
09Z1ohWo003Lo`00o_l0V_h0oYZ1ohCo002mo`2f]_l00?cooP00ooh0POn6o`00
f_l00?gooP00ooh0o_l0087oROl00=co003no`00o_om087oQOl0087ol_l00?co
o_X0ookjPOn6o`00f_l00?goo_X0ookjoP00nX7oROl00=co003no`3joP3nnP00
POn5o`00POobo`00o?onVP3ooYZ1ohKo003Jo`00oOonVP3ooY[n002JPOn9o`00
g?l00?ko09[n0?jJPOn4o`00_Ol0^kKo003looh00?on087oQ_l00=[o0@00o_on
003ooP3no`00POn:o`400=co1000o`00o_om087oQ_l10021oo;o003lookj0?on
nX7oQ_l00=[o0@00o_onnP3oo_[m087oR_l1003Lo`@00?ojn_h0o_X0087oQ_l1
0021oo;o003loojJ0?onVX7oQ_l00=[o0@00o_onVP3ooY[n087oROl1003Lo`@0
0?nJV_h0oYZ1ohGo0@00_Ol0X[Ko003looX0POn6o`00f_l00?gooP00ooh0POn5
o`00g?l40?oo003nood0POn5o`00POobo`00o?ojnX7oQ_l00=[o003mookj0?on
n_h0POn8o`00g?l40?oon_[n0?kj0021ohGo0021oo;o003looZJPOn6o`00f_l0
0?gooYX0oojJoP21ohSo003Lo`@0oonJV_h0oYZ1ohCo002mo`2O]_l00?conP21
ohKo003Jo`00oOon003on`21ohSo003Lo`40ooh0o_om087oQOl0087ol_l00?co
n_Z1ohKo003Jo`00oOonnP3oo_[n087oR?l00=co0@3oo_[n0?kj0021ohGo0021
oo;o003looZJPOn6o`00f_l00?gooYX0oojJoP21ohSo003Lo`40oojJoP3nVX7o
Q?l00;go09Zfo`00nook087oQ_l00=[o003mooh00?oj087oROl00=coo@3mood0
POn5o`00POobo`00nooknX7oQ_l00=[o003mookj0_ojn_`0POn9o`00g?l00?kj
o@3nnP00POn5o`00POobo`00nookVX7oQ_l00=[o003moojJ0_nJV_`0POn9o`00
g?l00?jJo@3nVX7oQ?l00;go09Zfo`400?con`21ohOo0@00f_l00?gooP00ooX0
POn9o`00g?om0?gooP21ohCo0021oo;o0@00o?oknX7oQol1003Jo`00oOonnP;o
n_[l087oROl00=cooO[m0?kjPOn4o`00POobo`400?coniZ1ohOo0@00f_l00?go
oYX2oiZJo021ohWo003LoofJo@3nVX7oQ?l00;go0:6fo`00nook087oQ_l00=[o
0@00o_on003onP21oh[o0@00gOol0?gooP21ohGo0@00POobo`00nooknX7oQ_l0
0=[o0@00o_onnP;on_[l087oR_l1003MoocjoP00ookjPOn5o`40087ol_l00?_o
niZ1ohKo003Jo`400?kooYX2oiZJo021oh[o0@00gOolV_h00?onVX7oQOl1002m
o`2H]_l00?_on`21ohKo003Jo`00oOon003on`21ohSo003Moo`0oOon087oQ?l0
087ol_l00?_onoZ1ohKo003Jo`00oOonnP3oo_[n087oR?l00=goo?[n003oo_Z1
ohCo0021oo;o003koo^JPOn6o`00f_l00?gooYX0oojJoP21ohSo003MoobJoP00
oojJPOn4o`00_Ol0U;Ko003koo/0POn6o`00f_l00?gooP00oo/0POn8o`00gOom
0?goo@21ohCo0021oo;o003koo_jPOn6o`00f_l00?goo_X0ookjoP21ohSo003M
oogjo03nnX7oQ?l0087ol_l00?_oniZ1ohKo003Jo`00oOonVP3ooYZ1ohGo003M
oofJo@00oojJPOn4o`00_Ol0V;Ko003koo/0POn6o`00f_l00?gooP00oo/0POn8
o`00gOon0?coo@21ohCo0021oo;o003koo_jPOn6o`00f_l00?goo_X0ookjoP21
ohSo003Mooh00?ol0?kjPOn4o`00POobo`00nookVX7oQ_l00=[o003moojJ0?on
VX7oQOl00=gooP00ood00?onVX7oQ?l00;go0@jfo`00nook0=[o003=o`00cOl0
0<go003=o`00f_l00?gooP00oo/0fol00<go003=o`00c_l00<go003Noo`0oOom
0=So003=o`00cOl00<go003=o`00POobo`00nookn][o003=o`00cOl00<go003=
o`00f_l00?goo_X0ookjoP3Ko`00cOl00<go003>o`00cOl00=kom`3nn]So003=
o`00cOl00<go003=o`00POobo`00nookV][o003=o`00cOl00<go003=o`00f_l0
0?gooYX0oojJf?l00<go003=o`00c_l00<go003NooP00?onV]So003=o`00cOl0
0<go003=o`00_Ol35kKo003kooX0mOl00?Go003eo`00m?l00?Go003eo`00mOl0
0?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl0
0=[o003mooh00?ok0?Go003eo`00mOl00?Go003eo`00m?l00?Go003eo`00mOl0
0?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003Noo`0o_ol
00;oo`3eo`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl0
0?Go003eo`00m?l00?Go003eo`00mOl00?Co003eo`00POobo`00nooknP00mOl0
0?Go003eo`00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00mOl0
0?Co003eo`00mOl00?Go003do`00mOl00=[o003mookj0?onn_h0mOl00?Go003e
o`00mOl00?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003e
o`00m?l00?Go003eo`00mOl00=kom`3nnP;oo`3eo`00mOl00?Go003do`00mOl0
0?Go003eo`00mOl00?Co003eo`00mOl00?Go003eo`00m?l00?Go003eo`00mOl0
0?Co003eo`00POobo`00nookVP00mOl00?Go003eo`00m?l00?Go003eo`00mOl0
0?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl0
0=[o003moojJ0?onV_;o003eo`00mOl00?Go003eo`00m?l00?Go003eo`00mOl0
0?Go003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003NooT00Ooo
oYX2ool0mOl00?Go003eo`00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go
003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl00;go06^foh40P@3h0=[o
P@210?P0g_ol007ooh40P@3m087ol_oj0?_jP@250=[oo03nnP00o_Z108@0g_og
0?kjP@23087ol_oj0?^JP@250=[oo03nVP00oY[noh40Q`3NooX0o_onVX40P`2m
o`1R[ook087oPOoIooh00?ok087oPOoSooD0POn1oh7okOoknX7oPOoIookj0?on
n_h0POn1on?on03nnX7oPOn1ongoniZ1oh7ofOonVP3ooYZ1oh7oh?on0?_ooYZ1
oh7o_ol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oWol2/X[ooP3mo`400?go0@00fOl00?go0@00oOl1003Jo`400?go
0@00oOl1003Kooh0oOl1003mo`400=go003lo`400?go0@00oOl1002fooh0oOl1
003mo`400=Wo003mo`400?go0@00f_l1003mo`400?go0@00g?on0?go0@00oOl1
003Mo`00o?l1003mo`400?go0@00^Oon0?go0@00oOl1003Io`00oOl1003mo`40
0=[o0@00oOl1003mo`400=_ooP3mo`400?go0@00gOl00?co0@00oOl1003mo`40
087ocoon0?go0@00oOl1003Io`00oOl1003mo`400=[o0@00oOl1003mo`400=_o
oP3mo`400?go0@00gOl00?co0@00oOl1003mo`400;KooP3mo`400?go0@00fOl0
0?go0@00oOl1003Jo`400?go0@00oOl1003Looh0oOl1003mo`400=go003lo`40
0?go0@00oOl1002iooh0oOl1003mo`400=Wo003mo`400?go0@00f_l1003mo`40
0?go0@00foon0?go0@00oOl1003Mo`00o?l1003mo`400?go0@00POo?ooh0oOl1
003mo`400=Wo003mo`400?go0@00f_l1003mo`400?go0@00foon0?go0@00oOl1
003Mo`00o?l1003mo`400?go0@00]_on0?go0@00oOl1003Io`00oOl1003mo`40
0=[o0@00oOl1003mo`400=cooP3mo`400?go0@00gOl00?co0@00oOl1003mo`40
0;WooP3mo`400?go0@00fOl00?go0@00oOl1003Jo`400?go0@00oOl1003Kooh0
oOl1003mo`400=go003lo`400?go0@00oOl10036o`>1Rol00?ko303oo`3oo`3o
o`3oo`3Ko`400?ko2@3oo`3oo`3oo`3Lo`00o?l90?oo0?oo0?oo0=go003no``0
ool0ool0ool0ool0gol1003mo`l0ool0ool0ool0ool0ool0^?l00?ko303oo`3o
o`3oo`3oo`3Ko`400?ko2@3oo`3oo`3oo`3Lo`00o?l90?oo0?oo0?oo0=ko003n
o``0ool0ool0ool0ool0gol1003mo`l0ool0ool0ool0ool0ool0^ol00?ko303o
o`3oo`3oo`3oo`3Ko`400?ko2@3oo`3oo`3oo`3Lo`00o?l90?oo0?oo0?oo0=go
003no``0ool0ool0ool0ool0gol1003mo`l0ool0ool0ool0ool0ool0POoAo`00
o_l<0?oo0?oo0?oo0?oo0=_o0@00o_l90?oo0?oo0?oo0=co003lo`T0ool0ool0
ool0gOl00?ko303oo`3oo`3oo`3oo`3Oo`400?go3`3oo`3oo`3oo`3oo`3oo`2h
o`00o_l<0?oo0?oo0?oo0?oo0=_o0@00o_l90?oo0?oo0?oo0=co003lo`T0ool0
ool0ool0g_l00?ko303oo`3oo`3oo`3oo`3Oo`400?go3`3oo`3oo`3oo`3oo`3o
o`2ko`00o_l<0?oo0?oo0?oo0?oo0=_o0@00o_l90?oo0?oo0?oo0=co003lo`T0
ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3Oo`400?go3`3oo`3oo`3oo`3o
o`3oo`21om7o003no``0ool0ool0ool0ool0fol1003no`T0ool0ool0ool0g?l0
0?co2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=oo0@00oOl?0?oo0?oo
0?oo0?oo0?oo0;So003no``0ool0ool0ool0ool0fol1003no`T0ool0ool0ool0
g?l00?co2@3oo`3oo`3oo`3No`00o_l<0?oo0?oo0?oo0?oo0=oo0@00oOl?0?oo
0?oo0?oo0?oo0?oo0;_o003no``0ool0ool0ool0ool0fol1003no`T0ool0ool0
ool0g?l00?co2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=oo0@00oOl?
0?oo0?oo0?oo0?oo0?oo0<Oo0h6;o`00o_l<0?oo0?oo0?oo0?oo0=co0P3o0?ko
2@3oo`3oo`3oo`3Mo`00nol90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0
g_l00?go3`3oo`3oo`3oo`3oo`3oo`2ho`00o_l<0?oo0?oo0?oo0?oo0=co0P3o
0?ko2@3oo`3oo`3oo`3Mo`00nol90?oo0?oo0?oo0=ko003no``0ool0ool0ool0
ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`2ko`00o_l<0?oo0?oo0?oo0?oo0=co
0P3o0?ko2@3oo`3oo`3oo`3Mo`00nol90?oo0?oo0?oo0=go003no``0ool0ool0
ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`21om7o003no``0ool0ool0ool0
ool0g?l20?l0o_l90?oo0?oo0?oo0=go003ko`T0ool0ool0ool0gOl00?ko303o
o`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;So003no``0ool0ool0
ool0ool0g?l20?l0o_l90?oo0?oo0?oo0=go003ko`T0ool0ool0ool0g_l00?ko
303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;_o003no``0ool0
ool0ool0ool0g?l20?l0o_l90?oo0?oo0?oo0=go003ko`T0ool0ool0ool0gOl0
0?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo087odOl00?ko
303oo`3oo`3oo`3oo`3Lo`80o`3no`T0ool0ool0ool0gOl00?_o2@3oo`3oo`3o
o`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0^?l0
0?ko303oo`3oo`3oo`3oo`3Lo`80o`3no`T0ool0ool0ool0gOl00?_o2@3oo`3o
o`3oo`3No`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0
^ol00?ko303oo`3oo`3oo`3oo`3Lo`80o`3no`T0ool0ool0ool0gOl00?_o2@3o
o`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0
ool0aol3E8So003no`T0ool0ool0ool0gOl30?oo0?ko2@3oo`3oo`3oo`3Mood0
o_l90?oo0?oo0?oo0=cooP3no`T0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3o
o`3oo`2eo`00o_l90?oo0?oo0?oo0=go0`3oo`3no`T0ool0ool0ool0gOom0?ko
2@3oo`3oo`3oo`3Mooh0o_l90?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0
ool0^?l00?ko2@3oo`3oo`3oo`3Mo`<0ool0o_l90?oo0?oo0?oo0=goo@3no`T0
ool0ool0ool0g?on0?ko2@3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo
087oc_l00?ko2@3oo`3oo`3oo`3Mo`<0ool0o_l90?oo0?oo0?oo0=goo@3no`T0
ool0ool0ool0g?on0?ko2@3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo
0;Go003no`T0ool0ool0ool0gOl30?oo0?ko2@3oo`3oo`3oo`3Mood0o_l90?oo
0?oo0?oo0=gooP3no`T0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`2h
o`00o_l90?oo0?oo0?oo0=go0`3oo`3no`T0ool0ool0ool0gOom0?ko2@3oo`3o
o`3oo`3Looh0o_l90?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0POo>
o`00o_l90?oo0?oo0?oo0=go0`3oo`3no`T0ool0ool0ool0gOom0?ko2@3oo`3o
o`3oo`3Looh0o_l90?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0]Ol0
0?ko2@3oo`3oo`3oo`3Mo`<0ool0o_l90?oo0?oo0?oo0=goo@3no`T0ool0ool0
ool0gOon0?ko2@3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;So003n
o`T0ool0ool0ool0gOl30?oo0?ko2@3oo`3oo`3oo`3Mood0o_l90?oo0?oo0?oo
0=cooP3no`T0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`37o`=_ROl0
0?go2@3oo`3oo`3oo`3Moo`02ooo0?oo0?oo0?oo0=go003no``0ool0ool0ool0
ool0gOl00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;Ko
003mo`T0ool0ool0ool0gOol00_oo`3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo
0?oo0=ko003no``0ool0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`2i
o`00oOl90?oo0?oo0?oo0=goo00;ool0ool0ool0ool0gOl00?ko303oo`3oo`3o
o`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0
POo?o`00oOl90?oo0?oo0?oo0=goo00;ool0ool0ool0ool0gOl00?ko303oo`3o
o`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0
ool0]_l00?go2@3oo`3oo`3oo`3Moo`02ooo0?oo0?oo0?oo0=go003no``0ool0
ool0ool0ool0g_l00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo
0?oo0;Wo003mo`T0ool0ool0ool0gOol00_oo`3oo`3oo`3oo`3Mo`00o_l<0?oo
0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3o
o`3oo`21oloo003mo`T0ool0ool0ool0gOol00_oo`3oo`3oo`3oo`3Mo`00o_l<
0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?go3`3oo`3oo`3o
o`3oo`3oo`2fo`00oOl90?oo0?oo0?oo0=goo00;ool0ool0ool0ool0gOl00?ko
303oo`3oo`3oo`3oo`3No`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0
ool0ool0ool0^Ol00?go2@3oo`3oo`3oo`3Moo`02ooo0?oo0?oo0?oo0=go003n
o``0ool0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo
0?oo0?oo0?oo0<Oo0h6:o`l0ool0ool0ool0ool0ool0f_l00?ko2@3oo`3oo`3o
o`3Mo`00o_l<0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?go
3`3oo`3oo`3oo`3oo`3oo`2go`l0ool0ool0ool0ool0ool0f_l00?ko2@3oo`3o
o`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003no``0ool0ool0ool0ool0g_l0
0?go3`3oo`3oo`3oo`3oo`3oo`2jo`l0ool0ool0ool0ool0ool0f_l00?ko2@3o
o`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0
g_l00?go3`3oo`3oo`3oo`3oo`3oo`21om3o3`3oo`3oo`3oo`3oo`3oo`3Jo`00
o_l90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0gOl00?ko303oo`3oo`3o
o`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;Oo3`3oo`3oo`3oo`3oo`3oo`3J
o`00o_l90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?ko303oo`3o
o`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;[o3`3oo`3oo`3oo`3oo`3o
o`3Jo`00o_l90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0gOl00?ko303o
o`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo087od?l?0?oo0?oo0?oo
0?oo0?oo0=[o003no`T0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3Mo`00
o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0]ol?0?oo0?oo
0?oo0?oo0?oo0=[o003no`T0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3N
o`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0^_l?0?oo
0?oo0?oo0?oo0?oo0=[o003no`T0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3o
o`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0aol2
ZH_oo03no`400?go0@00f_on0?ko0@00oOl1003Kooh0oOl1003mo`400=_ooP3m
o`400?go0@00g_on0?go0@00oOl1003mo`400;Ooo03no`400?go0@00f_on0?ko
0@00oOl1003Kooh0oOl1003mo`400=cooP3mo`400?go0@00g_on0?go0@00oOl1
003mo`400;[oo03no`400?go0@00f_on0?ko0@00oOl1003Kooh0oOl1003mo`40
0=_ooP3mo`400?go0@00g_on0?go0@00oOl1003mo`40087od?ol0?ko0@00oOl1
003Jooh0o_l1003mo`400=_ooP3mo`400?go0@00foon0?go0@00oOl1003Nooh0
oOl1003mo`400?go0@00]ool0?ko0@00oOl1003Jooh0o_l1003mo`400=_ooP3m
o`400?go0@00g?on0?go0@00oOl1003Nooh0oOl1003mo`400?go0@00^_ol0?ko
0@00oOl1003Jooh0o_l1003mo`400=_ooP3mo`400?go0@00foon0?go0@00oOl1
003Nooh0oOl1003mo`400?go0@00POo@oo`0o_l1003mo`400=[ooP3no`400?go
0@00foon0?go0@00oOl1003Kooh0oOl1003mo`400=kooP3mo`400?go0@00oOl1
002goo`0o_l1003mo`400=[ooP3no`400?go0@00foon0?go0@00oOl1003Looh0
oOl1003mo`400=kooP3mo`400?go0@00oOl1002joo`0o_l1003mo`400=[ooP3n
o`400?go0@00foon0?go0@00oOl1003Kooh0oOl1003mo`400=kooP3mo`400?go
0@00oOl10036o`15POnfo`00POn1oh7oPOnVo`40087oPOn1onWo0021oh7oPOn1
ojKo0@00POn1oh7ojOl0087oPOn1oh7oY_l10021okCo03R1oh7oPOn1oh7oPOoI
o`00POn1oh7oPOn1oh7oPOn<o`00POn1oh7oPOn1oh7oPOn<o`00POndo`2:POnm
ood00?on0?gonP01o`3no`40087oPOoVo`@00?l0087oPOoGooh0POn1oh7ol_om
003ooP3mooX00Ol0o_l10021oh7oi_l4003o0021oh7oeoon087oPOn1oo;oo@00
ooh0oOoj007o0?ko0@00POn1onKo1000o`00POn1omOooP21okKo09n1okko003j
o`00o_l00?ko2`3o0?l0o`3o0?oo087oPOoVo`40087oPOoEo`<0ool0POn1oh7o
m?l00?[o003no`00o_l;0?l0o`3o0?l0ool0POn1onKo0@00POn1omGo0`3oo`21
oh7oPOodo`00n_l00?ko003no`/0o`3o0?l0o`3oo`21oh7oi_l10021oh7oeOl3
0?oo087o]ol0VH7o_Oon0?go003no`00o_l80?l0o`3o0?oooP21oh7oi_l0087o
POoDo`<0ool0POn1oh7oloon0?go003no`00o_l80?l0o`3o0?oooP21oh7oi_l0
087oPOoDo`<0ool0POn1oh7oloon0?go003no`00o_l80?l0o`3o0?oooP21oh7o
i_l0087oPOoDo`<0ool0POngo`2LPOnjo`00o_l00?ko003no`/0o`3o0?l0o`3o
o`21oh7oi_l0087oPOoDo`<0ool0POn1oh7ol?l00?ko003no`00o_l;0?l0o`3o
0?l0ool0POn1onKo0021oh7oe?l30?oo087oPOn1oo3o003no`00o_l00?ko2`3o
0?l0o`3o0?oo087oPOoVo`00POn1omCo0`3oo`21okOo08f1okkoo@01oool007o
ood01ol0o`3o0?ooo@21oh7oj?on087oPOoFood0POn1oh7oloom007ooo`00Ooo
o@07o`3o0?l0ooom087oPOoXooh0POn1omKoo@21oh7oPOocood00Oooo001ooom
00Oo0?l0o`3oood0POn1onSooP21oh7oe_om087o]_l0>87o[_l0087oPOn1oh7o
POn1oh7oS?l0087oPOn1oh7oPOn1oh7oS?l0087oPOn1oh7oPOn1omoo03R1ok7o
oP21oh7oPOn1oh7oPOn1ohkooP21oh7oPOn1oh7oPOn1ohkooP21oh7oPOn1oh7o
POoNo`0hPOn1oh7oPOn1onCooP21oh7oPOn1oh7oPOn1ohkooP21oh7oPOn1oh7o
POn1ohkooP21oh7oZol0GL;ooP01oool087oPOn1oh7o[_l00?ko0021oh7oPOo]
ooh00Oooo021oh7oPOn1ojko003no`00POn1oh7okOon007ooo`0POn1oh7oPOn^
o`00o_l0087oPOn/o`1P`ol00?ko0P3o087oPOn1oh7oZ_l00?ko0021oh7oPOo^
o`00o_l20?l0POn1oh7oPOnZo`00o_l0087oPOn1onko003no`80o`21oh7oPOn1
oj[o003no`00POn1ojco06o3o`00o_l10?om087oPOoBoh40P@3f0>KooP3loh40
P@3f087ooOl00?ko0@3oo@21oh7od_n10840mP3Vooh0o?n10840mP21oogo003n
o`40ood0POn1om;oP@210?H0i_on0?coP@210?H0^ol2BL3o003ko`00oOn10840
m`3Qo`00m?l00?Go003eo`00mOl00?Co003eo`00mOl00?Co003eo`00mOl00?Go
003do`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003Wo`00o_l00?go
003eo`00mOl00?Co003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl00?Go
003do`00mOl00?Go003eo`00m?l00?Go003eo`00mOl10021oo[o003ko`00oOn1
0840m`3Qo`00m?l00?Go003eo`00mOl00?Co003eo`00mOl00?Co003eo`00mOl0
0?Go003do`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003Wo`00o_l0
0?go003eo`00mOl00?Co003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl0
0?Go003do`00mOl00?Go003eo`00m?l00?Go003eo`00mOl10021oo[o003ko`00
oOn10840m`3Qo`00m?l00?Go003eo`00mOl00?Co003eo`00mOl00?Co003eo`00
mOl00?Go003do`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003Wo`00
o_l00?go003eo`00mOl00?Co003eo`00mOl00?Co003eo`00mOl00?Go003do`00
mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003eo`00mOl1002ko`75`Ol0
0?[o003mo`00m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00m?l0
0?Go003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl00?Go003Qo`00cOl0
0<co003=o`00cOl00<go003Wo`00o_l00?go003=o`00cOl00<go003=o`00cOl1
0021oo_o003jo`00oOl00?Co003eo`00mOl00?Go003eo`00m?l00?Go003eo`00
mOl00?Co003eo`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003eo`00
hOl00<go003<o`00cOl00<go003=o`00iol00?ko003mo`00cOl00<go003=o`00
cOl00<go0@00POoko`00n_l00?go003do`00mOl00?Go003eo`00mOl00?Co003e
o`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003eo`00mOl00?Co003e
o`00mOl00>7o003=o`00c?l00<go003=o`00cOl00>Oo003no`00oOl00<go003=
o`00cOl00<go003=o`400;_o0:G2o`D0ool0o`3no`00oOl0087oPOoio`00hOl0
087oPOoho`00i_on0?co0021oh7on?l0087oo?l50?oo0?l0o_l00?go0021oh7o
nOl00>7o0021oh7on?l00>KooP3lo`00POn1ooSo0021ooco1@3oo`3o0?ko003m
o`00POn1ooWo003Qo`00POn1ooSo003Vooh0o?l0087oPOoho`00^ol0Tl?oo001
ooon0?co0021oh7onOl00>7o0021oh7on?l00=ko0@00POn1oo[o0@00POomoo`0
0OoooP3lo`00POn1ooWo003Qo`00POn1ooSo003No`40087oPOojo`40087ooOol
007oooh0o?l0087oPOoio`00hOl0087oPOoho`00g_l10021oh7on_l1002ko`1h
]?l10021oh7onol1003Qo`00POn1ooSo003No`00POn1ooSo0021onko0@00POn1
oo_o0@00hOl0087oPOoho`00g_l0087oPOoho`00POo^o`40087oPOoko`400>7o
0021oh7on?l00=ko0021oh7on?l00;_o07Rdo`00POn1ooWo003Qo`40087oPOoj
o`400=ko0021oh7on?l0087ok_l0087oPOoio`00hOl10021oh7on_l1003No`00
POn1ooSo0021onko0021oh7onOl00>7o0@00POn1oo[o0@00g_l0087oPOoho`00
^ol0L[Co0021oh7onOl00>7o0021oh7on?l00=ko0021oh7on?l0087ok_l0087o
POoio`00hOl0087oPOoho`00g_l0087oPOoho`00POo^o`00POn1ooWo003Qo`00
POn1ooSo003No`00POn1ooSo002ko`2:]?l0087oPOoio`00koon0?co003lo`00
POn1ooSo003No`00POn1ooSo0021onko0021oh7onOl00>oooP3lo`00o?l0087o
POoho`00g_l0087oPOoho`00POo^o`00POn1ooWo003_ooh0o?l00?co0021oh7o
n?l00=ko0021oh7on?l00;_o0:Fdo`40087oPOoko`400?3o003no`00o_l1003l
o`00POn1ooSo003No`40087oPOojo`40087ok_l10021oh7onol1003`o`00o_l0
0?ko0@00o?l0087oPOoho`00g_l10021oh7on_l10021onko0@00POn1oo_o0@00
l?l00?ko003no`400?co0021oh7on?l00=ko0@00POn1oo[o0@00^ol0SKCo0021
oh7onOl00>co1@3oo`3o0?co0021oh7on?l00=ko0021oh7on?l0087ok_l0087o
POoio`00k?l50?oo0?l0o?l0087oPOoho`00g_l0087oPOoho`00POo^o`00POn1
ooWo003/o`D0ool0o`3lo`00POn1ooSo003No`00POn1ooSo002ko`2F]?l0087o
POoio`00k_l7003oo`3oo`3looh0POn1oo_o0@00g_l0087oPOoho`00POo^o`00
POn1ooWo003^o`L00?oo0?oo0?cooP21oh7onol1003No`00POn1ooSo0021onko
0021oh7onOl00>ko1`00ool0ool0o?on087oPOoko`400=ko0021oh7on?l00;_o
08Ndo`00POn1ooWo003/o`40oo`0oOl0087oPOoho`00g_l0087oPOoho`00POo^
o`00POn1ooWo003/o`40oo`0oOl0087oPOoho`00g_l0087oPOoho`00POo^o`00
POn1ooWo003/o`40oo`0oOl0087oPOoho`00g_l0087oPOoho`00^ol0X[Co0@00
POn1oo_o0@00l?l00?ko003mo`00o?l0087oPOoho`00g_l10021oh7on_l10021
onko0@00POn1oo_o0@00l?l00?ko003mo`00o?l0087oPOoho`00g_l10021oh7o
n_l10021onko0@00POn1oo_o0@00l?l00?ko003mo`00o?l0087oPOoho`00g_l1
0021oh7on_l1002ko`2:]?l0087oPOoio`00koon0?gooP3mo`00POn1ooSo003N
o`00POn1ooSo0021onko0021oh7onOl00>oooP3mooh0oOl0087oPOoho`00g_l0
087oPOoho`00POo^o`00POn1ooWo003_ooh0oOon0?go0021oh7on?l00=ko0021
oh7on?l00;_o07:do`00POn1ooWo003Qo`00POn1ooSo003No`00POn1ooSo0021
onko0021oh7onOl00>7o0021oh7on?l00=ko0021oh7on?l0087ok_l0087oPOoi
o`00hOl0087oPOoho`00g_l0087oPOoho`00^ol0L[Co0021oh7onOl00>7o0021
oh7on?l00=ko0021oh7on?l0087ok_l0087oPOoio`00hOl0087oPOoho`00g_l0
087oPOoho`00POo^o`00POn1ooWo003Qo`00POn1ooSo003No`00POn1ooSo002k
o`24]?l10021oh7onol1003Qo`40087oPOojo`400=ko0@00POn1oo[o0@00POo^
o`40087oPOoko`400>7o0@00POn1oo[o0@00g_l10021oh7on_l10021onko0@00
POn1oo_o0@00hOl10021oh7on_l1003No`40087oPOojo`400;_o09k>ooh0o_on
0?Woo03mo`00POn1ooWo003Qo`00POn1ooSo003Woo`0oOl0087oPOoho`00R?on
0?kooP3ioo`0oOl0087oPOoio`00hOl0087oPOoho`00iool0?go0021oh7on?l0
08SooP3nooh0nOol0?go0021oh7onOl00>7o0021oh7on?l00>Ooo03mo`00POn1
ooSo002ko`2lcol00?ko0P3o0?ko003jo`00nOl0087oPOoio`00hOl0087oPOoh
o`00iol00?ko003mo`00POn1ooSo0029o`00o_l20?l0o_l00?[o003io`00POn1
ooWo003Qo`00POn1ooSo003Wo`00o_l00?go0021oh7on?l008Wo003no`80o`3n
o`00n_l00?Wo0021oh7onOl00>7o0021oh7on?l00>Oo003no`00oOl0087oPOoh
o`00^ol0/<oo003no`80o`3no`00n_om0?co0021oh7onOl00>7o0021oh7on?l0
0>?o003mo`00POn1ooSo0029o`00o_l20?l0o_l00?[oo@3lo`00POn1ooWo003Q
o`00POn1ooSo003So`00oOl0087oPOoho`00ROl00?ko0P3o0?ko003jood0o?l0
087oPOoio`00hOl0087oPOoho`00hol00?go0021oh7on?l00;_o0:C<o`00o?l0
0?Go003mooh0POn1ooco0@00hOl0087oPOoho`00i?l00?co0@00POn1oo_ooP26
o`00o?l00?Go003mooh0POn1ooco0@00hOl0087oPOoho`00i?l00?co0@00POn1
oo_ooP26o`00o?l00?Go003mooh0POn1ooco0@00hOl0087oPOoho`00i?l00?co
0@00POn1oo_ooP2ko`2TcOl00?co003do`00oOl0087oPOoio`00hOl10021oh7o
n_l1003To`00o?l0087oPOoho`00Qol00?co003do`00oOl0087oPOoio`00hOl1
0021oh7on_l1003To`00o?l0087oPOoho`00Qol00?co003do`00oOl0087oPOoi
o`00hOl10021oh7on_l1003To`00o?l0087oPOoho`00^ol0^Lko2@3oo`3oo`3o
o`3jo`00o_l00?go0021oh7onOl00>7o0021oh7on?l00>Go003ko`00POn1ooSo
0028o`T0ool0ool0ool0n_l00?ko003mo`00POn1ooWo003Qo`00POn1ooSo003U
o`00nol0087oPOoho`00R?l90?oo0?oo0?oo0?[o003no`00oOl0087oPOoio`00
hOl0087oPOoho`00iOl00?_o0021oh7on?l00;_o0:[?oo`00?ol0?ko003mooh0
o?l0087oPOoio`00hOl0087oPOoho`00iOl00?_o0021oh7on?l008Woo000oo`0
o_l00?gooP3lo`00POn1ooWo003Qo`00POn1ooSo003Uo`00nol0087oPOoho`00
ROol003oo03no`00oOon0?co0021oh7onOl00>7o0021oh7on?l00>Go003ko`00
POn1ooSo002ko`1n]?l10021oh7onol1003Qo`00POn1ooSo003No`40087oPOoj
o`40087ok_l10021oh7onol1003Qo`00POn1ooSo003No`40087oPOojo`40087o
k_l10021oh7onol1003Qo`00POn1ooSo003No`40087oPOojo`400;_o07:do`00
POn1ooWo003Qo`00POn1ooSo003No`00POn1ooSo0021onko0021oh7onOl00>7o
0021oh7on?l00=ko0021oh7on?l0087ok_l0087oPOoio`00hOl0087oPOoho`00
g_l0087oPOoho`00^ol0L[Co0021oh7onOl00>7o0021oh7on?l00=ko0021oh7o
n?l0087ok_l0087oPOoio`00hOl0087oPOoho`00g_l0087oPOoho`00POo^o`00
POn1ooWo003Qo`00POn1ooSo003No`00POn1ooSo002ko`1h]?l0087oPOoio`00
hOl10021oh7on_l1003No`00POn1ooSo0021onko0021oh7onOl00>7o0@00POn1
oo[o0@00g_l0087oPOoho`00POo^o`00POn1ooWo003Qo`40087oPOojo`400=ko
0021oh7on?l00;_o07jdo`40087oPOoko`400>7o0021oh7on?l00=ko0@00POn1
oo[o0@00POo^o`40087oPOoko`400>7o0021oh7on?l00=ko0@00POn1oo[o0@00
POo^o`40087oPOoko`400>7o0021oh7on?l00=ko0@00POn1oo[o0@00^ol0R[Co
0021oh7onOl00>oooP3nooh0o?l0087oPOoho`00g_l0087oPOoho`00POo^o`00
POn1ooWo003_ooh0o_on0?co0021oh7on?l00=ko0021oh7on?l0087ok_l0087o
POoio`00koon0?kooP3lo`00POn1ooSo003No`00POn1ooSo002ko`2L]?l0087o
POoio`00l?l00?ko0P3o0?ko003mo`00POn1ooSo003No`00POn1ooSo0021onko
0021oh7onOl00?3o003no`80o`3no`00oOl0087oPOoho`00g_l0087oPOoho`00
POo^o`00POn1ooWo003`o`00o_l20?l0o_l00?go0021oh7on?l00=ko0021oh7o
n?l00;_o092do`00POn1ooWo003/o`80o`3no`00oOl0087oPOoho`00g_l0087o
POoho`00POo^o`00POn1ooWo003/o`80o`3no`00oOl0087oPOoho`00g_l0087o
POoho`00POo^o`00POn1ooWo003/o`80o`3no`00oOl0087oPOoho`00g_l0087o
POoho`00^ol0W;Co0@00POn1oo_o0@00k_l1003lo`00o?on087oPOoko`400=ko
0@00POn1oo[o0@00POo^o`40087oPOoko`400>ko0@00o?l00?cooP21oh7onol1
003No`40087oPOojo`40087ok_l10021oh7onol1003^o`400?co003looh0POn1
oo_o0@00g_l10021oh7on_l1002ko`2@]?l00=_oi021okco003/o`00o_l00?_o
0021oh7on?l00=ko0021oh7on?l0087ok_l00=_oi?Z1okco003/o`00o_l00?_o
0021oh7on?l00=ko0021oh7on?l0087ok_l00=_oi9Z1okco003/o`00o_l00?_o
0021oh7on?l00=ko0021oh7on?l00;_o0::do`00j?oG087o_?l00?3o003no`H0
ool0ool0oOl0087oPOoho`00g_l0087oPOoho`00POo^o`00j?oGnX7o_?l00?3o
003no`H0ool0ool0oOl0087oPOoho`00g_l0087oPOoho`00POo^o`00j?oGVX7o
_?l00?3o003no`H0ool0ool0oOl0087oPOoho`00g_l0087oPOoho`00^ol0WkCo
003XomL0m_oG087olOl00>oooP01oool0?go0021oh7on?l00=ko0021oh7on?l0
087ok_l00>Soeo[fomOjPOoao`00koon007ooo`0oOl0087oPOoho`00g_l0087o
POoho`00POo^o`00j?oGV_KoeiZ1oo7o003_ooh00Oooo03mo`00POn1ooSo003N
o`00POn1ooSo002ko`2@]?l1003fon@0j_o9087ol_l1003Qo`00POn1ooSo003N
o`40087oPOojo`40087ok_l1003fonCjj_o9nX7ol_l1003Qo`00POn1ooSo003N
o`40087oPOojo`40087ok_l1003fonBJj_o9VX7ol_l1003Qo`00POn1ooSo003N
o`40087oPOojo`400;_o09Vdo`00mOoa0=gob@3Yoo40VOl00>7o0021oh7on?l0
0>Go0@00o?l0087oPOoho`00POo^o`00mOoan]gobO[Yoo7jVOl00>7o0021oh7o
n?l00>Go0@00o?l0087oPOoho`00POo^o`00mOoaV]gobI[Yoo6JVOl00>7o0021
oh7on?l00>Go0@00o?l0087oPOoho`00^ol0`l;ooP3mo`400?co003eoo40gOoa
0=cooP3Yoo40VOl00>7o0@00POn1oo[o0@00i_l00?[o0021oh7on?l0087oo?on
0?go0@00o?l00?GolO[Moo7jg?onn^WolOZIo`00hOl10021oh7on_l1003Vo`00
n_l0087oPOoho`00POolooh0oOl1003lo`00mOoaV]golI[LoojJjOoaVYWo003Q
o`40087oPOojo`400>Ko003jo`00POn1ooSo002ko`30`ol00?ko1P3oo`3oo`3m
o`00mOon09_ooP3fojl0c_l00>7o0021oh7on?l00>Oo003io`00POn1ooSo0021
oogo003no`H0ool0ool0oOl00?Goo_ZKookjm_n_n/ko003Qo`00POn1ooSo003W
o`00nOl0087oPOoho`00POomo`00o_l60?oo0?oo0?go003eoojJVoonV_Ko[i[>
o`00hOl0087oPOoho`00iol00?Wo0021oh7on?l00;_o0<?3o`00o_l60?oo0?oo
0?go003eooh0VooS0?Oob@3>o`00hOl0087oPOoho`00ioom0?co0@00POn1oo_o
oP21oogo003no`H0ool0ool0oOl00?Goo_ZKon?jmoo9n/ko003Qo`00POn1ooSo
003Wood0o?l10021oh7onoon087ooOl00?ko1P3oo`3oo`3mo`00mOonVY_ohi[g
olVJc_l00>7o0021oh7on?l00>Ooo@3lo`40087oPOokooh0^ol0d/3o003no`<0
ool0oOon0?OooP2Kon<0moo90>WolP3fo`400>7o0021oh7on?l00>Oo003no`00
oOl0087oPOoho`00POojo`00o_l30?oo0?gooP3gookjVooSn_OobO[Yoo;jm_l1
003Qo`00POn1ooSo003Wo`00o_l00?go0021oh7on?l0087on_l00?ko0`3oo`3m
ooh0moonVY_ohi[golVJjOobV_Ko0@00hOl0087oPOoho`00iol00?ko003mo`00
POn1ooSo002ko`2g`Ol00?go0`3oo`3mo`00mOon09_ol@2dolT0h_l0087oPOoh
o`00iol00?ko003mo`00POn1ooSo0021oo_o003mo`<0ool0oOl00?Goo_ZKoo7j
]?o9n^;o0021oh7on?l00>Oo003no`00oOl0087oPOoho`00POoko`00oOl30?oo
0?go003eoojJVooaV[CobI[Ro`00POn1ooSo003Wo`00o_l00?go0021oh7on?l0
0;_o0:S2o`T0ool0ool0ool0oOl00?GooP21okkob@3Soo40POn7o`400>KooP3l
o`00POn1ooSo0021ooco2@3oo`3oo`3oo`3mo`00mOonnX7o__o9n^?olOZ1ohOo
0@00i_on0?co0021oh7on?l0087oo?l90?oo0?oo0?oo0?go003eoojJPOnnolVJ
hooaVX7oQol1003Vooh0o?l0087oPOoho`00^ol0VL?oo03no`400?co003eooh0
POnnon@0m_oa0>?ol@21ohKo003No`00POn1ooSo0021oogoo03no`400?co003e
ookjPOnnonCjm_oan^?olOZ1ohKo003No`00POn1ooSo0021oogoo03no`400?co
003eoojJPOnnonBJm_oaV^?olIZ1ohKo003No`00POn1ooSo002ko`1k]?l1003f
ooh0POn9ooh0hooa087oQ_l00=ko0@00POn1oo[o0@00POo^o`400?Koo_Z1ohWo
o_[Soo7jPOn6o`00g_l10021oh7on_l10021onko0@00m_onVX7oROonV^?olIZ1
ohKo003No`40087oPOojo`400;_o07jdo`00mOon087oROon0>;o003fooh0POn6
o`00g_l0087oPOoho`00POo^o`00mOonnX7oROonn^;o003fookjPOn6o`00g_l0
087oPOoho`00POo^o`00mOonVX7oROonV^;o003foojJPOn6o`00g_l0087oPOoh
o`00^ol0N;Co003eooh0POn9ooh0h_l00?KooP21ohKo003Ooo40POn6o`00POo^
o`00mOonnX7oROonn^;o003fookjPOn6o`00gooanX7oQ_l0087ok_l00?GooYZ1
ohWooY[Ro`00m_onVX7oQ_l00=oolIZ1ohKo002ko`20]?l00?GooP21ohSo003Q
o`00m_on087oQ_l00=ool@21ohKo0021onko003eookjj_oT087o_?l00>7o003f
ookjPOn6o`00gooanX7oQ_l0087ok_l00?GooY[Zon@0POnlo`00hOl00?KooYZ1
ohKo003Ooo6JPOn6o`00^ol0SkCo0@00m_on087oROl1003Qo`400?OooP21ohOo
0@00gooa087oQol10021onko0@00m_onn_Ooe`21okgo0@00hOl1003gookjPOn7
o`400=oolOZ1ohOo0@00POo^o`400?KooY[gomL0POnmo`400>7o0@00moonVX7o
Qol1003Ooo6JPOn7o`400;_o08bdo`00mOon087oR?l00>7o003fooh0POn6o`00
g_l00?KooP21ohKo0021onko003eookjmonR087olOl00>7o003fookjPOn6o`00
g_l00?Koo_Z1ohKo0021onko003eoojJmonR087olOl00>7o003foojJPOn6o`00
g_l00?KooYZ1ohKo002ko`2U]?l0087oPOoio`00koon0?go0@00o?l00?KooP21
ohKo003No`00m_on087oQ_l0087ok_l00?Goi03ZolT0POoao`00koon0?go0@00
o?l00?Koo_Z1ohKo003No`00m_onnX7oQ_l0087ok_l00?Goi03ZolT0POoao`00
koon0?go0@00o?l00?KooYZ1ohKo003No`00m_onVX7oQ_l00;_o0;Rdo`00POn1
ooWo003`o`00o_l60?oo0?oo0?go003fooh0POn6o`00g_l00?KooP21ohKo0021
onko003eoo40gOo90>Wol@2Io`00l?l00?ko1P3oo`3oo`3mo`00m_onnX7oQ_l0
0=ko003fookjPOn6o`00POo^o`00mOoa0=gob@3Yoo40VOl00?3o003no`H0ool0
ool0oOl00?KooYZ1ohKo003No`00m_onVX7oQ_l00;_o0<2do`40087oPOoko`40
0>co1P3oo`3oo`3mo`00m_on087oQ_l00=ko0@00moon087oQol10021onko0@00
m_oa0:SooP3fon@0g?oa0<oo0@00k?l60?oo0?oo0?go003fookjPOn6o`00g_l1
003gookjPOn7o`40087ok_l1003foo40Z?on0?Koi03Loo40col1003/o`H0ool0
ool0oOl00?KooYZ1ohKo003No`400?OooYZ1ohOo0@00^ol0[KCo0021oh7onOl0
0>ko0@00o_l30?oo0?gooP3hooh0POn7o`400=ko003fooh0POn6o`00POo^o`00
mOon09_oX@3>o`00k_l1003no`<0ool0oOon0?Soo_Z1ohOo0@00g_l00?Koo_Z1
ohKo0021onko003eooh0VonQ0<ko003^o`400?ko0`3oo`3mooh0n?onVX7oQol1
003No`00m_onVX7oQ_l00;_o0:bdo`00POn1ooWo003/o`H0ool0ool0oOl00?Ko
oP21ohKo003No`00m_on087oQ_l0087ok_l00?GooP2Kon<0moo90<ko003/o`H0
ool0ool0oOl00?Koo_Z1ohKo003No`00m_onnX7oQ_l0087ok_l00?GooP2Kon<0
moo90<ko003/o`H0ool0ool0oOl00?KooYZ1ohKo003No`00m_onVX7oQ_l00;_o
0<Rdo`00POn1ooWo003`o`00o_l60?oo0?oo0?go003fooh0POn6o`00g_l00?Ko
oP21ohKo0021onko003eooh0Vooa0>WoeP3gooh0mooT0?Go003`o`00o_l60?oo
0?oo0?go003fookjPOn6o`00g_l00?Koo_Z1ohKo0021onko003eooh0Vooa0>Wo
eP3gooh0mooT0?Go003`o`00o_l60?oo0?oo0?go003foojJPOn6o`00g_l00?Ko
oYZ1ohKo002ko`2R]?l10021oh7oioon0?go0@00o?l00?KooP21ohKo003No`40
0?OooP21ohOo0@00POo^o`400?KooP21okkob@3`ooh0oOl1003lo`00m_onnX7o
Q_l00=ko0@00moonnX7oQol10021onko0@00m_on087o__o90?3ooP3mo`400?co
003foojJPOn6o`00g_l1003goojJPOn7o`400;_o0:[=o`00o_ol0?[oo03mo`00
POn1omSo003fooh0POn6o`00iool0?go003fooh0POn6o`00Qol00?koo03joo`0
oOl00?GooP21okkob@3Ro`00m_onnX7oQ_l00>Ooo03mo`00m_onnX7oQ_l008Oo
003noo`0n_ol0?go003eooh0POnnolT0h_l00?KooYZ1ohKo003Woo`0oOl00?Ko
oYZ1ohKo002ko`31c_l1003no`00o_l00?[o003io`00POn1omSo003fooh0POn6
o`00iol00?Wo003fooh0POn6o`00R?l1003no`00o_l00?[o003io`00mOon087o
__oa0>Wol@3Ro`00m_onnX7oQ_l00>Oo003io`00m_onnX7oQ_l008So0@00o_l0
0?ko003jo`00nOl00?GooP21okkol@3Yoo40h_l00?KooYZ1ohKo003Wo`00nOl0
0?KooYZ1ohKo002ko`2`cOl00?[o003jood0o?l0087oPOoHo`400?OooP21ohOo
0@00ioom0?co003fooh0POn6o`00Qol00?[o003jood0o?l00?GooP21ohWooP3R
o`400?Ooo_Z1ohOo0@00ioom0?co003fookjPOn6o`00Qol00?[o003jood0o?l0
0?GooP21ohWooP3Ro`400?OooYZ1ohOo0@00ioom0?co003foojJPOn6o`00^ol0
[Lgo003ko`00mOl00?gooP21oh7of_l00?KooP21ohKo003So`00oOl1003gooh0
POn8ooh0Qol00?_o003eo`00oOon0?OooP21ohWooP3Ro`00m_onnX7oQ_l00>?o
003mo`400?Ooo_Z1ohSooP27o`00nol00?Go003mooh0moon087oROon0>;o003f
oojJPOn6o`00hol00?go0@00moonVX7oR?on0;_o0:k=o`00nol00?Go003mo`00
POn1ooWo003Qo`00m_on087oQ_l00>?o003mo`00m_on087oQ_l008Oo003ko`00
mOl00?go003eooh0POn8o`00hOl00?Koo_Z1ohKo003So`00oOl00?Koo_Z1ohKo
0027o`00nol00?Go003mo`00mOon087oR?l00>7o003foojJPOn6o`00hol00?go
003foojJPOn6o`00^ol0d<go003lo`00n?l00?ko003mo`00fooT087o_?l00>7o
003fooh0POn6o`00iol00?ko003mo`00m_on087oQ_l008Oo003lo`00n?l00?ko
003mo`00mOon0>[oi?Z1okco003Qo`00m_onnX7oQ_l00>Oo003no`00oOl00?Ko
o_Z1ohKo0027o`00o?l00?So003no`00oOl00?GooP3ZonBJPOnlo`00hOl00?Ko
oYZ1ohKo003Wo`00o_l00?go003foojJPOn6o`00^ol0]/kooP3mo`00o?l00?go
oP3lo`00j?oG087o_?l0087oPOoGo`00i_on0?co003fooh0POn6o`00R?on0?go
003lo`00oOon0?co003eooh0mooGnX7o_?l00>;ol@21ohKo003Vooh0o?l00?Ko
o_Z1ohKo0028ooh0oOl00?co003mooh0o?l00?GooP3gomNJPOnlo`00h_oa087o
Q_l00>KooP3lo`00m_onVX7oQ_l00;_o08fdo`400>WoXP21oo;o0@00POn1omSo
0@00g_l1003gooh0POn7o`40087ok_l1003fooh0monRnX7ol_l1003Roo40POn7
o`400=ko0@00moonnX7oQol10021onko0@00m_on0?OoXYZ1oo;o0@00h_oa087o
Qol1003No`400?OooYZ1ohOo0@00^ol0S;Co003bonL0j_o90>Wol@2Io`00POn1
omOo003No`00m_on087oQ_l0087ok_l00?GooP3Wn^[obO[Yoo7jVOl00>;ol@21
ohKo003No`00m_onnX7oQ_l0087ok_l00?GooP3WV^[obI[Yoo6JVOl00>;ol@21
ohKo003No`00m_onVX7oQ_l00;_o0:2do`00m_l00?kom03MolT0jOoa09Wo003Q
o`00POn1ooSo003No`00m_on087oQ_l0087ok_l00?Ko0?[n0?CjgOo9n^WolOZI
o`00hOl00?KooP21ohKo003No`00m_onnX7oQ_l0087ok_l00?Ko09[n0?BJgOo9
V^WolIZIo`00hOl00?KooP21ohKo003No`00m_onVX7oQ_l00;_o0:bdo`00m_l0
0?kom02Xooh0m_o:0?Kol@3>o`00hOl0087oPOoho`00g_l00?KooP21ohKo0021
onko003fo`3joP3dnZSoo_[fol[jm_oan/ko003Qo`00m_on087oQ_l00=ko003f
ookjPOn6o`00POo^o`00m_l0V_h0m9ZXoojJm_o:V_KolI[>o`00hOl00?KooP21
ohKo003No`00m_onVX7oQ_l00;_o0:Zdo`400?Oo002Hon<0moo90<oo0@00hOl0
0??o0021ohOo003No`400?OooP21ohOo0@00POo^o`400?Oo0?[n09_oho[golWj
col1003Qo`00m_on003jPOn7o`00g_l1003gookjPOn7o`40087ok_l1003go`2J
oP2Kon>Jmoo9V/oo0@00hOl00?KooP00VX7oQol00=ko0@00moonVX7oQol1002k
o`2Z]?l00?Ko002Hon<0moo90>WolP3eo`00hOl00??o0021ohOo003No`00m_on
087oQ_l0087ok_l00?Ko0?[n09_oho[golWjjOobn_Go003Qo`00m_on003jPOn7
o`00g_l00?Koo_Z1ohKo0021onko003fo`2JoP2Kon>Jmoo9V^WolY[eo`00hOl0
0?KooP00VX7oQol00=ko003foojJPOn6o`00^ol0Y;Co003fo`00V?oa0<kol@3g
olT0h_l1003do`00POn8o`400=ko003fooh0POn6o`00POo^o`00m_l0n_h0Vooa
n/kolO[golWjh_l1003gooh00?Z1ohSo0@00g_l00?Koo_Z1ohKo0021onko003f
o`2JoP2Koo6Jc_oaV_OobI[Ro`400?OooP00VX7oR?l1003No`00m_onVX7oQ_l0
0;_o08bdo`00m_l0087o^oo90>;o003co`00POn7o`00g_l00?KooP21ohKo0021
onko003fo`3joP21okkobO[Ro`00m_on003jPOn7o`00g_l00?Koo_Z1ohKo0021
onko003fo`2JoP21okkobI[Ro`00m_on002JPOn7o`00g_l00?KooYZ1ohKo002k
o`2i]?l1003go`00POnkon@0m_oa0?3ooP3nooh0o?l00??o0021ohOo003No`40
0?OooP21ohOo0@00POo^o`400?Oo0?[n087o__oTn_KolO[`ooh0o_on0?co003f
ooh00?Z1ohOo003No`400?Ooo_Z1ohOo0@00POo^o`400?Oo09[n087o__oTV_Ko
lI[`ooh0o_on0?co003fooh009Z1ohOo003No`400?OooYZ1ohOo0@00^ol0][Co
003fo`00POn6ooh0lOl00?ko0P3o0?ko003mo`00lol0087oQol00=ko003fooh0
POn6o`00POo^o`00m_l0n_h0POn9ookjlOl00?ko0P3o0?ko003mo`00m_on003j
POn7o`00g_l00?Koo_Z1ohKo0021onko003fo`2JoP21ohWooY[ao`00o_l20?l0
o_l00?go003fooh009Z1ohOo003No`00m_onVX7oQ_l00;_o0:Jdo`00m_l0087o
Q_on0?7o003no`80o`3no`00o_od0?koP@240=oo003fooh0POn6o`00POo^o`00
m_l0n_h0POn9ookjlOl00?ko0P3o0?ko003noo400?Z108D0gol00?Koo_Z1ohKo
0021onko003fo`2JoP21ohWooY[ao`00o_l20?l0o_l00?7ooP00VX7oPOoSo`00
m_onVX7oQ_l00;_o09Bdo`00m_l0087oQ_on0>ko003nooh0oOod0?koP@240=oo
003fooh0POn6o`00POo^o`00m_l0n_h0POn9ookjk_l00?kooP3moo400?Z108D0
gol00?Koo_Z1ohKo0021onko003fo`2JoP21ohWooY[^o`00o_on0?3ooP00VX7o
POoSo`00m_onVX7oQ_l00;_o0:bdo`400?Oo0021ohKo0@00k_l00?ko003no`00
o_od0?koP@240=oo0@00moon087oQol10021onko0@00mol0n_h0POn9o`400>ko
003no`00o_l00?kol@00nX40Q@3Oo`400?Ooo_Z1ohOo0@00POo^o`400?Oo09[n
087oROl1003^o`00o_l00?ko003aooh009Z1oh7ohol1003goojJPOn7o`400;_o
0=O1o`00o_ol0?go003fo`00POn5o`00kol50?oo0?l0o_l00?go003co`00POn7
o`00i?l00?co003fooh0POn6o`00POoko`00o_ol0?go003fo`3joP21ohSo003_
o`D0ool0o`3no`00oOl00?KooP00nX7oQol00>Co003lo`00m_onnX7oQ_l0087o
nol00?koo03mo`00m_l0V_h0POn8o`00kol50?oo0?l0o_l00?go003fooh009Z1
ohOo003To`00o?l00?KooYZ1ohKo002ko`3A`_l1003no`00nOl00?Ko0021ohGo
003`oo`00OoooP3lo`00lol0087oQol00>Go0@00o?l00?KooP21ohKo0021ooco
0@00o_l00?Wo003fo`3joP21ohSo003`oo`00OoooP3lo`00m_on003jPOn7o`00
iOl1003lo`00m_onnX7oQ_l0087oo?l1003no`00nOl00?Ko09[n087oR?l00?3o
o001ooon0?co003fooh009Z1ohOo003Uo`400?co003foojJPOn6o`00^ol0]/7o
003nood0o?l00?Ko0021ohGo003Qo`00lol0087oQol00>Ko0P3o0?co003fooh0
POn6o`00POoko`00o_om0?co003fo`3joP21ohSo003Qo`00m_on003jPOn7o`00
i_l20?l0o?l00?Koo_Z1ohKo0021oo_o003nood0o?l00?Ko09[n087oR?l00>7o
003fooh009Z1ohOo003Vo`80o`3lo`00m_onVX7oQ_l00;_o0<G1o`00n_l00?go
oP3ho`00POn6o`400>7o0@00m?l0087oR?l1003Wo`<0ool0o?l1003gooh0POn8
ooh0POoko`00n_l00?gooP3ho`3joP21ohWo0@00hOl1003gooh00?Z1ohSo0@00
iol30?oo0?co0@00moonnX7oR?on087onol00?[o003mooh0n?l0V_h0POn9o`40
0>7o0@00moon002JPOn8o`400>Oo0`3oo`3lo`400?OooYZ1ohSooP2ko`2Z`Ol0
0?[o003mo`00POn1ooWo003Qo`00lol0087oQol00>Ooo03mo`00m_on087oQ_l0
087onol00?[o003mo`00m_om087oR?l00>7o003fooh00?Z1ohOo003Woo`0oOl0
0?Koo_Z1ohKo0021oo_o003jo`00oOl00?Koo@21ohSo003Qo`00m_on002JPOn7
o`00iool0?go003foojJPOn6o`00^ol0`/7o003no`00o_l00?go0021oh7onOl0
0>7o003co`00POn`on@0mOl00>Co003lo`00m_on087oQ_l0087onol00?ko003n
o`00oOl00?Koo@21ohSo003Qo`00m_on003jPOn`onCjmOl00>Co003lo`00m_on
nX7oQ_l0087onol00?ko003no`00oOl00?Koo@21ohSo003Qo`00m_on002JPOn`
onBJmOl00>Co003lo`00m_onVX7oQ_l00;_o0;c2ooh0o_on0?co003co`00POn8
o`00hOl00??o0021ok3oh`3fo`00iOon0?go003fooh0POn6o`00POolooh0o_on
0?co003fooh00?Z1ohSo003Qo`00m_on003jPOn`on?jm_l00>GooP3mo`00m_on
nX7oQ_l0087oo?on0?kooP3lo`00m_on002JPOn8o`00hOl00?KooP00VX7o/?oS
V_Ko003Uooh0oOl00?KooYZ1ohKo002ko`2B]?l00??o0021ohSo003Qo`00lol0
08gol@2domH0gol00?KooP21ohKo0021onko003fooh00?Z1ohSo003Qo`00m_on
003jSOoan[Coe_[Oo`00m_onnX7oQ_l0087ok_l00?KooP00VX7oR?l00>7o003f
ooh009Z=oo6J]?oFV]oo003foojJPOn6o`00^ol0Y[Co0@00m?l0087oROl1003R
oo@0o_l008gol@2dooh0jOoa0=oo0@00moon087oQol10021onko0@00moon003j
POn9o`400>;om?[n003jSOoan[Coo_[Yoo7jgol1003gookjPOn7o`40087ok_l1
003gooh009Z1ohWo0@00h_odV_h009Z=oo6J]?onV^WolI[Oo`400?OooYZ1ohOo
0@00^ol0S;Co003co`00POn8o`00h_od0?ko002=on@0`Oon0>Wol@21oh7oeOl0
087ok_l00?KooP00nX7oR?l00>;om?[n003jSOoTn/7oo_[Yoo7jh?oa087oQ_l0
087ok_l00?KooP00VX7oR?l00>;om9[n002JSOoTV/7ooY[Yoo6Jh?oa087oQ_l0
0;_o09Rdo`00lol0087oR?l00>;om03no`00SOon0?Ooh`3Loo40g?on087oPOoE
o`00POo^o`00m_on003jPOn8o`00h_odn_h00?Z=ookjmooSn]colO[Lookjh?oa
087oQ_l0087ok_l00?KooP00VX7oR?l00>;om9[n002JSOonV_Oohi[Loo6Jg?on
V^3ol@21ohKo002ko`2L]?l00??o0021ohSo003Qo`00lol008gooP3gon<0mooF
0=cooP21oh7oeOl0087ok_l00?KooP00nX7oR?l00>7o003fooh00?Z=ookjmooS
n_Ooe_[Lookjh?oa087oQ_l0087ok_l00?KooP00VX7oR?l00>7o003fooh009Z=
oojJmooSV_OoeY[LoojJh?oa087oQ_l00;_o0::do`400?Co0021ohWo0@00hOl0
087oo_on0>Wo_03Ko`00g_l10021oh7on_l10021onko0@00moon003jPOn9o`40
0>7o003food0SOonn^Wo_?[Ko`00g_l1003gooh0POn7o`40087ok_l1003gooh0
09Z1ohWo0@00hOl00?Koo@2=oojJjOnlV]_o003No`400?OooP21ohOo0@00^ol0
U;Co003co`00POn8o`00hOl00:KoeP3LomH0c_l00=ko0021oh7on?l0087ok_l0
0?KooP00nX7oR?l00>7o003food0]OoFn]coe_[>o`00g_l00?KooP21ohKo0021
onko003fooh009Z1ohSo003Qo`00m_om0;GoeY[LomJJc_l00=ko003fooh0POn6
o`00^ol0X[Co003co`00POn8o`00hOl1003go`00/_oF0=col@2do`400=ko0021
oh7on?l0087ok_l00?KooP00nX7oR?l00>7o0@00mol0n_h0]OoFn]colOZdo`40
0=ko003fooh0POn6o`00POo^o`00m_on002JPOn8o`00hOl1003go`2JoP2eomJJ
g?oaV[Co0@00g_l00?KooP21ohKo002ko`2J]?l00??o0021ohSo003Qo`00m_l0
0;;oeP21ooko003No`00POn1ooSo0021onko003fooh00?Z1ohSo003Qo`00m_l0
n_h0]OoFnY[ol@3eo`00g_l00?KooP21ohKo0021onko003fooh009Z1ohSo003Q
o`00m_l0V_h0]OoFVY[ol@3eo`00g_l00?KooP21ohKo002ko`2/]?l1003do`00
POn9o`400>7o003fo`00/_on087oe_l00=ko0@00POn1oo[o0@00POo^o`400?Oo
oP00nX7oROl1003Qo`00m_l0n_h0]OonnX7o0Oooh`3fo`00g_l1003gooh0POn7
o`40087ok_l1003gooh009Z1ohWo0@00hOl00?Ko09[n0;GooYZ1o`7oon<0m_l0
0=ko0@00moon087oQol1002ko`2g]?l00??o0021ohSo003_ooh0oOl1003lo`00
m_l00?kom032ooh0POnbo`00POn1ooSo0021onko003fooh00?Z1ohSo003_ooh0
oOl1003lo`00m_l0n_h0m?[2ookjPOl1oooF0=oo003fooh0POn6o`00POo^o`00
m_on002JPOn8o`00koon0?go0@00o?l00?Ko09[n0?BJ`_onVX7o0OooeP3Oo`00
m_on087oQ_l00;_o0=6do`00lol0087oR?l00?3o003no`<0ool0n_l00?Ko003n
oo@0j_oa0>WooP21ok;o0021oh7on?l0087ok_l00?KooP00nX7oR?l00?3o003n
o`<0ool0n_l00?Ko0?[n0?Cjj_oan^Woo_Z1o`7ooo40m_oa0=oo003fooh0POn6
o`00POo^o`00m_on002JPOn8o`00l?l00?ko0`3oo`3jo`00m_l0V_h0m9[Zoo6J
jOonVX7o0Oool@3foo40gol00?KooP21ohKo002ko`2n]Ood0?ko0021ohSo003`
o`00o_l20?l0nOl00?Ko003nonL0mooF087o/_l0087oPOoho`00POo_ooCjoP00
nX7oR?l00?3o003no`80o`3io`00m_l0n_h0io[gomKjPOl1ooon0>Wol@3Oo`00
m_on087oQ_l0087okoodV_h009Z1ohSo003`o`00o_l20?l0nOl00?Ko09[n0>NJ
mooFVX7o0OoooP3Yoo40gol00?KooP21ohKo002ko`37]Ood0?ko0021ohWo0@00
kOl20?ooo@3looh0n?l00?Col@3gomH0POnbo`40087oPOojo`40087okoodn_h0
0?Z1ohWo0@00kOl20?ooo@3looh0n?l0n_h0mooan_Ooe_[Loo40`Ooa0=cooP3O
o`400?OooP21ohOo0@00POo_ooBJoP00VX7oROl1003]o`80ooom0?cooP3ho`2J
oP3goo6JmooFV]col@31oo40g?on0=oo0@00moon087oQol1002ko`42cOl00?go
oP3ioo`0o_od0?ko0021ohSo003^o`00o_l00?ko003mo`00m_l00?Col@3gooh0
m_oT087o^_on0?co0021oh7on?l008Oo003mooh0nOol0?kom?[n003jPOn8o`00
k_l00?ko003no`00oOl00?Ko0?[n0?OolO[gookjm_oTn]coi03>oo40g?on0>Oo
oP3lo`00m_on087oQ_l008Oo003mooh0nOol0?kom9[n002JPOn8o`00k_l00?ko
003no`00oOl00?Ko09[n0?OolI[goojJm_oTV]coi03>oo40g?on0>OooP3lo`00
m_on087oQ_l00;_o0AK>o`400?ko003no`00n_l00?Wo0021oh7onOl00>oo1@3o
o`3o0?ko003mo`00m_l00>OooP3gooh0POn^o`00iol00?ko003mo`00POn1ooSo
0028o`400?ko003no`00n_l00?Wo003fooh0POn7o`00kol50?oo0?l0o_l00?go
003fo`3joP3Zookjmoonn[CoeP3gomH0fol00>Oo003no`00oOl00?KooP21ohKo
0028o`400?ko003no`00n_l00?Wo003fooh0POn7o`00kol50?oo0?l0o_l00?go
003fo`2JoP3ZoojJmoonV[CoeP3gomH0fol00>Oo003no`00oOl00?KooP21ohKo
002ko`3kcOl00?ko003no`00n_om0?co0021oh7onOl00?3oo001ooon0?co003f
o`00ioon0?OooP21ojko003So`00oOl0087oPOoho`00Qol00?ko003no`00n_om
0?co003fooh0POn7o`00l?ol007oooh0o?l00?Ko0?[n0>[oo_[gookj]?on0?Oo
^`3>o`00hol00?go003fooh0POn6o`00Qol00?ko003no`00n_om0?co003fooh0
POn7o`00l?ol007oooh0o?l00?Ko09[n0>[ooY[goojJ]?on0?Oo^`3>o`00hol0
0?go003fooh0POn6o`00^ol0dLgo003ko`00mOl00?gooP21oh7oo?l1003Qo`00
m_l00>Ool@21ojko003Uo`400?co0@00POn1oo_ooP27o`00nol00?Go003mooh0
n?on087oR?l1003Qo`00m_l0n_h0j_oan[CooP3YolT0c_l00>Go0@00o?l1003g
ooh0POn8ooh0Qol00?_o003eo`00oOon0?SooP21ohSo0@00hOl00?Ko09[n0>[o
lIZdooh0jOo90<ko003Uo`400?co0@00moon087oR?on0;_o0=[=o`00o?l00?Co
003mo`00POn1ooWo003Qo`400?Oo003Woo40POo:oo40m_l1003So`00oOl0087o
POoho`00Qol00?co003do`00oOl00?KooP21ohOo003Qo`400?Oo0?[n0>[olOZd
ooh0g?oa0<oolO[fo`400>?o003mo`00m_on087oQ_l008Oo003lo`00m?l00?go
003fooh0POn7o`00hOl1003go`2JoP3Zoo6J]?on0=col@3?oo6Jm_l1003So`00
oOl00?KooP21ohKo002ko`3]cOl00?go0`3oo`3jo`00o_l00?go0021oh7onOl0
0>7o003fo`00iooa087oeooS0?Ko003Wo`00o_l00?go0021oh7on?l008Oo003m
o`<0ool0n_l00?ko003mo`00m_on087oQol00>7o003fo`3joP3Zoo7j`Ooa0:Oo
ho[fo`00iol00?ko003mo`00m_on087oQ_l008Oo003mo`<0ool0n_l00?ko003m
o`00m_on087oQol00>7o003fo`2JoP3Zoo6J`Ooa0:Oohi[fo`00iol00?ko003m
o`00m_on087oQ_l00;_o0<?>ooh00Oooo03no`00oOon0?co0021oh7onOl00>7o
003fo`00POn]omH0ioon0?co0021oh7on?l008SooP01oool0?ko003mooh0o?l0
0?KooP21ohOo003Qo`00m_l0n_h0]OoF0:Ooe_[Wooh0o?l00?KooP21ohKo0028
ooh00Oooo03no`00oOon0?co003fooh0POn7o`00hOl00?Ko09[n0;GoeP2WomJJ
ioon0?co003fooh0POn6o`00^ol0X;Co0@00POn1oo_o0@00hOl00?Ko0021ojgo
l@3foo40gol10021oh7on_l10021onko0@00moon087oR?l1003Qo`00m_l0n_h0
]OoF0:OolO[foo7jgol1003gooh0POn7o`40087ok_l1003gooh0POn8o`400>7o
003fo`2JoP2eomH0YooaV_KolI[Oo`400?OooP21ohOo0@00^ol0U;Co0021oh7o
nOl00>7o003fo`00POn]ooh0jOoa0=oo0021oh7on?l0087ok_l00?KooP21ohOo
003Qo`00m_l0n_h0]OoS09[oo_[Yoo7jgol00?KooP21ohKo0021onko003fooh0
POn7o`00hOl00?Ko09[n0;Goh`2JoojJjOoaV]oo003fooh0POn6o`00^ol0S;Co
0021oh7onOl00>7o003fo`00POn]ooh0g?on0>3om03noh40Q@21onko003fooh0
POn7o`00hOl00?Ko0?[n0;GooP21o`7oookjg?onn^3oP@210?D0POo^o`00m_on
087oQol00>7o003fo`2JoP2eooh0POl1ooonV]cooY[Cooh0POn1okoo08bdo`00
POn1ooWo003Qo`400?Oo0021ok[ol@3Lo`400=oom03noh40Q@21onko003fooh0
POn7o`00hOl1003go`3joP2eooh0S?oan]co0@00gon10840m@21onko003fooh0
POn7o`00hOl1003go`2JoP2eooh0S?oaV]co0@00d_on087oPOnoo`2<]?l10021
oh7onol1003Qo`00m_l0087o^_oa0=_o003Ooo@0o_n108D0POo^o`400?OooP21
ohSo0@00hOl00?Ko0?[n0;GooP2<oo7jfol00=ooP@210?D0POo^o`400?OooP21
ohSo0@00hOl00?Ko09[n0;GooP2<oo6Jfol00=;ooP21oh7o_ol0W[Co0021oh7o
nOl00>7o003fo`00R_oa0=coeP3Ko`00g_l0087oPOoho`00POo^o`00m_on087o
Qol00>7o003fo`3joP2eooh0g?oan]coe_[Ko`00g_l00?KooP21ohKo0021onko
003fooh0POn7o`00hOl00?Ko09[n0;GooP3Loo6Jg?oFV]_o003No`00m_on087o
Q_l00;_o09jdo`00POn1ooWo003Qo`00m_l008[oi03Yon<0c_l00=ko0021oh7o
n?l0087ok_l00?KooP21ohOo003Qo`00m_l0n_h0`_oa0=coi?[Yon?jc_l00=ko
003fooh0POn6o`00POo^o`00m_on087oQol00>7o003fo`2JoP32oo40g?oTV^Wo
hi[>o`00g_l00?KooP21ohKo002ko`26POn1oj_o003Qo`00m_l008[o[P3>o`00
g_l0087oPOoho`00POo_oo40POn7o`00hOl00?Ko0?[n0<;ol@3Lojkjc_l00=ko
003fooh0POn6o`00POo_oo40POn7o`00hOl00?Ko09[n0<;ol@3LojjJc_l00=ko
003fooh0POn6o`00^ol0W87oPOn/o`400>7o0@00POl1ooon0?OoeP2do`400=ko
0@00POn1oo[o0@00POo_oo40POn8o`400>7o0@00m_on0=goeP3LookjmooFn[Co
0@00g_l1003gooh0POn7o`40087okooa087oR?l1003Qo`400?KooP3MomH0g?on
V_OoeYZdo`400=ko0@00moon087oQol1002ko`2<POn1oj_o003Qo`00POonooh0
jOoT0;?o003No`00POn1ooSo0021onool@21ohOo003Qo`00mOon0=goh`3?ookj
jOoTn[?o003No`00m_on087oQ_l0087okooa087oQol00>7o003eooh0gOoS0<oo
oY[YonBJ/ol00=ko003fooh0POn6o`00^ol0U;Co003fooh0POn7o`00hOl0087o
o_on087oo_l00=ko0021oh7on?l0087ok_l00?Koo_Z1ohOo003Qo`00mOoa0>[o
h`3?ookjPOono`00g_l00?KooP21ohKo0021onko003foojJPOn7o`00hOl00?Go
l@3Zon<0coonVX7oo_l00=ko003fooh0POn6o`00^ol0[;Co003fooh0POn7o`00
koon0?co003lo`00POonooh0POono`00g_l0087oPOoho`00POo^o`00m_onnX7o
Qol00>oooP3lo`00o?l00?Gol@3Zooh0]?onnX7oo_l00=ko003fooh0POn6o`00
POo^o`00m_onVX7oQol00>oooP3lo`00o?l00?Gol@3Zooh0]?onVX7oo_l00=ko
003fooh0POn6o`00^ol0aKCo0@00moon087oR?l1003`o`00o_l00?ko0@00o?l0
08_ol@21ooko003No`40087oPOojo`40087ok_l1003gookjPOn8o`400?3o003n
o`00o_l1003lo`00mOoT0?OooP31oo7jPOono`00g_l1003gooh0POn7o`40087o
k_l1003goojJPOn8o`400?3o003no`00o_l1003lo`00mOoT0?OooP31oo6JPOon
o`00g_l1003gooh0POn7o`400;_o0>31o`00o?l1003lo`00m_on087oQol00?3o
003no`D0ool0o`3lo`00mOon0:Ooi021ooko003No`00POn1ooSo0021oo_o003l
o`400?co003fookjPOn7o`00l?l00?ko1@3oo`3o0?co003eookjmooa0?OooP3>
onCjPOono`00g_l00?KooP21ohKo0021oo_o003lo`400?co003foojJPOn7o`00
l?l00?ko1@3oo`3o0?co003eoojJmooa0?OooP3>onBJPOono`00g_l00?KooP21
ohKo002ko`3_`_l1003mo`<0ool0oOl00?KooP21ohOo003]o`H0ool0ool0o?on
0?OooP2eomH0POl3ool00>KooP3lo`00POn1ooSo0021ooco0@00oOl30?oo0?go
003fookjPOn7o`00kOl60?oo0?oo0?cooP3gookjmooa0?OooP3LomKjPOl3ool0
0>KooP3lo`00m_on087oQ_l0087oo?l1003mo`<0ool0oOl00?KooYZ1ohOo003]
o`H0ool0ool0o?on0?OooY[goo40moon0=coeYZ1o`?oo`00i_on0?co003fooh0
POn6o`00^ol0el7o003mo`<0ool0o_n10840m@3_o`00o_ol0?go003eooh0]OoS
087olOl00>Oo003no`00oOl0087oPOoho`00POoko`00oOl30?oo0?kom03nnX40
Q@3_o`00o_ol0?go003eookjj_oa0=cohoZ1oo7o003Wo`00o_l00?go003fooh0
POn6o`00POoko`00oOl30?oo0?7ooYZ1oh7olol00?koo03mo`00mOonV^[ol@3L
on>JPOoao`00iol00?ko003mo`00m_on087oQ_l00;_o0>31o`00oOl30?oo0?ko
P@210?D0l?l30?oo0?go003lo`00mOon0;Gol@21on?o003Wo`00o_l00?go0021
oh7on?l0087onol00?go0`3oo`3noo@0o_Z108D0l?l30?oo0?go003lo`00mOon
n^[ol@3Loo7jPOoSo`00iol00?ko003mo`00m_on087oQ_l0087onol00?go0`3o
o`3aoojJPOn1ooCo0`3oo`3mo`00o?l00?GooY[Zoo40g?oaVX7ohol00>Oo003n
o`00oOl00?KooP21ohKo002ko`3>`Ol00?go0`3oo`3noh40P@3e0?7oo03nooh0
oOl00?GooP2eooh0POoFo`00i?l00?co0@00POn1oo_ooP21oo_o003mo`<0ool0
o_od0?kjP@250?7oo03nooh0oOl00?Goo_[Zoo40g?onnX7oe_l00>Co003lo`40
0?OooP21ohSooP21oo_o003mo`<0ool0lOonVX7oPOoeoo`0o_on0?go003eoojJ
j_oa0=cooYZ1omKo003To`00o?l1003gooh0POn8ooh0^ol0^L7o003mo`<0ool0
oOl00?KooP21ohOo003Qo`00mOon0;GooP21omKo003Uo`00nol0087oQooa087o
nol00?go0`3oo`3mo`00m_onnX7oQol00>7o003eookj]OonnX7oe_l00>Go003k
o`00m_on087oUOoanX7onol00?go0`3oo`3mo`00m_onVX7oQol00>7o003eoojJ
]OonVX7oe_l00>Go003ko`00m_on087oUOoaV[_o0<;2ooh0oOl1003lo`00m_on
087oQol00>7o0@00m_on0;GooP21omOo0@00i_l30?oo0?go0021oiCoi021ooco
oP3mo`400?co003fookjPOn7o`00hOl1003fookj]OonnX7oeol1003Vo`<0ool0
oOl00?KooP21oj;oi?Z1oocooP3mo`400?co003foojJPOn7o`00hOl1003foojJ
]OonVX7oeol1003Vo`<0ool0oOl00?KooP21oj;oi9Zko`2J]?l00?KooP21ohOo
003Qo`00mOon0;GooP21omKo003Woo`0oOl0087olOn7087ok_l00?Koo_Z1ohOo
003Qo`00mOonn[Goo_Z1omKo003Woo`0oOl00?KooP21o`7oohOjPOo^o`00m_on
VX7oQol00>7o003eoojJ]OonVX7oe_l00>Ooo03mo`00m_on087o0OooQiZko`2I
]?l1003gooh0POn8o`400>7o003eooh0]Oon087oe_l00=ko0@00V_n10?`0POoA
o`400?Ooo_Z1ohSo0@00hOl00?Goo_ZeookjPOoFo`00g_l1003gooh0Yon1n_cj
i021onko0@00moonVX7oR?l1003Qo`00mOonV[GooYZ1omKo003No`400?OooP2W
oh6Jo9[T0;_o08Jdo`00m_on087oQol00>7o003eooh0`_oa087oe_l00=oom02T
ohT0POo4o`00m_onnX7oQol00>7o003eookj`_oanX7oe_l00=oom?[n0:OoRO[G
087ok_l00?KooYZ1ohOo003Qo`00mOonV/;olIZ1omKo003OooBJoP2WohVJe`2k
o`1l]Ooa087oQol00>7o003eooh0`_oa087oe_l00=oom02aol`0POn1ooGolOZ1
ohOo003Qo`00mOonn/;olOZ1omKo003OooCjoP2dolcjQ`21onoolIZ1ohOo003Q
o`00mOonV/;olIZ1omKo003OooBJoP2dolbJQ`2ko`28]Ooa087oQol00>7o003e
ooh0`_oa087oe_l00=oom03Iol`0POoionL0POo_oo7jPOn7o`00hOl00?Goo_[2
oo7jPOoFo`00goodn_h0g?o<nX40n@3WnX7okooaVX7oQol00>7o003eoojJ`_oa
VX7oe_l00=oom9[n0=coc9Z10?T0iiZko`2B]Ooa087oR?l1003Qo`400?KooP3?
oo40POo:o`400=ko0@00coo<08Oof@21onoolOZ1ohSo0@00hOl1003fookjcooa
nX7ob_l1003No`400?OooP3LolcjQ`3InX7okooaVX7oR?l1003Qo`400?KooY[?
oo6JPOo:o`400=ko0@00moon0=coc9Z70=VJ^ol0V;Co0021oh7onOl00>7o003e
ooh0d?o`087obOl00=ko003Kol`0bOnG0?Go0021onko0021oh7onOl00>7o003e
ookjd?o`nX7obOl00=ko003fooh0jOo<n/T0Uo[eo`00POo^o`00POn1ooWo003Q
o`00mOonV]3ol9Z1olWo003No`00m_on0>Woc9[909NJmOl00;_o0::do`00POn1
ooWo003Qo`00mOon0=goh`21olWo003No`00jOoS0<coP@3l0>So0021onko0021
oh7onOl00>7o003eookjgOoSnX7obOl00=ko003fooh0mooSn_OoeP21n_cjj?l0
087ok_l0087oPOoio`00hOl00?GooY[Mon>JPOo9o`00g_l00?KooP3gon>JmooF
086Jo9[Xo`00^ol0V;Co0021oh7onOl00>7o003eooh0gOoa087o^ol00=ko003Y
onH0bOna0;?o0021onko0021oh7onOl00>7o003eookjgOoanX7o^ol00=ko003f
ooh0mooVn/T0/OZco`00POo^o`00POn1ooWo003Qo`00mOonV]golIZ1ok_o003N
o`00m_on0?OoiY[90;6J/ol00;_o0:Rdo`40087oPOoko`400>7o003eooh0gOoa
087o^ol00=ko0@00j_oa0<_oc02<o`40087ok_l10021oh7onol1003Qo`00mOon
n]golOZ1ok_o003No`400?OooP3goo7jm_oF0<cjS?l10021onko0@00POn1oo_o
0@00hOl00?GooY[Moo6JPOnko`00g_l1003gooh0mooaV_KoeP3<VXco0@00^ol0
Z;Co0021oh7onOl00>7o0@00m_on0=gooP21ojoo0@00g_l00>WooP3IomT0POoS
o`00POo^o`00POn1ooWo003Qo`400?Koo_[MookjPOn_o`400=ko003fooh0moon
n_Koi03InX7ohol0087ok_l0087oPOoio`00hOl1003foojJgOonVX7o[ol1003N
o`00m_on0?OooY[fon@0fIZ1on?o002ko`2F]?l0087oPOoio`00hOl00?GooP3M
ooh0POn^o`00g_l00<_oc021on?o0021onko0021oh7onOl00>7o003eookjgOon
nX7o[_l00=ko003fooh0mooS0<cjPOoSo`00POo^o`00POn1ooWo003Qo`00mOon
V]gooYZ1ojko003No`00m_on0?Ooh`3<VX7ohol00;_o09Jdo`00POn1ooWo003Q
o`00mOoT0?OooP21ojko003No`00booI087oe_l0087ok_l0087oPOoio`00hOl0
0?Goi?[gookjPOn^o`00g_l00?KooP3gon<0fOZ1omKo0021onko0021oh7onOl0
0>7o003eonBJmoonVX7o[_l00=ko003fooh0mooS0=VJPOoFo`00^ol0/[Co0@00
POn1oo_o0@00koon0?kooP3lo`00mOoG087o[_l00=ko0@00cooa087o_?l10021
onko0@00POn1oo_o0@00koon0?kooP3lo`00mOoGnX7o[_l00=ko0@00moon0?Oo
l@3foo7jPOnlo`40087ok_l10021oh7onol1003_ooh0o_on0?co003eomNJPOn^
o`00g_l1003gooh0mooa0?KolIZ1okco0@00^ol0f<Woo03joo`0oOl0087oPOoi
o`00l?l00?ko0P3o0?ko003mo`00mOoG087o[_l00>Go003ko`00fooa087o[_l0
08?oo03joo`0oOl0087oPOoio`00l?l00?ko0P3o0?ko003mo`00mOoGnX7o[_l0
0>Go003ko`00m_on0?OooP3foo7jPOn^o`00Pool0?[oo03mo`00POn1ooWo003`
o`00o_l20?l0o_l00?go003eomNJPOn^o`00iOl00?_o003fooh0moon0?KolIZ1
ojko002ko`3SbOl00?ko003jo`00nOl0087oPOoio`00l?l00?ko0P3o0?ko003m
o`00fooa087o[_l00>Ko0@00nol00>KoiP21ojko0023o`00o_l00?[o003io`00
POn1ooWo003`o`00o_l20?l0o_l00?go003Koo7jPOn^o`00i_l1003ko`00m_on
0?OooP3VnX7o[_l008?o003no`00n_l00?Wo0021oh7onOl00?3o003no`80o`3n
o`00oOl00=_olIZ1ojko003Vo`400?_o003fooh0moon0>JJPOn^o`00^ol0`lGo
003jood0o?l0087oPOoio`00kOl00?co003looh0POn1oo_o0@00iOl00?_o003V
onH0POn^o`00POl2ool0n_om0?co0021oh7onOl00>go003lo`00o?on087oPOok
o`400>Go003ko`00m_on0?OooP3VnX7o[_l0087o0_oo0?[oo@3lo`00POn1ooWo
003]o`00o?l00?cooP21oh7onol1003Uo`00nol00?KooP3gooh0iYZ1ojko002k
o`34a_l00?Go003mooh0POn1ooco0@00k_l00?co003ko`00POn1ooSo003Uo`00
nol1003Woo@0POnRooh0POl1o`3eo`00oOon087oPOolo`400>ko003lo`00nol0
087oPOoho`00iOl00?_o0@00moon0?OooP3dnX7oX_on087o0Ol0mOl00?gooP21
oh7oo?l1003^o`00o?l00?_o0021oh7on?l00>Go003ko`400?OooP3gooh0m9Z1
oj;ooP2ko`37a_l00?Go003mo`00POn1ooWo003_o`T0ool0ool0ool0oOl0087o
POoho`00iOl00?_o0021oh7on?l0087o0Ol0mOl00?go0021oh7onOl00>oo2@3o
o`3oo`3oo`3mo`00POn1ooSo003Uo`00nol00?KooP3gooh0POnCo`00POl1o`3e
o`00oOl0087oPOoio`00kol90?oo0?oo0?oo0?go0021oh7on?l00>Go003ko`00
m_on0?OooP21oi?o002ko`32aol00?So003no`00oOl0087oPOoio`00l?ol003o
o03mo`00POn1ooSo003Uo`00nol0087oPOoho`00POl00?So003no`00oOl0087o
POoio`00l?ol003oo03mo`00POn1ooSo003Uo`00nol00?KooP3gooh0POnCo`00
POl00?So003no`00oOl0087oPOoio`00l?ol003oo03mo`00POn1ooSo003Uo`00
nol00?KooP3gooh0POnCo`00^ol0Z/Oo003lo`00oOon0?co0021oh7onOl00>7o
0021oh7on?l00>KooP3lo`00POn1ooSo0021o`00o?l00?gooP3lo`00POn1ooWo
003Qo`00POn1ooSo003Vooh0o?l00?KooP3gooh0POnCo`00POl00?co003mooh0
o?l0087oPOoio`00hOl0087oPOoho`00i_on0?co003fooh0moon087oTol00;_o
09:do`40087oPOoko`400>7o0@00POn1oo[o0@00g_l1003dooL0POnAo`40087o
k_l10021oh7onol1003Qo`40087oPOojo`400=ko0@00moon0?OjoP21oiCo0@00
POo^o`40087oPOoko`400>7o0@00POn1oo[o0@00g_l1003gooh0mi[n087oU?l1
002ko`20]?l0087oPOoio`00hOl0087oPOoho`00g_l00??om`21oi3o0021onko
0021oh7onOl00>7o0021oh7on?l00=ko003fooh0mo[n087oTol0087ok_l0087o
POoio`00hOl0087oPOoho`00g_l00?KooP3gV_h0POnCo`00^ol0P;Co0021oh7o
nOl00>7o0021oh7on?l00=ko003cooL0POn@o`00POo^o`00POn1ooWo003Qo`00
POn1ooSo003No`00m_on0?OjoP21oi?o0021onko0021oh7onOl00>7o0021oh7o
n?l00=ko003fooh0mi[n087oTol00;_o07jdo`00POn1ooWo003Qo`00POn1ooSo
003No`00POn1ooSo0021onko0021oh7onOl00>7o0021oh7on?l00=ko003fooh0
moon087oTol0087ok_l0087oPOoio`00hOl0087oPOoho`00g_l00?KooP3gooh0
POnCo`00^ol0R[Co0@00POn1oo_o0@00hOl0087oPOoho`00g_l10021oh7on_l1
0021onko0@00POn1oo_o0@00hOl0087oPOoho`00g_l1003gooh0moon087oU?l1
0021onko0@00POn1oo_o0@00hOl0087oPOoho`00g_l1003gooh0moon087oU?l1
002ko`1n]?l0087oPOoio`00hOl0087oPOoho`00g_l0087oPOoho`00POo^o`00
POn1ooWo003Qo`00POn1ooSo003No`00m_on0?OooP21oi?o0021onko0021oh7o
nOl00>7o0021oh7on?l00=ko003fooh0moon087oTol00;_o08Bdo`00POn1ooWo
003Qo`40087oPOojo`400=ko0021oh7on?l0087ok_l0087oPOoio`00hOl10021
oh7on_l1003No`00m_on0?OooP21oi?o0021onko0021oh7onOl00>7o0@00POn1
oo[o0@00g_l00?KooP3gooh0POnCo`00^ol0O[Co0021oh7onOl00>7o0021oh7o
n?l00=ko0021oh7on?l0087ok_l0087oPOoio`00hOl0087oPOoho`00g_l00?Ko
oP3gooh0POnCo`00POo^o`00POn1ooWo003Qo`00POn1ooSo003No`00m_on0?Oo
oP21oi?o002ko`2:]?l10021oh7onol1003Qo`00POn1ooSo003No`40087oPOoj
o`40087ok_l10021oh7onol1003Qo`00POn1ooSo003No`400?OooP3gooh0POnD
o`40087ok_l10021oh7onol1003Qo`00POn1ooSo003No`400?OooP3gooh0POnD
o`400;_o07jdo`00POn1ooWo003Qo`00POn1ooSo003No`00POn1ooSo0021onko
0021oh7onOl00>7o0021oh7on?l00=ko003fooh0moon087oTol0087ok_l0087o
POoio`00hOl0087oPOoho`00g_l00?KooP3gooh0POnCo`00^ol0O[Co0021oh7o
nOl00>7o0021oh7on?l00=ko0021oh7on?l0087ok_l0087oPOoio`00hOl0087o
POoho`00g_l00?KooP3gooh0POnCo`00POo^o`00POn1ooWo003Qo`00POn1ooSo
003No`00m_on0?OooP21oi?o002ko`24]?l0087oPOoio`00hOl10021oh7on_l1
003No`00POn1ooSo0021onko0021oh7onOl00>7o0@00POn1oo[o0@00g_l00?Ko
oP3gooh0POnCo`00POo^o`00POn1ooWo003Qo`40087oPOojo`400=ko003fooh0
moon087oTol00;_o08Bdo`40087oPOoko`400>7o0021oh7on?l00=ko0021oh7o
n?l0087ok_l10021oh7onol1003Qo`00POn1ooSo003No`00m_on0?OooP21oi?o
0021onko0@00POn1oo_o0@00hOl0087oPOoho`00g_l00?KooP3gooh0POnCo`00
^ol0O;Co0021oh7onOl00>7o0021oh7on?l00=ko0@00POn1oo[o0@00POo^o`00
POn1ooWo003Qo`00POn1ooSo003No`400?Ool@21oiCo0@00POo^o`00POn1ooWo
003Qo`00POn1ooSo003No`400?Ool@21oiCo0@00^ol0M[Co0021oh7onOl00>7o
0021oh7on?l00=ko0021oh7on?l0087ok_l0087oPOoio`00hOl0087oPOoho`00
g_l00?Kol@21oi?o0021onko0021oh7onOl00>7o0021oh7on?l00=ko003foo40
POnCo`00^ol1WKCo003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go
003do`00mOl00?Go003eo`00m?l00?Go003eo`00mOl00?Co003eo`00mOl00>7o
003=o`00c?l00<go003=o`00cOl00=ko003=o`00cOl00<go003=o`00cOl10021
onko003do`00mOl00?Go003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl0
0?Go003eo`00m?l00?Go003eo`00mOl00?Co003eo`00mOl00>7o003=o`00c?l0
0<go003=o`00cOl00=ko003foo40j?l00<go003=o`00cOl00<go0@00POo^o`00
m?l00?Go003eo`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003eo`00
mOl00?Co003eo`00mOl00?Go003do`00mOl00?Go003Qo`00cOl00<co003=o`00
cOl00<go003No`00m_oa0>So003=o`00cOl00<go003=o`400;_o0QVdoh40P@3g
0>7o003do`00mOl00?Go003eo`00m?l00?Go003eo`00m?l00?Go003eo`00mOl0
0?Co003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl00=ko003fooh0moon
0?Go003eo`00mOl00?Co003eo`00mOl00?Go003do`00mOl00?Go003do`00mOl0
0?Go003eo`00m?l00?Go003eo`00mOl10021onkoP@210?L0hOl00?Co003eo`00
mOl00?Go003do`00mOl00?Go003do`00mOl00?Go003eo`00m?l00?Go003eo`00
m?l00?Go003eo`00mOl00?Co003eo`00g_l00?Koo_[gookjmOl00?Go003eo`00
m?l00?Go003eo`00mOl00?Co003eo`00mOl00?Co003eo`00mOl00?Go003do`00
mOl00?Go003eo`40087ok_n10840m`3Qo`00m?l00?Go003eo`00mOl00?Co003e
o`00mOl00?Co003eo`00mOl00?Go003do`00mOl00?Go003do`00mOl00?Go003e
o`00m?l00?Go003No`00m_onV_OooY[eo`00mOl00?Go003do`00mOl00?Go003e
o`00m?l00?Go003eo`00m?l00?Go003eo`00mOl00?Co003eo`00mOl00?Go0@00
^ol0CX7oPOn:oh40P@3f0=koP@210?H0POn1oh7oa?n10840mP3NooD0o_[g0?kj
P@2B087oPOn1olCoP@210?H0g_oe0?jJm`3nVX40TP2ko`14POn1oh7oPOn1om3o
oP3gooh0POn1oh7oPOn1oh7oPOnKookjmoonnX7oPOn1oh7oPOn1oh7oVoonV_Oo
oYZ1oh7oc?l0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oWol2/XOooP3mo`400?go0@00fOl00?go0@00oOl1003Jo`40
0?go0@00oOl1003Kooh0oOl1003mo`400=go003lo`400?go0@00oOl1002mooh0
oOl1003mo`400=So003mo`400?go0@00f_l1003mo`400?go0@00foon0?go0@00
oOl1003Mo`00o?l1003mo`400?go0@00^_on0?go0@00oOl1003Io`00oOl1003m
o`400=[o0@00oOl1003mo`400=_ooP3mo`400?go0@00gOl00?co0@00oOl1003m
o`40087obOon0?go0@00oOl1003Io`00oOl1003mo`400=[o0@00oOl1003mo`40
0=_ooP3mo`400?go0@00gOl00?co0@00oOl1003mo`400;gooP3mo`400?go0@00
f?l00?go0@00oOl1003Jo`400?go0@00oOl1003Kooh0oOl1003mo`400=go003l
o`400?go0@00oOl1002jooh0oOl1003mo`400=Wo003mo`400?go0@00f_l1003m
o`400?go0@00foon0?go0@00oOl1003Mo`00o?l1003mo`400?go0@00POo9ooh0
oOl1003mo`400=Wo003mo`400?go0@00f_l1003mo`400?go0@00foon0?go0@00
oOl1003Mo`00o?l1003mo`400?go0@00_Oon0?go0@00oOl1003Ho`00oOl1003m
o`400=[o0@00oOl1003mo`400=_ooP3mo`400?go0@00gOl00?co0@00oOl1003m
o`400;[ooP3mo`400?go0@00fOl00?go0@00oOl1003Jo`400?go0@00oOl1003K
ooh0oOl1003mo`400=go003lo`400?go0@00oOl10033o`>1R?l00?ko303oo`3o
o`3oo`3oo`3Ko`400?ko2@3oo`3oo`3oo`3Lo`00o?l90?oo0?oo0?oo0=go003n
o``0ool0ool0ool0ool0gol1003mo`l0ool0ool0ool0ool0ool0_ol00?ko303o
o`3oo`3oo`3oo`3Jo`400?ko2@3oo`3oo`3oo`3Lo`00o?l90?oo0?oo0?oo0=go
003no``0ool0ool0ool0ool0gol1003mo`l0ool0ool0ool0ool0ool0_?l00?ko
303oo`3oo`3oo`3oo`3Ko`400?ko2@3oo`3oo`3oo`3Lo`00o?l90?oo0?oo0?oo
0=go003no``0ool0ool0ool0ool0gol1003mo`l0ool0ool0ool0ool0ool0POo;
o`00o_l<0?oo0?oo0?oo0?oo0=_o0@00o_l90?oo0?oo0?oo0=co003lo`T0ool0
ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3Oo`400?go3`3oo`3oo`3oo`3oo`3o
o`2oo`00o_l<0?oo0?oo0?oo0?oo0=[o0@00o_l90?oo0?oo0?oo0=co003lo`T0
ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3Oo`400?go3`3oo`3oo`3oo`3o
o`3oo`2lo`00o_l<0?oo0?oo0?oo0?oo0=_o0@00o_l90?oo0?oo0?oo0=co003l
o`T0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3Oo`400?go3`3oo`3oo`3o
o`3oo`3oo`21ol_o003no``0ool0ool0ool0ool0fol1003no`T0ool0ool0ool0
g?l00?co2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=oo0@00oOl?0?oo
0?oo0?oo0?oo0?oo0;oo003no``0ool0ool0ool0ool0f_l1003no`T0ool0ool0
ool0g?l00?co2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=oo0@00oOl?
0?oo0?oo0?oo0?oo0?oo0;co003no``0ool0ool0ool0ool0fol1003no`T0ool0
ool0ool0g?l00?co2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=oo0@00
oOl?0?oo0?oo0?oo0?oo0?oo0<Co0h68o`00o_l<0?oo0?oo0?oo0?oo0=co0P3o
0?ko2@3oo`3oo`3oo`3Mo`00nol90?oo0?oo0?oo0=go003no``0ool0ool0ool0
ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`2oo`00o_l<0?oo0?oo0?oo0?oo0=_o
0P3o0?ko2@3oo`3oo`3oo`3Mo`00nol90?oo0?oo0?oo0=go003no``0ool0ool0
ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`2lo`00o_l<0?oo0?oo0?oo0?oo
0=co0P3o0?ko2@3oo`3oo`3oo`3Mo`00nol90?oo0?oo0?oo0=go003no``0ool0
ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`21ol_o003no``0ool0ool0
ool0ool0g?l20?l0o_l90?oo0?oo0?oo0=go003ko`T0ool0ool0ool0gOl00?ko
303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;oo003no``0ool0
ool0ool0ool0fol20?l0o_l90?oo0?oo0?oo0=go003ko`T0ool0ool0ool0gOl0
0?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;co003no``0
ool0ool0ool0ool0g?l20?l0o_l90?oo0?oo0?oo0=go003ko`T0ool0ool0ool0
gOl00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo087obol0
0?ko303oo`3oo`3oo`3oo`3Lo`80o`3no`T0ool0ool0ool0gOl00?_o2@3oo`3o
o`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0
_ol00?ko303oo`3oo`3oo`3oo`3Ko`80o`3no`T0ool0ool0ool0gOl00?_o2@3o
o`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0
ool0_?l00?ko303oo`3oo`3oo`3oo`3Lo`80o`3no`T0ool0ool0ool0gOl00?_o
2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0
ool0ool0a?l3E8Go003no`T0ool0ool0ool0gOl30?oo0?ko2@3oo`3oo`3oo`3M
ood0o_l90?oo0?oo0?oo0=cooP3no`T0ool0ool0ool0g_l00?go3`3oo`3oo`3o
o`3oo`3oo`2lo`00o_l90?oo0?oo0?oo0=co0`3oo`3no`T0ool0ool0ool0gOom
0?ko2@3oo`3oo`3oo`3Looh0o_l90?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0
ool0ool0^Ol00?ko2@3oo`3oo`3oo`3Mo`<0ool0o_l90?oo0?oo0?oo0=goo@3n
o`T0ool0ool0ool0g?on0?ko2@3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo
0?oo087ob?l00?ko2@3oo`3oo`3oo`3Mo`<0ool0o_l90?oo0?oo0?oo0=goo@3n
o`T0ool0ool0ool0g?on0?ko2@3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo
0?oo0;co003no`T0ool0ool0ool0g?l30?oo0?ko2@3oo`3oo`3oo`3Mood0o_l9
0?oo0?oo0?oo0=cooP3no`T0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3o
o`2io`00o_l90?oo0?oo0?oo0=go0`3oo`3no`T0ool0ool0ool0gOom0?ko2@3o
o`3oo`3oo`3Looh0o_l90?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0
POo8o`00o_l90?oo0?oo0?oo0=go0`3oo`3no`T0ool0ool0ool0gOom0?ko2@3o
o`3oo`3oo`3Looh0o_l90?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0
_?l00?ko2@3oo`3oo`3oo`3Lo`<0ool0o_l90?oo0?oo0?oo0=goo@3no`T0ool0
ool0ool0g?on0?ko2@3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;Wo
003no`T0ool0ool0ool0gOl30?oo0?ko2@3oo`3oo`3oo`3Mood0o_l90?oo0?oo
0?oo0=cooP3no`T0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`34o`=_
Q_l00?go2@3oo`3oo`3oo`3Moo`02ooo0?oo0?oo0?oo0=go003no``0ool0ool0
ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo
0;go003mo`T0ool0ool0ool0g?ol00_oo`3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo
0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?go3`3oo`3oo`3oo`3oo`3o
o`2jo`00oOl90?oo0?oo0?oo0=goo00;ool0ool0ool0ool0gOl00?ko303oo`3o
o`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0
ool0POo9o`00oOl90?oo0?oo0?oo0=goo00;ool0ool0ool0ool0gOl00?ko303o
o`3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0
ool0ool0_Ol00?go2@3oo`3oo`3oo`3Loo`02ooo0?oo0?oo0?oo0=go003no``0
ool0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo
0?oo0?oo0;[o003mo`T0ool0ool0ool0gOol00_oo`3oo`3oo`3oo`3Mo`00o_l<
0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?go3`3oo`3oo`3o
o`3oo`3oo`21olWo003mo`T0ool0ool0ool0gOol00_oo`3oo`3oo`3oo`3Mo`00
o_l<0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l00?go3`3oo`3o
o`3oo`3oo`3oo`2mo`00oOl90?oo0?oo0?oo0=coo00;ool0ool0ool0ool0gOl0
0?ko303oo`3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0
ool0ool0ool0ool0^_l00?go2@3oo`3oo`3oo`3Moo`02ooo0?oo0?oo0?oo0=go
003no``0ool0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3No`00oOl?0?oo
0?oo0?oo0?oo0?oo0<Co0h67o`l0ool0ool0ool0ool0ool0f_l00?ko2@3oo`3o
o`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0g_l0
0?go3`3oo`3oo`3oo`3oo`3oo`2no`l0ool0ool0ool0ool0ool0fOl00?ko2@3o
o`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0
g_l00?go3`3oo`3oo`3oo`3oo`3oo`2ko`l0ool0ool0ool0ool0ool0f_l00?ko
2@3oo`3oo`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=go003no``0ool0ool0ool0
ool0g_l00?go3`3oo`3oo`3oo`3oo`3oo`21ol[o3`3oo`3oo`3oo`3oo`3oo`3J
o`00o_l90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0gOl00?ko303oo`3o
o`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;ko3`3oo`3oo`3oo`3oo`3o
o`3Io`00o_l90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0gOl00?ko303o
o`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo0;_o3`3oo`3oo`3oo`3o
o`3oo`3Jo`00o_l90?oo0?oo0?oo0=go003no``0ool0ool0ool0ool0gOl00?ko
303oo`3oo`3oo`3oo`3No`00oOl?0?oo0?oo0?oo0?oo0?oo087ob_l?0?oo0?oo
0?oo0?oo0?oo0=[o003no`T0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3oo`3M
o`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0__l?0?oo
0?oo0?oo0?oo0?oo0=Wo003no`T0ool0ool0ool0gOl00?ko303oo`3oo`3oo`3o
o`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0^ol?
0?oo0?oo0?oo0?oo0?oo0=[o003no`T0ool0ool0ool0gOl00?ko303oo`3oo`3o
o`3oo`3Mo`00o_l<0?oo0?oo0?oo0?oo0=ko003mo`l0ool0ool0ool0ool0ool0
a?l2ZHSoo03no`400?go0@00f_on0?ko0@00oOl1003Kooh0oOl1003mo`400=_o
oP3mo`400?go0@00g_on0?go0@00oOl1003mo`400;koo03no`400?go0@00fOon
0?ko0@00oOl1003Kooh0oOl1003mo`400=_ooP3mo`400?go0@00g_on0?go0@00
oOl1003mo`400;_oo03no`400?go0@00f_on0?ko0@00oOl1003Kooh0oOl1003m
o`400=_ooP3mo`400?go0@00g_on0?go0@00oOl1003mo`40087ob_ol0?ko0@00
oOl1003Jooh0o_l1003mo`400=_ooP3mo`400?go0@00foon0?go0@00oOl1003N
ooh0oOl1003mo`400?go0@00__ol0?ko0@00oOl1003Iooh0o_l1003mo`400=_o
oP3mo`400?go0@00foon0?go0@00oOl1003Nooh0oOl1003mo`400?go0@00^ool
0?ko0@00oOl1003Jooh0o_l1003mo`400=_ooP3mo`400?go0@00foon0?go0@00
oOl1003Nooh0oOl1003mo`400?go0@00POo:oo`0o_l1003mo`400=[ooP3no`40
0?go0@00foon0?go0@00oOl1003Kooh0oOl1003mo`400=kooP3mo`400?go0@00
oOl1002noo`0o_l1003mo`400=WooP3no`400?go0@00foon0?go0@00oOl1003K
ooh0oOl1003mo`400=kooP3mo`400?go0@00oOl1002koo`0o_l1003mo`400=[o
oP3no`400?go0@00foon0?go0@00oOl1003Kooh0oOl1003mo`400=kooP3mo`40
0?go0@00oOl10033o`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oioo0321oh7oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oWol0<87oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOnOo`0`POn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oioo003o\>"], "Graphics",
  ImageSize->{1014, 417},
  ImageMargins->{{0, Inherited}, {Inherited, 4}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
GraphicsArray[\"<<>>\"]\
\>", "\<\
-GraphicsArray-\
\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF / m=2", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
sel=All;
{YF,PF,clik} = 
\tGHF[{ZM[[sel]], X[[sel]]}, Theta+1, 
\t     {driftLorenzX, OmegaLorenzX, hLorenzX, RLorenzX, \
mueLorenzX,sigmaLorenzX,dt,m=2},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({MessUpGHF, TimeUpGHF1}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("GHF: "\[InvisibleSpace]"m = "\[InvisibleSpace]2\),
      SequenceForm[ "GHF: ", "m = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    \({3.861201000000051`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["YF//MatrixForm", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
 MatrixForm[{{-0.4016054271800111, \
-0.04333005397132626, 0.17665191607175565, 11., 29., 3.6666666666666665}, 

    {-0.36219513612705556, -0.15865288363165433, 0.17034869499747318, \
10.999999999999986, 28.999999999999968,\\
  3.6666666666666603}, 
  {-0.3398413158898818, -0.2614851303731097, 0.1650566841012829, \
10.999999999999973, 28.999999999999936,\\
  3.666666666666656}, 
  {-0.3312640472624233, -0.35686135135871444, 0.1611614159559265, \
10.99999999999996, 28.99999999999988,\\
  3.666666666666652}, 
  {-0.3341099277120506, -0.44881771676180027, 0.15903620873432284, \
10.999999999999941, 28.999999999999844,\\
  3.666666666666647}, 
  {-0.3467363401805687, -0.5406682406344737, 0.15909292293479385, \
10.999999999999925, 28.999999999999797,\\
  3.666666666666642}, 
  {-0.3680511036553569, -0.63521448831035, 0.16182253685057382, \
10.99999999999991, 28.999999999999766,\\
  3.6666666666666377}, 
  {-0.3973937197437841, -0.7349057089991782, 0.16783295643406432, \
10.99999999999989, 28.99999999999972,\\
  3.666666666666633}, 
  {-0.43444791964605567, -0.841961646931292, 0.17788910374968184, \
10.999999999999876, 28.9999999999997,\\
  3.6666666666666288}, 
  {-0.47917777465352596, -0.9584668439629209, 0.19295914936180084, \
10.999999999999854,\\
  28.999999999999673, 3.6666666666666248}, 
  {-0.5317815097748444, -1.0864426037041899, 0.21427030318600393, \
10.999999999999835,\\
  28.999999999999645, 3.66666666666662}, 
  {-0.5926585233449619, -1.2279006420253717, 0.2433775888474797, \
10.99999999999983,\\
  28.99999999999961, 3.666666666666615}, 
  {-0.6623860811927287, -1.3848805790697143, 0.28224934392832457, \
10.999999999999819,\\
  28.999999999999577, 3.66666666666661}, 
  {-0.7417027993850478, -1.5594716473026113, 0.33337371665412885, \
10.999999999999803,\\
  28.99999999999954, 3.666666666666605}, 
  {-0.8314964020544613, -1.7538171230064352, 0.399891094377742, \
10.99999999999979,\\
  28.9999999999995, 3.6666666666666003}, 
  {-0.9327933624615293, -1.9700978529911892, 0.4857581181711796, \
10.999999999999776,\\
  28.999999999999464, 3.666666666666596}, 
  {-1.0467479053820357, -2.210488643816768, 0.5959495888039107, \
10.999999999999758,\\
  28.99999999999943, 3.6666666666665906}, 
  {-1.1746274439393969, -2.4770779827011955, 0.7367049510031914, \
10.999999999999748,\\
  28.999999999999396, 3.6666666666665857}, 
  {-1.3177907984232453, -2.771737322341403, 0.9158258194815384, \
10.999999999999742,\\
  28.999999999999346, 3.66666666666658}, 
  {-1.4776544305340795, -3.0959207448862616, 1.1430296334697638, \
10.99999999999973,\\
  28.999999999999307, 3.6666666666665764}, 
  {-1.655640336670413, -3.4503690490591508, 1.4303611266021279, \
10.999999999999714,\\
  28.999999999999265, 3.6666666666665715}, 
  {-1.8530970813838126, -3.8346842054831196, 1.7926565418303446, \
10.999999999999702,\\
  28.999999999999226, 3.666666666666566}, 
  {-2.0711826335286214, -4.246731182586076, 2.2480434405053833, \
10.999999999999687,\\
  28.999999999999186, 3.666666666666562}, 
  {-2.3106941720159897, -4.681815758479484, 2.818438800308544, \
10.999999999999671,\\
  28.99999999999914, 3.6666666666665586}, 
  {-2.571825991264824, -5.13158218209345, 3.5299763016379555, \
10.999999999999654,\\
  28.9999999999991, 3.6666666666665546}, 
  {-2.853832519210152, -5.58257936846274, 4.413246204318114, \
10.999999999999641,\\
  28.999999999999048, 3.6666666666665493}, 
  {-3.1545703288560643, -6.014469138083278, 5.503164579315967, \
10.999999999999627,\\
  28.999999999999016, 3.6666666666665444}, 
  {-3.4698929779296748, -6.397911604624317, 6.8382027553938665, \
10.999999999999607,\\
  28.999999999998977, 3.666666666666539}, 
  {-3.7928792703633576, -6.692285411561107, 8.458611194767968, \
10.999999999999599,\\
  28.999999999998938, 3.6666666666665337}, 
  {-4.112895084115308, -6.843613875387583, 10.403190942469966, \
10.99999999999959,\\
  28.999999999998906, 3.666666666666529}, 
  {-4.414529863579453, -6.783397739148373, 12.70415731580245, \
10.999999999999579,\\
  28.99999999999887, 3.666666666666522}, 
  {-4.676521708559729, -6.4294973098200785, 15.379804921842089, \
10.999999999999565,\\
  28.99999999999882, 3.6666666666665177}, 
  {-4.87089858974889, -5.690679345917513, 18.425162893477935, \
10.999999999999552,\\
  28.999999999998774, 3.6666666666665124}, 
  {-4.9627164206716525, -4.4767164598819384, 21.801765590780157, \
10.999999999999536,\\
  28.999999999998742, 3.666666666666508}, 
  {-4.910940970123762, -2.7155602239165946, 25.429069653965154, \
10.999999999999522,\\
  28.99999999999871, 3.666666666666504}, 
  {-4.67112779897942, -0.37750682767988986, 29.181575706184073, \
10.999999999999508,\\
  28.999999999998664, 3.6666666666664987}, 
  {-4.200472515917675, 2.496996280673911, 32.89640663702266, \
10.99999999999949,\\
  28.999999999998607, 3.666666666666494}, 
  {-3.4653694253399543, 5.773762817442396, 36.394445188529446, \
10.999999999999481,\\
  28.999999999998575, 3.6666666666664893}, 
  {-2.4507327918167343, 9.217033390668284, 39.51294396146226, \
10.999999999999465,\\
  28.999999999998522, 3.666666666666485}, 
  {-1.1691443455667958, 12.508206919079448, 42.13972120814478, \
10.999999999999455,\\
  28.999999999998494, 3.666666666666479}, 
  {0.3330861720337385, 15.294088065480423, 44.23319053608539, \
10.999999999999442,\\
  28.99999999999845, 3.666666666666475}, 
  {1.975858943537796, 17.25450584534901, 45.815055944611885, \
10.999999999999426,\\
  28.99999999999839, 3.66666666666647}, 
  {3.652685011063083, 18.16859967446176, 46.93602635393844, \
10.999999999999412,\\
  28.99999999999835, 3.666666666666465}, 
  {5.244567071661128, 17.95910068499212, 47.632344419541504, \
10.999999999999394,\\
  28.99999999999829, 3.6666666666664596}, 
  {6.637211032280058, 16.70431237664538, 47.89902031777937, \
10.999999999999384,\\
  28.999999999998252, 3.6666666666664547}, 
  {7.737641722533656, 14.61914626752557, 47.696664982882815, \
10.999999999999371,\\
  28.999999999998217, 3.666666666666451}, 
  {8.486885858787863, 12.01195871789197, 46.988244887883916, \
10.999999999999359,\\
  28.999999999998167, 3.6666666666664445}, 
  {8.8664953600128, 9.225115753186607, 45.78381598374425, 10.999999999999348,\
\\
  28.999999999998135, 3.66666666666644}, 
  {8.897796695964995, 6.570474832113705, 44.166818324286176, \
10.999999999999332,\\
  28.999999999998085, 3.6666666666664356}, 
  {8.634105427284647, 4.2761162268904425, 42.2871437132468, \
10.999999999999318,\\
  28.99999999999804, 3.666666666666431}, 
  {-20.487526445010353, -27.091760676889578, 39.851261461512564, \
14.106552029750421,\\
  27.088132004892483, -0.9550221678061339}, 
  {-21.41912738234991, -24.205954711535806, 45.78242970460083, \
14.1065520297504,\\
  27.08813200489244, -0.9550221678061328}, 
  {-21.811635017996224, -19.95940423702923, 51.405094625986024, \
14.106552029750379,\\
  27.088132004892422, -0.9550221678061315}, 
  {-21.549481141182046, -14.455238669245714, 56.25086873380792, \
14.10655202975035,\\
  27.088132004892394, -0.9550221678061303}, 
  {-20.547985426520256, -8.025485853824868, 59.90525001311827, \
14.106552029750338,\\
  27.08813200489235, -0.9550221678061289}, 
  {-18.781387588881664, -1.2013376432629046, 62.12963612731193, \
14.106552029750324,\\
  27.08813200489231, -0.9550221678061276}, 
  {-16.302660848775567, 5.392172220555578, 62.95325250046659, \
14.106552029750317,\\
  27.08813200489227, -0.9550221678061263}, 
  {-13.245561424001272, 11.184752966414303, 62.681697001758465, \
14.106552029750299,\\
  27.08813200489222, -0.9550221678061251}, 
  {-9.805335460251419, 15.785878900952202, 61.806612597623996, \
14.10655202975029,\\
  27.088132004892195, -0.9550221678061239}, 
  {-6.204508460594275, 19.028687927058858, 60.857680168627205, \
14.106552029750278,\\
  27.088132004892152, -0.9550221678061226}, 
  {-2.6574074732889224, 20.92674875797668, 60.2670035703254, \
14.106552029750254,\\
  27.08813200489211, -0.9550221678061213}, 
  {0.6540840934981312, 21.587685224778586, 60.29459210892592, \
14.106552029750242,\\
  27.088132004892074, -0.9550221678061196}, 
  {3.5890989207907484, 21.137746827048073, 61.01862823889445, \
14.106552029750214,\\
  27.08813200489203, -0.9550221678061183}, 
  {6.044533003679779, 19.68662299749771, 62.36570037005666, 14.1065520297502,\
\\
  27.088132004891985, -0.955022167806117}, 
  {7.947368029101536, 17.33192743595281, 64.15589267424697, \
14.106552029750182,\\
  27.08813200489194, -0.9550221678061157}, 
  {9.248785079050924, 14.186456155614811, 66.15066597435926, \
14.106552029750159,\\
  27.088132004891904, -0.9550221678061145}, 
  {9.922982335569742, 10.408224008636653, 68.1012825058383, \
14.10655202975013,\\
  27.088132004891868, -0.9550221678061136}, 
  {9.970361055287135, 6.2169869673826765, 69.79651806041677, \
14.106552029750118,\\
  27.08813200489183, -0.9550221678061125}, 
  {9.422501487205357, 1.8880595928933617, 71.10364039615405, \
14.106552029750105,\\
  27.088132004891797, -0.9550221678061109}, 
  {8.345451067545499, -2.276230912613698, 71.99236653355592, \
14.106552029750098,\\
  27.08813200489175, -0.9550221678061096}, 
  {6.838437654000007, -5.987484257211513, 72.53297162930373, \
14.106552029750071,\\
  27.088132004891715, -0.955022167806108}, 
  {5.026981207453647, -9.009412835144206, 72.86781120383759, \
14.106552029750052,\\
  27.088132004891683, -0.9550221678061067}, 
  {3.0516698557631887, -11.180803501960456, 73.16581606062262, \
14.106552029750022,\\
  27.088132004891648, -0.9550221678061055}, 
  {1.0554084266950652, -12.419721816345474, 73.5755183786549, 14.10655202975,\
\\
  27.08813200489161, -0.9550221678061043}, 
  {-0.8280148821768397, -12.714580834504174, 74.19066713545419, \
14.106552029749983,\\
  27.088132004891573, -0.955022167806103}, 
  {-2.482439796918615, -12.111536551046006, 75.03573725075228, \
14.106552029749958,\\
  27.088132004891538, -0.9550221678061018}, 
  {-3.814882104984221, -10.705197870780463, 76.07134820194202, \
14.106552029749938,\\
  27.0881320048915, -0.9550221678061004}, 
  {-4.759032731816092, -8.633967839897197, 77.21478900333268, \
14.106552029749924,\\
  27.088132004891474, -0.9550221678060989}, 
  {-5.277633964724117, -6.0765165011162035, 78.36859208472936, \
14.106552029749906,\\
  27.088132004891445, -0.9550221678060976}, 
  {-5.364008888335743, -3.244395570924417, 79.44932364653853, \
14.106552029749883,\\
  27.088132004891413, -0.9550221678060964}, 
  {-5.042281528385929, -0.36783866156854067, 80.40909715781127, \
14.106552029749864,\\
  27.088132004891378, -0.9550221678060951}, 
  {-4.365502497085906, 2.324311171039838, 81.2443236140167, \
14.10655202974985,\\
  27.088132004891342, -0.9550221678060938}, 
  {-3.4111754015001177, 4.626360162695378, 81.99014287625528, \
14.106552029749816,\\
  27.08813200489131, -0.9550221678060924}, 
  {-2.274364427959446, 6.374336778972892, 82.70368126607497, \
14.106552029749798,\\
  27.08813200489128, -0.955022167806091}, 
  {-1.059221411348161, 7.458376341215735, 83.44275654764307, \
14.106552029749773,\\
  27.08813200489125, -0.9550221678060896}, 
  {0.12995191420343385, 7.828721392853041, 84.24748027779407, \
14.106552029749755,\\
  27.088132004891218, -0.9550221678060882}, 
  {1.197153329826369, 7.496817905223751, 85.13032414407083, \
14.106552029749736,\\
  27.088132004891182, -0.9550221678060868}, 
  {2.062048361088128, 6.532784347490184, 86.07681276132044, \
14.106552029749718,\\
  27.088132004891143, -0.9550221678060858}, 
  {2.6659224725910318, 5.0592700019256736, 87.05537713408279, \
14.106552029749711,\\
  27.088132004891097, -0.9550221678060846}, 
  {2.9759130682103807, 3.2408310934793727, 88.03198720626982, \
14.10655202974968,\\
  27.088132004891065, -0.9550221678060834}, 
  {2.987122376033397, 1.2684001714764972, 88.98374164905341, \
14.106552029749661,\\
  27.088132004891033, -0.955022167806082}, 
  {2.722209869566336, -0.6599711272096009, 89.90624768379894, \
14.106552029749649,\\
  27.088132004890994, -0.9550221678060804}, 
  {2.2283021704521873, -2.359324408013556, 90.81238008624538, \
14.106552029749635,\\
  27.088132004890948, -0.9550221678060791}, 
  {1.5714914823019999, -3.675840897213786, 91.72383544179714, \
14.10655202974962,\\
  27.088132004890902, -0.9550221678060777}, 
  {0.8296040823046625, -4.500735582656207, 92.65988110956236, \
14.106552029749606,\\
  27.088132004890873, -0.9550221678060766}, 
  {0.08409647658042187, -4.7794374519132425, 93.62845561760244, \
14.10655202974959,\\
  27.08813200489085, -0.9550221678060754}, 
  {-0.5881228581470159, -4.516195503861708, 94.62341867274722, \
14.106552029749567,\\
  27.08813200489081, -0.955022167806074}, 
  {-1.1222959964453605, -3.7737752559558317, 95.62882589719023, \
14.106552029749535,\\
  27.08813200489077, -0.9550221678060725}, 
  {-1.472241783625316, -2.667140674042078, 96.62798949391238, \
14.106552029749519,\\
  27.088132004890742, -0.9550221678060712}, 
  {-1.6149310643048747, -1.350284419418237, 97.61292069333477, \
14.1065520297495,\\
  27.08813200489071, -0.9550221678060699}, 
  {2.85068048664031, 1.9468079695372966, 22.497602942314444, \
17.63144853634854,\\
  26.14508252094058, 0.6244125396570711}, 
  {2.691434232978953, 2.031384540834232, 22.412647650975835, \
17.631448536348515,\\
  26.14508252094053, 0.6244125396570703}, 
  {2.575234229901431, 2.111544019715067, 22.327615139945333, \
17.631448536348486,\\
  26.14508252094049, 0.6244125396570697}, 
  {2.493686310325945, 2.1887303078350997, 22.243316860801013, \
17.631448536348465,\\
  26.145082520940463, 0.6244125396570689}, 
  {2.440139220204146, 2.264123831473557, 22.160472473824825, \
17.631448536348433,\\
  26.145082520940424, 0.6244125396570682}, 
  {2.4093285547832157, 2.3386895870189304, 22.079723699479608, \
17.6314485363484,\\
  26.145082520940395, 0.6244125396570672}, 
  {2.39709253520299, 2.4132151414030263, 22.001648436498886, \
17.63144853634838,\\
  26.14508252094037, 0.6244125396570662}, 
  {2.400145044348687, 2.4883408651820944, 21.926774011711725, \
17.631448536348362,\\
  26.14508252094033, 0.6244125396570654}, 
  {2.4158943471470007, 2.5645839984054444, 21.85558902859218, \
17.631448536348337,\\
  26.1450825209403, 0.6244125396570644}, 
  {2.442298269356961, 2.6423577163889376, 21.788553620208813, \
17.63144853634831,\\
  26.145082520940257, 0.6244125396570637}, 
  {2.4777484612442366, 2.721986077047625, 21.72610809281773, \
17.631448536348287,\\
  26.14508252094022, 0.624412539657063}, 
  {2.520977843316887, 2.803715536597204, 21.668680032541644, \
17.63144853634827,\\
  26.145082520940182, 0.6244125396570623}, 
  {2.5709865048681912, 2.8877235828057897, 21.616689978431477, \
17.63144853634824,\\
  26.145082520940157, 0.6244125396570616}, 
  {2.626982265729897, 2.974124934973828, 21.570555764627027, \
17.631448536348216,\\
  26.145082520940118, 0.6244125396570609}, 
  {2.6883328658881056, 3.0629756859406134, 21.530695616902545, \
17.63144853634818,\\
  26.145082520940075, 0.62441253965706}, 
  {2.754527354231319, 3.1542757069017235, 21.49753006345641, \
17.631448536348156,\\
  26.145082520940047, 0.624412539657059}, 
  {2.8251447365007256, 3.247969596687291, 21.471482691762915, \
17.63144853634813,\\
  26.145082520940015, 0.6244125396570582}, 
  {2.8998283372689255, 3.3439464310231, 21.45297975600219, 17.63144853634811,\
\\
  26.145082520939997, 0.6244125396570573}, 
  {2.978264650582918, 3.4420385527128805, 21.442448615262666, \
17.63144853634809,\\
  26.145082520939944, 0.6244125396570567}, 
  {3.060165714194186, 3.5420196396507486, 21.440314963085044, \
17.63144853634806,\\
  26.145082520939905, 0.624412539657056}, 
  {3.1452542555539384, 3.6436022932785144, 21.44699879554678, \
17.631448536348035,\\
  26.14508252093987, 0.6244125396570551}, 
  {3.2332510340895, 3.74643540466597, 21.462909059591865, 17.631448536348014,\
\\
  26.145082520939845, 0.6244125396570543}, 
  {3.3238639518510222, 3.8501015776720666, 21.488436927487847, \
17.631448536347982,\\
  26.145082520939802, 0.6244125396570535}, 
  {3.4167786299213487, 3.954114917040732, 21.5239476591286, \
17.63144853634796,\\
  26.145082520939766, 0.6244125396570527}, 
  {3.511650256069238, 4.05791952153754, 21.56977104351266, 17.63144853634794,\
\\
  26.14508252093971, 0.6244125396570517}, 
  {3.6080966037487734, 4.160889055233377, 21.626190456195033, \
17.631448536347907,\\
  26.145082520939678, 0.6244125396570512}, 
  {3.7056922062379325, 4.262327799661389, 21.693430632620878, \
17.631448536347893,\\
  26.145082520939642, 0.6244125396570505}, 
  {3.8039637438164635, 4.361473610559613, 21.7716443391227, \
17.63144853634786,\\
  26.145082520939592, 0.6244125396570495}, 
  {3.90238676658532, 4.457503208877291, 21.86089822396491, 17.63144853634784,\
\\
  26.14508252093956, 0.6244125396570486}, 
  {4.000383929841061, 4.54954021930817, 21.9611582483949, 17.631448536347815,\
\\
  26.145082520939525, 0.6244125396570478}, 
  {4.097324960722819, 4.636666322872668, 22.072275228097716, \
17.631448536347797,\\
  26.1450825209395, 0.6244125396570469}, 
  {4.192528600998124, 4.717935805149584, 22.1939711516908, \
17.631448536347765,\\
  26.14508252093946, 0.624412539657046}, 
  {4.28526677736368, 4.792393651909928, 22.325827074471313, \
17.631448536347737,\\
  26.145082520939425, 0.6244125396570452}, 
  {4.37477123303561, 4.859097164837987, 22.467273498524452, \
17.631448536347722,\\
  26.145082520939386, 0.6244125396570442}, 
  {4.460242808247196, 4.9171408415138425, 22.61758422729531, \
17.6314485363477,\\
  26.145082520939354, 0.6244125396570432}, 
  {4.540863478863944, 4.965683991434835, 22.775874704424606, \
17.631448536347676,\\
  26.145082520939322, 0.6244125396570422}, 
  {4.615811149603722, 5.003980256444914, 22.941105793342427, \
17.63144853634765,\\
  26.145082520939276, 0.6244125396570412}, 
  {4.684277051894374, 5.031407890677161, 23.112093808512267, \
17.631448536347627,\\
  26.14508252093925, 0.6244125396570401}, 
  {4.745485420431723, 5.04749936137652, 23.287527359889943, 17.6314485363476,\
\\
  26.145082520939212, 0.6244125396570391}, 
  {4.798714925688793, 5.05196859382853, 23.465991217336708, \
17.63144853634757,\\
  26.145082520939166, 0.6244125396570382}, 
  {4.843321135491005, 5.044734040530852, 23.645996952768034, \
17.631448536347545,\\
  26.145082520939138, 0.6244125396570377}, 
  {4.87875908542085, 5.025935744445431, 23.826019601561516, \
17.631448536347516,\\
  26.145082520939102, 0.6244125396570368}, 
  {4.904604876831432, 4.995944718214852, 24.004539043710913, \
17.631448536347484,\\
  26.145082520939056, 0.624412539657036}, 
  {4.920575115625972, 4.955363290077518, 24.18008429496733, \
17.631448536347456,\\
  26.145082520939027, 0.6244125396570355}, 
  {4.92654297618543, 4.905015566262469, 24.35127848150487, 17.63144853634743,\
\\
  26.14508252093898, 0.6244125396570347}, 
  {4.922549739415308, 4.845927797749961, 24.51688200972058, \
17.631448536347392,\\
  26.145082520938963, 0.6244125396570338}, 
  {4.9088108199205465, 4.779299161279788, 24.675831384981013, \
17.63144853634737,\\
  26.145082520938924, 0.6244125396570329}, 
  {4.885715561699405, 4.706464196405603, 24.82727130688346, \
17.63144853634734,\\
  26.145082520938892, 0.6244125396570323}, 
  {4.853820428829159, 4.628848799186514, 24.970578071942214, \
17.631448536347325,\\
  26.145082520938857, 0.6244125396570315}, 
  {4.8138356198305035, 4.547922179434476, 25.10537291345583, \
17.631448536347303,\\
  26.145082520938818, 0.6244125396570306}, 
  {14.897131443748263, 5.627552309983836, 39.16558623969395, \
17.66839105754939,\\
  26.391814292794013, 0.6848480232854095}, 
  {13.25937212906661, 3.668254744115672, 39.735785795965384, \
17.668391057549375,\\
  26.391814292793978, 0.6848480232854085}, 
  {11.565392659927968, 1.8620490425211609, 39.950180515746865, \
17.668391057549368,\\
  26.391814292793956, 0.6848480232854077}, 
  {9.852137703623804, 0.27519688582535057, 39.892278898059686, \
17.668391057549343,\\
  26.391814292793914, 0.6848480232854068}, 
  {8.161716854223602, -1.0576158121613564, 39.646939248981354, \
17.66839105754931,\\
  26.39181429279388, 0.6848480232854054}, 
  {6.534908197331065, -2.128581820348108, 39.29045128666626, \
17.668391057549282,\\
  26.39181429279384, 0.6848480232854044}, 
  {5.006647577069686, -2.949551795218632, 38.88438271720008, \
17.668391057549265,\\
  26.3918142927938, 0.6848480232854035}, 
  {3.603594944155744, -3.544443584905055, 38.47337346605121, \
17.66839105754925,\\
  26.391814292793782, 0.6848480232854023}, 
  {2.3434727881625745, -3.942832829351686, 38.08600183537938, \
17.668391057549247,\\
  26.391814292793747, 0.6848480232854011}, 
  {1.2356525627718853, -4.1754052193788365, 37.737455077085805, \
17.668391057549233,\\
  26.39181429279372, 0.6848480232854001}, 
  {0.28243868609090317, -4.271243605368448, 37.43286742417802, \
17.6683910575492,\\
  26.391814292793693, 0.6848480232853992}, 
  {-0.5193973147231706, -4.256543247251132, 37.17055465872804, \
17.668391057549176,\\
  26.39181429279366, 0.6848480232853983}, 
  {-1.1771284955183545, -4.154253995457757, 36.94474633883733, \
17.668391057549144,\\
  26.391814292793626, 0.6848480232853976}, 
  {-1.7007850177415744, -3.984219778673705, 36.74768692244434, \
17.668391057549123,\\
  26.391814292793587, 0.6848480232853966}, 
  {-2.1021193071121775, -3.763516294422318, 36.57113114532617, \
17.668391057549098,\\
  26.39181429279354, 0.6848480232853955}, 
  {-2.393813848848916, -3.506813113923754, 36.407326249011184, \
17.668391057549073,\\
  26.3918142927935, 0.6848480232853942}, 
  {-2.5888928703068492, -3.226680503296979, 36.249590054834734, \
17.668391057549044,\\
  26.39181429279347, 0.6848480232853933}, 
  {-2.7002920661574894, -2.933820802269519, 36.092586623769996, \
17.668391057549023,\\
  26.39181429279343, 0.6848480232853923}, 
  {-2.740545139611812, -2.637235599751999, 35.93238609923903, \
17.668391057548998,\\
  26.3918142927934, 0.6848480232853914}, 
  {-2.721555232922531, -2.3443518880117304, 35.76637950927449, \
17.668391057548973,\\
  26.391814292793363, 0.6848480232853906}, 
  {-2.6544290526329464, -2.0611305950123446, 35.59310511932403, \
17.668391057548945,\\
  26.391814292793317, 0.68484802328539}, 
  {-2.549359527869732, -1.792175233623091, 35.4120305539214, \
17.66839105754893,\\
  26.39181429279327, 0.6848480232853889}, 
  {-2.415548448160906, -1.5408508489732506, 35.22332396345627, \
17.668391057548906,\\
  26.391814292793235, 0.6848480232853881}, 
  {-2.261163813148308, -1.3094164199123806, 35.02763774435531, \
17.668391057548888,\\
  26.391814292793196, 0.6848480232853871}, 
  {-2.093328099333473, -1.099168607102065, 34.825919737119115, \
17.66839105754886,\\
  26.391814292793164, 0.6848480232853862}, 
  {-1.9181339415771728, -0.9105916066612152, 34.619259600935564, \
17.668391057548856,\\
  26.39181429279312, 0.6848480232853852}, 
  {-1.74068342304638, -0.7435066776743735, 34.408772375638144, \
17.668391057548842,\\
  26.391814292793082, 0.6848480232853844}, 
  {-1.5651467127344905, -0.5972151873348199, 34.19551716094643, \
17.668391057548813,\\
  26.391814292793047, 0.6848480232853835}, 
  {-1.3948354671799632, -0.47063019855583255, 33.98044628546316, \
17.668391057548796,\\
  26.39181429279302, 0.6848480232853825}, 
  {-1.2322863565714335, -0.3623932055848277, 33.764379086213566, \
17.668391057548767,\\
  26.391814292792983, 0.6848480232853819}, 
  {-1.079350306721057, -0.2709742234361112, 33.54799417559099, \
17.66839105754874,\\
  26.391814292792947, 0.6848480232853811}, 
  {-0.9372835189434774, -0.19475482032500618, 33.331834518051615, \
17.66839105754873,\\
  26.39181429279292, 0.6848480232853803}, 
  {-0.8068369587444228, -0.13209473853077675, 33.11632048331743, \
17.668391057548703,\\
  26.39181429279288, 0.6848480232853792}, 
  {-0.6883417058143592, -0.08138346054258105, 32.90176705250152, \
17.66839105754869,\\
  26.391814292792848, 0.6848480232853783}, 
  {-0.5817882588577815, -0.04107848256823431, 32.68840236161128, \
17.668391057548668,\\
  26.391814292792816, 0.6848480232853772}, 
  {-0.486898535876738, -0.009732221110277163, 32.476385669616505, \
17.668391057548646,\\
  26.39181429279279, 0.6848480232853763}, 
  {-0.4031898711104053, 0.013990530305779906, 32.26582358367861, \
17.66839105754864,\\
  26.391814292792752, 0.6848480232853753}, 
  {-0.3300307692693892, 0.03130279624607663, 32.05678394778299, \
17.668391057548618,\\
  26.39181429279271, 0.6848480232853743}, 
  {-0.2666885347350032, 0.04329164900804213, 31.849307212606746, \
17.66839105754859,\\
  26.39181429279264, 0.6848480232853734}, 
  {-0.21236915549512658, 0.050919062610273784, 31.6434153768877, \
17.668391057548575,\\
  26.391814292792613, 0.6848480232853725}, 
  {-0.166250001021828, 0.05502619138962563, 31.439118751938224, \
17.668391057548558,\\
  26.391814292792553, 0.684848023285372}, 
  {-0.127506004172389, 0.05634007331435143, 31.23642087934974, \
17.668391057548526,\\
  26.391814292792507, 0.6848480232853712}, 
  {-0.09533005352737761, 0.05548194010373731, 31.03532195243017, \
17.668391057548515,\\
  26.391814292792468, 0.6848480232853704}, 
  {-0.06894833715651642, 0.05297647735023442, 30.83582107518869, \
17.668391057548497,\\
  26.391814292792443, 0.6848480232853694}, 
  {-0.04763136266582712, 0.04926151763057864, 30.637917654717647, \
17.668391057548472,\\
  26.391814292792404, 0.6848480232853686}, 
  {-0.030701340685072517, 0.044697769023903176, 30.441612175234017,\\
  17.668391057548437, 26.39181429279237, 0.684848023285368}, 
  {-0.017536567069787953, 0.03957828214534278, 30.246906552718382,\\
  17.668391057548426, 26.391814292792333, 0.6848480232853671}, 
  {-0.007573378796915434, 0.03413744261303294, 30.05380422293807,\\
  17.66839105754842, 26.3918142927923, 0.6848480232853661}, 
  {-0.0003061942595330845, 0.028559344679394756, 29.86231007533664,\\
  17.668391057548398, 26.391814292792255, 0.6848480232853649}, 
  {0.004713916265962806, 0.022985457385022796,\\
  29.672430311905636, 17.66839105754837, 26.391814292792223, \
0.6848480232853639}, 
  {-7.015551119272714, -13.504496322019506,\\
  17.04004903319339, 17.839620781944635, 26.83687692435948, \
0.8522350148552689}, 
  {-8.173160756154335, -14.056805801115084,\\
  17.842319909876345, 17.839620781944614, 26.836876924359434, \
0.8522350148552676}, 
  {-9.222504312202135, -14.651353955969936,\\
  18.8394624127777, 17.8396207819446, 26.836876924359398, \
0.8522350148552669}, 
  {-10.190551759362377, -15.242190001305692,\\
  20.031036443954548, 17.839620781944568, 26.83687692435934, \
0.8522350148552659}, 
  {-11.091215762256438, -15.782805072316343,\\
  21.41535351797653, 17.83962078194454, 26.836876924359302, \
0.8522350148552644}, 
  {-11.927596147107245, -16.22532065896741,\\
  22.986176319856778, 17.839620781944518, 26.83687692435928, \
0.8522350148552632}, 
  {-12.69367459338088, -16.520739014731625,\\
  24.729611019951363, 17.83962078194449, 26.836876924359238, \
0.8522350148552623}, 
  {-13.375748816059364, -16.62048826867362,\\
  26.621283371987317, 17.83962078194446, 26.836876924359203, \
0.8522350148552611}, 
  {-13.95388516868127, -16.479394437285688,\\
  28.62415238500604, 17.83962078194444, 26.83687692435916, 0.85223501485526}, \

  {-14.403642132473237, -16.06001178227476,\\
  30.687529621126433, 17.839620781944422, 26.836876924359128, \
0.8522350148552587}, 
  {-14.698259506504884, -15.337913848962891,\\
  32.7479785836177, 17.83962078194439, 26.836876924359096, \
0.8522350148552573}, 
  {-14.811401862013103, -14.307120581161119,\\
  34.73267375137381, 17.839620781944358, 26.836876924359057, \
0.8522350148552564}, 
  {-14.720381162034466, -12.984427672040876,\\
  36.56541589083195, 17.839620781944333, 26.836876924359032, \
0.852235014855255}, 
  {-14.409575881708324, -11.411212146469039,\\
  38.17482095889684, 17.839620781944312, 26.83687692435899, \
0.8522350148552537}, 
  {-13.873559340922693, -9.651532680991567,\\
  39.50337041642427, 17.83962078194429, 26.836876924358954, \
0.8522350148552527}, 
  {-13.11932606987749, -7.786130645085317,\\
  40.515350534251596, 17.839620781944273, 26.836876924358904, \
0.8522350148552514}, 
  {-12.167044658358652, -5.903117375884811,\\
  41.20160361788773, 17.83962078194426, 26.836876924358872, \
0.8522350148552502}, 
  {-11.049009399588128, -4.087266713271843,\\
  41.57969049282076, 17.839620781944234, 26.836876924358837, \
0.8522350148552491}, 
  {-9.806865867929014, -2.4103761708745317,\\
  41.689369633042865, 17.839620781944216, 26.836876924358815, \
0.8522350148552478}, 
  {-8.487612929478525, -0.924798963071442,\\
  41.58470137132456, 17.839620781944195, 26.836876924358776, \
0.8522350148552468}, 
  {-7.139168904776175, 0.338866095128761,\\
  41.32495555846906, 17.83962078194418, 26.836876924358737, \
0.8522350148552457}, 
  {-5.806323526975402, 1.3702633573449667,\\
  40.96649953126333, 17.839620781944166, 26.836876924358705, \
0.8522350148552446}, 
  {-4.527688435891143, 2.1752281426896274,\\
  40.55710914597559, 17.839620781944134, 26.83687692435867, \
0.8522350148552433}, 
  {-3.333919358848731, 2.770751260801503,\\
  40.13314078375059, 17.839620781944106, 26.836876924358634, \
0.8522350148552421}, 
  {-2.247155741793146, 3.180226155463966,\\
  39.71918308149202, 17.839620781944078, 26.836876924358606, \
0.8522350148552413}, 
  {-1.2814077634121686, 3.429693090616413,\\
  39.32939390258718, 17.839620781944063, 26.836876924358563, \
0.8522350148552402}, 
  {-0.4435423331045814, 3.5452753696170607,\\
  38.96969036116809, 17.839620781944028, 26.83687692435851, \
0.8522350148552391}, 
  {0.26545195450542364, 3.5516654287263787,\\
  38.64014052531404, 17.839620781944014, 26.83687692435847, \
0.8522350148552383}, 
  {0.8491577606477427, 3.471377241136263,\\
  38.33714836051174, 17.839620781944, 26.836876924358435, \
0.8522350148552373}, 
  {1.3145235002468425, 3.3244775641634665,\\
  38.055233556859484, 17.839620781943964, 26.83687692435839, \
0.8522350148552368}, 
  {1.67082609196814, 3.1285721632734576,\\
  37.788352137351595, 17.839620781943943, 26.83687692435836, \
0.8522350148552357}, 
  {1.9288169340566295, 2.8989026583122333,\\
  37.53078647007806, 17.839620781943925, 26.83687692435832, \
0.8522350148552347}, 
  {2.1000378242479067, 2.648477413943759,\\
  37.27767223172094, 17.8396207819439, 26.836876924358275, \
0.8522350148552339}, 
  {2.19628240334988, 2.3882063887967067,\\
  37.02524239455473, 17.839620781943886, 26.836876924358233, \
0.8522350148552328}, 
  {2.2291777988426893, 2.1270357813319563,\\
  36.77086669090802, 17.83962078194387, 26.836876924358204, \
0.8522350148552317}, 
  {2.2098649777432224, 1.8720887124769834,\\
  36.51295642573443, 17.83962078194385, 26.83687692435817, \
0.8522350148552308}, 
  {2.1487612833355185, 1.6288189518486047,\\
  36.25079275455086, 17.83962078194382, 26.836876924358133, \
0.8522350148552298}, 
  {2.0553928222475264, 1.4011808547661255,\\
  35.984323658283444, 17.839620781943797, 26.836876924358105, \
0.8522350148552285}, 
  {1.9382871171044425, 1.1918137864058556,\\
  35.71396211444027, 17.839620781943772, 26.836876924358062, \
0.8522350148552271}, 
  {1.8049178259792256, 1.0022354221130656,\\
  35.44040634287827, 17.83962078194375, 26.836876924358023, \
0.8522350148552263}, 
  {1.6616937812232067, 0.833036255077738,\\
  35.1644931997682, 17.83962078194373, 26.836876924357984, \
0.8522350148552249}, 
  {1.5139846121304332, 0.6840674016026225,\\
  34.88708821487588, 17.839620781943715, 26.836876924357952, \
0.8522350148552237}, 
  {1.3661751899811698, 0.5546149067662095,\\
  34.60901050245347, 17.839620781943694, 26.836876924357913, \
0.8522350148552226}, 
  {1.221741316200222, 0.44355561651504294,\\
  34.330987628941585, 17.839620781943683, 26.836876924357888, \
0.8522350148552216}, 
  {1.0833395587100048, 0.34949175498898444,\\
  34.053634103556874, 17.839620781943673, 26.836876924357853, \
0.8522350148552204}, 
  {0.9529049091527227, 0.2708632443919805,\\
  33.7774469998357, 17.83962078194365, 26.83687692435782, \
0.8522350148552192}, 
  {0.8317509012274733, 0.2060383184526416,\\
  33.50281285705798, 17.839620781943626, 26.836876924357774, \
0.8522350148552181}, 
  {0.7206678927538117, 0.1533840419270012,\\
  33.23002106206082, 17.8396207819436, 26.836876924357732, \
0.8522350148552171}, 
  {0.6200162734271081, 0.11131898546386305,\\
  32.95928008579518, 17.83962078194357, 26.8368769243577, 0.852235014855216}, \

  {0.5298123416251905, 0.07835059486869503,\\
  32.69073405714003, 17.839620781943562, 26.836876924357675, \
0.8522350148552148}, 
  {6.627422035591302, 7.936964176444642,\\
  23.038488947768307, 17.623211812968606, 25.91089465670534, \
0.921191970452777}, 
  {6.8582877799186495, 8.047970377186594,\\
  23.352339328235125, 17.62321181296858, 25.91089465670531, \
0.9211919704527759}, 
  {7.067991564784095, 8.142911496294703,\\
  23.689418793106007, 17.623211812968556, 25.910894656705278, \
0.9211919704527746}, 
  {7.257448469181711, 8.218341301585308,\\
  24.04744301522979, 17.623211812968528, 25.910894656705235, \
0.9211919704527736}, 
  {7.426800085273607, 8.271104059648394,\\
  24.4237525774193, 17.623211812968503, 25.910894656705196, \
0.9211919704527723}, 
  {7.575603262249184, 8.298364376731975,\\
  24.81529048124782, 17.62321181296849, 25.910894656705153, \
0.921191970452771}, 
  {7.702990535177597, 8.297659964999301,\\
  25.21859484293136, 17.623211812968457, 25.91089465670512, \
0.92119197045277}, 
  {7.807811355363689, 8.266969630988827,\\
  25.629811754227543, 17.623211812968442, 25.910894656705104, \
0.9211919704527687}, 
  {7.888760252639713, 8.204788955074307,\\
  26.044731808420373, 17.623211812968414, 25.910894656705047, \
0.9211919704527675}, 
  {7.944495634915372, 8.110205888703943,\\
  26.458852205323648, 17.62321181296839, 25.91089465670501, \
0.9211919704527664}, 
  {7.973750893298116, 7.982968219705721,\\
  26.867464505106195, 17.623211812968364, 25.910894656704965, \
0.921191970452765}, 
  {7.975437757010259, 7.82353486195422,\\
  27.265765973705406, 17.62321181296834, 25.91089465670493, \
0.9211919704527638}, 
  {7.948740425409302, 7.633103473574321,\\
  27.64899015016365, 17.6232118129683, 25.910894656704905, \
0.9211919704527625}, 
  {7.8931979358723, 7.413608177768944,\\
  28.012549977472165, 17.623211812968286, 25.910894656704873, \
0.9211919704527612}, 
  {7.808771571991404, 7.167683219307219,\\
  28.35218486682831, 17.62321181296827, 25.910894656704826, \
0.9211919704527601}, 
  {7.695893942557498, 6.898591160361806,\\
  28.66410174022383, 17.62321181296824, 25.910894656704784, \
0.9211919704527584}, 
  {7.555496708951935, 6.610117467215369,\\
  28.945099717249686, 17.623211812968215, 25.910894656704752, \
0.9211919704527567}, 
  {7.389014798909648, 6.306436691018957,\\
  29.192668873520898, 17.62321181296819, 25.91089465670472, \
0.9211919704527555}, 
  {7.198366245616181, 5.991958444065028,\\
  29.405055425948508, 17.623211812968172, 25.910894656704667, \
0.9211919704527542}, 
  {6.985908392187674, 5.671163562346729,\\
  29.581288617418487, 17.623211812968144, 25.910894656704624, \
0.921191970452753}, 
  {6.754372906508179, 5.348441869403339,\\
  29.721168113061104, 17.623211812968123, 25.910894656704603, \
0.9211919704527519}, 
  {6.506783635707484, 5.027942643124969,\\
  29.825214385832357, 17.623211812968087, 25.91089465670456, \
0.9211919704527506}, 
  {6.24636257808505, 4.71344729246551,\\
  29.894587833097642, 17.623211812968062, 25.91089465670453, \
0.9211919704527496}, 
  {5.976429995936515, 4.408271150295602,\\
  29.930984778930046, 17.623211812968044, 25.910894656704507, \
0.921191970452748}, 
  {5.70030484676704, 4.115198114336059,\\
  29.936519797566042, 17.62321181296802, 25.910894656704478, \
0.921191970452747}, 
  {5.4212112762332465, 3.8364486129279474,\\
  29.913603874645325, 17.623211812968005, 25.910894656704436, \
0.9211919704527458}, 
  {5.142195983788856, 3.5736784863687867,\\
  29.86482694371018, 17.62321181296797, 25.91089465670439, \
0.9211919704527445}, 
  {4.866059994968984, 3.328004184003559,\\
  29.79285158765624, 17.623211812967952, 25.910894656704368, \
0.9211919704527436}, 
  {4.595306936521163, 3.100048343537733,\\
  29.70032254267415, 17.62321181296793, 25.910894656704333, \
0.9211919704527423}, 
  {4.332108492034365, 2.889999340554123,\\
  29.58979444132861, 17.62321181296791, 25.910894656704304, \
0.9211919704527414}, 
  {4.078286463994472, 2.6976786444429295,\\
  29.463678266616277, 17.623211812967895, 25.910894656704276, \
0.9211919704527401}, 
  {3.8353098820648603, 2.522610589686628,\\
  29.324205441431534, 17.623211812967874, 25.910894656704244, \
0.9211919704527392}, 
  {3.604304922372383, 2.3640902464074443,\\
  29.17340742223443, 17.62321181296785, 25.91089465670421, \
0.9211919704527378}, 
  {3.3860750368623513, 2.2212462508160136,\\
  29.01310808755264, 17.623211812967824, 25.910894656704176, \
0.9211919704527363}, 
  {3.1811285984881277, 2.09309658076479,\\
  28.84492603745211, 17.6232118129678, 25.910894656704144, \
0.9211919704527349}, 
  {2.989711489611714, 1.978596234808884,\\
  28.670284046336594, 17.623211812967778, 25.9108946567041, \
0.9211919704527337}, 
  {2.8118423326997126, 1.8766765464174078,\\
  28.490423231315194, 17.623211812967742, 25.910894656704066, \
0.9211919704527326}, 
  {2.6473484223197974, 1.7862764292313653,\\
  28.306419917451013, 17.62321181296771, 25.910894656704034, \
0.9211919704527312}, 
  {2.495900813080812, 1.7063662218586368,\\
  28.11920362611573, 17.623211812967686, 25.910894656703995, \
0.9211919704527298}, 
  {2.3570474093902316, 1.6359650132050563,\\
  27.929575033135055, 17.623211812967668, 25.910894656703956, \
0.9211919704527287}, 
  {2.230243262288729, 1.574152418205754,\\
  27.73822310994159, 17.623211812967636, 25.910894656703917, \
0.9211919704527275}, 
  {2.114877590017588, 1.5200757741292716,\\
  27.545740960539927, 17.623211812967615, 25.910894656703878, \
0.9211919704527263}, 
  {2.0102972952843663, 1.4729536696621535,\\
  27.35264009831823, 17.6232118129676, 25.910894656703853, \
0.921191970452725}, 
  {1.915826952913666, 1.4320766268652894,\\
  27.159363075387, 17.623211812967586, 25.910894656703814, \
0.9211919704527238}, 
  {1.8307853905400675, 1.3968056477780437,\\
  26.966294492655535, 17.62321181296756, 25.910894656703782, \
0.9211919704527226}, 
  {1.7544990885373621, 1.3665692254510604,\\
  26.773770491941022, 17.623211812967526, 25.910894656703757, \
0.9211919704527213}, 
  {1.6863126908839776, 1.3408593116342207,\\
  26.582086872331818, 17.623211812967504, 25.91089465670372, \
0.9211919704527198}, 
  {1.6255969536579669, 1.3192266350180242,\\
  26.391505990833593, 17.623211812967476, 25.910894656703697, \
0.9211919704527185}, 
  {1.5717544693638639, 1.3012756772187755,\\
  26.20226260943808, 17.62321181296745, 25.91089465670366, \
0.9211919704527171}, 
  {1.524223499521224, 1.2866595393807831,\\
  26.014568842942285, 17.623211812967423, 25.910894656703622, \
0.9211919704527156}, 
  {4.114887995372978, 4.043097622453626,\\
  23.681732248969258, 17.60714643344015, 25.682166728206102, \
0.9339746584027164}, 
  {4.102274711720162, 4.084955035785072,\\
  23.626998607903694, 17.607146433440118, 25.68216672820606, \
0.9339746584027152}, 
  {4.099274568856865, 4.128358418904451,\\
  23.574154208177475, 17.607146433440093, 25.682166728206024, \
0.9339746584027138}, 
  {4.10446030131704, 4.173383266662008,\\
  23.523904509734347, 17.607146433440064, 25.682166728206, \
0.9339746584027124}, 
  {4.116671016279376, 4.22006232147532,\\
  23.47684853183568, 17.607146433440043, 25.682166728205974, \
0.9339746584027111}, 
  {4.1349573304828775, 4.268385226422524,\\
  23.43350249354674, 17.60714643344002, 25.68216672820594, \
0.9339746584027098}, 
  {4.158536205792028, 4.3182998526516565,\\
  23.39431684006895, 17.607146433439993, 25.682166728205903, \
0.9339746584027084}, 
  {4.186754048349862, 4.369714340608856,\\
  23.359688411168833, 17.60714643343997, 25.682166728205864, \
0.933974658402707}, 
  {4.219056724568284, 4.422499321779213,\\
  23.329968978621775, 17.60714643343996, 25.682166728205836, \
0.9339746584027058}, 
  {4.254965294205286, 4.476490058190173,\\
  23.305471022215116, 17.60714643343994, 25.682166728205804, \
0.9339746584027049}, 
  {4.294056428753857, 4.531488404838289,\\
  23.28647137015894, 17.607146433439915, 25.682166728205765, \
0.9339746584027036}, 
  {4.335946650707637, 4.5872646017216985,\\
  23.273213162871432, 17.60714643343988, 25.682166728205704, \
0.9339746584027024}, 
  {4.380279684521831, 4.643558961244841,\\
  23.265906485175005, 17.607146433439862, 25.682166728205658, \
0.9339746584027012}, 
  {4.426716348011071, 4.7000835489288475,\\
  23.26472793518404, 17.60714643343983, 25.68216672820563, 0.9339746584027}, 
  {4.474926531912313, 4.756523970419701,\\
  23.26981934795016, 17.6071464334398, 25.682166728205598, \
0.933974658402699}, 
  {4.524582915776938, 4.812541381719931,\\
  23.28128586092048, 17.607146433439777, 25.68216672820556, \
0.9339746584026976}, 
  {4.575356151602171, 4.86777483583512,\\
  23.299193491247877, 17.60714643343976, 25.682166728205516, \
0.9339746584026962}, 
  {4.6269113143849685, 4.921844069445293,\\
  23.323566388104215, 17.607146433439738, 25.68216672820547, \
0.933974658402695}, 
  {4.678905472809689, 4.974352818587545,\\
  23.35438392334783, 17.60714643343972, 25.682166728205434, \
0.9339746584026938}, 
  {4.730986275121749, 5.024892732894077,\\
  23.39157778861421, 17.607146433439702, 25.682166728205395, \
0.9339746584026927}, 
  {4.782791476210577, 5.073047933635391,\\
  23.435029273801643, 17.607146433439674, 25.682166728205363, \
0.933974658402691}, 
  {4.833949353101021, 5.1184002316287005,\\
  23.484566908772013, 17.60714643343964, 25.682166728205335, \
0.9339746584026898}, 
  {4.884079968307986, 5.160534987134923,\\
  23.539964654669106, 17.60714643343962, 25.682166728205313, \
0.9339746584026886}, 
  {4.932797244587812, 5.199047555686338,\\
  23.600940831390545, 17.60714643343961, 25.682166728205285, \
0.9339746584026871}, 
  {4.979711811221558, 5.233550222344904,\\
  23.667157961342, 17.607146433439578, 25.682166728205246, \
0.9339746584026862}, 
  {5.024434571838006, 5.2636794837395,\\
  23.73822369477443, 17.607146433439542, 25.68216672820521, \
0.9339746584026849}, 
  {5.06658092781655, 5.289103494515353,\\
  23.813692957252417, 17.607146433439524, 25.682166728205164, \
0.9339746584026838}, 
  {5.1057755706125345, 5.309529455256805,\\
  23.89307142419802, 17.607146433439517, 25.68216672820514, \
0.9339746584026821}, 
  {5.141657732310587, 5.324710685658716,\\
  23.975820380853225, 17.60714643343949, 25.682166728205104, \
0.9339746584026805}, 
  {5.173886758035752, 5.334453103097455,\\
  24.061362969229055, 17.607146433439464, 25.68216672820507, \
0.9339746584026798}, 
  {5.202147838532692, 5.338620816102877,\\
  24.1490917585822, 17.607146433439443, 25.68216672820504, \
0.9339746584026786}, 
  {5.226157718488025, 5.337140547450147,\\
  24.238377505741138, 17.607146433439418, 25.68216672820501, \
0.9339746584026773}, 
  {5.245670178365192, 5.330004624749205,\\
  24.328578900303636, 17.607146433439393, 25.68216672820498, \
0.9339746584026761}, 
  {5.260481076942466, 5.317272318383594,\\
  24.419053022282093, 17.607146433439382, 25.68216672820495, \
0.9339746584026746}, 
  {5.270432740438519, 5.299069366795574,\\
  24.50916618156024, 17.607146433439357, 25.68216672820491, \
0.9339746584026735}, 
  {5.27541749364829, 5.275585605084329,\\
  24.598304764869315, 17.60714643343932, 25.682166728204876, \
0.9339746584026724}, 
  {5.2753801497737935, 5.247070700624286,\\
  24.685885691583046, 17.607146433439304, 25.682166728204834, \
0.933974658402671}, 
  {5.2703193086292455, 5.213828093367459,\\
  24.771366077939643, 17.607146433439276, 25.6821667282048, \
0.9339746584026698}, 
  {5.2602873566539206, 5.176207332041152,\\
  24.854251732066402, 17.607146433439244, 25.68216672820478, \
0.9339746584026686}, 
  {5.245389114708772, 5.134595083500861,\\
  24.934104149076685, 17.607146433439226, 25.682166728204738, \
0.9339746584026677}, 
  {5.22577913808912, 5.089405164220845,\\
  25.01054574400308, 17.607146433439205, 25.68216672820468, \
0.9339746584026665}, 
  {5.201657733983731, 5.041067994483122,\\
  25.083263145859117, 17.607146433439194, 25.68216672820466, \
0.9339746584026652}, 
  {5.173265820781166, 4.990019903108709,\\
  25.152008472490717, 17.607146433439176, 25.682166728204603, \
0.9339746584026638}, 
  {5.1408788071671525, 4.936692711552332,\\
  25.216598605902014, 17.60714643343915, 25.682166728204574, \
0.9339746584026627}, 
  {5.104799713222119, 4.8815040011958395,\\
  25.276912583999035, 17.607146433439123, 25.68216672820454, \
0.9339746584026617}, 
  {5.065351787771419, 4.824848419343656,\\
  25.332887310321926, 17.607146433439105, 25.68216672820451, \
0.933974658402661}, 
  {5.022870894099964, 4.7670903122814225,\\
  25.38451185271231, 17.607146433439084, 25.682166728204486, \
0.9339746584026596}, 
  {4.977697939001676, 4.70855789369237,\\
  25.431820651115498, 17.607146433439066, 25.68216672820446, \
0.9339746584026586}, 
  {4.930171608360885, 4.649539070274769,\\
  25.474885981994294, 17.60714643343904, 25.68216672820442, \
0.9339746584026573}, 
  {4.880621647513333, 4.590278960050018,\\
  25.513810032288088, 17.60714643343902, 25.682166728204376, \
0.9339746584026556}, 
  {11.394476747015206, 7.267978967347744,\\
  35.66957390852307, 17.6593671942563, 26.359071937844476, \
0.9789834098636095}, 
  {10.665788606443062, 6.134337739018949,\\
  36.14860062987553, 17.659367194256276, 26.35907193784444, \
0.9789834098636081}, 
  {9.865849362512868, 5.028715767191892,\\
  36.4491498958234, 17.659367194256255, 26.35907193784441, \
0.9789834098636064}, 
  {9.012180871921402, 3.9827423561779183,\\
  36.588853847981525, 17.659367194256237, 26.359071937844373, \
0.9789834098636051}, 
  {8.124791482870418, 3.0207376869592384,\\
  36.59040949017328, 17.65936719425621, 26.35907193784434, \
0.9789834098636035}, 
  {7.2244441666206285, 2.1590035748455123,\\
  36.47901188180219, 17.65936719425618, 26.359071937844305, \
0.9789834098636023}, 
  {6.331106908506984, 1.4060855811202229,\\
  36.27994128272589, 17.65936719425616, 26.35907193784426, \
0.9789834098636012}, 
  {5.462724399585803, 0.7637731105769395,\\
  36.016639949316314, 17.659367194256134, 26.359071937844227, \
0.9789834098636001}, 
  {4.634384160251525, 0.22852340118209,\\
  35.70944134191873, 17.65936719425611, 26.359071937844192, \
0.9789834098635987}, 
  {3.857881803543134, -0.20699242327134373,\\
  35.37495259453611, 17.65936719425608, 26.35907193784415, \
0.978983409863597}, 
  {3.1416360733962487, -0.5524499752792208,\\
  35.025979107640396, 17.659367194256053, 26.359071937844135, \
0.9789834098635954}, 
  {2.4908727425441994, -0.8186732991452363,\\
  34.671828829571346, 17.659367194256046, 26.3590719378441, \
0.9789834098635939}, 
  {1.907987153742361, -1.0167271159926452,\\
  34.31883259201429, 17.659367194256028, 26.359071937844067, \
0.9789834098635927}, 
  {1.393002506875198, -1.1572890276685446,\\
  33.97094593586434, 17.659367194255996, 26.359071937844018, \
0.9789834098635913}, 
  {0.9440575899879243, -1.2502580705252055,\\
  33.63033826309956, 17.659367194255974, 26.359071937843982, \
0.97898340986359}, 
  {0.5578771076211873, -1.3045445571692378,\\
  33.297913857028796, 17.65936719425596, 26.35907193784397, \
0.9789834098635886}, 
  {0.2301957698931129, -1.3279883780545627,\\
  32.97373986477736, 17.659367194255946, 26.359071937843943, \
0.9789834098635871}, 
  {-0.043878279551798946, -1.3273618559875566,\\
  32.65737715794798, 17.65936719425591, 26.35907193784391, \
0.9789834098635857}, 
  {-0.2695648348600552, -1.308424007516702,\\
  32.34812223179414, 17.65936719425588, 26.359071937843872, \
0.9789834098635842}, 
  {-0.4521753718374405, -1.2760029601318292,\\
  32.04517414445185, 17.65936719425586, 26.359071937843847, \
0.978983409863583}, 
  {-0.5969330778393762, -1.234091183744852,\\
  31.74774212536035, 17.659367194255843, 26.35907193784381, \
0.9789834098635817}, 
  {-0.7088414610120826, -1.1859439560788927,\\
  31.455108660272366, 17.65936719425582, 26.359071937843773, \
0.9789834098635805}, 
  {-0.7925935119453268, -1.1341753939844603,\\
  31.166660833698515, 17.659367194255807, 26.359071937843744, \
0.9789834098635791}, 
  {-0.8525138149154439, -1.08084889417097,\\
  30.881900270439274, 17.65936719425578, 26.359071937843712, \
0.9789834098635776}, 
  {-0.8925267963242657, -1.0275603672562188,\\
  30.6004396222984, 17.65936719425575, 26.35907193784367, \
0.9789834098635762}, 
  {-0.9161452192212505, -0.9755135625202171,\\
  30.32199142487015, 17.65936719425572, 26.35907193784364, \
0.9789834098635747}, 
  {-0.926473951657915, -0.9255873132003116,\\
  30.046353393122324, 17.659367194255704, 26.35907193784361, \
0.9789834098635732}, 
  {-0.926224886565514, -0.8783948443961557,\\
  29.773392843294612, 17.659367194255687, 26.359071937843567, \
0.9789834098635718}, 
  {-0.9177396453607258, -0.8343354747345734,\\
  29.503031889953412, 17.659367194255662, 26.35907193784353, \
0.9789834098635702}, 
  {-0.903017351782567, -0.7936391629283381,\\
  29.23523431960148, 17.65936719425563, 26.359071937843503, \
0.9789834098635691}, 
  {-0.88374532209303, -0.7564044288769192,\\
  28.969994529710906, 17.659367194255616, 26.359071937843474, \
0.9789834098635679}, 
  {-0.8613309921548423, -0.7226302289637452,\\
  28.707328590731176, 17.65936719425559, 26.35907193784344, \
0.9789834098635668}, 
  {-0.8369338010745239, -0.6922423925305909,\\
  28.447267291293805, 17.659367194255577, 26.35907193784339, \
0.9789834098635654}, 
  {-0.8114960843705932, -0.6651152341847666,\\
  28.189850924273145, 17.659367194255566, 26.35907193784336, \
0.9789834098635639}, 
  {-0.7857723051986134, -0.6410889470247039,\\
  27.935125532495615, 17.65936719425554, 26.35907193784333, \
0.9789834098635628}, 
  {-0.7603561772222656, -0.6199833576891509,\\
  27.68314033414133, 17.659367194255523, 26.3590719378433, \
0.9789834098635614}, 
  {-0.735705413647471, -0.6016085883482889,\\
  27.433946072127473, 17.6593671942555, 26.35907193784326, \
0.9789834098635598}, 
  {-0.7121639795211512, -0.5857731265580784,\\
  27.187594067134203, 17.659367194255477, 26.35907193784322, \
0.9789834098635584}, 
  {-0.6899818339626251, -0.5722897544206467,\\
  26.944135792661637, 17.659367194255452, 26.359071937843186, \
0.9789834098635569}, 
  {-0.6693322304748435, -0.5609797365671574,\\
  26.703622827861494, 17.659367194255438, 26.359071937843147, \
0.9789834098635555}, 
  {-0.6503267014283873, -0.5516756144938632,\\
  26.466107077309637, 17.659367194255413, 26.35907193784311, \
0.9789834098635539}, 
  {-0.6330278913874494, -0.5442229046120728,\\
  26.231641175271104, 17.659367194255385, 26.35907193784308, \
0.9789834098635526}, 
  {-0.6174604269072799, -0.5384809503782106,\\
  26.000279015178045, 17.659367194255363, 26.359071937843044, \
0.9789834098635509}, 
  {-0.6036200211016916, -0.5343231359390078,\\
  25.77207636334941, 17.65936719425535, 26.359071937843012, \
0.9789834098635497}, 
  {-0.5914810125471177, -0.5316366303449105,\\
  25.547091530050945, 17.65936719425533, 26.359071937842977, \
0.9789834098635484}, 
  {-0.5810025324183432, -0.5303217977153218,\\
  25.3253860815406, 17.659367194255303, 26.359071937842955, \
0.9789834098635471}, 
  {-0.572133483193803, -0.5302913797021183,\\
  25.10702558446846, 17.659367194255292, 26.359071937842927, \
0.9789834098635458}, 
  {-0.564816498500404, -0.5314695319406004,\\
  24.89208037953256, 17.659367194255267, 26.3590719378429, \
0.9789834098635445}, 
  {-0.5589910380229625, -0.5337907755362559,\\
  24.680626385165628, 17.659367194255235, 26.359071937842867, \
0.9789834098635432}, 
  {-0.5545957549155026, -0.5371989075851995,\\
  24.472745934676023, 17.659367194255207, 26.359071937842835, \
0.9789834098635418}, 
  {-3.8686789832982242, -4.738901009020465,\\
  11.87884728343222, 17.661477408485446, 26.55338255974836, \
1.1010436524758624}, 
  {-4.022386956755713, -5.2592136811542005,\\
  11.931480834071152, 17.661477408485414, 26.553382559748325, \
1.101043652475861}, 
  {-4.24081275064172, -5.794726669653325,\\
  12.012007101517703, 17.661477408485407, 26.553382559748286, \
1.1010436524758593}, 
  {-4.515204952818826, -6.353323954085358,\\
  12.126512944544336, 17.661477408485386, 26.55338255974824, \
1.1010436524758578}, 
  {-4.83975576788009, -6.94091883639696,\\
  12.281866787896492, 17.661477408485364, 26.55338255974821, \
1.101043652475856}, 
  {-5.21073048370818, -7.561703782193312,\\
  12.485839515548351, 17.661477408485354, 26.553382559748172, \
1.101043652475855}, 
  {-5.625795741600729, -8.218225337825737,\\
  12.747216453732843, 17.661477408485336, 26.553382559748133, \
1.1010436524758531}, 
  {-6.0834802487732675, -8.9113057661721,\\
  13.075883310634456, 17.66147740848531, 26.5533825597481, \
1.1010436524758518}, 
  {-6.5827172256505815, -9.639824826371923,\\
  13.482864098108024, 17.661477408485275, 26.55338255974806, \
1.10104365247585}, 
  {-7.122429282106519, -10.400371794348075,\\
  13.98028153585314, 17.661477408485254, 26.55338255974802, \
1.1010436524758485}, 
  {-7.701125193966932, -11.186779865950818,\\
  14.58120086917207, 17.661477408485233, 26.55338255974799, \
1.101043652475847}, 
  {-8.316485626205624, -11.989563752278162,\\
  15.299307456334283, 17.661477408485208, 26.553382559747952, \
1.1010436524758458}, 
  {-8.964922612824026, -12.795298299944323,\\
  16.148358891563085, 17.661477408485183, 26.553382559747913, \
1.1010436524758442}, 
  {-9.641107005777092, -13.58600307335438,\\
  17.14134739068142, 17.661477408485165, 26.553382559747895, \
1.101043652475843}, 
  {-10.337470645164325, -14.3386357857117,\\
  18.289313414936167, 17.66147740848515, 26.55338255974785, \
1.1010436524758416}, 
  {-11.04370704824682, -15.024844408851017,\\
  19.599775207956505, 17.661477408485123, 26.553382559747828, \
1.1010436524758398}, 
  {-11.74631676188839, -15.611176819530254,\\
  21.07479095460515, 17.66147740848511, 26.553382559747792, \
1.101043652475838}, 
  {-12.42827059960658, -16.059983131469927,\\
  22.708759610430523, 17.661477408485087, 26.55338255974776, \
1.1010436524758362}, 
  {-13.068892688136058, -16.331244750467885,\\
  24.48619556137489, 17.66147740848506, 26.553382559747735, \
1.1010436524758342}, 
  {-13.644088646823489, -16.385492863795115,\\
  26.379868278770637, 17.66147740848504, 26.553382559747693, \
1.101043652475833}, 
  {-14.127050788093356, -16.187805819012677,\\
  28.349842856204877, 17.661477408485016, 26.553382559747657, \
1.1010436524758311}, 
  {-14.489546847177886, -15.71258881700526,\\
  30.34402260235477, 17.661477408485, 26.553382559747625, \
1.1010436524758296}, 
  {-14.703827078212889, -14.948478265676206,\\
  32.30069409759546, 17.66147740848497, 26.553382559747583, \
1.1010436524758282}, 
  {-14.745061511668267, -13.902384763092668,\\
  34.153240998480236, 17.661477408484952, 26.553382559747536, \
1.101043652475827}, 
  {-14.594059743726978, -12.601559654739424,\\
  35.83663787353975, 17.661477408484938, 26.553382559747508, \
1.1010436524758254}, 
  {-14.239871778942915, -11.09279868575534,\\
  37.294703141032414, 17.661477408484917, 26.553382559747472, \
1.1010436524758238}, 
  {-13.681782789063734, -9.438519894026186,\\
  38.48664190163741, 17.66147740848489, 26.55338255974741, \
1.101043652475822}, 
  {-12.930255263484323, -7.710300783453689,\\
  39.39140678502925, 17.661477408484867, 26.553382559747398, \
1.101043652475821}, 
  {-12.006556184476526, -5.981188589320303,\\
  40.00893279688839, 17.661477408484853, 26.55338255974737, \
1.1010436524758194}, 
  {-10.941087576822008, -4.318376369300506,\\
  40.35816723718979, 17.661477408484835, 26.553382559747334, \
1.1010436524758178}, 
  {-9.770718562563768, -2.7775641205804535,\\
  40.47263963677318, 17.661477408484807, 26.5533825597473, \
1.1010436524758165}, 
  {-8.53559762460149, -1.3996877402397105,\\
  40.3947724326849, 17.66147740848479, 26.55338255974727, \
1.1010436524758147}, 
  {-7.275958391850677, -0.21002866729949476,\\
  40.170135631863786, 17.661477408484743, 26.553382559747224, \
1.1010436524758136}, 
  {-6.029341383535849, 0.7807447692814194,\\
  39.84254479201469, 17.661477408484707, 26.55338255974719, \
1.1010436524758123}, 
  {-4.828497798519258, 1.5742520615017375,\\
  39.45050343709744, 17.66147740848467, 26.553382559747153, \
1.1010436524758112}, 
  {-3.7000785320884964, 2.181443805404717,\\
  39.02513683683039, 17.661477408484647, 26.553382559747117, \
1.1010436524758096}, 
  {-2.664077892200241, 2.6195628288121946,\\
  38.58949987239592, 17.66147740848463, 26.553382559747078, \
1.1010436524758083}, 
  {-1.7339106171203733, 2.909416922974199,\\
  38.15897114416244, 17.661477408484608, 26.55338255974705, \
1.1010436524758067}, 
  {-0.9169538766064231, 3.0731848990856454,\\
  37.742365855589036, 17.661477408484586, 26.553382559747014, \
1.101043652475805}, 
  {-0.2153776149859239, 3.132821295610884,\\
  37.34340316702845, 17.66147740848456, 26.553382559746968, \
1.1010436524758034}, 
  {0.37289299657811403, 3.1090107466647323,\\
  36.9622281360424, 17.66147740848454, 26.553382559746936, \
1.1010436524758018}, 
  {0.8532026456617369, 3.0205618450925678,\\
  36.59678267296298, 17.661477408484515, 26.5533825597469, \
1.1010436524758003}, 
  {1.2332575336184195, 2.884115946475473,\\
  36.24391463281557, 17.661477408484487, 26.553382559746858, \
1.1010436524757985}, 
  {1.5223268225151851, 2.7140621104790728,\\
  35.900190492686235, 17.661477408484462, 26.5533825597468, \
1.101043652475797}, 
  {1.730570448667055, 2.522577634539584,\\
  35.56242844187188, 17.661477408484433, 26.553382559746765, \
1.1010436524757956}, 
  {1.8684929084009567, 2.3197417013122332,\\
  35.22799699650172, 17.661477408484405, 26.553382559746733, \
1.1010436524757936}, 
  {1.946513555973063, 2.1136911877662072,\\
  34.89493503736472, 17.66147740848437, 26.5533825597467, 1.101043652475792}, \

  {1.974640236817924, 1.9108012973286614,\\
  34.56194850470921, 17.661477408484348, 26.55338255974667, \
1.1010436524757905}, 
  {1.9622323803747832, 1.7158807783853804,\\
  34.22833184593592, 17.66147740848432, 26.55338255974664, \
1.101043652475789}, 
  {1.917840328124194, 1.532374412277736,\\
  33.89385228288481, 17.66147740848429, 26.553382559746613, \
1.1010436524757876}, 
  {2.7934490534479264, 6.594064486439787,\\
  30.041160870122397, 17.277298775587347, 26.17748318039832, \
1.108059007402826}, 
  {3.4500650993364093, 6.420190032148226,\\
  29.89253293715628, 17.27729877558732, 26.17748318039829, \
1.1080590074028243}, 
  {3.9630235993332623, 6.227773606259818,\\
  29.782982850072084, 17.277298775587287, 26.17748318039826, \
1.108059007402823}, 
  {4.354008195819062, 6.022463155069895,\\
  29.70029376298159, 17.277298775587273, 26.177483180398227, \
1.1080590074028214}, 
  {4.641916184238562, 5.808568384120398,\\
  29.634445070028523, 17.277298775587255, 26.17748318039819, \
1.10805900740282}, 
  {4.843111406506162, 5.589559225442099,\\
  29.577389555077062, 17.277298775587226, 26.17748318039816, \
1.1080590074028183}, 
  {4.971719419192973, 5.368357517921047,\\
  29.52280610993859, 17.277298775587212, 26.177483180398138, \
1.1080590074028167}, 
  {5.0399217302647115, 5.147496379532879,\\
  29.465856592285245, 17.277298775587184, 26.177483180398106, \
1.1080590074028147}, 
  {5.058226359345809, 4.929199271125033,\\
  29.402958946504423, 17.27729877558716, 26.17748318039807, \
1.1080590074028132}, 
  {5.035704956986138, 4.7154137532213705,\\
  29.331580909007993, 17.277298775587134, 26.177483180398042, \
1.1080590074028114}, 
  {4.98019448166124, 4.5078226553065495,\\
  29.25005521038899, 17.27729877558711, 26.177483180397996, \
1.10805900740281}, 
  {4.898465711858843, 4.307846748807514,\\
  29.15741585116168, 17.2772987755871, 26.177483180397957, \
1.108059007402808}, 
  {4.7963629083052846, 4.116647084394395,\\
  29.053254570068074, 17.277298775587067, 26.177483180397914, \
1.1080590074028067}, 
  {4.678919597644942, 3.93513117163235,\\
  28.93759647171338, 17.27729877558704, 26.177483180397918, \
1.1080590074028047}, 
  {4.5504553024670775, 3.7639645890813496,\\
  28.81079369144741, 17.277298775587017, 26.177483180397886, \
1.108059007402803}, 
  {4.414657474607944, 3.603588012099928,\\
  28.67343587237791, 17.277298775586996, 26.177483180397854, \
1.1080590074028012}, 
  {4.274652143678666, 3.454238740309919,\\
  28.526276108409334, 17.277298775586967, 26.177483180397825, \
1.1080590074027998}, 
  {4.133066021759505, 3.315975381238615,\\
  28.370170890406463, 17.277298775586946, 26.177483180397786, \
1.1080590074027983}, 
  {3.992082095465351, 3.188704241054915,\\
  28.206032504579227, 17.277298775586914, 26.177483180397765, \
1.1080590074027972}, 
  {3.8534901325480417, 3.0722060685836516,\\
  28.03479229009212, 17.277298775586896, 26.177483180397743, \
1.1080590074027958}, 
  {3.718733047998951, 2.9661620073589874,\\
  27.857373173803698, 17.277298775586875, 26.1774831803977, \
1.1080590074027943}, 
  {3.5889497124836804, 2.8701778695466142,\\
  27.674669962096065, 17.277298775586853, 26.17748318039766, \
1.108059007402793}, 
  {3.465014531605539, 2.7838061120143367,\\
  27.48753597479967, 17.277298775586818, 26.177483180397626, \
1.1080590074027916}, 
  {3.347573960407562, 2.7065651411140434,\\
  27.296774742648225, 17.27729877558679, 26.17748318039759, \
1.10805900740279}, 
  {3.2370800244630082, 2.637955783287565,\\
  27.103135644936188, 17.277298775586765, 26.177483180397566, \
1.1080590074027885}, 
  {3.133820878331007, 2.5774749267009613,\\
  26.907312526369186, 17.277298775586743, 26.177483180397523, \
1.1080590074027872}, 
  {3.0379484276076822, 2.5246264641800686,\\
  26.709944491724176, 17.27729877558672, 26.17748318039749, \
1.1080590074027858}, 
  {2.9495030586011124, 2.478929753135886,\\
  26.51161822655131, 17.27729877558669, 26.177483180397456, \
1.1080590074027843}, 
  {2.8684355490842393, 2.4399258594991022,\\
  26.312871326922526, 17.277298775586676, 26.177483180397427, \
1.1080590074027827}, 
  {2.7946262667436863, 2.40718187640158,\\
  26.114196238555984, 17.27729877558665, 26.1774831803974, \
1.108059007402781}, 
  {2.7279017934421845, 2.3802936109385127,\\
  25.91604450471439, 17.277298775586633, 26.17748318039736, \
1.1080590074027794}, 
  {2.668049139902838, 2.358886919767919,\\
  25.718831103615067, 17.27729877558661, 26.17748318039734, \
1.1080590074027774}, 
  {2.6148277351644014, 2.342617951665623,\\
  25.52293872110675, 17.277298775586573, 26.177483180397306, \
1.108059007402776}, 
  {2.567979387589484, 2.3311725266152816,\\
  25.32872185497405, 17.27729877558655, 26.177483180397267, \
1.1080590074027743}, 
  {2.527236419585461, 2.3242648497985026,\\
  25.136510685538624, 17.27729877558652, 26.17748318039723, \
1.1080590074027727}, 
  {2.492328177284441, 2.3216357273340753,\\
  24.9466146753441, 17.277298775586484, 26.177483180397186, \
1.1080590074027716}, 
  {2.462986110262579, 2.3230504204476645,\\
  24.759325880597075, 17.277298775586452, 26.177483180397147, \
1.1080590074027703}, 
  {2.4389476061020234, 2.3282962469964685,\\
  24.57492197042317, 17.277298775586434, 26.177483180397104, \
1.1080590074027687}, 
  {2.4199587513370684, 2.337180014534605,\\
  24.3936689583585, 17.277298775586406, 26.177483180397072, \
1.1080590074027674}, 
  {2.4057761751142395, 2.3495253476554856,\\
  24.215823655047437, 17.277298775586388, 26.177483180397033, \
1.1080590074027656}, 
  {2.396168115636406, 2.3651699542225213,\\
  24.041635852828357, 17.277298775586367, 26.177483180396997, \
1.1080590074027643}, 
  {2.3909148329051293, 2.383962860180499,\\
  23.871350252519086, 17.27729877558635, 26.177483180396962, \
1.1080590074027628}, 
  {2.389808475024438, 2.4057616307181884,\\
  23.705208140843336, 17.27729877558633, 26.177483180396926, \
1.1080590074027612}, 
  {2.392652489844489, 2.430429586377419,\\
  23.543448824004223, 17.27729877558631, 26.177483180396887, \
1.1080590074027599}, 
  {2.3992606593434296, 2.457833016016986,\\
  23.38631081923611, 17.27729877558628, 26.17748318039685, \
1.1080590074027585}, 
  {2.409455821106164, 2.487838384100066,\\
  23.234032801994598, 17.277298775586264, 26.177483180396823, \
1.1080590074027572}, 
  {2.4230683297132343, 2.5203095273719343,\\
  23.086854301963864, 17.277298775586246, 26.17748318039679, \
1.1080590074027559}, 
  {2.439934300893334, 2.5551048354616315,\\
  22.94501613642713, 17.277298775586218, 26.177483180396745, \
1.1080590074027545}, 
  {2.4598936729657384, 2.5920744111506218,\\
  22.808760564901032, 17.2772987755862, 26.177483180396706, \
1.1080590074027532}, 
  {2.482788113421706, 2.6310572089186004,\\
  22.678331144426966, 17.277298775586175, 26.177483180396663, \
1.1080590074027519}, 
  {13.570025367992717, 8.31033662273278,\\
  37.541730481223325, 17.343853182891372, 26.98350156891835, \
1.1188384324547398}, 
  {12.657794756978683, 6.794462836252862,\\
  38.24950379340123, 17.343853182891355, 26.983501568918317, \
1.118838432454738}, 
  {11.641185714418555, 5.30037176108136,\\
  38.68174585787951, 17.343853182891333, 26.983501568918285, \
1.1188384324547365}, 
  {10.542080497234737, 3.885325998342624,\\
  38.866356134040544, 17.3438531828913, 26.98350156891826, \
1.118838432454735}, 
  {9.388491073208, 2.5934702839997605,\\
  38.841824642869355, 17.343853182891277, 26.98350156891823, \
1.1188384324547331}, 
  {8.211215913480276, 1.4538877883549197,\\
  38.6519629301627, 17.343853182891266, 26.98350156891821, \
1.1188384324547318}, 
  {7.0407427702507075, 0.4809178295900405,\\
  38.34074762741401, 17.343853182891245, 26.983501568918182, \
1.11883843245473}, 
  {5.9047466083912035, -0.3237612666999442,\\
  37.948214673872634, 17.34385318289123, 26.983501568918143, \
1.1188384324547285}, 
  {4.8263847681466165, -0.9680690520886112,\\
  37.50787491948182, 17.34385318289121, 26.98350156891811, \
1.1188384324547267}, 
  {3.8234200496766273, -1.4662530633780437,\\
  37.04565623829616, 17.343853182891195, 26.983501568918086, \
1.1188384324547254}, 
  {2.9080630241371717, -1.8359747262494306,\\
  36.580060869991726, 17.343853182891166, 26.983501568918058, \
1.1188384324547238}, 
  {2.0873464463566336, -2.096040689815453,\\
  36.12310083696472, 17.343853182891152, 26.98350156891801, \
1.1188384324547223}, 
  {1.3638272125717832, -2.264838085010125,\\
  35.68159851310405, 17.343853182891145, 26.983501568917966, \
1.118838432454721}, 
  {0.736436930220379, -2.359387481914942,\\
  35.258542474399405, 17.34385318289113, 26.983501568917923, \
1.1188384324547194}, 
  {0.20134833706401575, -2.394866061164969,\\
  34.85430882696133, 17.343853182891113, 26.983501568917898, \
1.1188384324547183}, 
  {-0.24722651163168352, -2.3844500090305147,\\
  34.467659165708085, 17.34385318289108, 26.98350156891786, \
1.118838432454717}, 
  {-0.6163495978726417, -2.339351173978064,\\
  34.09649569519023, 17.343853182891067, 26.98350156891781, \
1.1188384324547151}, 
  {-0.9137960012996068, -2.2689577536968843,\\
  33.73839380176866, 17.34385318289106, 26.983501568917767, \
1.1188384324547134}, 
  {-1.1476147729409565, -2.1810205709228896,\\
  33.39095023286737, 17.34385318289103, 26.98350156891773, \
1.1188384324547118}, 
  {-1.3257983149778587, -2.0818507790758383,\\
  33.051989189386774, 17.343853182891014, 26.983501568917696, \
1.1188384324547103}, 
  {-1.4560433774088712, -1.9765112127510323,\\
  32.71966544635351, 17.34385318289098, 26.983501568917656, \
1.118838432454709}, 
  {-1.5455866501655335, -1.8689935165058795,\\
  32.3924972744032, 17.343853182890964, 26.983501568917625, \
1.1188384324547072}, 
  {-1.6010995306452471, -1.762378558281219,\\
  32.06935485581764, 17.343853182890943, 26.983501568917582, \
1.1188384324547058}, 
  {-1.6286288957929795, -1.6589801578119854,\\
  31.749423293170462, 17.34385318289093, 26.983501568917546, \
1.1188384324547038}, 
  {-1.6335730010665617, -1.5604730957418322,\\
  31.432153704832828, 17.343853182890918, 26.983501568917518, \
1.118838432454702}, 
  {-1.6206836846663712, -1.4680065420162411,\\
  31.117211416191147, 17.3438531828909, 26.98350156891749, \
1.1188384324547007}, 
  {-1.594087784365675, -1.3823039343162826,\\
  30.804426829237276, 17.343853182890882, 26.983501568917443, \
1.1188384324546996}, 
  {-1.5573220847370306, -1.303750192011902,\\
  30.49375204827365, 17.343853182890864, 26.98350156891742, \
1.118838432454698}, 
  {-1.5133772533927494, -1.232467063938908,\\
  30.185224593629886, 17.343853182890832, 26.983501568917394, \
1.118838432454696}, 
  {-1.464747152777803, -1.1683773944778477,\\
  29.87893838853323, 17.34385318289081, 26.98350156891736, \
1.1188384324546945}, 
  {-1.4134806785280378, -1.111259131307581,\\
  29.575021511348837, 17.34385318289079, 26.983501568917337, \
1.1188384324546927}, 
  {-1.3612339137480407, -1.0607899595937997,\\
  29.273619841342946, 17.34385318289077, 26.983501568917312, \
1.1188384324546912}, 
  {-1.3093209264279035, -1.0165835047745764,\\
  28.974885588142847, 17.343853182890747, 26.98350156891728, \
1.1188384324546894}, 
  {-1.2587619912917725, -0.9782180818740862,\\
  28.678969702273097, 17.343853182890715, 26.983501568917248, \
1.118838432454688}, 
  {-1.2103283984466615, -0.9452589749865528,\\
  28.386017255731883, 17.343853182890683, 26.983501568917223, \
1.1188384324546863}, 
  {-1.1645833267833525, -0.9172752051983585,\\
  28.09616501415725, 17.34385318289066, 26.983501568917188, \
1.1188384324546847}, 
  {-1.1219185162239689, -0.8938516926346234,\\
  27.809540566633988, 17.34385318289064, 26.983501568917152, \
1.118838432454683}, 
  {-1.0825866752968658, -0.8745976449828273,\\
  27.526262517645886, 17.343853182890633, 26.983501568917116, \
1.1188384324546812}, 
  {-1.0467297149626442, -0.8591519179972185,\\
  27.24644136829734, 17.343853182890612, 26.983501568917095, \
1.1188384324546798}, 
  {-1.0144030121642549, -0.8471859999489078,\\
  26.970180816587575, 17.34385318289058, 26.983501568917053, \
1.1188384324546785}, 
  {-0.9855959833973447, -0.8384051775070396,\\
  26.697579288727773, 17.343853182890545, 26.983501568917024, \
1.1188384324546772}, 
  {-0.9602492957724638, -0.8325483495237136,\\
  26.42873157686917, 17.34385318289051, 26.983501568916992, \
1.1188384324546758}, 
  {-0.9382690663419506, -0.8293868707130903,\\
  26.163730505813987, 17.34385318289048, 26.983501568916957, \
1.1188384324546745}, 
  {-0.9195384051808054, -0.8287227311330588,\\
  25.902668585288794, 17.343853182890456, 26.983501568916918, \
1.118838432454673}, 
  {-0.9039266485287679, -0.8303863105901408,\\
  25.645639628039714, 17.34385318289043, 26.98350156891689, \
1.1188384324546716}, 
  {-0.8912966092404007, -0.8342338897470902,\\
  25.392740329892778, 17.343853182890403, 26.983501568916846, \
1.11883843245467}, 
  {-0.8815101461953658, -0.8401450514443121,\\
  25.144071818112845, 17.343853182890378, 26.983501568916807, \
1.1188384324546679}, 
  {-0.8744323248878723, -0.8480200658348171,\\
  24.89974118055327, 17.343853182890363, 26.98350156891675, \
1.1188384324546663}, 
  {-0.8699344102450819, -0.8577773204669534,\\
  24.659862991481024, 17.343853182890346, 26.983501568916722, \
1.118838432454665}, 
  {-0.8678959013980614, -0.8693508304331629,\\
  24.424560851508428, 17.34385318289033, 26.9835015689167, \
1.1188384324546632}, 
  {3.649790313191025, 7.771522093378172,\\
  12.990576740848114, 17.47465382923491, 26.92803672564532, \
1.1883936270163729}, 
  {4.370032305733031, 8.202497053396145,\\
  13.11993323869479, 17.47465382923489, 26.928036725645285, \
1.188393627016371}, 
  {5.039541037761653, 8.723838502856427,\\
  13.322812846448397, 17.47465382923487, 26.928036725645246, \
1.1883936270163697}, 
  {5.683050667172563, 9.322040614203203,\\
  13.605122418199937, 17.474653829234843, 26.92803672564522, \
1.188393627016368}, 
  {6.318583913141013, 9.985519219640238,\\
  13.975167879115272, 17.474653829234818, 26.92803672564519, \
1.1883936270163669}, 
  {6.958970180712519, 10.703271705284772,\\
  14.443201087288985, 17.474653829234803, 26.928036725645143, \
1.1883936270163649}, 
  {7.6128609557209295, 11.463659518220425,\\
  15.021027879583057, 17.474653829234793, 26.928036725645118, \
1.1883936270163633}, 
  {8.28535268965726, 12.253274571764365,\\
  15.721553846190767, 17.474653829234775, 26.928036725645097, \
1.188393627016362}, 
  {8.978301107565128, 13.055876186875008,\\
  16.5581667152239, 17.474653829234757, 26.928036725645054, \
1.1883936270163609}, 
  {9.690393686577499, 13.85142054239327,\\
  17.54386457931776, 17.47465382923474, 26.928036725645033, \
1.188393627016359}, 
  {10.417039116056973, 14.615250127346918,\\
  18.69004979868311, 17.474653829234715, 26.928036725645008, \
1.188393627016358}, 
  {11.150134018310451, 15.317565644071287,\\
  20.0049309316312, 17.4746538292347, 26.928036725644976, \
1.1883936270163562}, 
  {11.877778078652636, 15.92336250294036,\\
  21.491521838614517, 17.47465382923467, 26.928036725644933, \
1.1883936270163549}, 
  {12.584028178070588, 16.393066487538125,\\
  23.14531026414313, 17.474653829234633, 26.928036725644898, \
1.1883936270163535}, 
  {13.24880735265965, 16.68412602008389,\\
  24.951795386984653, 17.474653829234608, 26.928036725644848, \
1.1883936270163522}, 
  {13.848109199137932, 16.75377843587846,\\
  26.884260229767072, 17.474653829234583, 26.928036725644805, \
1.1883936270163504}, 
  {14.354651729130143, 16.563066209548918,\\
  28.902321989161173, 17.47465382923456, 26.928036725644763, \
1.1883936270163489}, 
  {14.739120827500033, 16.081908667243017,\\
  30.95192953945448, 17.474653829234548, 26.928036725644706, \
1.1883936270163473}, 
  {14.972084536725324, 15.294647291738038,\\
  32.96745939099388, 17.474653829234523, 26.928036725644674, \
1.1883936270163453}, 
  {15.026542779118044, 14.205061541779878,\\
  34.87630150199495, 17.474653829234494, 26.928036725644628, \
1.1883936270163438}, 
  {14.880907138137138, 12.839563726655621,\\
  36.605781015760556, 17.474653829234473, 26.9280367256446, \
1.188393627016342}, 
  {14.522014797100537, 11.24733494695443,\\
  38.09151548622694, 17.474653829234448, 26.928036725644553, \
1.1883936270163398}, 
  {13.947633472880216, 9.49670195945639,\\
  39.28560767060928, 17.474653829234448, 26.928036725644507, \
1.188393627016338}, 
  {13.167887690193071, 7.668016758330748,\\
  40.16276670649921, 17.474653829234423, 26.92803672564447, \
1.188393627016336}, 
  {12.205184068921453, 5.844365044583795,\\
  40.72279355663187, 17.474653829234413, 26.928036725644432, \
1.1883936270163342}, 
  {11.092521387735635, 4.1021313610659265,\\
  40.98882821891635, 17.4746538292344, 26.928036725644397, \
1.1883936270163329}, 
  {9.870447457766922, 2.5034448647363634,\\
  41.00196559335833, 17.474653829234366, 26.928036725644358, \
1.1883936270163316}, 
  {8.58323306173219, 1.091828995793255,\\
  40.81378540641814, 17.474653829234345, 26.928036725644326, \
1.18839362701633}, 
  {7.274963196867625, -0.10866330288803754,\\
  40.478651639198596, 17.474653829234327, 26.928036725644287, \
1.1883936270163287}, 
  {5.986169894780732, -1.0914646876416865,\\
  40.04730875362286, 17.474653829234295, 26.928036725644247, \
1.1883936270163271}, 
  {4.751407946466569, -1.863784897836305,\\
  39.56261039927328, 17.47465382923428, 26.928036725644205, \
1.1883936270163258}, 
  {3.5979063798909956, -2.442331551860099,\\
  39.05750395572128, 17.474653829234256, 26.928036725644176, \
1.1883936270163244}, 
  {2.5452037671191547, -2.8493312869472525,\\
  38.55489118713079, 17.474653829234228, 26.92803672564415, \
1.1883936270163222}, 
  {1.6055402932019915, -3.1093347916670653,\\
  38.06875744580669, 17.474653829234214, 26.928036725644105, \
1.1883936270163207}, 
  {0.7847360832338147, -3.2469478118587967,\\
  37.6059582149855, 17.47465382923419, 26.92803672564407, 1.188393627016319}, \

  {0.08330891012116669, -3.28540455125266,\\
  37.16817688825282, 17.474653829234157, 26.92803672564403, \
1.1883936270163162}, 
  {-0.5023571285694862, -3.2457940080319863,\\
  36.753734381833915, 17.474653829234136, 26.928036725644002, \
1.1883936270163147}, 
  {-0.9789140824101665, -3.1467327313785622,\\
  36.3590832390041, 17.474653829234114, 26.928036725643967, \
1.188393627016313}, 
  {-1.3550885083852302, -3.00430993404818,\\
  35.97993167331655, 17.474653829234093, 26.928036725643935, \
1.1883936270163116}, 
  {-1.6408789273562179, -2.8321806399717855,\\
  35.612013767617405, 17.474653829234065, 26.928036725643903, \
1.1883936270163098}, 
  {-1.8469100297731984, -2.641729622919964,\\
  35.25155882453047, 17.47465382923404, 26.92803672564386, \
1.1883936270163082}, 
  {-1.9839283832233223, -2.442264414759531,\\
  34.89552637323895, 17.474653829234008, 26.928036725643842, \
1.1883936270163062}, 
  {-2.0624198958204274, -2.241218161224097,\\
  34.541672859437526, 17.474653829233983, 26.928036725643818, \
1.1883936270163047}, 
  {-2.0923294525159593, -2.044354906306234,\\
  34.1885081967652, 17.474653829233954, 26.92803672564379, \
1.1883936270163027}, 
  {-2.0828652971480217, -1.8559745238899394,\\
  33.83518935122897, 17.47465382923394, 26.92803672564377, \
1.1883936270163011}, 
  {-2.042373297551398, -1.679115256561777,\\
  33.481386478610624, 17.474653829233915, 26.928036725643736, \
1.1883936270162994}, 
  {-1.9782684656725325, -1.5157510619850025,\\
  33.12714628201497, 17.474653829233887, 26.928036725643686, \
1.1883936270162976}, 
  {-1.8970128139256413, -1.3669801381401954,\\
  32.77276798509093, 17.47465382923386, 26.928036725643665, \
1.1883936270162958}, 
  {-1.8041298975600282, -1.233200740274886,\\
  32.41869997556543, 17.474653829233834, 26.928036725643626, \
1.1883936270162945}, 
  {-1.7042473989670401, -1.114270824829934,\\
  32.06545980861336, 17.47465382923381, 26.92803672564359, \
1.1883936270162931}, 
  {-2.696024654688543, -6.495140303729093,\\
  24.771905325884735, 17.264596963026236, 26.485867797442026, \
1.2056212089197047}, 
  {-3.3519603129074524, -6.476385068675077,\\
  24.648417637661854, 17.26459696302621, 26.48586779744199, \
1.2056212089197034}, 
  {-3.8912319874027452, -6.473166040046262,\\
  24.568561792833542, 17.26459696302619, 26.48586779744194, \
1.2056212089197018}, 
  {-4.3367340686187905, -6.482890341494531,\\
  24.524901113000553, 17.26459696302617, 26.485867797441905, \
1.2056212089197003}, 
  {-4.706940185640342, -6.502792923587884,\\
  24.511667551829095, 17.26459696302615, 26.485867797441855, \
1.2056212089196987}, 
  {-5.016641649693752, -6.530166760779966,\\
  24.524337274895128, 17.264596963026122, 26.48586779744182, \
1.2056212089196972}, 
  {-5.277597210282792, -6.5624745702431655,\\
  24.559306713550754, 17.264596963026097, 26.485867797441774, \
1.2056212089196958}, 
  {-5.499089060502442, -6.597393980825274,\\
  24.61364725217459, 17.264596963026076, 26.485867797441735, \
1.205621208919695}, 
  {-5.688389916713895, -6.6328273203510335,\\
  24.684919684267243, 17.264596963026055, 26.48586779744171, \
1.2056212089196932}, 
  {-5.851150553551623, -6.666894419368875,\\
  24.771033614975664, 17.26459696302604, 26.485867797441674, \
1.2056212089196918}, 
  {-5.991718720750211, -6.697919034187237,\\
  24.870140732459628, 17.26459696302601, 26.48586779744163, \
1.2056212089196905}, 
  {-6.113400294004517, -6.724414751992364,\\
  24.980553907670362, 17.264596963026, 26.48586779744159, \
1.2056212089196885}, 
  {-6.218672631064789, -6.745073361973037,\\
  25.100686386810303, 17.264596963025973, 26.48586779744154, \
1.2056212089196872}, 
  {-6.309358879841239, -6.758756926141086,\\
  25.229007018823, 17.26459696302596, 26.48586779744151, 1.2056212089196856}, \

  {-6.386770672624553, -6.764493717108201,\\
  25.364008641910353, 17.264596963025944, 26.485867797441475, \
1.2056212089196845}, 
  {-6.451825373105303, -6.761477540598268,\\
  25.504187554421765, 17.264596963025927, 26.485867797441426, \
1.2056212089196818}, 
  {-6.505142884678388, -6.7490695708617485,\\
  25.648032509393744, 17.26459696302591, 26.485867797441394, \
1.2056212089196805}, 
  {-6.54712600521744, -6.726801607842299,\\
  25.79402197033275, 17.264596963025884, 26.485867797441365, \
1.2056212089196794}, 
  {-6.578027430844242, -6.694379567307733,\\
  25.940628504727783, 17.264596963025852, 26.485867797441333, \
1.205621208919678}, 
  {-6.598005765585355, -6.651686014416853,\\
  26.086329217339305, 17.26459696302583, 26.4858677974413, \
1.2056212089196767}, 
  {-6.607172277980733, -6.598780634982472,\\
  26.229621077664767, 17.264596963025802, 26.485867797441266, \
1.2056212089196754}, 
  {-6.605629651628276, -6.535897699208516,\\
  26.369039911716058, 17.264596963025774, 26.485867797441234, \
1.2056212089196743}, 
  {-6.593503596344185, -6.463439801338084,\\
  26.50318174112287, 17.264596963025753, 26.485867797441202, \
1.2056212089196727}, 
  {-6.570967912052615, -6.38196744272329,\\
  26.630725092803097, 17.264596963025724, 26.485867797441177, \
1.2056212089196712}, 
  {-6.538263419868612, -6.292184346925845,\\
  26.75045289492776, 17.264596963025703, 26.485867797441145, \
1.2056212089196698}, 
  {-6.4957110836523375, -6.194918729733601,\\
  26.861272637102253, 17.264596963025664, 26.485867797441102, \
1.2056212089196687}, 
  {-6.4437196278387665, -6.09110106689499,\\
  26.9622336126197, 17.264596963025642, 26.48586779744107, \
1.2056212089196672}, 
  {-6.382787998291592, -5.98173917966885,\\
  27.052540275800666, 17.264596963025603, 26.48586779744103, \
1.2056212089196654}, 
  {-6.31350309476946, -5.8678916675843915,\\
  27.131561024911843, 17.264596963025575, 26.48586779744098, \
1.2056212089196638}, 
  {-6.236533307458962, -5.750640840167765,\\
  27.19883203929416, 17.26459696302556, 26.48586779744095, \
1.2056212089196623}, 
  {-6.152618497052799, -5.631066325104638,\\
  27.254056130700913, 17.264596963025536, 26.485867797440914, \
1.2056212089196607}, 
  {-6.062557150762144, -5.510220460317558,\\
  27.297096884137595, 17.264596963025514, 26.485867797440882, \
1.205621208919659}, 
  {-5.967191511338417, -5.389106423125539,\\
  27.327968635644936, 17.264596963025497, 26.485867797440843, \
1.2056212089196576}, 
  {-5.867391502949664, -5.268659831006778,\\
  27.34682304228655, 17.264596963025475, 26.485867797440797, \
1.2056212089196559}, 
  {-5.764038262060231, -5.149734291017237,\\
  27.353933130301076, 17.26459696302545, 26.485867797440754, \
1.2056212089196543}, 
  {-5.6580080239498365, -5.03309110596631,\\
  27.34967575758805, 17.264596963025422, 26.485867797440722, \
1.2056212089196527}, 
  {-5.550157021449262, -4.919393090544238,\\
  27.334513401973243, 17.2645969630254, 26.48586779744069, \
1.2056212089196512}, 
  {-5.44130793063384, -4.80920223049412,\\
  27.30897609973467, 17.264596963025376, 26.485867797440655, \
1.20562120891965}, 
  {-5.3322382594414, -4.70298074674752,\\
  27.27364422691424, 17.264596963025355, 26.485867797440616, \
1.2056212089196485}, 
  {-5.223670930868939, -4.601095011045003,\\
  27.229132657951865, 17.264596963025326, 26.48586779744058, \
1.2056212089196472}, 
  {-5.116267173157848, -4.503821699996441,\\
  27.176076670259505, 17.264596963025326, 26.485867797440548, \
1.2056212089196452}, 
  {-5.010621703976013, -4.411355565373348,\\
  27.11511980478357, 17.26459696302531, 26.48586779744051, \
1.205621208919644}, 
  {-4.907260090360129, -4.323818230519607,\\
  27.046903752689424, 17.26459696302529, 26.48586779744048, \
1.2056212089196425}, 
  {-4.806638084728746, -4.241267485094298,\\
  26.972060224002334, 17.264596963025266, 26.485867797440438, \
1.205621208919641}, 
  {-4.7091426807158285, -4.163706631656834,\\
  26.891204668252694, 17.264596963025234, 26.485867797440427, \
1.2056212089196392}, 
  {-4.615094599865838, -4.091093527611799,\\
  26.804931659462312, 17.264596963025213, 26.485867797440395, \
1.205621208919637}, 
  {-4.524751908743738, -4.023349056287899,\\
  26.713811725333557, 17.264596963025177, 26.485867797440367, \
1.2056212089196356}, 
  {-4.438314472107975, -3.9603648451271445,\\
  26.618389388987527, 17.264596963025156, 26.485867797440335, \
1.2056212089196345}, 
  {-4.355928967376058, -3.902010122968802,\\
  26.519182196171176, 17.264596963025138, 26.485867797440292, \
1.2056212089196332}, 
  {-4.277694214580146, -3.848137670024715,\\
  26.416680516709665, 17.264596963025113, 26.485867797440257, \
1.205621208919631}, 
  {-3.546881068314682, -4.122101214436246,\\
  22.63573849315088, 17.255325704735707, 26.277700053367077, \
1.1983997174482803}, 
  {-3.646174286104523, -4.209988826085729,\\
  22.510754346675284, 17.255325704735682, 26.27770005336704, \
1.1983997174482788}, 
  {-3.7434771425923374, -4.305154521569507,\\
  22.394742879278876, 17.255325704735654, 26.277700053367, \
1.198399717448277}, 
  {-3.840395002046116, -4.407315016749145,\\
  22.288244575201414, 17.25532570473564, 26.27770005336696, \
1.1983997174482752}, 
  {-3.938205658713675, -4.516205352665258,\\
  22.19180806225596, 17.255325704735615, 26.277700053366914, \
1.198399717448274}, 
  {-4.037919444308539, -4.631561867083722,\\
  22.10600051470516, 17.25532570473559, 26.277700053366882, \
1.198399717448272}, 
  {-4.14032592422259, -4.753107830160956,\\
  22.031413007833226, 17.25532570473557, 26.27770005336684, \
1.1983997174482708}, 
  {-4.24602997858149, -4.880540454542692,\\
  21.968662219944626, 17.25532570473555, 26.2777000533668, \
1.1983997174482692}, 
  {-4.35547935454047, -5.013518563962742,\\
  21.918389321812853, 17.255325704735526, 26.27770005336676, \
1.1983997174482677}, 
  {-4.468985288942098, -5.151650561606909,\\
  21.881256508870013, 17.255325704735498, 26.27770005336673, \
1.1983997174482657}, 
  {-4.586737459669624, -5.294482572801734,\\
  21.857941370402113, 17.255325704735476, 26.277700053366686, \
1.1983997174482643}, 
  {-4.7088142829197235, -5.44148680192797,\\
  21.8491291186944, 17.25532570473545, 26.277700053366633, \
1.1983997174482628}, 
  {-4.835189403142818, -5.592050274282264,\\
  21.855502596548842, 17.255325704735434, 26.277700053366605, \
1.1983997174482617}, 
  {-4.965735104321523, -5.74546424921554,\\
  21.877729929705925, 17.255325704735412, 26.277700053366573, \
1.1983997174482603}, 
  {-5.100223293835502, -5.900914701275635,\\
  21.916449683878824, 17.255325704735395, 26.27770005336654, \
1.198399717448259}, 
  {-5.2383246654213425, -6.057474374720672,\\
  21.972253421521533, 17.25532570473537, 26.277700053366527, \
1.1983997174482575}, 
  {-5.379606629684849, -6.214097021940001,\\
  22.045665631354563, 17.25532570473534, 26.277700053366484, \
1.1983997174482561}, 
  {-5.523530604015027, -6.369614531832099,\\
  22.13712112581643, 17.25532570473532, 26.277700053366445, \
1.1983997174482548}, 
  {-5.6694492731794774, -6.522737729695721,\\
  22.246940169623052, 17.255325704735295, 26.277700053366416, \
1.1983997174482532}, 
  {-5.816604461094679, -6.672061671496445,\\
  22.37530181622446, 17.255325704735267, 26.277700053366388, \
1.198399717448252}, 
  {-5.9641262856382316, -6.816076245030646,\\
  22.52221618402194, 17.255325704735252, 26.27770005336636, \
1.19839971744825}, 
  {-6.11103429258177, -6.953182809015779,\\
  22.68749669072942, 17.255325704735228, 26.27770005336631, \
1.1983997174482486}, 
  {-6.2562412706933825, -7.0817174289557485,\\
  22.870733564393767, 17.255325704735213, 26.277700053366278, \
1.1983997174482468}, 
  {-6.398560425244701, -7.199980989274066,\\
  23.071270236254843, 17.255325704735192, 26.27770005336625, \
1.1983997174482455}, 
  {-6.536716518336606, -7.306276065354628,\\
  23.288184457132058, 17.255325704735178, 26.277700053366207, \
1.1983997174482437}, 
  {-6.669361459079303, -7.398949929544141,\\
  23.5202761203634, 17.255325704735156, 26.277700053366168, \
1.1983997174482421}, 
  {-6.795094634827737, -7.476442461774249,\\
  23.766063770831202, 17.255325704735146, 26.277700053366146, \
1.198399717448241}, 
  {-6.912488011640447, -7.537337079492615,\\
  24.023791583380465, 17.255325704735117, 26.277700053366107, \
1.1983997174482397}, 
  {-7.020115701112083, -7.5804121573697465,\\
  24.291448167962244, 17.255325704735085, 26.27770005336608, \
1.1983997174482384}, 
  {-7.116587305513718, -7.604689859910915,\\
  24.56679788802814, 17.255325704735068, 26.277700053366047, \
1.1983997174482368}, 
  {-7.200583939892169, -7.609478957913621,\\
  24.847424480991318, 17.255325704735053, 26.27770005336602, \
1.1983997174482355}, 
  {-7.270895427046007, -7.5944081403710175,\\
  25.130785704333434, 17.255325704735036, 26.277700053365972, \
1.198399717448234}, 
  {-7.326456817952668, -7.559446645290995,\\
  25.414276601442083, 17.25532570473501, 26.27770005336594, \
1.1983997174482324}, 
  {-7.366382160222362, -7.5049097539577145,\\
  25.695297928124386, 17.255325704734993, 26.277700053365905, \
1.1983997174482306}, 
  {-7.389993371694456, -7.4314478023533495,\\
  25.971325464768704, 17.255325704734965, 26.277700053365876, \
1.1983997174482288}, 
  {-7.396842214069, -7.340018770158035,\\
  26.239975514587698, 17.25532570473495, 26.27770005336585, \
1.1983997174482275}, 
  {-7.3867237188050785, -7.231846054541777,\\
  26.499061970899085, 17.255325704734943, 26.277700053365816, \
1.1983997174482257}, 
  {-7.3596799806846445, -7.108364517509092,\\
  26.746640972640037, 17.25532570473492, 26.277700053365795, \
1.1983997174482244}, 
  {-7.315993956547522, -6.971159092104521,\\
  26.981040314900266, 17.255325704734897, 26.277700053365766, \
1.1983997174482226}, 
  {-7.2561737109513835, -6.821900952220934,\\
  27.200872306233215, 17.255325704734872, 26.277700053365745, \
1.1983997174482206}, 
  {-7.180928340146564, -6.66228636931981,\\
  27.405030459553682, 17.255325704734854, 26.27770005336571, \
1.1983997174482193}, 
  {-7.091137479349764, -6.493982870287597,\\
  27.59267202443767, 17.25532570473484, 26.277700053365674, \
1.1983997174482173}, 
  {-6.987816767336768, -6.3185862523054785,\\
  27.76318968142135, 17.25532570473482, 26.277700053365635, \
1.1983997174482157}, 
  {-6.8720818472053535, -6.13759057160071,\\
  27.916176544469884, 17.255325704734794, 26.277700053365603, \
1.1983997174482144}, 
  {-6.7451134026253845, -5.9523716277589145,\\
  28.051388864774083, 17.25532570473476, 26.277700053365564, \
1.1983997174482128}, 
  {-6.6081253871484185, -5.764182949724145,\\
  28.16871050571608, 17.25532570473475, 26.27770005336553, \
1.1983997174482115}, 
  {-6.462338059305087, -5.574162057366945,\\
  28.268122463570528, 17.25532570473473, 26.277700053365507, \
1.1983997174482097}, 
  {-6.308956772385103, -5.3833439625428685,\\
  28.34967960299804, 17.255325704734695, 26.277700053365475, \
1.198399717448208}, 
  {-6.149156778566436, -5.192678544363701,\\
  28.413495550189516, 17.25532570473467, 26.277700053365447, \
1.1983997174482064}, 
  {-5.984073679953299, -5.003048564531914,\\
  28.459735521536388, 17.255325704734663, 26.277700053365407, \
1.198399717448205}, 
  {-5.977216453477911, -0.9801395284834666,\\
  32.857517023700915, 17.215432732674163, 26.36659986841663, \
1.2079521319737596}, 
  {-5.116997765505661, -0.5822786244406495,\\
  32.519270890829226, 17.215432732674145, 26.36659986841659, \
1.2079521319737578}, 
  {-4.336630986206154, -0.26152943705045056,\\
  32.15642200734849, 17.215432732674124, 26.366599868416554, \
1.2079521319737567}, 
  {-3.6355896325549093, -0.007735983754135402,\\
  31.779790757976613, 17.21543273267409, 26.366599868416518, \
1.2079521319737552}, 
  {-3.011693546428133, 0.18922628428675953,\\
  31.397109628527623, 17.215432732674063, 26.36659986841648, \
1.2079521319737534}, 
  {-2.4613999216468683, 0.3388977554197226,\\
  31.01367873443757, 17.215432732674053, 26.366599868416436, \
1.207952131973752}, 
  {-1.9801391523542984, 0.449916652419261,\\
  30.632961337157155, 17.215432732674017, 26.36659986841639, \
1.2079521319737512}, 
  {-1.562647266920794, 0.5298733423046914,\\
  30.25708729562411, 17.21543273267399, 26.366599868416344, \
1.2079521319737494}, 
  {-1.2032658719358547, 0.5852821720110643,\\
  29.88725570732612, 17.21543273267397, 26.36659986841631, \
1.2079521319737478}, 
  {-0.8961950254955482, 0.6216272992547058,\\
  29.52404250277043, 17.215432732673953, 26.36659986841628, \
1.2079521319737463}, 
  {-0.6356944832980237, 0.6434504494352863,\\
  29.16762617595965, 17.215432732673932, 26.366599868416237, \
1.2079521319737447}, 
  {-0.41623506516159026, 0.6544584278561086,\\
  28.817947344772502, 17.215432732673918, 26.36659986841621, \
1.2079521319737432}, 
  {-0.23260539401141667, 0.6576359519411423,\\
  28.474817391575883, 17.215432732673893, 26.366599868416195, \
1.207952131973742}, 
  {-0.07998082536560935, 0.6553550018253277,\\
  28.137989495742517, 17.215432732673882, 26.366599868416152, \
1.2079521319737405}, 
  {0.046038287816072485, 0.649475772050956,\\
  27.80720289438057, 17.21543273267386, 26.366599868416113, \
1.207952131973739}, 
  {0.14941224617025997, 0.6414368633470204,\\
  27.48220875168404, 17.21543273267384, 26.366599868416074, \
1.2079521319737372}, 
  {0.23366558753182853, 0.6323339626211881,\\
  27.16278385648795, 17.215432732673815, 26.366599868416035, \
1.207952131973736}, 
  {0.3019035279744144, 0.6229872234443194,\\
  26.848736601875377, 17.215432732673793, 26.36659986841599, \
1.2079521319737345}, 
  {0.356837100853691, 0.6139980996047258,\\
  26.53990833152665, 17.21543273267378, 26.36659986841596, \
1.2079521319737334}, 
  {0.4008136837486618, 0.6057966541871681,\\
  26.23617211865352, 17.21543273267375, 26.36659986841593, \
1.207952131973732}, 
  {0.4358503514260481, 0.5986804686068816,\\
  25.937430311341174, 17.215432732673737, 26.366599868415882, \
1.2079521319737303}, 
  {0.4636681289123969, 0.592846276818625,\\
  25.643611668906413, 17.215432732673726, 26.36659986841585, \
1.2079521319737285}, 
  {0.485725744625836, 0.5884153921846615,\\
  25.354668570847668, 17.215432732673705, 26.366599868415815, \
1.2079521319737268}, 
  {0.5032519083855121, 0.585453905199793,\\
  25.07057455671591, 17.215432732673683, 26.36659986841579, \
1.2079521319737252}, 
  {0.5172754751047361, 0.5839885263709496,\\
  24.791322315694167, 17.21543273267366, 26.36659986841575, \
1.2079521319737236}, 
  {0.5286531149970471, 0.58401884058472,\\
  24.516922161889006, 17.21543273267364, 26.366599868415705, \
1.2079521319737219}, 
  {0.5380943076587693, 0.5855266337494659,\\
  24.247400985841203, 17.21543273267363, 26.36659986841567, \
1.2079521319737203}, 
  {0.5461836218565044, 0.5884828532257407,\\
  23.982801650910567, 17.215432732673627, 26.36659986841562, \
1.2079521319737185}, 
  {0.553400345340888, 0.5928526726979495,\\
  23.723182795692264, 17.21543273267359, 26.366599868415577, \
1.207952131973717}, 
  {0.5601355982402886, 0.5985990506894096,\\
  23.46861900433868, 17.215432732673563, 26.366599868415552, \
1.2079521319737154}, 
  {0.5667071069307931, 0.6056851001184542,\\
  23.219201311660832, 17.215432732673552, 26.366599868415527, \
1.2079521319737139}, 
  {0.5733718388645338, 0.6140755238673131,\\
  22.975038016742776, 17.215432732673523, 26.366599868415495, \
1.2079521319737123}, 
  {0.5803367076903966, 0.6237373176976837,\\
  22.736255786088456, 17.2154327326735, 26.366599868415463, \
1.2079521319737105}, 
  {0.5877675561706263, 0.6346398962144696,\\
  22.503001034235876, 17.215432732673477, 26.366599868415427, \
1.2079521319737092}, 
  {0.5957966150987979, 0.6467547590727504,\\
  22.27544157590314, 17.21543273267347, 26.366599868415385, \
1.2079521319737079}, 
  {0.6045286221664828, 0.6600547823362587,\\
  22.053768548877834, 17.215432732673435, 26.366599868415353, \
1.2079521319737068}, 
  {0.614045767425834, 0.6745131929457331,\\
  21.83819861093584, 17.215432732673413, 26.366599868415324, \
1.207952131973705}, 
  {0.6244116130883149, 0.6901022618193771,\\
  21.628976417022905, 17.215432732673374, 26.366599868415285, \
1.2079521319737037}, 
  {0.6356741159320678, 0.7067917324474664,\\
  21.426377384688152, 17.21543273267335, 26.366599868415236, \
1.207952131973702}, 
  {0.6478678613011348, 0.7245469863246581,\\
  21.230710756218407, 17.215432732673325, 26.366599868415197, \
1.2079521319737008}, 
  {0.6610155990722135, 0.743326933670332,\\
  21.042322964920004, 17.21543273267331, 26.36659986841516, \
1.207952131973699}, 
  {0.6751291543672036, 0.7630816072329528,\\
  20.861601310289906, 17.21543273267328, 26.366599868415108, \
1.2079521319736974}, 
  {0.6902097694085914, 0.7837494283160091,\\
  20.68897794208216, 17.21543273267325, 26.366599868415076, \
1.2079521319736963}, 
  {0.7062479178792671, 0.8052541074164643,\\
  20.524934146081584, 17.21543273267324, 26.36659986841504, \
1.2079521319736948}, 
  {0.7232226195521243, 0.827501137127167,\\
  20.370004914212295, 17.215432732673214, 26.366599868415, \
1.207952131973693}, 
  {0.741100270892345, 0.8503738325230158,\\
  20.224783767789017, 17.215432732673186, 26.366599868414962, \
1.2079521319736917}, 
  {0.7598329969370775, 0.8737288746659176,\\
  20.089927784504372, 17.21543273267317, 26.366599868414923, \
1.2079521319736897}, 
  {0.7793565212248236, 0.8973913169433008,\\
  19.966162756270823, 17.21543273267316, 26.36659986841489, \
1.207952131973688}, 
  {0.7995875441880167, 0.9211490228409687,\\
  19.85428837534459, 17.215432732673147, 26.366599868414852, \
1.2079521319736861}, 
  {0.8204206166889083, 0.944746518959346,\\
  19.755183309242284, 17.215432732673122, 26.366599868414824, \
1.2079521319736841}, 
  {-9.391500057502036, -16.595850628564406,\\
  13.949731888404187, 17.26918436487392, 26.413046317358727, \
1.2267652882320963}, 
  {-10.635635096540787, -17.60039789297182,\\
  15.337301196258402, 17.26918436487389, 26.413046317358692, \
1.226765288232095}, 
  {-11.838074630344217, -18.60225730121254,\\
  17.021404012057232, 17.269184364873873, 26.413046317358653, \
1.2267652882320939}, 
  {-13.005664769626206, -19.527568751927426,\\
  19.015682067022773, 17.26918436487386, 26.413046317358628, \
1.2267652882320919}, 
  {-14.131267145149108, -20.293340392475663,\\
  21.323864859616357, 17.269184364873837, 26.41304631735858, \
1.2267652882320905}, 
  {-15.194609370350271, -20.80770070427503,\\
  23.932701896933633, 17.26918436487382, 26.41304631735854, \
1.2267652882320892}, 
  {-16.163028667676226, -20.97348313004804,\\
  26.80444691129218, 17.26918436487379, 26.413046317358514, \
1.2267652882320876}, 
  {-16.99270517466794, -20.69602024852475,\\
  29.87011962975631, 17.269184364873773, 26.413046317358486, \
1.226765288232086}, 
  {-17.631029697578523, -19.895477365608865,\\
  33.025655033474955, 17.269184364873766, 26.41304631735844, \
1.2267652882320845}, 
  {-18.020695736066475, -18.522813256573667,\\
  36.1337034245182, 17.269184364873748, 26.413046317358404, \
1.2267652882320832}, 
  {-18.105844838198436, -16.576546482834427,\\
  39.03369788641692, 17.269184364873723, 26.413046317358376, \
1.2267652882320816}, 
  {-17.840047844960136, -14.115473013685314,\\
  41.561220372397905, 17.269184364873695, 26.413046317358344, \
1.22676528823208}, 
  {-17.19510079782764, -11.261504910744994,\\
  43.57446598402015, 17.269184364873688, 26.41304631735831, \
1.226765288232078}, 
  {-16.168781593954943, -8.18829004013908,\\
  44.98160239392315, 17.26918436487367, 26.413046317358283, \
1.2267652882320765}, 
  {-14.789284963051442, -5.095770722334988,\\
  45.760192638726295, 17.269184364873656, 26.41304631735824, \
1.226765288232075}, 
  {-13.114480030686094, -2.17685086054085,\\
  45.9609850710095, 17.26918436487363, 26.41304631735821, \
1.2267652882320732}, 
  {-11.225528887749116, 0.41350887202044956,\\
  45.693849947769245, 17.269184364873617, 26.413046317358166, \
1.2267652882320714}, 
  {-9.216272954811817, 2.5771798163138095,\\
  45.10090064993522, 17.269184364873595, 26.413046317358138, \
1.2267652882320699}, 
  {-7.181206680736908, 4.275676239235646,\\
  44.326567304377754, 17.26918436487358, 26.413046317358102, \
1.2267652882320683}, 
  {-5.205065290791463, 5.5196519530331996,\\
  43.49394010783883, 17.269184364873546, 26.413046317358067, \
1.226765288232067}, 
  {-3.3560434433662203, 6.351941602846775,\\
  42.692155688890246, 17.269184364873524, 26.41304631735803, \
1.226765288232065}, 
  {-1.6831225223666337, 6.830924721397207,\\
  41.97440290902522, 17.2691843648735, 26.413046317358, 1.2267652882320634}, 
  {-0.21673108282823045, 7.0182121262642925,\\
  41.363028864990376, 17.269184364873478, 26.413046317357967, \
1.2267652882320619}, 
  {1.0285897241084612, 6.971567826823978,\\
  40.857745469663996, 17.269184364873457, 26.413046317357953, \
1.2267652882320605}, 
  {2.050767456649416, 6.74204006161449,\\
  40.44401801218599, 17.269184364873436, 26.413046317357924, \
1.226765288232059}, 
  {2.856881570097004, 6.373656255082695,\\
  40.10011876362398, 17.26918436487341, 26.413046317357892, \
1.2267652882320577}, 
  {3.460370782682705, 5.904247174873251,\\
  39.80237072326141, 17.269184364873386, 26.413046317357868, \
1.226765288232056}, 
  {3.8788665785727288, 5.366471999464639,\\
  39.528662718303195, 17.26918436487337, 26.41304631735783, \
1.2267652882320546}, 
  {4.13257782314535, 4.788597688780971,\\
  39.26052507434577, 17.269184364873343, 26.4130463173578, \
1.2267652882320528}, 
  {4.243088233344059, 4.194923607401236,\\
  38.984087755836484, 17.269184364873325, 26.41304631735777, \
1.2267652882320508}, 
  {4.232434168931041, 3.6059283782322957,\\
  38.69021537619195, 17.26918436487331, 26.413046317357747, \
1.2267652882320492}, 
  {4.122366753206638, 3.03828489925759,\\
  38.37407726327841, 17.269184364873286, 26.41304631735771, \
1.2267652882320477}, 
  {3.9337441973128597, 2.5048830621255087,\\
  38.03437756339361, 17.26918436487327, 26.413046317357672, \
1.2267652882320461}, 
  {3.6860335446714774, 2.0149546321842755,\\
  37.67243624062962, 17.26918436487325, 26.413046317357647, \
1.2267652882320448}, 
  {3.3969207573384197, 1.5743390880641788,\\
  37.291272065968734, 17.26918436487324, 26.41304631735761, \
1.2267652882320434}, 
  {3.0820347450561623, 1.1858815293981095,\\
  36.894793486157035, 17.269184364873222, 26.41304631735758, \
1.2267652882320417}, 
  {2.754788275334921, 0.8499232245722961,\\
  36.48715729195654, 17.269184364873198, 26.413046317357548, \
1.22676528823204}, 
  {2.426331302173159, 0.564833321666022,\\
  36.07231440431746, 17.269184364873176, 26.413046317357505, \
1.2267652882320383}, 
  {2.1056041228618625, 0.3275328632853722,\\
  35.65373155297589, 17.269184364873137, 26.41304631735746, \
1.2267652882320366}, 
  {1.7994715561209595, 0.13397356864416096,\\
  35.234258938757975, 17.269184364873112, 26.413046317357416, \
1.2267652882320346}, 
  {1.5129161773498245, -0.020451799899228355,\\
  34.8161061902672, 17.269184364873084, 26.41304631735738, \
1.226765288232033}, 
  {1.2492685189804205, -0.14057732514888044,\\
  34.40088936416439, 17.269184364873055, 26.413046317357352, \
1.2267652882320312}, 
  {1.0104543312006171, -0.23120968743715656,\\
  33.98971719019597, 17.26918436487303, 26.413046317357328, \
1.2267652882320297}, 
  {0.7972425548764263, -0.2969448009431313,\\
  33.58329238879317, 17.269184364873013, 26.4130463173573, \
1.2267652882320284}, 
  {0.609481717837964, -0.34204496708148874,\\
  33.18201164960436, 17.269184364872984, 26.41304631735726, \
1.2267652882320268}, 
  {0.44631639097477105, -0.3703651501377274,\\
  32.78605456447875, 17.26918436487296, 26.41304631735722, \
1.226765288232025}, 
  {0.3063787524977246, -0.385317441302709,\\
  32.395456960232494, 17.269184364872938, 26.41304631735719, \
1.226765288232024}, 
  {0.18795304374189356, -0.3898640219659399,\\
  32.010167638942995, 17.269184364872917, 26.41304631735714, \
1.2267652882320228}, 
  {0.08911274360957373, -0.3865304786825423,\\
  31.63008972275986, 17.26918436487289, 26.413046317357114, \
1.2267652882320212}, 
  {0.00783171216114361, -0.3774328693918453,\\
  31.255108931110875, 17.269184364872864, 26.413046317357086, \
1.2267652882320192}, 
  {8.129462526835118, 10.038090198270707,\\
  27.63850970509935, 17.282503154582137, 26.35307041526934, \
1.2449097181061135}, 
  {8.459422927764264, 9.833220192073718,\\
  28.110539240993873, 17.28250315458211, 26.353070415269308, \
1.2449097181061117}, 
  {8.696868727277257, 9.586139413258827,\\
  28.592630279097175, 17.282503154582077, 26.35307041526927, \
1.2449097181061106}, 
  {8.850533436792047, 9.29524602351378,\\
  29.07094874552733, 17.28250315458205, 26.353070415269222, \
1.2449097181061084}, 
  {8.927353470447873, 8.961236568660196,\\
  29.532836216713687, 17.28250315458203, 26.353070415269187, \
1.2449097181061064}, 
  {8.933179018465673, 8.586941366813932,\\
  29.966962619185804, 17.28250315458201, 26.353070415269155, \
1.2449097181061044}, 
  {8.873332788706566, 8.177071002241776,\\
  30.363527910118325, 17.282503154581985, 26.353070415269123, \
1.2449097181061028}, 
  {8.753027708197841, 7.737879845093993,\\
  30.714464193658554, 17.282503154581956, 26.35307041526908, \
1.2449097181061013}, 
  {8.577653761852028, 7.276761337822319,\\
  31.013596553601662, 17.282503154581935, 26.353070415269062, \
1.2449097181060995}, 
  {8.352944915092497, 6.801799083991689,\\
  31.256730527973602, 17.282503154581917, 26.353070415269027, \
1.2449097181060982}, 
  {8.085039313796027, 6.321304874606305,\\
  31.441646522850718, 17.282503154581896, 26.353070415269, \
1.2449097181060964}, 
  {7.780449043199575, 5.843377803003139,\\
  31.567995385896833, 17.282503154581875, 26.35307041526897, \
1.2449097181060946}, 
  {7.44595880388157, 5.375516710401249,\\
  31.63710297020519, 17.282503154581857, 26.35307041526893, \
1.244909718106093}, 
  {7.088475076507827, 4.924311681417968,\\
  31.651702809516944, 17.28250315458184, 26.353070415268885, \
1.244909718106091}, 
  {6.714848048458788, 4.495230484619582,\\
  31.615623405312245, 17.282503154581807, 26.353070415268842, \
1.2449097181060893}, 
  {6.331687455767219, 4.092504648830782,\\
  31.53345932403918, 17.28250315458179, 26.353070415268807, \
1.2449097181060877}, 
  {5.945190630594691, 3.7191092945891047,\\
  31.410253510086136, 17.28250315458177, 26.35307041526877, \
1.2449097181060862}, 
  {5.56099685043969, 3.3768225256724027,\\
  31.251212948656512, 17.282503154581743, 26.353070415268743, \
1.2449097181060849}, 
  {5.184077182325818, 3.0663450550881417,\\
  31.06147255052103, 17.282503154581725, 26.353070415268714, \
1.244909718106083}, 
  {4.818664077409033, 2.787458950442475,\\
  30.845914431789435, 17.282503154581704, 26.35307041526868, \
1.2449097181060813}, 
  {4.468220582600081, 2.539205457630864,\\
  30.609042902776885, 17.282503154581683, 26.353070415268657, \
1.244909718106079}, 
  {4.135445595463944, 2.320064943460539,\\
  30.354910264592217, 17.28250315458166, 26.35307041526864, \
1.2449097181060773}, 
  {3.822309278808225, 2.128126128458434,\\
  30.087085239957688, 17.282503154581644, 26.35307041526862, \
1.2449097181060755}, 
  {3.5301115565877255, 1.9612361154179871,\\
  29.80865442404053, 17.28250315458162, 26.35307041526857, \
1.244909718106074}, 
  {3.2595563742365794, 1.8171266462653852,\\
  29.522247161446405, 17.282503154581605, 26.353070415268537, \
1.2449097181060724}, 
  {3.0108348876189073, 1.693515192444525,\\
  29.23007526382807, 17.282503154581583, 26.353070415268505, \
1.2449097181060704}, 
  {2.783711690053678, 1.5881817837937169,\\
  28.93398052275187, 17.282503154581562, 26.35307041526846, \
1.2449097181060689}, 
  {2.5776093649284, 1.4990239517887947,\\
  28.63548467651095, 17.28250315458154, 26.35307041526842, \
1.2449097181060667}, 
  {2.391687878744374, 1.4240929412684233,\\
  28.335838103585854, 17.28250315458152, 26.353070415268384, \
1.2449097181060653}, 
  {2.2249164779517048, 1.3616146011526975,\\
  28.036064894285342, 17.28250315458149, 26.353070415268352, \
1.2449097181060635}, 
  {2.0761367463067137, 1.309998265654958,\\
  27.73700303716703, 17.282503154581477, 26.353070415268327, \
1.2449097181060622}, 
  {1.9441162833740038, 1.2678366239327599,\\
  27.439339248859298, 17.282503154581466, 26.35307041526829, \
1.2449097181060604}, 
  {1.8275930751208014, 1.2338991556153958,\\
  27.143638509952684, 17.28250315458145, 26.353070415268252, \
1.2449097181060587}, 
  {1.725311059491104, 1.2071212573101782,\\
  26.85036869586146, 17.282503154581434, 26.353070415268206, \
1.2449097181060569}, 
  {1.6360476688928274, 1.1865907488162992,\\
  26.559920862305013, 17.282503154581416, 26.353070415268174, \
1.244909718106055}, 
  {1.5586342869794765, 1.1715330543184805,\\
  26.272625807413576, 17.28250315458138, 26.353070415268135, \
1.244909718106053}, 
  {1.491970617810094, 1.1612960156135796,\\
  25.988767524922647, 17.282503154581363, 26.353070415268103, \
1.2449097181060513}, 
  {1.435033957388927, 1.1553350142479781,\\
  25.70859411470892, 17.28250315458135, 26.353070415268057, \
1.2449097181060496}, 
  {1.386884302654643, 1.1531988544499254,\\
  25.432326648794113, 17.28250315458133, 26.35307041526801, \
1.2449097181060478}, 
  {1.3466661488406024, 1.1545166830843627,\\
  25.160166416670627, 17.282503154581317, 26.353070415267975, \
1.2449097181060462}, 
  {1.3136077263266077, 1.1589860894662127,\\
  24.892300901806735, 17.282503154581295, 26.353070415267926, \
1.2449097181060444}, 
  {1.2870183226397942, 1.1663624295160746,\\
  24.628908776047872, 17.282503154581278, 26.353070415267887, \
1.244909718106043}, 
  {1.2662842311503473, 1.1764493486538627,\\
  24.37016414232699, 17.282503154581264, 26.35307041526784, \
1.2449097181060413}, 
  {1.2508637698753964, 1.189090429973644,\\
  24.116240208974975, 17.282503154581246, 26.353070415267798, \
1.24490971810604}, 
  {1.2402817244398248, 1.2041618634574158,\\
  23.867312540380492, 17.28250315458122, 26.35307041526776, \
1.2449097181060385}, 
  {1.2341234900605582, 1.2215660139559972,\\
  23.62356199770751, 17.282503154581185, 26.353070415267727, \
1.2449097181060371}, 
  {1.2320291188489687, 1.2412257568806928,\\
  23.385177458586753, 17.282503154581157, 26.353070415267705, \
1.2449097181060356}, 
  {1.233687420513987, 1.2630794482128602,\\
  23.152358384902453, 17.282503154581118, 26.353070415267663, \
1.2449097181060345}, 
  {1.2388302160087357, 1.287076397372032,\\
  22.92531729184457, 17.2825031545811, 26.35307041526763, 1.244909718106033}, \

  {1.2472268038531311, 1.3131727160352165,\\
  22.70428215826741, 17.282503154581086, 26.35307041526759, \
1.2449097181060316}, 
  {11.156847212638532, 11.435002718518115,\\
  30.326843312892418, 17.386273384637988, 26.790871119322773, \
1.2559726900195793}, 
  {11.205209706191077, 10.926146537569407,\\
  31.221822094767237, 17.386273384637963, 26.790871119322734, \
1.2559726900195778}, 
  {11.156712771383908, 10.320277989949817,\\
  32.05419631937328, 17.386273384637946, 26.790871119322688, \
1.2559726900195762}, 
  {11.011352747475724, 9.629544536949544,\\
  32.803540881687134, 17.386273384637924, 26.79087111932267, \
1.2559726900195745}, 
  {10.771234751990436, 8.870592424981204,\\
  33.452882526967, 17.386273384637903, 26.79087111932266, \
1.2559726900195727}, 
  {10.440988929665284, 8.06342737462316,\\
  33.98978320142615, 17.38627338463788, 26.790871119322617, \
1.2559726900195711}, 
  {10.027915697763664, 7.229960264877112,\\
  34.40704013220594, 17.38627338463786, 26.790871119322567, \
1.2559726900195693}, 
  {9.541852492484647, 6.392400520966096,\\
  34.702895716811945, 17.386273384637832, 26.79087111932253, \
1.2559726900195676}, 
  {8.994784137668319, 5.571695532443175,\\
  34.88073150227487, 17.38627338463782, 26.790871119322492, \
1.2559726900195656}, 
  {8.400249604589934, 4.786206859263784,\\
  34.94830849466946, 17.386273384637793, 26.79087111932246, \
1.2559726900195634}, 
  {7.77262190804004, 4.050765926048692,\\
  34.91668801400647, 17.38627338463777, 26.790871119322425, \
1.2559726900195618}, 
  {7.1263493054827345, 3.3761779557409732,\\
  34.799005936472795, 17.386273384637747, 26.79087111932239, \
1.2559726900195602}, 
  {6.475242522016281, 2.7691640267089928,\\
  34.60927229315822, 17.38627338463772, 26.790871119322365, \
1.2559726900195591}, 
  {5.8318761601311175, 2.2326669735975764,\\
  34.361333851042964, 17.38627338463769, 26.79087111932233, \
1.2559726900195578}, 
  {5.207147625442825, 1.7664094192464252,\\
  34.06808383793587, 17.386273384637665, 26.790871119322286, \
1.255972690019556}, 
  {4.61000990496467, 1.3675836816272187,\\
  33.740946781960844, 17.386273384637647, 26.790871119322254, \
1.2559726900195542}, 
  {4.047370776723659, 1.0315677443068287,\\
  33.38962039122377, 17.386273384637626, 26.79087111932221, \
1.2559726900195531}, 
  {3.524133938243884, 0.7525890447687027,\\
  33.02202704824213, 17.386273384637608, 26.790871119322173, \
1.2559726900195516}, 
  {3.043348229495391, 0.5242887921928845,\\
  32.644415247986295, 17.386273384637587, 26.790871119322148, \
1.25597269001955}, 
  {2.60642882019272, 0.3401668756546527,\\
  32.26155251694894, 17.386273384637562, 26.790871119322112, \
1.2559726900195485}, 
  {2.2134170783740688, 0.19390764886858877,\\
  31.87696080748622, 17.386273384637537, 26.790871119322077, \
1.2559726900195465}, 
  {1.8632516979247529, 0.07959937174683714,\\
  31.493158226154872, 17.38627338463752, 26.790871119322038, \
1.2559726900195451}, 
  {1.5540306677053775, -0.008133971126188815,\\
  31.11188373168878, 17.386273384637505, 26.790871119322, \
1.2559726900195436}, 
  {1.2832504766208588, -0.07406848441709615,\\
  30.734292157486244, 17.386273384637477, 26.790871119321963, \
1.255972690019542}, 
  {1.048014791110781, -0.12236535913387696,\\
  30.361114845697475, 17.38627338463745, 26.79087111932191, \
1.2559726900195403}, 
  {0.8452093959889758, -0.1565894922368799,\\
  29.992786398811507, 17.38627338463743, 26.790871119321878, \
1.2559726900195385}, 
  {0.6716434478375363, -0.1797494209433633,\\
  29.629541037675757, 17.38627338463741, 26.790871119321856, \
1.2559726900195367}, 
  {0.5241592156498041, -0.19434931848163134,\\
  29.27148340148771, 17.386273384637377, 26.79087111932183, \
1.2559726900195352}, 
  {0.39971370839228654, -0.20244639609319398,\\
  28.918638894413174, 17.386273384637366, 26.79087111932179, \
1.2559726900195336}, 
  {0.2954361500263678, -0.20570912914714307,\\
  28.57098832272332, 17.38627338463735, 26.790871119321768, \
1.255972690019532}, 
  {0.20866536623495507, -0.20547330634356953,\\
  28.228490897699547, 17.386273384637327, 26.79087111932174, \
1.2559726900195303}, 
  {0.136970958692622, -0.20279406612823586,\\
  27.891098913827264, 17.38627338463732, 26.7908711193217, \
1.2559726900195287}, 
  {0.07816178526169995, -0.19849291884399023,\\
  27.558766673474008, 17.386273384637303, 26.790871119321665, \
1.2559726900195274}, 
  {0.030284824800373755,\\
  -0.19319933474115203, 27.23145558184395, 17.386273384637274, \
26.790871119321633, 1.2559726900195263}, 
 \\
  {-0.008382958513594482, -0.18738687129345477, 26.909136803400624, \
17.386273384637256, 26.7908711193216, 1.2559726900195245}, 
 \\
  {-0.03934758748407763, -0.1814040688373605, 26.591792453489195, \
17.386273384637235, 26.79087111932157, 1.2559726900195227}, 
 \\
  {-0.06391413362393099, -0.17550049966200845, 26.279415984550937, \
17.38627338463721, 26.790871119321526, 1.2559726900195214}, 
 \\
  {-0.08320449215339809, -0.16984844085781264, 25.972012197977005, \
17.38627338463719, 26.790871119321494, 1.2559726900195192}, 
 \\
  {-0.09817581521280011, -0.1645606765955227, 25.669597152376763, \
17.386273384637164, 26.790871119321473, 1.2559726900195174}, 
 \\
  {-0.1096388194708827, -0.1597049366522434, 25.372198130450503, \
17.386273384637136, 26.790871119321437, 1.2559726900195154}, 
 \\
  {-0.11827540846165574, -0.155315456452453, 25.079853755919686, \
17.38627338463711, 26.7908711193214, 1.2559726900195134}, 
 \\
  {-0.12465523133375833, -0.1514021081532008, 24.79261430803665, \
17.386273384637093, 26.790871119321366, 1.255972690019512}, 
 \\
  {-0.12925094325848108, -0.14795750860472429, 24.51054225563728, \
17.386273384637068, 26.790871119321327, 1.2559726900195103}, 
 \\
  {-0.13245204373102373, -0.14496246286443454, 24.233713019313775, \
17.386273384637043, 26.79087111932129, 1.255972690019509}, 
 \\
  {-0.13457725249902852, -0.14239005451177586, 23.962215964663187, \
17.386273384637015, 26.79087111932126, 1.2559726900195072}, 
 \\
  {-0.13588544360978844, -0.14020864846264305, 23.696155628679353, \
17.386273384637, 26.790871119321235, 1.2559726900195054}, 
 \\
  {-0.1365852003743876, -0.13838402969379307, 23.43565318318334, \
17.38627338463699, 26.790871119321213, 1.2559726900195043}, 
 \\
  {-0.13684308168416626, -0.1368808630509496, 23.180848142430342, \
17.38627338463697, 26.790871119321167, 1.255972690019503}, 
 \\
  {-0.13679070633986812, -0.1356636254858169, 22.931900325878342, \
17.386273384636937, 26.790871119321128, 1.2559726900195012}, 
 \\
  {-0.13653076961713595, -0.13469713269399888, 22.688992091063724, \
17.386273384636908, 26.79087111932109, 1.2559726900194994}, 
 \\
  {7.375917163944143, 11.31006920535992, 15.319139626598115, \
17.483468407992856, 26.8428631662284, 1.2998266955374074}, 
 \\
  {8.063738052953772, 12.046964562630585, 15.954331749428622, \
17.48346840799282, 26.842863166228376, 1.2998266955374058}, 
 \\
  {8.759973153632254, 12.804441042190325, 16.718716600795617, \
17.48346840799281, 26.842863166228344, 1.299826695537404}, 
 \\
  {9.46679858670657, 13.562957319969497, 17.62399183227146, \
17.48346840799278, 26.842863166228323, 1.299826695537402}, 
 \\
  {10.182576442013158, 14.299360980909823, 18.680665611831003, \
17.483468407992753, 26.842863166228295, 1.2998266955374003}, 
 \\
  {10.901894490294026, 14.986218485700455, 19.896714047648512, \
17.483468407992724, 26.842863166228263, 1.2998266955373985}, 
 \\
  {11.615480403185002, 15.591544036114945, 21.27587129977292, \
17.483468407992707, 26.84286316622824, 1.2998266955373965}, 
 \\
  {12.310082716629129, 16.079107687873528, 22.81559548138537, \
17.483468407992675, 26.842863166228213, 1.2998266955373952}, 
 \\
  {12.968426127737674, 16.409537408972202, 24.50484637761743, \
17.483468407992664, 26.842863166228195, 1.2998266955373936}, 
 \\
  {13.569367421625936, 16.542421201427604, 26.321941737830954, \
17.48346840799264, 26.842863166228152, 1.299826695537392}, 
 \\
  {14.088392252947639, 16.43953303616826, 28.232912357061284, \
17.483468407992625, 26.84286316622813, 1.2998266955373905}, 
 \\
  {14.498590037990219, 16.069120909682415, 30.190913149600778, \
17.48346840799259, 26.842863166228092, 1.299826695537389}, 
 \\
  {14.77220921966954, 15.410897841394862, 32.13730016050907, \
17.483468407992575, 26.84286316622805, 1.2998266955373872}, 
 \\
  {14.882814113748452, 14.461004800127093, 34.00486575170323, \
17.483468407992547, 26.842863166228007, 1.2998266955373856}, 
 \\
  {14.807932499727155, 13.23587491176047, 35.7233658780793, \
17.483468407992525, 26.842863166227982, 1.299826695537384}, 
 \\
  {14.531914749067546, 11.77379060016253, 37.22687837576739, \
17.4834684079925, 26.84286316622796, 1.299826695537382}, 
 \\
  {14.048562488626294, 10.133164326187854, 38.46183414117868, \
17.483468407992472, 26.842863166227918, 1.2998266955373805}, 
 \\
  {13.362992770162576, 8.38725912914636, 39.394033191453225, \
17.483468407992454, 26.84286316622788, 1.299826695537379}, 
 \\
  {12.492248346710628, 6.616054300850665, 40.012902122963176, \
17.483468407992426, 26.842863166227836, 1.2998266955373776}, 
 \\
  {11.464375003856656, 4.896890053209028, 40.33183093584647, \
17.483468407992397, 26.842863166227808, 1.2998266955373758}, 
 \\
  {10.316022867245369, 3.295962928395207, 40.384505157205666, \
17.48346840799237, 26.84286316622777, 1.2998266955373738}, 
 \\
  {9.08898173325754, 1.8624519704558902, 40.218294135877485, \
17.48346840799235, 26.842863166227747, 1.2998266955373727}, 
 \\
  {7.826299679477533, 0.6261596798373619, 39.886476065244246, \
17.483468407992326, 26.8428631662277, 1.2998266955373707}, 
 \\
  {6.568673854166359, -0.4015244170278886, 39.44111173218922, \
17.483468407992298, 26.842863166227673, 1.2998266955373692}, 
 \\
  {5.351646459057779, -1.2243285024786237, 38.92782176071032, \
17.48346840799228, 26.842863166227648, 1.2998266955373678}, 
 \\
  {4.203871034522214, -1.8567476191950445, 38.38292411026179, \
17.48346840799225, 26.842863166227612, 1.2998266955373663}, 
 \\
  {3.146444104843456, -2.319737332503638, 37.83270549741954, \
17.48346840799223, 26.84286316622758, 1.2998266955373645}, 
 \\
  {2.193106044841537, -2.6371380446870623, 37.294220773921985, \
17.4834684079922, 26.842863166227534, 1.299826695537363}, 
 \\
  {1.3510301308986497, -2.833091404116792, 36.77693718969674, \
17.483468407992177, 26.842863166227506, 1.2998266955373612}, 
 \\
  {0.6219230030955726, -2.93040683448967, 36.28465756589081, \
17.483468407992163, 26.842863166227488, 1.2998266955373594}, 
 \\
  {0.0032161174937368744, -2.9496828543554123, 35.81734588902117, \
17.483468407992138, 26.842863166227446, 1.2998266955373574}, 
 \\
  {-0.5107992179740226, -2.908951404398439, 35.37265746867627, \
17.483468407992117, 26.842863166227428, 1.2998266955373559}, 
 \\
  {-0.9279742551551742, -2.8236432107264275, 34.94710706004584, \
17.4834684079921, 26.842863166227385, 1.2998266955373539}, 
 \\
  {-1.257474284983551, -2.706726348012413, 34.53688818589932, \
17.48346840799207, 26.84286316622735, 1.2998266955373523}, 
 \\
  {-1.5091195549688659, -2.5689233115005305, 34.138396265086214, \
17.483468407992042, 26.84286316622732, 1.2998266955373508}, 
 \\
  {-1.692879500797797, -2.418953091987732, 33.74852112322398, \
17.48346840799201, 26.842863166227282, 1.2998266955373488}, 
 \\
  {-1.8184977304758199, -2.263772001284465, 33.36477263825425, \
17.483468407991985, 26.84286316622725, 1.2998266955373472}, 
 \\
  {-1.8952246189341926, -2.1088026260790462, 32.98529448842026, \
17.483468407991964, 26.842863166227218, 1.2998266955373456}, 
 \\
  {-1.9316365963848428, -1.9581478558719447, 32.60880983732127, \
17.483468407991932, 26.84286316622718, 1.299826695537344}, 
 \\
  {-1.9355243534636624, -1.8147897126362806, 32.234531751064345, \
17.483468407991914, 26.842863166227136, 1.299826695537342}, 
 \\
  {-1.9138352521847093, -1.6807731355867643, 31.862061352407906, \
17.4834684079919, 26.84286316622711, 1.29982669553734}, 
 \\
  {-1.872657831209716, -1.5573744779424221, 31.491288632135273, \
17.48346840799188, 26.842863166227083, 1.2998266955373383}, 
 \\
  {-1.8172383686509799, -1.4452540645139278, 31.122304544945788, \
17.483468407991865, 26.842863166227062, 1.2998266955373365}, 
 \\
  {-1.752021107187782, -1.3445920551780641, 30.75532840464231, \
17.483468407991843, 26.842863166227026, 1.299826695537334}, 
 \\
  {-1.6807050840945172, -1.2552070875365404, 30.390651443707583, \
17.483468407991815, 26.842863166226998, 1.2998266955373325}, 
 \\
  {-1.6063116536844397, -1.176657627091993, 30.028595446757876, \
17.483468407991797, 26.842863166226955, 1.2998266955373308}, 
 \\
  {-1.531257814412989, -1.1083264970120954, 29.66948432521808, \
17.483468407991783, 26.842863166226934, 1.2998266955373285}, 
 \\
  {-1.4574313933427816, -1.049489574627783, 29.31362610846201, \
17.483468407991747, 26.842863166226895, 1.299826695537327}, 
 \\
  {-1.3862650061031088, -0.9993700520957342, 28.961302857840096, \
17.483468407991722, 26.84286316622686, 1.2998266955373259}, 
 \\
  {-1.3188064954210488, -0.9571799296820377, 28.61276628423295, \
17.483468407991698, 26.842863166226824, 1.2998266955373239}, 
 \\
  {-3.33669321330028, -4.172899424287623, 20.13193428501733, \
17.378761413161293, 26.54321824426025, 1.324967898853682}, 
 \\
  {-3.482060836251917, -4.345086887457746, 20.004499466610355, \
17.378761413161268, 26.543218244260217, 1.32496789885368}, 
 \\
  {-3.632048864095399, -4.5292787274352575, 19.891013411145206, \
17.378761413161254, 26.543218244260178, 1.324967898853678}, 
 \\
  {-3.7879499124235028, -4.7254777782581465, 19.792752697133967, \
17.37876141316123, 26.543218244260142, 1.324967898853676}, 
 \\
  {-3.9508301065924325, -4.933680701714002, 19.71104783262095, \
17.378761413161197, 26.54321824426011, 1.324967898853674}, 
 \\
  {-4.121567930749411, -5.153843370853823, 19.647313620566294, \
17.378761413161172, 26.54321824426007, 1.3249678988536724}, 
 \\
  {-4.300880173455943, -5.3858469786820065, 19.603068023121306, \
17.378761413161158, 26.54321824426004, 1.3249678988536708}, 
 \\
  {-4.489337368341756, -5.629463067476379, 19.579942483286825, \
17.378761413161122, 26.543218244260004, 1.324967898853669}, 
 \\
  {-4.687370391021557, -5.884316350670241, 19.579685050276442, \
17.378761413161097, 26.543218244259965, 1.3249678988536673}, 
 \\
  {-4.895269383503746, -6.149844697036977, 19.60415654329803, \
17.37876141316108, 26.543218244259926, 1.3249678988536653}, 
 \\
  {-5.113175860181582, -6.425256083687791, 19.655319198645433, \
17.37876141316105, 26.5432182442599, 1.3249678988536637}, 
 \\
  {-5.3410686643448955, -6.709482778566685, 19.735216672087017, \
17.378761413161033, 26.543218244259872, 1.324967898853661}, 
 \\
  {-5.578744370910001, -7.001133539436288, 19.845943861554264, \
17.37876141316102, 26.543218244259837, 1.3249678988536593}, 
 \\
  {-5.825792762711391, -7.298445252429379, 19.98960476459007, \
17.378761413161, 26.54321824425982, 1.3249678988536575}, 
 \\
  {-6.081568145003526, -7.59923620008482, 20.168256515304638, \
17.378761413160984, 26.543218244259783, 1.3249678988536557}, 
 \\
  {-6.34515751009518, -7.9008640463627, 20.383837909455337, \
17.378761413160973, 26.54321824425975, 1.324967898853654}, 
 \\
  {-6.615346924849991, -8.200192625002598, 20.63808119883241, \
17.378761413160962, 26.54321824425972, 1.3249678988536515}, 
 \\
  {-6.890587985963061, -8.493572647543475, 20.932406805653397, \
17.378761413160948, 26.543218244259673, 1.3249678988536497}, 
 \\
  {-7.168966757443736, -8.776842384980922, 21.26780196014329, \
17.37876141316093, 26.543218244259645, 1.3249678988536482}, 
 \\
  {-7.448178238524467, -9.045355035896183, 21.64468615940904, \
17.378761413160916, 26.54321824425962, 1.3249678988536464}, 
 \\
  {-7.72551004845794, -9.294039622496895, 22.062768781604632, \
17.378761413160895, 26.543218244259595, 1.3249678988536446}, 
 \\
  {-7.997839564135677, -9.517501552076787, 22.520907060267543, \
17.378761413160873, 26.54321824425956, 1.3249678988536426}, 
 \\
  {-8.261649077483215, -9.710167130922638, 23.016975673085362, \
17.37876141316084, 26.54321824425952, 1.3249678988536409}, 
 \\
  {-8.513063490333446, -9.866473066523465, 23.54776198472114, \
17.37876141316081, 26.54321824425949, 1.3249678988536389}, 
 \\
  {-8.747914457011168, -9.98109725280961, 24.108902872419993, \
17.378761413160777, 26.54321824425946, 1.324967898853637}, 
 \\
  {-8.961833556682162, -10.049221103902486, 24.69487928799132, \
17.378761413160746, 26.54321824425943, 1.324967898853636}, 
 \\
  {-9.150374929647349, -10.066806992977543, 25.29908250197441, \
17.378761413160724, 26.5432182442594, 1.3249678988536342}, 
 \\
  {-9.309164868580618, -10.030868031453243, 25.913960788512824, \
17.3787614131607, 26.543218244259364, 1.3249678988536322}, 
 \\
  {-9.43407232345925, -9.93970293937302, 26.531247096849157, \
17.378761413160674, 26.54321824425932, 1.3249678988536309}, 
 \\
  {-9.521390580739798, -9.793067686717045, 27.142257731070963, \
17.37876141316065, 26.543218244259275, 1.324967898853629}, 
 \\
  {-9.568017137489003, -9.592259194580993, 27.73824081312837, \
17.378761413160625, 26.543218244259243, 1.3249678988536273}, 
 \\
  {-9.571616746215044, -9.340095104692779, 28.310743645750147, \
17.378761413160596, 26.543218244259204, 1.3249678988536255}, 
 \\
  {-9.530752439243207, -9.040786611406437, 28.85196256057125, \
17.378761413160575, 26.54321824425917, 1.3249678988536235}, 
 \\
  {-9.444971469504589, -8.699716369822053, 29.355039434966578, \
17.37876141316054, 26.543218244259133, 1.3249678988536215}, 
 \\
  {-9.314837482341616, -8.3231473108896, 29.814276451369256, \
17.37876141316051, 26.543218244259087, 1.3249678988536193}, 
 \\
  {-9.141906258441852, -7.917897443953843, 30.22525367972148, \
17.378761413160486, 26.54321824425905, 1.3249678988536175}, 
 \\
  {-8.928648957037728, -7.491018022420159, 30.584849783954343, \
17.378761413160458, 26.54321824425901, 1.3249678988536158}, 
 \\
  {-8.678332629171825, -7.0495072793752565, 30.89118075578673, \
17.37876141316044, 26.543218244258973, 1.3249678988536133}, 
 \\
  {-8.3948716906911, -6.600080940641573, 31.143481542767525, \
17.378761413160426, 26.543218244258938, 1.324967898853612}, 
 \\
  {-8.082665360348836, -6.149007138457261, 31.341958722866398, \
17.378761413160394, 26.5432182442589, 1.3249678988536104}, 
 \\
  {-7.7464347818176975, -5.702000908731752, 31.487639034879916, \
17.37876141316036, 26.54321824425887, 1.324967898853609}, 
 \\
  {-7.391070311778071, -5.264165115384317, 31.582230561313455, \
17.378761413160323, 26.54321824425884, 1.3249678988536076}, 
 \\
  {-7.0214953243843805, -4.839961723147294, 31.628003697573906, \
17.37876141316031, 26.54321824425882, 1.3249678988536056}, 
 \\
  {-6.642548956752641, -4.433199338646403, 31.627690682559273, \
17.378761413160294, 26.543218244258785, 1.324967898853604}, 
 \\
  {-6.25888732435492, -4.047028036716236, 31.584397372765874, \
17.378761413160284, 26.543218244258753, 1.3249678988536022}, 
 \\
  {-5.874901232474454, -3.683938383198258, 31.501519673226127, \
17.378761413160262, 26.543218244258714, 1.3249678988536002}, 
 \\
  {-5.494648198951945, -3.3457662960876, 31.382658896784413, \
17.378761413160234, 26.543218244258682, 1.3249678988535987}, 
 \\
  {-5.121797258629454, -3.033707846971081, 31.23153387783809, \
17.37876141316021, 26.543218244258643, 1.324967898853597}, 
 \\
  {-4.7595859959394495, -2.7483481501326796, 31.051891375795446, \
17.378761413160188, 26.54321824425861, 1.324967898853595}, 
 \\
  {-4.410790072613425, -2.4897067143801634, 30.8474190014659, \
17.378761413160152, 26.543218244258576, 1.3249678988535931}, 
 \\
  {-4.414577626390504, 0.055431830293163564, 27.83214817822405, \
17.181695847029985, 26.29180552425168, 1.320306493878301}}]\
\>", "\<\
       \
1            2            3            4            5            6

1      -0.401605    -0.0433301   0.176652     11.          29.          \
3.66667
2      -0.362195    -0.158653    0.170349     11.          29.          \
3.66667
3      -0.339841    -0.261485    0.165057     11.          29.          \
3.66667
4      -0.331264    -0.356861    0.161161     11.          29.          \
3.66667
5      -0.33411     -0.448818    0.159036     11.          29.          \
3.66667
6      -0.346736    -0.540668    0.159093     11.          29.          \
3.66667
7      -0.368051    -0.635214    0.161823     11.          29.          \
3.66667
8      -0.397394    -0.734906    0.167833     11.          29.          \
3.66667
9      -0.434448    -0.841962    0.177889     11.          29.          \
3.66667
10     -0.479178    -0.958467    0.192959     11.          29.          \
3.66667
11     -0.531782    -1.08644     0.21427      11.          29.          \
3.66667
12     -0.592659    -1.2279      0.243378     11.          29.          \
3.66667
13     -0.662386    -1.38488     0.282249     11.          29.          \
3.66667
14     -0.741703    -1.55947     0.333374     11.          29.          \
3.66667
15     -0.831496    -1.75382     0.399891     11.          29.          \
3.66667
16     -0.932793    -1.9701      0.485758     11.          29.          \
3.66667
17     -1.04675     -2.21049     0.59595      11.          29.          \
3.66667
18     -1.17463     -2.47708     0.736705     11.          29.          \
3.66667
19     -1.31779     -2.77174     0.915826     11.          29.          \
3.66667
20     -1.47765     -3.09592     1.14303      11.          29.          \
3.66667
21     -1.65564     -3.45037     1.43036      11.          29.          \
3.66667
22     -1.8531      -3.83468     1.79266      11.          29.          \
3.66667
23     -2.07118     -4.24673     2.24804      11.          29.          \
3.66667
24     -2.31069     -4.68182     2.81844      11.          29.          \
3.66667
25     -2.57183     -5.13158     3.52998      11.          29.          \
3.66667
26     -2.85383     -5.58258     4.41325      11.          29.          \
3.66667
27     -3.15457     -6.01447     5.50316      11.          29.          \
3.66667
28     -3.46989     -6.39791     6.8382       11.          29.          \
3.66667
29     -3.79288     -6.69229     8.45861      11.          29.          \
3.66667
30     -4.1129      -6.84361     10.4032      11.          29.          \
3.66667
31     -4.41453     -6.7834      12.7042      11.          29.          \
3.66667
32     -4.67652     -6.4295      15.3798      11.          29.          \
3.66667
33     -4.8709      -5.69068     18.4252      11.          29.          \
3.66667
34     -4.96272     -4.47672     21.8018      11.          29.          \
3.66667
35     -4.91094     -2.71556     25.4291      11.          29.          \
3.66667
36     -4.67113     -0.377507    29.1816      11.          29.          \
3.66667
37     -4.20047     2.497        32.8964      11.          29.          \
3.66667
38     -3.46537     5.77376      36.3944      11.          29.          \
3.66667
39     -2.45073     9.21703      39.5129      11.          29.          \
3.66667
40     -1.16914     12.5082      42.1397      11.          29.          \
3.66667
41     0.333086     15.2941      44.2332      11.          29.          \
3.66667
42     1.97586      17.2545      45.8151      11.          29.          \
3.66667
43     3.65269      18.1686      46.936       11.          29.          \
3.66667
44     5.24457      17.9591      47.6323      11.          29.          \
3.66667
45     6.63721      16.7043      47.899       11.          29.          \
3.66667
46     7.73764      14.6191      47.6967      11.          29.          \
3.66667
47     8.48689      12.012       46.9882      11.          29.          \
3.66667
48     8.8665       9.22512      45.7838      11.          29.          \
3.66667
49     8.8978       6.57047      44.1668      11.          29.          \
3.66667
50     8.63411      4.27612      42.2871      11.          29.          \
3.66667
51     -20.4875     -27.0918     39.8513      14.1066      27.0881      \
-0.955022
52     -21.4191     -24.206      45.7824      14.1066      27.0881      \
-0.955022
53     -21.8116     -19.9594     51.4051      14.1066      27.0881      \
-0.955022
54     -21.5495     -14.4552     56.2509      14.1066      27.0881      \
-0.955022
55     -20.548      -8.02549     59.9053      14.1066      27.0881      \
-0.955022
56     -18.7814     -1.20134     62.1296      14.1066      27.0881      \
-0.955022
57     -16.3027     5.39217      62.9533      14.1066      27.0881      \
-0.955022
58     -13.2456     11.1848      62.6817      14.1066      27.0881      \
-0.955022
59     -9.80534     15.7859      61.8066      14.1066      27.0881      \
-0.955022
60     -6.20451     19.0287      60.8577      14.1066      27.0881      \
-0.955022
61     -2.65741     20.9267      60.267       14.1066      27.0881      \
-0.955022
62     0.654084     21.5877      60.2946      14.1066      27.0881      \
-0.955022
63     3.5891       21.1377      61.0186      14.1066      27.0881      \
-0.955022
64     6.04453      19.6866      62.3657      14.1066      27.0881      \
-0.955022
65     7.94737      17.3319      64.1559      14.1066      27.0881      \
-0.955022
66     9.24879      14.1865      66.1507      14.1066      27.0881      \
-0.955022
67     9.92298      10.4082      68.1013      14.1066      27.0881      \
-0.955022
68     9.97036      6.21699      69.7965      14.1066      27.0881      \
-0.955022
69     9.4225       1.88806      71.1036      14.1066      27.0881      \
-0.955022
70     8.34545      -2.27623     71.9924      14.1066      27.0881      \
-0.955022
71     6.83844      -5.98748     72.533       14.1066      27.0881      \
-0.955022
72     5.02698      -9.00941     72.8678      14.1066      27.0881      \
-0.955022
73     3.05167      -11.1808     73.1658      14.1066      27.0881      \
-0.955022
74     1.05541      -12.4197     73.5755      14.1066      27.0881      \
-0.955022
75     -0.828015    -12.7146     74.1907      14.1066      27.0881      \
-0.955022
76     -2.48244     -12.1115     75.0357      14.1066      27.0881      \
-0.955022
77     -3.81488     -10.7052     76.0713      14.1066      27.0881      \
-0.955022
78     -4.75903     -8.63397     77.2148      14.1066      27.0881      \
-0.955022
79     -5.27763     -6.07652     78.3686      14.1066      27.0881      \
-0.955022
80     -5.36401     -3.2444      79.4493      14.1066      27.0881      \
-0.955022
81     -5.04228     -0.367839    80.4091      14.1066      27.0881      \
-0.955022
82     -4.3655      2.32431      81.2443      14.1066      27.0881      \
-0.955022
83     -3.41118     4.62636      81.9901      14.1066      27.0881      \
-0.955022
84     -2.27436     6.37434      82.7037      14.1066      27.0881      \
-0.955022
85     -1.05922     7.45838      83.4428      14.1066      27.0881      \
-0.955022
86     0.129952     7.82872      84.2475      14.1066      27.0881      \
-0.955022
87     1.19715      7.49682      85.1303      14.1066      27.0881      \
-0.955022
88     2.06205      6.53278      86.0768      14.1066      27.0881      \
-0.955022
89     2.66592      5.05927      87.0554      14.1066      27.0881      \
-0.955022
90     2.97591      3.24083      88.032       14.1066      27.0881      \
-0.955022
91     2.98712      1.2684       88.9837      14.1066      27.0881      \
-0.955022
92     2.72221      -0.659971    89.9062      14.1066      27.0881      \
-0.955022
93     2.2283       -2.35932     90.8124      14.1066      27.0881      \
-0.955022
94     1.57149      -3.67584     91.7238      14.1066      27.0881      \
-0.955022
95     0.829604     -4.50074     92.6599      14.1066      27.0881      \
-0.955022
96     0.0840965    -4.77944     93.6285      14.1066      27.0881      \
-0.955022
97     -0.588123    -4.5162      94.6234      14.1066      27.0881      \
-0.955022
98     -1.1223      -3.77378     95.6288      14.1066      27.0881      \
-0.955022
99     -1.47224     -2.66714     96.628       14.1066      27.0881      \
-0.955022
100    -1.61493     -1.35028     97.6129      14.1066      27.0881      \
-0.955022
101    2.85068      1.94681      22.4976      17.6314      26.1451      \
0.624413
102    2.69143      2.03138      22.4126      17.6314      26.1451      \
0.624413
103    2.57523      2.11154      22.3276      17.6314      26.1451      \
0.624413
104    2.49369      2.18873      22.2433      17.6314      26.1451      \
0.624413
105    2.44014      2.26412      22.1605      17.6314      26.1451      \
0.624413
106    2.40933      2.33869      22.0797      17.6314      26.1451      \
0.624413
107    2.39709      2.41322      22.0016      17.6314      26.1451      \
0.624413
108    2.40015      2.48834      21.9268      17.6314      26.1451      \
0.624413
109    2.41589      2.56458      21.8556      17.6314      26.1451      \
0.624413
110    2.4423       2.64236      21.7886      17.6314      26.1451      \
0.624413
111    2.47775      2.72199      21.7261      17.6314      26.1451      \
0.624413
112    2.52098      2.80372      21.6687      17.6314      26.1451      \
0.624413
113    2.57099      2.88772      21.6167      17.6314      26.1451      \
0.624413
114    2.62698      2.97412      21.5706      17.6314      26.1451      \
0.624413
115    2.68833      3.06298      21.5307      17.6314      26.1451      \
0.624413
116    2.75453      3.15428      21.4975      17.6314      26.1451      \
0.624413
117    2.82514      3.24797      21.4715      17.6314      26.1451      \
0.624413
118    2.89983      3.34395      21.453       17.6314      26.1451      \
0.624413
119    2.97826      3.44204      21.4424      17.6314      26.1451      \
0.624413
120    3.06017      3.54202      21.4403      17.6314      26.1451      \
0.624413
121    3.14525      3.6436       21.447       17.6314      26.1451      \
0.624413
122    3.23325      3.74644      21.4629      17.6314      26.1451      \
0.624413
123    3.32386      3.8501       21.4884      17.6314      26.1451      \
0.624413
124    3.41678      3.95411      21.5239      17.6314      26.1451      \
0.624413
125    3.51165      4.05792      21.5698      17.6314      26.1451      \
0.624413
126    3.6081       4.16089      21.6262      17.6314      26.1451      \
0.624413
127    3.70569      4.26233      21.6934      17.6314      26.1451      \
0.624413
128    3.80396      4.36147      21.7716      17.6314      26.1451      \
0.624413
129    3.90239      4.4575       21.8609      17.6314      26.1451      \
0.624413
130    4.00038      4.54954      21.9612      17.6314      26.1451      \
0.624413
131    4.09732      4.63667      22.0723      17.6314      26.1451      \
0.624413
132    4.19253      4.71794      22.194       17.6314      26.1451      \
0.624413
133    4.28527      4.79239      22.3258      17.6314      26.1451      \
0.624413
134    4.37477      4.8591       22.4673      17.6314      26.1451      \
0.624413
135    4.46024      4.91714      22.6176      17.6314      26.1451      \
0.624413
136    4.54086      4.96568      22.7759      17.6314      26.1451      \
0.624413
137    4.61581      5.00398      22.9411      17.6314      26.1451      \
0.624413
138    4.68428      5.03141      23.1121      17.6314      26.1451      \
0.624413
139    4.74549      5.0475       23.2875      17.6314      26.1451      \
0.624413
140    4.79871      5.05197      23.466       17.6314      26.1451      \
0.624413
141    4.84332      5.04473      23.646       17.6314      26.1451      \
0.624413
142    4.87876      5.02594      23.826       17.6314      26.1451      \
0.624413
143    4.9046       4.99594      24.0045      17.6314      26.1451      \
0.624413
144    4.92058      4.95536      24.1801      17.6314      26.1451      \
0.624413
145    4.92654      4.90502      24.3513      17.6314      26.1451      \
0.624413
146    4.92255      4.84593      24.5169      17.6314      26.1451      \
0.624413
147    4.90881      4.7793       24.6758      17.6314      26.1451      \
0.624413
148    4.88572      4.70646      24.8273      17.6314      26.1451      \
0.624413
149    4.85382      4.62885      24.9706      17.6314      26.1451      \
0.624413
150    4.81384      4.54792      25.1054      17.6314      26.1451      \
0.624413
151    14.8971      5.62755      39.1656      17.6684      26.3918      \
0.684848
152    13.2594      3.66825      39.7358      17.6684      26.3918      \
0.684848
153    11.5654      1.86205      39.9502      17.6684      26.3918      \
0.684848
154    9.85214      0.275197     39.8923      17.6684      26.3918      \
0.684848
155    8.16172      -1.05762     39.6469      17.6684      26.3918      \
0.684848
156    6.53491      -2.12858     39.2905      17.6684      26.3918      \
0.684848
157    5.00665      -2.94955     38.8844      17.6684      26.3918      \
0.684848
158    3.60359      -3.54444     38.4734      17.6684      26.3918      \
0.684848
159    2.34347      -3.94283     38.086       17.6684      26.3918      \
0.684848
160    1.23565      -4.17541     37.7375      17.6684      26.3918      \
0.684848
161    0.282439     -4.27124     37.4329      17.6684      26.3918      \
0.684848
162    -0.519397    -4.25654     37.1706      17.6684      26.3918      \
0.684848
163    -1.17713     -4.15425     36.9447      17.6684      26.3918      \
0.684848
164    -1.70079     -3.98422     36.7477      17.6684      26.3918      \
0.684848
165    -2.10212     -3.76352     36.5711      17.6684      26.3918      \
0.684848
166    -2.39381     -3.50681     36.4073      17.6684      26.3918      \
0.684848
167    -2.58889     -3.22668     36.2496      17.6684      26.3918      \
0.684848
168    -2.70029     -2.93382     36.0926      17.6684      26.3918      \
0.684848
169    -2.74055     -2.63724     35.9324      17.6684      26.3918      \
0.684848
170    -2.72156     -2.34435     35.7664      17.6684      26.3918      \
0.684848
171    -2.65443     -2.06113     35.5931      17.6684      26.3918      \
0.684848
172    -2.54936     -1.79218     35.412       17.6684      26.3918      \
0.684848
173    -2.41555     -1.54085     35.2233      17.6684      26.3918      \
0.684848
174    -2.26116     -1.30942     35.0276      17.6684      26.3918      \
0.684848
175    -2.09333     -1.09917     34.8259      17.6684      26.3918      \
0.684848
176    -1.91813     -0.910592    34.6193      17.6684      26.3918      \
0.684848
177    -1.74068     -0.743507    34.4088      17.6684      26.3918      \
0.684848
178    -1.56515     -0.597215    34.1955      17.6684      26.3918      \
0.684848
179    -1.39484     -0.47063     33.9804      17.6684      26.3918      \
0.684848
180    -1.23229     -0.362393    33.7644      17.6684      26.3918      \
0.684848
181    -1.07935     -0.270974    33.548       17.6684      26.3918      \
0.684848
182    -0.937284    -0.194755    33.3318      17.6684      26.3918      \
0.684848
183    -0.806837    -0.132095    33.1163      17.6684      26.3918      \
0.684848
184    -0.688342    -0.0813835   32.9018      17.6684      26.3918      \
0.684848
185    -0.581788    -0.0410785   32.6884      17.6684      26.3918      \
0.684848
186    -0.486899    -0.00973222  32.4764      17.6684      26.3918      \
0.684848
187    -0.40319     0.0139905    32.2658      17.6684      26.3918      \
0.684848
188    -0.330031    0.0313028    32.0568      17.6684      26.3918      \
0.684848
189    -0.266689    0.0432916    31.8493      17.6684      26.3918      \
0.684848
190    -0.212369    0.0509191    31.6434      17.6684      26.3918      \
0.684848
191    -0.16625     0.0550262    31.4391      17.6684      26.3918      \
0.684848
192    -0.127506    0.0563401    31.2364      17.6684      26.3918      \
0.684848
193    -0.0953301   0.0554819    31.0353      17.6684      26.3918      \
0.684848
194    -0.0689483   0.0529765    30.8358      17.6684      26.3918      \
0.684848
195    -0.0476314   0.0492615    30.6379      17.6684      26.3918      \
0.684848
196    -0.0307013   0.0446978    30.4416      17.6684      26.3918      \
0.684848
197    -0.0175366   0.0395783    30.2469      17.6684      26.3918      \
0.684848
198    -0.00757338  0.0341374    30.0538      17.6684      26.3918      \
0.684848
199    -0.000306194 0.0285593    29.8623      17.6684      26.3918      \
0.684848
200    0.00471392   0.0229855    29.6724      17.6684      26.3918      \
0.684848
201    -7.01555     -13.5045     17.04        17.8396      26.8369      \
0.852235
202    -8.17316     -14.0568     17.8423      17.8396      26.8369      \
0.852235
203    -9.2225      -14.6514     18.8395      17.8396      26.8369      \
0.852235
204    -10.1906     -15.2422     20.031       17.8396      26.8369      \
0.852235
205    -11.0912     -15.7828     21.4154      17.8396      26.8369      \
0.852235
206    -11.9276     -16.2253     22.9862      17.8396      26.8369      \
0.852235
207    -12.6937     -16.5207     24.7296      17.8396      26.8369      \
0.852235
208    -13.3757     -16.6205     26.6213      17.8396      26.8369      \
0.852235
209    -13.9539     -16.4794     28.6242      17.8396      26.8369      \
0.852235
210    -14.4036     -16.06       30.6875      17.8396      26.8369      \
0.852235
211    -14.6983     -15.3379     32.748       17.8396      26.8369      \
0.852235
212    -14.8114     -14.3071     34.7327      17.8396      26.8369      \
0.852235
213    -14.7204     -12.9844     36.5654      17.8396      26.8369      \
0.852235
214    -14.4096     -11.4112     38.1748      17.8396      26.8369      \
0.852235
215    -13.8736     -9.65153     39.5034      17.8396      26.8369      \
0.852235
216    -13.1193     -7.78613     40.5154      17.8396      26.8369      \
0.852235
217    -12.167      -5.90312     41.2016      17.8396      26.8369      \
0.852235
218    -11.049      -4.08727     41.5797      17.8396      26.8369      \
0.852235
219    -9.80687     -2.41038     41.6894      17.8396      26.8369      \
0.852235
220    -8.48761     -0.924799    41.5847      17.8396      26.8369      \
0.852235
221    -7.13917     0.338866     41.325       17.8396      26.8369      \
0.852235
222    -5.80632     1.37026      40.9665      17.8396      26.8369      \
0.852235
223    -4.52769     2.17523      40.5571      17.8396      26.8369      \
0.852235
224    -3.33392     2.77075      40.1331      17.8396      26.8369      \
0.852235
225    -2.24716     3.18023      39.7192      17.8396      26.8369      \
0.852235
226    -1.28141     3.42969      39.3294      17.8396      26.8369      \
0.852235
227    -0.443542    3.54528      38.9697      17.8396      26.8369      \
0.852235
228    0.265452     3.55167      38.6401      17.8396      26.8369      \
0.852235
229    0.849158     3.47138      38.3371      17.8396      26.8369      \
0.852235
230    1.31452      3.32448      38.0552      17.8396      26.8369      \
0.852235
231    1.67083      3.12857      37.7884      17.8396      26.8369      \
0.852235
232    1.92882      2.8989       37.5308      17.8396      26.8369      \
0.852235
233    2.10004      2.64848      37.2777      17.8396      26.8369      \
0.852235
234    2.19628      2.38821      37.0252      17.8396      26.8369      \
0.852235
235    2.22918      2.12704      36.7709      17.8396      26.8369      \
0.852235
236    2.20986      1.87209      36.513       17.8396      26.8369      \
0.852235
237    2.14876      1.62882      36.2508      17.8396      26.8369      \
0.852235
238    2.05539      1.40118      35.9843      17.8396      26.8369      \
0.852235
239    1.93829      1.19181      35.714       17.8396      26.8369      \
0.852235
240    1.80492      1.00224      35.4404      17.8396      26.8369      \
0.852235
241    1.66169      0.833036     35.1645      17.8396      26.8369      \
0.852235
242    1.51398      0.684067     34.8871      17.8396      26.8369      \
0.852235
243    1.36618      0.554615     34.609       17.8396      26.8369      \
0.852235
244    1.22174      0.443556     34.331       17.8396      26.8369      \
0.852235
245    1.08334      0.349492     34.0536      17.8396      26.8369      \
0.852235
246    0.952905     0.270863     33.7774      17.8396      26.8369      \
0.852235
247    0.831751     0.206038     33.5028      17.8396      26.8369      \
0.852235
248    0.720668     0.153384     33.23        17.8396      26.8369      \
0.852235
249    0.620016     0.111319     32.9593      17.8396      26.8369      \
0.852235
250    0.529812     0.0783506    32.6907      17.8396      26.8369      \
0.852235
251    6.62742      7.93696      23.0385      17.6232      25.9109      \
0.921192
252    6.85829      8.04797      23.3523      17.6232      25.9109      \
0.921192
253    7.06799      8.14291      23.6894      17.6232      25.9109      \
0.921192
254    7.25745      8.21834      24.0474      17.6232      25.9109      \
0.921192
255    7.4268       8.2711       24.4238      17.6232      25.9109      \
0.921192
256    7.5756       8.29836      24.8153      17.6232      25.9109      \
0.921192
257    7.70299      8.29766      25.2186      17.6232      25.9109      \
0.921192
258    7.80781      8.26697      25.6298      17.6232      25.9109      \
0.921192
259    7.88876      8.20479      26.0447      17.6232      25.9109      \
0.921192
260    7.9445       8.11021      26.4589      17.6232      25.9109      \
0.921192
261    7.97375      7.98297      26.8675      17.6232      25.9109      \
0.921192
262    7.97544      7.82353      27.2658      17.6232      25.9109      \
0.921192
263    7.94874      7.6331       27.649       17.6232      25.9109      \
0.921192
264    7.8932       7.41361      28.0125      17.6232      25.9109      \
0.921192
265    7.80877      7.16768      28.3522      17.6232      25.9109      \
0.921192
266    7.69589      6.89859      28.6641      17.6232      25.9109      \
0.921192
267    7.5555       6.61012      28.9451      17.6232      25.9109      \
0.921192
268    7.38901      6.30644      29.1927      17.6232      25.9109      \
0.921192
269    7.19837      5.99196      29.4051      17.6232      25.9109      \
0.921192
270    6.98591      5.67116      29.5813      17.6232      25.9109      \
0.921192
271    6.75437      5.34844      29.7212      17.6232      25.9109      \
0.921192
272    6.50678      5.02794      29.8252      17.6232      25.9109      \
0.921192
273    6.24636      4.71345      29.8946      17.6232      25.9109      \
0.921192
274    5.97643      4.40827      29.931       17.6232      25.9109      \
0.921192
275    5.7003       4.1152       29.9365      17.6232      25.9109      \
0.921192
276    5.42121      3.83645      29.9136      17.6232      25.9109      \
0.921192
277    5.1422       3.57368      29.8648      17.6232      25.9109      \
0.921192
278    4.86606      3.328        29.7929      17.6232      25.9109      \
0.921192
279    4.59531      3.10005      29.7003      17.6232      25.9109      \
0.921192
280    4.33211      2.89         29.5898      17.6232      25.9109      \
0.921192
281    4.07829      2.69768      29.4637      17.6232      25.9109      \
0.921192
282    3.83531      2.52261      29.3242      17.6232      25.9109      \
0.921192
283    3.6043       2.36409      29.1734      17.6232      25.9109      \
0.921192
284    3.38608      2.22125      29.0131      17.6232      25.9109      \
0.921192
285    3.18113      2.0931       28.8449      17.6232      25.9109      \
0.921192
286    2.98971      1.9786       28.6703      17.6232      25.9109      \
0.921192
287    2.81184      1.87668      28.4904      17.6232      25.9109      \
0.921192
288    2.64735      1.78628      28.3064      17.6232      25.9109      \
0.921192
289    2.4959       1.70637      28.1192      17.6232      25.9109      \
0.921192
290    2.35705      1.63597      27.9296      17.6232      25.9109      \
0.921192
291    2.23024      1.57415      27.7382      17.6232      25.9109      \
0.921192
292    2.11488      1.52008      27.5457      17.6232      25.9109      \
0.921192
293    2.0103       1.47295      27.3526      17.6232      25.9109      \
0.921192
294    1.91583      1.43208      27.1594      17.6232      25.9109      \
0.921192
295    1.83079      1.39681      26.9663      17.6232      25.9109      \
0.921192
296    1.7545       1.36657      26.7738      17.6232      25.9109      \
0.921192
297    1.68631      1.34086      26.5821      17.6232      25.9109      \
0.921192
298    1.6256       1.31923      26.3915      17.6232      25.9109      \
0.921192
299    1.57175      1.30128      26.2023      17.6232      25.9109      \
0.921192
300    1.52422      1.28666      26.0146      17.6232      25.9109      \
0.921192
301    4.11489      4.0431       23.6817      17.6071      25.6822      \
0.933975
302    4.10227      4.08496      23.627       17.6071      25.6822      \
0.933975
303    4.09927      4.12836      23.5742      17.6071      25.6822      \
0.933975
304    4.10446      4.17338      23.5239      17.6071      25.6822      \
0.933975
305    4.11667      4.22006      23.4768      17.6071      25.6822      \
0.933975
306    4.13496      4.26839      23.4335      17.6071      25.6822      \
0.933975
307    4.15854      4.3183       23.3943      17.6071      25.6822      \
0.933975
308    4.18675      4.36971      23.3597      17.6071      25.6822      \
0.933975
309    4.21906      4.4225       23.33        17.6071      25.6822      \
0.933975
310    4.25497      4.47649      23.3055      17.6071      25.6822      \
0.933975
311    4.29406      4.53149      23.2865      17.6071      25.6822      \
0.933975
312    4.33595      4.58726      23.2732      17.6071      25.6822      \
0.933975
313    4.38028      4.64356      23.2659      17.6071      25.6822      \
0.933975
314    4.42672      4.70008      23.2647      17.6071      25.6822      \
0.933975
315    4.47493      4.75652      23.2698      17.6071      25.6822      \
0.933975
316    4.52458      4.81254      23.2813      17.6071      25.6822      \
0.933975
317    4.57536      4.86777      23.2992      17.6071      25.6822      \
0.933975
318    4.62691      4.92184      23.3236      17.6071      25.6822      \
0.933975
319    4.67891      4.97435      23.3544      17.6071      25.6822      \
0.933975
320    4.73099      5.02489      23.3916      17.6071      25.6822      \
0.933975
321    4.78279      5.07305      23.435       17.6071      25.6822      \
0.933975
322    4.83395      5.1184       23.4846      17.6071      25.6822      \
0.933975
323    4.88408      5.16053      23.54        17.6071      25.6822      \
0.933975
324    4.9328       5.19905      23.6009      17.6071      25.6822      \
0.933975
325    4.97971      5.23355      23.6672      17.6071      25.6822      \
0.933975
326    5.02443      5.26368      23.7382      17.6071      25.6822      \
0.933975
327    5.06658      5.2891       23.8137      17.6071      25.6822      \
0.933975
328    5.10578      5.30953      23.8931      17.6071      25.6822      \
0.933975
329    5.14166      5.32471      23.9758      17.6071      25.6822      \
0.933975
330    5.17389      5.33445      24.0614      17.6071      25.6822      \
0.933975
331    5.20215      5.33862      24.1491      17.6071      25.6822      \
0.933975
332    5.22616      5.33714      24.2384      17.6071      25.6822      \
0.933975
333    5.24567      5.33         24.3286      17.6071      25.6822      \
0.933975
334    5.26048      5.31727      24.4191      17.6071      25.6822      \
0.933975
335    5.27043      5.29907      24.5092      17.6071      25.6822      \
0.933975
336    5.27542      5.27559      24.5983      17.6071      25.6822      \
0.933975
337    5.27538      5.24707      24.6859      17.6071      25.6822      \
0.933975
338    5.27032      5.21383      24.7714      17.6071      25.6822      \
0.933975
339    5.26029      5.17621      24.8543      17.6071      25.6822      \
0.933975
340    5.24539      5.1346       24.9341      17.6071      25.6822      \
0.933975
341    5.22578      5.08941      25.0105      17.6071      25.6822      \
0.933975
342    5.20166      5.04107      25.0833      17.6071      25.6822      \
0.933975
343    5.17327      4.99002      25.152       17.6071      25.6822      \
0.933975
344    5.14088      4.93669      25.2166      17.6071      25.6822      \
0.933975
345    5.1048       4.8815       25.2769      17.6071      25.6822      \
0.933975
346    5.06535      4.82485      25.3329      17.6071      25.6822      \
0.933975
347    5.02287      4.76709      25.3845      17.6071      25.6822      \
0.933975
348    4.9777       4.70856      25.4318      17.6071      25.6822      \
0.933975
349    4.93017      4.64954      25.4749      17.6071      25.6822      \
0.933975
350    4.88062      4.59028      25.5138      17.6071      25.6822      \
0.933975
351    11.3945      7.26798      35.6696      17.6594      26.3591      \
0.978983
352    10.6658      6.13434      36.1486      17.6594      26.3591      \
0.978983
353    9.86585      5.02872      36.4491      17.6594      26.3591      \
0.978983
354    9.01218      3.98274      36.5889      17.6594      26.3591      \
0.978983
355    8.12479      3.02074      36.5904      17.6594      26.3591      \
0.978983
356    7.22444      2.159        36.479       17.6594      26.3591      \
0.978983
357    6.33111      1.40609      36.2799      17.6594      26.3591      \
0.978983
358    5.46272      0.763773     36.0166      17.6594      26.3591      \
0.978983
359    4.63438      0.228523     35.7094      17.6594      26.3591      \
0.978983
360    3.85788      -0.206992    35.375       17.6594      26.3591      \
0.978983
361    3.14164      -0.55245     35.026       17.6594      26.3591      \
0.978983
362    2.49087      -0.818673    34.6718      17.6594      26.3591      \
0.978983
363    1.90799      -1.01673     34.3188      17.6594      26.3591      \
0.978983
364    1.393        -1.15729     33.9709      17.6594      26.3591      \
0.978983
365    0.944058     -1.25026     33.6303      17.6594      26.3591      \
0.978983
366    0.557877     -1.30454     33.2979      17.6594      26.3591      \
0.978983
367    0.230196     -1.32799     32.9737      17.6594      26.3591      \
0.978983
368    -0.0438783   -1.32736     32.6574      17.6594      26.3591      \
0.978983
369    -0.269565    -1.30842     32.3481      17.6594      26.3591      \
0.978983
370    -0.452175    -1.276       32.0452      17.6594      26.3591      \
0.978983
371    -0.596933    -1.23409     31.7477      17.6594      26.3591      \
0.978983
372    -0.708841    -1.18594     31.4551      17.6594      26.3591      \
0.978983
373    -0.792594    -1.13418     31.1667      17.6594      26.3591      \
0.978983
374    -0.852514    -1.08085     30.8819      17.6594      26.3591      \
0.978983
375    -0.892527    -1.02756     30.6004      17.6594      26.3591      \
0.978983
376    -0.916145    -0.975514    30.322       17.6594      26.3591      \
0.978983
377    -0.926474    -0.925587    30.0464      17.6594      26.3591      \
0.978983
378    -0.926225    -0.878395    29.7734      17.6594      26.3591      \
0.978983
379    -0.91774     -0.834335    29.503       17.6594      26.3591      \
0.978983
380    -0.903017    -0.793639    29.2352      17.6594      26.3591      \
0.978983
381    -0.883745    -0.756404    28.97        17.6594      26.3591      \
0.978983
382    -0.861331    -0.72263     28.7073      17.6594      26.3591      \
0.978983
383    -0.836934    -0.692242    28.4473      17.6594      26.3591      \
0.978983
384    -0.811496    -0.665115    28.1899      17.6594      26.3591      \
0.978983
385    -0.785772    -0.641089    27.9351      17.6594      26.3591      \
0.978983
386    -0.760356    -0.619983    27.6831      17.6594      26.3591      \
0.978983
387    -0.735705    -0.601609    27.4339      17.6594      26.3591      \
0.978983
388    -0.712164    -0.585773    27.1876      17.6594      26.3591      \
0.978983
389    -0.689982    -0.57229     26.9441      17.6594      26.3591      \
0.978983
390    -0.669332    -0.56098     26.7036      17.6594      26.3591      \
0.978983
391    -0.650327    -0.551676    26.4661      17.6594      26.3591      \
0.978983
392    -0.633028    -0.544223    26.2316      17.6594      26.3591      \
0.978983
393    -0.61746     -0.538481    26.0003      17.6594      26.3591      \
0.978983
394    -0.60362     -0.534323    25.7721      17.6594      26.3591      \
0.978983
395    -0.591481    -0.531637    25.5471      17.6594      26.3591      \
0.978983
396    -0.581003    -0.530322    25.3254      17.6594      26.3591      \
0.978983
397    -0.572133    -0.530291    25.107       17.6594      26.3591      \
0.978983
398    -0.564816    -0.53147     24.8921      17.6594      26.3591      \
0.978983
399    -0.558991    -0.533791    24.6806      17.6594      26.3591      \
0.978983
400    -0.554596    -0.537199    24.4727      17.6594      26.3591      \
0.978983
401    -3.86868     -4.7389      11.8788      17.6615      26.5534      \
1.10104
402    -4.02239     -5.25921     11.9315      17.6615      26.5534      \
1.10104
403    -4.24081     -5.79473     12.012       17.6615      26.5534      \
1.10104
404    -4.5152      -6.35332     12.1265      17.6615      26.5534      \
1.10104
405    -4.83976     -6.94092     12.2819      17.6615      26.5534      \
1.10104
406    -5.21073     -7.5617      12.4858      17.6615      26.5534      \
1.10104
407    -5.6258      -8.21823     12.7472      17.6615      26.5534      \
1.10104
408    -6.08348     -8.91131     13.0759      17.6615      26.5534      \
1.10104
409    -6.58272     -9.63982     13.4829      17.6615      26.5534      \
1.10104
410    -7.12243     -10.4004     13.9803      17.6615      26.5534      \
1.10104
411    -7.70113     -11.1868     14.5812      17.6615      26.5534      \
1.10104
412    -8.31649     -11.9896     15.2993      17.6615      26.5534      \
1.10104
413    -8.96492     -12.7953     16.1484      17.6615      26.5534      \
1.10104
414    -9.64111     -13.586      17.1413      17.6615      26.5534      \
1.10104
415    -10.3375     -14.3386     18.2893      17.6615      26.5534      \
1.10104
416    -11.0437     -15.0248     19.5998      17.6615      26.5534      \
1.10104
417    -11.7463     -15.6112     21.0748      17.6615      26.5534      \
1.10104
418    -12.4283     -16.06       22.7088      17.6615      26.5534      \
1.10104
419    -13.0689     -16.3312     24.4862      17.6615      26.5534      \
1.10104
420    -13.6441     -16.3855     26.3799      17.6615      26.5534      \
1.10104
421    -14.1271     -16.1878     28.3498      17.6615      26.5534      \
1.10104
422    -14.4895     -15.7126     30.344       17.6615      26.5534      \
1.10104
423    -14.7038     -14.9485     32.3007      17.6615      26.5534      \
1.10104
424    -14.7451     -13.9024     34.1532      17.6615      26.5534      \
1.10104
425    -14.5941     -12.6016     35.8366      17.6615      26.5534      \
1.10104
426    -14.2399     -11.0928     37.2947      17.6615      26.5534      \
1.10104
427    -13.6818     -9.43852     38.4866      17.6615      26.5534      \
1.10104
428    -12.9303     -7.7103      39.3914      17.6615      26.5534      \
1.10104
429    -12.0066     -5.98119     40.0089      17.6615      26.5534      \
1.10104
430    -10.9411     -4.31838     40.3582      17.6615      26.5534      \
1.10104
431    -9.77072     -2.77756     40.4726      17.6615      26.5534      \
1.10104
432    -8.5356      -1.39969     40.3948      17.6615      26.5534      \
1.10104
433    -7.27596     -0.210029    40.1701      17.6615      26.5534      \
1.10104
434    -6.02934     0.780745     39.8425      17.6615      26.5534      \
1.10104
435    -4.8285      1.57425      39.4505      17.6615      26.5534      \
1.10104
436    -3.70008     2.18144      39.0251      17.6615      26.5534      \
1.10104
437    -2.66408     2.61956      38.5895      17.6615      26.5534      \
1.10104
438    -1.73391     2.90942      38.159       17.6615      26.5534      \
1.10104
439    -0.916954    3.07318      37.7424      17.6615      26.5534      \
1.10104
440    -0.215378    3.13282      37.3434      17.6615      26.5534      \
1.10104
441    0.372893     3.10901      36.9622      17.6615      26.5534      \
1.10104
442    0.853203     3.02056      36.5968      17.6615      26.5534      \
1.10104
443    1.23326      2.88412      36.2439      17.6615      26.5534      \
1.10104
444    1.52233      2.71406      35.9002      17.6615      26.5534      \
1.10104
445    1.73057      2.52258      35.5624      17.6615      26.5534      \
1.10104
446    1.86849      2.31974      35.228       17.6615      26.5534      \
1.10104
447    1.94651      2.11369      34.8949      17.6615      26.5534      \
1.10104
448    1.97464      1.9108       34.5619      17.6615      26.5534      \
1.10104
449    1.96223      1.71588      34.2283      17.6615      26.5534      \
1.10104
450    1.91784      1.53237      33.8939      17.6615      26.5534      \
1.10104
451    2.79345      6.59406      30.0412      17.2773      26.1775      \
1.10806
452    3.45007      6.42019      29.8925      17.2773      26.1775      \
1.10806
453    3.96302      6.22777      29.783       17.2773      26.1775      \
1.10806
454    4.35401      6.02246      29.7003      17.2773      26.1775      \
1.10806
455    4.64192      5.80857      29.6344      17.2773      26.1775      \
1.10806
456    4.84311      5.58956      29.5774      17.2773      26.1775      \
1.10806
457    4.97172      5.36836      29.5228      17.2773      26.1775      \
1.10806
458    5.03992      5.1475       29.4659      17.2773      26.1775      \
1.10806
459    5.05823      4.9292       29.403       17.2773      26.1775      \
1.10806
460    5.0357       4.71541      29.3316      17.2773      26.1775      \
1.10806
461    4.98019      4.50782      29.2501      17.2773      26.1775      \
1.10806
462    4.89847      4.30785      29.1574      17.2773      26.1775      \
1.10806
463    4.79636      4.11665      29.0533      17.2773      26.1775      \
1.10806
464    4.67892      3.93513      28.9376      17.2773      26.1775      \
1.10806
465    4.55046      3.76396      28.8108      17.2773      26.1775      \
1.10806
466    4.41466      3.60359      28.6734      17.2773      26.1775      \
1.10806
467    4.27465      3.45424      28.5263      17.2773      26.1775      \
1.10806
468    4.13307      3.31598      28.3702      17.2773      26.1775      \
1.10806
469    3.99208      3.1887       28.206       17.2773      26.1775      \
1.10806
470    3.85349      3.07221      28.0348      17.2773      26.1775      \
1.10806
471    3.71873      2.96616      27.8574      17.2773      26.1775      \
1.10806
472    3.58895      2.87018      27.6747      17.2773      26.1775      \
1.10806
473    3.46501      2.78381      27.4875      17.2773      26.1775      \
1.10806
474    3.34757      2.70657      27.2968      17.2773      26.1775      \
1.10806
475    3.23708      2.63796      27.1031      17.2773      26.1775      \
1.10806
476    3.13382      2.57747      26.9073      17.2773      26.1775      \
1.10806
477    3.03795      2.52463      26.7099      17.2773      26.1775      \
1.10806
478    2.9495       2.47893      26.5116      17.2773      26.1775      \
1.10806
479    2.86844      2.43993      26.3129      17.2773      26.1775      \
1.10806
480    2.79463      2.40718      26.1142      17.2773      26.1775      \
1.10806
481    2.7279       2.38029      25.916       17.2773      26.1775      \
1.10806
482    2.66805      2.35889      25.7188      17.2773      26.1775      \
1.10806
483    2.61483      2.34262      25.5229      17.2773      26.1775      \
1.10806
484    2.56798      2.33117      25.3287      17.2773      26.1775      \
1.10806
485    2.52724      2.32426      25.1365      17.2773      26.1775      \
1.10806
486    2.49233      2.32164      24.9466      17.2773      26.1775      \
1.10806
487    2.46299      2.32305      24.7593      17.2773      26.1775      \
1.10806
488    2.43895      2.3283       24.5749      17.2773      26.1775      \
1.10806
489    2.41996      2.33718      24.3937      17.2773      26.1775      \
1.10806
490    2.40578      2.34953      24.2158      17.2773      26.1775      \
1.10806
491    2.39617      2.36517      24.0416      17.2773      26.1775      \
1.10806
492    2.39091      2.38396      23.8714      17.2773      26.1775      \
1.10806
493    2.38981      2.40576      23.7052      17.2773      26.1775      \
1.10806
494    2.39265      2.43043      23.5434      17.2773      26.1775      \
1.10806
495    2.39926      2.45783      23.3863      17.2773      26.1775      \
1.10806
496    2.40946      2.48784      23.234       17.2773      26.1775      \
1.10806
497    2.42307      2.52031      23.0869      17.2773      26.1775      \
1.10806
498    2.43993      2.5551       22.945       17.2773      26.1775      \
1.10806
499    2.45989      2.59207      22.8088      17.2773      26.1775      \
1.10806
500    2.48279      2.63106      22.6783      17.2773      26.1775      \
1.10806
501    13.57        8.31034      37.5417      17.3439      26.9835      \
1.11884
502    12.6578      6.79446      38.2495      17.3439      26.9835      \
1.11884
503    11.6412      5.30037      38.6817      17.3439      26.9835      \
1.11884
504    10.5421      3.88533      38.8664      17.3439      26.9835      \
1.11884
505    9.38849      2.59347      38.8418      17.3439      26.9835      \
1.11884
506    8.21122      1.45389      38.652       17.3439      26.9835      \
1.11884
507    7.04074      0.480918     38.3407      17.3439      26.9835      \
1.11884
508    5.90475      -0.323761    37.9482      17.3439      26.9835      \
1.11884
509    4.82638      -0.968069    37.5079      17.3439      26.9835      \
1.11884
510    3.82342      -1.46625     37.0457      17.3439      26.9835      \
1.11884
511    2.90806      -1.83597     36.5801      17.3439      26.9835      \
1.11884
512    2.08735      -2.09604     36.1231      17.3439      26.9835      \
1.11884
513    1.36383      -2.26484     35.6816      17.3439      26.9835      \
1.11884
514    0.736437     -2.35939     35.2585      17.3439      26.9835      \
1.11884
515    0.201348     -2.39487     34.8543      17.3439      26.9835      \
1.11884
516    -0.247227    -2.38445     34.4677      17.3439      26.9835      \
1.11884
517    -0.61635     -2.33935     34.0965      17.3439      26.9835      \
1.11884
518    -0.913796    -2.26896     33.7384      17.3439      26.9835      \
1.11884
519    -1.14761     -2.18102     33.391       17.3439      26.9835      \
1.11884
520    -1.3258      -2.08185     33.052       17.3439      26.9835      \
1.11884
521    -1.45604     -1.97651     32.7197      17.3439      26.9835      \
1.11884
522    -1.54559     -1.86899     32.3925      17.3439      26.9835      \
1.11884
523    -1.6011      -1.76238     32.0694      17.3439      26.9835      \
1.11884
524    -1.62863     -1.65898     31.7494      17.3439      26.9835      \
1.11884
525    -1.63357     -1.56047     31.4322      17.3439      26.9835      \
1.11884
526    -1.62068     -1.46801     31.1172      17.3439      26.9835      \
1.11884
527    -1.59409     -1.3823      30.8044      17.3439      26.9835      \
1.11884
528    -1.55732     -1.30375     30.4938      17.3439      26.9835      \
1.11884
529    -1.51338     -1.23247     30.1852      17.3439      26.9835      \
1.11884
530    -1.46475     -1.16838     29.8789      17.3439      26.9835      \
1.11884
531    -1.41348     -1.11126     29.575       17.3439      26.9835      \
1.11884
532    -1.36123     -1.06079     29.2736      17.3439      26.9835      \
1.11884
533    -1.30932     -1.01658     28.9749      17.3439      26.9835      \
1.11884
534    -1.25876     -0.978218    28.679       17.3439      26.9835      \
1.11884
535    -1.21033     -0.945259    28.386       17.3439      26.9835      \
1.11884
536    -1.16458     -0.917275    28.0962      17.3439      26.9835      \
1.11884
537    -1.12192     -0.893852    27.8095      17.3439      26.9835      \
1.11884
538    -1.08259     -0.874598    27.5263      17.3439      26.9835      \
1.11884
539    -1.04673     -0.859152    27.2464      17.3439      26.9835      \
1.11884
540    -1.0144      -0.847186    26.9702      17.3439      26.9835      \
1.11884
541    -0.985596    -0.838405    26.6976      17.3439      26.9835      \
1.11884
542    -0.960249    -0.832548    26.4287      17.3439      26.9835      \
1.11884
543    -0.938269    -0.829387    26.1637      17.3439      26.9835      \
1.11884
544    -0.919538    -0.828723    25.9027      17.3439      26.9835      \
1.11884
545    -0.903927    -0.830386    25.6456      17.3439      26.9835      \
1.11884
546    -0.891297    -0.834234    25.3927      17.3439      26.9835      \
1.11884
547    -0.88151     -0.840145    25.1441      17.3439      26.9835      \
1.11884
548    -0.874432    -0.84802     24.8997      17.3439      26.9835      \
1.11884
549    -0.869934    -0.857777    24.6599      17.3439      26.9835      \
1.11884
550    -0.867896    -0.869351    24.4246      17.3439      26.9835      \
1.11884
551    3.64979      7.77152      12.9906      17.4747      26.928       \
1.18839
552    4.37003      8.2025       13.1199      17.4747      26.928       \
1.18839
553    5.03954      8.72384      13.3228      17.4747      26.928       \
1.18839
554    5.68305      9.32204      13.6051      17.4747      26.928       \
1.18839
555    6.31858      9.98552      13.9752      17.4747      26.928       \
1.18839
556    6.95897      10.7033      14.4432      17.4747      26.928       \
1.18839
557    7.61286      11.4637      15.021       17.4747      26.928       \
1.18839
558    8.28535      12.2533      15.7216      17.4747      26.928       \
1.18839
559    8.9783       13.0559      16.5582      17.4747      26.928       \
1.18839
560    9.69039      13.8514      17.5439      17.4747      26.928       \
1.18839
561    10.417       14.6153      18.69        17.4747      26.928       \
1.18839
562    11.1501      15.3176      20.0049      17.4747      26.928       \
1.18839
563    11.8778      15.9234      21.4915      17.4747      26.928       \
1.18839
564    12.584       16.3931      23.1453      17.4747      26.928       \
1.18839
565    13.2488      16.6841      24.9518      17.4747      26.928       \
1.18839
566    13.8481      16.7538      26.8843      17.4747      26.928       \
1.18839
567    14.3547      16.5631      28.9023      17.4747      26.928       \
1.18839
568    14.7391      16.0819      30.9519      17.4747      26.928       \
1.18839
569    14.9721      15.2946      32.9675      17.4747      26.928       \
1.18839
570    15.0265      14.2051      34.8763      17.4747      26.928       \
1.18839
571    14.8809      12.8396      36.6058      17.4747      26.928       \
1.18839
572    14.522       11.2473      38.0915      17.4747      26.928       \
1.18839
573    13.9476      9.4967       39.2856      17.4747      26.928       \
1.18839
574    13.1679      7.66802      40.1628      17.4747      26.928       \
1.18839
575    12.2052      5.84437      40.7228      17.4747      26.928       \
1.18839
576    11.0925      4.10213      40.9888      17.4747      26.928       \
1.18839
577    9.87045      2.50344      41.002       17.4747      26.928       \
1.18839
578    8.58323      1.09183      40.8138      17.4747      26.928       \
1.18839
579    7.27496      -0.108663    40.4787      17.4747      26.928       \
1.18839
580    5.98617      -1.09146     40.0473      17.4747      26.928       \
1.18839
581    4.75141      -1.86378     39.5626      17.4747      26.928       \
1.18839
582    3.59791      -2.44233     39.0575      17.4747      26.928       \
1.18839
583    2.5452       -2.84933     38.5549      17.4747      26.928       \
1.18839
584    1.60554      -3.10933     38.0688      17.4747      26.928       \
1.18839
585    0.784736     -3.24695     37.606       17.4747      26.928       \
1.18839
586    0.0833089    -3.2854      37.1682      17.4747      26.928       \
1.18839
587    -0.502357    -3.24579     36.7537      17.4747      26.928       \
1.18839
588    -0.978914    -3.14673     36.3591      17.4747      26.928       \
1.18839
589    -1.35509     -3.00431     35.9799      17.4747      26.928       \
1.18839
590    -1.64088     -2.83218     35.612       17.4747      26.928       \
1.18839
591    -1.84691     -2.64173     35.2516      17.4747      26.928       \
1.18839
592    -1.98393     -2.44226     34.8955      17.4747      26.928       \
1.18839
593    -2.06242     -2.24122     34.5417      17.4747      26.928       \
1.18839
594    -2.09233     -2.04435     34.1885      17.4747      26.928       \
1.18839
595    -2.08287     -1.85597     33.8352      17.4747      26.928       \
1.18839
596    -2.04237     -1.67912     33.4814      17.4747      26.928       \
1.18839
597    -1.97827     -1.51575     33.1271      17.4747      26.928       \
1.18839
598    -1.89701     -1.36698     32.7728      17.4747      26.928       \
1.18839
599    -1.80413     -1.2332      32.4187      17.4747      26.928       \
1.18839
600    -1.70425     -1.11427     32.0655      17.4747      26.928       \
1.18839
601    -2.69602     -6.49514     24.7719      17.2646      26.4859      \
1.20562
602    -3.35196     -6.47639     24.6484      17.2646      26.4859      \
1.20562
603    -3.89123     -6.47317     24.5686      17.2646      26.4859      \
1.20562
604    -4.33673     -6.48289     24.5249      17.2646      26.4859      \
1.20562
605    -4.70694     -6.50279     24.5117      17.2646      26.4859      \
1.20562
606    -5.01664     -6.53017     24.5243      17.2646      26.4859      \
1.20562
607    -5.2776      -6.56247     24.5593      17.2646      26.4859      \
1.20562
608    -5.49909     -6.59739     24.6136      17.2646      26.4859      \
1.20562
609    -5.68839     -6.63283     24.6849      17.2646      26.4859      \
1.20562
610    -5.85115     -6.66689     24.771       17.2646      26.4859      \
1.20562
611    -5.99172     -6.69792     24.8701      17.2646      26.4859      \
1.20562
612    -6.1134      -6.72441     24.9806      17.2646      26.4859      \
1.20562
613    -6.21867     -6.74507     25.1007      17.2646      26.4859      \
1.20562
614    -6.30936     -6.75876     25.229       17.2646      26.4859      \
1.20562
615    -6.38677     -6.76449     25.364       17.2646      26.4859      \
1.20562
616    -6.45183     -6.76148     25.5042      17.2646      26.4859      \
1.20562
617    -6.50514     -6.74907     25.648       17.2646      26.4859      \
1.20562
618    -6.54713     -6.7268      25.794       17.2646      26.4859      \
1.20562
619    -6.57803     -6.69438     25.9406      17.2646      26.4859      \
1.20562
620    -6.59801     -6.65169     26.0863      17.2646      26.4859      \
1.20562
621    -6.60717     -6.59878     26.2296      17.2646      26.4859      \
1.20562
622    -6.60563     -6.5359      26.369       17.2646      26.4859      \
1.20562
623    -6.5935      -6.46344     26.5032      17.2646      26.4859      \
1.20562
624    -6.57097     -6.38197     26.6307      17.2646      26.4859      \
1.20562
625    -6.53826     -6.29218     26.7505      17.2646      26.4859      \
1.20562
626    -6.49571     -6.19492     26.8613      17.2646      26.4859      \
1.20562
627    -6.44372     -6.0911      26.9622      17.2646      26.4859      \
1.20562
628    -6.38279     -5.98174     27.0525      17.2646      26.4859      \
1.20562
629    -6.3135      -5.86789     27.1316      17.2646      26.4859      \
1.20562
630    -6.23653     -5.75064     27.1988      17.2646      26.4859      \
1.20562
631    -6.15262     -5.63107     27.2541      17.2646      26.4859      \
1.20562
632    -6.06256     -5.51022     27.2971      17.2646      26.4859      \
1.20562
633    -5.96719     -5.38911     27.328       17.2646      26.4859      \
1.20562
634    -5.86739     -5.26866     27.3468      17.2646      26.4859      \
1.20562
635    -5.76404     -5.14973     27.3539      17.2646      26.4859      \
1.20562
636    -5.65801     -5.03309     27.3497      17.2646      26.4859      \
1.20562
637    -5.55016     -4.91939     27.3345      17.2646      26.4859      \
1.20562
638    -5.44131     -4.8092      27.309       17.2646      26.4859      \
1.20562
639    -5.33224     -4.70298     27.2736      17.2646      26.4859      \
1.20562
640    -5.22367     -4.6011      27.2291      17.2646      26.4859      \
1.20562
641    -5.11627     -4.50382     27.1761      17.2646      26.4859      \
1.20562
642    -5.01062     -4.41136     27.1151      17.2646      26.4859      \
1.20562
643    -4.90726     -4.32382     27.0469      17.2646      26.4859      \
1.20562
644    -4.80664     -4.24127     26.9721      17.2646      26.4859      \
1.20562
645    -4.70914     -4.16371     26.8912      17.2646      26.4859      \
1.20562
646    -4.61509     -4.09109     26.8049      17.2646      26.4859      \
1.20562
647    -4.52475     -4.02335     26.7138      17.2646      26.4859      \
1.20562
648    -4.43831     -3.96036     26.6184      17.2646      26.4859      \
1.20562
649    -4.35593     -3.90201     26.5192      17.2646      26.4859      \
1.20562
650    -4.27769     -3.84814     26.4167      17.2646      26.4859      \
1.20562
651    -3.54688     -4.1221      22.6357      17.2553      26.2777      \
1.1984
652    -3.64617     -4.20999     22.5108      17.2553      26.2777      \
1.1984
653    -3.74348     -4.30515     22.3947      17.2553      26.2777      \
1.1984
654    -3.8404      -4.40732     22.2882      17.2553      26.2777      \
1.1984
655    -3.93821     -4.51621     22.1918      17.2553      26.2777      \
1.1984
656    -4.03792     -4.63156     22.106       17.2553      26.2777      \
1.1984
657    -4.14033     -4.75311     22.0314      17.2553      26.2777      \
1.1984
658    -4.24603     -4.88054     21.9687      17.2553      26.2777      \
1.1984
659    -4.35548     -5.01352     21.9184      17.2553      26.2777      \
1.1984
660    -4.46899     -5.15165     21.8813      17.2553      26.2777      \
1.1984
661    -4.58674     -5.29448     21.8579      17.2553      26.2777      \
1.1984
662    -4.70881     -5.44149     21.8491      17.2553      26.2777      \
1.1984
663    -4.83519     -5.59205     21.8555      17.2553      26.2777      \
1.1984
664    -4.96574     -5.74546     21.8777      17.2553      26.2777      \
1.1984
665    -5.10022     -5.90091     21.9164      17.2553      26.2777      \
1.1984
666    -5.23832     -6.05747     21.9723      17.2553      26.2777      \
1.1984
667    -5.37961     -6.2141      22.0457      17.2553      26.2777      \
1.1984
668    -5.52353     -6.36961     22.1371      17.2553      26.2777      \
1.1984
669    -5.66945     -6.52274     22.2469      17.2553      26.2777      \
1.1984
670    -5.8166      -6.67206     22.3753      17.2553      26.2777      \
1.1984
671    -5.96413     -6.81608     22.5222      17.2553      26.2777      \
1.1984
672    -6.11103     -6.95318     22.6875      17.2553      26.2777      \
1.1984
673    -6.25624     -7.08172     22.8707      17.2553      26.2777      \
1.1984
674    -6.39856     -7.19998     23.0713      17.2553      26.2777      \
1.1984
675    -6.53672     -7.30628     23.2882      17.2553      26.2777      \
1.1984
676    -6.66936     -7.39895     23.5203      17.2553      26.2777      \
1.1984
677    -6.79509     -7.47644     23.7661      17.2553      26.2777      \
1.1984
678    -6.91249     -7.53734     24.0238      17.2553      26.2777      \
1.1984
679    -7.02012     -7.58041     24.2914      17.2553      26.2777      \
1.1984
680    -7.11659     -7.60469     24.5668      17.2553      26.2777      \
1.1984
681    -7.20058     -7.60948     24.8474      17.2553      26.2777      \
1.1984
682    -7.2709      -7.59441     25.1308      17.2553      26.2777      \
1.1984
683    -7.32646     -7.55945     25.4143      17.2553      26.2777      \
1.1984
684    -7.36638     -7.50491     25.6953      17.2553      26.2777      \
1.1984
685    -7.38999     -7.43145     25.9713      17.2553      26.2777      \
1.1984
686    -7.39684     -7.34002     26.24        17.2553      26.2777      \
1.1984
687    -7.38672     -7.23185     26.4991      17.2553      26.2777      \
1.1984
688    -7.35968     -7.10836     26.7466      17.2553      26.2777      \
1.1984
689    -7.31599     -6.97116     26.981       17.2553      26.2777      \
1.1984
690    -7.25617     -6.8219      27.2009      17.2553      26.2777      \
1.1984
691    -7.18093     -6.66229     27.405       17.2553      26.2777      \
1.1984
692    -7.09114     -6.49398     27.5927      17.2553      26.2777      \
1.1984
693    -6.98782     -6.31859     27.7632      17.2553      26.2777      \
1.1984
694    -6.87208     -6.13759     27.9162      17.2553      26.2777      \
1.1984
695    -6.74511     -5.95237     28.0514      17.2553      26.2777      \
1.1984
696    -6.60813     -5.76418     28.1687      17.2553      26.2777      \
1.1984
697    -6.46234     -5.57416     28.2681      17.2553      26.2777      \
1.1984
698    -6.30896     -5.38334     28.3497      17.2553      26.2777      \
1.1984
699    -6.14916     -5.19268     28.4135      17.2553      26.2777      \
1.1984
700    -5.98407     -5.00305     28.4597      17.2553      26.2777      \
1.1984
701    -5.97722     -0.98014     32.8575      17.2154      26.3666      \
1.20795
702    -5.117       -0.582279    32.5193      17.2154      26.3666      \
1.20795
703    -4.33663     -0.261529    32.1564      17.2154      26.3666      \
1.20795
704    -3.63559     -0.00773598  31.7798      17.2154      26.3666      \
1.20795
705    -3.01169     0.189226     31.3971      17.2154      26.3666      \
1.20795
706    -2.4614      0.338898     31.0137      17.2154      26.3666      \
1.20795
707    -1.98014     0.449917     30.633       17.2154      26.3666      \
1.20795
708    -1.56265     0.529873     30.2571      17.2154      26.3666      \
1.20795
709    -1.20327     0.585282     29.8873      17.2154      26.3666      \
1.20795
710    -0.896195    0.621627     29.524       17.2154      26.3666      \
1.20795
711    -0.635694    0.64345      29.1676      17.2154      26.3666      \
1.20795
712    -0.416235    0.654458     28.8179      17.2154      26.3666      \
1.20795
713    -0.232605    0.657636     28.4748      17.2154      26.3666      \
1.20795
714    -0.0799808   0.655355     28.138       17.2154      26.3666      \
1.20795
715    0.0460383    0.649476     27.8072      17.2154      26.3666      \
1.20795
716    0.149412     0.641437     27.4822      17.2154      26.3666      \
1.20795
717    0.233666     0.632334     27.1628      17.2154      26.3666      \
1.20795
718    0.301904     0.622987     26.8487      17.2154      26.3666      \
1.20795
719    0.356837     0.613998     26.5399      17.2154      26.3666      \
1.20795
720    0.400814     0.605797     26.2362      17.2154      26.3666      \
1.20795
721    0.43585      0.59868      25.9374      17.2154      26.3666      \
1.20795
722    0.463668     0.592846     25.6436      17.2154      26.3666      \
1.20795
723    0.485726     0.588415     25.3547      17.2154      26.3666      \
1.20795
724    0.503252     0.585454     25.0706      17.2154      26.3666      \
1.20795
725    0.517275     0.583989     24.7913      17.2154      26.3666      \
1.20795
726    0.528653     0.584019     24.5169      17.2154      26.3666      \
1.20795
727    0.538094     0.585527     24.2474      17.2154      26.3666      \
1.20795
728    0.546184     0.588483     23.9828      17.2154      26.3666      \
1.20795
729    0.5534       0.592853     23.7232      17.2154      26.3666      \
1.20795
730    0.560136     0.598599     23.4686      17.2154      26.3666      \
1.20795
731    0.566707     0.605685     23.2192      17.2154      26.3666      \
1.20795
732    0.573372     0.614076     22.975       17.2154      26.3666      \
1.20795
733    0.580337     0.623737     22.7363      17.2154      26.3666      \
1.20795
734    0.587768     0.63464      22.503       17.2154      26.3666      \
1.20795
735    0.595797     0.646755     22.2754      17.2154      26.3666      \
1.20795
736    0.604529     0.660055     22.0538      17.2154      26.3666      \
1.20795
737    0.614046     0.674513     21.8382      17.2154      26.3666      \
1.20795
738    0.624412     0.690102     21.629       17.2154      26.3666      \
1.20795
739    0.635674     0.706792     21.4264      17.2154      26.3666      \
1.20795
740    0.647868     0.724547     21.2307      17.2154      26.3666      \
1.20795
741    0.661016     0.743327     21.0423      17.2154      26.3666      \
1.20795
742    0.675129     0.763082     20.8616      17.2154      26.3666      \
1.20795
743    0.69021      0.783749     20.689       17.2154      26.3666      \
1.20795
744    0.706248     0.805254     20.5249      17.2154      26.3666      \
1.20795
745    0.723223     0.827501     20.37        17.2154      26.3666      \
1.20795
746    0.7411       0.850374     20.2248      17.2154      26.3666      \
1.20795
747    0.759833     0.873729     20.0899      17.2154      26.3666      \
1.20795
748    0.779357     0.897391     19.9662      17.2154      26.3666      \
1.20795
749    0.799588     0.921149     19.8543      17.2154      26.3666      \
1.20795
750    0.820421     0.944747     19.7552      17.2154      26.3666      \
1.20795
751    -9.3915      -16.5959     13.9497      17.2692      26.413       \
1.22677
752    -10.6356     -17.6004     15.3373      17.2692      26.413       \
1.22677
753    -11.8381     -18.6023     17.0214      17.2692      26.413       \
1.22677
754    -13.0057     -19.5276     19.0157      17.2692      26.413       \
1.22677
755    -14.1313     -20.2933     21.3239      17.2692      26.413       \
1.22677
756    -15.1946     -20.8077     23.9327      17.2692      26.413       \
1.22677
757    -16.163      -20.9735     26.8044      17.2692      26.413       \
1.22677
758    -16.9927     -20.696      29.8701      17.2692      26.413       \
1.22677
759    -17.631      -19.8955     33.0257      17.2692      26.413       \
1.22677
760    -18.0207     -18.5228     36.1337      17.2692      26.413       \
1.22677
761    -18.1058     -16.5765     39.0337      17.2692      26.413       \
1.22677
762    -17.84       -14.1155     41.5612      17.2692      26.413       \
1.22677
763    -17.1951     -11.2615     43.5745      17.2692      26.413       \
1.22677
764    -16.1688     -8.18829     44.9816      17.2692      26.413       \
1.22677
765    -14.7893     -5.09577     45.7602      17.2692      26.413       \
1.22677
766    -13.1145     -2.17685     45.961       17.2692      26.413       \
1.22677
767    -11.2255     0.413509     45.6938      17.2692      26.413       \
1.22677
768    -9.21627     2.57718      45.1009      17.2692      26.413       \
1.22677
769    -7.18121     4.27568      44.3266      17.2692      26.413       \
1.22677
770    -5.20507     5.51965      43.4939      17.2692      26.413       \
1.22677
771    -3.35604     6.35194      42.6922      17.2692      26.413       \
1.22677
772    -1.68312     6.83092      41.9744      17.2692      26.413       \
1.22677
773    -0.216731    7.01821      41.363       17.2692      26.413       \
1.22677
774    1.02859      6.97157      40.8577      17.2692      26.413       \
1.22677
775    2.05077      6.74204      40.444       17.2692      26.413       \
1.22677
776    2.85688      6.37366      40.1001      17.2692      26.413       \
1.22677
777    3.46037      5.90425      39.8024      17.2692      26.413       \
1.22677
778    3.87887      5.36647      39.5287      17.2692      26.413       \
1.22677
779    4.13258      4.7886       39.2605      17.2692      26.413       \
1.22677
780    4.24309      4.19492      38.9841      17.2692      26.413       \
1.22677
781    4.23243      3.60593      38.6902      17.2692      26.413       \
1.22677
782    4.12237      3.03828      38.3741      17.2692      26.413       \
1.22677
783    3.93374      2.50488      38.0344      17.2692      26.413       \
1.22677
784    3.68603      2.01495      37.6724      17.2692      26.413       \
1.22677
785    3.39692      1.57434      37.2913      17.2692      26.413       \
1.22677
786    3.08203      1.18588      36.8948      17.2692      26.413       \
1.22677
787    2.75479      0.849923     36.4872      17.2692      26.413       \
1.22677
788    2.42633      0.564833     36.0723      17.2692      26.413       \
1.22677
789    2.1056       0.327533     35.6537      17.2692      26.413       \
1.22677
790    1.79947      0.133974     35.2343      17.2692      26.413       \
1.22677
791    1.51292      -0.0204518   34.8161      17.2692      26.413       \
1.22677
792    1.24927      -0.140577    34.4009      17.2692      26.413       \
1.22677
793    1.01045      -0.23121     33.9897      17.2692      26.413       \
1.22677
794    0.797243     -0.296945    33.5833      17.2692      26.413       \
1.22677
795    0.609482     -0.342045    33.182       17.2692      26.413       \
1.22677
796    0.446316     -0.370365    32.7861      17.2692      26.413       \
1.22677
797    0.306379     -0.385317    32.3955      17.2692      26.413       \
1.22677
798    0.187953     -0.389864    32.0102      17.2692      26.413       \
1.22677
799    0.0891127    -0.38653     31.6301      17.2692      26.413       \
1.22677
800    0.00783171   -0.377433    31.2551      17.2692      26.413       \
1.22677
801    8.12946      10.0381      27.6385      17.2825      26.3531      \
1.24491
802    8.45942      9.83322      28.1105      17.2825      26.3531      \
1.24491
803    8.69687      9.58614      28.5926      17.2825      26.3531      \
1.24491
804    8.85053      9.29525      29.0709      17.2825      26.3531      \
1.24491
805    8.92735      8.96124      29.5328      17.2825      26.3531      \
1.24491
806    8.93318      8.58694      29.967       17.2825      26.3531      \
1.24491
807    8.87333      8.17707      30.3635      17.2825      26.3531      \
1.24491
808    8.75303      7.73788      30.7145      17.2825      26.3531      \
1.24491
809    8.57765      7.27676      31.0136      17.2825      26.3531      \
1.24491
810    8.35294      6.8018       31.2567      17.2825      26.3531      \
1.24491
811    8.08504      6.3213       31.4416      17.2825      26.3531      \
1.24491
812    7.78045      5.84338      31.568       17.2825      26.3531      \
1.24491
813    7.44596      5.37552      31.6371      17.2825      26.3531      \
1.24491
814    7.08848      4.92431      31.6517      17.2825      26.3531      \
1.24491
815    6.71485      4.49523      31.6156      17.2825      26.3531      \
1.24491
816    6.33169      4.0925       31.5335      17.2825      26.3531      \
1.24491
817    5.94519      3.71911      31.4103      17.2825      26.3531      \
1.24491
818    5.561        3.37682      31.2512      17.2825      26.3531      \
1.24491
819    5.18408      3.06635      31.0615      17.2825      26.3531      \
1.24491
820    4.81866      2.78746      30.8459      17.2825      26.3531      \
1.24491
821    4.46822      2.53921      30.609       17.2825      26.3531      \
1.24491
822    4.13545      2.32006      30.3549      17.2825      26.3531      \
1.24491
823    3.82231      2.12813      30.0871      17.2825      26.3531      \
1.24491
824    3.53011      1.96124      29.8087      17.2825      26.3531      \
1.24491
825    3.25956      1.81713      29.5222      17.2825      26.3531      \
1.24491
826    3.01083      1.69352      29.2301      17.2825      26.3531      \
1.24491
827    2.78371      1.58818      28.934       17.2825      26.3531      \
1.24491
828    2.57761      1.49902      28.6355      17.2825      26.3531      \
1.24491
829    2.39169      1.42409      28.3358      17.2825      26.3531      \
1.24491
830    2.22492      1.36161      28.0361      17.2825      26.3531      \
1.24491
831    2.07614      1.31         27.737       17.2825      26.3531      \
1.24491
832    1.94412      1.26784      27.4393      17.2825      26.3531      \
1.24491
833    1.82759      1.2339       27.1436      17.2825      26.3531      \
1.24491
834    1.72531      1.20712      26.8504      17.2825      26.3531      \
1.24491
835    1.63605      1.18659      26.5599      17.2825      26.3531      \
1.24491
836    1.55863      1.17153      26.2726      17.2825      26.3531      \
1.24491
837    1.49197      1.1613       25.9888      17.2825      26.3531      \
1.24491
838    1.43503      1.15534      25.7086      17.2825      26.3531      \
1.24491
839    1.38688      1.1532       25.4323      17.2825      26.3531      \
1.24491
840    1.34667      1.15452      25.1602      17.2825      26.3531      \
1.24491
841    1.31361      1.15899      24.8923      17.2825      26.3531      \
1.24491
842    1.28702      1.16636      24.6289      17.2825      26.3531      \
1.24491
843    1.26628      1.17645      24.3702      17.2825      26.3531      \
1.24491
844    1.25086      1.18909      24.1162      17.2825      26.3531      \
1.24491
845    1.24028      1.20416      23.8673      17.2825      26.3531      \
1.24491
846    1.23412      1.22157      23.6236      17.2825      26.3531      \
1.24491
847    1.23203      1.24123      23.3852      17.2825      26.3531      \
1.24491
848    1.23369      1.26308      23.1524      17.2825      26.3531      \
1.24491
849    1.23883      1.28708      22.9253      17.2825      26.3531      \
1.24491
850    1.24723      1.31317      22.7043      17.2825      26.3531      \
1.24491
851    11.1568      11.435       30.3268      17.3863      26.7909      \
1.25597
852    11.2052      10.9261      31.2218      17.3863      26.7909      \
1.25597
853    11.1567      10.3203      32.0542      17.3863      26.7909      \
1.25597
854    11.0114      9.62954      32.8035      17.3863      26.7909      \
1.25597
855    10.7712      8.87059      33.4529      17.3863      26.7909      \
1.25597
856    10.441       8.06343      33.9898      17.3863      26.7909      \
1.25597
857    10.0279      7.22996      34.407       17.3863      26.7909      \
1.25597
858    9.54185      6.3924       34.7029      17.3863      26.7909      \
1.25597
859    8.99478      5.5717       34.8807      17.3863      26.7909      \
1.25597
860    8.40025      4.78621      34.9483      17.3863      26.7909      \
1.25597
861    7.77262      4.05077      34.9167      17.3863      26.7909      \
1.25597
862    7.12635      3.37618      34.799       17.3863      26.7909      \
1.25597
863    6.47524      2.76916      34.6093      17.3863      26.7909      \
1.25597
864    5.83188      2.23267      34.3613      17.3863      26.7909      \
1.25597
865    5.20715      1.76641      34.0681      17.3863      26.7909      \
1.25597
866    4.61001      1.36758      33.7409      17.3863      26.7909      \
1.25597
867    4.04737      1.03157      33.3896      17.3863      26.7909      \
1.25597
868    3.52413      0.752589     33.022       17.3863      26.7909      \
1.25597
869    3.04335      0.524289     32.6444      17.3863      26.7909      \
1.25597
870    2.60643      0.340167     32.2616      17.3863      26.7909      \
1.25597
871    2.21342      0.193908     31.877       17.3863      26.7909      \
1.25597
872    1.86325      0.0795994    31.4932      17.3863      26.7909      \
1.25597
873    1.55403      -0.00813397  31.1119      17.3863      26.7909      \
1.25597
874    1.28325      -0.0740685   30.7343      17.3863      26.7909      \
1.25597
875    1.04801      -0.122365    30.3611      17.3863      26.7909      \
1.25597
876    0.845209     -0.156589    29.9928      17.3863      26.7909      \
1.25597
877    0.671643     -0.179749    29.6295      17.3863      26.7909      \
1.25597
878    0.524159     -0.194349    29.2715      17.3863      26.7909      \
1.25597
879    0.399714     -0.202446    28.9186      17.3863      26.7909      \
1.25597
880    0.295436     -0.205709    28.571       17.3863      26.7909      \
1.25597
881    0.208665     -0.205473    28.2285      17.3863      26.7909      \
1.25597
882    0.136971     -0.202794    27.8911      17.3863      26.7909      \
1.25597
883    0.0781618    -0.198493    27.5588      17.3863      26.7909      \
1.25597
884    0.0302848    -0.193199    27.2315      17.3863      26.7909      \
1.25597
885    -0.00838296  -0.187387    26.9091      17.3863      26.7909      \
1.25597
886    -0.0393476   -0.181404    26.5918      17.3863      26.7909      \
1.25597
887    -0.0639141   -0.1755      26.2794      17.3863      26.7909      \
1.25597
888    -0.0832045   -0.169848    25.972       17.3863      26.7909      \
1.25597
889    -0.0981758   -0.164561    25.6696      17.3863      26.7909      \
1.25597
890    -0.109639    -0.159705    25.3722      17.3863      26.7909      \
1.25597
891    -0.118275    -0.155315    25.0799      17.3863      26.7909      \
1.25597
892    -0.124655    -0.151402    24.7926      17.3863      26.7909      \
1.25597
893    -0.129251    -0.147958    24.5105      17.3863      26.7909      \
1.25597
894    -0.132452    -0.144962    24.2337      17.3863      26.7909      \
1.25597
895    -0.134577    -0.14239     23.9622      17.3863      26.7909      \
1.25597
896    -0.135885    -0.140209    23.6962      17.3863      26.7909      \
1.25597
897    -0.136585    -0.138384    23.4357      17.3863      26.7909      \
1.25597
898    -0.136843    -0.136881    23.1808      17.3863      26.7909      \
1.25597
899    -0.136791    -0.135664    22.9319      17.3863      26.7909      \
1.25597
900    -0.136531    -0.134697    22.689       17.3863      26.7909      \
1.25597
901    7.37592      11.3101      15.3191      17.4835      26.8429      \
1.29983
902    8.06374      12.047       15.9543      17.4835      26.8429      \
1.29983
903    8.75997      12.8044      16.7187      17.4835      26.8429      \
1.29983
904    9.4668       13.563       17.624       17.4835      26.8429      \
1.29983
905    10.1826      14.2994      18.6807      17.4835      26.8429      \
1.29983
906    10.9019      14.9862      19.8967      17.4835      26.8429      \
1.29983
907    11.6155      15.5915      21.2759      17.4835      26.8429      \
1.29983
908    12.3101      16.0791      22.8156      17.4835      26.8429      \
1.29983
909    12.9684      16.4095      24.5048      17.4835      26.8429      \
1.29983
910    13.5694      16.5424      26.3219      17.4835      26.8429      \
1.29983
911    14.0884      16.4395      28.2329      17.4835      26.8429      \
1.29983
912    14.4986      16.0691      30.1909      17.4835      26.8429      \
1.29983
913    14.7722      15.4109      32.1373      17.4835      26.8429      \
1.29983
914    14.8828      14.461       34.0049      17.4835      26.8429      \
1.29983
915    14.8079      13.2359      35.7234      17.4835      26.8429      \
1.29983
916    14.5319      11.7738      37.2269      17.4835      26.8429      \
1.29983
917    14.0486      10.1332      38.4618      17.4835      26.8429      \
1.29983
918    13.363       8.38726      39.394       17.4835      26.8429      \
1.29983
919    12.4922      6.61605      40.0129      17.4835      26.8429      \
1.29983
920    11.4644      4.89689      40.3318      17.4835      26.8429      \
1.29983
921    10.316       3.29596      40.3845      17.4835      26.8429      \
1.29983
922    9.08898      1.86245      40.2183      17.4835      26.8429      \
1.29983
923    7.8263       0.62616      39.8865      17.4835      26.8429      \
1.29983
924    6.56867      -0.401524    39.4411      17.4835      26.8429      \
1.29983
925    5.35165      -1.22433     38.9278      17.4835      26.8429      \
1.29983
926    4.20387      -1.85675     38.3829      17.4835      26.8429      \
1.29983
927    3.14644      -2.31974     37.8327      17.4835      26.8429      \
1.29983
928    2.19311      -2.63714     37.2942      17.4835      26.8429      \
1.29983
929    1.35103      -2.83309     36.7769      17.4835      26.8429      \
1.29983
930    0.621923     -2.93041     36.2847      17.4835      26.8429      \
1.29983
931    0.00321612   -2.94968     35.8173      17.4835      26.8429      \
1.29983
932    -0.510799    -2.90895     35.3727      17.4835      26.8429      \
1.29983
933    -0.927974    -2.82364     34.9471      17.4835      26.8429      \
1.29983
934    -1.25747     -2.70673     34.5369      17.4835      26.8429      \
1.29983
935    -1.50912     -2.56892     34.1384      17.4835      26.8429      \
1.29983
936    -1.69288     -2.41895     33.7485      17.4835      26.8429      \
1.29983
937    -1.8185      -2.26377     33.3648      17.4835      26.8429      \
1.29983
938    -1.89522     -2.1088      32.9853      17.4835      26.8429      \
1.29983
939    -1.93164     -1.95815     32.6088      17.4835      26.8429      \
1.29983
940    -1.93552     -1.81479     32.2345      17.4835      26.8429      \
1.29983
941    -1.91384     -1.68077     31.8621      17.4835      26.8429      \
1.29983
942    -1.87266     -1.55737     31.4913      17.4835      26.8429      \
1.29983
943    -1.81724     -1.44525     31.1223      17.4835      26.8429      \
1.29983
944    -1.75202     -1.34459     30.7553      17.4835      26.8429      \
1.29983
945    -1.68071     -1.25521     30.3907      17.4835      26.8429      \
1.29983
946    -1.60631     -1.17666     30.0286      17.4835      26.8429      \
1.29983
947    -1.53126     -1.10833     29.6695      17.4835      26.8429      \
1.29983
948    -1.45743     -1.04949     29.3136      17.4835      26.8429      \
1.29983
949    -1.38627     -0.99937     28.9613      17.4835      26.8429      \
1.29983
950    -1.31881     -0.95718     28.6128      17.4835      26.8429      \
1.29983
951    -3.33669     -4.1729      20.1319      17.3788      26.5432      \
1.32497
952    -3.48206     -4.34509     20.0045      17.3788      26.5432      \
1.32497
953    -3.63205     -4.52928     19.891       17.3788      26.5432      \
1.32497
954    -3.78795     -4.72548     19.7928      17.3788      26.5432      \
1.32497
955    -3.95083     -4.93368     19.711       17.3788      26.5432      \
1.32497
956    -4.12157     -5.15384     19.6473      17.3788      26.5432      \
1.32497
957    -4.30088     -5.38585     19.6031      17.3788      26.5432      \
1.32497
958    -4.48934     -5.62946     19.5799      17.3788      26.5432      \
1.32497
959    -4.68737     -5.88432     19.5797      17.3788      26.5432      \
1.32497
960    -4.89527     -6.14984     19.6042      17.3788      26.5432      \
1.32497
961    -5.11318     -6.42526     19.6553      17.3788      26.5432      \
1.32497
962    -5.34107     -6.70948     19.7352      17.3788      26.5432      \
1.32497
963    -5.57874     -7.00113     19.8459      17.3788      26.5432      \
1.32497
964    -5.82579     -7.29845     19.9896      17.3788      26.5432      \
1.32497
965    -6.08157     -7.59924     20.1683      17.3788      26.5432      \
1.32497
966    -6.34516     -7.90086     20.3838      17.3788      26.5432      \
1.32497
967    -6.61535     -8.20019     20.6381      17.3788      26.5432      \
1.32497
968    -6.89059     -8.49357     20.9324      17.3788      26.5432      \
1.32497
969    -7.16897     -8.77684     21.2678      17.3788      26.5432      \
1.32497
970    -7.44818     -9.04536     21.6447      17.3788      26.5432      \
1.32497
971    -7.72551     -9.29404     22.0628      17.3788      26.5432      \
1.32497
972    -7.99784     -9.5175      22.5209      17.3788      26.5432      \
1.32497
973    -8.26165     -9.71017     23.017       17.3788      26.5432      \
1.32497
974    -8.51306     -9.86647     23.5478      17.3788      26.5432      \
1.32497
975    -8.74791     -9.9811      24.1089      17.3788      26.5432      \
1.32497
976    -8.96183     -10.0492     24.6949      17.3788      26.5432      \
1.32497
977    -9.15037     -10.0668     25.2991      17.3788      26.5432      \
1.32497
978    -9.30916     -10.0309     25.914       17.3788      26.5432      \
1.32497
979    -9.43407     -9.9397      26.5312      17.3788      26.5432      \
1.32497
980    -9.52139     -9.79307     27.1423      17.3788      26.5432      \
1.32497
981    -9.56802     -9.59226     27.7382      17.3788      26.5432      \
1.32497
982    -9.57162     -9.3401      28.3107      17.3788      26.5432      \
1.32497
983    -9.53075     -9.04079     28.852       17.3788      26.5432      \
1.32497
984    -9.44497     -8.69972     29.355       17.3788      26.5432      \
1.32497
985    -9.31484     -8.32315     29.8143      17.3788      26.5432      \
1.32497
986    -9.14191     -7.9179      30.2253      17.3788      26.5432      \
1.32497
987    -8.92865     -7.49102     30.5848      17.3788      26.5432      \
1.32497
988    -8.67833     -7.04951     30.8912      17.3788      26.5432      \
1.32497
989    -8.39487     -6.60008     31.1435      17.3788      26.5432      \
1.32497
990    -8.08267     -6.14901     31.342       17.3788      26.5432      \
1.32497
991    -7.74643     -5.702       31.4876      17.3788      26.5432      \
1.32497
992    -7.39107     -5.26417     31.5822      17.3788      26.5432      \
1.32497
993    -7.0215      -4.83996     31.628       17.3788      26.5432      \
1.32497
994    -6.64255     -4.4332      31.6277      17.3788      26.5432      \
1.32497
995    -6.25889     -4.04703     31.5844      17.3788      26.5432      \
1.32497
996    -5.8749      -3.68394     31.5015      17.3788      26.5432      \
1.32497
997    -5.49465     -3.34577     31.3827      17.3788      26.5432      \
1.32497
998    -5.1218      -3.03371     31.2315      17.3788      26.5432      \
1.32497
999    -4.75959     -2.74835     31.0519      17.3788      26.5432      \
1.32497
1000   -4.41079     -2.48971     30.8474      17.3788      26.5432      \
1.32497
1001   -4.41458     0.0554318    27.8321      17.1817      26.2918      \
1.32031\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({153.8866719365463`, 220.50839277585666`, 383.9575269033855`, 
      226.0427144914787`, 48.674006043035114`, 54.8167465671286`}\)], "Output"],

Cell[BoxData[
    \({{0.8256975229368245`, 
        0.8004353095006735`, \(-5.445499531885002`\), \
\(-6.9717770411759235`\), 1.3939393788983698`, 
        1.5574463463829382`}, {4.79329468632723`, 6.923487504429206`, 
        10.845397236046487`, 1.561598347302623`, 0.6509416872206304`, 
        0.7591012505014515`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF(0)", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{85.92451370491837, 138.93455426838256, \
162.27861139144125, 25.12424276224525, 15.785931841132768, 9.072918664102978}\
\
\>", "\<\
{85.9245, 138.935, 162.279, 25.1242, 15.7859, 9.07292}\
\>"], \
"Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-0.15813929525816642, -0.28708554276393833, \
-1.089889102232879, -0.700082800103109, -0.3984106402572074, \
-0.09945006185755041}, {2.711206073376374, 4.3819069745998895, \
5.012003733068537, 0.3748080180554098, 0.30035921681436034, \
0.2689708212139183}}\
\>", "\<\
{{-0.158139, -0.287086, -1.08989, -0.700083, \
-0.398411, -0.0994501}, {2.71121, 4.38191, 5.012, 0.374808, 0.300359, \
0.268971}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,25},{20,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.01{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-30, 20}, {-30, 30}, {0, 60}, {5, 25}, {20, 35}, \
{0, 8}}\
\>", "\<\
{{-30, 20}, {-30, 30}, {0, 60}, {5, 25}, {20, 35}, {0, 8}}\
\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gGHF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],PlotLabel->\"GHF, m=2\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {21, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {21, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {21, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {2}
Dimension der Daten  {2, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {2}
Dimension der Daten  {2, 2}
Dimension der Daten  {1001, 2}
Dimension der Daten  {1001, 4}
Dimension der Daten  {2}
Dimension der Daten  {2, 2}\
\>", "Print",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PICT", "\<\
:K`0100Y0?P2O@0A0_l<0?ooool0:@0000@0009m0000n0000000000N00402P04
02T0n09m09X0003oRE0000000?@2E00000@0000004P0E@1804@0400P00<02000
000KR>c<000000000000m09D00@0:@3h0Wd0901=POn1onkooP01ooon003onP3W
ooh0POn1oh7oPOoJooh00OoooP00ooX0ioon087oPOn1oh7of_on007oooh00?oj
0>OooP21oh7okOl0KX7oPOo_o`00o_l<0?oo0?oo0?oo0?oo0>So003no`00POn1
oh7oPOoLo`00o_l<0?oo0?oo0?oo0?oo0>So003no`00POn1oh7oPOoLo`00o_l<
0?oo0?oo0?oo0?oo0>So003no`00POn1onko0761oh7okol00?_o1P3oo`3oo`3a
o`<00?l0nOl00?ko0021oh7oPOn1omco003ko`H0ool0ool0lOl3003o0?Wo003n
o`00POn1oh7oPOoLo`00nol60?oo0?oo0?7o0`00o`3io`00o_l0087oPOo^o`1g
POn1onoo0@3oo@00ood00OoooP3co`D0o`3o0?ol0?go0021oh7oPOn1om_o0@3o
o@00ood00OoooP3co`D0o`3o0?ol0?go0021oh7oPOn1om_o0@3oo@00ood00Ooo
oP3co`D0o`3o0?ol0?go0021oh7okOl0LH7oPOo_o`00o_l90?oo0?oo0?oo0?7o
103o0?l0n?l0087oPOn1oh7of_l00?ko2@3oo`3oo`3oo`3ao`@0o`3o0?So0021
oh7oPOn1om[o003no`T0ool0ool0ool0lOl40?l0o`3ho`00POn1onco08>1oh7o
kol00?ko2@3oo`3oo`3oo`3ao`D0o`3o0?ol00Goo`3oo`21oh7oPOn1omco003n
o`T0ool0ool0ool0lOl50?l0o`3oo005ool0ool0POn1oh7oPOoLo`00o_l90?oo
0?oo0?oo0?7o1@3o0?l0oo`01Ooo0?oo087oPOo^o`1aPOn1onkooP01ooon003o
o03ko`00nOl40?l0o`3joo`0POn1oh7oPOoKooh00OoooP00oo`0nol00?Wo103o
0?l0n_ol087oPOn1oh7ofoon007oooh00?ol0?_o003io`@0o`3o0?[oo021oh7o
k_l09X7oPOoJo`00POn1oh7oPOn^o`00POn1oh7oPOn^o`00POn1omGo02J1oh7o
fol0087oPOn1oh7o[_l0087oPOn1oh7o[_l0087oPOoDo`0LPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0L
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0LPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
POn5o`0LPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0LPOn1oh7oPOn1oh7o
POn1oh7oPOn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0L
POn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7o
POn1oh7oPOn5o`0LPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn5o`0LPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oPOn5o`1>Q_l4003o0021omOo1000o`00POoJoo`0
POn=o`@00?l0087oeol4003o0021om[oo021ohgo1000o`00POoGo`@00?l0087o
f_ol08So04^5o`80o`21omGo0P3o087ofOl30?oo087oRol20?l0POoEo`80o`21
omWo0`3oo`21oh_o0P3o087oeOl20?l0POoIo`<0ool0Qol0?8Co0021omCo0P3o
087oeol0087oROl0087oe?l20?l0POoGo`00POn9o`00POoDo`80o`21omOo0026
o`15QOl20?l0POoDo`00POoGo`<0ool0POn<o`80o`21omCo0021omOo0`3oo`21
ohco0P3o087oe?l0087oeol30?oo08So04:6o`@00?l0087oeOl0087of?ol087o
SOl4003o0021omGo0021omSoo021ohgo1000o`00POoEo`00POoHoo`0R?l09X7o
POoFo`00POn1oh7oPOn^o`00POn1oh7oPOn^o`00POn1omWo06kEooh0oOl10021
om_ooP3mo`400;_ooP2Vo`400?go0@00POnAooh0oOl10021om_ooP3mo`400;_o
oP2Vo`400?go0@00POnAooh0oOl10021om_ooP3mo`400;_ooP2Vo`400?go0@00
POnmo`29e_l00?ko1P3oo`3oo`21omgo003no`H0ool0ool0POoOo`00o?l30?oo
087oTol00?ko1P3oo`3oo`21omgo003no`H0ool0ool0POoOo`00o?l30?oo087o
Tol00?ko1P3oo`3oo`21omgo003no`H0ool0ool0POoOo`00o?l30?oo087o__l0
OMKo003no`H0ool0ool0POoIo`H0ool0ool0POoPo`00nol30?oo087oTol00?ko
1P3oo`3oo`21omWo1P3oo`3oo`21on3o003ko`<0ool0POnCo`00o_l60?oo0?oo
087ofOl60?oo0?oo087oh?l00?_o0`3oo`21okko0<kCo`00o_l50?oo0?ooP@3d
0>[o0@00o_l50?oo0?ooP@3d0>ooo@3no`D0ool0oooi003oo000oh<0Wol00?ko
1@3oo`3ooo`00_X0nX40o03Zo`400?ko1@3oo`3oood00_X0nX40n`3_ood0o_l5
0?oo0?ooo03nnP800?Z1004009oo003no`D0ool0oool00:J09Z10?`0j_l1003n
o`D0ool0ooom00:J09Z10?/0koom0?ko1@3oo`3ooo`0oYX2002JP@01003=o`61
e?l00?go1P3oo`3oo`3mo`80o`3]o`00i_l00>Ko003Vo`00i_l00>So2@3oo`3o
o`3oo`3no`<0o`00kOl00>Ko003Vo`00i_l00>Ko003_o`00o_l90?oo0?oo0?oo
0?gooP02ool0l?l00>Ko003Vo`00i_l00>Ko002Po`00oOl60?oo0?oo0?go0_[o
n^go003Vo`00i_l00>Ko003Vo`00j?l90?oo0?oo0?oo0?ko0o[on_[]o`00i_l0
0>Ko003Vo`00i_l00>oo003no`T0ool0ool0ool0oOonnP80oo[no`00m?l00>Ko
003Vo`00i_l00>Ko002Po`00oOl60?oo0?oo0?go0Y[oV^go003Vo`00i_l00>Ko
003Vo`00j?l90?oo0?oo0?oo0?ko0i[oVY[]o`00i_l00>Ko003Vo`00i_l00>oo
003no`T0ool0ool0ool0oOonVP80oi[no`00m?l00>Ko003Vo`00i_l00>Ko003=
o`4@eOl<0?oo0?oo0?oo0?oo0?go0P3o087ooOl00>co003no`T0ool0ool0ool0
o_l30?l0087ooOl00>oo003no`T0ool0ool0ool0oOon00;o0021o`7o0:7o303o
o`3oo`3oo`3oo`3mo`;jooZ1oogo003/o`00o_l90?oo0?oo0?oo0?ko0o[on_Z1
oogo003_o`00o_l90?oo0?oo0?oo0?goo_X20?[jo_l008Co002Qo``0ool0ool0
ool0ool0oOl2V_nJPOomo`00k?l00?ko2@3oo`3oo`3oo`3no`>JoiZJPOomo`00
kol00?ko2@3oo`3oo`3oo`3moojJ0P2JV_ko0024o`00cOl0nMKoo03no`400?ko
0@00o_l20?l0^Ol00<Ko003[ooh0oOl1003no`L00?oo0?l0087ooOl00>kooP3m
o`400?ko0@00o_on007o087o0_oo0:;oo03no`400?ko0@00o_l2n_oj^Ol0n/Ko
003[ooh0oOl1003no`L00?oon_ojnX7ooOl00>kooP3mo`400?ko0@00o_onnP40
n_go0024o`00X_ol0?ko0@00o_l1003no`:JoiZio`2Ja_l00>_ooP3mo`400?ko
1`00oonJoiZJPOomo`00k_on0?go0@00o_l1003noojJ0@2JoOl008Co003=o`2R
bOl00?go0P3o0;Wo0036o`00gol00?ko0`3o0021oogo003Ro`00oOon007o087o
0_oo09Go003mo`;jooZio`3ja_l00=oo003no`?joo[jPOomo`00h_l00?goo_X1
0?[mo`00Q?l009Go003mo`:JoiZio`2Ja_l00=oo003no`>JoiZJPOomo`00h_l0
0?gooYX109[mo`00Q?l00<go0;W9o`00oOl20?l0m?l00<So0@00d_l00?Ko003O
o`00o_l30?oo087ooOl00>;o003mooh00Ol0POl2ool0UOl00?go0_[on_Co0038
o`7jn];o0?[fo`00gol00?ko0o[oooZ1oogo003Ro`00oOonnP40n_go0024o`00
UOl00?go0Y[oV[[o0IZJd_l0V_Ko003Oo`00o_l3V_ooVX7ooOl00>;o003moojJ
0@2JoOl008Co003=o`3@bOl00?ko0`3oo`3eooh0bOon0=?o0@00mol00=oo2@00
ool0ool0o`21o`;oo`3Ro`400?ko103o0?l0POl2ool0UOl00?ko0o[ooo[eooh0
bOl2nP3jdol1n_[go`00gol9003ooo[ooo[onX7o0_oo0>;o0@00o_l4n_oj0?[m
o`00Q?l009Go003no`>JoonJmOon0<Wo0Y[oV]?o0IZJmol00=oo2@00oonJoonJ
oiZ1o`;oo`3Ro`400?ko19[oVP2JoOl008Co003=o`3>bOl7003oo`3oo`3eooh0
bOom0=Co0@00mol00=oo003no`D0ool0o`21o`;oo`3Ro`00oOl40?l0o`21o`;o
o`2Eo`L00?oon_oon_GooP39o`?j0?X0e?l1n_[go`00gol00?ko1O[ooo[onX7o
0_oo0>;o003mo`CjooX0n_go0024o`00UOl7003ooi[ooi[eooh0bOl2V_nJdol1
VY[go`00gol00?ko1I[ooi[oVX7o0_oo0>;o003mo`BJoiX0V_go0024o`00cOl0
fLWo003no`<0ool0mOon0=;o003io`<0o`00eOon0?Oo003Oo`T00?oo0?oo0?l0
POl2ool0h_l1003no`80o`21oogo002Eo`00o_l3n_oon_GooP3Bo`00nOl3nP3j
0=Go0_X0n_Oo003Oo`T00?oon_oon_ojPOl2ool0h_l1003no`?jooX0o?l008Co
002Eo`00o_l3V_ooV_GooP39o`:J09[Do`:Joi[go`00gol9003ooi[ooi[oVX7o
0_oo0>;o0@00o_l3V_nJ0?co0024o`00cOl0hLWo003no`<0ool0mOl20?l0doon
0?[o0`3o003Eo`80o`3go`00gol00?ko1@3oo`3o087o0_oo0>;o003mo`80o`21
oogo002Eo`00o_l3n_oon_Go0P00n]?ooP3jo`?j0?X0eOl2nP3jmol00=oo003n
o`GjooojooZ1o`;oo`3Ro`00oOl3n_oj0?co0024o`00UOl00?ko0i[ooi[do`40
V]?ooP3jo`:J09[Do`:J09[go`00gol00?ko1I[ooi[oVX7o0_oo0>;o003mo`>J
oiX0o?l008Co003=o`3IbOl7003oo`3oo`3eo`00dOon0?So0@00eOl00?Go003O
o`00o_l50?oo0?l0POl2ool0h_l00?go0P3o087ooOl009Go1`00ooojooojmOon
0=?ooP3jo`<00?X0eOl2nP00mol00=oo003no`GjooojooZ1o`;oo`3Ro`00oOl3
n_oj0?co0024o`00UOl7003ooi[ooi[do`400=?ooP3jo`8009[Do`:J003go`00
gol00?ko1I[ooi[oVX7o0_oo0>;o003mo`>JoiX0o?l008Co003=o`4KbOl00?ko
0`3oo`3eo`00i_l00>gooP3io`80o`3Eo`00mOl00>_ooP3mo`400?ko2@00ool0
ool0o`21o`;oo`3_oo`0o_l1003no`400?ko103o0?l0POl2ool0UOl00?ko0o[o
oo[eooh0j?l00>gooP3jood0eOl2nP00mol00>_ooP3mo`400?ko2@00ooojoooj
ooZ1o`;oo`3_oo`0o_l1003no`400?ko1?[onP00oOl008Co002Eo`00o_l3V_oo
V_Co0@00doon0?[o0P3o0=Co0YX00?Oo003[ooh0oOl1003no`T00?ooV_ooV_nJ
POl2ool0kool0?ko0@00o_l1003no`>JoiX0o?l008Co003=o`4dbOl00?ko0`3o
o`3no`00nOl00>Ko0@00k_l00?Oo0P3o0=Co0P3o0?So003/o`00o_l90?oo0?oo
0?oo0?ko0`3oo`2io`00a_l00>oo003ko`H0ool0ool0oOl40?l0o`21o`;oo`2E
o`00o_l3n_oon_ko003iooh0j?l1003^ooh0n_om0=Goo@3ho`00k?l00?ko2@3o
o`3oo`3oo`3no`Gjooojo`2ko`00a_l00>oo003ko`H0ool0ool0oOl4n_oj003m
o`00Q?l009Go003no`>JoonJm?l1003Bo`400?[o0P3o0=Co0P3o0?Oo003/o`00
o_l90?oo0?oo0?oo0?ko1I[ooi[o087o0_oo0>oo003ko`H0ool0ool0oOl3V_nJ
0?co0024o`00cOl1D/Wo003no`L0ool0ool00?Wo003Vooh0kol00?Oo0P3o0=go
0@00n_l20?l0n?l00>co003no`T0ool0ool0ool0o_l60?oo0?oo0;co0036o`00
koom0?ko1P3oo`3oo`3mo`@0o`3o087o0_oo09Go003no`Ojooojoooj0?WooP3X
ooh0koon0?[o0`3j003Mo`7jn__o0`3j003ho`00k?l00?ko2@3oo`3oo`3oo`3n
o`Kjooojo`3j_?l00<Ko003_ood0o_l60?oo0?oo0?go1?[onP00oOl008Co002E
o`00o_l6V_ooV_ooV_Oo0@00j?on0>ko0@00n_l209X0g?l1VY[ko`80VP3go`00
k?l00?ko2@3oo`3oo`3oo`3no`JJoonJo`2JPOl1o`3_ood0o_l60?oo0?oo0?go
0i[oVP3lo`00Q?l00<go0G7Do`00o?l1003no`/00?oo0?oo0?oo003io`00ioom
0>oo003go`80o`3Nooh0n_l20?l0n?l00>Wo003noa00ool0ool00?oo0?oo0?oo
0;go0@00a_l00>_o2P3oo`3oo`3oo`00o_l40?l0o`2Po`00hOl00:3o003lo`40
0?ko2`00ooojooojoooj0?WooP3Yood0koon0?[o0`3j003Nooh0nol30?X00?So
003Yo`00o_l@0?oo0?oo003ooo[ooo[o0?Zmo`7jn/Ko003[o`X0ool0ool0ool0
0?ko1?[onP00oOl00:Go0?[Qo`00X?l00?co0@00o_l:003ooi[ooi[ooi[go`40
0>SooP3^o`400?[o0P2J0=gooP3ko`80VP3go`00jOl00?ko403oo`3oo`00oonJ
oonJo`2J_Ol1VY[6o`00jol:0?oo0?oo0?oo003no`>JoiX0o?l00:Go09[Qo`00
cOl1T=Go0@00oOl60?oo0?oo0?ko103oo`3ooP3jo`400>oo003jood0l?l00?So
103o0?l0g_on0?So003ho`00j_l00?go1P3oo`3oo`3no`H0ool0ool0_Oon0=?o
003fo`00jol90?oo0?oo0?oo0?go103o0?l0X?l1003Ro`00XOl1003mo`H0ool0
ool0o_l7n_oon_ojnP3jood0lOl00?[oo@3`o`<0o`00nol4nP3j003Nooh0nol3
0?l00?So003Zo`00oOl60?oo0?oo0?ko1_[ooo[o0?Zmo`;jnP3Co`3jm_l00>_o
2@3oo`3oo`3oo`3mo`CjooX00?go002Uo`7jn^;o002Qo`400?go1P3oo`3oo`3n
o`JJoonJoiZJmol1003Xooh0k_l1003ko`>J09X0gOon0?_o0P3o0?Oo003Zo`00
oOl60?oo0?oo0?ko1Y[ooi[o09Zmo`6JV];o09[fo`00jol90?oo0?oo0?oo0?go
0i[oVP3lo`00YOl1VY[Ro`00cOl1^MCo003mo`H0ool0ool0o_l40?oo0?on0?[o
0@00l?l1003jo`00kOl00?So003no`00hol00?gooP3ho`00n?l00>_o303oo`3o
o`3oo`3oo`3no`H0ool0ool0_Oon0=Co0@00m_l00>oo003no`T0ool0ool0ool0
oOl40?l0o`2Po`400>;o002Po`00oOl60?oo0?oo0?ko1o[ooo[on_X0n_l30?X0
0?;o0@00n_l30?l00?3o0`3o003ko`Cj0?l00>?o0?[mooh0nol30?l0n_So003[
o``0ool0ool0ool0ool0o_l6n_oon_l0n[go0_[j0=Co0O[jm_l00>oo003no`T0
ool0ool0ool0oOl4n_oj003mo`00YOl1n_[Ro`00X?l00?go1P3oo`3oo`3no`JJ
oonJoiZJn?l2VP00iol1003^o`400?_o0iX0o`3Ro`2JoOon0?_o0`3o09[ho`00
jol<0?oo0?oo0?oo0?oo0?ko1Y[ooi[o09Zmo`6JV]?o0IZJm_l00>oo003no`T0
ool0ool0ool0oOl3V_nJ0?co002Uo`6JV^;o003=o`6ne?l00?go4P3oo`3oo`00
ool0ool0o`3oo`3ko`00l?on0?[o003]o`00n?l00?ko003So`400?_o003io`00
n?l00>coo03no`400?ko2P00ool0ool0ool0n?l00<OooP3Do`400?Ko003^ooh0
oOl1003no`400?ko003no`00X?l1003Ro`00X?l00?go4P3oo`3oo`00ooojoooj
ooX0o`3ko`?jo`00lol2n_X0n_l30?l00?3o0`3o003ko`Cj0?l0n^?o0O[joOl2
003jo?l30?l0n_So003/oo`0o_l1003no`X00?oon_l0n_l0n_So0037o`;jnP3D
o`7jn_Ko003^ooh0oOl1003no`400?ko0O[ooP3mo`00YOl1n_[Ro`00X?l00?go
403oo`3oo`00oonJoonJoiX0nOl3V_l00??o0IZJmol1003^o`400?_o19X0o`2J
hol1VY[mo`8009[lo`<0o`2Jn?l00>coo03no`400?ko2P00oonJo`2Jo`2J_Ol1
VY[Co`6JV_Ko003^ooh0oOl1003no`400?ko0i[o003lo`00YOl1VY[Ro`00cOl1
WmCo003mo`H0ool0ool0o_l80?oo0?l0ool0nol00?7ooP01o`3ko`400>ko003h
o`00o_l00>Co0P3o0?_o003mo`00o_l00?So003Oo`00o_l00?co003ho`00aoon
0=CooP3go`00h_l00?go003no`00col00=?o0@00h_l00:3o003mo`H0ool0ool0
o_l8n_oon_oj0?l0nol3n_l00?Co1?X0n_l0nol3n_X00?3o0`3o003ko`Cj0?l0
n^Co0_[on_go0P00n_go1?X0o`3jn?l00=oo003no`Kjo`00o`3jn?l00<Oo0_[j
0=Co0_[j0?Oo003Ro`00oOl0n_d0oOl00=Co0?[Co`7jn^;o002Po`00oOl60?oo
0?oo0?ko1Y[ooi[oVP3io`>Jo`00m?l2V_nJnOl3VYX00>ko0@00nol4VP3o09[T
o`:Joi[mo`8009[mo`BJ0?l0V_So003Oo`00o_l6V_l00?l0V[go0IZJdol1VY[f
o`00h_l00?go09[n0?co003Do`2Jdol1VY[Ro`00cOl1^mCo003mo`H0ool0ool0
o_l00?go0`3oo`3lo`400?7oo03lo`400>go003go`<0ool0iOom0?_o003mo`00
o_l00?So003Oo`00o_l00?ko0P3o0?Wo0P3o0<Ko003Bo`00mol00>;o003mo`00
o_l00>co003Uo`400>ko003Xo`400>;o002Po`00oOl60?oo0?oo0?ko2?[oo`3o
nP3o0?co1?[jo`00m?l4nP3jnP3lo`Cjn_l00?3o0`3o003ko`@0n_l0n^GooP00
n_go0P00n_go1?X0o`3jn?l00=oo003no`Kjo`00nP3jnOl20?l0b?on0=CooP3g
o`00h_l00?go0?[m0?go003ao`3jiOl1n_[^o`3jj?l1n_[Ro`00X?l00?go1P3o
o`3oo`3no`JJool0oiX0n_l4VY[o003do`>JoiZJnol4VY[o003^o`400?_o102J
o`2JiOon002JoOl2002JoOl4VP3o09[ho`00gol00?ko1Y[o002J09Zmo`400=?o
0@00m_l00>;o003mo`2JoP3lo`00lOl0V^Go0IZJk_l0V^So0IZJh_l00<go0MSE
ooh0oOl1003no`00o_l00?[o003lo`400?7o1000o`00oOl1003/o`00mol40?oo
003Vooh01_l0ool0o`3ko`<0ool0n?l00=oo0`00o`3mo`<0o`00n_l20?l0iol0
0>go003io`<0ool0d_l00?Oo003Ro`400?ko003no`00k?l00>Go0@00kol10037
o`00XOon0?go0@00o_l00?ko2?[oo`3o003o0?co1?X0o`00m?l4nP3onP3mo`Gj
n_oo003`o`<0o`00nol50?[o0?X0i_om00Kjool00?X0oOl40?[o0?[ho`00gol;
003on_oo003j0?X0n_l20?l0iol00>go003io`3joP3Dooh0mol00>;o0@00o_l0
n_d0oOl00?7o0?[Uo`7jn^oo0O[jj?l1003Ro`00XOon0?go0@00o_l00?ko1Y[o
o`3o003jo`BJool00?Co0i[ooi[lo`FJV_oo003^o`400?_o102Jo`2JiOom002J
o_l209X0oOl409[o09[ho`00gol:003oV_oo002J09Zno`:J003Co`400?Ko003R
o`400?ko09[n0?co003ao`2JiOl1VY[_o`6JV^So0@00h_l00<go0MO9o`<00?l0
n_l1003lo`400>kooP3no`400>co003no`00nol40?oo003/o`00o?on00Ko0?l0
0?l0oOon00;oo`3ho`00gol30?oo0?go0`3oo`3jo`80o`3Wo`00kOl1003jo`<0
ool0d_l00?Oo003Ro`00oOl00?ko003/o`400>Ko0@00kol1003Bo`00mol009Go
0`00oo[no`D0o`00nP3lo`Cj0?l00?CooP02nP00o_l5nP3oo`00l?l10?on0?co
1@3jo`3j0>co0?[lood00O[ooP01nP3nooh00_l0n_So003Oo`P0ooojool00?[n
0?[o0P3o0>Oo003]o`400?[o0?[n0=CooP3go`00h_l00?go0?[m0?go003ao`7j
n^Ko0O[jkol1n_[Xo`400>go0?[go`00UOl3003oV_ko103o002Jnol4V_oo003d
ooh009[lo`2Jo_l1003^o`400?_o102Jo`2Jjol0V_coo@00V_ko0P2J0?kooP02
o`2Jn?l00=oo2P3ooi[oo`00VP00__l2VP00dol1003fo`00h_l00?go09[n0?co
003ao`6JV^Ko0IZJkol1VY[Xo`400>go09[go`00cOl21lWo0`3oo`3jo`400?go
0@00l_on0?ko0`00ooon0?go003do`<0o`00o_l00?So0@00k?l00?co0`3o0?om
00Go0?l0ooon007o0?Oo003Oo`<0ool0oOl40?oo003ko`80o`3Xo`400>go0@00
n_l30?oo0=;o003go`00h_l00?go003no`00kOl20?l0i_on0?3o0@00i_l00>ko
003go`00UOl30?oon_ko1@3o003j0?go1O[jool00?KooP0;o`3onP3ooo[j0?oo
oP3do`Cjo`00ooh0o?l50?oo0?X0k?l0n_co1000nP3jo@04nP00ooon00;onP3h
o`00gol80?oon_oo003joP00n__o0P3o0>So0@00kOl1003jo`?j003je?l2003j
mol00>;o003mo`3jo@3mo`00l_l2n_oji_l2n_X0l?l1n_[Xo`800?[^o`3jmol0
09Go0`3ooi[no`@0o`00V_co1IZJool00?KooP03o`3oV_ko0IZJo_l1003co`2J
oOl1003ko`@0ool0V^_o09[ko`<0VP2Jo_l209X0o_on00;oVP3ho`00gol<0?oo
V_oo002J003oV/3o0iX009[Do`8009[go`00h_l00?go09[n0?co003bo`:Joi[V
o`6JV^oo0IZJj?l2002Jk_l0V_Oo003=o`8SbOl30?oo0?[ooP3no`400?;ooP3n
o`H00?oo0?l0oOl00?Goo@04o`3oo`3ho`400>go0@00o_on00Ko0?l00?l0o_l2
0?oooP01o`3go`00gol3003o0?go103oo`00nol20?l0j?l1003^o`80o`3jo`<0
ool0gOl00?Oo003go`00h_l1003no`00o_l00>gooP3Vooh0l?on0>Oo003^o`00
mol009Go0`3ooo[no`H0o`00nP3jo_l5nP3oo`00m_on00ko0?oj0?oon_l0ool0
0?[eookj0P3on_h0o?l50?oo0?X0kOl1n_[no`ojnP00nP3j0?l00?l0n_oooP02
ooX0n?l00=oo2000oo[oo`00n_h00?[ko`80o`3Xo`400>ko0P3o0?[o0oX00?[M
o`00nOl2003jmol00>;o0@00o_l0n_d0oOl00?;o0_X0n^Ko0_[j0?3o0_X0n^Wo
0P00n^ko0?[go`00UOl30?ooV_ko1P3o002Joi[no`2Jo_l1003fooh00ol0oi[n
o`2JoOl2002JmOonVPCooiX00?_o103oo`2Jk?l1VY[no`JJV_l0VP2Jo_l50?l0
V_oooP02oiX0n?l00=oo3000oi[oo`00VP00oi[0o`>J002Je?l2002Jmol00>;o
0@00o_l0V_h0o?l00?;o0Y[oV^Ko0IZJkol2V_nJjOl2002Jk_l0V_Oo003=o`8Y
bOl3003o0?[ooP3no`400?go003good01?oo003ooP3lo`00mOok00;oo`3ho`40
0>go0@00o_on00Coo`3o0?co003ko`80o`3io`00gol30?oo0?co0`3o003ko`80
o`3Xo`400>ko0P3o0?Wo0P3o0=go0@00nol30?oo0?Oo003Ro`00oOl00?ko003]
ooh0i_on0?3ooP3Wo`400>oo0@00n?l009Go2P00oo[oo`00o`00o_[no`?j0?oo
oP3gooh02?X00?[joo[j0?ko0P00n_Go0OX0oOX2003jo?l50?oo0?X0kOl1n_[n
o`gjnP00ooX0n_oo0?l0n_ko1@3oooX00?Wo003Oo`D0ooojooon00?j003jnol2
0?l0j?l1003^o`80o`3jo`<0nP3jgOl1003ko`?j003jmol00>;o003mo`3jo@3m
o`00l_l2nP3ji_l2n_X0l?l2nP3jjOl3003jn^oo0O[jn?l009Go2P00oi[oo`00
o`00oY[no`2Jo_l1003fooh01iX009ZJoiZJoOl2002JmOl1V_omVP8009[lo`@0
ool0V^co0IZJo_l=VY[o0?nJ09[oo`3o09[no`@0oonJ0?So003Oo`D0oonJooon
00>J0?nJ`?l309X0V]Go0iX009[go`00h_l00?go09[n0?co003bo`:Joi[Vo`6J
V^oo0Y[oV^Wo0`00VY[_o`6JV_So003=o`96bOl30?oo0?[oo@00ooh0oOl00?Oo
1P3oo`00ooon007o0?co003goo`0o?l00?Wo0P3o0>go0@00o_on00Coo`3o0?co
0`3oo`3no`80o`3io`00gol30?oo0?co0@3ooP3lo`80o`3bo`400?Wo0P3o0>oo
0P3o0?Wo0P3o0=go0@00o?on007o0?Oo003Ro`00oOl40?oo003]ood0j?l30?l0
0?3ooP3Vo`00l?l20?l0n?l009Go2P3ooo[oo`00o`00oOX5oo[j0?oooP3go`H0
0?ojnP3oo_X0oo/00?[gookj0@00o_l2003jo?l50?oonP00kOl1n_[noaKjnP00
ooX0n_oo0?l0n_oo003oooX00?Wo003Oo`D0ooojooon00Cj003jn_co0P3o0?;o
0@00nOl20?l0kol20?l0n_l30?X0n]go0@00o?om003jmol00>;o003mo`Cj003j
0?go003bo`?j0?[jj?l3n_l0n_3o0_X0n^Wo0`00oo[`o`;joo[ho`00UOl:0?oo
V_oo003o003mVP;oVY[no`400?Go1@3oVYX0oojJ0Oooo000V_OooY[lo`8009[l
o`@0oonJ0>co0IZJo_l=VY[o0?nJ09[oo`3o09[no`@0oonJ0?So003Oo`D0oonJ
ooon00BJ0?nJV/7o0`2J09[Food009[go`00h_l00?go0iX009[lo`00l_l3V_nJ
V^So0i[ooi[`o`:Joi[Yo`<00?nJl?l2V_nJn?l00<go0Y?9o`<0ool0n_om00;o
003lo`00n?l1003no`80ooom0?co003fo`400?Wo003mo`00o_l20?l0k_on0?ko
oP06ool0ool00?ko0`00o`3no`80o`3io`00j_l00?co0@00o_l3003o0?co0@3o
oP3mo`<0ool0l_l1003jo`<0ool0kol20?l0nOl20?l0gOon0?gooP01o`3go`00
k?l00?go0@00o_l1003no`00o_l00>go0`3o003Xo`<0o`00l?on0>Oo0@00l?l2
0?l0n?l009Go4P3ooo[oo`00o`00n_X0n_oj0?om003jn?l7nP00oooj0?ok00Co
o`3j0?Oo0o[j003mo`800?[mo`Kj0?oonP00k_onn_koo_XC0?oj0?ojnP3o0?X0
o`00oooj003io`00j_l00?co0@00o_l5003on_oooP04nP00n_[mo`<0ool0l_l1
003jo`<0ool0kol20?l0n_l30?X0n]gooP3mood00?[go`00k?l00?go0@00o_l1
003no`Cj003o0?go003bo`?j003jj?l3n_l0n_3o0_X0n^WooP00n_3o0_[on_So
002Eoa80oonJool00?l009ZJoi[oV_ooo@00V_So1i[o0?ooVP3ooP07o`00ool0
VP3go`>JVP00oOl2002JoOl5VP3ooiX0kOonV_kooYX:0?nJ0?nJVP3o09[no`@0
oonJ0?So003Zo`00o?l1003no`D00?nJooon00BJ0?nJV/7o0`2J09[Mooh0oOom
002Jmol00>co003mo`400?ko0@00o_l2VP00nol00?;o0iX0oi[Xo`>JoonJl?l2
V_nJjOl3003oV_3o0Y[oV_So003=o`:kbOl3003o0?[on`3mo`80o`3iooh0o_l2
0?oooP3lo`400?Ko0@00n_l00?co003no`80o`3_o`<00?l0o?l30?oo0?_o103o
0?l0o_l20?l0nOl00>_o0@00oOl90?oo0?oo0?oo0?co0@3ooP3mood0l_l1003j
o`<0ool0kol20?l0nOl20?l0i?on0?koo@3mood0m_l00>go0@00o_l60?oo0?oo
0?go003no`00mOl00?[o103o0?l0jOl30?l00?3o0`3o003Wo`00l?l20?l0n?l0
09Go3@00oo[oo`00o`00n_X0o_X6ool0ooX0n_Woo_X30?oon_X0o_l2n_X0mol1
n_[n0?ko0P3j0?go1_X0oooj003_o`?jn_ojo_l6003j0?oj0?ko303onP00o`00
oooj003io`00jol1003mo`/0ool0ool0ooojooon00Cj003jn_go0`3jnP3bo`40
0?[o0`3oo`3_o`80o`3jo`<0nP3ji?on0?koo@3mooh00OX0mol00>go0@00o_l6
0?oo0?oo0?go1?X00?l0oOl00?[o0?[jo`Cj003on^Wo0o[o0?[`o`?j0?[jj_on
003jl?l2n_ojn?l009Go3@00oi[oo`00o`00VY[ooYX6ool0oiX0V_WooYX30?oo
V_X0o_l2VYX0mol1VY[n0?ko0P2J0?go1IX0oonJ0>ko0iZJoi[no`H009X0oiX0
o_l30?nJ0?ko103ooiX0n?l00>_o0@00oOl;0?oo0?oo0?ooV_oooP04VP3oVY[l
o`6JV/So0`2J09[Tooh0oOon0?gooP01VP3go`00kOl1003no`H0ool0ool0oOl2
VP00nol00?[o09[jo`BJ0?ooV^Wo0i[ooi[`o`>J09ZJj_on002Jl?l2V_nJn?l0
0<go0^_9o`<0ool0nol10?ol0?go0P3o0?WooP3no`80ooon0?co0@00mol20?l0
n_l40?l0ooon00Coo`3o0>oo2@3oo`3oo`3oo`3ho`40ooh0o?l00?Wo003Zo`00
oOl90?oo0?oo0?oo0?co0@3ooP3mood0lol3003o0?_o0`3oo`3`o`<00?l0mol0
0>Oo0P00ooh0o_om0?[o003fo`00k_l20?l0o_l60?oo0?oo0?goo03eo`400?_o
003no`00jOl40?oo003jo`00nOl30?l00>Wo0`3oo`3ao`80o`3ho`00UOl<0?oo
n_oo003o0?X0n_d01_l0oooj0?[io`Oj0?X0ooojood0o?l2n_X0n?l5n_oj0?l0
o_l50?X00?oooP04oooj003_oaSjooojoooj003j0?oo003oo`3onP3j0?X0o_l1
003io`00j_l00?go2`3oo`3oo`3ooo[oooh01?X00?[joOl00?kjlol3n_[o0?_o
0`3oo`3`o`<00?l0n_l30?l0n^Oo0_[jooh0o_om0?co0`3onP3go`00k_l20?l0
o_l60?oo0?oo0?go0?[m0?go003jo`7jn__o1?X00?ojjOl0n_h00?[jo`3jnOl3
nP00n^[o103j0?ojlOl2nP3jn?l009Go303ooi[oo`00o`2J09[n00Ooo`3ooiX0
V_Wo1i[oVP3ooi[oo@3lo`:JVP3ho`FJoiX0o`3no`80VP3nooh00oooVP3^oaRJ
oonJoonJ002J0?oo003oo`3oVP2JoiX0o_l00?So003Zo`00oOl;0?oo0?oo0?oo
V_oooP04VP3oVY[loojJlol1VY[Io`<0o`2Jiol2VY[ooP3mooh0o?l30?nJ0?Oo
003^o`80o`3no`H0ool0ool0oOl0V_h0o?l00?[o0IZJnol4VP00oi[Yo`BJ003o
V_[o09[io`>J0?nJj_l409X0oi[ao`:J09[ho`00cOl37<Wo0P3o0?[o0@3oo03m
o`400?So0@00oOl1003no`00o?l30?oo0?ko003moo`0o?l40?l0ooon00Coo`3o
0?3o003no`H0ool0ool0o_l00?co0@3ooP3lo`00nOl00>[o003mo`T0ool0ool0
0?l0o?l10?on0?go0`3oo`3co`<0o`00noom0?3o0`3oo`3go`00j_l50?oo003o
oP3no`00mol00?Ko003_o`<0ool0o_l70?oo0?oo003noo`00Ol0nOol0?So0@00
j_l40?oo003jo`400?Oo003Yo`<0ool0lOl00?Ko002Eo`80oo[no`H00?l0nP3j
n`04ooojnP3io`_j0?l0ooojnP3o0?[lo`?jo`00o_l0n_go0?[n00[jo`3oo`3j
003oooh01?oonP3jl?l0n_ko4O[oooX00?X0oooj0?oo0?oj0?kj003no`40n_Wo
003Zo`00oOl;0?oo0?oo003on_oon`01n_[mo`?jooojlol3n_oj0?_ooO[`o`<0
ool0n_l30?l0n^[o1O[ooo[jooh0o_l30?l00?co0`3onP3go`00kol30?oo0?ko
1`3oo`3oo`00o_l0n_d01?l0ool0o?on007jn_co1@3o0?ojn^[o0?[n003jn_l1
n_[jooh00?[Zo`@0nP3on_7o0_X00?So002Eo`80oi[no`H00?l0VP2JoP07o`00
oonJVP3io`^Jool0oonJVP3o09[lo`:Jo`3mo`2JoOl0V_h01i[o0?oo09X0o_on
00CooiX0V_3o09[noa6JoonJ002J0?ooVP3oo`3oVP3nVP00o_l109[io`00j_l0
0?go2`3oo`3oo`00oi[oooh01?l0oiZJoOl3V_ooV_?o0Y[oV_[ooI[Uo`<0o`2J
j_l5V_ooVY[ooP3lo`400?co0`3oVP3go`00kol30?oo0?ko1`3oo`3oo`00o_l0
V_h0o?l00?cooP01VY[lo`D0o`3oVY[Zo`BJ003oV_[o0IZJn_on002Jj_l409X0
oi[ao`:J003ho`00cOl3@lWo0P3o0?[o0@3oo@3lo`400?go0@00o_l00?_o003n
o`400?go1`3oo`3oo`00oOol0?[o0@3oo@04ool0o`3ao`400?ko0`3oo`3ko`00
o?l30?oo0?_o003io`00j_l00?go2@3oo`3oo`3oo`3lo`40ooh0oOl30?oo0?Go
oP02o`00o?l4003oo`3`o`<0ool0o?on00;oo`3Zo``0ool00?l0ool0ool0mol0
0?Ko003_oo`02?oo0?oo0?oo0?goo002o`00n_on00;o003ho`00j_l40?oo003i
o`00nOl30?l00>[o0`3oo`3ao`<0ool0nOl009Go0P3on_ko1P00o`3j0?[l0?ko
0_[j0?ko0O[jo_l3nP3o0?ko1O[o003jn_go1o[o0?[ooo[joOl0n_h00O[oo@03
o`00ood01?oonP3jlOl1n_[no`?jooojo@0=oooj0?oo0?oj0?l0o`3no`40n_Wo
003Zo`00oOl;0?oo0?oo0?oon_oon`01n_[mo`?jooojmOon00;onP3lo`Cjn_oo
n_3o0`3ooo[looh00_l0n^[o1O[ooo[jooh01_[oo`3o003lo`<0ooX0mol00>oo
o008ool0ool0ool0oOl0n_d01?l00?l0o?on00;on_[mo`D0o`3ooo[Zo`3joP00
n_[o0@3jn_on007jn^_o103j003jlOl3nP00n_Wo002Eo`80oi[no`H00?l0VP2J
o03no`:JVP3no`6JV_ko0iX0o`3no`FJo`00VY[mo`NJo`2JoonJV_go09[n006J
ood00Ol0o_on00CooiX0V_7o0IZJo_l3V_ooV_d02OooVP3oo`3oVP3no`00o_l1
09[io`00j_l00?go2`3oo`3oo`3ooi[oooh01?l0oiZJoOl3V_ooV_GooP01oi[k
o`BJV_ooV^go09[looh00_l0V^[o2I[ooiZJool009[mo`400?co0`3oVP3go`00
kool00Soo`3oo`3oo`3mo`2JoP3lo`00o?on00;oVY[mo`D0o`3ooi[Zo`BJ003o
V_[o0@2Jn_l40?l0VY[[o`@0VP00V_7o0iX009[io`00cOl3J<ko0@00o_on0?[o
1@3o0?oo0?co0@00o_on0?ko003ko`00oOl1003no`80oool0?gon`3no`80ooom
0?go0P3o0?7o003mo`D0ool0o`3mo`00l_l00?Wo003Zo`00oOl90?oo0?oo003o
0?[ooP3no`@00?oo0?Ooo002o`00o?l4003oo`3do`00o_l10?on0?gooP01o`3Y
o`80ooon0?ko0`3oo`3go`00m_l00>co003no`L0ool0ool00?ko1`3o0?l0o`00
n_on00;oo`3ho`00lol1003jo`00o_l00?coo@3io`<0ool0j_l3003o0?7o0`3o
o`3kooh0V_l1003no`800?[no`T00?l0nP3j003jo?l4n_X0ooonn_ko0?[n0?ko
1_[o003on_[no`;jo`3ln_go0?[n007jn_ko0O[ooP02n_X0o_l2nP3jlOl0n_go
4O[oooX0nP00oooj003o0?oo0?ko003no`40n_Wo003Zo`00oOl;0?oo0?oo003o
n_oooP04o`00n_[no`Cjn_oon_Oon`01nP3lo`Cj0?oon_Co003no`40ooh0oOon
00;onP3Zo`ojooojnP3o003jool0o`00o?l30?oj0?Oo003/o`00o_l70?oo0?oo
003no`Wj0?[o0?l00?l0o?om007on_go1@3o0?oon_?o0O[jn_l0n_h00?[looh0
0?[jooh00Oojjol40?X00?[ao`?j003jnol2n_X0V_l1003no`8009[no`T00?l0
VP2J002Jo?l4VYX0ooonV_ko09[n0?ko1Y[o003oVY[no`:Jo`3lV_go09[n006J
V_ko1i[o0?ooVYX0o_l2VP2JlOl0V_go4I[ooiX0VP00oonJ003o0?oo0?ko003n
o`40V_Wo003Zo`00oOl;0?oo0?oo003oV_oooP04o`3oVY[no`BJV_ooV_Goo@00
V__o09[no`2Jk_on0?gooP02oiX0j_l9V_ooVY[oo`00V_go0@00o?l30?nJ0?Oo
003/o`00o_l70?oo0?oo003no`:J09[ko`00o?om007oV_go1@3o0?ooV_?o0IZJ
n_l0V_h009[looh009[jo`@0o`3oV^_o102Jo`2JlOl3VP00V__o0YZJ0<go0iS?
o`L0ool0ool00?Wo003mo`00o?l00?ko0`00o`3mo`00o?l00?coo006ool00?oo
0?go1@3o0?oo0?ko0P3oood0oOl20?l0lOl00?go1@3oo`3o0?go003bo`80o`3k
o`00joon0?go0@00o_l30?oo0?[o1P3o003oo`3no`00mool00;oo`3mo`<00?oo
oP3good00ol00?on0?gooP01o`3Zo`<00?oooP3no`<0ool0n_l30?oo0?Ko003]
ooh0o_l1003no`00oOl70?l0o`3o003ho`@0ool00?co0`3oo`3co`400?[o003n
o`00o?om0?Wo0`3o003/o`H0o`00o`00nOl00?[o0P3o0?_ooP2Ko`L0ool0ool0
n_go1000o`3jo@00n_co1o[o0?ojn_ojo_om0?ko1O[oo`3ooocj1_l00?[ooo[m
o`Gj0?[ooo[no`;jo`3nnP400?ko0_X0n_7o0?[mo`_joooj0?X00?oon_on00Ko
o`00ool0o_l30?[on__o0?[[ooh0oOl1003no`D0ooojooon003ooP04n_[ooo[n
o`3jmook007on_go0oX0ooon0?Oo0?[n00?o003ooP3mooh00_oj0>_o4?[joooj
nP3o003jool0o`00oOl4003onP3go`00kOon0?ko0@00o_l00?go2OX0n_l0o`00
o`3ko`D0nP3on_[no`D0o`00oo[co`7jn_[o1?X0o`3jo?on003jn_om003jk?l6
nP3j003jn_Wo0?[kooh00?[ko`;jnP2Ko`L0ool0ool0V_go1000o`2Jo@00V_co
1i[o0?nJV_nJo_l30?l00?ko1I[oo`3ooobJ1_l0oi[ooi[mo`FJ09[ooi[no`:J
o`3nVP7o0?ko0YX0V_7o09[mo`^JoonJ09X00?ooV_on00Koo`00ool0o_l309[o
V__o09[[ooh0oOl1003no`D0oonJooon00So0?l0VY[ooi[no`2JmOom007oV_go
09[nooh0mol0V_h0oOon0?gooP02oiX0jol:VY[ooiZJool009[mo`400?co0`3o
VP3go`00kOon0?ko0@00o_l00?go0YX0V__o003ko`D0VP3oVY[no`D0ool0oi[c
o`6JV_[o19X0o`2Jo?on002Jn_l40?l0oi[/o`JJ09[o09ZJnOl0V__o0`3o09[k
o`:JVP3=o`=lcol70?oo0?oo003io`00oOl1003mo`00o_l30?oo0?go003ko`80
o`3lo`@00?oo0?ko003mo`D0o`3oo`3no`80ooon0?co0`3o003co`400?[o0P3o
0?co1P3oo`3oo`3iooh0nol00=oo0P3o0?Ko0`3oo`3no`00mol8003oo`3oo`00
o_l3003oooh0mook007oooh0nol40?l0o`3/o`400?Ko003no`00o_l00??o003R
o`00oOl70?l0o`3o003ho`00o_l1003no`@00?oo0?;o003jo`00o_l00?cooP01
o`3jo`<0o`00k?l60?oo0?oo0?[o0@00n_l30?oo0?cooP2Ko`L0ool0ool0n_go
2P00o`3j003o0?[joOl7n_l0oo[ooo[no`<00?l0oOl2n_ojo?l4n_[o003no`3j
oOl5nP3jooojo_l7n_l0n_X0o`3no`?j0?[jlol2n_[oo@06oooj0?X00?ko2_[o
oo[oooX0ool0o_l00?kjnol0n]oo0P3on_kooP08o`3o003jooojo_l0n_Oo2?X0
o`3j003j0?ko0oX0ooon0?Oo0?[n00?j0?oooP3lo`D0n_oj003/o`Ojn_oo003o
ooh01_oo0?l00?[no`@00?oo0?Oo003Ro`00oOl9nP3jo`3o003o0?_o3P3j0?oo
n_[oo`3j003on_?o0@3jn_l4nP3o0?[lood00?[kood00?[/o`Kj0?oj0?ojn_l1
n_[kooh00Oojo?l2nP3jVol70?oo0?oo09[mo`X00?l0VP00o`2JV_go1i[o0?nJ
oonJo_l30?oo0?go0Y[oV_co0iZJo`3mo`2JoOl5VP2JoonJo_l7V_l0VY[oo`3n
o`>J09ZJlol2VY[oo@06oonJ09X00?ko2Y[ooi[ooiX0ool0o_l00?jJnol0V]oo
0P3oV_kooP08o`3o002JoonJo_l0V_Oo1i[oo`2J002JoOl0V_kooP3go`2JoP00
V_kooP3lo`@0V_nJ0>_o1iZJool00?oooP3mo`8009[mo`<0ool0mol00>;o003m
o`:J09[ko`00nol>09X0oonJV_oo09[o0?nJlol109[jo`BJ0?l0V_coo@00V__o
103o0?nJk?l6VP3oVP3oV_[o0IZJnol40?l0oi[lo`:Joi[=o`>=col40?oo0?ol
0?So103oo`00o_l00?ko003jo`80o`3mo`80o`3ko`L0o`3o0?oo0?go0P3o0?ko
0`3oo`3do`00nol00?[o0`3oo`3kooh0oOl60?oo0?oo0?So0@00nol00=oooP3f
o`<0o`00o_l00?Oo003no`P0ool00?oo003nooh0mooh0?Oo0P3o0>co0@00oOl4
0?oo0?on0?ko003no`00lol00>;o0@00o_l70?l0o`3o003ho`00oOl00?ko1000
ool0mOol0?_o003no`00n_l20?l0n_l30?oo0?Go003io`H0ool0ool0n_l20?l0
nol30?oo0?goo@2Ko`@0ool0oo`03Ooo003o0?l00?X0oo[jo_l7n_l0oo[o003n
o`<00?ojoOl2n_ojnol7n_oj003ooo[mo`;j0?[no`Gjooojo`3mo`00oOl20?oj
nol0n_[o0?[n00Goo`3oo`3nnP00o_l:n_oon_oonP00o`3no`<0o`3jnol0n]oo
0P00n_kooP08o`3o003jooX0o_l0n_Oo3?[oo`3jo`3jn_oonP3nooh0mol0n_h0
o?X1003lo`D0oooj003/oa7jn_oo003jo`3j0?X00?l00?[no`@00?oo0?Oo003R
o`400?ko2OX0n_l0o`00o`3ko`h0nP00ooojool0n_X00?[eooh00O[jnol4nP3o
0?[ko`<0nP3jnol4003o0?[eo`00nOl6nP3onP00n_[o0_[on_co103j0?ojoOl3
nP00nY_o103oo`3ooP3mo`/00?l0o`00VP3oVY[no`NJo`3oV_l00?ko0`3ooi[m
o`:Joi[ko`>JoiX0o_l0V_go0YX0V_ko1I[ooi[o0?go003mo`80oi[ko`2Jn_l2
VP00o_l30?oo0?jJ003no`ZJoonJoonJ003o0?ko0`3ooi[ko`2Jgol2002Jo_on
00Oo0?l009[oV_go09[go`^Jool0V_l0VY[ooi[mooh0mol0V_h0o9X1003lo`@0
oonJ0>_o2iZJool009[o09X0V_ko0P00V_go0`3oo`3go`00h_l1003no`:J09[k
o`00nol>09X00?ooV_oo09ZJ002JmOon006JV__o19X0o`2Jnol309X0V__o103o
o`2Jk?l6VP3oVP00V_[o0Y[oV_co102J0?nJoOl3V_ooV/go0h[?o`@0ool0ooh0
0_l00?Wo003no`P00?oo0?oo003jooh0oOl20?l0nOl20?l0n_l20?l0o_l3003o
0?Co003ko`00n_l30?l00?_oo@3no`H0ool0ool0n_l30?l00?_o003Oo`80o`3f
o`80o`3nooh0nOon0?ko0P3ooo`0lOl3003oooh0mOl20?l0kOon0?go2`3oo`3o
003o0?oo0?ko003co`00h_l00?go1`3o0?l0o`00n?l1003no`P00?oo003oo`3e
ooh00Ol0nol00?Ko0`3o003ko`<0ool0mOl1003jo`H0ool0ool0n_l20?l0nol3
0?oo0?goo@2Ko`@0ool0oo/05?l00?l0o`00nP3ooo[jooojo`3jn_h0o_l00?kj
oOl2n_ojnOl5nP00o`00oOl2nP3jo_l6n_[on_l00?ko003mo`80oo[ko`3jn_l0
n_h02Ooo0?oo0?X0n_[no`[jooojooojool00?ko0oX00?[ko`3jgol20?ojo_on
00Oo0?l00?[on_kooP3io`Sj0?[o0?oj0?omnP40oo`0mol1n_[m00Cjool00?co
1@3oooX00>goo_X?ool00?[o0?X0nP3onP00n_ko1000ool0mol00>;o003mo`Wj
0?[o0?l00?l0nol>003j003on_[o0?[jo`3jmOom003jnol4nP3oo`3ko`@0nP3j
n_co103jo`3jmOl1n_[jo`Kj0?ojo`3jn_l2n_ojo?l40?X00?[mo`?j003jVol4
0?oo0?om0?ko4`00o`3o002J0?ooVY[ooi[o09ZJoP3no`00oY[mo`:Joi[io`FJ
0?oo003mo`:J09[no`JJV_nJo`00o_l00?go0P3oV__o09[jo`6J0?go1`3oo`2J
oiZJo_l:V_ooV_ooV_oo003no`>J0?nJnol0V]oo0P3oV_kooP07o`3o002Joi[n
ooh0nOl8V_nJo`3oVP3ooIX1oool0?Oo2YZJ003ooi[oo`00o?l40?ooVP3/oojJ
3ooo002Jo`2J09[ooiX009[mo`<0ool0mol00>;o003mo`:J09[ko`00nol>0?nJ
003oVY[o09ZJo`2JmOom002Jnol4VP3oo`3ko`@0VP2JV_co102Jo`2JmOl1VY[j
o`JJ0?nJo`2Jn_l2V_nJo?l409X009[mo`>JoonJcOl3VLoo103oo`3ooP02ool0
nOl00?goo@02ool0nOon0?co0@00nOl00?So0P3o0?go103o0?l0n?l20?l0o?l1
003ko`80ooon0?coo@3no`H00?l0ool0o_l00?ko0`3o003lo`400=oo0P3o0?Ko
oP3nooh0nOon0?ko003nooh0lOl20?l0m?l00?ko0P3o0>ko0`00o`3mo`@0ool0
ood01_l0o`3oo`3co`00h_l00?go1`3o0?l00?l0n_l30?l00?go003no`L0ool0
ool00?WooP01o`3ko`80o`3ho`<0ool0nol3003o0?KooP3jo`T0ool0ool0o`00
nol00?_o1000o`00o_om09_o103oo`3on`09o`00o`3o003j0?kooOX0ood00Ol0
o_l00?kjo?l1n_[io`3jo03mo`;j0?[mo`Kjoo[onP3ooP3mo`;j0?[lo`7jn__o
0?[l00So0?oo0?X0n_[no`Kjn_ojooojo_l0n_ko0oX00?[lo`7jn]oo0P3on_ko
oP04o`3o003nnP7oood0nOl9nP3jo`3onP3ooo/00?on0?So0O[oo@3mo`400?go
1P00oooj003^o`cjn_ojool00?[o0?X0oOX:0?X00?oo003oo`3go`00h_l00?go
2OX0n_l00?l0o`3looh04?[o0?oon_l0oo[o0?[ooo[jnOom003jnol4nP3jo`3k
ooh00Oojo?l40?[j0?[fookjn_l9nP3on_l0n_ojn_go0P00n_co1@3jnP3jn_ko
0oX00?ZKo`@0ool0oo`02_oo003o0?l009X0o_omVPKo0?l00?l0o_l00?jJo?l1
VY[io`2Jo03mo`:J09[mo`JJoi[oVP3ooP3mo`:J09[lo`6JV__o0YX00?go1`3o
o`2JoiZJo_l6VY[oV_ooV_ko09[no`>J0?nJo?l1VY[Oo`80oi[nooh01?l0o`00
oYX1ooom0?Wo2I[oV_l0oiX0oook003ooP3ho`:Jooon0?go0@00o?l40?ooVP3]
o`bJV_nJool009[o09X0oIX209X0oOl30?oo0?Oo003Ro`00oOl2VP2Jnol00?_o
4P3oV_l0oonJo`3oV_l0V_ooVY[iood009[ko`BJ09[o0?_o103o0?nJo?l409ZJ
09[foojJn_l9VP3oV_l0V_nJV_go0P00V_co1@2JVP2JV_ko0i[ooi[=o`>ic_l1
003no`@00?oo0?Wo003^o`80o`3lo`400?Wo0`3o003ko`80o`3lo`<00?l0oOl0
0?go003jo`400?_o1@3o003o0?co0`3o003mo`80o`3no`<0ool0o_l00?Wo0@00
goon0?ko003jo`400?gooP3iood01Ooo003oooh0o?l00?Oo103o0?l0m_l00?ko
0P3o0>ko0`3oo`3mo`00n?l50?l0ool0oOl00?So003Ro`400?go1P00ool0o`3j
o`<0o`00oOl00?ko003lo`80o`3ho`<0ool0o?l20?l0n?l30?oo0?_o0@00m?on
0?Wo203o003o0?l00?[o003lo`@00?oo0?koo@2Jo`400?ko3P3jo`00o`00o`3o
003j0?Wo1@3o0?oo0?ko0`3joo[lo`7jn_Wo1O[o003o0?go0_X0n_co0o[joo[n
007on_go0_X00?co0O[jnol0n_h02_l0o`3oo`3joo[joOl2n_ojo_l3n_oon_ko
0?[n0?co0O[jgolC003jool0nP00o`3o003jn_oo0?on0?Wo2OX0n_X0oo[j0?om
0?go0OX0n?l5n_l00?X0oOl1003mo`H00?oonP3jk_l<n_oon_oo003jo`3o0?go
2`3j003oooX0ool0n_So003Ro`400?ko2@3jn_oo0?l0o`3loaCj003jo`3ooo[o
0?ojo`00ooojoo[io`@0nP3on_co1?X0n_l0noom003jo?l40?[j003fo`;j0?[j
o`T0n_ojnP3joo[joOl3003on_go1@3jnP3on_ko0oX00?ZJo`400?ko3P2Jo`3o
o`00o`3o002J0?Wo1@3o0?oo0?ko0`2Joi[lo`6JV_Wo09[mo`00oOl2VP2Jo?l3
VY[oV_h00OnJoOl2VP00o?l1VY[ko`6J0?co1`3oo`2JoiZJoOl2V_nJo_l3V_oo
V_ko09[n0?co0IZJgolC002Jool0VP00o`3o002JV_oo0?on0?Wo2I[oVYX0oiZJ
0?om0?go0IX0n?l5V_oo09X0oOl1003lo`D0oonJ09[^o`bJoonJool009[o0?l0
oOl209X0o_l5VP3oo`2Jn?l00>;o0@00o_l209ZJnol00?co59X0oi[o0?ooV_l0
oi[o003ooi[oV_Wo102J0?nJo?l4VP2Jo`3ko`@0o`00V_co102JVP00m_l2V_nJ
n_l909[oVYX0V_nJV_go0`00oi[mo`D0VYX0oi[no`>JoonJcOl3d/Wo0@00o_l0
0?[o0@00m_l00?go103o0?l0nol00?Soo@3ko`400?_o0P3o0?go003mood0o_l2
0?l0nol50?l00?l0o?l30?l00?gooP3no`<0ool0o_l00?Wo0@00gol20?l0o_l0
0?go103oo`00o?l00?So0`3oo`3no`80ooon0?co003ko`00o_l00?ko003go`40
0?ko0P3o0?3o0@00o_l90?l0o`3o0?oo0?co0@3oo@3mo`00n?l00>;o003lo`L0
0?oo0?l00?_o0@3ooP3no`00o_l00?co0`3o003ko`D0o`3oo`3lo`<0ool0nOl4
003o003no`40ooh0o?l1003lood0n_l40?l00?ol0?_o003lo`@00?oo0?koo@2E
o`80n_ol00Ko0?l00?[jnOom00So0?oonP00oo[ko`3jn?l0n_d0oOl20?[jnol2
n_ojoOl0n_go0?[n0?ko0_[on__o3_X0n_[o0?l0ool0n_ojn_goo_[no`?joooj
o_l0n_h0o?l1n_[Ooa40oo[oo`3j003o0?X00?[jo`3no`7j0?Wo2OX00?X0oooj
0?on0?co0OX0o?l0n_ko1_[o003j003no`400?kooP04oooj0?[`o`7jn_ko2_[o
nP3j0?X0ooX0o_l;0?X0nP3jnP3oo`3jn?l0n^;o003mo`H0n_[oo`3ooP3loaGj
003jnP00oo[o0?ojool0ooojoo[jnoom007on_co1?X0ooX0nol5003j0?[jo_l5
nP3jnP00oOl1n_[lo`3joP3ko`D0n_l0nP3ln_kooP00n_go1@3jnP3on_ko0oX0
0?ZEo`h0V_l00?l00?l0o`00VY[iooh02Ooo0?ooVP3ooi[ko`2Jn?l0V_ko003m
o`80VY[ko`:Joi[mo`2JoOl0V_h0o_l2V_nJnol3VP2JV_ko1`3oo`2JoiZJoOon
V_ko0i[ooi[no`2JoP3lo`6JV]oo4@3oV_oo09X00?l0VP00VY[o0?ko0IX0nOl9
VP00VP3ooiX0ooh0o?l1VP3lo`2Jo_l6V_l009X00?ko0@00o?l50?ooVP2Jl?l1
VY[no`ZJoiX0VP2J0?nJ0?ko2`2J09[oVYX0ool0V_So09[Ro`00oOl209ZJnol0
0?co5IX0oiZJ003oV_l0oi[oo`3ooi[oVY[jo`@0o`3oV_co19X0oiX0nol50?nJ
09ZJo_l5VP2JV_l0oOl1VY[lo`2JoP3ko`D0V_ooVP3lV_kooP00V_go1@2JVP3o
V_ko0i[ooi[=o`?bbOon00;oo`3jo`400?Wo103oo`00o_l00>go0`3o003ko`40
0?Wo0@00o_l00?goo@01oooi00Oo003o0?l00?co0`3oo`3lo`400?ko0`00o`3n
o`40ood0o_l1003Oooh0o_l00?go0@3ooP3lo`00oOon00Goo`3oo`3no`D0ool0
o`3lo`80o`3no`400?ko003no`400?WooP3lo`00lOl1003mo`T0o`3o0?l0ool0
n_on0?co003io`400>;o003lo`L00?oo0?oo0?_o103oo`00o_l00?ko0@00oOl3
0?oo0?_o1P3oo`3oo`3lo`80o`3ho`<0ool0o_l40?oo003mood0oOom0?[o303o
003oo`3oo`3oo`3no`00nol30?oo0?ko0`00o`2Eo`<0n_[oo@06o`3o003jn_Wo
2OX00?[j0?oonP3^o`7jooh0oOl20?X0nOl1n_[no`3joOl0n_h00ooon_[n0?kj
4?ojnP3joo[jo`3oo`00ooojo?l1n_[no`?jn_ojo_l1n_on003jo_l1n_[Oo`/0
n_[oo`3j003o0?[l0?go0OX0o_onnPWoooX00?X0ooojo@00n_co0_X0n_ko0O[j
o_l0n_h01?[j003ooP05ool00?X0o_l10?[ao`7jn_go2_[onP3j0?X0ooX0o_l2
0?l0o_X5o`3oo`3jnOl1n_[Ro`00oOl90?[jool0ool00?co5OX0o`3jo`3on_l0
o`3jo`3ooo[ooo[ko`Kj0?oj0?ojoOl40?[onP3ko`D0ooX0oo[no`Gj0?oj003n
oogjoOl0n_h0nolA0?[o0?[o0?[ooo[oooX0o`3joOl50?oj003jo_l3nP3onYGo
3P2JV_l0o`00o`3o002JV_Wo2IX009ZJ0?ooVP3^o`2Jo_l00?go0@2Jn?l1VY[n
o`2JoOl0V_h00oooVY[n0?jJ3?nJVP2JoiZJo`3oo`3no`2Jo?l1VY[no`>JV_nJ
o_l1V_on002Jo_l1VY[Oo`/0VY[oo`2J003o09[l0?go0IX0o_onVPkooiX009X0
oonJ003o09[lo`:J09[no`6JV_ko09[n00BJVP00ooh0oOl1VP3no`40V_7o0IZJ
oOl:V_nJ09X0VP3oVP3no`80o`3nVPGo0?oo09[io`6JV^;o003mo`80VY[ko`00
o?lEVP3ooi[o0?nJo`3ooi[o0?ooV_ooV__o1YX0oiX0oi[mo`@0V_nJ0?_o1@3o
VP3oV_ko1IX0oi[o0?kooI[mo`2JoP3koa40V_ooV_l0V_ooV_ooVP3o09[mo`D0
oiX009[no`>JoonJcOl49lWo1@3o0?oo0?Wo003io`@0ool00?ko003]oo/0oOl0
0?Oo003no`00oOom00?o003ooP01ooom00Go0?oo003mo`00n?l00?gooP3no`40
ood0o_l1003To`400?ko0@00oOl00?go0@3ooP3lo`00o_l6003o0?oo0?_o003m
o`400?go1`3o0?l00?l0o_l50?l0ool0oOl20?ooo@3lo`00lOl00?co103o0?l0
oOl00?[o003jo`<0ool0o?l1003^ooh0oOl1003no`400?go0@00o?l00?_o103o
o`00o_l00?ko0@00o_ok0?co1P3oo`3oo`3lo`H0o`3oo`00o?l;0?oo003oo`3o
o`00oOl3003o0?goo03koa40ool0ool0ool0ool0o`3o003lo`<0ool0o_l3003o
09Go0`3on_om00Ko0?l00?ojnOl9n_oonP00oooj0>koo_[n0?ko0@3jmol0n_ko
0?[mo`3joP03oo[jooh00OoooOX:003oooX00?oo003ho`3joOonn_ko0O[ooP00
n_ko0O[ji?l1003no`40n_ko1P3j003o0?[m0?co4_X0ooojn_ojoooj003o0?oo
n_on007jn_go1oX0n_ojn_ojo_l0n_h00_ojooh01oX0o`00n_X0o_l10?[ao`3j
o?lAn_oj0?X0o`3onP00ool0o`00o_l70?oo0?[ooo[lo`7jn^kooP3mo`400?ko
0@00o_l20?[jo?l1003loaKj0?l0n_l00?[o0?l0n_l0oo[j003jn_co1_X0ooX0
oo[mo`L0n_oj0?ojn_ko3P3onP00n_[oooX0oo[j0?ko0oX0oo[mo`3joP00n_co
4P3jooojo`3jooojoooj0?X0n_[no`D0oo[o0?[no`?j0?ojUOl>0?nJo`3o003o
0?l00?nJnOl9V_ooV_l0oonJ0>kooY[n0?ko0@2Jmol0V_ko09[mo`2JoP03oiZJ
ooh00OoooIX00?ko1I[o0?oo0?Oo09[moojJo_l1V_on002Jo_l1VY[To`400?ko
0@2Jo_l609X00?l0V_d0o?lBVP3ooiZJoi[ooiX00?l0oonJooh00IZJoOl7VP2J
oiZJoi[no`JJ0?l0oi[ooP01VP3no`:JVP3no`40V_7o09[loa2JoiX0VP3o0?nJ
003oo`3o0?go1`3oo`2JoonJo?l1VY[^ooh0oOl1003no`400?ko0P2JV__o003l
oaJJ0?ooV_l009[o0?ooV_l0oiZJoonJV_co1YX0oiX0oi[mo`L0V_nJ0?nJV_ko
3P3oVP00VY[ooiX0oiZJ0?ko0i[ooi[mo`2JoP00V_co4P2JoonJo`2JoonJoonJ
09X0VY[no`D0oi[o09[no`>JoonJcOl46/WooP3fo`00nOl40?l0o`3no`00joom
0?go003goo`0oOl70?l0o`00ooom00[oo`3o0?l0ool00?go003bo`400?goo@03
o`3oooh0i_l70?oo0?oo003mo`00oOl10?on0?co003no`<0ool0o_l00?co0@00
oOom00;o0?on00;oo`3no`D0o`3oo`3mo`80ooon0?_o0P3o0?Co0@00o?l40?l0
o`3mo`00l_l30?l00?cooP3`o`00o_l90?oo0?oo0?oo0?co0@00o?l00?_o0P3o
ooh00_oo0?go003no`D0o`00o`3mo`P00?oo0?oo003mo`<0o`3oo@3mo`L00?oo
0?oo0?ko003nooh00Ol0o_l1003no`00nol60?oo003o0?koo002ool0o?l3003o
0?ko002Bo`h00?[o003o0?l0o`00oo[io`Wjoo[o003oooX0k?l0n_h0o_l10?[g
oocjoOl7n_oj0?[jooom00oooo[onP00ooojnP3oo`00l_l1n_[mo`3joP03oo[o
ooh0i_l70?oo0?oo0?[no`H0nP00o`3jo@3lo`Wj0?oon_oon_ooo007ooojn_l0
0?omnP;onP3nnP;ooo[no`3joP01oo[mo`Oj0?l0n_[o0?ko0`3joo[do`7jn_co
2_[onP3j0?l0oo[oo@01o`3mo`L0ool0n_ojn_cooP3`o`00o_l90?oo0?oo0?oo
0?go0P3jn_co0@00o?lFnP3o0?[jo`3jo`3ooo[o0?ojo`00oo[mo`Sj003onP3o
n_[no`@0n_oj0?gj5ooo0?ojnP3on_oonP3oooX0ooojnP3on_ko1OX0o`00n_co
2`00ool0nP3j003on_h00oX0oo[no`D0o`3j0?[no`?jo`00UOl>002Jo`00o`3o
0?l00?nJnOl9V_nJool0oonJ0>co09[n0?ko0@2JmoolV_go1i[oVP2JV_oooP3n
o`>JoiX0o_l5VYX0ool0lOl1VY[mo`2JoP03oi[oooh0i_l70?oo0?oo09[no`H0
VP00o`2Jo@3lo`^J0?ooV_ooV_oo0?on00OooiZJo`00oofJ0_nJ0?jJ0_ooV_ko
1IX0o`3oV_go1iX0oonJV_l0o_l309[oV_Co0IZJo?l:V_nJ09X0o`3oV_om007o
0?go1`3oo`2JoiZJo?on0?3o003no`T0ool0ool0ool0oOl209ZJnol00?co4IX0
oonJV_l0V_l0oonJo`3oV_go09[mo`RJo`3oVP3oVY[no`@0V_nJ0?fJ5ooo0?nJ
VP3oV_ooVP3ooiX0oonJV_ooV_ko1I[oo`00V_co003mo`JJ09X00?nJoP03VP3o
V_ko1@3ooiX0V_ko0i[o003=o`?lbOl20?l0m_l00?WooP01o`3no`00j_om0?ko
003do`400?go0P3o0?co003jo`00o?l00?go003ao`00oOon00?o003oo@3Vo`@0
ool0ooh0oOl00?go003no`00o?l70?oo003oo`3no`400?co0`3oo`3mooh00Ol0
oOl00?ko1P3o003o003no`40ooh0n_on0?_o003ko`00nOl00?[o003no`80o`3i
ood0o?on0>co2@3oo`3oo`3oo`3lo`400?co003lo`H00?oo0?l0n_l9003oo`3o
003o0?go1000ool0o_l00?go0@3ooP02ool0oOl7003oo`3oo`3no`00o_on007o
0?ko0@00o_l00?_o103oo`00o?ol00;oo`3ko`80o`3no`00T_l>0?ojool0o`3o
0?l00?ojnOonnPKo003oooX0joon00Cjool0n_Co0O[joOl3n_oj0?goo@3mo`7j
0?go1OX0ool00?7o0?[mookj1000n_ojoP3Vo`@0ool0ooh0o_l60?X00?l0n_h0
0?[lo`kj0?ojn_oon_oo0?[j003no`?jooojoOonnP400?go0?[no`Kj003joo[j
o_l1nP3nnP;oo`3no`00o_[ko`3jnol0n_X00ooj0?on00;ooo[no`?jooX0o_l3
0?oo0?gjo?on0>co2@3oo`3oo`3oo`3mo`80n_[lo`400?go5oX00?l0oo[o003o
0?oon_X0oo[o003on_go2?X00?ojo`3on_ko0P3jooh06_oon_oo0?l0nP3on_oo
nP3oooX0oooj003on_ko1OX0o`00n_co2`00ool0nP00o`3on_h00o[o0?[no`D0
oooj0?[no`?j0?l0UOl>0?nJool0o`3o0?l00?nJnOonVPKoo`3ooiX0joon00BJ
ool0V_Co0IZJoOl3V_nJ0?cooP3mo`6J0?go19X0ool0l?l0V_gooYX40?nJoi[n
0>Ko103oo`3ooP3no`H0VP00o`2JoP00V_co3YX0oiZJoonJool0VYX00?ko0i[o
oi[moojJ003lo`2Jo_l6VP3oV_nJV_ko0IX0oYX2ool0o_l00?jJnol0V__o09[j
00?oVP3ooP02oonJo_l3V_nJ0?ko0`3oo`3mV_cooP3/o`T0ool0ool0ool0oOl2
09ZJnol00?go0Y[o0?ko39[o003o0?ooVYX0oi[mo`2JoOl8V_l0oi[o0?nJo_l2
09[ooP0FoonJool0oonJ0?nJoonJ0?ooVP3ooi[no`2Jo_l5V_oo002Jo?l00?go
1YX00?l0oi[n00>Jo`2Jo_l50?ooVP2Jo_l3VP3o0<go0ok9o`80o`3fo`00n?l3
0?oo0?go003Xo`00o_l00>go0@00nol1003ko`00oOl00?go003/o`D0ool0oool
0>Ko103oo`3ooP3mo`00oOl00?kooP3no`<0ool0n_l1003lo`<0ool0o?on00Go
o`3oo`3no`H0o`00ool0o_l30?l00?WooP3lo`400?coo@3ko`<0ool0oOl00?ko
0P3o0?[o103o0?l0o?on0>ko0@00o_l70?oo0?oo003mo`400?co003lo`H00?oo
0?l0o_l00?ko1000ool0o_l1003nooh01ooo003oo`00o_l10?on007oooh02Ooo
003oo`00o`3no`00o_on007o0?ko0@00oOl00?co103oo`00o?ok00;o003lo`00
o?l009;o3P3on_oo0?l0o`3o003on_So2?[oo`00ool0n^Wo1@3jool0n^go0_[j
0?go0`3jnP3mo`40n_go1OX0ool00>co1o[oooX0oo[joP3Vo`@0ool0ooh0o_l6
0?X00?l0n_h0o_[no`Cj0?ojooh01_oo0?[jo`3no`?jooojo?onnPD0o`3ooo[n
o`Kj0?[jooojo_l3nP3jn_ko003no`00o_[lo`7jn_coo@3mo`X0ooX0ooX00?oo
n_ko0_[on_`01_oonP3joo[looh0k_l1003no`L0ool0ool00?ko0P3jn_co0@00
oOlGnP00o`3on_oo0?X0ool0nP3onP00o`3jo_l?n_X00?ojnP3on_[oo`3jooh0
6_oon_X00?l0nP3on_[onP3oooX0oooj003on_ko1_X0o`00oo[mo`/00?oo0?X0
0?l00?[m00_j0?[jool0ooojo`3no`?j0?l0UOl>0?nJool0o`3o0?l00?nJn?l0
V_ko103oo`2JjOl509[oo`2JkOl2VYX0oOl309ZJ0?go0@2JoOl4VP3oo`3[o`NJ
oonJ0?nJV_h0i_l40?oo0?on0?ko1P2J003o09[n0?jJo_l4VP3oV_on00Koo`2J
V_l0o_l3V_ooV_cooYX00?go09[no`JJ09ZJoonJo_l3VP2JV_ko003no`00oY[l
o`6JV_cooP3lo`X0oiX0oiX00?ooV_ko0Y[oV_`01_ooVP2Joi[looh0k_l1003n
o`L0ool0ool00?ko0P2JV__o003mo`:Jo`3no`FJool0VP3no`RJ0?nJ003ooi[n
o`nJV_l0oiZJ0?nJV_oo09[ooP0FoonJV_l0oonJ0?nJV_nJ0?ooVP3ooi[no`2J
o_l6V_oo003oV_go003mo`JJ003o002JoP0<oiX0VY[oo`3ooi[o0?ko0iX0o`3=
o`?JbOl60?oo0?oo0?go0`3oo`3`o`00j?l40?l0o`3Uooh0o_on0?go003mo`00
jOl40?oo003So`@0ool0ooh0oOl00?go003lo`L00?l00?oo0?[o0`00o`3no`<0
0?l0nol3003o0?[o0`3o003no`D0ool0o`3ho`80o`3mooh0o?ol0?_o0P3o0?go
003no`80o`3mo`<0ool0nOl00>Wo2@3oo`3oo`3oo`3lo`400?co003lo`X00?oo
0?l00?oo0?ko1000ool0o_l1003no`H0o`3oo`00o_l00?ko0@3ooP3no`D00?oo
003no`80o`3no`00o_l40?oo003no`H00?oo0?l0nOl1003ko`L0ool00?oo0?co
003mo`4009;o3P3ooo[oo`00o`3onP3on_Co103oo`3jjOl50?[onP3jjol;003o
o`00n_X00?oooP3mo`D00?oo003Yo`Kj0?ojn_l0iOl40?oo0?om00Soo`3j003o
0?[n01Cooo[joo[j0?oj0?oo0?oo0?[joo[no`?jn_ojnol1n_[k0?ko0oX0n_[n
o`Ojoooj003oooh0o_l3003on_goo_[loo`0o_l:0?l0n_ojo`3ooo[no`;joo[m
o`Ojoooj0?oo0?go0_[o0>_o2@3oo`3oo`3oo`3mo`80n_[lo`400?go4_X00?l0
oo[jo`3j0?oo0?X0oo[m003jo_l?n_l00?l0nP00oo[oo`3jood06Ooon_X0o`3j
o`3on_oj0?oonP3ooo[oo`3jo_l6nP3o0?X0n_go003noah0nP00ool0ooX0o`3j
0?ojool0ooojo`3oooX00?l0UOl30?ooV_ko1`3o0?nJ0?nJm?l40?oo09[Yo`D0
V_nJ09[[o`/00?oo002JV_l0ooon0?co0`3oo`3Xo`JJ0?nJV_l0iOl40?oo0?om
00Soo`2J003o09[n01CooiZJoiZJ0?nJ0?oo0?oo09ZJoi[no`>JV_nJnol3VYX0
ood0o_l3VP2JV_ko19[ooiX0o_on0?ko0`3ooi[moojJo?on0?co2P3o09[oV_l0
oonJo_l2V_nJoOl7V_ooVP3oo`3mo`:Jo`3[o`T0ool0ool0ool0oOl209ZJnol0
0?go0Y[o0?ko1IZJo`2J0?ko0iX0oi[n007oV_ko3i[oo`3ooiX00?nJool0V_om
01GooiZJ0?ooV_l0oi[oVP3ooiX0oonJo_l0V_ko1Y[oo`2J09[mo`00oOlMVP00
ool0oiX0oonJ0?nJool0oonJo`3ooi[o0?l0cOl3mLWo1P00o`3oo`3mo`<00?l0
mOon00;oo`3Xo`@0o`3o0>_o003looh0o_on0?So003Yo`@0ool00>?o303oo`3o
o`00o`3oo`3mo`00n_l00?ko0@00n_l30?l00?go0P3o0?[o003no`00o?l30?l0
0?ko1000o`00o?l00?go003ko`80o`3looX0oOl40?l0o`3no`H0ool0o`00o_l3
0?oo0?Wo0@00k_l00?ko2@3oo`3oo`3oo`3lo`400?co003lo`X00?oo0?oo0?oo
0?ko0@00n_l00?ko1P3o0?oo003no`00o_l40?oo003mo`@0ool00?ko0P3o0?_o
1@00ool00?ko1`00ool0o`00n_ol0?ko003no`<0ool0o?l00?go0P00ooh0U_l>
003on_oo003o0?ojn_ojmOon00;o0?[Yo`D0n_oj0?[[o`Oj0?l00?ojn_h00?on
0?co103oo`00jOl6nP3on_X00>Go4@3oo`3oo`3j003o0?X00?l0n_h0oOl@n_oo
0?[j0?oo0?oo0?[on_[mo`;joo[jo`3jo@01o`3no`?j0?[jo_l:n_[on_X0o`00
oo[no`<00?l0oOl2n_ojo?on003joP08o`3o0?[on_ojo_l6n_oon_ojn_ko1o[o
ooX0o`00oOl2nP00kol00?ko2@3oo`3oo`3oo`3mo`80n_[lo`400?go5oX00?l0
ooojo`3j0?oo0?X0o`00o`00n_ko8_[o003o0?[o0?ojool0n_oon_X00?oonP3o
0?[o0?ojooX0o_l70?oj0?oo0?[no`Oj0?l0nP3jn_ko003nood05_[o0?oj0?oo
nP3on_oo0?oon_l0ooojo02Fo`<00?nJo_l70?l0oiZJoi[eooh00_l0V^Wo1@2J
oiX0V^_o2iX0o`00oiZJo`00ooh0o?l30?oo0>So1YX0oiZJ003Uoa40ool0ool0
VP3oo`2J003o09[n0?go49[oo`2JVP3oo`3oo`2JoiZJoOl2V_nJn_l0V_h00_oo
0?ko0iX0VY[no`ZJV_nJVP3o003oV_ko0`3oo`3mo`:Joi[looh009[mo`L0o`2J
oi[oV_ko1Y[ooi[oVY[no`NJoonJ0?l00?go0Y[o0>oo003no`T0ool0ool0ool0
oOl209ZJnol00?go0Y[o0?go19[o09X0o_l8VP3o003o002Jo_lRV_oo0?ooV_l0
oi[oo`2JoonJVP00oonJ0?ooV_l0oi[oVP3no`80oi[mo`2Jo_l7V_oo09X0VY[n
o`00oOon01NJo`3oVP3ooiX0oi[oo`3ooi[o0?ooV_om0<ko0lo9o`H0ool0ool0
oOl1003cooh00_oo0>Wo1@3oo`3o0>_o003no`L0o`3o003oooh0n?l00>Wo0@00
oOl00>Co0@00o_l6003oo`3o0?go003fo`00mol1003mooh0nOl3003o0?co0P3o
0?_ooP3lo`00o_l00?_o0`00o`3lo`80ooom0?go0@3ooP3no`H00?l0ool0o_l3
0?oo0?Wo0@00kOon0?go0@00o_l1003mo`400?co003lo`X00?oo0?oo0?oo0?ko
1@3oo`3o0?ko2P3oo`00o`3oo`00o_l00?ko003no`00oOl;0?oo0?l0ool0ool0
o?l7003oo`00ooon00Goo`3oo`3joo/00_oo0?ko0P3oooh0o_l1003no`80ooon
09Ko303ooo[oo`00o`3on_[cooh00_l0n^Wo1OX0ooX0n^_o0?[m00Kon_oj003o
oP3lo`@0ool00>Wo1_[j0?oo0?[To`400?ko0@3jo@05nP00o`3joP3jo`80nP3n
o`L0ool0ooojn_goo_[io`Gj0?l0o`3no`;j0?[kookj0@00o_l0n_ko0?[n0?ko
0o[joo[lo`cj0?ojnP00o`3o0?[oo_[no`Kjn_ojooojo_l3n_oon_d0oOl2nP00
k_on0?go0@00o_l1003no`80n_[lo`400?go:OX00?l0ooojo`3j0?oo0?l0nP00
ool0n_oon_[o003o0?[o0?ojool0n_ko4?[o0?oo003o0?oj0?ojo`3jo_l;0?oj
0?oo0?[ooo[joP03nP3on_ko003nood02_[j003j0?oon_l0o_X:0?oo0?X0oooj
0?on09Ko0`3ooi[no`D0o`3oVY[cooh00_l0V^Wo1IX0oiX0V^_o09[n00Oooi[o
V_l0ooh0o?l30?oo0>So1YZJ0?oo09[To`400?ko2`2J003o09X00?l0V_h0n_l2
09X0o_l70?oo0?ooVY[moojJnOl0V_go003no`:J09[koojJ0@00o_l0V_ko09[n
0?ko0iZJoi[lo`BJ0?nJV_ko103o09[ooY[no`JJV_nJoonJo_l3V_ooV_d0oOl2
V_l0k_on0?go0@00o_l1003no`80VY[ko`00oOl2V_l0oOl4V_l0VP3mo`80VP3n
oa<0V_ooVY[oo`3ooi[o0?nJool0V_ko0Y[o0?ko003no`JJ0?nJo`2Jo_l20?nJ
oOl;V_ooVY[o002J0?nJo_l00?gooP0:VYX009X0oonJo`3nVP00o_l6VP3ooiX0
ooh0c_l3SlWo1P3oo`3oo`3mo`400??ooP02ool0jOl50?oo0?l0jol9003oo`3o
0?l00?ko003go`00j?l00?go003Oo`H00?oo0?l0oOl00?Ko0@3ooP3jo`00nol0
0?Wo103oo`00oOl00?So0@00o?l00?ko003lo`800?ol00;o003nooh0oOl40?oo
003mooh03?oo003oo`3oo`3oo`3lo`400>7o003lo`400?OooP02ool0o_l;0?oo
0?oo0?oo0?l0nol30?oo0?ko1000ool0o_l00?ko0@00o_l;0?oo0?l0ool0ool0
oOon0?_o2@3o0?l00?oo003koo/0nol5003oo`00o_l1003no`80ooon09Ko303o
oo[oo`00o`3on_[cooh00_l0n^Wo1OX0ooX0n^_o2?X0ool0oo[on_d00?[ko`@0
ool00>So1OX0ool0n]oo0P3jooh01OX00?l0n_h0n_on0?kj0`3oo`3no`3jnol0
n_Wo0_[oooh0o_l1nP3io`7jn_co0?[no`3joP05ooojn_l0oOXAoo[j0?oon_X0
o`3o0?[ooo[joOonnPWooo[jooojooojo@3mo`;j003Ro`00oOl20?[jnol00?ko
1O[j003o0?ko8OX00?[oo`3o0?X00?oo003ooo[oo`00ool0nP00n_oo0?[noa3j
nP00o`00o`3on_l0n_l0n_ko0P3jn_`01_oon_l00?[n00Cjn_oo0?koo00Gn_l0
o`3oo`3j0?ojnP3oo`3j0?oonP3ooP2Fo`<0oonJo_l50?l0oiZJloon00;o09[Y
o`FJ0?nJ09[[o`2Jo?l3V_nJooh009[ko`<0ool0iol5VP3oo`2Jgol;09[o0?l0
VP00o`2JoP3jo`80o`3nVP<0ool0o_l0V__o09[io`2JoOl00?ko0IX0nOl1VY[l
o`2Jo_l0V_h01OooVY[ooofJ4OnJVP3ooiZJool0o`2JoonJV_gooYX=oonJV_oo
V_ooVP00o`3mo`:Jo`3Ro`00oOl209ZJnol00?ko0iZJo`3lo`>J002JoOl209X0
o_l4003ooi[no`00o_l7VP00V_oo09[no`JJVP00ool0o_l6V_l0V_l0V_ko0`2J
V_om00kooi[oo`2Jo`00VY[oo`3mooh01OnJo`3o0?ko1IX0oiZJ0?ko1YX0oonJ
0?on0<ko0gC9o`H00?l0ool0oOl1003bo`00o_l00>Wo1@3oo`3o0>[o203oo`3o
0?l00?ko003go`00j?l00?go003Oo`400?go003mo`00m?l00>Soo03lo`00n?l1
003mo`00o_l00?go0P00ood00ooo003lo`400?go103oo`00nol00?koo@03ool0
oo`00ooo003Qo`00o?l1003go``0o`3oo`00ool0ool0o_l40?l0o`3lo`@00?oo
0?ko1000ool0o_l00?ko0@00o_l00?ko1`00ool0ool0oOl00?go003no`00o_on
00;oo`3jo`L00?l00?oo0?ko1@00ool00?ko0@00o_l00?ko002Eo``00?ojool0
0?l0oo[jl_l4nP3o0?[Yo`Gj0?oj003Zo`Sjool0oo[onP3no`3jnol40?oo003X
o`Gj0?oo0?[Oo`/0n_l0o`3j003o0?[n0?[ooP06n_oo0?oo0>koo?X00?ko0@3j
n?l1n_[mo`3jo_l0n_h00oojn_om00Gooo[jo`3no`[jn_l0o`3jooojn__o0?[n
oogj0ooon_om00Gjoooj003Ro`00oOl20?[jnol00?ko3?[o003o003oooX00?[n
o`@00?X00?ko4P3on_[oo`00ool0n_l0n_oo0?[noa00n_l0o`00ool0n_l0n_l0
n_ko5P3jo`00o`00ooojo`00nP3j0?ojool0oOl50?[o0?[ooP0Dool0nP3on_X0
ool0nP3oooX0ooojUOl3003oV_ko1@3o0?nJV_;o19X0o`2JjOl4VP3oVP3Yo`2J
oOl2V_nJoOl0V__o0`3oo`3Wo`FJ0?oo09[Oo`/0V_l0o`2J003o09[n0?[ooP06
V_oo0?oo0>koo9X00?ko0@2Jn?l1VY[mo`2Jo_l0V_h01?nJV_oooP05oonJV_l0
o_l:VY[o0?l0V_ooVY[ko`2Jo_omVPCooi[oooh01I[ooi[o0>;o003mo`80VY[k
o`00o_l3V_oo0?co0iX009[mo`80VP3mo`<0oiZJo_l00?ko1i[o09[oo`2JoOl5
V_l0ool0o_l6V_l0V_l0V_ko5P2Jo`00ool0oonJo`00V_nJ0?nJool0o?l7V_oo
V_l0o`3no`FJ0?nJVP3no`RJ0?ooVP3ooi[=o`==e?l00?co0@00o_l60?oo0?oo
0>So003Wo`<00?l0j_l8003o0?l0ool0o_l00?cooP02ool0j?l00?go003Oo`40
0?go003mo`80o`3io`<0o`00j?l3003oooh0o_l00?Oon`3no`L00?oo003oood0
mol1003no`00lOl6003oo`3ooo`00ol0o`3Ro`400?go0@00mol20?l0o_l60?oo
0?oo0?ko003no`00oOl4003oo`3mo`400?go0P3o0?ko0@00o_l00?kooP3mo`00
oOl00?Wo0`00ooon00?oo`00nol20?oooP01o`3mo`@0ool00?ko0@00o_l40?oo
002Po`00o?l1003no`T0ooojool00?l0k_l30?l00>So103jnP00j_l8nP3o0?oj
ooojo_l0n_cooP02o`00j?l0n_d00?[Oo`80n_on00Sj003o0?X0nP3jo`Wj0?[j
ool0ool0k_l3n_[oooh00ooo0?[goo_jo_l7nP3o0?[jooom0?co003mo`GjnP3o
0?[ao`Kjn_oon_oooP05n_[onP3jh_l1003no`80n_[ko`00o_l<n_l00?oo0?oo
nP00n_koo03noa80n_[oo`3o0?oo0?[o003onP3jo_l20?[oo@09ool0n_X00?l0
n_ko0`3j003no`l0oooj003onP3j0?ojn_l0oOl50?oo003joP3noa7j003jnP3o
o`3j0?oonP3on_ZPo`00o?l1003no`<0oonJo_l20?l0k_l20?l0iol309ZJ0>Wo
09[mo`>JoonJo_l0V_cooP01o`3Wo`2Jo@00V]oo0P2Jooh029X00?l0VP2J0?[o
2IX0VY[oo`3oo`3^o`>JV_oooP03ool0V_Ooni[no`FJool0VY[nooh0o?l00?go
1IZJ0?l0V_7o1YZJoonJooon00FJV_nJ09[Ro`400?ko0P2JV__o003no`>Jool0
o?l3VP00V_gooP3mo`80VY[mo`00o_l7V_l00?nJ09[mo`FJo`00o`3no`JJVP00
o`2Jo_l309X00?ko3`3ooi[o0?nJoiX0oiZJo`3ho`>J0?l0o_l5VP00VYX0o_l8
VP3ooiX0oiZJcOl3=MGo0@00oOl<0?oo0?oo0?oo0?oo0>So003Wo`<00?l0j_ok
00Koo`00ool0o?on00;oo`3Xo`D00?oo003Oo`80o`3no`00o?l1003io`<0o`00
i?on0?ko003go`400?ko003nooh00Ol0oOon0?Ko003no`00l?l00?koo005o`3o
0?l0h_l00?co0@00n?l30?oo0?ko003lo`00o_l20?oooP3no`00o_l00?gooP3n
o`80o`3nooh00_oo0?ko0P3o0?go0P3oooh0n_l70?l0ool0o`3no`00mol1003k
o`D0ool0o`3no`00o_l40?oo002Qo`400?go3`3oo`3oo`3ooo[oo`00o`3^o`<0
o`00j?l40?[j003Zo`;jnP3nnPKoooX0ooojo?on00;o003Xo`3jo@00n]oo3P3o
n_l00?X00?l00?[j0?[o2O[onP3oo`3oo`3Zooh00ooo0?[go`7jn_ko0?[no`Cj
0?X0n_koo03mo`00o?l4nP3o003`o`3jo_l1n_[n00Gon_oj0?[Ro`00oOl20?[j
nol:0?oon_oo003oo`3no`800?[nood01O[jool0n_kooP0:ool0n_[o0?oj0?[n
o`<00?[ooP0;ool0oo[o0?l0n_ooo@3mo`l0oo[o003on_oj003on_l0nOl40?[o
003no`Gjo`3j0?[no`P00?oonP3on_ZQo`400?go2@3oo`3oo`3ooi[no`80o`3^
o`80o`3Wo`<0VYX0jOl2VY[ooYX2oonJo_l0V_cooP01o`3Wo`FJo`00oi[Oo`h0
oi[o002J003o002JVP3jo`:Joi[no`<0ool0j_on00?oo`2Jmol1VY[no`2Jo_l4
V_nJ09[noo`0oOl00?co0iX0o`3_o`2Jo_l1VY[n00GoV_nJ09[Ro`00oOl209ZJ
nol30?ooV_ko003ko`8009[mo`P00?nJV_oo09[mo`400?ko1iZJo`3oVP2Jo?l4
V_l0o`3mo`NJo`3o09[oood0oOl?0?nJool0oi[oVP00oi[o0?So0i[o003no`FJ
o`2J09[mo`L0oonJ0?nJV/go0`?Do`00oOl>0?oo0?oo0?oo0?oo0?l0j_l00>Oo
0`00o`3Yooh0oOl4003oo`3lood0iOl40?oo003Oo`80o`3no`00o?on0?[o0@3o
oP3no`00jOon0?ko003^ooh00Ol0o?l1003mo`00nol00?ko003/o`X00?l0ool0
0?oo0>;o003lo`400?Wo0@00nol00?co003no`@0ool0oo`0o?l50?oo0?l0o_l2
0?l0oOl1003ko`80o`3mo`80ooon0?_o0@00oOl70?l00?oo003go`00nol5003o
0?l0o_l00?ko103oo`00X?l00?go3`3oo`3oo`3ooo[oo`00nP3^o`<0o`00j?l4
0?[j003YookjoOl4nP3ooo[looh00OX0i_l0n_h00?[Oo`/0oo[o003j003o003n
n_[o2O[onP00o`3onP3Zooh00ooo0?[^o`cj0?X0n_oo003on_X0o_l1003lo`Cj
0?l00>co2_[jooX0oo[jo`3jh_l00?go0P3jn__o2P3on_[oo`00ool0o_on0?ko
oP03n_ojn_h0o_l=003jool0oo[o0?oj0?[mo`80n_on00_oo`3on_l0o`3jooom
0?go3`3jn_l0ooojoo[j0?ojnP3ho`?jo`00o_l50?X0nP3jo_l8003oooX0ooX0
X?l00?go2@3oo`3oo`3ooi[no`80VP3^o`80o`3Wo`<0VYX0j?onV_go09[no`2J
o?on006J0>Ko19X00?nJgol;0?nJo`00VP00o`00oY[jo`:Joi[no`<0oiX0j_on
00?oo`2Jk_l<V_nJ09[oo`00oiZJ0?go003lo`>J0?l0jol:VY[oVP3oVY[o09[R
o`00oOl209ZJnol70?nJV_oo003ko`400?co1@00V_nJV_h0o_l2002JoOl6V_l0
oiX0V_co0I[ooP3mo`NJo`3o09[oood0oOl?09ZJo`3ooi[oVYX0oiZJ0?So0i[o
003mo`BJ09X0V_go1`3ooiX0oiX0cOl2k]Co003mo`h0ool0ool00?l0ool0o`3Z
o`00iol30?l00>So003ko`<0ool0n_l1003Uo`@00?l00=oooP3no`00o?on0?Wo
1`00ool0ool0hol00>ko0@3ooP3no`<0o`00m_l00?ko003/o`X00?oo0?oo0?oo
0>;o0@00oOl1003jo`00o?l30?oo0?Soo@01ooom0?ko1`3o0?oo0?l0o_l00?_o
oP3looh0oOl20?ooo@3lo`00o?l30?l00?ko003go`400?co0@00o_l00?ko0`3o
o`3no`400:3o003mo`l0ool0ool00?ojool00?X0k_l30?l00>So103j0?X0j?l0
0?_o0o[ooo[ko`<0n_X0i_l4nP3o0?[Oo`/00?[o003j003o003nn_Wo2?[jool0
0?oj0>So103oo`3jk_l1n_on003ooP08oo[j003oo`00o?l4nP3o003/o`[jn_oo
nP3on_l0n^;o0@00o_l20?[jnol10?[mo`@0n_oo0?ko0@00oOon00?jooojoP00
ooh02oojool0oo[o0?oj0?co4@3jn_l00?oo003jo`3o0?[oood0oOl?0?[oo`3o
oo[o0?X0oooj0?So0`3j003no`40n_h00?[no`P00?ojo`3onP2Po`00oOl90?oo
0?oo003oV_ko0P2J0>ko0P3o0>Oo0`2J09[Po`>JoonJnol309ZJ0>Ko09[no`2J
gol;002Jo`00VP00o`00oY[io`6JV_ko0`3oVP3Xo`@0ool0V^ko0I[ooP0<o`00
oonJVP00ool00?co0iX0o`3[o`ZJV_ooVP3oV_l0V^;o0@00o_l209ZJnol109[m
o`40V__o0@00oOon00>JoonJoP05o`00oonJoOl5V_l0oiX0nol4VY[o003mo`NJ
o`3o09[oooh0o?l?09[oo`3ooi[ooiX0oonJ0?Oo0YX00?go09[n002JoOl70?nJ
o`3oVP3=o`;Dg?ol0?ko003mo`h0ool0ool0ool0ool0o`3Zo`00iol30?l00>7o
0`3o003jo`400>Go1000o`00gol20?l0o_l00?cooP3io`00o_l30?oo0>Ko0`3o
o`3^oo`01?oo003ooP3mo`00o?l00?ko003Xo`00o?l00>;o003lo`400?cooP3l
o`<0ool0n?om0?kooP3no`/0o`3oo`3o003oo`3ko`@0o`3o0?go0P3o0?ko003m
o`400?kooP3lo`<0o`00o_l00?Ko003lo`400?ko003no`P0ool0o`00o`2Xoo`0
o_l00?go3`3oo`3oo`3ooo[oo`00nP3^o`<0o`00j?l40?X0nP3Qo`?jo`3jnol3
0?[j0>Ko1?X0o`3jgol;0?ojo`00nP00o`00o_[io`3jo_l4003onP3Xo`@0n_l0
n^ko0O[jnP02oo[jo000n_co1000o`00j?l6nP3oo`00n^;o003mo`80n_[looh0
o_l5003jool0o_l1003mood0o_ol00go0?ojool0oo[j0?oj0?co1@3on_l00?ko
1P3onP3o0?[mo`7j0?kooP0=o`00ooojo`3jo`3onP3go`;jo`3no`D0n_l00?[n
o`P00?oj003jo`2Xoo`0o_l00?go2@3oo`3oo`3ooi[no`80VP3^o`80o`3Wo`<0
VP2Jh?l3V_ooV__o0`2JVP3Vo`2Jo_l0V]oo2`3oV_l009X00?l00?jJnOl0V_go
0`3oVP3Xo`@0V_l0V^ko0IZJo03no`:JV_om002Jnol20?l0iol6VP3oo`00V^;o
003mo`80VY[looh0o_l2002Jnol1003mooh0oOol0?ko09[mo`FJVP3oVP3jo`>J
ool0o?l4VP3o09[mo`2JoOon00go003ooi[ooi[o0?nJ0?Oo0Y[o0?go19[o002J
oOl70?nJ0?nJo`3=o`;ae?l00?go3`3oo`3oo`3oo`3oo`3oo`3]o`80o`3Xo`@0
ool00>7oo@3ko`80o`3Uo`@00?l00>[o003lo`400?ko1P3o0?oo003looh0mOl3
0?oo0>Ko0`3oo`3]ood01?oo0?oooP3no`400?co003no`00j?l00?go0@00k_on
0?go0@00o_l00?co0@00o?on0?co0`3oo`3hood0o_ol00?o0?l0o_l50?l0ool0
nol30?l00?co0P3o0?ko003mooh00OoooP08ool0ool0o`00o_l00?Ko003ko`00
n_l80?oo0?l00?l0X?l00?go2`3oo`3oo`3ooo[oooh00?[^o`<0nP00j?l4nP00
nP3Qo`00o_[ko`?j0?X0i_l4nP3o0?[Zo`00o?l1003no`/0oo[oo`3j003o003n
n_Go1000ooX0j?l40?[o0?[]o`3joP04ool0ooonnP3ooP00n_co1000o`00j?l6
nP3oo`00n^kooP3mo`400?ko003mo`80n_[looh0o_l50?ojool0o_l1003mood0
o_onnPD00?l0oo[no`H0ooX0ooX0o?l50?oj0?l0o_l60?oj0?l0n_goo_X1ooon
00go003ooo[o0?[o0?oj0?Oo0_[o0?go0o[o003mo`P00?oj003jo`2Po`00oOl9
0?oo0?oo0?ooV_ko0P00V^ko0P2J0>Oo0iX009[OoojJnol3VP2J0>Ko09[no`2J
j_l00?co0@00o_l20?nJo_l5VP00o`00oY[do`<0oiX0j?l409[o09[]o`2JoP3l
oojJ1?l00?nJnol20?l0iol6VP3oo`3oV^kooP3mo`400?ko003mo`80VY[looh0
o_l20?nJnol1003mooh0oOonV_co09[lo`BJ0?nJ0?[o0i[oo`3lo`BJ0?l0V_go
oYX1ooon007o0?ko29[ooi[o0?nJ0?Oo0Y[o0?go0i[o003lo`L0oiX0oi[o0<go
0]gEooh0oOl1003no`T00?oo0?l0ool0kOl00>Ko103oo`00h?l1003jo`80o`3U
o`@00?l00>_o0@00oOl50?oo0?oooP03ool00?cooP3eo`<0ool0i_l30?oo0>[o
203oo`3oo`3o0?ko0@00o?l00?ko003Xo`400?ko0@00kol00?ko403oo`3oo`3o
o`00ool0o`00o?on0?co0`3oo`3fo`00o?om00?o0?l0o_l50?l0ool0n_on007o
0?ko0P3o0?Oon`06ool0ool0ooh00_oo0?Ko0P3o0?go0@00nol80?l0ool00?l0
XOon0?go0@00o_l5003ooo[ooP00n^ko0P3j0>Oo1?X00?X0h?l1003jo`?j0?X0
i_l4nP3onP3[o`400?go4@3oo`3oo`00n_oo0?X00?l00?kjmOl4003onP3Xo`@0
n_l0n^[o2?[oo`3ooo[on_ko0@3jo?l4003o003Xo`Kj003o003jkol00?ko403o
o`3oo`3oo`00oooj0?[jo?oj00Con_oo0?ko0@00nol00?co1o[j003o0?ojo_l6
0?oj0?oj0?_o103jn_ojo_l50?oj0?l0n_onn_d03?l0ooojo`3jnP00nP3go`;j
oo[mo`?jnP00oOl8003jo`00n_l0XOon0?go0@00o_l9003ooi[oo`00V^ko0P2J
0>Oo0iX009[Fo`>J09X0i_l4V_ooVP3[o`400?go203oo`3oo`00V_ko1IX00?l0
0?jJm?l30?nJ0>So102Jo`2Jj_l0V_co0Y[oV_go09[ko`80o`3Wo`JJo`3o0?nJ
kol00?ko403oo`3oo`3oo`00oonJ09ZJo?oj007oV__o0@00mOl1VY[lo`2Jo?l4
VP3oVP3jo`>JV_nJo?l3VP3o0?[ooY[m0?go29[ooiZJ002J0?Oo0Y[oV_go0iZJ
003lo`L0V_l0oi[o0<go0Z39o`00o_l50?l0ool0kOl00>Ko0`3oo`3Oo`400?Oo
003Uood0j_l00?go303oo`3oo`3o0?oo003looh0lOl00>Oo0`3oo`3Zo`800?om
007o0?ko0@00o?l00?ko003Wo`00oOl00>oo003no`T0ool0ool0ool0o_l30?l0
0?[o003no`D0o`3oo`3fo`00o?ol00;oo`3no`D0o`3oo`3jo`@0o`3o0?ko003b
ooh03?oo0?oo0?oo003oo`3eo`400?go0@00noon00Goo`00o`2Eo`00o_l1n_on
003jk_l20?X0iol3nP00n]oo0@00nOl2003jiOonnP00j_l00?go4@3oo`3oo`3o
n_oo0?X00?l00?kjm?l30?l0n^So103jo`3jj_l3n_[o0?kj0Oojo_l10?[lo`@0
0?l00>Oo1OX0o`3on^oo003no`T0ool0ool0ool0o_l3nP3j0?[o0?[no`D0oo[o
o`3no`400?_o003lookj1000ooojo_l60?oj0?oj0?_o103on_ojo_l50?oo0?l0
moonnPgoo`3ooo[oo`3jo`3j0?Ko0O[joOl30?X00?gooP05o`00n_l0UOl00?ko
1I[oo`00V^ko0P2J0>Oo0iX009[Eo`8009[UoojJ003Zo`00oOl80?oo0?oo0?nJ
o_l5VP00o`00oY[do`<0o`2Jj?l409[o09[Zo`>JV_oooYX1oi[mo`2Jnol20?l0
i_l5VP3o0?nJkol00?ko2@3oo`3oo`3oo`3no`:J09[io`2Jo?l0V__o0@00mOon
V_go09[lo`BJ0?nJ0?Wo0Y[oV__o0P3o0?OooY[lo`2Jo_l4V_l0VP3fo`6JV_co
0YX00?gooP05o`3oV_l0cOl2O<Wo003no`00oOl00>go003Vo`<0ool0gol1003g
o`00iOom0>[o003mo`D0ool0ooon00?oo`00o?on0?7o003Xo`00o_l00>[oo03n
o`D00?oo003lo`00o_l00>Oo1@3oo`3o0>co003no`d0ool0ool00?oo0?l00?[o
1P00ool0o`3no`00koon00;oo`3no`00o?l00?_o0@3ooP3no`00lOl;003o0?oo
003oo`00l_l1003mo`400?_ooP00ooh00Ol0UOl00?ko1O[oo`00n^kooP3Wo`?j
003jgol1003io`800?[Uo`?jnP00j_l00?go4@3oo`3oo`00n_oo0?X00?l00?kj
m?l30?l0n^So1?X0o`3jj_l00?gjo_l5n_[oo`3jo?l4003o003Wo`3joP01oo[/
o`00o_l=0?oo0?oo003oooX0nP3jo`Kj0?oo0?ojo_l40?oo003co`GjnP3ooo[n
o`H0ool0o`3jnol10?onn_ko1@3oo`3o0?Ko3?[jo`3ooo[jool0n_on0?Ko0O[j
oOl30?X00?gon`02n_l0UOl00?ko1I[oo`00V^ko0P3o0>Oo0iX009[Eo`8009[U
o`>JV_l0j_l00?go203oo`3oo`00V_ko1IX00?l00?jJm?l30?l0V^So19X0o`2J
jOomV_ko0IZJo_l0V__o0P3o0>Ko1IX00?ooV^co003no``0ool0ool00?ooVP2J
nOl0V_co09[ko`400??o0IZJo_l0V__o0`3o09[ioojJnol20?l0m_l1VY[mo`6J
V_ko0I[ooP3fo`6JV_co0YX00?goo@04oonJo`3=o`:4bOl00?ko003mo`00k_l2
0?l0iol30?oo0=oo003fo`00iOl3003o0?;oo03no`00oOl<0?oo0?oo0?l0ool0
0?ko0@3ooP3ao`00j?l40?l0o`3Yo`400?co1@00ool00?co003no`00iol2003o
oP3]o`00oOl60?oo0?oo0?ko0`3o003jo`H00?oo0?l0o_l00>ko1000ool0o_l0
0?co003koo`0o_l00?ko003dooh00_oo0?kooP3co`400?go0@00noon003ooP01
o`2Eo`00o_l2n_oooP3^o`;j0?[Wo`?j003jgol00?So0P00n^Go0`00o`3boo`0
o_l00?go4@3oo`3oo`3on_oo0?X00?oj0?kjm?l30?l0n^So1?X0nP3jjOl1003l
o`D0n_oo0?[lo`@00?l00>Oo0?[n007j0>go003mo`H0ool0ool0o_l3nP3j0?[o
1_[jool0oo[no`@0ool00?;o1?X0ooojo_l60?oo0?l0n__ooP01n_[no`D0ool0
nP3eo`GjnP3ooo[no`D0n_[o003fo`7jn_go0`3j003moo`00o[jo`2Eo`00o_l4
V_oo003]o`:J09[Wo`>J002JeOl2002Jh_l00?;oo03no`00oOl80?oo0?oo0?nJ
o_l5VP00oiX0oY[do`<0o`2Jj?l4VP2J09[Qo`2Jo_l0V__o0P3o0>Ko1I[o0?nJ
0>go003mo`H0ool0ool0o_l2VP2JnOl1VY[mo`2Jnol1003bo`2Jo_l0V__o0`3o
09[ho`6JV__o0P2J0?Go0IZJo_l0V_go19ZJo`00m_l1VY[lo`:J003mood01?nJ
V_l0cOl2FlWo1000ool0oOl00>ko0P3o0>Oo0`3oo`3Co`00iOl3003o0>[o003m
o``0ool0ool0ool0o`00o_l10?on0?7o003Xo`@0o`3o0>7o1000o`00n?l00>Oo
0P00ooh0k_l<0?oo0?oo0?oo0?oo0?ko0`3o003io`D0ool0o`3no`00k_l4003o
o`3no`00o?l00?_oo03mo`<0ool0m?on00;oo`3no`80o`3bo`00o?l00?[o1`00
o`00ool0UOl6003ooo[oooh0k_l2nP3jiol3nP00n]Go0P00n^Go0`00o`3Zo`00
oOlA0?oo0?oo0?oon_l0nP00ooX0o_[do`<0o`3jj?l4nP3j0?[Qo`Cjn_l0n__o
0`3o003Wo`Gj0?l0nP3^o``0ool0ool0ool0ool0o_l3nP3j0?Wo1O[oo`3on_ko
103oo`00l_l4n_[ooo[no`H0ool0o`3jnoon007jn_go103o0?X0mOl50?[joooj
o_l50?ojo`00mOl0n_cooP3lo`Ojn_l0n_oo09Go2000oonJool00>go0YX0V^Oo
0iX009[Eo`8009[Ro`00j_l00?go4@3oo`3oo`3ooi[ooiX00?nJ0?jJm?l30?l0
V^So19X0VP2JhOl4VY[ooi[ko`80o`3Vo`2Jo_l1VP3^o``0ool0ool0ool0ool0
o_l2VP2Jn?l0V_go09[ko`400?;o19ZJoonJnol30?l0V_So0IZJnol209X0m?l4
VY[ooi[lo`>Jo`00mOl0V__o0@00o?l7VY[ooi[oo`3=o`8`bOl00?ko003mo`00
k_l20?l0i?l00=?o003To`80o`3[ooh0oOl1003no`H00?l0o`00o_l10?on0?7o
003Xo`@0o`3o0>7oo03ho`00iol2003ooP3_oo`0o_l1003no`L00?oo0?l00?Wo
oP02ool0o_l00>go0`00o`3no`400?go003jo`<0ool0oOl30?oo0?Co0@3ooP3m
o`80o`3bo`00o?l00?Wo1P3o003oo`2Eo`00o_l2n_oooP3^o`;j0?[Vo`800?[E
ooh0i?l20?l0joon0?go0@00o_l;003on_l0nP00ooX0o_[do`<0o`3jj?l4nP3j
003Qo`00oO[ko`<0o`00iol5n_[o0?X0kool0?ko0@00o_l7003oooX0nP3io`Gj
nP3ooo[no`@0ool00?7o0o[joo[no`H00?l0o`3jn_l30?oon_go103o0?X0mOl1
0?onn_go1@3on_l00?Go0?[looh0nol6n_l0n_oo09Go003no`BJool00>go0YX0
V^Ko0P00V]Go0@00hOl00>_ooP3mo`400?ko2`00oi[ooiX00?nJ0?jJm?l30?l0
V^So0iX0VP3OoofJnol20?l0i_l5VY[ooiX0kool0?ko0@00o_l6003ooiX0V_So
0IZJo_l0V__o0@00lOl3VY[oV__o0`3o09[go`2Jnol209X0loonV__o0i[o003e
o`2Jnol1003ko`JJoonJool0cOl1`LWo003no`00oOl00>kooP3Vooh0/ol00=oo
1P3oo`3oo`3no`40ooh0lOl00>Ko0P3o0>7ooP3fo`00i_l10?on0>;o003no`<0
o`00n?l4003oo`3no`40ooh0l?on0?go003mo`00mol00?go0`3oo`3cood0oOl3
0?l00>go003iood00_oo09Go003no`;jooon0>ko0_X0n^Ko0_[j0=Go0@00hOl0
0=oo2`3ooo[oooX00?oj0?kjm?l30?l00>Oo0`3j003Qooh0nOl30?l00>Ko1?[o
0?X0h_l00?ko0oX0nP3ho`Cjn_oon_ko0@3ooP3`ookjoOl50?l0o`3jmol0n_go
103o0?X0m?l3003jn_go1@3on_X00>oooP3ko`KjnP3jool0UOl00?ko19[oo`00
kOl2V_nJi_l1VY[Do`400>7o003Oo`/0oonJoonJ003oVP3nV_Co0P3o0>Ko0P2J
0=Go0P3o0>Go19[ooiX0h_l00?ko0YX0V_Oo19ZJoonJo?on0?3ooY[ko`<0o`2J
mol0V__o0P2J0?;o0IZJnol3VYX00>ko0@00nol6VY[oV_oo0<go0Ig9o`@00?oo
0?go003]o`400>Ko0@00/_l00=oo1P3oo`3oo`3no`@00?l00??o0P3o0>Co003P
o`400=[o0@3ooP3Ro`00o_l30?l00?Oo0`3oo`3no`40ooh0jOl00?go003bo`00
o_l00?Co0@00nol30?oo0>go003iooh0o_l009Go1P00ooojooon0>go0OX0i_l1
n_[Do`400>7o003Oo`h0ooojoooj003on_[on_[do`<0nP00iol30?l00>3o0@00
nOl20?l0iOl4n_ojnP3Ro`00o_l3nP3j0?Oo0o[ooo[no`40ooh0jOl50?l0o`3j
l_l40?l00?[do`400?_o1@3oooX00>oooP3ko`80n_[no`00UOl8003ooi[oo`00
k?l0V^Go0IZJe?l1003Qo`00gol>0?ooV_ooVP00oiZJoiZJm?l209X0i_l20?l0
eOl20?l0iOl4V_nJVP3Ro`00o_l2VP2Jm_l3V_ooV_cooP3Wo`<0o`2Jl?l2002J
jOl2VP00k_l1003jo`6JV_ko003=o`5ibOl00?ko003mo`00kOl00>Go0@00/_l0
0=oo1P00o`3oo`3no`<00?l0m?on007o0>Co003Po`400=[ooP01o`3Ro`L00?oo
0?l00?Ko0P3o0?goo@3Yo`00oOl00?;o003no`00k?l50?oo0?l0koon0?[o003m
o`00UOl00?ko0_[oooh0kOl0n^Go0O[je?l1003Qo`00gol=003on_oonP00oo[j
oo[doo`0iol30?l00>3o0@00nOl20?l0iOonnP7o0>;o1`00oooj0?X0m_l2n_oj
oOom0>Wo1@3o0?l0n_;o103o003jk?l50?oonP3jkoon0?[o003mo`00UOl00?ko
19[oo`00k?l0V^Go0IZJe?l1003Qo`00gol=003oV_ooVP00oiZJoi[dood0i_l2
0?l0eOl20?l0iOonVP7o0>;o1P00oonJ09[eo`:Joi[looh0iol30?l0V_3o0P00
V^Wo0YX0V^oooP3eo`00cOl1GLWo003no`00j?l00>Go0@00/_l00=oo1P3oo`3o
o`3no`400?;ooP3So`400>3o0@00f_l40?l0o`3Ro`00o_l30?l00?Ko0P3o0?go
0P3o0>Oo103o0?l0lOl30?oo0>_o003no`00koon0?Go002Eo`00o_l4n_oo003/
o`3jiOl1n_[Do`400>7o003Oo`/0ooojoooj003on_[bood0i_l3003j0>3o0@00
nOl20?l0iOl40?l0o`3Ro`00o_l3nP3j0?Ko0_[on_go0P3o0>Oo1000nP3jlOon
003jjol40?oo0?[_ooh0mOl009Go003no`BJool00>co09[Uo`6JV]Co0@00hOl0
0=oo2`3ooi[ooiX00?nJV_;oo@3Vo`8009[Eo`80o`3Qo`00h_l00?ko0YX0V_Go
0Y[oV]oo0`2J09[`o`8009[Xo`40V^oooP3eo`00cOl1@LWo1000ool0bol1002b
o`00gol60?oo0?oo0?ko0@00l_on0>?o0@00h?l00=Wo103o0?l0h_l00?ko0`3o
003eo`400?gooP3Wo`80o`3_o`<0ool0jol10?on0>oooP3eo`00UOl8003ooo[o
o`00col1n_[Do`400>7o003Oo`/0ooojoooj003on_[bood0i_l3003j0>3o003h
o`80o`3Uo`@0o`3o0>;o003no`?j0?X0mOl1n_[mooh0iol3003j0?3ooP00n^_o
0@3ooP3_ooh0mOl009Go2000oonJool00<oo0IZJe?l1003Qo`00gol;0?ooV_oo
VP00oiZJl_om0>Ko0P00V]Go0P3o0>7o003Ro`00o_l2VP2Jm?l1VY[Oo`80VP3_
o`8009[Yooh0koon0?Go003=o`4jeOon0?go0@00o_l00?ko002Lo`00h?l00=oo
1P00o`3oo`3no`400=?o0`3o002fo`<00?l0h_l7003oo`3o003eo`400?go0@00
i_l20?l0kol30?oo0>_o0@3ooP3Po`00XOon0?go0@00o_l00?ko1?[oo`00X?l1
nP3Qo`00gol;003on_oonP00oo[jl?l1003Vo`?j0?X0e_l20?l0i?l3003o0>;o
1`00oooj0?X0mOl1n_[mo`400>Ko0`00nP3`ood0jol10?on0>3o002Qooh0oOl1
003no`00o_l4V_oo002Po`6J0>7o003Oo`/00?nJoonJ003oVY[`o`400>Ko0YX0
V]Go0P3o0>7o003Ro`H00?ooVP2Jm?l1VY[Oo`80VP3_o`400>SooP3Po`00cOl1
8]Ko003no`T0ool0ool0ool0o_l009co0@00hOl00=oo1P3oo`3oo`3mo`00dol2
0?l0e_on0>?o0`00o`3Ro`00o_l30?l00?Co003;ood0jool0>3o002Ro`00o_l9
0?oo0?oo0?oo0?ko1?[oo`00X?l1n_[Qo`00gol;0?oon_oonP00ooojl?l1003V
o`;j0?[Food0i?l3003o0>;o003no`?j0?X0m?l0n]oooP3`ood0jool0>3o002R
o`00o_l90?oo0?oo0?oo0?ko19[oo`00X?l1VY[Qo`00gol;0?ooV_ooVP00oonJ
l?l1003Vo`:J09[Food0hOl00>;o003no`:J09[co`2Jgoon0?3ooP3Xooh0h?l0
0<go0B7Fo`00o_l90?oo0?oo0?oo0?ko002Lo`400>7o003Oo`H0ool0ool0oOl0
0?3o0@00i_on0=KooP3So`<00?l0h_l00?ko0`3o003Bood0l?on0>Wo0P3o0=oo
002Ro`00o_l90?oo0?oo0?oo0?ko1?[oo`00X?l1n_[Qo`00gol;0?oon_oonP00
ooojl?l1n_[Vo`;j0?[Food0i?l3003o0>;o003no`?j0?X0d_on003jl?on0>Wo
0P3o0=oo002Ro`00o_l90?oo0?oo0?oo0?ko19[oo`00X?l1VY[Qo`00gol;0?oo
V_ooVP00oonJl?l1VY[Vo`:Joi[Food0hOl00>;o003no`:J09[Aooh009[`ooh0
a?l00<go0D_Co`00o_l:0?oo0?oo003oo`2Ko`00hOl00>_ooP3mo`400?ko1P00
o`3oo`3mo`00l?l1003Vooh0e_on0>?o0`3oo`3]o`00o?l1003no`L00?oo0?l0
0=;oo@3`ooh0jOl20?l0gol009oo003no`h0ool0ool00?oon_oo002Oo`3jhOl0
0>_ooP3mo`400?ko2`00oo[oooX00?oon_3o0O[ji_l2nP3je_om0>Co0`3oo`3]
o`00o?l1003no`L00?oonP3j0=;ooP00n_3ooP3Yo`80o`3Oo`00Wol00?ko3P3o
o`3oo`00oonJool009oo09[Qo`00joon0?go0@00o_l;003oV_ooVP00oonJl?l1
VY[Vo`:Joi[Food0hOl00>go003lo`400?ko1P00oonJ09[Aooh009[`ooh0a?l0
0<go0E[Loo`0o_l00?go1P3oo`3oo`3no`40ooh0POono`00k?l00?ko3`3oo`3o
o`3oo`3oo`3oo`3[o`400>KooP3Eo`00h_l30?oo0>ko0@00oOl60?oo0?oo0?ko
0`3o003Bood0k_l00>Wo0P3o0=oo002Xoo`0o_l00?go1P3oo`3oo`3no`7jooh0
POono`00k?l00?ko4@3oo`3oo`3oo`3ooo[oooX00>go0O[ji_l2nP3jeOl2nP00
i?l30?oo0>ko0@00oOl60?oo0?oo0?ko0oX0nP3Booh00?[^o`00jOl20?l0gol0
0:Soo03no`00oOl60?oo0?oo0?ko0I[ooP21ooko003/o`00o_lA0?oo0?oo0?oo
0?ooV_ooVP00kOl1VY[Vo`:Joi[Eo`:J003Qo`00k_l1003mo`H0ool0ool0o_l2
VP2JdOon002J/?l00<go0CGEo``0ool0ool0ool0ool0o_l10?on087oo_l00>co
003no`l0ool0ool0ool0ool0ool0jol1003Vooh0dol00>7o003]o`00oOl60?oo
0?oo0?ko0P3o0<oo003Dooh0gol00:7o303oo`3oo`3oo`3oo`3no`7jooh0POon
o`00k?l00?ko4@3oo`3oo`3oo`3ooo[oooX00>go0@3ji_l2n_X0e?l10?[Qo`00
kOl00?go1P3oo`3oo`3no`;j0?[?o`3je?on0=oo002Qo``0ool0ool0ool0ool0
o_l1V_on087oo_l00>co003noa40ool0ool0ool0oonJoonJ003/o`2Ji_l1VY[C
o`40V^7o003]o`00oOl60?oo0?oo0?ko0YX0V/oo09Z_o`00cOl15]Koo03no`40
0?ko1@00ool0ooh0POono`00jOl00?ko303oo`3oo`00o`3oo`3[o`400>Go0@00
dol00>7o003]o`00oOl<0?oo0?oo003oo`3o0:7o0@00g_l00:;oo03no`400?ko
1@00ooojooh0POono`00jOl00?ko3P3oo`3oo`00oo[oooX00>go0@00iOl1nP3D
o`40n^7o003]o`00oOl<0?oo0?oo003oooX0nZ7o0@00g_l00:;oo03no`400?ko
1@00oonJooh0POono`00jOl00?ko3P3oo`3oo`00oi[ooiX00<oo09[Co`40V^7o
003]o`00oOl<0?oo0?oo003ooiX0VX7oo?l00<go0@39o`00o_l40?oo0021ooko
003boo`0o_l00?go303oo`3oo`3oo`3oo`3[o`400>Co003Co`00hOl00>go003m
o`H0ool0ool0o?l00:3o003No`00UOl00?ko1?[ooo[jPOono`00l_ol0?ko003m
o`h0ool0ool0ooojoooj003]o`400>Co003Do`40n^7o003]o`00oOl60?oo0?oo
0?ko0P3onZ3o003No`00UOl00?ko19[ooiZJPOono`00l_ol0?ko003mo`h0ool0
ool0oonJoonJ002Po`40V^7o003]o`00oOl60?oo0?oo0?ko0P3oVX7oo?l00<go
0?K9o`00o_l40?oo0021ooko003[oa80ool0ool0ool0ool0ool0ool0jol1003T
o`00e?l1003Qo`00kOl00?go1P3oo`3oo`3lo`00POolo`00UOl00?ko1?[ooo[j
POono`00jolD0?oo0?oo0?oo0?oo0?oon_oonP00kOl1003To`00e?l1nP3Qo`00
kOl00?go1P3oo`3oo`3no`80ooZ1ooco002Eo`00o_l4V_ooVYZ1ooko003[oa@0
ool0ool0ool0ool0oonJoonJ002Po`2Jh?l00>go003mo`H0ool0ool0o_l20?nJ
POolo`00cOl0g/Wo003no`<0ool0POomo`00k?ol0?ko0@00o_l6003o0?oo0>[o
002fo`400>7o003^ooh0oOl1003no`400?go0021ooco002Eo`00o_l3n_oonX7o
oOl00>coo03no`400?ko2000oo[oooX00>co002fo`7j0>7o003^ooh0oOl1003n
o`H00?oo0?ojPOolo`00UOl00?ko0i[ooiZ1oogo003/oo`0o_l1003no`P00?nJ
oonJ002Po`2Jh?l00>kooP3mo`400?ko1P00ool0oiZ1ooco003=o`2ObOl7003o
o`3oo`21oogo003Oo`H0ool0ool0W_l1003Qo`00h_l00?co0021ooco002Eo`L0
0?oon_oonX7ooOl00=oo203ooo[oooX00:3o0OX0hOl00>;o003no`80ooZ1ooco
002Eo`L00?ooV_ooVX7ooOl00=oo203ooi[ooiX00:3o09[Po`00h_l00?ko0P3o
VX7oo?l00<go09C9o`00oOl20?l0POomo`00gol60?oo0?oo087oo?l00>;o003l
o`00POolo`00UOl00?go0_[onX7ooOl00=oo203ooo[oooX0087oo_l00>;o003n
o`80ooZ1ooco002Eo`00oOl2V_nJPOomo`00gol80?ooV_ooVP00POono`00h_l0
0?ko0P3oVX7oo?l00<go09K9o`00oOl20?l0POomo`00gol6003oo`3o087oo?l0
0>;o1P00o`3oo`21ooco002Eo`00oOl2n_ojPOomo`00gol8003ooo[onP00POon
o`00h_l6003onP3onX7oo?l009Go003mo`:JoiZ1oogo003Oo`P00?ooV_nJ0021
ooko003Ro`H00?nJ0?nJPOolo`00cOl0VLWo0@00o_l20?l0POomo`00gol00?ko
0P3o087oo?l00>;o1P3oo`3oo`21ooco002Eo`400?ko0_[onX7ooOl00=oo003n
o`CjooX0087oo_l00>;o1P3oooX0ooZ1ooco002Eo`400?ko0Y[oVX7ooOl00=oo
003no`BJoiX0087oo_l00>;o1P3ooiX0oiZ1ooco003=o`2HbOl00?go0P3o087o
oOl00=oo2000ool0o`3o087oo_l00>;o1P00o`3oo`21ooco002Eo`00oOl2n_oj
POomo`00gol8003ooo[onP3jPOono`00h_l6003onP3onX7oo?l009Go003mo`:J
oiZ1oogo003Oo`P00?ooV_nJ09Z1ooko003Ro`H00?nJ0?nJPOolo`00cOl0U<Wo
003mo`80o`21oogo003Oo`00o_l20?l0POolo`00h_l60?oo0?oo087oo?l009Go
003mo`;jooZ1oogo003Oo`00o_l3n_oj087ooOl00>;o1P3oooX0ooZ1ooco002E
o`00oOl2V_nJPOomo`00gol00?ko0i[oVP21oogo003Ro`H0oonJ0?nJPOolo`00
cOl0T/Wo003mo`40087oo?l00=oo003no`40ooh0POono`00h_l60?l00?oo087o
o?l009Go003mo`7jnX7oo?l00=oo003no`7jooh0POono`00h_l60?ojnP3onX7o
o?l009Go003mo`6JVX7oo?l00=oo003no`6Jooh0POono`00h_l60?nJVP3oVX7o
o?l00<go09C9o`400?ko0@00POolo`00gol5003oo`3ooP21ooko003Rooh00ooo
0021ooco002Eo`400?ko0O[jPOolo`00gol5003ooo[ooP21ooko003Ro`H0n_[o
003jPOolo`00UOl1003no`6JVX7oo?l00=oo1@00oonJooh0POono`00h_l609ZJ
o`3oVX7oo?l00<go08o9o`00oOl10021ooco003Oo`00o_l10?on087oo_l00>;o
0@00o_l0087onol009Go003mo`7jnX7oo?l00=oo003no`7jooh0POono`00h_l5
0?[o0?ojPOoko`00UOl00?go0IZJPOolo`00gol00?ko0I[ooP21ooko003Ro`D0
V_l0oiZ1oo_o003=o`4;bOl00?go0@00k?l00>Ko003Vo`00i_l00>Ko003Oo`00
o_l30?l00>go003Vo`00i_l00>Ko003Vo`00hoon0?ko003[o`00i_l00>Ko003V
o`00i_l009Go003mo`7jn^co003Vo`00i_l00>Ko003Vo`00gol00?ko0o[onP3]
o`00i_l00>Ko003Vo`00i_l00>?ooP03o`3on^_o003Vo`00i_l00>Ko003Vo`00
UOl00?go0IZJk?l00>Ko003Vo`00i_l00>Ko003Oo`00o_l2V_nJk?l00>Ko003V
o`00i_l00>Ko003Sooh00ol0oi[[o`00i_l00>Ko003Vo`00i_l00<go05g9oh40
m03Ooh40m03Sooh00OooP@3h09Goo001n_Z10?/0goom00;j0?Z10?/0hook003j
P@3j09Goo001VYZ10?/0goom00>J09[oP@3l0>?oo001oiZ10?X0cOl09X7oPOn1
onoooP21oh7oPOn1ok3ooP21oh7oPOn1ok3ooP21ol;o01b1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1ohGo01b1oh7oPOn1oh7oPOn1oh7oPOn1oh7oPOn1ohGo0Zje
ooh0oOl1003mo`400?;o003mo`400?go0@00lol1003mo`400?go0@00m?on0?go
0@00oOl1003fo`00o?l1003mo`400?go0@00e?on0?go0@00oOl1003bo`00oOl1
003mo`400??o0@00oOl1003mo`400?CooP3mo`400?go0@00m_l00?co0@00oOl1
003mo`400=OooP3mo`400?go0@00l_l00?go0@00oOl1003co`400?go0@00oOl1
003dooh0oOl1003mo`400?Ko003lo`400?go0@00oOl1002:ooh0oOl1003mo`40
0?;o003mo`400?go0@00lol1003mo`400?go0@00m?on0?go0@00oOl1003fo`00
o?l1003mo`400?go0@00e?on0?go0@00oOl1003bo`00oOl1003mo`400??o0@00
oOl1003mo`400?CooP3mo`400?go0@00m_l00?co0@00oOl1003mo`400=OooP3m
o`400?go0@00l_l00?go0@00oOl1003co`400?go0@00oOl1003dooh0oOl1003m
o`400?Ko003lo`400?go0@00oOl1002:ooh0oOl1003mo`400?;o003mo`400?go
0@00lol1003mo`400?go0@00m?on0?go0@00oOl1003fo`00o?l1003mo`400?go
0@00e?on0?go0@00oOl1003bo`00oOl1003mo`400??o0@00oOl1003mo`400?Co
oP3mo`400?go0@00m_l00?co0@00oOl1003mo`400=OooP3mo`400?go0@00l_l0
0?go0@00oOl1003co`400?go0@00oOl1003dooh0oOl1003mo`400?Ko003lo`40
0?go0@00oOl1003Fo`=m]_l00?ko303oo`3oo`3oo`3oo`3do`400?ko2@3oo`3o
o`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l1003m
o`l0ool0ool0ool0ool0ool0e_l00?ko303oo`3oo`3oo`3oo`3do`400?ko2@3o
o`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l1
003mo`l0ool0ool0ool0ool0ool0fOl00?ko303oo`3oo`3oo`3oo`3do`400?ko
2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0
n?l1003mo`l0ool0ool0ool0ool0ool0S?l00?ko303oo`3oo`3oo`3oo`3do`40
0?ko2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0
ool0n?l1003mo`l0ool0ool0ool0ool0ool0e_l00?ko303oo`3oo`3oo`3oo`3d
o`400?ko2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0
ool0ool0n?l1003mo`l0ool0ool0ool0ool0ool0fOl00?ko303oo`3oo`3oo`3o
o`3do`400?ko2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0ool0
ool0ool0ool0n?l1003mo`l0ool0ool0ool0ool0ool0S?l00?ko303oo`3oo`3o
o`3oo`3do`400?ko2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003no``0
ool0ool0ool0ool0n?l1003mo`l0ool0ool0ool0ool0ool0e_l00?ko303oo`3o
o`3oo`3oo`3do`400?ko2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko003n
o``0ool0ool0ool0ool0n?l1003mo`l0ool0ool0ool0ool0ool0fOl00?ko303o
o`3oo`3oo`3oo`3do`400?ko2@3oo`3oo`3oo`3eo`00o?l90?oo0?oo0?oo0?Ko
003no``0ool0ool0ool0ool0n?l1003mo`l0ool0ool0ool0ool0ool0eol3OKKo
003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo0?Ko003ko`T0ool0
ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo
0=Ko003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo0?Ko003ko`T0
ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo
0?oo0=Wo003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo0?Ko003k
o`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo
0?oo0?oo08co003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo0?Ko
003ko`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo
0?oo0?oo0?oo0=Ko003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo
0?Ko003ko`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo
0?oo0?oo0?oo0?oo0=Wo003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo
0?oo0?Ko003ko`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?
0?oo0?oo0?oo0?oo0?oo08co003no``0ool0ool0ool0ool0mOl20?l0o_l90?oo
0?oo0?oo0?Ko003ko`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00
oOl?0?oo0?oo0?oo0?oo0?oo0=Ko003no``0ool0ool0ool0ool0mOl20?l0o_l9
0?oo0?oo0?oo0?Ko003ko`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3g
o`00oOl?0?oo0?oo0?oo0?oo0?oo0=Wo003no``0ool0ool0ool0ool0mOl20?l0
o_l90?oo0?oo0?oo0?Ko003ko`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3o
o`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Oo0e2co`00o_l90?oo0?oo0?oo0?Ko
0`3oo`3no`T0ool0ool0ool0m_om0?ko2@3oo`3oo`3oo`3eooh0o_l90?oo0?oo
0?oo0?Oo003mo`l0ool0ool0ool0ool0ool0dol00?ko2@3oo`3oo`3oo`3fo`<0
ool0o_l90?oo0?oo0?oo0?Koo@3no`T0ool0ool0ool0mOon0?ko2@3oo`3oo`3o
o`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Ko003no`T0ool0ool0ool0m_l30?oo
0?ko2@3oo`3oo`3oo`3food0o_l90?oo0?oo0?oo0?GooP3no`T0ool0ool0ool0
mol00?go3`3oo`3oo`3oo`3oo`3oo`29o`00o_l90?oo0?oo0?oo0?Ko0`3oo`3n
o`T0ool0ool0ool0m_om0?ko2@3oo`3oo`3oo`3eooh0o_l90?oo0?oo0?oo0?Oo
003mo`l0ool0ool0ool0ool0ool0dol00?ko2@3oo`3oo`3oo`3fo`<0ool0o_l9
0?oo0?oo0?oo0?Koo@3no`T0ool0ool0ool0mOon0?ko2@3oo`3oo`3oo`3go`00
oOl?0?oo0?oo0?oo0?oo0?oo0=Ko003no`T0ool0ool0ool0m_l30?oo0?ko2@3o
o`3oo`3oo`3food0o_l90?oo0?oo0?oo0?GooP3no`T0ool0ool0ool0mol00?go
3`3oo`3oo`3oo`3oo`3oo`29o`00o_l90?oo0?oo0?oo0?Ko0`3oo`3no`T0ool0
ool0ool0m_om0?ko2@3oo`3oo`3oo`3eooh0o_l90?oo0?oo0?oo0?Oo003mo`l0
ool0ool0ool0ool0ool0dol00?ko2@3oo`3oo`3oo`3fo`<0ool0o_l90?oo0?oo
0?oo0?Koo@3no`T0ool0ool0ool0mOon0?ko2@3oo`3oo`3oo`3go`00oOl?0?oo
0?oo0?oo0?oo0?oo0=Ko003no`T0ool0ool0ool0m_l30?oo0?ko2@3oo`3oo`3o
o`3food0o_l90?oo0?oo0?oo0?GooP3no`T0ool0ool0ool0mol00?go3`3oo`3o
o`3oo`3oo`3oo`3Go`=[]?l00?go2@3oo`3oo`3oo`3foo`02ooo0?oo0?oo0?oo
0?Ko003no``0ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?
0?oo0?oo0?oo0?oo0?oo0=Co003mo`T0ool0ool0ool0m_ol00_oo`3oo`3oo`3o
o`3fo`00o_l<0?oo0?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0mol00?go
3`3oo`3oo`3oo`3oo`3oo`3Go`00oOl90?oo0?oo0?oo0?Koo00;ool0ool0ool0
ool0m_l00?ko303oo`3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?Oo003m
o`l0ool0ool0ool0ool0ool0R_l00?go2@3oo`3oo`3oo`3foo`02ooo0?oo0?oo
0?oo0?Ko003no``0ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00
oOl?0?oo0?oo0?oo0?oo0?oo0=Co003mo`T0ool0ool0ool0m_ol00_oo`3oo`3o
o`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0mol0
0?go3`3oo`3oo`3oo`3oo`3oo`3Go`00oOl90?oo0?oo0?oo0?Koo00;ool0ool0
ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?Oo
003mo`l0ool0ool0ool0ool0ool0R_l00?go2@3oo`3oo`3oo`3foo`02ooo0?oo
0?oo0?oo0?Ko003no``0ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3g
o`00oOl?0?oo0?oo0?oo0?oo0?oo0=Co003mo`T0ool0ool0ool0m_ol00_oo`3o
o`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0
mol00?go3`3oo`3oo`3oo`3oo`3oo`3Go`00oOl90?oo0?oo0?oo0?Koo00;ool0
ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo
0?Oo003mo`l0ool0ool0ool0ool0ool0eol3OKGo3`3oo`3oo`3oo`3oo`3oo`3c
o`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0m_l00?ko303oo`3o
o`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Go3`3oo`3oo`3oo`3oo`3o
o`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0m_l00?ko303o
o`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=So3`3oo`3oo`3oo`3o
o`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0m_l00?ko
303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo08_o3`3oo`3oo`3o
o`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0m_l0
0?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Go3`3oo`3o
o`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0
m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=So3`3o
o`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0
ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo08_o
3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0ool0
ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo
0=Go3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0ool0
ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo
0?oo0=So3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Ko003no``0
ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo
0?oo0?oo0=Oo0ZFfoo`0o_l1003mo`400??ooP3no`400?go0@00m?on0?go0@00
oOl1003dooh0oOl1003mo`400?OooP3mo`400?go0@00oOl1003Eoo`0o_l1003m
o`400??ooP3no`400?go0@00m?on0?go0@00oOl1003dooh0oOl1003mo`400?Oo
oP3mo`400?go0@00oOl1003Hoo`0o_l1003mo`400??ooP3no`400?go0@00m?on
0?go0@00oOl1003dooh0oOl1003mo`400?OooP3mo`400?go0@00oOl1002;oo`0
o_l1003mo`400??ooP3no`400?go0@00m?on0?go0@00oOl1003dooh0oOl1003m
o`400?OooP3mo`400?go0@00oOl1003Eoo`0o_l1003mo`400??ooP3no`400?go
0@00m?on0?go0@00oOl1003dooh0oOl1003mo`400?OooP3mo`400?go0@00oOl1
003Hoo`0o_l1003mo`400??ooP3no`400?go0@00m?on0?go0@00oOl1003dooh0
oOl1003mo`400?OooP3mo`400?go0@00oOl1002;oo`0o_l1003mo`400??ooP3n
o`400?go0@00m?on0?go0@00oOl1003dooh0oOl1003mo`400?OooP3mo`400?go
0@00oOl1003Eoo`0o_l1003mo`400??ooP3no`400?go0@00m?on0?go0@00oOl1
003dooh0oOl1003mo`400?OooP3mo`400?go0@00oOl1003Hoo`0o_l1003mo`40
0??ooP3no`400?go0@00m?on0?go0@00oOl1003dooh0oOl1003mo`400?OooP3m
o`400?go0@00oOl1003Fo`0WPOn1oh7o[_l10021oh7oPOn1ojoo0@00POn1oh7o
POn_o`4008;o02Z7o`00POn1ojSo0021ohSo0021oh7oZ?l0087oR?l0087oPOnX
o`00P_l0?87oPOoJo`@00?l0087ofOon087oPOn1omgo1000o`00POoIooh0POn1
oh7ogOl4003o0021omWooP24o`1bS_om003ooP3mooX00Ol0o_l10021onKo0@00
POoGo`<0ool0POnBood00?on0?gonP01o`3no`40087oi_l10021omOo0`3oo`21
oi;oo@00ooh0oOoj007o0?ko0@00POoVo`40087oeol30?oo08Go08B?o`00n_l0
0?ko003no`/0o`3o0?l0o`3oo`21onOo0021omKo0`3oo`21oi?o003jo`00o_l0
0?ko2`3o0?l0o`3o0?oo087oiol0087oe_l30?oo087oTol00?[o003no`00o_l;
0?l0o`3o0?l0ool0POoWo`00POoFo`<0ool0QOl0PHkooP3mo`00o_l00?ko203o
0?l0o`3oooh0POoWo`00POoFo`<0ool0POnBooh0oOl00?ko003no`P0o`3o0?l0
ooon087oiol0087oe_l30?oo087oT_on0?go003no`00o_l80?l0o`3o0?oooP21
onOo0021omKo0`3oo`25o`1kRol00?ko003no`00o_l;0?l0o`3o0?l0ool0POoX
ooh0POoHood0POn>o`00o_l00?ko003no`/0o`3o0?l0o`3oo`21onSooP21omSo
o@21ohko003no`00o_l00?ko2`3o0?l0o`3o0?oo087oj?on087of?om08Co06>?
ood00Oooo001ooom00Oo0?l0o`3oood0POn1oh7oPOo:ood00Oooo001ooom00Oo
0?l0o`3oood0POn1oh7oPOo:ood00Oooo001ooom00Oo0?l0o`3oood0POn1oh7o
_?l0<X7o0_oo087oPOokooh0POn1okOo0021oh7onoon087oPOngo`00POn1oo_o
oP21okWo05?Aooh00Oooo02looh0POn1oo_o003no`00POn:ooh00Oooo02looh0
POn1oo_o003no`00POn:ooh00Oooo02looh0POn1oo_o003no`00POnjo`1:d_l0
0?ko0P3o087oPOn_o`00o_l0087oRol00?ko0P3o087oPOn_o`00o_l0087oRol0
0?ko0P3o087oPOn_o`00o_l0087o^_l0FM;o003no`40ood0POoFoh40l`3Zooh0
oOn10?<0W?l00?ko0@3oo@21omKoP@3c0>[ooP3moh40l`2Lo`00o_l10?om087o
e_n10?<0j_on0?goP@3c0<_o0=C?o`00nol00?koP@3g0>Co003Vo`00i_l00>Go
003Vo`00i_l00>_o003no`00o_l00>Ko003Vo`00iOl00>Ko003Vo`00VOl00?_o
003noh40m`3To`00i_l00>Ko003Uo`00i_l00>Ko003[o`00o_l00?ko003Vo`00
i_l00>Go003Vo`00i_l009Wo003ko`00o_n10?L0i?l00>Ko003Vo`00iOl00>Ko
003Vo`00jol00?ko003no`00i_l00>Ko003Uo`00i_l00>Ko003;o`5Zd?l00?[o
003no`00nol00?co003ko`00nol00?_o003ko`00nol00?_o003lo`00nol00?_o
003ko`00nol00?_o003ko`00nol00?co003ko`00nol00?_o003To`00POoeo`00
jol00?ko003no`00POoeo`00V_l00?[o003no`00nol00?co003ko`00nol00?_o
003ko`00nol00?_o003lo`00nol00?_o003ko`00nol00?_o003ko`00nol00?co
003ko`00nol00?_o003To`00POoeo`00jol00?ko003no`00POoeo`00V_l00?[o
003no`00nol00?co003ko`00nol00?_o003ko`00nol00?_o003lo`00nol00?_o
003ko`00nol00?_o003ko`00nol00?co003ko`00nol00?_o003To`00POoeo`00
jol00?ko003no`00POoeo`00bol0Ym7o1@3oo`3o0?ko003no`00POoio`00lOon
0?co003mo`00POoeo`00j_on0?go0021ooGo002Ko`D0ool0o`3no`00o_l0087o
nOl00?7ooP3lo`00oOl0087omOl00>[ooP3mo`00POoeo`00Vol50?oo0?l0o_l0
0?ko0021ooWo003aooh0o?l00?go0021ooGo003Zooh0oOl0087omOl00<_o09kB
oo`00OoooP3mo`00POoio`00l_l00?ko003no`400?go0021ooGo003So`00POoe
o`00W?ol007oooh0oOl0087onOl00?;o003no`00o_l1003mo`00POoeo`00hol0
087omOl009coo001ooon0?go0021ooWo003bo`00o_l00?ko0@00oOl0087omOl0
0>?o0021ooGo003;o`1ga?l0087onOl00>ko1@3oo`3o0?go0021ooGo003So`00
POoeo`00S_l0087onOl00>ko1@3oo`3o0?go0021ooGo003So`00POoeo`00S_l0
087onOl00>ko1@3oo`3o0?go0021ooGo003So`00POoeo`00bol0PlCo0021ooWo
003`o`L00?oo0?oo0?go0@00POogo`400>?o0021ooGo002>o`00POoio`00l?l7
003oo`3oo`3mo`40087omol1003So`00POoeo`00S_l0087onOl00?3o1`00ool0
ool0oOl10021ooOo0@00hol0087omOl00<_o0774o`00POoio`00k_l10?ol0?ko
0021ooGo003So`00POoeo`00S_l0087onOl00>ko0@3oo03no`00POoeo`00hol0
087omOl008ko0021ooWo003^o`40oo`0o_l0087omOl00>?o0021ooGo003;o`2<
a?l0087onOl00?;o003no`00oOl00?go0021ooGo003[oo`0o_l0087omOl008ko
0021ooWo003bo`00o_l00?go003mo`00POoeo`00jool0?ko0021ooGo002>o`00
POoio`00l_l00?ko003mo`00oOl0087omOl00>_oo03no`00POoeo`00bol0/=go
oP3nooh0nOol0?ko0021ooWo003aooh0oOon0?ko0021ooGo003[o`00o_l00?ko
0021ooGo002Wooh0o_on0?Woo03no`00POoio`00lOon0?gooP3no`00POoeo`00
jol00?ko003no`00POoeo`00Yoon0?kooP3ioo`0o_l0087onOl00?7ooP3mooh0
o_l0087omOl00>_o003no`00o_l0087omOl00<_o09kNo`00o_l20?l0o_l00?[o
003jo`00POoio`00i?l0087omOl00>Oo003no`00POoeo`00Z?l00?ko0P3o0?ko
003jo`00n_l0087onOl00>Co0021ooGo003Wo`00o_l0087omOl00:So003no`80
o`3no`00n_l00?[o0021ooWo003To`00POoeo`00iol00?ko0021ooGo003;o`2T
g_l00?ko0P3o0?ko003jood0oOl0087onOl00>Co0021ooGo003Xo`00oOl10021
ooOo0@00Z?l00?ko0P3o0?ko003jood0oOl0087onOl00>Co0021ooGo003Xo`00
oOl10021ooOo0@00Z?l00?ko0P3o0?ko003jood0oOl0087onOl00>Co0021ooGo
003Xo`00oOl10021ooOo0@00bol0T]_o003lo`00mOl00?ko0@00POoko`400>Co
0021ooGo003Xo`00oOl0087omOl00:Go003lo`00mOl00?ko0@00POoko`400>Co
0021ooGo003Xo`00oOl0087omOl00:Go003lo`00mOl00?ko0@00POoko`400>Co
0021ooGo003Xo`00oOl0087omOl00<_o08cLo`00o?l00?Co003no`00POoio`00
i?l0087omOl00>Wo003lo`00POoeo`00Y_l00?co003do`00o_l0087onOl00>Co
0021ooGo003Yo`00o?l0087omOl00:Ko003lo`00m?l00?ko0021ooWo003To`00
POoeo`00jOl00?co0021ooGo003;o`2ogOl90?oo0?oo0?oo0?[o003no`00o_l0
087onOl00?7ooP3nooh0oOl0087omOl00>Wo003lo`00POoeo`00Yol90?oo0?oo
0?oo0?[o003no`00o_l0087onOl00?7ooP3nooh0oOl0087omOl00>Wo003lo`00
POoeo`00Yol90?oo0?oo0?oo0?[o003no`00o_l0087onOl00?7ooP3nooh0oOl0
087omOl00>Wo003lo`00POoeo`00bol0]]koo000oo`0o_l00?gooP3mo`00POoi
o`00l_l00?ko0P3o0?ko003no`00POoeo`00hol0087omOl00:Soo000oo`0o_l0
0?gooP3mo`00POoio`00l_l00?ko0P3o0?ko003no`00POoeo`00hol0087omOl0
0:Soo000oo`0o_l00?gooP3mo`00POoio`00l_l00?ko0P3o0?ko003no`00POoe
o`00hol0087omOl00<_o07[4o`00POoio`00k_l20?l0o_l00?ko0021ooGo003S
o`00POoeo`00S_l0087onOl00>ko0P3o0?ko003no`00POoeo`00hol0087omOl0
08ko0021ooWo003^o`80o`3no`00o_l0087omOl00>?o0021ooGo003;o`1ma?l0
087onOl00?3o0@00o?l00?go0@00POogo`400>?o0021ooGo002>o`00POoio`00
l?l1003lo`00oOl10021ooOo0@00hol0087omOl008ko0021ooWo003`o`400?co
003mo`40087omol1003So`00POoeo`00bol0M<Co0021ooWo003^o`00o_l00?co
0021ooGo003So`00POoeo`00S_l0087onOl00>ko003no`00o?l0087omOl00>?o
0021ooGo002>o`00POoio`00k_l00?ko003lo`00POoeo`00hol0087omOl00<_o
0;3Aooh0oOl1003mo`00POoio`00l_l00?ko1P3oo`3oo`3no`00POoeo`00jOl1
003mo`00POoeo`00Voon0?go0@00oOl0087onOl00?;o003no`H0ool0ool0o_l0
087omOl00>Wo0@00oOl0087omOl009_ooP3mo`400?go0021ooWo003bo`00o_l6
0?oo0?oo0?ko0021ooGo003Yo`400?go0021ooGo003;o`2]d_l00?ko1P3oo`3o
o`3no`00POoio`00lOon007ooo`0o_l0087omOl00>[o003ko`00POoeo`00W?l0
0?ko1P3oo`3oo`3no`00POoio`00lOon007ooo`0o_l0087omOl00>[o003ko`00
POoeo`00W?l00?ko1P3oo`3oo`3no`00POoio`00lOon007ooo`0o_l0087omOl0
0>[o003ko`00POoeo`00bol0T];o003no`H0ool0ool0o_l0087onOl00>Co0021
ooGo003[o`00n_l0087omOl009co003no`H0ool0ool0o_l0087onOl00>Co0021
ooGo003[o`00n_l0087omOl009co003no`H0ool0ool0o_l0087onOl00>Co0021
ooGo003[o`00n_l0087omOl00<_o09G?o`00o_l30?oo0?ko0@00POoko`400>Co
0021ooGo003[ood0oOl10021ooOo0@00VOl00?ko0`3oo`3no`40087onol1003T
o`00POoeo`00joom0?go0@00POogo`4009Wo003no`<0ool0o_l10021oo_o0@00
i?l0087omOl00>_oo@3mo`40087omol1003;o`2Ed?l00?go0`3oo`3no`00POoi
o`00i?oi087oo?l00>_o003no`00o_l0087omOl009[o003mo`<0ool0o_l0087o
nOl00>ConOZ1ooco003[o`00o_l00?ko0021ooGo002Jo`00oOl30?oo0?ko0021
ooWo003TooVJPOolo`00jol00?ko003no`00POoeo`00bol0Ym7o2@3oo`3oo`3o
o`3no`00POoio`00i?l00?_o0021ooco003[o`00o_l00?ko0021ooGo002Ko`T0
ool0ool0ool0o_l0087onOl00>Co003ko`3jPOolo`00jol00?ko003no`00POoe
o`00Vol90?oo0?oo0?oo0?ko0021ooWo003To`00nol0VX7oo?l00>_o003no`00
o_l0087omOl00<_o09GBoo`0o_l1003mo`00iooi09_o003To`00nol0087oo?l0
0>[ooP3mo`00POoeo`00W?ol0?ko0@00oOl00>OonOZKo`00i?l00?_o0?Z1ooco
003Zooh0oOl0087omOl009coo03no`400?go003WooVJVol00>Co003ko`2JPOol
o`00j_on0?go0021ooGo003;o`2Ea?l00?GolP3konD0]_l00?7ooP3mo`400?go
003ko`00POolo`00hooi087oo?l008ko003eoo;jnooUn[Ko003aooh0oOl1003m
o`00nol0nX7oo?l00>?onOZ1ooco002>o`00mOobV__oiIZfo`00lOon0?go0@00
oOl00?_o09Z1ooco003SooVJPOolo`00bol0b<Co003eo`00d_l00?Con@3IooT0
nol00?;o003no`H0ool0ool0o_l00?_o0021ooco003So`00nol0087oo?l008ko
003eo`3jd_l0n_ConO[IooWjnol00?;o003no`H0ool0ool0o_l00?_o0?Z1ooco
003So`00nol0nX7oo?l008ko003eo`2Jd_l0V_ConI[IooVJnol00?;o003no`H0
ool0ool0o_l00?_o09Z1ooco003So`00nol0VX7oo?l00<_o0;34o`00mOl00=;o
lP3komL0nooi0>ko1P3oo`3oo`3no`00nol0087oo?l00>?o003ko`00POolo`00
S_l00?Go0?[Boo;jnooGn__onO[^o`H0ool0ool0o_l00?_o0?Z1ooco003So`00
nol0nX7oo?l008ko003eo`2Jd_obV__oei[kooVJk_l60?oo0?oo0?ko003ko`2J
POolo`00hol00?_o09Z1ooco003;o`2Ta?l00?Go0026o`00l?l1003no`<0ool0
o_l1003lo`00POomo`400>?o003ko`00POolo`00S_l00?Go0?Z6o`3jl?l1003n
o`<0ool0o_l1003lo`3jPOomo`400>?o003ko`3jPOolo`00S_l00?Go09Z6o`2J
l?l1003no`<0ool0o_l1003lo`2JPOomo`400>?o003ko`2JPOolo`00bol0b=co
003noo`0n_ol0?ko003eo`00Q_l00>ko1P3oo`3oo`3no`00nol0087oo?l00>_o
o03no`00nol0087oo?l00:Ko003noo`0n_ol0?ko003eo`3jQ_l00>ko1P3oo`3o
o`3no`00nol0nX7oo?l00>_oo03no`00nol0nX7oo?l00:Ko003noo`0n_ol0?ko
003eo`2JQ_l00>ko1P3oo`3oo`3no`00nol0VX7oo?l00>_oo03no`00nol0VX7o
o?l00<_o0>_Mo`400?ko003no`00n_l00?[o003eo`00Q_l00?;o003no`H0ool0
ool0o_l00?_o0021ooco003[o`00n_l00?_o0021ooco002Wo`400?ko003no`00
n_l00?[o003eo`3jm?oi09_o003bo`00o_l60?oo0?oo0?ko003ko`3jPOolo`00
jol00?[o003ko`3jPOolo`00Yol1003no`00o_l00?[o003jo`00mOl0V_Con@2K
o`00l_l00?ko1P3oo`3oo`3no`00nol0VX7oo?l00>_o003jo`00nol0VX7oo?l0
0<_o0<_Lo`00n_l00?[oo@3mo`00POoio`00lOon0?go0@00oOl00?_o0021ooco
003[ood0oOl00?_o0021ooco002Vo`00n_l00?[oo@3mo`00mOob0?_oi@2fo`00
lOon0?go0@00oOl00?_o0?Z1ooco003[ood0oOl00?_o0?Z1ooco002Vo`00n_l0
0?[oo@3mo`00mOob0?_oi@2fo`00lOon0?go0@00oOl00?_o09Z1ooco003[ood0
oOl00?_o09Z1ooco003;o`2mg?l00?_o003eo`00o_l10021omco003ko`00POol
o`00iol00?ko0@00o?l0087ooOl1002Vo`00nol00?Go003no`400?Ko003Bo`00
m?oi0>3oj`3To`00nol0nX7oo?l00>Oo003no`400?co0?Z1oogo0@00Y_l00?_o
003eo`00o_l1003fo`00d_l00?Con@3Pon/0i?l00?_o09Z1ooco003Wo`00o_l1
003lo`2JPOomo`400<_o0;CLo`00nol00?Go003no`00POoKo`00nol0087oo?l0
0>Oo003no`00nol0087oo?l00:Ko003ko`00mOl00?ko003eo`00d_ob0?_ogP3]
o`00i?l00?_o0?Z1ooco003Wo`00o_l00?_o0?Z1ooco002Vo`00nol00?Go003n
o`00mOl00=;olP3komh0kOl00>Co003ko`2JPOolo`00iol00?ko003ko`2JPOol
o`00bol0/]co003lo`00n?l00?ko003no`00POoio`00g?oj08?o003[o`00o_l0
0?ko003ko`00POolo`00Y_l00?co003ho`00o_l00?ko003eo`00Q_l00>Con@3j
nX?o003[o`00o_l00?ko003ko`3jPOolo`00Y_l00?co003ho`00o_l00?ko003e
o`00Q_l00>Con@3jVX?o003[o`00o_l00?ko003ko`2JPOolo`00bol0]]gooP3m
o`00o?l00?gooP3mo`00POoio`00i?l00?Co0023o`00j_on0?go003ko`00POol
o`00Yoon0?go003lo`00oOon0?go003eo`00Q_l00>Co003ko`00nol0nX?o003Z
ooh0oOl00?_o0?Z1ooco002Wooh0oOl00?co003mooh0oOl00?Go0026o`00i?l0
0?_o003ko`2JPol00>[ooP3mo`00nol0VX7oo?l00<_o08C4o`00iooi09_o003T
o`00m?l008?o003So`00nol0087oo?l008ko003eo`00m?oinY_o003To`00nol0
0?_o0?Z3o`00hol00?_o0?Z1ooco002>o`00mOl00?ConIZKo`00i?l00?_o003k
o`2JPol00>?o003ko`2JPOolo`00bol0/<Co003doo<0nooU0;Ko003aooh0o_on
0?go003do`00m?oi09So003So`00nol0087oo?l008ko003eo`00lo[konGj]_l0
0?7ooP3nooh0oOl00?_o003ko`3jm?oinYSo003So`00nol0nX7oo?l008ko003e
o`00li[konFJ]_l00?7ooP3nooh0oOl00?_o003ko`2Jm?oiVYSo003So`00nol0
VX7oo?l00<_o0=[4o`00nook0=7o003koo80h?o[0?;o003no`80o`3no`00o_l0
0?Co003do`00nol009So003So`00nol0087oo?l008ko003koo_j003Bo`3jnoob
n^3ojo[bo`00o_l20?l0o_l00?ko003ko`00nol0n_Co0?[ko`3jV?l00>?o003k
o`3jPOolo`00S_l00?_oniX00=;o09[koo:Jh?o[V_;o003no`80o`3no`00o_l0
0?_o003ko`2Jm?l0V__o09ZHo`00hol00?_o09Z1ooco003;o`42d?l00?koo03n
o`00nol00<con@3domh0kOl00?;o003no`80o`3no`00o_l00?ColP3ko`00goob
0<Wo003Xo`00oOl00?_o0021ooco002Jo`00o_ol0?ko003ko`3jo?l00=;onO[d
omkjkOl0n_;o003no`80o`3no`00o_l00?_o003koo;jnol0n]ool_[9o`00j?l0
0?go003ko`3jPOolo`00V_l00?koo03no`00nol0V_co003BooVJm?oNV^go09[b
o`00o_l20?l0o_l00?ko003ko`00noobV__o09[Ooo:JbOl00>So003mo`00nol0
VX7oo?l00<_o0<gAo`400?ko003jo`00nol0087o0Ol0kol00?kooP3mooX00?n1
0?/0jOl1003mo`00nol0087oo?l009_o0@00o_l00?[o003ko`3jo?l008Ko003_
o`00o_on0?gogP00n^d0nO[k003jm000n/P0jOl1003mo`00nol0nX7oo?l009_o
0@00o_l00?[o003ko`2Jo?l008Ko003_o`00o_on0?Ko003Vo`2JkOoiV__o09[d
o`2J/?l1003mo`00nol0VX7oo?l00<_o0@o@o`00o_om0?go003ko`00POl1o`3`
o`00o_l00?ko003no`00gol00>go003ko`00nol00??o003Ooo80nol00>[o0P3o
0?go003ko`00POolo`00V_l00?koo@3mo`00nol0n_co0026o`00l?l00?ko003n
o`00o_l00?_o003Vo`3jkOl0n__o0?[ko`3jlol0n]ool_[ko`00j_l20?l0oOl0
0?_o0?Z1ooco002Jo`00o_om0?go003ko`2Jo?l008Ko003`o`00o_l00?ko003n
o`00nol00>Ko09[]o`2Jnol0V__o09[co`2JgoobV__o003Zo`80o`3mo`00nol0
VX7oo?l00<_o0Bc@o`00n_l00?ko0@00o?l0087o0@00lOl50?oo0?l0o_l00?ko
003Oo`00m?oi0?_o003ko`00looj0>Go003do`00nol00>_o0`3oo`3mo`400?co
0021oogo0@00V_l00?[o003no`400?co0?[lo`00Qol1003ao`D0ool0o`3no`00
o_l00?_o003Vo`3jm?oin__o0?[ko`3jloojn^Go0?[do`3jnol00>_o0`3oo`3m
o`400?co0?Z1oogo0@00V_l00?[o003no`400?co09[lo`00Qol1003ao`D0ool0
o`3no`00o_l00?_o003Vo`2Jm?oiV__o09[ko`2JloojV^Go09[do`2Jnol00>_o
0`3oo`3mo`400?co09Z1oogo0@00bol0m=3o003jo`00o_l00?_o0021o`7o0?;o
o001ooon0?go003OooT0nol00?Con@3/on/0nol00?Con@3[oo`0o_l00?_o0021
ooco002Jo`00n_l00?ko003ko`3jo?l008Ko003boo`00OoooP3mo`00nol00>Ko
nO[ko`3jm?oin^cojo[ko`3jm?oin^_oo03no`00nol0nX7oo?l009[o003jo`00
o_l00?_o09[lo`00Q_l00?;oo001ooon0?go003ko`00i_oiV__o09[dooVJk?o[
V__o09[dooVJjool0?ko003ko`2JPOolo`00bol0cM3o003no`00o_l00?ko003k
o`00POl1o`3To`00f?l00?_o0032ooT0kOl00>So003mo`00nol0087oo?l009[o
003no`00o_l00?ko003ko`3jo?l008Ko003To`00nol00=oo0?[ko`3j`_oin^go
0?[Xo`00oOl00?_o0?Z1ooco002Jo`00o_l00?ko003no`00nol0V_co0026o`00
i?l00?_o003Oo`2Jnol0V/;onI[]o`2Jj?l00?go003ko`2JPOolo`00bol0Y]7o
oP3nooh0oOl00?co0021o`;oo`3TooX0g_oi0:Ko003Yooh0o_l00?_o0021ooco
002Kooh0o_on0?go003lo`3jnol008Ko003Too[jn@3VooWjY_l00>WooP3no`00
nol0nX7oo?l009_ooP3nooh0oOl00?co09[ko`00Q_l00>ConY[i0>KonIZVo`00
jOon0?ko003ko`2JPOolo`00bol0S<Co003lo`00POl2ool0i?l00?_o0021ooco
0021omKo002>o`00o?l0n_X0Q_l00>Co003ko`3jnol00?Con@3Ooo80eooi0?_o
003SooT0POolo`00S_l00?co09[j08Ko003To`00nol0V__o003dooT0goob0=Oo
n@3ko`00hooi087oo?l00<_o0;S4o`00o?l00?_o0026o`00i?l00?_o0021ooco
003So`00POoeo`00S_l00?co0OX0o?l0nXKo003To`00nol0n__o003do`00nol0
0=oo003co`00gooi0?_o003ko`00hol00?_o0021ooco002>o`00o?l1VP3lo`2J
Q_l00>Co003ko`2Jnol00?Co003ko`00gol00??o003OooT0nol00?_o003So`00
nol0087oo?l00<_o0<o4o`00o?l00?_o0026o`00lOon0?go0@00oOl00?_o0021
omgo0021ooGo002>o`00o?l1nP3lo`3jQ_l00?7ooP3mo`400?go003ko`3jnol0
0?Co003ko`00kOoi0?_o003cooX0iOl00?Con@3So`00nol0087oo?l008ko003l
o`6J0?co09Z6o`00lOon0?go0@00oOl00?_o09[ko`00m?l00?_o003]ooT0nol0
0??onP3Uo`00m?oi0>?o003ko`00POolo`00bol0gLCo003lo`00nol008Ko003b
o`00o_l30?oo0?_o003ko`00POoMo`00POoeo`00S_l00?co0OX0o?l0nXKo003b
o`00o_l30?oo0?_o003ko`3jnol00?_on@3ko`00m?oi0?_o003ko`00k?l00?_o
j`3]o`00hol00?_o0021ooco002>o`00o?l1VP3lo`2JQ_l00?;o003no`<0ool0
nol00?_o09[ko`00nooi0?_o003dooT0nol00?_o003/o`00noo[0>go003So`00
nol0087oo?l00<_o0?;Lo`00oOon0?Woo03no`00o?l00?_o0026o`00l_l00?ko
0P3o0?[o003ko`00POoTooh0oOl0087omOl00:Ko003mooh0nOol0?ko003lo`7j
0?co0?Z6o`00l_l00?ko0P3o0?[o003ko`3jnooi0?Co003do`00m?oi0>con@3H
o`00j_on0?go003ko`00POolo`00Y_l00?gooP3ioo`0o_l00?co0IX0o?l0VXKo
003bo`00o_l20?l0n_l00?_o09[kooT0m?l00?Co003dooT0k?oi0=So003Zooh0
oOl00?_o0021ooco003;o`3_gOl1003no`00o_l00?[o003jooX0nol008Ko003_
o`80ooom0?go0@00o?l0087ooOl1003[o`00o_l00?ko0021ooGo002Wo`400?ko
003no`00n_l00?[on_X00?co0?Z6o`00kol20?ooo@3mo`400?co0?[Vo`00m?l0
0:Oo0@00jol00?ko003no`00nol0087oo?l00:Oo0@00o_l00?ko003jo`00n_oj
VP00o?l0VXKo003_o`80ooom0?go0@00o?l0V^Ko003do`00Yol1003[o`00o_l0
0?ko003ko`00POolo`00bol10=co003no`00o_l00?[oo@3mo`00mOl008Ko003`
o`00o_l00?ko003no`00nol00<?on@3Goo80nol00>Oo003no`00POoeo`00Y_l0
0?ko003no`00n_om0?go003ko`00o?l0nXKo003`o`00o_l00?ko003no`00nol0
n^Kon@3ko`00kOoin]Ool_[ko`00iol00?ko003ko`00POolo`00Y_l00?ko003n
o`00n_om0?go003ko`00o?l0VXKo003`o`00o_l00?ko003no`00nol0V^Kon@3k
o`00kOoiV]OolY[ko`00iol00?ko003ko`00POolo`00bol15]co003ko`00mOl0
0?ko0@00m_l008Oo0@00lOl50?oo0?l0o_l00?ko003ko`00`ol00?_on@3No`00
m?l00?_o003Yo`400?go0@00POogo`400:Ko003ko`00mOl00?ko0@00oOl00?_o
0?Z7o`400?7o1@3oo`3o0?ko003no`00nol0n]oon@3]o`3jnooin]ko0?[do`3j
nol00>Wo0@00oOl1003lo`00POomo`400:Ko003ko`00mOl00?ko0@00oOl00?_o
09Z7o`400?7o1@3oo`3o0?ko003no`00nol0V]oon@3]o`2JnooiV]ko09[do`2J
nol00>Wo0@00oOl1003lo`00POomo`400<_o0>?Lo`00o?l00?Co003no`00nooj
08Ko003boo`00OoooP3mo`00nol00<?o003co`00gol00?Con@3Wo`00o_l0087o
mOl00:Ko003lo`00m?l00?ko003lo`00n_Z6o`00l_ol007oooh0oOl00?_o0?[3
o`3jlol0n]oo0?[dooWjiol00?ko003ko`00POolo`00Y_l00?co003do`00o_l0
0?co003jVXKo003boo`00OoooP3mo`00nol0V/?o09[co`2Jgol0V_ConI[Wo`00
o_l00?_o0021ooco003;o`3Zg?l00?go0`3oo`3jo`00o_l00?ko003ko`00POl1
o`3To`00nol00<?o003cooX0n_o[0>go003[o`00o_l00?ko0021ooGo002Vo`00
oOl30?oo0?[o003no`00o_l00?co0@3jPOl1o`3To`00nol0n/?o0?[coo[jn_o[
n^go0?[[o`00o_l00?ko003ko`00POolo`00Y_l00?go0`3oo`3jo`00o_l00?ko
003lo`40VX7o0Ol0i?l00?_o09[3o`2JloojV_[oji[]o`2Jjol00?ko003no`00
nol0087oo?l00<_o0>CMooh00Oooo03no`00oOon0?go003ko`00POl1o`3To`00
nooi0?Con@3]ooT0nol00>con@3Ho`00j_on0?go0021ooGo002Wooh00Oooo03n
o`00oOon0?go003lo`40nX7o0Ol0i?l00?_onO[dooWjkOoin__o0?[/ooWjf?l0
0>[ooP3mo`00nol0087oo?l00:OooP01oool0?ko003mooh0oOl00?co0@2JPOl1
o`3To`00nooiV_ConI[]ooVJnol0V^conI[Ho`00j_on0?go003ko`00POolo`00
bol0ULCo003ko`00POl1o`3To`00m?l00?Co003ko`00m?oi0?_on@2ko`00hooj
003oP@3k08ko003lo`40nX7o0Ol0i?l00?Co0?[do`3jnol0n_ConO[kooWj^ol0
0>?oP@3c08ko003lo`40VX7o0Ol0i?l00?Co09[do`2Jnol0V_ConI[kooVJ^ol0
0=co0021olGo09W4o`00nol0087o0Ol0i?l00?Co003do`00nol00?Co002Vo`00
hol0087omOl008ko003lo`40nX7o0Ol0i?l00?Co0?[do`3jnol0n_Co0?ZVo`00
hol00?_o0021ooco002>o`00o?l109Z1o`7o0>Co003do`2Jm?l0V__o09[do`2J
Y_l00>?o003ko`00POolo`00bol0Skgo0021o`7o0>Co003do`00nooi0?_o003d
o`00Y_l00>?o0021ooGo002>ooX00?Z1o`7o0>Co003do`3jnooin__o0?[do`3j
Y_l00>?o003ko`00POolo`00S_oj002JPOl1o`3To`00m?l0V__onI[ko`2Jm?l0
VZKo003So`00nol0087oo?l00<_o0:o4o`00nol0087o0Ol0lOon0?co003mo`00
m?l00?_o003do`00m?l00:Ko003So`00POoeo`00S_l00?_o0?Z1o`7o0?7ooP3l
o`00oOl00?Co0?[ko`3jm?l0n_Co0?ZVo`00hol00?_o0021ooco002>o`00nol0
VX7o0Ol0lOon0?co003mo`00m?l0V__o09[do`2Jm?l0VZKo003So`00nol0087o
o?l00<_o0>S@o`00o?l1003mo`00o?l0087o0_oo0?;o003no`00o_l1003mo`00
m?l00?_o003dooT0nol00:Ko003Zooh0oOl0087omOl009[o003lo`400?go003l
o`3jPOl2ool0l_l00?ko003no`400?go003do`3jnol0n_ConO[ko`3jY_l00>[o
oP3mo`00nol0087oo?l009[o003lo`400?go003lo`2JPOl2ool0l_l00?ko003n
o`400?go003do`2Jnol0V_ConI[ko`2JY_l00>[ooP3mo`00nol0087oo?l00<_o
0>GAo`400?go0`3oo`3no`00o?l0087o0_oo0?;o003no`D0ool0o`3mo`00m?oi
0>gon@2Vo`00jol00?ko003no`00POoeo`00Vol1003mo`<0ool0o_l00?co0?Z1
o`;oo`3bo`00o_l50?oo0?l0oOl00?ConO[]ooWjY_l00>_o003no`00o_l00?_o
0021ooco002Ko`400?go0`3oo`3no`00o?l0VX7o0_oo0?;o003no`D0ool0o`3m
o`00m?oiV^gonIZVo`00jol00?ko003no`00nol0087oo?l00<_o0<g@o`00oOl3
0?oo0?ko003lo`00POl2ool0kol60?oo0?oo0?go0@00POogo`400>_o003no`00
o_l0087omOl009[o003mo`<0ool0o_l00?co0?Z1o`;oo`3_o`H0ool0ool0oOl1
0021ooOo0@00jol00?ko003no`00nol0087oo?l009[o003mo`<0ool0o_l00?co
09Z1o`;oo`3_o`H0ool0ool0oOl10021ooOo0@00jol00?ko003no`00nol0087o
o?l00<_o0:O@o`00oOl30?oo0?koP@3g0?3o003noo`0o_l0087omOl00>So003m
o`40087omol1002Jo`00oOl30?oo0?kon`00nX40oP3`o`00o_ol0?ko0021ooGo
003Xo`00oOl1003lo`00POomo`4009[o003mo`<0ool0n?l0VX7okOl00?koo03n
o`00POoeo`00j?l00?go0@00o?l0087ooOl1003;o`2nd?l00?go0`3oo`3no`00
o?l0087o0_oo0?7o0`3oo`3mo`00oOl0087omOl00>Wo003lo`00POoeo`00V_l0
0?go0`3oo`3no`00o?l0nX7o0_oo0?7o0`3oo`3mo`00oOl0087omOl00>Wo003l
o`00nol0087oo?l009[o003mo`<0ool0o_l00?co09Z1o`;oo`3ao`<0ool0oOl0
0?go0021ooGo003Yo`00o?l00?_o0021ooco003;o`2nd?l00?go0`3oo`3no`00
o?l0087o0_oo0?;oo03nooh0o_l0087omOl00>[o0`3oo`3no`00POoeo`00V_l0
0?go0`3oo`3no`00o?l0nX7o0_oo0?;oo03nooh0o_l0087omOl00>[o0`3oo`3n
o`00nol0087oo?l009[o003mo`<0ool0o_l00?co09Z1o`;oo`3boo`0o_on0?ko
0021ooGo003Zo`<0ool0o_l00?_o0021ooco003;o`2GdOon0?go0@00oOl00?co
0021o`;oo`3To`00POoeo`00jool0?ko0021ooGo002Kooh0oOl1003mo`00o?l0
nX7o0_oo0>Co0021ooGo003[oo`0o_l00?_o0021ooco002Kooh0oOl1003mo`00
o?l0VX7o0_oo0>Co0021ooGo003[oo`0o_l00?_o0021ooco003;o`1Pa?oj087o
0_oo0>Co0021ooGo003SooX0POoko`00S_ojnX7o0_oo0>Co0021ooGo003Soo[j
0021ooco002>ooZJPOl2ool0i?l0087omOl00>?onYX0087oo?l00<_o06C4o`00
POoio`00i?l0087omOl00>?o0021ooGo002>o`00POoio`00i?l0087omOl00>?o
003ko`00POolo`00S_l0087onOl00>Co0021ooGo003So`00nol0087oo?l00<_o
06C4o`00POoio`00i?l0087omOl00>?o0021ooGo002>o`00POoio`00i?l0087o
mOl00>?o003ko`00POolo`00S_l0087onOl00>Co0021ooGo003So`00nol0087o
o?l00<_o07KHoo`0n_ol0?ko0021ooWo003To`00POoeo`00hol0097oi02Roo`0
n_ol0?ko0021ooWo003To`00POoeo`00hol00?_o002HonCjX_ol0?[oo03no`00
POoio`00i?l0087omOl00>?o003ko`00V?oTV/_o0:kHo`00o_l00?[o003jo`00
POoio`00lOon0?kooP3mo`00POoeo`00jOl00?co002eom`0Q_l00?ko003jo`00
n_l0087onOl00?7ooP3nooh0oOl0087omOl00>Wo003lo`00nol00;cog?[kon/0
X_l00?ko003jo`00n_l0087onOl00?7ooP3nooh0oOl0087omOl00>Wo003lo`00
nol00;cog9[kon/0bol0_mCo003jood0oOl0087onOl00?;o003no`80o`3no`00
o_l0087omOl00>[o0@00o?l00<[ok03?oo80W_l00?[oo@3mo`00POoio`00l_l0
0?ko0P3o0?ko003no`00POoeo`00j_l1003lo`00nol00=7ok?[E0?_ol_ZNo`00
n_om0?go0021ooWo003bo`00o_l20?l0o_l00?ko0021ooGo003Zo`400?co003k
o`00dOo/V]D0noobV/_o0<kEo`00mOl00?ko0@00POoko`400?;o003no`80o`3n
o`00o_l0087omOl00>Wo003lo`00dOoj0>CoeP3do`00Wol00?Go003no`40087o
nol1003bo`00o_l20?l0o_l00?ko0021ooGo003Yo`00o?l00?_o003Hoo[jj`3j
omKjm?l009oo003eo`00o_l10021oo_o0@00l_l00?ko0P3o0?ko003no`00POoe
o`00jOl00?co003ko`00f?ojV^/0n_oFV_Co003;o`36eOl00?Go003no`00POoi
o`00kol00?co003mo`40087omol1003Yo`00o?l1003Won/0kOob0<[o0@00Wol0
0?Go003no`00POoio`00kol00?co003mo`40087omol1003Yo`00o?l1003lo`00
kOo[n__o003doo;jb_l1002Oo`00mOl00?ko0021ooWo003_o`00o?l00?go0@00
POogo`400>Wo003lo`400?co003]on^Jnol00?ColY[:o`400<_o0<;Fo`00n?l0
0?ko003no`00POoio`00l?l00?co003lo`00POoeo`00jOl00?co003Vo`00iOoc
0;_o002Po`00n?l00?ko003no`00POoio`00l?l00?co003lo`00POoeo`00jOl0
0?co003ko`00kOl0n__oj`3cn[_o002Po`00n?l00?ko003no`00POoio`00l?l0
0?co003lo`00POoeo`00jOl00?co003ko`00kOl0V__oj`3cV[_o003;o`3Ae_l0
0?co003mooh0oOl0087onOl00?7o2@3oo`3oo`3oo`3no`00POoeo`00jOl00?co
003]ooX0k?oi0:go002Po`00o?l00?gooP3mo`00POoio`00lOl90?oo0?oo0?oo
0?ko0021ooGo003Yo`00o?l00?_o003doo[jn@3dooWj[Ol00:3o003lo`00oOon
0?go0021ooWo003ao`T0ool0ool0ool0o_l0087omOl00>Wo003lo`00nol00?Co
nY[i0?ConIZ]o`00bol0W/Co0021ooWo003boo`00?ol0?ko0021ooGo003Zooh0
oOl00?Con@3jon`0Y_l008ko0021ooWo003boo`00?ol0?ko0021ooGo003Zooh0
oOl00?_o003kooWjnol00>cjY_l008ko0021ooWo003boo`00?ol0?ko0021ooGo
003Zooh0oOl00?_o003kooVJnol00>bJY_l00<_o06S4o`00POoio`00i?l0087o
mOl00>?o0021ooGo002>o`00POoio`00i?l0087omOl00>?o003ko`00noob097o
002>o`00POoio`00i?l0087omOl00>?o003ko`00noob097o003;o`1ba?l0087o
nOl00>Co0021ooGo003So`00kOoi097o002>o`00POoio`00i?l0087omOl00>?o
003ko`00nol00?_onOZAo`00S_l0087onOl00>Co0021ooGo003So`00nol00?_o
003kooVJTOl00<_o06k4o`00POoio`00i?l0087omOl00>?o003cooX0R_l008ko
0021ooWo003To`00POoeo`00hol00?_o003ko`00n_Z:o`00S_l0087onOl00>Co
0021ooGo003So`00nol00?_o003jVX[o003;o`1Xa?l0087onOl00>Co0021ooGo
003So`00POoeo`00S_l0087onOl00>Co0021ooGo003So`00nol00?_o0023o`00
S_l0087onOl00>Co0021ooGo003So`00nol00?_o0023o`00bol0J<Co0021ooWo
003To`00POoeo`00hol0087omOl008ko0021ooWo003To`00POoeo`00hol00?_o
003ko`00Pol008ko0021ooWo003To`00POoeo`00hol00?_o003ko`00Pol00<_o
0DK4o`00nol00?co003ko`00nol00?_o003ko`00nol00?_o003lo`00nol00?_o
003ko`00nol00?_o003ko`00nol00?co003ko`00nol00?_o003To`00POoeo`00
hol0087omOl008ko003ko`00o?l00?_o003ko`00nol00?_o003ko`00nol00?co
003ko`00nol00?_o003ko`00nol00?_o003ko`00o?l00?_o003ko`00nol00>Co
0021ooGo003So`00nol00?_o0023o`00S_l00?_o003lo`00nol00?_o003ko`00
nol00?_o003ko`00o?l00?_o003ko`00nol00?_o003ko`00nol00?_o003lo`00
nol00?_o003ko`00i?l0087omOl00>?o003ko`00nol008?o003;o`2da?n10?L0
i?l00>Ko003Vo`00iOl00>Ko003Vo`00hol00>Ko003Vo`00iOl00>Ko003Vo`00
S_n10?L0i?l00>Ko003Vo`00iOl00>Ko003Vo`00hol00?_o003ko`00m?l00>Ko
003Uo`00i_l00>Ko002>oh40m`3To`00i_l00>Ko003Uo`00i_l00>Ko003So`00
nol00?_o003do`00i_l00>Go003Vo`00i_l00<_o03J1oigoP@3c0>?onP00oo/0
0?n2087oPOoWoh40l`3Soh40l`21oh7oion10?<0hon10?<0bol0787oPOn1oh7o
POn1oh7oPOn1oh7oPOn1oh7oQOl0787oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7o
QOl0n;7ooP3mo`400?go0@00l_l00?go0@00oOl1003do`400?go0@00oOl1003d
ooh0oOl1003mo`400?Oo003lo`400?go0@00oOl10021oh7oPOn]ooh0oOl1003m
o`400?;o003mo`400?go0@00m?l1003mo`400?go0@00m?on0?go0@00oOl1003g
o`00o?l1003mo`400?go0@00POn1oh7o[Oon0?go0@00oOl1003bo`00oOl1003m
o`400?Co0@00oOl1003mo`400?CooP3mo`400?go0@00mol00?co0@00oOl1003m
o`40087oPOn1oogo0_>bo`00o_l<0?oo0?oo0?oo0?oo0?Co0@00o_l90?oo0?oo
0?oo0?Ko003lo`T0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3io`400?go
3`3oo`3oo`3oo`3oo`3oo`3Jooh0oOl1003mo`400?;o003mo`400?go0@00l_l1
003mo`400?go0@00m?on0?go0@00oOl1003fo`00o?l1003mo`400?go0@00f?on
0?go0@00oOl1003bo`00oOl1003mo`400?;o0@00oOl1003mo`400?CooP3mo`40
0?go0@00m_l00?co0@00oOl1003mo`4008Go003no``0ool0ool0ool0ool0m?l1
003no`T0ool0ool0ool0m_l00?co2@3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo
0?oo0?Wo0@00oOl?0?oo0?oo0?oo0?oo0?oo0=[ooP3mo`400?go0@00l_l00?go
0@00oOl1003bo`400?go0@00oOl1003dooh0oOl1003mo`400?Ko003lo`400?go
0@00oOl1003Hooh0oOl1003mo`400?;o003mo`400?go0@00l_l1003mo`400?go
0@00m?on0?go0@00oOl1003fo`00o?l1003mo`400?go0@00QOl00?ko303oo`3o
o`3oo`3oo`3do`400?ko2@3oo`3oo`3oo`3fo`00o?l90?oo0?oo0?oo0?Ko003n
o``0ool0ool0ool0ool0nOl1003mo`l0ool0ool0ool0ool0ool0f_on0?go0@00
oOl1003bo`00oOl1003mo`400?;o0@00oOl1003mo`400?CooP3mo`400?go0@00
m_l00?co0@00oOl1003mo`400=SooP3mo`400?go0@00l_l00?go0@00oOl1003b
o`400?go0@00oOl1003dooh0oOl1003mo`400?Ko003lo`400?go0@00oOl1003D
o`=m/_l00?ko303oo`3oo`3oo`3oo`3eo`80o`3no`T0ool0ool0ool0mol00?_o
2@3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?So003mo`l0ool0ool0ool0
ool0ool0fol00?ko303oo`3oo`3oo`3oo`3do`400?ko2@3oo`3oo`3oo`3do`00
o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l1003mo`l0ool0ool0
ool0ool0ool0f_l00?ko303oo`3oo`3oo`3oo`3do`400?ko2@3oo`3oo`3oo`3d
o`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l1003mo`l0ool0
ool0ool0ool0ool0Q_l00?ko303oo`3oo`3oo`3oo`3eo`80o`3no`T0ool0ool0
ool0mol00?_o2@3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?So003mo`l0
ool0ool0ool0ool0ool0fol00?ko303oo`3oo`3oo`3oo`3do`400?ko2@3oo`3o
o`3oo`3do`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l1003m
o`l0ool0ool0ool0ool0ool0f_l00?ko303oo`3oo`3oo`3oo`3do`400?ko2@3o
o`3oo`3oo`3do`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l1
003mo`l0ool0ool0ool0ool0ool0Q_l00?ko303oo`3oo`3oo`3oo`3eo`80o`3n
o`T0ool0ool0ool0mol00?_o2@3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo
0?So003mo`l0ool0ool0ool0ool0ool0fol00?ko303oo`3oo`3oo`3oo`3do`40
0?ko2@3oo`3oo`3oo`3do`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0ool0
ool0n?l1003mo`l0ool0ool0ool0ool0ool0f_l00?ko303oo`3oo`3oo`3oo`3d
o`400?ko2@3oo`3oo`3oo`3do`00o?l90?oo0?oo0?oo0?Ko003no``0ool0ool0
ool0ool0n?l1003mo`l0ool0ool0ool0ool0ool0eOl3KZoo003no`T0ool0ool0
ool0m_l30?oo0?ko2@3oo`3oo`3oo`3good0o_l90?oo0?oo0?oo0?GooP3no`T0
ool0ool0ool0n?l00?go3`3oo`3oo`3oo`3oo`3oo`3Ko`00o_l<0?oo0?oo0?oo
0?oo0?Go0P3o0?ko2@3oo`3oo`3oo`3eo`00nol90?oo0?oo0?oo0?Ko003no``0
ool0ool0ool0ool0mol00?go3`3oo`3oo`3oo`3oo`3oo`3Jo`00o_l<0?oo0?oo
0?oo0?oo0?Go0P3o0?ko2@3oo`3oo`3oo`3eo`00nol90?oo0?oo0?oo0?Ko003n
o``0ool0ool0ool0ool0mol00?go3`3oo`3oo`3oo`3oo`3oo`23o`00o_l90?oo
0?oo0?oo0?Ko0`3oo`3no`T0ool0ool0ool0moom0?ko2@3oo`3oo`3oo`3eooh0
o_l90?oo0?oo0?oo0?So003mo`l0ool0ool0ool0ool0ool0fol00?ko303oo`3o
o`3oo`3oo`3eo`80o`3no`T0ool0ool0ool0mOl00?_o2@3oo`3oo`3oo`3fo`00
o_l<0?oo0?oo0?oo0?oo0?Oo003mo`l0ool0ool0ool0ool0ool0f_l00?ko303o
o`3oo`3oo`3oo`3eo`80o`3no`T0ool0ool0ool0mOl00?_o2@3oo`3oo`3oo`3f
o`00o_l<0?oo0?oo0?oo0?oo0?Oo003mo`l0ool0ool0ool0ool0ool0Pol00?ko
2@3oo`3oo`3oo`3fo`<0ool0o_l90?oo0?oo0?oo0?Ooo@3no`T0ool0ool0ool0
mOon0?ko2@3oo`3oo`3oo`3ho`00oOl?0?oo0?oo0?oo0?oo0?oo0=_o003no``0
ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo0?Go003ko`T0ool0ool0ool0
m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=[o003n
o``0ool0ool0ool0ool0mOl20?l0o_l90?oo0?oo0?oo0?Go003ko`T0ool0ool0
ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Go
0eV`o`00oOl90?oo0?oo0?oo0?Koo00;ool0ool0ool0ool0mol00?ko303oo`3o
o`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?So003mo`l0ool0ool0ool0ool0
ool0f?l00?ko2@3oo`3oo`3oo`3fo`<0ool0o_l90?oo0?oo0?oo0?Goo@3no`T0
ool0ool0ool0mOon0?ko2@3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo
0=Oo003no`T0ool0ool0ool0m_l30?oo0?ko2@3oo`3oo`3oo`3eood0o_l90?oo
0?oo0?oo0?GooP3no`T0ool0ool0ool0mol00?go3`3oo`3oo`3oo`3oo`3oo`24
o`00oOl90?oo0?oo0?oo0?Koo00;ool0ool0ool0ool0mol00?ko303oo`3oo`3o
o`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?So003mo`l0ool0ool0ool0ool0ool0
f?l00?ko2@3oo`3oo`3oo`3fo`<0ool0o_l90?oo0?oo0?oo0?Goo@3no`T0ool0
ool0ool0mOon0?ko2@3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Oo
003no`T0ool0ool0ool0m_l30?oo0?ko2@3oo`3oo`3oo`3eood0o_l90?oo0?oo
0?oo0?GooP3no`T0ool0ool0ool0mol00?go3`3oo`3oo`3oo`3oo`3oo`24o`00
oOl90?oo0?oo0?oo0?Koo00;ool0ool0ool0ool0mol00?ko303oo`3oo`3oo`3o
o`3fo`00o_l<0?oo0?oo0?oo0?oo0?So003mo`l0ool0ool0ool0ool0ool0f?l0
0?ko2@3oo`3oo`3oo`3fo`<0ool0o_l90?oo0?oo0?oo0?Goo@3no`T0ool0ool0
ool0mOon0?ko2@3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Oo003n
o`T0ool0ool0ool0m_l30?oo0?ko2@3oo`3oo`3oo`3eood0o_l90?oo0?oo0?oo
0?GooP3no`T0ool0ool0ool0mol00?go3`3oo`3oo`3oo`3oo`3oo`3Eo`=a/Ol?
0?oo0?oo0?oo0?oo0?oo0??o003no`T0ool0ool0ool0mol00?ko303oo`3oo`3o
o`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?So003mo`l0ool0ool0ool0ool0ool0
fOl00?go2@3oo`3oo`3oo`3foo`02ooo0?oo0?oo0?oo0?Go003no``0ool0ool0
ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo
0=So003mo`T0ool0ool0ool0m_ol00_oo`3oo`3oo`3oo`3eo`00o_l<0?oo0?oo
0?oo0?oo0?Ko003no``0ool0ool0ool0ool0mol00?go3`3oo`3oo`3oo`3oo`3o
o`25o`l0ool0ool0ool0ool0ool0lol00?ko2@3oo`3oo`3oo`3go`00o_l<0?oo
0?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0n?l00?go3`3oo`3oo`3oo`3o
o`3oo`3Io`00oOl90?oo0?oo0?oo0?Koo00;ool0ool0ool0ool0mOl00?ko303o
o`3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?Oo003mo`l0ool0ool0ool0
ool0ool0f?l00?go2@3oo`3oo`3oo`3foo`02ooo0?oo0?oo0?oo0?Go003no``0
ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo
0?oo0?oo08Go3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Oo003n
o``0ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3ho`00oOl?0?oo0?oo
0?oo0?oo0?oo0=Wo003mo`T0ool0ool0ool0m_ol00_oo`3oo`3oo`3oo`3eo`00
o_l<0?oo0?oo0?oo0?oo0?Ko003no``0ool0ool0ool0ool0mol00?go3`3oo`3o
o`3oo`3oo`3oo`3Ho`00oOl90?oo0?oo0?oo0?Koo00;ool0ool0ool0ool0mOl0
0?ko303oo`3oo`3oo`3oo`3fo`00o_l<0?oo0?oo0?oo0?oo0?Oo003mo`l0ool0
ool0ool0ool0ool0eOl3=K;oo03no`400?go0@00loon0?ko0@00oOl1003eooh0
oOl1003mo`400?CooP3mo`400?go0@00n?on0?go0@00oOl1003mo`400=Wo3`3o
o`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Go003no``0ool0ool0ool0
ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Wo
3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo0?Go003no``0ool0ool0
ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo
08Koo03no`400?go0@00loon0?ko0@00oOl1003eooh0oOl1003mo`400?CooP3m
o`400?go0@00n?on0?go0@00oOl1003mo`400=Wo3`3oo`3oo`3oo`3oo`3oo`3c
o`00o_l90?oo0?oo0?oo0?Go003no``0ool0ool0ool0ool0m_l00?ko303oo`3o
o`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo0=Wo3`3oo`3oo`3oo`3oo`3o
o`3co`00o_l90?oo0?oo0?oo0?Go003no``0ool0ool0ool0ool0m_l00?ko303o
o`3oo`3oo`3oo`3go`00oOl?0?oo0?oo0?oo0?oo0?oo08Koo03no`400?go0@00
loon0?ko0@00oOl1003eooh0oOl1003mo`400?CooP3mo`400?go0@00n?on0?go
0@00oOl1003mo`400=Wo3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo0?oo
0?Go003no``0ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00oOl?
0?oo0?oo0?oo0?oo0?oo0=Wo3`3oo`3oo`3oo`3oo`3oo`3co`00o_l90?oo0?oo
0?oo0?Go003no``0ool0ool0ool0ool0m_l00?ko303oo`3oo`3oo`3oo`3go`00
oOl?0?oo0?oo0?oo0?oo0?oo0=Go0Lj1oh[oo03no`400?go0@00loon0?ko0@00
oOl1003cooh0oOl1003mo`400?CooP3mo`400?go0@00moon0?go0@00oOl1003m
o`400=Woo03no`400?go0@00loon0?ko0@00oOl1003cooh0oOl1003mo`400?Co
oP3mo`400?go0@00moon0?go0@00oOl1003mo`40087oPOoMoo`0o_l1003mo`40
0??ooP3no`400?go0@00loon0?go0@00oOl1003dooh0oOl1003mo`400?OooP3m
o`400?go0@00oOl1003Ioo`0o_l1003mo`400??ooP3no`400?go0@00loon0?go
0@00oOl1003dooh0oOl1003mo`400?OooP3mo`400?go0@00oOl10021oh7ogOol
0?ko0@00oOl1003cooh0o_l1003mo`400??ooP3mo`400?go0@00m?on0?go0@00
oOl1003gooh0oOl1003mo`400?go0@00fOol0?ko0@00oOl1003cooh0o_l1003m
o`400??ooP3mo`400?go0@00m?on0?go0@00oOl1003gooh0oOl1003mo`400?go
0@00e?l0787oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oQOl0787oPOn1oh7oPOn1
oh7oPOn1oh7oPOn1oh7oQOl0787oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oQOl0
787oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oQOl0787oPOn1oh7oPOn1oh7oPOn1
oh7oPOn1oh7oQOl0787oPOn1oh7oPOn1oh7oPOn1oh7oPOn1oh7oQOl00?l\>"], "Graphics",
  ImageSize->{596, 244},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
GraphicsArray[\"<<>>\"]\
\>", "\<\
-GraphicsArray-\
\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF / m=3/ =HNF(2,2)", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
sel=1001//Range;
{YF,PF,clik} = 
\tGHF[{ZM[[sel]], X[[sel]]}, Theta+1, 
\t     {driftLorenzX, OmegaLorenzX, hLorenzX, RLorenzX, \
mueLorenzX,sigmaLorenzX,dt,3},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({MessUpGHF, TimeUpGHF1}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("GHF: "\[InvisibleSpace]"m = "\[InvisibleSpace]3\),
      SequenceForm[ "GHF: ", "m = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    \({22.557253000000003`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({91.04657774576717`, 150.24159737408485`, 160.37692818749898`, 
      28.3224924798813`, 15.64426637747016`, 9.478478726971028`}\)], "Output"],

Cell[BoxData[
    \({{\(-0.1808070679209845`\), \(-0.34722388299705487`\), \
\(-1.045851246724496`\), \(-0.8181449487340433`\), \(-0.37906603818880863`\), \
\(-0.13334089465509716`\)}, {2.872021400561762`, 4.735971195963837`, 
        4.959965645097976`, 0.3633195025261481`, 0.3175019852050798`, 
        0.2682760015041415`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["HNF(2,2)", "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{91.04657774580875, 150.24159737196933, \
160.37692819005176, 28.322492481535033, 15.644266384120003, 9.47847872706034}\
\
\>", "\<\
{91.0466, 150.242, 160.377, 28.3225, 15.6443, 9.47848}\
\>"], \
"Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
 {{-0.18080706793864604, -0.34722388300726165, \
-1.0458512467142655, -0.8181449489024669, -0.3790660381798046, 

    -0.13334089472875946}, {2.8720214005619673, 4.735971195896045, \
4.959965645182594, 0.3633195022756689, 

    0.31750198554315984, 0.2682760014706816}}\
\>", "\<\
 {{-0.180807, \
-0.347224, -1.04585, -0.818145, -0.379066, -0.133341}, 
  {2.87202, 4.73597, 4.95997, 0.36332, 0.317502, 0.268276}}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF(0)", "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{85.92451370491837, 138.93455426838256, \
162.27861139144125, 25.12424276224525, 15.785931841132768, 9.072918664102978}\
\
\>", "\<\
{85.9245, 138.935, 162.279, 25.1242, 15.7859, 9.07292}\
\>"], \
"Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-0.15813929525816642, -0.28708554276393833, \
-1.089889102232879, -0.700082800103109, -0.3984106402572074, \
-0.09945006185755041}, {2.711206073376374, 4.3819069745998895, \
5.012003733068537, 0.3748080180554098, 0.30035921681436034, \
0.2689708212139183}}\
\>", "\<\
{{-0.158139, -0.287086, -1.08989, -0.700083, \
-0.398411, -0.0994501}, {2.71121, 4.38191, 5.012, 0.374808, 0.300359, \
0.268971}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{5,15},{25,35},{0,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.01{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-30\), 20}, {\(-30\), 30}, {0, 60}, {5, 15}, {25, 35}, {0, 
        8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gGHF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],
\t\t\tPlotLabel->\"GHF, m=3\"]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(gGHF\)\" is similar to \
existing symbol \"\!\(GHF\)\"."\)], "Message"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -26.0625 0 ]
[.5 .42452 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 -0.309017 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -6 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -6 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(6)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(8)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(10)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(12)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(14)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30902 m
.001 .30902 L
.002 .30902 L
.003 .30902 L
.004 .30902 L
.005 .30902 L
.00599 .30902 L
.00699 .30902 L
.00799 .30902 L
.00899 .30902 L
.00999 .30902 L
.01099 .30902 L
.01199 .30902 L
.01299 .30902 L
.01399 .30902 L
.01499 .30902 L
.01598 .30902 L
.01698 .30902 L
.01798 .30902 L
.01898 .30902 L
.01998 .30902 L
.02098 .30902 L
.02198 .30902 L
.02298 .30902 L
.02398 .30902 L
.02498 .30902 L
.02597 .30902 L
.02697 .30902 L
.02797 .30902 L
.02897 .30902 L
.02997 .30902 L
.03097 .30902 L
.03197 .30902 L
.03297 .30902 L
.03397 .30902 L
.03497 .30902 L
.03596 .30902 L
.03696 .30902 L
.03796 .30902 L
.03896 .30902 L
.03996 .30902 L
.04096 .30902 L
.04196 .30902 L
.04296 .30902 L
.04396 .30902 L
.04496 .30902 L
.04595 .30902 L
.04695 .30902 L
.04795 .30902 L
.04895 .30902 L
Mistroke
.04995 .30902 L
.05095 .30902 L
.05195 .30902 L
.05295 .30902 L
.05395 .30902 L
.05495 .30902 L
.05594 .30902 L
.05694 .30902 L
.05794 .30902 L
.05894 .30902 L
.05994 .30902 L
.06094 .30902 L
.06194 .30902 L
.06294 .30902 L
.06394 .30902 L
.06494 .30902 L
.06593 .30902 L
.06693 .30902 L
.06793 .30902 L
.06893 .30902 L
.06993 .30902 L
.07093 .30902 L
.07193 .30902 L
.07293 .30902 L
.07393 .30902 L
.07493 .30902 L
.07592 .30902 L
.07692 .30902 L
.07792 .30902 L
.07892 .30902 L
.07992 .30902 L
.08092 .30902 L
.08192 .30902 L
.08292 .30902 L
.08392 .30902 L
.08492 .30902 L
.08591 .30902 L
.08691 .30902 L
.08791 .30902 L
.08891 .30902 L
.08991 .30902 L
.09091 .30902 L
.09191 .30902 L
.09291 .30902 L
.09391 .30902 L
.09491 .30902 L
.0959 .30902 L
.0969 .30902 L
.0979 .30902 L
.0989 .30902 L
Mistroke
.0999 .30902 L
.1009 .30902 L
.1019 .30902 L
.1029 .30902 L
.1039 .30902 L
.1049 .30902 L
.10589 .30902 L
.10689 .30902 L
.10789 .30902 L
.10889 .30902 L
.10989 .30902 L
.11089 .30902 L
.11189 .30902 L
.11289 .30902 L
.11389 .30902 L
.11489 .30902 L
.11588 .30902 L
.11688 .30902 L
.11788 .30902 L
.11888 .30902 L
.11988 .30902 L
.12088 .30902 L
.12188 .30902 L
.12288 .30902 L
.12388 .30902 L
.12488 .30902 L
.12587 .30902 L
.12687 .30902 L
.12787 .30902 L
.12887 .30902 L
.12987 .30902 L
.13087 .30902 L
.13187 .30902 L
.13287 .30902 L
.13387 .30902 L
.13487 .30902 L
.13586 .30902 L
.13686 .30902 L
.13786 .30902 L
.13886 .30902 L
.13986 .30902 L
.14086 .30901 L
.14186 .30901 L
.14286 .30901 L
.14386 .30901 L
.14486 .30901 L
.14585 .30901 L
.14685 .30901 L
.14785 .30901 L
.14885 .30901 L
Mistroke
.14985 .30901 L
.15085 .30901 L
.15185 .30901 L
.15285 .30901 L
.15385 .30902 L
.15485 .30902 L
.15584 .30902 L
.15684 .30902 L
.15784 .30902 L
.15884 .30902 L
.15984 .30902 L
.16084 .30902 L
.16184 .30902 L
.16284 .30902 L
.16384 .30902 L
.16484 .30902 L
.16583 .30902 L
.16683 .30902 L
.16783 .30902 L
.16883 .30902 L
.16983 .30902 L
.17083 .30902 L
.17183 .30902 L
.17283 .30902 L
.17383 .30902 L
.17483 .30902 L
.17582 .30902 L
.17682 .30902 L
.17782 .30902 L
.17882 .30902 L
.17982 .30902 L
.18082 .30902 L
.18182 .30902 L
.18282 .30902 L
.18382 .30902 L
.18482 .30902 L
.18581 .30902 L
.18681 .30902 L
.18781 .30902 L
.18881 .30902 L
.18981 .30902 L
.19081 .30902 L
.19181 .30902 L
.19281 .30902 L
.19381 .30902 L
.19481 .30902 L
.1958 .30902 L
.1968 .30902 L
.1978 .30902 L
.1988 .30902 L
Mistroke
.1998 .30902 L
.2008 .30902 L
.2018 .30902 L
.2028 .30902 L
.2038 .30902 L
.2048 .30901 L
.20579 .30902 L
.20679 .30902 L
.20779 .30901 L
.20879 .30902 L
.20979 .30902 L
.21079 .30902 L
.21179 .30902 L
.21279 .30902 L
.21379 .30902 L
.21479 .30902 L
.21578 .30901 L
.21678 .30901 L
.21778 .30901 L
.21878 .30901 L
.21978 .30901 L
.22078 .30901 L
.22178 .30901 L
.22278 .30901 L
.22378 .30901 L
.22478 .30901 L
.22577 .30901 L
.22677 .30901 L
.22777 .30901 L
.22877 .30901 L
.22977 .30901 L
.23077 .30901 L
.23177 .30901 L
.23277 .30901 L
.23377 .30901 L
.23477 .30901 L
.23576 .30901 L
.23676 .30901 L
.23776 .30901 L
.23876 .30901 L
.23976 .30901 L
.24076 .30901 L
.24176 .30901 L
.24276 .30901 L
.24376 .30901 L
.24476 .30901 L
.24575 .30901 L
.24675 .30901 L
.24775 .30901 L
.24875 .30901 L
Mistroke
.24975 .30901 L
.25075 .30901 L
.25175 .30901 L
.25275 .30901 L
.25375 .30901 L
.25475 .30901 L
.25574 .30901 L
.25674 .30901 L
.25774 .30901 L
.25874 .30901 L
.25974 .30901 L
.26074 .30901 L
.26174 .30901 L
.26274 .30901 L
.26374 .30901 L
.26474 .30901 L
.26573 .30901 L
.26673 .30901 L
.26773 .30901 L
.26873 .30901 L
.26973 .30901 L
.27073 .30901 L
.27173 .30901 L
.27273 .30901 L
.27373 .30901 L
.27473 .30901 L
.27572 .30901 L
.27672 .30901 L
.27772 .30901 L
.27872 .30901 L
.27972 .30901 L
.28072 .30901 L
.28172 .30901 L
.28272 .30901 L
.28372 .30901 L
.28472 .30901 L
.28571 .30901 L
.28671 .30901 L
.28771 .30901 L
.28871 .30901 L
.28971 .30901 L
.29071 .30901 L
.29171 .30901 L
.29271 .30901 L
.29371 .30901 L
.29471 .30901 L
.2957 .30901 L
.2967 .30901 L
.2977 .30901 L
.2987 .30901 L
Mistroke
.2997 .30901 L
.3007 .30901 L
.3017 .30901 L
.3027 .30901 L
.3037 .30901 L
.3047 .30901 L
.30569 .30901 L
.30669 .30901 L
.30769 .30901 L
.30869 .30901 L
.30969 .30901 L
.31069 .30901 L
.31169 .30901 L
.31269 .30901 L
.31369 .30901 L
.31469 .30901 L
.31568 .30901 L
.31668 .309 L
.31768 .30901 L
.31868 .30901 L
.31968 .30901 L
.32068 .30901 L
.32168 .30901 L
.32268 .30901 L
.32368 .30901 L
.32468 .30901 L
.32567 .30901 L
.32667 .30901 L
.32767 .309 L
.32867 .309 L
.32967 .309 L
.33067 .309 L
.33167 .309 L
.33267 .309 L
.33367 .309 L
.33467 .309 L
.33566 .309 L
.33666 .309 L
.33766 .309 L
.33866 .309 L
.33966 .309 L
.34066 .309 L
.34166 .309 L
.34266 .309 L
.34366 .309 L
.34466 .309 L
.34565 .309 L
.34665 .309 L
.34765 .309 L
.34865 .309 L
Mistroke
.34965 .309 L
.35065 .309 L
.35165 .309 L
.35265 .309 L
.35365 .309 L
.35465 .309 L
.35564 .309 L
.35664 .309 L
.35764 .309 L
.35864 .309 L
.35964 .309 L
.36064 .309 L
.36164 .309 L
.36264 .309 L
.36364 .309 L
.36464 .309 L
.36563 .309 L
.36663 .309 L
.36763 .309 L
.36863 .309 L
.36963 .309 L
.37063 .309 L
.37163 .309 L
.37263 .309 L
.37363 .309 L
.37463 .309 L
.37562 .309 L
.37662 .309 L
.37762 .309 L
.37862 .309 L
.37962 .309 L
.38062 .309 L
.38162 .309 L
.38262 .309 L
.38362 .309 L
.38462 .309 L
.38561 .309 L
.38661 .309 L
.38761 .309 L
.38861 .309 L
.38961 .309 L
.39061 .309 L
.39161 .309 L
.39261 .309 L
.39361 .309 L
.39461 .309 L
.3956 .309 L
.3966 .309 L
.3976 .309 L
.3986 .309 L
Mistroke
.3996 .309 L
.4006 .309 L
.4016 .309 L
.4026 .309 L
.4036 .309 L
.4046 .309 L
.40559 .309 L
.40659 .309 L
.40759 .309 L
.40859 .309 L
.40959 .309 L
.41059 .309 L
.41159 .309 L
.41259 .309 L
.41359 .309 L
.41459 .309 L
.41558 .309 L
.41658 .309 L
.41758 .309 L
.41858 .309 L
.41958 .309 L
.42058 .309 L
.42158 .309 L
.42258 .309 L
.42358 .30901 L
.42458 .309 L
.42557 .309 L
.42657 .309 L
.42757 .309 L
.42857 .309 L
.42957 .309 L
.43057 .309 L
.43157 .309 L
.43257 .309 L
.43357 .309 L
.43457 .309 L
.43556 .309 L
.43656 .309 L
.43756 .309 L
.43856 .309 L
.43956 .309 L
.44056 .309 L
.44156 .309 L
.44256 .309 L
.44356 .309 L
.44456 .309 L
.44555 .309 L
.44655 .309 L
.44755 .309 L
.44855 .309 L
Mistroke
.44955 .309 L
.45055 .309 L
.45155 .309 L
.45255 .309 L
.45355 .309 L
.45455 .309 L
.45554 .309 L
.45654 .309 L
.45754 .309 L
.45854 .309 L
.45954 .309 L
.46054 .309 L
.46154 .309 L
.46254 .309 L
.46354 .309 L
.46454 .309 L
.46553 .309 L
.46653 .309 L
.46753 .309 L
.46853 .309 L
.46953 .309 L
.47053 .309 L
.47153 .309 L
.47253 .309 L
.47353 .309 L
.47453 .309 L
.47552 .309 L
.47652 .309 L
.47752 .309 L
.47852 .309 L
.47952 .309 L
.48052 .309 L
.48152 .309 L
.48252 .309 L
.48352 .309 L
.48452 .309 L
.48551 .309 L
.48651 .309 L
.48751 .309 L
.48851 .309 L
.48951 .309 L
.49051 .309 L
.49151 .309 L
.49251 .309 L
.49351 .309 L
.49451 .309 L
.4955 .309 L
.4965 .309 L
.4975 .309 L
.4985 .309 L
Mistroke
.4995 .309 L
.5005 .309 L
.5015 .309 L
.5025 .309 L
.5035 .309 L
.5045 .309 L
.50549 .309 L
.50649 .30901 L
.50749 .30901 L
.50849 .30901 L
.50949 .30901 L
.51049 .30901 L
.51149 .30901 L
.51249 .30901 L
.51349 .30901 L
.51449 .30901 L
.51548 .30901 L
.51648 .30901 L
.51748 .30901 L
.51848 .30901 L
.51948 .30901 L
.52048 .30901 L
.52148 .30901 L
.52248 .30901 L
.52348 .30901 L
.52448 .30901 L
.52547 .30901 L
.52647 .30901 L
.52747 .30901 L
.52847 .30901 L
.52947 .30901 L
.53047 .30901 L
.53147 .30901 L
.53247 .30901 L
.53347 .30901 L
.53447 .30901 L
.53546 .30901 L
.53646 .30901 L
.53746 .30901 L
.53846 .30901 L
.53946 .30901 L
.54046 .30901 L
.54146 .30901 L
.54246 .30901 L
.54346 .30901 L
.54446 .30901 L
.54545 .30901 L
.54645 .30901 L
.54745 .30901 L
.54845 .30901 L
Mistroke
.54945 .30901 L
.55045 .30901 L
.55145 .30901 L
.55245 .30901 L
.55345 .30901 L
.55445 .30901 L
.55544 .30901 L
.55644 .30901 L
.55744 .30901 L
.55844 .30901 L
.55944 .30901 L
.56044 .30901 L
.56144 .30901 L
.56244 .30901 L
.56344 .30901 L
.56444 .30901 L
.56543 .30901 L
.56643 .30901 L
.56743 .30901 L
.56843 .30901 L
.56943 .30901 L
.57043 .30901 L
.57143 .30901 L
.57243 .30901 L
.57343 .30901 L
.57443 .30901 L
.57542 .30901 L
.57642 .30901 L
.57742 .30901 L
.57842 .30901 L
.57942 .30901 L
.58042 .30901 L
.58142 .30901 L
.58242 .30901 L
.58342 .30901 L
.58442 .30901 L
.58541 .30901 L
.58641 .30901 L
.58741 .30901 L
.58841 .30901 L
.58941 .30901 L
.59041 .30901 L
.59141 .30901 L
.59241 .30901 L
.59341 .30901 L
.59441 .30901 L
.5954 .30901 L
.5964 .30901 L
.5974 .30901 L
.5984 .30901 L
Mistroke
.5994 .30901 L
.6004 .30901 L
.6014 .30901 L
.6024 .30901 L
.6034 .30901 L
.6044 .30901 L
.60539 .30901 L
.60639 .30901 L
.60739 .30901 L
.60839 .30901 L
.60939 .30901 L
.61039 .30901 L
.61139 .30901 L
.61239 .30901 L
.61339 .30901 L
.61439 .30901 L
.61538 .30901 L
.61638 .30901 L
.61738 .30901 L
.61838 .30901 L
.61938 .30901 L
.62038 .30901 L
.62138 .30901 L
.62238 .30901 L
.62338 .30901 L
.62438 .30901 L
.62537 .30901 L
.62637 .30901 L
.62737 .30901 L
.62837 .30901 L
.62937 .30901 L
.63037 .30901 L
.63137 .30901 L
.63237 .30901 L
.63337 .30901 L
.63437 .30901 L
.63536 .30901 L
.63636 .30901 L
.63736 .30901 L
.63836 .30901 L
.63936 .30901 L
.64036 .30901 L
.64136 .30901 L
.64236 .30901 L
.64336 .30901 L
.64436 .30901 L
.64535 .30901 L
.64635 .30901 L
.64735 .30901 L
.64835 .30901 L
Mistroke
.64935 .30901 L
.65035 .30901 L
.65135 .30901 L
.65235 .30901 L
.65335 .30901 L
.65435 .30901 L
.65534 .30901 L
.65634 .30901 L
.65734 .30901 L
.65834 .30901 L
.65934 .30901 L
.66034 .30901 L
.66134 .30901 L
.66234 .30901 L
.66334 .30901 L
.66434 .30901 L
.66533 .30901 L
.66633 .30901 L
.66733 .30901 L
.66833 .30901 L
.66933 .30901 L
.67033 .30901 L
.67133 .30901 L
.67233 .30901 L
.67333 .30901 L
.67433 .30901 L
.67532 .30901 L
.67632 .30901 L
.67732 .30901 L
.67832 .30901 L
.67932 .30901 L
.68032 .30901 L
.68132 .30901 L
.68232 .30901 L
.68332 .30901 L
.68432 .30901 L
.68531 .30901 L
.68631 .30901 L
.68731 .30901 L
.68831 .30901 L
.68931 .30901 L
.69031 .30901 L
.69131 .30901 L
.69231 .30901 L
.69331 .30901 L
.69431 .30901 L
.6953 .30901 L
.6963 .30901 L
.6973 .30901 L
.6983 .30901 L
Mistroke
.6993 .30901 L
.7003 .30901 L
.7013 .30901 L
.7023 .30901 L
.7033 .30901 L
.7043 .30901 L
.70529 .30901 L
.70629 .30901 L
.70729 .30901 L
.70829 .30901 L
.70929 .30901 L
.71029 .30901 L
.71129 .30901 L
.71229 .30901 L
.71329 .30901 L
.71429 .30901 L
.71528 .30901 L
.71628 .30901 L
.71728 .30901 L
.71828 .30901 L
.71928 .30901 L
.72028 .30901 L
.72128 .309 L
.72228 .309 L
.72328 .309 L
.72428 .309 L
.72527 .309 L
.72627 .309 L
.72727 .309 L
.72827 .309 L
.72927 .309 L
.73027 .309 L
.73127 .309 L
.73227 .309 L
.73327 .309 L
.73427 .309 L
.73526 .309 L
.73626 .30901 L
.73726 .30901 L
.73826 .30901 L
.73926 .30901 L
.74026 .30901 L
.74126 .30901 L
.74226 .30901 L
.74326 .30901 L
.74426 .30901 L
.74525 .30901 L
.74625 .30901 L
.74725 .30901 L
.74825 .30901 L
Mistroke
.74925 .30901 L
.75025 .30901 L
.75125 .30901 L
.75225 .30901 L
.75325 .30901 L
.75425 .30901 L
.75524 .30901 L
.75624 .30901 L
.75724 .30901 L
.75824 .30901 L
.75924 .30901 L
.76024 .30901 L
.76124 .30901 L
.76224 .30901 L
.76324 .30901 L
.76424 .30901 L
.76523 .30901 L
.76623 .30901 L
.76723 .30901 L
.76823 .30901 L
.76923 .30901 L
.77023 .30901 L
.77123 .30901 L
.77223 .30901 L
.77323 .30901 L
.77423 .30901 L
.77522 .30901 L
.77622 .30901 L
.77722 .30901 L
.77822 .30901 L
.77922 .30901 L
.78022 .30901 L
.78122 .30901 L
.78222 .30901 L
.78322 .30901 L
.78422 .30901 L
.78521 .30901 L
.78621 .30901 L
.78721 .30901 L
.78821 .30901 L
.78921 .30901 L
.79021 .30901 L
.79121 .30901 L
.79221 .30901 L
.79321 .30901 L
.79421 .30901 L
.7952 .30901 L
.7962 .30901 L
.7972 .30901 L
.7982 .30901 L
Mistroke
.7992 .30901 L
.8002 .30901 L
.8012 .30901 L
.8022 .30901 L
.8032 .30901 L
.8042 .30901 L
.80519 .309 L
.80619 .309 L
.80719 .309 L
.80819 .309 L
.80919 .309 L
.81019 .30901 L
.81119 .309 L
.81219 .309 L
.81319 .309 L
.81419 .309 L
.81518 .309 L
.81618 .309 L
.81718 .309 L
.81818 .309 L
.81918 .309 L
.82018 .309 L
.82118 .309 L
.82218 .309 L
.82318 .309 L
.82418 .309 L
.82517 .309 L
.82617 .309 L
.82717 .309 L
.82817 .309 L
.82917 .309 L
.83017 .309 L
.83117 .309 L
.83217 .309 L
.83317 .309 L
.83417 .309 L
.83516 .309 L
.83616 .309 L
.83716 .309 L
.83816 .309 L
.83916 .309 L
.84016 .309 L
.84116 .309 L
.84216 .309 L
.84316 .309 L
.84416 .309 L
.84515 .309 L
.84615 .309 L
.84715 .309 L
.84815 .309 L
Mistroke
.84915 .309 L
.85015 .309 L
.85115 .309 L
.85215 .309 L
.85315 .309 L
.85415 .309 L
.85514 .309 L
.85614 .309 L
.85714 .309 L
.85814 .309 L
.85914 .309 L
.86014 .309 L
.86114 .309 L
.86214 .309 L
.86314 .309 L
.86414 .309 L
.86513 .309 L
.86613 .309 L
.86713 .309 L
.86813 .309 L
.86913 .309 L
.87013 .309 L
.87113 .309 L
.87213 .309 L
.87313 .309 L
.87413 .309 L
.87512 .309 L
.87612 .309 L
.87712 .309 L
.87812 .309 L
.87912 .309 L
.88012 .30901 L
.88112 .309 L
.88212 .30901 L
.88312 .30901 L
.88412 .30901 L
.88511 .309 L
.88611 .309 L
.88711 .309 L
.88811 .309 L
.88911 .309 L
.89011 .309 L
.89111 .309 L
.89211 .309 L
.89311 .309 L
.89411 .309 L
.8951 .309 L
.8961 .309 L
.8971 .309 L
.8981 .309 L
Mistroke
.8991 .309 L
.9001 .309 L
.9011 .309 L
.9021 .309 L
.9031 .309 L
.9041 .309 L
.90509 .309 L
.90609 .309 L
.90709 .309 L
.90809 .309 L
.90909 .309 L
.91009 .309 L
.91109 .309 L
.91209 .309 L
.91309 .309 L
.91409 .309 L
.91508 .309 L
.91608 .309 L
.91708 .309 L
.91808 .309 L
.91908 .309 L
.92008 .309 L
.92108 .309 L
.92208 .309 L
.92308 .309 L
.92408 .309 L
.92507 .309 L
.92607 .309 L
.92707 .30901 L
.92807 .30901 L
.92907 .30901 L
.93007 .30901 L
.93107 .30901 L
.93207 .30901 L
.93307 .30901 L
.93407 .30901 L
.93506 .30901 L
.93606 .30901 L
.93706 .30901 L
.93806 .30901 L
.93906 .30901 L
.94006 .30901 L
.94106 .30901 L
.94206 .30901 L
.94306 .30901 L
.94406 .30901 L
.94505 .30901 L
.94605 .30901 L
.94705 .30901 L
.94805 .30901 L
Mistroke
.94905 .30901 L
.95005 .30901 L
.95105 .309 L
.95205 .309 L
.95305 .309 L
.95405 .309 L
.95504 .309 L
.95604 .309 L
.95704 .309 L
.95804 .309 L
.95904 .309 L
.96004 .309 L
.96104 .309 L
.96204 .30901 L
.96304 .30901 L
.96404 .30901 L
.96503 .30901 L
.96603 .30901 L
.96703 .30901 L
.96803 .30901 L
.96903 .30901 L
.97003 .30901 L
.97103 .30901 L
.97203 .309 L
.97303 .309 L
.97403 .30901 L
.97502 .309 L
.97602 .309 L
.97702 .309 L
.97802 .309 L
.97902 .309 L
.98002 .309 L
.98102 .309 L
.98202 .309 L
.98302 .309 L
.98402 .309 L
.98501 .309 L
.98601 .309 L
.98701 .309 L
.98801 .309 L
.98901 .309 L
.99001 .309 L
.99101 .309 L
.99201 .309 L
.99301 .309 L
.99401 .309 L
.995 .309 L
.996 .309 L
.997 .309 L
.998 .309 L
Mistroke
.999 .309 L
Mfstroke
0 .98 .604 r
gsave
.999 .26444 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .24969 m
.001 .24969 L
.002 .24969 L
.003 .24969 L
.004 .24969 L
.005 .24969 L
.00599 .24969 L
.00699 .24969 L
.00799 .24969 L
.00899 .24969 L
.00999 .24969 L
.01099 .24969 L
.01199 .24969 L
.01299 .24969 L
.01399 .24969 L
.01499 .24969 L
.01598 .24969 L
.01698 .24969 L
.01798 .24969 L
.01898 .24969 L
.01998 .24969 L
.02098 .24969 L
.02198 .24969 L
.02298 .24969 L
.02398 .24969 L
.02498 .24969 L
.02597 .24969 L
.02697 .24969 L
.02797 .24969 L
.02897 .24969 L
.02997 .24969 L
.03097 .24969 L
.03197 .24969 L
.03297 .24969 L
.03397 .24969 L
.03497 .24969 L
.03596 .24969 L
.03696 .24969 L
.03796 .24969 L
.03896 .24969 L
.03996 .24969 L
.04096 .24969 L
.04196 .24969 L
.04296 .24969 L
.04396 .24969 L
.04496 .24969 L
.04595 .24969 L
.04695 .24969 L
.04795 .24969 L
.04895 .24969 L
Mistroke
.04995 .26378 L
.05095 .26378 L
.05195 .26378 L
.05295 .26378 L
.05395 .26378 L
.05495 .26378 L
.05594 .26378 L
.05694 .26378 L
.05794 .26378 L
.05894 .26378 L
.05994 .26378 L
.06094 .26378 L
.06194 .26378 L
.06294 .26378 L
.06394 .26378 L
.06494 .26378 L
.06593 .26378 L
.06693 .26378 L
.06793 .26378 L
.06893 .26378 L
.06993 .26378 L
.07093 .26378 L
.07193 .26378 L
.07293 .26378 L
.07393 .26378 L
.07493 .26378 L
.07592 .26378 L
.07692 .26378 L
.07792 .26378 L
.07892 .26378 L
.07992 .26378 L
.08092 .26378 L
.08192 .26378 L
.08292 .26378 L
.08392 .26378 L
.08492 .26378 L
.08591 .26378 L
.08691 .26378 L
.08791 .26378 L
.08891 .26378 L
.08991 .26378 L
.09091 .26378 L
.09191 .26378 L
.09291 .26378 L
.09391 .26378 L
.09491 .26378 L
.0959 .26378 L
.0969 .26378 L
.0979 .26378 L
.0989 .26378 L
Mistroke
.0999 .30321 L
.1009 .30321 L
.1019 .30321 L
.1029 .30321 L
.1039 .30321 L
.1049 .30321 L
.10589 .30321 L
.10689 .30321 L
.10789 .30321 L
.10889 .30321 L
.10989 .30321 L
.11089 .30321 L
.11189 .30321 L
.11289 .30321 L
.11389 .30321 L
.11489 .30321 L
.11588 .30321 L
.11688 .30321 L
.11788 .30321 L
.11888 .30321 L
.11988 .30321 L
.12088 .30321 L
.12188 .30321 L
.12288 .30321 L
.12388 .30321 L
.12488 .30321 L
.12587 .30321 L
.12687 .30321 L
.12787 .30321 L
.12887 .30321 L
.12987 .30321 L
.13087 .30321 L
.13187 .30321 L
.13287 .30321 L
.13387 .30321 L
.13487 .30321 L
.13586 .30321 L
.13686 .30321 L
.13786 .30321 L
.13886 .30321 L
.13986 .30321 L
.14086 .30321 L
.14186 .30321 L
.14286 .30321 L
.14386 .30321 L
.14486 .30321 L
.14585 .30321 L
.14685 .30321 L
.14785 .30321 L
.14885 .30321 L
Mistroke
.14985 .28283 L
.15085 .28283 L
.15185 .28283 L
.15285 .28283 L
.15385 .28283 L
.15485 .28283 L
.15584 .28283 L
.15684 .28283 L
.15784 .28283 L
.15884 .28283 L
.15984 .28283 L
.16084 .28283 L
.16184 .28283 L
.16284 .28283 L
.16384 .28283 L
.16484 .28283 L
.16583 .28283 L
.16683 .28283 L
.16783 .28283 L
.16883 .28283 L
.16983 .28283 L
.17083 .28283 L
.17183 .28283 L
.17283 .28283 L
.17383 .28283 L
.17483 .28283 L
.17582 .28283 L
.17682 .28283 L
.17782 .28283 L
.17882 .28283 L
.17982 .28283 L
.18082 .28283 L
.18182 .28283 L
.18282 .28283 L
.18382 .28283 L
.18482 .28283 L
.18581 .28283 L
.18681 .28283 L
.18781 .28283 L
.18881 .28283 L
.18981 .28283 L
.19081 .28283 L
.19181 .28283 L
.19281 .28283 L
.19381 .28283 L
.19481 .28283 L
.1958 .28283 L
.1968 .28283 L
.1978 .28283 L
.1988 .28283 L
Mistroke
.1998 .26729 L
.2008 .26729 L
.2018 .26729 L
.2028 .26729 L
.2038 .26729 L
.2048 .26729 L
.20579 .26729 L
.20679 .26729 L
.20779 .26729 L
.20879 .26729 L
.20979 .26729 L
.21079 .26729 L
.21179 .26729 L
.21279 .26729 L
.21379 .26729 L
.21479 .26729 L
.21578 .26729 L
.21678 .26729 L
.21778 .26729 L
.21878 .26729 L
.21978 .26729 L
.22078 .26729 L
.22178 .26729 L
.22278 .26729 L
.22378 .26729 L
.22478 .26729 L
.22577 .26729 L
.22677 .26729 L
.22777 .26729 L
.22877 .26729 L
.22977 .26729 L
.23077 .26729 L
.23177 .26729 L
.23277 .26729 L
.23377 .26729 L
.23477 .26729 L
.23576 .26729 L
.23676 .26729 L
.23776 .26729 L
.23876 .26729 L
.23976 .26729 L
.24076 .26729 L
.24176 .26729 L
.24276 .26729 L
.24376 .26729 L
.24476 .26729 L
.24575 .26729 L
.24675 .26729 L
.24775 .26729 L
.24875 .26729 L
Mistroke
.24975 .27629 L
.25075 .27629 L
.25175 .27629 L
.25275 .27629 L
.25375 .27629 L
.25475 .27629 L
.25574 .27629 L
.25674 .27629 L
.25774 .27629 L
.25874 .27629 L
.25974 .27629 L
.26074 .27629 L
.26174 .27629 L
.26274 .27629 L
.26374 .27629 L
.26474 .27629 L
.26573 .27629 L
.26673 .27629 L
.26773 .27629 L
.26873 .27629 L
.26973 .27629 L
.27073 .27629 L
.27173 .27629 L
.27273 .27629 L
.27373 .27629 L
.27473 .27629 L
.27572 .27629 L
.27672 .27629 L
.27772 .27629 L
.27872 .27629 L
.27972 .27629 L
.28072 .27629 L
.28172 .27629 L
.28272 .27629 L
.28372 .27629 L
.28472 .27629 L
.28571 .27629 L
.28671 .27629 L
.28771 .27629 L
.28871 .27629 L
.28971 .27629 L
.29071 .27629 L
.29171 .27629 L
.29271 .27629 L
.29371 .27629 L
.29471 .27629 L
.2957 .27629 L
.2967 .27629 L
.2977 .27629 L
.2987 .27629 L
Mistroke
.2997 .28173 L
.3007 .28173 L
.3017 .28173 L
.3027 .28173 L
.3037 .28173 L
.3047 .28173 L
.30569 .28173 L
.30669 .28173 L
.30769 .28173 L
.30869 .28173 L
.30969 .28173 L
.31069 .28173 L
.31169 .28173 L
.31269 .28173 L
.31369 .28173 L
.31469 .28173 L
.31568 .28173 L
.31668 .28173 L
.31768 .28173 L
.31868 .28173 L
.31968 .28173 L
.32068 .28173 L
.32168 .28173 L
.32268 .28173 L
.32368 .28173 L
.32468 .28173 L
.32567 .28173 L
.32667 .28173 L
.32767 .28173 L
.32867 .28173 L
.32967 .28173 L
.33067 .28173 L
.33167 .28173 L
.33267 .28173 L
.33367 .28173 L
.33467 .28173 L
.33566 .28173 L
.33666 .28173 L
.33766 .28173 L
.33866 .28173 L
.33966 .28173 L
.34066 .28173 L
.34166 .28173 L
.34266 .28173 L
.34366 .28173 L
.34466 .28173 L
.34565 .28173 L
.34665 .28173 L
.34765 .28173 L
.34865 .28173 L
Mistroke
.34965 .27928 L
.35065 .27928 L
.35165 .27928 L
.35265 .27928 L
.35365 .27928 L
.35465 .27928 L
.35564 .27928 L
.35664 .27928 L
.35764 .27928 L
.35864 .27928 L
.35964 .27928 L
.36064 .27928 L
.36164 .27928 L
.36264 .27928 L
.36364 .27928 L
.36464 .27928 L
.36563 .27928 L
.36663 .27928 L
.36763 .27928 L
.36863 .27928 L
.36963 .27928 L
.37063 .27928 L
.37163 .27928 L
.37263 .27928 L
.37363 .27928 L
.37463 .27928 L
.37562 .27928 L
.37662 .27928 L
.37762 .27928 L
.37862 .27928 L
.37962 .27928 L
.38062 .27928 L
.38162 .27928 L
.38262 .27928 L
.38362 .27928 L
.38462 .27928 L
.38561 .27928 L
.38661 .27928 L
.38761 .27928 L
.38861 .27928 L
.38961 .27928 L
.39061 .27928 L
.39161 .27928 L
.39261 .27928 L
.39361 .27928 L
.39461 .27928 L
.3956 .27928 L
.3966 .27928 L
.3976 .27928 L
.3986 .27928 L
Mistroke
.3996 .26563 L
.4006 .26563 L
.4016 .26563 L
.4026 .26563 L
.4036 .26563 L
.4046 .26563 L
.40559 .26563 L
.40659 .26563 L
.40759 .26563 L
.40859 .26563 L
.40959 .26563 L
.41059 .26563 L
.41159 .26563 L
.41259 .26563 L
.41359 .26563 L
.41459 .26563 L
.41558 .26563 L
.41658 .26563 L
.41758 .26563 L
.41858 .26563 L
.41958 .26563 L
.42058 .26563 L
.42158 .26563 L
.42258 .26563 L
.42358 .26563 L
.42458 .26563 L
.42557 .26563 L
.42657 .26563 L
.42757 .26563 L
.42857 .26563 L
.42957 .26563 L
.43057 .26563 L
.43157 .26563 L
.43257 .26563 L
.43357 .26563 L
.43457 .26563 L
.43556 .26563 L
.43656 .26563 L
.43756 .26563 L
.43856 .26563 L
.43956 .26563 L
.44056 .26563 L
.44156 .26563 L
.44256 .26563 L
.44356 .26563 L
.44456 .26563 L
.44555 .26563 L
.44655 .26563 L
.44755 .26563 L
.44855 .26563 L
Mistroke
.44955 .25997 L
.45055 .25997 L
.45155 .25997 L
.45255 .25997 L
.45355 .25997 L
.45455 .25997 L
.45554 .25997 L
.45654 .25997 L
.45754 .25997 L
.45854 .25997 L
.45954 .25997 L
.46054 .25997 L
.46154 .25997 L
.46254 .25997 L
.46354 .25997 L
.46454 .25997 L
.46553 .25997 L
.46653 .25997 L
.46753 .25997 L
.46853 .25997 L
.46953 .25997 L
.47053 .25997 L
.47153 .25997 L
.47253 .25997 L
.47353 .25997 L
.47453 .25997 L
.47552 .25997 L
.47652 .25997 L
.47752 .25997 L
.47852 .25997 L
.47952 .25997 L
.48052 .25997 L
.48152 .25997 L
.48252 .25997 L
.48352 .25997 L
.48452 .25997 L
.48551 .25997 L
.48651 .25997 L
.48751 .25997 L
.48851 .25997 L
.48951 .25997 L
.49051 .25997 L
.49151 .25997 L
.49251 .25997 L
.49351 .25997 L
.49451 .25997 L
.4955 .25997 L
.4965 .25997 L
.4975 .25997 L
.4985 .25997 L
Mistroke
.4995 .26081 L
.5005 .26081 L
.5015 .26081 L
.5025 .26081 L
.5035 .26081 L
.5045 .26081 L
.50549 .26081 L
.50649 .26081 L
.50749 .26081 L
.50849 .26081 L
.50949 .26081 L
.51049 .26081 L
.51149 .26081 L
.51249 .26081 L
.51349 .26081 L
.51449 .26081 L
.51548 .26081 L
.51648 .26081 L
.51748 .26081 L
.51848 .26081 L
.51948 .26081 L
.52048 .26081 L
.52148 .26081 L
.52248 .26081 L
.52348 .26081 L
.52448 .26081 L
.52547 .26081 L
.52647 .26081 L
.52747 .26081 L
.52847 .26081 L
.52947 .26081 L
.53047 .26081 L
.53147 .26081 L
.53247 .26081 L
.53347 .26081 L
.53447 .26081 L
.53546 .26081 L
.53646 .26081 L
.53746 .26081 L
.53846 .26081 L
.53946 .26081 L
.54046 .26081 L
.54146 .26081 L
.54246 .26081 L
.54346 .26081 L
.54446 .26081 L
.54545 .26081 L
.54645 .26081 L
.54745 .26081 L
.54845 .26081 L
Mistroke
.54945 .2626 L
.55045 .2626 L
.55145 .2626 L
.55245 .2626 L
.55345 .2626 L
.55445 .2626 L
.55544 .2626 L
.55644 .2626 L
.55744 .2626 L
.55844 .2626 L
.55944 .2626 L
.56044 .2626 L
.56144 .2626 L
.56244 .2626 L
.56344 .2626 L
.56444 .2626 L
.56543 .2626 L
.56643 .2626 L
.56743 .2626 L
.56843 .2626 L
.56943 .2626 L
.57043 .2626 L
.57143 .2626 L
.57243 .2626 L
.57343 .2626 L
.57443 .2626 L
.57542 .2626 L
.57642 .2626 L
.57742 .2626 L
.57842 .2626 L
.57942 .2626 L
.58042 .2626 L
.58142 .2626 L
.58242 .2626 L
.58342 .2626 L
.58442 .2626 L
.58541 .2626 L
.58641 .2626 L
.58741 .2626 L
.58841 .2626 L
.58941 .2626 L
.59041 .2626 L
.59141 .2626 L
.59241 .2626 L
.59341 .2626 L
.59441 .2626 L
.5954 .2626 L
.5964 .2626 L
.5974 .2626 L
.5984 .2626 L
Mistroke
.5994 .24328 L
.6004 .24328 L
.6014 .24328 L
.6024 .24328 L
.6034 .24328 L
.6044 .24328 L
.60539 .24328 L
.60639 .24328 L
.60739 .24328 L
.60839 .24328 L
.60939 .24328 L
.61039 .24328 L
.61139 .24328 L
.61239 .24328 L
.61339 .24328 L
.61439 .24328 L
.61538 .24328 L
.61638 .24328 L
.61738 .24328 L
.61838 .24328 L
.61938 .24328 L
.62038 .24328 L
.62138 .24328 L
.62238 .24328 L
.62338 .24328 L
.62438 .24328 L
.62537 .24328 L
.62637 .24328 L
.62737 .24328 L
.62837 .24328 L
.62937 .24328 L
.63037 .24328 L
.63137 .24328 L
.63237 .24328 L
.63337 .24328 L
.63437 .24328 L
.63536 .24328 L
.63636 .24328 L
.63736 .24328 L
.63836 .24328 L
.63936 .24328 L
.64036 .24328 L
.64136 .24328 L
.64236 .24328 L
.64336 .24328 L
.64436 .24328 L
.64535 .24328 L
.64635 .24328 L
.64735 .24328 L
.64835 .24328 L
Mistroke
.64935 .25858 L
.65035 .25858 L
.65135 .25858 L
.65235 .25858 L
.65335 .25858 L
.65435 .25858 L
.65534 .25858 L
.65634 .25858 L
.65734 .25858 L
.65834 .25858 L
.65934 .25858 L
.66034 .25858 L
.66134 .25858 L
.66234 .25858 L
.66334 .25858 L
.66434 .25858 L
.66533 .25858 L
.66633 .25858 L
.66733 .25858 L
.66833 .25858 L
.66933 .25858 L
.67033 .25858 L
.67133 .25858 L
.67233 .25858 L
.67333 .25858 L
.67433 .25858 L
.67532 .25858 L
.67632 .25858 L
.67732 .25858 L
.67832 .25858 L
.67932 .25858 L
.68032 .25858 L
.68132 .25858 L
.68232 .25858 L
.68332 .25858 L
.68432 .25858 L
.68531 .25858 L
.68631 .25858 L
.68731 .25858 L
.68831 .25858 L
.68931 .25858 L
.69031 .25858 L
.69131 .25858 L
.69231 .25858 L
.69331 .25858 L
.69431 .25858 L
.6953 .25858 L
.6963 .25858 L
.6973 .25858 L
.6983 .25858 L
Mistroke
.6993 .26442 L
.7003 .26442 L
.7013 .26442 L
.7023 .26442 L
.7033 .26442 L
.7043 .26442 L
.70529 .26442 L
.70629 .26442 L
.70729 .26442 L
.70829 .26442 L
.70929 .26442 L
.71029 .26442 L
.71129 .26442 L
.71229 .26442 L
.71329 .26442 L
.71429 .26442 L
.71528 .26442 L
.71628 .26442 L
.71728 .26442 L
.71828 .26442 L
.71928 .26442 L
.72028 .26442 L
.72128 .26442 L
.72228 .26442 L
.72328 .26442 L
.72428 .26442 L
.72527 .26442 L
.72627 .26442 L
.72727 .26442 L
.72827 .26442 L
.72927 .26442 L
.73027 .26442 L
.73127 .26442 L
.73227 .26442 L
.73327 .26442 L
.73427 .26442 L
.73526 .26442 L
.73626 .26442 L
.73726 .26442 L
.73826 .26442 L
.73926 .26442 L
.74026 .26442 L
.74126 .26442 L
.74226 .26442 L
.74326 .26442 L
.74426 .26442 L
.74525 .26442 L
.74625 .26442 L
.74725 .26442 L
.74825 .26442 L
Mistroke
.74925 .263 L
.75025 .263 L
.75125 .263 L
.75225 .263 L
.75325 .263 L
.75425 .263 L
.75524 .263 L
.75624 .263 L
.75724 .263 L
.75824 .263 L
.75924 .263 L
.76024 .263 L
.76124 .263 L
.76224 .263 L
.76324 .263 L
.76424 .263 L
.76523 .263 L
.76623 .263 L
.76723 .263 L
.76823 .263 L
.76923 .263 L
.77023 .263 L
.77123 .263 L
.77223 .263 L
.77323 .263 L
.77423 .263 L
.77522 .263 L
.77622 .263 L
.77722 .263 L
.77822 .263 L
.77922 .263 L
.78022 .263 L
.78122 .263 L
.78222 .263 L
.78322 .263 L
.78422 .263 L
.78521 .263 L
.78621 .263 L
.78721 .263 L
.78821 .263 L
.78921 .263 L
.79021 .263 L
.79121 .263 L
.79221 .263 L
.79321 .263 L
.79421 .263 L
.7952 .263 L
.7962 .263 L
.7972 .263 L
.7982 .263 L
Mistroke
.7992 .25343 L
.8002 .25343 L
.8012 .25343 L
.8022 .25343 L
.8032 .25343 L
.8042 .25343 L
.80519 .25343 L
.80619 .25343 L
.80719 .25343 L
.80819 .25343 L
.80919 .25343 L
.81019 .25343 L
.81119 .25343 L
.81219 .25343 L
.81319 .25343 L
.81419 .25343 L
.81518 .25343 L
.81618 .25343 L
.81718 .25343 L
.81818 .25343 L
.81918 .25343 L
.82018 .25343 L
.82118 .25343 L
.82218 .25343 L
.82318 .25343 L
.82418 .25343 L
.82517 .25343 L
.82617 .25343 L
.82717 .25343 L
.82817 .25343 L
.82917 .25343 L
.83017 .25343 L
.83117 .25343 L
.83217 .25343 L
.83317 .25343 L
.83417 .25343 L
.83516 .25343 L
.83616 .25343 L
.83716 .25343 L
.83816 .25343 L
.83916 .25343 L
.84016 .25343 L
.84116 .25343 L
.84216 .25343 L
.84316 .25343 L
.84416 .25343 L
.84515 .25343 L
.84615 .25343 L
.84715 .25343 L
.84815 .25343 L
Mistroke
.84915 .25649 L
.85015 .25649 L
.85115 .25649 L
.85215 .25649 L
.85315 .25649 L
.85415 .25649 L
.85514 .25649 L
.85614 .25649 L
.85714 .25649 L
.85814 .25649 L
.85914 .25649 L
.86014 .25649 L
.86114 .25649 L
.86214 .25649 L
.86314 .25649 L
.86414 .25649 L
.86513 .25649 L
.86613 .25649 L
.86713 .25649 L
.86813 .25649 L
.86913 .25649 L
.87013 .25649 L
.87113 .25649 L
.87213 .25649 L
.87313 .25649 L
.87413 .25649 L
.87512 .25649 L
.87612 .25649 L
.87712 .25649 L
.87812 .25649 L
.87912 .25649 L
.88012 .25649 L
.88112 .25649 L
.88212 .25649 L
.88312 .25649 L
.88412 .25649 L
.88511 .25649 L
.88611 .25649 L
.88711 .25649 L
.88811 .25649 L
.88911 .25649 L
.89011 .25649 L
.89111 .25649 L
.89211 .25649 L
.89311 .25649 L
.89411 .25649 L
.8951 .25649 L
.8961 .25649 L
.8971 .25649 L
.8981 .25649 L
Mistroke
.8991 .26109 L
.9001 .26109 L
.9011 .26109 L
.9021 .26109 L
.9031 .26109 L
.9041 .26109 L
.90509 .26109 L
.90609 .26109 L
.90709 .26109 L
.90809 .26109 L
.90909 .26109 L
.91009 .26109 L
.91109 .26109 L
.91209 .26109 L
.91309 .26109 L
.91409 .26109 L
.91508 .26109 L
.91608 .26109 L
.91708 .26109 L
.91808 .26109 L
.91908 .26109 L
.92008 .26109 L
.92108 .26109 L
.92208 .26109 L
.92308 .26109 L
.92408 .26109 L
.92507 .26109 L
.92607 .26109 L
.92707 .26109 L
.92807 .26109 L
.92907 .26109 L
.93007 .26109 L
.93107 .26109 L
.93207 .26109 L
.93307 .26109 L
.93407 .26109 L
.93506 .26109 L
.93606 .26109 L
.93706 .26109 L
.93806 .26109 L
.93906 .26109 L
.94006 .26109 L
.94106 .26109 L
.94206 .26109 L
.94306 .26109 L
.94406 .26109 L
.94505 .26109 L
.94605 .26109 L
.94705 .26109 L
.94805 .26109 L
Mistroke
.94905 .26591 L
.95005 .26591 L
.95105 .26591 L
.95205 .26591 L
.95305 .26591 L
.95405 .26591 L
.95504 .26591 L
.95604 .26591 L
.95704 .26591 L
.95804 .26591 L
.95904 .26591 L
.96004 .26591 L
.96104 .26591 L
.96204 .26591 L
.96304 .26591 L
.96404 .26591 L
.96503 .26591 L
.96603 .26591 L
.96703 .26591 L
.96803 .26591 L
.96903 .26591 L
.97003 .26591 L
.97103 .26591 L
.97203 .26591 L
.97303 .26591 L
.97403 .26591 L
.97502 .26591 L
.97602 .26591 L
.97702 .26591 L
.97802 .26591 L
.97902 .26591 L
.98002 .26591 L
.98102 .26591 L
.98202 .26591 L
.98302 .26591 L
.98402 .26591 L
.98501 .26591 L
.98601 .26591 L
.98701 .26591 L
.98801 .26591 L
.98901 .26591 L
.99001 .26591 L
.99101 .26591 L
.99201 .26591 L
.99301 .26591 L
.99401 .26591 L
.995 .26591 L
.996 .26591 L
.997 .26591 L
.998 .26591 L
Mistroke
.999 .26444 L
Mfstroke
gsave
.999 .41279 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .49196 m
.001 .49196 L
.002 .49196 L
.003 .49196 L
.004 .49196 L
.005 .49196 L
.00599 .49196 L
.00699 .49196 L
.00799 .49196 L
.00899 .49196 L
.00999 .49196 L
.01099 .49196 L
.01199 .49196 L
.01299 .49196 L
.01399 .49196 L
.01499 .49196 L
.01598 .49196 L
.01698 .49196 L
.01798 .49196 L
.01898 .49196 L
.01998 .49196 L
.02098 .49196 L
.02198 .49196 L
.02298 .49196 L
.02398 .49196 L
.02498 .49196 L
.02597 .49196 L
.02697 .49196 L
.02797 .49196 L
.02897 .49196 L
.02997 .49196 L
.03097 .49196 L
.03197 .49196 L
.03297 .49196 L
.03397 .49196 L
.03497 .49196 L
.03596 .49196 L
.03696 .49196 L
.03796 .49196 L
.03896 .49196 L
.03996 .49196 L
.04096 .49196 L
.04196 .49196 L
.04296 .49196 L
.04396 .49196 L
.04496 .49196 L
.04595 .49196 L
.04695 .49196 L
.04795 .49196 L
.04895 .49196 L
Mistroke
.04995 .50568 L
.05095 .50568 L
.05195 .50568 L
.05295 .50568 L
.05395 .50568 L
.05495 .50568 L
.05594 .50568 L
.05694 .50568 L
.05794 .50568 L
.05894 .50568 L
.05994 .50568 L
.06094 .50568 L
.06194 .50568 L
.06294 .50568 L
.06394 .50568 L
.06494 .50568 L
.06593 .50568 L
.06693 .50568 L
.06793 .50568 L
.06893 .50568 L
.06993 .50568 L
.07093 .50568 L
.07193 .50568 L
.07293 .50568 L
.07393 .50568 L
.07493 .50568 L
.07592 .50568 L
.07692 .50568 L
.07792 .50568 L
.07892 .50568 L
.07992 .50568 L
.08092 .50568 L
.08192 .50568 L
.08292 .50568 L
.08392 .50568 L
.08492 .50568 L
.08591 .50568 L
.08691 .50568 L
.08791 .50568 L
.08891 .50568 L
.08991 .50568 L
.09091 .50568 L
.09191 .50568 L
.09291 .50568 L
.09391 .50568 L
.09491 .50568 L
.0959 .50568 L
.0969 .50568 L
.0979 .50568 L
.0989 .50568 L
Mistroke
.0999 .51918 L
.1009 .51918 L
.1019 .51918 L
.1029 .51918 L
.1039 .51918 L
.1049 .51918 L
.10589 .51918 L
.10689 .51918 L
.10789 .51918 L
.10889 .51918 L
.10989 .51918 L
.11089 .51918 L
.11189 .51918 L
.11289 .51918 L
.11389 .51918 L
.11489 .51918 L
.11588 .51918 L
.11688 .51918 L
.11788 .51918 L
.11888 .51918 L
.11988 .51918 L
.12088 .51918 L
.12188 .51918 L
.12288 .51918 L
.12388 .51918 L
.12488 .51918 L
.12587 .51918 L
.12687 .51918 L
.12787 .51918 L
.12887 .51918 L
.12987 .51918 L
.13087 .51918 L
.13187 .51918 L
.13287 .51918 L
.13387 .51918 L
.13487 .51918 L
.13586 .51918 L
.13686 .51918 L
.13786 .51918 L
.13886 .51918 L
.13986 .51918 L
.14086 .51918 L
.14186 .51918 L
.14286 .51918 L
.14386 .51918 L
.14486 .51918 L
.14585 .51918 L
.14685 .51918 L
.14785 .51918 L
.14885 .51918 L
Mistroke
.14985 .49494 L
.15085 .49494 L
.15185 .49494 L
.15285 .49494 L
.15385 .49494 L
.15485 .49494 L
.15584 .49494 L
.15684 .49494 L
.15784 .49494 L
.15884 .49494 L
.15984 .49494 L
.16084 .49494 L
.16184 .49494 L
.16284 .49494 L
.16384 .49494 L
.16484 .49494 L
.16583 .49494 L
.16683 .49494 L
.16783 .49494 L
.16883 .49494 L
.16983 .49494 L
.17083 .49494 L
.17183 .49494 L
.17283 .49494 L
.17383 .49494 L
.17483 .49494 L
.17582 .49494 L
.17682 .49494 L
.17782 .49494 L
.17882 .49494 L
.17982 .49494 L
.18082 .49494 L
.18182 .49494 L
.18282 .49494 L
.18382 .49494 L
.18482 .49494 L
.18581 .49494 L
.18681 .49494 L
.18781 .49494 L
.18881 .49494 L
.18981 .49494 L
.19081 .49494 L
.19181 .49494 L
.19281 .49494 L
.19381 .49494 L
.19481 .49494 L
.1958 .49494 L
.1968 .49494 L
.1978 .49494 L
.1988 .49494 L
Mistroke
.1998 .47772 L
.2008 .47772 L
.2018 .47772 L
.2028 .47772 L
.2038 .47772 L
.2048 .47772 L
.20579 .47772 L
.20679 .47772 L
.20779 .47772 L
.20879 .47772 L
.20979 .47772 L
.21079 .47772 L
.21179 .47772 L
.21279 .47772 L
.21379 .47772 L
.21479 .47772 L
.21578 .47772 L
.21678 .47772 L
.21778 .47772 L
.21878 .47772 L
.21978 .47772 L
.22078 .47772 L
.22178 .47772 L
.22278 .47772 L
.22378 .47772 L
.22478 .47772 L
.22577 .47772 L
.22677 .47772 L
.22777 .47772 L
.22877 .47772 L
.22977 .47772 L
.23077 .47772 L
.23177 .47772 L
.23277 .47772 L
.23377 .47772 L
.23477 .47772 L
.23576 .47772 L
.23676 .47772 L
.23776 .47772 L
.23876 .47772 L
.23976 .47772 L
.24076 .47772 L
.24176 .47772 L
.24276 .47772 L
.24376 .47772 L
.24476 .47772 L
.24575 .47772 L
.24675 .47772 L
.24775 .47772 L
.24875 .47772 L
Mistroke
.24975 .48458 L
.25075 .48458 L
.25175 .48458 L
.25275 .48458 L
.25375 .48458 L
.25475 .48458 L
.25574 .48458 L
.25674 .48458 L
.25774 .48458 L
.25874 .48458 L
.25974 .48458 L
.26074 .48458 L
.26174 .48458 L
.26274 .48458 L
.26374 .48458 L
.26474 .48458 L
.26573 .48458 L
.26673 .48458 L
.26773 .48458 L
.26873 .48458 L
.26973 .48458 L
.27073 .48458 L
.27173 .48458 L
.27273 .48458 L
.27373 .48458 L
.27473 .48458 L
.27572 .48458 L
.27672 .48458 L
.27772 .48458 L
.27872 .48458 L
.27972 .48458 L
.28072 .48458 L
.28172 .48458 L
.28272 .48458 L
.28372 .48458 L
.28472 .48458 L
.28571 .48458 L
.28671 .48458 L
.28771 .48458 L
.28871 .48458 L
.28971 .48458 L
.29071 .48458 L
.29171 .48458 L
.29271 .48458 L
.29371 .48458 L
.29471 .48458 L
.2957 .48458 L
.2967 .48458 L
.2977 .48458 L
.2987 .48458 L
Mistroke
.2997 .48734 L
.3007 .48734 L
.3017 .48734 L
.3027 .48734 L
.3037 .48734 L
.3047 .48734 L
.30569 .48734 L
.30669 .48734 L
.30769 .48734 L
.30869 .48734 L
.30969 .48734 L
.31069 .48734 L
.31169 .48734 L
.31269 .48734 L
.31369 .48734 L
.31469 .48734 L
.31568 .48734 L
.31668 .48734 L
.31768 .48734 L
.31868 .48734 L
.31968 .48734 L
.32068 .48734 L
.32168 .48734 L
.32268 .48734 L
.32368 .48734 L
.32468 .48734 L
.32567 .48734 L
.32667 .48734 L
.32767 .48734 L
.32867 .48734 L
.32967 .48734 L
.33067 .48734 L
.33167 .48734 L
.33267 .48734 L
.33367 .48734 L
.33467 .48734 L
.33566 .48734 L
.33666 .48734 L
.33766 .48734 L
.33866 .48734 L
.33966 .48734 L
.34066 .48734 L
.34166 .48734 L
.34266 .48734 L
.34366 .48734 L
.34466 .48734 L
.34565 .48734 L
.34665 .48734 L
.34765 .48734 L
.34865 .48734 L
Mistroke
.34965 .47803 L
.35065 .47803 L
.35165 .47803 L
.35265 .47803 L
.35365 .47803 L
.35465 .47803 L
.35564 .47803 L
.35664 .47803 L
.35764 .47803 L
.35864 .47803 L
.35964 .47803 L
.36064 .47803 L
.36164 .47803 L
.36264 .47803 L
.36364 .47803 L
.36464 .47803 L
.36563 .47803 L
.36663 .47803 L
.36763 .47803 L
.36863 .47803 L
.36963 .47803 L
.37063 .47803 L
.37163 .47803 L
.37263 .47803 L
.37363 .47803 L
.37463 .47803 L
.37562 .47803 L
.37662 .47803 L
.37762 .47803 L
.37862 .47803 L
.37962 .47803 L
.38062 .47803 L
.38162 .47803 L
.38262 .47803 L
.38362 .47803 L
.38462 .47803 L
.38561 .47803 L
.38661 .47803 L
.38761 .47803 L
.38861 .47803 L
.38961 .47803 L
.39061 .47803 L
.39161 .47803 L
.39261 .47803 L
.39361 .47803 L
.39461 .47803 L
.3956 .47803 L
.3966 .47803 L
.3976 .47803 L
.3986 .47803 L
Mistroke
.3996 .46292 L
.4006 .46292 L
.4016 .46292 L
.4026 .46292 L
.4036 .46292 L
.4046 .46292 L
.40559 .46292 L
.40659 .46292 L
.40759 .46292 L
.40859 .46292 L
.40959 .46292 L
.41059 .46292 L
.41159 .46292 L
.41259 .46292 L
.41359 .46292 L
.41459 .46292 L
.41558 .46292 L
.41658 .46292 L
.41758 .46292 L
.41858 .46292 L
.41958 .46292 L
.42058 .46292 L
.42158 .46292 L
.42258 .46292 L
.42358 .46292 L
.42458 .46292 L
.42557 .46292 L
.42657 .46292 L
.42757 .46292 L
.42857 .46292 L
.42957 .46292 L
.43057 .46292 L
.43157 .46292 L
.43257 .46292 L
.43357 .46292 L
.43457 .46292 L
.43556 .46292 L
.43656 .46292 L
.43756 .46292 L
.43856 .46292 L
.43956 .46292 L
.44056 .46292 L
.44156 .46292 L
.44256 .46292 L
.44356 .46292 L
.44456 .46292 L
.44555 .46292 L
.44655 .46292 L
.44755 .46292 L
.44855 .46292 L
Mistroke
.44955 .43773 L
.45055 .43773 L
.45155 .43773 L
.45255 .43773 L
.45355 .43773 L
.45455 .43773 L
.45554 .43773 L
.45654 .43773 L
.45754 .43773 L
.45854 .43773 L
.45954 .43773 L
.46054 .43773 L
.46154 .43773 L
.46254 .43773 L
.46354 .43773 L
.46454 .43773 L
.46553 .43773 L
.46653 .43773 L
.46753 .43773 L
.46853 .43773 L
.46953 .43773 L
.47053 .43773 L
.47153 .43773 L
.47253 .43773 L
.47353 .43773 L
.47453 .43773 L
.47552 .43773 L
.47652 .43773 L
.47752 .43773 L
.47852 .43773 L
.47952 .43773 L
.48052 .43773 L
.48152 .43773 L
.48252 .43773 L
.48352 .43773 L
.48452 .43773 L
.48551 .43773 L
.48651 .43773 L
.48751 .43773 L
.48851 .43773 L
.48951 .43773 L
.49051 .43773 L
.49151 .43773 L
.49251 .43773 L
.49351 .43773 L
.49451 .43773 L
.4955 .43773 L
.4965 .43773 L
.4975 .43773 L
.4985 .43773 L
Mistroke
.4995 .43845 L
.5005 .43845 L
.5015 .43845 L
.5025 .43845 L
.5035 .43845 L
.5045 .43845 L
.50549 .43845 L
.50649 .43845 L
.50749 .43845 L
.50849 .43845 L
.50949 .43845 L
.51049 .43845 L
.51149 .43845 L
.51249 .43845 L
.51349 .43845 L
.51449 .43845 L
.51548 .43845 L
.51648 .43845 L
.51748 .43845 L
.51848 .43845 L
.51948 .43845 L
.52048 .43845 L
.52148 .43845 L
.52248 .43845 L
.52348 .43845 L
.52448 .43845 L
.52547 .43845 L
.52647 .43845 L
.52747 .43845 L
.52847 .43845 L
.52947 .43845 L
.53047 .43845 L
.53147 .43845 L
.53247 .43845 L
.53347 .43845 L
.53447 .43845 L
.53546 .43845 L
.53646 .43845 L
.53746 .43845 L
.53846 .43845 L
.53946 .43845 L
.54046 .43845 L
.54146 .43845 L
.54246 .43845 L
.54346 .43845 L
.54446 .43845 L
.54545 .43845 L
.54645 .43845 L
.54745 .43845 L
.54845 .43845 L
Mistroke
.54945 .44013 L
.55045 .44013 L
.55145 .44013 L
.55245 .44013 L
.55345 .44013 L
.55445 .44013 L
.55544 .44013 L
.55644 .44013 L
.55744 .44013 L
.55844 .44013 L
.55944 .44013 L
.56044 .44013 L
.56144 .44013 L
.56244 .44013 L
.56344 .44013 L
.56444 .44013 L
.56543 .44013 L
.56643 .44013 L
.56743 .44013 L
.56843 .44013 L
.56943 .44013 L
.57043 .44013 L
.57143 .44013 L
.57243 .44013 L
.57343 .44013 L
.57443 .44013 L
.57542 .44013 L
.57642 .44013 L
.57742 .44013 L
.57842 .44013 L
.57942 .44013 L
.58042 .44013 L
.58142 .44013 L
.58242 .44013 L
.58342 .44013 L
.58442 .44013 L
.58541 .44013 L
.58641 .44013 L
.58741 .44013 L
.58841 .44013 L
.58941 .44013 L
.59041 .44013 L
.59141 .44013 L
.59241 .44013 L
.59341 .44013 L
.59441 .44013 L
.5954 .44013 L
.5964 .44013 L
.5974 .44013 L
.5984 .44013 L
Mistroke
.5994 .41104 L
.6004 .41104 L
.6014 .41104 L
.6024 .41104 L
.6034 .41104 L
.6044 .41104 L
.60539 .41104 L
.60639 .41104 L
.60739 .41104 L
.60839 .41104 L
.60939 .41104 L
.61039 .41104 L
.61139 .41104 L
.61239 .41104 L
.61339 .41104 L
.61439 .41104 L
.61538 .41104 L
.61638 .41104 L
.61738 .41104 L
.61838 .41104 L
.61938 .41104 L
.62038 .41104 L
.62138 .41104 L
.62238 .41104 L
.62338 .41104 L
.62438 .41104 L
.62537 .41104 L
.62637 .41104 L
.62737 .41104 L
.62837 .41104 L
.62937 .41104 L
.63037 .41104 L
.63137 .41104 L
.63237 .41104 L
.63337 .41104 L
.63437 .41104 L
.63536 .41104 L
.63636 .41104 L
.63736 .41104 L
.63836 .41104 L
.63936 .41104 L
.64036 .41104 L
.64136 .41104 L
.64236 .41104 L
.64336 .41104 L
.64436 .41104 L
.64535 .41104 L
.64635 .41104 L
.64735 .41104 L
.64835 .41104 L
Mistroke
.64935 .42329 L
.65035 .42329 L
.65135 .42329 L
.65235 .42329 L
.65335 .42329 L
.65435 .42329 L
.65534 .42329 L
.65634 .42329 L
.65734 .42329 L
.65834 .42329 L
.65934 .42329 L
.66034 .42329 L
.66134 .42329 L
.66234 .42329 L
.66334 .42329 L
.66434 .42329 L
.66533 .42329 L
.66633 .42329 L
.66733 .42329 L
.66833 .42329 L
.66933 .42329 L
.67033 .42329 L
.67133 .42329 L
.67233 .42329 L
.67333 .42329 L
.67433 .42329 L
.67532 .42329 L
.67632 .42329 L
.67732 .42329 L
.67832 .42329 L
.67932 .42329 L
.68032 .42329 L
.68132 .42329 L
.68232 .42329 L
.68332 .42329 L
.68432 .42329 L
.68531 .42329 L
.68631 .42329 L
.68731 .42329 L
.68831 .42329 L
.68931 .42329 L
.69031 .42329 L
.69131 .42329 L
.69231 .42329 L
.69331 .42329 L
.69431 .42329 L
.6953 .42329 L
.6963 .42329 L
.6973 .42329 L
.6983 .42329 L
Mistroke
.6993 .42584 L
.7003 .42584 L
.7013 .42584 L
.7023 .42584 L
.7033 .42584 L
.7043 .42584 L
.70529 .42584 L
.70629 .42584 L
.70729 .42584 L
.70829 .42584 L
.70929 .42584 L
.71029 .42584 L
.71129 .42584 L
.71229 .42584 L
.71329 .42584 L
.71429 .42584 L
.71528 .42584 L
.71628 .42584 L
.71728 .42584 L
.71828 .42584 L
.71928 .42584 L
.72028 .42584 L
.72128 .42584 L
.72228 .42584 L
.72328 .42584 L
.72428 .42584 L
.72527 .42584 L
.72627 .42584 L
.72727 .42584 L
.72827 .42584 L
.72927 .42584 L
.73027 .42584 L
.73127 .42584 L
.73227 .42584 L
.73327 .42584 L
.73427 .42584 L
.73526 .42584 L
.73626 .42584 L
.73726 .42584 L
.73826 .42584 L
.73926 .42584 L
.74026 .42584 L
.74126 .42584 L
.74226 .42584 L
.74326 .42584 L
.74426 .42584 L
.74525 .42584 L
.74625 .42584 L
.74725 .42584 L
.74825 .42584 L
Mistroke
.74925 .42403 L
.75025 .42403 L
.75125 .42403 L
.75225 .42403 L
.75325 .42403 L
.75425 .42403 L
.75524 .42403 L
.75624 .42403 L
.75724 .42403 L
.75824 .42403 L
.75924 .42403 L
.76024 .42403 L
.76124 .42403 L
.76224 .42403 L
.76324 .42403 L
.76424 .42403 L
.76523 .42403 L
.76623 .42403 L
.76723 .42403 L
.76823 .42403 L
.76923 .42403 L
.77023 .42403 L
.77123 .42403 L
.77223 .42403 L
.77323 .42403 L
.77423 .42403 L
.77522 .42403 L
.77622 .42403 L
.77722 .42403 L
.77822 .42403 L
.77922 .42403 L
.78022 .42403 L
.78122 .42403 L
.78222 .42403 L
.78322 .42403 L
.78422 .42403 L
.78521 .42403 L
.78621 .42403 L
.78721 .42403 L
.78821 .42403 L
.78921 .42403 L
.79021 .42403 L
.79121 .42403 L
.79221 .42403 L
.79321 .42403 L
.79421 .42403 L
.7952 .42403 L
.7962 .42403 L
.7972 .42403 L
.7982 .42403 L
Mistroke
.7992 .41097 L
.8002 .41097 L
.8012 .41097 L
.8022 .41097 L
.8032 .41097 L
.8042 .41097 L
.80519 .41097 L
.80619 .41097 L
.80719 .41097 L
.80819 .41097 L
.80919 .41097 L
.81019 .41097 L
.81119 .41097 L
.81219 .41097 L
.81319 .41097 L
.81419 .41097 L
.81518 .41097 L
.81618 .41097 L
.81718 .41097 L
.81818 .41097 L
.81918 .41097 L
.82018 .41097 L
.82118 .41097 L
.82218 .41097 L
.82318 .41097 L
.82418 .41097 L
.82517 .41097 L
.82617 .41097 L
.82717 .41097 L
.82817 .41097 L
.82917 .41097 L
.83017 .41097 L
.83117 .41097 L
.83217 .41097 L
.83317 .41097 L
.83417 .41097 L
.83516 .41097 L
.83616 .41097 L
.83716 .41097 L
.83816 .41097 L
.83916 .41097 L
.84016 .41097 L
.84116 .41097 L
.84216 .41097 L
.84316 .41097 L
.84416 .41097 L
.84515 .41097 L
.84615 .41097 L
.84715 .41097 L
.84815 .41097 L
Mistroke
.84915 .41368 L
.85015 .41368 L
.85115 .41368 L
.85215 .41368 L
.85315 .41368 L
.85415 .41368 L
.85514 .41368 L
.85614 .41368 L
.85714 .41368 L
.85814 .41368 L
.85914 .41368 L
.86014 .41368 L
.86114 .41368 L
.86214 .41368 L
.86314 .41368 L
.86414 .41368 L
.86513 .41368 L
.86613 .41368 L
.86713 .41368 L
.86813 .41368 L
.86913 .41368 L
.87013 .41368 L
.87113 .41368 L
.87213 .41368 L
.87313 .41368 L
.87413 .41368 L
.87512 .41368 L
.87612 .41368 L
.87712 .41368 L
.87812 .41368 L
.87912 .41368 L
.88012 .41368 L
.88112 .41368 L
.88212 .41368 L
.88312 .41368 L
.88412 .41368 L
.88511 .41368 L
.88611 .41368 L
.88711 .41368 L
.88811 .41368 L
.88911 .41368 L
.89011 .41368 L
.89111 .41368 L
.89211 .41368 L
.89311 .41368 L
.89411 .41368 L
.8951 .41368 L
.8961 .41368 L
.8971 .41368 L
.8981 .41368 L
Mistroke
.8991 .41699 L
.9001 .41699 L
.9011 .41699 L
.9021 .41699 L
.9031 .41699 L
.9041 .41699 L
.90509 .41699 L
.90609 .41699 L
.90709 .41699 L
.90809 .41699 L
.90909 .41699 L
.91009 .41699 L
.91109 .41699 L
.91209 .41699 L
.91309 .41699 L
.91409 .41699 L
.91508 .41699 L
.91608 .41699 L
.91708 .41699 L
.91808 .41699 L
.91908 .41699 L
.92008 .41699 L
.92108 .41699 L
.92208 .41699 L
.92308 .41699 L
.92408 .41699 L
.92507 .41699 L
.92607 .41699 L
.92707 .41699 L
.92807 .41699 L
.92907 .41699 L
.93007 .41699 L
.93107 .41699 L
.93207 .41699 L
.93307 .41699 L
.93407 .41699 L
.93506 .41699 L
.93606 .41699 L
.93706 .41699 L
.93806 .41699 L
.93906 .41699 L
.94006 .41699 L
.94106 .41699 L
.94206 .41699 L
.94306 .41699 L
.94406 .41699 L
.94505 .41699 L
.94605 .41699 L
.94705 .41699 L
.94805 .41699 L
Mistroke
.94905 .41996 L
.95005 .41996 L
.95105 .41996 L
.95205 .41996 L
.95305 .41996 L
.95405 .41996 L
.95504 .41996 L
.95604 .41996 L
.95704 .41996 L
.95804 .41996 L
.95904 .41996 L
.96004 .41996 L
.96104 .41996 L
.96204 .41996 L
.96304 .41996 L
.96404 .41996 L
.96503 .41996 L
.96603 .41996 L
.96703 .41996 L
.96803 .41996 L
.96903 .41996 L
.97003 .41996 L
.97103 .41996 L
.97203 .41996 L
.97303 .41996 L
.97403 .41996 L
.97502 .41996 L
.97602 .41996 L
.97702 .41996 L
.97802 .41996 L
.97902 .41996 L
.98002 .41996 L
.98102 .41996 L
.98202 .41996 L
.98302 .41996 L
.98402 .41996 L
.98501 .41996 L
.98601 .41996 L
.98701 .41996 L
.98801 .41996 L
.98901 .41996 L
.99001 .41996 L
.99101 .41996 L
.99201 .41996 L
.99301 .41996 L
.99401 .41996 L
.995 .41996 L
.996 .41996 L
.997 .41996 L
.998 .41996 L
Mistroke
.999 .41279 L
Mfstroke
1 0 0 r
gsave
.999 .33862 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37082 m
.001 .37082 L
.002 .37082 L
.003 .37082 L
.004 .37082 L
.005 .37082 L
.00599 .37082 L
.00699 .37082 L
.00799 .37082 L
.00899 .37082 L
.00999 .37082 L
.01099 .37082 L
.01199 .37082 L
.01299 .37082 L
.01399 .37082 L
.01499 .37082 L
.01598 .37082 L
.01698 .37082 L
.01798 .37082 L
.01898 .37082 L
.01998 .37082 L
.02098 .37082 L
.02198 .37082 L
.02298 .37082 L
.02398 .37082 L
.02498 .37082 L
.02597 .37082 L
.02697 .37082 L
.02797 .37082 L
.02897 .37082 L
.02997 .37082 L
.03097 .37082 L
.03197 .37082 L
.03297 .37082 L
.03397 .37082 L
.03497 .37082 L
.03596 .37082 L
.03696 .37082 L
.03796 .37082 L
.03896 .37082 L
.03996 .37082 L
.04096 .37082 L
.04196 .37082 L
.04296 .37082 L
.04396 .37082 L
.04496 .37082 L
.04595 .37082 L
.04695 .37082 L
.04795 .37082 L
.04895 .37082 L
Mistroke
.04995 .38473 L
.05095 .38473 L
.05195 .38473 L
.05295 .38473 L
.05395 .38473 L
.05495 .38473 L
.05594 .38473 L
.05694 .38473 L
.05794 .38473 L
.05894 .38473 L
.05994 .38473 L
.06094 .38473 L
.06194 .38473 L
.06294 .38473 L
.06394 .38473 L
.06494 .38473 L
.06593 .38473 L
.06693 .38473 L
.06793 .38473 L
.06893 .38473 L
.06993 .38473 L
.07093 .38473 L
.07193 .38473 L
.07293 .38473 L
.07393 .38473 L
.07493 .38473 L
.07592 .38473 L
.07692 .38473 L
.07792 .38473 L
.07892 .38473 L
.07992 .38473 L
.08092 .38473 L
.08192 .38473 L
.08292 .38473 L
.08392 .38473 L
.08492 .38473 L
.08591 .38473 L
.08691 .38473 L
.08791 .38473 L
.08891 .38473 L
.08991 .38473 L
.09091 .38473 L
.09191 .38473 L
.09291 .38473 L
.09391 .38473 L
.09491 .38473 L
.0959 .38473 L
.0969 .38473 L
.0979 .38473 L
.0989 .38473 L
Mistroke
.0999 .41119 L
.1009 .41119 L
.1019 .41119 L
.1029 .41119 L
.1039 .41119 L
.1049 .41119 L
.10589 .41119 L
.10689 .41119 L
.10789 .41119 L
.10889 .41119 L
.10989 .41119 L
.11089 .41119 L
.11189 .41119 L
.11289 .41119 L
.11389 .41119 L
.11489 .41119 L
.11588 .41119 L
.11688 .41119 L
.11788 .41119 L
.11888 .41119 L
.11988 .41119 L
.12088 .41119 L
.12188 .41119 L
.12288 .41119 L
.12388 .41119 L
.12488 .41119 L
.12587 .41119 L
.12687 .41119 L
.12787 .41119 L
.12887 .41119 L
.12987 .41119 L
.13087 .41119 L
.13187 .41119 L
.13287 .41119 L
.13387 .41119 L
.13487 .41119 L
.13586 .41119 L
.13686 .41119 L
.13786 .41119 L
.13886 .41119 L
.13986 .41119 L
.14086 .41119 L
.14186 .41119 L
.14286 .41119 L
.14386 .41119 L
.14486 .41119 L
.14585 .41119 L
.14685 .41119 L
.14785 .41119 L
.14885 .41119 L
Mistroke
.14985 .38889 L
.15085 .38889 L
.15185 .38889 L
.15285 .38889 L
.15385 .38889 L
.15485 .38889 L
.15584 .38889 L
.15684 .38889 L
.15784 .38889 L
.15884 .38889 L
.15984 .38889 L
.16084 .38889 L
.16184 .38889 L
.16284 .38889 L
.16384 .38889 L
.16484 .38889 L
.16583 .38889 L
.16683 .38889 L
.16783 .38889 L
.16883 .38889 L
.16983 .38889 L
.17083 .38889 L
.17183 .38889 L
.17283 .38889 L
.17383 .38889 L
.17483 .38889 L
.17582 .38889 L
.17682 .38889 L
.17782 .38889 L
.17882 .38889 L
.17982 .38889 L
.18082 .38889 L
.18182 .38889 L
.18282 .38889 L
.18382 .38889 L
.18482 .38889 L
.18581 .38889 L
.18681 .38889 L
.18781 .38889 L
.18881 .38889 L
.18981 .38889 L
.19081 .38889 L
.19181 .38889 L
.19281 .38889 L
.19381 .38889 L
.19481 .38889 L
.1958 .38889 L
.1968 .38889 L
.1978 .38889 L
.1988 .38889 L
Mistroke
.1998 .3725 L
.2008 .3725 L
.2018 .3725 L
.2028 .3725 L
.2038 .3725 L
.2048 .3725 L
.20579 .3725 L
.20679 .3725 L
.20779 .3725 L
.20879 .3725 L
.20979 .3725 L
.21079 .3725 L
.21179 .3725 L
.21279 .3725 L
.21379 .3725 L
.21479 .3725 L
.21578 .3725 L
.21678 .3725 L
.21778 .3725 L
.21878 .3725 L
.21978 .3725 L
.22078 .3725 L
.22178 .3725 L
.22278 .3725 L
.22378 .3725 L
.22478 .3725 L
.22577 .3725 L
.22677 .3725 L
.22777 .3725 L
.22877 .3725 L
.22977 .3725 L
.23077 .3725 L
.23177 .3725 L
.23277 .3725 L
.23377 .3725 L
.23477 .3725 L
.23576 .3725 L
.23676 .3725 L
.23776 .3725 L
.23876 .3725 L
.23976 .3725 L
.24076 .3725 L
.24176 .3725 L
.24276 .3725 L
.24376 .3725 L
.24476 .3725 L
.24575 .3725 L
.24675 .3725 L
.24775 .3725 L
.24875 .3725 L
Mistroke
.24975 .38043 L
.25075 .38043 L
.25175 .38043 L
.25275 .38043 L
.25375 .38043 L
.25475 .38043 L
.25574 .38043 L
.25674 .38043 L
.25774 .38043 L
.25874 .38043 L
.25974 .38043 L
.26074 .38043 L
.26174 .38043 L
.26274 .38043 L
.26374 .38043 L
.26474 .38043 L
.26573 .38043 L
.26673 .38043 L
.26773 .38043 L
.26873 .38043 L
.26973 .38043 L
.27073 .38043 L
.27173 .38043 L
.27273 .38043 L
.27373 .38043 L
.27473 .38043 L
.27572 .38043 L
.27672 .38043 L
.27772 .38043 L
.27872 .38043 L
.27972 .38043 L
.28072 .38043 L
.28172 .38043 L
.28272 .38043 L
.28372 .38043 L
.28472 .38043 L
.28571 .38043 L
.28671 .38043 L
.28771 .38043 L
.28871 .38043 L
.28971 .38043 L
.29071 .38043 L
.29171 .38043 L
.29271 .38043 L
.29371 .38043 L
.29471 .38043 L
.2957 .38043 L
.2967 .38043 L
.2977 .38043 L
.2987 .38043 L
Mistroke
.2997 .38453 L
.3007 .38453 L
.3017 .38453 L
.3027 .38453 L
.3037 .38453 L
.3047 .38453 L
.30569 .38453 L
.30669 .38453 L
.30769 .38453 L
.30869 .38453 L
.30969 .38453 L
.31069 .38453 L
.31169 .38453 L
.31269 .38453 L
.31369 .38453 L
.31469 .38453 L
.31568 .38453 L
.31668 .38453 L
.31768 .38453 L
.31868 .38453 L
.31968 .38453 L
.32068 .38453 L
.32168 .38453 L
.32268 .38453 L
.32368 .38453 L
.32468 .38453 L
.32567 .38453 L
.32667 .38453 L
.32767 .38453 L
.32867 .38453 L
.32967 .38453 L
.33067 .38453 L
.33167 .38453 L
.33267 .38453 L
.33367 .38453 L
.33467 .38453 L
.33566 .38453 L
.33666 .38453 L
.33766 .38453 L
.33866 .38453 L
.33966 .38453 L
.34066 .38453 L
.34166 .38453 L
.34266 .38453 L
.34366 .38453 L
.34466 .38453 L
.34565 .38453 L
.34665 .38453 L
.34765 .38453 L
.34865 .38453 L
Mistroke
.34965 .37866 L
.35065 .37866 L
.35165 .37866 L
.35265 .37866 L
.35365 .37866 L
.35465 .37866 L
.35564 .37866 L
.35664 .37866 L
.35764 .37866 L
.35864 .37866 L
.35964 .37866 L
.36064 .37866 L
.36164 .37866 L
.36264 .37866 L
.36364 .37866 L
.36464 .37866 L
.36563 .37866 L
.36663 .37866 L
.36763 .37866 L
.36863 .37866 L
.36963 .37866 L
.37063 .37866 L
.37163 .37866 L
.37263 .37866 L
.37363 .37866 L
.37463 .37866 L
.37562 .37866 L
.37662 .37866 L
.37762 .37866 L
.37862 .37866 L
.37962 .37866 L
.38062 .37866 L
.38162 .37866 L
.38262 .37866 L
.38362 .37866 L
.38462 .37866 L
.38561 .37866 L
.38661 .37866 L
.38761 .37866 L
.38861 .37866 L
.38961 .37866 L
.39061 .37866 L
.39161 .37866 L
.39261 .37866 L
.39361 .37866 L
.39461 .37866 L
.3956 .37866 L
.3966 .37866 L
.3976 .37866 L
.3986 .37866 L
Mistroke
.3996 .36427 L
.4006 .36427 L
.4016 .36427 L
.4026 .36427 L
.4036 .36427 L
.4046 .36427 L
.40559 .36427 L
.40659 .36427 L
.40759 .36427 L
.40859 .36427 L
.40959 .36427 L
.41059 .36427 L
.41159 .36427 L
.41259 .36427 L
.41359 .36427 L
.41459 .36427 L
.41558 .36427 L
.41658 .36427 L
.41758 .36427 L
.41858 .36427 L
.41958 .36427 L
.42058 .36427 L
.42158 .36427 L
.42258 .36427 L
.42358 .36427 L
.42458 .36427 L
.42557 .36427 L
.42657 .36427 L
.42757 .36427 L
.42857 .36427 L
.42957 .36427 L
.43057 .36427 L
.43157 .36427 L
.43257 .36427 L
.43357 .36427 L
.43457 .36427 L
.43556 .36427 L
.43656 .36427 L
.43756 .36427 L
.43856 .36427 L
.43956 .36427 L
.44056 .36427 L
.44156 .36427 L
.44256 .36427 L
.44356 .36427 L
.44456 .36427 L
.44555 .36427 L
.44655 .36427 L
.44755 .36427 L
.44855 .36427 L
Mistroke
.44955 .34885 L
.45055 .34885 L
.45155 .34885 L
.45255 .34885 L
.45355 .34885 L
.45455 .34885 L
.45554 .34885 L
.45654 .34885 L
.45754 .34885 L
.45854 .34885 L
.45954 .34885 L
.46054 .34885 L
.46154 .34885 L
.46254 .34885 L
.46354 .34885 L
.46454 .34885 L
.46553 .34885 L
.46653 .34885 L
.46753 .34885 L
.46853 .34885 L
.46953 .34885 L
.47053 .34885 L
.47153 .34885 L
.47253 .34885 L
.47353 .34885 L
.47453 .34885 L
.47552 .34885 L
.47652 .34885 L
.47752 .34885 L
.47852 .34885 L
.47952 .34885 L
.48052 .34885 L
.48152 .34885 L
.48252 .34885 L
.48352 .34885 L
.48452 .34885 L
.48551 .34885 L
.48651 .34885 L
.48751 .34885 L
.48851 .34885 L
.48951 .34885 L
.49051 .34885 L
.49151 .34885 L
.49251 .34885 L
.49351 .34885 L
.49451 .34885 L
.4955 .34885 L
.4965 .34885 L
.4975 .34885 L
.4985 .34885 L
Mistroke
.4995 .34963 L
.5005 .34963 L
.5015 .34963 L
.5025 .34963 L
.5035 .34963 L
.5045 .34963 L
.50549 .34963 L
.50649 .34963 L
.50749 .34963 L
.50849 .34963 L
.50949 .34963 L
.51049 .34963 L
.51149 .34963 L
.51249 .34963 L
.51349 .34963 L
.51449 .34963 L
.51548 .34963 L
.51648 .34963 L
.51748 .34963 L
.51848 .34963 L
.51948 .34963 L
.52048 .34963 L
.52148 .34963 L
.52248 .34963 L
.52348 .34963 L
.52448 .34963 L
.52547 .34963 L
.52647 .34963 L
.52747 .34963 L
.52847 .34963 L
.52947 .34963 L
.53047 .34963 L
.53147 .34963 L
.53247 .34963 L
.53347 .34963 L
.53447 .34963 L
.53546 .34963 L
.53646 .34963 L
.53746 .34963 L
.53846 .34963 L
.53946 .34963 L
.54046 .34963 L
.54146 .34963 L
.54246 .34963 L
.54346 .34963 L
.54446 .34963 L
.54545 .34963 L
.54645 .34963 L
.54745 .34963 L
.54845 .34963 L
Mistroke
.54945 .35137 L
.55045 .35137 L
.55145 .35137 L
.55245 .35137 L
.55345 .35137 L
.55445 .35137 L
.55544 .35137 L
.55644 .35137 L
.55744 .35137 L
.55844 .35137 L
.55944 .35137 L
.56044 .35137 L
.56144 .35137 L
.56244 .35137 L
.56344 .35137 L
.56444 .35137 L
.56543 .35137 L
.56643 .35137 L
.56743 .35137 L
.56843 .35137 L
.56943 .35137 L
.57043 .35137 L
.57143 .35137 L
.57243 .35137 L
.57343 .35137 L
.57443 .35137 L
.57542 .35137 L
.57642 .35137 L
.57742 .35137 L
.57842 .35137 L
.57942 .35137 L
.58042 .35137 L
.58142 .35137 L
.58242 .35137 L
.58342 .35137 L
.58442 .35137 L
.58541 .35137 L
.58641 .35137 L
.58741 .35137 L
.58841 .35137 L
.58941 .35137 L
.59041 .35137 L
.59141 .35137 L
.59241 .35137 L
.59341 .35137 L
.59441 .35137 L
.5954 .35137 L
.5964 .35137 L
.5974 .35137 L
.5984 .35137 L
Mistroke
.5994 .32716 L
.6004 .32716 L
.6014 .32716 L
.6024 .32716 L
.6034 .32716 L
.6044 .32716 L
.60539 .32716 L
.60639 .32716 L
.60739 .32716 L
.60839 .32716 L
.60939 .32716 L
.61039 .32716 L
.61139 .32716 L
.61239 .32716 L
.61339 .32716 L
.61439 .32716 L
.61538 .32716 L
.61638 .32716 L
.61738 .32716 L
.61838 .32716 L
.61938 .32716 L
.62038 .32716 L
.62138 .32716 L
.62238 .32716 L
.62338 .32716 L
.62438 .32716 L
.62537 .32716 L
.62637 .32716 L
.62737 .32716 L
.62837 .32716 L
.62937 .32716 L
.63037 .32716 L
.63137 .32716 L
.63237 .32716 L
.63337 .32716 L
.63437 .32716 L
.63536 .32716 L
.63636 .32716 L
.63736 .32716 L
.63836 .32716 L
.63936 .32716 L
.64036 .32716 L
.64136 .32716 L
.64236 .32716 L
.64336 .32716 L
.64436 .32716 L
.64535 .32716 L
.64635 .32716 L
.64735 .32716 L
.64835 .32716 L
Mistroke
.64935 .34094 L
.65035 .34094 L
.65135 .34094 L
.65235 .34094 L
.65335 .34094 L
.65435 .34094 L
.65534 .34094 L
.65634 .34094 L
.65734 .34094 L
.65834 .34094 L
.65934 .34094 L
.66034 .34094 L
.66134 .34094 L
.66234 .34094 L
.66334 .34094 L
.66434 .34094 L
.66533 .34094 L
.66633 .34094 L
.66733 .34094 L
.66833 .34094 L
.66933 .34094 L
.67033 .34094 L
.67133 .34094 L
.67233 .34094 L
.67333 .34094 L
.67433 .34094 L
.67532 .34094 L
.67632 .34094 L
.67732 .34094 L
.67832 .34094 L
.67932 .34094 L
.68032 .34094 L
.68132 .34094 L
.68232 .34094 L
.68332 .34094 L
.68432 .34094 L
.68531 .34094 L
.68631 .34094 L
.68731 .34094 L
.68831 .34094 L
.68931 .34094 L
.69031 .34094 L
.69131 .34094 L
.69231 .34094 L
.69331 .34094 L
.69431 .34094 L
.6953 .34094 L
.6963 .34094 L
.6973 .34094 L
.6983 .34094 L
Mistroke
.6993 .34513 L
.7003 .34513 L
.7013 .34513 L
.7023 .34513 L
.7033 .34513 L
.7043 .34513 L
.70529 .34513 L
.70629 .34513 L
.70729 .34513 L
.70829 .34513 L
.70929 .34513 L
.71029 .34513 L
.71129 .34513 L
.71229 .34513 L
.71329 .34513 L
.71429 .34513 L
.71528 .34513 L
.71628 .34513 L
.71728 .34513 L
.71828 .34513 L
.71928 .34513 L
.72028 .34513 L
.72128 .34513 L
.72228 .34513 L
.72328 .34513 L
.72428 .34513 L
.72527 .34513 L
.72627 .34513 L
.72727 .34513 L
.72827 .34513 L
.72927 .34513 L
.73027 .34513 L
.73127 .34513 L
.73227 .34513 L
.73327 .34513 L
.73427 .34513 L
.73526 .34513 L
.73626 .34513 L
.73726 .34513 L
.73826 .34513 L
.73926 .34513 L
.74026 .34513 L
.74126 .34513 L
.74226 .34513 L
.74326 .34513 L
.74426 .34513 L
.74525 .34513 L
.74625 .34513 L
.74725 .34513 L
.74825 .34513 L
Mistroke
.74925 .34352 L
.75025 .34352 L
.75125 .34352 L
.75225 .34352 L
.75325 .34352 L
.75425 .34352 L
.75524 .34352 L
.75624 .34352 L
.75724 .34352 L
.75824 .34352 L
.75924 .34352 L
.76024 .34352 L
.76124 .34352 L
.76224 .34352 L
.76324 .34352 L
.76424 .34352 L
.76523 .34352 L
.76623 .34352 L
.76723 .34352 L
.76823 .34352 L
.76923 .34352 L
.77023 .34352 L
.77123 .34352 L
.77223 .34352 L
.77323 .34352 L
.77423 .34352 L
.77522 .34352 L
.77622 .34352 L
.77722 .34352 L
.77822 .34352 L
.77922 .34352 L
.78022 .34352 L
.78122 .34352 L
.78222 .34352 L
.78322 .34352 L
.78422 .34352 L
.78521 .34352 L
.78621 .34352 L
.78721 .34352 L
.78821 .34352 L
.78921 .34352 L
.79021 .34352 L
.79121 .34352 L
.79221 .34352 L
.79321 .34352 L
.79421 .34352 L
.7952 .34352 L
.7962 .34352 L
.7972 .34352 L
.7982 .34352 L
Mistroke
.7992 .3322 L
.8002 .3322 L
.8012 .3322 L
.8022 .3322 L
.8032 .3322 L
.8042 .3322 L
.80519 .3322 L
.80619 .3322 L
.80719 .3322 L
.80819 .3322 L
.80919 .3322 L
.81019 .3322 L
.81119 .3322 L
.81219 .3322 L
.81319 .3322 L
.81419 .3322 L
.81518 .3322 L
.81618 .3322 L
.81718 .3322 L
.81818 .3322 L
.81918 .3322 L
.82018 .3322 L
.82118 .3322 L
.82218 .3322 L
.82318 .3322 L
.82418 .3322 L
.82517 .3322 L
.82617 .3322 L
.82717 .3322 L
.82817 .3322 L
.82917 .3322 L
.83017 .3322 L
.83117 .3322 L
.83217 .3322 L
.83317 .3322 L
.83417 .3322 L
.83516 .3322 L
.83616 .3322 L
.83716 .3322 L
.83816 .3322 L
.83916 .3322 L
.84016 .3322 L
.84116 .3322 L
.84216 .3322 L
.84316 .3322 L
.84416 .3322 L
.84515 .3322 L
.84615 .3322 L
.84715 .3322 L
.84815 .3322 L
Mistroke
.84915 .33509 L
.85015 .33509 L
.85115 .33509 L
.85215 .33509 L
.85315 .33509 L
.85415 .33509 L
.85514 .33509 L
.85614 .33509 L
.85714 .33509 L
.85814 .33509 L
.85914 .33509 L
.86014 .33509 L
.86114 .33509 L
.86214 .33509 L
.86314 .33509 L
.86414 .33509 L
.86513 .33509 L
.86613 .33509 L
.86713 .33509 L
.86813 .33509 L
.86913 .33509 L
.87013 .33509 L
.87113 .33509 L
.87213 .33509 L
.87313 .33509 L
.87413 .33509 L
.87512 .33509 L
.87612 .33509 L
.87712 .33509 L
.87812 .33509 L
.87912 .33509 L
.88012 .33509 L
.88112 .33509 L
.88212 .33509 L
.88312 .33509 L
.88412 .33509 L
.88511 .33509 L
.88611 .33509 L
.88711 .33509 L
.88811 .33509 L
.88911 .33509 L
.89011 .33509 L
.89111 .33509 L
.89211 .33509 L
.89311 .33509 L
.89411 .33509 L
.8951 .33509 L
.8961 .33509 L
.8971 .33509 L
.8981 .33509 L
Mistroke
.8991 .33904 L
.9001 .33904 L
.9011 .33904 L
.9021 .33904 L
.9031 .33904 L
.9041 .33904 L
.90509 .33904 L
.90609 .33904 L
.90709 .33904 L
.90809 .33904 L
.90909 .33904 L
.91009 .33904 L
.91109 .33904 L
.91209 .33904 L
.91309 .33904 L
.91409 .33904 L
.91508 .33904 L
.91608 .33904 L
.91708 .33904 L
.91808 .33904 L
.91908 .33904 L
.92008 .33904 L
.92108 .33904 L
.92208 .33904 L
.92308 .33904 L
.92408 .33904 L
.92507 .33904 L
.92607 .33904 L
.92707 .33904 L
.92807 .33904 L
.92907 .33904 L
.93007 .33904 L
.93107 .33904 L
.93207 .33904 L
.93307 .33904 L
.93407 .33904 L
.93506 .33904 L
.93606 .33904 L
.93706 .33904 L
.93806 .33904 L
.93906 .33904 L
.94006 .33904 L
.94106 .33904 L
.94206 .33904 L
.94306 .33904 L
.94406 .33904 L
.94505 .33904 L
.94605 .33904 L
.94705 .33904 L
.94805 .33904 L
Mistroke
.94905 .34293 L
.95005 .34293 L
.95105 .34293 L
.95205 .34293 L
.95305 .34293 L
.95405 .34293 L
.95504 .34293 L
.95604 .34293 L
.95704 .34293 L
.95804 .34293 L
.95904 .34293 L
.96004 .34293 L
.96104 .34293 L
.96204 .34293 L
.96304 .34293 L
.96404 .34293 L
.96503 .34293 L
.96603 .34293 L
.96703 .34293 L
.96803 .34293 L
.96903 .34293 L
.97003 .34293 L
.97103 .34293 L
.97203 .34293 L
.97303 .34293 L
.97403 .34293 L
.97502 .34293 L
.97602 .34293 L
.97702 .34293 L
.97802 .34293 L
.97902 .34293 L
.98002 .34293 L
.98102 .34293 L
.98202 .34293 L
.98302 .34293 L
.98402 .34293 L
.98501 .34293 L
.98601 .34293 L
.98701 .34293 L
.98801 .34293 L
.98901 .34293 L
.99001 .34293 L
.99101 .34293 L
.99201 .34293 L
.99301 .34293 L
.99401 .34293 L
.995 .34293 L
.996 .34293 L
.997 .34293 L
.998 .34293 L
Mistroke
.999 .33862 L
Mfstroke
0 0 1 r
gsave
.001 -0.61803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 -1.54508 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(26)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(28)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(32)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(34)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .18541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .18541 L
.05095 .18541 L
.05195 .18541 L
.05295 .18541 L
.05395 .18541 L
.05495 .18541 L
.05594 .18541 L
.05694 .18541 L
.05794 .18541 L
.05894 .18541 L
.05994 .18541 L
.06094 .18541 L
.06194 .18541 L
.06294 .18541 L
.06394 .18541 L
.06494 .18541 L
.06593 .18541 L
.06693 .18541 L
.06793 .18541 L
.06893 .18541 L
.06993 .18541 L
.07093 .18541 L
.07193 .18541 L
.07293 .18541 L
.07393 .18541 L
.07493 .18541 L
.07592 .18541 L
.07692 .18541 L
.07792 .18541 L
.07892 .18541 L
.07992 .18541 L
.08092 .18541 L
.08192 .18541 L
.08292 .18541 L
.08392 .18541 L
.08492 .18541 L
.08591 .18541 L
.08691 .18541 L
.08791 .18541 L
.08891 .18541 L
.08991 .18541 L
.09091 .18541 L
.09191 .18541 L
.09291 .18541 L
.09391 .18541 L
.09491 .18541 L
.0959 .18541 L
.0969 .18541 L
.0979 .18541 L
.0989 .18541 L
Mistroke
.0999 .18541 L
.1009 .18541 L
.1019 .18541 L
.1029 .18541 L
.1039 .18541 L
.1049 .18541 L
.10589 .18541 L
.10689 .18541 L
.10789 .18541 L
.10889 .18541 L
.10989 .18541 L
.11089 .18541 L
.11189 .18541 L
.11289 .18541 L
.11389 .18541 L
.11489 .18541 L
.11588 .18541 L
.11688 .18541 L
.11788 .18541 L
.11888 .18541 L
.11988 .18541 L
.12088 .18541 L
.12188 .18541 L
.12288 .18541 L
.12388 .18541 L
.12488 .18541 L
.12587 .18541 L
.12687 .18541 L
.12787 .18541 L
.12887 .18541 L
.12987 .18541 L
.13087 .18541 L
.13187 .18541 L
.13287 .18541 L
.13387 .18541 L
.13487 .18541 L
.13586 .18541 L
.13686 .18541 L
.13786 .18541 L
.13886 .18541 L
.13986 .18541 L
.14086 .18541 L
.14186 .18541 L
.14286 .18541 L
.14386 .18541 L
.14486 .18541 L
.14585 .18541 L
.14685 .18541 L
.14785 .18541 L
.14885 .18541 L
Mistroke
.14985 .18541 L
.15085 .18541 L
.15185 .18541 L
.15285 .18541 L
.15385 .18541 L
.15485 .18541 L
.15584 .18541 L
.15684 .18541 L
.15784 .18541 L
.15884 .18541 L
.15984 .18541 L
.16084 .18541 L
.16184 .18541 L
.16284 .18541 L
.16384 .18541 L
.16484 .18541 L
.16583 .18541 L
.16683 .18541 L
.16783 .18541 L
.16883 .18541 L
.16983 .18541 L
.17083 .18541 L
.17183 .18541 L
.17283 .18541 L
.17383 .18541 L
.17483 .18541 L
.17582 .18541 L
.17682 .18541 L
.17782 .18541 L
.17882 .18541 L
.17982 .18541 L
.18082 .18541 L
.18182 .18541 L
.18282 .18541 L
.18382 .18541 L
.18482 .18541 L
.18581 .18541 L
.18681 .18541 L
.18781 .18541 L
.18881 .18541 L
.18981 .18541 L
.19081 .18541 L
.19181 .18541 L
.19281 .18541 L
.19381 .18541 L
.19481 .18541 L
.1958 .18541 L
.1968 .18541 L
.1978 .18541 L
.1988 .18541 L
Mistroke
.1998 .18541 L
.2008 .18541 L
.2018 .18541 L
.2028 .18541 L
.2038 .18541 L
.2048 .18541 L
.20579 .18541 L
.20679 .18541 L
.20779 .18541 L
.20879 .18541 L
.20979 .18541 L
.21079 .18541 L
.21179 .18541 L
.21279 .18541 L
.21379 .18541 L
.21479 .18541 L
.21578 .18541 L
.21678 .18541 L
.21778 .18541 L
.21878 .18541 L
.21978 .18541 L
.22078 .18541 L
.22178 .18541 L
.22278 .18541 L
.22378 .18541 L
.22478 .18541 L
.22577 .18541 L
.22677 .18541 L
.22777 .18541 L
.22877 .18541 L
.22977 .18541 L
.23077 .18541 L
.23177 .18541 L
.23277 .18541 L
.23377 .18541 L
.23477 .18541 L
.23576 .18541 L
.23676 .18541 L
.23776 .18541 L
.23876 .18541 L
.23976 .18541 L
.24076 .18541 L
.24176 .18541 L
.24276 .18541 L
.24376 .18541 L
.24476 .18541 L
.24575 .18541 L
.24675 .18541 L
.24775 .18541 L
.24875 .18541 L
Mistroke
.24975 .18541 L
.25075 .18541 L
.25175 .18541 L
.25275 .18542 L
.25375 .18541 L
.25475 .18542 L
.25574 .18542 L
.25674 .18542 L
.25774 .18542 L
.25874 .18542 L
.25974 .18542 L
.26074 .18542 L
.26174 .18542 L
.26274 .18542 L
.26374 .18542 L
.26474 .18542 L
.26573 .18542 L
.26673 .18542 L
.26773 .18542 L
.26873 .18542 L
.26973 .18542 L
.27073 .18542 L
.27173 .18542 L
.27273 .18542 L
.27373 .18542 L
.27473 .18542 L
.27572 .18542 L
.27672 .18542 L
.27772 .18542 L
.27872 .18542 L
.27972 .18542 L
.28072 .18542 L
.28172 .18542 L
.28272 .18542 L
.28372 .18542 L
.28472 .18542 L
.28571 .18542 L
.28671 .18542 L
.28771 .18542 L
.28871 .18542 L
.28971 .18542 L
.29071 .18542 L
.29171 .18542 L
.29271 .18542 L
.29371 .18542 L
.29471 .18541 L
.2957 .18542 L
.2967 .18542 L
.2977 .18541 L
.2987 .18541 L
Mistroke
.2997 .18541 L
.3007 .18541 L
.3017 .18541 L
.3027 .18541 L
.3037 .18542 L
.3047 .18542 L
.30569 .18542 L
.30669 .18542 L
.30769 .18541 L
.30869 .18541 L
.30969 .18541 L
.31069 .18541 L
.31169 .18541 L
.31269 .18541 L
.31369 .18541 L
.31469 .18541 L
.31568 .18541 L
.31668 .18541 L
.31768 .18541 L
.31868 .18541 L
.31968 .18541 L
.32068 .18541 L
.32168 .18541 L
.32268 .18541 L
.32368 .18541 L
.32468 .18542 L
.32567 .18542 L
.32667 .18542 L
.32767 .18542 L
.32867 .18542 L
.32967 .18542 L
.33067 .18542 L
.33167 .18542 L
.33267 .18542 L
.33367 .18542 L
.33467 .18542 L
.33566 .18542 L
.33666 .18542 L
.33766 .18542 L
.33866 .18542 L
.33966 .18541 L
.34066 .18541 L
.34166 .18541 L
.34266 .18541 L
.34366 .18541 L
.34466 .18541 L
.34565 .18541 L
.34665 .18541 L
.34765 .18541 L
.34865 .18541 L
Mistroke
.34965 .18541 L
.35065 .18541 L
.35165 .18541 L
.35265 .18541 L
.35365 .18541 L
.35465 .18541 L
.35564 .18541 L
.35664 .18541 L
.35764 .18541 L
.35864 .18541 L
.35964 .18541 L
.36064 .18541 L
.36164 .18541 L
.36264 .18541 L
.36364 .18541 L
.36464 .18541 L
.36563 .18541 L
.36663 .18541 L
.36763 .18541 L
.36863 .18541 L
.36963 .18542 L
.37063 .18542 L
.37163 .18542 L
.37263 .18541 L
.37363 .18541 L
.37463 .18542 L
.37562 .18542 L
.37662 .18542 L
.37762 .18542 L
.37862 .18542 L
.37962 .18541 L
.38062 .18542 L
.38162 .18542 L
.38262 .18542 L
.38362 .18542 L
.38462 .18541 L
.38561 .18541 L
.38661 .18541 L
.38761 .18541 L
.38861 .18541 L
.38961 .18541 L
.39061 .18541 L
.39161 .18541 L
.39261 .18542 L
.39361 .18541 L
.39461 .18541 L
.3956 .18541 L
.3966 .18541 L
.3976 .18541 L
.3986 .18542 L
Mistroke
.3996 .18542 L
.4006 .18542 L
.4016 .18542 L
.4026 .18542 L
.4036 .18542 L
.4046 .18542 L
.40559 .18542 L
.40659 .18542 L
.40759 .18542 L
.40859 .18542 L
.40959 .18542 L
.41059 .18542 L
.41159 .18542 L
.41259 .18542 L
.41359 .18542 L
.41459 .18542 L
.41558 .18542 L
.41658 .18542 L
.41758 .18542 L
.41858 .18542 L
.41958 .18542 L
.42058 .18541 L
.42158 .18541 L
.42258 .18542 L
.42358 .18542 L
.42458 .18542 L
.42557 .18542 L
.42657 .18542 L
.42757 .18542 L
.42857 .18542 L
.42957 .18542 L
.43057 .18541 L
.43157 .18541 L
.43257 .18542 L
.43357 .18542 L
.43457 .18541 L
.43556 .18541 L
.43656 .18541 L
.43756 .18542 L
.43856 .18541 L
.43956 .18541 L
.44056 .18542 L
.44156 .18542 L
.44256 .18542 L
.44356 .18542 L
.44456 .18542 L
.44555 .18542 L
.44655 .18542 L
.44755 .18542 L
.44855 .18542 L
Mistroke
.44955 .18542 L
.45055 .18542 L
.45155 .18542 L
.45255 .18542 L
.45355 .18542 L
.45455 .18542 L
.45554 .18542 L
.45654 .18542 L
.45754 .18542 L
.45854 .18542 L
.45954 .18542 L
.46054 .18542 L
.46154 .18542 L
.46254 .18542 L
.46354 .18542 L
.46454 .18542 L
.46553 .18542 L
.46653 .18542 L
.46753 .18542 L
.46853 .18542 L
.46953 .18542 L
.47053 .18542 L
.47153 .18542 L
.47253 .18542 L
.47353 .18542 L
.47453 .18542 L
.47552 .18542 L
.47652 .18542 L
.47752 .18542 L
.47852 .18542 L
.47952 .18542 L
.48052 .18542 L
.48152 .18542 L
.48252 .18542 L
.48352 .18542 L
.48452 .18542 L
.48551 .18542 L
.48651 .18542 L
.48751 .18542 L
.48851 .18542 L
.48951 .18542 L
.49051 .18542 L
.49151 .18542 L
.49251 .18542 L
.49351 .18542 L
.49451 .18542 L
.4955 .18542 L
.4965 .18542 L
.4975 .18542 L
.4985 .18542 L
Mistroke
.4995 .18542 L
.5005 .18542 L
.5015 .18542 L
.5025 .18542 L
.5035 .18542 L
.5045 .18542 L
.50549 .18542 L
.50649 .18542 L
.50749 .18542 L
.50849 .18542 L
.50949 .18542 L
.51049 .18542 L
.51149 .18542 L
.51249 .18542 L
.51349 .18542 L
.51449 .18542 L
.51548 .18542 L
.51648 .18542 L
.51748 .18542 L
.51848 .18542 L
.51948 .18542 L
.52048 .18542 L
.52148 .18542 L
.52248 .18542 L
.52348 .18542 L
.52448 .18542 L
.52547 .18542 L
.52647 .18542 L
.52747 .18542 L
.52847 .18542 L
.52947 .18542 L
.53047 .18542 L
.53147 .18542 L
.53247 .18543 L
.53347 .18542 L
.53447 .18542 L
.53546 .18542 L
.53646 .18542 L
.53746 .18542 L
.53846 .18542 L
.53946 .18542 L
.54046 .18542 L
.54146 .18542 L
.54246 .18542 L
.54346 .18542 L
.54446 .18542 L
.54545 .18542 L
.54645 .18542 L
.54745 .18542 L
.54845 .18542 L
Mistroke
.54945 .18542 L
.55045 .18542 L
.55145 .18542 L
.55245 .18542 L
.55345 .18542 L
.55445 .18542 L
.55544 .18542 L
.55644 .18542 L
.55744 .18542 L
.55844 .18542 L
.55944 .18542 L
.56044 .18542 L
.56144 .18542 L
.56244 .18542 L
.56344 .18542 L
.56444 .18542 L
.56543 .18542 L
.56643 .18542 L
.56743 .18542 L
.56843 .18542 L
.56943 .18542 L
.57043 .18542 L
.57143 .18543 L
.57243 .18543 L
.57343 .18543 L
.57443 .18543 L
.57542 .18543 L
.57642 .18543 L
.57742 .18543 L
.57842 .18543 L
.57942 .18543 L
.58042 .18542 L
.58142 .18543 L
.58242 .18542 L
.58342 .18543 L
.58442 .18542 L
.58541 .18543 L
.58641 .18543 L
.58741 .18543 L
.58841 .18543 L
.58941 .18542 L
.59041 .18542 L
.59141 .18542 L
.59241 .18543 L
.59341 .18543 L
.59441 .18543 L
.5954 .18543 L
.5964 .18543 L
.5974 .18543 L
.5984 .18542 L
Mistroke
.5994 .18542 L
.6004 .18542 L
.6014 .18542 L
.6024 .18542 L
.6034 .18543 L
.6044 .18542 L
.60539 .18542 L
.60639 .18542 L
.60739 .18542 L
.60839 .18542 L
.60939 .18542 L
.61039 .18542 L
.61139 .18542 L
.61239 .18542 L
.61339 .18542 L
.61439 .18542 L
.61538 .18542 L
.61638 .18542 L
.61738 .18542 L
.61838 .18542 L
.61938 .18542 L
.62038 .18543 L
.62138 .18543 L
.62238 .18543 L
.62338 .18543 L
.62438 .18543 L
.62537 .18543 L
.62637 .18543 L
.62737 .18543 L
.62837 .18543 L
.62937 .18543 L
.63037 .18543 L
.63137 .18543 L
.63237 .18543 L
.63337 .18543 L
.63437 .18543 L
.63536 .18543 L
.63636 .18543 L
.63736 .18543 L
.63836 .18543 L
.63936 .18543 L
.64036 .18543 L
.64136 .18543 L
.64236 .18543 L
.64336 .18543 L
.64436 .18543 L
.64535 .18543 L
.64635 .18543 L
.64735 .18543 L
.64835 .18543 L
Mistroke
.64935 .18543 L
.65035 .18543 L
.65135 .18543 L
.65235 .18543 L
.65335 .18543 L
.65435 .18543 L
.65534 .18543 L
.65634 .18543 L
.65734 .18543 L
.65834 .18543 L
.65934 .18543 L
.66034 .18543 L
.66134 .18543 L
.66234 .18543 L
.66334 .18543 L
.66434 .18543 L
.66533 .18543 L
.66633 .18543 L
.66733 .18543 L
.66833 .18543 L
.66933 .18543 L
.67033 .18543 L
.67133 .18543 L
.67233 .18543 L
.67333 .18543 L
.67433 .18543 L
.67532 .18543 L
.67632 .18543 L
.67732 .18543 L
.67832 .18543 L
.67932 .18543 L
.68032 .18543 L
.68132 .18543 L
.68232 .18543 L
.68332 .18543 L
.68432 .18543 L
.68531 .18543 L
.68631 .18543 L
.68731 .18543 L
.68831 .18543 L
.68931 .18543 L
.69031 .18543 L
.69131 .18543 L
.69231 .18543 L
.69331 .18543 L
.69431 .18543 L
.6953 .18543 L
.6963 .18543 L
.6973 .18543 L
.6983 .18543 L
Mistroke
.6993 .18543 L
.7003 .18543 L
.7013 .18543 L
.7023 .18543 L
.7033 .18543 L
.7043 .18543 L
.70529 .18543 L
.70629 .18543 L
.70729 .18543 L
.70829 .18543 L
.70929 .18543 L
.71029 .18543 L
.71129 .18543 L
.71229 .18543 L
.71329 .18543 L
.71429 .18543 L
.71528 .18543 L
.71628 .18543 L
.71728 .18543 L
.71828 .18543 L
.71928 .18543 L
.72028 .18543 L
.72128 .18543 L
.72228 .18543 L
.72328 .18543 L
.72428 .18543 L
.72527 .18543 L
.72627 .18543 L
.72727 .18543 L
.72827 .18543 L
.72927 .18543 L
.73027 .18542 L
.73127 .18542 L
.73227 .18542 L
.73327 .18542 L
.73427 .18542 L
.73526 .18542 L
.73626 .18542 L
.73726 .18542 L
.73826 .18542 L
.73926 .18542 L
.74026 .18542 L
.74126 .18542 L
.74226 .18542 L
.74326 .18542 L
.74426 .18542 L
.74525 .18542 L
.74625 .18542 L
.74725 .18542 L
.74825 .18542 L
Mistroke
.74925 .18542 L
.75025 .18542 L
.75125 .18542 L
.75225 .18542 L
.75325 .18542 L
.75425 .18542 L
.75524 .18542 L
.75624 .18542 L
.75724 .18542 L
.75824 .18542 L
.75924 .18542 L
.76024 .18542 L
.76124 .18542 L
.76224 .18542 L
.76324 .18542 L
.76424 .18542 L
.76523 .18542 L
.76623 .18542 L
.76723 .18542 L
.76823 .18542 L
.76923 .18542 L
.77023 .18542 L
.77123 .18542 L
.77223 .18542 L
.77323 .18542 L
.77423 .18542 L
.77522 .18542 L
.77622 .18541 L
.77722 .18541 L
.77822 .18541 L
.77922 .18541 L
.78022 .18541 L
.78122 .18541 L
.78222 .18541 L
.78322 .18541 L
.78422 .18541 L
.78521 .18541 L
.78621 .18541 L
.78721 .18541 L
.78821 .18541 L
.78921 .18541 L
.79021 .18541 L
.79121 .18541 L
.79221 .18541 L
.79321 .18541 L
.79421 .18541 L
.7952 .18542 L
.7962 .18542 L
.7972 .18542 L
.7982 .18542 L
Mistroke
.7992 .18542 L
.8002 .18542 L
.8012 .18541 L
.8022 .18541 L
.8032 .18541 L
.8042 .18541 L
.80519 .18541 L
.80619 .18541 L
.80719 .18541 L
.80819 .18541 L
.80919 .18541 L
.81019 .18541 L
.81119 .18541 L
.81219 .18542 L
.81319 .18542 L
.81419 .18541 L
.81518 .18542 L
.81618 .18542 L
.81718 .18542 L
.81818 .18542 L
.81918 .18542 L
.82018 .18542 L
.82118 .18542 L
.82218 .18542 L
.82318 .18541 L
.82418 .18541 L
.82517 .18541 L
.82617 .18541 L
.82717 .18541 L
.82817 .18541 L
.82917 .18541 L
.83017 .18541 L
.83117 .18541 L
.83217 .18541 L
.83317 .18541 L
.83417 .18541 L
.83516 .18541 L
.83616 .18541 L
.83716 .18541 L
.83816 .18541 L
.83916 .18541 L
.84016 .18541 L
.84116 .18541 L
.84216 .18541 L
.84316 .18541 L
.84416 .18541 L
.84515 .18541 L
.84615 .18541 L
.84715 .18541 L
.84815 .18541 L
Mistroke
.84915 .18541 L
.85015 .18541 L
.85115 .18541 L
.85215 .18541 L
.85315 .18541 L
.85415 .18541 L
.85514 .18541 L
.85614 .18541 L
.85714 .18541 L
.85814 .18541 L
.85914 .18541 L
.86014 .18541 L
.86114 .18541 L
.86214 .18541 L
.86314 .18541 L
.86414 .18541 L
.86513 .18541 L
.86613 .18541 L
.86713 .18541 L
.86813 .18541 L
.86913 .18541 L
.87013 .18541 L
.87113 .18541 L
.87213 .18541 L
.87313 .18541 L
.87413 .18541 L
.87512 .18541 L
.87612 .18541 L
.87712 .18541 L
.87812 .18541 L
.87912 .18542 L
.88012 .18542 L
.88112 .18542 L
.88212 .18542 L
.88312 .18542 L
.88412 .18542 L
.88511 .18542 L
.88611 .18542 L
.88711 .18542 L
.88811 .18542 L
.88911 .18542 L
.89011 .18541 L
.89111 .18541 L
.89211 .18541 L
.89311 .18541 L
.89411 .18541 L
.8951 .18541 L
.8961 .18541 L
.8971 .18541 L
.8981 .18541 L
Mistroke
.8991 .18541 L
.9001 .18541 L
.9011 .18542 L
.9021 .18542 L
.9031 .18542 L
.9041 .18542 L
.90509 .18542 L
.90609 .18542 L
.90709 .18542 L
.90809 .18542 L
.90909 .18542 L
.91009 .18542 L
.91109 .18542 L
.91209 .18542 L
.91309 .18542 L
.91409 .18542 L
.91508 .18542 L
.91608 .18542 L
.91708 .18542 L
.91808 .18542 L
.91908 .18542 L
.92008 .18542 L
.92108 .18542 L
.92208 .18542 L
.92308 .18542 L
.92408 .18542 L
.92507 .18542 L
.92607 .18542 L
.92707 .18542 L
.92807 .18542 L
.92907 .18542 L
.93007 .18542 L
.93107 .18542 L
.93207 .18542 L
.93307 .18542 L
.93407 .18542 L
.93506 .18542 L
.93606 .18542 L
.93706 .18542 L
.93806 .18542 L
.93906 .18542 L
.94006 .18542 L
.94106 .18542 L
.94206 .18542 L
.94306 .18542 L
.94406 .18542 L
.94505 .18542 L
.94605 .18542 L
.94705 .18542 L
.94805 .18542 L
Mistroke
.94905 .18542 L
.95005 .18542 L
.95105 .18542 L
.95205 .18542 L
.95305 .18542 L
.95405 .18542 L
.95504 .18542 L
.95604 .18541 L
.95704 .18542 L
.95804 .18542 L
.95904 .18542 L
.96004 .18542 L
.96104 .18542 L
.96204 .18542 L
.96304 .18542 L
.96404 .18542 L
.96503 .18542 L
.96603 .18542 L
.96703 .18541 L
.96803 .18541 L
.96903 .18541 L
.97003 .18541 L
.97103 .18541 L
.97203 .18541 L
.97303 .18541 L
.97403 .18541 L
.97502 .18541 L
.97602 .18541 L
.97702 .18541 L
.97802 .18541 L
.97902 .18541 L
.98002 .18541 L
.98102 .18541 L
.98202 .18541 L
.98302 .18541 L
.98402 .18541 L
.98501 .18541 L
.98601 .18541 L
.98701 .18541 L
.98801 .18541 L
.98901 .18541 L
.99001 .18541 L
.99101 .18541 L
.99201 .18541 L
.99301 .18541 L
.99401 .18541 L
.995 .18541 L
.996 .18541 L
.997 .18541 L
.998 .18541 L
Mistroke
.999 .18541 L
Mfstroke
0 .98 .604 r
gsave
.999 .15755 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .12608 m
.001 .12608 L
.002 .12608 L
.003 .12608 L
.004 .12608 L
.005 .12608 L
.00599 .12608 L
.00699 .12608 L
.00799 .12608 L
.00899 .12608 L
.00999 .12608 L
.01099 .12608 L
.01199 .12608 L
.01299 .12608 L
.01399 .12608 L
.01499 .12608 L
.01598 .12608 L
.01698 .12608 L
.01798 .12608 L
.01898 .12608 L
.01998 .12608 L
.02098 .12608 L
.02198 .12608 L
.02298 .12608 L
.02398 .12608 L
.02498 .12608 L
.02597 .12608 L
.02697 .12608 L
.02797 .12608 L
.02897 .12608 L
.02997 .12608 L
.03097 .12608 L
.03197 .12608 L
.03297 .12608 L
.03397 .12608 L
.03497 .12608 L
.03596 .12608 L
.03696 .12608 L
.03796 .12608 L
.03896 .12608 L
.03996 .12608 L
.04096 .12608 L
.04196 .12608 L
.04296 .12608 L
.04396 .12608 L
.04496 .12608 L
.04595 .12608 L
.04695 .12608 L
.04795 .12608 L
.04895 .12608 L
Mistroke
.04995 .12432 L
.05095 .12432 L
.05195 .12432 L
.05295 .12432 L
.05395 .12432 L
.05495 .12432 L
.05594 .12432 L
.05694 .12432 L
.05794 .12432 L
.05894 .12432 L
.05994 .12432 L
.06094 .12432 L
.06194 .12432 L
.06294 .12432 L
.06394 .12432 L
.06494 .12432 L
.06593 .12432 L
.06693 .12432 L
.06793 .12432 L
.06893 .12432 L
.06993 .12432 L
.07093 .12432 L
.07193 .12432 L
.07293 .12432 L
.07393 .12432 L
.07493 .12432 L
.07592 .12432 L
.07692 .12432 L
.07792 .12432 L
.07892 .12432 L
.07992 .12432 L
.08092 .12432 L
.08192 .12432 L
.08292 .12432 L
.08392 .12432 L
.08492 .12432 L
.08591 .12432 L
.08691 .12432 L
.08791 .12432 L
.08891 .12432 L
.08991 .12432 L
.09091 .12432 L
.09191 .12432 L
.09291 .12432 L
.09391 .12432 L
.09491 .12432 L
.0959 .12432 L
.0969 .12432 L
.0979 .12432 L
.0989 .12432 L
Mistroke
.0999 .08782 L
.1009 .08782 L
.1019 .08782 L
.1029 .08782 L
.1039 .08782 L
.1049 .08782 L
.10589 .08782 L
.10689 .08782 L
.10789 .08782 L
.10889 .08782 L
.10989 .08782 L
.11089 .08782 L
.11189 .08782 L
.11289 .08782 L
.11389 .08782 L
.11489 .08782 L
.11588 .08782 L
.11688 .08782 L
.11788 .08782 L
.11888 .08782 L
.11988 .08782 L
.12088 .08782 L
.12188 .08782 L
.12288 .08782 L
.12388 .08782 L
.12488 .08782 L
.12587 .08782 L
.12687 .08782 L
.12787 .08782 L
.12887 .08782 L
.12987 .08782 L
.13087 .08782 L
.13187 .08782 L
.13287 .08782 L
.13387 .08782 L
.13487 .08782 L
.13586 .08782 L
.13686 .08782 L
.13786 .08782 L
.13886 .08782 L
.13986 .08782 L
.14086 .08782 L
.14186 .08782 L
.14286 .08782 L
.14386 .08782 L
.14486 .08782 L
.14585 .08782 L
.14685 .08782 L
.14785 .08782 L
.14885 .08782 L
Mistroke
.14985 .06128 L
.15085 .06128 L
.15185 .06128 L
.15285 .06128 L
.15385 .06128 L
.15485 .06128 L
.15584 .06128 L
.15684 .06128 L
.15784 .06128 L
.15884 .06128 L
.15984 .06128 L
.16084 .06128 L
.16184 .06128 L
.16284 .06128 L
.16384 .06128 L
.16484 .06128 L
.16583 .06128 L
.16683 .06128 L
.16783 .06128 L
.16883 .06128 L
.16983 .06128 L
.17083 .06128 L
.17183 .06128 L
.17283 .06128 L
.17383 .06128 L
.17483 .06128 L
.17582 .06128 L
.17682 .06128 L
.17782 .06128 L
.17882 .06128 L
.17982 .06128 L
.18082 .06128 L
.18182 .06128 L
.18282 .06128 L
.18382 .06128 L
.18482 .06128 L
.18581 .06128 L
.18681 .06128 L
.18781 .06128 L
.18881 .06128 L
.18981 .06128 L
.19081 .06128 L
.19181 .06128 L
.19281 .06128 L
.19381 .06128 L
.19481 .06128 L
.1958 .06128 L
.1968 .06128 L
.1978 .06128 L
.1988 .06128 L
Mistroke
.1998 .08453 L
.2008 .08453 L
.2018 .08453 L
.2028 .08453 L
.2038 .08453 L
.2048 .08453 L
.20579 .08453 L
.20679 .08453 L
.20779 .08453 L
.20879 .08453 L
.20979 .08453 L
.21079 .08453 L
.21179 .08453 L
.21279 .08453 L
.21379 .08453 L
.21479 .08453 L
.21578 .08453 L
.21678 .08453 L
.21778 .08453 L
.21878 .08453 L
.21978 .08453 L
.22078 .08453 L
.22178 .08453 L
.22278 .08453 L
.22378 .08453 L
.22478 .08453 L
.22577 .08453 L
.22677 .08453 L
.22777 .08453 L
.22877 .08453 L
.22977 .08453 L
.23077 .08453 L
.23177 .08453 L
.23277 .08453 L
.23377 .08453 L
.23477 .08453 L
.23576 .08453 L
.23676 .08453 L
.23776 .08453 L
.23876 .08453 L
.23976 .08453 L
.24076 .08453 L
.24176 .08453 L
.24276 .08453 L
.24376 .08453 L
.24476 .08453 L
.24575 .08453 L
.24675 .08453 L
.24775 .08453 L
.24875 .08453 L
Mistroke
.24975 .12924 L
.25075 .12924 L
.25175 .12924 L
.25275 .12924 L
.25375 .12924 L
.25475 .12924 L
.25574 .12924 L
.25674 .12924 L
.25774 .12924 L
.25874 .12924 L
.25974 .12924 L
.26074 .12924 L
.26174 .12924 L
.26274 .12924 L
.26374 .12924 L
.26474 .12924 L
.26573 .12924 L
.26673 .12924 L
.26773 .12924 L
.26873 .12924 L
.26973 .12924 L
.27073 .12924 L
.27173 .12924 L
.27273 .12924 L
.27373 .12924 L
.27473 .12924 L
.27572 .12924 L
.27672 .12924 L
.27772 .12924 L
.27872 .12924 L
.27972 .12924 L
.28072 .12924 L
.28172 .12924 L
.28272 .12924 L
.28372 .12924 L
.28472 .12924 L
.28571 .12924 L
.28671 .12924 L
.28771 .12924 L
.28871 .12924 L
.28971 .12924 L
.29071 .12924 L
.29171 .12924 L
.29271 .12924 L
.29371 .12924 L
.29471 .12924 L
.2957 .12924 L
.2967 .12924 L
.2977 .12924 L
.2987 .12924 L
Mistroke
.2997 .1351 L
.3007 .1351 L
.3017 .1351 L
.3027 .1351 L
.3037 .1351 L
.3047 .1351 L
.30569 .1351 L
.30669 .1351 L
.30769 .1351 L
.30869 .1351 L
.30969 .1351 L
.31069 .1351 L
.31169 .1351 L
.31269 .1351 L
.31369 .1351 L
.31469 .1351 L
.31568 .1351 L
.31668 .1351 L
.31768 .1351 L
.31868 .1351 L
.31968 .1351 L
.32068 .1351 L
.32168 .1351 L
.32268 .1351 L
.32368 .1351 L
.32468 .1351 L
.32567 .1351 L
.32667 .1351 L
.32767 .1351 L
.32867 .1351 L
.32967 .1351 L
.33067 .1351 L
.33167 .1351 L
.33267 .1351 L
.33367 .1351 L
.33467 .1351 L
.33566 .1351 L
.33666 .1351 L
.33766 .1351 L
.33866 .1351 L
.33966 .1351 L
.34066 .1351 L
.34166 .1351 L
.34266 .1351 L
.34366 .1351 L
.34466 .1351 L
.34565 .1351 L
.34665 .1351 L
.34765 .1351 L
.34865 .1351 L
Mistroke
.34965 .12395 L
.35065 .12395 L
.35165 .12395 L
.35265 .12395 L
.35365 .12395 L
.35465 .12395 L
.35564 .12395 L
.35664 .12395 L
.35764 .12395 L
.35864 .12395 L
.35964 .12395 L
.36064 .12395 L
.36164 .12395 L
.36264 .12395 L
.36364 .12395 L
.36464 .12395 L
.36563 .12395 L
.36663 .12395 L
.36763 .12395 L
.36863 .12395 L
.36963 .12395 L
.37063 .12395 L
.37163 .12395 L
.37263 .12395 L
.37363 .12395 L
.37463 .12395 L
.37562 .12395 L
.37662 .12395 L
.37762 .12395 L
.37862 .12395 L
.37962 .12395 L
.38062 .12395 L
.38162 .12395 L
.38262 .12395 L
.38362 .12395 L
.38462 .12395 L
.38561 .12395 L
.38661 .12395 L
.38761 .12395 L
.38861 .12395 L
.38961 .12395 L
.39061 .12395 L
.39161 .12395 L
.39261 .12395 L
.39361 .12395 L
.39461 .12395 L
.3956 .12395 L
.3966 .12395 L
.3976 .12395 L
.3986 .12395 L
Mistroke
.3996 .12171 L
.4006 .12171 L
.4016 .12171 L
.4026 .12171 L
.4036 .12171 L
.4046 .12171 L
.40559 .12171 L
.40659 .12171 L
.40759 .12171 L
.40859 .12171 L
.40959 .12171 L
.41059 .12171 L
.41159 .12171 L
.41259 .12171 L
.41359 .12171 L
.41459 .12171 L
.41558 .12171 L
.41658 .12171 L
.41758 .12171 L
.41858 .12171 L
.41958 .12171 L
.42058 .12171 L
.42158 .12171 L
.42258 .12171 L
.42358 .12171 L
.42458 .12171 L
.42557 .12171 L
.42657 .12171 L
.42757 .12171 L
.42857 .12171 L
.42957 .12171 L
.43057 .12171 L
.43157 .12171 L
.43257 .12171 L
.43357 .12171 L
.43457 .12171 L
.43556 .12171 L
.43656 .12171 L
.43756 .12171 L
.43856 .12171 L
.43956 .12171 L
.44056 .12171 L
.44156 .12171 L
.44256 .12171 L
.44356 .12171 L
.44456 .12171 L
.44555 .12171 L
.44655 .12171 L
.44755 .12171 L
.44855 .12171 L
Mistroke
.44955 .13042 L
.45055 .13042 L
.45155 .13042 L
.45255 .13042 L
.45355 .13042 L
.45455 .13042 L
.45554 .13042 L
.45654 .13042 L
.45754 .13042 L
.45854 .13042 L
.45954 .13042 L
.46054 .13042 L
.46154 .13042 L
.46254 .13042 L
.46354 .13042 L
.46454 .13042 L
.46553 .13042 L
.46653 .13042 L
.46753 .13042 L
.46853 .13042 L
.46953 .13042 L
.47053 .13042 L
.47153 .13042 L
.47253 .13042 L
.47353 .13042 L
.47453 .13042 L
.47552 .13042 L
.47652 .13042 L
.47752 .13042 L
.47852 .13042 L
.47952 .13042 L
.48052 .13042 L
.48152 .13042 L
.48252 .13042 L
.48352 .13042 L
.48452 .13042 L
.48551 .13042 L
.48651 .13042 L
.48751 .13042 L
.48851 .13042 L
.48951 .13042 L
.49051 .13042 L
.49151 .13042 L
.49251 .13042 L
.49351 .13042 L
.49451 .13042 L
.4955 .13042 L
.4965 .13042 L
.4975 .13042 L
.4985 .13042 L
Mistroke
.4995 .14153 L
.5005 .14153 L
.5015 .14153 L
.5025 .14153 L
.5035 .14153 L
.5045 .14153 L
.50549 .14153 L
.50649 .14153 L
.50749 .14153 L
.50849 .14153 L
.50949 .14153 L
.51049 .14153 L
.51149 .14153 L
.51249 .14153 L
.51349 .14153 L
.51449 .14153 L
.51548 .14153 L
.51648 .14153 L
.51748 .14153 L
.51848 .14153 L
.51948 .14153 L
.52048 .14153 L
.52148 .14153 L
.52248 .14153 L
.52348 .14153 L
.52448 .14153 L
.52547 .14153 L
.52647 .14153 L
.52747 .14153 L
.52847 .14153 L
.52947 .14153 L
.53047 .14153 L
.53147 .14153 L
.53247 .14153 L
.53347 .14153 L
.53447 .14153 L
.53546 .14153 L
.53646 .14153 L
.53746 .14153 L
.53846 .14153 L
.53946 .14153 L
.54046 .14153 L
.54146 .14153 L
.54246 .14153 L
.54346 .14153 L
.54446 .14153 L
.54545 .14153 L
.54645 .14153 L
.54745 .14153 L
.54845 .14153 L
Mistroke
.54945 .14806 L
.55045 .14806 L
.55145 .14806 L
.55245 .14806 L
.55345 .14806 L
.55445 .14806 L
.55544 .14806 L
.55644 .14806 L
.55744 .14806 L
.55844 .14806 L
.55944 .14806 L
.56044 .14806 L
.56144 .14806 L
.56244 .14806 L
.56344 .14806 L
.56444 .14806 L
.56543 .14806 L
.56643 .14806 L
.56743 .14806 L
.56843 .14806 L
.56943 .14806 L
.57043 .14806 L
.57143 .14806 L
.57243 .14806 L
.57343 .14806 L
.57443 .14806 L
.57542 .14806 L
.57642 .14806 L
.57742 .14806 L
.57842 .14806 L
.57942 .14806 L
.58042 .14806 L
.58142 .14806 L
.58242 .14806 L
.58342 .14806 L
.58442 .14806 L
.58541 .14806 L
.58641 .14806 L
.58741 .14806 L
.58841 .14806 L
.58941 .14806 L
.59041 .14806 L
.59141 .14806 L
.59241 .14806 L
.59341 .14806 L
.59441 .14806 L
.5954 .14806 L
.5964 .14806 L
.5974 .14806 L
.5984 .14806 L
Mistroke
.5994 .15162 L
.6004 .15162 L
.6014 .15162 L
.6024 .15162 L
.6034 .15162 L
.6044 .15162 L
.60539 .15162 L
.60639 .15162 L
.60739 .15162 L
.60839 .15162 L
.60939 .15162 L
.61039 .15162 L
.61139 .15162 L
.61239 .15162 L
.61339 .15162 L
.61439 .15162 L
.61538 .15162 L
.61638 .15162 L
.61738 .15162 L
.61838 .15162 L
.61938 .15162 L
.62038 .15162 L
.62138 .15162 L
.62238 .15162 L
.62338 .15162 L
.62438 .15162 L
.62537 .15162 L
.62637 .15162 L
.62737 .15162 L
.62837 .15162 L
.62937 .15162 L
.63037 .15162 L
.63137 .15162 L
.63237 .15162 L
.63337 .15162 L
.63437 .15162 L
.63536 .15162 L
.63636 .15162 L
.63736 .15162 L
.63836 .15162 L
.63936 .15162 L
.64036 .15162 L
.64136 .15162 L
.64236 .15162 L
.64336 .15162 L
.64436 .15162 L
.64535 .15162 L
.64635 .15162 L
.64735 .15162 L
.64835 .15162 L
Mistroke
.64935 .14774 L
.65035 .14774 L
.65135 .14774 L
.65235 .14774 L
.65335 .14774 L
.65435 .14774 L
.65534 .14774 L
.65634 .14774 L
.65734 .14774 L
.65834 .14774 L
.65934 .14774 L
.66034 .14774 L
.66134 .14774 L
.66234 .14774 L
.66334 .14774 L
.66434 .14774 L
.66533 .14774 L
.66633 .14774 L
.66733 .14774 L
.66833 .14774 L
.66933 .14774 L
.67033 .14774 L
.67133 .14774 L
.67233 .14774 L
.67333 .14774 L
.67433 .14774 L
.67532 .14774 L
.67632 .14774 L
.67732 .14774 L
.67832 .14774 L
.67932 .14774 L
.68032 .14774 L
.68132 .14774 L
.68232 .14774 L
.68332 .14774 L
.68432 .14774 L
.68531 .14774 L
.68631 .14774 L
.68731 .14774 L
.68831 .14774 L
.68931 .14774 L
.69031 .14774 L
.69131 .14774 L
.69231 .14774 L
.69331 .14774 L
.69431 .14774 L
.6953 .14774 L
.6963 .14774 L
.6973 .14774 L
.6983 .14774 L
Mistroke
.6993 .15319 L
.7003 .15319 L
.7013 .15319 L
.7023 .15319 L
.7033 .15319 L
.7043 .15319 L
.70529 .15319 L
.70629 .15319 L
.70729 .15319 L
.70829 .15319 L
.70929 .15319 L
.71029 .15319 L
.71129 .15319 L
.71229 .15319 L
.71329 .15319 L
.71429 .15319 L
.71528 .15319 L
.71628 .15319 L
.71728 .15319 L
.71828 .15319 L
.71928 .15319 L
.72028 .15319 L
.72128 .15319 L
.72228 .15319 L
.72328 .15319 L
.72428 .15319 L
.72527 .15319 L
.72627 .15319 L
.72727 .15319 L
.72827 .15319 L
.72927 .15319 L
.73027 .15319 L
.73127 .15319 L
.73227 .15319 L
.73327 .15319 L
.73427 .15319 L
.73526 .15319 L
.73626 .15319 L
.73726 .15319 L
.73826 .15319 L
.73926 .15319 L
.74026 .15319 L
.74126 .15319 L
.74226 .15319 L
.74326 .15319 L
.74426 .15319 L
.74525 .15319 L
.74625 .15319 L
.74725 .15319 L
.74825 .15319 L
Mistroke
.74925 .15879 L
.75025 .15879 L
.75125 .15879 L
.75225 .15879 L
.75325 .15879 L
.75425 .15879 L
.75524 .15879 L
.75624 .15879 L
.75724 .15879 L
.75824 .15879 L
.75924 .15879 L
.76024 .15879 L
.76124 .15879 L
.76224 .15879 L
.76324 .15879 L
.76424 .15879 L
.76523 .15879 L
.76623 .15879 L
.76723 .15879 L
.76823 .15879 L
.76923 .15879 L
.77023 .15879 L
.77123 .15879 L
.77223 .15879 L
.77323 .15879 L
.77423 .15879 L
.77522 .15879 L
.77622 .15879 L
.77722 .15879 L
.77822 .15879 L
.77922 .15879 L
.78022 .15879 L
.78122 .15879 L
.78222 .15879 L
.78322 .15879 L
.78422 .15879 L
.78521 .15879 L
.78621 .15879 L
.78721 .15879 L
.78821 .15879 L
.78921 .15879 L
.79021 .15879 L
.79121 .15879 L
.79221 .15879 L
.79321 .15879 L
.79421 .15879 L
.7952 .15879 L
.7962 .15879 L
.7972 .15879 L
.7982 .15879 L
Mistroke
.7992 .16914 L
.8002 .16914 L
.8012 .16914 L
.8022 .16914 L
.8032 .16914 L
.8042 .16914 L
.80519 .16914 L
.80619 .16914 L
.80719 .16914 L
.80819 .16914 L
.80919 .16914 L
.81019 .16914 L
.81119 .16914 L
.81219 .16914 L
.81319 .16914 L
.81419 .16914 L
.81518 .16914 L
.81618 .16914 L
.81718 .16914 L
.81818 .16914 L
.81918 .16914 L
.82018 .16914 L
.82118 .16914 L
.82218 .16914 L
.82318 .16914 L
.82418 .16914 L
.82517 .16914 L
.82617 .16914 L
.82717 .16914 L
.82817 .16914 L
.82917 .16914 L
.83017 .16914 L
.83117 .16914 L
.83217 .16914 L
.83317 .16914 L
.83417 .16914 L
.83516 .16914 L
.83616 .16914 L
.83716 .16914 L
.83816 .16914 L
.83916 .16914 L
.84016 .16914 L
.84116 .16914 L
.84216 .16914 L
.84316 .16914 L
.84416 .16914 L
.84515 .16914 L
.84615 .16914 L
.84715 .16914 L
.84815 .16914 L
Mistroke
.84915 .1709 L
.85015 .1709 L
.85115 .1709 L
.85215 .1709 L
.85315 .1709 L
.85415 .1709 L
.85514 .1709 L
.85614 .1709 L
.85714 .1709 L
.85814 .1709 L
.85914 .1709 L
.86014 .1709 L
.86114 .1709 L
.86214 .1709 L
.86314 .1709 L
.86414 .1709 L
.86513 .1709 L
.86613 .1709 L
.86713 .1709 L
.86813 .1709 L
.86913 .1709 L
.87013 .1709 L
.87113 .1709 L
.87213 .1709 L
.87313 .1709 L
.87413 .1709 L
.87512 .1709 L
.87612 .1709 L
.87712 .1709 L
.87812 .1709 L
.87912 .1709 L
.88012 .1709 L
.88112 .1709 L
.88212 .1709 L
.88312 .1709 L
.88412 .1709 L
.88511 .1709 L
.88611 .1709 L
.88711 .1709 L
.88811 .1709 L
.88911 .1709 L
.89011 .1709 L
.89111 .1709 L
.89211 .1709 L
.89311 .1709 L
.89411 .1709 L
.8951 .1709 L
.8961 .1709 L
.8971 .1709 L
.8981 .1709 L
Mistroke
.8991 .16155 L
.9001 .16155 L
.9011 .16155 L
.9021 .16155 L
.9031 .16155 L
.9041 .16155 L
.90509 .16155 L
.90609 .16155 L
.90709 .16155 L
.90809 .16155 L
.90909 .16155 L
.91009 .16155 L
.91109 .16155 L
.91209 .16155 L
.91309 .16155 L
.91409 .16155 L
.91508 .16155 L
.91608 .16155 L
.91708 .16155 L
.91808 .16155 L
.91908 .16155 L
.92008 .16155 L
.92108 .16155 L
.92208 .16155 L
.92308 .16155 L
.92408 .16155 L
.92507 .16155 L
.92607 .16155 L
.92707 .16155 L
.92807 .16155 L
.92907 .16155 L
.93007 .16155 L
.93107 .16155 L
.93207 .16155 L
.93307 .16155 L
.93407 .16155 L
.93506 .16155 L
.93606 .16155 L
.93706 .16155 L
.93806 .16155 L
.93906 .16155 L
.94006 .16155 L
.94106 .16155 L
.94206 .16155 L
.94306 .16155 L
.94406 .16155 L
.94505 .16155 L
.94605 .16155 L
.94705 .16155 L
.94805 .16155 L
Mistroke
.94905 .16099 L
.95005 .16099 L
.95105 .16099 L
.95205 .16099 L
.95305 .16099 L
.95405 .16099 L
.95504 .16099 L
.95604 .16099 L
.95704 .16099 L
.95804 .16099 L
.95904 .16099 L
.96004 .16099 L
.96104 .16099 L
.96204 .16099 L
.96304 .16099 L
.96404 .16099 L
.96503 .16099 L
.96603 .16099 L
.96703 .16099 L
.96803 .16099 L
.96903 .16099 L
.97003 .16099 L
.97103 .16099 L
.97203 .16099 L
.97303 .16099 L
.97403 .16099 L
.97502 .16099 L
.97602 .16099 L
.97702 .16099 L
.97802 .16099 L
.97902 .16099 L
.98002 .16099 L
.98102 .16099 L
.98202 .16099 L
.98302 .16099 L
.98402 .16099 L
.98501 .16099 L
.98601 .16099 L
.98701 .16099 L
.98801 .16099 L
.98901 .16099 L
.99001 .16099 L
.99101 .16099 L
.99201 .16099 L
.99301 .16099 L
.99401 .16099 L
.995 .16099 L
.996 .16099 L
.997 .16099 L
.998 .16099 L
Mistroke
.999 .15755 L
Mfstroke
gsave
.999 .25705 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36835 m
.001 .36835 L
.002 .36835 L
.003 .36835 L
.004 .36835 L
.005 .36835 L
.00599 .36835 L
.00699 .36835 L
.00799 .36835 L
.00899 .36835 L
.00999 .36835 L
.01099 .36835 L
.01199 .36835 L
.01299 .36835 L
.01399 .36835 L
.01499 .36835 L
.01598 .36835 L
.01698 .36835 L
.01798 .36835 L
.01898 .36835 L
.01998 .36835 L
.02098 .36835 L
.02198 .36835 L
.02298 .36835 L
.02398 .36835 L
.02498 .36835 L
.02597 .36835 L
.02697 .36835 L
.02797 .36835 L
.02897 .36835 L
.02997 .36835 L
.03097 .36835 L
.03197 .36835 L
.03297 .36835 L
.03397 .36835 L
.03497 .36835 L
.03596 .36835 L
.03696 .36835 L
.03796 .36835 L
.03896 .36835 L
.03996 .36835 L
.04096 .36835 L
.04196 .36835 L
.04296 .36835 L
.04396 .36835 L
.04496 .36835 L
.04595 .36835 L
.04695 .36835 L
.04795 .36835 L
.04895 .36835 L
Mistroke
.04995 .36614 L
.05095 .36614 L
.05195 .36614 L
.05295 .36614 L
.05395 .36614 L
.05495 .36614 L
.05594 .36614 L
.05694 .36614 L
.05794 .36614 L
.05894 .36614 L
.05994 .36614 L
.06094 .36614 L
.06194 .36614 L
.06294 .36614 L
.06394 .36614 L
.06494 .36614 L
.06593 .36614 L
.06693 .36614 L
.06793 .36614 L
.06893 .36614 L
.06993 .36614 L
.07093 .36614 L
.07193 .36614 L
.07293 .36614 L
.07393 .36614 L
.07493 .36614 L
.07592 .36614 L
.07692 .36614 L
.07792 .36614 L
.07892 .36614 L
.07992 .36614 L
.08092 .36614 L
.08192 .36614 L
.08292 .36614 L
.08392 .36614 L
.08492 .36614 L
.08591 .36614 L
.08691 .36614 L
.08791 .36614 L
.08891 .36614 L
.08991 .36614 L
.09091 .36614 L
.09191 .36614 L
.09291 .36614 L
.09391 .36614 L
.09491 .36614 L
.0959 .36614 L
.0969 .36614 L
.0979 .36614 L
.0989 .36614 L
Mistroke
.0999 .3104 L
.1009 .3104 L
.1019 .3104 L
.1029 .3104 L
.1039 .3104 L
.1049 .3104 L
.10589 .3104 L
.10689 .3104 L
.10789 .3104 L
.10889 .3104 L
.10989 .3104 L
.11089 .3104 L
.11189 .3104 L
.11289 .3104 L
.11389 .3104 L
.11489 .3104 L
.11588 .3104 L
.11688 .3104 L
.11788 .3104 L
.11888 .3104 L
.11988 .3104 L
.12088 .3104 L
.12188 .3104 L
.12288 .3104 L
.12388 .3104 L
.12488 .3104 L
.12587 .3104 L
.12687 .3104 L
.12787 .3104 L
.12887 .3104 L
.12987 .3104 L
.13087 .3104 L
.13187 .3104 L
.13287 .3104 L
.13387 .3104 L
.13487 .3104 L
.13586 .3104 L
.13686 .3104 L
.13786 .3104 L
.13886 .3104 L
.13986 .3104 L
.14086 .3104 L
.14186 .3104 L
.14286 .3104 L
.14386 .3104 L
.14486 .3104 L
.14585 .3104 L
.14685 .3104 L
.14785 .3104 L
.14885 .3104 L
Mistroke
.14985 .25233 L
.15085 .25233 L
.15185 .25233 L
.15285 .25233 L
.15385 .25233 L
.15485 .25233 L
.15584 .25233 L
.15684 .25233 L
.15784 .25233 L
.15884 .25233 L
.15984 .25233 L
.16084 .25233 L
.16184 .25233 L
.16284 .25233 L
.16384 .25233 L
.16484 .25233 L
.16583 .25233 L
.16683 .25233 L
.16783 .25233 L
.16883 .25233 L
.16983 .25233 L
.17083 .25233 L
.17183 .25233 L
.17283 .25233 L
.17383 .25233 L
.17483 .25233 L
.17582 .25233 L
.17682 .25233 L
.17782 .25233 L
.17882 .25233 L
.17982 .25233 L
.18082 .25233 L
.18182 .25233 L
.18282 .25233 L
.18382 .25233 L
.18482 .25233 L
.18581 .25233 L
.18681 .25233 L
.18781 .25233 L
.18881 .25233 L
.18981 .25233 L
.19081 .25233 L
.19181 .25233 L
.19281 .25233 L
.19381 .25233 L
.19481 .25233 L
.1958 .25233 L
.1968 .25233 L
.1978 .25233 L
.1988 .25233 L
Mistroke
.1998 .26788 L
.2008 .26788 L
.2018 .26788 L
.2028 .26788 L
.2038 .26788 L
.2048 .26788 L
.20579 .26788 L
.20679 .26788 L
.20779 .26788 L
.20879 .26788 L
.20979 .26788 L
.21079 .26788 L
.21179 .26788 L
.21279 .26788 L
.21379 .26788 L
.21479 .26788 L
.21578 .26788 L
.21678 .26788 L
.21778 .26788 L
.21878 .26788 L
.21978 .26788 L
.22078 .26788 L
.22178 .26788 L
.22278 .26788 L
.22378 .26788 L
.22478 .26788 L
.22577 .26788 L
.22677 .26788 L
.22777 .26788 L
.22877 .26788 L
.22977 .26788 L
.23077 .26788 L
.23177 .26788 L
.23277 .26788 L
.23377 .26788 L
.23477 .26788 L
.23576 .26788 L
.23676 .26788 L
.23776 .26788 L
.23876 .26788 L
.23976 .26788 L
.24076 .26788 L
.24176 .26788 L
.24276 .26788 L
.24376 .26788 L
.24476 .26788 L
.24575 .26788 L
.24675 .26788 L
.24775 .26788 L
.24875 .26788 L
Mistroke
.24975 .29996 L
.25075 .29996 L
.25175 .29996 L
.25275 .29996 L
.25375 .29996 L
.25475 .29996 L
.25574 .29996 L
.25674 .29996 L
.25774 .29996 L
.25874 .29996 L
.25974 .29996 L
.26074 .29996 L
.26174 .29996 L
.26274 .29996 L
.26374 .29996 L
.26474 .29996 L
.26573 .29996 L
.26673 .29996 L
.26773 .29996 L
.26873 .29996 L
.26973 .29996 L
.27073 .29996 L
.27173 .29996 L
.27273 .29996 L
.27373 .29996 L
.27473 .29996 L
.27572 .29996 L
.27672 .29996 L
.27772 .29996 L
.27872 .29996 L
.27972 .29996 L
.28072 .29996 L
.28172 .29996 L
.28272 .29996 L
.28372 .29996 L
.28472 .29996 L
.28571 .29996 L
.28671 .29996 L
.28771 .29996 L
.28871 .29996 L
.28971 .29996 L
.29071 .29996 L
.29171 .29996 L
.29271 .29996 L
.29371 .29996 L
.29471 .29996 L
.2957 .29996 L
.2967 .29996 L
.2977 .29996 L
.2987 .29996 L
Mistroke
.2997 .29956 L
.3007 .29956 L
.3017 .29956 L
.3027 .29956 L
.3037 .29956 L
.3047 .29956 L
.30569 .29956 L
.30669 .29956 L
.30769 .29956 L
.30869 .29956 L
.30969 .29956 L
.31069 .29956 L
.31169 .29956 L
.31269 .29956 L
.31369 .29956 L
.31469 .29956 L
.31568 .29956 L
.31668 .29956 L
.31768 .29956 L
.31868 .29956 L
.31968 .29956 L
.32068 .29956 L
.32168 .29956 L
.32268 .29956 L
.32368 .29956 L
.32468 .29956 L
.32567 .29956 L
.32667 .29956 L
.32767 .29956 L
.32867 .29956 L
.32967 .29956 L
.33067 .29956 L
.33167 .29956 L
.33267 .29956 L
.33367 .29956 L
.33467 .29956 L
.33566 .29956 L
.33666 .29956 L
.33766 .29956 L
.33866 .29956 L
.33966 .29956 L
.34066 .29956 L
.34166 .29956 L
.34266 .29956 L
.34366 .29956 L
.34466 .29956 L
.34565 .29956 L
.34665 .29956 L
.34765 .29956 L
.34865 .29956 L
Mistroke
.34965 .27685 L
.35065 .27685 L
.35165 .27685 L
.35265 .27685 L
.35365 .27685 L
.35465 .27685 L
.35564 .27685 L
.35664 .27685 L
.35764 .27685 L
.35864 .27685 L
.35964 .27685 L
.36064 .27685 L
.36164 .27685 L
.36264 .27685 L
.36364 .27685 L
.36464 .27685 L
.36563 .27685 L
.36663 .27685 L
.36763 .27685 L
.36863 .27685 L
.36963 .27685 L
.37063 .27685 L
.37163 .27685 L
.37263 .27685 L
.37363 .27685 L
.37463 .27685 L
.37562 .27685 L
.37662 .27685 L
.37762 .27685 L
.37862 .27685 L
.37962 .27685 L
.38062 .27685 L
.38162 .27685 L
.38262 .27685 L
.38362 .27685 L
.38462 .27685 L
.38561 .27685 L
.38661 .27685 L
.38761 .27685 L
.38861 .27685 L
.38961 .27685 L
.39061 .27685 L
.39161 .27685 L
.39261 .27685 L
.39361 .27685 L
.39461 .27685 L
.3956 .27685 L
.3966 .27685 L
.3976 .27685 L
.3986 .27685 L
Mistroke
.3996 .26388 L
.4006 .26388 L
.4016 .26388 L
.4026 .26388 L
.4036 .26388 L
.4046 .26388 L
.40559 .26388 L
.40659 .26388 L
.40759 .26388 L
.40859 .26388 L
.40959 .26388 L
.41059 .26388 L
.41159 .26388 L
.41259 .26388 L
.41359 .26388 L
.41459 .26388 L
.41558 .26388 L
.41658 .26388 L
.41758 .26388 L
.41858 .26388 L
.41958 .26388 L
.42058 .26388 L
.42158 .26388 L
.42258 .26388 L
.42358 .26388 L
.42458 .26388 L
.42557 .26388 L
.42657 .26388 L
.42757 .26388 L
.42857 .26388 L
.42957 .26388 L
.43057 .26388 L
.43157 .26388 L
.43257 .26388 L
.43357 .26388 L
.43457 .26388 L
.43556 .26388 L
.43656 .26388 L
.43756 .26388 L
.43856 .26388 L
.43956 .26388 L
.44056 .26388 L
.44156 .26388 L
.44256 .26388 L
.44356 .26388 L
.44456 .26388 L
.44555 .26388 L
.44655 .26388 L
.44755 .26388 L
.44855 .26388 L
Mistroke
.44955 .26713 L
.45055 .26713 L
.45155 .26713 L
.45255 .26713 L
.45355 .26713 L
.45455 .26713 L
.45554 .26713 L
.45654 .26713 L
.45754 .26713 L
.45854 .26713 L
.45954 .26713 L
.46054 .26713 L
.46154 .26713 L
.46254 .26713 L
.46354 .26713 L
.46454 .26713 L
.46553 .26713 L
.46653 .26713 L
.46753 .26713 L
.46853 .26713 L
.46953 .26713 L
.47053 .26713 L
.47153 .26713 L
.47253 .26713 L
.47353 .26713 L
.47453 .26713 L
.47552 .26713 L
.47652 .26713 L
.47752 .26713 L
.47852 .26713 L
.47952 .26713 L
.48052 .26713 L
.48152 .26713 L
.48252 .26713 L
.48352 .26713 L
.48452 .26713 L
.48551 .26713 L
.48651 .26713 L
.48751 .26713 L
.48851 .26713 L
.48951 .26713 L
.49051 .26713 L
.49151 .26713 L
.49251 .26713 L
.49351 .26713 L
.49451 .26713 L
.4955 .26713 L
.4965 .26713 L
.4975 .26713 L
.4985 .26713 L
Mistroke
.4995 .26937 L
.5005 .26937 L
.5015 .26937 L
.5025 .26937 L
.5035 .26937 L
.5045 .26937 L
.50549 .26937 L
.50649 .26937 L
.50749 .26937 L
.50849 .26937 L
.50949 .26937 L
.51049 .26937 L
.51149 .26937 L
.51249 .26937 L
.51349 .26937 L
.51449 .26937 L
.51548 .26937 L
.51648 .26937 L
.51748 .26937 L
.51848 .26937 L
.51948 .26937 L
.52048 .26937 L
.52148 .26937 L
.52248 .26937 L
.52348 .26937 L
.52448 .26937 L
.52547 .26937 L
.52647 .26937 L
.52747 .26937 L
.52847 .26937 L
.52947 .26937 L
.53047 .26937 L
.53147 .26937 L
.53247 .26937 L
.53347 .26937 L
.53447 .26937 L
.53546 .26937 L
.53646 .26937 L
.53746 .26937 L
.53846 .26937 L
.53946 .26937 L
.54046 .26937 L
.54146 .26937 L
.54246 .26937 L
.54346 .26937 L
.54446 .26937 L
.54545 .26937 L
.54645 .26937 L
.54745 .26937 L
.54845 .26937 L
Mistroke
.54945 .27216 L
.55045 .27216 L
.55145 .27216 L
.55245 .27216 L
.55345 .27216 L
.55445 .27216 L
.55544 .27216 L
.55644 .27216 L
.55744 .27216 L
.55844 .27216 L
.55944 .27216 L
.56044 .27216 L
.56144 .27216 L
.56244 .27216 L
.56344 .27216 L
.56444 .27216 L
.56543 .27216 L
.56643 .27216 L
.56743 .27216 L
.56843 .27216 L
.56943 .27216 L
.57043 .27216 L
.57143 .27216 L
.57243 .27216 L
.57343 .27216 L
.57443 .27216 L
.57542 .27216 L
.57642 .27216 L
.57742 .27216 L
.57842 .27216 L
.57942 .27216 L
.58042 .27216 L
.58142 .27216 L
.58242 .27216 L
.58342 .27216 L
.58442 .27216 L
.58541 .27216 L
.58641 .27216 L
.58741 .27216 L
.58841 .27216 L
.58941 .27216 L
.59041 .27216 L
.59141 .27216 L
.59241 .27216 L
.59341 .27216 L
.59441 .27216 L
.5954 .27216 L
.5964 .27216 L
.5974 .27216 L
.5984 .27216 L
Mistroke
.5994 .27183 L
.6004 .27183 L
.6014 .27183 L
.6024 .27183 L
.6034 .27183 L
.6044 .27183 L
.60539 .27183 L
.60639 .27183 L
.60739 .27183 L
.60839 .27183 L
.60939 .27183 L
.61039 .27183 L
.61139 .27183 L
.61239 .27183 L
.61339 .27183 L
.61439 .27183 L
.61538 .27183 L
.61638 .27183 L
.61738 .27183 L
.61838 .27183 L
.61938 .27183 L
.62038 .27183 L
.62138 .27183 L
.62238 .27183 L
.62338 .27183 L
.62438 .27183 L
.62537 .27183 L
.62637 .27183 L
.62737 .27183 L
.62837 .27183 L
.62937 .27183 L
.63037 .27183 L
.63137 .27183 L
.63237 .27183 L
.63337 .27183 L
.63437 .27183 L
.63536 .27183 L
.63636 .27183 L
.63736 .27183 L
.63836 .27183 L
.63936 .27183 L
.64036 .27183 L
.64136 .27183 L
.64236 .27183 L
.64336 .27183 L
.64436 .27183 L
.64535 .27183 L
.64635 .27183 L
.64735 .27183 L
.64835 .27183 L
Mistroke
.64935 .26417 L
.65035 .26417 L
.65135 .26417 L
.65235 .26417 L
.65335 .26417 L
.65435 .26417 L
.65534 .26417 L
.65634 .26417 L
.65734 .26417 L
.65834 .26417 L
.65934 .26417 L
.66034 .26417 L
.66134 .26417 L
.66234 .26417 L
.66334 .26417 L
.66434 .26417 L
.66533 .26417 L
.66633 .26417 L
.66733 .26417 L
.66833 .26417 L
.66933 .26417 L
.67033 .26417 L
.67133 .26417 L
.67233 .26417 L
.67333 .26417 L
.67433 .26417 L
.67532 .26417 L
.67632 .26417 L
.67732 .26417 L
.67832 .26417 L
.67932 .26417 L
.68032 .26417 L
.68132 .26417 L
.68232 .26417 L
.68332 .26417 L
.68432 .26417 L
.68531 .26417 L
.68631 .26417 L
.68731 .26417 L
.68831 .26417 L
.68931 .26417 L
.69031 .26417 L
.69131 .26417 L
.69231 .26417 L
.69331 .26417 L
.69431 .26417 L
.6953 .26417 L
.6963 .26417 L
.6973 .26417 L
.6983 .26417 L
Mistroke
.6993 .26558 L
.7003 .26558 L
.7013 .26558 L
.7023 .26558 L
.7033 .26558 L
.7043 .26558 L
.70529 .26558 L
.70629 .26558 L
.70729 .26558 L
.70829 .26558 L
.70929 .26558 L
.71029 .26558 L
.71129 .26558 L
.71229 .26558 L
.71329 .26558 L
.71429 .26558 L
.71528 .26558 L
.71628 .26558 L
.71728 .26558 L
.71828 .26558 L
.71928 .26558 L
.72028 .26558 L
.72128 .26558 L
.72228 .26558 L
.72328 .26558 L
.72428 .26558 L
.72527 .26558 L
.72627 .26558 L
.72727 .26558 L
.72827 .26558 L
.72927 .26558 L
.73027 .26558 L
.73127 .26558 L
.73227 .26558 L
.73327 .26558 L
.73427 .26558 L
.73526 .26558 L
.73626 .26558 L
.73726 .26558 L
.73826 .26558 L
.73926 .26558 L
.74026 .26558 L
.74126 .26558 L
.74226 .26558 L
.74326 .26558 L
.74426 .26558 L
.74525 .26558 L
.74625 .26558 L
.74725 .26558 L
.74825 .26558 L
Mistroke
.74925 .2697 L
.75025 .2697 L
.75125 .2697 L
.75225 .2697 L
.75325 .2697 L
.75425 .2697 L
.75524 .2697 L
.75624 .2697 L
.75724 .2697 L
.75824 .2697 L
.75924 .2697 L
.76024 .2697 L
.76124 .2697 L
.76224 .2697 L
.76324 .2697 L
.76424 .2697 L
.76523 .2697 L
.76623 .2697 L
.76723 .2697 L
.76823 .2697 L
.76923 .2697 L
.77023 .2697 L
.77123 .2697 L
.77223 .2697 L
.77323 .2697 L
.77423 .2697 L
.77522 .2697 L
.77622 .2697 L
.77722 .2697 L
.77822 .2697 L
.77922 .2697 L
.78022 .2697 L
.78122 .2697 L
.78222 .2697 L
.78322 .2697 L
.78422 .2697 L
.78521 .2697 L
.78621 .2697 L
.78721 .2697 L
.78821 .2697 L
.78921 .2697 L
.79021 .2697 L
.79121 .2697 L
.79221 .2697 L
.79321 .2697 L
.79421 .2697 L
.7952 .2697 L
.7962 .2697 L
.7972 .2697 L
.7982 .2697 L
Mistroke
.7992 .27681 L
.8002 .27681 L
.8012 .27681 L
.8022 .27681 L
.8032 .27681 L
.8042 .27681 L
.80519 .27681 L
.80619 .27681 L
.80719 .27681 L
.80819 .27681 L
.80919 .27681 L
.81019 .27681 L
.81119 .27681 L
.81219 .27681 L
.81319 .27681 L
.81419 .27681 L
.81518 .27681 L
.81618 .27681 L
.81718 .27681 L
.81818 .27681 L
.81918 .27681 L
.82018 .27681 L
.82118 .27681 L
.82218 .27681 L
.82318 .27681 L
.82418 .27681 L
.82517 .27681 L
.82617 .27681 L
.82717 .27681 L
.82817 .27681 L
.82917 .27681 L
.83017 .27681 L
.83117 .27681 L
.83217 .27681 L
.83317 .27681 L
.83417 .27681 L
.83516 .27681 L
.83616 .27681 L
.83716 .27681 L
.83816 .27681 L
.83916 .27681 L
.84016 .27681 L
.84116 .27681 L
.84216 .27681 L
.84316 .27681 L
.84416 .27681 L
.84515 .27681 L
.84615 .27681 L
.84715 .27681 L
.84815 .27681 L
Mistroke
.84915 .27665 L
.85015 .27665 L
.85115 .27665 L
.85215 .27665 L
.85315 .27665 L
.85415 .27665 L
.85514 .27665 L
.85614 .27665 L
.85714 .27665 L
.85814 .27665 L
.85914 .27665 L
.86014 .27665 L
.86114 .27665 L
.86214 .27665 L
.86314 .27665 L
.86414 .27665 L
.86513 .27665 L
.86613 .27665 L
.86713 .27665 L
.86813 .27665 L
.86913 .27665 L
.87013 .27665 L
.87113 .27665 L
.87213 .27665 L
.87313 .27665 L
.87413 .27665 L
.87512 .27665 L
.87612 .27665 L
.87712 .27665 L
.87812 .27665 L
.87912 .27665 L
.88012 .27665 L
.88112 .27665 L
.88212 .27665 L
.88312 .27665 L
.88412 .27665 L
.88511 .27665 L
.88611 .27665 L
.88711 .27665 L
.88811 .27665 L
.88911 .27665 L
.89011 .27665 L
.89111 .27665 L
.89211 .27665 L
.89311 .27665 L
.89411 .27665 L
.8951 .27665 L
.8961 .27665 L
.8971 .27665 L
.8981 .27665 L
Mistroke
.8991 .26465 L
.9001 .26465 L
.9011 .26465 L
.9021 .26465 L
.9031 .26465 L
.9041 .26465 L
.90509 .26465 L
.90609 .26465 L
.90709 .26465 L
.90809 .26465 L
.90909 .26465 L
.91009 .26465 L
.91109 .26465 L
.91209 .26465 L
.91309 .26465 L
.91409 .26465 L
.91508 .26465 L
.91608 .26465 L
.91708 .26465 L
.91808 .26465 L
.91908 .26465 L
.92008 .26465 L
.92108 .26465 L
.92208 .26465 L
.92308 .26465 L
.92408 .26465 L
.92507 .26465 L
.92607 .26465 L
.92707 .26465 L
.92807 .26465 L
.92907 .26465 L
.93007 .26465 L
.93107 .26465 L
.93207 .26465 L
.93307 .26465 L
.93407 .26465 L
.93506 .26465 L
.93606 .26465 L
.93706 .26465 L
.93806 .26465 L
.93906 .26465 L
.94006 .26465 L
.94106 .26465 L
.94206 .26465 L
.94306 .26465 L
.94406 .26465 L
.94505 .26465 L
.94605 .26465 L
.94705 .26465 L
.94805 .26465 L
Mistroke
.94905 .26248 L
.95005 .26248 L
.95105 .26248 L
.95205 .26248 L
.95305 .26248 L
.95405 .26248 L
.95504 .26248 L
.95604 .26248 L
.95704 .26248 L
.95804 .26248 L
.95904 .26248 L
.96004 .26248 L
.96104 .26248 L
.96204 .26248 L
.96304 .26248 L
.96404 .26248 L
.96503 .26248 L
.96603 .26248 L
.96703 .26248 L
.96803 .26248 L
.96903 .26248 L
.97003 .26248 L
.97103 .26248 L
.97203 .26248 L
.97303 .26248 L
.97403 .26248 L
.97502 .26248 L
.97602 .26248 L
.97702 .26248 L
.97802 .26248 L
.97902 .26248 L
.98002 .26248 L
.98102 .26248 L
.98202 .26248 L
.98302 .26248 L
.98402 .26248 L
.98501 .26248 L
.98601 .26248 L
.98701 .26248 L
.98801 .26248 L
.98901 .26248 L
.99001 .26248 L
.99101 .26248 L
.99201 .26248 L
.99301 .26248 L
.99401 .26248 L
.995 .26248 L
.996 .26248 L
.997 .26248 L
.998 .26248 L
Mistroke
.999 .25705 L
Mfstroke
1 0 0 r
gsave
.999 .2073 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24721 m
.001 .24721 L
.002 .24721 L
.003 .24721 L
.004 .24721 L
.005 .24721 L
.00599 .24721 L
.00699 .24721 L
.00799 .24721 L
.00899 .24721 L
.00999 .24721 L
.01099 .24721 L
.01199 .24721 L
.01299 .24721 L
.01399 .24721 L
.01499 .24721 L
.01598 .24721 L
.01698 .24721 L
.01798 .24721 L
.01898 .24721 L
.01998 .24721 L
.02098 .24721 L
.02198 .24721 L
.02298 .24721 L
.02398 .24721 L
.02498 .24721 L
.02597 .24721 L
.02697 .24721 L
.02797 .24721 L
.02897 .24721 L
.02997 .24721 L
.03097 .24721 L
.03197 .24721 L
.03297 .24721 L
.03397 .24721 L
.03497 .24721 L
.03596 .24721 L
.03696 .24721 L
.03796 .24721 L
.03896 .24721 L
.03996 .24721 L
.04096 .24721 L
.04196 .24721 L
.04296 .24721 L
.04396 .24721 L
.04496 .24721 L
.04595 .24721 L
.04695 .24721 L
.04795 .24721 L
.04895 .24721 L
Mistroke
.04995 .24523 L
.05095 .24523 L
.05195 .24523 L
.05295 .24523 L
.05395 .24523 L
.05495 .24523 L
.05594 .24523 L
.05694 .24523 L
.05794 .24523 L
.05894 .24523 L
.05994 .24523 L
.06094 .24523 L
.06194 .24523 L
.06294 .24523 L
.06394 .24523 L
.06494 .24523 L
.06593 .24523 L
.06693 .24523 L
.06793 .24523 L
.06893 .24523 L
.06993 .24523 L
.07093 .24523 L
.07193 .24523 L
.07293 .24523 L
.07393 .24523 L
.07493 .24523 L
.07592 .24523 L
.07692 .24523 L
.07792 .24523 L
.07892 .24523 L
.07992 .24523 L
.08092 .24523 L
.08192 .24523 L
.08292 .24523 L
.08392 .24523 L
.08492 .24523 L
.08591 .24523 L
.08691 .24523 L
.08791 .24523 L
.08891 .24523 L
.08991 .24523 L
.09091 .24523 L
.09191 .24523 L
.09291 .24523 L
.09391 .24523 L
.09491 .24523 L
.0959 .24523 L
.0969 .24523 L
.0979 .24523 L
.0989 .24523 L
Mistroke
.0999 .19911 L
.1009 .19911 L
.1019 .19911 L
.1029 .19911 L
.1039 .19911 L
.1049 .19911 L
.10589 .19911 L
.10689 .19911 L
.10789 .19911 L
.10889 .19911 L
.10989 .19911 L
.11089 .19911 L
.11189 .19911 L
.11289 .19911 L
.11389 .19911 L
.11489 .19911 L
.11588 .19911 L
.11688 .19911 L
.11788 .19911 L
.11888 .19911 L
.11988 .19911 L
.12088 .19911 L
.12188 .19911 L
.12288 .19911 L
.12388 .19911 L
.12488 .19911 L
.12587 .19911 L
.12687 .19911 L
.12787 .19911 L
.12887 .19911 L
.12987 .19911 L
.13087 .19911 L
.13187 .19911 L
.13287 .19911 L
.13387 .19911 L
.13487 .19911 L
.13586 .19911 L
.13686 .19911 L
.13786 .19911 L
.13886 .19911 L
.13986 .19911 L
.14086 .19911 L
.14186 .19911 L
.14286 .19911 L
.14386 .19911 L
.14486 .19911 L
.14585 .19911 L
.14685 .19911 L
.14785 .19911 L
.14885 .19911 L
Mistroke
.14985 .1568 L
.15085 .1568 L
.15185 .1568 L
.15285 .1568 L
.15385 .1568 L
.15485 .1568 L
.15584 .1568 L
.15684 .1568 L
.15784 .1568 L
.15884 .1568 L
.15984 .1568 L
.16084 .1568 L
.16184 .1568 L
.16284 .1568 L
.16384 .1568 L
.16484 .1568 L
.16583 .1568 L
.16683 .1568 L
.16783 .1568 L
.16883 .1568 L
.16983 .1568 L
.17083 .1568 L
.17183 .1568 L
.17283 .1568 L
.17383 .1568 L
.17483 .1568 L
.17582 .1568 L
.17682 .1568 L
.17782 .1568 L
.17882 .1568 L
.17982 .1568 L
.18082 .1568 L
.18182 .1568 L
.18282 .1568 L
.18382 .1568 L
.18482 .1568 L
.18581 .1568 L
.18681 .1568 L
.18781 .1568 L
.18881 .1568 L
.18981 .1568 L
.19081 .1568 L
.19181 .1568 L
.19281 .1568 L
.19381 .1568 L
.19481 .1568 L
.1958 .1568 L
.1968 .1568 L
.1978 .1568 L
.1988 .1568 L
Mistroke
.1998 .1762 L
.2008 .1762 L
.2018 .1762 L
.2028 .1762 L
.2038 .1762 L
.2048 .1762 L
.20579 .1762 L
.20679 .1762 L
.20779 .1762 L
.20879 .1762 L
.20979 .1762 L
.21079 .1762 L
.21179 .1762 L
.21279 .1762 L
.21379 .1762 L
.21479 .1762 L
.21578 .1762 L
.21678 .1762 L
.21778 .1762 L
.21878 .1762 L
.21978 .1762 L
.22078 .1762 L
.22178 .1762 L
.22278 .1762 L
.22378 .1762 L
.22478 .1762 L
.22577 .1762 L
.22677 .1762 L
.22777 .1762 L
.22877 .1762 L
.22977 .1762 L
.23077 .1762 L
.23177 .1762 L
.23277 .1762 L
.23377 .1762 L
.23477 .1762 L
.23576 .1762 L
.23676 .1762 L
.23776 .1762 L
.23876 .1762 L
.23976 .1762 L
.24076 .1762 L
.24176 .1762 L
.24276 .1762 L
.24376 .1762 L
.24476 .1762 L
.24575 .1762 L
.24675 .1762 L
.24775 .1762 L
.24875 .1762 L
Mistroke
.24975 .2146 L
.25075 .2146 L
.25175 .2146 L
.25275 .2146 L
.25375 .2146 L
.25475 .2146 L
.25574 .2146 L
.25674 .2146 L
.25774 .2146 L
.25874 .2146 L
.25974 .2146 L
.26074 .2146 L
.26174 .2146 L
.26274 .2146 L
.26374 .2146 L
.26474 .2146 L
.26573 .2146 L
.26673 .2146 L
.26773 .2146 L
.26873 .2146 L
.26973 .2146 L
.27073 .2146 L
.27173 .2146 L
.27273 .2146 L
.27373 .2146 L
.27473 .2146 L
.27572 .2146 L
.27672 .2146 L
.27772 .2146 L
.27872 .2146 L
.27972 .2146 L
.28072 .2146 L
.28172 .2146 L
.28272 .2146 L
.28372 .2146 L
.28472 .2146 L
.28571 .2146 L
.28671 .2146 L
.28771 .2146 L
.28871 .2146 L
.28971 .2146 L
.29071 .2146 L
.29171 .2146 L
.29271 .2146 L
.29371 .2146 L
.29471 .2146 L
.2957 .2146 L
.2967 .2146 L
.2977 .2146 L
.2987 .2146 L
Mistroke
.2997 .21733 L
.3007 .21733 L
.3017 .21733 L
.3027 .21733 L
.3037 .21733 L
.3047 .21733 L
.30569 .21733 L
.30669 .21733 L
.30769 .21733 L
.30869 .21733 L
.30969 .21733 L
.31069 .21733 L
.31169 .21733 L
.31269 .21733 L
.31369 .21733 L
.31469 .21733 L
.31568 .21733 L
.31668 .21733 L
.31768 .21733 L
.31868 .21733 L
.31968 .21733 L
.32068 .21733 L
.32168 .21733 L
.32268 .21733 L
.32368 .21733 L
.32468 .21733 L
.32567 .21733 L
.32667 .21733 L
.32767 .21733 L
.32867 .21733 L
.32967 .21733 L
.33067 .21733 L
.33167 .21733 L
.33267 .21733 L
.33367 .21733 L
.33467 .21733 L
.33566 .21733 L
.33666 .21733 L
.33766 .21733 L
.33866 .21733 L
.33966 .21733 L
.34066 .21733 L
.34166 .21733 L
.34266 .21733 L
.34366 .21733 L
.34466 .21733 L
.34565 .21733 L
.34665 .21733 L
.34765 .21733 L
.34865 .21733 L
Mistroke
.34965 .2004 L
.35065 .2004 L
.35165 .2004 L
.35265 .2004 L
.35365 .2004 L
.35465 .2004 L
.35564 .2004 L
.35664 .2004 L
.35764 .2004 L
.35864 .2004 L
.35964 .2004 L
.36064 .2004 L
.36164 .2004 L
.36264 .2004 L
.36364 .2004 L
.36464 .2004 L
.36563 .2004 L
.36663 .2004 L
.36763 .2004 L
.36863 .2004 L
.36963 .2004 L
.37063 .2004 L
.37163 .2004 L
.37263 .2004 L
.37363 .2004 L
.37463 .2004 L
.37562 .2004 L
.37662 .2004 L
.37762 .2004 L
.37862 .2004 L
.37962 .2004 L
.38062 .2004 L
.38162 .2004 L
.38262 .2004 L
.38362 .2004 L
.38462 .2004 L
.38561 .2004 L
.38661 .2004 L
.38761 .2004 L
.38861 .2004 L
.38961 .2004 L
.39061 .2004 L
.39161 .2004 L
.39261 .2004 L
.39361 .2004 L
.39461 .2004 L
.3956 .2004 L
.3966 .2004 L
.3976 .2004 L
.3986 .2004 L
Mistroke
.3996 .19279 L
.4006 .19279 L
.4016 .19279 L
.4026 .19279 L
.4036 .19279 L
.4046 .19279 L
.40559 .19279 L
.40659 .19279 L
.40759 .19279 L
.40859 .19279 L
.40959 .19279 L
.41059 .19279 L
.41159 .19279 L
.41259 .19279 L
.41359 .19279 L
.41459 .19279 L
.41558 .19279 L
.41658 .19279 L
.41758 .19279 L
.41858 .19279 L
.41958 .19279 L
.42058 .19279 L
.42158 .19279 L
.42258 .19279 L
.42358 .19279 L
.42458 .19279 L
.42557 .19279 L
.42657 .19279 L
.42757 .19279 L
.42857 .19279 L
.42957 .19279 L
.43057 .19279 L
.43157 .19279 L
.43257 .19279 L
.43357 .19279 L
.43457 .19279 L
.43556 .19279 L
.43656 .19279 L
.43756 .19279 L
.43856 .19279 L
.43956 .19279 L
.44056 .19279 L
.44156 .19279 L
.44256 .19279 L
.44356 .19279 L
.44456 .19279 L
.44555 .19279 L
.44655 .19279 L
.44755 .19279 L
.44855 .19279 L
Mistroke
.44955 .19877 L
.45055 .19877 L
.45155 .19877 L
.45255 .19877 L
.45355 .19877 L
.45455 .19877 L
.45554 .19877 L
.45654 .19877 L
.45754 .19877 L
.45854 .19877 L
.45954 .19877 L
.46054 .19877 L
.46154 .19877 L
.46254 .19877 L
.46354 .19877 L
.46454 .19877 L
.46553 .19877 L
.46653 .19877 L
.46753 .19877 L
.46853 .19877 L
.46953 .19877 L
.47053 .19877 L
.47153 .19877 L
.47253 .19877 L
.47353 .19877 L
.47453 .19877 L
.47552 .19877 L
.47652 .19877 L
.47752 .19877 L
.47852 .19877 L
.47952 .19877 L
.48052 .19877 L
.48152 .19877 L
.48252 .19877 L
.48352 .19877 L
.48452 .19877 L
.48551 .19877 L
.48651 .19877 L
.48751 .19877 L
.48851 .19877 L
.48951 .19877 L
.49051 .19877 L
.49151 .19877 L
.49251 .19877 L
.49351 .19877 L
.49451 .19877 L
.4955 .19877 L
.4965 .19877 L
.4975 .19877 L
.4985 .19877 L
Mistroke
.4995 .20545 L
.5005 .20545 L
.5015 .20545 L
.5025 .20545 L
.5035 .20545 L
.5045 .20545 L
.50549 .20545 L
.50649 .20545 L
.50749 .20545 L
.50849 .20545 L
.50949 .20545 L
.51049 .20545 L
.51149 .20545 L
.51249 .20545 L
.51349 .20545 L
.51449 .20545 L
.51548 .20545 L
.51648 .20545 L
.51748 .20545 L
.51848 .20545 L
.51948 .20545 L
.52048 .20545 L
.52148 .20545 L
.52248 .20545 L
.52348 .20545 L
.52448 .20545 L
.52547 .20545 L
.52647 .20545 L
.52747 .20545 L
.52847 .20545 L
.52947 .20545 L
.53047 .20545 L
.53147 .20545 L
.53247 .20545 L
.53347 .20545 L
.53447 .20545 L
.53546 .20545 L
.53646 .20545 L
.53746 .20545 L
.53846 .20545 L
.53946 .20545 L
.54046 .20545 L
.54146 .20545 L
.54246 .20545 L
.54346 .20545 L
.54446 .20545 L
.54545 .20545 L
.54645 .20545 L
.54745 .20545 L
.54845 .20545 L
Mistroke
.54945 .21011 L
.55045 .21011 L
.55145 .21011 L
.55245 .21011 L
.55345 .21011 L
.55445 .21011 L
.55544 .21011 L
.55644 .21011 L
.55744 .21011 L
.55844 .21011 L
.55944 .21011 L
.56044 .21011 L
.56144 .21011 L
.56244 .21011 L
.56344 .21011 L
.56444 .21011 L
.56543 .21011 L
.56643 .21011 L
.56743 .21011 L
.56843 .21011 L
.56943 .21011 L
.57043 .21011 L
.57143 .21011 L
.57243 .21011 L
.57343 .21011 L
.57443 .21011 L
.57542 .21011 L
.57642 .21011 L
.57742 .21011 L
.57842 .21011 L
.57942 .21011 L
.58042 .21011 L
.58142 .21011 L
.58242 .21011 L
.58342 .21011 L
.58442 .21011 L
.58541 .21011 L
.58641 .21011 L
.58741 .21011 L
.58841 .21011 L
.58941 .21011 L
.59041 .21011 L
.59141 .21011 L
.59241 .21011 L
.59341 .21011 L
.59441 .21011 L
.5954 .21011 L
.5964 .21011 L
.5974 .21011 L
.5984 .21011 L
Mistroke
.5994 .21173 L
.6004 .21173 L
.6014 .21173 L
.6024 .21173 L
.6034 .21173 L
.6044 .21173 L
.60539 .21173 L
.60639 .21173 L
.60739 .21173 L
.60839 .21173 L
.60939 .21173 L
.61039 .21173 L
.61139 .21173 L
.61239 .21173 L
.61339 .21173 L
.61439 .21173 L
.61538 .21173 L
.61638 .21173 L
.61738 .21173 L
.61838 .21173 L
.61938 .21173 L
.62038 .21173 L
.62138 .21173 L
.62238 .21173 L
.62338 .21173 L
.62438 .21173 L
.62537 .21173 L
.62637 .21173 L
.62737 .21173 L
.62837 .21173 L
.62937 .21173 L
.63037 .21173 L
.63137 .21173 L
.63237 .21173 L
.63337 .21173 L
.63437 .21173 L
.63536 .21173 L
.63636 .21173 L
.63736 .21173 L
.63836 .21173 L
.63936 .21173 L
.64036 .21173 L
.64136 .21173 L
.64236 .21173 L
.64336 .21173 L
.64436 .21173 L
.64535 .21173 L
.64635 .21173 L
.64735 .21173 L
.64835 .21173 L
Mistroke
.64935 .20596 L
.65035 .20596 L
.65135 .20596 L
.65235 .20596 L
.65335 .20596 L
.65435 .20596 L
.65534 .20596 L
.65634 .20596 L
.65734 .20596 L
.65834 .20596 L
.65934 .20596 L
.66034 .20596 L
.66134 .20596 L
.66234 .20596 L
.66334 .20596 L
.66434 .20596 L
.66533 .20596 L
.66633 .20596 L
.66733 .20596 L
.66833 .20596 L
.66933 .20596 L
.67033 .20596 L
.67133 .20596 L
.67233 .20596 L
.67333 .20596 L
.67433 .20596 L
.67532 .20596 L
.67632 .20596 L
.67732 .20596 L
.67832 .20596 L
.67932 .20596 L
.68032 .20596 L
.68132 .20596 L
.68232 .20596 L
.68332 .20596 L
.68432 .20596 L
.68531 .20596 L
.68631 .20596 L
.68731 .20596 L
.68831 .20596 L
.68931 .20596 L
.69031 .20596 L
.69131 .20596 L
.69231 .20596 L
.69331 .20596 L
.69431 .20596 L
.6953 .20596 L
.6963 .20596 L
.6973 .20596 L
.6983 .20596 L
Mistroke
.6993 .20939 L
.7003 .20939 L
.7013 .20939 L
.7023 .20939 L
.7033 .20939 L
.7043 .20939 L
.70529 .20939 L
.70629 .20939 L
.70729 .20939 L
.70829 .20939 L
.70929 .20939 L
.71029 .20939 L
.71129 .20939 L
.71229 .20939 L
.71329 .20939 L
.71429 .20939 L
.71528 .20939 L
.71628 .20939 L
.71728 .20939 L
.71828 .20939 L
.71928 .20939 L
.72028 .20939 L
.72128 .20939 L
.72228 .20939 L
.72328 .20939 L
.72428 .20939 L
.72527 .20939 L
.72627 .20939 L
.72727 .20939 L
.72827 .20939 L
.72927 .20939 L
.73027 .20939 L
.73127 .20939 L
.73227 .20939 L
.73327 .20939 L
.73427 .20939 L
.73526 .20939 L
.73626 .20939 L
.73726 .20939 L
.73826 .20939 L
.73926 .20939 L
.74026 .20939 L
.74126 .20939 L
.74226 .20939 L
.74326 .20939 L
.74426 .20939 L
.74525 .20939 L
.74625 .20939 L
.74725 .20939 L
.74825 .20939 L
Mistroke
.74925 .21425 L
.75025 .21425 L
.75125 .21425 L
.75225 .21425 L
.75325 .21425 L
.75425 .21425 L
.75524 .21425 L
.75624 .21425 L
.75724 .21425 L
.75824 .21425 L
.75924 .21425 L
.76024 .21425 L
.76124 .21425 L
.76224 .21425 L
.76324 .21425 L
.76424 .21425 L
.76523 .21425 L
.76623 .21425 L
.76723 .21425 L
.76823 .21425 L
.76923 .21425 L
.77023 .21425 L
.77123 .21425 L
.77223 .21425 L
.77323 .21425 L
.77423 .21425 L
.77522 .21425 L
.77622 .21425 L
.77722 .21425 L
.77822 .21425 L
.77922 .21425 L
.78022 .21425 L
.78122 .21425 L
.78222 .21425 L
.78322 .21425 L
.78422 .21425 L
.78521 .21425 L
.78621 .21425 L
.78721 .21425 L
.78821 .21425 L
.78921 .21425 L
.79021 .21425 L
.79121 .21425 L
.79221 .21425 L
.79321 .21425 L
.79421 .21425 L
.7952 .21425 L
.7962 .21425 L
.7972 .21425 L
.7982 .21425 L
Mistroke
.7992 .22297 L
.8002 .22297 L
.8012 .22297 L
.8022 .22297 L
.8032 .22297 L
.8042 .22297 L
.80519 .22297 L
.80619 .22297 L
.80719 .22297 L
.80819 .22297 L
.80919 .22297 L
.81019 .22297 L
.81119 .22297 L
.81219 .22297 L
.81319 .22297 L
.81419 .22297 L
.81518 .22297 L
.81618 .22297 L
.81718 .22297 L
.81818 .22297 L
.81918 .22297 L
.82018 .22297 L
.82118 .22297 L
.82218 .22297 L
.82318 .22297 L
.82418 .22297 L
.82517 .22297 L
.82617 .22297 L
.82717 .22297 L
.82817 .22297 L
.82917 .22297 L
.83017 .22297 L
.83117 .22297 L
.83217 .22297 L
.83317 .22297 L
.83417 .22297 L
.83516 .22297 L
.83616 .22297 L
.83716 .22297 L
.83816 .22297 L
.83916 .22297 L
.84016 .22297 L
.84116 .22297 L
.84216 .22297 L
.84316 .22297 L
.84416 .22297 L
.84515 .22297 L
.84615 .22297 L
.84715 .22297 L
.84815 .22297 L
Mistroke
.84915 .22377 L
.85015 .22377 L
.85115 .22377 L
.85215 .22377 L
.85315 .22377 L
.85415 .22377 L
.85514 .22377 L
.85614 .22377 L
.85714 .22377 L
.85814 .22377 L
.85914 .22377 L
.86014 .22377 L
.86114 .22377 L
.86214 .22377 L
.86314 .22377 L
.86414 .22377 L
.86513 .22377 L
.86613 .22377 L
.86713 .22377 L
.86813 .22377 L
.86913 .22377 L
.87013 .22377 L
.87113 .22377 L
.87213 .22377 L
.87313 .22377 L
.87413 .22377 L
.87512 .22377 L
.87612 .22377 L
.87712 .22377 L
.87812 .22377 L
.87912 .22377 L
.88012 .22377 L
.88112 .22377 L
.88212 .22377 L
.88312 .22377 L
.88412 .22377 L
.88511 .22377 L
.88611 .22377 L
.88711 .22377 L
.88811 .22377 L
.88911 .22377 L
.89011 .22377 L
.89111 .22377 L
.89211 .22377 L
.89311 .22377 L
.89411 .22377 L
.8951 .22377 L
.8961 .22377 L
.8971 .22377 L
.8981 .22377 L
Mistroke
.8991 .2131 L
.9001 .2131 L
.9011 .2131 L
.9021 .2131 L
.9031 .2131 L
.9041 .2131 L
.90509 .2131 L
.90609 .2131 L
.90709 .2131 L
.90809 .2131 L
.90909 .2131 L
.91009 .2131 L
.91109 .2131 L
.91209 .2131 L
.91309 .2131 L
.91409 .2131 L
.91508 .2131 L
.91608 .2131 L
.91708 .2131 L
.91808 .2131 L
.91908 .2131 L
.92008 .2131 L
.92108 .2131 L
.92208 .2131 L
.92308 .2131 L
.92408 .2131 L
.92507 .2131 L
.92607 .2131 L
.92707 .2131 L
.92807 .2131 L
.92907 .2131 L
.93007 .2131 L
.93107 .2131 L
.93207 .2131 L
.93307 .2131 L
.93407 .2131 L
.93506 .2131 L
.93606 .2131 L
.93706 .2131 L
.93806 .2131 L
.93906 .2131 L
.94006 .2131 L
.94106 .2131 L
.94206 .2131 L
.94306 .2131 L
.94406 .2131 L
.94505 .2131 L
.94605 .2131 L
.94705 .2131 L
.94805 .2131 L
Mistroke
.94905 .21174 L
.95005 .21174 L
.95105 .21174 L
.95205 .21174 L
.95305 .21174 L
.95405 .21174 L
.95504 .21174 L
.95604 .21174 L
.95704 .21174 L
.95804 .21174 L
.95904 .21174 L
.96004 .21174 L
.96104 .21174 L
.96204 .21174 L
.96304 .21174 L
.96404 .21174 L
.96503 .21174 L
.96603 .21174 L
.96703 .21174 L
.96803 .21174 L
.96903 .21174 L
.97003 .21174 L
.97103 .21174 L
.97203 .21174 L
.97303 .21174 L
.97403 .21174 L
.97502 .21174 L
.97602 .21174 L
.97702 .21174 L
.97802 .21174 L
.97902 .21174 L
.98002 .21174 L
.98102 .21174 L
.98202 .21174 L
.98302 .21174 L
.98402 .21174 L
.98501 .21174 L
.98601 .21174 L
.98701 .21174 L
.98801 .21174 L
.98901 .21174 L
.99001 .21174 L
.99101 .21174 L
.99201 .21174 L
.99301 .21174 L
.99401 .21174 L
.995 .21174 L
.996 .21174 L
.997 .21174 L
.998 .21174 L
Mistroke
.999 .2073 L
Mfstroke
0 0 1 r
gsave
.001 -1.8541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0 0.0772542 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -6 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -6 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -6 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -6 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -6 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -6 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(1)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(2)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(3)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(4)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(5)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(6)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(7)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .20601 m
.001 .20601 L
.002 .20601 L
.003 .20601 L
.004 .20601 L
.005 .20601 L
.00599 .20601 L
.00699 .20601 L
.00799 .20601 L
.00899 .20601 L
.00999 .20601 L
.01099 .20601 L
.01199 .20601 L
.01299 .20601 L
.01399 .20601 L
.01499 .20601 L
.01598 .20601 L
.01698 .20601 L
.01798 .20602 L
.01898 .20602 L
.01998 .20602 L
.02098 .20602 L
.02198 .20602 L
.02298 .20602 L
.02398 .20602 L
.02498 .20602 L
.02597 .20602 L
.02697 .20602 L
.02797 .20602 L
.02897 .20602 L
.02997 .20602 L
.03097 .20602 L
.03197 .20602 L
.03297 .20602 L
.03397 .20602 L
.03497 .20602 L
.03596 .20602 L
.03696 .20602 L
.03796 .20602 L
.03896 .20602 L
.03996 .20602 L
.04096 .20602 L
.04196 .20602 L
.04296 .20602 L
.04396 .20602 L
.04496 .20602 L
.04595 .20602 L
.04695 .20602 L
.04795 .20602 L
.04895 .20602 L
Mistroke
.04995 .20602 L
.05095 .20602 L
.05195 .20602 L
.05295 .20602 L
.05395 .20601 L
.05495 .20602 L
.05594 .20602 L
.05694 .20602 L
.05794 .20602 L
.05894 .20602 L
.05994 .20602 L
.06094 .20601 L
.06194 .20602 L
.06294 .20602 L
.06394 .20602 L
.06494 .20602 L
.06593 .20602 L
.06693 .20602 L
.06793 .20602 L
.06893 .20602 L
.06993 .20602 L
.07093 .20602 L
.07193 .20602 L
.07293 .20602 L
.07393 .20602 L
.07493 .20602 L
.07592 .20602 L
.07692 .20602 L
.07792 .20602 L
.07892 .20602 L
.07992 .20602 L
.08092 .20602 L
.08192 .20602 L
.08292 .20602 L
.08392 .20602 L
.08492 .20602 L
.08591 .20602 L
.08691 .20602 L
.08791 .20602 L
.08891 .20602 L
.08991 .20602 L
.09091 .20602 L
.09191 .20602 L
.09291 .20602 L
.09391 .20602 L
.09491 .20602 L
.0959 .20602 L
.0969 .20603 L
.0979 .20602 L
.0989 .20602 L
Mistroke
.0999 .20602 L
.1009 .20603 L
.1019 .20603 L
.1029 .20603 L
.1039 .20603 L
.1049 .20602 L
.10589 .20603 L
.10689 .20603 L
.10789 .20603 L
.10889 .20603 L
.10989 .20602 L
.11089 .20602 L
.11189 .20603 L
.11289 .20602 L
.11389 .20602 L
.11489 .20602 L
.11588 .20602 L
.11688 .20602 L
.11788 .20602 L
.11888 .20602 L
.11988 .20602 L
.12088 .20602 L
.12188 .20602 L
.12288 .20603 L
.12388 .20602 L
.12488 .20602 L
.12587 .20602 L
.12687 .20602 L
.12787 .20602 L
.12887 .20602 L
.12987 .20602 L
.13087 .20602 L
.13187 .20602 L
.13287 .20602 L
.13387 .20602 L
.13487 .20602 L
.13586 .20603 L
.13686 .20603 L
.13786 .20603 L
.13886 .20603 L
.13986 .20603 L
.14086 .20603 L
.14186 .20603 L
.14286 .20603 L
.14386 .20602 L
.14486 .20602 L
.14585 .20602 L
.14685 .20602 L
.14785 .20602 L
.14885 .20602 L
Mistroke
.14985 .20602 L
.15085 .20602 L
.15185 .20603 L
.15285 .20603 L
.15385 .20603 L
.15485 .20603 L
.15584 .20602 L
.15684 .20602 L
.15784 .20602 L
.15884 .20602 L
.15984 .20602 L
.16084 .20602 L
.16184 .20602 L
.16284 .20602 L
.16384 .20602 L
.16484 .20602 L
.16583 .20602 L
.16683 .20602 L
.16783 .20602 L
.16883 .20602 L
.16983 .20602 L
.17083 .20602 L
.17183 .20602 L
.17283 .20602 L
.17383 .20602 L
.17483 .20602 L
.17582 .20602 L
.17682 .20602 L
.17782 .20602 L
.17882 .20602 L
.17982 .20602 L
.18082 .20602 L
.18182 .20602 L
.18282 .20602 L
.18382 .20602 L
.18482 .20602 L
.18581 .20602 L
.18681 .20603 L
.18781 .20602 L
.18881 .20602 L
.18981 .20603 L
.19081 .20603 L
.19181 .20603 L
.19281 .20603 L
.19381 .20603 L
.19481 .20603 L
.1958 .20603 L
.1968 .20603 L
.1978 .20603 L
.1988 .20603 L
Mistroke
.1998 .20603 L
.2008 .20603 L
.2018 .20603 L
.2028 .20603 L
.2038 .20603 L
.2048 .20603 L
.20579 .20603 L
.20679 .20603 L
.20779 .20603 L
.20879 .20603 L
.20979 .20603 L
.21079 .20603 L
.21179 .20603 L
.21279 .20603 L
.21379 .20603 L
.21479 .20603 L
.21578 .20603 L
.21678 .20603 L
.21778 .20603 L
.21878 .20603 L
.21978 .20603 L
.22078 .20603 L
.22178 .20603 L
.22278 .20603 L
.22378 .20603 L
.22478 .20603 L
.22577 .20603 L
.22677 .20603 L
.22777 .20603 L
.22877 .20603 L
.22977 .20603 L
.23077 .20603 L
.23177 .20603 L
.23277 .20603 L
.23377 .20603 L
.23477 .20603 L
.23576 .20603 L
.23676 .20603 L
.23776 .20603 L
.23876 .20603 L
.23976 .20602 L
.24076 .20602 L
.24176 .20602 L
.24276 .20602 L
.24376 .20602 L
.24476 .20603 L
.24575 .20603 L
.24675 .20603 L
.24775 .20603 L
.24875 .20603 L
Mistroke
.24975 .20603 L
.25075 .20603 L
.25175 .20603 L
.25275 .20603 L
.25375 .20603 L
.25475 .20603 L
.25574 .20603 L
.25674 .20603 L
.25774 .20603 L
.25874 .20602 L
.25974 .20603 L
.26074 .20602 L
.26174 .20602 L
.26274 .20602 L
.26374 .20603 L
.26474 .20603 L
.26573 .20603 L
.26673 .20603 L
.26773 .20603 L
.26873 .20603 L
.26973 .20603 L
.27073 .20603 L
.27173 .20603 L
.27273 .20603 L
.27373 .20603 L
.27473 .20603 L
.27572 .20602 L
.27672 .20602 L
.27772 .20602 L
.27872 .20602 L
.27972 .20602 L
.28072 .20602 L
.28172 .20602 L
.28272 .20602 L
.28372 .20602 L
.28472 .20602 L
.28571 .20603 L
.28671 .20603 L
.28771 .20603 L
.28871 .20603 L
.28971 .20603 L
.29071 .20603 L
.29171 .20603 L
.29271 .20603 L
.29371 .20603 L
.29471 .20603 L
.2957 .20603 L
.2967 .20603 L
.2977 .20603 L
.2987 .20603 L
Mistroke
.2997 .20603 L
.3007 .20603 L
.3017 .20603 L
.3027 .20603 L
.3037 .20603 L
.3047 .20603 L
.30569 .20603 L
.30669 .20603 L
.30769 .20603 L
.30869 .20603 L
.30969 .20603 L
.31069 .20603 L
.31169 .20603 L
.31269 .20603 L
.31369 .20603 L
.31469 .20603 L
.31568 .20603 L
.31668 .20603 L
.31768 .20603 L
.31868 .20603 L
.31968 .20603 L
.32068 .20603 L
.32168 .20603 L
.32268 .20603 L
.32368 .20603 L
.32468 .20603 L
.32567 .20603 L
.32667 .20603 L
.32767 .20603 L
.32867 .20603 L
.32967 .20603 L
.33067 .20603 L
.33167 .20603 L
.33267 .20603 L
.33367 .20603 L
.33467 .20603 L
.33566 .20603 L
.33666 .20603 L
.33766 .20603 L
.33866 .20603 L
.33966 .20603 L
.34066 .20603 L
.34166 .20603 L
.34266 .20604 L
.34366 .20603 L
.34466 .20603 L
.34565 .20604 L
.34665 .20603 L
.34765 .20604 L
.34865 .20604 L
Mistroke
.34965 .20603 L
.35065 .20603 L
.35165 .20603 L
.35265 .20604 L
.35365 .20603 L
.35465 .20603 L
.35564 .20603 L
.35664 .20603 L
.35764 .20603 L
.35864 .20603 L
.35964 .20603 L
.36064 .20604 L
.36164 .20604 L
.36264 .20604 L
.36364 .20604 L
.36464 .20604 L
.36563 .20604 L
.36663 .20604 L
.36763 .20604 L
.36863 .20604 L
.36963 .20604 L
.37063 .20604 L
.37163 .20604 L
.37263 .20604 L
.37363 .20604 L
.37463 .20604 L
.37562 .20604 L
.37662 .20604 L
.37762 .20604 L
.37862 .20604 L
.37962 .20604 L
.38062 .20604 L
.38162 .20604 L
.38262 .20604 L
.38362 .20604 L
.38462 .20604 L
.38561 .20603 L
.38661 .20604 L
.38761 .20604 L
.38861 .20604 L
.38961 .20604 L
.39061 .20604 L
.39161 .20604 L
.39261 .20604 L
.39361 .20604 L
.39461 .20604 L
.3956 .20604 L
.3966 .20604 L
.3976 .20604 L
.3986 .20604 L
Mistroke
.3996 .20604 L
.4006 .20604 L
.4016 .20604 L
.4026 .20604 L
.4036 .20604 L
.4046 .20604 L
.40559 .20604 L
.40659 .20604 L
.40759 .20604 L
.40859 .20604 L
.40959 .20604 L
.41059 .20604 L
.41159 .20604 L
.41259 .20604 L
.41359 .20604 L
.41459 .20604 L
.41558 .20604 L
.41658 .20604 L
.41758 .20604 L
.41858 .20604 L
.41958 .20604 L
.42058 .20604 L
.42158 .20604 L
.42258 .20604 L
.42358 .20604 L
.42458 .20604 L
.42557 .20604 L
.42657 .20604 L
.42757 .20604 L
.42857 .20604 L
.42957 .20604 L
.43057 .20604 L
.43157 .20604 L
.43257 .20604 L
.43357 .20604 L
.43457 .20604 L
.43556 .20604 L
.43656 .20604 L
.43756 .20604 L
.43856 .20604 L
.43956 .20604 L
.44056 .20604 L
.44156 .20604 L
.44256 .20604 L
.44356 .20604 L
.44456 .20604 L
.44555 .20604 L
.44655 .20604 L
.44755 .20604 L
.44855 .20604 L
Mistroke
.44955 .20604 L
.45055 .20604 L
.45155 .20604 L
.45255 .20604 L
.45355 .20604 L
.45455 .20604 L
.45554 .20604 L
.45654 .20603 L
.45754 .20604 L
.45854 .20604 L
.45954 .20604 L
.46054 .20604 L
.46154 .20604 L
.46254 .20604 L
.46354 .20604 L
.46454 .20604 L
.46553 .20604 L
.46653 .20604 L
.46753 .20604 L
.46853 .20604 L
.46953 .20604 L
.47053 .20604 L
.47153 .20604 L
.47253 .20604 L
.47353 .20604 L
.47453 .20604 L
.47552 .20604 L
.47652 .20604 L
.47752 .20604 L
.47852 .20604 L
.47952 .20604 L
.48052 .20604 L
.48152 .20604 L
.48252 .20604 L
.48352 .20604 L
.48452 .20605 L
.48551 .20604 L
.48651 .20604 L
.48751 .20604 L
.48851 .20604 L
.48951 .20604 L
.49051 .20604 L
.49151 .20605 L
.49251 .20604 L
.49351 .20605 L
.49451 .20605 L
.4955 .20605 L
.4965 .20605 L
.4975 .20604 L
.4985 .20604 L
Mistroke
.4995 .20604 L
.5005 .20604 L
.5015 .20604 L
.5025 .20604 L
.5035 .20604 L
.5045 .20604 L
.50549 .20604 L
.50649 .20604 L
.50749 .20604 L
.50849 .20604 L
.50949 .20604 L
.51049 .20604 L
.51149 .20604 L
.51249 .20604 L
.51349 .20604 L
.51449 .20604 L
.51548 .20604 L
.51648 .20604 L
.51748 .20604 L
.51848 .20604 L
.51948 .20604 L
.52048 .20604 L
.52148 .20604 L
.52248 .20604 L
.52348 .20604 L
.52448 .20604 L
.52547 .20604 L
.52647 .20604 L
.52747 .20604 L
.52847 .20604 L
.52947 .20604 L
.53047 .20605 L
.53147 .20605 L
.53247 .20605 L
.53347 .20605 L
.53447 .20605 L
.53546 .20605 L
.53646 .20605 L
.53746 .20605 L
.53846 .20605 L
.53946 .20604 L
.54046 .20604 L
.54146 .20604 L
.54246 .20604 L
.54346 .20604 L
.54446 .20604 L
.54545 .20604 L
.54645 .20604 L
.54745 .20604 L
.54845 .20604 L
Mistroke
.54945 .20604 L
.55045 .20604 L
.55145 .20604 L
.55245 .20604 L
.55345 .20604 L
.55445 .20604 L
.55544 .20605 L
.55644 .20605 L
.55744 .20604 L
.55844 .20605 L
.55944 .20605 L
.56044 .20605 L
.56144 .20605 L
.56244 .20604 L
.56344 .20604 L
.56444 .20604 L
.56543 .20604 L
.56643 .20604 L
.56743 .20604 L
.56843 .20604 L
.56943 .20604 L
.57043 .20604 L
.57143 .20605 L
.57243 .20605 L
.57343 .20605 L
.57443 .20605 L
.57542 .20605 L
.57642 .20605 L
.57742 .20605 L
.57842 .20605 L
.57942 .20605 L
.58042 .20605 L
.58142 .20605 L
.58242 .20605 L
.58342 .20605 L
.58442 .20604 L
.58541 .20604 L
.58641 .20604 L
.58741 .20605 L
.58841 .20604 L
.58941 .20605 L
.59041 .20605 L
.59141 .20605 L
.59241 .20605 L
.59341 .20605 L
.59441 .20605 L
.5954 .20604 L
.5964 .20604 L
.5974 .20604 L
.5984 .20604 L
Mistroke
.5994 .20605 L
.6004 .20605 L
.6014 .20605 L
.6024 .20605 L
.6034 .20605 L
.6044 .20605 L
.60539 .20605 L
.60639 .20605 L
.60739 .20605 L
.60839 .20605 L
.60939 .20605 L
.61039 .20604 L
.61139 .20604 L
.61239 .20604 L
.61339 .20604 L
.61439 .20604 L
.61538 .20604 L
.61638 .20604 L
.61738 .20604 L
.61838 .20604 L
.61938 .20604 L
.62038 .20604 L
.62138 .20604 L
.62238 .20604 L
.62338 .20604 L
.62438 .20604 L
.62537 .20604 L
.62637 .20604 L
.62737 .20604 L
.62837 .20604 L
.62937 .20604 L
.63037 .20605 L
.63137 .20605 L
.63237 .20605 L
.63337 .20605 L
.63437 .20605 L
.63536 .20605 L
.63636 .20605 L
.63736 .20605 L
.63836 .20605 L
.63936 .20605 L
.64036 .20605 L
.64136 .20605 L
.64236 .20605 L
.64336 .20605 L
.64436 .20605 L
.64535 .20605 L
.64635 .20605 L
.64735 .20605 L
.64835 .20605 L
Mistroke
.64935 .20605 L
.65035 .20605 L
.65135 .20605 L
.65235 .20605 L
.65335 .20605 L
.65435 .20605 L
.65534 .20605 L
.65634 .20605 L
.65734 .20605 L
.65834 .20605 L
.65934 .20605 L
.66034 .20605 L
.66134 .20605 L
.66234 .20605 L
.66334 .20605 L
.66434 .20605 L
.66533 .20605 L
.66633 .20605 L
.66733 .20605 L
.66833 .20605 L
.66933 .20605 L
.67033 .20605 L
.67133 .20605 L
.67233 .20605 L
.67333 .20605 L
.67433 .20605 L
.67532 .20605 L
.67632 .20605 L
.67732 .20605 L
.67832 .20605 L
.67932 .20605 L
.68032 .20605 L
.68132 .20605 L
.68232 .20605 L
.68332 .20605 L
.68432 .20605 L
.68531 .20605 L
.68631 .20605 L
.68731 .20605 L
.68831 .20605 L
.68931 .20605 L
.69031 .20605 L
.69131 .20605 L
.69231 .20605 L
.69331 .20605 L
.69431 .20605 L
.6953 .20605 L
.6963 .20605 L
.6973 .20605 L
.6983 .20605 L
Mistroke
.6993 .20605 L
.7003 .20605 L
.7013 .20605 L
.7023 .20605 L
.7033 .20605 L
.7043 .20605 L
.70529 .20605 L
.70629 .20605 L
.70729 .20605 L
.70829 .20605 L
.70929 .20605 L
.71029 .20605 L
.71129 .20605 L
.71229 .20605 L
.71329 .20605 L
.71429 .20605 L
.71528 .20605 L
.71628 .20605 L
.71728 .20604 L
.71828 .20604 L
.71928 .20604 L
.72028 .20604 L
.72128 .20605 L
.72228 .20605 L
.72328 .20605 L
.72428 .20605 L
.72527 .20605 L
.72627 .20605 L
.72727 .20605 L
.72827 .20605 L
.72927 .20605 L
.73027 .20605 L
.73127 .20605 L
.73227 .20605 L
.73327 .20605 L
.73427 .20605 L
.73526 .20605 L
.73626 .20605 L
.73726 .20605 L
.73826 .20605 L
.73926 .20605 L
.74026 .20605 L
.74126 .20605 L
.74226 .20605 L
.74326 .20605 L
.74426 .20605 L
.74525 .20605 L
.74625 .20605 L
.74725 .20605 L
.74825 .20605 L
Mistroke
.74925 .20605 L
.75025 .20605 L
.75125 .20605 L
.75225 .20605 L
.75325 .20605 L
.75425 .20606 L
.75524 .20606 L
.75624 .20606 L
.75724 .20606 L
.75824 .20606 L
.75924 .20605 L
.76024 .20605 L
.76124 .20605 L
.76224 .20605 L
.76324 .20606 L
.76424 .20606 L
.76523 .20606 L
.76623 .20606 L
.76723 .20606 L
.76823 .20606 L
.76923 .20606 L
.77023 .20606 L
.77123 .20606 L
.77223 .20606 L
.77323 .20606 L
.77423 .20606 L
.77522 .20606 L
.77622 .20606 L
.77722 .20606 L
.77822 .20606 L
.77922 .20606 L
.78022 .20606 L
.78122 .20606 L
.78222 .20606 L
.78322 .20606 L
.78422 .20606 L
.78521 .20606 L
.78621 .20606 L
.78721 .20606 L
.78821 .20606 L
.78921 .20606 L
.79021 .20606 L
.79121 .20606 L
.79221 .20606 L
.79321 .20606 L
.79421 .20606 L
.7952 .20606 L
.7962 .20606 L
.7972 .20606 L
.7982 .20606 L
Mistroke
.7992 .20606 L
.8002 .20606 L
.8012 .20607 L
.8022 .20606 L
.8032 .20607 L
.8042 .20607 L
.80519 .20606 L
.80619 .20606 L
.80719 .20606 L
.80819 .20606 L
.80919 .20606 L
.81019 .20606 L
.81119 .20607 L
.81219 .20607 L
.81319 .20607 L
.81419 .20607 L
.81518 .20607 L
.81618 .20607 L
.81718 .20606 L
.81818 .20606 L
.81918 .20606 L
.82018 .20606 L
.82118 .20606 L
.82218 .20606 L
.82318 .20606 L
.82418 .20606 L
.82517 .20606 L
.82617 .20606 L
.82717 .20606 L
.82817 .20606 L
.82917 .20606 L
.83017 .20606 L
.83117 .20606 L
.83217 .20606 L
.83317 .20607 L
.83417 .20607 L
.83516 .20607 L
.83616 .20607 L
.83716 .20607 L
.83816 .20607 L
.83916 .20607 L
.84016 .20607 L
.84116 .20606 L
.84216 .20606 L
.84316 .20606 L
.84416 .20606 L
.84515 .20606 L
.84615 .20607 L
.84715 .20606 L
.84815 .20606 L
Mistroke
.84915 .20606 L
.85015 .20606 L
.85115 .20606 L
.85215 .20606 L
.85315 .20606 L
.85415 .20607 L
.85514 .20607 L
.85614 .20607 L
.85714 .20607 L
.85814 .20607 L
.85914 .20607 L
.86014 .20607 L
.86114 .20607 L
.86214 .20607 L
.86314 .20607 L
.86414 .20607 L
.86513 .20607 L
.86613 .20607 L
.86713 .20607 L
.86813 .20607 L
.86913 .20607 L
.87013 .20607 L
.87113 .20607 L
.87213 .20607 L
.87313 .20607 L
.87413 .20607 L
.87512 .20607 L
.87612 .20607 L
.87712 .20607 L
.87812 .20607 L
.87912 .20607 L
.88012 .20607 L
.88112 .20607 L
.88212 .20607 L
.88312 .20607 L
.88412 .20607 L
.88511 .20607 L
.88611 .20607 L
.88711 .20607 L
.88811 .20607 L
.88911 .20607 L
.89011 .20607 L
.89111 .20607 L
.89211 .20607 L
.89311 .20607 L
.89411 .20607 L
.8951 .20607 L
.8961 .20607 L
.8971 .20607 L
.8981 .20607 L
Mistroke
.8991 .20606 L
.9001 .20607 L
.9011 .20607 L
.9021 .20606 L
.9031 .20606 L
.9041 .20606 L
.90509 .20606 L
.90609 .20606 L
.90709 .20606 L
.90809 .20606 L
.90909 .20606 L
.91009 .20606 L
.91109 .20606 L
.91209 .20606 L
.91309 .20606 L
.91409 .20606 L
.91508 .20606 L
.91608 .20606 L
.91708 .20606 L
.91808 .20606 L
.91908 .20606 L
.92008 .20606 L
.92108 .20607 L
.92208 .20606 L
.92308 .20606 L
.92408 .20606 L
.92507 .20606 L
.92607 .20606 L
.92707 .20606 L
.92807 .20606 L
.92907 .20606 L
.93007 .20606 L
.93107 .20606 L
.93207 .20606 L
.93307 .20606 L
.93407 .20606 L
.93506 .20606 L
.93606 .20606 L
.93706 .20606 L
.93806 .20606 L
.93906 .20606 L
.94006 .20606 L
.94106 .20606 L
.94206 .20606 L
.94306 .20606 L
.94406 .20606 L
.94505 .20606 L
.94605 .20606 L
.94705 .20606 L
.94805 .20606 L
Mistroke
.94905 .20606 L
.95005 .20606 L
.95105 .20606 L
.95205 .20606 L
.95305 .20606 L
.95405 .20606 L
.95504 .20606 L
.95604 .20606 L
.95704 .20606 L
.95804 .20606 L
.95904 .20606 L
.96004 .20606 L
.96104 .20606 L
.96204 .20606 L
.96304 .20606 L
.96404 .20606 L
.96503 .20606 L
.96603 .20606 L
.96703 .20606 L
.96803 .20606 L
.96903 .20607 L
.97003 .20607 L
.97103 .20607 L
.97203 .20606 L
.97303 .20606 L
.97403 .20606 L
.97502 .20606 L
.97602 .20606 L
.97702 .20606 L
.97802 .20606 L
.97902 .20606 L
.98002 .20606 L
.98102 .20606 L
.98202 .20606 L
.98302 .20606 L
.98402 .20606 L
.98501 .20606 L
.98601 .20606 L
.98701 .20606 L
.98801 .20606 L
.98901 .20606 L
.99001 .20606 L
.99101 .20606 L
.99201 .20606 L
.99301 .20606 L
.99401 .20607 L
.995 .20607 L
.996 .20607 L
.997 .20607 L
.998 .20607 L
Mistroke
.999 .20607 L
Mfstroke
0 .98 .604 r
gsave
.999 .19682 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .13185 m
.001 .13185 L
.002 .13185 L
.003 .13185 L
.004 .13185 L
.005 .13185 L
.00599 .13185 L
.00699 .13185 L
.00799 .13185 L
.00899 .13185 L
.00999 .13185 L
.01099 .13185 L
.01199 .13185 L
.01299 .13185 L
.01399 .13185 L
.01499 .13185 L
.01598 .13185 L
.01698 .13185 L
.01798 .13185 L
.01898 .13185 L
.01998 .13185 L
.02098 .13185 L
.02198 .13185 L
.02298 .13185 L
.02398 .13185 L
.02498 .13185 L
.02597 .13185 L
.02697 .13185 L
.02797 .13185 L
.02897 .13185 L
.02997 .13185 L
.03097 .13185 L
.03197 .13185 L
.03297 .13185 L
.03397 .13185 L
.03497 .13185 L
.03596 .13185 L
.03696 .13185 L
.03796 .13185 L
.03896 .13185 L
.03996 .13185 L
.04096 .13185 L
.04196 .13185 L
.04296 .13185 L
.04396 .13185 L
.04496 .13185 L
.04595 .13185 L
.04695 .13185 L
.04795 .13185 L
.04895 .13185 L
Mistroke
.04995 .082 L
.05095 .082 L
.05195 .082 L
.05295 .082 L
.05395 .082 L
.05495 .082 L
.05594 .082 L
.05694 .082 L
.05794 .082 L
.05894 .082 L
.05994 .082 L
.06094 .082 L
.06194 .082 L
.06294 .082 L
.06394 .082 L
.06494 .082 L
.06593 .082 L
.06693 .082 L
.06793 .082 L
.06893 .082 L
.06993 .082 L
.07093 .082 L
.07193 .082 L
.07293 .082 L
.07393 .082 L
.07493 .082 L
.07592 .082 L
.07692 .082 L
.07792 .082 L
.07892 .082 L
.07992 .082 L
.08092 .082 L
.08192 .082 L
.08292 .082 L
.08392 .082 L
.08492 .082 L
.08591 .082 L
.08691 .082 L
.08791 .082 L
.08891 .082 L
.08991 .082 L
.09091 .082 L
.09191 .082 L
.09291 .082 L
.09391 .082 L
.09491 .082 L
.0959 .082 L
.0969 .082 L
.0979 .082 L
.0989 .082 L
Mistroke
.0999 .17835 L
.1009 .17835 L
.1019 .17835 L
.1029 .17835 L
.1039 .17835 L
.1049 .17835 L
.10589 .17835 L
.10689 .17835 L
.10789 .17835 L
.10889 .17835 L
.10989 .17835 L
.11089 .17835 L
.11189 .17835 L
.11289 .17835 L
.11389 .17835 L
.11489 .17835 L
.11588 .17835 L
.11688 .17835 L
.11788 .17835 L
.11888 .17835 L
.11988 .17835 L
.12088 .17835 L
.12188 .17835 L
.12288 .17835 L
.12388 .17835 L
.12488 .17835 L
.12587 .17835 L
.12687 .17835 L
.12787 .17835 L
.12887 .17835 L
.12987 .17835 L
.13087 .17835 L
.13187 .17835 L
.13287 .17835 L
.13387 .17835 L
.13487 .17835 L
.13586 .17835 L
.13686 .17835 L
.13786 .17835 L
.13886 .17835 L
.13986 .17835 L
.14086 .17835 L
.14186 .17835 L
.14286 .17835 L
.14386 .17835 L
.14486 .17835 L
.14585 .17835 L
.14685 .17835 L
.14785 .17835 L
.14885 .17835 L
Mistroke
.14985 .205 L
.15085 .205 L
.15185 .205 L
.15285 .205 L
.15385 .205 L
.15485 .205 L
.15584 .205 L
.15684 .205 L
.15784 .205 L
.15884 .205 L
.15984 .205 L
.16084 .205 L
.16184 .205 L
.16284 .205 L
.16384 .205 L
.16484 .205 L
.16583 .205 L
.16683 .205 L
.16783 .205 L
.16883 .205 L
.16983 .205 L
.17083 .205 L
.17183 .205 L
.17283 .205 L
.17383 .205 L
.17483 .205 L
.17582 .205 L
.17682 .205 L
.17782 .205 L
.17882 .205 L
.17982 .205 L
.18082 .205 L
.18182 .205 L
.18282 .205 L
.18382 .205 L
.18482 .205 L
.18581 .205 L
.18681 .205 L
.18781 .205 L
.18881 .205 L
.18981 .205 L
.19081 .205 L
.19181 .205 L
.19281 .205 L
.19381 .205 L
.19481 .205 L
.1958 .205 L
.1968 .205 L
.1978 .205 L
.1988 .205 L
Mistroke
.1998 .20803 L
.2008 .20803 L
.2018 .20803 L
.2028 .20803 L
.2038 .20803 L
.2048 .20803 L
.20579 .20803 L
.20679 .20803 L
.20779 .20803 L
.20879 .20803 L
.20979 .20803 L
.21079 .20803 L
.21179 .20803 L
.21279 .20803 L
.21379 .20803 L
.21479 .20803 L
.21578 .20803 L
.21678 .20803 L
.21778 .20803 L
.21878 .20803 L
.21978 .20803 L
.22078 .20803 L
.22178 .20803 L
.22278 .20803 L
.22378 .20803 L
.22478 .20803 L
.22577 .20803 L
.22677 .20803 L
.22777 .20803 L
.22877 .20803 L
.22977 .20803 L
.23077 .20803 L
.23177 .20803 L
.23277 .20803 L
.23377 .20803 L
.23477 .20803 L
.23576 .20803 L
.23676 .20803 L
.23776 .20803 L
.23876 .20803 L
.23976 .20803 L
.24076 .20803 L
.24176 .20803 L
.24276 .20803 L
.24376 .20803 L
.24476 .20803 L
.24575 .20803 L
.24675 .20803 L
.24775 .20803 L
.24875 .20803 L
Mistroke
.24975 .18763 L
.25075 .18763 L
.25175 .18763 L
.25275 .18763 L
.25375 .18763 L
.25475 .18763 L
.25574 .18763 L
.25674 .18763 L
.25774 .18763 L
.25874 .18763 L
.25974 .18763 L
.26074 .18763 L
.26174 .18763 L
.26274 .18763 L
.26374 .18763 L
.26474 .18763 L
.26573 .18763 L
.26673 .18763 L
.26773 .18763 L
.26873 .18763 L
.26973 .18763 L
.27073 .18763 L
.27173 .18763 L
.27273 .18763 L
.27373 .18763 L
.27473 .18763 L
.27572 .18763 L
.27672 .18763 L
.27772 .18763 L
.27872 .18763 L
.27972 .18763 L
.28072 .18763 L
.28172 .18763 L
.28272 .18763 L
.28372 .18763 L
.28472 .18763 L
.28571 .18763 L
.28671 .18763 L
.28771 .18763 L
.28871 .18763 L
.28971 .18763 L
.29071 .18763 L
.29171 .18763 L
.29271 .18763 L
.29371 .18763 L
.29471 .18763 L
.2957 .18763 L
.2967 .18763 L
.2977 .18763 L
.2987 .18763 L
Mistroke
.2997 .18813 L
.3007 .18813 L
.3017 .18813 L
.3027 .18813 L
.3037 .18813 L
.3047 .18813 L
.30569 .18813 L
.30669 .18813 L
.30769 .18813 L
.30869 .18813 L
.30969 .18813 L
.31069 .18813 L
.31169 .18813 L
.31269 .18813 L
.31369 .18813 L
.31469 .18813 L
.31568 .18813 L
.31668 .18813 L
.31768 .18813 L
.31868 .18813 L
.31968 .18813 L
.32068 .18813 L
.32168 .18813 L
.32268 .18813 L
.32368 .18813 L
.32468 .18813 L
.32567 .18813 L
.32667 .18813 L
.32767 .18813 L
.32867 .18813 L
.32967 .18813 L
.33067 .18813 L
.33167 .18813 L
.33267 .18813 L
.33367 .18813 L
.33467 .18813 L
.33566 .18813 L
.33666 .18813 L
.33766 .18813 L
.33866 .18813 L
.33966 .18813 L
.34066 .18813 L
.34166 .18813 L
.34266 .18813 L
.34366 .18813 L
.34466 .18813 L
.34565 .18813 L
.34665 .18813 L
.34765 .18813 L
.34865 .18813 L
Mistroke
.34965 .18514 L
.35065 .18514 L
.35165 .18514 L
.35265 .18514 L
.35365 .18514 L
.35465 .18514 L
.35564 .18514 L
.35664 .18514 L
.35764 .18514 L
.35864 .18514 L
.35964 .18514 L
.36064 .18514 L
.36164 .18514 L
.36264 .18514 L
.36364 .18514 L
.36464 .18514 L
.36563 .18514 L
.36663 .18514 L
.36763 .18514 L
.36863 .18514 L
.36963 .18514 L
.37063 .18514 L
.37163 .18514 L
.37263 .18514 L
.37363 .18514 L
.37463 .18514 L
.37562 .18514 L
.37662 .18514 L
.37762 .18514 L
.37862 .18514 L
.37962 .18514 L
.38062 .18514 L
.38162 .18514 L
.38262 .18514 L
.38362 .18514 L
.38462 .18514 L
.38561 .18514 L
.38661 .18514 L
.38761 .18514 L
.38861 .18514 L
.38961 .18514 L
.39061 .18514 L
.39161 .18514 L
.39261 .18514 L
.39361 .18514 L
.39461 .18514 L
.3956 .18514 L
.3966 .18514 L
.3976 .18514 L
.3986 .18514 L
Mistroke
.3996 .17141 L
.4006 .17141 L
.4016 .17141 L
.4026 .17141 L
.4036 .17141 L
.4046 .17141 L
.40559 .17141 L
.40659 .17141 L
.40759 .17141 L
.40859 .17141 L
.40959 .17141 L
.41059 .17141 L
.41159 .17141 L
.41259 .17141 L
.41359 .17141 L
.41459 .17141 L
.41558 .17141 L
.41658 .17141 L
.41758 .17141 L
.41858 .17141 L
.41958 .17141 L
.42058 .17141 L
.42158 .17141 L
.42258 .17141 L
.42358 .17141 L
.42458 .17141 L
.42557 .17141 L
.42657 .17141 L
.42757 .17141 L
.42857 .17141 L
.42957 .17141 L
.43057 .17141 L
.43157 .17141 L
.43257 .17141 L
.43357 .17141 L
.43457 .17141 L
.43556 .17141 L
.43656 .17141 L
.43756 .17141 L
.43856 .17141 L
.43956 .17141 L
.44056 .17141 L
.44156 .17141 L
.44256 .17141 L
.44356 .17141 L
.44456 .17141 L
.44555 .17141 L
.44655 .17141 L
.44755 .17141 L
.44855 .17141 L
Mistroke
.44955 .16798 L
.45055 .16798 L
.45155 .16798 L
.45255 .16798 L
.45355 .16798 L
.45455 .16798 L
.45554 .16798 L
.45654 .16798 L
.45754 .16798 L
.45854 .16798 L
.45954 .16798 L
.46054 .16798 L
.46154 .16798 L
.46254 .16798 L
.46354 .16798 L
.46454 .16798 L
.46553 .16798 L
.46653 .16798 L
.46753 .16798 L
.46853 .16798 L
.46953 .16798 L
.47053 .16798 L
.47153 .16798 L
.47253 .16798 L
.47353 .16798 L
.47453 .16798 L
.47552 .16798 L
.47652 .16798 L
.47752 .16798 L
.47852 .16798 L
.47952 .16798 L
.48052 .16798 L
.48152 .16798 L
.48252 .16798 L
.48352 .16798 L
.48452 .16798 L
.48551 .16798 L
.48651 .16798 L
.48751 .16798 L
.48851 .16798 L
.48951 .16798 L
.49051 .16798 L
.49151 .16798 L
.49251 .16798 L
.49351 .16798 L
.49451 .16798 L
.4955 .16798 L
.4965 .16798 L
.4975 .16798 L
.4985 .16798 L
Mistroke
.4995 .17683 L
.5005 .17683 L
.5015 .17683 L
.5025 .17683 L
.5035 .17683 L
.5045 .17683 L
.50549 .17683 L
.50649 .17683 L
.50749 .17683 L
.50849 .17683 L
.50949 .17683 L
.51049 .17683 L
.51149 .17683 L
.51249 .17683 L
.51349 .17683 L
.51449 .17683 L
.51548 .17683 L
.51648 .17683 L
.51748 .17683 L
.51848 .17683 L
.51948 .17683 L
.52048 .17683 L
.52148 .17683 L
.52248 .17683 L
.52348 .17683 L
.52448 .17683 L
.52547 .17683 L
.52647 .17683 L
.52747 .17683 L
.52847 .17683 L
.52947 .17683 L
.53047 .17683 L
.53147 .17683 L
.53247 .17683 L
.53347 .17683 L
.53447 .17683 L
.53546 .17683 L
.53646 .17683 L
.53746 .17683 L
.53846 .17683 L
.53946 .17683 L
.54046 .17683 L
.54146 .17683 L
.54246 .17683 L
.54346 .17683 L
.54446 .17683 L
.54545 .17683 L
.54645 .17683 L
.54745 .17683 L
.54845 .17683 L
Mistroke
.54945 .18238 L
.55045 .18238 L
.55145 .18238 L
.55245 .18238 L
.55345 .18238 L
.55445 .18238 L
.55544 .18238 L
.55644 .18238 L
.55744 .18238 L
.55844 .18238 L
.55944 .18238 L
.56044 .18238 L
.56144 .18238 L
.56244 .18238 L
.56344 .18238 L
.56444 .18238 L
.56543 .18238 L
.56643 .18238 L
.56743 .18238 L
.56843 .18238 L
.56943 .18238 L
.57043 .18238 L
.57143 .18238 L
.57243 .18238 L
.57343 .18238 L
.57443 .18238 L
.57542 .18238 L
.57642 .18238 L
.57742 .18238 L
.57842 .18238 L
.57942 .18238 L
.58042 .18238 L
.58142 .18238 L
.58242 .18238 L
.58342 .18238 L
.58442 .18238 L
.58541 .18238 L
.58641 .18238 L
.58741 .18238 L
.58841 .18238 L
.58941 .18238 L
.59041 .18238 L
.59141 .18238 L
.59241 .18238 L
.59341 .18238 L
.59441 .18238 L
.5954 .18238 L
.5964 .18238 L
.5974 .18238 L
.5984 .18238 L
Mistroke
.5994 .1839 L
.6004 .1839 L
.6014 .1839 L
.6024 .1839 L
.6034 .1839 L
.6044 .1839 L
.60539 .1839 L
.60639 .1839 L
.60739 .1839 L
.60839 .1839 L
.60939 .1839 L
.61039 .1839 L
.61139 .1839 L
.61239 .1839 L
.61339 .1839 L
.61439 .1839 L
.61538 .1839 L
.61638 .1839 L
.61738 .1839 L
.61838 .1839 L
.61938 .1839 L
.62038 .1839 L
.62138 .1839 L
.62238 .1839 L
.62338 .1839 L
.62438 .1839 L
.62537 .1839 L
.62637 .1839 L
.62737 .1839 L
.62837 .1839 L
.62937 .1839 L
.63037 .1839 L
.63137 .1839 L
.63237 .1839 L
.63337 .1839 L
.63437 .1839 L
.63536 .1839 L
.63636 .1839 L
.63736 .1839 L
.63836 .1839 L
.63936 .1839 L
.64036 .1839 L
.64136 .1839 L
.64236 .1839 L
.64336 .1839 L
.64436 .1839 L
.64535 .1839 L
.64635 .1839 L
.64735 .1839 L
.64835 .1839 L
Mistroke
.64935 .18475 L
.65035 .18475 L
.65135 .18475 L
.65235 .18475 L
.65335 .18475 L
.65435 .18475 L
.65534 .18475 L
.65634 .18475 L
.65734 .18475 L
.65834 .18475 L
.65934 .18475 L
.66034 .18475 L
.66134 .18475 L
.66234 .18475 L
.66334 .18475 L
.66434 .18475 L
.66533 .18475 L
.66633 .18475 L
.66733 .18475 L
.66833 .18475 L
.66933 .18475 L
.67033 .18475 L
.67133 .18475 L
.67233 .18475 L
.67333 .18475 L
.67433 .18475 L
.67532 .18475 L
.67632 .18475 L
.67732 .18475 L
.67832 .18475 L
.67932 .18475 L
.68032 .18475 L
.68132 .18475 L
.68232 .18475 L
.68332 .18475 L
.68432 .18475 L
.68531 .18475 L
.68631 .18475 L
.68731 .18475 L
.68831 .18475 L
.68931 .18475 L
.69031 .18475 L
.69131 .18475 L
.69231 .18475 L
.69331 .18475 L
.69431 .18475 L
.6953 .18475 L
.6963 .18475 L
.6973 .18475 L
.6983 .18475 L
Mistroke
.6993 .18453 L
.7003 .18453 L
.7013 .18453 L
.7023 .18453 L
.7033 .18453 L
.7043 .18453 L
.70529 .18453 L
.70629 .18453 L
.70729 .18453 L
.70829 .18453 L
.70929 .18453 L
.71029 .18453 L
.71129 .18453 L
.71229 .18453 L
.71329 .18453 L
.71429 .18453 L
.71528 .18453 L
.71628 .18453 L
.71728 .18453 L
.71828 .18453 L
.71928 .18453 L
.72028 .18453 L
.72128 .18453 L
.72228 .18453 L
.72328 .18453 L
.72428 .18453 L
.72527 .18453 L
.72627 .18453 L
.72727 .18453 L
.72827 .18453 L
.72927 .18453 L
.73027 .18453 L
.73127 .18453 L
.73227 .18453 L
.73327 .18453 L
.73427 .18453 L
.73526 .18453 L
.73626 .18453 L
.73726 .18453 L
.73826 .18453 L
.73926 .18453 L
.74026 .18453 L
.74126 .18453 L
.74226 .18453 L
.74326 .18453 L
.74426 .18453 L
.74525 .18453 L
.74625 .18453 L
.74725 .18453 L
.74825 .18453 L
Mistroke
.74925 .18801 L
.75025 .18801 L
.75125 .18801 L
.75225 .18801 L
.75325 .18801 L
.75425 .18801 L
.75524 .18801 L
.75624 .18801 L
.75724 .18801 L
.75824 .18801 L
.75924 .18801 L
.76024 .18801 L
.76124 .18801 L
.76224 .18801 L
.76324 .18801 L
.76424 .18801 L
.76523 .18801 L
.76623 .18801 L
.76723 .18801 L
.76823 .18801 L
.76923 .18801 L
.77023 .18801 L
.77123 .18801 L
.77223 .18801 L
.77323 .18801 L
.77423 .18801 L
.77522 .18801 L
.77622 .18801 L
.77722 .18801 L
.77822 .18801 L
.77922 .18801 L
.78022 .18801 L
.78122 .18801 L
.78222 .18801 L
.78322 .18801 L
.78422 .18801 L
.78521 .18801 L
.78621 .18801 L
.78721 .18801 L
.78821 .18801 L
.78921 .18801 L
.79021 .18801 L
.79121 .18801 L
.79221 .18801 L
.79321 .18801 L
.79421 .18801 L
.7952 .18801 L
.7962 .18801 L
.7972 .18801 L
.7982 .18801 L
Mistroke
.7992 .18982 L
.8002 .18982 L
.8012 .18982 L
.8022 .18982 L
.8032 .18982 L
.8042 .18982 L
.80519 .18982 L
.80619 .18982 L
.80719 .18982 L
.80819 .18982 L
.80919 .18982 L
.81019 .18982 L
.81119 .18982 L
.81219 .18982 L
.81319 .18982 L
.81419 .18982 L
.81518 .18982 L
.81618 .18982 L
.81718 .18982 L
.81818 .18982 L
.81918 .18982 L
.82018 .18982 L
.82118 .18982 L
.82218 .18982 L
.82318 .18982 L
.82418 .18982 L
.82517 .18982 L
.82617 .18982 L
.82717 .18982 L
.82817 .18982 L
.82917 .18982 L
.83017 .18982 L
.83117 .18982 L
.83217 .18982 L
.83317 .18982 L
.83417 .18982 L
.83516 .18982 L
.83616 .18982 L
.83716 .18982 L
.83816 .18982 L
.83916 .18982 L
.84016 .18982 L
.84116 .18982 L
.84216 .18982 L
.84316 .18982 L
.84416 .18982 L
.84515 .18982 L
.84615 .18982 L
.84715 .18982 L
.84815 .18982 L
Mistroke
.84915 .19264 L
.85015 .19264 L
.85115 .19264 L
.85215 .19264 L
.85315 .19264 L
.85415 .19264 L
.85514 .19264 L
.85614 .19264 L
.85714 .19264 L
.85814 .19264 L
.85914 .19264 L
.86014 .19264 L
.86114 .19264 L
.86214 .19264 L
.86314 .19264 L
.86414 .19264 L
.86513 .19264 L
.86613 .19264 L
.86713 .19264 L
.86813 .19264 L
.86913 .19264 L
.87013 .19264 L
.87113 .19264 L
.87213 .19264 L
.87313 .19264 L
.87413 .19264 L
.87512 .19264 L
.87612 .19264 L
.87712 .19264 L
.87812 .19264 L
.87912 .19264 L
.88012 .19264 L
.88112 .19264 L
.88212 .19264 L
.88312 .19264 L
.88412 .19264 L
.88511 .19264 L
.88611 .19264 L
.88711 .19264 L
.88811 .19264 L
.88911 .19264 L
.89011 .19264 L
.89111 .19264 L
.89211 .19264 L
.89311 .19264 L
.89411 .19264 L
.8951 .19264 L
.8961 .19264 L
.8971 .19264 L
.8981 .19264 L
Mistroke
.8991 .19402 L
.9001 .19402 L
.9011 .19402 L
.9021 .19402 L
.9031 .19402 L
.9041 .19402 L
.90509 .19402 L
.90609 .19402 L
.90709 .19402 L
.90809 .19402 L
.90909 .19402 L
.91009 .19402 L
.91109 .19402 L
.91209 .19402 L
.91309 .19402 L
.91409 .19402 L
.91508 .19402 L
.91608 .19402 L
.91708 .19402 L
.91808 .19402 L
.91908 .19402 L
.92008 .19402 L
.92108 .19402 L
.92208 .19402 L
.92308 .19402 L
.92408 .19402 L
.92507 .19402 L
.92607 .19402 L
.92707 .19402 L
.92807 .19402 L
.92907 .19402 L
.93007 .19402 L
.93107 .19402 L
.93207 .19402 L
.93307 .19402 L
.93407 .19402 L
.93506 .19402 L
.93606 .19402 L
.93706 .19402 L
.93806 .19402 L
.93906 .19402 L
.94006 .19402 L
.94106 .19402 L
.94206 .19402 L
.94306 .19402 L
.94406 .19402 L
.94505 .19402 L
.94605 .19402 L
.94705 .19402 L
.94805 .19402 L
Mistroke
.94905 .19566 L
.95005 .19566 L
.95105 .19566 L
.95205 .19566 L
.95305 .19566 L
.95405 .19566 L
.95504 .19566 L
.95604 .19566 L
.95704 .19566 L
.95804 .19566 L
.95904 .19566 L
.96004 .19566 L
.96104 .19566 L
.96204 .19566 L
.96304 .19566 L
.96404 .19566 L
.96503 .19566 L
.96603 .19566 L
.96703 .19566 L
.96803 .19566 L
.96903 .19566 L
.97003 .19566 L
.97103 .19566 L
.97203 .19566 L
.97303 .19566 L
.97403 .19566 L
.97502 .19566 L
.97602 .19566 L
.97702 .19566 L
.97802 .19566 L
.97902 .19566 L
.98002 .19566 L
.98102 .19566 L
.98202 .19566 L
.98302 .19566 L
.98402 .19566 L
.98501 .19566 L
.98601 .19566 L
.98701 .19566 L
.98801 .19566 L
.98901 .19566 L
.99001 .19566 L
.99101 .19566 L
.99201 .19566 L
.99301 .19566 L
.99401 .19566 L
.995 .19566 L
.996 .19566 L
.997 .19566 L
.998 .19566 L
Mistroke
.999 .19682 L
Mfstroke
gsave
.999 .22833 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .43468 m
.001 .43468 L
.002 .43468 L
.003 .43468 L
.004 .43468 L
.005 .43468 L
.00599 .43468 L
.00699 .43468 L
.00799 .43468 L
.00899 .43468 L
.00999 .43468 L
.01099 .43468 L
.01199 .43468 L
.01299 .43468 L
.01399 .43468 L
.01499 .43468 L
.01598 .43468 L
.01698 .43468 L
.01798 .43468 L
.01898 .43468 L
.01998 .43468 L
.02098 .43468 L
.02198 .43468 L
.02298 .43468 L
.02398 .43468 L
.02498 .43468 L
.02597 .43468 L
.02697 .43468 L
.02797 .43468 L
.02897 .43468 L
.02997 .43468 L
.03097 .43468 L
.03197 .43468 L
.03297 .43468 L
.03397 .43468 L
.03497 .43468 L
.03596 .43468 L
.03696 .43468 L
.03796 .43468 L
.03896 .43468 L
.03996 .43468 L
.04096 .43468 L
.04196 .43468 L
.04296 .43468 L
.04396 .43468 L
.04496 .43468 L
.04595 .43468 L
.04695 .43468 L
.04795 .43468 L
.04895 .43468 L
Mistroke
.04995 .36338 L
.05095 .36338 L
.05195 .36338 L
.05295 .36338 L
.05395 .36338 L
.05495 .36338 L
.05594 .36338 L
.05694 .36338 L
.05794 .36338 L
.05894 .36338 L
.05994 .36338 L
.06094 .36338 L
.06194 .36338 L
.06294 .36338 L
.06394 .36338 L
.06494 .36338 L
.06593 .36338 L
.06693 .36338 L
.06793 .36338 L
.06893 .36338 L
.06993 .36338 L
.07093 .36338 L
.07193 .36338 L
.07293 .36338 L
.07393 .36338 L
.07493 .36338 L
.07592 .36338 L
.07692 .36338 L
.07792 .36338 L
.07892 .36338 L
.07992 .36338 L
.08092 .36338 L
.08192 .36338 L
.08292 .36338 L
.08392 .36338 L
.08492 .36338 L
.08591 .36338 L
.08691 .36338 L
.08791 .36338 L
.08891 .36338 L
.08991 .36338 L
.09091 .36338 L
.09191 .36338 L
.09291 .36338 L
.09391 .36338 L
.09491 .36338 L
.0959 .36338 L
.0969 .36338 L
.0979 .36338 L
.0989 .36338 L
Mistroke
.0999 .27025 L
.1009 .27025 L
.1019 .27025 L
.1029 .27025 L
.1039 .27025 L
.1049 .27025 L
.10589 .27025 L
.10689 .27025 L
.10789 .27025 L
.10889 .27025 L
.10989 .27025 L
.11089 .27025 L
.11189 .27025 L
.11289 .27025 L
.11389 .27025 L
.11489 .27025 L
.11588 .27025 L
.11688 .27025 L
.11788 .27025 L
.11888 .27025 L
.11988 .27025 L
.12088 .27025 L
.12188 .27025 L
.12288 .27025 L
.12388 .27025 L
.12488 .27025 L
.12587 .27025 L
.12687 .27025 L
.12787 .27025 L
.12887 .27025 L
.12987 .27025 L
.13087 .27025 L
.13187 .27025 L
.13287 .27025 L
.13387 .27025 L
.13487 .27025 L
.13586 .27025 L
.13686 .27025 L
.13786 .27025 L
.13886 .27025 L
.13986 .27025 L
.14086 .27025 L
.14186 .27025 L
.14286 .27025 L
.14386 .27025 L
.14486 .27025 L
.14585 .27025 L
.14685 .27025 L
.14785 .27025 L
.14885 .27025 L
Mistroke
.14985 .29091 L
.15085 .29091 L
.15185 .29091 L
.15285 .29091 L
.15385 .29091 L
.15485 .29091 L
.15584 .29091 L
.15684 .29091 L
.15784 .29091 L
.15884 .29091 L
.15984 .29091 L
.16084 .29091 L
.16184 .29091 L
.16284 .29091 L
.16384 .29091 L
.16484 .29091 L
.16583 .29091 L
.16683 .29091 L
.16783 .29091 L
.16883 .29091 L
.16983 .29091 L
.17083 .29091 L
.17183 .29091 L
.17283 .29091 L
.17383 .29091 L
.17483 .29091 L
.17582 .29091 L
.17682 .29091 L
.17782 .29091 L
.17882 .29091 L
.17982 .29091 L
.18082 .29091 L
.18182 .29091 L
.18282 .29091 L
.18382 .29091 L
.18482 .29091 L
.18581 .29091 L
.18681 .29091 L
.18781 .29091 L
.18881 .29091 L
.18981 .29091 L
.19081 .29091 L
.19181 .29091 L
.19281 .29091 L
.19381 .29091 L
.19481 .29091 L
.1958 .29091 L
.1968 .29091 L
.1978 .29091 L
.1988 .29091 L
Mistroke
.1998 .28443 L
.2008 .28443 L
.2018 .28443 L
.2028 .28443 L
.2038 .28443 L
.2048 .28443 L
.20579 .28443 L
.20679 .28443 L
.20779 .28443 L
.20879 .28443 L
.20979 .28443 L
.21079 .28443 L
.21179 .28443 L
.21279 .28443 L
.21379 .28443 L
.21479 .28443 L
.21578 .28443 L
.21678 .28443 L
.21778 .28443 L
.21878 .28443 L
.21978 .28443 L
.22078 .28443 L
.22178 .28443 L
.22278 .28443 L
.22378 .28443 L
.22478 .28443 L
.22577 .28443 L
.22677 .28443 L
.22777 .28443 L
.22877 .28443 L
.22977 .28443 L
.23077 .28443 L
.23177 .28443 L
.23277 .28443 L
.23377 .28443 L
.23477 .28443 L
.23576 .28443 L
.23676 .28443 L
.23776 .28443 L
.23876 .28443 L
.23976 .28443 L
.24076 .28443 L
.24176 .28443 L
.24276 .28443 L
.24376 .28443 L
.24476 .28443 L
.24575 .28443 L
.24675 .28443 L
.24775 .28443 L
.24875 .28443 L
Mistroke
.24975 .24903 L
.25075 .24903 L
.25175 .24903 L
.25275 .24903 L
.25375 .24903 L
.25475 .24903 L
.25574 .24903 L
.25674 .24903 L
.25774 .24903 L
.25874 .24903 L
.25974 .24903 L
.26074 .24903 L
.26174 .24903 L
.26274 .24903 L
.26374 .24903 L
.26474 .24903 L
.26573 .24903 L
.26673 .24903 L
.26773 .24903 L
.26873 .24903 L
.26973 .24903 L
.27073 .24903 L
.27173 .24903 L
.27273 .24903 L
.27373 .24903 L
.27473 .24903 L
.27572 .24903 L
.27672 .24903 L
.27772 .24903 L
.27872 .24903 L
.27972 .24903 L
.28072 .24903 L
.28172 .24903 L
.28272 .24903 L
.28372 .24903 L
.28472 .24903 L
.28571 .24903 L
.28671 .24903 L
.28771 .24903 L
.28871 .24903 L
.28971 .24903 L
.29071 .24903 L
.29171 .24903 L
.29271 .24903 L
.29371 .24903 L
.29471 .24903 L
.2957 .24903 L
.2967 .24903 L
.2977 .24903 L
.2987 .24903 L
Mistroke
.2997 .24789 L
.3007 .24789 L
.3017 .24789 L
.3027 .24789 L
.3037 .24789 L
.3047 .24789 L
.30569 .24789 L
.30669 .24789 L
.30769 .24789 L
.30869 .24789 L
.30969 .24789 L
.31069 .24789 L
.31169 .24789 L
.31269 .24789 L
.31369 .24789 L
.31469 .24789 L
.31568 .24789 L
.31668 .24789 L
.31768 .24789 L
.31868 .24789 L
.31968 .24789 L
.32068 .24789 L
.32168 .24789 L
.32268 .24789 L
.32368 .24789 L
.32468 .24789 L
.32567 .24789 L
.32667 .24789 L
.32767 .24789 L
.32867 .24789 L
.32967 .24789 L
.33067 .24789 L
.33167 .24789 L
.33267 .24789 L
.33367 .24789 L
.33467 .24789 L
.33566 .24789 L
.33666 .24789 L
.33766 .24789 L
.33866 .24789 L
.33966 .24789 L
.34066 .24789 L
.34166 .24789 L
.34266 .24789 L
.34366 .24789 L
.34466 .24789 L
.34565 .24789 L
.34665 .24789 L
.34765 .24789 L
.34865 .24789 L
Mistroke
.34965 .24314 L
.35065 .24314 L
.35165 .24314 L
.35265 .24314 L
.35365 .24314 L
.35465 .24314 L
.35564 .24314 L
.35664 .24314 L
.35764 .24314 L
.35864 .24314 L
.35964 .24314 L
.36064 .24314 L
.36164 .24314 L
.36264 .24314 L
.36364 .24314 L
.36464 .24314 L
.36563 .24314 L
.36663 .24314 L
.36763 .24314 L
.36863 .24314 L
.36963 .24314 L
.37063 .24314 L
.37163 .24314 L
.37263 .24314 L
.37363 .24314 L
.37463 .24314 L
.37562 .24314 L
.37662 .24314 L
.37762 .24314 L
.37862 .24314 L
.37962 .24314 L
.38062 .24314 L
.38162 .24314 L
.38262 .24314 L
.38362 .24314 L
.38462 .24314 L
.38561 .24314 L
.38661 .24314 L
.38761 .24314 L
.38861 .24314 L
.38961 .24314 L
.39061 .24314 L
.39161 .24314 L
.39261 .24314 L
.39361 .24314 L
.39461 .24314 L
.3956 .24314 L
.3966 .24314 L
.3976 .24314 L
.3986 .24314 L
Mistroke
.3996 .22317 L
.4006 .22317 L
.4016 .22317 L
.4026 .22317 L
.4036 .22317 L
.4046 .22317 L
.40559 .22317 L
.40659 .22317 L
.40759 .22317 L
.40859 .22317 L
.40959 .22317 L
.41059 .22317 L
.41159 .22317 L
.41259 .22317 L
.41359 .22317 L
.41459 .22317 L
.41558 .22317 L
.41658 .22317 L
.41758 .22317 L
.41858 .22317 L
.41958 .22317 L
.42058 .22317 L
.42158 .22317 L
.42258 .22317 L
.42358 .22317 L
.42458 .22317 L
.42557 .22317 L
.42657 .22317 L
.42757 .22317 L
.42857 .22317 L
.42957 .22317 L
.43057 .22317 L
.43157 .22317 L
.43257 .22317 L
.43357 .22317 L
.43457 .22317 L
.43556 .22317 L
.43656 .22317 L
.43756 .22317 L
.43856 .22317 L
.43956 .22317 L
.44056 .22317 L
.44156 .22317 L
.44256 .22317 L
.44356 .22317 L
.44456 .22317 L
.44555 .22317 L
.44655 .22317 L
.44755 .22317 L
.44855 .22317 L
Mistroke
.44955 .21547 L
.45055 .21547 L
.45155 .21547 L
.45255 .21547 L
.45355 .21547 L
.45455 .21547 L
.45554 .21547 L
.45654 .21547 L
.45754 .21547 L
.45854 .21547 L
.45954 .21547 L
.46054 .21547 L
.46154 .21547 L
.46254 .21547 L
.46354 .21547 L
.46454 .21547 L
.46553 .21547 L
.46653 .21547 L
.46753 .21547 L
.46853 .21547 L
.46953 .21547 L
.47053 .21547 L
.47153 .21547 L
.47253 .21547 L
.47353 .21547 L
.47453 .21547 L
.47552 .21547 L
.47652 .21547 L
.47752 .21547 L
.47852 .21547 L
.47952 .21547 L
.48052 .21547 L
.48152 .21547 L
.48252 .21547 L
.48352 .21547 L
.48452 .21547 L
.48551 .21547 L
.48651 .21547 L
.48751 .21547 L
.48851 .21547 L
.48951 .21547 L
.49051 .21547 L
.49151 .21547 L
.49251 .21547 L
.49351 .21547 L
.49451 .21547 L
.4955 .21547 L
.4965 .21547 L
.4975 .21547 L
.4985 .21547 L
Mistroke
.4995 .22287 L
.5005 .22287 L
.5015 .22287 L
.5025 .22287 L
.5035 .22287 L
.5045 .22287 L
.50549 .22287 L
.50649 .22287 L
.50749 .22287 L
.50849 .22287 L
.50949 .22287 L
.51049 .22287 L
.51149 .22287 L
.51249 .22287 L
.51349 .22287 L
.51449 .22287 L
.51548 .22287 L
.51648 .22287 L
.51748 .22287 L
.51848 .22287 L
.51948 .22287 L
.52048 .22287 L
.52148 .22287 L
.52248 .22287 L
.52348 .22287 L
.52448 .22287 L
.52547 .22287 L
.52647 .22287 L
.52747 .22287 L
.52847 .22287 L
.52947 .22287 L
.53047 .22287 L
.53147 .22287 L
.53247 .22287 L
.53347 .22287 L
.53447 .22287 L
.53546 .22287 L
.53646 .22287 L
.53746 .22287 L
.53846 .22287 L
.53946 .22287 L
.54046 .22287 L
.54146 .22287 L
.54246 .22287 L
.54346 .22287 L
.54446 .22287 L
.54545 .22287 L
.54645 .22287 L
.54745 .22287 L
.54845 .22287 L
Mistroke
.54945 .22525 L
.55045 .22525 L
.55145 .22525 L
.55245 .22525 L
.55345 .22525 L
.55445 .22525 L
.55544 .22525 L
.55644 .22525 L
.55744 .22525 L
.55844 .22525 L
.55944 .22525 L
.56044 .22525 L
.56144 .22525 L
.56244 .22525 L
.56344 .22525 L
.56444 .22525 L
.56543 .22525 L
.56643 .22525 L
.56743 .22525 L
.56843 .22525 L
.56943 .22525 L
.57043 .22525 L
.57143 .22525 L
.57243 .22525 L
.57343 .22525 L
.57443 .22525 L
.57542 .22525 L
.57642 .22525 L
.57742 .22525 L
.57842 .22525 L
.57942 .22525 L
.58042 .22525 L
.58142 .22525 L
.58242 .22525 L
.58342 .22525 L
.58442 .22525 L
.58541 .22525 L
.58641 .22525 L
.58741 .22525 L
.58841 .22525 L
.58941 .22525 L
.59041 .22525 L
.59141 .22525 L
.59241 .22525 L
.59341 .22525 L
.59441 .22525 L
.5954 .22525 L
.5964 .22525 L
.5974 .22525 L
.5984 .22525 L
Mistroke
.5994 .22367 L
.6004 .22367 L
.6014 .22367 L
.6024 .22367 L
.6034 .22367 L
.6044 .22367 L
.60539 .22367 L
.60639 .22367 L
.60739 .22367 L
.60839 .22367 L
.60939 .22367 L
.61039 .22367 L
.61139 .22367 L
.61239 .22367 L
.61339 .22367 L
.61439 .22367 L
.61538 .22367 L
.61638 .22367 L
.61738 .22367 L
.61838 .22367 L
.61938 .22367 L
.62038 .22367 L
.62138 .22367 L
.62238 .22367 L
.62338 .22367 L
.62438 .22367 L
.62537 .22367 L
.62637 .22367 L
.62737 .22367 L
.62837 .22367 L
.62937 .22367 L
.63037 .22367 L
.63137 .22367 L
.63237 .22367 L
.63337 .22367 L
.63437 .22367 L
.63536 .22367 L
.63636 .22367 L
.63736 .22367 L
.63836 .22367 L
.63936 .22367 L
.64036 .22367 L
.64136 .22367 L
.64236 .22367 L
.64336 .22367 L
.64436 .22367 L
.64535 .22367 L
.64635 .22367 L
.64735 .22367 L
.64835 .22367 L
Mistroke
.64935 .22416 L
.65035 .22416 L
.65135 .22416 L
.65235 .22416 L
.65335 .22416 L
.65435 .22416 L
.65534 .22416 L
.65634 .22416 L
.65734 .22416 L
.65834 .22416 L
.65934 .22416 L
.66034 .22416 L
.66134 .22416 L
.66234 .22416 L
.66334 .22416 L
.66434 .22416 L
.66533 .22416 L
.66633 .22416 L
.66733 .22416 L
.66833 .22416 L
.66933 .22416 L
.67033 .22416 L
.67133 .22416 L
.67233 .22416 L
.67333 .22416 L
.67433 .22416 L
.67532 .22416 L
.67632 .22416 L
.67732 .22416 L
.67832 .22416 L
.67932 .22416 L
.68032 .22416 L
.68132 .22416 L
.68232 .22416 L
.68332 .22416 L
.68432 .22416 L
.68531 .22416 L
.68631 .22416 L
.68731 .22416 L
.68831 .22416 L
.68931 .22416 L
.69031 .22416 L
.69131 .22416 L
.69231 .22416 L
.69331 .22416 L
.69431 .22416 L
.6953 .22416 L
.6963 .22416 L
.6973 .22416 L
.6983 .22416 L
Mistroke
.6993 .22349 L
.7003 .22349 L
.7013 .22349 L
.7023 .22349 L
.7033 .22349 L
.7043 .22349 L
.70529 .22349 L
.70629 .22349 L
.70729 .22349 L
.70829 .22349 L
.70929 .22349 L
.71029 .22349 L
.71129 .22349 L
.71229 .22349 L
.71329 .22349 L
.71429 .22349 L
.71528 .22349 L
.71628 .22349 L
.71728 .22349 L
.71828 .22349 L
.71928 .22349 L
.72028 .22349 L
.72128 .22349 L
.72228 .22349 L
.72328 .22349 L
.72428 .22349 L
.72527 .22349 L
.72627 .22349 L
.72727 .22349 L
.72827 .22349 L
.72927 .22349 L
.73027 .22349 L
.73127 .22349 L
.73227 .22349 L
.73327 .22349 L
.73427 .22349 L
.73526 .22349 L
.73626 .22349 L
.73726 .22349 L
.73826 .22349 L
.73926 .22349 L
.74026 .22349 L
.74126 .22349 L
.74226 .22349 L
.74326 .22349 L
.74426 .22349 L
.74525 .22349 L
.74625 .22349 L
.74725 .22349 L
.74825 .22349 L
Mistroke
.74925 .22634 L
.75025 .22634 L
.75125 .22634 L
.75225 .22634 L
.75325 .22634 L
.75425 .22634 L
.75524 .22634 L
.75624 .22634 L
.75724 .22634 L
.75824 .22634 L
.75924 .22634 L
.76024 .22634 L
.76124 .22634 L
.76224 .22634 L
.76324 .22634 L
.76424 .22634 L
.76523 .22634 L
.76623 .22634 L
.76723 .22634 L
.76823 .22634 L
.76923 .22634 L
.77023 .22634 L
.77123 .22634 L
.77223 .22634 L
.77323 .22634 L
.77423 .22634 L
.77522 .22634 L
.77622 .22634 L
.77722 .22634 L
.77822 .22634 L
.77922 .22634 L
.78022 .22634 L
.78122 .22634 L
.78222 .22634 L
.78322 .22634 L
.78422 .22634 L
.78521 .22634 L
.78621 .22634 L
.78721 .22634 L
.78821 .22634 L
.78921 .22634 L
.79021 .22634 L
.79121 .22634 L
.79221 .22634 L
.79321 .22634 L
.79421 .22634 L
.7952 .22634 L
.7962 .22634 L
.7972 .22634 L
.7982 .22634 L
Mistroke
.7992 .22524 L
.8002 .22524 L
.8012 .22524 L
.8022 .22524 L
.8032 .22524 L
.8042 .22524 L
.80519 .22524 L
.80619 .22524 L
.80719 .22524 L
.80819 .22524 L
.80919 .22524 L
.81019 .22524 L
.81119 .22524 L
.81219 .22524 L
.81319 .22524 L
.81419 .22524 L
.81518 .22524 L
.81618 .22524 L
.81718 .22524 L
.81818 .22524 L
.81918 .22524 L
.82018 .22524 L
.82118 .22524 L
.82218 .22524 L
.82318 .22524 L
.82418 .22524 L
.82517 .22524 L
.82617 .22524 L
.82717 .22524 L
.82817 .22524 L
.82917 .22524 L
.83017 .22524 L
.83117 .22524 L
.83217 .22524 L
.83317 .22524 L
.83417 .22524 L
.83516 .22524 L
.83616 .22524 L
.83716 .22524 L
.83816 .22524 L
.83916 .22524 L
.84016 .22524 L
.84116 .22524 L
.84216 .22524 L
.84316 .22524 L
.84416 .22524 L
.84515 .22524 L
.84615 .22524 L
.84715 .22524 L
.84815 .22524 L
Mistroke
.84915 .22758 L
.85015 .22758 L
.85115 .22758 L
.85215 .22758 L
.85315 .22758 L
.85415 .22758 L
.85514 .22758 L
.85614 .22758 L
.85714 .22758 L
.85814 .22758 L
.85914 .22758 L
.86014 .22758 L
.86114 .22758 L
.86214 .22758 L
.86314 .22758 L
.86414 .22758 L
.86513 .22758 L
.86613 .22758 L
.86713 .22758 L
.86813 .22758 L
.86913 .22758 L
.87013 .22758 L
.87113 .22758 L
.87213 .22758 L
.87313 .22758 L
.87413 .22758 L
.87512 .22758 L
.87612 .22758 L
.87712 .22758 L
.87812 .22758 L
.87912 .22758 L
.88012 .22758 L
.88112 .22758 L
.88212 .22758 L
.88312 .22758 L
.88412 .22758 L
.88511 .22758 L
.88611 .22758 L
.88711 .22758 L
.88811 .22758 L
.88911 .22758 L
.89011 .22758 L
.89111 .22758 L
.89211 .22758 L
.89311 .22758 L
.89411 .22758 L
.8951 .22758 L
.8961 .22758 L
.8971 .22758 L
.8981 .22758 L
Mistroke
.8991 .2274 L
.9001 .2274 L
.9011 .2274 L
.9021 .2274 L
.9031 .2274 L
.9041 .2274 L
.90509 .2274 L
.90609 .2274 L
.90709 .2274 L
.90809 .2274 L
.90909 .2274 L
.91009 .2274 L
.91109 .2274 L
.91209 .2274 L
.91309 .2274 L
.91409 .2274 L
.91508 .2274 L
.91608 .2274 L
.91708 .2274 L
.91808 .2274 L
.91908 .2274 L
.92008 .2274 L
.92108 .2274 L
.92208 .2274 L
.92308 .2274 L
.92408 .2274 L
.92507 .2274 L
.92607 .2274 L
.92707 .2274 L
.92807 .2274 L
.92907 .2274 L
.93007 .2274 L
.93107 .2274 L
.93207 .2274 L
.93307 .2274 L
.93407 .2274 L
.93506 .2274 L
.93606 .2274 L
.93706 .2274 L
.93806 .2274 L
.93906 .2274 L
.94006 .2274 L
.94106 .2274 L
.94206 .2274 L
.94306 .2274 L
.94406 .2274 L
.94505 .2274 L
.94605 .2274 L
.94705 .2274 L
.94805 .2274 L
Mistroke
.94905 .22744 L
.95005 .22744 L
.95105 .22744 L
.95205 .22744 L
.95305 .22744 L
.95405 .22744 L
.95504 .22744 L
.95604 .22744 L
.95704 .22744 L
.95804 .22744 L
.95904 .22744 L
.96004 .22744 L
.96104 .22744 L
.96204 .22744 L
.96304 .22744 L
.96404 .22744 L
.96503 .22744 L
.96603 .22744 L
.96703 .22744 L
.96803 .22744 L
.96903 .22744 L
.97003 .22744 L
.97103 .22744 L
.97203 .22744 L
.97303 .22744 L
.97403 .22744 L
.97502 .22744 L
.97602 .22744 L
.97702 .22744 L
.97802 .22744 L
.97902 .22744 L
.98002 .22744 L
.98102 .22744 L
.98202 .22744 L
.98302 .22744 L
.98402 .22744 L
.98501 .22744 L
.98601 .22744 L
.98701 .22744 L
.98801 .22744 L
.98901 .22744 L
.99001 .22744 L
.99101 .22744 L
.99201 .22744 L
.99301 .22744 L
.99401 .22744 L
.995 .22744 L
.996 .22744 L
.997 .22744 L
.998 .22744 L
Mistroke
.999 .22833 L
Mfstroke
1 0 0 r
gsave
.999 .21257 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .28327 m
.001 .28327 L
.002 .28327 L
.003 .28327 L
.004 .28327 L
.005 .28327 L
.00599 .28327 L
.00699 .28327 L
.00799 .28327 L
.00899 .28327 L
.00999 .28327 L
.01099 .28327 L
.01199 .28327 L
.01299 .28327 L
.01399 .28327 L
.01499 .28327 L
.01598 .28327 L
.01698 .28327 L
.01798 .28327 L
.01898 .28327 L
.01998 .28327 L
.02098 .28327 L
.02198 .28327 L
.02298 .28327 L
.02398 .28327 L
.02498 .28327 L
.02597 .28327 L
.02697 .28327 L
.02797 .28327 L
.02897 .28327 L
.02997 .28327 L
.03097 .28327 L
.03197 .28327 L
.03297 .28327 L
.03397 .28327 L
.03497 .28327 L
.03596 .28327 L
.03696 .28327 L
.03796 .28327 L
.03896 .28327 L
.03996 .28327 L
.04096 .28327 L
.04196 .28327 L
.04296 .28327 L
.04396 .28327 L
.04496 .28327 L
.04595 .28327 L
.04695 .28327 L
.04795 .28327 L
.04895 .28327 L
Mistroke
.04995 .22269 L
.05095 .22269 L
.05195 .22269 L
.05295 .22269 L
.05395 .22269 L
.05495 .22269 L
.05594 .22269 L
.05694 .22269 L
.05794 .22269 L
.05894 .22269 L
.05994 .22269 L
.06094 .22269 L
.06194 .22269 L
.06294 .22269 L
.06394 .22269 L
.06494 .22269 L
.06593 .22269 L
.06693 .22269 L
.06793 .22269 L
.06893 .22269 L
.06993 .22269 L
.07093 .22269 L
.07193 .22269 L
.07293 .22269 L
.07393 .22269 L
.07493 .22269 L
.07592 .22269 L
.07692 .22269 L
.07792 .22269 L
.07892 .22269 L
.07992 .22269 L
.08092 .22269 L
.08192 .22269 L
.08292 .22269 L
.08392 .22269 L
.08492 .22269 L
.08591 .22269 L
.08691 .22269 L
.08791 .22269 L
.08891 .22269 L
.08991 .22269 L
.09091 .22269 L
.09191 .22269 L
.09291 .22269 L
.09391 .22269 L
.09491 .22269 L
.0959 .22269 L
.0969 .22269 L
.0979 .22269 L
.0989 .22269 L
Mistroke
.0999 .2243 L
.1009 .2243 L
.1019 .2243 L
.1029 .2243 L
.1039 .2243 L
.1049 .2243 L
.10589 .2243 L
.10689 .2243 L
.10789 .2243 L
.10889 .2243 L
.10989 .2243 L
.11089 .2243 L
.11189 .2243 L
.11289 .2243 L
.11389 .2243 L
.11489 .2243 L
.11588 .2243 L
.11688 .2243 L
.11788 .2243 L
.11888 .2243 L
.11988 .2243 L
.12088 .2243 L
.12188 .2243 L
.12288 .2243 L
.12388 .2243 L
.12488 .2243 L
.12587 .2243 L
.12687 .2243 L
.12787 .2243 L
.12887 .2243 L
.12987 .2243 L
.13087 .2243 L
.13187 .2243 L
.13287 .2243 L
.13387 .2243 L
.13487 .2243 L
.13586 .2243 L
.13686 .2243 L
.13786 .2243 L
.13886 .2243 L
.13986 .2243 L
.14086 .2243 L
.14186 .2243 L
.14286 .2243 L
.14386 .2243 L
.14486 .2243 L
.14585 .2243 L
.14685 .2243 L
.14785 .2243 L
.14885 .2243 L
Mistroke
.14985 .24796 L
.15085 .24796 L
.15185 .24796 L
.15285 .24796 L
.15385 .24796 L
.15485 .24796 L
.15584 .24796 L
.15684 .24796 L
.15784 .24796 L
.15884 .24796 L
.15984 .24796 L
.16084 .24796 L
.16184 .24796 L
.16284 .24796 L
.16384 .24796 L
.16484 .24796 L
.16583 .24796 L
.16683 .24796 L
.16783 .24796 L
.16883 .24796 L
.16983 .24796 L
.17083 .24796 L
.17183 .24796 L
.17283 .24796 L
.17383 .24796 L
.17483 .24796 L
.17582 .24796 L
.17682 .24796 L
.17782 .24796 L
.17882 .24796 L
.17982 .24796 L
.18082 .24796 L
.18182 .24796 L
.18282 .24796 L
.18382 .24796 L
.18482 .24796 L
.18581 .24796 L
.18681 .24796 L
.18781 .24796 L
.18881 .24796 L
.18981 .24796 L
.19081 .24796 L
.19181 .24796 L
.19281 .24796 L
.19381 .24796 L
.19481 .24796 L
.1958 .24796 L
.1968 .24796 L
.1978 .24796 L
.1988 .24796 L
Mistroke
.1998 .24623 L
.2008 .24623 L
.2018 .24623 L
.2028 .24623 L
.2038 .24623 L
.2048 .24623 L
.20579 .24623 L
.20679 .24623 L
.20779 .24623 L
.20879 .24623 L
.20979 .24623 L
.21079 .24623 L
.21179 .24623 L
.21279 .24623 L
.21379 .24623 L
.21479 .24623 L
.21578 .24623 L
.21678 .24623 L
.21778 .24623 L
.21878 .24623 L
.21978 .24623 L
.22078 .24623 L
.22178 .24623 L
.22278 .24623 L
.22378 .24623 L
.22478 .24623 L
.22577 .24623 L
.22677 .24623 L
.22777 .24623 L
.22877 .24623 L
.22977 .24623 L
.23077 .24623 L
.23177 .24623 L
.23277 .24623 L
.23377 .24623 L
.23477 .24623 L
.23576 .24623 L
.23676 .24623 L
.23776 .24623 L
.23876 .24623 L
.23976 .24623 L
.24076 .24623 L
.24176 .24623 L
.24276 .24623 L
.24376 .24623 L
.24476 .24623 L
.24575 .24623 L
.24675 .24623 L
.24775 .24623 L
.24875 .24623 L
Mistroke
.24975 .21833 L
.25075 .21833 L
.25175 .21833 L
.25275 .21833 L
.25375 .21833 L
.25475 .21833 L
.25574 .21833 L
.25674 .21833 L
.25774 .21833 L
.25874 .21833 L
.25974 .21833 L
.26074 .21833 L
.26174 .21833 L
.26274 .21833 L
.26374 .21833 L
.26474 .21833 L
.26573 .21833 L
.26673 .21833 L
.26773 .21833 L
.26873 .21833 L
.26973 .21833 L
.27073 .21833 L
.27173 .21833 L
.27273 .21833 L
.27373 .21833 L
.27473 .21833 L
.27572 .21833 L
.27672 .21833 L
.27772 .21833 L
.27872 .21833 L
.27972 .21833 L
.28072 .21833 L
.28172 .21833 L
.28272 .21833 L
.28372 .21833 L
.28472 .21833 L
.28571 .21833 L
.28671 .21833 L
.28771 .21833 L
.28871 .21833 L
.28971 .21833 L
.29071 .21833 L
.29171 .21833 L
.29271 .21833 L
.29371 .21833 L
.29471 .21833 L
.2957 .21833 L
.2967 .21833 L
.2977 .21833 L
.2987 .21833 L
Mistroke
.2997 .21801 L
.3007 .21801 L
.3017 .21801 L
.3027 .21801 L
.3037 .21801 L
.3047 .21801 L
.30569 .21801 L
.30669 .21801 L
.30769 .21801 L
.30869 .21801 L
.30969 .21801 L
.31069 .21801 L
.31169 .21801 L
.31269 .21801 L
.31369 .21801 L
.31469 .21801 L
.31568 .21801 L
.31668 .21801 L
.31768 .21801 L
.31868 .21801 L
.31968 .21801 L
.32068 .21801 L
.32168 .21801 L
.32268 .21801 L
.32368 .21801 L
.32468 .21801 L
.32567 .21801 L
.32667 .21801 L
.32767 .21801 L
.32867 .21801 L
.32967 .21801 L
.33067 .21801 L
.33167 .21801 L
.33267 .21801 L
.33367 .21801 L
.33467 .21801 L
.33566 .21801 L
.33666 .21801 L
.33766 .21801 L
.33866 .21801 L
.33966 .21801 L
.34066 .21801 L
.34166 .21801 L
.34266 .21801 L
.34366 .21801 L
.34466 .21801 L
.34565 .21801 L
.34665 .21801 L
.34765 .21801 L
.34865 .21801 L
Mistroke
.34965 .21414 L
.35065 .21414 L
.35165 .21414 L
.35265 .21414 L
.35365 .21414 L
.35465 .21414 L
.35564 .21414 L
.35664 .21414 L
.35764 .21414 L
.35864 .21414 L
.35964 .21414 L
.36064 .21414 L
.36164 .21414 L
.36264 .21414 L
.36364 .21414 L
.36464 .21414 L
.36563 .21414 L
.36663 .21414 L
.36763 .21414 L
.36863 .21414 L
.36963 .21414 L
.37063 .21414 L
.37163 .21414 L
.37263 .21414 L
.37363 .21414 L
.37463 .21414 L
.37562 .21414 L
.37662 .21414 L
.37762 .21414 L
.37862 .21414 L
.37962 .21414 L
.38062 .21414 L
.38162 .21414 L
.38262 .21414 L
.38362 .21414 L
.38462 .21414 L
.38561 .21414 L
.38661 .21414 L
.38761 .21414 L
.38861 .21414 L
.38961 .21414 L
.39061 .21414 L
.39161 .21414 L
.39261 .21414 L
.39361 .21414 L
.39461 .21414 L
.3956 .21414 L
.3966 .21414 L
.3976 .21414 L
.3986 .21414 L
Mistroke
.3996 .19729 L
.4006 .19729 L
.4016 .19729 L
.4026 .19729 L
.4036 .19729 L
.4046 .19729 L
.40559 .19729 L
.40659 .19729 L
.40759 .19729 L
.40859 .19729 L
.40959 .19729 L
.41059 .19729 L
.41159 .19729 L
.41259 .19729 L
.41359 .19729 L
.41459 .19729 L
.41558 .19729 L
.41658 .19729 L
.41758 .19729 L
.41858 .19729 L
.41958 .19729 L
.42058 .19729 L
.42158 .19729 L
.42258 .19729 L
.42358 .19729 L
.42458 .19729 L
.42557 .19729 L
.42657 .19729 L
.42757 .19729 L
.42857 .19729 L
.42957 .19729 L
.43057 .19729 L
.43157 .19729 L
.43257 .19729 L
.43357 .19729 L
.43457 .19729 L
.43556 .19729 L
.43656 .19729 L
.43756 .19729 L
.43856 .19729 L
.43956 .19729 L
.44056 .19729 L
.44156 .19729 L
.44256 .19729 L
.44356 .19729 L
.44456 .19729 L
.44555 .19729 L
.44655 .19729 L
.44755 .19729 L
.44855 .19729 L
Mistroke
.44955 .19173 L
.45055 .19173 L
.45155 .19173 L
.45255 .19173 L
.45355 .19173 L
.45455 .19173 L
.45554 .19173 L
.45654 .19173 L
.45754 .19173 L
.45854 .19173 L
.45954 .19173 L
.46054 .19173 L
.46154 .19173 L
.46254 .19173 L
.46354 .19173 L
.46454 .19173 L
.46553 .19173 L
.46653 .19173 L
.46753 .19173 L
.46853 .19173 L
.46953 .19173 L
.47053 .19173 L
.47153 .19173 L
.47253 .19173 L
.47353 .19173 L
.47453 .19173 L
.47552 .19173 L
.47652 .19173 L
.47752 .19173 L
.47852 .19173 L
.47952 .19173 L
.48052 .19173 L
.48152 .19173 L
.48252 .19173 L
.48352 .19173 L
.48452 .19173 L
.48551 .19173 L
.48651 .19173 L
.48751 .19173 L
.48851 .19173 L
.48951 .19173 L
.49051 .19173 L
.49151 .19173 L
.49251 .19173 L
.49351 .19173 L
.49451 .19173 L
.4955 .19173 L
.4965 .19173 L
.4975 .19173 L
.4985 .19173 L
Mistroke
.4995 .19985 L
.5005 .19985 L
.5015 .19985 L
.5025 .19985 L
.5035 .19985 L
.5045 .19985 L
.50549 .19985 L
.50649 .19985 L
.50749 .19985 L
.50849 .19985 L
.50949 .19985 L
.51049 .19985 L
.51149 .19985 L
.51249 .19985 L
.51349 .19985 L
.51449 .19985 L
.51548 .19985 L
.51648 .19985 L
.51748 .19985 L
.51848 .19985 L
.51948 .19985 L
.52048 .19985 L
.52148 .19985 L
.52248 .19985 L
.52348 .19985 L
.52448 .19985 L
.52547 .19985 L
.52647 .19985 L
.52747 .19985 L
.52847 .19985 L
.52947 .19985 L
.53047 .19985 L
.53147 .19985 L
.53247 .19985 L
.53347 .19985 L
.53447 .19985 L
.53546 .19985 L
.53646 .19985 L
.53746 .19985 L
.53846 .19985 L
.53946 .19985 L
.54046 .19985 L
.54146 .19985 L
.54246 .19985 L
.54346 .19985 L
.54446 .19985 L
.54545 .19985 L
.54645 .19985 L
.54745 .19985 L
.54845 .19985 L
Mistroke
.54945 .20382 L
.55045 .20382 L
.55145 .20382 L
.55245 .20382 L
.55345 .20382 L
.55445 .20382 L
.55544 .20382 L
.55644 .20382 L
.55744 .20382 L
.55844 .20382 L
.55944 .20382 L
.56044 .20382 L
.56144 .20382 L
.56244 .20382 L
.56344 .20382 L
.56444 .20382 L
.56543 .20382 L
.56643 .20382 L
.56743 .20382 L
.56843 .20382 L
.56943 .20382 L
.57043 .20382 L
.57143 .20382 L
.57243 .20382 L
.57343 .20382 L
.57443 .20382 L
.57542 .20382 L
.57642 .20382 L
.57742 .20382 L
.57842 .20382 L
.57942 .20382 L
.58042 .20382 L
.58142 .20382 L
.58242 .20382 L
.58342 .20382 L
.58442 .20382 L
.58541 .20382 L
.58641 .20382 L
.58741 .20382 L
.58841 .20382 L
.58941 .20382 L
.59041 .20382 L
.59141 .20382 L
.59241 .20382 L
.59341 .20382 L
.59441 .20382 L
.5954 .20382 L
.5964 .20382 L
.5974 .20382 L
.5984 .20382 L
Mistroke
.5994 .20379 L
.6004 .20379 L
.6014 .20379 L
.6024 .20379 L
.6034 .20379 L
.6044 .20379 L
.60539 .20379 L
.60639 .20379 L
.60739 .20379 L
.60839 .20379 L
.60939 .20379 L
.61039 .20379 L
.61139 .20379 L
.61239 .20379 L
.61339 .20379 L
.61439 .20379 L
.61538 .20379 L
.61638 .20379 L
.61738 .20379 L
.61838 .20379 L
.61938 .20379 L
.62038 .20379 L
.62138 .20379 L
.62238 .20379 L
.62338 .20379 L
.62438 .20379 L
.62537 .20379 L
.62637 .20379 L
.62737 .20379 L
.62837 .20379 L
.62937 .20379 L
.63037 .20379 L
.63137 .20379 L
.63237 .20379 L
.63337 .20379 L
.63437 .20379 L
.63536 .20379 L
.63636 .20379 L
.63736 .20379 L
.63836 .20379 L
.63936 .20379 L
.64036 .20379 L
.64136 .20379 L
.64236 .20379 L
.64336 .20379 L
.64436 .20379 L
.64535 .20379 L
.64635 .20379 L
.64735 .20379 L
.64835 .20379 L
Mistroke
.64935 .20446 L
.65035 .20446 L
.65135 .20446 L
.65235 .20446 L
.65335 .20446 L
.65435 .20446 L
.65534 .20446 L
.65634 .20446 L
.65734 .20446 L
.65834 .20446 L
.65934 .20446 L
.66034 .20446 L
.66134 .20446 L
.66234 .20446 L
.66334 .20446 L
.66434 .20446 L
.66533 .20446 L
.66633 .20446 L
.66733 .20446 L
.66833 .20446 L
.66933 .20446 L
.67033 .20446 L
.67133 .20446 L
.67233 .20446 L
.67333 .20446 L
.67433 .20446 L
.67532 .20446 L
.67632 .20446 L
.67732 .20446 L
.67832 .20446 L
.67932 .20446 L
.68032 .20446 L
.68132 .20446 L
.68232 .20446 L
.68332 .20446 L
.68432 .20446 L
.68531 .20446 L
.68631 .20446 L
.68731 .20446 L
.68831 .20446 L
.68931 .20446 L
.69031 .20446 L
.69131 .20446 L
.69231 .20446 L
.69331 .20446 L
.69431 .20446 L
.6953 .20446 L
.6963 .20446 L
.6973 .20446 L
.6983 .20446 L
Mistroke
.6993 .20401 L
.7003 .20401 L
.7013 .20401 L
.7023 .20401 L
.7033 .20401 L
.7043 .20401 L
.70529 .20401 L
.70629 .20401 L
.70729 .20401 L
.70829 .20401 L
.70929 .20401 L
.71029 .20401 L
.71129 .20401 L
.71229 .20401 L
.71329 .20401 L
.71429 .20401 L
.71528 .20401 L
.71628 .20401 L
.71728 .20401 L
.71828 .20401 L
.71928 .20401 L
.72028 .20401 L
.72128 .20401 L
.72228 .20401 L
.72328 .20401 L
.72428 .20401 L
.72527 .20401 L
.72627 .20401 L
.72727 .20401 L
.72827 .20401 L
.72927 .20401 L
.73027 .20401 L
.73127 .20401 L
.73227 .20401 L
.73327 .20401 L
.73427 .20401 L
.73526 .20401 L
.73626 .20401 L
.73726 .20401 L
.73826 .20401 L
.73926 .20401 L
.74026 .20401 L
.74126 .20401 L
.74226 .20401 L
.74326 .20401 L
.74426 .20401 L
.74525 .20401 L
.74625 .20401 L
.74725 .20401 L
.74825 .20401 L
Mistroke
.74925 .20717 L
.75025 .20717 L
.75125 .20717 L
.75225 .20717 L
.75325 .20717 L
.75425 .20717 L
.75524 .20717 L
.75624 .20717 L
.75724 .20717 L
.75824 .20717 L
.75924 .20717 L
.76024 .20717 L
.76124 .20717 L
.76224 .20717 L
.76324 .20717 L
.76424 .20717 L
.76523 .20717 L
.76623 .20717 L
.76723 .20717 L
.76823 .20717 L
.76923 .20717 L
.77023 .20717 L
.77123 .20717 L
.77223 .20717 L
.77323 .20717 L
.77423 .20717 L
.77522 .20717 L
.77622 .20717 L
.77722 .20717 L
.77822 .20717 L
.77922 .20717 L
.78022 .20717 L
.78122 .20717 L
.78222 .20717 L
.78322 .20717 L
.78422 .20717 L
.78521 .20717 L
.78621 .20717 L
.78721 .20717 L
.78821 .20717 L
.78921 .20717 L
.79021 .20717 L
.79121 .20717 L
.79221 .20717 L
.79321 .20717 L
.79421 .20717 L
.7952 .20717 L
.7962 .20717 L
.7972 .20717 L
.7982 .20717 L
Mistroke
.7992 .20753 L
.8002 .20753 L
.8012 .20753 L
.8022 .20753 L
.8032 .20753 L
.8042 .20753 L
.80519 .20753 L
.80619 .20753 L
.80719 .20753 L
.80819 .20753 L
.80919 .20753 L
.81019 .20753 L
.81119 .20753 L
.81219 .20753 L
.81319 .20753 L
.81419 .20753 L
.81518 .20753 L
.81618 .20753 L
.81718 .20753 L
.81818 .20753 L
.81918 .20753 L
.82018 .20753 L
.82118 .20753 L
.82218 .20753 L
.82318 .20753 L
.82418 .20753 L
.82517 .20753 L
.82617 .20753 L
.82717 .20753 L
.82817 .20753 L
.82917 .20753 L
.83017 .20753 L
.83117 .20753 L
.83217 .20753 L
.83317 .20753 L
.83417 .20753 L
.83516 .20753 L
.83616 .20753 L
.83716 .20753 L
.83816 .20753 L
.83916 .20753 L
.84016 .20753 L
.84116 .20753 L
.84216 .20753 L
.84316 .20753 L
.84416 .20753 L
.84515 .20753 L
.84615 .20753 L
.84715 .20753 L
.84815 .20753 L
Mistroke
.84915 .21011 L
.85015 .21011 L
.85115 .21011 L
.85215 .21011 L
.85315 .21011 L
.85415 .21011 L
.85514 .21011 L
.85614 .21011 L
.85714 .21011 L
.85814 .21011 L
.85914 .21011 L
.86014 .21011 L
.86114 .21011 L
.86214 .21011 L
.86314 .21011 L
.86414 .21011 L
.86513 .21011 L
.86613 .21011 L
.86713 .21011 L
.86813 .21011 L
.86913 .21011 L
.87013 .21011 L
.87113 .21011 L
.87213 .21011 L
.87313 .21011 L
.87413 .21011 L
.87512 .21011 L
.87612 .21011 L
.87712 .21011 L
.87812 .21011 L
.87912 .21011 L
.88012 .21011 L
.88112 .21011 L
.88212 .21011 L
.88312 .21011 L
.88412 .21011 L
.88511 .21011 L
.88611 .21011 L
.88711 .21011 L
.88811 .21011 L
.88911 .21011 L
.89011 .21011 L
.89111 .21011 L
.89211 .21011 L
.89311 .21011 L
.89411 .21011 L
.8951 .21011 L
.8961 .21011 L
.8971 .21011 L
.8981 .21011 L
Mistroke
.8991 .21071 L
.9001 .21071 L
.9011 .21071 L
.9021 .21071 L
.9031 .21071 L
.9041 .21071 L
.90509 .21071 L
.90609 .21071 L
.90709 .21071 L
.90809 .21071 L
.90909 .21071 L
.91009 .21071 L
.91109 .21071 L
.91209 .21071 L
.91309 .21071 L
.91409 .21071 L
.91508 .21071 L
.91608 .21071 L
.91708 .21071 L
.91808 .21071 L
.91908 .21071 L
.92008 .21071 L
.92108 .21071 L
.92208 .21071 L
.92308 .21071 L
.92408 .21071 L
.92507 .21071 L
.92607 .21071 L
.92707 .21071 L
.92807 .21071 L
.92907 .21071 L
.93007 .21071 L
.93107 .21071 L
.93207 .21071 L
.93307 .21071 L
.93407 .21071 L
.93506 .21071 L
.93606 .21071 L
.93706 .21071 L
.93806 .21071 L
.93906 .21071 L
.94006 .21071 L
.94106 .21071 L
.94206 .21071 L
.94306 .21071 L
.94406 .21071 L
.94505 .21071 L
.94605 .21071 L
.94705 .21071 L
.94805 .21071 L
Mistroke
.94905 .21155 L
.95005 .21155 L
.95105 .21155 L
.95205 .21155 L
.95305 .21155 L
.95405 .21155 L
.95504 .21155 L
.95604 .21155 L
.95704 .21155 L
.95804 .21155 L
.95904 .21155 L
.96004 .21155 L
.96104 .21155 L
.96204 .21155 L
.96304 .21155 L
.96404 .21155 L
.96503 .21155 L
.96603 .21155 L
.96703 .21155 L
.96803 .21155 L
.96903 .21155 L
.97003 .21155 L
.97103 .21155 L
.97203 .21155 L
.97303 .21155 L
.97403 .21155 L
.97502 .21155 L
.97602 .21155 L
.97702 .21155 L
.97802 .21155 L
.97902 .21155 L
.98002 .21155 L
.98102 .21155 L
.98202 .21155 L
.98302 .21155 L
.98402 .21155 L
.98501 .21155 L
.98601 .21155 L
.98701 .21155 L
.98801 .21155 L
.98901 .21155 L
.99001 .21155 L
.99101 .21155 L
.99201 .21155 L
.99301 .21155 L
.99401 .21155 L
.995 .21155 L
.996 .21155 L
.997 .21155 L
.998 .21155 L
Mistroke
.999 .21257 L
Mfstroke
0 0 1 r
gsave
.001 -0.38627 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .3062 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .348 L
.005 .34585 L
.00599 .34348 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33051 L
.01099 .3261 L
.01199 .32109 L
.01299 .31542 L
.01399 .30899 L
.01499 .30173 L
.01598 .29354 L
.01698 .28431 L
.01798 .27394 L
.01898 .26228 L
.01998 .24922 L
.02098 .23462 L
.02198 .21833 L
.02298 .20023 L
.02398 .18018 L
.02498 .15808 L
.02597 .13389 L
.02697 .10759 L
.02797 .0793 L
.02897 .04923 L
.02997 .0178 L
s
.02997 .0178 m
.03052 0 L
s
.04361 0 m
.04396 .01479 L
.04496 .05968 L
.04595 .10507 L
.04695 .14932 L
.04795 .19052 L
.04895 .22618 L
.04995 .10227 L
.05095 .08924 L
.05195 .08245 L
.05295 .082 L
.05395 .0881 L
.05495 .10046 L
.05594 .11825 L
.05694 .1403 L
.05794 .16536 L
.05894 .19221 L
.05994 .21971 L
.06094 .24684 L
.06194 .27278 L
.06294 .29699 L
.06394 .31915 L
.06494 .33915 L
.06593 .35705 L
.06693 .37302 L
.06793 .38726 L
.06893 .4 L
.06993 .41145 L
.07093 .42172 L
.07193 .43084 L
.07293 .43865 L
.07393 .44474 L
.07493 .44836 L
.07592 .44856 L
.07692 .44479 L
.07792 .43738 L
.07892 .42724 L
.07992 .41533 L
.08092 .40245 L
.08192 .38919 L
.08292 .37598 L
.08392 .36316 L
.08492 .35096 L
.08591 .33955 L
.08691 .32904 L
.08791 .3195 L
.08891 .31094 L
.08991 .30335 L
.09091 .2967 L
.09191 .29093 L
Mistroke
.09291 .28599 L
.09391 .2818 L
.09491 .27827 L
.0959 .27532 L
.0969 .27288 L
.0979 .27086 L
.0989 .26918 L
.0999 .39807 L
.1009 .39278 L
.1019 .38952 L
.1029 .38721 L
.1039 .38551 L
.1049 .38421 L
.10589 .38321 L
.10689 .38244 L
.10789 .38186 L
.10889 .38145 L
.10989 .38117 L
.11089 .38102 L
.11189 .38098 L
.11289 .38105 L
.11389 .38123 L
.11489 .38152 L
.11588 .3819 L
.11688 .3824 L
.11788 .38302 L
.11888 .38375 L
.11988 .38462 L
.12088 .38565 L
.12188 .38685 L
.12288 .38824 L
.12388 .38987 L
.12488 .39176 L
.12587 .39397 L
.12687 .39654 L
.12787 .39955 L
.12887 .40307 L
.12987 .40717 L
.13087 .41195 L
.13187 .41749 L
.13287 .42387 L
.13387 .43117 L
.13487 .4394 L
.13586 .44856 L
.13686 .45848 L
.13786 .46888 L
.13886 .47913 L
.13986 .48811 L
.14086 .49397 L
.14186 .49438 L
Mistroke
.14286 .48805 L
.14386 .47591 L
.14486 .46 L
.14585 .44213 L
.14685 .42367 L
.14785 .40561 L
.14885 .38865 L
.14985 .55473 L
.15085 .5357 L
.15185 .51732 L
.15285 .49909 L
.15385 .48116 L
.15485 .46377 L
.15584 .44719 L
.15684 .43162 L
.15784 .41719 L
.15884 .40397 L
.15984 .39197 L
.16084 .38115 L
.16184 .37144 L
.16284 .36274 L
.16384 .35496 L
.16484 .34799 L
.16583 .3417 L
.16683 .33601 L
.16783 .33081 L
.16883 .326 L
.16983 .32149 L
.17083 .31721 L
.17183 .31308 L
.17283 .30904 L
.17383 .305 L
.17483 .30093 L
.17582 .29676 L
.17682 .29244 L
.17782 .28793 L
.17882 .28319 L
.17982 .27816 L
.18082 .27283 L
.18182 .26714 L
.18282 .26107 L
.18382 .2546 L
.18482 .24769 L
.18581 .24033 L
.18681 .23252 L
.18781 .22424 L
.18881 .21551 L
.18981 .20635 L
.19081 .19679 L
.19181 .18689 L
Mistroke
.19281 .17673 L
.19381 .16641 L
.19481 .15606 L
.1958 .14585 L
.1968 .13596 L
.1978 .12663 L
.1988 .11811 L
.1998 .27727 L
.2008 .26286 L
.2018 .25039 L
.2028 .23871 L
.2038 .22744 L
.2048 .21644 L
.20579 .20567 L
.20679 .19518 L
.20779 .18509 L
.20879 .1756 L
.20979 .16693 L
.21079 .15936 L
.21179 .15318 L
.21279 .14866 L
.21379 .14604 L
.21479 .14545 L
.21578 .14691 L
.21678 .15031 L
.21778 .15543 L
.21878 .16197 L
.21978 .16968 L
.22078 .17832 L
.22178 .18776 L
.22278 .19782 L
.22378 .20835 L
.22478 .21914 L
.22577 .22998 L
.22677 .24065 L
.22777 .25097 L
.22877 .26075 L
.22977 .26988 L
.23077 .27825 L
.23177 .2858 L
.23277 .29251 L
.23377 .29838 L
.23477 .30343 L
.23576 .30769 L
.23676 .31122 L
.23776 .31406 L
.23876 .31627 L
.23976 .3179 L
.24076 .319 L
.24176 .3196 L
Mistroke
.24276 .31976 L
.24376 .3195 L
.24476 .31884 L
.24575 .31782 L
.24675 .31645 L
.24775 .31473 L
.24875 .31267 L
.24975 .4456 L
.25075 .44346 L
.25175 .44325 L
.25275 .44388 L
.25375 .44499 L
.25475 .44643 L
.25574 .44809 L
.25674 .44991 L
.25774 .45187 L
.25874 .45393 L
.25974 .45606 L
.26074 .45825 L
.26174 .46048 L
.26274 .46274 L
.26374 .46498 L
.26474 .4672 L
.26573 .46936 L
.26673 .47143 L
.26773 .47336 L
.26873 .4751 L
.26973 .4766 L
.27073 .47778 L
.27173 .47858 L
.27273 .47892 L
.27373 .47869 L
.27473 .47783 L
.27572 .47627 L
.27672 .47394 L
.27772 .47084 L
.27872 .46698 L
.27972 .46243 L
.28072 .45729 L
.28172 .45168 L
.28272 .44574 L
.28372 .43961 L
.28472 .43342 L
.28571 .42728 L
.28671 .4213 L
.28771 .41554 L
.28871 .41008 L
.28971 .40495 L
.29071 .40017 L
.29171 .39575 L
Mistroke
.29271 .39169 L
.29371 .38798 L
.29471 .3846 L
.2957 .38155 L
.2967 .37878 L
.2977 .37629 L
.2987 .37405 L
.2997 .4154 L
.3007 .41078 L
.3017 .40817 L
.3027 .4065 L
.3037 .40542 L
.3047 .40475 L
.30569 .4044 L
.30669 .40431 L
.30769 .40445 L
.30869 .4048 L
.30969 .40535 L
.31069 .40608 L
.31169 .407 L
.31269 .4081 L
.31369 .4094 L
.31469 .41089 L
.31568 .41259 L
.31668 .41451 L
.31768 .41665 L
.31868 .41903 L
.31968 .42167 L
.32068 .42459 L
.32168 .42779 L
.32268 .43131 L
.32368 .43516 L
.32468 .43934 L
.32567 .44388 L
.32667 .44877 L
.32767 .454 L
.32867 .45952 L
.32967 .46527 L
.33067 .47113 L
.33167 .47692 L
.33267 .48237 L
.33367 .48709 L
.33467 .4906 L
.33566 .49232 L
.33666 .49173 L
.33766 .48855 L
.33866 .48286 L
.33966 .47506 L
.34066 .4657 L
.34166 .45533 L
Mistroke
.34266 .44447 L
.34366 .43355 L
.34466 .4229 L
.34565 .41276 L
.34665 .40332 L
.34765 .39466 L
.34865 .38681 L
.34965 .50784 L
.35065 .49705 L
.35165 .48742 L
.35265 .47811 L
.35365 .46893 L
.35465 .45988 L
.35564 .451 L
.35664 .44236 L
.35764 .43405 L
.35864 .42612 L
.35964 .41863 L
.36064 .4116 L
.36164 .40507 L
.36264 .39903 L
.36364 .39348 L
.36464 .38841 L
.36563 .38379 L
.36663 .37959 L
.36763 .37578 L
.36863 .37233 L
.36963 .36919 L
.37063 .36634 L
.37163 .36374 L
.37263 .36134 L
.37363 .35913 L
.37463 .35706 L
.37562 .35511 L
.37662 .35326 L
.37762 .35146 L
.37862 .34971 L
.37962 .34798 L
.38062 .34625 L
.38162 .3445 L
.38262 .34271 L
.38362 .34087 L
.38462 .33896 L
.38561 .33698 L
.38661 .3349 L
.38761 .33272 L
.38861 .33044 L
.38961 .32805 L
.39061 .32554 L
.39161 .32292 L
Mistroke
.39261 .3202 L
.39361 .31739 L
.39461 .3145 L
.3956 .31155 L
.3966 .30857 L
.3976 .30561 L
.3986 .3027 L
.3996 .31791 L
.4006 .31186 L
.4016 .30698 L
.4026 .30218 L
.4036 .29713 L
.4046 .29167 L
.40559 .28572 L
.40659 .27921 L
.40759 .2721 L
.40859 .26438 L
.40959 .25602 L
.41059 .24701 L
.41159 .23739 L
.41259 .22718 L
.41359 .21645 L
.41459 .2053 L
.41558 .19389 L
.41658 .18242 L
.41758 .17114 L
.41858 .16039 L
.41958 .15054 L
.42058 .142 L
.42158 .13521 L
.42258 .13054 L
.42358 .12822 L
.42458 .12817 L
.42557 .12983 L
.42657 .13209 L
.42757 .13383 L
.42857 .13493 L
.42957 .1363 L
.43057 .13907 L
.43157 .144 L
.43257 .15145 L
.43357 .16144 L
.43457 .17369 L
.43556 .18779 L
.43656 .20316 L
.43756 .21923 L
.43856 .23545 L
.43956 .25134 L
.44056 .26651 L
.44156 .28069 L
Mistroke
.44256 .29369 L
.44356 .30542 L
.44456 .31586 L
.44555 .32505 L
.44655 .33305 L
.44755 .33998 L
.44855 .34593 L
.44955 .39727 L
.45055 .39836 L
.45155 .40044 L
.45255 .40259 L
.45355 .40459 L
.45455 .40635 L
.45554 .40784 L
.45654 .40908 L
.45754 .41008 L
.45854 .41089 L
.45954 .41153 L
.46054 .41204 L
.46154 .41245 L
.46254 .4128 L
.46354 .4131 L
.46454 .41338 L
.46553 .41368 L
.46653 .41399 L
.46753 .41435 L
.46853 .41476 L
.46953 .41524 L
.47053 .4158 L
.47153 .41645 L
.47253 .4172 L
.47353 .41805 L
.47453 .41901 L
.47552 .42008 L
.47652 .42127 L
.47752 .42258 L
.47852 .424 L
.47952 .42553 L
.48052 .42718 L
.48152 .42892 L
.48252 .43075 L
.48352 .43264 L
.48452 .43458 L
.48551 .43652 L
.48651 .43843 L
.48751 .44027 L
.48851 .44197 L
.48951 .44347 L
.49051 .44471 L
.49151 .44561 L
Mistroke
.49251 .4461 L
.49351 .44614 L
.49451 .44566 L
.4955 .44465 L
.4965 .44311 L
.4975 .44105 L
.4985 .43853 L
.4995 .53689 L
.5005 .52434 L
.5015 .51256 L
.5025 .50071 L
.5035 .48869 L
.5045 .47657 L
.50549 .46447 L
.50649 .45257 L
.50749 .44101 L
.50849 .42993 L
.50949 .41942 L
.51049 .40956 L
.51149 .40039 L
.51249 .39192 L
.51349 .38415 L
.51449 .37705 L
.51548 .37058 L
.51648 .3647 L
.51748 .35935 L
.51848 .35449 L
.51948 .35004 L
.52048 .34596 L
.52148 .34219 L
.52248 .33868 L
.52348 .33537 L
.52448 .33222 L
.52547 .32918 L
.52647 .3262 L
.52747 .32325 L
.52847 .32029 L
.52947 .31727 L
.53047 .31416 L
.53147 .31094 L
.53247 .30755 L
.53347 .30398 L
.53447 .30019 L
.53546 .29614 L
.53646 .29181 L
.53746 .28716 L
.53846 .28215 L
.53946 .27677 L
.54046 .27096 L
.54146 .2647 L
Mistroke
.54246 .25796 L
.54346 .25069 L
.54446 .24287 L
.54545 .23447 L
.54645 .22545 L
.54745 .2158 L
.54845 .2055 L
.54945 .40678 L
.55045 .40836 L
.55145 .41165 L
.55245 .41563 L
.55345 .42005 L
.55445 .42481 L
.55544 .42989 L
.55644 .43527 L
.55744 .44098 L
.55844 .44703 L
.55944 .45343 L
.56044 .46018 L
.56144 .46729 L
.56244 .47474 L
.56344 .48252 L
.56444 .49057 L
.56543 .49883 L
.56643 .50718 L
.56743 .51547 L
.56843 .52346 L
.56943 .53083 L
.57043 .53711 L
.57143 .54168 L
.57243 .54368 L
.57343 .54214 L
.57443 .53631 L
.57542 .52607 L
.57642 .51206 L
.57742 .49528 L
.57842 .4768 L
.57942 .45757 L
.58042 .43837 L
.58142 .41979 L
.58242 .40224 L
.58342 .38597 L
.58442 .37111 L
.58541 .35767 L
.58641 .3456 L
.58741 .33482 L
.58841 .32521 L
.58941 .31664 L
.59041 .30899 L
.59141 .30216 L
Mistroke
.59241 .29603 L
.59341 .29052 L
.59441 .28554 L
.5954 .28102 L
.5964 .27689 L
.5974 .27309 L
.5984 .26956 L
.5994 .3304 L
.6004 .32079 L
.6014 .3134 L
.6024 .30711 L
.6034 .30153 L
.6044 .2964 L
.60539 .29157 L
.60639 .28693 L
.60739 .2824 L
.60839 .27791 L
.60939 .27342 L
.61039 .2689 L
.61139 .26431 L
.61239 .25963 L
.61339 .25487 L
.61439 .25002 L
.61538 .2451 L
.61638 .24011 L
.61738 .23508 L
.61838 .23005 L
.61938 .22505 L
.62038 .22015 L
.62138 .21539 L
.62238 .21083 L
.62338 .20656 L
.62438 .20263 L
.62537 .1991 L
.62637 .19604 L
.62737 .19348 L
.62837 .19144 L
.62937 .18992 L
.63037 .18887 L
.63137 .18821 L
.63237 .18785 L
.63337 .18768 L
.63437 .18762 L
.63536 .18762 L
.63636 .18772 L
.63736 .18798 L
.63836 .18852 L
.63936 .18944 L
.64036 .19084 L
.64136 .19279 L
Mistroke
.64236 .19532 L
.64336 .19845 L
.64436 .20212 L
.64535 .20627 L
.64635 .21083 L
.64735 .21568 L
.64835 .22071 L
.64935 .31956 L
.65035 .31444 L
.65135 .31091 L
.65235 .30793 L
.65335 .30514 L
.65435 .30238 L
.65534 .29954 L
.65634 .29655 L
.65734 .29338 L
.65834 .29 L
.65934 .28637 L
.66034 .28249 L
.66134 .27833 L
.66234 .2739 L
.66334 .26919 L
.66434 .26419 L
.66533 .2589 L
.66633 .25335 L
.66733 .24753 L
.66833 .24148 L
.66933 .23522 L
.67033 .22881 L
.67133 .2223 L
.67233 .21575 L
.67333 .20927 L
.67433 .20294 L
.67532 .19688 L
.67632 .19121 L
.67732 .18608 L
.67832 .1816 L
.67932 .1779 L
.68032 .17506 L
.68132 .17311 L
.68232 .17201 L
.68332 .17159 L
.68432 .17157 L
.68531 .17154 L
.68631 .17111 L
.68731 .17007 L
.68831 .16849 L
.68931 .16673 L
.69031 .16523 L
.69131 .16442 L
Mistroke
.69231 .16464 L
.69331 .16613 L
.69431 .169 L
.6953 .17326 L
.6963 .17885 L
.6973 .18561 L
.6983 .19333 L
.6993 .28613 L
.7003 .2889 L
.7013 .29303 L
.7023 .29743 L
.7033 .30176 L
.7043 .30583 L
.70529 .30953 L
.70629 .31281 L
.70729 .31565 L
.70829 .31804 L
.70929 .32 L
.71029 .32153 L
.71129 .32267 L
.71229 .32342 L
.71329 .32383 L
.71429 .3239 L
.71528 .32366 L
.71628 .32313 L
.71728 .32231 L
.71828 .32122 L
.71928 .31986 L
.72028 .31824 L
.72128 .31636 L
.72228 .31421 L
.72328 .31179 L
.72428 .30908 L
.72527 .30609 L
.72627 .30278 L
.72727 .29914 L
.72827 .29516 L
.72927 .29081 L
.73027 .28607 L
.73127 .2809 L
.73227 .27529 L
.73327 .2692 L
.73427 .2626 L
.73526 .25547 L
.73626 .24776 L
.73726 .23946 L
.73826 .23054 L
.73926 .22097 L
.74026 .21075 L
.74126 .19986 L
Mistroke
.74226 .18832 L
.74326 .17614 L
.74426 .16338 L
.74525 .15008 L
.74625 .13636 L
.74725 .12233 L
.74825 .10816 L
.74925 .25279 L
.75025 .23773 L
.75125 .224 L
.75225 .21056 L
.75325 .19719 L
.75425 .18392 L
.75524 .17091 L
.75624 .15846 L
.75724 .14695 L
.75824 .13686 L
.75924 .12871 L
.76024 .12302 L
.76124 .12024 L
.76224 .12067 L
.76324 .12436 L
.76424 .13113 L
.76523 .14058 L
.76623 .15229 L
.76723 .16587 L
.76823 .181 L
.76923 .19732 L
.77023 .21444 L
.77123 .2319 L
.77223 .24926 L
.77323 .26612 L
.77423 .28216 L
.77522 .29713 L
.77622 .3109 L
.77722 .32337 L
.77822 .33456 L
.77922 .34448 L
.78022 .35322 L
.78122 .36087 L
.78222 .36753 L
.78322 .37332 L
.78422 .37835 L
.78521 .38272 L
.78621 .38654 L
.78721 .3899 L
.78821 .39287 L
.78921 .39553 L
.79021 .39794 L
.79121 .40015 L
Mistroke
.79221 .40221 L
.79321 .40415 L
.79421 .406 L
.7952 .40777 L
.7962 .40949 L
.7972 .41116 L
.7982 .41278 L
.7992 .46672 L
.8002 .4649 L
.8012 .46455 L
.8022 .46464 L
.8032 .46487 L
.8042 .46508 L
.80519 .46519 L
.80619 .46515 L
.80719 .46495 L
.80819 .46457 L
.80919 .46401 L
.81019 .46326 L
.81119 .46233 L
.81219 .46122 L
.81319 .45995 L
.81419 .45852 L
.81518 .45694 L
.81618 .45523 L
.81718 .4534 L
.81818 .45146 L
.81918 .44942 L
.82018 .44729 L
.82118 .4451 L
.82218 .44285 L
.82318 .44056 L
.82418 .43824 L
.82517 .43592 L
.82617 .43361 L
.82717 .43132 L
.82817 .42907 L
.82917 .42688 L
.83017 .42476 L
.83117 .42272 L
.83217 .42078 L
.83317 .41896 L
.83417 .41725 L
.83516 .41566 L
.83616 .41421 L
.83716 .4129 L
.83816 .41173 L
.83916 .41071 L
.84016 .40984 L
.84116 .40912 L
Mistroke
.84216 .40855 L
.84316 .40814 L
.84416 .40787 L
.84515 .40776 L
.84615 .40779 L
.84715 .40798 L
.84815 .40831 L
.84915 .50312 L
.85015 .49883 L
.85115 .49589 L
.85215 .49326 L
.85315 .49058 L
.85415 .48771 L
.85514 .48455 L
.85614 .4811 L
.85714 .47733 L
.85814 .47327 L
.85914 .46896 L
.86014 .46444 L
.86114 .45976 L
.86214 .45498 L
.86314 .45015 L
.86414 .44532 L
.86513 .44055 L
.86613 .43587 L
.86713 .43134 L
.86813 .42697 L
.86913 .42281 L
.87013 .41887 L
.87113 .41516 L
.87213 .41171 L
.87313 .4085 L
.87413 .40556 L
.87512 .40287 L
.87612 .40043 L
.87712 .39824 L
.87812 .39629 L
.87912 .39457 L
.88012 .39308 L
.88112 .3918 L
.88212 .39073 L
.88312 .38986 L
.88412 .38918 L
.88511 .38869 L
.88611 .38838 L
.88711 .38826 L
.88811 .38832 L
.88911 .38857 L
.89011 .389 L
.89111 .38962 L
Mistroke
.89211 .39044 L
.89311 .39147 L
.89411 .39273 L
.8951 .39421 L
.8961 .39595 L
.8971 .39794 L
.8981 .40022 L
.8991 .45108 L
.9001 .45247 L
.9011 .45604 L
.9021 .46069 L
.9031 .46606 L
.9041 .47194 L
.90509 .47823 L
.90609 .48482 L
.90709 .49161 L
.90809 .4985 L
.90909 .50538 L
.91009 .51209 L
.91109 .51849 L
.91209 .52436 L
.91309 .52949 L
.91409 .5336 L
.91508 .53639 L
.91608 .5375 L
.91708 .53658 L
.91808 .53327 L
.91908 .52733 L
.92008 .5187 L
.92108 .5076 L
.92208 .49445 L
.92308 .47982 L
.92408 .46433 L
.92507 .44853 L
.92607 .43289 L
.92707 .41778 L
.92807 .40345 L
.92907 .39008 L
.93007 .37774 L
.93107 .36646 L
.93207 .35621 L
.93307 .34695 L
.93407 .3386 L
.93506 .33106 L
.93606 .32426 L
.93706 .3181 L
.93806 .31249 L
.93906 .30735 L
.94006 .3026 L
.94106 .29816 L
Mistroke
.94206 .29396 L
.94306 .28994 L
.94406 .28604 L
.94505 .28221 L
.94605 .2784 L
.94705 .27457 L
.94805 .27067 L
.94905 .32241 L
.95005 .31669 L
.95105 .31255 L
.95205 .30891 L
.95305 .30541 L
.95405 .30188 L
.95504 .29821 L
.95604 .29434 L
.95704 .29022 L
.95804 .28582 L
.95904 .28111 L
.96004 .27608 L
.96104 .2707 L
.96204 .26498 L
.96304 .2589 L
.96404 .25248 L
.96503 .24574 L
.96603 .23868 L
.96703 .23136 L
.96803 .22383 L
.96903 .21616 L
.97003 .20845 L
.97103 .2008 L
.97203 .19336 L
.97303 .18629 L
.97403 .17975 L
.97502 .17394 L
.97602 .16904 L
.97702 .1652 L
.97802 .16253 L
.97902 .16103 L
.98002 .16056 L
.98102 .16078 L
.98202 .16116 L
.98302 .16113 L
.98402 .16038 L
.98501 .15907 L
.98601 .15773 L
.98701 .15698 L
.98801 .15733 L
.98901 .15913 L
.99001 .16257 L
.99101 .16769 L
Mistroke
.99201 .17441 L
.99301 .18253 L
.99401 .19179 L
.995 .20186 L
.996 .21241 L
.997 .22312 L
.998 .23368 L
.999 .3062 L
Mfstroke
gsave
.999 .32111 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38342 L
.004 .38538 L
.005 .38722 L
.00599 .38906 L
.00699 .39099 L
.00799 .39308 L
.00899 .3954 L
.00999 .39798 L
.01099 .40089 L
.01199 .40417 L
.01299 .40789 L
.01399 .41209 L
.01499 .41685 L
.01598 .42222 L
.01698 .42829 L
.01798 .43513 L
.01898 .44283 L
.01998 .45149 L
.02098 .46121 L
.02198 .47211 L
.02298 .48429 L
.02398 .49788 L
.02498 .513 L
.02597 .52976 L
.02697 .54826 L
.02797 .56857 L
.02897 .59071 L
.02997 .61466 L
s
.02997 .61466 m
.0301 .61803 L
s
.04904 .61803 m
.04995 .11757 L
.05095 .11317 L
.05195 .11155 L
.05295 .11455 L
.05395 .12332 L
.05495 .13859 L
.05594 .16053 L
.05694 .18853 L
.05794 .22118 L
.05894 .25658 L
.05994 .2928 L
.06094 .3282 L
.06194 .36158 L
.06294 .39215 L
.06394 .4195 L
.06494 .44344 L
.06593 .46393 L
.06693 .48102 L
.06793 .49479 L
.06893 .50537 L
.06993 .51292 L
.07093 .51763 L
.07193 .51985 L
.07293 .52005 L
.07393 .519 L
.07493 .51781 L
.07592 .51775 L
.07692 .51974 L
.07792 .52379 L
.07892 .52934 L
.07992 .53572 L
.08092 .54242 L
.08192 .54909 L
.08292 .5555 L
.08392 .56147 L
.08492 .56687 L
.08591 .57164 L
.08691 .57571 L
.08791 .57906 L
.08891 .58167 L
.08991 .58355 L
.09091 .58473 L
.09191 .58525 L
.09291 .58515 L
.09391 .5845 L
.09491 .58336 L
.0959 .58181 L
.0969 .57993 L
.0979 .57779 L
Mistroke
.0989 .57547 L
.0999 .41305 L
.1009 .41637 L
.1019 .41829 L
.1029 .41983 L
.1039 .42134 L
.1049 .42295 L
.10589 .42474 L
.10689 .42678 L
.10789 .42907 L
.10889 .43165 L
.10989 .43454 L
.11089 .43774 L
.11189 .44127 L
.11289 .44515 L
.11389 .44939 L
.11489 .45402 L
.11588 .45905 L
.11688 .4645 L
.11788 .47039 L
.11888 .47673 L
.11988 .48354 L
.12088 .49082 L
.12188 .49856 L
.12288 .50676 L
.12388 .51539 L
.12488 .5244 L
.12587 .53372 L
.12687 .54326 L
.12787 .55288 L
.12887 .56244 L
.12987 .57173 L
.13087 .5805 L
.13187 .58848 L
.13287 .59537 L
.13387 .60085 L
.13487 .60461 L
.13586 .6064 L
.13686 .60606 L
.13786 .60363 L
.13886 .59951 L
.13986 .59463 L
.14086 .59072 L
.14186 .59006 L
.14286 .59392 L
.14386 .60139 L
.14486 .6105 L
Mfstroke
.14486 .6105 m
.14569 .61803 L
s
.14911 .61803 m
.14985 .56958 L
.15085 .55971 L
.15185 .54731 L
.15285 .53372 L
.15385 .51963 L
.15485 .50553 L
.15584 .49183 L
.15684 .4788 L
.15784 .46666 L
.15884 .45554 L
.15984 .44552 L
.16084 .43662 L
.16184 .42882 L
.16284 .42208 L
.16384 .41632 L
.16484 .41147 L
.16583 .40745 L
.16683 .40415 L
.16783 .40151 L
.16883 .39944 L
.16983 .39787 L
.17083 .39674 L
.17183 .39598 L
.17283 .39556 L
.17383 .39543 L
.17483 .39555 L
.17582 .39591 L
.17682 .39647 L
.17782 .39722 L
.17882 .39815 L
.17982 .39925 L
.18082 .40051 L
.18182 .40193 L
.18282 .40349 L
.18382 .40521 L
.18482 .40708 L
.18581 .40909 L
.18681 .41125 L
.18781 .41354 L
.18881 .41596 L
.18981 .4185 L
.19081 .42114 L
.19181 .42386 L
.19281 .42663 L
.19381 .42942 L
.19481 .43217 L
.1958 .43484 L
.1968 .43736 L
.1978 .43965 L
Mistroke
.1988 .44166 L
.1998 .29177 L
.2008 .2865 L
.2018 .27977 L
.2028 .27254 L
.2038 .26509 L
.2048 .25755 L
.20579 .25002 L
.20679 .24259 L
.20779 .23536 L
.20879 .22845 L
.20979 .22201 L
.21079 .21621 L
.21179 .21125 L
.21279 .20736 L
.21379 .2048 L
.21479 .20385 L
.21578 .2048 L
.21678 .20795 L
.21778 .2135 L
.21878 .22155 L
.21978 .23195 L
.22078 .24438 L
.22178 .25832 L
.22278 .27319 L
.22378 .28845 L
.22478 .30359 L
.22577 .31825 L
.22677 .33213 L
.22777 .34507 L
.22877 .35696 L
.22977 .36779 L
.23077 .37759 L
.23177 .3864 L
.23277 .39433 L
.23377 .40144 L
.23477 .40786 L
.23576 .41368 L
.23676 .41899 L
.23776 .4239 L
.23876 .42847 L
.23976 .43281 L
.24076 .43698 L
.24176 .44106 L
.24276 .44511 L
.24376 .44919 L
.24476 .45335 L
.24575 .45765 L
.24675 .46215 L
.24775 .46687 L
Mistroke
.24875 .47187 L
.24975 .46004 L
.25075 .46686 L
.25175 .47202 L
.25275 .47662 L
.25375 .48101 L
.25475 .48536 L
.25574 .48976 L
.25674 .49423 L
.25774 .4988 L
.25874 .50345 L
.25974 .50817 L
.26074 .51291 L
.26174 .51765 L
.26274 .52231 L
.26374 .52684 L
.26474 .53117 L
.26573 .53522 L
.26673 .53893 L
.26773 .54221 L
.26873 .545 L
.26973 .54725 L
.27073 .5489 L
.27173 .54995 L
.27273 .55039 L
.27373 .55025 L
.27473 .54958 L
.27572 .54844 L
.27672 .54691 L
.27772 .54505 L
.27872 .54293 L
.27972 .54058 L
.28072 .53804 L
.28172 .5353 L
.28272 .53239 L
.28372 .52932 L
.28472 .52611 L
.28571 .52277 L
.28671 .51936 L
.28771 .5159 L
.28871 .51245 L
.28971 .50906 L
.29071 .50577 L
.29171 .50264 L
.29271 .49971 L
.29371 .49702 L
.29471 .4946 L
.2957 .49248 L
.2967 .49068 L
.2977 .48923 L
Mistroke
.2987 .48812 L
.2997 .43005 L
.3007 .43423 L
.3017 .4369 L
.3027 .43913 L
.3037 .44126 L
.3047 .44347 L
.30569 .44584 L
.30669 .44843 L
.30769 .45128 L
.30869 .45441 L
.30969 .45783 L
.31069 .46156 L
.31169 .46561 L
.31269 .46998 L
.31369 .47468 L
.31469 .4797 L
.31568 .48504 L
.31668 .49069 L
.31768 .49663 L
.31868 .50284 L
.31968 .50928 L
.32068 .51591 L
.32168 .52266 L
.32268 .52946 L
.32368 .53622 L
.32468 .54283 L
.32567 .54916 L
.32667 .55508 L
.32767 .56045 L
.32867 .56512 L
.32967 .56897 L
.33067 .5719 L
.33167 .57387 L
.33267 .57494 L
.33367 .57528 L
.33467 .5752 L
.33566 .57511 L
.33666 .57543 L
.33766 .57635 L
.33866 .57778 L
.33966 .57933 L
.34066 .58056 L
.34166 .58101 L
.34266 .58036 L
.34366 .57838 L
.34466 .57497 L
.34565 .57014 L
.34665 .564 L
.34765 .55672 L
Mistroke
.34865 .54854 L
.34965 .52268 L
.35065 .52072 L
.35165 .51644 L
.35265 .511 L
.35365 .5049 L
.35465 .49847 L
.35564 .49192 L
.35664 .48546 L
.35764 .47923 L
.35864 .47333 L
.35964 .46784 L
.36064 .46283 L
.36164 .45832 L
.36264 .45434 L
.36364 .4509 L
.36464 .44799 L
.36563 .44559 L
.36663 .4437 L
.36763 .44229 L
.36863 .44133 L
.36963 .44082 L
.37063 .44072 L
.37163 .44103 L
.37263 .44172 L
.37363 .44278 L
.37463 .4442 L
.37562 .44598 L
.37662 .44811 L
.37762 .4506 L
.37862 .45344 L
.37962 .45663 L
.38062 .4602 L
.38162 .46414 L
.38262 .46846 L
.38362 .47319 L
.38462 .47832 L
.38561 .48388 L
.38661 .48986 L
.38761 .49629 L
.38861 .50317 L
.38961 .51049 L
.39061 .51824 L
.39161 .52642 L
.39261 .53499 L
.39361 .54391 L
.39461 .55313 L
.3956 .56257 L
.3966 .57213 L
.3976 .5817 L
Mistroke
.3986 .59112 L
.3996 .33231 L
.4006 .33522 L
.4016 .33578 L
.4026 .33517 L
.4036 .33376 L
.4046 .33174 L
.40559 .32921 L
.40659 .32621 L
.40759 .32279 L
.40859 .31894 L
.40959 .31469 L
.41059 .31001 L
.41159 .30489 L
.41259 .29933 L
.41359 .2933 L
.41459 .28679 L
.41558 .27978 L
.41658 .27226 L
.41758 .26425 L
.41858 .25576 L
.41958 .24685 L
.42058 .23763 L
.42158 .22829 L
.42258 .21912 L
.42358 .2106 L
.42458 .2035 L
.42557 .199 L
.42657 .1987 L
.42757 .20403 L
.42857 .21517 L
.42957 .23101 L
.43057 .25001 L
.43157 .27075 L
.43257 .29208 L
.43357 .31307 L
.43457 .33309 L
.43556 .35168 L
.43656 .36862 L
.43756 .38384 L
.43856 .39736 L
.43956 .40929 L
.44056 .4198 L
.44156 .42904 L
.44256 .43717 L
.44356 .44434 L
.44456 .45069 L
.44555 .45631 L
.44655 .4613 L
.44755 .46574 L
Mistroke
.44855 .46969 L
.44955 .4123 L
.45055 .42213 L
.45155 .42951 L
.45255 .43551 L
.45355 .44056 L
.45455 .44491 L
.45554 .44872 L
.45654 .45213 L
.45754 .45523 L
.45854 .4581 L
.45954 .4608 L
.46054 .4634 L
.46154 .46592 L
.46254 .4684 L
.46354 .47087 L
.46454 .47335 L
.46553 .47587 L
.46653 .47843 L
.46753 .48104 L
.46853 .48371 L
.46953 .48645 L
.47053 .48925 L
.47153 .49211 L
.47253 .49503 L
.47353 .49799 L
.47453 .50098 L
.47552 .50399 L
.47652 .507 L
.47752 .50999 L
.47852 .51294 L
.47952 .51582 L
.48052 .51861 L
.48152 .52128 L
.48252 .52381 L
.48352 .52618 L
.48452 .52837 L
.48551 .53037 L
.48651 .53216 L
.48751 .53375 L
.48851 .53515 L
.48951 .53637 L
.49051 .53745 L
.49151 .53842 L
.49251 .53929 L
.49351 .54012 L
.49451 .54091 L
.4955 .54168 L
.4965 .5424 L
.4975 .54307 L
Mistroke
.4985 .54363 L
.4995 .55148 L
.5005 .54789 L
.5015 .54159 L
.5025 .53378 L
.5035 .52498 L
.5045 .51559 L
.50549 .5059 L
.50649 .4962 L
.50749 .48668 L
.50849 .47753 L
.50949 .46889 L
.51049 .46084 L
.51149 .45346 L
.51249 .44678 L
.51349 .44081 L
.51449 .43556 L
.51548 .43098 L
.51648 .42707 L
.51748 .42377 L
.51848 .42104 L
.51948 .41885 L
.52048 .41715 L
.52148 .4159 L
.52248 .41505 L
.52348 .41459 L
.52448 .41447 L
.52547 .41467 L
.52647 .41518 L
.52747 .41597 L
.52847 .41703 L
.52947 .41836 L
.53047 .41995 L
.53147 .4218 L
.53247 .42391 L
.53347 .42629 L
.53447 .42894 L
.53546 .43189 L
.53646 .43515 L
.53746 .43873 L
.53846 .44265 L
.53946 .44694 L
.54046 .45163 L
.54146 .45673 L
.54246 .46228 L
.54346 .46832 L
.54446 .47487 L
.54545 .48197 L
.54645 .48966 L
.54745 .49796 L
Mistroke
.54845 .50692 L
.54945 .42112 L
.55045 .43177 L
.55145 .44063 L
.55245 .44891 L
.55345 .45705 L
.55445 .46529 L
.55544 .47378 L
.55644 .48262 L
.55744 .49187 L
.55844 .50155 L
.55944 .51166 L
.56044 .52216 L
.56144 .53298 L
.56244 .54397 L
.56344 .55498 L
.56444 .56576 L
.56543 .57604 L
.56643 .58547 L
.56743 .5937 L
.56843 .60034 L
.56943 .60507 L
.57043 .60769 L
.57143 .60819 L
.57243 .60688 L
.57343 .60432 L
.57443 .60109 L
.57542 .59733 L
.57642 .59272 L
.57742 .58675 L
.57842 .57908 L
.57942 .56959 L
.58042 .55841 L
.58142 .54582 L
.58242 .53221 L
.58342 .51802 L
.58442 .50368 L
.58541 .48958 L
.58641 .47605 L
.58741 .46334 L
.58841 .4516 L
.58941 .44093 L
.59041 .43138 L
.59141 .42292 L
.59241 .41551 L
.59341 .40907 L
.59441 .40352 L
.5954 .39877 L
.5964 .39471 L
.5974 .39126 L
Mistroke
.5984 .38832 L
.5994 .34522 L
.6004 .34448 L
.6014 .34251 L
.6024 .34023 L
.6034 .33791 L
.6044 .33564 L
.60539 .33345 L
.60639 .33133 L
.60739 .32928 L
.60839 .32727 L
.60939 .32528 L
.61039 .32328 L
.61139 .32127 L
.61239 .3192 L
.61339 .31707 L
.61439 .31485 L
.61538 .31254 L
.61638 .31011 L
.61738 .30755 L
.61838 .30486 L
.61938 .30203 L
.62038 .29906 L
.62138 .29595 L
.62238 .29271 L
.62338 .28937 L
.62438 .28594 L
.62537 .28247 L
.62637 .27901 L
.62737 .27565 L
.62837 .27249 L
.62937 .26965 L
.63037 .26729 L
.63137 .26559 L
.63237 .26472 L
.63337 .26485 L
.63437 .26612 L
.63536 .26858 L
.63636 .27219 L
.63736 .27684 L
.63836 .28235 L
.63936 .28853 L
.64036 .29518 L
.64136 .30208 L
.64236 .30907 L
.64336 .31599 L
.64436 .32274 L
.64535 .32921 L
.64635 .33536 L
.64735 .34114 L
Mistroke
.64835 .34654 L
.64935 .33432 L
.65035 .33798 L
.65135 .33979 L
.65235 .34077 L
.65335 .34126 L
.65435 .34141 L
.65534 .3413 L
.65634 .34099 L
.65734 .3405 L
.65834 .33984 L
.65934 .33902 L
.66034 .33805 L
.66134 .33692 L
.66234 .33562 L
.66334 .33416 L
.66434 .33252 L
.66533 .3307 L
.66633 .32867 L
.66733 .32643 L
.66833 .32396 L
.66933 .32125 L
.67033 .31828 L
.67133 .31502 L
.67233 .31146 L
.67333 .30759 L
.67433 .30339 L
.67532 .29885 L
.67632 .29397 L
.67732 .28877 L
.67832 .28328 L
.67932 .27756 L
.68032 .27174 L
.68132 .26597 L
.68232 .26052 L
.68332 .25572 L
.68432 .25206 L
.68531 .25009 L
.68631 .25032 L
.68731 .25304 L
.68831 .25822 L
.68931 .2655 L
.69031 .27437 L
.69131 .2843 L
.69231 .29481 L
.69331 .3055 L
.69431 .31602 L
.6953 .32614 L
.6963 .33566 L
.6973 .34449 L
Mistroke
.6983 .35257 L
.6993 .30095 L
.7003 .31258 L
.7013 .32208 L
.7023 .33039 L
.7033 .33782 L
.7043 .34449 L
.70529 .35052 L
.70629 .35598 L
.70729 .36092 L
.70829 .36539 L
.70929 .36945 L
.71029 .37314 L
.71129 .37651 L
.71229 .37959 L
.71329 .38242 L
.71429 .38505 L
.71528 .3875 L
.71628 .38981 L
.71728 .39202 L
.71828 .39415 L
.71928 .39622 L
.72028 .39828 L
.72128 .40034 L
.72228 .40243 L
.72328 .40457 L
.72428 .40679 L
.72527 .40911 L
.72627 .41156 L
.72727 .41415 L
.72827 .41692 L
.72927 .41988 L
.73027 .42306 L
.73127 .4265 L
.73227 .4302 L
.73327 .4342 L
.73427 .43854 L
.73526 .44323 L
.73626 .44832 L
.73726 .45382 L
.73826 .45977 L
.73926 .46621 L
.74026 .47317 L
.74126 .48067 L
.74226 .48874 L
.74326 .49742 L
.74426 .50671 L
.74525 .51663 L
.74625 .5272 L
.74725 .5384 L
Mistroke
.74825 .55022 L
.74925 .26728 L
.75025 .26133 L
.75125 .25332 L
.75225 .24436 L
.75325 .23484 L
.75425 .22503 L
.75524 .21517 L
.75624 .20551 L
.75724 .19637 L
.75824 .18808 L
.75924 .18104 L
.76024 .17572 L
.76124 .17262 L
.76224 .17227 L
.76324 .17522 L
.76424 .18192 L
.76523 .19265 L
.76623 .20727 L
.76723 .22523 L
.76823 .24564 L
.76923 .2675 L
.77023 .28984 L
.77123 .31186 L
.77223 .33296 L
.77323 .35273 L
.77423 .37093 L
.77522 .38747 L
.77622 .40234 L
.77722 .41561 L
.77822 .42736 L
.77922 .43774 L
.78022 .44686 L
.78122 .45485 L
.78222 .46184 L
.78322 .46794 L
.78422 .47325 L
.78521 .47787 L
.78621 .48188 L
.78721 .48535 L
.78821 .48837 L
.78921 .49098 L
.79021 .49325 L
.79121 .49523 L
.79221 .49697 L
.79321 .49851 L
.79421 .4999 L
.7952 .50117 L
.7962 .50237 L
.7972 .50353 L
Mistroke
.7982 .50468 L
.7992 .48124 L
.8002 .48836 L
.8012 .49339 L
.8022 .4974 L
.8032 .50076 L
.8042 .50362 L
.80519 .50608 L
.80619 .50821 L
.80719 .51002 L
.80819 .51156 L
.80919 .51283 L
.81019 .51383 L
.81119 .51458 L
.81219 .51508 L
.81319 .51535 L
.81419 .51539 L
.81518 .51522 L
.81618 .51486 L
.81718 .51432 L
.81818 .51363 L
.81918 .51282 L
.82018 .5119 L
.82118 .51092 L
.82218 .50989 L
.82318 .50884 L
.82418 .5078 L
.82517 .50679 L
.82617 .50583 L
.82717 .50494 L
.82817 .50414 L
.82917 .50344 L
.83017 .50285 L
.83117 .50238 L
.83217 .50203 L
.83317 .50182 L
.83417 .50175 L
.83516 .5018 L
.83616 .502 L
.83716 .50233 L
.83816 .50279 L
.83916 .50339 L
.84016 .50411 L
.84116 .50495 L
.84216 .5059 L
.84316 .50697 L
.84416 .50814 L
.84515 .5094 L
.84615 .51075 L
.84715 .51217 L
Mistroke
.84815 .51366 L
.84915 .51763 L
.85015 .52227 L
.85115 .52468 L
.85215 .52589 L
.85315 .52624 L
.85415 .52588 L
.85514 .52492 L
.85614 .52343 L
.85714 .52149 L
.85814 .51917 L
.85914 .51652 L
.86014 .51362 L
.86114 .51054 L
.86214 .50733 L
.86314 .50407 L
.86414 .50081 L
.86513 .49761 L
.86613 .49451 L
.86713 .49157 L
.86813 .48882 L
.86913 .4863 L
.87013 .48403 L
.87113 .48203 L
.87213 .48031 L
.87313 .4789 L
.87413 .47779 L
.87512 .47698 L
.87612 .47649 L
.87712 .47631 L
.87812 .47642 L
.87912 .47684 L
.88012 .47756 L
.88112 .47857 L
.88212 .47985 L
.88312 .48142 L
.88412 .48325 L
.88511 .48534 L
.88611 .48769 L
.88711 .49027 L
.88811 .49308 L
.88911 .49611 L
.89011 .49934 L
.89111 .50275 L
.89211 .50632 L
.89311 .51002 L
.89411 .51383 L
.8951 .51772 L
.8961 .52163 L
.8971 .52554 L
Mistroke
.8981 .52939 L
.8991 .46549 L
.9001 .47593 L
.9011 .48506 L
.9021 .49396 L
.9031 .50294 L
.9041 .51212 L
.90509 .52152 L
.90609 .53108 L
.90709 .54072 L
.90809 .55028 L
.90909 .55958 L
.91009 .56837 L
.91109 .57638 L
.91209 .58331 L
.91309 .58888 L
.91409 .59281 L
.91508 .59489 L
.91608 .59502 L
.91708 .59323 L
.91808 .58966 L
.91908 .58455 L
.92008 .57815 L
.92108 .57061 L
.92208 .56206 L
.92308 .55257 L
.92408 .54227 L
.92507 .53132 L
.92607 .51994 L
.92707 .50839 L
.92807 .4969 L
.92907 .48571 L
.93007 .47501 L
.93107 .46495 L
.93207 .45564 L
.93307 .44715 L
.93407 .43951 L
.93506 .43272 L
.93606 .42675 L
.93706 .42158 L
.93806 .41713 L
.93906 .41337 L
.94006 .41022 L
.94106 .40762 L
.94206 .40551 L
.94306 .40385 L
.94406 .40257 L
.94505 .40164 L
.94605 .401 L
.94705 .40063 L
Mistroke
.94805 .4005 L
.94905 .33697 L
.95005 .34017 L
.95105 .34143 L
.95205 .34183 L
.95305 .3417 L
.95405 .34121 L
.95504 .34043 L
.95604 .33942 L
.95704 .3382 L
.95804 .33678 L
.95904 .33516 L
.96004 .33335 L
.96104 .33134 L
.96204 .32912 L
.96304 .32667 L
.96404 .32399 L
.96503 .32106 L
.96603 .31785 L
.96703 .31436 L
.96803 .31055 L
.96903 .30642 L
.97003 .30193 L
.97103 .29706 L
.97203 .29182 L
.97303 .28618 L
.97403 .28017 L
.97502 .27381 L
.97602 .26717 L
.97702 .26037 L
.97802 .25358 L
.97902 .2471 L
.98002 .24135 L
.98102 .23694 L
.98202 .23463 L
.98302 .23515 L
.98402 .23894 L
.98501 .24586 L
.98601 .25533 L
.98701 .26662 L
.98801 .27904 L
.98901 .29197 L
.99001 .30492 L
.99101 .31749 L
.99201 .32942 L
.99301 .34052 L
.99401 .3507 L
.995 .35993 L
.996 .36827 L
.997 .37577 L
Mistroke
.998 .38254 L
.999 .32111 L
Mfstroke
1 0 0 r
gsave
.999 .31365 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36653 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .3649 L
.00999 .36425 L
.01099 .36349 L
.01199 .36263 L
.01299 .36165 L
.01399 .36054 L
.01499 .35929 L
.01598 .35788 L
.01698 .3563 L
.01798 .35453 L
.01898 .35256 L
.01998 .35036 L
.02098 .34791 L
.02198 .34522 L
.02298 .34226 L
.02398 .33903 L
.02498 .33554 L
.02597 .33183 L
.02697 .32793 L
.02797 .32393 L
.02897 .31997 L
.02997 .31623 L
.03097 .31297 L
.03197 .31053 L
.03297 .30934 L
.03397 .30989 L
.03497 .3127 L
.03596 .31829 L
.03696 .32702 L
.03796 .33904 L
.03896 .35415 L
.03996 .37172 L
.04096 .39067 L
.04196 .40964 L
.04296 .42708 L
.04396 .44151 L
.04496 .45178 L
.04595 .45721 L
.04695 .45772 L
.04795 .45378 L
.04895 .44628 L
Mistroke
.04995 .10992 L
.05095 .1012 L
.05195 .097 L
.05295 .09827 L
.05395 .10571 L
.05495 .11952 L
.05594 .13939 L
.05694 .16442 L
.05794 .19327 L
.05894 .2244 L
.05994 .25625 L
.06094 .28752 L
.06194 .31718 L
.06294 .34457 L
.06394 .36932 L
.06494 .39129 L
.06593 .41049 L
.06693 .42702 L
.06793 .44103 L
.06893 .45269 L
.06993 .46218 L
.07093 .46967 L
.07193 .47534 L
.07293 .47935 L
.07393 .48187 L
.07493 .48308 L
.07592 .48315 L
.07692 .48226 L
.07792 .48059 L
.07892 .47829 L
.07992 .47553 L
.08092 .47244 L
.08192 .46914 L
.08292 .46574 L
.08392 .46231 L
.08492 .45891 L
.08591 .45559 L
.08691 .45238 L
.08791 .44928 L
.08891 .4463 L
.08991 .44345 L
.09091 .44071 L
.09191 .43809 L
.09291 .43557 L
.09391 .43315 L
.09491 .43082 L
.0959 .42857 L
.0969 .4264 L
.0979 .42432 L
.0989 .42232 L
Mistroke
.0999 .40556 L
.1009 .40457 L
.1019 .4039 L
.1029 .40352 L
.1039 .40342 L
.1049 .40358 L
.10589 .40397 L
.10689 .40461 L
.10789 .40547 L
.10889 .40655 L
.10989 .40785 L
.11089 .40938 L
.11189 .41112 L
.11289 .4131 L
.11389 .41531 L
.11489 .41777 L
.11588 .42048 L
.11688 .42345 L
.11788 .4267 L
.11888 .43024 L
.11988 .43408 L
.12088 .43823 L
.12188 .4427 L
.12288 .4475 L
.12388 .45263 L
.12488 .45808 L
.12587 .46384 L
.12687 .4699 L
.12787 .47622 L
.12887 .48275 L
.12987 .48945 L
.13087 .49622 L
.13187 .50298 L
.13287 .50962 L
.13387 .51601 L
.13487 .52201 L
.13586 .52748 L
.13686 .53227 L
.13786 .53626 L
.13886 .53932 L
.13986 .54137 L
.14086 .54235 L
.14186 .54222 L
.14286 .54098 L
.14386 .53865 L
.14486 .53525 L
.14585 .53081 L
.14685 .52537 L
.14785 .51896 L
.14885 .51163 L
Mistroke
.14985 .56216 L
.15085 .5477 L
.15185 .53232 L
.15285 .51641 L
.15385 .50039 L
.15485 .48465 L
.15584 .46951 L
.15684 .45521 L
.15784 .44192 L
.15884 .42976 L
.15984 .41875 L
.16084 .40889 L
.16184 .40013 L
.16284 .39241 L
.16384 .38564 L
.16484 .37973 L
.16583 .37457 L
.16683 .37008 L
.16783 .36616 L
.16883 .36272 L
.16983 .35968 L
.17083 .35698 L
.17183 .35453 L
.17283 .3523 L
.17383 .35022 L
.17483 .34824 L
.17582 .34633 L
.17682 .34446 L
.17782 .34258 L
.17882 .34067 L
.17982 .33871 L
.18082 .33667 L
.18182 .33453 L
.18282 .33228 L
.18382 .3299 L
.18482 .32738 L
.18581 .32471 L
.18681 .32188 L
.18781 .31889 L
.18881 .31574 L
.18981 .31242 L
.19081 .30896 L
.19181 .30537 L
.19281 .30168 L
.19381 .29791 L
.19481 .29411 L
.1958 .29034 L
.1968 .28666 L
.1978 .28314 L
.1988 .27988 L
Mistroke
.1998 .28452 L
.2008 .27468 L
.2018 .26508 L
.2028 .25562 L
.2038 .24626 L
.2048 .23699 L
.20579 .22784 L
.20679 .21888 L
.20779 .21022 L
.20879 .20202 L
.20979 .19447 L
.21079 .18779 L
.21179 .18222 L
.21279 .17801 L
.21379 .17542 L
.21479 .17465 L
.21578 .17586 L
.21678 .17913 L
.21778 .18447 L
.21878 .19176 L
.21978 .20081 L
.22078 .21135 L
.22178 .22304 L
.22278 .23551 L
.22378 .2484 L
.22478 .26136 L
.22577 .27411 L
.22677 .28639 L
.22777 .29802 L
.22877 .30886 L
.22977 .31884 L
.23077 .32792 L
.23177 .3361 L
.23277 .34342 L
.23377 .34991 L
.23477 .35564 L
.23576 .36069 L
.23676 .36511 L
.23776 .36898 L
.23876 .37237 L
.23976 .37536 L
.24076 .37799 L
.24176 .38033 L
.24276 .38243 L
.24376 .38434 L
.24476 .3861 L
.24575 .38774 L
.24675 .3893 L
.24775 .3908 L
.24875 .39227 L
Mistroke
.24975 .45282 L
.25075 .45516 L
.25175 .45763 L
.25275 .46025 L
.25375 .463 L
.25475 .4659 L
.25574 .46892 L
.25674 .47207 L
.25774 .47533 L
.25874 .47869 L
.25974 .48211 L
.26074 .48558 L
.26174 .48906 L
.26274 .49252 L
.26374 .49591 L
.26474 .49919 L
.26573 .50229 L
.26673 .50518 L
.26773 .50778 L
.26873 .51005 L
.26973 .51192 L
.27073 .51334 L
.27173 .51427 L
.27273 .51465 L
.27373 .51447 L
.27473 .51371 L
.27572 .51235 L
.27672 .51042 L
.27772 .50795 L
.27872 .50496 L
.27972 .50151 L
.28072 .49766 L
.28172 .49349 L
.28272 .48907 L
.28372 .48447 L
.28472 .47976 L
.28571 .47503 L
.28671 .47033 L
.28771 .46572 L
.28871 .46127 L
.28971 .457 L
.29071 .45297 L
.29171 .44919 L
.29271 .4457 L
.29371 .4425 L
.29471 .4396 L
.2957 .43701 L
.2967 .43473 L
.2977 .43276 L
.2987 .43108 L
Mistroke
.2997 .42273 L
.3007 .4225 L
.3017 .42253 L
.3027 .42281 L
.3037 .42334 L
.3047 .42411 L
.30569 .42512 L
.30669 .42637 L
.30769 .42787 L
.30869 .42961 L
.30969 .43159 L
.31069 .43382 L
.31169 .43631 L
.31269 .43904 L
.31369 .44204 L
.31469 .4453 L
.31568 .44882 L
.31668 .4526 L
.31768 .45664 L
.31868 .46093 L
.31968 .46548 L
.32068 .47025 L
.32168 .47523 L
.32268 .48038 L
.32368 .48569 L
.32468 .49109 L
.32567 .49652 L
.32667 .50193 L
.32767 .50723 L
.32867 .51232 L
.32967 .51712 L
.33067 .52152 L
.33167 .5254 L
.33267 .52865 L
.33367 .53119 L
.33467 .5329 L
.33566 .53372 L
.33666 .53358 L
.33766 .53245 L
.33866 .53032 L
.33966 .5272 L
.34066 .52313 L
.34166 .51817 L
.34266 .51242 L
.34366 .50596 L
.34466 .49893 L
.34565 .49145 L
.34665 .48366 L
.34765 .47569 L
.34865 .46767 L
Mistroke
.34965 .51526 L
.35065 .50888 L
.35165 .50193 L
.35265 .49455 L
.35365 .48692 L
.35465 .47917 L
.35564 .47146 L
.35664 .46391 L
.35764 .45664 L
.35864 .44972 L
.35964 .44323 L
.36064 .43721 L
.36164 .43169 L
.36264 .42669 L
.36364 .42219 L
.36464 .4182 L
.36563 .41469 L
.36663 .41165 L
.36763 .40903 L
.36863 .40683 L
.36963 .40501 L
.37063 .40353 L
.37163 .40238 L
.37263 .40153 L
.37363 .40095 L
.37463 .40063 L
.37562 .40055 L
.37662 .40069 L
.37762 .40103 L
.37862 .40157 L
.37962 .40231 L
.38062 .40322 L
.38162 .40432 L
.38262 .40559 L
.38362 .40703 L
.38462 .40864 L
.38561 .41043 L
.38661 .41238 L
.38761 .41451 L
.38861 .4168 L
.38961 .41927 L
.39061 .42189 L
.39161 .42467 L
.39261 .4276 L
.39361 .43065 L
.39461 .43381 L
.3956 .43706 L
.3966 .44035 L
.3976 .44365 L
.3986 .44691 L
Mistroke
.3996 .32511 L
.4006 .32354 L
.4016 .32138 L
.4026 .31868 L
.4036 .31545 L
.4046 .31171 L
.40559 .30746 L
.40659 .30271 L
.40759 .29744 L
.40859 .29166 L
.40959 .28535 L
.41059 .27851 L
.41159 .27114 L
.41259 .26325 L
.41359 .25487 L
.41459 .24604 L
.41558 .23683 L
.41658 .22734 L
.41758 .2177 L
.41858 .20807 L
.41958 .19869 L
.42058 .18982 L
.42158 .18175 L
.42258 .17483 L
.42358 .16941 L
.42458 .16583 L
.42557 .16441 L
.42657 .1654 L
.42757 .16893 L
.42857 .17505 L
.42957 .18366 L
.43057 .19454 L
.43157 .20738 L
.43257 .22176 L
.43357 .23726 L
.43457 .25339 L
.43556 .26973 L
.43656 .28589 L
.43756 .30153 L
.43856 .3164 L
.43956 .33032 L
.44056 .34316 L
.44156 .35487 L
.44256 .36543 L
.44356 .37488 L
.44456 .38327 L
.44555 .39068 L
.44655 .39718 L
.44755 .40286 L
.44855 .40781 L
Mistroke
.44955 .40478 L
.45055 .41025 L
.45155 .41497 L
.45255 .41905 L
.45355 .42258 L
.45455 .42563 L
.45554 .42828 L
.45654 .4306 L
.45754 .43265 L
.45854 .43449 L
.45954 .43617 L
.46054 .43772 L
.46154 .43918 L
.46254 .4406 L
.46354 .44198 L
.46454 .44337 L
.46553 .44477 L
.46653 .44621 L
.46753 .44769 L
.46853 .44924 L
.46953 .45085 L
.47053 .45253 L
.47153 .45428 L
.47253 .45611 L
.47353 .45802 L
.47453 .45999 L
.47552 .46204 L
.47652 .46414 L
.47752 .46628 L
.47852 .46847 L
.47952 .47068 L
.48052 .47289 L
.48152 .4751 L
.48252 .47728 L
.48352 .47941 L
.48452 .48148 L
.48551 .48344 L
.48651 .4853 L
.48751 .48701 L
.48851 .48856 L
.48951 .48992 L
.49051 .49108 L
.49151 .49201 L
.49251 .4927 L
.49351 .49313 L
.49451 .49328 L
.4955 .49316 L
.4965 .49276 L
.4975 .49206 L
.4985 .49108 L
Mistroke
.4995 .54418 L
.5005 .53611 L
.5015 .52707 L
.5025 .51724 L
.5035 .50684 L
.5045 .49608 L
.50549 .48519 L
.50649 .47438 L
.50749 .46385 L
.50849 .45373 L
.50949 .44415 L
.51049 .4352 L
.51149 .42692 L
.51249 .41935 L
.51349 .41248 L
.51449 .4063 L
.51548 .40078 L
.51648 .39588 L
.51748 .39156 L
.51848 .38776 L
.51948 .38445 L
.52048 .38156 L
.52148 .37904 L
.52248 .37687 L
.52348 .37498 L
.52448 .37335 L
.52547 .37193 L
.52647 .37069 L
.52747 .36961 L
.52847 .36866 L
.52947 .36781 L
.53047 .36706 L
.53147 .36637 L
.53247 .36573 L
.53347 .36513 L
.53447 .36457 L
.53546 .36402 L
.53646 .36348 L
.53746 .36294 L
.53846 .3624 L
.53946 .36185 L
.54046 .36129 L
.54146 .36072 L
.54246 .36012 L
.54346 .35951 L
.54446 .35887 L
.54545 .35822 L
.54645 .35756 L
.54745 .35688 L
.54845 .35621 L
Mistroke
.54945 .41395 L
.55045 .42007 L
.55145 .42614 L
.55245 .43227 L
.55345 .43855 L
.55445 .44505 L
.55544 .45183 L
.55644 .45895 L
.55744 .46643 L
.55844 .47429 L
.55944 .48254 L
.56044 .49117 L
.56144 .50013 L
.56244 .50936 L
.56344 .51875 L
.56444 .52817 L
.56543 .53743 L
.56643 .54633 L
.56743 .55458 L
.56843 .5619 L
.56943 .56795 L
.57043 .5724 L
.57143 .57493 L
.57243 .57528 L
.57343 .57323 L
.57443 .5687 L
.57542 .5617 L
.57642 .55239 L
.57742 .54101 L
.57842 .52794 L
.57942 .51358 L
.58042 .49839 L
.58142 .4828 L
.58242 .46722 L
.58342 .45199 L
.58442 .43739 L
.58541 .42363 L
.58641 .41083 L
.58741 .39908 L
.58841 .3884 L
.58941 .37879 L
.59041 .37019 L
.59141 .36254 L
.59241 .35577 L
.59341 .3498 L
.59441 .34453 L
.5954 .33989 L
.5964 .3358 L
.5974 .33217 L
.5984 .32894 L
Mistroke
.5994 .33781 L
.6004 .33264 L
.6014 .32795 L
.6024 .32367 L
.6034 .31972 L
.6044 .31602 L
.60539 .31251 L
.60639 .30913 L
.60739 .30584 L
.60839 .30259 L
.60939 .29935 L
.61039 .29609 L
.61139 .29279 L
.61239 .28942 L
.61339 .28597 L
.61439 .28244 L
.61538 .27882 L
.61638 .27511 L
.61738 .27131 L
.61838 .26745 L
.61938 .26354 L
.62038 .2596 L
.62138 .25567 L
.62238 .25177 L
.62338 .24796 L
.62438 .24428 L
.62537 .24078 L
.62637 .23753 L
.62737 .23457 L
.62837 .23197 L
.62937 .22979 L
.63037 .22808 L
.63137 .2269 L
.63237 .22628 L
.63337 .22627 L
.63437 .22687 L
.63536 .2281 L
.63636 .22995 L
.63736 .23241 L
.63836 .23544 L
.63936 .23899 L
.64036 .24301 L
.64136 .24743 L
.64236 .2522 L
.64336 .25722 L
.64436 .26243 L
.64535 .26774 L
.64635 .27309 L
.64735 .27841 L
.64835 .28363 L
Mistroke
.64935 .32694 L
.65035 .32621 L
.65135 .32535 L
.65235 .32435 L
.65335 .3232 L
.65435 .3219 L
.65534 .32042 L
.65634 .31877 L
.65734 .31694 L
.65834 .31492 L
.65934 .31269 L
.66034 .31027 L
.66134 .30762 L
.66234 .30476 L
.66334 .30168 L
.66434 .29836 L
.66533 .2948 L
.66633 .29101 L
.66733 .28698 L
.66833 .28272 L
.66933 .27824 L
.67033 .27354 L
.67133 .26866 L
.67233 .26361 L
.67333 .25843 L
.67433 .25316 L
.67532 .24786 L
.67632 .24259 L
.67732 .23742 L
.67832 .23244 L
.67932 .22773 L
.68032 .2234 L
.68132 .21954 L
.68232 .21626 L
.68332 .21366 L
.68432 .21181 L
.68531 .21081 L
.68631 .21071 L
.68731 .21155 L
.68831 .21336 L
.68931 .21611 L
.69031 .2198 L
.69131 .22436 L
.69231 .22973 L
.69331 .23581 L
.69431 .24251 L
.6953 .2497 L
.6963 .25725 L
.6973 .26505 L
.6983 .27295 L
Mistroke
.6993 .29354 L
.7003 .30074 L
.7013 .30755 L
.7023 .31391 L
.7033 .31979 L
.7043 .32516 L
.70529 .33002 L
.70629 .33439 L
.70729 .33828 L
.70829 .34171 L
.70929 .34472 L
.71029 .34734 L
.71129 .34959 L
.71229 .35151 L
.71329 .35313 L
.71429 .35448 L
.71528 .35558 L
.71628 .35647 L
.71728 .35716 L
.71828 .35768 L
.71928 .35804 L
.72028 .35826 L
.72128 .35835 L
.72228 .35832 L
.72328 .35818 L
.72428 .35794 L
.72527 .3576 L
.72627 .35717 L
.72727 .35665 L
.72827 .35604 L
.72927 .35535 L
.73027 .35457 L
.73127 .3537 L
.73227 .35275 L
.73327 .3517 L
.73427 .35057 L
.73526 .34935 L
.73626 .34804 L
.73726 .34664 L
.73826 .34516 L
.73926 .34359 L
.74026 .34196 L
.74126 .34027 L
.74226 .33853 L
.74326 .33678 L
.74426 .33504 L
.74525 .33336 L
.74625 .33178 L
.74725 .33037 L
.74825 .32919 L
Mistroke
.74925 .26003 L
.75025 .24953 L
.75125 .23866 L
.75225 .22746 L
.75325 .21602 L
.75425 .20447 L
.75524 .19304 L
.75624 .18199 L
.75724 .17166 L
.75824 .16247 L
.75924 .15488 L
.76024 .14937 L
.76124 .14643 L
.76224 .14647 L
.76324 .14979 L
.76424 .15653 L
.76523 .16662 L
.76623 .17978 L
.76723 .19555 L
.76823 .21332 L
.76923 .23241 L
.77023 .25214 L
.77123 .27188 L
.77223 .29111 L
.77323 .30942 L
.77423 .32654 L
.77522 .3423 L
.77622 .35662 L
.77722 .36949 L
.77822 .38096 L
.77922 .39111 L
.78022 .40004 L
.78122 .40786 L
.78222 .41468 L
.78322 .42063 L
.78422 .4258 L
.78521 .43029 L
.78621 .43421 L
.78721 .43762 L
.78821 .44062 L
.78921 .44325 L
.79021 .44559 L
.79121 .44769 L
.79221 .44959 L
.79321 .45133 L
.79421 .45295 L
.7952 .45447 L
.7962 .45593 L
.7972 .45734 L
.7982 .45873 L
Mistroke
.7992 .47398 L
.8002 .47663 L
.8012 .47897 L
.8022 .48102 L
.8032 .48281 L
.8042 .48435 L
.80519 .48563 L
.80619 .48668 L
.80719 .48749 L
.80819 .48807 L
.80919 .48842 L
.81019 .48854 L
.81119 .48845 L
.81219 .48815 L
.81319 .48765 L
.81419 .48696 L
.81518 .48608 L
.81618 .48505 L
.81718 .48386 L
.81818 .48255 L
.81918 .48112 L
.82018 .4796 L
.82118 .47801 L
.82218 .47637 L
.82318 .4747 L
.82418 .47302 L
.82517 .47135 L
.82617 .46972 L
.82717 .46813 L
.82817 .4666 L
.82917 .46516 L
.83017 .4638 L
.83117 .46255 L
.83217 .46141 L
.83317 .46039 L
.83417 .4595 L
.83516 .45873 L
.83616 .45811 L
.83716 .45762 L
.83816 .45726 L
.83916 .45705 L
.84016 .45697 L
.84116 .45704 L
.84216 .45723 L
.84316 .45755 L
.84416 .45801 L
.84515 .45858 L
.84615 .45927 L
.84715 .46007 L
.84815 .46098 L
Mistroke
.84915 .51038 L
.85015 .51055 L
.85115 .51028 L
.85215 .50958 L
.85315 .50841 L
.85415 .50679 L
.85514 .50474 L
.85614 .50226 L
.85714 .49941 L
.85814 .49622 L
.85914 .49274 L
.86014 .48903 L
.86114 .48515 L
.86214 .48116 L
.86314 .47711 L
.86414 .47307 L
.86513 .46908 L
.86613 .46519 L
.86713 .46145 L
.86813 .4579 L
.86913 .45455 L
.87013 .45145 L
.87113 .44859 L
.87213 .44601 L
.87313 .4437 L
.87413 .44167 L
.87512 .43993 L
.87612 .43846 L
.87712 .43727 L
.87812 .43636 L
.87912 .43571 L
.88012 .43532 L
.88112 .43518 L
.88212 .43529 L
.88312 .43564 L
.88412 .43621 L
.88511 .43702 L
.88611 .43803 L
.88711 .43927 L
.88811 .4407 L
.88911 .44234 L
.89011 .44417 L
.89111 .44618 L
.89211 .44838 L
.89311 .45075 L
.89411 .45328 L
.8951 .45596 L
.8961 .45879 L
.8971 .46174 L
.8981 .4648 L
Mistroke
.8991 .45829 L
.9001 .4642 L
.9011 .47055 L
.9021 .47732 L
.9031 .4845 L
.9041 .49203 L
.90509 .49987 L
.90609 .50795 L
.90709 .51617 L
.90809 .52439 L
.90909 .53248 L
.91009 .54023 L
.91109 .54743 L
.91209 .55384 L
.91309 .55919 L
.91409 .56321 L
.91508 .56564 L
.91608 .56626 L
.91708 .5649 L
.91808 .56146 L
.91908 .55594 L
.92008 .54843 L
.92108 .53911 L
.92208 .52825 L
.92308 .5162 L
.92408 .5033 L
.92507 .48992 L
.92607 .47642 L
.92707 .46308 L
.92807 .45018 L
.92907 .43789 L
.93007 .42637 L
.93107 .4157 L
.93207 .40593 L
.93307 .39705 L
.93407 .38905 L
.93506 .38189 L
.93606 .37551 L
.93706 .36984 L
.93806 .36481 L
.93906 .36036 L
.94006 .35641 L
.94106 .35289 L
.94206 .34974 L
.94306 .34689 L
.94406 .34431 L
.94505 .34192 L
.94605 .3397 L
.94705 .3376 L
.94805 .33558 L
Mistroke
.94905 .32969 L
.95005 .32843 L
.95105 .32699 L
.95205 .32537 L
.95305 .32356 L
.95405 .32154 L
.95504 .31932 L
.95604 .31688 L
.95704 .31421 L
.95804 .3113 L
.95904 .30814 L
.96004 .30471 L
.96104 .30102 L
.96204 .29705 L
.96304 .29279 L
.96404 .28824 L
.96503 .2834 L
.96603 .27827 L
.96703 .27286 L
.96803 .26719 L
.96903 .26129 L
.97003 .25519 L
.97103 .24893 L
.97203 .24259 L
.97303 .23624 L
.97403 .22996 L
.97502 .22388 L
.97602 .21811 L
.97702 .21278 L
.97802 .20805 L
.97902 .20406 L
.98002 .20095 L
.98102 .19886 L
.98202 .19789 L
.98302 .19814 L
.98402 .19966 L
.98501 .20246 L
.98601 .20653 L
.98701 .2118 L
.98801 .21818 L
.98901 .22555 L
.99001 .23374 L
.99101 .24259 L
.99201 .25191 L
.99301 .26153 L
.99401 .27124 L
.995 .2809 L
.996 .29034 L
.997 .29945 L
.998 .30811 L
Mistroke
.999 .31365 L
Mfstroke
0 0 0 r
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .30608 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28377 L
.005 .27889 L
.00599 .27358 L
.00699 .26776 L
.00799 .26135 L
.00899 .25426 L
.00999 .24642 L
.01099 .2377 L
.01199 .22801 L
.01299 .21721 L
.01399 .20518 L
.01499 .19178 L
.01598 .17683 L
.01698 .16019 L
.01798 .14169 L
.01898 .12115 L
.01998 .09843 L
.02098 .07339 L
.02198 .04593 L
.02298 .01602 L
s
.02298 .01602 m
.02347 0 L
s
.03934 0 m
.03996 .04305 L
.04096 .10754 L
.04196 .16277 L
.04296 .20266 L
.04396 .21822 L
.04496 .19993 L
.04595 .1488 L
.04695 .08047 L
.04795 .01242 L
s
.04795 .01242 m
.04817 0 L
s
.04963 0 m
.04995 .0205 L
.05095 .04188 L
.05195 .07423 L
.05295 .11579 L
.05395 .16359 L
.05495 .21377 L
.05594 .26228 L
.05694 .30561 L
.05794 .3414 L
.05894 .36871 L
.05994 .38788 L
.06094 .40014 L
.06194 .4071 L
.06294 .41039 L
.06394 .41136 L
.06494 .41105 L
.06593 .41011 L
.06693 .40885 L
.06793 .40714 L
.06893 .40438 L
.06993 .39945 L
.07093 .39106 L
.07193 .37858 L
.07293 .36257 L
.07393 .34427 L
.07493 .32495 L
.07592 .30565 L
.07692 .28717 L
.07792 .27008 L
.07892 .25477 L
.07992 .24146 L
.08092 .23024 L
.08192 .22106 L
.08292 .21381 L
.08392 .20831 L
.08492 .20438 L
.08591 .20178 L
.08691 .20029 L
.08791 .19971 L
.08891 .19985 L
.08991 .20052 L
.09091 .20158 L
.09191 .20287 L
.09291 .2043 L
.09391 .20575 L
.09491 .20714 L
.0959 .20841 L
.0969 .20951 L
.0979 .21039 L
Mistroke
.0989 .21101 L
.0999 .32463 L
.1009 .32209 L
.1019 .32082 L
.1029 .3201 L
.1039 .31971 L
.1049 .31955 L
.10589 .31955 L
.10689 .31967 L
.10789 .3199 L
.10889 .32021 L
.10989 .32059 L
.11089 .32106 L
.11189 .3216 L
.11289 .32223 L
.11389 .32295 L
.11489 .32378 L
.11588 .32473 L
.11688 .32582 L
.11788 .32709 L
.11888 .32855 L
.11988 .33024 L
.12088 .33222 L
.12188 .33452 L
.12288 .33722 L
.12388 .34039 L
.12488 .3441 L
.12587 .34845 L
.12687 .35353 L
.12787 .35945 L
.12887 .36627 L
.12987 .37407 L
.13087 .38282 L
.13187 .39238 L
.13287 .40238 L
.13387 .41193 L
.13487 .41932 L
.13586 .42164 L
.13686 .41581 L
.13786 .40125 L
.13886 .38006 L
.13986 .35492 L
.14086 .3281 L
.14186 .30147 L
.14286 .27658 L
.14386 .25461 L
.14486 .23643 L
.14585 .22249 L
.14685 .21288 L
.14785 .20732 L
Mistroke
.14885 .20523 L
.14985 .35547 L
.15085 .33217 L
.15185 .31206 L
.15285 .2951 L
.15385 .28127 L
.15485 .2704 L
.15584 .26217 L
.15684 .25618 L
.15784 .252 L
.15884 .24921 L
.15984 .24744 L
.16084 .24637 L
.16184 .24572 L
.16284 .24529 L
.16384 .24491 L
.16484 .24444 L
.16583 .24378 L
.16683 .24288 L
.16783 .24166 L
.16883 .24009 L
.16983 .23814 L
.17083 .23579 L
.17183 .23302 L
.17283 .22981 L
.17383 .22616 L
.17483 .22206 L
.17582 .21748 L
.17682 .21242 L
.17782 .20687 L
.17882 .20081 L
.17982 .19424 L
.18082 .18715 L
.18182 .17953 L
.18282 .17139 L
.18382 .16274 L
.18482 .1536 L
.18581 .144 L
.18681 .134 L
.18781 .12366 L
.18881 .1131 L
.18981 .10244 L
.19081 .09185 L
.19181 .08153 L
.19281 .07173 L
.19381 .06272 L
.19481 .05484 L
.1958 .04841 L
.1968 .0438 L
.1978 .04135 L
Mistroke
.1988 .04133 L
.1998 .15645 L
.2008 .14597 L
.2018 .13604 L
.2028 .12625 L
.2038 .11667 L
.2048 .10757 L
.20579 .09929 L
.20679 .09223 L
.20779 .08682 L
.20879 .08346 L
.20979 .08252 L
.21079 .08422 L
.21179 .08863 L
.21279 .09562 L
.21379 .10496 L
.21479 .11635 L
.21578 .12949 L
.21678 .14408 L
.21778 .15976 L
.21878 .17609 L
.21978 .19258 L
.22078 .20867 L
.22178 .22384 L
.22278 .23765 L
.22378 .24978 L
.22478 .26003 L
.22577 .26839 L
.22677 .27491 L
.22777 .27978 L
.22877 .28318 L
.22977 .28537 L
.23077 .28654 L
.23177 .28689 L
.23277 .28659 L
.23377 .28577 L
.23477 .28454 L
.23576 .28298 L
.23676 .28115 L
.23776 .27909 L
.23876 .27684 L
.23976 .2744 L
.24076 .2718 L
.24176 .26902 L
.24276 .26608 L
.24376 .26295 L
.24476 .25962 L
.24575 .25609 L
.24675 .25232 L
.24775 .24829 L
Mistroke
.24875 .24399 L
.24975 .38863 L
.25075 .38758 L
.25175 .38779 L
.25275 .38858 L
.25375 .38972 L
.25475 .39108 L
.25574 .3926 L
.25674 .39422 L
.25774 .3959 L
.25874 .3976 L
.25974 .39927 L
.26074 .40086 L
.26174 .40233 L
.26274 .40362 L
.26374 .40465 L
.26474 .40535 L
.26573 .40562 L
.26673 .40536 L
.26773 .40444 L
.26873 .40276 L
.26973 .40019 L
.27073 .39665 L
.27173 .39211 L
.27273 .38659 L
.27373 .38018 L
.27473 .37305 L
.27572 .3654 L
.27672 .35747 L
.27772 .34949 L
.27872 .3417 L
.27972 .33428 L
.28072 .3274 L
.28172 .32115 L
.28272 .31562 L
.28372 .3108 L
.28472 .30671 L
.28571 .3033 L
.28671 .30051 L
.28771 .29829 L
.28871 .29655 L
.28971 .29523 L
.29071 .29427 L
.29171 .2936 L
.29271 .29317 L
.29371 .29292 L
.29471 .29283 L
.2957 .29284 L
.2967 .29294 L
.2977 .2931 L
Mistroke
.2987 .29329 L
.2997 .34437 L
.3007 .34209 L
.3017 .34114 L
.3027 .34085 L
.3037 .34099 L
.3047 .34145 L
.30569 .34218 L
.30669 .34313 L
.30769 .34429 L
.30869 .34564 L
.30969 .34719 L
.31069 .34892 L
.31169 .35086 L
.31269 .353 L
.31369 .35536 L
.31469 .35795 L
.31568 .3608 L
.31668 .36391 L
.31768 .36731 L
.31868 .37102 L
.31968 .37505 L
.32068 .37941 L
.32168 .3841 L
.32268 .38911 L
.32368 .39438 L
.32468 .39982 L
.32567 .40528 L
.32667 .41051 L
.32767 .4151 L
.32867 .41847 L
.32967 .41988 L
.33067 .41852 L
.33167 .41384 L
.33267 .40574 L
.33367 .39464 L
.33467 .38122 L
.33566 .36631 L
.33666 .35072 L
.33766 .33522 L
.33866 .32048 L
.33966 .30703 L
.34066 .29526 L
.34166 .28536 L
.34266 .27736 L
.34366 .27115 L
.34466 .26648 L
.34565 .26305 L
.34665 .26051 L
.34765 .25856 L
Mistroke
.34865 .25694 L
.34965 .37531 L
.35065 .36159 L
.35165 .34961 L
.35265 .33896 L
.35365 .32958 L
.35465 .32144 L
.35564 .3145 L
.35664 .30869 L
.35764 .30392 L
.35864 .30008 L
.35964 .29703 L
.36064 .29467 L
.36164 .29286 L
.36264 .29151 L
.36364 .2905 L
.36464 .28976 L
.36563 .2892 L
.36663 .28876 L
.36763 .28839 L
.36863 .28804 L
.36963 .28767 L
.37063 .28726 L
.37163 .28677 L
.37263 .2862 L
.37363 .28552 L
.37463 .28473 L
.37562 .28381 L
.37662 .28276 L
.37762 .28158 L
.37862 .28025 L
.37962 .27877 L
.38062 .27714 L
.38162 .27536 L
.38262 .27343 L
.38362 .27133 L
.38462 .26909 L
.38561 .26669 L
.38661 .26415 L
.38761 .26147 L
.38861 .25867 L
.38961 .25576 L
.39061 .25276 L
.39161 .24971 L
.39261 .24665 L
.39361 .24362 L
.39461 .24067 L
.3956 .23787 L
.3966 .23529 L
.3976 .233 L
Mistroke
.3986 .23107 L
.3996 .25266 L
.4006 .24285 L
.4016 .23386 L
.4026 .22489 L
.4036 .21565 L
.4046 .206 L
.40559 .19585 L
.40659 .18517 L
.40759 .17393 L
.40859 .16216 L
.40959 .14992 L
.41059 .13734 L
.41159 .12456 L
.41259 .11184 L
.41359 .09947 L
.41459 .08786 L
.41558 .07747 L
.41658 .06883 L
.41758 .06246 L
.41858 .05875 L
.41958 .05771 L
.42058 .05863 L
.42158 .05989 L
.42258 .06001 L
.42358 .0593 L
.42458 .05941 L
.42557 .06208 L
.42657 .06863 L
.42757 .07987 L
.42857 .09605 L
.42957 .11683 L
.43057 .1413 L
.43157 .16811 L
.43257 .19564 L
.43357 .22227 L
.43457 .24658 L
.43556 .26758 L
.43656 .28477 L
.43756 .29811 L
.43856 .30795 L
.43956 .31487 L
.44056 .31949 L
.44156 .3224 L
.44256 .32408 L
.44356 .3249 L
.44456 .32514 L
.44555 .32501 L
.44655 .32465 L
.44755 .32418 L
Mistroke
.44855 .32366 L
.44955 .37388 L
.45055 .36874 L
.45155 .3649 L
.45255 .36172 L
.45355 .35903 L
.45455 .35674 L
.45554 .35479 L
.45654 .35315 L
.45754 .35179 L
.45854 .35069 L
.45954 .34983 L
.46054 .34919 L
.46154 .34875 L
.46254 .34851 L
.46354 .34845 L
.46454 .34855 L
.46553 .34882 L
.46653 .34924 L
.46753 .34981 L
.46853 .35052 L
.46953 .35136 L
.47053 .35233 L
.47153 .35343 L
.47253 .35463 L
.47353 .35595 L
.47453 .35735 L
.47552 .35884 L
.47652 .36039 L
.47752 .36198 L
.47852 .36358 L
.47952 .36514 L
.48052 .36663 L
.48152 .36798 L
.48252 .36912 L
.48352 .36999 L
.48452 .37049 L
.48551 .37055 L
.48651 .37009 L
.48751 .36905 L
.48851 .36739 L
.48951 .36509 L
.49051 .36219 L
.49151 .35872 L
.49251 .35476 L
.49351 .35042 L
.49451 .34581 L
.4955 .34102 L
.4965 .33619 L
.4975 .3314 L
Mistroke
.4985 .32675 L
.4995 .38409 L
.5005 .36568 L
.5015 .34891 L
.5025 .33361 L
.5035 .31993 L
.5045 .30799 L
.50549 .29781 L
.50649 .28937 L
.50749 .28252 L
.50849 .27712 L
.50949 .27295 L
.51049 .26982 L
.51149 .26753 L
.51249 .26588 L
.51349 .26472 L
.51449 .26389 L
.51548 .26327 L
.51648 .26276 L
.51748 .26228 L
.51848 .26174 L
.51948 .26111 L
.52048 .26032 L
.52148 .25935 L
.52248 .25816 L
.52348 .25674 L
.52448 .25506 L
.52547 .2531 L
.52647 .25085 L
.52747 .2483 L
.52847 .24542 L
.52947 .2422 L
.53047 .23862 L
.53147 .23467 L
.53247 .23032 L
.53347 .22555 L
.53447 .22034 L
.53546 .21467 L
.53646 .20849 L
.53746 .20179 L
.53846 .19453 L
.53946 .18669 L
.54046 .17824 L
.54146 .16914 L
.54246 .15938 L
.54346 .14892 L
.54446 .13777 L
.54545 .12591 L
.54645 .11336 L
.54745 .10014 L
Mistroke
.54845 .0863 L
.54945 .38644 L
.55045 .38718 L
.55145 .38975 L
.55245 .39338 L
.55345 .39781 L
.55445 .40291 L
.55544 .40862 L
.55644 .4149 L
.55744 .4217 L
.55844 .42896 L
.55944 .43663 L
.56044 .44462 L
.56144 .45278 L
.56244 .46095 L
.56344 .46883 L
.56444 .47601 L
.56543 .48187 L
.56643 .48546 L
.56743 .4854 L
.56843 .48007 L
.56943 .46823 L
.57043 .44974 L
.57143 .42556 L
.57243 .39729 L
.57343 .36677 L
.57443 .33592 L
.57542 .3065 L
.57642 .27996 L
.57742 .25724 L
.57842 .23875 L
.57942 .22441 L
.58042 .21378 L
.58142 .20624 L
.58242 .20111 L
.58342 .19779 L
.58442 .19581 L
.58541 .19482 L
.58641 .19457 L
.58741 .19483 L
.58841 .19544 L
.58941 .19626 L
.59041 .19714 L
.59141 .19798 L
.59241 .19871 L
.59341 .19925 L
.59441 .19956 L
.5954 .19961 L
.5964 .1994 L
.5974 .19891 L
Mistroke
.5984 .19816 L
.5994 .23334 L
.6004 .22906 L
.6014 .22564 L
.6024 .2224 L
.6034 .21912 L
.6044 .21569 L
.60539 .21208 L
.60639 .20825 L
.60739 .20419 L
.60839 .19992 L
.60939 .19545 L
.61039 .19079 L
.61139 .18599 L
.61239 .18108 L
.61339 .17611 L
.61439 .17113 L
.61538 .1662 L
.61638 .1614 L
.61738 .1568 L
.61838 .15249 L
.61938 .14853 L
.62038 .145 L
.62138 .14195 L
.62238 .13942 L
.62338 .1374 L
.62438 .13585 L
.62537 .13467 L
.62637 .13375 L
.62737 .13297 L
.62837 .13223 L
.62937 .13153 L
.63037 .13095 L
.63137 .13062 L
.63237 .13074 L
.63337 .13149 L
.63437 .13304 L
.63536 .13551 L
.63636 .13896 L
.63736 .14341 L
.63836 .14878 L
.63936 .15497 L
.64036 .16179 L
.64136 .16905 L
.64236 .17651 L
.64336 .18394 L
.64436 .19113 L
.64535 .19787 L
.64635 .20403 L
.64735 .20949 L
Mistroke
.64835 .21419 L
.64935 .26041 L
.65035 .25483 L
.65135 .2502 L
.65235 .24584 L
.65335 .24152 L
.65435 .23714 L
.65534 .23262 L
.65634 .22791 L
.65734 .22298 L
.65834 .21782 L
.65934 .2124 L
.66034 .20672 L
.66134 .20078 L
.66234 .19459 L
.66334 .18817 L
.66434 .18154 L
.66533 .17476 L
.66633 .16787 L
.66733 .16094 L
.66833 .15408 L
.66933 .14737 L
.67033 .14096 L
.67133 .13497 L
.67233 .12956 L
.67333 .12487 L
.67433 .12103 L
.67532 .11813 L
.67632 .11616 L
.67732 .11499 L
.67832 .11427 L
.67932 .11349 L
.68032 .1121 L
.68132 .10975 L
.68232 .10654 L
.68332 .10297 L
.68432 .09966 L
.68531 .09726 L
.68631 .09633 L
.68731 .09733 L
.68831 .10055 L
.68931 .10616 L
.69031 .11412 L
.69131 .12425 L
.69231 .13619 L
.69331 .14944 L
.69431 .16343 L
.6953 .17754 L
.6963 .19118 L
.6973 .20382 L
Mistroke
.6983 .21509 L
.6993 .29505 L
.7003 .29404 L
.7013 .29342 L
.7023 .29268 L
.7033 .29171 L
.7043 .29053 L
.70529 .28915 L
.70629 .2876 L
.70729 .28591 L
.70829 .2841 L
.70929 .28218 L
.71029 .28017 L
.71129 .27806 L
.71229 .27585 L
.71329 .27353 L
.71429 .2711 L
.71528 .26854 L
.71628 .26583 L
.71728 .26296 L
.71828 .2599 L
.71928 .25664 L
.72028 .25315 L
.72128 .2494 L
.72228 .24537 L
.72328 .24104 L
.72428 .23637 L
.72527 .23133 L
.72627 .22589 L
.72727 .22001 L
.72827 .21368 L
.72927 .20684 L
.73027 .19946 L
.73127 .19152 L
.73227 .18297 L
.73327 .17379 L
.73427 .16395 L
.73526 .15343 L
.73626 .14221 L
.73726 .1303 L
.73826 .1177 L
.73926 .10446 L
.74026 .09063 L
.74126 .0763 L
.74226 .0616 L
.74326 .04669 L
.74426 .03179 L
.74525 .01719 L
.74625 .0032 L
Mfstroke
.74625 .0032 m
.7465 0 L
s
.74839 0 m
.74925 .12754 L
.75025 .11179 L
.75125 .0971 L
.75225 .08323 L
.75325 .07057 L
.75425 .05971 L
.75524 .05141 L
.75624 .04643 L
.75724 .04549 L
.75824 .04911 L
.75924 .0575 L
.76024 .07056 L
.76124 .08797 L
.76224 .10931 L
.76324 .134 L
.76424 .16125 L
.76523 .18997 L
.76623 .21885 L
.76723 .24654 L
.76823 .27185 L
.76923 .29385 L
.77023 .31207 L
.77123 .3264 L
.77223 .33711 L
.77323 .34465 L
.77423 .3496 L
.77522 .35253 L
.77622 .35397 L
.77722 .35435 L
.77822 .35402 L
.77922 .35325 L
.78022 .35225 L
.78122 .35116 L
.78222 .3501 L
.78322 .34913 L
.78422 .3483 L
.78521 .34765 L
.78621 .34718 L
.78721 .3469 L
.78821 .34679 L
.78921 .34684 L
.79021 .34702 L
.79121 .34731 L
.79221 .34769 L
.79321 .34811 L
.79421 .34855 L
.7952 .34899 L
.7962 .34939 L
.7972 .34973 L
Mistroke
.7982 .34999 L
.7992 .41 L
.8002 .40578 L
.8012 .40263 L
.8022 .39986 L
.8032 .39727 L
.8042 .39475 L
.80519 .39224 L
.80619 .3897 L
.80719 .38713 L
.80819 .38451 L
.80919 .38183 L
.81019 .37909 L
.81119 .37631 L
.81219 .37348 L
.81319 .37062 L
.81419 .36773 L
.81518 .36484 L
.81618 .36196 L
.81718 .3591 L
.81818 .35629 L
.81918 .35355 L
.82018 .3509 L
.82118 .34836 L
.82218 .34596 L
.82318 .3437 L
.82418 .3416 L
.82517 .33967 L
.82617 .33793 L
.82717 .33638 L
.82817 .33502 L
.82917 .33385 L
.83017 .33286 L
.83117 .33206 L
.83217 .33143 L
.83317 .33098 L
.83417 .33069 L
.83516 .33055 L
.83616 .33055 L
.83716 .3307 L
.83816 .33097 L
.83916 .33137 L
.84016 .33188 L
.84116 .3325 L
.84216 .33322 L
.84316 .33403 L
.84416 .33494 L
.84515 .33593 L
.84615 .33699 L
.84715 .33811 L
Mistroke
.84815 .33928 L
.84915 .42041 L
.85015 .41312 L
.85115 .40644 L
.85215 .39981 L
.85315 .39313 L
.85415 .38641 L
.85514 .37969 L
.85614 .37305 L
.85714 .36656 L
.85814 .36031 L
.85914 .35437 L
.86014 .34879 L
.86114 .34363 L
.86214 .33892 L
.86314 .33468 L
.86414 .33091 L
.86513 .32763 L
.86613 .3248 L
.86713 .32241 L
.86813 .32043 L
.86913 .31884 L
.87013 .31758 L
.87113 .31663 L
.87213 .31596 L
.87313 .31554 L
.87413 .31532 L
.87512 .31529 L
.87612 .31542 L
.87712 .31569 L
.87812 .31609 L
.87912 .3166 L
.88012 .31722 L
.88112 .31794 L
.88212 .31875 L
.88312 .31966 L
.88412 .32067 L
.88511 .3218 L
.88611 .32304 L
.88711 .32441 L
.88811 .32592 L
.88911 .32759 L
.89011 .32943 L
.89111 .33147 L
.89211 .33372 L
.89311 .3362 L
.89411 .33893 L
.8951 .34192 L
.8961 .34517 L
.8971 .34869 L
Mistroke
.8981 .35245 L
.8991 .42268 L
.9001 .42707 L
.9011 .4328 L
.9021 .43909 L
.9031 .44562 L
.9041 .45219 L
.90509 .45862 L
.90609 .46468 L
.90709 .47013 L
.90809 .47465 L
.90909 .47786 L
.91009 .4793 L
.91109 .47842 L
.91209 .47457 L
.91309 .46712 L
.91409 .4556 L
.91508 .4399 L
.91608 .42043 L
.91708 .39801 L
.91808 .3738 L
.91908 .34907 L
.92008 .32506 L
.92108 .30281 L
.92208 .28307 L
.92308 .26628 L
.92408 .25255 L
.92507 .24175 L
.92607 .23359 L
.92707 .22767 L
.92807 .22359 L
.92907 .22095 L
.93007 .21941 L
.93107 .21864 L
.93207 .21841 L
.93307 .21848 L
.93407 .21869 L
.93506 .21889 L
.93606 .21898 L
.93706 .21886 L
.93806 .21848 L
.93906 .21779 L
.94006 .21675 L
.94106 .21536 L
.94206 .21359 L
.94306 .21144 L
.94406 .20891 L
.94505 .20601 L
.94605 .20274 L
.94705 .1991 L
Mistroke
.94805 .19512 L
.94905 .25855 L
.95005 .25212 L
.95105 .24664 L
.95205 .24137 L
.95305 .23607 L
.95405 .23063 L
.95504 .22496 L
.95604 .21902 L
.95704 .21278 L
.95804 .20621 L
.95904 .19932 L
.96004 .1921 L
.96104 .18457 L
.96204 .17676 L
.96304 .16872 L
.96404 .16053 L
.96503 .15226 L
.96603 .14405 L
.96703 .13602 L
.96803 .12837 L
.96903 .12128 L
.97003 .11496 L
.97103 .10964 L
.97203 .10551 L
.97303 .10267 L
.97403 .10108 L
.97502 .10044 L
.97602 .10011 L
.97702 .09926 L
.97802 .09726 L
.97902 .0942 L
.98002 .09079 L
.98102 .08793 L
.98202 .08649 L
.98302 .08716 L
.98402 .09047 L
.98501 .09671 L
.98601 .10592 L
.98701 .11793 L
.98801 .1323 L
.98901 .14838 L
.99001 .16542 L
.99101 .18258 L
.99201 .19908 L
.99301 .21424 L
.99401 .22755 L
.995 .23876 L
.996 .24779 L
.997 .25478 L
Mistroke
.998 .25996 L
.999 .30608 L
Mfstroke
gsave
.999 .31867 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32502 L
.005 .328 L
.00599 .33137 L
.00699 .33514 L
.00799 .33934 L
.00899 .34402 L
.00999 .34924 L
.01099 .35504 L
.01199 .3615 L
.01299 .36869 L
.01399 .37672 L
.01499 .38567 L
.01598 .39566 L
.01698 .40681 L
.01798 .41925 L
.01898 .4331 L
.01998 .44852 L
.02098 .46565 L
.02198 .48462 L
.02298 .50556 L
.02398 .52857 L
.02498 .5537 L
.02597 .58095 L
.02697 .61021 L
s
.02697 .61021 m
.02722 .61803 L
s
.04898 .61803 m
.04995 .03326 L
.05095 .06428 L
.05195 .10621 L
.05295 .15819 L
.05395 .21764 L
.05495 .28052 L
.05594 .34201 L
.05694 .39762 L
.05794 .44412 L
.05894 .48006 L
.05994 .50562 L
.06094 .52208 L
.06194 .53115 L
.06294 .53453 L
.06394 .53361 L
.06494 .52944 L
.06593 .52276 L
.06693 .51418 L
.06793 .50438 L
.06893 .4943 L
.06993 .48533 L
.07093 .479 L
.07193 .4762 L
.07293 .47666 L
.07393 .47946 L
.07493 .48367 L
.07592 .48855 L
.07692 .49357 L
.07792 .49833 L
.07892 .50256 L
.07992 .50607 L
.08092 .50876 L
.08192 .51054 L
.08292 .51142 L
.08392 .5114 L
.08492 .51055 L
.08591 .50892 L
.08691 .5066 L
.08791 .50369 L
.08891 .50029 L
.08991 .49652 L
.09091 .49248 L
.09191 .4883 L
.09291 .48408 L
.09391 .47992 L
.09491 .47592 L
.0959 .47217 L
.0969 .46872 L
.0979 .46566 L
Mistroke
.0989 .46301 L
.0999 .33713 L
.1009 .34253 L
.1019 .34689 L
.1029 .3509 L
.1039 .35481 L
.1049 .35873 L
.10589 .36275 L
.10689 .36694 L
.10789 .37134 L
.10889 .37599 L
.10989 .38094 L
.11089 .38622 L
.11189 .39187 L
.11289 .39791 L
.11389 .40437 L
.11489 .41127 L
.11588 .41863 L
.11688 .42645 L
.11788 .43474 L
.11888 .44348 L
.11988 .45264 L
.12088 .46216 L
.12188 .47197 L
.12288 .48196 L
.12388 .49199 L
.12488 .50185 L
.12587 .51131 L
.12687 .52009 L
.12787 .52783 L
.12887 .53418 L
.12987 .53874 L
.13087 .54115 L
.13187 .54115 L
.13287 .53873 L
.13387 .53438 L
.13487 .5295 L
.13586 .52679 L
.13686 .52921 L
.13786 .53738 L
.13886 .54934 L
.13986 .56269 L
.14086 .57544 L
.14186 .58605 L
.14286 .59324 L
.14386 .59599 L
.14486 .59359 L
.14585 .58565 L
.14685 .57219 L
.14785 .55367 L
Mistroke
.14885 .531 L
.14985 .36813 L
.15085 .35339 L
.15185 .33999 L
.15285 .32872 L
.15385 .31977 L
.15485 .31308 L
.15584 .30841 L
.15684 .30548 L
.15784 .30395 L
.15884 .30352 L
.15984 .3039 L
.16084 .30487 L
.16184 .30625 L
.16284 .30788 L
.16384 .30967 L
.16484 .31154 L
.16583 .31344 L
.16683 .31534 L
.16783 .31722 L
.16883 .31907 L
.16983 .32089 L
.17083 .32269 L
.17183 .32449 L
.17283 .32628 L
.17383 .32809 L
.17483 .32994 L
.17582 .33182 L
.17682 .33376 L
.17782 .33577 L
.17882 .33787 L
.17982 .34006 L
.18082 .34234 L
.18182 .34474 L
.18282 .34724 L
.18382 .34986 L
.18482 .35258 L
.18581 .3554 L
.18681 .3583 L
.18781 .36126 L
.18881 .36424 L
.18981 .36721 L
.19081 .37011 L
.19181 .37289 L
.19281 .37547 L
.19381 .37776 L
.19481 .37969 L
.1958 .38115 L
.1968 .38206 L
.1978 .38236 L
Mistroke
.1988 .382 L
.1998 .16904 L
.2008 .1666 L
.2018 .16266 L
.2028 .1581 L
.2038 .15336 L
.2048 .14877 L
.20579 .14464 L
.20679 .14132 L
.20779 .13916 L
.20879 .13856 L
.20979 .13997 L
.21079 .14388 L
.21179 .15074 L
.21279 .16097 L
.21379 .17476 L
.21479 .19196 L
.21578 .21203 L
.21678 .23406 L
.21778 .25694 L
.21878 .27949 L
.21978 .3007 L
.22078 .31977 L
.22178 .33619 L
.22278 .34978 L
.22378 .36058 L
.22478 .36883 L
.22577 .37487 L
.22677 .3791 L
.22777 .38188 L
.22877 .38358 L
.22977 .3845 L
.23077 .38492 L
.23177 .38505 L
.23277 .38509 L
.23377 .38517 L
.23477 .38542 L
.23576 .38592 L
.23676 .38675 L
.23776 .38795 L
.23876 .38956 L
.23976 .3916 L
.24076 .3941 L
.24176 .39707 L
.24276 .40052 L
.24376 .40447 L
.24476 .40892 L
.24575 .41388 L
.24675 .41937 L
.24775 .4254 L
Mistroke
.24875 .43197 L
.24975 .40105 L
.25075 .40804 L
.25175 .41404 L
.25275 .41972 L
.25375 .42526 L
.25475 .43072 L
.25574 .43611 L
.25674 .4414 L
.25774 .44656 L
.25874 .45153 L
.25974 .45625 L
.26074 .46063 L
.26174 .4646 L
.26274 .46808 L
.26374 .471 L
.26474 .47328 L
.26573 .47489 L
.26673 .4758 L
.26773 .47602 L
.26873 .4756 L
.26973 .47459 L
.27073 .47307 L
.27173 .47113 L
.27273 .46882 L
.27373 .4662 L
.27473 .46327 L
.27572 .46004 L
.27672 .45651 L
.27772 .45269 L
.27872 .4486 L
.27972 .44429 L
.28072 .43982 L
.28172 .43526 L
.28272 .4307 L
.28372 .42624 L
.28472 .42196 L
.28571 .41795 L
.28671 .41427 L
.28771 .41099 L
.28871 .40813 L
.28971 .40574 L
.29071 .40381 L
.29171 .40236 L
.29271 .40137 L
.29371 .40082 L
.29471 .4007 L
.2957 .40098 L
.2967 .40166 L
.2977 .4027 L
Mistroke
.2987 .40409 L
.2997 .35684 L
.3007 .3625 L
.3017 .36719 L
.3027 .37161 L
.3037 .37598 L
.3047 .3804 L
.30569 .38496 L
.30669 .38971 L
.30769 .39466 L
.30869 .39986 L
.30969 .40532 L
.31069 .41104 L
.31169 .41704 L
.31269 .42331 L
.31369 .42982 L
.31469 .43656 L
.31568 .44349 L
.31668 .45055 L
.31768 .45767 L
.31868 .46477 L
.31968 .47174 L
.32068 .47844 L
.32168 .48474 L
.32268 .49048 L
.32368 .49549 L
.32468 .49965 L
.32567 .50284 L
.32667 .50504 L
.32767 .50636 L
.32867 .5071 L
.32967 .50775 L
.33067 .50887 L
.33167 .51084 L
.33267 .51366 L
.33367 .51688 L
.33467 .51988 L
.33566 .522 L
.33666 .52265 L
.33766 .52136 L
.33866 .51783 L
.33966 .51192 L
.34066 .50366 L
.34166 .49329 L
.34266 .48119 L
.34366 .4679 L
.34466 .454 L
.34565 .44014 L
.34665 .42689 L
.34765 .41477 L
Mistroke
.34865 .40411 L
.34965 .38791 L
.35065 .3823 L
.35165 .37632 L
.35265 .37069 L
.35365 .36567 L
.35465 .36138 L
.35564 .35787 L
.35664 .35513 L
.35764 .35311 L
.35864 .35177 L
.35964 .35104 L
.36064 .35085 L
.36164 .35113 L
.36264 .35182 L
.36364 .35287 L
.36464 .35424 L
.36563 .3559 L
.36663 .35781 L
.36763 .35996 L
.36863 .36234 L
.36963 .36495 L
.37063 .36779 L
.37163 .37086 L
.37263 .37417 L
.37363 .37773 L
.37463 .38157 L
.37562 .38569 L
.37662 .39011 L
.37762 .39486 L
.37862 .39996 L
.37962 .40541 L
.38062 .41125 L
.38162 .41749 L
.38262 .42414 L
.38362 .43122 L
.38462 .43873 L
.38561 .44668 L
.38661 .45504 L
.38761 .46381 L
.38861 .47294 L
.38961 .4824 L
.39061 .4921 L
.39161 .50195 L
.39261 .51183 L
.39361 .5216 L
.39461 .53105 L
.3956 .53998 L
.3966 .54814 L
.3976 .55525 L
Mistroke
.3986 .56101 L
.3996 .26518 L
.4006 .2634 L
.4016 .26038 L
.4026 .2568 L
.4036 .25282 L
.4046 .24848 L
.40559 .24378 L
.40659 .2387 L
.40759 .23321 L
.40859 .22727 L
.40959 .22085 L
.41059 .21393 L
.41159 .20649 L
.41259 .19852 L
.41359 .19003 L
.41459 .18107 L
.41558 .17172 L
.41658 .16217 L
.41758 .15274 L
.41858 .144 L
.41958 .13699 L
.42058 .13351 L
.42158 .13618 L
.42258 .14727 L
.42358 .16699 L
.42458 .19373 L
.42557 .22529 L
.42657 .25933 L
.42757 .29353 L
.42857 .32577 L
.42957 .35435 L
.43057 .37819 L
.43157 .39688 L
.43257 .41063 L
.43357 .42013 L
.43457 .42629 L
.43556 .43007 L
.43656 .43226 L
.43756 .43342 L
.43856 .43389 L
.43956 .43384 L
.44056 .43335 L
.44156 .4325 L
.44256 .43135 L
.44356 .43001 L
.44456 .42856 L
.44555 .42709 L
.44655 .42568 L
.44755 .42439 L
Mistroke
.44855 .42325 L
.44955 .38638 L
.45055 .3891 L
.45155 .39076 L
.45255 .39205 L
.45355 .3932 L
.45455 .39435 L
.45554 .39555 L
.45654 .39685 L
.45754 .39828 L
.45854 .39985 L
.45954 .40157 L
.46054 .40345 L
.46154 .40549 L
.46254 .40769 L
.46354 .41002 L
.46454 .4125 L
.46553 .4151 L
.46653 .41782 L
.46753 .42064 L
.46853 .42353 L
.46953 .42649 L
.47053 .42949 L
.47153 .4325 L
.47253 .43551 L
.47353 .43848 L
.47453 .4414 L
.47552 .44422 L
.47652 .44693 L
.47752 .44951 L
.47852 .45192 L
.47952 .45417 L
.48052 .45624 L
.48152 .45814 L
.48252 .45987 L
.48352 .46146 L
.48452 .46294 L
.48551 .46434 L
.48651 .4657 L
.48751 .46705 L
.48851 .46839 L
.48951 .46973 L
.49051 .47102 L
.49151 .47221 L
.49251 .47325 L
.49351 .47406 L
.49451 .47455 L
.4955 .47466 L
.4965 .47431 L
.4975 .47347 L
Mistroke
.4985 .47211 L
.4995 .39667 L
.5005 .38642 L
.5015 .37571 L
.5025 .3655 L
.5035 .35625 L
.5045 .3482 L
.50549 .34145 L
.50649 .33601 L
.50749 .33181 L
.50849 .32874 L
.50949 .32666 L
.51049 .32543 L
.51149 .3249 L
.51249 .32495 L
.51349 .32546 L
.51449 .32634 L
.51548 .3275 L
.51648 .32888 L
.51748 .33044 L
.51848 .33215 L
.51948 .33398 L
.52048 .33592 L
.52148 .33796 L
.52248 .3401 L
.52348 .34236 L
.52448 .34472 L
.52547 .34722 L
.52647 .34986 L
.52747 .35266 L
.52847 .35564 L
.52947 .35883 L
.53047 .36224 L
.53147 .36589 L
.53247 .36983 L
.53347 .37406 L
.53447 .37863 L
.53546 .38356 L
.53646 .38889 L
.53746 .39466 L
.53846 .40088 L
.53946 .40762 L
.54046 .41489 L
.54146 .42275 L
.54246 .43123 L
.54346 .44037 L
.54446 .4502 L
.54545 .46077 L
.54645 .47209 L
.54745 .48419 L
Mistroke
.54845 .49707 L
.54945 .39891 L
.55045 .40771 L
.55145 .41621 L
.55245 .42513 L
.55345 .43464 L
.55445 .44478 L
.55544 .45554 L
.55644 .46683 L
.55744 .47852 L
.55844 .49045 L
.55944 .50238 L
.56044 .514 L
.56144 .52494 L
.56244 .53477 L
.56344 .54303 L
.56444 .54925 L
.56543 .55309 L
.56643 .55448 L
.56743 .55378 L
.56843 .55171 L
.56943 .54884 L
.57043 .54499 L
.57143 .53935 L
.57243 .53102 L
.57343 .51937 L
.57443 .50417 L
.57542 .48561 L
.57642 .46432 L
.57742 .44128 L
.57842 .41766 L
.57942 .39469 L
.58042 .37348 L
.58142 .35482 L
.58242 .3392 L
.58342 .32671 L
.58442 .31719 L
.58541 .31025 L
.58641 .30545 L
.58741 .30231 L
.58841 .30045 L
.58941 .29951 L
.59041 .29923 L
.59141 .2994 L
.59241 .29988 L
.59341 .30054 L
.59441 .30129 L
.5954 .30208 L
.5964 .30284 L
.5974 .30354 L
Mistroke
.5984 .30415 L
.5994 .24578 L
.6004 .2494 L
.6014 .25154 L
.6024 .25289 L
.6034 .25367 L
.6044 .25399 L
.60539 .25392 L
.60639 .25351 L
.60739 .25279 L
.60839 .25179 L
.60939 .25052 L
.61039 .24902 L
.61139 .24728 L
.61239 .24532 L
.61339 .24315 L
.61439 .24078 L
.61538 .23823 L
.61638 .23552 L
.61738 .23267 L
.61838 .22972 L
.61938 .22671 L
.62038 .22373 L
.62138 .22085 L
.62238 .21821 L
.62338 .21597 L
.62438 .21433 L
.62537 .21354 L
.62637 .21385 L
.62737 .21549 L
.62837 .21865 L
.62937 .22337 L
.63037 .22959 L
.63137 .23711 L
.63237 .24566 L
.63337 .25493 L
.63437 .26457 L
.63536 .27426 L
.63636 .28369 L
.63736 .29262 L
.63836 .30086 L
.63936 .30828 L
.64036 .31481 L
.64136 .32045 L
.64236 .32523 L
.64336 .32924 L
.64436 .33256 L
.64535 .33531 L
.64635 .33758 L
.64735 .33947 L
Mistroke
.64835 .34105 L
.64935 .27299 L
.65035 .27527 L
.65135 .27623 L
.65235 .27653 L
.65335 .27641 L
.65435 .27596 L
.65534 .27525 L
.65634 .2743 L
.65734 .27314 L
.65834 .27178 L
.65934 .27023 L
.66034 .26847 L
.66134 .26651 L
.66234 .26433 L
.66334 .26193 L
.66434 .25929 L
.66533 .25638 L
.66633 .25321 L
.66733 .24973 L
.66833 .24595 L
.66933 .24184 L
.67033 .2374 L
.67133 .23262 L
.67233 .22754 L
.67333 .2222 L
.67433 .2167 L
.67532 .21121 L
.67632 .20598 L
.67732 .20145 L
.67832 .1982 L
.67932 .19702 L
.68032 .19869 L
.68132 .20371 L
.68232 .2121 L
.68332 .2234 L
.68432 .23693 L
.68531 .25192 L
.68631 .26759 L
.68731 .28322 L
.68831 .29817 L
.68931 .31191 L
.69031 .32405 L
.69131 .33439 L
.69231 .34285 L
.69331 .34953 L
.69431 .35463 L
.6953 .35844 L
.6963 .36128 L
.6973 .36347 L
Mistroke
.6983 .36526 L
.6993 .30766 L
.7003 .31451 L
.7013 .31943 L
.7023 .32315 L
.7033 .326 L
.7043 .32819 L
.70529 .32986 L
.70629 .33115 L
.70729 .33216 L
.70829 .33299 L
.70929 .33369 L
.71029 .33434 L
.71129 .33498 L
.71229 .33566 L
.71329 .3364 L
.71429 .33724 L
.71528 .3382 L
.71628 .33929 L
.71728 .34054 L
.71828 .34196 L
.71928 .34357 L
.72028 .34537 L
.72128 .34738 L
.72228 .34962 L
.72328 .3521 L
.72428 .35484 L
.72527 .35785 L
.72627 .36115 L
.72727 .36477 L
.72827 .36872 L
.72927 .37303 L
.73027 .37773 L
.73127 .38284 L
.73227 .38839 L
.73327 .39441 L
.73427 .40094 L
.73526 .40801 L
.73626 .41564 L
.73726 .42387 L
.73826 .43272 L
.73926 .44223 L
.74026 .4524 L
.74126 .46325 L
.74226 .47478 L
.74326 .48698 L
.74426 .49981 L
.74525 .51324 L
.74625 .5272 L
.74725 .54161 L
Mistroke
.74825 .55634 L
.74925 .14008 L
.75025 .13242 L
.75125 .12372 L
.75225 .11504 L
.75325 .10702 L
.75425 .10028 L
.75524 .09551 L
.75624 .09347 L
.75724 .09507 L
.75824 .10129 L
.75924 .1131 L
.76024 .13124 L
.76124 .15589 L
.76224 .18636 L
.76324 .22113 L
.76424 .25805 L
.76523 .2948 L
.76623 .3292 L
.76723 .3596 L
.76823 .38501 L
.76923 .40515 L
.77023 .42027 L
.77123 .431 L
.77223 .43811 L
.77323 .44239 L
.77423 .44455 L
.77522 .4452 L
.77622 .44482 L
.77722 .44377 L
.77822 .44235 L
.77922 .44073 L
.78022 .43906 L
.78122 .43743 L
.78222 .4359 L
.78322 .43449 L
.78422 .43323 L
.78521 .43214 L
.78621 .43121 L
.78721 .43046 L
.78821 .42989 L
.78921 .42952 L
.79021 .42934 L
.79121 .42937 L
.79221 .42964 L
.79321 .43014 L
.79421 .43089 L
.7952 .43191 L
.7962 .43321 L
.7972 .43479 L
Mistroke
.7982 .43665 L
.7992 .42247 L
.8002 .42623 L
.8012 .42875 L
.8022 .43066 L
.8032 .43213 L
.8042 .43324 L
.80519 .43403 L
.80619 .43451 L
.80719 .43471 L
.80819 .43463 L
.80919 .43431 L
.81019 .43375 L
.81119 .433 L
.81219 .43207 L
.81319 .43102 L
.81419 .42986 L
.81518 .42865 L
.81618 .42741 L
.81718 .42617 L
.81818 .42498 L
.81918 .42386 L
.82018 .42282 L
.82118 .42189 L
.82218 .42109 L
.82318 .42042 L
.82418 .4199 L
.82517 .41952 L
.82617 .41929 L
.82717 .41922 L
.82817 .41929 L
.82917 .41952 L
.83017 .41989 L
.83117 .4204 L
.83217 .42105 L
.83317 .42184 L
.83417 .42276 L
.83516 .4238 L
.83616 .42495 L
.83716 .42622 L
.83816 .42759 L
.83916 .42906 L
.84016 .43062 L
.84116 .43225 L
.84216 .43396 L
.84316 .43573 L
.84416 .43755 L
.84515 .43941 L
.84615 .44131 L
.84715 .44324 L
Mistroke
.84815 .44519 L
.84915 .43291 L
.85015 .43362 L
.85115 .43271 L
.85215 .43086 L
.85315 .42835 L
.85415 .42534 L
.85514 .42197 L
.85614 .41839 L
.85714 .41471 L
.85814 .41103 L
.85914 .40745 L
.86014 .40407 L
.86114 .40093 L
.86214 .39811 L
.86314 .39564 L
.86414 .39354 L
.86513 .39183 L
.86613 .3905 L
.86713 .38957 L
.86813 .38901 L
.86913 .38881 L
.87013 .38895 L
.87113 .38943 L
.87213 .39021 L
.87313 .39129 L
.87413 .39265 L
.87512 .39427 L
.87612 .39614 L
.87712 .39825 L
.87812 .4006 L
.87912 .40317 L
.88012 .40595 L
.88112 .40894 L
.88212 .41213 L
.88312 .4155 L
.88412 .41905 L
.88511 .42276 L
.88611 .42661 L
.88711 .43059 L
.88811 .43468 L
.88911 .43884 L
.89011 .44304 L
.89111 .44725 L
.89211 .45141 L
.89311 .4555 L
.89411 .45944 L
.8951 .46319 L
.8961 .46669 L
.8971 .4699 L
Mistroke
.8981 .47275 L
.8991 .43515 L
.9001 .44759 L
.9011 .4592 L
.9021 .47057 L
.9031 .48176 L
.9041 .49267 L
.90509 .50307 L
.90609 .51268 L
.90709 .52115 L
.90809 .52808 L
.90909 .53311 L
.91009 .53589 L
.91109 .53619 L
.91209 .53395 L
.91309 .52926 L
.91409 .52234 L
.91508 .51334 L
.91608 .50238 L
.91708 .4895 L
.91808 .47483 L
.91908 .45864 L
.92008 .44137 L
.92108 .42359 L
.92208 .40594 L
.92308 .38908 L
.92408 .37356 L
.92507 .35981 L
.92607 .34806 L
.92707 .33841 L
.92807 .33077 L
.92907 .32498 L
.93007 .32079 L
.93107 .31795 L
.93207 .31619 L
.93307 .3153 L
.93407 .31508 L
.93506 .31537 L
.93606 .31603 L
.93706 .31697 L
.93806 .31811 L
.93906 .3194 L
.94006 .32078 L
.94106 .32222 L
.94206 .3237 L
.94306 .3252 L
.94406 .32671 L
.94505 .32822 L
.94605 .32974 L
.94705 .33125 L
Mistroke
.94805 .33276 L
.94905 .27096 L
.95005 .2725 L
.95105 .27269 L
.95205 .27223 L
.95305 .27134 L
.95405 .27012 L
.95504 .26862 L
.95604 .26686 L
.95704 .26485 L
.95804 .2626 L
.95904 .26009 L
.96004 .25733 L
.96104 .25428 L
.96204 .25094 L
.96304 .24728 L
.96404 .24329 L
.96503 .23894 L
.96603 .2342 L
.96703 .22908 L
.96803 .22356 L
.96903 .21764 L
.97003 .21138 L
.97103 .20485 L
.97203 .1982 L
.97303 .1917 L
.97403 .18579 L
.97502 .18119 L
.97602 .17893 L
.97702 .18022 L
.97802 .18595 L
.97902 .19623 L
.98002 .21044 L
.98102 .22757 L
.98202 .24656 L
.98302 .26633 L
.98402 .28588 L
.98501 .30434 L
.98601 .321 L
.98701 .3354 L
.98801 .3473 L
.98901 .35671 L
.99001 .36385 L
.99101 .36906 L
.99201 .37279 L
.99301 .37547 L
.99401 .3775 L
.995 .37914 L
.996 .38058 L
.997 .38187 L
Mistroke
.998 .38302 L
.999 .31867 L
Mfstroke
1 0 0 r
gsave
.999 .31237 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30145 L
.00799 .30034 L
.00899 .29914 L
.00999 .29783 L
.01099 .29637 L
.01199 .29475 L
.01299 .29295 L
.01399 .29095 L
.01499 .28872 L
.01598 .28625 L
.01698 .2835 L
.01798 .28047 L
.01898 .27713 L
.01998 .27348 L
.02098 .26952 L
.02198 .26527 L
.02298 .26079 L
.02398 .25615 L
.02498 .2515 L
.02597 .24705 L
.02697 .24308 L
.02797 .24003 L
.02897 .23843 L
.02997 .23897 L
.03097 .2425 L
.03197 .2499 L
.03297 .26208 L
.03397 .27971 L
.03497 .30304 L
.03596 .33155 L
.03696 .36376 L
.03796 .39716 L
.03896 .42837 L
.03996 .45364 L
.04096 .46957 L
.04196 .47384 L
.04296 .46572 L
.04396 .44628 L
.04496 .41826 L
.04595 .38551 L
.04695 .35218 L
.04795 .32182 L
.04895 .29675 L
Mistroke
.04995 .02688 L
.05095 .05308 L
.05195 .09022 L
.05295 .13699 L
.05395 .19061 L
.05495 .24714 L
.05594 .30214 L
.05694 .35161 L
.05794 .39276 L
.05894 .42439 L
.05994 .44675 L
.06094 .46111 L
.06194 .46912 L
.06294 .47246 L
.06394 .47249 L
.06494 .47024 L
.06593 .46644 L
.06693 .46152 L
.06793 .45576 L
.06893 .44934 L
.06993 .44239 L
.07093 .43503 L
.07193 .42739 L
.07293 .41961 L
.07393 .41187 L
.07493 .40431 L
.07592 .3971 L
.07692 .39037 L
.07792 .3842 L
.07892 .37867 L
.07992 .37377 L
.08092 .3695 L
.08192 .3658 L
.08292 .36261 L
.08392 .35986 L
.08492 .35746 L
.08591 .35535 L
.08691 .35344 L
.08791 .3517 L
.08891 .35007 L
.08991 .34852 L
.09091 .34703 L
.09191 .34559 L
.09291 .34419 L
.09391 .34283 L
.09491 .34153 L
.0959 .34029 L
.0969 .33912 L
.0979 .33802 L
.0989 .33701 L
Mistroke
.0999 .33088 L
.1009 .33231 L
.1019 .33385 L
.1029 .3355 L
.1039 .33726 L
.1049 .33914 L
.10589 .34115 L
.10689 .34331 L
.10789 .34562 L
.10889 .3481 L
.10989 .35077 L
.11089 .35364 L
.11189 .35674 L
.11289 .36007 L
.11389 .36366 L
.11489 .36752 L
.11588 .37168 L
.11688 .37614 L
.11788 .38091 L
.11888 .38601 L
.11988 .39144 L
.12088 .39719 L
.12188 .40325 L
.12288 .40959 L
.12388 .41619 L
.12488 .42298 L
.12587 .42988 L
.12687 .43681 L
.12787 .44364 L
.12887 .45023 L
.12987 .45641 L
.13087 .46199 L
.13187 .46677 L
.13287 .47056 L
.13387 .47316 L
.13487 .47441 L
.13586 .47422 L
.13686 .47251 L
.13786 .46932 L
.13886 .4647 L
.13986 .4588 L
.14086 .45177 L
.14186 .44376 L
.14286 .43491 L
.14386 .4253 L
.14486 .41501 L
.14585 .40407 L
.14685 .39253 L
.14785 .38049 L
.14885 .36811 L
Mistroke
.14985 .3618 L
.15085 .34278 L
.15185 .32603 L
.15285 .31191 L
.15385 .30052 L
.15485 .29174 L
.15584 .28529 L
.15684 .28083 L
.15784 .27797 L
.15884 .27636 L
.15984 .27567 L
.16084 .27562 L
.16184 .27598 L
.16284 .27659 L
.16384 .27729 L
.16484 .27799 L
.16583 .27861 L
.16683 .27911 L
.16783 .27944 L
.16883 .27958 L
.16983 .27951 L
.17083 .27924 L
.17183 .27875 L
.17283 .27805 L
.17383 .27713 L
.17483 .276 L
.17582 .27465 L
.17682 .27309 L
.17782 .27132 L
.17882 .26934 L
.17982 .26715 L
.18082 .26474 L
.18182 .26213 L
.18282 .25932 L
.18382 .2563 L
.18482 .25309 L
.18581 .2497 L
.18681 .24615 L
.18781 .24246 L
.18881 .23867 L
.18981 .23483 L
.19081 .23098 L
.19181 .22721 L
.19281 .2236 L
.19381 .22024 L
.19481 .21726 L
.1958 .21478 L
.1968 .21293 L
.1978 .21185 L
.1988 .21166 L
Mistroke
.1998 .16275 L
.2008 .15628 L
.2018 .14935 L
.2028 .14217 L
.2038 .13501 L
.2048 .12817 L
.20579 .12197 L
.20679 .11677 L
.20779 .11299 L
.20879 .11101 L
.20979 .11125 L
.21079 .11405 L
.21179 .11968 L
.21279 .12829 L
.21379 .13986 L
.21479 .15415 L
.21578 .17076 L
.21678 .18907 L
.21778 .20835 L
.21878 .22779 L
.21978 .24664 L
.22078 .26422 L
.22178 .28002 L
.22278 .29371 L
.22378 .30518 L
.22478 .31443 L
.22577 .32163 L
.22677 .32701 L
.22777 .33083 L
.22877 .33338 L
.22977 .33493 L
.23077 .33573 L
.23177 .33597 L
.23277 .33584 L
.23377 .33547 L
.23477 .33498 L
.23576 .33445 L
.23676 .33395 L
.23776 .33352 L
.23876 .3332 L
.23976 .333 L
.24076 .33295 L
.24176 .33305 L
.24276 .3333 L
.24376 .33371 L
.24476 .33427 L
.24575 .33498 L
.24675 .33584 L
.24775 .33685 L
.24875 .33798 L
Mistroke
.24975 .39484 L
.25075 .39781 L
.25175 .40092 L
.25275 .40415 L
.25375 .40749 L
.25475 .4109 L
.25574 .41435 L
.25674 .41781 L
.25774 .42123 L
.25874 .42457 L
.25974 .42776 L
.26074 .43075 L
.26174 .43347 L
.26274 .43585 L
.26374 .43783 L
.26474 .43932 L
.26573 .44026 L
.26673 .44058 L
.26773 .44023 L
.26873 .43918 L
.26973 .43739 L
.27073 .43486 L
.27173 .43162 L
.27273 .42771 L
.27373 .42319 L
.27473 .41816 L
.27572 .41272 L
.27672 .40699 L
.27772 .40109 L
.27872 .39515 L
.27972 .38929 L
.28072 .38361 L
.28172 .37821 L
.28272 .37316 L
.28372 .36852 L
.28472 .36433 L
.28571 .36062 L
.28671 .35739 L
.28771 .35464 L
.28871 .35234 L
.28971 .35049 L
.29071 .34904 L
.29171 .34798 L
.29271 .34727 L
.29371 .34687 L
.29471 .34676 L
.2957 .34691 L
.2967 .3473 L
.2977 .3479 L
.2987 .34869 L
Mistroke
.2997 .35061 L
.3007 .35229 L
.3017 .35417 L
.3027 .35623 L
.3037 .35848 L
.3047 .36093 L
.30569 .36357 L
.30669 .36642 L
.30769 .36948 L
.30869 .37275 L
.30969 .37625 L
.31069 .37998 L
.31169 .38395 L
.31269 .38815 L
.31369 .39259 L
.31469 .39726 L
.31568 .40214 L
.31668 .40723 L
.31768 .41249 L
.31868 .4179 L
.31968 .42339 L
.32068 .42893 L
.32168 .43442 L
.32268 .43979 L
.32368 .44494 L
.32468 .44973 L
.32567 .45406 L
.32667 .45777 L
.32767 .46073 L
.32867 .46279 L
.32967 .46381 L
.33067 .46369 L
.33167 .46234 L
.33267 .4597 L
.33367 .45576 L
.33467 .45055 L
.33566 .44416 L
.33666 .43668 L
.33766 .42829 L
.33866 .41916 L
.33966 .40948 L
.34066 .39946 L
.34166 .38932 L
.34266 .37928 L
.34366 .36952 L
.34466 .36024 L
.34565 .35159 L
.34665 .3437 L
.34765 .33666 L
.34865 .33052 L
Mistroke
.34965 .38161 L
.35065 .37195 L
.35165 .36297 L
.35265 .35482 L
.35365 .34762 L
.35465 .34141 L
.35564 .33618 L
.35664 .33191 L
.35764 .32852 L
.35864 .32593 L
.35964 .32404 L
.36064 .32276 L
.36164 .322 L
.36264 .32166 L
.36364 .32169 L
.36464 .322 L
.36563 .32255 L
.36663 .32329 L
.36763 .32418 L
.36863 .32519 L
.36963 .32631 L
.37063 .32752 L
.37163 .32881 L
.37263 .33018 L
.37363 .33163 L
.37463 .33315 L
.37562 .33475 L
.37662 .33644 L
.37762 .33822 L
.37862 .3401 L
.37962 .34209 L
.38062 .3442 L
.38162 .34643 L
.38262 .34878 L
.38362 .35128 L
.38462 .35391 L
.38561 .35668 L
.38661 .3596 L
.38761 .36264 L
.38861 .36581 L
.38961 .36908 L
.39061 .37243 L
.39161 .37583 L
.39261 .37924 L
.39361 .38261 L
.39461 .38586 L
.3956 .38893 L
.3966 .39171 L
.3976 .39412 L
.3986 .39604 L
Mistroke
.3996 .25892 L
.4006 .25312 L
.4016 .24712 L
.4026 .24084 L
.4036 .23424 L
.4046 .22724 L
.40559 .21982 L
.40659 .21193 L
.40759 .20357 L
.40859 .19471 L
.40959 .18539 L
.41059 .17563 L
.41159 .16553 L
.41259 .15518 L
.41359 .14475 L
.41459 .13446 L
.41558 .12459 L
.41658 .1155 L
.41758 .1076 L
.41858 .10137 L
.41958 .09735 L
.42058 .09607 L
.42158 .09803 L
.42258 .10364 L
.42358 .11314 L
.42458 .12657 L
.42557 .14369 L
.42657 .16398 L
.42757 .1867 L
.42857 .21091 L
.42957 .23559 L
.43057 .25975 L
.43157 .28249 L
.43257 .30314 L
.43357 .3212 L
.43457 .33644 L
.43556 .34883 L
.43656 .35851 L
.43756 .36576 L
.43856 .37092 L
.43956 .37436 L
.44056 .37642 L
.44156 .37745 L
.44256 .37771 L
.44356 .37745 L
.44456 .37685 L
.44555 .37605 L
.44655 .37517 L
.44755 .37428 L
.44855 .37345 L
Mistroke
.44955 .38013 L
.45055 .37892 L
.45155 .37783 L
.45255 .37688 L
.45355 .37612 L
.45455 .37554 L
.45554 .37517 L
.45654 .375 L
.45754 .37504 L
.45854 .37527 L
.45954 .3757 L
.46054 .37632 L
.46154 .37712 L
.46254 .3781 L
.46354 .37924 L
.46454 .38053 L
.46553 .38196 L
.46653 .38353 L
.46753 .38522 L
.46853 .38703 L
.46953 .38893 L
.47053 .39091 L
.47153 .39296 L
.47253 .39507 L
.47353 .39721 L
.47453 .39937 L
.47552 .40153 L
.47652 .40366 L
.47752 .40574 L
.47852 .40775 L
.47952 .40966 L
.48052 .41143 L
.48152 .41306 L
.48252 .41449 L
.48352 .41572 L
.48452 .41672 L
.48551 .41745 L
.48651 .4179 L
.48751 .41805 L
.48851 .41789 L
.48951 .41741 L
.49051 .4166 L
.49151 .41547 L
.49251 .41401 L
.49351 .41224 L
.49451 .41018 L
.4955 .40784 L
.4965 .40525 L
.4975 .40244 L
.4985 .39943 L
Mistroke
.4995 .39038 L
.5005 .37605 L
.5015 .36231 L
.5025 .34956 L
.5035 .33809 L
.5045 .32809 L
.50549 .31963 L
.50649 .31269 L
.50749 .30717 L
.50849 .30293 L
.50949 .29981 L
.51049 .29763 L
.51149 .29622 L
.51249 .29542 L
.51349 .29509 L
.51449 .29511 L
.51548 .29538 L
.51648 .29582 L
.51748 .29636 L
.51848 .29695 L
.51948 .29754 L
.52048 .29812 L
.52148 .29866 L
.52248 .29913 L
.52348 .29955 L
.52448 .29989 L
.52547 .30016 L
.52647 .30036 L
.52747 .30048 L
.52847 .30053 L
.52947 .30051 L
.53047 .30043 L
.53147 .30028 L
.53247 .30007 L
.53347 .29981 L
.53447 .29949 L
.53546 .29911 L
.53646 .29869 L
.53746 .29822 L
.53846 .29771 L
.53946 .29716 L
.54046 .29657 L
.54146 .29595 L
.54246 .2953 L
.54346 .29465 L
.54446 .29399 L
.54545 .29334 L
.54645 .29272 L
.54745 .29216 L
.54845 .29168 L
Mistroke
.54945 .39267 L
.55045 .39744 L
.55145 .40298 L
.55245 .40925 L
.55345 .41622 L
.55445 .42385 L
.55544 .43208 L
.55644 .44086 L
.55744 .45011 L
.55844 .45971 L
.55944 .4695 L
.56044 .47931 L
.56144 .48886 L
.56244 .49786 L
.56344 .50593 L
.56444 .51263 L
.56543 .51748 L
.56643 .51997 L
.56743 .51959 L
.56843 .51589 L
.56943 .50853 L
.57043 .49736 L
.57143 .48246 L
.57243 .46415 L
.57343 .44307 L
.57443 .42004 L
.57542 .39606 L
.57642 .37214 L
.57742 .34926 L
.57842 .3282 L
.57942 .30955 L
.58042 .29363 L
.58142 .28053 L
.58242 .27015 L
.58342 .26225 L
.58442 .2565 L
.58541 .25254 L
.58641 .25001 L
.58741 .24857 L
.58841 .24794 L
.58941 .24788 L
.59041 .24818 L
.59141 .24869 L
.59241 .24929 L
.59341 .24989 L
.59441 .25043 L
.5954 .25085 L
.5964 .25112 L
.5974 .25123 L
.5984 .25115 L
Mistroke
.5994 .23956 L
.6004 .23923 L
.6014 .23859 L
.6024 .23765 L
.6034 .23639 L
.6044 .23484 L
.60539 .233 L
.60639 .23088 L
.60739 .22849 L
.60839 .22585 L
.60939 .22299 L
.61039 .21991 L
.61139 .21663 L
.61239 .2132 L
.61339 .20963 L
.61439 .20595 L
.61538 .20222 L
.61638 .19846 L
.61738 .19474 L
.61838 .1911 L
.61938 .18762 L
.62038 .18436 L
.62138 .1814 L
.62238 .17881 L
.62338 .17668 L
.62438 .17509 L
.62537 .1741 L
.62637 .1738 L
.62737 .17423 L
.62837 .17544 L
.62937 .17745 L
.63037 .18027 L
.63137 .18387 L
.63237 .1882 L
.63337 .19321 L
.63437 .19881 L
.63536 .20488 L
.63636 .21133 L
.63736 .21802 L
.63836 .22482 L
.63936 .23162 L
.64036 .2383 L
.64136 .24475 L
.64236 .25087 L
.64336 .25659 L
.64436 .26184 L
.64535 .26659 L
.64635 .27081 L
.64735 .27448 L
.64835 .27762 L
Mistroke
.64935 .2667 L
.65035 .26505 L
.65135 .26321 L
.65235 .26119 L
.65335 .25897 L
.65435 .25655 L
.65534 .25393 L
.65634 .2511 L
.65734 .24806 L
.65834 .2448 L
.65934 .24131 L
.66034 .23759 L
.66134 .23364 L
.66234 .22946 L
.66334 .22505 L
.66434 .22041 L
.66533 .21557 L
.66633 .21054 L
.66733 .20534 L
.66833 .20001 L
.66933 .19461 L
.67033 .18918 L
.67133 .1838 L
.67233 .17855 L
.67333 .17354 L
.67433 .16887 L
.67532 .16467 L
.67632 .16107 L
.67732 .15822 L
.67832 .15624 L
.67932 .15526 L
.68032 .15539 L
.68132 .15673 L
.68232 .15932 L
.68332 .16318 L
.68432 .16829 L
.68531 .17459 L
.68631 .18196 L
.68731 .19027 L
.68831 .19936 L
.68931 .20903 L
.69031 .21909 L
.69131 .22932 L
.69231 .23952 L
.69331 .24949 L
.69431 .25903 L
.6953 .26799 L
.6963 .27623 L
.6973 .28364 L
.6983 .29017 L
Mistroke
.6993 .30136 L
.7003 .30428 L
.7013 .30642 L
.7023 .30791 L
.7033 .30886 L
.7043 .30936 L
.70529 .3095 L
.70629 .30937 L
.70729 .30904 L
.70829 .30854 L
.70929 .30794 L
.71029 .30725 L
.71129 .30652 L
.71229 .30575 L
.71329 .30497 L
.71429 .30417 L
.71528 .30337 L
.71628 .30256 L
.71728 .30175 L
.71828 .30093 L
.71928 .3001 L
.72028 .29926 L
.72128 .29839 L
.72228 .2975 L
.72328 .29657 L
.72428 .2956 L
.72527 .29459 L
.72627 .29352 L
.72727 .29239 L
.72827 .2912 L
.72927 .28993 L
.73027 .2886 L
.73127 .28718 L
.73227 .28568 L
.73327 .2841 L
.73427 .28245 L
.73526 .28072 L
.73626 .27892 L
.73726 .27708 L
.73826 .27521 L
.73926 .27334 L
.74026 .27152 L
.74126 .26978 L
.74226 .26819 L
.74326 .26683 L
.74426 .2658 L
.74525 .26522 L
.74625 .2652 L
.74725 .26591 L
.74825 .26751 L
Mistroke
.74925 .13381 L
.75025 .12211 L
.75125 .11041 L
.75225 .09913 L
.75325 .08879 L
.75425 .08 L
.75524 .07346 L
.75624 .06995 L
.75724 .07028 L
.75824 .0752 L
.75924 .0853 L
.76024 .1009 L
.76124 .12193 L
.76224 .14784 L
.76324 .17757 L
.76424 .20965 L
.76523 .24238 L
.76623 .27403 L
.76723 .30307 L
.76823 .32843 L
.76923 .3495 L
.77023 .36617 L
.77123 .3787 L
.77223 .38761 L
.77323 .39352 L
.77423 .39708 L
.77522 .39887 L
.77622 .39939 L
.77722 .39906 L
.77822 .39818 L
.77922 .39699 L
.78022 .39566 L
.78122 .3943 L
.78222 .393 L
.78322 .39181 L
.78422 .39077 L
.78521 .3899 L
.78621 .3892 L
.78721 .38868 L
.78821 .38834 L
.78921 .38818 L
.79021 .38818 L
.79121 .38834 L
.79221 .38866 L
.79321 .38912 L
.79421 .38972 L
.7952 .39045 L
.7962 .3913 L
.7972 .39226 L
.7982 .39332 L
Mistroke
.7992 .41624 L
.8002 .41601 L
.8012 .41569 L
.8022 .41526 L
.8032 .4147 L
.8042 .414 L
.80519 .41313 L
.80619 .41211 L
.80719 .41092 L
.80819 .40957 L
.80919 .40807 L
.81019 .40642 L
.81119 .40465 L
.81219 .40278 L
.81319 .40082 L
.81419 .3988 L
.81518 .39674 L
.81618 .39468 L
.81718 .39264 L
.81818 .39064 L
.81918 .3887 L
.82018 .38686 L
.82118 .38513 L
.82218 .38352 L
.82318 .38206 L
.82418 .38075 L
.82517 .3796 L
.82617 .37861 L
.82717 .3778 L
.82817 .37715 L
.82917 .37668 L
.83017 .37637 L
.83117 .37623 L
.83217 .37624 L
.83317 .37641 L
.83417 .37672 L
.83516 .37717 L
.83616 .37775 L
.83716 .37846 L
.83816 .37928 L
.83916 .38021 L
.84016 .38125 L
.84116 .38237 L
.84216 .38359 L
.84316 .38488 L
.84416 .38624 L
.84515 .38767 L
.84615 .38915 L
.84715 .39067 L
.84815 .39223 L
Mistroke
.84915 .42666 L
.85015 .42337 L
.85115 .41957 L
.85215 .41534 L
.85315 .41074 L
.85415 .40587 L
.85514 .40083 L
.85614 .39572 L
.85714 .39064 L
.85814 .38567 L
.85914 .38091 L
.86014 .37643 L
.86114 .37228 L
.86214 .36851 L
.86314 .36516 L
.86414 .36223 L
.86513 .35973 L
.86613 .35765 L
.86713 .35599 L
.86813 .35472 L
.86913 .35382 L
.87013 .35327 L
.87113 .35303 L
.87213 .35309 L
.87313 .35341 L
.87413 .35398 L
.87512 .35478 L
.87612 .35578 L
.87712 .35697 L
.87812 .35834 L
.87912 .35989 L
.88012 .36159 L
.88112 .36344 L
.88212 .36544 L
.88312 .36758 L
.88412 .36986 L
.88511 .37228 L
.88611 .37482 L
.88711 .3775 L
.88811 .3803 L
.88911 .38321 L
.89011 .38624 L
.89111 .38936 L
.89211 .39257 L
.89311 .39585 L
.89411 .39919 L
.8951 .40255 L
.8961 .40593 L
.8971 .40929 L
.8981 .4126 L
Mistroke
.8991 .42892 L
.9001 .43733 L
.9011 .446 L
.9021 .45483 L
.9031 .46369 L
.9041 .47243 L
.90509 .48085 L
.90609 .48868 L
.90709 .49564 L
.90809 .50137 L
.90909 .50549 L
.91009 .5076 L
.91109 .5073 L
.91209 .50426 L
.91309 .49819 L
.91409 .48897 L
.91508 .47662 L
.91608 .4614 L
.91708 .44375 L
.91808 .42431 L
.91908 .40385 L
.92008 .38321 L
.92108 .3632 L
.92208 .34451 L
.92308 .32768 L
.92408 .31306 L
.92507 .30078 L
.92607 .29083 L
.92707 .28304 L
.92807 .27718 L
.92907 .27297 L
.93007 .2701 L
.93107 .26829 L
.93207 .2673 L
.93307 .26689 L
.93407 .26689 L
.93506 .26713 L
.93606 .26751 L
.93706 .26792 L
.93806 .2683 L
.93906 .26859 L
.94006 .26877 L
.94106 .26879 L
.94206 .26864 L
.94306 .26832 L
.94406 .26781 L
.94505 .26712 L
.94605 .26624 L
.94705 .26518 L
.94805 .26394 L
Mistroke
.94905 .26475 L
.95005 .26231 L
.95105 .25967 L
.95205 .2568 L
.95305 .25371 L
.95405 .25038 L
.95504 .24679 L
.95604 .24294 L
.95704 .23881 L
.95804 .2344 L
.95904 .22971 L
.96004 .22471 L
.96104 .21942 L
.96204 .21385 L
.96304 .208 L
.96404 .20191 L
.96503 .1956 L
.96603 .18912 L
.96703 .18255 L
.96803 .17596 L
.96903 .16946 L
.97003 .16317 L
.97103 .15725 L
.97203 .15185 L
.97303 .14718 L
.97403 .14343 L
.97502 .14081 L
.97602 .13952 L
.97702 .13974 L
.97802 .1416 L
.97902 .14522 L
.98002 .15061 L
.98102 .15775 L
.98202 .16652 L
.98302 .17675 L
.98402 .18817 L
.98501 .20052 L
.98601 .21346 L
.98701 .22667 L
.98801 .2398 L
.98901 .25255 L
.99001 .26463 L
.99101 .27582 L
.99201 .28594 L
.99301 .29486 L
.99401 .30253 L
.995 .30895 L
.996 .31419 L
.997 .31833 L
.998 .32149 L
Mistroke
.999 .31237 L
Mfstroke
0 0 0 r
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .27968 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.03876 0 m
.03896 .00817 L
.03996 .05173 L
.04096 .08935 L
.04196 .11238 L
.04296 .11685 L
.04396 .106 L
.04496 .08736 L
.04595 .0681 L
.04695 .05255 L
.04795 .04221 L
.04895 .03674 L
.04995 .40277 L
.05095 .44407 L
.05195 .4789 L
.05295 .50468 L
.05395 .51917 L
.05495 .52127 L
.05594 .51145 L
.05694 .49165 L
.05794 .46486 L
.05894 .43436 L
.05994 .40298 L
.06094 .37273 L
.06194 .34479 L
.06294 .31964 L
.06394 .29737 L
.06494 .27784 L
.06593 .26082 L
.06693 .2461 L
.06793 .23348 L
.06893 .22285 L
.06993 .21414 L
.07093 .2073 L
.07193 .20232 L
.07293 .19916 L
.07393 .19777 L
.07493 .19804 L
.07592 .19984 L
.07692 .20299 L
.07792 .20726 L
.07892 .21242 L
.07992 .21821 L
.08092 .22435 L
.08192 .23059 L
.08292 .23666 L
.08392 .24233 L
.08492 .24736 L
.08591 .25157 L
.08691 .25478 L
Mistroke
.08791 .2569 L
.08891 .25788 L
.08991 .25775 L
.09091 .2566 L
.09191 .25458 L
.09291 .25187 L
.09391 .24862 L
.09491 .24501 L
.0959 .24114 L
.0969 .23714 L
.0979 .23307 L
.0989 .229 L
.0999 .22551 L
.1009 .21546 L
.1019 .20676 L
.1029 .19878 L
.1039 .19132 L
.1049 .18429 L
.10589 .17764 L
.10689 .17135 L
.10789 .16537 L
.10889 .15971 L
.10989 .15434 L
.11089 .14925 L
.11189 .14443 L
.11289 .13987 L
.11389 .13554 L
.11489 .13143 L
.11588 .12751 L
.11688 .12375 L
.11788 .12012 L
.11888 .11656 L
.11988 .11306 L
.12088 .10955 L
.12188 .10601 L
.12288 .1024 L
.12388 .09871 L
.12488 .09494 L
.12587 .09111 L
.12687 .08727 L
.12787 .08349 L
.12887 .07989 L
.12987 .07665 L
.13087 .07397 L
.13187 .07213 L
.13287 .07148 L
.13387 .07241 L
.13487 .07535 L
.13586 .08078 L
.13686 .08915 L
Mistroke
.13786 .10083 L
.13886 .11611 L
.13986 .13505 L
.14086 .15747 L
.14186 .18284 L
.14286 .21017 L
.14386 .23791 L
.14486 .26368 L
.14585 .28418 L
.14685 .29579 L
.14785 .29695 L
.14885 .28992 L
.14985 .39677 L
.15085 .38785 L
.15185 .37669 L
.15285 .36361 L
.15385 .34928 L
.15485 .33435 L
.15584 .31937 L
.15684 .30471 L
.15784 .29064 L
.15884 .2773 L
.15984 .26473 L
.16084 .25293 L
.16184 .24186 L
.16284 .23146 L
.16384 .22168 L
.16484 .21245 L
.16583 .20371 L
.16683 .19543 L
.16783 .18755 L
.16883 .18004 L
.16983 .17288 L
.17083 .16604 L
.17183 .15949 L
.17283 .15321 L
.17383 .14719 L
.17483 .1414 L
.17582 .13583 L
.17682 .13045 L
.17782 .12524 L
.17882 .12016 L
.17982 .11519 L
.18082 .11029 L
.18182 .10541 L
.18282 .1005 L
.18382 .09552 L
.18482 .0904 L
.18581 .08508 L
.18681 .0795 L
Mistroke
.18781 .07361 L
.18881 .06734 L
.18981 .06064 L
.19081 .05347 L
.19181 .04579 L
.19281 .03758 L
.19381 .02884 L
.19481 .01958 L
.1958 .00984 L
Mfstroke
.1958 .00984 m
.19677 0 L
s
.19891 0 m
.1998 .16702 L
.2008 .1678 L
.2018 .17118 L
.2028 .17651 L
.2038 .18354 L
.2048 .19213 L
.20579 .20218 L
.20679 .21355 L
.20779 .22612 L
.20879 .23972 L
.20979 .25414 L
.21079 .26913 L
.21179 .28435 L
.21279 .29942 L
.21379 .31387 L
.21479 .32718 L
.21578 .33881 L
.21678 .34822 L
.21778 .35494 L
.21878 .35861 L
.21978 .35907 L
.22078 .3564 L
.22178 .35089 L
.22278 .34306 L
.22378 .3335 L
.22478 .32283 L
.22577 .31158 L
.22677 .30016 L
.22777 .28886 L
.22877 .27784 L
.22977 .26721 L
.23077 .25701 L
.23177 .24725 L
.23277 .2379 L
.23377 .22896 L
.23477 .22038 L
.23576 .21216 L
.23676 .20427 L
.23776 .19668 L
.23876 .18937 L
.23976 .18234 L
.24076 .17556 L
.24176 .16902 L
.24276 .16271 L
.24376 .15661 L
.24476 .1507 L
.24575 .14497 L
.24675 .1394 L
.24775 .13397 L
Mistroke
.24875 .12865 L
.24975 .22931 L
.25075 .22439 L
.25175 .22104 L
.25275 .21858 L
.25375 .2168 L
.25475 .21561 L
.25574 .21494 L
.25674 .21476 L
.25774 .21502 L
.25874 .2157 L
.25974 .21677 L
.26074 .21821 L
.26174 .22001 L
.26274 .22214 L
.26374 .22459 L
.26474 .22735 L
.26573 .23041 L
.26673 .23376 L
.26773 .23737 L
.26873 .24122 L
.26973 .24527 L
.27073 .24948 L
.27173 .25379 L
.27273 .25811 L
.27373 .26235 L
.27473 .26641 L
.27572 .27016 L
.27672 .27347 L
.27772 .27622 L
.27872 .27829 L
.27972 .27957 L
.28072 .27999 L
.28172 .27951 L
.28272 .27814 L
.28372 .2759 L
.28472 .27287 L
.28571 .26914 L
.28671 .26482 L
.28771 .26003 L
.28871 .25487 L
.28971 .24943 L
.29071 .2438 L
.29171 .23804 L
.29271 .23222 L
.29371 .22637 L
.29471 .22054 L
.2957 .21474 L
.2967 .209 L
.2977 .20332 L
Mistroke
.2987 .19772 L
.2997 .23731 L
.3007 .22828 L
.3017 .22065 L
.3027 .21377 L
.3037 .20743 L
.3047 .20154 L
.30569 .19606 L
.30669 .19094 L
.30769 .18618 L
.30869 .18176 L
.30969 .17766 L
.31069 .17387 L
.31169 .17037 L
.31269 .16716 L
.31369 .16423 L
.31469 .16156 L
.31568 .15914 L
.31668 .15697 L
.31768 .15505 L
.31868 .15339 L
.31968 .15201 L
.32068 .15094 L
.32168 .15023 L
.32268 .14994 L
.32368 .15016 L
.32468 .15098 L
.32567 .15252 L
.32667 .15493 L
.32767 .15834 L
.32867 .1629 L
.32967 .16877 L
.33067 .17607 L
.33167 .18489 L
.33267 .19526 L
.33367 .20711 L
.33467 .22026 L
.33566 .23439 L
.33666 .24902 L
.33766 .26347 L
.33866 .2769 L
.33966 .28833 L
.34066 .29676 L
.34166 .30147 L
.34266 .30225 L
.34366 .29955 L
.34466 .29424 L
.34565 .28726 L
.34665 .27938 L
.34765 .27116 L
Mistroke
.34865 .26294 L
.34965 .36106 L
.35065 .35537 L
.35165 .34939 L
.35265 .34267 L
.35365 .33526 L
.35465 .32726 L
.35564 .31884 L
.35664 .31014 L
.35764 .30129 L
.35864 .29241 L
.35964 .28359 L
.36064 .27488 L
.36164 .26634 L
.36264 .258 L
.36364 .24988 L
.36464 .24199 L
.36563 .23434 L
.36663 .22692 L
.36763 .21973 L
.36863 .21277 L
.36963 .20604 L
.37063 .19952 L
.37163 .19322 L
.37263 .18713 L
.37363 .18123 L
.37463 .17553 L
.37562 .17001 L
.37662 .16466 L
.37762 .15947 L
.37862 .15442 L
.37962 .14951 L
.38062 .14469 L
.38162 .13996 L
.38262 .13527 L
.38362 .13059 L
.38462 .12589 L
.38561 .12111 L
.38661 .11621 L
.38761 .11113 L
.38861 .10583 L
.38961 .10025 L
.39061 .09433 L
.39161 .08804 L
.39261 .08133 L
.39361 .07417 L
.39461 .06653 L
.3956 .0584 L
.3966 .04978 L
.3976 .04068 L
Mistroke
.3986 .03115 L
.3996 .113 L
.4006 .10796 L
.4016 .10443 L
.4026 .10177 L
.4036 .09981 L
.4046 .09849 L
.40559 .09778 L
.40659 .09767 L
.40759 .09815 L
.40859 .09924 L
.40959 .10094 L
.41059 .10325 L
.41159 .10622 L
.41259 .10989 L
.41359 .11434 L
.41459 .1197 L
.41558 .12612 L
.41658 .1338 L
.41758 .14297 L
.41858 .1539 L
.41958 .16685 L
.42058 .1821 L
.42158 .19984 L
.42258 .22017 L
.42358 .24299 L
.42458 .26792 L
.42557 .29421 L
.42657 .32067 L
.42757 .34565 L
.42857 .36699 L
.42957 .38216 L
.43057 .38894 L
.43157 .3868 L
.43257 .37784 L
.43357 .36526 L
.43457 .35162 L
.43556 .33841 L
.43656 .32632 L
.43756 .31556 L
.43856 .30604 L
.43956 .29754 L
.44056 .28981 L
.44156 .28261 L
.44256 .27571 L
.44356 .26898 L
.44456 .26231 L
.44555 .25565 L
.44655 .249 L
.44755 .24236 L
Mistroke
.44855 .23576 L
.44955 .30238 L
.45055 .29275 L
.45155 .2847 L
.45255 .27752 L
.45355 .27096 L
.45455 .26488 L
.45554 .25919 L
.45654 .25384 L
.45754 .24879 L
.45854 .244 L
.45954 .23945 L
.46054 .23512 L
.46154 .231 L
.46254 .22707 L
.46354 .22332 L
.46454 .21975 L
.46553 .21635 L
.46653 .21311 L
.46753 .21004 L
.46853 .20712 L
.46953 .20437 L
.47053 .20177 L
.47153 .19933 L
.47253 .19706 L
.47353 .19496 L
.47453 .19304 L
.47552 .19132 L
.47652 .1898 L
.47752 .18851 L
.47852 .18746 L
.47952 .18668 L
.48052 .18618 L
.48152 .18601 L
.48252 .18617 L
.48352 .18671 L
.48452 .18764 L
.48551 .18897 L
.48651 .19074 L
.48751 .19294 L
.48851 .19556 L
.48951 .1986 L
.49051 .20203 L
.49151 .20578 L
.49251 .20979 L
.49351 .21398 L
.49451 .21824 L
.4955 .22244 L
.4965 .22645 L
.4975 .23012 L
Mistroke
.4985 .23332 L
.4995 .38182 L
.5005 .37924 L
.5015 .37528 L
.5025 .36961 L
.5035 .36242 L
.5045 .35399 L
.50549 .34466 L
.50649 .33476 L
.50749 .32455 L
.50849 .31427 L
.50949 .30408 L
.51049 .29409 L
.51149 .28439 L
.51249 .27502 L
.51349 .26599 L
.51449 .25732 L
.51548 .24898 L
.51648 .24097 L
.51748 .23327 L
.51848 .22585 L
.51948 .21871 L
.52048 .21183 L
.52148 .20518 L
.52248 .19878 L
.52348 .19259 L
.52448 .18661 L
.52547 .18085 L
.52647 .17528 L
.52747 .16991 L
.52847 .16474 L
.52947 .15976 L
.53047 .15496 L
.53147 .15036 L
.53247 .14594 L
.53347 .14171 L
.53447 .13767 L
.53546 .13381 L
.53646 .13014 L
.53746 .12666 L
.53846 .12337 L
.53946 .12026 L
.54046 .11733 L
.54146 .11457 L
.54246 .11198 L
.54346 .10954 L
.54446 .10725 L
.54545 .10508 L
.54645 .10303 L
.54745 .10108 L
Mistroke
.54845 .09922 L
.54945 .12551 L
.55045 .1211 L
.55145 .11848 L
.55245 .11703 L
.55345 .11658 L
.55445 .11707 L
.55544 .11848 L
.55644 .12082 L
.55744 .12411 L
.55844 .12836 L
.55944 .13363 L
.56044 .13996 L
.56144 .14745 L
.56244 .15621 L
.56344 .16637 L
.56444 .17806 L
.56543 .19142 L
.56643 .20656 L
.56743 .22355 L
.56843 .24235 L
.56943 .26278 L
.57043 .28448 L
.57143 .30686 L
.57243 .32905 L
.57343 .3499 L
.57443 .36799 L
.57542 .38177 L
.57642 .3898 L
.57742 .39126 L
.57842 .38653 L
.57942 .3772 L
.58042 .36525 L
.58142 .3523 L
.58242 .33945 L
.58342 .32728 L
.58442 .31603 L
.58541 .30573 L
.58641 .29628 L
.58741 .28754 L
.58841 .27938 L
.58941 .27164 L
.59041 .26421 L
.59141 .25701 L
.59241 .24998 L
.59341 .24307 L
.59441 .23628 L
.5954 .22957 L
.5964 .22296 L
.5974 .21644 L
Mistroke
.5984 .21001 L
.5994 .24811 L
.6004 .23936 L
.6014 .23223 L
.6024 .22603 L
.6034 .22052 L
.6044 .21558 L
.60539 .21113 L
.60639 .20713 L
.60739 .20355 L
.60839 .20035 L
.60939 .19752 L
.61039 .19503 L
.61139 .19288 L
.61239 .19104 L
.61339 .18952 L
.61439 .1883 L
.61538 .1874 L
.61638 .18682 L
.61738 .18658 L
.61838 .18669 L
.61938 .18719 L
.62038 .18812 L
.62138 .18951 L
.62238 .19141 L
.62338 .19387 L
.62438 .19693 L
.62537 .20065 L
.62637 .20505 L
.62737 .21014 L
.62837 .21593 L
.62937 .22236 L
.63037 .22938 L
.63137 .23686 L
.63237 .24462 L
.63337 .25245 L
.63437 .26007 L
.63536 .26717 L
.63636 .27341 L
.63736 .27848 L
.63836 .28208 L
.63936 .28404 L
.64036 .28431 L
.64136 .28297 L
.64236 .28023 L
.64336 .27635 L
.64436 .27161 L
.64535 .26627 L
.64635 .26053 L
.64735 .25456 L
Mistroke
.64835 .24849 L
.64935 .22706 L
.65035 .21852 L
.65135 .21138 L
.65235 .205 L
.65335 .19916 L
.65435 .19378 L
.65534 .18879 L
.65634 .18416 L
.65734 .17987 L
.65834 .17589 L
.65934 .17223 L
.66034 .16885 L
.66134 .16575 L
.66234 .16292 L
.66334 .16034 L
.66434 .158 L
.66533 .15589 L
.66633 .15401 L
.66733 .15237 L
.66833 .15097 L
.66933 .14984 L
.67033 .14902 L
.67133 .14855 L
.67233 .1485 L
.67333 .14896 L
.67433 .15003 L
.67532 .15182 L
.67632 .15446 L
.67732 .1581 L
.67832 .16288 L
.67932 .16895 L
.68032 .17643 L
.68132 .1854 L
.68232 .19589 L
.68332 .20785 L
.68432 .2211 L
.68531 .23534 L
.68631 .25012 L
.68731 .26479 L
.68831 .27853 L
.68931 .29037 L
.69031 .29929 L
.69131 .30448 L
.69231 .30568 L
.69331 .3033 L
.69431 .2982 L
.6953 .29137 L
.6963 .28361 L
.6973 .27549 L
Mistroke
.6983 .2674 L
.6993 .33156 L
.7003 .31923 L
.7013 .3081 L
.7023 .2976 L
.7033 .28757 L
.7043 .27796 L
.70529 .26873 L
.70629 .25985 L
.70729 .2513 L
.70829 .24307 L
.70929 .23514 L
.71029 .2275 L
.71129 .22012 L
.71229 .213 L
.71329 .20612 L
.71429 .19948 L
.71528 .19306 L
.71628 .18686 L
.71728 .18087 L
.71828 .17509 L
.71928 .1695 L
.72028 .16411 L
.72128 .15891 L
.72228 .1539 L
.72328 .14907 L
.72428 .14441 L
.72527 .13993 L
.72627 .13561 L
.72727 .13146 L
.72827 .12746 L
.72927 .1236 L
.73027 .11987 L
.73127 .11625 L
.73227 .11271 L
.73327 .10924 L
.73427 .10578 L
.73526 .10232 L
.73626 .09879 L
.73726 .09517 L
.73826 .09139 L
.73926 .08742 L
.74026 .08321 L
.74126 .07874 L
.74226 .07399 L
.74326 .06894 L
.74426 .06362 L
.74525 .05807 L
.74625 .05235 L
.74725 .04659 L
Mistroke
.74825 .04093 L
.74925 .13672 L
.75025 .14468 L
.75125 .156 L
.75225 .17008 L
.75325 .18674 L
.75425 .20584 L
.75524 .22721 L
.75624 .25061 L
.75724 .27566 L
.75824 .30186 L
.75924 .32848 L
.76024 .35461 L
.76124 .37915 L
.76224 .40087 L
.76324 .41854 L
.76424 .43101 L
.76523 .43747 L
.76623 .43761 L
.76723 .43178 L
.76823 .42103 L
.76923 .40691 L
.77023 .391 L
.77123 .37467 L
.77223 .35884 L
.77323 .34405 L
.77423 .3305 L
.77522 .31821 L
.77622 .30705 L
.77722 .29686 L
.77822 .2875 L
.77922 .27881 L
.78022 .27069 L
.78122 .26304 L
.78222 .25581 L
.78322 .24895 L
.78422 .24242 L
.78521 .23621 L
.78621 .2303 L
.78721 .22468 L
.78821 .21935 L
.78921 .21431 L
.79021 .20957 L
.79121 .20512 L
.79221 .20098 L
.79321 .19717 L
.79421 .19367 L
.7952 .19052 L
.7962 .18771 L
.7972 .18526 L
Mistroke
.7982 .18317 L
.7992 .27822 L
.8002 .27563 L
.8012 .27436 L
.8022 .2737 L
.8032 .27338 L
.8042 .27327 L
.80519 .27326 L
.80619 .27329 L
.80719 .2733 L
.80819 .27325 L
.80919 .27309 L
.81019 .2728 L
.81119 .27237 L
.81219 .27177 L
.81319 .27101 L
.81419 .27007 L
.81518 .26895 L
.81618 .26765 L
.81718 .26619 L
.81818 .26456 L
.81918 .26278 L
.82018 .26084 L
.82118 .25877 L
.82218 .25656 L
.82318 .25423 L
.82418 .25179 L
.82517 .24924 L
.82617 .2466 L
.82717 .24387 L
.82817 .24106 L
.82917 .23818 L
.83017 .23525 L
.83117 .23226 L
.83217 .22923 L
.83317 .22617 L
.83417 .22309 L
.83516 .21998 L
.83616 .21687 L
.83716 .21377 L
.83816 .21067 L
.83916 .20759 L
.84016 .20454 L
.84116 .20153 L
.84216 .19857 L
.84316 .19567 L
.84416 .19284 L
.84515 .19009 L
.84615 .18744 L
.84715 .1849 L
Mistroke
.84815 .18249 L
.84915 .30717 L
.85015 .30802 L
.85115 .3095 L
.85215 .31088 L
.85315 .31188 L
.85415 .31235 L
.85514 .31222 L
.85614 .31145 L
.85714 .31002 L
.85814 .30797 L
.85914 .30532 L
.86014 .30211 L
.86114 .29842 L
.86214 .29429 L
.86314 .2898 L
.86414 .28501 L
.86513 .27998 L
.86613 .27476 L
.86713 .26941 L
.86813 .26396 L
.86913 .25847 L
.87013 .25296 L
.87113 .24745 L
.87213 .24198 L
.87313 .23655 L
.87413 .23119 L
.87512 .2259 L
.87612 .22069 L
.87712 .21558 L
.87812 .21055 L
.87912 .20562 L
.88012 .20078 L
.88112 .19604 L
.88212 .19139 L
.88312 .18682 L
.88412 .18234 L
.88511 .17794 L
.88611 .17362 L
.88711 .16938 L
.88811 .16521 L
.88911 .16111 L
.89011 .15709 L
.89111 .15314 L
.89211 .14929 L
.89311 .14554 L
.89411 .14192 L
.8951 .13844 L
.8961 .13515 L
.8971 .13209 L
Mistroke
.8981 .1293 L
.8991 .15077 L
.9001 .15109 L
.9011 .15365 L
.9021 .15782 L
.9031 .16346 L
.9041 .1705 L
.90509 .17891 L
.90609 .18866 L
.90709 .19972 L
.90809 .21206 L
.90909 .22563 L
.91009 .24033 L
.91109 .25602 L
.91209 .2725 L
.91309 .28947 L
.91409 .30655 L
.91508 .32323 L
.91608 .33894 L
.91708 .35303 L
.91808 .3648 L
.91908 .37361 L
.92008 .37893 L
.92108 .38046 L
.92208 .37822 L
.92308 .37261 L
.92408 .36434 L
.92507 .35423 L
.92607 .3431 L
.92707 .33157 L
.92807 .32013 L
.92907 .30904 L
.93007 .29846 L
.93107 .28843 L
.93207 .27897 L
.93307 .27002 L
.93407 .26154 L
.93506 .25347 L
.93606 .24576 L
.93706 .23836 L
.93806 .23123 L
.93906 .22434 L
.94006 .21764 L
.94106 .21113 L
.94206 .20477 L
.94306 .19854 L
.94406 .19242 L
.94505 .1864 L
.94605 .18046 L
.94705 .17457 L
Mistroke
.94805 .16872 L
.94905 .19986 L
.95005 .19182 L
.95105 .18524 L
.95205 .17946 L
.95305 .17427 L
.95405 .16957 L
.95504 .16532 L
.95604 .16148 L
.95704 .15803 L
.95804 .15494 L
.95904 .15222 L
.96004 .14984 L
.96104 .14778 L
.96204 .14604 L
.96304 .1446 L
.96404 .14347 L
.96503 .14265 L
.96603 .14215 L
.96703 .14202 L
.96803 .14229 L
.96903 .14304 L
.97003 .14437 L
.97103 .14638 L
.97203 .14922 L
.97303 .15304 L
.97403 .15801 L
.97502 .16432 L
.97602 .17214 L
.97702 .18164 L
.97802 .19292 L
.97902 .206 L
.98002 .22082 L
.98102 .23712 L
.98202 .25448 L
.98302 .27225 L
.98402 .28952 L
.98501 .3051 L
.98601 .31763 L
.98701 .32573 L
.98801 .32859 L
.98901 .32644 L
.99001 .32045 L
.99101 .31209 L
.99201 .30257 L
.99301 .29274 L
.99401 .28307 L
.995 .27385 L
.996 .26515 L
.997 .257 L
Mistroke
.998 .24934 L
.999 .27968 L
Mfstroke
gsave
.999 .29229 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .0163 L
.004 .01789 L
.005 .01926 L
.00599 .02047 L
.00699 .02157 L
.00799 .02259 L
.00899 .02358 L
.00999 .02456 L
.01099 .02556 L
.01199 .02663 L
.01299 .02783 L
.01399 .02922 L
.01499 .03089 L
.01598 .03296 L
.01698 .03562 L
.01798 .0391 L
.01898 .04369 L
.01998 .04979 L
.02098 .05788 L
.02198 .06851 L
.02298 .08231 L
.02398 .09998 L
.02498 .1223 L
.02597 .15011 L
.02697 .18428 L
.02797 .22565 L
.02897 .27491 L
.02997 .33245 L
.03097 .39808 L
.03197 .47077 L
.03297 .54837 L
s
.03297 .54837 m
.03385 .61803 L
s
.04948 .61803 m
.04995 .41554 L
.05095 .46976 L
.05195 .52031 L
.05295 .56281 L
.05395 .59364 L
.05495 .61056 L
.05594 .61332 L
.05694 .60376 L
.05794 .58534 L
.05894 .56223 L
.05994 .53839 L
.06094 .51694 L
.06194 .49986 L
.06294 .48802 L
.06394 .48146 L
.06494 .47968 L
.06593 .48183 L
.06693 .48695 L
.06793 .49403 L
.06893 .50207 L
.06993 .51013 L
.07093 .51736 L
.07193 .52308 L
.07293 .52673 L
.07393 .52798 L
.07493 .52667 L
.07592 .52285 L
.07692 .51672 L
.07792 .5086 L
.07892 .49891 L
.07992 .48808 L
.08092 .47657 L
.08192 .4648 L
.08292 .45314 L
.08392 .44193 L
.08492 .43143 L
.08591 .42184 L
.08691 .41331 L
.08791 .4059 L
.08891 .39962 L
.08991 .39438 L
.09091 .39003 L
.09191 .38639 L
.09291 .38326 L
.09391 .38045 L
.09491 .37778 L
.0959 .37515 L
.0969 .37244 L
.0979 .36962 L
Mistroke
.0989 .36664 L
.0999 .2382 L
.1009 .23602 L
.1019 .23289 L
.1029 .22946 L
.1039 .22593 L
.1049 .22239 L
.10589 .21891 L
.10689 .21553 L
.10789 .21228 L
.10889 .20921 L
.10989 .20635 L
.11089 .20373 L
.11189 .2014 L
.11289 .19941 L
.11389 .19782 L
.11489 .19671 L
.11588 .19615 L
.11688 .19625 L
.11788 .19711 L
.11888 .19888 L
.11988 .2017 L
.12088 .20571 L
.12188 .21109 L
.12288 .218 L
.12388 .2266 L
.12488 .23705 L
.12587 .24945 L
.12687 .26391 L
.12787 .28046 L
.12887 .29905 L
.12987 .31956 L
.13087 .34173 L
.13187 .36515 L
.13287 .38928 L
.13387 .41339 L
.13487 .43663 L
.13586 .45803 L
.13686 .47658 L
.13786 .49136 L
.13886 .50157 L
.13986 .50671 L
.14086 .50663 L
.14186 .50166 L
.14286 .49267 L
.14386 .48112 L
.14486 .46927 L
.14585 .46027 L
.14685 .4575 L
.14785 .46218 L
Mistroke
.14885 .47175 L
.14985 .40943 L
.15085 .40882 L
.15185 .40408 L
.15285 .39656 L
.15385 .3872 L
.15485 .37674 L
.15584 .36577 L
.15684 .35471 L
.15784 .34385 L
.15884 .33337 L
.15984 .32336 L
.16084 .31386 L
.16184 .30488 L
.16284 .29639 L
.16384 .28836 L
.16484 .28076 L
.16583 .27356 L
.16683 .26673 L
.16783 .26024 L
.16883 .25408 L
.16983 .24824 L
.17083 .2427 L
.17183 .23747 L
.17283 .23255 L
.17383 .22795 L
.17483 .22369 L
.17582 .21978 L
.17682 .21627 L
.17782 .21318 L
.17882 .21056 L
.17982 .20848 L
.18082 .207 L
.18182 .20621 L
.18282 .20618 L
.18382 .20703 L
.18482 .20888 L
.18581 .21183 L
.18681 .21604 L
.18781 .22162 L
.18881 .22872 L
.18981 .23745 L
.19081 .24795 L
.19181 .2603 L
.19281 .27457 L
.19381 .29079 L
.19481 .30892 L
.1958 .32887 L
.1968 .35042 L
.1978 .37329 L
Mistroke
.1988 .39705 L
.1998 .17972 L
.2008 .18832 L
.2018 .19735 L
.2028 .20762 L
.2038 .21948 L
.2048 .23317 L
.20579 .2488 L
.20679 .26643 L
.20779 .28595 L
.20879 .30711 L
.20979 .3295 L
.21079 .35251 L
.21179 .37538 L
.21279 .39722 L
.21379 .41709 L
.21479 .43408 L
.21578 .44745 L
.21678 .45671 L
.21778 .46167 L
.21878 .4625 L
.21978 .45963 L
.22078 .45367 L
.22178 .44529 L
.22278 .43513 L
.22378 .42375 L
.22478 .41162 L
.22577 .39911 L
.22677 .38654 L
.22777 .37416 L
.22877 .36215 L
.22977 .35064 L
.23077 .3397 L
.23177 .32934 L
.23277 .31958 L
.23377 .3104 L
.23477 .30176 L
.23576 .29363 L
.23676 .28597 L
.23776 .27876 L
.23876 .27197 L
.23976 .26558 L
.24076 .25958 L
.24176 .25395 L
.24276 .24872 L
.24376 .24386 L
.24476 .23942 L
.24575 .23539 L
.24675 .23182 L
.24775 .22874 L
Mistroke
.24875 .22619 L
.24975 .24194 L
.25075 .24493 L
.25175 .24714 L
.25275 .2493 L
.25375 .25165 L
.25475 .25433 L
.25574 .25746 L
.25674 .26111 L
.25774 .26533 L
.25874 .27019 L
.25974 .27572 L
.26074 .28194 L
.26174 .28883 L
.26274 .29637 L
.26374 .30451 L
.26474 .31314 L
.26573 .32217 L
.26673 .33143 L
.26773 .34076 L
.26873 .34996 L
.26973 .35883 L
.27073 .36714 L
.27173 .37472 L
.27273 .38136 L
.27373 .38694 L
.27473 .39134 L
.27572 .39451 L
.27672 .39646 L
.27772 .39724 L
.27872 .39694 L
.27972 .39569 L
.28072 .39364 L
.28172 .39092 L
.28272 .38767 L
.28372 .38402 L
.28472 .38004 L
.28571 .3758 L
.28671 .37137 L
.28771 .36678 L
.28871 .36207 L
.28971 .35727 L
.29071 .35241 L
.29171 .34752 L
.29271 .34264 L
.29371 .3378 L
.29471 .33302 L
.2957 .32834 L
.2967 .32378 L
.2977 .31937 L
Mistroke
.2987 .31515 L
.2997 .24994 L
.3007 .24871 L
.3017 .24651 L
.3027 .244 L
.3037 .24143 L
.3047 .2389 L
.30569 .23649 L
.30669 .23428 L
.30769 .23232 L
.30869 .23066 L
.30969 .22937 L
.31069 .22851 L
.31169 .22815 L
.31269 .22836 L
.31369 .22922 L
.31469 .23083 L
.31568 .23327 L
.31668 .23665 L
.31768 .24104 L
.31868 .24654 L
.31968 .25323 L
.32068 .26115 L
.32168 .27035 L
.32268 .28083 L
.32368 .29254 L
.32468 .3054 L
.32567 .31926 L
.32667 .33392 L
.32767 .34908 L
.32867 .36441 L
.32967 .37947 L
.33067 .39383 L
.33167 .407 L
.33267 .41852 L
.33367 .42799 L
.33467 .43513 L
.33566 .4398 L
.33666 .44208 L
.33766 .44228 L
.33866 .44094 L
.33966 .43883 L
.34066 .43678 L
.34166 .43549 L
.34266 .43515 L
.34366 .43542 L
.34466 .43559 L
.34565 .43497 L
.34665 .43308 L
.34765 .4297 L
Mistroke
.34865 .42482 L
.34965 .37368 L
.35065 .37597 L
.35165 .37575 L
.35265 .37381 L
.35365 .37056 L
.35465 .36627 L
.35564 .36118 L
.35664 .35551 L
.35764 .34942 L
.35864 .34306 L
.35964 .33653 L
.36064 .32994 L
.36164 .32334 L
.36264 .31679 L
.36364 .31032 L
.36464 .30398 L
.36563 .29776 L
.36663 .29169 L
.36763 .28579 L
.36863 .28005 L
.36963 .27448 L
.37063 .26911 L
.37163 .26392 L
.37263 .25893 L
.37363 .25415 L
.37463 .2496 L
.37562 .24529 L
.37662 .24124 L
.37762 .23748 L
.37862 .23404 L
.37962 .23095 L
.38062 .22826 L
.38162 .22602 L
.38262 .22429 L
.38362 .22313 L
.38462 .22264 L
.38561 .2229 L
.38661 .22401 L
.38761 .22607 L
.38861 .2292 L
.38961 .23351 L
.39061 .23912 L
.39161 .24614 L
.39261 .25469 L
.39361 .26485 L
.39461 .2767 L
.3956 .29029 L
.3966 .30563 L
.3976 .32267 L
Mistroke
.3986 .3413 L
.3996 .12569 L
.4006 .12834 L
.4016 .13012 L
.4026 .13176 L
.4036 .13355 L
.4046 .13567 L
.40559 .13832 L
.40659 .14168 L
.40759 .14595 L
.40859 .15137 L
.40959 .1582 L
.41059 .1667 L
.41159 .17717 L
.41259 .18988 L
.41359 .2051 L
.41459 .22302 L
.41558 .24377 L
.41658 .26735 L
.41758 .2936 L
.41858 .32214 L
.41958 .35236 L
.42058 .38334 L
.42158 .4139 L
.42258 .44262 L
.42358 .46801 L
.42458 .48861 L
.42557 .50333 L
.42657 .51163 L
.42757 .51378 L
.42857 .51107 L
.42957 .50567 L
.43057 .50013 L
.43157 .49576 L
.43257 .49166 L
.43357 .48605 L
.43457 .47789 L
.43556 .4671 L
.43656 .45426 L
.43756 .44017 L
.43856 .42565 L
.43956 .41142 L
.44056 .39801 L
.44156 .38575 L
.44256 .37486 L
.44356 .36538 L
.44456 .35728 L
.44555 .35045 L
.44655 .34476 L
.44755 .34005 L
Mistroke
.44855 .33615 L
.44955 .31503 L
.45055 .31325 L
.45155 .31073 L
.45255 .30805 L
.45355 .3054 L
.45455 .30283 L
.45554 .30037 L
.45654 .29804 L
.45754 .29585 L
.45854 .29383 L
.45954 .29198 L
.46054 .29031 L
.46154 .28884 L
.46254 .28759 L
.46354 .28658 L
.46454 .28582 L
.46553 .28534 L
.46653 .28515 L
.46753 .28528 L
.46853 .28574 L
.46953 .28655 L
.47053 .28773 L
.47153 .28929 L
.47253 .29125 L
.47353 .29361 L
.47453 .29638 L
.47552 .29955 L
.47652 .30312 L
.47752 .30707 L
.47852 .31136 L
.47952 .31599 L
.48052 .32088 L
.48152 .32601 L
.48252 .33131 L
.48352 .3367 L
.48452 .34213 L
.48551 .3475 L
.48651 .35273 L
.48751 .35775 L
.48851 .36248 L
.48951 .36684 L
.49051 .37079 L
.49151 .37427 L
.49251 .37727 L
.49351 .37978 L
.49451 .38183 L
.4955 .38346 L
.4965 .38472 L
.4975 .38569 L
Mistroke
.4985 .38645 L
.4995 .39445 L
.5005 .39978 L
.5015 .40151 L
.5025 .40056 L
.5035 .39745 L
.5045 .39263 L
.50549 .38653 L
.50649 .37952 L
.50749 .37191 L
.50849 .36396 L
.50949 .35587 L
.51049 .34779 L
.51149 .33982 L
.51249 .33202 L
.51349 .32444 L
.51449 .31709 L
.51548 .30999 L
.51648 .30313 L
.51748 .2965 L
.51848 .2901 L
.51948 .28392 L
.52048 .27794 L
.52148 .27217 L
.52248 .26658 L
.52348 .26117 L
.52448 .25594 L
.52547 .25089 L
.52647 .24601 L
.52747 .24131 L
.52847 .23678 L
.52947 .23243 L
.53047 .22827 L
.53147 .2243 L
.53247 .22053 L
.53347 .21697 L
.53447 .21364 L
.53546 .21057 L
.53646 .20776 L
.53746 .20526 L
.53846 .2031 L
.53946 .20132 L
.54046 .19998 L
.54146 .19914 L
.54246 .19888 L
.54346 .19928 L
.54446 .20045 L
.54545 .20249 L
.54645 .20556 L
.54745 .20977 L
Mistroke
.54845 .2153 L
.54945 .13818 L
.55045 .14148 L
.55145 .14422 L
.55245 .14717 L
.55345 .15066 L
.55445 .15493 L
.55544 .16022 L
.55644 .16678 L
.55744 .17487 L
.55844 .18475 L
.55944 .1967 L
.56044 .21095 L
.56144 .2277 L
.56244 .24705 L
.56344 .26899 L
.56444 .29336 L
.56543 .31981 L
.56643 .34776 L
.56743 .37637 L
.56843 .40459 L
.56943 .43118 L
.57043 .45483 L
.57143 .47433 L
.57243 .48876 L
.57343 .49767 L
.57443 .50128 L
.57542 .5005 L
.57642 .49675 L
.57742 .49142 L
.57842 .48516 L
.57942 .47777 L
.58042 .46878 L
.58142 .45804 L
.58242 .44579 L
.58342 .43253 L
.58442 .41883 L
.58541 .40522 L
.58641 .39213 L
.58741 .37986 L
.58841 .36859 L
.58941 .35842 L
.59041 .34935 L
.59141 .34134 L
.59241 .33433 L
.59341 .32823 L
.59441 .32295 L
.5954 .31841 L
.5964 .31452 L
.5974 .31123 L
Mistroke
.5984 .30846 L
.5994 .26073 L
.6004 .25977 L
.6014 .25805 L
.6024 .25621 L
.6034 .25447 L
.6044 .25293 L
.60539 .25165 L
.60639 .25069 L
.60739 .25009 L
.60839 .24991 L
.60939 .2502 L
.61039 .251 L
.61139 .25238 L
.61239 .25437 L
.61339 .25704 L
.61439 .26043 L
.61538 .26457 L
.61638 .2695 L
.61738 .27524 L
.61838 .28177 L
.61938 .28908 L
.62038 .29714 L
.62138 .30585 L
.62238 .31514 L
.62338 .32486 L
.62438 .33487 L
.62537 .34496 L
.62637 .35495 L
.62737 .36459 L
.62837 .37366 L
.62937 .38195 L
.63037 .38925 L
.63137 .39543 L
.63237 .40038 L
.63337 .40408 L
.63437 .40658 L
.63536 .408 L
.63636 .40855 L
.63736 .40844 L
.63836 .40791 L
.63936 .40712 L
.64036 .40618 L
.64136 .40507 L
.64236 .4037 L
.64336 .40195 L
.64436 .39971 L
.64535 .39689 L
.64635 .39347 L
.64735 .38945 L
Mistroke
.64835 .38487 L
.64935 .23968 L
.65035 .23887 L
.65135 .23708 L
.65235 .23497 L
.65335 .23279 L
.65435 .23064 L
.65534 .22862 L
.65634 .22677 L
.65734 .22518 L
.65834 .22389 L
.65934 .22295 L
.66034 .22245 L
.66134 .22244 L
.66234 .223 L
.66334 .22421 L
.66434 .22616 L
.66533 .22893 L
.66633 .23262 L
.66733 .2373 L
.66833 .24307 L
.66933 .24998 L
.67033 .25809 L
.67133 .26741 L
.67233 .27796 L
.67333 .28968 L
.67433 .30249 L
.67532 .31623 L
.67632 .33071 L
.67732 .34565 L
.67832 .36072 L
.67932 .37553 L
.68032 .38964 L
.68132 .40262 L
.68232 .41401 L
.68332 .42345 L
.68432 .43066 L
.68531 .4355 L
.68631 .43802 L
.68731 .43851 L
.68831 .4375 L
.68931 .43571 L
.69031 .43401 L
.69131 .43311 L
.69231 .43328 L
.69331 .43418 L
.69431 .43508 L
.6953 .43523 L
.6963 .43408 L
.6973 .43139 L
Mistroke
.6983 .42712 L
.6993 .34418 L
.7003 .33962 L
.7013 .3339 L
.7023 .32772 L
.7033 .32135 L
.7043 .31492 L
.70529 .30851 L
.70629 .30217 L
.70729 .29592 L
.70829 .28979 L
.70929 .28378 L
.71029 .27791 L
.71129 .27218 L
.71229 .26658 L
.71329 .26112 L
.71429 .25581 L
.71528 .25064 L
.71628 .24561 L
.71728 .24073 L
.71828 .236 L
.71928 .23142 L
.72028 .227 L
.72128 .22274 L
.72228 .21865 L
.72328 .21474 L
.72428 .21103 L
.72527 .20752 L
.72627 .20424 L
.72727 .20121 L
.72827 .19846 L
.72927 .19603 L
.73027 .19396 L
.73127 .19231 L
.73227 .19114 L
.73327 .19053 L
.73427 .19057 L
.73526 .19137 L
.73626 .19306 L
.73726 .19576 L
.73826 .19964 L
.73926 .20483 L
.74026 .21151 L
.74126 .21984 L
.74226 .22999 L
.74326 .2421 L
.74426 .25631 L
.74525 .27271 L
.74625 .29136 L
.74725 .31223 L
Mistroke
.74825 .33522 L
.74925 .14944 L
.75025 .16521 L
.75125 .18227 L
.75225 .20161 L
.75325 .2237 L
.75425 .2488 L
.75524 .27695 L
.75624 .30787 L
.75724 .34097 L
.75824 .37526 L
.75924 .40939 L
.76024 .4417 L
.76124 .47041 L
.76224 .49384 L
.76324 .51069 L
.76424 .52032 L
.76523 .52284 L
.76623 .51909 L
.76723 .51027 L
.76823 .49772 L
.76923 .48262 L
.77023 .46602 L
.77123 .44885 L
.77223 .43192 L
.77323 .41586 L
.77423 .40112 L
.77522 .38799 L
.77622 .37658 L
.77722 .36688 L
.77822 .35879 L
.77922 .35216 L
.78022 .34682 L
.78122 .34259 L
.78222 .33929 L
.78322 .33677 L
.78422 .33489 L
.78521 .33353 L
.78621 .33258 L
.78721 .33197 L
.78821 .33163 L
.78921 .33149 L
.79021 .3315 L
.79121 .33164 L
.79221 .33185 L
.79321 .33213 L
.79421 .33245 L
.7952 .3328 L
.7962 .33316 L
.7972 .33353 L
Mistroke
.7982 .33391 L
.7992 .29089 L
.8002 .29609 L
.8012 .30032 L
.8022 .30422 L
.8032 .30798 L
.8042 .31165 L
.80519 .31527 L
.80619 .31882 L
.80719 .3223 L
.80819 .32568 L
.80919 .32892 L
.81019 .33199 L
.81119 .33486 L
.81219 .33749 L
.81319 .33984 L
.81419 .34189 L
.81518 .34362 L
.81618 .345 L
.81718 .34604 L
.81818 .34673 L
.81918 .34707 L
.82018 .34708 L
.82118 .34678 L
.82218 .34618 L
.82318 .34532 L
.82418 .34423 L
.82517 .34295 L
.82617 .3415 L
.82717 .33992 L
.82817 .33825 L
.82917 .33653 L
.83017 .33477 L
.83117 .33303 L
.83217 .33132 L
.83317 .32968 L
.83417 .32813 L
.83516 .32669 L
.83616 .32539 L
.83716 .32424 L
.83816 .32327 L
.83916 .32249 L
.84016 .32192 L
.84116 .32157 L
.84216 .32144 L
.84316 .32156 L
.84416 .32192 L
.84515 .32254 L
.84615 .32341 L
.84715 .32453 L
Mistroke
.84815 .32591 L
.84915 .31982 L
.85015 .32849 L
.85115 .33554 L
.85215 .34158 L
.85315 .34672 L
.85415 .351 L
.85514 .35443 L
.85614 .35701 L
.85714 .35875 L
.85814 .35966 L
.85914 .35979 L
.86014 .35917 L
.86114 .35788 L
.86214 .35598 L
.86314 .35354 L
.86414 .35063 L
.86513 .34735 L
.86613 .34375 L
.86713 .33991 L
.86813 .33589 L
.86913 .33175 L
.87013 .32755 L
.87113 .32332 L
.87213 .31913 L
.87313 .31499 L
.87413 .31096 L
.87512 .30706 L
.87612 .30331 L
.87712 .29976 L
.87812 .29642 L
.87912 .29333 L
.88012 .29051 L
.88112 .28799 L
.88212 .2858 L
.88312 .28398 L
.88412 .28255 L
.88511 .28154 L
.88611 .281 L
.88711 .28095 L
.88811 .28143 L
.88911 .28246 L
.89011 .28409 L
.89111 .28634 L
.89211 .28924 L
.89311 .29279 L
.89411 .29702 L
.8951 .30192 L
.8961 .30748 L
.8971 .31369 L
Mistroke
.8981 .3205 L
.8991 .16344 L
.9001 .17152 L
.9011 .17956 L
.9021 .18841 L
.9031 .19849 L
.9041 .21008 L
.90509 .22342 L
.90609 .23867 L
.90709 .25593 L
.90809 .27519 L
.90909 .29628 L
.91009 .31889 L
.91109 .34254 L
.91209 .36655 L
.91309 .3901 L
.91409 .41225 L
.91508 .43205 L
.91608 .44862 L
.91708 .46128 L
.91808 .46966 L
.91908 .47374 L
.92008 .47387 L
.92108 .47064 L
.92208 .46475 L
.92308 .45683 L
.92408 .44738 L
.92507 .43679 L
.92607 .42539 L
.92707 .41349 L
.92807 .40141 L
.92907 .3894 L
.93007 .37769 L
.93107 .36646 L
.93207 .35579 L
.93307 .34576 L
.93407 .33637 L
.93506 .32764 L
.93606 .31952 L
.93706 .312 L
.93806 .30503 L
.93906 .2986 L
.94006 .29266 L
.94106 .2872 L
.94206 .28221 L
.94306 .27768 L
.94406 .2736 L
.94505 .26999 L
.94605 .26685 L
.94705 .26421 L
Mistroke
.94805 .26207 L
.94905 .21246 L
.95005 .21215 L
.95105 .21088 L
.95205 .20933 L
.95305 .20774 L
.95405 .20625 L
.95504 .20496 L
.95604 .20394 L
.95704 .20327 L
.95804 .20305 L
.95904 .20335 L
.96004 .20428 L
.96104 .20594 L
.96204 .20845 L
.96304 .21192 L
.96404 .21649 L
.96503 .22227 L
.96603 .22939 L
.96703 .23793 L
.96803 .24799 L
.96903 .25959 L
.97003 .27275 L
.97103 .2874 L
.97203 .30342 L
.97303 .32059 L
.97403 .33861 L
.97502 .35708 L
.97602 .37549 L
.97702 .39326 L
.97802 .40977 L
.97902 .42438 L
.98002 .43651 L
.98102 .44572 L
.98202 .45176 L
.98302 .45469 L
.98402 .45488 L
.98501 .45311 L
.98601 .45049 L
.98701 .44826 L
.98801 .44726 L
.98901 .44741 L
.99001 .4478 L
.99101 .44734 L
.99201 .44529 L
.99301 .4413 L
.99401 .4354 L
.995 .42783 L
.996 .41895 L
.997 .40914 L
Mistroke
.998 .39877 L
.999 .29229 L
Mfstroke
1 0 0 r
gsave
.999 .28598 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00166 L
.004 .00164 L
.005 .00164 L
.00599 .00167 L
.00699 .00173 L
.00799 .00183 L
.00899 .00199 L
.00999 .00221 L
.01099 .00251 L
.01199 .00291 L
.01299 .00343 L
.01399 .00412 L
.01499 .005 L
.01598 .00614 L
.01698 .00759 L
.01798 .00943 L
.01898 .01177 L
.01998 .01473 L
.02098 .01847 L
.02198 .02316 L
.02298 .02903 L
.02398 .03636 L
.02498 .04546 L
.02597 .05669 L
.02697 .07045 L
.02797 .08715 L
.02897 .10719 L
.02997 .13093 L
.03097 .15856 L
.03197 .19005 L
.03297 .22506 L
.03397 .26281 L
.03497 .30212 L
.03596 .34143 L
.03696 .37903 L
.03796 .41338 L
.03896 .44334 L
.03996 .46838 L
.04096 .48838 L
.04196 .50334 L
.04296 .51297 L
.04396 .51663 L
.04496 .51358 L
.04595 .50353 L
.04695 .48716 L
.04795 .46621 L
.04895 .44313 L
Mistroke
.04995 .40915 L
.05095 .45691 L
.05195 .4996 L
.05295 .53374 L
.05395 .5564 L
.05495 .56592 L
.05594 .56238 L
.05694 .5477 L
.05794 .5251 L
.05894 .4983 L
.05994 .47069 L
.06094 .44484 L
.06194 .42232 L
.06294 .40383 L
.06394 .38942 L
.06494 .37876 L
.06593 .37133 L
.06693 .36653 L
.06793 .36376 L
.06893 .36246 L
.06993 .36213 L
.07093 .36233 L
.07193 .3627 L
.07293 .36294 L
.07393 .36287 L
.07493 .36235 L
.07592 .36135 L
.07692 .35985 L
.07792 .35793 L
.07892 .35567 L
.07992 .35314 L
.08092 .35046 L
.08192 .34769 L
.08292 .3449 L
.08392 .34213 L
.08492 .3394 L
.08591 .3367 L
.08691 .33405 L
.08791 .3314 L
.08891 .32875 L
.08991 .32606 L
.09091 .32331 L
.09191 .32049 L
.09291 .31756 L
.09391 .31454 L
.09491 .3114 L
.0959 .30815 L
.0969 .30479 L
.0979 .30135 L
.0989 .29782 L
Mistroke
.0999 .23186 L
.1009 .22574 L
.1019 .21983 L
.1029 .21412 L
.1039 .20862 L
.1049 .20334 L
.10589 .19827 L
.10689 .19344 L
.10789 .18883 L
.10889 .18446 L
.10989 .18034 L
.11089 .17649 L
.11189 .17292 L
.11289 .16964 L
.11389 .16668 L
.11489 .16407 L
.11588 .16183 L
.11688 .16 L
.11788 .15861 L
.11888 .15772 L
.11988 .15738 L
.12088 .15763 L
.12188 .15855 L
.12288 .1602 L
.12388 .16266 L
.12488 .16599 L
.12587 .17028 L
.12687 .17559 L
.12787 .18197 L
.12887 .18947 L
.12987 .1981 L
.13087 .20785 L
.13187 .21864 L
.13287 .23038 L
.13387 .2429 L
.13487 .25599 L
.13586 .2694 L
.13686 .28287 L
.13786 .2961 L
.13886 .30884 L
.13986 .32088 L
.14086 .33205 L
.14186 .34225 L
.14286 .35142 L
.14386 .35951 L
.14486 .36648 L
.14585 .37223 L
.14685 .37664 L
.14785 .37956 L
.14885 .38083 L
Mistroke
.14985 .4031 L
.15085 .39833 L
.15185 .39038 L
.15285 .38008 L
.15385 .36824 L
.15485 .35555 L
.15584 .34257 L
.15684 .32971 L
.15784 .31725 L
.15884 .30533 L
.15984 .29404 L
.16084 .2834 L
.16184 .27337 L
.16284 .26392 L
.16384 .25502 L
.16484 .2466 L
.16583 .23864 L
.16683 .23108 L
.16783 .2239 L
.16883 .21706 L
.16983 .21056 L
.17083 .20437 L
.17183 .19848 L
.17283 .19288 L
.17383 .18757 L
.17483 .18254 L
.17582 .17781 L
.17682 .17336 L
.17782 .16921 L
.17882 .16536 L
.17982 .16184 L
.18082 .15865 L
.18182 .15581 L
.18282 .15334 L
.18382 .15128 L
.18482 .14964 L
.18581 .14846 L
.18681 .14777 L
.18781 .14761 L
.18881 .14803 L
.18981 .14904 L
.19081 .15071 L
.19181 .15304 L
.19281 .15608 L
.19381 .15981 L
.19481 .16425 L
.1958 .16935 L
.1968 .17506 L
.1978 .18128 L
.1988 .18788 L
Mistroke
.1998 .17337 L
.2008 .17806 L
.2018 .18427 L
.2028 .19206 L
.2038 .20151 L
.2048 .21265 L
.20579 .22549 L
.20679 .23999 L
.20779 .25604 L
.20879 .27342 L
.20979 .29182 L
.21079 .31082 L
.21179 .32987 L
.21279 .34832 L
.21379 .36548 L
.21479 .38063 L
.21578 .39313 L
.21678 .40247 L
.21778 .40831 L
.21878 .41055 L
.21978 .40935 L
.22078 .40503 L
.22178 .39809 L
.22278 .3891 L
.22378 .37863 L
.22478 .36722 L
.22577 .35534 L
.22677 .34335 L
.22777 .33151 L
.22877 .32 L
.22977 .30893 L
.23077 .29836 L
.23177 .2883 L
.23277 .27874 L
.23377 .26968 L
.23477 .26107 L
.23576 .25289 L
.23676 .24512 L
.23776 .23772 L
.23876 .23067 L
.23976 .22396 L
.24076 .21757 L
.24176 .21149 L
.24276 .20571 L
.24376 .20024 L
.24476 .19506 L
.24575 .19018 L
.24675 .18561 L
.24775 .18135 L
.24875 .17742 L
Mistroke
.24975 .23562 L
.25075 .23466 L
.25175 .23409 L
.25275 .23394 L
.25375 .23422 L
.25475 .23497 L
.25574 .2362 L
.25674 .23793 L
.25774 .24018 L
.25874 .24295 L
.25974 .24625 L
.26074 .25007 L
.26174 .25442 L
.26274 .25925 L
.26374 .26455 L
.26474 .27025 L
.26573 .27629 L
.26673 .2826 L
.26773 .28907 L
.26873 .29559 L
.26973 .30205 L
.27073 .30831 L
.27173 .31425 L
.27273 .31974 L
.27373 .32464 L
.27473 .32887 L
.27572 .33233 L
.27672 .33497 L
.27772 .33673 L
.27872 .33761 L
.27972 .33763 L
.28072 .33681 L
.28172 .33522 L
.28272 .33291 L
.28372 .32996 L
.28472 .32645 L
.28571 .32247 L
.28671 .3181 L
.28771 .31341 L
.28871 .30847 L
.28971 .30335 L
.29071 .2981 L
.29171 .29278 L
.29271 .28743 L
.29371 .28209 L
.29471 .27678 L
.2957 .27154 L
.2967 .26639 L
.2977 .26135 L
.2987 .25643 L
Mistroke
.2997 .24362 L
.3007 .2385 L
.3017 .23358 L
.3027 .22888 L
.3037 .22443 L
.3047 .22022 L
.30569 .21627 L
.30669 .21261 L
.30769 .20925 L
.30869 .20621 L
.30969 .20352 L
.31069 .20119 L
.31169 .19926 L
.31269 .19776 L
.31369 .19672 L
.31469 .19619 L
.31568 .19621 L
.31668 .19681 L
.31768 .19805 L
.31868 .19997 L
.31968 .20262 L
.32068 .20604 L
.32168 .21029 L
.32268 .21538 L
.32368 .22135 L
.32468 .22819 L
.32567 .23589 L
.32667 .24442 L
.32767 .25371 L
.32867 .26365 L
.32967 .27412 L
.33067 .28495 L
.33167 .29594 L
.33267 .30689 L
.33367 .31755 L
.33467 .32769 L
.33566 .3371 L
.33666 .34555 L
.33766 .35287 L
.33866 .35892 L
.33966 .36358 L
.34066 .36677 L
.34166 .36848 L
.34266 .3687 L
.34366 .36748 L
.34466 .36492 L
.34565 .36112 L
.34665 .35623 L
.34765 .35043 L
.34865 .34388 L
Mistroke
.34965 .36737 L
.35065 .36567 L
.35165 .36257 L
.35265 .35824 L
.35365 .35291 L
.35465 .34676 L
.35564 .34001 L
.35664 .33282 L
.35764 .32536 L
.35864 .31773 L
.35964 .31006 L
.36064 .30241 L
.36164 .29484 L
.36264 .2874 L
.36364 .2801 L
.36464 .27298 L
.36563 .26605 L
.36663 .25931 L
.36763 .25276 L
.36863 .24641 L
.36963 .24026 L
.37063 .23431 L
.37163 .22857 L
.37263 .22303 L
.37363 .21769 L
.37463 .21256 L
.37562 .20765 L
.37662 .20295 L
.37762 .19848 L
.37862 .19423 L
.37962 .19023 L
.38062 .18648 L
.38162 .18299 L
.38262 .17978 L
.38362 .17686 L
.38462 .17427 L
.38561 .17201 L
.38661 .17011 L
.38761 .1686 L
.38861 .16751 L
.38961 .16688 L
.39061 .16673 L
.39161 .16709 L
.39261 .16801 L
.39361 .16951 L
.39461 .17162 L
.3956 .17435 L
.3966 .1777 L
.3976 .18167 L
.3986 .18623 L
Mistroke
.3996 .11935 L
.4006 .11815 L
.4016 .11728 L
.4026 .11677 L
.4036 .11668 L
.4046 .11708 L
.40559 .11805 L
.40659 .11967 L
.40759 .12205 L
.40859 .12531 L
.40959 .12957 L
.41059 .13498 L
.41159 .14169 L
.41259 .14988 L
.41359 .15972 L
.41459 .17136 L
.41558 .18494 L
.41658 .20057 L
.41758 .21828 L
.41858 .23802 L
.41958 .25961 L
.42058 .28272 L
.42158 .30687 L
.42258 .3314 L
.42358 .3555 L
.42458 .37827 L
.42557 .39877 L
.42657 .41615 L
.42757 .42972 L
.42857 .43903 L
.42957 .44392 L
.43057 .44454 L
.43157 .44128 L
.43257 .43475 L
.43357 .42566 L
.43457 .41475 L
.43556 .40276 L
.43656 .39029 L
.43756 .37786 L
.43856 .36585 L
.43956 .35448 L
.44056 .34391 L
.44156 .33418 L
.44256 .32529 L
.44356 .31718 L
.44456 .30979 L
.44555 .30305 L
.44655 .29688 L
.44755 .2912 L
.44855 .28596 L
Mistroke
.44955 .30871 L
.45055 .303 L
.45155 .29771 L
.45255 .29279 L
.45355 .28818 L
.45455 .28385 L
.45554 .27978 L
.45654 .27594 L
.45754 .27232 L
.45854 .26892 L
.45954 .26571 L
.46054 .26271 L
.46154 .25992 L
.46254 .25733 L
.46354 .25495 L
.46454 .25279 L
.46553 .25084 L
.46653 .24913 L
.46753 .24766 L
.46853 .24643 L
.46953 .24546 L
.47053 .24475 L
.47153 .24431 L
.47253 .24416 L
.47353 .24429 L
.47453 .24471 L
.47552 .24544 L
.47652 .24646 L
.47752 .24779 L
.47852 .24941 L
.47952 .25133 L
.48052 .25353 L
.48152 .25601 L
.48252 .25874 L
.48352 .26171 L
.48452 .26488 L
.48551 .26824 L
.48651 .27174 L
.48751 .27534 L
.48851 .27902 L
.48951 .28272 L
.49051 .28641 L
.49151 .29002 L
.49251 .29353 L
.49351 .29688 L
.49451 .30004 L
.4955 .30295 L
.4965 .30559 L
.4975 .30791 L
.4985 .30988 L
Mistroke
.4995 .38813 L
.5005 .38951 L
.5015 .38839 L
.5025 .38509 L
.5035 .37993 L
.5045 .37331 L
.50549 .3656 L
.50649 .35714 L
.50749 .34823 L
.50849 .33912 L
.50949 .32997 L
.51049 .32094 L
.51149 .3121 L
.51249 .30352 L
.51349 .29522 L
.51449 .2872 L
.51548 .27949 L
.51648 .27205 L
.51748 .26488 L
.51848 .25798 L
.51948 .25132 L
.52048 .24489 L
.52148 .23868 L
.52248 .23268 L
.52348 .22688 L
.52448 .22128 L
.52547 .21587 L
.52647 .21065 L
.52747 .20561 L
.52847 .20076 L
.52947 .19609 L
.53047 .19162 L
.53147 .18733 L
.53247 .18323 L
.53347 .17934 L
.53447 .17565 L
.53546 .17219 L
.53646 .16895 L
.53746 .16596 L
.53846 .16323 L
.53946 .16079 L
.54046 .15865 L
.54146 .15686 L
.54246 .15543 L
.54346 .15441 L
.54446 .15385 L
.54545 .15379 L
.54645 .15429 L
.54745 .15543 L
.54845 .15726 L
Mistroke
.54945 .13185 L
.55045 .13129 L
.55145 .13135 L
.55245 .1321 L
.55345 .13362 L
.55445 .136 L
.55544 .13935 L
.55644 .1438 L
.55744 .14949 L
.55844 .15656 L
.55944 .16516 L
.56044 .17546 L
.56144 .18758 L
.56244 .20163 L
.56344 .21768 L
.56444 .23571 L
.56543 .25562 L
.56643 .27716 L
.56743 .29996 L
.56843 .32347 L
.56943 .34698 L
.57043 .36966 L
.57143 .3906 L
.57243 .4089 L
.57343 .42378 L
.57443 .43463 L
.57542 .44114 L
.57642 .44328 L
.57742 .44134 L
.57842 .43585 L
.57942 .42749 L
.58042 .41701 L
.58142 .40517 L
.58242 .39262 L
.58342 .37991 L
.58442 .36743 L
.58541 .35547 L
.58641 .3442 L
.58741 .3337 L
.58841 .32399 L
.58941 .31503 L
.59041 .30678 L
.59141 .29918 L
.59241 .29215 L
.59341 .28565 L
.59441 .27961 L
.5954 .27399 L
.5964 .26874 L
.5974 .26383 L
.5984 .25924 L
Mistroke
.5994 .25442 L
.6004 .24956 L
.6014 .24514 L
.6024 .24112 L
.6034 .2375 L
.6044 .23425 L
.60539 .23139 L
.60639 .22891 L
.60739 .22682 L
.60839 .22513 L
.60939 .22386 L
.61039 .22302 L
.61139 .22263 L
.61239 .22271 L
.61339 .22328 L
.61439 .22437 L
.61538 .22599 L
.61638 .22816 L
.61738 .23091 L
.61838 .23423 L
.61938 .23814 L
.62038 .24263 L
.62138 .24768 L
.62238 .25327 L
.62338 .25937 L
.62438 .2659 L
.62537 .27281 L
.62637 .28 L
.62737 .28736 L
.62837 .29479 L
.62937 .30216 L
.63037 .30932 L
.63137 .31614 L
.63237 .3225 L
.63337 .32826 L
.63437 .33332 L
.63536 .33759 L
.63636 .34098 L
.63736 .34346 L
.63836 .34499 L
.63936 .34558 L
.64036 .34524 L
.64136 .34402 L
.64236 .34197 L
.64336 .33915 L
.64436 .33566 L
.64535 .33158 L
.64635 .327 L
.64735 .322 L
.64835 .31668 L
Mistroke
.64935 .23337 L
.65035 .22869 L
.65135 .22423 L
.65235 .21999 L
.65335 .21598 L
.65435 .21221 L
.65534 .2087 L
.65634 .20547 L
.65734 .20252 L
.65834 .19989 L
.65934 .19759 L
.66034 .19565 L
.66134 .1941 L
.66234 .19296 L
.66334 .19227 L
.66434 .19208 L
.66533 .19241 L
.66633 .19331 L
.66733 .19483 L
.66833 .19702 L
.66933 .19991 L
.67033 .20355 L
.67133 .20798 L
.67233 .21323 L
.67333 .21932 L
.67433 .22626 L
.67532 .23402 L
.67632 .24258 L
.67732 .25187 L
.67832 .2618 L
.67932 .27224 L
.68032 .28304 L
.68132 .29401 L
.68232 .30495 L
.68332 .31565 L
.68432 .32588 L
.68531 .33542 L
.68631 .34407 L
.68731 .35165 L
.68831 .35802 L
.68931 .36304 L
.69031 .36665 L
.69131 .36879 L
.69231 .36948 L
.69331 .36874 L
.69431 .36664 L
.6953 .3633 L
.6963 .35885 L
.6973 .35344 L
.6983 .34726 L
Mistroke
.6993 .33787 L
.7003 .32943 L
.7013 .321 L
.7023 .31266 L
.7033 .30446 L
.7043 .29644 L
.70529 .28862 L
.70629 .28101 L
.70729 .27361 L
.70829 .26643 L
.70929 .25946 L
.71029 .25271 L
.71129 .24615 L
.71229 .23979 L
.71329 .23362 L
.71429 .22764 L
.71528 .22185 L
.71628 .21624 L
.71728 .2108 L
.71828 .20554 L
.71928 .20046 L
.72028 .19556 L
.72128 .19083 L
.72228 .18628 L
.72328 .1819 L
.72428 .17772 L
.72527 .17373 L
.72627 .16993 L
.72727 .16634 L
.72827 .16296 L
.72927 .15982 L
.73027 .15692 L
.73127 .15428 L
.73227 .15192 L
.73327 .14988 L
.73427 .14818 L
.73526 .14684 L
.73626 .14593 L
.73726 .14547 L
.73826 .14551 L
.73926 .14612 L
.74026 .14736 L
.74126 .14929 L
.74226 .15199 L
.74326 .15552 L
.74426 .15996 L
.74525 .16539 L
.74625 .17186 L
.74725 .17941 L
.74825 .18808 L
Mistroke
.74925 .14308 L
.75025 .15495 L
.75125 .16914 L
.75225 .18584 L
.75325 .20522 L
.75425 .22732 L
.75524 .25208 L
.75624 .27924 L
.75724 .30832 L
.75824 .33856 L
.75924 .36893 L
.76024 .39815 L
.76124 .42478 L
.76224 .44735 L
.76324 .46461 L
.76424 .47566 L
.76523 .48016 L
.76623 .47835 L
.76723 .47103 L
.76823 .45938 L
.76923 .44476 L
.77023 .42851 L
.77123 .41176 L
.77223 .39538 L
.77323 .37995 L
.77423 .36581 L
.77522 .3531 L
.77622 .34181 L
.77722 .33187 L
.77822 .32314 L
.77922 .31548 L
.78022 .30875 L
.78122 .30282 L
.78222 .29755 L
.78322 .29286 L
.78422 .28866 L
.78521 .28487 L
.78621 .28144 L
.78721 .27833 L
.78821 .27549 L
.78921 .2729 L
.79021 .27053 L
.79121 .26838 L
.79221 .26642 L
.79321 .26465 L
.79421 .26306 L
.7952 .26166 L
.7962 .26044 L
.7972 .25939 L
.7982 .25854 L
Mistroke
.7992 .28456 L
.8002 .28586 L
.8012 .28734 L
.8022 .28896 L
.8032 .29068 L
.8042 .29246 L
.80519 .29427 L
.80619 .29606 L
.80719 .2978 L
.80819 .29946 L
.80919 .30101 L
.81019 .3024 L
.81119 .30361 L
.81219 .30463 L
.81319 .30542 L
.81419 .30598 L
.81518 .30628 L
.81618 .30633 L
.81718 .30612 L
.81818 .30565 L
.81918 .30492 L
.82018 .30396 L
.82118 .30277 L
.82218 .30137 L
.82318 .29978 L
.82418 .29801 L
.82517 .29609 L
.82617 .29405 L
.82717 .29189 L
.82817 .28966 L
.82917 .28735 L
.83017 .28501 L
.83117 .28265 L
.83217 .28028 L
.83317 .27792 L
.83417 .27561 L
.83516 .27333 L
.83616 .27113 L
.83716 .269 L
.83816 .26697 L
.83916 .26504 L
.84016 .26323 L
.84116 .26155 L
.84216 .26001 L
.84316 .25861 L
.84416 .25738 L
.84515 .25631 L
.84615 .25542 L
.84715 .25472 L
.84815 .2542 L
Mistroke
.84915 .31349 L
.85015 .31825 L
.85115 .32252 L
.85215 .32623 L
.85315 .3293 L
.85415 .33168 L
.85514 .33333 L
.85614 .33423 L
.85714 .33439 L
.85814 .33381 L
.85914 .33255 L
.86014 .33064 L
.86114 .32815 L
.86214 .32513 L
.86314 .32167 L
.86414 .31782 L
.86513 .31366 L
.86613 .30925 L
.86713 .30466 L
.86813 .29993 L
.86913 .29511 L
.87013 .29025 L
.87113 .28539 L
.87213 .28055 L
.87313 .27577 L
.87413 .27107 L
.87512 .26648 L
.87612 .262 L
.87712 .25767 L
.87812 .25348 L
.87912 .24947 L
.88012 .24564 L
.88112 .24201 L
.88212 .23859 L
.88312 .2354 L
.88412 .23244 L
.88511 .22974 L
.88611 .22731 L
.88711 .22516 L
.88811 .22332 L
.88911 .22179 L
.89011 .22059 L
.89111 .21974 L
.89211 .21926 L
.89311 .21917 L
.89411 .21947 L
.8951 .22018 L
.8961 .22132 L
.8971 .22289 L
.8981 .2249 L
Mistroke
.8991 .15711 L
.9001 .16131 L
.9011 .1666 L
.9021 .17312 L
.9031 .18098 L
.9041 .19029 L
.90509 .20116 L
.90609 .21366 L
.90709 .22783 L
.90809 .24362 L
.90909 .26095 L
.91009 .27961 L
.91109 .29928 L
.91209 .31953 L
.91309 .33979 L
.91409 .3594 L
.91508 .37764 L
.91608 .39378 L
.91708 .40715 L
.91808 .41723 L
.91908 .42367 L
.92008 .4264 L
.92108 .42555 L
.92208 .42148 L
.92308 .41472 L
.92408 .40586 L
.92507 .39551 L
.92607 .38424 L
.92707 .37253 L
.92807 .36077 L
.92907 .34922 L
.93007 .33808 L
.93107 .32745 L
.93207 .31738 L
.93307 .30789 L
.93407 .29896 L
.93506 .29055 L
.93606 .28264 L
.93706 .27518 L
.93806 .26813 L
.93906 .26147 L
.94006 .25515 L
.94106 .24917 L
.94206 .24349 L
.94306 .23811 L
.94406 .23301 L
.94505 .2282 L
.94605 .22365 L
.94705 .21939 L
.94805 .2154 L
Mistroke
.94905 .20616 L
.95005 .20199 L
.95105 .19806 L
.95205 .19439 L
.95305 .191 L
.95405 .18791 L
.95504 .18514 L
.95604 .18271 L
.95704 .18065 L
.95804 .179 L
.95904 .17779 L
.96004 .17706 L
.96104 .17686 L
.96204 .17724 L
.96304 .17826 L
.96404 .17998 L
.96503 .18246 L
.96603 .18577 L
.96703 .18998 L
.96803 .19514 L
.96903 .20132 L
.97003 .20856 L
.97103 .21689 L
.97203 .22632 L
.97303 .23681 L
.97403 .24831 L
.97502 .2607 L
.97602 .27382 L
.97702 .28745 L
.97802 .30134 L
.97902 .31519 L
.98002 .32866 L
.98102 .34142 L
.98202 .35312 L
.98302 .36347 L
.98402 .3722 L
.98501 .37911 L
.98601 .38406 L
.98701 .387 L
.98801 .38793 L
.98901 .38692 L
.99001 .38412 L
.99101 .37972 L
.99201 .37393 L
.99301 .36702 L
.99401 .35924 L
.995 .35084 L
.996 .34205 L
.997 .33307 L
.998 .32406 L
Mistroke
.999 .28598 L
Mfstroke
0 0 0 r
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{683.75, 281.688},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:[00016B000`400?l00000o`00003oo`3ooooo
0?ooojd0oooo003o0?ooool0oooo[@3oool00?l0ooooo`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo
003o0?ooool0oooo[@3oool00?l0ooooo`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo001D0?ooo`D0
00000`3oool2000000@0oooo0P00000B0?ooo`<000000`3oool2000000@0oooo0P00000A0?ooo`<0
0000103oool2000000@0oooo0P00000A0?ooo`<00000103oool2000000@0oooo0P00000>0?ooo`<0
0000103oool2000000@0oooo0P0000040?ooo`800000=P3oool5000000<0oooo0P0000040?ooo`80
00004P3oool3000000<0oooo0P0000040?ooo`8000004@3oool3000000@0oooo0P0000040?ooo`80
00004@3oool3000000@0oooo0P0000040?ooo`8000003P3oool3000000@0oooo0P0000040?ooo`80
0000103oool2000003<0oooo1@0000030?ooo`800000103oool200000180oooo0`0000030?ooo`80
0000103oool200000140oooo0`0000040?ooo`800000103oool200000140oooo0`0000040?ooo`80
0000103oool2000000h0oooo0`0000040?ooo`800000103oool2000000@0oooo0P00000e0?ooo`00
E@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000004P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0=0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000l0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003P3oool00`000000
oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000f0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo00d0oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003`3oool01@00
0000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000>0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000003<0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000180oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool03@3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000=03oool005H0
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000l0oooo1@0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
3`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo000000h0oooo00<000000?ooo`3oool00P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000=`3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00003`3oool500000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000l0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000003P3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000d0?oo
o`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000?0?ooo`D000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000l0
oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000003`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000>0?ooo`030000003oool0oooo0080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003@0oooo
001G0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo00d0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000l0oooo100000030?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool00000403oool3000000<0oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000>0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003P0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool03@3oool0
10000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00003`3oool4000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000@
0?ooo`<000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000h0oooo
00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool000000080oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000<0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`@000000`3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000100oooo0`0000030?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000003P3oool00`000000oooo0?ooo`020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000d0?ooo`00E03oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000@0?ooo`030000003oool0000000<0oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`030000003oool0oooo00@0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`050000003oool0oooo0?oo
o`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000h0oooo00<0
00000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool000000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`00000@0?ooo`030000003oool0000000<0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`030000003oool0oooo
00@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
00h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool00000<P3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000@0?ooo`030000003oool0
000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?oo
o`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo000000h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool00000=03oool005@0oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
4@3oool2000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000@0?oo
o`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000d0oooo0P0000040?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`00000e0?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000140oooo0P000003
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000403oool00`000000oooo
0?ooo`030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003`3oool01@00
0000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000=0?ooo`800000103oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool00000<P3oool01@000000oooo0?ooo`3oool000000080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`00000A0?ooo`8000000`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000100oooo00<000000?ooo`3oool00`3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000l0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003@3oool2
000000@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000003@0oooo001E0?ooo`<00000103oool2000000@0oooo0P00000C0?ooo`030000
003oool0oooo0080oooo0P0000040?ooo`8000004P3oool2000000@0oooo0P0000040?ooo`800000
4@3oool3000000@0oooo0P0000040?ooo`8000003`3oool00`000000oooo0?ooo`030?ooo`800000
103oool2000000@0oooo0P00000g0?ooo`<00000103oool2000000@0oooo0P00000C0?ooo`030000
003oool0oooo0080oooo0P0000040?ooo`8000004P3oool2000000@0oooo0P0000040?ooo`800000
4@3oool3000000@0oooo0P0000040?ooo`8000003`3oool00`000000oooo0?ooo`030?ooo`800000
103oool2000000@0oooo0P00000d0?ooo`<00000103oool2000000@0oooo0P00000C0?ooo`030000
003oool0oooo0080oooo0P0000040?ooo`8000004P3oool2000000@0oooo0P0000040?ooo`800000
4@3oool3000000@0oooo0P0000040?ooo`8000003`3oool00`000000oooo0?ooo`030?ooo`800000
103oool2000000@0oooo0P00000e0?ooo`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo[@3oool0
0?l0ooooo`3ooon]0?ooo`00?@3ooonQ000002P0ooooX@00000U0?oooj400000?P3oool003d0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo02H0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo02<0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo03`0oooo
000m0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`2M0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?oo
o`0l0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02H0oooo00<00000
0?ooo`3oool0W@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo09`0oooo0P00000n
0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool0W@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo09d0oooo00<000000?oo
o`3oool0?03oool003d0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`03
0000003oool0oooo09d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2L0?ooo`80
0000?P3oool003d0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000
003oool0oooo09d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2M0?ooo`030000
003oool0oooo03`0oooo000f0?ooo`<00000103oool00`000000oooo0?ooo`2M0?ooo`030000003o
ool0oooo01P0oooo1@0000020?ooo`<00000103oool00`000000oooo0?ooo`2M0?ooo`030000003o
ool0oooo02<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0l0?ooo`00=@3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?oo
o`0I0?ooo`060000003oool0oooo0000003oool000000`3oool01@000000oooo0?ooo`3oool00000
09l0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2L0?ooo`800000?P3oool003D0
oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo09d0oooo00<000000?oo
o`3oool06P3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo0000
002O0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?oo
o`0l0?ooo`00=@3oool4000000@0oooo0P00002M0?ooo`8000007@3oool00`000000oooo0?ooo`04
000000@0oooo0P00000F0?ooo`T00?ZJOP3oool2000001h0oooo0`0000040?ooo`030000003oool0
oooo09`0oooo0P00000n0?ooo`00=@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
09d0oooo00<000000?ooo`3oool0603oool01`000000oooo0?ooo`3oool000000?ooo`0000001`3o
ool00`000000oooo0?ooo`0E0?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0O@3o
ool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0W@3o
ool00`000000oooo0?ooo`0l0?ooo`00=P3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo09d0oooo00<000000?ooo`3oool0603oool01@000000oooo0?ooo`3oool000000080oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`0E0?ooo`03003jVP3oool0oooo00D0oooo00<0
0?ZJ0?ooo`3oool0O@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00<0oooo0P00
002M0?ooo`800000?P3oool003L0oooo0P0000040?ooo`030000003oool0oooo09d0oooo00<00000
0?ooo`3oool06@3oool3000000@0oooo0P0000040?ooo`030000003oool0oooo01D0oooo00<00?ZJ
0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`1m0?ooo`030000003oool0oooo01d0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`T00?ZJS`3oool00`000000oooo0?ooo`0l
0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool03@3oool9003jVPL0oooo2@00nYYg0?ooo`030000003oool0oooo01d0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?oo
o`3oool0S@3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`0E0?ooo`03
003jVP3oool0oooo07D0oooo00<000000?ooo`3oool0703oool2000000D0oooo00<000000?ooo`3o
ool01@3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo08`0oooo0P00000n0?ooo`00
?@3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0
3@3oool00`00nYX0oooo0?ooo`0E0?ooo`03003jVP3oool0oooo07D0oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0
1@3oool00`00nYX0oooo0?ooo`2=0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003o
ool0oooo09d0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0=0?ooo`03003jVP3o
ool0oooo01D0oooo00<00?ZJ0?ooo`3oool0M@3oool00`000000oooo0?ooo`0S0?ooo`030000003o
ool0oooo00D0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`2<0?ooo`800000?P3o
ool003d0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0
oooo00d0oooo00<00?ZJ0?ooo`3oool05@3oool00`00nYX0oooo0?ooo`1e0?ooo`030000003oool0
oooo02<0oooo00<000000?ooo`3oool0103oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3oool0
oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0W@3oool00`00
0000oooo0?ooo`0V0?ooo`030000003oool0oooo00d0oooo00<00?ZJ0?ooo`3oool05@3oool00`00
nYX0oooo0?ooo`1e0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0103oool00`00
nYX0oooo0?ooo`060?ooo`03003jVP3oool0oooo08d0oooo00<000000?ooo`3oool0?03oool003d0
oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?oooa400?ZJ5`3oool00`00nYX0
oooo0?ooo`0=0?oooa400?ZJE`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo00@0
oooo00<00?ZJ0?ooo`3oool01P3oool00`00nYX0oooo0?ooo`2<0?ooo`800000?P3oool003d0oooo
00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02D0oooo
2@00nYX70?ooo`03003jVP3oool0oooo00d0oooo2@00nYY?0?ooo`030000003oool0oooo02<0oooo
2000nYX80?ooo`03003jVP3oool0oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<0
00000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02d0oooo2@00
nYXG0?ooo`03003jVP3oool0oooo04d0oooo00<000000?ooo`3oool06`3oool5000000<0oooo00<0
00000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`2<0?ooo`800000?P3oool003d0oooo00<00000
0?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo04d0oooo2@00nYY7
0?ooo`030000003oool0oooo01`0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?oo
o`0=0?ooo`03003jVP3oool0oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<00000
0?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo05D0oooo6@00nYX_
0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0=
0?ooo`03003jVP3oool0oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?oo
o`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo01D0oooo2@3o001?0?oo
o`T00?ZJ9`3oool00`00nYX0oooo0?ooo`0N0?ooo`030000003oool0oooo0080oooo0P00000>0?oo
o`03003jVP3oool0oooo08`0oooo0P00000n0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool05@3oool00`3o0000oooo0?ooo`050?ooo`03
0?l0003oool0oooo05D0oooo2@00nYX?0?oooa400?ZJ7@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00<000000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`2=0?ooo`030000003oool0oooo
03`0oooo000f0?ooo`<00000103oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo01P0
oooo1@0000020?ooo`<00000103oool00`000000oooo0?ooo`0E0?ooo`030?l0003oool0oooo00D0
oooo00<0o`000?ooo`3oool0G@3ooolA003jVPl0oooo00<000000?ooo`3oool06`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`0e0?oo
o`T00?ZJCP3oool2000003h0oooo000e0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`2M0?ooo`030000003oool0oooo01T0oooo00H000000?ooo`3oool000000?ooo`00
00030?ooo`050000003oool0oooo0?ooo`0000005`3oool00`3o0000oooo0?ooo`050?ooo`T0o`00
M`3oool00`000000oooo0?ooo`0L0?ooo`<00000103oool00`000000oooo0?ooo`0=0?ooo`03003j
VP3oool0oooo02d0oooo2@00nYX70?ooo`T00?ZJA`3oool00`000000oooo0?ooo`0l0?ooo`00=@3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo
0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool00000
01L0oooo00<0o`000?ooo`3oool03@3oool00`3o0000oooo0?ooo`1e0?ooo`030000003oool0oooo
02<0oooo00<000000?ooo`3oool03@3oool9003jVRL0oooo00<00?ZJ0?ooo`3oool05@3oool9003j
VSl0oooo00<000000?ooo`3oool0?03oool003H0oooo0`0000040?ooo`800000W@3oool2000001d0
oooo00@000000?ooo`3oool0oooo0`0000040?oooaP0003o00<0o`000000o`000?l03@000?l00`3o
0000003o0000o`1f0000obD0oooo00<000000?ooo`3oool05@3oool00`00nYX0oooo0?ooo`0=0?oo
oaT00?ZJ7`3ooolQ003jVQh0oooo0P00000n0?ooo`00=@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0H0?ooo`070000003oool0oooo
0?ooo`000000oooo000000030?ooo`050000003oool0oooo0?ooo`0000005`3oool00`3o0000oooo
0?ooo`0=0?ooo`030?l0003oool0oooo01D0oooo2@3o001G0?ooo`030000003oool0oooo02<0oooo
00<000000?ooo`3oool05@3oool00`00nYX0oooo0?ooo`0=0?ooo`03003jVP3oool0oooo01d0oooo
2@3o000_0?ooob400?ZJ?P3oool003D0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000
003oool0oooo09d0oooo00<000000?ooo`3oool0603oool01`000000oooo0?ooo`3oool000000?oo
o`0000000`3oool01@000000oooo0?ooo`3oool0000000l0oooo2@3o000?0?ooo`030?l0003oool0
oooo00d0oooo2@3o00070?ooo`T0o`00C`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0
oooo01D0oooo00<00?ZJ0?ooo`3oool03@3oool00`00nYX0oooo0?ooo`0E0?ooo`T0o`001`3oool9
0?l004H0oooo00<00000003jVP3oool0?@3oool003H0oooo0`0000040?ooo`030000003oool0oooo
09d0oooo00<000000?ooo`3oool06@3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo
00d0oooo00<0o`000?ooo`3oool05@3oool00`3o0000oooo0?ooo`0=0?ooo`030?l0003oool0oooo
01D0oooo2@3o000?0?ooo`T0o`00;`3oool00`3o0000oooo0?ooo`0S0?oooaP0003o4@00nYXG0000
o`030?l000000?l0003o01D0003o<@3o000H0000och0oooo000m0?ooo`030000003oool0oooo09d0
oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0=0?ooo`030?l0003oool0oooo01D0
oooo00<0o`000?ooo`3oool03@3oool00`3o0000oooo0?ooo`0M0?oooa40o`001`3ooolA0?l000l0
oooo4@3o000U0?ooo`030000003oool0oooo03D0oooo2@3o00170?oooaT0o`00?P3oool003d0oooo
00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00d0oooo
00<0o`000?ooo`3oool05@3ooolA0?l004L0oooo00<0o`000?ooo`3oool03@3oool00`3o0000oooo
0?ooo`0=0?ooo`030000003oool0oooo01`0oooo0`0000040?ooo`030000003oool0oooo02D0oooo
4@3o000?0?ooo`T00?ZJCP3oool2000003h0oooo000m0?ooo`030000003oool0oooo09d0oooo00<0
00000?ooo`3oool09P3oool00`000000oooo0?ooo`0=0?ooo`030?l0003oool0oooo06d0oooo4@3o
000?0?ooo`030000003oool0oooo01/0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000
003oool0oooo00D0oooo4@3o000?0?ooo`030?l0003oool0oooo01D0oooo2@00nYX70?ooocT00?ZJ
5`3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`030000003o
ool0oooo02H0oooo00<000000?ooo`3oool03@3oool00`3o0000oooo0?ooo`2=0?ooo`030000003o
ool0oooo01l0oooo00@000000?ooo`3oool0oooo0P0000060?ooo`030?l0003oool0oooo00d0oooo
00<0o`000?ooo`3oool03@3oool00`3o0000oooo0?ooo`0E0?ooo`03003jVP3oool0oooo04D0oooo
6@00nYXn0?ooo`00?@3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool03@3oool00`3o0000oooo0?ooo`2=0?ooo`030000003oool0oooo01d0oooo0P00
00040?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool03@3oool00`3o0000oooo0?oo
o`0=0?ooo`030?l0003oool0oooo01D0oooo00<00?ZJ0?ooo`3oool0G@3oool00`000000oooo0?oo
o`0l0?ooo`00?@3oool00`000000oooo0?ooo`1M0?ooo`T00?ZJ=`3oool00`000000oooo0?ooo`0V
0?ooo`030000003oool0oooo00D0oooo2@3o002?0?ooo`030000003oool0oooo01l0oooo00D00000
0?ooo`3oool0oooo000000070?ooo`030?l0003oool0oooo00d0oooo00<0o`000?ooo`3oool03@3o
ool00`3o0000oooo0?ooo`0=0?ooo`T00?ZJG`3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool9
003jVUL0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`0e0?ooo`030000003oool0
oooo02H0oooo2@3o002G0?ooo`030000003oool0oooo01/0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool03@3ooolA0?l001000?ZJIP3o
ool2000003h0oooo000m0?ooo`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0E@3oool0
0`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo01D0oooo4@00nYX?0?ooo`030000003oool0
oooo02H0oooo00<000000?ooo`3oool05@3oool9003jVWl0oooo00<00?ZJ0?ooo`3oool0703oool3
000000@0oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`0M0?ooo`03003jVP3oool0
oooo07D0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool01@3oool9003j
VSL0oooo6@00nYX70?oooaT00?ZJ3`3oool9003jVPL0oooo00<000000?ooo`3oool09P3oool00`00
0000oooo0?ooo`0E0?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool07@3oool9003j
VQl0oooo2@00nYXW0?ooo`T00?ZJ9@3oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo
01h0oooo00<00?ZJ0?ooo`3oool0M03oool2000003h0oooo000m0?ooo`030000003oool0oooo00d0
oooo00<00?ZJ0?ooo`3oool03@3oool9003jVQL0oooo2@00nYY?0?ooo`T00?ZJ:03oool00`000000
oooo0?ooo`0E0?ooo`03003jVP3oool0oooo00D0oooo2@00nYXG0?ooo`03003jVP3oool0oooo00D0
oooo4@00nYX?0?ooo`03003jVP3oool0oooo00D0oooo4@00nYX?0?ooo`T00?ZJ1`3oool00`000000
oooo0?ooo`0S0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool01P3oool9003jVPl0
oooo00<00?ZJ0?ooo`3oool0M@3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo
0?ooo`0=0?ooo`03003jVP3oool0oooo00d0oooo00<00?ZJ0?ooo`3oool01@3oool9003jVPl0oooo
00<00?ZJ0?ooo`3oool0G@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo01D0oooo
00<00?ZJ0?ooo`3oool03@3oool00`00nYX0oooo0?ooo`0=0?ooo`T00?ZJ5`3ooolA003jVQL0oooo
4@00nYX?0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0103oool00`3o0000oooo
0?ooo`060?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool03@3oool00`00nYX0oooo
0?ooo`1e0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0oooo00d0oooo00<0
0?ZJ0?ooo`3oool01@3oool9003jVPl0oooo4@00nYYO0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool05@3oool00`00nYX0oooo0?ooo`0=0?ooo`03003jVP3oool0oooo00d0oooo00<0
0?ZJ0?ooo`3oool0I@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo00@0oooo00<0
o`000?ooo`3oool01P3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo00d0oooo00<0
0?ZJ0?ooo`3oool0M03oool2000003h0oooo000m0?ooo`030000003oool0oooo00d0oooo00<00?ZJ
0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`250?ooo`030000003oool0oooo02H0oooo00<00000
0?ooo`3oool05@3oool00`00nYX0oooo0?ooo`0=0?ooo`03003jVP3oool0oooo00d0oooo00<00?ZJ
0?ooo`3oool0I@3oool00`000000oooo0?ooo`0S0?ooo`P0o`00203oool00`00nYX0oooo0?ooo`05
0?ooo`03003jVP3oool0oooo00D0oooo2@00nYYg0?ooo`030000003oool0oooo03`0oooo000`0?oo
o`<00000103oool2000000@0oooo00<000000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`050?oo
o`03003jVP3oool0oooo08D0oooo00<000000?ooo`3oool06@3oool3000000@0oooo0P0000040?oo
o`030000003oool0oooo01D0oooo00<00?ZJ0?ooo`3oool03@3oool00`00nYX0oooo0?ooo`0=0?oo
o`03003jVP3oool0oooo06D0oooo00<000000?ooo`3oool07@3oool3000000<0oooo00<000000?oo
o`3oool03@3oool00`00nYX0oooo0?ooo`050?ooo`T00?ZJOP3oool2000003h0oooo000a0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`0=0?oo
o`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0Q@3oool00`000000oooo0?ooo`0H0?oo
o`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`030000003o
ool0oooo01D0oooo00<00?ZJ0?ooo`3oool03@3ooolA003jVVL0oooo00<000000?ooo`3oool07P3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00d0oooo00<00?ZJ0?ooo`3oool0S@3o
ool00`000000oooo0?ooo`0l0?ooo`00<@3oool00`000000oooo0?ooo`020?ooo`040000003oool0
oooo000000<0oooo00<000000?ooo`3oool03@3oool9003jVXL0oooo00<000000?ooo`3oool0703o
ool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000005`3oool00`00nYX0
oooo0?ooo`250?ooo`030000003oool0oooo01/0oooo1@0000030?ooo`030000003oool0oooo00d0
oooo00<00?ZJ0?ooo`3oool0S@3oool00`000000oooo0?ooo`0l0?ooo`00<@3oool00`000000oooo
0?ooo`020?ooo`040000003oool0oooo000000<0ooooX@000?lL0?ooo`8000000`3oool010000000
oooo0?ooo`0000030?ooo`8000003P3oool9003jVXH0oooo0P00000M0?ooo`040000003oool0oooo
000000@0oooo0P00000>0?ooo`03003jVP3oool0oooo08`0oooo0P00000n0?ooo`00<@3oool00`00
0000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0W@3oool0
0`000000oooo0?ooo`0L0?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo
0000000?0?ooo`03003jVP3oool0oooo08d0oooo00<000000?ooo`3oool0703oool00`000000oooo
000000040?ooo`030000003oool0oooo00d0oooo00<00?ZJ0?ooo`3oool0S@3oool00`000000oooo
0?ooo`0l0?ooo`00<03oool2000000@0oooo00@000000?ooo`3oool000000`3oool00`000000oooo
0?ooo`2M0?ooo`030000003oool0oooo01P0oooo00D000000?ooo`3oool0oooo000000020?ooo`04
0000003oool0oooo000000<0oooo00<000000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`2=0?oo
o`030000003oool0oooo01d0oooo0P0000040?ooo`030000003oool0oooo00d0oooo00<00?ZJ0?oo
o`3oool0S03oool2000003h0oooo000a0?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`03
0000003oool0oooo05d0oooo2@3o000G0?ooo`T0o`005`3oool00`000000oooo0?ooo`0I0?ooo`<0
0000103oool2000000@0oooo00<000000?ooo`3oool03@3oool00`00nYX0oooo0?ooo`2=0?ooo`03
0000003oool0oooo01h0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0=0?ooo`03
003jVP3oool0oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0
G@3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo01D0oooo00<0o`000?ooo`3oool0
1@3ooolA0?l000L0oooo00<0o`000?ooo`3oool09P3oool00`000000oooo0?ooo`0=0?ooo`03003j
VP3oool0oooo08d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0=0?ooo`03003j
VP3oool0oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0G@3o
ool00`3o0000oooo0?ooo`050?oooaT0o`005`3oool90?l002P0oooo00<000000?ooo`3oool03@3o
ool00`00nYX0oooo0?ooo`2=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool03@3o
ool00`00nYX0oooo0?ooo`2<0?ooo`800000?P3oool003d0oooo00<000000?ooo`3oool0A@3ooolI
0?l003l0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0=0?ooo`03003jVP3oool0
oooo08d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0=0?ooo`03003jVP3oool0
oooo08d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0A@3oool00`3o
0000oooo0?ooo`1E0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool03@3oool00`00
nYX0oooo0?ooo`2=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool03@3oool00`00
nYX0oooo0?ooo`2<0?ooo`800000?P3oool003d0oooo00<000000?ooo`3oool0A@3oool00`3o0000
oooo0?ooo`1E0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool03@3oool00`00nYX0
oooo0?ooo`2=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool01@3oool9003jVXl0
oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0?@3oool90?l005L0oooo
00<000000?ooo`3oool09P3ooolA003jVXl0oooo00<000000?ooo`3oool08`3oool00`000000oooo
0?ooo`050?ooo`03003jVP3oool0oooo09D0oooo00<000000?ooo`3oool0?03oool003d0oooo2@3o
000G0?ooo`T0o`005`3oool00`3o0000oooo0?ooo`1M0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool0W@3oool00`000000oooo0?ooo`0L0?ooo`<00000103oool00`000000oooo0?oo
o`050?ooo`03003jVP3oool0oooo09@0oooo0P00000n0?ooo`00?@3oool00`000000oooo0?ooo`05
0?ooo`030?l0003oool0oooo01D0oooo00<0o`000?ooo`3oool01@3oool90?l000L0oooo2@3o001O
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0K
0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`03003jVP3o
ool0oooo09D0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool01@3oool9
0?l000L0oooo2@3o000?0?ooo`T0o`00I`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0
oooo09d0oooo00<000000?ooo`3oool07`3oool010000000oooo0?ooo`3oool2000000H0oooo00<0
0?ZJ0?ooo`3oool0U03oool2000003h0oooo000m0?ooo`030000003oool0oooo00d0oooo00<0o`00
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`250?ooo`030000003oool0oooo02H0oooo00<00000
0?ooo`3oool0W@3oool00`000000oooo0?ooo`0O0?ooo`050000003oool0oooo0?ooo`0000001`3o
ool00`00nYX0oooo0?ooo`2E0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0
oooo00d0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`250?ooo`030000003oool0
oooo02H0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0K0?ooo`@00000103oool0
0`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo09D0oooo00<000000?ooo`3oool0?03oool0
03d0oooo00<000000?ooo`3oool03@3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo
08D0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo
09D0oooo0P00000n0?ooo`00?@3oool00`000000oooo0?ooo`0=0?ooo`T0o`00A`3oool9003jVQL0
oooo4@00nYX?0?ooo`03003jVP3oool0oooo02H0oooo00<000000?ooo`3oool0W@3oool00`000000
oooo0?ooo`0K0?ooo`D000000`3oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo09H0
oooo00<000000?ooo`3oool0?03oool00300oooo0`0000020?ooo`D000000`3oool00`000000oooo
0?ooo`1M0?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool05@3oool00`00nYX0oooo
0?ooo`0=0?oooa400?ZJ6`3oool300000080oooo1@0000030?ooo`030000003oool0oooo09d0oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo09D0oooo
0P00000n0?ooo`00<@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo
00<000000?ooo`3oool0G@3oool00`00nYX0oooo0?ooo`050?oooaT00?ZJ7`3oool00`000000oooo
0?ooo`0H0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?oo
o`030000003oool0oooo09d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`040?oo
o`03003jVP3oool0oooo09H0oooo00<000000?ooo`3oool0?03oool00340oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`030?ooo`800000GP3oool00`00nYX0oooo0?ooo`0l0?ooo`80
00007P3oool01@000000oooo0?ooo`3oool0000000D0oooo0P00002M0?ooo`8000009@3oool00`00
0000oooo0?ooo`040?ooo`03003jVP3oool0oooo09D0oooo0P00000n0?ooo`00<@3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0A@3ooolA003jVPL0
oooo00<00?ZJ0?ooo`3oool0?@3oool00`000000oooo0?ooo`0J0?ooo`8000001@3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool08`3oool8003jVYP0
oooo00<000000?ooo`3oool0?03oool00340oooo00D000000?ooo`3oool0oooo000000030?ooo`05
0000003oool0oooo0?ooo`000000A`3oool00`00nYX0oooo0?ooo`0=0?ooo`T00?ZJ?`3oool00`00
0000oooo0?ooo`0L0?ooo`030000003oool0000000<0oooo00D000000?ooo`3oool0oooo0000002O
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0l
0?ooo`00<03oool2000000<0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0
oooo04D0oooo00<00?ZJ0?ooo`3oool0E@3oool00`000000oooo0?ooo`0H0?ooo`070000003oool0
oooo0?ooo`000000oooo000000030?ooo`050000003oool0oooo0?ooo`000000W`3oool00`000000
oooo0?ooo`0L0?ooo`<00000103oool00`000000oooo0?ooo`2L0?ooo`800000?P3oool00340oooo
00<000000?ooo`3oool00P3oool3000000@0oooo00<000000?ooo`3oool0A@3oool00`00nYX0oooo
0?ooo`1E0?ooo`030000003oool0oooo01T0oooo0`0000030?ooo`<00000103oool00`000000oooo
0?ooo`2M0?ooo`030000003oool0oooo01/0oooo00D000000?ooo`3oool0oooo000000030?ooo`03
0000003oool0oooo09d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0
?@3oool9003jVUL0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`2M0?ooo`030000
003oool0oooo01/0oooo00D000000?ooo`3oool0oooo000000030?ooo`800000W@3oool2000003h0
oooo000m0?ooo`030000003oool0oooo03d0oooo00<00?ZJ0?ooo`3oool0G@3oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool06`3oool4000000@0oooo
00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?oo
o`0m0?ooo`03003jVP3oool0oooo05d0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`2M0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`2M0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0oooo01d0oooo2@00nYX?
0?ooo`T00?ZJG`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo09d0oooo00<00000
0?ooo`3oool0703oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09`0oooo0P00000n
0?ooo`00?@3oool00`000000oooo0?ooo`0M0?ooo`03003jVP3oool0oooo00D0oooo4@00nYYW0?oo
o`030000003oool0oooo02H0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0M0?oo
o`800000103oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo03`0oooo000m0?ooo`T0
0?ZJ3`3oool9003jVWl0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`2M0?ooo`03
0000003oool0oooo02<0oooo00<000000?ooo`3oool0W03oool2000003h0oooo000m0?ooo`030000
003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool03@3oool00`00nYX0oooo0?ooo`250?ooo`030000
003oool0oooo02H0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0S0?ooo`030000
003oool0oooo09d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool01@3o
ool9003jVPL0oooo00<00?ZJ0?ooo`3oool0Q@3oool00`000000oooo0?ooo`0V0?ooo`030000003o
ool0oooo09d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2M0?ooo`030000003o
ool0oooo03`0oooo000m0?ooo`030000003oool0oooo00d0oooo00<00?ZJ0?ooo`3oool01@3oool0
0`00nYX0oooo0?ooo`250?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0W@3oool0
0`000000oooo0?ooo`0S0?ooo`030000003oool0oooo09`0oooo0P00000n0?ooo`00?@3oool00`00
0000oooo0?ooo`0=0?ooo`T00?ZJQ`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo
09d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo
03`0oooo000m0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool09P3oool00`000000
oooo0?ooo`2M0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`2L0?ooo`800000?P3oool003d0oooo00<000000?ooo`3oool0W@3oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<0
00000?ooo`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo09d0oooo00<0
00000?ooo`3oool07P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo09d0oooo00<0
00000?ooo`3oool0?03oool00300oooo0`0000040?ooo`<000000`3oool00`000000oooo0?ooo`2M
0?ooo`030000003oool0oooo01T0oooo0`0000040?ooo`<000000`3oool00`000000oooo0?ooo`2M
0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool00P3oool2000009d0oooo0P00000n
0?ooo`00<@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0W@3oool00`000000oooo0?ooo`0H0?ooo`050000003oool0oooo0?ooo`000000103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool07`3oool0
1@000000oooo0?ooo`3oool0000009l0oooo00<000000?ooo`3oool0?03oool00340oooo00@00000
0?ooo`3oool0oooo1@0000030?ooo`800000W@3oool2000001h0oooo00<000000?ooo`0000001000
00030?ooo`800000W@3oool2000001d0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000
003oool0oooo09`0oooo0P00000n0?ooo`00<@3oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo01X0oooo
0P0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0W@3oool00`000000
oooo0?ooo`0K0?ooo`D000000`3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo03`0
oooo000a0?ooo`030000003oool0oooo0080oooo00<000000?ooo`000000103oool00`000000oooo
0?ooo`2M0?ooo`030000003oool0oooo01`0oooo00H000000?ooo`3oool000000?ooo`0000040?oo
o`030000003oool0oooo09d0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2M0?oo
o`030000003oool0oooo03`0oooo000`0?ooo`8000001@3oool2000000@0oooo00<000000?ooo`3o
ool0W@3oool00`000000oooo0?ooo`0H0?ooo`050000003oool0oooo0?ooo`0000000`3oool20000
00@0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
09`0oooo0P00000n0?ooo`00<@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0I0?ooo`<000001@3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool08`3oool00`000000
oooo0?ooo`2M0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0oooo09d0oooo
00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02<0oooo
00<000000?ooo`3oool0W03oool2000003h0oooo000m0?ooo`030000003oool0oooo09d0oooo00<0
00000?ooo`3oool09P3oool00`000000oooo0?ooo`2M0?ooo`030000003oool0oooo02<0oooo00<0
00000?ooo`3oool0W@3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?ooo`2M
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0S
0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?oo
o`3oool0W@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo09d0oooo00<000000?oo
o`3oool0703oool3000000@0oooo00<000000?ooo`3oool0W03oool2000003h0oooo000m0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0V0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0K0?ooo`05
0000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool0?03oool003d0ooooX@00000X0?oooj4000007@3oool01@000000
oooo0?ooo`3oool0000000<0ooooX@00000n0?ooo`00o`3oooo60?ooo`<00000h`3oool00?l0oooo
a@3oool01@000000oooo0?ooo`3oool000000>80oooo003o0?ooolD0oooo00D000000?ooo`3oool0
oooo0000003R0?ooo`00R`3oool300000?l0oooo>03oool300000><0oooo002>0?ooo`030000003o
ool0oooo0?l0ooooo`3ooolL0?ooo`00OP3oool400000080oooo1@0000020?ooo`@0000000H0oooo
0000003oool000000?ooo`0000020?ooo`@00000^03oool300000<<0oooo1000002>0?ooo`00PP3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00d000000?ooo`3oool0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000080oooo00<000000?ooo`3oool0^03oool00`000000oooo
0?ooo`330?ooo`040000003oool0oooo000008d0oooo001o0?ooo`<00000103oool01@000000oooo
0?ooo`3oool0000000<0oooo00L000000?ooo`000000oooo0000003oool000000080oooo0`00002j
0?ooo`030000003oool0oooo0<<0oooo00@000000?ooo`3oool00000S@3oool007h0oooo00<00000
0?ooo`3oool01@3oool01@000000oooo0?ooo`3oool0000000<0oooo00T000000?ooo`000000oooo
0000003oool000000?ooo`0000000P3oool00`000000oooo0?ooo`2h0?ooo`800000a03oool01000
0000oooo0?ooo`00002=0?ooo`00O`3oool4000000040?ooo`0000000000000000@0oooo1`000000
0`3oool000000?ooo`020?ooo`800000^P3oool2000000030?ooo`00000000000<80oooo0`00002>
0?ooo`00o`3ooooo0?oooa`0oooo00<000000?ooo`3oool0SP3oool008H0oooo00<000000?ooo`3o
ool0o`3ooonA0?ooo`800000T03oool00?l0ooooo`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo001G
0?ooo`D000000`3oool2000000@0oooo0P00000B0?ooo`<000000`3oool2000000@0oooo0P00000A
0?ooo`<00000103oool2000000@0oooo0P00000A0?ooo`<00000103oool2000000@0oooo0P00000>
0?ooo`<00000103oool2000000@0oooo0P0000040?ooo`800000=P3oool5000000<0oooo0P000004
0?ooo`8000004P3oool3000000<0oooo0P0000040?ooo`8000004@3oool3000000@0oooo0P000004
0?ooo`8000004@3oool3000000@0oooo0P0000040?ooo`8000003P3oool3000000@0oooo0P000004
0?ooo`800000103oool2000003<0oooo1@0000030?ooo`800000103oool200000180oooo0`000003
0?ooo`800000103oool200000140oooo0`0000040?ooo`800000103oool200000140oooo0`000004
0?ooo`800000103oool2000000h0oooo0`0000040?ooo`800000103oool2000000@0oooo0P00000b
0?ooo`00F03oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000004P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`0=0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000l0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003P3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000f0?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000B0?ooo`050000003oool0oooo0?ooo`000000
0P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00d0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003`3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`00000>0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003<0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000180oooo00D00000
0?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
3@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo000000h0oooo00<000000?ooo`3oool00P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000<@3o
ool005T0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo000000l0oooo1@0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000003`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000h0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
0000=`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000003`3oool500000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000000l0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000003P3oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000d0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000?0?ooo`D000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000l0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000003`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000>0?ooo`030000003oool0oooo0080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0340oooo001J0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo00d0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo000000l0oooo100000030?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool00000403oool3000000<0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000>0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000003P0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
3@3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000003`3oool4000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000@0?ooo`<000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
00h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo
000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`@00000
0`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000100oooo0`0000030?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003P3oool00`000000oooo0?oo
o`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`00000a0?ooo`00E`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000@0?ooo`030000003oool0000000<0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`030000003oool0oooo00@0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`050000003oool0
oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000h0
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool000000080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000@0?ooo`030000003oool00000
00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`030000003o
ool0oooo00@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool00000<P3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000@0?ooo`030000
003oool0000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?oo
o`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000h0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000<@3oool005L0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000004@3oool2000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000@0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000d0oooo0P0000040?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000e0?ooo`050000003oool0oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000140oooo
0P0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000403oool00`00
0000oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000003`3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`00000=0?ooo`800000103oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool00000<P3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000A0?ooo`8000000`3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000100oooo00<000000?ooo`3oool0
0`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000l0oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
3@3oool2000000@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000340oooo001H0?ooo`<00000103oool2000000@0oooo0P00000C0?oo
o`030000003oool0oooo0080oooo0P0000040?ooo`8000004P3oool2000000@0oooo0P0000040?oo
o`8000004@3oool3000000@0oooo0P0000040?ooo`8000003`3oool00`000000oooo0?ooo`030?oo
o`800000103oool2000000@0oooo0P00000g0?ooo`<00000103oool2000000@0oooo0P00000C0?oo
o`030000003oool0oooo0080oooo0P0000040?ooo`8000004P3oool2000000@0oooo0P0000040?oo
o`8000004@3oool3000000@0oooo0P0000040?ooo`8000003`3oool00`000000oooo0?ooo`030?oo
o`800000103oool2000000@0oooo0P00000d0?ooo`<00000103oool2000000@0oooo0P00000C0?oo
o`030000003oool0oooo0080oooo0P0000040?ooo`8000004P3oool2000000@0oooo0P0000040?oo
o`8000004@3oool3000000@0oooo0P0000040?ooo`8000003`3oool00`000000oooo0?ooo`030?oo
o`800000103oool2000000@0oooo0P00000b0?ooo`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo
[@3oool00?l0ooooo`3ooon]0?ooo`00@03oool500000003003jVP0000000?ZJ09T00000:03oool3
00000003003jVP000000000000<00?ZJKP000002003jVRP00000903oool3000000@0003o00<00?ZJ
0000000000005P000002003jVX000000>`3oool00400oooo00<000000?ooo`3oool00P3oool01000
nYX0oooo003jVP0000070?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo02H0oooo00@000000?ooo`3oool00?ZJ0P3o
ool3003jVPL0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0103oool2003jVPL0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`0R0?ooo`<0000000L0o`000000o`3oool0003o003jVP3oool0000000L0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`800?ZJ1`3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`0i0?ooo`00@03oool00`000000oooo0?ooo`020?ooo`03003jVP3oool00?ZJ09P0oooo
00<000000?ooo`3oool09P3oool010000000oooo0?ooo`00nYX20?ooo`<00?ZJKP3oool2003jVRL0
oooo00<000000?ooo`3oool08P3oool3000000050?ooo`3o0000oooo0000o`00nYX0603oool2003j
VWl0oooo00<000000?ooo`3oool0>@3oool00400oooo00<000000?ooo`3oool00P3oool00`00nYX0
oooo003jVP2H0?ooo`030000003oool0oooo02H0oooo00@000000?ooo`3oool00?ZJ0P3oool3003j
VVh0oooo0P00nYXW0?ooo`030000003oool0oooo02<0oooo00L00?ZJ0?ooo`3oool0o`000?ooo`00
0?l00?ZJ01P0oooo0P00nYYo0?ooo`030000003oool0oooo03T0oooo00100?ooo`030000003oool0
oooo0080oooo00<00?ZJ0?ooo`00nYX0V03oool00`000000oooo0?ooo`0V0?ooo`040000003oool0
oooo003jVP80oooo00@00?ZJ0000000000000000K@3oool2003jVRL0oooo00<000000?ooo`3oool0
8`3oool01`0000000?ZJ0?ooo`3o0000oooo0000o`00nYX0603oool2003jVWh0oooo0P00000k0?oo
o`00@03oool00`000000oooo0?ooo`020?ooo`03003jVP3oool00?ZJ09P0oooo00<000000?ooo`3o
ool09P3oool010000000oooo0?ooo`00nYX20?ooo`04003jVP0000000000000006d0oooo0P00nYXW
0?ooo`030000003oool0oooo02<0oooo00@000000?ooo`00nYX0o`000P3oool00`00nYX0oooo0?oo
o`0F0?ooo`800?ZJ7`3oool00`00nYX0oooo0?ooo`1M0?ooo`030000003oool0oooo03T0oooo0010
0?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`2F0?ooo`030000003o
ool0oooo02H0oooo00@000000?ooo`3oool00?ZJ0P3oool01000nYX0000000000000001]0?ooo`80
0?ZJ9`3oool00`000000oooo0?ooo`0S0?ooo`040000003oool00?ZJ0?l00080oooo0P00nYXG0?oo
o`800?ZJ7`3oool00`00nYX0oooo0?ooo`1M0?ooo`030000003oool0oooo03T0oooo00100?ooo`05
0000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`2F0?ooo`030000003oool0oooo
02H0oooo00@000000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01@0oooo0P00nYYF
0?ooo`800?ZJ9`3oool00`000000oooo0?ooo`0S0?ooo`040000003oool0oooo0?l00080oooo0P00
nYXG0?ooo`800?ZJ7P3oool2003jVSL0oooo00<00?ZJ0?ooo`3oool0903oool2000003/0oooo0010
0?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`2F0?ooo`030000003o
ool0oooo02H0oooo00@000000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01@0oooo
0P00nYYF0?ooo`<00?ZJ9P3oool00`000000oooo0?ooo`0S0?ooo`060000003oool0oooo003jVP3o
0000oooo0P00nYXF0?ooo`03003jVP3oool00?ZJ01h0oooo0P00nYXg0?ooo`03003jVP3oool0oooo
02D0oooo00<000000?ooo`3oool0>@3oool00400oooo00D000000?ooo`3oool0oooo003jVP020?oo
o`03003jVP3oool0oooo09H0oooo00<000000?ooo`3oool09P3oool010000000oooo0?ooo`00nYX2
0?ooo`800?ZJ00<0o`000?ooo`3oool0503oool2003jVUH0oooo1000nYXU0?ooo`030000003oool0
oooo02<0oooo00H000000?ooo`3oool00?ZJ0?l0003oool2003jVQH0oooo00<00?ZJ0?ooo`00nYX0
7P3oool2003jVSH0oooo0P00nYXW0?ooo`030000003oool0oooo03T0oooo00100?ooo`050000003o
ool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`2F0?ooo`030000003oool0oooo02H0oooo
00@000000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01@0oooo0P00nYXR0?ooo`80
0?ZJ<P3oool4003jVRD0oooo00<000000?ooo`3oool08`3oool01P000000oooo0?ooo`00nYX0o`00
0?ooo`800?ZJ5P3oool00`00nYX0oooo003jVP0N0?ooo`800?ZJ=P3oool2003jVRH0oooo0P00000k
0?ooo`00@03oool01@000000oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0?ooo`3oool0UP3oool0
0`000000oooo0?ooo`0V0?ooo`040000003oool0oooo003jVP80oooo0P00nYX00`3o0000oooo0?oo
o`0D0?ooo`800?ZJ8P3oool2003jVS80oooo0P00nYX00`3o00000?ZJ0?ooo`0T0?ooo`030000003o
ool0oooo02<0oooo00H000000?ooo`3oool00?ZJ0?l0003oool2003jVQH0oooo00<00?ZJ0?ooo`00
nYX07P3oool2003jVSH0oooo0P00nYXW0?ooo`030000003oool0oooo03T0oooo00100?ooo`050000
003oool0oooo0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`2F0?ooo`030000003oool0oooo02H0
oooo00@000000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01@0oooo0P00nYXR0?oo
o`800?ZJ<P3oool2003jVP030?l00000nYX0oooo02@0oooo00<000000?ooo`3oool08`3oool01P00
0000oooo0?ooo`00nYX0o`000?ooo`800?ZJ3@3oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3o
ool00?ZJ01h0oooo0P00nYXf0?ooo`800?ZJ9`3oool00`000000oooo0?ooo`0i0?ooo`00@03oool0
1@000000oooo0?ooo`3oool00?ZJ0080oooo0P00nYZG0?ooo`030000003oool0oooo02H0oooo00@0
00000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01<0oooo00@00?ZJ0?ooo`00nYX0
0?ZJ803oool00`00nYX0oooo003jVP0b0?ooo`800?ZJ00<0o`00003jVP3oool0903oool00`000000
oooo0?ooo`0S0?ooo`060000003oool0oooo003jVP3o0000oooo0P00nYX<0?ooo`800?ZJ203oool0
0`00nYX0oooo003jVP0N0?ooo`800?ZJ=P3oool2003jVRH0oooo0P00000k0?ooo`00@03oool01@00
0000oooo0?ooo`3oool00?ZJ0080oooo0P00nYZG0?ooo`030000003oool0oooo01P0oooo1@000003
0?ooo`800000103oool010000000oooo0?ooo`00nYX20?ooo`800?ZJ00<0o`000?ooo`3oool04`3o
ool00`00nYX0oooo003jVP02003jVQl0oooo00<00?ZJ0?ooo`00nYX04`3oool00`00nYX0oooo0?oo
o`0K0?ooo`03003jVP3oool00?ZJ0080o`008P3oool01000nYX0oooo0?ooo`00000H0?ooo`<00000
103oool2000000@0oooo00H000000?ooo`3oool00?ZJ0?l0003oool2003jVP`0oooo0P00nYX70?oo
o`04003jVP3oool0oooo003jVQd0oooo00<00?ZJ0?ooo`00nYX0=@3oool00`00nYX0oooo003jVP0W
0?ooo`030000003oool0oooo03T0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX00P3oool2
003jVYL0oooo00<000000?ooo`3oool06@3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo000000<0oooo00@000000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01<0
oooo00<00?ZJ0?ooo`00nYX00P00nYXO0?ooo`03003jVP3oool00?ZJ01<0oooo00<00?ZJ0?ooo`3o
ool06`3oool00`00nYX0oooo003jVP020?l00280oooo0P00nYX00`3oool000000?ooo`0H0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool01P000000oooo0?ooo`00nYX0
o`000?ooo`800?ZJ303oool00`00nYX0oooo003jVP060?ooo`04003jVP3oool0oooo003jVQd0oooo
00<00?ZJ0?ooo`00nYX0=@3oool00`00nYX0oooo003jVP0W0?ooo`030000003oool0oooo03T0oooo
00100?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0o`00003jVP2F0?ooo`030000
003oool0oooo0180oooo1@0000030?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
00000`3oool010000000oooo0?ooo`00nYX20?ooo`800?ZJ00<0o`000?ooo`3oool04`3oool00`00
nYX0oooo003jVP02003jVQl0oooo00<00?ZJ0?l00000nYX04`3oool00`00nYX0oooo0?ooo`0C0?oo
o`03003jVP3oool0oooo00D0oooo00D00?ZJ0?ooo`3o00000?ZJ0?l0000Q0?ooo`<00?ZJ00<0oooo
0000003oool0603oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00H0
00000?ooo`3oool00?ZJ0?l0003oool2003jVP`0oooo00<00?ZJ0?ooo`00nYX01P3oool01000nYX0
oooo0?ooo`00nYXM0?ooo`04003jVP3oool00?ZJ003jVQD0oooo0P00nYXM0?ooo`03003jVP3oool0
0?ZJ02L0oooo00<000000?ooo`3oool0>@3oool00400oooo00D000000?ooo`3oool0oooo003jVP02
0?ooo`<00000UP3oool00`000000oooo0?ooo`0K0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`3oool2000000040?ooo`00nYX0oooo0?ooo`800?ZJ00<0o`000?ooo`3o
ool04`3oool00`00nYX0oooo003jVP02003jVQl0oooo00<00?ZJ0?l0003o00004`3oool00`00nYX0
oooo0?ooo`0B0?ooo`800?ZJ1`3oool01@00nYX0oooo0?l00000nYX0o`000240oooo00<00?ZJ0?oo
o`00nYX00P00000I0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool2
000000040?ooo`00nYX0o`000?ooo`800?ZJ2`3oool01000nYX0oooo0?ooo`00nYX60?ooo`04003j
VP3oool0oooo003jVQd0oooo00D00?ZJ0?ooo`00nYX0oooo003jVP0D0?ooo`800?ZJ703oool2003j
VP030000o`00nYX0oooo02D0oooo0P00000k0?ooo`00<P3oool5000000<0oooo0P0000040?ooo`05
0000003oool0oooo0?ooo`00nYX00P3oool3000006h0oooo00<00?ZJ0?ooo`3oool09@3oool00`00
0000oooo0?ooo`0H0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00
00030?ooo`040000003oool0oooo003jVP80oooo0P00nYX00`3o0000oooo0?ooo`0C0?ooo`05003j
VP3oool00?ZJ0?l00000nYX07`3oool01000nYX0o`000?l00000nYXA0?ooo`800?ZJ503oool2003j
VPL0oooo00D00?ZJ0?ooo`3o00000?ZJ0?l0000Q0?ooo`05003jVP3oool00?ZJ0?ooo`0000006@3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00H000000?ooo`3oool0
0?ZJ0?l0003oool2003jVP/0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool01000nYX0oooo0?ooo`00
nYXM0?ooo`05003jVP3oool00?ZJ0?ooo`00nYX0503oool2003jVQ`0oooo00@00?ZJ0?ooo`000?l0
0?ZJ9`3oool00`000000oooo0?ooo`0i0?ooo`00<`3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000<0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`<000005P3oool0
0`00nYX0oooo0?ooo`1E0?ooo`03003jVP3oool0oooo02D0oooo00<000000?ooo`3oool0603oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3oool010000000oooo
0?ooo`00nYX20?ooo`800?ZJ00<0o`000?ooo`3oool04`3oool00`00nYX0oooo003jVP020?l001l0
oooo00@00?ZJ0?l0003o00000?ZJ4@3oool2003jVQ<0oooo0`00nYX70?ooo`05003jVP3oool0o`00
0?ooo`3o0000803oool01P00nYX0003o0000o`00nYX0oooo000001P0oooo0P0000040?ooo`040000
003oool0oooo000000<0oooo00D000000?ooo`3oool0oooo0?l000020?ooo`03003jVP3oool0oooo
00T0oooo00@00?ZJ0?ooo`3oool00?ZJ1@3oool01@00nYX0oooo0?ooo`3oool00?ZJ01d0oooo00D0
0?ZJ0000000000000000003jVP0C0?ooo`@00?ZJ6`3oool01000nYX0oooo0000o`00nYXW0?ooo`03
0000003oool0oooo03T0oooo000/0?ooo`D000000`3oool00`000000oooo0?ooo`020?ooo`040000
003oool0oooo000000<0oooo0P0000020?ooo`04003jVP3oool0oooo003jVP80o`005P3oool00`00
nYX0oooo0?ooo`1E0?ooo`03003jVP3oool00?ZJ02@0oooo0P00000K0?ooo`<00000103oool20000
00@0oooo00@000000?ooo`3oool00?ZJ0P3oool2003jVP030?l0003oool0oooo01<0oooo00<00?ZJ
0?ooo`00nYX00P3o000O0?ooo`040?l000000?l0o`00003jVQ40oooo0P00nYXC0?ooo`04003jVP3o
ool0oooo003jVPH0oooo00D00?ZJ0?ooo`3o0000oooo0?l0000P0?ooo`06003jVP000?l0003o003j
VP3oool000006@3oool00`000000oooo0?ooo`030?ooo`800000103oool01@000000oooo0?ooo`3o
ool0o`000080oooo00<00?ZJ0?ooo`3oool0203oool2003jVP80oooo00<00?ZJ0?ooo`3oool00`3o
ool01@00nYX0oooo0?ooo`3oool00?ZJ01`0oooo0P00nYX300000003003jVP3oool0oooo0140oooo
00@00?ZJ00000000000000006`3oool01000nYX0oooo0000o`00nYXV0?ooo`800000>`3oool003D0
oooo00D000000?ooo`3oool0oooo000000020?ooo`050000003oool0oooo0?ooo`0000000`3oool0
1000nYX0oooo0?ooo`00nYX20?l001D0oooo0P00nYXS0?ooo`03003jVP3oool0oooo0340oooo00<0
0?ZJ0?ooo`00nYX09@3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0oooo003jVP80oooo
0P00nYX00`3o0000oooo0?ooo`0C0?ooo`03003jVP3oool00?ZJ0080o`007`3oool0103o0000003o
0?l00000nYXA0?ooo`800?ZJ303oool00`00nYX0oooo0?ooo`040?ooo`04003jVP3oool0oooo003j
VPH0oooo00D00?ZJ00000000000000000?l0000P0?ooo`06003jVP000?l0003o003jVP3oool00000
9@3oool01@000000oooo0?ooo`3oool0o`000080oooo00<00?ZJ0?ooo`3oool0203oool01@00nYX0
oooo0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?ooo`3oool0oooo003jVP070?ooo`03003jVP3oool0
oooo0180oooo00<00?ZJ0?ooo`0000000P0000000`00nYX0oooo0?ooo`0A0?ooo`04003jVP000000
0000000001X0oooo00D00?ZJ0000o`3oool0oooo003jVP0G0?ooo`03003jVP3oool0oooo00d0oooo
00<000000?ooo`3oool0>@3oool00380oooo00D000000?ooo`3oool0oooo000000020?ooo`040000
003oool0oooo000000<0oooo00D000000?ooo`3oool0oooo003jVP020?ooo`03003jVP3o0000o`00
01D0oooo0P00nYXR0?ooo`<00?ZJ<P3oool3003jVRD0oooo00<000000?ooo`3oool09P3oool01000
0000oooo0?ooo`00nYX20?ooo`800?ZJ00<0o`000?ooo`3oool04`3oool01@00nYX0oooo0?l00000
nYX0o`0001l0oooo00@0o`00003jVP3o00000?ZJ4@3oool2003jVP/0oooo0`00nYX40?ooo`05003j
VP3oool0oooo0?ooo`00nYX01P3oool01@00nYX00000000000000000o`000200oooo00H00?ZJ0000
o`000?l00?ZJ0?ooo`00000U0?ooo`050000003oool0oooo0?ooo`3o00000P3oool00`00nYX0oooo
0?ooo`080?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`3oool00?ZJ
00H0oooo0P00nYXD0?ooo`06003jVP3oool0003o0?l00000nYX0o`004P3oool2003jVP<000006P3o
ool00`00nYX0003o0?ooo`03000001D0oooo0P00nYX?0?ooo`030000003oool0oooo03T0oooo000b
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`050000
003oool0oooo0?ooo`00nYX00P3oool00`00nYX0o`000?l0000E0?ooo`800?ZJ8P3oool00`00nYX0
oooo003jVP0b0?ooo`800?ZJ00<0oooo003jVP3oool08`3oool00`000000oooo0?ooo`0V0?ooo`04
0000003oool0oooo003jVP80oooo0P00nYX00`3o0000oooo0?ooo`0C0?ooo`05003jVP3oool0o`00
003jVP3o00007`3oool0103o00000?ZJ0?l00000nYXA0?ooo`800?ZJ2P3oool2003jVP030?ooo`00
nYX0oooo00<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`05003jVP00000000000000003o
0000803oool01P00nYX0o`000?l00000nYX0oooo000002D0oooo00D000000?ooo`3oool0oooo0?l0
00020?ooo`03003jVP3oool0oooo00P0oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?ooo`05003j
VP3oool0003o0?ooo`00nYX01P3oool2003jVQ@0oooo00L00?ZJ0000o`000?l0o`00003jVP3o0000
0?ZJ0140oooo00<00?ZJ0000o`3oool00P3o00000`00nYX0oooo0?ooo`0G0?ooo`03003jVP000?l0
oooo00<000005@3oool2003jVPT0oooo0P00nYX30?ooo`800000>`3oool003<0oooo0`0000040?oo
o`800000103oool01@000000oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0?l0003o00005@3oool2
003jVP030?ooo`00nYX00?ZJ01l0oooo00<00?ZJ0?ooo`00nYX0<@3oool3003jVP030?l00000nYX0
oooo02<0oooo00<000000?ooo`3oool09P3oool010000000oooo0?ooo`00nYX20?ooo`800?ZJ00<0
o`000?ooo`3oool04`3oool01@00nYX0oooo0?l00000nYX0o`0001h0oooo00D00?ZJ0?l00000nYX0
o`00003jVP0A0?ooo`800?ZJ2P3oool01000nYX0oooo0?ooo`00nYX40?ooo`05003jVP3oool0oooo
0?ooo`00nYX01P3oool01@00nYX0oooo0?l0003oool0o`000200oooo00H00?ZJ0?l0003o00000?ZJ
0?ooo`00000U0?ooo`080000003oool0oooo0?ooo`00nYX0o`000?ooo`00nYX90?ooo`03003jVP3o
ool0oooo0080oooo00<00?ZJ0?ooo`3oool00`3oool01@00nYX0o`000?l000000?l00?ZJ00H0oooo
0P00nYX:0?ooo`800?ZJ203oool01`00nYX0003o0?ooo`3o00000?ZJ0?l00000nYX04@3oool00`00
nYX0003o0?ooo`020?l00003003jVP3oool0oooo00h0oooo0P00nYX70?ooo`03003jVP3o0000o`00
00<000005@3oool3000000P0oooo0`00nYX30?ooo`030000003oool0oooo03T0oooo00100?ooo`05
0000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0o`000?l0000E0?ooo`800?ZJ00<0oooo003j
VP00nYX07`3oool00`00nYX0oooo003jVP0a0?ooo`<00?ZJ00<0o`00003jVP3oool08@3oool00`00
nYX0oooo0000000X0?ooo`030000003oool00?ZJ00<0oooo0P00nYX00`3o0000oooo0?ooo`0B0?oo
o`03003jVP3oool000000080000000<0o`00003jVP3oool0703oool01@00nYX0o`00003jVP3o0000
0?ZJ0140oooo0P00nYX:0?ooo`04003jVP3oool0oooo003jVP@0oooo00D00?ZJ0000o`3o0000oooo
003jVP060?ooo`05003jVP3oool0o`000?ooo`3o0000803oool01P00nYX0o`000?l00000nYX0oooo
000002D0oooo00P000000?ooo`3oool0oooo003jVP3o0000oooo003jVPT0oooo00<00?ZJ0?ooo`3o
ool00P3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0o`000080o`0000<00?ZJ0?ooo`3o
ool0103oool2003jVPT0oooo0`00nYX70?ooo`08003jVP3oool0003o0?ooo`3o00000?ZJ0?l00000
nYXA0?ooo`03003jVP000?l0o`000080o`0000<00?ZJ0?ooo`3oool03@3oool3003jVPL0oooo00<0
0?ZJ0?l0003oool00P3o000E0?ooo`04003jVP0000000000000000L0oooo0P00nYX00`3oool00?ZJ
0?ooo`020?ooo`030000003oool0oooo03T0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX0
0P3oool00`00nYX0o`000?l0000E0?ooo`800?ZJ00<0oooo003jVP00nYX07`3oool00`00nYX0oooo
003jVP0a0?ooo`800?ZJ0P3o00000`00nYX0oooo0?ooo`0O0?ooo`<00?ZJ00<000000?ooo`3oool0
9P3oool00`000000oooo003jVP030?ooo`800?ZJ00<0o`000?ooo`3oool04P3oool00`00nYX0oooo
00000002000000030?l00000nYX0oooo01`0oooo00D00?ZJ0?l00000nYX0o`00003jVP0A0?ooo`80
0?ZJ2P3oool01000nYX0oooo0?ooo`00nYX40?ooo`05003jVP3o0000o`000?ooo`00nYX01P3oool0
1@00nYX0oooo0?l0003oool0o`0001l0oooo00L00?ZJ0?l0003oool0o`000?ooo`00nYX0000002D0
oooo00P000000?ooo`3oool0oooo003jVP3o0000oooo003jVPT0oooo00H00?ZJ0?l0003o0000o`00
0?ooo`00nYX40?ooo`06003jVP3o0000o`000?ooo`3o00000?ZJ1P3oool2003jVPT0oooo00<00?ZJ
0?ooo`00nYX01`3oool02000nYX0oooo0000o`3oool0o`00003jVP3o00000?ZJ4@3oool01P00nYX0
o`000?ooo`00nYX0o`00003jVPl0oooo00<00?ZJ0?ooo`00nYX01P3oool01000nYX0o`000?l0003o
ool20?l001D0oooo00@00?ZJ00000000000000001`3oool01000nYX0oooo0?ooo`00nYX30?ooo`03
0000003oool0oooo03T0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00nYX0
o`000?l0000E0?ooo`<00?ZJ00<0oooo003jVP3oool07P3oool00`00nYX0o`00003jVP0X0?ooo`80
0?ZJ1`3oool2003jVP030?l0003oool0o`000200oooo0P00nYX00`3oool00?ZJ0000000X0?ooo`03
0000003oool00?ZJ00<0oooo0P00nYX00`3o0000oooo0?ooo`0B0?ooo`03003jVP3oool000000080
000000<0o`00003jVP3oool0703oool01@00nYX0o`00003jVP3o00000?ZJ0140oooo0P00nYX90?oo
o`03003jVP3oool0oooo0080oooo00T00?ZJ0?ooo`3oool0oooo003jVP3o0000003o0?l00000nYX0
1P3oool01@00nYX0oooo0?l0003oool0o`0001l0oooo00L00?ZJ0?l0003oool0o`000?ooo`00nYX0
000002D0oooo00P000000?ooo`3oool0oooo003jVP3o0000oooo003jVPT0oooo00H00?ZJ0?l0003o
ool0o`000?ooo`00nYX40?ooo`04003jVP3o0000oooo0?ooo`<00000103oool00`00nYX0oooo003j
VP090?ooo`04003jVP3oool0oooo003jVPH0oooo00<00?ZJ0000o`3o00000P3o00000`3oool0o`00
003jVP0@0?ooo`07003jVP3oool0o`000?ooo`00nYX0o`00003jVP0?0?ooo`04003jVP3oool0oooo
003jVPD0oooo00@00?ZJ0?l0003oool0oooo0P3o000E0?ooo`04003jVP000?l0o`00003jVPH0oooo
0P00nYX00`000?l0oooo003jVP020?ooo`800000>`3oool00400oooo00D000000?ooo`3oool0oooo
003jVP020?ooo`03003jVP3o0000o`0001D0oooo0`00nYX00`3o00000?ZJ0?ooo`0N0?ooo`03003j
VP3o0000o`0002L0oooo0`00nYX70?ooo`800?ZJ00<0o`00003jVP3o0000803oool01@00nYX0oooo
0?ooo`00nYX0000002P0oooo00<000000?ooo`00nYX00`3oool2003jVP030?l0003oool0oooo0180
oooo00L00?ZJ0?ooo`3oool0o`000?ooo`3o00000?ZJ01d0oooo00D00?ZJ0?l0003oool0o`00003j
VP0A0?ooo`800?ZJ2@3oool01P00nYX0oooo0?l0003o0000oooo003jVP80oooo00H00?ZJ0?ooo`3o
0000oooo0?l00000nYX50?ooo`06003jVP3oool0oooo0?l0003oool0o`007`3oool01`00nYX0o`00
0?ooo`3o0000oooo003jVP0000009@3oool020000000oooo0?ooo`3oool00?ZJ0?l0003oool00?ZJ
2@3oool01P00nYX0o`000?ooo`3o0000oooo003jVP@0oooo00@00?ZJ0?l0003oool0oooo0`000004
0?ooo`03003jVP3oool00?ZJ00P0oooo0P00nYX20?ooo`03003jVP3oool0oooo00@0oooo00<00?ZJ
0?l0003o00000P3o00000`3oool0o`00003jVP0@0?ooo`04003jVP3o0000o`000?ooo`800?ZJ00<0
o`000?ooo`3oool0303oool01@00nYX0003o0?ooo`3oool00?ZJ00D0oooo00@00?ZJ0?l0003oool0
oooo0P3o000E0?ooo`04003jVP000?l0o`00003jVPH0oooo0P00nYX00`000?l0oooo003jVP030?oo
o`030000003oool0oooo03T0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX00P3oool00`00
nYX0o`000?l0000E0?ooo`<00?ZJ0P3o000O0?ooo`030?l000000?l0o`0002L0oooo00<00?ZJ0?oo
o`00nYX01`3oool2003jVP030?l00000nYX0o`000200oooo00D00?ZJ0?ooo`3oool00?ZJ0000000X
0?ooo`030000003oool00?ZJ00<0oooo0P00nYX00`3o0000oooo0?ooo`0B0?ooo`07003jVP3oool0
003o0?l0003oool0o`00003jVP0M0?ooo`05003jVP3o0000oooo0?l00000nYX0403oool00`00nYX0
oooo003jVP090?ooo`06003jVP3o0000o`000?l0003oool00?ZJ0P3oool01P00nYX0003o0?l0003o
ool0o`00003jVPD0oooo00H00?ZJ0?ooo`000?l0o`000?ooo`3o000O0?ooo`07003jVP3o00000?ZJ
0?l0003oool00?ZJ0000000U0?ooo`080000003oool0oooo0?ooo`00nYX0o`000?ooo`00nYX90?oo
o`060?l000000?l0003o0?l0003oool00?ZJ103oool01000nYX0o`000?ooo`3oool3000000@0oooo
00<00?ZJ0?l0003o0000203oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?l0003o
ool00P3o00000`3oool0o`00003jVP0@0?ooo`04003jVP3o0000oooo0?ooo`800?ZJ00<0o`000?oo
o`3oool0303oool01@00nYX0003o0000o`3oool00?ZJ00D0oooo00<00?ZJ0?l0003oool00P3oool0
0`3o0000oooo0?ooo`0C0?ooo`04003jVP000?l0o`000?l000D0oooo0P00nYX20?l000030?ooo`00
nYX0oooo0080oooo00<000000?ooo`3oool0>@3oool00400oooo00D000000?ooo`3oool0oooo003j
VP020?ooo`03003jVP3o0000o`0001D0oooo0`00nYX20?l001l0oooo00@0o`000000o`3o00000?ZJ
7P3oool2003jVPD0oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`800?ZJ00<0o`00003jVP3o
0000803oool01@00nYX0003o0000o`00nYX0000002P0oooo00<000000?ooo`00nYX00`3oool00`00
0?l00?ZJ0?l0000D0?ooo`07003jVP3oool0003o0?l0003oool0o`00003jVP0M0?ooo`050?l00000
nYX0oooo0?l00000nYX0403oool00`00nYX0oooo003jVP090?ooo`06003jVP3o0000oooo0?l0003o
ool00?ZJ0P3oool01P00nYX0o`000?ooo`3oool0o`00003jVPD0oooo00H00?ZJ0?ooo`000?l0o`00
0?ooo`3o000O0?ooo`07003jVP3o00000?ZJ003jVP3o00000?ZJ0000000U0?ooo`080000003oool0
oooo0?ooo`00nYX0o`000?ooo`00nYX80?ooo`07003jVP3o0000003o0000o`3o0000oooo003jVP04
0?ooo`03003jVP3o0000oooo0080oooo00<0o`000?ooo`3oool00`3oool00`00nYX0o`000?l00008
0?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool00`00nYX0003o0?l000020?ooo`040?l0003o
ool0o`00003jVPP0oooo0P00nYX60?ooo`04003jVP3o0000oooo0?ooo`800?ZJ00<0o`000?ooo`3o
ool01@3oool2003jVPD0oooo00D00?ZJ0?ooo`000?l0oooo003jVP050?ooo`03003jVP3o0000oooo
0080oooo00<0o`00003jVP3oool0103oool2003jVPH0oooo0P00nYX40?ooo`800?ZJ00<0oooo0?l0
003o00001@3oool2003jVP<0o`0000<00?ZJ0?ooo`3oool00P00000k0?ooo`00@03oool010000000
oooo0?ooo`00nYX30?ooo`03003jVP3o0000o`0001D0oooo0P00nYX00`3o0000oooo0?l0000N0?oo
o`05003jVP3o0000003o0?l00000nYX07@3oool4003jVP@0oooo00D00?ZJ0?ooo`3oool0oooo003j
VP060?ooo`800?ZJ00<0o`000000o`3o0000803oool01@00nYX0003o0000o`00nYX0000001/0oooo
0`0000040?ooo`800000103oool00`000000oooo003jVP020?ooo`040000o`3oool00?ZJ0?l001@0
oooo00L00?ZJ0?ooo`000?l0o`000?ooo`3o00000?ZJ01d0oooo00D0o`00003jVP3oool0o`00003j
VP0@0?ooo`03003jVP3oool00?ZJ00D0oooo00X00?ZJ0?ooo`3oool0oooo003jVP3o0000oooo0?l0
003oool00?ZJ0P3oool01P00nYX0o`000?ooo`3oool0o`00003jVPD0oooo00H00?ZJ0?ooo`000?l0
o`000?ooo`3o000O0?ooo`07003jVP3o00000?ZJ003jVP3o00000?ZJ0000000G0?ooo`D000000`3o
ool2000000@0oooo00P000000?ooo`3oool0oooo003jVP3o0000oooo003jVPP0oooo00L00?ZJ0?l0
00000?l0003o0?l000000?l00?ZJ00@0oooo00<0o`000000o`3oool00P3oool00`3o0000oooo0?oo
o`030?ooo`03003jVP3o0000o`0000P0oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?ooo`03003j
VP3o0000o`000080oooo00@00?ZJ0?ooo`3o00000?ZJ1`3oool010000?l00?ZJ0?ooo`00nYX50?oo
o`04003jVP3o0000oooo0?ooo`800?ZJ00<0o`000?ooo`3oool01@3oool3003jVP@0oooo00D00?ZJ
0?l0003o0000oooo003jVP040?ooo`03003jVP3o0000oooo00800?ZJ00<0oooo0?l00000nYX01@3o
ool2003jVPH0oooo0P00nYX40?ooo`03003jVP000?l0oooo0080o`001@3oool01`00nYX0o`000?l0
003oool0o`000?ooo`00nYX00P3oool00`000000oooo0?ooo`0i0?ooo`00@03oool010000000oooo
0?ooo`00nYX30?ooo`03003jVP3o0000o`0001@0oooo00L00?ZJ0?ooo`00nYX0o`000?ooo`3o0000
0?ZJ01d0oooo00D00?ZJ0?l00000nYX0o`00003jVP0M0?ooo`04003jVP3oool0oooo003jVP@0oooo
00D00?ZJ0000o`3oool0oooo003jVP060?ooo`800?ZJ00<0o`000?ooo`3o0000803oool01@00nYX0
o`000?l00000nYX0000001`0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`000003
0?ooo`030000003oool00?ZJ0080oooo00D0003o0?ooo`00nYX0o`00003jVP040?ooo`03003jVP3o
ool0oooo00/0oooo00P00?ZJ0?ooo`3oool0003o0?l0003oool0o`00003jVQd0oooo00D0o`00003j
VP3oool0o`00003jVP0@0?ooo`03003jVP3oool00?ZJ00@0oooo1@00nYX01P000?l0o`000?ooo`3o
0000oooo003jVP80oooo00H00?ZJ0?l0003oool00?ZJ0?l00000nYX50?ooo`06003jVP3oool0003o
0?l0003oool0o`007@3oool01000nYX0oooo003jVP3o0002003jVP030?l00000nYX0000001P0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`080000003oool0oooo
0?ooo`00nYX0o`000?ooo`00nYX30?ooo`800?ZJ0`3oool01`00nYX0o`00003jVP00nYX0o`000000
o`00nYX00`3oool00`00nYX0o`000000o`030?ooo`030?l0003oool0oooo00<0oooo00<00?ZJ0?l0
003o00001`3oool2003jVP80o`0000<0oooo003jVP3oool0103oool00`00nYX0o`000?ooo`020?oo
o`04003jVP3oool0o`00003jVPL0oooo0P00nYX00`000?l00?ZJ0?ooo`030?ooo`03003jVP3o0000
o`0000@00?ZJ00<0o`000?ooo`3oool0103oool2003jVP030?ooo`00nYX0oooo0080oooo00H00?ZJ
0?l0003o0000o`000?ooo`00nYX40?ooo`03003jVP3o00000?ZJ00800?ZJ00<0oooo003jVP3o0000
1@3oool2003jVPH0oooo0P00nYX40?ooo`03003jVP000?l0oooo0080o`001@3oool3000000040?oo
o`3o0000oooo003jVP80oooo00<000000?ooo`3oool0>@3oool00400oooo00@000000?ooo`3oool0
0?ZJ0`3oool00`00nYX0o`000?l0000D0?ooo`07003jVP3oool00?ZJ0?l00000nYX0o`00003jVP0M
0?ooo`05003jVP3o00000?ZJ0?l00000nYX04@3oool00`00nYX0oooo0?ooo`090?ooo`04003jVP3o
ool0oooo003jVP@0oooo00D00?ZJ0000o`000?l0oooo003jVP060?ooo`800?ZJ00<0o`000?ooo`3o
0000803oool01@00nYX0o`000?l00000nYX0000001@0oooo1@0000030?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000000`3oool200000008003jVP3oool0oooo0000o`3oool00?ZJ
0?l00000nYX30?ooo`<00?ZJ203oool01@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00D0003o0?l0
003oool00?ZJ0?l0000M0?ooo`050?l00000nYX0oooo0?l00000nYX0403oool00`00nYX0oooo003j
VP040?ooo`03003jVP3oool0oooo00800?ZJ00H0o`000000o`3oool0oooo0?l00000nYX20?ooo`07
003jVP3o00000?ZJ003jVP3o0000oooo003jVP040?ooo`07003jVP3oool0003o0?l0003oool0o`00
0000o`0K0?ooo`<00?ZJ00L0o`000?ooo`00nYX00?ZJ0?l00000nYX0000001T0oooo00<000000?oo
o`3oool00P3oool010000000oooo0?ooo`0000030?ooo`8000000P3oool01000nYX0o`000?ooo`00
nYX30?ooo`800?ZJ0`3oool0203o00000?ZJ003jVP00nYX0o`000000o`3oool00?ZJ0P3oool01000
nYX0o`000?ooo`00nYX20?ooo`030?l00000nYX0oooo00<0oooo00<00?ZJ0?l0003o00001P3oool2
003jVP050?l0003oool0o`000000o`00nYX01@3oool00`00nYX0o`000?ooo`020?ooo`04003jVP3o
ool0o`00003jVPL0oooo00<00?ZJ0?ooo`000?l00P00nYX30?ooo`03003jVP3o0000oooo00@00?ZJ
00<0o`00003jVP3oool0103oool01000nYX0oooo0?ooo`00nYX30?ooo`06003jVP3o0000oooo0?l0
003oool00?ZJ103oool02000nYX0o`00003jVP3oool00?ZJ0?ooo`00nYX0o`001@3oool2003jVPD0
oooo0`00nYX40?ooo`03003jVP000?l0oooo0080o`001@3oool300000005003jVP3o0000oooo003j
VP3oool00P00000k0?ooo`00@03oool010000000oooo0?ooo`00nYX30?ooo`03003jVP3o0000o`00
01@0oooo00L00?ZJ0?ooo`00nYX0o`00003jVP3o00000?ZJ01d0oooo00D00?ZJ0?l00000nYX0o`00
003jVP0A0?ooo`03003jVP3oool0oooo00T0oooo00@00?ZJ0?ooo`3oool00?ZJ103oool01@00nYX0
003o0?l0003oool00?ZJ00H0oooo0P00nYX00`3o0000oooo0?l0000O0?ooo`06003jVP000?l0o`00
0?l0003oool00?ZJ703oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo
00<000000?ooo`00nYX00P3oool01@000?l0oooo003jVP3o00000?ZJ00<0oooo00@00?ZJ0?ooo`00
nYX00?ZJ1P3oool2003jVP<0oooo00<00?ZJ0?ooo`3oool00P3o00000`3oool00?ZJ0?l0000M0?oo
o`050?l00000nYX0oooo0?l00000nYX0403oool00`00nYX0oooo003jVP040?ooo`03003jVP3oool0
oooo00800?ZJ00H0o`000000o`000?l0oooo0?l0003oool2003jVP070000o`3o00000?ZJ003jVP3o
0000oooo003jVP040?ooo`07003jVP3oool0003o0?l0003oool0o`00003jVP0K0?ooo`<00?ZJ00L0
o`00003jVP3oool00?ZJ0?l00000nYX0000001X0oooo00D000000?ooo`3oool0oooo000000020?oo
o`050000003oool0oooo0?ooo`0000000`3oool01000nYX0o`000?ooo`00nYX30?ooo`800?ZJ0`3o
ool0203o00000?ZJ0?ooo`00nYX0oooo0?l0003oool00?ZJ0P3oool01000nYX0o`00003jVP00nYX2
0?ooo`030?l00000nYX0oooo0080oooo00@00?ZJ0?l0003oool0o`001P3oool2003jVP050?l0003o
ool0o`000000o`00nYX01@3oool00`00nYX0o`000?ooo`020?ooo`04003jVP3oool00?ZJ0?l000H0
oooo0P00nYX0103oool0003o0?ooo`00nYX30?ooo`03003jVP3o0000oooo00<00?ZJ00<0oooo0?l0
0000nYX0103oool2003jVP80oooo00L00?ZJ0?ooo`3oool0oooo003jVP3o0000oooo0080o`0000<0
0?ZJ0?ooo`3oool00P3oool02000nYX0o`00003jVP3oool00?ZJ0?ooo`00nYX0o`00103oool00`00
nYX0oooo003jVP050?ooo`03003jVP3oool00?ZJ00@0oooo00<00?ZJ0000o`3oool00P3o00050?oo
o`<0000000@00?ZJ0?l000000?l00?ZJ0P3oool00`000000oooo0?ooo`0i0?ooo`00@03oool01000
0000oooo0?ooo`00nYX30?ooo`030000o`3o0000o`0001@0oooo00L00?ZJ0?ooo`00nYX0o`00003j
VP3o00000?ZJ01d0oooo00D00?ZJ0?l00000nYX0o`00003jVP0A0?ooo`03003jVP3oool0oooo00P0
oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0080o`0000<0oooo003j
VP3oool01@3oool2003jVP030?l0003oool0o`0001l0oooo00H00?ZJ0?l0003oool0o`000?ooo`00
nYXL0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool00`000000oooo
003jVP020?ooo`050000o`3oool00?ZJ0?l00000nYX00`3oool01000nYX0oooo0?ooo`00nYX60?oo
o`800?ZJ0`3oool02000nYX0oooo0?ooo`3o00000?ZJ0?ooo`00nYX0o`00703oool01P00nYX0o`00
003jVP3oool0o`00003jVQ00oooo00<00?ZJ0?ooo`00nYX0103oool00`00nYX0oooo0?ooo`02003j
VP060?l0003oool00?ZJ003jVP3o0000oooo0P00nYX01`3o0000oooo003jVP00nYX0o`000?ooo`00
nYX0103oool01`00nYX0oooo0000o`3o0000oooo0?l00000nYX06@3oool5003jVP070?l00000nYX0
oooo003jVP3o00000?ZJ0000000G0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`0000030?ooo`080000003oool0oooo0?ooo`00nYX0o`000?ooo`00nYX30?ooo`800?ZJ
0`3oool0203o00000?ZJ0?ooo`00nYX0oooo0?l0003oool00?ZJ0P3oool02000nYX0o`00003jVP3o
ool00?ZJ0?ooo`3o00000?ZJ0`3oool01@00nYX0o`000?ooo`3o00000?ZJ00D0oooo0P00nYX01@3o
0000oooo0?l000000?l00?ZJ00D0oooo00<00?ZJ0?l0003oool00P3oool01000nYX0oooo003jVP3o
00060?ooo`06003jVP000?l0oooo0000o`3oool00?ZJ0`3oool00`00nYX0o`00003jVP020?ooo`04
003jVP3oool0o`00003jVP<0oooo0`00nYX20?ooo`05003jVP3oool0oooo0?ooo`3o00000`3oool0
0`3o00000?ZJ0?ooo`030?ooo`08003jVP3o00000?ZJ0?ooo`00nYX0oooo003jVP3o00040?ooo`03
003jVP3oool00?ZJ00D0oooo00<00?ZJ0?ooo`00nYX00`3oool00`00nYX0003o0?ooo`030?l000@0
oooo00P00?ZJ0000o`3o0000oooo003jVP3o0000003o003jVP80oooo00<000000?ooo`3oool0>@3o
ool00400oooo00@000000?ooo`3oool00?ZJ0`3oool00`000?l0o`000?l0000D0?ooo`07003jVP3o
ool00?ZJ0?l0003oool0o`00003jVP0M0?ooo`05003jVP3o00000?ZJ0?l00000nYX0403oool2003j
VPX0oooo00<00?ZJ0?ooo`3oool00P3oool02@00nYX0oooo0?ooo`00nYX0oooo0?l000000?l0o`00
003jVP050?ooo`06003jVP3oool00?ZJ0?l0003oool0o`007`3oool01P00nYX0o`000?ooo`3o0000
003o003jVQ/0oooo0P0000040?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`00nYX0
0P3oool00`000?l0oooo0?ooo`020?l000<0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool2003jVP<0
oooo00P00?ZJ0?ooo`3oool0o`00003jVP3oool00?ZJ0?l001`0oooo00H00?ZJ0?l0003oool0oooo
0?l00000nYX?0?ooo`04003jVP3oool0oooo003jVP@0oooo00@00?ZJ0?ooo`3oool00?ZJ0P3o0000
1@00nYX0003o003jVP3o0000oooo00800?ZJ00L0o`000?ooo`00nYX00?ZJ0?l0003oool00?ZJ00<0
oooo00P00?ZJ0?ooo`3oool0003o0?l0003oool0o`00003jVQT0oooo00<00?ZJ0?ooo`3oool00P00
nYX01`3o00000?ZJ0?ooo`00nYX0o`00003jVP0000005`3oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000000`3oool02@000000oooo0?ooo`3oool00?ZJ0?l0003oool0
003o003jVP020?ooo`04003jVP3oool00?ZJ0?ooo`<0000000H0oooo003jVP3oool0o`000?ooo`00
nYX20?ooo`08003jVP3o00000?ZJ0?ooo`00nYX0oooo003jVP3o00030?ooo`06003jVP3o0000oooo
0?l000000?l00?ZJ103oool00`00nYX0o`000?l000020000o`030?l00000nYX0oooo00@0oooo00T0
o`000000o`00nYX00?ZJ0?ooo`00nYX0oooo003jVP3o00001P3oool00`00nYX0oooo0?ooo`020000
o`07003jVP3oool0oooo0?ooo`00nYX0o`00003jVP040?ooo`030?l00000nYX0oooo0080oooo0P00
nYX20?l00080oooo00@00?ZJ0?ooo`3oool0o`000P00nYX00`3oool0o`00003jVP040?ooo`030?l0
0000nYX0oooo0080oooo0P00nYX00`3o0000oooo0?ooo`020?ooo`03003jVP3oool00?ZJ00@0oooo
0P00nYX00`3oool00?ZJ0?ooo`020?ooo`03003jVP000?l0o`0000<0o`0000`00?ZJ0?ooo`3oool0
oooo003jVP3o00000?ZJ0?ooo`00nYX0o`000000o`00nYX20?ooo`030000003oool0oooo03T0oooo
000c0?ooo`<00000103oool2000000@0oooo00@000000?ooo`3oool00?ZJ0`3oool00`000?l0o`00
0?l0000D0?ooo`07003jVP3oool00?ZJ0?l0003oool0o`00003jVP0M0?ooo`05003jVP3o0000oooo
0?l00000nYX0403oool2003jVPX0oooo00H00?ZJ0?ooo`3o0000o`000?ooo`00nYX20?ooo`06003j
VP000?l0o`000?ooo`3o00000?ZJ1@3oool01`00nYX0oooo0?l00000nYX0oooo0?l00000nYX07P3o
ool01P00nYX0o`000?ooo`3o0000003o003jVQ`0oooo00<000000?ooo`3oool00`3oool2000000@0
oooo00<000000?ooo`00nYX00P3oool00`000?l0oooo0?ooo`020?l000<0oooo00@00?ZJ0?ooo`3o
ool00?ZJ1P3oool2003jVP80oooo0P00nYX01`3oool0o`000?ooo`00nYX0oooo003jVP3o0000703o
ool01P00nYX0o`000?ooo`3oool00?ZJ0?l000l0oooo00@00?ZJ0?ooo`3oool00?ZJ103oool02`00
nYX0oooo0?ooo`00nYX0o`000?ooo`00nYX0003o003jVP3o0000oooo00800?ZJ00L0o`000?ooo`00
nYX00?ZJ0000o`3o00000?ZJ00<0oooo00P00?ZJ0?ooo`3oool0003o0?l0003oool0o`00003jVQP0
oooo00@00?ZJ0?ooo`3oool0oooo0P00nYX01`3o00000?ZJ0?ooo`00nYX0o`00003jVP000000603o
ool3000000@0oooo0P0000040?ooo`090000003oool0oooo0?ooo`00nYX0o`000?ooo`000?l00?ZJ
0080oooo00@00?ZJ0?ooo`00nYX0oooo0`0000020?ooo`04003jVP3o0000oooo003jVP80oooo00P0
o`000000o`00nYX0oooo003jVP3oool00?ZJ0?l000<0oooo00<00?ZJ0?l0000000000P0000000`00
nYX0oooo0?ooo`020?ooo`07003jVP3o00000?ZJ003jVP3oool0o`00003jVP040?ooo`03003jVP3o
0000oooo00800?ZJ00D0oooo003jVP3oool00?ZJ0?l000060?ooo`06003jVP3oool0oooo0?ooo`00
0?l00?ZJ0`3oool00`00nYX0o`00003jVP040?ooo`030?l00000nYX0oooo0080oooo0P00nYX30?l0
00030?ooo`00nYX0oooo00<0000000@00?ZJ0?ooo`3o00000?ZJ103oool00`3o00000?ZJ0?ooo`02
0?ooo`800?ZJ00<0o`000?ooo`3oool00P3oool00`00nYX0oooo003jVP040?ooo`04003jVP3oool0
oooo003jVP<0oooo00L00?ZJ0000o`3o0000oooo003jVP3o00000?ZJ00<0oooo00<00?ZJ0?l00000
nYX00P3oool01000nYX0o`00003jVP3oool2000003/0oooo000d0?ooo`030000003oool0oooo0080
oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00nYX20?ooo`040000o`3oool0
o`000?l001@0oooo00L00?ZJ0?ooo`00nYX0o`000?ooo`00nYX0o`0001d0oooo00D0o`00003jVP3o
ool0o`00003jVP0@0?ooo`800?ZJ2P3oool01P00nYX0o`000?ooo`3o0000oooo003jVP80oooo00H0
0?ZJ0?l0003o0000oooo0?l00000nYX50?ooo`07003jVP3oool0o`00003jVP3oool0o`00003jVP0N
0?ooo`06003jVP3o00000?ZJ003jVP3o00000?ZJ:03oool00`0000000?ZJ0?ooo`020?ooo`030000
o`3oool0oooo0080o`000`3oool01000nYX0oooo0?ooo`00nYX60?ooo`800?ZJ0P3oool02@00nYX0
oooo0?ooo`3o0000oooo003jVP3oool00?ZJ0?l0000K0?ooo`03003jVP3o00000?ZJ0080oooo00<0
0?ZJ0?l0003oool03P3oool01000nYX0oooo0?ooo`00nYX40?ooo`03003jVP3oool0000000800000
0P00nYX010000?l00?ZJ0?l0003oool2003jVP070?l00000nYX0oooo0?ooo`00nYX0o`00003jVP03
0?ooo`08003jVP3oool0003o0?ooo`3o0000oooo0?l00000nYXH0?ooo`0=003jVP3oool0oooo0?oo
o`00nYX0o`000?ooo`00nYX0oooo003jVP3o00000?ZJ0000000U0?ooo`090000003oool0oooo0?oo
o`00nYX0o`000?ooo`000?l00?ZJ0080oooo00@00?ZJ0?ooo`00nYX0oooo0`0000020?ooo`04003j
VP3o0000oooo003jVP80oooo00P0o`00003jVP3oool0oooo003jVP3oool00?ZJ0?l000<0oooo00<0
0?ZJ0?l0000000000P000002003jVP80oooo00P00?ZJ0000000000000000003jVP3oool0o`00003j
VP@0oooo00/00?ZJ0?l00000nYX0oooo003jVP3oool00?ZJ0?ooo`00nYX0o`00003jVP030?ooo`03
003jVP3oool00?ZJ00<0oooo00<0003o0?ooo`00nYX00P3oool00`3o00000?ZJ003jVP040?ooo`03
0?l00000nYX0oooo0080oooo00P00?ZJ0?l0003o0000oooo0?l0003oool00?ZJ0?ooo`<0000000D0
oooo003jVP3o0000oooo003jVP020?ooo`03003jVP3o00000?ZJ00<0oooo0P00nYX00`3o0000oooo
0?ooo`020?ooo`03003jVP3oool00?ZJ00@0oooo00@00?ZJ0?ooo`3oool00?ZJ0`3oool01`00nYX0
o`000?l0003oool00?ZJ0?l00000nYX00`3oool00`00nYX0o`00003jVP020?ooo`03003jVP3o0000
0?ZJ0080oooo00<000000?ooo`3oool0>@3oool002`0oooo1@0000030?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00nYX20?ooo`050000o`3o
ool0o`000?l00000nYX04`3oool01`00nYX0oooo003jVP3o0000oooo003jVP3o00007@3oool01@3o
00000?ZJ0?ooo`3o00000?ZJ0100oooo0P00nYX:0?ooo`03003jVP3o0000oooo0080o`0000D00?ZJ
0?ooo`3oool00?ZJ0?l000020?ooo`030?l00000nYX0oooo00@0oooo00<00?ZJ0?ooo`3o00000P3o
ool00`3o00000?ZJ0?ooo`0M0?ooo`06003jVP3o00000?ZJ003jVP3o00000?ZJ:03oool010000000
0?ZJ0?ooo`3oool20?l00080oooo0P3o00030?ooo`04003jVP3oool0oooo003jVPH0oooo0P00nYX0
0`3oool00?ZJ003jVP020?ooo`060?l0003oool00?ZJ0?ooo`00nYX0o`00103oool00`00nYX0oooo
0?ooo`0D0?ooo`03003jVP3o00000?ZJ0080oooo00<00?ZJ0?l0003oool03P3oool01000nYX0oooo
0?ooo`00nYX40?ooo`03003jVP000?l000000080000000X00?ZJ0?ooo`000?l00?ZJ0?l0003oool0
0?ZJ0?l000000?l00?ZJ0P3oool00`00nYX0o`00003jVP030?ooo`08003jVP3oool0003o0?ooo`3o
0000oooo0?l00000nYXH0?ooo`06003jVP3oool0oooo0?ooo`00nYX0o`000P00nYX01@3oool00?ZJ
0?l00000nYX0000002D0oooo00T000000?ooo`3oool0oooo003jVP3o0000oooo0000o`00nYX00P3o
ool01P00nYX0oooo003jVP3oool00?ZJ0?l000<0oooo00@00?ZJ0?l0003oool00?ZJ0P3oool0203o
00000?ZJ0?ooo`3oool00?ZJ0?ooo`00nYX0o`000`3oool00`00nYX0o`0000000002000000050?oo
o`00nYX0oooo0?ooo`00nYX00`000000103oool00?ZJ0?l00000nYX40?ooo`0;003jVP3o00000?ZJ
0?ooo`00nYX0oooo003jVP3oool00?ZJ0?l00000nYX00P3oool3003jVP070000o`3o0000o`000?oo
o`000?l0oooo003jVP020?ooo`030?l00000nYX0oooo00@0oooo00<0o`00003jVP3oool00P3oool0
2000nYX0o`000000o`000?l0o`000?ooo`00nYX0oooo0`0000001@3oool00?ZJ0?l0003oool00?ZJ
0080oooo00<00?ZJ0?l00000nYX00`3oool2003jVP050?l0003oool0oooo0?ooo`00nYX00P3oool0
1000nYX0oooo0?ooo`3oool2003jVP030000o`3oool00?ZJ00<0oooo00L00?ZJ0?l0003oool0oooo
003jVP3o00000?ZJ00<0oooo00<00?ZJ0?l00000nYX00P3oool00`00nYX0o`00003jVP020?ooo`03
0000003oool0oooo03T0oooo000d0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
00000`3oool2000000060?ooo`00nYX0oooo0?ooo`000?l0oooo0P3o00000`00nYX0oooo0?ooo`0@
0?ooo`08003jVP3oool0oooo0?l00000nYX0oooo003jVP3o000M0?ooo`050?l00000nYX0oooo0?l0
0000nYX0403oool2003jVPT0oooo0P00nYX01@3o0000oooo0?ooo`3o00000?ZJ0080oooo00H00?ZJ
0?l0003oool00?ZJ0?l00000nYX50?ooo`03003jVP3oool0o`000080oooo00<0o`00003jVP3oool0
7@3oool01P00nYX0o`00003jVP00nYX0o`00003jVRP0oooo00@00000003jVP3oool0oooo0P3o0002
0?ooo`80o`000`3oool01000nYX0oooo0?ooo`00nYX60?ooo`@00?ZJ0P3oool010000?l0o`000?oo
o`00nYX20?ooo`040?l00000nYX0oooo0?ooo`800?ZJ5P3oool00`00nYX0o`00003jVP020?ooo`03
003jVP3o0000oooo00d0oooo00D00?ZJ0?ooo`3oool0oooo003jVP040?ooo`03003jVP3o00000000
0080000000X00?ZJ0?ooo`3oool00?ZJ0?ooo`3o00000?ZJ0?l0003oool00?ZJ0P3oool00`00nYX0
o`00003jVP020?ooo`800?ZJ00L0oooo0000o`3oool0o`000?ooo`3o00000?ZJ01P0oooo00L00?ZJ
0?ooo`3oool0oooo003jVP3o00000?ZJ0080oooo00@00?ZJ0?l0003oool00?ZJ9@3oool02`000000
oooo0?ooo`3oool00?ZJ0?l0003oool0003o003jVP3oool00?ZJ0080oooo00@00?ZJ0?ooo`00nYX0
o`000`3oool01000nYX0o`000000o`00nYX20?ooo`080?l00000nYX0oooo0?ooo`00nYX0oooo003j
VP3o00030?ooo`07003jVP3o00000?ZJ003jVP3o0000003o003jVP020?ooo`09003jVP0000000000
0000003oool00?ZJ0?l000000?l00?ZJ00<0oooo00/00?ZJ0?l00000nYX0oooo003jVP3oool00?ZJ
0?ooo`00nYX0o`00003jVP020?ooo`<00?ZJ0`3o0000203oool0003o0?ooo`00nYX0oooo003jVP3o
00000?ZJ1@3oool00`3o00000?ZJ0?ooo`020?ooo`<0000000L0003o0?l0003oool00?ZJ0?ooo`00
0?l0o`000080oooo00@00?ZJ0?l0003oool00?ZJ0P3oool00`00nYX0o`00003jVP030?ooo`800?ZJ
00D0o`000?ooo`3oool0oooo003jVP020?ooo`05003jVP3oool0oooo0?ooo`00nYX00P000?l01`3o
ool00?ZJ0?ooo`3oool00?ZJ0000o`3o00000P3oool00`00nYX0o`00003jVP030?ooo`03003jVP3o
00000?ZJ0080oooo00H00?ZJ0?l00000nYX0oooo00000000nYXk0?ooo`00=03oool00`000000oooo
0?ooo`020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool00?ZJ0P3oool01@00
0?l0oooo0?l0003o00000?ZJ0180oooo00P00?ZJ0?ooo`3oool0o`00003jVP3oool00?ZJ0?l001`0
oooo00H00?ZJ0?l00000nYX0oooo0?l00000nYX@0?ooo`800?ZJ2@3oool00`00nYX0o`000?l00002
0?ooo`060?l00000nYX0oooo0?ooo`00nYX0o`000P00nYX00`3o00000?ZJ0?ooo`040?ooo`07003j
VP00000000000000003oool0o`00003jVP0M0?ooo`03003jVP3o0000003o00800?ZJ00<0o`00003j
VP3oool09`3oool0100000000?ZJ0?ooo`3oool20?l00080oooo0P3o00020?ooo`05003jVP3oool0
oooo0?ooo`00nYX01P3oool3003jVP80oooo00D0003o0?l0003oool0oooo003jVP020?ooo`040?l0
0000nYX0oooo0?ooo`800?ZJ3`3oool00`00nYX0oooo0?ooo`030?ooo`04003jVP00000000000000
0080oooo00<00?ZJ0?l0003oool03@3oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ
0?l0003o00000P3o00002@00nYX0oooo0?ooo`3oool00?ZJ0?ooo`3o00000?ZJ0?l00002003jVP80
oooo00<00?ZJ0?l00000nYX00P3oool02@00nYX0oooo0?ooo`000?l0oooo0?l0003oool0o`00003j
VP0H0?ooo`04003jVP3oool0oooo0?ooo`80o`0000L00?ZJ0?ooo`3oool00?ZJ0?l0003oool00?ZJ
02D0oooo00/000000?ooo`3oool0oooo003jVP3o0000oooo0000o`00nYX0oooo003jVP020?ooo`<0
0?ZJ00`0o`000?ooo`3oool0oooo003jVP3o0000003o003jVP3oool00?ZJ0?l00000nYX20?ooo`04
003jVP3oool00?ZJ0?l000<0oooo00<0o`00003jVP000?l00P00nYX01`3o00000?ZJ0?ooo`3oool0
0?ZJ0000o`3o00000P3oool01000nYX0o`000000o`00nYX30?ooo`03003jVP3o00000?ZJ0080oooo
0P00nYX0103oool00?ZJ0?l00000nYX20?ooo`<00?ZJ00/0o`000?ooo`3oool0o`000000o`3oool0
0?ZJ0?ooo`00nYX0o`00003jVP050?ooo`030?l00000nYX0oooo0080oooo0`0000001`00nYX0oooo
0?l00000nYX0oooo0000o`3o00000P3oool01000nYX0o`000?ooo`00nYX20?ooo`03003jVP3o0000
oooo00<0oooo0P00nYX01@3o0000oooo0?ooo`3oool00?ZJ0080oooo00L00?ZJ0?ooo`3oool0003o
003jVP3oool0003o0080o`000P3oool00`00nYX0003o0?l000020?ooo`800?ZJ00L0o`000?ooo`3o
ool0oooo0?l0003oool00?ZJ0080oooo00<00?ZJ0?l00000nYX00P3oool00`00nYX0oooo0?ooo`0i
0?ooo`00<`3oool2000000@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00
nYX20?ooo`050000o`3oool0o`000?l00000nYX04P3oool02000nYX0oooo0?ooo`3o00000?ZJ0?oo
o`00nYX0o`00703oool01P00nYX0o`00003jVP3oool0o`00003jVQ00oooo0P00nYX90?ooo`07003j
VP3o0000003o0000o`3oool0o`00003jVP020?ooo`06003jVP3o00000?ZJ003jVP3o00000?ZJ1@3o
ool01`00nYX00000000000000000oooo0?l00000nYX07@3oool00`00nYX0o`000000o`02003jVP03
0?l00000nYX0oooo02L0oooo00H00000003jVP3oool0o`000?ooo`3o00020?ooo`80o`000P3oool0
1@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo0`00nYX0103oool0003o0000o`3o00020?ooo`05003j
VP3oool0oooo0?l00000nYX00P3oool2003jVPh0oooo0P00nYX50?ooo`04003jVP00000000000000
0080oooo00<00?ZJ0?l00000nYX0303oool2003jVP<0oooo00T00?ZJ0?ooo`3oool0oooo003jVP3o
0000003o0?ooo`00nYX0103oool00`00nYX0oooo0000000200000007003jVP3oool0oooo0?ooo`00
nYX0o`00003jVP020?ooo`09003jVP3oool0oooo0000o`3oool0o`000?ooo`00nYX0o`0001P0oooo
00<00?ZJ0?ooo`3oool00`0000001`00nYX0oooo0?ooo`00nYX0o`000?ooo`00nYX09@3oool02`00
0000oooo0?ooo`3oool00?ZJ0?l0003oool0003o003jVP3oool00?ZJ00<0oooo00<00?ZJ0000o`3o
00000`3oool02000nYX0o`000000o`00nYX0oooo003jVP3o00000?ZJ0P3oool01000nYX0oooo003j
VP3o00030?ooo`060?l00000nYX0oooo0?ooo`00nYX0o`000P00nYX0103oool00?ZJ0?l00000nYX2
0?ooo`09003jVP3o0000003o003jVP3oool00?ZJ0?ooo`3o00000?ZJ00<0oooo0P00nYX0103oool0
0?ZJ0?l00000nYX20?ooo`<00?ZJ00/0o`000?ooo`3oool0o`000000o`3oool00?ZJ0?ooo`00nYX0
o`00003jVP050?ooo`030?l00000nYX0oooo0080oooo0`0000001`00nYX0oooo0?l00000nYX0oooo
003jVP3o00000P3oool01000nYX0o`000?ooo`00nYX20?ooo`030?l00000nYX0oooo00<0oooo0P00
nYX01P3o0000oooo0?ooo`3oool00?ZJ0?ooo`80o`000P3oool00`00nYX0003o0?ooo`030?l00080
oooo00<00?ZJ0?l0003oool00P3oool2003jVP070?l0003oool0oooo0?ooo`3o0000oooo003jVP02
0?ooo`03003jVP3o00000?ZJ0080oooo00<00?ZJ0?ooo`3oool0>@3oool003@0oooo00<000000?oo
o`3oool00`3oool2000000@0oooo00@000000?ooo`3oool00?ZJ0P3oool01@000?l0oooo0?l0003o
00000?ZJ00D0oooo00<00?ZJ0?ooo`3oool02P3oool01000nYX0oooo0?ooo`3o00020?ooo`03003j
VP3o0000oooo01/0oooo00H00?ZJ0?l00000nYX0oooo003jVP3o000@0?ooo`800?ZJ2@3oool00`00
nYX0o`000?ooo`02003jVP040?l00000nYX0oooo003jVP80o`000P00nYX00`3oool0o`000?ooo`03
0?ooo`03003jVP3oool000000080000000<0oooo003jVP3o00007@3oool01`00nYX0o`00003jVP3o
ool00?ZJ0?l00000nYX0:03oool01P0000000?ZJ0?ooo`3o0000003o0?l00080oooo0P3o00020?oo
o`05003jVP3oool0oooo0?ooo`00nYX01P3oool3003jVP040?ooo`000?l0o`000?l00080oooo00H0
0?ZJ0?ooo`3oool0o`00003jVP3oool3003jVPh0oooo0P00nYX40?ooo`800?ZJ0`0000020?ooo`03
003jVP3o00000?ZJ00/0oooo00<00?ZJ0?ooo`3oool00`3oool01P00nYX0oooo0?ooo`3oool00?ZJ
0?l00080oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0003o0000000200000008003jVP3oool0
oooo0?ooo`00nYX0o`00003jVP3oool2003jVP80oooo00H0003o0?l0003o0000oooo003jVP3o000H
0?ooo`03003jVP3o0000o`0000<000000`3oool01000nYX0oooo0?l00000nYXU0?ooo`0;0000003o
ool0oooo0?ooo`00nYX0o`000?ooo`000?l00?ZJ0?ooo`00nYX0103oool00`000?l0o`000?ooo`02
0?ooo`07003jVP3o0000003o003jVP3oool00?ZJ0?l000030?ooo`04003jVP3oool00?ZJ0?l000<0
oooo00L0o`00003jVP3oool0oooo003jVP3o0000oooo00<00?ZJ00d0o`00003jVP3oool0oooo003j
VP3o0000003o003jVP3oool00?ZJ0?ooo`3o00000?ZJ00<0oooo0P00nYX0103oool00?ZJ0?l00000
nYX20?ooo`800?ZJ00@0o`000?ooo`3oool0oooo0P3o00001@3oool00?ZJ0?ooo`00nYX0o`0000H0
oooo00`0o`00003jVP3oool0oooo003jVP3o00000?ZJ0?ooo`00nYX0oooo0?l0003oool2003jVP0;
0?l0003oool0oooo003jVP3o0000oooo003jVP3oool00?ZJ0?l00000nYX0103oool2003jVP060?l0
003oool0oooo0?ooo`00nYX0003o0P3o00000`3oool00?ZJ003jVP020?ooo`030?l0003oool0o`00
0080oooo00<00?ZJ0?l0003oool00P3oool2003jVP050?l0003oool0oooo0?ooo`3o00000P00nYX2
0?ooo`04003jVP3o00000?ZJ0?ooo`800?ZJ>`3oool00400oooo00@000000?ooo`3oool00?ZJ0P3o
ool01@000?l0oooo0?l00000nYX0o`0000@0oooo0P00nYX<0?ooo`04003jVP3oool0oooo0?l000<0
oooo00<0o`00003jVP3oool06P3oool01P00nYX0o`00003jVP3oool00?ZJ0?l000l0oooo00<00?ZJ
0?ooo`00nYX01`3oool01000nYX0oooo003jVP3o0003003jVP0:0?l00000nYX0oooo003jVP3o0000
oooo003jVP3oool00?ZJ0?l000@0oooo00@00?ZJ0?ooo`3oool0o`000P3oool00`00nYX0o`000?oo
o`0J0?ooo`09003jVP3oool00?ZJ0?l00000nYX0oooo003jVP3o00000?ZJ02P0oooo00H00000003j
VP3oool0o`000000o`3o00020?ooo`80o`000P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo
0P00nYX20?l000030000o`3o0000oooo0080oooo00T00?ZJ0?ooo`3oool0o`00003jVP3oool00?ZJ
0?ooo`00nYX03P3oool2003jVP@0oooo00@00?ZJ0?ooo`000?l0o`000`3oool00`00nYX0o`00003j
VP0:0?ooo`800?ZJ1@3oool01P00nYX0oooo0?ooo`3oool00?ZJ0?l00080oooo00<00?ZJ0?ooo`3o
ool00P3oool00`000?l00?ZJ00000002000000@0oooo00D00?ZJ0?l00000nYX0oooo003jVP030?oo
o`80o`0000@00?ZJ0?ooo`00nYX0o`00603oool00`00nYX0o`000000o`03000000<0oooo00@00?ZJ
0?ooo`3o00000?ZJ9@3oool02`000000oooo0?ooo`3oool00?ZJ0?l0003oool0003o003jVP3oool0
0?ZJ00@0oooo00<0003o0?l0003oool00P3oool01`00nYX0o`000000o`00nYX0oooo003jVP3o0000
103oool2003jVP060?l0003oool0oooo0?ooo`3o00000?ZJ0P3oool00`00nYX0o`000?ooo`02003j
VP030?ooo`3o00000?ZJ0080oooo00<00?ZJ0?ooo`3o00000`00nYX00`3oool0o`00003jVP030?oo
o`800?ZJ00@0oooo003jVP3o00000?ZJ0P3oool2003jVP030?l0003oool0oooo0080oooo00H0o`00
0?ooo`00nYX0oooo003jVP3o00060?ooo`0<003jVP3o0000oooo0?ooo`00nYX0o`00003jVP3oool0
003o003jVP3o0000oooo0P00nYX02`3o0000oooo0?ooo`00nYX0003o0?l00000nYX0oooo003jVP3o
00000?ZJ00@0oooo0P00nYX0203o0000oooo0?ooo`3oool00?ZJ0?l000000?l0o`000P00nYX20?oo
o`80o`0000H0003o0?l0003oool0oooo003jVP3o00030?ooo`800?ZJ00H0o`000?ooo`3oool00?ZJ
0?l00000nYX30?ooo`04003jVP3o00000?ZJ0?ooo`800?ZJ>`3oool00400oooo00@000000?ooo`3o
ool00?ZJ0P3oool01@000?l0oooo0?l00000nYX0o`0000@0oooo0P00nYX<0?ooo`04003jVP3oool0
oooo0?l000<0oooo00<0o`00003jVP3oool06P3oool01`00nYX0o`000?ooo`3oool00?ZJ0?l00000
nYX03P3oool00`00nYX0oooo003jVP060?ooo`<00?ZJ00l0003o0?l00000nYX0003o003jVP3oool0
o`000?ooo`00nYX0o`000?ooo`00nYX0oooo003jVP3o0000103oool01000nYX0oooo0?ooo`3o0002
0?ooo`03003jVP3o0000oooo01X0oooo00T00?ZJ0?ooo`00nYX0o`00003jVP3oool00?ZJ0?l00000
nYX0:03oool01P00nYX0oooo0?ooo`3o0000003o0?l00080oooo0P3o00020?ooo`05003jVP3oool0
oooo0?ooo`00nYX01P3oool2003jVP@0o`000`3oool02@00nYX0oooo0?ooo`3o00000?ZJ0?ooo`00
nYX0oooo003jVP0>0?ooo`800?ZJ0`3oool2003jVP030000o`3oool0o`0000<0oooo00<00?ZJ0?l0
0000nYX02P3oool00`00nYX0oooo0?ooo`040?ooo`06003jVP3oool0oooo0?ooo`00nYX0o`000P3o
ool00`00nYX0oooo0?ooo`030?ooo`04003jVP000?l0o`00003jVP@0oooo00D00?ZJ0?l00000nYX0
oooo003jVP020?ooo`070000o`3o0000oooo003jVP3oool00?ZJ0?l0000H0?ooo`05003jVP3o0000
003o0000o`00nYX01@3oool00`00nYX0o`00003jVP0U0?ooo`0;0000003oool0oooo0?ooo`00nYX0
o`000?ooo`000?l00?ZJ0?ooo`00nYX0103oool00`000?l0o`000?ooo`020?ooo`07003jVP3oool0
o`00003jVP3oool00?ZJ0?l000040?ooo`800?ZJ00H0o`00003jVP3oool00?ZJ0?l00000nYX20?oo
o`03003jVP3o0000oooo00800?ZJ00<0oooo0?l00000nYX00P3oool00`00nYX0oooo0?l00003003j
VP030?ooo`3o00000?ZJ00<0oooo0P00nYX0103oool00?ZJ0?l00000nYX20?ooo`800?ZJ00<0o`00
0?ooo`3oool00P3oool01P3o0000oooo003jVP3oool0o`00003jVPH0oooo00L00?ZJ0?l0003oool0
oooo003jVP3o00000?ZJ0080oooo00<00?ZJ0?l0003oool00P00nYX02`3o0000oooo0?ooo`3oool0
0?ZJ0?l00000nYX0oooo003jVP3o00000?ZJ00@0oooo0P00nYX01P3o0000oooo0?ooo`3oool00?ZJ
0?l000<0000000h0003o0?ooo`3oool0o`000?ooo`000?l0o`000?ooo`00nYX0003o0?l0003oool0
0?ZJ0?ooo`800?ZJ00H0o`000?ooo`3oool00?ZJ0?l00000nYX30?ooo`04003jVP3o00000?ZJ0?oo
o`<00000>P3oool00400oooo00<000000?ooo`00nYX00`3oool01@000?l0oooo0?l00000nYX0o`00
00@0oooo0P00nYX;0?ooo`03003jVP3oool0oooo00<000000P3oool00`3o00000?ZJ0?ooo`0J0?oo
o`070?l00000nYX0oooo0?ooo`00nYX0o`00003jVP0>0?ooo`03003jVP3oool00?ZJ00H0oooo0`00
nYX03`3o0000oooo003jVP000?l00?ZJ0?ooo`3o0000oooo003jVP3o0000oooo003jVP3oool00?ZJ
0?l000040?ooo`04003jVP3oool0oooo0?l00080oooo00<00?ZJ0?l0003oool06@3oool3003jVP07
0000o`3o00000?ZJ0?ooo`00nYX0o`00003jVP0X0?ooo`03003jVP3oool0o`000080003o00<0o`00
0?ooo`3oool00P3o00020?ooo`05003jVP3oool0oooo0?ooo`00nYX01P3oool2003jVP030?l00000
0?l0oooo00@0oooo00@00?ZJ0?ooo`3oool0o`000`00nYX00`3oool00?ZJ0?ooo`0=0?ooo`800?ZJ
0P3oool2003jVP80003o00<0oooo0?l0003oool00P3oool00`00nYX0o`00003jVP0:0?ooo`03003j
VP3oool0oooo00@0oooo00H00?ZJ0?ooo`3oool0oooo003jVP3o00020?ooo`03003jVP3oool0oooo
00<0oooo00<00?ZJ0?ooo`00nYX01@3oool00`00nYX0003o0?l00002003jVP090?ooo`000?l0o`00
0?l0003oool00?ZJ0?ooo`00nYX0o`0001P0oooo00D0o`000000o`3oool0003o003jVP050?ooo`03
003jVP3o00000?ZJ02D0oooo00/000000?ooo`3oool0oooo003jVP3o0000oooo0000o`00nYX0oooo
003jVP040?ooo`030000o`3o0000oooo0080oooo00L00?ZJ0?ooo`3o00000?ZJ0?ooo`3o00000?ZJ
00@0oooo0P00nYX01P3o00000?ZJ0?ooo`00nYX0o`00003jVP80oooo00<00?ZJ0?l0003oool00`3o
ool01`3o00000?ZJ0?ooo`3oool00?ZJ0?ooo`3o00001000nYX00`3o00000?ZJ0?ooo`020?ooo`80
0?ZJ0P3oool01@3o00000?ZJ0?ooo`00nYX0oooo0080o`000P00nYX20?ooo`060?l0003oool00?ZJ
0?ooo`3o00000?ZJ1P3oool01`00nYX0o`000?ooo`3oool00?ZJ0?l00000nYX00P3oool00`00nYX0
o`000?ooo`02003jVP060?l0003oool0oooo0?ooo`00nYX0o`000`00nYX00`3o0000oooo0?ooo`03
0?ooo`800?ZJ00H0o`000?ooo`3oool0oooo003jVP3o00030000000;0000o`3oool0oooo0?l0003o
ool0003o0?l0003oool00?ZJ0?l0003oool01@00nYX01P3o0000oooo0?ooo`00nYX0o`00003jVP<0
oooo00@00?ZJ0?l0003oool00?ZJ0`00000j0?ooo`00@03oool00`000000oooo003jVP030?ooo`05
0000o`3oool0o`00003jVP3o0000103oool2003jVP/0oooo00<00?ZJ0?ooo`3oool00`0000020?oo
o`030?l00000nYX0oooo01X0oooo00L0o`00003jVP3oool0oooo003jVP3o00000?ZJ00h0oooo00<0
0?ZJ0?ooo`00nYX01P3oool3003jVP0;0?l0003oool00?ZJ0000o`00nYX0oooo0?l00000nYX0003o
0?l00000nYX00P3oool3000000<0oooo00@00?ZJ0?ooo`3oool0o`000P3oool00`00nYX0o`000?oo
o`0I0?ooo`<00?ZJ00L0o`000?ooo`00nYX0oooo003jVP3oool0o`000280oooo0P0000040?ooo`06
003jVP000?l0o`000000o`3oool0o`000P3oool20?l00080oooo00D00?ZJ0?ooo`3oool0oooo003j
VP060?ooo`800?ZJ00<0o`000?ooo`3oool0103oool01000nYX0oooo0?ooo`3o00040?ooo`03003j
VP3oool0oooo00<0oooo0`00nYX60?ooo`800?ZJ00D0oooo003jVP00nYX0oooo0000o`020?ooo`07
0?l0003oool0oooo0?ooo`00nYX0o`00003jVP0:0?ooo`03003jVP3oool0oooo00<0oooo0P3o0003
0?ooo`05003jVP3o0000oooo0?ooo`00nYX01@3oool00`00nYX0oooo003jVP050?ooo`04003jVP3o
ool0o`00003jVP80oooo0P3o00020?ooo`04003jVP3oool00?ZJ0?l001P0oooo00D0o`000?ooo`3o
ool0oooo003jVP050?ooo`03003jVP3o00000?ZJ01P0oooo0`0000040?ooo`800000103oool02`00
0000oooo0?ooo`3oool00?ZJ0?l0003oool0003o003jVP3oool00?ZJ00<0oooo0P000?l01`3o0000
oooo0?ooo`3oool00?ZJ0?ooo`3o00000P00nYX00`3o00000?ZJ0?ooo`030?ooo`800?ZJ00D0o`00
003jVP3oool00?ZJ0?l000040?ooo`07003jVP3o0000oooo0?ooo`3o0000oooo003jVP030?ooo`03
003jVP3o00000?ZJ00<00?ZJ00<0o`000?ooo`3oool00P3oool2003jVP80oooo00@0o`00003jVP3o
ool00?ZJ0P3o0004003jVP80oooo00D0o`00003jVP3oool0o`00003jVP060?ooo`07003jVP3o0000
oooo0?ooo`00nYX0o`00003jVP020?ooo`06003jVP3o0000oooo0000o`3oool0o`000`3oool00`00
nYX0o`00003jVP02003jVP030?l0003oool0oooo00<0oooo0P00nYX01P3o0000oooo0?ooo`3oool0
o`000?ooo`<000000P3oool20?l000090?ooo`000?l0o`000?ooo`00nYX0o`000?ooo`00nYX0oooo
00800?ZJ00H0oooo0?l0003oool0oooo003jVP3o00040?ooo`04003jVP3o0000oooo003jVP<00000
>P3oool00400oooo00<000000?ooo`00nYX00`3oool01@000?l0oooo0?l00000nYX0o`0000<0oooo
00<00?ZJ0?ooo`00nYX02`3oool00`00nYX0oooo0?ooo`0300000080oooo00<0o`00003jVP3oool0
6P3oool01`3o00000?ZJ0?ooo`3oool00?ZJ0?l00000nYX03P3oool00`00nYX0oooo003jVP060?oo
o`<00?ZJ00P0o`00003jVP3oool0oooo0000o`00nYX0o`00003jVP80o`0000<00?ZJ0?ooo`3oool0
0`0000020?ooo`800?ZJ00<0oooo0000o`3o00000P3oool00`00nYX0o`000?ooo`0I0?ooo`<00?ZJ
00L0o`000?ooo`00nYX0oooo003jVP3oool0o`000240oooo00@000000?ooo`3oool000000`3oool0
1P00nYX0o`000?l000000?l0oooo0?l00080oooo0P3o00020?ooo`05003jVP3oool0oooo0?ooo`00
nYX01@3oool00`00nYX0oooo0?l000070?ooo`04003jVP3oool0oooo0?l000@0oooo00<00?ZJ0?oo
o`3oool00`3oool00`00nYX0oooo003jVP050?ooo`03003jVP3oool00?ZJ00800?ZJ0P000?l30?oo
o`070?l0003oool0oooo0?ooo`00nYX0o`00003jVP0:0?ooo`P0o`000`3oool00`00nYX0o`00003j
VP02003jVPD0oooo00<00?ZJ0?ooo`00nYX01@3oool01@00nYX00000000000000000003o0080o`00
0`3oool01000nYX0oooo003jVP3o000G0?ooo`03003jVP3o0000oooo0080oooo00<00?ZJ0?ooo`3o
ool00`3oool00`00nYX0o`00003jVP0G0?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`0000030?ooo`0;0000003oool0oooo0?ooo`00nYX0o`000?ooo`000?l00?ZJ0?oo
o`00nYX00`3oool00`000?l0oooo0?l000030?ooo`03003jVP3oool0o`0000800?ZJ00<0o`00003j
VP3oool00`3oool2003jVP050?l00000nYX0oooo003jVP3o0000103oool01`00nYX0o`000?ooo`3o
ool0o`000?ooo`00nYX00`3oool00`00nYX0o`00003jVP03003jVP030?l0003oool0oooo0080oooo
0P00nYX20?ooo`040?l00000nYX0oooo003jVP80o`0000@00?ZJ0?ooo`3oool00?ZJ0P3oool01@3o
00000?ZJ0?ooo`3o00000?ZJ00H0oooo00L00?ZJ0?l0003oool0oooo003jVP3o00000?ZJ0080oooo
00H00?ZJ0?l0003oool0003o0?ooo`3o00030?ooo`03003jVP3o00000?ZJ00800?ZJ00<0o`000?oo
o`3oool00`3oool2003jVP050?l0003oool0oooo003jVP3o00000P3oool01@00nYX0o`000?ooo`3o
ool0o`0000<0oooo00@0o`000?ooo`00nYX0o`000P00nYX01@3oool00?ZJ003jVP3oool0o`000080
oooo00<00?ZJ0?l0003oool0103oool01@00nYX0o`00003jVP00nYX0o`0003/0oooo00100?ooo`03
0000003oool00?ZJ00<0oooo00D0003o0?ooo`3o00000?ZJ0?l000030?ooo`03003jVP3oool00?ZJ
00/0oooo00D00?ZJ0?ooo`3oool0o`00003jVP030?ooo`030?l00000nYX0oooo01T0oooo00<00?ZJ
0?l00000nYX00P3oool00`00nYX0o`00003jVP0=0?ooo`04003jVP3oool0oooo003jVPH0oooo0P00
nYX00`3o0000oooo003jVP020?ooo`070000o`00nYX0o`00003jVP3o0000oooo003jVP020?ooo`<0
00000P3oool01@00nYX0oooo0?ooo`000?l0o`0000<0oooo00<0o`000?ooo`3oool0603oool3003j
VP030?l00000nYX0oooo0080oooo00<00?ZJ0?l0003oool0803oool010000000oooo0?ooo`000002
0?ooo`<000000`3oool00`3o0000oooo0?ooo`020?l00080oooo00D00?ZJ0?ooo`3oool0003o003j
VP050?ooo`03003jVP3oool0o`0000800?ZJ1@3oool01@00nYX0oooo0?ooo`00nYX0o`0000<0oooo
00<00?ZJ0?ooo`3oool00P3oool2003jVP030?ooo`00nYX0oooo00@0oooo00@00?ZJ0?ooo`00nYX0
0?ZJ0`000?l30?ooo`070?l0003oool0oooo0?ooo`00nYX0o`00003jVP0:0?ooo`030?l000000?l0
oooo00@0oooo00H0o`000?ooo`3oool0oooo003jVP3o0003003jVPD0oooo00<00?ZJ0?ooo`00nYX0
1@3oool01000nYX000000000000000020?l000@0oooo00@00?ZJ0?ooo`00nYX0o`005`3oool00`00
nYX0o`000?ooo`020?ooo`03003jVP3oool0oooo00<0oooo00@00?ZJ00000000000000006P3oool0
10000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000`3oool01`00nYX0o`00
0?ooo`000?l00?ZJ0?ooo`00nYX00`3oool00`000?l0o`00003jVP030?ooo`07003jVP3oool0o`00
0?ooo`00nYX0o`00003jVP040?ooo`800?ZJ00D0o`00003jVP3oool00?ZJ0?l000040?ooo`07003j
VP3o0000oooo0?ooo`3o0000oooo003jVP030?ooo`03003jVP3o00000?ZJ00<00?ZJ00<0o`000?oo
o`3oool00P3oool2003jVP80oooo00@0o`00003jVP3oool00?ZJ0`0000020?ooo`04003jVP3oool0
oooo0?l000800?ZJ00<0o`00003jVP3oool01@3oool01`00nYX0o`000?ooo`3oool0o`000000o`00
nYX00P3oool01P00nYX0oooo0?l000000?l0oooo0?l000<0oooo00H00?ZJ0?l0003oool00?ZJ0?l0
0000nYX60?ooo`06003jVP3o0000oooo0?ooo`00nYX0o`000P3oool00`00nYX0o`000?l000020?l0
00<0oooo00D0o`00003jVP00nYX0o`00003jVP020?ooo`800?ZJ00H0oooo0?l0003oool0oooo003j
VP3o00050?ooo`05003jVP3o00000?ZJ003jVP3o0000>`3oool00400oooo00<000000?ooo`00nYX0
0P3oool01P3o0000oooo0?ooo`3o00000?ZJ0?l000<0oooo00<00?ZJ0?ooo`00nYX02P3oool01P00
nYX0oooo0?ooo`3o0000003o003jVP<0oooo00D0o`000?ooo`00nYX0oooo003jVP0F0?ooo`800?ZJ
00L0o`00003jVP3oool0oooo003jVP3o00000?ZJ00d0oooo00@00?ZJ0?ooo`3oool00?ZJ1@3oool0
1P00nYX0oooo003jVP3o0000oooo003jVP80oooo00L0003o003jVP3o0000oooo0?l0003oool00?ZJ
0080oooo00<00?ZJ0?l00000nYX00P3oool01@00nYX0oooo0?ooo`000?l0o`0000<0oooo00<0o`00
0?ooo`3oool05`3oool00`00nYX0oooo003jVP020?l00004003jVP3oool0oooo0?ooo`<00000803o
ool010000000oooo0?ooo`0000020?ooo`<000000`3oool00`3o0000oooo0?ooo`020?l00080oooo
00D00?ZJ0?ooo`000?l0003o003jVP050?ooo`03003jVP3oool0o`0000800?ZJ1@3oool01@00nYX0
oooo0?ooo`00nYX0o`0000<0oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX5
0?ooo`05003jVP3oool00?ZJ003jVP000?l01@3oool01`3o0000oooo0?ooo`3oool00?ZJ0?l00000
nYX02P3oool00`3o0000003o0000o`040?ooo`070?l0003oool0oooo0?ooo`00nYX0o`00003jVP07
0?ooo`03003jVP3oool00?ZJ00D0oooo00D00?ZJ00000000000000000?l000050?ooo`04003jVP3o
ool00?ZJ0?l001L0oooo00<00?ZJ0?l0003oool00P3oool00`00nYX0oooo0?ooo`030?ooo`04003j
VP0000000000000001P0oooo0P0000030?ooo`040000003oool0oooo000000<0oooo0P0000020?oo
o`07003jVP3o0000oooo0000o`00nYX0oooo003jVP030?ooo`030000o`3o00000?ZJ00<0oooo00L0
0?ZJ0?ooo`3o0000oooo003jVP3o00000?ZJ00@0oooo0P00nYX01@3o00000?ZJ0?ooo`00nYX0o`00
00@0oooo00L00?ZJ0?l0003oool0oooo0?l0003oool00?ZJ00<0oooo00L00?ZJ0?l000000?l0oooo
003jVP3o00000?ZJ00@0oooo0P00nYX20?ooo`040?l00000nYX0oooo003jVP<000000P3oool00`00
nYX0oooo0?ooo`020?l00003003jVP3o0000oooo00H0oooo00D00?ZJ0?l0003oool0oooo0?l00002
003jVP80oooo00H00?ZJ0000o`3o0000003o0?ooo`3o00030?ooo`06003jVP3o0000oooo0?ooo`3o
00000?ZJ1P3oool01P00nYX0o`000?ooo`3oool00?ZJ0?l00080oooo0P00nYX50?ooo`<0000000<0
003o0?l00000nYX00P3oool2003jVP060?ooo`3o0000oooo0?ooo`3o00000?ZJ1@3oool01@00nYX0
o`00003jVP00nYX0o`0003/0oooo00100?ooo`030000003oool00?ZJ0080oooo0P3o0000103oool0
o`000?ooo`3o00030?ooo`03003jVP3oool00?ZJ00X0oooo00H00?ZJ0?ooo`3oool0o`000000o`00
nYX30?ooo`03003jVP3o00000?ZJ00800?ZJ5P3oool3000000<0oooo00<00?ZJ0?l00000nYX03@3o
ool01000nYX0oooo0?ooo`00nYX50?ooo`05003jVP3oool00?ZJ0?l00000nYX0103oool01@00nYX0
o`000?l000000?l00?ZJ00<0oooo00@00?ZJ0?l00000nYX0oooo0P00nYX20?ooo`030000o`3o0000
oooo0080oooo00<0o`000?ooo`3oool05`3oool01P00nYX0oooo003jVP3o0000oooo003jVP<0oooo
0`00000P0?ooo`040000003oool0oooo00000080oooo0`0000030?ooo`050?l0003oool0o`00003j
VP3o00000P3oool01@00nYX0oooo0000o`000?l00?ZJ00D0oooo00<00?ZJ0?ooo`3o00000`00nYX4
0?ooo`05003jVP3oool0oooo003jVP3o00000`3oool00`00nYX0oooo0?ooo`020?ooo`04003jVP3o
ool0oooo003jVPD0oooo00D00?ZJ0?ooo`00nYX00?ZJ0000o`050?ooo`070?l0003oool0oooo0?oo
o`00nYX0o`00003jVP0:0?ooo`030?l0003oool0003o00@0oooo00H0o`000?ooo`3oool0oooo003j
VP3o00080?ooo`03003jVP3oool00?ZJ00D0oooo00@00?ZJ0?ooo`00nYX0003o1P3oool01000nYX0
oooo0?ooo`3o000?0?ooo`<00?ZJ1@3oool01P00nYX0o`00003jVP00nYX0oooo003jVPD0oooo00@0
0?ZJ00000000000000006P3oool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?oo
o`0000000`3oool01`00nYX0o`000?ooo`000?l00?ZJ0?ooo`00nYX00`3oool00`000?l0o`00003j
VP030?ooo`06003jVP3oool0o`000?ooo`00nYX0o`001@3oool2003jVP050?l00000nYX0oooo003j
VP3o0000103oool01`00nYX0o`000000o`000?l0o`000?ooo`00nYX00`3oool01`00nYX0o`000000
o`3oool00?ZJ0?l00000nYX0103oool2003jVP80oooo00@0o`00003jVP3oool00?ZJ0`0000030?oo
o`06003jVP3oool0003o0?l00000nYX0o`001`3oool01P00nYX0o`000?ooo`00nYX0o`00003jVP@0
oooo00D00?ZJ0?l0003oool0oooo0?l000030?ooo`06003jVP3o0000oooo0?ooo`3o00000?ZJ1P3o
ool01P00nYX0o`000?ooo`3oool00?ZJ0?l00080oooo0P00nYX50?ooo`<0000000<0o`000?ooo`00
nYX00`3oool00`00nYX0oooo0?l000020?ooo`030?l00000nYX0oooo00@0oooo00D00?ZJ0?l00000
nYX00?ZJ0?l0000k0?ooo`00@03oool02`000000oooo003jVP3oool0o`000000o`3o0000oooo0?l0
003oool0o`0000<0oooo00<00?ZJ0?ooo`00nYX02P3oool01P00nYX0oooo0?ooo`3o0000003o003j
VP<0oooo00<00?ZJ0?l0003oool00P00nYXE0?ooo`04003jVP0000000000000000<0oooo00<00?ZJ
0?l00000nYX0303oool2003jVP80oooo00<00?ZJ0?ooo`3oool00`3oool01@00nYX0oooo0?l0003o
00000?ZJ00@0oooo0`0000000`000?l00?ZJ0?ooo`020?ooo`800?ZJ00<0o`00003jVP00nYX00`3o
ool00`000?l0o`000?ooo`020?ooo`030?l0003oool0oooo01L0oooo00@00?ZJ0000000000000000
0P00nYX30?ooo`<00000803oool010000000oooo0?ooo`0000030?ooo`03003jVP3oool0oooo0080
oooo00D0o`000?ooo`3o00000?ZJ0?l000020?ooo`03003jVP000?l0003o00<0000000L00?ZJ0?oo
o`3oool0oooo003jVP3oool0o`000080oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?oo
o`00nYX0o`0000<0oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX50?ooo`03
003jVP3oool00?ZJ00<0o`00103oool01P3o0000oooo0?ooo`3oool00?ZJ0?l000<00?ZJ1`3oool0
1000nYX0o`00003jVP000?l40?ooo`060?l0003oool0oooo0?ooo`00nYX0o`002@3oool2003jVPD0
oooo00@00?ZJ0?ooo`00nYX0003o1P3oool01000nYX0oooo0?ooo`3o000?0?ooo`04003jVP3oool0
0?ZJ003jVP@0oooo00<00?ZJ0?l00000nYX00`00nYX50?ooo`03003jVP3oool0o`0001L0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000000<0oooo00/000000?ooo`3o
ool0oooo003jVP3o0000oooo0000o`00nYX0oooo003jVP030?ooo`030?l0003oool00?ZJ00<0oooo
00H00?ZJ0?ooo`3o0000oooo003jVP3o00050?ooo`<00?ZJ00@0o`000?ooo`3o00000?ZJ103oool0
1P00nYX0o`000?l0003o0000oooo003jVP@0oooo00L00?ZJ0?l000000?l0oooo003jVP3o00000?ZJ
00@0oooo0P00nYX20?ooo`060?l00000nYX0oooo003jVP3o00000?ZJ103oool01P00nYX0oooo0000
o`3o00000?ZJ0?l000L0oooo00H00?ZJ0?l0003oool00?ZJ0?l00000nYX40?ooo`05003jVP3o0000
oooo0?ooo`3o00000`3oool01@00nYX0o`000?ooo`3oool0o`0000L0oooo00H00?ZJ0?l0003oool0
oooo003jVP3o00020?ooo`800?ZJ103oool01P00nYX00000000000000000o`00003jVP@0oooo00<0
0?ZJ0?ooo`3o00000P3oool00`3o00000?ZJ0?ooo`040?ooo`05003jVP3o00000?ZJ0000o`3o0000
>`3oool00400oooo00/00000003jVP00nYX0oooo0?l000000?l0o`000?ooo`3o0000oooo0?l00003
0?ooo`03003jVP3oool00?ZJ00X0oooo00<00?ZJ0?ooo`3o00000P000?l01P00nYX0oooo0?ooo`3o
ool00?ZJ0?l00080oooo00<00?ZJ0?ooo`3oool04`3oool01000nYX000000000000000030?ooo`03
003jVP3o00000?ZJ00`0oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?ooo`04003jVP3oool0o`00
003jVPD0oooo0`0000000`3oool00?ZJ0?ooo`020?ooo`800?ZJ00<0o`000000o`3oool00P3oool0
0`000?l0oooo0?l000030?ooo`030?l0003oool0oooo01L0oooo00D00?ZJ0000000000000000003j
VP040?ooo`800?ZJ8P3oool2000000@0oooo0P00nYX30?ooo`050?l0003oool0o`00003jVP3o0000
0P3oool00`00nYX0003o0000o`03000000800?ZJ0P3oool00`00nYX0oooo0?l000020?ooo`800?ZJ
0`3oool01@00nYX0oooo0?ooo`00nYX0o`0000<0oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0
oooo0?ooo`00nYX50?ooo`05003jVP3oool0o`000?l0003oool00P3o00030?ooo`090?l0003oool0
oooo0?ooo`00nYX0o`000000o`3oool00?ZJ00L0oooo00@00?ZJ0?l00000nYX00?ZJ103oool01P3o
0000oooo0?ooo`3oool00?ZJ0?l000T0oooo0P00nYX50?ooo`04003jVP3oool00?ZJ003jVPH0oooo
00@00?ZJ0?ooo`3oool0o`002@3oool2003jVP<0oooo0P00nYX20?ooo`800?ZJ0`3oool01000nYX0
o`00003jVP3oool2003jVPD0oooo00<00?ZJ0?ooo`00nYX0603oool3000000@0oooo0P0000040?oo
o`0;0000003oool0oooo0?ooo`00nYX0o`000?ooo`000?l00?ZJ0?ooo`00nYX00`3oool00`3o0000
oooo003jVP030?ooo`06003jVP3oool0o`000?ooo`00nYX0o`001@3oool3003jVP040?l0003oool0
o`00003jVP@0oooo00H00?ZJ0?ooo`3o0000o`000?ooo`00nYX40?ooo`07003jVP3o0000003o0?oo
o`00nYX0o`00003jVP040?ooo`800?ZJ0P3oool01P3o00000?ZJ0?ooo`00nYX0o`00003jVP@0oooo
00<00?ZJ0?ooo`000?l00P3o00000`00nYX0oooo0?ooo`050?ooo`06003jVP3o0000oooo003jVP3o
00000?ZJ103oool01@00nYX0o`000?ooo`3o00000?ZJ00<0oooo00D00?ZJ0?l0003oool0oooo0?l0
00070?ooo`06003jVP3o0000oooo0?ooo`00nYX0o`001000nYX30?ooo`800?ZJ00D0oooo0?l0003o
0000o`00003jVP060?ooo`050?l0003oool00?ZJ0?l00000nYX01@3oool01@00nYX0o`00003jVP00
0?l0o`0003/0oooo00100?ooo`0;00000000nYX0oooo0?ooo`3o0000003o0?l0003oool0o`000?oo
o`3o00000`3oool00`00nYX0oooo003jVP0:0?ooo`06003jVP3oool0o`000000o`3oool00?ZJ0`3o
ool01@00nYX0o`000?ooo`3oool00?ZJ01D0oooo00@00?ZJ0000o`3o00000?ZJ0`3oool00`00nYX0
o`00003jVP0<0?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool01000nYX00000000000000005
0?ooo`<0000000<00?ZJ0?ooo`3oool00P3oool2003jVP040?l000000?l0oooo0?ooo`80003o00<0
o`00003jVP3oool00P3oool00`3o00000?ZJ0?ooo`0G0?ooo`05003jVP000000000000000000nYX0
103oool2003jVRP0oooo00<00000003jVP3oool00P3oool01@3o0000oooo0?l00000nYX0o`000080
oooo00<00?ZJ0000o`3oool00`0000001`3oool00?ZJ0?ooo`3oool00?ZJ0?ooo`3o00000`3oool0
1@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0?l0003o00000`3o00040?ooo`04003jVP3o
ool0003o003jVPD0oooo00@00?ZJ0?l0003o0000o`000P3oool01@3o0000oooo0?ooo`3oool0o`00
00<0oooo00D00?ZJ0?l000000?l0oooo003jVP060?ooo`800?ZJ00<0o`000?ooo`00nYX00P000?l2
0?ooo`060?l0003oool0oooo0?ooo`00nYX0o`002@3oool2003jVPH0oooo1000nYX50?ooo`05003j
VP3oool0oooo0?l00000nYX01`3oool2003jVP050?ooo`00nYX0oooo0?ooo`00nYX00P000?l20?oo
o`07003jVP3oool0oooo0?ooo`00nYX0o`00003jVP020?ooo`03003jVP3oool0oooo00<0oooo00<0
0?ZJ0?ooo`00nYX09@3oool02`000000oooo0?ooo`3oool00?ZJ0?l0003oool0003o003jVP3oool0
0?ZJ0080oooo0P3o00000`3oool00?ZJ0?ooo`030?ooo`05003jVP3o0000oooo003jVP3o00001@3o
ool3003jVP040?l0003oool0o`00003jVP@0oooo00H00?ZJ0?ooo`3o0000o`000?ooo`00nYX40?oo
o`06003jVP3o0000003o0?ooo`00nYX0o`001P3oool02@00nYX0oooo0?ooo`3o00000?ZJ0?ooo`3o
0000003o003jVP040?ooo`03003jVP3oool0003o0080o`0000<00?ZJ0?ooo`3oool01@3oool01P00
nYX0o`000?ooo`00nYX0o`00003jVP@0oooo00D00?ZJ0?l0003o0000o`00003jVP030?ooo`03003j
VP000?l0o`0000<000001P3oool01@00nYX0o`000?ooo`3oool0o`0000@00?ZJ00D0oooo003jVP3o
ool0oooo003jVP020?ooo`04003jVP3o0000oooo003jVPH0oooo00D0o`00003jVP00nYX0o`00003j
VP050?ooo`05003jVP3o0000oooo0000o`3o0000>`3oool00400oooo00<00000003jVP3oool00P3o
00001P3oool0o`000?ooo`3o0000oooo0?l000<0oooo00<00?ZJ0?ooo`00nYX02@3oool01`00nYX0
oooo0?l0003o0000003o0?ooo`00nYX00`3oool01@00nYX0o`000?ooo`3oool00?ZJ01@0oooo00@0
0?ZJ0000o`000?l0o`00103oool01000nYX0o`000000o`00nYX:0?ooo`800?ZJ0`3oool00`00nYX0
oooo0?ooo`030?ooo`04003jVP0000000000000000H0oooo0`00nYX40?ooo`800?ZJ00D0o`000000
o`3oool0oooo0000o`020?l00006003jVP3oool0oooo0?ooo`3o00000?ZJ603oool01000nYX0o`00
0?l00000nYX50?ooo`800?ZJ:03oool00`0000000?ZJ0?ooo`020?ooo`050?l0003oool0o`00003j
VP3o00000P3oool01P00nYX0003o0?ooo`3o00000?ZJ0?l00080oooo00D00?ZJ0?ooo`00nYX0oooo
0?l000040?ooo`04003jVP3oool0oooo003jVP80oooo00<00?ZJ0?ooo`3oool00P3oool01P3o0000
oooo0?ooo`3oool00?ZJ0?ooo`80003o0P00nYX40?ooo`04003jVP3o0000o`000?l00080oooo0P3o
00020?ooo`090?l0003oool0oooo0?ooo`00nYX0o`000000o`3oool00?ZJ00H0oooo00<00?ZJ0?l0
0000nYX00P3oool01@00nYX0003o0000o`3oool0o`0000<0oooo00<0o`00003jVP3oool02@3oool0
0`00nYX0oooo0?ooo`040?ooo`800?ZJ00<0oooo003jVP00nYX0103oool01@00nYX0oooo0?ooo`3o
00000?ZJ00L0oooo00L00?ZJ0?ooo`3oool0oooo003jVP3oool00?ZJ00@0003o00H00?ZJ0?ooo`3o
ool0oooo003jVP3o00090?ooo`03003jVP3oool00?ZJ02D0oooo00/000000?ooo`3oool0oooo003j
VP3o0000oooo0000o`00nYX0oooo003jVP020?ooo`040?l000000?l0oooo003jVP@0oooo00D00?ZJ
0?l0003oool00?ZJ0?l000050?ooo`<00?ZJ00@0o`00003jVP3o00000?ZJ1@3oool01@00nYX0oooo
0?ooo`3oool00?ZJ00@0oooo00@00?ZJ0?l000000?l0oooo0P3o00060?ooo`08003jVP3oool0oooo
0?l00000nYX0oooo0?l00000nYX50?ooo`03003jVP3oool0003o0080o`0000<00?ZJ0?ooo`3oool0
1P3oool01@3o00000?ZJ003jVP3o00000?ZJ00@0oooo00D00?ZJ0?ooo`3o0000o`00003jVP030?oo
o`03003jVP3oool0o`0000<000001`3oool01@3o0000oooo0?ooo`3o00000?ZJ00@0oooo00@00?ZJ
0?ooo`00nYX00?ZJ0P3oool01000nYX0oooo0?ooo`00nYX60?ooo`050?l00000nYX00?ZJ0?l00000
nYX01@3oool01@00nYX0o`000?ooo`3o00000?ZJ03/0oooo00100?ooo`800?ZJ00T0oooo0?l00000
0?l0oooo0?l0003oool0o`000?ooo`3o00000`3oool00`00nYX0oooo003jVP090?ooo`04003jVP3o
ool0o`000000o`80oooo00H00?ZJ0?ooo`3oool0oooo003jVP3o00020?ooo`03003jVP3oool0oooo
0140oooo00D0003o003jVP3oool0oooo0?l000050?ooo`030?l000000?l00?ZJ00X0oooo00<00?ZJ
0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`030?ooo`04003jVP0000000000000000H0oooo00<0
0?ZJ0?ooo`3oool01@3oool2003jVP070?l000000?l0oooo0000o`3o0000oooo003jVP030?ooo`03
0?l00000nYX0oooo01H0oooo00@00?ZJ0?ooo`3o00000?ZJ1P3oool2003jVRP0oooo00<00000003j
VP3oool00P3oool01@3o0000oooo0?l00000nYX0o`000080oooo00H00?ZJ0000o`3o0000oooo003j
VP3o00020?ooo`05003jVP3oool00?ZJ0?ooo`3o0000103oool01000nYX0oooo0?ooo`00nYX20?oo
o`03003jVP3oool0oooo0080oooo00L0o`000?ooo`3oool0oooo003jVP3oool0o`0000<0000000D0
0?ZJ0?ooo`3oool0oooo003jVP020?l000@0oooo00@0o`000?ooo`3oool0o`00103oool00`00nYX0
o`000?ooo`04003jVP<0oooo00<00?ZJ0?l00000nYX00P3oool01@00nYX0003o0000o`3oool0o`00
00<0oooo00<0o`00003jVP3oool0403oool2003jVP80oooo0P00nYX30?ooo`04003jVP3oool0oooo
0?l000D00?ZJ0P3oool2003jVP<0oooo00D00?ZJ0?ooo`00nYX0003o0?ooo`020000o`800?ZJ0P3o
ool00`00nYX0o`000?ooo`080?ooo`03003jVP3oool00?ZJ02D0oooo014000000?ooo`3oool0oooo
003jVP3o0000oooo0000o`00nYX0oooo003jVP000?l0oooo0?l000000?l0oooo003jVP040?ooo`05
003jVP3o0000003o003jVP3o00001@3oool3003jVP040?l00000nYX0o`00003jVPD0oooo00@00?ZJ
0?ooo`3oool00?ZJ1@3oool00`00nYX0oooo0?l000030?l000T0oooo00D00?ZJ0?l0003oool0o`00
003jVP060?ooo`05003jVP000?l0o`000?l00000nYX0203oool0103o00000?ZJ003jVP3o00050?oo
o`05003jVP3oool0o`000?ooo`00nYX00`3oool00`00nYX0oooo0?l00003000000L0oooo00D0o`00
003jVP3oool0o`00003jVP050?ooo`800?ZJ103oool2003jVPL0oooo00@0o`00003jVP00nYX0o`00
1P3oool01@00nYX0o`000?ooo`3o00000?ZJ03/0oooo000j0?ooo`800000103oool02`00nYX0oooo
0?l0003o0000003o0?ooo`3o0000oooo0?l0003oool0o`000080oooo00@00?ZJ0?ooo`3oool00?ZJ
2@3oool00`00nYX0o`000000o`030?ooo`06003jVP3oool0oooo0?ooo`00nYX0o`000P3oool00`00
nYX0oooo0?ooo`0A0?ooo`05003jVP000?l0oooo0?ooo`3o00001@3oool00`00nYX0o`00003jVP0:
0?ooo`03003jVP3oool0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`00nYX0o`00003jVP0?
0?ooo`800?ZJ1@3o00000`3oool00?ZJ0?ooo`020?ooo`030?l00000nYX0oooo01H0oooo00@00?ZJ
0?ooo`3o00000?ZJ1P3oool2003jVRP0oooo00<00000003jVP3oool00`3oool20?l00005003jVP3o
0000oooo003jVP3oool00P3o00000`3oool00?ZJ0?l000020?ooo`03003jVP3oool00?ZJ00<00000
0`3oool2003jVP060?ooo`00nYX0oooo0?ooo`00nYX0003o0`3oool01`3o0000oooo0?ooo`3oool0
0?ZJ0?ooo`3o00000`0000001@00nYX0oooo0?ooo`3oool00?ZJ0080o`000P00nYX20?ooo`80o`00
00<0oooo0?l0003oool00`3oool00`00nYX0o`000?ooo`02003jVP030?ooo`00nYX00?ZJ0080oooo
00<00?ZJ0?l0003oool00P3oool01@00nYX0oooo0000o`3oool0o`0000<0oooo00<0o`00003jVP3o
ool0403oool2003jVP<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?ooo`030?l00000nYX00?ZJ
0080oooo00@00?ZJ0?ooo`3oool00?ZJ103oool00`00nYX0oooo003jVP020?l000040?ooo`000?l0
oooo003jVP80oooo00<00?ZJ0?l0003oool0203oool00`00nYX0oooo003jVP0U0?ooo`0>0000003o
ool0oooo0?ooo`00nYX0o`000?ooo`000?l00?ZJ0?ooo`00nYX0003o0?l000000?l20?ooo`03003j
VP3oool0oooo0080oooo00D00?ZJ0?ooo`3o0000o`00003jVP050?ooo`<00?ZJ00@0o`00003jVP3o
00000?ZJ1@3oool01000nYX0oooo0?ooo`00nYX50?ooo`03003jVP3oool0o`000080o`0000<00?ZJ
0?ooo`3oool01`3oool01@00nYX0o`00003jVP3o00000?ZJ00H0oooo00@00?ZJ0000o`3o0000o`00
2@3oool0103o00000?ZJ003jVP3o00050?ooo`05003jVP3oool0oooo0?ooo`00nYX00`3oool01@00
nYX0oooo0?l000000?l0o`0000P0oooo00D0o`00003jVP3oool0o`00003jVP0;0?ooo`800?ZJ1`3o
ool0103o00000?ZJ003jVP3o00060?ooo`05003jVP3o0000oooo0?l00000nYX0>`3oool003T0oooo
00@000000?ooo`3oool000000P3oool3000000090?l0003oool0003o0?ooo`3o0000oooo0?l0003o
ool0o`000080oooo00@00?ZJ0?ooo`3oool00?ZJ2@3oool00`00nYX0o`000?ooo`030?ooo`09003j
VP3oool0oooo0?ooo`00nYX0003o0?l0003oool00?ZJ01<0oooo00D00?ZJ0?ooo`3oool0oooo0?l0
00050?ooo`03003jVP3o00000?ZJ00X0oooo00<00?ZJ0?ooo`3oool00`3o00050?ooo`03003jVP3o
00000?ZJ0100oooo00D00?ZJ0?ooo`3o0000o`000000o`020?ooo`06003jVP3oool0oooo0?ooo`3o
00000?ZJ5`3oool01000nYX0o`000000o`00nYX60?ooo`800?ZJ:03oool00`000000oooo003jVP03
0?ooo`80o`0000H00?ZJ0?l0003oool00?ZJ0?ooo`3o00020?ooo`800?ZJ00D0o`000?ooo`00nYX0
oooo003jVP03000000@0oooo00<00?ZJ0?ooo`00nYX00`3oool01@00nYX0oooo0?ooo`3oool0o`00
00<0oooo00<00?ZJ0?ooo`3o00000`0000001@00nYX0oooo0?ooo`3oool00?ZJ0080o`0000<00?ZJ
0?ooo`00nYX00P3oool00`3o0000oooo0?l000040?ooo`03003jVP3o0000oooo00800?ZJ00@0003o
0?ooo`00nYX0oooo0P00nYX00`3o0000oooo0?ooo`020?ooo`04003jVP000?l0003o0?l000<0oooo
00<0o`00003jVP3oool0403oool2003jVP<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?ooo`03
0?l000000?l0oooo0080oooo00D00?ZJ0?ooo`3oool00?ZJ0000o`030?ooo`800?ZJ103o00000`00
0?l0oooo003jVP020?ooo`030?l00000nYX0oooo00P0oooo00<00?ZJ0?ooo`00nYX09@3oool02`00
0000oooo0?ooo`3oool00?ZJ0?l0003oool0003o003jVP3oool00?ZJ0080o`0000@0003o0?ooo`3o
ool00?ZJ103oool01@00nYX0oooo0?l0003o00000?ZJ00D0oooo0`00nYX00`3o00000?ZJ0?l00006
0?ooo`04003jVP3oool0oooo003jVPD0oooo00<00?ZJ0?ooo`3o00000`0000090?ooo`05003jVP3o
00000?ZJ0?l00000nYX01P3oool01000nYX0003o0?l0003o00090?ooo`040?l00000nYX00?ZJ0?l0
00D0oooo00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`05003jVP3oool0o`000?l00000nYX0203o
ool01@3o00000?ZJ0?ooo`3o00000?ZJ00/0oooo0P00nYX70?ooo`040?l00000nYX00?ZJ0?l000H0
oooo00D00?ZJ0?l0003oool0o`00003jVP0k0?ooo`00>@3oool010000000oooo0?ooo`0000020?oo
o`<0000000T0o`000000o`000?l0oooo0?l0003oool0o`000?ooo`3o00000P3oool01000nYX0oooo
0?ooo`00nYX90?ooo`03003jVP3o0000oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0
o`000?ooo`00nYXB0?ooo`03003jVP000?l0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`00
nYX0o`00003jVP0:0?ooo`06003jVP3oool0o`000?l0003oool0o`001@3oool00`00nYX0o`00003j
VP0@0?ooo`04003jVP3oool0003o0000o`<0oooo00H00?ZJ0?ooo`3oool0oooo0?l00000nYXG0?oo
o`04003jVP3o0000003o003jVPL0oooo00<00?ZJ0?ooo`3oool09P3oool00`000000oooo003jVP03
0?ooo`80o`0000H00?ZJ0?l0003oool00?ZJ0?ooo`3o00020?ooo`800?ZJ00D0o`000?ooo`00nYX0
oooo003jVP03000000@0oooo00<00?ZJ0?ooo`00nYX00`3oool01@00nYX0oooo0?ooo`3oool0o`00
00<0oooo00P00?ZJ0?l000000?l0oooo003jVP3o0000003o003jVP80oooo00<00?ZJ0?l0003o0000
0P3oool01P00nYX0oooo0?ooo`3o0000oooo0?l000@0oooo00L00?ZJ0?l0003oool00?ZJ0?ooo`00
0?l0oooo00<00?ZJ00<0oooo0?l0003oool00`3oool01000nYX0oooo0000o`3o00030?ooo`030?l0
0000nYX0oooo0140oooo00@00?ZJ0?ooo`3oool0oooo0P00nYX20?ooo`05003jVP3oool0oooo0?l0
00000?l00`3oool01@00nYX0oooo003jVP00nYX0003o00<0oooo0P00nYX01`3o0000oooo0?ooo`3o
0000oooo0000o`00nYX00P3oool00`3o00000?ZJ0?ooo`090?ooo`800?ZJ9@3oool020000000oooo
0?ooo`3oool00?ZJ0?ooo`3o0000003o0P00nYX20?l000050?ooo`000?l0oooo0?ooo`00nYX0103o
ool01@00nYX0oooo0?l0003o00000?ZJ00D0oooo0P00nYX0103oool0o`000?ooo`3o00060?ooo`04
003jVP3oool0oooo003jVPD0oooo00<00?ZJ0?ooo`3o00000`0000090?ooo`05003jVP3o00000?ZJ
0?l00000nYX01P3oool01000nYX0003o0?l0003o00090?ooo`040?l00000nYX0o`00003jVPD0oooo
00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`05003jVP3oool0o`000?l00000nYX0203oool0103o
00000?ZJ0?ooo`3o000E0?ooo`040?l00000nYX00?ZJ0?l000H0oooo00D00?ZJ0?l0003oool0o`00
003jVP0k0?ooo`00>@3oool010000000oooo0?ooo`0000020?ooo`<000000P000?l20?ooo`050?l0
003oool0o`000?ooo`3o00000P3oool01000nYX0oooo0?ooo`00nYX90?ooo`80o`00103oool00`00
nYX0oooo0?ooo`020?ooo`04003jVP3o0000oooo003jVPL0oooo00<00?ZJ0?ooo`3oool0203oool0
0`00nYX0003o0?ooo`020?ooo`030?l0003oool0oooo00<0oooo00<00?ZJ0?l00000nYX02@3oool0
0`00nYX0oooo0?l000030?ooo`030?l0003oool0oooo00<0oooo00<0o`000000o`00nYX04@3oool0
0`00nYX0oooo0000o`030?ooo`06003jVP3oool0oooo0?ooo`3o00000?ZJ5`3oool01000nYX0o`00
0?ooo`00nYX60?ooo`0300000000nYX0oooo02L0oooo00<000000?ooo`00nYX00`3oool20?l00006
003jVP3o0000oooo003jVP000?l0o`000P3oool2003jVP030?l0003oool0oooo00800?ZJ00<0oooo
0?l0003oool0103oool00`00nYX0oooo003jVP030?ooo`05003jVP3oool0oooo0?ooo`3o00000`3o
ool02000nYX0o`000?ooo`3oool00?ZJ0?l000000?l00?ZJ0P3oool00`00nYX0o`000?l000020?oo
o`06003jVP3oool0oooo0?l0003oool0o`00103oool00`00nYX0o`0000000002000000030?ooo`00
0?l0oooo00800?ZJ00<0oooo0?l0003oool00`3oool01000nYX0oooo0000o`3o00030?ooo`030?l0
0000nYX0oooo01H0oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool00`3o0000003o0?ooo`020?ooo`06
003jVP3oool00?ZJ0000o`3oool0003o0P3oool2003jVP070?l0003oool0oooo0?ooo`3o0000003o
003jVP020?ooo`030?l00000nYX0oooo00T0oooo0P00nYXU0?ooo`030000003oool0oooo0080oooo
00<00?ZJ0?l000000?l00P00nYX01P3o0000003o0?ooo`000?l0oooo003jVPD0oooo00D00?ZJ0?oo
o`3o0000o`00003jVP050?ooo`800?ZJ00@0oooo0?l0003oool0o`001P3oool01000nYX0oooo0?oo
o`00nYX50?ooo`03003jVP3oool0oooo00<000002@3oool01@00nYX0o`00003jVP3o00000?ZJ00H0
oooo0P00nYX20?l000T0oooo00@0o`00003jVP3o00000?ZJ1@3oool01@00nYX0oooo0?ooo`3oool0
0?ZJ00@0oooo00@00?ZJ0000o`3o00000?ZJ203oool0103o00000?ZJ003jVP3o000E0?ooo`040?l0
0000nYX0o`00003jVPH0oooo00D00?ZJ0000o`3o0000o`00003jVP0k0?ooo`00>@3oool010000000
oooo0?ooo`0000030?ooo`03003jVP3oool0003o00<0oooo00D0o`000?ooo`3o0000oooo0?l00002
0?ooo`03003jVP3oool0oooo00<00?ZJ1`3oool00`3o0000oooo0?ooo`030?ooo`03003jVP3oool0
oooo0080oooo00@00?ZJ0?l0003o00000?ZJ1P3oool2003jVPX0oooo00<00?ZJ0?ooo`3oool00P3o
ool00`3o0000oooo0?ooo`030?ooo`03003jVP3o00000?ZJ00T0oooo00<00?ZJ0?l0003o00000`3o
ool00`3o0000oooo0?ooo`030?ooo`030?l000000?l00?ZJ0140oooo00<00?ZJ0?ooo`3oool00`3o
ool01`00nYX0oooo0?ooo`3oool00?ZJ0?l00000nYX05P3oool01000nYX0o`000?ooo`00nYX70?oo
o`03003jVP3oool0oooo02H0oooo00<000000?ooo`00nYX00`3oool20?l00005003jVP3o0000oooo
003jVP3o00000`3oool2003jVP80o`0000D0oooo003jVP00nYX0o`00003jVP060?ooo`800?ZJ0`3o
ool01@00nYX0003o0?ooo`000?l0o`0000<0oooo00D00?ZJ0?l0003oool0oooo003jVP020?l00004
003jVP3oool00?ZJ0?ooo`<000000P3oool00`00nYX0oooo0?ooo`020?l000@0oooo00<00?ZJ0?l0
000000000P0000000`3o0000003o0?ooo`030?ooo`030?l0003oool0oooo0080oooo00@00?ZJ0?oo
o`000?l0o`000`3oool00`3o00000?ZJ0?ooo`0F0?ooo`04003jVP3oool0oooo003jVP80oooo00<0
o`000000o`3oool00P3oool01000nYX0003o003jVP000?l40?l000800?ZJ00L0o`000?ooo`3oool0
oooo0?l000000?l00?ZJ0080oooo00<0o`00003jVP3oool02@3oool2003jVRD0oooo00<000000?oo
o`3oool00P3oool00`00nYX0o`000?ooo`02003jVP060?l000000?l0oooo0000o`3oool00?ZJ1@3o
ool01000nYX0oooo0?l0003o00060?ooo`800?ZJ00@0oooo0?l0003oool0o`001P3oool00`00nYX0
oooo003jVP070?ooo`04003jVP3oool0oooo003jVPX0oooo00D00?ZJ0?l00000nYX0o`00003jVP07
0?ooo`03003jVP3o00000?ZJ00T0oooo00@0o`00003jVP3o00000?ZJ1@3oool01@00nYX0oooo0?oo
o`3oool00?ZJ00@0oooo00@00?ZJ0?ooo`3oool00?ZJ203oool0103o00000?ZJ003jVP3o000E0?oo
o`040?l00000nYX0o`00003jVPH0oooo00D00?ZJ0?ooo`3o0000o`00003jVP0k0?ooo`00>@3oool0
10000000oooo0?ooo`0000030?ooo`800?ZJ103oool0203o0000oooo0?l0003oool0o`00003jVP3o
ool00?ZJ0P3oool4003jVPH0oooo00<0o`000?ooo`3oool00`3oool00`00nYX0oooo0?ooo`020?oo
o`04003jVP3oool0o`00003jVPH0oooo0P00nYX70?ooo`04003jVP3oool00?ZJ0000o`@0oooo00<0
o`000?ooo`3oool00`3oool00`00nYX0o`00003jVP090?ooo`03003jVP3o0000oooo0080003o00<0
oooo0?l0003oool00`3oool01000nYX0o`000000o`00nYXA0?ooo`800?ZJ103oool01`00nYX0oooo
0?ooo`3oool00?ZJ0?l00000nYX05P3oool01000nYX0o`000?ooo`00nYX70?ooo`03003jVP3oool0
oooo02H0oooo00<000000?ooo`00nYX00`3oool20?l00005003jVP3o0000oooo003jVP3o00000`3o
ool2003jVP030?ooo`3o0000oooo00800?ZJ00<0o`00003jVP3oool01@3oool2003jVP<0oooo0`00
nYX01`000?l0o`000?ooo`3oool00?ZJ0000o`3o00000P3oool2003jVP050?l00000nYX0oooo003j
VP3oool00`0000020?ooo`03003jVP3oool0oooo0080o`00103oool00`00nYX0oooo000000020000
0080o`0000<0003o0?ooo`3oool00`0000040?ooo`03003jVP000?l0o`0000<0oooo00<0o`00003j
VP3oool05P3oool01000nYX0oooo0?ooo`00nYX20?ooo`03003jVP3o0000oooo0080oooo0`00nYX2
0?l000050000o`3oool0o`00003jVP3o0000103oool20?l00005003jVP3oool0oooo0?l00000nYX0
2`3oool00`00nYX0oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00<00?ZJ0?l0003oool0
0P00nYX0103o0000003o0?ooo`000?l2003jVPD0oooo00@00?ZJ0?ooo`000?l0o`001P3oool2003j
VP040?ooo`3o0000oooo0?l000L0oooo0P00nYX70?ooo`04003jVP3oool0oooo003jVPX0oooo00D0
0?ZJ0?l00000nYX0o`000000o`070?ooo`<000002@3oool0103o00000?ZJ0?l00000nYX60?ooo`04
003jVP3oool0oooo003jVP@0oooo00@00?ZJ0?ooo`3oool00?ZJ203oool01000nYX0o`00003jVP3o
000E0?ooo`040?l000000?l0o`00003jVPH0oooo00D00?ZJ0?ooo`3o0000oooo003jVP0k0?ooo`00
>P3oool2000000@0oooo00<00000003jVP3oool00`3oool0203o0000oooo0?l0003oool0o`00003j
VP3oool00?ZJ0P3oool00`00nYX0003o0?ooo`02003jVP<0oooo0P00nYX00`3o0000oooo0?ooo`03
0?ooo`03003jVP3oool0oooo0080oooo00@00?ZJ0?ooo`3o0000o`001P3oool2003jVPL0oooo00@0
0?ZJ0?ooo`00nYX0003o103oool00`3o0000oooo0?ooo`030?ooo`03003jVP3o00000?ZJ00T0oooo
00<00?ZJ0?l000000?l00`000?l00`3o0000oooo0?ooo`020?ooo`04003jVP3o0000003o003jVQ80
oooo00<00?ZJ0?ooo`3oool00P3oool01`00nYX0oooo0?ooo`3oool00?ZJ0?l00000nYX03P3oool3
003jVPD0oooo00@00?ZJ0?l0003oool00?ZJ1`3oool00`000000oooo0?ooo`0V0?ooo`030000003o
ool00?ZJ00<0oooo0P3o00001@00nYX0o`000?ooo`00nYX0o`0000<0oooo00D00?ZJ0?ooo`00nYX0
o`000?ooo`02003jVP030?l00000nYX0oooo00X0oooo0P000?l02000nYX00000000000000000oooo
003jVP000?l0o`000P3oool2003jVP050?l00000nYX0oooo003jVP3oool00`0000020?ooo`03003j
VP3oool0oooo0080o`00103oool01000nYX0oooo0000o`00nYX20?ooo`040?l000000?l0oooo0?oo
o`<00000103oool01000nYX000000000000000020?ooo`030?l00000nYX0oooo01H0oooo00@00?ZJ
0?ooo`3oool00?ZJ0P3oool00`00nYX0o`000?l000030?l00006003jVP3oool0o`000?ooo`000?l0
oooo0`3o0003003jVP80oooo00H0o`00003jVP3oool0oooo0?l00000nYX;0?ooo`030000003oool0
oooo02<0oooo00<000000?ooo`3oool00P3oool00`00nYX0o`000?ooo`02003jVP050?l000000?l0
oooo0000o`00nYX01P3oool01000nYX0oooo0000o`3o00070?ooo`05003jVP3oool0o`000?l00000
nYX01`3oool2003jVPL0oooo00@00?ZJ0?ooo`3oool00?ZJ2P3oool01000nYX0o`00003jVP3o0008
0?ooo`<000002@3oool0103o00000?ZJ0?l00000nYX60?ooo`04003jVP3oool00?ZJ003jVP@0oooo
00@00?ZJ0?ooo`3oool00?ZJ203oool01000nYX0o`00003jVP3o000E0?ooo`04003jVP3o0000o`00
003jVPH0oooo00D00?ZJ0?ooo`3o00000000003jVP0k0?ooo`00@03oool00`0000000?ZJ0?ooo`03
0?ooo`090?l0003oool0o`000?ooo`3o00000?ZJ0?ooo`00nYX0oooo00<000000P3oool01000nYX0
oooo0?ooo`3oool2003jVP040?l00000nYX00?ZJ003jVP80oooo00<00?ZJ0?ooo`3oool00P3oool0
1000nYX0oooo0?ooo`3o00050?ooo`<00?ZJ1`3oool01000nYX0oooo003jVP000?l40?ooo`030?l0
003oool0oooo00<0oooo00@00?ZJ0000000000000000203oool01000nYX0o`000000o`3oool20000
o`030?l0003oool0oooo0080oooo00<00?ZJ0?l00000nYX04`3oool00`00nYX0oooo0?ooo`020?oo
o`06003jVP3oool0oooo0?ooo`00nYX0o`000P00nYX=0?ooo`04003jVP3oool00?ZJ003jVP@0oooo
00@0o`000000o`3oool00?ZJ1`3oool00`000000oooo0?ooo`0I0?ooo`<00000103oool2000000@0
oooo00<000000?ooo`00nYX00`3oool20?l00005003jVP3o0000oooo003jVP3o00000`3oool01@00
nYX0oooo003jVP3o0000oooo00800?ZJ00<0o`00003jVP3oool0303oool01`00nYX0000000000000
0000oooo003jVP3o00000`3oool2003jVP070?l000000?l00?ZJ003jVP3o0000oooo003jVP030?oo
o`05003jVP3oool0oooo0?ooo`3o0000103oool00`00nYX0oooo0?ooo`02003jVP80oooo00<0o`00
0?ooo`3oool00`0000040?ooo`04003jVP000000000000000080oooo00<0o`00003jVP3oool05P3o
ool01000nYX0oooo0?ooo`00nYX20?ooo`07003jVP3o0000o`000000o`3oool0o`00003jVP020?l0
00040?ooo`000?l0oooo0?ooo`80o`0000<00?ZJ0?ooo`00nYX00P3oool01P3o00000?ZJ0?ooo`3o
ool0o`00003jVP/0oooo00<000000?ooo`3oool05`3oool3000000<0oooo0P0000040?ooo`030000
003oool0oooo0080oooo00<00?ZJ0?l0003oool00P00nYX01@3o0000oooo0000o`000?l00?ZJ00H0
oooo00<00?ZJ0?ooo`0000000P0000060?ooo`05003jVP3oool0o`000?l00000nYX01`3oool2003j
VPL0oooo00@00?ZJ0?ooo`3oool00?ZJ2P3oool01000nYX0o`000?ooo`3o00080?ooo`<000002@3o
ool0103o0000003o0?l00000nYX60?ooo`03003jVP3oool00?ZJ00D0oooo00@00?ZJ0?ooo`3oool0
0?ZJ203oool01000nYX0o`00003jVP3o000E0?ooo`04003jVP3o0000o`00003jVPH0oooo00D00?ZJ
0?ooo`3oool0oooo003jVP0k0?ooo`00@03oool00`000000oooo003jVP030?ooo`090?l0003oool0
o`000?ooo`3o00000?ZJ0?ooo`00nYX0oooo00<000000P3oool00`00nYX0oooo0?ooo`03003jVP04
0?l00000nYX0oooo003jVP80oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`3o0005
0?ooo`03003jVP3oool00?ZJ00800?ZJ103oool2003jVP030?ooo`00nYX0o`000080o`000P3oool0
0`3o0000oooo0?ooo`030?ooo`04003jVP0000000000000000P0oooo00<0o`000000o`3oool00P3o
ool3000000<0oooo00<00?ZJ0?l00000nYX0503oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0oooo
00@00?ZJ0?l0003oool00?ZJ303oool01@00nYX0003o0000o`3oool00?ZJ00@0oooo00@0o`000?oo
o`00nYX00?ZJ1`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0080oooo00@00000
0?ooo`3oool000000`3oool00`000000oooo003jVP030?ooo`80o`0000D00?ZJ0?l0003oool00?ZJ
0?l000030?ooo`05003jVP3oool00?ZJ0?l0003oool00P00nYX00`3o00000?ZJ0?ooo`0=0?ooo`<0
00000P00nYX00`3o0000oooo003jVP03003jVP070?l0003oool00?ZJ003jVP3o0000003o003jVP04
0?ooo`04003jVP3oool0oooo003jVP@0oooo00<00?ZJ0?ooo`3oool00`00nYX0103oool0o`000?oo
o`3oool20?l000D0oooo00@00?ZJ00000000000000000P3oool00`3o00000?ZJ0?ooo`0G0?ooo`03
003jVP3oool00?ZJ0080oooo00P00?ZJ0?ooo`3oool0003o0?ooo`3o0000003o0?l00080oooo00<0
003o0?ooo`3oool00P3o00001`00nYX0oooo0?ooo`00nYX0oooo0?l00000nYX00P3oool00`3o0000
0?ZJ0?ooo`0:0?ooo`030000003oool0oooo01P0oooo00D000000?ooo`3oool0oooo000000020?oo
o`050000003oool0oooo0?ooo`000000103oool00`00nYX0o`0000000002000000050?l0003oool0
003o0?ooo`00nYX01P3oool00`00nYX0oooo00000002000000P0oooo0P3o00000`00nYX0oooo0?oo
o`0>0?ooo`04003jVP3oool0oooo003jVPX0oooo00@00?ZJ0?l0003oool0o`002@3oool00`00nYX0
oooo0?ooo`080?ooo`040?l000000?l0o`00003jVPH0oooo0`00nYX50?ooo`04003jVP3oool0oooo
003jVPP0oooo00@00?ZJ0?l00000nYX0o`005@3oool01000nYX0o`000?l00000nYX70?ooo`04003j
VP3oool0oooo003jVS/0oooo00100?ooo`030000003oool00?ZJ00<0oooo00T0o`000?ooo`3o0000
oooo0?l00000nYX0oooo003jVP000?l00`0000001@3o0000oooo0?ooo`00nYX0oooo00<00?ZJ00<0
o`000?ooo`3oool00P00nYX00`3oool00?ZJ0?ooo`030?ooo`04003jVP000?l0oooo0?l000D0oooo
00D00?ZJ0?ooo`00nYX0oooo003jVP040?ooo`800?ZJ00@0oooo003jVP3o0000oooo0P3o00000`3o
ool0o`000?ooo`040?ooo`05003jVP000000000000000000nYX01`3oool00`3o0000003o0?ooo`02
0?ooo`<000000`3oool00`00nYX0o`00003jVP0D0?ooo`05003jVP3oool0oooo0?ooo`00nYX00`3o
ool00`00nYX0o`000?ooo`02003jVPD0oooo0`00nYX30?ooo`05003jVP000?l0003o0?ooo`00nYX0
103oool00`3o0000oooo003jVP080?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
0P3oool010000000oooo0?ooo`0000030?ooo`80000000@00?ZJ0?ooo`3oool0oooo0P3o00001@00
nYX0o`00003jVP00nYX0o`0000<0oooo00D00?ZJ0?ooo`00nYX0o`000?ooo`02003jVP030?l00000
nYX0oooo00d0oooo00<00?ZJ0?l0003o00000P3oool00`3o0000oooo003jVP030?ooo`07003jVP3o
00000?ZJ003jVP3o0000003o003jVP040?ooo`04003jVP3oool0oooo003jVP@0oooo00L00?ZJ0?oo
o`3oool00?ZJ0?ooo`00nYX0oooo0080o`0000<0oooo0?l00000nYX01@3oool01000nYX0oooo0?l0
0000nYX20?ooo`030?l00000nYX0oooo01L0oooo00<00?ZJ0?ooo`00nYX00P3oool01000nYX0oooo
0?ooo`000?l3000000060?l0003oool0oooo0?ooo`000?l0oooo0P3o00001000nYX0oooo0?ooo`00
nYX20?ooo`050?l0003oool0oooo0?l00000nYX02P3oool2000001L0oooo1@0000020?ooo`040000
003oool0oooo000000<0oooo0P0000030?ooo`03003jVP3o000000000080000000D0o`000?ooo`00
0?l0oooo003jVP060?ooo`03003jVP3oool0000000800000203oool00`00nYX0o`00003jVP0@0?oo
o`04003jVP3oool0oooo003jVPX0oooo00@00?ZJ0?l0003oool0o`00503oool0103o0000003o0?l0
0000nYX70?ooo`03003jVP3oool0oooo00@0oooo00@00?ZJ0?ooo`3oool00?ZJ203oool01000nYX0
o`000?l00000nYXE0?ooo`04003jVP3o0000o`00003jVPL0oooo00@00?ZJ0?ooo`0000000?ZJ>`3o
ool00400oooo00<000000?ooo`00nYX00`3oool03@3o0000oooo0?l0003oool0o`00003jVP3oool0
0?ZJ0000o`3oool0o`000?ooo`3o00000P3oool01P00nYX0oooo003jVP00nYX0o`00003jVP<0oooo
00<00?ZJ0?ooo`00nYX01@3oool00`00nYX0oooo0?l000050?ooo`06003jVP00000000000000003o
ool00?ZJ0`3oool3003jVP070?l0003oool0oooo0?ooo`3o0000oooo0?l000050?ooo`04003jVP3o
ool0o`000000o`<00?ZJ1@3oool01@3o00000?ZJ003jVP00nYX0oooo00<000000`3oool00`00nYX0
o`00003jVP0D0?ooo`800?ZJ0P3oool01P00nYX0oooo0?ooo`3oool00?ZJ0?l00080oooo00<00?ZJ
0?ooo`3oool00P3oool2003jVP040?ooo`00nYX0oooo0?ooo`800?ZJ0P000?l00`3oool00?ZJ0?oo
o`030?ooo`030?l00000nYX0oooo00P0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?oo
o`020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`00nYX00`3oool20?l00005003j
VP3o0000oooo0?ooo`3o00000`3oool01@00nYX0oooo003jVP3oool0o`0000800?ZJ00<0o`00003j
VP3oool03@3oool2003jVP060?l0003oool0003o0?l0003oool00?ZJ0`3oool01P00nYX0o`00003j
VP00nYX0o`00003jVPD0oooo00@00?ZJ0?ooo`3oool00?ZJ103oool01@00nYX0oooo0?ooo`00nYX0
oooo00800?ZJ00D0003o0?l0003o0000o`00003jVP050?ooo`08003jVP3oool00?ZJ0?l0003oool0
0?ZJ0?l00000nYXH0?ooo`03003jVP3oool00?ZJ0080oooo00@00?ZJ0?ooo`3oool0oooo0`000004
0?ooo`040000o`3oool0o`00003jVP<0oooo0P00nYX01@3oool0o`000?ooo`3oool0o`0000`0oooo
00<000000?ooo`3oool05@3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo0000
00<0oooo00<000000?ooo`3oool00P3oool00`00nYX0o`0000000002000000050?l0003oool0oooo
0?ooo`00nYX01P3oool01000nYX0oooo0?ooo`00nYX90?ooo`03003jVP000?l00?ZJ0100oooo00@0
0?ZJ0?ooo`3oool00?ZJ2P3oool01000nYX0o`000?l00000nYXD0?ooo`030?l000000?l0o`0000l0
oooo00@00?ZJ0?ooo`3oool00?ZJ203oool01000nYX0o`000?l00000nYXE0?ooo`03003jVP3o0000
o`0000P0oooo00@00?ZJ0?ooo`00nYX00000>`3oool00400oooo00<000000?ooo`00nYX0103oool2
0?l000060?ooo`3o00000?ZJ0?ooo`00nYX0003o0P3o00001P00nYX0o`000?l0003oool00?ZJ0?oo
o`800?ZJ00<0o`00003jVP3oool00P3oool3003jVPD0oooo00<00?ZJ0?ooo`3o00001@3oool01P00
nYX00000000000000000003o003jVP<0oooo0`00nYX0103o0000oooo0?ooo`3oool30?l000D0oooo
00H00?ZJ0?ooo`00nYX0o`000000o`3oool2003jVP@0oooo00@0o`00003jVP3oool00?ZJ0P3oool0
0`3o00000?ZJ0?ooo`020?ooo`03003jVP3o00000?ZJ01D0oooo00@00?ZJ0?ooo`3oool00?ZJ0`3o
ool01@00nYX0o`000000o`3oool00?ZJ00@0oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool00`00nYX0
003o0000o`020000o`03003jVP3oool0oooo0080oooo00<0o`00003jVP3oool0203oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool01000
0000oooo0?ooo`00nYX20?ooo`80o`0000D00?ZJ0?l0003oool0o`000000o`030?ooo`09003jVP3o
ool00?ZJ0?ooo`3o00000?ZJ0?ooo`3o00000?ZJ00h0oooo0P00nYX01@3o0000oooo0000o`3o0000
0?ZJ00@0oooo00H00?ZJ0?l000000?l00?ZJ0?l00000nYX50?ooo`04003jVP3oool0oooo003jVP@0
oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool00`00nYX0oooo0000o`020?ooo`03003jVP3oool0oooo
00@0oooo0P00nYX01@3o0000oooo003jVP3o00000?ZJ01P0oooo00<00?ZJ0?ooo`00nYX00P3oool0
1000nYX0oooo0?ooo`3oool3000000030?ooo`00nYX00?ZJ00800?ZJ0`0000040?ooo`06003jVP00
000000000000003oool0o`00303oool00`000000oooo0?ooo`0F0?ooo`030000003oool0000000<0
oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?ooo`06003jVP3o0000oooo
0?l00000nYX0o`000P3oool00`00nYX0oooo0?ooo`050?ooo`04003jVP3oool0oooo003jVPT0oooo
00<00?ZJ0000o`00nYX0403oool01000nYX0oooo0?ooo`00nYX:0?ooo`04003jVP3o0000o`00003j
VQ@0oooo00<00?ZJ0?l0003o00003`3oool01000nYX0oooo0?ooo`00nYX80?ooo`04003jVP3o0000
o`00003jVQD0oooo00<00?ZJ0?l0003o0000203oool01000nYX0oooo003jVP00000k0?ooo`00@03o
ool00`000000oooo003jVP040?ooo`80o`0000L0oooo0?l00000nYX00?ZJ0?ooo`000?l0o`000080
0?ZJ00D0003o0?l0003oool00?ZJ0?ooo`02003jVP030?l00000nYX0oooo00<0oooo0P00nYX50?oo
o`03003jVP3oool0o`0000D0oooo00D00?ZJ00000000000000000000o`02003jVP80oooo0`00nYX0
0`3o0000oooo0?ooo`020?ooo`80o`001P3oool2003jVP050?l000000?l0oooo0?ooo`00nYX00`3o
ool01000nYX0o`00003jVP3oool2003jVP030?ooo`3o00000?ZJ00<0oooo00<00?ZJ0?l0003oool0
5@3oool01000nYX0oooo0?ooo`00nYX40?ooo`04003jVP3o0000oooo003jVP<0oooo0P00nYX20?oo
o`06003jVP3oool0oooo003jVP000?l0oooo0P000?l01`00nYX0oooo0?ooo`3oool00?ZJ0?l00000
nYX02@3oool00`000000oooo0?ooo`0I0?ooo`800000103oool010000000oooo0?ooo`0000030?oo
o`040000003oool0oooo003jVP80oooo0P3o00001@00nYX0o`000?ooo`3o0000003o00<0oooo00D0
0?ZJ0?ooo`00nYX0oooo0?l000020?ooo`030?l00000nYX0oooo00d0oooo0P00nYX30?l000030?oo
o`00nYX0oooo00<0oooo00H00?ZJ0?l000000?l0oooo0?l00000nYX50?ooo`04003jVP3oool0oooo
003jVP@0oooo0`00nYX30?ooo`03003jVP3oool0003o0080oooo00<00?ZJ0?ooo`3oool0103oool2
003jVP050?l0003oool00?ZJ0?l00000nYX0603oool00`00nYX0oooo003jVP020?ooo`03003jVP3o
ool0oooo00<00?ZJ00<0oooo003jVP00nYX00P3oool01000nYX000000000000000040?ooo`06003j
VP00000000000000003oool0o`00303oool00`000000oooo0?ooo`0G0?ooo`8000000`3oool01000
0000oooo0?ooo`0000030?ooo`030000003oool0oooo0080oooo00H00?ZJ0?l0003o0000o`00003j
VP3o00020?ooo`03003jVP3oool0oooo00D0oooo00@00?ZJ0?ooo`3oool00?ZJ2@3oool00`00nYX0
003o003jVP0@0?ooo`03003jVP3oool00?ZJ00/0oooo00@00?ZJ0?l0003o00000?ZJ503oool00`00
nYX0o`000?l0000?0?ooo`04003jVP3oool0oooo003jVPT0oooo0P3o00000`00nYX0oooo0?ooo`0C
0?ooo`03003jVP3o00000?ZJ00P0oooo00@00?ZJ0?ooo`00nYX00000>`3oool00400oooo00@00000
0?ooo`3oool00?ZJ0`3oool20?l000070?ooo`3o00000?ZJ003jVP3oool0003o0?l00003003jVP04
0?l0003oool00?ZJ0?ooo`800?ZJ00<0o`00003jVP3oool00`3oool2003jVPD0oooo00<00?ZJ0000
o`3o0000103oool00`00nYX0oooo0?l000030?l000040000o`00nYX0oooo0?ooo`<00?ZJ00<0o`00
0?ooo`3oool00P3oool20?l000H0oooo0P00nYX20?l000040000o`3oool00?ZJ003jVP80oooo00<0
0?ZJ0?l0003oool00P3oool01000nYX0oooo0?l00000nYX30?ooo`03003jVP3o0000oooo01D0oooo
00@00?ZJ0?ooo`3oool00?ZJ103oool01000nYX0o`000?ooo`00nYX30?ooo`05003jVP3oool0oooo
0?ooo`00nYX00P3oool01P00nYX0oooo0?l0003o0000003o003jVP<0oooo00<00?ZJ0?l00000nYX0
2@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`040000
003oool0oooo003jVP80oooo0P3o00001@00nYX0o`000?ooo`3o0000003o00<0oooo00D00?ZJ0?oo
o`3oool00?ZJ0?l000020?ooo`030?l00000nYX0oooo00h0oooo0P00nYX20?l000030?ooo`00nYX0
oooo00<0oooo00H00?ZJ0?l000000?l0oooo0?l00000nYX50?ooo`04003jVP3oool0oooo003jVPD0
oooo0P00nYX30?ooo`800?ZJ00@0003o0?ooo`3oool00?ZJ1P3oool2003jVP040?l0003oool00?ZJ
0?l001T0oooo00<00?ZJ0?ooo`00nYX00P3oool00`00nYX0oooo003jVP05003jVP<0oooo00@0003o
0000000000000000103oool01P00nYX00000000000000000oooo0?l000`0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`020?ooo`800000103oool00`000000oooo0?ooo`020?ooo`06
003jVP3o0000o`000?l00000nYX0o`000P3oool00`00nYX0oooo0?ooo`050?ooo`04003jVP3oool0
oooo003jVPT0oooo0P00nYXA0?ooo`<00?ZJ2`3oool01000nYX0o`000?l00000nYXD0?ooo`03003j
VP3o00000?ZJ0100oooo0P00nYX:0?ooo`80o`0000<00?ZJ0?ooo`3oool04`3oool00`00nYX0oooo
003jVP080?ooo`04003jVP3oool00?ZJ000003/0oooo00100?ooo`040000003oool0oooo003jVP<0
oooo0P3o00001@3oool00?ZJ0?l00000nYX0oooo0080o`0000L00?ZJ0?ooo`00nYX0o`000?ooo`00
nYX0oooo00800?ZJ00<0o`00003jVP3oool00`3oool2003jVPD0oooo00<0003o003jVP3o0000103o
ool00`00nYX0oooo0?l00002003jVP030?l000000?l00?ZJ0080oooo0P00nYX0103o0000003o003j
VP00nYX20?ooo`80o`001P3oool3003jVP040?l000000?l0oooo0?ooo`@00?ZJ00P0o`000?ooo`3o
ool0oooo003jVP3oool00?ZJ0?l000<0oooo00<00?ZJ0?l0003oool05P3oool00`00nYX0oooo003j
VP040?ooo`04003jVP3o0000003o003jVP<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?ooo`06
003jVP3o0000oooo0?l000000?l00?ZJ0`3oool00`00nYX0o`00003jVP090?ooo`030000003oool0
oooo02H0oooo00@000000?ooo`3oool00?ZJ0P3oool20?l00005003jVP3o0000oooo0?l000000?l0
0`3oool02@00nYX0oooo0?ooo`00nYX0o`000?ooo`3o0000003o003jVP0@0?ooo`05003jVP3o0000
o`000?ooo`00nYX0103oool01P00nYX0o`000?ooo`000?l0o`00003jVPD0oooo00@00?ZJ0?ooo`3o
ool00?ZJ2`3oool01@00nYX0003o0?ooo`000?l00?ZJ00H0oooo0P00nYX0103o0000oooo003jVP3o
000I0?ooo`03003jVP3oool00?ZJ00<0oooo0P00nYX90?ooo`800?ZJ1@3oool2003jVP040?l0003o
ool0oooo0?l000`0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`020?ooo`03003j
VP3o0000o`000080o`000`3oool00`00nYX0oooo0?ooo`050?ooo`04003jVP3oool0oooo003jVPT0
oooo0P00nYXA0?ooo`800?ZJ303oool01000nYX0o`000?l00000nYXD0?ooo`03003jVP3o00000?ZJ
0100oooo00<00?ZJ0?ooo`3oool02@3oool20?l00003003jVP3oool0oooo01<0oooo00<00?ZJ0?oo
o`00nYX0203oool01000nYX0oooo003jVP00000k0?ooo`00@03oool010000000oooo0?ooo`00nYX3
0?ooo`80o`0000d0oooo003jVP3o00000?ZJ0000o`3o0000oooo003jVP3oool00?ZJ0?l000000?l0
oooo00<00?ZJ00<0o`000?ooo`3oool02`3oool3000000<0oooo00<00?ZJ0000o`3o00000P00nYX0
0`3o0000003o003jVP020?ooo`800?ZJ00@0o`00003jVP3oool00?ZJ0`3oool00`3o0000oooo0?oo
o`040?ooo`<00?ZJ0P3o00000`000?l0oooo003jVP03003jVP080?l0003oool0oooo0?ooo`00nYX0
oooo003jVP3o00030?ooo`030?l00000nYX0oooo01H0oooo00<00?ZJ0?ooo`00nYX0103oool01000
nYX0oooo0?l00000nYX20?ooo`800?ZJ0`3oool01@00nYX0oooo003jVP000?l0o`000080oooo00<0
o`00003jVP3oool00P3oool00`00nYX0o`000?ooo`090?ooo`030000003oool0oooo02H0oooo00@0
00000?ooo`3oool00?ZJ0P3oool20?l00005003jVP3o0000oooo0?l000000?l00`3oool02@00nYX0
oooo0?ooo`00nYX0o`000000o`3o0000003o003jVP0@0?ooo`03003jVP3oool0oooo00800?ZJ103o
ool01P00nYX0oooo0?l000000?l0o`00003jVPH0oooo00<00?ZJ0?ooo`00nYX02`3oool01@00nYX0
003o0?ooo`000?l00?ZJ00H0oooo0P00nYX0103o00000?ZJ003jVP3o000I0?ooo`03003jVP3oool0
0?ZJ00<0oooo00<00?ZJ0?ooo`3oool0203oool00`000?l00?ZJ0?ooo`050?ooo`05003jVP3o0000
0?ZJ0?ooo`3o0000303oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00<0
0?ZJ0?l0003o00000P3o00030?ooo`03003jVP3oool0oooo00D0oooo00@00?ZJ0?ooo`3oool00?ZJ
2@3oool2003jVQl0oooo00@00?ZJ0?ooo`3o00000?ZJ503oool00`00nYX0003o003jVP0L0?ooo`80
o`005`3oool2003jVPP0oooo0`00nYX00`000000oooo0?ooo`0i0?ooo`00@03oool010000000oooo
0?ooo`00nYX30?ooo`0?0?l00000nYX0oooo003jVP3o0000oooo0000o`3o0000oooo003jVP3oool0
0?ZJ0?ooo`3o0000oooo00<00?ZJ00<0o`000?ooo`3oool02`3oool3000000<0oooo00<00?ZJ0?l0
003oool00P00nYX00`3oool0o`00003jVP020?ooo`800?ZJ00<0o`00003jVP3oool00P00nYX20?oo
o`03003jVP3oool0oooo00@0oooo0`00nYX0103oool0o`000?l000000?l20?ooo`03003jVP3o0000
0?ZJ00<0oooo00D00?ZJ0?ooo`00nYX0o`00003jVP020?ooo`030?l00000nYX0oooo01H0oooo00<0
0?ZJ0?ooo`00nYX0103oool01000nYX0oooo0?l0003o00020?ooo`09003jVP000?l0oooo0000o`3o
ool00?ZJ0?ooo`00nYX0o`0000<0oooo0`0000020?ooo`03003jVP3o0000oooo00T0oooo00<00000
0?ooo`3oool09P3oool010000000oooo0?ooo`00nYX20?ooo`80o`0000D00?ZJ0?l0003oool0o`00
0000o`030?ooo`04003jVP3oool0oooo003jVP<0o`0000<0003o003jVP3oool03`3oool01000nYX0
oooo0?ooo`00nYX60?ooo`05003jVP3o0000o`000?ooo`00nYX01P3oool00`00nYX0oooo003jVP0;
0?ooo`800?ZJ0P000?l00`00nYX0oooo0?ooo`040?ooo`800?ZJ00@0o`00003jVP00nYX0o`006@3o
ool00`00nYX0oooo003jVP0>0?ooo`030000o`3oool0oooo00D0oooo00D00?ZJ0?l00000nYX00?ZJ
0?l0000<0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00P3oool00`00nYX0o`00
0?l000020?l000<0oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0oooo0?ooo`00nYX90?ooo`80
0?ZJ7`3oool01000nYX0oooo0000o`00nYXD0?ooo`03003jVP3oool00?ZJ01`0oooo0P3o000G0?oo
o`800?ZJ203oool2003jVP800000>`3oool00400oooo00@000000?ooo`3oool00?ZJ0`3oool01`3o
00000?ZJ0?ooo`00nYX0o`000?ooo`3o00000P3oool01P00nYX0oooo003jVP3oool0o`000?ooo`<0
0?ZJ00<0o`000?ooo`3oool02`3oool300000006003jVP3oool0oooo003jVP3o0000oooo0`00nYX0
103o00000?ZJ0?ooo`3oool2003jVP050?l00000nYX0oooo0?ooo`00nYX00P3oool00`00nYX0oooo
0?ooo`040?ooo`<00?ZJ0P3oool01`3o0000003o0?ooo`3oool00?ZJ0?l00000nYX0103oool2003j
VP060?l00000nYX0oooo0?ooo`3o00000?ZJ5`3oool00`00nYX0oooo003jVP040?ooo`05003jVP3o
ool0003o0?l0003oool00P00nYX00`000?l0o`000?l000020?l000030?ooo`00nYX0o`0000<0oooo
0`0000020?ooo`03003jVP3o0000oooo00T0oooo00<000000?ooo`3oool09P3oool010000000oooo
0?ooo`00nYX20?ooo`80o`0000@00?ZJ0?l0003o0000003o103oool01@00nYX0oooo0?ooo`00nYX0
oooo0080o`0000<0003o003jVP3oool0403oool00`00nYX0oooo003jVP060?ooo`05003jVP3o0000
o`000000o`00nYX01P3oool00`00nYX0oooo003jVP0<0?ooo`04003jVP000?l0003o003jVPH0oooo
0P00nYX0103o00000?ZJ003jVP3o000I0?ooo`03003jVP3oool00?ZJ01H0oooo00D00?ZJ0?l00000
nYX00?ZJ0?l0000<0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00P3oool00`00
nYX0o`000?l000020?l000<0oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0oooo003jVP00nYX9
0?ooo`800?ZJ803oool00`00nYX0003o003jVP0D0?ooo`03003jVP3oool00?ZJ01`0oooo0P3o000G
0?ooo`800?ZJ2`3oool00`000000oooo0?ooo`0i0?ooo`00@03oool010000000oooo0?ooo`00nYX4
0?ooo`06003jVP3oool00?ZJ0?l0003oool0o`000P3oool01P00nYX0oooo0?ooo`00nYX0o`000?oo
o`<00?ZJ00<0o`000?ooo`3oool0303oool20?l0000;003jVP3oool00?ZJ0?ooo`3o0000oooo003j
VP3oool00?ZJ0?l000000?l00P00nYX0103oool0o`000?l00000nYX20?ooo`04003jVP3oool0oooo
003jVPL0oooo00@00?ZJ0?ooo`00nYX0oooo0P3o00020?ooo`03003jVP3o00000?ZJ00@0oooo0P00
nYX01P3o00000?ZJ0?ooo`3oool0o`00003jVQL0oooo00<00?ZJ0?ooo`00nYX0103oool00`00nYX0
oooo000000020000000:003jVP000?l0o`000?l0003oool0003o0?l0003oool00?ZJ0?l000<0oooo
0`0000020?ooo`03003jVP3o0000oooo00T0oooo00<000000?ooo`3oool09P3oool010000000oooo
0?ooo`00nYX20?ooo`80o`0000@00?ZJ0?l0003o0000003o0`3oool2003jVP80oooo00H00?ZJ0?oo
o`3o0000o`000000o`00nYXA0?ooo`<00?ZJ1P3oool01@00nYX0o`000?l000000?l00?ZJ00H0oooo
00<00?ZJ0?ooo`00nYX0303oool2003jVP030000o`00nYX0oooo00D0oooo0P00nYX0103o00000?ZJ
003jVP3o000J0?ooo`800?ZJ5P3oool2003jVP030?l00000nYX0o`0000`0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`020?ooo`03003jVP3o0000o`000080o`000`3oool00`00nYX0
oooo0?ooo`050?ooo`04003jVP3oool00?ZJ003jVR/0oooo00<00?ZJ0000o`00nYX0503oool00`00
nYX0oooo003jVP0L0?ooo`80o`005`3oool2003jVP/0oooo00<000000?ooo`3oool0>@3oool00400
oooo00@000000?ooo`3oool00?ZJ103oool01P00nYX0oooo003jVP3o0000oooo0?l00080oooo00H0
0?ZJ0?ooo`3oool00?ZJ0?l000000?l3003jVP030?l0003oool0oooo00`0oooo00<00?ZJ0?l00000
nYX00P00nYX0203oool0o`000?ooo`00nYX0oooo003jVP3o0000003o0P00nYX00`3oool0o`000?l0
00030?ooo`04003jVP3oool0oooo003jVPL0oooo00<00?ZJ0?ooo`00nYX00P3oool01P3o0000oooo
0?ooo`00nYX0o`00003jVP@0oooo0P00nYX01P3o00000?ZJ0?ooo`3oool0o`00003jVQP0oooo0P00
nYX50?ooo`07003jVP0000000000000000000?l0oooo0?l000020?ooo`030000o`3o00000?ZJ0080
o`00103oool01P3o00000?ZJ0?ooo`3oool00?ZJ0?l000X0oooo00<000000?ooo`3oool09P3oool0
10000000oooo0?ooo`00nYX20?ooo`060?l0003oool00?ZJ003jVP3o0000003o0`3oool01P00nYX0
oooo0?ooo`3oool00?ZJ0?ooo`80o`0000<0003o003jVP3oool0403oool2003jVPL0oooo00D00?ZJ
0?ooo`3oool0003o003jVP060?ooo`03003jVP3oool00?ZJ00d0oooo0`00nYX60?ooo`800?ZJ00@0
o`00003jVP00nYX0o`006P3oool2003jVQL0oooo00@00?ZJ0?l00000nYX0o`00303oool00`000000
oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00<00?ZJ0?l0003o00000P3o00030?ooo`03
003jVP3oool0oooo00H0oooo0`00nYX[0?ooo`03003jVP3oool00?ZJ01@0oooo00<00?ZJ0?ooo`00
nYX0703oool20?l001L0oooo00<00?ZJ0?ooo`3oool02@3oool2000003/0oooo000c0?ooo`<00000
103oool2000000@0oooo00@000000?ooo`3oool00?ZJ103oool00`00nYX0oooo003jVP030?l00080
oooo00H00?ZJ0?ooo`3oool00?ZJ0?l000000?l3003jVP030?l0003oool0oooo00`0oooo00<00?ZJ
0?l0003oool00P00nYX01P3o0000oooo0?ooo`00nYX0oooo003jVP80o`000P00nYX00`3oool0o`00
0?l000030?ooo`04003jVP3oool0oooo003jVPT0oooo0P00nYX01P3oool0o`000?ooo`3oool00?ZJ
0?l000D0oooo0P00nYX01P3o00000?ZJ0?ooo`3oool0o`00003jVQP0oooo0P00nYX50?ooo`05003j
VP0000000000000000000?l00P3o00020?ooo`050000o`3o00000?ZJ0?l0003oool00P00nYX20?oo
o`06003jVP3o0000oooo0?ooo`3o00000?ZJ2P3oool00`000000oooo0?ooo`0V0?ooo`040000003o
ool0oooo003jVP@0oooo0P00nYX00`3oool00?ZJ003jVP020?ooo`0:003jVP3oool0oooo0?ooo`00
nYX0oooo0000o`3oool0003o003jVQ40oooo0P00nYX70?ooo`05003jVP3oool0oooo0?ooo`00nYX0
1P3oool00`00nYX0oooo003jVP0F0?ooo`<00?ZJ0P3o00000`00nYX0oooo0?ooo`0H0?ooo`800?ZJ
5`3oool01000nYX0o`00003jVP3o000<0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3o
ool00P3oool00`00nYX0o`000?l000020?l00004003jVP3oool0oooo003jVPP0oooo0P00nYX/0?oo
o`800?ZJ5@3oool00`00nYX0oooo003jVP0L0?ooo`80o`00903oool00`000000oooo0?ooo`0i0?oo
o`00=03oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo00@000000?oo
o`3oool00?ZJ103oool01P00nYX0oooo003jVP000?l0o`000000o`80oooo00H00?ZJ0?ooo`3oool0
0?ZJ0?l000000?l3003jVP030?l0003oool0oooo00d0oooo0P3o00020?ooo`080?l0003oool0oooo
003jVP3oool00?ZJ0?ooo`3o0002003jVP<0o`00103oool00`00nYX0oooo003jVP0:0?ooo`07003j
VP3oool0003o0?l0003oool00?ZJ0?l000050?ooo`<00?ZJ00D0o`000?ooo`3oool0o`00003jVP0H
0?ooo`800?ZJ1@3oool00`00nYX0oooo003jVP030?l000<0oooo00@0003o0?l00000nYX0o`001000
nYX00`3oool00?ZJ0?l000020?ooo`030?l00000nYX0oooo00T0oooo00<000000?ooo`3oool09P3o
ool010000000oooo0?ooo`00nYX40?ooo`800?ZJ00<0oooo003jVP00nYX00P3oool02P00nYX0oooo
0?ooo`3oool00?ZJ0?ooo`000?l0oooo0000o`00nYXJ0?ooo`05003jVP3oool0oooo0?ooo`00nYX0
1P3oool00`00nYX0oooo003jVP0G0?ooo`800?ZJ0P3o00000`00nYX0oooo0?ooo`0H0?ooo`800?ZJ
603oool00`3o0000oooo0?l0000<0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0
0P3oool00`00nYX0o`000?l000020?l00004003jVP3oool0oooo003jVPP0oooo0P00nYX/0?ooo`80
0?ZJ5@3oool2003jVQd0oooo0P00nYXT0?ooo`030000003oool0oooo03T0oooo000d0?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00nYX40?oo
o`05003jVP3oool0oooo003jVP000?l00`3oool01P00nYX0oooo0?ooo`00nYX0oooo0?l000<00?ZJ
00<0o`000?ooo`3oool03@3oool01P00nYX0o`000?ooo`000?l0o`000?ooo`800?ZJ0P3oool01000
nYX0o`00003jVP00nYX30?l000@0oooo00<00?ZJ0?ooo`00nYX02P3oool00`00nYX0oooo0000o`04
0?l000D0oooo0`00nYX01@3o0000oooo003jVP3o00000?ZJ01P0oooo0P00nYX50?ooo`<00?ZJ0P3o
00050?ooo`040?l00000nYX0o`00003jVP80oooo00@00?ZJ0?ooo`00nYX0o`000P3oool00`3o0000
0?ZJ0?ooo`090?ooo`030000003oool0oooo02H0oooo00@000000?ooo`3oool00?ZJ103oool2003j
VP050?ooo`00nYX00?ZJ0?ooo`00nYX01@3oool01@00nYX0oooo0000o`3oool00?ZJ01X0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP060?ooo`03003jVP3oool00?ZJ01L0oooo0P00nYX20?l00003003j
VP3oool0oooo01P0oooo0P00nYXH0?ooo`80o`0000<00?ZJ0?ooo`3oool02P3oool00`000000oooo
0?ooo`0S0?ooo`030000003oool0oooo0080oooo00<00?ZJ0?l0003o00000P3o00000`00nYX0oooo
003jVP090?ooo`800?ZJ;03oool2003jVQD0oooo0P00nYXM0?ooo`800?ZJ903oool00`000000oooo
0?ooo`0i0?ooo`00=03oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo
0P0000020?ooo`05003jVP3oool0oooo0?ooo`00nYX00P3oool00`00nYX0003o0?ooo`020?ooo`06
003jVP3oool0oooo003jVP3oool0o`000P00nYX00`3o00000?ZJ0?ooo`0>0?ooo`07003jVP3o0000
003o0000o`3o0000oooo003jVP030?ooo`04003jVP3o0000003o0?ooo`80o`0000<00?ZJ0?ooo`3o
ool00P3oool00`00nYX0oooo003jVP0;0?ooo`04003jVP000?l0oooo0?ooo`80o`001P3oool2003j
VP050?l0003oool00?ZJ0?l00000nYX0603oool2003jVPH0oooo0P00nYX70?ooo`80o`0000@0oooo
003jVP3oool0oooo0`00nYX01@3o0000oooo0?ooo`3o00000?ZJ00T0oooo0P00000J0?ooo`D00000
0`3oool2000000@0oooo00@000000?ooo`3oool00?ZJ103oool2003jVP050?ooo`00nYX00?ZJ0?oo
o`00nYX01@3oool01@00nYX0oooo0000o`3oool00?ZJ01/0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3o
ool00`00nYX0oooo003jVP0G0?ooo`800?ZJ0P3o00000`00nYX0oooo0?ooo`0H0?ooo`800?ZJ603o
ool20?l00003003jVP3oool0oooo00X0oooo00<000000?ooo`3oool05P3oool3000000@0oooo0P00
00040?ooo`030000003oool0oooo0080oooo00<00?ZJ0?l0003o00000P3o0003003jVPT0oooo0P00
nYX/0?ooo`800?ZJ5P3oool00`00nYX0oooo0?ooo`0K0?ooo`800?ZJ8`3oool2000003/0oooo000d
0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool01@000000oooo0?oo
o`3oool00?ZJ00<0oooo00D00?ZJ0?ooo`3oool00?ZJ0000o`030?ooo`0:003jVP3oool0oooo003j
VP3oool0o`000000o`3oool0o`00003jVPl0oooo00<00?ZJ0?l0003o00000P3o0002003jVP<0oooo
00@00?ZJ0?l000000?l0oooo0P3o00000`00nYX0oooo0?ooo`020?ooo`03003jVP3oool00?ZJ00/0
oooo00@00?ZJ0?ooo`000?l0oooo0P3o00060?ooo`800?ZJ00D0o`000?ooo`00nYX0o`00003jVP0H
0?ooo`800?ZJ1P3oool3003jVP80oooo0`00nYX300000003003jVP3oool0oooo0080oooo0P00nYX0
1@3o00000?ZJ0?ooo`3o00000?ZJ00X0oooo00<000000?ooo`3oool06@3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool00?ZJ103oool2003j
VP030000o`00nYX00?ZJ00800?ZJ1@3oool01@00nYX0oooo0?ooo`3oool00?ZJ01/0oooo00<00?ZJ
0?ooo`00nYX0203oool2003jVQP0oooo00@00?ZJ0?l0003o00000?ZJ6P3oool2003jVQP0oooo0P3o
00000`00nYX0oooo0?ooo`0:0?ooo`030000003oool0oooo01D0oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool00`00nYX0
o`000?l000020?l000<00?ZJ2@3oool00`00nYX0oooo0?ooo`0[0?ooo`800?ZJ5P3oool00`00nYX0
oooo0?ooo`0K0?ooo`800?ZJ903oool00`000000oooo0?ooo`0i0?ooo`00<`3oool2000000@0oooo
00@000000?ooo`3oool000000`3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00D00?ZJ0?oo
o`3oool00?ZJ0000o`030?ooo`0:003jVP3oool0oooo003jVP3oool0o`000000o`3oool0o`00003j
VPl0oooo00H00?ZJ0?ooo`3o0000o`000?ooo`00nYX40?ooo`04003jVP3o0000003o0000o`<00000
103oool00`00nYX0oooo003jVP0;0?ooo`04003jVP3oool0003o0?ooo`80o`001P3oool00`00nYX0
oooo0?l00002003jVP030?l00000nYX0oooo01L0oooo0P00nYX80?ooo`04003jVP3oool00?ZJ003j
VP80oooo0`0000000`00nYX0oooo0?ooo`020?ooo`800?ZJ00D0o`00003jVP3oool0o`00003jVP0:
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00
00030?ooo`040000003oool0oooo003jVP@0oooo0P00nYX00`000?l00?ZJ0?ooo`02003jVPD0oooo
00D00?ZJ0?ooo`3oool0oooo003jVP0K0?ooo`<00?ZJ203oool2003jVQP0oooo00@00?ZJ0?l0003o
00000?ZJ6P3oool2003jVQP0oooo00<00?ZJ0?l00000nYX0303oool00`000000oooo0?ooo`0I0?oo
o`040000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo000000040?ooo`03003jVP3o
0000o`000080o`0000<0oooo003jVP00nYX02@3oool00`00nYX0oooo0?ooo`0[0?ooo`03003jVP3o
ool0oooo03<0oooo0P00nYXT0?ooo`030000003oool0oooo03T0oooo000d0?ooo`030000003oool0
oooo00<0oooo0P0000040?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?oo
o`02003jVP<0oooo00T00?ZJ0?ooo`3oool0oooo003jVP3o0000003o0?ooo`3o00004@3oool01@00
nYX0o`000?l0003oool00?ZJ00@0oooo00@00?ZJ0?ooo`3o0000003o0`0000040?ooo`03003jVP3o
ool00?ZJ00`0oooo00D00?ZJ0000o`3oool0o`00003jVP080?ooo`040?l00000nYX00?ZJ0?l001T0
oooo0P00nYX90?ooo`800?ZJ0`3oool300000003003jVP3oool0oooo0080oooo0P00nYX01@3o0000
0?ZJ003jVP3o00000?ZJ00X0oooo00<000000?ooo`3oool06`3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool0oooo0P0000000`3oool00?ZJ0?ooo`030?ooo`<00?ZJ2@3o
ool01@00nYX0oooo0?ooo`3oool00?ZJ01`0oooo0P00nYX80?ooo`800?ZJ6@3oool20?l00003003j
VP3oool0oooo01P0oooo0P00nYXH0?ooo`03003jVP3oool00?ZJ00/0oooo0P00000K0?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool0oooo0P0000030?ooo`03003jVP3oool0o`00
0080o`0000<0oooo003jVP00nYX0=`3oool00`00nYX0oooo0?ooo`0c0?ooo`800?ZJ8`3oool20000
03/0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`02003j
VP<0oooo00L00?ZJ0?ooo`3oool0oooo003jVP3o0000003o0080o`004@3oool01@00nYX0oooo0?oo
o`3oool00?ZJ00@0oooo00@00?ZJ0?ooo`3o0000o`000`0000040?ooo`03003jVP3oool00?ZJ00`0
oooo00D00?ZJ0000o`3oool0o`00003jVP080?ooo`040?l00000nYX00?ZJ0?l001T0oooo0P00nYX?
0?ooo`800?ZJ1P3oool01@00nYX0o`00003jVP00nYX0o`0000/0oooo00<000000?ooo`3oool0603o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3oool01@000000
oooo0?ooo`3oool00?ZJ00<0oooo0`00nYX90?ooo`05003jVP3oool0oooo0?ooo`00nYX0703oool2
003jVPP0oooo0P00nYXI0?ooo`03003jVP3o00000?ZJ01X0oooo0P00nYXH0?ooo`800?ZJ3@3oool0
0`000000oooo0?ooo`0E0?ooo`@000000`3oool010000000oooo0?ooo`0000030?ooo`030000003o
ool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3o00000`3oool00?ZJ003jVP1]0?ooo`800?ZJ903o
ool00`000000oooo0?ooo`0i0?ooo`00@03oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP030?ooo`06003jVP3oool0oooo0?ooo`00nYX0oooo0`3o000A0?oo
o`04003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?l0003o0000003o003jVP060?ooo`800?ZJ303o
ool2003jVP030?ooo`3o00000?ZJ00P0oooo00@0o`00003jVP00nYX0o`006P3oool00`00nYX0oooo
0?ooo`0>0?ooo`03003jVP3oool0oooo00@0oooo00D00?ZJ0?l00000nYX00?ZJ0?l0000;0?ooo`03
0000003oool0oooo01P0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
000000<0oooo00D000000?ooo`3oool0oooo003jVP030?ooo`03003jVP3oool00?ZJ00T0oooo0`00
nYX00`3oool00?ZJ0?ooo`0U0?ooo`800?ZJ6@3oool00`00nYX0003o003jVP0J0?ooo`800?ZJ603o
ool2003jVPd0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000000<0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo0?ooo`020?l000030?oo
o`00nYX00?ZJ09<0oooo00<000000?ooo`3oool0>@3oool00400oooo00D000000?ooo`3oool0oooo
003jVP030?ooo`03003jVP3oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJ0`3oool00`00nYX0
oooo0?l000020?l00140oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool01@00nYX0o`000?l000000?l0
0?ZJ00H0oooo0P00nYX=0?ooo`03003jVP000?l0o`0000T0oooo00@0o`00003jVP00nYX0o`006P3o
ool00`00nYX0oooo0?ooo`0F0?ooo`04003jVP3o00000?ZJ0?l000/0oooo00<000000?ooo`3oool0
6@3oool3000000@0oooo0P0000040?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0
oooo003jVP090?ooo`<00?ZJ00<0oooo003jVP3oool09@3oool2003jVQT0oooo00<00?ZJ0?ooo`00
nYX06P3oool2003jVQT0oooo00<00?ZJ0?ooo`3oool02`3oool00`000000oooo0?ooo`0E0?ooo`D0
00000`3oool2000000@0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo0?ooo`020?l009D0
oooo0P00000k0?ooo`00@03oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3o
ool00P3oool01000nYX0oooo0?ooo`00nYX30?ooo`03003jVP3oool0o`000080o`004P3oool3003j
VPH0oooo00D00?ZJ0?ooo`000?l0003o003jVP060?ooo`800?ZJ3P3oool3000000P0oooo00@0o`00
003jVP3o00000?ZJ6P3oool00`00nYX0oooo0?ooo`0F0?ooo`04003jVP3o00000?ZJ0?l000/0oooo
00<000000?ooo`3oool09P3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3o
ool02P3oool2003jVP030?ooo`00nYX0oooo02D0oooo0P00nYXI0?ooo`800?ZJ703oool00`00nYX0
oooo0?ooo`0U0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00P3oool00`00nYX0
oooo0?ooo`020?l009H0oooo00<000000?ooo`3oool0>@3oool00400oooo00D000000?ooo`3oool0
oooo003jVP030?ooo`03003jVP3oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJ0`3oool01@00
nYX0oooo0?ooo`000?l0o`000180oooo0P00nYX70?ooo`05003jVP3oool0oooo0?ooo`00nYX01P3o
ool2003jVPh0oooo0`0000080?ooo`04003jVP3o0000o`00003jVQX0oooo00<00?ZJ0?ooo`3oool0
5P3oool01000nYX0o`000?l00000nYX;0?ooo`030000003oool0oooo02H0oooo00D000000?ooo`3o
ool0oooo003jVP030?ooo`03003jVP3oool0oooo00/0oooo0P00nYXW0?ooo`800?ZJ6@3oool2003j
VQ`0oooo00<00?ZJ0?ooo`3oool09@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
0080oooo00<00?ZJ0?ooo`3oool00P3o002F0?ooo`030000003oool0oooo03T0oooo00100?ooo`05
0000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`020?ooo`04003jVP3oool0oooo
003jVP<0oooo00D00?ZJ0?ooo`3oool0003o0?l0000B0?ooo`800?ZJ1`3oool01@00nYX0oooo0?oo
o`3oool00?ZJ00H0oooo0P00nYX>0?ooo`<00000203oool01000nYX0o`000?l00000nYXJ0?ooo`03
003jVP3oool0oooo01H0oooo00@00?ZJ0?l0003o00000?ZJ2`3oool00`000000oooo0?ooo`0V0?oo
o`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0;0?ooo`800?ZJ9`3oool2
003jVQT0oooo0P00nYXL0?ooo`03003jVP3oool0oooo02D0oooo00<000000?ooo`3oool08`3oool0
0`000000oooo0?ooo`020?ooo`03003jVP3oool0oooo0080o`00UP3oool00`000000oooo0?ooo`0i
0?ooo`00@03oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool00P3oool0
1000nYX0oooo0?ooo`00nYX30?ooo`03003jVP3oool0oooo00<000006P3oool01@00nYX0oooo0?oo
o`3oool00?ZJ00H0oooo0P00nYX>0?ooo`030000o`3oool0oooo00P0oooo00@00?ZJ0?l0003o0000
0?ZJ=03oool20?l00003003jVP3oool0oooo00T0oooo00<000000?ooo`3oool09P3oool01@000000
oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool02`3oool2003jVRP0oooo00<00?ZJ0?oo
o`3oool0=@3oool00`00nYX0oooo0?ooo`0U0?ooo`030000003oool0oooo02<0oooo00<000000?oo
o`3oool00P3oool00`00nYX0oooo0?ooo`020?l009D0oooo0P00000k0?ooo`00@03oool01@000000
oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX3
0?ooo`03003jVP3oool0oooo00<000006P3oool01000nYX0oooo0?ooo`00nYX70?ooo`800?ZJ6@3o
ool01000nYX0o`000?l00000nYXd0?ooo`80o`0000<00?ZJ0?ooo`3oool02@3oool00`000000oooo
0?ooo`0V0?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0;0?ooo`80
0?ZJR03oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00D00?ZJ0?ooo`3o
ool0o`00003jVP2F0?ooo`030000003oool0oooo03T0oooo00100?ooo`050000003oool0oooo0?oo
o`00nYX00`3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool00?ZJ00@0oooo00<00?ZJ0?oo
o`0000000P00000K0?ooo`03003jVP3oool00?ZJ00L0oooo0P00nYXI0?ooo`04003jVP3o0000o`00
003jVS@0oooo00<00?ZJ0?ooo`00nYX02`3oool00`000000oooo0?ooo`0V0?ooo`050000003oool0
oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0;0?ooo`800?ZJR03oool00`000000oooo0?oo
o`0S0?ooo`030000003oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P00nYZF0?ooo`030000003o
ool0oooo03T0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?oo
o`030?ooo`<00?ZJ103oool01000nYX0oooo0000o`00nYXL0?ooo`<00?ZJ1`3oool2003jVQT0oooo
00@00?ZJ0?l0003o00000?ZJ=03oool2003jVP`0oooo00<000000?ooo`3oool09P3oool01@000000
oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool02`3oool2003jVXP0oooo00<000000?oo
o`3oool08`3oool00`000000oooo0?ooo`020?ooo`03003jVP3oool0oooo00800?ZJU@3oool20000
03/0oooo00100?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`030?oo
o`800?ZJ1@3oool01000nYX0oooo0?ooo`00nYXW0?ooo`03003jVP3oool0oooo01P0oooo0P00nYXe
0?ooo`800?ZJ303oool00`000000oooo0?ooo`0V0?ooo`050000003oool0oooo0?ooo`00nYX00`3o
ool00`00nYX0oooo0?ooo`0;0?ooo`800?ZJR03oool00`000000oooo0?ooo`0S0?ooo`030000003o
ool0oooo0080oooo00<00?ZJ0?ooo`3oool00P00nYZF0?ooo`030000003oool0oooo03T0oooo0010
0?ooo`050000003oool0oooo0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0:0?ooo`@00?ZJ9`3o
ool00`00nYX0oooo0?ooo`0H0?ooo`800?ZJ=@3oool2003jVP`0oooo00<000000?ooo`3oool09P3o
ool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool0303oool00`00nYX0oooo
0?ooo`260?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo
0?ooo`02003jVYH0oooo00<000000?ooo`3oool0>@3oool00400oooo00D000000?ooo`3oool0oooo
003jVP030?ooo`03003jVP3oool0oooo00X0oooo1000nYY20?ooo`800?ZJ=P3oool00`00nYX0oooo
0?ooo`0:0?ooo`030000003oool0oooo02H0oooo00D000000?ooo`3oool0oooo003jVP030?ooo`03
003jVP3oool0oooo00`0oooo00<00?ZJ0?ooo`3oool0QP3oool00`000000oooo0?ooo`0S0?ooo`03
0000003oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P00nYZE0?ooo`800000>`3oool00380oooo
1@0000030?ooo`800000103oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3o
ool02P3oool4003jVT80oooo0P00nYY30?ooo`030000003oool0oooo01T0oooo0`0000040?ooo`80
0000103oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool0U@3oool00`00
0000oooo0?ooo`0F0?ooo`<00000103oool2000000@0oooo00<000000?ooo`3oool00P3oool00`00
nYX0oooo0?ooo`02003jVYH0oooo00<000000?ooo`3oool0>@3oool003<0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo0080oooo00@00?ZJ
0?ooo`3oool00?ZJ3@3oool3003jVPL0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?oo
o`0H0?ooo`800?ZJ0`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01d0oooo00<0
00000?ooo`3oool0603oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000`3oool01@000000oooo0?ooo`3oool00?ZJ00<0oooo00<00?ZJ0?ooo`3oool05@3oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool0oooo01D0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo0?oo
o`02003jVQH0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0M0?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0i0?ooo`00=03oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo1@0000001000nYX000000000
0000nYX>000000800?ZJR000000N0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool0oooo100000001@00nYX000000000000000000?ZJ09P000005`3oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000`3oool500000003003jVP000000000000800?ZJ
U`00000k0?ooo`00=@3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
_P3oool2000000<0oooo00@000000?ooo`3oool00000^`3oool4000000<0oooo00@000000?ooo`3o
ool00000g`3oool00380oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000<80oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`2i0?ooo`030000003o
ool0oooo00@0oooo00@000000?ooo`3oool00000g`3oool00380oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo00000;h0oooo00D000000?ooo`3oool0oooo000000020?oo
o`040000003oool0oooo00000;`0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`00
003O0?ooo`00<`3oool3000000@0oooo0P0000300?ooo`<00000103oool200000540oooo0`00001Z
0?ooo`800000103oool200000>00oooo003o0?oooeP0oooo00<000000?ooo`3oool0o`3ooomB0?oo
o`00S@3oool2000000030?ooo`00000000000<H0oooo00<000000?ooo`3oool0`@3oool5000008X0
oooo002>0?ooo`030000003oool000000<L0oooo00<000000?ooo`3oool0`P3oool010000000oooo
0?ooo`00002:0?ooo`00S`3oool00`000000oooo0?ooo`350?ooo`030000003oool000000<@0oooo
00<000000?ooo`3oool0RP3oool008h0oooo00<000000?ooo`000000aP3oool00`000000oooo0000
00320?ooo`040000003oool0oooo000008/0oooo002=0?ooo`80000000<0oooo000000000000a03o
ool2000000030?ooo`00000000000<40oooo1@00002:0?ooo`00o`3ooooo0?ooojd0oooo003o0?oo
ool0oooo[@3oool00?l0ooooo`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo[@3o
ool00?l0ooooo`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo[@3oool00?l0oooo
o`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo[@3oool00?l0ooooo`3ooon]0?oo
o`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo[@3oool00?l0ooooo`3ooon]0?ooo`00o`3ooooo
0?ooojd0oooo003o0?ooool0oooo[@3oool00?l0ooooo`3ooon]0?ooo`00o`3ooooo0?ooojd0oooo
003o0?oooe80oooo00<000000?ooo`3oool0o`3ooomH0?ooo`00o`3ooomC0?ooo`030000003oool0
oooo0?l0ooooE`3oool00?l0oooo?`3oool300000080oooo0`0000000`3oool00000000000030000
00H0oooo00<000000?ooo`3oool01P3oool01@000000oooo0000003oool000000080oooo10000002
0?ooo`<00000o`3ooom10?ooo`00o`3oooln0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo00h0oooo00D000000?ooo`000000oooo
000000070?ooo`050000003oool0oooo0?ooo`000000o`3ooom00?ooo`00o`3oooln0?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
00h0oooo00D000000?ooo`000000oooo000000020?ooo`@000001@3oool00`000000oooo0?ooo`3o
0?oooch0oooo003o0?oooch0oooo00<000000?ooo`0000000`0000000`3oool00000000000020000
0080oooo0`00000>0?ooo`050000003oool000000?ooo`0000002@3oool200000?l0oooo@@3oool0
0?l0oooo?P3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool03P3oool2000000030?ooo`000000oooo00/0oooo00<000000?ooo`3oool0o`3oooln
0?ooo`00o`3oooln0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo000001T0oooo00D000000?ooo`3oool0oooo0000003o0?oood00
oooo003o0?ooocl0oooo0`0000020?ooo`<0000000<0oooo0000000000001@00000J0?ooo`<00000
o`3ooom10?ooo`00o`3ooooo0?ooojd0oooo003o0?ooool0oooo[@3oool00001\
\>"],
  ImageRangeCache->{{{0, 682.75}, {280.688, 0}} -> {-0.199015, -0.0309084, \
0.00497698, 0.00497698}, {{39.9375, 240.875}, {274.438, 150.25}} -> \
{-382.105, 3.26001, 6.23796, 0.100831}, {{240.875, 441.812}, {274.438, \
150.25}} -> {-1635.55, 23.2599, 6.23796, 0.100831}, {{441.812, 642.75}, \
{274.438, 150.25}} -> {-2870.27, -1.39199, 6.23796, 0.0806652}, {{39.9375, \
240.875}, {150.25, 26.0625}} -> {-400.819, -101.31, 6.23796, 0.504157}, \
{{240.875, 441.812}, {150.25, 26.0625}} -> {-1654.26, -115.572, 6.23796, \
0.604987}, {{441.812, 642.75}, {150.25, 26.0625}} -> {-2888.99, -85.5717, \
6.23796, 0.604987}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["LLF", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(\(YMAX = 5000;\)\)], "Input"],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tShojiOzaki[{ZM, X}, Theta+1, 
\t     {driftLorenzX, DdriftLorenzX,DDdriftLorenzX,diffusionLorenzX, 
\t      hLorenzX, DhLorenzX, RLorenzX, mueLorenzX,sigmaLorenzX,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]39\),
      SequenceForm[ "Warnung: Overflow", 39],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]43\),
      SequenceForm[ "Warnung: Overflow", 43],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]45\),
      SequenceForm[ "Warnung: Overflow", 45],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]46\),
      SequenceForm[ "Warnung: Overflow", 46],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]49\),
      SequenceForm[ "Warnung: Overflow", 49],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.2770730000000299`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["YF//Dimensions", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1001, 6}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({301.0920246429617`, 735.5124285736117`, 652.7605519536414`, 
      181.9597878362411`, 81.0166574136542`, 81.15483735307338`}\)], "Output"],

Cell[BoxData[
    \({{0.119322028622599`, 0.7587803849008747`, \(-7.519246683171544`\), 
        4.970670504944493`, \(-2.1830293671393513`\), 
        2.131921599660071`}, {9.515860639775108`, 23.234938063598324`, 
        19.212797735804045`, 2.892874493057629`, 1.3384783969312795`, 
        1.4263374041961214`}}\)], "Output"]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
yrange={{-30,20},{-30,30},{0,60},{0,15},{25,35},{-5,8}}

graph1[i_]:=
DisplayTogether[

plot1[Y[[All,{i}]]//AddTimeAxis,
\t\tcolor->1(*,GridLines->{ti,None}*)],

plot1[Column[KI,{0,6,12}+i]//AddTimeAxis,permute->{3,2,1},
\t\tcolor->{3,2,2}(*,GridLines->{ti,None}*),dicke->.005{1,1,1,1,1,1}],

If[i<=3,\t
plot1[Spalte[ti-1]~ii~Z[[ti,{i}]],PlotJoined->False,
\t\t\tcolor->10,dicke->.02],
plot1[{-5,-5}]
],

PlotRange->{{0,T1},yrange[[i]]},
PlotLabel->{\"x\",\"y\",\"z\",\"sigma\",\"r\",\"b\"}[[i]],
DisplayFunction->Identity];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-30\), 20}, {\(-30\), 30}, {0, 60}, {0, 15}, {25, 35}, {\(-5\), 
        8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gLLF=Show[GraphicsArray[{{graph1[1],graph1[2],graph1[3]},{graph1[4],\
graph1[5],graph1[6]}}],PlotLabel->\"LLF\"]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 4}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 4}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2}\),
      SequenceForm[ "Dimension der Daten  ", {2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{2, 2}\),
      SequenceForm[ "Dimension der Daten  ", {2, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -11 0 ]
[.5 .42452 11 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(LLF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0412023 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0824 -6 -4.5 ]
[-0.0125 .0824 0 4.5 ]
[-0.0125 .16481 -6 -4.5 ]
[-0.0125 .16481 0 4.5 ]
[-0.0125 .24721 -6 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .32962 -6 -4.5 ]
[-0.0125 .32962 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .57683 -12 -4.5 ]
[-0.0125 .57683 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -17 0 ]
[.5 .63053 17 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0824 m
.00625 .0824 L
s
[(2)] -0.0125 .0824 1 0 Mshowa
0 .16481 m
.00625 .16481 L
s
[(4)] -0.0125 .16481 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(6)] -0.0125 .24721 1 0 Mshowa
0 .32962 m
.00625 .32962 L
s
[(8)] -0.0125 .32962 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(12)] -0.0125 .49443 1 0 Mshowa
0 .57683 m
.00625 .57683 L
s
[(14)] -0.0125 .57683 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .10301 m
.00375 .10301 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .18541 m
.00375 .18541 L
s
0 .20601 m
.00375 .20601 L
s
0 .22661 m
.00375 .22661 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .30902 m
.00375 .30902 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .51503 m
.00375 .51503 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .0824 m
1 .0824 L
s
.99375 .16481 m
1 .16481 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .32962 m
1 .32962 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .49443 m
1 .49443 L
s
.99375 .57683 m
1 .57683 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .10301 m
1 .10301 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20601 m
1 .20601 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .30902 m
1 .30902 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .51503 m
1 .51503 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sigma) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .41201 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .41202 m
.001 .41202 L
.002 .41202 L
.003 .41202 L
.004 .41202 L
.005 .41202 L
.00599 .41202 L
.00699 .41202 L
.00799 .41202 L
.00899 .41202 L
.00999 .41202 L
.01099 .41202 L
.01199 .41202 L
.01299 .41202 L
.01399 .41202 L
.01499 .41202 L
.01598 .41202 L
.01698 .41202 L
.01798 .41203 L
.01898 .41203 L
.01998 .41203 L
.02098 .41202 L
.02198 .41202 L
.02298 .41202 L
.02398 .41203 L
.02498 .41203 L
.02597 .41203 L
.02697 .41203 L
.02797 .41203 L
.02897 .41203 L
.02997 .41202 L
.03097 .41203 L
.03197 .41203 L
.03297 .41203 L
.03397 .41203 L
.03497 .41203 L
.03596 .41203 L
.03696 .41203 L
.03796 .41203 L
.03896 .41203 L
.03996 .41203 L
.04096 .41202 L
.04196 .41203 L
.04296 .41203 L
.04396 .41203 L
.04496 .41203 L
.04595 .41203 L
.04695 .41203 L
.04795 .41203 L
.04895 .41202 L
Mistroke
.04995 .41202 L
.05095 .41202 L
.05195 .41202 L
.05295 .41202 L
.05395 .41202 L
.05495 .41202 L
.05594 .41202 L
.05694 .41202 L
.05794 .41202 L
.05894 .41202 L
.05994 .41202 L
.06094 .41202 L
.06194 .41202 L
.06294 .41202 L
.06394 .41202 L
.06494 .41202 L
.06593 .41202 L
.06693 .41202 L
.06793 .41202 L
.06893 .41202 L
.06993 .41202 L
.07093 .41202 L
.07193 .41202 L
.07293 .41202 L
.07393 .41203 L
.07493 .41202 L
.07592 .41202 L
.07692 .41202 L
.07792 .41202 L
.07892 .41202 L
.07992 .41202 L
.08092 .41202 L
.08192 .41202 L
.08292 .41202 L
.08392 .41202 L
.08492 .41202 L
.08591 .41202 L
.08691 .41202 L
.08791 .41202 L
.08891 .41202 L
.08991 .41202 L
.09091 .41202 L
.09191 .41202 L
.09291 .41202 L
.09391 .41202 L
.09491 .41202 L
.0959 .41202 L
.0969 .41202 L
.0979 .41202 L
.0989 .41202 L
Mistroke
.0999 .41202 L
.1009 .41202 L
.1019 .41202 L
.1029 .41202 L
.1039 .41202 L
.1049 .41202 L
.10589 .41202 L
.10689 .41202 L
.10789 .41202 L
.10889 .41202 L
.10989 .41202 L
.11089 .41202 L
.11189 .41202 L
.11289 .41202 L
.11389 .41202 L
.11489 .41202 L
.11588 .41202 L
.11688 .41202 L
.11788 .41202 L
.11888 .41202 L
.11988 .41202 L
.12088 .41202 L
.12188 .41202 L
.12288 .41202 L
.12388 .41202 L
.12488 .41202 L
.12587 .41202 L
.12687 .41202 L
.12787 .41202 L
.12887 .41202 L
.12987 .41202 L
.13087 .41202 L
.13187 .41202 L
.13287 .41202 L
.13387 .41202 L
.13487 .41202 L
.13586 .41202 L
.13686 .41202 L
.13786 .41202 L
.13886 .41202 L
.13986 .41202 L
.14086 .41202 L
.14186 .41202 L
.14286 .41202 L
.14386 .41202 L
.14486 .41202 L
.14585 .41202 L
.14685 .41202 L
.14785 .41202 L
.14885 .41202 L
Mistroke
.14985 .41202 L
.15085 .41202 L
.15185 .41202 L
.15285 .41202 L
.15385 .41202 L
.15485 .41202 L
.15584 .41202 L
.15684 .41202 L
.15784 .41202 L
.15884 .41202 L
.15984 .41202 L
.16084 .41202 L
.16184 .41202 L
.16284 .41202 L
.16384 .41202 L
.16484 .41202 L
.16583 .41202 L
.16683 .41202 L
.16783 .41202 L
.16883 .41202 L
.16983 .41202 L
.17083 .41202 L
.17183 .41202 L
.17283 .41202 L
.17383 .41202 L
.17483 .41202 L
.17582 .41202 L
.17682 .41202 L
.17782 .41202 L
.17882 .41202 L
.17982 .41202 L
.18082 .41202 L
.18182 .41202 L
.18282 .41202 L
.18382 .41202 L
.18482 .41202 L
.18581 .41202 L
.18681 .41202 L
.18781 .41202 L
.18881 .41202 L
.18981 .41202 L
.19081 .41202 L
.19181 .41202 L
.19281 .41202 L
.19381 .41202 L
.19481 .41202 L
.1958 .41202 L
.1968 .41202 L
.1978 .41202 L
.1988 .41202 L
Mistroke
.1998 .41202 L
.2008 .41202 L
.2018 .41202 L
.2028 .41202 L
.2038 .41202 L
.2048 .41202 L
.20579 .41202 L
.20679 .41202 L
.20779 .41202 L
.20879 .41202 L
.20979 .41202 L
.21079 .41202 L
.21179 .41202 L
.21279 .41202 L
.21379 .41202 L
.21479 .41202 L
.21578 .41202 L
.21678 .41202 L
.21778 .41202 L
.21878 .41202 L
.21978 .41202 L
.22078 .41202 L
.22178 .41202 L
.22278 .41202 L
.22378 .41202 L
.22478 .41202 L
.22577 .41202 L
.22677 .41202 L
.22777 .41202 L
.22877 .41202 L
.22977 .41202 L
.23077 .41202 L
.23177 .41202 L
.23277 .41202 L
.23377 .41202 L
.23477 .41202 L
.23576 .41202 L
.23676 .41202 L
.23776 .41202 L
.23876 .41202 L
.23976 .41202 L
.24076 .41202 L
.24176 .41202 L
.24276 .41202 L
.24376 .41202 L
.24476 .41202 L
.24575 .41202 L
.24675 .41202 L
.24775 .41202 L
.24875 .41202 L
Mistroke
.24975 .41202 L
.25075 .41202 L
.25175 .41202 L
.25275 .41202 L
.25375 .41202 L
.25475 .41202 L
.25574 .41202 L
.25674 .41202 L
.25774 .41202 L
.25874 .41202 L
.25974 .41202 L
.26074 .41202 L
.26174 .41202 L
.26274 .41202 L
.26374 .41202 L
.26474 .41202 L
.26573 .41202 L
.26673 .41202 L
.26773 .41202 L
.26873 .41202 L
.26973 .41202 L
.27073 .41202 L
.27173 .41202 L
.27273 .41202 L
.27373 .41202 L
.27473 .41202 L
.27572 .41202 L
.27672 .41202 L
.27772 .41202 L
.27872 .41202 L
.27972 .41202 L
.28072 .41202 L
.28172 .41202 L
.28272 .41202 L
.28372 .41202 L
.28472 .41202 L
.28571 .41202 L
.28671 .41202 L
.28771 .41202 L
.28871 .41202 L
.28971 .41202 L
.29071 .41202 L
.29171 .41202 L
.29271 .41202 L
.29371 .41202 L
.29471 .41202 L
.2957 .41202 L
.2967 .41202 L
.2977 .41202 L
.2987 .41202 L
Mistroke
.2997 .41202 L
.3007 .41202 L
.3017 .41202 L
.3027 .41202 L
.3037 .41202 L
.3047 .41202 L
.30569 .41202 L
.30669 .41202 L
.30769 .41202 L
.30869 .41202 L
.30969 .41202 L
.31069 .41202 L
.31169 .41202 L
.31269 .41202 L
.31369 .41202 L
.31469 .41202 L
.31568 .41201 L
.31668 .41201 L
.31768 .41202 L
.31868 .41202 L
.31968 .41202 L
.32068 .41202 L
.32168 .41202 L
.32268 .41202 L
.32368 .41202 L
.32468 .41202 L
.32567 .41202 L
.32667 .41202 L
.32767 .41201 L
.32867 .41201 L
.32967 .41201 L
.33067 .41201 L
.33167 .41201 L
.33267 .41201 L
.33367 .41201 L
.33467 .41201 L
.33566 .41201 L
.33666 .41201 L
.33766 .41201 L
.33866 .41201 L
.33966 .41201 L
.34066 .41201 L
.34166 .41201 L
.34266 .41201 L
.34366 .41201 L
.34466 .41201 L
.34565 .41201 L
.34665 .41201 L
.34765 .41201 L
.34865 .41201 L
Mistroke
.34965 .41201 L
.35065 .41201 L
.35165 .41201 L
.35265 .41201 L
.35365 .41201 L
.35465 .41201 L
.35564 .41201 L
.35664 .41201 L
.35764 .41201 L
.35864 .41201 L
.35964 .41201 L
.36064 .41201 L
.36164 .41201 L
.36264 .41201 L
.36364 .41201 L
.36464 .41201 L
.36563 .41201 L
.36663 .41201 L
.36763 .41201 L
.36863 .41201 L
.36963 .41201 L
.37063 .41201 L
.37163 .41201 L
.37263 .41201 L
.37363 .41201 L
.37463 .41201 L
.37562 .41201 L
.37662 .41201 L
.37762 .41201 L
.37862 .41201 L
.37962 .41201 L
.38062 .41201 L
.38162 .41201 L
.38262 .41201 L
.38362 .41201 L
.38462 .41201 L
.38561 .41201 L
.38661 .41201 L
.38761 .41201 L
.38861 .41201 L
.38961 .41201 L
.39061 .41201 L
.39161 .41201 L
.39261 .41201 L
.39361 .41201 L
.39461 .41201 L
.3956 .41201 L
.3966 .41201 L
.3976 .41201 L
.3986 .41201 L
Mistroke
.3996 .41201 L
.4006 .41201 L
.4016 .41201 L
.4026 .41201 L
.4036 .41201 L
.4046 .41201 L
.40559 .41201 L
.40659 .41201 L
.40759 .41201 L
.40859 .41201 L
.40959 .41201 L
.41059 .41201 L
.41159 .41201 L
.41259 .41201 L
.41359 .41201 L
.41459 .41201 L
.41558 .41201 L
.41658 .41201 L
.41758 .41201 L
.41858 .41201 L
.41958 .41201 L
.42058 .41201 L
.42158 .41201 L
.42258 .41201 L
.42358 .41201 L
.42458 .41201 L
.42557 .41201 L
.42657 .41201 L
.42757 .41201 L
.42857 .41201 L
.42957 .41201 L
.43057 .41201 L
.43157 .41201 L
.43257 .41201 L
.43357 .41201 L
.43457 .41201 L
.43556 .41201 L
.43656 .41201 L
.43756 .41201 L
.43856 .41201 L
.43956 .41201 L
.44056 .41201 L
.44156 .41201 L
.44256 .41201 L
.44356 .41201 L
.44456 .41201 L
.44555 .41201 L
.44655 .41201 L
.44755 .41201 L
.44855 .41201 L
Mistroke
.44955 .41201 L
.45055 .41201 L
.45155 .41201 L
.45255 .41201 L
.45355 .41201 L
.45455 .41201 L
.45554 .41201 L
.45654 .41201 L
.45754 .41201 L
.45854 .41201 L
.45954 .41201 L
.46054 .41201 L
.46154 .41201 L
.46254 .41201 L
.46354 .41201 L
.46454 .41201 L
.46553 .41201 L
.46653 .41201 L
.46753 .41201 L
.46853 .41201 L
.46953 .41201 L
.47053 .41201 L
.47153 .41201 L
.47253 .41201 L
.47353 .41201 L
.47453 .41201 L
.47552 .41201 L
.47652 .41201 L
.47752 .41201 L
.47852 .41201 L
.47952 .41201 L
.48052 .41201 L
.48152 .41201 L
.48252 .41201 L
.48352 .41201 L
.48452 .41201 L
.48551 .41201 L
.48651 .41201 L
.48751 .41201 L
.48851 .41201 L
.48951 .41201 L
.49051 .41201 L
.49151 .41201 L
.49251 .41201 L
.49351 .41201 L
.49451 .41201 L
.4955 .41201 L
.4965 .41201 L
.4975 .41201 L
.4985 .41201 L
Mistroke
.4995 .41201 L
.5005 .41201 L
.5015 .41201 L
.5025 .41201 L
.5035 .41201 L
.5045 .41201 L
.50549 .41201 L
.50649 .41201 L
.50749 .41201 L
.50849 .41202 L
.50949 .41201 L
.51049 .41202 L
.51149 .41202 L
.51249 .41202 L
.51349 .41202 L
.51449 .41202 L
.51548 .41202 L
.51648 .41202 L
.51748 .41202 L
.51848 .41202 L
.51948 .41202 L
.52048 .41202 L
.52148 .41202 L
.52248 .41202 L
.52348 .41202 L
.52448 .41202 L
.52547 .41202 L
.52647 .41202 L
.52747 .41202 L
.52847 .41202 L
.52947 .41202 L
.53047 .41202 L
.53147 .41202 L
.53247 .41202 L
.53347 .41202 L
.53447 .41202 L
.53546 .41202 L
.53646 .41202 L
.53746 .41202 L
.53846 .41202 L
.53946 .41202 L
.54046 .41202 L
.54146 .41202 L
.54246 .41202 L
.54346 .41202 L
.54446 .41202 L
.54545 .41202 L
.54645 .41202 L
.54745 .41202 L
.54845 .41202 L
Mistroke
.54945 .41202 L
.55045 .41202 L
.55145 .41202 L
.55245 .41202 L
.55345 .41202 L
.55445 .41202 L
.55544 .41202 L
.55644 .41202 L
.55744 .41202 L
.55844 .41202 L
.55944 .41202 L
.56044 .41202 L
.56144 .41202 L
.56244 .41202 L
.56344 .41202 L
.56444 .41202 L
.56543 .41202 L
.56643 .41202 L
.56743 .41202 L
.56843 .41202 L
.56943 .41202 L
.57043 .41202 L
.57143 .41202 L
.57243 .41202 L
.57343 .41202 L
.57443 .41202 L
.57542 .41202 L
.57642 .41202 L
.57742 .41202 L
.57842 .41202 L
.57942 .41202 L
.58042 .41202 L
.58142 .41202 L
.58242 .41202 L
.58342 .41202 L
.58442 .41202 L
.58541 .41202 L
.58641 .41202 L
.58741 .41202 L
.58841 .41202 L
.58941 .41202 L
.59041 .41202 L
.59141 .41202 L
.59241 .41202 L
.59341 .41202 L
.59441 .41202 L
.5954 .41202 L
.5964 .41202 L
.5974 .41202 L
.5984 .41202 L
Mistroke
.5994 .41202 L
.6004 .41202 L
.6014 .41202 L
.6024 .41202 L
.6034 .41202 L
.6044 .41202 L
.60539 .41202 L
.60639 .41202 L
.60739 .41202 L
.60839 .41202 L
.60939 .41202 L
.61039 .41202 L
.61139 .41202 L
.61239 .41202 L
.61339 .41202 L
.61439 .41202 L
.61538 .41202 L
.61638 .41202 L
.61738 .41202 L
.61838 .41202 L
.61938 .41202 L
.62038 .41202 L
.62138 .41202 L
.62238 .41202 L
.62338 .41202 L
.62438 .41202 L
.62537 .41202 L
.62637 .41202 L
.62737 .41202 L
.62837 .41202 L
.62937 .41202 L
.63037 .41202 L
.63137 .41202 L
.63237 .41202 L
.63337 .41202 L
.63437 .41202 L
.63536 .41202 L
.63636 .41202 L
.63736 .41202 L
.63836 .41202 L
.63936 .41202 L
.64036 .41202 L
.64136 .41202 L
.64236 .41202 L
.64336 .41202 L
.64436 .41202 L
.64535 .41202 L
.64635 .41202 L
.64735 .41202 L
.64835 .41202 L
Mistroke
.64935 .41202 L
.65035 .41202 L
.65135 .41202 L
.65235 .41202 L
.65335 .41202 L
.65435 .41202 L
.65534 .41202 L
.65634 .41202 L
.65734 .41202 L
.65834 .41202 L
.65934 .41202 L
.66034 .41202 L
.66134 .41202 L
.66234 .41202 L
.66334 .41202 L
.66434 .41202 L
.66533 .41202 L
.66633 .41202 L
.66733 .41202 L
.66833 .41202 L
.66933 .41202 L
.67033 .41202 L
.67133 .41202 L
.67233 .41202 L
.67333 .41202 L
.67433 .41202 L
.67532 .41202 L
.67632 .41202 L
.67732 .41202 L
.67832 .41202 L
.67932 .41202 L
.68032 .41202 L
.68132 .41202 L
.68232 .41202 L
.68332 .41202 L
.68432 .41202 L
.68531 .41202 L
.68631 .41202 L
.68731 .41202 L
.68831 .41202 L
.68931 .41202 L
.69031 .41202 L
.69131 .41202 L
.69231 .41202 L
.69331 .41202 L
.69431 .41202 L
.6953 .41202 L
.6963 .41202 L
.6973 .41202 L
.6983 .41202 L
Mistroke
.6993 .41202 L
.7003 .41202 L
.7013 .41202 L
.7023 .41202 L
.7033 .41202 L
.7043 .41202 L
.70529 .41202 L
.70629 .41202 L
.70729 .41202 L
.70829 .41202 L
.70929 .41202 L
.71029 .41202 L
.71129 .41202 L
.71229 .41202 L
.71329 .41202 L
.71429 .41202 L
.71528 .41202 L
.71628 .41202 L
.71728 .41201 L
.71828 .41201 L
.71928 .41202 L
.72028 .41202 L
.72128 .41201 L
.72228 .41201 L
.72328 .41201 L
.72428 .41201 L
.72527 .41201 L
.72627 .41201 L
.72727 .41201 L
.72827 .41201 L
.72927 .41201 L
.73027 .41201 L
.73127 .41201 L
.73227 .41201 L
.73327 .41201 L
.73427 .41201 L
.73526 .41201 L
.73626 .41201 L
.73726 .41202 L
.73826 .41202 L
.73926 .41202 L
.74026 .41202 L
.74126 .41202 L
.74226 .41202 L
.74326 .41202 L
.74426 .41202 L
.74525 .41202 L
.74625 .41202 L
.74725 .41202 L
.74825 .41202 L
Mistroke
.74925 .41202 L
.75025 .41202 L
.75125 .41202 L
.75225 .41202 L
.75325 .41202 L
.75425 .41202 L
.75524 .41202 L
.75624 .41202 L
.75724 .41202 L
.75824 .41202 L
.75924 .41202 L
.76024 .41202 L
.76124 .41202 L
.76224 .41202 L
.76324 .41202 L
.76424 .41202 L
.76523 .41202 L
.76623 .41202 L
.76723 .41202 L
.76823 .41202 L
.76923 .41202 L
.77023 .41202 L
.77123 .41202 L
.77223 .41202 L
.77323 .41202 L
.77423 .41202 L
.77522 .41202 L
.77622 .41202 L
.77722 .41202 L
.77822 .41202 L
.77922 .41202 L
.78022 .41202 L
.78122 .41202 L
.78222 .41202 L
.78322 .41202 L
.78422 .41202 L
.78521 .41202 L
.78621 .41202 L
.78721 .41202 L
.78821 .41202 L
.78921 .41202 L
.79021 .41202 L
.79121 .41202 L
.79221 .41202 L
.79321 .41202 L
.79421 .41202 L
.7952 .41202 L
.7962 .41202 L
.7972 .41202 L
.7982 .41202 L
Mistroke
.7992 .41202 L
.8002 .41202 L
.8012 .41202 L
.8022 .41202 L
.8032 .41202 L
.8042 .41202 L
.80519 .41201 L
.80619 .41201 L
.80719 .41201 L
.80819 .41201 L
.80919 .41201 L
.81019 .41201 L
.81119 .41201 L
.81219 .41201 L
.81319 .41201 L
.81419 .41201 L
.81518 .41201 L
.81618 .41201 L
.81718 .41201 L
.81818 .41201 L
.81918 .41201 L
.82018 .41201 L
.82118 .41201 L
.82218 .41201 L
.82318 .41201 L
.82418 .41201 L
.82517 .41201 L
.82617 .41201 L
.82717 .41201 L
.82817 .41201 L
.82917 .41201 L
.83017 .41201 L
.83117 .41201 L
.83217 .41201 L
.83317 .41201 L
.83417 .41201 L
.83516 .41201 L
.83616 .41201 L
.83716 .41201 L
.83816 .41201 L
.83916 .41201 L
.84016 .41201 L
.84116 .41201 L
.84216 .41201 L
.84316 .41201 L
.84416 .41201 L
.84515 .41201 L
.84615 .41201 L
.84715 .41201 L
.84815 .41201 L
Mistroke
.84915 .41201 L
.85015 .41201 L
.85115 .41201 L
.85215 .41201 L
.85315 .41201 L
.85415 .41201 L
.85514 .41201 L
.85614 .41201 L
.85714 .41201 L
.85814 .41201 L
.85914 .41201 L
.86014 .41201 L
.86114 .41201 L
.86214 .41201 L
.86314 .41201 L
.86414 .41201 L
.86513 .41201 L
.86613 .41201 L
.86713 .41201 L
.86813 .41201 L
.86913 .41201 L
.87013 .41201 L
.87113 .41201 L
.87213 .41201 L
.87313 .41201 L
.87413 .41201 L
.87512 .41201 L
.87612 .41201 L
.87712 .41201 L
.87812 .41201 L
.87912 .41201 L
.88012 .41201 L
.88112 .41201 L
.88212 .41202 L
.88312 .41201 L
.88412 .41201 L
.88511 .41201 L
.88611 .41201 L
.88711 .41201 L
.88811 .41201 L
.88911 .41201 L
.89011 .41201 L
.89111 .41201 L
.89211 .41201 L
.89311 .41201 L
.89411 .41201 L
.8951 .41201 L
.8961 .41201 L
.8971 .41201 L
.8981 .41201 L
Mistroke
.8991 .41201 L
.9001 .41201 L
.9011 .41201 L
.9021 .41201 L
.9031 .41201 L
.9041 .41201 L
.90509 .41201 L
.90609 .41201 L
.90709 .41201 L
.90809 .41201 L
.90909 .41201 L
.91009 .41201 L
.91109 .41201 L
.91209 .41201 L
.91309 .41201 L
.91409 .41201 L
.91508 .41201 L
.91608 .41201 L
.91708 .41201 L
.91808 .41201 L
.91908 .41201 L
.92008 .41201 L
.92108 .41201 L
.92208 .41201 L
.92308 .41201 L
.92408 .41201 L
.92507 .41201 L
.92607 .41201 L
.92707 .41201 L
.92807 .41202 L
.92907 .41202 L
.93007 .41202 L
.93107 .41202 L
.93207 .41202 L
.93307 .41202 L
.93407 .41202 L
.93506 .41202 L
.93606 .41202 L
.93706 .41202 L
.93806 .41202 L
.93906 .41202 L
.94006 .41202 L
.94106 .41202 L
.94206 .41202 L
.94306 .41202 L
.94406 .41202 L
.94505 .41201 L
.94605 .41201 L
.94705 .41202 L
.94805 .41201 L
Mistroke
.94905 .41202 L
.95005 .41201 L
.95105 .41201 L
.95205 .41201 L
.95305 .41201 L
.95405 .41201 L
.95504 .41201 L
.95604 .41201 L
.95704 .41201 L
.95804 .41201 L
.95904 .41201 L
.96004 .41201 L
.96104 .41201 L
.96204 .41202 L
.96304 .41202 L
.96404 .41202 L
.96503 .41201 L
.96603 .41201 L
.96703 .41202 L
.96803 .41202 L
.96903 .41202 L
.97003 .41202 L
.97103 .41201 L
.97203 .41201 L
.97303 .41201 L
.97403 .41201 L
.97502 .41201 L
.97602 .41201 L
.97702 .41201 L
.97802 .41201 L
.97902 .41201 L
.98002 .41201 L
.98102 .41201 L
.98202 .41201 L
.98302 .41201 L
.98402 .41201 L
.98501 .41201 L
.98601 .41201 L
.98701 .41201 L
.98801 .41201 L
.98901 .41201 L
.99001 .41201 L
.99101 .41201 L
.99201 .41201 L
.99301 .41201 L
.99401 .41201 L
.995 .41201 L
.996 .41201 L
.997 .41201 L
.998 .41201 L
Mistroke
.999 .41201 L
Mfstroke
0 .98 .604 r
gsave
.999 .01405 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
0 .37247 m
.001 .37247 L
.002 .37247 L
.003 .37247 L
.004 .37247 L
.005 .37247 L
.00599 .37247 L
.00699 .37247 L
.00799 .37247 L
.00899 .37247 L
.00999 .37247 L
.01099 .37247 L
.01199 .37247 L
.01299 .37247 L
.01399 .37247 L
.01499 .37247 L
.01598 .37247 L
.01698 .37247 L
.01798 .37247 L
.01898 .37247 L
.01998 .37247 L
.02098 .37247 L
.02198 .37247 L
.02298 .37247 L
.02398 .37247 L
.02498 .37247 L
.02597 .37247 L
.02697 .37247 L
.02797 .37247 L
.02897 .37247 L
.02997 .37247 L
.03097 .37247 L
.03197 .37247 L
.03297 .37247 L
.03397 .37247 L
.03497 .37247 L
.03596 .37247 L
.03696 .37247 L
.03796 .37247 L
.03896 .37247 L
.03996 .37247 L
.04096 .37247 L
.04196 .37247 L
.04296 .37247 L
.04396 .37247 L
.04496 .37247 L
.04595 .37247 L
.04695 .37247 L
.04795 .37247 L
.04895 .37247 L
Mistroke
.04995 .40016 L
.05095 .40016 L
.05195 .40016 L
.05295 .40016 L
.05395 .40016 L
.05495 .40016 L
.05594 .40016 L
.05694 .40016 L
.05794 .40016 L
.05894 .40016 L
.05994 .40016 L
.06094 .40016 L
.06194 .40016 L
.06294 .40016 L
.06394 .40016 L
.06494 .40016 L
.06593 .40016 L
.06693 .40016 L
.06793 .40016 L
.06893 .40016 L
.06993 .40016 L
.07093 .40016 L
.07193 .40016 L
.07293 .40016 L
.07393 .40016 L
.07493 .40016 L
.07592 .40016 L
.07692 .40016 L
.07792 .40016 L
.07892 .40016 L
.07992 .40016 L
.08092 .40016 L
.08192 .40016 L
.08292 .40016 L
.08392 .40016 L
.08492 .40016 L
.08591 .40016 L
.08691 .40016 L
.08791 .40016 L
.08891 .40016 L
.08991 .40016 L
.09091 .40016 L
.09191 .40016 L
.09291 .40016 L
.09391 .40016 L
.09491 .40016 L
.0959 .40016 L
.0969 .40016 L
.0979 .40016 L
.0989 .40016 L
Mistroke
.0999 .23117 L
.1009 .23117 L
.1019 .23117 L
.1029 .23117 L
.1039 .23117 L
.1049 .23117 L
.10589 .23117 L
.10689 .23117 L
.10789 .23117 L
.10889 .23117 L
.10989 .23117 L
.11089 .23117 L
.11189 .23117 L
.11289 .23117 L
.11389 .23117 L
.11489 .23117 L
.11588 .23117 L
.11688 .23117 L
.11788 .23117 L
.11888 .23117 L
.11988 .23117 L
.12088 .23117 L
.12188 .23117 L
.12288 .23117 L
.12388 .23117 L
.12488 .23117 L
.12587 .23117 L
.12687 .23117 L
.12787 .23117 L
.12887 .23117 L
.12987 .23117 L
.13087 .23117 L
.13187 .23117 L
.13287 .23117 L
.13387 .23117 L
.13487 .23117 L
.13586 .23117 L
.13686 .23117 L
.13786 .23117 L
.13886 .23117 L
.13986 .23117 L
.14086 .23117 L
.14186 .23117 L
.14286 .23117 L
.14386 .23117 L
.14486 .23117 L
.14585 .23117 L
.14685 .23117 L
.14785 .23117 L
.14885 .23117 L
Mistroke
.14985 .29654 L
.15085 .29654 L
.15185 .29654 L
.15285 .29654 L
.15385 .29654 L
.15485 .29654 L
.15584 .29654 L
.15684 .29654 L
.15784 .29654 L
.15884 .29654 L
.15984 .29654 L
.16084 .29654 L
.16184 .29654 L
.16284 .29654 L
.16384 .29654 L
.16484 .29654 L
.16583 .29654 L
.16683 .29654 L
.16783 .29654 L
.16883 .29654 L
.16983 .29654 L
.17083 .29654 L
.17183 .29654 L
.17283 .29654 L
.17383 .29654 L
.17483 .29654 L
.17582 .29654 L
.17682 .29654 L
.17782 .29654 L
.17882 .29654 L
.17982 .29654 L
.18082 .29654 L
.18182 .29654 L
.18282 .29654 L
.18382 .29654 L
.18482 .29654 L
.18581 .29654 L
.18681 .29654 L
.18781 .29654 L
.18881 .29654 L
.18981 .29654 L
.19081 .29654 L
.19181 .29654 L
.19281 .29654 L
.19381 .29654 L
.19481 .29654 L
.1958 .29654 L
.1968 .29654 L
.1978 .29654 L
.1988 .29654 L
Mistroke
.1998 .25084 L
.2008 .25084 L
.2018 .25084 L
.2028 .25084 L
.2038 .25084 L
.2048 .25084 L
.20579 .25084 L
.20679 .25084 L
.20779 .25084 L
.20879 .25084 L
.20979 .25084 L
.21079 .25084 L
.21179 .25084 L
.21279 .25084 L
.21379 .25084 L
.21479 .25084 L
.21578 .25084 L
.21678 .25084 L
.21778 .25084 L
.21878 .25084 L
.21978 .25084 L
.22078 .25084 L
.22178 .25084 L
.22278 .25084 L
.22378 .25084 L
.22478 .25084 L
.22577 .25084 L
.22677 .25084 L
.22777 .25084 L
.22877 .25084 L
.22977 .25084 L
.23077 .25084 L
.23177 .25084 L
.23277 .25084 L
.23377 .25084 L
.23477 .25084 L
.23576 .25084 L
.23676 .25084 L
.23776 .25084 L
.23876 .25084 L
.23976 .25084 L
.24076 .25084 L
.24176 .25084 L
.24276 .25084 L
.24376 .25084 L
.24476 .25084 L
.24575 .25084 L
.24675 .25084 L
.24775 .25084 L
.24875 .25084 L
Mistroke
.24975 .14201 L
.25075 .14201 L
.25175 .14201 L
.25275 .14201 L
.25375 .14201 L
.25475 .14201 L
.25574 .14201 L
.25674 .14201 L
.25774 .14201 L
.25874 .14201 L
.25974 .14201 L
.26074 .14201 L
.26174 .14201 L
.26274 .14201 L
.26374 .14201 L
.26474 .14201 L
.26573 .14201 L
.26673 .14201 L
.26773 .14201 L
.26873 .14201 L
.26973 .14201 L
.27073 .14201 L
.27173 .14201 L
.27273 .14201 L
.27373 .14201 L
.27473 .14201 L
.27572 .14201 L
.27672 .14201 L
.27772 .14201 L
.27872 .14201 L
.27972 .14201 L
.28072 .14201 L
.28172 .14201 L
.28272 .14201 L
.28372 .14201 L
.28472 .14201 L
.28571 .14201 L
.28671 .14201 L
.28771 .14201 L
.28871 .14201 L
.28971 .14201 L
.29071 .14201 L
.29171 .14201 L
.29271 .14201 L
.29371 .14201 L
.29471 .14201 L
.2957 .14201 L
.2967 .14201 L
.2977 .14201 L
.2987 .14201 L
Mistroke
.2997 .14388 L
.3007 .14388 L
.3017 .14388 L
.3027 .14388 L
.3037 .14388 L
.3047 .14388 L
.30569 .14388 L
.30669 .14388 L
.30769 .14388 L
.30869 .14388 L
.30969 .14388 L
.31069 .14388 L
.31169 .14388 L
.31269 .14388 L
.31369 .14388 L
.31469 .14388 L
.31568 .14388 L
.31668 .14388 L
.31768 .14388 L
.31868 .14388 L
.31968 .14388 L
.32068 .14388 L
.32168 .14388 L
.32268 .14388 L
.32368 .14388 L
.32468 .14388 L
.32567 .14388 L
.32667 .14388 L
.32767 .14388 L
.32867 .14388 L
.32967 .14388 L
.33067 .14388 L
.33167 .14388 L
.33267 .14388 L
.33367 .14388 L
.33467 .14388 L
.33566 .14388 L
.33666 .14388 L
.33766 .14388 L
.33866 .14388 L
.33966 .14388 L
.34066 .14388 L
.34166 .14388 L
.34266 .14388 L
.34366 .14388 L
.34466 .14388 L
.34565 .14388 L
.34665 .14388 L
.34765 .14388 L
.34865 .14388 L
Mistroke
.34965 .14869 L
.35065 .14869 L
.35165 .14869 L
.35265 .14869 L
.35365 .14869 L
.35465 .14869 L
.35564 .14869 L
.35664 .14869 L
.35764 .14869 L
.35864 .14869 L
.35964 .14869 L
.36064 .14869 L
.36164 .14869 L
.36264 .14869 L
.36364 .14869 L
.36464 .14869 L
.36563 .14869 L
.36663 .14869 L
.36763 .14869 L
.36863 .14869 L
.36963 .14869 L
.37063 .14869 L
.37163 .14869 L
.37263 .14869 L
.37363 .14869 L
.37463 .14869 L
.37562 .14869 L
.37662 .14869 L
.37762 .14869 L
.37862 .14869 L
.37962 .14869 L
.38062 .14869 L
.38162 .14869 L
.38262 .14869 L
.38362 .14869 L
.38462 .14869 L
.38561 .14869 L
.38661 .14869 L
.38761 .14869 L
.38861 .14869 L
.38961 .14869 L
.39061 .14869 L
.39161 .14869 L
.39261 .14869 L
.39361 .14869 L
.39461 .14869 L
.3956 .14869 L
.3966 .14869 L
.3976 .14869 L
.3986 .14869 L
Mistroke
.3996 .14316 L
.4006 .14316 L
.4016 .14316 L
.4026 .14316 L
.4036 .14316 L
.4046 .14316 L
.40559 .14316 L
.40659 .14316 L
.40759 .14316 L
.40859 .14316 L
.40959 .14316 L
.41059 .14316 L
.41159 .14316 L
.41259 .14316 L
.41359 .14316 L
.41459 .14316 L
.41558 .14316 L
.41658 .14316 L
.41758 .14316 L
.41858 .14316 L
.41958 .14316 L
.42058 .14316 L
.42158 .14316 L
.42258 .14316 L
.42358 .14316 L
.42458 .14316 L
.42557 .14316 L
.42657 .14316 L
.42757 .14316 L
.42857 .14316 L
.42957 .14316 L
.43057 .14316 L
.43157 .14316 L
.43257 .14316 L
.43357 .14316 L
.43457 .14316 L
.43556 .14316 L
.43656 .14316 L
.43756 .14316 L
.43856 .14316 L
.43956 .14316 L
.44056 .14316 L
.44156 .14316 L
.44256 .14316 L
.44356 .14316 L
.44456 .14316 L
.44555 .14316 L
.44655 .14316 L
.44755 .14316 L
.44855 .14316 L
Mistroke
.44955 .13239 L
.45055 .13239 L
.45155 .13239 L
.45255 .13239 L
.45355 .13239 L
.45455 .13239 L
.45554 .13239 L
.45654 .13239 L
.45754 .13239 L
.45854 .13239 L
.45954 .13239 L
.46054 .13239 L
.46154 .13239 L
.46254 .13239 L
.46354 .13239 L
.46454 .13239 L
.46553 .13239 L
.46653 .13239 L
.46753 .13239 L
.46853 .13239 L
.46953 .13239 L
.47053 .13239 L
.47153 .13239 L
.47253 .13239 L
.47353 .13239 L
.47453 .13239 L
.47552 .13239 L
.47652 .13239 L
.47752 .13239 L
.47852 .13239 L
.47952 .13239 L
.48052 .13239 L
.48152 .13239 L
.48252 .13239 L
.48352 .13239 L
.48452 .13239 L
.48551 .13239 L
.48651 .13239 L
.48751 .13239 L
.48851 .13239 L
.48951 .13239 L
.49051 .13239 L
.49151 .13239 L
.49251 .13239 L
.49351 .13239 L
.49451 .13239 L
.4955 .13239 L
.4965 .13239 L
.4975 .13239 L
.4985 .13239 L
Mistroke
.4995 .16616 L
.5005 .16616 L
.5015 .16616 L
.5025 .16616 L
.5035 .16616 L
.5045 .16616 L
.50549 .16616 L
.50649 .16616 L
.50749 .16616 L
.50849 .16616 L
.50949 .16616 L
.51049 .16616 L
.51149 .16616 L
.51249 .16616 L
.51349 .16616 L
.51449 .16616 L
.51548 .16616 L
.51648 .16616 L
.51748 .16616 L
.51848 .16616 L
.51948 .16616 L
.52048 .16616 L
.52148 .16616 L
.52248 .16616 L
.52348 .16616 L
.52448 .16616 L
.52547 .16616 L
.52647 .16616 L
.52747 .16616 L
.52847 .16616 L
.52947 .16616 L
.53047 .16616 L
.53147 .16616 L
.53247 .16616 L
.53347 .16616 L
.53447 .16616 L
.53546 .16616 L
.53646 .16616 L
.53746 .16616 L
.53846 .16616 L
.53946 .16616 L
.54046 .16616 L
.54146 .16616 L
.54246 .16616 L
.54346 .16616 L
.54446 .16616 L
.54545 .16616 L
.54645 .16616 L
.54745 .16616 L
.54845 .16616 L
Mistroke
.54945 .15421 L
.55045 .15421 L
.55145 .15421 L
.55245 .15421 L
.55345 .15421 L
.55445 .15421 L
.55544 .15421 L
.55644 .15421 L
.55744 .15421 L
.55844 .15421 L
.55944 .15421 L
.56044 .15421 L
.56144 .15421 L
.56244 .15421 L
.56344 .15421 L
.56444 .15421 L
.56543 .15421 L
.56643 .15421 L
.56743 .15421 L
.56843 .15421 L
.56943 .15421 L
.57043 .15421 L
.57143 .15421 L
.57243 .15421 L
.57343 .15421 L
.57443 .15421 L
.57542 .15421 L
.57642 .15421 L
.57742 .15421 L
.57842 .15421 L
.57942 .15421 L
.58042 .15421 L
.58142 .15421 L
.58242 .15421 L
.58342 .15421 L
.58442 .15421 L
.58541 .15421 L
.58641 .15421 L
.58741 .15421 L
.58841 .15421 L
.58941 .15421 L
.59041 .15421 L
.59141 .15421 L
.59241 .15421 L
.59341 .15421 L
.59441 .15421 L
.5954 .15421 L
.5964 .15421 L
.5974 .15421 L
.5984 .15421 L
Mistroke
.5994 .11416 L
.6004 .11416 L
.6014 .11416 L
.6024 .11416 L
.6034 .11416 L
.6044 .11416 L
.60539 .11416 L
.60639 .11416 L
.60739 .11416 L
.60839 .11416 L
.60939 .11416 L
.61039 .11416 L
.61139 .11416 L
.61239 .11416 L
.61339 .11416 L
.61439 .11416 L
.61538 .11416 L
.61638 .11416 L
.61738 .11416 L
.61838 .11416 L
.61938 .11416 L
.62038 .11416 L
.62138 .11416 L
.62238 .11416 L
.62338 .11416 L
.62438 .11416 L
.62537 .11416 L
.62637 .11416 L
.62737 .11416 L
.62837 .11416 L
.62937 .11416 L
.63037 .11416 L
.63137 .11416 L
.63237 .11416 L
.63337 .11416 L
.63437 .11416 L
.63536 .11416 L
.63636 .11416 L
.63736 .11416 L
.63836 .11416 L
.63936 .11416 L
.64036 .11416 L
.64136 .11416 L
.64236 .11416 L
.64336 .11416 L
.64436 .11416 L
.64535 .11416 L
.64635 .11416 L
.64735 .11416 L
.64835 .11416 L
Mistroke
.64935 .11128 L
.65035 .11128 L
.65135 .11128 L
.65235 .11128 L
.65335 .11128 L
.65435 .11128 L
.65534 .11128 L
.65634 .11128 L
.65734 .11128 L
.65834 .11128 L
.65934 .11128 L
.66034 .11128 L
.66134 .11128 L
.66234 .11128 L
.66334 .11128 L
.66434 .11128 L
.66533 .11128 L
.66633 .11128 L
.66733 .11128 L
.66833 .11128 L
.66933 .11128 L
.67033 .11128 L
.67133 .11128 L
.67233 .11128 L
.67333 .11128 L
.67433 .11128 L
.67532 .11128 L
.67632 .11128 L
.67732 .11128 L
.67832 .11128 L
.67932 .11128 L
.68032 .11128 L
.68132 .11128 L
.68232 .11128 L
.68332 .11128 L
.68432 .11128 L
.68531 .11128 L
.68631 .11128 L
.68731 .11128 L
.68831 .11128 L
.68931 .11128 L
.69031 .11128 L
.69131 .11128 L
.69231 .11128 L
.69331 .11128 L
.69431 .11128 L
.6953 .11128 L
.6963 .11128 L
.6973 .11128 L
.6983 .11128 L
Mistroke
.6993 .11384 L
.7003 .11384 L
.7013 .11384 L
.7023 .11384 L
.7033 .11384 L
.7043 .11384 L
.70529 .11384 L
.70629 .11384 L
.70729 .11384 L
.70829 .11384 L
.70929 .11384 L
.71029 .11384 L
.71129 .11384 L
.71229 .11384 L
.71329 .11384 L
.71429 .11384 L
.71528 .11384 L
.71628 .11384 L
.71728 .11384 L
.71828 .11384 L
.71928 .11384 L
.72028 .11384 L
.72128 .11384 L
.72228 .11384 L
.72328 .11384 L
.72428 .11384 L
.72527 .11384 L
.72627 .11384 L
.72727 .11384 L
.72827 .11384 L
.72927 .11384 L
.73027 .11384 L
.73127 .11384 L
.73227 .11384 L
.73327 .11384 L
.73427 .11384 L
.73526 .11384 L
.73626 .11384 L
.73726 .11384 L
.73826 .11384 L
.73926 .11384 L
.74026 .11384 L
.74126 .11384 L
.74226 .11384 L
.74326 .11384 L
.74426 .11384 L
.74525 .11384 L
.74625 .11384 L
.74725 .11384 L
.74825 .11384 L
Mistroke
.74925 .10433 L
.75025 .10433 L
.75125 .10433 L
.75225 .10433 L
.75325 .10433 L
.75425 .10433 L
.75524 .10433 L
.75624 .10433 L
.75724 .10433 L
.75824 .10433 L
.75924 .10433 L
.76024 .10433 L
.76124 .10433 L
.76224 .10433 L
.76324 .10433 L
.76424 .10433 L
.76523 .10433 L
.76623 .10433 L
.76723 .10433 L
.76823 .10433 L
.76923 .10433 L
.77023 .10433 L
.77123 .10433 L
.77223 .10433 L
.77323 .10433 L
.77423 .10433 L
.77522 .10433 L
.77622 .10433 L
.77722 .10433 L
.77822 .10433 L
.77922 .10433 L
.78022 .10433 L
.78122 .10433 L
.78222 .10433 L
.78322 .10433 L
.78422 .10433 L
.78521 .10433 L
.78621 .10433 L
.78721 .10433 L
.78821 .10433 L
.78921 .10433 L
.79021 .10433 L
.79121 .10433 L
.79221 .10433 L
.79321 .10433 L
.79421 .10433 L
.7952 .10433 L
.7962 .10433 L
.7972 .10433 L
.7982 .10433 L
Mistroke
.7992 .02765 L
.8002 .02765 L
.8012 .02765 L
.8022 .02765 L
.8032 .02765 L
.8042 .02765 L
.80519 .02765 L
.80619 .02765 L
.80719 .02765 L
.80819 .02765 L
.80919 .02765 L
.81019 .02765 L
.81119 .02765 L
.81219 .02765 L
.81319 .02765 L
.81419 .02765 L
.81518 .02765 L
.81618 .02765 L
.81718 .02765 L
.81818 .02765 L
.81918 .02765 L
.82018 .02765 L
.82118 .02765 L
.82218 .02765 L
.82318 .02765 L
.82418 .02765 L
.82517 .02765 L
.82617 .02765 L
.82717 .02765 L
.82817 .02765 L
.82917 .02765 L
.83017 .02765 L
.83117 .02765 L
.83217 .02765 L
.83317 .02765 L
.83417 .02765 L
.83516 .02765 L
.83616 .02765 L
.83716 .02765 L
.83816 .02765 L
.83916 .02765 L
.84016 .02765 L
.84116 .02765 L
.84216 .02765 L
.84316 .02765 L
.84416 .02765 L
.84515 .02765 L
.84615 .02765 L
.84715 .02765 L
.84815 .02765 L
Mistroke
.84915 .03664 L
.85015 .03664 L
.85115 .03664 L
.85215 .03664 L
.85315 .03664 L
.85415 .03664 L
.85514 .03664 L
.85614 .03664 L
.85714 .03664 L
.85814 .03664 L
.85914 .03664 L
.86014 .03664 L
.86114 .03664 L
.86214 .03664 L
.86314 .03664 L
.86414 .03664 L
.86513 .03664 L
.86613 .03664 L
.86713 .03664 L
.86813 .03664 L
.86913 .03664 L
.87013 .03664 L
.87113 .03664 L
.87213 .03664 L
.87313 .03664 L
.87413 .03664 L
.87512 .03664 L
.87612 .03664 L
.87712 .03664 L
.87812 .03664 L
.87912 .03664 L
.88012 .03664 L
.88112 .03664 L
.88212 .03664 L
.88312 .03664 L
.88412 .03664 L
.88511 .03664 L
.88611 .03664 L
.88711 .03664 L
.88811 .03664 L
.88911 .03664 L
.89011 .03664 L
.89111 .03664 L
.89211 .03664 L
.89311 .03664 L
.89411 .03664 L
.8951 .03664 L
.8961 .03664 L
.8971 .03664 L
.8981 .03664 L
Mistroke
.8991 .03675 L
.9001 .03675 L
.9011 .03675 L
.9021 .03675 L
.9031 .03675 L
.9041 .03675 L
.90509 .03675 L
.90609 .03675 L
.90709 .03675 L
.90809 .03675 L
.90909 .03675 L
.91009 .03675 L
.91109 .03675 L
.91209 .03675 L
.91309 .03675 L
.91409 .03675 L
.91508 .03675 L
.91608 .03675 L
.91708 .03675 L
.91808 .03675 L
.91908 .03675 L
.92008 .03675 L
.92108 .03675 L
.92208 .03675 L
.92308 .03675 L
.92408 .03675 L
.92507 .03675 L
.92607 .03675 L
.92707 .03675 L
.92807 .03675 L
.92907 .03675 L
.93007 .03675 L
.93107 .03675 L
.93207 .03675 L
.93307 .03675 L
.93407 .03675 L
.93506 .03675 L
.93606 .03675 L
.93706 .03675 L
.93806 .03675 L
.93906 .03675 L
.94006 .03675 L
.94106 .03675 L
.94206 .03675 L
.94306 .03675 L
.94406 .03675 L
.94505 .03675 L
.94605 .03675 L
.94705 .03675 L
.94805 .03675 L
Mistroke
.94905 .0132 L
.95005 .0132 L
.95105 .0132 L
.95205 .0132 L
.95305 .0132 L
.95405 .0132 L
.95504 .0132 L
.95604 .0132 L
.95704 .0132 L
.95804 .0132 L
.95904 .0132 L
.96004 .0132 L
.96104 .0132 L
.96204 .0132 L
.96304 .0132 L
.96404 .0132 L
.96503 .0132 L
.96603 .0132 L
.96703 .0132 L
.96803 .0132 L
.96903 .0132 L
.97003 .0132 L
.97103 .0132 L
.97203 .0132 L
.97303 .0132 L
.97403 .0132 L
.97502 .0132 L
.97602 .0132 L
.97702 .0132 L
.97802 .0132 L
.97902 .0132 L
.98002 .0132 L
.98102 .0132 L
.98202 .0132 L
.98302 .0132 L
.98402 .0132 L
.98501 .0132 L
.98601 .0132 L
.98701 .0132 L
.98801 .0132 L
.98901 .0132 L
.99001 .0132 L
.99101 .0132 L
.99201 .0132 L
.99301 .0132 L
.99401 .0132 L
.995 .0132 L
.996 .0132 L
.997 .0132 L
.998 .0132 L
Mistroke
.999 .01405 L
Mfstroke
gsave
.999 .07559 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .53398 m
.001 .53398 L
.002 .53398 L
.003 .53398 L
.004 .53398 L
.005 .53398 L
.00599 .53398 L
.00699 .53398 L
.00799 .53398 L
.00899 .53398 L
.00999 .53398 L
.01099 .53398 L
.01199 .53398 L
.01299 .53398 L
.01399 .53398 L
.01499 .53398 L
.01598 .53398 L
.01698 .53398 L
.01798 .53398 L
.01898 .53398 L
.01998 .53398 L
.02098 .53398 L
.02198 .53398 L
.02298 .53398 L
.02398 .53398 L
.02498 .53398 L
.02597 .53398 L
.02697 .53398 L
.02797 .53398 L
.02897 .53398 L
.02997 .53398 L
.03097 .53398 L
.03197 .53398 L
.03297 .53398 L
.03397 .53398 L
.03497 .53398 L
.03596 .53398 L
.03696 .53398 L
.03796 .53398 L
.03896 .53398 L
.03996 .53398 L
.04096 .53398 L
.04196 .53398 L
.04296 .53398 L
.04396 .53398 L
.04496 .53398 L
.04595 .53398 L
.04695 .53398 L
.04795 .53398 L
.04895 .53398 L
Mistroke
.04995 .56144 L
.05095 .56144 L
.05195 .56144 L
.05295 .56144 L
.05395 .56144 L
.05495 .56144 L
.05594 .56144 L
.05694 .56144 L
.05794 .56144 L
.05894 .56144 L
.05994 .56144 L
.06094 .56144 L
.06194 .56144 L
.06294 .56144 L
.06394 .56144 L
.06494 .56144 L
.06593 .56144 L
.06693 .56144 L
.06793 .56144 L
.06893 .56144 L
.06993 .56144 L
.07093 .56144 L
.07193 .56144 L
.07293 .56144 L
.07393 .56144 L
.07493 .56144 L
.07592 .56144 L
.07692 .56144 L
.07792 .56144 L
.07892 .56144 L
.07992 .56144 L
.08092 .56144 L
.08192 .56144 L
.08292 .56144 L
.08392 .56144 L
.08492 .56144 L
.08591 .56144 L
.08691 .56144 L
.08791 .56144 L
.08891 .56144 L
.08991 .56144 L
.09091 .56144 L
.09191 .56144 L
.09291 .56144 L
.09391 .56144 L
.09491 .56144 L
.0959 .56144 L
.0969 .56144 L
.0979 .56144 L
.0989 .56144 L
Mistroke
.0999 .38358 L
.1009 .38358 L
.1019 .38358 L
.1029 .38358 L
.1039 .38358 L
.1049 .38358 L
.10589 .38358 L
.10689 .38358 L
.10789 .38358 L
.10889 .38358 L
.10989 .38358 L
.11089 .38358 L
.11189 .38358 L
.11289 .38358 L
.11389 .38358 L
.11489 .38358 L
.11588 .38358 L
.11688 .38358 L
.11788 .38358 L
.11888 .38358 L
.11988 .38358 L
.12088 .38358 L
.12188 .38358 L
.12288 .38358 L
.12388 .38358 L
.12488 .38358 L
.12587 .38358 L
.12687 .38358 L
.12787 .38358 L
.12887 .38358 L
.12987 .38358 L
.13087 .38358 L
.13187 .38358 L
.13287 .38358 L
.13387 .38358 L
.13487 .38358 L
.13586 .38358 L
.13686 .38358 L
.13786 .38358 L
.13886 .38358 L
.13986 .38358 L
.14086 .38358 L
.14186 .38358 L
.14286 .38358 L
.14386 .38358 L
.14486 .38358 L
.14585 .38358 L
.14685 .38358 L
.14785 .38358 L
.14885 .38358 L
Mistroke
.14985 .44735 L
.15085 .44735 L
.15185 .44735 L
.15285 .44735 L
.15385 .44735 L
.15485 .44735 L
.15584 .44735 L
.15684 .44735 L
.15784 .44735 L
.15884 .44735 L
.15984 .44735 L
.16084 .44735 L
.16184 .44735 L
.16284 .44735 L
.16384 .44735 L
.16484 .44735 L
.16583 .44735 L
.16683 .44735 L
.16783 .44735 L
.16883 .44735 L
.16983 .44735 L
.17083 .44735 L
.17183 .44735 L
.17283 .44735 L
.17383 .44735 L
.17483 .44735 L
.17582 .44735 L
.17682 .44735 L
.17782 .44735 L
.17882 .44735 L
.17982 .44735 L
.18082 .44735 L
.18182 .44735 L
.18282 .44735 L
.18382 .44735 L
.18482 .44735 L
.18581 .44735 L
.18681 .44735 L
.18781 .44735 L
.18881 .44735 L
.18981 .44735 L
.19081 .44735 L
.19181 .44735 L
.19281 .44735 L
.19381 .44735 L
.19481 .44735 L
.1958 .44735 L
.1968 .44735 L
.1978 .44735 L
.1988 .44735 L
Mistroke
.1998 .37218 L
.2008 .37218 L
.2018 .37218 L
.2028 .37218 L
.2038 .37218 L
.2048 .37218 L
.20579 .37218 L
.20679 .37218 L
.20779 .37218 L
.20879 .37218 L
.20979 .37218 L
.21079 .37218 L
.21179 .37218 L
.21279 .37218 L
.21379 .37218 L
.21479 .37218 L
.21578 .37218 L
.21678 .37218 L
.21778 .37218 L
.21878 .37218 L
.21978 .37218 L
.22078 .37218 L
.22178 .37218 L
.22278 .37218 L
.22378 .37218 L
.22478 .37218 L
.22577 .37218 L
.22677 .37218 L
.22777 .37218 L
.22877 .37218 L
.22977 .37218 L
.23077 .37218 L
.23177 .37218 L
.23277 .37218 L
.23377 .37218 L
.23477 .37218 L
.23576 .37218 L
.23676 .37218 L
.23776 .37218 L
.23876 .37218 L
.23976 .37218 L
.24076 .37218 L
.24176 .37218 L
.24276 .37218 L
.24376 .37218 L
.24476 .37218 L
.24575 .37218 L
.24675 .37218 L
.24775 .37218 L
.24875 .37218 L
Mistroke
.24975 .24745 L
.25075 .24745 L
.25175 .24745 L
.25275 .24745 L
.25375 .24745 L
.25475 .24745 L
.25574 .24745 L
.25674 .24745 L
.25774 .24745 L
.25874 .24745 L
.25974 .24745 L
.26074 .24745 L
.26174 .24745 L
.26274 .24745 L
.26374 .24745 L
.26474 .24745 L
.26573 .24745 L
.26673 .24745 L
.26773 .24745 L
.26873 .24745 L
.26973 .24745 L
.27073 .24745 L
.27173 .24745 L
.27273 .24745 L
.27373 .24745 L
.27473 .24745 L
.27572 .24745 L
.27672 .24745 L
.27772 .24745 L
.27872 .24745 L
.27972 .24745 L
.28072 .24745 L
.28172 .24745 L
.28272 .24745 L
.28372 .24745 L
.28472 .24745 L
.28571 .24745 L
.28671 .24745 L
.28771 .24745 L
.28871 .24745 L
.28971 .24745 L
.29071 .24745 L
.29171 .24745 L
.29271 .24745 L
.29371 .24745 L
.29471 .24745 L
.2957 .24745 L
.2967 .24745 L
.2977 .24745 L
.2987 .24745 L
Mistroke
.2997 .2475 L
.3007 .2475 L
.3017 .2475 L
.3027 .2475 L
.3037 .2475 L
.3047 .2475 L
.30569 .2475 L
.30669 .2475 L
.30769 .2475 L
.30869 .2475 L
.30969 .2475 L
.31069 .2475 L
.31169 .2475 L
.31269 .2475 L
.31369 .2475 L
.31469 .2475 L
.31568 .2475 L
.31668 .2475 L
.31768 .2475 L
.31868 .2475 L
.31968 .2475 L
.32068 .2475 L
.32168 .2475 L
.32268 .2475 L
.32368 .2475 L
.32468 .2475 L
.32567 .2475 L
.32667 .2475 L
.32767 .2475 L
.32867 .2475 L
.32967 .2475 L
.33067 .2475 L
.33167 .2475 L
.33267 .2475 L
.33367 .2475 L
.33467 .2475 L
.33566 .2475 L
.33666 .2475 L
.33766 .2475 L
.33866 .2475 L
.33966 .2475 L
.34066 .2475 L
.34166 .2475 L
.34266 .2475 L
.34366 .2475 L
.34466 .2475 L
.34565 .2475 L
.34665 .2475 L
.34765 .2475 L
.34865 .2475 L
Mistroke
.34965 .25216 L
.35065 .25216 L
.35165 .25216 L
.35265 .25216 L
.35365 .25216 L
.35465 .25216 L
.35564 .25216 L
.35664 .25216 L
.35764 .25216 L
.35864 .25216 L
.35964 .25216 L
.36064 .25216 L
.36164 .25216 L
.36264 .25216 L
.36364 .25216 L
.36464 .25216 L
.36563 .25216 L
.36663 .25216 L
.36763 .25216 L
.36863 .25216 L
.36963 .25216 L
.37063 .25216 L
.37163 .25216 L
.37263 .25216 L
.37363 .25216 L
.37463 .25216 L
.37562 .25216 L
.37662 .25216 L
.37762 .25216 L
.37862 .25216 L
.37962 .25216 L
.38062 .25216 L
.38162 .25216 L
.38262 .25216 L
.38362 .25216 L
.38462 .25216 L
.38561 .25216 L
.38661 .25216 L
.38761 .25216 L
.38861 .25216 L
.38961 .25216 L
.39061 .25216 L
.39161 .25216 L
.39261 .25216 L
.39361 .25216 L
.39461 .25216 L
.3956 .25216 L
.3966 .25216 L
.3976 .25216 L
.3986 .25216 L
Mistroke
.3996 .24321 L
.4006 .24321 L
.4016 .24321 L
.4026 .24321 L
.4036 .24321 L
.4046 .24321 L
.40559 .24321 L
.40659 .24321 L
.40759 .24321 L
.40859 .24321 L
.40959 .24321 L
.41059 .24321 L
.41159 .24321 L
.41259 .24321 L
.41359 .24321 L
.41459 .24321 L
.41558 .24321 L
.41658 .24321 L
.41758 .24321 L
.41858 .24321 L
.41958 .24321 L
.42058 .24321 L
.42158 .24321 L
.42258 .24321 L
.42358 .24321 L
.42458 .24321 L
.42557 .24321 L
.42657 .24321 L
.42757 .24321 L
.42857 .24321 L
.42957 .24321 L
.43057 .24321 L
.43157 .24321 L
.43257 .24321 L
.43357 .24321 L
.43457 .24321 L
.43556 .24321 L
.43656 .24321 L
.43756 .24321 L
.43856 .24321 L
.43956 .24321 L
.44056 .24321 L
.44156 .24321 L
.44256 .24321 L
.44356 .24321 L
.44456 .24321 L
.44555 .24321 L
.44655 .24321 L
.44755 .24321 L
.44855 .24321 L
Mistroke
.44955 .23213 L
.45055 .23213 L
.45155 .23213 L
.45255 .23213 L
.45355 .23213 L
.45455 .23213 L
.45554 .23213 L
.45654 .23213 L
.45754 .23213 L
.45854 .23213 L
.45954 .23213 L
.46054 .23213 L
.46154 .23213 L
.46254 .23213 L
.46354 .23213 L
.46454 .23213 L
.46553 .23213 L
.46653 .23213 L
.46753 .23213 L
.46853 .23213 L
.46953 .23213 L
.47053 .23213 L
.47153 .23213 L
.47253 .23213 L
.47353 .23213 L
.47453 .23213 L
.47552 .23213 L
.47652 .23213 L
.47752 .23213 L
.47852 .23213 L
.47952 .23213 L
.48052 .23213 L
.48152 .23213 L
.48252 .23213 L
.48352 .23213 L
.48452 .23213 L
.48551 .23213 L
.48651 .23213 L
.48751 .23213 L
.48851 .23213 L
.48951 .23213 L
.49051 .23213 L
.49151 .23213 L
.49251 .23213 L
.49351 .23213 L
.49451 .23213 L
.4955 .23213 L
.4965 .23213 L
.4975 .23213 L
.4985 .23213 L
Mistroke
.4995 .26017 L
.5005 .26017 L
.5015 .26017 L
.5025 .26017 L
.5035 .26017 L
.5045 .26017 L
.50549 .26017 L
.50649 .26017 L
.50749 .26017 L
.50849 .26017 L
.50949 .26017 L
.51049 .26017 L
.51149 .26017 L
.51249 .26017 L
.51349 .26017 L
.51449 .26017 L
.51548 .26017 L
.51648 .26017 L
.51748 .26017 L
.51848 .26017 L
.51948 .26017 L
.52048 .26017 L
.52148 .26017 L
.52248 .26017 L
.52348 .26017 L
.52448 .26017 L
.52547 .26017 L
.52647 .26017 L
.52747 .26017 L
.52847 .26017 L
.52947 .26017 L
.53047 .26017 L
.53147 .26017 L
.53247 .26017 L
.53347 .26017 L
.53447 .26017 L
.53546 .26017 L
.53646 .26017 L
.53746 .26017 L
.53846 .26017 L
.53946 .26017 L
.54046 .26017 L
.54146 .26017 L
.54246 .26017 L
.54346 .26017 L
.54446 .26017 L
.54545 .26017 L
.54645 .26017 L
.54745 .26017 L
.54845 .26017 L
Mistroke
.54945 .24244 L
.55045 .24244 L
.55145 .24244 L
.55245 .24244 L
.55345 .24244 L
.55445 .24244 L
.55544 .24244 L
.55644 .24244 L
.55744 .24244 L
.55844 .24244 L
.55944 .24244 L
.56044 .24244 L
.56144 .24244 L
.56244 .24244 L
.56344 .24244 L
.56444 .24244 L
.56543 .24244 L
.56643 .24244 L
.56743 .24244 L
.56843 .24244 L
.56943 .24244 L
.57043 .24244 L
.57143 .24244 L
.57243 .24244 L
.57343 .24244 L
.57443 .24244 L
.57542 .24244 L
.57642 .24244 L
.57742 .24244 L
.57842 .24244 L
.57942 .24244 L
.58042 .24244 L
.58142 .24244 L
.58242 .24244 L
.58342 .24244 L
.58442 .24244 L
.58541 .24244 L
.58641 .24244 L
.58741 .24244 L
.58841 .24244 L
.58941 .24244 L
.59041 .24244 L
.59141 .24244 L
.59241 .24244 L
.59341 .24244 L
.59441 .24244 L
.5954 .24244 L
.5964 .24244 L
.5974 .24244 L
.5984 .24244 L
Mistroke
.5994 .19711 L
.6004 .19711 L
.6014 .19711 L
.6024 .19711 L
.6034 .19711 L
.6044 .19711 L
.60539 .19711 L
.60639 .19711 L
.60739 .19711 L
.60839 .19711 L
.60939 .19711 L
.61039 .19711 L
.61139 .19711 L
.61239 .19711 L
.61339 .19711 L
.61439 .19711 L
.61538 .19711 L
.61638 .19711 L
.61738 .19711 L
.61838 .19711 L
.61938 .19711 L
.62038 .19711 L
.62138 .19711 L
.62238 .19711 L
.62338 .19711 L
.62438 .19711 L
.62537 .19711 L
.62637 .19711 L
.62737 .19711 L
.62837 .19711 L
.62937 .19711 L
.63037 .19711 L
.63137 .19711 L
.63237 .19711 L
.63337 .19711 L
.63437 .19711 L
.63536 .19711 L
.63636 .19711 L
.63736 .19711 L
.63836 .19711 L
.63936 .19711 L
.64036 .19711 L
.64136 .19711 L
.64236 .19711 L
.64336 .19711 L
.64436 .19711 L
.64535 .19711 L
.64635 .19711 L
.64735 .19711 L
.64835 .19711 L
Mistroke
.64935 .19063 L
.65035 .19063 L
.65135 .19063 L
.65235 .19063 L
.65335 .19063 L
.65435 .19063 L
.65534 .19063 L
.65634 .19063 L
.65734 .19063 L
.65834 .19063 L
.65934 .19063 L
.66034 .19063 L
.66134 .19063 L
.66234 .19063 L
.66334 .19063 L
.66434 .19063 L
.66533 .19063 L
.66633 .19063 L
.66733 .19063 L
.66833 .19063 L
.66933 .19063 L
.67033 .19063 L
.67133 .19063 L
.67233 .19063 L
.67333 .19063 L
.67433 .19063 L
.67532 .19063 L
.67632 .19063 L
.67732 .19063 L
.67832 .19063 L
.67932 .19063 L
.68032 .19063 L
.68132 .19063 L
.68232 .19063 L
.68332 .19063 L
.68432 .19063 L
.68531 .19063 L
.68631 .19063 L
.68731 .19063 L
.68831 .19063 L
.68931 .19063 L
.69031 .19063 L
.69131 .19063 L
.69231 .19063 L
.69331 .19063 L
.69431 .19063 L
.6953 .19063 L
.6963 .19063 L
.6973 .19063 L
.6983 .19063 L
Mistroke
.6993 .19297 L
.7003 .19297 L
.7013 .19297 L
.7023 .19297 L
.7033 .19297 L
.7043 .19297 L
.70529 .19297 L
.70629 .19297 L
.70729 .19297 L
.70829 .19297 L
.70929 .19297 L
.71029 .19297 L
.71129 .19297 L
.71229 .19297 L
.71329 .19297 L
.71429 .19297 L
.71528 .19297 L
.71628 .19297 L
.71728 .19297 L
.71828 .19297 L
.71928 .19297 L
.72028 .19297 L
.72128 .19297 L
.72228 .19297 L
.72328 .19297 L
.72428 .19297 L
.72527 .19297 L
.72627 .19297 L
.72727 .19297 L
.72827 .19297 L
.72927 .19297 L
.73027 .19297 L
.73127 .19297 L
.73227 .19297 L
.73327 .19297 L
.73427 .19297 L
.73526 .19297 L
.73626 .19297 L
.73726 .19297 L
.73826 .19297 L
.73926 .19297 L
.74026 .19297 L
.74126 .19297 L
.74226 .19297 L
.74326 .19297 L
.74426 .19297 L
.74525 .19297 L
.74625 .19297 L
.74725 .19297 L
.74825 .19297 L
Mistroke
.74925 .17974 L
.75025 .17974 L
.75125 .17974 L
.75225 .17974 L
.75325 .17974 L
.75425 .17974 L
.75524 .17974 L
.75624 .17974 L
.75724 .17974 L
.75824 .17974 L
.75924 .17974 L
.76024 .17974 L
.76124 .17974 L
.76224 .17974 L
.76324 .17974 L
.76424 .17974 L
.76523 .17974 L
.76623 .17974 L
.76723 .17974 L
.76823 .17974 L
.76923 .17974 L
.77023 .17974 L
.77123 .17974 L
.77223 .17974 L
.77323 .17974 L
.77423 .17974 L
.77522 .17974 L
.77622 .17974 L
.77722 .17974 L
.77822 .17974 L
.77922 .17974 L
.78022 .17974 L
.78122 .17974 L
.78222 .17974 L
.78322 .17974 L
.78422 .17974 L
.78521 .17974 L
.78621 .17974 L
.78721 .17974 L
.78821 .17974 L
.78921 .17974 L
.79021 .17974 L
.79121 .17974 L
.79221 .17974 L
.79321 .17974 L
.79421 .17974 L
.7952 .17974 L
.7962 .17974 L
.7972 .17974 L
.7982 .17974 L
Mistroke
.7992 .09406 L
.8002 .09406 L
.8012 .09406 L
.8022 .09406 L
.8032 .09406 L
.8042 .09406 L
.80519 .09406 L
.80619 .09406 L
.80719 .09406 L
.80819 .09406 L
.80919 .09406 L
.81019 .09406 L
.81119 .09406 L
.81219 .09406 L
.81319 .09406 L
.81419 .09406 L
.81518 .09406 L
.81618 .09406 L
.81718 .09406 L
.81818 .09406 L
.81918 .09406 L
.82018 .09406 L
.82118 .09406 L
.82218 .09406 L
.82318 .09406 L
.82418 .09406 L
.82517 .09406 L
.82617 .09406 L
.82717 .09406 L
.82817 .09406 L
.82917 .09406 L
.83017 .09406 L
.83117 .09406 L
.83217 .09406 L
.83317 .09406 L
.83417 .09406 L
.83516 .09406 L
.83616 .09406 L
.83716 .09406 L
.83816 .09406 L
.83916 .09406 L
.84016 .09406 L
.84116 .09406 L
.84216 .09406 L
.84316 .09406 L
.84416 .09406 L
.84515 .09406 L
.84615 .09406 L
.84715 .09406 L
.84815 .09406 L
Mistroke
.84915 .1012 L
.85015 .1012 L
.85115 .1012 L
.85215 .1012 L
.85315 .1012 L
.85415 .1012 L
.85514 .1012 L
.85614 .1012 L
.85714 .1012 L
.85814 .1012 L
.85914 .1012 L
.86014 .1012 L
.86114 .1012 L
.86214 .1012 L
.86314 .1012 L
.86414 .1012 L
.86513 .1012 L
.86613 .1012 L
.86713 .1012 L
.86813 .1012 L
.86913 .1012 L
.87013 .1012 L
.87113 .1012 L
.87213 .1012 L
.87313 .1012 L
.87413 .1012 L
.87512 .1012 L
.87612 .1012 L
.87712 .1012 L
.87812 .1012 L
.87912 .1012 L
.88012 .1012 L
.88112 .1012 L
.88212 .1012 L
.88312 .1012 L
.88412 .1012 L
.88511 .1012 L
.88611 .1012 L
.88711 .1012 L
.88811 .1012 L
.88911 .1012 L
.89011 .1012 L
.89111 .1012 L
.89211 .1012 L
.89311 .1012 L
.89411 .1012 L
.8951 .1012 L
.8961 .1012 L
.8971 .1012 L
.8981 .1012 L
Mistroke
.8991 .10126 L
.9001 .10126 L
.9011 .10126 L
.9021 .10126 L
.9031 .10126 L
.9041 .10126 L
.90509 .10126 L
.90609 .10126 L
.90709 .10126 L
.90809 .10126 L
.90909 .10126 L
.91009 .10126 L
.91109 .10126 L
.91209 .10126 L
.91309 .10126 L
.91409 .10126 L
.91508 .10126 L
.91608 .10126 L
.91708 .10126 L
.91808 .10126 L
.91908 .10126 L
.92008 .10126 L
.92108 .10126 L
.92208 .10126 L
.92308 .10126 L
.92408 .10126 L
.92507 .10126 L
.92607 .10126 L
.92707 .10126 L
.92807 .10126 L
.92907 .10126 L
.93007 .10126 L
.93107 .10126 L
.93207 .10126 L
.93307 .10126 L
.93407 .10126 L
.93506 .10126 L
.93606 .10126 L
.93706 .10126 L
.93806 .10126 L
.93906 .10126 L
.94006 .10126 L
.94106 .10126 L
.94206 .10126 L
.94306 .10126 L
.94406 .10126 L
.94505 .10126 L
.94605 .10126 L
.94705 .10126 L
.94805 .10126 L
Mistroke
.94905 .07498 L
.95005 .07498 L
.95105 .07498 L
.95205 .07498 L
.95305 .07498 L
.95405 .07498 L
.95504 .07498 L
.95604 .07498 L
.95704 .07498 L
.95804 .07498 L
.95904 .07498 L
.96004 .07498 L
.96104 .07498 L
.96204 .07498 L
.96304 .07498 L
.96404 .07498 L
.96503 .07498 L
.96603 .07498 L
.96703 .07498 L
.96803 .07498 L
.96903 .07498 L
.97003 .07498 L
.97103 .07498 L
.97203 .07498 L
.97303 .07498 L
.97403 .07498 L
.97502 .07498 L
.97602 .07498 L
.97702 .07498 L
.97802 .07498 L
.97902 .07498 L
.98002 .07498 L
.98102 .07498 L
.98202 .07498 L
.98302 .07498 L
.98402 .07498 L
.98501 .07498 L
.98601 .07498 L
.98701 .07498 L
.98801 .07498 L
.98901 .07498 L
.99001 .07498 L
.99101 .07498 L
.99201 .07498 L
.99301 .07498 L
.99401 .07498 L
.995 .07498 L
.996 .07498 L
.997 .07498 L
.998 .07498 L
Mistroke
.999 .07559 L
Mfstroke
1 0 0 r
gsave
.999 .04482 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .45322 m
.001 .45322 L
.002 .45322 L
.003 .45322 L
.004 .45322 L
.005 .45322 L
.00599 .45322 L
.00699 .45322 L
.00799 .45322 L
.00899 .45322 L
.00999 .45322 L
.01099 .45322 L
.01199 .45322 L
.01299 .45322 L
.01399 .45322 L
.01499 .45322 L
.01598 .45322 L
.01698 .45322 L
.01798 .45322 L
.01898 .45322 L
.01998 .45322 L
.02098 .45322 L
.02198 .45322 L
.02298 .45322 L
.02398 .45322 L
.02498 .45322 L
.02597 .45322 L
.02697 .45322 L
.02797 .45322 L
.02897 .45322 L
.02997 .45322 L
.03097 .45322 L
.03197 .45322 L
.03297 .45322 L
.03397 .45322 L
.03497 .45322 L
.03596 .45322 L
.03696 .45322 L
.03796 .45322 L
.03896 .45322 L
.03996 .45322 L
.04096 .45322 L
.04196 .45322 L
.04296 .45322 L
.04396 .45322 L
.04496 .45322 L
.04595 .45322 L
.04695 .45322 L
.04795 .45322 L
.04895 .45322 L
Mistroke
.04995 .4808 L
.05095 .4808 L
.05195 .4808 L
.05295 .4808 L
.05395 .4808 L
.05495 .4808 L
.05594 .4808 L
.05694 .4808 L
.05794 .4808 L
.05894 .4808 L
.05994 .4808 L
.06094 .4808 L
.06194 .4808 L
.06294 .4808 L
.06394 .4808 L
.06494 .4808 L
.06593 .4808 L
.06693 .4808 L
.06793 .4808 L
.06893 .4808 L
.06993 .4808 L
.07093 .4808 L
.07193 .4808 L
.07293 .4808 L
.07393 .4808 L
.07493 .4808 L
.07592 .4808 L
.07692 .4808 L
.07792 .4808 L
.07892 .4808 L
.07992 .4808 L
.08092 .4808 L
.08192 .4808 L
.08292 .4808 L
.08392 .4808 L
.08492 .4808 L
.08591 .4808 L
.08691 .4808 L
.08791 .4808 L
.08891 .4808 L
.08991 .4808 L
.09091 .4808 L
.09191 .4808 L
.09291 .4808 L
.09391 .4808 L
.09491 .4808 L
.0959 .4808 L
.0969 .4808 L
.0979 .4808 L
.0989 .4808 L
Mistroke
.0999 .30737 L
.1009 .30737 L
.1019 .30737 L
.1029 .30737 L
.1039 .30737 L
.1049 .30737 L
.10589 .30737 L
.10689 .30737 L
.10789 .30737 L
.10889 .30737 L
.10989 .30737 L
.11089 .30737 L
.11189 .30737 L
.11289 .30737 L
.11389 .30737 L
.11489 .30737 L
.11588 .30737 L
.11688 .30737 L
.11788 .30737 L
.11888 .30737 L
.11988 .30737 L
.12088 .30737 L
.12188 .30737 L
.12288 .30737 L
.12388 .30737 L
.12488 .30737 L
.12587 .30737 L
.12687 .30737 L
.12787 .30737 L
.12887 .30737 L
.12987 .30737 L
.13087 .30737 L
.13187 .30737 L
.13287 .30737 L
.13387 .30737 L
.13487 .30737 L
.13586 .30737 L
.13686 .30737 L
.13786 .30737 L
.13886 .30737 L
.13986 .30737 L
.14086 .30737 L
.14186 .30737 L
.14286 .30737 L
.14386 .30737 L
.14486 .30737 L
.14585 .30737 L
.14685 .30737 L
.14785 .30737 L
.14885 .30737 L
Mistroke
.14985 .37195 L
.15085 .37195 L
.15185 .37195 L
.15285 .37195 L
.15385 .37195 L
.15485 .37195 L
.15584 .37195 L
.15684 .37195 L
.15784 .37195 L
.15884 .37195 L
.15984 .37195 L
.16084 .37195 L
.16184 .37195 L
.16284 .37195 L
.16384 .37195 L
.16484 .37195 L
.16583 .37195 L
.16683 .37195 L
.16783 .37195 L
.16883 .37195 L
.16983 .37195 L
.17083 .37195 L
.17183 .37195 L
.17283 .37195 L
.17383 .37195 L
.17483 .37195 L
.17582 .37195 L
.17682 .37195 L
.17782 .37195 L
.17882 .37195 L
.17982 .37195 L
.18082 .37195 L
.18182 .37195 L
.18282 .37195 L
.18382 .37195 L
.18482 .37195 L
.18581 .37195 L
.18681 .37195 L
.18781 .37195 L
.18881 .37195 L
.18981 .37195 L
.19081 .37195 L
.19181 .37195 L
.19281 .37195 L
.19381 .37195 L
.19481 .37195 L
.1958 .37195 L
.1968 .37195 L
.1978 .37195 L
.1988 .37195 L
Mistroke
.1998 .31151 L
.2008 .31151 L
.2018 .31151 L
.2028 .31151 L
.2038 .31151 L
.2048 .31151 L
.20579 .31151 L
.20679 .31151 L
.20779 .31151 L
.20879 .31151 L
.20979 .31151 L
.21079 .31151 L
.21179 .31151 L
.21279 .31151 L
.21379 .31151 L
.21479 .31151 L
.21578 .31151 L
.21678 .31151 L
.21778 .31151 L
.21878 .31151 L
.21978 .31151 L
.22078 .31151 L
.22178 .31151 L
.22278 .31151 L
.22378 .31151 L
.22478 .31151 L
.22577 .31151 L
.22677 .31151 L
.22777 .31151 L
.22877 .31151 L
.22977 .31151 L
.23077 .31151 L
.23177 .31151 L
.23277 .31151 L
.23377 .31151 L
.23477 .31151 L
.23576 .31151 L
.23676 .31151 L
.23776 .31151 L
.23876 .31151 L
.23976 .31151 L
.24076 .31151 L
.24176 .31151 L
.24276 .31151 L
.24376 .31151 L
.24476 .31151 L
.24575 .31151 L
.24675 .31151 L
.24775 .31151 L
.24875 .31151 L
Mistroke
.24975 .19473 L
.25075 .19473 L
.25175 .19473 L
.25275 .19473 L
.25375 .19473 L
.25475 .19473 L
.25574 .19473 L
.25674 .19473 L
.25774 .19473 L
.25874 .19473 L
.25974 .19473 L
.26074 .19473 L
.26174 .19473 L
.26274 .19473 L
.26374 .19473 L
.26474 .19473 L
.26573 .19473 L
.26673 .19473 L
.26773 .19473 L
.26873 .19473 L
.26973 .19473 L
.27073 .19473 L
.27173 .19473 L
.27273 .19473 L
.27373 .19473 L
.27473 .19473 L
.27572 .19473 L
.27672 .19473 L
.27772 .19473 L
.27872 .19473 L
.27972 .19473 L
.28072 .19473 L
.28172 .19473 L
.28272 .19473 L
.28372 .19473 L
.28472 .19473 L
.28571 .19473 L
.28671 .19473 L
.28771 .19473 L
.28871 .19473 L
.28971 .19473 L
.29071 .19473 L
.29171 .19473 L
.29271 .19473 L
.29371 .19473 L
.29471 .19473 L
.2957 .19473 L
.2967 .19473 L
.2977 .19473 L
.2987 .19473 L
Mistroke
.2997 .19569 L
.3007 .19569 L
.3017 .19569 L
.3027 .19569 L
.3037 .19569 L
.3047 .19569 L
.30569 .19569 L
.30669 .19569 L
.30769 .19569 L
.30869 .19569 L
.30969 .19569 L
.31069 .19569 L
.31169 .19569 L
.31269 .19569 L
.31369 .19569 L
.31469 .19569 L
.31568 .19569 L
.31668 .19569 L
.31768 .19569 L
.31868 .19569 L
.31968 .19569 L
.32068 .19569 L
.32168 .19569 L
.32268 .19569 L
.32368 .19569 L
.32468 .19569 L
.32567 .19569 L
.32667 .19569 L
.32767 .19569 L
.32867 .19569 L
.32967 .19569 L
.33067 .19569 L
.33167 .19569 L
.33267 .19569 L
.33367 .19569 L
.33467 .19569 L
.33566 .19569 L
.33666 .19569 L
.33766 .19569 L
.33866 .19569 L
.33966 .19569 L
.34066 .19569 L
.34166 .19569 L
.34266 .19569 L
.34366 .19569 L
.34466 .19569 L
.34565 .19569 L
.34665 .19569 L
.34765 .19569 L
.34865 .19569 L
Mistroke
.34965 .20042 L
.35065 .20042 L
.35165 .20042 L
.35265 .20042 L
.35365 .20042 L
.35465 .20042 L
.35564 .20042 L
.35664 .20042 L
.35764 .20042 L
.35864 .20042 L
.35964 .20042 L
.36064 .20042 L
.36164 .20042 L
.36264 .20042 L
.36364 .20042 L
.36464 .20042 L
.36563 .20042 L
.36663 .20042 L
.36763 .20042 L
.36863 .20042 L
.36963 .20042 L
.37063 .20042 L
.37163 .20042 L
.37263 .20042 L
.37363 .20042 L
.37463 .20042 L
.37562 .20042 L
.37662 .20042 L
.37762 .20042 L
.37862 .20042 L
.37962 .20042 L
.38062 .20042 L
.38162 .20042 L
.38262 .20042 L
.38362 .20042 L
.38462 .20042 L
.38561 .20042 L
.38661 .20042 L
.38761 .20042 L
.38861 .20042 L
.38961 .20042 L
.39061 .20042 L
.39161 .20042 L
.39261 .20042 L
.39361 .20042 L
.39461 .20042 L
.3956 .20042 L
.3966 .20042 L
.3976 .20042 L
.3986 .20042 L
Mistroke
.3996 .19318 L
.4006 .19318 L
.4016 .19318 L
.4026 .19318 L
.4036 .19318 L
.4046 .19318 L
.40559 .19318 L
.40659 .19318 L
.40759 .19318 L
.40859 .19318 L
.40959 .19318 L
.41059 .19318 L
.41159 .19318 L
.41259 .19318 L
.41359 .19318 L
.41459 .19318 L
.41558 .19318 L
.41658 .19318 L
.41758 .19318 L
.41858 .19318 L
.41958 .19318 L
.42058 .19318 L
.42158 .19318 L
.42258 .19318 L
.42358 .19318 L
.42458 .19318 L
.42557 .19318 L
.42657 .19318 L
.42757 .19318 L
.42857 .19318 L
.42957 .19318 L
.43057 .19318 L
.43157 .19318 L
.43257 .19318 L
.43357 .19318 L
.43457 .19318 L
.43556 .19318 L
.43656 .19318 L
.43756 .19318 L
.43856 .19318 L
.43956 .19318 L
.44056 .19318 L
.44156 .19318 L
.44256 .19318 L
.44356 .19318 L
.44456 .19318 L
.44555 .19318 L
.44655 .19318 L
.44755 .19318 L
.44855 .19318 L
Mistroke
.44955 .18226 L
.45055 .18226 L
.45155 .18226 L
.45255 .18226 L
.45355 .18226 L
.45455 .18226 L
.45554 .18226 L
.45654 .18226 L
.45754 .18226 L
.45854 .18226 L
.45954 .18226 L
.46054 .18226 L
.46154 .18226 L
.46254 .18226 L
.46354 .18226 L
.46454 .18226 L
.46553 .18226 L
.46653 .18226 L
.46753 .18226 L
.46853 .18226 L
.46953 .18226 L
.47053 .18226 L
.47153 .18226 L
.47253 .18226 L
.47353 .18226 L
.47453 .18226 L
.47552 .18226 L
.47652 .18226 L
.47752 .18226 L
.47852 .18226 L
.47952 .18226 L
.48052 .18226 L
.48152 .18226 L
.48252 .18226 L
.48352 .18226 L
.48452 .18226 L
.48551 .18226 L
.48651 .18226 L
.48751 .18226 L
.48851 .18226 L
.48951 .18226 L
.49051 .18226 L
.49151 .18226 L
.49251 .18226 L
.49351 .18226 L
.49451 .18226 L
.4955 .18226 L
.4965 .18226 L
.4975 .18226 L
.4985 .18226 L
Mistroke
.4995 .21316 L
.5005 .21316 L
.5015 .21316 L
.5025 .21316 L
.5035 .21316 L
.5045 .21316 L
.50549 .21316 L
.50649 .21316 L
.50749 .21316 L
.50849 .21316 L
.50949 .21316 L
.51049 .21316 L
.51149 .21316 L
.51249 .21316 L
.51349 .21316 L
.51449 .21316 L
.51548 .21316 L
.51648 .21316 L
.51748 .21316 L
.51848 .21316 L
.51948 .21316 L
.52048 .21316 L
.52148 .21316 L
.52248 .21316 L
.52348 .21316 L
.52448 .21316 L
.52547 .21316 L
.52647 .21316 L
.52747 .21316 L
.52847 .21316 L
.52947 .21316 L
.53047 .21316 L
.53147 .21316 L
.53247 .21316 L
.53347 .21316 L
.53447 .21316 L
.53546 .21316 L
.53646 .21316 L
.53746 .21316 L
.53846 .21316 L
.53946 .21316 L
.54046 .21316 L
.54146 .21316 L
.54246 .21316 L
.54346 .21316 L
.54446 .21316 L
.54545 .21316 L
.54645 .21316 L
.54745 .21316 L
.54845 .21316 L
Mistroke
.54945 .19833 L
.55045 .19833 L
.55145 .19833 L
.55245 .19833 L
.55345 .19833 L
.55445 .19833 L
.55544 .19833 L
.55644 .19833 L
.55744 .19833 L
.55844 .19833 L
.55944 .19833 L
.56044 .19833 L
.56144 .19833 L
.56244 .19833 L
.56344 .19833 L
.56444 .19833 L
.56543 .19833 L
.56643 .19833 L
.56743 .19833 L
.56843 .19833 L
.56943 .19833 L
.57043 .19833 L
.57143 .19833 L
.57243 .19833 L
.57343 .19833 L
.57443 .19833 L
.57542 .19833 L
.57642 .19833 L
.57742 .19833 L
.57842 .19833 L
.57942 .19833 L
.58042 .19833 L
.58142 .19833 L
.58242 .19833 L
.58342 .19833 L
.58442 .19833 L
.58541 .19833 L
.58641 .19833 L
.58741 .19833 L
.58841 .19833 L
.58941 .19833 L
.59041 .19833 L
.59141 .19833 L
.59241 .19833 L
.59341 .19833 L
.59441 .19833 L
.5954 .19833 L
.5964 .19833 L
.5974 .19833 L
.5984 .19833 L
Mistroke
.5994 .15563 L
.6004 .15563 L
.6014 .15563 L
.6024 .15563 L
.6034 .15563 L
.6044 .15563 L
.60539 .15563 L
.60639 .15563 L
.60739 .15563 L
.60839 .15563 L
.60939 .15563 L
.61039 .15563 L
.61139 .15563 L
.61239 .15563 L
.61339 .15563 L
.61439 .15563 L
.61538 .15563 L
.61638 .15563 L
.61738 .15563 L
.61838 .15563 L
.61938 .15563 L
.62038 .15563 L
.62138 .15563 L
.62238 .15563 L
.62338 .15563 L
.62438 .15563 L
.62537 .15563 L
.62637 .15563 L
.62737 .15563 L
.62837 .15563 L
.62937 .15563 L
.63037 .15563 L
.63137 .15563 L
.63237 .15563 L
.63337 .15563 L
.63437 .15563 L
.63536 .15563 L
.63636 .15563 L
.63736 .15563 L
.63836 .15563 L
.63936 .15563 L
.64036 .15563 L
.64136 .15563 L
.64236 .15563 L
.64336 .15563 L
.64436 .15563 L
.64535 .15563 L
.64635 .15563 L
.64735 .15563 L
.64835 .15563 L
Mistroke
.64935 .15096 L
.65035 .15096 L
.65135 .15096 L
.65235 .15096 L
.65335 .15096 L
.65435 .15096 L
.65534 .15096 L
.65634 .15096 L
.65734 .15096 L
.65834 .15096 L
.65934 .15096 L
.66034 .15096 L
.66134 .15096 L
.66234 .15096 L
.66334 .15096 L
.66434 .15096 L
.66533 .15096 L
.66633 .15096 L
.66733 .15096 L
.66833 .15096 L
.66933 .15096 L
.67033 .15096 L
.67133 .15096 L
.67233 .15096 L
.67333 .15096 L
.67433 .15096 L
.67532 .15096 L
.67632 .15096 L
.67732 .15096 L
.67832 .15096 L
.67932 .15096 L
.68032 .15096 L
.68132 .15096 L
.68232 .15096 L
.68332 .15096 L
.68432 .15096 L
.68531 .15096 L
.68631 .15096 L
.68731 .15096 L
.68831 .15096 L
.68931 .15096 L
.69031 .15096 L
.69131 .15096 L
.69231 .15096 L
.69331 .15096 L
.69431 .15096 L
.6953 .15096 L
.6963 .15096 L
.6973 .15096 L
.6983 .15096 L
Mistroke
.6993 .1534 L
.7003 .1534 L
.7013 .1534 L
.7023 .1534 L
.7033 .1534 L
.7043 .1534 L
.70529 .1534 L
.70629 .1534 L
.70729 .1534 L
.70829 .1534 L
.70929 .1534 L
.71029 .1534 L
.71129 .1534 L
.71229 .1534 L
.71329 .1534 L
.71429 .1534 L
.71528 .1534 L
.71628 .1534 L
.71728 .1534 L
.71828 .1534 L
.71928 .1534 L
.72028 .1534 L
.72128 .1534 L
.72228 .1534 L
.72328 .1534 L
.72428 .1534 L
.72527 .1534 L
.72627 .1534 L
.72727 .1534 L
.72827 .1534 L
.72927 .1534 L
.73027 .1534 L
.73127 .1534 L
.73227 .1534 L
.73327 .1534 L
.73427 .1534 L
.73526 .1534 L
.73626 .1534 L
.73726 .1534 L
.73826 .1534 L
.73926 .1534 L
.74026 .1534 L
.74126 .1534 L
.74226 .1534 L
.74326 .1534 L
.74426 .1534 L
.74525 .1534 L
.74625 .1534 L
.74725 .1534 L
.74825 .1534 L
Mistroke
.74925 .14204 L
.75025 .14204 L
.75125 .14204 L
.75225 .14204 L
.75325 .14204 L
.75425 .14204 L
.75524 .14204 L
.75624 .14204 L
.75724 .14204 L
.75824 .14204 L
.75924 .14204 L
.76024 .14204 L
.76124 .14204 L
.76224 .14204 L
.76324 .14204 L
.76424 .14204 L
.76523 .14204 L
.76623 .14204 L
.76723 .14204 L
.76823 .14204 L
.76923 .14204 L
.77023 .14204 L
.77123 .14204 L
.77223 .14204 L
.77323 .14204 L
.77423 .14204 L
.77522 .14204 L
.77622 .14204 L
.77722 .14204 L
.77822 .14204 L
.77922 .14204 L
.78022 .14204 L
.78122 .14204 L
.78222 .14204 L
.78322 .14204 L
.78422 .14204 L
.78521 .14204 L
.78621 .14204 L
.78721 .14204 L
.78821 .14204 L
.78921 .14204 L
.79021 .14204 L
.79121 .14204 L
.79221 .14204 L
.79321 .14204 L
.79421 .14204 L
.7952 .14204 L
.7962 .14204 L
.7972 .14204 L
.7982 .14204 L
Mistroke
.7992 .06085 L
.8002 .06085 L
.8012 .06085 L
.8022 .06085 L
.8032 .06085 L
.8042 .06085 L
.80519 .06085 L
.80619 .06085 L
.80719 .06085 L
.80819 .06085 L
.80919 .06085 L
.81019 .06085 L
.81119 .06085 L
.81219 .06085 L
.81319 .06085 L
.81419 .06085 L
.81518 .06085 L
.81618 .06085 L
.81718 .06085 L
.81818 .06085 L
.81918 .06085 L
.82018 .06085 L
.82118 .06085 L
.82218 .06085 L
.82318 .06085 L
.82418 .06085 L
.82517 .06085 L
.82617 .06085 L
.82717 .06085 L
.82817 .06085 L
.82917 .06085 L
.83017 .06085 L
.83117 .06085 L
.83217 .06085 L
.83317 .06085 L
.83417 .06085 L
.83516 .06085 L
.83616 .06085 L
.83716 .06085 L
.83816 .06085 L
.83916 .06085 L
.84016 .06085 L
.84116 .06085 L
.84216 .06085 L
.84316 .06085 L
.84416 .06085 L
.84515 .06085 L
.84615 .06085 L
.84715 .06085 L
.84815 .06085 L
Mistroke
.84915 .06892 L
.85015 .06892 L
.85115 .06892 L
.85215 .06892 L
.85315 .06892 L
.85415 .06892 L
.85514 .06892 L
.85614 .06892 L
.85714 .06892 L
.85814 .06892 L
.85914 .06892 L
.86014 .06892 L
.86114 .06892 L
.86214 .06892 L
.86314 .06892 L
.86414 .06892 L
.86513 .06892 L
.86613 .06892 L
.86713 .06892 L
.86813 .06892 L
.86913 .06892 L
.87013 .06892 L
.87113 .06892 L
.87213 .06892 L
.87313 .06892 L
.87413 .06892 L
.87512 .06892 L
.87612 .06892 L
.87712 .06892 L
.87812 .06892 L
.87912 .06892 L
.88012 .06892 L
.88112 .06892 L
.88212 .06892 L
.88312 .06892 L
.88412 .06892 L
.88511 .06892 L
.88611 .06892 L
.88711 .06892 L
.88811 .06892 L
.88911 .06892 L
.89011 .06892 L
.89111 .06892 L
.89211 .06892 L
.89311 .06892 L
.89411 .06892 L
.8951 .06892 L
.8961 .06892 L
.8971 .06892 L
.8981 .06892 L
Mistroke
.8991 .06901 L
.9001 .06901 L
.9011 .06901 L
.9021 .06901 L
.9031 .06901 L
.9041 .06901 L
.90509 .06901 L
.90609 .06901 L
.90709 .06901 L
.90809 .06901 L
.90909 .06901 L
.91009 .06901 L
.91109 .06901 L
.91209 .06901 L
.91309 .06901 L
.91409 .06901 L
.91508 .06901 L
.91608 .06901 L
.91708 .06901 L
.91808 .06901 L
.91908 .06901 L
.92008 .06901 L
.92108 .06901 L
.92208 .06901 L
.92308 .06901 L
.92408 .06901 L
.92507 .06901 L
.92607 .06901 L
.92707 .06901 L
.92807 .06901 L
.92907 .06901 L
.93007 .06901 L
.93107 .06901 L
.93207 .06901 L
.93307 .06901 L
.93407 .06901 L
.93506 .06901 L
.93606 .06901 L
.93706 .06901 L
.93806 .06901 L
.93906 .06901 L
.94006 .06901 L
.94106 .06901 L
.94206 .06901 L
.94306 .06901 L
.94406 .06901 L
.94505 .06901 L
.94605 .06901 L
.94705 .06901 L
.94805 .06901 L
Mistroke
.94905 .04409 L
.95005 .04409 L
.95105 .04409 L
.95205 .04409 L
.95305 .04409 L
.95405 .04409 L
.95504 .04409 L
.95604 .04409 L
.95704 .04409 L
.95804 .04409 L
.95904 .04409 L
.96004 .04409 L
.96104 .04409 L
.96204 .04409 L
.96304 .04409 L
.96404 .04409 L
.96503 .04409 L
.96603 .04409 L
.96703 .04409 L
.96803 .04409 L
.96903 .04409 L
.97003 .04409 L
.97103 .04409 L
.97203 .04409 L
.97303 .04409 L
.97403 .04409 L
.97502 .04409 L
.97602 .04409 L
.97702 .04409 L
.97802 .04409 L
.97902 .04409 L
.98002 .04409 L
.98102 .04409 L
.98202 .04409 L
.98302 .04409 L
.98402 .04409 L
.98501 .04409 L
.98601 .04409 L
.98701 .04409 L
.98801 .04409 L
.98901 .04409 L
.99001 .04409 L
.99101 .04409 L
.99201 .04409 L
.99301 .04409 L
.99401 .04409 L
.995 .04409 L
.996 .04409 L
.997 .04409 L
.998 .04409 L
Mistroke
.999 .04482 L
Mfstroke
0 0 1 r
gsave
.001 -0.20601 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 -1.54508 0.0618034 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -12 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -12 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(26)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(28)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(32)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(34)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(r) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .18541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .18541 m
.001 .18541 L
.002 .18541 L
.003 .18541 L
.004 .18541 L
.005 .18541 L
.00599 .18541 L
.00699 .18541 L
.00799 .18541 L
.00899 .18541 L
.00999 .18541 L
.01099 .18541 L
.01199 .18541 L
.01299 .18541 L
.01399 .18541 L
.01499 .18541 L
.01598 .18541 L
.01698 .18541 L
.01798 .18541 L
.01898 .18541 L
.01998 .18541 L
.02098 .18541 L
.02198 .18541 L
.02298 .18541 L
.02398 .18541 L
.02498 .18541 L
.02597 .18541 L
.02697 .18541 L
.02797 .18541 L
.02897 .18541 L
.02997 .18541 L
.03097 .18541 L
.03197 .18541 L
.03297 .18541 L
.03397 .18541 L
.03497 .18541 L
.03596 .18541 L
.03696 .18541 L
.03796 .18541 L
.03896 .18541 L
.03996 .18541 L
.04096 .18541 L
.04196 .18541 L
.04296 .18541 L
.04396 .18541 L
.04496 .18541 L
.04595 .18541 L
.04695 .18541 L
.04795 .18541 L
.04895 .18541 L
Mistroke
.04995 .18541 L
.05095 .18541 L
.05195 .18541 L
.05295 .18541 L
.05395 .18541 L
.05495 .18541 L
.05594 .18541 L
.05694 .18541 L
.05794 .18541 L
.05894 .18541 L
.05994 .18541 L
.06094 .18541 L
.06194 .18541 L
.06294 .18541 L
.06394 .18541 L
.06494 .18541 L
.06593 .18541 L
.06693 .18541 L
.06793 .18541 L
.06893 .18541 L
.06993 .18541 L
.07093 .18541 L
.07193 .18541 L
.07293 .18541 L
.07393 .18541 L
.07493 .18541 L
.07592 .18541 L
.07692 .18541 L
.07792 .18541 L
.07892 .18541 L
.07992 .18541 L
.08092 .18541 L
.08192 .18541 L
.08292 .18541 L
.08392 .18541 L
.08492 .18541 L
.08591 .18541 L
.08691 .18541 L
.08791 .18541 L
.08891 .18541 L
.08991 .18541 L
.09091 .18541 L
.09191 .18541 L
.09291 .18541 L
.09391 .18541 L
.09491 .18541 L
.0959 .18541 L
.0969 .18541 L
.0979 .18541 L
.0989 .18541 L
Mistroke
.0999 .18541 L
.1009 .18541 L
.1019 .18541 L
.1029 .18541 L
.1039 .18541 L
.1049 .18541 L
.10589 .18541 L
.10689 .18541 L
.10789 .18541 L
.10889 .18541 L
.10989 .18541 L
.11089 .18541 L
.11189 .18541 L
.11289 .18541 L
.11389 .18541 L
.11489 .18541 L
.11588 .18541 L
.11688 .18541 L
.11788 .18541 L
.11888 .18541 L
.11988 .18541 L
.12088 .18541 L
.12188 .18541 L
.12288 .18541 L
.12388 .18541 L
.12488 .18541 L
.12587 .18541 L
.12687 .18541 L
.12787 .18541 L
.12887 .18541 L
.12987 .18541 L
.13087 .18541 L
.13187 .18541 L
.13287 .18541 L
.13387 .18541 L
.13487 .18541 L
.13586 .18541 L
.13686 .18541 L
.13786 .18541 L
.13886 .18541 L
.13986 .18541 L
.14086 .18541 L
.14186 .18541 L
.14286 .18541 L
.14386 .18541 L
.14486 .18541 L
.14585 .18541 L
.14685 .18541 L
.14785 .18541 L
.14885 .18541 L
Mistroke
.14985 .18541 L
.15085 .18541 L
.15185 .18541 L
.15285 .18541 L
.15385 .18541 L
.15485 .18541 L
.15584 .18541 L
.15684 .18541 L
.15784 .18541 L
.15884 .18541 L
.15984 .18541 L
.16084 .18541 L
.16184 .18541 L
.16284 .18541 L
.16384 .18541 L
.16484 .18541 L
.16583 .18541 L
.16683 .18541 L
.16783 .18541 L
.16883 .18541 L
.16983 .18541 L
.17083 .18541 L
.17183 .18541 L
.17283 .18541 L
.17383 .18541 L
.17483 .18541 L
.17582 .18541 L
.17682 .18541 L
.17782 .18541 L
.17882 .18541 L
.17982 .18541 L
.18082 .18541 L
.18182 .18541 L
.18282 .18541 L
.18382 .18541 L
.18482 .18541 L
.18581 .18541 L
.18681 .18541 L
.18781 .18541 L
.18881 .18541 L
.18981 .18541 L
.19081 .18541 L
.19181 .18541 L
.19281 .18541 L
.19381 .18541 L
.19481 .18541 L
.1958 .18541 L
.1968 .18541 L
.1978 .18541 L
.1988 .18541 L
Mistroke
.1998 .18541 L
.2008 .18541 L
.2018 .18541 L
.2028 .18541 L
.2038 .18541 L
.2048 .18541 L
.20579 .18541 L
.20679 .18541 L
.20779 .18541 L
.20879 .18541 L
.20979 .18541 L
.21079 .18541 L
.21179 .18541 L
.21279 .18541 L
.21379 .18541 L
.21479 .18541 L
.21578 .18541 L
.21678 .18541 L
.21778 .18541 L
.21878 .18541 L
.21978 .18541 L
.22078 .18541 L
.22178 .18541 L
.22278 .18541 L
.22378 .18541 L
.22478 .18541 L
.22577 .18541 L
.22677 .18541 L
.22777 .18541 L
.22877 .18541 L
.22977 .18541 L
.23077 .18541 L
.23177 .18541 L
.23277 .18541 L
.23377 .18541 L
.23477 .18541 L
.23576 .18541 L
.23676 .18541 L
.23776 .18541 L
.23876 .18541 L
.23976 .18541 L
.24076 .18541 L
.24176 .18541 L
.24276 .18541 L
.24376 .18541 L
.24476 .18541 L
.24575 .18541 L
.24675 .18541 L
.24775 .18541 L
.24875 .18541 L
Mistroke
.24975 .18541 L
.25075 .18541 L
.25175 .18541 L
.25275 .18542 L
.25375 .18541 L
.25475 .18542 L
.25574 .18542 L
.25674 .18542 L
.25774 .18542 L
.25874 .18542 L
.25974 .18542 L
.26074 .18542 L
.26174 .18542 L
.26274 .18542 L
.26374 .18542 L
.26474 .18542 L
.26573 .18542 L
.26673 .18542 L
.26773 .18542 L
.26873 .18542 L
.26973 .18542 L
.27073 .18542 L
.27173 .18542 L
.27273 .18542 L
.27373 .18542 L
.27473 .18542 L
.27572 .18542 L
.27672 .18542 L
.27772 .18542 L
.27872 .18542 L
.27972 .18542 L
.28072 .18542 L
.28172 .18542 L
.28272 .18542 L
.28372 .18542 L
.28472 .18542 L
.28571 .18542 L
.28671 .18542 L
.28771 .18542 L
.28871 .18542 L
.28971 .18542 L
.29071 .18542 L
.29171 .18542 L
.29271 .18542 L
.29371 .18542 L
.29471 .18541 L
.2957 .18542 L
.2967 .18542 L
.2977 .18541 L
.2987 .18541 L
Mistroke
.2997 .18541 L
.3007 .18541 L
.3017 .18541 L
.3027 .18541 L
.3037 .18542 L
.3047 .18542 L
.30569 .18542 L
.30669 .18542 L
.30769 .18541 L
.30869 .18541 L
.30969 .18541 L
.31069 .18541 L
.31169 .18541 L
.31269 .18541 L
.31369 .18541 L
.31469 .18541 L
.31568 .18541 L
.31668 .18541 L
.31768 .18541 L
.31868 .18541 L
.31968 .18541 L
.32068 .18541 L
.32168 .18541 L
.32268 .18541 L
.32368 .18541 L
.32468 .18542 L
.32567 .18542 L
.32667 .18542 L
.32767 .18542 L
.32867 .18542 L
.32967 .18542 L
.33067 .18542 L
.33167 .18542 L
.33267 .18542 L
.33367 .18542 L
.33467 .18542 L
.33566 .18542 L
.33666 .18542 L
.33766 .18542 L
.33866 .18542 L
.33966 .18541 L
.34066 .18541 L
.34166 .18541 L
.34266 .18541 L
.34366 .18541 L
.34466 .18541 L
.34565 .18541 L
.34665 .18541 L
.34765 .18541 L
.34865 .18541 L
Mistroke
.34965 .18541 L
.35065 .18541 L
.35165 .18541 L
.35265 .18541 L
.35365 .18541 L
.35465 .18541 L
.35564 .18541 L
.35664 .18541 L
.35764 .18541 L
.35864 .18541 L
.35964 .18541 L
.36064 .18541 L
.36164 .18541 L
.36264 .18541 L
.36364 .18541 L
.36464 .18541 L
.36563 .18541 L
.36663 .18541 L
.36763 .18541 L
.36863 .18541 L
.36963 .18542 L
.37063 .18542 L
.37163 .18542 L
.37263 .18541 L
.37363 .18541 L
.37463 .18542 L
.37562 .18542 L
.37662 .18542 L
.37762 .18542 L
.37862 .18542 L
.37962 .18541 L
.38062 .18542 L
.38162 .18542 L
.38262 .18542 L
.38362 .18542 L
.38462 .18541 L
.38561 .18541 L
.38661 .18541 L
.38761 .18541 L
.38861 .18541 L
.38961 .18541 L
.39061 .18541 L
.39161 .18541 L
.39261 .18542 L
.39361 .18541 L
.39461 .18541 L
.3956 .18541 L
.3966 .18541 L
.3976 .18541 L
.3986 .18542 L
Mistroke
.3996 .18542 L
.4006 .18542 L
.4016 .18542 L
.4026 .18542 L
.4036 .18542 L
.4046 .18542 L
.40559 .18542 L
.40659 .18542 L
.40759 .18542 L
.40859 .18542 L
.40959 .18542 L
.41059 .18542 L
.41159 .18542 L
.41259 .18542 L
.41359 .18542 L
.41459 .18542 L
.41558 .18542 L
.41658 .18542 L
.41758 .18542 L
.41858 .18542 L
.41958 .18542 L
.42058 .18541 L
.42158 .18541 L
.42258 .18542 L
.42358 .18542 L
.42458 .18542 L
.42557 .18542 L
.42657 .18542 L
.42757 .18542 L
.42857 .18542 L
.42957 .18542 L
.43057 .18541 L
.43157 .18541 L
.43257 .18542 L
.43357 .18542 L
.43457 .18541 L
.43556 .18541 L
.43656 .18541 L
.43756 .18542 L
.43856 .18541 L
.43956 .18541 L
.44056 .18542 L
.44156 .18542 L
.44256 .18542 L
.44356 .18542 L
.44456 .18542 L
.44555 .18542 L
.44655 .18542 L
.44755 .18542 L
.44855 .18542 L
Mistroke
.44955 .18542 L
.45055 .18542 L
.45155 .18542 L
.45255 .18542 L
.45355 .18542 L
.45455 .18542 L
.45554 .18542 L
.45654 .18542 L
.45754 .18542 L
.45854 .18542 L
.45954 .18542 L
.46054 .18542 L
.46154 .18542 L
.46254 .18542 L
.46354 .18542 L
.46454 .18542 L
.46553 .18542 L
.46653 .18542 L
.46753 .18542 L
.46853 .18542 L
.46953 .18542 L
.47053 .18542 L
.47153 .18542 L
.47253 .18542 L
.47353 .18542 L
.47453 .18542 L
.47552 .18542 L
.47652 .18542 L
.47752 .18542 L
.47852 .18542 L
.47952 .18542 L
.48052 .18542 L
.48152 .18542 L
.48252 .18542 L
.48352 .18542 L
.48452 .18542 L
.48551 .18542 L
.48651 .18542 L
.48751 .18542 L
.48851 .18542 L
.48951 .18542 L
.49051 .18542 L
.49151 .18542 L
.49251 .18542 L
.49351 .18542 L
.49451 .18542 L
.4955 .18542 L
.4965 .18542 L
.4975 .18542 L
.4985 .18542 L
Mistroke
.4995 .18542 L
.5005 .18542 L
.5015 .18542 L
.5025 .18542 L
.5035 .18542 L
.5045 .18542 L
.50549 .18542 L
.50649 .18542 L
.50749 .18542 L
.50849 .18542 L
.50949 .18542 L
.51049 .18542 L
.51149 .18542 L
.51249 .18542 L
.51349 .18542 L
.51449 .18542 L
.51548 .18542 L
.51648 .18542 L
.51748 .18542 L
.51848 .18542 L
.51948 .18542 L
.52048 .18542 L
.52148 .18542 L
.52248 .18542 L
.52348 .18542 L
.52448 .18542 L
.52547 .18542 L
.52647 .18542 L
.52747 .18542 L
.52847 .18542 L
.52947 .18542 L
.53047 .18542 L
.53147 .18542 L
.53247 .18543 L
.53347 .18542 L
.53447 .18542 L
.53546 .18542 L
.53646 .18542 L
.53746 .18542 L
.53846 .18542 L
.53946 .18542 L
.54046 .18542 L
.54146 .18542 L
.54246 .18542 L
.54346 .18542 L
.54446 .18542 L
.54545 .18542 L
.54645 .18542 L
.54745 .18542 L
.54845 .18542 L
Mistroke
.54945 .18542 L
.55045 .18542 L
.55145 .18542 L
.55245 .18542 L
.55345 .18542 L
.55445 .18542 L
.55544 .18542 L
.55644 .18542 L
.55744 .18542 L
.55844 .18542 L
.55944 .18542 L
.56044 .18542 L
.56144 .18542 L
.56244 .18542 L
.56344 .18542 L
.56444 .18542 L
.56543 .18542 L
.56643 .18542 L
.56743 .18542 L
.56843 .18542 L
.56943 .18542 L
.57043 .18542 L
.57143 .18543 L
.57243 .18543 L
.57343 .18543 L
.57443 .18543 L
.57542 .18543 L
.57642 .18543 L
.57742 .18543 L
.57842 .18543 L
.57942 .18543 L
.58042 .18542 L
.58142 .18543 L
.58242 .18542 L
.58342 .18543 L
.58442 .18542 L
.58541 .18543 L
.58641 .18543 L
.58741 .18543 L
.58841 .18543 L
.58941 .18542 L
.59041 .18542 L
.59141 .18542 L
.59241 .18543 L
.59341 .18543 L
.59441 .18543 L
.5954 .18543 L
.5964 .18543 L
.5974 .18543 L
.5984 .18542 L
Mistroke
.5994 .18542 L
.6004 .18542 L
.6014 .18542 L
.6024 .18542 L
.6034 .18543 L
.6044 .18542 L
.60539 .18542 L
.60639 .18542 L
.60739 .18542 L
.60839 .18542 L
.60939 .18542 L
.61039 .18542 L
.61139 .18542 L
.61239 .18542 L
.61339 .18542 L
.61439 .18542 L
.61538 .18542 L
.61638 .18542 L
.61738 .18542 L
.61838 .18542 L
.61938 .18542 L
.62038 .18543 L
.62138 .18543 L
.62238 .18543 L
.62338 .18543 L
.62438 .18543 L
.62537 .18543 L
.62637 .18543 L
.62737 .18543 L
.62837 .18543 L
.62937 .18543 L
.63037 .18543 L
.63137 .18543 L
.63237 .18543 L
.63337 .18543 L
.63437 .18543 L
.63536 .18543 L
.63636 .18543 L
.63736 .18543 L
.63836 .18543 L
.63936 .18543 L
.64036 .18543 L
.64136 .18543 L
.64236 .18543 L
.64336 .18543 L
.64436 .18543 L
.64535 .18543 L
.64635 .18543 L
.64735 .18543 L
.64835 .18543 L
Mistroke
.64935 .18543 L
.65035 .18543 L
.65135 .18543 L
.65235 .18543 L
.65335 .18543 L
.65435 .18543 L
.65534 .18543 L
.65634 .18543 L
.65734 .18543 L
.65834 .18543 L
.65934 .18543 L
.66034 .18543 L
.66134 .18543 L
.66234 .18543 L
.66334 .18543 L
.66434 .18543 L
.66533 .18543 L
.66633 .18543 L
.66733 .18543 L
.66833 .18543 L
.66933 .18543 L
.67033 .18543 L
.67133 .18543 L
.67233 .18543 L
.67333 .18543 L
.67433 .18543 L
.67532 .18543 L
.67632 .18543 L
.67732 .18543 L
.67832 .18543 L
.67932 .18543 L
.68032 .18543 L
.68132 .18543 L
.68232 .18543 L
.68332 .18543 L
.68432 .18543 L
.68531 .18543 L
.68631 .18543 L
.68731 .18543 L
.68831 .18543 L
.68931 .18543 L
.69031 .18543 L
.69131 .18543 L
.69231 .18543 L
.69331 .18543 L
.69431 .18543 L
.6953 .18543 L
.6963 .18543 L
.6973 .18543 L
.6983 .18543 L
Mistroke
.6993 .18543 L
.7003 .18543 L
.7013 .18543 L
.7023 .18543 L
.7033 .18543 L
.7043 .18543 L
.70529 .18543 L
.70629 .18543 L
.70729 .18543 L
.70829 .18543 L
.70929 .18543 L
.71029 .18543 L
.71129 .18543 L
.71229 .18543 L
.71329 .18543 L
.71429 .18543 L
.71528 .18543 L
.71628 .18543 L
.71728 .18543 L
.71828 .18543 L
.71928 .18543 L
.72028 .18543 L
.72128 .18543 L
.72228 .18543 L
.72328 .18543 L
.72428 .18543 L
.72527 .18543 L
.72627 .18543 L
.72727 .18543 L
.72827 .18543 L
.72927 .18543 L
.73027 .18542 L
.73127 .18542 L
.73227 .18542 L
.73327 .18542 L
.73427 .18542 L
.73526 .18542 L
.73626 .18542 L
.73726 .18542 L
.73826 .18542 L
.73926 .18542 L
.74026 .18542 L
.74126 .18542 L
.74226 .18542 L
.74326 .18542 L
.74426 .18542 L
.74525 .18542 L
.74625 .18542 L
.74725 .18542 L
.74825 .18542 L
Mistroke
.74925 .18542 L
.75025 .18542 L
.75125 .18542 L
.75225 .18542 L
.75325 .18542 L
.75425 .18542 L
.75524 .18542 L
.75624 .18542 L
.75724 .18542 L
.75824 .18542 L
.75924 .18542 L
.76024 .18542 L
.76124 .18542 L
.76224 .18542 L
.76324 .18542 L
.76424 .18542 L
.76523 .18542 L
.76623 .18542 L
.76723 .18542 L
.76823 .18542 L
.76923 .18542 L
.77023 .18542 L
.77123 .18542 L
.77223 .18542 L
.77323 .18542 L
.77423 .18542 L
.77522 .18542 L
.77622 .18541 L
.77722 .18541 L
.77822 .18541 L
.77922 .18541 L
.78022 .18541 L
.78122 .18541 L
.78222 .18541 L
.78322 .18541 L
.78422 .18541 L
.78521 .18541 L
.78621 .18541 L
.78721 .18541 L
.78821 .18541 L
.78921 .18541 L
.79021 .18541 L
.79121 .18541 L
.79221 .18541 L
.79321 .18541 L
.79421 .18541 L
.7952 .18542 L
.7962 .18542 L
.7972 .18542 L
.7982 .18542 L
Mistroke
.7992 .18542 L
.8002 .18542 L
.8012 .18541 L
.8022 .18541 L
.8032 .18541 L
.8042 .18541 L
.80519 .18541 L
.80619 .18541 L
.80719 .18541 L
.80819 .18541 L
.80919 .18541 L
.81019 .18541 L
.81119 .18541 L
.81219 .18542 L
.81319 .18542 L
.81419 .18541 L
.81518 .18542 L
.81618 .18542 L
.81718 .18542 L
.81818 .18542 L
.81918 .18542 L
.82018 .18542 L
.82118 .18542 L
.82218 .18542 L
.82318 .18541 L
.82418 .18541 L
.82517 .18541 L
.82617 .18541 L
.82717 .18541 L
.82817 .18541 L
.82917 .18541 L
.83017 .18541 L
.83117 .18541 L
.83217 .18541 L
.83317 .18541 L
.83417 .18541 L
.83516 .18541 L
.83616 .18541 L
.83716 .18541 L
.83816 .18541 L
.83916 .18541 L
.84016 .18541 L
.84116 .18541 L
.84216 .18541 L
.84316 .18541 L
.84416 .18541 L
.84515 .18541 L
.84615 .18541 L
.84715 .18541 L
.84815 .18541 L
Mistroke
.84915 .18541 L
.85015 .18541 L
.85115 .18541 L
.85215 .18541 L
.85315 .18541 L
.85415 .18541 L
.85514 .18541 L
.85614 .18541 L
.85714 .18541 L
.85814 .18541 L
.85914 .18541 L
.86014 .18541 L
.86114 .18541 L
.86214 .18541 L
.86314 .18541 L
.86414 .18541 L
.86513 .18541 L
.86613 .18541 L
.86713 .18541 L
.86813 .18541 L
.86913 .18541 L
.87013 .18541 L
.87113 .18541 L
.87213 .18541 L
.87313 .18541 L
.87413 .18541 L
.87512 .18541 L
.87612 .18541 L
.87712 .18541 L
.87812 .18541 L
.87912 .18542 L
.88012 .18542 L
.88112 .18542 L
.88212 .18542 L
.88312 .18542 L
.88412 .18542 L
.88511 .18542 L
.88611 .18542 L
.88711 .18542 L
.88811 .18542 L
.88911 .18542 L
.89011 .18541 L
.89111 .18541 L
.89211 .18541 L
.89311 .18541 L
.89411 .18541 L
.8951 .18541 L
.8961 .18541 L
.8971 .18541 L
.8981 .18541 L
Mistroke
.8991 .18541 L
.9001 .18541 L
.9011 .18542 L
.9021 .18542 L
.9031 .18542 L
.9041 .18542 L
.90509 .18542 L
.90609 .18542 L
.90709 .18542 L
.90809 .18542 L
.90909 .18542 L
.91009 .18542 L
.91109 .18542 L
.91209 .18542 L
.91309 .18542 L
.91409 .18542 L
.91508 .18542 L
.91608 .18542 L
.91708 .18542 L
.91808 .18542 L
.91908 .18542 L
.92008 .18542 L
.92108 .18542 L
.92208 .18542 L
.92308 .18542 L
.92408 .18542 L
.92507 .18542 L
.92607 .18542 L
.92707 .18542 L
.92807 .18542 L
.92907 .18542 L
.93007 .18542 L
.93107 .18542 L
.93207 .18542 L
.93307 .18542 L
.93407 .18542 L
.93506 .18542 L
.93606 .18542 L
.93706 .18542 L
.93806 .18542 L
.93906 .18542 L
.94006 .18542 L
.94106 .18542 L
.94206 .18542 L
.94306 .18542 L
.94406 .18542 L
.94505 .18542 L
.94605 .18542 L
.94705 .18542 L
.94805 .18542 L
Mistroke
.94905 .18542 L
.95005 .18542 L
.95105 .18542 L
.95205 .18542 L
.95305 .18542 L
.95405 .18542 L
.95504 .18542 L
.95604 .18541 L
.95704 .18542 L
.95804 .18542 L
.95904 .18542 L
.96004 .18542 L
.96104 .18542 L
.96204 .18542 L
.96304 .18542 L
.96404 .18542 L
.96503 .18542 L
.96603 .18542 L
.96703 .18541 L
.96803 .18541 L
.96903 .18541 L
.97003 .18541 L
.97103 .18541 L
.97203 .18541 L
.97303 .18541 L
.97403 .18541 L
.97502 .18541 L
.97602 .18541 L
.97702 .18541 L
.97802 .18541 L
.97902 .18541 L
.98002 .18541 L
.98102 .18541 L
.98202 .18541 L
.98302 .18541 L
.98402 .18541 L
.98501 .18541 L
.98601 .18541 L
.98701 .18541 L
.98801 .18541 L
.98901 .18541 L
.99001 .18541 L
.99101 .18541 L
.99201 .18541 L
.99301 .18541 L
.99401 .18541 L
.995 .18541 L
.996 .18541 L
.997 .18541 L
.998 .18541 L
Mistroke
.999 .18541 L
Mfstroke
0 .98 .604 r
gsave
.999 .22371 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
0 .12608 m
.001 .12608 L
.002 .12608 L
.003 .12608 L
.004 .12608 L
.005 .12608 L
.00599 .12608 L
.00699 .12608 L
.00799 .12608 L
.00899 .12608 L
.00999 .12608 L
.01099 .12608 L
.01199 .12608 L
.01299 .12608 L
.01399 .12608 L
.01499 .12608 L
.01598 .12608 L
.01698 .12608 L
.01798 .12608 L
.01898 .12608 L
.01998 .12608 L
.02098 .12608 L
.02198 .12608 L
.02298 .12608 L
.02398 .12608 L
.02498 .12608 L
.02597 .12608 L
.02697 .12608 L
.02797 .12608 L
.02897 .12608 L
.02997 .12608 L
.03097 .12608 L
.03197 .12608 L
.03297 .12608 L
.03397 .12608 L
.03497 .12608 L
.03596 .12608 L
.03696 .12608 L
.03796 .12608 L
.03896 .12608 L
.03996 .12608 L
.04096 .12608 L
.04196 .12608 L
.04296 .12608 L
.04396 .12608 L
.04496 .12608 L
.04595 .12608 L
.04695 .12608 L
.04795 .12608 L
.04895 .12608 L
Mistroke
.04995 .09479 L
.05095 .09479 L
.05195 .09479 L
.05295 .09479 L
.05395 .09479 L
.05495 .09479 L
.05594 .09479 L
.05694 .09479 L
.05794 .09479 L
.05894 .09479 L
.05994 .09479 L
.06094 .09479 L
.06194 .09479 L
.06294 .09479 L
.06394 .09479 L
.06494 .09479 L
.06593 .09479 L
.06693 .09479 L
.06793 .09479 L
.06893 .09479 L
.06993 .09479 L
.07093 .09479 L
.07193 .09479 L
.07293 .09479 L
.07393 .09479 L
.07493 .09479 L
.07592 .09479 L
.07692 .09479 L
.07792 .09479 L
.07892 .09479 L
.07992 .09479 L
.08092 .09479 L
.08192 .09479 L
.08292 .09479 L
.08392 .09479 L
.08492 .09479 L
.08591 .09479 L
.08691 .09479 L
.08791 .09479 L
.08891 .09479 L
.08991 .09479 L
.09091 .09479 L
.09191 .09479 L
.09291 .09479 L
.09391 .09479 L
.09491 .09479 L
.0959 .09479 L
.0969 .09479 L
.0979 .09479 L
.0989 .09479 L
Mistroke
.0999 .4764 L
.1009 .4764 L
.1019 .4764 L
.1029 .4764 L
.1039 .4764 L
.1049 .4764 L
.10589 .4764 L
.10689 .4764 L
.10789 .4764 L
.10889 .4764 L
.10989 .4764 L
.11089 .4764 L
.11189 .4764 L
.11289 .4764 L
.11389 .4764 L
.11489 .4764 L
.11588 .4764 L
.11688 .4764 L
.11788 .4764 L
.11888 .4764 L
.11988 .4764 L
.12088 .4764 L
.12188 .4764 L
.12288 .4764 L
.12388 .4764 L
.12488 .4764 L
.12587 .4764 L
.12687 .4764 L
.12787 .4764 L
.12887 .4764 L
.12987 .4764 L
.13087 .4764 L
.13187 .4764 L
.13287 .4764 L
.13387 .4764 L
.13487 .4764 L
.13586 .4764 L
.13686 .4764 L
.13786 .4764 L
.13886 .4764 L
.13986 .4764 L
.14086 .4764 L
.14186 .4764 L
.14286 .4764 L
.14386 .4764 L
.14486 .4764 L
.14585 .4764 L
.14685 .4764 L
.14785 .4764 L
.14885 .4764 L
Mistroke
.14985 .3761 L
.15085 .3761 L
.15185 .3761 L
.15285 .3761 L
.15385 .3761 L
.15485 .3761 L
.15584 .3761 L
.15684 .3761 L
.15784 .3761 L
.15884 .3761 L
.15984 .3761 L
.16084 .3761 L
.16184 .3761 L
.16284 .3761 L
.16384 .3761 L
.16484 .3761 L
.16583 .3761 L
.16683 .3761 L
.16783 .3761 L
.16883 .3761 L
.16983 .3761 L
.17083 .3761 L
.17183 .3761 L
.17283 .3761 L
.17383 .3761 L
.17483 .3761 L
.17582 .3761 L
.17682 .3761 L
.17782 .3761 L
.17882 .3761 L
.17982 .3761 L
.18082 .3761 L
.18182 .3761 L
.18282 .3761 L
.18382 .3761 L
.18482 .3761 L
.18581 .3761 L
.18681 .3761 L
.18781 .3761 L
.18881 .3761 L
.18981 .3761 L
.19081 .3761 L
.19181 .3761 L
.19281 .3761 L
.19381 .3761 L
.19481 .3761 L
.1958 .3761 L
.1968 .3761 L
.1978 .3761 L
.1988 .3761 L
Mistroke
.1998 .27524 L
.2008 .27524 L
.2018 .27524 L
.2028 .27524 L
.2038 .27524 L
.2048 .27524 L
.20579 .27524 L
.20679 .27524 L
.20779 .27524 L
.20879 .27524 L
.20979 .27524 L
.21079 .27524 L
.21179 .27524 L
.21279 .27524 L
.21379 .27524 L
.21479 .27524 L
.21578 .27524 L
.21678 .27524 L
.21778 .27524 L
.21878 .27524 L
.21978 .27524 L
.22078 .27524 L
.22178 .27524 L
.22278 .27524 L
.22378 .27524 L
.22478 .27524 L
.22577 .27524 L
.22677 .27524 L
.22777 .27524 L
.22877 .27524 L
.22977 .27524 L
.23077 .27524 L
.23177 .27524 L
.23277 .27524 L
.23377 .27524 L
.23477 .27524 L
.23576 .27524 L
.23676 .27524 L
.23776 .27524 L
.23876 .27524 L
.23976 .27524 L
.24076 .27524 L
.24176 .27524 L
.24276 .27524 L
.24376 .27524 L
.24476 .27524 L
.24575 .27524 L
.24675 .27524 L
.24775 .27524 L
.24875 .27524 L
Mistroke
.24975 .2928 L
.25075 .2928 L
.25175 .2928 L
.25275 .2928 L
.25375 .2928 L
.25475 .2928 L
.25574 .2928 L
.25674 .2928 L
.25774 .2928 L
.25874 .2928 L
.25974 .2928 L
.26074 .2928 L
.26174 .2928 L
.26274 .2928 L
.26374 .2928 L
.26474 .2928 L
.26573 .2928 L
.26673 .2928 L
.26773 .2928 L
.26873 .2928 L
.26973 .2928 L
.27073 .2928 L
.27173 .2928 L
.27273 .2928 L
.27373 .2928 L
.27473 .2928 L
.27572 .2928 L
.27672 .2928 L
.27772 .2928 L
.27872 .2928 L
.27972 .2928 L
.28072 .2928 L
.28172 .2928 L
.28272 .2928 L
.28372 .2928 L
.28472 .2928 L
.28571 .2928 L
.28671 .2928 L
.28771 .2928 L
.28871 .2928 L
.28971 .2928 L
.29071 .2928 L
.29171 .2928 L
.29271 .2928 L
.29371 .2928 L
.29471 .2928 L
.2957 .2928 L
.2967 .2928 L
.2977 .2928 L
.2987 .2928 L
Mistroke
.2997 .2644 L
.3007 .2644 L
.3017 .2644 L
.3027 .2644 L
.3037 .2644 L
.3047 .2644 L
.30569 .2644 L
.30669 .2644 L
.30769 .2644 L
.30869 .2644 L
.30969 .2644 L
.31069 .2644 L
.31169 .2644 L
.31269 .2644 L
.31369 .2644 L
.31469 .2644 L
.31568 .2644 L
.31668 .2644 L
.31768 .2644 L
.31868 .2644 L
.31968 .2644 L
.32068 .2644 L
.32168 .2644 L
.32268 .2644 L
.32368 .2644 L
.32468 .2644 L
.32567 .2644 L
.32667 .2644 L
.32767 .2644 L
.32867 .2644 L
.32967 .2644 L
.33067 .2644 L
.33167 .2644 L
.33267 .2644 L
.33367 .2644 L
.33467 .2644 L
.33566 .2644 L
.33666 .2644 L
.33766 .2644 L
.33866 .2644 L
.33966 .2644 L
.34066 .2644 L
.34166 .2644 L
.34266 .2644 L
.34366 .2644 L
.34466 .2644 L
.34565 .2644 L
.34665 .2644 L
.34765 .2644 L
.34865 .2644 L
Mistroke
.34965 .24591 L
.35065 .24591 L
.35165 .24591 L
.35265 .24591 L
.35365 .24591 L
.35465 .24591 L
.35564 .24591 L
.35664 .24591 L
.35764 .24591 L
.35864 .24591 L
.35964 .24591 L
.36064 .24591 L
.36164 .24591 L
.36264 .24591 L
.36364 .24591 L
.36464 .24591 L
.36563 .24591 L
.36663 .24591 L
.36763 .24591 L
.36863 .24591 L
.36963 .24591 L
.37063 .24591 L
.37163 .24591 L
.37263 .24591 L
.37363 .24591 L
.37463 .24591 L
.37562 .24591 L
.37662 .24591 L
.37762 .24591 L
.37862 .24591 L
.37962 .24591 L
.38062 .24591 L
.38162 .24591 L
.38262 .24591 L
.38362 .24591 L
.38462 .24591 L
.38561 .24591 L
.38661 .24591 L
.38761 .24591 L
.38861 .24591 L
.38961 .24591 L
.39061 .24591 L
.39161 .24591 L
.39261 .24591 L
.39361 .24591 L
.39461 .24591 L
.3956 .24591 L
.3966 .24591 L
.3976 .24591 L
.3986 .24591 L
Mistroke
.3996 .27081 L
.4006 .27081 L
.4016 .27081 L
.4026 .27081 L
.4036 .27081 L
.4046 .27081 L
.40559 .27081 L
.40659 .27081 L
.40759 .27081 L
.40859 .27081 L
.40959 .27081 L
.41059 .27081 L
.41159 .27081 L
.41259 .27081 L
.41359 .27081 L
.41459 .27081 L
.41558 .27081 L
.41658 .27081 L
.41758 .27081 L
.41858 .27081 L
.41958 .27081 L
.42058 .27081 L
.42158 .27081 L
.42258 .27081 L
.42358 .27081 L
.42458 .27081 L
.42557 .27081 L
.42657 .27081 L
.42757 .27081 L
.42857 .27081 L
.42957 .27081 L
.43057 .27081 L
.43157 .27081 L
.43257 .27081 L
.43357 .27081 L
.43457 .27081 L
.43556 .27081 L
.43656 .27081 L
.43756 .27081 L
.43856 .27081 L
.43956 .27081 L
.44056 .27081 L
.44156 .27081 L
.44256 .27081 L
.44356 .27081 L
.44456 .27081 L
.44555 .27081 L
.44655 .27081 L
.44755 .27081 L
.44855 .27081 L
Mistroke
.44955 .24927 L
.45055 .24927 L
.45155 .24927 L
.45255 .24927 L
.45355 .24927 L
.45455 .24927 L
.45554 .24927 L
.45654 .24927 L
.45754 .24927 L
.45854 .24927 L
.45954 .24927 L
.46054 .24927 L
.46154 .24927 L
.46254 .24927 L
.46354 .24927 L
.46454 .24927 L
.46553 .24927 L
.46653 .24927 L
.46753 .24927 L
.46853 .24927 L
.46953 .24927 L
.47053 .24927 L
.47153 .24927 L
.47253 .24927 L
.47353 .24927 L
.47453 .24927 L
.47552 .24927 L
.47652 .24927 L
.47752 .24927 L
.47852 .24927 L
.47952 .24927 L
.48052 .24927 L
.48152 .24927 L
.48252 .24927 L
.48352 .24927 L
.48452 .24927 L
.48551 .24927 L
.48651 .24927 L
.48751 .24927 L
.48851 .24927 L
.48951 .24927 L
.49051 .24927 L
.49151 .24927 L
.49251 .24927 L
.49351 .24927 L
.49451 .24927 L
.4955 .24927 L
.4965 .24927 L
.4975 .24927 L
.4985 .24927 L
Mistroke
.4995 .25012 L
.5005 .25012 L
.5015 .25012 L
.5025 .25012 L
.5035 .25012 L
.5045 .25012 L
.50549 .25012 L
.50649 .25012 L
.50749 .25012 L
.50849 .25012 L
.50949 .25012 L
.51049 .25012 L
.51149 .25012 L
.51249 .25012 L
.51349 .25012 L
.51449 .25012 L
.51548 .25012 L
.51648 .25012 L
.51748 .25012 L
.51848 .25012 L
.51948 .25012 L
.52048 .25012 L
.52148 .25012 L
.52248 .25012 L
.52348 .25012 L
.52448 .25012 L
.52547 .25012 L
.52647 .25012 L
.52747 .25012 L
.52847 .25012 L
.52947 .25012 L
.53047 .25012 L
.53147 .25012 L
.53247 .25012 L
.53347 .25012 L
.53447 .25012 L
.53546 .25012 L
.53646 .25012 L
.53746 .25012 L
.53846 .25012 L
.53946 .25012 L
.54046 .25012 L
.54146 .25012 L
.54246 .25012 L
.54346 .25012 L
.54446 .25012 L
.54545 .25012 L
.54645 .25012 L
.54745 .25012 L
.54845 .25012 L
Mistroke
.54945 .24906 L
.55045 .24906 L
.55145 .24906 L
.55245 .24906 L
.55345 .24906 L
.55445 .24906 L
.55544 .24906 L
.55644 .24906 L
.55744 .24906 L
.55844 .24906 L
.55944 .24906 L
.56044 .24906 L
.56144 .24906 L
.56244 .24906 L
.56344 .24906 L
.56444 .24906 L
.56543 .24906 L
.56643 .24906 L
.56743 .24906 L
.56843 .24906 L
.56943 .24906 L
.57043 .24906 L
.57143 .24906 L
.57243 .24906 L
.57343 .24906 L
.57443 .24906 L
.57542 .24906 L
.57642 .24906 L
.57742 .24906 L
.57842 .24906 L
.57942 .24906 L
.58042 .24906 L
.58142 .24906 L
.58242 .24906 L
.58342 .24906 L
.58442 .24906 L
.58541 .24906 L
.58641 .24906 L
.58741 .24906 L
.58841 .24906 L
.58941 .24906 L
.59041 .24906 L
.59141 .24906 L
.59241 .24906 L
.59341 .24906 L
.59441 .24906 L
.5954 .24906 L
.5964 .24906 L
.5974 .24906 L
.5984 .24906 L
Mistroke
.5994 .22863 L
.6004 .22863 L
.6014 .22863 L
.6024 .22863 L
.6034 .22863 L
.6044 .22863 L
.60539 .22863 L
.60639 .22863 L
.60739 .22863 L
.60839 .22863 L
.60939 .22863 L
.61039 .22863 L
.61139 .22863 L
.61239 .22863 L
.61339 .22863 L
.61439 .22863 L
.61538 .22863 L
.61638 .22863 L
.61738 .22863 L
.61838 .22863 L
.61938 .22863 L
.62038 .22863 L
.62138 .22863 L
.62238 .22863 L
.62338 .22863 L
.62438 .22863 L
.62537 .22863 L
.62637 .22863 L
.62737 .22863 L
.62837 .22863 L
.62937 .22863 L
.63037 .22863 L
.63137 .22863 L
.63237 .22863 L
.63337 .22863 L
.63437 .22863 L
.63536 .22863 L
.63636 .22863 L
.63736 .22863 L
.63836 .22863 L
.63936 .22863 L
.64036 .22863 L
.64136 .22863 L
.64236 .22863 L
.64336 .22863 L
.64436 .22863 L
.64535 .22863 L
.64635 .22863 L
.64735 .22863 L
.64835 .22863 L
Mistroke
.64935 .21603 L
.65035 .21603 L
.65135 .21603 L
.65235 .21603 L
.65335 .21603 L
.65435 .21603 L
.65534 .21603 L
.65634 .21603 L
.65734 .21603 L
.65834 .21603 L
.65934 .21603 L
.66034 .21603 L
.66134 .21603 L
.66234 .21603 L
.66334 .21603 L
.66434 .21603 L
.66533 .21603 L
.66633 .21603 L
.66733 .21603 L
.66833 .21603 L
.66933 .21603 L
.67033 .21603 L
.67133 .21603 L
.67233 .21603 L
.67333 .21603 L
.67433 .21603 L
.67532 .21603 L
.67632 .21603 L
.67732 .21603 L
.67832 .21603 L
.67932 .21603 L
.68032 .21603 L
.68132 .21603 L
.68232 .21603 L
.68332 .21603 L
.68432 .21603 L
.68531 .21603 L
.68631 .21603 L
.68731 .21603 L
.68831 .21603 L
.68931 .21603 L
.69031 .21603 L
.69131 .21603 L
.69231 .21603 L
.69331 .21603 L
.69431 .21603 L
.6953 .21603 L
.6963 .21603 L
.6973 .21603 L
.6983 .21603 L
Mistroke
.6993 .19756 L
.7003 .19756 L
.7013 .19756 L
.7023 .19756 L
.7033 .19756 L
.7043 .19756 L
.70529 .19756 L
.70629 .19756 L
.70729 .19756 L
.70829 .19756 L
.70929 .19756 L
.71029 .19756 L
.71129 .19756 L
.71229 .19756 L
.71329 .19756 L
.71429 .19756 L
.71528 .19756 L
.71628 .19756 L
.71728 .19756 L
.71828 .19756 L
.71928 .19756 L
.72028 .19756 L
.72128 .19756 L
.72228 .19756 L
.72328 .19756 L
.72428 .19756 L
.72527 .19756 L
.72627 .19756 L
.72727 .19756 L
.72827 .19756 L
.72927 .19756 L
.73027 .19756 L
.73127 .19756 L
.73227 .19756 L
.73327 .19756 L
.73427 .19756 L
.73526 .19756 L
.73626 .19756 L
.73726 .19756 L
.73826 .19756 L
.73926 .19756 L
.74026 .19756 L
.74126 .19756 L
.74226 .19756 L
.74326 .19756 L
.74426 .19756 L
.74525 .19756 L
.74625 .19756 L
.74725 .19756 L
.74825 .19756 L
Mistroke
.74925 .15449 L
.75025 .15449 L
.75125 .15449 L
.75225 .15449 L
.75325 .15449 L
.75425 .15449 L
.75524 .15449 L
.75624 .15449 L
.75724 .15449 L
.75824 .15449 L
.75924 .15449 L
.76024 .15449 L
.76124 .15449 L
.76224 .15449 L
.76324 .15449 L
.76424 .15449 L
.76523 .15449 L
.76623 .15449 L
.76723 .15449 L
.76823 .15449 L
.76923 .15449 L
.77023 .15449 L
.77123 .15449 L
.77223 .15449 L
.77323 .15449 L
.77423 .15449 L
.77522 .15449 L
.77622 .15449 L
.77722 .15449 L
.77822 .15449 L
.77922 .15449 L
.78022 .15449 L
.78122 .15449 L
.78222 .15449 L
.78322 .15449 L
.78422 .15449 L
.78521 .15449 L
.78621 .15449 L
.78721 .15449 L
.78821 .15449 L
.78921 .15449 L
.79021 .15449 L
.79121 .15449 L
.79221 .15449 L
.79321 .15449 L
.79421 .15449 L
.7952 .15449 L
.7962 .15449 L
.7972 .15449 L
.7982 .15449 L
Mistroke
.7992 .22707 L
.8002 .22707 L
.8012 .22707 L
.8022 .22707 L
.8032 .22707 L
.8042 .22707 L
.80519 .22707 L
.80619 .22707 L
.80719 .22707 L
.80819 .22707 L
.80919 .22707 L
.81019 .22707 L
.81119 .22707 L
.81219 .22707 L
.81319 .22707 L
.81419 .22707 L
.81518 .22707 L
.81618 .22707 L
.81718 .22707 L
.81818 .22707 L
.81918 .22707 L
.82018 .22707 L
.82118 .22707 L
.82218 .22707 L
.82318 .22707 L
.82418 .22707 L
.82517 .22707 L
.82617 .22707 L
.82717 .22707 L
.82817 .22707 L
.82917 .22707 L
.83017 .22707 L
.83117 .22707 L
.83217 .22707 L
.83317 .22707 L
.83417 .22707 L
.83516 .22707 L
.83616 .22707 L
.83716 .22707 L
.83816 .22707 L
.83916 .22707 L
.84016 .22707 L
.84116 .22707 L
.84216 .22707 L
.84316 .22707 L
.84416 .22707 L
.84515 .22707 L
.84615 .22707 L
.84715 .22707 L
.84815 .22707 L
Mistroke
.84915 .21804 L
.85015 .21804 L
.85115 .21804 L
.85215 .21804 L
.85315 .21804 L
.85415 .21804 L
.85514 .21804 L
.85614 .21804 L
.85714 .21804 L
.85814 .21804 L
.85914 .21804 L
.86014 .21804 L
.86114 .21804 L
.86214 .21804 L
.86314 .21804 L
.86414 .21804 L
.86513 .21804 L
.86613 .21804 L
.86713 .21804 L
.86813 .21804 L
.86913 .21804 L
.87013 .21804 L
.87113 .21804 L
.87213 .21804 L
.87313 .21804 L
.87413 .21804 L
.87512 .21804 L
.87612 .21804 L
.87712 .21804 L
.87812 .21804 L
.87912 .21804 L
.88012 .21804 L
.88112 .21804 L
.88212 .21804 L
.88312 .21804 L
.88412 .21804 L
.88511 .21804 L
.88611 .21804 L
.88711 .21804 L
.88811 .21804 L
.88911 .21804 L
.89011 .21804 L
.89111 .21804 L
.89211 .21804 L
.89311 .21804 L
.89411 .21804 L
.8951 .21804 L
.8961 .21804 L
.8971 .21804 L
.8981 .21804 L
Mistroke
.8991 .22127 L
.9001 .22127 L
.9011 .22127 L
.9021 .22127 L
.9031 .22127 L
.9041 .22127 L
.90509 .22127 L
.90609 .22127 L
.90709 .22127 L
.90809 .22127 L
.90909 .22127 L
.91009 .22127 L
.91109 .22127 L
.91209 .22127 L
.91309 .22127 L
.91409 .22127 L
.91508 .22127 L
.91608 .22127 L
.91708 .22127 L
.91808 .22127 L
.91908 .22127 L
.92008 .22127 L
.92108 .22127 L
.92208 .22127 L
.92308 .22127 L
.92408 .22127 L
.92507 .22127 L
.92607 .22127 L
.92707 .22127 L
.92807 .22127 L
.92907 .22127 L
.93007 .22127 L
.93107 .22127 L
.93207 .22127 L
.93307 .22127 L
.93407 .22127 L
.93506 .22127 L
.93606 .22127 L
.93706 .22127 L
.93806 .22127 L
.93906 .22127 L
.94006 .22127 L
.94106 .22127 L
.94206 .22127 L
.94306 .22127 L
.94406 .22127 L
.94505 .22127 L
.94605 .22127 L
.94705 .22127 L
.94805 .22127 L
Mistroke
.94905 .23828 L
.95005 .23828 L
.95105 .23828 L
.95205 .23828 L
.95305 .23828 L
.95405 .23828 L
.95504 .23828 L
.95604 .23828 L
.95704 .23828 L
.95804 .23828 L
.95904 .23828 L
.96004 .23828 L
.96104 .23828 L
.96204 .23828 L
.96304 .23828 L
.96404 .23828 L
.96503 .23828 L
.96603 .23828 L
.96703 .23828 L
.96803 .23828 L
.96903 .23828 L
.97003 .23828 L
.97103 .23828 L
.97203 .23828 L
.97303 .23828 L
.97403 .23828 L
.97502 .23828 L
.97602 .23828 L
.97702 .23828 L
.97802 .23828 L
.97902 .23828 L
.98002 .23828 L
.98102 .23828 L
.98202 .23828 L
.98302 .23828 L
.98402 .23828 L
.98501 .23828 L
.98601 .23828 L
.98701 .23828 L
.98801 .23828 L
.98901 .23828 L
.99001 .23828 L
.99101 .23828 L
.99201 .23828 L
.99301 .23828 L
.99401 .23828 L
.995 .23828 L
.996 .23828 L
.997 .23828 L
.998 .23828 L
Mistroke
.999 .22371 L
Mfstroke
gsave
.999 .33395 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36835 m
.001 .36835 L
.002 .36835 L
.003 .36835 L
.004 .36835 L
.005 .36835 L
.00599 .36835 L
.00699 .36835 L
.00799 .36835 L
.00899 .36835 L
.00999 .36835 L
.01099 .36835 L
.01199 .36835 L
.01299 .36835 L
.01399 .36835 L
.01499 .36835 L
.01598 .36835 L
.01698 .36835 L
.01798 .36835 L
.01898 .36835 L
.01998 .36835 L
.02098 .36835 L
.02198 .36835 L
.02298 .36835 L
.02398 .36835 L
.02498 .36835 L
.02597 .36835 L
.02697 .36835 L
.02797 .36835 L
.02897 .36835 L
.02997 .36835 L
.03097 .36835 L
.03197 .36835 L
.03297 .36835 L
.03397 .36835 L
.03497 .36835 L
.03596 .36835 L
.03696 .36835 L
.03796 .36835 L
.03896 .36835 L
.03996 .36835 L
.04096 .36835 L
.04196 .36835 L
.04296 .36835 L
.04396 .36835 L
.04496 .36835 L
.04595 .36835 L
.04695 .36835 L
.04795 .36835 L
.04895 .36835 L
Mistroke
.04995 .3368 L
.05095 .3368 L
.05195 .3368 L
.05295 .3368 L
.05395 .3368 L
.05495 .3368 L
.05594 .3368 L
.05694 .3368 L
.05794 .3368 L
.05894 .3368 L
.05994 .3368 L
.06094 .3368 L
.06194 .3368 L
.06294 .3368 L
.06394 .3368 L
.06494 .3368 L
.06593 .3368 L
.06693 .3368 L
.06793 .3368 L
.06893 .3368 L
.06993 .3368 L
.07093 .3368 L
.07193 .3368 L
.07293 .3368 L
.07393 .3368 L
.07493 .3368 L
.07592 .3368 L
.07692 .3368 L
.07792 .3368 L
.07892 .3368 L
.07992 .3368 L
.08092 .3368 L
.08192 .3368 L
.08292 .3368 L
.08392 .3368 L
.08492 .3368 L
.08591 .3368 L
.08691 .3368 L
.08791 .3368 L
.08891 .3368 L
.08991 .3368 L
.09091 .3368 L
.09191 .3368 L
.09291 .3368 L
.09391 .3368 L
.09491 .3368 L
.0959 .3368 L
.0969 .3368 L
.0979 .3368 L
.0989 .3368 L
Mistroke
Mfstroke
.0989 .3368 m
.09971 .61803 L
s
.14948 .61803 m
.14985 .57967 L
.15085 .57967 L
.15185 .57967 L
.15285 .57967 L
.15385 .57967 L
.15485 .57967 L
.15584 .57967 L
.15684 .57967 L
.15784 .57967 L
.15884 .57967 L
.15984 .57967 L
.16084 .57967 L
.16184 .57967 L
.16284 .57967 L
.16384 .57967 L
.16484 .57967 L
.16583 .57967 L
.16683 .57967 L
.16783 .57967 L
.16883 .57967 L
.16983 .57967 L
.17083 .57967 L
.17183 .57967 L
.17283 .57967 L
.17383 .57967 L
.17483 .57967 L
.17582 .57967 L
.17682 .57967 L
.17782 .57967 L
.17882 .57967 L
.17982 .57967 L
.18082 .57967 L
.18182 .57967 L
.18282 .57967 L
.18382 .57967 L
.18482 .57967 L
.18581 .57967 L
.18681 .57967 L
.18781 .57967 L
.18881 .57967 L
.18981 .57967 L
.19081 .57967 L
.19181 .57967 L
.19281 .57967 L
.19381 .57967 L
.19481 .57967 L
.1958 .57967 L
.1968 .57967 L
.1978 .57967 L
Mistroke
.1988 .57967 L
.1998 .45377 L
.2008 .45377 L
.2018 .45377 L
.2028 .45377 L
.2038 .45377 L
.2048 .45377 L
.20579 .45377 L
.20679 .45377 L
.20779 .45377 L
.20879 .45377 L
.20979 .45377 L
.21079 .45377 L
.21179 .45377 L
.21279 .45377 L
.21379 .45377 L
.21479 .45377 L
.21578 .45377 L
.21678 .45377 L
.21778 .45377 L
.21878 .45377 L
.21978 .45377 L
.22078 .45377 L
.22178 .45377 L
.22278 .45377 L
.22378 .45377 L
.22478 .45377 L
.22577 .45377 L
.22677 .45377 L
.22777 .45377 L
.22877 .45377 L
.22977 .45377 L
.23077 .45377 L
.23177 .45377 L
.23277 .45377 L
.23377 .45377 L
.23477 .45377 L
.23576 .45377 L
.23676 .45377 L
.23776 .45377 L
.23876 .45377 L
.23976 .45377 L
.24076 .45377 L
.24176 .45377 L
.24276 .45377 L
.24376 .45377 L
.24476 .45377 L
.24575 .45377 L
.24675 .45377 L
.24775 .45377 L
Mistroke
.24875 .45377 L
.24975 .45786 L
.25075 .45786 L
.25175 .45786 L
.25275 .45786 L
.25375 .45786 L
.25475 .45786 L
.25574 .45786 L
.25674 .45786 L
.25774 .45786 L
.25874 .45786 L
.25974 .45786 L
.26074 .45786 L
.26174 .45786 L
.26274 .45786 L
.26374 .45786 L
.26474 .45786 L
.26573 .45786 L
.26673 .45786 L
.26773 .45786 L
.26873 .45786 L
.26973 .45786 L
.27073 .45786 L
.27173 .45786 L
.27273 .45786 L
.27373 .45786 L
.27473 .45786 L
.27572 .45786 L
.27672 .45786 L
.27772 .45786 L
.27872 .45786 L
.27972 .45786 L
.28072 .45786 L
.28172 .45786 L
.28272 .45786 L
.28372 .45786 L
.28472 .45786 L
.28571 .45786 L
.28671 .45786 L
.28771 .45786 L
.28871 .45786 L
.28971 .45786 L
.29071 .45786 L
.29171 .45786 L
.29271 .45786 L
.29371 .45786 L
.29471 .45786 L
.2957 .45786 L
.2967 .45786 L
.2977 .45786 L
Mistroke
.2987 .45786 L
.2997 .41751 L
.3007 .41751 L
.3017 .41751 L
.3027 .41751 L
.3037 .41751 L
.3047 .41751 L
.30569 .41751 L
.30669 .41751 L
.30769 .41751 L
.30869 .41751 L
.30969 .41751 L
.31069 .41751 L
.31169 .41751 L
.31269 .41751 L
.31369 .41751 L
.31469 .41751 L
.31568 .41751 L
.31668 .41751 L
.31768 .41751 L
.31868 .41751 L
.31968 .41751 L
.32068 .41751 L
.32168 .41751 L
.32268 .41751 L
.32368 .41751 L
.32468 .41751 L
.32567 .41751 L
.32667 .41751 L
.32767 .41751 L
.32867 .41751 L
.32967 .41751 L
.33067 .41751 L
.33167 .41751 L
.33267 .41751 L
.33367 .41751 L
.33467 .41751 L
.33566 .41751 L
.33666 .41751 L
.33766 .41751 L
.33866 .41751 L
.33966 .41751 L
.34066 .41751 L
.34166 .41751 L
.34266 .41751 L
.34366 .41751 L
.34466 .41751 L
.34565 .41751 L
.34665 .41751 L
.34765 .41751 L
Mistroke
.34865 .41751 L
.34965 .39215 L
.35065 .39215 L
.35165 .39215 L
.35265 .39215 L
.35365 .39215 L
.35465 .39215 L
.35564 .39215 L
.35664 .39215 L
.35764 .39215 L
.35864 .39215 L
.35964 .39215 L
.36064 .39215 L
.36164 .39215 L
.36264 .39215 L
.36364 .39215 L
.36464 .39215 L
.36563 .39215 L
.36663 .39215 L
.36763 .39215 L
.36863 .39215 L
.36963 .39215 L
.37063 .39215 L
.37163 .39215 L
.37263 .39215 L
.37363 .39215 L
.37463 .39215 L
.37562 .39215 L
.37662 .39215 L
.37762 .39215 L
.37862 .39215 L
.37962 .39215 L
.38062 .39215 L
.38162 .39215 L
.38262 .39215 L
.38362 .39215 L
.38462 .39215 L
.38561 .39215 L
.38661 .39215 L
.38761 .39215 L
.38861 .39215 L
.38961 .39215 L
.39061 .39215 L
.39161 .39215 L
.39261 .39215 L
.39361 .39215 L
.39461 .39215 L
.3956 .39215 L
.3966 .39215 L
.3976 .39215 L
Mistroke
.3986 .39215 L
.3996 .41562 L
.4006 .41562 L
.4016 .41562 L
.4026 .41562 L
.4036 .41562 L
.4046 .41562 L
.40559 .41562 L
.40659 .41562 L
.40759 .41562 L
.40859 .41562 L
.40959 .41562 L
.41059 .41562 L
.41159 .41562 L
.41259 .41562 L
.41359 .41562 L
.41459 .41562 L
.41558 .41562 L
.41658 .41562 L
.41758 .41562 L
.41858 .41562 L
.41958 .41562 L
.42058 .41562 L
.42158 .41562 L
.42258 .41562 L
.42358 .41562 L
.42458 .41562 L
.42557 .41562 L
.42657 .41562 L
.42757 .41562 L
.42857 .41562 L
.42957 .41562 L
.43057 .41562 L
.43157 .41562 L
.43257 .41562 L
.43357 .41562 L
.43457 .41562 L
.43556 .41562 L
.43656 .41562 L
.43756 .41562 L
.43856 .41562 L
.43956 .41562 L
.44056 .41562 L
.44156 .41562 L
.44256 .41562 L
.44356 .41562 L
.44456 .41562 L
.44555 .41562 L
.44655 .41562 L
.44755 .41562 L
Mistroke
.44855 .41562 L
.44955 .39184 L
.45055 .39184 L
.45155 .39184 L
.45255 .39184 L
.45355 .39184 L
.45455 .39184 L
.45554 .39184 L
.45654 .39184 L
.45754 .39184 L
.45854 .39184 L
.45954 .39184 L
.46054 .39184 L
.46154 .39184 L
.46254 .39184 L
.46354 .39184 L
.46454 .39184 L
.46553 .39184 L
.46653 .39184 L
.46753 .39184 L
.46853 .39184 L
.46953 .39184 L
.47053 .39184 L
.47153 .39184 L
.47253 .39184 L
.47353 .39184 L
.47453 .39184 L
.47552 .39184 L
.47652 .39184 L
.47752 .39184 L
.47852 .39184 L
.47952 .39184 L
.48052 .39184 L
.48152 .39184 L
.48252 .39184 L
.48352 .39184 L
.48452 .39184 L
.48551 .39184 L
.48651 .39184 L
.48751 .39184 L
.48851 .39184 L
.48951 .39184 L
.49051 .39184 L
.49151 .39184 L
.49251 .39184 L
.49351 .39184 L
.49451 .39184 L
.4955 .39184 L
.4965 .39184 L
.4975 .39184 L
Mistroke
.4985 .39184 L
.4995 .38875 L
.5005 .38875 L
.5015 .38875 L
.5025 .38875 L
.5035 .38875 L
.5045 .38875 L
.50549 .38875 L
.50649 .38875 L
.50749 .38875 L
.50849 .38875 L
.50949 .38875 L
.51049 .38875 L
.51149 .38875 L
.51249 .38875 L
.51349 .38875 L
.51449 .38875 L
.51548 .38875 L
.51648 .38875 L
.51748 .38875 L
.51848 .38875 L
.51948 .38875 L
.52048 .38875 L
.52148 .38875 L
.52248 .38875 L
.52348 .38875 L
.52448 .38875 L
.52547 .38875 L
.52647 .38875 L
.52747 .38875 L
.52847 .38875 L
.52947 .38875 L
.53047 .38875 L
.53147 .38875 L
.53247 .38875 L
.53347 .38875 L
.53447 .38875 L
.53546 .38875 L
.53646 .38875 L
.53746 .38875 L
.53846 .38875 L
.53946 .38875 L
.54046 .38875 L
.54146 .38875 L
.54246 .38875 L
.54346 .38875 L
.54446 .38875 L
.54545 .38875 L
.54645 .38875 L
.54745 .38875 L
Mistroke
.54845 .38875 L
.54945 .38359 L
.55045 .38359 L
.55145 .38359 L
.55245 .38359 L
.55345 .38359 L
.55445 .38359 L
.55544 .38359 L
.55644 .38359 L
.55744 .38359 L
.55844 .38359 L
.55944 .38359 L
.56044 .38359 L
.56144 .38359 L
.56244 .38359 L
.56344 .38359 L
.56444 .38359 L
.56543 .38359 L
.56643 .38359 L
.56743 .38359 L
.56843 .38359 L
.56943 .38359 L
.57043 .38359 L
.57143 .38359 L
.57243 .38359 L
.57343 .38359 L
.57443 .38359 L
.57542 .38359 L
.57642 .38359 L
.57742 .38359 L
.57842 .38359 L
.57942 .38359 L
.58042 .38359 L
.58142 .38359 L
.58242 .38359 L
.58342 .38359 L
.58442 .38359 L
.58541 .38359 L
.58641 .38359 L
.58741 .38359 L
.58841 .38359 L
.58941 .38359 L
.59041 .38359 L
.59141 .38359 L
.59241 .38359 L
.59341 .38359 L
.59441 .38359 L
.5954 .38359 L
.5964 .38359 L
.5974 .38359 L
Mistroke
.5984 .38359 L
.5994 .36175 L
.6004 .36175 L
.6014 .36175 L
.6024 .36175 L
.6034 .36175 L
.6044 .36175 L
.60539 .36175 L
.60639 .36175 L
.60739 .36175 L
.60839 .36175 L
.60939 .36175 L
.61039 .36175 L
.61139 .36175 L
.61239 .36175 L
.61339 .36175 L
.61439 .36175 L
.61538 .36175 L
.61638 .36175 L
.61738 .36175 L
.61838 .36175 L
.61938 .36175 L
.62038 .36175 L
.62138 .36175 L
.62238 .36175 L
.62338 .36175 L
.62438 .36175 L
.62537 .36175 L
.62637 .36175 L
.62737 .36175 L
.62837 .36175 L
.62937 .36175 L
.63037 .36175 L
.63137 .36175 L
.63237 .36175 L
.63337 .36175 L
.63437 .36175 L
.63536 .36175 L
.63636 .36175 L
.63736 .36175 L
.63836 .36175 L
.63936 .36175 L
.64036 .36175 L
.64136 .36175 L
.64236 .36175 L
.64336 .36175 L
.64436 .36175 L
.64535 .36175 L
.64635 .36175 L
.64735 .36175 L
Mistroke
.64835 .36175 L
.64935 .34687 L
.65035 .34687 L
.65135 .34687 L
.65235 .34687 L
.65335 .34687 L
.65435 .34687 L
.65534 .34687 L
.65634 .34687 L
.65734 .34687 L
.65834 .34687 L
.65934 .34687 L
.66034 .34687 L
.66134 .34687 L
.66234 .34687 L
.66334 .34687 L
.66434 .34687 L
.66533 .34687 L
.66633 .34687 L
.66733 .34687 L
.66833 .34687 L
.66933 .34687 L
.67033 .34687 L
.67133 .34687 L
.67233 .34687 L
.67333 .34687 L
.67433 .34687 L
.67532 .34687 L
.67632 .34687 L
.67732 .34687 L
.67832 .34687 L
.67932 .34687 L
.68032 .34687 L
.68132 .34687 L
.68232 .34687 L
.68332 .34687 L
.68432 .34687 L
.68531 .34687 L
.68631 .34687 L
.68731 .34687 L
.68831 .34687 L
.68931 .34687 L
.69031 .34687 L
.69131 .34687 L
.69231 .34687 L
.69331 .34687 L
.69431 .34687 L
.6953 .34687 L
.6963 .34687 L
.6973 .34687 L
Mistroke
.6983 .34687 L
.6993 .32523 L
.7003 .32523 L
.7013 .32523 L
.7023 .32523 L
.7033 .32523 L
.7043 .32523 L
.70529 .32523 L
.70629 .32523 L
.70729 .32523 L
.70829 .32523 L
.70929 .32523 L
.71029 .32523 L
.71129 .32523 L
.71229 .32523 L
.71329 .32523 L
.71429 .32523 L
.71528 .32523 L
.71628 .32523 L
.71728 .32523 L
.71828 .32523 L
.71928 .32523 L
.72028 .32523 L
.72128 .32523 L
.72228 .32523 L
.72328 .32523 L
.72428 .32523 L
.72527 .32523 L
.72627 .32523 L
.72727 .32523 L
.72827 .32523 L
.72927 .32523 L
.73027 .32523 L
.73127 .32523 L
.73227 .32523 L
.73327 .32523 L
.73427 .32523 L
.73526 .32523 L
.73626 .32523 L
.73726 .32523 L
.73826 .32523 L
.73926 .32523 L
.74026 .32523 L
.74126 .32523 L
.74226 .32523 L
.74326 .32523 L
.74426 .32523 L
.74525 .32523 L
.74625 .32523 L
.74725 .32523 L
Mistroke
.74825 .32523 L
.74925 .27625 L
.75025 .27625 L
.75125 .27625 L
.75225 .27625 L
.75325 .27625 L
.75425 .27625 L
.75524 .27625 L
.75624 .27625 L
.75724 .27625 L
.75824 .27625 L
.75924 .27625 L
.76024 .27625 L
.76124 .27625 L
.76224 .27625 L
.76324 .27625 L
.76424 .27625 L
.76523 .27625 L
.76623 .27625 L
.76723 .27625 L
.76823 .27625 L
.76923 .27625 L
.77023 .27625 L
.77123 .27625 L
.77223 .27625 L
.77323 .27625 L
.77423 .27625 L
.77522 .27625 L
.77622 .27625 L
.77722 .27625 L
.77822 .27625 L
.77922 .27625 L
.78022 .27625 L
.78122 .27625 L
.78222 .27625 L
.78322 .27625 L
.78422 .27625 L
.78521 .27625 L
.78621 .27625 L
.78721 .27625 L
.78821 .27625 L
.78921 .27625 L
.79021 .27625 L
.79121 .27625 L
.79221 .27625 L
.79321 .27625 L
.79421 .27625 L
.7952 .27625 L
.7962 .27625 L
.7972 .27625 L
Mistroke
.7982 .27625 L
.7992 .34575 L
.8002 .34575 L
.8012 .34575 L
.8022 .34575 L
.8032 .34575 L
.8042 .34575 L
.80519 .34575 L
.80619 .34575 L
.80719 .34575 L
.80819 .34575 L
.80919 .34575 L
.81019 .34575 L
.81119 .34575 L
.81219 .34575 L
.81319 .34575 L
.81419 .34575 L
.81518 .34575 L
.81618 .34575 L
.81718 .34575 L
.81818 .34575 L
.81918 .34575 L
.82018 .34575 L
.82118 .34575 L
.82218 .34575 L
.82318 .34575 L
.82418 .34575 L
.82517 .34575 L
.82617 .34575 L
.82717 .34575 L
.82817 .34575 L
.82917 .34575 L
.83017 .34575 L
.83117 .34575 L
.83217 .34575 L
.83317 .34575 L
.83417 .34575 L
.83516 .34575 L
.83616 .34575 L
.83716 .34575 L
.83816 .34575 L
.83916 .34575 L
.84016 .34575 L
.84116 .34575 L
.84216 .34575 L
.84316 .34575 L
.84416 .34575 L
.84515 .34575 L
.84615 .34575 L
.84715 .34575 L
Mistroke
.84815 .34575 L
.84915 .33226 L
.85015 .33226 L
.85115 .33226 L
.85215 .33226 L
.85315 .33226 L
.85415 .33226 L
.85514 .33226 L
.85614 .33226 L
.85714 .33226 L
.85814 .33226 L
.85914 .33226 L
.86014 .33226 L
.86114 .33226 L
.86214 .33226 L
.86314 .33226 L
.86414 .33226 L
.86513 .33226 L
.86613 .33226 L
.86713 .33226 L
.86813 .33226 L
.86913 .33226 L
.87013 .33226 L
.87113 .33226 L
.87213 .33226 L
.87313 .33226 L
.87413 .33226 L
.87512 .33226 L
.87612 .33226 L
.87712 .33226 L
.87812 .33226 L
.87912 .33226 L
.88012 .33226 L
.88112 .33226 L
.88212 .33226 L
.88312 .33226 L
.88412 .33226 L
.88511 .33226 L
.88611 .33226 L
.88711 .33226 L
.88811 .33226 L
.88911 .33226 L
.89011 .33226 L
.89111 .33226 L
.89211 .33226 L
.89311 .33226 L
.89411 .33226 L
.8951 .33226 L
.8961 .33226 L
.8971 .33226 L
Mistroke
.8981 .33226 L
.8991 .33487 L
.9001 .33487 L
.9011 .33487 L
.9021 .33487 L
.9031 .33487 L
.9041 .33487 L
.90509 .33487 L
.90609 .33487 L
.90709 .33487 L
.90809 .33487 L
.90909 .33487 L
.91009 .33487 L
.91109 .33487 L
.91209 .33487 L
.91309 .33487 L
.91409 .33487 L
.91508 .33487 L
.91608 .33487 L
.91708 .33487 L
.91808 .33487 L
.91908 .33487 L
.92008 .33487 L
.92108 .33487 L
.92208 .33487 L
.92308 .33487 L
.92408 .33487 L
.92507 .33487 L
.92607 .33487 L
.92707 .33487 L
.92807 .33487 L
.92907 .33487 L
.93007 .33487 L
.93107 .33487 L
.93207 .33487 L
.93307 .33487 L
.93407 .33487 L
.93506 .33487 L
.93606 .33487 L
.93706 .33487 L
.93806 .33487 L
.93906 .33487 L
.94006 .33487 L
.94106 .33487 L
.94206 .33487 L
.94306 .33487 L
.94406 .33487 L
.94505 .33487 L
.94605 .33487 L
.94705 .33487 L
Mistroke
.94805 .33487 L
.94905 .34956 L
.95005 .34956 L
.95105 .34956 L
.95205 .34956 L
.95305 .34956 L
.95405 .34956 L
.95504 .34956 L
.95604 .34956 L
.95704 .34956 L
.95804 .34956 L
.95904 .34956 L
.96004 .34956 L
.96104 .34956 L
.96204 .34956 L
.96304 .34956 L
.96404 .34956 L
.96503 .34956 L
.96603 .34956 L
.96703 .34956 L
.96803 .34956 L
.96903 .34956 L
.97003 .34956 L
.97103 .34956 L
.97203 .34956 L
.97303 .34956 L
.97403 .34956 L
.97502 .34956 L
.97602 .34956 L
.97702 .34956 L
.97802 .34956 L
.97902 .34956 L
.98002 .34956 L
.98102 .34956 L
.98202 .34956 L
.98302 .34956 L
.98402 .34956 L
.98501 .34956 L
.98601 .34956 L
.98701 .34956 L
.98801 .34956 L
.98901 .34956 L
.99001 .34956 L
.99101 .34956 L
.99201 .34956 L
.99301 .34956 L
.99401 .34956 L
.995 .34956 L
.996 .34956 L
.997 .34956 L
Mistroke
.998 .34956 L
.999 .33395 L
Mfstroke
1 0 0 r
gsave
.999 .27883 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24721 m
.001 .24721 L
.002 .24721 L
.003 .24721 L
.004 .24721 L
.005 .24721 L
.00599 .24721 L
.00699 .24721 L
.00799 .24721 L
.00899 .24721 L
.00999 .24721 L
.01099 .24721 L
.01199 .24721 L
.01299 .24721 L
.01399 .24721 L
.01499 .24721 L
.01598 .24721 L
.01698 .24721 L
.01798 .24721 L
.01898 .24721 L
.01998 .24721 L
.02098 .24721 L
.02198 .24721 L
.02298 .24721 L
.02398 .24721 L
.02498 .24721 L
.02597 .24721 L
.02697 .24721 L
.02797 .24721 L
.02897 .24721 L
.02997 .24721 L
.03097 .24721 L
.03197 .24721 L
.03297 .24721 L
.03397 .24721 L
.03497 .24721 L
.03596 .24721 L
.03696 .24721 L
.03796 .24721 L
.03896 .24721 L
.03996 .24721 L
.04096 .24721 L
.04196 .24721 L
.04296 .24721 L
.04396 .24721 L
.04496 .24721 L
.04595 .24721 L
.04695 .24721 L
.04795 .24721 L
.04895 .24721 L
Mistroke
.04995 .21579 L
.05095 .21579 L
.05195 .21579 L
.05295 .21579 L
.05395 .21579 L
.05495 .21579 L
.05594 .21579 L
.05694 .21579 L
.05794 .21579 L
.05894 .21579 L
.05994 .21579 L
.06094 .21579 L
.06194 .21579 L
.06294 .21579 L
.06394 .21579 L
.06494 .21579 L
.06593 .21579 L
.06693 .21579 L
.06793 .21579 L
.06893 .21579 L
.06993 .21579 L
.07093 .21579 L
.07193 .21579 L
.07293 .21579 L
.07393 .21579 L
.07493 .21579 L
.07592 .21579 L
.07692 .21579 L
.07792 .21579 L
.07892 .21579 L
.07992 .21579 L
.08092 .21579 L
.08192 .21579 L
.08292 .21579 L
.08392 .21579 L
.08492 .21579 L
.08591 .21579 L
.08691 .21579 L
.08791 .21579 L
.08891 .21579 L
.08991 .21579 L
.09091 .21579 L
.09191 .21579 L
.09291 .21579 L
.09391 .21579 L
.09491 .21579 L
.0959 .21579 L
.0969 .21579 L
.0979 .21579 L
.0989 .21579 L
Mistroke
.0999 .58034 L
.1009 .58034 L
.1019 .58034 L
.1029 .58034 L
.1039 .58034 L
.1049 .58034 L
.10589 .58034 L
.10689 .58034 L
.10789 .58034 L
.10889 .58034 L
.10989 .58034 L
.11089 .58034 L
.11189 .58034 L
.11289 .58034 L
.11389 .58034 L
.11489 .58034 L
.11588 .58034 L
.11688 .58034 L
.11788 .58034 L
.11888 .58034 L
.11988 .58034 L
.12088 .58034 L
.12188 .58034 L
.12288 .58034 L
.12388 .58034 L
.12488 .58034 L
.12587 .58034 L
.12687 .58034 L
.12787 .58034 L
.12887 .58034 L
.12987 .58034 L
.13087 .58034 L
.13187 .58034 L
.13287 .58034 L
.13387 .58034 L
.13487 .58034 L
.13586 .58034 L
.13686 .58034 L
.13786 .58034 L
.13886 .58034 L
.13986 .58034 L
.14086 .58034 L
.14186 .58034 L
.14286 .58034 L
.14386 .58034 L
.14486 .58034 L
.14585 .58034 L
.14685 .58034 L
.14785 .58034 L
.14885 .58034 L
Mistroke
.14985 .47788 L
.15085 .47788 L
.15185 .47788 L
.15285 .47788 L
.15385 .47788 L
.15485 .47788 L
.15584 .47788 L
.15684 .47788 L
.15784 .47788 L
.15884 .47788 L
.15984 .47788 L
.16084 .47788 L
.16184 .47788 L
.16284 .47788 L
.16384 .47788 L
.16484 .47788 L
.16583 .47788 L
.16683 .47788 L
.16783 .47788 L
.16883 .47788 L
.16983 .47788 L
.17083 .47788 L
.17183 .47788 L
.17283 .47788 L
.17383 .47788 L
.17483 .47788 L
.17582 .47788 L
.17682 .47788 L
.17782 .47788 L
.17882 .47788 L
.17982 .47788 L
.18082 .47788 L
.18182 .47788 L
.18282 .47788 L
.18382 .47788 L
.18482 .47788 L
.18581 .47788 L
.18681 .47788 L
.18781 .47788 L
.18881 .47788 L
.18981 .47788 L
.19081 .47788 L
.19181 .47788 L
.19281 .47788 L
.19381 .47788 L
.19481 .47788 L
.1958 .47788 L
.1968 .47788 L
.1978 .47788 L
.1988 .47788 L
Mistroke
.1998 .36451 L
.2008 .36451 L
.2018 .36451 L
.2028 .36451 L
.2038 .36451 L
.2048 .36451 L
.20579 .36451 L
.20679 .36451 L
.20779 .36451 L
.20879 .36451 L
.20979 .36451 L
.21079 .36451 L
.21179 .36451 L
.21279 .36451 L
.21379 .36451 L
.21479 .36451 L
.21578 .36451 L
.21678 .36451 L
.21778 .36451 L
.21878 .36451 L
.21978 .36451 L
.22078 .36451 L
.22178 .36451 L
.22278 .36451 L
.22378 .36451 L
.22478 .36451 L
.22577 .36451 L
.22677 .36451 L
.22777 .36451 L
.22877 .36451 L
.22977 .36451 L
.23077 .36451 L
.23177 .36451 L
.23277 .36451 L
.23377 .36451 L
.23477 .36451 L
.23576 .36451 L
.23676 .36451 L
.23776 .36451 L
.23876 .36451 L
.23976 .36451 L
.24076 .36451 L
.24176 .36451 L
.24276 .36451 L
.24376 .36451 L
.24476 .36451 L
.24575 .36451 L
.24675 .36451 L
.24775 .36451 L
.24875 .36451 L
Mistroke
.24975 .37533 L
.25075 .37533 L
.25175 .37533 L
.25275 .37533 L
.25375 .37533 L
.25475 .37533 L
.25574 .37533 L
.25674 .37533 L
.25774 .37533 L
.25874 .37533 L
.25974 .37533 L
.26074 .37533 L
.26174 .37533 L
.26274 .37533 L
.26374 .37533 L
.26474 .37533 L
.26573 .37533 L
.26673 .37533 L
.26773 .37533 L
.26873 .37533 L
.26973 .37533 L
.27073 .37533 L
.27173 .37533 L
.27273 .37533 L
.27373 .37533 L
.27473 .37533 L
.27572 .37533 L
.27672 .37533 L
.27772 .37533 L
.27872 .37533 L
.27972 .37533 L
.28072 .37533 L
.28172 .37533 L
.28272 .37533 L
.28372 .37533 L
.28472 .37533 L
.28571 .37533 L
.28671 .37533 L
.28771 .37533 L
.28871 .37533 L
.28971 .37533 L
.29071 .37533 L
.29171 .37533 L
.29271 .37533 L
.29371 .37533 L
.29471 .37533 L
.2957 .37533 L
.2967 .37533 L
.2977 .37533 L
.2987 .37533 L
Mistroke
.2997 .34095 L
.3007 .34095 L
.3017 .34095 L
.3027 .34095 L
.3037 .34095 L
.3047 .34095 L
.30569 .34095 L
.30669 .34095 L
.30769 .34095 L
.30869 .34095 L
.30969 .34095 L
.31069 .34095 L
.31169 .34095 L
.31269 .34095 L
.31369 .34095 L
.31469 .34095 L
.31568 .34095 L
.31668 .34095 L
.31768 .34095 L
.31868 .34095 L
.31968 .34095 L
.32068 .34095 L
.32168 .34095 L
.32268 .34095 L
.32368 .34095 L
.32468 .34095 L
.32567 .34095 L
.32667 .34095 L
.32767 .34095 L
.32867 .34095 L
.32967 .34095 L
.33067 .34095 L
.33167 .34095 L
.33267 .34095 L
.33367 .34095 L
.33467 .34095 L
.33566 .34095 L
.33666 .34095 L
.33766 .34095 L
.33866 .34095 L
.33966 .34095 L
.34066 .34095 L
.34166 .34095 L
.34266 .34095 L
.34366 .34095 L
.34466 .34095 L
.34565 .34095 L
.34665 .34095 L
.34765 .34095 L
.34865 .34095 L
Mistroke
.34965 .31903 L
.35065 .31903 L
.35165 .31903 L
.35265 .31903 L
.35365 .31903 L
.35465 .31903 L
.35564 .31903 L
.35664 .31903 L
.35764 .31903 L
.35864 .31903 L
.35964 .31903 L
.36064 .31903 L
.36164 .31903 L
.36264 .31903 L
.36364 .31903 L
.36464 .31903 L
.36563 .31903 L
.36663 .31903 L
.36763 .31903 L
.36863 .31903 L
.36963 .31903 L
.37063 .31903 L
.37163 .31903 L
.37263 .31903 L
.37363 .31903 L
.37463 .31903 L
.37562 .31903 L
.37662 .31903 L
.37762 .31903 L
.37862 .31903 L
.37962 .31903 L
.38062 .31903 L
.38162 .31903 L
.38262 .31903 L
.38362 .31903 L
.38462 .31903 L
.38561 .31903 L
.38661 .31903 L
.38761 .31903 L
.38861 .31903 L
.38961 .31903 L
.39061 .31903 L
.39161 .31903 L
.39261 .31903 L
.39361 .31903 L
.39461 .31903 L
.3956 .31903 L
.3966 .31903 L
.3976 .31903 L
.3986 .31903 L
Mistroke
.3996 .34321 L
.4006 .34321 L
.4016 .34321 L
.4026 .34321 L
.4036 .34321 L
.4046 .34321 L
.40559 .34321 L
.40659 .34321 L
.40759 .34321 L
.40859 .34321 L
.40959 .34321 L
.41059 .34321 L
.41159 .34321 L
.41259 .34321 L
.41359 .34321 L
.41459 .34321 L
.41558 .34321 L
.41658 .34321 L
.41758 .34321 L
.41858 .34321 L
.41958 .34321 L
.42058 .34321 L
.42158 .34321 L
.42258 .34321 L
.42358 .34321 L
.42458 .34321 L
.42557 .34321 L
.42657 .34321 L
.42757 .34321 L
.42857 .34321 L
.42957 .34321 L
.43057 .34321 L
.43157 .34321 L
.43257 .34321 L
.43357 .34321 L
.43457 .34321 L
.43556 .34321 L
.43656 .34321 L
.43756 .34321 L
.43856 .34321 L
.43956 .34321 L
.44056 .34321 L
.44156 .34321 L
.44256 .34321 L
.44356 .34321 L
.44456 .34321 L
.44555 .34321 L
.44655 .34321 L
.44755 .34321 L
.44855 .34321 L
Mistroke
.44955 .32055 L
.45055 .32055 L
.45155 .32055 L
.45255 .32055 L
.45355 .32055 L
.45455 .32055 L
.45554 .32055 L
.45654 .32055 L
.45754 .32055 L
.45854 .32055 L
.45954 .32055 L
.46054 .32055 L
.46154 .32055 L
.46254 .32055 L
.46354 .32055 L
.46454 .32055 L
.46553 .32055 L
.46653 .32055 L
.46753 .32055 L
.46853 .32055 L
.46953 .32055 L
.47053 .32055 L
.47153 .32055 L
.47253 .32055 L
.47353 .32055 L
.47453 .32055 L
.47552 .32055 L
.47652 .32055 L
.47752 .32055 L
.47852 .32055 L
.47952 .32055 L
.48052 .32055 L
.48152 .32055 L
.48252 .32055 L
.48352 .32055 L
.48452 .32055 L
.48551 .32055 L
.48651 .32055 L
.48751 .32055 L
.48851 .32055 L
.48951 .32055 L
.49051 .32055 L
.49151 .32055 L
.49251 .32055 L
.49351 .32055 L
.49451 .32055 L
.4955 .32055 L
.4965 .32055 L
.4975 .32055 L
.4985 .32055 L
Mistroke
.4995 .31944 L
.5005 .31944 L
.5015 .31944 L
.5025 .31944 L
.5035 .31944 L
.5045 .31944 L
.50549 .31944 L
.50649 .31944 L
.50749 .31944 L
.50849 .31944 L
.50949 .31944 L
.51049 .31944 L
.51149 .31944 L
.51249 .31944 L
.51349 .31944 L
.51449 .31944 L
.51548 .31944 L
.51648 .31944 L
.51748 .31944 L
.51848 .31944 L
.51948 .31944 L
.52048 .31944 L
.52148 .31944 L
.52248 .31944 L
.52348 .31944 L
.52448 .31944 L
.52547 .31944 L
.52647 .31944 L
.52747 .31944 L
.52847 .31944 L
.52947 .31944 L
.53047 .31944 L
.53147 .31944 L
.53247 .31944 L
.53347 .31944 L
.53447 .31944 L
.53546 .31944 L
.53646 .31944 L
.53746 .31944 L
.53846 .31944 L
.53946 .31944 L
.54046 .31944 L
.54146 .31944 L
.54246 .31944 L
.54346 .31944 L
.54446 .31944 L
.54545 .31944 L
.54645 .31944 L
.54745 .31944 L
.54845 .31944 L
Mistroke
.54945 .31632 L
.55045 .31632 L
.55145 .31632 L
.55245 .31632 L
.55345 .31632 L
.55445 .31632 L
.55544 .31632 L
.55644 .31632 L
.55744 .31632 L
.55844 .31632 L
.55944 .31632 L
.56044 .31632 L
.56144 .31632 L
.56244 .31632 L
.56344 .31632 L
.56444 .31632 L
.56543 .31632 L
.56643 .31632 L
.56743 .31632 L
.56843 .31632 L
.56943 .31632 L
.57043 .31632 L
.57143 .31632 L
.57243 .31632 L
.57343 .31632 L
.57443 .31632 L
.57542 .31632 L
.57642 .31632 L
.57742 .31632 L
.57842 .31632 L
.57942 .31632 L
.58042 .31632 L
.58142 .31632 L
.58242 .31632 L
.58342 .31632 L
.58442 .31632 L
.58541 .31632 L
.58641 .31632 L
.58741 .31632 L
.58841 .31632 L
.58941 .31632 L
.59041 .31632 L
.59141 .31632 L
.59241 .31632 L
.59341 .31632 L
.59441 .31632 L
.5954 .31632 L
.5964 .31632 L
.5974 .31632 L
.5984 .31632 L
Mistroke
.5994 .29519 L
.6004 .29519 L
.6014 .29519 L
.6024 .29519 L
.6034 .29519 L
.6044 .29519 L
.60539 .29519 L
.60639 .29519 L
.60739 .29519 L
.60839 .29519 L
.60939 .29519 L
.61039 .29519 L
.61139 .29519 L
.61239 .29519 L
.61339 .29519 L
.61439 .29519 L
.61538 .29519 L
.61638 .29519 L
.61738 .29519 L
.61838 .29519 L
.61938 .29519 L
.62038 .29519 L
.62138 .29519 L
.62238 .29519 L
.62338 .29519 L
.62438 .29519 L
.62537 .29519 L
.62637 .29519 L
.62737 .29519 L
.62837 .29519 L
.62937 .29519 L
.63037 .29519 L
.63137 .29519 L
.63237 .29519 L
.63337 .29519 L
.63437 .29519 L
.63536 .29519 L
.63636 .29519 L
.63736 .29519 L
.63836 .29519 L
.63936 .29519 L
.64036 .29519 L
.64136 .29519 L
.64236 .29519 L
.64336 .29519 L
.64436 .29519 L
.64535 .29519 L
.64635 .29519 L
.64735 .29519 L
.64835 .29519 L
Mistroke
.64935 .28145 L
.65035 .28145 L
.65135 .28145 L
.65235 .28145 L
.65335 .28145 L
.65435 .28145 L
.65534 .28145 L
.65634 .28145 L
.65734 .28145 L
.65834 .28145 L
.65934 .28145 L
.66034 .28145 L
.66134 .28145 L
.66234 .28145 L
.66334 .28145 L
.66434 .28145 L
.66533 .28145 L
.66633 .28145 L
.66733 .28145 L
.66833 .28145 L
.66933 .28145 L
.67033 .28145 L
.67133 .28145 L
.67233 .28145 L
.67333 .28145 L
.67433 .28145 L
.67532 .28145 L
.67632 .28145 L
.67732 .28145 L
.67832 .28145 L
.67932 .28145 L
.68032 .28145 L
.68132 .28145 L
.68232 .28145 L
.68332 .28145 L
.68432 .28145 L
.68531 .28145 L
.68631 .28145 L
.68731 .28145 L
.68831 .28145 L
.68931 .28145 L
.69031 .28145 L
.69131 .28145 L
.69231 .28145 L
.69331 .28145 L
.69431 .28145 L
.6953 .28145 L
.6963 .28145 L
.6973 .28145 L
.6983 .28145 L
Mistroke
.6993 .2614 L
.7003 .2614 L
.7013 .2614 L
.7023 .2614 L
.7033 .2614 L
.7043 .2614 L
.70529 .2614 L
.70629 .2614 L
.70729 .2614 L
.70829 .2614 L
.70929 .2614 L
.71029 .2614 L
.71129 .2614 L
.71229 .2614 L
.71329 .2614 L
.71429 .2614 L
.71528 .2614 L
.71628 .2614 L
.71728 .2614 L
.71828 .2614 L
.71928 .2614 L
.72028 .2614 L
.72128 .2614 L
.72228 .2614 L
.72328 .2614 L
.72428 .2614 L
.72527 .2614 L
.72627 .2614 L
.72727 .2614 L
.72827 .2614 L
.72927 .2614 L
.73027 .2614 L
.73127 .2614 L
.73227 .2614 L
.73327 .2614 L
.73427 .2614 L
.73526 .2614 L
.73626 .2614 L
.73726 .2614 L
.73826 .2614 L
.73926 .2614 L
.74026 .2614 L
.74126 .2614 L
.74226 .2614 L
.74326 .2614 L
.74426 .2614 L
.74525 .2614 L
.74625 .2614 L
.74725 .2614 L
.74825 .2614 L
Mistroke
.74925 .21537 L
.75025 .21537 L
.75125 .21537 L
.75225 .21537 L
.75325 .21537 L
.75425 .21537 L
.75524 .21537 L
.75624 .21537 L
.75724 .21537 L
.75824 .21537 L
.75924 .21537 L
.76024 .21537 L
.76124 .21537 L
.76224 .21537 L
.76324 .21537 L
.76424 .21537 L
.76523 .21537 L
.76623 .21537 L
.76723 .21537 L
.76823 .21537 L
.76923 .21537 L
.77023 .21537 L
.77123 .21537 L
.77223 .21537 L
.77323 .21537 L
.77423 .21537 L
.77522 .21537 L
.77622 .21537 L
.77722 .21537 L
.77822 .21537 L
.77922 .21537 L
.78022 .21537 L
.78122 .21537 L
.78222 .21537 L
.78322 .21537 L
.78422 .21537 L
.78521 .21537 L
.78621 .21537 L
.78721 .21537 L
.78821 .21537 L
.78921 .21537 L
.79021 .21537 L
.79121 .21537 L
.79221 .21537 L
.79321 .21537 L
.79421 .21537 L
.7952 .21537 L
.7962 .21537 L
.7972 .21537 L
.7982 .21537 L
Mistroke
.7992 .28641 L
.8002 .28641 L
.8012 .28641 L
.8022 .28641 L
.8032 .28641 L
.8042 .28641 L
.80519 .28641 L
.80619 .28641 L
.80719 .28641 L
.80819 .28641 L
.80919 .28641 L
.81019 .28641 L
.81119 .28641 L
.81219 .28641 L
.81319 .28641 L
.81419 .28641 L
.81518 .28641 L
.81618 .28641 L
.81718 .28641 L
.81818 .28641 L
.81918 .28641 L
.82018 .28641 L
.82118 .28641 L
.82218 .28641 L
.82318 .28641 L
.82418 .28641 L
.82517 .28641 L
.82617 .28641 L
.82717 .28641 L
.82817 .28641 L
.82917 .28641 L
.83017 .28641 L
.83117 .28641 L
.83217 .28641 L
.83317 .28641 L
.83417 .28641 L
.83516 .28641 L
.83616 .28641 L
.83716 .28641 L
.83816 .28641 L
.83916 .28641 L
.84016 .28641 L
.84116 .28641 L
.84216 .28641 L
.84316 .28641 L
.84416 .28641 L
.84515 .28641 L
.84615 .28641 L
.84715 .28641 L
.84815 .28641 L
Mistroke
.84915 .27515 L
.85015 .27515 L
.85115 .27515 L
.85215 .27515 L
.85315 .27515 L
.85415 .27515 L
.85514 .27515 L
.85614 .27515 L
.85714 .27515 L
.85814 .27515 L
.85914 .27515 L
.86014 .27515 L
.86114 .27515 L
.86214 .27515 L
.86314 .27515 L
.86414 .27515 L
.86513 .27515 L
.86613 .27515 L
.86713 .27515 L
.86813 .27515 L
.86913 .27515 L
.87013 .27515 L
.87113 .27515 L
.87213 .27515 L
.87313 .27515 L
.87413 .27515 L
.87512 .27515 L
.87612 .27515 L
.87712 .27515 L
.87812 .27515 L
.87912 .27515 L
.88012 .27515 L
.88112 .27515 L
.88212 .27515 L
.88312 .27515 L
.88412 .27515 L
.88511 .27515 L
.88611 .27515 L
.88711 .27515 L
.88811 .27515 L
.88911 .27515 L
.89011 .27515 L
.89111 .27515 L
.89211 .27515 L
.89311 .27515 L
.89411 .27515 L
.8951 .27515 L
.8961 .27515 L
.8971 .27515 L
.8981 .27515 L
Mistroke
.8991 .27807 L
.9001 .27807 L
.9011 .27807 L
.9021 .27807 L
.9031 .27807 L
.9041 .27807 L
.90509 .27807 L
.90609 .27807 L
.90709 .27807 L
.90809 .27807 L
.90909 .27807 L
.91009 .27807 L
.91109 .27807 L
.91209 .27807 L
.91309 .27807 L
.91409 .27807 L
.91508 .27807 L
.91608 .27807 L
.91708 .27807 L
.91808 .27807 L
.91908 .27807 L
.92008 .27807 L
.92108 .27807 L
.92208 .27807 L
.92308 .27807 L
.92408 .27807 L
.92507 .27807 L
.92607 .27807 L
.92707 .27807 L
.92807 .27807 L
.92907 .27807 L
.93007 .27807 L
.93107 .27807 L
.93207 .27807 L
.93307 .27807 L
.93407 .27807 L
.93506 .27807 L
.93606 .27807 L
.93706 .27807 L
.93806 .27807 L
.93906 .27807 L
.94006 .27807 L
.94106 .27807 L
.94206 .27807 L
.94306 .27807 L
.94406 .27807 L
.94505 .27807 L
.94605 .27807 L
.94705 .27807 L
.94805 .27807 L
Mistroke
.94905 .29392 L
.95005 .29392 L
.95105 .29392 L
.95205 .29392 L
.95305 .29392 L
.95405 .29392 L
.95504 .29392 L
.95604 .29392 L
.95704 .29392 L
.95804 .29392 L
.95904 .29392 L
.96004 .29392 L
.96104 .29392 L
.96204 .29392 L
.96304 .29392 L
.96404 .29392 L
.96503 .29392 L
.96603 .29392 L
.96703 .29392 L
.96803 .29392 L
.96903 .29392 L
.97003 .29392 L
.97103 .29392 L
.97203 .29392 L
.97303 .29392 L
.97403 .29392 L
.97502 .29392 L
.97602 .29392 L
.97702 .29392 L
.97802 .29392 L
.97902 .29392 L
.98002 .29392 L
.98102 .29392 L
.98202 .29392 L
.98302 .29392 L
.98402 .29392 L
.98501 .29392 L
.98601 .29392 L
.98701 .29392 L
.98801 .29392 L
.98901 .29392 L
.99001 .29392 L
.99101 .29392 L
.99201 .29392 L
.99301 .29392 L
.99401 .29392 L
.995 .29392 L
.996 .29392 L
.997 .29392 L
.998 .29392 L
Mistroke
.999 .27883 L
Mfstroke
0 0 1 r
gsave
.001 -1.8541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.237705 0.0475411 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04754 -12 -4.5 ]
[-0.0125 .04754 0 4.5 ]
[-0.0125 .14262 -12 -4.5 ]
[-0.0125 .14262 0 4.5 ]
[-0.0125 .23771 -6 -4.5 ]
[-0.0125 .23771 0 4.5 ]
[-0.0125 .33279 -6 -4.5 ]
[-0.0125 .33279 0 4.5 ]
[-0.0125 .42787 -6 -4.5 ]
[-0.0125 .42787 0 4.5 ]
[-0.0125 .52295 -6 -4.5 ]
[-0.0125 .52295 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04754 m
.00625 .04754 L
s
[(-4)] -0.0125 .04754 1 0 Mshowa
0 .14262 m
.00625 .14262 L
s
[(-2)] -0.0125 .14262 1 0 Mshowa
0 .23771 m
.00625 .23771 L
s
[(0)] -0.0125 .23771 1 0 Mshowa
0 .33279 m
.00625 .33279 L
s
[(2)] -0.0125 .33279 1 0 Mshowa
0 .42787 m
.00625 .42787 L
s
[(4)] -0.0125 .42787 1 0 Mshowa
0 .52295 m
.00625 .52295 L
s
[(6)] -0.0125 .52295 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(8)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .07131 m
.00375 .07131 L
s
0 .09508 m
.00375 .09508 L
s
0 .11885 m
.00375 .11885 L
s
0 .16639 m
.00375 .16639 L
s
0 .19016 m
.00375 .19016 L
s
0 .21393 m
.00375 .21393 L
s
0 .26148 m
.00375 .26148 L
s
0 .28525 m
.00375 .28525 L
s
0 .30902 m
.00375 .30902 L
s
0 .35656 m
.00375 .35656 L
s
0 .38033 m
.00375 .38033 L
s
0 .4041 m
.00375 .4041 L
s
0 .45164 m
.00375 .45164 L
s
0 .47541 m
.00375 .47541 L
s
0 .49918 m
.00375 .49918 L
s
0 .54672 m
.00375 .54672 L
s
0 .57049 m
.00375 .57049 L
s
0 .59426 m
.00375 .59426 L
s
0 .02377 m
.00375 .02377 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04754 m
1 .04754 L
s
.99375 .14262 m
1 .14262 L
s
.99375 .23771 m
1 .23771 L
s
.99375 .33279 m
1 .33279 L
s
.99375 .42787 m
1 .42787 L
s
.99375 .52295 m
1 .52295 L
s
.125 Mabswid
.99625 .07131 m
1 .07131 L
s
.99625 .09508 m
1 .09508 L
s
.99625 .11885 m
1 .11885 L
s
.99625 .16639 m
1 .16639 L
s
.99625 .19016 m
1 .19016 L
s
.99625 .21393 m
1 .21393 L
s
.99625 .26148 m
1 .26148 L
s
.99625 .28525 m
1 .28525 L
s
.99625 .30902 m
1 .30902 L
s
.99625 .35656 m
1 .35656 L
s
.99625 .38033 m
1 .38033 L
s
.99625 .4041 m
1 .4041 L
s
.99625 .45164 m
1 .45164 L
s
.99625 .47541 m
1 .47541 L
s
.99625 .49918 m
1 .49918 L
s
.99625 .54672 m
1 .54672 L
s
.99625 .57049 m
1 .57049 L
s
.99625 .59426 m
1 .59426 L
s
.99625 .02377 m
1 .02377 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .36452 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .36448 m
.001 .36448 L
.002 .36448 L
.003 .36448 L
.004 .36448 L
.005 .36448 L
.00599 .36448 L
.00699 .36448 L
.00799 .36448 L
.00899 .36448 L
.00999 .36448 L
.01099 .36448 L
.01199 .36448 L
.01299 .36448 L
.01399 .36448 L
.01499 .36448 L
.01598 .36448 L
.01698 .36448 L
.01798 .36448 L
.01898 .36448 L
.01998 .36448 L
.02098 .36448 L
.02198 .36449 L
.02298 .36449 L
.02398 .36449 L
.02498 .36449 L
.02597 .36449 L
.02697 .36449 L
.02797 .36449 L
.02897 .36449 L
.02997 .36449 L
.03097 .36449 L
.03197 .36449 L
.03297 .36449 L
.03397 .36449 L
.03497 .36449 L
.03596 .36449 L
.03696 .36449 L
.03796 .36449 L
.03896 .36449 L
.03996 .36449 L
.04096 .36449 L
.04196 .36449 L
.04296 .36449 L
.04396 .36449 L
.04496 .36449 L
.04595 .36449 L
.04695 .36449 L
.04795 .36449 L
.04895 .36449 L
Mistroke
.04995 .36449 L
.05095 .36449 L
.05195 .36449 L
.05295 .36448 L
.05395 .36448 L
.05495 .36448 L
.05594 .36449 L
.05694 .36449 L
.05794 .36449 L
.05894 .36449 L
.05994 .36448 L
.06094 .36448 L
.06194 .36448 L
.06294 .36449 L
.06394 .36449 L
.06494 .36449 L
.06593 .36449 L
.06693 .36449 L
.06793 .36449 L
.06893 .36449 L
.06993 .36449 L
.07093 .36449 L
.07193 .36449 L
.07293 .36449 L
.07393 .36449 L
.07493 .36449 L
.07592 .36449 L
.07692 .36449 L
.07792 .36449 L
.07892 .36449 L
.07992 .36449 L
.08092 .36449 L
.08192 .36449 L
.08292 .36449 L
.08392 .36449 L
.08492 .36449 L
.08591 .36449 L
.08691 .36449 L
.08791 .36449 L
.08891 .36449 L
.08991 .36449 L
.09091 .36449 L
.09191 .36449 L
.09291 .36449 L
.09391 .36449 L
.09491 .36449 L
.0959 .36449 L
.0969 .36449 L
.0979 .36449 L
.0989 .36449 L
Mistroke
.0999 .36449 L
.1009 .36449 L
.1019 .36449 L
.1029 .36449 L
.1039 .36449 L
.1049 .36449 L
.10589 .36449 L
.10689 .36449 L
.10789 .36449 L
.10889 .36449 L
.10989 .36449 L
.11089 .36449 L
.11189 .36449 L
.11289 .36449 L
.11389 .36449 L
.11489 .36449 L
.11588 .36449 L
.11688 .36449 L
.11788 .36449 L
.11888 .36449 L
.11988 .36449 L
.12088 .36449 L
.12188 .36449 L
.12288 .36449 L
.12388 .36449 L
.12488 .36449 L
.12587 .36449 L
.12687 .36449 L
.12787 .36449 L
.12887 .36449 L
.12987 .36449 L
.13087 .36449 L
.13187 .36449 L
.13287 .36449 L
.13387 .36449 L
.13487 .36449 L
.13586 .36449 L
.13686 .36449 L
.13786 .36449 L
.13886 .36449 L
.13986 .36449 L
.14086 .36449 L
.14186 .36449 L
.14286 .36449 L
.14386 .36449 L
.14486 .36449 L
.14585 .36449 L
.14685 .36449 L
.14785 .36449 L
.14885 .36449 L
Mistroke
.14985 .36449 L
.15085 .36449 L
.15185 .36449 L
.15285 .36449 L
.15385 .36449 L
.15485 .36449 L
.15584 .36449 L
.15684 .36449 L
.15784 .36449 L
.15884 .36449 L
.15984 .36449 L
.16084 .36449 L
.16184 .36449 L
.16284 .36449 L
.16384 .36449 L
.16484 .36449 L
.16583 .36449 L
.16683 .36449 L
.16783 .36449 L
.16883 .36449 L
.16983 .36449 L
.17083 .36449 L
.17183 .36449 L
.17283 .36449 L
.17383 .36449 L
.17483 .36449 L
.17582 .36449 L
.17682 .36449 L
.17782 .36449 L
.17882 .36449 L
.17982 .36449 L
.18082 .36449 L
.18182 .36449 L
.18282 .36449 L
.18382 .36449 L
.18482 .36449 L
.18581 .36449 L
.18681 .36449 L
.18781 .36449 L
.18881 .36449 L
.18981 .36449 L
.19081 .36449 L
.19181 .36449 L
.19281 .36449 L
.19381 .36449 L
.19481 .36449 L
.1958 .36449 L
.1968 .36449 L
.1978 .36449 L
.1988 .36449 L
Mistroke
.1998 .36449 L
.2008 .36449 L
.2018 .36449 L
.2028 .36449 L
.2038 .36449 L
.2048 .36449 L
.20579 .36449 L
.20679 .36449 L
.20779 .36449 L
.20879 .36449 L
.20979 .36449 L
.21079 .36449 L
.21179 .36449 L
.21279 .36449 L
.21379 .36449 L
.21479 .36449 L
.21578 .36449 L
.21678 .36449 L
.21778 .36449 L
.21878 .36449 L
.21978 .36449 L
.22078 .36449 L
.22178 .36449 L
.22278 .36449 L
.22378 .36449 L
.22478 .36449 L
.22577 .36449 L
.22677 .36449 L
.22777 .36449 L
.22877 .36449 L
.22977 .36449 L
.23077 .36449 L
.23177 .36449 L
.23277 .36449 L
.23377 .36449 L
.23477 .36449 L
.23576 .36449 L
.23676 .36449 L
.23776 .36449 L
.23876 .36449 L
.23976 .36449 L
.24076 .36449 L
.24176 .36449 L
.24276 .36449 L
.24376 .36449 L
.24476 .36449 L
.24575 .36449 L
.24675 .36449 L
.24775 .36449 L
.24875 .36449 L
Mistroke
.24975 .36449 L
.25075 .36449 L
.25175 .36449 L
.25275 .36449 L
.25375 .36449 L
.25475 .36449 L
.25574 .36449 L
.25674 .36449 L
.25774 .36449 L
.25874 .36449 L
.25974 .36449 L
.26074 .36449 L
.26174 .36449 L
.26274 .36449 L
.26374 .36449 L
.26474 .36449 L
.26573 .36449 L
.26673 .36449 L
.26773 .36449 L
.26873 .36449 L
.26973 .36449 L
.27073 .36449 L
.27173 .36449 L
.27273 .36449 L
.27373 .36449 L
.27473 .36449 L
.27572 .36449 L
.27672 .36449 L
.27772 .36449 L
.27872 .36449 L
.27972 .36449 L
.28072 .36449 L
.28172 .36449 L
.28272 .36449 L
.28372 .36449 L
.28472 .36449 L
.28571 .36449 L
.28671 .36449 L
.28771 .36449 L
.28871 .36449 L
.28971 .36449 L
.29071 .36449 L
.29171 .36449 L
.29271 .36449 L
.29371 .36449 L
.29471 .36449 L
.2957 .36449 L
.2967 .36449 L
.2977 .36449 L
.2987 .36449 L
Mistroke
.2997 .36449 L
.3007 .36449 L
.3017 .36449 L
.3027 .36449 L
.3037 .36449 L
.3047 .36449 L
.30569 .36449 L
.30669 .36449 L
.30769 .36449 L
.30869 .36449 L
.30969 .36449 L
.31069 .36449 L
.31169 .36449 L
.31269 .36449 L
.31369 .36449 L
.31469 .36449 L
.31568 .36449 L
.31668 .36449 L
.31768 .36449 L
.31868 .36449 L
.31968 .36449 L
.32068 .36449 L
.32168 .36449 L
.32268 .36449 L
.32368 .36449 L
.32468 .36449 L
.32567 .36449 L
.32667 .36449 L
.32767 .36449 L
.32867 .36449 L
.32967 .36449 L
.33067 .36449 L
.33167 .36449 L
.33267 .36449 L
.33367 .36449 L
.33467 .36449 L
.33566 .36449 L
.33666 .36449 L
.33766 .36449 L
.33866 .3645 L
.33966 .3645 L
.34066 .3645 L
.34166 .3645 L
.34266 .3645 L
.34366 .3645 L
.34466 .3645 L
.34565 .3645 L
.34665 .3645 L
.34765 .3645 L
.34865 .3645 L
Mistroke
.34965 .3645 L
.35065 .3645 L
.35165 .3645 L
.35265 .3645 L
.35365 .3645 L
.35465 .3645 L
.35564 .3645 L
.35664 .3645 L
.35764 .3645 L
.35864 .3645 L
.35964 .3645 L
.36064 .3645 L
.36164 .3645 L
.36264 .3645 L
.36364 .3645 L
.36464 .3645 L
.36563 .3645 L
.36663 .3645 L
.36763 .3645 L
.36863 .3645 L
.36963 .3645 L
.37063 .3645 L
.37163 .3645 L
.37263 .3645 L
.37363 .3645 L
.37463 .3645 L
.37562 .3645 L
.37662 .3645 L
.37762 .3645 L
.37862 .3645 L
.37962 .3645 L
.38062 .3645 L
.38162 .3645 L
.38262 .3645 L
.38362 .3645 L
.38462 .3645 L
.38561 .3645 L
.38661 .3645 L
.38761 .3645 L
.38861 .3645 L
.38961 .3645 L
.39061 .3645 L
.39161 .3645 L
.39261 .3645 L
.39361 .3645 L
.39461 .3645 L
.3956 .3645 L
.3966 .3645 L
.3976 .3645 L
.3986 .3645 L
Mistroke
.3996 .3645 L
.4006 .3645 L
.4016 .3645 L
.4026 .3645 L
.4036 .3645 L
.4046 .3645 L
.40559 .3645 L
.40659 .3645 L
.40759 .3645 L
.40859 .3645 L
.40959 .3645 L
.41059 .3645 L
.41159 .3645 L
.41259 .3645 L
.41359 .3645 L
.41459 .3645 L
.41558 .3645 L
.41658 .3645 L
.41758 .3645 L
.41858 .3645 L
.41958 .3645 L
.42058 .3645 L
.42158 .3645 L
.42258 .3645 L
.42358 .3645 L
.42458 .3645 L
.42557 .3645 L
.42657 .3645 L
.42757 .3645 L
.42857 .3645 L
.42957 .3645 L
.43057 .3645 L
.43157 .3645 L
.43257 .3645 L
.43357 .3645 L
.43457 .3645 L
.43556 .3645 L
.43656 .3645 L
.43756 .3645 L
.43856 .3645 L
.43956 .3645 L
.44056 .3645 L
.44156 .3645 L
.44256 .3645 L
.44356 .3645 L
.44456 .3645 L
.44555 .3645 L
.44655 .3645 L
.44755 .3645 L
.44855 .3645 L
Mistroke
.44955 .3645 L
.45055 .3645 L
.45155 .3645 L
.45255 .3645 L
.45355 .3645 L
.45455 .3645 L
.45554 .3645 L
.45654 .3645 L
.45754 .3645 L
.45854 .3645 L
.45954 .3645 L
.46054 .3645 L
.46154 .3645 L
.46254 .3645 L
.46354 .3645 L
.46454 .3645 L
.46553 .3645 L
.46653 .3645 L
.46753 .3645 L
.46853 .3645 L
.46953 .3645 L
.47053 .3645 L
.47153 .3645 L
.47253 .3645 L
.47353 .3645 L
.47453 .3645 L
.47552 .3645 L
.47652 .3645 L
.47752 .3645 L
.47852 .3645 L
.47952 .3645 L
.48052 .3645 L
.48152 .3645 L
.48252 .3645 L
.48352 .3645 L
.48452 .3645 L
.48551 .3645 L
.48651 .3645 L
.48751 .3645 L
.48851 .3645 L
.48951 .3645 L
.49051 .3645 L
.49151 .3645 L
.49251 .3645 L
.49351 .3645 L
.49451 .3645 L
.4955 .3645 L
.4965 .3645 L
.4975 .3645 L
.4985 .3645 L
Mistroke
.4995 .3645 L
.5005 .3645 L
.5015 .3645 L
.5025 .3645 L
.5035 .3645 L
.5045 .3645 L
.50549 .3645 L
.50649 .3645 L
.50749 .3645 L
.50849 .3645 L
.50949 .3645 L
.51049 .3645 L
.51149 .3645 L
.51249 .3645 L
.51349 .3645 L
.51449 .3645 L
.51548 .3645 L
.51648 .3645 L
.51748 .3645 L
.51848 .3645 L
.51948 .3645 L
.52048 .3645 L
.52148 .3645 L
.52248 .3645 L
.52348 .3645 L
.52448 .3645 L
.52547 .3645 L
.52647 .3645 L
.52747 .3645 L
.52847 .3645 L
.52947 .3645 L
.53047 .3645 L
.53147 .3645 L
.53247 .3645 L
.53347 .3645 L
.53447 .3645 L
.53546 .3645 L
.53646 .3645 L
.53746 .3645 L
.53846 .3645 L
.53946 .3645 L
.54046 .3645 L
.54146 .3645 L
.54246 .3645 L
.54346 .3645 L
.54446 .3645 L
.54545 .3645 L
.54645 .3645 L
.54745 .3645 L
.54845 .3645 L
Mistroke
.54945 .3645 L
.55045 .3645 L
.55145 .3645 L
.55245 .3645 L
.55345 .3645 L
.55445 .3645 L
.55544 .3645 L
.55644 .3645 L
.55744 .3645 L
.55844 .3645 L
.55944 .3645 L
.56044 .3645 L
.56144 .3645 L
.56244 .3645 L
.56344 .3645 L
.56444 .3645 L
.56543 .3645 L
.56643 .3645 L
.56743 .3645 L
.56843 .3645 L
.56943 .3645 L
.57043 .3645 L
.57143 .3645 L
.57243 .3645 L
.57343 .3645 L
.57443 .3645 L
.57542 .3645 L
.57642 .3645 L
.57742 .3645 L
.57842 .3645 L
.57942 .3645 L
.58042 .3645 L
.58142 .3645 L
.58242 .3645 L
.58342 .3645 L
.58442 .3645 L
.58541 .3645 L
.58641 .3645 L
.58741 .3645 L
.58841 .3645 L
.58941 .3645 L
.59041 .3645 L
.59141 .3645 L
.59241 .3645 L
.59341 .3645 L
.59441 .3645 L
.5954 .3645 L
.5964 .3645 L
.5974 .3645 L
.5984 .3645 L
Mistroke
.5994 .3645 L
.6004 .3645 L
.6014 .3645 L
.6024 .3645 L
.6034 .3645 L
.6044 .3645 L
.60539 .3645 L
.60639 .3645 L
.60739 .3645 L
.60839 .3645 L
.60939 .3645 L
.61039 .3645 L
.61139 .3645 L
.61239 .3645 L
.61339 .3645 L
.61439 .3645 L
.61538 .3645 L
.61638 .3645 L
.61738 .3645 L
.61838 .3645 L
.61938 .3645 L
.62038 .3645 L
.62138 .3645 L
.62238 .3645 L
.62338 .3645 L
.62438 .3645 L
.62537 .3645 L
.62637 .3645 L
.62737 .3645 L
.62837 .3645 L
.62937 .3645 L
.63037 .3645 L
.63137 .3645 L
.63237 .3645 L
.63337 .3645 L
.63437 .3645 L
.63536 .36451 L
.63636 .36451 L
.63736 .36451 L
.63836 .36451 L
.63936 .36451 L
.64036 .36451 L
.64136 .36451 L
.64236 .36451 L
.64336 .36451 L
.64436 .36451 L
.64535 .36451 L
.64635 .36451 L
.64735 .36451 L
.64835 .36451 L
Mistroke
.64935 .36451 L
.65035 .36451 L
.65135 .36451 L
.65235 .36451 L
.65335 .36451 L
.65435 .36451 L
.65534 .36451 L
.65634 .36451 L
.65734 .36451 L
.65834 .36451 L
.65934 .36451 L
.66034 .36451 L
.66134 .36451 L
.66234 .36451 L
.66334 .36451 L
.66434 .3645 L
.66533 .36451 L
.66633 .36451 L
.66733 .36451 L
.66833 .36451 L
.66933 .3645 L
.67033 .3645 L
.67133 .36451 L
.67233 .36451 L
.67333 .3645 L
.67433 .36451 L
.67532 .36451 L
.67632 .36451 L
.67732 .36451 L
.67832 .36451 L
.67932 .3645 L
.68032 .3645 L
.68132 .3645 L
.68232 .36451 L
.68332 .36451 L
.68432 .3645 L
.68531 .3645 L
.68631 .3645 L
.68731 .3645 L
.68831 .3645 L
.68931 .3645 L
.69031 .3645 L
.69131 .3645 L
.69231 .3645 L
.69331 .3645 L
.69431 .3645 L
.6953 .3645 L
.6963 .3645 L
.6973 .3645 L
.6983 .3645 L
Mistroke
.6993 .3645 L
.7003 .3645 L
.7013 .3645 L
.7023 .3645 L
.7033 .3645 L
.7043 .3645 L
.70529 .3645 L
.70629 .3645 L
.70729 .3645 L
.70829 .3645 L
.70929 .3645 L
.71029 .3645 L
.71129 .3645 L
.71229 .3645 L
.71329 .3645 L
.71429 .3645 L
.71528 .3645 L
.71628 .3645 L
.71728 .3645 L
.71828 .3645 L
.71928 .3645 L
.72028 .3645 L
.72128 .3645 L
.72228 .3645 L
.72328 .3645 L
.72428 .3645 L
.72527 .3645 L
.72627 .3645 L
.72727 .3645 L
.72827 .3645 L
.72927 .3645 L
.73027 .3645 L
.73127 .36451 L
.73227 .36451 L
.73327 .36451 L
.73427 .36451 L
.73526 .36451 L
.73626 .36451 L
.73726 .36451 L
.73826 .36451 L
.73926 .36451 L
.74026 .36451 L
.74126 .36451 L
.74226 .3645 L
.74326 .3645 L
.74426 .3645 L
.74525 .36451 L
.74625 .3645 L
.74725 .36451 L
.74825 .36451 L
Mistroke
.74925 .36451 L
.75025 .36451 L
.75125 .36451 L
.75225 .36451 L
.75325 .36451 L
.75425 .36451 L
.75524 .36451 L
.75624 .36451 L
.75724 .36451 L
.75824 .36451 L
.75924 .36451 L
.76024 .36451 L
.76124 .36451 L
.76224 .36451 L
.76324 .36451 L
.76424 .36451 L
.76523 .36451 L
.76623 .36451 L
.76723 .36451 L
.76823 .36451 L
.76923 .36451 L
.77023 .36451 L
.77123 .36451 L
.77223 .36451 L
.77323 .36451 L
.77423 .36451 L
.77522 .36451 L
.77622 .36451 L
.77722 .36451 L
.77822 .36451 L
.77922 .36451 L
.78022 .36451 L
.78122 .36451 L
.78222 .36451 L
.78322 .36451 L
.78422 .36451 L
.78521 .36451 L
.78621 .36451 L
.78721 .36451 L
.78821 .36451 L
.78921 .36451 L
.79021 .36451 L
.79121 .36451 L
.79221 .36451 L
.79321 .36451 L
.79421 .36451 L
.7952 .36451 L
.7962 .36451 L
.7972 .36451 L
.7982 .36451 L
Mistroke
.7992 .36451 L
.8002 .36451 L
.8012 .36451 L
.8022 .36451 L
.8032 .36451 L
.8042 .36452 L
.80519 .36451 L
.80619 .36451 L
.80719 .36451 L
.80819 .36451 L
.80919 .36451 L
.81019 .36451 L
.81119 .36451 L
.81219 .36452 L
.81319 .36452 L
.81419 .36452 L
.81518 .36452 L
.81618 .36451 L
.81718 .36451 L
.81818 .36451 L
.81918 .36451 L
.82018 .36451 L
.82118 .36451 L
.82218 .36451 L
.82318 .36451 L
.82418 .36451 L
.82517 .36451 L
.82617 .36451 L
.82717 .36451 L
.82817 .36451 L
.82917 .36451 L
.83017 .36451 L
.83117 .36451 L
.83217 .36451 L
.83317 .36452 L
.83417 .36452 L
.83516 .36452 L
.83616 .36452 L
.83716 .36452 L
.83816 .36452 L
.83916 .36452 L
.84016 .36452 L
.84116 .36451 L
.84216 .36451 L
.84316 .36451 L
.84416 .36451 L
.84515 .36451 L
.84615 .36452 L
.84715 .36451 L
.84815 .36451 L
Mistroke
.84915 .36451 L
.85015 .36451 L
.85115 .36451 L
.85215 .36451 L
.85315 .36451 L
.85415 .36452 L
.85514 .36452 L
.85614 .36452 L
.85714 .36452 L
.85814 .36452 L
.85914 .36452 L
.86014 .36452 L
.86114 .36452 L
.86214 .36452 L
.86314 .36452 L
.86414 .36452 L
.86513 .36452 L
.86613 .36452 L
.86713 .36452 L
.86813 .36452 L
.86913 .36452 L
.87013 .36452 L
.87113 .36452 L
.87213 .36452 L
.87313 .36452 L
.87413 .36452 L
.87512 .36452 L
.87612 .36452 L
.87712 .36452 L
.87812 .36452 L
.87912 .36452 L
.88012 .36452 L
.88112 .36452 L
.88212 .36452 L
.88312 .36452 L
.88412 .36452 L
.88511 .36452 L
.88611 .36452 L
.88711 .36452 L
.88811 .36452 L
.88911 .36452 L
.89011 .36452 L
.89111 .36451 L
.89211 .36451 L
.89311 .36452 L
.89411 .36452 L
.8951 .36451 L
.8961 .36452 L
.8971 .36452 L
.8981 .36452 L
Mistroke
.8991 .36451 L
.9001 .36451 L
.9011 .36452 L
.9021 .36451 L
.9031 .36451 L
.9041 .36451 L
.90509 .36451 L
.90609 .36451 L
.90709 .36451 L
.90809 .36451 L
.90909 .36451 L
.91009 .36451 L
.91109 .36451 L
.91209 .36451 L
.91309 .36451 L
.91409 .36451 L
.91508 .36451 L
.91608 .36451 L
.91708 .36451 L
.91808 .36451 L
.91908 .36451 L
.92008 .36451 L
.92108 .36451 L
.92208 .36451 L
.92308 .36451 L
.92408 .36451 L
.92507 .36451 L
.92607 .36451 L
.92707 .36451 L
.92807 .36451 L
.92907 .36451 L
.93007 .36451 L
.93107 .36451 L
.93207 .36451 L
.93307 .36451 L
.93407 .36451 L
.93506 .36451 L
.93606 .36451 L
.93706 .36451 L
.93806 .36451 L
.93906 .36451 L
.94006 .36451 L
.94106 .36451 L
.94206 .36451 L
.94306 .36451 L
.94406 .36451 L
.94505 .36451 L
.94605 .36451 L
.94705 .36451 L
.94805 .36451 L
Mistroke
.94905 .36451 L
.95005 .36451 L
.95105 .36451 L
.95205 .36451 L
.95305 .36451 L
.95405 .36451 L
.95504 .36451 L
.95604 .36451 L
.95704 .36451 L
.95804 .36451 L
.95904 .36451 L
.96004 .36451 L
.96104 .36451 L
.96204 .36451 L
.96304 .36451 L
.96404 .36451 L
.96503 .36451 L
.96603 .36451 L
.96703 .36451 L
.96803 .36451 L
.96903 .36451 L
.97003 .36452 L
.97103 .36452 L
.97203 .36451 L
.97303 .36451 L
.97403 .36451 L
.97502 .36451 L
.97602 .36451 L
.97702 .36451 L
.97802 .36451 L
.97902 .36451 L
.98002 .36451 L
.98102 .36451 L
.98202 .36451 L
.98302 .36451 L
.98402 .36451 L
.98501 .36451 L
.98601 .36451 L
.98701 .36451 L
.98801 .36451 L
.98901 .36451 L
.99001 .36451 L
.99101 .36451 L
.99201 .36451 L
.99301 .36451 L
.99401 .36451 L
.995 .36451 L
.996 .36452 L
.997 .36452 L
.998 .36452 L
Mistroke
.999 .36452 L
Mfstroke
0 .98 .604 r
gsave
.999 .25079 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
0 .31884 m
.001 .31884 L
.002 .31884 L
.003 .31884 L
.004 .31884 L
.005 .31884 L
.00599 .31884 L
.00699 .31884 L
.00799 .31884 L
.00899 .31884 L
.00999 .31884 L
.01099 .31884 L
.01199 .31884 L
.01299 .31884 L
.01399 .31884 L
.01499 .31884 L
.01598 .31884 L
.01698 .31884 L
.01798 .31884 L
.01898 .31884 L
.01998 .31884 L
.02098 .31884 L
.02198 .31884 L
.02298 .31884 L
.02398 .31884 L
.02498 .31884 L
.02597 .31884 L
.02697 .31884 L
.02797 .31884 L
.02897 .31884 L
.02997 .31884 L
.03097 .31884 L
.03197 .31884 L
.03297 .31884 L
.03397 .31884 L
.03497 .31884 L
.03596 .31884 L
.03696 .31884 L
.03796 .31884 L
.03896 .31884 L
.03996 .31884 L
.04096 .31884 L
.04196 .31884 L
.04296 .31884 L
.04396 .31884 L
.04496 .31884 L
.04595 .31884 L
.04695 .31884 L
.04795 .31884 L
.04895 .31884 L
Mistroke
.04995 .2895 L
.05095 .2895 L
.05195 .2895 L
.05295 .2895 L
.05395 .2895 L
.05495 .2895 L
.05594 .2895 L
.05694 .2895 L
.05794 .2895 L
.05894 .2895 L
.05994 .2895 L
.06094 .2895 L
.06194 .2895 L
.06294 .2895 L
.06394 .2895 L
.06494 .2895 L
.06593 .2895 L
.06693 .2895 L
.06793 .2895 L
.06893 .2895 L
.06993 .2895 L
.07093 .2895 L
.07193 .2895 L
.07293 .2895 L
.07393 .2895 L
.07493 .2895 L
.07592 .2895 L
.07692 .2895 L
.07792 .2895 L
.07892 .2895 L
.07992 .2895 L
.08092 .2895 L
.08192 .2895 L
.08292 .2895 L
.08392 .2895 L
.08492 .2895 L
.08591 .2895 L
.08691 .2895 L
.08791 .2895 L
.08891 .2895 L
.08991 .2895 L
.09091 .2895 L
.09191 .2895 L
.09291 .2895 L
.09391 .2895 L
.09491 .2895 L
.0959 .2895 L
.0969 .2895 L
.0979 .2895 L
.0989 .2895 L
Mistroke
.0999 .3694 L
.1009 .3694 L
.1019 .3694 L
.1029 .3694 L
.1039 .3694 L
.1049 .3694 L
.10589 .3694 L
.10689 .3694 L
.10789 .3694 L
.10889 .3694 L
.10989 .3694 L
.11089 .3694 L
.11189 .3694 L
.11289 .3694 L
.11389 .3694 L
.11489 .3694 L
.11588 .3694 L
.11688 .3694 L
.11788 .3694 L
.11888 .3694 L
.11988 .3694 L
.12088 .3694 L
.12188 .3694 L
.12288 .3694 L
.12388 .3694 L
.12488 .3694 L
.12587 .3694 L
.12687 .3694 L
.12787 .3694 L
.12887 .3694 L
.12987 .3694 L
.13087 .3694 L
.13187 .3694 L
.13287 .3694 L
.13387 .3694 L
.13487 .3694 L
.13586 .3694 L
.13686 .3694 L
.13786 .3694 L
.13886 .3694 L
.13986 .3694 L
.14086 .3694 L
.14186 .3694 L
.14286 .3694 L
.14386 .3694 L
.14486 .3694 L
.14585 .3694 L
.14685 .3694 L
.14785 .3694 L
.14885 .3694 L
Mistroke
.14985 .12713 L
.15085 .12713 L
.15185 .12713 L
.15285 .12713 L
.15385 .12713 L
.15485 .12713 L
.15584 .12713 L
.15684 .12713 L
.15784 .12713 L
.15884 .12713 L
.15984 .12713 L
.16084 .12713 L
.16184 .12713 L
.16284 .12713 L
.16384 .12713 L
.16484 .12713 L
.16583 .12713 L
.16683 .12713 L
.16783 .12713 L
.16883 .12713 L
.16983 .12713 L
.17083 .12713 L
.17183 .12713 L
.17283 .12713 L
.17383 .12713 L
.17483 .12713 L
.17582 .12713 L
.17682 .12713 L
.17782 .12713 L
.17882 .12713 L
.17982 .12713 L
.18082 .12713 L
.18182 .12713 L
.18282 .12713 L
.18382 .12713 L
.18482 .12713 L
.18581 .12713 L
.18681 .12713 L
.18781 .12713 L
.18881 .12713 L
.18981 .12713 L
.19081 .12713 L
.19181 .12713 L
.19281 .12713 L
.19381 .12713 L
.19481 .12713 L
.1958 .12713 L
.1968 .12713 L
.1978 .12713 L
.1988 .12713 L
Mistroke
.1998 .16965 L
.2008 .16965 L
.2018 .16965 L
.2028 .16965 L
.2038 .16965 L
.2048 .16965 L
.20579 .16965 L
.20679 .16965 L
.20779 .16965 L
.20879 .16965 L
.20979 .16965 L
.21079 .16965 L
.21179 .16965 L
.21279 .16965 L
.21379 .16965 L
.21479 .16965 L
.21578 .16965 L
.21678 .16965 L
.21778 .16965 L
.21878 .16965 L
.21978 .16965 L
.22078 .16965 L
.22178 .16965 L
.22278 .16965 L
.22378 .16965 L
.22478 .16965 L
.22577 .16965 L
.22677 .16965 L
.22777 .16965 L
.22877 .16965 L
.22977 .16965 L
.23077 .16965 L
.23177 .16965 L
.23277 .16965 L
.23377 .16965 L
.23477 .16965 L
.23576 .16965 L
.23676 .16965 L
.23776 .16965 L
.23876 .16965 L
.23976 .16965 L
.24076 .16965 L
.24176 .16965 L
.24276 .16965 L
.24376 .16965 L
.24476 .16965 L
.24575 .16965 L
.24675 .16965 L
.24775 .16965 L
.24875 .16965 L
Mistroke
.24975 .1783 L
.25075 .1783 L
.25175 .1783 L
.25275 .1783 L
.25375 .1783 L
.25475 .1783 L
.25574 .1783 L
.25674 .1783 L
.25774 .1783 L
.25874 .1783 L
.25974 .1783 L
.26074 .1783 L
.26174 .1783 L
.26274 .1783 L
.26374 .1783 L
.26474 .1783 L
.26573 .1783 L
.26673 .1783 L
.26773 .1783 L
.26873 .1783 L
.26973 .1783 L
.27073 .1783 L
.27173 .1783 L
.27273 .1783 L
.27373 .1783 L
.27473 .1783 L
.27572 .1783 L
.27672 .1783 L
.27772 .1783 L
.27872 .1783 L
.27972 .1783 L
.28072 .1783 L
.28172 .1783 L
.28272 .1783 L
.28372 .1783 L
.28472 .1783 L
.28571 .1783 L
.28671 .1783 L
.28771 .1783 L
.28871 .1783 L
.28971 .1783 L
.29071 .1783 L
.29171 .1783 L
.29271 .1783 L
.29371 .1783 L
.29471 .1783 L
.2957 .1783 L
.2967 .1783 L
.2977 .1783 L
.2987 .1783 L
Mistroke
.2997 .19844 L
.3007 .19844 L
.3017 .19844 L
.3027 .19844 L
.3037 .19844 L
.3047 .19844 L
.30569 .19844 L
.30669 .19844 L
.30769 .19844 L
.30869 .19844 L
.30969 .19844 L
.31069 .19844 L
.31169 .19844 L
.31269 .19844 L
.31369 .19844 L
.31469 .19844 L
.31568 .19844 L
.31668 .19844 L
.31768 .19844 L
.31868 .19844 L
.31968 .19844 L
.32068 .19844 L
.32168 .19844 L
.32268 .19844 L
.32368 .19844 L
.32468 .19844 L
.32567 .19844 L
.32667 .19844 L
.32767 .19844 L
.32867 .19844 L
.32967 .19844 L
.33067 .19844 L
.33167 .19844 L
.33267 .19844 L
.33367 .19844 L
.33467 .19844 L
.33566 .19844 L
.33666 .19844 L
.33766 .19844 L
.33866 .19844 L
.33966 .19844 L
.34066 .19844 L
.34166 .19844 L
.34266 .19844 L
.34366 .19844 L
.34466 .19844 L
.34565 .19844 L
.34665 .19844 L
.34765 .19844 L
.34865 .19844 L
Mistroke
.34965 .21716 L
.35065 .21716 L
.35165 .21716 L
.35265 .21716 L
.35365 .21716 L
.35465 .21716 L
.35564 .21716 L
.35664 .21716 L
.35764 .21716 L
.35864 .21716 L
.35964 .21716 L
.36064 .21716 L
.36164 .21716 L
.36264 .21716 L
.36364 .21716 L
.36464 .21716 L
.36563 .21716 L
.36663 .21716 L
.36763 .21716 L
.36863 .21716 L
.36963 .21716 L
.37063 .21716 L
.37163 .21716 L
.37263 .21716 L
.37363 .21716 L
.37463 .21716 L
.37562 .21716 L
.37662 .21716 L
.37762 .21716 L
.37862 .21716 L
.37962 .21716 L
.38062 .21716 L
.38162 .21716 L
.38262 .21716 L
.38362 .21716 L
.38462 .21716 L
.38561 .21716 L
.38661 .21716 L
.38761 .21716 L
.38861 .21716 L
.38961 .21716 L
.39061 .21716 L
.39161 .21716 L
.39261 .21716 L
.39361 .21716 L
.39461 .21716 L
.3956 .21716 L
.3966 .21716 L
.3976 .21716 L
.3986 .21716 L
Mistroke
.3996 .222 L
.4006 .222 L
.4016 .222 L
.4026 .222 L
.4036 .222 L
.4046 .222 L
.40559 .222 L
.40659 .222 L
.40759 .222 L
.40859 .222 L
.40959 .222 L
.41059 .222 L
.41159 .222 L
.41259 .222 L
.41359 .222 L
.41459 .222 L
.41558 .222 L
.41658 .222 L
.41758 .222 L
.41858 .222 L
.41958 .222 L
.42058 .222 L
.42158 .222 L
.42258 .222 L
.42358 .222 L
.42458 .222 L
.42557 .222 L
.42657 .222 L
.42757 .222 L
.42857 .222 L
.42957 .222 L
.43057 .222 L
.43157 .222 L
.43257 .222 L
.43357 .222 L
.43457 .222 L
.43556 .222 L
.43656 .222 L
.43756 .222 L
.43856 .222 L
.43956 .222 L
.44056 .222 L
.44156 .222 L
.44256 .222 L
.44356 .222 L
.44456 .222 L
.44555 .222 L
.44655 .222 L
.44755 .222 L
.44855 .222 L
Mistroke
.44955 .21095 L
.45055 .21095 L
.45155 .21095 L
.45255 .21095 L
.45355 .21095 L
.45455 .21095 L
.45554 .21095 L
.45654 .21095 L
.45754 .21095 L
.45854 .21095 L
.45954 .21095 L
.46054 .21095 L
.46154 .21095 L
.46254 .21095 L
.46354 .21095 L
.46454 .21095 L
.46553 .21095 L
.46653 .21095 L
.46753 .21095 L
.46853 .21095 L
.46953 .21095 L
.47053 .21095 L
.47153 .21095 L
.47253 .21095 L
.47353 .21095 L
.47453 .21095 L
.47552 .21095 L
.47652 .21095 L
.47752 .21095 L
.47852 .21095 L
.47952 .21095 L
.48052 .21095 L
.48152 .21095 L
.48252 .21095 L
.48352 .21095 L
.48452 .21095 L
.48551 .21095 L
.48651 .21095 L
.48751 .21095 L
.48851 .21095 L
.48951 .21095 L
.49051 .21095 L
.49151 .21095 L
.49251 .21095 L
.49351 .21095 L
.49451 .21095 L
.4955 .21095 L
.4965 .21095 L
.4975 .21095 L
.4985 .21095 L
Mistroke
.4995 .23555 L
.5005 .23555 L
.5015 .23555 L
.5025 .23555 L
.5035 .23555 L
.5045 .23555 L
.50549 .23555 L
.50649 .23555 L
.50749 .23555 L
.50849 .23555 L
.50949 .23555 L
.51049 .23555 L
.51149 .23555 L
.51249 .23555 L
.51349 .23555 L
.51449 .23555 L
.51548 .23555 L
.51648 .23555 L
.51748 .23555 L
.51848 .23555 L
.51948 .23555 L
.52048 .23555 L
.52148 .23555 L
.52248 .23555 L
.52348 .23555 L
.52448 .23555 L
.52547 .23555 L
.52647 .23555 L
.52747 .23555 L
.52847 .23555 L
.52947 .23555 L
.53047 .23555 L
.53147 .23555 L
.53247 .23555 L
.53347 .23555 L
.53447 .23555 L
.53546 .23555 L
.53646 .23555 L
.53746 .23555 L
.53846 .23555 L
.53946 .23555 L
.54046 .23555 L
.54146 .23555 L
.54246 .23555 L
.54346 .23555 L
.54446 .23555 L
.54545 .23555 L
.54645 .23555 L
.54745 .23555 L
.54845 .23555 L
Mistroke
.54945 .24715 L
.55045 .24715 L
.55145 .24715 L
.55245 .24715 L
.55345 .24715 L
.55445 .24715 L
.55544 .24715 L
.55644 .24715 L
.55744 .24715 L
.55844 .24715 L
.55944 .24715 L
.56044 .24715 L
.56144 .24715 L
.56244 .24715 L
.56344 .24715 L
.56444 .24715 L
.56543 .24715 L
.56643 .24715 L
.56743 .24715 L
.56843 .24715 L
.56943 .24715 L
.57043 .24715 L
.57143 .24715 L
.57243 .24715 L
.57343 .24715 L
.57443 .24715 L
.57542 .24715 L
.57642 .24715 L
.57742 .24715 L
.57842 .24715 L
.57942 .24715 L
.58042 .24715 L
.58142 .24715 L
.58242 .24715 L
.58342 .24715 L
.58442 .24715 L
.58541 .24715 L
.58641 .24715 L
.58741 .24715 L
.58841 .24715 L
.58941 .24715 L
.59041 .24715 L
.59141 .24715 L
.59241 .24715 L
.59341 .24715 L
.59441 .24715 L
.5954 .24715 L
.5964 .24715 L
.5974 .24715 L
.5984 .24715 L
Mistroke
.5994 .23577 L
.6004 .23577 L
.6014 .23577 L
.6024 .23577 L
.6034 .23577 L
.6044 .23577 L
.60539 .23577 L
.60639 .23577 L
.60739 .23577 L
.60839 .23577 L
.60939 .23577 L
.61039 .23577 L
.61139 .23577 L
.61239 .23577 L
.61339 .23577 L
.61439 .23577 L
.61538 .23577 L
.61638 .23577 L
.61738 .23577 L
.61838 .23577 L
.61938 .23577 L
.62038 .23577 L
.62138 .23577 L
.62238 .23577 L
.62338 .23577 L
.62438 .23577 L
.62537 .23577 L
.62637 .23577 L
.62737 .23577 L
.62837 .23577 L
.62937 .23577 L
.63037 .23577 L
.63137 .23577 L
.63237 .23577 L
.63337 .23577 L
.63437 .23577 L
.63536 .23577 L
.63636 .23577 L
.63736 .23577 L
.63836 .23577 L
.63936 .23577 L
.64036 .23577 L
.64136 .23577 L
.64236 .23577 L
.64336 .23577 L
.64436 .23577 L
.64535 .23577 L
.64635 .23577 L
.64735 .23577 L
.64835 .23577 L
Mistroke
.64935 .23976 L
.65035 .23976 L
.65135 .23976 L
.65235 .23976 L
.65335 .23976 L
.65435 .23976 L
.65534 .23976 L
.65634 .23976 L
.65734 .23976 L
.65834 .23976 L
.65934 .23976 L
.66034 .23976 L
.66134 .23976 L
.66234 .23976 L
.66334 .23976 L
.66434 .23976 L
.66533 .23976 L
.66633 .23976 L
.66733 .23976 L
.66833 .23976 L
.66933 .23976 L
.67033 .23976 L
.67133 .23976 L
.67233 .23976 L
.67333 .23976 L
.67433 .23976 L
.67532 .23976 L
.67632 .23976 L
.67732 .23976 L
.67832 .23976 L
.67932 .23976 L
.68032 .23976 L
.68132 .23976 L
.68232 .23976 L
.68332 .23976 L
.68432 .23976 L
.68531 .23976 L
.68631 .23976 L
.68731 .23976 L
.68831 .23976 L
.68931 .23976 L
.69031 .23976 L
.69131 .23976 L
.69231 .23976 L
.69331 .23976 L
.69431 .23976 L
.6953 .23976 L
.6963 .23976 L
.6973 .23976 L
.6983 .23976 L
Mistroke
.6993 .23715 L
.7003 .23715 L
.7013 .23715 L
.7023 .23715 L
.7033 .23715 L
.7043 .23715 L
.70529 .23715 L
.70629 .23715 L
.70729 .23715 L
.70829 .23715 L
.70929 .23715 L
.71029 .23715 L
.71129 .23715 L
.71229 .23715 L
.71329 .23715 L
.71429 .23715 L
.71528 .23715 L
.71628 .23715 L
.71728 .23715 L
.71828 .23715 L
.71928 .23715 L
.72028 .23715 L
.72128 .23715 L
.72228 .23715 L
.72328 .23715 L
.72428 .23715 L
.72527 .23715 L
.72627 .23715 L
.72727 .23715 L
.72827 .23715 L
.72927 .23715 L
.73027 .23715 L
.73127 .23715 L
.73227 .23715 L
.73327 .23715 L
.73427 .23715 L
.73526 .23715 L
.73626 .23715 L
.73726 .23715 L
.73826 .23715 L
.73926 .23715 L
.74026 .23715 L
.74126 .23715 L
.74226 .23715 L
.74326 .23715 L
.74426 .23715 L
.74525 .23715 L
.74625 .23715 L
.74725 .23715 L
.74825 .23715 L
Mistroke
.74925 .25354 L
.75025 .25354 L
.75125 .25354 L
.75225 .25354 L
.75325 .25354 L
.75425 .25354 L
.75524 .25354 L
.75624 .25354 L
.75724 .25354 L
.75824 .25354 L
.75924 .25354 L
.76024 .25354 L
.76124 .25354 L
.76224 .25354 L
.76324 .25354 L
.76424 .25354 L
.76523 .25354 L
.76623 .25354 L
.76723 .25354 L
.76823 .25354 L
.76923 .25354 L
.77023 .25354 L
.77123 .25354 L
.77223 .25354 L
.77323 .25354 L
.77423 .25354 L
.77522 .25354 L
.77622 .25354 L
.77722 .25354 L
.77822 .25354 L
.77922 .25354 L
.78022 .25354 L
.78122 .25354 L
.78222 .25354 L
.78322 .25354 L
.78422 .25354 L
.78521 .25354 L
.78621 .25354 L
.78721 .25354 L
.78821 .25354 L
.78921 .25354 L
.79021 .25354 L
.79121 .25354 L
.79221 .25354 L
.79321 .25354 L
.79421 .25354 L
.7952 .25354 L
.7962 .25354 L
.7972 .25354 L
.7982 .25354 L
Mistroke
.7992 .25056 L
.8002 .25056 L
.8012 .25056 L
.8022 .25056 L
.8032 .25056 L
.8042 .25056 L
.80519 .25056 L
.80619 .25056 L
.80719 .25056 L
.80819 .25056 L
.80919 .25056 L
.81019 .25056 L
.81119 .25056 L
.81219 .25056 L
.81319 .25056 L
.81419 .25056 L
.81518 .25056 L
.81618 .25056 L
.81718 .25056 L
.81818 .25056 L
.81918 .25056 L
.82018 .25056 L
.82118 .25056 L
.82218 .25056 L
.82318 .25056 L
.82418 .25056 L
.82517 .25056 L
.82617 .25056 L
.82717 .25056 L
.82817 .25056 L
.82917 .25056 L
.83017 .25056 L
.83117 .25056 L
.83217 .25056 L
.83317 .25056 L
.83417 .25056 L
.83516 .25056 L
.83616 .25056 L
.83716 .25056 L
.83816 .25056 L
.83916 .25056 L
.84016 .25056 L
.84116 .25056 L
.84216 .25056 L
.84316 .25056 L
.84416 .25056 L
.84515 .25056 L
.84615 .25056 L
.84715 .25056 L
.84815 .25056 L
Mistroke
.84915 .25593 L
.85015 .25593 L
.85115 .25593 L
.85215 .25593 L
.85315 .25593 L
.85415 .25593 L
.85514 .25593 L
.85614 .25593 L
.85714 .25593 L
.85814 .25593 L
.85914 .25593 L
.86014 .25593 L
.86114 .25593 L
.86214 .25593 L
.86314 .25593 L
.86414 .25593 L
.86513 .25593 L
.86613 .25593 L
.86713 .25593 L
.86813 .25593 L
.86913 .25593 L
.87013 .25593 L
.87113 .25593 L
.87213 .25593 L
.87313 .25593 L
.87413 .25593 L
.87512 .25593 L
.87612 .25593 L
.87712 .25593 L
.87812 .25593 L
.87912 .25593 L
.88012 .25593 L
.88112 .25593 L
.88212 .25593 L
.88312 .25593 L
.88412 .25593 L
.88511 .25593 L
.88611 .25593 L
.88711 .25593 L
.88811 .25593 L
.88911 .25593 L
.89011 .25593 L
.89111 .25593 L
.89211 .25593 L
.89311 .25593 L
.89411 .25593 L
.8951 .25593 L
.8961 .25593 L
.8971 .25593 L
.8981 .25593 L
Mistroke
.8991 .25591 L
.9001 .25591 L
.9011 .25591 L
.9021 .25591 L
.9031 .25591 L
.9041 .25591 L
.90509 .25591 L
.90609 .25591 L
.90709 .25591 L
.90809 .25591 L
.90909 .25591 L
.91009 .25591 L
.91109 .25591 L
.91209 .25591 L
.91309 .25591 L
.91409 .25591 L
.91508 .25591 L
.91608 .25591 L
.91708 .25591 L
.91808 .25591 L
.91908 .25591 L
.92008 .25591 L
.92108 .25591 L
.92208 .25591 L
.92308 .25591 L
.92408 .25591 L
.92507 .25591 L
.92607 .25591 L
.92707 .25591 L
.92807 .25591 L
.92907 .25591 L
.93007 .25591 L
.93107 .25591 L
.93207 .25591 L
.93307 .25591 L
.93407 .25591 L
.93506 .25591 L
.93606 .25591 L
.93706 .25591 L
.93806 .25591 L
.93906 .25591 L
.94006 .25591 L
.94106 .25591 L
.94206 .25591 L
.94306 .25591 L
.94406 .25591 L
.94505 .25591 L
.94605 .25591 L
.94705 .25591 L
.94805 .25591 L
Mistroke
.94905 .25519 L
.95005 .25519 L
.95105 .25519 L
.95205 .25519 L
.95305 .25519 L
.95405 .25519 L
.95504 .25519 L
.95604 .25519 L
.95704 .25519 L
.95804 .25519 L
.95904 .25519 L
.96004 .25519 L
.96104 .25519 L
.96204 .25519 L
.96304 .25519 L
.96404 .25519 L
.96503 .25519 L
.96603 .25519 L
.96703 .25519 L
.96803 .25519 L
.96903 .25519 L
.97003 .25519 L
.97103 .25519 L
.97203 .25519 L
.97303 .25519 L
.97403 .25519 L
.97502 .25519 L
.97602 .25519 L
.97702 .25519 L
.97802 .25519 L
.97902 .25519 L
.98002 .25519 L
.98102 .25519 L
.98202 .25519 L
.98302 .25519 L
.98402 .25519 L
.98501 .25519 L
.98601 .25519 L
.98701 .25519 L
.98801 .25519 L
.98901 .25519 L
.99001 .25519 L
.99101 .25519 L
.99201 .25519 L
.99301 .25519 L
.99401 .25519 L
.995 .25519 L
.996 .25519 L
.997 .25519 L
.998 .25519 L
Mistroke
.999 .25079 L
Mfstroke
gsave
.999 .26898 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .5052 m
.001 .5052 L
.002 .5052 L
.003 .5052 L
.004 .5052 L
.005 .5052 L
.00599 .5052 L
.00699 .5052 L
.00799 .5052 L
.00899 .5052 L
.00999 .5052 L
.01099 .5052 L
.01199 .5052 L
.01299 .5052 L
.01399 .5052 L
.01499 .5052 L
.01598 .5052 L
.01698 .5052 L
.01798 .5052 L
.01898 .5052 L
.01998 .5052 L
.02098 .5052 L
.02198 .5052 L
.02298 .5052 L
.02398 .5052 L
.02498 .5052 L
.02597 .5052 L
.02697 .5052 L
.02797 .5052 L
.02897 .5052 L
.02997 .5052 L
.03097 .5052 L
.03197 .5052 L
.03297 .5052 L
.03397 .5052 L
.03497 .5052 L
.03596 .5052 L
.03696 .5052 L
.03796 .5052 L
.03896 .5052 L
.03996 .5052 L
.04096 .5052 L
.04196 .5052 L
.04296 .5052 L
.04396 .5052 L
.04496 .5052 L
.04595 .5052 L
.04695 .5052 L
.04795 .5052 L
.04895 .5052 L
Mistroke
.04995 .4758 L
.05095 .4758 L
.05195 .4758 L
.05295 .4758 L
.05395 .4758 L
.05495 .4758 L
.05594 .4758 L
.05694 .4758 L
.05794 .4758 L
.05894 .4758 L
.05994 .4758 L
.06094 .4758 L
.06194 .4758 L
.06294 .4758 L
.06394 .4758 L
.06494 .4758 L
.06593 .4758 L
.06693 .4758 L
.06793 .4758 L
.06893 .4758 L
.06993 .4758 L
.07093 .4758 L
.07193 .4758 L
.07293 .4758 L
.07393 .4758 L
.07493 .4758 L
.07592 .4758 L
.07692 .4758 L
.07792 .4758 L
.07892 .4758 L
.07992 .4758 L
.08092 .4758 L
.08192 .4758 L
.08292 .4758 L
.08392 .4758 L
.08492 .4758 L
.08591 .4758 L
.08691 .4758 L
.08791 .4758 L
.08891 .4758 L
.08991 .4758 L
.09091 .4758 L
.09191 .4758 L
.09291 .4758 L
.09391 .4758 L
.09491 .4758 L
.0959 .4758 L
.0969 .4758 L
.0979 .4758 L
.0989 .4758 L
Mistroke
.0999 .49584 L
.1009 .49584 L
.1019 .49584 L
.1029 .49584 L
.1039 .49584 L
.1049 .49584 L
.10589 .49584 L
.10689 .49584 L
.10789 .49584 L
.10889 .49584 L
.10989 .49584 L
.11089 .49584 L
.11189 .49584 L
.11289 .49584 L
.11389 .49584 L
.11489 .49584 L
.11588 .49584 L
.11688 .49584 L
.11788 .49584 L
.11888 .49584 L
.11988 .49584 L
.12088 .49584 L
.12188 .49584 L
.12288 .49584 L
.12388 .49584 L
.12488 .49584 L
.12587 .49584 L
.12687 .49584 L
.12787 .49584 L
.12887 .49584 L
.12987 .49584 L
.13087 .49584 L
.13187 .49584 L
.13287 .49584 L
.13387 .49584 L
.13487 .49584 L
.13586 .49584 L
.13686 .49584 L
.13786 .49584 L
.13886 .49584 L
.13986 .49584 L
.14086 .49584 L
.14186 .49584 L
.14286 .49584 L
.14386 .49584 L
.14486 .49584 L
.14585 .49584 L
.14685 .49584 L
.14785 .49584 L
.14885 .49584 L
Mistroke
.14985 .17916 L
.15085 .17916 L
.15185 .17916 L
.15285 .17916 L
.15385 .17916 L
.15485 .17916 L
.15584 .17916 L
.15684 .17916 L
.15784 .17916 L
.15884 .17916 L
.15984 .17916 L
.16084 .17916 L
.16184 .17916 L
.16284 .17916 L
.16384 .17916 L
.16484 .17916 L
.16583 .17916 L
.16683 .17916 L
.16783 .17916 L
.16883 .17916 L
.16983 .17916 L
.17083 .17916 L
.17183 .17916 L
.17283 .17916 L
.17383 .17916 L
.17483 .17916 L
.17582 .17916 L
.17682 .17916 L
.17782 .17916 L
.17882 .17916 L
.17982 .17916 L
.18082 .17916 L
.18182 .17916 L
.18282 .17916 L
.18382 .17916 L
.18482 .17916 L
.18581 .17916 L
.18681 .17916 L
.18781 .17916 L
.18881 .17916 L
.18981 .17916 L
.19081 .17916 L
.19181 .17916 L
.19281 .17916 L
.19381 .17916 L
.19481 .17916 L
.1958 .17916 L
.1968 .17916 L
.1978 .17916 L
.1988 .17916 L
Mistroke
.1998 .21571 L
.2008 .21571 L
.2018 .21571 L
.2028 .21571 L
.2038 .21571 L
.2048 .21571 L
.20579 .21571 L
.20679 .21571 L
.20779 .21571 L
.20879 .21571 L
.20979 .21571 L
.21079 .21571 L
.21179 .21571 L
.21279 .21571 L
.21379 .21571 L
.21479 .21571 L
.21578 .21571 L
.21678 .21571 L
.21778 .21571 L
.21878 .21571 L
.21978 .21571 L
.22078 .21571 L
.22178 .21571 L
.22278 .21571 L
.22378 .21571 L
.22478 .21571 L
.22577 .21571 L
.22677 .21571 L
.22777 .21571 L
.22877 .21571 L
.22977 .21571 L
.23077 .21571 L
.23177 .21571 L
.23277 .21571 L
.23377 .21571 L
.23477 .21571 L
.23576 .21571 L
.23676 .21571 L
.23776 .21571 L
.23876 .21571 L
.23976 .21571 L
.24076 .21571 L
.24176 .21571 L
.24276 .21571 L
.24376 .21571 L
.24476 .21571 L
.24575 .21571 L
.24675 .21571 L
.24775 .21571 L
.24875 .21571 L
Mistroke
.24975 .22138 L
.25075 .22138 L
.25175 .22138 L
.25275 .22138 L
.25375 .22138 L
.25475 .22138 L
.25574 .22138 L
.25674 .22138 L
.25774 .22138 L
.25874 .22138 L
.25974 .22138 L
.26074 .22138 L
.26174 .22138 L
.26274 .22138 L
.26374 .22138 L
.26474 .22138 L
.26573 .22138 L
.26673 .22138 L
.26773 .22138 L
.26873 .22138 L
.26973 .22138 L
.27073 .22138 L
.27173 .22138 L
.27273 .22138 L
.27373 .22138 L
.27473 .22138 L
.27572 .22138 L
.27672 .22138 L
.27772 .22138 L
.27872 .22138 L
.27972 .22138 L
.28072 .22138 L
.28172 .22138 L
.28272 .22138 L
.28372 .22138 L
.28472 .22138 L
.28571 .22138 L
.28671 .22138 L
.28771 .22138 L
.28871 .22138 L
.28971 .22138 L
.29071 .22138 L
.29171 .22138 L
.29271 .22138 L
.29371 .22138 L
.29471 .22138 L
.2957 .22138 L
.2967 .22138 L
.2977 .22138 L
.2987 .22138 L
Mistroke
.2997 .23723 L
.3007 .23723 L
.3017 .23723 L
.3027 .23723 L
.3037 .23723 L
.3047 .23723 L
.30569 .23723 L
.30669 .23723 L
.30769 .23723 L
.30869 .23723 L
.30969 .23723 L
.31069 .23723 L
.31169 .23723 L
.31269 .23723 L
.31369 .23723 L
.31469 .23723 L
.31568 .23723 L
.31668 .23723 L
.31768 .23723 L
.31868 .23723 L
.31968 .23723 L
.32068 .23723 L
.32168 .23723 L
.32268 .23723 L
.32368 .23723 L
.32468 .23723 L
.32567 .23723 L
.32667 .23723 L
.32767 .23723 L
.32867 .23723 L
.32967 .23723 L
.33067 .23723 L
.33167 .23723 L
.33267 .23723 L
.33367 .23723 L
.33467 .23723 L
.33566 .23723 L
.33666 .23723 L
.33766 .23723 L
.33866 .23723 L
.33966 .23723 L
.34066 .23723 L
.34166 .23723 L
.34266 .23723 L
.34366 .23723 L
.34466 .23723 L
.34565 .23723 L
.34665 .23723 L
.34765 .23723 L
.34865 .23723 L
Mistroke
.34965 .24952 L
.35065 .24952 L
.35165 .24952 L
.35265 .24952 L
.35365 .24952 L
.35465 .24952 L
.35564 .24952 L
.35664 .24952 L
.35764 .24952 L
.35864 .24952 L
.35964 .24952 L
.36064 .24952 L
.36164 .24952 L
.36264 .24952 L
.36364 .24952 L
.36464 .24952 L
.36563 .24952 L
.36663 .24952 L
.36763 .24952 L
.36863 .24952 L
.36963 .24952 L
.37063 .24952 L
.37163 .24952 L
.37263 .24952 L
.37363 .24952 L
.37463 .24952 L
.37562 .24952 L
.37662 .24952 L
.37762 .24952 L
.37862 .24952 L
.37962 .24952 L
.38062 .24952 L
.38162 .24952 L
.38262 .24952 L
.38362 .24952 L
.38462 .24952 L
.38561 .24952 L
.38661 .24952 L
.38761 .24952 L
.38861 .24952 L
.38961 .24952 L
.39061 .24952 L
.39161 .24952 L
.39261 .24952 L
.39361 .24952 L
.39461 .24952 L
.3956 .24952 L
.3966 .24952 L
.3976 .24952 L
.3986 .24952 L
Mistroke
.3996 .25345 L
.4006 .25345 L
.4016 .25345 L
.4026 .25345 L
.4036 .25345 L
.4046 .25345 L
.40559 .25345 L
.40659 .25345 L
.40759 .25345 L
.40859 .25345 L
.40959 .25345 L
.41059 .25345 L
.41159 .25345 L
.41259 .25345 L
.41359 .25345 L
.41459 .25345 L
.41558 .25345 L
.41658 .25345 L
.41758 .25345 L
.41858 .25345 L
.41958 .25345 L
.42058 .25345 L
.42158 .25345 L
.42258 .25345 L
.42358 .25345 L
.42458 .25345 L
.42557 .25345 L
.42657 .25345 L
.42757 .25345 L
.42857 .25345 L
.42957 .25345 L
.43057 .25345 L
.43157 .25345 L
.43257 .25345 L
.43357 .25345 L
.43457 .25345 L
.43556 .25345 L
.43656 .25345 L
.43756 .25345 L
.43856 .25345 L
.43956 .25345 L
.44056 .25345 L
.44156 .25345 L
.44256 .25345 L
.44356 .25345 L
.44456 .25345 L
.44555 .25345 L
.44655 .25345 L
.44755 .25345 L
.44855 .25345 L
Mistroke
.44955 .24109 L
.45055 .24109 L
.45155 .24109 L
.45255 .24109 L
.45355 .24109 L
.45455 .24109 L
.45554 .24109 L
.45654 .24109 L
.45754 .24109 L
.45854 .24109 L
.45954 .24109 L
.46054 .24109 L
.46154 .24109 L
.46254 .24109 L
.46354 .24109 L
.46454 .24109 L
.46553 .24109 L
.46653 .24109 L
.46753 .24109 L
.46853 .24109 L
.46953 .24109 L
.47053 .24109 L
.47153 .24109 L
.47253 .24109 L
.47353 .24109 L
.47453 .24109 L
.47552 .24109 L
.47652 .24109 L
.47752 .24109 L
.47852 .24109 L
.47952 .24109 L
.48052 .24109 L
.48152 .24109 L
.48252 .24109 L
.48352 .24109 L
.48452 .24109 L
.48551 .24109 L
.48651 .24109 L
.48751 .24109 L
.48851 .24109 L
.48951 .24109 L
.49051 .24109 L
.49151 .24109 L
.49251 .24109 L
.49351 .24109 L
.49451 .24109 L
.4955 .24109 L
.4965 .24109 L
.4975 .24109 L
.4985 .24109 L
Mistroke
.4995 .26185 L
.5005 .26185 L
.5015 .26185 L
.5025 .26185 L
.5035 .26185 L
.5045 .26185 L
.50549 .26185 L
.50649 .26185 L
.50749 .26185 L
.50849 .26185 L
.50949 .26185 L
.51049 .26185 L
.51149 .26185 L
.51249 .26185 L
.51349 .26185 L
.51449 .26185 L
.51548 .26185 L
.51648 .26185 L
.51748 .26185 L
.51848 .26185 L
.51948 .26185 L
.52048 .26185 L
.52148 .26185 L
.52248 .26185 L
.52348 .26185 L
.52448 .26185 L
.52547 .26185 L
.52647 .26185 L
.52747 .26185 L
.52847 .26185 L
.52947 .26185 L
.53047 .26185 L
.53147 .26185 L
.53247 .26185 L
.53347 .26185 L
.53447 .26185 L
.53546 .26185 L
.53646 .26185 L
.53746 .26185 L
.53846 .26185 L
.53946 .26185 L
.54046 .26185 L
.54146 .26185 L
.54246 .26185 L
.54346 .26185 L
.54446 .26185 L
.54545 .26185 L
.54645 .26185 L
.54745 .26185 L
.54845 .26185 L
Mistroke
.54945 .27288 L
.55045 .27288 L
.55145 .27288 L
.55245 .27288 L
.55345 .27288 L
.55445 .27288 L
.55544 .27288 L
.55644 .27288 L
.55744 .27288 L
.55844 .27288 L
.55944 .27288 L
.56044 .27288 L
.56144 .27288 L
.56244 .27288 L
.56344 .27288 L
.56444 .27288 L
.56543 .27288 L
.56643 .27288 L
.56743 .27288 L
.56843 .27288 L
.56943 .27288 L
.57043 .27288 L
.57143 .27288 L
.57243 .27288 L
.57343 .27288 L
.57443 .27288 L
.57542 .27288 L
.57642 .27288 L
.57742 .27288 L
.57842 .27288 L
.57942 .27288 L
.58042 .27288 L
.58142 .27288 L
.58242 .27288 L
.58342 .27288 L
.58442 .27288 L
.58541 .27288 L
.58641 .27288 L
.58741 .27288 L
.58841 .27288 L
.58941 .27288 L
.59041 .27288 L
.59141 .27288 L
.59241 .27288 L
.59341 .27288 L
.59441 .27288 L
.5954 .27288 L
.5964 .27288 L
.5974 .27288 L
.5984 .27288 L
Mistroke
.5994 .26059 L
.6004 .26059 L
.6014 .26059 L
.6024 .26059 L
.6034 .26059 L
.6044 .26059 L
.60539 .26059 L
.60639 .26059 L
.60739 .26059 L
.60839 .26059 L
.60939 .26059 L
.61039 .26059 L
.61139 .26059 L
.61239 .26059 L
.61339 .26059 L
.61439 .26059 L
.61538 .26059 L
.61638 .26059 L
.61738 .26059 L
.61838 .26059 L
.61938 .26059 L
.62038 .26059 L
.62138 .26059 L
.62238 .26059 L
.62338 .26059 L
.62438 .26059 L
.62537 .26059 L
.62637 .26059 L
.62737 .26059 L
.62837 .26059 L
.62937 .26059 L
.63037 .26059 L
.63137 .26059 L
.63237 .26059 L
.63337 .26059 L
.63437 .26059 L
.63536 .26059 L
.63636 .26059 L
.63736 .26059 L
.63836 .26059 L
.63936 .26059 L
.64036 .26059 L
.64136 .26059 L
.64236 .26059 L
.64336 .26059 L
.64436 .26059 L
.64535 .26059 L
.64635 .26059 L
.64735 .26059 L
.64835 .26059 L
Mistroke
.64935 .26262 L
.65035 .26262 L
.65135 .26262 L
.65235 .26262 L
.65335 .26262 L
.65435 .26262 L
.65534 .26262 L
.65634 .26262 L
.65734 .26262 L
.65834 .26262 L
.65934 .26262 L
.66034 .26262 L
.66134 .26262 L
.66234 .26262 L
.66334 .26262 L
.66434 .26262 L
.66533 .26262 L
.66633 .26262 L
.66733 .26262 L
.66833 .26262 L
.66933 .26262 L
.67033 .26262 L
.67133 .26262 L
.67233 .26262 L
.67333 .26262 L
.67433 .26262 L
.67532 .26262 L
.67632 .26262 L
.67732 .26262 L
.67832 .26262 L
.67932 .26262 L
.68032 .26262 L
.68132 .26262 L
.68232 .26262 L
.68332 .26262 L
.68432 .26262 L
.68531 .26262 L
.68631 .26262 L
.68731 .26262 L
.68831 .26262 L
.68931 .26262 L
.69031 .26262 L
.69131 .26262 L
.69231 .26262 L
.69331 .26262 L
.69431 .26262 L
.6953 .26262 L
.6963 .26262 L
.6973 .26262 L
.6983 .26262 L
Mistroke
.6993 .25848 L
.7003 .25848 L
.7013 .25848 L
.7023 .25848 L
.7033 .25848 L
.7043 .25848 L
.70529 .25848 L
.70629 .25848 L
.70729 .25848 L
.70829 .25848 L
.70929 .25848 L
.71029 .25848 L
.71129 .25848 L
.71229 .25848 L
.71329 .25848 L
.71429 .25848 L
.71528 .25848 L
.71628 .25848 L
.71728 .25848 L
.71828 .25848 L
.71928 .25848 L
.72028 .25848 L
.72128 .25848 L
.72228 .25848 L
.72328 .25848 L
.72428 .25848 L
.72527 .25848 L
.72627 .25848 L
.72727 .25848 L
.72827 .25848 L
.72927 .25848 L
.73027 .25848 L
.73127 .25848 L
.73227 .25848 L
.73327 .25848 L
.73427 .25848 L
.73526 .25848 L
.73626 .25848 L
.73726 .25848 L
.73826 .25848 L
.73926 .25848 L
.74026 .25848 L
.74126 .25848 L
.74226 .25848 L
.74326 .25848 L
.74426 .25848 L
.74525 .25848 L
.74625 .25848 L
.74725 .25848 L
.74825 .25848 L
Mistroke
.74925 .27315 L
.75025 .27315 L
.75125 .27315 L
.75225 .27315 L
.75325 .27315 L
.75425 .27315 L
.75524 .27315 L
.75624 .27315 L
.75724 .27315 L
.75824 .27315 L
.75924 .27315 L
.76024 .27315 L
.76124 .27315 L
.76224 .27315 L
.76324 .27315 L
.76424 .27315 L
.76523 .27315 L
.76623 .27315 L
.76723 .27315 L
.76823 .27315 L
.76923 .27315 L
.77023 .27315 L
.77123 .27315 L
.77223 .27315 L
.77323 .27315 L
.77423 .27315 L
.77522 .27315 L
.77622 .27315 L
.77722 .27315 L
.77822 .27315 L
.77922 .27315 L
.78022 .27315 L
.78122 .27315 L
.78222 .27315 L
.78322 .27315 L
.78422 .27315 L
.78521 .27315 L
.78621 .27315 L
.78721 .27315 L
.78821 .27315 L
.78921 .27315 L
.79021 .27315 L
.79121 .27315 L
.79221 .27315 L
.79321 .27315 L
.79421 .27315 L
.7952 .27315 L
.7962 .27315 L
.7972 .27315 L
.7982 .27315 L
Mistroke
.7992 .27002 L
.8002 .27002 L
.8012 .27002 L
.8022 .27002 L
.8032 .27002 L
.8042 .27002 L
.80519 .27002 L
.80619 .27002 L
.80719 .27002 L
.80819 .27002 L
.80919 .27002 L
.81019 .27002 L
.81119 .27002 L
.81219 .27002 L
.81319 .27002 L
.81419 .27002 L
.81518 .27002 L
.81618 .27002 L
.81718 .27002 L
.81818 .27002 L
.81918 .27002 L
.82018 .27002 L
.82118 .27002 L
.82218 .27002 L
.82318 .27002 L
.82418 .27002 L
.82517 .27002 L
.82617 .27002 L
.82717 .27002 L
.82817 .27002 L
.82917 .27002 L
.83017 .27002 L
.83117 .27002 L
.83217 .27002 L
.83317 .27002 L
.83417 .27002 L
.83516 .27002 L
.83616 .27002 L
.83716 .27002 L
.83816 .27002 L
.83916 .27002 L
.84016 .27002 L
.84116 .27002 L
.84216 .27002 L
.84316 .27002 L
.84416 .27002 L
.84515 .27002 L
.84615 .27002 L
.84715 .27002 L
.84815 .27002 L
Mistroke
.84915 .27506 L
.85015 .27506 L
.85115 .27506 L
.85215 .27506 L
.85315 .27506 L
.85415 .27506 L
.85514 .27506 L
.85614 .27506 L
.85714 .27506 L
.85814 .27506 L
.85914 .27506 L
.86014 .27506 L
.86114 .27506 L
.86214 .27506 L
.86314 .27506 L
.86414 .27506 L
.86513 .27506 L
.86613 .27506 L
.86713 .27506 L
.86813 .27506 L
.86913 .27506 L
.87013 .27506 L
.87113 .27506 L
.87213 .27506 L
.87313 .27506 L
.87413 .27506 L
.87512 .27506 L
.87612 .27506 L
.87712 .27506 L
.87812 .27506 L
.87912 .27506 L
.88012 .27506 L
.88112 .27506 L
.88212 .27506 L
.88312 .27506 L
.88412 .27506 L
.88511 .27506 L
.88611 .27506 L
.88711 .27506 L
.88811 .27506 L
.88911 .27506 L
.89011 .27506 L
.89111 .27506 L
.89211 .27506 L
.89311 .27506 L
.89411 .27506 L
.8951 .27506 L
.8961 .27506 L
.8971 .27506 L
.8981 .27506 L
Mistroke
.8991 .27497 L
.9001 .27497 L
.9011 .27497 L
.9021 .27497 L
.9031 .27497 L
.9041 .27497 L
.90509 .27497 L
.90609 .27497 L
.90709 .27497 L
.90809 .27497 L
.90909 .27497 L
.91009 .27497 L
.91109 .27497 L
.91209 .27497 L
.91309 .27497 L
.91409 .27497 L
.91508 .27497 L
.91608 .27497 L
.91708 .27497 L
.91808 .27497 L
.91908 .27497 L
.92008 .27497 L
.92108 .27497 L
.92208 .27497 L
.92308 .27497 L
.92408 .27497 L
.92507 .27497 L
.92607 .27497 L
.92707 .27497 L
.92807 .27497 L
.92907 .27497 L
.93007 .27497 L
.93107 .27497 L
.93207 .27497 L
.93307 .27497 L
.93407 .27497 L
.93506 .27497 L
.93606 .27497 L
.93706 .27497 L
.93806 .27497 L
.93906 .27497 L
.94006 .27497 L
.94106 .27497 L
.94206 .27497 L
.94306 .27497 L
.94406 .27497 L
.94505 .27497 L
.94605 .27497 L
.94705 .27497 L
.94805 .27497 L
Mistroke
.94905 .27412 L
.95005 .27412 L
.95105 .27412 L
.95205 .27412 L
.95305 .27412 L
.95405 .27412 L
.95504 .27412 L
.95604 .27412 L
.95704 .27412 L
.95804 .27412 L
.95904 .27412 L
.96004 .27412 L
.96104 .27412 L
.96204 .27412 L
.96304 .27412 L
.96404 .27412 L
.96503 .27412 L
.96603 .27412 L
.96703 .27412 L
.96803 .27412 L
.96903 .27412 L
.97003 .27412 L
.97103 .27412 L
.97203 .27412 L
.97303 .27412 L
.97403 .27412 L
.97502 .27412 L
.97602 .27412 L
.97702 .27412 L
.97802 .27412 L
.97902 .27412 L
.98002 .27412 L
.98102 .27412 L
.98202 .27412 L
.98302 .27412 L
.98402 .27412 L
.98501 .27412 L
.98601 .27412 L
.98701 .27412 L
.98801 .27412 L
.98901 .27412 L
.99001 .27412 L
.99101 .27412 L
.99201 .27412 L
.99301 .27412 L
.99401 .27412 L
.995 .27412 L
.996 .27412 L
.997 .27412 L
.998 .27412 L
Mistroke
.999 .26898 L
Mfstroke
1 0 0 r
gsave
.999 .25988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .41202 m
.001 .41202 L
.002 .41202 L
.003 .41202 L
.004 .41202 L
.005 .41202 L
.00599 .41202 L
.00699 .41202 L
.00799 .41202 L
.00899 .41202 L
.00999 .41202 L
.01099 .41202 L
.01199 .41202 L
.01299 .41202 L
.01399 .41202 L
.01499 .41202 L
.01598 .41202 L
.01698 .41202 L
.01798 .41202 L
.01898 .41202 L
.01998 .41202 L
.02098 .41202 L
.02198 .41202 L
.02298 .41202 L
.02398 .41202 L
.02498 .41202 L
.02597 .41202 L
.02697 .41202 L
.02797 .41202 L
.02897 .41202 L
.02997 .41202 L
.03097 .41202 L
.03197 .41202 L
.03297 .41202 L
.03397 .41202 L
.03497 .41202 L
.03596 .41202 L
.03696 .41202 L
.03796 .41202 L
.03896 .41202 L
.03996 .41202 L
.04096 .41202 L
.04196 .41202 L
.04296 .41202 L
.04396 .41202 L
.04496 .41202 L
.04595 .41202 L
.04695 .41202 L
.04795 .41202 L
.04895 .41202 L
Mistroke
.04995 .38265 L
.05095 .38265 L
.05195 .38265 L
.05295 .38265 L
.05395 .38265 L
.05495 .38265 L
.05594 .38265 L
.05694 .38265 L
.05794 .38265 L
.05894 .38265 L
.05994 .38265 L
.06094 .38265 L
.06194 .38265 L
.06294 .38265 L
.06394 .38265 L
.06494 .38265 L
.06593 .38265 L
.06693 .38265 L
.06793 .38265 L
.06893 .38265 L
.06993 .38265 L
.07093 .38265 L
.07193 .38265 L
.07293 .38265 L
.07393 .38265 L
.07493 .38265 L
.07592 .38265 L
.07692 .38265 L
.07792 .38265 L
.07892 .38265 L
.07992 .38265 L
.08092 .38265 L
.08192 .38265 L
.08292 .38265 L
.08392 .38265 L
.08492 .38265 L
.08591 .38265 L
.08691 .38265 L
.08791 .38265 L
.08891 .38265 L
.08991 .38265 L
.09091 .38265 L
.09191 .38265 L
.09291 .38265 L
.09391 .38265 L
.09491 .38265 L
.0959 .38265 L
.0969 .38265 L
.0979 .38265 L
.0989 .38265 L
Mistroke
.0999 .43262 L
.1009 .43262 L
.1019 .43262 L
.1029 .43262 L
.1039 .43262 L
.1049 .43262 L
.10589 .43262 L
.10689 .43262 L
.10789 .43262 L
.10889 .43262 L
.10989 .43262 L
.11089 .43262 L
.11189 .43262 L
.11289 .43262 L
.11389 .43262 L
.11489 .43262 L
.11588 .43262 L
.11688 .43262 L
.11788 .43262 L
.11888 .43262 L
.11988 .43262 L
.12088 .43262 L
.12188 .43262 L
.12288 .43262 L
.12388 .43262 L
.12488 .43262 L
.12587 .43262 L
.12687 .43262 L
.12787 .43262 L
.12887 .43262 L
.12987 .43262 L
.13087 .43262 L
.13187 .43262 L
.13287 .43262 L
.13387 .43262 L
.13487 .43262 L
.13586 .43262 L
.13686 .43262 L
.13786 .43262 L
.13886 .43262 L
.13986 .43262 L
.14086 .43262 L
.14186 .43262 L
.14286 .43262 L
.14386 .43262 L
.14486 .43262 L
.14585 .43262 L
.14685 .43262 L
.14785 .43262 L
.14885 .43262 L
Mistroke
.14985 .15314 L
.15085 .15314 L
.15185 .15314 L
.15285 .15314 L
.15385 .15314 L
.15485 .15314 L
.15584 .15314 L
.15684 .15314 L
.15784 .15314 L
.15884 .15314 L
.15984 .15314 L
.16084 .15314 L
.16184 .15314 L
.16284 .15314 L
.16384 .15314 L
.16484 .15314 L
.16583 .15314 L
.16683 .15314 L
.16783 .15314 L
.16883 .15314 L
.16983 .15314 L
.17083 .15314 L
.17183 .15314 L
.17283 .15314 L
.17383 .15314 L
.17483 .15314 L
.17582 .15314 L
.17682 .15314 L
.17782 .15314 L
.17882 .15314 L
.17982 .15314 L
.18082 .15314 L
.18182 .15314 L
.18282 .15314 L
.18382 .15314 L
.18482 .15314 L
.18581 .15314 L
.18681 .15314 L
.18781 .15314 L
.18881 .15314 L
.18981 .15314 L
.19081 .15314 L
.19181 .15314 L
.19281 .15314 L
.19381 .15314 L
.19481 .15314 L
.1958 .15314 L
.1968 .15314 L
.1978 .15314 L
.1988 .15314 L
Mistroke
.1998 .19268 L
.2008 .19268 L
.2018 .19268 L
.2028 .19268 L
.2038 .19268 L
.2048 .19268 L
.20579 .19268 L
.20679 .19268 L
.20779 .19268 L
.20879 .19268 L
.20979 .19268 L
.21079 .19268 L
.21179 .19268 L
.21279 .19268 L
.21379 .19268 L
.21479 .19268 L
.21578 .19268 L
.21678 .19268 L
.21778 .19268 L
.21878 .19268 L
.21978 .19268 L
.22078 .19268 L
.22178 .19268 L
.22278 .19268 L
.22378 .19268 L
.22478 .19268 L
.22577 .19268 L
.22677 .19268 L
.22777 .19268 L
.22877 .19268 L
.22977 .19268 L
.23077 .19268 L
.23177 .19268 L
.23277 .19268 L
.23377 .19268 L
.23477 .19268 L
.23576 .19268 L
.23676 .19268 L
.23776 .19268 L
.23876 .19268 L
.23976 .19268 L
.24076 .19268 L
.24176 .19268 L
.24276 .19268 L
.24376 .19268 L
.24476 .19268 L
.24575 .19268 L
.24675 .19268 L
.24775 .19268 L
.24875 .19268 L
Mistroke
.24975 .19984 L
.25075 .19984 L
.25175 .19984 L
.25275 .19984 L
.25375 .19984 L
.25475 .19984 L
.25574 .19984 L
.25674 .19984 L
.25774 .19984 L
.25874 .19984 L
.25974 .19984 L
.26074 .19984 L
.26174 .19984 L
.26274 .19984 L
.26374 .19984 L
.26474 .19984 L
.26573 .19984 L
.26673 .19984 L
.26773 .19984 L
.26873 .19984 L
.26973 .19984 L
.27073 .19984 L
.27173 .19984 L
.27273 .19984 L
.27373 .19984 L
.27473 .19984 L
.27572 .19984 L
.27672 .19984 L
.27772 .19984 L
.27872 .19984 L
.27972 .19984 L
.28072 .19984 L
.28172 .19984 L
.28272 .19984 L
.28372 .19984 L
.28472 .19984 L
.28571 .19984 L
.28671 .19984 L
.28771 .19984 L
.28871 .19984 L
.28971 .19984 L
.29071 .19984 L
.29171 .19984 L
.29271 .19984 L
.29371 .19984 L
.29471 .19984 L
.2957 .19984 L
.2967 .19984 L
.2977 .19984 L
.2987 .19984 L
Mistroke
.2997 .21783 L
.3007 .21783 L
.3017 .21783 L
.3027 .21783 L
.3037 .21783 L
.3047 .21783 L
.30569 .21783 L
.30669 .21783 L
.30769 .21783 L
.30869 .21783 L
.30969 .21783 L
.31069 .21783 L
.31169 .21783 L
.31269 .21783 L
.31369 .21783 L
.31469 .21783 L
.31568 .21783 L
.31668 .21783 L
.31768 .21783 L
.31868 .21783 L
.31968 .21783 L
.32068 .21783 L
.32168 .21783 L
.32268 .21783 L
.32368 .21783 L
.32468 .21783 L
.32567 .21783 L
.32667 .21783 L
.32767 .21783 L
.32867 .21783 L
.32967 .21783 L
.33067 .21783 L
.33167 .21783 L
.33267 .21783 L
.33367 .21783 L
.33467 .21783 L
.33566 .21783 L
.33666 .21783 L
.33766 .21783 L
.33866 .21783 L
.33966 .21783 L
.34066 .21783 L
.34166 .21783 L
.34266 .21783 L
.34366 .21783 L
.34466 .21783 L
.34565 .21783 L
.34665 .21783 L
.34765 .21783 L
.34865 .21783 L
Mistroke
.34965 .23334 L
.35065 .23334 L
.35165 .23334 L
.35265 .23334 L
.35365 .23334 L
.35465 .23334 L
.35564 .23334 L
.35664 .23334 L
.35764 .23334 L
.35864 .23334 L
.35964 .23334 L
.36064 .23334 L
.36164 .23334 L
.36264 .23334 L
.36364 .23334 L
.36464 .23334 L
.36563 .23334 L
.36663 .23334 L
.36763 .23334 L
.36863 .23334 L
.36963 .23334 L
.37063 .23334 L
.37163 .23334 L
.37263 .23334 L
.37363 .23334 L
.37463 .23334 L
.37562 .23334 L
.37662 .23334 L
.37762 .23334 L
.37862 .23334 L
.37962 .23334 L
.38062 .23334 L
.38162 .23334 L
.38262 .23334 L
.38362 .23334 L
.38462 .23334 L
.38561 .23334 L
.38661 .23334 L
.38761 .23334 L
.38861 .23334 L
.38961 .23334 L
.39061 .23334 L
.39161 .23334 L
.39261 .23334 L
.39361 .23334 L
.39461 .23334 L
.3956 .23334 L
.3966 .23334 L
.3976 .23334 L
.3986 .23334 L
Mistroke
.3996 .23773 L
.4006 .23773 L
.4016 .23773 L
.4026 .23773 L
.4036 .23773 L
.4046 .23773 L
.40559 .23773 L
.40659 .23773 L
.40759 .23773 L
.40859 .23773 L
.40959 .23773 L
.41059 .23773 L
.41159 .23773 L
.41259 .23773 L
.41359 .23773 L
.41459 .23773 L
.41558 .23773 L
.41658 .23773 L
.41758 .23773 L
.41858 .23773 L
.41958 .23773 L
.42058 .23773 L
.42158 .23773 L
.42258 .23773 L
.42358 .23773 L
.42458 .23773 L
.42557 .23773 L
.42657 .23773 L
.42757 .23773 L
.42857 .23773 L
.42957 .23773 L
.43057 .23773 L
.43157 .23773 L
.43257 .23773 L
.43357 .23773 L
.43457 .23773 L
.43556 .23773 L
.43656 .23773 L
.43756 .23773 L
.43856 .23773 L
.43956 .23773 L
.44056 .23773 L
.44156 .23773 L
.44256 .23773 L
.44356 .23773 L
.44456 .23773 L
.44555 .23773 L
.44655 .23773 L
.44755 .23773 L
.44855 .23773 L
Mistroke
.44955 .22602 L
.45055 .22602 L
.45155 .22602 L
.45255 .22602 L
.45355 .22602 L
.45455 .22602 L
.45554 .22602 L
.45654 .22602 L
.45754 .22602 L
.45854 .22602 L
.45954 .22602 L
.46054 .22602 L
.46154 .22602 L
.46254 .22602 L
.46354 .22602 L
.46454 .22602 L
.46553 .22602 L
.46653 .22602 L
.46753 .22602 L
.46853 .22602 L
.46953 .22602 L
.47053 .22602 L
.47153 .22602 L
.47253 .22602 L
.47353 .22602 L
.47453 .22602 L
.47552 .22602 L
.47652 .22602 L
.47752 .22602 L
.47852 .22602 L
.47952 .22602 L
.48052 .22602 L
.48152 .22602 L
.48252 .22602 L
.48352 .22602 L
.48452 .22602 L
.48551 .22602 L
.48651 .22602 L
.48751 .22602 L
.48851 .22602 L
.48951 .22602 L
.49051 .22602 L
.49151 .22602 L
.49251 .22602 L
.49351 .22602 L
.49451 .22602 L
.4955 .22602 L
.4965 .22602 L
.4975 .22602 L
.4985 .22602 L
Mistroke
.4995 .2487 L
.5005 .2487 L
.5015 .2487 L
.5025 .2487 L
.5035 .2487 L
.5045 .2487 L
.50549 .2487 L
.50649 .2487 L
.50749 .2487 L
.50849 .2487 L
.50949 .2487 L
.51049 .2487 L
.51149 .2487 L
.51249 .2487 L
.51349 .2487 L
.51449 .2487 L
.51548 .2487 L
.51648 .2487 L
.51748 .2487 L
.51848 .2487 L
.51948 .2487 L
.52048 .2487 L
.52148 .2487 L
.52248 .2487 L
.52348 .2487 L
.52448 .2487 L
.52547 .2487 L
.52647 .2487 L
.52747 .2487 L
.52847 .2487 L
.52947 .2487 L
.53047 .2487 L
.53147 .2487 L
.53247 .2487 L
.53347 .2487 L
.53447 .2487 L
.53546 .2487 L
.53646 .2487 L
.53746 .2487 L
.53846 .2487 L
.53946 .2487 L
.54046 .2487 L
.54146 .2487 L
.54246 .2487 L
.54346 .2487 L
.54446 .2487 L
.54545 .2487 L
.54645 .2487 L
.54745 .2487 L
.54845 .2487 L
Mistroke
.54945 .26002 L
.55045 .26002 L
.55145 .26002 L
.55245 .26002 L
.55345 .26002 L
.55445 .26002 L
.55544 .26002 L
.55644 .26002 L
.55744 .26002 L
.55844 .26002 L
.55944 .26002 L
.56044 .26002 L
.56144 .26002 L
.56244 .26002 L
.56344 .26002 L
.56444 .26002 L
.56543 .26002 L
.56643 .26002 L
.56743 .26002 L
.56843 .26002 L
.56943 .26002 L
.57043 .26002 L
.57143 .26002 L
.57243 .26002 L
.57343 .26002 L
.57443 .26002 L
.57542 .26002 L
.57642 .26002 L
.57742 .26002 L
.57842 .26002 L
.57942 .26002 L
.58042 .26002 L
.58142 .26002 L
.58242 .26002 L
.58342 .26002 L
.58442 .26002 L
.58541 .26002 L
.58641 .26002 L
.58741 .26002 L
.58841 .26002 L
.58941 .26002 L
.59041 .26002 L
.59141 .26002 L
.59241 .26002 L
.59341 .26002 L
.59441 .26002 L
.5954 .26002 L
.5964 .26002 L
.5974 .26002 L
.5984 .26002 L
Mistroke
.5994 .24818 L
.6004 .24818 L
.6014 .24818 L
.6024 .24818 L
.6034 .24818 L
.6044 .24818 L
.60539 .24818 L
.60639 .24818 L
.60739 .24818 L
.60839 .24818 L
.60939 .24818 L
.61039 .24818 L
.61139 .24818 L
.61239 .24818 L
.61339 .24818 L
.61439 .24818 L
.61538 .24818 L
.61638 .24818 L
.61738 .24818 L
.61838 .24818 L
.61938 .24818 L
.62038 .24818 L
.62138 .24818 L
.62238 .24818 L
.62338 .24818 L
.62438 .24818 L
.62537 .24818 L
.62637 .24818 L
.62737 .24818 L
.62837 .24818 L
.62937 .24818 L
.63037 .24818 L
.63137 .24818 L
.63237 .24818 L
.63337 .24818 L
.63437 .24818 L
.63536 .24818 L
.63636 .24818 L
.63736 .24818 L
.63836 .24818 L
.63936 .24818 L
.64036 .24818 L
.64136 .24818 L
.64236 .24818 L
.64336 .24818 L
.64436 .24818 L
.64535 .24818 L
.64635 .24818 L
.64735 .24818 L
.64835 .24818 L
Mistroke
.64935 .25119 L
.65035 .25119 L
.65135 .25119 L
.65235 .25119 L
.65335 .25119 L
.65435 .25119 L
.65534 .25119 L
.65634 .25119 L
.65734 .25119 L
.65834 .25119 L
.65934 .25119 L
.66034 .25119 L
.66134 .25119 L
.66234 .25119 L
.66334 .25119 L
.66434 .25119 L
.66533 .25119 L
.66633 .25119 L
.66733 .25119 L
.66833 .25119 L
.66933 .25119 L
.67033 .25119 L
.67133 .25119 L
.67233 .25119 L
.67333 .25119 L
.67433 .25119 L
.67532 .25119 L
.67632 .25119 L
.67732 .25119 L
.67832 .25119 L
.67932 .25119 L
.68032 .25119 L
.68132 .25119 L
.68232 .25119 L
.68332 .25119 L
.68432 .25119 L
.68531 .25119 L
.68631 .25119 L
.68731 .25119 L
.68831 .25119 L
.68931 .25119 L
.69031 .25119 L
.69131 .25119 L
.69231 .25119 L
.69331 .25119 L
.69431 .25119 L
.6953 .25119 L
.6963 .25119 L
.6973 .25119 L
.6983 .25119 L
Mistroke
.6993 .24781 L
.7003 .24781 L
.7013 .24781 L
.7023 .24781 L
.7033 .24781 L
.7043 .24781 L
.70529 .24781 L
.70629 .24781 L
.70729 .24781 L
.70829 .24781 L
.70929 .24781 L
.71029 .24781 L
.71129 .24781 L
.71229 .24781 L
.71329 .24781 L
.71429 .24781 L
.71528 .24781 L
.71628 .24781 L
.71728 .24781 L
.71828 .24781 L
.71928 .24781 L
.72028 .24781 L
.72128 .24781 L
.72228 .24781 L
.72328 .24781 L
.72428 .24781 L
.72527 .24781 L
.72627 .24781 L
.72727 .24781 L
.72827 .24781 L
.72927 .24781 L
.73027 .24781 L
.73127 .24781 L
.73227 .24781 L
.73327 .24781 L
.73427 .24781 L
.73526 .24781 L
.73626 .24781 L
.73726 .24781 L
.73826 .24781 L
.73926 .24781 L
.74026 .24781 L
.74126 .24781 L
.74226 .24781 L
.74326 .24781 L
.74426 .24781 L
.74525 .24781 L
.74625 .24781 L
.74725 .24781 L
.74825 .24781 L
Mistroke
.74925 .26334 L
.75025 .26334 L
.75125 .26334 L
.75225 .26334 L
.75325 .26334 L
.75425 .26334 L
.75524 .26334 L
.75624 .26334 L
.75724 .26334 L
.75824 .26334 L
.75924 .26334 L
.76024 .26334 L
.76124 .26334 L
.76224 .26334 L
.76324 .26334 L
.76424 .26334 L
.76523 .26334 L
.76623 .26334 L
.76723 .26334 L
.76823 .26334 L
.76923 .26334 L
.77023 .26334 L
.77123 .26334 L
.77223 .26334 L
.77323 .26334 L
.77423 .26334 L
.77522 .26334 L
.77622 .26334 L
.77722 .26334 L
.77822 .26334 L
.77922 .26334 L
.78022 .26334 L
.78122 .26334 L
.78222 .26334 L
.78322 .26334 L
.78422 .26334 L
.78521 .26334 L
.78621 .26334 L
.78721 .26334 L
.78821 .26334 L
.78921 .26334 L
.79021 .26334 L
.79121 .26334 L
.79221 .26334 L
.79321 .26334 L
.79421 .26334 L
.7952 .26334 L
.7962 .26334 L
.7972 .26334 L
.7982 .26334 L
Mistroke
.7992 .26029 L
.8002 .26029 L
.8012 .26029 L
.8022 .26029 L
.8032 .26029 L
.8042 .26029 L
.80519 .26029 L
.80619 .26029 L
.80719 .26029 L
.80819 .26029 L
.80919 .26029 L
.81019 .26029 L
.81119 .26029 L
.81219 .26029 L
.81319 .26029 L
.81419 .26029 L
.81518 .26029 L
.81618 .26029 L
.81718 .26029 L
.81818 .26029 L
.81918 .26029 L
.82018 .26029 L
.82118 .26029 L
.82218 .26029 L
.82318 .26029 L
.82418 .26029 L
.82517 .26029 L
.82617 .26029 L
.82717 .26029 L
.82817 .26029 L
.82917 .26029 L
.83017 .26029 L
.83117 .26029 L
.83217 .26029 L
.83317 .26029 L
.83417 .26029 L
.83516 .26029 L
.83616 .26029 L
.83716 .26029 L
.83816 .26029 L
.83916 .26029 L
.84016 .26029 L
.84116 .26029 L
.84216 .26029 L
.84316 .26029 L
.84416 .26029 L
.84515 .26029 L
.84615 .26029 L
.84715 .26029 L
.84815 .26029 L
Mistroke
.84915 .26549 L
.85015 .26549 L
.85115 .26549 L
.85215 .26549 L
.85315 .26549 L
.85415 .26549 L
.85514 .26549 L
.85614 .26549 L
.85714 .26549 L
.85814 .26549 L
.85914 .26549 L
.86014 .26549 L
.86114 .26549 L
.86214 .26549 L
.86314 .26549 L
.86414 .26549 L
.86513 .26549 L
.86613 .26549 L
.86713 .26549 L
.86813 .26549 L
.86913 .26549 L
.87013 .26549 L
.87113 .26549 L
.87213 .26549 L
.87313 .26549 L
.87413 .26549 L
.87512 .26549 L
.87612 .26549 L
.87712 .26549 L
.87812 .26549 L
.87912 .26549 L
.88012 .26549 L
.88112 .26549 L
.88212 .26549 L
.88312 .26549 L
.88412 .26549 L
.88511 .26549 L
.88611 .26549 L
.88711 .26549 L
.88811 .26549 L
.88911 .26549 L
.89011 .26549 L
.89111 .26549 L
.89211 .26549 L
.89311 .26549 L
.89411 .26549 L
.8951 .26549 L
.8961 .26549 L
.8971 .26549 L
.8981 .26549 L
Mistroke
.8991 .26544 L
.9001 .26544 L
.9011 .26544 L
.9021 .26544 L
.9031 .26544 L
.9041 .26544 L
.90509 .26544 L
.90609 .26544 L
.90709 .26544 L
.90809 .26544 L
.90909 .26544 L
.91009 .26544 L
.91109 .26544 L
.91209 .26544 L
.91309 .26544 L
.91409 .26544 L
.91508 .26544 L
.91608 .26544 L
.91708 .26544 L
.91808 .26544 L
.91908 .26544 L
.92008 .26544 L
.92108 .26544 L
.92208 .26544 L
.92308 .26544 L
.92408 .26544 L
.92507 .26544 L
.92607 .26544 L
.92707 .26544 L
.92807 .26544 L
.92907 .26544 L
.93007 .26544 L
.93107 .26544 L
.93207 .26544 L
.93307 .26544 L
.93407 .26544 L
.93506 .26544 L
.93606 .26544 L
.93706 .26544 L
.93806 .26544 L
.93906 .26544 L
.94006 .26544 L
.94106 .26544 L
.94206 .26544 L
.94306 .26544 L
.94406 .26544 L
.94505 .26544 L
.94605 .26544 L
.94705 .26544 L
.94805 .26544 L
Mistroke
.94905 .26466 L
.95005 .26466 L
.95105 .26466 L
.95205 .26466 L
.95305 .26466 L
.95405 .26466 L
.95504 .26466 L
.95604 .26466 L
.95704 .26466 L
.95804 .26466 L
.95904 .26466 L
.96004 .26466 L
.96104 .26466 L
.96204 .26466 L
.96304 .26466 L
.96404 .26466 L
.96503 .26466 L
.96603 .26466 L
.96703 .26466 L
.96803 .26466 L
.96903 .26466 L
.97003 .26466 L
.97103 .26466 L
.97203 .26466 L
.97303 .26466 L
.97403 .26466 L
.97502 .26466 L
.97602 .26466 L
.97702 .26466 L
.97802 .26466 L
.97902 .26466 L
.98002 .26466 L
.98102 .26466 L
.98202 .26466 L
.98302 .26466 L
.98402 .26466 L
.98501 .26466 L
.98601 .26466 L
.98701 .26466 L
.98801 .26466 L
.98901 .26466 L
.99001 .26466 L
.99101 .26466 L
.99201 .26466 L
.99301 .26466 L
.99401 .26466 L
.995 .26466 L
.996 .26466 L
.997 .26466 L
.998 .26466 L
Mistroke
.999 .25988 L
Mfstroke
0 0 1 r
gsave
.001 0 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 0 m
.001 0 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.37082 0.0123607 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12361 -18 -4.5 ]
[-0.0125 .12361 0 4.5 ]
[-0.0125 .24721 -18 -4.5 ]
[-0.0125 .24721 0 4.5 ]
[-0.0125 .37082 -6 -4.5 ]
[-0.0125 .37082 0 4.5 ]
[-0.0125 .49443 -12 -4.5 ]
[-0.0125 .49443 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12361 m
.00625 .12361 L
s
[(-20)] -0.0125 .12361 1 0 Mshowa
0 .24721 m
.00625 .24721 L
s
[(-10)] -0.0125 .24721 1 0 Mshowa
0 .37082 m
.00625 .37082 L
s
[(0)] -0.0125 .37082 1 0 Mshowa
0 .49443 m
.00625 .49443 L
s
[(10)] -0.0125 .49443 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(20)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02472 m
.00375 .02472 L
s
0 .04944 m
.00375 .04944 L
s
0 .07416 m
.00375 .07416 L
s
0 .09889 m
.00375 .09889 L
s
0 .14833 m
.00375 .14833 L
s
0 .17305 m
.00375 .17305 L
s
0 .19777 m
.00375 .19777 L
s
0 .22249 m
.00375 .22249 L
s
0 .27193 m
.00375 .27193 L
s
0 .29666 m
.00375 .29666 L
s
0 .32138 m
.00375 .32138 L
s
0 .3461 m
.00375 .3461 L
s
0 .39554 m
.00375 .39554 L
s
0 .42026 m
.00375 .42026 L
s
0 .44498 m
.00375 .44498 L
s
0 .46971 m
.00375 .46971 L
s
0 .51915 m
.00375 .51915 L
s
0 .54387 m
.00375 .54387 L
s
0 .56859 m
.00375 .56859 L
s
0 .59331 m
.00375 .59331 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .12361 m
1 .12361 L
s
.99375 .24721 m
1 .24721 L
s
.99375 .37082 m
1 .37082 L
s
.99375 .49443 m
1 .49443 L
s
.125 Mabswid
.99625 .02472 m
1 .02472 L
s
.99625 .04944 m
1 .04944 L
s
.99625 .07416 m
1 .07416 L
s
.99625 .09889 m
1 .09889 L
s
.99625 .14833 m
1 .14833 L
s
.99625 .17305 m
1 .17305 L
s
.99625 .19777 m
1 .19777 L
s
.99625 .22249 m
1 .22249 L
s
.99625 .27193 m
1 .27193 L
s
.99625 .29666 m
1 .29666 L
s
.99625 .32138 m
1 .32138 L
s
.99625 .3461 m
1 .3461 L
s
.99625 .39554 m
1 .39554 L
s
.99625 .42026 m
1 .42026 L
s
.99625 .44498 m
1 .44498 L
s
.99625 .46971 m
1 .46971 L
s
.99625 .51915 m
1 .51915 L
s
.99625 .54387 m
1 .54387 L
s
.99625 .56859 m
1 .56859 L
s
.99625 .59331 m
1 .59331 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .37094 m
.001 .3633 L
.002 .36514 L
.003 .36423 L
.004 .36445 L
.005 .36832 L
.00599 .36761 L
.00699 .35935 L
.00799 .36089 L
.00899 .36482 L
.00999 .36868 L
.01099 .3755 L
.01199 .37266 L
.01299 .36367 L
.01399 .36542 L
.01499 .36588 L
.01598 .36482 L
.01698 .36968 L
.01798 .3733 L
.01898 .36872 L
.01998 .36437 L
.02098 .36355 L
.02198 .36512 L
.02298 .36607 L
.02398 .3677 L
.02498 .3653 L
.02597 .36279 L
.02697 .35364 L
.02797 .35398 L
.02897 .3423 L
.02997 .3326 L
.03097 .33402 L
.03197 .32653 L
.03297 .32064 L
.03397 .31528 L
.03497 .31002 L
.03596 .30593 L
.03696 .29713 L
.03796 .28419 L
.03896 .2807 L
.03996 .26902 L
.04096 .25395 L
.04196 .23591 L
.04296 .22426 L
.04396 .19978 L
.04496 .18453 L
.04595 .16372 L
.04695 .1457 L
.04795 .12512 L
.04895 .11585 L
Mistroke
.04995 .1085 L
.05095 .10686 L
.05195 .09902 L
.05295 .10158 L
.05395 .10247 L
.05495 .11101 L
.05594 .12467 L
.05694 .14492 L
.05794 .17091 L
.05894 .20074 L
.05994 .2381 L
.06094 .27317 L
.06194 .30548 L
.06294 .3281 L
.06394 .3609 L
.06494 .38692 L
.06593 .40709 L
.06693 .43598 L
.06793 .46451 L
.06893 .48065 L
.06993 .49292 L
.07093 .50009 L
.07193 .50728 L
.07293 .50987 L
.07393 .52521 L
.07493 .52741 L
.07592 .53095 L
.07692 .51424 L
.07792 .50475 L
.07892 .49181 L
.07992 .48711 L
.08092 .47929 L
.08192 .47667 L
.08292 .46866 L
.08392 .44987 L
.08492 .44723 L
.08591 .43427 L
.08691 .42351 L
.08791 .42537 L
.08891 .41958 L
.08991 .41012 L
.09091 .41209 L
.09191 .40844 L
.09291 .40621 L
.09391 .40721 L
.09491 .40316 L
.0959 .40287 L
.0969 .40117 L
.0979 .40181 L
.0989 .40301 L
Mistroke
.0999 .40448 L
.1009 .40271 L
.1019 .39765 L
.1029 .39856 L
.1039 .39871 L
.1049 .39397 L
.10589 .40047 L
.10689 .40244 L
.10789 .40776 L
.10889 .40659 L
.10989 .40706 L
.11089 .41362 L
.11189 .41932 L
.11289 .4233 L
.11389 .42924 L
.11489 .42948 L
.11588 .43004 L
.11688 .42948 L
.11788 .42936 L
.11888 .43139 L
.11988 .42798 L
.12088 .42923 L
.12188 .43921 L
.12288 .44481 L
.12388 .44411 L
.12488 .44882 L
.12587 .45558 L
.12687 .46069 L
.12787 .46369 L
.12887 .46789 L
.12987 .47395 L
.13087 .48551 L
.13187 .4894 L
.13287 .50209 L
.13387 .50265 L
.13487 .50474 L
.13586 .50613 L
.13686 .50905 L
.13786 .52118 L
.13886 .51899 L
.13986 .52786 L
.14086 .53589 L
.14186 .55054 L
.14286 .55973 L
.14386 .57075 L
.14486 .56361 L
.14585 .57308 L
.14685 .57602 L
.14785 .57759 L
.14885 .57198 L
Mistroke
.14985 .56113 L
.15085 .54596 L
.15185 .53023 L
.15285 .51433 L
.15385 .49469 L
.15485 .47621 L
.15584 .46284 L
.15684 .45034 L
.15784 .43728 L
.15884 .4209 L
.15984 .40978 L
.16084 .3943 L
.16184 .39136 L
.16284 .38127 L
.16384 .36652 L
.16484 .36756 L
.16583 .36336 L
.16683 .36777 L
.16783 .36858 L
.16883 .36839 L
.16983 .36044 L
.17083 .3658 L
.17183 .36045 L
.17283 .35448 L
.17383 .34913 L
.17483 .35345 L
.17582 .34637 L
.17682 .34341 L
.17782 .34558 L
.17882 .34832 L
.17982 .34489 L
.18082 .34802 L
.18182 .3427 L
.18282 .33492 L
.18382 .33636 L
.18482 .33051 L
.18581 .32758 L
.18681 .33615 L
.18781 .3387 L
.18881 .33626 L
.18981 .33461 L
.19081 .33259 L
.19181 .32062 L
.19281 .309 L
.19381 .30493 L
.19481 .30207 L
.1958 .29752 L
.1968 .29255 L
.1978 .28891 L
.1988 .28779 L
Mistroke
.1998 .28213 L
.2008 .27851 L
.2018 .26596 L
.2028 .26198 L
.2038 .25298 L
.2048 .24401 L
.20579 .23578 L
.20679 .21828 L
.20779 .20944 L
.20879 .19594 L
.20979 .18378 L
.21079 .17553 L
.21179 .18396 L
.21279 .1826 L
.21379 .17798 L
.21479 .17997 L
.21578 .17405 L
.21678 .17523 L
.21778 .17795 L
.21878 .19004 L
.21978 .20582 L
.22078 .21375 L
.22178 .22988 L
.22278 .24654 L
.22378 .256 L
.22478 .26593 L
.22577 .28173 L
.22677 .29864 L
.22777 .31562 L
.22877 .32874 L
.22977 .34154 L
.23077 .35316 L
.23177 .36629 L
.23277 .38221 L
.23377 .39004 L
.23477 .40031 L
.23576 .41398 L
.23676 .42455 L
.23776 .4295 L
.23876 .43232 L
.23976 .44 L
.24076 .43898 L
.24176 .43816 L
.24276 .43983 L
.24376 .43375 L
.24476 .43879 L
.24575 .43812 L
.24675 .44506 L
.24775 .44778 L
.24875 .45506 L
Mistroke
.24975 .45696 L
.25075 .46195 L
.25175 .4605 L
.25275 .46281 L
.25375 .46423 L
.25475 .4657 L
.25574 .46486 L
.25674 .46927 L
.25774 .47589 L
.25874 .47649 L
.25974 .47329 L
.26074 .48353 L
.26174 .488 L
.26274 .489 L
.26374 .49545 L
.26474 .49164 L
.26573 .49578 L
.26673 .50101 L
.26773 .5022 L
.26873 .50363 L
.26973 .49816 L
.27073 .50113 L
.27173 .50453 L
.27273 .50737 L
.27373 .50263 L
.27473 .50664 L
.27572 .50467 L
.27672 .50649 L
.27772 .50055 L
.27872 .49265 L
.27972 .48779 L
.28072 .48474 L
.28172 .48267 L
.28272 .48746 L
.28372 .48615 L
.28472 .47629 L
.28571 .46793 L
.28671 .46373 L
.28771 .46612 L
.28871 .45202 L
.28971 .45144 L
.29071 .44819 L
.29171 .4483 L
.29271 .43844 L
.29371 .43439 L
.29471 .42857 L
.2957 .42731 L
.2967 .42336 L
.2977 .42177 L
.2987 .41911 L
Mistroke
.2997 .42231 L
.3007 .4247 L
.3017 .42667 L
.3027 .42701 L
.3037 .43066 L
.3047 .4254 L
.30569 .43593 L
.30669 .43283 L
.30769 .43042 L
.30869 .43099 L
.30969 .43267 L
.31069 .43016 L
.31169 .42776 L
.31269 .42433 L
.31369 .42638 L
.31469 .43303 L
.31568 .42661 L
.31668 .42534 L
.31768 .42812 L
.31868 .43141 L
.31968 .4377 L
.32068 .44188 L
.32168 .44618 L
.32268 .44935 L
.32368 .45422 L
.32468 .45538 L
.32567 .45542 L
.32667 .46235 L
.32767 .46619 L
.32867 .48053 L
.32967 .47899 L
.33067 .48539 L
.33167 .49732 L
.33267 .49504 L
.33367 .50208 L
.33467 .50653 L
.33566 .51281 L
.33666 .51062 L
.33766 .51723 L
.33866 .52528 L
.33966 .53519 L
.34066 .53878 L
.34166 .54018 L
.34266 .53747 L
.34366 .53166 L
.34466 .52425 L
.34565 .52344 L
.34665 .52681 L
.34765 .51833 L
.34865 .52176 L
Mistroke
.34965 .51767 L
.35065 .52351 L
.35165 .51766 L
.35265 .50483 L
.35365 .49144 L
.35465 .48328 L
.35564 .47742 L
.35664 .46793 L
.35764 .45924 L
.35864 .4537 L
.35964 .44337 L
.36064 .44118 L
.36164 .43206 L
.36264 .43153 L
.36364 .41083 L
.36464 .41489 L
.36563 .40394 L
.36663 .3917 L
.36763 .38587 L
.36863 .387 L
.36963 .38899 L
.37063 .38247 L
.37163 .37575 L
.37263 .37241 L
.37363 .37179 L
.37463 .36466 L
.37562 .36092 L
.37662 .35853 L
.37762 .35009 L
.37862 .34394 L
.37962 .35035 L
.38062 .34979 L
.38162 .35061 L
.38262 .34529 L
.38362 .34663 L
.38462 .34446 L
.38561 .34075 L
.38661 .33821 L
.38761 .34425 L
.38861 .33811 L
.38961 .3379 L
.39061 .3392 L
.39161 .34023 L
.39261 .33242 L
.39361 .33815 L
.39461 .33453 L
.3956 .34237 L
.3966 .34353 L
.3976 .33525 L
.3986 .34424 L
Mistroke
.3996 .33384 L
.4006 .3285 L
.4016 .32257 L
.4026 .32652 L
.4036 .32293 L
.4046 .31342 L
.40559 .30701 L
.40659 .30088 L
.40759 .30326 L
.40859 .3057 L
.40959 .30068 L
.41059 .29992 L
.41159 .29279 L
.41259 .28366 L
.41359 .26433 L
.41459 .26534 L
.41558 .25954 L
.41658 .25852 L
.41758 .25706 L
.41858 .2485 L
.41958 .23788 L
.42058 .22877 L
.42158 .22051 L
.42258 .20237 L
.42358 .20402 L
.42458 .18869 L
.42557 .18557 L
.42657 .18248 L
.42757 .17573 L
.42857 .17972 L
.42957 .18357 L
.43057 .18489 L
.43157 .17916 L
.43257 .19079 L
.43357 .1935 L
.43457 .19937 L
.43556 .21892 L
.43656 .22641 L
.43756 .24667 L
.43856 .26214 L
.43956 .27645 L
.44056 .29591 L
.44156 .31737 L
.44256 .32735 L
.44356 .34023 L
.44456 .3518 L
.44555 .3628 L
.44655 .37673 L
.44755 .38537 L
.44855 .39301 L
Mistroke
.44955 .40364 L
.45055 .40798 L
.45155 .40782 L
.45255 .41755 L
.45355 .41892 L
.45455 .42518 L
.45554 .42629 L
.45654 .43292 L
.45754 .44184 L
.45854 .43797 L
.45954 .4345 L
.46054 .424 L
.46154 .43097 L
.46254 .43339 L
.46354 .43392 L
.46454 .43703 L
.46553 .44737 L
.46653 .44525 L
.46753 .43571 L
.46853 .43674 L
.46953 .44717 L
.47053 .44981 L
.47153 .44963 L
.47253 .45056 L
.47353 .44679 L
.47453 .45065 L
.47552 .45645 L
.47652 .45507 L
.47752 .44849 L
.47852 .45204 L
.47952 .45967 L
.48052 .46471 L
.48152 .4737 L
.48252 .48766 L
.48352 .49563 L
.48452 .50551 L
.48551 .50442 L
.48651 .51403 L
.48751 .52077 L
.48851 .52372 L
.48951 .52759 L
.49051 .52887 L
.49151 .53155 L
.49251 .53531 L
.49351 .54101 L
.49451 .54879 L
.4955 .55645 L
.4965 .55735 L
.4975 .55454 L
.4985 .55064 L
Mistroke
.4995 .54824 L
.5005 .54178 L
.5015 .53813 L
.5025 .5263 L
.5035 .51437 L
.5045 .50443 L
.50549 .49374 L
.50649 .47816 L
.50749 .46151 L
.50849 .46507 L
.50949 .45999 L
.51049 .448 L
.51149 .44046 L
.51249 .43054 L
.51349 .42683 L
.51449 .41796 L
.51548 .41339 L
.51648 .40912 L
.51748 .4079 L
.51848 .40131 L
.51948 .40152 L
.52048 .39787 L
.52148 .39961 L
.52248 .39471 L
.52348 .39665 L
.52448 .39658 L
.52547 .39738 L
.52647 .39327 L
.52747 .39705 L
.52847 .38574 L
.52947 .38326 L
.53047 .39217 L
.53147 .3912 L
.53247 .39037 L
.53347 .39232 L
.53447 .39889 L
.53546 .39588 L
.53646 .39632 L
.53746 .3903 L
.53846 .39126 L
.53946 .38752 L
.54046 .38982 L
.54146 .38976 L
.54246 .4056 L
.54346 .40248 L
.54446 .40253 L
.54545 .4054 L
.54645 .40485 L
.54745 .40641 L
.54845 .41027 L
Mistroke
.54945 .41575 L
.55045 .41655 L
.55145 .42803 L
.55245 .43031 L
.55345 .43184 L
.55445 .42993 L
.55544 .43654 L
.55644 .44187 L
.55744 .44976 L
.55844 .46823 L
.55944 .47681 L
.56044 .48301 L
.56144 .4885 L
.56244 .50266 L
.56344 .50334 L
.56444 .51538 L
.56543 .52246 L
.56643 .52726 L
.56743 .54322 L
.56843 .55392 L
.56943 .55999 L
.57043 .56661 L
.57143 .57382 L
.57243 .57185 L
.57343 .56717 L
.57443 .56692 L
.57542 .56813 L
.57642 .56924 L
.57742 .57386 L
.57842 .56965 L
.57942 .56542 L
.58042 .55424 L
.58142 .54809 L
.58242 .52827 L
.58342 .51142 L
.58442 .50033 L
.58541 .47717 L
.58641 .467 L
.58741 .45638 L
.58841 .43935 L
.58941 .42296 L
.59041 .40775 L
.59141 .39899 L
.59241 .38524 L
.59341 .37463 L
.59441 .36506 L
.5954 .36668 L
.5964 .36008 L
.5974 .35359 L
.5984 .34401 L
Mistroke
.5994 .33723 L
.6004 .335 L
.6014 .32907 L
.6024 .31668 L
.6034 .31449 L
.6044 .30882 L
.60539 .3027 L
.60639 .30057 L
.60739 .30139 L
.60839 .28487 L
.60939 .28228 L
.61039 .27986 L
.61139 .26669 L
.61239 .26366 L
.61339 .26019 L
.61439 .25885 L
.61538 .25271 L
.61638 .25473 L
.61738 .25844 L
.61838 .26329 L
.61938 .26499 L
.62038 .26531 L
.62138 .25804 L
.62238 .2475 L
.62338 .25006 L
.62438 .25403 L
.62537 .26209 L
.62637 .26123 L
.62737 .25931 L
.62837 .26049 L
.62937 .26014 L
.63037 .26706 L
.63137 .27478 L
.63237 .28538 L
.63337 .28855 L
.63437 .28431 L
.63536 .28863 L
.63636 .30784 L
.63736 .30341 L
.63836 .30401 L
.63936 .30876 L
.64036 .31322 L
.64136 .31059 L
.64236 .3177 L
.64336 .3212 L
.64436 .33453 L
.64535 .33473 L
.64635 .33314 L
.64735 .33454 L
.64835 .33178 L
Mistroke
.64935 .33282 L
.65035 .3312 L
.65135 .33223 L
.65235 .32183 L
.65335 .32155 L
.65435 .32127 L
.65534 .31387 L
.65634 .31506 L
.65734 .3165 L
.65834 .31489 L
.65934 .31347 L
.66034 .31739 L
.66134 .3231 L
.66234 .31184 L
.66334 .30126 L
.66434 .2905 L
.66533 .28583 L
.66633 .27642 L
.66733 .27318 L
.66833 .27085 L
.66933 .26344 L
.67033 .26591 L
.67133 .26785 L
.67233 .26145 L
.67333 .25483 L
.67433 .24235 L
.67532 .23727 L
.67632 .23293 L
.67732 .22864 L
.67832 .22812 L
.67932 .21549 L
.68032 .20473 L
.68132 .20266 L
.68232 .20038 L
.68332 .20922 L
.68432 .21014 L
.68531 .21646 L
.68631 .20584 L
.68731 .21203 L
.68831 .212 L
.68931 .22164 L
.69031 .22902 L
.69131 .2359 L
.69231 .23903 L
.69331 .24115 L
.69431 .24576 L
.6953 .25247 L
.6963 .2561 L
.6973 .27217 L
.6983 .2777 L
Mistroke
.6993 .29564 L
.7003 .30047 L
.7013 .30223 L
.7023 .30521 L
.7033 .31108 L
.7043 .31481 L
.70529 .31861 L
.70629 .32414 L
.70729 .32304 L
.70829 .32315 L
.70929 .3281 L
.71029 .33178 L
.71129 .3326 L
.71229 .32946 L
.71329 .33664 L
.71429 .35414 L
.71528 .35295 L
.71628 .34871 L
.71728 .34971 L
.71828 .35593 L
.71928 .35176 L
.72028 .35959 L
.72128 .36405 L
.72228 .36116 L
.72328 .36982 L
.72428 .36892 L
.72527 .37082 L
.72627 .36376 L
.72727 .35901 L
.72827 .35776 L
.72927 .35682 L
.73027 .35842 L
.73127 .35149 L
.73227 .34238 L
.73327 .33697 L
.73427 .33421 L
.73526 .33769 L
.73626 .33266 L
.73726 .32967 L
.73826 .32834 L
.73926 .32714 L
.74026 .31728 L
.74126 .30556 L
.74226 .30657 L
.74326 .30398 L
.74426 .30955 L
.74525 .30314 L
.74625 .28633 L
.74725 .27955 L
.74825 .26843 L
Mistroke
.74925 .2567 L
.75025 .25372 L
.75125 .25154 L
.75225 .2396 L
.75325 .22625 L
.75425 .22036 L
.75524 .21048 L
.75624 .20715 L
.75724 .18975 L
.75824 .19152 L
.75924 .19047 L
.76024 .18922 L
.76124 .18714 L
.76224 .18526 L
.76324 .18213 L
.76424 .1786 L
.76523 .18887 L
.76623 .1969 L
.76723 .20495 L
.76823 .20821 L
.76923 .22185 L
.77023 .2373 L
.77123 .25211 L
.77223 .25936 L
.77323 .27113 L
.77423 .28699 L
.77522 .30062 L
.77622 .3117 L
.77722 .33426 L
.77822 .34752 L
.77922 .36549 L
.78022 .38042 L
.78122 .39749 L
.78222 .40779 L
.78322 .4123 L
.78422 .42021 L
.78521 .42643 L
.78621 .43265 L
.78721 .42753 L
.78821 .43184 L
.78921 .43441 L
.79021 .44165 L
.79121 .44958 L
.79221 .45113 L
.79321 .45563 L
.79421 .46595 L
.7952 .47493 L
.7962 .47558 L
.7972 .47454 L
.7982 .47377 L
Mistroke
.7992 .47176 L
.8002 .4764 L
.8012 .47687 L
.8022 .46727 L
.8032 .47076 L
.8042 .47253 L
.80519 .47622 L
.80619 .47961 L
.80719 .47929 L
.80819 .48599 L
.80919 .47633 L
.81019 .4767 L
.81119 .47736 L
.81219 .47003 L
.81319 .47208 L
.81419 .46444 L
.81518 .45184 L
.81618 .46802 L
.81718 .46867 L
.81818 .46538 L
.81918 .45995 L
.82018 .454 L
.82118 .45047 L
.82218 .45198 L
.82318 .45273 L
.82418 .45907 L
.82517 .45589 L
.82617 .44928 L
.82717 .45432 L
.82817 .46071 L
.82917 .45889 L
.83017 .46433 L
.83117 .46224 L
.83217 .45649 L
.83317 .45868 L
.83417 .45876 L
.83516 .45696 L
.83616 .4581 L
.83716 .45364 L
.83816 .46061 L
.83916 .45993 L
.84016 .4641 L
.84116 .46993 L
.84216 .47397 L
.84316 .47368 L
.84416 .48226 L
.84515 .47963 L
.84615 .48811 L
.84715 .50632 L
.84815 .5109 L
Mistroke
.84915 .50987 L
.85015 .5075 L
.85115 .50495 L
.85215 .49739 L
.85315 .4995 L
.85415 .49385 L
.85514 .4833 L
.85614 .47966 L
.85714 .47717 L
.85814 .46894 L
.85914 .46243 L
.86014 .45859 L
.86114 .45801 L
.86214 .46142 L
.86314 .46575 L
.86414 .46391 L
.86513 .46192 L
.86613 .45385 L
.86713 .44967 L
.86813 .44288 L
.86913 .43752 L
.87013 .43563 L
.87113 .43101 L
.87213 .43151 L
.87313 .43083 L
.87413 .4175 L
.87512 .42939 L
.87612 .42739 L
.87712 .41726 L
.87812 .41593 L
.87912 .41792 L
.88012 .40539 L
.88112 .41009 L
.88212 .40931 L
.88312 .40941 L
.88412 .40918 L
.88511 .40539 L
.88611 .40971 L
.88711 .41454 L
.88811 .42733 L
.88911 .42544 L
.89011 .41957 L
.89111 .42111 L
.89211 .43435 L
.89311 .43062 L
.89411 .43518 L
.8951 .44004 L
.8961 .44189 L
.8971 .4402 L
.8981 .45096 L
Mistroke
.8991 .45348 L
.9001 .45925 L
.9011 .47619 L
.9021 .47737 L
.9031 .48594 L
.9041 .49395 L
.90509 .49433 L
.90609 .50791 L
.90709 .51776 L
.90809 .52952 L
.90909 .53885 L
.91009 .53998 L
.91109 .54793 L
.91209 .55087 L
.91309 .5476 L
.91409 .55613 L
.91508 .56288 L
.91608 .55851 L
.91708 .56026 L
.91808 .5625 L
.91908 .55103 L
.92008 .54648 L
.92108 .5388 L
.92208 .52737 L
.92308 .51911 L
.92408 .51501 L
.92507 .4999 L
.92607 .48767 L
.92707 .46857 L
.92807 .45703 L
.92907 .453 L
.93007 .43984 L
.93107 .42841 L
.93207 .4181 L
.93307 .40491 L
.93407 .3929 L
.93506 .39028 L
.93606 .38076 L
.93706 .37582 L
.93806 .36803 L
.93906 .36163 L
.94006 .3663 L
.94106 .362 L
.94206 .35023 L
.94306 .35227 L
.94406 .34508 L
.94505 .34122 L
.94605 .33427 L
.94705 .33462 L
.94805 .3357 L
Mistroke
.94905 .32476 L
.95005 .32223 L
.95105 .32644 L
.95205 .32371 L
.95305 .33131 L
.95405 .32598 L
.95504 .32513 L
.95604 .32348 L
.95704 .3217 L
.95804 .31756 L
.95904 .30809 L
.96004 .3045 L
.96104 .30182 L
.96204 .29309 L
.96304 .28736 L
.96404 .2934 L
.96503 .28335 L
.96603 .27741 L
.96703 .27614 L
.96803 .27308 L
.96903 .26561 L
.97003 .2612 L
.97103 .25962 L
.97203 .23821 L
.97303 .23729 L
.97403 .22472 L
.97502 .21142 L
.97602 .20926 L
.97702 .20059 L
.97802 .2017 L
.97902 .19206 L
.98002 .18739 L
.98102 .18957 L
.98202 .19077 L
.98302 .18705 L
.98402 .1877 L
.98501 .19247 L
.98601 .20117 L
.98701 .20703 L
.98801 .20747 L
.98901 .21261 L
.99001 .2237 L
.99101 .23217 L
.99201 .24923 L
.99301 .25682 L
.99401 .26238 L
.995 .27331 L
.996 .28594 L
.997 .29797 L
.998 .30271 L
Mistroke
.999 .31208 L
Mfstroke
0 .98 .604 r
gsave
.999 .30807 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
0 .35823 m
.001 .35448 L
.002 .35208 L
.003 .35003 L
.004 .348 L
.005 .34586 L
.00599 .34349 L
.00699 .34083 L
.00799 .33782 L
.00899 .3344 L
.00999 .33051 L
.01099 .3261 L
.01199 .32108 L
.01299 .3154 L
.01399 .30895 L
.01499 .30166 L
.01598 .29342 L
.01698 .28411 L
.01798 .2736 L
.01898 .26174 L
.01998 .24838 L
.02098 .23332 L
.02198 .21635 L
.02298 .19724 L
.02398 .17573 L
.02498 .15151 L
.02597 .12425 L
.02697 .09357 L
.02797 .05905 L
.02897 .0202 L
s
.02897 .0202 m
.02943 0 L
s
.04989 0 m
.04995 .09622 L
.05095 .08379 L
.05195 .07736 L
.05295 .07698 L
.05395 .08298 L
.05495 .09541 L
.05594 .11393 L
.05694 .13774 L
.05794 .16564 L
.05894 .19605 L
.05994 .22711 L
.06094 .25678 L
.06194 .28291 L
.06294 .30341 L
.06394 .31634 L
.06494 .32009 L
.06593 .31347 L
.06693 .29587 L
.06793 .26733 L
.06893 .22858 L
.06993 .18105 L
.07093 .12685 L
.07193 .06871 L
.07293 .00989 L
s
.07293 .00989 m
.0731 0 L
s
.08144 0 m
.08192 .03688 L
.08292 .12746 L
.08392 .22607 L
.08492 .3264 L
.08591 .42164 L
.08691 .5049 L
.08791 .56952 L
.08891 .60941 L
s
.08891 .60941 m
.08977 .61803 L
s
.08997 .61803 m
.09091 .5961 L
.09191 .53731 L
.09291 .4432 L
.09391 .31604 L
.09491 .16027 L
s
.09491 .16027 m
.09581 0 L
s
.0995 0 m
.0999 .38414 L
.1009 .38018 L
.1019 .37801 L
.1029 .37663 L
.1039 .37576 L
.1049 .37523 L
.10589 .37498 L
.10689 .37494 L
.10789 .37509 L
.10889 .37541 L
.10989 .37589 L
.11089 .37651 L
.11189 .37727 L
.11289 .37817 L
.11389 .3792 L
.11489 .38038 L
.11588 .3817 L
.11688 .38315 L
.11788 .38476 L
.11888 .38651 L
.11988 .38842 L
.12088 .39049 L
.12188 .39272 L
.12288 .39513 L
.12388 .39772 L
.12488 .40049 L
.12587 .40346 L
.12687 .40664 L
.12787 .41003 L
.12887 .41364 L
.12987 .4175 L
.13087 .42159 L
.13187 .42595 L
.13287 .43059 L
.13387 .43551 L
.13487 .44073 L
.13586 .44627 L
.13686 .45214 L
.13786 .45837 L
.13886 .46496 L
.13986 .47195 L
.14086 .47935 L
.14186 .48718 L
.14286 .49546 L
.14386 .50423 L
.14486 .5135 L
.14585 .52331 L
.14685 .53367 L
.14785 .54464 L
Mistroke
.14885 .55622 L
.14985 .54229 L
.15085 .52793 L
.15185 .51501 L
.15285 .50244 L
.15385 .48981 L
.15485 .47689 L
.15584 .46356 L
.15684 .44977 L
.15784 .43553 L
.15884 .42091 L
.15984 .40602 L
.16084 .39101 L
.16184 .37607 L
.16284 .36141 L
.16384 .34726 L
.16484 .33386 L
.16583 .32144 L
.16683 .31026 L
.16783 .30052 L
.16883 .29243 L
.16983 .28617 L
.17083 .28188 L
.17183 .27964 L
.17283 .27952 L
.17383 .28152 L
.17483 .28559 L
.17582 .29165 L
.17682 .29953 L
.17782 .30905 L
.17882 .31997 L
.17982 .33199 L
.18082 .3448 L
.18182 .35804 L
.18282 .37134 L
.18382 .3843 L
.18482 .39653 L
.18581 .40764 L
.18681 .41724 L
.18781 .42498 L
.18881 .43055 L
.18981 .43365 L
.19081 .43408 L
.19181 .43168 L
.19281 .42635 L
.19381 .4181 L
.19481 .40698 L
.1958 .39315 L
.1968 .37685 L
.1978 .35839 L
Mistroke
.1988 .33816 L
.1998 .27828 L
.2008 .26672 L
.2018 .25651 L
.2028 .24675 L
.2038 .23715 L
.2048 .22761 L
.20579 .21808 L
.20679 .20855 L
.20779 .19906 L
.20879 .18962 L
.20979 .1803 L
.21079 .17114 L
.21179 .16223 L
.21279 .15362 L
.21379 .14541 L
.21479 .13768 L
.21578 .13053 L
.21678 .12405 L
.21778 .11836 L
.21878 .11355 L
.21978 .10974 L
.22078 .10703 L
.22178 .10555 L
.22278 .1054 L
.22378 .10669 L
.22478 .10954 L
.22577 .11404 L
.22677 .1203 L
.22777 .12842 L
.22877 .13847 L
.22977 .15054 L
.23077 .16469 L
.23177 .18097 L
.23277 .19942 L
.23377 .22004 L
.23477 .24286 L
.23576 .26784 L
.23676 .29494 L
.23776 .32411 L
.23876 .35527 L
.23976 .38832 L
.24076 .42313 L
.24176 .45957 L
.24276 .49748 L
.24376 .5367 L
.24476 .57704 L
Mfstroke
.24476 .57704 m
.24575 .61803 L
s
.24917 .61803 m
.24975 .44093 L
.25075 .43761 L
.25175 .43607 L
.25275 .43536 L
.25375 .43518 L
.25475 .43534 L
.25574 .43575 L
.25674 .43631 L
.25774 .43698 L
.25874 .43769 L
.25974 .4384 L
.26074 .43908 L
.26174 .43967 L
.26274 .44017 L
.26374 .44052 L
.26474 .4407 L
.26573 .44069 L
.26673 .44046 L
.26773 .43998 L
.26873 .43923 L
.26973 .4382 L
.27073 .43684 L
.27173 .43516 L
.27273 .43312 L
.27373 .43072 L
.27473 .42792 L
.27572 .42473 L
.27672 .42111 L
.27772 .41707 L
.27872 .41259 L
.27972 .40765 L
.28072 .40225 L
.28172 .39638 L
.28272 .39003 L
.28372 .3832 L
.28472 .3759 L
.28571 .3681 L
.28671 .35983 L
.28771 .35108 L
.28871 .34185 L
.28971 .33216 L
.29071 .32201 L
.29171 .31143 L
.29271 .30041 L
.29371 .28899 L
.29471 .27719 L
.2957 .26503 L
.2967 .25254 L
.2977 .23976 L
Mistroke
.2987 .22672 L
.2997 .41344 L
.3007 .40881 L
.3017 .40591 L
.3027 .40382 L
.3037 .40224 L
.3047 .40102 L
.30569 .40007 L
.30669 .39932 L
.30769 .39874 L
.30869 .39828 L
.30969 .39791 L
.31069 .39762 L
.31169 .39739 L
.31269 .39719 L
.31369 .39702 L
.31469 .39686 L
.31568 .3967 L
.31668 .39652 L
.31768 .39633 L
.31868 .39611 L
.31968 .39585 L
.32068 .39555 L
.32168 .3952 L
.32268 .3948 L
.32368 .39433 L
.32468 .39379 L
.32567 .39317 L
.32667 .39248 L
.32767 .3917 L
.32867 .39083 L
.32967 .38987 L
.33067 .38881 L
.33167 .38765 L
.33267 .38637 L
.33367 .38499 L
.33467 .38349 L
.33566 .38187 L
.33666 .38012 L
.33766 .37825 L
.33866 .37625 L
.33966 .37411 L
.34066 .37183 L
.34166 .36942 L
.34266 .36686 L
.34366 .36415 L
.34466 .36129 L
.34565 .35828 L
.34665 .35511 L
.34765 .35179 L
Mistroke
.34865 .34831 L
.34965 .50294 L
.35065 .49589 L
.35165 .49012 L
.35265 .48472 L
.35365 .4794 L
.35465 .47401 L
.35564 .46847 L
.35664 .46273 L
.35764 .45678 L
.35864 .45061 L
.35964 .44424 L
.36064 .43769 L
.36164 .43101 L
.36264 .42423 L
.36364 .41741 L
.36464 .41061 L
.36563 .40389 L
.36663 .39733 L
.36763 .39098 L
.36863 .38493 L
.36963 .37923 L
.37063 .37397 L
.37163 .3692 L
.37263 .36498 L
.37363 .36136 L
.37463 .35841 L
.37562 .35614 L
.37662 .35461 L
.37762 .35381 L
.37862 .35377 L
.37962 .35449 L
.38062 .35595 L
.38162 .35812 L
.38262 .36098 L
.38362 .36448 L
.38462 .36856 L
.38561 .37314 L
.38661 .37817 L
.38761 .38354 L
.38861 .38916 L
.38961 .39495 L
.39061 .40078 L
.39161 .40657 L
.39261 .41219 L
.39361 .41755 L
.39461 .42254 L
.3956 .42706 L
.3966 .43101 L
.3976 .43431 L
Mistroke
.3986 .43688 L
.3996 .31637 L
.4006 .31128 L
.4016 .30738 L
.4026 .30377 L
.4036 .3002 L
.4046 .29652 L
.40559 .29268 L
.40659 .28861 L
.40759 .28429 L
.40859 .2797 L
.40959 .2748 L
.41059 .2696 L
.41159 .26406 L
.41259 .25817 L
.41359 .25192 L
.41459 .24529 L
.41558 .23827 L
.41658 .23084 L
.41758 .22299 L
.41858 .21469 L
.41958 .20594 L
.42058 .1967 L
.42158 .18698 L
.42258 .17674 L
.42358 .16596 L
.42458 .15463 L
.42557 .14273 L
.42657 .13023 L
.42757 .11711 L
.42857 .10335 L
.42957 .08892 L
.43057 .07379 L
.43157 .05795 L
.43257 .04136 L
.43357 .024 L
.43457 .00584 L
Mfstroke
.43457 .00584 m
.43487 0 L
s
.44902 0 m
.44955 .39431 L
.45055 .39204 L
.45155 .39123 L
.45255 .39098 L
.45355 .39102 L
.45455 .3912 L
.45554 .39147 L
.45654 .39177 L
.45754 .39206 L
.45854 .39234 L
.45954 .39258 L
.46054 .39277 L
.46154 .3929 L
.46254 .39296 L
.46354 .39295 L
.46454 .39287 L
.46553 .3927 L
.46653 .39246 L
.46753 .39213 L
.46853 .39172 L
.46953 .39122 L
.47053 .39063 L
.47153 .38996 L
.47253 .38919 L
.47353 .38835 L
.47453 .38741 L
.47552 .38639 L
.47652 .38528 L
.47752 .38408 L
.47852 .3828 L
.47952 .38143 L
.48052 .37998 L
.48152 .37844 L
.48252 .37682 L
.48352 .37512 L
.48452 .37334 L
.48551 .37148 L
.48651 .36954 L
.48751 .36753 L
.48851 .36543 L
.48951 .36327 L
.49051 .36102 L
.49151 .35871 L
.49251 .35633 L
.49351 .35388 L
.49451 .35136 L
.4955 .34878 L
.4965 .34613 L
.4975 .34343 L
Mistroke
.4985 .34066 L
.4995 .53408 L
.5005 .52574 L
.5015 .51841 L
.5025 .51122 L
.5035 .50388 L
.5045 .49627 L
.50549 .48833 L
.50649 .48006 L
.50749 .47149 L
.50849 .46269 L
.50949 .45372 L
.51049 .44468 L
.51149 .4357 L
.51249 .42688 L
.51349 .41837 L
.51449 .41029 L
.51548 .40277 L
.51648 .39595 L
.51748 .38993 L
.51848 .38482 L
.51948 .38072 L
.52048 .3777 L
.52148 .3758 L
.52248 .37507 L
.52348 .3755 L
.52448 .37707 L
.52547 .37975 L
.52647 .38346 L
.52747 .38811 L
.52847 .39357 L
.52947 .39973 L
.53047 .4064 L
.53147 .41344 L
.53247 .42064 L
.53347 .42783 L
.53447 .43481 L
.53546 .44139 L
.53646 .44738 L
.53746 .45259 L
.53846 .45688 L
.53946 .46009 L
.54046 .4621 L
.54146 .46281 L
.54246 .46216 L
.54346 .4601 L
.54446 .45664 L
.54545 .4518 L
.54645 .44565 L
.54745 .43828 L
Mistroke
.54845 .42983 L
.54945 .40181 L
.55045 .40028 L
.55145 .40038 L
.55245 .40125 L
.55345 .40261 L
.55445 .40435 L
.55544 .40638 L
.55644 .40867 L
.55744 .41119 L
.55844 .41393 L
.55944 .41688 L
.56044 .42002 L
.56144 .42337 L
.56244 .42691 L
.56344 .43065 L
.56444 .43459 L
.56543 .43874 L
.56643 .4431 L
.56743 .44767 L
.56843 .45247 L
.56943 .45749 L
.57043 .46276 L
.57143 .46827 L
.57243 .47404 L
.57343 .48007 L
.57443 .48638 L
.57542 .49297 L
.57642 .49985 L
.57742 .50705 L
.57842 .51456 L
.57942 .52241 L
.58042 .5306 L
.58142 .53914 L
.58242 .54806 L
.58342 .55736 L
.58442 .56707 L
.58541 .57719 L
.58641 .58774 L
.58741 .59873 L
.58841 .61019 L
Mfstroke
.58841 .61019 m
.58907 .61803 L
s
.59872 .61803 m
.5994 .33287 L
.6004 .32619 L
.6014 .32112 L
.6024 .31678 L
.6034 .31287 L
.6044 .30927 L
.60539 .30589 L
.60639 .30269 L
.60739 .29962 L
.60839 .29667 L
.60939 .29381 L
.61039 .29103 L
.61139 .28831 L
.61239 .28565 L
.61339 .28304 L
.61439 .28047 L
.61538 .27793 L
.61638 .27544 L
.61738 .27297 L
.61838 .27053 L
.61938 .26811 L
.62038 .26573 L
.62138 .26336 L
.62238 .26103 L
.62338 .25871 L
.62438 .25642 L
.62537 .25416 L
.62637 .25192 L
.62737 .24971 L
.62837 .24752 L
.62937 .24537 L
.63037 .24324 L
.63137 .24115 L
.63237 .23909 L
.63337 .23707 L
.63437 .23508 L
.63536 .23314 L
.63636 .23123 L
.63736 .22937 L
.63836 .22755 L
.63936 .22578 L
.64036 .22406 L
.64136 .22239 L
.64236 .22078 L
.64336 .21922 L
.64436 .21772 L
.64535 .21629 L
.64635 .21491 L
.64735 .2136 L
Mistroke
.64835 .21236 L
.64935 .32106 L
.65035 .31608 L
.65135 .31256 L
.65235 .30964 L
.65335 .30705 L
.65435 .30466 L
.65534 .3024 L
.65634 .30022 L
.65734 .2981 L
.65834 .296 L
.65934 .29391 L
.66034 .29183 L
.66134 .28974 L
.66234 .28764 L
.66334 .28552 L
.66434 .28338 L
.66533 .28122 L
.66633 .27903 L
.66733 .27682 L
.66833 .27459 L
.66933 .27232 L
.67033 .27004 L
.67133 .26773 L
.67233 .26539 L
.67333 .26304 L
.67433 .26066 L
.67532 .25827 L
.67632 .25586 L
.67732 .25343 L
.67832 .25099 L
.67932 .24855 L
.68032 .24609 L
.68132 .24363 L
.68232 .24116 L
.68332 .2387 L
.68432 .23624 L
.68531 .23378 L
.68631 .23133 L
.68731 .2289 L
.68831 .22647 L
.68931 .22407 L
.69031 .22168 L
.69131 .21932 L
.69231 .21698 L
.69331 .21467 L
.69431 .2124 L
.6953 .21016 L
.6963 .20796 L
.6973 .20581 L
Mistroke
.6983 .2037 L
.6993 .28932 L
.7003 .28701 L
.7013 .28625 L
.7023 .28619 L
.7033 .28656 L
.7043 .28722 L
.70529 .28809 L
.70629 .28913 L
.70729 .29029 L
.70829 .29154 L
.70929 .29285 L
.71029 .29421 L
.71129 .29561 L
.71229 .29701 L
.71329 .29842 L
.71429 .29982 L
.71528 .3012 L
.71628 .30254 L
.71728 .30385 L
.71828 .30511 L
.71928 .30631 L
.72028 .30746 L
.72128 .30853 L
.72228 .30953 L
.72328 .31046 L
.72428 .3113 L
.72527 .31206 L
.72627 .31273 L
.72727 .31331 L
.72827 .3138 L
.72927 .3142 L
.73027 .3145 L
.73127 .31471 L
.73227 .31483 L
.73327 .31485 L
.73427 .31478 L
.73526 .31462 L
.73626 .31437 L
.73726 .31403 L
.73826 .31361 L
.73926 .31312 L
.74026 .31255 L
.74126 .3119 L
.74226 .31119 L
.74326 .31041 L
.74426 .30958 L
.74525 .3087 L
.74625 .30776 L
.74725 .30679 L
Mistroke
.74825 .30578 L
.74925 .25682 L
.75025 .24865 L
.75125 .24158 L
.75225 .23484 L
.75325 .22823 L
.75425 .22168 L
.75524 .21515 L
.75624 .20868 L
.75724 .20227 L
.75824 .19597 L
.75924 .18983 L
.76024 .18388 L
.76124 .1782 L
.76224 .17282 L
.76324 .16781 L
.76424 .16323 L
.76523 .15913 L
.76623 .15557 L
.76723 .15262 L
.76823 .15031 L
.76923 .14872 L
.77023 .14788 L
.77123 .14785 L
.77223 .14866 L
.77323 .15035 L
.77423 .15295 L
.77522 .15648 L
.77622 .16096 L
.77722 .16641 L
.77822 .17281 L
.77922 .18016 L
.78022 .18845 L
.78122 .19764 L
.78222 .20771 L
.78322 .21859 L
.78422 .23024 L
.78521 .24258 L
.78621 .25554 L
.78721 .26904 L
.78821 .28298 L
.78921 .29726 L
.79021 .31178 L
.79121 .32644 L
.79221 .34111 L
.79321 .35569 L
.79421 .37006 L
.7952 .3841 L
.7962 .3977 L
.7972 .41074 L
Mistroke
.7982 .42309 L
.7992 .45255 L
.8002 .44845 L
.8012 .44583 L
.8022 .44384 L
.8032 .44223 L
.8042 .44086 L
.80519 .43966 L
.80619 .43858 L
.80719 .43758 L
.80819 .43663 L
.80919 .43572 L
.81019 .43483 L
.81119 .43393 L
.81219 .43303 L
.81319 .4321 L
.81419 .43114 L
.81518 .43014 L
.81618 .4291 L
.81718 .42801 L
.81818 .42687 L
.81918 .42567 L
.82018 .4244 L
.82118 .42308 L
.82218 .42169 L
.82318 .42024 L
.82418 .41873 L
.82517 .41715 L
.82617 .41552 L
.82717 .41382 L
.82817 .41207 L
.82917 .41027 L
.83017 .40841 L
.83117 .40652 L
.83217 .40458 L
.83317 .4026 L
.83417 .4006 L
.83516 .39856 L
.83616 .39651 L
.83716 .39445 L
.83816 .39238 L
.83916 .39032 L
.84016 .38826 L
.84116 .38621 L
.84216 .38419 L
.84316 .3822 L
.84416 .38025 L
.84515 .37835 L
.84615 .3765 L
.84715 .37471 L
Mistroke
.84815 .37299 L
.84915 .50019 L
.85015 .49556 L
.85115 .49233 L
.85215 .48969 L
.85315 .48735 L
.85415 .48517 L
.85514 .48308 L
.85614 .481 L
.85714 .47891 L
.85814 .47676 L
.85914 .47453 L
.86014 .47221 L
.86114 .46978 L
.86214 .46725 L
.86314 .46459 L
.86414 .46182 L
.86513 .45894 L
.86613 .45596 L
.86713 .45288 L
.86813 .44972 L
.86913 .44651 L
.87013 .44324 L
.87113 .43995 L
.87213 .43666 L
.87313 .43339 L
.87413 .43015 L
.87512 .42699 L
.87612 .42391 L
.87712 .42095 L
.87812 .41814 L
.87912 .41548 L
.88012 .41301 L
.88112 .41074 L
.88212 .40871 L
.88312 .40691 L
.88412 .40538 L
.88511 .40411 L
.88611 .40313 L
.88711 .40243 L
.88811 .40203 L
.88911 .40192 L
.89011 .40211 L
.89111 .40257 L
.89211 .40332 L
.89311 .40432 L
.89411 .40558 L
.8951 .40706 L
.8961 .40874 L
.8971 .41061 L
Mistroke
.8981 .41263 L
.8991 .45105 L
.9001 .44731 L
.9011 .44517 L
.9021 .44382 L
.9031 .44299 L
.9041 .44253 L
.90509 .44236 L
.90609 .44243 L
.90709 .44268 L
.90809 .4431 L
.90909 .44363 L
.91009 .44427 L
.91109 .44498 L
.91209 .44574 L
.91309 .44654 L
.91409 .44734 L
.91508 .44815 L
.91608 .44893 L
.91708 .44968 L
.91808 .45038 L
.91908 .45101 L
.92008 .45156 L
.92108 .45202 L
.92208 .45237 L
.92308 .45261 L
.92408 .45272 L
.92507 .4527 L
.92607 .45253 L
.92707 .4522 L
.92807 .45171 L
.92907 .45104 L
.93007 .4502 L
.93107 .44917 L
.93207 .44795 L
.93307 .44654 L
.93407 .44492 L
.93506 .4431 L
.93606 .44108 L
.93706 .43884 L
.93806 .4364 L
.93906 .43374 L
.94006 .43088 L
.94106 .4278 L
.94206 .42452 L
.94306 .42102 L
.94406 .41733 L
.94505 .41343 L
.94605 .40934 L
.94705 .40506 L
Mistroke
.94805 .40059 L
.94905 .32636 L
.95005 .32144 L
.95105 .31793 L
.95205 .31503 L
.95305 .31247 L
.95405 .31014 L
.95504 .30796 L
.95604 .30591 L
.95704 .30394 L
.95804 .30203 L
.95904 .30018 L
.96004 .29836 L
.96104 .29656 L
.96204 .29479 L
.96304 .29303 L
.96404 .29128 L
.96503 .28954 L
.96603 .28779 L
.96703 .28605 L
.96803 .28429 L
.96903 .28254 L
.97003 .28077 L
.97103 .27899 L
.97203 .2772 L
.97303 .2754 L
.97403 .27359 L
.97502 .27176 L
.97602 .26992 L
.97702 .26806 L
.97802 .26619 L
.97902 .2643 L
.98002 .2624 L
.98102 .26048 L
.98202 .25854 L
.98302 .25659 L
.98402 .25463 L
.98501 .25265 L
.98601 .25065 L
.98701 .24864 L
.98801 .24661 L
.98901 .24458 L
.99001 .24252 L
.99101 .24046 L
.99201 .23838 L
.99301 .2363 L
.99401 .2342 L
.995 .23209 L
.996 .22997 L
.997 .22785 L
Mistroke
.998 .22571 L
.999 .30807 L
Mfstroke
gsave
.999 .32299 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .37348 m
.001 .3782 L
.002 .38116 L
.003 .38343 L
.004 .38538 L
.005 .38722 L
.00599 .38906 L
.00699 .39099 L
.00799 .39308 L
.00899 .39539 L
.00999 .39797 L
.01099 .40088 L
.01199 .40416 L
.01299 .40787 L
.01399 .41207 L
.01499 .41683 L
.01598 .42221 L
.01698 .42829 L
.01798 .43517 L
.01898 .44293 L
.01998 .45168 L
.02098 .46155 L
.02198 .47268 L
.02298 .48522 L
.02398 .49934 L
.02498 .51525 L
.02597 .53315 L
.02697 .55331 L
.02797 .57599 L
.02897 .60152 L
s
.02897 .60152 m
.02955 .61803 L
s
.04934 .61803 m
.04995 .11152 L
.05095 .10764 L
.05195 .10653 L
.05295 .11015 L
.05395 .11954 L
.05495 .13523 L
.05594 .15724 L
.05694 .18508 L
.05794 .21776 L
.05894 .25377 L
.05994 .29116 L
.06094 .32761 L
.06194 .36064 L
.06294 .38772 L
.06394 .40646 L
.06494 .41485 L
.06593 .41139 L
.06693 .39526 L
.06793 .36647 L
.06893 .32596 L
.06993 .27559 L
.07093 .21815 L
.07193 .15724 L
.07293 .09702 L
.07393 .04186 L
s
.07393 .04186 m
.07484 0 L
s
.07956 0 m
.07992 .01594 L
.08092 .08008 L
.08192 .16276 L
.08292 .2608 L
.08392 .36958 L
.08492 .48307 L
.08591 .59407 L
s
.08591 .59407 m
.08615 .61803 L
s
.09353 .61803 m
.09391 .57006 L
.09491 .4124 L
.0959 .23424 L
.0969 .04701 L
s
.0969 .04701 m
.09716 0 L
s
.09933 0 m
.0999 .39879 L
.1009 .40386 L
.1019 .40742 L
.1029 .41044 L
.1039 .41325 L
.1049 .416 L
.10589 .41879 L
.10689 .42169 L
.10789 .42474 L
.10889 .42798 L
.10989 .43143 L
.11089 .43513 L
.11189 .43909 L
.11289 .44333 L
.11389 .44788 L
.11489 .45275 L
.11588 .45796 L
.11688 .46354 L
.11788 .46949 L
.11888 .47585 L
.11988 .48264 L
.12088 .48987 L
.12188 .49757 L
.12288 .50577 L
.12388 .51449 L
.12488 .52375 L
.12587 .53359 L
.12687 .54404 L
.12787 .55512 L
.12887 .56688 L
.12987 .57934 L
.13087 .59255 L
.13187 .60654 L
s
.13187 .60654 m
.13264 .61803 L
s
.14972 .61803 m
.14985 .55676 L
.15085 .55175 L
.15185 .54494 L
.15285 .53708 L
.15385 .52834 L
.15485 .5188 L
.15584 .5085 L
.15684 .49752 L
.15784 .48593 L
.15884 .47387 L
.15984 .46147 L
.16084 .44891 L
.16184 .43639 L
.16284 .42411 L
.16384 .41231 L
.16484 .40122 L
.16583 .39107 L
.16683 .3821 L
.16783 .37453 L
.16883 .36855 L
.16983 .36434 L
.17083 .36204 L
.17183 .36175 L
.17283 .36351 L
.17383 .36736 L
.17483 .37322 L
.17582 .38103 L
.17682 .39061 L
.17782 .40178 L
.17882 .41428 L
.17982 .42782 L
.18082 .44207 L
.18182 .45668 L
.18282 .47126 L
.18382 .48542 L
.18482 .49877 L
.18581 .51093 L
.18681 .52154 L
.18781 .53026 L
.18881 .53682 L
.18981 .54097 L
.19081 .54253 L
.19181 .54138 L
.19281 .53748 L
.19381 .53085 L
.19481 .52157 L
.1958 .50983 L
.1968 .49585 L
.1978 .47994 L
Mistroke
.1988 .46246 L
.1998 .29327 L
.2008 .29097 L
.2018 .28684 L
.2028 .28186 L
.2038 .27637 L
.2048 .27055 L
.20579 .26453 L
.20679 .25841 L
.20779 .25226 L
.20879 .24617 L
.20979 .2402 L
.21079 .23444 L
.21179 .22896 L
.21279 .22383 L
.21379 .21914 L
.21479 .21497 L
.21578 .2114 L
.21678 .20852 L
.21778 .20641 L
.21878 .20517 L
.21978 .2049 L
.22078 .20569 L
.22178 .20763 L
.22278 .21083 L
.22378 .21539 L
.22478 .22141 L
.22577 .22899 L
.22677 .23823 L
.22777 .24923 L
.22877 .26208 L
.22977 .2769 L
.23077 .29376 L
.23177 .31276 L
.23277 .33399 L
.23377 .35753 L
.23477 .38346 L
.23576 .41185 L
.23676 .44275 L
.23776 .4762 L
.23876 .51225 L
.23976 .5509 L
.24076 .59215 L
Mfstroke
.24076 .59215 m
.24135 .61803 L
s
.24945 .61803 m
.24975 .45541 L
.25075 .46138 L
.25175 .46594 L
.25275 .46998 L
.25375 .47374 L
.25475 .47734 L
.25574 .48083 L
.25674 .48423 L
.25774 .48753 L
.25874 .49075 L
.25974 .49386 L
.26074 .49686 L
.26174 .49972 L
.26274 .50243 L
.26374 .50496 L
.26474 .5073 L
.26573 .50942 L
.26673 .5113 L
.26773 .51291 L
.26873 .51424 L
.26973 .51526 L
.27073 .51594 L
.27173 .51628 L
.27273 .51624 L
.27373 .51582 L
.27473 .51498 L
.27572 .51373 L
.27672 .51203 L
.27772 .50989 L
.27872 .50729 L
.27972 .50422 L
.28072 .50068 L
.28172 .49666 L
.28272 .49217 L
.28372 .4872 L
.28472 .48177 L
.28571 .47587 L
.28671 .46953 L
.28771 .46276 L
.28871 .45558 L
.28971 .448 L
.29071 .44005 L
.29171 .43177 L
.29271 .42317 L
.29371 .4143 L
.29471 .4052 L
.2957 .3959 L
.2967 .38644 L
.2977 .37687 L
Mistroke
.2987 .36724 L
.2997 .42812 L
.3007 .43273 L
.3017 .43589 L
.3027 .43849 L
.3037 .44079 L
.3047 .44294 L
.30569 .44499 L
.30669 .44699 L
.30769 .44896 L
.30869 .45092 L
.30969 .45288 L
.31069 .45483 L
.31169 .4568 L
.31269 .45877 L
.31369 .46074 L
.31469 .46272 L
.31568 .4647 L
.31668 .46667 L
.31768 .46864 L
.31868 .47059 L
.31968 .47253 L
.32068 .47444 L
.32168 .47633 L
.32268 .47818 L
.32368 .48 L
.32468 .48177 L
.32567 .4835 L
.32667 .48517 L
.32767 .48678 L
.32867 .48833 L
.32967 .4898 L
.33067 .49121 L
.33167 .49252 L
.33267 .49376 L
.33367 .4949 L
.33467 .49594 L
.33566 .49688 L
.33666 .49772 L
.33766 .49844 L
.33866 .49905 L
.33966 .49953 L
.34066 .49989 L
.34166 .50012 L
.34266 .50021 L
.34366 .50017 L
.34466 .49999 L
.34565 .49966 L
.34665 .49918 L
.34765 .49855 L
Mistroke
.34865 .49777 L
.34965 .51768 L
.35065 .51987 L
.35165 .52016 L
.35265 .51941 L
.35365 .51785 L
.35465 .51562 L
.35564 .51278 L
.35664 .5094 L
.35764 .50552 L
.35864 .50119 L
.35964 .49646 L
.36064 .4914 L
.36164 .48607 L
.36264 .48053 L
.36364 .47485 L
.36464 .46912 L
.36563 .4634 L
.36663 .45778 L
.36763 .45235 L
.36863 .44716 L
.36963 .44232 L
.37063 .43788 L
.37163 .43392 L
.37263 .4305 L
.37363 .42769 L
.37463 .42552 L
.37562 .42403 L
.37662 .42326 L
.37762 .42323 L
.37862 .42394 L
.37962 .4254 L
.38062 .42758 L
.38162 .43046 L
.38262 .43401 L
.38362 .43817 L
.38462 .44289 L
.38561 .44811 L
.38661 .45374 L
.38761 .4597 L
.38861 .4659 L
.38961 .47225 L
.39061 .47864 L
.39161 .48499 L
.39261 .49117 L
.39361 .4971 L
.39461 .50268 L
.3956 .5078 L
.3966 .51239 L
.3976 .51635 L
Mistroke
.3986 .51962 L
.3996 .33126 L
.4006 .33533 L
.4016 .33751 L
.4026 .33869 L
.4036 .3392 L
.4046 .3392 L
.40559 .33876 L
.40659 .33796 L
.40759 .33684 L
.40859 .33544 L
.40959 .33378 L
.41059 .33188 L
.41159 .32974 L
.41259 .3274 L
.41359 .32484 L
.41459 .32209 L
.41558 .31913 L
.41658 .31598 L
.41758 .31264 L
.41858 .3091 L
.41958 .30536 L
.42058 .30142 L
.42158 .29728 L
.42258 .29293 L
.42358 .28837 L
.42458 .2836 L
.42557 .27859 L
.42657 .27336 L
.42757 .26788 L
.42857 .26216 L
.42957 .25618 L
.43057 .24993 L
.43157 .2434 L
.43257 .23659 L
.43357 .22949 L
.43457 .22207 L
.43556 .21433 L
.43656 .20626 L
.43756 .19785 L
.43856 .18908 L
.43956 .17993 L
.44056 .1704 L
.44156 .16047 L
.44256 .15013 L
.44356 .13935 L
.44456 .12812 L
.44555 .11644 L
.44655 .10427 L
.44755 .0916 L
Mistroke
.44855 .07842 L
.44955 .40878 L
.45055 .4159 L
.45155 .42128 L
.45255 .42582 L
.45355 .42981 L
.45455 .43338 L
.45554 .43662 L
.45654 .43957 L
.45754 .44227 L
.45854 .44475 L
.45954 .44702 L
.46054 .4491 L
.46154 .45101 L
.46254 .45276 L
.46354 .45434 L
.46454 .45578 L
.46553 .45707 L
.46653 .45822 L
.46753 .45923 L
.46853 .46011 L
.46953 .46086 L
.47053 .46149 L
.47153 .46199 L
.47253 .46238 L
.47353 .46264 L
.47453 .46279 L
.47552 .46282 L
.47652 .46274 L
.47752 .46255 L
.47852 .46225 L
.47952 .46185 L
.48052 .46134 L
.48152 .46073 L
.48252 .46003 L
.48352 .45922 L
.48452 .45833 L
.48551 .45735 L
.48651 .45627 L
.48751 .45512 L
.48851 .45388 L
.48951 .45257 L
.49051 .45118 L
.49151 .44972 L
.49251 .4482 L
.49351 .44661 L
.49451 .44497 L
.4955 .44327 L
.4965 .44152 L
.4975 .43972 L
Mistroke
.4985 .43789 L
.4995 .54903 L
.5005 .54977 L
.5015 .54845 L
.5025 .54586 L
.5035 .54227 L
.5045 .53779 L
.50549 .53254 L
.50649 .5266 L
.50749 .52007 L
.50849 .51305 L
.50949 .50568 L
.51049 .49806 L
.51149 .49035 L
.51249 .48268 L
.51349 .47519 L
.51449 .46804 L
.51548 .46137 L
.51648 .45531 L
.51748 .45 L
.51848 .44555 L
.51948 .44205 L
.52048 .4396 L
.52148 .43825 L
.52248 .43805 L
.52348 .43899 L
.52448 .44108 L
.52547 .44426 L
.52647 .44849 L
.52747 .45366 L
.52847 .45967 L
.52947 .46638 L
.53047 .47364 L
.53147 .48128 L
.53247 .48912 L
.53347 .49697 L
.53447 .50464 L
.53546 .51193 L
.53646 .51865 L
.53746 .52464 L
.53846 .52972 L
.53946 .53375 L
.54046 .53661 L
.54146 .53821 L
.54246 .53846 L
.54346 .53734 L
.54446 .53484 L
.54545 .53098 L
.54645 .52584 L
.54745 .51949 L
Mistroke
.54845 .51208 L
.54945 .41668 L
.55045 .42426 L
.55145 .43046 L
.55245 .43615 L
.55345 .44165 L
.55445 .44709 L
.55544 .45258 L
.55644 .45817 L
.55744 .46392 L
.55844 .46987 L
.55944 .47604 L
.56044 .48247 L
.56144 .48919 L
.56244 .49621 L
.56344 .50356 L
.56444 .51127 L
.56543 .51935 L
.56643 .52782 L
.56743 .5367 L
.56843 .54602 L
.56943 .5558 L
.57043 .56605 L
.57143 .5768 L
.57243 .58806 L
.57343 .59986 L
.57443 .61223 L
Mfstroke
.57443 .61223 m
.57487 .61803 L
s
.59906 .61803 m
.5994 .34738 L
.6004 .35007 L
.6014 .35125 L
.6024 .3518 L
.6034 .35198 L
.6044 .35194 L
.60539 .35173 L
.60639 .35141 L
.60739 .35101 L
.60839 .35055 L
.60939 .35004 L
.61039 .3495 L
.61139 .34895 L
.61239 .34837 L
.61339 .34779 L
.61439 .34721 L
.61538 .34662 L
.61638 .34604 L
.61738 .34547 L
.61838 .3449 L
.61938 .34434 L
.62038 .3438 L
.62138 .34328 L
.62238 .34276 L
.62338 .34227 L
.62438 .3418 L
.62537 .34134 L
.62637 .34091 L
.62737 .3405 L
.62837 .34011 L
.62937 .33975 L
.63037 .33941 L
.63137 .3391 L
.63237 .33882 L
.63337 .33857 L
.63437 .33835 L
.63536 .33816 L
.63636 .33801 L
.63736 .33789 L
.63836 .3378 L
.63936 .33775 L
.64036 .33774 L
.64136 .33777 L
.64236 .33784 L
.64336 .33796 L
.64436 .33812 L
.64535 .33832 L
.64635 .33857 L
.64735 .33887 L
Mistroke
.64835 .33922 L
.64935 .3359 L
.65035 .34019 L
.65135 .34286 L
.65235 .3448 L
.65335 .34626 L
.65435 .3474 L
.65534 .34829 L
.65634 .34898 L
.65734 .34952 L
.65834 .34992 L
.65934 .35021 L
.66034 .35041 L
.66134 .35052 L
.66234 .35057 L
.66334 .35056 L
.66434 .35049 L
.66533 .35038 L
.66633 .35023 L
.66733 .35005 L
.66833 .34984 L
.66933 .3496 L
.67033 .34935 L
.67133 .34907 L
.67233 .34878 L
.67333 .34848 L
.67433 .34817 L
.67532 .34785 L
.67632 .34753 L
.67732 .3472 L
.67832 .34688 L
.67932 .34655 L
.68032 .34623 L
.68132 .34592 L
.68232 .34561 L
.68332 .34531 L
.68432 .34503 L
.68531 .34475 L
.68631 .34449 L
.68731 .34424 L
.68831 .34401 L
.68931 .3438 L
.69031 .34361 L
.69131 .34344 L
.69231 .34329 L
.69331 .34317 L
.69431 .34307 L
.6953 .343 L
.6963 .34296 L
.6973 .34295 L
Mistroke
.6983 .34298 L
.6993 .30413 L
.7003 .3111 L
.7013 .31656 L
.7023 .32134 L
.7033 .32571 L
.7043 .32979 L
.70529 .33365 L
.70629 .33732 L
.70729 .34084 L
.70829 .34422 L
.70929 .34748 L
.71029 .35063 L
.71129 .35366 L
.71229 .35659 L
.71329 .35942 L
.71429 .36214 L
.71528 .36476 L
.71628 .36728 L
.71728 .3697 L
.71828 .37201 L
.71928 .37422 L
.72028 .37632 L
.72128 .37832 L
.72228 .3802 L
.72328 .38198 L
.72428 .38365 L
.72527 .38521 L
.72627 .38666 L
.72727 .388 L
.72827 .38923 L
.72927 .39035 L
.73027 .39136 L
.73127 .39227 L
.73227 .39307 L
.73327 .39376 L
.73427 .39436 L
.73526 .39485 L
.73626 .39525 L
.73726 .39556 L
.73826 .39577 L
.73926 .3959 L
.74026 .39594 L
.74126 .39591 L
.74226 .3958 L
.74326 .39562 L
.74426 .39538 L
.74525 .39507 L
.74625 .39471 L
.74725 .3943 L
Mistroke
.74825 .39384 L
.74925 .27189 L
.75025 .27291 L
.75125 .27217 L
.75225 .27052 L
.75325 .26828 L
.75425 .26563 L
.75524 .26268 L
.75624 .25955 L
.75724 .2563 L
.75824 .25302 L
.75924 .24977 L
.76024 .24662 L
.76124 .24363 L
.76224 .24087 L
.76324 .23839 L
.76424 .23625 L
.76523 .2345 L
.76623 .23319 L
.76723 .23238 L
.76823 .23212 L
.76923 .23244 L
.77023 .23339 L
.77123 .23502 L
.77223 .23735 L
.77323 .24042 L
.77423 .24427 L
.77522 .24892 L
.77622 .25439 L
.77722 .2607 L
.77822 .26786 L
.77922 .27589 L
.78022 .28478 L
.78122 .29454 L
.78222 .30516 L
.78322 .31663 L
.78422 .32892 L
.78521 .34203 L
.78621 .35591 L
.78721 .37052 L
.78821 .38581 L
.78921 .40172 L
.79021 .41819 L
.79121 .43512 L
.79221 .45243 L
.79321 .47001 L
.79421 .48774 L
.7952 .50549 L
.7962 .52312 L
.7972 .54048 L
Mistroke
.7982 .55741 L
.7992 .4672 L
.8002 .47259 L
.8012 .4765 L
.8022 .47976 L
.8032 .48262 L
.8042 .48518 L
.80519 .48751 L
.80619 .48965 L
.80719 .4916 L
.80819 .49339 L
.80919 .49503 L
.81019 .49651 L
.81119 .49785 L
.81219 .49905 L
.81319 .50009 L
.81419 .50099 L
.81518 .50175 L
.81618 .50236 L
.81718 .50282 L
.81818 .50314 L
.81918 .50331 L
.82018 .50333 L
.82118 .50321 L
.82218 .50295 L
.82318 .50255 L
.82418 .50201 L
.82517 .50133 L
.82617 .50053 L
.82717 .4996 L
.82817 .49855 L
.82917 .49738 L
.83017 .49612 L
.83117 .49475 L
.83217 .49329 L
.83317 .49175 L
.83417 .49013 L
.83516 .48845 L
.83616 .48672 L
.83716 .48494 L
.83816 .48313 L
.83916 .48129 L
.84016 .47945 L
.84116 .4776 L
.84216 .47577 L
.84316 .47395 L
.84416 .47217 L
.84515 .47044 L
.84615 .46875 L
.84715 .46714 L
Mistroke
.84815 .46559 L
.84915 .51514 L
.85015 .51988 L
.85115 .52312 L
.85215 .52564 L
.85315 .52767 L
.85415 .5293 L
.85514 .53059 L
.85614 .53157 L
.85714 .53224 L
.85814 .53261 L
.85914 .5327 L
.86014 .5325 L
.86114 .53202 L
.86214 .53127 L
.86314 .53025 L
.86414 .52898 L
.86513 .52747 L
.86613 .52574 L
.86713 .5238 L
.86813 .52167 L
.86913 .51937 L
.87013 .51694 L
.87113 .51439 L
.87213 .51175 L
.87313 .50906 L
.87413 .50634 L
.87512 .50363 L
.87612 .50095 L
.87712 .49833 L
.87812 .49582 L
.87912 .49342 L
.88012 .49118 L
.88112 .48912 L
.88212 .48726 L
.88312 .48563 L
.88412 .48424 L
.88511 .4831 L
.88611 .48224 L
.88711 .48167 L
.88811 .48137 L
.88911 .48137 L
.89011 .48166 L
.89111 .48223 L
.89211 .48307 L
.89311 .48417 L
.89411 .48553 L
.8951 .48711 L
.8961 .48889 L
.8971 .49087 L
Mistroke
.8981 .49299 L
.8991 .46603 L
.9001 .47167 L
.9011 .47605 L
.9021 .47996 L
.9031 .48364 L
.9041 .4872 L
.90509 .49069 L
.90609 .49415 L
.90709 .49759 L
.90809 .50102 L
.90909 .50443 L
.91009 .50783 L
.91109 .51121 L
.91209 .51455 L
.91309 .51786 L
.91409 .52111 L
.91508 .5243 L
.91608 .52742 L
.91708 .53044 L
.91808 .53335 L
.91908 .53615 L
.92008 .53881 L
.92108 .54133 L
.92208 .54368 L
.92308 .54586 L
.92408 .54785 L
.92507 .54964 L
.92607 .55121 L
.92707 .55255 L
.92807 .55366 L
.92907 .55452 L
.93007 .55512 L
.93107 .55545 L
.93207 .55551 L
.93307 .55529 L
.93407 .55478 L
.93506 .55399 L
.93606 .5529 L
.93706 .55152 L
.93806 .54985 L
.93906 .54789 L
.94006 .54563 L
.94106 .5431 L
.94206 .54029 L
.94306 .53721 L
.94406 .53387 L
.94505 .53029 L
.94605 .52646 L
.94705 .52242 L
Mistroke
.94805 .51817 L
.94905 .34114 L
.95005 .34571 L
.95105 .3488 L
.95205 .35122 L
.95305 .35324 L
.95405 .35497 L
.95504 .35648 L
.95604 .35782 L
.95704 .35902 L
.95804 .36009 L
.95904 .36107 L
.96004 .36195 L
.96104 .36275 L
.96204 .36349 L
.96304 .36415 L
.96404 .36477 L
.96503 .36532 L
.96603 .36583 L
.96703 .3663 L
.96803 .36672 L
.96903 .36711 L
.97003 .36746 L
.97103 .36778 L
.97203 .36807 L
.97303 .36833 L
.97403 .36856 L
.97502 .36877 L
.97602 .36896 L
.97702 .36912 L
.97802 .36926 L
.97902 .36939 L
.98002 .36949 L
.98102 .36958 L
.98202 .36966 L
.98302 .36972 L
.98402 .36976 L
.98501 .36979 L
.98601 .36981 L
.98701 .36981 L
.98801 .36981 L
.98901 .36979 L
.99001 .36977 L
.99101 .36973 L
.99201 .36969 L
.99301 .36964 L
.99401 .36958 L
.995 .36951 L
.996 .36943 L
.997 .36935 L
Mistroke
.998 .36926 L
.999 .32299 L
Mfstroke
1 0 0 r
gsave
.999 .31553 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .36586 m
.001 .36634 L
.002 .36662 L
.003 .36673 L
.004 .36669 L
.005 .36654 L
.00599 .36627 L
.00699 .36591 L
.00799 .36545 L
.00899 .36489 L
.00999 .36424 L
.01099 .36349 L
.01199 .36262 L
.01299 .36163 L
.01399 .36051 L
.01499 .35924 L
.01598 .35781 L
.01698 .3562 L
.01798 .35438 L
.01898 .35233 L
.01998 .35003 L
.02098 .34744 L
.02198 .34452 L
.02298 .34123 L
.02398 .33754 L
.02498 .33338 L
.02597 .3287 L
.02697 .32344 L
.02797 .31752 L
.02897 .31086 L
.02997 .30337 L
.03097 .29495 L
.03197 .28547 L
.03297 .27481 L
.03397 .26281 L
.03497 .24932 L
.03596 .23415 L
.03696 .21708 L
.03796 .19787 L
.03896 .17627 L
.03996 .15197 L
.04096 .12464 L
.04196 .0939 L
.04296 .05931 L
.04396 .02041 L
s
.04396 .02041 m
.04442 0 L
s
.04967 0 m
.04995 .10387 L
.05095 .09572 L
.05195 .09194 L
.05295 .09356 L
.05395 .10126 L
.05495 .11532 L
.05594 .13559 L
.05694 .16141 L
.05794 .1917 L
.05894 .22491 L
.05994 .25913 L
.06094 .2922 L
.06194 .32178 L
.06294 .34556 L
.06394 .3614 L
.06494 .36747 L
.06593 .36243 L
.06693 .34556 L
.06793 .3169 L
.06893 .27727 L
.06993 .22832 L
.07093 .1725 L
.07193 .11298 L
.07293 .05345 L
s
.07293 .05345 m
.07389 0 L
s
.0806 0 m
.08092 .01993 L
.08192 .09982 L
.08292 .19413 L
.08392 .29783 L
.08492 .40473 L
.08591 .50786 L
.08691 .59978 L
s
.08691 .59978 m
.08716 .61803 L
s
.0924 .61803 m
.09291 .57064 L
.09391 .44305 L
.09491 .28633 L
.0959 .10838 L
s
.0959 .10838 m
.09648 0 L
s
.09943 0 m
.0999 .39146 L
.1009 .39202 L
.1019 .39271 L
.1029 .39354 L
.1039 .3945 L
.1049 .39561 L
.10589 .39688 L
.10689 .39831 L
.10789 .39991 L
.10889 .40169 L
.10989 .40366 L
.11089 .40582 L
.11189 .40818 L
.11289 .41075 L
.11389 .41354 L
.11489 .41656 L
.11588 .41983 L
.11688 .42335 L
.11788 .42713 L
.11888 .43118 L
.11988 .43553 L
.12088 .44018 L
.12188 .44515 L
.12288 .45045 L
.12388 .4561 L
.12488 .46212 L
.12587 .46853 L
.12687 .47534 L
.12787 .48257 L
.12887 .49026 L
.12987 .49842 L
.13087 .50707 L
.13187 .51625 L
.13287 .52597 L
.13387 .53627 L
.13487 .54718 L
.13586 .55874 L
.13686 .57097 L
.13786 .58391 L
.13886 .5976 L
.13986 .61208 L
s
.13986 .61208 m
.14025 .61803 L
s
.14956 .61803 m
.14985 .54953 L
.15085 .53984 L
.15185 .52997 L
.15285 .51976 L
.15385 .50908 L
.15485 .49785 L
.15584 .48603 L
.15684 .47364 L
.15784 .46073 L
.15884 .44739 L
.15984 .43374 L
.16084 .41996 L
.16184 .40623 L
.16284 .39276 L
.16384 .37978 L
.16484 .36754 L
.16583 .35626 L
.16683 .34618 L
.16783 .33752 L
.16883 .33049 L
.16983 .32526 L
.17083 .32196 L
.17183 .32069 L
.17283 .32152 L
.17383 .32444 L
.17483 .32941 L
.17582 .33634 L
.17682 .34507 L
.17782 .35541 L
.17882 .36712 L
.17982 .3799 L
.18082 .39343 L
.18182 .40736 L
.18282 .4213 L
.18382 .43486 L
.18482 .44765 L
.18581 .45928 L
.18681 .46939 L
.18781 .47762 L
.18881 .48368 L
.18981 .48731 L
.19081 .48831 L
.19181 .48653 L
.19281 .48192 L
.19381 .47447 L
.19481 .46428 L
.1958 .45149 L
.1968 .43635 L
.1978 .41916 L
Mistroke
.1988 .40031 L
.1998 .28578 L
.2008 .27884 L
.2018 .27168 L
.2028 .2643 L
.2038 .25676 L
.2048 .24908 L
.20579 .24131 L
.20679 .23348 L
.20779 .22566 L
.20879 .21789 L
.20979 .21025 L
.21079 .20279 L
.21179 .19559 L
.21279 .18873 L
.21379 .18228 L
.21479 .17633 L
.21578 .17096 L
.21678 .16629 L
.21778 .16238 L
.21878 .15936 L
.21978 .15732 L
.22078 .15636 L
.22178 .15659 L
.22278 .15812 L
.22378 .16104 L
.22478 .16547 L
.22577 .17152 L
.22677 .17927 L
.22777 .18882 L
.22877 .20028 L
.22977 .21372 L
.23077 .22923 L
.23177 .24687 L
.23277 .2667 L
.23377 .28879 L
.23477 .31316 L
.23576 .33984 L
.23676 .36884 L
.23776 .40016 L
.23876 .43376 L
.23976 .46961 L
.24076 .50764 L
.24176 .54776 L
.24276 .58986 L
Mfstroke
.24276 .58986 m
.2434 .61803 L
s
.24935 .61803 m
.24975 .44817 L
.25075 .44949 L
.25175 .451 L
.25275 .45267 L
.25375 .45446 L
.25475 .45634 L
.25574 .45829 L
.25674 .46027 L
.25774 .46226 L
.25874 .46422 L
.25974 .46613 L
.26074 .46797 L
.26174 .4697 L
.26274 .4713 L
.26374 .47274 L
.26474 .474 L
.26573 .47506 L
.26673 .47588 L
.26773 .47645 L
.26873 .47674 L
.26973 .47673 L
.27073 .47639 L
.27173 .47572 L
.27273 .47468 L
.27373 .47327 L
.27473 .47145 L
.27572 .46923 L
.27672 .46657 L
.27772 .46348 L
.27872 .45994 L
.27972 .45593 L
.28072 .45146 L
.28172 .44652 L
.28272 .4411 L
.28372 .4352 L
.28472 .42883 L
.28571 .42199 L
.28671 .41468 L
.28771 .40692 L
.28871 .39871 L
.28971 .39008 L
.29071 .38103 L
.29171 .3716 L
.29271 .36179 L
.29371 .35165 L
.29471 .3412 L
.2957 .33046 L
.2967 .31949 L
.2977 .30832 L
Mistroke
.2987 .29698 L
.2997 .42078 L
.3007 .42077 L
.3017 .4209 L
.3027 .42115 L
.3037 .42151 L
.3047 .42198 L
.30569 .42253 L
.30669 .42316 L
.30769 .42385 L
.30869 .4246 L
.30969 .42539 L
.31069 .42623 L
.31169 .42709 L
.31269 .42798 L
.31369 .42888 L
.31469 .42979 L
.31568 .4307 L
.31668 .4316 L
.31768 .43248 L
.31868 .43335 L
.31968 .43419 L
.32068 .435 L
.32168 .43577 L
.32268 .43649 L
.32368 .43716 L
.32468 .43778 L
.32567 .43834 L
.32667 .43883 L
.32767 .43924 L
.32867 .43958 L
.32967 .43984 L
.33067 .44001 L
.33167 .44009 L
.33267 .44006 L
.33367 .43994 L
.33467 .43971 L
.33566 .43937 L
.33666 .43892 L
.33766 .43834 L
.33866 .43765 L
.33966 .43682 L
.34066 .43586 L
.34166 .43477 L
.34266 .43353 L
.34366 .43216 L
.34466 .43064 L
.34565 .42897 L
.34665 .42715 L
.34765 .42517 L
Mistroke
.34865 .42304 L
.34965 .51031 L
.35065 .50788 L
.35165 .50514 L
.35265 .50207 L
.35365 .49863 L
.35465 .49482 L
.35564 .49063 L
.35664 .48607 L
.35764 .48115 L
.35864 .4759 L
.35964 .47035 L
.36064 .46455 L
.36164 .45854 L
.36264 .45238 L
.36364 .44613 L
.36464 .43986 L
.36563 .43365 L
.36663 .42756 L
.36763 .42166 L
.36863 .41605 L
.36963 .41078 L
.37063 .40592 L
.37163 .40156 L
.37263 .39774 L
.37363 .39453 L
.37463 .39196 L
.37562 .39009 L
.37662 .38893 L
.37762 .38852 L
.37862 .38886 L
.37962 .38994 L
.38062 .39176 L
.38162 .39429 L
.38262 .3975 L
.38362 .40133 L
.38462 .40573 L
.38561 .41063 L
.38661 .41595 L
.38761 .42162 L
.38861 .42753 L
.38961 .4336 L
.39061 .43971 L
.39161 .44578 L
.39261 .45168 L
.39361 .45733 L
.39461 .46261 L
.3956 .46743 L
.3966 .4717 L
.3976 .47533 L
Mistroke
.3986 .47825 L
.3996 .32382 L
.4006 .32331 L
.4016 .32244 L
.4026 .32123 L
.4036 .3197 L
.4046 .31786 L
.40559 .31572 L
.40659 .31329 L
.40759 .31057 L
.40859 .30757 L
.40959 .30429 L
.41059 .30074 L
.41159 .2969 L
.41259 .29278 L
.41359 .28838 L
.41459 .28369 L
.41558 .2787 L
.41658 .27341 L
.41758 .26781 L
.41858 .26189 L
.41958 .25565 L
.42058 .24906 L
.42158 .24213 L
.42258 .23484 L
.42358 .22717 L
.42458 .21912 L
.42557 .21066 L
.42657 .20179 L
.42757 .1925 L
.42857 .18275 L
.42957 .17255 L
.43057 .16186 L
.43157 .15068 L
.43257 .13898 L
.43357 .12674 L
.43457 .11395 L
.43556 .10059 L
.43656 .08662 L
.43756 .07203 L
.43856 .0568 L
.43956 .0409 L
.44056 .02431 L
.44156 .007 L
Mfstroke
.44156 .007 m
.44195 0 L
s
.44881 0 m
.44955 .40154 L
.45055 .40397 L
.45155 .40625 L
.45255 .4084 L
.45355 .41041 L
.45455 .41229 L
.45554 .41404 L
.45654 .41567 L
.45754 .41717 L
.45854 .41854 L
.45954 .4198 L
.46054 .42094 L
.46154 .42195 L
.46254 .42286 L
.46354 .42365 L
.46454 .42432 L
.46553 .42489 L
.46653 .42534 L
.46753 .42568 L
.46853 .42591 L
.46953 .42604 L
.47053 .42606 L
.47153 .42598 L
.47253 .42579 L
.47353 .42549 L
.47453 .4251 L
.47552 .4246 L
.47652 .42401 L
.47752 .42331 L
.47852 .42252 L
.47952 .42164 L
.48052 .42066 L
.48152 .41959 L
.48252 .41842 L
.48352 .41717 L
.48452 .41584 L
.48551 .41441 L
.48651 .41291 L
.48751 .41132 L
.48851 .40966 L
.48951 .40792 L
.49051 .4061 L
.49151 .40422 L
.49251 .40226 L
.49351 .40025 L
.49451 .39816 L
.4955 .39602 L
.4965 .39383 L
.4975 .39158 L
Mistroke
.4985 .38927 L
.4995 .54155 L
.5005 .53775 L
.5015 .53343 L
.5025 .52854 L
.5035 .52307 L
.5045 .51703 L
.50549 .51043 L
.50649 .50333 L
.50749 .49578 L
.50849 .48787 L
.50949 .4797 L
.51049 .47137 L
.51149 .46302 L
.51249 .45478 L
.51349 .44678 L
.51449 .43917 L
.51548 .43207 L
.51648 .42563 L
.51748 .41996 L
.51848 .41518 L
.51948 .41139 L
.52048 .40865 L
.52148 .40703 L
.52248 .40656 L
.52348 .40724 L
.52448 .40907 L
.52547 .41201 L
.52647 .41597 L
.52747 .42088 L
.52847 .42662 L
.52947 .43305 L
.53047 .44002 L
.53147 .44736 L
.53247 .45488 L
.53347 .4624 L
.53447 .46973 L
.53546 .47666 L
.53646 .48301 L
.53746 .48862 L
.53846 .4933 L
.53946 .49692 L
.54046 .49936 L
.54146 .50051 L
.54246 .50031 L
.54346 .49872 L
.54446 .49574 L
.54545 .49139 L
.54645 .48575 L
.54745 .47889 L
Mistroke
.54845 .47095 L
.54945 .40925 L
.55045 .41227 L
.55145 .41542 L
.55245 .4187 L
.55345 .42213 L
.55445 .42572 L
.55544 .42948 L
.55644 .43342 L
.55744 .43756 L
.55844 .4419 L
.55944 .44646 L
.56044 .45125 L
.56144 .45628 L
.56244 .46156 L
.56344 .46711 L
.56444 .47293 L
.56543 .47904 L
.56643 .48546 L
.56743 .49219 L
.56843 .49924 L
.56943 .50665 L
.57043 .5144 L
.57143 .52253 L
.57243 .53105 L
.57343 .53997 L
.57443 .5493 L
.57542 .55907 L
.57642 .56929 L
.57742 .57998 L
.57842 .59115 L
.57942 .60283 L
.58042 .61504 L
Mfstroke
.58042 .61504 m
.58065 .61803 L
s
.59895 .61803 m
.5994 .34012 L
.6004 .33813 L
.6014 .33619 L
.6024 .33429 L
.6034 .33243 L
.6044 .3306 L
.60539 .32881 L
.60639 .32705 L
.60739 .32532 L
.60839 .32361 L
.60939 .32193 L
.61039 .32027 L
.61139 .31863 L
.61239 .31701 L
.61339 .31541 L
.61439 .31384 L
.61538 .31228 L
.61638 .31074 L
.61738 .30922 L
.61838 .30771 L
.61938 .30623 L
.62038 .30477 L
.62138 .30332 L
.62238 .3019 L
.62338 .30049 L
.62438 .29911 L
.62537 .29775 L
.62637 .29641 L
.62737 .2951 L
.62837 .29382 L
.62937 .29256 L
.63037 .29133 L
.63137 .29013 L
.63237 .28896 L
.63337 .28782 L
.63437 .28672 L
.63536 .28565 L
.63636 .28462 L
.63736 .28363 L
.63836 .28268 L
.63936 .28177 L
.64036 .2809 L
.64136 .28008 L
.64236 .27931 L
.64336 .27859 L
.64436 .27792 L
.64535 .2773 L
.64635 .27674 L
.64735 .27623 L
Mistroke
.64835 .27579 L
.64935 .32848 L
.65035 .32814 L
.65135 .32771 L
.65235 .32722 L
.65335 .32666 L
.65435 .32603 L
.65534 .32535 L
.65634 .3246 L
.65734 .32381 L
.65834 .32296 L
.65934 .32206 L
.66034 .32112 L
.66134 .32013 L
.66234 .3191 L
.66334 .31804 L
.66434 .31694 L
.66533 .3158 L
.66633 .31463 L
.66733 .31344 L
.66833 .31221 L
.66933 .31096 L
.67033 .30969 L
.67133 .3084 L
.67233 .30709 L
.67333 .30576 L
.67433 .30441 L
.67532 .30306 L
.67632 .30169 L
.67732 .30032 L
.67832 .29893 L
.67932 .29755 L
.68032 .29616 L
.68132 .29477 L
.68232 .29339 L
.68332 .29201 L
.68432 .29063 L
.68531 .28927 L
.68631 .28791 L
.68731 .28657 L
.68831 .28524 L
.68931 .28393 L
.69031 .28264 L
.69131 .28138 L
.69231 .28014 L
.69331 .27892 L
.69431 .27774 L
.6953 .27658 L
.6963 .27546 L
.6973 .27438 L
Mistroke
.6983 .27334 L
.6993 .29673 L
.7003 .29906 L
.7013 .30141 L
.7023 .30377 L
.7033 .30614 L
.7043 .30851 L
.70529 .31087 L
.70629 .31322 L
.70729 .31556 L
.70829 .31788 L
.70929 .32017 L
.71029 .32242 L
.71129 .32463 L
.71229 .3268 L
.71329 .32892 L
.71429 .33098 L
.71528 .33298 L
.71628 .33491 L
.71728 .33677 L
.71828 .33856 L
.71928 .34027 L
.72028 .34189 L
.72128 .34342 L
.72228 .34487 L
.72328 .34622 L
.72428 .34748 L
.72527 .34864 L
.72627 .3497 L
.72727 .35066 L
.72827 .35152 L
.72927 .35228 L
.73027 .35293 L
.73127 .35349 L
.73227 .35395 L
.73327 .35431 L
.73427 .35457 L
.73526 .35473 L
.73626 .35481 L
.73726 .35479 L
.73826 .35469 L
.73926 .35451 L
.74026 .35424 L
.74126 .35391 L
.74226 .3535 L
.74326 .35302 L
.74426 .35248 L
.74525 .35188 L
.74625 .35124 L
.74725 .35054 L
Mistroke
.74825 .34981 L
.74925 .26435 L
.75025 .26078 L
.75125 .25687 L
.75225 .25268 L
.75325 .24826 L
.75425 .24365 L
.75524 .23892 L
.75624 .23411 L
.75724 .22928 L
.75824 .22449 L
.75924 .2198 L
.76024 .21525 L
.76124 .21092 L
.76224 .20685 L
.76324 .2031 L
.76424 .19974 L
.76523 .19681 L
.76623 .19438 L
.76723 .1925 L
.76823 .19122 L
.76923 .19058 L
.77023 .19064 L
.77123 .19143 L
.77223 .193 L
.77323 .19539 L
.77423 .19861 L
.77522 .2027 L
.77622 .20768 L
.77722 .21355 L
.77822 .22034 L
.77922 .22802 L
.78022 .23662 L
.78122 .24609 L
.78222 .25643 L
.78322 .26761 L
.78422 .27958 L
.78521 .2923 L
.78621 .30572 L
.78721 .31978 L
.78821 .33439 L
.78921 .34949 L
.79021 .36499 L
.79121 .38078 L
.79221 .39677 L
.79321 .41285 L
.79421 .4289 L
.7952 .44479 L
.7962 .46041 L
.7972 .47561 L
Mistroke
.7982 .49025 L
.7992 .45987 L
.8002 .46052 L
.8012 .46117 L
.8022 .4618 L
.8032 .46243 L
.8042 .46302 L
.80519 .46359 L
.80619 .46411 L
.80719 .46459 L
.80819 .46501 L
.80919 .46538 L
.81019 .46567 L
.81119 .46589 L
.81219 .46604 L
.81319 .4661 L
.81419 .46607 L
.81518 .46595 L
.81618 .46573 L
.81718 .46542 L
.81818 .465 L
.81918 .46449 L
.82018 .46387 L
.82118 .46315 L
.82218 .46232 L
.82318 .46139 L
.82418 .46037 L
.82517 .45924 L
.82617 .45802 L
.82717 .45671 L
.82817 .45531 L
.82917 .45383 L
.83017 .45226 L
.83117 .45063 L
.83217 .44893 L
.83317 .44717 L
.83417 .44536 L
.83516 .44351 L
.83616 .44161 L
.83716 .43969 L
.83816 .43776 L
.83916 .4358 L
.84016 .43385 L
.84116 .43191 L
.84216 .42998 L
.84316 .42808 L
.84416 .42621 L
.84515 .42439 L
.84615 .42262 L
.84715 .42092 L
Mistroke
.84815 .41929 L
.84915 .50766 L
.85015 .50772 L
.85115 .50773 L
.85215 .50766 L
.85315 .50751 L
.85415 .50724 L
.85514 .50684 L
.85614 .50629 L
.85714 .50557 L
.85814 .50469 L
.85914 .50361 L
.86014 .50235 L
.86114 .5009 L
.86214 .49926 L
.86314 .49742 L
.86414 .4954 L
.86513 .49321 L
.86613 .49085 L
.86713 .48834 L
.86813 .4857 L
.86913 .48294 L
.87013 .48009 L
.87113 .47717 L
.87213 .47421 L
.87313 .47122 L
.87413 .46825 L
.87512 .46531 L
.87612 .46243 L
.87712 .45964 L
.87812 .45698 L
.87912 .45445 L
.88012 .4521 L
.88112 .44993 L
.88212 .44798 L
.88312 .44627 L
.88412 .44481 L
.88511 .44361 L
.88611 .44269 L
.88711 .44205 L
.88811 .4417 L
.88911 .44165 L
.89011 .44188 L
.89111 .4424 L
.89211 .44319 L
.89311 .44425 L
.89411 .44555 L
.8951 .44708 L
.8961 .44882 L
.8971 .45074 L
Mistroke
.8981 .45281 L
.8991 .45854 L
.9001 .45949 L
.9011 .46061 L
.9021 .46189 L
.9031 .46331 L
.9041 .46486 L
.90509 .46652 L
.90609 .46829 L
.90709 .47014 L
.90809 .47206 L
.90909 .47403 L
.91009 .47605 L
.91109 .47809 L
.91209 .48015 L
.91309 .4822 L
.91409 .48423 L
.91508 .48623 L
.91608 .48817 L
.91708 .49006 L
.91808 .49186 L
.91908 .49358 L
.92008 .49519 L
.92108 .49667 L
.92208 .49803 L
.92308 .49924 L
.92408 .50029 L
.92507 .50117 L
.92607 .50187 L
.92707 .50238 L
.92807 .50268 L
.92907 .50278 L
.93007 .50266 L
.93107 .50231 L
.93207 .50173 L
.93307 .50091 L
.93407 .49985 L
.93506 .49855 L
.93606 .49699 L
.93706 .49518 L
.93806 .49312 L
.93906 .49081 L
.94006 .48826 L
.94106 .48545 L
.94206 .4824 L
.94306 .47912 L
.94406 .4756 L
.94505 .47186 L
.94605 .4679 L
.94705 .46374 L
Mistroke
.94805 .45938 L
.94905 .33375 L
.95005 .33357 L
.95105 .33336 L
.95205 .33312 L
.95305 .33285 L
.95405 .33255 L
.95504 .33222 L
.95604 .33186 L
.95704 .33148 L
.95804 .33106 L
.95904 .33062 L
.96004 .33015 L
.96104 .32966 L
.96204 .32914 L
.96304 .32859 L
.96404 .32802 L
.96503 .32743 L
.96603 .32681 L
.96703 .32617 L
.96803 .32551 L
.96903 .32482 L
.97003 .32411 L
.97103 .32339 L
.97203 .32264 L
.97303 .32187 L
.97403 .32108 L
.97502 .32027 L
.97602 .31944 L
.97702 .31859 L
.97802 .31773 L
.97902 .31684 L
.98002 .31595 L
.98102 .31503 L
.98202 .3141 L
.98302 .31315 L
.98402 .31219 L
.98501 .31122 L
.98601 .31023 L
.98701 .30923 L
.98801 .30821 L
.98901 .30718 L
.99001 .30615 L
.99101 .3051 L
.99201 .30404 L
.99301 .30297 L
.99401 .30189 L
.995 .3008 L
.996 .2997 L
.997 .2986 L
Mistroke
.998 .29749 L
.999 .31553 L
Mfstroke
0 g
gsave
.999 .31283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .36581 Mdot
.04995 .10918 Mdot
.0999 .40619 Mdot
.14985 .56503 Mdot
.1998 .28795 Mdot
.24975 .45421 Mdot
.2997 .42228 Mdot
.34965 .51524 Mdot
.3996 .32256 Mdot
.44955 .40409 Mdot
.4995 .54665 Mdot
.54945 .41152 Mdot
.5994 .33935 Mdot
.64935 .32725 Mdot
.6993 .29408 Mdot
.74925 .26164 Mdot
.7992 .47289 Mdot
.84915 .51095 Mdot
.8991 .4591 Mdot
.94905 .32894 Mdot
.999 .31283 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0.309017 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -18 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -18 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-20)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-10)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(10)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(20)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(30)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(y) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .31258 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .30912 m
.001 .30561 L
.002 .30591 L
.003 .30267 L
.004 .30158 L
.005 .29626 L
.00599 .2969 L
.00699 .29339 L
.00799 .29454 L
.00899 .29302 L
.00999 .29567 L
.01099 .29791 L
.01199 .29806 L
.01299 .30011 L
.01399 .29313 L
.01499 .29656 L
.01598 .29248 L
.01698 .29653 L
.01798 .29532 L
.01898 .29593 L
.01998 .29595 L
.02098 .29386 L
.02198 .29068 L
.02298 .28392 L
.02398 .28216 L
.02498 .28162 L
.02597 .28128 L
.02697 .28323 L
.02797 .27758 L
.02897 .2664 L
.02997 .25899 L
.03097 .25012 L
.03197 .2348 L
.03297 .21903 L
.03397 .20744 L
.03497 .20022 L
.03596 .19022 L
.03696 .17868 L
.03796 .16004 L
.03896 .15243 L
.03996 .14215 L
.04096 .12109 L
.04196 .102 L
.04296 .07095 L
.04396 .05168 L
.04496 .03154 L
.04595 .01335 L
.04695 .00131 L
s
.04695 .00131 m
.04749 0 L
s
.04815 0 m
.04895 .00458 L
.04995 .02536 L
.05095 .05433 L
.05195 .09007 L
.05295 .13743 L
.05395 .18852 L
.05495 .25501 L
.05594 .31113 L
.05694 .37114 L
.05794 .42077 L
.05894 .45327 L
.05994 .47581 L
.06094 .49665 L
.06194 .50544 L
.06294 .51248 L
.06394 .51469 L
.06494 .50324 L
.06593 .50212 L
.06693 .50662 L
.06793 .50527 L
.06893 .4993 L
.06993 .48571 L
.07093 .48092 L
.07193 .47041 L
.07293 .45885 L
.07393 .44996 L
.07493 .43096 L
.07592 .41552 L
.07692 .39576 L
.07792 .38488 L
.07892 .37647 L
.07992 .35961 L
.08092 .35248 L
.08192 .33702 L
.08292 .33435 L
.08392 .32794 L
.08492 .32547 L
.08591 .31973 L
.08691 .32563 L
.08791 .32787 L
.08891 .32603 L
.08991 .31943 L
.09091 .3172 L
.09191 .31145 L
.09291 .30804 L
.09391 .30535 L
.09491 .30482 L
.0959 .31059 L
.0969 .31185 L
Mistroke
.0979 .31869 L
.0989 .32383 L
.0999 .3309 L
.1009 .33786 L
.1019 .34314 L
.1029 .34787 L
.1039 .34616 L
.1049 .35224 L
.10589 .35233 L
.10689 .35261 L
.10789 .35627 L
.10889 .35954 L
.10989 .36286 L
.11089 .36102 L
.11189 .36335 L
.11289 .36579 L
.11389 .37215 L
.11489 .37564 L
.11588 .37228 L
.11688 .37875 L
.11788 .38247 L
.11888 .38596 L
.11988 .38878 L
.12088 .39649 L
.12188 .39905 L
.12288 .40371 L
.12388 .41522 L
.12488 .41492 L
.12587 .41736 L
.12687 .4276 L
.12787 .43235 L
.12887 .43501 L
.12987 .44441 L
.13087 .45231 L
.13187 .45562 L
.13287 .46105 L
.13387 .4658 L
.13487 .47322 L
.13586 .4832 L
.13686 .49021 L
.13786 .49397 L
.13886 .49665 L
.13986 .49399 L
.14086 .49617 L
.14186 .49262 L
.14286 .48535 L
.14386 .47297 L
.14486 .46338 L
.14585 .4485 L
.14685 .4282 L
Mistroke
.14785 .40571 L
.14885 .38269 L
.14985 .36018 L
.15085 .33358 L
.15185 .32402 L
.15285 .30918 L
.15385 .2972 L
.15485 .28408 L
.15584 .27739 L
.15684 .27279 L
.15784 .27081 L
.15884 .26999 L
.15984 .27406 L
.16084 .27349 L
.16184 .27076 L
.16284 .27331 L
.16384 .27874 L
.16484 .28634 L
.16583 .28552 L
.16683 .28282 L
.16783 .27456 L
.16883 .27345 L
.16983 .27358 L
.17083 .27526 L
.17183 .26834 L
.17283 .26232 L
.17383 .26533 L
.17483 .27089 L
.17582 .26772 L
.17682 .26119 L
.17782 .25435 L
.17882 .25699 L
.17982 .2535 L
.18082 .25113 L
.18182 .25388 L
.18282 .25143 L
.18382 .25293 L
.18482 .24859 L
.18581 .25017 L
.18681 .24596 L
.18781 .24337 L
.18881 .2397 L
.18981 .23162 L
.19081 .23099 L
.19181 .22754 L
.19281 .2226 L
.19381 .20713 L
.19481 .20001 L
.1958 .20112 L
.1968 .19085 L
Mistroke
.1978 .18092 L
.1988 .17147 L
.1998 .16154 L
.2008 .15336 L
.2018 .14337 L
.2028 .13333 L
.2038 .12389 L
.2048 .10898 L
.20579 .09394 L
.20679 .08497 L
.20779 .08699 L
.20879 .08363 L
.20979 .09292 L
.21079 .09879 L
.21179 .1158 L
.21279 .13243 L
.21379 .1533 L
.21479 .16677 L
.21578 .18697 L
.21678 .20717 L
.21778 .23255 L
.21878 .25229 L
.21978 .28292 L
.22078 .31028 L
.22178 .32588 L
.22278 .34285 L
.22378 .36042 L
.22478 .37259 L
.22577 .37635 L
.22677 .38045 L
.22777 .38658 L
.22877 .39214 L
.22977 .39234 L
.23077 .38452 L
.23177 .38009 L
.23277 .37716 L
.23377 .38712 L
.23477 .39237 L
.23576 .38854 L
.23676 .3878 L
.23776 .386 L
.23876 .38649 L
.23976 .38454 L
.24076 .38488 L
.24176 .38566 L
.24276 .38622 L
.24376 .38417 L
.24476 .38154 L
.24575 .38511 L
.24675 .38959 L
Mistroke
.24775 .39503 L
.24875 .39268 L
.24975 .39134 L
.25075 .38835 L
.25175 .38685 L
.25275 .39228 L
.25375 .39913 L
.25475 .40257 L
.25574 .40981 L
.25674 .41238 L
.25774 .41307 L
.25874 .41795 L
.25974 .42456 L
.26074 .42843 L
.26174 .43892 L
.26274 .43732 L
.26374 .43058 L
.26474 .43924 L
.26573 .4342 L
.26673 .43779 L
.26773 .43254 L
.26873 .42852 L
.26973 .43115 L
.27073 .42794 L
.27173 .42557 L
.27273 .41329 L
.27373 .40436 L
.27473 .39846 L
.27572 .39451 L
.27672 .38696 L
.27772 .38246 L
.27872 .37764 L
.27972 .3752 L
.28072 .3752 L
.28172 .37793 L
.28272 .37443 L
.28372 .36534 L
.28472 .37036 L
.28571 .36871 L
.28671 .36182 L
.28771 .3588 L
.28871 .34895 L
.28971 .34382 L
.29071 .34303 L
.29171 .34091 L
.29271 .33771 L
.29371 .34442 L
.29471 .3423 L
.2957 .34449 L
.2967 .34863 L
Mistroke
.2977 .34518 L
.2987 .35153 L
.2997 .34828 L
.3007 .34306 L
.3017 .34631 L
.3027 .34786 L
.3037 .34706 L
.3047 .35598 L
.30569 .35927 L
.30669 .35755 L
.30769 .35822 L
.30869 .3651 L
.30969 .36331 L
.31069 .36361 L
.31169 .3661 L
.31269 .36329 L
.31369 .36624 L
.31469 .3776 L
.31568 .3849 L
.31668 .38143 L
.31768 .38356 L
.31868 .38884 L
.31968 .3863 L
.32068 .38259 L
.32168 .39302 L
.32268 .39919 L
.32368 .39982 L
.32468 .39782 L
.32567 .40433 L
.32667 .41721 L
.32767 .42171 L
.32867 .43166 L
.32967 .43818 L
.33067 .4466 L
.33167 .44747 L
.33267 .45418 L
.33367 .46075 L
.33467 .4597 L
.33566 .45965 L
.33666 .46897 L
.33766 .4704 L
.33866 .46622 L
.33966 .46712 L
.34066 .45958 L
.34166 .44931 L
.34266 .44235 L
.34366 .43533 L
.34466 .42368 L
.34565 .42054 L
.34665 .41204 L
Mistroke
.34765 .40884 L
.34865 .39376 L
.34965 .3843 L
.35065 .37289 L
.35165 .36708 L
.35265 .35216 L
.35365 .34971 L
.35465 .34174 L
.35564 .3393 L
.35664 .33217 L
.35764 .32787 L
.35864 .32466 L
.35964 .32138 L
.36064 .31163 L
.36164 .31626 L
.36264 .30946 L
.36364 .31161 L
.36464 .30667 L
.36563 .29593 L
.36663 .29001 L
.36763 .29509 L
.36863 .29533 L
.36963 .29424 L
.37063 .29673 L
.37163 .30514 L
.37263 .30573 L
.37363 .3037 L
.37463 .29794 L
.37562 .29868 L
.37662 .29839 L
.37762 .30072 L
.37862 .29578 L
.37962 .29431 L
.38062 .29364 L
.38162 .29119 L
.38262 .28683 L
.38362 .28306 L
.38462 .28144 L
.38561 .28189 L
.38661 .28203 L
.38761 .27704 L
.38861 .27844 L
.38961 .28216 L
.39061 .27858 L
.39161 .27565 L
.39261 .27359 L
.39361 .26949 L
.39461 .26868 L
.3956 .27028 L
.3966 .27154 L
Mistroke
.3976 .27335 L
.3986 .26566 L
.3996 .26162 L
.4006 .25373 L
.4016 .2427 L
.4026 .23182 L
.4036 .22201 L
.4046 .22312 L
.40559 .21655 L
.40659 .20797 L
.40759 .20074 L
.40859 .19442 L
.40959 .18565 L
.41059 .1795 L
.41159 .17427 L
.41259 .16925 L
.41359 .16816 L
.41459 .1499 L
.41558 .14019 L
.41658 .13052 L
.41758 .12104 L
.41858 .11287 L
.41958 .10485 L
.42058 .10659 L
.42158 .09913 L
.42258 .09068 L
.42358 .09125 L
.42458 .09213 L
.42557 .0953 L
.42657 .11164 L
.42757 .12046 L
.42857 .12953 L
.42957 .15192 L
.43057 .16986 L
.43157 .19455 L
.43257 .22166 L
.43357 .24421 L
.43457 .25571 L
.43556 .28157 L
.43656 .30658 L
.43756 .32353 L
.43856 .34211 L
.43956 .35162 L
.44056 .36636 L
.44156 .37154 L
.44256 .37869 L
.44356 .38496 L
.44456 .38904 L
.44555 .39212 L
.44655 .38911 L
Mistroke
.44755 .39075 L
.44855 .39053 L
.44955 .38327 L
.45055 .37459 L
.45155 .36353 L
.45255 .3601 L
.45355 .36136 L
.45455 .35741 L
.45554 .35678 L
.45654 .35761 L
.45754 .35604 L
.45854 .3619 L
.45954 .36032 L
.46054 .36272 L
.46154 .36266 L
.46254 .3692 L
.46354 .36669 L
.46454 .36794 L
.46553 .36875 L
.46653 .37362 L
.46753 .37109 L
.46853 .37299 L
.46953 .37472 L
.47053 .37643 L
.47153 .38629 L
.47253 .38636 L
.47353 .39305 L
.47453 .3901 L
.47552 .39606 L
.47652 .3981 L
.47752 .40553 L
.47852 .41352 L
.47952 .41916 L
.48052 .42152 L
.48152 .43224 L
.48252 .43464 L
.48352 .44709 L
.48452 .44897 L
.48551 .45168 L
.48651 .45621 L
.48751 .46014 L
.48851 .47106 L
.48951 .46609 L
.49051 .46788 L
.49151 .47022 L
.49251 .46903 L
.49351 .46279 L
.49451 .46053 L
.4955 .45428 L
.4965 .44379 L
Mistroke
.4975 .42725 L
.4985 .40644 L
.4995 .39072 L
.5005 .37715 L
.5015 .36053 L
.5025 .35545 L
.5035 .34124 L
.5045 .32589 L
.50549 .3213 L
.50649 .30832 L
.50749 .29962 L
.50849 .29394 L
.50949 .29952 L
.51049 .29854 L
.51149 .29457 L
.51249 .30558 L
.51349 .30102 L
.51449 .30364 L
.51548 .30767 L
.51648 .31138 L
.51748 .31298 L
.51848 .319 L
.51948 .31473 L
.52048 .32336 L
.52148 .33099 L
.52248 .33251 L
.52348 .3336 L
.52448 .33941 L
.52547 .33435 L
.52647 .33286 L
.52747 .33648 L
.52847 .33632 L
.52947 .33781 L
.53047 .33845 L
.53147 .3449 L
.53247 .34586 L
.53347 .34638 L
.53447 .34216 L
.53546 .34019 L
.53646 .3396 L
.53746 .34456 L
.53846 .35522 L
.53946 .35905 L
.54046 .36034 L
.54146 .35708 L
.54246 .36044 L
.54346 .36749 L
.54446 .371 L
.54545 .37539 L
.54645 .38469 L
Mistroke
.54745 .38684 L
.54845 .39258 L
.54945 .39533 L
.55045 .39963 L
.55145 .40512 L
.55245 .4125 L
.55345 .41546 L
.55445 .42192 L
.55544 .42062 L
.55644 .43257 L
.55744 .44085 L
.55844 .44764 L
.55944 .45416 L
.56044 .46924 L
.56144 .47836 L
.56244 .48486 L
.56344 .49132 L
.56444 .50095 L
.56543 .51275 L
.56643 .51819 L
.56743 .52033 L
.56843 .53103 L
.56943 .52694 L
.57043 .52213 L
.57143 .51446 L
.57243 .49861 L
.57343 .49267 L
.57443 .48112 L
.57542 .4621 L
.57642 .43834 L
.57742 .41686 L
.57842 .3943 L
.57942 .36672 L
.58042 .34686 L
.58142 .32346 L
.58242 .30483 L
.58342 .28281 L
.58442 .26783 L
.58541 .25509 L
.58641 .24755 L
.58741 .2463 L
.58841 .2455 L
.58941 .24044 L
.59041 .23867 L
.59141 .24357 L
.59241 .24296 L
.59341 .24723 L
.59441 .2475 L
.5954 .24186 L
.5964 .24113 L
Mistroke
.5974 .2438 L
.5984 .24395 L
.5994 .24297 L
.6004 .23809 L
.6014 .2322 L
.6024 .22798 L
.6034 .21954 L
.6044 .21963 L
.60539 .21251 L
.60639 .21194 L
.60739 .20885 L
.60839 .20547 L
.60939 .20465 L
.61039 .20911 L
.61139 .20502 L
.61239 .20133 L
.61339 .19976 L
.61439 .20311 L
.61538 .2057 L
.61638 .20405 L
.61738 .20151 L
.61838 .207 L
.61938 .20426 L
.62038 .20839 L
.62138 .20922 L
.62238 .2115 L
.62338 .22193 L
.62438 .22485 L
.62537 .2376 L
.62637 .2369 L
.62737 .24022 L
.62837 .2391 L
.62937 .23947 L
.63037 .24504 L
.63137 .2555 L
.63237 .26525 L
.63337 .2629 L
.63437 .2663 L
.63536 .27677 L
.63636 .27767 L
.63736 .27177 L
.63836 .27044 L
.63936 .26934 L
.64036 .26976 L
.64136 .26912 L
.64236 .27068 L
.64336 .27805 L
.64436 .28104 L
.64535 .27403 L
.64635 .27631 L
Mistroke
.64735 .27821 L
.64835 .27831 L
.64935 .27074 L
.65035 .27076 L
.65135 .26836 L
.65235 .27078 L
.65335 .26836 L
.65435 .26581 L
.65534 .26739 L
.65634 .26613 L
.65734 .25488 L
.65834 .2534 L
.65934 .24643 L
.66034 .23815 L
.66134 .23079 L
.66234 .21852 L
.66334 .20907 L
.66434 .20358 L
.66533 .19931 L
.66633 .19786 L
.66733 .19682 L
.66833 .19457 L
.66933 .18601 L
.67033 .17994 L
.67133 .17867 L
.67233 .17805 L
.67333 .17607 L
.67433 .17053 L
.67532 .1625 L
.67632 .15604 L
.67732 .15267 L
.67832 .15463 L
.67932 .15545 L
.68032 .15701 L
.68132 .15772 L
.68232 .162 L
.68332 .16788 L
.68432 .17411 L
.68531 .17885 L
.68631 .18443 L
.68731 .19462 L
.68831 .2108 L
.68931 .22168 L
.69031 .23248 L
.69131 .24627 L
.69231 .25148 L
.69331 .25708 L
.69431 .26349 L
.6953 .27666 L
.6963 .28562 L
Mistroke
.6973 .29142 L
.6983 .29282 L
.6993 .30271 L
.7003 .30543 L
.7013 .31219 L
.7023 .31793 L
.7033 .32126 L
.7043 .32217 L
.70529 .31429 L
.70629 .31245 L
.70729 .30886 L
.70829 .30646 L
.70929 .30356 L
.71029 .30468 L
.71129 .30481 L
.71229 .30228 L
.71329 .30109 L
.71429 .29705 L
.71528 .30154 L
.71628 .30008 L
.71728 .30111 L
.71828 .29846 L
.71928 .30356 L
.72028 .30272 L
.72128 .2973 L
.72228 .29608 L
.72328 .29109 L
.72428 .28413 L
.72527 .28623 L
.72627 .28655 L
.72727 .28958 L
.72827 .28909 L
.72927 .29014 L
.73027 .28707 L
.73127 .29345 L
.73227 .28688 L
.73327 .27863 L
.73427 .27331 L
.73526 .26459 L
.73626 .26183 L
.73726 .25114 L
.73826 .25173 L
.73926 .24758 L
.74026 .23406 L
.74126 .22523 L
.74226 .21446 L
.74326 .19867 L
.74426 .18998 L
.74525 .18406 L
.74625 .18046 L
Mistroke
.74725 .16655 L
.74825 .14996 L
.74925 .13577 L
.75025 .12936 L
.75125 .11124 L
.75225 .10508 L
.75325 .09064 L
.75425 .08163 L
.75524 .07457 L
.75624 .07548 L
.75724 .07343 L
.75824 .07326 L
.75924 .0819 L
.76024 .08904 L
.76124 .10515 L
.76224 .1213 L
.76324 .13827 L
.76424 .16141 L
.76523 .18733 L
.76623 .21674 L
.76723 .24893 L
.76823 .27182 L
.76923 .29059 L
.77023 .31128 L
.77123 .33002 L
.77223 .34172 L
.77323 .35912 L
.77423 .36985 L
.77522 .3799 L
.77622 .38761 L
.77722 .39315 L
.77822 .39188 L
.77922 .396 L
.78022 .39588 L
.78122 .3883 L
.78222 .39425 L
.78322 .39719 L
.78422 .39613 L
.78521 .39761 L
.78621 .4016 L
.78721 .40818 L
.78821 .40686 L
.78921 .40699 L
.79021 .40304 L
.79121 .41089 L
.79221 .41582 L
.79321 .41611 L
.79421 .4127 L
.7952 .41468 L
.7962 .41345 L
Mistroke
.7972 .41555 L
.7982 .41671 L
.7992 .41708 L
.8002 .41441 L
.8012 .41252 L
.8022 .41297 L
.8032 .40858 L
.8042 .40489 L
.80519 .39646 L
.80619 .39094 L
.80719 .38512 L
.80819 .37944 L
.80919 .38398 L
.81019 .3832 L
.81119 .38358 L
.81219 .38299 L
.81319 .37955 L
.81419 .37566 L
.81518 .37224 L
.81618 .3765 L
.81718 .37087 L
.81818 .37153 L
.81918 .36893 L
.82018 .37028 L
.82118 .3693 L
.82218 .36389 L
.82318 .36754 L
.82418 .36505 L
.82517 .35709 L
.82617 .36046 L
.82717 .36316 L
.82817 .37274 L
.82917 .37423 L
.83017 .38522 L
.83117 .39013 L
.83217 .39522 L
.83317 .40416 L
.83417 .41113 L
.83516 .41299 L
.83616 .42131 L
.83716 .42456 L
.83816 .42922 L
.83916 .43143 L
.84016 .44338 L
.84116 .44603 L
.84216 .45194 L
.84316 .44747 L
.84416 .44084 L
.84515 .43974 L
.84615 .44171 L
Mistroke
.84715 .4411 L
.84815 .43322 L
.84915 .42656 L
.85015 .41847 L
.85115 .40956 L
.85215 .39982 L
.85315 .39089 L
.85415 .39053 L
.85514 .38595 L
.85614 .37771 L
.85714 .37967 L
.85814 .37181 L
.85914 .36743 L
.86014 .371 L
.86114 .3707 L
.86214 .36588 L
.86314 .36463 L
.86414 .35575 L
.86513 .35582 L
.86613 .3583 L
.86713 .34881 L
.86813 .34304 L
.86913 .33926 L
.87013 .33286 L
.87113 .3371 L
.87213 .33638 L
.87313 .33608 L
.87413 .33659 L
.87512 .33718 L
.87612 .33673 L
.87712 .34228 L
.87812 .34456 L
.87912 .33905 L
.88012 .34705 L
.88112 .34531 L
.88212 .33871 L
.88312 .33951 L
.88412 .342 L
.88511 .34782 L
.88611 .34571 L
.88711 .35244 L
.88811 .35552 L
.88911 .36113 L
.89011 .3677 L
.89111 .3673 L
.89211 .3772 L
.89311 .38512 L
.89411 .389 L
.8951 .3962 L
.8961 .40262 L
Mistroke
.8971 .40932 L
.8981 .42181 L
.8991 .42953 L
.9001 .44251 L
.9011 .44839 L
.9021 .4602 L
.9031 .47015 L
.9041 .48055 L
.90509 .4857 L
.90609 .49103 L
.90709 .495 L
.90809 .50003 L
.90909 .49529 L
.91009 .50183 L
.91109 .5045 L
.91209 .50921 L
.91309 .49956 L
.91409 .49219 L
.91508 .48503 L
.91608 .46549 L
.91708 .45117 L
.91808 .42912 L
.91908 .4002 L
.92008 .38236 L
.92108 .36219 L
.92208 .34742 L
.92308 .33201 L
.92408 .31389 L
.92507 .30264 L
.92607 .29186 L
.92707 .28477 L
.92807 .27804 L
.92907 .2827 L
.93007 .28304 L
.93107 .27732 L
.93207 .27532 L
.93307 .2783 L
.93407 .27958 L
.93506 .2802 L
.93606 .27493 L
.93706 .26833 L
.93806 .27116 L
.93906 .28012 L
.94006 .27926 L
.94106 .28475 L
.94206 .28395 L
.94306 .28127 L
.94406 .27464 L
.94505 .27625 L
.94605 .28184 L
Mistroke
.94705 .28037 L
.94805 .27454 L
.94905 .26743 L
.95005 .26603 L
.95105 .26939 L
.95205 .26468 L
.95305 .25363 L
.95405 .24545 L
.95504 .24103 L
.95604 .23308 L
.95704 .23719 L
.95804 .23184 L
.95904 .22668 L
.96004 .21811 L
.96104 .21663 L
.96204 .20612 L
.96304 .20606 L
.96404 .20477 L
.96503 .20042 L
.96603 .1971 L
.96703 .18602 L
.96803 .17925 L
.96903 .16882 L
.97003 .15877 L
.97103 .15093 L
.97203 .13861 L
.97303 .13134 L
.97403 .12749 L
.97502 .12607 L
.97602 .11867 L
.97702 .11892 L
.97802 .11899 L
.97902 .12618 L
.98002 .13294 L
.98102 .14991 L
.98202 .1614 L
.98302 .17046 L
.98402 .18714 L
.98501 .19867 L
.98601 .20902 L
.98701 .22568 L
.98801 .24131 L
.98901 .25086 L
.99001 .27062 L
.99101 .28291 L
.99201 .28437 L
.99301 .29513 L
.99401 .3019 L
.995 .3066 L
.996 .31166 L
Mistroke
.997 .3124 L
.998 .31184 L
.999 .31258 L
Mfstroke
0 .98 .604 r
gsave
.999 .30434 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
0 .30222 m
.001 .29698 L
.002 .29262 L
.003 .28831 L
.004 .28378 L
.005 .2789 L
.00599 .27359 L
.00699 .26777 L
.00799 .26135 L
.00899 .25426 L
.00999 .2464 L
.01099 .23766 L
.01199 .22793 L
.01299 .21706 L
.01399 .20491 L
.01499 .19132 L
.01598 .17608 L
.01698 .15901 L
.01798 .13985 L
.01898 .11834 L
.01998 .09419 L
.02098 .06705 L
.02198 .03656 L
.02298 .0023 L
s
.02298 .0023 m
.02304 0 L
s
.04994 0 m
.04995 .02198 L
.05095 .04157 L
.05195 .07221 L
.05295 .11204 L
.05395 .15857 L
.05495 .20879 L
.05594 .25928 L
.05694 .30636 L
.05794 .34631 L
.05894 .37554 L
.05994 .39088 L
.06094 .38978 L
.06194 .37052 L
.06294 .3324 L
.06394 .27586 L
.06494 .20251 L
.06593 .11514 L
.06693 .01766 L
s
.06693 .01766 m
.06711 0 L
s
.07822 0 m
.07892 .11508 L
.07992 .28756 L
.08092 .4582 L
.08192 .61515 L
s
.08192 .61515 m
.08194 .61803 L
s
.08835 .61803 m
.08891 .51459 L
.08991 .27641 L
s
.08991 .27641 m
.09088 0 L
s
.09974 0 m
.0999 .32614 L
.1009 .3241 L
.1019 .32332 L
.1029 .32311 L
.1039 .32327 L
.1049 .32368 L
.10589 .32432 L
.10689 .32513 L
.10789 .32612 L
.10889 .32727 L
.10989 .32858 L
.11089 .33004 L
.11189 .33167 L
.11289 .33346 L
.11389 .33542 L
.11489 .33755 L
.11588 .33986 L
.11688 .34236 L
.11788 .34505 L
.11888 .34795 L
.11988 .35105 L
.12088 .35437 L
.12188 .35793 L
.12288 .36172 L
.12388 .36576 L
.12488 .37007 L
.12587 .37465 L
.12687 .37953 L
.12787 .38471 L
.12887 .39021 L
.12987 .39604 L
.13087 .40223 L
.13187 .40879 L
.13287 .41574 L
.13387 .4231 L
.13487 .4309 L
.13586 .43915 L
.13686 .44788 L
.13786 .45712 L
.13886 .4669 L
.13986 .47723 L
.14086 .48815 L
.14186 .4997 L
.14286 .51191 L
.14386 .52481 L
.14486 .53845 L
.14585 .55285 L
.14685 .56807 L
.14785 .58415 L
Mistroke
.14885 .60113 L
.14985 .36225 L
.15085 .34825 L
.15185 .33338 L
.15285 .31741 L
.15385 .3005 L
.15485 .28295 L
.15584 .26511 L
.15684 .24739 L
.15784 .23018 L
.15884 .21391 L
.15984 .199 L
.16084 .18583 L
.16184 .17478 L
.16284 .16614 L
.16384 .1602 L
.16484 .15716 L
.16583 .15715 L
.16683 .16025 L
.16783 .16643 L
.16883 .17561 L
.16983 .18762 L
.17083 .2022 L
.17183 .21902 L
.17283 .23769 L
.17383 .25776 L
.17483 .27871 L
.17582 .29998 L
.17682 .32098 L
.17782 .34112 L
.17882 .35977 L
.17982 .37635 L
.18082 .39029 L
.18182 .40105 L
.18282 .40818 L
.18382 .41128 L
.18482 .41006 L
.18581 .40432 L
.18681 .39399 L
.18781 .37911 L
.18881 .35986 L
.18981 .33653 L
.19081 .30955 L
.19181 .27947 L
.19281 .24694 L
.19381 .21271 L
.19481 .17758 L
.1958 .14243 L
.1968 .10815 L
.1978 .07564 L
Mistroke
.1988 .04579 L
.1998 .15533 L
.2008 .14306 L
.2018 .13186 L
.2028 .12118 L
.2038 .11089 L
.2048 .10101 L
.20579 .09159 L
.20679 .08272 L
.20779 .07448 L
.20879 .06698 L
.20979 .06033 L
.21079 .05465 L
.21179 .05005 L
.21279 .04667 L
.21379 .04461 L
.21479 .044 L
.21578 .04496 L
.21678 .04761 L
.21778 .05207 L
.21878 .05842 L
.21978 .06679 L
.22078 .07725 L
.22178 .08989 L
.22278 .10477 L
.22378 .12195 L
.22478 .14147 L
.22577 .16333 L
.22677 .18754 L
.22777 .21408 L
.22877 .2429 L
.22977 .27395 L
.23077 .30714 L
.23177 .34238 L
.23277 .37953 L
.23377 .41846 L
.23477 .45901 L
.23576 .50102 L
.23676 .54428 L
.23776 .58858 L
Mfstroke
.23776 .58858 m
.23841 .61803 L
s
.24941 .61803 m
.24975 .39049 L
.25075 .39094 L
.25175 .39207 L
.25275 .39321 L
.25375 .39415 L
.25475 .39479 L
.25574 .39507 L
.25674 .39494 L
.25774 .39437 L
.25874 .39334 L
.25974 .39183 L
.26074 .38982 L
.26174 .38728 L
.26274 .38422 L
.26374 .3806 L
.26474 .37642 L
.26573 .37167 L
.26673 .36632 L
.26773 .36039 L
.26873 .35384 L
.26973 .34668 L
.27073 .33891 L
.27173 .3305 L
.27273 .32148 L
.27373 .31182 L
.27473 .30154 L
.27572 .29063 L
.27672 .27911 L
.27772 .26699 L
.27872 .25427 L
.27972 .24097 L
.28072 .22711 L
.28172 .21271 L
.28272 .19781 L
.28372 .18243 L
.28472 .16662 L
.28571 .1504 L
.28671 .13383 L
.28771 .11697 L
.28871 .09985 L
.28971 .08256 L
.29071 .06515 L
.29171 .0477 L
.29271 .03028 L
.29371 .01297 L
s
.29371 .01297 m
.29446 0 L
s
.29887 0 m
.2997 .34412 L
.3007 .34262 L
.3017 .34211 L
.3027 .34195 L
.3037 .34192 L
.3047 .34193 L
.30569 .34193 L
.30669 .34188 L
.30769 .34176 L
.30869 .34157 L
.30969 .34128 L
.31069 .34089 L
.31169 .34041 L
.31269 .33981 L
.31369 .3391 L
.31469 .33827 L
.31568 .33732 L
.31668 .33626 L
.31768 .33507 L
.31868 .33375 L
.31968 .3323 L
.32068 .33072 L
.32168 .32901 L
.32268 .32716 L
.32368 .32517 L
.32468 .32304 L
.32567 .32077 L
.32667 .31834 L
.32767 .31577 L
.32867 .31305 L
.32967 .31018 L
.33067 .30714 L
.33167 .30395 L
.33267 .3006 L
.33367 .29708 L
.33467 .2934 L
.33566 .28955 L
.33666 .28553 L
.33766 .28134 L
.33866 .27698 L
.33966 .27244 L
.34066 .26772 L
.34166 .26283 L
.34266 .25776 L
.34366 .25251 L
.34466 .24708 L
.34565 .24146 L
.34665 .23567 L
.34765 .22969 L
Mistroke
.34865 .22353 L
.34965 .37731 L
.35065 .36599 L
.35165 .35492 L
.35265 .34362 L
.35365 .33205 L
.35465 .32028 L
.35564 .30842 L
.35664 .2966 L
.35764 .28498 L
.35864 .27372 L
.35964 .26297 L
.36064 .25289 L
.36164 .24364 L
.36264 .23537 L
.36364 .2282 L
.36464 .22225 L
.36563 .21764 L
.36663 .21445 L
.36763 .21273 L
.36863 .21255 L
.36963 .2139 L
.37063 .2168 L
.37163 .22121 L
.37263 .22707 L
.37363 .2343 L
.37463 .2428 L
.37562 .25245 L
.37662 .26308 L
.37762 .27453 L
.37862 .28662 L
.37962 .29914 L
.38062 .31187 L
.38162 .32461 L
.38262 .33711 L
.38362 .34915 L
.38462 .36052 L
.38561 .37098 L
.38661 .38033 L
.38761 .38839 L
.38861 .39496 L
.38961 .39991 L
.39061 .40309 L
.39161 .40441 L
.39261 .40378 L
.39361 .40117 L
.39461 .39656 L
.3956 .38997 L
.3966 .38145 L
.3976 .37108 L
Mistroke
.3986 .35898 L
.3996 .25448 L
.4006 .24368 L
.4016 .23392 L
.4026 .22443 L
.4036 .21497 L
.4046 .20538 L
.40559 .19558 L
.40659 .18553 L
.40759 .17516 L
.40859 .16446 L
.40959 .15338 L
.41059 .1419 L
.41159 .13 L
.41259 .11763 L
.41359 .10478 L
.41459 .09143 L
.41558 .07753 L
.41658 .06307 L
.41758 .04802 L
.41858 .03235 L
.41958 .01602 L
Mfstroke
.41958 .01602 m
.42052 0 L
s
.44926 0 m
.44955 .37402 L
.45055 .36947 L
.45155 .36603 L
.45255 .36306 L
.45355 .36035 L
.45455 .3578 L
.45554 .35534 L
.45654 .35296 L
.45754 .35061 L
.45854 .34828 L
.45954 .34596 L
.46054 .34363 L
.46154 .34129 L
.46254 .33892 L
.46354 .33653 L
.46454 .3341 L
.46553 .33164 L
.46653 .32914 L
.46753 .32659 L
.46853 .324 L
.46953 .32136 L
.47053 .31867 L
.47153 .31593 L
.47253 .31314 L
.47353 .31029 L
.47453 .30739 L
.47552 .30443 L
.47652 .30142 L
.47752 .29836 L
.47852 .29524 L
.47952 .29207 L
.48052 .28885 L
.48152 .28558 L
.48252 .28226 L
.48352 .27889 L
.48452 .27548 L
.48551 .27202 L
.48651 .26853 L
.48751 .26499 L
.48851 .26143 L
.48951 .25783 L
.49051 .2542 L
.49151 .25054 L
.49251 .24687 L
.49351 .24318 L
.49451 .23947 L
.4955 .23576 L
.4965 .23205 L
.4975 .22833 L
Mistroke
.4985 .22462 L
.4995 .38375 L
.5005 .36806 L
.5015 .35232 L
.5025 .33623 L
.5035 .31995 L
.5045 .30373 L
.50549 .28789 L
.50649 .27276 L
.50749 .25867 L
.50849 .24595 L
.50949 .23488 L
.51049 .22575 L
.51149 .21879 L
.51249 .21418 L
.51349 .21206 L
.51449 .21253 L
.51548 .2156 L
.51648 .22123 L
.51748 .22934 L
.51848 .23976 L
.51948 .25227 L
.52048 .26662 L
.52148 .28247 L
.52248 .29947 L
.52348 .3172 L
.52448 .33526 L
.52547 .35319 L
.52647 .37053 L
.52747 .38683 L
.52847 .40166 L
.52947 .4146 L
.53047 .42526 L
.53147 .43331 L
.53247 .43846 L
.53347 .44048 L
.53447 .43922 L
.53546 .43459 L
.53646 .4266 L
.53746 .41531 L
.53846 .40088 L
.53946 .38354 L
.54046 .36362 L
.54146 .34147 L
.54246 .31755 L
.54346 .29236 L
.54446 .26642 L
.54545 .24032 L
.54645 .21463 L
.54745 .18995 L
Mistroke
.54845 .16687 L
.54945 .38706 L
.55045 .38774 L
.55145 .38976 L
.55245 .39241 L
.55345 .39548 L
.55445 .39888 L
.55544 .40255 L
.55644 .40648 L
.55744 .41066 L
.55844 .4151 L
.55944 .4198 L
.56044 .42476 L
.56144 .43 L
.56244 .43552 L
.56344 .44134 L
.56444 .44747 L
.56543 .45391 L
.56643 .46069 L
.56743 .4678 L
.56843 .47527 L
.56943 .48311 L
.57043 .49132 L
.57143 .49993 L
.57243 .50894 L
.57343 .51837 L
.57443 .52824 L
.57542 .53855 L
.57642 .54933 L
.57742 .56059 L
.57842 .57234 L
.57942 .58461 L
.58042 .5974 L
.58142 .61075 L
Mfstroke
.58142 .61075 m
.58194 .61803 L
s
.59886 .61803 m
.5994 .23323 L
.6004 .22869 L
.6014 .22525 L
.6024 .22227 L
.6034 .21953 L
.6044 .21694 L
.60539 .21446 L
.60639 .21206 L
.60739 .2097 L
.60839 .20739 L
.60939 .20512 L
.61039 .20287 L
.61139 .20066 L
.61239 .19847 L
.61339 .19632 L
.61439 .19419 L
.61538 .19209 L
.61638 .19002 L
.61738 .18799 L
.61838 .18599 L
.61938 .18404 L
.62038 .18212 L
.62138 .18025 L
.62238 .17843 L
.62338 .17666 L
.62438 .17493 L
.62537 .17327 L
.62637 .17166 L
.62737 .17011 L
.62837 .16863 L
.62937 .16721 L
.63037 .16586 L
.63137 .16458 L
.63237 .16337 L
.63337 .16224 L
.63437 .16118 L
.63536 .16021 L
.63636 .15931 L
.63736 .1585 L
.63836 .15778 L
.63936 .15714 L
.64036 .15659 L
.64136 .15613 L
.64236 .15576 L
.64336 .15548 L
.64436 .1553 L
.64535 .15521 L
.64635 .15522 L
.64735 .15532 L
Mistroke
.64835 .15552 L
.64935 .25952 L
.65035 .25359 L
.65135 .24883 L
.65235 .24457 L
.65335 .24061 L
.65435 .23684 L
.65534 .2332 L
.65634 .22966 L
.65734 .22619 L
.65834 .22278 L
.65934 .21942 L
.66034 .2161 L
.66134 .21282 L
.66234 .20957 L
.66334 .20636 L
.66434 .20317 L
.66533 .20002 L
.66633 .19689 L
.66733 .1938 L
.66833 .19074 L
.66933 .18771 L
.67033 .18472 L
.67133 .18177 L
.67233 .17885 L
.67333 .17599 L
.67433 .17316 L
.67532 .17039 L
.67632 .16766 L
.67732 .16499 L
.67832 .16237 L
.67932 .15981 L
.68032 .15731 L
.68132 .15488 L
.68232 .15251 L
.68332 .15021 L
.68432 .14799 L
.68531 .14584 L
.68631 .14377 L
.68731 .14178 L
.68831 .13987 L
.68931 .13805 L
.69031 .13632 L
.69131 .13468 L
.69231 .13313 L
.69331 .13168 L
.69431 .13033 L
.6953 .12908 L
.6963 .12793 L
.6973 .12689 L
Mistroke
.6983 .12595 L
.6993 .29314 L
.7003 .29154 L
.7013 .29099 L
.7023 .29082 L
.7033 .29085 L
.7043 .29095 L
.70529 .29108 L
.70629 .29119 L
.70729 .29126 L
.70829 .29125 L
.70929 .29116 L
.71029 .29098 L
.71129 .29069 L
.71229 .29028 L
.71329 .28975 L
.71429 .28909 L
.71528 .2883 L
.71628 .28738 L
.71728 .28633 L
.71828 .28515 L
.71928 .28384 L
.72028 .2824 L
.72128 .28084 L
.72228 .27916 L
.72328 .27736 L
.72428 .27546 L
.72527 .27346 L
.72627 .27136 L
.72727 .26918 L
.72827 .26692 L
.72927 .26459 L
.73027 .2622 L
.73127 .25977 L
.73227 .25729 L
.73327 .25479 L
.73427 .25227 L
.73526 .24974 L
.73626 .24721 L
.73726 .24469 L
.73826 .2422 L
.73926 .23974 L
.74026 .23732 L
.74126 .23495 L
.74226 .23265 L
.74326 .23041 L
.74426 .22825 L
.74525 .22618 L
.74625 .22419 L
.74725 .22231 L
Mistroke
.74825 .22054 L
.74925 .12755 L
.75025 .11255 L
.75125 .09948 L
.75225 .08778 L
.75325 .07732 L
.75425 .06812 L
.75524 .06021 L
.75624 .05366 L
.75724 .04854 L
.75824 .04493 L
.75924 .0429 L
.76024 .0425 L
.76124 .0438 L
.76224 .04683 L
.76324 .05163 L
.76424 .05821 L
.76523 .06657 L
.76623 .07671 L
.76723 .08857 L
.76823 .10213 L
.76923 .11729 L
.77023 .13398 L
.77123 .15208 L
.77223 .17148 L
.77323 .19204 L
.77423 .21362 L
.77522 .23606 L
.77622 .25921 L
.77722 .28291 L
.77822 .307 L
.77922 .33131 L
.78022 .35566 L
.78122 .3799 L
.78222 .40383 L
.78322 .42727 L
.78422 .45003 L
.78521 .47191 L
.78621 .49271 L
.78721 .51221 L
.78821 .5302 L
.78921 .54647 L
.79021 .5608 L
.79121 .57297 L
.79221 .58276 L
.79321 .58997 L
.79421 .59438 L
.7952 .59579 L
.7962 .59401 L
.7972 .58885 L
Mistroke
.7982 .58014 L
.7992 .4133 L
.8002 .40994 L
.8012 .40723 L
.8022 .40454 L
.8032 .40168 L
.8042 .39857 L
.80519 .39516 L
.80619 .39142 L
.80719 .38734 L
.80819 .38291 L
.80919 .37815 L
.81019 .37304 L
.81119 .36761 L
.81219 .36185 L
.81319 .35579 L
.81419 .34943 L
.81518 .34279 L
.81618 .33589 L
.81718 .32875 L
.81818 .32139 L
.81918 .31384 L
.82018 .30612 L
.82118 .29826 L
.82218 .29029 L
.82318 .28225 L
.82418 .27418 L
.82517 .2661 L
.82617 .25806 L
.82717 .25011 L
.82817 .24227 L
.82917 .2346 L
.83017 .22714 L
.83117 .21992 L
.83217 .213 L
.83317 .2064 L
.83417 .20018 L
.83516 .19436 L
.83616 .189 L
.83716 .18411 L
.83816 .17973 L
.83916 .17589 L
.84016 .17261 L
.84116 .16993 L
.84216 .16785 L
.84316 .16639 L
.84416 .16556 L
.84515 .16538 L
.84615 .16584 L
.84715 .16695 L
Mistroke
.84815 .1687 L
.84915 .41948 L
.85015 .41319 L
.85115 .40678 L
.85215 .39967 L
.85315 .39175 L
.85415 .383 L
.85514 .37344 L
.85614 .36314 L
.85714 .35219 L
.85814 .34068 L
.85914 .32873 L
.86014 .31645 L
.86114 .30398 L
.86214 .29145 L
.86314 .27899 L
.86414 .26676 L
.86513 .2549 L
.86613 .24355 L
.86713 .23286 L
.86813 .22296 L
.86913 .21399 L
.87013 .20608 L
.87113 .19932 L
.87213 .19383 L
.87313 .18969 L
.87413 .18696 L
.87512 .1857 L
.87612 .18593 L
.87712 .18768 L
.87812 .19093 L
.87912 .19566 L
.88012 .2018 L
.88112 .20931 L
.88212 .21807 L
.88312 .22799 L
.88412 .23893 L
.88511 .25076 L
.88611 .26332 L
.88711 .27643 L
.88811 .28992 L
.88911 .30359 L
.89011 .31725 L
.89111 .33071 L
.89211 .34377 L
.89311 .35624 L
.89411 .36793 L
.8951 .37868 L
.8961 .38832 L
.8971 .3967 L
Mistroke
.8981 .4037 L
.8991 .42319 L
.9001 .42845 L
.9011 .43423 L
.9021 .43985 L
.9031 .44507 L
.9041 .4498 L
.90509 .45397 L
.90609 .45754 L
.90709 .46049 L
.90809 .46281 L
.90909 .46448 L
.91009 .46551 L
.91109 .46587 L
.91209 .46557 L
.91309 .46461 L
.91409 .46299 L
.91508 .4607 L
.91608 .45773 L
.91708 .4541 L
.91808 .4498 L
.91908 .44484 L
.92008 .4392 L
.92108 .4329 L
.92208 .42594 L
.92308 .4183 L
.92408 .41001 L
.92507 .40105 L
.92607 .39143 L
.92707 .38114 L
.92807 .3702 L
.92907 .3586 L
.93007 .34635 L
.93107 .33346 L
.93207 .31994 L
.93307 .3058 L
.93407 .29107 L
.93506 .27578 L
.93606 .25996 L
.93706 .24365 L
.93806 .22691 L
.93906 .20978 L
.94006 .19235 L
.94106 .17467 L
.94206 .15682 L
.94306 .13887 L
.94406 .12091 L
.94505 .10303 L
.94605 .08529 L
.94705 .06781 L
Mistroke
.94805 .05065 L
.94905 .25786 L
.95005 .25136 L
.95105 .24599 L
.95205 .24109 L
.95305 .23644 L
.95405 .23193 L
.95504 .22752 L
.95604 .22316 L
.95704 .21884 L
.95804 .21453 L
.95904 .21023 L
.96004 .20594 L
.96104 .20164 L
.96204 .19734 L
.96304 .19304 L
.96404 .18873 L
.96503 .18443 L
.96603 .18013 L
.96703 .17583 L
.96803 .17154 L
.96903 .16725 L
.97003 .16298 L
.97103 .15872 L
.97203 .15448 L
.97303 .15026 L
.97403 .14606 L
.97502 .14189 L
.97602 .13774 L
.97702 .13363 L
.97802 .12955 L
.97902 .1255 L
.98002 .1215 L
.98102 .11753 L
.98202 .1136 L
.98302 .10973 L
.98402 .10589 L
.98501 .10211 L
.98601 .09838 L
.98701 .09471 L
.98801 .09109 L
.98901 .08752 L
.99001 .08402 L
.99101 .08058 L
.99201 .07721 L
.99301 .07389 L
.99401 .07065 L
.995 .06748 L
.996 .06437 L
.997 .06134 L
Mistroke
.998 .05838 L
.999 .30434 L
Mfstroke
gsave
.999 .31702 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .31492 m
.001 .31778 L
.002 .32003 L
.003 .32238 L
.004 .32501 L
.005 .328 L
.00599 .33136 L
.00699 .33512 L
.00799 .33932 L
.00899 .344 L
.00999 .34921 L
.01099 .35501 L
.01199 .36148 L
.01299 .36869 L
.01399 .37674 L
.01499 .38575 L
.01598 .39582 L
.01698 .40711 L
.01798 .41977 L
.01898 .43396 L
.01998 .44989 L
.02098 .46777 L
.02198 .48786 L
.02298 .51043 L
.02398 .53579 L
.02498 .56429 L
.02597 .59634 L
s
.02597 .59634 m
.02658 .61803 L
s
.0482 .61803 m
.04895 .06753 L
.04995 .03474 L
.05095 .06406 L
.05195 .10415 L
.05295 .15384 L
.05395 .21104 L
.05495 .27282 L
.05594 .33559 L
.05694 .39525 L
.05794 .4475 L
.05894 .4881 L
.05994 .51321 L
.06094 .51971 L
.06194 .5055 L
.06294 .46976 L
.06394 .41314 L
.06494 .33794 L
.06593 .24806 L
.06693 .14891 L
.06793 .04702 L
s
.06793 .04702 m
.06841 0 L
s
.0768 0 m
.07692 .01462 L
.07792 .16435 L
.07892 .33722 L
.07992 .52472 L
s
.07992 .52472 m
.08041 .61803 L
s
.09017 .61803 m
.09091 .40867 L
.09191 .09941 L
s
.09191 .09941 m
.09222 0 L
s
.09966 0 m
.0999 .33888 L
.1009 .34467 L
.1019 .3496 L
.1029 .35433 L
.1039 .3591 L
.1049 .36401 L
.10589 .36912 L
.10689 .37449 L
.10789 .38014 L
.10889 .38611 L
.10989 .3924 L
.11089 .39905 L
.11189 .40608 L
.11289 .41351 L
.11389 .42136 L
.11489 .42965 L
.11588 .43841 L
.11688 .44768 L
.11788 .45746 L
.11888 .4678 L
.11988 .47872 L
.12088 .49025 L
.12188 .50243 L
.12288 .5153 L
.12388 .52889 L
.12488 .54324 L
.12587 .55839 L
.12687 .5744 L
.12787 .59129 L
.12887 .60914 L
s
.12887 .60914 m
.12934 .61803 L
s
.14958 .61803 m
.14985 .3748 L
.15085 .36932 L
.15185 .36135 L
.15285 .35162 L
.15385 .3406 L
.15485 .32866 L
.15584 .3162 L
.15684 .30364 L
.15784 .29138 L
.15884 .27984 L
.15984 .26944 L
.16084 .26058 L
.16184 .25361 L
.16284 .24887 L
.16384 .24664 L
.16484 .24715 L
.16583 .25056 L
.16683 .25694 L
.16783 .2663 L
.16883 .27857 L
.16983 .29356 L
.17083 .31104 L
.17183 .33068 L
.17283 .35207 L
.17383 .37475 L
.17483 .3982 L
.17582 .42185 L
.17682 .44511 L
.17782 .46738 L
.17882 .48808 L
.17982 .50663 L
.18082 .5225 L
.18182 .53522 L
.18282 .54438 L
.18382 .54965 L
.18482 .5508 L
.18581 .54771 L
.18681 .54035 L
.18781 .5288 L
.18881 .51326 L
.18981 .49403 L
.19081 .47152 L
.19181 .44624 L
.19281 .41879 L
.19381 .38984 L
.19481 .36016 L
.1958 .33053 L
.1968 .30179 L
.1978 .27481 L
Mistroke
.1988 .25041 L
.1998 .16805 L
.2008 .1637 L
.2018 .15845 L
.2028 .15304 L
.2038 .14774 L
.2048 .14271 L
.20579 .13809 L
.20679 .13397 L
.20779 .13046 L
.20879 .12767 L
.20979 .12569 L
.21079 .12463 L
.21179 .12459 L
.21279 .12568 L
.21379 .128 L
.21479 .13168 L
.21578 .13682 L
.21678 .14354 L
.21778 .15194 L
.21878 .16215 L
.21978 .17427 L
.22078 .18843 L
.22178 .20472 L
.22278 .22326 L
.22378 .24415 L
.22478 .2675 L
.22577 .29339 L
.22677 .32192 L
.22777 .35317 L
.22877 .3872 L
.22977 .42406 L
.23077 .46378 L
.23177 .50638 L
.23277 .55184 L
.23377 .60011 L
Mfstroke
.23377 .60011 m
.23412 .61803 L
s
.24956 .61803 m
.24975 .40313 L
.25075 .41149 L
.25175 .41836 L
.25275 .42436 L
.25375 .42969 L
.25475 .43442 L
.25574 .43859 L
.25674 .44221 L
.25774 .44529 L
.25874 .44781 L
.25974 .44978 L
.26074 .45117 L
.26174 .45197 L
.26274 .45218 L
.26374 .45178 L
.26474 .45076 L
.26573 .44912 L
.26673 .44683 L
.26773 .44391 L
.26873 .44034 L
.26973 .43614 L
.27073 .43129 L
.27173 .42581 L
.27273 .41971 L
.27373 .41301 L
.27473 .40571 L
.27572 .39784 L
.27672 .38943 L
.27772 .38051 L
.27872 .3711 L
.27972 .36124 L
.28072 .35098 L
.28172 .34036 L
.28272 .32942 L
.28372 .31822 L
.28472 .3068 L
.28571 .29523 L
.28671 .28356 L
.28771 .27185 L
.28871 .26016 L
.28971 .24857 L
.29071 .23713 L
.29171 .22592 L
.29271 .21501 L
.29371 .20446 L
.29471 .19437 L
.2957 .18479 L
.2967 .17581 L
.2977 .1675 L
Mistroke
.2987 .15995 L
.2997 .35679 L
.3007 .36314 L
.3017 .36824 L
.3027 .37274 L
.3037 .37685 L
.3047 .38068 L
.30569 .38428 L
.30669 .3877 L
.30769 .39095 L
.30869 .39405 L
.30969 .39701 L
.31069 .39984 L
.31169 .40254 L
.31269 .40511 L
.31369 .40757 L
.31469 .4099 L
.31568 .41211 L
.31668 .41419 L
.31768 .41614 L
.31868 .41797 L
.31968 .41967 L
.32068 .42123 L
.32168 .42266 L
.32268 .42395 L
.32368 .4251 L
.32468 .4261 L
.32567 .42695 L
.32667 .42766 L
.32767 .42821 L
.32867 .4286 L
.32967 .42884 L
.33067 .42891 L
.33167 .42882 L
.33267 .42856 L
.33367 .42813 L
.33467 .42754 L
.33566 .42677 L
.33666 .42583 L
.33766 .42472 L
.33866 .42343 L
.33966 .42197 L
.34066 .42033 L
.34166 .41852 L
.34266 .41654 L
.34366 .41439 L
.34466 .41207 L
.34565 .40958 L
.34665 .40693 L
.34765 .40412 L
Mistroke
.34865 .40115 L
.34965 .38993 L
.35065 .38669 L
.35165 .38159 L
.35265 .37539 L
.35365 .36839 L
.35465 .36086 L
.35564 .35299 L
.35664 .34499 L
.35764 .33705 L
.35864 .32936 L
.35964 .3221 L
.36064 .31544 L
.36164 .30954 L
.36264 .30456 L
.36364 .30063 L
.36464 .29788 L
.36563 .29639 L
.36663 .29627 L
.36763 .29756 L
.36863 .3003 L
.36963 .3045 L
.37063 .31016 L
.37163 .31724 L
.37263 .32567 L
.37363 .33538 L
.37463 .34626 L
.37562 .35819 L
.37662 .371 L
.37762 .38455 L
.37862 .39865 L
.37962 .41311 L
.38062 .42773 L
.38162 .4423 L
.38262 .45661 L
.38362 .47045 L
.38462 .4836 L
.38561 .49586 L
.38661 .50704 L
.38761 .51695 L
.38861 .52543 L
.38961 .53234 L
.39061 .53753 L
.39161 .54092 L
.39261 .54242 L
.39361 .54199 L
.39461 .53962 L
.3956 .53531 L
.3966 .52911 L
.3976 .52109 L
Mistroke
.3986 .51138 L
.3996 .26719 L
.4006 .26433 L
.4016 .26055 L
.4026 .25651 L
.4036 .2524 L
.4046 .24828 L
.40559 .24415 L
.40659 .24002 L
.40759 .23586 L
.40859 .23165 L
.40959 .22737 L
.41059 .22299 L
.41159 .2185 L
.41259 .21386 L
.41359 .20907 L
.41459 .2041 L
.41558 .19893 L
.41658 .19356 L
.41758 .18795 L
.41858 .18211 L
.41958 .17601 L
.42058 .16963 L
.42158 .16298 L
.42258 .15602 L
.42358 .14875 L
.42458 .14115 L
.42557 .13321 L
.42657 .12492 L
.42757 .11626 L
.42857 .10721 L
.42957 .09777 L
.43057 .08791 L
.43157 .07763 L
.43257 .06689 L
.43357 .0557 L
.43457 .04403 L
.43556 .03187 L
.43656 .01919 L
.43756 .00599 L
Mfstroke
.43756 .00599 m
.438 0 L
s
.44887 0 m
.44955 .38665 L
.45055 .38991 L
.45155 .39194 L
.45255 .39341 L
.45355 .3945 L
.45455 .39532 L
.45554 .39591 L
.45654 .39631 L
.45754 .39653 L
.45854 .39661 L
.45954 .39654 L
.46054 .39634 L
.46154 .39601 L
.46254 .39556 L
.46354 .395 L
.46454 .39432 L
.46553 .39355 L
.46653 .39267 L
.46753 .39169 L
.46853 .39062 L
.46953 .38945 L
.47053 .38821 L
.47153 .38688 L
.47253 .38547 L
.47353 .38398 L
.47453 .38243 L
.47552 .38081 L
.47652 .37913 L
.47752 .37739 L
.47852 .3756 L
.47952 .37376 L
.48052 .37187 L
.48152 .36995 L
.48252 .36799 L
.48352 .366 L
.48452 .36398 L
.48551 .36195 L
.48651 .3599 L
.48751 .35783 L
.48851 .35576 L
.48951 .35369 L
.49051 .35162 L
.49151 .34956 L
.49251 .34751 L
.49351 .34548 L
.49451 .34347 L
.4955 .34148 L
.4965 .33952 L
.4975 .3376 L
Mistroke
.4985 .33572 L
.4995 .39635 L
.5005 .38887 L
.5015 .37932 L
.5025 .36858 L
.5035 .35716 L
.5045 .34549 L
.50549 .33395 L
.50649 .32293 L
.50749 .31278 L
.50849 .30386 L
.50949 .29646 L
.51049 .29089 L
.51149 .28737 L
.51249 .2861 L
.51349 .28723 L
.51449 .29085 L
.51548 .29699 L
.51648 .30562 L
.51748 .31664 L
.51848 .3299 L
.51948 .34519 L
.52048 .36223 L
.52148 .38071 L
.52248 .40027 L
.52348 .42051 L
.52448 .441 L
.52547 .46129 L
.52647 .48095 L
.52747 .49951 L
.52847 .51655 L
.52947 .53166 L
.53047 .54447 L
.53147 .55465 L
.53247 .56193 L
.53347 .5661 L
.53447 .56701 L
.53546 .5646 L
.53646 .55888 L
.53746 .54993 L
.53846 .53793 L
.53946 .5231 L
.54046 .50576 L
.54146 .4863 L
.54246 .46515 L
.54346 .44281 L
.54446 .4198 L
.54545 .39669 L
.54645 .37406 L
.54745 .35249 L
Mistroke
.54845 .33255 L
.54945 .39978 L
.55045 .40837 L
.55145 .41626 L
.55245 .42417 L
.55345 .43233 L
.55445 .44084 L
.55544 .44976 L
.55644 .45912 L
.55744 .46896 L
.55844 .47928 L
.55944 .49011 L
.56044 .50146 L
.56144 .51335 L
.56244 .52579 L
.56344 .5388 L
.56444 .55239 L
.56543 .5666 L
.56643 .58143 L
.56743 .59692 L
.56843 .61307 L
Mfstroke
.56843 .61307 m
.56873 .61803 L
s
.59912 .61803 m
.5994 .24585 L
.6004 .24914 L
.6014 .25123 L
.6024 .25278 L
.6034 .254 L
.6044 .255 L
.60539 .25583 L
.60639 .25655 L
.60739 .25717 L
.60839 .25771 L
.60939 .2582 L
.61039 .25864 L
.61139 .25904 L
.61239 .25941 L
.61339 .25976 L
.61439 .2601 L
.61538 .26042 L
.61638 .26075 L
.61738 .26107 L
.61838 .26139 L
.61938 .26172 L
.62038 .26206 L
.62138 .26242 L
.62238 .26279 L
.62338 .26318 L
.62438 .26359 L
.62537 .26403 L
.62637 .2645 L
.62737 .265 L
.62837 .26553 L
.62937 .2661 L
.63037 .26671 L
.63137 .26736 L
.63237 .26805 L
.63337 .26878 L
.63437 .26957 L
.63536 .27041 L
.63636 .2713 L
.63736 .27225 L
.63836 .27325 L
.63936 .27432 L
.64036 .27545 L
.64136 .27664 L
.64236 .27791 L
.64336 .27925 L
.64436 .28066 L
.64535 .28215 L
.64635 .28371 L
.64735 .28536 L
Mistroke
.64835 .2871 L
.64935 .27214 L
.65035 .27407 L
.65135 .27489 L
.65235 .27526 L
.65335 .27538 L
.65435 .27536 L
.65534 .27525 L
.65634 .27509 L
.65734 .27489 L
.65834 .27467 L
.65934 .27445 L
.66034 .27422 L
.66134 .274 L
.66234 .27378 L
.66334 .27358 L
.66434 .27339 L
.66533 .27322 L
.66633 .27306 L
.66733 .27292 L
.66833 .27279 L
.66933 .27269 L
.67033 .27261 L
.67133 .27255 L
.67233 .27251 L
.67333 .2725 L
.67433 .27251 L
.67532 .27255 L
.67632 .27261 L
.67732 .2727 L
.67832 .27282 L
.67932 .27297 L
.68032 .27316 L
.68132 .27338 L
.68232 .27363 L
.68332 .27392 L
.68432 .27425 L
.68531 .27462 L
.68631 .27503 L
.68731 .27548 L
.68831 .27599 L
.68931 .27654 L
.69031 .27714 L
.69131 .27779 L
.69231 .2785 L
.69331 .27926 L
.69431 .28009 L
.6953 .28097 L
.6963 .28193 L
.6973 .28295 L
Mistroke
.6983 .28403 L
.6993 .30577 L
.7003 .31204 L
.7013 .31706 L
.7023 .32146 L
.7033 .32544 L
.7043 .32908 L
.70529 .33243 L
.70629 .33551 L
.70729 .33835 L
.70829 .34095 L
.70929 .34333 L
.71029 .34549 L
.71129 .34744 L
.71229 .34918 L
.71329 .35071 L
.71429 .35204 L
.71528 .35318 L
.71628 .35413 L
.71728 .3549 L
.71828 .35548 L
.71928 .35589 L
.72028 .35614 L
.72128 .35622 L
.72228 .35615 L
.72328 .35593 L
.72428 .35557 L
.72527 .35508 L
.72627 .35446 L
.72727 .35373 L
.72827 .3529 L
.72927 .35197 L
.73027 .35094 L
.73127 .34984 L
.73227 .34867 L
.73327 .34744 L
.73427 .34615 L
.73526 .34483 L
.73626 .34347 L
.73726 .34209 L
.73826 .3407 L
.73926 .3393 L
.74026 .33791 L
.74126 .33653 L
.74226 .33517 L
.74326 .33384 L
.74426 .33256 L
.74525 .33132 L
.74625 .33013 L
.74725 .32901 L
Mistroke
.74825 .32795 L
.74925 .14022 L
.75025 .13318 L
.75125 .12603 L
.75225 .11949 L
.75325 .11381 L
.75425 .10913 L
.75524 .10555 L
.75624 .10315 L
.75724 .102 L
.75824 .10215 L
.75924 .10367 L
.76024 .10659 L
.76124 .11098 L
.76224 .11687 L
.76324 .1243 L
.76424 .13331 L
.76523 .14394 L
.76623 .15622 L
.76723 .17016 L
.76823 .1858 L
.76923 .20314 L
.77023 .22219 L
.77123 .24294 L
.77223 .26538 L
.77323 .28947 L
.77423 .31515 L
.77522 .34236 L
.77622 .371 L
.77722 .40092 L
.77822 .432 L
.77922 .46404 L
.78022 .49684 L
.78122 .5302 L
.78222 .56386 L
.78322 .59757 L
Mfstroke
.78322 .59757 m
.78383 .61803 L
s
.79881 .61803 m
.7992 .42604 L
.8002 .4305 L
.8012 .43337 L
.8022 .43527 L
.8032 .43641 L
.8042 .43687 L
.80519 .43672 L
.80619 .43601 L
.80719 .43475 L
.80819 .433 L
.80919 .43077 L
.81019 .42811 L
.81119 .42504 L
.81219 .4216 L
.81319 .41783 L
.81419 .41376 L
.81518 .40945 L
.81618 .40492 L
.81718 .40022 L
.81818 .39539 L
.81918 .39048 L
.82018 .38553 L
.82118 .38057 L
.82218 .37566 L
.82318 .37084 L
.82418 .36613 L
.82517 .36157 L
.82617 .35721 L
.82717 .35307 L
.82817 .34919 L
.82917 .34559 L
.83017 .3423 L
.83117 .33934 L
.83217 .33675 L
.83317 .33453 L
.83417 .33272 L
.83516 .33132 L
.83616 .33035 L
.83716 .32983 L
.83816 .32976 L
.83916 .33016 L
.84016 .33103 L
.84116 .33238 L
.84216 .3342 L
.84316 .33651 L
.84416 .3393 L
.84515 .34256 L
.84615 .3463 L
.84715 .3505 L
Mistroke
.84815 .35515 L
.84915 .43221 L
.85015 .43384 L
.85115 .43318 L
.85215 .43089 L
.85315 .42722 L
.85415 .42236 L
.85514 .41644 L
.85614 .4096 L
.85714 .40199 L
.85814 .39376 L
.85914 .38507 L
.86014 .37606 L
.86114 .36691 L
.86214 .35778 L
.86314 .34882 L
.86414 .34019 L
.86513 .33205 L
.86613 .32453 L
.86713 .31777 L
.86813 .3119 L
.86913 .30703 L
.87013 .30325 L
.87113 .30065 L
.87213 .29929 L
.87313 .29923 L
.87413 .30051 L
.87512 .30315 L
.87612 .30714 L
.87712 .31248 L
.87812 .31913 L
.87912 .32706 L
.88012 .33619 L
.88112 .34645 L
.88212 .35774 L
.88312 .36998 L
.88412 .38303 L
.88511 .39677 L
.88611 .41107 L
.88711 .42578 L
.88811 .44075 L
.88911 .45582 L
.89011 .47084 L
.89111 .48565 L
.89211 .50008 L
.89311 .51397 L
.89411 .52717 L
.8951 .53952 L
.8961 .55087 L
.8971 .56109 L
Mistroke
.8981 .57005 L
.8991 .43592 L
.9001 .44907 L
.9011 .46066 L
.9021 .47133 L
.9031 .48126 L
.9041 .49049 L
.90509 .49905 L
.90609 .50693 L
.90709 .51412 L
.90809 .52058 L
.90909 .52629 L
.91009 .53123 L
.91109 .53537 L
.91209 .53869 L
.91309 .54117 L
.91409 .54279 L
.91508 .54355 L
.91608 .54342 L
.91708 .54242 L
.91808 .54054 L
.91908 .53778 L
.92008 .53416 L
.92108 .52969 L
.92208 .5244 L
.92308 .51831 L
.92408 .51145 L
.92507 .50387 L
.92607 .49561 L
.92707 .48672 L
.92807 .47725 L
.92907 .46727 L
.93007 .45683 L
.93107 .44601 L
.93207 .43488 L
.93307 .42349 L
.93407 .41193 L
.93506 .40025 L
.93606 .38852 L
.93706 .3768 L
.93806 .36514 L
.93906 .35361 L
.94006 .34225 L
.94106 .33112 L
.94206 .32025 L
.94306 .30969 L
.94406 .29949 L
.94505 .28969 L
.94605 .28033 L
.94705 .27145 L
Mistroke
.94805 .26309 L
.94905 .27059 L
.95005 .2719 L
.95105 .27213 L
.95205 .27192 L
.95305 .2715 L
.95405 .27096 L
.95504 .27035 L
.95604 .26973 L
.95704 .2691 L
.95804 .26849 L
.95904 .2679 L
.96004 .26735 L
.96104 .26682 L
.96204 .26634 L
.96304 .26588 L
.96404 .26547 L
.96503 .26509 L
.96603 .26474 L
.96703 .26443 L
.96803 .26414 L
.96903 .26389 L
.97003 .26366 L
.97103 .26346 L
.97203 .26329 L
.97303 .26313 L
.97403 .263 L
.97502 .26289 L
.97602 .26279 L
.97702 .26271 L
.97802 .26265 L
.97902 .2626 L
.98002 .26256 L
.98102 .26254 L
.98202 .26253 L
.98302 .26252 L
.98402 .26253 L
.98501 .26255 L
.98601 .26258 L
.98701 .26261 L
.98801 .26265 L
.98901 .2627 L
.99001 .26276 L
.99101 .26282 L
.99201 .26289 L
.99301 .26297 L
.99401 .26305 L
.995 .26314 L
.996 .26324 L
.997 .26334 L
Mistroke
.998 .26345 L
.999 .31702 L
Mfstroke
1 0 0 r
gsave
.999 .31068 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30857 m
.001 .30738 L
.002 .30632 L
.003 .30534 L
.004 .30439 L
.005 .30345 L
.00599 .30247 L
.00699 .30144 L
.00799 .30034 L
.00899 .29913 L
.00999 .29781 L
.01099 .29634 L
.01199 .2947 L
.01299 .29287 L
.01399 .29083 L
.01499 .28853 L
.01598 .28595 L
.01698 .28306 L
.01798 .27981 L
.01898 .27615 L
.01998 .27204 L
.02098 .26741 L
.02198 .26221 L
.02298 .25636 L
.02398 .24978 L
.02498 .24238 L
.02597 .23406 L
.02697 .22469 L
.02797 .21416 L
.02897 .20231 L
.02997 .18898 L
.03097 .17399 L
.03197 .15712 L
.03297 .13815 L
.03397 .11681 L
.03497 .0928 L
.03596 .0658 L
.03696 .03542 L
.03796 .00125 L
s
.03796 .00125 m
.03799 0 L
s
.04992 0 m
.04995 .02836 L
.05095 .05281 L
.05195 .08818 L
.05295 .13294 L
.05395 .1848 L
.05495 .24081 L
.05594 .29744 L
.05694 .35081 L
.05794 .39691 L
.05894 .43182 L
.05994 .45205 L
.06094 .45474 L
.06194 .43801 L
.06294 .40108 L
.06394 .3445 L
.06494 .27022 L
.06593 .1816 L
.06693 .08328 L
s
.06693 .08328 m
.06775 0 L
s
.07752 0 m
.07792 .05824 L
.07892 .22615 L
.07992 .40614 L
.08092 .58708 L
s
.08092 .58708 m
.0811 .61803 L
s
.08935 .61803 m
.08991 .48354 L
.09091 .20084 L
s
.09091 .20084 m
.09155 0 L
s
.09971 0 m
.0999 .33251 L
.1009 .33439 L
.1019 .33646 L
.1029 .33872 L
.1039 .34118 L
.1049 .34385 L
.10589 .34672 L
.10689 .34981 L
.10789 .35313 L
.10889 .35669 L
.10989 .36049 L
.11089 .36455 L
.11189 .36888 L
.11289 .37348 L
.11389 .37839 L
.11489 .3836 L
.11588 .38914 L
.11688 .39502 L
.11788 .40126 L
.11888 .40787 L
.11988 .41488 L
.12088 .42231 L
.12188 .43018 L
.12288 .43851 L
.12388 .44732 L
.12488 .45665 L
.12587 .46652 L
.12687 .47696 L
.12787 .488 L
.12887 .49967 L
.12987 .51201 L
.13087 .52505 L
.13187 .53883 L
.13287 .55339 L
.13387 .56878 L
.13487 .58504 L
.13586 .60221 L
s
.13586 .60221 m
.13674 .61803 L
s
.14941 .61803 m
.14985 .36853 L
.15085 .35879 L
.15185 .34736 L
.15285 .33452 L
.15385 .32055 L
.15485 .3058 L
.15584 .29066 L
.15684 .27551 L
.15784 .26078 L
.15884 .24688 L
.15984 .23422 L
.16084 .2232 L
.16184 .21419 L
.16284 .20751 L
.16384 .20342 L
.16484 .20216 L
.16583 .20386 L
.16683 .20859 L
.16783 .21637 L
.16883 .22709 L
.16983 .24059 L
.17083 .25662 L
.17183 .27485 L
.17283 .29488 L
.17383 .31626 L
.17483 .33845 L
.17582 .36091 L
.17682 .38304 L
.17782 .40425 L
.17882 .42393 L
.17982 .44149 L
.18082 .4564 L
.18182 .46814 L
.18282 .47628 L
.18382 .48046 L
.18482 .48043 L
.18581 .47602 L
.18681 .46717 L
.18781 .45396 L
.18881 .43656 L
.18981 .41528 L
.19081 .39054 L
.19181 .36286 L
.19281 .33287 L
.19381 .30128 L
.19481 .26887 L
.1958 .23648 L
.1968 .20497 L
.1978 .17522 L
Mistroke
.1988 .1481 L
.1998 .16169 L
.2008 .15338 L
.2018 .14516 L
.2028 .13711 L
.2038 .12932 L
.2048 .12186 L
.20579 .11484 L
.20679 .10834 L
.20779 .10247 L
.20879 .09732 L
.20979 .09301 L
.21079 .08964 L
.21179 .08732 L
.21279 .08617 L
.21379 .08631 L
.21479 .08784 L
.21578 .09089 L
.21678 .09558 L
.21778 .102 L
.21878 .11029 L
.21978 .12053 L
.22078 .13284 L
.22178 .1473 L
.22278 .16402 L
.22378 .18305 L
.22478 .20448 L
.22577 .22836 L
.22677 .25473 L
.22777 .28362 L
.22877 .31505 L
.22977 .34901 L
.23077 .38546 L
.23177 .42438 L
.23277 .46568 L
.23377 .50928 L
.23477 .55506 L
.23576 .60287 L
Mfstroke
.23576 .60287 m
.23607 .61803 L
s
.2495 .61803 m
.24975 .39681 L
.25075 .40122 L
.25175 .40521 L
.25275 .40878 L
.25375 .41192 L
.25475 .4146 L
.25574 .41683 L
.25674 .41858 L
.25774 .41983 L
.25874 .42058 L
.25974 .4208 L
.26074 .42049 L
.26174 .41963 L
.26274 .4182 L
.26374 .41619 L
.26474 .41359 L
.26573 .41039 L
.26673 .40658 L
.26773 .40215 L
.26873 .39709 L
.26973 .39141 L
.27073 .3851 L
.27173 .37816 L
.27273 .3706 L
.27373 .36241 L
.27473 .35362 L
.27572 .34424 L
.27672 .33427 L
.27772 .32375 L
.27872 .31268 L
.27972 .30111 L
.28072 .28905 L
.28172 .27654 L
.28272 .26362 L
.28372 .25033 L
.28472 .23671 L
.28571 .22281 L
.28671 .20869 L
.28771 .19441 L
.28871 .18001 L
.28971 .16556 L
.29071 .15114 L
.29171 .13681 L
.29271 .12264 L
.29371 .10872 L
.29471 .09511 L
.2957 .08191 L
.2967 .0692 L
.2977 .05707 L
Mistroke
.2987 .04559 L
.2997 .35045 L
.3007 .35288 L
.3017 .35518 L
.3027 .35734 L
.3037 .35938 L
.3047 .3613 L
.30569 .36311 L
.30669 .36479 L
.30769 .36636 L
.30869 .36781 L
.30969 .36914 L
.31069 .37037 L
.31169 .37147 L
.31269 .37246 L
.31369 .37333 L
.31469 .37408 L
.31568 .37471 L
.31668 .37522 L
.31768 .3756 L
.31868 .37586 L
.31968 .37598 L
.32068 .37598 L
.32168 .37584 L
.32268 .37556 L
.32368 .37513 L
.32468 .37457 L
.32567 .37386 L
.32667 .373 L
.32767 .37199 L
.32867 .37083 L
.32967 .36951 L
.33067 .36803 L
.33167 .36638 L
.33267 .36458 L
.33367 .36261 L
.33467 .36047 L
.33566 .35816 L
.33666 .35568 L
.33766 .35303 L
.33866 .3502 L
.33966 .3472 L
.34066 .34403 L
.34166 .34068 L
.34266 .33715 L
.34366 .33345 L
.34466 .32957 L
.34565 .32552 L
.34665 .3213 L
.34765 .3169 L
Mistroke
.34865 .31234 L
.34965 .38362 L
.35065 .37634 L
.35165 .36826 L
.35265 .3595 L
.35365 .35022 L
.35465 .34057 L
.35564 .33071 L
.35664 .3208 L
.35764 .31102 L
.35864 .30154 L
.35964 .29253 L
.36064 .28417 L
.36164 .27659 L
.36264 .26996 L
.36364 .26441 L
.36464 .26006 L
.36563 .25702 L
.36663 .25536 L
.36763 .25514 L
.36863 .25642 L
.36963 .2592 L
.37063 .26348 L
.37163 .26922 L
.37263 .27637 L
.37363 .28484 L
.37463 .29453 L
.37562 .30532 L
.37662 .31704 L
.37762 .32954 L
.37862 .34264 L
.37962 .35613 L
.38062 .3698 L
.38162 .38346 L
.38262 .39686 L
.38362 .4098 L
.38462 .42206 L
.38561 .43342 L
.38661 .44369 L
.38761 .45267 L
.38861 .4602 L
.38961 .46612 L
.39061 .47031 L
.39161 .47266 L
.39261 .4731 L
.39361 .47158 L
.39461 .46809 L
.3956 .46264 L
.3966 .45528 L
.3976 .44609 L
Mistroke
.3986 .43518 L
.3996 .26083 L
.4006 .254 L
.4016 .24723 L
.4026 .24047 L
.4036 .23368 L
.4046 .22683 L
.40559 .21987 L
.40659 .21277 L
.40759 .20551 L
.40859 .19805 L
.40959 .19038 L
.41059 .18245 L
.41159 .17425 L
.41259 .16575 L
.41359 .15693 L
.41459 .14776 L
.41558 .13823 L
.41658 .12832 L
.41758 .11799 L
.41858 .10723 L
.41958 .09601 L
.42058 .08432 L
.42158 .07214 L
.42258 .05943 L
.42358 .04617 L
.42458 .03235 L
.42557 .01794 L
.42657 .00291 L
Mfstroke
.42657 .00291 m
.42676 0 L
s
.44914 0 m
.44955 .38033 L
.45055 .37969 L
.45155 .37899 L
.45255 .37824 L
.45355 .37743 L
.45455 .37656 L
.45554 .37563 L
.45654 .37463 L
.45754 .37357 L
.45854 .37244 L
.45954 .37125 L
.46054 .36998 L
.46154 .36865 L
.46254 .36724 L
.46354 .36576 L
.46454 .36421 L
.46553 .36259 L
.46653 .3609 L
.46753 .35914 L
.46853 .35731 L
.46953 .35541 L
.47053 .35344 L
.47153 .3514 L
.47253 .3493 L
.47353 .34714 L
.47453 .34491 L
.47552 .34262 L
.47652 .34028 L
.47752 .33787 L
.47852 .33542 L
.47952 .33291 L
.48052 .33036 L
.48152 .32776 L
.48252 .32512 L
.48352 .32245 L
.48452 .31973 L
.48551 .31699 L
.48651 .31421 L
.48751 .31141 L
.48851 .30859 L
.48951 .30576 L
.49051 .30291 L
.49151 .30005 L
.49251 .29719 L
.49351 .29433 L
.49451 .29147 L
.4955 .28862 L
.4965 .28578 L
.4975 .28297 L
Mistroke
.4985 .28017 L
.4995 .39005 L
.5005 .37847 L
.5015 .36582 L
.5025 .3524 L
.5035 .33855 L
.5045 .32461 L
.50549 .31092 L
.50649 .29785 L
.50749 .28573 L
.50849 .2749 L
.50949 .26567 L
.51049 .25832 L
.51149 .25308 L
.51249 .25014 L
.51349 .24965 L
.51449 .25169 L
.51548 .25629 L
.51648 .26342 L
.51748 .27299 L
.51848 .28483 L
.51948 .29873 L
.52048 .31442 L
.52148 .33159 L
.52248 .34987 L
.52348 .36886 L
.52448 .38813 L
.52547 .40724 L
.52647 .42574 L
.52747 .44317 L
.52847 .45911 L
.52947 .47313 L
.53047 .48487 L
.53147 .49398 L
.53247 .50019 L
.53347 .50329 L
.53447 .50311 L
.53546 .4996 L
.53646 .49274 L
.53746 .48262 L
.53846 .4694 L
.53946 .45332 L
.54046 .43469 L
.54146 .41388 L
.54246 .39135 L
.54346 .36758 L
.54446 .34311 L
.54545 .31851 L
.54645 .29435 L
.54745 .27122 L
Mistroke
.54845 .24971 L
.54945 .39342 L
.55045 .39805 L
.55145 .40301 L
.55245 .40829 L
.55345 .41391 L
.55445 .41986 L
.55544 .42615 L
.55644 .4328 L
.55744 .43981 L
.55844 .44719 L
.55944 .45495 L
.56044 .46311 L
.56144 .47167 L
.56244 .48065 L
.56344 .49007 L
.56444 .49993 L
.56543 .51026 L
.56643 .52106 L
.56743 .53236 L
.56843 .54417 L
.56943 .55651 L
.57043 .56941 L
.57143 .58287 L
.57243 .59692 L
.57343 .61158 L
Mfstroke
.57343 .61158 m
.57385 .61803 L
s
.59903 .61803 m
.5994 .23954 L
.6004 .23892 L
.6014 .23824 L
.6024 .23752 L
.6034 .23676 L
.6044 .23597 L
.60539 .23515 L
.60639 .2343 L
.60739 .23343 L
.60839 .23255 L
.60939 .23166 L
.61039 .23075 L
.61139 .22985 L
.61239 .22894 L
.61339 .22804 L
.61439 .22714 L
.61538 .22626 L
.61638 .22538 L
.61738 .22453 L
.61838 .22369 L
.61938 .22288 L
.62038 .22209 L
.62138 .22133 L
.62238 .22061 L
.62338 .21992 L
.62438 .21926 L
.62537 .21865 L
.62637 .21808 L
.62737 .21756 L
.62837 .21708 L
.62937 .21665 L
.63037 .21628 L
.63137 .21597 L
.63237 .21571 L
.63337 .21551 L
.63437 .21538 L
.63536 .21531 L
.63636 .21531 L
.63736 .21537 L
.63836 .21551 L
.63936 .21573 L
.64036 .21602 L
.64136 .21639 L
.64236 .21683 L
.64336 .21736 L
.64436 .21798 L
.64535 .21868 L
.64635 .21946 L
.64735 .22034 L
Mistroke
.64835 .22131 L
.64935 .26583 L
.65035 .26383 L
.65135 .26186 L
.65235 .25992 L
.65335 .258 L
.65435 .2561 L
.65534 .25422 L
.65634 .25237 L
.65734 .25054 L
.65834 .24873 L
.65934 .24693 L
.66034 .24516 L
.66134 .24341 L
.66234 .24168 L
.66334 .23997 L
.66434 .23828 L
.66533 .23662 L
.66633 .23497 L
.66733 .23336 L
.66833 .23176 L
.66933 .2302 L
.67033 .22866 L
.67133 .22716 L
.67233 .22568 L
.67333 .22424 L
.67433 .22284 L
.67532 .22147 L
.67632 .22013 L
.67732 .21884 L
.67832 .2176 L
.67932 .21639 L
.68032 .21523 L
.68132 .21413 L
.68232 .21307 L
.68332 .21207 L
.68432 .21112 L
.68531 .21023 L
.68631 .2094 L
.68731 .20863 L
.68831 .20793 L
.68931 .20729 L
.69031 .20673 L
.69131 .20624 L
.69231 .20582 L
.69331 .20547 L
.69431 .20521 L
.6953 .20503 L
.6963 .20493 L
.6973 .20492 L
Mistroke
.6983 .20499 L
.6993 .29946 L
.7003 .30179 L
.7013 .30402 L
.7023 .30614 L
.7033 .30814 L
.7043 .31002 L
.70529 .31175 L
.70629 .31335 L
.70729 .3148 L
.70829 .3161 L
.70929 .31725 L
.71029 .31824 L
.71129 .31906 L
.71229 .31973 L
.71329 .32023 L
.71429 .32057 L
.71528 .32074 L
.71628 .32076 L
.71728 .32062 L
.71828 .32032 L
.71928 .31987 L
.72028 .31927 L
.72128 .31853 L
.72228 .31765 L
.72328 .31665 L
.72428 .31551 L
.72527 .31427 L
.72627 .31291 L
.72727 .31146 L
.72827 .30991 L
.72927 .30828 L
.73027 .30657 L
.73127 .30481 L
.73227 .30298 L
.73327 .30111 L
.73427 .29921 L
.73526 .29728 L
.73626 .29534 L
.73726 .29339 L
.73826 .29145 L
.73926 .28952 L
.74026 .28761 L
.74126 .28574 L
.74226 .28391 L
.74326 .28213 L
.74426 .2804 L
.74525 .27875 L
.74625 .27716 L
.74725 .27566 L
Mistroke
.74825 .27424 L
.74925 .13389 L
.75025 .12286 L
.75125 .11276 L
.75225 .10363 L
.75325 .09556 L
.75425 .08862 L
.75524 .08288 L
.75624 .0784 L
.75724 .07527 L
.75824 .07354 L
.75924 .07328 L
.76024 .07455 L
.76124 .07739 L
.76224 .08185 L
.76324 .08796 L
.76424 .09576 L
.76523 .10526 L
.76623 .11646 L
.76723 .12937 L
.76823 .14396 L
.76923 .16022 L
.77023 .17808 L
.77123 .19751 L
.77223 .21843 L
.77323 .24075 L
.77423 .26439 L
.77522 .28921 L
.77622 .3151 L
.77722 .34192 L
.77822 .3695 L
.77922 .39767 L
.78022 .42625 L
.78122 .45505 L
.78222 .48384 L
.78322 .51242 L
.78422 .54055 L
.78521 .56798 L
.78621 .59448 L
Mfstroke
.78621 .59448 m
.78714 .61803 L
s
.79859 .61803 m
.7992 .41967 L
.8002 .42022 L
.8012 .4203 L
.8022 .41991 L
.8032 .41905 L
.8042 .41772 L
.80519 .41594 L
.80619 .41371 L
.80719 .41104 L
.80819 .40796 L
.80919 .40446 L
.81019 .40058 L
.81119 .39632 L
.81219 .39173 L
.81319 .38681 L
.81419 .3816 L
.81518 .37612 L
.81618 .3704 L
.81718 .36448 L
.81818 .35839 L
.81918 .35216 L
.82018 .34582 L
.82118 .33942 L
.82218 .33298 L
.82318 .32655 L
.82418 .32015 L
.82517 .31384 L
.82617 .30764 L
.82717 .30159 L
.82817 .29573 L
.82917 .29009 L
.83017 .28472 L
.83117 .27963 L
.83217 .27487 L
.83317 .27047 L
.83417 .26645 L
.83516 .26284 L
.83616 .25967 L
.83716 .25697 L
.83816 .25474 L
.83916 .25302 L
.84016 .25182 L
.84116 .25115 L
.84216 .25102 L
.84316 .25145 L
.84416 .25243 L
.84515 .25397 L
.84615 .25607 L
.84715 .25872 L
Mistroke
.84815 .26192 L
.84915 .42585 L
.85015 .42351 L
.85115 .41998 L
.85215 .41528 L
.85315 .40949 L
.85415 .40268 L
.85514 .39494 L
.85614 .38637 L
.85714 .37709 L
.85814 .36722 L
.85914 .3569 L
.86014 .34626 L
.86114 .33545 L
.86214 .32461 L
.86314 .3139 L
.86414 .30347 L
.86513 .29347 L
.86613 .28404 L
.86713 .27532 L
.86813 .26743 L
.86913 .26051 L
.87013 .25466 L
.87113 .24998 L
.87213 .24656 L
.87313 .24446 L
.87413 .24374 L
.87512 .24442 L
.87612 .24654 L
.87712 .25008 L
.87812 .25503 L
.87912 .26136 L
.88012 .269 L
.88112 .27788 L
.88212 .28791 L
.88312 .29898 L
.88412 .31098 L
.88511 .32377 L
.88611 .33719 L
.88711 .3511 L
.88811 .36533 L
.88911 .3797 L
.89011 .39404 L
.89111 .40818 L
.89211 .42192 L
.89311 .4351 L
.89411 .44755 L
.8951 .4591 L
.8961 .4696 L
.8971 .4789 L
Mistroke
.8981 .48687 L
.8991 .42955 L
.9001 .43876 L
.9011 .44745 L
.9021 .45559 L
.9031 .46316 L
.9041 .47014 L
.90509 .47651 L
.90609 .48224 L
.90709 .4873 L
.90809 .49169 L
.90909 .49539 L
.91009 .49837 L
.91109 .50062 L
.91209 .50213 L
.91309 .50289 L
.91409 .50289 L
.91508 .50212 L
.91608 .50058 L
.91708 .49826 L
.91808 .49517 L
.91908 .49131 L
.92008 .48668 L
.92108 .4813 L
.92208 .47517 L
.92308 .46831 L
.92408 .46073 L
.92507 .45246 L
.92607 .44352 L
.92707 .43393 L
.92807 .42373 L
.92907 .41294 L
.93007 .40159 L
.93107 .38974 L
.93207 .37741 L
.93307 .36465 L
.93407 .3515 L
.93506 .33801 L
.93606 .32424 L
.93706 .31022 L
.93806 .29602 L
.93906 .2817 L
.94006 .2673 L
.94106 .25289 L
.94206 .23853 L
.94306 .22428 L
.94406 .2102 L
.94505 .19636 L
.94605 .18281 L
.94705 .16963 L
Mistroke
.94805 .15687 L
.94905 .26422 L
.95005 .26163 L
.95105 .25906 L
.95205 .25651 L
.95305 .25397 L
.95405 .25144 L
.95504 .24894 L
.95604 .24645 L
.95704 .24397 L
.95804 .24151 L
.95904 .23907 L
.96004 .23664 L
.96104 .23423 L
.96204 .23184 L
.96304 .22946 L
.96404 .2271 L
.96503 .22476 L
.96603 .22243 L
.96703 .22013 L
.96803 .21784 L
.96903 .21557 L
.97003 .21332 L
.97103 .21109 L
.97203 .20888 L
.97303 .2067 L
.97403 .20453 L
.97502 .20239 L
.97602 .20027 L
.97702 .19817 L
.97802 .1961 L
.97902 .19405 L
.98002 .19203 L
.98102 .19003 L
.98202 .18807 L
.98302 .18613 L
.98402 .18421 L
.98501 .18233 L
.98601 .18048 L
.98701 .17866 L
.98801 .17687 L
.98901 .17511 L
.99001 .17339 L
.99101 .1717 L
.99201 .17005 L
.99301 .16843 L
.99401 .16685 L
.995 .16531 L
.996 .1638 L
.997 .16234 L
Mistroke
.998 .16092 L
.999 .31068 L
Mfstroke
0 g
gsave
.999 .31262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .30857 Mdot
.04995 .02676 Mdot
.0999 .33043 Mdot
.14985 .36056 Mdot
.1998 .16105 Mdot
.24975 .39404 Mdot
.2997 .35088 Mdot
.34965 .38206 Mdot
.3996 .2595 Mdot
.44955 .38047 Mdot
.4995 .38947 Mdot
.54945 .39394 Mdot
.5994 .23842 Mdot
.64935 .26635 Mdot
.6993 .30117 Mdot
.74925 .13277 Mdot
.7992 .41714 Mdot
.84915 .42676 Mdot
.8991 .42916 Mdot
.94905 .26515 Mdot
.999 .31262 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.000999001 0 0.0103006 [
[.1998 -0.0125 -9 -9 ]
[.1998 -0.0125 9 0 ]
[.3996 -0.0125 -9 -9 ]
[.3996 -0.0125 9 0 ]
[.5994 -0.0125 -9 -9 ]
[.5994 -0.0125 9 0 ]
[.7992 -0.0125 -9 -9 ]
[.7992 -0.0125 9 0 ]
[.999 -0.0125 -12 -9 ]
[.999 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -12 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -12 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -12 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -12 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -5 0 ]
[.5 .63053 5 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.1998 0 m
.1998 .00625 L
s
[(200)] .1998 -0.0125 0 1 Mshowa
.3996 0 m
.3996 .00625 L
s
[(400)] .3996 -0.0125 0 1 Mshowa
.5994 0 m
.5994 .00625 L
s
[(600)] .5994 -0.0125 0 1 Mshowa
.7992 0 m
.7992 .00625 L
s
[(800)] .7992 -0.0125 0 1 Mshowa
.999 0 m
.999 .00625 L
s
[(1000)] .999 -0.0125 0 1 Mshowa
.125 Mabswid
.04995 0 m
.04995 .00375 L
s
.0999 0 m
.0999 .00375 L
s
.14985 0 m
.14985 .00375 L
s
.24975 0 m
.24975 .00375 L
s
.2997 0 m
.2997 .00375 L
s
.34965 0 m
.34965 .00375 L
s
.44955 0 m
.44955 .00375 L
s
.4995 0 m
.4995 .00375 L
s
.54945 0 m
.54945 .00375 L
s
.64935 0 m
.64935 .00375 L
s
.6993 0 m
.6993 .00375 L
s
.74925 0 m
.74925 .00375 L
s
.84915 0 m
.84915 .00375 L
s
.8991 0 m
.8991 .00375 L
s
.94905 0 m
.94905 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(10)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(20)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(30)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(40)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(50)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(60)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .0206 m
.00375 .0206 L
s
0 .0412 m
.00375 .0412 L
s
0 .0618 m
.00375 .0618 L
s
0 .0824 m
.00375 .0824 L
s
0 .12361 m
.00375 .12361 L
s
0 .14421 m
.00375 .14421 L
s
0 .16481 m
.00375 .16481 L
s
0 .18541 m
.00375 .18541 L
s
0 .22661 m
.00375 .22661 L
s
0 .24721 m
.00375 .24721 L
s
0 .26781 m
.00375 .26781 L
s
0 .28842 m
.00375 .28842 L
s
0 .32962 m
.00375 .32962 L
s
0 .35022 m
.00375 .35022 L
s
0 .37082 m
.00375 .37082 L
s
0 .39142 m
.00375 .39142 L
s
0 .43262 m
.00375 .43262 L
s
0 .45322 m
.00375 .45322 L
s
0 .47383 m
.00375 .47383 L
s
0 .49443 m
.00375 .49443 L
s
0 .53563 m
.00375 .53563 L
s
0 .55623 m
.00375 .55623 L
s
0 .57683 m
.00375 .57683 L
s
0 .59743 m
.00375 .59743 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.1998 .61178 m
.1998 .61803 L
s
.3996 .61178 m
.3996 .61803 L
s
.5994 .61178 m
.5994 .61803 L
s
.7992 .61178 m
.7992 .61803 L
s
.999 .61178 m
.999 .61803 L
s
.125 Mabswid
.04995 .61428 m
.04995 .61803 L
s
.0999 .61428 m
.0999 .61803 L
s
.14985 .61428 m
.14985 .61803 L
s
.24975 .61428 m
.24975 .61803 L
s
.2997 .61428 m
.2997 .61803 L
s
.34965 .61428 m
.34965 .61803 L
s
.44955 .61428 m
.44955 .61803 L
s
.4995 .61428 m
.4995 .61803 L
s
.54945 .61428 m
.54945 .61803 L
s
.64935 .61428 m
.64935 .61803 L
s
.6993 .61428 m
.6993 .61803 L
s
.74925 .61428 m
.74925 .61803 L
s
.84915 .61428 m
.84915 .61803 L
s
.8991 .61428 m
.8991 .61803 L
s
.94905 .61428 m
.94905 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .0206 m
1 .0206 L
s
.99625 .0412 m
1 .0412 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .0824 m
1 .0824 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .14421 m
1 .14421 L
s
.99625 .16481 m
1 .16481 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .22661 m
1 .22661 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26781 m
1 .26781 L
s
.99625 .28842 m
1 .28842 L
s
.99625 .32962 m
1 .32962 L
s
.99625 .35022 m
1 .35022 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .39142 m
1 .39142 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .45322 m
1 .45322 L
s
.99625 .47383 m
1 .47383 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .53563 m
1 .53563 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57683 m
1 .57683 L
s
.99625 .59743 m
1 .59743 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(z) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.999 .28788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
0 .0001 m
0 0 rlineto s
0 .0001 m
.00019 0 L
s
.00152 0 m
.002 .00039 L
s
.002 .00039 m
.0025 0 L
s
.00311 0 m
.004 .00293 L
.005 .00311 L
.00599 .00065 L
.00699 .00357 L
s
.00699 .00357 m
.00772 0 L
s
.00859 0 m
.00899 .00088 L
.00999 .00167 L
s
.00999 .00167 m
.01047 0 L
s
.01182 0 m
.01199 .00036 L
s
.01199 .00036 m
.01211 0 L
s
.01746 0 m
.01798 .00255 L
.01898 .00306 L
.01998 .00743 L
.02098 .00468 L
s
.02098 .00468 m
.02174 0 L
s
.02979 0 m
.02997 .00054 L
.03097 1e-05 L
.03197 .00972 L
.03297 .01165 L
.03397 .01238 L
.03497 .01282 L
.03596 .01921 L
.03696 .02857 L
.03796 .03451 L
.03896 .04308 L
.03996 .04725 L
.04096 .05823 L
.04196 .07066 L
.04296 .10062 L
.04396 .1232 L
.04496 .15517 L
.04595 .19215 L
.04695 .23578 L
.04795 .28733 L
.04895 .34772 L
.04995 .40589 L
.05095 .45984 L
.05195 .50138 L
.05295 .53445 L
.05395 .55844 L
.05495 .57183 L
.05594 .56551 L
.05694 .54954 L
.05794 .52386 L
.05894 .48851 L
.05994 .46223 L
.06094 .43043 L
.06194 .40394 L
.06294 .38404 L
.06394 .36227 L
.06494 .34852 L
.06593 .33989 L
.06693 .3442 L
.06793 .34752 L
.06893 .35072 L
.06993 .35661 L
.07093 .35972 L
.07193 .36918 L
.07293 .38031 L
.07393 .38425 L
.07493 .39483 L
.07592 .40315 L
.07692 .40259 L
.07792 .40769 L
Mistroke
.07892 .40546 L
.07992 .40477 L
.08092 .39693 L
.08192 .39189 L
.08292 .37371 L
.08392 .36718 L
.08492 .35827 L
.08591 .34723 L
.08691 .34554 L
.08791 .33315 L
.08891 .32345 L
.08991 .3077 L
.09091 .30092 L
.09191 .29187 L
.09291 .28999 L
.09391 .2768 L
.09491 .26057 L
.0959 .25704 L
.0969 .24695 L
.0979 .24336 L
.0989 .24284 L
.0999 .23725 L
.1009 .23102 L
.1019 .23385 L
.1029 .22644 L
.1039 .21937 L
.1049 .21525 L
.10589 .21408 L
.10689 .21257 L
.10789 .21221 L
.10889 .20857 L
.10989 .20221 L
.11089 .19798 L
.11189 .1958 L
.11289 .19415 L
.11389 .19431 L
.11489 .1858 L
.11588 .18348 L
.11688 .17994 L
.11788 .18074 L
.11888 .18176 L
.11988 .18598 L
.12088 .18487 L
.12188 .18493 L
.12288 .19023 L
.12388 .18534 L
.12488 .1888 L
.12587 .18838 L
.12687 .18585 L
.12787 .18731 L
Mistroke
.12887 .19217 L
.12987 .19144 L
.13087 .19372 L
.13187 .19737 L
.13287 .20534 L
.13387 .21844 L
.13487 .22247 L
.13586 .23478 L
.13686 .24533 L
.13786 .26674 L
.13886 .28525 L
.13986 .29718 L
.14086 .31236 L
.14186 .33005 L
.14286 .35134 L
.14386 .36397 L
.14486 .37769 L
.14585 .39387 L
.14685 .39745 L
.14785 .39958 L
.14885 .40848 L
.14985 .40492 L
.15085 .40701 L
.15185 .39685 L
.15285 .38532 L
.15385 .37906 L
.15485 .3675 L
.15584 .35976 L
.15684 .34985 L
.15784 .33096 L
.15884 .32195 L
.15984 .30643 L
.16084 .2941 L
.16184 .28765 L
.16284 .27943 L
.16384 .27546 L
.16484 .27078 L
.16583 .25324 L
.16683 .25015 L
.16783 .24304 L
.16883 .22933 L
.16983 .22435 L
.17083 .21747 L
.17183 .21251 L
.17283 .20626 L
.17383 .19564 L
.17483 .19081 L
.17582 .18405 L
.17682 .17924 L
.17782 .17627 L
Mistroke
.17882 .16976 L
.17982 .16278 L
.18082 .15257 L
.18182 .14811 L
.18282 .149 L
.18382 .15279 L
.18482 .14749 L
.18581 .14927 L
.18681 .15144 L
.18781 .14907 L
.18881 .14551 L
.18981 .14499 L
.19081 .14577 L
.19181 .1447 L
.19281 .14938 L
.19381 .1521 L
.19481 .15062 L
.1958 .15273 L
.1968 .15534 L
.1978 .15944 L
.1988 .1689 L
.1998 .17376 L
.2008 .17446 L
.2018 .18327 L
.2028 .18796 L
.2038 .19908 L
.2048 .20859 L
.20579 .22208 L
.20679 .23471 L
.20779 .2618 L
.20879 .28989 L
.20979 .32112 L
.21079 .3473 L
.21179 .37281 L
.21279 .38161 L
.21379 .40429 L
.21479 .4192 L
.21578 .43394 L
.21678 .44667 L
.21778 .44766 L
.21878 .44951 L
.21978 .44392 L
.22078 .43828 L
.22178 .42694 L
.22278 .41392 L
.22378 .40061 L
.22478 .38988 L
.22577 .37953 L
.22677 .35914 L
.22777 .34484 L
Mistroke
.22877 .32717 L
.22977 .32028 L
.23077 .32061 L
.23177 .30404 L
.23277 .29758 L
.23377 .29097 L
.23477 .28344 L
.23576 .27851 L
.23676 .26832 L
.23776 .2676 L
.23876 .25584 L
.23976 .25155 L
.24076 .25622 L
.24176 .25632 L
.24276 .257 L
.24376 .25307 L
.24476 .24582 L
.24575 .24395 L
.24675 .24341 L
.24775 .2485 L
.24875 .24331 L
.24975 .24007 L
.25075 .23297 L
.25175 .22774 L
.25275 .22199 L
.25375 .21589 L
.25475 .21621 L
.25574 .21977 L
.25674 .22576 L
.25774 .22779 L
.25874 .23359 L
.25974 .24559 L
.26074 .24435 L
.26174 .2483 L
.26274 .25281 L
.26374 .25993 L
.26474 .26811 L
.26573 .27479 L
.26673 .27993 L
.26773 .28846 L
.26873 .30136 L
.26973 .30172 L
.27073 .30309 L
.27173 .31144 L
.27273 .31493 L
.27373 .32074 L
.27473 .31851 L
.27572 .32034 L
.27672 .32137 L
.27772 .32721 L
Mistroke
.27872 .33208 L
.27972 .33236 L
.28072 .33393 L
.28172 .3328 L
.28272 .32948 L
.28372 .32114 L
.28472 .31808 L
.28571 .31417 L
.28671 .30772 L
.28771 .30589 L
.28871 .30471 L
.28971 .30156 L
.29071 .3 L
.29171 .29328 L
.29271 .28595 L
.29371 .28422 L
.29471 .27342 L
.2957 .26407 L
.2967 .26167 L
.2977 .25072 L
.2987 .24606 L
.2997 .24192 L
.3007 .24072 L
.3017 .2392 L
.3027 .23994 L
.3037 .23976 L
.3047 .23526 L
.30569 .23644 L
.30669 .23485 L
.30769 .23801 L
.30869 .23488 L
.30969 .23126 L
.31069 .23677 L
.31169 .233 L
.31269 .23232 L
.31369 .22641 L
.31469 .22831 L
.31568 .22123 L
.31668 .22231 L
.31768 .22021 L
.31868 .21639 L
.31968 .21549 L
.32068 .22038 L
.32168 .22107 L
.32268 .21136 L
.32368 .21126 L
.32468 .20929 L
.32567 .21023 L
.32667 .20738 L
.32767 .20448 L
Mistroke
.32867 .21021 L
.32967 .22052 L
.33067 .22917 L
.33167 .24105 L
.33267 .24905 L
.33367 .24832 L
.33467 .2567 L
.33566 .26698 L
.33666 .27487 L
.33766 .2873 L
.33866 .30297 L
.33966 .31325 L
.34066 .32329 L
.34166 .33463 L
.34266 .34549 L
.34366 .34845 L
.34466 .35474 L
.34565 .35707 L
.34665 .35997 L
.34765 .3637 L
.34865 .36843 L
.34965 .36729 L
.35065 .36791 L
.35165 .36744 L
.35265 .37075 L
.35365 .36901 L
.35465 .35462 L
.35564 .34655 L
.35664 .34233 L
.35764 .33647 L
.35864 .33327 L
.35964 .32282 L
.36064 .31805 L
.36164 .3116 L
.36264 .29912 L
.36364 .29227 L
.36464 .28526 L
.36563 .27776 L
.36663 .26997 L
.36763 .26231 L
.36863 .26358 L
.36963 .24801 L
.37063 .24573 L
.37163 .23464 L
.37263 .22692 L
.37363 .22586 L
.37463 .21754 L
.37562 .20807 L
.37662 .20405 L
.37762 .19192 L
Mistroke
.37862 .18579 L
.37962 .18653 L
.38062 .18599 L
.38162 .17779 L
.38262 .17515 L
.38362 .16975 L
.38462 .16692 L
.38561 .16726 L
.38661 .16122 L
.38761 .15522 L
.38861 .15048 L
.38961 .14685 L
.39061 .15004 L
.39161 .14242 L
.39261 .1424 L
.39361 .13677 L
.39461 .13311 L
.3956 .13644 L
.3966 .13451 L
.3976 .12944 L
.3986 .12407 L
.3996 .11865 L
.4006 .11704 L
.4016 .12681 L
.4026 .12168 L
.4036 .11903 L
.4046 .12056 L
.40559 .12152 L
.40659 .12703 L
.40759 .12977 L
.40859 .13472 L
.40959 .14075 L
.41059 .13664 L
.41159 .13852 L
.41259 .14081 L
.41359 .14696 L
.41459 .15341 L
.41558 .15956 L
.41658 .17346 L
.41758 .18955 L
.41858 .20133 L
.41958 .21193 L
.42058 .21922 L
.42158 .2392 L
.42258 .2609 L
.42358 .28579 L
.42458 .31249 L
.42557 .34056 L
.42657 .36013 L
.42757 .38124 L
Mistroke
.42857 .4049 L
.42957 .42131 L
.43057 .43331 L
.43157 .44932 L
.43257 .46187 L
.43357 .46328 L
.43457 .45917 L
.43556 .46492 L
.43656 .45191 L
.43756 .44358 L
.43856 .43238 L
.43956 .42136 L
.44056 .40801 L
.44156 .39881 L
.44256 .37787 L
.44356 .3656 L
.44456 .35462 L
.44555 .34372 L
.44655 .33728 L
.44755 .33268 L
.44855 .32096 L
.44955 .31375 L
.45055 .30852 L
.45155 .29571 L
.45255 .28664 L
.45355 .2801 L
.45455 .27211 L
.45554 .26437 L
.45654 .2611 L
.45754 .25844 L
.45854 .256 L
.45954 .2539 L
.46054 .2586 L
.46154 .25962 L
.46254 .25289 L
.46354 .23866 L
.46454 .23094 L
.46553 .21888 L
.46653 .21399 L
.46753 .21557 L
.46853 .21374 L
.46953 .20521 L
.47053 .1988 L
.47153 .19505 L
.47253 .18852 L
.47353 .19376 L
.47453 .1917 L
.47552 .1922 L
.47652 .19655 L
.47752 .19982 L
Mistroke
.47852 .19793 L
.47952 .19713 L
.48052 .19679 L
.48152 .20416 L
.48252 .21271 L
.48352 .21381 L
.48452 .22375 L
.48551 .22521 L
.48651 .23623 L
.48751 .24445 L
.48851 .25984 L
.48951 .27422 L
.49051 .28167 L
.49151 .29408 L
.49251 .305 L
.49351 .31372 L
.49451 .32884 L
.4955 .34897 L
.4965 .36199 L
.4975 .37507 L
.4985 .37964 L
.4995 .38734 L
.5005 .39015 L
.5015 .38613 L
.5025 .38473 L
.5035 .38203 L
.5045 .37705 L
.50549 .36488 L
.50649 .35755 L
.50749 .34794 L
.50849 .32991 L
.50949 .32711 L
.51049 .31655 L
.51149 .30665 L
.51249 .29471 L
.51349 .28444 L
.51449 .2785 L
.51548 .26944 L
.51648 .25662 L
.51748 .25246 L
.51848 .24788 L
.51948 .24835 L
.52048 .24416 L
.52148 .24285 L
.52248 .24242 L
.52348 .23804 L
.52448 .22679 L
.52547 .22174 L
.52647 .22037 L
.52747 .21789 L
Mistroke
.52847 .20335 L
.52947 .19611 L
.53047 .1907 L
.53147 .18215 L
.53247 .17941 L
.53347 .17617 L
.53447 .17392 L
.53546 .16762 L
.53646 .16021 L
.53746 .15266 L
.53846 .14847 L
.53946 .14182 L
.54046 .13352 L
.54146 .13399 L
.54246 .12678 L
.54346 .13034 L
.54446 .12425 L
.54545 .12621 L
.54645 .12604 L
.54745 .13011 L
.54845 .12739 L
.54945 .12437 L
.55045 .12066 L
.55145 .11416 L
.55245 .11757 L
.55345 .12404 L
.55445 .12776 L
.55544 .12467 L
.55644 .1285 L
.55744 .13581 L
.55844 .13993 L
.55944 .14541 L
.56044 .15032 L
.56144 .15848 L
.56244 .17506 L
.56344 .19066 L
.56444 .21321 L
.56543 .23599 L
.56643 .25062 L
.56743 .26754 L
.56843 .28195 L
.56943 .30866 L
.57043 .33121 L
.57143 .35067 L
.57243 .3716 L
.57343 .39409 L
.57443 .41895 L
.57542 .42742 L
.57642 .43657 L
.57742 .44812 L
Mistroke
.57842 .44878 L
.57942 .45286 L
.58042 .45324 L
.58142 .44986 L
.58242 .44611 L
.58342 .43353 L
.58442 .41396 L
.58541 .40024 L
.58641 .37427 L
.58741 .36391 L
.58841 .34987 L
.58941 .34023 L
.59041 .33218 L
.59141 .32131 L
.59241 .30997 L
.59341 .29505 L
.59441 .28342 L
.5954 .27016 L
.5964 .26373 L
.5974 .26033 L
.5984 .26305 L
.5994 .25285 L
.6004 .25051 L
.6014 .24975 L
.6024 .24822 L
.6034 .24566 L
.6044 .24194 L
.60539 .24284 L
.60639 .24533 L
.60739 .25061 L
.60839 .23981 L
.60939 .23869 L
.61039 .24315 L
.61139 .2454 L
.61239 .24926 L
.61339 .26331 L
.61439 .26044 L
.61538 .26643 L
.61638 .27692 L
.61738 .2768 L
.61838 .29027 L
.61938 .29744 L
.62038 .30201 L
.62138 .30457 L
.62238 .31186 L
.62338 .31134 L
.62438 .31707 L
.62537 .32083 L
.62637 .32433 L
.62737 .32331 L
Mistroke
.62837 .32087 L
.62937 .32291 L
.63037 .32918 L
.63137 .32308 L
.63237 .31611 L
.63337 .31785 L
.63437 .31126 L
.63536 .3091 L
.63636 .30477 L
.63736 .29826 L
.63836 .28741 L
.63936 .27888 L
.64036 .27408 L
.64136 .2701 L
.64236 .27238 L
.64336 .26554 L
.64436 .25972 L
.64535 .25198 L
.64635 .24446 L
.64735 .23757 L
.64835 .23152 L
.64935 .23154 L
.65035 .22297 L
.65135 .21765 L
.65235 .21289 L
.65335 .20856 L
.65435 .20717 L
.65534 .20386 L
.65634 .19895 L
.65734 .18446 L
.65834 .18145 L
.65934 .17492 L
.66034 .17207 L
.66134 .17218 L
.66234 .17486 L
.66334 .17262 L
.66434 .17564 L
.66533 .17669 L
.66633 .18128 L
.66733 .18148 L
.66833 .19396 L
.66933 .20154 L
.67033 .20525 L
.67133 .21227 L
.67233 .21697 L
.67333 .22554 L
.67433 .23021 L
.67532 .23845 L
.67632 .24847 L
.67732 .26117 L
Mistroke
.67832 .26543 L
.67932 .27666 L
.68032 .28606 L
.68132 .30056 L
.68232 .31334 L
.68332 .32748 L
.68432 .33292 L
.68531 .33747 L
.68631 .34625 L
.68731 .35364 L
.68831 .36115 L
.68931 .36601 L
.69031 .37342 L
.69131 .36838 L
.69231 .36019 L
.69331 .36242 L
.69431 .35968 L
.6953 .35456 L
.6963 .35418 L
.6973 .34745 L
.6983 .33932 L
.6993 .3367 L
.7003 .32314 L
.7013 .31779 L
.7023 .30812 L
.7033 .30635 L
.7043 .29529 L
.70529 .28831 L
.70629 .27386 L
.70729 .26583 L
.70829 .26141 L
.70929 .24942 L
.71029 .2409 L
.71129 .23888 L
.71229 .23661 L
.71329 .22849 L
.71429 .22312 L
.71528 .21679 L
.71628 .20281 L
.71728 .20023 L
.71828 .18749 L
.71928 .18533 L
.72028 .17318 L
.72128 .16551 L
.72228 .15172 L
.72328 .14993 L
.72428 .15325 L
.72527 .14634 L
.72627 .13996 L
.72727 .14467 L
Mistroke
.72827 .14267 L
.72927 .14012 L
.73027 .13808 L
.73127 .13322 L
.73227 .126 L
.73327 .11675 L
.73427 .10749 L
.73526 .1033 L
.73626 .09875 L
.73726 .09284 L
.73826 .0954 L
.73926 .09306 L
.74026 .09407 L
.74126 .1036 L
.74226 .10705 L
.74326 .11147 L
.74426 .11127 L
.74525 .11296 L
.74625 .11887 L
.74725 .12629 L
.74825 .13433 L
.74925 .14683 L
.75025 .16233 L
.75125 .17598 L
.75225 .18299 L
.75325 .201 L
.75425 .21648 L
.75524 .24006 L
.75624 .25332 L
.75724 .28976 L
.75824 .31919 L
.75924 .34609 L
.76024 .37058 L
.76124 .39934 L
.76224 .4205 L
.76324 .44813 L
.76424 .462 L
.76523 .47257 L
.76623 .47882 L
.76723 .47548 L
.76823 .4707 L
.76923 .46339 L
.77023 .45168 L
.77123 .43905 L
.77223 .42986 L
.77323 .41633 L
.77423 .40679 L
.77522 .39081 L
.77622 .37655 L
.77722 .36375 L
Mistroke
.77822 .34748 L
.77922 .32516 L
.78022 .31475 L
.78122 .3067 L
.78222 .29782 L
.78322 .2958 L
.78422 .28843 L
.78521 .2828 L
.78621 .28009 L
.78721 .27962 L
.78821 .274 L
.78921 .27127 L
.79021 .26605 L
.79121 .26697 L
.79221 .26705 L
.79321 .27127 L
.79421 .27539 L
.7952 .26976 L
.7962 .27393 L
.7972 .27351 L
.7982 .2763 L
.7992 .28483 L
.8002 .28755 L
.8012 .28531 L
.8022 .29432 L
.8032 .28972 L
.8042 .29499 L
.80519 .29402 L
.80619 .29526 L
.80719 .2944 L
.80819 .28791 L
.80919 .28173 L
.81019 .27977 L
.81119 .28336 L
.81219 .27965 L
.81319 .2719 L
.81419 .26376 L
.81518 .26334 L
.81618 .25845 L
.81718 .2587 L
.81818 .26334 L
.81918 .25864 L
.82018 .26401 L
.82118 .25655 L
.82218 .25593 L
.82318 .25695 L
.82418 .25909 L
.82517 .26186 L
.82617 .25547 L
.82717 .24759 L
Mistroke
.82817 .24776 L
.82917 .24311 L
.83017 .2472 L
.83117 .24026 L
.83217 .24061 L
.83317 .24274 L
.83417 .24066 L
.83516 .2441 L
.83616 .24798 L
.83716 .25221 L
.83816 .25708 L
.83916 .2645 L
.84016 .26843 L
.84116 .27355 L
.84216 .27321 L
.84316 .27312 L
.84416 .27581 L
.84515 .2833 L
.84615 .29239 L
.84715 .29771 L
.84815 .30956 L
.84915 .31364 L
.85015 .32107 L
.85115 .33064 L
.85215 .33398 L
.85315 .33465 L
.85415 .33181 L
.85514 .328 L
.85614 .32534 L
.85714 .31949 L
.85814 .32534 L
.85914 .32711 L
.86014 .32792 L
.86114 .31398 L
.86214 .30984 L
.86314 .30698 L
.86414 .302 L
.86513 .29663 L
.86613 .28815 L
.86713 .28747 L
.86813 .28633 L
.86913 .28223 L
.87013 .27533 L
.87113 .27652 L
.87213 .26806 L
.87313 .25836 L
.87413 .25199 L
.87512 .24988 L
.87612 .24652 L
.87712 .23994 L
Mistroke
.87812 .24568 L
.87912 .23439 L
.88012 .23214 L
.88112 .22385 L
.88212 .21574 L
.88312 .20983 L
.88412 .21244 L
.88511 .20755 L
.88611 .20003 L
.88711 .19136 L
.88811 .18724 L
.88911 .18496 L
.89011 .18019 L
.89111 .17926 L
.89211 .17771 L
.89311 .17091 L
.89411 .16735 L
.8951 .16767 L
.8961 .1604 L
.8971 .1542 L
.8981 .15895 L
.8991 .1608 L
.9001 .16851 L
.9011 .17283 L
.9021 .18427 L
.9031 .19408 L
.9041 .19985 L
.90509 .21189 L
.90609 .22113 L
.90709 .22621 L
.90809 .2443 L
.90909 .26021 L
.91009 .279 L
.91109 .2974 L
.91209 .31673 L
.91309 .33231 L
.91409 .34616 L
.91508 .36625 L
.91608 .37598 L
.91708 .38838 L
.91808 .40331 L
.91908 .40689 L
.92008 .40512 L
.92108 .40149 L
.92208 .39676 L
.92308 .39139 L
.92408 .38888 L
.92507 .37832 L
.92607 .36816 L
.92707 .3507 L
Mistroke
.92807 .33889 L
.92907 .32314 L
.93007 .31918 L
.93107 .31841 L
.93207 .30452 L
.93307 .28945 L
.93407 .28582 L
.93506 .2782 L
.93606 .26896 L
.93706 .26706 L
.93806 .25603 L
.93906 .25278 L
.94006 .24996 L
.94106 .24484 L
.94206 .23632 L
.94306 .2265 L
.94406 .22075 L
.94505 .22295 L
.94605 .21344 L
.94705 .21019 L
.94805 .2012 L
.94905 .20287 L
.95005 .19793 L
.95105 .1878 L
.95205 .18223 L
.95305 .17756 L
.95405 .17369 L
.95504 .17698 L
.95604 .17506 L
.95704 .17636 L
.95804 .17451 L
.95904 .16968 L
.96004 .17165 L
.96104 .17923 L
.96204 .17332 L
.96304 .17858 L
.96404 .1767 L
.96503 .1793 L
.96603 .18525 L
.96703 .18772 L
.96803 .18606 L
.96903 .18928 L
.97003 .20092 L
.97103 .20628 L
.97203 .21231 L
.97303 .22658 L
.97403 .24744 L
.97502 .25857 L
.97602 .27084 L
.97702 .28966 L
Mistroke
.97802 .30511 L
.97902 .31787 L
.98002 .33407 L
.98102 .34729 L
.98202 .35322 L
.98302 .36394 L
.98402 .37551 L
.98501 .38469 L
.98601 .38541 L
.98701 .39029 L
.98801 .38997 L
.98901 .38975 L
.99001 .37883 L
.99101 .36956 L
.99201 .35783 L
.99301 .34575 L
.99401 .33825 L
.995 .32685 L
.996 .31754 L
.997 .30582 L
.998 .29526 L
.999 .28788 L
Mfstroke
0 .98 .604 r
gsave
.999 .27876 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
.04911 0 m
.04995 .38746 L
.05095 .4294 L
.05195 .46561 L
.05295 .49381 L
.05395 .51137 L
.05495 .516 L
.05594 .50595 L
.05694 .48024 L
.05794 .43879 L
.05894 .38248 L
.05994 .31323 L
.06094 .23399 L
.06194 .14872 L
.06294 .0623 L
s
.06294 .0623 m
.0637 0 L
s
.07111 0 m
.07193 .09081 L
.07293 .22122 L
.07393 .36326 L
.07493 .50754 L
s
.07493 .50754 m
.07573 .61803 L
s
.08333 .61803 m
.08392 .51331 L
.08492 .29383 L
.08591 .0422 L
s
.08591 .0422 m
.08607 0 L
s
.09791 0 m
.0989 .44864 L
.0999 .2211 L
.1009 .20784 L
.1019 .19586 L
.1029 .18468 L
.1039 .17412 L
.1049 .16413 L
.10589 .15466 L
.10689 .14567 L
.10789 .13714 L
.10889 .12907 L
.10989 .12142 L
.11089 .11419 L
.11189 .10737 L
.11289 .10094 L
.11389 .09489 L
.11489 .08923 L
.11588 .08393 L
.11688 .07899 L
.11788 .0744 L
.11888 .07017 L
.11988 .06627 L
.12088 .06271 L
.12188 .05948 L
.12288 .05658 L
.12388 .054 L
.12488 .05174 L
.12587 .0498 L
.12687 .04816 L
.12787 .04684 L
.12887 .04581 L
.12987 .0451 L
.13087 .04468 L
.13187 .04456 L
.13287 .04473 L
.13387 .0452 L
.13487 .04596 L
.13586 .04702 L
.13686 .04836 L
.13786 .04999 L
.13886 .0519 L
.13986 .05411 L
.14086 .0566 L
.14186 .05938 L
.14286 .06246 L
.14386 .06582 L
.14486 .06949 L
.14585 .07346 L
.14685 .07773 L
Mistroke
.14785 .08232 L
.14885 .08723 L
.14985 .39407 L
.15085 .4053 L
.15185 .41582 L
.15285 .4248 L
.15385 .43181 L
.15485 .43656 L
.15584 .43884 L
.15684 .43851 L
.15784 .43549 L
.15884 .42977 L
.15984 .4214 L
.16084 .41051 L
.16184 .39731 L
.16284 .38205 L
.16384 .36507 L
.16484 .34675 L
.16583 .32752 L
.16683 .30786 L
.16783 .28826 L
.16883 .26924 L
.16983 .25132 L
.17083 .23499 L
.17183 .22074 L
.17283 .209 L
.17383 .20016 L
.17483 .19454 L
.17582 .19236 L
.17682 .1938 L
.17782 .1989 L
.17882 .20765 L
.17982 .21991 L
.18082 .23545 L
.18182 .25396 L
.18282 .27502 L
.18382 .29814 L
.18482 .32277 L
.18581 .34828 L
.18681 .37402 L
.18781 .39927 L
.18881 .42333 L
.18981 .44548 L
.19081 .465 L
.19181 .48125 L
.19281 .49362 L
.19381 .50156 L
.19481 .50463 L
.1958 .50252 L
.1968 .495 L
Mistroke
.1978 .482 L
.1988 .4636 L
.1998 .16961 L
.2008 .17735 L
.2018 .18755 L
.2028 .19958 L
.2038 .21326 L
.2048 .22848 L
.20579 .24516 L
.20679 .26325 L
.20779 .28269 L
.20879 .30342 L
.20979 .32538 L
.21079 .34848 L
.21179 .37264 L
.21279 .39777 L
.21379 .42375 L
.21479 .45044 L
.21578 .47772 L
.21678 .50541 L
.21778 .53334 L
.21878 .56132 L
.21978 .58912 L
.22078 .61653 L
Mfstroke
.22078 .61653 m
.22084 .61803 L
s
.23988 .61803 m
.24076 .57013 L
.24176 .50688 L
.24276 .43462 L
.24376 .35292 L
.24476 .26137 L
.24575 .15959 L
.24675 .04722 L
s
.24675 .04722 m
.24714 0 L
s
.24923 0 m
.24975 .22919 L
.25075 .23255 L
.25175 .23732 L
.25275 .24289 L
.25375 .24905 L
.25475 .25569 L
.25574 .26274 L
.25674 .27012 L
.25774 .2778 L
.25874 .28573 L
.25974 .29385 L
.26074 .30213 L
.26174 .31052 L
.26274 .31897 L
.26374 .32744 L
.26474 .33588 L
.26573 .34425 L
.26673 .35248 L
.26773 .36053 L
.26873 .36834 L
.26973 .37587 L
.27073 .38304 L
.27173 .3898 L
.27273 .3961 L
.27373 .40188 L
.27473 .40706 L
.27572 .41159 L
.27672 .41541 L
.27772 .41845 L
.27872 .42064 L
.27972 .42194 L
.28072 .42226 L
.28172 .42156 L
.28272 .41976 L
.28372 .41681 L
.28472 .41265 L
.28571 .40722 L
.28671 .40046 L
.28771 .39233 L
.28871 .38276 L
.28971 .37172 L
.29071 .35916 L
.29171 .34503 L
.29271 .32929 L
.29371 .31193 L
.29471 .29289 L
.2957 .27217 L
.2967 .24973 L
.2977 .22557 L
Mistroke
.2987 .19967 L
.2997 .23761 L
.3007 .23632 L
.3017 .23619 L
.3027 .2366 L
.3037 .23737 L
.3047 .23841 L
.30569 .23965 L
.30669 .24107 L
.30769 .24265 L
.30869 .24435 L
.30969 .24616 L
.31069 .24808 L
.31169 .25009 L
.31269 .25218 L
.31369 .25433 L
.31469 .25655 L
.31568 .25882 L
.31668 .26113 L
.31768 .26347 L
.31868 .26583 L
.31968 .26821 L
.32068 .2706 L
.32168 .27299 L
.32268 .27536 L
.32368 .27772 L
.32468 .28005 L
.32567 .28234 L
.32667 .28458 L
.32767 .28676 L
.32867 .28889 L
.32967 .29093 L
.33067 .29289 L
.33167 .29476 L
.33267 .29653 L
.33367 .29817 L
.33467 .2997 L
.33566 .30109 L
.33666 .30233 L
.33766 .30342 L
.33866 .30434 L
.33966 .30509 L
.34066 .30565 L
.34166 .30601 L
.34266 .30616 L
.34366 .30609 L
.34466 .30578 L
.34565 .30524 L
.34665 .30444 L
.34765 .30338 L
Mistroke
.34865 .30204 L
.34965 .36222 L
.35065 .36693 L
.35165 .37169 L
.35265 .37578 L
.35365 .37892 L
.35465 .38095 L
.35564 .38176 L
.35664 .38129 L
.35764 .37949 L
.35864 .37634 L
.35964 .37187 L
.36064 .3661 L
.36164 .3591 L
.36264 .35093 L
.36364 .3417 L
.36464 .33153 L
.36563 .32055 L
.36663 .3089 L
.36763 .29676 L
.36863 .28429 L
.36963 .27168 L
.37063 .25911 L
.37163 .24678 L
.37263 .23487 L
.37363 .22358 L
.37463 .21308 L
.37562 .20355 L
.37662 .19514 L
.37762 .18802 L
.37862 .1823 L
.37962 .17809 L
.38062 .17549 L
.38162 .17455 L
.38262 .17533 L
.38362 .17782 L
.38462 .18202 L
.38561 .18788 L
.38661 .19533 L
.38761 .20427 L
.38861 .21458 L
.38961 .22609 L
.39061 .23864 L
.39161 .25203 L
.39261 .26603 L
.39361 .28043 L
.39461 .29497 L
.3956 .30941 L
.3966 .32349 L
.3976 .33696 L
Mistroke
.3986 .34955 L
.3996 .11605 L
.4006 .11394 L
.4016 .11322 L
.4026 .11326 L
.4036 .11386 L
.4046 .11495 L
.40559 .11646 L
.40659 .11837 L
.40759 .12066 L
.40859 .1233 L
.40959 .12631 L
.41059 .12965 L
.41159 .13334 L
.41259 .13737 L
.41359 .14173 L
.41459 .14644 L
.41558 .15148 L
.41658 .15687 L
.41758 .16261 L
.41858 .16871 L
.41958 .17518 L
.42058 .18203 L
.42158 .18928 L
.42258 .19693 L
.42358 .20501 L
.42458 .21353 L
.42557 .22252 L
.42657 .23198 L
.42757 .24196 L
.42857 .25246 L
.42957 .26351 L
.43057 .27513 L
.43157 .28736 L
.43257 .30022 L
.43357 .31374 L
.43457 .32795 L
.43556 .34287 L
.43656 .35855 L
.43756 .37501 L
.43856 .39229 L
.43956 .41042 L
.44056 .42944 L
.44156 .44939 L
.44256 .4703 L
.44356 .49223 L
.44456 .5152 L
.44555 .53927 L
.44655 .56448 L
.44755 .59087 L
Mistroke
Mfstroke
.44755 .59087 m
.44853 .61803 L
s
.44855 .61803 m
.44955 .30192 L
.45055 .30046 L
.45155 .30018 L
.45255 .30045 L
.45355 .30107 L
.45455 .30193 L
.45554 .30298 L
.45654 .30418 L
.45754 .3055 L
.45854 .3069 L
.45954 .30839 L
.46054 .30993 L
.46154 .31152 L
.46254 .31314 L
.46354 .31478 L
.46454 .31644 L
.46553 .3181 L
.46653 .31975 L
.46753 .32139 L
.46853 .32301 L
.46953 .3246 L
.47053 .32615 L
.47153 .32765 L
.47253 .32911 L
.47353 .33051 L
.47453 .33185 L
.47552 .33312 L
.47652 .33431 L
.47752 .33542 L
.47852 .33644 L
.47952 .33738 L
.48052 .33821 L
.48152 .33894 L
.48252 .33957 L
.48352 .34008 L
.48452 .34047 L
.48551 .34075 L
.48651 .34089 L
.48751 .34091 L
.48851 .34079 L
.48951 .34054 L
.49051 .34014 L
.49151 .3396 L
.49251 .33891 L
.49351 .33807 L
.49451 .33707 L
.4955 .33591 L
.4965 .3346 L
.4975 .33312 L
Mistroke
.4985 .33147 L
.4995 .38239 L
.5005 .38865 L
.5015 .39407 L
.5025 .39784 L
.5035 .39964 L
.5045 .39929 L
.50549 .39671 L
.50649 .39186 L
.50749 .3848 L
.50849 .37563 L
.50949 .36451 L
.51049 .35165 L
.51149 .33729 L
.51249 .32176 L
.51349 .30536 L
.51449 .28848 L
.51548 .27148 L
.51648 .25477 L
.51748 .23872 L
.51848 .22374 L
.51948 .2102 L
.52048 .19843 L
.52148 .18874 L
.52248 .18141 L
.52348 .17665 L
.52448 .17462 L
.52547 .17542 L
.52647 .17908 L
.52747 .18558 L
.52847 .1948 L
.52947 .20658 L
.53047 .22069 L
.53147 .23682 L
.53247 .25463 L
.53347 .27371 L
.53447 .29363 L
.53546 .31391 L
.53646 .33407 L
.53746 .35359 L
.53846 .37198 L
.53946 .38875 L
.54046 .40344 L
.54146 .41562 L
.54246 .42491 L
.54346 .431 L
.54446 .43363 L
.54545 .43262 L
.54645 .42788 L
.54745 .41939 L
Mistroke
.54845 .40724 L
.54945 .12769 L
.55045 .12575 L
.55145 .12526 L
.55245 .12559 L
.55345 .12653 L
.55445 .12799 L
.55544 .12993 L
.55644 .13232 L
.55744 .13515 L
.55844 .13839 L
.55944 .14205 L
.56044 .14613 L
.56144 .15063 L
.56244 .15555 L
.56344 .16091 L
.56444 .16671 L
.56543 .17296 L
.56643 .17968 L
.56743 .18689 L
.56843 .1946 L
.56943 .20283 L
.57043 .2116 L
.57143 .22094 L
.57243 .23087 L
.57343 .24141 L
.57443 .2526 L
.57542 .26446 L
.57642 .27701 L
.57742 .2903 L
.57842 .30435 L
.57942 .3192 L
.58042 .33489 L
.58142 .35144 L
.58242 .36889 L
.58342 .3873 L
.58442 .40668 L
.58541 .4271 L
.58641 .44859 L
.58741 .47119 L
.58841 .49496 L
.58941 .51994 L
.59041 .54618 L
.59141 .57373 L
.59241 .60265 L
Mfstroke
.59241 .60265 m
.59291 .61803 L
s
.59874 .61803 m
.5994 .24723 L
.6004 .24446 L
.6014 .2429 L
.6024 .24192 L
.6034 .24131 L
.6044 .24098 L
.60539 .24088 L
.60639 .24096 L
.60739 .24119 L
.60839 .24156 L
.60939 .24206 L
.61039 .24266 L
.61139 .24336 L
.61239 .24415 L
.61339 .24503 L
.61439 .24599 L
.61538 .24701 L
.61638 .24811 L
.61738 .24927 L
.61838 .25048 L
.61938 .25175 L
.62038 .25308 L
.62138 .25445 L
.62238 .25586 L
.62338 .25732 L
.62438 .25882 L
.62537 .26035 L
.62637 .26192 L
.62737 .26351 L
.62837 .26514 L
.62937 .26679 L
.63037 .26847 L
.63137 .27017 L
.63237 .27188 L
.63337 .27361 L
.63437 .27535 L
.63536 .27711 L
.63636 .27887 L
.63736 .28064 L
.63836 .2824 L
.63936 .28417 L
.64036 .28593 L
.64136 .28769 L
.64236 .28944 L
.64336 .29117 L
.64436 .29289 L
.64535 .29459 L
.64635 .29626 L
.64735 .29791 L
Mistroke
.64835 .29953 L
.64935 .22711 L
.65035 .22399 L
.65135 .22206 L
.65235 .22069 L
.65335 .21969 L
.65435 .21894 L
.65534 .21841 L
.65634 .21805 L
.65734 .21784 L
.65834 .21776 L
.65934 .21779 L
.66034 .21793 L
.66134 .21817 L
.66234 .21849 L
.66334 .21889 L
.66434 .21936 L
.66533 .2199 L
.66633 .2205 L
.66733 .22116 L
.66833 .22187 L
.66933 .22263 L
.67033 .22344 L
.67133 .22429 L
.67233 .22518 L
.67333 .22611 L
.67433 .22707 L
.67532 .22806 L
.67632 .22909 L
.67732 .23014 L
.67832 .23121 L
.67932 .23231 L
.68032 .23343 L
.68132 .23456 L
.68232 .23572 L
.68332 .23689 L
.68432 .23807 L
.68531 .23927 L
.68631 .24047 L
.68731 .24168 L
.68831 .2429 L
.68931 .24413 L
.69031 .24536 L
.69131 .24658 L
.69231 .24781 L
.69331 .24904 L
.69431 .25026 L
.6953 .25147 L
.6963 .25267 L
.6973 .25387 L
Mistroke
.6983 .25505 L
.6993 .33206 L
.7003 .32796 L
.7013 .3248 L
.7023 .32197 L
.7033 .31929 L
.7043 .31666 L
.70529 .31405 L
.70629 .31143 L
.70729 .30878 L
.70829 .30612 L
.70929 .30343 L
.71029 .30071 L
.71129 .29797 L
.71229 .29522 L
.71329 .29246 L
.71429 .28971 L
.71528 .28696 L
.71628 .28423 L
.71728 .28152 L
.71828 .27885 L
.71928 .27623 L
.72028 .27366 L
.72128 .27115 L
.72228 .26872 L
.72328 .26636 L
.72428 .2641 L
.72527 .26192 L
.72627 .25985 L
.72727 .25789 L
.72827 .25605 L
.72927 .25432 L
.73027 .25272 L
.73127 .25125 L
.73227 .24991 L
.73327 .2487 L
.73427 .24763 L
.73526 .2467 L
.73626 .24591 L
.73726 .24526 L
.73826 .24476 L
.73926 .24438 L
.74026 .24415 L
.74126 .24405 L
.74226 .24408 L
.74326 .24424 L
.74426 .24453 L
.74525 .24493 L
.74625 .24545 L
.74725 .24608 L
Mistroke
.74825 .24682 L
.74925 .13879 L
.75025 .14911 L
.75125 .1618 L
.75225 .17611 L
.75325 .19173 L
.75425 .20845 L
.75524 .22613 L
.75624 .24462 L
.75724 .26378 L
.75824 .2835 L
.75924 .30363 L
.76024 .32406 L
.76124 .34463 L
.76224 .3652 L
.76324 .38562 L
.76424 .40573 L
.76523 .42535 L
.76623 .44432 L
.76723 .46245 L
.76823 .47955 L
.76923 .49545 L
.77023 .50993 L
.77123 .52282 L
.77223 .53392 L
.77323 .54303 L
.77423 .54996 L
.77522 .55453 L
.77622 .55656 L
.77722 .55587 L
.77822 .55228 L
.77922 .54565 L
.78022 .53583 L
.78122 .52268 L
.78222 .50608 L
.78322 .48591 L
.78422 .46209 L
.78521 .43453 L
.78621 .40316 L
.78721 .36796 L
.78821 .32888 L
.78921 .28591 L
.79021 .23908 L
.79121 .18842 L
.79221 .134 L
.79321 .0759 L
.79421 .01426 L
Mfstroke
.79421 .01426 m
.79442 0 L
s
.79869 0 m
.7992 .27587 L
.8002 .27856 L
.8012 .28237 L
.8022 .28663 L
.8032 .29108 L
.8042 .2956 L
.80519 .30007 L
.80619 .30445 L
.80719 .30866 L
.80819 .31266 L
.80919 .31642 L
.81019 .31989 L
.81119 .32306 L
.81219 .32589 L
.81319 .32835 L
.81419 .33043 L
.81518 .33212 L
.81618 .33338 L
.81718 .33422 L
.81818 .33461 L
.81918 .33456 L
.82018 .33404 L
.82118 .33306 L
.82218 .33161 L
.82318 .32969 L
.82418 .3273 L
.82517 .32444 L
.82617 .32112 L
.82717 .31735 L
.82817 .31312 L
.82917 .30846 L
.83017 .30337 L
.83117 .29787 L
.83217 .29197 L
.83317 .28568 L
.83417 .27903 L
.83516 .27203 L
.83616 .26471 L
.83716 .25709 L
.83816 .24919 L
.83916 .24103 L
.84016 .23264 L
.84116 .22405 L
.84216 .21528 L
.84316 .20636 L
.84416 .19733 L
.84515 .18821 L
.84615 .17904 L
.84715 .16986 L
Mistroke
.84815 .16069 L
.84915 .30753 L
.85015 .31466 L
.85115 .32252 L
.85215 .33033 L
.85315 .33775 L
.85415 .34456 L
.85514 .35059 L
.85614 .3557 L
.85714 .35979 L
.85814 .36276 L
.85914 .36456 L
.86014 .36511 L
.86114 .3644 L
.86214 .3624 L
.86314 .35912 L
.86414 .35455 L
.86513 .34875 L
.86613 .34174 L
.86713 .3336 L
.86813 .32439 L
.86913 .31421 L
.87013 .30314 L
.87113 .2913 L
.87213 .27881 L
.87313 .2658 L
.87413 .25239 L
.87512 .23874 L
.87612 .22498 L
.87712 .21126 L
.87812 .19774 L
.87912 .18456 L
.88012 .17188 L
.88112 .15985 L
.88212 .1486 L
.88312 .13828 L
.88412 .12903 L
.88511 .12096 L
.88611 .11419 L
.88711 .10881 L
.88811 .10491 L
.88911 .10257 L
.89011 .10181 L
.89111 .10269 L
.89211 .10519 L
.89311 .10931 L
.89411 .11501 L
.8951 .12224 L
.8961 .1309 L
.8971 .1409 L
Mistroke
.8981 .15211 L
.8991 .15075 L
.9001 .15444 L
.9011 .15991 L
.9021 .16644 L
.9031 .17378 L
.9041 .18176 L
.90509 .19027 L
.90609 .19922 L
.90709 .20853 L
.90809 .21814 L
.90909 .22797 L
.91009 .23798 L
.91109 .24811 L
.91209 .25832 L
.91309 .26855 L
.91409 .27876 L
.91508 .2889 L
.91608 .29893 L
.91708 .3088 L
.91808 .31847 L
.91908 .32789 L
.92008 .33702 L
.92108 .3458 L
.92208 .3542 L
.92308 .36216 L
.92408 .36965 L
.92507 .37662 L
.92607 .38302 L
.92707 .38882 L
.92807 .39397 L
.92907 .39842 L
.93007 .40215 L
.93107 .40511 L
.93207 .40727 L
.93307 .40858 L
.93407 .40903 L
.93506 .40858 L
.93606 .40719 L
.93706 .40485 L
.93806 .40153 L
.93906 .39721 L
.94006 .39186 L
.94106 .38548 L
.94206 .37805 L
.94306 .36956 L
.94406 .36 L
.94505 .34937 L
.94605 .33765 L
.94705 .32485 L
Mistroke
.94805 .31098 L
.94905 .19888 L
.95005 .19516 L
.95105 .19264 L
.95205 .19069 L
.95305 .18911 L
.95405 .18779 L
.95504 .18669 L
.95604 .18576 L
.95704 .18497 L
.95804 .1843 L
.95904 .18373 L
.96004 .18326 L
.96104 .18286 L
.96204 .18253 L
.96304 .18225 L
.96404 .18203 L
.96503 .18185 L
.96603 .1817 L
.96703 .18159 L
.96803 .1815 L
.96903 .18143 L
.97003 .18138 L
.97103 .18134 L
.97203 .18131 L
.97303 .1813 L
.97403 .18128 L
.97502 .18128 L
.97602 .18127 L
.97702 .18127 L
.97802 .18127 L
.97902 .18127 L
.98002 .18127 L
.98102 .18127 L
.98202 .18127 L
.98302 .18127 L
.98402 .18126 L
.98501 .18126 L
.98601 .18125 L
.98701 .18125 L
.98801 .18124 L
.98901 .18124 L
.99001 .18123 L
.99101 .18122 L
.99201 .18122 L
.99301 .18122 L
.99401 .18121 L
.995 .18121 L
.996 .18122 L
.997 .18122 L
Mistroke
.998 .18123 L
.999 .27876 L
Mfstroke
gsave
.999 .29149 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00817 m
.001 .01189 L
.002 .01437 L
.003 .01628 L
.004 .01785 L
.005 .01917 L
.00599 .02032 L
.00699 .02132 L
.00799 .02221 L
.00899 .023 L
.00999 .02372 L
.01099 .02437 L
.01199 .02497 L
.01299 .02552 L
.01399 .02603 L
.01499 .02651 L
.01598 .02697 L
.01698 .02741 L
.01798 .02784 L
.01898 .02827 L
.01998 .0287 L
.02098 .02914 L
.02198 .0296 L
.02298 .03009 L
.02398 .03062 L
.02498 .03121 L
.02597 .03187 L
.02697 .03263 L
.02797 .03349 L
.02897 .0345 L
.02997 .03567 L
.03097 .03705 L
.03197 .03869 L
.03297 .04061 L
.03397 .04288 L
.03497 .04556 L
.03596 .0487 L
.03696 .05238 L
.03796 .05667 L
.03896 .06131 L
.03996 .06619 L
.04096 .07155 L
.04196 .07756 L
.04296 .08405 L
.04396 .09096 L
.04496 .09836 L
.04595 .10628 L
.04695 .11476 L
.04795 .12384 L
.04895 .13343 L
Mistroke
.04995 .39997 L
.05095 .45525 L
.05195 .50643 L
.05295 .54939 L
.05395 .58076 L
.05495 .59768 L
.05594 .59803 L
.05694 .58068 L
.05794 .5456 L
.05894 .49405 L
.05994 .42857 L
.06094 .3529 L
.06194 .27181 L
.06294 .19074 L
.06394 .11545 L
.06494 .05162 L
.06593 .00457 L
Mfstroke
.06593 .00457 m
.06611 0 L
s
.06873 0 m
.06893 .00537 L
.06993 .06093 L
.07093 .1445 L
.07193 .2539 L
.07293 .38525 L
.07393 .53289 L
s
.07393 .53289 m
.07447 .61803 L
s
.08503 .61803 m
.08591 .4012 L
.08691 .14268 L
s
.08691 .14268 m
.08747 0 L
s
.09647 0 m
.0969 .15489 L
.0979 .57619 L
s
.0979 .57619 m
.09799 .61803 L
s
.09943 .61803 m
.0999 .2338 L
.1009 .2292 L
.1019 .22412 L
.1029 .21905 L
.1039 .21412 L
.1049 .20939 L
.10589 .20487 L
.10689 .20058 L
.10789 .19654 L
.10889 .19273 L
.10989 .18916 L
.11089 .18584 L
.11189 .18276 L
.11289 .17993 L
.11389 .17735 L
.11489 .17501 L
.11588 .17292 L
.11688 .17108 L
.11788 .1695 L
.11888 .16817 L
.11988 .16711 L
.12088 .16631 L
.12188 .16578 L
.12288 .16554 L
.12388 .16557 L
.12488 .16591 L
.12587 .16655 L
.12687 .1675 L
.12787 .16878 L
.12887 .1704 L
.12987 .17238 L
.13087 .17473 L
.13187 .17746 L
.13287 .1806 L
.13387 .18417 L
.13487 .18818 L
.13586 .19267 L
.13686 .19765 L
.13786 .20315 L
.13886 .20921 L
.13986 .21585 L
.14086 .2231 L
.14186 .231 L
.14286 .23958 L
.14386 .24888 L
.14486 .25894 L
.14585 .26979 L
.14685 .28149 L
.14785 .29408 L
Mistroke
.14885 .3076 L
.14985 .40679 L
.15085 .42702 L
.15185 .44476 L
.15285 .4603 L
.15385 .47354 L
.15485 .48433 L
.15584 .49252 L
.15684 .49799 L
.15784 .50067 L
.15884 .50055 L
.15984 .49766 L
.16084 .49212 L
.16184 .48409 L
.16284 .47381 L
.16384 .46156 L
.16484 .44771 L
.16583 .43265 L
.16683 .41681 L
.16783 .40068 L
.16883 .38475 L
.16983 .36953 L
.17083 .35552 L
.17183 .34321 L
.17283 .33306 L
.17383 .3255 L
.17483 .3209 L
.17582 .31956 L
.17682 .32171 L
.17782 .32749 L
.17882 .33695 L
.17982 .35004 L
.18082 .3666 L
.18182 .38639 L
.18282 .40904 L
.18382 .43411 L
.18482 .46103 L
.18581 .48922 L
.18681 .51798 L
.18781 .5466 L
.18881 .57435 L
.18981 .60049 L
Mfstroke
.18981 .60049 m
.19055 .61803 L
s
.1989 .61803 m
.1998 .18232 L
.2008 .19819 L
.2018 .21462 L
.2028 .2323 L
.2038 .25148 L
.2048 .27232 L
.20579 .29488 L
.20679 .31922 L
.20779 .34538 L
.20879 .37335 L
.20979 .40311 L
.21079 .43463 L
.21179 .46785 L
.21279 .50269 L
.21379 .53904 L
.21479 .57678 L
.21578 .61576 L
s
.21578 .61576 m
.21584 .61803 L
s
.24703 .61803 m
.24775 .53939 L
.24875 .42175 L
.24975 .24194 L
.25075 .25332 L
.25175 .26415 L
.25275 .27501 L
.25375 .2861 L
.25475 .29749 L
.25574 .30923 L
.25674 .32133 L
.25774 .33379 L
.25874 .34661 L
.25974 .35977 L
.26074 .37324 L
.26174 .38699 L
.26274 .401 L
.26374 .41521 L
.26474 .42959 L
.26573 .44408 L
.26673 .45863 L
.26773 .47319 L
.26873 .48769 L
.26973 .50206 L
.27073 .51625 L
.27173 .53018 L
.27273 .54378 L
.27373 .55696 L
.27473 .56967 L
.27572 .58181 L
.27672 .5933 L
.27772 .60407 L
.27872 .61404 L
s
.27872 .61404 m
.27916 .61803 L
s
.29352 .61803 m
.29371 .6161 L
.29471 .60375 L
.2957 .58965 L
.2967 .57381 L
.2977 .55624 L
.2987 .53696 L
.2997 .25035 L
.3007 .25703 L
.3017 .26277 L
.3027 .26818 L
.3037 .27345 L
.3047 .27867 L
.30569 .28389 L
.30669 .28915 L
.30769 .29446 L
.30869 .29985 L
.30969 .30531 L
.31069 .31087 L
.31169 .31652 L
.31269 .32227 L
.31369 .32813 L
.31469 .33409 L
.31568 .34016 L
.31668 .34633 L
.31768 .3526 L
.31868 .35898 L
.31968 .36546 L
.32068 .37203 L
.32168 .3787 L
.32268 .38545 L
.32368 .39229 L
.32468 .39921 L
.32567 .40619 L
.32667 .41325 L
.32767 .42036 L
.32867 .42752 L
.32967 .43473 L
.33067 .44197 L
.33167 .44923 L
.33267 .45651 L
.33367 .46379 L
.33467 .47107 L
.33566 .47833 L
.33666 .48556 L
.33766 .49275 L
.33866 .49989 L
.33966 .50697 L
.34066 .51397 L
.34166 .52088 L
Mistroke
.34266 .52768 L
.34366 .53436 L
.34466 .54091 L
.34565 .54732 L
.34665 .55356 L
.34765 .55963 L
.34865 .56551 L
.34965 .37495 L
.35065 .38775 L
.35165 .39859 L
.35265 .40795 L
.35365 .41593 L
.35465 .42252 L
.35564 .4277 L
.35664 .43143 L
.35764 .43372 L
.35864 .43454 L
.35964 .43392 L
.36064 .43188 L
.36164 .42849 L
.36264 .42381 L
.36364 .41794 L
.36464 .411 L
.36563 .40311 L
.36663 .39443 L
.36763 .38512 L
.36863 .37536 L
.36963 .36533 L
.37063 .35522 L
.37163 .34524 L
.37263 .33558 L
.37363 .32644 L
.37463 .31802 L
.37562 .31048 L
.37662 .30401 L
.37762 .29876 L
.37862 .29486 L
.37962 .29243 L
.38062 .29157 L
.38162 .29234 L
.38262 .29479 L
.38362 .29894 L
.38462 .30477 L
.38561 .31225 L
.38661 .3213 L
.38761 .33184 L
.38861 .34375 L
.38961 .35688 L
.39061 .37106 L
.39161 .38612 L
Mistroke
.39261 .40184 L
.39361 .41802 L
.39461 .43441 L
.3956 .45079 L
.3966 .4669 L
.3976 .48252 L
.3986 .49738 L
.3996 .12875 L
.4006 .13452 L
.4016 .13947 L
.4026 .14423 L
.4036 .14904 L
.4046 .154 L
.40559 .15921 L
.40659 .16471 L
.40759 .17056 L
.40859 .17681 L
.40959 .18352 L
.41059 .19071 L
.41159 .19845 L
.41259 .20677 L
.41359 .21572 L
.41459 .22535 L
.41558 .23569 L
.41658 .24681 L
.41758 .25874 L
.41858 .27153 L
.41958 .28523 L
.42058 .29989 L
.42158 .31556 L
.42258 .33229 L
.42358 .35013 L
.42458 .36913 L
.42557 .38935 L
.42657 .41083 L
.42757 .43365 L
.42857 .45786 L
.42957 .48352 L
.43057 .51069 L
.43157 .53945 L
.43257 .56985 L
.43357 .60197 L
Mfstroke
.43357 .60197 m
.43404 .61803 L
s
.44926 .61803 m
.44955 .31466 L
.45055 .32118 L
.45155 .32679 L
.45255 .33208 L
.45355 .33725 L
.45455 .34238 L
.45554 .34751 L
.45654 .35266 L
.45754 .35786 L
.45854 .36309 L
.45954 .36837 L
.46054 .37369 L
.46154 .37905 L
.46254 .38445 L
.46354 .38987 L
.46454 .39532 L
.46553 .40078 L
.46653 .40625 L
.46753 .41172 L
.46853 .41718 L
.46953 .42263 L
.47053 .42805 L
.47153 .43343 L
.47253 .43877 L
.47353 .44406 L
.47453 .44928 L
.47552 .45444 L
.47652 .45951 L
.47752 .4645 L
.47852 .46939 L
.47952 .47417 L
.48052 .47884 L
.48152 .48338 L
.48252 .48779 L
.48352 .49206 L
.48452 .49619 L
.48551 .50015 L
.48651 .50395 L
.48751 .50758 L
.48851 .51103 L
.48951 .5143 L
.49051 .51737 L
.49151 .52024 L
.49251 .52291 L
.49351 .52537 L
.49451 .52761 L
.4955 .52962 L
.4965 .53142 L
.4975 .53298 L
Mistroke
.4985 .53431 L
.4995 .39511 L
.5005 .40944 L
.5015 .42086 L
.5025 .42983 L
.5035 .43639 L
.5045 .44054 L
.50549 .44228 L
.50649 .44163 L
.50749 .43866 L
.50849 .43349 L
.50949 .42628 L
.51049 .41723 L
.51149 .4066 L
.51249 .39466 L
.51349 .38176 L
.51449 .36822 L
.51548 .35444 L
.51648 .34079 L
.51748 .32766 L
.51848 .31543 L
.51948 .30448 L
.52048 .29515 L
.52148 .28776 L
.52248 .28259 L
.52348 .27986 L
.52448 .27976 L
.52547 .28239 L
.52647 .28782 L
.52747 .29602 L
.52847 .30692 L
.52947 .32038 L
.53047 .33616 L
.53147 .35401 L
.53247 .37358 L
.53347 .39449 L
.53447 .41632 L
.53546 .43859 L
.53646 .46084 L
.53746 .48255 L
.53846 .50325 L
.53946 .52243 L
.54046 .53965 L
.54146 .55447 L
.54246 .56652 L
.54346 .57548 L
.54446 .58108 L
.54545 .58316 L
.54645 .58159 L
.54745 .57637 L
Mistroke
.54845 .56756 L
.54945 .14039 L
.55045 .14632 L
.55145 .15149 L
.55245 .15655 L
.55345 .16175 L
.55445 .16721 L
.55544 .17302 L
.55644 .17926 L
.55744 .18597 L
.55844 .19322 L
.55944 .20105 L
.56044 .20952 L
.56144 .21867 L
.56244 .22855 L
.56344 .2392 L
.56444 .25069 L
.56543 .26304 L
.56643 .27632 L
.56743 .29056 L
.56843 .30582 L
.56943 .32216 L
.57043 .33961 L
.57143 .35823 L
.57243 .37808 L
.57343 .39922 L
.57443 .42169 L
.57542 .44555 L
.57642 .47088 L
.57742 .49773 L
.57842 .52616 L
.57942 .55624 L
.58042 .58804 L
Mfstroke
.58042 .58804 m
.58131 .61803 L
s
.59912 .61803 m
.5994 .25997 L
.6004 .26508 L
.6014 .26923 L
.6024 .27304 L
.6034 .27672 L
.6044 .28036 L
.60539 .28401 L
.60639 .28772 L
.60739 .2915 L
.60839 .29538 L
.60939 .29936 L
.61039 .30345 L
.61139 .30766 L
.61239 .312 L
.61339 .31648 L
.61439 .32108 L
.61538 .32583 L
.61638 .33072 L
.61738 .33574 L
.61838 .34091 L
.61938 .34621 L
.62038 .35166 L
.62138 .35725 L
.62238 .36298 L
.62338 .36885 L
.62438 .37486 L
.62537 .381 L
.62637 .38727 L
.62737 .39367 L
.62837 .4002 L
.62937 .40685 L
.63037 .41363 L
.63137 .42052 L
.63237 .42753 L
.63337 .43464 L
.63437 .44187 L
.63536 .44919 L
.63636 .4566 L
.63736 .46411 L
.63836 .47171 L
.63936 .47938 L
.64036 .48713 L
.64136 .49495 L
.64236 .50283 L
.64336 .51076 L
.64436 .51875 L
.64535 .52678 L
.64635 .53484 L
.64735 .54293 L
Mistroke
.64835 .55105 L
.64935 .23984 L
.65035 .24459 L
.65135 .24831 L
.65235 .25163 L
.65335 .25475 L
.65435 .25777 L
.65534 .26075 L
.65634 .26372 L
.65734 .26672 L
.65834 .26976 L
.65934 .27285 L
.66034 .27602 L
.66134 .27928 L
.66234 .28263 L
.66334 .28607 L
.66434 .28963 L
.66533 .2933 L
.66633 .29709 L
.66733 .301 L
.66833 .30504 L
.66933 .30921 L
.67033 .31352 L
.67133 .31796 L
.67233 .32254 L
.67333 .32727 L
.67433 .33213 L
.67532 .33714 L
.67632 .34229 L
.67732 .34758 L
.67832 .35301 L
.67932 .35858 L
.68032 .3643 L
.68132 .37015 L
.68232 .37613 L
.68332 .38225 L
.68432 .3885 L
.68531 .39488 L
.68631 .40139 L
.68731 .40801 L
.68831 .41476 L
.68931 .42161 L
.69031 .42858 L
.69131 .43565 L
.69231 .44282 L
.69331 .45008 L
.69431 .45744 L
.6953 .46487 L
.6963 .47239 L
.6973 .47997 L
Mistroke
.6983 .48762 L
.6993 .34479 L
.7003 .34859 L
.7013 .35114 L
.7023 .35306 L
.7033 .35455 L
.7043 .3557 L
.70529 .35658 L
.70629 .35723 L
.70729 .35768 L
.70829 .35794 L
.70929 .35805 L
.71029 .35801 L
.71129 .35784 L
.71229 .35756 L
.71329 .35718 L
.71429 .35672 L
.71528 .35618 L
.71628 .35557 L
.71728 .35492 L
.71828 .35422 L
.71928 .3535 L
.72028 .35276 L
.72128 .352 L
.72228 .35125 L
.72328 .35051 L
.72428 .34978 L
.72527 .34909 L
.72627 .34842 L
.72727 .34781 L
.72827 .34724 L
.72927 .34673 L
.73027 .34628 L
.73127 .3459 L
.73227 .3456 L
.73327 .34538 L
.73427 .34524 L
.73526 .34519 L
.73626 .34523 L
.73726 .34536 L
.73826 .34559 L
.73926 .34592 L
.74026 .34634 L
.74126 .34686 L
.74226 .34748 L
.74326 .34819 L
.74426 .349 L
.74525 .3499 L
.74625 .35089 L
.74725 .35197 L
Mistroke
.74825 .35313 L
.74925 .15146 L
.75025 .16975 L
.75125 .18842 L
.75225 .20816 L
.75325 .22915 L
.75425 .25149 L
.75524 .27516 L
.75624 .30014 L
.75724 .32633 L
.75824 .35364 L
.75924 .38192 L
.76024 .41104 L
.76124 .44081 L
.76224 .47105 L
.76324 .50155 L
.76424 .53209 L
.76523 .56246 L
.76623 .5924 L
Mfstroke
.76623 .5924 m
.76711 .61803 L
s
.78913 .61803 m
.78921 .61483 L
.79021 .57121 L
.79121 .52406 L
.79221 .47363 L
.79321 .42025 L
.79421 .36427 L
.7952 .30609 L
.7962 .24611 L
.7972 .18477 L
.7982 .12252 L
.7992 .2886 L
.8002 .29917 L
.8012 .30875 L
.8022 .31796 L
.8032 .32695 L
.8042 .33582 L
.80519 .34457 L
.80619 .3532 L
.80719 .36171 L
.80819 .37007 L
.80919 .37825 L
.81019 .38621 L
.81119 .39392 L
.81219 .40135 L
.81319 .40845 L
.81419 .41519 L
.81518 .42153 L
.81618 .42744 L
.81718 .43289 L
.81818 .43783 L
.81918 .44225 L
.82018 .44612 L
.82118 .44942 L
.82218 .45212 L
.82318 .4542 L
.82418 .45567 L
.82517 .4565 L
.82617 .45669 L
.82717 .45624 L
.82817 .45515 L
.82917 .45343 L
.83017 .4511 L
.83117 .44815 L
.83217 .44462 L
.83317 .44053 L
.83417 .4359 L
.83516 .43077 L
.83616 .42517 L
.83716 .41913 L
Mistroke
.83816 .41271 L
.83916 .40595 L
.84016 .39889 L
.84116 .39158 L
.84216 .38408 L
.84316 .37644 L
.84416 .36872 L
.84515 .36096 L
.84615 .35324 L
.84715 .3456 L
.84815 .3381 L
.84915 .32024 L
.85015 .3353 L
.85115 .34901 L
.85215 .36185 L
.85315 .37391 L
.85415 .38516 L
.85514 .39553 L
.85614 .40492 L
.85714 .41325 L
.85814 .42043 L
.85914 .42639 L
.86014 .43104 L
.86114 .43435 L
.86214 .43625 L
.86314 .43673 L
.86414 .43579 L
.86513 .43343 L
.86613 .42969 L
.86713 .42461 L
.86813 .41827 L
.86913 .41076 L
.87013 .40217 L
.87113 .39264 L
.87213 .3823 L
.87313 .3713 L
.87413 .3598 L
.87512 .34797 L
.87612 .33599 L
.87712 .32404 L
.87812 .31231 L
.87912 .30097 L
.88012 .2902 L
.88112 .28017 L
.88212 .27104 L
.88312 .26295 L
.88412 .25603 L
.88511 .2504 L
.88611 .24616 L
.88711 .24339 L
Mistroke
.88811 .24214 L
.88911 .24246 L
.89011 .24437 L
.89111 .24786 L
.89211 .25293 L
.89311 .25952 L
.89411 .2676 L
.8951 .27707 L
.8961 .28785 L
.8971 .29984 L
.8981 .31291 L
.8991 .16347 L
.9001 .17505 L
.9011 .18626 L
.9021 .19776 L
.9031 .20976 L
.9041 .22235 L
.90509 .23558 L
.90609 .24947 L
.90709 .26403 L
.90809 .27924 L
.90909 .29506 L
.91009 .31148 L
.91109 .32843 L
.91209 .34587 L
.91309 .36374 L
.91409 .38197 L
.91508 .4005 L
.91608 .41925 L
.91708 .43816 L
.91808 .45714 L
.91908 .47611 L
.92008 .49501 L
.92108 .51373 L
.92208 .53221 L
.92308 .55036 L
.92408 .56809 L
.92507 .58532 L
.92607 .60198 L
.92707 .61798 L
Mfstroke
.92707 .61798 m
.92708 .61803 L
s
.9482 .61803 m
.94905 .21162 L
.95005 .2157 L
.95105 .21875 L
.95205 .22139 L
.95305 .22383 L
.95405 .22617 L
.95504 .22846 L
.95604 .23076 L
.95704 .23308 L
.95804 .23544 L
.95904 .23787 L
.96004 .24038 L
.96104 .24298 L
.96204 .24568 L
.96304 .24849 L
.96404 .25142 L
.96503 .25447 L
.96603 .25765 L
.96703 .26097 L
.96803 .26444 L
.96903 .26804 L
.97003 .2718 L
.97103 .2757 L
.97203 .27976 L
.97303 .28398 L
.97403 .28835 L
.97502 .29288 L
.97602 .29757 L
.97702 .30242 L
.97802 .30742 L
.97902 .31259 L
.98002 .31791 L
.98102 .32339 L
.98202 .32902 L
.98302 .33481 L
.98402 .34075 L
.98501 .34684 L
.98601 .35309 L
.98701 .35948 L
.98801 .36601 L
.98901 .3727 L
.99001 .37952 L
.99101 .38648 L
.99201 .39358 L
.99301 .40081 L
.99401 .40818 L
.995 .41568 L
.996 .4233 L
.997 .43104 L
Mistroke
.998 .43891 L
.999 .29149 L
Mfstroke
1 0 0 r
gsave
.999 .28512 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.001 .00175 L
.002 .0017 L
.003 .00165 L
.004 .0016 L
.005 .00156 L
.00599 .00152 L
.00699 .00149 L
.00799 .00147 L
.00899 .00145 L
.00999 .00144 L
.01099 .00143 L
.01199 .00143 L
.01299 .00144 L
.01399 .00145 L
.01499 .00147 L
.01598 .0015 L
.01698 .00154 L
.01798 .00159 L
.01898 .00166 L
.01998 .00173 L
.02098 .00182 L
.02198 .00193 L
.02298 .00206 L
.02398 .0022 L
.02498 .00237 L
.02597 .00256 L
.02697 .00278 L
.02797 .00303 L
.02897 .00332 L
.02997 .00365 L
.03097 .00402 L
.03197 .00444 L
.03297 .00491 L
.03397 .00545 L
.03497 .00606 L
.03596 .00675 L
.03696 .00753 L
.03796 .0084 L
.03896 .00939 L
.03996 .01051 L
.04096 .01176 L
.04196 .01318 L
.04296 .01477 L
.04396 .01657 L
.04496 .01859 L
.04595 .02086 L
.04695 .02343 L
.04795 .02631 L
.04895 .02956 L
Mistroke
.04995 .39371 L
.05095 .44232 L
.05195 .48602 L
.05295 .5216 L
.05395 .54607 L
.05495 .55684 L
.05594 .55199 L
.05694 .53046 L
.05794 .4922 L
.05894 .43826 L
.05994 .3709 L
.06094 .29345 L
.06194 .21027 L
.06294 .12652 L
.06394 .0479 L
Mfstroke
.06394 .0479 m
.06464 0 L
s
.07019 0 m
.07093 .06234 L
.07193 .17235 L
.07293 .30324 L
.07393 .44807 L
.07493 .59832 L
s
.07493 .59832 m
.07506 .61803 L
s
.08423 .61803 m
.08492 .46947 L
.08591 .2217 L
s
.08591 .2217 m
.08675 0 L
s
.09722 0 m
.0979 .28665 L
s
.0979 .28665 m
.09862 .61803 L
s
.09915 .61803 m
.0999 .22745 L
.1009 .21852 L
.1019 .20999 L
.1029 .20186 L
.1039 .19412 L
.1049 .18676 L
.10589 .17976 L
.10689 .17313 L
.10789 .16684 L
.10889 .1609 L
.10989 .15529 L
.11089 .15002 L
.11189 .14506 L
.11289 .14043 L
.11389 .13612 L
.11489 .13212 L
.11588 .12842 L
.11688 .12503 L
.11788 .12195 L
.11888 .11917 L
.11988 .11669 L
.12088 .11451 L
.12188 .11263 L
.12288 .11106 L
.12388 .10979 L
.12488 .10883 L
.12587 .10817 L
.12687 .10783 L
.12787 .10781 L
.12887 .10811 L
.12987 .10874 L
.13087 .1097 L
.13187 .11101 L
.13287 .11267 L
.13387 .11468 L
.13487 .11707 L
.13586 .11984 L
.13686 .123 L
.13786 .12657 L
.13886 .13056 L
.13986 .13498 L
.14086 .13985 L
.14186 .14519 L
.14286 .15102 L
.14386 .15735 L
.14486 .16421 L
.14585 .17162 L
.14685 .17961 L
.14785 .1882 L
Mistroke
.14885 .19741 L
.14985 .40043 L
.15085 .41616 L
.15185 .43029 L
.15285 .44255 L
.15385 .45267 L
.15485 .46044 L
.15584 .46568 L
.15684 .46825 L
.15784 .46808 L
.15884 .46516 L
.15984 .45953 L
.16084 .45132 L
.16184 .4407 L
.16284 .42793 L
.16384 .41332 L
.16484 .39723 L
.16583 .38008 L
.16683 .36234 L
.16783 .34447 L
.16883 .327 L
.16983 .31042 L
.17083 .29526 L
.17183 .28197 L
.17283 .27103 L
.17383 .26283 L
.17483 .25772 L
.17582 .25596 L
.17682 .25775 L
.17782 .2632 L
.17882 .2723 L
.17982 .28497 L
.18082 .30103 L
.18182 .32018 L
.18282 .34203 L
.18382 .36612 L
.18482 .3919 L
.18581 .41875 L
.18681 .446 L
.18781 .47294 L
.18881 .49884 L
.18981 .52298 L
.19081 .54465 L
.19181 .56318 L
.19281 .57795 L
.19381 .58842 L
.19481 .59415 L
.1958 .59481 L
.1968 .59019 L
.1978 .58019 L
Mistroke
.1988 .56489 L
.1998 .17597 L
.2008 .18777 L
.2018 .20108 L
.2028 .21594 L
.2038 .23237 L
.2048 .2504 L
.20579 .27002 L
.20679 .29123 L
.20779 .31403 L
.20879 .33838 L
.20979 .36424 L
.21079 .39156 L
.21179 .42025 L
.21279 .45023 L
.21379 .48139 L
.21479 .51361 L
.21578 .54674 L
.21678 .58061 L
.21778 .61503 L
Mfstroke
.21778 .61503 m
.21787 .61803 L
s
.24393 .61803 m
.24476 .54785 L
.24575 .45269 L
.24675 .34734 L
.24775 .23167 L
.24875 .1056 L
.24975 .23556 L
.25075 .24293 L
.25175 .25073 L
.25275 .25895 L
.25375 .26758 L
.25475 .27659 L
.25574 .28598 L
.25674 .29573 L
.25774 .3058 L
.25874 .31617 L
.25974 .32681 L
.26074 .33768 L
.26174 .34875 L
.26274 .35998 L
.26374 .37133 L
.26474 .38273 L
.26573 .39416 L
.26673 .40556 L
.26773 .41686 L
.26873 .42802 L
.26973 .43897 L
.27073 .44965 L
.27173 .45999 L
.27273 .46994 L
.27373 .47942 L
.27473 .48836 L
.27572 .4967 L
.27672 .50435 L
.27772 .51126 L
.27872 .51734 L
.27972 .52253 L
.28072 .52674 L
.28172 .52992 L
.28272 .532 L
.28372 .53289 L
.28472 .53254 L
.28571 .53088 L
.28671 .52786 L
.28771 .52341 L
.28871 .51747 L
.28971 .51001 L
.29071 .50097 L
.29171 .49031 L
.29271 .478 L
Mistroke
.29371 .46401 L
.29471 .44832 L
.2957 .43091 L
.2967 .41177 L
.2977 .3909 L
.2987 .36832 L
.2997 .24398 L
.3007 .24667 L
.3017 .24948 L
.3027 .25239 L
.3037 .25541 L
.3047 .25854 L
.30569 .26177 L
.30669 .26511 L
.30769 .26855 L
.30869 .2721 L
.30969 .27574 L
.31069 .27948 L
.31169 .28331 L
.31269 .28723 L
.31369 .29123 L
.31469 .29532 L
.31568 .29949 L
.31668 .30373 L
.31768 .30803 L
.31868 .31241 L
.31968 .31683 L
.32068 .32132 L
.32168 .32584 L
.32268 .33041 L
.32368 .335 L
.32468 .33963 L
.32567 .34426 L
.32667 .34891 L
.32767 .35356 L
.32867 .3582 L
.32967 .36283 L
.33067 .36743 L
.33167 .372 L
.33267 .37652 L
.33367 .38098 L
.33467 .38538 L
.33566 .38971 L
.33666 .39395 L
.33766 .39809 L
.33866 .40212 L
.33966 .40603 L
.34066 .40981 L
.34166 .41344 L
.34266 .41692 L
Mistroke
.34366 .42022 L
.34466 .42335 L
.34565 .42628 L
.34665 .429 L
.34765 .43151 L
.34865 .43378 L
.34965 .36858 L
.35065 .37734 L
.35165 .38514 L
.35265 .39186 L
.35365 .39742 L
.35465 .40174 L
.35564 .40473 L
.35664 .40636 L
.35764 .4066 L
.35864 .40544 L
.35964 .40289 L
.36064 .39899 L
.36164 .39379 L
.36264 .38737 L
.36364 .37982 L
.36464 .37126 L
.36563 .36183 L
.36663 .35167 L
.36763 .34094 L
.36863 .32982 L
.36963 .3185 L
.37063 .30717 L
.37163 .29601 L
.37263 .28523 L
.37363 .27501 L
.37463 .26555 L
.37562 .25702 L
.37662 .24958 L
.37762 .24339 L
.37862 .23858 L
.37962 .23526 L
.38062 .23353 L
.38162 .23345 L
.38262 .23506 L
.38362 .23838 L
.38462 .2434 L
.38561 .25007 L
.38661 .25832 L
.38761 .26806 L
.38861 .27916 L
.38961 .29148 L
.39061 .30485 L
.39161 .31907 L
.39261 .33394 L
Mistroke
.39361 .34922 L
.39461 .36469 L
.3956 .3801 L
.3966 .3952 L
.3976 .40974 L
.3986 .42347 L
.3996 .1224 L
.4006 .12423 L
.4016 .12634 L
.4026 .12874 L
.4036 .13145 L
.4046 .13448 L
.40559 .13783 L
.40659 .14154 L
.40759 .14561 L
.40859 .15006 L
.40959 .15491 L
.41059 .16018 L
.41159 .1659 L
.41259 .17207 L
.41359 .17873 L
.41459 .18589 L
.41558 .19359 L
.41658 .20184 L
.41758 .21067 L
.41858 .22012 L
.41958 .23021 L
.42058 .24096 L
.42158 .25242 L
.42258 .26461 L
.42358 .27757 L
.42458 .29133 L
.42557 .30593 L
.42657 .32141 L
.42757 .33781 L
.42857 .35516 L
.42957 .37351 L
.43057 .39291 L
.43157 .4134 L
.43257 .43504 L
.43357 .45785 L
.43457 .48191 L
.43556 .50727 L
.43656 .53397 L
.43756 .56208 L
.43856 .59165 L
Mfstroke
.43856 .59165 m
.43941 .61803 L
s
.44909 .61803 m
.44955 .30829 L
.45055 .31082 L
.45155 .31348 L
.45255 .31626 L
.45355 .31916 L
.45455 .32216 L
.45554 .32525 L
.45654 .32842 L
.45754 .33168 L
.45854 .335 L
.45954 .33838 L
.46054 .34181 L
.46154 .34528 L
.46254 .34879 L
.46354 .35233 L
.46454 .35588 L
.46553 .35944 L
.46653 .363 L
.46753 .36656 L
.46853 .3701 L
.46953 .37361 L
.47053 .3771 L
.47153 .38054 L
.47253 .38394 L
.47353 .38729 L
.47453 .39057 L
.47552 .39378 L
.47652 .39691 L
.47752 .39996 L
.47852 .40292 L
.47952 .40577 L
.48052 .40852 L
.48152 .41116 L
.48252 .41368 L
.48352 .41607 L
.48452 .41833 L
.48551 .42045 L
.48651 .42242 L
.48751 .42425 L
.48851 .42591 L
.48951 .42742 L
.49051 .42876 L
.49151 .42992 L
.49251 .43091 L
.49351 .43172 L
.49451 .43234 L
.4955 .43277 L
.4965 .43301 L
.4975 .43305 L
Mistroke
.4985 .43289 L
.4995 .38875 L
.5005 .39904 L
.5015 .40746 L
.5025 .41383 L
.5035 .41802 L
.5045 .41992 L
.50549 .41949 L
.50649 .41675 L
.50749 .41173 L
.50849 .40456 L
.50949 .39539 L
.51049 .38444 L
.51149 .37195 L
.51249 .35821 L
.51349 .34356 L
.51449 .32835 L
.51548 .31296 L
.51648 .29778 L
.51748 .28319 L
.51848 .26959 L
.51948 .25734 L
.52048 .24679 L
.52148 .23825 L
.52248 .232 L
.52348 .22826 L
.52448 .22719 L
.52547 .22891 L
.52647 .23345 L
.52747 .2408 L
.52847 .25086 L
.52947 .26348 L
.53047 .27842 L
.53147 .29541 L
.53247 .3141 L
.53347 .3341 L
.53447 .35497 L
.53546 .37625 L
.53646 .39745 L
.53746 .41807 L
.53846 .43761 L
.53946 .45559 L
.54046 .47154 L
.54146 .48504 L
.54246 .49572 L
.54346 .50324 L
.54446 .50736 L
.54545 .50789 L
.54645 .50474 L
.54745 .49788 L
Mistroke
.54845 .4874 L
.54945 .13404 L
.55045 .13604 L
.55145 .13837 L
.55245 .14107 L
.55345 .14414 L
.55445 .1476 L
.55544 .15148 L
.55644 .15579 L
.55744 .16056 L
.55844 .1658 L
.55944 .17155 L
.56044 .17782 L
.56144 .18465 L
.56244 .19205 L
.56344 .20006 L
.56444 .2087 L
.56543 .218 L
.56643 .228 L
.56743 .23872 L
.56843 .25021 L
.56943 .26249 L
.57043 .2756 L
.57143 .28959 L
.57243 .30448 L
.57343 .32031 L
.57443 .33714 L
.57542 .35501 L
.57642 .37395 L
.57742 .39401 L
.57842 .41526 L
.57942 .43772 L
.58042 .46146 L
.58142 .48654 L
.58242 .513 L
.58342 .5409 L
.58442 .57031 L
.58541 .60129 L
Mfstroke
.58541 .60129 m
.58593 .61803 L
s
.59901 .61803 m
.5994 .2536 L
.6004 .25477 L
.6014 .25606 L
.6024 .25748 L
.6034 .25901 L
.6044 .26067 L
.60539 .26245 L
.60639 .26434 L
.60739 .26635 L
.60839 .26847 L
.60939 .27071 L
.61039 .27305 L
.61139 .27551 L
.61239 .27808 L
.61339 .28075 L
.61439 .28354 L
.61538 .28642 L
.61638 .28941 L
.61738 .2925 L
.61838 .29569 L
.61938 .29898 L
.62038 .30237 L
.62138 .30585 L
.62238 .30942 L
.62338 .31309 L
.62438 .31684 L
.62537 .32067 L
.62637 .32459 L
.62737 .32859 L
.62837 .33267 L
.62937 .33682 L
.63037 .34105 L
.63137 .34534 L
.63237 .3497 L
.63337 .35413 L
.63437 .35861 L
.63536 .36315 L
.63636 .36774 L
.63736 .37237 L
.63836 .37706 L
.63936 .38178 L
.64036 .38653 L
.64136 .39132 L
.64236 .39613 L
.64336 .40097 L
.64436 .40582 L
.64535 .41068 L
.64635 .41555 L
.64735 .42042 L
Mistroke
.64835 .42529 L
.64935 .23347 L
.65035 .23429 L
.65135 .23519 L
.65235 .23616 L
.65335 .23722 L
.65435 .23836 L
.65534 .23958 L
.65634 .24089 L
.65734 .24228 L
.65834 .24376 L
.65934 .24532 L
.66034 .24698 L
.66134 .24872 L
.66234 .25056 L
.66334 .25248 L
.66434 .25449 L
.66533 .2566 L
.66633 .25879 L
.66733 .26108 L
.66833 .26346 L
.66933 .26592 L
.67033 .26848 L
.67133 .27113 L
.67233 .27386 L
.67333 .27669 L
.67433 .2796 L
.67532 .2826 L
.67632 .28569 L
.67732 .28886 L
.67832 .29211 L
.67932 .29545 L
.68032 .29886 L
.68132 .30235 L
.68232 .30593 L
.68332 .30957 L
.68432 .31329 L
.68531 .31707 L
.68631 .32093 L
.68731 .32485 L
.68831 .32883 L
.68931 .33287 L
.69031 .33697 L
.69131 .34112 L
.69231 .34531 L
.69331 .34956 L
.69431 .35385 L
.6953 .35817 L
.6963 .36253 L
.6973 .36692 L
Mistroke
.6983 .37134 L
.6993 .33842 L
.7003 .33828 L
.7013 .33797 L
.7023 .33752 L
.7033 .33692 L
.7043 .33618 L
.70529 .33532 L
.70629 .33433 L
.70729 .33323 L
.70829 .33203 L
.70929 .33074 L
.71029 .32936 L
.71129 .32791 L
.71229 .32639 L
.71329 .32482 L
.71429 .32321 L
.71528 .32157 L
.71628 .3199 L
.71728 .31822 L
.71828 .31654 L
.71928 .31486 L
.72028 .31321 L
.72128 .31158 L
.72228 .30998 L
.72328 .30844 L
.72428 .30694 L
.72527 .30551 L
.72627 .30414 L
.72727 .30285 L
.72827 .30164 L
.72927 .30052 L
.73027 .2995 L
.73127 .29857 L
.73227 .29775 L
.73327 .29704 L
.73427 .29644 L
.73526 .29595 L
.73626 .29557 L
.73726 .29531 L
.73826 .29517 L
.73926 .29515 L
.74026 .29524 L
.74126 .29546 L
.74226 .29578 L
.74326 .29622 L
.74426 .29676 L
.74525 .29742 L
.74625 .29817 L
.74725 .29903 L
Mistroke
.74825 .29997 L
.74925 .14513 L
.75025 .15943 L
.75125 .17511 L
.75225 .19213 L
.75325 .21044 L
.75425 .22997 L
.75524 .25065 L
.75624 .27238 L
.75724 .29506 L
.75824 .31857 L
.75924 .34278 L
.76024 .36755 L
.76124 .39272 L
.76224 .41812 L
.76324 .44358 L
.76424 .46891 L
.76523 .4939 L
.76623 .51836 L
.76723 .54206 L
.76823 .5648 L
.76923 .58633 L
.77023 .60644 L
Mfstroke
.77023 .60644 m
.77086 .61803 L
s
.7842 .61803 m
.78422 .61761 L
.78521 .59218 L
.78621 .56273 L
.78721 .52924 L
.78821 .49177 L
.78921 .45037 L
.79021 .40515 L
.79121 .35624 L
.79221 .30381 L
.79321 .24807 L
.79421 .18927 L
.7952 .12767 L
.7962 .06359 L
s
.7962 .06359 m
.79716 0 L
s
.7984 0 m
.7992 .28223 L
.8002 .28887 L
.8012 .29556 L
.8022 .30229 L
.8032 .30902 L
.8042 .31571 L
.80519 .32232 L
.80619 .32883 L
.80719 .33519 L
.80819 .34137 L
.80919 .34733 L
.81019 .35305 L
.81119 .35849 L
.81219 .36362 L
.81319 .3684 L
.81419 .37281 L
.81518 .37682 L
.81618 .38041 L
.81718 .38355 L
.81818 .38622 L
.81918 .3884 L
.82018 .39008 L
.82118 .39124 L
.82218 .39186 L
.82318 .39195 L
.82418 .39148 L
.82517 .39047 L
.82617 .38891 L
.82717 .38679 L
.82817 .38414 L
.82917 .38095 L
.83017 .37723 L
.83117 .37301 L
.83217 .36829 L
.83317 .3631 L
.83417 .35747 L
.83516 .3514 L
.83616 .34494 L
.83716 .33811 L
.83816 .33095 L
.83916 .32349 L
.84016 .31576 L
.84116 .30781 L
.84216 .29968 L
.84316 .2914 L
.84416 .28302 L
.84515 .27459 L
.84615 .26614 L
.84715 .25773 L
Mistroke
.84815 .24939 L
.84915 .31388 L
.85015 .32498 L
.85115 .33576 L
.85215 .34609 L
.85315 .35583 L
.85415 .36486 L
.85514 .37306 L
.85614 .38031 L
.85714 .38652 L
.85814 .3916 L
.85914 .39547 L
.86014 .39808 L
.86114 .39937 L
.86214 .39933 L
.86314 .39792 L
.86414 .39517 L
.86513 .39109 L
.86613 .38572 L
.86713 .37911 L
.86813 .37133 L
.86913 .36248 L
.87013 .35266 L
.87113 .34197 L
.87213 .33056 L
.87313 .31855 L
.87413 .30609 L
.87512 .29335 L
.87612 .28048 L
.87712 .26765 L
.87812 .25502 L
.87912 .24277 L
.88012 .23104 L
.88112 .22001 L
.88212 .20982 L
.88312 .20061 L
.88412 .19253 L
.88511 .18568 L
.88611 .18017 L
.88711 .1761 L
.88811 .17353 L
.88911 .17251 L
.89011 .17309 L
.89111 .17527 L
.89211 .17906 L
.89311 .18442 L
.89411 .19131 L
.8951 .19965 L
.8961 .20938 L
.8971 .22037 L
Mistroke
.8981 .23251 L
.8991 .15711 L
.9001 .16475 L
.9011 .17308 L
.9021 .1821 L
.9031 .19177 L
.9041 .20205 L
.90509 .21293 L
.90609 .22435 L
.90709 .23628 L
.90809 .24869 L
.90909 .26152 L
.91009 .27473 L
.91109 .28827 L
.91209 .30209 L
.91309 .31614 L
.91409 .33036 L
.91508 .3447 L
.91608 .35909 L
.91708 .37348 L
.91808 .38781 L
.91908 .402 L
.92008 .41601 L
.92108 .42977 L
.92208 .4432 L
.92308 .45626 L
.92408 .46887 L
.92507 .48097 L
.92607 .4925 L
.92707 .5034 L
.92807 .5136 L
.92907 .52305 L
.93007 .53169 L
.93107 .53946 L
.93207 .54631 L
.93307 .55219 L
.93407 .55704 L
.93506 .56084 L
.93606 .56353 L
.93706 .56507 L
.93806 .56543 L
.93906 .56458 L
.94006 .5625 L
.94106 .55915 L
.94206 .55453 L
.94306 .54862 L
.94406 .54141 L
.94505 .53291 L
.94605 .5231 L
.94705 .51201 L
Mistroke
.94805 .49964 L
.94905 .20525 L
.95005 .20543 L
.95105 .20569 L
.95205 .20604 L
.95305 .20647 L
.95405 .20698 L
.95504 .20758 L
.95604 .20826 L
.95704 .20902 L
.95804 .20987 L
.95904 .2108 L
.96004 .21182 L
.96104 .21292 L
.96204 .2141 L
.96304 .21537 L
.96404 .21672 L
.96503 .21816 L
.96603 .21968 L
.96703 .22128 L
.96803 .22297 L
.96903 .22474 L
.97003 .22659 L
.97103 .22852 L
.97203 .23054 L
.97303 .23264 L
.97403 .23482 L
.97502 .23708 L
.97602 .23942 L
.97702 .24184 L
.97802 .24435 L
.97902 .24693 L
.98002 .24959 L
.98102 .25233 L
.98202 .25514 L
.98302 .25804 L
.98402 .26101 L
.98501 .26405 L
.98601 .26717 L
.98701 .27036 L
.98801 .27363 L
.98901 .27697 L
.99001 .28037 L
.99101 .28385 L
.99201 .2874 L
.99301 .29102 L
.99401 .2947 L
.995 .29844 L
.996 .30226 L
.997 .30613 L
Mistroke
.998 .31007 L
.999 .28512 L
Mfstroke
0 g
gsave
.999 .28538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
0 .00184 Mdot
.04995 .40921 Mdot
.0999 .23115 Mdot
.14985 .40212 Mdot
.1998 .17393 Mdot
.24975 .23659 Mdot
.2997 .24364 Mdot
.34965 .3675 Mdot
.3996 .1202 Mdot
.44955 .30922 Mdot
.4995 .38792 Mdot
.54945 .13154 Mdot
.5994 .25451 Mdot
.64935 .2328 Mdot
.6993 .3381 Mdot
.74925 .14281 Mdot
.7992 .28501 Mdot
.84915 .31373 Mdot
.8991 .15644 Mdot
.94905 .20595 Mdot
.999 .28538 Mdot
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{879.625, 362.438},
  ImageMargins->{{0, 0}, {0, 4}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000=_0001JR000`400?l00000o`00003ooooooooo
ooooooooooooL_ooool00?ooooooooooooooooooog;ooooo003ooooooooooooooooooombooooo`00
ooooooooooooooooooooL_ooool00?ooooooooooooooooooog;ooooo003ooooooooooooooooooomb
ooooo`00ooooooooooooooooooooL_ooool00?ooooooooooooooooooog;ooooo003ooooooooooooo
oooooombooooo`00J?ooool5o`0000?ooooo0_l00004ooooo`;o00007_ooool3o`0000?ooooo0_l0
0004ooooo`;o00007Oooool3o`0000Cooooo0_l00004ooooo`;o00007?ooool3o`0000Cooooo0_l0
0004ooooo`;o00006_ooool3o`0000Cooooo0_l00004ooooo`;o00001?ooool2o`0004Cooooo1Ol0
0003ooooo`;o00001?ooool2o`0001gooooo0ol00003ooooo`;o00001?ooool2o`0001gooooo0ol0
0004ooooo`;o00001?ooool2o`0001gooooo0ol00004ooooo`;o00001?ooool2o`0001Wooooo0ol0
0004ooooo`;o00001?ooool2o`0000Cooooo0_l00014ooooo`Go00000oooool2o`0000Cooooo0_l0
000Nooooo`?o00000oooool2o`0000Cooooo0_l0000Looooo`?o00001?ooool2o`0000Cooooo0_l0
000Mooooo`?o00001?ooool2o`0000Cooooo0_l0000Jooooo`?o00001?ooool2o`0000Cooooo0_l0
0004ooooo`;o0000>_ooool006Wooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0001kooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06Oooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Jooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001[ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000A?ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007Oooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Ioooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00006Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00014ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
000Nooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo01Sooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00006oooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Jooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0003Wooooo001Zooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Kooooo`Go00000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00006_ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Jooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0004Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001[ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00006oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000Kooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Wooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo0000AOooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00006oooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Jooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001_ooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000iooooo`00Joooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`0Iooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Kooooo`Co00000oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001_ooooo0ol00003ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0016ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo01Sooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001_ooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00007?ooool3o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Iooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004Kooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06Oooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00006_ooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000L
ooooo`?o00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001[ooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo0000>Oooool006Sooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007?ooool00ol0003ooooo
o`000003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006oooool00ol0
003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006_oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000Jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004?ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006oooool0
0ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
6oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00006oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Iooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004?ooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00007?ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00006_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00006oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Jooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0003Wo
oooo001Xooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001gooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00007?ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00006_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Iooooo`;o00001?ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000@oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Looooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001cooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00006?ooool2o`0000Cooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004?ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007Ooo
ool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Kooooo`03
o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000K
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001Wooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000iooooo`00JOooool3o`0000Cooooo0_l00004
ooooo`;o00007oooool00ol0003oooooooooo`02ooooo`;o00001?ooool2o`0001kooooo0_l00004
ooooo`;o00001?ooool2o`0001cooooo0ol00004ooooo`;o00001?ooool2o`0001_ooooo00?o0000
ooooooooool00oooool2o`0000Cooooo0_l00004ooooo`;o0000AOooool3o`0000Cooooo0_l00004
ooooo`;o00007_ooool00ol0003oooooooooo`02ooooo`;o00001?ooool2o`0001kooooo0_l00004
ooooo`;o00001?ooool2o`0001gooooo0ol00004ooooo`;o00001?ooool2o`0001[ooooo00?o0000
ooooooooool00oooool2o`0000Cooooo0_l00004ooooo`;o0000AOooool3o`0000Cooooo0_l00004
ooooo`;o00007oooool00ol0003oooooooooo`02ooooo`;o00001?ooool2o`0001gooooo0_l00004
ooooo`;o00001?ooool2o`0001gooooo0ol00004ooooo`;o00001?ooool2o`0001_ooooo00?o0000
ooooooooool00oooool2o`0000Cooooo0_l00004ooooo`;o0000>_ooool00?oooooooooooooooooo
og;ooooo003ooooooooooooooooooombooooo`00ooooooooooooooooooooL_ooool00?oooooooooo
ooooooooog;ooooo0016ooooom_o0000:_oooooLo`0002Wooooo0_l00?oJo`0004?ooooo0016oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Xoooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool2o`0002Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo047ooooo0016ooooo`03
o`000?oooooooooo0=Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`3Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11ooooo`00
A_ooool00ol0003oooooooooo`3<ooooo`co0?ZJ:_ooool00ol0003oooooooooo`3Hooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11ooooo`00A_oo
ool2o`000<gooooo00?o0?ZJooooooooool01oooool2o`0002[ooooo00?o0000ooooooooool0f?oo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Ooo
ool004Kooooo00?o0000ooooooooool0c?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooo
oooo02Sooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Wooooo`;o0000f?ooool2
o`0004?ooooo0016ooooo`03o`000?oooooooooo0:_ooooo3?l0nYXEooooo`03o`3jV_oooooooooo
00Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003o
ooooooooo`2[ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool04oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo02Sooooo0_l0003Hooooo`;o0000:Oooool00ol0003o
ooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo0:_ooooo
00?o0?ZJooooooooool02?oooolGo`3jVP[ooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`3Hooooo`03o`000?oooooooooo027ooooo0ol00003ooooo`03o`000?oooooooooo0=Sooooo
00?o0000ooooooooool0@Oooool004Kooooo0_l0002/ooooo`03o`3jV_oooooooooo02Sooooo0_l0
000Zooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000
ooooooooool0Zoooool00ol0nY[oooooooooo`0Nooooo`coo`00:_ooool00ol0003oooooooooo`3H
ooooo`03o`000?oooooooooo01Wooooo1Ol000000ooooooo0000o`000003o`0000?ooooo0ol0003F
ooooo`?o0000@oooool004Kooooo00?o0000ooooooooool0Zoooool00ol0nY[oooooooooo`0Noooo
o`03ool00?oooooooooo00Sooooo00?o0000ooooooooool06Oooool5o`0000;ooooo0ol00005oooo
o`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool07oooool01?l0003oooooooooool00004
ooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000oooo
ooooool0Zoooool00ol0nY[oooooooooo`0Nooooo`03ool00?oooooooooo00Sooooo00?o0000oooo
ooooool06_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo023ooooo00?o0000ooooool000001?oo
ool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`;o0000[?ooool<
ool001Gooooo00?oo`00ooooooooool01oooool2o`0001gooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00;ooooo0_l0003Gooooo`?o00008oooool2o`0000Cooooo00?o
0000ooooooooool0f?ooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`2[
ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool04oooool00ooo003oooooooooo`08
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01?l00005ooooo`03o`000?oooooo
oooo0=Sooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo0=Sooooo00?o0000ooooooooool0@Oooool003gooooo1Ol00004ooooo`03o`000?oooooooooo
0:_ooooo00?oo`00ooooooooool02?oooolGool000[ooooo00?o0000ooooooooool06Oooool01ol0
003ooooooooooooooooo0000ooooool000002?ooool00ol0003oooooooooo`3Hooooo`03o`000?oo
oooooooo02Oooooo0_l0003Hooooo`;o0000@oooool003kooooo00Co0000oooooooooooo00001?oo
ool00ol0003oooooooooo`2[ooooo`03ool00?oooooooooo01kooooo3?l0nYXKooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0=Sooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo
000oooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Zoooool00ooo003ooooooooo
o`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool06_ooool3o`0000Cooooo0_l0
0005ooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`3Hooooo`03o`000?oooooooooo047ooooo0010ooooo`03o`000?oooooooooo00?ooooo0_l0002/
ooooo`03ool00?oooooooooo01kooooo00?o0?ZJooooooooool01oooool2o`0002[ooooo00?o0000
ooooooooool0f?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo0=Sooooo00?o0000
ooooooooool0@Oooool003gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooo
oooo0:_ooooo00?oo`00ooooooooool07_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooo
oooo02Sooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo0=Sooooo00?o0000ooooooooool0@Oooool003gooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo0:_ooooo00?oo`00o`3jV_l0nYX02Ol0nYXEooooo`03o`3jV_oooooo
oooo00Sooooo00?o0000ooooooooool0:?ooool2o`000=Sooooo0_l0000Yooooo`03o`000?oooooo
oooo0=Sooooo00?o0000ooooooooool0@Oooool003kooooo0ol00005ooooo`03o`000?oooooooooo
0:_ooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo
00Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`08ooooo`co0?ZJa?ooool00ol0
003oooooooooo`0Wooooo`;o0000f?ooool2o`0004?ooooo0016ooooo`;o0000[?ooool00ooo003o
ooooooooo`08oooooaOo0?ZJ2Oooool2o`0002[ooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo0<;ooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo0:3ooooo
2ol0nYX00ooo003oooooooooo`0Yooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0<;ooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oo
oooooooo08_ooooo2ol0nYX:ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool0:Ooo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?oo
ool00ol0nY[oooooooooo`32ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0f?oo
ool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`20ooooo`_o0?ZJ2_ooool<
o`3jVP[ooooo00?oo`00ooooooooool0:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooo
oooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`32ooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0
003oooooooooo`20ooooo`03o`3jV_oooooooooo02Sooooo00?oo`00ooooooooool0:Oooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0
nY[oooooooooo`32ooooo`03o`000?oooooooooo02Oooooo0_l0003Hooooo`;o0000@oooool004Ko
oooo0_l00021ooooo`03o`3jV_oooooooooo02Sooooo00?oo`00ooooooooool0:?ooool2o`0002[o
oooo3?l0nYX:ooooo`03o`3jV_oooooooooo0<7ooooo0_l0000Yooooo`03o`000?oooooooooo0=So
oooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000ooooooooool0P?ooool00ol0nY[ooooo
ooooo`0Xooooo`03ool00?oooooooooo02Wooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo0<;ooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Nooooo`co0?ZJ[_ooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003ooooooooo
o`1Oooooo`co0?ZJ5Oooool00ol0nY[oooooooooo`0Xooooo`03ool00?oooooooooo02Wooooo00?o
0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo0<;ooooo00?o
0000ooooooooool07oooool5o`0000?ooooo00?o0000ooooooooool07_ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo0:cooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000
ooooooooool0Goooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJ
ooooooooool0:Oooool00ooo003oooooooooo`0Yooooo`03o`000?oooooooooo02Sooooo00?o0000
ooooooooool04oooool00ol0nY[oooooooooo`32ooooo`03o`000?oooooooooo023ooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool0[?ooool00ol0003oooooooooo`11ooooo`00A_ooool2o`0003Cooooo5ol0nYX:
ooooo`co0?ZJ2_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo01kooooo3?oo000Z
ooooo`;o0000:_ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo0<;ooooo00?o0000
ooooooooool06Oooool5o`0000?ooooo00?o0000ooooooooool00oooool3o`0001kooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`2Zooooo`?o0000@oooool004Kooooo00?o0000oooo
ooooool0<oooool00ol0nY[oooooooooo`0Cooooo`co0?ZJ5Oooool00ol0nY[oooooooooo`0Boooo
o`03o`3jV_oooooooooo01kooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`0Yoooo
o`03o`000?oooooooooo02Sooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`32oooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Noooo
o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0[?ooool00ol0003oooooooooo`11oooo
o`00?oooool3o`0000Cooooo00?o0000ooooooooool0<oooool00ol0nY[oooooooooo`0dooooo`03
o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool02OoooolFool000[ooooo00?o0?ZJoooooooo
ool0:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo01?ooooo00?o0?ZJoooooooo
ool0`_ooool00ol0003oooooooooo`0Oooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`0Nooooo`coo`00[_ooool00ol0003oooooooooo`11ooooo`00@?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo03?ooooo00?o0?ZJooooooooool0=?ooool00ol0nY[o
ooooooooo`08ooooo`_o0?ZJ2ooo000Pooooo`03o`3jV_oooooooooo02Wooooo00?o0000oooooooo
ool0:?ooool2o`0001Cooooo00?o0?ZJooooooooool0Roooool;o`3jVR_ooooo0_l0000Qooooo`05
o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Nooooo`03ool00?oooooooooo
00Sooooo00?oo`00ooooooooool0[?ooool00ol0003oooooooooo`11ooooo`00?Oooool5o`0000Co
oooo00?o0000ooooooooool0<oooool00ol0nY[oooooooooo`0dooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`0Xooooo`03o`3jV_oooooooooo02Wo
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo08_o
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Zooooo`03o`000?oooooooooo023o
oooo0ol00004ooooo`03o`000?oooooooooo01kooooo00?oo`00ooooooooool02?ooool00ooo003o
ooooooooo`2/ooooo`03o`000?oooooooooo047ooooo000mooooo`04o`000?ooooooooooo`0000Go
oooo0_l0000dooooo`03o`3jV_oooooooooo03Cooooo3?l0nYX:ooooo`03ool00?oooooooooo02So
oooo00?o0?ZJooooooooool0:?ooool2o`0002[ooooo00?o0000ooooooooool04oooool00ol0nY[o
ooooooooo`2;ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0:_ooool00ol0003o
ooooooooo`0Wooooo`;o00007oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo0:_o
oooo0_l00013ooooo`00?_ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo03?ooooo
00?o0?ZJooooooooool0B_ooool00ooo003oooooooooo`0Xooooo`03o`3jV_oooooooooo02Wooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo08_ooooo
00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Zooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool07_ooool00ooo003oooooooooo`08ooooo`03ool00?l0nY[o0?ZJ00Wo0?ZJ
Xoooool00ol0003oooooooooo`11ooooo`00?oooool2o`0000Gooooo00?o0000ooooooooool0<ooo
ool00ol0nY[oooooooooo`1:ooooo`03ool00?oooooooooo02Sooooo00?o0?ZJooooooooool0:Ooo
ool00ol0003oooooooooo`0Iooooo`Go00000_ooool3o`0000Gooooo00?o0000ooooooooool04ooo
ool00ol0nY[oooooooooo`2;ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0:_oo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01kooooo00?oo`00ooooooooool02?oo
ool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0@Ooo
ool0043ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0cooooo`03o`3jV_oooooo
oooo04Wooooo00?oo`00ooooooooool07_ooool<o`3jVR_ooooo00?o0000ooooooooool06_ooool0
1_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo08[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooo
ooooo`0Zooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool07_ooool00ooo003o0?ZJ
o`3jVP08o`3jVP03ool00?oooooooooo00Sooooo3?l0nYZHooooo`03o`000?oooooooooo047ooooo
0016ooooo`;o0000=?ooool00ol0nY[oooooooooo`0Yooooo`coo`005?ooool00ooo003ooooooooo
o`0Nooooo`03o`3jV_oooooooooo03?ooooo0_l0000Mooooo`05o`000?ooooooooooooooool00000
0oooool00ol0003oooooooooo`02oooooaKo003o00?o0?ZJo`00ool00?l0R_l00?l00ol0nY[o003o
o`00o`08o`00o`03o`3jV_l00?oo003o02[o003o00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Nooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool04oooool00ol0nY[ooooo
ooooo`2Fooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo03?ooooo00?o
0?ZJooooooooool0:Oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo01;ooooo00?o
o`00ooooooooool07_ooool00ol0nY[oooooooooo`0dooooo`03o`000?oooooooooo01cooooo00Co
0000oooooooooooooooo0ol00005ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool0
R_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo02[ooooo00?o0000ooooooooool0
9oooool2o`0001oooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0Cooooo`03o`3j
V_oooooooooo09Gooooo0_l00013ooooo`00A_ooool00ol0003oooooooooo`0cooooo`coo`005Ooo
ool<ool000[ooooo00?oo`00ooooooooool04_ooool00ooo003oooooooooo`09oooooaKo0?ZJ=_oo
ool00ol0003oooooooooo`0Iooooo`07o`000?ooooooooooooooool0003oooooo`000003ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`2:ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0:_ooool00ol0003oooooooooo`0Wooooo`03
o`000?oooooooooo01kooooo00?oo`00ooooooooool02?ooool<ool000[ooooo00?o0?ZJoooooooo
ool0U_ooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`0cooooo`03ool0
0?oooooooooo00Sooooo3?oo000:ooooo`03ool00?oooooooooo01?ooooo00?oo`00ooooooooool0
2?ooool;ool000_o0?ZJC?ooool00ol0003oooooooooo`0Iooooo`07o`000?ooooooooooooooool0
003oooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04oooool00ol0
nY[oooooooooo`20ooooo`_o0?ZJ2oooool00ol0nY[oooooooooo`0Yooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool07_ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo
00Sooooo00?oo`00ooooooooool02?ooool<o`3jVXgooooo00?o0000ooooooooool0@Oooool004Ko
oooo00?o0000ooooooooool0<oooool00ooo003oooooooooo`0Cooooo`coo`005Oooool00ooo003o
ooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool0E?ooool00ol0003o
ooooooooo`0Jooooo`?o00000oooool3o`0000Gooooo00?o0000ooooooooool04oooool00ol0nY[o
ooooooooo`20ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool0:Oooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo01kooooo00?oo`00ooooooooool02?ooool00ol0nY[o
ooooooooo`08ooooo`coo`002_ooool00ol0nY[oooooooooo`2;ooooo`03o`000?oooooooooo047o
oooo0016ooooo`;o0000=?ooool00ooo003oooooooooo`0dooooo`03ool00?oooooooooo00Sooooo
00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`1Cooooo`;o0000:_ooool00ol0003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo083ooooo00?o0?ZJooooooooool04oooool00ol0nY[ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool07_ooool00ooo003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ol0nY[ooooo
ooooo`2;ooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo03?ooooo00?o
o`00ooooooooool0=?ooool<ool000[ooooo00?o0?ZJooooooooool0E?ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool0P?ooool00ol0nY[ooooooooo
o`0Cooooo`03o`3jV_oooooooooo02Wooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0Nooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool04oooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo01?ooooo2ol0nYY]ooooo`03o`000?oooooooooo047ooooo0016
ooooo`03o`000?oooooooooo03?ooooo00?oo`00ooooooooool0B_ooool00ol0nY[oooooooooo`1D
ooooo`03o`000?oooooooooo02Sooooo0_l00009ooooo`coo`00Moooool<o`3jVP[ooooo2ooo0000
0ol0nY[oooooooooo`0Xooooo`;o0000:Oooool2o`0001oooooo00?oo`00ooooooooool02?ooool<
o`3jVP[ooooo00?oo`00ooooooooool02?ooool;o`3jVP_ooooo00?o0?ZJooooooooool01oooool0
0ol0nY[oooooooooo`1Zooooo`;o0000@oooool004Kooooo00?o0000ooooooooool0<oooool00ooo
003oooooooooo`1:ooooo`03o`3jV_oooooooooo05Cooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool0MOooool00ol0
nY[oooooooooo`0Cooooo`03ool00?oooooooooo00Oooooo00?oo`00o`3jV_ooool02OoooolFo`3j
VP_ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Nooooo`03ool00?oooooooooo
01?ooooo2ol0nYX<ool000[ooooo2ol0nYX:ooooo`03o`3jV_oooooooooo06_ooooo00?o0000oooo
ooooool0@Oooool004Kooooo0_l0000dooooo`03ool00?oooooooooo04Wooooo00?o0?ZJoooooooo
ool0E?ooool2o`0002[ooooo00?o0000ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03
ool00?oooooooooo07Gooooo00?o0?ZJooooooooool04oooool00ooo003oooooooooo`07ooooo`03
ool00?l0nY[ooooo00Wooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_l0003ooooo02;ooooo0_l00004ooooo`03o`000?oooooooooo01kooooo00?oo`00oooooooo
ool07_ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo01?ooooo2ooo001]ooooo`03
o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo01?ooooo2ol0nYXEooooo`03ool0
0?oooooooooo04Wooooo00?o0?ZJooooooooool0EOooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`1Zooooo`co0?ZJ
5Oooool00ooo003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Wo0?ZJ5Oooool00ol0nY[ooooo
ooooo`08ooooo`03o`3jV_l0003ooooo027ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`0Nooooo`03ool00?oooooooooo01kooooo00?o0?ZJooooooooool02?ooool00ooo003o
ooooooooo`0Cooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool0Joooool00ol0003o
ooooooooo`11ooooo`00?_ooool3o`0000Gooooo00?o0000ooooooooool04oooool00ol0nY[ooooo
ooooo`07ooooo`03o`3jV_oooooooooo01?ooooo00?oo`00ooooooooool0:Oooool<o`3jVQCooooo
00?o0?ZJooooooooool0EOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo00Sooooo
00?oo`00ooooooooool02?ooool00ooo003oooooooooo`1Zooooo`03o`3jV_oooooooooo01kooooo
00?oo`00ooooooooool01oooool00ooo003oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo
00?o0?ZJo`000?ooool08Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo01ko
oooo00?oo`00ooooooooool07_ooool00ol0nY[oooooooooo`08ooooo`_oo`002_ooool00ooo003o
ooooooooo`08ooooo`03ool00?l0nY[o0?ZJ00Wo0?ZJ2_ooool<o`3jVTcooooo00?o0000oooooooo
ool0@Oooool003gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo01?o
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Cooooo`03ool00?oooooooooo02Wo
oooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo05Go
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`08ooooo`03ool00?oooooooooo00So
oooo00?oo`00ooooooooool0J_ooool00ol0nY[oooooooooo`0Nooooo`03ool00?oooooooooo00Oo
oooo00?oo`00ooooooooool07_ooool<o`3jVP03o`000?oooooooooo023ooooo00Co0000oooooooo
oooo00000oooool3o`0001kooooo00?oo`00ooooooooool07_ooool<o`3jVP[ooooo2ooo000:oooo
o`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08oooo
oaOo0?ZJ=?ooool3o`0004?ooooo000mooooo`05o`000?ooooooooooooooool000001?ooool00ol0
003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool04oooool00ooo
003oooooooooo`0Nooooo`co0?ZJ2_ooool00ol0nY[oooooooooo`08ooooo`_o0?ZJEoooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo
003oooooooooo`1Zooooo`03o`3jV_oooooooooo01gooooo00?oo`00ooooooooool02?ooool00ooo
003oooooooooo`0Zooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`0Nooooo`03ool00?oooooooooo02Wooooo00?o0?ZJooooooooool04oooool:
o`3jVP03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0N
ooooo`03o`3jV_oooooooooo03Cooooo00?o0000ooooooooool0@Oooool003gooooo1?l00005oooo
o`;o00005?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01?ooooo00?oo`00o`3j
V_l0nYX05?l0nYX:ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool02?ooool00ol0
nY[oooooooooo`1Nooooo`;o0000:_ooool<ool000[ooooo00?oo`00ooooooooool0<oooool<o`3j
VP[ooooo3?l0nYX:ooooo`co0?ZJ7oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo
02Wooooo0_l0000Rooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool07_ooool0
0ooo003oooooooooo`0Yooooo`_o0?ZJ2oooool00ol0nY[oooooooooo`07ooooo`coo`002_l0nYX<
ool000[ooooo3?oo000fooooo`03o`000?oooooooooo047ooooo000mooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo
00Sooooo2ol0nYX00ooo003oooooooooo`0Cooooo`co0?ZJ5Oooool00ol0nY[oooooooooo`08oooo
o`03o`3jV_oooooooooo05oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Coooo
o`03ool00?oooooooooo03?ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08oooo
o`03o`3jV_oooooooooo00Sooooo3?l0nYXZooooo`03ool00?oooooooooo00Wooooo00?oo`00oooo
ooooool0:Oooool00ol0003oooooooooo`0Qooooo`;o00001?ooool00ol0003oooooooooo`0Noooo
o`03ool00?oooooooooo03Cooooo2ol0nYX:ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00oooo
ooooool02?ooool00ooo003oooooooooo`08ooooo`coo`002_ooool00ooo003o0?ZJo`3jVP0Do`3j
VR3ooooo00?o0?ZJooooooooool0@Oooool003kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`08ooooo`03ool00?oooooooooo03Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`1Oooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool04oooool00ooo003o
ooooooooo`0cooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`0nooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool0:Oooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo01kooooo00?oo`00ooooooooool0BOooool00ol0nY[o
ooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool04oooool;o`3jVP03
ool00?oooooooooo01?ooooo8Ol0nYX00ol0003oooooooooo`11ooooo`00?oooool2o`0000Gooooo
00?o0000ooooooooool04oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Sooooo
00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`0dooooo`co0?ZJHOooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool0<oooool00ol0nY[ooooo
ooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0=?ooool;ool000_ooooo
00?oo`00ooooooooool0:Oooool00ol0003oooooooooo`0Wooooo`;o00007oooool00ooo003ooooo
ooooo`19ooooo`_o0?ZJ3?oo000Fo`3jVP[ooooo5ooo000Oooooo`03o`000?oo003ooooo04;ooooo
0016ooooo`;o00005?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool02?ooool00ooo003oooooooooo`2Pooooo`;o0000:_ooool00ol0003ooooooooo
o`0Cooooo`03ool00?oooooooooo02Sooooo3?l0nYX:ooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool0=?ooool00ooo003oooooooooo`0Cooooo`03ool00?oooooooooo02Wooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Nooooo`03ool00?oooooooooo05Cooooo00?o
0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo01?ooooo8Ooo
00000ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooo
oooo0:7ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooo
oooo02Sooooo00?o0?ZJooooooooool04oooool<o`3jVSKooooo00?oo`00ooooooooool04oooool0
0ooo003oooooooooo`0Yooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool07_ooool0
0ooo003oooooooooo`1Dooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool07_ooool0
0ol0nY[oooooooooo`08ooooo`co0?ZJ8?ooool00ol0nY[oooooooooo`11ooooo`00A_ooool00ol0
003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0
nY[oooooooooo`08ooooo`03ool00?oooooooooo0:7ooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Cooooo`03ool00?oooooooooo01?ooooo2ol0nYX:ooooo`03o`3jV_oooooooooo
05Gooooo00?oo`00ooooooooool02?ooool;o`3jVP03ool00?oooooooooo00Sooooo2ooo000Foooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool07_ooool00ooo003oooooooooo`1Doooo
o`co0?ZJ8?ooool<o`3jVP[ooooo8Ol0nYX00ol0003oooooooooo`11ooooo`00A_ooool00ol0003o
ooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`08ooooo`03ool00?oooooooooo0:7ooooo00?o0000ooooooooool0:?ooool2o`0001Co
oooo00?oo`00ooooooooool04oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooooooool0B_ooool<ool000[ooooo00?o0?ZJooooooooool01oooool00ol0nY[o
o`00ooooo`09ooooo`03ool00?oooooooooo00Oooooo3?oo000:ooooo`03ool00?l0003ooooo02So
oooo00?o0000ooooooooool07_ooool00ooo003oooooooooo`2gooooo`03o`000?oooooooooo047o
oooo0016ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooo
ooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool0XOooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool04oooool00ol0nY[ooooo
ooooo`07ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0B_ooool00ooo003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJool00?oo00002Ooo000Eooooo`03ool0
0?oooooooooo00Sooooo00?oo`00o`000?ooool0:?ooool2o`0001oooooo00?oo`00ooooooooool0
]_ooool2o`0004?ooooo0016ooooo`;o00005?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`2Pooooo`;o0000:_oo
ool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo01?ooooo00?o0?ZJooooooooool02?oo
ool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo04[ooooo00?oo`00ooooooooool04ooo
ool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01kooooo00?oo`00ooooooooool02?oo
ool00ooo003o0000ooooo`0Xooooo`03o`000?oooooooooo00Sooooo3?l0nYX:ooooo`03ool00?oo
oooooooo0;Oooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000ooooooooool04oooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool0
0ooo003oooooooooo`2Qooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool04oooool0
0ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo2ol0nYY1ooooo`coo`005Oooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01kooooo3?oo00000ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08
ooooo`03ool00?oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000oooo
ooooool04oooool00ol0nY[oooooooooo`07ooooo`co0?ZJ2_ooool00ooo003oooooooooo`2Qoooo
o`03o`000?oooooooooo01[ooooo0ol00004ooooo`;o00001Oooool00ol0003oooooooooo`0Coooo
o`03ool00?oooooooooo01?ooooo00?o0?ZJooooooooool0E?ooool00ooo003oooooooooo`0Noooo
o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0:_ooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08oooo
o`03ool00?oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`0Mooooo`03ool00?oooooooooo0:7ooooo00?o0000oooooooo
ool06Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool0
0ol0003oooooooooo`0Cooooo`03ool00?oooooooooo01?ooooo00?o0?ZJooooooooool0E?ooool0
0ooo003oooooooooo`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0:_ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool0
04Kooooo0_l0000Dooooo`_oo`005Oooool00ooo003oooooooooo`2Pooooo`;o00007oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00;ooooo0_l0000Dooooo`03ool00?oooooo
oooo01?ooooo00?o0?ZJooooooooool0E?ooool00ooo003oooooooooo`0Mooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool0:?ooool3o`0002Wooooo0_l00009ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`2fooooo`;o0000@oooool0
04Kooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo
00Sooooo3?oo002Sooooo`03o`000?oooooooooo01_ooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Cooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooo
oooo05Cooooo00?oo`00ooooooooool07Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo
oooo02Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`2gooooo`03o`000?oooooo
oooo047ooooo000nooooo`?o00001Oooool00ol0003oooooooooo`0Booooo`03o`3jV_oo003ooooo
00Sooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo
0:7ooooo00?o0000ooooooooool07Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooo
oooo04Wooooo3?oo000Oooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0:Oooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool0
03gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJ
ool00?ooool02?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0XOooool00ol0003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool0
4oooool00ol0nY[oooooooooo`0Mooooo`coo`002_oooolGool002[ooooo00?o0?ZJooooooooool0
2Oooool00ol0nY[oooooooooo`0Yooooo`03o`000?oooooooooo01oooooo1Ol00003ooooo`co0?ZJ
2_ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo0;Oooooo00?o0000ooooooooool0
@Oooool003gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJool00?ooool02?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo
00?o0?ZJooooooooool0XOooool00ol0003oooooooooo`0Jooooo`?o00001?ooool2o`0000Gooooo
00?o0000ooooooooool04oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo01gooooo
00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo03Cooooo
2ol0nYX;ooooo`03o`3jV_oooooooooo02Wooooo00?o0000ooooooooool08?ooool01?l0003ooooo
ooooool00003ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool02?ooool00ooo003o
ooooooooo`2gooooo`03o`000?oooooooooo047ooooo000nooooo`?o00001Oooool2o`0001?ooooo
00?o0?ZJool00?ooool02?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo
00?o0?ZJooooooooool0X?ooool2o`0002[ooooo00?o0000ooooooooool04oooool00ooo003ooooo
ooooo`0Booooo`03o`3jV_oooooooooo01kooooo00?oo`00ooooooooool02?ooool00ooo003ooooo
ooooo`08ooooo`03ool00?oooooooooo03Cooooo00?o0?ZJooooooooool04oooool00ol0nY[ooooo
ooooo`0Yooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool0]oooool00ol0003ooooo
ooooo`11ooooo`00?Oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
4_ooool00ol0nY[oo`00ooooo`08ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool0
2?ooool00ol0nY[oooooooooo`2Qooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0
4oooool00ooo003oooooooooo`0Booooo`03o`3jV_oooooooooo01kooooo00?oo`00ooooooooool0
2?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo03Cooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`08oooooaKo0?ZJ2_ooool00ol0nY[o0000ooooo`0Sooooo`03o`00
0?oooooooooo00;ooooo0ol0000Cooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool0
]Oooool3o`0004?ooooo000mooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`0Booooo`03o`3jV_oo003ooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0:?ooool2o`0000Wooooo
2ol0nYX00ooo003oooooooooo`0Booooo`03o`3jV_oooooooooo01?ooooo3?oo000:ooooo`03ool0
0?oooooooooo00Sooooo00?oo`00ooooooooool0=?ooool00ol0nY[oooooooooo`0Cooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`08ooooo`03o`3j
V_l0003ooooo023ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01?o
oooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`2gooooo`03o`000?oooooooooo047o
oooo000nooooo`?o00001Oooool00ol0003oooooooooo`0Booooo`03o`3jV_oo003ooooo00Sooooo
00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo0:7ooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Sooooo
00?oo`00ooooooooool04_ooool00ol0nY[oooooooooo`0Cooooo`03ool00?oooooooooo01?ooooo
3?oo000fooooo`03o`3jV_oooooooooo01?ooooo2ol0nYXEooooo`03o`3jV_oooooooooo00Sooooo
00?o0?ZJo`000?ooool08?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo0;Oooooo00?o0000oooooooo
ool0@Oooool004Kooooo0_l0000Cooooo`03o`3jV_oo003ooooo00Sooooo00?oo`00ooooooooool0
2?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo0:3ooooo0_l0000Zooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`0Booooo`03o`3j
V_oooooooooo01?ooooo00?oo`00ooooooooool0B_ooool<o`3jVSGooooo3?l0nYX00ol0003ooooo
ooooo`0Pooooo`?o00001?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo
00?oo`00ooooooooool0]oooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003ooooooooo
o`0Booooo`03o`3jV_oo003ooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool04_ooool00ol0nY[ooooooooo
o`0Cooooo`03ool00?oooooooooo04[ooooo00?o0?ZJooooooooool0B_ooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool02?ooool00ooo003ooooooooo
o`2gooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJ
ool00?ooool02?ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0XOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool02?ooool00ooo003oooooooooo`0Booooo`03o`3jV_oooooooooo01?ooooo00?oo`00
ooooooooool0B_ooool00ol0nY[oooooooooo`1:ooooo`03o`000?oooooooooo02Oooooo0_l0000D
ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool0]_ooool2o`0004?ooooo0016oooo
o`03o`000?oooooooooo01;ooooo00?o0?ZJool00?ooool02?ooool00ooo003oooooooooo`08oooo
o`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool0XOooool00ol0003oooooooooo`0Xoooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`0Boooo
o`03o`3jV_oooooooooo01?ooooo00?oo`00ooooooooool0?oooool<o`3jVTcooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo00?oo`00oooo
ooooool0]oooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`0Booooo`03
o`3jV_oo003ooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03
o`3jV_oooooooooo0:7ooooo00?o0000ooooooooool0:?ooool<o`3jVP[ooooo00?oo`00oooooooo
ool04_ooool00ol0nY[oo`00ool00009ool000[ooooo00?oo`00ooooooooool0?oooool00ol0nY[o
ooooooooo`1Eooooo`03o`000?oooooooooo02Oooooo5_l00?l00ol0nY[o003oo`00o`08o`00o`03
ool00?l00?oo003o0;So003o@oooool004Kooooo2ol0nYX:ooooo`03o`3jV_oo003ooooo00Sooooo
3?oo000;o`3jVZ;ooooo0_l0000Zooooo`;o00005?ooool00ooo003oooooooooo`0Booooo`03o`3j
V_oo003ooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0oooooo`03o`3j
V_oooooooooo05Cooooo0_l0000Yooooo`03o`000?oooooooooo01?ooooo2ol0nYX00ooo003ooooo
ooooo`2gooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool02?ooool00ol0nY[oo`00ooooo`0Cooooo`03o`3jV_oooooooooo0:cooooo00?o
0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo2ol0
nYX00ooo003oooooooooo`08ooooo`_oo`00@Oooool00ol0nY[oooooooooo`1Eooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07_ooool00ooo003oooooooooo`2gooooo`03o`000?oo
oooooooo047ooooo0016ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oo`00ooooo`0Cooooo`03o`3jV_oooooooooo0:cooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool0
0ooo003oooooooooo`1Dooooo`03o`3jV_oooooooooo05Gooooo00?o0000ooooooooool09oooool2
o`0001oooooo00?oo`00ooooooooool0]_ooool2o`0004?ooooo0016ooooo`03o`000?oooooooooo
00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oo`00o`3jVP09o`3jVP[ooooo00?o0?ZJoooo
ooooool0[?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo01?ooooo00?oo`00oooo
ooooool02?ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo04Wooooo3?l0nYYGoooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02?ooool<ool000[ooooo00?oo`00oooo
ooooool0]oooool00ol0003oooooooooo`11ooooo`00A_ooool2o`0000Wooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oo`00ooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooooooo
ool0Zoooool2o`0002[ooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`08ooooo`03
o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool0?_ooool<o`3jVV;ooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?oo`00oooooooo
ool02?ooool00ooo003oooooooooo`2gooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool01oooool00ol0nY[oo`00ooooo`08ooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool0[?ooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`08ooooo`03ool0
0?oooooooooo01gooooo3?l0nYX:ooooo`co0?ZJKOooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03ool0
0?oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool003Sooooo0ol00004ooooo`;o00001Ooo
ool00ol0003oooooooooo`08ooooo`[o0?ZJ00?oo`00o`3jV_ooool02?ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo0:cooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`0Cooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003ooooooooo
o`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooooooo
o`1fooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02?ooool00ooo003ooooooooo
o`08ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool0]oooool00ol0003ooooooooo
o`11ooooo`00>Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool04_ooool00ooo003o0?ZJooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool0[?ooool00ol0003oooooooooo`0Xooooo`;o00005?ooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool07Oooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0MOooool2o`0002Wooooo0_l0
0009ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool02?ooool00ooo003ooooooooo
o`2fooooo`;o0000@oooool003Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo01;ooooo00?oo`00o`3jV_ooool02?ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo0:cooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`0Cooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ooo003ooooooooo
o`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooooooo
o`1fooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02?ooool00ooo003ooooooooo
o`08ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool0]oooool00ol0003ooooooooo
o`11ooooo`00>Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo5Ol0
0?l00ooo003o0?ZJo`00o`08o`00o`03o`3jV_l00?oo003o00So003o00?o0?ZJo`00ool00?l0[Ol0
0?lZooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ol0nY[ooooooooo
o`08ooooo`03ool00?oooooooooo01gooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo07Kooooo00?o0000ooooooooool09oooool<ool000[ooooo00?o
o`00ooooooooool02?ooool00ooo003oooooooooo`2gooooo`03o`000?oooooooooo047ooooo000i
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`0Booooo`03ool00?l0nY[ooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooooooo
o`2/ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool04oooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool04_ooool<o`3jVP[ooooo3?l0
nYYhooooo`03o`000?oooooooooo027ooooo0ol00003ooooo`03o`000?oooooooooo01?ooooo00?o
o`00ooooooooool02?ooool00ooo003oooooooooo`2gooooo`03o`000?oooooooooo047ooooo000h
ooooo`;o00001?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo01;ooooo00?o
o`00o`3jV_ooool02?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0:cooooo00?o
0000ooooooooool06_ooool3o`0000;ooooo1Ol00004ooooo`03o`000?oooooooooo01?ooooo00?o
o`00ooooooooool02?ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo01;ooooo00?o
0?ZJooooooooool0Uoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool04oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo0;Oooooo00?o
0000ooooooooool0@Oooool003Wooooo00?o0000ooooooooool00oooool2o`0000Gooooo00?o0000
ooooooooool04_ooool00ooo003o0?ZJooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJ
ooooooooool0[?ooool00ol0003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool0
2?ooool00ol0nY[oooooooooo`07ooooo`03ool00?oooooooooo01?ooooo00?o0?ZJooooooooool0
Uoooool00ol0003oooooooooo`0Oooooo`Go00000oooool3o`0001?ooooo00?oo`00ooooooooool0
2?ooool00ooo003oooooooooo`2eooooo`?o0000@oooool004Kooooo0_l0000Cooooo`03ool00?l0
nY[ooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`2[ooooo`;o00007ooo
ool01Ol0003ooooooooooooooooo000000Kooooo0_l0000Dooooo`03ool00?oooooooooo00Sooooo
00?o0?ZJooooooooool01oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo09Gooooo
0ol0000Qooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool04oooool<ool00;Wo
oooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000ooooooooool04_ooool00ooo003o0?ZJ
ooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0[?ooool00ol0003ooooo
ooooo`0Kooooo`;o00001Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?ooooo
00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`07ooooo`03ool00?oooooooooo01?ooooo
00?o0?ZJooooooooool0Uoooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo000000Cooooo
00?o0000ooooooooool07_ooool00ol0nY[oooooooooo`2gooooo`03o`000?oooooooooo047ooooo
0016ooooo`03o`000?oooooooooo01;ooooo00?oo`00o`3jV_ooool02?ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo0:cooooo00?o0000ooooooooool07Oooool00ol0003oooooo`00
0003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04oooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Oooooo00?oo`00ooooooooool04oooool00ol0nY[ooooooooo
o`2Gooooo`03o`000?oooooooooo027ooooo0_l00004ooooo`03o`000?oooooooooo01kooooo00?o
0?ZJooooooooool0]oooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`0B
ooooo`03ool00?l0nY[ooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`2/
ooooo`03o`000?oooooooooo01Wooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo
00?o0?ZJooooooooool01oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo09Oooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo01kooooo
00?o0?ZJooooooooool0]oooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003ooooooooo
o`0Booooo`03ool00?l0nY[ooooo00Sooooo3?l0nYZ^ooooo`03o`000?oooooooooo01[ooooo0ol0
0003ooooo`?o00001Oooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?o
0?ZJooooooooool01oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo09Oooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Nooooo`03o`3jV_oooooooooo0;Oooooo00?o
0000ooooooooool0@Oooool004Kooooo2ooo000:ooooo`03ool00?l0nY[ooooo0<7ooooo0_l0000Z
ooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`07
ooooo`03ool00?l0nY[o0?ZJ00Wo0?ZJ2_ooool00ol0nY[oooooooooo`2Gooooo`03o`000?oooooo
oooo02Oooooo0_l0000Oooooo`03o`3jV_oooooooooo0;Kooooo0_l00013ooooo`00A_ooool00ol0
003oooooooooo`07ooooo`03ool00?oooooooooo00Sooooo00?oo`00o`3jV_ooool0`_ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ol0
nY[oooooooooo`07ooooo`03ool00?l0nY[ooooo00Wooooo2ol0nYZIooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool07_ooool00ol0nY[oooooooooo`2gooooo`03o`000?oooooooooo
047ooooo0016ooooo`03o`000?oooooooooo00Oooooo00?oo`00ooooooooool02?ooool00ooo003o
0?ZJooooo`32ooooo`03o`000?oooooooooo02Sooooo0_l0000Dooooo`03ool00?oooooooooo00So
oooo00?o0?ZJooooooooool01oooool00ooo003o0?ZJooooo`2/ooooo`;o0000:Oooool00ol0003o
ooooooooo`0Nooooo`03o`3jV_oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool004Kooooo
00?o0000ooooooooool01oooool00ooo003oooooooooo`08ooooo`03ool00?l0nY[ooooo0<;ooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo
00?o0?ZJooooooooool01oooool00ooo003o0?ZJooooo`2]ooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool07_ooool00ol0nY[oooooooooo`2gooooo`03o`000?oooooooooo047ooooo
0016ooooo`;o00002Oooool00ooo003oooooooooo`07ooooo`03ool00?l0nY[ooooo0<7ooooo0_l0
000Zooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ol0nY[ooooooooo
o`07ooooo`03ool00?l0nY[ooooo0:gooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0Nooooo`03o`3jV_oooooooooo0;Oooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000
ooooooooool02?ooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo0<;ooooo00?o0000
ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03ool00?l0nY[o0?ZJ00So0?ZJ2ooo0000
0ol0nY[oooooooooo`2/ooooo`03o`000?oooooooooo02Oooooo0_l00009ooooo`co0?ZJ2_ooool0
0ol0nY[oooooooooo`2fooooo`;o0000@oooool003Sooooo0ol00002ooooo`Go00001?ooool00ol0
003oooooooooo`08ooooo`_oo`00a?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01?ooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo
0:cooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
00Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`2gooooo`03o`000?oooooooooo
047ooooo000iooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`0Booooo`03o`3jV_oooooooooo0<;ooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool02?ooool00ol0
nY[oooooooooo`2/ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0]oooool00ol0
003oooooooooo`11ooooo`00>Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`32ooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool04oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00So
oooo00?o0?ZJooooooooool0[?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0;Oo
oooo00?o0000ooooooooool0@Oooool003Wooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`03ooooo`;o00004oooool00ol0nY[oooooooooo`31ooooo`;o0000:_ooool2o`0001Cooooo
00?oo`00ooooooooool02?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo0:_ooooo
0_l0000Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool<o`3jV[Wooooo
00?o0000ooooooooool0@Oooool003Wooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`32ooooo`03o`00
0?oooooooooo02Sooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`08ooooo`03ool0
0?oooooooooo00Sooooo00?o0?ZJooooooooool0[?ooool00ol0003oooooooooo`0Wooooo`;o0000
2Oooool00ol0nY[oooooooooo`3<ooooo`;o0000@oooool003Sooooo0_l00003ooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo0<;ooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo
00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`2/ooooo`03o`000?oooooooooo02Oooooo
3?l0nY[?ooooo`03o`000?oooooooooo047ooooo000iooooo`03o`000?oooooooooo00;ooooo0ol0
0005ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0`_ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo01?ooooo00?oo`00ooooooooool02?ooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo0:cooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`;o00004oooool00ol0nY[oooooooooo`31
ooooo`;o0000:_ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?oo`00
ooooooooool02?ooool00ol0nY[oooooooooo`2/ooooo`03o`000?oooooooooo023ooooo0ol00004
ooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool004Kooooo00?o0000oooo
ooooool04_ooool00ol0nY[oooooooooo`32ooooo`03o`000?oooooooooo02Sooooo00?o0000oooo
ooooool04oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJoooo
ooooool0[?ooool00ol0003oooooooooo`0Oooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo
01;ooooo00?o0?ZJooooooooool0`_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01?ooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`07ooooo`03o`3jV_oooooooooo
0:gooooo00?o0000ooooooooool07oooool01Ol0003ooooooooooooooooo000000?ooooo0ol0003F
ooooo`?o0000@oooool004Kooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`32oooo
o`03o`000?oooooooooo02Sooooo0_l0000Dooooo`03ool00?oooooooooo00Sooooo00?oo`00oooo
ooooool01oooool00ol0nY[oooooooooo`2/ooooo`;o00008Oooool4o`0000Cooooo00?o0000oooo
ooooool0f?ooool00ol0003oooooooooo`11ooooo`00A_ooool00ol0003oooooooooo`0Booooo`03
o`3jV_oooooooooo0<;ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Cooooo`03
ool00?oooooooooo00Sooooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`2]ooooo`03
o`000?oooooooooo01oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3Hooooo`03
o`000?oooooooooo047ooooo0016ooooo`_o0?ZJ2_ooool00ol0nY[oooooooooo`31ooooo`;o0000
:_ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool0
1oooool00ol0nY[oooooooooo`2]ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oo
oooooooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`32ooooo`03o`000?oo
oooooooo02Sooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`08ooooo`03ool00?oo
oooooooo00Oooooo00?o0?ZJooooooooool0[Oooool00ol0003oooooooooo`0Qooooo`;o00001?oo
ool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooo
oooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`32ooooo`03o`000?oooooo
oooo01[ooooo0ol00004ooooo`?o00001?ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooo
oooo00Sooooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`2]ooooo`03o`000?oooooo
oooo02Oooooo0_l0003Hooooo`;o0000@oooool004Kooooo00?o0000ooooooooool01oooool00ol0
nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0<;ooooo00?o0000ooooooooool06Oooool01Ol0
003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0C
ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`2]
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11
ooooo`00A_ooool2o`0000Wooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`31oooo
o`;o00007oooool00ol0003oooooo`000004o`0000Cooooo0_l0000Dooooo`03ool00?oooooooooo
00Sooooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`2[ooooo`?o0000:Oooool00ol0
003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo0016ooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`32ooooo`03o`000?oooooooooo01_o
oooo0_l00002ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool04oooool00ooo
003oooooooooo`08ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool0[Oooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool003So
oooo0ol00004ooooo`?o00001?ooool00ol0003oooooooooo`08ooooo`_o0?ZJa?ooool00ol0003o
ooooooooo`0Mooooo`06o`000?ooooooooooo`000?oooooo00001Oooool00ol0003oooooooooo`0C
ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`2]
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11
ooooo`00>Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0eoooool00ol0003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000000oooool2
o`0000Gooooo00?o0000ooooooooool04oooool00ooo003oooooooooo`08ooooo`03ool00?oooooo
oooo00Oooooo00?o0?ZJooooooooool0[Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo0=Sooooo00?o0000ooooooooool0@Oooool003Wooooo00Co0000oooooooooooooooo1Ol00004
ooooo`03o`000?oooooooooo0=Oooooo00?o0000ooooooooool06_ooool3o`0000Gooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?oo`00
ooooooooool01oooool00ol0nY[oooooooooo`2]ooooo`03o`000?oooooooooo02Oooooo0_l0003H
ooooo`;o0000@oooool003Wooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooo
oooo00?ooooo0_l0003Gooooo`;o0000:_ooool00ol0003oooooooooo`0Cooooo`03ool00?oooooo
oooo00Sooooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`2]ooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`11ooooo`00>Oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0eoooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo01?ooooo3?oo000:o`3jVZoooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo047ooooo000hooooo`;o
00001Oooool2o`0000Gooooo00?o0000ooooooooool0eoooool00ol0003oooooooooo`0Xooooo`;o
00005?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0;Kooooo0_l0000Yooooo`03
o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool003Wooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0=Oooooo00?o0000ooooooooool0
:?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0
]oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0
@Oooool004Kooooo0_l0003Gooooo`;o0000:_ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00Sooooo00?o0?ZJooooooooool0]oooool00ol0003oooooooooo`0Wooooo`;o0000f?oo
ool2o`0004?ooooo0016ooooo`03o`000?oooooooooo0=Oooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0]oooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool0
04Kooooo00?o0000ooooooooool0eoooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01?ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`2gooooo`03o`000?oooooooooo
023ooooo0ol00004ooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0@Oooool004Ko
oooo00?o0000ooooooooool0eoooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo01?o
oooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`2gooooo`03o`000?oooooooooo01oo
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0=Sooooo00?o0000oooo
ooooool0@Oooool004Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo02Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o
00008Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo047ooooo0016ooooom_o0000:_oooolFo`000003
o`3jV_l0003o000000So000000?o0?ZJo`000?l00000^?l0000Rooooo`?o00001?oooooLo`0004?o
oooo003oooooooooooooB_ooool01Ol0003ooooooooooooooooo00000?oooooo8oooool00?oooooo
oooooom:ooooo`05o`000?ooooooooooooooool00000oooooolSooooo`00oooooooooooood_ooooo
0ol0003oooooobCooooo003ooooooooooooooooooombooooo`00/Oooool3o`000?oooooooooooonm
ooooo`00]?ooool00ol0003oooooooooo`3ooooooooooooo^_ooool00:Cooooo1?l00002ooooo`Go
00000_ooool4o`000006ooooool0003oooooo`000?oooooo00000_ooool4o`000?Cooooo0ol0003o
ooooo`Cooooo1?l0002`ooooo`00Z?ooool01Ol0003ooooooooooooooooo000000?ooooo00go0000
ooooooooooooooooo`000?oooooo0000ooooool0003oooooo`000?oooooo000000;ooooo00?o0000
ooooooooool0m?ooool00ol0003oooooooooo`3oooooo`Cooooo00Co0000oooooooooooo0000[ooo
ool00:Gooooo0ol00004ooooo`05o`000?ooooooooooooooool000000oooool01ol0003oooooo`00
0?oooooo0000ooooool000000_ooool3o`000?Kooooo00?o0000ooooooooool0ooooool4ooooo`04
o`000?ooooooooooo`000:oooooo002Tooooo`03o`000?oooooooooo00Gooooo00Go0000oooooooo
ooooooooo`000003ooooo`09o`000?oooooo0000ooooool0003oooooo`000?oooooo000000;ooooo
00?o0000ooooooooool0m?ooool2o`000?oooooo1Oooool01?l0003oooooooooool0002_ooooo`00
YOooool4o`000004ooooool0003o0000o`0000Cooooo1ol000000ooooooo0000ooooo`02ooooo`;o
0000m_ooool2o`000003ooooool0003o00000?oooooo0oooool3o`000;3ooooo003ooooooooooooo
__ooool00ol0003oooooooooo`2`ooooo`00[?ooool00ol0003oooooooooo`3ooooooooooooo3_oo
ool2o`000;;ooooo003ooooooooooooooooooombooooo`00ooooooooooooooooooooL_ooool006_o
oooo1Ol00003ooooo`;o00001?ooool2o`0001kooooo0ol00003ooooo`;o00001?ooool2o`0001go
oooo0ol00004ooooo`;o00001?ooool2o`0001cooooo0ol00004ooooo`;o00001?ooool2o`0001[o
oooo0ol00004ooooo`;o00001?ooool2o`0000Cooooo0_l00014ooooo`Go00000oooool2o`0000Co
oooo0_l0000Mooooo`?o00000oooool2o`0000Cooooo0_l0000Mooooo`?o00001?ooool2o`0000Co
oooo0_l0000Mooooo`?o00001?ooool2o`0000Cooooo0_l0000Iooooo`?o00001?ooool2o`0000Co
oooo0_l00004ooooo`;o0000@Oooool5o`0000?ooooo0_l00004ooooo`;o00007_ooool3o`0000?o
oooo0_l00004ooooo`;o00007?ooool3o`0000Cooooo0_l00004ooooo`;o00007Oooool3o`0000Co
oooo0_l00004ooooo`;o00006_ooool3o`0000Cooooo0_l00004ooooo`;o00001?ooool2o`0003[o
oooo001/ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Nooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo01Wooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006_ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Jooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0004Cooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001gooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06Oooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Koooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000@Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007_ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0H
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0001_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000ioooo
o`00KOooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00006oooool5o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Kooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0015ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Jooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00006oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000Iooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
04;ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001_ooooo1Ol00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00006_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Kooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001[ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
>Oooool006kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool06Oooool01?l0003oooooooooool00003ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00006oooool4o`0000?ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Kooooo`?o00000oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001[ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000A_ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0H
ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Kooooo`Co00000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001cooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
6Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00013ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Wooooo00Co0000oooooooooooo
00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001[ooooo1?l00003
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007?ooool3o`0000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Jooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0003Wooooo001[ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001cooooo00?o0000ooooool000000oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001_ooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001[ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00013ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001_ooooo00?o0000ooooool00000
0oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001_ooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001_ooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00006Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00010ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001cooooo00?o0000
ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001[ooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000iooooo`00Joooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Mooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01cooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0001[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00006Oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004?ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007?ooool2
o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Looooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Koooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001Sooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00010ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001gooooo0_l00003ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006oooool00ol0003oooooooooo`03
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006oooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000I
ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo0000>Oooool006cooooo0ol00004ooooo`;o00001?ooool2o`0001oooooo
00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Nooooo`;o00001?ooool2o`0000Cooooo
0_l0000Looooo`?o00001?ooool2o`0000Cooooo0_l0000Kooooo`03o`000?oooooooooo00?ooooo
0_l00004ooooo`;o00001?ooool2o`0004Gooooo0ol00004ooooo`;o00001?ooool2o`0001kooooo
00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Nooooo`;o00001?ooool2o`0000Cooooo
0_l0000Mooooo`?o00001?ooool2o`0000Cooooo0_l0000Jooooo`03o`000?oooooooooo00?ooooo
0_l00004ooooo`;o00001?ooool2o`0004;ooooo0ol00004ooooo`;o00001?ooool2o`0001oooooo
00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Mooooo`;o00001?ooool2o`0000Cooooo
0_l0000Mooooo`?o00001?ooool2o`0000Cooooo0_l0000Kooooo`03o`000?oooooooooo00?ooooo
0_l00004ooooo`;o00001?ooool2o`0003[ooooo003ooooooooooooooooooombooooo`00oooooooo
ooooooooooooL_ooool00?ooooooooooooooooooog;ooooo0019ooooo`Ko000000Ko0?ZJo`000?l0
003oo`00o`000?oo0004o`0000;oo`000ol000000ooo003o0000o`000017o`000004o`3jV_oo003o
0000ool007So0000:_ooool5o`000007o`3jV_l0003o0000ool00?l0003o003oool00003o`000003
ool00?l0003oo`0000;o000000?oo`00o`000?oo0000:Ol00002o`3jVQ[o000000Oo0?ZJool00?l0
003o0000o`3jV_l0003oo`0007Wo00009_ooool3o`0000?o003o00?o0000o`00ool000000_l00000
1_l0nY[o0000o`000?oo003o0?ZJool000;o000000Coo`00o`000?l0nY[oo`007ol00002o`3jVWKo
00000_oo000/o`0004?ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Ko0?ZJoooooooooooo
o`00oooooooo0004ooooo`;oo`000oooool00ooo003o0000ooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`05ooooo`04o`3jV_oo003ooooo
ool000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooo
oooo00;ooooo00Oo0?ZJooooooooooooo`00ooooool00?ooo`0000?ooooo00?oo`00oooooooo0000
0_ooool00ooo003oooooool0000:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ2_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00;ooooo00Oo0?ZJool00?ooooooooooo`3jV_ooooooo`0000[ooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool2o`0002Kooooo0ol00006ool000;ooooo00Ko0?ZJooooooooooooo`00o`3jV_oo
0002ooooo`04ool00?oooooo0?ZJool000[ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`07ooooo`;o0?ZJ2_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`;oo`002_ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`11ooooo`00BOooool00ol0003oooooooooo`03ooooo`06o`3jV_ooooooooooool00?oooooo
o`001?ooool2ool000?ooooo00?oo`00ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00Gooooo00Co0?ZJool00?ooooooo`008?ooool00ol0003oooooooooo`0Xoooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`02oooo
o`07o`3jV_ooooooooooool00?oooooo003oool00003ooooo`03ool00?ooooooo`0000;ooooo00?o
o`00oooooooo00005Oooool00ol0003oooooooooo`0Aooooo`;o0?ZJ5Oooool00ol0003ooooooooo
o`02ooooo`07o`3jV_oo003oooooooooool0nY[oooooool0000Pooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool0:?ooool2o`0002Kooooo0_l00003ooooo`03o`00oooooooo003o00;o
o`0000Ooooooo`3jV_ooooooooooool00?l0nY[oo`0000;ooooo00Coo`00ooooool0nY[oo`005Ooo
ool00ol0003oooooooooo`07ooooo`;o0?ZJ8?ooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo02Sooooo0_oo000[ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooo
oooo00?ooooo00Ko0?ZJooooooooooooo`00oooooooo0004ooooo`;oo`000oooool00ooo003ooooo
ooooo`17ooooo`04o`3jV_oo003oooooool007Oooooo00?o0000ooooooooool0:?ooool00ol0003o
ooooooooo`02ooooo`07o`3jV_ooooooooooool00?oooooo003oool00003ooooo`03ool00?oooooo
o`0000;ooooo00?oo`00oooooooo0000:Oooool2o`3jVQ[ooooo00Oo0?ZJool00?ooooooooooo`3j
V_ooooooo`0007Sooooo00?o0000ooooooooool09?ooool00ol0003o0?ZJooooo`04ooooo`;o003o
00?oo`00ooooool0nYX00_ooool00ooo003o0?ZJool00002ooooo`04ool00?oooooo0?ZJool001oo
oooo0_l0nYYfooooo`;oo`00:oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003ooooo
ooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`001?ooool2ool000?ooooo00?oo`00oooo
ooooool0Aoooool01?l0nY[oo`00oooooooo001gooooo`03o`000?oooooooooo02Sooooo00?o0000
ooooooooool00_ooool01ol0nY[ooooooooooooo003oooooo`00oooo00000oooool00ooo003ooooo
ool00002ooooo`03ool00?ooooooo`0002Wooooo0_l0nYXJooooo`04o`3jV_oo003oooooo`3jVP;o
oooo00?oo`00ooooooooool0M_ooool00ol0003oooooooooo`0Tooooo`03o`000?l0nY[ooooo00Go
oooo00Co003ooooooooo003o0?ZJ0_ooool00ooo003o0?ZJool00002ooooo`04ool00?oooooo0?ZJ
ool001oooooo0_l0nYYfooooo`;oo`00:oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0
003oooooooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`001?ooool2ool00004o`3jV_oo
ooooooooool004Sooooo00Go0?ZJoooooooo003oooooool0001gooooo`03o`000?oooooooooo02So
oooo0_l00003ooooo`05o`3jV_ooooooooooool00?ooool00_l00003ooooo`03ool00?ooooooo`00
00;ooooo00?oo`00oooooooo0000:Oooool2o`3jVQ[ooooo00Co0?ZJool00?oooooo0?ZJ0_ooool0
0ooo003oooooooooo`1eooooo`;o00009_ooool00ol0003o0?ZJo`3jVP05ooooo`04o`00oooooooo
o`00o`3jVP;ooooo00?oo`00o`3jV_oo00000_ooool01?oo003oooooo`3jV_oo000Oooooo`;o0?ZJ
M_ooool2ool002[ooooo0_l00013ooooo`00BOooool2o`0000Cooooo00Ko0?ZJooooooooooooo`00
oooooooo0004ooooo`;oo`0000Co0?ZJooooooooooooo`00B?ooool01Ol0nY[oooooool00?oooooo
o`0007Kooooo0_l0000Zooooo`03o`000?oooooooooo00;ooooo00Co0?ZJooooooooooooo`001?l0
0002ooooo`03ool00?ooooooo`0000;ooooo00?oo`00oooooooo0000:Oooool2o`3jVQWooooo00Go
0?ZJoooooooo003oooooo`3jVP02ooooo`03ool00?oooooooooo07Kooooo00?o0000ooooooooool0
9?ooool00ol0003oooooooooo`02o`3jVP?ooooo00Co003oooooooooooooo`000_ooool00ooo003o
0?ZJool00002ooooo`04ool00?oooooo0?ZJool001oooooo0_l0nYYfooooo`;oo`00:oooool00ol0
003oooooooooo`11ooooo`00BOooool00ol0003oooooooooo`03ooooo`06o`3jV_ooooooooooool0
0?ooooooo`001?ooool2ool00004o`3jV_ooooooooooool004Sooooo00Go0?ZJoooooooo003ooooo
ool0001gooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00_ooool01?l0nY[ooooo
oooooooo0004o`0000;ooooo00?oo`00oooooooo00000_ooool00ooo003oooooool0000Yooooo`;o
0?ZJ6Oooool01Ol0nY[oooooool00?oooooo0?ZJ00;ooooo00?oo`00ooooooooool0M_ooool00ol0
003oooooooooo`0Tooooo`04o`000?ooooooooooooooo`?o0?ZJ00Goooooo`00ooooooooooooool0
0002ooooo`03ool00?l0nY[oo`0000;ooooo00Coo`00ooooool0nY[oo`007oooool2o`3jVWKooooo
0_oo000[ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Ko
0?ZJooooooooooooo`00oooooooo0004ooooo`;oo`0000Co0?ZJooooooooooooo`00B?ooool01Ol0
nY[oooooool00?ooooooo`0007Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`02
ooooo`05o`3jV_ooooooooooool00?ooool00_l00003ooooo`03ool00?ooooooo`0000;ooooo00?o
o`00oooooooo0000:Oooool2o`3jVQWooooo00Go0?ZJoooooooo003oooooo`3jVP02ooooo`03ool0
0?oooooooooo07Kooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`03ooooo`;o0?ZJ
00Coooooo`00ooooooooo`000_ooool00ooo003o0?ZJool00002ooooo`04ool00?oooooo0?ZJool0
01oooooo0_l0nYYfooooo`;oo`00:oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003o
ooooooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`001?ooool2ool00004o`3jV_oooooo
ooooool004Sooooo00Go0?ZJoooooooo003oooooool0001gooooo`03o`000?oooooooooo02Sooooo
0_l00003ooooo`07o`3jV_ooooooooooool00?oooooo003oool00003ooooo`03ool00?ooooooo`00
00;ooooo00?oo`00oooooooo0000:Oooool2o`3jVQWooooo00Go0?ZJoooooooo003oooooo`3jVP02
ooooo`03ool00?oooooooooo07Gooooo0_l0000Vooooo`;o00001Oooool2o`3jVP03o`00oooooooo
o`0000;ooooo00?oo`00o`3jV_oo00000_ooool01?oo003oooooo`3jV_oo000Oooooo`;o0?ZJM_oo
ool2ool002[ooooo0_l00013ooooo`00BOooool00ol0003oooooooooo`03ooooo`06o`3jV_oooooo
ooooool00?ooooooo`000oooool01?l0nY[oo`00ool00?l0nYX2ooooo`03ool00?oooooooooo04Ko
oooo00Go0?ZJoooooooo003oooooool0001gooooo`03o`000?oooooooooo02Sooooo00?o0000oooo
ooooool00_ooool01ol0nY[ooooooooooooo003oooooo`00oooo00000oooool00ooo003oooooool0
0002ooooo`03ool00?ooooooo`0001Cooooo00Go0?ZJooooooooooooooooo`3jVP0@ooooo`03o`3j
V_oo003ooooo01Sooooo00Go0?ZJoooooooo003oooooo`3jVP02ooooo`03ool00?oooooooooo047o
oooo00?o0?ZJooooooooool0<_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Go
oooo00Co0?ZJo`00ooooooooo`000_ooool00ooo003o0?ZJool00002ooooo`04ool00?oooooo0?ZJ
ool000Gooooo0ol0nYXGooooo`;o0?ZJM_ooool2ool002_ooooo00?o0000ooooooooool0@Oooool0
04Wooooo0_l00004ooooo`06o`3jV_ooooooooooool00?ooooooo`000oooool01?l0nY[oo`00ool0
0?l0nYX2ooooo`03ool00?oooooooooo04Kooooo00Go0?ZJoooooooo003oooooool0001fooooo`;o
0000:_ooool00ol0003oooooooooo`02ooooo`07o`3jV_ooooooooooool00?oooooo003oool00003
ooooo`03ool00?ooooooo`0000;ooooo00?oo`00oooooooo00005?ooool00ol0nY[oooooooooo`02
o`3jVQ3ooooo00?o0?ZJool00?ooool06?ooool01Ol0nY[oooooool00?oooooo0?ZJ00;ooooo00?o
o`00ooooooooool0@?ooool00ol0nY[oooooo`3jVP0Wooooo`03o`3jV_oooooooooo00Wooooo00?o
0000ooooooooool09?ooool00ol0003oooooooooo`05ooooo`04o`3jV_l00?ooooooool000;ooooo
00?oo`00o`3jV_oo00000_ooool01?oo003oooooo`3jV_oo0005ooooo`03o`3jV_oooooo0?ZJ01Oo
oooo0_l0nYYfooooo`;oo`00:oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003ooooo
ooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`000oooool01?l0nY[oo`00ool00?l0nYX2
ooooo`03ool00?oooooooooo04Kooooo00Go0?ZJoooooooo003oooooool0001gooooo`03o`000?oo
oooooooo02Sooooo00?o0000ooooooooool00_ooool01ol0nY[ooooooooooooo003oooooo`00oooo
00000oooool00ooo003oooooool00002ooooo`03ool00?ooooooo`0001Cooooo00Ko0?ZJoooooooo
oooo0?ZJooooool0nYX?ooooo`03o`3jV_oo003ooooo01Sooooo00Go0?ZJoooooooo003oooooo`3j
VP02ooooo`03ool00?oooooooooo043ooooo00?o0?ZJooooool0nYX09oooool00ol0nY[ooooooooo
o`09ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool01Oooool01?l0nY[o003ooooo
oooo0002ooooo`03ool00?l0nY[oo`0000;ooooo00Coo`00ooooool0nY[oo`001?ooool2o`3jVP;o
oooo00?o0?ZJooooooooool05?ooool2o`3jVWKooooo0_oo000[ooooo`03o`000?oooooooooo047o
oooo0019ooooo`03o`000?oooooooooo00?ooooo00Ko0?ZJooooooooooooo`00oooooooo0003oooo
o`04o`3jV_oo003oo`00o`3jVP;ooooo00?oo`00ooooooooool0A_ooool01Ol0nY[oooooool00?oo
ooooo`0007Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`02ooooo`07o`3jV_oo
ooooooooool00?oooooo003oool00003ooooo`03ool00?ooooooo`0000;ooooo00?oo`00oooooooo
00005?ooool01_l0nY[oooooooooool0nY[oooooo`3jVPoooooo00?o0?ZJool00?ooool06?ooool0
1Ol0nY[oo`00oooooooooooo0?ZJ00;ooooo00?oo`00ooooooooool0@?ooool00ol0nY[oooooo`3j
VP0Wooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJo`000?ooool09Oooool00ol0003ooooooooo
o`06ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_oo00000_ooool01?oo003oooooo`3j
V_oo0004ooooo`05o`3jV_ooooooooooooooool0nYX05_ooool2o`3jVWKooooo0_oo000[ooooo`03
o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Ko0?ZJoooooooooooo
o`00oooooooo0003ooooo`04o`3jV_oo003o0?ZJool000;ooooo00?oo`00ooooooooool0A_ooool0
1Ol0nY[oooooool00?ooooooo`0007Oooooo00?o0000ooooooooool0:?ooool2o`0000?ooooo00Oo
0?ZJooooooooooooo`00ooooool00?ooo`0000?ooooo00?oo`00oooooooo00000_ooool00ooo003o
ooooool0000Dooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ3oooool00ol0nY[oo`00ooooo`0H
ooooo`05o`3jV_oo003oooooooooool0nYX00_ooool00ooo003oooooooooo`10ooooo`03o`3jV_oo
oooo0?ZJ02Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[o0000ooooo`0Uooooo`;o00001ooo
ool00ol0nY[oooooool00002ooooo`03ool00?l0nY[oo`0000;ooooo00Coo`00ooooool0nY[oo`00
1?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01?ooooo0_l0nYYfooooo`;oo`00
:_ooool2o`0004?ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Ko0?ZJooooooooooooo`00
oooooooo0003ooooo`04o`3jV_oo003o0?ZJool000;ooooo00?oo`00ooooooooool0A_ooool01Ol0
nY[oo`00ooooooooooooo`0007Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`02
ooooo`07o`3jV_ooooooooooool00?l00?ooooooool00003ooooo`03ool00?ooooooo`0000;ooooo
00?oo`00oooooooo00005?ooool01_l0nY[oooooooooool0nY[oooooo`3jVPoooooo00?o0?ZJool0
0?ooool06?ooool01Ol0nY[oo`00oooooooooooo0?ZJ00;ooooo00?oo`00ooooooooool0@?ooool0
0ol0nY[oooooo`3jVP0Wooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo00Kooooo00?o0?ZJoooooooo00000_ooool00ooo003o0?ZJool00002
ooooo`04ool00?oooooo0?ZJool000Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Cooooo`;o0?ZJM_ooool2ool002_ooooo00?o0000ooooooooool0@Oooool004Wooooo00?o0000
ooooooooool00oooool01_l0nY[ooooooooooooo003oooooool000?ooooo00Co0?ZJool00?l0nY[o
o`000_ooool00ooo003oooooooooo`16ooooo`05o`3jV_oo003ooooooooooooo0000Moooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo00;ooooo00Oo0?ZJooooooooooooo`00o`00oooo
ooooo`0000;ooooo00Co0?ZJool00?ooooooo`000_ooool00ooo003oooooool0000Dooooo`06o`3j
V_ooooooooooo`3jV_oooooo0?ZJ3oooool00ol0nY[oo`00ooooo`0Hooooo`05o`3jV_oo003ooooo
ooooool0nYX00_ooool00ooo003oooooooooo`10ooooo`03o`3jV_oo003o0?ZJ02Oooooo00?o0?ZJ
ooooooooool01oooool2o`3jVP03o`000?oooooooooo02Cooooo00?o0000ooooooooool01_ooool0
0ol0nY[oooooool00002ooooo`03ool00?l0nY[oo`0000;ooooo00Coo`00ooooool0nY[oo`000ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01?ooooo0_l0nYYfooooo`;oo`00:ooo
ool00ol0003oooooooooo`11ooooo`00BOooool2o`0000Cooooo00Ko0?ZJooooooooooooo`00oooo
oooo0003ooooo`04o`3jV_oo003o0?ZJool000;ooooo00?oo`00ooooooooool0A_ooool01Ol0nY[o
o`00ooooooooooooo`0007Kooooo0_l0000Zooooo`03o`000?oooooooooo00;ooooo00Oo0?ZJoooo
ooooooooo`00o`00ooooooooo`0000;ooooo00Co0?ZJool00?ooooooo`000_ooool00ooo003ooooo
ool0000Dooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool03?ooool00ol0nY[ooooo
ool0000Iooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?oo`00ooooooooool0@?ooool2ool00003
o`3jV_oooooooooo02Gooooo00?o0?ZJooooooooool01oooool2o`3jVP03o`000?oooooooooo02Co
oooo00?o0000ooooooooool01_ooool00ol0nY[oooooool00002ooooo`03ool00?l0nY[oo`0000;o
oooo00Coo`00ooooool0nY[oo`000oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
01?ooooo0_l0nYYfooooo`;oo`00:oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003o
ooooooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`000oooool01ol0nY[oo`00o`3jV_oo
003oooooo`3jV_oo0000B?ooool01Ol0nY[oo`00ooooooooooooo`0007Oooooo00?o0000oooooooo
ool0:?ooool2o`0000?ooooo00Oo0?ZJooooooooooooo`00o`00ooooooooo`0000;ooooo00Co0?ZJ
ool00?ooooooo`000_ooool00ooo003oooooool0000Dooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o
0?ZJooooooooool03?ooool00ol0nY[oooooool0000Iooooo`04o`3jV_oo003oooooo`3jVP?ooooo
00?oo`00ooooooooool0@?ooool00ooo003o003oool0000Wooooo`03o`3jV_oooooooooo00Oooooo
0_l0nYX00ol0003oooooooooo`0Tooooo`;o00001oooool00ol0nY[oooooool00002ooooo`03ool0
0?l0nY[oo`0000;ooooo00Coo`00ooooool0nY[oo`000oooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo01;ooooo0_l0nYYfooooo`;oo`00:_ooool2o`0004?ooooo0019ooooo`03o`00
0?oooooooooo00?ooooo00Ko0?ZJooooooooooooo`00oooooooo0003ooooo`07ool00?l0nY[o0?ZJ
ool00?oooooo0?ZJool00018ooooo`05o`3jV_oo003ooooooooooooo0000Moooool00ol0003ooooo
ooooo`0Xooooo`05o`000?ooooooooooooooool0nYX00oooool01?oo003o003ooooooooo0002oooo
o`04o`3jV_oo003oooooool000;ooooo00?oo`00oooooooo00005?ooool00ol0nY[oooooo`3jVP02
ool00003o`3jV_oooooooooo00cooooo00?o0?ZJoooooooo00006Oooool01?l0nY[oo`00ooooool0
nYX3ooooo`03ool00?oooooooooo03oooooo00Go0?ZJool00?l00?ooo`00o`3jVP0Vooooo`03o`3j
V_oooooooooo00Kooooo00Co0?ZJooooool0nY[o00009_ooool00ol0003oooooooooo`06ooooo`03
o`00ool0nY[oo`0000;ooooo00?oo`00o`3jV_oo00000_ooool01?oo003oooooo`3jV_oo0003oooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool04_ooool2o`3jVWKooooo0_oo000[oooo
o`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Ko0?ZJoooooooo
ooooo`00oooooooo0003ooooo`07ool00?l0nY[o0?ZJool00?oooooo0?ZJool00018ooooo`05o`3j
V_oo003oooooo`3jV_oo0000Moooool00ol0003oooooooooo`0Iooooo`Go00000oooool2o`0000Go
oooo00Go0000ooooooooooooooooo`3jVP03ooooo`04ool00?l00?ooooooool000;ooooo00Co0?ZJ
ool00?ooooooo`000_ooool00ooo003oooooool0000Dooooo`03o`3jV_oooooo0?ZJ00;oo`0000?o
0?ZJooooooooool03?ooool00ol0nY[oo`00ool0000Iooooo`04o`3jV_oo003o003oo`3jVP?ooooo
00?oo`00ooooooooool0?oooool01Ol0nY[oo`00o`00oooo003o0?ZJ02Kooooo00?o0?ZJoooooooo
ool01_ooool01?l0nY[oooooo`3jV_l0000Iooooo`?o00001?ooool2o`0000Cooooo00?o0000oooo
ooooool01oooool01ol0nY[oo`00ooooooooooooo`00oooooooo00000_ooool01?oo003oooooo`3j
V_oo0002ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04_ooool2o`3jVWKooooo
0_oo000[ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Oo
0?ZJooooooooooooo`00oooooooo003o0?ZJ00;ooooo00Ooo`00o`3jV_l0nY[oo`00ooooool0nY[o
o`0004Sooooo00Go0?ZJool00?oooooo0?ZJool0001gooooo`03o`000?oooooooooo01[ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`05o`000?oooooooooooooo
ool0nYX00oooool02_oo003o003ooooooooo003o0?ZJooooool0nY[oo`00oooooooo0002ooooo`03
ool00?ooooooo`0001Cooooo00?o0?ZJooooool0nYX00_oo00000ol0nY[oooooooooo`0<ooooo`03
o`3jV_oo003oo`0001Wooooo00Co0?ZJool00?l00?oo0?ZJ0oooool00ooo003oooooooooo`0ooooo
o`05o`3jV_oo003o003oool00?l0nYX09_ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_oooooo
0?ZJo`0001[ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`03o`00
0?oooooooooo00Oooooo00Oo0?ZJool00?ooooooooooool00?ooooooo`0000;ooooo00Coo`00oooo
ool0nY[oo`000_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01;ooooo0_l0nYYY
ooooo`;o003o2oooool2ool002_ooooo00?o0000ooooooooool0@Oooool004Wooooo0_l00004oooo
o`07o`3jV_ooooooooooool00?ooooooo`00o`3jVP02ooooo`07ool00?l0nY[o0?ZJool00?oooooo
0?ZJool00017ooooo`06o`3jV_ooooooo`00ooooool0nY[oo`00M_ooool2o`0001Gooooo1Ol00003
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01Ol0003ooooooooo
oooooooo0?ZJ00?ooooo00[oo`00o`00ooooooooo`00o`3jV_oooooo0?ZJool00?ooooooo`000_oo
ool00ooo003oooooool0000Dooooo`03o`3jV_oooooo0?ZJ00;oo`0000?oooooo`3jV_ooool03?oo
ool00ol0nY[oo`00ool0000Hooooo`05o`3jV_ooooooo`00o`00ool0nYX00oooool00ooo003ooooo
ooooo`0oooooo`05o`3jV_oo003o003oool00?l0nYX09Oooool2o`3jVPOooooo00Go0?ZJoooooooo
oooo0?ZJo`00000Jooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`07ooooo`07o`3jV_oo003ooooooooooooo003oooooool00002ooooo`04ool0
0?oooooo0?ZJool000;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Booooo`;o
0?ZJJOooool2o`00o`_ooooo0_oo000[ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`00
0?oooooooooo00?ooooo00Co0?ZJooooooooooooo`000_l000001?l0nY[ooooooooooooo0002o`3j
VP04ool00?oooooo0?ZJool001[ooooo00?o0?ZJooooooooool0:_ooool01_l0nY[oooooool00?oo
oooo0?ZJool007Oooooo00?o0000ooooooooool07?ooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool00_ooool2o`0000;ooooo00ko0?ZJooooooooooooooooool00?l00?oo
ooooool00?l0nY[oooooo`3jV_oo003oooooool000;ooooo00?oo`00oooooooo00005?ooool2o`3j
VP05ool00?l00?ooooooool00?l0nYX03Oooool00ol0nY[oo`00ool0000Hooooo`05o`3jV_oo003o
003oo`00ool0nYX00oooool00ooo003oooooooooo`0oooooo`05ool00?l0nY[o0?ZJool00?l0nYX0
9Oooool2o`3jVPOooooo00Go0?ZJooooool0003o0?ZJo`00000Jooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000oooool3o`0000Oooooo00Oo0?ZJool00?ooooooooooool00?oo
ooooo`0000;ooooo00Coo`00ooooool0nY[oo`000_ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo01;ooooo00?o0?ZJool00?ooool0J?ooool2o`00o`_ooooo0_oo000Booooo`;o0?ZJ
5Oooool3o`0004?ooooo0019ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool01?l0
0002ooooo`07ool00?l0nY[o0?ZJool00?oooooo0?ZJool0000Jooooo`;o0?ZJ:oooool01_l0nY[o
ooooool00?oooooo0?ZJool007Oooooo00?o0000ooooooooool06Oooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00;o
oooo00_oo`00ooooool00?ooooooool00?l0nY[oooooo`3jV_oo003oooooool00002ooooo`03ool0
0?ooooooo`0001Cooooo0_l0nYX01Ooo003o003ooooooooo003o0?ZJ00gooooo00?o0?ZJool00?oo
00006?ooool01Ol0nY[oo`00o`00ool00?oo0?ZJ00?ooooo00?oo`00ooooooooool0?oooool01Ooo
003o0?ZJo`3jV_oo003o0?ZJ02Gooooo0_l0nYX7ooooo`05o`3jV_ooooooooooo`3jV_l000006_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
1oooool01ol0nY[oo`00ooooooooooooo`00oooooooo00000_ooool01?oo003oooooo`3jV_oo0002
ooooo`03o`3jV_ooooooo`0000;oo`000oooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oo003o
oooo06Sooooo00?o003oooooool00?l02Oooool00ol0nY[oo`00ool0000Booooo`;o0?ZJ5oooool0
0ol0003oooooooooo`11ooooo`00>_ooool5o`0000?ooooo0_l00005ooooo`03o`000?oooooooooo
00;ooooo00Co0?ZJoooooooooooooooo1?l00002ooooo`07ool00?l0nY[o0?ZJool00?oooooo0?ZJ
ool0000Jooooo`;o0?ZJ:oooool01_l0nY[oooooool00?oooooo0?ZJool007Oooooo00?o0000oooo
ooooool06Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?oo
ool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00_oo`00ooooool00?ooooooo`3jV_oo003ooooo
o`3jV_oo003oooooool00002ooooo`03ool00?ooooooo`0001Cooooo0_l0nYX01Ooo003o003ooooo
oooo003o0?ZJ00gooooo00?o0?ZJool00?oo00006?ooool01Ol0nY[oo`00ooooool00?oo0?ZJ00?o
oooo00?oo`00ooooooooool0?oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ02Gooooo0_l0nYX7oooo
o`05o`3jV_ooooooooooo`3jV_l000006Oooool2o`0000Cooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`07ooooo`07o`00oooo003ooooooooooooo003oooooool00002ooooo`04
ool00?oooooo0?ZJool000;ooooo00Co0?ZJoooooooo003ooooo0_oo0002ooooo`03o`3jV_oooooo
oooo01;ooooo00?o0?ZJool00?ooool07_ooool2o`000003o`3jV_oooooooooo01gooooo00?o003o
ooooooooool09Oooool00ol00?ooooooo`00o`09ooooo`03o`3jV_oo003oo`0001;ooooo0_l0nYXG
ooooo`03o`000?oooooooooo047ooooo000kooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00001?ooool00ol0003oooooooooo`02ooooo`05o`3jV_oooooooooooooooooo0000
0_l000001?oo003ooooooooooooo0002o`3jVP04ool00?oooooo0?ZJool001Wooooo00?o0?ZJoooo
ool0nYX0:oooool01_l0nY[oooooool00?oooooo0?ZJool007Oooooo00?o0000ooooooooool06_oo
ool3o`0000Cooooo0_l00005ooooo`05o`000?ooooooooooooooool0nYX00_ooool02ooo003ooooo
o`00oooooooo0?ZJool00?oooooo0?ZJool00?ooooooo`0000;ooooo00?oo`00oooooooo00005?oo
ool2o`3jVP05ool00?l00?ooooooool00?l0nYX03Oooool00ol0nY[oo`00ool0000Hooooo`04o`3j
V_oo003oooooo`3jVPCooooo00?oo`00ooooooooool0?oooool01Ooo003o0?ZJoooooooo003o0?ZJ
02Gooooo0_l0nYX5ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`000?ooool06Oooool00ol0
003oooooooooo`03ooooo`;o00001?ooool00ol0003oooooooooo`07ooooo`07o`00oooo003ooooo
oooooooo003oooooool00002ooooo`04ool00?oooooo0?ZJool000;ooooo00?o0?ZJool00?oo0000
0_ooool01?oo003oooooooooool0nYXDooooo`03o`3jV_oo003ooooo01gooooo1?l0000Oooooo`03
o`00oooooooooooo02Gooooo00?o003oooooool00?l02Oooool00ol0nY[oo`00ool0000Booooo`03
o`3jV_oooooo0?ZJ01Kooooo00?o0000ooooooooool0@Oooool003Cooooo1Ol00003ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`0000?ooooo00So0?ZJoooooooo
ooooooooool00?l00?oo0?ZJool000;ooooo00Ooo`00o`3jV_l0nY[oo`00ooooool0nY[oo`0001Wo
oooo00?o0?ZJooooool0nYX0:oooool01_l0nY[oo`00oooooooooooo0?ZJool007Kooooo0_l0000Z
ooooo`;o00000_ooool03_l0nY[ooooooooooooo003oooooo`00oooooooo0?ZJool00?oooooo0?ZJ
ool00?ooooooo`000_ooool00ooo003oooooool0000Dooooo`;o0?ZJ00Goo`00o`00ooooooooo`00
o`3jVP0=ooooo`03o`3jV_oo003oo`0001Sooooo00Co0?ZJool00?oooooo0?ZJ1?ooool00ooo003o
ooooooooo`0oooooo`05ool00?ooooooooooool00?l0nYX09Oooool2o`3jVPGooooo00?o003oo`3j
V_ooool00_ooool00ol0nY[o0000ooooo`0Uooooo`;o00002?ooool01ol00?ooo`00oooooooooooo
o`00oooooooo00000_ooool02?oo003oooooo`3jV_oo003oooooo`3jV_ooooooo`000oooool01?oo
003oooooooooool0nYXDooooo`03o`3jV_oo003ooooo01gooooo1?l000000ol0nY[oooooooooo`0L
ooooo`03o`00oooooooooooo02Gooooo00?o003oooooool00?l02Oooool00ol0nY[oo`00ool0000B
ooooo`03o`3jV_oooooo0?ZJ01Gooooo0_l00013ooooo`00?Oooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`08o`3jV_oooooo
oooooooooooo003o003oo`3jV_oo0002ooooo`07ool00?l0nY[oooooool00?oooooo0?ZJool0000I
ooooo`03o`3jV_oooooo0?ZJ02_ooooo00Ko0?ZJool00?ooooooooooo`3jV_oo001gooooo`03o`00
0?oooooooooo02Sooooo00Go0000ooooooooooooooooo`3jVP02ooooo`0;ool00?oooooo003ooooo
ool0nY[oo`00ooooool0nY[oo`00oooooooo00000_ooool00ooo003oooooool0000Dooooo`;o0?ZJ
00Goo`00o`3jV_l0nY[oo`00o`3jVP0=ooooo`03o`3jV_oo003oo`0001Sooooo00Co0?ZJool00?oo
oooo0?ZJ1?ooool00ooo003oooooooooo`0cooooo`;o0?ZJ2Oooool2o`0000;ooooo00?o0?ZJool0
0?ooool09?ooool2o`3jVPGooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o0000ooooo`0Uoooo
o`03o`000?oooooooooo00Oooooo00Oo003oool00?ooooooooooool00?ooooooo`0000;ooooo00So
o`00ooooool0nY[oo`00ooooool0nY[oooooool000?ooooo00Coo`00oooooooooooo0?ZJ5?ooool0
0ol0nY[oo`00ooooo`0Nooooo`;o000000?o003oo`3jV_ooool06oooool01?l00?oo0000o`000?l0
0?lUooooo`05o`00ooooooooooooooooool00?l02?ooool00ol0nY[oo`00ool0000Booooo`03o`3j
V_oooooo0?ZJ01Kooooo00?o0000ooooooooool0@Oooool003[ooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool02?l0nY[o
ooooooooooooooooo`00o`00ool0nY[oo`000_ooool01ooo003ooooooooooooo003oooooo`3jV_oo
00006Oooool00ol0nY[oooooo`3jVP0[ooooo`06o`3jV_oo003oooooooooool0nY[oo`00Moooool0
0ol0003oooooooooo`0Xooooo`05o`000?ooooooooooooooool0nYX00_ooool02ooo003oooooo`00
oooooooo0?ZJool00?oooooo0?ZJool00?ooooooo`0000;ooooo00?oo`00oooooooo00005?ooool2
o`3jVP05ool00?oooooo0?ZJool00?l0nYX03Oooool00ol0nY[oo`00ool0000Hooooo`05o`3jV_oo
003oooooo`3jV_l00?l00oooool00ooo003oooooooooo`0booooo`?o0?ZJ2?ooool4o`000003oooo
ool0nY[oo`0002Gooooo0_l0nYX5ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`000?ooool0
9Oooool00ol0003oooooooooo`07ooooo`07o`00oooo003ooooooooooooo003oooooool00002oooo
o`07ool00?oooooo0?ZJool00?oooooo0?ZJool00005ooooo`03ool00?oooooo0?ZJ01Cooooo00?o
0?ZJool00?ooool07_ooool01?l00?ooo`00ool00?l0nYXLooooo`Co00009Oooool01Ol00?oooooo
oooooooooooo003o00Sooooo00?o0?ZJool00?oo00004Oooool01?l0nY[oooooooooool0nYXFoooo
o`03o`000?oooooooooo047ooooo000jooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00So0?ZJooooooooooooooooool0
0?l00?oo0?ZJool000;ooooo00Ooo`00ooooooooooooo`00ooooool0nY[oo`0001Wooooo00Co0?ZJ
oooooooooooo0?ZJ:_ooool01_l0nY[oo`00oooooooooooo0?ZJool007Oooooo00?o0000oooooooo
ool0:?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00_oo`00ooooool00?ooooooo`3jV_oo
003oooooool00?l0nY[oooooool00002ooooo`03ool00?ooooooo`0001Cooooo00Oo0?ZJool00?l0
nY[oooooo`3jV_oo003o0?ZJ00gooooo00?o0?ZJool00?oo00006?ooool01Ol0nY[oo`00ooooool0
nY[o003o00?ooooo00?oo`00ooooooooool0<_ooool00ol0nY[oooooo`3jVP08ooooo`Co000000?o
ooooo`3jV_oo00009Oooool2o`3jVPGooooo00?o0?ZJo`00ooooool00_ooool00ol0nY[o0000oooo
o`0Uooooo`03o`000?oooooooooo00Oooooo00Oo003oool00?ooooooooooool00?ooooooo`0000;o
oooo00Ooo`00ooooool0nY[oo`00ooooool0nY[oo`0000Gooooo00?oo`00ooooool0nYX05?ooool0
0ol0nY[oo`00ooooo`0Mooooo`;o003o0_oo00000ol0nY[oooooooooo`0Iooooo`03o`00ool0003o
000000;o00009Oooool00ol00?ooooooooooo`02o`0000Sooooo00?o0?ZJool00?oo00004Oooool0
1?l0nY[oooooooooool0nYXFooooo`03o`000?oooooooooo047ooooo000kooooo`?o00001?ooool2
o`0000Gooooo00?o0000ooooooooool00_ooool02?l0nY[oooooooooooooooooo`00o`00ool0nY[o
o`000_ooool01ooo003ooooooooooooo003oooooo`3jV_oo00006Oooool01?l0nY[oooooooooool0
nYXZooooo`06o`3jV_oo003oooooooooool0nY[oo`00Moooool00ol0003oooooooooo`0Xooooo`05
o`000?ooooooooooooooool0nYX00_ooool02ooo003oooooo`00oooooooo0?ZJool00?ooooooo`00
o`3jV_ooooooo`0000;ooooo00?oo`00oooooooo00005?ooool01ol0nY[oo`00o`3jV_oooooo0?ZJ
ool00?l0nYX03Oooool00ol0nY[oo`00ool0000Hooooo`05o`3jV_oo003oooooo`3jV_l00?l00ooo
ool00ooo003oooooooooo`0aooooo`;o0?ZJ00?oooooo`3jV_ooool02?ooool2o`0000;ooooo00?o
0?ZJool00?ooool09?ooool2o`3jVPCooooo00?o003oo`3jV_l00?l00oooool00ol0nY[o0000oooo
o`0Uooooo`03o`000?oooooooooo00Oooooo00Oo003oool00?ooooooooooool00?ooooooo`0000;o
oooo00Ooo`00ooooool0nY[oo`00ooooool0nY[oo`0000Gooooo00?oo`00ooooool0nYX05?ooool0
0ol0nY[oo`00ooooo`0Mooooo`06o`00ooooooooo`00ool00?l00?oo0?ZJ6_ooool01?l00?oooooo
o`000?l00002o`3jVR?ooooo0_l00?l00ooooooo0000o`000002o`0000Oooooo00?o0?ZJool00?oo
00004Oooool01?l0nY[oooooooooool0nYXFooooo`03o`000?oooooooooo047ooooo0019ooooo`03
o`000?oooooooooo00;ooooo00So0?ZJooooooooooooo`00ooooool00?oo0?ZJool000;ooooo00Oo
o`00ooooooooooooo`00ooooool0nY[oo`0001Sooooo00Go0?ZJooooooooooooooooo`3jVP0Zoooo
o`06o`3jV_oo003oooooooooool0nY[oo`00Moooool00ol0003oooooooooo`0Xooooo`;o00000_oo
ool03_l0nY[ooooooooooooo003oooooo`00oooooooo0?ZJool00?ooooooo`00o`3jV_ooooooo`00
0_ooool00ooo003oooooool0000Dooooo`07o`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP0<oooo
o`04o`3jV_ooooooo`00ool001Sooooo00Go0?ZJool00?oooooo0?ZJo`00o`03ooooo`03ool00?oo
oooooooo037ooooo00Co0?ZJoooooooooooo0?ZJ2Oooool01_l00?ooo`00oooooooooooo0?ZJool0
02Gooooo0_l0nYX4ooooo`03o`00ool0nY[o003o00?ooooo00?o0?ZJo`000?ooool09Oooool2o`00
00Sooooo00Oo003oool00?ooooooooooool00?ooooooo`0000;ooooo00Ooo`00ooooool0nY[oo`00
ooooool0nY[oo`0000Gooooo00?oo`00ooooool0nYX02?ooool00ol00?ooooooooooo`09ooooo`03
o`3jV_oo003ooooo01gooooo00Ko003ooooooooo003oo`00o`00ool0nYXJooooo`06o`00oooooooo
o`00ool00?oooooo0?ZJ8oooool00ol00?ooooooooooo`04o`0000Oooooo00?o0?ZJool00?oo0000
4Oooool01?l0nY[oooooooooool0nYXEooooo`;o0000@oooool004Wooooo0_l00003ooooo`08o`3j
V_ooooooooooool00?oooooo003oo`3jV_oo0002ooooo`07ool00?ooooooooooool00?oooooo0?ZJ
ool0000Hooooo`05o`3jV_ooooooooooooooool0nYX0:_ooool01_l0nY[oo`00ooooool0nY[ooooo
ool004Gooooo0_l0nYX_ooooo`;o0000:_ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00_o
o`00ooooool00?ooooooo`3jV_oo003oooooool00?l0nY[oooooool00002ooooo`03ool00?oooooo
o`0001Cooooo0_oo00001Ol0nY[oooooo`3jV_oo003o0?ZJ00cooooo00Co0?ZJoooooooo003oo`00
6?ooool01Ol0nY[oo`00ooooool0nY[o003o00?ooooo00?oo`00ooooooooool0<?ooool2o`3jVP;o
oooo00?o0?ZJooooooooool01oooool01ol00?ooo`00oooooooooooo0?ZJool00?l0nYX09?ooool2
o`3jVPCooooo00?o003oo`3jV_l00?l00oooool00ol0nY[o0000ooooo`0Uooooo`03o`000?oooooo
oooo00Oooooo00Oo003oool00?ooooooooooool00?ooooooo`0000;ooooo00Ooo`00ooooool0nY[o
o`00ooooool0nY[oo`0000Kooooo00?oo`00o`3jV_ooool01Oooool4o`00o`[ooooo00?o0?ZJool0
0?ooool07?ooool2o`00o`05oooooooo003o0?ZJool00?l0nYX06_ooool01_l00?ooooooool00?oo
003oooooo`3jVR;ooooo0_l00?l3ooooo`;o00002?ooool00ol0nY[oo`00ool0000Aooooo`03o`3j
V_oooooooooo00;o00005Oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003ooooooooo
o`02ooooo`08o`3jV_ooooooooooool00?oooooo003oo`3jV_oo0002ooooo`07ool00?oooooooooo
ool00?oooooo0?ZJool0000Hooooo`05o`3jV_ooooooooooooooool0nYX0:Oooool01ol0nY[ooooo
ool00?oooooo0?ZJoooooooo0000A?ooool00ol0nY[oooooo`3jVP0`ooooo`03o`000?oooooooooo
02Sooooo00Go0000ooooooooooooooooo`3jVP02ooooo`0;ool00?oooooo003oooooool0nY[oo`00
oooooooo003o0?ZJoooooooo00000_ooool00ooo003oooooool0000Dooooo`;o00000_ooool00ol0
0?ooo`00o`3jVP0<ooooo`04o`3jV_ooooooo`00ool001Sooooo00Go0?ZJool00?oooooo0?ZJo`00
o`03ooooo`03ool00?oooooooooo02Oooooo0ol0nYX5ooooo`03o`00ool0nY[ooooo00;ooooo00?o
0?ZJooooooooool01oooool01ol00?ooo`00oooooooooooo0?ZJool00?l0nYX09?ooool2o`3jVPCo
oooo00?o0?ZJooooool00?l00oooool00ol0nY[o0000ooooo`0Uooooo`03o`000?oooooooooo00Oo
oooo00Oo003oool00?ooooooooooool00?ooooooo`0000;ooooo00Koo`00ooooool0nY[oo`00o`3j
V_oo0007ooooo`03ool00?l0nY[ooooo00Gooooo0_l00?l00ooooooo003oooooo`09ooooo`03o`3j
V_oo003ooooo01cooooo00Oo003oooooooooooooo`00o`3jV_oo003o0?ZJ01[ooooo00Ko003ooooo
oooo003o0?ZJool00?l0nYXRooooo`;o003o1?ooool00ooo003oooooooooo`06ooooo`03o`3jV_oo
003oo`00017ooooo00?o0?ZJooooool000000ol0000Dooooo`03o`000?oooooooooo047ooooo0019
ooooo`03o`000?oooooooooo00;ooooo00So0?ZJooooooooooooo`00ooooool00?oo0?ZJool000;o
oooo00Ooo`00ooooooooooooo`00ooooool0nY[oo`0001Sooooo00Go0?ZJoooooooo003oooooo`3j
VP0Yooooo`07o`3jV_ooooooo`00ooooool0nY[oooooool00014ooooo`03o`3jV_oooooo0?ZJ033o
oooo00?o0000ooooooooool0:?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00_oo`00o`00
ooooooooooooo`3jV_oo003oooooool00?l0nY[oooooool00002ooooo`03ool00?ooooooo`0000go
oooo00?o0?ZJooooooooool00oooool4o`000004ooooool00?oo0?ZJool000cooooo00Co0?ZJoooo
oooo003oo`006?ooool01Ooo003o003oo`3jV_oooooo003o00?ooooo00?oo`00ooooooooool09_oo
ool2o`3jVP03ooooool0nY[ooooo00Cooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Oooooo00Oo
003oool00?ooooooooooo`3jV_oo003o0?ZJ02Cooooo00?o0?ZJool00?ooool00oooool01?l0nY[o
ooooooooool00?l2ooooo`03o`3jV_l0003ooooo02Gooooo00?o0000ooooooooool01oooool01ol0
0?ooo`00ooooooooooooo`00oooooooo00000_ooool01_oo003oooooo`3jV_oo003o0?ZJool000Oo
oooo00?oo`00o`3jV_ooool01Oooool01Ol00?oooooooooooooooooo003o00Wooooo00?o0?ZJool0
0?ooool07?ooool01ol00?oooooooooooooo003o0?ZJool00?l0nYX06_ooool01_l00?ooooooool0
0?l0nY[oo`00o`3jVR;ooooo00?o003oooooooooool00oooool00ooo003oooooooooo`06ooooo`03
o`3jV_oo003oo`00017ooooo00?o0?ZJooooool000000ol0000Dooooo`03o`000?oooooooooo047o
oooo0019ooooo`03o`000?oooooooooo00;ooooo00So0?ZJooooooooooooo`00ooooool00?oo0?ZJ
ool000;ooooo00Ooo`00ooooooooooooo`00ooooool0nY[oo`0001Sooooo00Go0?ZJool00?oooooo
o`00o`3jVP0Yooooo`07o`3jV_ooooooo`00ooooool0nY[oooooool00014ooooo`03o`3jV_oooooo
0?ZJ033ooooo00?o0000ooooooooool0:?ooool2o`0000;ooooo00Go0?ZJooooooooooooo`00o`00
o`02ooooo`07o`3jV_oo003oooooool00?l0nY[oooooool00002ooooo`03ool00?ooooooo`0000go
oooo00?o0?ZJooooooooool00oooool4o`000004ooooool00?oo0?ZJool000cooooo00Co0?ZJool0
0?ooooooo`005oooool01_l0nY[oo`00ooooool0nY[oooooo`00o`?ooooo00?oo`00ooooooooool0
9Oooool2o`3jVP;ooooo00?o0?ZJooooooooool00oooool00ol0nY[o003oooooo`02ooooo`03o`3j
V_oooooooooo00Oooooo00Oo003oool00?ooooooooooo`3jV_oo003o0?ZJ02Cooooo00?o0?ZJool0
0?ooool00oooool01?l0nY[oooooooooool00?l2ooooo`03ool00?l0003ooooo02Gooooo0_l00008
ooooo`07o`00oooo003ooooooooooooo003oooooool00002ooooo`06ool00?oooooo0?ZJool00?l0
nY[oo`001oooool00ooo003o0?ZJooooo`05ooooo`05o`00ooooooooooooooooool00?l02Oooool0
0ol0nY[oo`00ooooo`0Looooo`08o`00ooooooooooooool00?l0nY[oo`00o`00ool0nYXIooooo`06
o`00ooooooooo`00o`3jV_oo003o0?ZJ8_ooool00ol00?ooooooooooo`03ooooo`03ool00?oooooo
oooo00Kooooo00?o0?ZJool00?oo00002_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo00;o00005?ooool2o`0004?ooooo0019ooooo`03o`000?oooooooooo00;ooooo00So0?ZJoooo
ooooooooo`00ooooool00?oo0?ZJool000;ooooo00Ooo`00ooooooooooooo`00ooooool0nY[oo`00
01Sooooo00Go0?ZJool00?ooooooo`00o`3jVP0Yooooo`07o`3jV_ooooooo`00ooooool0nY[ooooo
ool00013ooooo`05o`3jV_ooooooooooooooool0nYX0;oooool00ol0003oooooooooo`0Xooooo`05
o`000?ooooooooooooooool0nYX00_ooool02ooo003o003ooooooooooooo0?ZJool00?ooooooo`00
o`3jV_ooooooo`0000;ooooo00?oo`00oooooooo00003Oooool2o`3jVPGooooo0_l00002ooooo`03
o`00ool0nY[oo`0000cooooo00Co0?ZJool00?ooooooo`005oooool01_l0nY[oo`00ooooool0nY[o
ooooo`00o`?ooooo00?oo`00ooooooooool04oooool00ol0nY[oooooooooo`0>ooooo`;o0?ZJ0ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_l00?oooooo00;ooooo00?o0?ZJooooooooool01ooo
ool01ol00?ooo`00oooooooooooo003oool00?l0nYX03_ooool2o`3jVQCooooo00?o0?ZJool00?oo
ool00oooool01Ol0nY[oooooooooool00?oooooo00;oo`0000?o0000ooooooooool09?ooool00ol0
003oooooooooo`07ooooo`07o`00oooo003ooooooooooooo003oooooool00002ooooo`07ool00?oo
oooo0?ZJool00?l0nY[oo`00ooooo`03o`3jVP?ooooo00?oo`00o`3jV_ooool01Oooool00ol00?oo
ooooooooo`02o`0000Wooooo00?o0?ZJool00?ooool06oooool2o`00o`;ooooo00Goo`00o`3jV_oo
003o003oo`3jVP0Hooooo`08o`00ooooooooooooool00?l0nY[oo`00o`00ool0nYXQooooo`03o`00
oooooooooooo00?ooooo00?oo`00ooooooooool01_ooool00ol0nY[oo`00ool0000:ooooo`03o`3j
V_oooooooooo00Cooooo00Go0?ZJoooooooooooo003oool0000<ooooo`03o`00oooooooooooo00Ko
oooo00?o0000ooooooooool0@Oooool004Wooooo0_l00003ooooo`08o`3jV_ooooooooooool00?oo
oooo003oo`3jV_oo0002ooooo`07ool00?ooooooooooool00?oooooo0?ZJool0000Hooooo`05o`3j
V_oo003oooooool00?l0nYX0:Oooool01ol0nY[oooooool00?oooooo0?ZJoooooooo0000@oooool0
1Ol0nY[ooooooooooooooooo0?ZJ02kooooo0_l0000Zooooo`05o`000?ooooooooooooooool0nYX0
0_ooool02ooo003o003ooooooooooooo0?ZJool00?ooooooo`00o`3jV_ooooooo`0000;ooooo00?o
o`00oooooooo00003Oooool2o`3jVPGooooo00Ooo`00o`3jV_ooooooooooo`00ool0nY[oo`0000co
oooo00Co0?ZJool00?ooooooo`005oooool01_l0nY[oo`00ooooool0nY[oooooo`00o`?ooooo00?o
o`00ooooooooool04oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool00_ooool2o`3jVP05ooooool00?ooooooooooool0nYX02Oooool01ol00?ooo`00
oooooooooooo003oool00?l0nYX03_ooool2o`3jVQCooooo00?o0?ZJool00?ooool00oooool01?l0
nY[oooooooooool00?l3ool00003o`000?oooooooooo02Cooooo00?o0000ooooooooool01oooool0
1ol00?ooo`00ooooooooooooo`00oooooooo00000_ooool02Ooo003oooooo`3jV_oo003o0?ZJool0
0?oooooo0?ZJooooo`02o`3jVP;ooooo00?oo`00o`3jV_ooool01?ooool00ol00?ooooooooooo`04
o`0000Sooooo0_oo000Looooo`09o`00oooooooooooooooooooo003o0?ZJool00?l00?oo0?ZJ01So
oooo00So003oooooooooooooo`00ooooool0nY[oo`00o`3jVQCooooo00?o003oooooooooool02_oo
ool00ol00?ooooooooooo`03ooooo`03ool00?l0nY[ooooo00Kooooo00?o0?ZJool00?oo00002Ooo
ool2o`3jVPKooooo00Ko0?ZJool00?oo003oooooool00?l0nYX:ooooo`?o003o1oooool00ol0003o
ooooooooo`11ooooo`00BOooool00ol0003oooooooooo`02ooooo`08o`3jV_ooooooooooool00?oo
oooo003oo`3jV_oo0002ooooo`07ool00?ooooooooooool00?oooooo0?ZJool0000Hooooo`05o`3j
V_oo003oooooool00?l0nYX0:Oooool01ol0nY[o003oool00?oooooo0?ZJoooooooo0000@oooool0
1Ol0nY[o003ooooooooooooo0?ZJ02oooooo00?o0000ooooooooool0:?ooool01Ol0003ooooooooo
oooooooo0?ZJ00;ooooo00_oo`00o`00ooooooooooooo`3jV_oo003oooooool00?l0nY[oooooool0
0002ooooo`03ool00?ooooooo`0000cooooo00?o0?ZJooooool0nYX01Oooool02?oo003o0?ZJoooo
oooooooo003oo`3jV_oo003o0?ZJ2oooool01?l0nY[oo`00oooooooo000Gooooo`06o`3jV_oo003o
ooooo`3jV_oooooo003o0oooool00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo00gooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`;o
oooo00?o0?ZJooooooooool01oooool01ol0nY[oo`00oooooooooooo003oool00?l0nYX03Oooool0
0ol0nY[oooooo`3jVP0Dooooo`03o`3jV_oo003ooooo00;ooooo00Wo0?ZJo`00ooooooooooooo`00
oooo003oooooool00?l000009_ooool00ol0003oooooooooo`07ooooo`07o`00oooo003ooooooooo
oooo003oooooool00002ooooo`07ool00?oooooo0?ZJool00?l0nY[oo`00o`3jVP03ooooo`05o`3j
V_ooooooooooool00?l0nYX01Oooool00ol00?ooooooooooo`04o`0000Sooooo0_oo000Kooooo`;o
0?ZJ0oooool01Ooo003oooooo`3jV_oo003o0?ZJ01Kooooo00?o0?ZJooooool00?l00_ooool01Ooo
003oooooo`3jV_oo003o0?ZJ01?ooooo0ol00?l;ooooo`03o`00oooooooooooo00?ooooo00?oo`00
o`3jV_ooool01_ooool00ol0nY[oo`00ool00009ooooo`;o0?ZJ1_ooool01_l0nY[oo`00ool00?oo
ooooo`00o`3jVP[ooooo0ol00?l7ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oo
oooooooo00;ooooo00So0?ZJooooooooooooo`00ooooool00?oo0?ZJool000;ooooo00Ooo`00oooo
ooooooooo`00ooooool0nY[oo`0001Sooooo00Goo`00o`00ooooooooo`00o`3jVP0Yooooo`07o`3j
V_oo003o003oooooool0nY[oooooool00013ooooo`05o`3jV_l00?ooooooooooool0nYX0;oooool0
0ol0003oooooooooo`0Xooooo`05o`000?ooooooooooooooool0nYX00_ooool02ooo003o003ooooo
oooooooo0?ZJool00?ooooooo`00o`3jV_ooooooo`0000;ooooo00?oo`00oooooooo00003?ooool0
0ol0nY[oooooo`3jVP05ooooo`08ool00?l0nY[oooooooooool00?oo0?ZJool00?l0nYX;ooooo`04
o`3jV_oo003oooooool001Oooooo00?o0?ZJool00?l0nYX00_ooool01Ol00?oooooooooooooooooo
o`0001Gooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`03ooooo`06o`3jV_oooooo
ooooooooool00?oo0?ZJ0_ooool01?l00?ooooooooooool0nYX9ooooo`07o`3jV_oo003ooooooooo
ool00?ooo`00o`3jVP0=ooooo`03o`3jV_oooooo0?ZJ01Cooooo00?o0?ZJool00?ooool00_ooool0
1Ol0nY[o003oooooooooooooo`0000;ooooo00?oo`00o`000?ooool09Oooool00ol0003ooooooooo
o`07ooooo`07o`00oooo003ooooooooooooo003oooooool00002ooooo`03ool00?oooooo0?ZJ00;o
o`0000?oooooo`3jV_l00?l00_ooool01Ol0nY[ooooooooooooo003o0?ZJ00Gooooo00Co003ooooo
oooooooooooo0_l00009ooooo`;oo`006oooool2o`3jVP?ooooo00Goo`00ooooool0nY[oo`00o`3j
VP0Eooooo`;o0?ZJ0_l00?l2ooooo`05ool00?oooooo0?ZJool00?l0nYX04oooool00ol00?oooooo
o`00o`0:ooooo`03o`00oooooooooooo00Cooooo00?oo`00o`3jV_ooool01_ooool00ol0nY[oo`00
ool00009ooooo`;o0?ZJ1Oooool01ol0nY[oooooool00?oo003oooooool00?l0nYX02Oooool00ol0
0?ooooooo`3jVP08o`3jVP03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00;o
oooo00_o0?ZJooooooooooooo`00ooooool00?oo0?ZJool00?l0nY[oooooool00002ooooo`04ool0
0?oooooo0?ZJool001Sooooo00Goo`00ooooool00?ooo`00o`3jVP0Yooooo`07o`3jV_oo003o003o
ooooool0nY[oooooool00013ooooo`05o`3jV_l00?ooooooooooool0nYX0:oooool2o`00o`;ooooo
00?o0000ooooooooool0:?ooool2o`000003ooooool0nY[ooooo00;ooooo00_oo`00o`00oooooooo
ooooo`3jV_oo003oooooool00?l0nY[oooooool00002ooooo`03ool00?ooooooo`0000cooooo00?o
0?ZJooooool0nYX01Oooool02?oo003o0?ZJoooooooooooo003oo`3jV_oo003o0?ZJ2oooool01?l0
nY[oo`00oooooooo000Gooooo`03o`3jV_oo003o0?ZJ00;ooooo00Go003oooooooooooooooooool0
000Eooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool01?ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00?ooooo00Co003ooooooooooooo0?ZJ2Oooool01ol0nY[oo`00oooooooooooo003o
ool00?l0nYX03Oooool00ol0nY[oooooo`3jVP05ooooo`;o0?ZJ3?ooool00ol0nY[oooooool00003
ooooo`05o`3jV_oooooooooooooooooo00000_ooool00ooo003o0000ooooo`0Uooooo`;o00002?oo
ool01ol00?ooo`00ooooooooooooo`00oooooooo00000_ooool00ooo003oooooo`3jVP02ool00003
ooooool0nY[o003o00;o003o00Goooooo`3jV_ooooooo`00o`3jVP05ooooo`03o`00oooooooooooo
00;ooooo00?oo`00o`00ooooool01oooool2ool001_ooooo00?o0?ZJooooool0nYX00_ooool01Ooo
003oooooo`3jV_oo003o0?ZJ01Gooooo00?o0?ZJooooool0nYX00oooool01Ooo003oooooo`3jV_oo
003o0?ZJ01?ooooo00?o003oooooool00?l02_ooool00ol00?ooooooooooo`04ooooo`;oo`001ooo
ool00ol0nY[oo`00ool00009ooooo`;o0?ZJ1Oooool01ol0nY[oooooool00?oo003oooooool00?l0
nYX02Oooool00ol00?oo0?ZJo`3jVP02o`00o`Gooooo00?o0?ZJo`000?ooool0@_ooool004Wooooo
00?o0000ooooooooool00_ooool02ol0nY[ooooooooooooo003oooooo`00ool0nY[oo`00o`3jV_oo
ooooo`0000;ooooo00Coo`00ooooool0nY[oo`005oooool01_l0nY[oo`00ooooool00?ooo`00o`3j
VRWooooo00Oo0?ZJool00?l00?ooooooo`3jV_ooooooo`0004;ooooo00Ko003oo`3jV_oo003oo`00
ooooool0nYX[ooooo`;o003o0_ooool00ol0003oooooooooo`0Xooooo`04o`000?ooooooooooo`3j
VP?ooooo00_oo`00o`00ooooooooooooo`3jV_oo003oooooool00?l0nY[oooooool00002ooooo`03
ool00?ooooooo`0000cooooo00?o0?ZJooooool0nYX01Oooool02?oo003o0?ZJoooooooooooo003o
o`3jV_oo003o0?ZJ2oooool01?l0nY[oo`00oooooooo000Gooooo`03o`3jV_oo003o0?ZJ00;ooooo
00Go003oooooooooooooooooool0000Eooooo`03o`3jV_oooooooooo00_ooooo0_l0nYX6ooooo`05
o`3jV_ooooooooooooooool0nYX00oooool01?l00?ooooooooooool0nYX9ooooo`07o`3jV_oo003o
ooooooooool00?oo0?ZJool0000=ooooo`03o`3jV_oooooo0?ZJ00Gooooo0_l0nYX<ooooo`03o`3j
V_oo003oo`0000?ooooo00?o0?ZJooooooooool00_oo0002ooooo`03ool00?l0003ooooo02Gooooo
00?o0000ooooooooool01oooool01ol00?ooo`00ooooooooooooo`00oooooooo00000_ooool00ooo
003oooooo`3jVP02ool00003o`3jV_l00?oooooo00?o003o00Co0?ZJooooooooooooo`001Oooool0
0ol0nY[oooooooooo`02ooooo`03ool00?l00?oooooo00Oooooo0_oo000Kooooo`03o`3jV_oooooo
0?ZJ00;ooooo00Goo`00ooooool0nY[oo`00o`3jVP0;ooooo`03o`00oooooooooooo00Oooooo00?o
0?ZJooooool0nYX00oooool01Ooo003oooooo`3jV_oo003o0?ZJ01?ooooo00?o003oooooool00?l0
2_ooool00ol00?ooooooooooo`04ooooo`;oo`001oooool00ol0nY[oo`00ool00009ooooo`;o0?ZJ
1Oooool01?l0nY[oo`00o`00ooooool3ool000Wooooo0_l0nYX2ooooo`03o`00oooooooooooo00?o
oooo00?o0?ZJo`000?ooool0@_ooool004Wooooo00?o0000ooooooooool00_ooool02ol0nY[ooooo
oooooooo003o003oooooool0nY[oo`00o`3jV_ooooooo`0000;ooooo00Goo`00ooooool0nY[oo`00
o`3jVP0Fooooo`07o`3jV_oo003oooooo`00oooo003oooooo`3jVP0Xooooo`07o`3jV_oo003o003o
ooooool0nY[oooooool00012ooooo`03o`3jV_ooooooo`0000;oo`0000?o0?ZJooooooooool0:Ooo
ool2o`00o`;ooooo00?o0000ooooooooool06_ooool3o`0000Cooooo0_l00005ooooo`04o`000?oo
ooooooooo`3jVP?ooooo00_oo`00o`00ooooooooooooo`3jV_oo003oooooool00?l0nY[oooooool0
0002ooooo`03ool00?ooooooo`0000cooooo00?o0?ZJooooool0nYX01Oooool02?oo003o0?ZJoooo
oooooooo003oo`3jV_oo003o0?ZJ2oooool01?l0nY[oo`00o`3jV_oo000Gooooo`03o`3jV_oo003o
0?ZJ00;ooooo00Go003oooooooooooooooooool0000Eooooo`03o`3jV_oooooooooo00_ooooo00?o
0?ZJooooooooool01Oooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Co003ooooooooooooo
0?ZJ2Oooool01ol0nY[oo`00oooooooooooo003oo`3jV_oo00003?ooool01?l0nY[oooooooooool0
nYX5ooooo`;o0?ZJ3?ooool00ol0nY[oo`00ool00002ooooo`06o`3jV_l00?oooooooooooooo003o
003o0_ooool00ooo003o0000ooooo`0Gooooo`Go00000oooool2o`0000Cooooo00?o0000oooooooo
ool01oooool01ol00?ooo`00ooooooooooooo`00oooooooo00000_ooool00ooo003oooooo`3jVP02
ool00003o`3jV_l00?oooooo00;ooooo00Go003oo`3jV_ooooooooooool00004ooooo`03o`00ool0
nY[ooooo00?ooooo00?oo`00o`3jV_ooool01oooool2ool001_ooooo00?o0?ZJooooool0nYX00_oo
ool01_oo003oooooo`3jV_oo003o003oo`3jVPWooooo0ol00?l8ooooo`03o`3jV_oooooo0?ZJ00?o
oooo00Koo`00ooooool0nY[oo`00ooooool0nYXBooooo`03o`00oooooooo003o00[ooooo00?o003o
ooooooooool01?ooool2ool000Oooooo00?o0?ZJool00?oo00002Oooool2o`3jVPGooooo00Co0?ZJ
ool00?l00?oooooo0ooo0009ooooo`05o`3jV_ooooooooooooooool00?l01Oooool00ol0nY[o0000
ooooo`12ooooo`00BOooool2o`0000?ooooo00_o0?ZJooooooooooooo`00o`00oooooooo0?ZJool0
0?l0nY[oooooool00002ooooo`05ool00?ooooooo`00o`3jV_oo00005_ooool01ol0nY[oo`00oooo
ool00?ooooooool00?l0nYX0:?ooool01?l0nY[oo`00ooooool0nYX2ooooo`03ool00?oooooooooo
033ooooo00?o003oooooooooool03Oooool01_l0nY[oooooool00?ooooooo`00o`3jVR[ooooo00Co
003oooooool00?oooooo0_l0000Mooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001?ooool01?l0003oooooooooool0nYX2ooooo`03ool00?oooooo003o00;ooooo00Oo0?ZJool0
0?ooooooo`00o`3jV_ooooooo`0000;ooooo00?oo`00oooooooo00003?ooool00ol0nY[oooooo`3j
VP04ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Co003oo`3jV_oo003o0?ZJ2oooool01?l0nY[oo`00
o`3jV_oo000Gooooo`03ool00?oooooo0?ZJ00;ooooo00Go003oooooooooooooooooool0000Eoooo
o`03o`3jV_oooooooooo00_ooooo00?o0?ZJo`00ooooool01Oooool01Ol0nY[oooooooooool0nY[o
003o00?ooooo00Co003ooooooooooooo0?ZJ2?ooool00ol00?oo0?ZJool00002ooooo`03o`00ool0
nY[oo`0000cooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooo`3jVP0<ooooo`03o`3j
V_oo003oo`0000;ooooo00Ko0?ZJo`00ooooooooo`00ooooool00?l2ooooo`03ool00?l0003ooooo
01Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00003ooooo`03o`000?oo
oooooooo00Oooooo00Oo003oool00?ooooooooooool00?ooooooo`0000;ooooo00?oo`00ooooool0
nYX00_oo00000ol0nY[o003oooooo`02ooooo`05o`00ool0nY[ooooooooooooo00001?ooool2o`3j
VPCooooo00?oo`00o`3jV_ooool01oooool2ool000[ooooo00?o0?ZJooooooooool03_ooool00ol0
nY[oooooo`3jVP02ooooo`06ool00?oooooo0?ZJool00?l00?oo0?ZJ2Oooool00ol00?ooooooo`00
o`08ooooo`03o`3jV_oooooo0?ZJ00?ooooo00Koo`00ooooooooooooo`00ooooool0nYXBooooo`04
o`00ooooooooooooo`00o`Wooooo00?o003oooooooooool01?ooool2ool000Oooooo00?o0?ZJool0
0?oo00002Oooool2o`3jVPGooooo00Co0?ZJool00?l00?oooooo0ooo0008ooooo`;o00000oooool0
0ol00?ooooooooooo`03ooooo`03o`3jV_l0003ooooo04;ooooo0019ooooo`03o`000?oooooooooo
00;ooooo00_o0?ZJooooooooooooo`00o`00oooooooo0?ZJool00?l0nY[oooooool00002ooooo`05
ool00?ooooooo`00o`3jV_oo00005_ooool01ol0nY[oo`00ooooool0nY[oooooool00?l0nYX09ooo
ool01Ol0nY[o003oool00?oooooo0?ZJ00;ooooo00?oo`00ooooooooool0;oooool3o`00o`03oooo
ool0nY[ooooo00_ooooo00Ko0?ZJool00?l00?ooooooool00?l0nYXZooooo`03o`00oooooooo003o
00;ooooo00?o0000ooooooooool04oooool5o`0000?ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`;o000000Ooooooo`3jV_ooooooooooool00?oooooo003o00;ooooo
00Co0?ZJool00?ooooooo`000_ooool01_oo003ooooooooooooo003oooooool000cooooo00?o0?ZJ
ool00?l0nYX01?ooool00ol0nY[oo`00o`3jVP02ooooo`04o`00ool0nY[oo`00o`3jVP_ooooo00Co
0?ZJool00?l0nY[oo`005_ooool01?l0nY[oo`00ooooool0nYX2ooooo`05o`00oooooooooooooooo
oooo00005?ooool2o`3jVPcooooo00?o0?ZJo`00ool00?l01_ooool01?l0nY[oooooooooool0nYX4
ooooo`04o`00oooo003oo`00ool000Sooooo00?o003oo`3jV_oo00000_ooool00ol00?oo0?ZJool0
000<ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooool0nYX03?ooool00ol0nY[oo`00
ool00002ooooo`0:o`3jV_l00?ooooooool00?oooooo003oooooool0003oo`00o`0001[ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`?o00001oooool01ol00?ooo`00
ooooooooooooo`00oooooooo00000_ooool00ooo003oooooo`3jVP02ool00003o`00oooooooooooo
00;ooooo00Go003oo`3jV_ooooooooooool00004ooooo`;o0?ZJ1?ooool00ooo003o0?ZJooooo`07
ooooo`;oo`002_ooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00Oooooo00Co0?ZJ
o`00oooooooo0?ZJ0_ooool01_oo003oooooo`3jV_oo003o003oo`3jVPWooooo00Co003ooooooooo
oooo003o1oooool00ol0nY[oooooo`3jVP03ooooo`06ool00?ooooooooooool00?l00?oo0?ZJ4_oo
ool01?l00?ooooooooooool00?l9ooooo`03o`00oooooooooooo00Cooooo0_oo0007ooooo`03o`3j
V_oo003oo`0000Wooooo0_l0nYX5ooooo`04o`3jV_oo003o003oooooo`?oo`001oooool4o`0000;o
oooo00?o003oooooooooool00_ooool00ol0003o0?ZJo`000013ooooo`00BOooool00ol0003ooooo
ooooo`02ooooo`0;o`3jV_ooooooooooool00?l00?ooooooo`3jV_oo003o0?ZJoooooooo00000_oo
ool01Ooo003oooooool00?l0nY[oo`0001Kooooo00Oo0?ZJool00?l0nY[o0?ZJoooooooo003o0?ZJ
02Oooooo00Go0?ZJo`00oooo003oooooo`3jVP02ooooo`03ool00?oooooooooo02oooooo0ol00?l0
0ooooooo0?ZJooooo`0;ooooo`07o`3jV_oo003oooooo`00oooo003oooooo`3jVP0Yooooo`06o`00
oooooooo003oo`00oooooooo00007Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo00Co0000oooooooooooo0?ZJ0_ooool00ooo003o003oooooo`02ooooo`04o`3jV_oo
003oooooool000;ooooo00Koo`00ooooooooooooo`00oooooooo000<ooooo`03o`3jV_oo003o0?ZJ
00Cooooo00?o0?ZJool00?l0nYX00_ooool01?l00?oo0?ZJool00?l0nYX;ooooo`04o`3jV_oo003o
0?ZJool001Kooooo00?o0?ZJool00?l0nYX00oooool01Ol00?ooooooooooooooooooo`0001Cooooo
0_l0nYX<ooooo`04o`3jV_oooooo003oo`00o`Gooooo00Co0?ZJoooooooooooo0?ZJ1?ooool2ool0
0003oooooooo003ooooo00Oooooo00?o003oool00?l0nYX00_ooool00ol00?oo0?ZJool0000<oooo
o`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ2oooool00ol0nY[oo`00ool0
0002ooooo`06o`3jV_ooooooo`00ool00?oooooo003o0_ooool00ooo003o0000ooooo`0Jooooo`05
o`000?ooooooooooooooool000000_ooool01Ol0003ooooooooooooooooo000000Wooooo00Oo003o
ool00?ooooooooooool00?ooooooo`0000;ooooo00?oo`00ooooool0nYX00_oo00000ol00?oooooo
ooooo`02ooooo`05o`00oooooooo0?ZJoooooooo00001?ooool2o`3jVPCooooo00?oo`00o`3jV_oo
ool01oooool2ool000[ooooo00?o0?ZJooooooooool00_ooool2o`00o`Wooooo00Co0?ZJoooooooo
oooo0?ZJ0_ooool01_oo003oooooo`3jV_ooooooo`00o`3jVPWooooo00Co003ooooooooooooo003o
1oooool00ol0nY[oooooo`3jVP03ooooo`06ool00?ooooooooooo`3jV_oo003o0?ZJ4Oooool01Ol0
0?oooooooooooooooooo003o00Wooooo00?o003oooooooooool01?ooool2ool000Oooooo00?o0?ZJ
ool00?oo00002Oooool2o`3jVPGooooo00Co0?ZJool00?l00?oooooo0ooo00000ol0nY[ooooooooo
o`04ooooo`Co000000?oo`00ooooool00?l01Oooool00ol0nY[o0000ooooo`12ooooo`00BOooool0
0ol0003oooooooooo`02ooooo`06o`3jV_ooooooooooool00?l00?oooooo0_l0nYX00ooo003ooooo
ool00002ooooo`05ool00?ooooooo`00o`3jV_oo00005_ooool01ol0nY[oo`00o`3jV_l00?oo0?ZJ
ool00?l0nYX09oooool01Ol0nY[o003oool00?oooooo0?ZJ00;ooooo00?oo`00ooooooooool0:?oo
ool00ol0nY[oooooooooo`04ooooo`?o003o0_l0nYX<ooooo`07o`3jV_oo003oooooo`00oooooooo
o`00o`3jVP0Yooooo`06o`00ooooooooooooo`00oooooooo00007Oooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo0?ZJ0_ooool00ooo003o003o
ooooo`02ooooo`04o`3jV_oo003oooooool000;ooooo00Koo`00ooooooooooooo`00oooooooo000<
ooooo`;oo`0000?oooooo`3jV_ooool00_ooool00ol0nY[oo`00ooooo`02ooooo`04o`00ool0nY[o
o`00o`3jVP_ooooo00Co0?ZJool00?l0nY[oo`003_ooool2o`3jVPKooooo00?o0?ZJool00?l0nYX0
1?ooool01?l00?oooooooooooooo000=ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX;ooooo`;o
0?ZJ0_ooool01?l00?oooooooooooooo0002ooooo`04o`3jV_ooooooooooo`3jVP?ooooo0_oo0002
ooooo`03ool00?oooooooooo00Kooooo00?o003oool00?l0nYX00_ooool00ol00?oo0?ZJool0000<
ooooo`04o`3jV_ooooooooooo`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ2oooool02?l0nY[oo`00
ool00?oooooo0?ZJo`00ooooooooo`000_ooool01Ol00?oooooooooooooo003o000001Sooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooooooo
ool01oooool01ol00?ooo`00ooooooooooooo`00oooooooo00000_ooool00ooo003oooooo`3jVP02
ool00003o`00oooooooooooo00?ooooo00Co003oo`3jV_ooooooo`001?ooool2o`3jVPCooooo0_oo
0008ooooo`;oo`002_ooool00ol0nY[oooooooooo`02ooooo`;o003o2Oooool01?l0nY[ooooooooo
ool0nYX2ooooo`06ool00?oooooo0?ZJoooooooo003o0?ZJ2?ooool2o`00o`;ooooo00?o003ooooo
ooooool01Oooool00ol0nY[oooooo`3jVP03ooooo`06ool00?ooooooooooo`3jV_oo003o0?ZJ4Ooo
ool01Ol00?oooooooooooooooooo003o00Wooooo00?o003oooooooooool01?ooool2ool000Oooooo
00?o0?ZJool00?oo00002?ooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_oo003oooooooooo`?o
o`0000?o0?ZJooooooooool01Oooool2o`000005oooooooo003oo`00ooooool00?l01?ooool00ol0
nY[o0000ooooo`12ooooo`00BOooool00ol0003oooooooooo`02ooooo`06o`3jV_ooooooooooool0
0?l00?oooooo0_l0nYX00ooo003oooooool00002ooooo`05ool00?ooooooo`00o`3jV_oo00005_oo
ool01ooo003o0?ZJooooool00?oo0?ZJool00?l0nYX09oooool01Ol0nY[oo`00oooooooooooo0?ZJ
00;ooooo00?oo`00ooooooooool09oooool2o`3jVPKooooo0ol00?l2o`3jVP_ooooo00So003oo`3j
V_oo003oooooo`00ooooooooo`00o`3jVRWooooo00Ko003ooooooooooooo003oooooool0000Loooo
o`;o00001?ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`3jVP;ooooo00?o
o`00o`00ooooool00_ooool01?l0nY[oo`00oooooooo0002ooooo`06ool00?ooooooooooool00?oo
ooooo`003?ooool01?oo003oooooool00?l0nYX3ooooo`03o`3jV_oo003ooooo00;ooooo00Co003o
oooooooo003o0?ZJ2oooool01?oo003oooooo`3jV_oo000>ooooo`;o0?ZJ1_ooool00ol0nY[oo`00
o`3jVP04ooooo`04o`00ooooooooooooool000gooooo0_l0nYX5ooooo`;o0?ZJ2oooool01?l0nY[o
ooooooooooooool6ool00004o`3jV_oooooo0?ZJo`00o`;ooooo00Koo`00oooooooooooo003ooooo
oooo0008ooooo`03o`00oooo003o0?ZJ00;ooooo00?o003oo`3jV_oo00003?ooool01?l0nY[ooooo
ooooool0nYX4ooooo`04o`3jV_ooooooooooo`3jVP_ooooo00So0?ZJool00?oo003oooooo`3jV_l0
0?ooooooool000;ooooo00Go003oooooooooooooo`00o`00000Hooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Sooooo00Koo`00
ooooooooooooo`00oooooooo0002ooooo`05ool00?oooooo0?ZJool00?l0nYX01_ooool01?l00?oo
0?ZJoooooooo0004ooooo`03o`3jV_oooooo0?ZJ00?ooooo0_oo0008ooooo`;oo`0000?o003ooooo
ooooool01_ooool2o`3jVP?ooooo0ol00?l9ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00Koo`00
oooooooooooo0?ZJool00?l0nYX8ooooo`05o`00ooooooooooooooooool00?l01oooool00ol0nY[o
ooooo`3jVP03ooooo`06ool00?ooooooooooo`3jV_oo003o0?ZJ4Oooool4o`3jVP03o`00oooooooo
oooo00Oooooo00?o003oooooooooool01?ooool2ool000Oooooo00?o0?ZJool00?oo00002?ooool0
0ol0nY[oooooo`3jVP05ooooo`04o`3jV_oo003oooooooooo`?oo`0000?o0?ZJooooooooool01Ooo
ool01ol00?ooo`00ooooooooooooo`00ooooool00?l01?ooool00ol0nY[o0000ooooo`12ooooo`00
BOooool2o`0000?ooooo00Ko0?ZJooooooooooooo`00o`00ooooool2o`3jVP03ool00?ooooooo`00
00;ooooo00Goo`00oooooooo003o0?ZJool0000Fooooo`07ool00?l0nY[oooooo`00ool0nY[oo`00
o`3jVP0Wooooo`05o`3jV_oo003oooooooooool0nYX00_ooool00ooo003oooooooooo`0Wooooo`;o
0?ZJ1_ooool00ol00?ooooooo`3jVP02o`3jVP_ooooo00So0?ZJool00?ooooooooooo`00oooooooo
o`00o`3jVRWooooo00Co003ooooooooooooo003o0_l0000Mooooo`03o`000?oooooooooo00?ooooo
0_l00005ooooo`04o`000?ooooooooooo`3jVP;ooooo00?oo`00o`00ooooool00_ooool01?l0nY[o
o`00oooooooo0002ooooo`06ool00?ooooooooooool00?ooooooo`003?ooool01?oo003oooooool0
0?l0nYX3ooooo`03o`3jV_oo003ooooo00?ooooo00?o003oool00?l0nYX02_ooool01Ol0nY[oo`00
ooooool0nY[oo`0000[ooooo00Co0?ZJoooooooooooooooo0_l0nYX6ooooo`03o`3jV_oo003o0?ZJ
00Cooooo00Co003oooooooooooooo`002_ooool00ol0nY[oooooooooo`02o`3jVPGooooo0_l0nYX;
ooooo`03o`3jV_oooooooooo00;oo`001?ooool2ool00004ooooool0nY[o003oooooo`;oo`000_oo
ool00ol00?ooooooool00008ooooo`03o`00oooo003o0?ZJ00;ooooo00?o003oo`3jV_oo00003?oo
ool01?l0nY[oooooooooool0nYX4ooooo`04o`3jV_ooooooooooo`3jVP_ooooo00Oo0?ZJool00?oo
003oooooo`3jV_l00?ooo`0000Cooooo00Co003ooooooooo003o00006Oooool3o`0000Cooooo0_l0
0004ooooo`03o`000?oooooooooo00Sooooo00Koo`00ooooooooooooo`00oooooooo0002ooooo`05
ool00?oooooo0?ZJool00?l0nYX01_ooool01?l00?oo0?ZJoooooooo0003ooooo`04o`00ool0nY[o
ooooo`3jVP?ooooo0_oo0008ooooo`;oo`0000?o003oooooooooool01_ooool2o`3jVP;ooooo1?l0
0?l9ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00Koo`00oooooooooooo0?ZJool00?l0nYX8oooo
o`05o`00ooooooooooooooooool00?l01oooool00ol0nY[o003oo`3jVP03ooooo`06ool00?oooooo
ooooo`3jV_oo003o0?ZJ4?ooool2o`3jVP;ooooo0_l0nYX8ooooo`03o`00oooooooooooo00Gooooo
0_oo0007ooooo`03o`3jV_oo003oo`0000Sooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[oo`00
ooooooooool3ool00003o`3jV_oooooooooo00Gooooo00?o003oool00?l0nYX00_ooool00ooo003o
003oooooo`03ooooo`03o`3jV_l0003ooooo04;ooooo0019ooooo`05o`000?ooooooooooooooool0
nYX00oooool00ooo003o003oooooo`02o`3jVP03ool00?ooooooo`0000;ooooo00Goo`00oooooooo
003o0?ZJool0000Eooooo`08o`3jV_oo003o0?ZJooooool00?oo0?ZJool00?l0nYX=ooooo`03o`3j
V_oooooooooo01Oooooo00Go0?ZJool00?ooooooooooo`3jVP02ooooo`03ool00?oooooooooo02Ko
oooo00?o0?ZJooooool0nYX01_ooool01Ol00?ooooooo`3jV_l00?oo0?ZJ00_ooooo00So0?ZJool0
0?ooooooooooo`00ooooooooo`00o`3jVRWooooo00Ko003ooooooooooooo003oooooool0nYXZoooo
o`;o000000Koooooo`3jV_ooooooooooool00?l00?l3ooooo`04o`3jV_oo003oooooool000;ooooo
00Koo`00ooooooooooooo`00oooooooo000;ooooo`05o`3jV_oo003oooooool00?l0nYX00oooool0
0ol0nY[oo`00ooooo`03ooooo`03o`00oooo003o0?ZJ00[ooooo00Go0?ZJool00?oooooo0?ZJool0
000:ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1_ooool00ooo003oooooo`3jVP04ooooo`04
o`00ooooooooooooool000[ooooo00?o0?ZJooooooooool00_l0nYX5ooooo`;o0?ZJ2_ooool00ol0
nY[o003oooooo`02ool00003o`00oooooooooooo00?ooooo00Coo`00ooooool0nY[o003o0_oo0003
ooooo`03o`00ooooooooo`0000Sooooo00?o003oool00?l0nYX00_ooool00ol00?oo0?ZJool0000;
ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool01?l0nY[oooooooooool0nYX;ooooo`07o`3j
V_oo003oo`00ooooool0nY[o003oool00004ooooo`04o`00ooooooooo`00o`0002Kooooo0_l00009
ooooo`06ool00?ooooooooooool00?ooooooo`000_ooool00ooo003oooooo`3jVP02o`0000Kooooo
00Co003oo`3jV_ooooooo`000oooool01?l00?oo0?ZJooooool0nYX3ooooo`;oo`002?ooool2ool0
00;o003o1oooool2o`3jVP;ooooo00Go003oooooooooooooooooo`00o`08ooooo`04o`3jV_oooooo
ooooo`3jVP;ooooo00Koo`00oooooooooooo0?ZJool00?l0nYX8ooooo`05o`00oooooooooooooooo
ool00?l01oooool00ol0nY[oo`00o`3jVP03ooooo`06ool00?ooooooooooo`3jV_oo003o0?ZJ4?oo
ool2o`0000?ooooo0_l0nYX7ooooo`03o`00oooooooooooo00Gooooo0_oo0007ooooo`03o`3jV_oo
003oo`0000Sooooo00?o0?ZJooooool0nYX01Oooool01?l0nY[oo`00ooooooooool3ool00003o`3j
V_oooooooooo00Cooooo00Co003ooooooooo003o0?ZJ0_ooool00ooo003o003oooooo`03ooooo`03
o`3jV_l0003ooooo04;ooooo0019ooooo`05o`000?ooooooooooooooool0nYX00oooool00ooo003o
003oooooo`02o`3jVP03ool00?ooooooo`0000;ooooo00Goo`00oooooooo003o0?ZJool0000Eoooo
o`08o`3jV_oo003o0?ZJooooool00?oo0?ZJool00?l0nYX=ooooo`03o`3jV_oooooooooo01Oooooo
00Go0?ZJool00?oooooo0?ZJo`00o`02ooooo`03ool00?oooooooooo02Kooooo00?o0?ZJooooool0
nYX01Oooool01_l00?ooooooo`3jV_l0nY[o003oo`3jVP_ooooo00?o0?ZJool00?ooool00_l0nYX0
0oooooooo`00o`3jVP0Yooooo`04o`00ooooooooooooo`00o`;o0?ZJ:_ooool01?l0003ooooooooo
ool0nYX2ooooo`03ool00?l00?oooooo00;ooooo00Co0?ZJool00?ooooooo`000_ooool01_oo003o
oooooooooooo003oooooool000_ooooo00Go0?ZJool00?ooooooo`00o`3jVP02ooooo`03o`00ool0
nY[oo`0000Cooooo00?o003oool00?l0nYX02_ooool01Ol0nY[oo`00ooooool0nY[oo`0000[ooooo
00Ko0?ZJoooooooooooo0?ZJooooool0nYX6ooooo`03ool00?l0nY[ooooo00Cooooo00Co003ooooo
ooooooooo`002Oooool2o`3jVP;ooooo0_l0nYX5ooooo`;o0?ZJ2Oooool2o`000005oooooooo003o
o`00ooooool00?l01Oooool01Ooo003o0?ZJooooool00?ooo`0000Cooooo00?o003ooooooooo0000
2?ooool00ol0nY[oo`00o`3jVP02ooooo`03o`00ool0nY[oo`0000_ooooo00Go0?ZJoooooooooooo
ooooo`3jVP03ooooo`05o`3jV_ooooooooooooooool0nYX02oooool01_l0nY[oo`00ool00?l0nY[o
003oool000Gooooo00Co003ooooooooo003o00009_ooool00ol0003oooooooooo`08ooooo`06ool0
0?ooooooooooool00?ooooooo`000_ooool00ooo003oooooo`000003o`0000Gooooo00Co003oo`3j
V_ooooooo`000oooool01?l00?oo0?ZJooooool0nYX3ooooo`;oo`0000?o003oooooooooool01Ooo
ool2o`000003ooooool00?oooooo00Kooooo0_l0nYX00ooooooo003oo`00o`03ooooo`03o`00oooo
oooooooo00Kooooo00Co0?ZJool00?oo003o0?ZJ0_ooool01ooo003oooooooooool0nY[oo`00oooo
ool0nYX01oooool01Ol00?oooooooooooooooooo003o00Oooooo0_oo00001Ol0nY[ooooooooooooo
ooooo`0000;ooooo00?o0?ZJool00?l0nYX03oooool4o`0000?ooooo0_l0nYX6ooooo`03o`00oooo
oooooooo00Gooooo0_oo0007ooooo`03o`3jV_oo003oo`0000Sooooo00?o0?ZJooooool0nYX01Ooo
ool00ol0nY[oo`00ooooo`02ooooo`03ool00?l0nY[oo`0000Kooooo00Co003ooooooooo003o0?ZJ
0oooool00ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo047ooooo000kooooo`?o00001?oo
ool2o`0000Gooooo00Go0000ooooooooooooooooo`3jVP03ooooo`03ool00?l00?oooooo00;o0?ZJ
00?oo`00oooooooo00000_ooool01Ooo003oooooool00?l0nY[oo`0001Gooooo00So0?ZJool00?l0
nY[oooooo`00ool0nY[oo`00o`3jVPgooooo00?o0?ZJooooooooool05oooool01Ol0nY[oo`00oooo
ool0nY[o003o00;ooooo00?oo`00ooooooooool09Oooool01?l0nY[oooooooooool0nYX5ooooo`06
o`00oooooooo0?ZJooooool00?oo0?ZJ2oooool00ol0nY[oo`00ooooo`02o`3jVP03oooooooo003o
0?ZJ02Sooooo00Go003oooooooooooooooooo`00o`02o`3jVR[ooooo00?o0000ooooool0nYX00ooo
ool00ooo003o003oooooo`02ooooo`04o`3jV_oo003oooooool000;ooooo00Koo`00oooooooooooo
o`00oooooooo000;ooooo`05o`3jV_oo003oooooool00?l0nYX00_ooool00ol00?oo0?ZJool00004
ooooo`03o`00oooo003o0?ZJ00[ooooo00Go0?ZJool00?oooooo0?ZJool0000:ooooo`04o`3jV_oo
ooooooooo`3jVP;ooooo00?o0?ZJooooooooool00oooool00ooo003o0?ZJooooo`04ooooo`04o`00
ooooooooooooool000Wooooo0_l0nYX01?oooooo0?ZJooooool0nYX5ooooo`;o0?ZJ2?ooool4o`00
0005ool00?ooooooooooooooool00?l01?ooool00ooo003o0?ZJo`00o`02ool000Cooooo00?o003o
oooooooo00002?ooool00ol0nY[oo`00ooooo`03ooooo`03o`00oooo003ooooo00[ooooo00Go0?ZJ
ooooooooooooooooo`3jVP03ooooo`05o`3jV_ooooooooooooooool0nYX02oooool01_l0nY[oo`00
ool00?l0nY[o003oool000Gooooo00Co003ooooooooo003o00009_ooool00ol0003oooooooooo`08
ooooo`06ool00?ooooooooooool00?ooooooo`000_ooool00ooo003oooooo`000003o`0000Gooooo
00Co003oo`3jV_ooooooo`000oooool01?l00?oo0?ZJooooool0nYX3ooooo`;oo`0000?o003ooooo
ooooool01?ooool4o`000003o`00oooooooooooo00Gooooo0_l000000ol0nY[o003oooooo`03oooo
o`03o`00oooooooooooo00Kooooo00Co0?ZJool00?oo003ooooo0_l0nYX01ooo003oooooooooool0
nY[oo`00ooooool0nYX01oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?ooooo
00Co0?ZJool00?oo003o0?ZJ0oooool01_oo003oooooooooool0nY[oo`00o`3jVPoooooo1?l00003
ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oooooooooool01Oooool2ool000Oooooo00?o0?ZJ
ool00?oo00002?ooool00ol0nY[oooooo`3jVP05ooooo`03o`3jV_oo003ooooo00;ooooo0_l0nYX0
0ooo003oooooooooo`04ooooo`05o`00ooooooooo`00ooooool0nYX00_ooool00ooo003ooooooooo
o`03ooooo`03o`3jV_oooooooooo047ooooo000looooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00?ooooo00Soo`00o`00oooooooo
0?ZJoooooooo003oooooool000;ooooo00Goo`00oooooooo003o0?ZJool0000Eooooo`08o`3jV_oo
003o0?ZJooooool00?oo0?ZJool00?l0nYX=ooooo`03o`3jV_oooooooooo01Oooooo00Go0?ZJool0
0?oooooo0?ZJo`00o`02ooooo`03ool00?oooooooooo02Gooooo00Co0?ZJoooooooooooo0?ZJ1Ooo
ool01_l00?ooooooo`3jV_oooooo003oo`3jVP_ooooo00So0?ZJool00?l0nY[oooooo`00ool0nY[o
o`00o`3jVRSooooo00Oo003oooooooooooooooooo`3jV_oooooo0?ZJ02[ooooo00?o0000ooooool0
nYX00_ooool00ooo003oooooo`00o`03ooooo`04o`3jV_oo003oooooool000;ooooo00Koo`00oooo
ooooooooo`00oooooooo000;ooooo`05o`3jV_oo003oooooool00?l0nYX00_ooool00ol00?oo0?ZJ
ool00004ooooo`03o`00oooo003o0?ZJ00[ooooo00Go0?ZJool00?oooooo0?ZJool0000:ooooo`04
o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool00oooool00ooo003o0?ZJooooo`04oooo
o`04o`00ooooooooooooool000Wooooo0_l0nYX01?oooooo0?ZJooooool0nYX5ooooo`;o0?ZJ2?oo
ool4o`0000Cooooo0_l00?l3ooooo`04ool00?l0nY[o003oool000Gooooo00?o003ooooooooo0000
1oooool2o`3jVP03ool00?oooooooooo00;ooooo00?o003oool00?ooool02_ooool01Ol0nY[ooooo
oooooooooooo0?ZJ00?ooooo00Go0?ZJooooooooooooooooo`3jVP0;ooooo`04o`3jV_oo003oo`00
o`3jVP;oo`001Oooool01?l00?ooooooool00?l0000Vooooo`03o`000?oooooooooo00Sooooo00Ko
o`00ooooooooooooo`00oooooooo0002ooooo`03ool00?oooooo0?ZJ00;o00001_ooool01?l00?oo
ooooo`3jV_oo0003ooooo`04o`00ool0nY[oooooo`3jVP?ooooo0_oo00000ol00?ooooooooooo`04
ooooo`Co000000?o003oooooooooool01?ooool4o`000003o`3jV_oooooooooo00;ooooo00?o003o
ooooooooool01_ooool01?l0nY[oo`00ool00?ooool2o`3jVP07ool00?ooooooooooo`3jV_oo003o
ooooo`3jVP07ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00oooool01?l0nY[o
o`00oooooooo0003ooooo`07ool00?ooooooooooo`3jV_oo003oooooo`3jVP05ooooo`?o0?ZJ1ooo
ool2o`000006ool00?ooooooooooooooool00?oooooo0_l0nYX4ooooo`03o`00oooooooooooo00Go
oooo0_oo00000ol0nY[oooooooooo`04ooooo`03o`3jV_oo003oo`0000Kooooo0_l00?l00ol0nY[o
ooooo`3jVP05ooooo`05ool00?oooooo0?ZJo`3jV_ooool00_l0nYX00ooo003oooooooooo`04oooo
o`05o`00ooooooooo`00ooooool0nYX00_ooool00ol00?ooo`00ooooo`03ooooo`03o`3jV_oooooo
oooo047ooooo000dooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo0_l00002ooooo`0<o`3jV_ooooooooooool00?oooooo003oooooool0nY[oooooool0
0?ooooooo`000_ooool01Ooo003oooooool00?l0nY[oo`0001Gooooo00So0?ZJool00?oooooooooo
o`00ool0nY[oo`00o`3jVPgooooo00?o0?ZJooooooooool05_ooool01_l0nY[o003oool00?oooooo
0?ZJo`00o`;ooooo00?oo`00ooooooooool08oooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oo
oooooooo00?ooooo00Ko003oo`3jV_l0nY[oooooo`00ool0nYX;ooooo`08ool00?oooooo0?ZJoooo
ool00?oo0?ZJool00?l0nYXXooooo`07o`00ooooooooooooooooool0nY[o0000o`3jVP0Zooooo`;o
000000Ko0?ZJooooooooooooo`00ooooool00?l3ooooo`04o`3jV_oo003oooooool000;ooooo00Ko
o`00ooooooooooooo`00oooooooo000;ooooo`05o`3jV_oo003o0?ZJool00?l0nYX00_ooool00ol0
0?oo0?ZJool00004ooooo`03o`00ool0nY[oo`0000[ooooo00Go0?ZJool00?l0nY[oooooool00009
ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYX5ooooo`03ool00?l0nY[ooooo00Cooooo00Co
003oooooooooooooo`002Oooool2o`3jVP04ooooool0nY[oooooo`3jVPGooooo0_l0nYX7ooooo`;o
003o0_l00006ooooo`06o`00oooooooooooooooooooo003o0?ZJ0_oo0005ooooo`03o`00oooooooo
o`0000Oooooo00?o0?ZJo`00oooo00001?ooool00ol00?ooo`00ooooo`0:ooooo`05o`3jV_oooooo
ooooooooool0nYX00oooool01Ol0nY[oooooool00?oooooo0?ZJ00_ooooo00Go0?ZJool00?oo003o
0?ZJool00006ooooo`04o`00ooooooooo`00o`0002Kooooo0_l00009ooooo`06ool00?oooooooooo
ool00?ooooooo`000_ooool01?oo003oooooo`3jV_oo0007ooooo`04o`00oooooooo0?ZJool000?o
oooo00Co0?ZJoooooooooooo0?ZJ0oooool2ool00003o`00oooooooooooo00Gooooo0_l000000ol0
nY[o003oooooo`05ooooo`Co000000?o0?ZJooooooooool00_ooool00ol00?ooooooooooo`05oooo
o`05o`00ool0nY[oo`00ool00?ooool00_l0nYX01ooo003oooooooooool0nY[oo`00ooooool0nYX0
1oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00?ooooo00Co0?ZJool00?oooooo
o`000oooool01ooo003oooooooooool0nY[oo`00ooooool0nYX01?ooool2o`3jVP03o`00ool0nY[o
0?ZJ00Kooooo00Coo`00oooooooo003oo`000_ooool01?l00?ooooooooooool0nYX4ooooo`03o`00
oooooooooooo00;ooooo0ol0nYX2ool00003o`3jV_oooooooooo00Cooooo00?o0?ZJool00?oo0000
1Oooool3o`00o`03o`3jV_oooooo0?ZJ00Gooooo00Goo`00ooooool0nY[o0?ZJooooo`02o`3jVP03
ool00?oooooooooo00Cooooo00Co003ooooooooo003ooooo0_l0nYX00ooooooo003oool00003oooo
o`03o`000?l0nY[ooooo04;ooooo000looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo00Woo`00ooooool00?ooooooo`3j
V_ooooooo`00oooooooo00000_ooool01Ooo003oooooool00?l0nY[oo`0001Gooooo00Soo`00o`3j
V_ooooooooooo`00ool0nY[oo`00o`3jVPgooooo00?o0?ZJooooooooool05_ooool01_l0nY[o003o
ool00?oooooo0?ZJo`00o`;ooooo00?oo`00ooooooooool08oooool00ol00?oo0?ZJooooo`02oooo
o`03o`3jV_oooooooooo00?ooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX;ooooo`08ool00?oo
oooo0?ZJooooool00?oo0?ZJool00?l0nYXXooooo`07o`00ooooooooooooo`3jV_l00?ooooooo`3j
VP0Zooooo`03o`000?oooooo0?ZJ00;ooooo00?oo`00ooooool00?l00oooool01?l0nY[oo`00oooo
oooo0002ooooo`06ool00?ooooooooooool00?ooooooo`002oooool01_l0nY[oo`00o`3jV_oo003o
0?ZJooooo`;o003o00?o0?ZJool00?ooool00oooool00ol00?oo0?ZJool0000:ooooo`05o`3jV_oo
003o0?ZJoooooooo00002Oooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool00ooo003o
ooooooooo`04ooooo`04o`00ooooooooooooool000Sooooo00So0?ZJooooool0nY[oooooo`3jV_oo
003oooooo`3jVPCooooo00?o0?ZJool00?ooool01_ooool01?l00?oooooooooooooo0006ooooo`07
o`00oooooooooooooooooooo003oooooool00006ooooo`03o`00ooooooooo`0000Oooooo00?o0?ZJ
o`00oooo00001?ooool00ol00?ooo`00o`3jVP0:ooooo`05o`3jV_ooooooooooool00?l0nYX00ooo
ool01Ol0nY[oo`00oooooooo003o0?ZJ00_ooooo00?o0?ZJool00?oo00000_oo0006ooooo`04o`00
ooooooooo`00o`0002Kooooo00?o0000ooooooooool02?ooool01_oo003ooooooooooooo003ooooo
ool000;ooooo00Coo`00ooooool0nY[oo`001oooool01?l00?ooooooo`3jV_oo0003ooooo`04o`3j
V_ooooooooooo`3jVP?ooooo0_oo00000ol00?ooooooooooo`04ooooo`06o`00oooo003oo`00o`3j
V_oooooo003o1_ooool2o`000003ooooool0nY[ooooo00?ooooo00?o003oooooooooool01Oooool0
1Ol00?oo0?ZJool00?ooooooo`0000;o0?ZJ00Ooo`00oooooooooooo0?ZJool00?oooooo0?ZJ00Ko
oooo00?o003oooooooooool00oooool00ol00?ooooooooooo`03ooooo`05o`3jV_oo003oooooool0
0?l0nYX00_ooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX01?ooool2o`0000;o003o0_l0
nYX4ooooo`05o`00oooo003o0?ZJoooooooo00000_ooool01Ol00?oooooooooooooooooo0?ZJ00;o
oooo00?o003oooooooooool00_ooool2o`3jVP;ooooo0_oo00000ol0nY[oooooooooo`04ooooo`03
o`3jV_oo003oo`0000Gooooo00?o003oooooool0nYX00_ooool00ooo003oooooooooo`02ooooo`03
o`3jV_oo003ooooo00;o0?ZJ00Coooooo`3jV_l0nY[oo`001_ooool00ol00?ooooooool00002oooo
o`04o`3jV_oooooo003oool000Cooooo00?o0?ZJooooooooool0@Oooool003cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00004ooooo`05o`000?ooooooooooooooool0nYX00_oo
ool02Ooo003oooooo`00oooooooo0?ZJoooooooo003oooooool00002ooooo`05ool00?ooooooo`00
o`3jV_oo00005Oooool00ooo003o0?ZJooooo`02ooooo`03o`3jV_oo003o0?ZJ00gooooo00?o0?ZJ
ooooooooool05_ooool01_l0nY[oo`00oooooooooooo0?ZJo`00o`;ooooo00?oo`00ooooooooool0
8Oooool2o`00o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool2o`3jVP?ooooo
00?o0?ZJooooooooool02?ooool2o`000007o`3jV_ooooooooooo`00ool0nY[oooooool0000Xoooo
o`07o`00oooooooo0?ZJo`3jV_l00?ooooooo`3jVP0Zooooo`03o`000?oooooo0?ZJ00;ooooo00?o
o`00ooooool00?l00oooool01?l0nY[oo`00oooooooo0002ooooo`06ool00?ooooooooooool00?oo
ooooo`002oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00;o003o00?oooooo`3jV_oo00001?ooool0
0ol00?oo0?ZJool0000:ooooo`05o`3jV_oo003o0?ZJoooooooo00002Oooool2o`3jVP;ooooo00Co
0?ZJool00?oo003o0?ZJ1?ooool2o`0000Kooooo00Co003oooooooooooooo`002?ooool01Ol0nY[o
ooooo`3jV_oooooo0?ZJ00;oo`0000?o0?ZJooooooooool00_ooool00ol0nY[oo`00ooooo`06oooo
o`04o`00ooooooooooooool000;o0?ZJ1?ooool01?l00?ooooooooooooooool2ool00003o`00oooo
oooooooo00Cooooo00?o003ooooooooo00001_ooool01?l0nY[o003ooooooooo0004ooooo`03o`00
oooo003o0?ZJ00[ooooo00?o0?ZJoooooooo00000_oo0003ooooo`05o`3jV_oo003oooooool00?l0
nYX02oooool01?l0nY[oo`00ool00?oo0007ooooo`04o`00ooooooooo`00o`0002Kooooo00?o0000
ooooooooool02?ooool01_oo003ooooooooooooo003oooooool000;ooooo00Coo`00ooooool0nY[o
o`001oooool01?l00?ooooooo`3jV_oo0003ooooo`04o`3jV_ooooooo`00o`3jVP?ooooo0_oo0000
0ol00?ooooooooooo`03ooooo`;o003o0_oo00000ol0nY[oooooo`00o`06ooooo`05o`3jV_oo003o
o`00ooooool0nYX00oooool00ol00?ooooooooooo`05ooooo`05o`3jV_ooooooo`00oooooooo0000
0_l0nYX01ooo003oooooooooooooooooo`00o`00ool0nYX01_ooool00ol00?ooooooooooo`03oooo
o`03o`00oooooooooooo00?ooooo00Go0?ZJool00?ooooooo`00o`3jVP02ooooo`07ool00?oooooo
ooooooooool0nY[oo`00o`3jVP03ooooo`Co000000?o003oooooool0nYX01?ooool01?l00?ooo`00
o`3jV_ooool2ool00003ooooool00?oooooo00;ooooo0_l0nYX00ooooooo003oooooo`02ooooo`;o
0?ZJ0oooool2ool00003o`3jV_oooooooooo00Cooooo00?o0?ZJool00?oo00001?ooool2o`00o`05
ooooool0nY[ooooooooooooo00001?ooool01_l0nY[oo`00o`3jV_oooooo0?ZJooooo`;o0?ZJ00?o
o`00ooooooooool00oooool2o`00o`09oooooooo003oooooooooool0nY[oooooo`00ooooooooo`00
00?ooooo00?o0?ZJooooooooool0@Oooool003_ooooo0_l00004ooooo`04o`000?ooooooooooo`00
00Cooooo00Go0000ooooooooooooooooo`3jVP02ooooo`09ool00?oooooo003oooooool0nY[ooooo
ool00?ooooooo`0000;ooooo00Goo`00oooooooo003o0?ZJool0000Eooooo`03ool00?l0nY[ooooo
00;ooooo00?o003oo`3jV_oo00003Oooool00ol0nY[oooooooooo`0Fooooo`09o`3jV_oo003ooooo
ooooool0nY[oooooo`00ooooooooo`0002?ooooo0_l00?l00ol0nY[o003oooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`07ooooo`Co0000
0_ooool01?l00?ooooooo`3jV_oo000Xooooo`03o`00oooooooo0?ZJ00;ooooo00?o003oo`3jV_oo
ool0:Oooool00ol0003oooooo`3jVP02ooooo`03ool00?oooooo003o00?ooooo00Co0?ZJool00?oo
ooooo`000_ooool01_oo003ooooooooooooo003oooooool000_ooooo00Koo`00o`3jV_l0nY[oo`00
o`3jV_l00?l2ooooo`03o`3jV_oo003ooooo00?ooooo00?o003oo`3jV_oo00002_ooool01Ol0nY[o
o`00o`3jV_ooooooo`0000Wooooo0_l0nYX2ooooo`04o`3jV_oo003oo`00o`3jVP?ooooo1?l00005
ooooo`04o`00ooooooooooooool000Sooooo00Go0?ZJooooool0nY[oooooo`3jVP02ool00003o`3j
V_oooooooooo00;ooooo00?o0?ZJool00?ooool01_ooool01Ol00?oooooooooooooo003ooooo00?o
0?ZJ0_ooool00ol00?ooooooooooo`02o`000003ool00?l00?oooooo00Gooooo00?o003ooooooooo
00001_ooool01?l0nY[o003ooooooooo0004ooooo`03o`00oooo003o0?ZJ00[ooooo00Go0?ZJoooo
oooo003oooooool00003ooooo`06o`3jV_oo003oooooool00?oooooo0?ZJ2_ooool01?l0nY[oo`00
o`000?l00007ooooo`04o`00ooooooooo`00o`0002Kooooo00?o0000ooooooooool02?ooool01_oo
003ooooooooooooo003oooooool000;ooooo00Coo`00ooooool0nY[oo`001oooool01?l00?oooooo
o`3jV_oo0003ooooo`04o`3jV_ooooooo`00o`3jVP?ooooo0_oo00000ol0nY[oooooooooo`03oooo
o`;o003o00Goo`00o`3jV_oo003oooooo`00o`06ooooo`04o`3jV_oo003oo`00ooooo`;o0?ZJ0_oo
ool00ol00?ooooooooooo`05ooooo`05o`3jV_oo003ooooooooooooo00000_l0nYX01ooo003ooooo
ooooooooooooo`00o`00ool0nYX01Oooool2o`00o`Gooooo00?o003oooooooooool00oooool01Ol0
nY[oo`00oooooooo003o0?ZJ00;ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00?ooooo
1?l00002o`00o`03ooooool0nY[ooooo00;ooooo00So003oool00?l0nY[o0?ZJoooooooo003ooooo
o`00o`Cooooo00?o0?ZJooooool00?l00oooool00ol0nY[oooooooooo`02ooooo`;oo`0000?o0?ZJ
ooooooooool01?ooool00ol0nY[oo`00ool00003ooooo`?o003o00?oooooo`3jV_ooool00_oo0004
ooooo`0:o`3jV_oo003o0?ZJooooool0nY[oooooo`3jV_ooooooo`00o`3jVPCooooo00Co003ooooo
ool0nY[oo`000_ooool2o`3jVP03o`00ooooooooo`0000?ooooo00?o0?ZJooooooooool0@Oooool0
03cooooo00?o0000ooooooooool00oooool2o`0000Gooooo00Go0000ooooooooooooooooo`3jVP02
ooooo`09ool00?l00?ooooooooooool0nY[oooooool00?ooooooo`0000;ooooo00Goo`00oooooooo
003o0?ZJool0000Eooooo`03ool00?l0nY[ooooo00;ooooo00?o003oo`3jV_oo00003?ooool2o`3j
VQSooooo00Co0?ZJool00?oooooo0?ZJ0_ooool00ol00?ooooooool0000Sooooo`04o`00ool0nY[o
003oo`00o`?ooooo00?o0?ZJooooooooool00_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oo
oooooooo00Oooooo1?l00002ooooo`05o`00oooooooo0?ZJool00?l0nYX09_ooool01?l00?oooooo
ooooool0nYX2ooooo`03o`00ool0nY[ooooo02Wooooo00?o0000ooooool0nYX00_ooool00ooo003o
ooooo`00o`03ooooo`04o`3jV_oo003oooooool000;ooooo00Koo`00ooooooooooooo`00oooooooo
000;ooooo`06ool00?l0nY[o0?ZJool00?l0nY[o003o0_ooool00ol0nY[oo`00ooooo`03ooooo`03
o`00ool0nY[oo`0000[ooooo00Go0?ZJool00?l0nY[oooooool00009ooooo`;o0?ZJ0_ooool01?oo
003oooooool00?l0nYX3ooooo`Co00001Oooool01?l00?oooooooooooooo0008ooooo`08o`3jV_oo
oooo0?ZJoooooooo003oooooool00?l0nYX4ooooo`03o`3jV_oo003ooooo00Kooooo00Co003ooooo
ooooooooo`000oooool3o`3jVP03o`00oooooooo000000?o00002?ooool00ol00?ooo`00ooooo`04
ooooo`;o0?ZJ00?o003ooooooooo00001?ooool00ol00?ooo`00o`3jVP0:ooooo`05o`3jV_oo003o
oooooooooooo00000oooool01_l0nY[oo`00oooooooo003oooooo`3jVP[ooooo00?oo`00o`000?l0
00000_l000000ooooooo0?ZJo`3jVP05o`3jVP03ool00?l0003ooooo02Gooooo00?o0000oooooooo
ool02?ooool01_oo003ooooooooooooo003oooooool000;ooooo00Coo`00ooooool0nY[oo`001ooo
ool01?l00?ooooooo`3jV_oo0003ooooo`04o`3jV_oo003oo`00o`3jVP?ooooo0_oo00000ol0nY[o
ooooooooo`03ooooo`07o`00ooooooooo`00o`3jV_oo003oooooo`00o`06ooooo`03o`3jV_oo003o
o`0000;ooooo00Co0?ZJoooooooooooo003o1oooool01Ol0nY[oo`00ooooooooooooo`0000;o0?ZJ
00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00Gooooo00?o003oooooooooool01?ooool00ol0
0?ooooooooooo`03ooooo`05o`3jV_oo003oooooool00?l0nYX00_ooool01ooo003ooooooooooooo
oooo0?ZJool00?l0nYX01?ooool2o`000004ool00?l00?oo003oooooo`;o0?ZJ0_ooool01_l00?oo
o`00ooooool0nY[oooooool000;ooooo00Oo003oooooooooooooooooo`3jV_oooooo003o00?ooooo
00?o0?ZJooooooooool00_ooool00ooo003o0?ZJool00006ooooo`03o`3jV_oo003oo`0000;ooooo
1?l00?l00ooooooo0?ZJo`00o`02ool000Cooooo00[o0?ZJool00?l0nY[oooooo`3jV_oooooo0?ZJ
oooooooo003o0?ZJ1?ooool01?l00?ooooooo`3jV_oo0003ooooo`05o`3jV_l00?oooooooooooooo
00000_ooool00ol0nY[oooooooooo`11ooooo`00BOooool01Ol0003ooooooooooooooooo0?ZJ00;o
oooo00Woo`00o`00ooooooooooooo`3jV_ooooooo`00oooooooo00000_ooool01Ooo003oooooool0
0?l0nY[oo`0001Gooooo00?oo`00o`3jV_ooool00_ooool00ol00?oo0?ZJool0000<ooooo`;o0?ZJ
5oooool01Ol0nY[o003oool00?oooooo0?ZJ00;ooooo00?o003ooooooooo00008_ooool01Ol00?oo
ooooo`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo00Sooooo0_l00004ooooo`04o`00ool0nY[oo`00o`3jVRKooooo00?o003o
ooooool0nYX00oooool00ol00?oo0?ZJooooo`0Yooooo`;o000000Go0?ZJooooooooooooo`00o`00
o`04ooooo`04o`3jV_oo003oooooool000;ooooo00Koo`00ooooooooooooo`00oooooooo000;oooo
o`05ool00?l0nY[oooooo`3jV_oo00000oooool00ol0nY[oo`00ooooo`03ooooo`03o`00ool0nY[o
o`0000[ooooo00Go0?ZJool00?l0nY[oooooool00008ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Co
o`00oooooooo003o0?ZJ0oooool00ol00?oo0000o`000006ooooo`04o`00ooooooooooooool000Oo
oooo00Wo0?ZJoooooooooooo0?ZJoooooooo003oooooool00?l0nYX01?ooool00ol0nY[oo`00oooo
o`06ooooo`04o`00ooooooooooooool000Kooooo0_l0nYX4o`0000Sooooo00?o003oool00?ooool0
1?ooool01Ol0nY[oooooo`00ooooooooo`0000Cooooo00?o003oool00?l0nYX02Oooool00ol0nY[o
ooooool00002ooooo`0:ool00?ooooooooooooooool0nY[oo`00oooooooo003oooooo`3jVP[ooooo
00?oo`00o`000?l000000_l000000ol0nY[oooooooooo`03ooooo`04o`00ooooooooo`00o`0002Ko
oooo0_l00009ooooo`06ool00?ooooooooooool00?ooooooo`000_ooool01?oo003oooooo`3jV_oo
0007ooooo`04o`00oooooooo0?ZJool000;ooooo00Go003oo`3jV_oo003oo`00o`3jVP03ooooo`;o
o`0000?o0?ZJooooooooool00oooool01ol00?ooooooool00?l0nY[oo`00ooooool00?l01_ooool0
1_l0nY[oo`00oooooooo003oooooo`3jVP?ooooo00?o003oooooooooool00oooool00ol00?oo0?ZJ
ool00002ooooo`04ool00?l0nY[o0?ZJool000?ooooo00?o0?ZJool00?l0nYX01Oooool00ol00?oo
ooooooooo`04ooooo`03o`00oooooooooooo00?ooooo00Go0?ZJool00?ooooooo`00o`3jVP02oooo
o`07ool00?ooooooooooooooool0nY[oo`00o`3jVP03ooooo`06o`00oooo003o0?ZJool00?oooooo
003o0_ooool01ol0nY[oooooo`00ool00?ooo`00ooooool0nYX00_ooool00ooo003oooooo`00o`03
ooooo`03o`3jV_oooooo003o00;ooooo00?o0?ZJooooooooool00oooool00ooo003o0?ZJool00006
ooooo`03o`3jV_oo003oo`0000;ooooo00?o003oooooooooool00_ooool01?l0nY[o003oool00?oo
0004ooooo`03o`3jV_oo003o0?ZJ00;ooooo0_l0nYX00oooooooo`00o`3jVP04ooooo`04o`00oooo
oooo0?ZJool000?ooooo00So0?ZJooooool00?ooooooool00?oooooo0000o`3jVT?ooooo0019oooo
o`;o00000_ooool01Ol0nY[ooooooooooooo003o003o00;ooooo00Go0?ZJoooooooo003oooooool0
0002ooooo`05ool00?ooooooo`00o`3jV_oo00005Oooool00ooo003oooooooooo`02ooooo`03o`00
ool0nY[oo`0000cooooo0_l0nYXGooooo`05o`3jV_l00?ooo`00ooooool0nYX00_ooool00ol00?oo
ooooool0000Rooooo`03o`00oooooooo0?ZJ00;ooooo00Go003oooooooooooooooooo`3jVP03oooo
o`03o`3jV_oooooooooo00?ooooo00?oo`00ooooooooool02?ooool00ooo003o0?ZJooooo`03oooo
o`04o`00ool0nY[oo`00o`3jVRKooooo00?o003oooooool0nYX00oooool00ol00?oo0?ZJooooo`0Y
ooooo`07o`000?l0nY[ooooooooooooo003oooooo`00o`04ooooo`04o`3jV_oo003oooooool000;o
oooo00Koo`00ooooooooooooo`00oooooooo000;ooooo`05ool00?l0nY[o003oo`3jV_oo00000ooo
ool00ol0nY[oo`00ooooo`03ooooo`03o`00ool0nY[oo`0000[ooooo00Go0?ZJool00?l0nY[ooooo
ool00008ooooo`0:o`3jV_oooooo0?ZJooooool0nY[oo`00oooooooo003oooooo`3jVP;ooooo00?o
003oool00?ooool01_ooool01?l00?oooooooooooooo0007ooooo`09o`3jV_ooooooooooo`3jV_oo
ooooo`00oooooooo003o0?ZJ00Cooooo00?o0?ZJool00?ooool01_ooool01?l00?oooooooooooooo
0007ooooo`;o0?ZJ0_l000000ol00?oo0?ZJo`3jVP05o`3jVP03ooooool00?ooo`0000Cooooo0_l0
nYX01?l00?oooooooooooooo0004ooooo`03o`00oooo003o0?ZJ00Wooooo00?o0?ZJoooooooo0000
0_ooool02_oo003ooooooooooooooooo0?ZJool00?ooooooo`00ooooool0nYX9ooooo`03o`3jV_oo
003o003o00;o00001oooool01?l00?ooooooool00?l0000Vooooo`03o`000?oooooooooo00Sooooo
00Koo`00ooooooooooooo`00oooooooo0002ooooo`04ool00?oooooo0?ZJool000Oooooo00Co003o
ooooool0nY[oo`000_ooool01Ol00?oo0?ZJool00?oo003o0?ZJ00?ooooo0_oo00000ol0nY[ooooo
ooooo`03ooooo`07o`00ooooooooo`00o`3jV_oo003oooooo`00o`06ooooo`05o`3jV_oo003o0?ZJ
ool00?ooool00_l0nYX2ooooo`03o`00oooooooooooo00?ooooo00?o003oo`3jV_oo00000_ooool0
1?oo003o0?ZJo`3jV_oo0003ooooo`03o`3jV_oo003o0?ZJ00Gooooo00?o003oooooooooool01?oo
ool00ol00?ooooooooooo`03ooooo`05o`3jV_oo003oooooool00?l0nYX00_ooool01ooo003ooooo
oooooooooooo0?ZJool00?l0nYX00oooool00ol00?ooo`00o`3jVP02ool00003o`00oooooooooooo
00;o0?ZJ0_l00?l00ooo003oooooo`3jVP02ooooo`03ool00?oooooo003o00?ooooo00?o0?ZJoooo
ool00?l00_ooool00ol0nY[oooooooooo`03ooooo`03ool00?l0nY[oo`0000Kooooo00?o0?ZJool0
0?oo00000_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_l00?ooo`00ool000Cooooo00?o0?ZJ
ool00?l0nYX00_ooool2o`3jVP03oooooooo003o0?ZJ00Cooooo00Co003oooooool0nY[oo`000ooo
ool01Ol0nY[oooooo`00ooooooooo`0000;ooooo00?o0?ZJooooooooool0@Oooool004Wooooo00Go
0000ooooooooooooooooo`3jVP02ooooo`09ool00?l00?ooooooooooool0nY[oooooool00?oooooo
o`0000;ooooo00Goo`00oooooooo003o0?ZJool0000>ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJool00?ooool00oooool00ol00?oo0?ZJool0000<ooooo`;o0?ZJ5oooool01Ol0nY[o003oool0
0?oooooo0?ZJ00;ooooo00?o003ooooooooo00008_ooool00ol00?oo0?ZJooooo`02ooooo`05o`00
ooooooooo`00ool00?l0nYX00_ooool2o`3jVPCooooo0_oo000:ooooo`03ool00?oooooooooo00?o
oooo00Co003oo`3jV_oo003o0?ZJ9_ooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo
02Wooooo00Oo0000o`3jV_ooooooooooool00?oooooo003o00Cooooo00Co0?ZJool00?ooooooo`00
0_ooool01_oo003ooooooooooooo003oooooool000_ooooo00Goo`00o`3jV_l00?oo0?ZJool00003
ooooo`03o`3jV_oo003ooooo00?ooooo00?o003oo`3jV_oo00002Oooool01_l0nY[oooooool00?l0
nY[oooooool000Sooooo00_o0?ZJooooool0nY[oooooo`3jV_oo003oooooool00?oooooo0?ZJoooo
o`02o`00o`03ool00?oooooooooo00Gooooo00Co003oooooooooooooo`001oooool02Ol0nY[ooooo
ooooool0nY[oooooool00?ooooooo`00o`3jVP04ooooo`03o`3jV_oo003ooooo00Gooooo00Go003o
ooooooooooooooooool00007ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1_ooool2o`3jVP03o`00oooo
003ooooo00?ooooo00?o0?ZJooooool00?l00_ooool00ooo003oooooooooo`02ooooo`03o`00oooo
003o0?ZJ00Wooooo00?o0?ZJoooooooo00000_ooool01Ooo003oooooooooooooooooo`0000?ooooo
00?oo`00o`3jV_ooool01oooool01Ol00?oo0?ZJool00?l00?oo0?ZJ00Sooooo00Co003ooooooooo
003o00009_ooool00ol0003oooooooooo`08ooooo`06ool00?oooooo0?ZJool00?ooooooo`000_oo
ool01?oo003oooooo`3jV_oo0007ooooo`04o`00oooooooo0?ZJool000;ooooo00Go003oo`3jV_oo
003oo`00o`3jVP03ooooo`;oo`0000?o0?ZJooooooooool00oooool01ol00?ooooooool00?l0nY[o
o`00o`3jV_l00?l01_ooool01?l0nY[oo`00o`3jV_oo0002ooooo`04o`3jV_ooooooooooo`00o`Go
oooo00?o003oo`3jV_oo00000_ooool01?oo003o0?ZJool00?l0nYX3ooooo`03o`3jV_oo003o0?ZJ
00Gooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`03ooooo`05ool00?oooooooooo
ool00?l0nYX00_ooool01ooo003ooooooooooooooooo0?ZJool00?l0nYX00oooool01_l00?ooo`00
o`3jV_ooooooo`00o`00o`?ooooo00Co0?ZJo`00ooooooooo`000_ooool01Ol0nY[oooooool00?oo
oooo003o00?ooooo00Go0?ZJooooool00?ooooooo`3jVP06ooooo`03ool00?l0nY[oo`0000Kooooo
00?o0?ZJo`000?l000000_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_ooooooo`00ool000?o
oooo00Co003oo`3jV_oo003o0?ZJ0_ooool2o`3jVP03oooooooo003o0?ZJ00Cooooo00Co003ooooo
ool0nY[oo`000oooool01_l0nY[oooooo`00ooooooooo`00ooooo`;o0000@oooool004Wooooo00Co
0000oooooooooooo0?ZJ0oooool02Ooo003o003ooooooooooooo0?ZJoooooooo003oooooool00002
ooooo`05ool00?ooooooo`00o`3jV_oo00003_ooool2o`3jVPCooooo0_l00004ooooo`03o`00ool0
nY[oo`0000cooooo0_l0nYXGooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?o003ooooooooo0000
8_ooool00ol00?oo0?ZJooooo`02ooooo`05o`00oooo003oo`00ool00?l0nYX00_ooool00ol0nY[o
ooooooooo`02ooooo`?oo`002_ooool00ooo003oooooooooo`03ooooo`04o`00ool0nY[oo`00o`3j
VRKooooo0_l0nYX4ooooo`03o`00ool0nY[ooooo02Wooooo00Go0000o`3jV_ooooooooooool00002
o`00o`Cooooo00Co0?ZJool00?ooooooo`000_ooool01_oo003ooooooooooooo003oooooool000_o
oooo00Goo`00o`3jV_l00?oo0?ZJool00003ooooo`03o`3jV_oo003ooooo00?ooooo00?o003oo`3j
V_oo00002Oooool01_l0nY[oooooool00?l0nY[oooooool000Sooooo00[o0?ZJooooool0nY[ooooo
o`3jV_oo003oooooool00?oooooo0?ZJ0_l00?l00oooooooo`00ooooo`06ooooo`04o`00oooooooo
ooooool000Kooooo00[o0?ZJooooooooooooooooool00?l0nY[oo`00oooooooo003o0?ZJ1?ooool0
0ol0nY[oo`00ooooo`05ooooo`05o`00oooooooooooooooooooo00002Oooool2o`3jVPWooooo00?o
0?ZJool00?ooool00_ooool2o`3jVP03ooooool00?oooooo00;oo`001?ooool00ol00?ooo`00o`3j
VP09ooooo`03o`3jV_ooooooo`0000;ooooo00Goo`00ooooooooooooooooool00003ooooo`03ool0
0?l0nY[ooooo00Oooooo00Go003oo`3jV_oo003o003oo`3jVP09ooooo`03o`00oooo003o000002Ko
oooo00?o0000ooooooooool02?ooool01_oo003oooooo`3jV_oo003oooooool000;ooooo00Coo`00
ooooool0nY[oo`002?ooool00ol00?oo0?ZJool00002ooooo`05o`00ool0nY[oo`00oooooooo0000
0oooool00ooo003o0?ZJool00005ooooo`08o`00ooooooooo`00o`3jV_oo003o0?ZJooooool00?l4
ooooo`05o`00ool0nY[oo`00o`3jV_oo00000_ooool01?l0nY[oooooooooool00?l5ooooo`03o`00
ool0nY[oo`0000;ooooo00Coo`00o`3jV_oo003o0?ZJ0oooool00ol0nY[oo`00o`3jVP04ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooooooool00oooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ
00;ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00?ooooo00Co003oool00?l0nY[o0?ZJ
0_oo0004ooooo`03o`3jV_ooooooo`0000;ooooo00Go0?ZJooooooooooooo`00o`00o`03ooooo`05
o`3jV_l00?ooooooooooool0nYX01_ooool00ooo003o0?ZJool00005ooooo`03o`00ool0003o0000
00;o00000_l00?l4ooooo`04o`3jV_ooooooo`00ool000?ooooo00Co003oo`3jV_oo003o0?ZJ0_oo
ool2o`3jVP03oooooooo003o0?ZJ00Cooooo00Co003oooooool0nY[oo`001?ooool01?l0nY[o003o
ooooooooool3o`0004?ooooo0019ooooo`04o`000?ooooooooooo`3jVP?ooooo00Woo`00o`00oooo
ooooooooo`3jV_ooooooo`00o`3jV_oo00000_ooool01Ooo003oooooool00?l0nY[oo`0000kooooo
0_l0nYX3ooooo`Co00000oooool00ol00?oo0?ZJool0000<ooooo`;o0?ZJ5oooool01?l0nY[oo`00
ooooool0nYX3ooooo`03o`00ooooooooo`0002;ooooo0_l0nYX3ooooo`;oo`0000Coooooool00?l0
nY[ooooo0_l0nYX4ooooo`05ool00?oooooo0000o`000?l0nYX02?ooool00ooo003oooooooooo`03
ooooo`04o`00ool0nY[oo`00o`3jVRGooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJoooo
o`0Yooooo`03o`000?l0nY[ooooo00;oo`0000?o003oooooooooool00oooool01?l0nY[oo`00oooo
oooo0002ooooo`06ool00?ooooooooooool00?ooooooo`002oooool01Ooo003o0?ZJo`00ool0nY[o
o`0000?ooooo00?oo`00o`3jV_ooool00oooool00ol00?oo0?ZJool00009ooooo`06o`3jV_oo003o
ooooo`3jV_ooooooo`002?ooool01_l0nY[oooooo`3jV_oooooo0?ZJool000;ooooo00?oo`00o`3j
V_l00?l00_ooool00ooo003oooooooooo`05ooooo`04o`00ooooooooooooool000Kooooo00?o0?ZJ
ooooooooool00_oo00001Ol0nY[oo`00o`3jV_oo003o0?ZJ00Cooooo0_oo0006ooooo`05o`00oooo
oooooooooooooooo00002Oooool2o`3jVPWooooo00Co003oool00?oooooooooo0_l0nYX3o`00o`03
oooooooo003o0?ZJ00Cooooo00?o003oool00?l0nYX02Oooool00ol0nY[oo`00ooooo`02ooooo`05
ool00?ooooooooooo`3jV_oo00000oooool00ooo003o0?ZJooooo`07ooooo`05o`00ool0nY[oo`00
o`00ool0nYX02Oooool00ol00?ooo`00o`00000Vooooo`;o00002Oooool01_oo003oooooo`3jV_oo
003oooooool000;ooooo00Coo`00ooooool0nY[oo`002?ooool00ol00?oo0?ZJool00002ooooo`05
o`00ool0nY[oo`00oooooooo00000oooool00ooo003o0?ZJool00005ooooo`08o`00ooooooooo`00
o`3jV_oo003o0?ZJooooool00?l4ooooo`06o`00ool0nY[oo`00o`3jV_ooooooo`000_ooool00ol0
nY[oooooo`00o`05ooooo`03o`00ool0nY[oo`0000;ooooo00Coo`00o`3jV_oo003o0?ZJ0oooool0
1?l0nY[oo`00ooooool0nYX3ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool00ooo
ool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00;ooooo00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ
00?ooooo00Ko003oool00?oooooo0?ZJoooooooo0004ooooo`03o`3jV_ooooooo`0000;ooooo00Go
0?ZJooooooooooooo`00o`00o`03ooooo`05o`3jV_l00?ooooooooooool0nYX01_ooool00ooo003o
0?ZJool00005ooooo`03o`00ool0003o000000;o000000?o003oooooooooool00_ooool00ol0nY[o
ooooooooo`02ool000?ooooo00Co003oo`3jV_oo003o0?ZJ0_ooool2o`3jVP03oooooooo003o0?ZJ
00?ooooo00Go003ooooooooooooo0?ZJool00004ooooo`04o`3jV_l00?ooooooooooo`?o0000@ooo
ool004Wooooo00Co0000oooooooooooo0?ZJ0oooool02Ooo003o003ooooooooooooo0?ZJoooooooo
003o0?ZJool00002ooooo`05ool00?ooooooo`00o`3jV_oo00003_ooool2o`3jVP?ooooo1?l00003
ooooo`03o`00ool0nY[oo`0000cooooo0_l0nYXFooooo`05o`3jV_ooooooo`00ooooool0nYX00ooo
ool00ol00?ooooooool0000Rooooo`04o`3jV_ooooooooooooooo`;oo`0000Oo003ooooooooo003o
0?ZJooooool0nY[o003o00?ooooo00?oo`00ooooool000000ol000000ol0nY[oooooooooo`05oooo
o`03ool00?oooooooooo00?ooooo00Co003oo`3jV_oo003o0?ZJ9Oooool2o`3jVPGooooo00?o003o
o`3jV_ooool0:Oooool01?l0nY[oooooo`00oooo0002o`00o`Gooooo00Co0?ZJool00?ooooooo`00
0_ooool01_oo003ooooooooooooo003oooooool000_ooooo00Goo`00oooooooooooo0?ZJool00003
ooooo`03ool00?l0nY[ooooo00?ooooo00?o003oo`3jV_oo00002Oooool00ol0nY[oo`00o`3jVP02
ooooo`03ool00?oooooooooo00Gooooo00_o0?ZJoooooooooooo0?ZJooooool0nY[oo`00o`00oooo
ooooo`00o`3jVP03ooooo`03ool00?oooooooooo00Gooooo00Co003oooooooooooooo`001_ooool0
0ol0nY[oooooooooo`02ool00005o`3jV_oo003o0?ZJool00?l0nYX01?ooool2ool000Kooooo00Go
003oooooooooooooooooool0000Dooooo`03o`00oooo003o0?ZJ00;o0?ZJ00Coooooo`00ool00?oo
003o0_oo00000ol0nY[oooooooooo`02ooooo`03o`00oooo003o0?ZJ00Wooooo00?o0?ZJool00?oo
ool00_ooool01Ooo003oooooooooool0nY[oo`0000?ooooo00?oo`00o`3jV_ooool01_ooool01Ol0
0?ooooooo`3jV_oo003o0?ZJ00[ooooo00?o003oool00?l000009_ooool00ol0003oooooooooo`08
ooooo`06ool00?oooooo0?ZJool00?ooooooo`000_ooool01?oo003o003oo`3jV_oo0008ooooo`03
o`00ooooooooo`0000;ooooo00Go003oo`3jV_oo003oooooool00003ooooo`03ool00?l0nY[oo`00
00Cooooo00Wo003oooooooooooooo`00o`3jV_oo003o0?ZJooooool00?l01?ooool01_l00?oo0?ZJ
ool00?l0nY[oooooool000;ooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03o`00ool0nY[oo`00
00;o0?ZJ00Coo`00oooooooo003o0?ZJ0oooool01?l0nY[oo`00ooooool0nYX3ooooo`03o`00oooo
oooooooo00Kooooo00?o003oooooooooool00_ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00;ooooo
00Ooo`00ooooooooooooooooo`3jV_oo003o0?ZJ00?ooooo00Ko003oool00?oooooo0?ZJoooooooo
0004ooooo`03o`00ool0nY[oo`0000;ooooo00?o0?ZJooooooooool00_oo0003ooooo`04o`3jV_l0
0?ooooooo`3jVPOooooo00?oo`00oooooooo00001Oooool01_l00?ooo`00o`000?l0003o0?ZJo`00
o`Cooooo00?o0?ZJooooooooool00_oo0003ooooo`04o`00ool0nY[oo`00o`3jVP;ooooo0_l0nYX0
0oooooooo`00o`3jVP03ooooo`05o`00ooooooooooooo`3jV_oo00001?ooool01Ol0nY[o003ooooo
ooooooooo`0000;o0000@oooool004Wooooo0_l000001ooooooo0?ZJooooooooooooo`00ooooool0
0?l00_ooool01Ol0nY[oooooool00?l0nY[oo`0000;ooooo00Goo`00oooooooo003o0?ZJool0000>
ooooo`;o0?ZJ0oooool00ol00?oo0000o`000004ooooo`03o`00ool0nY[oo`0000cooooo00?o0?ZJ
ool00?ooool05Oooool01Ol0nY[oooooool00?oooooo0?ZJ00?ooooo00?o003ooooooooo00008Ooo
ool01?l00?oo0?ZJooooooooool2ool00008ooooool00?ooooooool00?l0nY[oooooo`3jV_l00?l2
ooooo`;oo`0000?oooooo`000?l000000_l000000ol0nY[oooooooooo`05ooooo`03ool00?oooooo
oooo00?ooooo00Co003oo`3jV_oo003o0?ZJ9Oooool00ol0nY[oooooooooo`04ooooo`03o`000?oo
003ooooo02;ooooo0_l00005ooooo`04o`3jV_l00?ooo`00ool000;o003o1Oooool01?l0nY[oo`00
oooooooo0002ooooo`06ool00?ooooooooooool00?ooooooo`002oooool01Ooo003oooooooooool0
nY[oo`0000?ooooo00?oo`00o`3jV_ooool00oooool00ol00?oo0?ZJool00009ooooo`03o`3jV_oo
003o0?ZJ00;ooooo00?oo`00ooooooooool01Oooool02ol0nY[oooooooooool0nY[oooooo`3jV_oo
003o0?ZJo`00oooo003o0?ZJ00?ooooo00?oo`00ooooooooool01Oooool01?l00?oooooooooooooo
0006ooooo`03o`3jV_oooooooooo00;oo`0000Go0?ZJool00?l00?oo0?ZJool00004ooooo`;oo`00
1_ooool01Ol00?ooooooooooooooooooo`0001Cooooo0_l00002ooooo`08o`00oooooooo003ooooo
ool00?ooo`00ooooool0nYX4ooooo`03o`00oooo003o0?ZJ00Wooooo00?o0?ZJool00?ooool00_oo
ool01Ooo003o0?ZJooooool0nY[oo`0000?ooooo00?oo`00o`3jV_ooool01_ooool01Ol00?oooooo
o`3jV_oo003o0?ZJ00[ooooo00?o003oool00?l000006Oooool3o`0000Cooooo0_l00004ooooo`03
o`000?oooooooooo00Sooooo00Koo`00ooooool0nY[oo`00oooooooo0002ooooo`04ool00?l00?oo
0?ZJool000Sooooo00[o003ooooooooo003oooooo`00oooooooo0?ZJool00?ooooooo`000oooool0
0ooo003o0?ZJool00004ooooo`09o`00ooooooooooooool00?l0nY[oo`00o`3jV_oooooo003o00Co
oooo00Ko003oo`3jV_oo003oooooo`3jV_oo0003ooooo`03o`3jV_l00?oooooo00Cooooo00?o003o
o`3jV_oo00000_l0nYX01?oo003oooooool00?l0nYX3ooooo`04o`3jV_oo003oooooo`3jVP?ooooo
00?o003oooooooooool01_ooool02_l00?oooooooooooooooooo003oool00?l0nY[oooooool00?l0
nYX2ooooo`07ool00?ooooooooooooooool0nY[oo`00o`3jVP03ooooo`07o`00oooo003oooooo`3j
V_ooooooo`00o`00o`03ooooo`03o`00ool0nY[oo`0000?ooooo00Co0?ZJooooooooooooo`000ooo
ool01?l0nY[o003oooooool0nYX3ooooo`Goo`0000?oooooool00?ooool00oooool01ol00?oooooo
ool00?l0nY[oo`00o`3jV_l00?l01?ooool00ol0nY[oooooooooo`02ool000;ooooo00Go003ooooo
ool0nY[oo`00o`3jVP02ooooo`;o0?ZJ00?oooooo`3jV_oo00000oooool01Ol00?ooooooooooool0
nY[oo`0000Gooooo00Co0?ZJoooooooooooooooo0_oo0013ooooo`00BOooool01?l0003ooooooooo
ool0nYX2ooooo`03ool00?oooooo003o00;ooooo00Go0?ZJoooooooo003o0?ZJool00002ooooo`05
ool00?ooooooo`00o`3jV_oo00003Oooool00ol0nY[oooooo`3jVP03ooooo`03o`00oooo003ooooo
00Cooooo00?o003oo`3jV_oo00003?ooool00ol0nY[oo`00ooooo`0Eooooo`05o`3jV_oo003ooooo
ooooool0nYX00oooool00ol00?ooooooool0000Qooooo`05o`3jV_oooooooooooooooooo00000_oo
ool00ol00?ooooooool00002o`3jVP03ooooool00?oooooo00;oo`000oooool2o`0000;ooooo00?o
0?ZJooooooooool01?ooool00ooo003oooooooooo`03ooooo`04o`00ool0nY[oo`00o`3jVRCooooo
00?o0?ZJo`00ooooool01Oooool2ool002;ooooo00Co0000oooooooooooo00001?ooool01?l0003o
003oool00?l00?l7ooooo`04o`3jV_oo003oooooool000;ooooo00Koo`00ooooooooooooo`00oooo
oooo000;ooooo`05ool00?ooooooooooo`3jV_oo00000oooool00ooo003o0?ZJooooo`03ooooo`03
o`00ool0nY[oo`0000Wooooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`05ooooo`06
o`3jV_ooooooooooo`3jV_ooooooo`000ol0nYX00ooo003o0?ZJooooo`02ooooo`03ool00?oooooo
oooo00Gooooo00Co003oooooooooooooo`001Oooool02ol0nY[ooooooooooooo003oooooool00?l0
nY[oo`00o`00ool0nY[oo`0000Cooooo0_oo0006ooooo`05o`00oooooooooooooooooooo00004ooo
ool4o`000006ooooool00?oo003oo`00ooooooooo`000_ooool00ol0nY[oooooooooo`02ooooo`03
o`00oooo003o0?ZJ00Sooooo00?o0?ZJoooooooo00000oooool01Ooo003o0?ZJooooool0nY[oo`00
00;o0?ZJ00?oooooool00?l0nYX01oooool01Ol00?ooooooo`3jV_oo003o0?ZJ00[ooooo00?o003o
ool00?l000006?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0oooool00ol0003oooooooooo`08ooooo`06ool00?oooooo0?ZJool00?ooooooo`000_ooool01?oo
003o003oo`3jV_oo0008ooooo`0:o`00ooooooooo`00ooooool00?ooooooo`3jV_oo003oooooool0
00?ooooo00?oo`00o`3jV_oo00001?ooool02Ol00?oooooooooooooo003o0?ZJool00?l0nY[ooooo
o`00o`04ooooo`06o`00ool0nY[oo`00ooooool0nY[oo`000oooool2o`3jVP;ooooo00Ko0?ZJoooo
oooooooo003oo`3jV_oo0002o`3jVP04oooooooo003oo`00o`3jVP?ooooo00Co0?ZJool00?oooooo
0?ZJ0oooool2o`3jVPOooooo00[o003oooooooooooooooooo`00oooo003o0?ZJoooooooo003o0?ZJ
0_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooo0?ZJ00;ooooo00Co003oool00?oooooo
0?ZJ0_ooool01ooo003ooooooooooooooooo003ooooooooo00000oooool01?l0nY[ooooooooooooo
0003ooooo`04o`3jV_l00?ooooooo`3jVP;ooooo0_oo0002ooooo`;oo`0000?oooooool00?ooool0
0oooool00ol00?ooooooool00002o`3jVP03ool00?oooooooooo00?ooooo00Go0?ZJoooooooo003o
003oool00002ooooo`04o`00ool0nY[oooooool000?ooooo0_l0nYX00ooooooo0?ZJool00003oooo
o`05o`00ooooooooooooo`3jV_oo00001Oooool01_l0nY[oooooooooooooooooo`00o`3jVT?ooooo
0019ooooo`04o`000?ooooooooooo`3jVP;ooooo00?oo`00ooooool00?l00_ooool01Ol0nY[ooooo
ool00?l0nY[oo`0000;ooooo00Goo`00oooooooo003o0?ZJool0000=ooooo`03o`3jV_oooooo0?ZJ
00?ooooo00?o003oool00?ooool01?ooool00ol00?oo0?ZJool0000<ooooo`03o`3jV_oo003ooooo
01Gooooo00Co0?ZJool00?oooooo0?ZJ1?ooool00ol00?ooooooool0000Qooooo`04o`3jV_oooooo
ooooool000?ooooo00Wo003oooooooooooooo`00o`3jV_oooooo003ooooooooo00001?ooool01?l0
nY[oo`00ooooooooool2o`3jVPCooooo00?o003oool00?ooool01?ooool01?l00?ooooooool00?l0
nYXTooooo`03o`3jV_oooooooooo00Cooooo00?oo`00o`000?l000008_ooool01?l0003ooooooooo
ool00004ooooo`;o00002Oooool01?l0nY[oo`00oooooooo0002ooooo`06ool00?ooooooooooool0
0?l00?ooo`002_ooool01_l00?ooo`00oooooooooooo0?ZJool000?ooooo00?oo`00o`3jV_ooool0
0oooool00ol00?oo0?ZJool00009ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool0
1?ooool03?l0nY[ooooooooooooooooo0?ZJoooooooo003o0?ZJo`00ool0nY[oo`00o`3jVP?ooooo
00?oo`00ooooooooool01Oooool01?l00?oooooooooooooo0005ooooo`05o`3jV_ooooooooooool0
0?ooool00_oo00001?l0nY[o003oo`3jV_oo0004ooooo`;oo`001_ooool01Ol00?oooooooooooooo
ooooo`0001?ooooo1?l000000ol00?ooooooo`00o`02ooooo`04ool00?ooooooooooo`3jVPCooooo
00?o003oo`3jV_oo00002?ooool00ol0nY[oooooool00003ooooo`05ool00?l0nY[oooooo`3jV_oo
00000_l0nYX00oooooooo`00o`3jVP07ooooo`05o`00oooooooo0?ZJool00?l0nYX02_ooool00ol0
0?oo0000o`00000Looooo`04o`000?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`00
000:ooooo`06ool00?oooooo0?ZJool00?ooooooo`000_ooool01?oo003o003oo`3jV_oo0008oooo
o`07o`00ooooooooo`00ooooool00?ooooooool00002ooooo`07ool00?oooooooooooooooooo003o
0?ZJool00004ooooo`04o`00ooooooooooooool000;o0?ZJ00?oo`00ooooool00?l00oooool02?l0
0?oo0?ZJoooooooo003oooooo`3jV_ooooooo`000oooool4o`3jVP;ooooo00?o0?ZJool00?ooool0
0_l0nYX01?ooooooo`00ool00?l0nYX3ooooo`04o`3jV_oo003oooooo`3jVP;ooooo0_l00002o`3j
VPKooooo00[o003oooooooooooooooooo`00oooo003o0?ZJoooooooo003o0?ZJ0_ooool00ooo003o
ooooooooo`02ooooo`03ool00?oooooo0?ZJ00;ooooo00Oo003oool00?ooooooooooo`3jV_oooooo
o`0000;ooooo00Co003oooooooooooooo`000oooool01?l0nY[ooooooooooooo0003ooooo`03o`3j
V_l00?oo0?ZJ00?ooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooool00004ooooo`03o`00
ooooooooo`0000;o0?ZJ00?oo`00ooooooooool00oooool01Ol0nY[oooooool00?ooooooo`0000;o
oooo00Co003oo`3jV_oo003o0?ZJ0oooool2o`3jVP03ooooool0nY[oo`0000?ooooo00Go003ooooo
oooooooo0?ZJool00005ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ@oooool004Wooooo00Co
0000oooooooooooo0?ZJ0_ooool00ooo003o003oooooo`02ooooo`05o`3jV_ooooooo`00o`3jV_oo
00000_ooool01Ooo003oooooool00?l0nY[oo`0000gooooo00Co0?ZJoooooooooooo0?ZJ0_ooool0
0ol00?ooo`00ooooo`04ooooo`03o`00ool0nY[oo`0000_ooooo00?o0?ZJoooooooo00005Oooool0
1Ol0nY[o003oool00?oooooo0?ZJ00Cooooo00?o003ooooooooo00008Oooool01?l0nY[oooooool0
0?oo0003ooooo`;o003o00Goooooool00?oooooo003oooooo`02ool000Cooooo0_l0nYX00ooo003o
ooooooooo`02o`3jVP?ooooo00?o0?ZJool00?ooool01?ooool01?l00?ooooooool00?l0nYXSoooo
o`03o`3jV_l00?oooooo00Cooooo00Coo`00o`000?l0003o00008_ooool01?l0003oooooooooool0
0004ooooo`;o00002Oooool01?l0nY[oo`00oooooooo0002ooooo`06ool00?ooooooooooool00?l0
0?ooo`002_ooool01_l00?ooo`00oooooooooooo0?ZJool000?ooooo00?oo`00o`3jV_ooool00ooo
ool00ol00?oo0?ZJool00009ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool01?oo
ool03?l0nY[ooooooooooooooooo0?ZJoooooooo003o0?ZJo`00ool0nY[oo`00o`3jVP?ooooo00?o
o`00ooooooooool01Oooool01?l00?oooooooooooooo0004ooooo`;o0?ZJ0_ooool02?oo003ooooo
ool00?oo003o0?ZJooooool0nY[oo`001?ooool2ool000Kooooo00Go003oooooooooooooooooool0
000Dooooo`;o000000?oo`00o`00ooooool00_ooool01Ooo003ooooooooooooooooo0?ZJ00Cooooo
00?o003oo`3jV_oo00002?ooool00ol0nY[oooooool00003ooooo`05ool00?l0nY[oooooo`3jV_oo
00000_l0nYX00oooooooo`00o`3jVP07ooooo`05o`00oooooooo0?ZJool00?l0nYX02_ooool3o`00
01[ooooo0_l00003ooooo`04o`000?ooooooooooo`0000?ooooo0ol00008ooooo`06ool00?oooooo
0?ZJool00?ooooooo`000_ooool01?oo003o003oo`3jV_oo0008ooooo`07o`00ooooooooo`00oooo
ool00?ooooooool00002ooooo`07ool00?oooooooooooooooooo003oooooool00004ooooo`04o`00
ooooooooooooool000;o0?ZJ00Coo`00o`3jV_oooooo003o0_ooool02?l00?oo0?ZJoooooooo003o
ooooo`3jV_ooooooo`000oooool03?l00?ooooooooooool0nY[oooooo`00ool0nY[oo`00o`3jV_oo
oooo0?ZJooooo`;oo`0000Wo0?ZJooooooooooooooooo`3jV_oo003oooooo`3jV_ooool01?l00000
0ol0nY[oooooooooo`04ooooo`0:o`00ooooooooooooooooool00?ooo`00o`3jV_oooooo0?ZJool0
00;ooooo00?oo`00ooooooooool00_ooool00ooo003oooooo`3jVP02ooooo`0:o`00oooo003ooooo
ooooool0nY[oooooool00?l00?ooooooo`00o`;ooooo00?oo`00ooooooooool00_ooool01?l0nY[o
ooooo`00oooo0002ooooo`03o`3jV_l00?oo0?ZJ00;ooooo00?oo`00ooooooooool00oooool00ol0
nY[oooooool00004ooooo`03o`00ooooooooo`0000;o0?ZJ00?oo`00o`3jV_ooool00_ooool01?l0
nY[ooooooooooooo0002o`0000;ooooo00Co003oo`3jV_oo003o0?ZJ1?ooool01Ol0nY[oooooo`3j
V_oo003o0?ZJ00;ooooo00Go003ooooooooooooo0?ZJool00005ooooo`06o`3jV_ooooooooooo`00
0?oo003o0?ZJ@oooool004Wooooo00Co0000oooooooooooo0?ZJ0_ooool00ooo003o003oooooo`02
ooooo`05o`3jV_ooooooo`00o`3jV_oo00000_ooool01Ooo003oooooool00?l0nY[oo`0000gooooo
00Co0?ZJoooooooooooo0?ZJ0_ooool00ol00?ooo`00ooooo`04ooooo`04o`00ool0nY[oo`00o`3j
VP[ooooo00?o0?ZJoooooooo00005Oooool01Ol0nY[oo`00ool00?oooooo0?ZJ00Cooooo00?o003o
oooooooo00008Oooool00ol0nY[oooooool00005ooooo`03o`00ooooooooo`0000;o003o0_oo0005
ooooo`;o0?ZJ00Coo`00oooooooooooooooo1Ol0nYX00ooo003oooooooooo`03ooooo`04o`00oooo
oooo0?ZJool002?ooooo00?o0?ZJo`00ooooool00oooool2ool000?o00008_ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo00Sooooo00Co0?ZJool00?ooooooo`000_ooool01_oo
003ooooooooooooo003o003oool000[ooooo00Oo0?ZJool00?ooooooooooo`3jV_oo003o0?ZJ00;o
oooo00?oo`00o`3jV_ooool00oooool00ol00?ooooooool00009ooooo`03o`3jV_oo003o0?ZJ00;o
oooo00?oo`00ooooooooool01?ooool03?l0nY[oooooooooooooooooo`00oooooooo003o0?ZJoooo
ool0nY[oo`00o`3jVP?ooooo00?oo`00ooooooooool01Oooool01?l00?oooooooooooooo0004oooo
o`04o`3jV_ooooooooooool000;ooooo0_oo00001?l0nY[oooooo`3jV_oo0004ooooo`;oo`001_oo
ool01Ol00?ooooooooooooooooooo`0001Gooooo00?o0?ZJool00?oo00000_ooool2ool000?ooooo
00?o0?ZJooooooooool00_ooool00ol00?oo0?ZJool00008ooooo`03o`3jV_oo003ooooo00?ooooo
00[oo`00o`3jV_oooooo0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ1oooool01Ol00?ooooooo`3j
V_oo003o0?ZJ00[ooooo0ol0000Looooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooo
ooooooooo`00000:ooooo`06ool00?oooooo0?ZJool00?ooooooo`000_ooool01?oo003o003oo`3j
V_oo0008ooooo`07o`00ooooooooo`00ooooool00?ooooooool00002ooooo`07ool00?l0nY[ooooo
oooooooo003oooooool00004ooooo`04o`00ooooooooooooool000;o0?ZJ00Coo`00o`3jV_oooooo
003o0_ooool02?l00?oo0?ZJoooooooo003oooooo`3jV_ooooooo`001?ooool02?l00?ooooooo`3j
V_oooooo003oo`3jV_oo003o0?ZJ0_ooool01?l0nY[oo`00ool00?l0nYX3ooooo`05o`3jV_oo003o
ooooo`3jV_ooool01?l00002o`3jVPGooooo00[o003oooooooooooooooooo`00oooo003o0?ZJoooo
ool0nY[oo`000_ooool00ooo003oooooooooo`02ooooo`03o`3jV_oo003o0?ZJ00;ooooo00So003o
ool00?ooooooooooo`3jV_oooooo003oool000;o003o0_ooool00ooo003oooooooooo`02ooooo`04
o`3jV_oooooo003oool000;ooooo0_l0nYX2ooooo`;oo`001Oooool00ol0nY[oooooool00004oooo
o`03o`00ooooooooo`0000;o0?ZJ00?oo`00o`3jV_ooool00_ooool00ol0nY[oooooooooo`04o`00
0005o`00oooooooo0?ZJool00?l0nYX01?ooool01Ol0nY[oooooo`3jV_oo003o0?ZJ00;ooooo00Go
003ooooooooooooo0?ZJool00005ooooo`06o`3jV_ooooooooooooooool00?oo0?ZJ@oooool004Wo
oooo00Co0000oooooooooooo0?ZJ0_ooool00ooo003o003oooooo`02ooooo`05o`3jV_ooooooo`00
o`3jV_oo00000_ooool01Ooo003oooooool00?l0nY[oo`0000gooooo00Co0?ZJool00?oooooo0?ZJ
0_ooool00ol00?ooo`00ooooo`04ooooo`04o`00ool0nY[oo`00o`3jVP[ooooo00?o0?ZJoooooooo
00005?ooool2o`000004ool00?ooooooooooo`3jVPCooooo00?o003ooooooooo00008?ooool01?l0
nY[oooooool00?oo0005ooooo`04o`00ooooooooo`00o`00o`;oo`001_ooool2o`3jVP;oo`001Ooo
ool00ol00?ooooooool00005ooooo`04o`00oooooooo0?ZJool002;ooooo00?o0?ZJooooool00?l0
0oooool2ool000;ooooo0_l0000Rooooo`04o`000?ooooooooooo`0000Cooooo00?o0?ZJoooooooo
ool02?ooool01?l0nY[oo`00oooooooo0002ooooo`06ool00?oooooo003oool00?l00?ooo`002_oo
ool01ol0nY[oo`00oooooooooooo0?ZJool00?l0nYX00_ooool00ooo003o0?ZJooooo`03ooooo`03
o`00ooooooooo`0000Wooooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`03ooooo`03
o`3jV_oooooooooo00;ooooo00Soo`00o`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP?ooooo00?o
o`00ooooooooool01_ooool00ol00?ooooooool00004ooooo`04o`3jV_ooooooooooool000;ooooo
0_oo00001?l0nY[oooooo`3jV_oo0004ooooo`;oo`001_ooool01Ol00?ooooooooooooooooooo`00
01Gooooo00?o0?ZJo`00oooo00000ooo0004ooooo`03o`3jV_oooooooooo00;ooooo00?o003oo`3j
V_oo00002?ooool00ol0nY[oo`00ooooo`03ooooo`05ool00?l0nY[oooooo`3jV_oo00000_ooool0
0ol0nY[oo`00o`3jVP07ooooo`05o`00oooooooo0?ZJool00?l0nYX02oooool2o`0001Sooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooooooo
ool02?ooool01_oo003oooooo`3jV_oo003oooooool000;ooooo00Coo`00o`00ool0nY[oo`002?oo
ool02ol00?ooooooool00?oooooo003ooooooooo003oooooo`3jV_oo003o0?ZJ00;ooooo00?oo`00
oooooooo00001?ooool01?l00?oooooooooooooo0002o`3jVP03ool00?l0nY[ooooo00;o003o00Wo
ooooo`00ool0nY[oooooool00?oooooo0?ZJoooooooo00001?ooool02?l00?ooooooo`3jV_oooooo
003oo`3jV_oo003o0?ZJ0_ooool00ol0nY[oo`00ool00004ooooo`04o`3jV_l00?ooo`00o`3jVP;o
oooo0_l00002ooooo`03o`3jV_oooooooooo00?ooooo00[o003oooooooooooooooooo`3jV_oo003o
0?ZJooooool0nY[oo`000_ooool00ooo003oooooooooo`02ooooo`03o`3jV_oo003o0?ZJ00;ooooo
00Go003oool00?ooooooooooo`3jVP02ooooo`03ool00?l00?oo003o00;ooooo00?oo`00oooooooo
ool00_ooool01?l0nY[oooooo`00oooo0002ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`04oooo
o`03o`3jV_ooooooo`0000Cooooo00Oo003ooooooooo003o0?ZJoooooooo003o0?ZJ00?ooooo00?o
0?ZJooooooooool01?l000001Ol00?ooooooo`3jV_oo003o0?ZJ00Kooooo00?o0?ZJool00?l0nYX0
0_ooool01Ol00?ooooooooooool0nY[oo`0000Gooooo00Ko0?ZJooooooooooooooooo`00ool0nYY3
ooooo`00BOooool2o`000006o`3jV_oooooooooooooooooo003o003o0oooool01Ol0nY[oooooool0
0?ooooooo`0000;ooooo00Goo`00oooooooo003o0?ZJool0000=ooooo`04o`3jV_oo003oo`00o`3j
VP;ooooo00?o003oool00?ooool01Oooool00ol0nY[oo`00o`3jVP0:ooooo`03o`3jV_ooooooo`00
01?ooooo1?l000000ooooooo0?ZJooooo`04ooooo`03o`00ooooooooo`00023ooooo00?o0?ZJool0
0?oo00001_ooool00ol00?oo0000o`000002ool000Oooooo0_l0nYX00ol00?ooo`00ooooo`04oooo
o`03o`00ooooooooo`0000Gooooo00Go003oooooool0nY[oo`00o`3jVP0Pooooo`;o00000_l00?l0
1?ooooooo`00ool00?oo0003ooooo`03o`000?l0nY[ooooo02;ooooo0_l00005ooooo`03o`000?l0
nY[ooooo00Sooooo00Co0?ZJool00?ooooooo`000_ooool01?oo003oooooo`00oooo0002o`000003
o`3jV_oooooooooo00Oooooo00?o0?ZJool00?ooool00_ooool01_oo003o0?ZJooooooooooooo`00
o`3jVPCooooo00?o003ooooooooo00002Oooool00ol0nY[oo`00o`3jVP02ooooo`03ool00?oooooo
oooo00?ooooo00?o0?ZJooooooooool00_ooool02?oo003o0?ZJool00?l0nY[oooooo`3jV_oo003o
0?ZJ0oooool00ooo003oooooooooo`06ooooo`03o`00ooooooooo`0000?ooooo0_l0nYX00ooooooo
o`00ool00002ooooo`;oo`0000Co0?ZJooooool0nY[oo`001?ooool2ool000Kooooo00Go003ooooo
ooooooooooooool0000Eooooo`05o`3jV_l00?oooooooooooooo00001Oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oo003ooooo00Oooooo00?o0?ZJool00?ooool00oooool01Ooo003o0?ZJoooo
oooo003o0?ZJ00;ooooo00?o0?ZJool00?l0nYX01oooool01Ol00?ooooooo`3jV_oo003o0?ZJ00co
oooo00?o0000ooooooooool05oooool3o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo00So
oooo00Koo`00ooooool0nY[oo`00oooooooo0002ooooo`04ool00?l00?oo0?ZJool000Sooooo00_o
003ooooooooo003oooooo`00ooooooooo`00ooooool0nY[oo`00o`3jVP02ooooo`03ool00?oooooo
o`0000Cooooo00Co003oooooooooooooo`000_l0nYX01?oo003o0?ZJooooooooool2o`00o`04oooo
ool0nY[oooooool000;ooooo00?o0?ZJool00?ooool00oooool02?l00?ooooooo`3jV_oooooo003o
o`3jV_oo003o0?ZJ0_ooool00ol0nY[oo`00ool00004ooooo`04o`3jV_l00?ooo`00o`3jVP;ooooo
00Co003oool00?oo003ooooo0_l0nYX4ooooo`06o`00ooooooooooooooooool0nY[oo`000_ooool0
1Ol0nY[oo`00ooooooooooooo`0000Cooooo00?o0?ZJool00?l0nYX00_ooool00ol00?ooo`00oooo
o`02ooooo`04o`3jV_ooooooo`00o`00o`?ooooo00?oo`00ooooooooool00_ooool01?l0nY[ooooo
oooooooo0002ooooo`;o0?ZJ00?oooooool00?oo00001_ooool00ol0nY[oooooool00004ooooo`08
o`00ooooooooo`00o`3jV_ooooooo`00ooooool0nYX2ooooo`04o`3jV_ooooooooooool000;o0000
00Koooooo`00oooooooo0?ZJool00?l0nYX6ooooo`05o`3jV_oo003o0?ZJooooool00?l00oooool0
0ol0nY[oo`00ooooo`04ooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ@oooool004Wooooo00?o
0000ooooool0nYX00_ooool00ooo003oooooo`00o`03ooooo`05o`3jV_ooooooo`00oooooooo0000
0_ooool01Ooo003oooooool00?ooooooo`0000gooooo00Co0?ZJool00?oo003o0?ZJ0_l00?l00ooo
ooooo`00ooooo`05ooooo`03o`00oooo003o0?ZJ00[ooooo00?o0?ZJool00?oo00004oooool4o`00
0003ooooool0nY[ooooo00Cooooo00?o003ooooooooo00008?ooool00ol0nY[oo`00ooooo`06oooo
o`Co00002?ooool3o`3jVP;oo`001?ooool00ol00?ooooooool00006ooooo`04o`00ool0nY[oo`00
o`3jVQoooooo1?l000000oooooooo`00ool00006ooooo`03o`3jV_oooooooooo02Sooooo00?o0000
o`3jV_ooool02?ooool01?l0nY[oo`00o`3jV_oo0002ooooo`03ool00?l00?oo003o00Co000000?o
0?ZJooooooooool01_ooool00ol0nY[oo`00ooooo`02ooooo`06ool00?l0nY[oooooo`3jV_oo003o
0?ZJ1?ooool01?l00?ooooooool00?l0nYX8ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00oooo
ooooool00_ooool2o`3jVP?ooooo0_oo00001ol0nY[oo`00oooooooooooo0?ZJoooooooo00000ooo
ool00ooo003oooooooooo`06ooooo`03o`00ooooooooo`0000?ooooo00Co0?ZJooooooooooooo`00
0oooool2ool00004o`3jV_oooooo0?ZJool000Cooooo0_oo0006ooooo`05o`00oooooooooooooooo
oooo00005_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJool0
0?ooool01oooool02ol0nY[oo`00oooooooooooo0?ZJoooooooo003o0?ZJoooooooo003o0?ZJ00;o
oooo00Co0?ZJool00?oooooo0?ZJ1_ooool01Ol00?oo0?ZJoooooooo003o0?ZJ00_ooooo0_l0000V
ooooo`;o00002Oooool01_oo003oooooo`3jV_oo003oooooool000;ooooo00Coo`00o`00ool0nY[o
o`002?ooool01ol00?ooooooool00?oooooo003ooooooooo00000_l0nYX01ooo003o0?ZJoooooooo
ooooo`00oooooooo00000oooool01Ol00?ooooooooooooooooooo`0000;o0?ZJ00Coo`00o`3jV_oo
oooooooo0_l00?l01?oooooo0?ZJoooooooo0002ooooo`03o`3jV_ooooooo`0000?ooooo00So003o
ooooool0nY[oooooo`00ool0nY[oo`00o`3jVP;ooooo00?o0?ZJool00?oo00001Oooool00ol0nY[o
o`00o`3jVP02ooooo`03o`00oooo003oo`0000;ooooo0_l0nYX3ooooo`06o`00oooooooooooooooo
ool0nY[oo`000_ooool01Ol0nY[oo`00o`3jV_ooooooo`0000Cooooo00?o0?ZJool00?l0nYX00_oo
ool00ol00?ooo`00ooooo`02ooooo`04o`3jV_ooooooo`00o`00o`?ooooo00?oo`00ooooooooool0
0_ooool01ol0nY[oooooooooool00?ooo`00ooooool0nYX00_ooool00ooo003oooooooooo`05oooo
o`03o`3jV_ooooooo`0000Cooooo00[o003ooooooooo003o0?ZJoooooooo003oooooo`3jV_oooooo
0?ZJ0oooool00ooo003oooooool00002o`00o`04ooooool0nY[oo`00o`3jVPKooooo00Go0?ZJool0
0?l0nY[oooooo`00o`03ooooo`03o`3jV_oo003ooooo00Cooooo00Ko003oo`3jV_ooooooooooo`00
ool0nYY3ooooo`00BOooool00ol0003oooooo`3jVP02ooooo`03ool00?l00?oooooo00?ooooo00Go
0?ZJoooooooo003oooooool00002ooooo`05ool00?ooooooo`00oooooooo00003Oooool01?l0nY[o
o`00ool00?l0nYX2o`00o`03oooooooo003ooooo00Gooooo00?o003oool00?l0nYX02_ooool00ol0
nY[oo`00ool0000Cooooo`05o`00ool0003o0000ooooool0nYX01_ooool00ol00?ooooooool0000O
ooooo`;o000000?oo`00ooooooooool01Oooool4o`0000Sooooo00Go0?ZJooooool0nY[o003oool0
0003ooooo`;o003o00?oooooool00?ooool01Oooool01?l00?oo0?ZJool00?l0nYXOooooo`Co0000
00?oo`00ooooooooool01_ooool00ol0nY[oooooooooo`0Xooooo`03o`000?l0nY[ooooo00Sooooo
00Co0?ZJool00?l0nY[oo`000_ooool00ooo003o003oooooo`04o`0000;o0?ZJ1oooool00ooo003o
0?ZJooooo`02ooooo`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool01?l00?ooooooool00?l0
nYX7ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?oo`00ooooooooool00_ooool00ol0nY[ooooo
ooooo`02ooooo`;oo`0000So0?ZJool00?ooooooooooo`3jV_ooooooo`00o`3jVP;ooooo00?oo`00
ooooooooool01_ooool00ol00?ooooooool00003ooooo`04o`3jV_ooooooooooool000?ooooo0_oo
0002ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?oo00001_ooool01Ol00?oooooooooo
ooooooooo`0001Kooooo00?o0?ZJooooooooool01Oooool2o`3jVPGooooo00?o0?ZJool00?ooool0
1oooool00ol0nY[oo`00ooooo`03o`3jVP0;ool00?l0nY[oooooool00?l0nY[o003oooooool0nY[o
ooooool00?l0nYX01_ooool01Ol00?oo0?ZJool00?oooooo0?ZJ00cooooo00?o0000ooooooooool0
9?ooool00ol0003oooooooooo`08ooooo`06ool00?oooooo0?ZJool00?ooooooo`000_ooool01?oo
003o003oo`3jV_oo0008ooooo`07o`00ooooooooo`00ooooool00?ooooooool00002o`3jVP07ool0
0?l0nY[ooooooooooooo003oooooool00003ooooo`09o`00oooooooooooooooooooo003o0?ZJoooo
oooo003o0?ZJ00;ooooo0_l00?l01?oooooo0?ZJoooooooo0002ooooo`03o`3jV_ooooooo`0000?o
oooo00So003oooooool0nY[oooooo`00ool0nY[oo`00o`3jVP;ooooo00?o0?ZJool00?oo00001Ooo
ool00ol0nY[oo`00o`3jVP02ooooo`03o`00oooo003oo`0000?ooooo00[o0?ZJoooooooooooooooo
o`00ool0nY[oooooo`00ool0nY[oo`000_ooool01Ol0nY[oo`00o`3jV_ooooooo`0000Cooooo00Oo
0?ZJool00?l0nY[oooooo`00ooooooooo`0000?ooooo00Co0?ZJooooooooooooo`000oooool00ooo
003oooooooooo`03ooooo`04o`3jV_oooooo003oool000;o000000?oooooool00?ooool01oooool0
0ol0nY[oooooool00004ooooo`07o`00ooooooooo`00o`3jV_ooooooo`00ooooo`03o`3jVP;ooooo
00Goo`00ooooooooooooo`00o`3jVP02ooooo`03o`3jV_oo003o0?ZJ00Kooooo00Go0?ZJool00?l0
nY[oooooo`00o`03ooooo`03o`3jV_oo003ooooo00Cooooo00Ko003oo`3jV_ooooooooooo`00ool0
nYY3ooooo`00BOooool00ol0003o0?ZJooooo`02ooooo`03ool00?l00?oooooo00?ooooo00Go0?ZJ
oooooooo003oo`00o`3jVP02ooooo`05ool00?ooooooo`00oooooooo00003Oooool01?oo003ooooo
ool00?l0nYX2o`00o`03oooooooo003ooooo00Gooooo00?o003oool00?l0nYX02_ooool00ol0nY[o
o`00ool0000Booooo`?o003o00?oo`00o`3jV_l0nYX01oooool00ol00?ooo`00ooooo`0Mooooo`Co
00001Oooool3o`3jVP;o00002Oooool01?l0nY[oooooo`3jV_ooool2ool000;ooooo00Co003ooooo
ooooooooo`001_ooool01?l00?oo0?ZJool00?l0nYXPooooo`;o00002_ooool00ol0nY[ooooooooo
o`0Xooooo`03o`000?oooooo0?ZJ00Sooooo00Co0?ZJool00?l0nY[oo`000_ooool01?oo003o003o
oooooooo0002o`0000;ooooo00?o0?ZJooooooooool01Oooool00ooo003o0?ZJooooo`02ooooo`06
ool00?l0nY[oooooo`3jV_oo003o0?ZJ1Oooool00ol00?ooo`00o`3jVP07ooooo`07o`3jV_oo003o
ooooo`3jV_oooooo003oool00003ooooo`03o`3jV_oooooooooo00?ooooo0_oo00000ol0nY[oo`00
ooooo`02ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool01_ooool00ol00?oooooo
ool00002ooooo`03o`3jV_oooooooooo00;oo`000oooool2ool000;ooooo00Ko0?ZJool00?l0nY[o
003oooooool0nYX2ool000Kooooo00Go003oooooooooooooooooool0000Fooooo`;o0?ZJ1_ooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oo003ooooo00Kooooo00co0?ZJoooooooo003oooooo`3j
V_oooooo0?ZJool00?l0nY[oooooool00?l0nYX2o`00o`04o`3jV_l00?ooo`00o`3jVPKooooo00Go
003oo`3jV_oo003oooooo`3jVP0<ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0
2?ooool01_oo003oooooool00?l0nY[oooooool000;ooooo00Coo`00o`00ool0nY[oo`002?ooool0
1ol00?ooooooool00?oooooo003ooooooooo00000_l0nYX01ooo003o0?ZJooooooooooooo`00oooo
oooo00000oooool02Ol00?ooooooooooooooooooo`00o`3jV_ooooooo`00o`3jVP05ooooo`03o`3j
V_ooooooo`0000;ooooo00?o0?ZJoooooooo00000oooool02?l00?ooooooo`3jV_l00?ooooooo`3j
V_oo003o0?ZJ0_ooool00ol0nY[oo`00ool00005ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Co003o
ool00?ooooooo`000oooool2o`3jVP07ooooool0nY[o0?ZJooooool00?oo0?ZJool00002ooooo`05
o`3jV_oo003o0?ZJoooooooo00001?ooool01ol0nY[oo`00o`3jV_oooooo003ooooooooo00000ooo
ool01?l0nY[ooooooooooooo0003ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJooooool00?l0
1?l00009ooooo`04o`3jV_ooooooo`00o`3jVP;ooooo00[o003oooooooooooooo`00o`3jV_oooooo
0?ZJool00?oooooo0?ZJ0oooool01Ooo003ooooooooooooo003o0?ZJ00;ooooo00?o0?ZJool00?l0
nYX01_ooool01Ol0nY[oo`00o`3jV_oooooo003o00?ooooo00?o0?ZJool00?ooool01?ooool01_l0
0?oo0?ZJoooooooooooo003oo`3jVT?ooooo0019ooooo`03o`000?l0nY[ooooo00;ooooo00?oo`00
o`00ooooool00oooool01Ol0nY[oooooool00?oo003o0?ZJ00;ooooo00Goo`00oooooooo003ooooo
ool0000<ooooo`05o`3jV_oo003oooooool00?l0nYX00oooool00ooo003oooooooooo`04ooooo`03
o`00oooo003o0?ZJ00[ooooo00?o0?ZJool00?oo00004_ooool3o`00o`03ool00?l0nY[ooooo00Oo
oooo00?o003oool00?ooool02?ooool2o`3jVQ?ooooo1?l00002ooooo`Co0?ZJ0_ooool2o`3jVPSo
oooo0_l0nYX01Ooooooo0?ZJooooool00?ooo`0000;ooooo00Co003oooooooooooooo`001_ooool0
1?l00?oo0?ZJool00?l0nYXPooooo`03o`00oooo003ooooo00Wooooo00?o0?ZJooooooooool0:?oo
ool00ol0003oooooo`3jVP08ooooo`04o`3jV_oo003o0?ZJool000;ooooo00Soo`00o`00oooooooo
o`00ooooool0nY[oo`00ooooo`;o0?ZJ1_ooool00ooo003o0?ZJooooo`02ooooo`06ool00?l0nY[o
ooooo`3jV_oo003o0?ZJ1Oooool00ol00?ooo`00o`3jVP07ooooo`07o`3jV_oo003oooooo`3jV_oo
oooo003oool00004o`3jVPGooooo0ooo00001ol0nY[ooooooooooooooooo0?ZJool00?l0nYX00_oo
ool00ooo003oooooooooo`06ooooo`03o`00ooooooooo`0000;ooooo00Co0?ZJooooooooooooo`00
0oooool00ol0nY[oo`00ool00003ooooo`05ool00?l0nY[o003oo`00ool0nYX00_oo0006ooooo`05
o`00oooooooooooooooooooo00005oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1_ooool00ol0
nY[oo`00ooooo`06ooooo`03o`3jV_oo003ooooo00;o0?ZJ00goooooo`3jV_oo003o0?ZJoooooooo
003o0?ZJo`00oooooooo0?ZJo`00oooo003o0?ZJ00Gooooo00Go003oooooool0nY[oo`00o`3jVP0=
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool01_oo003oooooool00?l0
nY[o003oool000;ooooo00Coo`00ooooool0nY[oo`002?ooool01ol00?ooooooool00?oooooo003o
o`3jV_oo00000_l0nYX01ooo003o0?ZJooooooooooooo`00oooooooo00000oooool02Ol00?oooooo
ooooooooooooo`00o`3jV_ooooooo`00o`3jVP05ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJ
oooooooo00000oooool02?l00?ooooooo`3jV_l00?ooooooo`3jV_oo003o0?ZJ0_ooool00ol0nY[o
o`00ool00005ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Co003oool00?l0nY[oo`001?ooool4o`3j
VP04ooooool00?oo0?ZJool000;ooooo00Go0?ZJool00?l0nY[oooooool00004ooooo`07o`3jV_oo
003o0?ZJooooool00?ooooooool00003ooooo`04o`3jV_ooooooooooool000?ooooo00?oo`00oooo
ooooool00oooool00ol0nY[oooooo`00o`04o`0000Wooooo00Co0?ZJoooooooo003o0?ZJ0_ooool0
2?l00?oooooooooooooo003o0?ZJooooool0nY[oo`001Oooool01Ooo003ooooooooooooo003o0?ZJ
00;ooooo00?o0?ZJool00?l0nYX01oooool01?oo003o0?ZJooooool00?l3ooooo`03o`3jV_oo003o
oooo00Gooooo00Go0?ZJoooooooooooo003oo`3jVP13ooooo`00BOooool01?l0003o0?ZJoooooooo
ool2ool00003o`00oooooooooooo00;ooooo00Go0?ZJoooooooo003oo`00o`3jVP02ooooo`05ool0
0?ooooooo`00oooooooo00003?ooool01Ol0nY[oo`00oooooooo003o0?ZJ00?ooooo00?oo`00oooo
ooooool01?ooool00ol00?ooo`00o`3jVP0:ooooo`03o`3jV_oo003oo`00013ooooo0ol00?l2oooo
o`03ool00?oooooooooo00Oooooo00?o003oool00?ooool02?ooool2o`3jVQCooooo0_l00002oooo
o`;o0?ZJ1_ooool2o`3jVP?ooooo1?l0nYX3ooooo`;o0?ZJ00Go003ooooooooo003oooooo`00o`02
ooooo`03ool00?oooooooooo00Cooooo00Co003oo`3jV_oo003o0?ZJ8?ooool00ol00?ooo`00oooo
o`08ooooo`03o`000?l0nY[ooooo02Wooooo00?o0000ooooool0nYX02?ooool01?l0nY[oo`00o`3j
V_oo0002ooooo`07ool00?l00?ooooooool00?oooooo0?ZJool00002ooooo`03o`3jV_oooooooooo
00Cooooo00?oo`00o`3jV_ooool00_ooool01_oo003o0?ZJooooool0nY[oo`00o`3jVPGooooo00?o
003oool00?l0nYX01oooool01?l0nY[oo`00ooooool0nYX2o`00o`;o00001oooool01Ooo003ooooo
ool00?oo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`06ooooo`05
o`00ooooooooo`00ooooool0nYX00_ooool2ool000?ooooo00?o0?ZJool00?oo00000oooool01Ooo
003o0?ZJo`00ool00?oo0?ZJ00;oo`001_ooool01Ol00?ooooooooooooooooooo`0001Oooooo00?o
0?ZJooooooooool00_ooool2o`3jVPOooooo00?o0?ZJool00?ooool01_ooool01?l0nY[oo`00oooo
ool0nYX3ooooo`0;o`3jV_oo003oooooool00?l0nY[o003oooooool00?oo0?ZJool00?l0nYX01Ooo
ool01Ol00?ooooooo`3jV_oo003o0?ZJ00gooooo00?o0000ooooooooool09?ooool00ol0003ooooo
ooooo`08ooooo`06ool00?ooooooo`00o`3jV_l00?ooo`000_ooool01?oo003oooooo`3jV_oo0009
ooooo`0:o`00oooo003oooooo`00ool0nY[oo`00o`3jV_ooooooo`00o`3jVP;ooooo00?oo`00oooo
oooo00000oooool02Ol00?ooooooooooooooooooo`00o`3jV_oooooo0?ZJool00005ooooo`03o`3j
V_ooooooo`0000?ooooo00?o0?ZJool00?ooool00_ooool02?l00?ooooooo`3jV_l00?ooooooo`3j
V_oo003o0?ZJ0_ooool00ol0nY[oo`00ool00005ooooo`03o`3jV_oo003o0?ZJ00;ooooo00Co003o
ool00?l0nY[oo`001oooool01Ol0nY[oooooo`00ool0nY[oo`0000;ooooo00Go0?ZJool00?l0nY[o
ooooool00004ooooo`07o`3jV_oo003o0?ZJooooool00?ooooooool00004ooooo`03o`3jV_oooooo
o`0000?ooooo00?oo`00ooooooooool00oooool01?l0nY[oooooo`00ooooool2o`0000Gooooo1_l0
nYX00oooooooo`00o`3jVP02ooooo`08o`00ooooooooooooool00?l0nY[oooooo`3jV_oo0005oooo
o`05ool00?oooooo0?ZJo`3jV_oo00000_ooool00ol0nY[oo`00o`3jVP07ooooo`04ool00?oooooo
0?ZJo`00o`?ooooo00?o0?ZJool00?ooool01Oooool01Ol00?oo0?ZJo`00oooooooo0?ZJ04?ooooo
0019ooooo`07o`3jV_oooooooooooooooooo003oooooo`00o`04ooooo`05o`3jV_ooooooo`00ool0
0?l0nYX00_ooool01Ooo003oooooool00?ooooooo`0000cooooo00Go0?ZJool00?ooooooo`00o`3j
VP03ooooo`03ool00?oooooooooo00Cooooo00?o003oool00?l0nYX02_ooool00ol0nY[oo`00ool0
000:ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l3ooooo`03ool00?oooooooooo00Oooooo00?o
003oool00?ooool02?ooool2o`3jVQCooooo00?o003oool00?l0nYX00_l0nYX8ooooo`Go0?ZJ1ooo
ool00ol0nY[o003oo`00o`02ool000;ooooo0_oo0006ooooo`04o`00ool0nY[oo`00o`3jVR3ooooo
00?o003oool00?l0nYX02Oooool00ol0nY[oooooooooo`0Xooooo`;o000000?o0?ZJooooooooool0
1_ooool01?l0nY[oo`00o`3jV_oo0002ooooo`07ool00?l00?ooooooool00?oooooo0?ZJool00002
ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00ooooooooool00_ooool01_oo003o0?ZJooooool0
nY[oo`00o`3jVPGooooo00?o003oool00?l0nYX01oooool01Ol0nY[oo`00o`3jV_oooooo003o00Co
00001_ooool01Ooo003oooooool00?oo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX00_ooool00ooo
003oooooooooo`06ooooo`05o`00ooooooooo`00ooooool0nYX00_ooool01_oo003ooooooooooooo
oooo0?ZJooooo`;oo`000oooool01Ooo003o0?ZJooooool00?oo0?ZJ00;oo`001_ooool01Ol00?oo
ooooooooooooooooo`0001Sooooo00?o0?ZJooooooooool00_l0nYX8ooooo`03o`3jV_oo003ooooo
00Kooooo00Co0?ZJool00?oooooo0?ZJ0oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00?ooooo00?o
0?ZJool00?l0nYX01Oooool01Ol00?ooooooo`3jV_oo003o0?ZJ00cooooo0_l0000Vooooo`;o0000
2Oooool01_oo003oooooool00?l0nY[o003oool000;ooooo00Coo`00ooooool0nY[oo`002Oooool0
2_l00?ooo`00ooooool00?oo0?ZJool00?l0nY[oooooool00?l0nYX2ooooo`03ool00?ooooooo`00
00?ooooo00[o003oooooooooooooooooool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool00ol0nY[o
ooooool00003ooooo`03o`3jV_ooooooo`0000;ooooo00So003oooooool0nY[o003ooooooooo003o
ooooo`3jVP;ooooo00?o0?ZJool00?oo00001Oooool00ol0nY[oo`00o`3jVP02ooooo`03o`00oooo
003o0?ZJ00;oo`001_ooool01Ol0nY[oooooo`00ool0nY[oo`0000;ooooo00Go0?ZJool00?l0nY[o
ooooool00004ooooo`07o`3jV_oo003o0?ZJooooool00?ooooooool00004ooooo`03o`3jV_oooooo
o`0000?ooooo00?oo`00ooooooooool00oooool01?l0nY[oooooo`00ooooool2ool00004o`3jV_oo
ooooooooooooo`;o0?ZJ0oooool2o`3jVP03oooooooo003o0?ZJ00;ooooo00So003oooooool0nY[o
o`00o`3jV_oooooo0?ZJool000Gooooo00[oo`00ooooool0nY[o0?ZJool00?oooooo0?ZJool00?oo
oooo0?ZJ1oooool01?oo003oooooo`3jV_l00?l3ooooo`03o`3jV_oo003ooooo00Gooooo00Go003o
o`3jV_l00?oo0000o`3jVP13ooooo`00BOooool00ol0nY[oooooooooo`02ool00003ooooool00?oo
oooo00?ooooo00Go0?ZJooooool0nY[oo`00o`3jVP02ooooo`05ool00?ooooooo`00oooooooo0000
3?ooool01Ol0nY[oo`00o`00ool00?ooo`0000?ooooo00?oo`00ooooooooool01?ooool00ol00?oo
o`00o`3jVP0:ooooo`03o`3jV_oo003oo`0000Wooooo0_l0nYX5ooooo`;o0?ZJ0oooool00ooo003o
ooooooooo`07ooooo`03o`00oooo003ooooo00Oooooo0ol0nYXDooooo`03o`00oooo003ooooo01Ko
oooo00Co0?ZJo`00ool00?oooooo1?oo00000ol0nY[oooooooooo`04ooooo`04o`00ool0nY[oo`00
o`3jVR3ooooo00?o003oool00?l0nYX02Oooool00ol0nY[oooooooooo`0Xooooo`03o`000?oooooo
0?ZJ00Sooooo00Co0?ZJool00?l0nY[oo`000_ooool02_oo003o003ooooooooo003oooooo`3jV_oo
ooooo`00ooooool0nYX5ooooo`;o00001?ooool01_oo003o0?ZJooooool0nY[oo`00o`3jVPGooooo
00?o003oool00?l0nYX01oooool01Ol0nY[oo`00o`3jV_oooooo003o00Co00001_ooool01Ooo003o
ooooool00?oo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`06oooo
o`06o`00ooooooooo`00ooooool0nY[ooooo0_oo0003ooooo`04o`3jV_ooooooo`00ool000?ooooo
00Goo`00o`3jV_ooooooooooo`3jVP02ool000Kooooo00Go003oooooooooooooooooool0000Hoooo
o`Co0?ZJ2Oooool00ol0nY[oo`00ooooo`06ooooo`04o`3jV_oo003o003oo`3jVP?ooooo00Go0?ZJ
ool00?l0nY[oo`00o`3jVP03ooooo`03o`3jV_oo003o0?ZJ00Gooooo00Go003oooooool0nY[oo`00
o`3jVP0=ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool01_oo003ooooo
ool00?l0nY[o003oool000;ooooo00Coo`00ooooool0nY[oo`002Oooool02_l00?ooo`00ooooool0
0?oo0?ZJool00?l0nY[oooooool00?l0nYX2ooooo`03ool00?ooooooo`0000?ooooo00[o003ooooo
ooooooooooooool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool00ol0nY[oooooool00003ooooo`03
o`3jV_ooooooo`0000?ooooo00Ko003oo`3jV_l00?ooooooool00?l0nYX3ooooo`03o`3jV_oo003o
o`0000Gooooo00[o0?ZJool00?oooooo0?ZJo`00ooooooooo`00o`3jV_ooooooo`001_ooool01Ol0
nY[oooooo`00oooo003o0?ZJ00;ooooo00Go0?ZJool00?l0nY[oooooool00004ooooo`07o`3jV_oo
003o0?ZJooooool00?ooooooool00004ooooo`04o`3jV_ooooooooooool000;ooooo00?oo`00oooo
ooooool01?ooool00ol0nY[o003oooooo`02ool000Co0?ZJ1_ooool01?l0nY[oooooool00?l0nYX2
ooooo`08o`00oooooooo0?ZJool00?l0nY[oooooo`3jV_oo0005ooooo`09ool00?oooooo0?ZJo`3j
V_oo003oooooo`3jV_oo003o0?ZJ00Sooooo00Coo`00ooooool0nY[o003o0oooool00ooo003o0?ZJ
ooooo`05ooooo`05o`00ool0nY[o003oooooool0nYX0@oooool004;ooooo0_l00005ooooo`04o`00
0?l00?ooooooool000;ooooo00?o003oooooooooool00_ooool01Ol0nY[oooooo`3jV_oo003o0?ZJ
00;ooooo00Goo`00oooooooo003oooooool0000<ooooo`05o`3jV_oo003o0?ZJoooooooo00000ooo
ool00ooo003oooooooooo`04ooooo`03o`00oooo003o0?ZJ00Wooooo00Co0?ZJoooooooo003oo`00
2Oooool2o`3jVPCooooo0ol0nYX3ooooo`03ool00?oooooooooo00Oooooo00?o003oool00?ooool0
1oooool00ol0nY[oooooo`3jVP0Dooooo`03o`00oooo003ooooo01Oooooo00Co0?ZJo`00ool00?oo
003o0oooool00ol0nY[oooooooooo`04ooooo`04o`00ool0nY[oo`00o`3jVQoooooo00Go003ooooo
oooo003oooooo`3jVP08ooooo`03o`3jV_oooooooooo02Sooooo00Co0000oooooooooooo0?ZJ1ooo
ool01?l0nY[oo`00o`3jV_oo0002ooooo`04ool00?ooooooooooool000;ooooo00Go0?ZJool00?oo
ooooooooo`3jVP03ooooo`Co00000oooool01_oo003o0?ZJooooool0nY[oo`00o`3jVPGooooo00?o
003oool00?l0nYX01oooool01_l0nY[oo`00o`3jV_oooooo003oooooo`;o000000?oo`00oooooooo
ool00oooool00ooo003oooooooooo`02ool000Cooooo00?o0?ZJool00?l0nYX00_ooool00ooo003o
ooooooooo`06ooooo`07o`00ooooooooo`00o`3jV_l00?ooooooool00003ooooo`;o0?ZJ00?ooooo
ool00?oo00000oooool01Ooo003o0?ZJoooooooooooo0?ZJ00;oo`001_ooool01Ol00?oooooooooo
ooooooooo`0002Gooooo00?o003oool00?ooool01Oooool01Ol0nY[oooooool00?l0nY[o003o00?o
oooo00Go0?ZJool00?l0nY[oo`00o`00o`03ooooo`03o`3jV_oo003o0?ZJ00Gooooo00Go003ooooo
ool0nY[oo`00o`3jVP0=ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool0
1_oo003oooooool00?l0nY[oooooool000;ooooo00Coo`00ooooool0nY[oo`002Oooool02_l00?oo
o`00o`00oooooooo0?ZJool00?l0nY[oooooool00?l0nYX2ooooo`03ool00?ooooooo`0000?ooooo
00[o003oooooooooooooooooool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool00ol0nY[oooooool0
0003ooooo`03o`3jV_ooooooo`0000?ooooo0_l000001?l00?oo0?ZJool00?l0nYX3ooooo`03o`3j
V_ooooooo`0000Gooooo00[o0?ZJool00?oooooo0?ZJo`00ooooooooo`00o`3jV_ooooooo`001_oo
ool01Ol0nY[oooooo`00oooo003o0?ZJ00;ooooo00Go0?ZJool00?l0nY[oooooool00004ooooo`07
o`3jV_oo003o0?ZJooooool00?ooooooool00004ooooo`04o`3jV_ooooooooooool000;ooooo00?o
o`00ooooooooool01?ooool00ol0nY[oooooo`00o`02ool00003ooooool0nY[o0?ZJ00Wooooo00Wo
o`00o`3jV_ooooooooooo`00oooooooo0?ZJool00?l0nYX00_ooool00ol0nY[oo`00ooooo`03oooo
o`05ool00?oooooo0?ZJoooooooo00000_l0nYX00ooo003o0?ZJooooo`07ooooo`04ool00?oooooo
0?ZJo`00o`?ooooo00?oo`00o`3jV_ooool01Oooool01Ol00?oo0?ZJo`00oooooooo0?ZJ04?ooooo
0011ooooo`04o`000?ooooooooooo`0000Cooooo0_l000001?oo003o003oo`00ool00?l5ooooo`05
o`3jV_oooooo0?ZJool00?l0nYX00_ooool01Ooo003oooooool00?ooooooo`0000cooooo00Go0?ZJ
ool00?l0nY[oooooool00003ooooo`03ool00?oooooooooo00Cooooo00?o003oool00?l0nYX02Ooo
ool01?l0nY[oooooool00?oo0009ooooo`;o0?ZJ1?ooool01?l0nY[o003oooooool0nYX2ooooo`03
ool00?oooooooooo00Oooooo00?o003oool00?ooool01_ooool2o`3jVP03ooooool0nY[ooooo01?o
oooo00?o003oool00?ooool05oooool00ol0nY[o003oo`00o`04ooooo`03o`3jV_oooooooooo00Co
oooo00Co003ooooooooo003o0?ZJ7oooool01?l00?ooooooool00?ooool3o`3jVPKooooo00?o0?ZJ
ooooooooool0:?ooool01?l0003oooooooooool0nYX7ooooo`04o`3jV_oo003o0?ZJool000;ooooo
00Coo`00ooooooooooooo`000_ooool01Ol0nY[oo`00o`00oooooooo0?ZJ00?ooooo1?l00003oooo
o`06ool00?l0nY[oooooo`3jV_oo003o0?ZJ1Oooool00ol00?ooo`00o`3jVP06ooooo`04o`3jV_oo
ooooo`00o`3jVP;o003o0_ooool01?l0nY[oo`00o`00ool00?l2ooooo`;oo`000_ooool2ool000Co
oooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`06ooooo`05o`00ooooooooo`00o`3j
V_ooool00_oo0003ooooo`03o`3jV_oooooooooo00;oo`000oooool01Ooo003o0?ZJoooooooooooo
0?ZJ00;oo`001_ooool01Ol00?ooooooooooooooooooo`0002Gooooo00?o003oool00?ooool01Ooo
ool01Ol0nY[oooooool00?l0nY[o003o00?ooooo00Go0?ZJool00?l0nY[oo`00o`00o`03ooooo`03
o`3jV_oo003o0?ZJ00Gooooo00Go003oooooool0nY[oo`00o`3jVP0=ooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool02?ooool01_oo003oooooool00?l0nY[oooooool000;ooooo00Co
o`00ooooool0nY[oo`002Oooool01_l00?ooo`00o`00oooooooo0?ZJool000;ooooo00Soo`00o`3j
V_ooooooooooool00?ooooooo`00o`3jVP;ooooo00[o003oooooooooooooooooool00?l0nY[ooooo
o`3jV_oo003o0?ZJ1?ooool00ol0nY[oooooool00003ooooo`03o`3jV_ooooooo`0000;ooooo1?l0
00000ol0nY[oo`00o`3jVP04ooooo`03o`3jV_oo003ooooo00Cooooo00[o0?ZJool00?oooooo0?ZJ
o`00ooooooooo`00ooooool0nY[oo`001_ooool01Ol0nY[oooooo`00oooo003o0?ZJ00;ooooo00Go
0?ZJool00?l0nY[oooooool00004ooooo`07o`3jV_oo003oooooo`3jV_l00?ooooooool00004oooo
o`04o`3jV_ooooooooooool000;ooooo00?oo`00ooooooooool01?ooool00ol0nY[oooooo`00o`02
ool000cooooo00Woo`00o`3jV_ooooooooooo`00oooooooo0?ZJool00?l0nYX00_ooool00ol0nY[o
o`00ooooo`02ooooo`06ool00?ooooooooooo`3jV_ooooooo`000_l0nYX00ooo003o0?ZJooooo`07
ooooo`04ool00?oooooo0?ZJo`00o`?ooooo00?oo`00o`3jV_ooool01Oooool01Ol00?oo0?ZJo`00
oooooooo0?ZJ04?ooooo0011ooooo`04o`000?ooooooooooo`0000Cooooo0_l00004o`00o`Cooooo
00Ko0?ZJoooooooooooo0?ZJool00?l0nYX2ooooo`05ool00?ooooooo`00oooooooo00003?ooool0
1_l0nY[oo`00o`3jV_l0nY[oo`00o`3jVP;ooooo00?oo`00ooooooooool01?ooool00ol00?ooo`00
o`3jVP09ooooo`04o`3jV_oo003oooooool000Sooooo0ol0nYX4ooooo`04o`3jV_l00?ooooooo`3j
VP;ooooo00?oo`00ooooooooool01oooool00ol00?ooo`00ooooo`06ooooo`04o`3jV_oooooooooo
o`3jVQCooooo00?o003oool00?ooool05oooool00ol0nY[oooooo`00o`04ooooo`03o`3jV_oooooo
oooo00Cooooo00Co003ooooooooo003o0?ZJ7oooool00ol00?ooooooool00003ooooo`So0?ZJ:_oo
ool2o`000003ooooool0nY[ooooo00Kooooo00Co0?ZJool00?l0nY[oo`000_ooool01?oo003ooooo
oooooooo0002ooooo`05o`3jV_oo003o003oooooool0nYX01?ooool2o`0000Cooooo00Koo`00o`3j
V_oooooo0?ZJool00?l0nYX5ooooo`03o`00oooo003o0?ZJ00Kooooo00Go0?ZJoooooooo003o0?ZJ
o`00o`03ooooo`04o`3jV_oo003oo`00o`00o`;ooooo00Coo`00oooooooooooooooo0_oo0004oooo
o`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool01_ooool01ol00?ooooooool00?l00?oo
ooooool00?l00?l00_ooool01?l0nY[oooooooooooooool2ool000?ooooo00Goo`00o`3jV_oooooo
ooooo`3jVP02ool000Kooooo00Go003oooooooooooooooooool0000Uooooo`03o`00oooo003o0?ZJ
00Gooooo00Go0?ZJool00?l00?oo0?ZJo`00o`03ooooo`04o`3jV_oo003o0?ZJool000Cooooo00?o
0?ZJool00?l0nYX01Oooool01Ol00?ooooooo`3jV_oo003o0?ZJ00cooooo0_l0000Vooooo`;o0000
2Oooool01_oo003oooooool00?l0nY[oooooool000;ooooo00Coo`00ooooooooooooo`002Oooool0
1_l00?ooo`00o`00oooooooo0?ZJool000;ooooo00Soo`00o`3jV_ooooooooooool00?ooooooo`00
o`3jVP;ooooo00[o003oooooooooooooooooool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool00ol0
nY[oooooool00003ooooo`05o`3jV_ooooooooooool00?ooool01?l000000ol0nY[oo`00o`3jVP04
ooooo`03o`3jV_oo003ooooo00Cooooo00Wo0?ZJool00?oooooo0?ZJo`00ooooooooo`00ooooool0
nYX00_oo0005ooooo`05o`3jV_oooooo003oool00?l0nYX00oooool01?oo003o0?ZJoooooooo0004
ooooo`07o`3jV_oo003oooooo`3jV_l00?ooooooool00005ooooo`03o`3jV_ooooooo`0000;ooooo
00?oo`00ooooooooool01?ooool01Ol0nY[oooooo`00ooooooooo`0000cooooo00Woo`00o`3jV_oo
ooooooooo`00oooooooo0?ZJool00?l0nYX00_ooool00ol0nY[oo`00ooooo`02ooooo`06ool00?oo
ooooooooo`3jV_ooooooo`000_ooool00ooo003o0?ZJooooo`07ooooo`04o`3jV_oo003o0?ZJo`00
o`;ooooo00?o0?ZJool00?l0nYX01_ooool01Ol00?oo0?ZJo`00ool0nY[o000004?ooooo0011oooo
o`04o`000?ooooooooooo`0000Cooooo00Go0000ooooool00?ooooooo`00o`05ooooo`06o`3jV_oo
ooooooooo`3jV_l00?oo0?ZJ0_ooool01_oo003oooooool00?ooooooo`00o`3jVP_ooooo00Ko0?ZJ
ool00?oooooo0?ZJool00?l0nYX2ooooo`03ool00?oooooooooo00Cooooo00?o003oool00?l0nYX0
2Oooool01?l0nY[oo`00oooooooo0008ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJoooooooo
oooo0?ZJ0_ooool00ooo003oooooooooo`07ooooo`03o`00oooo003ooooo00Gooooo0_l0nYX2oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool03?ooool00ol00?ooooooool0000Ioooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01?ooool01?l00?ooooooool00?l0nYX;
ooooo`03o`3jV_oooooooooo017ooooo00?o003ooooooooo00002_ooool00ol0003oooooooooo`0X
ooooo`04o`000?ooooooooooo`3jVPOooooo00Co0?ZJool00?l0nY[oo`000_ooool01?oo003ooooo
oooooooo0002ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJooooooooool00_ooool00ooo003o
ooooooooo`02ooooo`06o`3jV_oo003oooooo`3jV_oo003o0?ZJ1Oooool00ol00?ooo`00o`3jVP06
ooooo`05o`3jV_ooooooo`00o`3jV_l00?l00oooool01Ol0nY[oooooool00?oo003ooooo00;oo`00
0oooool2ool000Cooooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`06ooooo`06o`00
oooooooo0000o`000?oo003ooooo0_l00?l00ooooooo0?ZJooooo`02ooooo`03ool00?l0nY[ooooo
00;ooooo00Goo`00o`3jV_ooooooooooo`3jVP02ool000Kooooo00Go003oooooooooooooooooool0
000Uooooo`03o`00oooo003o0?ZJ00Gooooo00Go0?ZJool00?l00?oo0?ZJo`00o`03ooooo`04o`3j
V_oo003o0?ZJool000Cooooo00?o0?ZJool00?l0nYX01Oooool01Ol00?ooooooo`3jV_oo003o0?ZJ
00gooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`08ooooo`09ool00?ooooooo`00
o`3jV_ooooooo`00ooooool00?ooo`0000;ooooo00?oo`00ooooooooool01oooool01_l00?ooo`00
o`00oooooooo0?ZJool000;ooooo00Soo`00o`3jV_ooooooooooool00?ooooooo`00o`3jVP;ooooo
00[o003oooooooooooooooooool00?l0nY[oooooo`3jV_oo003o0?ZJ1?ooool00ol0nY[oooooool0
0003ooooo`04o`3jV_ooooooooooool000;ooooo0_l000001?oooooo0?ZJool00?l0nYX4ooooo`03
o`3jV_oo003ooooo00Cooooo00_o0?ZJool00?oooooo0?ZJo`00ooooooooo`00ooooool0nY[ooooo
ool00005ooooo`05o`3jV_oooooo0?ZJool00?l0nYX00oooool01?oo003o0?ZJoooooooo0004oooo
o`04o`3jV_oo003oooooo`3jVP;ooooo00?oo`00ooooooooool00oooool01_l0nY[ooooooooooooo
003oooooool000Kooooo00Go0?ZJooooool00?ooooooool0000<ooooo`09ool00?l0nY[ooooooooo
ool00?ooooooo`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?ooool00_ooool01_oo003ooooooooo
ool0nY[oooooool000;ooooo00?oo`00o`3jV_ooool01oooool01?l0nY[oo`00o`3jV_l00?l2oooo
o`03o`3jV_oo003o0?ZJ00Kooooo00Go003oo`3jV_l00?oo0?ZJo`000013ooooo`00@Oooool01?l0
003oooooooooool00004ooooo`03o`3jV_oooooooooo00Oooooo00Ko0?ZJoooooooooooo0?ZJo`00
ool0nYX2ooooo`06ool00?ooooooo`00oooooooo003ooooo0_l0nYX9ooooo`06ool00?l0nY[ooooo
o`3jV_oo003o0?ZJ0_ooool00ooo003oooooooooo`05ooooo`03ool00?l0nY[ooooo00Sooooo00Co
0?ZJool00?ooooooo`001oooool2o`3jVP03ooooool0nY[ooooo00;ooooo00Go0?ZJo`00oooooooo
ooooo`3jVP02ooooo`03ool00?oooooooooo00Oooooo00?o003oool00?ooool01Oooool01Ol0nY[o
oooooooooooooooo0?ZJ00?ooooo0ol0nYX=ooooo`03o`00ooooooooo`0001Wooooo0_l0nYX4oooo
o`03o`3jV_oooooooooo00Cooooo00Co003oooooool0nY[oo`002_ooool2o`3jVQ;ooooo00Co003o
ooooooooooooo`002_ooool00ol0003oooooooooo`0Xooooo`04o`000?ooooooooooo`3jVPOooooo
0_l0nYX2ool000;ooooo00Coo`00o`3jV_ooooooo`000oooool01Ol0nY[oo`00o`00oooooooo0?ZJ
00Cooooo00?oo`00ooooooooool00_ooool01Ol0nY[oo`00ooooool0nY[oo`0000Kooooo00?o003o
ool00?l0nYX01_ooool01Ol0nY[oo`00ooooool0nY[o003o00?ooooo00Go0?ZJoooooooooooo003o
ool00005ooooo`;o00001Oooool01Ooo003o0?ZJooooooooooooo`0000Wooooo1?l00002ooooo`03
o`00ool0nY[ooooo00?ooooo00?oo`00o`3jV_ooool00_ooool01Ooo003o0?ZJoooooooooooo0?ZJ
00;oo`001_ooool01Ol00?ooooooooooooooooooo`0002Gooooo00?o003oool00?l0nYX01Oooool0
1Ol0nY[oo`00ooooool0nY[o003o00?ooooo00Co0?ZJool00?oo003o0?ZJ1?ooool01?l0nY[oo`00
o`00ool0nYX4ooooo`05o`00oooooooo0?ZJool00?l0nYX03Oooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo00Sooooo00Woo`00oooooooo003o0?ZJoooooooo003oooooo`00oooo0000
0_ooool00ooo003oooooooooo`07ooooo`06o`00oooo003o003oooooool0nY[oo`000_ooool02?oo
003o0?ZJooooooooooooo`00oooooooo003o0?ZJ0_ooool02_l00?ooooooooooooooooooo`00o`3j
V_oooooo0?ZJool00?l0nYX4ooooo`03o`3jV_ooooooo`0000Cooooo00?o0?ZJoooooooo00000ooo
ool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00Cooooo00?o0?ZJool00?ooool01?ooool02ol0nY[oo`00
ooooool0nY[o003ooooooooo003oooooo`3jV_ooooooo`0000Gooooo00Go0?ZJooooool0nY[oo`00
o`3jVP03ooooo`04ool00?l0nY[oooooool000Cooooo00Co0?ZJool00?oooooo0?ZJ0_ooool00ooo
003oooooooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`001_ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00cooooo00Woo`00o`3jV_ooooooooooo`00oooooooo0?ZJool00?l0nYX00_ooool0
0ol0nY[oo`00ooooo`02ooooo`06ool00?ooooooooooo`3jV_ooooooo`000_ooool00ooo003o0?ZJ
ooooo`07ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?l0nYX01_ooool01Ol00?oooooo
o`3jV_l0nY[o000004?ooooo0011ooooo`04o`000?ooooooooooo`0000Cooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooooooo`02o`3jVP?ooooo00Goo`00oooooooo003oooooool00002oooo
o`03o`3jV_oooooooooo00Oooooo00Koo`00o`3jV_oooooo0?ZJool00?l0nYX2ooooo`03ool00?oo
oooooooo00Gooooo00?oo`00o`3jV_ooool02?ooool01?l0nY[oo`00oooooooo0007ooooo`04o`3j
V_ooooooooooo`3jVP?ooooo00Go0?ZJo`00ooooooooooooo`3jVP02ooooo`03ool00?oooooooooo
00Oooooo00?o003oool00?ooool01?ooool00ol0nY[oooooooooo`02ooooo`07o`3jV_oooooooooo
ooooool0nY[oooooo`3jVP0=ooooo`03o`00ooooooooo`0001[ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`04ooooo`04o`00oooooooo0?ZJool000[ooooo0_l0nYXBooooo`04o`00
ooooooooooooool000[ooooo00?o0000ooooooooool0:?ooool01?l0003oooooooooool0nYX7oooo
o`;o0?ZJ0_oo0002ooooo`04ool00?l0nY[oooooool000?ooooo00Go0?ZJool00?l00?ooooooo`3j
VP04ooooo`03ool00?oooooooooo00;ooooo00Go0?ZJool00?oooooo0?ZJool00007ooooo`04ool0
0?l0nY[o003oo`00o`?ooooo0_l0nYX00ooo003oooooo`3jVP05ooooo`04o`3jV_oooooo003oo`00
o`Cooooo1?l00004ooooo`05ool00?l0nY[ooooooooooooo00002Oooool4o`0000;ooooo0_l0nYX4
ooooo`;o00000oooool01Ol0nY[oo`00oooooooooooo0?ZJ00;oo`001_ooool01Ol00?oooooooooo
ooooooooo`0002Gooooo00?o003oool00?l0nYX01Oooool01Ol0nY[oo`00o`3jV_oooooo003o00?o
oooo00Co0?ZJool00?oo003o0?ZJ1?ooool01?l0nY[oo`00o`00ool0nYX4ooooo`05o`00oooooooo
0?ZJool00?l0nYX03Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Sooooo00Wo
o`00oooooooo003o0?ZJoooooooo003oooooo`00oooo00000_ooool00ooo003oooooooooo`07oooo
o`06o`00oooo003o003oooooool0nY[oo`000_ooool02?l0nY[oo`00ooooooooooooo`00oooooooo
003o0?ZJ0_ooool01_l00?ooooooooooooooooooo`00o`3jVP;ooooo00?oo`00o`3jV_ooool00_oo
ool01?l0nY[oooooool00?l0nYX4ooooo`03o`3jV_ooooooo`0000?ooooo00Goo`00o`3jV_oooooo
o`00o`3jVP04ooooo`03o`3jV_oo003ooooo00Cooooo00[o0?ZJool00?oooooo0?ZJo`00oooooooo
o`00ooooool0nY[ooooo0_oo0004ooooo`;o000000?o0?ZJool00?l0nYX00oooool01?oo003o0?ZJ
oooooooo0004ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?oo`00ooooooooool00oooool01_l0
nY[ooooooooooooo003oooooool000Oooooo00Co0?ZJoooooooooooo0?ZJ3?ooool02Ol0nY[oo`00
oooooooooooo003oooooool0nY[oo`00o`3jVP02ooooo`05o`3jV_ooooooo`00oooooooo00000_oo
ool01?l0nY[ooooooooooooo0002ooooo`03ool00?l0nY[ooooo00Oooooo00Co0?ZJool00?l00?oo
0?ZJ0_ooool00ol0nY[oo`00o`3jVP07ooooo`04o`00ool0nY[o0?ZJo`0004?ooooo0012ooooo`;o
00001Oooool00ol0003o0?ZJooooo`07ooooo`03o`3jV_oooooooooo00;o0?ZJ0oooool01Ooo003o
ooooool00?ooooooo`0000?ooooo00?o0?ZJooooooooool01_ooool02Ooo003o0?ZJooooool0nY[o
o`00o`3jV_oooooo0?ZJool00007ooooo`03o`3jV_oo003ooooo00Sooooo00Co0?ZJool00?oooooo
o`001_ooool2o`3jVP;ooooo00Oo0?ZJooooooooooooooooo`3jV_ooooooo`0000;ooooo00?o0?ZJ
oooooooo00002Oooool00ol00?ooo`00ooooo`03ooooo`;o0?ZJ1?ooool01ooo003ooooooooooooo
oooo0?ZJooooool0nYX00_ooool00ol00?ooooooooooo`08ooooo`03o`00ooooooooo`0001[ooooo
0_l0nYX3ooooo`03o`3jV_oooooooooo00Cooooo00Co003oooooool0nY[oo`002Oooool00ol0nY[o
ooooo`3jVP0Booooo`04o`00ooooooooooooool000[ooooo00?o0000ooooooooool0:?ooool01?l0
003oooooooooool0nYX7ooooo`;o0?ZJ0_oo0002ooooo`04ool00?l0nY[oooooool000?ooooo00Go
0?ZJool00?l00?ooooooo`3jVP04ooooo`03ool00?oooooooooo00;ooooo00Go0?ZJool00?l0nY[o
0?ZJool00007ooooo`04ool00?l0nY[o003oo`00o`;o000000Koooooo`3jV_ooooooo`00o`00ool0
nYX5ooooo`04o`3jV_oooooo003oo`00o`Cooooo1?l00004ooooo`05ool00?oooooo0?ZJoooooooo
00002Oooool00ol00?oo0000o`000003ooooo`03o`3jV_oooooooooo00;ooooo1?l00002ooooo`05
o`3jV_oo003oooooooooool0nYX00_l00005ooooo`03o`00oooooooooooo00;ooooo00?oo`00oooo
ooooool09?ooool00ooo003o0?ZJooooo`03ooooo`06o`3jV_ooooooo`00o`3jV_oooooo003o0ooo
ool01?l0nY[oo`00ool00?l0nYX4ooooo`04o`3jV_oo003o003oo`3jVPCooooo00Go003ooooooooo
003oooooo`3jVP0=ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool02Ooo
003oooooool00?l0nY[oooooool00?oooooo003oool00002ooooo`03ool00?oooooooooo00Oooooo
00Ko003oool00?l00?ooooooo`3jV_oo0002ooooo`0:o`3jV_oo003ooooooooooooo003oooooool0
0?l0nY[oooooo`00o`Cooooo00Koo`00o`3jV_ooooooooooool00?l0nYX3ooooo`04o`3jV_oooooo
o`00o`3jVPCooooo00?o0?ZJoooooooo00000oooool01Ooo003ooooooooooooo003o0?ZJ00Cooooo
00?o0?ZJool00?ooool01?ooool02Ol0nY[oo`00ooooool0nY[o003ooooooooo003oooooo`3jVP02
ooooo`04ool00?ooooooooooooooo`Co000000?oo`00o`3jV_ooool00_ooool01?oo003o0?ZJoooo
oooo0004ooooo`04o`3jV_oo003oooooo`3jVP;ooooo00?oo`00ooooooooool00oooool01_l0nY[o
oooooooooooo003oooooool000Oooooo00Co0?ZJoooooooooooo0?ZJ3?ooool02Ol0nY[oo`00oooo
oooooooo003oooooool0nY[oo`00o`3jVP02ooooo`05o`3jV_ooooooo`00oooooooo00000_ooool0
2?l0nY[oooooooooool0nY[oo`00oooooooo003o0?ZJ2?ooool01?l0nY[oo`00o`00ool0nYX2oooo
o`03o`3jV_oo003o0?ZJ00Oooooo00Co003oo`3jV_l0nY[o0000@oooool004Wooooo00?o0000o`3j
V_ooool01oooool00ol0nY[oooooooooo`02o`3jVP?ooooo00Koo`00oooooooo003oooooool00?l0
0?l2ooooo`03o`3jV_oooooooooo00Kooooo00Woo`00o`3jV_oooooo0?ZJool00?l0nY[oooooo`3j
V_oo00001oooool00ol0nY[oo`00ooooo`07ooooo`05o`3jV_ooooooo`00oooooooo00001Oooool2
o`3jVP?ooooo00Ko0?ZJooooooooooooooooo`3jV_ooool2ool00004ooooool0nY[oooooool000[o
oooo00?oo`00o`3jV_l0nYX00ol0nYX4ooooo`;oo`000oooool00ol0nY[oooooo`3jVP03o`00o`[o
oooo00?o003ooooooooo00006oooool2o`3jVP;ooooo00?o0?ZJooooooooool01?ooool01Ol00?oo
ooooo`3jV_oo003o0?ZJ00Sooooo00?o0?ZJooooool0nYX04_ooool01?l00?oooooooooooooo000:
ooooo`03o`000?oooooooooo02Sooooo0_l000000ooooooo0?ZJooooo`06ooooo`;o0?ZJ0_oo0002
ooooo`04ool00?l0nY[oooooool000?ooooo00Go0?ZJool00?l00?ooooooo`3jVP04ooooo`03ool0
0?oooooooooo00;ooooo00Go0?ZJool00?l0nY[o0?ZJool00007ooooo`03ool00?l0nY[ooooo00Co
000000Co0?ZJoooooooo003o0?ZJ1_ooool01?l0nY[oooooooooool00?l5ooooo`;o00001Oooool0
1Ol0nY[oo`00o`3jV_l0nY[oo`0000Wooooo00?o003oo`3jV_l0nYX00_ooool2o`3jVP04o`00oooo
ooooooooooooo`Co00000_ooool01?l0nY[oo`00ooooooooool4o`0000Cooooo00?o003ooooooooo
ool00_ooool00ooo003oooooooooo`0Tooooo`03ool00?l0nY[ooooo00?ooooo00Co0?ZJool00?oo
oooo0?ZJ0_ooool01?l00?ooooooooooool0nYX2ool00003o`3jV_oooooooooo00;ooooo00Co0?ZJ
ool00?l00?oo0?ZJ1?ooool01Ol00?oo0?ZJool00?oooooo0?ZJ00cooooo0_l0000Vooooo`;o0000
2Oooool01_oo003oooooool00?l0nY[oooooool000;o003o00Coo`00ooooooooooooo`002Oooool0
1_l00?ooo`00o`00ooooooooo`00o`3jVP;ooooo00[o0?ZJool00?ooooooooooool00?ooooooo`00
o`3jV_oooooo003o1?ooool01ooo003o0?ZJooooooooooooo`00ooooool0nYX00_ooool01?l0nY[o
ooooool00?l0nYX4ooooo`04o`3jV_ooooooooooool000;ooooo00Goo`00oooooooo003oooooo`3j
VP04ooooo`03o`3jV_oo003ooooo00Cooooo00Oo0?ZJool00?oooooo0?ZJo`00ooooooooo`0000;o
oooo00?o0?ZJoooooooo00000oooool4o`000003ool00?oooooooooo00;ooooo00Co0?ZJool00?oo
ooooo`001Oooool00ooo003oooooo`3jVP02ooooo`03ool00?oooooooooo00?ooooo00Ko0?ZJoooo
ooooooooo`00oooooooo0007ooooo`04o`3jV_ooooooooooo`3jVPcooooo00Wo0?ZJool00?oooooo
ooooo`00oooooooo0?ZJool00?l0nYX00oooool01?l0nY[oooooool00?oo0002ooooo`04o`3jV_oo
ooooooooo`3jVP;oo`0000?oooooo`3jV_ooool01oooool01?l0nY[oo`00o`00ool0nYX2ooooo`03
o`3jV_oo003o0?ZJ00Oooooo00Co003oo`3jV_l0nY[o0000@oooool004Wooooo0_l000000ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo00;o0?ZJ0oooool01?oo003oooooool00?ooool2ool0
00?ooooo00?o0?ZJooooooooool01Oooool02Ooo003o0?ZJooooool0nY[oo`00o`3jV_oooooo0?ZJ
ool00007ooooo`03o`3jV_oo003ooooo00Oooooo00Ko0?ZJoooooooo003o0?ZJool00?ooool4o`3j
VPGooooo00co0?ZJooooooooooooooooo`3jV_oo003oooooool00?oooooo0?ZJoooooooo0009oooo
o`;o00002Oooool2ool000?ooooo00?o0?ZJo`00ool0nYX00ol00?l:ooooo`03o`00ooooooooo`00
01cooooo1?l0nYX6ooooo`05o`00oooooooo0?ZJool00?l0nYX01oooool2o`3jVP03ooooool0nY[o
oooo017ooooo00Co003oooooooooooooo`002Oooool2o`0002[ooooo00Go0000oooooooooooooooo
o`3jVP06ooooo`;o0?ZJ0_oo0002ooooo`04ool00?l0nY[oooooool000?ooooo00Go0?ZJoooooooo
003oooooo`3jVP03ooooo`03o`00oooo003ooooo00?ooooo00Go0?ZJool00?l0nY[o0?ZJool00007
ooooo`03ool00?l0nY[ooooo00Co00000_ooool00ooo003o0?ZJooooo`05ooooo`;o0?ZJ00?ooooo
o`00ool00?l01?ooool00ol0nY[oooooooooo`04ooooo`05o`3jV_oo003o0?ZJo`3jV_oo00002ooo
ool4o`3jVP03ooooool00?oooooo00?ooooo0_l00003ooooo`04o`3jV_oo003oooooooooo`Co0000
1?ooool00ol00?ooooooooooo`02ooooo`03ool00?oooooooooo02Cooooo00?oo`00o`3jV_l00?l0
0oooool01?l0nY[oo`00ooooool0nYX2ooooo`04o`00ooooooooooooooooo`;oo`0000?o0?ZJoooo
ooooool00_ooool01?l0nY[oo`00ooooool0nYX4ooooo`04o`00ool0nY[oo`00o`3jVPkooooo00?o
0000ooooooooool09?ooool00ol0003oooooooooo`08ooooo`06ool00?ooooooo`00o`00oooooooo
o`000_l00?l01?oo003ooooooooooooo0009ooooo`;o000000Co003ooooooooo003o0?ZJ0_ooool0
2_l0nY[oo`00ooooooooooooo`00oooooooo003o0?ZJooooool00?l3ooooo`03o`3jV_oo003o0?ZJ
00;ooooo00?oo`00ooooool0nYX00_ooool01?l0nY[oooooool00?l0nYX4ooooo`04o`3jV_oooooo
ooooool000;ooooo0ooo00000ol0nY[oooooooooo`03ooooo`03o`3jV_oo003ooooo00Cooooo00Oo
0?ZJool00?oooooo0?ZJo`00ooooooooo`0000;ooooo00?o0?ZJoooooooo00001?ooool2o`000003
o`3jV_oo003ooooo00?ooooo00Co0?ZJool00?ooooooo`001Oooool00ooo003oooooo`3jVP02oooo
o`03ool00?oooooooooo00?ooooo00Co0?ZJoooooooooooooooo0_oo0007ooooo`04o`3jV_oooooo
ooooo`3jVPcooooo00Wo0?ZJool00?ooooooooooo`00oooooooo0?ZJool00?l0nYX00oooool00ol0
nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP;oo`0000?oooooo`3jV_ooool01oooool0
1?l0nY[oo`00o`00ool0nYX2ooooo`03o`3jV_oo003o0?ZJ00Sooooo0_l0nYX00ol0003ooooooooo
o`11ooooo`00BOooool00ol0003oooooo`3jVP07ooooo`05o`3jV_ooooooooooooooool0nYX00ooo
ool00ooo003oooooool00002o`000005ool00?ooooooooooooooool0nYX01oooool02Ooo003o0?ZJ
ooooooooooooo`00o`3jV_oooooo0?ZJool00007ooooo`03o`3jV_oo003ooooo00Oooooo00Go0?ZJ
oooooooo003o0?ZJool00002o`3jVPSooooo00Ko0?ZJooooooooooooooooo`3jV_oo0002ooooo`04
ool00?l0nY[oooooool000Sooooo1?l00007ooooo`?oo`000_ooool01_l0nY[o003oo`00ool0nY[o
003oooooo`;o003o0_l0nYX7ooooo`03o`00ooooooooo`0002Kooooo00Go003oooooool0nY[oo`00
o`3jVP07ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX9ooooo`04o`00ooooooooooooool0
00[ooooo00?o0000ooooooooool06_ooool3o`0000Cooooo0_l00005ooooo`05o`000?oooooooooo
ooooool0nYX01_ooool2o`3jVP;oo`000_ooool01?oo003o0?ZJo`3jV_oo0003ooooo`06o`3jV_oo
ooooo`00o`00oooooooo0?ZJ0_ooool00ol00?ooo`00ooooo`03ooooo`05o`3jV_oo003o0?ZJo`3j
V_oo00001oooool01?oo003o0?ZJooooooooool2o`000005o`00ooooooooooooool00?l0nYX01ooo
ool01?l0nY[oooooooooool00?l4ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJool00?l0nY[o
0?ZJool0000@ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool01Ol0nY[o
o`00oooooooooooo0?ZJ00;o000000?o0?ZJooooooooool00_ooool00ol00?ooooooooooo`02oooo
o`03ool00?oooooooooo02Cooooo00Coo`00o`3jV_l00?oo003o0_ooool01?l0nY[oo`00ooooool0
nYX2ooooo`04o`00ooooooooooooooooo`;oo`001Oooool01?l0nY[oo`00ooooool0nYX4ooooo`04
o`00ool0nY[oo`00o`3jVPkooooo00?o0000ooooooooool06?ooool3o`0000?ooooo0_l00004oooo
o`03o`000?oooooooooo00Sooooo0_l000001?oo003o003ooooooooo0002o`00o`04ool00?oooooo
ooooool000Sooooo1?l000000oooooooo`00o`3jVP02ooooo`0:o`3jV_oo003ooooooooooooo003o
ooooool00?l0nY[oooooo`00o`?ooooo00?o0?ZJool00?l0nYX00_ooool00ooo003oooooo`3jVP02
ooooo`04o`3jV_ooooooo`00o`3jVPCooooo00Co0?ZJooooooooooooo`000_ooool3ool00003o`3j
V_oooooooooo00?ooooo00?o0?ZJool00?ooool01Oooool01_oo003oooooo`3jV_l00?ooooooool0
00;ooooo00Co0?ZJooooooooooooo`000oooool2ool00003o`3jV_oo003ooooo00?ooooo00Co0?ZJ
ool00?ooooooo`001Oooool00ooo003oooooo`3jVP02ooooo`03ool00?oooooooooo00Cooooo00?o
0?ZJooooooooool00_oo0007ooooo`04o`3jV_ooooooooooo`3jVPcooooo00Co0?ZJool00?oooooo
003o0_ooool00ol0nY[oo`00o`3jVP03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooo
oooo0?ZJ0_oo00000ol0nY[oooooooooo`07ooooo`04o`3jV_oo003o003oooooo`;o0?ZJ00?ooooo
ool00?l0nYX02?ooool2o`3jVP03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooo0?ZJ
00Oooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`03ool00?oooooo000000?o000000Coo`00
oooooooooooo0?ZJ1oooool02Ooo003o0?ZJooooooooooooo`00o`3jV_oooooo0?ZJool00007oooo
o`03o`3jV_oo003ooooo00Oooooo00Ko0?ZJoooooooo003o0?ZJool00?l0nYX9ooooo`06o`3jV_oo
ooooooooooooool0nY[oo`000_ooool01?oo003o0?ZJoooooooo0008ooooo`Co00001oooool00ooo
003oooooool00002ooooo`07o`3jV_l00?ooo`00ooooool0nY[oooooo`00o`02o`000003o`3jV_oo
oooooooo00Gooooo00?o003ooooooooo00009oooool01?l00?oo0?ZJool00?l0nYX6ooooo`;o0?ZJ
0_ooool00ol0nY[oooooooooo`04ooooo`04o`00ool0nY[oooooo`3jVPSooooo00Co003ooooooooo
ooooo`002_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00001?ooool01Ol0003ooooooooooooooooo0?ZJ00Kooooo0_l0nYX2ool000;ooooo00Co
o`00o`3jV_l0nY[oo`000oooool01_l0nY[oooooool00?l00?ooooooo`3jVP;ooooo00?o003oool0
0?ooool00oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00Oooooo00?oo`00o`3jV_ooool00_ooool0
1_oo003o003ooooooooo003oooooo`3jVPOooooo0_l0nYX00ooooooo003oooooo`03ooooo`03o`3j
V_oooooooooo00Cooooo00Go0?ZJool00?oooooo0?ZJool0000@ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool00_ooool02Ol0nY[oo`00ooooooooooooo`00o`3jV_oo003oooooo`3j
VP03ooooo`03o`00oooooooooooo00;ooooo00?oo`00ooooooooool09?ooool02Ooo003o0?ZJo`00
ool00?ooooooo`3jV_l00?ooo`00o`3jVP03ooooo`04o`00ooooooooooooooooo`;oo`001_ooool0
0ol0nY[oo`00o`3jVP04ooooo`04o`00ool0nY[oo`00o`3jVPkooooo00?o0000ooooooooool06Ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Go0000ooooooooooooooooo`000009ooooo`Co
000000?o003ooooooooo00000_l00?l01?oo003ooooooooooooo0008ooooo`Co000000?o0?ZJool0
0?l0nYX00_ooool02_l0nY[oo`00ooooooooooooo`00oooooooo003o0?ZJooooool00?l3ooooo`03
o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?l0nYX00_ooool01?l0nY[oooooool00?l0nYX4oooo
o`06o`3jV_oooooooooooooooooo003ooooo0ooo00000ol0nY[oooooooooo`03ooooo`03o`3jV_oo
003ooooo00Gooooo00Ko0?ZJool00?l0nY[o003ooooooooo0002ooooo`04o`3jV_ooooooooooool0
00?ooooo0ooo00000ol0nY[oooooooooo`02ooooo`04o`3jV_oo003oooooool000Gooooo00?oo`00
ooooool0nYX00_ooool00ooo003oooooooooo`04ooooo`03o`3jV_oooooooooo00;oo`001oooool0
1?l0nY[oooooooooool0nYX<ooooo`04o`3jV_oo003oooooo`00o`;ooooo00?o0?ZJool00?l0nYX0
0oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJoooooooo
ool01oooool01?l0nY[oo`00ooooooooool2o`3jVP03oooooooo003o0?ZJ00Sooooo0_l0nYX00ol0
003oooooooooo`11ooooo`00BOooool01?l0003oooooooooool0nYX6ooooo`05o`3jV_oooooooooo
ooooool0nYX00oooool00ooo003o003oo`000003o`000005ool00?ooooooooooooooool0nYX01_oo
ool02Ooo003oooooooooooooooooo`00o`3jV_oooooo0?ZJool00007ooooo`03o`3jV_oo003ooooo
00Oooooo00Go0?ZJoooooooo003o0?ZJool0000:ooooo`05o`3jV_ooooooooooo`3jV_oo00000ooo
ool01?oo003o0?ZJoooooooo0009ooooo`;o000000?oo`00ooooooooool01?ooool2ool00005oooo
oooo003oooooooooool0nYX00ooo00000ol0nY[oooooo`000003o`0000Oooooo00?o003ooooooooo
00009oooool01?l00?oo0?ZJool00?l0nYX6ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool0
0ol0nY[o003oooooo`02o`3jVPOooooo00Co003oooooool0nY[oo`002_ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`0000;ooooo
00?o0?ZJooooooooool01?ooool2o`3jVP;oo`000_ooool01?oo003o0?ZJo`3jV_oo0003ooooo`06
o`3jV_ooooooo`00o`00oooooooo0?ZJ0_ooool00ol00?ooo`00ooooo`03ooooo`05o`3jV_oo003o
0?ZJool00?l0nYX01oooool00ol0nY[oo`00ooooo`02ooooo`06ool00?l00?ooooooool00?oooooo
0?ZJ2?ooool00ol0nY[oooooo`00o`03ooooo`;o0?ZJ1_ooool01Ol0nY[oo`00ooooooooooooo`00
013ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`02ooooo`05o`3jV_oo003o0?ZJ
o`3jV_oo00000_l0nYX00ooo003o0?ZJooooo`02ooooo`03o`00oooooooooooo00;ooooo00?oo`00
ooooooooool09?ooool01?oo003o0?ZJo`00ool00?l2o`0000;oo`0000Go0?ZJoooooooooooooooo
o`00o`03ooooo`03ool00?l0nY[ooooo00Gooooo00?o0?ZJool00?l0nYX01?ooool01?l00?oo0?ZJ
ool00?l0nYX<ooooo`?o00006?ooool5o`0000;ooooo00Co0000oooooooooooo00000oooool3o`00
00Oooooo1?l000000ol00?ooooooool00002ooooo`04ool00?ooooooooooool000Wooooo0_l00000
1?oooooo0?ZJool00?l0nYX2ooooo`0:o`3jV_oo003ooooooooooooo003oooooo`3jV_oo003ooooo
o`00o`?ooooo00?o0?ZJool00?l0nYX00_ooool02Ol0nY[oo`00ooooool0nY[oooooo`3jV_oooooo
o`00o`3jVP04ooooo`07o`3jV_oooooooooooooooooo003oooooool00002ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJool00?ooool01Oooool01_l0nY[oo`00o`3jV_l00?ooooooool000;ooooo
00?o0?ZJooooooooool00_oo0002ooooo`?oo`0000?o0?ZJooooooooool00_ooool01?l0nY[oo`00
oooooooo0005ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool01?ooool00ol0nY[o
ooooooooo`02ool000Oooooo00Co0?ZJoooooooooooo0?ZJ3?ooool01?l0nY[oo`00ooooool00?l2
ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool0
nYX2ooooo`03o`3jV_oooooooooo00Oooooo00Co0?ZJool00?oooooooooo0_l0nYX00oooooooo`00
o`3jVP08ooooo`03o`000?l0nY[o000004?ooooo0019ooooo`04o`000?ooooooooooo`3jVPKooooo
00Go0?ZJooooooooooooooooo`3jVP03ooooo`03ool00?l00?ooo`0000;o000000?o0?ZJo`00oooo
00000_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo003ooooo00;ooooo00Go0?ZJool00?l0
nY[o0?ZJool00007ooooo`03o`3jV_oo003ooooo00Oooooo00Co0?ZJool00?oooooo0?ZJ0_l00009
ooooo`05o`3jV_ooooooooooo`3jV_oo00000oooool01?oo003o0?ZJoooooooo000:ooooo`03o`3j
V_oo003ooooo00Gooooo00Coo`00ooooooooooooo`000_ooool01_l0nY[oo`00oooooooo003o0?ZJ
ooooo`Co000000?o0?ZJooooooooool01?ooool00ol00?ooooooool0000Wooooo`04o`00ool0nY[o
o`00o`3jVPGooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`05o`3jV_oo
oooo003oooooool0nYX01_ooool01Ol00?ooooooooooool0nY[oo`0000[ooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Go0000oooo
ooooooooooooo`3jVP06ooooo`;o0?ZJ0_oo0002ooooo`04ool00?l0nY[o0?ZJool000Cooooo00Go
0?ZJool00?l00?ooooooo`3jVP02ooooo`03o`00oooo003ooooo00?ooooo00Go0?ZJool00?oooooo
o`00o`3jVP07ooooo`03o`3jV_oo003ooooo00;ooooo0_oo00001?ooooooo`00ooooool0nYX8oooo
o`03o`3jV_oooooo003o00?ooooo00?o0?ZJo`00ooooool01Oooool01Ol0nY[oo`00oooooooooooo
o`00017ooooo00Go003oooooooooooooooooo`00o`04ooooo`05o`3jV_oo003o0?ZJo`3jV_oo0000
0_l0nYX00ooo003o0?ZJooooo`02ooooo`03o`00oooooooooooo00;ooooo00?oo`00ooooooooool0
9?ooool00ooo003o0?ZJooooo`04o`000003ooooool0nY[ooooo00;ooooo00Ko003ooooooooooooo
ooooool00?l0nYX6ooooo`03o`3jV_oo003o0?ZJ00Cooooo00Co003oo`3jV_oo003o0?ZJ3_ooool0
0ol0003oooooooooo`0Fooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000
0oooool00ol0003oooooooooo`08ooooo`;o000000Coo`00o`00ooooooooo`000_ooool01?oo003o
oooooooooooo000:ooooo`05ool00?l0nY[o0?ZJool00?l0nYX00_ooool02_l0nY[oo`00o`3jV_oo
ooooo`00ooooool0nY[oo`00ooooool00?l3ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool0
0?ooool00ol0nYX00oooooooo`00o`3jVP05ooooo`09o`3jV_ooooooooooool00?ooooooo`00o`3j
V_oooooo0?ZJ00Gooooo00?o0?ZJool00?ooool01Oooool01_l0nY[oo`00o`3jV_l00?ooooooool0
00;ooooo00Go0?ZJooooooooooooooooool00002ooooo`?oo`0000?o0?ZJooooooooool00_ooool0
1?l0nY[oo`00o`3jV_oo0005ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool01?oo
ool01Ol0nY[oooooooooooooooooo`0000Sooooo00?o0?ZJooooool0nYX03?ooool01?l0nY[oo`00
ooooool00?l2ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Wooooo00?o0?ZJool00?ooool01?ooool00ooo003o
0?ZJooooo`08ooooo`03o`3jV_l0003ooooo04;ooooo0019ooooo`;o000000?oooooo`3jV_ooool0
1Oooool01Ol0nY[ooooooooooooooooo003o00?ooooo00?oo`00o`00oooo00000_ooool00ol0nY[o
003oool00002ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJool00?ooool00_ooool01Ol0nY[o
o`00o`3jV_l0nY[oo`0000Oooooo00?o0?ZJool00?ooool01_ooool01?l0nY[oooooool00?ooool4
o`0000Sooooo00Go0?ZJoooooooooooo0?ZJool00003ooooo`04ool00?oooooo0?ZJool000[ooooo
00?o0?ZJo`00oooo00001?ooool01Ooo003oooooooooooooooooo`0000;ooooo00Go0?ZJool00?oo
ooooo`00o`3jVP02ooooo`;o000000?oooooo`3jV_ooool01?ooool01?l00?oooooooooooooo000W
ooooo`04o`00ool0nY[oo`00o`3jVPGooooo00?o0?ZJooooooooool00_ooool00ooo003ooooooooo
o`03ooooo`;o0?ZJ00Coooooo`00oooooooo0?ZJ1_ooool01Ol00?ooooooooooool0nY[oo`0000Wo
oooo0_l0000Mooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01Ol0
003ooooooooooooooooo0?ZJ00Kooooo0_l0nYX2ool000;ooooo00Coo`00o`3jV_l0nY[oo`001?oo
ool01Ol0nY[oo`00ooooool00?oo0?ZJ00;ooooo00?o003oool00?ooool00oooool01Ol0nY[oo`00
oooooooo003o0?ZJ00Oooooo00?o0?ZJool00?ooool00_ooool3ool000;ooooo00?o0?ZJoooooooo
ool01oooool01?l0nY[o003oooooooooool2o`3jVP03o`00oooooooooooo00Cooooo00Go0?ZJool0
0?ooooooooooool0000Aooooo`05o`00ooooooooooooooooool00?l01?ooool01Ol0nY[oo`00o`3j
V_l0nY[oo`0000;o0?ZJ00?oo`00o`3jV_ooool00_ooool00ol00?ooooooooooo`02ooooo`03ool0
0?oooooooooo02Cooooo00?oo`00o`3jV_ooool01?l000000ooooooo0?ZJooooo`03ooooo`05o`00
oooooooo0000o`000?l0nYX01_ooool00ol0nY[oo`00o`3jVP04ooooo`04o`00ool0nY[oo`00o`3j
VPkooooo00?o0000ooooooooool05oooool00ol0003oooooo`000003ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool02?ooool01_oo003oooooool00?l00?ooooooool000;ooooo
00Coo`00ooooooooooooo`002_ooool01Ooo003o0?ZJo`3jV_oo003o0?ZJ00;ooooo00[o0?ZJool0
0?l0nY[oooooool00?oooooo0?ZJool00?oooooo003o0oooool00ol0nY[oo`00o`3jVP02ooooo`03
o`3jV_oo003ooooo00;o0?ZJ0_ooool00ooo003o0?ZJooooo`04ooooo`09o`3jV_ooooooooooool0
0?ooooooo`00o`3jV_oooooo0?ZJ00Gooooo00?o0?ZJool00?ooool01Oooool00ol0nY[oo`00o`3j
VP02ooooo`05ool00?ooooooooooooooool0nYX00_ooool00ooo003oooooooooo`03ool00003o`3j
V_oooooooooo00;ooooo00Co0?ZJool00?l0nY[oo`001Oooool00ol0nY[oo`00o`3jVP02ooooo`03
ool00?oooooooooo00Cooooo00Go0?ZJooooooooooooooooool00008ooooo`03o`3jV_oooooo0?ZJ
00cooooo00Co0?ZJool00?l0nY[o003o0_ooool00ol0nY[oo`00o`3jVP03ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`3jVP09ooooo`03o`3jV_oo003o
oooo00Cooooo00?oo`00ooooooooool02?ooool00ol0nY[o0000ooooo`12ooooo`00BOooool01?l0
003oooooooooool0nYX6ooooo`05o`3jV_ooooooooooooooool00?l00oooool00ooo003o003oool0
0002ooooo`03o`3jV_l00?ooo`0000;ooooo0_l0nYX4ooooo`03o`3jV_oo003ooooo00;ooooo00Go
0?ZJool00?l0nY[o0?ZJool00007ooooo`03o`3jV_oo003ooooo00Kooooo00Co0?ZJoooooooo003o
oooo1?l00002o`00o`Kooooo00Koo`00oooooooooooo0?ZJool00?ooool2o`3jVP04ool00?oooooo
0?ZJool000_ooooo00?o0?ZJo`00oooo00000ooo0004ooooo`08ool00?ooooooooooo`3jV_oo003o
ooooool00?l0nYX3ooooo`;oo`0000?o0?ZJooooooooool00oooool01?l00?oooooooooooooo000W
ooooo`04o`00ool0nY[oo`00o`3jVPCooooo00?o0?ZJooooooooool00_ooool2ool000Gooooo00Ko
0?ZJoooooooooooo003oooooool0nYX6ooooo`05o`00ooooooooooooo`3jV_oo00002_ooool00ol0
003oooooooooo`0Jooooo`;o00001?ooool01?l0003oooooooooool00004ooooo`05o`000?oooooo
ooooooooool0nYX01_ooool01?l0nY[oooooool00?oo0002ooooo`04ool00?l0nY[o0?ZJool000Co
oooo00Go0?ZJool00?oooooo003oo`3jVP02ooooo`03o`00oooo003ooooo00?ooooo00Go0?ZJool0
0?ooooooo`00o`3jVP07ooooo`03o`3jV_oo003ooooo00;ooooo00Goo`00ooooool00?ooooooo`3j
VP0:ooooo`;o0?ZJ00Co003oooooool0nY[o003o1oooool01Ol0nY[oo`00ooooooooooooo`00017o
oooo00Go003oooooooooooooooooo`00o`04ooooo`09o`3jV_oo003o0?ZJo`3jV_oo003o0?ZJoooo
oooo003o0?ZJ00?ooooo00?o003oooooooooool00_ooool00ooo003oooooooooo`0Tooooo`04ool0
0?l0nY[oooooooooo`;o000000?oooooo`3jV_ooool01?ooool00ol00?oo0000o`000002o`0000Ko
oooo00Co0?ZJool00?l0003o00000oooool01?l0nY[oooooool00?l0nYX>ooooo`03o`000?oooooo
oooo01Sooooo0_l00003ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool02?oo
ool01_oo003oooooool00?l00?ooooooool000;ooooo00Coo`00ooooooooooooo`002_ooool01Ol0
nY[oo`00o`3jV_oo003o0?ZJ00;ooooo00[o0?ZJool00?l0nY[oooooool00?oooooo0?ZJool00?oo
oooo003o0oooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003ooooo00;o0?ZJ0_ooool00ooo
003o0?ZJooooo`04ooooo`04o`3jV_ooooooooooooooo`;oo`0000?o0?ZJooooool0nYX01Oooool0
0ol0nY[oo`00ooooo`05ooooo`06o`3jV_oo003o003oo`3jV_ooooooo`000oooool02_l0nY[ooooo
ooooooooooooo`00oooooooo003o0?ZJooooool0nYX4ooooo`04o`3jV_oo003o0?ZJool000Gooooo
00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`04ooooo`05o`3jV_oooooooooooooooooo
00002?ooool00ol0nY[oooooo`3jVP0<ooooo`04o`3jV_oo003o0?ZJo`00o`;ooooo00?o0?ZJool0
0?l0nYX00oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ool0nYX02Oooool00ol0nY[oooooool00004ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJo`00
0?ooool0@_ooool004Wooooo00Co0000oooooooooooo0?ZJ1_ooool01Ol0nY[ooooooooooooooooo
003o00?ooooo00?oo`00o`00oooo00000_ooool01?l0nY[oooooool00?l00?l2ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJool00?ooool00_ooool01Ol0nY[oo`00o`3jV_l0nY[oo`0000Oooooo
00?o0?ZJool00?ooool01_ooool01Ol0nY[oooooool00?oooooo0?ZJ00;o000000?o003oool00?l0
0?l01Oooool2ool000;ooooo00Wo0?ZJool00?l0nY[oooooo`3jV_ooooooo`00o`3jV_oo00002ooo
ool00ol0nY[o003oooooo`02ool000Gooooo00Soo`00oooooooooooo0?ZJool00?ooooooo`00o`3j
VP?ooooo0_oo00000ooooooo0?ZJooooo`03ooooo`04o`00ooooooooooooool002Oooooo0_l00?l0
0ooo003o0?ZJooooo`02ooooo`03o`3jV_oooooooooo00?ooooo0_oo0004ooooo`04o`00ool0nY[o
ooooooooo`;o003o00?o0?ZJooooooooool01?ooool01Ol00?ooooooo`3jV_ooooooo`0000[ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`03ooooo`;o00001Oooool01Ol0003ooooo
oooooooooooo0?ZJ00Kooooo00Oo0?ZJoooooooo003oo`00ooooool00?ooo`0000;o0?ZJ00?oo`00
ooooooooool00_ooool01Ol0nY[oooooool00?l00?oo0?ZJ00;ooooo00?o003oool00?ooool00ooo
ool01Ol0nY[oo`00oooooooo003o0?ZJ00Oooooo00?o0?ZJool00?ooool00_ooool01Ooo003ooooo
o`00ool00?oo0?ZJ00_ooooo0ol0nYX00ooooooo003oooooo`06ooooo`05o`3jV_oo003ooooooooo
oooo00004Oooool01Ol00?oooooooooooooooooo003o00Cooooo00[o0?ZJool00?l0nY[o0?ZJool0
0?l0nY[oooooool00?l00?oo0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03ool00?oooooooooo
02Cooooo00?oo`00o`3jV_ooool00_ooool00ooo003oooooo`3jVP05ooooo`03o`00ool0003o0000
00;o00001_ooool00ol0nY[o0000o`000002o`0000;ooooo00Co0?ZJoooooooo003o0?ZJ3_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`03o`000?oooooo
oooo00Sooooo00Koo`00oooooooo003o003ooooooooo0002ooooo`04ool00?ooooooooooool000[o
oooo00Go0?ZJool00?l0nY[oo`00o`3jVP02ooooo`0:o`3jV_oo003o0?ZJoooooooo003oooooo`3j
V_oo003oooooo`00o`?ooooo00?o0?ZJool00?l0nYX00_ooool00ol0nY[oo`00ooooo`04ooooo`03
ool00?l0nY[ooooo00Cooooo00Co0?ZJoooooooooooooooo0_oo0002o`3jVPOooooo00?o0?ZJoooo
ooooool01?ooool01_l0nY[oo`00o`00ool0nY[oooooool000?ooooo00Co0?ZJoooooooooooooooo
0ooo00000ol0nY[oooooo`3jVP04ooooo`04o`3jV_oo003o0?ZJool000Gooooo00?o0?ZJool00?l0
nYX00_ooool00ooo003oooooooooo`04ooooo`05o`3jV_ooooooooooooooool0nYX02?ooool00ol0
nY[oooooo`3jVP0=ooooo`03ool00?l0nY[o003o00;ooooo00?o0?ZJool00?l0nYX01?ooool01Ol0
nY[ooooooooooooooooo0?ZJ00Cooooo00?o0?ZJooooool0nYX02Oooool00ol0nY[oooooool00004
ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJo`000?ooool0@_ooool004Wooooo00Go0000oooo
ooooooooooooo`3jVP05ooooo`05o`3jV_ooooooooooooooool00?l00oooool00ooo003oooooool0
0003ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oo`00oooo
o`02ooooo`05o`3jV_oo003o0?ZJo`3jV_oo00001oooool00ol0nY[oo`00o`00o`05ooooo`;o0?ZJ
00Goooooool00?l0nY[o003oo`3jVP03o`00o`;oo`000oooool3ool000;ooooo00Wo0?ZJool00?l0
nY[oooooo`3jV_ooooooo`00o`3jV_oo00002oooool00ol0nY[o003oo`00o`07ooooo`04ool00?oo
ooooooooool000;ooooo00?oo`00o`3jV_ooool00_ooool2ool00003ooooool0nY[ooooo00?ooooo
00Co003oooooooooooooo`009oooool2o`00o`04ool00?l0nY[oooooooooo`;o0?ZJ1?ooool00ooo
003oooooool00004ooooo`03o`3jV_oooooooooo00;ooooo00?o003oo`3jV_ooool01Oooool01Ol0
0?ooooooo`3jV_ooooooo`0000[ooooo00?o0000ooooooooool0:?ooool2o`0000;ooooo00?o0?ZJ
ooooooooool01?ooool01ol0nY[oooooool00?oo003oooooo`00oooo00000_l0nYX00ooo003ooooo
ooooo`02ooooo`05o`3jV_ooooooo`00o`00ool0nYX00_ooool00ol00?ooo`00ooooo`03ooooo`05
o`3jV_oo003oooooool00?l0nYX01oooool00ol0nY[oo`00ooooo`02ooooo`05ool00?l0nY[o003o
o`00ool0nYX03?ooool01?l00?ooooooooooool00?l7ooooo`05o`3jV_oo003ooooooooooooo0000
4Oooool01Ol00?oooooooooooooooooo003o00Gooooo00Woo`00o`3jV_l0nY[oo`00o`3jV_oooooo
0?ZJool00?l0nYX00_ooool00ol00?ooooooooooo`02ooooo`03ool00?oooooooooo02Cooooo00?o
o`00o`3jV_ooool00_ooool00ooo003o0?ZJo`3jVP05ooooo`04o`00oooooooo0000o`0000Oooooo
00?o0?ZJo`000?l000000_l00002ooooo`04o`3jV_ooooooo`00o`3jVPgooooo0_l0000Vooooo`;o
00002Oooool01_oo003oooooool00?l00?ooooooool000;ooooo00Coo`00ooooooooooooo`002_oo
ool01Ol0nY[oo`00o`3jV_oo003o0?ZJ00;ooooo00[o0?ZJool00?l0nY[oooooool00?oooooo0?ZJ
ool00?oooooo003o0oooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003ooooo00Cooooo00?o
o`00o`3jV_ooool01?ooool01?l0nY[oooooooooooooool2ool000;o0?ZJ1oooool00ol0nY[ooooo
ooooo`04ooooo`06o`3jV_oo003o003oo`3jV_ooooooo`000oooool00ol0nY[oooooooooo`02oooo
o`;oo`000_l0nYX5ooooo`04o`3jV_oo003o0?ZJool000Gooooo00?o0?ZJool00?l0nYX00_ooool0
0ooo003oooooooooo`05ooooo`04o`3jV_ooooooooooo`3jVPSooooo00?o0?ZJooooool0nYX03Ooo
ool00ooo003o0?ZJo`00o`02ooooo`03o`3jV_oo003o0?ZJ00Cooooo00Go0?ZJoooooooooooooooo
o`3jVP04ooooo`;o0?ZJ2oooool00ol0nY[oo`00ooooo`03ooooo`03ool00?oooooooooo00Sooooo
00?o0?ZJo`000?ooool0@_ooool004Wooooo00Go0000ooooooooooooooooo`3jVP05ooooo`05o`3j
V_ooooooooooooooool00?l00oooool00ooo003oooooool00003ooooo`03o`3jV_ooooooo`0000;o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oo`00ooooo`02ooooo`05o`3jV_oo003ooooooooo
oooo00001oooool00ol0nY[oo`00o`00o`06o`3jVP;ooooo00Goo`00o`3jV_l00?ooooooo`3jVP03
ooooo`Goo`0000Ooooooool00?oooooo0?ZJo`00oooo003o0?ZJ00;ooooo00Co0?ZJool00?oooooo
o`002oooool01?l0nY[o003oo`00ool00?l5ooooo`05o`3jV_oo003oooooo`3jV_oo00000_l0nYX0
1Ooo003o0?ZJoooooooooooo0?ZJ00;oo`0000?oooooo`3jV_ooool00oooool01?l00?oooooooooo
oooo000Xooooo`04o`00oooo003o0?ZJooooo`;o0?ZJ1Oooool00ooo003oooooool00004ooooo`03
o`3jV_oooooooooo00;ooooo00?o003oo`3jV_ooool01Oooool01Ol00?oo0?ZJo`3jV_ooooooo`00
00[ooooo00?o0000ooooooooool0:?ooool01Ol0003ooooooooooooooooo0?ZJ00Kooooo00Oo0?ZJ
oooooooo003oo`00ooooool00?ooo`0000;o0?ZJ00?oo`00ooooooooool00_ooool02Ol0nY[ooooo
ool00?l00?ooooooo`3jV_oooooo003oool00005ooooo`04ool00?ooooooo`00o`3jVPOooooo00?o
0?ZJool00?ooool00_ooool01Ooo003o0?ZJo`00ool00?oo0?ZJ00cooooo00Co003ooooooooooooo
003o1oooool01Ol0nY[oo`00ooooooooooooo`00017ooooo00Co003ooooooooooooo003o1_ooool0
2Ooo003o0?ZJo`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP02ooooo`03o`00oooooooooooo00;o
oooo00?oo`00ooooooooool09?ooool00ooo003o0?ZJooooo`02ooooo`03ool00?l0nY[ooooo00Go
oooo00?o003oooooool00?l02?ooool01?l0nY[oo`00o`000?l00003ooooo`04o`3jV_ooooooo`00
o`3jVPkooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`08ooooo`09ool00?oooooo
o`00o`00ooooooooo`00o`3jV_ooooooo`0000;ooooo00?oo`00ooooooooool02?ooool01Ol0nY[o
o`00o`3jV_oo003o0?ZJ00;ooooo00[o0?ZJool00?l0nY[oooooool00?oooooo0?ZJool00?oooooo
003o0oooool00ol0nY[oo`00o`3jVP02ooooo`03o`3jV_oo003ooooo00Cooooo00?oo`00o`3jV_oo
ool01?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo
ool01?ooool01_l0nY[oo`00o`00ool0nY[oooooool000Cooooo00?o0?ZJooooooooool00_ooool3
o`3jVPGooooo00Co0?ZJool00?ooooooo`001Oooool00ol0nY[oo`00o`3jVP02ooooo`03ool00?oo
oooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ2?ooool00ol0nY[oooooo`3jVP0=ooooo`03ool0
0?l0nY[o003o00;ooooo00?o0?ZJool00?l0nYX01?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Go
oooo00?o0?ZJooooooooool02Oooool00ol0nY[oo`00ooooo`03ooooo`03ool00?oooooooooo00So
oooo00?o0?ZJo`000?ooool0@_ooool004Wooooo00Go0000ooooooooooooooooo`3jVP05ooooo`05
o`3jV_ooooooooooooooool00?l00oooool00ooo003oooooool00003ooooo`06o`3jV_ooooooo`00
o`00oooooooo0?ZJ1?ooool00ooo003o0?ZJooooo`02ooooo`05o`3jV_oo003ooooooooooooo0000
1oooool01?l0nY[oo`00o`00ool0nYX2ooooo`;o0?ZJ0_ooool01_oo003oooooo`3jV_l00?oooooo
o`3jVP?ooooo00Co003ooooooooo003oo`000_ooool01Ooo003oooooo`3jV_oo003o0?ZJ00?ooooo
00Co0?ZJool00?ooooooo`003?ooool00ol0nY[o003oo`00o`05ooooo`05o`3jV_oo003oooooo`3j
V_oo00000ol0nYX02?oo003o0?ZJooooool0nY[oo`00o`3jV_oo003o0?ZJ1?ooool01?l00?oooooo
oooooooo000Xooooo`04o`00oooo003o0?ZJo`3jVPKooooo00Coo`00ooooooooooooo`000oooool0
1?l00?oo0?ZJooooooooool3ool000Co0?ZJ0oooool01Ol00?oo0?ZJooooooooooooo`0000[ooooo
00?o0000ooooooooool0:?ooool01Ol0003ooooooooooooooooo0?ZJ00Kooooo00Oo0?ZJoooooooo
003oo`00ooooool00?ooo`0000;o0?ZJ00?oo`00ooooooooool00_ooool02Ol0nY[oooooool00?l0
0?ooooooo`3jV_oooooo003oool00005ooooo`04ool00?ooooooo`00o`3jVPOooooo00?o0?ZJool0
0?ooool00_ooool01Ooo003o0?ZJoooooooooooo0?ZJ00cooooo00Co003ooooooooooooo003o1ooo
ool01Ol0nY[oo`00ooooooooooooo`0001;ooooo00?o003oooooool00?l01_ooool02Ooo003ooooo
o`3jV_oo003o0?ZJooooool0nY[oo`00o`3jVP02ooooo`03o`00oooooooooooo00;ooooo00?oo`00
ooooooooool09?ooool00ooo003o0?ZJooooo`02ooooo`03ool00?oooooooooo00Kooooo0_l00?l8
ooooo`04o`3jV_oo003oo`00ool000;ooooo00Co003oo`3jV_oo003o0?ZJ3oooool00ol0003ooooo
ooooo`0Tooooo`03o`000?oooooooooo00Sooooo00Woo`00oooooooo003o003ooooooooo003o0?ZJ
oooooooo00000_ooool00ooo003oooooooooo`09ooooo`03ool00?ooooooo`0000?ooooo00Wo0?ZJ
ool00?l0nY[oooooool00?oooooo0?ZJool00?l00?l01?ooool00ol0nY[oo`00o`3jVP02ooooo`03
o`3jV_oo003ooooo00Cooooo00?oo`00o`3jV_ooool01Oooool01Ol0nY[ooooooooooooooooo0?ZJ
00Wooooo00?o0?ZJooooooooool01?ooool01_l0nY[oo`00o`00ool0nY[oooooool000Cooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooo`3jVP05ooooo`04o`3jV_oo003oooooool000Gooooo
00?o0?ZJool00?l0nYX00_ooool00ooo003oooooooooo`05ooooo`04o`3jV_ooooooooooo`3jVPWo
oooo0_l0nYX=ooooo`03ool00?l0nY[o003o00;ooooo00?o0?ZJool00?l0nYX01?ooool01?l0nY[o
ooooooooool0nYXBooooo`03o`3jV_oo003ooooo00?ooooo00?oo`00ooooooooool02Oooool00ol0
003oooooooooo`11ooooo`00BOooool2o`0000;ooooo00?o0?ZJooooooooool00oooool01Ol0nY[o
oooooooooooooooo003o00?ooooo00?oo`00oooooooo00001?ooool01Ol0nY[oo`00o`00oooooooo
0?ZJ00Cooooo00?oo`00o`3jV_ooool00_ooool01Ol0nY[oo`00oooooooo003o0?ZJ00Oooooo00?o
0?ZJool00?l0nYX00_l00005ooooo`03ool00?oooooo0?ZJ00;ooooo0_l0nYX2ooooo`03o`00oooo
oooooooo00?ooooo00Goo`00ooooool0nY[oo`00o`3jVP03ooooo`04o`3jV_oo003oooooool000co
oooo00?o0?ZJo`00ool00?l00_l00?l2ooooo`;o0?ZJ013oo`00ooooool0nY[oo`00o`3jV_oooooo
0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJool00?oooooo0?ZJ0oooool01?l00?oooooooooooooo
000Xooooo`04o`00oooo003o0?ZJo`3jVPKooooo00Coo`00ooooooooooooo`000oooool00ol00?oo
0?ZJooooo`02ool00005oooooooo003o0?ZJo`3jV_ooool00_l0nYX2ooooo`;o0?ZJ0_ooool00ooo
003oooooooooo`07ooooo`;o0000:_ooool01Ol0003ooooooooooooooooo0?ZJ00Kooooo00Oo0?ZJ
oooooooo003oo`00ooooool00?ooo`0000;o0?ZJ00?oo`00ooooooooool00oooool02?l0nY[oo`00
o`00oooooooo0?ZJooooool00?ooo`001Oooool01?oo003oooooool00?l0nYX7ooooo`03o`3jV_oo
003ooooo00;ooooo00Coo`00o`3jV_l0nY[o0?ZJ3Oooool01?l00?ooooooooooool00?l7ooooo`05
o`3jV_oo003ooooooooooooo00004_ooool00ol00?ooooooo`00o`06ooooo`09ool00?oooooooooo
ool00?l0nY[oooooo`3jV_oo003o0?ZJ00;ooooo00?o003oooooooooool00_ooool00ooo003ooooo
ooooo`0Tooooo`03o`3jV_oo003ooooo00;ooooo00?oo`00ooooooooool01_ooool00ol00?oooooo
ooooo`07ooooo`04o`3jV_oo003oo`00ool000;ooooo00Co003oo`3jV_oo003o0?ZJ3oooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo00Sooooo00?oo`00oooooooo00000_ooool01?oo
003o0?ZJoooooooo0002ooooo`03ool00?oooooooooo00Wooooo00?oo`00oooooooo00000oooool0
2Ol0nY[oo`00o`3jV_ooooooo`00ooooool0nY[oo`00o`00o`04ooooo`03o`3jV_oo003o0?ZJ00;o
oooo00?o0?ZJool00?ooool01?ooool00ooo003o0?ZJooooo`05ooooo`05o`3jV_oooooooooooooo
ool0nYX02Oooool00ol0nY[oooooooooo`04ooooo`06o`3jV_oo003o003oo`3jV_ooooooo`001?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJool00?ooooooo`00
1Oooool00ol0nY[oo`00o`3jVP02ooooo`03ool00?oooooooooo00Gooooo00Co0?ZJoooooooooooo
0?ZJ2Oooool2o`3jVPgooooo00?oo`00o`3jV_l00?l00_ooool00ol0nY[oo`00o`3jVP05ooooo`03
o`3jV_oooooo0?ZJ01;ooooo00?o0?ZJool00?ooool00oooool00ooo003oooooooooo`09ooooo`03
o`000?oooooooooo047ooooo0019ooooo`05o`000?ooooooooooooooool0nYX01Oooool01Ol0nY[o
oooooooooooooooo003o00?ooooo00?oo`00oooooooo00001?ooool00ol0nY[oooooool00002oooo
o`06o`3jV_oooooooooooooooooo003o0?ZJ0oooool01Ol0nY[oo`00oooooooo003o0?ZJ00Oooooo
00?o0?ZJool00?l000000ol00004ooooo`03ool00?oooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo
003o1Oooool01Ooo003oooooo`3jV_oo003o0?ZJ00?ooooo00Co0?ZJool00?ooooooo`003?ooool2
o`3jVP03ooooool00?oo003o00;ooooo01;o0?ZJoooooooo003oooooo`3jV_oo003o0?ZJooooool0
nY[oo`00o`3jV_oooooo0?ZJool00?l0nY[oo`00ooooool0nYX3ooooo`04o`00ooooooooooooool0
02Wooooo00?oo`00o`3jV_ooool00_ooool3o`00o`;oo`000_ooool01Ooo003ooooooooooooooooo
0?ZJ00;ooooo00Coo`00oooooooooooooooo0_l00002ooooo`Co0?ZJ0oooool00ooo003ooooooooo
o`08ooooo`03o`000?oooooooooo02Sooooo0_l00002ooooo`03o`3jV_oooooooooo00Cooooo00Oo
0?ZJoooooooo003o0?ZJooooool00?ooo`0000;o0?ZJ00?oo`00ooooooooool00oooool02?l0nY[o
o`00ooooool00?oo0?ZJooooool00?ooo`001Oooool01?l0nY[oo`00ool00?l0nYX7ooooo`03o`3j
V_oo003ooooo00;ooooo00Coo`00ooooool0nY[o0?ZJ3Oooool01?l00?ooooooooooool00?l8oooo
o`04o`3jV_oo003oooooool001;ooooo00?o003oooooool00?l01_ooool02Ooo003ooooooooooooo
003o0?ZJooooool0nY[oo`00o`3jVP02ooooo`03o`00oooooooooooo00;ooooo00?oo`00oooooooo
ool09?ooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooooooo00Kooooo00?o003ooooooooo
ool01oooool02_l0nY[oo`00ool00?oo003o0?ZJooooool00?oo0?ZJool00?l0nYX>ooooo`;o0000
9_ooool2o`0000Wooooo00?oo`00o`3jV_oo00000_ooool01?oo003o0?ZJoooooooo0002ooooo`03
ool00?oooooooooo00Wooooo0_oo00000ol0nY[oooooooooo`02ooooo`08ool00?l0nY[oooooool0
0?oooooo0?ZJool00?l00?l4ooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?ooool01?oo
ool00ooo003o0?ZJooooo`05ooooo`05o`3jV_ooooooooooooooool0nYX02Oooool00ol0nY[ooooo
ooooo`04ooooo`06o`3jV_oo003o003oo`3jV_ooooooo`001?ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Kooooo00?oo`00oooooooo00001Oooool00ol0nY[oo`00o`3jVP02oooo
o`03ool00?oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ2Oooool2o`3jVPgooooo00?oo`00
o`3jV_l00?l00_ooool00ol0nY[oo`00ooooo`05ooooo`?o0?ZJ4_ooool00ol0nY[oo`00ooooo`03
ooooo`03ool00?oooooooooo00Sooooo0_l00013ooooo`00BOooool01Ol0003ooooooooooooooooo
0?ZJ00Gooooo00?o0?ZJooooooooool00_ooool01_l00?oooooooooooooo003oooooool000Cooooo
00?o0?ZJoooooooo00000_ooool01_l0nY[oooooooooooooooooo`00o`3jVP?ooooo00Go0?ZJool0
0?ooooooo`00o`3jVP07ooooo`03o`3jV_oo003o000000?o00001?ooool00ooo003oooooo`3jVP04
ooooo`04o`3jV_oooooo003oo`00o`Cooooo00Goo`00ooooool0nY[oo`00o`3jVP03ooooo`04o`3j
V_ooooooo`00ool000gooooo00Ko0?ZJoooooooooooo003oooooool0nYX2ooooo`0@ool00?oooooo
0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJooooool0nY[oo`00o`3jV_oo003oooooo`3jVP?ooooo
00Co003oooooooooooooo`00:Oooool00ol0nY[oo`00ooooo`02ooooo`;o003o0_oo0002o`00o`06
oooooooo003oooooooooool00?oo0?ZJ0_ooool00ooo003oooooooooo`04o`0000?ooooo00?o003o
ooooooooool00_ooool00ooo003oooooooooo`08ooooo`03o`000?oooooooooo02Sooooo00Go0000
ooooooooooooooooo`3jVP06ooooo`07o`3jV_ooooooo`00o`3jV_oooooo003oool00002o`3jVP03
ool00?oooooooooo00?ooooo00So0?ZJool00?oooooo003oo`3jV_oooooo003oool000Gooooo00Co
0?ZJool00?oo003o0?ZJ1oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooooooo00oooooo
00?o003oooooool00?l02?ooool01?l0nY[oo`00oooooooo000Booooo`03o`00oooooooo003o00Ko
oooo00coo`00ooooooooooooo`00o`3jV_oooooo0?ZJool00?oooooo0?ZJooooool00?l4ooooo`03
ool00?oooooooooo02Cooooo00?o0?ZJool00?ooool00_ooool00ooo003oooooooooo`0@ooooo`0:
o`3jV_ooooooo`00ool00?l0nY[oooooo`3jV_ooooooo`00o`3jVPoooooo00?o0000ooooooooool0
9?ooool00ol0003oooooooooo`08ooooo`03ool00?l0nY[oo`0000;ooooo00Coo`00o`3jV_oooooo
o`000_ooool00ooo003oooooooooo`09ooooo`;oo`0000?o0?ZJooooooooool00_ooool01?oo003o
0?ZJoooooooo0002ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJool00?l0nYX00oooool00ooo
003oooooooooo`03ooooo`03ool00?l0nY[ooooo00Gooooo00Go0?ZJooooooooooooooooo`3jVP09
ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJool00?l00?oo0?ZJoooooooo0004ooooo`03o`3j
V_oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool00ooo003oooooool00005ooooo`03o`3j
V_oo003o0?ZJ00;ooooo00?oo`00ooooooooool01Oooool01?l0nY[oooooooooool0nYX9ooooo`;o
0?ZJ3Oooool00ooo003o0?ZJo`00o`02ooooo`03o`3jV_oo003ooooo00Gooooo0_l0nYXCooooo`03
o`3jV_oo003ooooo00?ooooo00?oo`00ooooooooool02Oooool00ol0003oooooooooo`11ooooo`00
BOooool01Ol0003ooooooooooooooooo0?ZJ00Gooooo00?o0?ZJooooooooool00_ooool01_l00?oo
oooooooooooo003oooooool000Cooooo00?o0?ZJoooooooo00000_ooool01_l0nY[ooooooooooooo
ooooo`00o`3jVP?ooooo00Go0?ZJool00?ooooooo`00o`3jVP08ooooo`05ool00?l0nY[o0000o`00
0?oo00001?ooool00ooo003oooooo`3jVP04ooooo`04o`3jV_ooooooooooo`00o`Cooooo00Goo`00
ooooool0nY[oo`00o`3jVP03ooooo`04o`3jV_ooooooo`00ool000kooooo1Ol0nYX2ooooo`04ool0
0?oooooo0?ZJool000;ooooo00[o0?ZJool00?oooooo0?ZJoooooooo003o0?ZJoooooooo003o0?ZJ
0oooool01?l00?oooooooooooooo000Yooooo`03o`3jV_oo003oo`0000;ooooo00?o003oool00?oo
00000ol00?l00oooooooo`00ooooo`02o`00o`03o`3jV_ooooooo`0000?ooooo1?l00003ooooo`03
o`00oooooooooooo00;ooooo00?oo`00ooooooooool02?ooool00ol0003oooooooooo`0Xooooo`05
o`000?ooooooooooooooool0nYX01_ooool01ol0nY[oooooo`3jV_l0nY[oooooo`00oooo00000_l0
nYX00ooo003oooooooooo`03ooooo`08o`3jV_oo003oooooo`00ool0nY[oooooo`00oooo0005oooo
o`04o`3jV_oo003oo`00o`3jVPOooooo00?o0?ZJool00?ooool00_ooool00ooo003oooooooooo`0?
ooooo`;o003o2Oooool01?l0nY[oo`00oooooooo000Cooooo`;o003o1_ooool01Ooo003ooooooooo
oooo003o0?ZJ00;ooooo00Goo`00ooooool0nY[oooooo`00o`04ooooo`03ool00?oooooooooo02Co
oooo00?o0?ZJool00?ooool00_ooool00ooo003oooooooooo`0@ooooo`0:o`3jV_ooooooo`00ool0
0?l0nY[oooooo`3jV_ooooooo`00o`3jVPoooooo00?o0000ooooooooool09?ooool00ol0003ooooo
ooooo`08ooooo`03ool00?l0nY[oo`0000;ooooo00Coo`00o`3jV_ooooooo`000_ooool00ooo003o
ooooooooo`09ooooo`;oo`0000?o0?ZJooooooooool00_ooool01?oo003o0?ZJoooooooo0002oooo
o`03ool00?oooooooooo00?ooooo00?o0?ZJool00?l0nYX00oooool00ol0nY[oo`00ooooo`02oooo
o`03ool00?oooooo0?ZJ00Kooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJool00?ooool00_l0nYX00ooo003oooooooooo`02ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01_ooool00ooo003oooooool00005ooooo`06o`3jV_oo003o
ooooo`3jV_ooooooo`001oooool01?l0nY[oooooooooool0nYX9ooooo`;o0?ZJ3Oooool00ooo003o
0?ZJooooo`02ooooo`03o`3jV_oo003ooooo01[ooooo00?o0?ZJool00?ooool00oooool00ooo003o
ooooooooo`09ooooo`03o`000?oooooooooo047ooooo0019ooooo`05o`000?ooooooooooooooool0
nYX01Oooool00ol0nY[oooooooooo`02ooooo`06o`00ooooooooooooool00?ooooooo`001?ooool0
1_l0nY[oooooool00?l00?ooooooo`3jVP?ooooo00?oo`00o`3jV_ooool00oooool01?oo003ooooo
ool00?l0nYX8ooooo`05ool00?l0nY[oo`00o`3jV_oo00000oooool01?oo003oooooo`00ool0nYX4
ooooo`;o0?ZJ00?oooooo`00ooooool00oooool01Ooo003oooooool00?oooooo0?ZJ00Cooooo00?o
0?ZJool00?oo00003oooool2o`3jVP08o`00oooooooooooooooooooo003oooooool00?l0nYX2oooo
o`0:o`3jV_oo003oooooo`3jV_ooooooo`00o`3jV_l00?ooo`00o`3jVP?ooooo00Co003ooooooooo
ooooo`00:Oooool00ol0nY[o0000o`000004ool0000<ooooool00?ooooooo`00ooooooooo`00oooo
ool00?oo0?ZJo`00ooooooooo`001?ooool2o`0000Cooooo00?o003oooooooooool00_ooool00ooo
003oooooooooo`08ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00_ooool00ol0
nY[oooooooooo`03ooooo`07o`3jV_oooooo0?ZJo`3jV_oooooo003oool00002o`3jVP03ool00?oo
oooooooo00?ooooo00So0?ZJoooooooo003o003oo`3jV_oooooo003oool000Gooooo00Co0?ZJool0
0?oo003o0?ZJ1oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooooooo00oooooo0_l00?l9
ooooo`04o`3jV_oo003oo`00o`3jVQ?ooooo0_l00?l6ooooo`05ool00?ooooooooooool00?l0nYX0
0_ooool01Ooo003oooooo`3jV_oooooo003o00Cooooo00?oo`00ooooooooool09?ooool00ol0nY[o
o`00o`3jVP02ooooo`03ool00?oooooooooo013ooooo00Co0?ZJoooooooo003oo`000ol0nYX00ooo
ooooo`00o`3jVP0?ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool00ooo
003o0?ZJool00002ooooo`04ool00?l0nY[oooooool000;ooooo00?oo`00ooooooooool02Oooool2
ool00003o`3jV_oooooooooo00;ooooo00Coo`00o`3jV_ooooooo`000_ooool00ooo003ooooooooo
o`03ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?ooool00_ooool00ooo003oooooo`3j
VP06ooooo`05o`3jV_ooooooooooooooool0nYX02Oooool00ol0nY[oooooooooo`04ooooo`06o`3j
V_oo003oooooo`3jV_oo003o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00?oo`00
oooooooo00001Oooool01_l0nY[oo`00ooooool0nY[oooooool000Sooooo00?o0?ZJooooool0nYX0
2Oooool2o`3jVPgooooo00?oo`00o`3jV_ooool00_ooool00ol0nY[oo`00ooooo`0Jooooo`03o`3j
V_oo003ooooo00?ooooo00?oo`00ooooooooool02Oooool00ol0003oooooooooo`11ooooo`00BOoo
ool2o`0000?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`06o`00oooo
ooooooooool00?l0nY[oo`001?ooool01_l0nY[oooooool00?l00?ooooooo`3jVP?ooooo00?oo`00
ooooooooool00oooool01?l0nY[oo`00ool00?l0nYX8ooooo`06ool00?l0nY[oo`00o`3jV_l00?oo
o`000_ooool00ooo003oooooo`3jVP06ooooo`03o`3jV_oooooo003o00Cooooo00Coo`00o`3jV_oo
003o0?ZJ1Oooool00ol0nY[oo`00ool0000Aooooo`08o`00oooooooooooooooooooo003oooooool0
0?l0nYX2ooooo`03o`3jV_oo003ooooo00;ooooo00Koo`00ooooool0nY[oo`00ooooool0nYX2oooo
o`04o`00ooooooooooooool002Wooooo1?l00002o`00o`Cooooo00Oo003oo`3jV_oo003oooooo`00
ool0nY[ooooo00;oo`001?ooool00ol0nY[o003oool00003ooooo`06o`00oooooooooooooooooooo
003o0?ZJ2Oooool2o`0002[ooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03oooo
o`07o`3jV_oooooo0?ZJo`3jV_oooooo003oool00002o`3jVP03ool00?oooooooooo00?ooooo00So
0?ZJoooooooo003o003oo`3jV_oooooo003oool000Gooooo00Co0?ZJool00?oo003o0?ZJ1oooool0
0ol0nY[oo`00ooooo`02ooooo`03ool00?oooooooooo013ooooo00?o003oooooooooool01oooool0
1?l0nY[oo`00ool00?l0nYXCooooo`;o003o1_ooool01Ol0nY[oo`00oooooooo003o0?ZJ00;ooooo
00Go0?ZJool00?l0nY[oooooo`00o`04ooooo`03ool00?oooooooooo02Cooooo00?o0?ZJool00?l0
nYX00_ooool00ooo003oooooooooo`0@ooooo`0:o`3jV_ooooooo`00o`3jV_oo003oooooo`00oooo
ooooo`00o`3jVPoooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`08ooooo`03o`3j
V_oo003oo`0000;ooooo00Coo`00o`3jV_ooooooo`000_ooool00ooo003oooooooooo`09ooooo`03
o`3jV_oo003o0?ZJ00Cooooo00Coo`00o`3jV_ooooooo`000_ooool00ooo003oooooooooo`03oooo
o`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?ooool00_ooool00ooo003oooooo`3jVP06oooo
o`05o`3jV_ooooooooooooooool0nYX02Oooool00ol0nY[oooooooooo`04ooooo`05o`3jV_oo003o
ooooo`3jV_oo00001_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00?oo`00oooooooo0000
1Oooool01_l0nY[oo`00ooooool0nY[oooooool000Sooooo00?o0?ZJooooool0nYX02Oooool2o`3j
VPgooooo00?oo`00o`3jV_ooool00_ooool00ol0nY[oo`00ooooo`0Jooooo`03o`3jV_oo003ooooo
00?ooooo00?oo`00ooooooooool02Oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003o
ooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool01_l00?oo
oooooooooooo003o0?ZJool000Gooooo00Go0?ZJool00?l00?ooooooo`3jVP03ooooo`03ool00?oo
oooooooo00?ooooo00Co0?ZJool00?oo003o0?ZJ2?ooool01Ooo003o0?ZJool00?l0nY[o003o00Co
o`0000?oooooo`3jV_ooool01_ooool00ol0nY[oooooo`00o`03ooooo`04ool00?l0nY[oo`00o`3j
VPGooooo00?o0?ZJoooooooo00004Oooool02?l00?ooooooooooooooooooo`00o`00oooo003o0?ZJ
0oooool02_oo003oooooooooooooooooo`00ooooool0nY[oo`00ooooool0nYX2ooooo`04o`00oooo
ooooooooool002Wooooo1?l000000ol00?ooooooooooo`04ooooo`03o`3jV_oo003ooooo00;o0?ZJ
00?oooooool00?ooool01?ooool2o`3jVP;oo`000_ooool01_l00?ooooooooooooooooooo`00o`3j
VP[ooooo00?o0000ooooooooool0:?ooool2o`0000?ooooo00?o0?ZJooooooooool00oooool01ol0
nY[oooooo`3jV_l0nY[oooooo`00oooo00000_l0nYX00ooo003oooooooooo`03ooooo`08o`3jV_oo
ooooo`00o`00oooooooo0?ZJoooooooo0005ooooo`04o`3jV_oo003oo`00o`3jVPOooooo00?o0?ZJ
ool00?ooool00_ooool00ooo003oooooooooo`0Jooooo`04o`3jV_ooooooo`00o`3jVQ_ooooo00Go
0?ZJool00?ooooooo`00o`3jVP02ooooo`05o`3jV_oo003o0?ZJooooool00?l01?ooool00ooo003o
ooooooooo`0Tooooo`03o`3jV_oo003o0?ZJ00;ooooo00?oo`00ooooooooool04?ooool02_l0nY[o
ooooool00?l0nY[oo`00ooooool00?ooo`00ooooool0nYX>ooooo`;o00009_ooool2o`0000Wooooo
00?o0?ZJool00?oo00000_ooool01?oo003o0?ZJoooooooo0002ooooo`03ool00?oooooooooo00Wo
oooo00?o0?ZJooooool0nYX01?ooool01?oo003o0?ZJoooooooo0002ooooo`03ool00?oooooooooo
00?ooooo00?o0?ZJool00?l0nYX00oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooo0?ZJ
00Kooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJ
ool00?oooooo0?ZJool00006ooooo`05o`3jV_ooooooooooooooool0nYX02?ooool00ooo003ooooo
ool00005ooooo`06o`3jV_oo003oooooo`3jV_ooooooo`002?ooool00ol0nY[oooooo`3jVP09oooo
o`;o0?ZJ3Oooool00ooo003o0?ZJooooo`02ooooo`03o`3jV_oo003ooooo01[ooooo00?o0?ZJool0
0?ooool00oooool00ooo003oooooooooo`08ooooo`;o0000@oooool004Wooooo00?o0000oooooooo
ool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Ko003oooooool0
0?ooo`00o`3jV_oo0005ooooo`05o`3jV_oo003o003oooooool0nYX00oooool00ooo003ooooooooo
o`03ooooo`04o`3jV_oo003oo`00o`3jVPSooooo00?oo`00o`3jV_oo00000_l0nYX00oooooooo`00
ool00002ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool00?l00oooool01?oo003o0?ZJ
ool00?l0nYX5ooooo`03o`3jV_ooooooo`00017ooooo00So003oooooooooooooooooool00?l0nY[o
o`00o`3jVP?ooooo00[o0?ZJool00?ooooooo`00o`3jV_oooooo0?ZJool00?oooooo0?ZJ0_ooool0
1?l00?oooooooooooooo000Yooooo`03o`3jV_l0003o000000;o003o1Oooool01Ol0nY[o003oool0
0?oooooo0?ZJ00;ooooo00?oo`00ooooooooool00oooool2o`3jVP05oooooooo003oooooooooool0
0?l00oooool00ooo003o0?ZJooooo`09ooooo`03o`000?oooooooooo02Sooooo00?o0000oooooooo
ool00_ooool00ol0nY[oooooooooo`03ooooo`07o`3jV_oooooo0?ZJo`3jV_oooooo003oool00002
o`3jVP03ool00?oooooooooo00?ooooo00So0?ZJoooooooo003o003oooooool0nY[oooooool000Go
oooo00Co0?ZJool00?oooooo0?ZJ1oooool00ol0nY[oo`00ooooo`02ooooo`03ool00?oooooooooo
01[ooooo00Co0?ZJoooooooooooo0?ZJ6oooool01?l0nY[oo`00ool00?l0nYX3ooooo`05o`3jV_oo
003o0?ZJooooool00?l01?ooool00ooo003oooooooooo`0Tooooo`03o`3jV_oo003o0?ZJ00;ooooo
00?oo`00ooooooooool04?ooool02_l0nY[oooooool00?l0nY[oo`00ooooool00?ooo`00ooooool0
nYX?ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool00ol0nY[oo`00ool0
0002ooooo`04ool00?l0nY[oooooool000;ooooo00?oo`00ooooooooool02Oooool00ol0nY[ooooo
o`3jVP04ooooo`04ool00?l0nY[oooooool000;ooooo00?oo`00ooooooooool00oooool00ol0nY[o
o`00o`3jVP03ooooo`03o`3jV_oo003ooooo00;ooooo00?oo`00ooooool0nYX01oooool01?l0nY[o
ooooooooool0nYX9ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJool00?oooooo0?ZJool00006
ooooo`05o`3jV_ooooooooooooooool0nYX02?ooool00ol0nY[oo`00ool00005ooooo`06o`3jV_oo
003oooooo`3jV_ooooooo`002?ooool00ol0nY[oooooo`3jVP0:ooooo`03o`3jV_oooooooooo00_o
oooo00Ooo`00o`3jV_ooooooooooo`3jV_ooooooo`0001_ooooo00?o0?ZJool00?ooool00oooool0
0ooo003oooooooooo`09ooooo`03o`000?oooooooooo047ooooo000kooooo`?o00001?ooool2o`00
00Gooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
00;ooooo00Ko003oooooool00?ooo`00o`3jV_oo0005ooooo`05o`3jV_ooooooo`00ooooool0nYX0
0oooool00ooo003oooooooooo`03ooooo`04o`3jV_oo003oo`00o`3jVPSooooo00Koo`00o`3jV_oo
003oooooo`3jV_l00?l3ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJo`00ooooool00_ooool0
1?oo003o0?ZJool00?l0nYX5ooooo`03o`3jV_oooooo0?ZJ017ooooo00So003ooooooooooooooooo
ool00?l0nY[oo`00o`3jVP?ooooo00[o0?ZJool00?ooooooo`00o`3jV_oooooo0?ZJool00?oooooo
0?ZJ0_ooool01?l00?oooooooooooooo000Yooooo`04o`3jV_oo003o0?ZJo`00o`Kooooo00?o0?ZJ
o`00oooo00000_l0nYX2ooooo`03ool00?oooooooooo00Go0?ZJ00Goooooool00?ooooooooooo`00
o`02ooooo`;oo`0000?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo00;ooooo00?o0?ZJooooooooool00oooool01ol0nY[oooooo`3jV_l0nY[oooooo`00oooo
00000_l0nYX00ooo003oooooooooo`03ooooo`08o`3jV_ooooooo`00ooooool00?oo0?ZJoooooooo
0005ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJool00?l0nYX00_ooool00ooo003ooooooooo
o`0Jooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00Co0?ZJool00?oo003o0?ZJ0oooool01Ol0nY[o
o`00o`3jV_oooooo003o00Cooooo00?oo`00ooooooooool09?ooool00ol0nY[oo`00o`3jVP02oooo
o`03ool00?oooooooooo017ooooo00Wo0?ZJool00?l0nY[oo`00ooooool00?ooo`00ooooool0nYX0
3oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Wooooo0_oo0002ooooo`04ool0
0?l0nY[oooooool000;ooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooo`3jVP04ooooo`04
ool00?l0nY[oooooool000;ooooo00?oo`00ooooooooool00oooool00ol0nY[oo`00ooooo`03oooo
o`03o`3jV_oo003ooooo00;ooooo00?oo`00ooooool0nYX01oooool01?l0nY[oooooooooool0nYX9
ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJool00?oooooo0?ZJool00007ooooo`04o`3jV_oo
ooooooooo`3jVPSooooo00?o0?ZJool00?oo00001Oooool01_l0nY[oo`00ooooool0nY[oooooool0
00Sooooo00?o0?ZJooooool0nYX02_ooool00ol0nY[oooooooooo`0;ooooo`07o`3jV_oo003ooooo
ooooool0nY[oooooool0000Kooooo`03o`3jV_oo003ooooo00?ooooo00?oo`00ooooooooool02Ooo
ool00ol0003oooooooooo`11ooooo`00??ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00;ooooo00Ko003oooooool00?ooo`00o`3jV_oo0005ooooo`09o`3jV_ooooooo`00o`00
oooooooo0?ZJooooool0nY[oo`0000Gooooo00Co0?ZJool00?oo003o0?ZJ2?ooool01_oo003o0?ZJ
ool00?oooooo0?ZJo`00o`?ooooo00?o003oo`3jV_ooool01oooool2o`3jVP?ooooo00Coo`00o`3j
V_oo003o0?ZJ1Oooool00ol0nY[oooooo`3jVP0Aooooo`08o`00oooooooooooooooooooo003o0?ZJ
ool00?l0nYX3ooooo`0:o`3jV_oo003oooooool00?l0nY[oooooo`3jV_oo003oooooo`3jVP;ooooo
00Co003oooooooooooooo`00:Oooool01?l0nY[oo`00ooooool0nYX5ooooo`08o`3jV_oooooooooo
ool00?l0nY[o003ooooooooo0002ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool00ooo003o
ooooo`00o`02ooooo`03ool00?oooooo0?ZJ00[ooooo00?o0000ooooooooool0:?ooool00ol0003o
ooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00Oo0?ZJooooool0nY[o0?ZJo`00oooooooo
o`0000;o0?ZJ00?oo`00ooooooooool00oooool02?l0nY[oooooool00?oooooo003oo`3jV_oooooo
o`001Oooool00ol0nY[oooooo`3jVP09ooooo`05ool00?l0nY[ooooooooooooo00007?ooool01?l0
nY[oooooooooool0nYXKooooo`04o`3jV_oo003oo`00o`3jVP?ooooo00Go0?ZJool00?l0nY[ooooo
o`00o`04ooooo`03ool00?oooooooooo02Cooooo00?o0?ZJool00?l0nYX00_ooool00ooo003ooooo
ooooo`0Aooooo`09o`3jV_oo003o0?ZJool00?oooooo003oool00?oooooo0?ZJ00oooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`09ooooo`;oo`000_ooool01?oo003o0?ZJoooooooo
0002ooooo`03ool00?oooooooooo00Wooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oo`00oooo
oooo0002ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJool00?ooool00oooool00ol0nY[oo`00
ooooo`02ooooo`03ool00?oooooo0?ZJ00Oooooo00Co0?ZJoooooooooooo0?ZJ2Oooool00ol0nY[o
ooooooooo`04ooooo`05o`3jV_oo003oooooo`3jV_oo00001oooool01?l0nY[oooooooooool0nYX8
ooooo`03o`3jV_oo003oo`0000Gooooo00Ko0?ZJool00?oooooo0?ZJoooooooo0008ooooo`03o`3j
V_oooooo0?ZJ00[ooooo00?o0?ZJooooooooool02oooool01ol0nY[oo`00oooooooooooo0?ZJoooo
oooo00006oooool00ol0nY[oo`00ooooo`03ooooo`03ool00?oooooooooo00Wooooo00?o0000oooo
ooooool0@Oooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004oooo
o`;o00000oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Ko003ooooo
ool00?ooo`00o`3jV_oo0005ooooo`09o`3jV_ooooooo`00o`00oooooooo0?ZJooooool0nY[oo`00
00Gooooo00Co0?ZJoooooooooooo0?ZJ2?ooool01Ooo003o0?ZJool00?oooooo0?ZJ00;o003o0_oo
ool00ol0nY[oooooooooo`08ooooo`04o`3jV_ooooooooooooooo`;oo`0000?o0?ZJooooooooool0
1?ooool00ol0nY[oooooo`3jVP0Aooooo`07o`00oooooooooooooooooooo003o0?ZJool00004oooo
o`0<o`3jV_oo003oooooool00?l0nY[oooooo`3jV_ooooooo`00o`3jV_oooooo003o0oooool00ooo
003oooooooooo`0Wooooo`04o`3jV_oo003oooooo`3jVPGooooo00Go0?ZJooooooooooooo`00o`3j
VP02ooooo`04ool00?ooooooooooo`3jVP?ooooo0ol0nYX01?ooooooo`00ool00?l00?l2ooooo`03
ool00?oooooo0?ZJ00Wooooo0_l0000Zooooo`;o00000oooool00ol0nY[oooooooooo`03ooooo`07
o`3jV_oooooo0?ZJo`3jV_l00?ooooooool00002o`3jVP03ool00?oooooooooo00?ooooo00So0?ZJ
oooooooo003oooooo`00ool0nY[oooooool000Gooooo00?o0?ZJooooool0nYX02Oooool01Ooo003o
0?ZJooooooooooooo`0001cooooo00Co0?ZJoooooooooooo0?ZJ6oooool01?l0nY[oo`00ool00?l0
nYX3ooooo`04o`3jV_oo003oooooo`3jVPGooooo00?oo`00ooooooooool09?ooool00ol0nY[oo`00
o`3jVP02ooooo`03ool00?oooooooooo017ooooo0_l0nYX01oooooooo`00ooooool00?ooo`00oooo
ool0nYX03_ooool2o`0002Kooooo0_l0000:ooooo`;oo`000_ooool01?oo003o0?ZJoooooooo0002
ooooo`03ool00?oooooooooo00Wooooo0_l0nYX5ooooo`04o`3jV_oo003o0?ZJool000;ooooo00?o
o`00ooooooooool00oooool00ol0nY[oo`00ooooo`03ooooo`03o`3jV_oo003ooooo00;ooooo00?o
o`00ooooool0nYX01oooool01?l0nY[oooooooooool0nYX9ooooo`03o`3jV_oooooooooo00Cooooo
00Go0?ZJool00?oooooo0?ZJool00007ooooo`04o`3jV_ooooooooooo`3jVPSooooo00?o0?ZJool0
0?oo00001Oooool01_l0nY[oo`00ooooool0nY[oooooool000Sooooo00?o0?ZJooooool0nYX06?oo
ool01ol0nY[oo`00oooooooooooo0?ZJoooooooo00006oooool00ol0nY[oooooool00003ooooo`03
ool00?oooooooooo00Sooooo0_l00013ooooo`00??ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00;ooooo00Ko003oooooool00?ooo`00o`3jV_oo0005ooooo`09o`3jV_oooooo
o`00o`00oooooooo0?ZJooooool0nY[oo`0000Gooooo00Co0?ZJoooooooooooo0?ZJ2?ooool00ooo
003o0?ZJool00002ooooo`05o`3jV_l00?oo003oooooool0nYX02_ooool01?l00?oo0?ZJo`3jV_l0
nYX2ool00003o`3jV_oooooooooo00Gooooo0_l0nYXAooooo`07o`00oooooooooooooooooooo003o
0?ZJool00004ooooo`05o`3jV_ooooooo`00ool00?l0nYX00_ooool01Ol0nY[oo`00o`3jV_oooooo
003o00?ooooo00?oo`00ooooooooool09oooool2o`3jVP;ooooo00Go0?ZJooooooooooooooooo`3j
VP03ooooo`03ool00?l00?oooooo00;oo`0000?oooooo`3jV_l0nYX01?ooool02?l00?oo0?ZJoooo
ooooooooo`00o`00ooooooooo`000_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo
02Sooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`07o`3jV_oooooo0?ZJ
o`3jV_l00?ooooooool00002o`3jVP03ool00?oooooooooo00?ooooo00So0?ZJoooooooo003ooooo
o`00ool0nY[oooooool000Gooooo00?o0?ZJooooool0nYX02Oooool01Ooo003o0?ZJoooooooooooo
o`0001cooooo00Co0?ZJoooooooooooo0?ZJ6oooool01?l0nY[oo`00ool00?l0nYX3ooooo`04o`3j
V_oo003oooooo`3jVPGooooo00?oo`00ooooooooool09?ooool00ol0nY[oo`00o`3jVP02ooooo`03
ool00?oooooooooo017ooooo0_l0nYX00ooooooo0?ZJool00002ool00003o`3jV_oooooooooo00ko
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`09ooooo`;oo`000_ooool01?oo003o
0?ZJoooooooo0002ooooo`03ool00?oooooooooo00[ooooo00?o0?ZJooooooooool00oooool01?l0
nY[oo`00o`3jV_oo0002ooooo`03ool00?l0nY[ooooo00?ooooo00?o0?ZJool00?ooool00oooool0
0ol0nY[oooooool00002ooooo`03ool00?oooooo0?ZJ00Oooooo00Co0?ZJoooooooooooo0?ZJ2Ooo
ool00ol0nY[oooooooooo`04ooooo`05o`3jV_oo003oooooo`3jV_oo00001oooool01?l0nY[ooooo
ooooool0nYX8ooooo`03o`3jV_oo003oo`0000Gooooo00Ko0?ZJool00?oooooo0?ZJoooooooo0008
ooooo`03o`3jV_oooooo0?ZJ01Sooooo00Oo0?ZJool00?ooooooooooo`3jV_ooooooo`0001_ooooo
00?o0?ZJoooooooo00000oooool00ooo003oooooooooo`09ooooo`03o`000?oooooooooo047ooooo
000looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool01_l00?oooooo
o`00oooo003o0?ZJool000Gooooo00Wo0?ZJoooooooo003o003oooooool0nY[oooooo`3jV_oo0000
1Oooool01?l0nY[oooooooooool0nYX8ooooo`03ool00?l0nY[oo`0000;ooooo00Go0?ZJo`00ool0
0?oo003oo`3jVP0;ooooo`03o`00ool0nY[o0?ZJ00;oo`0000?o0?ZJooooooooool01Oooool2o`3j
VQ7ooooo00Co003ooooooooooooooooo0_oo00000ol0nY[oooooooooo`02ooooo`05o`3jV_oooooo
o`00ooooool0nYX00_ooool01Ol0nY[oo`00ooooool0nY[o003o00?ooooo00?oo`00ooooooooool0
9oooool2o`3jVP;ooooo1?l0nYX4ooooo`04ool00?l00?ooo`00ool000;ooooo00?o0?ZJoooooooo
ool01?ooool01?l0nY[oooooooooooooool3ool000;ooooo00?o0?ZJooooooooool02?ooool00ol0
003oooooooooo`0Iooooo`Go00000oooool2o`0000Gooooo00?o0000ooooooooool00_ooool00ol0
nY[oooooooooo`03ooooo`0:o`3jV_oooooo0?ZJo`3jV_l00?ooooooo`3jV_oo003o0?ZJool000Ko
oooo00Oo0?ZJool00?ooooooooooo`3jV_ooooooo`0000Gooooo00?o0?ZJooooool0nYX02Oooool0
1Ooo003o0?ZJooooooooooooo`0001cooooo00Co0?ZJoooooooooooo0?ZJ6oooool01?l0nY[oo`00
ool00?l0nYX3ooooo`04o`3jV_oo003oooooo`3jVPGooooo00?oo`00ooooooooool09?ooool01_l0
nY[oo`00o`3jV_oooooo0?ZJool001?ooooo0_l0nYX01_oooooo0?ZJool00?oo003oooooo`3jVQ3o
oooo00?o0000ooooooooool05oooool3o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo00Wo
oooo0_oo0002ooooo`04ool00?l0nY[oooooool000;ooooo00?oo`00ooooooooool02_ooool00ol0
nY[oooooooooo`03ooooo`04o`3jV_oo003o0?ZJool000;ooooo00?oo`00o`3jV_ooool00oooool0
0ol0nY[oo`00ooooo`03ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00ooooool0nYX01oooool0
1?l0nY[oooooooooool0nYX@ooooo`05o`3jV_oo003oooooo`3jV_oo00001oooool01?l0nY[ooooo
ooooool0nYX8ooooo`03o`3jV_oo003oo`0000Gooooo00Ko0?ZJool00?oooooo0?ZJoooooooo0009
ooooo`;o0?ZJ6?ooool01ol0nY[oo`00oooooooooooo0?ZJoooooooo00006oooool00ol0nY[ooooo
ool00003ooooo`03ool00?oooooooooo00Wooooo00?o0000ooooooooool0@Oooool003_ooooo0_l0
0004ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Ko003oooooool00?ooo`00o`3jV_oo0006oooo
o`08o`3jV_oo003o003oooooool0nY[oooooool00?l0nYX5ooooo`03o`3jV_oooooo0?ZJ00Wooooo
00?oo`00o`3jV_oo00000_ooool2o`3jVP;o003o00?o0?ZJooooooooool02Oooool00ol00?oooooo
ooooo`02ool00003o`3jV_oooooooooo00Gooooo0_l0nYXBooooo`03o`00oooooooooooo00;oo`00
00?o0?ZJooooooooool00_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Go0?ZJool00?oo
oooo0?ZJo`00o`03ooooo`03ool00?oooooooooo02Oooooo0_l0nYX:ooooo`;o000000Goo`00oooo
ooooooooooooo`3jVP06ooooo`;o0?ZJ0_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0000ooooooooool06_ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`0:o`3j
V_oooooo0?ZJo`3jV_l00?ooooooo`3jV_oo003o0?ZJool000Kooooo00Oo0?ZJool00?oooooooooo
o`3jV_ooooooo`0000Gooooo00?o0?ZJooooool0nYX02Oooool01Ooo003o0?ZJooooooooooooo`00
01cooooo00Co0?ZJoooooooooooo0?ZJ6oooool01?l0nY[oooooooooool0nYX3ooooo`04o`3jV_oo
003oooooo`3jVPGooooo00?oo`00ooooooooool09?ooool01_l0nY[oo`00o`3jV_oooooo0?ZJool0
01?ooooo0_l0nYX01_oooooo0?ZJo`00ool00?ooooooo`3jVQ3ooooo00?o0000ooooooooool05_oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`09ooooo`;oo`000_ooool01?oo003o0?ZJoooooooo0002ooooo`03ool00?oooooooooo
013ooooo00Co0?ZJool00?l0nY[oo`000_ooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003o
oooo00?ooooo00?o0?ZJoooooooo00000_ooool00ooo003oooooo`3jVP08ooooo`03o`3jV_oooooo
0?ZJ013ooooo00Go0?ZJool00?oooooo0?ZJool00008ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o
0?ZJool00?oo00001Oooool01_l0nY[oooooool00?l0nY[oooooool000Wooooo0_l0nYXHooooo`07
o`3jV_oo003o0?ZJooooool0nY[oooooool0000Kooooo`03o`3jV_ooooooo`0000?ooooo00?oo`00
ooooooooool02Oooool00ol0003oooooooooo`11ooooo`00??ooool00ol0003oooooooooo`03oooo
o`;o00001Oooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool00oooool2o`00o`03ool00?l0nY[oo`0000Kooooo00So0?ZJool00?oooooo003oo`3jV_oo
ooooo`00o`3jVPGooooo00?o0?ZJooooool0nYX02Oooool00ooo003o0?ZJool00003ooooo`03o`3j
V_oooooo0?ZJ00cooooo00Co003oooooool0003o00000_l0nYX7ooooo`;o0?ZJ4_ooool00ol00?oo
ooooooooo`02ool00003o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool01Ol0
nY[oo`00ooooool0nY[o003o00?ooooo00?oo`00ooooooooool09oooool2o`3jVPWooooo1?l00002
ooooo`03o`3jV_oooooooooo00Gooooo00Go003oo`3jV_ooooooooooo`00o`04ooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`04o`3j
V_oooooo0?ZJo`3jVP;ooooo00Co0?ZJool00?l0nY[oo`001_ooool01ol0nY[oo`00oooooooooooo
0?ZJoooooooo00001Oooool00ol0nY[oooooo`3jVP09ooooo`05ool00?l0nY[ooooooooooooo0000
7?ooool01?l0nY[oooooooooool0nYXKooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJool0
0?l0nYX01Oooool00ooo003oooooooooo`0Tooooo`06o`3jV_oo003o0?ZJooooool0nY[oo`004ooo
ool2o`3jVP03ooooool0nY[o003o00;ooooo00?o0?ZJooooooooool03_ooool00ol0003ooooooooo
o`0Jooooo`04o`000?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`00000;ooooo`;o
o`000_ooool01?oo003o0?ZJoooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co0?ZJool0
0?ooooooo`000_ooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJ
oooooooo00000_ooool00ooo003oooooo`3jVP08ooooo`03o`3jV_oooooo0?ZJ013ooooo00Go0?ZJ
ool00?oooooo0?ZJool00008ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooool0nYX01Ooo
ool01_l0nY[oooooool00?l0nY[oooooool000Wooooo0_l0nYXHooooo`07o`3jV_oo003o0?ZJoooo
ool0nY[oooooool0000Looooo`03o`3jV_oo003ooooo00;ooooo00?oo`00ooooooooool02Oooool0
0ol0003oooooooooo`11ooooo`00BOooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool00oooool2o`00o`03ool00?l0nY[oo`0000Kooooo00So0?ZJoooo
oooo003o003oo`3jV_ooooooo`00o`3jVPGooooo00?o0?ZJooooool0nYX02Oooool00ooo003o0?ZJ
ool00003ooooo`?o0?ZJ3?ooool00ol00?oo0000o`000002o`0000Wooooo00?o0?ZJooooooooool0
4?ooool00ol00?ooooooooooo`02ool00003o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo
0?ZJ0_ooool01Ol0nY[oo`00ooooool0nY[o003o00?ooooo00?oo`00ooooooooool09oooool2o`3j
VPWooooo1?l00002ooooo`03o`3jV_oooooooooo00Gooooo00Go003oo`3jV_ooooooooooo`00o`04
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00?o0000ooooooooool00_ooool2o`0000?ooooo00?o0?ZJooooooooool00ooo
ool01?l0nY[oooooo`3jV_l00?l2ooooo`04o`3jV_oo003o0?ZJool000Kooooo00Oo0?ZJool00?oo
ooooooooo`3jV_ooooooo`0000Gooooo00?o0?ZJooooool0nYX02Oooool01Ooo003o0?ZJoooooooo
ooooo`0001gooooo00?o0?ZJooooool0nYX06oooool01?l0nY[oooooooooool0nYX4ooooo`03o`3j
V_oo003o0?ZJ00Gooooo00?oo`00ooooooooool09Oooool01Ooo003o0?ZJooooool0nY[oo`0001?o
oooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00cooooo0ol0000Looooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo0ol00009ooooo`;oo`000_ooool0
1?oo003o0?ZJoooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co0?ZJool00?ooooooo`00
0_ooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00?ooooo00Go0?ZJoooooooo003o
ooooool00002ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool0nYX04?ooool01Ol0nY[o
o`00ooooool0nY[oo`0000Sooooo00?o0?ZJooooool0nYX02?ooool00ol0nY[oooooo`3jVP06oooo
o`05o`3jV_oo003o0?ZJoooooooo00002Oooool2o`3jVQSooooo00Oo0?ZJool00?l0nY[oooooo`3j
V_oo003o0?ZJ01cooooo00?o0?ZJool00?ooool00_ooool00ooo003oooooooooo`07ooooo`?o0000
@oooool004Wooooo0_l00003ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00ooo
ool2o`00o`03ool00?l0nY[oo`0000Kooooo00So0?ZJoooooooo003o003oo`3jV_ooooooo`00o`3j
VPKooooo0_l0nYX9ooooo`03ool00?l0nY[oo`0001;ooooo00?o003oo`000?l000000_l00009oooo
o`03o`3jV_oooooooooo013ooooo00?o003oooooooooool00_oo00000ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooo0?ZJ00?ooooo00Go0?ZJool00?oooooo0?ZJo`00o`03ooooo`03ool00?oooooo
oooo02Sooooo00?o0?ZJooooooooool02?ooool2o`0000;ooooo0_l0nYX7ooooo`04o`00ool0nY[o
ooooo`00o`Gooooo00?o0?ZJooooooooool01oooool2o`0001_ooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00?ooooo00Co0?ZJool00?l0nY[oo`001_ooool01ol0
nY[oooooool00?oooooo0?ZJoooooooo00001_ooool2o`3jVPWooooo00Goo`00o`3jV_oooooooooo
ool0000Mooooo`03o`3jV_oooooo0?ZJ01_ooooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[o
o`00o`3jVP05ooooo`03ool00?oooooooooo02Gooooo00Goo`00o`3jV_ooooooo`00o`3jVP0Coooo
o`;o0?ZJ00?oooooo`3jV_ooool00_ooool00ol0nY[oooooooooo`0>ooooo`03o`000?oooooooooo
01Kooooo1?l00003ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool02Oooool2
ool000;ooooo00Coo`00o`3jV_ooooooo`000_ooool00ooo003oooooooooo`0@ooooo`04o`3jV_oo
003oooooool000;ooooo00?oo`00o`3jV_ooool00oooool00ol0nY[oo`00ooooo`03ooooo`05o`3j
V_ooooooo`00oooooooo00000_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ013o
oooo00Go0?ZJool00?oooooo0?ZJool00009ooooo`;o0?ZJ2?ooool00ol0nY[oooooo`3jVP06oooo
o`05o`3jV_oo003o0?ZJoooooooo00002Oooool2o`3jVQSooooo00Oo0?ZJool00?l0nY[oooooo`3j
V_oo003o0?ZJ01cooooo00?o0?ZJool00?ooool00_ooool00ooo003oooooooooo`09ooooo`03o`00
0?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`03ooooo`05o`00ooooooooo`00o`3jV_oo00001_ooool02?l0nY[ooooo
ool00?l00?ooooooo`3jV_oo003o0?ZJ1_ooool2o`3jVPWooooo00?oo`00o`3jV_oo00004oooool0
0ol00?oo0000o`00000Mooooo`03o`00oooooooooooo00;oo`001_ooool00ol0nY[oooooo`3jVP03
ooooo`05o`3jV_ooooooo`00o`3jV_l00?l00oooool00ooo003oooooooooo`0Xooooo`03o`3jV_oo
oooooooo00Wooooo00Co0?ZJoooooooooooo0?ZJ2?ooool01?l00?ooooooo`3jV_l00?l4ooooo`;o
0?ZJ2_ooool00ol0003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`03ooooo`04o`3jV_oo003o0?ZJool000Kooooo00Oo0?ZJoooooooo003ooooo
o`3jV_ooooooo`0000Kooooo0_l0nYX9ooooo`05ool00?l0nY[ooooooooooooo00007Oooool00ol0
nY[oooooo`3jVP0Kooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJool00?l0nYX01Oooool0
0ooo003oooooooooo`0Uooooo`05ool00?l0nY[oooooool00?l0nYX04oooool2o`3jVP;ooooo00?o
0?ZJooooool0nYX04Oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00000oooool00ol0003oooooooooo`09ooooo`;oo`000_ooool01?l0nY[oo`00
oooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co0?ZJool00?ooooooo`000_ooool00ooo
003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00Cooooo00Co0?ZJool00?ooooooo`000_ooool0
0ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ013ooooo00Go0?ZJoooooooo003o0?ZJool0
0009ooooo`;o0?ZJ2?ooool00ol0nY[oooooo`3jVP06ooooo`05o`3jV_oo003o0?ZJoooooooo0000
2Oooool2o`3jVQSooooo00Oo0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ01cooooo00?o0?ZJool0
0?ooool00_ooool00ooo003oooooooooo`09ooooo`03o`000?oooooooooo047ooooo0019ooooo`03
o`000?oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`05
o`00ooooooooo`00o`3jV_oo00001_ooool01ol0nY[oooooool00?l00?ooooooo`3jV_oo00001ooo
ool2o`3jVPWooooo00?o0?ZJool00?oo00004oooool2o`00oaoooooo00Co003ooooooooo003o0?ZJ
1_ooool00ol0nY[oooooo`3jVP03ooooo`05o`3jV_ooooooo`00ooooool0nYX00oooool00ooo003o
ooooooooo`0Xooooo`03o`3jV_oooooooooo00Wooooo1?l0nYX8ooooo`04o`00oooooooo0?ZJo`00
o`Cooooo00?o0?ZJooooooooool02Oooool00ol0003oooooooooo`0Jooooo`?o00001?ooool2o`00
00Gooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00?ooooo00Co0?ZJool00?l0nY[oo`001_ooool01ol0nY[oooooool00?oooooo0?ZJoooooooo0000
1_ooool2o`3jVPWooooo00Goo`00o`3jV_ooooooooooool0000Mooooo`03o`3jV_oooooo0?ZJ01co
oooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oo`00ooooool0nYX4ooooo`03ool00?oooooooooo
02Gooooo00Goo`00o`3jV_ooooooo`00o`3jVP0Cooooo`;o0?ZJ0_ooool00ol0nY[oooooo`3jVP0A
ooooo`03o`000?oooooooooo01Kooooo1Ol00003ooooo`;o00001?ooool00ol0003oooooooooo`09
ooooo`;oo`000_ooool01?l0nY[oo`00oooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co
0?ZJool00?ooooooo`000_ooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00Cooooo
00Co0?ZJoooooooo003oo`000_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ017o
oooo00Co0?ZJool00?ooooooo`002Oooool2o`3jVPSooooo00?o0?ZJooooool0nYX01_ooool01Ol0
nY[oo`00o`3jV_ooooooo`0000Wooooo0_l0nYXHooooo`07o`3jV_oo003o0?ZJooooool0nY[oo`00
o`3jVP0Looooo`03o`3jV_oo003ooooo00;ooooo00?oo`00ooooooooool02Oooool00ol0003ooooo
ooooo`11ooooo`00BOooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool01Oooool00ooo003o0?ZJool00006ooooo`07o`3jV_ooooooo`00o`00oooooooo
0?ZJool00007ooooo`;o0?ZJ2Oooool00ol0nY[oo`00ool0000Cooooo`;o003o7oooool01?l00?oo
ooooool00?l0nYX7ooooo`;o0?ZJ0oooool01Ol0nY[oooooool00?oooooo0?ZJ00?ooooo00?oo`00
ooooooooool0:?ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ2Oooool01?l00?ooooooo`3jV_l0
0?l4ooooo`03o`3jV_oooooooooo00Wooooo00?o0000ooooooooool0:?ooool2o`0000?ooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_oo003o0?ZJool000Kooooo
00?o0?ZJoooooooo00000_ooool00ol0nY[oo`00ooooo`05ooooo`;o0?ZJ2Oooool01Ooo003o0?ZJ
ooooooooooooo`0001gooooo0_l0nYXMooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co0?ZJool00?oo
oooo0?ZJ1?ooool00ooo003oooooooooo`0Uooooo`05ool00?l0nY[oooooool00?l0nYX04oooool2
o`3jVP;ooooo00?o0?ZJooooool0nYX04?ooool2o`0002Kooooo0_l0000:ooooo`;oo`000_ooool0
1?l0nY[oo`00oooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co0?ZJool00?ooooooo`00
0_ooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00Cooooo00Co0?ZJoooooooo003o
o`000_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ017ooooo00Co0?ZJool00?oo
ooooo`002_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Go0?ZJool0
0?l0nY[oooooool0000:ooooo`03o`3jV_oooooooooo01Kooooo00Oo0?ZJool00?l0nY[oooooo`3j
V_oo003o0?ZJ01cooooo00?o0?ZJoooooooo00000_ooool00ooo003oooooooooo`08ooooo`;o0000
@oooool004Wooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00Gooooo00?oo`00o`3jV_oo00001_ooool01ol0nY[oooooool00?l00?ooooooo`3jV_oo
00001oooool2o`3jVPWooooo00?o0?ZJool00?oo00004oooool2o`00oaoooooo00Co003oo`000?l0
003o0?ZJ1oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?oo`00
ooooooooool0:?ooool00ol0nY[oooooooooo`0Eooooo`;o003o00?oooooo`3jV_ooool00oooool0
0ol0nY[oooooooooo`09ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00_ooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJool00?l0nY[oo`001_oo
ool00ol0nY[oooooool00002ooooo`03o`3jV_oo003ooooo00Gooooo0_l0nYX9ooooo`05ool00?l0
nY[ooooooooooooo00007Oooool2o`3jVQgooooo00?o0?ZJooooool0nYX01?ooool01?l0nY[oo`00
ooooool0nYX4ooooo`03ool00?oooooooooo02Gooooo00Goo`00o`3jV_ooooooo`00o`3jVP0Doooo
o`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ4Oooool00ol0003oooooooooo`0Tooooo`03o`000?oo
oooooooo00Wooooo0_oo0002ooooo`04o`3jV_oo003oooooool000;ooooo00?oo`00ooooooooool0
4?ooool01?l0nY[oo`00oooooooo0002ooooo`03ool00?l0nY[ooooo00?ooooo00?o0?ZJool00?oo
ool01?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool0
nYX04Oooool01?l0nY[oo`00oooooooo000Cooooo`03o`3jV_oooooo0?ZJ00Kooooo00Go0?ZJool0
0?l0nY[oooooool0000:ooooo`03o`3jV_oooooooooo01Kooooo00Oo0?ZJool00?l0nY[oooooo`3j
V_oo003o0?ZJ01cooooo00?o0?ZJoooooooo00000_ooool00ooo003oooooooooo`09ooooo`03o`00
0?oooooooooo047ooooo0019ooooo`;o00000oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00Gooooo00?oo`00o`3jV_oo00001_ooool01ol0nY[oooooool00?l00?ooooooo`3jV_oo
00001oooool2o`3jVPWooooo00?o0?ZJool00?oo0000=?ooool4o`0000gooooo00Co0?ZJool00?oo
oooo0?ZJ0oooool00ooo003oooooooooo`0Xooooo`03o`3jV_oooooooooo01Kooooo00?o003ooooo
ool0nYX00oooool00ol0nY[oooooooooo`09ooooo`;o0000:_ooool00ol0003oooooooooo`02oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oo`00o`3jV_oo0006
ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJool00?ooool01Oooool2o`3jVPWooooo00Goo`00
o`3jV_ooooooooooool0000Nooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX01?oo
ool01?l0nY[oo`00ooooool0nYX4ooooo`03ool00?oooooooooo02Gooooo00Goo`00o`3jV_oooooo
o`00o`3jVP0Dooooo`04o`3jV_ooooooooooooooo`;o0?ZJ4Oooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo00Wooooo0_oo0002ooooo`04o`3jV_oo003oooooool000;ooooo00?oo`00
ooooooooool04?ooool01?l0nY[oo`00oooooooo0002ooooo`03ool00?l0nY[ooooo00?ooooo00?o
0?ZJool00?ooool01?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Oooooo0_l0
nYXAooooo`04o`3jV_oo003oooooool001?ooooo00?o0?ZJooooool0nYX01_ooool01Ol0nY[oo`00
o`3jV_ooooooo`0000[ooooo00?o0?ZJooooooooool05_ooool01ol0nY[oo`00o`3jV_oooooo0?ZJ
ool00?l0nYX07?ooool00ol0nY[oooooool00002ooooo`03ool00?oooooooooo00Wooooo00?o0000
ooooooooool0@Oooool004Wooooo00?o0000ooooooooool00oooool01Ol0nY[ooooooooooooooooo
0?ZJ00Oooooo00?oo`00o`3jV_oo00001_ooool01ol0nY[oooooool00?oooooo003oool00?l0nYX0
4_ooool00ol0nY[oo`00ool0000dooooo`Co00003Oooool01?l0nY[oo`00ooooool0nYX3ooooo`03
ool00?oooooooooo02Sooooo00?o0?ZJooooooooool05_ooool01?l00?ooooooo`3jV_l0nYX2oooo
o`03o`3jV_oooooooooo00[ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`02oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oo`00o`3jV_oo0006
ooooo`03o`3jV_ooooooo`0000;ooooo00?o0?ZJool00?ooool01Oooool2o`3jVPWooooo00Goo`00
o`3jV_ooooooooooool0000looooo`;o0?ZJ1Oooool01?l0nY[oo`00ooooool0nYX4ooooo`03ool0
0?oooooooooo02Gooooo00Goo`00o`3jV_ooooooo`00o`3jVP0Dooooo`03o`3jV_oooooooooo01Co
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`09ooooo`;oo`000_ooool01?l0nY[o
o`00oooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co0?ZJool00?ooooooo`000_ooool0
0ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00Cooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`07ooooo`;o0?ZJ4Oooool01?l0nY[oo`00oooooooo000Cooooo`03o`3jV_oo
oooo0?ZJ00Kooooo00Go0?ZJool00?l0nY[oooooool0000:ooooo`03o`3jV_oooooooooo01Kooooo
00Oo0?ZJool00?l0nY[oooooo`3jV_oo003o0?ZJ01cooooo00Ko0?ZJoooooooo003oooooool00?l0
nYX;ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Go0?ZJ
ooooooooooooooooo`3jVP07ooooo`03ool00?l0nY[oo`0000Oooooo00Ko0?ZJool00?oooooo003o
ool00?l0nYXBooooo`03o`3jV_oo003oo`0003Gooooo0_l0000>ooooo`04o`3jV_oo003oooooo`3j
VP?ooooo00?oo`00ooooooooool0:?ooool00ol0nY[oooooooooo`0Fooooo`05o`00oooooooo003o
o`3jV_ooool00_l0nYX<ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00_ooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJool00?l0nY[oo`001ooo
ool01_l0nY[oo`00oooooooooooo0?ZJool000Kooooo00?o0?ZJooooooooool02?ooool01Ooo003o
0?ZJooooooooooooo`0003cooooo0_l0nYX5ooooo`04o`3jV_oo003oooooo`3jVPCooooo00?oo`00
ooooooooool09Oooool01Ooo003o0?ZJoooooooo003o0?ZJ01Cooooo00?o0?ZJooooooooool05?oo
ool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Wooooo0_oo0002ooooo`04o`3jV_oo
003oooooool000;ooooo00?oo`00ooooooooool04?ooool01?l0nY[oo`00oooooooo0002ooooo`03
ool00?l0nY[ooooo00?ooooo00?o0?ZJool00?ooool01?ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Sooooo0_l0nYXAooooo`04o`3jV_oo003oooooool001Cooooo0_l0nYX6oooo
o`05o`3jV_oo003o0?ZJoooooooo00002_ooool00ol0nY[oooooooooo`0Gooooo`06ool00?l0nY[o
0?ZJoooooooo003o0?ZJ7?ooool01_l0nY[oooooool00?ooooooo`00o`3jVP_ooooo00?o0000oooo
ooooool0@Oooool004Wooooo00?o0000ooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ
00Oooooo00?o0?ZJool00?oo00001oooool01?l0nY[oo`00ooooool00?l2o`0001;ooooo00?o0?ZJ
ool00?oo0000=Oooool00ol00?ooooooooooo`0=ooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?o
o`00ooooooooool0:?ooool00ol0nY[oooooooooo`0Fooooo`?o003o00?oooooo`3jV_l0nYX03Ooo
ool00ol0003oooooooooo`0Xooooo`;o00000oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo00?ooooo00Co0?ZJool00?l0nY[oo`001oooool01_l0nY[oo`00oooooooooooo0?ZJool0
017ooooo00Goo`00o`3jV_ooooooooooool0000looooo`;o0?ZJ1Oooool01?l0nY[oo`00ooooool0
nYX4ooooo`03ool00?oooooooooo02Gooooo00Goo`00ooooool0nY[oo`00o`3jVP0Dooooo`03o`3j
V_oooooooooo01?ooooo0_l0000Vooooo`;o00002_ooool02?oo003o0?ZJoooooooooooo0?ZJool0
0?ooooooo`000_ooool00ooo003oooooooooo`0@ooooo`04o`3jV_oo003oooooool000;ooooo00?o
o`00o`3jV_ooool00oooool00ol0nY[oo`00ooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool02?ooool2o`3jVQ7ooooo00Co0?ZJool00?ooooooo`005?ooool2o`3jVPKooooo
00Go0?ZJool00?l0nY[oooooool0000Tooooo`06ool00?oooooo0?ZJoooooooo003o0?ZJ7?ooool0
1_l0nY[oooooool00?ooooooo`00o`3jVP[ooooo0_l00013ooooo`00BOooool00ol0003ooooooooo
o`03ooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol0nY[oo`00ool00007ooooo`03o`3j
V_oo003ooooo00Co00004Oooool00ol0nY[oo`00ool00015ooooo`04o`3jV_oo003oooooo`3jVP?o
oooo00?oo`00ooooooooool0@_ooool00ol00?ooooooooooo`0?ooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?o
oooo00Co0?ZJool00?l0nY[oo`001oooool01_l0nY[oo`00oooooooooooo0?ZJool0017ooooo00Go
o`00o`3jV_ooooooooooool0000looooo`;o0?ZJ1_ooool00ooo003oooooo`3jVP04ooooo`03ool0
0?oooooooooo02Gooooo00Go0?ZJool00?l0nY[oo`00o`3jVP0Dooooo`03o`3jV_oooooooooo01Co
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0_ooool01?l0nY[o
o`00oooooooo0002ooooo`03ool00?oooooooooo013ooooo00Co0?ZJool00?ooooooo`000_ooool0
0ooo003o0?ZJooooo`03ooooo`03o`3jV_oo003ooooo00Cooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`08ooooo`;o0?ZJ4Oooool01?l0nY[oo`00oooooooo000Dooooo`;o0?ZJ1_oo
ool01Ol0nY[oo`00o`3jV_ooooooo`0002Cooooo00Koo`00ooooooooooooooooool00?l0nYXLoooo
o`03o`3jV_oooooooooo00;oo`0000?o0?ZJooooooooool02Oooool00ol0003oooooooooo`11oooo
o`00BOooool00ol0003oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol0
nY[oo`00ool00007ooooo`03o`3jV_ooooooo`0000Co00004Oooool00ol0nY[oo`00ool00015oooo
o`04o`3jV_oo003o003oo`3jVP?ooooo00?oo`00ooooooooool0E?ooool00ol0003oooooooooo`0X
ooooo`03o`000?oooooooooo00;ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03
ooooo`04o`3jV_oo003o0?ZJool000Oooooo00Ko0?ZJool00?ooooooooooo`3jV_oo000Aooooo`05
ool00?l0nY[ooooooooooooo0000?Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo003o0?ZJ
00Cooooo00?oo`00ooooooooool09Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ01Cooooo00?o0?ZJ
ooooooooool05?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Wooooo0_l0nYX2
ooooo`04o`3jV_oo003oooooool000;ooooo00?oo`00ooooooooool04Oooool00ooo003oooooool0
0002ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJool00?ooool01?ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool03oooool01?l0nY[oo`00oooo
oooo000Dooooo`;o0?ZJ1_ooool01Ol0nY[oo`00ooooool0nY[oo`0002Cooooo00Koo`00oooooooo
ooooooooool00?l0nYXLooooo`03o`3jV_oooooooooo00;oo`0000?o0?ZJooooooooool02Oooool0
0ol0003oooooooooo`11ooooo`00BOooool2o`0000Cooooo00Go0?ZJooooooooooooooooo`3jVP07
ooooo`03o`3jV_oo003oo`0000Oooooo00Co0?ZJoooooooo003o003o0_l0000Booooo`03o`3jV_oo
003oo`0004Gooooo00Co0?ZJo`00oooo003o0?ZJ0oooool00ooo003oooooooooo`1Cooooo`;o0000
:_ooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
0oooool01?l0nY[oo`00o`3jV_oo0007ooooo`06o`3jV_oo003oooooooooool0nY[oo`004Oooool0
1Ooo003o0?ZJooooooooooooo`0004Cooooo00?o0?ZJool00?l0nYX01?ooool00ooo003ooooooooo
o`0Uooooo`05o`3jV_oo003o0?ZJool00?l0nYX05?ooool00ol0nY[oooooooooo`0Dooooo`03o`00
0?oooooooooo02Cooooo00?o0000ooooooooool02Oooool2o`3jVP;ooooo00Co0?ZJool00?oooooo
o`000_ooool00ooo003oooooooooo`0Aooooo`03ool00?ooooooo`0000;ooooo00?o0?ZJool00?oo
ool00oooool00ol0nY[oo`00ooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool06oooool01?l0nY[oo`00oooooooo000Dooooo`;o0?ZJ1_ooool01Ol0nY[oo`00ooooool0nY[o
o`0002Cooooo00Koo`00ooooooooooooooooool00?l0nYXLooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool02Oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003ooooooooo
o`03ooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol0nY[oo`00ool00007ooooo`05o`3j
V_ooooooo`00oooooooo00004oooool00ol0nY[oo`00ool00016ooooo`04o`3jV_oo003oooooo`3j
VP;ooooo00?oo`00ooooooooool0E?ooool00ol0003oooooooooo`0Xooooo`;o00000oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00o`3jV_oo00001oooool01_l0
nY[oo`00oooooooooooo0?ZJool0017ooooo00Goo`00o`3jV_ooooooooooool00014ooooo`03o`3j
V_oo003o0?ZJ00Cooooo00?oo`00ooooooooool09Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ02[o
oooo0_l0000Vooooo`;o00002_ooool2o`3jVP;ooooo00Co0?ZJool00?ooooooo`000_ooool00ooo
003oooooooooo`0Aooooo`03ool00?ooooooo`0000;ooooo00?o0?ZJool00?ooool00oooool00ol0
nY[oo`00ooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06oooool01?l0
nY[oo`00oooooooo000Dooooo`;o0?ZJ1_ooool01Ol0nY[oo`00ooooool0nY[oo`0002Cooooo00Ko
o`00ooooooooooooooooool00?l0nYXLooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool02?ooool2o`0004?ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Go0?ZJoooooooooooo
ooooo`3jVP07ooooo`03o`3jV_oo003oo`0000Oooooo00Go0?ZJoooooooo003oooooool0000Coooo
o`03o`3jV_oo003oo`0004Kooooo00Co0?ZJool00?oooooo0?ZJ0_ooool00ooo003oooooooooo`1D
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00_ooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00o`3jV_oo00001oooool01_l0nY[oo`00oooooooo
oooo0?ZJool0017ooooo00Goo`00o`3jV_ooooooooooool00014ooooo`04o`3jV_oo003oooooo`3j
VP?ooooo00?oo`00ooooooooool09Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ02_ooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool00ooo003oooooool00002
ooooo`03ool00?oooooooooo017ooooo00?oo`00oooooooo00000_ooool00ol0nY[oo`00ooooo`03
ooooo`03o`3jV_oo003ooooo00Gooooo00Go0?ZJooooooooooooooooo`3jVP0Mooooo`04o`3jV_oo
003oooooool001Cooooo0_l0nYX6ooooo`05o`3jV_oo003oooooo`3jV_oo00009?ooool01_oo003o
ooooooooooooooooo`00o`3jVQcooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`09
ooooo`03o`000?oooooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Go0?ZJoooo
ooooooooooooo`3jVP07ooooo`03o`3jV_oo003oo`0000Oooooo00Go0?ZJoooooooo003oooooool0
000Cooooo`03o`3jV_oo003oo`0004Kooooo00Co0?ZJool00?oooooo0?ZJ0_ooool00ooo003ooooo
ooooo`1Dooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00oooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00o`3jV_oo00001oooool01_l0nY[oo`00
oooooooooooo0?ZJool0017ooooo00Go0?ZJool00?ooooooooooool00014ooooo`04o`3jV_oo003o
ooooo`3jVP?ooooo00?oo`00ooooooooool09Oooool01Ol0nY[oo`00o`3jV_oo003o0?ZJ02_ooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool00ooo003ooooo
ool00002ooooo`03ool00?oooooooooo017ooooo00?oo`00oooooooo00000_ooool00ol0nY[oo`00
ooooo`03ooooo`03o`3jV_oo003ooooo00Gooooo00Go0?ZJooooooooooooooooo`3jVP0Mooooo`04
o`3jV_oo003oooooool001Gooooo00?o0?ZJooooooooool01?ooool01Ol0nY[oo`00ooooool0nY[o
o`0002Cooooo00Koo`00ooooooooooooooooool00?l0nYXLooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool02Oooool00ol0003oooooooooo`11ooooo`00BOooool00ol0003ooooooooo
o`03ooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol0nY[oo`00ool00007ooooo`05o`3j
V_ooooooo`00oooooooo00004oooool00ol0nY[oo`00ool00016ooooo`04o`3jV_oo003oooooo`3j
VP;ooooo00?oo`00ooooooooool0E?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03ool00?l0nY[oo`00
00Oooooo00Ko0?ZJool00?ooooooooooo`3jV_oo000Aooooo`05o`3jV_oo003ooooooooooooo0000
A?ooool01?l0nY[oo`00ooooool0nYX3ooooo`03ool00?oooooooooo02Gooooo00Go0?ZJool00?l0
nY[oo`00o`3jVP0[ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02Oooool2o`3j
VP?ooooo00?oo`00oooooooo00000_ooool00ooo003oooooooooo`0Aooooo`03o`3jV_oo003o0?ZJ
00;ooooo00?o0?ZJool00?ooool00oooool00ol0nY[oo`00ooooo`05ooooo`05o`3jV_oooooooooo
ooooool0nYX07Oooool01?l0nY[oo`00oooooooo000Looooo`05o`3jV_oo003oooooo`3jV_oo0000
9?ooool01_oo003oooooooooooooooooo`00o`3jVQcooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`09ooooo`03o`000?oooooooooo047ooooo0019ooooo`;o00001?ooool01Ol0nY[o
oooooooooooooooo0?ZJ00Oooooo00?o0?ZJool00?oo00001oooool01Ol0nY[oooooool00?oooooo
o`0001?ooooo00?o0?ZJool00?oo0000A_ooool01?l0nY[oo`00ooooool0nYX2ooooo`03ool00?oo
oooooooo05?ooooo0_l0000Zooooo`03o`000?oooooooooo00?ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`04ooooo`03ool00?l0nY[oo`0000Oooooo00Ko0?ZJool00?oooooooooo
o`3jV_oo000Aooooo`05o`3jV_oo003ooooooooooooo0000A?ooool01?l0nY[oo`00ooooool0nYX3
ooooo`03ool00?oooooooooo02Gooooo00Go0?ZJool00?ooooooo`00o`3jVP0[ooooo`03o`000?oo
oooooooo02Cooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo00?oo`00oooooooo00000_oo
ool00ooo003oooooooooo`0Aooooo`03o`3jV_oo003o0?ZJ00;ooooo00?o0?ZJool00?ooool00ooo
ool00ol0nY[oo`00ooooo`05ooooo`05o`3jV_ooooooooooooooool0nYX07Oooool01?l0nY[oo`00
oooooooo000Looooo`05o`3jV_oo003oooooo`3jV_oo00009?ooool01_oo003ooooooooooooooooo
o`00o`3jVQcooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`09ooooo`03o`000?oo
oooooooo047ooooo0019ooooo`03o`000?oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3j
VP07ooooo`03o`3jV_oo003oo`0000Oooooo00Go0?ZJoooooooo003oooooool0000Cooooo`03o`3j
V_oo003oo`0004Kooooo00Co0?ZJool00?oooooo0?ZJ0_ooool00ooo003oooooooooo`1Dooooo`03
o`000?oooooooooo02Sooooo0_l00004ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool01?ooool00ooo003o0?ZJool00007ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00oooooooo
ool03oooool01Ol0nY[oo`00ooooooooooooo`0004Cooooo00Co0?ZJool00?oooooo0?ZJ0oooool0
0ooo003oooooooooo`0Uooooo`05o`3jV_oo003oooooool00?l0nYX0:_ooool2o`0002Kooooo0_l0
000:ooooo`;o0?ZJ0oooool00ooo003oooooool00002ooooo`03ool00?oooooooooo017ooooo00?o
0?ZJooooool0nYX00_ooool00ol0nY[oo`00ooooo`03ooooo`03o`3jV_oo003ooooo00Gooooo00Go
0?ZJooooooooooooooooo`3jVP0Mooooo`04o`3jV_oo003oooooool001cooooo00Go0?ZJool00?oo
oooo0?ZJool0000Tooooo`06ool00?oooooooooooooooooo003o0?ZJ7Oooool01Ol0nY[ooooooooo
oooooooo0?ZJ00[ooooo0_l00013ooooo`00BOooool00ol0003oooooooooo`03ooooo`05o`3jV_oo
ooooooooooooool0nYX01oooool00ol0nY[oo`00ool00008ooooo`04o`3jV_oo003oooooool001?o
oooo00?o0?ZJool00?oo0000A_ooool01?l0nY[oo`00ooooool0nYX2ooooo`03ool00?oooooooooo
05Cooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool01?ooool00ooo003o0?ZJool00007ooooo`03o`3jV_ooooooo`00
00;ooooo00?oo`00ooooooooool03oooool01Ol0nY[oo`00ooooooooooooo`0004Cooooo00Co0?ZJ
ool00?oooooo0?ZJ0oooool00ooo003oooooooooo`0Uooooo`05o`3jV_oo003oooooool00?l0nYX0
:oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00kooooo00?oo`00oooooooo0000
0_ooool00ooo003oooooooooo`0Aooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJool00?ooool0
0oooool00ol0nY[oo`00ooooo`05ooooo`05o`3jV_ooooooooooooooool0nYX07Oooool01?l0nY[o
o`00oooooooo000Looooo`05o`3jV_oo003oooooo`3jV_oo00009?ooool01_l0nY[oo`00oooooooo
ooooo`00o`3jVQgooooo00Go0?ZJooooooooooooooooo`3jVP0;ooooo`03o`000?oooooooooo047o
oooo000jooooo`Go00000oooool2o`0000Gooooo00?o0000ooooooooool00oooool01Ol0nY[ooooo
oooooooooooo0?ZJ00Sooooo0_oo0008ooooo`04o`3jV_oo003oooooool001?ooooo00?o0?ZJool0
0?oo0000A_ooool01?l0nY[oo`00ooooool0nYX2ooooo`03ool00?oooooooooo05Cooooo00?o0000
ooooooooool06_ooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03ool00?l0nY[oo`0000Oooooo00?o0?ZJ
oooooooo00000_ooool00ooo003oooooooooo`0?ooooo`05o`3jV_oo003ooooooooooooo0000A?oo
ool01?l0nY[oo`00ooooool0nYX3ooooo`03ool00?oooooooooo02Gooooo00Go0?ZJool00?oooooo
o`00o`3jVP0[ooooo`03o`000?oooooooooo01Oooooo0ol00004ooooo`;o00001?ooool00ol0003o
ooooooooo`0>ooooo`03ool00?ooooooo`0000;ooooo00?oo`00ooooooooool04Oooool00ol0nY[o
ooooo`3jVP02ooooo`03o`3jV_oo003o0?ZJ00?ooooo00?o0?ZJool00?ooool01Oooool01Ol0nY[o
oooooooooooooooo0?ZJ01gooooo00Co0?ZJool00?ooooooo`007?ooool01Ol0nY[oo`00ooooool0
nY[oo`0002Cooooo00Ko0?ZJool00?ooooooooooool00?l0nYXMooooo`05o`3jV_oooooooooooooo
ool0nYX02oooool00ol0003oooooooooo`11ooooo`00>oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Sooooo0_oo0008ooooo`04o`3jV_oo003oooooool000[ooooo00?o0000ooooooooool0
1_ooool00ol0nY[oo`00ool0000Pooooo`03o`000?oooooooooo02?ooooo00Co0?ZJoooooooo003o
0?ZJ0_ooool00ooo003oooooooooo`0Xooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool06Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool0
0ol0003oooooooooo`03ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool0
0ooo003o0?ZJool00007ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`05o`3jV_oo003ooooooooooooo00007oooool00ol0003ooooooooo
o`0Rooooo`04o`3jV_oo003oooooo`3jVP?ooooo00?oo`00ooooooooool09Oooool01Ol0nY[oo`00
oooooooo003o0?ZJ02[ooooo0_l0000Hooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo00kooooo00?oo`00oooooooo00000_ooool0
0ooo003oooooooooo`0Aooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJool00?l0nYX00oooool0
0ol0nY[oo`00ooooo`05ooooo`04o`3jV_ooooooooooo`3jVQOooooo00?o0000ooooooooool01?oo
ool01?l0nY[oo`00oooooooo000Looooo`05o`3jV_oo003oooooo`3jV_oo00009?ooool02?l0nY[o
o`00ooooooooooooo`00o`3jV_oooooo00006oooool01Ol0nY[ooooooooooooooooo0?ZJ00_ooooo
00?o0000ooooooooool0@Oooool003cooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00004ooooo`Ko000000Go0?ZJo`000?l0003o0000o`3jVP08o`0000;oo`002?l000001?l0nY[o
o`00o`000?oo000Co`000003o`3jV_oo003oo`0004Ko000000Co0?ZJo`000?oo003o0?ZJ0_l00000
0ooo003o0000o`00001Eo`0001oooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`02ooooo`Ko000000?o0?ZJo`000?l000000_l000000ol0nY[o0000o`000004o`000003ool00?l0
nY[oo`0000Oo000000?o0?ZJo`000?oo00000_l000000ooo003o0000o`00000?o`000005o`3jV_oo
003o0000o`000?oo0000A?l000001?l0nY[oo`00o`000?l0nYX3o`000003ool00?l0003o000002Go
000000Go0?ZJool00?l0003oo`00o`3jVP0/o`0001Sooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000?ooooo4Ol000000ooo003o0000ool00002o`000003ool00?l0
003o0000017o000000?o0?ZJo`000?l0nYX00_l000000ol0nY[oo`00o`3jVP03o`000003o`3jV_oo
003o000000Go000000Co0?ZJo`000?l0003o0?ZJ7_l000001?l0nY[oo`00o`000?oo000Lo`000005
o`3jV_oo003o0000o`3jV_oo00009?l000001_l0nY[oo`00o`000?l0003oo`00o`3jVQgo000000Go
0?ZJo`000?l0003o0000o`3jVP0<o`0004?ooooo000mooooo`05o`000?ooooooooooooooool00000
0_ooool00ol0003oooooooooo`3jooooo`;o00000oooool01?l0003oooooooooool0003hooooo`Co
00000oooool01?l0003oooooooooool0003oooooob?ooooo000jooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool0003nooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool0m_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`000?oooooo
8oooool003[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`000?[o
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`000?Wooooo00?o0000
ooooooooool00oooool01?l0003oooooooooool0003oooooob?ooooo000kooooo`?o00001?ooool2
o`000?cooooo0ol00004ooooo`;o0000noooool2o`0000Cooooo0_l0003oooooobCooooo003ooooo
okWooooo0ol0003ooooookGooooo003ooooook[ooooo00?o0000ooooooooool0oooooondooooo`00
/oooool2o`000003ooooool0003o00000?oooooo0oooool00ol0003oooooooooo`3nooooo`Go0000
[oooool00;Cooooo00?o0000ooooool00000ooooool4ooooo`03o`000?oooooooooo0?oooooo00Co
0000oooooooooooo0000[oooool00;Gooooo00?o0000ooooooooool0ooooool2ooooo`03o`000?oo
oooo00000?oooooo0_ooool00ol0003oooooooooo`2_ooooo`00]?ooool00ol0003oooooo`00003o
ooooo`?ooooo00?o0000ooooool00000ooooool01?l0003oooooooooool0002`ooooo`00/oooool2
o`000003ooooool0003o00000?oooooo0Oooool2o`000003ooooool0003o00000?kooooo1Ol0002_
ooooo`00ooooooooooooooooooooL_ooool00?ooooooooooooooooooog;ooooo003ooooooooooooo
oooooombooooo`00ooooooooooooooooooooL_ooool00?ooooooooooooooooooog;ooooo003ooooo
oooooooooooooombooooo`00ooooooooooooooooooooL_ooool00?ooooooooooooooooooog;ooooo
003ooooooooooooooooooombooooo`00ooooooooooooooooooooL_ooool00?oooooooooooooooooo
og;ooooo003ooooooooooooooooooombooooo`00ooooooooooooooooooooL_ooool00?oooooooooo
ooooooooog;ooooo003ooooooooooooooooooombooooo`00ooooooooooooooooooooL_ooool00?oo
ooooooooooooooooog;ooooo003ooooooooooooooooooombooooo`00ooooooooooooooooooooL_oo
ool00?ooooooooooooooooooog;ooooo003ooooooooooooooooooombooooo`00oooooooooooooooo
ooooL_ooool00?ooooooooooooooooooog;ooooo003ooooooooooooooooooombooooo`00oooooooo
ooooooooooooL_ooool00?oooooo[oooool5o`000003ooooool0003o000000?o000000Coooooo`00
0?l0003o0000ooooooncooooo`00oooooon`ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`3ooooook;ooooo003ooooook3ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo/_ooool0
0?oooooo/?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo0ol0003ooooo
ok;ooooo003ooooook3ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo0?oooooo/_ooool00?oooooo/?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo0000oooooonaooooo`00oooooon_ooooo`?o0000
0oooool3o`0000?ooooo1Ol0003ooooook7ooooo003ooooooooooooooooooombooooo`00oooooooo
ooooooooooooL_ooool00001\
\>"],
  ImageRangeCache->{{{0, 878.625}, {361.438, 0}} -> {-0.181191, -0.0309084, \
0.00382687, 0.00382687}, {{47.3125, 308.625}, {353.312, 191.812}} -> \
{-321.594, -2.20571, 4.58135, 0.11108}, {{308.625, 569.938}, {353.312, \
191.812}} -> {-1518.76, 23.5294, 4.58135, 0.0740537}, {{569.938, 831.25}, \
{353.312, 191.812}} -> {-2715.92, -6.91161, 4.58135, 0.0962698}, {{47.3125, \
308.625}, {191.812, 30.3125}} -> {-335.338, -97.1506, 4.58135, 0.370268}, \
{{308.625, 569.938}, {191.812, 30.3125}} -> {-1532.5, -110.581, 4.58135, \
0.444321}, {{569.938, 831.25}, {191.812, 30.3125}} -> {-2715.92, -80.5807, \
4.58135, 0.444321}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Filtering error, together", "Section",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["EKF", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{71.03466677840261, 110.05990103222496, \
116.94651397710119, 24.402568952057575, 19.62390147247157, 14.80457775304218}\
\
\>", "\<\
{71.0347, 110.06, 116.947, 24.4026, 19.6239, 14.8046}\
\>"], \
"Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
 {{0.08865823710713036, 0.22384448410212693, \
-0.9768269425944218, 0.5015049279476034, -0.5593143246929002, \
0.1191049194525137}, 

   {2.2434399297307768, 3.4714513364622754, 3.5649170300738935, \
0.585989153673696, 0.26810498391188436, 0.45251583844347554}}\
\>", \
"\<\
{{0.0886582, 0.223844, -0.976827, 0.501505, -0.559314, 0.119105}, \
{2.24344, 3.47145, 3.56492, 0.585989, 0.268105, 0.452516}}\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["SNF", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{146.60189526077576, 210.0567470688367, \
250.1448862633178, 260.0111266167884, 86.93804040821321, \
38.421051671157855}\
\>", "\<\
{146.602, 210.057, 250.145, 260.011, 86.938, \
38.4211}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{0.7924047543155442, 0.7535832399176229, \
-2.2518978442923574, -8.050977273487419, 2.5176901192422987, \
1.0672058894486671}, {4.565384951385872, 6.596352744693432, \
7.578846235964292, 1.6492460879455864, 1.1008672314552692, \
0.5794601785583305}}\
\>", "\<\
{{0.792405, 0.753583, -2.2519, -8.05098, \
2.51769, 1.06721}, {4.56538, 6.59635, 7.57885, 1.64925, 1.10087, \
0.57946}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["HNF(2,2)", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{91.04657774580875, 150.24159737196933, \
160.37692819005176, 28.322492481535033, 15.644266384120003, 9.47847872706034}\
\
\>", "\<\
{91.0466, 150.242, 160.377, 28.3225, 15.6443, 9.47848}\
\>"], \
"Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
 {{-0.18080706793864604, -0.34722388300726165, \
-1.0458512467142655, -0.8181449489024669, -0.3790660381798046, 

    -0.13334089472875946}, {2.8720214005619673, 4.735971195896045, \
4.959965645182594, 0.3633195022756689, 0.31750198554315984, 

    0.2682760014706816}}\
\>", "\<\
{{-0.180807, -0.347224, -1.04585, \
-0.818145, -0.379066, -0.133341}, {2.87202, 4.73597, 4.95997, 0.36332, \
0.317502, 0.268276}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["GHF", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{91.04658904465467, 150.24157436901348, \
160.37693799818757, 28.322524517785524, 15.644250157926502, 9.47851453835641}\
\
\>", "\<\
{91.0466, 150.242, 160.377, 28.3225, 15.6443, 9.47851}\
\>"], \
"Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-0.18080670155009096, -0.3472240938106425, \
-1.0458486087283108, -0.8181467579789669, -0.3790644657434402, \
-0.13334229434354275}, {2.872021781457153, 4.735970451435375, \
4.959966518245971, 0.3633179233647007, 0.31750306415763097, \
0.2682765698074757}}\
\>", "\<\
{{-0.180807, -0.347224, -1.04585, -0.818147, \
-0.379064, -0.133342}, {2.87202, 4.73597, 4.95997, 0.363318, 0.317503, \
0.268277}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF,kappa=0", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{85.92451370491837, 138.93455426838256, \
162.27861139144125, 25.12424276224525, 15.785931841132768, 9.072918664102978}\
\
\>", "\<\
{85.9245, 138.935, 162.279, 25.1242, 15.7859, 9.07292}\
\>"], \
"Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{-0.15813929525816642, -0.28708554276393833, \
-1.089889102232879, -0.700082800103109, -0.3984106402572074, \
-0.09945006185755041}, {2.711206073376374, 4.3819069745998895, \
5.012003733068537, 0.3748080180554098, 0.30035921681436034, \
0.2689708212139183}}\
\>", "\<\
{{-0.158139, -0.287086, -1.08989, -0.700083, \
-0.398411, -0.0994501}, {2.71121, 4.38191, 5.012, 0.374808, 0.300359, \
0.268971}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF,kappa=-3", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{100.65831579206339, 161.96822848215044, \
223.3542987178399, 54.101033785329655, 11.076487113636432, 24.81608985590985}\
\
\>", "\<\
{100.658, 161.968, 223.354, 54.101, 11.0765, 24.8161}\
\>"], \
"Output",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{0.2596488945199773, 0.2352278210310794, \
-2.9687595233170763, -1.5973116363292923, -0.17664574345696937, \
0.5803864076566666}, {3.17089214813525, 5.113918987461666, 6.40498027655058, \
0.6104042883447304, 0.3022619428514128, 0.5276122728399497}}\
\>", \
"\<\
{{0.259649, 0.235228, -2.96876, -1.59731, -0.176646, 0.580386}, \
{3.17089, 5.11392, 6.40498, 0.610404, 0.302262, 0.527612}}\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["LLF", "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({301.09202464324926`, 735.5124285739488`, 652.7605519541382`, 
      181.9597878362384`, 81.01665741359373`, 81.15483735309654`}\)], "Output"],

Cell[BoxData[
    \({{0.11932202863067184`, 0.7587803849039001`, \(-7.519246683211219`\), 
        4.970670504944721`, \(-2.1830293671360277`\), 
        2.1319215996606915`}, {9.515860639784096`, 23.234938063608883`, 
        19.212797735805378`, 2.892874493057067`, 1.3384783969330445`, 
        1.4263374041965111`}}\)], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{42, 1440}, {0, 878}},
AutoGeneratedPackage->None,
WindowToolbars->{},
WindowSize->{994, 818},
WindowMargins->{{33, Automatic}, {Automatic, 8}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
StyleDefinitions -> "Default.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 1646, 31, 251, "Input"],

Cell[CellGroupData[{
Cell[3425, 86, 60, 1, 69, "Section"],

Cell[CellGroupData[{
Cell[3510, 91, 65, 1, 26, "Subsubsection"],

Cell[CellGroupData[{
Cell[3600, 96, 56, 1, 26, "Input"],
Cell[3659, 99, 971, 15, 131, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4667, 119, 134, 7, 82, "Input"],
Cell[4804, 128, 282, 4, 21, "Message"],
Cell[5089, 134, 344, 5, 21, "Message"],
Cell[5436, 141, 278, 4, 21, "Message"],
Cell[5717, 147, 363, 5, 21, "Message"],
Cell[6083, 154, 274, 4, 21, "Message"],
Cell[6360, 160, 330, 5, 21, "Message"],
Cell[6693, 167, 304, 5, 21, "Message"],
Cell[7000, 174, 335, 5, 21, "Message"]
}, Open  ]],
Cell[7350, 182, 81, 1, 26, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7468, 188, 74, 1, 26, "Subsubsection"],

Cell[CellGroupData[{
Cell[7567, 193, 933, 35, 519, "Input"],
Cell[8503, 230, 371, 5, 70, "Message"],
Cell[8877, 237, 108, 2, 70, "Output"],
Cell[8988, 241, 67, 1, 70, "Output"],
Cell[9058, 244, 363, 5, 70, "Message"],
Cell[9424, 251, 73, 1, 70, "Output"],
Cell[9500, 254, 67, 1, 70, "Output"],
Cell[9570, 257, 43, 1, 70, "Output"],
Cell[9616, 260, 70, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9723, 266, 361, 11, 159, "Input"],
Cell[10087, 279, 108, 2, 70, "Output"],
Cell[10198, 283, 116, 2, 70, "Output"],
Cell[10317, 287, 67, 1, 70, "Output"],
Cell[10387, 290, 46, 1, 70, "Output"],
Cell[10436, 293, 73, 1, 70, "Output"],
Cell[10512, 296, 43, 1, 70, "Output"],
Cell[10558, 299, 70, 1, 70, "Output"],
Cell[10631, 302, 237, 4, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[10917, 312, 76, 1, 20, "Subsubsection"],

Cell[CellGroupData[{
Cell[11018, 317, 1073, 30, 414, "Input"],
Cell[12094, 349, 371, 5, 70, "Message"],
Cell[12468, 356, 380, 5, 70, "Message"],
Cell[12851, 363, 375, 5, 70, "Message"],
Cell[13229, 370, 377, 5, 70, "Message"],
Cell[13609, 377, 333, 5, 70, "Message"],
Cell[13945, 384, 368, 5, 70, "Message"],
Cell[14316, 391, 47, 1, 70, "Output"],
Cell[14366, 394, 218, 3, 70, "Output"],
Cell[14587, 399, 48, 1, 70, "Output"],
Cell[14638, 402, 928, 13, 70, "Output"],
Cell[15569, 417, 49, 1, 70, "Output"],
Cell[15621, 420, 5361, 72, 70, "Output"],
Cell[20985, 494, 50, 1, 70, "Output"],
Cell[21038, 497, 32935, 432, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[54010, 934, 740, 14, 174, "Input"],
Cell[54753, 950, 887, 12, 70, "Output"],
Cell[55643, 964, 5361, 72, 70, "Output"],
Cell[61007, 1038, 32935, 432, 70, "Output"],
Cell[93945, 1472, 203015, 2610, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[296997, 4087, 685, 28, 399, "Input"],
Cell[297685, 4117, 109, 2, 70, "Output"],
Cell[297797, 4121, 76, 1, 70, "Output"],
Cell[297876, 4124, 369, 6, 70, "Message"],
Cell[298248, 4132, 62, 1, 70, "Output"],
Cell[298313, 4135, 371, 5, 70, "Message"],
Cell[298687, 4142, 256, 4, 70, "Output"],
Cell[298946, 4148, 365, 5, 70, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[299348, 4158, 477, 12, 159, "Input",
  InitializationCell->True],
Cell[299828, 4172, 117, 2, 70, "Output"],
Cell[299948, 4176, 960, 23, 70, "Output"],
Cell[300911, 4201, 928, 13, 70, "Output"],
Cell[301842, 4216, 932, 23, 70, "Output"],
Cell[302777, 4241, 46, 1, 70, "Output"],
Cell[302826, 4244, 761, 20, 70, "Output"],
Cell[303590, 4266, 65, 1, 70, "Output"],
Cell[303658, 4269, 256, 4, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[303951, 4278, 79, 1, 39, "Input"],
Cell[304033, 4281, 587, 8, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[304669, 4295, 71, 1, 20, "Subsubsection"],

Cell[CellGroupData[{
Cell[304765, 4300, 505, 21, 278, "Input"],
Cell[305273, 4323, 355, 5, 21, "Message"],
Cell[305631, 4330, 359, 5, 21, "Message"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[306051, 4342, 63, 1, 69, "Section"],
Cell[306117, 4345, 387, 19, 236, "Input"],

Cell[CellGroupData[{
Cell[306529, 4368, 358, 8, 124, "Input"],
Cell[306890, 4378, 36, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[306963, 4384, 201, 7, 82, "Input"],
Cell[307167, 4393, 181, 3, 22, "Print"],
Cell[307351, 4398, 181, 3, 22, "Print"],
Cell[307535, 4403, 542648, 15058, 263, 161614, 10349, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[850220, 19466, 97, 1, 26, "Input"],
Cell[850320, 19469, 3452, 65, 167, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[853809, 19539, 162, 4, 26, "Input"],
Cell[853974, 19545, 193250, 8402, 393, 75528, 6944, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1047273, 27953, 65, 1, 69, "Section"],

Cell[CellGroupData[{
Cell[1047363, 27958, 238, 7, 68, "Input"],
Cell[1047604, 27967, 355, 5, 21, "Message"],
Cell[1047962, 27974, 69, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1048068, 27980, 85, 4, 40, "Input"],
Cell[1048156, 27986, 172, 3, 26, "Output"],
Cell[1048331, 27991, 341, 5, 26, "Output"]
}, Open  ]],
Cell[1048687, 27999, 131, 6, 68, "Input"],

Cell[CellGroupData[{
Cell[1048843, 28009, 581, 22, 292, "Input"],
Cell[1049427, 28033, 359, 5, 21, "Message"],
Cell[1049789, 28040, 109, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1049935, 28047, 193, 5, 40, "Input"],
Cell[1050131, 28054, 354, 5, 21, "Message"],
Cell[1050488, 28061, 181, 3, 22, "Print"],
Cell[1050672, 28066, 181, 3, 22, "Print"],
Cell[1050856, 28071, 177, 3, 22, "Print"],
Cell[1051036, 28076, 181, 3, 22, "Print"],
Cell[1051220, 28081, 181, 3, 22, "Print"],
Cell[1051404, 28086, 177, 3, 22, "Print"],
Cell[1051584, 28091, 181, 3, 22, "Print"],
Cell[1051768, 28096, 181, 3, 22, "Print"],
Cell[1051952, 28101, 177, 3, 22, "Print"],
Cell[1052132, 28106, 181, 3, 22, "Print"],
Cell[1052316, 28111, 181, 3, 22, "Print"],
Cell[1052500, 28116, 169, 3, 22, "Print"],
Cell[1052672, 28121, 175, 3, 22, "Print"],
Cell[1052850, 28126, 181, 3, 22, "Print"],
Cell[1053034, 28131, 181, 3, 22, "Print"],
Cell[1053218, 28136, 169, 3, 22, "Print"],
Cell[1053390, 28141, 175, 3, 22, "Print"],
Cell[1053568, 28146, 181, 3, 22, "Print"],
Cell[1053752, 28151, 181, 3, 22, "Print"],
Cell[1053936, 28156, 169, 3, 22, "Print"],
Cell[1054108, 28161, 175, 3, 22, "Print"],
Cell[1054286, 28166, 622560, 30422, 307, 448350, 28266, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1676849, 58590, 135, 3, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1677033, 58599, 81, 1, 39, "Section"],

Cell[CellGroupData[{
Cell[1677139, 58604, 239, 7, 68, "Input"],
Cell[1677381, 58613, 69, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1677487, 58619, 85, 4, 40, "Input"],
Cell[1677575, 58625, 171, 3, 26, "Output"],
Cell[1677749, 58630, 329, 5, 26, "Output"]
}, Open  ]],
Cell[1678093, 58638, 131, 6, 68, "Input"],

Cell[CellGroupData[{
Cell[1678249, 58648, 575, 21, 278, "Input"],
Cell[1678827, 58671, 109, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1678973, 58678, 188, 4, 26, "Input"],
Cell[1679164, 58684, 181, 3, 22, "Print"],
Cell[1679348, 58689, 181, 3, 22, "Print"],
Cell[1679532, 58694, 177, 3, 22, "Print"],
Cell[1679712, 58699, 181, 3, 22, "Print"],
Cell[1679896, 58704, 181, 3, 22, "Print"],
Cell[1680080, 58709, 177, 3, 22, "Print"],
Cell[1680260, 58714, 181, 3, 22, "Print"],
Cell[1680444, 58719, 181, 3, 22, "Print"],
Cell[1680628, 58724, 177, 3, 22, "Print"],
Cell[1680808, 58729, 181, 3, 22, "Print"],
Cell[1680992, 58734, 181, 3, 22, "Print"],
Cell[1681176, 58739, 169, 3, 22, "Print"],
Cell[1681348, 58744, 175, 3, 22, "Print"],
Cell[1681526, 58749, 181, 3, 22, "Print"],
Cell[1681710, 58754, 181, 3, 22, "Print"],
Cell[1681894, 58759, 169, 3, 22, "Print"],
Cell[1682066, 58764, 175, 3, 22, "Print"],
Cell[1682244, 58769, 181, 3, 22, "Print"],
Cell[1682428, 58774, 181, 3, 22, "Print"],
Cell[1682612, 58779, 169, 3, 22, "Print"],
Cell[1682784, 58784, 175, 3, 22, "Print"],
Cell[1682962, 58789, 615665, 30267, 307, 447044, 28181, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2298630, 89058, 135, 3, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[2298814, 89067, 81, 1, 39, "Section"],

Cell[CellGroupData[{
Cell[2298920, 89072, 239, 7, 72, "Input"],
Cell[2299162, 89081, 308, 6, 36, "Print"],
Cell[2299473, 89089, 144, 6, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2299654, 89100, 85, 4, 42, "Input"],
Cell[2299742, 89106, 262, 8, 24, "Output"],
Cell[2300007, 89116, 454, 10, 24, "Output"]
}, Open  ]],
Cell[2300476, 89129, 131, 6, 72, "Input"],

Cell[CellGroupData[{
Cell[2300632, 89139, 582, 22, 312, "Input"],
Cell[2301217, 89163, 208, 7, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2301462, 89175, 191, 5, 54, "Input"],
Cell[2301656, 89182, 181, 3, 22, "Print"],
Cell[2301840, 89187, 181, 3, 22, "Print"],
Cell[2302024, 89192, 177, 3, 22, "Print"],
Cell[2302204, 89197, 181, 3, 22, "Print"],
Cell[2302388, 89202, 181, 3, 22, "Print"],
Cell[2302572, 89207, 177, 3, 22, "Print"],
Cell[2302752, 89212, 181, 3, 22, "Print"],
Cell[2302936, 89217, 181, 3, 22, "Print"],
Cell[2303120, 89222, 177, 3, 22, "Print"],
Cell[2303300, 89227, 181, 3, 22, "Print"],
Cell[2303484, 89232, 181, 3, 22, "Print"],
Cell[2303668, 89237, 169, 3, 22, "Print"],
Cell[2303840, 89242, 175, 3, 22, "Print"],
Cell[2304018, 89247, 181, 3, 22, "Print"],
Cell[2304202, 89252, 181, 3, 22, "Print"],
Cell[2304386, 89257, 169, 3, 22, "Print"],
Cell[2304558, 89262, 175, 3, 22, "Print"],
Cell[2304736, 89267, 181, 3, 22, "Print"],
Cell[2304920, 89272, 181, 3, 22, "Print"],
Cell[2305104, 89277, 169, 3, 22, "Print"],
Cell[2305276, 89282, 175, 3, 22, "Print"],
Cell[2305454, 89287, 618550, 30423, 314, 448663, 28320, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2924007, 119712, 135, 3, 38, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[2924191, 119721, 83, 1, 39, "Section"],

Cell[CellGroupData[{
Cell[2924299, 119726, 306, 8, 96, "Input"],
Cell[2924608, 119736, 69, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2924714, 119742, 65, 1, 26, "Input"],
Cell[2924782, 119745, 43, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2924862, 119751, 85, 4, 40, "Input"],
Cell[2924950, 119757, 172, 3, 26, "Output"],
Cell[2925125, 119762, 347, 5, 26, "Output"]
}, Open  ]],
Cell[2925487, 119770, 131, 6, 68, "Input"],

Cell[CellGroupData[{
Cell[2925643, 119780, 581, 22, 292, "Input"],
Cell[2926227, 119804, 109, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2926373, 119811, 181, 5, 40, "Input"],
Cell[2926557, 119818, 181, 3, 22, "Print"],
Cell[2926741, 119823, 181, 3, 22, "Print"],
Cell[2926925, 119828, 177, 3, 22, "Print"],
Cell[2927105, 119833, 181, 3, 22, "Print"],
Cell[2927289, 119838, 181, 3, 22, "Print"],
Cell[2927473, 119843, 177, 3, 22, "Print"],
Cell[2927653, 119848, 181, 3, 22, "Print"],
Cell[2927837, 119853, 181, 3, 22, "Print"],
Cell[2928021, 119858, 177, 3, 22, "Print"],
Cell[2928201, 119863, 181, 3, 22, "Print"],
Cell[2928385, 119868, 181, 3, 22, "Print"],
Cell[2928569, 119873, 169, 3, 22, "Print"],
Cell[2928741, 119878, 175, 3, 22, "Print"],
Cell[2928919, 119883, 181, 3, 22, "Print"],
Cell[2929103, 119888, 181, 3, 22, "Print"],
Cell[2929287, 119893, 169, 3, 22, "Print"],
Cell[2929459, 119898, 175, 3, 22, "Print"],
Cell[2929637, 119903, 181, 3, 22, "Print"],
Cell[2929821, 119908, 181, 3, 22, "Print"],
Cell[2930005, 119913, 169, 3, 22, "Print"],
Cell[2930177, 119918, 175, 3, 22, "Print"],
Cell[2930355, 119923, 623598, 30449, 305, 448483, 28282, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3553956, 150374, 135, 3, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3554140, 150383, 56, 1, 39, "Section"],

Cell[CellGroupData[{
Cell[3554221, 150388, 63, 1, 26, "Input"],
Cell[3554287, 150391, 40, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3554364, 150397, 284, 8, 82, "Input"],
Cell[3554651, 150407, 355, 5, 21, "Message"],
Cell[3555009, 150414, 159, 3, 22, "Print"],
Cell[3555171, 150419, 159, 3, 22, "Print"],
Cell[3555333, 150424, 159, 3, 22, "Print"],
Cell[3555495, 150429, 70, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3555602, 150435, 85, 4, 40, "Input"],
Cell[3555690, 150441, 170, 3, 26, "Output"],
Cell[3555863, 150446, 337, 5, 26, "Output"]
}, Open  ]],
Cell[3556215, 150454, 131, 6, 68, "Input"],

Cell[CellGroupData[{
Cell[3556371, 150464, 581, 22, 292, "Input"],
Cell[3556955, 150488, 359, 5, 21, "Message"],
Cell[3557317, 150495, 109, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3557463, 150502, 171, 4, 26, "Input"],
Cell[3557637, 150508, 355, 5, 21, "Message"],
Cell[3557995, 150515, 181, 3, 22, "Print"],
Cell[3558179, 150520, 181, 3, 22, "Print"],
Cell[3558363, 150525, 177, 3, 22, "Print"],
Cell[3558543, 150530, 181, 3, 22, "Print"],
Cell[3558727, 150535, 181, 3, 22, "Print"],
Cell[3558911, 150540, 177, 3, 22, "Print"],
Cell[3559091, 150545, 181, 3, 22, "Print"],
Cell[3559275, 150550, 181, 3, 22, "Print"],
Cell[3559459, 150555, 177, 3, 22, "Print"],
Cell[3559639, 150560, 181, 3, 22, "Print"],
Cell[3559823, 150565, 181, 3, 22, "Print"],
Cell[3560007, 150570, 169, 3, 22, "Print"],
Cell[3560179, 150575, 175, 3, 22, "Print"],
Cell[3560357, 150580, 181, 3, 22, "Print"],
Cell[3560541, 150585, 181, 3, 22, "Print"],
Cell[3560725, 150590, 169, 3, 22, "Print"],
Cell[3560897, 150595, 175, 3, 22, "Print"],
Cell[3561075, 150600, 181, 3, 22, "Print"],
Cell[3561259, 150605, 181, 3, 22, "Print"],
Cell[3561443, 150610, 169, 3, 22, "Print"],
Cell[3561615, 150615, 175, 3, 22, "Print"],
Cell[3561793, 150620, 605761, 30172, 285, 447129, 28209, "GraphicsData", \
"PostScript", "Graphics"],
Cell[4167557, 180794, 496, 7, 21, "Message"],
Cell[4168056, 180803, 496, 7, 21, "Message"],
Cell[4168555, 180812, 490, 7, 21, "Message"],
Cell[4169048, 180821, 332, 5, 21, "Message"],
Cell[4169383, 180828, 135, 3, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4169555, 180836, 92, 1, 26, "Input"],
Cell[4169650, 180839, 74, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4169761, 180845, 89, 1, 26, "Input"],
Cell[4169853, 180848, 496, 7, 21, "Message"],
Cell[4170352, 180857, 496, 7, 21, "Message"],
Cell[4170851, 180866, 490, 7, 21, "Message"],
Cell[4171344, 180875, 332, 5, 21, "Message"],
Cell[4171679, 180882, 43, 1, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[4171771, 180889, 87, 1, 39, "Section"],

Cell[CellGroupData[{
Cell[4171883, 180894, 271, 7, 70, "Input"],
Cell[4172157, 180903, 144, 6, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4172338, 180914, 65, 1, 70, "Input"],
Cell[4172406, 180917, 106, 5, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4172549, 180927, 85, 4, 70, "Input"],
Cell[4172637, 180933, 263, 8, 70, "Output"],
Cell[4172903, 180943, 464, 12, 70, "Output"]
}, Open  ]],
Cell[4173382, 180958, 131, 6, 70, "Input"],

Cell[CellGroupData[{
Cell[4173538, 180968, 581, 22, 70, "Input"],
Cell[4174122, 180992, 208, 7, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4174367, 181004, 171, 4, 70, "Input"],
Cell[4174541, 181010, 676, 23, 70, "Print"],
Cell[4175220, 181035, 196636, 3026, 70, 196526, 3023, "GraphicsData", "PICT",
   "Graphics"],
Cell[4371859, 184063, 128, 6, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[4372036, 184075, 62, 1, 39, "Section"],

Cell[CellGroupData[{
Cell[4372123, 184080, 253, 8, 82, "Input"],
Cell[4372379, 184090, 56, 1, 22, "Print"],
Cell[4372438, 184093, 164, 3, 22, "Print"],
Cell[4372605, 184098, 68, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4372710, 184104, 65, 1, 26, "Input"],
Cell[4372778, 184107, 212253, 5006, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[4585068, 189118, 85, 4, 37, "Input"],
Cell[4585156, 189124, 162, 2, 26, "Output"],
Cell[4585321, 189128, 333, 6, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4585691, 189139, 79, 2, 26, "Input",
  Evaluatable->False],
Cell[4585773, 189143, 265, 8, 24, "Output"],
Cell[4586041, 189153, 475, 11, 24, "Output"]
}, Open  ]],
Cell[4586531, 189167, 131, 6, 68, "Input"],

Cell[CellGroupData[{
Cell[4586687, 189177, 581, 22, 292, "Input"],
Cell[4587271, 189201, 208, 7, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4587516, 189213, 176, 4, 26, "Input"],
Cell[4587695, 189219, 676, 23, 302, "Print"],
Cell[4588374, 189244, 103380, 1591, 252, 103262, 1588, "GraphicsData", \
"PICT", "Graphics"],
Cell[4691757, 190837, 128, 6, 24, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[4691934, 190849, 96, 2, 39, "Section"],

Cell[CellGroupData[{
Cell[4692055, 190855, 282, 9, 82, "Input"],
Cell[4692340, 190866, 56, 1, 22, "Print"],
Cell[4692399, 190869, 164, 3, 22, "Print"],
Cell[4692566, 190874, 69, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4692672, 190880, 108, 5, 40, "Input"],
Cell[4692783, 190887, 162, 2, 26, "Output"],
Cell[4692948, 190891, 341, 5, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4693326, 190901, 104, 3, 26, "Input",
  Evaluatable->False],
Cell[4693433, 190906, 288, 9, 24, "Output"],
Cell[4693724, 190917, 534, 15, 36, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4694295, 190937, 102, 3, 26, "Input",
  Evaluatable->False],
Cell[4694400, 190942, 288, 9, 24, "Output"],
Cell[4694691, 190953, 498, 12, 24, "Output"]
}, Open  ]],
Cell[4695204, 190968, 154, 7, 68, "Input"],

Cell[CellGroupData[{
Cell[4695383, 190979, 604, 23, 292, "Input"],
Cell[4695990, 191004, 109, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4696136, 191011, 206, 6, 40, "Input"],
Cell[4696345, 191019, 180, 3, 21, "Message"],
Cell[4696528, 191024, 181, 3, 22, "Print"],
Cell[4696712, 191029, 181, 3, 22, "Print"],
Cell[4696896, 191034, 177, 3, 22, "Print"],
Cell[4697076, 191039, 181, 3, 22, "Print"],
Cell[4697260, 191044, 181, 3, 22, "Print"],
Cell[4697444, 191049, 177, 3, 22, "Print"],
Cell[4697624, 191054, 181, 3, 22, "Print"],
Cell[4697808, 191059, 181, 3, 22, "Print"],
Cell[4697992, 191064, 177, 3, 22, "Print"],
Cell[4698172, 191069, 181, 3, 22, "Print"],
Cell[4698356, 191074, 181, 3, 22, "Print"],
Cell[4698540, 191079, 169, 3, 22, "Print"],
Cell[4698712, 191084, 175, 3, 22, "Print"],
Cell[4698890, 191089, 181, 3, 22, "Print"],
Cell[4699074, 191094, 181, 3, 22, "Print"],
Cell[4699258, 191099, 169, 3, 22, "Print"],
Cell[4699430, 191104, 175, 3, 22, "Print"],
Cell[4699608, 191109, 181, 3, 22, "Print"],
Cell[4699792, 191114, 181, 3, 22, "Print"],
Cell[4699976, 191119, 169, 3, 22, "Print"],
Cell[4700148, 191124, 175, 3, 22, "Print"],
Cell[4700326, 191129, 610567, 30283, 290, 448360, 28275, "GraphicsData", \
"PostScript", "Graphics"],
Cell[5310896, 221414, 135, 3, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[5311080, 221423, 79, 2, 39, "Section"],
Cell[5311162, 221427, 49, 1, 26, "Input"],

Cell[CellGroupData[{
Cell[5311236, 221432, 307, 8, 82, "Input"],
Cell[5311546, 221442, 159, 3, 22, "Print"],
Cell[5311708, 221447, 159, 3, 22, "Print"],
Cell[5311870, 221452, 159, 3, 22, "Print"],
Cell[5312032, 221457, 159, 3, 22, "Print"],
Cell[5312194, 221462, 159, 3, 22, "Print"],
Cell[5312356, 221467, 69, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5312462, 221473, 88, 2, 26, "Input"],
Cell[5312553, 221477, 43, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5312633, 221483, 108, 5, 40, "Input"],
Cell[5312744, 221490, 160, 2, 26, "Output"],
Cell[5312907, 221494, 330, 5, 26, "Output"]
}, Open  ]],
Cell[5313252, 221502, 154, 7, 68, "Input"],

Cell[CellGroupData[{
Cell[5313431, 221513, 606, 23, 292, "Input"],
Cell[5314040, 221538, 114, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5314191, 221545, 194, 5, 26, "Input"],
Cell[5314388, 221552, 181, 3, 22, "Print"],
Cell[5314572, 221557, 181, 3, 22, "Print"],
Cell[5314756, 221562, 177, 3, 22, "Print"],
Cell[5314936, 221567, 181, 3, 22, "Print"],
Cell[5315120, 221572, 181, 3, 22, "Print"],
Cell[5315304, 221577, 177, 3, 22, "Print"],
Cell[5315484, 221582, 181, 3, 22, "Print"],
Cell[5315668, 221587, 181, 3, 22, "Print"],
Cell[5315852, 221592, 177, 3, 22, "Print"],
Cell[5316032, 221597, 181, 3, 22, "Print"],
Cell[5316216, 221602, 181, 3, 22, "Print"],
Cell[5316400, 221607, 169, 3, 22, "Print"],
Cell[5316572, 221612, 175, 3, 22, "Print"],
Cell[5316750, 221617, 181, 3, 22, "Print"],
Cell[5316934, 221622, 181, 3, 22, "Print"],
Cell[5317118, 221627, 169, 3, 22, "Print"],
Cell[5317290, 221632, 175, 3, 22, "Print"],
Cell[5317468, 221637, 181, 3, 22, "Print"],
Cell[5317652, 221642, 181, 3, 22, "Print"],
Cell[5317836, 221647, 169, 3, 22, "Print"],
Cell[5318008, 221652, 175, 3, 22, "Print"],
Cell[5318186, 221657, 730764, 31301, 375, 437531, 27675, "GraphicsData", \
"PostScript", "Graphics"],
Cell[6048953, 252960, 135, 3, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[6049137, 252969, 78, 1, 39, "Section"],
Cell[6049218, 252972, 76, 2, 26, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[6049319, 252978, 107, 5, 40, "Input",
  Evaluatable->False],
Cell[6049429, 252985, 287, 9, 24, "Output"],
Cell[6049719, 252996, 500, 13, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6050256, 253014, 76, 2, 26, "Input",
  Evaluatable->False],
Cell[6050335, 253018, 263, 8, 24, "Output"],
Cell[6050601, 253028, 457, 11, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6051095, 253044, 81, 2, 26, "Input",
  Evaluatable->False],
Cell[6051179, 253048, 265, 8, 24, "Output"],
Cell[6051447, 253058, 486, 13, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6051970, 253076, 76, 2, 26, "Input",
  Evaluatable->False],
Cell[6052049, 253080, 265, 8, 24, "Output"],
Cell[6052317, 253090, 476, 11, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6052830, 253106, 84, 2, 26, "Input",
  Evaluatable->False],
Cell[6052917, 253110, 265, 8, 24, "Output"],
Cell[6053185, 253120, 475, 11, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6053697, 253136, 85, 2, 26, "Input",
  Evaluatable->False],
Cell[6053785, 253140, 265, 8, 24, "Output"],
Cell[6054053, 253150, 463, 10, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6054553, 253165, 99, 3, 26, "Input",
  Evaluatable->False],
Cell[6054655, 253170, 162, 2, 26, "Output"],
Cell[6054820, 253174, 333, 5, 26, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

