(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

RESAMPLING = True;
FDIGITS = Round[-Log[10,$MachineEpsilon]];
TYP = 1;
YMAX = 10^8.;
ANALGRAD = False;
FACTOR = 1.0;
MAXSTEP=0.1;
CSEED=-999;
SCALING=1;
STEPREDUCE = 4;
FISHER=False;
PRINT={1,1,1,1,1,1,1,1}
OVERFLOW=False;
SHIFT$=10^-16;





<<KernDichte.m
<<Feynman.Fokker.impl.ma
<<Momente.multi.m









box[cmin_,c_,cmax_] := 
	MapThread[Flatten[List[#1+First[#2],#2,#3+Last[#2]]]&,{cmin,c,cmax}]

box1[cmin_,c_,cmax_] := 
	MapThread[Flatten[List[#1,#2,#3]]&,{cmin,c,cmax}]

	
cuts[S_,t_,Theta_] :=  (*geordnete cuts!!*)
	Module[{c1},
	c1 = Take[Theta,-5];
	c1 = (c1//First) + FoldList[Plus,0,Abs[c1]//Rest];
	box[cmin,{c1},cmax]
	]


cutoffs1//Clear
cutoffs1[z_,c_]:= c[[{z,z+1}]]

cutoffs//Clear
cutoffs[z_,c_] := MapThread[cutoffs1[#1,#2]&,{z,c}]	

messind//Clear
(***************************************************************)			 
messind[ZM_,MISS_] := Locate[Map[any,unsameq[ZM,MISS]],True]
(***************************************************************)			 

(***************************************************************)			 
messind1[ZM_,MISS_] := Complement[ Range[Length[ZM]],
                       Locate[ Map[all,ZM~eq~MISS], True]
                       ]
(***************************************************************)

missings[z_,miss_,op_]:=Apply[op,Map[(#===miss)&,z]]
CaseDel[Z_,miss_]:=Select[Z,Not[missings[#,miss,Or]]&]
CaseDel1[X_,m_]:=X[[Locate[Map[(And@@#)&,Map[(#=!=m)&,X,{2}]]]]]	
		 

(***************************************************************)			 
smoothQuickAndDirty1[ST_]:= 
(***************************************************************)			 
	Module[{m,s,sm},
	{m,s} =  ST//MS1;
	sm = (s//Max)^2 Length[ST]^(-2/5) //N;
	{sm,m,s}]
	
(***************************************************************)			 


Modus = "Fix"; (*Voreinstellung*)
AutomaticGrid//Clear
(***************************************************************)			 
AutomaticGrid[Theta_,{m_,s_,nstd_},{Z_,Modus_},{y1_,y2_,dy_}]:= 
(***************************************************************)			 
Module[{y1s,y2s,dys,c},
Which[  Modus == "Ordinal",

		c = cuts[_,X,Theta]; 
		{y1s,y2s} = cutoffs[Z,c]//Transpose//N;
		dys = dy
		 
		,Modus == "Automatic",
	
		y1s = m-nstd s;
		y2s = m+nstd s;
		dys = dy
		
		,Modus == "Fix",
		
		{y1s,y2s,dys} = {y1,y2,dy} (*fixes Gitter*)
		
  ];
		
Print["Gitter:",{Modus,y1s,y2s,dys,Z}];
{y1s,y2s,dys}
]

(***************************************************************)			 
chi[{Z_,Y_,X_},Theta_,{h_,R_}] := 
(***************************************************************)			 
	Module[{z = Z-h[Y,X,Theta]},
	Exp[- z.Inverse[R].z]
	]

(***************************************************************)			 
Over[y_,MAX_]:= 
(***************************************************************)			 
Block[{ov,max,y1},
ov  = Position[y,Overflow[]];
max = Position[y,x_/;Abs[x]>MAX];
y1 = ReplacePart[y ,0,max];
y1 = ReplacePart[y1,0,ov];
If[y=!=y1, Print["Warnung: Overflow", i]];
y1
]

(***************************************************************)			 
Over[y_,MAX_,i_]:= 
(***************************************************************)			 
Block[{ov,max,y1},
ov  = Position[y,Overflow[]];
max = Position[y,x_/;Abs[x]>MAX];
y1 = ReplacePart[y ,0,max];
y1 = ReplacePart[y1,0,ov];
If[y=!=y1, Print["Warnung: Overflow", i];OVERFLOW=True];
{y1,OVERFLOW}
]

(***************************************************************)			 
InverseStepFunction[y_,yi_]:= 
(***************************************************************)			 
	Module[{out},
	out = Position[le[yi,y],True];
	out = If[out == {},0,out//Last//First]
	]

(***************************************************************)			 
CompressData[Z_,miss_]:= Module[{ti},
(***************************************************************)			 
	ti  = messind[Z,miss];
	ti  = Union[ti,{1,Length[Z]}];
	{Z[[ti]],ti}]

ExpandData//Clear
(***************************************************************)			 
ExpandData[{Z_,ti_},miss_]:= Module[{Tc,k,T1,ZE},
(***************************************************************)			 
	{Tc,k} = Z//Dimensions;
	 T1    = ti//Last;
	
	ZE = Shape[miss,{T1,k}];
	Map[ (ZE[[ti[[#]] ]]=Z[[#]])&,Tc//Range];
	
	ZE
	
	]	

(***************************************************************)			 
ExpandData[{Zi_,ti_,dt_},miss_]:=
(***************************************************************)			 
Module[{Z},
(* voller Datensatz *)
	{T1,k}=Zi//Dimensions;
	If[OrderedQ[ti]//Not,Print["ti not ordered ",ti];Return[{}]];
	j =ti/dt;
	j= j - Min[j] + 1//Rationalize;
	Z = Shape[miss,{j//Last,k}];
	Do[Z[[ j[[i]] ]]=Zi[[i]],{i,1,T1}];
	Z]

(***************************************************************)			 
SampleData[Z_,select_,miss_]:=
(***************************************************************)			 
Module[{ZM},
ZM = Shape[miss,Z//Dimensions];
Map[(ZM[[#]] = Z[[#]])&,select];
ZM
]





IdPlusA[A_] := Block[{out,p},
		p = Length[A];
		out = A; 
		Do[out[[i,i]] = out[[i,i]]+1 ,{i,p}];
		out]
		
IdPlusA[vec_,A_] := Block[{out,p},
		p = Length[A];
		out = A; 
		Do[out[[i,i]] = out[[i,i]]+vec[[i]] ,{i,p}];
		out]

Symmetrize[A_]:=0.5(A+Transpose[A]);
	  

Symmetrize[{{1,2},{3,4}}]





(***************************************************************)
Shift[H_,BOUND_,Text_:""] := Module[{H1,EIGEN,MINI,COND,minabs},
(***************************************************************)
EIGEN=Eigenvalues[H];
MINI=Min[EIGEN];

minabs=Min[Abs[EIGEN]];
COND=If[minabs=!=0,Max[Abs[EIGEN]]/minabs,Infinity];

If[MINI<BOUND,
Print[Text,i,"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", 
				EIGEN,"  BOUND  ",BOUND//N];
H1=H+DiagonalMatrix[Array[(BOUND-MINI)&,{Length[H]}]], 
H1 = H ];
Return[H1]
]





SigmaSample//Clear
SigmaSample[mue_, Sigma_, kappa_]:=
Module[{Gamma,p,pk,pk2,alpha0,alpha,x1,x2},

(*Print["SigmaSample",Sigma,"Eigenwerte",Sigma//Eigenvalues];*)

Gamma=CholeskyDecomposition[Sigma]; (*Zeilen*)
p=mue//Length;

pk=(p+kappa);
pk2=pk//Sqrt;
alpha0=kappa/pk;
alpha=1/(2 pk);

x1=Map[(mue + pk2#)&,Gamma];
x2=Map[(mue - pk2#)&,Gamma];

{Join[{mue},x1,x2],{alpha0,Table[alpha,{i,2p}]}//Flatten}

]





SigmaSample2//Clear
SigmaSample2[mue_, Sigma_, kappa_,tau_]:=
Module[{Gamma,p,pk,pk2,alpha0,alpha,alpha1,alpha2,x1,x2,x3,x4},

Gamma=CholeskyDecomposition[Sigma]; (*Zeilen*)
p=mue//Length;

pk=(p+kappa);
pk2=pk//Sqrt;
alpha0= (2pk-p*(1+1/tau^2))/(2pk);
alpha=1/(2 pk);
alpha1=alpha/2;
alpha2=alpha1/tau^2;

x1=Map[(mue + pk2#)&,Gamma];
x2=Map[(mue - pk2#)&,Gamma];

pk2=tau pk2;
x3=Map[(mue + pk2#)&,Gamma];
x4=Map[(mue - pk2#)&,Gamma];

{Join[{mue},x1,x2,x3,x4],{alpha0,Table[alpha1,{i,2p}],Table[alpha2,{i,2p}]}//Flatten}

]

WeightedMean//Clear
WeightedMean[x_,alpha_]:=Apply[Plus,x alpha];


WeightedVariance//Clear
WeightedVariance[x_,alpha_]:=
Module[{mean},

mean=Apply[Plus,x alpha];

Apply[Plus,alpha Map[Outer[Times,#,#]&,x]]- Outer[Times,mean,mean]

]

WeightedMeanAndVariance//Clear
WeightedMeanAndVariance[x_,alpha_]:=
Module[{mean,var,xx},

mean=Apply[Plus,x alpha];

(*xx=Map[Outer[Times,#,#]&,x];*)
(*xx=Table[Outer[Times,x[[i]],x[[i]]],{i,x//Length}];*)
xx=MapThread[Outer[Times,#1,#2]&,{x,x}];

var=Apply[Plus,alpha xx]- Outer[Times,mean,mean];

(*xx//Clear;*)

{mean,var}
]

WeightedMeanAndVariance1//Clear
WeightedMeanAndVariance1[x_,alpha_]:=
Module[{mean,var,xx},

mean=alpha.x;

(*xx=Map[Outer[Times,#,#]&,x];*)
(*xx=Table[Outer[Times,x[[i]],x[[i]]],{i,x//Length}];*)
xx=MapThread[Outer[Times,#1,#2]&,{x,x}];

var=alpha.xx- Outer[Times,mean,mean];

(*xx//Clear;*)

{mean,var}
]

WeightedMeanAndVariance[x_,y_,alpha_]:=
Module[{meanx,meany,covxy},

meanx=Apply[Plus,x alpha];
meany=Apply[Plus,y alpha];
covxy=Apply[Plus,alpha MapThread[Outer[Times,#1,#2]&,{x,y}]]
                               - Outer[Times,meanx,meany];

{meanx, meany, covxy}
]

WeightedMeanAndVarianceSpezial//Clear
WeightedMeanAndVarianceSpezial[x_,meanx_,y_,alpha_]:=
Module[{meany,covxy,covyy},

meany=Apply[Plus,y alpha];
covyy=Apply[Plus,alpha Map[Outer[Times,#,#]&,y]]
                         - Outer[Times,meany,meany];

covxy=Apply[Plus,alpha MapThread[Outer[Times,#1,#2]&,{x,y}]]
                               - Outer[Times,meanx,meany];

{meany, covyy, covxy}
]



(***************************************************************)
GaussIntegral//Clear
GaussIntegral[f_,{mue_,Sigma_},{a_,b_},Genau_]:=
(***************************************************************)
Module[{p=mue//Length,y,yy,iter,phi,i,z,Sigma1,int},

yy=Array[y,p];
iter=Apply[Sequence,Table[{y[i],a[[i]],b[[i]]},{i,p}]];
z=yy-mue;
Sigma1=Sigma//Inverse;
(*Print[Genau];*)
int=NIntegrate[f[yy]Exp[-0.5*z.Sigma1.z],iter//Evaluate,
				Method->GaussKronrod,
				AccuracyGoal->Genau,
				MaxPoints->Automatic];
    
int*GaussFaktor[Sigma]
]

(***************************************************************)
GaussIntegral1//Clear
GaussIntegral1[f_,{mue_,Sigma_},{a_,b_},Genau_]:=
(***************************************************************)
Module[{p=mue//Length,y,yy,iter,phi,i,z,Sigma1,int,Gamma},

zz=Array[z,p];
iter=Apply[Sequence,Table[{z[i],a,b},{i,p}]];

(*Print[Genau];*)
Gamma=Sigma//CholeskyDecomposition//Transpose;

int=NIntegrate[f[mue+Gamma.zz]Exp[-0.5*zz.zz],iter//Evaluate,
				Method->GaussKronrod,
				AccuracyGoal->Genau,
				MaxPoints->Automatic];
    
int*(2Pi)^(-p/2)
]

(***************************************************************)
GaussHermitePoints//Clear
GaussHermitePoints[m_]:=
(***************************************************************)
Module[{superdiag,null,JJ,vals,vecs,weight},

Print["Genauigkeit x^",2m-1];

superdiag=Sqrt[Range[m-1]/2]//N;
null=Shape[0,m];
JJ=TridiagonalMatrix[{superdiag,null,superdiag}];
{vals,vecs}=JJ//Eigensystem;
weight=vecs[[All,1]]^2;

{vals,weight}
]

(***************************************************************)
GaussHermitePoints1//Clear
GaussHermitePoints1[m_,text_:0]:=
(***************************************************************)
Module[{superdiag,null,JJ,vals,vecs,weight},

If[text===1,Print["Genauigkeit x^",2m-1]];

superdiag=Sqrt[Range[m-1]]//N; (*ohne 1/2; Gewicht N(0,1)*)
null=Shape[0,m];
JJ=TridiagonalMatrix[{superdiag,null,superdiag}];
{vals,vecs}=JJ//Eigensystem;
weight=vecs[[All,1]]^2;

{vals,weight}//Transpose//Sort//Transpose
]







(***************************************************************)
GaussHermitePointsMulti//Clear
GaussHermitePointsMulti[m_,{mue_,Sigma_}]:=
(***************************************************************)
Module[{Gamma,vals,weight,n},

n=mue//Length; 
(*n//Print;*)

{vals,weight}=GaussHermitePoints1[m];

vals  = Sequence@@Table[  vals,{i,n}];
weight= Sequence@@Table[weight,{i,n}];

Gamma = CholeskyDecomposition[Sigma]//Transpose;

vals  =Outer[(mue+Gamma.List[##])&,vals]; (*Transf. Stutzstellen*)
weight=Outer[Times,weight];

{vals,weight}
]

(***************************************************************)
GaussHermitePointsMulti2//Clear
GaussHermitePointsMulti2[m_,n_,eps_:10.^-16,ksigma_:Infinity,text_:0]:=
(***************************************************************)
(* Gewicht N(0,1) !!*)
Module[{vals1,weight1,sel},

{vals1,weight1}=GaussHermitePoints1[m];

sel=Position[Map[(Abs[#]<ksigma)&,vals1],True]//Flatten;
vals1=vals1[[sel]];
weight1=weight1[[sel]];

vals1  = tupel[vals1,n];   
weight1= tupel[weight1,n,Times]; 
sel=Position[Map[(#>eps)&,weight1],True]//Flatten;


If[text===1,

Print["Genauigkeit x^",2m-1,"; ",
      "Stuetzstellen: ",m^n,"; weight > ",eps//N, 
      " und |vals| < ", ksigma, ": ",sel//Length]
 ];
      
(*weight1//Print;*)

{vals1,weight1}={vals1[[sel]],weight1[[sel]]};

weight1=weight1/Plus@@weight1; (*Normierung auf 1*)

{vals1,weight1}
]













(***************************************************************)
Shift[H_, BOUND_, Text_:""] :=
(***************************************************************) 
Module[{H1, EIGEN, MINI, COND, minabs}, 
      EIGEN = Eigenvalues[H]; MINI = Min[EIGEN]; minabs = Min[Abs[EIGEN]]; 
      COND = If[minabs =!= 0, Max[Abs[EIGEN]]/minabs, Infinity]; 
      If[MINI < BOUND, 
      Print[Text, i, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", 
         EIGEN, "  BOUND  ", N[BOUND]]; 
      H1 = H + DiagonalMatrix[Array[BOUND - MINI &, {Length[H]}]], 
      H1 = H]; 
      Return[H1]];

(***************************************************************)
TrafoMueSigma//Clear
TrafoMueSigma[vals_,{mue_,Sigma_},shift_:0]:=
(***************************************************************)
Module[{Gamma,vals1},

Gamma = If[shift==0,
           CholeskyDecomposition[Sigma//Symmetrize]//Transpose,
           CholeskyDecomposition[Shift[Sigma//Symmetrize,shift]]//Transpose];

vals1 = Map[(mue+Gamma.#)&,vals]; (*Transf. Stuetzstellen*)

vals1
]

(***************************************************************)
GaussHermite2//Clear
GaussHermite2[g_,{vals_,weight_}]:=weight.Map[g,vals]
(***************************************************************)

(***************************************************************)
GaussHermiteA//Clear
GaussHermiteA[g_,m_,{mue_,Sigma_}]:=
(***************************************************************)
Module[{Gamma,z,n,superdiag,null,JJ,vals,vecs,weight,g1},
n=mue//Length; 
(*n//Print;*)
Print["Genauigkeit x^",2m-1];

superdiag=Sqrt[Range[m-1]]//N;
null=Shape[0,m];
JJ=TridiagonalMatrix[{superdiag,null,superdiag}];
{vals,vecs}=JJ//Eigensystem;
weight=vecs[[All,1]]^2;

weight=Sequence@@Table[weight,{i,n}];

Gamma = CholeskyDecomposition[Sigma]//Transpose;

g1//Clear;
g1[z_]:= g[mue+Gamma.(z)];
vals  = Sequence@@Table[vals,{i,n}];

Flatten[Outer[Times,weight]].Flatten[Outer[g1[List[##]]&,vals]]
(*Outer[Times,weight] Outer[g1[List[##]]&,vals]/.List->Plus*)

]

(***************************************************************)
GaussHermite//Clear
GaussHermite[g_,m_,{mue_,Sigma_},eps_:10^-16]:=
(***************************************************************)
Module[{Gamma,z,n,superdiag,null,JJ,vals,vecs,weight,g1},
n=mue//Length; 
(*n//Print;*)

superdiag=Sqrt[Range[m-1]]//N; (*ohne Sqrt[2]!!*)
null=Shape[0,m];
JJ=TridiagonalMatrix[{superdiag,null,superdiag}];
{vals,vecs}=JJ//Eigensystem;
weight=vecs[[All,1]]^2;

weight=tupel[weight,n,Times];

sel=Position[Map[(#>eps)&,weight],True]//Flatten;

(*
Print["Genauigkeit x^",2m-1,"  Stuetzstellen:",weight//Length,
		"  groesser ",eps//N//AccountingForm, " :",sel//Length];*)

Gamma = CholeskyDecomposition[Sigma]//Transpose;

vals  = tupel[vals,n];

weight[[sel]].Map[g[mue+Gamma.#]&,vals[[sel]]]


]

(***************************************************************)
GaussHermite1//Clear
GaussHermite1[g_,{vals_,weight_},{mue_,Sigma_},eps_:10^-16]:=
(***************************************************************)
Module[{Gamma,z,n,g1,vals1,weight1},
n=mue//Length; 
(*n//Print;*)

vals1  = tupel[vals,n]; 
weight1= tupel[weight,n,Times]; 
sel=Position[Map[(#>eps)&,weight1],True]//Flatten;

Gamma = CholeskyDecomposition[Sigma]//Transpose;

g1//Clear;
g1[z_]:= g[mue+Gamma.z];

weight1[[sel]].Map[g1,vals1[[sel]]]

]

TrapezFormel//Clear
(***************************************************************)
TrapezFormel[n_,{x0_,x1_}]:=
(***************************************************************)
Module[{dx,x,vals,wx,weight},

dx=(x1-x0)/n;
x=Range[x0,x1,dx];

vals=tupel1[x];

wx=Map[Shape[1,#]&,n+1];
wx[[All, 1]]=.5;
wx[[All,-1]]=.5;

dx=Times@@dx;
weight=tupel1[wx,Times]dx;

{vals,weight}

]

Needs["NumericalMath`GaussianQuadrature`"]

GaussFormel[n_, {x0_, x1_}] := 
Module[{X,vals,weight},
X=MapThread[(GaussianQuadratureWeights[#1, #2, #3]//Transpose)&,{n,x0,x1}]//Transpose;
vals  =tupel1[X[[1]]];
weight=tupel1[X[[2]],Times];
{vals,weight}]



RandomMultinomial//Clear
(***************************************************************)			 
RandomMultinomial[xij_,pij_,n_]:= 
(***************************************************************)			 
	Module[{u,U,pos,pcum,z,out},
	pcum = CumulativeSums[{0,pij}//Flatten];
	z = Last[pcum]; 
	(*Print["RandomMultinomial: Normierung  ",z];*)
    pcum = pcum/z;
    (*U = Table[Random[],{n}];*)
    
    out = 
    Table[
	u = Random[];
	Print[u];
	pos = Position[le[u,pcum],False]//Last;
	xij[[pos]]//Flatten,
	{n}];
	out
	]








xijpos//Clear
(***************************************************************)			 
xijpos[u_,xij_,pcum_]:= 
(***************************************************************)			 
Module[{pos},
pos = Position[le[u,pcum],False]//Last;
xij[[pos]]//Flatten
]

RandomMultinomial1//Clear
(***************************************************************)			 
RandomMultinomial1[xij_,pij_,n_,quote_:1]:= 
(***************************************************************)			 
	Module[{u,U,pos,pcum,z,out,i,c},
	(*quote = True: Quotenstichprobe*)
	
	pcum = CumulativeSums[{0,pij}//Flatten];
	z = Last[pcum]; 
	(*Print["RandomMultinomial: Normierung  ",z];*)
    pcum = pcum/z;
    c=0.5;
    
    U= If[quote==1, (Table[i,{i,n}]-c)/n,
       (*else*) 
       If[quote==2, Table[Random[],{n}]]
       ];
    
    (*U//Print;*)
    out = Map[xijpos[#,xij,pcum]&,U];
	out
	]

(***************************************************************)			 
RandomMultinomial1[xij_,pij_,n_,quote_,seed_]:= 
(***************************************************************)			 
	Block[{u,U,pos,pcum,z,out,i,c},
	(*quote = 1: Quotenstichprobe*)
	
	pcum = CumulativeSums[{0,pij}//Flatten];
	z = Last[pcum]; 
	(* Print["RandomMultinomial: Normierung  ",z]; *)
    pcum = pcum/z;
    c=0.5;
    
    U= If[quote==1, (Table[i,{i,n}]-c)/n,
       (*else*) 
       If[quote==2, cRandomC[n,1,seed]//Flatten,  
       (*else*) 
       If[quote==3, c=c+.5;(Table[i,{i,n}]+(cRandomC[n,1,seed]//Flatten)-c)/n
       ]]];
       
    (* U//Print; *)
    
    out = Map[xijpos[#,xij,pcum]&,U];
	out
	]

RandomNumbers//Clear
(***************************************************************)			 
RandomNumbers[{x1_,x2_,dx_},density_,n_]:= 
(***************************************************************)			 
Module[{range,z,xij,pij},
range = MapThread[Range[##]&,{x1,x2,dx}];
xij = Flatten[Apply[Outer[List,##]&,range],Length[range]-1];
pij = Map[density[##]&,xij] Apply[Times,dx]//Chop;

(*
Print["xij  ",xij];
Print["pij  ",pij]; 
*)

z = Apply[Plus,pij];
Print["RandomNumbers: Normierung  ",z];
If[z == 0,Print["Warnung: Gleichverteilung benutzt"];
		  Print["pij  ",pij]; 
		  pij = pij + 1./Length[pij]; z=1];

{z,RandomMultinomial[xij,pij/z,n]}
]








zufall//Clear
(***************************************************************)			 
zufall[Generator_,n_,p_,seed_,anti_]:=
(***************************************************************)			 
Block[{eps,n1},
SeedRandom[seed];
If[anti==1,n1=n/2,n1=n];
eps=If[Generator===cGaussC,

         (*Print[Generator,{n1,p,1.0,seed}]; *)
         
         cGaussC[n1,p,1.0,seed],
         
    (*else*)
         
         (*Print[Generator];*) 
         Table[Generator//ToExpression,{nn,n1},{pp,p}]
     ];
 If[anti==1,eps=Join[eps,-eps]];
 eps
  ]

RandomKDE//Clear
(***************************************************************)			 
RandomKDE[data_,Generator_,n_]:=
(***************************************************************)			 
Module[{m,sm,Y},
(* Zufallszahlen aus KDE[data] *)

{m,p}= data//Dimensions;
sm = smoothQuickAndDirtyM[data,2];
sm//Print;
Y = RandomMultinomial[data,Shape[1/m,{m}],n];
eps = Table[Generator//ToExpression,{nn,n},{pp,p}];
Z = Y + sm eps
]

(***************************************************************)			 
RandomKDE[data_,Gewichte_,Generator_,n_]:=
(***************************************************************)			 
Module[{m,sm,Y},
(* Zufallszahlen aus KDE[data] *)

{m,p}= data//Dimensions;
sm = smoothQuickAndDirtyM[data,2];
Print["sm  ",sm];
Y = RandomMultinomial[data,Gewichte,n];
eps = Table[Generator//ToExpression,{nn,n},{pp,p}];
Z = Y + sm eps
]





(***************************************************************)			 
RandomKDE[data_,Gewichte_,Cov_,Generator_,seed_,n_]:=
(***************************************************************)			 
Module[{m,p,mm,MM,eps,Std,Z,shift},
(* Zufallszahlen aus KDE[data] *)

{m,p}= data//Dimensions;
mm = m//Range;

	(*MM = RandomMultinomial[mm,Gewichte,n]//Flatten//Sort;*)
	(*MM = RandomMultinomial[mm,Gewichte,n]//Flatten;*)

    (*MM = RandomMultinomial1[mm,Gewichte,n]//Flatten//Sort;*)

MM = RandomMultinomial1[mm,Gewichte,n]//Flatten;

	(*"----------"//Print;*)
	(*Gewichte//Print;*)
	(*MM//Print;*)
	(*Column[data,2]//MS//Print;*)

shift = 10.^-14 * IdentityMatrix[p];(*falls Cov singul\[ADoubleDot]r*)

(*eps = Table[Generator[],{nn,n},{pp,p}];*)

SeedRandom[seed];
eps = If[Generator===cGaussC,

         (*Print[Generator,{n,p,1.0,seed}]; *)
         cGaussC[n,p,1.0,seed],
         
         (*else*)
         
         (*Print[Generator];*) 
         Table[Generator//ToExpression,{nn,n},{pp,p}]
        ];
        

Std = Map[Transpose[CholeskyDecomposition[#+shift]]&,Cov];
Z   = data[[MM]] + MapThread[Dot,{Std[[MM]],eps}];

	    (*
	    Print["Std ",Std];
		Print["Z     ",Z];
		Print["MM       ",MM];
		Print["data     ",data[[MM]] ];
		Print["eps      ",eps  ];
		Print["Std*eps  ",MapThread[Dot,{Std[[MM]],eps}] ];
		*)

		(* Column[Z,2]//MS//Print; *)

Z]

(***************************************************************)			 
RandomKDE1[data_,Gewichte_,Cov_,eps_,seed_,quote_]:=
(***************************************************************)	
		 
Module[{n,m,p,mm,MM,Std,Z,shift},
(* Zufallszahlen aus KDE[data] *)

{m,p}= data//Dimensions;  
mm = m//Range;

	(*MM = RandomMultinomial[mm,Gewichte,n]//Flatten//Sort;*)
	(*MM = RandomMultinomial[mm,Gewichte,n]//Flatten;*)

    (*MM = RandomMultinomial1[mm,Gewichte,n]//Flatten//Sort;*)

SeedRandom[seed];
MM = RandomMultinomial1[mm,Gewichte,n=Length[eps],quote,seed]//Flatten;


	(*"----------"//Print;      *)
	(*Gewichte//Print;          *)
	(*MM//Print;                *)
	(*Column[data,2]//MS//Print;*)

shift = 10.^-14 * IdentityMatrix[p];(*falls Cov singul\[ADoubleDot]r*)
       
Std = Map[Transpose[CholeskyDecomposition[Symmetrize[#+shift]]]&,Cov];
Z   = data[[MM]] + MapThread[Dot,{Std[[MM]],eps}];

	    (*
	    Print["Std ",Std];
		Print["Z     ",Z];
		Print["MM       ",MM];
		Print["data     ",data[[MM]] ];
		Print["eps      ",eps  ];
		Print["Std*eps  ",MapThread[Dot,{Std[[MM]],eps}] ];
		*)

		(* Column[Z,2]//MS//Print; *)

Z]

(***************************************************************)			 
RandomKDE2[data_,Gewichte_,Cov_,eps_,seed_,quote_]:=
(***************************************************************)	
		 
Module[{n,m,p,mm,MM,Std,Z,shift},
(* Zufallszahlen aus KDE[data] *)

{m,p}= data//Dimensions;
mm = m//Range;

	(*MM = RandomMultinomial[mm,Gewichte,n]//Flatten//Sort;*)
	(*MM = RandomMultinomial[mm,Gewichte,n]//Flatten;*)

    (*MM = RandomMultinomial1[mm,Gewichte,n]//Flatten//Sort;*)

SeedRandom[seed];
MM = RandomMultinomial1[mm,Gewichte,n=Length[eps],quote,seed]//Flatten;

	(*"----------"//Print;*)
	(*Gewichte//Print;*)
	(*MM//Print;*)
	(*Column[data,2]//MS//Print;*)

shift = 10.^-14 * IdentityMatrix[p];(*falls Cov singul\[ADoubleDot]r*)
       
Std = Map[Transpose[CholeskyDecomposition[Symmetrize[#+shift]]]&,Cov];
Z   = data[[MM]] + MapThread[Dot,{Std[[MM]],eps}];

	    (*
	    Print["Std ",Std];
		Print["Z     ",Z];
		Print["MM       ",MM];
		Print["data     ",data[[MM]] ];
		Print["eps      ",eps  ];
		Print["Std*eps  ",MapThread[Dot,{Std[[MM]],eps}] ];
		*)

		(* Column[Z,2]//MS//Print; *)

{Z,MM}]

(***************************************************************)			 
RandomGauss//Unprotect;
RandomGauss//Clear;
RandomGauss[X_,Theta_,{mue_,sigma_},n_?IntegerQ,Generator_:"Gauss[]"]:=
(***************************************************************)			 
Module[{m,s,s2},
m =   mue[X,Theta];
s = sigma[X,Theta];
s2 = CholeskyDecomposition[s];
Map[Plus[m,#]&,Table[Generator//ToExpression,{n},{Length[m]}].s2]
]

(***************************************************************)			 
RandomGauss[mue_,sigma_,n_?IntegerQ,Generator_:"Gauss[]",Anti_:0]:=
(***************************************************************)			 
Module[{s2,z},
s2 = CholeskyDecomposition[sigma];

(*Print[Generator,"  ",Anti];*)

If[Anti==0,
	z=Table[Generator//ToExpression,{n},{Length[mue]}],
	(*Anti==1*)
	z=Table[Generator//ToExpression,{n/2},{Length[mue]}];
	z=Join[z,-z]
];

Map[Plus[mue,#]&,z.s2]
]

Protect[RandomGauss]









(***************************************************************)			 
Quote[alpha_]:= 
(***************************************************************)			 
	Module[{factor,an,nn, n = Length[alpha]},
	
	factor = Min[DeleteCases[alpha//Chop//N,0]];
	factor = 1/n //N;
	(*factor//Print;*)
	an = alpha n //Round;
	
    nn = Apply[Plus,an];
  
    If[nn == n,Return[APLExpand[an,n//Range]//Flatten],
    (*else*)
    
	Do[
    an = (alpha + factor Table[Random[]-.5,{n}]) n //Round;
    nn = Apply[Plus,an];
    nn//Print;
    If[nn == n,Break[]];
    ,{20}];
   
    Return[APLExpand[an,n//Range]//Flatten]
    ];
	]

alphanorm//Clear
(***************************************************************)			 
alphanorm[x_]:= x/Apply[Plus,x];
(***************************************************************)
alphanorm//Protect;			 






alphanorm[{1,2.}]



Sortieren//Clear
(***************************************************************)			 
Sortieren[{yii_,Pii_,alphaii_},sort_]:=
(***************************************************************)			 
Block[{perm,krit},

krit=
If[sort==1,Map[pNorm,yii//N],       (*else*)
If[sort==2,Map[MatrixTrace,Pii//N], (*else*)
If[sort==3,alphaii//N,              (*else*)
If[sort<0 ,col=Column[yii,-sort]
]]]]; 


perm=PlatzInUngeordneterListe[krit];

{yii[[perm]],Pii[[perm]],alphaii[[perm]]} 

]

Resampling//Clear
(***************************************************************)			 
Resampling[{yii_,Pii_,alphaii_,N1_},eps_,seed_,{quote_,tanner_}]:= 
(***************************************************************)			 
Module[{MM,yiiR,alphai1i},

If [tanner==0,

    yiiR = RandomKDE1[yii,alphaii,Pii,eps,seed,quote]; 
	alphai1i=N1,

(*else*)

	If[ (tanner==1||tanner==2), 
	
		{yiiR,MM}=RandomKDE2[yii,N1,Pii,eps,seed,quote];     (* 1=quote, 2=uni, 3=sobol, 4=uni/geschichtet *)
		alphai1i=alphaii[[MM]];                              (* unnormiert! *)
		If[ (tanner==2) , alphai1i=alphanorm[alphai1i]];     (* normiert *)
	  ]
    ];
	
{yiiR,alphai1i}]	



(***************************************************************)			 
TimeUpFokker//Clear
TimeUpFokker[{Yii_,X_,$dw$_,dt_},Theta_,{f_,g_},step_:EulerStep1]:=
(***************************************************************)			 
	(*mit gegebenen Zufallszahlen dw*) 
	Block[{T,n,Y,Yi1i},
	n = $dw$//Length;
	T = Length[X]-1;
	Y = MapThread[RungeKutta1[f,g,#1,{X,#2},T,dt,Theta,step]&,{Yii,$dw$}];
	Yi1i = Last/@Y;
	{Yi1i,Y}
]

(***************************************************************)			 
TimeUpEKF//Clear
TimeUpEKF[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_,Dg_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,A,G,Omega,B,BPB,AP,Yi1i,Pi1i,Y,P},

T = Length[X]-1;
p = Length[Yii];
pp = p//Range;
{p,rr} = g[Yii,X[[1]],Theta]//Dimensions;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

Do[ 
	xi = X[[i]];
    A = Df[Yi1i,xi,Theta]; 
    G =  g[Yi1i,xi,Theta];
    Omega = G.Transpose[G];
    
    B = Dg[Yi1i,xi,Theta];	
	BPB = Sum[  Bl = B[[pp,l,pp]];
				Bl.Pi1i.Transpose[Bl], {l,rr}];
						
	(*
	BPB dt //Print;
	Omega dt//Print;
	*)
	
	Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;
	
	(*
	AP = A.Pi1i;   
	Pi1i = Pi1i + (AP + Transpose[AP] + BPB + Omega) dt; 
	*)
	
	(*Variante*)
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + (BPB + Omega) dt; 
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpEKF[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Y,P,Astern},

T = Length[X]-1;

Yi1i = Yii;
Pi1i = Pii;

(*IP = IdentityMatrix[Yii//Length];*)

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;


Do[ 

	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	(*If[OVERFLOW,Pi1i=Shift[Pi1i,10^-8];OVERFLOW=False];*)
	
	
	xi = X[[i]];   (*Print["xi in Timeup",xi];*) 
	
    A = Df[Yi1i,xi,Theta];  (*A//Print; *)
    
    G =  g[Yi1i,xi,Theta];  (*G//Print;*)
    Omega = G.Transpose[G]; (*Omega//Print;*)  
    
   
    Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;  (*Print["Yi1i in Timeup",Yi1i]; *)
   	
   	(*
	AP   = A.Pi1i;
	Pi1i = Pi1i + (AP + Transpose[AP] + Omega) dt;
	*)
	 
	(*Astern = IP + A dt;*)
	
	
	
	Astern = IdPlusA[A dt]; (*Astern//Print;*)
	
	(*Print["Timeup",(Astern.Pi1i.Transpose[Astern])~ii~(Omega dt)//MatrixForm];*)
	
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;  (*Var(y+fdt+gdW)*)
	   
	(*Pi1i//Print;*)
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]


(***************************************************************)			 
TimeUpSumFilter[{Yii_,Pii_,alphaii_,X_,dt_,corr_},Theta_,{f_,Df_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Y,P,Astern,mue,muen,QneuQ,Qalt,dQ},

T = Length[X]-1;

Yi1i = Yii;
Pi1i = Pii;

n=Yii//Length;

Y = Shape[1,{n,T+1}];
Y[[All,1]]  = Yii;
P = Shape[1,{n,T+1}];
P[[All,1]] = Pii;

If[corr,
mue  = WeightedMean[Yii,alphaii];
muen = Map[(#-mue)&,Yii];
Qalt = Map[Outer[Times,#,#]&,muen]
];


Do[ 
    (*
	i//Print;
    Yi1i//Print;
	Pi1i//Print;
	*)
	
	
	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 	
	
	xi = X[[i]];   (*Print["xi in Timeup",xi];*) 
	
    A = Map[Df[#,xi,Theta]&,Yi1i];  (*A//Print; *)
    
    G =  Map[g[#,xi,Theta]&,Yi1i];  (*G//Print;*)
    
    Omega = Map[#.Transpose[#]&,G]; (*Omega//Print;*)  
    
   
    Yi1i = Yi1i + Map[f[#,xi,Theta]&,Yi1i] dt;  (*Print["Yi1i in Timeup",Yi1i]; *)	
	
	
	Astern = Map[IdPlusA[#]&,A dt]; (*Astern//Print;*)
	
	If[corr,
	mue  = WeightedMean[Yi1i,alphaii];
	muen = Map[(#-mue)&,Yi1i];
	Qneu = Map[Outer[Times,#,#]&,muen];
	dQ   = Qneu-Qalt
	];
	
	
	(*
	Print["Pi1i",Pi1i];
	Print["Omega dt",Omega dt];
	Print["dQ  ",dQ];
	*)
	
	
	Pi1i = MapThread[#1.#2.Transpose[#1]&,{Astern,Pi1i}] + Omega dt; 
	       (*Var(y+fdt+gdW)*)
	
	If[corr,
	Pi1i=Pi1i-dQ;
	Qalt=Qneu
	];
	
	Pi1i=Map[Shift[#,10^-8]&,Pi1i];
	 
	(*Pi1i//Print;*)
	
	Y[[All,i+1]] = Yi1i;
	P[[All,i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]


(***************************************************************)			 
TimeUpEKFJacobi[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_},Nonlin_]:=
(***************************************************************)
(* mit EMM, LL: Nonlin=1*)	
		 
Block[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Y,P,Astern,Bstern,Ostern,Asterni,b},

T = Length[X]-1;

Yi1i = Yii;
Pi1i = Pii;

(*IP = IdentityMatrix[Yii//Length];*)

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;
Astern=Shape[1,{T}]; 


Do[ 
	xi = X[[i]];   (*Print["xi in Timeup",xi];*) 
	
    A = Df[Yi1i,xi,Theta];  			(*A//Print; *)
    
    G =  g[Yi1i,xi,Theta]; 			    (*G//Print;*)
    Omega = G.Transpose[G]; 		    (*Omega//Print;*)  
    
    If[Nonlin==0,
    	Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;  
    									(*Print["Yi1i in Timeup",Yi1i]; *)	
		Asterni = IdPlusA[A dt]; 		(*Asterni//Print;*)
										(*Print["Timeup",(Astern.Pi1i.Transpose[Astern])~ii~(Omega dt)//MatrixForm];*)
		Pi1i = Asterni.Pi1i.Transpose[Asterni] + Omega dt,
		
	(*else*)
	     
	     (*
	     b=f[Yi1i,xi,Theta] - A.Yi1i;
	    {Ostern,Asterni,Bstern} = STERN01R[Omega,A,b,dt,Nonlin];
		 Yi1i = Asterni.Yi1i + Bstern;
		 *)
		 
		 {Ostern,Asterni,Bstern} = STERN01R[Omega,A,1,dt,Nonlin];
		 Yi1i = Yi1i + Bstern.f[Yi1i,xi,Theta]; (*Bstern=A1*)
		 
		  
		 Pi1i = Asterni.Pi1i.Transpose[Asterni] + Ostern;
	 ]; 
	 
		(*Pi1i//Print;*)
		
		
	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	
	Y[[i+1]]    = Yi1i;
	P[[i+1]]    = Pi1i;
	Astern[[i]] = Asterni;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P,Astern}]


(***************************************************************)			 
TimeUpEKFEDM//Clear
TimeUpEKFEDM[{Yii_,Pii_,X_,dt_},Theta_,
             {f_,Df_,g_,
             OsternX_,AsternX_,A1X_,BsternX_,AX_},
             {Nonlin_,const_}]:=
(***************************************************************)			 
Module[{T,p,i,xi,A,A1,B,G,Omega,Yi1i,Pi1i,Y,P,Ostern,Astern,Bstern},

T = Length[X]-1;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;


Do[ 
	xi = X[[i]];
	
	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	If[const==False,
	
    A = Df[Yi1i,xi,Theta]; 
    G =  g[Yi1i,xi,Theta];
    Omega = G.Transpose[G];
     
    (*B = (f[Yi1i,xi,Theta] - A.Yi1i) //Spalte;*)
	(*{Ostern,Astern,Bstern} = STERN01R[Omega,A,B,dt,Nonlin];*)
	
	{Ostern,Astern,A1} = 
	If[Det[A]==0,
	STERN01R1[Omega,A,1,dt,Nonlin],
	STERN01R [Omega,A,1,dt,Nonlin]
	];

		(*
		Print[{Omega,A,B}//TableForm];
		Print[{V,Astern,Bstern}//TableForm];
		*)
			
	(*Yi1i = Astern.Yi1i + Flatten[Bstern];*)
	Yi1i = Yi1i + A1.f[Yi1i,xi,Theta];	
	
		
	Pi1i = Astern.Pi1i.Transpose[Astern] + Ostern
	
	
	
	,(*else konstantes A, f = Ay + b xi*)
	
	(*
	B = (f[Yi1i,xi,Theta] - AX.Yi1i);  (* B = b xi*)
	Bstern=A1X.B;
	Yi1i = AsternX.Yi1i + Bstern;
	*)
	
	
	Yi1i = Yi1i + A1X.f[Yi1i,xi,Theta];
	
	Pi1i = AsternX.Pi1i.Transpose[AsternX] + OsternX
	
	];
		
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

(*Y//MatrixForm//Print;*)

{Yi1i,Pi1i,Y,P}]














(***************************************************************)			 
TimeUpEKFSmooth//Clear
TimeUpEKFSmooth[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Astern,Phi,F},

T = Length[X]; (* T//Print; *)

Yi1i = Yii;
Pi1i = Pii;
Phi = IdentityMatrix[Yii//Length];


Do[ 
	xi = X[[i]];
	
    A = Df[Yi1i,xi,Theta]; 
    
    G =  g[Yi1i,xi,Theta]; 
    Omega = G.Transpose[G];
    
   
    Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;
   		
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;   
	
	Phi = Astern.Phi;  (* Phi//Print; *)
	
	
,{i,1,T}];

F = Pii.Transpose[Phi].Inverse[Pi1i];

{Yi1i,Pi1i,F}]


(***************************************************************)			 
TimeUpEKFSmoothIter//Clear
TimeUpEKFSmoothIter[{Yii_,xiref_,Pii_,X_,dt_},Theta_,{f_,Df_,g_}]:=
(***************************************************************)
(* xiref = A.B. der Referenztrajektorie xiref(t_i) *)
			 
Block[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Astern,Phi,F},

T = Length[X]; (* T//Print; *)

Yi1i = xiref;
Pi1i = Pii;
Phi  = IdentityMatrix[Yii//Length];


Do[ 
	xi = X[[i]];
	
    A = Df[Yi1i,xi,Theta]; 
    
    G =  g[Yi1i,xi,Theta]; 
    Omega = G.Transpose[G];
    
   
    Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;
   		
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;   
	
	Phi = Astern.Phi;  (* Phi//Print; *)
	
	
,{i,1,T}];

F    = Pii.Transpose[Phi].Inverse[Pi1i];
Yi1i = Yi1i + Phi.(Yii-xiref);

{Yi1i,Pi1i,F,Phi}]


(***************************************************************)			 
TimeUpEKFSmooth2//Clear
TimeUpEKFSmooth2[{Yii_,_,X_,dt_},Theta_,{f_,Df_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Astern,Phi,Pj1j,F},

T = Length[X];  (* T//Print; *)
p = Yii//Length;


xi = X[[1]];
	
A = Df[Yii,xi,Theta]; 
    
G =  g[Yii,xi,Theta]; 
Omega = G.Transpose[G];

Phi  = IdentityMatrix[p];    
   
Yi1i = Yii + f[Yii,xi,Theta] dt;
Pi1i = Pj1j = Omega dt;   
	
Do[ 
	xi = X[[i]];
	
    A = Df[Yi1i,xi,Theta]; 
    
    G =  g[Yi1i,xi,Theta]; 
    Omega = G.Transpose[G];
    
   
    Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;
   		
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;   
	
	Phi = Astern.Phi;  (* Phi//Print; *) (* Phi(t_i+1,tau_j *)
		
,{i,2,T}];

F = Pj1j.Transpose[Phi].Inverse[Pi1i]; (* Gain f\[UDoubleDot]r \[CapitalUDoubleDot]bergangsw.*)

(* Print["Korr. \[CapitalUDoubleDot]  ",T,Yi1i]; *)

{Yi1i,Pi1i,F}]



TimeUpEKF2//Clear
(***************************************************************)			 
TimeUpEKF2[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,DDf_,g_}]:=
(***************************************************************)			 
Module[{T,p,i,xi,DA,A,G,Omega,AP,Yi1i,Pi1i,Y,P,Astern},

T = Length[X]-1;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;


Do[ 

    {Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	xi = X[[i]];
	

    A  =  Df[Yi1i,xi,Theta];
    DA = DDf[Yi1i,xi,Theta];
    G  =   g[Yi1i,xi,Theta]; 
    Omega = G.Transpose[G];
    
    Yi1i = Yi1i + (f[Yi1i,xi,Theta] + .5 Map[MatrixTrace,DA.Pi1i]) dt;
     
                (*Korrektur 2. Ordnung = Ito-Taylor Entwicklung*)
   	
   	
   	(*
	AP   = A.Pi1i;
	Pi1i = Pi1i + (AP + Transpose[AP] + Omega) dt + AP.Transpose[A]dt^2;
	Pi1i//Eigenvalues//Print;
	*)
	
		 
	(* Astern = IP + A dt;*)
	
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;  
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]


(***************************************************************)			 
TimeUpEKF4//Clear
TimeUpEKF4[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,DDf_,Omega_,DDOmega_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,A,DA,O,DDO,AP,Yi1i,Pi1i,Y,P},

T = Length[X]-1;
p = Length[Yii];
pp = p//Range;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

Do[ 
	xi =   X[[i]];
    A  =  Df[Yi1i,xi,Theta]; 
    DA = DDf[Yi1i,xi,Theta]; 
    O  =   Omega[Yi1i,xi,Theta];
    DDO= DDOmega[Yi1i,xi,Theta];
  	
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] + .5 Map[MatrixTrace,DA.Pi1i]) dt;
	 
             (* Korrektur 2. Ordnung = Ito-Taylor Entwicklung *)
	
	(*
	AP = A.Pi1i;   
	Pi1i = Pi1i + (AP + Transpose[AP] + 
	               O + 0.5 Map[MatrixTrace[#.Pi1i]&,DDO,{2}]) dt; 
	*)
	
	(*Variante*)
	
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + 
	       (O + 0.5 Map[MatrixTrace[#.Pi1i]&,DDO,{2}]) dt; 
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpEKF4alt//Clear
TimeUpEKF4alt[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,DDf_,g_,Dg_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,A,G,Omega,B,BPB,AP,Yi1i,Pi1i,Y,P},

T = Length[X]-1;
p = Length[Yii];
pp = p//Range;
{p,rr} = g[Yii,X[[1]],Theta]//Dimensions;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

Do[ 
	xi =   X[[i]];
    A  =  Df[Yi1i,xi,Theta]; 
    DA = DDf[Yi1i,xi,Theta]; 
    G  =   g[Yi1i,xi,Theta];
    Omega = G.Transpose[G];
    
    B = Dg[Yi1i,xi,Theta];	
	BPB = Sum[  Bl = B[[pp,l,pp]];
				Bl.Pi1i.Transpose[Bl], {l,rr}];
						
	(*
	BPB dt //Print;
	Omega dt//Print;
	*)
	
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] + .5 Map[MatrixTrace,DA.Pi1i]) dt;
	 
             (*Korrektur 2. Ordnung = Ito-Taylor Entwicklung*)
	
	(*
	AP = A.Pi1i;   
	Pi1i = Pi1i + (AP + Transpose[AP] + BPB + Omega) dt; 
	*)
	
	(*Variante*)
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + (BPB + Omega) dt; 
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpHNF24//Clear
TimeUpHNF24[{Yii_,Pii_,X_,dt_},Theta_,
            {f_,Df_,DDf_,DDDf_,DDDDf_,Omega_,DDOmega_,DDDDOmega_},
            {M6anal_,Sanal_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,Astern,f1,f2,f3,f4,O,O2,O4,PP,M4,
        Yi1i,Pi1i,Y,P},

 (*Var(y+f dt) = Var(y) + 2Cov(f,y)dt + Cov(f,f)dt^2
                  = P + ( 2 f'P + 2/6 f'''M4)dt + 
                    
                    (f'^2 P + 1/4 f''^2 (M4-P^2)
                     + 1/36 f'''^2 M6 + 
                       1/3  f'f''' M4)dt^2
 *)
 
T = Length[X]-1;
p = Length[Yii];
pp = p//Range;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

c24=1/24;


Do[ (*i//Print;*)

	xi =  X[[i]];
    f1 =        Df[Yi1i,xi,Theta];
    f2 =       DDf[Yi1i,xi,Theta];
    f3 =      DDDf[Yi1i,xi,Theta];
    f4 =     DDDDf[Yi1i,xi,Theta];
    O  =     Omega[Yi1i,xi,Theta];
    O2 =   DDOmega[Yi1i,xi,Theta];
    O4 = DDDDOmega[Yi1i,xi,Theta];
       
    PP = Outer[Times,Pi1i,Pi1i]; 
    M4 = PP+Transpose[PP,{1,3,2,4}]+Transpose[PP,{1,3,4,2}]; (*Gauss-Fakt.*)
    m4 = Flatten[M4];
  	
    (*
    diagP = DiagonalMatrix[Pi1i//VecDiag];
    M6=15 Outer[Times,diagP,diagP,diagP];
    *)
    
    M6=MMnum[M6anal,Sanal,Pi1i];
  	
    PM4=Outer[Times,Pi1i,M4];
    
    f223  = flatten[f2,{2,3}];
    f3234 = flatten[f3,{2,3,4}];
    f42345= flatten[f4,{2,3,4,5}];
    
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] 
	            +  0.5 f223.Flatten[Pi1i]
	            + c24 flatten[f4,{2,3,4,5}].m4)*dt;
	 
             (* Korrektur 2. und 4. Ordnung = Ito-Taylor Entwicklung *)
	
	(*Yi1i//Print;*)
	
	Astern = IdPlusA[f1 dt]; (*enth\[ADoubleDot]lt f'^2 P dt^2*)
	
	f2M4f2= 1/4 f223.flatten[flatten[M4-PP,{1,2}],{2,3}].Transpose[f223]; 
   		 (*f2M4f2//Print;*) 
   	
	f3M4  = 1/6 f3234.flatten[M4,{1,2,3}]; 
		 (*f3M4//Print;*)
  
    f3M6f3= 1/36 f3234.flatten[flatten[M6,{1,2,3}],{2,3,4}].Transpose[f3234];
   		 (*f3M6f3//Print;*)
   		 
    f1M4f3= 1/6 f1.flatten[M4,{2,3,4}].Transpose[f3234];
   		 (*f1M4f3//Print;*)
   		 
    f2M6f4= 1/48 f223.flatten[flatten[M6-PM4,{1,2}],{2,3,4,5}].Transpose[f42345];
		 (*f2M6f4//Print;*)
	
	(*f4M8f4= (1/24)^2 f42345.flatten[flatten[M8-M4M4,{}],{}].Transpose[f42345]*)
	
	
	Pi1i = Astern.Pi1i.Transpose[Astern] 
	
	       + dt(f3M4 + Transpose[f3M4]
	            + O 
	            + 0.5 flatten[O2,{3,4}].Flatten[Pi1i]
	            + c24 flatten[O4,{3,4,5,6}].Flatten[M4]
	            )
	         
	         
	       + dt^2(f2M4f2
	             +f3M6f3
	             +f1M4f3+Transpose[f1M4f3]
	             +f2M6f4+Transpose[f2M6f4]
	             (*+f4M8f4+Transpose[f4M8f4]*)
	              );     
	         
	
	(*Variante ohne O(dt^2)*)
	
	(*
	f1Pi1i=f1.Pi1i;
	
	Pi1i = Pi1i + (f1Pi1i + Transpose[f1Pi1i])dt
	
	            + (f3M4 + Transpose[f3M4]
	            + O + 0.5 flatten[O2,{3,4}].Flatten[Pi1i]
	            + c24 flatten[O4,{3,4,5,6}].Flatten[M4])*dt;
	*)
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpHNF22alt//Clear
TimeUpHNF22alt[{Yii_,Pii_,X_,dt_},Theta_,
            {f_,Df_,DDf_,Omega_,DDOmega_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,Astern,f1,f2,f3,f4,O,O2,O4,PP,M4,
        Yi1i,Pi1i,Y,P},

 (*Var(y+f dt) = Var(y) + 2Cov(f,y)dt + Cov(f,f)dt^2
                  = P + 2 f'P dt + (f'^2 P + 1/4 f''^2 (M4-P^2)) dt^2
 *)
 
T = Length[X]-1;
p = Length[Yii];
pp = p//Range;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

c24=1/24;


Do[ (*i//Print;*)

	xi =  X[[i]];
    f1 =        Df[Yi1i,xi,Theta];
    f2 =       DDf[Yi1i,xi,Theta];
    O  =     Omega[Yi1i,xi,Theta];
    O2 =   DDOmega[Yi1i,xi,Theta];
       
    PP = Outer[Times,Pi1i,Pi1i]; 
    M4 = PP+Transpose[PP,{1,3,2,4}]+Transpose[PP,{1,3,4,2}]; (*Gauss-Fakt.*)
    
    f223  = flatten[f2,{2,3}]; (*f223//Print;*)
    (*f223  = Partition[Flatten[f2],p*p];*) (*f223//Print;*)
  	
  	
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] + 0.5 f223.Flatten[Pi1i])*dt;
	 
             (* Korrektur 2. Ordnung = Ito-Taylor Entwicklung *)
	
	Astern = IdPlusA[f1 dt]; (*enth\[ADoubleDot]lt f'^2 P dt^2*)
	
	f2M4f2= 1/4 f223.flatten[flatten[M4-PP,{1,2}],{2,3}].Transpose[f223];
   		 (*f2M4f2//Print;*)
	
	(*f2M4f2= 1/4 f223.Partition[Flatten[M4-PP],p*p].Transpose[f223];*)
   	    (* f2M4f2//Print;*)
	
	
	Pi1i = Astern.Pi1i.Transpose[Astern] 
	
	       + dt(O + 0.5 flatten[O2,{3,4}].Flatten[Pi1i])
	                  
	       + dt^2 * f2M4f2;     
	            
	
	(*Variante ohne O(dt^2)*)
	(*
	f1Pi1i=f1.Pi1i;
	
	Pi1i = Pi1i + (f1Pi1i + Transpose[f1Pi1i] + O)dt;
	
	*)
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpHNF22//Clear
TimeUpHNF22[{Yii_,Pii_,X_,dt_},Theta_,
            {f_,Df_,DDf_,Omega_,DDOmega_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,Astern,f1,f2,f3,f4,O,O2,O4,PP,M4,M4mPP,
        Yi1i,Pi1i,Y,P},

 (*Var(y+f dt) = Var(y) + 2Cov(f,y)dt + Cov(f,f)dt^2
                  = P + 2 f'P dt + (f'^2 P + 1/4 f''^2 (M4-P^2)) dt^2
 *)
 
T = Length[X]-1;
p = Length[Yii];
pp = p//Range;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

c24=1/24;


Do[ (*i//Print;*)

	xi =  X[[i]];
    f1 =        Df[Yi1i,xi,Theta];
    f2 =       DDf[Yi1i,xi,Theta];
    O  =     Omega[Yi1i,xi,Theta];
    O2 =   DDOmega[Yi1i,xi,Theta];
       
    PP = Outer[Times,Pi1i,Pi1i]; 
    M4mPP = Transpose[PP,{1,3,2,4}]+Transpose[PP,{1,3,4,2}]; (*Gauss-Fakt.*)
    
    (*f223  = flatten[f2,{2,3}]; *) (*f223//Print;*)
    f223  = Partition[Flatten[f2],p*p]; (*f223//Print;*)
  	
  	
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] + 0.5 f223.Flatten[Pi1i])*dt;
	 
             (* Korrektur 2. Ordnung = Ito-Taylor Entwicklung *)
	
	Astern = IdPlusA[f1 dt]; (*enth\[ADoubleDot]lt f'^2 P dt^2*)
	
	(*f2M4f2= 1/4 f223.flatten[flatten[M4mPP,{1,2}],{2,3}].Transpose[f223];*)
   		 (*f2M4f2//Print;*)
	
	f2M4f2= 1/4 f223.Partition[Flatten[M4mPP],p*p].Transpose[f223];
   	    (* f2M4f2//Print;*)
	
	
	Pi1i = Astern.Pi1i.Transpose[Astern] 
	
	       + dt(O + 0.5 Partition[Partition[Flatten[O2],p*p].Flatten[Pi1i],p])
	                  
	       + dt^2 * f2M4f2;     
	            
	
	(*Variante ohne O(dt^2)*)
	(*
	f1Pi1i=f1.Pi1i;
	
	Pi1i = Pi1i + (f1Pi1i + Transpose[f1Pi1i] + O)dt;
	
	*)
	
	(*{i,Yi1i,Pi1i}//Print;*)
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpHNF23//Clear
TimeUpHNF23[{Yii_,Pii_,X_,dt_},Theta_,
            {f_,Df_,DDf_,DDDf_,Omega_,DDOmega_},
            {M6anal_,Sanal_}]:=
(***************************************************************)			 
Module[{T,p,pp,rr,i,xi,Astern,f1,f2,f3,f4,O,O2,O4,PP,M4,M6,
        Yi1i,Pi1i,Y,P},

 (*Var(y+f dt) = Var(y) + 2Cov(f,y)dt + Cov(f,f)dt^2
                  = P + ( 2 f'P + 2/6 f'''M4)dt + 
                    
                    (f'^2 P + 1/4 f''^2 (M4-P^2)
                     + 1/36 f'''^2 M6 + 
                       1/3  f'f''' M4)dt^2
 *)
 
T = Length[X]-1;
p = Length[Yii];
pp = p//Range;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

c24=1/24;


Do[ (*i//Print;*)

	xi =  X[[i]];
    f1 =        Df[Yi1i,xi,Theta];
    f2 =       DDf[Yi1i,xi,Theta];
    f3 =      DDDf[Yi1i,xi,Theta];
    O  =     Omega[Yi1i,xi,Theta];
    O2 =   DDOmega[Yi1i,xi,Theta];
       
    PP = Outer[Times,Pi1i,Pi1i]; 
    M4 = PP+Transpose[PP,{1,3,2,4}]+Transpose[PP,{1,3,4,2}]; (*Gauss-Fakt.*)
  	
    (*
    diagP = DiagonalMatrix[Pi1i//VecDiag];
    M6=15 Outer[Times,diagP,diagP,diagP];
    *)
    
    M6=MMnum[M6anal,Sanal,Pi1i];
    
    f223  = flatten[f2,{2,3}];
    f3234 = flatten[f3,{2,3,4}];
    
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] 
	            +  0.5 f223.Flatten[Pi1i])*dt;
	 
             (* Korrektur 2. Ordnung = Ito-Taylor Entwicklung *)
	
	
	Astern = IdPlusA[f1 dt]; (*enth\[ADoubleDot]lt f'^2 P dt^2*)
	
	
	f2M4f2= 1/4 f223.flatten[flatten[M4-PP,{1,2}],{2,3}].Transpose[f223]; 
   		 (*f2M4f2//Print;*)
   	
	f3M4  = 1/6 f3234.flatten[M4,{1,2,3}]; 
		 (*f3M4//Print;*)
  
    f3M6f3= 1/36 f3234.flatten[flatten[M6,{1,2,3}],{2,3,4}].Transpose[f3234];
   		 (*f3M6f3//Print;*)
   		 
    f1M4f3= 1/6 f1.flatten[M4,{2,3,4}].Transpose[f3234];
   		 (*f1M4f3//Print;*)
   	
   	
   	(*
   	Pi1i = Astern.Pi1i.Transpose[Astern]
	
	       + dt(f3M4 + Transpose[f3M4]
	            + O 
	            + 0.5 flatten[O2,{3,4}].Flatten[Pi1i]
	            )
	                
	       + dt^2(
	              f2M4f2
	             +f3M6f3
	             +f1M4f3+Transpose[f1M4f3]
	              );     
	 *)      
	
	(*Variante ohne O(dt^2)*)
	
	f1Pi1i=f1.Pi1i;
	
	Pi1i = Pi1i + (f1Pi1i + Transpose[f1Pi1i])dt
	
	            + (f3M4 + Transpose[f3M4]
	            + O + 0.5 flatten[O2,{3,4}].Flatten[Pi1i])*dt;
	
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

		 
(***************************************************************)			 
TimeUpEKF[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_},{Y0_,P0_,IP_}]:=
(***************************************************************)			 
Module[{T,p,i,xi,A,G,Omega,AP,Yi1i,Pi1i,Y,P,Astern},

T = Length[X]-1;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;


Do[ 
	xi = X[[i]];
	

    A = Df[Yi1i,xi,Theta]; 
    G =  g[Yi1i,xi,Theta]; 
    Omega = G.Transpose[G];
    
    Yi1i = Yi1i + f[Yi1i,xi,Theta] dt;
   		(*
		AP   = A.Pi1i;
		Pi1i = Pi1i + (AP + Transpose[AP] + Omega) dt;
		*) 
	Astern = IP + A dt;
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;         
	
	If[Max[Abs[Yi1i]] > YMAX,
		    	Print["possible divergence, i = ",i];
		    	Yi1i = Y0;
		    	Pi1i = P0 ];
	    	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]

(***************************************************************)			 
TimeUpDKS[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_}]:=
(***************************************************************)			 
Module[{T,TT,G,Omega,Yi1i,Pi1i,Y,P,ff},

T = Length[X]-1;
TT = Range[0,T]dt;
G =  g[Yii,X[[1]],Theta];
Omega = G.Transpose[G];
P = Map[Times[Omega,#]&,TT];
Pi1i = P//Last; 
Y = Map[Plus[Yii,#]&, Map[Times[f[Yii,X[[1]],Theta],#]&,TT]];
Yi1i = Y//Last;   

{Yi1i,Pi1i,Y,P}]

TimeUpShojiOzaki//Clear
(***************************************************************)			 
TimeUpShojiOzaki[{Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,DDf_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,DA,A,G,Omega,AP,Yi1i,Pi1i,Y,P,Astern,b1,b2,fi},

T = Length[X]-1;

Yi1i   = Yii;
Pi1i   = Pii;

Y      = Shape[1,{T+1}];
Y[[1]] = Yii;
P      = Shape[1,{T+1}];
P[[1]] = Pii;

xi     = X[[1]];
fi     = f[Yii,xi,Theta];
A      = Df[Yii,xi,Theta];
DA     = DDf[Yii,xi,Theta];
Astern = IdPlusA[A dt];
G      = g[Yii,xi,Theta]; 
Omega  = G.Transpose[G];
b1     = (fi - A.Yii)dt;
b2     = 0.5 Map[MatrixTrace,DA.Omega] dt*dt; (*i dt = t-ti*)

(* dy = Ay dt + [fi-A.Yii + 1/2 DA*Omega(t-ti)]dt + g dW  *)

Do[ (*i//Print; Yi1i//Print;*)

    {Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	
    Yi1i = Yi1i + (A.Yi1i) dt + b1 + b2 i;
     
                (*Korrektur 2. Ordnung = Ito-Taylor Entwicklung*)
   		
	Pi1i = Astern.Pi1i.Transpose[Astern] + Omega dt;        
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}]


(***************************************************************)			 
TimeUpUKF[{Yii_,Pii_,X_,dt_,kappa_},Theta_,{f_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,Yi1i,Pi1i,Y,P,yi1i,yi1ineu,alphai1i,gi1i,omegai1i,Eomegai1i},

T = Length[X]-1;
p=Yii//Length;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;



Do[ 
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
    
		(*Pi1i=Pi1i + 10^-8 IdentityMatrix[p];*) (*Pi1i>0*)
	
	Pi1i=Shift[Pi1i,10.^-16,"TimeUpUKF "]//Symmetrize;
	{yi1i,alphai1i} = SigmaSample[Yi1i, Pi1i, kappa]; (* sigma-sample mit Kleinbuchstaben*)
	
		(*Print[i," vor Euler",yi1i];*)


    yi1ineu = yi1i + Map[f[#,xi,Theta]dt &,yi1i];  (* update von yi1i*)
    
   		 (*Print[i,"nach Euler",yi1ineu];*)

   	
	{Yi1i,Pi1i} = WeightedMeanAndVariance[yi1ineu,alphai1i]; 
	
		(* E(y+fdt),Var(y+fdt) *) 
	
		(*{Yi1i,Pi1i}//Print;*)
	
	gi1i =  Map[g[#,xi,Theta]&,yi1i];  
	
		(*gi1i//Print;*)
	
	omegai1i=Map[Flatten[#.Transpose[#]]&,gi1i]; 
	
		(*omegai1i//Print;*)
    
    Eomegai1i = WeightedMean[omegai1i,alphai1i];  (* E(omega)*)
    
    Eomegai1i = Shape[Eomegai1i,{p,p}];
    
    Pi1i = Pi1i + Eomegai1i*dt; (* Var(yi1i) =Var(y + f dt) + E(Omega) dt *)
	
		(*Print[Pi1i , Eomegai1i*dt];*)
	
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];
	

{Yi1i,Pi1i,Y,P}]


(***************************************************************)			 
TimeUpUKF1[{Yii_,Pii_,X_,dt_,kappa_},Theta_,{f_,g_}]:=
(***************************************************************)			 
Block[{T,p,i,xi,Yi1i,Pi1i,Y,P,yi1i,yi1ineu,alphai1i,gg,Eomegai1i},

T = Length[X]-1;
p=Yii//Length;

Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;



Do[ 
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
    
		(*Pi1i=Pi1i + 10^-8 IdentityMatrix[p];*) (*Pi1i>0*)
	
	Pi1i=Shift[Pi1i,10.^-16,"TimeUpUKF "]//Symmetrize;
	{yi1i,alphai1i} = SigmaSample[Yi1i, Pi1i, kappa]; (* sigma-sample mit Kleinbuchstaben*)
	
		(*Print[i," vor Euler",yi1i];*)


    yi1ineu = yi1i + Map[f[#,xi,Theta]dt &,yi1i];  (* update von yi1i*)
    
   		 (*Print[i,"nach Euler",yi1ineu];*)

   
	{Yi1i,Pi1i} = WeightedMeanAndVariance[yi1ineu,alphai1i]; 
	
	(*
	Yi1i=alphai1i.yi1ineu;
	Pi1i=alphai1i.Map[Dyad,yi1ineu]-Dyad[Yi1i,Yi1i];
	*)
	
		(* E(y+fdt),Var(y+fdt) *) 
	
		(*{Yi1i,Pi1i}//Print;*)
	
	gg=g[Yii,xi,Theta];
    
    Eomegai1i = gg.Transpose[gg];
    
    Pi1i = Pi1i + Eomegai1i*dt; (* Var(yi1i) =Var(y + f dt) + E(Omega) dt *)
	
		(*Print[Pi1i , Eomegai1i*dt];*)
	
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];
	

{Yi1i,Pi1i,Y,P}]


(***************************************************************)
TimeUpSMKF[{Yii_,Pii_,X_,dt_,n_,seed_,anti_},Theta_,{f_,g_}]:=
(***************************************************************)
Block[{T,p,i,xi,Yi1i,Pi1i,Y,P,yi1i,yi1ineu,alphai1i,gi1i,omegai1i,Eomegai1i},

T = Length[X]-1;
p=Yii//Length;	
	
Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

alphai1i=1./n;

Do[
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
	
	(*Pi1i//Print;*)
	
	SeedRandom[seed];
	yi1i = RandomGauss[Yi1i, Pi1i, n, Gauss, anti]; (*antithetisch*)
										(* random-sample mit Kleinbuchstaben*)
   	
   	(*Print[i," vor Euler",yi1i];*)
	
    yi1ineu = yi1i + Map[(f[#,xi,Theta]dt)&,yi1i];  (* update von yi1i*)
    
    (*Print[i,"nach Euler",yi1ineu];*)

	{Yi1i,Pi1i} = WeightedMeanAndVariance[yi1ineu,alphai1i]; 
	
	      				(* E(y + f dt),Var(y+fdt)=P+(y,f)dt+(f,y)dt+O(dt^2)*) 
	
	gi1i =  Map[g[#,xi,Theta]&,yi1i];  
	
	(*gi1i//Print;*)
	
	omegai1i=Map[Flatten[#.Transpose[#]]&,gi1i]; 
	
	(*omegai1i//Print;*)
    
    Eomegai1i = WeightedMean[omegai1i,alphai1i];  (* E(omega)*)
    
    Eomegai1i = Shape[Eomegai1i,{p,p}];
    
    (*Print[Pi1i//Eigenvalues,Eomegai1i dt//Eigenvalues];*)
    
    Pi1i = Pi1i + Eomegai1i*dt; (* Var(yi1i) =Var(y+fdt) + E(gg') dt *)
    
    Pi1i=Shift[Pi1i,SHIFT$];
	
	
	(*Print[Pi1i , Eomegai1i*dt];*)
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];


{Yi1i,Pi1i,Y,P}//Return;

]

(***************************************************************)
TimeUpGF//Clear
TimeUpGF[{Yii_,Pii_,X_,dt_},Theta_,{f_,Omega_}]:=
(***************************************************************)
(*Gaussian Filter*)
Module[{T,p,xi,Yi1i,Pi1i,Y,P,Ef,fymue,Efymue,Eomega,s,a,b},

T = Length[X]-1;
p=Yii//Length;	
	
Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
(*P[[1]] = Pii;*)

Eomega=Shape[0,{p,p}];

Do[
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)

	Pi1i=(Pi1i//Symmetrize) + 10^-8 IdentityMatrix[p]; (*Pi1i>0*)
	
	Pi1i=Shift[Pi1i,10.^-6];
	
	If[i==1,P[[1]]=Pi1i]; (*falls korrigiert*)
	
	(*Pi1i//Print;*)
	
	s=Pi1i//VecDiag//Sqrt;
    {a,b}={Yi1i-ksigma s,Yi1i+ksigma s};

		
   	Ef=Table[GaussIntegral[(f[#,xi,Theta][[i]])&,{Yi1i,Pi1i},{a,b},genau],
   	         {i,p}];
   	
    Yi1i = Yi1i + Ef*dt; 
    
    (*{i,Yi1i}//Print;*)
	
    
    (* E(y + f dt),Var(y+fdt)=P+(y,f)dt+(f,y)dt+O(dt^2) *) 
	
	fymue=Outer[Times,f[#,xi,Theta],(#-Yi1i)]&;
	
	Efymue=Table[GaussIntegral[fymue[#][[i,j]]&,{Yi1i,Pi1i},{a,b},genau],
	            {i,p},{j,p}];
	                        
	(*{i,Efymue}//Print;*)
	
    Do[Eomega[[i,j]] = 
        GaussIntegral[Omega[#,xi,Theta][[i,j]]&,{Yi1i,Pi1i},{a,b},genau]
       ,{i,p},{j,i,p}];
   
    Table[Eomega[[j,i]]=Eomega[[i,j]],{i,p},{j,i+1,p}]; (*untere Dr.*)
    
    (*Print[Pi1i//Eigenvalues,Eomegai1i dt//Eigenvalues];*)
    
    Pi1i = Pi1i + (Efymue+Transpose[Efymue]+ Eomega)*dt; 
    
    (* Var(yi1i) =Var(y+fdt) + E(gg') dt *)

	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}//Return;

]

(***************************************************************)
TimeUpGHF//Clear
TimeUpGHF[{Yii_,Pii_,X_,dt_,m_},Theta_,{f_,Omega_}]:=
(***************************************************************)
(*Gauss-Hermite-Filter*)
Block[{T,p,xi,Yi1i,Pi1i,Y,P,Ef,fl,yfdt,yfdt1,yfdt2,varyfdt,Eomega,vals},

T = Length[X]-1;	
	
Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;


(*   E(y + f dt)=mue+E[f]dt,
   Var(y + f dt)=P+(y,f)dt+(f,y)dt+(f,f)dt^2  *) 
	
	

Do[
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
	
	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	(*{i,Yi1i,Pi1i//VecDiag//Sqrt}//Print;*)
	
	vals = TrafoMueSigma[VALS,{Yi1i,Pi1i},10^-16];
   	       
   	fl   = Map[f[#,xi,Theta]&,vals];
    
    yfdt = vals + fl*dt;
    
    Yi1i = WEIGHT.yfdt;  (*E[y+f dt]*)
    
   
    yfdt2 = Map[Outer[Times,#,#]&,yfdt]; 
    varyfdt = WEIGHT.yfdt2 - Outer[Times,Yi1i,Yi1i];
    
    
    (* langsamer*)
    (*
    yfdt1 = Map[(#-Yi1i)&,yfdt];
    varyfdt = WEIGHT.Map[Outer[Times,#,#]&,yfdt1];  (*Var[y+f dt]*)
    *)      
    
    
    Eomega = WEIGHT.Map[Omega[#,xi,Theta]&,vals];
      
    Pi1i = varyfdt + Eomega*dt; 
   
    (*Pi1i=Shift[Pi1i//Symmetrize,10.^-8];*)
    (*Print[nach,Pi1i];*) 
    (* Var(yi1i) =Var(y+fdt) + E(gg') dt *)
	(*{i,Yi1i,Pi1i//VecDiag//Sqrt}//Print;*)
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}

]

(***************************************************************)
TimeUpGHF1//Clear
TimeUpGHF1[{Yii_,Pii_,X_,dt_,m_},Theta_,{f_,Omega_}]:=
(***************************************************************)
(*Gauss-Hermite-Filter, konstantes Omega*)
Block[{T,p,xi,Yi1i,Pi1i,Y,P,Ef,fl,yfdt,yfdt1,yfdt2,varyfdt,Eomega,vals},

T = Length[X]-1;	
	
Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;


(*   E(y + f dt)=mue+E[f]dt,
   Var(y + f dt)=P+(y,f)dt+(f,y)dt+(f,f)dt^2  *) 
	
	

Do[
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
	
	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	(*{i,Yi1i,Pi1i//VecDiag//Sqrt}//Print;*)
	
	vals = TrafoMueSigma[VALS,{Yi1i,Pi1i},SHIFT$];
	
	(*If[OVERFLOW,Return[]];*)
   	       
   	fl   = Map[f[#,xi,Theta]&,vals];
    
    yfdt = vals + fl*dt;
    
    
    Yi1i = WEIGHT.yfdt;  (*E[y+f dt]*) 
    yfdt2 = Map[Outer[Times,#,#]&,yfdt]; 
    varyfdt = WEIGHT.yfdt2 - Outer[Times,Yi1i,Yi1i];
    
    
    (*
    Wyfdt=WEIGHT yfdt;
    Yi1i = Apply[Plus,Wyfdt]; 
    varyfdt =  Transpose[Wyfdt].yfdt - Outer[Times,Yi1i,Yi1i];
    *)
    
    (* langsamer*)
    (*
    yfdt1=Map[(#-Yi1i)&,yfdt];
    varyfdt = WEIGHT.Map[Outer[Times,#,#]&,yfdt1];  (*Var[y+f dt]*)
    *)      
    
  
    Eomega = Omega[Yii,xi,Theta]; (*konstant in Yii*)
    
    Pi1i = varyfdt + Eomega*dt; 
   
    (*Pi1i=Shift[Pi1i//Symmetrize,10.^-8];*)
    (*Print[nach,Pi1i];*) 
    (* Var(yi1i) =Var(y+fdt) + E(gg') dt *)
	(*{i,Yi1i,Pi1i//VecDiag//Sqrt}//Print;*)
	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}

]

(***************************************************************)
TimeUpGHFN//Clear
TimeUpGHFN[{Yii_,Pii_,X_,dt_,mm_},Theta_,{f_,Omega_}]:=
(***************************************************************)
(*Gauss-Hermite-Filter, konstantes Omega, Panel-Daten*)
Block[{n,m,N,T,p,xi,Yi1i,Pi1i,Y,P,Ef,fl,yfdt,yfdt1,yfdt2,varyfdt,Eomega,vals},

T = Length[X]-1;
N = Yii//Length;	
	
Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

varyfdt=Pii;
EYi1i=Yi1i;


(*   E(y + f dt)=mue+E[f]dt,
   Var(y + f dt)=P+(y,f)dt+(f,y)dt+(f,f)dt^2  *) 
	
	

Do[
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
	
	{Yi1i,OVERFLOW} = Over[Yi1i,YMAX,i]; 
	{Pi1i,OVERFLOW} = Over[Pi1i,YMAX,i]; 
	
	(*{i,Yi1i,Pi1i//VecDiag//Sqrt}//Print;*)
	
	Do[
    
	vals = TrafoMueSigma[VALS1,{{Yi1i[[n]]},{{Pi1i[[n,n]]}}},10^-16];
   	       
   	fl   = Map[f[#,xi,Theta]&,vals];
    yfdt = vals + fl*dt;
    
    EYi1i[[n]] = (WEIGHT1.yfdt)[[1]];  (*E[y+f dt]*) 
    varyfdt[[n,n]] = (WEIGHT1.yfdt^2)[[1]] - EYi1i[[n]]^2,
    
    {n,1,N}];
    
  
    
    Do[
    
	vals = TrafoMueSigma[VALS2,{ Yi1i[[{n,m}]],
	                           {{Pi1i[[n,n]],Pi1i[[n,m]]},
	                            {Pi1i[[m,n]],Pi1i[[m,m]]}}},10^-16];
      
   	fl   = Map[f[#,xi,Theta]&,vals,{2}];
   	
    yfdt = vals + fl*dt;
  
    yfdt2 = Map[Apply[Times,#]&,yfdt]; 
    
    varyfdt[[n,m]] = WEIGHT2.yfdt2 - EYi1i[[n]]EYi1i[[m]];
    varyfdt[[m,n]] = varyfdt[[n,m]],
    
    {n,1,N},{m,n+1,N}];
    
   
  
    Eomega = Omega[Yii,xi,Theta]; (*konstant in Yii*)
    
    Pi1i = varyfdt + Eomega*dt; 
   
    (*Pi1i=Shift[Pi1i//Symmetrize,10.^-8];*)
    (*Print[nach,Pi1i];*) 
    (* Var(yi1i) =Var(y+fdt) + E(gg') dt *)
	(*{i,Yi1i,Pi1i//VecDiag//Sqrt}//Print;*)
	
	
	Y[[i+1]] = Yi1i = EYi1i; 
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}

]





(***************************************************************)
TimeUpGHFalt//Clear
TimeUpGHFalt[{Yii_,Pii_,X_,dt_,m_},Theta_,{f_,Omega_}]:=
(***************************************************************)
(*Gauss-Hermite-Filter*)
Block[{T,p,xi,Yi1i,Pi1i,Y,P,Ef,fymue,Efymue,Eomega,s,a,b,vals},

T = Length[X]-1;
p=Yii//Length;	
	
Yi1i = Yii;
Pi1i = Pii;

Y = Shape[1,{T+1}];
Y[[1]]  = Yii;
P = Shape[1,{T+1}];
P[[1]] = Pii;

Eomega=Shape[0,{p,p}];
Efymue=Shape[0,{p,p}];

yfdt//Clear;
yfdt[y_,i_]:=y[[i]]+f[y,xi,Theta][[i]]dt;

(*   E(y + f dt)=mue+E[f]dt,
   Var(y + f dt)=P+(y,f)dt+(f,y)dt+(f,f)dt^2  *) 
	
	

Do[
	xi = X[[i]];   (*Print["xi in Timeup",xi];  *)
	
	
	vals=TrafoMueSigma[VALS,{Yi1i,Pi1i}];
	
	(*
   	Ef=Table[GaussHermite2[(f[#,xi,Theta][[i]])&,{vals,WEIGHT}],
   	         {i,p}];*)
   	       
   	fl=Map[f[#,xi,Theta]&,vals];
   	Ef=WEIGHT.fl;
   	
    Yi1i = Yi1i + Ef*dt; 
    
    (*{i,Yi1i}//Print;*)
   
	
	(* Variante 1*)
	(*
	fymue=Outer[Times,f[#,xi,Theta],(#-Yi1i)]&;
	
	Efymue=Table[GaussHermite2[fymue[#][[i,j]]&,{vals,WEIGHT}],
	            {i,p},{j,p}];
	Efymue= Efymue-Outer[Times,Yi1i,Yi1i];                        
	*)
	
	
	(*Variante 2*)
	(*
	Do[Efymue[[i,j]]=GaussHermite2[yfdt[#,i]*yfdt[#,j]&,{vals,WEIGHT}],{i,p},{j,i,p}];
	
	Do[Efymue[[j,i]]=Efymue[[i,j]],{i,p},{j,i+1,p}]; (*untere Dr.*)
	
	Efymue= Efymue-Outer[Times,Yi1i,Yi1i];                       
    *)
    
    
    yfdt=vals+ fl dt;
    Efymue=Map[Outer[Times,#,#]&,yfdt]; 
    Efymue= WEIGHT.Efymue-Outer[Times,Yi1i,Yi1i];                
	
	
	(*Variante 3*)
	(*
	fymue=Outer[Times,#+f[#,xi,Theta] dt,#+f[#,xi,Theta] dt]&;
	
	Do[Efymue[[i,j]]=GaussHermite2[(fymue[#][[i,j]])&,{vals,WEIGHT}],
	            {i,p},{j,i,p}];
	Do[Efymue[[j,i]]=Efymue[[i,j]],{i,p},{j,i+1,p}]; (*untere Dr.*)
	Efymue= Efymue-Outer[Times,Yi1i,Yi1i];                                         
	*)                      
                     
	(*{i,Efymue}//Print;*)
	
	(*
    Do[Eomega[[i,j]] = 
        GaussHermite2[Omega[#,xi,Theta][[i,j]]&,{vals,WEIGHT}]
       ,{i,p},{j,i,p}];
   
    Table[Eomega[[j,i]]=Eomega[[i,j]],{i,p},{j,i+1,p}]; (*untere Dr.*)
    *)
    
    Eomega = GaussHermite2[Omega[#,xi,Theta]&,{vals,WEIGHT}];
   
  
    
    (*Print[Pi1i//Eigenvalues,Eomegai1i dt//Eigenvalues];*)
    
    (*Pi1i = Pi1i + (Efymue+Transpose[Efymue]+ Eomega)*dt; *)(*Variante 1*)
    
    Pi1i = Efymue + Eomega*dt; 
   
    
    Pi1i=Shift[Pi1i//Symmetrize,10.^-8];
   
    (*Print[nach,Pi1i];*)
    
    (* Var(yi1i) =Var(y+fdt) + E(gg') dt *)

	
	
	Y[[i+1]] = Yi1i;
	P[[i+1]] = Pi1i;
	
,{i,1,T}];

{Yi1i,Pi1i,Y,P}//Return;

]

(***************************************************************)
TimeUpGHFn//Clear
TimeUpGHFn[{Yii_,Pii_,X_,dt_,m_},Theta_,{f_,Omega_}]:=
(***************************************************************)
(*Gauss-Hermite-Filter, n-fach*)

MapThread[TimeUpGHF[{#1,#2,X,dt,m},Theta,{f,Omega}]&,{Yii,Pii}]//Transpose


(***************************************************************)
TimeUpUKFn//Clear
TimeUpUKFn[{Yii_,Pii_,X_,dt_,kappa_},Theta_,{f_,g_}]:=
(***************************************************************)
(*Gauss-Hermite-Filter, n-fach*)

MapThread[TimeUpUKF[{#1,#2,X,dt,kappa},Theta,{f,g}]&,{Yii,Pii}]//Transpose





(***************************************************************)			 
MessUpFokker//Clear
MessUpFokker[{Z_,Yi1i_,X_,$z$_},Theta_,{h_,R_}]:=
(***************************************************************)			 
	(*mit gegebenen Zufallszahlen $z$ *) 
	Module[{n,sm,sm1,pi1i,r,r2,pzy,Zi1i,pzi1i,pii,lik,yy},
	n = $z$//Length;
	sm1 = smoothQuickAndDirty[Yi1i]; sm1 //Print;
	pi1i = (KernDichte[#,Yi1i,GaussKern,sm1])&;
	r = R[_,X,Theta];
	r2 = CholeskyDecomposition[r]//Transpose;
	pzy = GaussDichte[Z,{h[#,X,Theta],r,Inverse[r]}]&;
	Zi1i = Map[h[#,X,Theta]&,Yi1i] + Map[Dot[r2,#]&,$z$];
	sm = smoothQuickAndDirty[Zi1i]; sm//Print; 
	sm = r//VecDiag//Max; sm//Print;
	(*da Zi1i ordinal*) 
	pzi1i = KernDichte[Z,Zi1i,GaussKern,sm]; (* lik *)
	pii = (pzy[#] pi1i[#] / pzi1i )&;
	lik = Log[pzi1i];
	{pii,pi1i,lik}
]

MessUpFokker1//Clear
MessUpFokker1[{Z_,Yi1i_,X_,_},Theta_,{h_,R_}]:=
	(*mit gegebenen Zufallszahlen $z$ *) 
	Module[{n,sm,pi1i,r,r2,pzy,Zi1i,pzi1i,pii,lik,yy},
	n = Yi1i//Length;
	sm = smoothQuickAndDirty[Yi1i]//Evaluate;
	pi1i = KernDichte[#,Yi1i,GaussKern,sm//Evaluate]&;
	r = R[_,X,Theta];
	r2 = CholeskyDecomposition[r]//Transpose;
	pzy = GaussDichte[Z,{h[#,X,Theta],r,Inverse[r]}]&;
	pzi1i = Map[pzy,Yi1i]; (* lik *)
	pzi1i//Print;
	pzi1i = Apply[Plus,pzi1i]/n;
	pii = (pzy[#] pi1i[#] / pzi1i)&;
	
	lik = Log[pzi1i];
	{pii,pi1i,lik}
]

			
MessUpFokker2//Clear
(***************************************************************)			 
MessUpFokker2[{Z_,Yi1i_,X_,_},Theta_,{h_,R_},{{y1_,y2_,dy_},nstd_,$n$_}]:=
(***************************************************************)			 
	(*  *) 
	Module[{sm,m,s,pi1i,r,pzy,piiU,yii,z,lik,pii,y1s,y2s,dys},
	
	{sm,m,s} = smoothQuickAndDirty1[Yi1i];
	If[sm == 0, Print["Singul\[ADoubleDot]re Verteilung pi1i"]; sm = 10.^-6];
	
	pi1i = KernDichte[#,Yi1i,GaussKern,sm]&;	
	r = R[y1(*dummy*),X,Theta];  
	pzy = GaussDichte[Z,{h[#,X,Theta],r,Inverse[r]}]&;
	piiU = (pzy[#] pi1i[#])&;
	{y1s,y2s,dys} = AutomaticGrid[Theta,{m,s,nstd},{Z,Modus},{y1,y2,dy}];
	{z,yii} = RandomNumbers[{y1s,y2s,dys},piiU,$n$];
	{z,yii}//Print;
	lik = Log[z];
	pii = (piiU[#]/z)&;
	
		  (*Plot[{pii[{yy}],pi1i[{yy}]}//Evaluate,{yy,-10,10}];*)
		  
	{yii,pii,pi1i,lik}
]


MessUpEKF//Clear
(***************************************************************)			 
MessUpEKF[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(* Standard-Update*) 
	Block[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	    If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)
	    
		H = Dh[Yi1i,X,Theta]; 
		H = H[[lc]]; 
		r = R[Yi1i,X,Theta][[lc,lc]];	
		vi = H . Pi1i . Transpose[H] + r; 
		
		(*If[vi[[1,1]]>10^5,Print["vi  ",vi]];*)
		
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1; 
		
		(*
		lc//Print;
		h[Yi1i,X,Theta][[lc]]//Print;
		*)
		
		inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]];	
		lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
		
		Yii = Yi1i + gain.inn;
		
		{k,p} = H//Dimensions; 
		ikh = IdentityMatrix[p] - gain.H;
		Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
		
		(*
		Print["Z",Z, "h",h[Yi1i,X,Theta]//Chop,"H",H//Chop,"lik",lik];
		Print["Yi1i",Yi1i,"Yii",Yii];
		*)
		(*
		Print["-------------------"];
		Print[Pi1i~ii~Pii//MatrixForm];
		*)
		
	
		{Yii,Pii,lik}
		
]

MessUpHNF22//Clear
(***************************************************************)			 
MessUpHNF22[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,DDh_,R_},{miss_}]:=
(***************************************************************)			 
	(* Standard-Update*) 
	Block[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii,h2,h223,PP,M4mPP},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	    If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)
	    
		H = Dh[Yi1i,X,Theta]; 
		H = H[[lc]];

		{k,p}=Dimensions[H]; 

		PP = Outer[Times,Pi1i,Pi1i];  (*ijkl*)
        M4mPP = Transpose[PP,{1,3,2,4}]+Transpose[PP,{1,3,4,2}]; (*Gauss-Fakt.*)
                             (*ikjl*)                (*iljk*)
        h2 = DDh[Yi1i,X,Theta]; 
		h2 = h2[[lc]];
        h223 =Partition[Flatten[h2],p*p];

        (*h223//Print;*)

		r  = R[Yi1i,X,Theta][[lc,lc]];

		(*var(h+h'(y-m)+1/h''(y-m)^2; var[(y-m)^2]=m_4-m_2^2*)
	
		vi = H . Pi1i . Transpose[H] + 
             1/4 h223.Partition[Flatten[M4mPP],p*p].Transpose[h223]
             +r; 
		
		(*If[vi[[1,1]]>10^5,Print["vi  ",vi]];*)
		
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1;
		inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]] - 1/2 h223.Flatten[Pi1i];	
		lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
		
		Yii = Yi1i + gain.inn;
		 
		ikh = IdentityMatrix[p] - gain.H;
        Pii = ikh.Pi1i;

		(*PiiJ = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];*)
		(*Pii-PiiJ//Print;*)
		
		
		(*
		Print["Z",Z, "h",h[Yi1i,X,Theta]//Chop,"H",H//Chop,"lik",lik];
		Print["Yi1i",Yi1i,"Yii",Yii];
		*)
		(*
		Print["-------------------"];
		Print[Pi1i~ii~Pii//MatrixForm];
		*)
		
	
		{Yii,Pii,lik}
		
]

MessUpEKFIter//Clear
(***************************************************************)			 
MessUpEKFIter[{Z_,{Yi1i_,Pi1i_},X_,eta_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(* Mess-Update, entwickelt um eta *) 
	
	Block[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	    If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)
	    
		H = Dh[eta,X,Theta]; 
		H = H[[lc]]; 
		r = R[eta,X,Theta][[lc,lc]];	
		vi = H . Pi1i . Transpose[H] + r; 
			
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1;
		inn = Z[[lc]] - h[eta,X,Theta][[lc]] - H.(Yi1i-eta);	
		lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
		
		Yii = Yi1i + gain.inn;
		
		{k,p} = H//Dimensions;
		ikh = IdentityMatrix[p] - gain.H;
		Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
		
		(*
		Print["Z",Z, "h",h[Yi1i,X,Theta]//Chop,"H",H//Chop,"lik",lik];
		Print["Yi1i",Yi1i,"Yii",Yii];
		*)
		(*
		Print["-------------------"];
		Print[Pi1i~ii~Pii//MatrixForm];
		*)
		
	
		{Yii,Pii,lik}
		
]

MessUpEKFInno//Clear
(***************************************************************)			 
MessUpEKFInno[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(* ret. innovation, innocov und normierte inno.*) 
	
	Block[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii,innostern},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	    If[lc == {},Return[{Yi1i,Pi1i,0,{miss},{{miss}},{miss}}]]; (*keine Messung*)
	    
		H = Dh[Yi1i,X,Theta]; 
		H = H[[lc]]; 
		r = R[Yi1i,X,Theta][[lc,lc]];	
		vi = H . Pi1i . Transpose[H] + r; 
			
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1;
		inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]];	
		lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
		
		Yii = Yi1i + gain.inn;
		
		{k,p} = H//Dimensions;
		ikh = IdentityMatrix[p] - gain.H;
		Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
		innostern=Transpose[CholeskyDecomposition[vi1]].inn;
		
		{Yii,Pii,lik,inn,vi,innostern}
		
]

MessUpEKFcov//Clear
(***************************************************************)			 
MessUpEKFcov[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(* EKF-Update, returns Pii and gains etc. *) 
	Module[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii,
	        jacobi,prederr},
	
	zmiss = Map[SameQ[miss,#]&,Z];	
	lc = Locate[zmiss,False]; 
	
	    If[lc == {},Return[{Pi1i,0,0,0,lc}]]; (*keine Messung*)
	    
		H = Dh[Yi1i,X,Theta];
		H = H[[lc]]; 
		r = R[Yi1i,X,Theta][[lc,lc]];	
		vi = H . Pi1i . Transpose[H] + r;
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1;		
		jacobi  = -.5 Log[Det[vi]]; 
		{k,p} = H//Dimensions;
		ikh = IdentityMatrix[p] - gain.H;
		Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
	
		{Pii,jacobi,vi1,gain,lc}
		
]
MessUpEKFstate//Clear
(***************************************************************)			 
MessUpEKFstate[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,R_},
               {vi1_,gain_,lc_},{miss_}]:=
(***************************************************************)			 
	(* EKF-Update, returns states *) 
	Module[{inn,prederr,Yii},
	
	    If[lc == {},Return[{Yi1i,0}]]; (*keine Messung*)
	    
		inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]];	
		prederr = -.5 inn.vi1.inn;
		Yii = Yi1i + gain.inn;

		{Yii,prederr}
		
]

MessUpGARCH//Clear
(***************************************************************)			 
MessUpGARCH[{Z_,{Yi1i_,Pi1i_},X_,dt_},Theta_,{g_,h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(* *) 
	Block[{zmiss,lc,H,r,vi,vi1,gain,inn,lik,Yii,k,p,ikh,Pii},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	    If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)
	    
		H = Dh[Yi1i,X,Theta]; 
		H = H[[lc]]; 
		r = R[Yi1i,X,Theta][[lc,lc]];	
		vi = H . Pi1i . Transpose[H] + r; 
		
		(*If[vi[[1,1]]>10^5,Print["vi  ",vi]];*)
		
		vi1 = Inverse[vi];
		gain = Pi1i . Transpose[H] . vi1;
		inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]];	
		lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
		
		
		Yii = Yi1i + { gain[[1,1]]* inn[[1]], 
		               g[Yi1i,X,Theta][[2,2]]*(inn[[1]]^2/vi[[1,1]]-1)*Sqrt[dt/2] };
		
		
		(*Yii = Yi1i + gain.inn;*)
		(*
		{k,p} = H//Dimensions;
		ikh = IdentityMatrix[p] - gain.H;
		*)
		
		ikh=IdPlusA[-gain.H];
		
		Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
		
		(*
		Print["Z",Z, "h",h[Yi1i,X,Theta]//Chop,"H",H//Chop,"lik",lik];
		Print["Yi1i",Yi1i,"Yii",Yii];
		*)
		(*
		Print["-------------------"];
		Print[Pi1i~ii~Pii//MatrixForm];
		*)
		
	
		{Yii,Pii,lik}
		
]

MessUpEKF1//Clear
(***************************************************************)			 
MessUpEKF1[{Z_,Yi1i_,X_,_},Theta_,{h_,Dh_,R_},{$n$_,miss_,Option_}]:=
(***************************************************************)			 
	(* Yi1i = Stichprobe, gemeinsamer update *) 
	
	Module[{Pi1i,S,Yi1im,pi1i,Yiim,Pii,lik,pii,z,Yii},
	
	{Pi1i,S,Yi1im} = Varianz[Yi1i];
	pi1i = GaussDichte[#,{Yi1im,Pi1i,Inverse[Pi1i]}]&;
	
	{Yiim,Pii,lik} = MessUpEKF[{Z,{Yi1im,Pi1i},X,_},Theta,{h,R,Dh},{miss}];
	
	pii = GaussDichte[#,{Yiim,Pii,Inverse[Pii]}]&;
		
	If[Option == 1,		
		(* Zufallszahlen N(Yiim,Pii) *)
		z = Table[GaussC[],{jj,$n$},{pp,p}].CholeskyDecomposition[Pii]; 
		Yii = (Shape[1,{$n$}]/.(1->Yiim)) + z
		
		,(*else*)
		 
		Yii = Indeterminate];
		
	{Yii,pii,pi1i,lik,Yiim,Pii}
		
]

MessUpEKF2//Clear
(***************************************************************)			 
MessUpEKF2[{Z_,{Yi1i_,Pi1i_},X_,_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)			 
	(*  *) 
	Module[{zmiss,lc,H,Hs,r,vi,vi1,gain,inn,
		    lik,Yii},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	
    H = Dh[Yi1i,X,Theta];
	H = H[[lc]];
	r = R[Yi1i,X,Theta][[lc,lc]];
	Hs = Transpose[H];		
	vi = H . Pi1i . Hs  + r;
	vi1 = Inverse[vi];
	gain = Pi1i . Hs . vi1;
		(*Print["gain ",gain//MatrixForm];*)
	inn = Z[[lc]] - h[Yi1i,X,Theta][[lc]];			
	lik = -.5(Log[Det[vi]] + inn.vi1.inn);	
	Yii = Yi1i + gain.inn;
		
{Yii,lik}
			
]

MessUpEKFSum//Clear
(***************************************************************)			 
MessUpEKFSum[{Z_,Yi1i_,X_,_},Theta_,{h_,Dh_,R_},{miss_}]:=
(***************************************************************)
(*ohne Gewichte und resampling*)

Module[{sm,m,s,Pi1i,pn,Yii,lik},
	Pi1i = smoothQuickAndDirtyM[Yi1i,1]; (*1 = SML*)
	pn = MessUpEKF2[{Z,{#,Pi1i},X,_},Theta,{h,Dh,R},{miss}]&;
	{Yii,lik} = Map[pn,Yi1i]//Transpose;
	lik = Log[Exp[lik]//mean];
	{Yii,lik}
]

MessUpEKFSumX//Clear
(***************************************************************)			 
MessUpEKFSumX[{Z_,Yi1i_,X_,_},Theta_,{h_,Dh_,R_},{miss_,nn_}]:=
(***************************************************************)
(*mit Gewichten und resampling (ohne Pii)*)

Module[{sm,m,s,Pi1i,pn,Yii,lik,L,LQuer,alpha,n,MM},

	Pi1i = smoothQuickAndDirtyM[Yi1i,1]; (*1 = SML*)
	pn = MessUpEKF2[{Z,{#,Pi1i},X,_},Theta,{h,Dh,R},{miss}]&;
	{Yii,lik} = Map[pn,Yi1i]//Transpose;
	L = Exp[lik];
	n = Length[Yi1i];
	LQuer = Apply[Plus,L]/n; 
	alpha = L/(LQuer*n); (*alpha//Print;*)
	lik = Log[LQuer];
    MM = RandomMultinomial[n//Range,alpha,nn]//Flatten//Sort;
    (*MM//Print;*)
	Yii = Yii[[MM]];
	{Yii,lik}
]

MessUpEKFSum1//Clear
(***************************************************************)			 
MessUpEKFSum1[{Z_,Yi1i_,X_,_},Theta_,{h_,Dh_,R_},{miss_,nn_}]:=
(***************************************************************)
(* mit Gewichten alpha = Ln/Summe Ln und resampling*)

Module[{Pi1i,pn,Yii,lik,L,LQuer,alpha,n},

	Pi1i = smoothQuickAndDirtyM[Yi1i,1]//Re; (*1 = SML*)
	Pi1i = Pi1i*FACTOR;
	                    (* Print["smooth  in MessUpEKFSum1",Pi1i//VecDiag]; *)
	n = Length[Yi1i];
	
	If[ LINEARMESS,
		
		{Pii,jacobi,vi1,gain,lc} = 
			MessUpEKFcov[{Z,{Yi1i//First,Pi1i},X,_},Theta,{h,Dh,R},{miss}];  
		 
		{Yii,prederr} = 
			Map[MessUpEKFstate[{Z,{#,Pi1i},X,_},Theta,{h,Dh,R},
                {vi1,gain,lc},{miss}]&,Yi1i]//Transpose;
    	lik = jacobi + prederr;
    	(*Print[jacobi,prederr];*)
    	Pii = Shape[1,{n}]/. 1->Pii;
		
	,(*else*)
	
	    pn = MessUpEKF [{Z,{#,Pi1i},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = Map[pn,Yi1i]//Transpose,
		
		pn = MessUpEKF [{Z,{#,Pi1i},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = Map[pn,Yi1i]//Transpose
	];
	
	(*Pii//First//Print;*)
	
	L = Exp[lik];
	LQuer = Apply[Plus,L]/n; 
	alpha = L/(LQuer*n);    (* alpha//Print; *)
	lik = Log[LQuer];       (* lik//Print; *)
	
	(*
	alpha = Chop[alpha,10.^-1];
	pos = Position[alpha,0];
	{alpha,Yii,Pii} = Map[Delete[#,pos]&,{alpha,Yii,Pii}];
	sum = Apply[Plus,alpha];
	alpha = alpha/sum;
	*)
	
	If[RESAMPLING,
		YiiR = RandomKDE[Yii,alpha,Pii,GaussC,n], (*resampling*)
		YiiR = Yii];
	
	{YiiR,lik}
]

MessUpEKFSumDKS//Clear
(***************************************************************)			 
MessUpEKFSumDKS[{Z_,Yi1i_,Pi1i_,X_},Theta_,{h_,Dh_,R_},{miss_,nn_}]:=
(***************************************************************)
(* mit Gewichten alpha = Ln/Summe Ln und resampling*)

Module[{pn,Yii,YiiR,Pii,lik,L,LQuer,alpha,n},

	(*Pi1i//First//VecDiag//Print;*)
	
	n = Length[Yi1i];
	
	If[ LINEARMESS,
		
		{Pii,jacobi,vi1,gain,lc} = 
			Map[MessUpEKFcov[{Z,{Yi1i//First,#},X,_},Theta,{h,Dh,R},{miss}]&,
			    Pi1i]//Transpose;  
		 
		{Yii,prederr} = 
			MapThread[MessUpEKFstate[{Z,{#1,#2},X,_},Theta,{h,Dh,R},
                      {#3,#4,#5},{miss}]&,
                      {Yi1i,Pi1i,vi1,gain,lc}]//Transpose;
    	lik = jacobi + prederr;
    	(*Print[jacobi,prederr];*)
				
	,(*else*)
	
	    pn = MessUpEKF [{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = MapThread[pn,{Yi1i,Pi1i}]//Transpose,
		
		pn = MessUpEKF [{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = MapThread[pn,{Yi1i,Pi1i}]//Transpose
	];
	
	                            (*Pii//First//Print;*)
	L = (1/n)* Exp[lik];
	LQuer = Apply[Plus,L]; 
	alpha = L/LQuer;            (* alpha//Print; *)
	lik = Log[LQuer];

	If[RESAMPLING,
		YiiR = RandomKDE[Yii,alpha,Pii,GaussC,n], (*resampling*)
		YiiR = Yii];
	
	{YiiR,lik,Yii,Pii,alpha}
]

MessUpEKFSumAlpha//Clear
(***************************************************************)			 
MessUpEKFSumAlpha[{Z_,{Yi1i_,Pi1i_,alphai1i_},X_},Theta_,
                  {h_,Dh_,R_},{miss_,n_}]:=
(***************************************************************)
(* mit a priori-Gewichten alphai1i *)
(* Gaussian sum filter             *)

Module[{Pii,jacobi,vi1,gain,lc,Yii,prederr,pn,lik,L,LQuer,alphaii},

	If[ LINEARMESS,
		
		{Pii,jacobi,vi1,gain,lc} = 
			Map[MessUpEKFcov[{Z,{Yi1i//First,#},X,_},Theta,{h,Dh,R},{miss}]&,
			    Pi1i]//Transpose;  
		 
		{Yii,prederr} = 
			MapThread[MessUpEKFstate[{Z,{#1,#2},X,_},Theta,{h,Dh,R},
                      {#3,#4,#5},{miss}]&,
                      {Yi1i,Pi1i,vi1,gain,lc}]//Transpose;
    	lik = jacobi + prederr;
    	(*Print[jacobi,prederr];*)
				
	,(*else*)
	
	    pn = MessUpEKF [{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = MapThread[pn,{Yi1i,Pi1i}]//Transpose,
		
		pn = MessUpEKF [{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = MapThread[pn,{Yi1i,Pi1i}]//Transpose
	];
	
	L = alphai1i Exp[lik];
	LQuer = Apply[Plus,L]; 
	alphaii = L/LQuer;
	lik = Log[LQuer];
	
	{Yii,Pii,alphaii,lik}
]





MessUpOmnibus//Clear
(***************************************************************)			 
MessUpOmnibus[{Z_,{Yi1i_,Pi1i_,alphai1i_},X_},Theta_,
                  {h_,Dh_,R_},
                  {miss_,n_,Generator_,seed_,RESAMPLING_:True}]:=
(***************************************************************)
(* mit a priori-Gewichten alphai1i *)
(* alle Methoden                   *)

Block[{Pii,jacobi,vi1,gain,lc,Yii,YiiR,prederr,pn,lik,L,LQuer,alphaii,c},

	If[ LINEARMESS,
		
		{Pii,jacobi,vi1,gain,lc} = 
			Map[MessUpEKFcov[{Z,{Yi1i//First,#},X,_},Theta,{h,Dh,R},{miss}]&,
			    Pi1i]//Transpose;  
		 
		{Yii,prederr} = 
			MapThread[MessUpEKFstate[{Z,{#1,#2},X,_},Theta,{h,Dh,R},
                      {#3,#4,#5},{miss}]&,
                      {Yi1i,Pi1i,vi1,gain,lc}]//Transpose;
    	lik = jacobi + prederr;
    	(*Print[jacobi,prederr];*)
				
	,(*else*)
	   
	    pn = MessUpEKF[{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = MapThread[pn,{Yi1i,Pi1i}]//Transpose,
		
		pn = MessUpEKF[{Z,{#1,#2},X,_},Theta,{h,Dh,R},{miss}]&;
		{Yii,Pii,lik} = MapThread[pn,{Yi1i,Pi1i}]//Transpose
	];
	
	(*Print[pn];*)
	
	c = lik//Max;   
	L = alphai1i Exp[lik-c]; 
	LQuer = Apply[Plus,L];  
	
	(*Print["---------------"]; lik//Print;*)
	
	alphaii = L/LQuer;
	lik = Log[LQuer]+c;
	
	(*
	alphai1i//Print;
	alphaii//Print;
	Print[N[lik,16]]; 
	*)
	
	
	(*RESAMPLING//Print;*)
	
	If[RESAMPLING,
		YiiR = RandomKDE[Yii,alphaii,Pii,Generator,seed,n], (* resampling *)
		YiiR = Yii];
	
	{YiiR,lik,Yii,Pii,alphaii}
]

			
MessUpFokkerOrdinal//Clear
(***************************************************************)			 
MessUpFokkerOrdinal[{Z_,Yi1i_,X_,_},Theta_,{h_,R_},{_}]:=
(***************************************************************)			 
	(* Problem: yii k\[UDoubleDot]rzer als yi1i *) 
	
	Module[{sm,s,m,pi1i,yii,z,lik,r,ind,pii},
	
	{sm,m,s} = smoothQuickAndDirty1[Yi1i];
	If[sm == 0, Print["Singul\[ADoubleDot]re Verteilung pi1i"]; sm = 10.^-6];
	pi1i = KernDichte[#,Yi1i,GaussKern,sm]&;
	yii = Select[Yi1i,(h[#,X,Theta] == Z)&];
	z = Length[yii]/Length[Yi1i] //N;
	lik = Log[z];
	r = R[{_},X,Theta];  
	ind = chi[{Z,#,X},Theta,{h,r}]&;
	pii = (ind[#] pi1i[#]/z)&;
	{yii,pii,pi1i,lik}
]


(***************************************************************)			 
SmoothEKF1//Clear
SmoothEKF1[{Z_,Yii_,Pii_,X_,dt_},Theta_,{f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{Yi1i,Pi1i,F,Yi1i1,Pi1i1,yii,pii,liki},

	{Yi1i,Pi1i,F} = TimeUpEKFSmooth[{Yii,Pii,X,dt},Theta,{f,Df,g}];
	
	Yi1i = Over[Yi1i,YMAX]; 
	
	{Yi1i1,Pi1i1,liki} = MessUpEKF[{Z,{Yi1i,Pi1i},X//Last,_},Theta,{h,Dh,R},{miss}];	
	
	yii = Yii + F.(Yi1i1-Yi1i);
	pii = Pii + F.(Pi1i1-Pi1i).Transpose[F];
	
	{yii,pii,liki}
	
]
	

(***************************************************************)			 
EKFFilterSmoother//Clear
EKFFilterSmoother[{Z_,Yii_,Pii_,X_,dt_,L_},Theta_,{f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{eta,xiref,Yi1i,Pi1i,F,Phi,Yi1i1,Pi1i1,liki,Yii1,Pii1},

xiref=Yii;

Do[
	{Yi1i,Pi1i,F,Phi} = TimeUpEKFSmoothIter[{Yii,xiref,Pii,X,dt},Theta,{f,Df,g}];
	
	Yi1i = Over[Yi1i,YMAX]; 
	
	eta = If[l==1,Yi1i,Yi1i1];
	{Yi1i1,Pi1i1,liki} = MessUpEKFIter[{Z,{Yi1i,Pi1i},X//Last,eta},Theta,{h,Dh,R},{miss}];	
	
	Yii1 = Yii + F.(Yi1i1-Yi1i);  (* Yii1 = xirefneu; Yi1i1 = etaneu *)
	Pii1 = Pii + F.(Pi1i1-Pi1i).Transpose[F];
	
	xiref = Yii1;
	
 ,{l,1,L}];
 
 {Yii1,Pii1,liki}	
	
]
	

(***************************************************************)			 
SmoothEKF//Clear
SmoothEKF[{Z_,Yii_,Pii_,alphaii_,X_,dt_},Theta_,{f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{yiiZ,PiiZ,alphaiiZ,likZ,c},

{yiiZ,PiiZ,likZ}=
MapThread[SmoothEKF1[{Z,#1,#2,X,dt},Theta,{f,Df,g,h,Dh,R},miss]&,
	                 {Yii,Pii}]//Transpose;

c = likZ//Max; 
alphaiiZ=alphaii*Exp[likZ-c];

		(*Print["likZ  ",likZ];
		Print["alphaii  ",alphaii];
		Print["alphaiiZ ",alphaiiZ];
		*)
	
alphaiiZ=alphaiiZ/Apply[Plus,alphaiiZ];


		(*alphaiiZ=Shape[1./Length[alphaii],{Length[alphaii]}];*)
		(*alphaiiZ=alphaii;*) (*alt*)
		(*Print["alphaii  ",alphaii];*)
		(*Print["alphaiiZ ",alphaiiZ];*)
		(*Print["Pii  ",VecDiag/@Pii ];*)
		(*Print["PiiZ ",VecDiag/@PiiZ];*)

                 
{yiiZ,PiiZ,alphaiiZ}	                  
]	

(***************************************************************)			 
SmoothEKFIter//Clear
SmoothEKFIter[{Z_,Yii_,Pii_,alphaii_,X_,dt_,L_},Theta_,{f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{yiiZ,PiiZ,alphaiiZ,likZ,c},

{yiiZ,PiiZ,likZ}=
MapThread[EKFFilterSmoother[{Z,#1,#2,X,dt,L},Theta,{f,Df,g,h,Dh,R},miss]&,
	                        {Yii,Pii}]//Transpose;

c = likZ//Max; 
alphaiiZ=alphaii*Exp[likZ-c];
	
alphaiiZ=alphaiiZ/Apply[Plus,alphaiiZ];
                 
{yiiZ,PiiZ,alphaiiZ}	                  
]	

(***************************************************************)			 
SmoothEKF2//Clear
SmoothEKF2[{Z_,etaj_,_,X_,dt_},Theta_,{f_,Df_,g_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Block[{Yi1j,Pi1j,Fj,Yi1ji1,Pi1ji1,liki,fI,OmegaI},

	{Yi1j,Pi1j,Fj} = TimeUpEKFSmooth2[{etaj,_,X,dt},Theta,{f,Df,g}];
	
	(* X//Print;
	{Yi1j,Pi1j,Fj}//Print;*)
	
	(*Yi1j//Abs//Max//Print;*)
		
	Yi1j = Over[Yi1j,YMAX]; 
	
	{Yi1ji1,Pi1ji1,liki} = 
	            MessUpEKF[{Z,{Yi1j,Pi1j},X//Last,_},Theta,{h,Dh,R},{miss}];	
	
	fI     = Fj.(Yi1ji1-Yi1j)/dt;
	OmegaI = Fj.(Pi1ji1-Pi1j).Transpose[Fj]/dt;
	
	
	
	{fI,OmegaI}
	
]
	

MessUpUKF//Clear
(******************************************************************************)			 
MessUpUKF[{Z_,{Yi1i_,pi1i_},X_,kappa_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Unscented Transform*) 
	
Module[{zmiss,lc,hi1i,Eh,Varh,CovYZ,VarZ,VarZ1,gain,inn,lik,Yii,Pii,Pi1i},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,pi1i,0}]]; (*keine Messung*)

Pi1i = Shift[pi1i,10^-16,"MessUpUKF "]//Symmetrize;
{yi1i,alphai1i}=SigmaSample[Yi1i,Pi1i,kappa]; 

hi1i = Map[h[#,X,Theta][[lc]]&,yi1i]; (* missing weglassen*) 


(*{Eh,Varh,CovYZ}=WeightedMeanAndVarianceSpezial[yi1i,Yi1i,hi1i,alphai1i];*)

Eh=alphai1i.hi1i; 
Varh=alphai1i.Map[Dyad,hi1i]-Dyad[Eh,Eh]; 
CovYZ= alphai1i.MapThread[Outer[Times,#1,#2]&,{yi1i,hi1i}]-Dyad[Yi1i,Eh];

(*Print[Yi1i,WeightedMean[yi1i,alphai1i]];*)

VarZ = Varh + R[Yi1i,X,Theta][[lc,lc]]; (* (Z,Z)=(h,h)+R *) 	
		
VarZ1 = Inverse[VarZ];  
				
gain = CovYZ.VarZ1; (* (Y,Z)=(Y,h) *)
		
inn = Z[[lc]] - Eh;
		
(*Print[Z, Eh];*)
			
lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);	
		
Yii = Yi1i + gain.inn;
		
Pii = Pi1i - gain.Transpose[CovYZ];


(*
Print["CovYZ",CovYZ//MatrixForm];
Print["Pi1i",Pi1i//MatrixForm,"CovYZ.VarZ1.CovZY",gain.Transpose[CovYZ]//MatrixForm];
Print["Pii",Pii//Eigenvalues];
Print["Pii",Pii//MatrixForm];
*)
	
		(*
		Yii[[2]]=Yi1i[[2]];
		Pii[[2,2]]=Pi1i[[2,2]]; (*ad hoc*)
		*)
	
{Yii,Pii,lik}
		
]

MessUpUKFBayes//Clear
(******************************************************************************)			 
MessUpUKFBayes[{Z_,{Yi1i_,Pi1i_},X_,kappa_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Bayes-Formel mit Normal-Korrelation und UT*) 
	
Module[{zmiss,lc,Y0,P0,lik0,P01,vals,vals2,phi,phi0,pmess,Lik,Yii,Pii,alpha,p},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

{Y0,P0,lik0}=MessUpUKF[{Z,{Yi1i,Pi1i},X,kappa},Theta,{h,R},{miss}];

P0=Shift[P0,10^-8,"MessUpUKFBayes "]//Symmetrize;
{vals,alpha}  = SigmaSample[Y0,P0,kappa]; 

vals2 = Map[Dyad,vals];

Pi1i1=Pi1i//Inverse;
phi  =GaussDichte1[#,{Yi1i,Pi1i,Pi1i1}]&;

pmess=GaussDichte[Z,{h[#,X,Theta][[lc]],R[#,X,Theta][[lc]]}]&;

P01=P0//Inverse;
phi0 =GaussDichte1[#,{Y0,P0,P01}]&;

pl = Map[(pmess[#] phi[#]/phi0[#])&,vals]//Chop;

Lik= alpha.pl;

p=Yi1i//Length;
If[ Lik==0,Lik=Exp[lik0](2Pi)^(-p/2);Print["Warnung: Lik=0, Lik0=",Lik] ];

Yii= (alpha.(pl vals))/Lik;
Pii= (alpha.(pl vals2))/Lik - Dyad[Yii];

(*Pii//Print;*)

{Yii,Pii,Lik//Log}
	
]

MessUpSMKF//Clear
(******************************************************************************)			 
MessUpSMKF[{Z_,{Yi1i_,Pi1i_},X_,n_,seed_,anti_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Monte Carlo*) 
	
Module[{zmiss,lc,hi1i,Eh,Varh,CovYZ,VarZ,VarZ1,gain,inn,lik,Yii,Pii,alphai1i},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)


SeedRandom[seed];
yi1i = RandomGauss[Yi1i, Pi1i, n, Gauss, anti]; (*antithetisch=1*)
alphai1i=1/n;
	
hi1i = Map[h[#,X,Theta][[lc]]&,yi1i]; (* missing weglassen*) 
	
{Eh,Varh,CovYZ}=WeightedMeanAndVarianceSpezial[yi1i,Yi1i,hi1i,alphai1i];

(*Print[Yi1i,WeightedMean[yi1i,alphai1i]];*)

VarZ = Varh + R[Yi1i,X,Theta][[lc,lc]]; (* (Z,Z)=(h,h)+R *) 	
		
VarZ1 = Inverse[VarZ];  
				
gain = CovYZ.VarZ1; (* (Y,Z)=(Y,h) *)
		
inn = Z[[lc]] - Eh;
		
(*Print[Z, Eh];*)
			
lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);	
		
Yii = Yi1i + gain.inn;
		
Pii = Pi1i - gain.Transpose[CovYZ];

Pii = Shift[Pii,SHIFT$];

	
{Yii,Pii,lik}
		
]

MessUpGF//Clear
(******************************************************************************)			 
MessUpGF[{Z_,{Yi1i_,Pi1i_},X_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Gauss-Integral*) 
	
Module[{zmiss,lc,Eh,Varh,CovYZ,VarZ,VarZ1,gain,inn,lik,Yii,Pii,s,a,b},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

k1=lc//Length; 
p=Yi1i//Length;

s=Pi1i//VecDiag//Sqrt;
(*s//Print;*)
{a,b}={Yi1i-ksigma s,Yi1i+ksigma s}; 

hi=(h[#1,X,Theta][[lc]][[#2]])&;

Eh = Table[
     GaussIntegral[hi[#,i]&,{Yi1i,Pi1i},{a,b},genau]
     ,{i,k1}];

Varh = Table[
       GaussIntegral[hi[#,i]hi[#,j]&,{Yi1i,Pi1i},{a,b},genau]
      ,{i,k1},{j,k1}];
      
Varh=Varh-Outer[Times,Eh,Eh];

CovYZ=Table[
       GaussIntegral[#[[i]]*hi[#,j]&,{Yi1i,Pi1i},{a,b},genau]
      ,{i,p},{j,k1}];

CovYZ = CovYZ-Outer[Times,Yi1i,Eh];

VarZ = Varh + R[Yi1i,X,Theta][[lc,lc]]; (* (Z,Z)=(h,h)+R *) 	
		
VarZ1 = Inverse[VarZ];  
				
gain = CovYZ.VarZ1; (* (Y,Z)=(Y,h) *)
		
inn = Z[[lc]] - Eh;
		
(*Print[Z, Eh];*)
			
lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);	
		
Yii = Yi1i + gain.inn;
		
Pii = Pi1i - gain.Transpose[CovYZ];


	
{Yii,Pii,lik}
		
]

MessUpGHF//Clear
(******************************************************************************)			 
MessUpGHF[{Z_,{Yi1i_,Pi1i_},X_,m_},Theta_,{h_,R_},{miss_,zweipi_:True}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Gauss-Hermite-Integral*) 
	
Module[{zmiss,lc,Eh,Varh,CovYZ,VarZ,VarZ1,gain,inn,lik,Yii,Pii,vals,hl,p},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

vals  = TrafoMueSigma[VALS,{Yi1i,Pi1i}];
hl    = Map[h[#,X,Theta][[lc]]&,vals];

Eh    = WEIGHT.hl;
Varh  = WEIGHT.Map[Outer[Times,#,#]&,hl]-Outer[Times,Eh,Eh];
CovYZ = WEIGHT.MapThread[Outer[Times,#1,#2]&,{vals,hl}]; 
CovYZ = CovYZ-Outer[Times,Yi1i,Eh];

VarZ  = Varh + R[Yi1i,X,Theta][[lc,lc]]; (* (Z,Z)=(h,h)+R *) 	
		
VarZ1 = Inverse[VarZ];  
				
gain  = CovYZ.VarZ1; (* (Y,Z)=(Y,h) *)
		
inn   = Z[[lc]] - Eh;
		
(*Print[Z, Eh];*)
			
lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);

If[zweipi,p=Yi1i//Length; lik=lik-p/2 Log[2 Pi]];	
		
Yii = Yi1i + gain.inn;
		
Pii = Pi1i - gain.Transpose[CovYZ];

(*Pii = Shift[Pii//Symmetrize,10^-8];*)

(*Print[{Yi1i,Yii}//Transpose//MatrixForm];*)

{Yii,Pii,lik}
		
]

MessUpGHFN//Clear
(******************************************************************************)			 
MessUpGHFN[{Z_,{Yi1i_,Pi1i_},X_,mm_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Gauss-Hermite-Integral, Panel-Daten*) 
	
Module[{N,n,m,k,zmiss,lc,Eh,Varh,CovYZ,VarZ,VarZ1,gain,inn,lik,Yii,Pii,vals,hl},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

N = Yi1i//Length;
Eh=Table[0,{n,N}];
Varh=CovYZ=Table[0,{n,N},{n,N}];


Do[ (*univariat*)

vals  = TrafoMueSigma[VALS1,{{Yi1i[[n]]},{{Pi1i[[n,n]]}}}];

hl    = Map[h[#,X,Theta]&,vals];

Eh[[n]]      = (WEIGHT1.hl)[[1]];
Varh[[n,n]]  = (WEIGHT1.hl^2)[[1]];
CovYZ[[n,n]] =  WEIGHT1.MapThread[(Part[#1,1]*Part[#2,1])&,{vals,hl}] 

,{n,1,N}];


Do[ (*bivariat*)

vals = TrafoMueSigma[VALS2,{ Yi1i[[{n,m}]],
	                       {{Pi1i[[n,n]],Pi1i[[n,m]]},
	                        {Pi1i[[m,n]],Pi1i[[m,m]]}}},10^-16];

hl    = Map[h[#,X,Theta]&,vals,{2}]; 
  
hl2 = Map[Part[#,1]Part[#,2]&,hl];

Varh[[n,m]]  = (WEIGHT2.hl2);
CovYZ[[n,m]] =  WEIGHT2.MapThread[(Part[#1,1]*Part[#2,2])&,{vals,hl}]; 

Varh[[m,n]]  = Varh[[n,m]];
CovYZ[[m,n]] = CovYZ[[n,m]]

,{n,1,N},{m,n+1,N}];

    
Varh  = (Varh - Outer[Times,Eh,Eh])[[lc,lc]];
CovYZ = (CovYZ-Outer[Times,Yi1i,Eh][[All,lc]]);

VarZ  = Varh + R[Yi1i,X,Theta][[lc,lc]]; (* (Z,Z)=(h,h)+R *) 	
		
VarZ1 = Inverse[VarZ];  
				
gain  = CovYZ.VarZ1; (* (Y,Z)=(Y,h) *)
		
inn   = Z[[lc]] - Eh[[lc]];
		
(*Print[Z, Eh];*)
			
lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);	
		
Yii = Yi1i + gain.inn;
		
Pii = Pi1i - gain.Transpose[CovYZ];

(*Pii = Shift[Pii//Symmetrize,10^-8];*)

(*Print[{Yi1i,Yii}//Transpose//MatrixForm];*)

{Yii,Pii,lik}
		
]

(******************************************************************************)			 
pzypyp0//Clear
pzypyp0[z_,lc_,y_,t_,Theta_,h_,R_,mue_,SigmaI_,mue0_,Sigma0I_]:=
(******************************************************************************)			 
Block[{Rl,zhl,Q1,ymue,Q2,ymue0,Q3,zweipi,detRl,jacobi23,Jacobi},

Rl = Map[R[#,t,Theta][[lc,lc]]&,y];
zhl = Map[(z-h[#,t,Theta][[lc]])&,y];
Q1 = MapThread[(#1.Inverse[#2].#1)&,{zhl,Rl}];

ymue = Map[(#-mue)&,y];
Q2 = Map[(#.SigmaI.#)&,ymue];

ymue0 = Map[(#-mue0)&,y];
Q3 = Map[(#.Sigma0I.#)&,ymue0];

zweipi = 2 Pi;
detRl = (Map[Det[zweipi #]&,Rl])^(-.5);

jacobi23 = (Det[SigmaI]/Det[Sigma0I])^(.5); 

Jacobi = detRl jacobi23; 
Jacobi Exp[-.5(Q1+Q2-Q3)]

]

MessUpGHFBayes//Clear
(******************************************************************************)			 
MessUpGHFBayes[{Z_,{Yi1i_,Pi1i_},X_,m_},Theta_,{h_,R_},{miss_},itermax_:1]:=
(******************************************************************************)			 
(* Bayes-Formel; Normal-Korrelation mit Gauss-Hermite-Integral*) 
	
Module[{zmiss,lc,Y0,P0,lik0,P01,vals,vals2,Pi1i1,pl,Lik,Yii,Pii,iter},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

{Y0,P0,lik0}=MessUpGHF[{Z,{Yi1i,Pi1i},X,m},Theta,{h,R},{miss}];

(*Y0=Yi1i; P0=Pi1i;*)
(*{Y0,P0,lik0}//Print;*)

Do[  (*Print["------------",iter];*)

If[iter>1,Y0=Yii;P0=Pii];

vals  = TrafoMueSigma[VALS,{Y0,P0}];
vals2 = Map[Dyad,vals];

Pi1i1=Pi1i//Inverse;
P01  =P0//Inverse;

pl = pzypyp0[Z[[lc]],lc,vals,X,Theta,h,R,Yi1i,Pi1i1,Y0,P01];

Lik= WEIGHT.pl;  (*mit 2Pi!!*)

Yii= (WEIGHT.(pl vals))/Lik;
Pii= (WEIGHT.(pl vals2))/Lik - Dyad[Yii];

,{iter,1,itermax}];

{Yii,Pii,Lik//Log}

	
]

MessUpGHFBayesAlt//Clear
(******************************************************************************)			 
MessUpGHFBayesAlt[{Z_,{Yi1i_,Pi1i_},X_,m_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Bayes-Formel mit Normal-Korrelation mit Gauss-Hermite-Integral*) 
	
Module[{zmiss,lc,Y0,P0,lik0,P01,vals,vals2,Pi1i1,phi,phi0,pl,pmess,Lik,Yii,Pii},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

{Y0,P0,lik0}=MessUpGHF[{Z,{Yi1i,Pi1i},X,m},Theta,{h,R},{miss}];


(*{Y0,P0,lik0}//Print;*)

vals  = TrafoMueSigma[VALS,{Y0,P0}];
vals2 = Map[Dyad,vals];

Pi1i1=Pi1i//Inverse;
phi  =GaussDichte1[#,{Yi1i,Pi1i,Pi1i1}]&;

pmess=GaussDichte[Z[[lc]],{h[#,X,Theta][[lc]],R[#,X,Theta][[lc,lc]]}]&;

P01  =P0//Inverse;
phi0 =GaussDichte1[#,{Y0,P0,P01}]&;

pl = Map[(pmess[#] phi[#]/phi0[#])&,vals]; 

Lik= WEIGHT.pl;  (*mit 2Pi!!*)

Yii= (WEIGHT.(pl vals))/Lik;
Pii= (WEIGHT.(pl vals2))/Lik - Dyad[Yii];

{Yii,Pii,Lik//Log}

	
]

MessUpGHFBayesOI//Clear
(******************************************************************************)			 
MessUpGHFBayesOI[{Z_,{Yi1i_,Pi1i_},X_,m_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Bayes-Formel mit Gauss-Hermite-Integral ohne IS*) 
	
Module[{zmiss,lc,P01,vals,vals2,Pi1i1,phi,phi0,pl,pmess,Lik,Yii,Pii},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

(*Pi1i//Print;*)

vals  = TrafoMueSigma[VALS,{Yi1i,Pi1i},0];
vals2 = Map[Dyad,vals];

Pi1i1=Pi1i//Inverse;
phi  =GaussDichte1[#,{Yi1i,Pi1i,Pi1i1}]&;

pmess=GaussDichte[Z[[lc]],{h[#,X,Theta][[lc]],R[#,X,Theta][[lc,lc]]}]&;

pl = Map[pmess[#]&,vals]; 

Lik= WEIGHT.pl;  (*mit 2Pi!!*)

Yii= (WEIGHT.(pl vals))/Lik;
Pii= (WEIGHT.(pl vals2))/Lik - Dyad[Yii];

{Yii,Pii,Lik//Log}

	
]

MessUpGHFalt//Clear
(******************************************************************************)			 
MessUpGHFalt[{Z_,{Yi1i_,Pi1i_},X_,m_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Gauss-Hermite-Integral*) 
	
Module[{zmiss,lc,Eh,Varh,CovYZ,VarZ,VarZ1,gain,inn,lik,Yii,Pii,s,a,b},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)

k1=lc//Length; 
p=Yi1i//Length;

hi=(h[#1,X,Theta][[lc]][[#2]])&;

vals=TrafoMueSigma[VALS,{Yi1i,Pi1i}];

(*
Eh = Table[
     GaussHermite2[hi[#,i]&,{vals,WEIGHT}]
     ,{i,k1}];
     
Varh = Table[
       GaussHermite2[hi[#,i]hi[#,j]&,{vals,WEIGHT}]
      ,{i,k1},{j,k1}];
      
Varh=Varh-Outer[Times,Eh,Eh];

CovYZ=Table[
       GaussHermite2[#[[i]]*hi[#,j]&,{vals,WEIGHT}]
      ,{i,p},{j,k1}];
*)      

hl=Map[h[#,X,Theta][[lc]]&,vals];
Eh =WEIGHT.hl;
Varh = WEIGHT.Map[Outer[Times,#,#]&,hl];
Varh=Varh-Outer[Times,Eh,Eh];
CovYZ=WEIGHT.MapThread[Outer[Times,#1,#2]&,{vals,hl}]; 
 

CovYZ = CovYZ-Outer[Times,Yi1i,Eh];

VarZ = Varh + R[Yi1i,X,Theta][[lc,lc]]; (* (Z,Z)=(h,h)+R *) 	
		
VarZ1 = Inverse[VarZ];  
				
gain = CovYZ.VarZ1; (* (Y,Z)=(Y,h) *)
		
inn = Z[[lc]] - Eh;
		
(*Print[Z, Eh];*)
			
lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);	
		
Yii = Yi1i + gain.inn;
		
Pii = Pi1i - gain.Transpose[CovYZ];

Pii=Shift[Pii//Symmetrize,10^-8];

{Yii,Pii,lik}
		
]

MessUpGHFn//Clear
(******************************************************************************)			 
MessUpGHFn[{Z_,{Yi1i_,Pi1i_,alphai1i_},X_,m_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit Gauss-Hermite-Integral*) 
	
Module[{zmiss,lc,c,Yii,Pii,alphaii,lik,L},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 

	    
If[lc == {},Return[{0,Yi1i,Pi1i,alphai1i}]]; (*keine Messung*)


{Yii,Pii,lik}=
	MapThread[MessUpGHF[{Z,{#1,#2},X,m},Theta,{h,R},{miss}]&,
	         		    {Yi1i,Pi1i}]//Transpose;

c = lik//Max;   
L = alphai1i Exp[lik-c]; 
LQuer = Apply[Plus,L];  
alphaii = L/LQuer;
lik = Log[LQuer]+c;

(*{lik,Yii,Pii,alphaii}//Print;*)

	
{lik,Yii,Pii,alphaii}
		
]

MessUpUKFn//Clear
(******************************************************************************)			 
MessUpUKFn[{Z_,{Yi1i_,Pi1i_,alphai1i_},X_,kappa_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
(* Normal-Korrelation mit UT*) 
	
Module[{zmiss,lc,c,Yii,Pii,alphaii,lik,L},
	
zmiss = Map[SameQ[miss,#]&,Z];		
lc = Locate[zmiss,False]; 
	    
If[lc == {},Return[{0,Yi1i,Pi1i,alphai1i}]]; (*keine Messung*)


{Yii,Pii,lik}=
	MapThread[MessUpUKF[{Z,{#1,#2},X,kappa},Theta,{h,R},{miss}]&,
	         		    {Yi1i,Pi1i}]//Transpose;

c = lik//Max;   
L = alphai1i Exp[lik-c]; 
LQuer = Apply[Plus,L];  
alphaii = L/LQuer;
lik = Log[LQuer]+c;

(*{lik,Yii,Pii,alphaii}//Print;*)

	
{lik,Yii,Pii,alphaii}
		
]

MessUpUKFalt//Clear
(******************************************************************************)			 
MessUpUKFalt[{Z_,{Yi1i_,Pi1i_,{yi1i_,alphai1i_}},X_},Theta_,{h_,R_},{miss_}]:=
(******************************************************************************)			 
	(* Normal-Korrelation mit Unscented Transform*) 
	
	Block[{zmiss,lc,VarZ,VarZ1,EY,Eh,CovYZ,gain,inn,lik,Yii,Pii},
	
	zmiss = Map[SameQ[miss,#]&,Z];		
	lc = Locate[zmiss,False]; 
	    
	 If[lc == {},Return[{Yi1i,Pi1i,0}]]; (*keine Messung*)
	     
		hi1i = Map[h[#,X,Theta][[lc]]&,yi1i]; (* missing weglassen*)  
		
		{Eh,Varh} = WeightedMeanAndVariance[hi1i,alphai1i]; (* E(z)=E(h(y)); Var(z) = Var(h)+R *)
		
		VarZ = Varh + R[Yi1i,X,Theta][[lc,lc]]; 	
		
		VarZ1 = Inverse[VarZ];  
		
		{EY,Eh,CovYZ} = WeightedMeanAndVariance[yi1i,hi1i,alphai1i];  (*Cov(y,z)=Cov(y,h(y))*)

		gain = CovYZ.VarZ1;
		
		inn = Z[[lc]] - Eh[[lc]];
		
		(*Print[Z, Eh];*)
			
		lik = -.5(Log[Det[VarZ]] + inn.VarZ1.inn);	
		
		Yii = Yi1i + gain.inn;
		
		Pii = Pi1i - CovYZ.VarZ1.Transpose[CovYZ];
		
		(*
		Yii[[2]]=Yi1i[[2]];
		Pii[[2,2]]=Pi1i[[2,2]]; (*ad hoc*)
		*)
	
		{Yii,Pii,lik}
		
]



KalmanFokker//Clear
(***************************************************************)			 
KalmanFokker[{Z_,X_},Theta_,{f_,g_,h_,R_,p0_,dt_},
				{{y1_,y2_,dy_},nstd_,$dw$_,seed_,MISS_}]:=
(***************************************************************)			 
Module[{$n$},

ti  = messind[Z,MISS]; (*Indices mit mind. einer Messung*)
dti = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

$n$ = Length[$dw$];

(*ti//Print;*)

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,$n$];
{z,y0}//Print;

{yii,pii,pi1i,lik} = 
	MessUpFokker2[{Z[[1]],y0,Xi,_},Theta,{h,R},{{y1,y2,dy},nstd,$n$}];
Print["yii",yii];

YF   = {};
Pii  = {pii};
Pi1i = {pi1i};

Do[ Print[i];

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	Print["nach Timeup"];
	yi1i = Over[yi1i,YMAX];
	y    = Over[y,YMAX];
	YF = Join[YF,Drop[y//Transpose,-1]];
	j = ti[[i+1]]; 
	
	{yii,pii,pi1i,liki} = 
		MessUpFokker2[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,R},{{y1,y2,dy},nstd,$n$}];
	
	(*liki//Print;*)
	Pii  = Append[Pii,pii];
	Pi1i = Append[Pi1i,pi1i];	
		
	lik +=liki;

,{i,1,Length[ti]-1}];

YF = Join[YF,{yii}];

{YF,lik,Pii,Pi1i}
];

EKF//Clear
(***************************************************************)			 
EKF[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* EKF*)
Block[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,IP,inno,likvec},

OVERFLOW=False;

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta]; 	

(*{Yi1i,Pi1i}//Print;*)

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{Yi1i,Pi1i},Xi,_},
		Theta,{h,Dh,R},{miss}];  
		
If[option==4, inno = {Yii-Yi1i}];
If[option==5, likvec = {lik}];
		
(*wird in TimeUpEKF ben\[ODoubleDot]tigt*)		
Y0 = Yii; P0 = Pii; 
p = Length[Y0]; IP = IdentityMatrix[p];

YF   = {};
PF   = {};


Do[ (*Print[i];*)

	

	Xi  = Take[ X,dti[[i]] ]; 
	
			(*
			{Yi1i,Pi1i,Y,P} = 
					TimeUpEKF[{Yii,Pii,Xi,dt},Theta,{f,Df,g},{Y0,P0,IP}];
			*)
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF[{Yii,Pii,Xi,dt},Theta,{f,Df,g}];
	
	(*Yi1i//Print;
	Pi1i//MatrixForm//Print;*)
	
	(*
	{Yi1i,Ov} = Over[Yi1i,YMAX,i]; 
	{Y,Ov}    = Over[Y,YMAX,i];
	
	If[Ov, Pi1i = 100 IP]; 
	{P,Ov}    = Over[P,YMAX,i];
	
	*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
	If[option==5, likvec = Append[likvec,liki]];

		
	  (* liki//Print; *)	
	  (* Print[i,"\n",Yi1i," ",Yii]; *)	
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,Return[{lik,inno}//N]];

If[option==5,Return[{lik,likvec}//N]];


];

EKG//Clear
(***************************************************************)			 
EKG[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_,Nonlin_}]:=
(***************************************************************)			 
(* EKG Gl\[ADoubleDot]tter*)

Block[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,IP,inno,Y1,P1,ASTERN, Astern,
        YG,YGalt,PG,PGalt},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;


Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta]; 

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{Yi1i,Pi1i},Xi,_},
		Theta,{h,Dh,R},{miss}];
		
If[option==4, inno = {Yii-Yi1i}];
		

YF   = {};
PF   = {};
Y1   = {};
P1   = {};
ASTERN={};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ]; 
	
	{Yi1i,Pi1i,Y,P,Astern} = 
		TimeUpEKFJacobi[{Yii,Pii,Xi,dt},Theta,{f,Df,g},Nonlin]; 
	
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	Y1 = Join[Y1,Drop[Y, 1]];
	P1 = Join[P1,Drop[P, 1]];
	ASTERN = Join[ASTERN,Astern]; 
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
		
	  (* liki//Print; *)	
	  (* Print[i,"\n",Yi1i," ",Yii]; *)	
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

YF = Join[YF,{Yii}];
PF = Join[PF,{Pii}];

(*Gl\[ADoubleDot]tter*)

YGalt = YF//Last;
PGalt = PF//Last;
YG = {YGalt};
PG = {PGalt};

(*
ti//Print;
YF//Dimensions//Print; 
PF//Dimensions//Print;
Y1//Dimensions//Print; 
P1//Dimensions//Print; 
*)

		
Do[	(*Print[j];*)

	Yii   = YF[[j]];
	Yi1i  = Y1[[j]];
	Pii   = PF[[j]];
	Pi1i  = P1[[j]];
	
		(*Pi1i//Print;*)
			
	{YGalt,PGalt} = MNonLinGlattUp[ {YGalt,PGalt},
								    {Yii,Pii,Yi1i,Pi1i},ASTERN[[j]] ];
								    
	(*{YGalt,PGalt}//Print;*) 
	
	YG = Join[{YGalt},YG];
	PG = Join[{PGalt},PG];
			
		
,{j,(ti//Last)-1,1,-1}];

				
{YG,PG,YF,PF,lik}

];

MNonLinGlattUp//Clear
MNonLinGlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Asterni_]:=
	Block[{YGneu,PGneu,Pistern},
		
			Pistern = LinearSolve[Pi1i,Asterni.Pii]//Transpose;
			
			YGneu = Yii + Pistern.(YG - Yi1i);
			PGneu = Pii + Pistern.(PG - Pi1i).Transpose[Pistern];
	
		   {YGneu,PGneu}
	]

EKFEDM//Clear
(***************************************************************)			 
EKFEDM[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
	   {miss_,option_,Nonlin_:1,const_:False}]:=
(***************************************************************)			 
(* EKF mit EDM *)
Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,likvec,
        A,B,G,Omega,Ostern,Astern,Bstern,A1},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;


Xi = X[[1]];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];

If[option==5, likvec = {lik}];

If[const, (*konstantes A*)
	
    A = Df[Yii,Xi,Theta]; 
    G =  g[Yii,Xi,Theta];
    Omega = G.Transpose[G];
    
    (* 
    B = (f[Yii,Xi,Theta] - A.Yii)//Spalte;  
	{Ostern,Astern,Bstern} = STERN01R[Omega,A,B,dt,Nonlin];
	p=Yii//Length;
	A1=Inverse[A].(Astern-IdentityMatrix[p]);
	A1//Print;
	*)
    
    If[Det[A]==0, Print["|A|=0"];
    {Ostern,Astern,A1} = STERN01R1[Omega,A,1,dt,Nonlin],
    {Ostern,Astern,A1} = STERN01R[Omega,A,1,dt,Nonlin]
    ];
	
];

YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
		
    {Yi1i,Pi1i,Y,P} = 
		TimeUpEKFEDM[{Yii,Pii,Xi,dt},Theta,
		             {f,Df,g,
		              Ostern,Astern,A1,Bstern,A},{Nonlin,const}];
	
	(*
	Yi1i//MatrixForm//Print;
	Pi1i//Print;
	Return[];
    *)
	
	
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];

	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	   
	(*{Yi1i,Pi1i}//Print;*)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	
	If[option==5, likvec = Append[likvec,liki]];
	
	  (* liki//Print; *)	
	  (* Print[i,"\n",Yi1i," ",Yii]; *)	
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==1, Return[lik//N]];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==5,Return[{lik,likvec}//N]];
	
	
];

(***************************************************************)			 
EKF[{Z_,X_},Theta_,{f_,Df_,g_,Dg_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* EKF*)
Module[{ti,dti,dti1,Xi,Yii,Pii,lik,liki,YF,PF,Yi1i,Pi1i,Y,P,j},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Short//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1; 

Xi = X[[1]];
{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},Theta,{h,Dh,R},{miss}];

YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF[{Yii,Pii,Xi,dt},Theta,{f,Df,g,Dg}];
	
	Yi1i = Over[Yi1i,YMAX];
	(*Y    = Over[Y,YMAX];*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*j//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
		
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

EKF2//Clear
(***************************************************************)			 
EKF2[{Z_,X_},Theta_,{f_,Df_,DDf_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* EKF mit Korr. 2. Ordnung*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,IP},

OVERFLOW=False;

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;



Xi = X[[1]];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];
			
(*wird in TimeUpEKF ben\[ODoubleDot]tigt*)		
Y0 = Yii; P0 = Pii; 
p = Length[Y0]; IP = IdentityMatrix[p];

YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF2[{Yii,Pii,Xi,dt},Theta,{f,Df,DDf,g}];
	
	(*
	Yi1i = Over[Yi1i,YMAX]; 
	Y    = Over[Y,YMAX];
	Pi1i = Over[Pi1i,YMAX]; 
	P    = Over[P,YMAX];
	*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	(*{Yii,Pii,liki}//Print;*)
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

EKF4//Clear
(***************************************************************)			 
EKF4[{Z_,X_},Theta_,{f_,Df_,DDf_,Omega_,DDOmega_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* EKF mit Korr. 2. Ordnung in f und Omega*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,IP},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;



Xi = X[[1]];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];
			
YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF4[{Yii,Pii,Xi,dt},Theta,{f,Df,DDf,Omega,DDOmega}];
	
	
	Yi1i = Over[Yi1i,YMAX]; 
	(*Y    = Over[Y,YMAX];*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	(*{Yii,Pii,liki}//Print;*)
	(*liki//Print;*)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

HNF22//Clear
(***************************************************************)			 
HNF22[{Z_,X_},Theta_,{f_,Df_,DDf_,Omega_,DDOmega_,
                      h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* HNF(2,2) mit Korr. 2. Ordnung in f und Omega; Gauss-Fakt.*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,IP},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];

(*{Yii,Pii,lik}//Print;*)
			
YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpHNF22[{Yii,Pii,Xi,dt},Theta,
		            {f,Df,DDf,Omega,DDOmega}];
	
	
	(*Yi1i = Over[Yi1i,YMAX];*)
	(*Y    = Over[Y,YMAX];*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
		
	(*{Yii,Pii,liki}//Print;*)
	(*liki//Print;*)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

HNF23//Clear
(***************************************************************)			 
HNF23[{Z_,X_},Theta_,{f_,Df_,DDf_,DDDf_,
                      Omega_,DDOmega_,
                      h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* HNF(2,3) mit Korr. 3. Ordnung in f und Omega*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,IP},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];

s//Clear;
p=mue[Xi,Theta]//Length;
{M6anal,Sanal}=MOMENTanalytisch[6,p,s];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];
			
YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpHNF23[{Yii,Pii,Xi,dt},Theta,
		            {f,Df,DDf,DDDf,Omega,DDOmega},
		            {M6anal,Sanal}];

	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	(*{Yii,Pii,liki}//Print;*)
	(*liki//Print;*)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

HNF24//Clear
(***************************************************************)			 
HNF24[{Z_,X_},Theta_,{f_,Df_,DDf_,DDDf_,DDDDf_,
                      Omega_,DDOmega_,DDDDOmega_,
                      h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* HNF(2,4) mit Korr. 4. Ordnung in f und Omega*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,s},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];

s//Clear;
p=mue[Xi,Theta]//Length;
{M6anal,Sanal}=MOMENTanalytisch[6,p,s];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];
			
YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpHNF24[{Yii,Pii,Xi,dt},Theta,
		            {f,Df,DDf,DDDf,DDDDf,Omega,DDOmega,DDDDOmega},
		            {M6anal,Sanal}];
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	(*{Yii,Pii,liki}//Print;*)
	(*liki//Print;*)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

EKF4alt//Clear
(***************************************************************)			 
EKF4alt[{Z_,X_},Theta_,{f_,Df_,DDf_,g_,Dg_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* EKF mit Korr. 2. Ordnung in f und g*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,IP},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;



Xi = X[[1]];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];
			
(*wird in TimeUpEKF ben\[ODoubleDot]tigt*)		
Y0 = Yii; P0 = Pii; 
p = Length[Y0]; IP = IdentityMatrix[p];

YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF4[{Yii,Pii,Xi,dt},Theta,{f,Df,DDf,g,Dg}];
	
	Yi1i = Over[Yi1i,YMAX]; 
	(*Y    = Over[Y,YMAX];*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	(*{Yii,Pii,liki}//Print;*)
	(*liki//Print;*)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

EKFGARCH//Clear
(***************************************************************)			 
EKFGARCH[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
		 {miss_,option_:1}]:=
(***************************************************************)			 
(* EKF mit GARCH update*)

Block[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,IP,inno},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]*dt;


Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta];

{Yii,Pii,lik} = 
	MessUpGARCH[{Z[[1]],{Yi1i,Pi1i},Xi,0},
		Theta,{g,h,Dh,R},{miss}];

(* {Yii,Pii,lik}//Print; *)
		
If[option==4, inno = {Yii-Yi1i}];

YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF[{Yii,Pii,Xi,dt},Theta,{f,Df,g}];
		
	
	Yi1i = Over[Yi1i,YMAX]; 
	Y    = Over[Y,YMAX];
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpGARCH[{Z[[j]],{Yi1i,Pi1i},X[[j]],dti1[[i]]},Theta,{g,h,Dh,R},{miss}];	
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
		
	  (* liki//Print; *)	
	  (* Print[i,"\n",Yi1i," ",Yii]; *)	
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,Return[{lik,inno//N}]];

];

EKFInno//Clear
(***************************************************************)			 
EKFInno[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* EKF mit verz\[ODoubleDot]gerten Messungen*)

Block[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,IP,
        inno,vi,innostern,Inno,deltat},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta];  

{Yii,Pii,lik,inno,vi,innostern} = 
	MessUpEKFInno[{Z[[1]],{Yi1i,Pi1i},Xi,_},
		Theta,{h,Dh,R},{miss}];
		
YF   = {};
PF   = {};
Inno = {innostern};

(* { inno,vi,innostern} //Print; *)


Do[ (*Print[i];*)

	

	Xi  = Take[ X,dti[[i]] ];
	deltat = Table[(dti1[[i]]-1)*dt,{j,dti1[[i]]}];
	
	(* deltat//Print; *)	
	(* innostern//Print; *)
	
	innostern1 = Table[innostern,{j,dti1[[i]]}];
	
	(*innostern1//Print; *)
	
	
	(* {Xi,innostern,deltat}//Transpose//Print; *)
	
	{Yi1i,Pi1i,Y,P} = 
		TimeUpEKF[{Yii,Pii,{Xi,innostern1,deltat}//Transpose,dt},Theta,{f,Df,g}];
		
	
	Yi1i = Over[Yi1i,YMAX]; 
	Y    = Over[Y,YMAX];
	
	
	If[option==2,
		YF = Join[YF,Drop[Y,-1]];
		PF = Join[PF,Drop[P,-1]]
	];
	
	If[option==4,
		YF = Join[YF,Drop[Y,-1]];
		PF = Join[PF,Drop[P,-1]];
		Inno = Append[Inno,innostern] 
	];
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	
	{Yii,Pii,liki,inno,vi,innostern} = 
		MessUpEKFInno[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
		
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Inno = Append[Inno,innostern];
	Return[{YF,PF,lik,Inno//N}]];

];

ShojiOzaki//Clear
(***************************************************************)			 
ShojiOzaki[{Z_,X_},Theta_,{f_,Df_,DDf_,g_,h_,Dh_,R_,mue_,sigma_,dt_},
		{miss_,option_:1}]:=
(***************************************************************)			 
(* ShojiOzaki-Methode mit Korr. 2. Ordnung*)

Block[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,IP},

OVERFLOW=False;

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];

{Yii,Pii,lik} = 
	MessUpEKF[{Z[[1]],{mue[Xi,Theta],sigma[Xi,Theta]},Xi,_},
		Theta,{h,Dh,R},{miss}];			


YF   = {};
PF   = {};

Do[ (*Print[i];*)

	Xi  = Take[ X,dti[[i]] ];
	
	
	{Yi1i,Pi1i,Y,P} = TimeUpShojiOzaki[{Yii,Pii,Xi,dt},Theta,{f,Df,DDf,g}];
	
	
	(*Yi1i = Over[Yi1i,YMAX];*)
	(*Y    = Over[Y,YMAX];*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	j = ti[[i+1]];
	(*{i,j}//Print; *)
	
	{Yii,Pii,liki} = 
		MessUpEKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],_},Theta,{h,Dh,R},{miss}];	
	(*{Yii,Pii,liki}//Print;*)
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N],
	
	Return[lik//N]];

];

KalmanFokkerEKF//Clear
(***************************************************************)			 
KalmanFokkerEKF[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				{{y1_,y2_,dy_},nstd_,$dw$_,seed_,miss_}]:=
(***************************************************************)			 
(* exakter time update, summarischer EKF1-Me\[SZ]update*)
Module[{$n$},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
dti = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

$n$ = Length[$dw$];

ti//Print;

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,$n$];

{yii,pii,pi1i,lik,ym,pm} = 
	MessUpEKF1[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{$n$,miss,1}];


YF   = {};
Pii  = {pii};
Pi1i = {pi1i};

Do[ 

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	
	yi1i = Over[yi1i,YMAX];
	y    = Over[y,YMAX];
	YF = Join[YF,Drop[y//Transpose,-1]];
	j = ti[[i+1]]; 
	
	{yii,pii,pi1i,liki,ym,pm} = 
		MessUpEKF1[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,Dh,R},{$n$,miss,1}];
	
	(*liki//Print;*)
	Pii  = Append[Pii ,pii];
	Pi1i = Append[Pi1i,pi1i];	
		
	lik +=liki;

,{i,1,Length[ti]-1}];

YF = Join[YF,{yii}];

{YF,lik,Pii,Pi1i}
];

KalmanFokkerEKFSum//Clear
(***************************************************************)			 
KalmanFokkerEKFSum[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				   {{y1_,y2_,dy_},_,$dw$_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* exakter time update, EKFSum-Me\[SZ]update*)
Module[{ti,dti,$n$,Xi,z,y0,yii,lik,YF,dwi,yi1i,y,j,liki},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
dti = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

$n$ = Length[$dw$];

(*ti//Print;*)

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,$n$];

{yii,lik} = 
	MessUpEKFSum[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{miss}];

YF   = {};

Do[ 

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	
	yi1i = Over[yi1i,YMAX];
	(*y    = Over[y,YMAX];*)
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]]  ];
	j = ti[[i+1]]; 
	
	{yii,liki} = 
		MessUpEKFSum[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,Dh,R},{miss}];
	
	(*liki//Print;*)
		
	lik +=liki;

,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{yii}];Return[{YF,lik}],
		Return[lik]];
];

Length[p0]



KalmanFokkerEKFSum1//Clear
(***************************************************************)			 
KalmanFokkerEKFSum1[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				   {$dw$_,seed_,Generator_,miss_,option_:1}]:=
(***************************************************************)			 
(* exakter time update, EKFSum1-Me\[SZ]update === KDF *)

Module[{ti,T1,dti,dti1,n,n1,Xi,z,y0,P0,yii,yiiR,lik,YF,dwi,yi1i,y,j,liki},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
                       (*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
                       (*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;
n = Length[$dw$];
n1 = 1./n;

Print["Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

SeedRandom[seed];

Xi = X[[1]];

If[Length[p0]==0,
	{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,n],
	    y0 = RandomGauss[Xi,Theta,p0,n]
  ];

SeedRandom[seed];

(*{yiiR,lik} = MessUpEKFSum1[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{miss,n}];*)

P0 = FACTOR*smoothQuickAndDirtyM[y0,1]//Re; (*1 = SML*)
P0 = Shape[1,{n}]/.(1->P0);

{yiiR,lik,yii,Pii,alphaii} = 
	MessUpOmnibus[{Z[[1]],{y0,P0,n1},X[[1]]},Theta,{h,Dh,R},
	              {miss,n,Generator,seed,True}];
		                  	
YF   = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];
		
	{yi1i,y} = TimeUpFokker[{yiiR,Xi,dwi,dt},Theta,{f,g}];
	
	yi1i = Over[yi1i,YMAX];	
	(*y  = Over[y,YMAX];*)
	
	
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]]  ];
	j = ti[[i+1]];
	 
	(*Print[{i+1,j}];*)
	
	SeedRandom[seed];
	
	(*
	{yiiR,liki} = 
		MessUpEKFSum1[{Z[[j]],yi1i,X[[j]],_},Theta,{h,Dh,R},{miss,n}];
	*)
	
	Pi1i = FACTOR*smoothQuickAndDirtyM[yi1i,1]//Re; (*1 = SML*)
	Pi1i = Shape[1,{n}]/.(1->Pi1i);
	
    {yiiR,liki,yii,Pii,alphaii} = 
	         MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,n1},X[[1]]},Theta,{h,Dh,R},
	                       {miss,n,Generator,seed,True}];

			
	(*Print["yiiR  ",yiiR];*)
	(*liki//Print;*)
		
	lik +=liki;

,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{yiiR}];Return[{YF,lik}],
	Return[lik]];
];

KernDichteFilter//Clear
(***************************************************************)			 
KernDichteFilter[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				   {dW_,seed_,Generator_,miss_,option_:1}]:=
(***************************************************************)			 
(* KDF *)

Module[{ti,T1,dti,dti1,n,n1,Xi,z,y0,P0,yii,yiiR,lik,YF,dwi,yi1i,y,j,liki},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n = Length[dW];
n1 = 1./n; 

Print["Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

{y0,P0,alpha0} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{y0,P0,alpha0},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,True}];
		                  	
YF   = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,dW];
		
	{yi1i,y} = TimeUpFokker[{yiiR,Xi,dwi,dt},Theta,{f,g}];
	
	yi1i = Over[yi1i,YMAX];	
	(*y  = Over[y,YMAX];*)
		
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]]  ];
	
	j = ti[[i+1]];
	 
	(*Print[{i+1,j}];*)
	
	Pi1i = FACTOR*smoothQuickAndDirtyM[yi1i,1]//Re; (*1 = SML*)
	Pi1i = Shape[1,{n}]/.(1->Pi1i);
	

    {yiiR,liki,yii,Pii,alphaii} = 
	         MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,n1},X[[1]]},Theta,{h,Dh,R},
	                       {miss,n,Generator,seed,True}];
		
	lik +=liki;

,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{yiiR}];Return[{YF,lik}],
	Return[lik]];
];

KDFImportance//Clear
(***************************************************************)			 
KDFImportance[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				             {{l0_,l1_,l2_:0},{FACTOR_,FIX_},
				             step_,dW_,seed_,Generator_,miss_,option_:1}]:=
(***************************************************************)			 
(* importance sampling, Pi1i fix oder Kerndichte-Gl\[ADoubleDot]ttparameter   

   p_{i+1|i} = 1/N sum phi(y_{i+1}; y_J, P(i+1|i) * alpha{i+1|i}; 
   dy = fdt + gdW 
 
   option = 1: lik, 
   option = 2: YF: TxNxp,(Stichproben-Trajektorien) 
   option = 3: YF: Tx2xp (m und s)

*)

Module[{ti,T1,T,dti,dti1,n,n1,Xi,z,y0,P0,yiiR,lik,yii,Pii,alphaii,alphai1i,
        YF,Misch,likvec,xi,dwi,yJ1,y,G,Pi1i,yi1i,liki,fI,f2,f1,g1,g2,XZ,p,
        likratio,loglik},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n = Length[dW]; n1 = 1./n; 

Print["KDFImportance: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

fI//Clear; 
fI[{z_,y_},{x_,_,_},Th_]:= (z - h[y,x,Th]).Inverse[ R[y,x,Th] ].Dh[y,x,Th];
                         
f2//Clear;
f2[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th] + lambdat*fI[{z,y},{x,_,_},Th];

f1//Clear;
f1[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th]; 

g1//Clear;
g1[y_,{x_,z_,lambdat_},Th_]:= g[y,x,Th];

g2//Clear;
g2[y_,{x_,z_,lambdat_},Th_]:= g[y,x,Th];



SeedRandom[seed];

{y0,P0,alpha0} = p0[X[[1]],Theta,n];  {n,p}=Dimensions[y0];


{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{y0,P0,alpha0},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,True}];
		                  
		                  				                 	
YF   = {}; Misch = {}; likvec = {lik};

lambdat = Lambda2[ti,T1,{l0,l1},miss];
  
XZ = {X, Interpol[Z,miss,1],lambdat}//Transpose;

Do[  

		Xi  = Take[ XZ,dti[[i]] ];
 	xi  = Xi//Last;
		dwi = Map[Take[#,dti1[[i]] ]&,dW];
 
		{yi1i,y} = TimeUpFokker[{yiiR,Xi,dwi,dt},Theta,{f2,g2},step];
		
		(* yi1i//Print; *)
		
 	Pi1i = If[FIX, FACTOR*IdentityMatrix[p],
 	
 											     FACTOR*smoothQuickAndDirtyM[yi1i,1]//Re (*1 = SML*)
 											];
 		 	
	 Pi1i = Shape[1,{n}]/.(1->Pi1i);

		yi1i = Over[yi1i,YMAX];
		(*y  = Over[y,YMAX];*)

		If[option==2,
				 	YF = Join[YF,Drop[y//Transpose,-1]];   
	   ];
	  
	 If[option==3,
				 YF = Join[YF,Drop[y//TensorMS//Transpose,-1]];
				 (*YF//Print; *) 
	   ];
	   
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	If[dti1[[i]] =!= 1,
				
				loglik = LogLikelihoodRatio[#,{f1,f2},g1,Xi,dt,Theta]&; 
				alphai1i = n1*(Map[loglik,y]//Exp),	  
	
				alphai1i = n1
	];


 (* alphai1i//Print; *)


	{yiiR,liki,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,alphai1i},X[[j]]},
				                 Theta,{h,Dh,R},{miss,n,Generator,seed,True}];
	
	(*liki//Print;*)	
	(*likvec = Append[likvec,liki];*)
	
	lik +=liki;
	
,{i,1,Length[ti]-1}];



If[option==1,Return[lik] ];

If[option==2,
	YF = Join[YF,{yiiR}];
	(*Misch = Append[Misch,{alphaii,yii,Pii}];*)
	Return[{YF,lik,Misch//Transpose}] ];
	
If[option==3,
	YF = Join[YF,{yiiR//TensorMS}];
	Return[{YF,lik,Misch}] ];	
	
];


(***************************************************************)			 
KalmanFokkerEKFSum1Mean[data_,parameter_,system_, 
	  		            {{y1_, y2_, dy_}, _, dw_, {seed_,M_},MISS_}] :=
(***************************************************************)			 
	 Module[{m,s,lik},
	  lik = 
	  Table[
	  KalmanFokkerEKFSum1[data,parameter,system, 
	  					  {{y1, y2, dy}, _, dw, seed+mm 1000,MISS}]
	  ,{mm,M}];
	  {m,s} = lik//Spalte//MS1;
	  Print["gemittelte Lik, std  ",{m,s}];
	  FDIGITS = -Log[10,s//First]; 
	  Print["FDIGITS  ", FDIGITS];
	  m[[1]]
	  ]

KalmanFokkerEKFSum2//Clear
(***************************************************************)			 
KalmanFokkerEKFSum2[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				   {{y1_,y2_,dy_},_,$dw$_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* langes W(t), nur einmal seedrandom *)

Module[{ti,dti,n,Xi,z,y0,yii,lik,YF,dwi,yi1i,y,j,liki},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;
n = Length[$dw$];
(*Print["Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];*)

SeedRandom[seed];

Xi = X[[1]];

If[Length[p0]==0,
	{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,n],
	    y0 = RandomGauss[Xi,Theta,p0,n]
  ];


{yii,lik} = 
	MessUpEKFSum1[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{miss,n}];
	
YF   = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti[[i]] ]&,$dw$];
	
	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)

	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]]  ];
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	{yii,liki} = 
		MessUpEKFSum1[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,Dh,R},{miss,n}];
	
	(*liki//Print;*)
		
	lik +=liki;

,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{yii}];Return[{YF,lik}],
		Return[lik]];
];

GaussianSumFilter//Clear
(***************************************************************)			 
GaussianSumFilter[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,p0_,dt_},
				              {n_,miss_,option_:1}]:=
(***************************************************************)			 
(* gaussian sum filter *)

Module[{ti,dti,Xi,z,yi1i,Pi1i,alphai1i,yii,yiiR,Pii,lik,YF,PF,alphaii,
        y,P,j,liki,n1,alpha,m,sigma,s},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n1 = 1./n; 

Print["GaussianSumFilter/EKF, n = ",n];

{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

(*alphai1i//Print;*)

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,False}];
                 
YF  = {}; PF  = {}; alpha = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];

	{yi1i,Pi1i,y,P} = 
	    	MapThread[TimeUpEKF[{#1,#2,Xi,dt},Theta,{f,Df,g}]&,{yii,Pii}]//Transpose;		
	
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]];
	             PF = Join[PF,Drop[P//Transpose,-1]];
	             alpha = Join[alpha,Shape[1,{dti1[[i]]-1}]/. 1->alphaii]
	             ];
	
	(*y=nxTxp; P=nxTxpxp*)
	
	If[option==3,{m,sigma,s}=
												MapThread[Mischverteilung[alphaii,#1,#2]&,
																						{Drop[y//Transpose,-1],
																						 Drop[P//Transpose,-1]}]//Transpose;
												YF=Join[YF,m];
												PF=Join[PF,sigma];
	];
	
	                         
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	alphai1i=alphaii;
	
	{yiiR,liki,yii,Pii,alphaii} = 
		      MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,alphai1i},X[[j]]},
				                   Theta,{h,Dh,R},{miss,n,Generator,seed,False}];		
				                   	
	(* Print[alphaii]; *)               
	(* liki//Print;	*)  
	
	lik +=liki;
	
,{i,1,Length[ti]-1}];

If[option==2,
     	YF = Join[YF,{yii}];
     	PF = Join[PF,{Pii}];
     	alpha = Join[alpha,{alphaii}];
	     Return[{YF,PF,alpha,lik}]];
	
	If[option==3,
				{m,sigma,s}=Mischverteilung[alphaii,yii,Pii];
					YF=Join[YF,{m}];
					PF=Join[PF,{sigma}];
					Return[{YF,PF,lik}]];  
	
	If[option==1,Return[lik]];
	
];

GaussianSumFilter1//Clear
(***************************************************************)			 
GaussianSumFilter1[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,p0_,dt_,corr_},
				               {n_,miss_,option_:1}]:=
(***************************************************************)			 
(* gaussian sum filter (mit Zusatzterm *)

Module[{ti,dti,Xi,z,yi1i,Pi1i,alphai1i,yii,yiiR,Pii,lik,YF,PF,alphaii,
        y,P,j,liki,n1,alpha,m,sigma,s},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n1 = 1./n; 

Print["GaussianSumFilter, n = ",n,"  corr = ",corr];

{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

(*alphai1i//Print;*)

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,False}];

                 
YF  = {}; PF  = {}; alpha = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];

	{yi1i,Pi1i,y,P} = TimeUpSumFilter[{yii,Pii,alphaii,Xi,dt,corr},Theta,{f,Df,g}];
	
	
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]];
	             PF = Join[PF,Drop[P//Transpose,-1]];
	             alpha = Join[alpha,Shape[1,{dti1[[i]]-1}]/. 1->alphaii]
	             ];
	
	(*y=nxTxp; P=nxTxpxp*)
	
	If[option==3,{m,sigma,s}=
												MapThread[Mischverteilung[alphaii,#1,#2]&,
																						{Drop[y//Transpose,-1],
																						 Drop[P//Transpose,-1]}]//Transpose;
												YF=Join[YF,m];
												PF=Join[PF,sigma];
	];
	
	                         
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	
	{yiiR,liki,yii,Pii,alphaii} = 
		      MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,alphaii},X[[j]]},
				                   Theta,{h,Dh,R},{miss,n,Generator,seed,False}];		
				                   	
	(* Print[alphaii]; *)               
	(* liki//Print;	*)  
	
	lik +=liki;
	
,{i,1,Length[ti]-1}];

If[option==2,
     	YF = Join[YF,{yii}];
     	PF = Join[PF,{Pii}];
     	alpha = Join[alpha,{alphaii}];
	     Return[{YF,PF,alpha,lik}]];
	
	If[option==3,
				{m,sigma,s}=Mischverteilung[alphaii,yii,Pii];
					YF=Join[YF,{m}];
					PF=Join[PF,{sigma}];
					Return[{YF,PF,lik}]];  
	
	If[option==1,Return[lik]];
	
];

GaussianSumFilterGHF//Clear
(***************************************************************)			 
GaussianSumFilterGHF[{Z_,X_},Theta_,
                     {f_,Omega_,h_,R_,p0_,dt_,m_,eps_:10^-16,ksigma_:Infinity},
				              {n_,miss_,option_:1}]:=
(***************************************************************)			 
(* gaussian sum filter mit GHF update*)

Module[{ti,dti,Xi,z,yi1i,Pi1i,alphai1i,yii,Pii,lik,YF,PF,alphaii,
        y,P,j,liki,n1,alpha,mean,sigma,s},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

(*{ti,T1,T,dti,dti1}//Print;*)

n1 = 1./n; 

Print["GaussianSumFilter/GHF, n = ",n];  

{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

(* Gewicht N(0,1) *)
{VALS,WEIGHT}=GaussHermitePointsMulti2[m,p=yi1i//First//Length,eps,ksigma];

{lik,yii,Pii,alphaii} = 
		    MessUpGHFn[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]],m},Theta,{h,R},{miss}];

                
YF  = {}; PF  = {}; alpha = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];

	{yi1i,Pi1i,y,P} = TimeUpGHFn[{yii,Pii,Xi,dt,m},Theta,{f,Omega}];

	
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]];
	             PF = Join[PF,Drop[P//Transpose,-1]];
	             alpha = Join[alpha,Shape[1,{dti1[[i]]-1}]/. 1->alphaii]
	             ];
	
	(*y=nxTxp; P=nxTxpxp*)
	
	If[option==3,{mean,sigma,s}=
		         MapThread[Mischverteilung[alphaii,#1,#2]&,
				               {Drop[y//Transpose,-1],
			  	                Drop[P//Transpose,-1]}]//Transpose;
				YF=Join[YF,mean];
				PF=Join[PF,sigma];
	];
	

	                        
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	alphai1i=alphaii;
	
	{liki,yii,Pii,alphaii} = 
		      MessUpGHFn[{Z[[j]],{yi1i,Pi1i,alphai1i},X[[j]],m},Theta,{h,R},{miss}];		
	
	                 	
	(* Print[alphaii]; *)               
	(* liki//Print;	*)  
	
	lik +=liki;
	
,{i,1,Length[ti]-1}];


    If[option==2,
     	YF = Join[YF,{yii}];
     	PF = Join[PF,{Pii}];
     	alpha = Join[alpha,{alphaii}];
	     Return[{YF,PF,alpha,lik}]];
	
	If[option==3,
		{mean,sigma,s}=Mischverteilung[alphaii,yii,Pii];
		YF=Join[YF,{mean}];
		PF=Join[PF,{sigma}];
		Return[{YF,PF,lik}]];  
	
	If[option==1,Return[lik]];
	
];

SumFilterUKF//Clear
(***************************************************************)			 
SumFilterUKF[{Z_,X_},Theta_,{f_,g_,h_,R_,p0_,dt_,kappa_},
				                        {n_,miss_,option_:1}]:=
(***************************************************************)			 
(* sum filter mit UKF update*)

Module[{ti,dti,Xi,z,yi1i,Pi1i,alphai1i,yii,Pii,lik,YF,PF,alphaii,
        y,P,j,liki,n1,alpha,mean,sigma,s},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n1 = 1./n; 

Print["SumFilter/UKF, n = ",n];

{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

{lik,yii,Pii,alphaii} = 
		    MessUpUKFn[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]],kappa},Theta,{h,R},{miss}];

                
YF  = {}; PF  = {}; alpha = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];

	{yi1i,Pi1i,y,P} = TimeUpUKFn[{yii,Pii,Xi,dt,kappa},Theta,{f,g}];

	
	
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]];
	             PF = Join[PF,Drop[P//Transpose,-1]];
	             alpha = Join[alpha,Shape[1,{dti1[[i]]-1}]/. 1->alphaii]
	             ];
	
	(*y=nxTxp; P=nxTxpxp*)
	
	If[option==3,{mean,sigma,s}=
		           		MapThread[Mischverteilung[alphaii,#1,#2]&,
				                   {Drop[y//Transpose,-1],
			  	                    Drop[P//Transpose,-1]}]//Transpose;
				YF=Join[YF,mean];
				PF=Join[PF,sigma];
	];
	

	                        
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	alphai1i=alphaii;
	
	{liki,yii,Pii,alphaii} = 
		      MessUpUKFn[{Z[[j]],{yi1i,Pi1i,alphai1i},X[[j]],kappa},Theta,{h,R},{miss}];		
	
			                   	
	(* Print[alphaii]; *)               
	(* liki//Print;	*)  
	
	lik +=liki;
	
,{i,1,Length[ti]-1}];

If[option==2,
     	YF = Join[YF,{yii}];
     	PF = Join[PF,{Pii}];
     	alpha = Join[alpha,{alphaii}];
	     Return[{YF,PF,alpha,lik}]];
	
	If[option==3,
		{mean,sigma,s}=Mischverteilung[alphaii,yii,Pii];
		 YF=Join[YF,{mean}];
		 PF=Join[PF,{sigma}];
		 Return[{YF,PF,lik}]];  
	
	If[option==1,Return[lik]];
	
];

GaussianSumFilteralt//Clear
(***************************************************************)			 
GaussianSumFilteralt[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,p0_,dt_},
				  {{y1_,y2_,dy_},_,n_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* gaussian sum filter *)

Module[{ti,dti,Xi,z,y0,yii,Pii,lik,YF,PF,alpha,alphai,
        yi1i,Pi1i,y,P,j,liki},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;
Print["Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

SeedRandom[seed];

Xi = X[[1]];

If[Length[p0]==0,
	{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,n],
	   y0  = RandomGauss[Xi,Theta,p0,n]
  ];

If[ n == 1, y0 = {p0[[1]][_,Theta]}  ]; (* a priori mean *)
y0//Print;
P0 = If[n > 1, smoothQuickAndDirtyM[y0,1], p0[[2]][_,Theta]];
P0//Print;
P0 = (Shape[1,{n}]/.(1->P0));
alphai = Shape[1/n,{n}]//N;

{yii,Pii,alphai,lik} = 
	MessUpEKFSumAlpha[{Z[[1]],{y0,P0,alphai},Xi},Theta,{h,Dh,R},{miss,n}];

YF   = {}; PF   = {}; alpha = {};

Do[  

	Xi  = Take[ X,dti[[i]] ];

	{yi1i,Pi1i,y,P} = 
		MapThread[TimeUpEKF[{#1,#2,Xi,dt},Theta,{f,Df,g}]&,{yii,Pii}]//Transpose;	
		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]];
	             PF = Join[PF,Drop[P//Transpose,-1]];
	             alpha = Join[alpha,{alphai}] ];
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	{yii,Pii,alphai,liki} = 
		MessUpEKFSumAlpha[{Z[[j]],{yi1i,Pi1i,alphai},X[[j]]},
				Theta,{h,Dh,R},{miss,n}];
	liki//Print;	
	lik +=liki;
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{yii}];
	PF = Join[PF,{Pii}];
	alpha = Join[alpha,{alphai}];
	Return[{YF,PF,alpha,lik}],
	
	Return[lik]];
];

KalmanFokkerEKFSumDKS//Clear
(***************************************************************)			 
KalmanFokkerEKFSumDKS[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,p0_,dt_},
				                  {n_,seed_,Generator_,miss_,option_:1}]:=
(***************************************************************)			 
(* Diskretisiertes kontinuierliches sampling
   p_i+1|i = sum phi(y_i+1|i, P_i+1|i)            *)

Module[{ti,dti,Xi,z,y0,yii,yiiR,Pii,lik,alpha,alphaii,
        yi1i,Pi1i,y,P,j,liki,YF,PF,YFiiR,n1},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n1 = 1./n; 

Print["Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

{y0,P0,alpha0} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{y0,P0,alpha0},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,True}];
                 
YF   = {}; PF   = {}; alpha = {}; YFiiR = {}; null = Pii*0.;

Do[  

	Xi  = Take[ X,dti[[i]] ];
	       
	timeup = TimeUpEKF[{#1,#2,Xi,dt},Theta,{f,Df,g}]&;
		       
	{yi1i,Pi1i,y,P} = MapThread[timeup,{yiiR,null}]//Transpose;	
	
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)
	
	If[option==2,y = y//Transpose;
				 y = Drop[y,-1];
				 y = ReplacePart[y,yii,1];
				 YF = Join[YF,y];
				 									(*YF//Print;*)
	    PF = Join[PF,ReplacePart[Drop[P//Transpose,-1],Pii,1] ];
	    									(*PF//Print;*)
	    YFiiR = Join[YFiiR,{yiiR}];
	    alpha = Join[alpha,Join[{alphaii},Shape[n1,{dti1[[i]]-2}] ] ];
	             (*alphaii//Print;*)
	  ];
	  

	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	 
	      
	{yiiR,liki,yii,Pii,alphaii} = 
	     MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,n1},X[[j]]},Theta,{h,Dh,R},
	                   {miss,n,Generator,seed,True}];
	           
	lik +=liki;
	
,{i,1,Length[ti]-1}];

If[option==2,
	      YF = Join[YF,{yii}];
	      PF = Join[PF,{Pii}];
	      YFiiR = Join[YFiiR,{yiiR}];
	      alpha = Join[alpha,{alphaii}];
	
	Return[{YF,PF,alpha,lik,YFiiR}],
	
	Return[lik]];
];

FunctionalFilter//Clear
(***************************************************************)			 
FunctionalFilter[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				 {{quote_,anti_,tanner_,sort_},dW_,seed_,Generator_,miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral 
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_i+1|i = 1/N sum p(y_J|y_J-1); dy = fdt + gdW 
 
   option = 1: lik, 
   option = 2: YF: TxNxp,(Stichproben-Trajektorien) 
   option = 3: YF: Tx2xp (m und s)
   
   quote = 1,2,3

*)

Block[{ti,T,T1,dti,dti1,n,n1,Xi,z,y0,P0,alpha0,yiiR,lik,yii,Pii,alphaii,
        YF,Misch,likvec,xi,dwi,yJ1,y,G,Pi1i,yi1i,liki,eps,N1,p},


{ti,T1,T,dti,dti1} = Zeiten1[Z,miss];

n = Length[dW];
n1 = 1./n; 

Print["Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

{y0,P0,alpha0} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{y0,P0,alpha0},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,False}];

N1 = Table[n1,{n}];  (* a priori-Gewichte 1/n *)

{n,p}=yii//Dimensions;
eps= zufall[Generator,n,p,seed,anti];    (* eps=Zufallmatrix (0,1) *)

If[sort!=0,{yii,Pii,alphaii} = Sortieren[{yii,Pii,alphaii},sort]];

{yiiR,alphai1i} = Resampling[{yii,Pii,alphaii,N1},eps,seed,{quote,tanner}];

(*            
Print[Spalte[alphaii]~ii~yii~ii~yiiR~ii~y0//Chop//MatrixForm];
Pii//Print;
*)



YF   = {}; Misch = {}; likvec = {lik};

Do[  

	  Xi  = Take[ X,dti[[i]] ];
   xi  = Xi//Last;
	  dwi = Map[Take[#,dti1[[i]] ]&,dW];
  
   {yJ1,y} = TimeUpFokker[{yiiR,Xi,dwi,dt},Theta,{f,g}];
 
   G    = Map[g[#,xi,Theta]&,yJ1]; 
   Pi1i = MapThread[Dot,{G,Map[Transpose,G]}] dt;
   yi1i = yJ1 + Map[f[#,xi,Theta]&,yJ1] dt; 

 
   					(*Print[Pi1i//First//VecDiag]; *)
   					(*yi1i//Abs//Max//Print; 		*)
   					
	  yi1i = Over[yi1i,YMAX]; 
	  
	  					(*y  = Over[y,YMAX];*)

	  If[option==2,
				   YF = Join[YF,y//Transpose];
				   (*YF//Print;*)
	      (*Misch = Append[Misch,{alphaii,yii,Pii}];*)       
	  ];
	  
	  If[option==3,
	      (*
	      y//Dimensions//Print;
	      y//TensorMS//Dimensions//Print;
	      *)
	      
				   YF = Join[YF,y//TensorMS//Transpose];
				   
				   (*YF//Print; *) 
	  ];
	   
	  j = ti[[i+1]];     (* Print[{i+1,j}]; *)
		
		 {yiiR,liki,yii,Pii,alphaii} = 
		         MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,alphai1i},X[[j]]},Theta,{h,Dh,R},
		                       {miss,n,Generator,seed,False}];

			(* alphaii//Chop//Print; *)
			
			If[sort!=0,{yii,Pii,alphaii} = Sortieren[{yii,Pii,alphaii},sort]];
			
			{yiiR,alphai1i} = Resampling[{yii,Pii,alphaii,N1},eps,seed,{quote,tanner}];

	  lik +=liki; 

	
,{i,1,Length[ti]-1}];



If[option==1,Return[lik] ];

If[option==2,
	     YF = Join[YF,{yiiR}];
	     (*Misch = Append[Misch,{alphaii,yii,Pii}];*)
						Return[{YF,lik,Misch//Transpose}] ];
	
If[option==3,
						YF = Join[YF,{yiiR//TensorMS}];
	     Return[{YF,lik,Misch}] ];	
	
];

KalmanFokkerEKFSumX//Clear
(***************************************************************)			 
KalmanFokkerEKFSumX[{Z_,X_},Theta_,
	                {f_,g_,h_,Dh_,R_,p0_,dt_,MessUpEKFSumX_},
				    {{y1_,y2_,dy_},_,$dw$_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* exakter time update, EKFSumX-Me\[SZ]update*)
Module[{ti,dti,y0,n,Xi,z,yii,lik,YF,dwi,yi1i,y,j,liki},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
dti = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

n = Length[$dw$];

(*ti//Print;*)

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,n];

SeedRandom[seed];
{yii,lik} = 
	MessUpEKFSumX[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{miss,n}];

YF   = {};

Do[ 

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	
	yi1i = Over[yi1i,YMAX];
	(*y    = Over[y,YMAX];*)
	If[option==2,YF = Join[YF,Drop[y//Transpose,-1]]  ];
	j = ti[[i+1]]; 
	
	SeedRandom[seed];
	{yii,liki} = 
		MessUpEKFSumX[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,Dh,R},{miss,n}];
	
	(*liki//Print;*)
		
	lik +=liki;

,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{yii}];Return[{YF,lik}],
		Return[lik]];
];

UKF//Clear
(***************************************************************)			 
UKF[{Z_,X_},Theta_,{f_,g_,h_,R_,mue_,sigma_,dt_,kappa_,
                    messupdate_:MessUpUKF,timeupdate_:TimeUpUKF1},
		           {miss_,option_:1}]:=
(***************************************************************)			 
Block[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,Y,P,j,Y0,P0,p,IP,inno,likvec},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta]; 

{Yii,Pii,lik} = messupdate[{Z[[1]],{Yi1i,Pi1i},Xi,kappa},Theta,{h,R},{miss}];

(*{Yii,Pii,lik}//Print;*)

If[option==4, inno = {Yii-Yi1i}];
If[option==5, likvec = {lik}];


YF   = {};
PF   = {};

Do[ (*Print[i];*)

	

	Xi  = Take[ X,dti[[i]] ];  
	
	{Yi1i,Pi1i,Y,P} = 
			timeupdate[{Yii,Pii,Xi,dt,kappa},Theta,{f,g}];
	
	
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	
	{Yii,Pii,liki} = messupdate[{Z[[j]],{Yi1i,Pi1i},X[[j]],kappa},Theta,{h,R},{miss}];	

    (*{i,Yii,Pii,liki}//Print;*)

	(*Print[Z[[j]],Yi1i,Yii];*)
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
	If[option==5, likvec = Append[likvec,liki]];

		
	  (* liki//Print; *)	
	  (* Print[i,"\n",Yi1i," ",Yii]; *)	
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

If[option==2,
	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,Return[{lik,inno}//N]];

If[option==5,Return[{lik,likvec}//N]];


];


GF//Clear
(***************************************************************)
GF[{Z_,X_},Theta_,{f_,Omega_,h_,R_,mue_,sigma_,dt_},{miss_,option_:1}]:=
(***************************************************************)
(* Gauss-Filter*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,yi1i,alphai1i,Y,P,j,Y0,P0,p,
        inno,likvec},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
ti//Print;
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta];

ksigma=4;
genau=10.^-8;

Print["GF: ","ksigma = ",ksigma,", genau = ",genau];

{Yii,Pii,lik} = MessUpGF[{Z[[1]],{Yi1i,Pi1i},Xi},Theta,{h,R},{miss}];

Pii=Shift[Pii,10^-6];

{Yii,Pii}//Print;


If[option==4, inno = {Yii-Yi1i}];
If[option==5, likvec = {lik}];


YF   = {};
PF   = {};


Do[ (*Print[i];*)



	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = 
			TimeUpGF[{Yii,Pii,Xi,dt},Theta,{f,Omega}];
	
	(*
	Yi1i = Over[Yi1i,YMAX];
	Y    = Over[Y,YMAX];
	*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	
	{yi1i,alphai1i}=SigmaSample[Yi1i,Pi1i,0];

	{Yii,Pii,liki} = MessUpGF[{Z[[j]],{Yi1i,Pi1i},X[[j]]},Theta,{h,R},{miss}];

	
	(*Print[Z[[j]],Yi1i,Yii];*)
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
	If[option==5, likvec = Append[likvec,liki]];

	  (* liki//Print; *)
	  (* Print[i,"\n",Yi1i," ",Yii]; *)
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

	
If[option==2,
 (*
	Pii=(Pii//Symmetrize) + 10^-8 IdentityMatrix[Pii//Length]; (*Pii>0*)
	Pii=Shift[Pii,10.^-6];
	*)

	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,Return[{lik,inno}//N]];

If[option==5,Return[{lik,likvec}//N]];


];


GHF//Clear
(***************************************************************)
GHF[{Z_,X_},Theta_,{f_,Omega_,h_,R_,mue_,sigma_,dt_,
     m_,eps_:10^-16,ksigma_:Infinity,
     update_:MessUpGHF,timeup_:TimeUpGHF1},
     {miss_,option_:1,Panel_:False}]:=
(***************************************************************)
(* Gauss-Hermite-Filter, TimeUpGHF1: konstantes Omega(_,t_,Theta_) *)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,yi1i,alphai1i,Y,P,j,Y0,P0,p,
        inno,likvec},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)

(*ti//Print; *)
(*{update,timeup}//Print;*)

T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta];

(*Print["GHF: ","m = ",m];*)

If[Panel,
  
	{VALS1,WEIGHT1}=GaussHermitePointsMulti2[m,1,eps,ksigma];
	{VALS2,WEIGHT2}=GaussHermitePointsMulti2[m,2,eps,ksigma],

	(*else*)
	(* Gewicht N(0,1) *)
	
	{VALS,WEIGHT}=GaussHermitePointsMulti2[m,p=Yi1i//Length,eps,ksigma,1]
];


{Yii,Pii,lik} = update[{Z[[1]],{Yi1i,Pi1i},Xi,m},Theta,{h,R},{miss}];


If[option==4, inno = {Yii-Yi1i}];
If[option==5, likvec = {lik}];


YF   = {};
PF   = {};


Do[ (*Print[i];*)



	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = 
			timeup[{Yii,Pii,Xi,dt,m},Theta,{f,Omega}];
	
	
	(*
	Yi1i = Over[Yi1i,YMAX];
	Y    = Over[Y,YMAX];
	*)
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)

	{Yii,Pii,liki} = update[{Z[[j]],{Yi1i,Pi1i},X[[j]],m},Theta,{h,R},{miss}];
	
	(*Print[Z[[j]],Yi1i,Yii];*)
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
	If[option==5, likvec = Append[likvec,liki]];

	  (* liki//Print; *)
	  (* Print[i,"\n",Yi1i," ",Yii]; *)
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

	
If[option==2,

	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,Return[{lik,inno}//N]];

If[option==5,Return[{lik,likvec}//N]];


];


SMKF//Clear
(***************************************************************)
SMKF[{Z_,X_},Theta_,{f_,g_,h_,R_,mue_,sigma_,dt_,n_,seed_,anti_},{miss_,option_:1}]:=
(***************************************************************)
(* simulated moments KF*)

Module[{T1,ti,dti,dti1,Xi,Yii,Pii,lik,liki,
        YF,PF,Yi1i,Pi1i,yi1i,alphai1i,Y,P,j,Y0,P0,p,inno,likvec},


ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
ti//Print;
T1 = Length[Z];
ti = Union[ti,{1,T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

Xi = X[[1]];
Yi1i=mue[Xi,Theta];
Pi1i=sigma[Xi,Theta];

{Yii,Pii,lik} = MessUpSMKF[{Z[[1]],{Yi1i,Pi1i},Xi,n,seed,anti},Theta,{h,R},{miss}];

{Yii,Pii}//Print; 


If[option==4, inno = {Yii-Yi1i}];
If[option==5, likvec = {lik}];


YF   = {};
PF   = {};


Do[ (*Print[i];*)



	Xi  = Take[ X,dti[[i]] ];
	
	{Yi1i,Pi1i,Y,P} = TimeUpSMKF[{Yii,Pii,Xi,dt,n,seed,anti},Theta,{f,g}];
	
	If[option==2,
	YF = Join[YF,Drop[Y,-1]];
	PF = Join[PF,Drop[P,-1]];
	];
	
	
	j = ti[[i+1]];
	
	   (*{i,j}//Print; *)
	

	{Yii,Pii,liki} = MessUpSMKF[{Z[[j]],{Yi1i,Pi1i},X[[j]],n,seed,anti},Theta,{h,R},{miss}];

	
	(*Print[Z[[j]],Yi1i,Yii];*)
	
	If[option==4, inno = Join[inno,{Yii-Yi1i}]];
	If[option==5, likvec = Append[likvec,liki]];

	  (* liki//Print; *)
	  (* Print[i,"\n",Yi1i," ",Yii]; *)
	  (* {i,Yii,Pii,liki}//Print; *)
	
	lik +=liki;
	
	
,{i,1,Length[ti]-1}];

	
If[option==2,

	Pii=(Pii//Symmetrize) + 10^-8 IdentityMatrix[Pii//Length]; (*Pii>0*)
	Pii=Shift[Pii,10.^-6];

	YF = Join[YF,{Yii}];
	PF = Join[PF,{Pii}];
	Return[{YF,PF,lik}//N]];
	
If[option==1,Return[lik//N]];

If[option==4,Return[{lik,inno}//N]];

If[option==5,Return[{lik,likvec}//N]];


];



AntiThetisch[x_]:= Join[x,-x];

AntiThetisch1//Clear
AntiThetisch1[x_]:= 
Module[{n,x1,xi},
n = Length[x];
x1 = Range[2n];
Do[xi = x[[i]];x1[[2i-1]] = xi; x1[[2i]] = -xi,{i,n}];
x1
]

AntiThetisch1[{1,2,{3},A,{B}}]



dW//Clear;
dW[Generator_,seed_,{n_,T_,r_,dt_}]:=
Module[{nn,tt,rr,dt2},
SeedRandom[seed];
dt2 = Sqrt[dt];
Table[Generator[]*dt2,{nn,n},{tt,T+1},{rr,r}] ]

dWAntiThetisch[Generator_,seed_,{n_,T_,r_,dt_}]:=
Module[{dwn,nn,tt,rr,dt2},
SeedRandom[seed];
dt2 = Sqrt[dt];
Table[If[OddQ[nn], dwn = Table[Generator[]*dt2,{tt,T+1},{rr,r}], 
                  -dwn],
     {nn,n} ] ]

pzy//Clear
(***************************************************************)			 
pzy[{Z_,Y_,X_},Theta_,{h_,R_},{miss_}]:=
(***************************************************************)			 
	(* Dichte p(z|y) *) 
	
	Module[{zmiss,lc,r,r1,inn},
	
	 zmiss = Map[SameQ[miss,#]&,Z];		
	 lc = Locate[zmiss,False];
	    
	 If[lc == {},Return[1] ]; (*keine Messung*)
	    
		
		r = R[Y,X,Theta][[lc,lc]];	
		r1 = r//Inverse;
		inn = Z[[lc]] - h[Y,X,Theta][[lc]];	
		
						(* Print[{Z[[lc]],Y,inn,r,r1} ]; *)
		
		Det[r]^(-0.5) Exp[(-0.5) (inn.r1.inn)]	
	
]

Logpzy//Clear
(***************************************************************)			 
Logpzy[{Z_,Y_,X_},Theta_,{h_,R_},{miss_}]:=
(***************************************************************)			 
	(* Dichte Log p(z|y) *) 
	
	Module[{zmiss,lc,r,r1,inn},
	
	 zmiss = Map[SameQ[miss,#]&,Z];		
	 lc = Locate[zmiss,False];
	    
	 If[lc == {},Return[0] ]; (*keine Messung*)
	    
		
		r = R[Y,X,Theta][[lc,lc]]; 
		r1 = r//Inverse;
		inn = Z[[lc]] - h[Y,X,Theta][[lc]];	
		(*Print[{Z[[lc]],Y,inn,r,r1} ];*)
				
		-0.5( Log[Det[r]]+(inn.r1.inn) )
]


Interpol//Clear
(***************************************************************)
Interpol[XM_,MISS_,ORDER_] := 
(***************************************************************)
	Module[{XMr,Xint,tau3,T1,q,data,i},
	  {T1,q} = XM//Dimensions; 
		 XMr = XM//Reverse;
		
		 Xint = 
		 Table[tau3 = Locate[XMr[[T1//Range,qq]] ~sameq~ MISS, False];
		       
		       If[tau3=={},
		       Print["keine Daten in Spalte ",qq];
		       i=Table[MISS,{j,T1}],
		       
		       (*else*)
			      data = {tau3,XMr[[tau3,qq]]}//Transpose;
			      (*data//Print;*)
         i=Interpolation[data,InterpolationOrder->ORDER][(T1)//Range];
         (*i//Print;*)
         If[XMr[[1,q]]=!=MISS && ORDER==0,i[[1]]=XMr[[1,q]] ];
         ];
         
         i
         
   ,{qq,q}];
       		  
		Xint=Transpose[Xint]//Reverse
	
	 ]

Phi//Clear
Phi[y_,mue_,sigma_] := 
	Module[{dy = y-mue},
	Det[sigma]^(-0.5) Exp[-0.5 dy.Inverse[sigma].dy ]
	]

Phi1//Clear
Phi1[y_,mue_,sigma1_] := 
	Module[{dy = y-mue},
	Det[sigma1]^(0.5) Exp[-0.5 dy.sigma1.dy ]
	]

LogPhi//Clear
LogPhi[y_,mue_,sigma_] := 
	Module[{dy = y-mue},
	-0.5( Log[Det[sigma]] + dy.Inverse[sigma].dy) 
	]

LogPhi1//Clear
LogPhi1[y_,mue_,sigma1_] := 
	Module[{dy = y-mue},
	-0.5( -Log[Det[sigma1]] + dy.sigma1.dy) 
	]

Phi[{1},0,{{2}}]
Phi1[{1},0,{{2}}//Inverse]
LogPhi[{1},0,{{2}}]//Exp//N
LogPhi1[{1},0,{{2}}//Inverse]//Exp//N









likratio0[y_,{yii1_,Pii1_,alphaii1_},{yii2_,Pii2_,alphaii2_}]:=
Module[{p1,p2},
p1=Apply[Plus,alphaii1*MapThread[Phi[y,#1,#2]&,{yii1,Pii1}]];
p2=Apply[Plus,alphaii2*MapThread[Phi[y,#1,#2]&,{yii2,Pii2}]];

p1/p2 

]	

likratio0[{y},{ {{y11},{y12}} , {{{1}},{{2}}}, {.2,.8}}, 
              { {{y21},{y22}} , {{{1}},{{2}}}, {.4,.6}}]



SML//Clear
(***************************************************************)			 
SML[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				   {{y1_,y2_,dy_},_,$dw$_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* langes W(t), nur einmal seedrandom *)

Module[{ti,T1,dti,dti1,n,Xi,z,y0,dwi,yii,yi1i,y,j,Liki,Lik},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;
n = Length[$dw$];
Print["SML: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

SeedRandom[seed];

Xi = X[[1]];

If[Length[p0]==0,
	{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,n],
	    y0 = RandomGauss[Xi,Theta,p0,n]
  ];

Lik = Map[pzy[{Z[[1]],#,X[[1]]},Theta,{h,R},{miss}]&,y0];
	
yii = y0;

(*YF = {}; *)	

Do[  

		Xi  = Take[ X,dti[[i]] ];
		dwi = Map[Take[#,dti[[i]] ]&,$dw$];
		
		{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
		
		yi1i = Over[yi1i,YMAX];
		(*y  = Over[y,YMAX];*)
		
	 (*YF = Join[YF,Drop[y//Transpose,-1]];*)
		
		j = ti[[i+1]]; 
		(*Print[{i+1,j}];*)
		
		Liki = Map[pzy[{Z[[j]],#,X[[j]]},Theta,{h,R},{miss}]&,yi1i];
	 yii = yi1i;
			
		(*Liki//Print;*)
			
		Lik *= Liki; 

,{i,1,Length[ti]-1}];

		Return[Log[mean[Lik]] ]
];

SML1//Clear
(***************************************************************)			 
SML1[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				   {{y1_,y2_,dy_},_,$dw$_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* langes W(t), nur einmal seedrandom *)

Module[{ti,T1,dti,n,Xi,z,y0,dwi,yii,yi1i,y,j,Liki,Lik,lik},

ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
(*ti//Print;*)
T1 = Length[Z];
ti = Union[ti,{T1}];
(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;
n = Length[$dw$];
Print["SML1: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

SeedRandom[seed];

Xi = X[[1]];

If[Length[p0]==0,
	{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,n],
	    y0 = RandomGauss[Xi,Theta,p0,n]
  ];

  (*YF = {}; *)	
		
		{yi1i,y} = TimeUpFokker[{y0,X,$dw$,dt},Theta,{f,g}];
		
		y = Map[Part[#,ti]&,y];
		
		
		Lik = Table[
														Apply[Times,
		            MapThread[pzy[{#1,#2,#3},Theta,{h,R},{miss}]&,
			                     {Z[[ti]],y[[nn]],X[[ti]]}]],
			           {nn,n}];
		(*	           
	 Lik//Print; 
  Lik//Max//Log//Print;
  Lik//Min//Log//Print;
  *)
     
  lik = Lik//mean//Log;
      
		If[option == 1, lik,
		If[option == 2,     lik,                        
		If[option == 3,{lik,lik},
		If[option == 4, Log[CuMean[Lik]]                        
		  ]]]]
];

Lambda//Clear
(***************************************************************)			 
Lambda[ti_,T1_,{l0_,l1_,l2_:0},Miss_] := 
(***************************************************************)			 
Module[{tt,lambda},
tt = Drop[ti,-1] + Delta[ti]/2.//Ceiling;
tt = Intersection[tt,Complement[Range[T1],ti]];

(*Mitte zwischen den Messungen (au\[SZ]er Delta[ti] = 1*)

lambda = Shape[Miss,{T1}];
(*ti//Print;*)
(*tt//Print;*)
Map[(lambda[[#]]=l1)&,ti];
Map[(lambda[[#]]=l0)&,tt];
lambda = Interpol[lambda//Spalte,Miss,1]//Flatten//N;
Map[Max[#,l2]&,lambda]
]

Lambda1//Clear
(***************************************************************)			 
Lambda1[ti_,T1_,{l0_,l1_,l2_:0},Miss_] := 
(***************************************************************)			 
Module[{tt,lambda},

lambda = Shape[Miss,{T1}];

Map[(lambda[[#]]=l1)&,ti];
tt = Intersection[Drop[ti,-1]+1,Complement[Range[T1],ti]];
Map[(lambda[[#]]=l0)&,tt];
lambda = Interpol[lambda//Spalte,Miss,1]//Flatten//N;
Map[Max[#,l2]&,lambda]
]

Lambda2//Clear
(***************************************************************)			 
Lambda2[ti_,T1_,{l0_,l1_,l2_:0},Miss_] := 
(***************************************************************)			 
Module[{tt,lambda},

lambda = Shape[Miss,{T1}];

Map[(lambda[[#]]=l0)&,ti];
tt = Intersection[Drop[ti,1]-1,Complement[Range[T1],ti]];
Map[(lambda[[#]]=l1)&,tt];
lambda = Interpol[lambda//Spalte,Miss,1]//Flatten//N;
Map[Max[#,l2]&,lambda]
]

toExpression[y_]:= If[StringQ[y],ToExpression[y],y,y];

Zeiten//Clear
(***************************************************************)			 
Zeiten[Z_,miss_]:= 
(***************************************************************)			 
Module[{ti,T1,T,dti,dti1},
ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
			(*ti//Print;*)
T1 = Length[Z];
T = T1-1;
ti = Union[ti,{1,T1}];
			(*ti//Print;*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

{ti,T1,T,dti,dti1}]

Zeiten1//Clear
(***************************************************************)			 
Zeiten1[Z_,miss_]:= 
(***************************************************************)			 
Module[{ti,T1,T,dti,dti1},
ti  = messind[Z,miss]; (*Indices mit mind. einer Messung*)
			(*ti//Print;*)
T1 = Length[Z];
T = T1-1;
ti = Union[ti,{1,T1}];
			(*ti//Print;*)
dti  = Delta[ti,ti-1,List,-1];
dti1 = Delta[ti];

{ti,T1,T,dti,dti1}]

(***************************************************************)			 
CompressData[Z_,miss_]:= Module[{ti},
(***************************************************************)			 
	ti  = messind[Z,miss];
	ti  = Union[ti,{1,Length[Z]}];
	{Z[[ti]],ti}]

(***************************************************************)			 
ExpandData[{Z_,ti_},miss_]:= Module[{Tc,k,T1,ZE},
(***************************************************************)			 
	{Tc,k} = Z//Dimensions;
	 T1    = ti//Last;
	
	ZE = Shape[miss,{T1,k}];
	Map[ (ZE[[ti[[#]] ]]=Z[[#]])&,Tc//Range];
	
	ZE
	
	]	
	

GAMMA = 1.;
SMLImportance//Clear
(***************************************************************)			 
SMLImportance[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				          {{l0_,l1_,l2_:0},step_:EulerStep1,dw_,
				          seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* langes W(t), nur einmal seedrandom *)

Module[{fI,f1,f2,g1,i,n,ti,T1,T,dti,dti1,X0,mue,sigma,
        Y00,P00,lik0,sigma1,P001,z,y0,ZI,XZ,zi,xi,
        Lik,lik,norm,lognorm,likratiomean,
        y0n,yn,yni,dwn,likratioT,likratio0,pZY},

{ti,T1,T,dti,dti1} = Zeiten[Z,miss];

n = Length[toExpression[dw]];

Print["SMLImportance: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

fI//Clear; 
fI[{z_,y_},{x_,_,_},Th_]:= (z - h[y,x,Th]).Inverse[ R[y,x,Th] ].Dh[y,x,Th];

(*
fI//Clear; 
fI[{z_,y_},{x_,_,_},Th_]:= 
Module[{K,H,SH,r,r1},
H = Dh[y,x,Th];
r = R[y,x,Th];
r1 = r//Inverse;
SH = SIGMA.Transpose[H];
K = SH.Inverse[H.SH + r];
(z-h[y,x,Th]).r1.H + Inverse[SIGMA - K.H.SIGMA].(MUE-y)
];
*)
                         
f2//Clear;
f2[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th] + lambdat*fI[{z,y},{x,_,_},Th];

f1//Clear;
f1[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th]; 
 
g1//Clear;
g1[y_,{x_,z_,lambdat_},Th_]:= g[y,x,Th];

g2//Clear;
(*g2[y_,{x_,z_,lambdat_},Th_]:= GAMMA * g[y,x,Th];*)
g2[y_,{x_,z_,lambdat_},Th_]:=         g[y,x,Th];

X0    =  X[[1]];
mue   = p0[[1]][X0,Theta];
sigma = p0[[2]][X0,Theta];

{Y00,P00,lik0} = MessUpEKF[{Z[[1]],{mue,sigma},X0,_},Theta,{h,Dh,R},{miss}];	
        
 sigma1 = sigma//Inverse;
 P001   = P00  //Inverse;        

SeedRandom[seed];
       	
If[Length[p0]==0,
	 {z,y0} = RandomNumbers[{y1,y2,dy},p0[#,X0,Theta]&,n],
	    y0  = RandomGauss[Y00,P00,n]
  ];  
  (*AB aus EKF-posteriori-Verteilung*)
    
  ZI = Interpol[Z,miss,1];
  lambdat = Lambda[ti,T1,{l0,l1},miss];
  
		XZ = {X,ZI,lambdat}//Transpose;
		
		zi = Z[[ti]];
		xi = X[[ti]];
		YY = {};
				
		Lik = 
		Table[ 
		      y0n = y0[[nn]];
		      
		      dwn = toExpression[dw][[nn]];
		      
		      yn = RungeKutta1[f2,g2,y0n,{XZ,dwn}, T, dt, Theta, step];		     
		      yni = yn[[ti]];
		      
		      (*AppendTo[YY,yn];*)
		      
       	(*likratioT  =   LogLikelihoodRatio2[yn,{f1,f2},{g1,g2},XZ,dt,Theta];*)
       	
       	likratioT  =   LogLikelihoodRatio[yn,{f1,f2},g1,XZ,dt,Theta];
       
       
      		likratio0 =  (LogPhi1[y0n,mue,sigma1]-
		                    LogPhi1[y0n,Y00,P001  ]);
		                   
		      pZY =  Apply[Plus,
		                   MapThread[Logpzy[{#1,#2,#3},Theta,{h,R},{miss}]&,
		                   {zi,yni,xi}]];
			                                             
       likrat = Exp[likratioT+likratio0];
       
         (*{likrat, Exp[pZY]*likrat}//Print; *)
               
      	{likrat, Exp[pZY]*likrat}
       
      			      
		,{nn,n}];
		
		Lik = Lik//Transpose;
		
		norm = Plus@@Lik[[1]] ;
		lognorm = norm//Log;
		lik = Log[mean[Lik[[2]] ]]; 
		
		           (*Lik[[2]]//Print;Lik[[2]]//Max//Log//Print;*)
		
		likratiomean = norm/n;
	 (*likratiomean//Print;*)
  
		If[option == 1, {lik,likratiomean},
		If[option == 2,      lik - lognorm,                        
		If[option == 3, {lik,lik - lognorm},
		If[option == 4, Log[CuMean[Lik[[2]] ]]                        
		  ]]]]
		                
		 
];

LikFIF//Clear
(***************************************************************)			 
LikFIF[{Y_,X_},Theta_,{f_,g_,p0_,dt_},{dW_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral, kein Me\[SZ]-Modell, ohne IS
 
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_i+1|i = 1/N sum p(y_J|y_J-1); dy = fdt + gdW 
 
   option = 1: lik

*)

Module[{ti,T1,T,dti,dti1,n,X0,lik,mue,sigma,Xi,xi,dwi,Yi,yJ1,y,
        G,Pi1i,yi1i,j,liki},

{ti,T1,T,dti,dti1} = Zeiten1[Y,miss];

n = Length[dW]; 
Print["LikFIF: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

SeedRandom[seed];

X0 = X[[1]];

If[Length[p0]==0,
	 	lik = Log[ p0[Y[[1]],X0,Theta] ],
	 			(*else*)
	 	mue   = p0[[1]][X0,Theta];
  	sigma = p0[[2]][X0,Theta];  
  	lik = LogPhi[Y[[1]],mue,sigma]; (*AB*)	 
  ];  
  
(*lik//Print;*)

Do[ 

	Xi  = Take[ X,dti[[i]] ]; 
 xi  = Xi//Last;
	dwi = Map[Take[#,dti1[[i]] ]&,dW];
 Yi = Y[[ti[[i]] ]];
 Yi = Table[Yi,{n}];
 
 If[dti1[[i]] =!= 1,
      {yJ1,y} = TimeUpFokker[{Yi,Xi,dwi,dt},Theta,{f,g}],
            (*else*)  	
            yJ1 = Yi;   (*DKS*)
 ];

 G =  Map[g[#,xi,Theta]&,yJ1]; 
 Pi1i = MapThread[Dot,{G,Map[Transpose,G]}] dt;
 yi1i = yJ1 + Map[f[#,xi,Theta]&,yJ1] dt;  
    		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)
	   
	j = ti[[i+1]];      (*Print[{i+1,j}];*)
	
	liki = MapThread[Phi[Y[[j]],#1,#2]&,{yi1i,Pi1i}];
	
	liki = If[option == 1, Log[mean[liki] ], Log[CuMean[liki] ]   ];
	
     (*liki//Print;*)
		
	lik += liki;
	
,{i,1,Length[ti]-1}];

lik

	
];

LikFIFImportance//Clear
(***************************************************************)			 
LikFIFImportance[{Y_,X_},Theta_,{f_,g_,p0_,dt_},
                 {{l0_,l1_,l2_:0},dW_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral, kein Me\[SZ]-Modell, mit IS
 
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_i+1|i = 1/N sum p(y_J|y_J-1); dy = fdt + gdW 
 
   option = 1: lik

*)

Module[{ti,T1,T,dti,dti1,n,X0,lik,mue,sigma,Xi,xi,dwi,Yi,yJ1,y,
        G,Pi1i,yi1i,j,liki,fI,f1,f2,g1,p,likratio},

{ti,T1,T,dti,dti1} = Zeiten1[Y,miss];

n = Length[dW]; 
Print["LikFIFImportance: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

fI//Clear; 
fI[{z_,y_},{x_,_,_},Th_]:= (z - y); (*ohne R*)
                         
f2//Clear;
f2[y_,{x_,z_,lambdat_},Th_]:=  f[y,x,Th] + lambdat*fI[{z,y},{x,_,_},Th];

f1//Clear;
f1[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th]; 
 
g1//Clear;
g1[y_,{x_,z_,lambdat_},Th_]:= g[y,x,Th];
SeedRandom[seed];

X0 = X[[1]];

If[Length[p0]==0,

	 	lik = Log[ p0[Y[[1]],X0,Theta] ],
	 	
	(*else*)
	 	mue   = p0[[1]][X0,Theta];
  	sigma = p0[[2]][X0,Theta];  
  	lik = LogPhi[Y[[1]],mue,sigma]; (*AB*)	
  	 
  ];  
  
(*lik//Print;*)

YI = Interpol[Y,miss,1];
lambdat = Lambda2[ti,T1,{l0,l1,l2},miss];
  
XY = {X,YI,lambdat}//Transpose;

YY = {};

Do[ 

	Xi  = Take[ XY,dti[[i]] ]; 
 xi  = Xi//Last;
	dwi = Map[ Take[#,dti1[[i]] ]&, dW];
 Yi  = Y[[ti[[i]] ]];
 Yi  = Table[Yi,{n}];
 	
 If[dti1[[i]] =!= 1,
      {yJ1,y} = TimeUpFokker[{Yi,Xi,dwi,dt},Theta,{f2,g1}],
   (*else*)  	
      yJ1 = Yi; y = Map[List,Yi]   (*DKS*)
 ];
 
       (* YY = Join[YY,y//Transpose];*)
  
 G =  Map[g1[#,xi,Theta]&,yJ1]; 
 Pi1i = MapThread[Dot,{G,Map[Transpose,G]}] dt;
 yi1i = yJ1 + Map[f1[#,xi,Theta]&,yJ1] dt; 
    		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)
	   
	j = ti[[i+1]];      (*Print[{i+1,j}];*)
		   
	p = LogLikelihoodRatio[#,{f1,f2},g1,Xi,dt,Theta]&;
      		
	likratio = Map[p,y]; 
	
					(*{y//Dimensions,likratio}//Print; *)
	
	liki = Exp[MapThread[LogPhi[Y[[j]],#1,#2]&,{yi1i,Pi1i}] + likratio];
	
	(*liki = MapThread[Phi[Y[[j]],#1,#2]&,{yi1i,Pi1i}] * likratio;*)
	
	liki = If[option == 1, Log[mean[liki] ], Log[CuMean[liki] ]   ];
	
	(*liki = Log[mean[liki] ];*)
 (*liki//Print;*)
		
	lik += liki;
	
,{i,1,Length[ti]-1}];

(*YY = Join[YY,{yi1i}];*)

lik

	
];

FIFImportance//Clear
(***************************************************************)			 
FIFImportance[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				             {{l0_,l1_,l2_:0},step_,dW_,seed_,Generator_,miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral mit importance sampling 
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_{i+1|i} = 1/N sum p(y_{i+1} = y_J|y_J-1) * alpha{i+1|i}; 
   dy = fdt + gdW 
 
   option = 1: lik, 
   option = 2: YF: TxNxp,(Stichproben-Trajektorien) 
   option = 3: YF: Tx2xp (m und s)

*)

Module[{ti,T1,T,dti,dti1,n,n1,Xi,z,y0,P0,yiiR,lik,yii,Pii,alphaii,alphai1i,
        YF,Misch,likvec,xi,dwi,yJ1,y,G,Pi1i,yi1i,liki,fI,f2,f1,g1,g2,XZ,p,
        likratio},

{ti,T1,T,dti,dti1} = Zeiten1[Z,miss];

n = Length[dW]; n1 = 1./n; 

Print["FIFImportance: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

fI//Clear; 
fI[{z_,y_},{x_,_,_},Th_]:= (z - h[y,x,Th]).Inverse[ R[y,x,Th] ].Dh[y,x,Th];
                         
f2//Clear;
f2[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th] + lambdat*fI[{z,y},{x,_,_},Th];

f1//Clear;
f1[y_,{x_,z_,lambdat_},Th_]:= f[y,x,Th]; 

g1//Clear;
g1[y_,{x_,z_,lambdat_},Th_]:= g[y,x,Th];

g2//Clear;
g2[y_,{x_,z_,lambdat_},Th_]:= g[y,x,Th];



SeedRandom[seed];

{y0,P0,alpha0} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{y0,P0,alpha0},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,True}];
		                  
		                  				                 	
YF   = {}; Misch = {}; likvec = {lik};

lambdat = Lambda2[ti,T1,{l0,l1},miss];
  
XZ = {X, Interpol[Z,miss,1],lambdat}//Transpose;

Do[  

	Xi  = Take[ XZ,dti[[i]] ];
 xi  = Xi//Last;
	dwi = Map[Take[#,dti1[[i]] ]&,dW];
 
 If[dti1[[i]] =!= 1,
  
		{yJ1,y} = TimeUpFokker[{yiiR,Xi,dwi,dt},Theta,{f2,g2},step],
		
   yJ1 = yiiR; y = {yiiR}//Transpose  (*DKS*)
 ];
 
 G =  Map[g1[#,xi,Theta]&,yJ1]; 
 Pi1i = MapThread[Dot,{G,Map[Transpose,G]}] dt;
 yi1i = yJ1 + Map[f1[#,xi,Theta]&,yJ1] dt; 

 (*Print[yi1i//First];*)
 (*Print[Pi1i//First//VecDiag]; *)
    		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)

	If[option==2,
				 YF = Join[YF,y//Transpose];
				 (*YF//Print;*)
	    (*Misch = Append[Misch,{alphaii,yii,Pii}];*)       
	  ];
	  
	If[option==3,
	    (*y//Dimensions//Print;
	    y//TensorMS//Dimensions//Print;*)
				 YF = Join[YF,y//TensorMS//Transpose];
				 (*YF//Print; *) 
	  ];
	   
	j = ti[[i+1]]; 
	(*Print[{i+1,j}];*)
	
	If[dti1[[i]] =!= 1,
	
				p = LogLikelihoodRatio[#,{f1,f2},g1,Xi,dt,Theta]&; 
				alphai1i = n1*(Map[p,y]//Exp),	  
	
				alphai1i = n1
	];


alphai1i//Print;


         (* yi1i//Print;*)
							 	(* oder:alphai1i = alphai1i/(Plus@@alphai1i); *)    		(*Normierung*)	
       	 (*Plus@@alphai1i//Print;*)
		
	{yiiR,liki,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[j]],{yi1i,Pi1i,alphai1i},X[[j]]},
				                 Theta,{h,Dh,R},{miss,n,Generator,seed,True}];
	
	(*liki//Print;*)	
	(*likvec = Append[likvec,liki];*)
	
	lik +=liki;
	
,{i,1,Length[ti]-1}];



If[option==1,Return[lik] ];

If[option==2,
	YF = Join[YF,{yiiR}];
	(*Misch = Append[Misch,{alphaii,yii,Pii}];*)
	Return[{YF,lik,Misch//Transpose}] ];
	
If[option==3,
	YF = Join[YF,{yiiR//TensorMS}];
	Return[{YF,lik,Misch}] ];	
	
];

(***************************************************************)			 
alphamax[alphaiiZ_]:=Module[{alphaiimax,imax,n=alphaiiZ//Length},
(***************************************************************)			 
imax=Position[alphaiiZ,alphaiiZ//Max]//Flatten;
alphaiimax=Shape[0,{n}];
Map[(alphaiimax[[#]]=1./Length[imax])&,imax];
alphaiimax
]


alphamax[{.4,.4,.6,.4}]



(***************************************************************)			 
alphafilter[alpha_,c_]:=
(***************************************************************)	
Module[{pos,alpha1},		 
pos=Position[Map[(#<c)&,alpha],True];
alpha1=ReplacePart[alpha,0,pos];
alpha1=alpha1/Apply[Plus,alpha1]
]


alpha={.1,.1,.2,.6};
alphafilter[alpha,.21]



FIFImportanceSmooth//Clear
(***************************************************************)			 
FIFImportanceSmooth[{Z_,X_},Theta_,{f_,Df_,g_,h_,Dh_,R_,p0_,dt_},
				                {{l0_:1,l1_:1,l2_:0,iter_:1,
				                  quote_,anti_,tanner_,sort_,Alphanorm_},
				                step_,dW_,seed_,Generator_,
				                 miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral mit exaktem importance sampling
   f\[UDoubleDot]r lineare Systeme 
   
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_{i+1|i} = 1/N sum p(y_{i+1} = y_J|y_J-1) * alpha{i+1|i}; 
   dy = fdt + gdW 
 
   option = 1: lik, 
   option = 2: YF: TxNxp,(Stichproben-Trajektorien) 
   option = 3: YF: Tx2xp (m und s)

*)

Block[{ti,T1,T,dti,dti1,n,n1,Xi,z,y0,P0,yiiR,lik,yii,Pii,alphaii,alphai1i,
        yiiZ,PiiZ,alphaiiZ,
        YF,Misch,(*likvec,*)xi,dwi,yJ1,y,G,Pi1i,yi1i,liki,f2g2,fI,f2,f1,g1,g2,XZ,p,
        likratio,lik2,lik1,Zi1},

{ti,T1,T,dti,dti1} = Zeiten1[Z,miss];

(*
ti//Print;
dti//Print;  
dti1//Print; 
*)

n = Length[dW]; n1 = 1./n; 

Print["FIFImportanceSmooth: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];


f2g2//Clear;
f2g2[y_,{XX_,z_},Th_]:= Block[{fI,OmegaI,F1,F2,G,Omega,G2},
	
	   {fI,OmegaI} = SmoothEKF2[{z,y,_,XX,dt},Th,{f,Df,g,h,Dh,R},miss];	
	
	   F1 = f[y,XX//First,Th];
	   F2 = F1 + l0*fI;
	 
	   G = g[y,XX//First,Th];
	   Omega = G.Transpose[G];	  
	   
	   G2 =  CholeskyDecomposition[Symmetrize[Omega + l1*OmegaI]]//Transpose;
	   
	   (*Print[XX//First,F1,F2,G,G2]; *)
	 
	 {F2,G2}	 ];
	 
	 
{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,False}];
		                  
likneu=lik;

					(*
						{yiiZ,PiiZ,alphaiiZ} = SmoothEKF[{Z[[ti[[2]] ]],yii,Pii,alphaii,
                                						  Take[X,dti[[1]] ],dt},Theta,
                                						 {f,Df,g,h,Dh,R},miss];

						{yiiZ,PiiZ,alphaiiZ}//Print;

						*)
                                

{yiiZ,PiiZ,alphaiiZ} = SmoothEKFIter[{Z[[ti[[2]] ]],yii,Pii,alphaii,
                                     Take[X,dti[[1]] ],dt,iter},Theta,
                                     {f,Df,g,h,Dh,R},miss];
                                                              
                                 
If[l2==1,alphaiiZ= Shape[n1,{n}]  ];
If[l2==2,alphaiiZ= ALPHIIZ[[1]] ];
If[l2==3,ALPHIIZ = Append[{},alphaiiZ] ];
If[l2==4,alphaiiZ= alphamax[alphaiiZ]  ];
If[l2==6,alphaiiZ= alphafilter[alphaiiZ,n1]  ];
	
				
N1 = Table[n1,{n}];  (* a priori-Gewichte 1/n *)

{n,p}=yii//Dimensions;
eps= zufall[Generator,n,p,seed,anti];    (* eps=Zufallmatrix (0,1) *)

If[sort!=0,{yiiZ,PiiZ,alphaiiZ} = Sortieren[{yiiZ,PiiZ,alphaiiZ},sort]];

{yiiR,alphai1i} = Resampling[{yiiZ,PiiZ,alphaiiZ,N1},eps,seed,{quote,tanner}];

        (*PiiZ//TableForm//Print;
          PiiZ[[1]]//Eigenvalues//Print;*)

								(*yiiR = RandomKDE[yiiZ,alphaiiZ,PiiZ,Generator,seed,n];*) (* resampling *)


p0Z = Map[likratio0[#,{yii,Pii,alphaii},{yiiZ,PiiZ,alphaiiZ}]&,yiiR];	                

(*
Print[i,"  ",p0Z];
Print[i,"  ",yiiR]; 
*)   
		                  				                 	
YF   = {}; Misch = {}; likvec = {lik};
  
Do[  

	j   = ti[[i+1]];      (*Print[{i+1,j}];*)
	Zi1 = Z[[j]];
	
	Xi  = Take[ X,dti[[i]] ];
	XZ  = Table[{Drop[Xi,j-1],Zi1},{j,1,Xi//Length}];
	
	(* XZ//Print; *)
	
	
 xi  = Xi//Last;
	dwi = Map[Take[#,dti1[[i]] ]&,dW];  

	{y,lik2} = MapThread[RungeKutta1Lik[f2g2,#1,{XZ,#2},
	                     Length[XZ]-1,dt,Theta,EulerStep1Lik]&,{yiiR,dwi}]//Transpose;

 
 yJ1 = Map[Last,y];
 
 (* yJ1//Print; lik2//Print; *)
	
	
 G =  Map[g[#,xi,Theta]&,yJ1]; 
 Pi1i = MapThread[Dot,{G,Map[Transpose,G]}] dt;
 yi1i = yJ1 + Map[f[#,xi,Theta]&,yJ1] dt; 

 
 (*Print[Pi1i//First//VecDiag]; *)
 
 (* yi1i//Abs//Max//Print;*)
   		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)

	If[option==2,
				 YF = Join[YF,y//Transpose];
				 (*YF//Print;*)     
	  ];
	  
	If[option==3,
	    (*y//Dimensions//Print;
	    y//TensorMS//Dimensions//Print;*)
				 YF = Join[YF,y//TensorMS//Transpose];
				 (*YF//Print; *) 
	  ];
	   
	
	If[dti1[[i]] =!= 1,
				
				lik1=Map[LogLikelihood[#,f,g,Xi,dt,Theta]&,y];
				alphai1i = n1*Exp[lik1-lik2]*p0Z,	  
	
				alphai1i = n1*p0Z
	];
	
  If[Alphanorm==1,alphai1i =	alphanorm[alphai1i]];
	
	{yiiR,liki,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Zi1,{yi1i,Pi1i,alphai1i},X[[j]]},
				                 Theta,{h,Dh,R},{miss,n,Generator,seed,False}];
				                 
	(*Print[liki1,"   ",liki];*)

	If[i < Length[ti]-1,
					
				(*
				{yiiZ,PiiZ,alphaiiZ} = SmoothEKF[{Z[[ti[[i+2]]]],yii,Pii,alphaii,
				                                  Take[X,dti[[i+1]] ],dt},
				                                  Theta,{f,Df,g,h,Dh,R},miss];
				                                  
				Print["alphaiiZ ",alphaiiZ//Chop]; 
				*)   
				                              
				{yiiZ,PiiZ,alphaiiZ} = SmoothEKFIter[{Z[[ti[[i+2]] ]],yii,Pii,alphaii,
                                         Take[X,dti[[i+1]] ],dt,iter},Theta,
                                         {f,Df,g,h,Dh,R},miss];
                                     
				If[l2==1,alphaiiZ= Shape[n1,{n}]  ];
				If[l2==2,alphaiiZ= ALPHIIZ[[i+1]] ];
				If[l2==3,ALPHIIZ = Append[ALPHIIZ,alphaiiZ] ];
				If[l2==4,alphaiiZ= alphamax[alphaiiZ]  ];
				If[l2==6,alphaiiZ= alphafilter[alphaiiZ,n1]  ];
				
				Print["alphaiiZ ",alphaiiZ//Chop];
				(* Print["PiiZ ",PiiZ]; *)
				
				
				If[sort!=0,{yiiZ,PiiZ,alphaiiZ} = Sortieren[{yiiZ,PiiZ,alphaiiZ},sort]];

    {yiiR,alphai1i} = Resampling[{yiiZ,PiiZ,alphaiiZ,N1},eps,seed,{quote,tanner}];
	
   						(*
									SeedRandom[seed];                    
 		 					yiiR = RandomKDE[yiiZ,alphaiiZ,PiiZ,Generator,seed,n]; (* resampling *)
    					*)
    					 		 
 		 p0Z = Map[likratio0[#,{yii,Pii,alphaii},{yiiZ,PiiZ,alphaiiZ}]&,yiiR];
 		 
 		 (*
 		 Print[i,"yi1i",yi1i];
 		 Print[i,"Pi1i",Pi1i];  
 		 Print[i,"alphai1i",alphai1i//Log];
 		 Print[i,"yii",yii];
 		 Print[i,"Pii",Pii];  
 		 Print[i,"alphaii",alphaii];
 		 Print[i,"yiiZ",yiiZ];
 		 Print[i,"PiiZ",PiiZ];  
 		 Print[i,"alphaiiZ",alphaiiZ];
 		 
 		 Print[i,"yiiR",yiiR]; 
 		 Print[i,"p0Z ",p0Z];  
 		 *) 
 		 
 		 (*Return[];*)                    
				
	  ];
  		
	
	likvec = Append[likvec,liki];	
	lik +=liki;
	
	(*likneu+=liki1;*)
	
,{i,1,Length[ti]-1}];



If[option==1,Return[lik] ];

If[option==2,
	YF = Join[YF,{yiiR}];
	Return[{YF,lik,likvec}] ];
	
If[option==3,
	YF = Join[YF,{yiiR//TensorMS}];
	Return[{YF,lik,Misch}] ];	
	
];

LikKernDichte//Clear
(***************************************************************)			 
LikKernDichte[{Y_,X_},Theta_,{f_,g_,p0_,dt_},{dW_,seed_,miss_,option_:1}]:=
(***************************************************************)			 
(* KernDichte, kein Me\[SZ]-Modell, ohne IS
   
   p_i+1|i = 1/N sum K(y_J|eta_J); dy = fdt + gdW 
 
   option = 1: lik

*)

Module[{ti,T1,T,dti,dti1,n,X0,lik,mue,sigma,smooth,smooth1,Xi,dwi,Yi,y,
        yi1i,j,i,liki,jacobi},

{ti,T1,T,dti,dti1} = Zeiten[Y,miss];        (*dti//Print; dti1//Print;*)

n = Length[dW]; 
Print["LikKernDichte: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

SeedRandom[seed];

X0 = X[[1]];

If[Length[p0]==0,
	 	lik = Log[ p0[Y[[1]],X0,Theta] ],
	 			(*else*)
	 	mue   = p0[[1]][X0,Theta];
  	sigma = p0[[2]][X0,Theta];  
  	lik = LogPhi[Y[[1]],mue,sigma]; (*AB*)	 
  ];  
  
(*lik//Print;*)
YY = {};

Do[ 

	Xi  = Take[ X,dti[[i]] ]; 
	dwi = Map[Take[#,dti1[[i]] ]&,dW];
 Yi = Y[[ti[[i]] ]];
 Yi = Table[Yi,{n}];
 
 {yi1i,y} = TimeUpFokker[{Yi,Xi,dwi,dt},Theta,{f,g}];
         		
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)  
	
	(*YY = Join[YY,Drop[y//Transpose,-1]];*)

	j = ti[[i+1]];   (*Print[{i+1,j}];*)
	
	smooth  = smoothQuickAndDirtyM[yi1i,1];  
	smooth1 = smooth//Inverse;	
	jacobi  = Det[smooth]^(-.5); 
	liki    = Map[ GaussKernO[Y[[j]] - #,{smooth,smooth1}]&, yi1i];	
	(*liki//Print;*)
	liki    = Log[ jacobi*mean[liki] ];
	
     (*liki//Print;*)
		
	lik += liki;
	
,{i,1,Length[ti]-1}];

lik

	
];



LikKalmanFokkerN//Clear
(***************************************************************)			 
LikKalmanFokkerN[{Z_,X_},Theta_,{f_,g_,h_,R_,p0_,dt_},
				{{y1_,y2_,dy_},nstd_,$dw$_,seed_,miss_}]:=
(***************************************************************)			 
				
Module[{ti,dti,dti1,$n$,z,y0,yii,pii,pi1i,lik,Xi,dwi,yi1i,j},

Print["LikKalmanFokkerN: "];

ti   = messind[Z,miss]; (*Indices mit mind. einer Messung*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

$n$ = Length[$dw$]; 

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,$n$];

{yii,pii,pi1i,lik} = 
	MessUpFokker2[{Z[[1]],y0,Xi,_},Theta,{h,R},{{y1,y2,dy},nstd,$n$}];

Do[ (*Print["LikKalmanFokkerN: ",i];*)

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	yi1i = Over[yi1i,YMAX];
	j = ti[[i+1]]; 
	
	{yii,pii,pi1i,liki} = 
		MessUpFokker2[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,R},{{y1,y2,dy},nstd,$n$}];	
		
	lik +=liki;

,{i,1,Length[ti]-1}];

lik ];

LikKalmanFokkerEKFN//Clear
(***************************************************************)			 
LikKalmanFokkerEKFN[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				{{y1_,y2_,dy_},_,$dw$_,seed_,miss_}]:=
(***************************************************************)			 				
Module[{ti,dti,dti1,$n$,z,y0,yii,pii,pi1i,lik,Xi,dwi,yi1i,j},

Print["LikKalmanFokkerEKFN: "];

ti   = messind[Z,miss]; (*Indices mit mind. einer Messung*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

$n$ = Length[$dw$]; 

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,$n$];

{yii,pii,pi1i,lik,ym,pm} = 
	MessUpEKF1[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{$n$,miss,1}];

Do[ (*Print["LikKalmanFokkerN: ",i];*)

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	yi1i = Over[yi1i,YMAX];
	j = ti[[i+1]]; 
	
	{yii,pii,pi1i,liki,ym,pm} = 
		MessUpEKF1[{Z[[j]],yi1i,X[[j]],_},
				Theta,{h,Dh,R},{$n$,miss,1}];
		
	lik +=liki;

,{i,1,Length[ti]-1}];

lik ];

LikKalmanFokkerEKFSumN//Clear
(***************************************************************)			 
LikKalmanFokkerEKFSumN[{Z_,X_},Theta_,{f_,g_,h_,Dh_,R_,p0_,dt_},
				{{y1_,y2_,dy_},_,$dw$_,seed_,miss_}]:=
(***************************************************************)			 				
Module[{ti,dti,dti1,$n$,z,y0,yii,pii,pi1i,lik,Xi,dwi,yi1i,j},

Print["LikKalmanFokkerEKFSumN: "];

ti   = messind[Z,miss]; (*Indices mit mind. einer Messung*)
dti  = Delta[ti,ti,List,-1];
dti1 = Delta[ti]+1;

$n$ = Length[$dw$]; 

SeedRandom[seed];

Xi = X[[1]];
{z,y0} = RandomNumbers[{y1,y2,dy},p0[#,Xi,Theta]&,$n$];

{yii,lik} = 
	MessUpEKFSum[{Z[[1]],y0,Xi,_},Theta,{h,Dh,R},{miss}];

Do[ (*Print["LikKalmanFokkerN: ",i];*)

	Xi  = Take[ X,dti[[i]] ];
	dwi = Map[Take[#,dti1[[i]] ]&,$dw$];

	{yi1i,y} = TimeUpFokker[{yii,Xi,dwi,dt},Theta,{f,g}];
	yi1i = Over[yi1i,YMAX];
	j = ti[[i+1]]; 
	
	{yii,liki} = 
		MessUpEKFSum[{Z[[j]],yi1i,X[[j]],_},Theta,{h,Dh,R},{miss}];
		
	lik +=liki;

,{i,1,Length[ti]-1}];

lik ];





Lik//Unprotect
Lik//Clear
(***************************************************************)			 
Lik[data_,Theta_,{system_,LikN_},misc_]:=
(***************************************************************)			 
Apply[Plus,
Map[LikN[#,Theta*SCALING,system,misc]&,data]
]

Lik//Protect;



Unprotect[Lik1]
Lik1//Clear
(***************************************************************)			 
Lik1[data_,Theta_,{system_,LikN_},misc_]:=
(***************************************************************)			 
Sum[LikN[data[[i]],Theta*SCALING,system,misc],{i,data//Length}]

Lik1//Protect;



Score//Clear
(***************************************************************)			 
Score[data_,Theta_,{system_,{Lik_,LikN_}},misc_]:=
(***************************************************************)			 
Module[{INC,i,LIK,LIKI,INC1,SNUM},

LIK = Lik[data,Theta,{system,LikN},misc]; (*setzt FDIGITS*)

ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/2) max[Abs[Theta],Abs[TYP]];
Print["Score: INC: ",INC]; 
INC1= 1./INC; 

SNUM = {};
u=Length[Theta];

Do[ (*Print["Score: ",i];*)
   	
   	Thetai=GRIDI[Theta,i, INC];
    LIKI = Lik[data,Thetai,{system,LikN},misc];
    
    (*Thetai//PaddedForm[#,{20,15}]&//Print;*)
    (*LIKI//PaddedForm[#,{20,20}]&//Print;*)
    (*Print[LIKI//PaddedForm[#,{20,20}]&,"   ",
          LIK//PaddedForm[#,{20,20}]&,"    ",
          LIKI-LIK//PaddedForm[#,{20,20}]&,"   ", INC1[[i]] ];
     *)
    
    SNUM = Append[SNUM,(LIKI-LIK)*INC1[[i]]//N ]
    
  ,{i,u} ];
  
{SNUM,LIK}
]

cScore//Clear
(***************************************************************)			 
cScore[data_,Theta_,{system_,{Lik_,LikN_}},misc_]:=
(***************************************************************)	
(*berechnet u Likelihoods simultan in C*)		 
Module[{INC,i,LIK,LIKI,INC1,SNUM,u,Thetai},

(*LIK = Lik[data,Theta,{system,LikN},misc];*) (*setzt FDIGITS*)

ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/2) max[Abs[Theta],Abs[TYP]];
Print["Score: INC: ",INC]; 
INC1= 1./INC; 

SNUM = {};
u=Length[Theta];

Thetai= Table[ SCALING*GRIDI[Theta,i, INC],{i,u} ]; (* uxu!!*) 
Thetai= Join [{SCALING*Theta},Thetai];

LIKI = Sum[LikN[data[[i]],Thetai,system,misc],{i,data//Length}]; (* u+1-Vektor!!*)

LIK =LIKI//First;
LIKI=LIKI//Rest;

Do[(*Print["Score: ",i];*)
   (*
    Print[LIKI[[i]]//PaddedForm[#,{20,20}]&,"   ",
          LIK//PaddedForm[#,{20,20}]&,"    ",
          LIKI[[i]]-LIK//PaddedForm[#,{20,20}]&,"   ", INC1[[i]] ];
    *)
    
    SNUM = Append[SNUM,(LIKI[[i]]-LIK)*INC1[[i]]//N ]
    
  ,{i,u} ];  
  
{SNUM,LIK}
]


Score2//Clear
(***************************************************************)			 
Score2[data_,Theta_,{system_,{Lik_,LikN_}},misc_]:=
(***************************************************************)			 
Module[{INC,i,LIK,LIKup,LIKdo,INC1,SNUM},

LIK = Lik[data,Theta,{system,LikN},misc]; (*setzt FDIGITS*)

ETA = Max[$MachineEpsilon,10.^-FDIGITS]; 
INC = ETA^(1/3) max[Abs[Theta],Abs[TYP]];
Print["Score2: INC: ",INC]; 
INC1= 1/(2 INC);
 

SNUM = {};
Do[ (*Print["Score2: ",i];*)
   
    LIKup = Lik[data,GRIDI[Theta,i, INC],{system,LikN},misc];
    LIKdo = Lik[data,GRIDI[Theta,i,-INC],{system,LikN},misc];
    SNUM = Append[SNUM,(LIKup-LIKdo)*INC1[[i]] ]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]
	

	
(***************************************************************)			 
Hesse2[data_,Theta_,{system_,{Lik_,LikN_,Score_}},misc_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE (MIT MISSING DATA) 2-seitig*)

Module[{INC,i,LIK,INC1,
		Sup,Sdo,DS,S,HNUM,SNUM},

{S,LIK} = Score[data,Theta,{system,{Lik,LikN}},misc];

ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/3);
INC = INC max[Abs[Theta],Abs[TYP]];
INC1=1/(2 INC);
HNUM = {};
SNUM = {};
Do[ 
    {Sup,likup} = Score[data,GRIDI[Theta,i, INC],{system,{Lik,LikN}},misc];
	{Sdo,likdo} = Score[data,GRIDI[Theta,i,-INC],{system,{Lik,LikN}},misc];
	
    HNUM = Append[HNUM,(Sup  -  Sdo)*INC1[[i]]];
    SNUM = Append[SNUM,(likup-likdo)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];

HNUM = .5(HNUM + Transpose[HNUM]);  
DS = S-SNUM;
Print[ "KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"];
Print[MatrixForm[{SNUM, S, DS, Theta, INC }//Transpose,
	TableHeadings->{Automatic,{"SNUM","S","DS","THETA","INC"}}]];  
{HNUM,LIK}
]

(***************************************************************)
Hesse[data_,Theta_,{system_,{Lik_,LikN_,Score_}},misc_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:              *)
(* ZENTRALE DIFFERENZEN                                        *)
(* s_i=1/(2h_i) (l^i-l^{-i}) ; l^i=l(theta+h_i e_i)            *)
(* H_{ij} = 1/(4H_i H_j) (l^{ij}-l^{i,-j} -l^{-i,j}+l^{-i,-j}) *)


Module[{LIK,L2,INK,INK2,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J},
		
LIK  = Lik[data,Theta,{system,LikN},misc]; (*setzt FDIGITS*)
		
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/3);
INK = INC max[Abs[Theta],Abs[TYP]];
Print["INK: ",INK];
U    = Length[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];
L2   = 2 LIK;

H = Shape[0,{U,U}];

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
	Map[Lik[data,#,{system,LikN},misc]&,
			{GRIDIJ[Theta ,I,J,  INK,  INK],
			 GRIDIJ[Theta ,I,J,  INK, -INK],
			 GRIDIJ[Theta ,I,J, -INK,  INK],
			 GRIDIJ[Theta ,I,J, -INK, -INK]
			 }];
	
    H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;
    
,{I,1,U},{J,I+1,U}];

H = H + Transpose[H]; 

Do[ 

{L2I,LM2I} = 
	Map[Lik[data,#,{system,LikN},misc]&,
			{GRIDI[Theta ,I, INK2],
			 GRIDI[Theta ,I,-INK2]
			 }];
    H[[I,I]] = L2I - L2 + LM2I;
    
,{I,1,U}];

H = H H4;
{H,LIK}
]


(***************************************************************)
cHesse[data_,Theta_,{system_,{Lik_,LikN_,Score_}},misc_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:              *)
(* ZENTRALE DIFFERENZEN                                        *)
(* s_i=1/(2h_i) (l^i-l^{-i}) ; l^i=l(theta+h_i e_i)            *)
(* H_{ij} = 1/(4H_i H_j) (l^{ij}-l^{i,-j} -l^{-i,j}+l^{-i,-j}) *)


Module[{LIK,L2,INK,INK2,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J,LIKI,lin,ThetaM,LIKI},
		
		
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/3);
INK = INC max[Abs[Theta],Abs[TYP]];
Print["INK: ",INK];
U    = Length[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];
L2   = 2 LIK;

H = Shape[0,{U,U}];

ThetaM={};

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
			{SCALING*GRIDIJ[Theta ,I,J,  INK,  INK],
			 SCALING*GRIDIJ[Theta ,I,J,  INK, -INK],
			 SCALING*GRIDIJ[Theta ,I,J, -INK,  INK],
			 SCALING*GRIDIJ[Theta ,I,J, -INK, -INK]};

ThetaM=Join[ThetaM,{LIJ,LIMJ,LIJM,LIMJM}];	
   
,{I,1,U},{J,I,U}];

ThetaM//Dimensions//Print;

LIKI = Sum[LikN[data[[i]],ThetaM,system,misc],{i,data//Length}]; (* u-Vektor!!*)

LIK=LIKI[[2]];

lin=0;

Do[ 

LIJ  =LIKI[[lin+=1]];
LIMJ =LIKI[[lin+=1]];
LIJM =LIKI[[lin+=1]];
LIMJM=LIKI[[lin+=1]];


H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;

H[[J,I]] = H[[I,J]];

,{I,1,U},{J,I,U}];  


H = H H4;
{H,LIK}
]


lin//Unprotect;
lin//Clear;

lin[{i_,j_},{I_,J_}]:=(i-1)J+j;

lin//Protect;

partition//Unprotect;
partition//Clear

partition[x_,JJ_]:=
Module[{LL=x//Length},
Table[Take[x,{lin[{i,1},{_,JJ}],Min[lin[{i,JJ},{_,JJ}],LL]}],{i,1,LL/JJ//Ceiling}]
]

partition//Protect;

(***************************************************************)
cHesse1[data_,Theta_,{system_,{Lik_,LikN_,_}},misc_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:              *)
(* ZENTRALE DIFFERENZEN                                        *)
(* s_i=1/(2h_i) (l^i-l^{-i}) ; l^i=l(theta+h_i e_i)            *)
(* H_{ij} = 1/(4H_i H_j) (l^{ij}-l^{i,-j} -l^{-i,j}+l^{-i,-j}) *)
(* mit CHUNKS = 127                                            *)

Module[{LIK,L2,ETA,INC,INK,INK2,U,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J,lin,ThetaM,LIKI},
		
(*LIK  = Lik[data,Theta,{system,LikN},misc];*) (*setzt FDIGITS*)
		
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/3);
INK = INC max[Abs[Theta],Abs[TYP]];
Print["INK: ",INK];
U    = Length[Theta]; (*U=UU;*)
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];

H = Shape[0,{U,U}];

ThetaM={};

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
			{SCALING*GRIDIJ[Theta ,I,J,  INK,  INK],
			 SCALING*GRIDIJ[Theta ,I,J,  INK, -INK],
			 SCALING*GRIDIJ[Theta ,I,J, -INK,  INK],
			 SCALING*GRIDIJ[Theta ,I,J, -INK, -INK]};

ThetaM=Join[ThetaM,{LIJ,LIMJ,LIJM,LIMJM}];	
   
,{I,1,U},{J,I+1,U}];

(*Diagonale*)

Do[ 

{LIJ,LIMJM} = 
			{SCALING*GRIDI[Theta ,I,  INK2],
			 SCALING*GRIDI[Theta ,I, -INK2]};

ThetaM=Join[ThetaM,{LIJ,LIMJM}];	
   
,{I,1,U}];

ThetaM//Dimensions//Print;

ThetaM=Join[{SCALING*Theta},ThetaM];

ThetaM=partition[ThetaM,CHUNKS = 127]; (*chunks maximal 127 x u*)

LIKI = 
Map[

Sum[LikN[data[[i]],#,system,misc],{i,data//Length}]&,

ThetaM]//Flatten;


LIK =LIKI//First;
LIKI=LIKI//Rest;

L2   = 2 LIK;

lin=0;
Do[ 

LIJ  =LIKI[[lin+=1]];
LIMJ =LIKI[[lin+=1]];
LIJM =LIKI[[lin+=1]];
LIMJM=LIKI[[lin+=1]];


H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;

,{I,1,U},{J,I+1,U}];  

H = H + Transpose[H]; 


(*Diagonale*)

Do[ 


LIJ  =LIKI[[lin+=1]];
LIMJM=LIKI[[lin+=1]];


H[[I,I]] = LIJ - L2 + LIMJM;

,{I,1,U}];  

H = H H4[[Range[1,U],Range[1,U]]];

{H,LIK}
]


FisherInformationN//Clear
(***************************************************************)			 
FisherInformationN[data_,Theta_,{system_,LikN_},misc_]:=
(***************************************************************)
(*F = Sum[E[s_t s_t']]*)
(*nur f\[UDoubleDot]r Likelihood mit option=5*)
			 
Module[{INC,i,LIK,Thetai,LIKI,INC1,SNUM,SNUMt,F,likvec,likveci},

{LIK,likvec} = LikN[data,Theta*SCALING,system,misc]; (*likvec*) 

ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/2) max[Abs[Theta],Abs[TYP]];
(*Print["Score: INC: ",INC];*)
INC1= 1./INC; 

SNUM = SNUMt = {};
u=Length[Theta]; 

Do[ (*Print["Score: ",i];*)
   	
   	Thetai=GRIDI[Theta,i, INC];
    {LIKI,likveci} = LikN[data,Thetai*SCALING,system,misc];
    
     (*{LIKI,likveci}//Print;*)
     (*
      Print[LIKI//PaddedForm[#,{20,20}]&,"   ",
            LIK//PaddedForm[#,{20,20}]&,"    ",
            LIKI-LIK//PaddedForm[#,{20,20}]&,"   ", INC1[[i]] ];
      *)

  
    SNUM = Append[SNUM,(LIKI-LIK)*INC1[[i]]//N];
   
    SNUMt = Append[SNUMt,(likveci-likvec)*INC1[[i]]//N];
    
  ,{i,u} ];

F=Apply[Plus,Map[Outer[Times,#,#]&,SNUMt//Transpose]]; 

{F,LIK,likvec,SNUM,SNUMt}
]

FisherInformation//Unprotect;
FisherInformation//Clear
(***************************************************************)			 
FisherInformation[data_,Theta_,{system_,LikN_,FisherInformationN_},misc_]:=
(***************************************************************)
(*F = Sum[E[s_t s_t']]*)
(*nur f\[UDoubleDot]r Likelihood mit option=5*)		 
Module[{F},

F=Apply[Plus,
        Map[(FisherInformationN[#,Theta,{system,LikN},misc]//First)&,
        data]];

F];

FisherInformation//Protect;


FisherInformation1//Unprotect;
FisherInformation1//Clear
(***************************************************************)			 
FisherInformation1[data_,Theta_,{system_,LikN_,FisherInformationN_},misc_]:=
(***************************************************************)
(*F = Sum[E[s_t s_t']]*)
(*nur f\[UDoubleDot]r Likelihood mit option=5*)		 
Module[{F},

F=Sum[FisherInformationN[data[[i]],
                          Theta,
                          {system,LikN},misc]//First
                         ,{i,data//Length}];

F];

BFGSUP//Clear
(***************************************************************)			 
BFGSUP[F_,SNEU_,S_,STEP_] := 
	Module[{MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)			 
(*NOISE LEVEL*)
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
TOL = If[ANALGRAD,ETA,ETA^0.5,ETA^0.5];
NOISE = (Max[Abs[SNEU]]+Max[Abs[S]])*TOL;
Print["NOISE  ",NOISE];
MACHEPS2 = $MachineEpsilon^0.5;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < NOISE, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print["*BFGSUP ", A,"  ", B];  
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]

(***************************************************************)			 
LikTest[LIKNEU_]:=
(***************************************************************)
	If[(LIKNEU//NumberQ//Not)||(Im[LIKNEU]=!=0)||(LIKNEU>10.^10),
	 	Print["LIKNEU = ",LIKNEU," reset to -10.^10"]; -10.^10,
	 		LIKNEU]				

(***************************************************************)			 
BFGS//Clear
BFGS[data_,
	 {THETA0_,F0_},
	 {system_,{Lik_,LikN_,Score_,Hesse_}},
	 {misc_,KMAX_,{EPS1_,EPS2_},OPTION_,PRINT_}]:= 
(***************************************************************)			 
Module[{MINSTEP,BOUND,ALPHA,u,THETA,THETA1,F,
        S,LIKALT,LIKI,psii,scoreii,STEPL,STEP,
        LIKNEU,SNEU,likpsi,COV,LIKELI,n,T,T1,Tc,P,Q,k,K,KK,Z,Y,X,
        ReturnCode},


MINSTEP=10.^-10;
FMAX = 10^3; (*Maximaler EW*)
BOUND=10.^-6;
ALPHA=10.^-4;


n = data//Length;

Q = Dimensions[data[[1,2]]][[2]];

If[Depth[data]===5, {T1,K}=Map[Dimensions[Part[#,1]]&,data]//Transpose,

(* else *) 

If[Depth[data]===6, {T1,K}=Map[Dimensions[Part[#,1,1]]&,data]//Transpose

]];

Depth[data]//Print["Tiefe von data = ",#]&;  

Print["L\[ADoubleDot]nge der Paneldaten"];
T1//Print;
T = T1-1; 

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL:    BFGS (skeleton)**************"];
Print["**************************************************************"];
Print["Technical Output"];
Print[LikN];
Print["**************************************************************"];
VecPrint[{ KMAX,  EPS1,  EPS2,  K//First,  Q,  n,  T//First,  OPTION}//Spalte,
         {"KMAX","EPS1","EPS2","K","Q","n","T","OPTION"}];
Print[ ""];
VecPrint[{ MAXSTEP,  MINSTEP,  BOUND,  STEPREDUCE,  FMAX}//Spalte,
         {"MAXSTEP","MINSTEP","BOUND","STEPREDUCE","FMAX"}];
Print[ ""];

VecPrint[{RESAMPLING,  FDIGITS,  TYP,  YMAX,  ANALGRAD,   FACTOR,  CSEED }//Spalte,
        {"RESAMPLING","FDIGITS","TYP","YMAX","ANALGRAD", "FACTOR","CSEED"}];
Print[ ""];

Print["    SCALING"];
Print[MatrixForm[SCALING//Spalte//Transpose,
      TableHeadings->{Automatic,{"SCALING"}},
      TableDepth->0] 
      ];




Print[ ""];
Print["**************************************************************"];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0]
];

u = Length[THETA0]; 

THETA=THETA0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ]; 


{S,LIKALT} = Score[data,THETA0,{system,{Lik,LikN}},misc]; 


Print[{S,LIKALT}];  

LIKI = {}; psii = {}; scoreii = {};
ReturnCode = 0;
k=0;



DoUntil[{KK,KMAX},
    (ReturnCode == 3),
     
    (*
	(ReturnCode == 1 || ReturnCode == 2 || 
	 ReturnCode == 3 || ReturnCode == 4), 
	 *)
 	
	If[PRINT[[2]] == 1,
	Print["-----------------------------------------------------------------"];
    Print["BFGS: Iteration = ",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    scoreii = Append[scoreii,S];
    
 	STEP=LinearSolve[F,S];  
 	

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]]+$MachineEpsilon; (*falls STEP=0*)
    STEP=STEP*Min[1,MAXSTEP/STEPL];
    

    (*STEP-Reduction*)
   
    THETA1 = THETA + STEP;   (*VOLLER NEWTON-STEP*)
    
    (*Print["VOLLER NEWTON-STEP  ",THETA1,"   ",THETA];*)
    
  	LIKNEU = Lik[data,THETA1,{system,LikN},misc];	
  	
  	(*LIKNEU//Print;*)
  			
   	LIKNEU = LikTest[LIKNEU];
  	
   		 
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
          				 
         STEP=STEP/STEPREDUCE;
         
         THETA1 = THETA + STEP; 
         
         LIKNEU = Lik[data,THETA1,{system,LikN},misc];	
			  		
		 LIKNEU = LikTest[LIKNEU];
	  		
		 If[PRINT[[3]] == 1,
         Print["STEP-REDUCTION:  ",half,
         			"  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			"  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
     ]; (*End DoWhile*)
     
     
	If[LIKNEU - LIKALT < 0,
		Print["ReturnCode = 4"];ReturnCode = 4;Break[]];
		
	(* If[LIKNEU - LIKALT < 0,
		  Print["LIKNEU - LIKALT < 0"];FDIGITS+=1]; *)
		

	(* If[Max[Abs[STEP]] < 10^6 MINSTEP,
		  Print["schlechte Suchrichtung"]; FDIGITS+=1]; *)
			
	If[PRINT[[4]] == 1,
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
          "  LIKALT  ", PaddedForm[LIKALT,{20,15}],
          "  LIKNEU - LIKALT  ",PaddedForm[LIKNEU-LIKALT,{20,15}]];
    Print[""];
    ];
    
  
    If[PRINT[[5]] == 1, 
    Print[PaddedForm[
          MatrixForm[{THETA1,THETA,STEP,S}//Transpose//Chop[#,10^-5]&,
    	  TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}],
    	  {5,4}]
    	  ]];
    
    If[PRINT[[6]] == 1,
    Print[""];
    MatPrint[F];
    ];
       
    {SNEU,LIKALT} = 
    	Score[data,THETA1,{system,{Lik,LikN}},misc]; 
		
    
    (* BFGS-UPDATE *)
    
    F = BFGSUP[F,SNEU,S,STEP];
    
    (*F = F0;(*steepest descent*)*)
    (*Feigen = F//Eigenvalues;*)
    (*Print["Fup: Eigenwerte:  ",Feigen];*)
    (*If[Max[Abs[Feigen]]>FMAX,F = F0];*) 
    
    
    S = SNEU;
    
    THETA = THETA1GLOBAL=THETA1;
    k = KK;
    
    relgrad = Max[Abs[S max[Abs[THETA],TYP]]]/Abs[LIKNEU];
    Print["relgrad = ",relgrad," = Elastizitaet(d l/l)/(d theta/theta)"];
    
    
    If[Max[Abs[S   ]]<EPS1,Print["ReturnCode = 1"];ReturnCode = 1];
    If[Max[Abs[STEP]]<EPS2,Print["ReturnCode = 2"];ReturnCode = 2];
    If[Max[Abs[S   ]]<EPS1 && 
       Max[Abs[STEP]]<EPS2,Print["ReturnCode = 3"];ReturnCode = 3];
   
	

];

If[PRINT[[7]] == 1,
Print[ "BFGS:  ENDE DER ITERATION  ",k,"  ",KMAX] ];

If[PRINT[[5]] == 1, 
    Print[MatrixForm[{SNEU}//Transpose,
    	  TableHeadings->{Automatic,{"SCORE"}}]
    	  ]];
    
If[PRINT[[6]] == 1,
    Print[""];
    MatPrint[F];
    ];
    
LIKI = Append[LIKI,LIKALT]; 
psii = Append[psii,THETA];
scoreii = Append[scoreii,S];

likpsi = Spalte[LIKI]~ii~psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
		TableHeadings->{Automatic,{"Likelihood","THETA"}} ]];
];
					

If[FISHER&&(k<KMAX),

	{F,LIKELI} = Hesse[data,THETA,{system,{Lik,LikN,Score}},misc];
		
	F=-F;
	
	COV = OUTPUT[THETA,F,.05,S,LIKELI];
	LKOMP[LIKELI,u,Apply[Plus,T1]];
	
,(* else *)

	COV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,COV,LIKI,psii,scoreii,k,ReturnCode}

]

 

	
(***************************************************************)			 
GRIDSEARCH//Clear
GRIDSEARCH[data_,
	 {THETA0_,F0_},
	  {system_,{Lik_,LikN_,Score_}},
	  {misc_,KMAX_,EPS2_,{STEPREDUCE_,nhalf_},PRINT_}]:= 
(***************************************************************)
(*F0 = Matrix der Suchrichtungen*)	
		 
Module[{MINSTEP,BOUND,ALPHA,u,THETA,THETA1,THETA1j,THETAj,F,
        S,LIKALT,LIKI,psii,scoreii,STEPL,STEP,
        LIKNEU,SNEU,likpsi,COV,LIKELI,n,T,T1,P,Q,k,KK,Y,Z,X,
        ReturnCode},

MAXSTEP=1;
MINSTEP=10.^-10;

(*STEPREDUCE = 2;
nhalf = 9;*)

BOUND=10.^-6;


{Z,X} = data;

{n,T1,Q} = Dimensions[X];

If[Depth[Z]===4,{n,T1,K} = Dimensions[Z],

(* else *) If[Depth[Z]===5,{Tc,K}=Dimensions[Z[[1,1]] ]

]];

Depth[Z]//Print;

T = T1-1;

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: GRIDSEARCH (skeleton)***********"];
Print["**************************************************************"];
Print["Technical Output"];
Print[LikN];
VecPrint[{KMAX,EPS2,K,Q,n,T,OPTION,MAXSTEP}//Spalte,
         {"KMAX","EPS2","K","Q","n","T","OPTION","MAXSTEP"}];
VecPrint[{ MINSTEP,  BOUND,  STEPREDUCE,  nhalf}//Spalte,
         {"MINSTEP","BOUND","STEPREDUCE","nhalf"}];

Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0]
];

u = Length[THETA0];

THETA=THETA0;
LIKALT = Lik[data,THETA,{system,LikN},misc];

LIKI = {}; psii = {}; 
ReturnCode = 0;

DoUntil[{KK,KMAX}, 
	(ReturnCode == 1 || ReturnCode == 2 || 
	 ReturnCode == 3 || ReturnCode == 4),
 	
	If[PRINT[[2]] == 1,
	Print["-----------------------------------------------------------------"];
    Print["GRIDSEARCH: Iteration = ",KK];
    ];
     
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    
   	LIKALTj = LIKALT;
    THETAj = THETA;
    
    Do[ (*Zyklisch, 1...u*)
    
    	Print["j = ",j,"   LIKALTj = ", LIKALTj]//If[PRINT[[3]] == 1,#]&;
   
 		STEP=F0[[j]]; 
 		Print["Suchrichtung  ",STEP]//If[PRINT[[3]] == 1,#]&;
 			
    	{LIKNEUj,THETA1j} = LINESEARCH[STEP,THETAj,LIKALTj,nhalf,STEPREDUCE,
                                   	   {data,{system,LikN},misc}];
      
	   	If[LIKNEUj - LIKALTj <= 0, 
		
		STEP= -STEP; (*andere Richtung*)
	   	Print["Suchrichtung  ",STEP]//If[PRINT[[3]] == 1,#]&;
	   
	   	{LIKNEUj,THETA1j} = LINESEARCH[STEP,THETAj,LIKALTj,nhalf,STEPREDUCE,
	                                   {data,{system,LikN},misc}]
	   	];
	  	
	  	If[LIKNEUj - LIKALTj > 0, 
	   				THETAj  = THETA1j;
    				LIKALTj = LIKNEUj];
	
	   ,{j,1,u}]; 

	   	THETA1  = THETAj;
   		LIKNEU  = LIKALTj;
    
    (* Acceleration Step *)
    
 		If[Mod[KK,2] == 0,
 		   	
    		STEP=THETA1-THETA;
    		Print["Acceleration Step  ",STEP]//If[PRINT[[3]] == 1,#]&;
    		norm = pNorm[STEP];
    		If[norm > 0, 
 			Print["Acceleration Step, Suchrichtung  ",STEP = STEP]//If[PRINT[[3]] == 1,#]&;
    		{LIKNEUacc,THETA1acc} = 
    			LINESEARCH[STEP,THETA1,LIKNEU,nhalf,STEPREDUCE,
	                       {data,{system,LikN},misc}];
       ];
       
       If[LIKNEUacc-LIKNEU > 0, THETA1 = THETA1acc; LIKNEU = LIKNEUacc];
     ];                           
                                                           
                                	
	If[PRINT[[4]] == 1,
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];
    Print["LIKNEU - LIKALT  ",PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    Print[""];
    ];
    
  
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA}//Transpose,
    	  TableHeadings->{Automatic,{"THETA1","THETA"}}]
    	  ]];
    
    k = KK;
    THETA  = THETA1;
    LIKALT = LIKNEU;
    
    If[Max[Abs[STEP]]<EPS2,Print["ReturnCode = 2"];ReturnCode = 2];
   
	

];

If[PRINT[[7]] == 1,
Print[ "GRIDSEARCH:  ENDE DER ITERATION  ",k,"  ",KMAX] ];

LIKI=Append[LIKI,LIKALT];
psii=Append[psii,THETA];

likpsi = Spalte[LIKI]~ii~psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
		TableHeadings->{Automatic,{"Likelihood","THETA"}} ]];
];
					

If[Fisher,
	
	{S,LIKELI} = 
    	Score[data,THETA,{system,{Lik,LikN}},misc];
    	 
	{F,LIKELI} = 
		Hesse[data,THETA,{system,{Lik,LikN,Score}},misc];
		
	F=-F;
	
	COV = OUTPUT[THETA,F,.05,S,LIKELI];
	LKOMP[LIKELI,u,(T+1)];
	
,(* else *)
	COV = F0; (* BFGS-UPDATE!!*)
];

{THETA,COV,LIKI,psii,k,ReturnCode}

]


(***************************************************************)
LINESEARCH//Clear
LINESEARCH[step_,THETA_,LIKALT_,nhalf_,STEPREDUCE_,
           {data_,{system_,LikN_},misc_}]:= 
(***************************************************************)           
Module[{THETA1,LIKNEU,half,STEP},

	STEP = step;

    THETA1 = THETA + STEP;   (*VOLLER STEP*)
    
  	LIKNEU = Lik[data,THETA1,{system,LikN},misc];	 	
   	LIKNEU = LikTest[LIKNEU];
   	
   (*STEP-Reduction*)
   
    DoWhile[{half,nhalf}, (LIKNEU<=LIKALT && Max[Abs[STEP]]>MINSTEP),
    
         STEP=STEP/STEPREDUCE;
         
         (*
         lambda = (1-half/(nhalf+1))//N;
         STEP = step*lambda; 
         Print["lambda  ",lambda];
         *)
         
         THETA1 = THETA + STEP; 
        
         LIKNEU = Lik[data,THETA1,{system,LikN},misc];	
			  		
		 LIKNEU = LikTest[LIKNEU];
	  		
		 If[PRINT[[3]] == 1,
         		Print["STEP-REDUCTION:  ",half,
         			  "  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			  "  LIKALT  ", PaddedForm[LIKALT,{20,15}],
         			  "  LIKNEU - LIKALT  ", PaddedForm[LIKNEU-LIKALT,{20,15}]];
         ];
     ]; (*End DoWhile*)
     
    {LIKNEU,THETA1}
    ]; 