(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     37869,       1387]*)
(*NotebookOutlinePosition[     38958,       1421]*)
(*  CellTagsIndexPosition[     38914,       1417]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["<<code`LSD`", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Lokal linearisierte Filter", "Section",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
NLTimeUp//Clear
NLTimeUp[Yii_,Pii_,Xii_,drift_,diff_,Theta_,dt_,Nonlin_] :=
\tModule[{A,B,G,Omega,V,Astern,Bstern,Yi1i,Pi1i},
\t\tA = Jacobi[Yii,Xii,Theta]; 
        B = (drift[Yii,Xii,Theta] - A.Yii) //Spalte;
        G = diff[Yii,Xii,Theta];
        Omega = G.Transpose[G];
\t    {V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];

\t\t(*Print[{Omega,A,B}//TableForm]
\t\tPrint[{V,Astern,Bstern}//TableForm];*)
\t\t\t
\t\t(*Yi1i = Astern.Yii + Flatten[Bstern];*)
\t\t
\t\tYi1i = Yii + drift[Yii,Xii,Theta] dt;
\t\tPi1i = Astern.Pii.Transpose[Astern] + V;
\t\t\t
\t\t{Yi1i,Pi1i}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
NonLinFilter//Clear
NonLinFilter[mue_,sigma_,Z_,X_,drift_,diff_,Theta_,H_,D_,R_,dt_,Nonlin_]:= 
\tModule[{k,p,q,Yii,Pii,YF,PF,i,i1,ON,Yi1i,Pi1i,lik,liki,T1,T},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t{T1,k} = Dimensions[Z];
\t\tT = T1-1;
\t\t{k,p,q,T}//Print;
\t\t
\t\t{Y0,P0,lik} = MNonLinMessup[mue,sigma,Z[[1]],X[[1]],
\t\t\t\t\t  {H,Jacobih,R},Theta,Nonlin,-9];
\t\t
\t\tYii = Y0;
\t\tYF = Shape[1,{T1}];
\t\tYF[[1]]  = Y0;
\t\tPii = P0;
\t\tPF = Shape[1,{T1}];
\t\tPF[[1]] = P0;
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t
\t\t\txi = X[[i]];
\t\t\tA = Jacobi[Yii,xi,Theta]; 
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G =   diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
\t\t\t{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
\t\t\t(*Print[{Omega,A,B}//TableForm]
\t\t\tPrint[{V,Astern,Bstern}//TableForm];*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Flatten[Bstern];
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t    
\t\t    If[Max[Abs[Yi1i]] > YMAX,
\t\t    \tPrint[\"possible divergence, i = \",i];
\t\t    \tYi1i = Y0;
\t\t    \tPi1i = P0];
\t\t    (*
\t\t\t{Yi1i,Pi1i} = NLTimeUp[Yii,Pii,X[[i]],dr,diff,Theta,Nonlin];
\t\t\t*)
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t\t\tvi = H . Pi1i . Transpose[H] + R;
\t\t\tvi1 = Inverse[vi];
\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\ti1 = i+1;
\t\t\tinn = Z[[i1]] - H . Yi1i - D . X[[i1]];
\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\tlik += liki;
\t\t\tYii = Yi1i + gain.inn;
\t\t\tikh = IdentityMatrix[p] - gain.H;
\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.R.Transpose[gain];
\t\t\t\t\t\t\t\t\t \t
\t        YF[[i1]] = Yii;
\t        PF[[i1]] = Pii;
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{YF,PF,lik}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MNonLinMessup//Clear
MNonLinMessup[Yi1i_,Pi1i_,Zi1_,Xi1_,{h_,R_,Jacobih_},Theta_,Nonlin_,miss_] :=
\tModule[{zmiss,lc,H,r,vi,vi1,gain,liki,p,k},
\t\t
\t\t\tzmiss = Zi1 ~eq~ miss;
\t\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t
\t\t\t(* keine Messung *)
\t\t\t\t(*Print[\"  keine Messung\"];*)
\t        \t{Yi1i,Pi1i,0},
\t        \t
\t        (* Messung *)
\t        
\t        \tlc = Locate[zmiss,False];
\t\t\t\tH = Jacobih[Yi1i,Xi1,Theta];
\t\t\t\tH = H[[lc]];
\t\t\t\tr = R[Yi1i,Xi1,Theta][[lc,lc]];\t\t
\t\t\t\tvi = H . Pi1i . Transpose[H] + r;
\t\t\t\tvi1 = Inverse[vi];
\t\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\t\t(*Print[\"gain \",gain//MatrixForm];*)
\t\t\t\tinn = Zi1[[lc]] - h[Yi1i,Xi1,Theta][[lc]];
\t\t\t\t
\t\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\t\t
\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\t{k,p} = H//Dimensions;
\t\t\t\tikh = IdentityMatrix[p] - gain.H;
\t\t\t\t(*ikh = IdPlusA[-gain.H];*)
\t\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
\t\t\t\t{Yii,Pii,liki} 
\t\t\t]
\t\t]
\t\t\t\t\t\t\t
MNonLinMessup[Yi1i_,Pi1i_,Zi1_,Xi1_,H_,D_,R_,Nonlin_,miss_] :=
\tModule[{zmiss,lc,h,d,r,vi,vi1,gain,liki,p,k},
\t
\t(* lineares Messmodell !! *)
\t\t
\t\t\tzmiss = Zi1 ~eq~ miss;
\t\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t
\t\t\t(* keine Messung *)
\t\t\t\t(*Print[\"  keine Messung\"];*)
\t        \t{Yi1i,Pi1i,0},
\t        \t
\t        (* Messung *)
\t        
\t        \tlc = Locate[zmiss,False];
\t        \t
\t\t\t\th = H[[lc]];
\t\t\t\td = D[[lc]];
\t\t\t\tr = R[[lc,lc]];
\t\t\t\t\t\t
\t\t\t\tvi = h . Pi1i . Transpose[h] + r;
\t\t\t\tvi1 = Inverse[vi];
\t\t\t\tgain = Pi1i . Transpose[h] . vi1;
\t\t\t\t(*Print[\"gain \",gain//MatrixForm];*)
\t\t\t\tinn = Zi1[[lc]] - h.Yi1i - d.Xi1;
\t\t\t\t
\t\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\t\t
\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\t{k,p} = H//Dimensions;
\t\t\t\tikh = IdentityMatrix[p] - gain.h;
\t\t\t\t(*ikh = IdPlusA[-gain.h];*)
\t\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
\t\t\t\t{Yii,Pii,liki} 
\t\t\t]
\t\t]\t\t\t\t\t\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MNonLinFilter//Clear
MNonLinFilter[mue_,sigma_,Z_,X_,{drift_,diff_,Jacobif_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:= 
\tModule[{k,p,q,Yii,Pii,YF,PF,i,i1,Yi1i,Pi1i,lik,liki,xi,
\t\t\tA,B,G,Omega,
\t\t\tr,H,Y0,P0,T,T1,IP,mue0,sigma0},
\t
\t\tmue0 = mue[X[[1]],Theta];
\t\tsigma0 = sigma[X[[1]],Theta];
\t\t
\t\t{p} = Dimensions[mue0];
\t\t{T1,k} = Dimensions[Z];
\t\tT = T1-1;
\t\tPrint[\"{k,p,T} = \",{k,p,T}];
\t\t
\t\t{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
\t\t\t\t\t  {h,R,Jacobih},Theta,Nonlin,miss];

\t\tYii = Y0;
\t\tYF = Shape[1,{T1}];
\t\tYF[[1]]  = Y0;
\t\tPii = P0;
\t\tPF = Shape[1,{T1}];
\t\tPF[[1]] = P0;
\t\tIP = IdentityMatrix[p];
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\txi = X[[i]];
\t\t\tA = Jacobif[Yii,xi,Theta];
\t\t\t
\t\t  \t(*
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
\t\t\t{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
\t\t\t
\t\t\t(*Print[{Omega,A,B}//TableForm]
\t\t\tPrint[{V,Astern,Bstern}//TableForm];*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Flatten[Bstern];
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t    *)  
\t\t 
            G = diff[Yii,xi,Theta]; 
            Omega = G.Transpose[G];
            V = Omega dt;
\t\t\tAstern = IP + A dt;
\t\t\t
\t\t\tYi1i = Yii + drift[Yii,xi,Theta] dt;
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t 
\t\t    
\t\t    
\t\t    If[Max[Abs[Yi1i]] > YMAX,
\t\t    \tPrint[\"possible divergence, i = \",i];
\t\t    \tYi1i = Y0;
\t\t    \tPi1i = P0];
\t\t    \t
\t\t\t(*Mess-Update*)
\t\t\t
\t\t\ti1 = i+1;
\t\t\tz = Z[[i1]];
\t\t\tzmiss = z ~eq~ miss;
\t\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t
\t\t\t(* keine Messung *)
\t\t\t\tYF[[i1]] = Yii = Yi1i;
\t        \tPF[[i1]] = Pii = Pi1i,
\t        \t
\t        (* Messung *)
\t        \tlc = Locate[zmiss,False];
\t\t\t\tH = Jacobih[Yi1i,X[[i1]],Theta];
\t\t\t\tH = H[[lc]];
\t\t\t\tr = R[Yi1i,X[[i1]],Theta][[lc,lc]];\t\t
\t\t\t\tvi = H . Pi1i . Transpose[H] + r;
\t\t\t\tvi1 = Inverse[vi];
\t\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\t\tinn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
\t\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\t\tlik += liki;
\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\tikh = IP - gain.H;
\t\t\t\t(*ikh = IdPlusA[-gain.H];*)
\t\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
\t\t\t\t\t\t\t\t\t \t
\t        \tYF[[i1]] = Yii;
\t        \tPF[[i1]] = Pii
\t        ]
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{YF,PF,lik}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MNonLinGlattUp//Clear
MNonLinGlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Asterni_]:=
\tModule[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},
\t\t
\t\t\tPistern = LinearSolve[Pi1i,Asterni.Pii]//Transpose;
\t\t\t
\t\t\tYGneu = Yii + Pistern.(YG - Yi1i);
\t\t\tPGneu = Pii + Pistern.(PG - Pi1i).Transpose[Pistern];
\t
\t\t   {YGneu,PGneu}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MNonLinGlatt//Clear
MNonLinGlatt[mue_,sigma_,Z_,X_,{drift_,diff_,Jacobif_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:=
\t\t\t   
\tModule[{k,p,q,Yii,Pii,YF,PF,i,i1,Yi1i,Pi1i,Y1,P1,lik,liki,xi,
\t\t\tA,Asterni,B,G,Omega,
\t\t\tr,H,Y0,P0,T,T1,IP,mue0,sigma0,z,zmiss},
\t
\t\t
\t\tmue0   = mue  [ X[[1]],Theta];
\t\tsigma0 = sigma[ X[[1]],Theta];
\t\t
\t\t{p} = Dimensions[mue0];
\t\t{T1,k} = Dimensions[Z];
\t\tT = T1-1;
\t\tPrint[\"{k,p,T} = \",{k,p,T}];
\t\t
\t\t{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
\t\t\t\t\t  {h,R,Jacobih},Theta,Nonlin,miss];

\t\tYii = Y0;
\t\tYF = Shape[1,{T1}];
\t\tYF[[1]]  = Y0;
\t\tPii = P0;
\t\tPF = Shape[1,{T1}];
\t\tPF[[1]] = P0;
\t\t
\t\tY1 = Shape[1,{T}];
\t\tP1 = Shape[1,{T}];
\t\t
\t\tIP = IdentityMatrix[p];
\t\tAsterni = {};
\t\t
\t\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\txi = X[[i]];
\t\t\tA = Jacobif[Yii,xi,Theta]; 
\t\t\t
\t\t(*  \t
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
\t\t\t{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
\t\t\t
\t\t\t(*Print[{Omega,A,B}//TableForm]
\t\t\tPrint[{V,Astern,Bstern}//TableForm];*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Flatten[Bstern];
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t*)     
\t\t 
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
            V = Omega dt;
\t\t\tAstern = IP + A dt;
\t\t\tAppendTo[Asterni,Astern];
\t\t\t(*Astern//Print;*)
\t\t\t
\t\t\tYi1i = Yii + drift[Yii,xi,Theta] dt;
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t  
\t\t    
\t\t    
\t\t    If[Max[Abs[Yi1i]] > YMAX,
\t\t    \tPrint[\"possible divergence, i = \",i];
\t\t    \tYi1i = Y0;
\t\t    \tPi1i = P0];
\t\t    \t
\t\t\t(*Mess-Update*)
\t\t\t
\t\t\ti1 = i+1;
\t\t\tz = Z[[i1]];
\t\t\tzmiss = z ~eq~ miss;
\t\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t
\t\t\t(* keine Messung *)
\t\t\t\tYF[[i1]] = Y1[[i]] = Yii = Yi1i;
\t        \tPF[[i1]] = P1[[i]] = Pii = Pi1i,
\t        \t
\t        (* Messung *)
\t        \tlc = Locate[zmiss,False];
\t\t\t\tH = Jacobih[Yi1i,X[[i1]],Theta];
\t\t\t\tH = H[[lc]];
\t\t\t\tr = R[Yi1i,X[[i1]],Theta][[lc,lc]];\t\t
\t\t\t\tvi = H . Pi1i . Transpose[H] + r;
\t\t\t\tvi1 = Inverse[vi];
\t\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\t\tinn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
\t\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\t\tlik += liki;
\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\tikh = IP - gain.H;
\t\t\t\t(*ikh = IdPlusA[-gain.H];*)
\t\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
\t\t\t\t\t\t\t\t\t \t
\t        \tYF[[i1]] = Yii;
\t        \tPF[[i1]] = Pii;
\t        \tY1[[i]] = Yi1i;
\t        \tP1[[i]] = Pi1i;
\t        \t
\t        ]
\t        \t
\t\t,{i,T}];  
\t\t
\t\tYGalt = YF[[T1]];
\t\tPGalt = PF[[T1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t(*Pi1i//Print;*)
\t\t\t
\t\t\t{YGalt,PGalt} = MNonLinGlattUp[ {YGalt,PGalt},
\t\t\t\t\t\t\t\t   {Yii,Pii,Yi1i,Pi1i},Asterni[[i]] ];
\t\t\t(*{YGalt,PGalt}//Print;*)
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\t
\t\t
\t\t,{i,T,1,-1}];
\t\t
\t\tlik = -.5 lik;
\t\t\t\t
\t\t{YG,PG,YF,PF,lik}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
IdPlusA[A_] := Module[{out,p},
\t\tp = Length[A];
\t\tout = A; 
\t\tDo[out[[i,i]] = out[[i,i]]+1 ,{i,p}];
\t\tout]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
NonLinStateSpace//Clear
NonLinStateSpace[h_,R_,f_,g_,Y0_,X_,T_,dt_,Theta_,Prozess_,Step_]:=
\tModule[{Y,R2,Z,eps = 10^-16,k},
\t\tk = Length[h[Y0,X[[1]],Theta]];
\t\tY = RungeKutta[f,g,Y0,X,T,dt,Theta,Prozess,Step];
\t\teps = eps IdentityMatrix[k];
\t\tR2 = MapThread[(Transpose[
\t\t\t\tCholeskyDecomposition[R[#1,#2,Theta]+eps]])&,
\t\t\t\t\t{Y,Take[X,T+1]}];
\t\t\t\t\t\t
\t\tZ = MapThread[h[#1,#2,Theta]&,{Y,Take[X,T+1]}] 
          + MapThread[Dot,{R2,Table[Prozess[],{i,T+1},{j,k}]} ];
   
                         
     \t{Z,Y}
     ]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\

NonLinStateSpace[h_,{R_,konstant_},f_,g_,Y0_,X_,T_,dt_,Theta_,Prozess_,Step_]:\
=
\tModule[{Y,R2,Z,eps = 10.^-16,k},
\t\tk = Length[h[Y0,X[[1]],Theta]];
\t\tY = RungeKutta[f,g,Y0,X,T,dt,Theta,Prozess,Step];
\t\teps = eps IdentityMatrix[k];
\t\tR2 = CholeskyDecomposition[R[Y0,X[[1]],Theta]+eps];\t
\t\tZ = MapThread[h[#1,#2,Theta]&,{Y,Take[X,T+1]}] 
          + Table[Prozess[],{i,T+1},{j,k}].R2;
   
                         
     \t{Z,Y}
     ]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MNonLinLikn//Clear
MNonLinLikn[mue_,sigma_,Z_,X_,{drift_,diff_,Jacobif_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:= 
\tModule[{k,p,q,Yii,Pii,i,i1,Yi1i,Pi1i,lik,liki,xi,
\t\t\tA,B,G,Omega,
\t\t\tr,H,Y0,P0,T,T1,IP,mue0,sigma0},
\t\t  
\t\tmue0   = mue[  X[[1]],Theta];
\t\tsigma0 = sigma[X[[1]],Theta];
\t\t
\t\t{p} = Dimensions[mue0];
\t\t{T1,k} = Dimensions[Z];
\t\tT = T1-1;
\t\t
\t\t(*Print[\"MNonLinLikn {k,p,T} = \",{k,p,T}];*)
\t\t
\t\t{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
\t\t\t\t\t  {h,R,Jacobih},Theta,Nonlin,miss];

\t\tYii = Y0;
\t\tPii = P0;
\t\tIP = IdentityMatrix[p];
\t\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\txi = X[[i]];
\t\t\tA = Jacobif[Yii,xi,Theta];
\t\t\t
\t\t \t(* 
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
\t\t\t{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
\t\t\t
\t\t\t(*Print[{Omega,A,B}//TableForm]
\t\t\tPrint[{V,Astern,Bstern}//TableForm];
\t\t\t*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Flatten[Bstern];
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t    *) 
\t\t 
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
            V = Omega dt;
\t\t\tAstern = IP + A dt;
\t\t\t
\t\t\tYi1i = Yii + drift[Yii,xi,Theta] dt;
\t\t\t
\t\t    Pi1i = Astern.Pii.Transpose[Astern] + V;
\t\t 
\t\t    
\t\t    (*
\t\t    If[Max[Abs[Yi1i]] > YMAX,
\t\t    \tPrint[\"possible divergence, i = \",i];
\t\t    \tYi1i = Y0;
\t\t    \tPi1i = P0];*)
\t\t    \t
\t\t\t(*Mess-Update*)
\t\t\t
\t\t\ti1 = i+1;
\t\t\tz = Z[[i1]];
\t\t\tzmiss = z ~eq~ miss;
\t\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t
\t\t\t(* keine Messung *)
\t\t\t\tYii = Yi1i;
\t        \tPii = Pi1i,
\t        \t
\t        (* Messung *)
\t        \tlc = Locate[zmiss,False];
\t        \t
\t\t\t\tH = Jacobih[Yi1i,X[[i1]],Theta];
\t\t\t\tH = H[[lc]];
\t\t\t\tr = R[Yi1i,X[[i1]],Theta][[lc,lc]]; 
\t\t\t\tvi = H . Pi1i . Transpose[H] + r;
\t\t\t\tvi1 = PseudoInverse[vi];
\t\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\t\t
\t\t\t\tinn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
\t\t\t\t\t(*
\t\t\t\t\tPrint[\"i, vi1, inn, z  \", i,vi1//N20,inn//N20,z[[lc]]//N20];
\t\t\t\t\t*)
\t\t\t\t
\t\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\t
\t\t\t\tlik += liki;
\t\t\t\tYii = Yi1i + gain.inn; 
\t\t\t\tikh = IP - gain.H;
\t\t\t\t(*ikh = IdPlusA[-gain.H];*)
\t\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
\t\t\t\t
\t        ]
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t(*Print[\"lik  \",lik//N20];\t*)
\t\tlik
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
(***************************************************************)\t\
\t\t \t\t\t 
MNonLinLik//Clear\t\t\t 
MNonLinLik[mue_,sigma_,Z_,X_,system_,Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)\t\t\t 
Module[{},\t\t  
Apply[Plus,
\tMapThread[MNonLinLikn[mue,sigma,#1,#2,system,
\tTheta,dt,Nonlin,miss]&,{Z,X}]]
]; \
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[CellGroupData[{

Cell["$MachineEpsilon//Sqrt", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[OutputFormData["\<\
3.292722539913596233*10^-10\
\>", "\<\
          -10
3.29272 10\
\>"], "Output",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontVariations->{"CompatibilityType"->0}]
}, Open  ]],

Cell["\<\
(***************************************************************)\t\
\t\t 
MNonLinScore[mue_,sigma_,Z_,X_,
\t\t\t {drift_,diff_,Jacobif_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)\t\t\t 
(* NUMERISCHER SCORE (MIT MISSING DATA) *)
Module[{INC = $MachineEpsilon//Sqrt,i,u,LIK,LIKI,INC1,SNUM,Thetai},

LIK = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t\t  Theta,dt,Nonlin,miss];
INC = INC Abs[Theta];
INC1=1/INC;
SNUM = {};
Do[ 
    Thetai=Theta//Flatten;
    Thetai[[i]]=Thetai[[i]]+INC[[i]];
    
    LIKI = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t\t  Thetai,dt,Nonlin,miss];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
(***************************************************************)\t\
\t\t 
MNonLinScore2[mue_,sigma_,Z_,X_,
\t\t\t {drift_,diff_,Jacobif_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)\t\t\t 
(* NUMERISCHER SCORE (MIT MISSING DATA) 2-seitig*)
Module[{INC = $MachineEpsilon^(1/3),i,u,LIK,LIKI,INC1,SNUM,Thetai},

LIK = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t\t  Theta,dt,Nonlin,miss];
INC = INC Abs[Theta];
INC1=1/(2INC);
SNUM = {};
Do[ 
    Thetaiup=Theta//Flatten;
    Thetaido=Theta//Flatten;
    Thetaiup[[i]]=Thetaiup[[i]]+INC[[i]];
    Thetaido[[i]]=Thetaido[[i]]-INC[[i]];
    
    LIKIup = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t\t  Thetaiup,dt,Nonlin,miss];
\tLIKIdo = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t\t  Thetaido,dt,Nonlin,miss];
    SNUM = Append[SNUM,(LIKIup-LIKIdo)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[CellGroupData[{

Cell["\<\
(***************************************************************)
GRIDIJ[PSI_,I_,J_,HI_,HJ_]:= Module[{OUT},
(***************************************************************)
OUT = PSI;
OUT[[I]] = OUT[[I]] + HI[[I]];
OUT[[J]] = OUT[[J]] + HJ[[J]];
OUT
]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
General::spell: Possible spelling error: new symbol name \"OUT\" is \
similar to existing symbols {out, Out}.\
\>", "Message",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontVariations->{"CompatibilityType"->0}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
(***************************************************************)
GRIDI[PSI_,I_,HI_]:= Module[{OUT},
(***************************************************************)
OUT = PSI;
OUT[[I]] = OUT[[I]] + HI[[I]];
OUT
]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
General::spell1: Possible spelling error: new symbol name \"GRIDI\" \
is similar to existing symbol \"GRIDIJ\".\
\>", "Message",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontVariations->{"CompatibilityType"->0}]
}, Open  ]],

Cell[CellGroupData[{

Cell["GRIDI[{1,2,3},2,{.1,.2,.4}]", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[OutputFormData["\<\
{1, 2.2, 3}\
\>", "\<\
{1, 2.2, 3}\
\>"], "Output",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontVariations->{"CompatibilityType"->0}]
}, Open  ]],

Cell[CellGroupData[{

Cell["GRIDIJ[{1,2,3},2,3,{.1,.2,.4},{.1,.2,.1}]", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[OutputFormData["\<\
{1, 2.2, 3.1}\
\>", "\<\
{1, 2.2, 3.1}\
\>"], \
"Output",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontVariations->{"CompatibilityType"->0}]
}, Open  ]],

Cell["\<\
(***************************************************************)
MNonLinHesse[mue_,sigma_,Z_,X_,
\t\t\t {drift_,diff_,Jacobif_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:*)
(* ZENTRALE DIFFERENZEN *)


Module[{LIK,L2,INC = $MachineEpsilon^(1/3),INK,INK2,H4,H,
\t\tLIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J},

U = Length[Theta];
LIK = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t\t  \t\tTheta,dt,Nonlin,miss];
L2   = 2 LIK;
INK  =INC Abs[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];

H = Shape[0,{U,U}];

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
\tMap[MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t#,dt,Nonlin,miss]&,
\t\t\t{GRIDIJ[Theta ,I,J,  INK,  INK],
\t\t\t GRIDIJ[Theta ,I,J,  INK, -INK],
\t\t\t GRIDIJ[Theta ,I,J, -INK,  INK],
\t\t\t GRIDIJ[Theta ,I,J, -INK, -INK]
\t\t\t }];
\t
    H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;
    
,{I,1,U},{J,I+1,U}];

H = H + Transpose[H];

Do[ 

{L2I,LM2I} = 
\tMap[MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
\t\t#,dt,Nonlin,miss]&,
\t\t\t{GRIDI[Theta ,I, INK2],
\t\t\t GRIDI[Theta ,I,-INK2]
\t\t\t }];
    H[[I,I]] = L2I - L2 + LM2I;
    
,{I,1,U}];

H = H H4;
{H,LIK}
]
\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\


(***************************************************************)\t\t\t 
BFGSUP[F_,SNEU_,S_,STEP_] := Module[{ETA,MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)\t\t\t 
ETA = 10^-4; (*NOISE LEVEL*)
MACHEPS2 = 10.^-8;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < ETA, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print[\"*BFGSUP \", A,\"  \", B];
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{1, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MatPrint[F_]:=
  Print[NumberForm[F//MatrixForm,4,NumberSigns->{\"-\",\" \"}]];\
\>", "Input",\

  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
LikTest[LIKNEU_]:=
\tIf[(LIKNEU//NumberQ//Not)||(Im[LIKNEU]!=0)||(LIKNEU>10.^10),
\t \tPrint[\"LIKNEU = \",LIKNEU,\" reset to -10.^10\"]; -10.^10,
\t \t\tLIKNEU]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
(***************************************************************)\t\
\t\t 
MNonLinBFGS//Clear
MNonLinBFGS[THETA0_,F0_,KMAX_,EPS_,Z_,X_,K_,P_,Q_,n_,np_,T_,DT_,
\t\t\tOPTION_,NONLIN_,MISS_,mue_,sigma_,
\t\t\tdrift_,diffusion_,Jacobif_,h_,R_,Jacobih_,PRINT_]:= 
(***************************************************************)\t\t\t 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,u,THETA,F,
        S,LIKALT,LIKI,psii,STEPL,STEP,
        LIKNEU,SNEU,likpsi,COV,k,LIKELI},
INC=10.^-5;
MAXSTEP=10.^2;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;
stepreduce = 3;

If[PRINT[[1]] == 1,
Print[\"***********************LSDE1**********************************\"];
Print[\"***********************MODUL: MNonLinBFGS*********************\"];
Print[\"**************************************************************\"];
Print[\"Technical Output\"];
VecPrint[{KMAX,EPS,K,P,Q,n,np,T,DT,OPTION,NONLIN,MISS,MAXSTEP,
\t\t  MINSTEP,BOUND,stepreduce}//Spalte,
         {\"KMAX\",\"EPS\",\"K\",\"P\",\"Q\",\"n\",\"np\",\"T\",\"DT\",\"\
OPTION\",\"NONLIN\",
          \"MISS\",\"MAXSTEP\",\"MINSTEP\",\"BOUND\",\"stepreduce\"}];
Print[ \"\"];
Print[ \"STARTWERT THETA0 = \", THETA0]
];

u = Length[THETA0];

THETA=THETA0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = 
\tMNonLinScore[mue,sigma,Z,X,
\t\t{drift,diffusion,Jacobif,h,R,Jacobih},THETA0,DT,Nonlin,MISS];

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,
 \t
\tIf[PRINT[[2]] == 1,
\tPrint[\"-----------------------------------------------------------------\"]\
;
    Print[\"MNonLinBFGS: Iteration = \",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    
 \tSTEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-Reduction*)
   
    THETA1 = THETA + STEP;   (*VOLLER NEWTON-STEP*)
    
    Print[\"VOLLER NEWTON-STEP  \",THETA1,\"   \",THETA];
    
  \tLIKNEU = MNonLinLik[mue,sigma,Z,X,
  \t\t\t\t{drift,diffusion,Jacobif,h,R,Jacobih},
\t\t\t  \t\t\tTHETA1,DT,Nonlin,MISS];
\t\t\t  \t\t\t
   \tLIKNEU = LikTest[LIKNEU];
   \t 
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          \t\t\t\t Max[Abs[STEP]]>MINSTEP),
         STEP=STEP/stepreduce;
         THETA1 = THETA + STEP; 
         
         LIKNEU = 
         MNonLinLik[mue,sigma,Z,X,
         \t{drift,diffusion,Jacobif,h,R,Jacobih},
\t\t\t  \t\tTHETA1,DT,Nonlin,MISS];
\t\t\t  \t\t
\t\t LIKNEU = LikTest[LIKNEU];
\t  \t\t
\t\t If[PRINT[[3]] == 1,
         Print[\"STEP-REDUCTION:  \",half,
         \t\t\t\"  LIKNEU  \", PaddedForm[LIKNEU,{20,15}],
         \t\t\t\"  LIKALT  \", PaddedForm[LIKALT,{20,15}]];
         ];
     ]; (*End DoWhile*)
     
\t
\tIf[PRINT[[4]] == 1,
    Print[\"LIKNEU  \", PaddedForm[LIKNEU,{20,15}],\"      \",
          \"LIKALT  \", PaddedForm[LIKALT,{20,15}] ];
    Print[\"LIKNEU - LIKALT  \",PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    Print[\"\"];
  
    If[PRINT[[5]] == 1, 
    Print[TableForm[{THETA1,THETA,STEP,S}//Transpose,
                     TableDirections\[Rule]Column,
                     TableSpacing\[Rule]Automatic,
    \t             TableHeadings->{Automatic,{\"THETA1\",\"THETA\",\"STEP\",\"\
SCORE\"}}]
    \t  ]];
    \t             
    If[PRINT[[6]] == 1,
    Print[\"BFGS update\"];
    MatPrint[F];
    ];
       
    {SNEU,LIKALT} = 
\t\tMNonLinScore[mue,sigma,Z,X,
\t\t\t{drift,diffusion,Jacobif,h,R,Jacobih},THETA1,DT,Nonlin,MISS];
   
    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S = SNEU;
    
    THETA = THETA1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ \"MBFGS:  ENDE DER ITERATION  k=\",k,\"  KMAX=\",KMAX] ];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,THETA];
likpsi = Spalte[LIKI]~ii~psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
\t\tTableHeadings->{Automatic,{\"Likelihood\",\"THETA\"}} ]];
];
\t\t\t\t\t

If[Fisher,

\t{F,LIKELI} = MNonLinHesse[mue,sigma,Z,X,
\t\t\t\t{drift,diffusion,Jacobif,h,R,Jacobih},THETA,DT,Nonlin,MISS];\t
\tF=-F;
\t
\tCOV = OUTPUT[THETA,F,.05,S,LIKELI];
\tLKOMP[LIKELI,u,(T+1)];
\t
,(* else *)
\tCOV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,COV,likpsi,k}

]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
MBiNonLinFilter//Clear
MBiNonLinFilter[mue_,sigma_,Z_,X_,
\t\t\t{drift_,diff_,Jacobif_,Jacobig_,h_,R_,Jacobih_},
\t\t\t  Theta_,dt_,Nonlin_,miss_]:= 
\tModule[{k,p,q,Yii,Pii,YF,PF,i,i1,Yi1i,Pi1i,lik,liki,xi,
\t\t\tA,B,G,Omega,
\t\t\tRR,rr,H,Y0,P0,T,T1,IP,mue0,sigma0,l},
\t
\t\tmue0 = mue[X[[1]],Theta];
\t\tsigma0 = sigma[X[[1]],Theta];
\t\t
\t\t{p} = Dimensions[mue0];
\t\t{T1,k} = Dimensions[Z];
\t\tT = T1-1;
\t\tPrint[\"{k,p,T} = \",{k,p,T}];
\t\t
\t\t{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
\t\t\t\t\t  {h,R,Jacobih},Theta,Nonlin,miss];

\t\tYii = Y0;
\t\tYF = Shape[1,{T1}];
\t\tYF[[1]]  = Y0;
\t\tPii = P0;
\t\tPF = Shape[1,{T1}];
\t\tPF[[1]] = P0;
\t\tIP = IdentityMatrix[p];
\t\t{p,rr} = diff[Y0,X[[1]],Theta]//Dimensions;
\t\t(*rr//Print;*)
\t\tpp = p//Range;
\t\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\txi = X[[i]];
\t\t\tA = Jacobif[Yii,xi,Theta]; 
\t\t 
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
            B = Jacobig[Yii,xi,Theta];
\t\t\t
\t\t\tYi1i = Yii + drift[Yii,xi,Theta] dt;
\t\t\tAP = A.Pii;
\t\t\t
\t\t\tBPB = Sum[  Bl = B[[pp,l,pp]];
\t\t\t\t\t\tBl.Pii.Transpose[Bl],
\t\t\t\t\t\t{l,rr}];
\t\t\t(*
\t\t\ti//Print;
\t\t\tPii//Print;
\t\t\tBPB//Print;\t
\t\t\tOmega//Print;\t
\t\t\t*)
\t\t\t    
\t\t    Pi1i = Pii + (AP + Transpose[AP] + BPB + Omega) dt;
\t\t 
\t\t    
\t\t    
\t\t    If[Max[Abs[Yi1i]] > YMAX,
\t\t    \tPrint[\"possible divergence, i = \",i];
\t\t    \tYi1i = Y0;
\t\t    \tPi1i = P0];
\t\t    \t
\t\t\t(*Mess-Update*)
\t\t\t
\t\t\ti1 = i+1;
\t\t\tz = Z[[i1]];
\t\t\tzmiss = z ~eq~ miss;
\t\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t
\t\t\t(* keine Messung *)
\t\t\t\tYF[[i1]] = Yii = Yi1i;
\t        \tPF[[i1]] = Pii = Pi1i,
\t        \t
\t        (* Messung *)
\t        \tlc = Locate[zmiss,False];
\t\t\t\tH = Jacobih[Yi1i,X[[i1]],Theta];
\t\t\t\tH = H[[lc]];
\t\t\t\tRR = R[Yi1i,X[[i1]],Theta][[lc,lc]];\t\t
\t\t\t\tvi = H . Pi1i . Transpose[H] + RR;
\t\t\t\tvi1 = Inverse[vi];
\t\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\t\tinn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
\t\t\t\tliki = Log[Det[vi]] + inn.vi1.inn;
\t\t\t\tlik += liki;
\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\tikh = IP - gain.H;
\t\t\t\t(*ikh = IdPlusA[-gain.H];*)
\t\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain.RR.Transpose[gain];
\t\t\t\t\t\t\t\t\t \t
\t        \tYF[[i1]] = Yii;
\t        \tPF[[i1]] = Pii
\t        ]
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{YF,PF,lik}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
(***************************************************************)
Adapter//Clear
Adapter[Z_,Y_,YG_,PG_,YF_,PF_] := 
(***************************************************************)

\tModule[{},
\t
\t{n,T1,p} = Dimensions[Z];
\t
\tYG1 = Shape[YG,{T+1,p,1}];
\tYF1 = Shape[YF,{T+1,p,1}];
\tPG1 = Shape[PG,{T+1,1,p,p}];
\tPF1 = Shape[PF,{T+1,1,p,p}];
\t
\tZ1  = Z//Transpose[#,{3,1,2}]&;
\tY1  = Y//Transpose[#,{3,1,2}]&;
\t
\t{Z1,Y1,YG1,YF1,PG1,PF1}
\t]
\t
(***************************************************************)
ConfidenceBand[Y_,YF_,PF_,pp_,nn_,z_] := 
(***************************************************************)

\tModule[{var1,conf1,conf2,yf,T,p,n,np},
\t{T,p,n} = Y//Dimensions;
\t{T,np,p,p} = PF//Dimensions;
\tn = If[np == 1, 1, nn];
\tvar1 = Sqrt[PF[[T//Range,n,{pp},pp]]  ];
\tyf = YF[[T//Range,{pp},nn]];
\tconf1 = yf + z var1;
\tconf2 = yf - z var1;
\tY[[T//Range,{pp},nn]] ~ii~ yf ~ii~ conf1 ~ii~ conf2
]



(***************************************************************)
graph//Clear
graph[Z_,Y_,YG_,PG_,tau_,DT_,pp_,nn_,plotrange_,alpha_] := 
(***************************************************************)
Module[{T1,p,n},

{T1,p,n} = Dimensions[Y];
zalphahalbe = Quantile[NormalDistribution[0,1], 1-alpha/2];
Print[\"Quantil = \",zalphahalbe];

g1 = plot1[{DT(tau-1),Z[[tau,pp,nn]]}//Transpose,
\t\t\t\tPlotJoined->False,
\t\t\t\tdicke->.01,
\t\t\t\tcolor->{10},
\t\t\t\tDisplayFunction->Identity];
\t\t\t\t
g2 = plot1[ Y[[T1//Range,{pp},nn]]//AddTimeAxis[#,DT]&,
            DisplayFunction->Identity];

g3 = plot1[YG[[T1//Range,{pp},nn]]//AddTimeAxis[#,DT]&,
\t\t\t\tcolor->{2},
\t\t\t\tdicke -> .01,
\t\t\t\tDisplayFunction->Identity];

g4 = plot1[ConfidenceBand[YG,YG,PG,pp,nn,zalphahalbe]//AddTimeAxis[#,DT]&,
\t\t\t\t\tcolor->{1,2,5,5},
\t\t\t\t\tdicke->.002,
\t\t\t\t\tDisplayFunction->Identity ];

Show[g2,g3,g4,g1, DisplayFunction->Identity,
\t\t\t\t  PlotRange->plotrange]
]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{22, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->Automatic,
WindowToolbars->"RulerBar",
CellGrouping->Manual,
WindowSize->{675, 670},
WindowMargins->{{Automatic, 20}, {Automatic, 12}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
0000001804P000000bd2=_oaoo43?095o`85N@?NW0002008ool000001@050001
0000I24A4R060`410@000BL?0040000000000000000004E3<34100;o00000001
000A0S<R<3`00Q3400018NOWinOWia4A\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 90, 2, 27, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[1869, 57, 255, 6, 56, "Section",
  InitializationCell->True],
Cell[2127, 65, 817, 26, 278, "Input",
  InitializationCell->True],
Cell[2947, 93, 2038, 73, 922, "Input",
  InitializationCell->True],
Cell[4988, 168, 2258, 79, 1020, "Input",
  InitializationCell->True],
Cell[7249, 249, 2813, 105, 1370, "Input",
  InitializationCell->True],
Cell[10065, 356, 565, 18, 166, "Input",
  InitializationCell->True],
Cell[10633, 376, 3564, 141, 1874, "Input",
  InitializationCell->True],
Cell[14200, 519, 349, 12, 82, "Input",
  InitializationCell->True],
Cell[14552, 533, 776, 23, 236, "Input",
  InitializationCell->True],
Cell[15331, 558, 682, 21, 194, "Input",
  InitializationCell->True],
Cell[16016, 581, 2838, 109, 1426, "Input",
  InitializationCell->True],
Cell[18857, 692, 593, 17, 138, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[19475, 713, 248, 6, 26, "Input",
  InitializationCell->True],
Cell[19726, 721, 292, 10, 33, "Output",
  InitializationCell->True]
}, Open  ]],
Cell[20033, 734, 1079, 34, 362, "Input",
  InitializationCell->True],
Cell[21115, 770, 1281, 38, 418, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[22421, 812, 550, 16, 124, "Input",
  InitializationCell->True],
Cell[22974, 830, 323, 8, 21, "Message",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[23334, 843, 511, 15, 110, "Input",
  InitializationCell->True],
Cell[23848, 860, 325, 8, 21, "Message",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[24210, 873, 254, 6, 26, "Input",
  InitializationCell->True],
Cell[24467, 881, 263, 9, 24, "Output",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[24767, 895, 268, 6, 26, "Input",
  InitializationCell->True],
Cell[25038, 903, 269, 10, 24, "Output",
  InitializationCell->True]
}, Open  ]],
Cell[25322, 916, 1576, 63, 782, "Input",
  InitializationCell->True],
Cell[26901, 981, 861, 27, 278, "Input",
  InitializationCell->True],
Cell[27765, 1010, 316, 10, 40, "Input",
  InitializationCell->True],
Cell[28084, 1022, 396, 11, 68, "Input",
  InitializationCell->True],
Cell[28483, 1035, 4463, 162, 2112, "Input",
  InitializationCell->True],
Cell[32949, 1199, 2746, 107, 1398, "Input",
  InitializationCell->True],
Cell[35698, 1308, 2155, 76, 978, "Input",
  InitializationCell->True]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

