(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     64665,       2242]*)
(*NotebookOutlinePosition[     65746,       2276]*)
(*  CellTagsIndexPosition[     65702,       2272]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
<<code`LSD`
<<code`PARTest`

\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
BFGS::usage = \"BFGS[THETA0,PHI0,F0,KMAX,EPS,Z,X,K,P,Q,N,T,DT,
\t\t            OPTION,NONLIN,PRINT]\"
\t\t        
\t\t        
\t\t   \t\t        \
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
MatPrint[F_]:=
  Print[NumberForm[F//MatrixForm,4,NumberSigns->{\"-\",\" \"}]];\
\>", "Input",\

  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
(***************************************************************)
DMS[Y_,X_] := Outer[D,Y//Flatten,X//Flatten]//Transpose;
(***************************************************************)\
\>", \
"Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
INTERPOL[XM_,MISS_,ORDER_] := 
(***************************************************************)
\tModule[{XMr,Xint,tau3,T1,q,n,data},
\t\t{T1,q,n} = XM//Dimensions;
\t\tXMr = XM//Reverse;
\t\tXint = Table[
\t\t\ttau3 = Locate[XMr[[T1//Range,qq,nn]] ~eq~ MISS, False];
\t\t\t(*tau3//Print;*)
\t\t\tdata = {tau3,XMr[[tau3,qq,nn]]}//Transpose;
      \t\tInterpolation[data,InterpolationOrder->ORDER][T1//Range]
       \t\t  ,{qq,q},{nn,n}];
\t\tTranspose[Xint,{2,3,1}]//Reverse
\t ]\t\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
analyze[z_,miss_] := Module[{t1,p,n,LC,messindTN,messindT},
(***************************************************************)

\t{t1,p,n} = Dimensions[z];
\tLC = Map[Locate[# ~ne~ miss]&,Transpose[z,{1,3,2}],{2}];
\tmessindTN = Delete[Outer[List,t1//Range,n//Range],Position[LC,{}]];
\tmessindTN = Flatten[messindTN,1];
\tmessindT = Map[Part[#,{1}]&,messindTN]//Union;
\t{LC,messindTN,messindT}
\t]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
Z = Shape[1,{5,2,3}];
Z[[1,1,1]] = -9;
Z[[1,2,1]] = -9;
Z[[3,1,3]] = -9;
Z[[4,1,3]] = -9;
Z[[2]]=Shape[-9,{2,3}];
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Position[Z,-9]
Map[Part[#,{1,3}]&,Position[Z,-9] ] // Union
{LC,messindTN,messindT} = analyze[Z,-9]
Z//TableForm\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{1, 1, 1}, {1, 2, 1}, {2, 1, 1}, {2, 1, 2}, {2, 1, \
3}, {2, 2, 1}, {2, 2, 2}, {2, 2, 3}, {3, 1, 3}, {4, 1, 3}}\
\>", "\<\
{{1, 1, \
1}, {1, 2, 1}, {2, 1, 1}, {2, 1, 2}, {2, 1, 3}, {2, 2, 1}, {2, 2, 2}, {2, 2, \
3}, {3, 1, 3}, {4, 1, 3}}\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{1, 1}, {2, 1}, {2, 2}, {2, 3}, {3, 3}, {4, \
3}}\
\>", "\<\
{{1, 1}, {2, 1}, {2, 2}, {2, 3}, {3, 3}, {4, 3}}\
\>"], \
"Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{{{}, {1, 2}, {1, 2}}, {{}, {}, {}}, {{1, 2}, {1, \
2}, {2}}, {{1, 2}, {1, 2}, {2}}, {{1, 2}, {1, 2}, {1, 2}}}, 
 {{1, 2}, {1, 3}, {3, 1}, {3, 2}, {3, 3}, {4, 1}, {4, 2}, {4, 3}, {5, 1}, {5, \
2}, {5, 3}}, {{1}, {3}, {4}, {5}}}\
\>", "\<\
{{{{}, {1, 2}, {1, 2}}, {{}, \
{}, {}}, {{1, 2}, {1, 2}, {2}}, {{1, 2}, {1, 2}, {2}}, {{1, 2}, {1, 2}, {1, \
2}}}, 
 {{1, 2}, {1, 3}, {3, 1}, {3, 2}, {3, 3}, {4, 1}, {4, 2}, {4, 3}, {5, 1}, {5, \
2}, {5, 3}}, {{1}, {3}, {4}, {5}}}\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
TableForm[{{{-9, 1, 1}, {-9, 1, 1}}, {{-9, -9, -9}, \
{-9, -9, -9}}, {{1, 1, -9}, {1, 1, 1}}, {{1, 1, -9}, {1, 1, 1}}, {{1, 1, 1}, \
{1, 1, 1}}}]\
\>", "\<\
       1  2  3

  1    -9 1  1
1 2    -9 1  1

  1    -9 -9 -9
2 2    -9 -9 -9

  1    1  1  -9
3 2    1  1  1

  1    1  1  -9
4 2    1  1  1

  1    1  1  1
5 2    1  1  1\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
(***************************************************************)
ConfidenceBand[Y_,YF_,PF_,pp_,nn_,z_] := 
(***************************************************************)

\tModule[{var1,conf1,conf2,yf,T,p,n,np},
\t{T,p,n} = Y//Dimensions;
\t{T,np,p,p} = PF//Dimensions;
\tn = If[np == 1, 1, nn];
\tvar1 = Sqrt[PF[[T//Range,n,{pp},pp]]  ];
\tyf = YF[[T//Range,{pp},nn]];
\tconf1 = yf + z var1;
\tconf2 = yf - z var1;
\tY[[T//Range,{pp},nn]] ~ii~ yf ~ii~ conf1 ~ii~ conf2
]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
MessUp5[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,miss_,LC_,{k_,p_,q_,n_,np_}] :=
(***************************************************************)
\tModule[{nn,zmiss,lc,hnt,dnt,rnt,pi1in,vint,vi1,gain,inn,ikh,
\t        Yii,Pii,lik},
\t\t
\t\tlik = .0;
\t\tYii = Yi1i;
\t\tPii = Pi1i;
\t\t
\t\tDo[ 
\t\t\tlc = LC[[nn]]; \t\t
\t\t\tIf[ lc == {},
\t\t\t\t(* keine Messung *)
\t\t\t\t 
\t\t\t\tIf[np == 1, Return[] ]\t
\t\t\t\t
\t\t\t,(*else*)
\t\t\t\t
\t\t\t\thnt = H[[lc]];
\t\t\t\tdnt = D[[lc]]; 
\t\t\t\trnt = R[[lc,lc]];
\t\t\t\t
\t\t\t\tpi1in = Pi1i[[nn]];
\t\t\t\tvint = hnt.pi1in.Transpose[hnt] + rnt;
\t\t\t\tvi1 = Inverse[vint];
\t\t\t\tgain = pi1in.Transpose[hnt].vi1;
\t\t\t\t
\t\t\t\tIf[np == 1, (*Print[\"Messung, simultan\"];*)
\t\t\t\t
\t\t\t\t\t(* alle N simultan*)
\t\t\t\t\tinn = Z[[ lc ]] - hnt.Yi1i - dnt.X;
\t\t\t\t\tlik = n Log[Det[vint]] + MatrixTrace[vi1.
\t\t\t\t\t\t\t\t\t\t\t  (inn.Transpose[inn])];
\t\t\t\t\t\t\t\t\t\t\t 
\t\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\t\tikh = IdentityMatrix[p] - gain.hnt;
\t\t\t\t\tPii = {ikh.pi1in.Transpose[ikh] +
\t\t\t\t\t\t\t\t gain.rnt.Transpose[gain]}
\t\t\t\t\t
\t\t\t\t\t
\t\t\t\t\t
\t\t\t\t,(*else*) (*Print[\"Messung, einzeln\"];*)
\t\t\t\t
\t\t\t\t    inn = Z[[lc,nn]] - hnt.Yi1i[[Range[p],nn]] 
\t\t\t\t                     - dnt.X[[Range[q],nn]]; (*Vektor*)
\t\t\t\t\tlik += Log[Det[vint]] + inn.vi1.inn;
\t\t\t\t\t
\t\t\t\t\tYii = Yii//Transpose;
\t\t\t\t\tYii[[nn]] = Yi1i[[Range[p],nn]] + gain.inn;
\t\t\t\t\tYii = Yii//Transpose; (*wieder zur\[UDoubleDot]ck*)
\t\t\t\t\t
\t\t\t\t\tikh = IdentityMatrix[p] - gain.hnt;
\t\t\t\t\tPii[[nn]] = ikh.pi1in.Transpose[ikh] 
\t\t\t\t\t \t\t   + gain.rnt.Transpose[gain]
\t
\t\t\t\t](*end if*)
\t\t\t\t\t
\t\t\t](*end if*)
\t\t\t\t\t
\t\t,{nn,np}];
\t\t
\t   {Yii,Pii,lik}
\t   
\t](*End MessUp5*)
\
\>", "Input",
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
MGLATT5[Z_,X_,Astern_,Bstern_,Ostern_,MUEN_,SIGMAN_,
\t\tH_,D_,R_,n_,T_,miss_,LC_]:=
(***************************************************************)\t\t\t 
\tModule[{np,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,
\t\t\tYi1i,Pi1i,lik,liki,Z0,X0,Y0,P0,lik0,SUM},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = Length[SIGMAN];
\t\t(*Print[\"*MGLATT5\",{k,p,q,n,np}];*)
\t\tZ0 = Z[[1]];
\t\tX0 = X[[1]]; 
\t\t{Y0,P0,lik0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,miss]; 
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp5[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,
\t        \t\t\t\t\t\t\t  LC[[i+1]],{k,p,q,n,np}];
\t      
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik + lik0;
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\tPISUM = 0;
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t{YGalt,PGalt,SUM} = 
\t\t\t\tGlattUp[{YGalt,PGalt},{Yii,Pii,Yi1i,Pi1i},Astern,{p,np}];
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\tPISUM += SUM;
\t\t
\t\t,{i,T,1,-1}];
\t
\t\tPISUM = PISUM//Transpose;
\t\t
\t\t{YG,PG,PISUM,lik}
\t]\
\>", "Input",
  CellMargins->{{9, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
GLATT5[Z_,X_,Astern_,Bstern_,Ostern_,MUEN_,SIGMAN_,
\t\t\t\t\t\t              H_,D_,R_,n_,T_]:=
(***************************************************************)\t\t\t 
\tModule[{k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,
\t\t\tYi1i,Pi1i,lik,liki,Z0,X0,Y0,P0,lik0,SUM},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t
\t\tPrint[\"*Glatt5 {k,p,q,n} \",{k,p,q,n}];
\t\tZ0 = Z[[1]];
\t\tX0 = X[[1]]; 
\t\t{Y0,P0,lik0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9]; 
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = {Ostern};
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
\t      
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik + lik0;
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\tPISUM = 0;
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t{YGalt,PGalt,SUM} = 
\t\t\t\tGlattUp[{YGalt,PGalt},{Yii,Pii,Yi1i,Pi1i},Astern];
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\tPISUM += SUM;
\t\t
\t\t,{i,T,1,-1}];
\t
\t\tPISUM = PISUM//Transpose;
\t\t
\t\t{YG,PG,PISUM,lik}
\t]\
\>", "Input",
  CellMargins->{{9, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
GLATT5X[Z_,X_,Astern_,Bstern_,Ostern_,MUEN_,SIGMAN_,
\t\t\t\t\t\t              H_,D_,R_,n_,T_]:=
(***************************************************************)
(* alles explizit *)

\tModule[{k,p,q,Z0,X0,Y0,P0,lik0,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,
\t\t\ti,ON,Yii,Pii,Yi1i,Pi1i,lik,liki,PISUM,Pistern,IP},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tPrint[\"*Glatt5X {k,p,q,n} \",{k,p,q,n}];
\t\tZ0 = Z[[1]];
\t\tX0 = X[[1]]; 
\t\t{Y0,P0,lik0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9]; 
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = {Ostern};
\t\tIP = IdentityMatrix[p];
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t(*{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Bstern.X[[i]];
\t\t\tPi1i = Astern.Transpose[Pii,{2,1,3}].Transpose[Astern];
\t\t\tPi1i = Transpose[Pi1i,{2,1,3}] + ON;
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        (*{Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];*)
\t        \t
\t        pi1in = Pi1i[[1]]; 
\t\t\tvint = H . pi1in . Transpose[H] + R;
\t\t\tvi1 = Inverse[vint];
\t\t\tgain = pi1in . Transpose[H] . vi1;
\t\t\tinn = Z[[i+1]] - H . Yi1i - D . X[[i+1]];
\t\t\tliki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
\t\t\tYii = Yi1i + gain.inn;
\t\t\tikh = IP - gain.H;
\t\t\tPii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};\t\t\t\t\t\
\t \t
\t\t\t
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -lik/2 + lik0;
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\tPISUM = 0;
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t(*{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
\t\t\t\t\t\t\t\t     {Yii,Pii,Yi1i,Pi1i},Astern];*)
\t\t\tPiin  = Pii[[1]];\t
\t\t\tPi1in = Pi1i[[1]];
\t\t\tPGn   = PGalt[[1]];
\t\t\tPistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
\t\t\t
\t\t\tYGalt = Yii + Pistern.(YGalt - Yi1i);
\t\t\tPGalt = {Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]};
\t\t\tPISUM += Pistern.PGn;
\t\t\t(*Pistern.PGn//Transpose//Print;*)
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\t(*PG//TableForm//Print;*)
\t\t
\t\t,{i,T,1,-1}];
\t\t
\t\tPISUM = PISUM//Transpose;
\t\t
\t\t{YG,PG,PISUM,lik}
\t]\
\>", "Input",
  CellMargins->{{5, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)\t\
\t\t 
MFilter5[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_,LC_]:=
(***************************************************************)\t\t\t 
(* NUR BERECHNUNG DER LIKELIHOOD *)
 
\tModule[{np,k,p,q,Yii,Pii,i,ON,Yi1i,Pi1i,lik,liki},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = Length[P0];
\t\t
\t\t(*{k,p,q,n,np}//Print;*)
\t\t
\t\tYii = Y0;
\t\tPii = P0;
\t\tlik = 0;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp5[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,LC[[i+1]],{k,p,q,n,\
np}];
\t        
\t        lik += liki;
\t        
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{lik}
\t]\
\>", "Input",
  CellMargins->{{3, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)\t\
\t\t 
Filter5[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:=
(***************************************************************)\t\t\t 
(* NUR BERECHNUNG DER LIKELIHOOD *)
 
\tModule[{k,p,q,Yii,Pii,i,Yi1i,Pi1i,lik,liki,IP},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t
\t\t(*Print[\"*Filter5\",{k,p,q,n}];*)
\t\t
\t\tYii = Y0;
\t\tPii = P0[[1]];
\t\tlik = 0;
\t\tIP = IdentityMatrix[p];
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Bstern.X[[i]];
\t\t\tPi1i = Astern.Pii.Transpose[Astern]+Ostern;
\t\t\t
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t\t\tvint = H . Pi1i . Transpose[H] + R;
\t\t\t
\t\t\tCheck[
\t\t\tvi1 = PseudoInverse[vint],
\t\t\tInterrupt[] 
\t\t\t];
\t\t\t
\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\tinn = Z[[i+1]] - H . Yi1i - D . X[[i+1]];
\t\t\tliki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
\t\t\tYii = Yi1i + gain.inn;
\t\t\tikh = IP - gain.H;
\t\t\tPii = ikh.Pi1i.Transpose[ikh] + gain . R . Transpose[gain];\t\t\t\t\t\t \
\t
\t\t\t
\t        lik += liki
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{lik}
\t]\
\>", "Input",
  CellMargins->{{3, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["??Filter5", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Global`Filter5

Filter5[Y0_, P0_, Z_, X_, Astern_, Bstern_, Ostern_, H_, D_, R_, n_, T_] := 
  Module[{k, p, q, Yii, Pii, i, Yi1i, Pi1i, lik, liki, IP}, 
   {k, p} = Dimensions[H]; {k, q} = Dimensions[D]; Print[\"*Filter5\", {k, p, \
q, n}]; Yii = Y0; Pii = P0[[1]]; lik = 0; 
    IP = IdentityMatrix[p]; Do[Yi1i = Astern . Yii + Bstern . X[[i]]; Pi1i = \
Astern . Pii . Transpose[Astern] + Ostern; 
      vint = H . Pi1i . Transpose[H] + R; Check[vi1 = PseudoInverse[vint], \
Interrupt[]]; gain = Pi1i . Transpose[H] . vi1; 
      inn = Z[[i + 1]] - H . Yi1i - D . X[[i + 1]]; liki = n*Log[Det[vint]] + \
MatrixTrace[vi1 . inn . Transpose[inn]]; 
      Yii = Yi1i + gain . inn; ikh = IP - gain . H; Pii = ikh . Pi1i . \
Transpose[ikh] + gain . R . Transpose[gain]; lik += liki, 
     {i, T}]; lik = -0.5*lik; {lik}]\
\>", "Print",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\

MLIKEX//Clear
(***************************************************************)
MLIKEX[Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,PSI_,NONLIN_,MISS_,LC_] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD MIT MISSING DATA*)
Module[{THETA,PHI,OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,
\t\tZ0,X0,MUEN,SIGMAN,Y0,P0,LIK,LIK0},
\t\t
{THETA,PHI}=PSI;
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN=(Array[1&,{NP}] /. 1->SIGMA);
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,MISS];
LIK = MFilter5[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R,N,T,MISS,LC];
LIK=LIK + LIK0
]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\

cMLIKEX//Clear
(***************************************************************)
cMLIKEX[Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,PSI_,NONLIN_,MISS_,LC_] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD MIT MISSING DATA, c-Impl*)

Module[{THETA,PHI,OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,
        LIK,Z1,X1},

{THETA,PHI}=PSI;\t\t
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];

Z1=Transpose[Z,{2,3,1}]; (*kTN->NTk*)
X1=Transpose[X,{2,3,1}];


LIK = Apply[Plus,
      MapThread[cKF[{#1,#2}, _,{{ASTERN,BSTERN, V, H, D, R, MUE, SIGMA},
                {K, P, Q, 1, T}}, {MISS, 1}]&,
                {Z1, X1}]];
                
{LIK}    
    

]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
General::spell1: Possible spelling error: new symbol name \"cMLIKEX\
\" is similar to existing symbol \"MLIKEX\".\
\>", "Message",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
cMLIKEX//Clear
(***************************************************************)
cMLIKEX[{Z_,X_},PSI_,{PAR_,PARM_,DT_,NONLIN_},MISS_:-9] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD MIT MISSING DATA, c-Impl*)
(* Panel-Daten NxTxk                        *)
(* kompatibel zu Kalman.Exakt.impl          *)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,LIK,
        N,T,K,P,Q},
\t\t
{OMEGA,A,B,SIGMA,MUE} = PAR[PSI];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PSI];

{K,P}=H//Dimensions;
{K,Q}=D//Dimensions;
{N,T,K}=Z//Dimensions;
T=T-1;

{OMEGA,A,B,SIGMA,MUE}//Print;
{V,ASTERN,BSTERN}//Print;
{R,H,D}//Print;


LIK = Apply[Plus,
      MapThread[cKF[{#1,#2},_,{{ASTERN,BSTERN, V, H, D, R, MUE, SIGMA},
                {K, P, Q, 1(*dummy*), T}}, {MISS, 1}]&,
                {Z, X}]];
                
LIK   
    
]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
LIKEX//Clear
(***************************************************************)
LIKEX[Z_,X_,K_,P_,Q_,N_,T_,DT_,PSI_,NONLIN_] := 
(***************************************************************)
(*EXAKTE LIKELIHOOD OHNE MISSING DATA*)
Module[{THETA,PHI,OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,
\t\tZ0,X0,MUEN,SIGMAN,Y0,P0,LIK,LIK0},
\t\t
{THETA,PHI}=PSI;
{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN={SIGMA};
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9];
LIK = Filter5[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R,N,T];
LIK=LIK + LIK0
]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\

FilterX//Clear
(***************************************************************)
FilterX[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
(***************************************************************)
(* ohne TimeUp etc...*)
\tModule[{T,k,p,q,YF,PF,i,i1,Yii,Pii,Yi1i,Pi1i,
\t\t\tlik,liki},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t{p,n} = Dimensions[Y0];
\t\tT = Length[Z] - 1;
\t\t
\t\t{k,p,q,n,T}//Print;
\t\t
\t\tYii = Y0;
\t\tYF = Shape[1,{T+1}];
\t\tYF[[1]]  = Y0;
\t\tPii = P0[[1]];
\t\tPF  = Shape[1,{T+1}];
\t\tPF[[1]] = P0;
\t\tlik = 0;
\t\t
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t(*{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,{Ostern}];*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Bstern.X[[i]];
\t\t\tPi1i = Astern.Pii.Transpose[Astern] + Ostern;
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        (*{Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];*)
\t        \t
\t\t\tvint = H . Pi1i . Transpose[H] + R;
\t\t\tvi1 = Inverse[vint];
\t\t\tgain = Pi1i . Transpose[H] . vi1;
\t\t\ti1 = i+1;
\t\t\tinn = Z[[i1]] - H . Yi1i - D . X[[i1]];
\t\t\tliki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
\t\t\tYii = Yi1i + gain.inn;
\t\t\tikh = IdentityMatrix[p] - gain.H;
\t\t\tPii = ikh.Pi1i.Transpose[ikh] + 
\t\t\t\t  gain . R . Transpose[gain];\t\t\t\t\t\t \t
\t\t\t
\t        lik += liki;
\t        
\t        YF[[i1]] = Yii;
\t        PF[[i1]] = {Pii};
\t        \t
\t\t,{i,T}];
\t\t
\t\t
\t\tlik = -.5 lik;
\t\t{YF,PF,lik}
\t]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
GlattX[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
(***************************************************************)
(* ohne TimeUp etc...*)
\tModule[{T,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
\t\t\tlik,liki},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t{p,n} = Dimensions[Y0];
\t\tT = Length[Z] - 1;
\t\t
\t\t{k,p,q,n,T}//Print;
\t\t
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = {Ostern};
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t(*{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];*)
\t\t\t
\t\t\tYi1i = Astern.Yii + Bstern.X[[i]];
\t\t\tPi1i = Astern.Transpose[Pii,{2,1,3}].Transpose[Astern];
\t\t\tPi1i = Transpose[Pi1i,{2,1,3}] + ON;
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        (*{Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];*)
\t        \t
\t        pi1in = Pi1i[[1]]; 
\t\t\tvint = H . pi1in . Transpose[H] + R;
\t\t\tvi1 = Inverse[vint];
\t\t\tgain = pi1in . Transpose[H] . vi1;
\t\t\tinn = Z[[i+1]] - H . Yi1i - D . X[[i+1]];
\t\t\tliki = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
\t\t\tYii = Yi1i + gain.inn;
\t\t\tikh = IdentityMatrix[p] - gain.H;
\t\t\tPii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};\t\t\t\t\t\
\t \t
\t\t\t
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        \t
\t\t,{i,T}];
\t\t
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t(*{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
\t\t\t\t\t\t\t\t     {Yii,Pii,Yi1i,Pi1i},Astern];*)
\t\t\tPiin  = Pii[[1]];\t
\t\t\tPi1in = Pi1i[[1]];
\t\t\tPGn   = PGalt[[1]];
\t\t\tPistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
\t\t\t
\t\t\tYGalt = Yii + Pistern.(YGalt - Yi1i);
\t\t\tPGalt = {Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]};
\t
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\t(*PG//TableForm//Print;*)
\t\t
\t\t,{i,T,1,-1}];
\t\t
\t\tlik = -.5 lik;
\t\t{YG,PG,YF,PF,lik}
\t]\
\>", "Input",
  CellMargins->{{5, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
MGLATT1[Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,THETA_,PHI_,NONLIN_,MISS_] :=
(***************************************************************)
(* NP=1: ALLE N GLEICH *)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,Y0,P0,LIK0,LIK,
\t\tZ0,MUEN,SIGMAN,X0,YG,PG,YF,PF},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]]; 
Z0//Print;
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN=(Array[1&,{NP}] /. 1->SIGMA);
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,MISS];
Y0//Print;
P0//Print;
{YG,PG,YF,PF,LIK} = MGlattFold[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R,N,T,MISS];
LIK=LIK + LIK0;

{YG,PG,YF,PF,LIK}
]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
GLATT1[Z_,X_,K_,P_,Q_,N_,T_,DT_,THETA_,PHI_,NONLIN_] :=
(***************************************************************)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,Y0,P0,LIK0,LIK,
\t\tZ0,MUEN,SIGMAN,X0,YG,PG,YF,PF},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN={SIGMA};
{Y0,P0,LIK0} = MNorKorr[Z0,MUEN,SIGMAN,X0,H,D,R,-9];
{YG,PG,YF,PF,LIK} = Glatt[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R];
LIK=LIK + LIK0;

{YG,PG,YF,PF,LIK}
]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
aprioriFilter//Clear;
aprioriFilter[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
\tModule[{np,k,p,q,i,OsternN,Yi1i,Pi1i,lik,liki,inno,innocov,innocov1,
\t\t\tInno,Innocov,Innocov1,gain,L,Li,Y1,P1},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = 1; (* ohne missing *)
\t\t
\t\t(*Print[\"aprioriFilter\",{k,p,q,n,np}];*)
\t\t
\t\tY1 = Shape[1,{T+2}] /. 1->Y0;
\t\tYi1i = Y0;
\t\tP1 = Shape[1,{T+2}] /. 1->P0;
\t\tPi1i = P0[[1]];
\t\tlik = 0;
\t\tOsternN  = Array[1&,{np}] /. 1->Ostern;
\t\tInno = Shape[1,{T+1}];
\t\tInnocov1 = Inno;
\t\tL = Inno;
\t
\t\tDo[ 
\t\t\t
\t\t\tinno = Z[[i]] - H.Yi1i -  D.X[[i]];
\t\t\tinnocov = H.Pi1i.Transpose[H]+ R;
\t\t\tinnocov1 = Inverse[innocov];
\t\t\tgain = Astern.Pi1i.Transpose[H].innocov1;
\t\t\tLi = Astern - gain.H;
\t\t\tYi1i = Astern.Yi1i + Bstern.X[[i]] + gain.inno;
\t\t\t(* Pi1i = Astern.Pi1i.Transpose[Li] + Ostern; *)
\t\t\t
\t\t\t(*Joseph stabilized*)
\t\t\tPi1i = Li.Pi1i.Transpose[Li] + gain.R.Transpose[gain] + Ostern;
\t\t\t
\t\t\tliki = n Log[Det[innocov]] + 
\t\t\t\t   MatrixTrace[innocov1 . (inno . Transpose[inno])];
\t        lik += liki;
\t        Y1[[i+1]] = Yi1i;
\t        P1[[i+1]] = {Pi1i};
\t        Inno[[i]] = inno;
\t        Innocov1[[i]] = innocov1;
\t        L[[i]] = Li;
\t        \t
\t\t,{i,1,T+1}];
\t\t
\t\tlik = -.5 lik;
\t\tY1 = Drop[Y1,-1];
\t\tYP = Drop[P1,-1];\t
\t\t\t
\t\t{Y1,P1,Inno,Innocov1,L,lik}
\t]\
\>", "Input",
  InitializationCell->True,
  CellLabelMargins->{{7, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
\t
\t
GlattDeJong//Clear;
GlattDeJong[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
\tModule[{np,k,p,q,i,pi1i,lik,Y1,P1,Inno,
\t\t\tInnocov1,L,Li,ri,Ri,YG,PG,HI,LiT},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = 1; (* ohne missing *)
\t\t{k,p,q,n,np}//Print;
\t\t
\t\t
\t\t
\t\tYG = Shape[1,{T+1}];\t
\t\tPG = Shape[1,{T+1}];
\t\t{Y1,P1,Inno,Innocov1,L,lik} = 
\t\t\taprioriFilter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,n,T];
\t\t
\t\tri = Shape[0,{p,n}];
\t\tRi = Shape[0,{p,p}];
\t\t
\t\tDo[ 
\t\t\t
\t\t\tHI = Transpose[H].Innocov1[[i]];
\t\t\tLi = L[[i]];
\t\t\tLiT = Li//Transpose;
\t\t\tri = HI.Inno[[i]] + LiT.ri;
\t\t\tRi = HI.H + LiT.Ri.Li;
\t\t\tpi1i = P1[[i,1]];
\t\t\tYG[[i]] = Y1[[i]] + pi1i.ri;
\t\t\tPG[[i]] = {pi1i - pi1i.Ri.pi1i};\t
\t\t\t
\t\t,{i,T+1,1,-1}];
\t\t
\t\t\t
\t\t{YG,PG,lik}
\t]\
\>", "Input",
  InitializationCell->True,
  CellLabelMargins->{{7, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
GlattDeJong5//Clear;
GlattDeJong5[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
\tModule[{np,k,p,q,i,pi1i,lik,Y1,P1,Inno,
\t\t\tInnocov1,L,Li,ri,Ri,YG,PG,PISUM,RR,id,HI,LiT,Ripi1i},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = 1; (* ohne missing *)
\t\tPrint[\"*GlattDeJong5 {k,p,q,n} \",{k,p,q,n}];
\t\t
\t\t
\t\t
\t\tYG = Shape[1,{T+1}];\t
\t\tPG = Shape[1,{T+1}];
\t\t{Y1,P1,Inno,Innocov1,L,lik} = 
\t\t\taprioriFilter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,n,T];
\t\t
\t\tri = Shape[0,{p,n}];
\t\tRi = Shape[0,{p,p}];
\t\tid = IdentityMatrix[p];
\t\tPISUM = 0;
\t\t
\t\tDo[ 
\t\t\t
\t\t\tHI = Transpose[H].Innocov1[[i]];
\t\t\tLi = L[[i]];
\t\t\tLiT = Li//Transpose;
\t\t\tri = HI.Inno[[i]] + LiT.ri;
\t\t\tRi = HI.H + LiT.Ri.Li;
\t\t\tpi1i = P1[[i,1]];
\t\t\tYG[[i]] = Y1[[i]] + pi1i.ri;
\t\t\tRipi1i = Ri.pi1i;
\t\t\tPG[[i]] = {pi1i - pi1i.Ripi1i};\t
\t\t
\t\t\tPISUM += P1[[i-1,1]].Transpose[L[[i-1]]].(id - Ripi1i);
\t
\t\t,{i,T+1,2,-1}];
\t\t
\t\t
\t\t    i = 1;
\t\t\tHI = Transpose[H].Innocov1[[i]];
\t\t\tLi = L[[i]];
\t\t\tLiT = Li//Transpose;
\t\t\tri = HI.Inno[[i]] + LiT.ri;
\t\t\tRi = HI.H + LiT.Ri.Li;
\t\t\tpi1i = P1[[i,1]];
\t\t\tYG[[i]] = Y1[[i]] + pi1i.ri;
\t\t\tRipi1i = Ri.pi1i;
\t\t\tPG[[i]] = {pi1i - pi1i.Ripi1i};\t
\t\t
\t\t
\t\t{YG,PG,PISUM//Transpose,lik}
\t]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
linind[i_,j_,I_,J_]:= (i-1) J + j
(***************************************************************)

(***************************************************************)
tree[i_,j_,I_,J_] := Outer[linind[#1,#2,I,J]&,i,j] // Flatten
(***************************************************************)
\
\>", "Input",
  CellMargins->{{9, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
\t20//Range
\ttree[{1,2,4},{1,3,5},4,5]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, \
16, 17, 18, 19, 20}\
\>", "\<\
{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, \
14, 15, 16, 17, 18, 19, 20}\
\>"], "Output",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{1, 3, 5, 6, 8, 10, 16, 18, 20}\
\>", "\<\
{1, 3, 5, \
6, 8, 10, 16, 18, 20}\
\>"], "Output",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
KOMPNT//Clear;
(***************************************************************)
KOMPNT[H_,D_,R_,DH_,DD_,DR_,K_,P_,Q_,LC_] := 
(***************************************************************)
Module[{HNT,DNT,RNT,R1,DHNT,DDNT,DRNT,U,UU},
U = Length[DH]; UU = U//Range; 
HNT =H[[LC]];
DNT =D[[LC]];
RNT =R[[LC,LC]];
R1  =Inverse[RNT];
DRNT=DR[[UU,tree[LC,LC,K,K] ]]; 
DHNT=DH[[UU,tree[LC,P//Range,K,P] ]];
DDNT=DD[[UU,tree[LC,Q//Range,K,Q] ]];

{HNT,DNT,RNT,R1,DHNT,DDNT,DRNT}
]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{3, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
I6 = IdentityMatrix[6];
DI = Shape[2,{4,36}];
KOMPNT[I6,I6,I6,DI,DI,DI,6,6,6,{1,3,4,6}]
\
\>", "Input",
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{{{1, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0}, {0, 0, 0, \
1, 0, 0}, 
 {0, 0, 0, 0, 0, 1}}, {{1, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0}, 
 {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 1}}, 
 {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}}, 
 {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}}, 
 {{2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}}, 
 {{2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}}, 
 {{2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}}}\
\>", "\<\
{{{1, 0, 0, 0, \
0, 0}, {0, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 0}, 
 {0, 0, 0, 0, 0, 1}}, {{1, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0}, 
 {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 1}}, 
 {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}}, 
 {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}}, 
 {{2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}}, 
 {{2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}}, 
 {{2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}, 
 {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}}}\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
(***************************************************************)
MISSCORE[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,NP_,T_,DT_,NONLIN_,
\t\t  MISS_,{LC_,messindTN_,messindT_}]:=
(***************************************************************)
(*SCORE MIT MISSING DATA: STREICH-METHODE*)
(* NP=1: ALLE N GLEICHES MESS-SCHEMA BEI DEN ZEITPUNKTEN *)

Module[{PP,PQ,NT,NPP,OMEGA,A,B,SIGMA,MUE,DVDTH,DASDTH,DBSDTH,DSIGDTH,
\t\tDMUEDTH,V,ASTERN,BSTERN,V1,SIGMA1,R,H,D,DR,DH,DD,RSUM,HSUM,
\t\tDSUM,U1,U2,SS,SM,T1,MUEN,SIGMAN,YG,PG,PISUM,LIK,t,n,S,YGYG,
\t\tYGT,YG0,YG1,SY0Y0,SY1Y1,SY1Y,SY1X,lcalt,lc,ZI,YI,XI},

PP =P P;
PQ =P Q;
NT =N T;
NPP=1+N-NP;

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
          V,ASTERN,BSTERN,SIGMA,MUE} = ABL01[THETA,DT,NONLIN];
V1=Inverse[V];
SIGMA1=Inverse[SIGMA];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];

U1=Length[THETA];
U2=Length[PHI];
SM=Array[0&,{U2}];
T1=T+1;
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose; 
SIGMAN=(Array[1&,{NP}] /. 1->SIGMA);

{YG,PG,PISUM,LIK} = 
\tMGLATT5[Z,X,ASTERN,BSTERN,V,MUEN,SIGMAN,H,D,R,N,T,MISS,LC];
\t
    (*YGYG = Sum[YG[[i]].Transpose[YG[[i]]],{i,T1}];*)
YGYG = product[YG];\t
\t
PGSUM=Sum[PG[[i,j]],{i,T1},{j,NP}];
YGYG =YGYG + NPP PGSUM;   (* Summe E[Y|Z] E[Y|Z]` + Cov[Y,Y|Z] *)
YGT  =YG[[T1]];
YG0  =YG[[1]];
YG1  =Drop[YG,1];
SY0Y0=YG0.Transpose[YG0] + NPP Sum[PG[[1,n]],{n,1,NP}]; 
SY1Y1=YGYG - SY0Y0;

SY1Y =product[YG1,Drop[YG,-1]] + NPP PISUM;\t\t
SY1X =product[YG1,Drop[ X,-1]];
SYY  =YGYG - YGT.Transpose[YGT] - NPP Sum[PG[[T1,n]],{n,1,NP}];
SYX  =product[Drop[YG,-1],Drop[ X,-1]];
   
If[PHI =!= {},

lcalt = {};
If[ NP==1,
\t(* ALLE N SIMULTAN *)
\tDo[  
      {t} = messindT[[i]];
      lc = LC[[t,1]];
      If[lc != lcalt,{HNT,DNT,RNT,R1,DHNT,DDNT,DRNT} = 
      \t\t\t\t\t\t\t\t  KOMPNT[H,D,R,DH,DD,DR,K,P,Q,lc] ];
      ZI =Z[[t,lc,N//Range]];
      YI =YG[[t,P//Range,N//Range]];
      XI =X[[t,Q//Range,N//Range]];
      ZZ =ZI.Transpose[ZI];
      ZY =ZI.Transpose[YI];
      ZX =ZI.Transpose[XI];
      YY =YI.Transpose[YI] + N PG[[t,1]];
      YX =YI.Transpose[XI];
      XX =XI.Transpose[XI];
\t  {RDACH,H1,H2,H3} = VDACH[HNT,DNT,{ZZ,ZY,ZX,YY,YX,XX}];
      \t     
\t  SM += -.5 DRNT.Flatten[R1.(N RNT-RDACH).R1]
           \t  + DHNT.Flatten[R1.H2]
           \t  + DDNT.Flatten[R1.H3];

      lcalt = lc;
      
\t,{i,1,Length[messindT]}]
\t
,(*ELSE*)

\tDo[ 
      \t{t,n} = messindTN[[i]];
      \tlc = LC[[t,n]];
     \t 
      \tIf[lc != lcalt, {HNT,DNT,RNT,R1,DHNT,DDNT,DRNT} = 
     \t\t  \t\t\t\t\t\t  KOMPNT[H,D,R,DH,DD,DR,K,P,Q,lc] ];
     \tZI = Z[[t,lc,n]];
     \tYI =YG[[t,P//Range,n]];
     \tXI = X[[t,Q//Range,n]];
     \tZZ =Outer[Times,ZI,ZI];
     \tZY =Outer[Times,ZI,YI];
     \tZX =Outer[Times,ZI,XI];
      \tYY =Outer[Times,YI,YI] + PG[[t,n]];
      \tYX =Outer[Times,YI,XI];
\t\tXX =Outer[Times,XI,XI];
\t
        {RDACH,H1,H2,H3} = VDACH[HNT,DNT,{ZZ,ZY,ZX,YY,YX,XX}];

      \tSM += -.5 DRNT.Flatten[R1.(RNT-RDACH).R1]
           \t\t+ DHNT.Flatten[R1.H2]
           \t\t+ DDNT.Flatten[R1.H3];

     \tlcalt = lc;
      
\t,{i,Length[messindTN]}]
];

]; (* End If[PHI =!= {} *)
  
(* MOMENTE DER AB.*)

SY0  = Sum[YG0[[P//Range,n]],{n,N}];
S0   = -Outer[Times,SY0,MUE];
S0   = S0 + Transpose[S0] + SY0Y0 + N Outer[Times,MUE,MUE];

{vd,H1,H2,H3} =  VDACH[ASTERN,BSTERN,{SY1Y1,SY1Y,SY1X,SYY,SYX,SXX}];

 SS=  -   .5 DVDTH.Flatten[V1.(NT V - vd).V1]
      +     DASDTH.Flatten[V1.H2]
      +     DBSDTH.Flatten[V1.H3]
      - .5*DSIGDTH.Flatten[SIGMA1.(N SIGMA-S0).SIGMA1]
      +    DMUEDTH.SIGMA1.(SY0-N MUE);
      
If[PHI =!= {}, S=Join[SS,SM], S=SS];

{S,LIK} ]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
product[y_]:= Module[{y1,t,p,n},
(***************************************************************)
\t\t{t,p,n} = y//Dimensions;
\t\ty1 = Partition[Flatten[Transpose[y,{1,3,2}]],p];
        Transpose[y1].y1 ]
(***************************************************************)
product[y_,x_]:= Module[{y1,t,p,n,q},
(***************************************************************)
\t\t{t,p,n} = y//Dimensions;
\t\t{t,q,n} = x//Dimensions;
\t\ty1 = Partition[Flatten[Transpose[y,{1,3,2}]],p];
\t\tx1 = Partition[Flatten[Transpose[x,{1,3,2}]],q];
        Transpose[y1].x1 ]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
score[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,T_,DT_,NONLIN_]:=
(***************************************************************)

Module[{PP,PQ,NT,NPP,OMEGA,A,B,SIGMA,MUE,DVDTH,DASDTH,DBSDTH,DSIGDTH,
\t\tDMUEDTH,V,ASTERN,BSTERN,V1,SIGMA1,R,H,D,DR,DH,DD,RSUM,HSUM,
\t\tDSUM,U1,U2,SS,SM,T1,MUEN,SIGMAN,YG,PG,PISUM,LIK,t,n,S,YGYG,
\t\tYGT,YG0,SY0Y0,SY1Y1,SY1Y,SY1X},

NT =N T;
NT1=NT + N;
T1 =T+1;

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];  
{DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
          V,ASTERN,BSTERN,SIGMA,MUE} = ABL01[THETA,DT,NONLIN];
          
V1=Inverse[V];
SIGMA1=Inverse[SIGMA];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];
R1 = Inverse[R];

MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose; 
SIGMAN={SIGMA};
(*
{YG,PG,PISUM,LIK} = GLATT5X[Z,X,ASTERN,BSTERN,V,MUEN,SIGMAN,H,D,R,N,T];
*)\t
(*Print[\"vor GlattDeJong5\"];*)
{YG,PG,PISUM,LIK} = GlattDeJong5[MUEN,SIGMAN,Z,X,ASTERN,BSTERN,V,H,D,R,N,T];

\t(* YGYG = Sum[YG[[i]].Transpose[YG[[i]]],{i,T1}]; *)
    (* YGYG = Apply[Plus,MapThread[Dot,{YG, Transpose[YG,{1,3,2}]  }] ];*)
\t(* Summe YG[[i]].Transpose[YG[[i]] ]: pxp *)
\t
YGYG = product[YG];\t
PGSUM= Sum[PG[[i,1]],{i,T1}];
YGYG = YGYG + N PGSUM;   (* Summe E[Y|Z] E[Y|Z]` + Cov[Y,Y|Z] *)
YGT  = YG[[T1]];
XT   =  X[[T1]];
YG0  = YG[[1]];
YG1  = Drop[YG,1];

SY0Y0= YG0.Transpose[YG0] + N PG[[1,1]]; 
SY1Y1= YGYG - SY0Y0;

SY1Y = product[YG1,Drop[YG,-1]] + N PISUM;\t\t
SY1X = product[YG1,Drop[ X,-1]]; 
SYY  = YGYG - YGT.Transpose[YGT] - N PG[[T1,1]] ;
SYX  = product[YG,X];
SYX1 = SYX - YGT.Transpose[XT];
 
If[PHI =!= {},
\tSZZ  = product[Z]; 
\tSZY  = product[Z,YG];
\tSZX  = product[Z,X];
\t
\tSXX1 = SXX +  XT.Transpose[XT];
\t{RDACH,H1,H2,H3} = VDACH[H,D,{SZZ,SZY,SZX,YGYG,SYX,SXX1}];
      \t     
\tSM =  -.5  DR.Flatten[R1.(NT1 R - RDACH).R1]
\t         + DH.Flatten[R1.H2]
 \t         + DD.Flatten[R1.H3];
]; 
 
(* MOMENTE DER AB.*)

SY0  = Sum[YG0[[P//Range,n]],{n,N}];
S0   = -Outer[Times,SY0,MUE];
S0   = S0 + Transpose[S0] + SY0Y0 + N Outer[Times,MUE,MUE];

{vd,H1,H2,H3} =  VDACH[ASTERN,BSTERN,{SY1Y1,SY1Y,SY1X,SYY,SYX1,SXX}];

 SS=  -    .5 DVDTH .Flatten[V1.(NT V - vd).V1]
      +       DASDTH.Flatten[V1.H2]
      +       DBSDTH.Flatten[V1.H3]
      -    .5 DSIGDTH.Flatten[SIGMA1.(N SIGMA-S0).SIGMA1]
      +       DMUEDTH.SIGMA1.(SY0-N MUE);

If[PHI =!= {}, S=Join[SS,SM], S=SS];

{S,LIK} ]
\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
MISSHES1[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,NP_,T_,DT_,INC_,
\t\t \t\t\t\tNONLIN_,MISS_,{LC_,messindTN_,messindT_}] :=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT ANALYTISCHEM SCORE:  *)
(* ZENTRALE DIFFERENZEN                             *)
(*  S(PSI,Z) = E[S(THETA)//S(PHI)|Z]                *)
(* VORSICHT: E(H) = -E(SS`) = -F !!!\t\t\t\t*)

Module[{S,H,LIK,PSI,psi,U,U1,U2,INK,INC1,SNUM,UP,DO,THUP,PHUP,DS},

{S,LIK} = MISSCORE[THETA,PHI,Z,X,SXX,K,P,Q,N,NP,T,DT,NONLIN,
\t\t  \t\t\t\t\t\t\t\t  MISS,{LC,messindTN,messindT}];
PSI={THETA,PHI};
psi = PSI//Flatten;
U = Length[psi];
U1 = Length[THETA];
U2 = Length[PHI];

INK=INC Abs[psi];
INC1=.5/INK;
H = {}; SNUM = {};

Do[
    UP=psi;
    DO=psi;
    UP[[I]] = UP[[I]]+INK[[I]] ;
    DO[[I]] = DO[[I]]-INK[[I]] ;
    {THUP,PHUP} = {Take[UP,U1],Take[UP,-U2]};
    {THDO,PHDO} = {Take[DO,U1],Take[DO,-U2]};
    
    {SUP,LIKUP} = MISSCORE[THUP,PHUP,Z,X,SXX,K,P,Q,N,NP,T,DT,
    \t\t\t\t\t\t\t\tNONLIN,MISS,{LC,messindTN,messindT}];
    {SDO,LIKDO} = MISSCORE[THDO,PHDO,Z,X,SXX,K,P,Q,N,NP,T,DT,
    \t\t\t\t\t\t\t\tNONLIN,MISS,{LC,messindTN,messindT}];
    H = Append[H,(SUP-SDO) INC1[[I]] ];
    SNUM = Append[SNUM,(LIKUP-LIKDO) INC1[[I]]  ];
,{I,1,U}];

H = .5(H + Transpose[H]);
DS = S-SNUM;
Print[ \"KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN\"];
Print[MatrixForm[{SNUM, S, DS, psi, INK }//Transpose,
\tTableHeadings->{Automatic,{\"SNUM\",\"S\",\"DS\",\"PSI\",\"INK\"}}]];
{S,H,LIK}]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
HESSE[THETA_,PHI_,Z_,X_,SXX_,K_,P_,Q_,N_,T_,DT_,INC_,NONLIN_] :=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT ANALYTISCHEM SCORE:  *)
(* ZENTRALE DIFFERENZEN                             *)
(*  S(PSI,Z) = E[S(THETA)//S(PHI)|Z]                *)
(* VORSICHT: E(H) = -E(SS`) = -F !!!\t\t\t\t*)

Module[{S,LIK,PSI,psi,U,U1,U2,INK,INC1,H,SNUM,UP,DO,THUP,PHUP,THDO,PHDO,
\t\tSUP,LIKUP,SDO,LIKDO,I},

{S,LIK} = score[THETA,PHI,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];
PSI={THETA,PHI};
psi = PSI//Flatten;
U = Length[psi];
U1 = Length[THETA];
U2 = Length[PHI];

INK=INC Abs[psi];
INC1=.5/INK;
H = {}; SNUM = {};

Do[
    UP=psi;
    DO=psi;
    UP[[I]] = UP[[I]]+INK[[I]] ;
    DO[[I]] = DO[[I]]-INK[[I]] ;
    {THUP,PHUP} = {Take[UP,U1],Take[UP,-U2]};
    {THDO,PHDO} = {Take[DO,U1],Take[DO,-U2]};
    {SUP,LIKUP} = score[THUP,PHUP,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];
    {SDO,LIKDO} = score[THDO,PHDO,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];
    H = Append[H,(SUP-SDO) INC1[[I]] ];
    SNUM = Append[SNUM,(LIKUP-LIKDO) INC1[[I]]  ];
,{I,1,U}];

H = .5(H + Transpose[H]);
DS = S-SNUM;
Print[ \"KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN\"];
Print[MatrixForm[{SNUM, S, DS, psi, INK }//Transpose,
\tTableHeadings->{Automatic,{\"SNUM\",\"S\",\"DS\",\"PSI\",\"INK\"}}]];
{S,H,LIK}]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)\t\
\t\t 
MSCNUM[THETA_,PHI_,Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,
\t\t\t\t\t\t\t\t\t     INC_,NONLIN_,MISS_,LC_]:=
(***************************************************************)\t\t\t 
(* NUMERISCHER SCORE (MIT MISSING DATA) *)
Module[{i,PSI,PSII,LIK,LIKI,SNUM,u1},
PSI={THETA,PHI};
u1=Length[THETA];
u2=Length[PHI];
{LIK} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSI,NONLIN,MISS,LC];
INC1=1/INC;
SNUM = {};
Do[ 
    PSII=PSI//Flatten;
    PSII[[i]]=PSII[[i]]+INC;
    PSII = {Take[PSII,u1],Take[PSII,-u2]};
    
    {LIKI} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSII,NONLIN,MISS,LC];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1]
    
  ,{i,Length[THETA]+Length[PHI]} ];
  
{SNUM,LIK}
]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)\t\
\t\t 
SCNUM[THETA_,PHI_,Z_,X_,K_,P_,Q_,N_,T_,DT_,INC_,NONLIN_]:=
(***************************************************************)\t\t\t 
(* NUMERISCHER SCORE (MIT MISSING DATA) *)
Module[{i,PSI,PSII,LIK,LIKI,SNUM,u1},
PSI={THETA,PHI};
u1=Length[THETA];
u2=Length[PHI];
{LIK} = LIKEX[Z,X,K,P,Q,N,T,DT,PSI,NONLIN];
INC1=1/INC;
SNUM = {};
Do[ 
    PSII=PSI//Flatten;
    PSII[[i]]=PSII[[i]]+INC;
    PSII = {Take[PSII,u1],Take[PSII,-u2]};
    
    {LIKI} = LIKEX[Z,X,K,P,Q,N,T,DT,PSII,NONLIN];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1]
    
  ,{i,Length[THETA]+Length[PHI]} ];
  
{SNUM,LIK}
]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
DELTA1[COV_,TH_,PHI_] := Module[
(***************************************************************)
(*DELTA-THEOREM*)
{m,OMEGA,A,B,SIGMA,MUE,DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH,
 STDA,STDB,STDO,STDMUE,STDSIG,STDH,STDD,STDR,K,P,Q,U1,U2,U,
 R,H,D,DR,DH,DD},
 
{OMEGA,A,B,SIGMA,MUE} = PAR[TH];
{DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH} = PARD[TH];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];

{P,Q}=Dimensions[B];
{K,P}=Dimensions[H];

U1=Length[TH];
U2=Length[PHI];
U = U1 + U2;
C11=COV[[U1//Range,U1//Range]];
C22=COV[[Range[U1+1,U],Range[U1+1,U]  ]];
STDA=STANDARD[DADTH,C11,P,P];
STDB=STANDARD[DBDTH,C11,P,Q];
STDO=STANDARD[DODTH,C11,P,P];
STDMUE=STANDARD[DMUEDTH,C11,P,1];
STDSIG=STANDARD[DSIGDTH,C11,P,P];
STDH=STANDARD[DH,C22,K,P];
STDD=STANDARD[DD,C22,K,Q];
STDR=STANDARD[DR,C22,K,K];
m = MatrixForm[#,TableHeadings->None]&;
Print[\"----------------------------------------------------------\"];
Print[\"DELTA-THEOREM\"];
Print[\"----------------------------------------------------------\"];
Print[\"GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN\"];
Print[\"A, B, OMEGA, SIGMA UND MUE\"];
Print[\"UND DER MESS-MODELL-MATRIZEN H, D UND R\"];
Print[\"----------------------------------------------------------\"];
Print[\" A     \",A//m,    \"   STDA   \",STDA//m];
Print[\"----------------------------------------------------------\"];
Print[\" B     \",B//m,    \"   STDB   \",STDB//m];
Print[\"----------------------------------------------------------\"];
Print[\"OMEGA  \",OMEGA//m,\"   STDO   \",STDO//m];
Print[\"----------------------------------------------------------\"];
Print[\"MUE    \",MUE//m,  \"   STDMUE \",STDMUE//m];
Print[\"----------------------------------------------------------\"];
Print[\"SIGMA  \",SIGMA//m,\"   STDSIG \",STDSIG//m];
Print[\"----------------------------------------------------------\"];
Print[\" H     \",H//m,    \"   STDH   \",STDH//m];
Print[\"----------------------------------------------------------\"];
Print[\" D     \",D//m,    \"   STDD   \",STDD//m];
Print[\"----------------------------------------------------------\"];
Print[\" R     \",R//m,    \"   STDR   \",STDR//m];


];\
\>", "Input",
  CellMargins->{{5, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{5, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
DELTA1[COV_,TH_,PHI_,LAMBDA_] := Module[
(***************************************************************)
(*DELTA-THEOREM*)
{m,OMEGA,A,B,SIGMA,MUE,DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH,
 STDA,STDB,STDO,STDMUE,STDSIG,STDH,STDD,STDR,K,P,Q,U1,U2,U,
 R,H,D,DR,DH,DD,CUTS,DCUTS},
 
{OMEGA,A,B,SIGMA,MUE} = PAR[TH];
{DODTH,DADTH,DBDTH,DSIGDTH,DMUEDTH} = PARD[TH];
{R,H,D} = PARM[PHI];
{DR,DH,DD} = PARMD[PHI];
CUTS  = PARCUT[LAMBDA];
DCUTS = PARCUTD[LAMBDA];

{P,Q}=Dimensions[B];
{K,P}=Dimensions[H];
KC = Length[CUTS//Flatten];

U1=Length[TH];
U2=Length[PHI];
U3=Length[LAMBDA];
U = U1 + U2 + U3;
C11=COV[[U1//Range,U1//Range]];
C22=COV[[Range[U1+1,U1+U2],Range[U1+1,U1+U2] ]];
C33=COV[[Range[U1+U2+1,U] ,Range[U1+U2+1,U]  ]];

STDA=STANDARD[DADTH,C11,P,P];
STDB=STANDARD[DBDTH,C11,P,Q];
STDO=STANDARD[DODTH,C11,P,P];
STDMUE=STANDARD[DMUEDTH,C11,P,1];
STDSIG=STANDARD[DSIGDTH,C11,P,P];
STDH=STANDARD[DH,C22,K,P];
STDD=STANDARD[DD,C22,K,Q];
STDR=STANDARD[DR,C22,K,K];
STDCUTS=STANDARD[DCUTS,C33,KC,1];

m = MatrixForm[#,TableHeadings->None]&;
Print[\"----------------------------------------------------------\"];
Print[\"DELTA-THEOREM\"];
Print[\"----------------------------------------------------------\"];
Print[\"GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN\"];
Print[\"A, B, OMEGA, SIGMA UND MUE\"];
Print[\"UND DER MESS-MODELL-MATRIZEN H, D UND R\"];
Print[\"----------------------------------------------------------\"];
Print[\" A     \",A//m,    \"   STDA   \",STDA//m];
Print[\"----------------------------------------------------------\"];
Print[\" B     \",B//m,    \"   STDB   \",STDB//m];
Print[\"----------------------------------------------------------\"];
Print[\"OMEGA  \",OMEGA//m,\"   STDO   \",STDO//m];
Print[\"----------------------------------------------------------\"];
Print[\"MUE    \",MUE//m,  \"   STDMUE \",STDMUE//m];
Print[\"----------------------------------------------------------\"];
Print[\"SIGMA  \",SIGMA//m,\"   STDSIG \",STDSIG//m];
Print[\"----------------------------------------------------------\"];
Print[\" H     \",H//m,    \"   STDH   \",STDH//m];
Print[\"----------------------------------------------------------\"];
Print[\" D     \",D//m,    \"   STDD   \",STDD//m];
Print[\"----------------------------------------------------------\"];
Print[\" R     \",R//m,    \"   STDR   \",STDR//m];
Print[\"----------------------------------------------------------\"];
Print[\" CUTS  \",CUTS//Spalte//m, \"   STDCUTS   \",STDCUTS//m];


];\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)\t\
\t\t 
BFGSUP[F_,SNEU_,S_,STEP_] := Module[{ETA,MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)\t\t\t 
ETA = 10^-4; (*NOISE LEVEL*)
MACHEPS2 = 10.^-8;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < ETA, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print[\"*BFGSUP \", A,\"  \", B];
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]\
\>", "Input",
  CellMargins->{{3, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{1, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
BFGSUP[IdentityMatrix[4],{1.001,2,3,4},{1,2,3,4},{0.01,0,0,0}]//\
MatrixForm\
\>", "Input",
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{7, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
MatrixForm[{{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, \
0}, {0, 0, 0, 1}}]\
\>", "\<\
    1 2 3 4

1   1 0 0 0
2   0 1 0 0
3   0 0 1 0
4   0 0 0 1\
\>"], "Output",
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{7, Inherited}, {Inherited, Inherited}},
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
(***************************************************************)\t\
\t\t 
MBFGS[THETA0_,PHI0_,F0_,KMAX_,EPS_,Z_,X_,K_,P_,Q_,N_,NP_,T_,DT_,
\t\tOPTION_,NONLIN_,MISS_,PRINT_] := 
(***************************************************************)\t\t\t 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,SXX,u1,u2,U,PSI0,PSI,F,
        S,LIKALT,SNUM,LIKLIK,LIKI,psii,psi,STEPL,STEP,psi1,PSI1,
        LIKNEU,SNEU,likpsi,I,COV,k,THETA,PHI,LIKELI},
INC=10.^-5;
MAXSTEP=10.^1;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;

SXX=Sum[X[[i]].Transpose[X[[i]] ],{i,T}];

If[PRINT[[1]] == 1,
Print[\"***********************LSDE1**********************************\"];
Print[\"***********************MODUL: MBFGS***************************\"];
Print[\"**************************************************************\"];
Print[\"Technical Output\"];
VecPrint[{KMAX,EPS,K,P,Q,N,NP,T,DT,OPTION,NONLIN,MISS,MAXSTEP,
\t\t  MINSTEP,BOUND}//Spalte,
         {\"KMAX\",\"EPS\",\"K\",\"P\",\"Q\",\"N\",\"NP\",\"T\",\"DT\",\"\
OPTION\",\"NONLIN\",
         \"MISS\",\"MAXSTEP\",\"MINSTEP\",\"BOUND\"}];
Print[ \"\"];
Print[ \"STARTWERT THETA0 = \", THETA0];
Print[ \"STARTWERT PHI0   = \", PHI0];
];

u1 = Length[THETA0];
u2 = Length[PHI0];
U = u1+u2;

PSI0={THETA0,PHI0};
PSI=PSI0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{LC,messindTN,messindT} = analyze[Z,MISS];


{S,LIKALT} = MISSCORE[ THETA0,PHI0,Z,X,SXX,K,P,Q,N,NP,T,DT,NONLIN,
\t\t\t\t\t   MISS,{LC,messindTN,messindT}];

{SNUM,LIKLIK} = MSCNUM[THETA0,PHI0,Z,X,K,P,Q,N,NP,T,DT,10.^-8,
\t\t\t\t\t\tNONLIN,MISS,LC];
\t\t\t\t\t
Print[\"KONTROLLE\",MatrixForm[{SNUM,S,S-SNUM}//Transpose,
\t\tTableHeadings->{Automatic,{\"SNUM\",\"S\",\"DS\"}}]];
Print[\"Likelihoods  \",LIKALT,\"  \",LIKLIK];

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,

\tIf[PRINT[[2]] == 1, 
\tPrint[\"-----------------------------------------------------------------\"]\
;
    Print[\"MBFGS: Iteration = \",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psi = PSI//Flatten;
    psii=Append[psii,psi];
    
 \tSTEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-HALVING*)
   
    psi1 = psi + STEP;   (*VOLLER NEWTON-STEP*)
    PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
    {LIKNEU} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSI1,NONLIN,MISS,LC];
   
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          \t\t\t\t Max[Abs[STEP]]>MINSTEP),
         STEP=STEP*.5;
         psi1 = psi + STEP;
         PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
         {LIKNEU} = MLIKEX[Z,X,K,P,Q,N,NP,T,DT,PSI1,NONLIN,MISS,LC];
         
         If[PRINT[[3]] == 1,
         Print[\"STEP-HALVING:  \",half,
         \t\t\t\"  LIKNEU  \", PaddedForm[LIKNEU,{20,15}],
         \t\t\t\"  LIKALT  \", PaddedForm[LIKALT,{20,15}]];
         ];
         
     ]; (*End DoWhile*)
     
\tIf[PRINT[[4]] == 1,
\tPrint[\"\"]; 
    Print[\"LIKNEU  \", PaddedForm[LIKNEU,{20,15}],\"      \",
          \"LIKALT  \", PaddedForm[LIKALT,{20,15}] ];
    
    Print[\"LIKNEU - LIKALT  \", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    If[PRINT[[5]] == 1,
    Print[\"\"]; 
    Print[TableForm[{psi1,psi,STEP,S}//Transpose,
                     TableDirections\[Rule]Column,
                     TableSpacing\[Rule]Automatic,
    \t             TableHeadings->{Automatic,{\"PSI1\",\"PSI\",\"STEP\",\"\
SCORE\"}}]];
    ];
    
    If[PRINT[[6]] == 1,
    Print[\"Fisher Information\"];
    MatPrint[F];
    ];
    
    {THETA,PHI}=PSI1;
    {SNEU,LIKALT} = MISSCORE[THETA,PHI,Z,X,SXX,K,P,Q,N,NP,T,DT,NONLIN,
\t\t\t\t\t   \t\t\t\t\t MISS,{LC,messindTN,messindT}];
    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S=SNEU;
    
    PSI=PSI1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ \"MBFGS:  ENDE DER ITERATION  \",k,\"  \",KMAX];
];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,PSI//Flatten];
likpsi = Spalte[LIKI] ~ii~ psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
\t\t\t\t\tTableHeadings->{Automatic,{\"Likelihood\",\"PSI\"}}]];
];
\t\t\t\t\t
{THETA,PHI}=PSI;

If[Fisher,
\tDo[
\t
\tINC=10.^(-I);
\tPrint[\"INKREMENT   \", INC];
\t{S,F,LIKELI} = MISSHES1[THETA,PHI,Z,X,SXX,K,P,Q,N,NP,T,DT,INC,
\t\t\t\t\t\t\t\t\tNONLIN,MISS,{LC,messindTN,messindT}];
\tF=-F;
\tCOV = OUTPUT[PSI//Flatten,F,.05,S,LIKELI];
\tLKOMP[LIKELI,U,N*(T+1)];
\tDELTA1[COV,THETA,PHI];
\t
\t,{I,6,6}];
\t
,(* else *)
\tCOV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,PHI,COV,likpsi,k}
]
\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
MAXSTEP=10.^0;
STEPREDUCE=4;

(***************************************************************)\t\t\t 
BFGS[THETA0_,PHI0_,F0_,KMAX_,EPS_,Z_,X_,K_,P_,Q_,N_,T_,DT_,
\t\tOPTION_,NONLIN_,PRINT_,NUMABL_:0] := 
(***************************************************************)\t\t\t 
Module[{INC,MINSTEP,BOUND,ALPHA,SXX,u1,u2,U,PSI0,PSI,F,
        S,LIKALT,SNUM,LIKLIK,LIKI,psii,psi,STEPL,STEP,psi1,PSI1,
        LIKNEU,SNEU,likpsi,I,COV,k,THETA,PHI,LIKELI,MISS,NP},
INC=10.^-5;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;

SXX=Sum[X[[i]].Transpose[X[[i]] ],{i,T}];

If[PRINT[[1]] == 1,
Print[\"***********************LSDE1**********************************\"];
Print[\"***********************MODUL: BFGS***************************\"];
Print[\"**************************************************************\"];
Print[\"Technical Output\"];
VecPrint[{KMAX,EPS,K,P,Q,N,T,DT}//Spalte,
         {\"KMAX\",\"EPS\",\"K\",\"P\",\"Q\",\"N\",\"T\",\"DT\"}];
Print[ \"\"];
VecPrint[{OPTION,NONLIN,MAXSTEP,MINSTEP,BOUND}//Spalte,
         {\"OPTION\",\"NONLIN\",\"MAXSTEP\",\"MINSTEP\",\"BOUND\"}];
Print[ \"\"];
VecPrint[{STEPREDUCE,NUMABL}//Spalte,
         {\"STEPREDUCE\",\"NUMABL\"}];
Print[ \"\"];
Print[ \"STARTWERT THETA0 = \", THETA0];
Print[ \"STARTWERT PHI0   = \", PHI0];
];

u1 = Length[THETA0];
u2 = Length[PHI0];
U = u1+u2;

PSI0={THETA0,PHI0};
PSI=PSI0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = score[ THETA0,PHI0,Z,X,SXX,K,P,Q,N,T,DT,NONLIN];

INC = $MachineEpsilon//Sqrt;
{SNUM,LIKLIK} = SCNUM[THETA0,PHI0,Z,X,K,P,Q,N,T,DT,INC,NONLIN];

Print[\"KONTROLLE, INC = \",INC];
Print[MatrixForm[{SNUM,S,S-SNUM}//Transpose,
\t\tTableHeadings->{Automatic,{\"SNUM\",\"S\",\"DS\"}}]];
Print[\"Likelihoods  \",LIKALT,\"  \",LIKLIK];

If[NUMABL==1,S=SNUM];

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,

\tIf[PRINT[[2]] == 1, 
\tPrint[\"-----------------------------------------------------------------\"]\
;
    Print[\"BFGS: Iteration = \",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psi = PSI//Flatten;
    psii=Append[psii,psi];
    
 \tSTEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-HALVING*)
   
    psi1 = psi + STEP;   (*VOLLER NEWTON-STEP*)
    PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
    {LIKNEU} = LIKEX[Z,X,K,P,Q,N,T,DT,PSI1,NONLIN];
    
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          \t\t\t\t Max[Abs[STEP]]>MINSTEP),
         STEP=STEP/STEPREDUCE;
         psi1 = psi + STEP;
         PSI1 = {Take[psi1,u1],Take[psi1,-u2]};
         {LIKNEU} = LIKEX[Z,X,K,P,Q,N,T,DT,PSI1,NONLIN];
         
         If[PRINT[[3]] == 1,
         Print[\"STEP-HALVING:  \",half,
         \t\t\t\"  LIKNEU  \", PaddedForm[LIKNEU,{20,15}],
         \t\t\t\"  LIKALT  \", PaddedForm[LIKALT,{20,15}]];
         ];
         
     ]; (*End DoWhile*)
     
    If[PRINT[[4]] == 1, 
\tPrint[\"\"];
    Print[\"LIKNEU  \", PaddedForm[LIKNEU,{20,15}],\"      \",
          \"LIKALT  \", PaddedForm[LIKALT,{20,15}] ];
    Print[\"LIKNEU - LIKALT  \", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    
    If[PRINT[[5]] == 1,
    Print[\"\"]; 
    Print[TableForm[{psi1,psi,STEP,S}//Transpose,
                     TableDirections\[Rule]Column,
                     TableSpacing\[Rule]Automatic,
    \t             TableHeadings->{Automatic,{\"PSI1\",\"PSI\",\"STEP\",\"\
SCORE\"}}]];
    ];
    
    If[PRINT[[6]] == 1, 
    Print[\"Fisher Information\"];
    MatPrint[F];
    ]; 
     
    {THETA,PHI}=PSI1;
    
    If[NUMABL==0,

    {SNEU,LIKALT}= score[THETA,PHI,Z,X,SXX,K,P,Q,N,T,DT,NONLIN],
    
    {SNEU,LIKALT} = SCNUM[THETA,PHI,Z,X,K,P,Q,N,T,DT,INC,NONLIN]
    ];

    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S=SNEU;
    
    PSI=PSI1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ \"MBFGS:  ENDE DER ITERATION  \",k,\"  \",KMAX];
];
LIKI = Append[LIKI,LIKALT]; psii = Append[psii,PSI//Flatten];
likpsi = Spalte[LIKI] ~ii~ psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
\t\tTableHeadings->{Automatic,{\"Likelihood\",\"PSI\"}}]];
];
\t\t\t\t\t
{THETA,PHI}=PSI;

If[Fisher,
\tDo[
\tINC=10.^(-I);
\tINC = $MachineEpsilon^(1/3);
\tPrint[\"INKREMENT   \", INC];
\t{S,F,LIKELI} = HESSE[THETA,PHI,Z,X,SXX,K,P,Q,N,T,DT,INC,NONLIN];
\tF=-F;
\tCOV = OUTPUT[PSI//Flatten,F,.05,S,LIKELI];
\tLKOMP[LIKELI,U,N*(T+1)];
\tDELTA1[COV,THETA,PHI];
\tu1 = THETA//Length//Range;
\tDELTASTERN[COV[[u1,u1]],THETA,DT,NONLIN];
\t
\t,{I,6,6}];

,(* else *)
\tCOV = Inverse[F];
];

{THETA,PHI,COV,likpsi,k}

]\
\>", "Input",
  CellMargins->{{4, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{692, 693},
WindowMargins->{{Automatic, 14}, {Automatic, 10}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
0000001804P000000bd2=_oaoo43?095o`85N@?NW0002008ool000001@050001
0000I24A4R060`410@000BL?0040000000000000000004E3<34100;o00000001
000A0S<R<3`00Q3400018NOWinOWia4A\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 116, 7, 72, "Input",
  InitializationCell->True],
Cell[1873, 60, 234, 8, 87, "Input",
  InitializationCell->True],
Cell[2110, 70, 168, 6, 42, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[2303, 80, 334, 8, 57, "Input",
  InitializationCell->True],
Cell[2640, 90, 692, 18, 222, "Input",
  InitializationCell->True],
Cell[3335, 110, 608, 15, 177, "Input",
  InitializationCell->True]
}, Open  ]],
Cell[3958, 128, 173, 9, 117, "Input"],

Cell[CellGroupData[{
Cell[4156, 141, 171, 6, 72, "Input"],
Cell[4330, 149, 337, 9, 24, "Output"],
Cell[4670, 160, 211, 8, 24, "Output"],
Cell[4884, 170, 569, 13, 36, "Output"],
Cell[5456, 185, 429, 23, 204, "Output"]
}, Open  ]],
Cell[5900, 211, 562, 17, 222, "Input",
  InitializationCell->True],
Cell[6465, 230, 2007, 70, 1002, "Input",
  InitializationCell->True],
Cell[8475, 302, 1818, 71, 1017, "Input",
  InitializationCell->True],
Cell[10296, 375, 1730, 70, 1002, "Input",
  InitializationCell->True],
Cell[12029, 447, 2708, 95, 1377, "Input",
  InitializationCell->True],
Cell[14740, 544, 1086, 43, 567, "Input",
  InitializationCell->True],
Cell[15829, 589, 1391, 54, 744, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[17245, 647, 60, 1, 27, "Input"],
Cell[17308, 650, 875, 17, 218, "Print"]
}, Open  ]],
Cell[18198, 670, 929, 26, 327, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[19152, 700, 943, 33, 432, "Input",
  InitializationCell->True],
Cell[20098, 735, 174, 4, 34, "Message"]
}, Open  ]],
Cell[20287, 742, 1090, 38, 507, "Input",
  InitializationCell->True],
Cell[21380, 782, 762, 23, 312, "Input",
  InitializationCell->True],
Cell[22145, 807, 1604, 62, 912, "Input",
  InitializationCell->True],
Cell[23752, 871, 2453, 90, 1302, "Input",
  InitializationCell->True],
Cell[26208, 963, 953, 29, 372, "Input",
  InitializationCell->True],
Cell[27164, 994, 726, 23, 312, "Input",
  InitializationCell->True],
Cell[27893, 1019, 1567, 55, 789, "Input",
  InitializationCell->True],
Cell[29463, 1076, 988, 42, 582, "Input",
  InitializationCell->True],
Cell[30454, 1120, 1407, 56, 807, "Input",
  InitializationCell->True],
Cell[31864, 1178, 505, 12, 132, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[32394, 1194, 245, 7, 42, "Input",
  InitializationCell->True],
Cell[32642, 1203, 262, 8, 24, "Output",
  InitializationCell->True],
Cell[32907, 1213, 180, 7, 24, "Output",
  InitializationCell->True]
}, Open  ]],
Cell[33102, 1223, 683, 21, 252, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[33810, 1248, 204, 7, 72, "Input"],
Cell[34017, 1257, 2335, 40, 216, "Output"]
}, Open  ]],
Cell[36367, 1300, 3815, 133, 1932, "Input",
  InitializationCell->True],
Cell[40185, 1435, 721, 17, 222, "Input",
  InitializationCell->True],
Cell[40909, 1454, 2590, 88, 1257, "Input",
  InitializationCell->True],
Cell[43502, 1544, 1772, 50, 687, "Input",
  InitializationCell->True],
Cell[45277, 1596, 1575, 46, 627, "Input",
  InitializationCell->True],
Cell[46855, 1644, 926, 30, 372, "Input",
  InitializationCell->True],
Cell[47784, 1676, 863, 29, 357, "Input",
  InitializationCell->True],
Cell[48650, 1707, 2413, 60, 837, "Input",
  InitializationCell->True],
Cell[51066, 1769, 2643, 68, 987, "Input",
  InitializationCell->True],
Cell[53712, 1839, 770, 23, 267, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[54507, 1866, 282, 7, 27, "Input",
  InitializationCell->True],
Cell[54792, 1875, 388, 15, 84, "Output",
  InitializationCell->True]
}, Open  ]],
Cell[55195, 1893, 4684, 168, 2397, "Input",
  InitializationCell->True],
Cell[59882, 2063, 4779, 177, 2574, "Input",
  InitializationCell->True]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

