(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    467878,      10634]*)
(*NotebookOutlinePosition[    468947,      10668]*)
(*  CellTagsIndexPosition[    468903,      10664]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Unprotect[In,Out]
Clear[In,Out]
MaxMemoryUsed[]
MemoryInUse[]
$Post = .
(*Share[]*)\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({}\)], "Output"],

Cell[BoxData[
    \(5179968\)], "Output"],

Cell[BoxData[
    \(4201468\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
?Global`*
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[GridBox[{
        {
          StyleBox["Global`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["A",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`A"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["G",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`G"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lik",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lik"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["omega02",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`omega02"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["rr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`rr"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THUP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THUP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["A0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`A0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIK",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIK"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Omega$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Omega$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RR"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["tree",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`tree"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["A1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`A1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lik0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lik0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OMEGA$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OMEGA$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["rr$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`rr$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Adapter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Adapter"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIK0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIK0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ON",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ON"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RR$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RR$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["T$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`T$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Alles",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Alles"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lik0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lik0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ON$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ON$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RSUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RSUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["u",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`u"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["alpha",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`alpha"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIK0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIK0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OPTION",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OPTION"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RSUM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RSUM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ALPHA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ALPHA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g3$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g3$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKALT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKALT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ORDER",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ORDER"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["r$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`r$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["u1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`u1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ALPHA$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ALPHA$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["g4",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g4"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKALT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKALT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Ostern",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Ostern"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["R$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`R$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["analyze",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`analyze"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["gain",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`gain"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKDO",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKDO"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OsternN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OsternN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["s",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`s"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["u1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`u1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["AP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`AP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["gain$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`gain$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKDO$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKDO$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OsternN$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OsternN$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["S",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`S"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["aprioriFilter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`aprioriFilter"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["gamma",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`gamma"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKELI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKELI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Ostern$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Ostern$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["S0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`S0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["u2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`u2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Astern",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Astern"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["glatt1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`glatt1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKELI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKELI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["out",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`out"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SCNUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SCNUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ASTERN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ASTERN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GLATT1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`GLATT1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKEX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKEX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OUT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OUT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["score",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`score"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["u2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`u2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Asterni",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Asterni"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["glatt2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`glatt2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["liki",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`liki"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["out$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`out$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SDO",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SDO"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Asterni$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Asterni$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GLATT5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`GLATT5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OUT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OUT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SDO$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SDO$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Astern$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Astern$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GLATT5X",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`GLATT5X"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKIdo",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKIdo"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["p",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`p"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["seed",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`seed"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["UP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`UP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ASTERN$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ASTERN$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GlattDeJong",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`GlattDeJong"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKIup",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKIup"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["P",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`P"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["sigma",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`sigma"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["UP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`UP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["A$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`A$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GlattDeJong5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`GlattDeJong5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["liki$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`liki$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["P0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`P0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SIGMA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SIGMA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["UU",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`UU"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["B",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`B"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GlattX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`GlattX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["P0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`P0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["sigma0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`sigma0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["UU$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`UU$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["beta",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`beta"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["graph",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`graph"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKLIK",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKLIK"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["P1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`P1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["sigma0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`sigma0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["u$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`u$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BFGS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BFGS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GRIDI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`GRIDI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKLIK$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKLIK$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["P1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`P1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SIGMA1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SIGMA1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["U$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`U$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BFGSUP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BFGSUP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["GRIDIJ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`GRIDIJ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKNEU",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKNEU"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["panel",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`panel"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SIGMA1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SIGMA1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["V",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`V"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Bl",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Bl"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["G$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`G$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKNEU$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKNEU$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PAR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PAR"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SigmaN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SigmaN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["V1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`V1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BOUND",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BOUND"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["h",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`h"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["likpsi",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`likpsi"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PARCUT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PARCUT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SIGMAN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SIGMAN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["V1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`V1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BOUND$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BOUND$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["likpsi$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`likpsi$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PARCUTD",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PARCUTD"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SIGMAN$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SIGMAN$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["var1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`var1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BPB",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BPB"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PARD",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PARD"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SIGMA$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SIGMA$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["var1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`var1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Bstern",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Bstern"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LikTest",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LikTest"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PARM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PARM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vd",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vd"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BSTERN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BSTERN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKUP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKUP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PARMD",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PARMD"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vi",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vi"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Bstern$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Bstern$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H4",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H4"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIKUP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIKUP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["period",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`period"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SNEU",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SNEU"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vi1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vi1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["BSTERN$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`BSTERN$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H4$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H4$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lik$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lik$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PF",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PF"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SNEU$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SNEU$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vi1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vi1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["B$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`B$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["half",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`half"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIK$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIK$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PF1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PF1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SNUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SNUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vint",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vint"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["C11",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`C11"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HESSE",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HESSE"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIMJ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIMJ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PFt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PFt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SNUM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SNUM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vint$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vint$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["C22",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`C22"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIMJM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIMJM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PF$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PF$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["vi$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`vi$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["C33",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`C33"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIMJM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIMJM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PG",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PG"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SS$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SS$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["V$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`V$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["cf",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`cf"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HJ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HJ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIMJ$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIMJ$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PG1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PG1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["x",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`x"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["cKF",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`cKF"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["hnt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`hnt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["linind",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`linind"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGalt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGalt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDA$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDA$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["X",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`X"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["cMLIKEX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`cMLIKEX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LiT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LiT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGalt$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGalt$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDB",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDB"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["X0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`X0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["conf1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`conf1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["hnt$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`hnt$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LiT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LiT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGn",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGn"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDB$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDB$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["X0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`X0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["conf1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`conf1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HNT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HNT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Li$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Li$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGneu",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGneu"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDCUTS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDCUTS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["x1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`x1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["conf2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`conf2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HSUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HSUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LM2I",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LM2I"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGneu$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGneu$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDD",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDD"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["X1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`X1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["conf2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`conf2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["HSUM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`HSUM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LM2I$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LM2I$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGSUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGSUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDD$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDD$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["X1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`X1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ConfidenceBand",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`ConfidenceBand"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["h$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`h$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["l$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`l$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PGt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PGt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["xi",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`xi"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["const",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`const"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["H$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`H$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["m",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`m"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PG$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PG$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["COV",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`COV"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["i",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`i"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MACHEPS2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MACHEPS2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHDO",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHDO"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDMUE",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDMUE"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Xi1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Xi1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["COV$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`COV$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["i1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`i1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MACHEPS2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MACHEPS2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHDO$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHDO$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDMUE$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDMUE$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Xii",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Xii"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["CUTS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`CUTS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["I1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`I1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MatPrint",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MatPrint"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDO",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDO"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Xint",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Xint"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["CUTS$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`CUTS$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["i1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`i1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MAXSTEP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MAXSTEP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHI0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHI0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDO$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDO$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XintPoly",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XintPoly"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["d",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`d"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["I2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`I2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MAXSTEP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MAXSTEP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["phi1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`phi1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDR"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XintSpline",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XintSpline"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DADTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DADTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["I3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`I3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MBFGS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MBFGS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["phi2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`phi2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDR$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDR$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Xint$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Xint$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DADTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DADTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["I4",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`I4"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MBiNonLinFilter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MBiNonLinFilter"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDSIG",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDSIG"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["xi$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`xi$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DASDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DASDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["I5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`I5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["messindT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`messindT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHUP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHUP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STDSIG$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STDSIG$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DASDTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DASDTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["id",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`id"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["messindTN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`messindTN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PHUP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PHUP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Step",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Step"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["data",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`data"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["IdPlusA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`IdPlusA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["messindTN$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`messindTN$"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["pi1i",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`pi1i"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STEP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STEP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XMr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XMr"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["data$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`data$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["id$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`id$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["messindT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`messindT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pi1i",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pi1i"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STEPL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STEPL"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XMr$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XMr$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DBDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DBDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ikh",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ikh"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MessUp5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MessUp5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["pi1in",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`pi1in"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STEPL$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STEPL$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DBDTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DBDTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ikh$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ikh$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MFilter5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MFilter5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pi1in",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pi1in"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["stepreduce",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`stepreduce"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["XX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`XX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DBSDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DBSDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INC",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INC"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MGLATT1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MGLATT1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["pi1in$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`pi1in$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STEPREDUCE",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STEPREDUCE"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["y",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`y"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DBSDTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DBSDTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INC1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INC1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MGLATT5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MGLATT5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pi1in$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pi1in$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["STEP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`STEP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DCUTS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DCUTS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INC1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INC1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MINSTEP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MINSTEP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["pi1i$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`pi1i$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DCUTS$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DCUTS$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INC$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INC$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MINSTEP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MINSTEP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pi1i$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pi1i$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SUM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SUM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DD",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DD"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INK",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INK"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["miss",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`miss"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pii",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pii"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SUP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SUP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["y1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`y1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DDNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DDNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INK2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INK2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MISS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MISS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Piin",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Piin"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SUP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SUP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DDNT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DDNT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INK2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INK2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MISSCORE",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MISSCORE"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Piin$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Piin$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SXX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SXX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["y1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`y1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DD$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DD$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INK$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INK$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MISSHES1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MISSHES1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pii$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pii$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SXX1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SXX1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DELTA1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DELTA1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["inn",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`inn"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MISS$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MISS$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pistern",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pistern"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SXX$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SXX$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["y2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`y2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["inno",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`inno"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MLIKEX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MLIKEX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Pistern$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Pistern$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DHNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DHNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Inno",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Inno"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinBFGS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinBFGS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PISUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PISUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY0Y0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY0Y0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["yf",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`yf"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DHNT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DHNT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["innocov",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`innocov"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinFilter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinFilter"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PISUM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PISUM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY0Y0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY0Y0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YF",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YF"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Innocov",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Innocov"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinGlatt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinGlatt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["plotrange",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`plotrange"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY1X",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY1X"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YF1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YF1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["diff",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`diff"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["innocov1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`innocov1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinGlattUp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinGlattUp"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["pp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`pp"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY1X$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY1X$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YFt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YFt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["diffusion",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`diffusion"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Innocov1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Innocov1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinHesse",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinHesse"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY1Y",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY1Y"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["yf$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`yf$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DMUEDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DMUEDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["innocov1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`innocov1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinLik",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MNonLinLik"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["pp$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`pp$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY1Y1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY1Y1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YF$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YF$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DMUEDTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DMUEDTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Innocov1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Innocov1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinLikn",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinLikn"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY1Y1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY1Y1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YG",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YG"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["dnt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`dnt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["innocov$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`innocov$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinMessup",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinMessup"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PQ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PQ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SY1Y$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SY1Y$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YG0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YG0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Innocov$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Innocov$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinScore",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinScore"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PQ$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PQ$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["system",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`system"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YG0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YG0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["dnt$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`dnt$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["inno$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`inno$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MNonLinScore2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`MNonLinScore2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PRINT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PRINT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SYX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SYX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YG1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YG1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DNT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DNT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Inno$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Inno$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MSCNUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MSCNUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["product",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`product"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SYX1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SYX1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YG1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YG1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DO",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DO"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["inn$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`inn$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["mue",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`mue"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Prozess",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Prozess"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SYY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SYY"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGalt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGalt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DODTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DODTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["INTERPOL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`INTERPOL"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MUE",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MUE"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["psi",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`psi"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SZX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SZX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGalt$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGalt$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DODTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DODTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["IP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`IP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["mue0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`mue0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SZY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SZY"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGneu",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGneu"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DO$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DO$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["IP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`IP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["mue0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`mue0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSI0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSI0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["SZZ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`SZZ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGneu$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGneu$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DR"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["i$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`i$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MueN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MueN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSI0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSI0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["S$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`S$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["drift",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`drift"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["j",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`j"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MUEN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MUEN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["psi1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`psi1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DRNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DRNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Jacobi",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Jacobi"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MUEN$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MUEN$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSI1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSI1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["T",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`T"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DRNT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DRNT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Jacobif",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Jacobif"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["MUE$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`MUE$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["psi1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`psi1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGYG",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGYG"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DR$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DR$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Jacobig",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Jacobig"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["m$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`m$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSI1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSI1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["T1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`T1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YGYG$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YGYG$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Jacobih",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Jacobih"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["n",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`n"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["psii",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`psii"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YG$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YG$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DSIGDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DSIGDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["j$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`j$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N10",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N10"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSII",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSII"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["T1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`T1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DSIGDTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DSIGDTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["k",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`k"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N16",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N16"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["psii$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`psii$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Yi1i",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Yi1i"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DSUM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DSUM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["KC",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`KC"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSII$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSII$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Yi1i$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Yi1i$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DSUM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DSUM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["KK",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`KK"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["psi$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`psi$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t3$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t3$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Yii",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Yii"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DS$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DS$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["KMAX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`KMAX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N4",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N4"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["PSI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`PSI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t4",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t4"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Yii$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Yii$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["dt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`dt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["KOMPNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`KOMPNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["p$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`p$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["konstant",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`konstant"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N6",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N6"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["P$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`P$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["t6",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`t6"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YMAX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YMAX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DVDTH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DVDTH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["k$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`k$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N7",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N7"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["q",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`q"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["tau",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`tau"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["DVDTH$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`DVDTH$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["l",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`l"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N8",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N8"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Q",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Q"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["tau1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`tau1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["d$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`d$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["L2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`L2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["N9",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`N9"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["qq",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`qq"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["tau2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`tau2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["YY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`YY"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["eps",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`eps"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["L2I",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`L2I"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NLTimeUp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NLTimeUp"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["q$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`q$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["tau3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`tau3"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Y$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Y$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["EPS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`EPS"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["L2I$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`L2I$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["nn",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`nn"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Q$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Q$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["tau3$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`tau3$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["z",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`z"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["eps$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`eps$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["L2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`L2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["nn$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`nn$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["r",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`r"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Tensor2Q",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Tensor2Q"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Z",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Z"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ETA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ETA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LAMBDA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LAMBDA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Nonlin",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Nonlin"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["R",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`R"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Tensor3Q",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Tensor3Q"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Z0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Z0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["ETA$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ETA$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lambda11",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lambda11"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NONLIN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NONLIN"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["R1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`R1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["TH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`TH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Z0$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Z0$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["f",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`f"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lambda12",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lambda12"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NonLinFilter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`NonLinFilter"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["R1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`R1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THDO",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THDO"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Z1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Z1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["F",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`F"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lambda21",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lambda21"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NonLinStateSpace",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`NonLinStateSpace"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["R2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`R2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THDO$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THDO$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Z1$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Z1$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["F0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`F0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lambda22",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lambda22"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["np",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`np"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["R2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`R2$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["theta",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`theta"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["zalphahalbe",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969799-9860654", 
                    "Global`zalphahalbe"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["filter1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`filter1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lc",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lc"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RDACH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RDACH"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Theta",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Theta"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ZI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ZI"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["filter2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`filter2"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LC",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LC"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NPP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NPP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ri",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ri"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THETA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THETA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Zi1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Zi1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Filter5",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Filter5"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lcalt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lcalt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NPP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NPP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Ri",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Ri"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THETA0",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THETA0"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ZI$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ZI$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["FilterX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`FilterX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lcalt$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lcalt$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["np$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`np$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Ripi1i",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Ripi1i"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THETA1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THETA1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ZM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ZM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Fisher",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Fisher"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["lc$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`lc$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Ripi1i$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Ripi1i$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Thetai",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Thetai"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["zmiss",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`zmiss"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["FSTEP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`FSTEP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LC$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LC$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ri$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ri$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Thetaido",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Thetaido"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["zmiss$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`zmiss$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["FSTEP$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`FSTEP$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Li",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Li"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NT1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NT1"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Ri$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Ri$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Thetaiup",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Thetaiup"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ZX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ZX"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Fup",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Fup"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIJ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIJ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["NT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`NT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["rnt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`rnt"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Thetai$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Thetai$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ZY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ZY"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["Fup$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Fup$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIJM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIJM"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["n$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`n$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RNT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RNT"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Theta$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Theta$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["ZZ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`ZZ"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["F$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`F$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIJM$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIJM$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Omega",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Omega"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["rnt$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`rnt$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THETA$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THETA$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["z$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`z$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]},
              {
                ButtonBox[
                  StyleBox["g",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`g"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["LIJ$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`LIJ$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["OMEGA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`OMEGA"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["RNT$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`RNT$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["THUP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`THUP"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"], 
                ButtonBox[
                  StyleBox["Z$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969799-9860654", "Global`Z$"},
                  ButtonFrame->"None",
                  ButtonNote->"Global`"]}
              },
            
            RowMinHeight->{
              1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
?code`Kronecker`*
?code`LSD`*
?code`PARTest`*

\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[GridBox[{
        {
          StyleBox["code`Kronecker`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["AddTimeAxis",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`AddTimeAxis"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["FlattenSymmetric1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`FlattenSymmetric1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Logit",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Logit"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Probit1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Probit1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["all",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`all"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["FlattenSymmetric2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`FlattenSymmetric2"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["lt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`lt"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["QQplot",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`QQplot"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["any",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`any"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["funk",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`funk"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MahalanobisDistanz",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MahalanobisDistanz"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["QQplot2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`QQplot2"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["APLExpand",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`APLExpand"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Gauss",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Gauss"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MatrixForm2List",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MatrixForm2List"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["RandomGauss",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`RandomGauss"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["autocorr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`autocorr"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["GaussC",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`GaussC"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MatrixTrace",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MatrixTrace"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["RandomMultinomial",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`RandomMultinomial"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Autokorr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Autokorr"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["GaussCumul",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`GaussCumul"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["max",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`max"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["RandomNumbers",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`RandomNumbers"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Autokorr1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Autokorr1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["GaussDichte",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`GaussDichte"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["max$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`max$"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Rank",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Rank"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Autokorr1M",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Autokorr1M"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["ge",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`ge"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["mean",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`mean"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["ReplaceColumns",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`ReplaceColumns"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["AutokorrM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`AutokorrM"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["generalizederrorlistplot",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`generalizederrorlistplot"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["min",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`min"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["sameq",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`sameq"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Bars",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Bars"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["gestrichelt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`gestrichelt"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MinMax",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MinMax"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["ScalarQ",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`ScalarQ"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["barsize",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`barsize"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["gr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`gr"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["min$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`min$"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["SelectIndex",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`SelectIndex"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["BlockDiagonalMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`BlockDiagonalMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["gray",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`gray"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`MS"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Shape",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Shape"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["BlockDiagTimesMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`BlockDiagTimesMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Hadamard",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Hadamard"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MS1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MS1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Shape1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Shape1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["CAT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`CAT"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Heaviside",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Heaviside"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MS2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MS2"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Sigma2Corr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Sigma2Corr"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["color",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`color"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Histogramm",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Histogramm"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["MultivariateRegression",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`MultivariateRegression"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["SkalarProdukt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`SkalarProdukt"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["ColumnSelect",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`ColumnSelect"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Histogramm1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Histogramm1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["ne",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`ne"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Spalte",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Spalte"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Compress",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Compress"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["HistogrammChart",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`HistogrammChart"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["nnn",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`nnn"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["StreifenDiagramm",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`StreifenDiagramm"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Correlation",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Correlation"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["hue",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`hue"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["NotPosition",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`NotPosition"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["StreifenDiagrammQuer",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`StreifenDiagrammQuer"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["CuMean",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`CuMean"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["ii",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`ii"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["OrnsteinUhlenbeck",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`OrnsteinUhlenbeck"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["SymmetricMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`SymmetricMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["CumulatedBarChart",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`CumulatedBarChart"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["ii$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`ii$"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["P2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`P2"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["TableForm2List",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`TableForm2List"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Delta",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Delta"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Indikator",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Indikator"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["P2C",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`P2C"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["TensorMS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`TensorMS"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["dicke",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`dicke"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Indikator1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Indikator1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["P2$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`P2$"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["text",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`text"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["DurbinWatson",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`DurbinWatson"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Indikator2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Indikator2"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["permute",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`permute"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["TEXTSHIFT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`TEXTSHIFT"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Dyad",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Dyad"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Indikator3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Indikator3"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["phaseplot",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`phaseplot"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["TF",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`TF"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["eigene",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`eigene"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["J",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`J"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["PlatzInUngeordneterListe",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`PlatzInUngeordneterListe"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["thickness",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`thickness"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Eigensystem1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Eigensystem1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["join",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`join"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["PlatzInUngeordneterListe1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`PlatzInUngeordneterListe1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["TridiagonalMult",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`TridiagonalMult"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["EinfachRegression",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`EinfachRegression"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["J$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`J$"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["plognormal",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`plognormal"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["tupel",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`tupel"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["EinfachRegressionSequentiell",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`EinfachRegressionSequentiell"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["KernDichtePlot",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`KernDichtePlot"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["plot1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`plot1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Uni",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Uni"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["Einheitsvektor",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Einheitsvektor"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Kontingenz",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Kontingenz"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["PlotLabelsX",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`PlotLabelsX"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["UniC",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`UniC"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["epilog",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`epilog"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["KroneckerProduct",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`KroneckerProduct"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["PlotLabelsY",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`PlotLabelsY"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["univariate",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`univariate"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["eq",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`eq"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Ksigma",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Ksigma"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Plots",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Plots"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["univariatealt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`univariatealt"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["ErrorBar",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`ErrorBar"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["le",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`le"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["pNorm",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`pNorm"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["unsameq",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`unsameq"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["errorlistplot",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`errorlistplot"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["listplay",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`listplay"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["pointsize",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`pointsize"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Varianz",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Varianz"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["farbmodell",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`farbmodell"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["locate",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`locate"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["position",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`position"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["VecDiag",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`VecDiag"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["flatten",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`flatten"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Locate",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Locate"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["PR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`PR"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["vv",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969836-2444862", "code`Kronecker`vv"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]},
              {
                ButtonBox[
                  StyleBox["FlattenSymmetric",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`FlattenSymmetric"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Logistic",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Logistic"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Probit",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Probit"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"], 
                ButtonBox[
                  StyleBox["Wiener",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969836-2444862", 
                    "code`Kronecker`Wiener"},
                  ButtonFrame->"None",
                  ButtonNote->"code`Kronecker`"]}
              },
            
            RowMinHeight->{
              1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}],

Cell[BoxData[GridBox[{
        {
          StyleBox["code`LSD`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["DiffusionsKoeffizient",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`DiffusionsKoeffizient"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["GlattUp1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`GlattUp1"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MFilter1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`MFilter1"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MNorKorr",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`MNorKorr"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["TimeMessUp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`TimeMessUp"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"]},
              {
                ButtonBox[
                  StyleBox["EulerStep",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`EulerStep"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["HeunStep",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`HeunStep"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MFilterFold",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`MFilterFold"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["Panel",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`Panel"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["TimeUp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`TimeUp"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"]},
              {
                ButtonBox[
                  StyleBox["Filter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`Filter"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MessUp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`MessUp"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MGlattFold",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`MGlattFold"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["RungeKutta4Step",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`RungeKutta4Step"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], ""},
              {
                ButtonBox[
                  StyleBox["Glatt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`Glatt"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MessUp1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`MessUp1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MGlattLoop",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`MGlattLoop"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["StateSpace",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`StateSpace"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], ""},
              {
                ButtonBox[
                  StyleBox["GlattUp",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`GlattUp"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MFilter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3465104", "code`LSD`MFilter"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["MLSchaetzer",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`MLSchaetzer"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], 
                ButtonBox[
                  StyleBox["StateSpace1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3465104", 
                    "code`LSD`StateSpace1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`LSD`"], ""}
              },
            RowMinHeight->{1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}],

Cell[BoxData[GridBox[{
        {
          StyleBox["code`PARTest`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["ABL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3150660", "code`PARTest`ABL"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["DELTA",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`DELTA"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["DoWhile",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`DoWhile"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["LIKSTERN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`LIKSTERN"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["MatrixE1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`MatrixE1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["MOMENT1",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`MOMENT1"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["PStern",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`PStern"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["SIGNI",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`SIGNI"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["STERN01R",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`STERN01R"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], ""},
              {
                ButtonBox[
                  StyleBox["ABL01",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`ABL01"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["DELTASTERN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`DELTASTERN"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["Indirekt",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`Indirekt"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["LINSTERN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`LINSTERN"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["MatrixE2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`MatrixE2"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["NEWTON",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`NEWTON"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["SH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3150660", "code`PARTest`SH"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["STANDARD",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`STANDARD"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["STERNR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`STERNR"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], ""},
              {
                ButtonBox[
                  StyleBox["ABLIN",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`ABLIN"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["DMS",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3150660", "code`PARTest`DMS"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["L",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3150660", "code`PARTest`L"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["LKOMP",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`LKOMP"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["MatrixE3",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`MatrixE3"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["NUMABL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`NUMABL"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["SHIFT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`SHIFT"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["Stern",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`Stern"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["VDACH",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`VDACH"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], ""},
              {
                ButtonBox[
                  StyleBox["ALIASING",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`ALIASING"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["DoUntil",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`DoUntil"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["LIK2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3150660", "code`PARTest`LIK2"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["L$",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3373969837-3150660", "code`PARTest`L$"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["MatrixLog",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`MatrixLog"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["OUTPUT",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`OUTPUT"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["SigmaStat",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`SigmaStat"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["STERN01",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`STERN01"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], 
                ButtonBox[
                  StyleBox["VecPrint",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3373969837-3150660", 
                    "code`PARTest`VecPrint"},
                  ButtonFrame->"None",
                  ButtonNote->"code`PARTest`"], ""}
              },
            RowMinHeight->{1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Contexts[]\)], "Input"],

Cell[BoxData[
    \({"Algebra`Algebraics`Private`", "BoxForm`", "BrowserCategoryLoad`", 
      "Chase`", "code`KernDichte`", "code`KernDichte`Private`", 
      "code`Kronecker`", "code`Kronecker`Private`", "code`LSD`", 
      "code`LSD`Private`", "code`PARTest`", "code`PARTest`Private`", 
      "Compile`", "Conversion`", "Debug`", "Developer`", 
      "DiscreteMath`Tree`", "DiscreteMath`Tree`Private`", "DSolve`", 
      "Experimental`", "Factor`", "FE`", "Format`", "FrontEnd`", "Global`", 
      "Graphics`Colors`", "Graphics`Colors`Private`", 
      "Graphics`Common`GraphicsCommon`", "Graphics`Graphics`", 
      "Graphics`Graphics`Private`", "HypergeometricLogDump`", "Integrate`", 
      "Integrate`Elliptic`", "Internal`", "Internal`ProcessEquations`", 
      "Limit`", "LinearAlgebra`Cholesky`", "LinearAlgebra`Cholesky`Private`", 
      "LinearAlgebra`MatrixManipulation`", 
      "LinearAlgebra`MatrixManipulation`Private`", "LinearAlgebra`Private`", 
      "MLFS`", "NPDSolve`", "Optimization`LinearProgramming`", "OscNInt`", 
      "OutputFormsDump`", "ProgrammingDump`", "Series`", "Simplify`", 
      "Solve`", "Statistics`Common`DistributionsCommon`", 
      "Statistics`DataManipulation`", "Statistics`DataManipulation`Private`", 
      "Statistics`DescriptiveStatistics`", 
      "Statistics`DescriptiveStatistics`Private`", 
      "Statistics`NormalDistribution`", 
      "Statistics`NormalDistribution`Private`", "SymbolicProduct`", 
      "SymbolicSum`", "System`", "System`CholeskyDump`", 
      "System`CompileDump`", "System`ComplexExpand`", 
      "System`Convert`CommonDump`", "System`Convert`MathMLDump`", 
      "System`Convert`NotebookMLDump`", "System`Convert`SVGDump`", 
      "System`Convert`XMLDump`", "System`CrossDump`", "System`Dump`", 
      "System`Dump`ArgumentCount`", "System`FactorDump`", "System`FEDump`", 
      "System`GroebnerBasisDump`", "System`IntegerPartitionsDump`", 
      "System`InverseFunctionDump`", "System`ISFDump`", "System`Private`", 
      "Utilities`FilterOptions`", "Utilities`FilterOptions`Private`", "XML`", 
      "XML`MathML`", "XML`MathML`Symbols`", "XML`NotebookML`", "XML`Parser`", 
      "XML`SVG`"}\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{857, 657},
WindowMargins->{{34, Automatic}, {Automatic, 14}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
00<0001804P000000`d26_oRon<3;08f0dL5N`?P0080001804P000000`d26P01
0000I00000400`<30?l00BL?00400@0000000000000006P801T1T00000000000
00000000004000000000000000000000\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 142, 8, 114, "Input"],
Cell[1921, 63, 36, 1, 38, "Output"],
Cell[1960, 66, 41, 1, 38, "Output"],
Cell[2004, 69, 41, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2082, 75, 69, 4, 54, "Input"],
Cell[2154, 81, 348942, 7817, 2019, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[351133, 7903, 106, 7, 99, "Input"],
Cell[351242, 7912, 81695, 1908, 639, "Print"],
Cell[432940, 9822, 12349, 288, 137, "Print"],
Cell[445292, 10112, 20301, 478, 121, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[465630, 10595, 43, 1, 39, "Input"],
Cell[465676, 10598, 2186, 33, 308, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

