(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     23733,        784]*)
(*NotebookOutlinePosition[     24813,        818]*)
(*  CellTagsIndexPosition[     24769,        814]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
(***************************************************************)
GLATT2//Clear
GLATT2[Z_,X_,DT_,THETA_,PHI_,NONLIN_] :=
(***************************************************************)

Module[{OMEGA,A,B,SIGMA,MUE,V,ASTERN,BSTERN,R,H,D,Y0,P0,LIK0,LIK,
\t\tZ0,MUEN,SIGMAN,X0,YG,PG,YF,PF,K,P,Q,N,T,T1},

{OMEGA,A,B,SIGMA,MUE} = PAR[THETA];
{V,ASTERN,BSTERN} = STERN01[OMEGA,A,B,DT,NONLIN];
{R,H,D} = PARM[PHI];
{T1,K,N} = Dimensions[Z];
{P,Q} = Dimensions[BSTERN];
Z0    =Z[[1]];
X0    =X[[1]];
MUEN  =(Array[1&,{N}] /. 1->MUE)//Transpose;
SIGMAN={SIGMA};

{Y0,P0,LIK0,inn0,stdinn0} = MessUp2[Z0,MUEN,SIGMAN,X0,H,D,R,{N,P}]; 
{YG,PG,YF,PF,LIK,INN,STDINN} = Glatt2[Y0,P0,Z,X,ASTERN,BSTERN,V,H,D,R];

LIK=LIK - .5 LIK0;

{YG,PG,YF,PF,LIK,Join[{inn0},INN],Join[{stdinn0},STDINN]}
]

(***************************************************************)
Glatt2[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
(***************************************************************)
\tModule[{T,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
\t\t\tlik,liki,inn,inni},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t{p,n} = Dimensions[Y0];
\t\tT = Length[Z] -1;
\t\t
\t\tPrint[\"{k,p,q,n,T} = \",{k,p,q,n,T}];
\t\t
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = {Ostern};
\t\tinn = {};
\t    stdinn = {};
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki,inni,stdinni} = 
\t        \tMessUp2[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
\t       
\t        lik += liki;
\t        
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        inn = Append[inn,inni];
\t        stdinn = Append[stdinn,stdinni];\t
\t        
\t        
\t\t,{i,T}];
\t\t
\t\t(*
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
\t\t\t\t\t\t\t\t     {Yii,Pii,Yi1i,Pi1i},Astern];
\t\t\t
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\t
\t\t
\t\t,{i,T,1,-1}];
\t\t*)
\t\t
\t\tlik = -.5 lik;
\t\t{YG,PG,YF,PF,lik,inn,stdinn}
\t]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["??Glatt2", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Global`Glatt2

Glatt2[Y0_, P0_, Z_, X_, Astern_, Bstern_, Ostern_, H_, D_, R_] := 
  Module[{T, k, p, q, YF, PF, YG, PG, Y1, P1, YGalt, PGalt, i, ON, Yii, Pii, \
Yi1i, Pi1i, lik, liki, inn, inni}, {k, p} = Dimensions[H]; {k, q} = \
Dimensions[D]; {p, n} = Dimensions[Y0]; T = Length[Z] - 1; \
Print[\"{k,p,q,n,T} = \", {k, p, q, n, T}]; Yii = Y0; YF = {Y0}; Y1 = {}; Pii \
= P0; PF = {P0}; 
    P1 = {}; lik = 0; ON = {Ostern}; inn = {}; stdinn = {}; Do[{Yi1i, Pi1i} = \
TimeUp[Yii, Pii, X[[i]], Astern, Bstern, ON]; {Yii, Pii, liki, inni, stdinni} \
= MessUp2[Z[[i + 1]], Yi1i, Pi1i, X[[i + 1]], H, D, R, {n, p}]; lik += liki; \
YF = Append[YF, Yii]; PF = Append[PF, Pii]; 
      Y1 = Append[Y1, Yi1i]; P1 = Append[P1, Pi1i]; inn = Append[inn, inni]; \
stdinn = Append[stdinn, stdinni]; Null, {i, T}]; lik = -0.5*lik; {YG, PG, YF, \
PF, lik, inn, stdinn}]\
\>", "Print",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
\t
(***************************************************************)
MessUp2[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,{n_,p_}] :=
(***************************************************************)
\tModule[{pi1in,vint,vi1,gain,inn,stdinn,ikh,Yii,Pii,lik},\t\t
\t\t
\tpi1in = Pi1i[[1]];
\tvint = H . pi1in . Transpose[H] + R;
\tvi1 = Inverse[vint];
\tvi1=0.5(vi1+(vi1//Transpose));
\tgain = pi1in . Transpose[H] . vi1;
\tinn = Z - H . Yi1i - D . X;
\tstdinn = Transpose[CholeskyDecomposition[vi1]].inn;
\tlik = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
\tYii = Yi1i + gain.inn;
\tikh = IdentityMatrix[p] - gain.H;
\tPii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};\t\t\t\t\t\t \
\t
\t{Yii,Pii,lik,inn,stdinn}
\t   
\t](* End MessUp ohne missing *) 
\t\t \t\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
autokov//Clear
autokov[y_,lag_,Mean_:0]:= Module[{t1,m,y1},
(***************************************************************)
(* Autokovarianzfunktion, (1/T)Summe(yi+lag)*yi`*)
(* vgl. L\[UDoubleDot]tkepohl 138ff*)

t1=Length[y];
If[Mean === 0,

\tApply[Plus,Delta[y,y,Outer[Times,#1,#2]&,lag]]/t1,
\t
\tm = mean[y]; Print[\"mit Mittelwert\"];
\ty1 = Map[(#-m)&,y]; 
\tApply[Plus,Delta[y1,y1,Outer[Times,#1,#2]&,lag]]/t1]
]
\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
SeedRandom[999];r = \
autokov[Table[UniC[],{50},{3}],1,free]//MatrixForm
SeedRandom[999];r = autokov[Table[UniC[],{50},{3}],1]//MatrixForm\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
General::spell1: Possible spelling error: new symbol name \"free\" \
is similar to existing symbol \"tree\".\
\>", "Message",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["mit Mittelwert", "Print",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
MatrixForm[{{0.2795267463096199, \
-0.2193791979637147, -0.1594154035484183}, {0.07095657534627034, \
-0.003229902087851784, -0.01011453421569261}, {0.1249338016626342, \
0.06752955658610033, -0.1483301715680698}}]\
\>", "\<\
    1          2       \
   3

1   0.279527   -0.219379  -0.159415
2   0.0709566  -0.0032299 -0.0101145
3   0.124934   0.0675296  -0.14833\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
MatrixForm[{{0.3429223081296176, \
-0.2161904463480724, -0.1446725009268314}, {0.07740583774975835, \
-0.003196348779080216, -0.00835666459688279}, {0.1264424913087601, \
0.06684836823247592, -0.1473075559846042}}]\
\>", "\<\
    1           2      \
     3

1   0.342922    -0.21619    -0.144673
2   0.0774058   -0.00319635 -0.00835666
3   0.126442    0.0668484   -0.147308\
\>"], "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Delta[{a,b,c,d},{aa,bb,cc,dd},Dot[#1,#2//Transpose]&,2]
autokov[{a,b,c,d},1]
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
{c . Transpose[aa], d . Transpose[bb]}\
\>", "\<\
{c \
. Transpose[aa], d . Transpose[bb]}\
\>"], "Output",
  Evaluatable->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Outer::normal: Normal expression expected at position 2 in \
Outer[Times, b, a].\
\>", "Message",
  Evaluatable->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Outer::normal: Normal expression expected at position 2 in \
Outer[Times, c, b].\
\>", "Message",
  Evaluatable->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
Outer::normal: Normal expression expected at position 2 in \
Outer[Times, d, c].\
\>", "Message",
  Evaluatable->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
General::stop: Further output of Outer::normal will be suppressed \
during this calculation.\
\>", "Message",
  Evaluatable->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
(Outer[Times, b, a] + Outer[Times, c, b] + \
Outer[Times, d, c])/4\
\>", "\<\
Outer[Times, b, a] + Outer[Times, c, b] + \
Outer[Times, d, c]
------------------------------------------------------------
                             4\
\>"], "Output",
  Evaluatable->True,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
(***************************************************************)
DIAGNOSE//Clear
DIAGNOSE[maxlag_,u_,Z_,X_,DT_,nselect_,tselect_,THETA_,PHI_,NONLIN_,PRINT_]:= \

(***************************************************************)
 Module[{YG,PG,YF,PF,LIK,INNO,STDINN,T1,K,N,T,k2,tab,ns,gamman,
 \t\t rhon,j,jj,inn,c0,gamma,rho,c01,p,p0,clag,rlag,rmlag,
 \t\t tr,df,prob,probmod,zeta,M,zetaq,S,kt1,det,likratio,pn,cum},
 
(*Innovations-Prozess                            *)
(*FILTER  MIT ANFANGSBEDINGUNG Y0=E[Y0|Z0]       *)
(*                             P0=V[Y0|Z0]       *)

Print[\"**********************************************************************\
\"];
Print[\"***********************MODUL: \
DIAGNOSE********************************\"];
Print[\"**********************************************************************\
\"];

{YG,PG,YF,PF,LIK,INNO,STDINN} = GLATT2[Z,X,DT,THETA,PHI,NONLIN];

INNO   = Take[INNO,  tselect]; 
STDINN = Take[STDINN,tselect];

INNO=STDINN;
Print[\"Analyse der standardisierten Innovationen Gamma^-.5 nue\"];

{t1, t2} = tselect;
Print[ \"---------------------------------------------------\"];
Print[\"Selektion {t1, t2} = \",tselect];
Print[ \"---------------------------------------------------\"];

{T1,K,N} =Dimensions[INNO];

T = T1-1; 
k2 = K^2;
tab = TableForm[#,TableDirections->{Column,Column,Row}]&;
If[PRINT[[1]]==1,Print[\"Innovationsprozess  \",INNO//tab]];

Print[ \"---------------------------------------------------\"];
pn = pNorm[INNO//Flatten,2];
Print[\"2-Norm der Innovation (Summe nue_tpn^2)^(1/2): \",pn];
Print[ \"---------------------------------------------------\"];
Print[\"getrennte Analyse der Einheiten  \",nselect];
Print[ \"---------------------------------------------------\"];
ns = Length[nselect];
gamman = {}; rhon = {};


Do[ 
    j=nselect[[jj]];
    inn=INNO[[T1//Range,K//Range,j]]; (* j-te Einheit *)
    c0 = autokov[inn,0];
    gamma={c0};
    rho={IdentityMatrix[K]};
    c01=Inverse[c0];
    p=0;pmod=0;
    
    Print[\"---------------Statistische Einheit----------------:  \",j];
    If[PRINT[[2]]==1,Print[\"Autokovarianz der Residuen\",gamma//tab]];
    If[PRINT[[3]]==1,Print[\"Autokorrelation der Residuen\",rho//tab]];
    \t
    cum={};
    
    Do[
         clag = autokov[inn,lag];
         rlag=clag.c01;
         rmlag=Transpose[clag].c01;
         gamma=Append[gamma,clag];
         rho=Append[rho,rlag];
         tr=MatrixTrace[rmlag.rlag];
         p = p + tr;
         pmod = pmod + tr/(T1-lag);
         
         df=k2*lag-u;
         
         If[df>0,
         
         prob   =1-CDF[ChiSquareDistribution[df],T1*p];
         probmod=1-CDF[ChiSquareDistribution[df],T1*T1*pmod];
                
         cum=Append[cum,{{lag,df},{T1*p,prob,T1*T1*pmod,probmod}//N5}//\
Flatten];
         
         ];

          
    ,{lag,1,maxlag}];
    
Print[ \"---------------------------------------------------\"];
Print[\"Multivariate Portmanteau-Statistik (Hosking 1980)\"];
Print[ \"---------------------------------------------------\"];
Print[\" K = \",K,\", u = \",u, \", maxlag = \",maxlag, \", df = K^2 lag - \
u\"]; 
Print[\"\"];
 
Print[cum//Chop//TableForm[#,
TableDirections->{Column,Row},
TableSpacing->Automatic,
TableHeadings->{None,{\"lag\",\"df\",\"P\",\"prob\",\"Pmod\",\"probmod\"}}]&];\


plot1[Column[cum,{3,5}]//AddTimeAxis,PlotLabel->\"Portmanteau-Statistiken P \
(blau) und Pmod (gruen)\"];   
    
plot1[Column[cum,{4,6}]//AddTimeAxis,PlotLabel->\"p-Werte der \
Portmanteau-Statistiken P (blau) und Pmod (gruen)\"];   
    

rhon=Append[rhon,rho];
gamman=Append[gamman,gamma];


plot1[inn//AddTimeAxis[#,Join[(tselect-1)DT,{DT}]]&,
\t\tPlotLabel->\"Innovations-Prozess\"];
(*\t\t
plot1[flatten[rho,{2,3}]//AddTimeAxis,
\tPlotLabel->\"Autokorrelation der Innovation: C(t)C(0)^(-1)\",
\tPlotRange->{All,{-1,1}}];
*)

ki = 1.96/Sqrt[t2-t1];\t
plot1[Map[VecDiag,rho]//AddTimeAxis[#,{t1,t1+maxlag,1}]&,
\tPlotLabel->\"Autokorrelation der Innovation: C(t)C(0)^(-1)\",
\tPlotRange->{All,{-1,1}},
\tGridLines->{None,{ki,-ki}}];

,{jj,1,ns}];


If[ N > 1,
    Print[ \"---------------------------------------------------\"];
    Print[ \"simultane Analyse aller Einheiten (Panel, N > 1)\"];
    Print[ \"---------------------------------------------------\"];
    zeta = flatten[STDINN,{1,2}];
    M=(zeta.Transpose[zeta])/N;
    zetaq=mean[zeta//Transpose];
    S=M-Outer[Times,zetaq,zetaq];
    Print[ \"---------------------------------------------------\"];
    Print[\"normierte Innovationen <(k,T1) . N>\"];
    Print[ \"---------------------------------------------------\"];
    Print[zeta//N4//MatrixForm];
    Print[ \"---------------------------------------------------\"];
    Print[\"1. und 2. Moment um 0 der standardisierten Residuen: zetaq, M\"];
    Print[ \"---------------------------------------------------\"];
    Print[zetaq//MatrixForm];
    Print[M//N4//MatrixForm];
    Print[ \"---------------------------------------------------\"];
    Print[\"Standardabweichung S = M-zetaq*zetaq`\"];
    Print[ \"---------------------------------------------------\"];
    Print[S//N4//MatrixForm];
    kt1=K*T1;
    det = If[pNorm[S//Flatten,2]==0,0,Det[S]];
    likratio=-N*(Log[det]+ kt1 - MatrixTrace[M]);
    df=(1.5 + 0.5*kt1)*kt1;
    prob=1-CDF[ChiSquareDistribution[df],likratio];
    Print[ \"---------------------------------------------------\"];
    Print[\"Asymptotischer Likelihood-Quotienten-Test\"];
    Print[ \"---------------------------------------------------\"];
    Print[\"{likratio,df,prob} = \", {likratio,df,prob}];
];

{INNO,gamman,rhon}

];\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain"],

Cell["\<\
(***************************************************************)
DIAGNOSESIM//Clear
DIAGNOSESIM[maxlag_,pq_,Z_,X_,DT_,nselect_,tselect_,THETA_,PHI_,NONLIN_,PRINT_\
]:= 
(***************************************************************)
 Module[{YG,PG,YF,PF,LIK,INNO,STDINN,T1,K,N,T,k2,tab,ns,gamman,
 \t\t rhon,j,jj,inn,c0,gamma,rho,c01,p,p0,clag,rlag,rmlag,
 \t\t tr,df,prob,probmod,zeta,M,zetaq,S,kt1,det,likratio,pn},
 
(*Innovations-Prozess                            *)
(*FILTER  MIT ANFANGSBEDINGUNG Y0=E[Y0|Z0]       *)
(*                             P0=V[Y0|Z0]       *)
(*
Print[\"**********************************************************************\
\"];
Print[\"***********************MODUL: \
DIAGNOSE********************************\"];
Print[\"**********************************************************************\
\"];
*)

{YG,PG,YF,PF,LIK,INNO,STDINN} = GLATT2[Z,X,DT,THETA,PHI,NONLIN];

INNO = Take[INNO,tselect];
STDINN = Take[STDINN,tselect];
(*
Print[ \"---------------------------------------------------\"];
Print[ \"Selektion {t1, t2} = \",tselect];
Print[ \"---------------------------------------------------\"];
*)

{T1,K,N} =Dimensions[INNO];
T = T1-1; 
k2 = K^2;
tab = TableForm[#,TableDirections->{Column,Column,Row}]&;
If[PRINT[[1]]==1,Print[\"Innovationsprozess  \",INNO//tab]];

pn = pNorm[INNO//Flatten,2];
Print[\"Innovation \",TensorMS[INNO]];
Print[\"std-Innov. \",TensorMS[STDINN]];

(*
Print[ \"---------------------------------------------------\"];
Print[\"2-Norm der Innovation (Summe nue_tpn^2)^(1/2): \",pn];
Print[ \"---------------------------------------------------\"];
*)

Return[pn];


Print[\"getrennte Analyse der Einheiten  \",nselect];
Print[ \"---------------------------------------------------\"];
ns = Length[nselect];
gamman = {}; rhon = {};

Do[ 
    j=nselect[[jj]];
    inn=INNO[[T1//Range,K//Range,j]]; (* j-te Einheit *)
    c0 = autokov[inn,0];
    gamma={c0};
    rho={IdentityMatrix[K]};
    c01=Inverse[c0];
    p=0;pmod=0;
    
    Do[
         clag = autokov[inn,lag];
         rlag=clag.c01;
         rmlag=Transpose[clag].c01;
         gamma=Append[gamma,clag];
         rho=Append[rho,rlag];
         tr=MatrixTrace[rmlag.rlag];
         p = p + tr;
         pmod = pmod + tr/(T1-lag);
          
    ,{lag,1,maxlag}];

rhon=Append[rhon,rho];
gamman=Append[gamman,gamma];
p=T1*p;
pmod=T1*T1*pmod;

df=k2*(maxlag-pq);

prob   =1-CDF[ChiSquareDistribution[df],p];
probmod=1-CDF[ChiSquareDistribution[df],pmod];
Print[\"---------------Statistische Einheit----------------:  \",j];
If[PRINT[[2]]==1,Print[\"Autokovarianz der Residuen\",gamma//tab]];
If[PRINT[[3]]==1,Print[\"Autokorrelation der Residuen\",rho//tab]];
Print[ \"---------------------------------------------------\"];
Print[\"Multivariate Portmanteau-Statistik (Hosking 1980)\"];
Print[ \"---------------------------------------------------\"];
Print[\"{p,prob,df=k^2 (maxlag-pq),maxlag}= \", {p,prob,df,maxlag}];
Print[ \"---------------------------------------------------\"];
Print[\"Modifizierte Portmanteau-Statistik (Hosking 1980)\"];
Print[ \"---------------------------------------------------\"];
Print[\"{pmod,probmod,df=k^2 (maxlag-pq),maxlag} = \
\",{pmod,probmod,df,maxlag}];
Print[ \"---------------------------------------------------\"];

plot1[inn//AddTimeAxis[#,Join[(tselect-1)DT,{DT}]]&,
\t\tPlotLabel->\"Innovations-Prozess\",
\t\tfarbmodell->Hue];
\t\t
plot1[flatten[rho,{2,3}]//AddTimeAxis,
\tPlotLabel->\"Autokorrelation der Innovation: C(t)C(0)^(-1)\",
\tfarbmodell->Hue,PlotRange->{All,{-1,1}}];

,{jj,1,ns}];


If[ N > 1,
    Print[ \"---------------------------------------------------\"];
    Print[ \"simultane Analyse aller Einheiten (Panel, N > 1)\"];
    Print[ \"---------------------------------------------------\"];
    zeta = flatten[STDINN,{1,2}];
    M=(zeta.Transpose[zeta])/N;
    zetaq=mean[zeta//Transpose];
    S=M-Outer[Times,zetaq,zetaq];
    Print[ \"---------------------------------------------------\"];
    Print[\"normierte Innovationen <(k,T1) . N>\"];
    Print[ \"---------------------------------------------------\"];
    Print[zeta//N4//MatrixForm];
    Print[ \"---------------------------------------------------\"];
    Print[\"1. und 2. Moment um 0 der standardisierten Residuen: zetaq, M\"];
    Print[ \"---------------------------------------------------\"];
    Print[zetaq//MatrixForm];
    Print[M//N4//MatrixForm];
    Print[ \"---------------------------------------------------\"];
    Print[\"Standardabweichung S = M-zetaq*zetaq`\"];
    Print[ \"---------------------------------------------------\"];
    Print[S//N4//MatrixForm];
    kt1=K*T1;
    det = If[pNorm[S//Flatten,2]==0,0,Det[S]];
    likratio=-N*(Log[det]+ kt1 - MatrixTrace[M]);
    df=(1.5 + 0.5*kt1)*kt1;
    prob=1-CDF[ChiSquareDistribution[df],likratio];
    Print[ \"---------------------------------------------------\"];
    Print[\"Asymptotischer Likelihood-Quotienten-Test\"];
    Print[ \"---------------------------------------------------\"];
    Print[\"{likratio,df,prob} = \", {likratio,df,prob}];
];

{INNO,gamman,rhon}

];\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
(***************************************************************)
NEWTONSIM[THETA0_,KMAX_,EPS_,M0_,M00_,M_,DT_,n_,T_,OPTION_,NONLIN_,PRINT_] := \

(***************************************************************)
Module[
{THETA,MAXSTEP,MINSTEP,BOUND,U,K,S,H,LIKELI,vdach,DVDTH,DASDTH,
 DBSDTH,DSIGDTH,DMUEDTH,V,ASTERN,BSTERN,SIGMA,MUE,liktheta,LIKALT,
 ALPHA,THETA1,LIKNEU,STEP,STEPL,t},

MAXSTEP=10.^3;
MINSTEP=10.^-10;
BOUND=10.^-4;
ALPHA=10^-4;
U=Length[THETA0];

If[PRINT[[1]] == 1,
Print[\"***********************LSDE1**********************************\"];
Print[\"***********************MODUL: NEWTON**************************\"];
Print[\"**************************************************************\"];
Print[\"Technical Output\"];
VecPrint[{KMAX,EPS,DT,n,T,OPTION,NONLIN,MAXSTEP,MINSTEP,BOUND}//Spalte,
         {\"KMAX\",\"EPS\",\"DT\",\"n\",\"T\",\"OPTION\",\"NONLIN\",\"MAXSTEP\
\",
          \"MINSTEP\",\"BOUND\"}];
Print[ \"\"];
Print[ \"STARTWERT THETA0 = \", THETA0];
];

THETA=THETA0;
liktheta = {};
(*NUMABL[THETA0,DT,$MachineEpsilon^.5,M0,M00,M,n,T,NONLIN];*)

DoUntil[{K,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS, 
  \t
  \tIf[PRINT[[2]] == 1,
  \tPrint[\"-----------------------------------------------------------------\
\"];
    Print[\"NEWTON: Iteration = \",K];
    ];
   
    {S,H,LIKALT,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
     V,ASTERN,BSTERN,SIGMA,MUE} = SH[THETA,DT,M0,M00,M,n,T,NONLIN];
    liktheta = Append[liktheta, Join[{LIKALT},THETA]];
    
\tIf[OPTION == 1, H = SHIFT[H,BOUND] ];
\t
    STEP=LinearSolve[H,S];

    (*BEGRENZUNG DER SCHRITTL\[CapitalADoubleDot]NGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];
    

    (*STEP-HALVING*)
   
    THETA1=THETA+STEP;   (*VOLLER NEWTON-STEP*)
    LIKNEU = LIK2[THETA1,DT,M0,M00,M,n,T,NONLIN];
    DoWhile[{Z,100},
         \t(LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          \t\tMax[Abs[STEP]]>MINSTEP),
         STEP=STEP*.5;
         
         If[PRINT[[3]] == 1,
         Print[\"STEP-HALVING:  \",Z,\"  LIKNEU  \", LIKNEU,\"  LIKALT  \", \
LIKALT];
         ];
         
         THETA1=THETA+STEP;
         LIKNEU = LIK2[THETA1,DT,M0,M00,M,n,T,NONLIN];

    ]; (*End DoWhile*)
    
    If[PRINT[[4]] == 1,
    Print[\"\"];
    Print[\"LIKNEU \", PaddedForm[LIKNEU,{20,15}],
    \t  \" LIKALT \", PaddedForm[LIKALT,{20,15}],
    \t  \" LIKNEU-LIKALT \", PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    Print[\"\"];
    ];
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA, STEP, S}//Transpose,
    TableHeadings->{Automatic,{\"THETA1\",\"THETA\",\"STEP\",\"SCORE\"}}]];
    Print[\"\"];
    ];
    
    If[PRINT[[6]] == 1,
    Print[H//MatrixForm]]; 
    
    THETA=THETA1;
    k = K;
   
]; (*End DoUntil*)

If[PRINT[[7]] == 1,
Print[ \"NEWTON: ENDE DER ITERATION  \",k,\"  \",KMAX]];


{S,H,LIKELI,vdach,DVDTH,DASDTH,DBSDTH,DSIGDTH,DMUEDTH,
 \tV,ASTERN,BSTERN,SIGMA,MUE} = SH[THETA,DT,M0,M00,M,n,T,NONLIN];

liktheta = Append[liktheta,Join[{LIKELI},THETA]];

If[PRINT[[8]] == 1,
Print[MatrixForm[liktheta,
\tTableHeadings->{Automatic,{\"Likelihood\",\"Theta\"}}]]];


(*\t
COV = OUTPUT[THETA,H,.05,S,LIKELI];
LKOMP[LIKELI,U,n*(T+1)];
DELTA[COV,THETA];
DELTASTERN[COV,THETA,DT,NONLIN];
*)

COV = Inverse[H];
{THETA,COV,liktheta,k}
]

\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{655, 693},
WindowMargins->{{Automatic, 55}, {Automatic, 9}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
00<0001804P000000`d26_oRon<3;08f0dL5N`?P0080001804P000000`82C`01
0000I00000400`<300000Gd000400@0000000000000004P801T1T00000000000
00000000000000000000000000000000\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 2481, 100, 1482, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[4260, 155, 59, 1, 27, "Input"],
Cell[4322, 158, 915, 17, 204, "Print"]
}, Open  ]],
Cell[5252, 178, 861, 25, 342, "Input",
  InitializationCell->True],
Cell[6116, 205, 577, 20, 267, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[6718, 229, 199, 6, 57, "Input"],
Cell[6920, 237, 169, 4, 34, "Message"],
Cell[7092, 243, 65, 1, 22, "Print"],
Cell[7160, 246, 463, 14, 72, "Output"],
Cell[7626, 262, 473, 14, 72, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8136, 281, 136, 5, 57, "Input"],
Cell[8275, 288, 187, 7, 24, "Output",
  Evaluatable->True],
Cell[8465, 297, 162, 5, 21, "Message",
  Evaluatable->True],
Cell[8630, 304, 162, 5, 21, "Message",
  Evaluatable->True],
Cell[8795, 311, 162, 5, 21, "Message",
  Evaluatable->True],
Cell[8960, 318, 174, 5, 34, "Message",
  Evaluatable->True],
Cell[9137, 325, 329, 10, 41, "Output",
  Evaluatable->True]
}, Open  ]],
Cell[9481, 338, 5705, 170, 2238, "Input",
  InitializationCell->True],
Cell[15189, 510, 5201, 148, 2202, "Input",
  InitializationCell->True],
Cell[20393, 660, 3336, 122, 70, "Input",
  InitializationCell->True]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

